/* BlindsEffect.c generated by valac 0.56.18, the Vala compiler
 * generated from BlindsEffect.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2013 Jens Bav
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "pantheon-photos-transitions.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <math.h>
#include <float.h>
#include <gdk/gdk.h>

#define BLINDS_EFFECT_DESIRED_FPS 30
#define BLINDS_EFFECT_MIN_FPS 15
#define BLINDS_EFFECT_BLIND_WIDTH 50
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_BLINDS_EFFECT_DESCRIPTOR (blinds_effect_descriptor_get_type ())
#define BLINDS_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLINDS_EFFECT_DESCRIPTOR, BlindsEffectDescriptor))
#define BLINDS_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BLINDS_EFFECT_DESCRIPTOR, BlindsEffectDescriptorClass))
#define IS_BLINDS_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLINDS_EFFECT_DESCRIPTOR))
#define IS_BLINDS_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BLINDS_EFFECT_DESCRIPTOR))
#define BLINDS_EFFECT_DESCRIPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BLINDS_EFFECT_DESCRIPTOR, BlindsEffectDescriptorClass))

typedef struct _BlindsEffectDescriptor BlindsEffectDescriptor;
typedef struct _BlindsEffectDescriptorClass BlindsEffectDescriptorClass;
typedef struct _BlindsEffectDescriptorPrivate BlindsEffectDescriptorPrivate;
enum  {
	BLINDS_EFFECT_DESCRIPTOR_0_PROPERTY,
	BLINDS_EFFECT_DESCRIPTOR_NUM_PROPERTIES
};
static GParamSpec* blinds_effect_descriptor_properties[BLINDS_EFFECT_DESCRIPTOR_NUM_PROPERTIES];

#define TYPE_BLINDS_EFFECT (blinds_effect_get_type ())
#define BLINDS_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLINDS_EFFECT, BlindsEffect))
#define BLINDS_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BLINDS_EFFECT, BlindsEffectClass))
#define IS_BLINDS_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLINDS_EFFECT))
#define IS_BLINDS_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BLINDS_EFFECT))
#define BLINDS_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BLINDS_EFFECT, BlindsEffectClass))

typedef struct _BlindsEffect BlindsEffect;
typedef struct _BlindsEffectClass BlindsEffectClass;
typedef struct _BlindsEffectPrivate BlindsEffectPrivate;
enum  {
	BLINDS_EFFECT_0_PROPERTY,
	BLINDS_EFFECT_NUM_PROPERTIES
};
static GParamSpec* blinds_effect_properties[BLINDS_EFFECT_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _BlindsEffectDescriptor {
	ShotwellTransitionDescriptor parent_instance;
	BlindsEffectDescriptorPrivate * priv;
};

struct _BlindsEffectDescriptorClass {
	ShotwellTransitionDescriptorClass parent_class;
};

struct _BlindsEffect {
	GObject parent_instance;
	BlindsEffectPrivate * priv;
};

struct _BlindsEffectClass {
	GObjectClass parent_class;
};

struct _BlindsEffectPrivate {
	gint current_blind_width;
	cairo_surface_t** to_blinds;
	gint to_blinds_length1;
	gint _to_blinds_size_;
	gint blind_count;
};

static gpointer blinds_effect_descriptor_parent_class = NULL;
static gint BlindsEffect_private_offset;
static gpointer blinds_effect_parent_class = NULL;
static SpitTransitionsEffectIface * blinds_effect_spit_transitions_effect_parent_iface = NULL;

VALA_EXTERN GType blinds_effect_descriptor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN BlindsEffectDescriptor* blinds_effect_descriptor_new (GFile* resource_directory);
VALA_EXTERN BlindsEffectDescriptor* blinds_effect_descriptor_construct (GType object_type,
                                                            GFile* resource_directory);
static const gchar* blinds_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base);
static const gchar* blinds_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base);
static SpitTransitionsEffect* blinds_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                                             SpitHostInterface* host);
VALA_EXTERN BlindsEffect* blinds_effect_new (void);
VALA_EXTERN BlindsEffect* blinds_effect_construct (GType object_type);
VALA_EXTERN GType blinds_effect_get_type (void) G_GNUC_CONST ;
static GType blinds_effect_descriptor_get_type_once (void);
static void blinds_effect_real_get_fps (SpitTransitionsEffect* base,
                                 gint* desired_fps,
                                 gint* min_fps);
static gboolean blinds_effect_real_needs_clear_background (SpitTransitionsEffect* base);
static void blinds_effect_real_start (SpitTransitionsEffect* base,
                               SpitTransitionsVisuals* visuals,
                               SpitTransitionsMotion* motion);
static void blinds_effect_real_paint (SpitTransitionsEffect* base,
                               SpitTransitionsVisuals* visuals,
                               SpitTransitionsMotion* motion,
                               cairo_t* ctx,
                               gint width,
                               gint height,
                               gint frame_number);
static void blinds_effect_real_advance (SpitTransitionsEffect* base,
                                 SpitTransitionsVisuals* visuals,
                                 SpitTransitionsMotion* motion,
                                 gint frame_number);
static void blinds_effect_real_cancel (SpitTransitionsEffect* base);
static void blinds_effect_finalize (GObject * obj);
static GType blinds_effect_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

BlindsEffectDescriptor*
blinds_effect_descriptor_construct (GType object_type,
                                    GFile* resource_directory)
{
	BlindsEffectDescriptor * self = NULL;
#line 24 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_val_if_fail (resource_directory != NULL, NULL);
#line 25 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffectDescriptor*) shotwell_transition_descriptor_construct (object_type, resource_directory);
#line 24 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	return self;
#line 167 "BlindsEffect.c"
}

BlindsEffectDescriptor*
blinds_effect_descriptor_new (GFile* resource_directory)
{
#line 24 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	return blinds_effect_descriptor_construct (TYPE_BLINDS_EFFECT_DESCRIPTOR, resource_directory);
#line 175 "BlindsEffect.c"
}

static const gchar*
blinds_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base)
{
	BlindsEffectDescriptor * self;
	const gchar* result;
#line 28 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffectDescriptor*) base;
#line 29 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	result = "io.elementary.photos.transitions.blinds";
#line 29 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	return result;
#line 189 "BlindsEffect.c"
}

static const gchar*
blinds_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base)
{
	BlindsEffectDescriptor * self;
	const gchar* result;
#line 32 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffectDescriptor*) base;
#line 33 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	result = _ ("Blinds");
#line 33 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	return result;
#line 203 "BlindsEffect.c"
}

static SpitTransitionsEffect*
blinds_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                      SpitHostInterface* host)
{
	BlindsEffectDescriptor * self;
	BlindsEffect* _tmp0_;
	SpitTransitionsEffect* result;
#line 36 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffectDescriptor*) base;
#line 36 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 37 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_tmp0_ = blinds_effect_new ();
#line 37 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	result = (SpitTransitionsEffect*) _tmp0_;
#line 37 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	return result;
#line 223 "BlindsEffect.c"
}

static void
blinds_effect_descriptor_class_init (BlindsEffectDescriptorClass * klass,
                                     gpointer klass_data)
{
#line 23 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	blinds_effect_descriptor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_id = (const gchar* (*) (ShotwellTransitionDescriptor*)) blinds_effect_descriptor_real_get_id;
#line 23 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_pluggable_name = (const gchar* (*) (ShotwellTransitionDescriptor*)) blinds_effect_descriptor_real_get_pluggable_name;
#line 23 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->create = (SpitTransitionsEffect* (*) (ShotwellTransitionDescriptor*, SpitHostInterface*)) blinds_effect_descriptor_real_create;
#line 238 "BlindsEffect.c"
}

static void
blinds_effect_descriptor_instance_init (BlindsEffectDescriptor * self,
                                        gpointer klass)
{
}

static GType
blinds_effect_descriptor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BlindsEffectDescriptorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) blinds_effect_descriptor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BlindsEffectDescriptor), 0, (GInstanceInitFunc) blinds_effect_descriptor_instance_init, NULL };
	GType blinds_effect_descriptor_type_id;
	blinds_effect_descriptor_type_id = g_type_register_static (TYPE_SHOTWELL_TRANSITION_DESCRIPTOR, "BlindsEffectDescriptor", &g_define_type_info, 0);
	return blinds_effect_descriptor_type_id;
}

GType
blinds_effect_descriptor_get_type (void)
{
	static volatile gsize blinds_effect_descriptor_type_id__once = 0;
	if (g_once_init_enter (&blinds_effect_descriptor_type_id__once)) {
		GType blinds_effect_descriptor_type_id;
		blinds_effect_descriptor_type_id = blinds_effect_descriptor_get_type_once ();
		g_once_init_leave (&blinds_effect_descriptor_type_id__once, blinds_effect_descriptor_type_id);
	}
	return blinds_effect_descriptor_type_id__once;
}

static inline gpointer
blinds_effect_get_instance_private (BlindsEffect* self)
{
	return G_STRUCT_MEMBER_P (self, BlindsEffect_private_offset);
}

BlindsEffect*
blinds_effect_construct (GType object_type)
{
	BlindsEffect * self = NULL;
#line 51 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffect*) g_object_new (object_type, NULL);
#line 51 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	return self;
#line 282 "BlindsEffect.c"
}

BlindsEffect*
blinds_effect_new (void)
{
#line 51 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	return blinds_effect_construct (TYPE_BLINDS_EFFECT);
#line 290 "BlindsEffect.c"
}

static void
blinds_effect_real_get_fps (SpitTransitionsEffect* base,
                            gint* desired_fps,
                            gint* min_fps)
{
	BlindsEffect * self;
	gint _vala_desired_fps = 0;
	gint _vala_min_fps = 0;
#line 54 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffect*) base;
#line 55 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_vala_desired_fps = BLINDS_EFFECT_DESIRED_FPS;
#line 56 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_vala_min_fps = BLINDS_EFFECT_MIN_FPS;
#line 54 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	if (desired_fps) {
#line 54 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		*desired_fps = _vala_desired_fps;
#line 311 "BlindsEffect.c"
	}
#line 54 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	if (min_fps) {
#line 54 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		*min_fps = _vala_min_fps;
#line 317 "BlindsEffect.c"
	}
}

static gboolean
blinds_effect_real_needs_clear_background (SpitTransitionsEffect* base)
{
	BlindsEffect * self;
	gboolean result;
#line 59 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffect*) base;
#line 60 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	result = TRUE;
#line 60 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	return result;
#line 332 "BlindsEffect.c"
}

static void
blinds_effect_real_start (SpitTransitionsEffect* base,
                          SpitTransitionsVisuals* visuals,
                          SpitTransitionsMotion* motion)
{
	BlindsEffect * self;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 63 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffect*) base;
#line 63 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 63 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_if_fail (motion != NULL);
#line 64 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_tmp0_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 64 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_tmp1_ = _tmp0_;
#line 64 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	if (_tmp1_ != NULL) {
#line 355 "BlindsEffect.c"
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		GdkPixbuf* _tmp6_;
		GdkPixbuf* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		cairo_surface_t** _tmp10_;
#line 65 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp2_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 65 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp3_ = _tmp2_;
#line 65 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp4_ = gdk_pixbuf_get_width (_tmp3_);
#line 65 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp5_ = _tmp4_;
#line 65 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		self->priv->blind_count = _tmp5_ / BLINDS_EFFECT_BLIND_WIDTH;
#line 66 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp6_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 66 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp7_ = _tmp6_;
#line 66 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp8_ = gdk_pixbuf_get_width (_tmp7_);
#line 66 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp9_ = _tmp8_;
#line 66 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		self->priv->current_blind_width = (gint) ceil (((gdouble) _tmp9_) / ((gdouble) self->priv->blind_count));
#line 69 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp10_ = g_new0 (cairo_surface_t*, self->priv->blind_count + 1);
#line 69 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		self->priv->to_blinds = (_vala_array_free (self->priv->to_blinds, self->priv->to_blinds_length1, (GDestroyNotify) cairo_surface_destroy), NULL);
#line 69 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		self->priv->to_blinds = _tmp10_;
#line 69 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		self->priv->to_blinds_length1 = self->priv->blind_count;
#line 69 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		self->priv->_to_blinds_size_ = self->priv->to_blinds_length1;
#line 395 "BlindsEffect.c"
		{
			gint i = 0;
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
			i = 0;
#line 400 "BlindsEffect.c"
			{
				gboolean _tmp11_ = FALSE;
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp11_ = TRUE;
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				while (TRUE) {
#line 407 "BlindsEffect.c"
					cairo_surface_t** _tmp13_;
					gint _tmp13__length1;
					GdkPixbuf* _tmp14_;
					GdkPixbuf* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
					cairo_surface_t* _tmp18_;
					cairo_t* ctx = NULL;
					cairo_surface_t** _tmp19_;
					gint _tmp19__length1;
					cairo_surface_t* _tmp20_;
					cairo_t* _tmp21_;
					cairo_t* _tmp22_;
					GdkPixbuf* _tmp23_;
					GdkPixbuf* _tmp24_;
					cairo_t* _tmp25_;
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					if (!_tmp11_) {
#line 426 "BlindsEffect.c"
						gint _tmp12_;
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
						i = i + 1;
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
						_tmp12_ = i;
#line 432 "BlindsEffect.c"
					}
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp11_ = FALSE;
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					if (!(i < self->priv->blind_count)) {
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
						break;
#line 440 "BlindsEffect.c"
					}
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp13_ = self->priv->to_blinds;
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp13__length1 = self->priv->to_blinds_length1;
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp14_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp15_ = _tmp14_;
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp16_ = gdk_pixbuf_get_height (_tmp15_);
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp17_ = _tmp16_;
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp18_ = cairo_image_surface_create (CAIRO_FORMAT_RGB24, self->priv->current_blind_width, _tmp17_);
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_cairo_surface_destroy0 (_tmp13_[i]);
#line 72 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp13_[i] = _tmp18_;
#line 74 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp19_ = self->priv->to_blinds;
#line 74 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp19__length1 = self->priv->to_blinds_length1;
#line 74 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp20_ = _tmp19_[i];
#line 74 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp21_ = cairo_create (_tmp20_);
#line 74 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					ctx = _tmp21_;
#line 75 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp22_ = ctx;
#line 75 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp23_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 75 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp24_ = _tmp23_;
#line 75 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					gdk_cairo_set_source_pixbuf (_tmp22_, _tmp24_, (gdouble) ((-i) * self->priv->current_blind_width), (gdouble) 0);
#line 76 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp25_ = ctx;
#line 76 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					cairo_paint (_tmp25_);
#line 71 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_cairo_destroy0 (ctx);
#line 484 "BlindsEffect.c"
				}
			}
		}
	}
}

static void
blinds_effect_real_paint (SpitTransitionsEffect* base,
                          SpitTransitionsVisuals* visuals,
                          SpitTransitionsMotion* motion,
                          cairo_t* ctx,
                          gint width,
                          gint height,
                          gint frame_number)
{
	BlindsEffect * self;
	gdouble alpha = 0.0;
	gint y = 0;
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	gint x = 0;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
#line 81 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffect*) base;
#line 81 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 81 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_if_fail (motion != NULL);
#line 81 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_if_fail (ctx != NULL);
#line 83 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	alpha = spit_transitions_motion_get_alpha (motion, frame_number);
#line 84 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	spit_transitions_visuals_get_to_pos (visuals, &_tmp0_);
#line 84 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_tmp1_ = _tmp0_;
#line 84 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	y = _tmp1_.y;
#line 85 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	spit_transitions_visuals_get_to_pos (visuals, &_tmp2_);
#line 85 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_tmp3_ = _tmp2_;
#line 85 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	x = _tmp3_.x;
#line 87 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_tmp4_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 87 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	_tmp5_ = _tmp4_;
#line 87 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	if (_tmp5_ != NULL) {
#line 538 "BlindsEffect.c"
		GdkPixbuf* _tmp6_;
		GdkPixbuf* _tmp7_;
		GdkRectangle _tmp8_ = {0};
		GdkRectangle _tmp9_;
		GdkRectangle _tmp10_ = {0};
		GdkRectangle _tmp11_;
#line 88 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp6_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 88 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp7_ = _tmp6_;
#line 88 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp8_);
#line 88 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp9_ = _tmp8_;
#line 88 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp10_);
#line 88 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		_tmp11_ = _tmp10_;
#line 88 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp7_, (gdouble) _tmp9_.x, (gdouble) _tmp11_.y);
#line 90 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		cairo_paint_with_alpha (ctx, 1 - (alpha * 2));
#line 561 "BlindsEffect.c"
	}
	{
		gint i = 0;
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
		i = 0;
#line 567 "BlindsEffect.c"
		{
			gboolean _tmp12_ = FALSE;
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
			_tmp12_ = TRUE;
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
			while (TRUE) {
#line 574 "BlindsEffect.c"
				cairo_surface_t** _tmp14_;
				gint _tmp14__length1;
				cairo_surface_t* _tmp15_;
				GdkPixbuf* _tmp16_;
				GdkPixbuf* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				if (!_tmp12_) {
#line 584 "BlindsEffect.c"
					gint _tmp13_;
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					i = i + 1;
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					_tmp13_ = i;
#line 590 "BlindsEffect.c"
				}
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp12_ = FALSE;
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				if (!(i < self->priv->blind_count)) {
#line 93 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
					break;
#line 598 "BlindsEffect.c"
				}
#line 94 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp14_ = self->priv->to_blinds;
#line 94 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp14__length1 = self->priv->to_blinds_length1;
#line 94 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp15_ = _tmp14_[i];
#line 94 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				cairo_set_source_surface (ctx, _tmp15_, (gdouble) (x + (i * self->priv->current_blind_width)), (gdouble) y);
#line 95 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp16_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 95 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp17_ = _tmp16_;
#line 95 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp18_ = gdk_pixbuf_get_height (_tmp17_);
#line 95 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				_tmp19_ = _tmp18_;
#line 95 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				cairo_rectangle (ctx, (gdouble) (x + (i * self->priv->current_blind_width)), (gdouble) y, self->priv->current_blind_width * (alpha + 0.5), (gdouble) _tmp19_);
#line 97 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
				cairo_fill (ctx);
#line 620 "BlindsEffect.c"
			}
		}
	}
#line 100 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	cairo_clip (ctx);
#line 101 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	cairo_paint (ctx);
#line 628 "BlindsEffect.c"
}

static void
blinds_effect_real_advance (SpitTransitionsEffect* base,
                            SpitTransitionsVisuals* visuals,
                            SpitTransitionsMotion* motion,
                            gint frame_number)
{
	BlindsEffect * self;
#line 104 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffect*) base;
#line 104 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 104 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_return_if_fail (motion != NULL);
#line 644 "BlindsEffect.c"
}

static void
blinds_effect_real_cancel (SpitTransitionsEffect* base)
{
	BlindsEffect * self;
#line 107 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = (BlindsEffect*) base;
#line 653 "BlindsEffect.c"
}

static void
blinds_effect_class_init (BlindsEffectClass * klass,
                          gpointer klass_data)
{
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	blinds_effect_parent_class = g_type_class_peek_parent (klass);
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	g_type_class_adjust_private_offset (klass, &BlindsEffect_private_offset);
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	G_OBJECT_CLASS (klass)->finalize = blinds_effect_finalize;
#line 666 "BlindsEffect.c"
}

static void
blinds_effect_spit_transitions_effect_interface_init (SpitTransitionsEffectIface * iface,
                                                      gpointer iface_data)
{
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	blinds_effect_spit_transitions_effect_parent_iface = g_type_interface_peek_parent (iface);
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	iface->get_fps = (void (*) (SpitTransitionsEffect*, gint*, gint*)) blinds_effect_real_get_fps;
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	iface->needs_clear_background = (gboolean (*) (SpitTransitionsEffect*)) blinds_effect_real_needs_clear_background;
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	iface->start = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*)) blinds_effect_real_start;
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	iface->paint = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, cairo_t*, gint, gint, gint)) blinds_effect_real_paint;
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	iface->advance = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, gint)) blinds_effect_real_advance;
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	iface->cancel = (void (*) (SpitTransitionsEffect*)) blinds_effect_real_cancel;
#line 687 "BlindsEffect.c"
}

static void
blinds_effect_instance_init (BlindsEffect * self,
                             gpointer klass)
{
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self->priv = blinds_effect_get_instance_private (self);
#line 696 "BlindsEffect.c"
}

static void
blinds_effect_finalize (GObject * obj)
{
	BlindsEffect * self;
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLINDS_EFFECT, BlindsEffect);
#line 48 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	self->priv->to_blinds = (_vala_array_free (self->priv->to_blinds, self->priv->to_blinds_length1, (GDestroyNotify) cairo_surface_destroy), NULL);
#line 41 "../plugins/pantheon-photos-transitions/BlindsEffect.vala"
	G_OBJECT_CLASS (blinds_effect_parent_class)->finalize (obj);
#line 709 "BlindsEffect.c"
}

static GType
blinds_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BlindsEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) blinds_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BlindsEffect), 0, (GInstanceInitFunc) blinds_effect_instance_init, NULL };
	static const GInterfaceInfo spit_transitions_effect_info = { (GInterfaceInitFunc) blinds_effect_spit_transitions_effect_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType blinds_effect_type_id;
	blinds_effect_type_id = g_type_register_static (G_TYPE_OBJECT, "BlindsEffect", &g_define_type_info, 0);
	g_type_add_interface_static (blinds_effect_type_id, SPIT_TRANSITIONS_TYPE_EFFECT, &spit_transitions_effect_info);
	BlindsEffect_private_offset = g_type_add_instance_private (blinds_effect_type_id, sizeof (BlindsEffectPrivate));
	return blinds_effect_type_id;
}

GType
blinds_effect_get_type (void)
{
	static volatile gsize blinds_effect_type_id__once = 0;
	if (g_once_init_enter (&blinds_effect_type_id__once)) {
		GType blinds_effect_type_id;
		blinds_effect_type_id = blinds_effect_get_type_once ();
		g_once_init_leave (&blinds_effect_type_id__once, blinds_effect_type_id);
	}
	return blinds_effect_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

