/* ChessEffect.c generated by valac 0.56.18, the Vala compiler
 * generated from ChessEffect.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2013 Jens Bav
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "pantheon-photos-transitions.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define CHESS_EFFECT_DESIRED_FPS 25
#define CHESS_EFFECT_MIN_FPS 10
#define CHESS_EFFECT_SQUARE_SIZE 100
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_CHESS_EFFECT_DESCRIPTOR (chess_effect_descriptor_get_type ())
#define CHESS_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptor))
#define CHESS_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptorClass))
#define IS_CHESS_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_EFFECT_DESCRIPTOR))
#define IS_CHESS_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_EFFECT_DESCRIPTOR))
#define CHESS_EFFECT_DESCRIPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_EFFECT_DESCRIPTOR, ChessEffectDescriptorClass))

typedef struct _ChessEffectDescriptor ChessEffectDescriptor;
typedef struct _ChessEffectDescriptorClass ChessEffectDescriptorClass;
typedef struct _ChessEffectDescriptorPrivate ChessEffectDescriptorPrivate;
enum  {
	CHESS_EFFECT_DESCRIPTOR_0_PROPERTY,
	CHESS_EFFECT_DESCRIPTOR_NUM_PROPERTIES
};
static GParamSpec* chess_effect_descriptor_properties[CHESS_EFFECT_DESCRIPTOR_NUM_PROPERTIES];

#define TYPE_CHESS_EFFECT (chess_effect_get_type ())
#define CHESS_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_EFFECT, ChessEffect))
#define CHESS_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_EFFECT, ChessEffectClass))
#define IS_CHESS_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_EFFECT))
#define IS_CHESS_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_EFFECT))
#define CHESS_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_EFFECT, ChessEffectClass))

typedef struct _ChessEffect ChessEffect;
typedef struct _ChessEffectClass ChessEffectClass;
typedef struct _ChessEffectPrivate ChessEffectPrivate;
enum  {
	CHESS_EFFECT_0_PROPERTY,
	CHESS_EFFECT_NUM_PROPERTIES
};
static GParamSpec* chess_effect_properties[CHESS_EFFECT_NUM_PROPERTIES];

struct _ChessEffectDescriptor {
	ShotwellTransitionDescriptor parent_instance;
	ChessEffectDescriptorPrivate * priv;
};

struct _ChessEffectDescriptorClass {
	ShotwellTransitionDescriptorClass parent_class;
};

struct _ChessEffect {
	GObject parent_instance;
	ChessEffectPrivate * priv;
};

struct _ChessEffectClass {
	GObjectClass parent_class;
};

struct _ChessEffectPrivate {
	gdouble square_count_x;
	gdouble square_count_y;
};

static gpointer chess_effect_descriptor_parent_class = NULL;
static gint ChessEffect_private_offset;
static gpointer chess_effect_parent_class = NULL;
static SpitTransitionsEffectIface * chess_effect_spit_transitions_effect_parent_iface = NULL;

VALA_EXTERN GType chess_effect_descriptor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ChessEffectDescriptor* chess_effect_descriptor_new (GFile* resource_directory);
VALA_EXTERN ChessEffectDescriptor* chess_effect_descriptor_construct (GType object_type,
                                                          GFile* resource_directory);
static const gchar* chess_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base);
static const gchar* chess_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base);
static SpitTransitionsEffect* chess_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                                            SpitHostInterface* host);
VALA_EXTERN ChessEffect* chess_effect_new (void);
VALA_EXTERN ChessEffect* chess_effect_construct (GType object_type);
VALA_EXTERN GType chess_effect_get_type (void) G_GNUC_CONST ;
static GType chess_effect_descriptor_get_type_once (void);
static void chess_effect_real_get_fps (SpitTransitionsEffect* base,
                                gint* desired_fps,
                                gint* min_fps);
static void chess_effect_real_start (SpitTransitionsEffect* base,
                              SpitTransitionsVisuals* visuals,
                              SpitTransitionsMotion* motion);
static gboolean chess_effect_real_needs_clear_background (SpitTransitionsEffect* base);
static void chess_effect_real_paint (SpitTransitionsEffect* base,
                              SpitTransitionsVisuals* visuals,
                              SpitTransitionsMotion* motion,
                              cairo_t* ctx,
                              gint width,
                              gint height,
                              gint frame_number);
static void chess_effect_real_advance (SpitTransitionsEffect* base,
                                SpitTransitionsVisuals* visuals,
                                SpitTransitionsMotion* motion,
                                gint frame_number);
static void chess_effect_real_cancel (SpitTransitionsEffect* base);
static void chess_effect_finalize (GObject * obj);
static GType chess_effect_get_type_once (void);

ChessEffectDescriptor*
chess_effect_descriptor_construct (GType object_type,
                                   GFile* resource_directory)
{
	ChessEffectDescriptor * self = NULL;
#line 24 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_val_if_fail (resource_directory != NULL, NULL);
#line 25 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffectDescriptor*) shotwell_transition_descriptor_construct (object_type, resource_directory);
#line 24 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	return self;
#line 156 "ChessEffect.c"
}

ChessEffectDescriptor*
chess_effect_descriptor_new (GFile* resource_directory)
{
#line 24 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	return chess_effect_descriptor_construct (TYPE_CHESS_EFFECT_DESCRIPTOR, resource_directory);
#line 164 "ChessEffect.c"
}

static const gchar*
chess_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base)
{
	ChessEffectDescriptor * self;
	const gchar* result;
#line 28 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffectDescriptor*) base;
#line 29 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	result = "io.elementary.photos.transitions.chess";
#line 29 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	return result;
#line 178 "ChessEffect.c"
}

static const gchar*
chess_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base)
{
	ChessEffectDescriptor * self;
	const gchar* result;
#line 32 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffectDescriptor*) base;
#line 33 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	result = _ ("Chess");
#line 33 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	return result;
#line 192 "ChessEffect.c"
}

static SpitTransitionsEffect*
chess_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                     SpitHostInterface* host)
{
	ChessEffectDescriptor * self;
	ChessEffect* _tmp0_;
	SpitTransitionsEffect* result;
#line 36 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffectDescriptor*) base;
#line 36 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 37 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_tmp0_ = chess_effect_new ();
#line 37 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	result = (SpitTransitionsEffect*) _tmp0_;
#line 37 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	return result;
#line 212 "ChessEffect.c"
}

static void
chess_effect_descriptor_class_init (ChessEffectDescriptorClass * klass,
                                    gpointer klass_data)
{
#line 23 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	chess_effect_descriptor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_id = (const gchar* (*) (ShotwellTransitionDescriptor*)) chess_effect_descriptor_real_get_id;
#line 23 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_pluggable_name = (const gchar* (*) (ShotwellTransitionDescriptor*)) chess_effect_descriptor_real_get_pluggable_name;
#line 23 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->create = (SpitTransitionsEffect* (*) (ShotwellTransitionDescriptor*, SpitHostInterface*)) chess_effect_descriptor_real_create;
#line 227 "ChessEffect.c"
}

static void
chess_effect_descriptor_instance_init (ChessEffectDescriptor * self,
                                       gpointer klass)
{
}

static GType
chess_effect_descriptor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessEffectDescriptorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_effect_descriptor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEffectDescriptor), 0, (GInstanceInitFunc) chess_effect_descriptor_instance_init, NULL };
	GType chess_effect_descriptor_type_id;
	chess_effect_descriptor_type_id = g_type_register_static (TYPE_SHOTWELL_TRANSITION_DESCRIPTOR, "ChessEffectDescriptor", &g_define_type_info, 0);
	return chess_effect_descriptor_type_id;
}

GType
chess_effect_descriptor_get_type (void)
{
	static volatile gsize chess_effect_descriptor_type_id__once = 0;
	if (g_once_init_enter (&chess_effect_descriptor_type_id__once)) {
		GType chess_effect_descriptor_type_id;
		chess_effect_descriptor_type_id = chess_effect_descriptor_get_type_once ();
		g_once_init_leave (&chess_effect_descriptor_type_id__once, chess_effect_descriptor_type_id);
	}
	return chess_effect_descriptor_type_id__once;
}

static inline gpointer
chess_effect_get_instance_private (ChessEffect* self)
{
	return G_STRUCT_MEMBER_P (self, ChessEffect_private_offset);
}

ChessEffect*
chess_effect_construct (GType object_type)
{
	ChessEffect * self = NULL;
#line 48 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffect*) g_object_new (object_type, NULL);
#line 48 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	return self;
#line 271 "ChessEffect.c"
}

ChessEffect*
chess_effect_new (void)
{
#line 48 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	return chess_effect_construct (TYPE_CHESS_EFFECT);
#line 279 "ChessEffect.c"
}

static void
chess_effect_real_get_fps (SpitTransitionsEffect* base,
                           gint* desired_fps,
                           gint* min_fps)
{
	ChessEffect * self;
	gint _vala_desired_fps = 0;
	gint _vala_min_fps = 0;
#line 51 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffect*) base;
#line 52 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_vala_desired_fps = CHESS_EFFECT_DESIRED_FPS;
#line 53 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_vala_min_fps = CHESS_EFFECT_MIN_FPS;
#line 51 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	if (desired_fps) {
#line 51 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		*desired_fps = _vala_desired_fps;
#line 300 "ChessEffect.c"
	}
#line 51 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	if (min_fps) {
#line 51 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		*min_fps = _vala_min_fps;
#line 306 "ChessEffect.c"
	}
}

static void
chess_effect_real_start (SpitTransitionsEffect* base,
                         SpitTransitionsVisuals* visuals,
                         SpitTransitionsMotion* motion)
{
	ChessEffect * self;
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_;
#line 56 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffect*) base;
#line 56 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 56 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_if_fail (motion != NULL);
#line 57 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	spit_transitions_visuals_get_to_pos (visuals, &_tmp0_);
#line 57 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_tmp1_ = _tmp0_;
#line 57 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self->priv->square_count_y = (gdouble) ((_tmp1_.height / CHESS_EFFECT_SQUARE_SIZE) + 2);
#line 58 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	spit_transitions_visuals_get_to_pos (visuals, &_tmp2_);
#line 58 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_tmp3_ = _tmp2_;
#line 58 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self->priv->square_count_x = (gdouble) ((_tmp3_.width / CHESS_EFFECT_SQUARE_SIZE) + 2);
#line 338 "ChessEffect.c"
}

static gboolean
chess_effect_real_needs_clear_background (SpitTransitionsEffect* base)
{
	ChessEffect * self;
	gboolean result;
#line 61 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffect*) base;
#line 62 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	result = TRUE;
#line 62 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	return result;
#line 352 "ChessEffect.c"
}

static void
chess_effect_real_paint (SpitTransitionsEffect* base,
                         SpitTransitionsVisuals* visuals,
                         SpitTransitionsMotion* motion,
                         cairo_t* ctx,
                         gint width,
                         gint height,
                         gint frame_number)
{
	ChessEffect * self;
	gdouble alpha = 0.0;
	gdouble size = 0.0;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
#line 65 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffect*) base;
#line 65 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 65 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_if_fail (motion != NULL);
#line 65 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_if_fail (ctx != NULL);
#line 67 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	alpha = spit_transitions_motion_get_alpha (motion, frame_number);
#line 68 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	size = (2 * alpha) * CHESS_EFFECT_SQUARE_SIZE;
#line 69 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_tmp0_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 69 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_tmp1_ = _tmp0_;
#line 69 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	if (_tmp1_ != NULL) {
#line 389 "ChessEffect.c"
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkRectangle _tmp4_ = {0};
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_ = {0};
		GdkRectangle _tmp7_;
#line 70 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		_tmp2_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 70 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		_tmp3_ = _tmp2_;
#line 70 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp4_);
#line 70 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		_tmp5_ = _tmp4_;
#line 70 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp6_);
#line 70 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		_tmp7_ = _tmp6_;
#line 70 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp3_, (gdouble) _tmp5_.x, (gdouble) _tmp7_.y);
#line 72 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		cairo_paint_with_alpha (ctx, 1 - alpha);
#line 412 "ChessEffect.c"
	}
#line 75 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_tmp8_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 75 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	_tmp9_ = _tmp8_;
#line 75 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	if (_tmp9_ != NULL) {
#line 420 "ChessEffect.c"
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkRectangle _tmp12_ = {0};
		GdkRectangle _tmp13_;
		GdkRectangle _tmp14_ = {0};
		GdkRectangle _tmp15_;
#line 76 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		_tmp10_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 76 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		_tmp11_ = _tmp10_;
#line 76 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp12_);
#line 76 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		_tmp13_ = _tmp12_;
#line 76 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp14_);
#line 76 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		_tmp15_ = _tmp14_;
#line 76 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp11_, (gdouble) _tmp13_.x, (gdouble) _tmp15_.y);
#line 441 "ChessEffect.c"
		{
			gdouble y = 0.0;
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
			y = (gdouble) 0;
#line 446 "ChessEffect.c"
			{
				gboolean _tmp16_ = FALSE;
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
				_tmp16_ = TRUE;
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
				while (TRUE) {
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
					if (!_tmp16_) {
#line 455 "ChessEffect.c"
						gdouble _tmp17_;
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
						_tmp17_ = y;
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
						y = _tmp17_ + 1;
#line 461 "ChessEffect.c"
					}
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
					_tmp16_ = FALSE;
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
					if (!(y <= self->priv->square_count_y)) {
#line 77 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
						break;
#line 469 "ChessEffect.c"
					}
					{
						gdouble x = 0.0;
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
						x = (gdouble) 0;
#line 475 "ChessEffect.c"
						{
							gboolean _tmp18_ = FALSE;
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
							_tmp18_ = TRUE;
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
							while (TRUE) {
#line 482 "ChessEffect.c"
								gdouble _tmp20_ = 0.0;
								gdouble translation = 0.0;
								SpitTransitionsDirection _tmp21_;
								SpitTransitionsDirection _tmp22_;
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
								if (!_tmp18_) {
#line 489 "ChessEffect.c"
									gdouble _tmp19_;
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									_tmp19_ = x;
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									x = _tmp19_ + 1;
#line 495 "ChessEffect.c"
								}
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
								_tmp18_ = FALSE;
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
								if (!(x <= self->priv->square_count_x)) {
#line 78 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									break;
#line 503 "ChessEffect.c"
								}
#line 79 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
								if (fmod (x + y, 2) == ((gdouble) 0)) {
#line 79 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									_tmp20_ = (-1.5) * CHESS_EFFECT_SQUARE_SIZE;
#line 509 "ChessEffect.c"
								} else {
#line 79 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									_tmp20_ = 1.5 * CHESS_EFFECT_SQUARE_SIZE;
#line 513 "ChessEffect.c"
								}
#line 79 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
								translation = _tmp20_;
#line 80 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
								_tmp21_ = spit_transitions_motion_get_direction (motion);
#line 80 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
								_tmp22_ = _tmp21_;
#line 80 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
								if (_tmp22_ == SPIT_TRANSITIONS_DIRECTION_FORWARD) {
#line 523 "ChessEffect.c"
									GdkRectangle _tmp23_ = {0};
									GdkRectangle _tmp24_;
									GdkRectangle _tmp25_ = {0};
									GdkRectangle _tmp26_;
#line 81 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp23_);
#line 81 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									_tmp24_ = _tmp23_;
#line 81 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp25_);
#line 81 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									_tmp26_ = _tmp25_;
#line 81 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									cairo_rectangle (ctx, (_tmp24_.x + translation) + (x * CHESS_EFFECT_SQUARE_SIZE), _tmp26_.y + (y * CHESS_EFFECT_SQUARE_SIZE), size, (gdouble) CHESS_EFFECT_SQUARE_SIZE);
#line 538 "ChessEffect.c"
								} else {
									GdkRectangle _tmp27_ = {0};
									GdkRectangle _tmp28_;
									GdkRectangle _tmp29_ = {0};
									GdkRectangle _tmp30_;
									GdkRectangle _tmp31_ = {0};
									GdkRectangle _tmp32_;
#line 84 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp27_);
#line 84 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									_tmp28_ = _tmp27_;
#line 84 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp29_);
#line 84 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									_tmp30_ = _tmp29_;
#line 84 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									spit_transitions_visuals_get_to_pos (visuals, &_tmp31_);
#line 84 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									_tmp32_ = _tmp31_;
#line 84 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
									cairo_rectangle (ctx, (((_tmp28_.x + _tmp30_.width) + translation) - (x * CHESS_EFFECT_SQUARE_SIZE)) - size, _tmp32_.y + (y * CHESS_EFFECT_SQUARE_SIZE), size, (gdouble) CHESS_EFFECT_SQUARE_SIZE);
#line 560 "ChessEffect.c"
								}
							}
						}
					}
				}
			}
		}
#line 91 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		cairo_clip (ctx);
#line 92 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
		cairo_paint_with_alpha (ctx, alpha);
#line 572 "ChessEffect.c"
	}
}

static void
chess_effect_real_advance (SpitTransitionsEffect* base,
                           SpitTransitionsVisuals* visuals,
                           SpitTransitionsMotion* motion,
                           gint frame_number)
{
	ChessEffect * self;
#line 96 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffect*) base;
#line 96 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 96 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_return_if_fail (motion != NULL);
#line 589 "ChessEffect.c"
}

static void
chess_effect_real_cancel (SpitTransitionsEffect* base)
{
	ChessEffect * self;
#line 99 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = (ChessEffect*) base;
#line 598 "ChessEffect.c"
}

static void
chess_effect_class_init (ChessEffectClass * klass,
                         gpointer klass_data)
{
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	chess_effect_parent_class = g_type_class_peek_parent (klass);
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	g_type_class_adjust_private_offset (klass, &ChessEffect_private_offset);
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_effect_finalize;
#line 611 "ChessEffect.c"
}

static void
chess_effect_spit_transitions_effect_interface_init (SpitTransitionsEffectIface * iface,
                                                     gpointer iface_data)
{
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	chess_effect_spit_transitions_effect_parent_iface = g_type_interface_peek_parent (iface);
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	iface->get_fps = (void (*) (SpitTransitionsEffect*, gint*, gint*)) chess_effect_real_get_fps;
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	iface->start = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*)) chess_effect_real_start;
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	iface->needs_clear_background = (gboolean (*) (SpitTransitionsEffect*)) chess_effect_real_needs_clear_background;
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	iface->paint = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, cairo_t*, gint, gint, gint)) chess_effect_real_paint;
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	iface->advance = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, gint)) chess_effect_real_advance;
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	iface->cancel = (void (*) (SpitTransitionsEffect*)) chess_effect_real_cancel;
#line 632 "ChessEffect.c"
}

static void
chess_effect_instance_init (ChessEffect * self,
                            gpointer klass)
{
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self->priv = chess_effect_get_instance_private (self);
#line 641 "ChessEffect.c"
}

static void
chess_effect_finalize (GObject * obj)
{
	ChessEffect * self;
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_EFFECT, ChessEffect);
#line 41 "../plugins/pantheon-photos-transitions/ChessEffect.vala"
	G_OBJECT_CLASS (chess_effect_parent_class)->finalize (obj);
#line 652 "ChessEffect.c"
}

static GType
chess_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEffect), 0, (GInstanceInitFunc) chess_effect_instance_init, NULL };
	static const GInterfaceInfo spit_transitions_effect_info = { (GInterfaceInitFunc) chess_effect_spit_transitions_effect_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType chess_effect_type_id;
	chess_effect_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessEffect", &g_define_type_info, 0);
	g_type_add_interface_static (chess_effect_type_id, SPIT_TRANSITIONS_TYPE_EFFECT, &spit_transitions_effect_info);
	ChessEffect_private_offset = g_type_add_instance_private (chess_effect_type_id, sizeof (ChessEffectPrivate));
	return chess_effect_type_id;
}

GType
chess_effect_get_type (void)
{
	static volatile gsize chess_effect_type_id__once = 0;
	if (g_once_init_enter (&chess_effect_type_id__once)) {
		GType chess_effect_type_id;
		chess_effect_type_id = chess_effect_get_type_once ();
		g_once_init_leave (&chess_effect_type_id__once, chess_effect_type_id);
	}
	return chess_effect_type_id__once;
}

