/* CirclesEffect.c generated by valac 0.56.18, the Vala compiler
 * generated from CirclesEffect.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2013 Jens Bav
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "pantheon-photos-transitions.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>

#define CIRCLES_EFFECT_DESIRED_FPS 25
#define CIRCLES_EFFECT_MIN_FPS 15
#define CIRCLES_EFFECT_SPEED 2.5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_CIRCLES_EFFECT_DESCRIPTOR (circles_effect_descriptor_get_type ())
#define CIRCLES_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CIRCLES_EFFECT_DESCRIPTOR, CirclesEffectDescriptor))
#define CIRCLES_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CIRCLES_EFFECT_DESCRIPTOR, CirclesEffectDescriptorClass))
#define IS_CIRCLES_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CIRCLES_EFFECT_DESCRIPTOR))
#define IS_CIRCLES_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CIRCLES_EFFECT_DESCRIPTOR))
#define CIRCLES_EFFECT_DESCRIPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CIRCLES_EFFECT_DESCRIPTOR, CirclesEffectDescriptorClass))

typedef struct _CirclesEffectDescriptor CirclesEffectDescriptor;
typedef struct _CirclesEffectDescriptorClass CirclesEffectDescriptorClass;
typedef struct _CirclesEffectDescriptorPrivate CirclesEffectDescriptorPrivate;
enum  {
	CIRCLES_EFFECT_DESCRIPTOR_0_PROPERTY,
	CIRCLES_EFFECT_DESCRIPTOR_NUM_PROPERTIES
};
static GParamSpec* circles_effect_descriptor_properties[CIRCLES_EFFECT_DESCRIPTOR_NUM_PROPERTIES];

#define TYPE_CIRCLES_EFFECT (circles_effect_get_type ())
#define CIRCLES_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CIRCLES_EFFECT, CirclesEffect))
#define CIRCLES_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CIRCLES_EFFECT, CirclesEffectClass))
#define IS_CIRCLES_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CIRCLES_EFFECT))
#define IS_CIRCLES_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CIRCLES_EFFECT))
#define CIRCLES_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CIRCLES_EFFECT, CirclesEffectClass))

typedef struct _CirclesEffect CirclesEffect;
typedef struct _CirclesEffectClass CirclesEffectClass;
typedef struct _CirclesEffectPrivate CirclesEffectPrivate;
enum  {
	CIRCLES_EFFECT_0_PROPERTY,
	CIRCLES_EFFECT_NUM_PROPERTIES
};
static GParamSpec* circles_effect_properties[CIRCLES_EFFECT_NUM_PROPERTIES];

struct _CirclesEffectDescriptor {
	ShotwellTransitionDescriptor parent_instance;
	CirclesEffectDescriptorPrivate * priv;
};

struct _CirclesEffectDescriptorClass {
	ShotwellTransitionDescriptorClass parent_class;
};

struct _CirclesEffect {
	GObject parent_instance;
	CirclesEffectPrivate * priv;
};

struct _CirclesEffectClass {
	GObjectClass parent_class;
};

static gpointer circles_effect_descriptor_parent_class = NULL;
static gpointer circles_effect_parent_class = NULL;
static SpitTransitionsEffectIface * circles_effect_spit_transitions_effect_parent_iface = NULL;

VALA_EXTERN GType circles_effect_descriptor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN CirclesEffectDescriptor* circles_effect_descriptor_new (GFile* resource_directory);
VALA_EXTERN CirclesEffectDescriptor* circles_effect_descriptor_construct (GType object_type,
                                                              GFile* resource_directory);
static const gchar* circles_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base);
static const gchar* circles_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base);
static SpitTransitionsEffect* circles_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                                              SpitHostInterface* host);
VALA_EXTERN CirclesEffect* circles_effect_new (void);
VALA_EXTERN CirclesEffect* circles_effect_construct (GType object_type);
VALA_EXTERN GType circles_effect_get_type (void) G_GNUC_CONST ;
static GType circles_effect_descriptor_get_type_once (void);
static void circles_effect_real_get_fps (SpitTransitionsEffect* base,
                                  gint* desired_fps,
                                  gint* min_fps);
static void circles_effect_real_start (SpitTransitionsEffect* base,
                                SpitTransitionsVisuals* visuals,
                                SpitTransitionsMotion* motion);
static gboolean circles_effect_real_needs_clear_background (SpitTransitionsEffect* base);
static void circles_effect_real_paint (SpitTransitionsEffect* base,
                                SpitTransitionsVisuals* visuals,
                                SpitTransitionsMotion* motion,
                                cairo_t* ctx,
                                gint width,
                                gint height,
                                gint frame_number);
static void circles_effect_real_advance (SpitTransitionsEffect* base,
                                  SpitTransitionsVisuals* visuals,
                                  SpitTransitionsMotion* motion,
                                  gint frame_number);
static void circles_effect_real_cancel (SpitTransitionsEffect* base);
static GType circles_effect_get_type_once (void);

CirclesEffectDescriptor*
circles_effect_descriptor_construct (GType object_type,
                                     GFile* resource_directory)
{
	CirclesEffectDescriptor * self = NULL;
#line 24 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_val_if_fail (resource_directory != NULL, NULL);
#line 25 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffectDescriptor*) shotwell_transition_descriptor_construct (object_type, resource_directory);
#line 24 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	return self;
#line 149 "CirclesEffect.c"
}

CirclesEffectDescriptor*
circles_effect_descriptor_new (GFile* resource_directory)
{
#line 24 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	return circles_effect_descriptor_construct (TYPE_CIRCLES_EFFECT_DESCRIPTOR, resource_directory);
#line 157 "CirclesEffect.c"
}

static const gchar*
circles_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base)
{
	CirclesEffectDescriptor * self;
	const gchar* result;
#line 28 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffectDescriptor*) base;
#line 29 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	result = "io.elementary.photos.transitions.circles";
#line 29 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	return result;
#line 171 "CirclesEffect.c"
}

static const gchar*
circles_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base)
{
	CirclesEffectDescriptor * self;
	const gchar* result;
#line 32 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffectDescriptor*) base;
#line 33 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	result = _ ("Circles");
#line 33 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	return result;
#line 185 "CirclesEffect.c"
}

static SpitTransitionsEffect*
circles_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                       SpitHostInterface* host)
{
	CirclesEffectDescriptor * self;
	CirclesEffect* _tmp0_;
	SpitTransitionsEffect* result;
#line 36 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffectDescriptor*) base;
#line 36 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 37 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	_tmp0_ = circles_effect_new ();
#line 37 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	result = (SpitTransitionsEffect*) _tmp0_;
#line 37 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	return result;
#line 205 "CirclesEffect.c"
}

static void
circles_effect_descriptor_class_init (CirclesEffectDescriptorClass * klass,
                                      gpointer klass_data)
{
#line 23 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	circles_effect_descriptor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_id = (const gchar* (*) (ShotwellTransitionDescriptor*)) circles_effect_descriptor_real_get_id;
#line 23 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_pluggable_name = (const gchar* (*) (ShotwellTransitionDescriptor*)) circles_effect_descriptor_real_get_pluggable_name;
#line 23 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->create = (SpitTransitionsEffect* (*) (ShotwellTransitionDescriptor*, SpitHostInterface*)) circles_effect_descriptor_real_create;
#line 220 "CirclesEffect.c"
}

static void
circles_effect_descriptor_instance_init (CirclesEffectDescriptor * self,
                                         gpointer klass)
{
}

static GType
circles_effect_descriptor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CirclesEffectDescriptorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) circles_effect_descriptor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CirclesEffectDescriptor), 0, (GInstanceInitFunc) circles_effect_descriptor_instance_init, NULL };
	GType circles_effect_descriptor_type_id;
	circles_effect_descriptor_type_id = g_type_register_static (TYPE_SHOTWELL_TRANSITION_DESCRIPTOR, "CirclesEffectDescriptor", &g_define_type_info, 0);
	return circles_effect_descriptor_type_id;
}

GType
circles_effect_descriptor_get_type (void)
{
	static volatile gsize circles_effect_descriptor_type_id__once = 0;
	if (g_once_init_enter (&circles_effect_descriptor_type_id__once)) {
		GType circles_effect_descriptor_type_id;
		circles_effect_descriptor_type_id = circles_effect_descriptor_get_type_once ();
		g_once_init_leave (&circles_effect_descriptor_type_id__once, circles_effect_descriptor_type_id);
	}
	return circles_effect_descriptor_type_id__once;
}

CirclesEffect*
circles_effect_construct (GType object_type)
{
	CirclesEffect * self = NULL;
#line 46 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffect*) g_object_new (object_type, NULL);
#line 46 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	return self;
#line 258 "CirclesEffect.c"
}

CirclesEffect*
circles_effect_new (void)
{
#line 46 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	return circles_effect_construct (TYPE_CIRCLES_EFFECT);
#line 266 "CirclesEffect.c"
}

static void
circles_effect_real_get_fps (SpitTransitionsEffect* base,
                             gint* desired_fps,
                             gint* min_fps)
{
	CirclesEffect * self;
	gint _vala_desired_fps = 0;
	gint _vala_min_fps = 0;
#line 49 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffect*) base;
#line 50 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	_vala_desired_fps = CIRCLES_EFFECT_DESIRED_FPS;
#line 51 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	_vala_min_fps = CIRCLES_EFFECT_MIN_FPS;
#line 49 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	if (desired_fps) {
#line 49 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		*desired_fps = _vala_desired_fps;
#line 287 "CirclesEffect.c"
	}
#line 49 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	if (min_fps) {
#line 49 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		*min_fps = _vala_min_fps;
#line 293 "CirclesEffect.c"
	}
}

static void
circles_effect_real_start (SpitTransitionsEffect* base,
                           SpitTransitionsVisuals* visuals,
                           SpitTransitionsMotion* motion)
{
	CirclesEffect * self;
#line 54 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffect*) base;
#line 54 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 54 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_if_fail (motion != NULL);
#line 309 "CirclesEffect.c"
}

static gboolean
circles_effect_real_needs_clear_background (SpitTransitionsEffect* base)
{
	CirclesEffect * self;
	gboolean result;
#line 57 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffect*) base;
#line 58 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	result = TRUE;
#line 58 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	return result;
#line 323 "CirclesEffect.c"
}

static void
circles_effect_real_paint (SpitTransitionsEffect* base,
                           SpitTransitionsVisuals* visuals,
                           SpitTransitionsMotion* motion,
                           cairo_t* ctx,
                           gint width,
                           gint height,
                           gint frame_number)
{
	CirclesEffect * self;
	gdouble alpha = 0.0;
	gint distance = 0;
	gint radius = 0;
	gint circle_count_x = 0;
	gint circle_count_y = 0;
	gdouble max_radius = 0.0;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
#line 61 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffect*) base;
#line 61 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 61 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_if_fail (motion != NULL);
#line 61 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_if_fail (ctx != NULL);
#line 63 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	alpha = spit_transitions_motion_get_alpha (motion, frame_number);
#line 64 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	distance = 60;
#line 65 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	circle_count_x = width / (2 * distance);
#line 66 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	circle_count_y = height / distance;
#line 67 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	max_radius = CIRCLES_EFFECT_SPEED * distance;
#line 69 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	_tmp0_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 69 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	_tmp1_ = _tmp0_;
#line 69 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	if (_tmp1_ != NULL) {
#line 370 "CirclesEffect.c"
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkRectangle _tmp4_ = {0};
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_ = {0};
		GdkRectangle _tmp7_;
#line 70 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		_tmp2_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 70 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		_tmp3_ = _tmp2_;
#line 70 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp4_);
#line 70 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		_tmp5_ = _tmp4_;
#line 70 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp6_);
#line 70 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		_tmp7_ = _tmp6_;
#line 70 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp3_, (gdouble) _tmp5_.x, (gdouble) _tmp7_.y);
#line 72 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		cairo_paint_with_alpha (ctx, 1 - alpha);
#line 393 "CirclesEffect.c"
	}
#line 75 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	_tmp8_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 75 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	_tmp9_ = _tmp8_;
#line 75 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	if (_tmp9_ != NULL) {
#line 401 "CirclesEffect.c"
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkRectangle _tmp12_ = {0};
		GdkRectangle _tmp13_;
		GdkRectangle _tmp14_ = {0};
		GdkRectangle _tmp15_;
#line 76 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		_tmp10_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 76 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		_tmp11_ = _tmp10_;
#line 76 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp12_);
#line 76 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		_tmp13_ = _tmp12_;
#line 76 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp14_);
#line 76 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		_tmp15_ = _tmp14_;
#line 76 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp11_, (gdouble) _tmp13_.x, (gdouble) _tmp15_.y);
#line 422 "CirclesEffect.c"
		{
			gint y = 0;
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
			y = 0;
#line 427 "CirclesEffect.c"
			{
				gboolean _tmp16_ = FALSE;
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
				_tmp16_ = TRUE;
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
				while (TRUE) {
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
					if (!_tmp16_) {
#line 436 "CirclesEffect.c"
						gint _tmp17_;
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
						_tmp17_ = y;
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
						y = _tmp17_ + 1;
#line 442 "CirclesEffect.c"
					}
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
					_tmp16_ = FALSE;
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
					if (!(y <= circle_count_y)) {
#line 78 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
						break;
#line 450 "CirclesEffect.c"
					}
					{
						gint x = 0;
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
						x = 0;
#line 456 "CirclesEffect.c"
						{
							gboolean _tmp18_ = FALSE;
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
							_tmp18_ = TRUE;
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
							while (TRUE) {
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
								if (!_tmp18_) {
#line 465 "CirclesEffect.c"
									gint _tmp19_;
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
									_tmp19_ = x;
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
									x = _tmp19_ + 1;
#line 471 "CirclesEffect.c"
								}
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
								_tmp18_ = FALSE;
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
								if (!(x <= circle_count_x)) {
#line 79 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
									break;
#line 479 "CirclesEffect.c"
								}
#line 80 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
								radius = (gint) (fmax ((gdouble) 0, fmin ((gdouble) 1, alpha - (((gdouble) (x + y)) / ((gdouble) ((circle_count_y + circle_count_x) * CIRCLES_EFFECT_SPEED))))) * max_radius);
#line 82 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
								cairo_arc (ctx, (gdouble) ((2 * distance) * x), (gdouble) ((2 * distance) * y), (gdouble) radius, (gdouble) 0, 2 * G_PI);
#line 83 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
								cairo_fill (ctx);
#line 487 "CirclesEffect.c"
							}
						}
					}
				}
			}
		}
#line 87 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		cairo_clip (ctx);
#line 88 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
		cairo_paint_with_alpha (ctx, alpha);
#line 498 "CirclesEffect.c"
	}
}

static void
circles_effect_real_advance (SpitTransitionsEffect* base,
                             SpitTransitionsVisuals* visuals,
                             SpitTransitionsMotion* motion,
                             gint frame_number)
{
	CirclesEffect * self;
#line 92 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffect*) base;
#line 92 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 92 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	g_return_if_fail (motion != NULL);
#line 515 "CirclesEffect.c"
}

static void
circles_effect_real_cancel (SpitTransitionsEffect* base)
{
	CirclesEffect * self;
#line 95 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	self = (CirclesEffect*) base;
#line 524 "CirclesEffect.c"
}

static void
circles_effect_class_init (CirclesEffectClass * klass,
                           gpointer klass_data)
{
#line 41 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	circles_effect_parent_class = g_type_class_peek_parent (klass);
#line 533 "CirclesEffect.c"
}

static void
circles_effect_spit_transitions_effect_interface_init (SpitTransitionsEffectIface * iface,
                                                       gpointer iface_data)
{
#line 41 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	circles_effect_spit_transitions_effect_parent_iface = g_type_interface_peek_parent (iface);
#line 41 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	iface->get_fps = (void (*) (SpitTransitionsEffect*, gint*, gint*)) circles_effect_real_get_fps;
#line 41 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	iface->start = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*)) circles_effect_real_start;
#line 41 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	iface->needs_clear_background = (gboolean (*) (SpitTransitionsEffect*)) circles_effect_real_needs_clear_background;
#line 41 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	iface->paint = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, cairo_t*, gint, gint, gint)) circles_effect_real_paint;
#line 41 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	iface->advance = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, gint)) circles_effect_real_advance;
#line 41 "../plugins/pantheon-photos-transitions/CirclesEffect.vala"
	iface->cancel = (void (*) (SpitTransitionsEffect*)) circles_effect_real_cancel;
#line 554 "CirclesEffect.c"
}

static void
circles_effect_instance_init (CirclesEffect * self,
                              gpointer klass)
{
}

static GType
circles_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CirclesEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) circles_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CirclesEffect), 0, (GInstanceInitFunc) circles_effect_instance_init, NULL };
	static const GInterfaceInfo spit_transitions_effect_info = { (GInterfaceInitFunc) circles_effect_spit_transitions_effect_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType circles_effect_type_id;
	circles_effect_type_id = g_type_register_static (G_TYPE_OBJECT, "CirclesEffect", &g_define_type_info, 0);
	g_type_add_interface_static (circles_effect_type_id, SPIT_TRANSITIONS_TYPE_EFFECT, &spit_transitions_effect_info);
	return circles_effect_type_id;
}

GType
circles_effect_get_type (void)
{
	static volatile gsize circles_effect_type_id__once = 0;
	if (g_once_init_enter (&circles_effect_type_id__once)) {
		GType circles_effect_type_id;
		circles_effect_type_id = circles_effect_get_type_once ();
		g_once_init_leave (&circles_effect_type_id__once, circles_effect_type_id);
	}
	return circles_effect_type_id__once;
}

