/* ClockEffect.c generated by valac 0.56.18, the Vala compiler
 * generated from ClockEffect.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2013 Jens Bav
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "pantheon-photos-transitions.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define CLOCK_EFFECT_DESIRED_FPS 25
#define CLOCK_EFFECT_MIN_FPS 15
#define CLOCK_EFFECT_TOP_RADIANT (0.5 * G_PI)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_CLOCK_EFFECT_DESCRIPTOR (clock_effect_descriptor_get_type ())
#define CLOCK_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOCK_EFFECT_DESCRIPTOR, ClockEffectDescriptor))
#define CLOCK_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOCK_EFFECT_DESCRIPTOR, ClockEffectDescriptorClass))
#define IS_CLOCK_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOCK_EFFECT_DESCRIPTOR))
#define IS_CLOCK_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOCK_EFFECT_DESCRIPTOR))
#define CLOCK_EFFECT_DESCRIPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOCK_EFFECT_DESCRIPTOR, ClockEffectDescriptorClass))

typedef struct _ClockEffectDescriptor ClockEffectDescriptor;
typedef struct _ClockEffectDescriptorClass ClockEffectDescriptorClass;
typedef struct _ClockEffectDescriptorPrivate ClockEffectDescriptorPrivate;
enum  {
	CLOCK_EFFECT_DESCRIPTOR_0_PROPERTY,
	CLOCK_EFFECT_DESCRIPTOR_NUM_PROPERTIES
};
static GParamSpec* clock_effect_descriptor_properties[CLOCK_EFFECT_DESCRIPTOR_NUM_PROPERTIES];

#define TYPE_CLOCK_EFFECT (clock_effect_get_type ())
#define CLOCK_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOCK_EFFECT, ClockEffect))
#define CLOCK_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOCK_EFFECT, ClockEffectClass))
#define IS_CLOCK_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOCK_EFFECT))
#define IS_CLOCK_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOCK_EFFECT))
#define CLOCK_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOCK_EFFECT, ClockEffectClass))

typedef struct _ClockEffect ClockEffect;
typedef struct _ClockEffectClass ClockEffectClass;
typedef struct _ClockEffectPrivate ClockEffectPrivate;
enum  {
	CLOCK_EFFECT_0_PROPERTY,
	CLOCK_EFFECT_NUM_PROPERTIES
};
static GParamSpec* clock_effect_properties[CLOCK_EFFECT_NUM_PROPERTIES];

struct _ClockEffectDescriptor {
	ShotwellTransitionDescriptor parent_instance;
	ClockEffectDescriptorPrivate * priv;
};

struct _ClockEffectDescriptorClass {
	ShotwellTransitionDescriptorClass parent_class;
};

struct _ClockEffect {
	GObject parent_instance;
	ClockEffectPrivate * priv;
};

struct _ClockEffectClass {
	GObjectClass parent_class;
};

static gpointer clock_effect_descriptor_parent_class = NULL;
static gpointer clock_effect_parent_class = NULL;
static SpitTransitionsEffectIface * clock_effect_spit_transitions_effect_parent_iface = NULL;

VALA_EXTERN GType clock_effect_descriptor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClockEffectDescriptor* clock_effect_descriptor_new (GFile* resource_directory);
VALA_EXTERN ClockEffectDescriptor* clock_effect_descriptor_construct (GType object_type,
                                                          GFile* resource_directory);
static const gchar* clock_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base);
static const gchar* clock_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base);
static SpitTransitionsEffect* clock_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                                            SpitHostInterface* host);
VALA_EXTERN ClockEffect* clock_effect_new (void);
VALA_EXTERN ClockEffect* clock_effect_construct (GType object_type);
VALA_EXTERN GType clock_effect_get_type (void) G_GNUC_CONST ;
static GType clock_effect_descriptor_get_type_once (void);
static void clock_effect_real_get_fps (SpitTransitionsEffect* base,
                                gint* desired_fps,
                                gint* min_fps);
static void clock_effect_real_start (SpitTransitionsEffect* base,
                              SpitTransitionsVisuals* visuals,
                              SpitTransitionsMotion* motion);
static gboolean clock_effect_real_needs_clear_background (SpitTransitionsEffect* base);
static void clock_effect_real_paint (SpitTransitionsEffect* base,
                              SpitTransitionsVisuals* visuals,
                              SpitTransitionsMotion* motion,
                              cairo_t* ctx,
                              gint width,
                              gint height,
                              gint frame_number);
static void clock_effect_real_advance (SpitTransitionsEffect* base,
                                SpitTransitionsVisuals* visuals,
                                SpitTransitionsMotion* motion,
                                gint frame_number);
static void clock_effect_real_cancel (SpitTransitionsEffect* base);
static GType clock_effect_get_type_once (void);

ClockEffectDescriptor*
clock_effect_descriptor_construct (GType object_type,
                                   GFile* resource_directory)
{
	ClockEffectDescriptor * self = NULL;
#line 24 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_val_if_fail (resource_directory != NULL, NULL);
#line 25 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffectDescriptor*) shotwell_transition_descriptor_construct (object_type, resource_directory);
#line 24 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	return self;
#line 149 "ClockEffect.c"
}

ClockEffectDescriptor*
clock_effect_descriptor_new (GFile* resource_directory)
{
#line 24 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	return clock_effect_descriptor_construct (TYPE_CLOCK_EFFECT_DESCRIPTOR, resource_directory);
#line 157 "ClockEffect.c"
}

static const gchar*
clock_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base)
{
	ClockEffectDescriptor * self;
	const gchar* result;
#line 28 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffectDescriptor*) base;
#line 29 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	result = "io.elementary.photos.transitions.clock";
#line 29 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	return result;
#line 171 "ClockEffect.c"
}

static const gchar*
clock_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base)
{
	ClockEffectDescriptor * self;
	const gchar* result;
#line 32 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffectDescriptor*) base;
#line 33 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	result = _ ("Clock");
#line 33 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	return result;
#line 185 "ClockEffect.c"
}

static SpitTransitionsEffect*
clock_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                     SpitHostInterface* host)
{
	ClockEffectDescriptor * self;
	ClockEffect* _tmp0_;
	SpitTransitionsEffect* result;
#line 36 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffectDescriptor*) base;
#line 36 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 37 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp0_ = clock_effect_new ();
#line 37 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	result = (SpitTransitionsEffect*) _tmp0_;
#line 37 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	return result;
#line 205 "ClockEffect.c"
}

static void
clock_effect_descriptor_class_init (ClockEffectDescriptorClass * klass,
                                    gpointer klass_data)
{
#line 23 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	clock_effect_descriptor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_id = (const gchar* (*) (ShotwellTransitionDescriptor*)) clock_effect_descriptor_real_get_id;
#line 23 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_pluggable_name = (const gchar* (*) (ShotwellTransitionDescriptor*)) clock_effect_descriptor_real_get_pluggable_name;
#line 23 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->create = (SpitTransitionsEffect* (*) (ShotwellTransitionDescriptor*, SpitHostInterface*)) clock_effect_descriptor_real_create;
#line 220 "ClockEffect.c"
}

static void
clock_effect_descriptor_instance_init (ClockEffectDescriptor * self,
                                       gpointer klass)
{
}

static GType
clock_effect_descriptor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockEffectDescriptorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_effect_descriptor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockEffectDescriptor), 0, (GInstanceInitFunc) clock_effect_descriptor_instance_init, NULL };
	GType clock_effect_descriptor_type_id;
	clock_effect_descriptor_type_id = g_type_register_static (TYPE_SHOTWELL_TRANSITION_DESCRIPTOR, "ClockEffectDescriptor", &g_define_type_info, 0);
	return clock_effect_descriptor_type_id;
}

GType
clock_effect_descriptor_get_type (void)
{
	static volatile gsize clock_effect_descriptor_type_id__once = 0;
	if (g_once_init_enter (&clock_effect_descriptor_type_id__once)) {
		GType clock_effect_descriptor_type_id;
		clock_effect_descriptor_type_id = clock_effect_descriptor_get_type_once ();
		g_once_init_leave (&clock_effect_descriptor_type_id__once, clock_effect_descriptor_type_id);
	}
	return clock_effect_descriptor_type_id__once;
}

ClockEffect*
clock_effect_construct (GType object_type)
{
	ClockEffect * self = NULL;
#line 46 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffect*) g_object_new (object_type, NULL);
#line 46 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	return self;
#line 258 "ClockEffect.c"
}

ClockEffect*
clock_effect_new (void)
{
#line 46 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	return clock_effect_construct (TYPE_CLOCK_EFFECT);
#line 266 "ClockEffect.c"
}

static void
clock_effect_real_get_fps (SpitTransitionsEffect* base,
                           gint* desired_fps,
                           gint* min_fps)
{
	ClockEffect * self;
	gint _vala_desired_fps = 0;
	gint _vala_min_fps = 0;
#line 49 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffect*) base;
#line 50 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_vala_desired_fps = CLOCK_EFFECT_DESIRED_FPS;
#line 51 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_vala_min_fps = CLOCK_EFFECT_MIN_FPS;
#line 49 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	if (desired_fps) {
#line 49 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		*desired_fps = _vala_desired_fps;
#line 287 "ClockEffect.c"
	}
#line 49 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	if (min_fps) {
#line 49 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		*min_fps = _vala_min_fps;
#line 293 "ClockEffect.c"
	}
}

static void
clock_effect_real_start (SpitTransitionsEffect* base,
                         SpitTransitionsVisuals* visuals,
                         SpitTransitionsMotion* motion)
{
	ClockEffect * self;
#line 54 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffect*) base;
#line 54 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 54 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_if_fail (motion != NULL);
#line 309 "ClockEffect.c"
}

static gboolean
clock_effect_real_needs_clear_background (SpitTransitionsEffect* base)
{
	ClockEffect * self;
	gboolean result;
#line 57 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffect*) base;
#line 58 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	result = TRUE;
#line 58 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	return result;
#line 323 "ClockEffect.c"
}

static void
clock_effect_real_paint (SpitTransitionsEffect* base,
                         SpitTransitionsVisuals* visuals,
                         SpitTransitionsMotion* motion,
                         cairo_t* ctx,
                         gint width,
                         gint height,
                         gint frame_number)
{
	ClockEffect * self;
	gdouble alpha = 0.0;
	gdouble start_angle = 0.0;
	gdouble stop_angle = 0.0;
	SpitTransitionsDirection _tmp0_;
	SpitTransitionsDirection _tmp1_;
	gint radius = 0;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp14_;
	GdkPixbuf* _tmp15_;
#line 61 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffect*) base;
#line 61 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 61 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_if_fail (motion != NULL);
#line 61 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_if_fail (ctx != NULL);
#line 63 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	alpha = spit_transitions_motion_get_alpha (motion, frame_number);
#line 64 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	start_angle = -CLOCK_EFFECT_TOP_RADIANT;
#line 64 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	stop_angle = -CLOCK_EFFECT_TOP_RADIANT;
#line 66 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp0_ = spit_transitions_motion_get_direction (motion);
#line 66 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp1_ = _tmp0_;
#line 66 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	if (_tmp1_ == SPIT_TRANSITIONS_DIRECTION_FORWARD) {
#line 67 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		stop_angle = ((alpha * G_PI) * 2) - CLOCK_EFFECT_TOP_RADIANT;
#line 372 "ClockEffect.c"
	} else {
#line 69 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		start_angle = ((2 * (1 - alpha)) * G_PI) - CLOCK_EFFECT_TOP_RADIANT;
#line 376 "ClockEffect.c"
	}
#line 71 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	spit_transitions_visuals_get_to_pos (visuals, &_tmp2_);
#line 71 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp3_ = _tmp2_;
#line 71 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	spit_transitions_visuals_get_to_pos (visuals, &_tmp4_);
#line 71 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp5_ = _tmp4_;
#line 71 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	radius = (gint) fmax ((gdouble) _tmp3_.width, (gdouble) _tmp5_.height);
#line 73 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp6_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 73 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp7_ = _tmp6_;
#line 73 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	if (_tmp7_ != NULL) {
#line 394 "ClockEffect.c"
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		GdkRectangle _tmp10_ = {0};
		GdkRectangle _tmp11_;
		GdkRectangle _tmp12_ = {0};
		GdkRectangle _tmp13_;
#line 74 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp8_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 74 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp9_ = _tmp8_;
#line 74 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp10_);
#line 74 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp11_ = _tmp10_;
#line 74 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp12_);
#line 74 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp13_ = _tmp12_;
#line 74 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp9_, (gdouble) _tmp11_.x, (gdouble) _tmp13_.y);
#line 76 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		cairo_paint_with_alpha (ctx, 1 - alpha);
#line 417 "ClockEffect.c"
	}
#line 79 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp14_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 79 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	_tmp15_ = _tmp14_;
#line 79 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	if (_tmp15_ != NULL) {
#line 425 "ClockEffect.c"
		GdkPixbuf* _tmp16_;
		GdkPixbuf* _tmp17_;
		GdkRectangle _tmp18_ = {0};
		GdkRectangle _tmp19_;
		GdkRectangle _tmp20_ = {0};
		GdkRectangle _tmp21_;
		gint x = 0;
		GdkRectangle _tmp22_ = {0};
		GdkRectangle _tmp23_;
		GdkRectangle _tmp24_ = {0};
		GdkRectangle _tmp25_;
		gint y = 0;
		GdkRectangle _tmp26_ = {0};
		GdkRectangle _tmp27_;
		GdkRectangle _tmp28_ = {0};
		GdkRectangle _tmp29_;
#line 80 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp16_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 80 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp17_ = _tmp16_;
#line 80 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp18_);
#line 80 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp19_ = _tmp18_;
#line 80 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp20_);
#line 80 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp21_ = _tmp20_;
#line 80 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp17_, (gdouble) _tmp19_.x, (gdouble) _tmp21_.y);
#line 82 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp22_);
#line 82 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp23_ = _tmp22_;
#line 82 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp24_);
#line 82 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp25_ = _tmp24_;
#line 82 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		x = _tmp23_.x + (((gint) _tmp25_.width) / 2);
#line 83 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp26_);
#line 83 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp27_ = _tmp26_;
#line 83 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp28_);
#line 83 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		_tmp29_ = _tmp28_;
#line 83 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		y = _tmp27_.y + (((gint) _tmp29_.height) / 2);
#line 85 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		cairo_move_to (ctx, (gdouble) x, (gdouble) y);
#line 86 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		cairo_arc (ctx, (gdouble) x, (gdouble) y, (gdouble) radius, start_angle, stop_angle);
#line 87 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
		cairo_fill_preserve (ctx);
#line 482 "ClockEffect.c"
	}
}

static void
clock_effect_real_advance (SpitTransitionsEffect* base,
                           SpitTransitionsVisuals* visuals,
                           SpitTransitionsMotion* motion,
                           gint frame_number)
{
	ClockEffect * self;
#line 91 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffect*) base;
#line 91 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 91 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	g_return_if_fail (motion != NULL);
#line 499 "ClockEffect.c"
}

static void
clock_effect_real_cancel (SpitTransitionsEffect* base)
{
	ClockEffect * self;
#line 94 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	self = (ClockEffect*) base;
#line 508 "ClockEffect.c"
}

static void
clock_effect_class_init (ClockEffectClass * klass,
                         gpointer klass_data)
{
#line 41 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	clock_effect_parent_class = g_type_class_peek_parent (klass);
#line 517 "ClockEffect.c"
}

static void
clock_effect_spit_transitions_effect_interface_init (SpitTransitionsEffectIface * iface,
                                                     gpointer iface_data)
{
#line 41 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	clock_effect_spit_transitions_effect_parent_iface = g_type_interface_peek_parent (iface);
#line 41 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	iface->get_fps = (void (*) (SpitTransitionsEffect*, gint*, gint*)) clock_effect_real_get_fps;
#line 41 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	iface->start = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*)) clock_effect_real_start;
#line 41 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	iface->needs_clear_background = (gboolean (*) (SpitTransitionsEffect*)) clock_effect_real_needs_clear_background;
#line 41 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	iface->paint = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, cairo_t*, gint, gint, gint)) clock_effect_real_paint;
#line 41 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	iface->advance = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, gint)) clock_effect_real_advance;
#line 41 "../plugins/pantheon-photos-transitions/ClockEffect.vala"
	iface->cancel = (void (*) (SpitTransitionsEffect*)) clock_effect_real_cancel;
#line 538 "ClockEffect.c"
}

static void
clock_effect_instance_init (ClockEffect * self,
                            gpointer klass)
{
}

static GType
clock_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockEffect), 0, (GInstanceInitFunc) clock_effect_instance_init, NULL };
	static const GInterfaceInfo spit_transitions_effect_info = { (GInterfaceInitFunc) clock_effect_spit_transitions_effect_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType clock_effect_type_id;
	clock_effect_type_id = g_type_register_static (G_TYPE_OBJECT, "ClockEffect", &g_define_type_info, 0);
	g_type_add_interface_static (clock_effect_type_id, SPIT_TRANSITIONS_TYPE_EFFECT, &spit_transitions_effect_info);
	return clock_effect_type_id;
}

GType
clock_effect_get_type (void)
{
	static volatile gsize clock_effect_type_id__once = 0;
	if (g_once_init_enter (&clock_effect_type_id__once)) {
		GType clock_effect_type_id;
		clock_effect_type_id = clock_effect_get_type_once ();
		g_once_init_leave (&clock_effect_type_id__once, clock_effect_type_id);
	}
	return clock_effect_type_id__once;
}

