/* FadeEffect.c generated by valac 0.56.18, the Vala compiler
 * generated from FadeEffect.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2010 Maxim Kartashev
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "pantheon-photos-transitions.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>

#define FADE_EFFECT_DESIRED_FPS 30
#define FADE_EFFECT_MIN_FPS 20
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_FADE_EFFECT_DESCRIPTOR (fade_effect_descriptor_get_type ())
#define FADE_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FADE_EFFECT_DESCRIPTOR, FadeEffectDescriptor))
#define FADE_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FADE_EFFECT_DESCRIPTOR, FadeEffectDescriptorClass))
#define IS_FADE_EFFECT_DESCRIPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FADE_EFFECT_DESCRIPTOR))
#define IS_FADE_EFFECT_DESCRIPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FADE_EFFECT_DESCRIPTOR))
#define FADE_EFFECT_DESCRIPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FADE_EFFECT_DESCRIPTOR, FadeEffectDescriptorClass))

typedef struct _FadeEffectDescriptor FadeEffectDescriptor;
typedef struct _FadeEffectDescriptorClass FadeEffectDescriptorClass;
typedef struct _FadeEffectDescriptorPrivate FadeEffectDescriptorPrivate;
enum  {
	FADE_EFFECT_DESCRIPTOR_0_PROPERTY,
	FADE_EFFECT_DESCRIPTOR_NUM_PROPERTIES
};
static GParamSpec* fade_effect_descriptor_properties[FADE_EFFECT_DESCRIPTOR_NUM_PROPERTIES];

#define TYPE_FADE_EFFECT (fade_effect_get_type ())
#define FADE_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FADE_EFFECT, FadeEffect))
#define FADE_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FADE_EFFECT, FadeEffectClass))
#define IS_FADE_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FADE_EFFECT))
#define IS_FADE_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FADE_EFFECT))
#define FADE_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FADE_EFFECT, FadeEffectClass))

typedef struct _FadeEffect FadeEffect;
typedef struct _FadeEffectClass FadeEffectClass;
typedef struct _FadeEffectPrivate FadeEffectPrivate;
enum  {
	FADE_EFFECT_0_PROPERTY,
	FADE_EFFECT_NUM_PROPERTIES
};
static GParamSpec* fade_effect_properties[FADE_EFFECT_NUM_PROPERTIES];

struct _FadeEffectDescriptor {
	ShotwellTransitionDescriptor parent_instance;
	FadeEffectDescriptorPrivate * priv;
};

struct _FadeEffectDescriptorClass {
	ShotwellTransitionDescriptorClass parent_class;
};

struct _FadeEffect {
	GObject parent_instance;
	FadeEffectPrivate * priv;
};

struct _FadeEffectClass {
	GObjectClass parent_class;
};

static gpointer fade_effect_descriptor_parent_class = NULL;
static gpointer fade_effect_parent_class = NULL;
static SpitTransitionsEffectIface * fade_effect_spit_transitions_effect_parent_iface = NULL;

VALA_EXTERN GType fade_effect_descriptor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FadeEffectDescriptor* fade_effect_descriptor_new (GFile* resource_directory);
VALA_EXTERN FadeEffectDescriptor* fade_effect_descriptor_construct (GType object_type,
                                                        GFile* resource_directory);
static const gchar* fade_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base);
static const gchar* fade_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base);
static SpitTransitionsEffect* fade_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                                           SpitHostInterface* host);
VALA_EXTERN FadeEffect* fade_effect_new (void);
VALA_EXTERN FadeEffect* fade_effect_construct (GType object_type);
VALA_EXTERN GType fade_effect_get_type (void) G_GNUC_CONST ;
static GType fade_effect_descriptor_get_type_once (void);
static void fade_effect_real_get_fps (SpitTransitionsEffect* base,
                               gint* desired_fps,
                               gint* min_fps);
static void fade_effect_real_start (SpitTransitionsEffect* base,
                             SpitTransitionsVisuals* visuals,
                             SpitTransitionsMotion* motion);
static gboolean fade_effect_real_needs_clear_background (SpitTransitionsEffect* base);
static void fade_effect_real_paint (SpitTransitionsEffect* base,
                             SpitTransitionsVisuals* visuals,
                             SpitTransitionsMotion* motion,
                             cairo_t* ctx,
                             gint width,
                             gint height,
                             gint frame_number);
static void fade_effect_real_advance (SpitTransitionsEffect* base,
                               SpitTransitionsVisuals* visuals,
                               SpitTransitionsMotion* motion,
                               gint frame_number);
static void fade_effect_real_cancel (SpitTransitionsEffect* base);
static GType fade_effect_get_type_once (void);

FadeEffectDescriptor*
fade_effect_descriptor_construct (GType object_type,
                                  GFile* resource_directory)
{
	FadeEffectDescriptor * self = NULL;
#line 24 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_val_if_fail (resource_directory != NULL, NULL);
#line 25 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffectDescriptor*) shotwell_transition_descriptor_construct (object_type, resource_directory);
#line 24 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	return self;
#line 148 "FadeEffect.c"
}

FadeEffectDescriptor*
fade_effect_descriptor_new (GFile* resource_directory)
{
#line 24 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	return fade_effect_descriptor_construct (TYPE_FADE_EFFECT_DESCRIPTOR, resource_directory);
#line 156 "FadeEffect.c"
}

static const gchar*
fade_effect_descriptor_real_get_id (ShotwellTransitionDescriptor* base)
{
	FadeEffectDescriptor * self;
	const gchar* result;
#line 28 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffectDescriptor*) base;
#line 29 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	result = "io.elementary.photos.transitions.fade";
#line 29 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	return result;
#line 170 "FadeEffect.c"
}

static const gchar*
fade_effect_descriptor_real_get_pluggable_name (ShotwellTransitionDescriptor* base)
{
	FadeEffectDescriptor * self;
	const gchar* result;
#line 32 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffectDescriptor*) base;
#line 33 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	result = _ ("Fade");
#line 33 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	return result;
#line 184 "FadeEffect.c"
}

static SpitTransitionsEffect*
fade_effect_descriptor_real_create (ShotwellTransitionDescriptor* base,
                                    SpitHostInterface* host)
{
	FadeEffectDescriptor * self;
	FadeEffect* _tmp0_;
	SpitTransitionsEffect* result;
#line 36 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffectDescriptor*) base;
#line 36 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 37 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	_tmp0_ = fade_effect_new ();
#line 37 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	result = (SpitTransitionsEffect*) _tmp0_;
#line 37 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	return result;
#line 204 "FadeEffect.c"
}

static void
fade_effect_descriptor_class_init (FadeEffectDescriptorClass * klass,
                                   gpointer klass_data)
{
#line 23 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	fade_effect_descriptor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_id = (const gchar* (*) (ShotwellTransitionDescriptor*)) fade_effect_descriptor_real_get_id;
#line 23 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->get_pluggable_name = (const gchar* (*) (ShotwellTransitionDescriptor*)) fade_effect_descriptor_real_get_pluggable_name;
#line 23 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	((ShotwellTransitionDescriptorClass *) klass)->create = (SpitTransitionsEffect* (*) (ShotwellTransitionDescriptor*, SpitHostInterface*)) fade_effect_descriptor_real_create;
#line 219 "FadeEffect.c"
}

static void
fade_effect_descriptor_instance_init (FadeEffectDescriptor * self,
                                      gpointer klass)
{
}

static GType
fade_effect_descriptor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FadeEffectDescriptorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fade_effect_descriptor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FadeEffectDescriptor), 0, (GInstanceInitFunc) fade_effect_descriptor_instance_init, NULL };
	GType fade_effect_descriptor_type_id;
	fade_effect_descriptor_type_id = g_type_register_static (TYPE_SHOTWELL_TRANSITION_DESCRIPTOR, "FadeEffectDescriptor", &g_define_type_info, 0);
	return fade_effect_descriptor_type_id;
}

GType
fade_effect_descriptor_get_type (void)
{
	static volatile gsize fade_effect_descriptor_type_id__once = 0;
	if (g_once_init_enter (&fade_effect_descriptor_type_id__once)) {
		GType fade_effect_descriptor_type_id;
		fade_effect_descriptor_type_id = fade_effect_descriptor_get_type_once ();
		g_once_init_leave (&fade_effect_descriptor_type_id__once, fade_effect_descriptor_type_id);
	}
	return fade_effect_descriptor_type_id__once;
}

FadeEffect*
fade_effect_construct (GType object_type)
{
	FadeEffect * self = NULL;
#line 45 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffect*) g_object_new (object_type, NULL);
#line 45 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	return self;
#line 257 "FadeEffect.c"
}

FadeEffect*
fade_effect_new (void)
{
#line 45 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	return fade_effect_construct (TYPE_FADE_EFFECT);
#line 265 "FadeEffect.c"
}

static void
fade_effect_real_get_fps (SpitTransitionsEffect* base,
                          gint* desired_fps,
                          gint* min_fps)
{
	FadeEffect * self;
	gint _vala_desired_fps = 0;
	gint _vala_min_fps = 0;
#line 48 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffect*) base;
#line 49 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	_vala_desired_fps = FADE_EFFECT_DESIRED_FPS;
#line 50 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	_vala_min_fps = FADE_EFFECT_MIN_FPS;
#line 48 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	if (desired_fps) {
#line 48 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		*desired_fps = _vala_desired_fps;
#line 286 "FadeEffect.c"
	}
#line 48 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	if (min_fps) {
#line 48 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		*min_fps = _vala_min_fps;
#line 292 "FadeEffect.c"
	}
}

static void
fade_effect_real_start (SpitTransitionsEffect* base,
                        SpitTransitionsVisuals* visuals,
                        SpitTransitionsMotion* motion)
{
	FadeEffect * self;
#line 53 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffect*) base;
#line 53 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 53 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_if_fail (motion != NULL);
#line 308 "FadeEffect.c"
}

static gboolean
fade_effect_real_needs_clear_background (SpitTransitionsEffect* base)
{
	FadeEffect * self;
	gboolean result;
#line 56 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffect*) base;
#line 57 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	result = TRUE;
#line 57 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	return result;
#line 322 "FadeEffect.c"
}

static void
fade_effect_real_paint (SpitTransitionsEffect* base,
                        SpitTransitionsVisuals* visuals,
                        SpitTransitionsMotion* motion,
                        cairo_t* ctx,
                        gint width,
                        gint height,
                        gint frame_number)
{
	FadeEffect * self;
	gdouble alpha = 0.0;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
#line 60 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffect*) base;
#line 60 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 60 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_if_fail (motion != NULL);
#line 60 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_if_fail (ctx != NULL);
#line 62 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	alpha = spit_transitions_motion_get_alpha (motion, frame_number);
#line 66 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	_tmp0_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 66 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	_tmp1_ = _tmp0_;
#line 66 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	if (_tmp1_ != NULL) {
#line 356 "FadeEffect.c"
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkRectangle _tmp4_ = {0};
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_ = {0};
		GdkRectangle _tmp7_;
#line 67 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		_tmp2_ = spit_transitions_visuals_get_from_pixbuf (visuals);
#line 67 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		_tmp3_ = _tmp2_;
#line 67 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp4_);
#line 67 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		_tmp5_ = _tmp4_;
#line 67 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		spit_transitions_visuals_get_from_pos (visuals, &_tmp6_);
#line 67 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		_tmp7_ = _tmp6_;
#line 67 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp3_, (gdouble) _tmp5_.x, (gdouble) _tmp7_.y);
#line 68 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		cairo_paint_with_alpha (ctx, 1.0 - alpha);
#line 379 "FadeEffect.c"
	}
#line 71 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	_tmp8_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 71 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	_tmp9_ = _tmp8_;
#line 71 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	if (_tmp9_ != NULL) {
#line 387 "FadeEffect.c"
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkRectangle _tmp12_ = {0};
		GdkRectangle _tmp13_;
		GdkRectangle _tmp14_ = {0};
		GdkRectangle _tmp15_;
#line 72 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		_tmp10_ = spit_transitions_visuals_get_to_pixbuf (visuals);
#line 72 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		_tmp11_ = _tmp10_;
#line 72 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp12_);
#line 72 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		_tmp13_ = _tmp12_;
#line 72 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		spit_transitions_visuals_get_to_pos (visuals, &_tmp14_);
#line 72 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		_tmp15_ = _tmp14_;
#line 72 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp11_, (gdouble) _tmp13_.x, (gdouble) _tmp15_.y);
#line 73 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
		cairo_paint_with_alpha (ctx, alpha);
#line 410 "FadeEffect.c"
	}
}

static void
fade_effect_real_advance (SpitTransitionsEffect* base,
                          SpitTransitionsVisuals* visuals,
                          SpitTransitionsMotion* motion,
                          gint frame_number)
{
	FadeEffect * self;
#line 77 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffect*) base;
#line 77 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_if_fail (visuals != NULL);
#line 77 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	g_return_if_fail (motion != NULL);
#line 427 "FadeEffect.c"
}

static void
fade_effect_real_cancel (SpitTransitionsEffect* base)
{
	FadeEffect * self;
#line 80 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	self = (FadeEffect*) base;
#line 436 "FadeEffect.c"
}

static void
fade_effect_class_init (FadeEffectClass * klass,
                        gpointer klass_data)
{
#line 41 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	fade_effect_parent_class = g_type_class_peek_parent (klass);
#line 445 "FadeEffect.c"
}

static void
fade_effect_spit_transitions_effect_interface_init (SpitTransitionsEffectIface * iface,
                                                    gpointer iface_data)
{
#line 41 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	fade_effect_spit_transitions_effect_parent_iface = g_type_interface_peek_parent (iface);
#line 41 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	iface->get_fps = (void (*) (SpitTransitionsEffect*, gint*, gint*)) fade_effect_real_get_fps;
#line 41 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	iface->start = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*)) fade_effect_real_start;
#line 41 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	iface->needs_clear_background = (gboolean (*) (SpitTransitionsEffect*)) fade_effect_real_needs_clear_background;
#line 41 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	iface->paint = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, cairo_t*, gint, gint, gint)) fade_effect_real_paint;
#line 41 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	iface->advance = (void (*) (SpitTransitionsEffect*, SpitTransitionsVisuals*, SpitTransitionsMotion*, gint)) fade_effect_real_advance;
#line 41 "../plugins/pantheon-photos-transitions/FadeEffect.vala"
	iface->cancel = (void (*) (SpitTransitionsEffect*)) fade_effect_real_cancel;
#line 466 "FadeEffect.c"
}

static void
fade_effect_instance_init (FadeEffect * self,
                           gpointer klass)
{
}

static GType
fade_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FadeEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fade_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FadeEffect), 0, (GInstanceInitFunc) fade_effect_instance_init, NULL };
	static const GInterfaceInfo spit_transitions_effect_info = { (GInterfaceInitFunc) fade_effect_spit_transitions_effect_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType fade_effect_type_id;
	fade_effect_type_id = g_type_register_static (G_TYPE_OBJECT, "FadeEffect", &g_define_type_info, 0);
	g_type_add_interface_static (fade_effect_type_id, SPIT_TRANSITIONS_TYPE_EFFECT, &spit_transitions_effect_info);
	return fade_effect_type_id;
}

GType
fade_effect_get_type (void)
{
	static volatile gsize fade_effect_type_id__once = 0;
	if (g_once_init_enter (&fade_effect_type_id__once)) {
		GType fade_effect_type_id;
		fade_effect_type_id = fade_effect_get_type_once ();
		g_once_init_leave (&fade_effect_type_id__once, fade_effect_type_id);
	}
	return fade_effect_type_id__once;
}

