/* AppWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from AppWindow.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io)
*               2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* AppWindow is the parent window for most windows in Photos (FullscreenWindow is the exception).*/
/* There are multiple types of AppWindows (LibraryWindow, DirectWindow) for different tasks, but only*/
/* one AppWindow may exist per process.  Thus, if the user closes an AppWindow, the program exits.*/
/**/
/* AppWindow also offers support for going into fullscreen mode.  It handles the interface*/
/* notifications Page is expecting when switching back and forth.*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <libportal/portal.h>
#include <libportal-gtk3/portal-gtk3.h>
#include <gee.h>
#include <handy.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	APP_WINDOW_0_PROPERTY,
	APP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* app_window_properties[APP_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_XdpParent_free0(var) ((var == NULL) ? NULL : (var = (_vala_XdpParent_free (var), NULL)))
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _AppWindowPrivate {
	gint pos_x;
	gint pos_y;
};

static gint AppWindow_private_offset;
static gpointer app_window_parent_class = NULL;
AppWindow* app_window_instance = NULL;
static FullscreenWindow* app_window_fullscreen_window;
static FullscreenWindow* app_window_fullscreen_window = NULL;
static CommandManager* app_window_command_manager;
static CommandManager* app_window_command_manager = NULL;

static void _app_window_on_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self);
static void app_window_on_jump_to_file (AppWindow* self);
static void _app_window_on_jump_to_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static void _app_window_on_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void app_window_on_redo (AppWindow* self);
static void _app_window_on_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void app_window_on_select_all (AppWindow* self);
static void _app_window_on_select_all_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self);
static void app_window_on_select_none (AppWindow* self);
static void _app_window_on_select_none_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void app_window_on_undo (AppWindow* self);
static void _app_window_on_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void app_window_action_set_wallpaper (AppWindow* self,
                                      GSimpleAction* action,
                                      GVariant* param);
static void _app_window_action_set_wallpaper_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void app_window_real_on_fullscreen (AppWindow* self);
static gchar* app_window_real_get_app_role (AppWindow* self);
static void app_window_real_on_quit (AppWindow* self);
static void app_window_show_file_uri (AppWindow* self,
                               GFile* file,
                               GError** error);
static void app_window_real_destroy (GtkWidget* base);
static void _vala_XdpParent_free (XdpParent* self);
static GtkActionGroup** app_window_real_create_common_action_groups (AppWindow* self,
                                                              gint* result_length1);
static GtkActionGroup** _vala_array_dup1 (GtkActionGroup** self,
                                   gssize length);
static void app_window_real_switched_pages (PageWindow* base,
                                     Page* old_page,
                                     Page* new_page);
static void app_window_on_update_common_actions (AppWindow* self);
static void _app_window_on_update_common_actions_data_collection_contents_altered (DataCollection* _sender,
                                                                            GeeIterable* added,
                                                                            GeeIterable* removed,
                                                                            gpointer self);
static void _app_window_on_update_common_actions_view_collection_selection_group_altered (ViewCollection* _sender,
                                                                                   gpointer self);
static void _app_window_on_update_common_actions_view_collection_items_state_changed (ViewCollection* _sender,
                                                                               GeeIterable* changed,
                                                                               gpointer self);
static void app_window_real_update_common_action_availability (AppWindow* self,
                                                        Page* old_page,
                                                        Page* new_page);
static void app_window_real_update_common_actions (AppWindow* self,
                                            Page* page,
                                            gint selected_count,
                                            gint count);
static void app_window_on_command_manager_altered (AppWindow* self);
static void app_window_decorate_command_manager_action (AppWindow* self,
                                                 const gchar* name,
                                                 GtkButton* button,
                                                 const gchar* default_explanation,
                                                 Command* command);
static gboolean app_window_real_configure_event (GtkWidget* base,
                                          GdkEventConfigure* event);
static GObject * app_window_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void _app_window_on_command_manager_altered_command_manager_altered (CommandManager* _sender,
                                                                     gboolean can_undo,
                                                                     gboolean can_redo,
                                                                     gpointer self);
static void app_window_finalize (GObject * obj);
static GType app_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry APP_WINDOW_ACTION_ENTRIES[8] = {{APP_WINDOW_ACTION_FULLSCREEN, _app_window_on_fullscreen_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_JUMP_TO_FILE, _app_window_on_jump_to_file_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_QUIT, _app_window_on_quit_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_REDO, _app_window_on_redo_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_SELECT_ALL, _app_window_on_select_all_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_SELECT_NONE, _app_window_on_select_none_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_UNDO, _app_window_on_undo_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_SET_WALLPAPER, _app_window_action_set_wallpaper_gsimple_action_activate_callback, "s"}};

static inline gpointer
app_window_get_instance_private (AppWindow* self)
{
	return G_STRUCT_MEMBER_P (self, AppWindow_private_offset);
}

static void
_app_window_on_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self)
{
#line 56 "../src/AppWindow.vala"
	app_window_on_fullscreen ((AppWindow*) self);
#line 187 "AppWindow.c"
}

static void
_app_window_on_jump_to_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 56 "../src/AppWindow.vala"
	app_window_on_jump_to_file ((AppWindow*) self);
#line 197 "AppWindow.c"
}

static void
_app_window_on_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 56 "../src/AppWindow.vala"
	app_window_on_quit ((AppWindow*) self);
#line 207 "AppWindow.c"
}

static void
_app_window_on_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 56 "../src/AppWindow.vala"
	app_window_on_redo ((AppWindow*) self);
#line 217 "AppWindow.c"
}

static void
_app_window_on_select_all_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self)
{
#line 56 "../src/AppWindow.vala"
	app_window_on_select_all ((AppWindow*) self);
#line 227 "AppWindow.c"
}

static void
_app_window_on_select_none_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 56 "../src/AppWindow.vala"
	app_window_on_select_none ((AppWindow*) self);
#line 237 "AppWindow.c"
}

static void
_app_window_on_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 56 "../src/AppWindow.vala"
	app_window_on_undo ((AppWindow*) self);
#line 247 "AppWindow.c"
}

static void
_app_window_action_set_wallpaper_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 56 "../src/AppWindow.vala"
	app_window_action_set_wallpaper ((AppWindow*) self, action, parameter);
#line 257 "AppWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 70 "../src/AppWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 265 "AppWindow.c"
}

AppWindow*
app_window_construct (GType object_type)
{
	AppWindow * self = NULL;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
#line 67 "../src/AppWindow.vala"
	self = (AppWindow*) page_window_construct (object_type);
#line 69 "../src/AppWindow.vala"
	_tmp0_ = app_window_instance;
#line 69 "../src/AppWindow.vala"
	_vala_assert (_tmp0_ == NULL, "instance == null");
#line 70 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (self);
#line 70 "../src/AppWindow.vala"
	_g_object_unref0 (app_window_instance);
#line 70 "../src/AppWindow.vala"
	app_window_instance = _tmp1_;
#line 67 "../src/AppWindow.vala"
	return self;
#line 288 "AppWindow.c"
}

static void
app_window_real_on_fullscreen (AppWindow* self)
{
#line 126 "../src/AppWindow.vala"
	g_critical ("Type `%s' does not implement abstract method `app_window_on_fullscreen'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 126 "../src/AppWindow.vala"
	return;
#line 298 "AppWindow.c"
}

void
app_window_on_fullscreen (AppWindow* self)
{
	AppWindowClass* _klass_;
#line 126 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/AppWindow.vala"
	_klass_ = APP_WINDOW_GET_CLASS (self);
#line 126 "../src/AppWindow.vala"
	if (_klass_->on_fullscreen) {
#line 126 "../src/AppWindow.vala"
		_klass_->on_fullscreen (self);
#line 313 "AppWindow.c"
	}
}

AppWindow*
app_window_get_instance (void)
{
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	AppWindow* result;
#line 129 "../src/AppWindow.vala"
	_tmp0_ = app_window_instance;
#line 129 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 129 "../src/AppWindow.vala"
	result = _tmp1_;
#line 129 "../src/AppWindow.vala"
	return result;
#line 331 "AppWindow.c"
}

FullscreenWindow*
app_window_get_fullscreen (void)
{
	FullscreenWindow* _tmp0_;
	FullscreenWindow* _tmp1_;
	FullscreenWindow* result;
#line 133 "../src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 133 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 133 "../src/AppWindow.vala"
	result = _tmp1_;
#line 133 "../src/AppWindow.vala"
	return result;
#line 348 "AppWindow.c"
}

void
app_window_error_message (const gchar* title,
                          const gchar* message,
                          GtkWindow* parent)
{
	GraniteMessageDialog* dialog = NULL;
	GraniteMessageDialog* _tmp0_;
	GtkWindow* _tmp1_ = NULL;
	GtkWindow* _tmp2_;
	GraniteMessageDialog* _tmp4_;
	GraniteMessageDialog* _tmp5_;
	GraniteMessageDialog* _tmp6_;
#line 136 "../src/AppWindow.vala"
	g_return_if_fail (title != NULL);
#line 137 "../src/AppWindow.vala"
	_tmp0_ = granite_message_dialog_new_with_image_from_icon_name (title, message, "dialog-error", GTK_BUTTONS_CLOSE);
#line 137 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 137 "../src/AppWindow.vala"
	dialog = _tmp0_;
#line 143 "../src/AppWindow.vala"
	_tmp2_ = _g_object_ref0 (parent);
#line 143 "../src/AppWindow.vala"
	_tmp1_ = _tmp2_;
#line 143 "../src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 377 "AppWindow.c"
		AppWindow* _tmp3_;
#line 143 "../src/AppWindow.vala"
		_tmp3_ = app_window_get_instance ();
#line 143 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp1_);
#line 143 "../src/AppWindow.vala"
		_tmp1_ = (GtkWindow*) _tmp3_;
#line 385 "AppWindow.c"
	}
#line 143 "../src/AppWindow.vala"
	_tmp4_ = dialog;
#line 143 "../src/AppWindow.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp4_, _tmp1_);
#line 144 "../src/AppWindow.vala"
	_tmp5_ = dialog;
#line 144 "../src/AppWindow.vala"
	gtk_dialog_run ((GtkDialog*) _tmp5_);
#line 145 "../src/AppWindow.vala"
	_tmp6_ = dialog;
#line 145 "../src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp6_);
#line 136 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 136 "../src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 403 "AppWindow.c"
}

GtkResponseType
app_window_cancel_affirm_question (const gchar* message,
                                   const gchar* affirmative,
                                   const gchar* title)
{
	const gchar* _tmp0_ = NULL;
	GraniteMessageDialog* dialog = NULL;
	GraniteMessageDialog* _tmp1_;
	AppWindow* _tmp2_;
	AppWindow* _tmp3_;
	gint response = 0;
	GtkResponseType result;
#line 148 "../src/AppWindow.vala"
	g_return_val_if_fail (message != NULL, 0);
#line 148 "../src/AppWindow.vala"
	g_return_val_if_fail (affirmative != NULL, 0);
#line 150 "../src/AppWindow.vala"
	_tmp0_ = title;
#line 150 "../src/AppWindow.vala"
	if (_tmp0_ == NULL) {
#line 150 "../src/AppWindow.vala"
		_tmp0_ = _ (RESOURCES_APP_TITLE);
#line 428 "AppWindow.c"
	}
#line 149 "../src/AppWindow.vala"
	_tmp1_ = granite_message_dialog_new_with_image_from_icon_name (_tmp0_, message, "dialog-question", GTK_BUTTONS_CANCEL);
#line 149 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 149 "../src/AppWindow.vala"
	dialog = _tmp1_;
#line 155 "../src/AppWindow.vala"
	_tmp2_ = app_window_get_instance ();
#line 155 "../src/AppWindow.vala"
	_tmp3_ = _tmp2_;
#line 155 "../src/AppWindow.vala"
	gtk_window_set_transient_for ((GtkWindow*) dialog, (GtkWindow*) _tmp3_);
#line 155 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 156 "../src/AppWindow.vala"
	gtk_dialog_add_button ((GtkDialog*) dialog, affirmative, (gint) GTK_RESPONSE_YES);
#line 157 "../src/AppWindow.vala"
	response = gtk_dialog_run ((GtkDialog*) dialog);
#line 158 "../src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 160 "../src/AppWindow.vala"
	result = (GtkResponseType) response;
#line 160 "../src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 160 "../src/AppWindow.vala"
	return result;
#line 456 "AppWindow.c"
}

void
app_window_database_error (GError* err)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 164 "../src/AppWindow.vala"
	_tmp0_ = err->message;
#line 164 "../src/AppWindow.vala"
	_tmp1_ = g_strdup_printf (_ ("A fatal error occurred when accessing Photos' library. Photos cannot c" \
"ontinue.\n" \
"\n" \
"%s"), _tmp0_);
#line 164 "../src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 164 "../src/AppWindow.vala"
	app_window_panic (_tmp2_);
#line 164 "../src/AppWindow.vala"
	_g_free0 (_tmp2_);
#line 475 "AppWindow.c"
}

void
app_window_panic (const gchar* msg)
{
	GApplication* _tmp0_;
#line 168 "../src/AppWindow.vala"
	g_return_if_fail (msg != NULL);
#line 169 "../src/AppWindow.vala"
	g_critical ("AppWindow.vala:169: %s", msg);
#line 170 "../src/AppWindow.vala"
	app_window_error_message (msg, NULL, NULL);
#line 172 "../src/AppWindow.vala"
	_tmp0_ = g_application_get_default ();
#line 172 "../src/AppWindow.vala"
	photos_application_panic (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTOS_TYPE_APPLICATION, PhotosApplication));
#line 492 "AppWindow.c"
}

static gchar*
app_window_real_get_app_role (AppWindow* self)
{
#line 175 "../src/AppWindow.vala"
	g_critical ("Type `%s' does not implement abstract method `app_window_get_app_role'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 175 "../src/AppWindow.vala"
	return NULL;
#line 502 "AppWindow.c"
}

gchar*
app_window_get_app_role (AppWindow* self)
{
	AppWindowClass* _klass_;
#line 175 "../src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 175 "../src/AppWindow.vala"
	_klass_ = APP_WINDOW_GET_CLASS (self);
#line 175 "../src/AppWindow.vala"
	if (_klass_->get_app_role) {
#line 175 "../src/AppWindow.vala"
		return _klass_->get_app_role (self);
#line 517 "AppWindow.c"
	}
#line 175 "../src/AppWindow.vala"
	return NULL;
#line 521 "AppWindow.c"
}

static void
app_window_real_on_quit (AppWindow* self)
{
	GApplication* _tmp0_;
#line 178 "../src/AppWindow.vala"
	_tmp0_ = g_application_get_default ();
#line 178 "../src/AppWindow.vala"
	photos_application_exit (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTOS_TYPE_APPLICATION, PhotosApplication));
#line 532 "AppWindow.c"
}

void
app_window_on_quit (AppWindow* self)
{
	AppWindowClass* _klass_;
#line 177 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/AppWindow.vala"
	_klass_ = APP_WINDOW_GET_CLASS (self);
#line 177 "../src/AppWindow.vala"
	if (_klass_->on_quit) {
#line 177 "../src/AppWindow.vala"
		_klass_->on_quit (self);
#line 547 "AppWindow.c"
	}
}

static void
app_window_on_jump_to_file (AppWindow* self)
{
	Page* _tmp0_;
	Page* _tmp1_;
	ViewCollection* _tmp2_;
	ViewCollection* _tmp3_;
	gboolean _tmp4_;
	MediaSource* media = NULL;
	Page* _tmp5_;
	Page* _tmp6_;
	ViewCollection* _tmp7_;
	ViewCollection* _tmp8_;
	DataView* _tmp9_;
	DataView* _tmp10_;
	DataSource* _tmp11_;
	DataSource* _tmp12_;
	MediaSource* _tmp13_;
	MediaSource* _tmp14_;
	MediaSource* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 181 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 182 "../src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/AppWindow.vala"
	_tmp2_ = page_get_view (_tmp1_);
#line 182 "../src/AppWindow.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/AppWindow.vala"
	_tmp4_ = view_collection_get_selected_count (_tmp3_) != 1;
#line 182 "../src/AppWindow.vala"
	_data_collection_unref0 (_tmp3_);
#line 182 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 182 "../src/AppWindow.vala"
	if (_tmp4_) {
#line 183 "../src/AppWindow.vala"
		return;
#line 592 "AppWindow.c"
	}
#line 185 "../src/AppWindow.vala"
	_tmp5_ = page_window_get_current_page ((PageWindow*) self);
#line 185 "../src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 185 "../src/AppWindow.vala"
	_tmp7_ = page_get_view (_tmp6_);
#line 185 "../src/AppWindow.vala"
	_tmp8_ = _tmp7_;
#line 185 "../src/AppWindow.vala"
	_tmp9_ = view_collection_get_selected_at (_tmp8_, 0);
#line 185 "../src/AppWindow.vala"
	_tmp10_ = _tmp9_;
#line 185 "../src/AppWindow.vala"
	_tmp11_ = data_view_get_source (_tmp10_);
#line 185 "../src/AppWindow.vala"
	_tmp12_ = _tmp11_;
#line 185 "../src/AppWindow.vala"
	_tmp13_ = _g_object_ref0 (IS_MEDIA_SOURCE (_tmp12_) ? ((MediaSource*) _tmp12_) : NULL);
#line 185 "../src/AppWindow.vala"
	_tmp14_ = _tmp13_;
#line 185 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp10_);
#line 185 "../src/AppWindow.vala"
	_data_collection_unref0 (_tmp8_);
#line 185 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 185 "../src/AppWindow.vala"
	media = _tmp14_;
#line 186 "../src/AppWindow.vala"
	_tmp15_ = media;
#line 186 "../src/AppWindow.vala"
	if (_tmp15_ == NULL) {
#line 187 "../src/AppWindow.vala"
		_g_object_unref0 (media);
#line 187 "../src/AppWindow.vala"
		return;
#line 630 "AppWindow.c"
	}
	{
		AppWindow* _tmp16_;
		AppWindow* _tmp17_;
		MediaSource* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
#line 190 "../src/AppWindow.vala"
		_tmp16_ = app_window_get_instance ();
#line 190 "../src/AppWindow.vala"
		_tmp17_ = _tmp16_;
#line 190 "../src/AppWindow.vala"
		_tmp18_ = media;
#line 190 "../src/AppWindow.vala"
		_tmp19_ = media_source_get_master_file (_tmp18_);
#line 190 "../src/AppWindow.vala"
		_tmp20_ = _tmp19_;
#line 190 "../src/AppWindow.vala"
		app_window_show_file_uri (_tmp17_, _tmp20_, &_inner_error0_);
#line 190 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp20_);
#line 190 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp17_);
#line 190 "../src/AppWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 656 "AppWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 189 "../src/AppWindow.vala"
		err = _inner_error0_;
#line 189 "../src/AppWindow.vala"
		_inner_error0_ = NULL;
#line 192 "../src/AppWindow.vala"
		_tmp21_ = err;
#line 192 "../src/AppWindow.vala"
		_tmp22_ = resources_jump_to_file_failed (_tmp21_);
#line 192 "../src/AppWindow.vala"
		_tmp23_ = _tmp22_;
#line 192 "../src/AppWindow.vala"
		app_window_error_message (_tmp23_, NULL, NULL);
#line 192 "../src/AppWindow.vala"
		_g_free0 (_tmp23_);
#line 189 "../src/AppWindow.vala"
		_g_error_free0 (err);
#line 683 "AppWindow.c"
	}
	__finally0:
#line 189 "../src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 189 "../src/AppWindow.vala"
		_g_object_unref0 (media);
#line 189 "../src/AppWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 189 "../src/AppWindow.vala"
		g_clear_error (&_inner_error0_);
#line 189 "../src/AppWindow.vala"
		return;
#line 696 "AppWindow.c"
	}
#line 181 "../src/AppWindow.vala"
	_g_object_unref0 (media);
#line 700 "AppWindow.c"
}

static void
app_window_real_destroy (GtkWidget* base)
{
	AppWindow * self;
#line 196 "../src/AppWindow.vala"
	self = (AppWindow*) base;
#line 197 "../src/AppWindow.vala"
	app_window_on_quit (self);
#line 711 "AppWindow.c"
}

static void
_vala_XdpParent_free (XdpParent* self)
{
#line 200 "../src/AppWindow.vala"
	g_boxed_free (xdp_parent_get_type (), self);
#line 719 "AppWindow.c"
}

static void
app_window_show_file_uri (AppWindow* self,
                          GFile* file,
                          GError** error)
{
	XdpParent* parent = NULL;
	XdpParent* _tmp0_;
	XdpPortal* portal = NULL;
	XdpPortal* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 200 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/AppWindow.vala"
	g_return_if_fail (file != NULL);
#line 201 "../src/AppWindow.vala"
	_tmp0_ = xdp_parent_new_gtk ((GtkWindow*) self);
#line 201 "../src/AppWindow.vala"
	parent = _tmp0_;
#line 203 "../src/AppWindow.vala"
	_tmp1_ = xdp_portal_new ();
#line 203 "../src/AppWindow.vala"
	portal = _tmp1_;
#line 204 "../src/AppWindow.vala"
	_tmp2_ = g_file_get_uri (file);
#line 204 "../src/AppWindow.vala"
	_tmp3_ = _tmp2_;
#line 204 "../src/AppWindow.vala"
	xdp_portal_open_directory (portal, parent, _tmp3_, XDP_OPEN_URI_FLAG_NONE, NULL, NULL, NULL);
#line 204 "../src/AppWindow.vala"
	_g_free0 (_tmp3_);
#line 200 "../src/AppWindow.vala"
	_g_object_unref0 (portal);
#line 200 "../src/AppWindow.vala"
	__vala_XdpParent_free0 (parent);
#line 757 "AppWindow.c"
}

static GtkActionGroup**
app_window_real_create_common_action_groups (AppWindow* self,
                                             gint* result_length1)
{
	GtkActionGroup** groups = NULL;
	GtkActionGroup** _tmp0_;
	gint groups_length1;
	gint _groups_size_;
	GtkActionGroup** _tmp1_;
	gint _tmp1__length1;
	GtkActionGroup** result;
#line 208 "../src/AppWindow.vala"
	_tmp0_ = g_new0 (GtkActionGroup*, 0 + 1);
#line 208 "../src/AppWindow.vala"
	groups = _tmp0_;
#line 208 "../src/AppWindow.vala"
	groups_length1 = 0;
#line 208 "../src/AppWindow.vala"
	_groups_size_ = groups_length1;
#line 209 "../src/AppWindow.vala"
	_tmp1_ = groups;
#line 209 "../src/AppWindow.vala"
	_tmp1__length1 = groups_length1;
#line 209 "../src/AppWindow.vala"
	if (result_length1) {
#line 209 "../src/AppWindow.vala"
		*result_length1 = _tmp1__length1;
#line 787 "AppWindow.c"
	}
#line 209 "../src/AppWindow.vala"
	result = _tmp1_;
#line 209 "../src/AppWindow.vala"
	return result;
#line 793 "AppWindow.c"
}

GtkActionGroup**
app_window_create_common_action_groups (AppWindow* self,
                                        gint* result_length1)
{
	AppWindowClass* _klass_;
#line 207 "../src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 207 "../src/AppWindow.vala"
	_klass_ = APP_WINDOW_GET_CLASS (self);
#line 207 "../src/AppWindow.vala"
	if (_klass_->create_common_action_groups) {
#line 207 "../src/AppWindow.vala"
		return _klass_->create_common_action_groups (self, result_length1);
#line 809 "AppWindow.c"
	}
#line 207 "../src/AppWindow.vala"
	return NULL;
#line 813 "AppWindow.c"
}

static GtkActionGroup**
_vala_array_dup1 (GtkActionGroup** self,
                  gssize length)
{
#line 213 "../src/AppWindow.vala"
	if (length >= 0) {
#line 822 "AppWindow.c"
		GtkActionGroup** result;
		gssize i;
#line 213 "../src/AppWindow.vala"
		result = g_new0 (GtkActionGroup*, length + 1);
#line 213 "../src/AppWindow.vala"
		for (i = 0; i < length; i++) {
#line 829 "AppWindow.c"
			GtkActionGroup* _tmp0_;
#line 213 "../src/AppWindow.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 213 "../src/AppWindow.vala"
			result[i] = _tmp0_;
#line 835 "AppWindow.c"
		}
#line 213 "../src/AppWindow.vala"
		return result;
#line 839 "AppWindow.c"
	}
#line 213 "../src/AppWindow.vala"
	return NULL;
#line 843 "AppWindow.c"
}

GtkActionGroup**
app_window_get_common_action_groups (AppWindow* self,
                                     gint* result_length1)
{
	GtkActionGroup** _tmp0_;
	gint _tmp0__length1;
	GtkActionGroup** _tmp1_;
	gint _tmp1__length1;
	GtkActionGroup** _tmp2_;
	gint _tmp2__length1;
	GtkActionGroup** result;
#line 212 "../src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 213 "../src/AppWindow.vala"
	_tmp0_ = self->common_action_groups;
#line 213 "../src/AppWindow.vala"
	_tmp0__length1 = self->common_action_groups_length1;
#line 213 "../src/AppWindow.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 213 "../src/AppWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 213 "../src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 213 "../src/AppWindow.vala"
	_tmp2__length1 = _tmp1__length1;
#line 213 "../src/AppWindow.vala"
	if (result_length1) {
#line 213 "../src/AppWindow.vala"
		*result_length1 = _tmp2__length1;
#line 875 "AppWindow.c"
	}
#line 213 "../src/AppWindow.vala"
	result = _tmp2_;
#line 213 "../src/AppWindow.vala"
	return result;
#line 881 "AppWindow.c"
}

void
app_window_go_fullscreen (AppWindow* self,
                          Page* page)
{
	FullscreenWindow* _tmp0_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	FullscreenWindow* fsw = NULL;
	FullscreenWindow* _tmp4_;
	Page* _tmp5_;
	Page* _tmp6_;
	gboolean _tmp7_;
	FullscreenWindow* _tmp11_;
	FullscreenWindow* _tmp12_;
	FullscreenWindow* _tmp13_;
#line 216 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/AppWindow.vala"
	g_return_if_fail (page != NULL);
#line 218 "../src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 218 "../src/AppWindow.vala"
	if (_tmp0_ != NULL) {
#line 907 "AppWindow.c"
		FullscreenWindow* _tmp1_;
#line 219 "../src/AppWindow.vala"
		_tmp1_ = app_window_fullscreen_window;
#line 219 "../src/AppWindow.vala"
		gtk_window_present ((GtkWindow*) _tmp1_);
#line 221 "../src/AppWindow.vala"
		return;
#line 915 "AppWindow.c"
	}
#line 224 "../src/AppWindow.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 224 "../src/AppWindow.vala"
	self->priv->pos_x = _tmp2_;
#line 224 "../src/AppWindow.vala"
	self->priv->pos_y = _tmp3_;
#line 225 "../src/AppWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 227 "../src/AppWindow.vala"
	_tmp4_ = fullscreen_window_new (page);
#line 227 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 227 "../src/AppWindow.vala"
	fsw = _tmp4_;
#line 229 "../src/AppWindow.vala"
	_tmp5_ = page_window_get_current_page ((PageWindow*) self);
#line 229 "../src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 229 "../src/AppWindow.vala"
	_tmp7_ = _tmp6_ != NULL;
#line 229 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 229 "../src/AppWindow.vala"
	if (_tmp7_) {
#line 941 "AppWindow.c"
		Page* _tmp8_;
		Page* _tmp9_;
		FullscreenWindow* _tmp10_;
#line 230 "../src/AppWindow.vala"
		_tmp8_ = page_window_get_current_page ((PageWindow*) self);
#line 230 "../src/AppWindow.vala"
		_tmp9_ = _tmp8_;
#line 230 "../src/AppWindow.vala"
		_tmp10_ = fsw;
#line 230 "../src/AppWindow.vala"
		page_switching_to_fullscreen (_tmp9_, _tmp10_);
#line 230 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp9_);
#line 955 "AppWindow.c"
	}
#line 232 "../src/AppWindow.vala"
	_tmp11_ = fsw;
#line 232 "../src/AppWindow.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 232 "../src/AppWindow.vala"
	_g_object_unref0 (app_window_fullscreen_window);
#line 232 "../src/AppWindow.vala"
	app_window_fullscreen_window = _tmp12_;
#line 233 "../src/AppWindow.vala"
	_tmp13_ = app_window_fullscreen_window;
#line 233 "../src/AppWindow.vala"
	gtk_window_present ((GtkWindow*) _tmp13_);
#line 216 "../src/AppWindow.vala"
	_g_object_unref0 (fsw);
#line 971 "AppWindow.c"
}

void
app_window_end_fullscreen (AppWindow* self)
{
	FullscreenWindow* _tmp0_;
	Page* _tmp1_;
	Page* _tmp2_;
	gboolean _tmp3_;
	FullscreenWindow* _tmp7_;
	FullscreenWindow* _tmp8_;
#line 236 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 237 "../src/AppWindow.vala"
	if (_tmp0_ == NULL) {
#line 238 "../src/AppWindow.vala"
		return;
#line 991 "AppWindow.c"
	}
#line 240 "../src/AppWindow.vala"
	gtk_window_move ((GtkWindow*) self, self->priv->pos_x, self->priv->pos_y);
#line 242 "../src/AppWindow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 244 "../src/AppWindow.vala"
	_tmp1_ = page_window_get_current_page ((PageWindow*) self);
#line 244 "../src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 244 "../src/AppWindow.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 244 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp2_);
#line 244 "../src/AppWindow.vala"
	if (_tmp3_) {
#line 1007 "AppWindow.c"
		Page* _tmp4_;
		Page* _tmp5_;
		FullscreenWindow* _tmp6_;
#line 245 "../src/AppWindow.vala"
		_tmp4_ = page_window_get_current_page ((PageWindow*) self);
#line 245 "../src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 245 "../src/AppWindow.vala"
		_tmp6_ = app_window_fullscreen_window;
#line 245 "../src/AppWindow.vala"
		page_returning_from_fullscreen (_tmp5_, _tmp6_);
#line 245 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp5_);
#line 1021 "AppWindow.c"
	}
#line 247 "../src/AppWindow.vala"
	_tmp7_ = app_window_fullscreen_window;
#line 247 "../src/AppWindow.vala"
	gtk_widget_hide ((GtkWidget*) _tmp7_);
#line 248 "../src/AppWindow.vala"
	_tmp8_ = app_window_fullscreen_window;
#line 248 "../src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp8_);
#line 249 "../src/AppWindow.vala"
	_g_object_unref0 (app_window_fullscreen_window);
#line 249 "../src/AppWindow.vala"
	app_window_fullscreen_window = NULL;
#line 251 "../src/AppWindow.vala"
	gtk_window_present ((GtkWindow*) self);
#line 1037 "AppWindow.c"
}

GtkAction*
app_window_get_common_action (AppWindow* self,
                              const gchar* name)
{
	GtkActionGroup** _tmp0_;
	gint _tmp0__length1;
	GtkAction* result;
#line 254 "../src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 254 "../src/AppWindow.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 255 "../src/AppWindow.vala"
	_tmp0_ = self->common_action_groups;
#line 255 "../src/AppWindow.vala"
	_tmp0__length1 = self->common_action_groups_length1;
#line 1055 "AppWindow.c"
	{
		GtkActionGroup** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
#line 255 "../src/AppWindow.vala"
		group_collection = _tmp0_;
#line 255 "../src/AppWindow.vala"
		group_collection_length1 = _tmp0__length1;
#line 255 "../src/AppWindow.vala"
		for (group_it = 0; group_it < group_collection_length1; group_it = group_it + 1) {
#line 1067 "AppWindow.c"
			GtkActionGroup* _tmp1_;
			GtkActionGroup* group = NULL;
#line 255 "../src/AppWindow.vala"
			_tmp1_ = _g_object_ref0 (group_collection[group_it]);
#line 255 "../src/AppWindow.vala"
			group = _tmp1_;
#line 1074 "AppWindow.c"
			{
				GtkAction* action = NULL;
				GtkActionGroup* _tmp2_;
				GtkAction* _tmp3_;
				GtkAction* _tmp4_;
				GtkAction* _tmp5_;
#line 256 "../src/AppWindow.vala"
				_tmp2_ = group;
#line 256 "../src/AppWindow.vala"
				_tmp3_ = gtk_action_group_get_action (_tmp2_, name);
#line 256 "../src/AppWindow.vala"
				_tmp4_ = _g_object_ref0 (_tmp3_);
#line 256 "../src/AppWindow.vala"
				action = _tmp4_;
#line 257 "../src/AppWindow.vala"
				_tmp5_ = action;
#line 257 "../src/AppWindow.vala"
				if (_tmp5_ != NULL) {
#line 258 "../src/AppWindow.vala"
					result = action;
#line 258 "../src/AppWindow.vala"
					_g_object_unref0 (group);
#line 258 "../src/AppWindow.vala"
					return result;
#line 1099 "AppWindow.c"
				}
#line 255 "../src/AppWindow.vala"
				_g_object_unref0 (action);
#line 255 "../src/AppWindow.vala"
				_g_object_unref0 (group);
#line 1105 "AppWindow.c"
			}
		}
	}
#line 261 "../src/AppWindow.vala"
	g_warning ("AppWindow.vala:261: No common action found: %s", name);
#line 263 "../src/AppWindow.vala"
	result = NULL;
#line 263 "../src/AppWindow.vala"
	return result;
#line 1115 "AppWindow.c"
}

void
app_window_set_common_action_sensitive (AppWindow* self,
                                        const gchar* name,
                                        gboolean sensitive)
{
	GtkAction* action = NULL;
	GtkAction* _tmp0_;
	GtkAction* _tmp1_;
#line 266 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 266 "../src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 267 "../src/AppWindow.vala"
	_tmp0_ = app_window_get_common_action (self, name);
#line 267 "../src/AppWindow.vala"
	action = _tmp0_;
#line 268 "../src/AppWindow.vala"
	_tmp1_ = action;
#line 268 "../src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 1138 "AppWindow.c"
		GtkAction* _tmp2_;
#line 269 "../src/AppWindow.vala"
		_tmp2_ = action;
#line 269 "../src/AppWindow.vala"
		gtk_action_set_sensitive (_tmp2_, sensitive);
#line 1144 "AppWindow.c"
	}
#line 266 "../src/AppWindow.vala"
	_g_object_unref0 (action);
#line 1148 "AppWindow.c"
}

void
app_window_set_common_action_visible (AppWindow* self,
                                      const gchar* name,
                                      gboolean visible)
{
	GtkAction* action = NULL;
	GtkAction* _tmp0_;
	GtkAction* _tmp1_;
#line 272 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 273 "../src/AppWindow.vala"
	_tmp0_ = app_window_get_common_action (self, name);
#line 273 "../src/AppWindow.vala"
	action = _tmp0_;
#line 274 "../src/AppWindow.vala"
	_tmp1_ = action;
#line 274 "../src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 1171 "AppWindow.c"
		GtkAction* _tmp2_;
#line 275 "../src/AppWindow.vala"
		_tmp2_ = action;
#line 275 "../src/AppWindow.vala"
		gtk_action_set_visible (_tmp2_, visible);
#line 1177 "AppWindow.c"
	}
#line 272 "../src/AppWindow.vala"
	_g_object_unref0 (action);
#line 1181 "AppWindow.c"
}

static void
_app_window_on_update_common_actions_data_collection_contents_altered (DataCollection* _sender,
                                                                       GeeIterable* added,
                                                                       GeeIterable* removed,
                                                                       gpointer self)
{
#line 282 "../src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 1192 "AppWindow.c"
}

static void
_app_window_on_update_common_actions_view_collection_selection_group_altered (ViewCollection* _sender,
                                                                              gpointer self)
{
#line 283 "../src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 1201 "AppWindow.c"
}

static void
_app_window_on_update_common_actions_view_collection_items_state_changed (ViewCollection* _sender,
                                                                          GeeIterable* changed,
                                                                          gpointer self)
{
#line 284 "../src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 1211 "AppWindow.c"
}

static void
app_window_real_switched_pages (PageWindow* base,
                                Page* old_page,
                                Page* new_page)
{
	AppWindow * self;
#line 278 "../src/AppWindow.vala"
	self = (AppWindow*) base;
#line 279 "../src/AppWindow.vala"
	app_window_update_common_action_availability (self, old_page, new_page);
#line 281 "../src/AppWindow.vala"
	if (old_page != NULL) {
#line 1226 "AppWindow.c"
		ViewCollection* _tmp0_;
		ViewCollection* _tmp1_;
		guint _tmp2_;
		ViewCollection* _tmp3_;
		ViewCollection* _tmp4_;
		guint _tmp5_;
		ViewCollection* _tmp6_;
		ViewCollection* _tmp7_;
		guint _tmp8_;
#line 282 "../src/AppWindow.vala"
		_tmp0_ = page_get_view (old_page);
#line 282 "../src/AppWindow.vala"
		_tmp1_ = _tmp0_;
#line 282 "../src/AppWindow.vala"
		g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 282 "../src/AppWindow.vala"
		g_signal_handlers_disconnect_matched ((DataCollection*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _app_window_on_update_common_actions_data_collection_contents_altered, self);
#line 282 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp1_);
#line 283 "../src/AppWindow.vala"
		_tmp3_ = page_get_view (old_page);
#line 283 "../src/AppWindow.vala"
		_tmp4_ = _tmp3_;
#line 283 "../src/AppWindow.vala"
		g_signal_parse_name ("selection-group-altered", TYPE_VIEW_COLLECTION, &_tmp5_, NULL, FALSE);
#line 283 "../src/AppWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _app_window_on_update_common_actions_view_collection_selection_group_altered, self);
#line 283 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp4_);
#line 284 "../src/AppWindow.vala"
		_tmp6_ = page_get_view (old_page);
#line 284 "../src/AppWindow.vala"
		_tmp7_ = _tmp6_;
#line 284 "../src/AppWindow.vala"
		g_signal_parse_name ("items-state-changed", TYPE_VIEW_COLLECTION, &_tmp8_, NULL, FALSE);
#line 284 "../src/AppWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _app_window_on_update_common_actions_view_collection_items_state_changed, self);
#line 284 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp7_);
#line 1266 "AppWindow.c"
	}
#line 287 "../src/AppWindow.vala"
	if (new_page != NULL) {
#line 1270 "AppWindow.c"
		ViewCollection* _tmp9_;
		ViewCollection* _tmp10_;
		ViewCollection* _tmp11_;
		ViewCollection* _tmp12_;
		ViewCollection* _tmp13_;
		ViewCollection* _tmp14_;
		ViewCollection* _tmp15_;
		ViewCollection* _tmp16_;
		ViewCollection* _tmp17_;
		ViewCollection* _tmp18_;
#line 288 "../src/AppWindow.vala"
		_tmp9_ = page_get_view (new_page);
#line 288 "../src/AppWindow.vala"
		_tmp10_ = _tmp9_;
#line 288 "../src/AppWindow.vala"
		g_signal_connect_object ((DataCollection*) _tmp10_, "contents-altered", (GCallback) _app_window_on_update_common_actions_data_collection_contents_altered, self, 0);
#line 288 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp10_);
#line 289 "../src/AppWindow.vala"
		_tmp11_ = page_get_view (new_page);
#line 289 "../src/AppWindow.vala"
		_tmp12_ = _tmp11_;
#line 289 "../src/AppWindow.vala"
		g_signal_connect_object (_tmp12_, "selection-group-altered", (GCallback) _app_window_on_update_common_actions_view_collection_selection_group_altered, self, 0);
#line 289 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp12_);
#line 290 "../src/AppWindow.vala"
		_tmp13_ = page_get_view (new_page);
#line 290 "../src/AppWindow.vala"
		_tmp14_ = _tmp13_;
#line 290 "../src/AppWindow.vala"
		g_signal_connect_object (_tmp14_, "items-state-changed", (GCallback) _app_window_on_update_common_actions_view_collection_items_state_changed, self, 0);
#line 290 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp14_);
#line 292 "../src/AppWindow.vala"
		_tmp15_ = page_get_view (new_page);
#line 292 "../src/AppWindow.vala"
		_tmp16_ = _tmp15_;
#line 292 "../src/AppWindow.vala"
		_tmp17_ = page_get_view (new_page);
#line 292 "../src/AppWindow.vala"
		_tmp18_ = _tmp17_;
#line 292 "../src/AppWindow.vala"
		app_window_update_common_actions (self, new_page, view_collection_get_selected_count (_tmp16_), data_collection_get_count ((DataCollection*) _tmp18_));
#line 292 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp18_);
#line 292 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp16_);
#line 1319 "AppWindow.c"
	}
#line 296 "../src/AppWindow.vala"
	PAGE_WINDOW_CLASS (app_window_parent_class)->switched_pages (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), old_page, new_page);
#line 1323 "AppWindow.c"
}

static void
app_window_real_update_common_action_availability (AppWindow* self,
                                                   Page* old_page,
                                                   Page* new_page)
{
	gboolean is_checkerboard = FALSE;
	GAction* _tmp0_;
	GAction* _tmp1_;
#line 303 "../src/AppWindow.vala"
	is_checkerboard = IS_CHECKERBOARD_PAGE (new_page);
#line 305 "../src/AppWindow.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, APP_WINDOW_ACTION_SELECT_ALL);
#line 305 "../src/AppWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), is_checkerboard);
#line 306 "../src/AppWindow.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) self, APP_WINDOW_ACTION_SELECT_NONE);
#line 306 "../src/AppWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction), is_checkerboard);
#line 1344 "AppWindow.c"
}

void
app_window_update_common_action_availability (AppWindow* self,
                                              Page* old_page,
                                              Page* new_page)
{
	AppWindowClass* _klass_;
#line 302 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 302 "../src/AppWindow.vala"
	_klass_ = APP_WINDOW_GET_CLASS (self);
#line 302 "../src/AppWindow.vala"
	if (_klass_->update_common_action_availability) {
#line 302 "../src/AppWindow.vala"
		_klass_->update_common_action_availability (self, old_page, new_page);
#line 1361 "AppWindow.c"
	}
}

static void
app_window_real_update_common_actions (AppWindow* self,
                                       Page* page,
                                       gint selected_count,
                                       gint count)
{
	GAction* _tmp1_;
#line 312 "../src/AppWindow.vala"
	g_return_if_fail (page != NULL);
#line 313 "../src/AppWindow.vala"
	if (IS_CHECKERBOARD_PAGE (page)) {
#line 1376 "AppWindow.c"
		GAction* _tmp0_;
#line 314 "../src/AppWindow.vala"
		_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, APP_WINDOW_ACTION_SELECT_ALL);
#line 314 "../src/AppWindow.vala"
		g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), count > 0);
#line 1382 "AppWindow.c"
	}
#line 317 "../src/AppWindow.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) self, APP_WINDOW_ACTION_JUMP_TO_FILE);
#line 317 "../src/AppWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction), selected_count == 1);
#line 319 "../src/AppWindow.vala"
	app_window_on_command_manager_altered (self);
#line 1390 "AppWindow.c"
}

void
app_window_update_common_actions (AppWindow* self,
                                  Page* page,
                                  gint selected_count,
                                  gint count)
{
	AppWindowClass* _klass_;
#line 312 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 312 "../src/AppWindow.vala"
	_klass_ = APP_WINDOW_GET_CLASS (self);
#line 312 "../src/AppWindow.vala"
	if (_klass_->update_common_actions) {
#line 312 "../src/AppWindow.vala"
		_klass_->update_common_actions (self, page, selected_count, count);
#line 1408 "AppWindow.c"
	}
}

static void
app_window_on_update_common_actions (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	Page* _tmp1_;
#line 322 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 323 "../src/AppWindow.vala"
	page = _tmp0_;
#line 324 "../src/AppWindow.vala"
	_tmp1_ = page;
#line 324 "../src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 1428 "AppWindow.c"
		Page* _tmp2_;
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
		Page* _tmp6_;
		ViewCollection* _tmp7_;
		ViewCollection* _tmp8_;
#line 325 "../src/AppWindow.vala"
		_tmp2_ = page;
#line 325 "../src/AppWindow.vala"
		_tmp3_ = page;
#line 325 "../src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 325 "../src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 325 "../src/AppWindow.vala"
		_tmp6_ = page;
#line 325 "../src/AppWindow.vala"
		_tmp7_ = page_get_view (_tmp6_);
#line 325 "../src/AppWindow.vala"
		_tmp8_ = _tmp7_;
#line 325 "../src/AppWindow.vala"
		app_window_update_common_actions (self, _tmp2_, view_collection_get_selected_count (_tmp5_), data_collection_get_count ((DataCollection*) _tmp8_));
#line 325 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp8_);
#line 325 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 1456 "AppWindow.c"
	}
#line 322 "../src/AppWindow.vala"
	_g_object_unref0 (page);
#line 1460 "AppWindow.c"
}

static gpointer
_command_manager_ref0 (gpointer self)
{
#line 329 "../src/AppWindow.vala"
	return self ? command_manager_ref (self) : NULL;
#line 1468 "AppWindow.c"
}

CommandManager*
app_window_get_command_manager (void)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
	CommandManager* result;
#line 329 "../src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 329 "../src/AppWindow.vala"
	_tmp1_ = _command_manager_ref0 (_tmp0_);
#line 329 "../src/AppWindow.vala"
	result = _tmp1_;
#line 329 "../src/AppWindow.vala"
	return result;
#line 1485 "AppWindow.c"
}

static void
app_window_on_command_manager_altered (AppWindow* self)
{
	GtkButton* _tmp0_;
	CommandManager* _tmp1_;
	CommandManager* _tmp2_;
	Command* _tmp3_;
	Command* _tmp4_;
	GtkButton* _tmp5_;
	CommandManager* _tmp6_;
	CommandManager* _tmp7_;
	Command* _tmp8_;
	Command* _tmp9_;
#line 332 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/AppWindow.vala"
	_tmp0_ = self->undo_btn;
#line 333 "../src/AppWindow.vala"
	_tmp1_ = app_window_get_command_manager ();
#line 333 "../src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 333 "../src/AppWindow.vala"
	_tmp3_ = command_manager_get_undo_command (_tmp2_);
#line 333 "../src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 333 "../src/AppWindow.vala"
	app_window_decorate_command_manager_action (self, APP_WINDOW_ACTION_UNDO, _tmp0_, _ ("Undo"), _tmp4_);
#line 333 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 333 "../src/AppWindow.vala"
	_command_manager_unref0 (_tmp2_);
#line 334 "../src/AppWindow.vala"
	_tmp5_ = self->redo_btn;
#line 334 "../src/AppWindow.vala"
	_tmp6_ = app_window_get_command_manager ();
#line 334 "../src/AppWindow.vala"
	_tmp7_ = _tmp6_;
#line 334 "../src/AppWindow.vala"
	_tmp8_ = command_manager_get_redo_command (_tmp7_);
#line 334 "../src/AppWindow.vala"
	_tmp9_ = _tmp8_;
#line 334 "../src/AppWindow.vala"
	app_window_decorate_command_manager_action (self, APP_WINDOW_ACTION_REDO, _tmp5_, _ ("Redo"), _tmp9_);
#line 334 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp9_);
#line 334 "../src/AppWindow.vala"
	_command_manager_unref0 (_tmp7_);
#line 1535 "AppWindow.c"
}

static void
app_window_decorate_command_manager_action (AppWindow* self,
                                            const gchar* name,
                                            GtkButton* button,
                                            const gchar* default_explanation,
                                            Command* command)
{
	GSimpleAction* action = NULL;
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
#line 337 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 337 "../src/AppWindow.vala"
	g_return_if_fail (button != NULL);
#line 337 "../src/AppWindow.vala"
	g_return_if_fail (default_explanation != NULL);
#line 338 "../src/AppWindow.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, name);
#line 338 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 338 "../src/AppWindow.vala"
	action = _tmp1_;
#line 339 "../src/AppWindow.vala"
	_tmp2_ = action;
#line 339 "../src/AppWindow.vala"
	if (_tmp2_ == NULL) {
#line 340 "../src/AppWindow.vala"
		_g_object_unref0 (action);
#line 340 "../src/AppWindow.vala"
		return;
#line 1571 "AppWindow.c"
	}
#line 343 "../src/AppWindow.vala"
	if (command != NULL) {
#line 1575 "AppWindow.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GSimpleAction* _tmp7_;
#line 344 "../src/AppWindow.vala"
		_tmp3_ = command_get_name (command);
#line 344 "../src/AppWindow.vala"
		_tmp4_ = _tmp3_;
#line 344 "../src/AppWindow.vala"
		_tmp5_ = g_strdup_printf ("%s %s", default_explanation, _tmp4_);
#line 344 "../src/AppWindow.vala"
		_tmp6_ = _tmp5_;
#line 344 "../src/AppWindow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) button, _tmp6_);
#line 344 "../src/AppWindow.vala"
		_g_free0 (_tmp6_);
#line 345 "../src/AppWindow.vala"
		_tmp7_ = action;
#line 345 "../src/AppWindow.vala"
		g_simple_action_set_enabled (_tmp7_, TRUE);
#line 1597 "AppWindow.c"
	} else {
		GSimpleAction* _tmp8_;
#line 347 "../src/AppWindow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) button, default_explanation);
#line 348 "../src/AppWindow.vala"
		_tmp8_ = action;
#line 348 "../src/AppWindow.vala"
		g_simple_action_set_enabled (_tmp8_, FALSE);
#line 1606 "AppWindow.c"
	}
#line 337 "../src/AppWindow.vala"
	_g_object_unref0 (action);
#line 1610 "AppWindow.c"
}

static void
app_window_action_set_wallpaper (AppWindow* self,
                                 GSimpleAction* action,
                                 GVariant* param)
{
	XdpParent* parent = NULL;
	XdpParent* _tmp0_;
	XdpPortal* portal = NULL;
	XdpPortal* _tmp1_;
	const gchar* _tmp2_;
#line 352 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 352 "../src/AppWindow.vala"
	g_return_if_fail (action != NULL);
#line 353 "../src/AppWindow.vala"
	_tmp0_ = xdp_parent_new_gtk ((GtkWindow*) self);
#line 353 "../src/AppWindow.vala"
	parent = _tmp0_;
#line 355 "../src/AppWindow.vala"
	_tmp1_ = xdp_portal_new ();
#line 355 "../src/AppWindow.vala"
	portal = _tmp1_;
#line 356 "../src/AppWindow.vala"
	_tmp2_ = g_variant_get_string (param, NULL);
#line 356 "../src/AppWindow.vala"
	xdp_portal_set_wallpaper (portal, parent, _tmp2_, XDP_WALLPAPER_FLAG_NONE, NULL, NULL, NULL);
#line 352 "../src/AppWindow.vala"
	_g_object_unref0 (portal);
#line 352 "../src/AppWindow.vala"
	__vala_XdpParent_free0 (parent);
#line 1643 "AppWindow.c"
}

static void
app_window_on_undo (AppWindow* self)
{
	CommandManager* _tmp0_;
#line 359 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 360 "../src/AppWindow.vala"
	command_manager_undo (_tmp0_);
#line 1656 "AppWindow.c"
}

static void
app_window_on_redo (AppWindow* self)
{
	CommandManager* _tmp0_;
#line 363 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 364 "../src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 364 "../src/AppWindow.vala"
	command_manager_redo (_tmp0_);
#line 1669 "AppWindow.c"
}

static void
app_window_on_select_all (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	CheckerboardPage* _tmp1_;
	Page* _tmp2_;
#line 367 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 368 "../src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 368 "../src/AppWindow.vala"
	_tmp1_ = IS_CHECKERBOARD_PAGE (_tmp0_) ? ((CheckerboardPage*) _tmp0_) : NULL;
#line 368 "../src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 368 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 1689 "AppWindow.c"
	}
#line 368 "../src/AppWindow.vala"
	page = (Page*) _tmp1_;
#line 369 "../src/AppWindow.vala"
	_tmp2_ = page;
#line 369 "../src/AppWindow.vala"
	if (_tmp2_ != NULL) {
#line 1697 "AppWindow.c"
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
#line 370 "../src/AppWindow.vala"
		_tmp3_ = page;
#line 370 "../src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 370 "../src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 370 "../src/AppWindow.vala"
		view_collection_select_all (_tmp5_);
#line 370 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 1711 "AppWindow.c"
	}
#line 367 "../src/AppWindow.vala"
	_g_object_unref0 (page);
#line 1715 "AppWindow.c"
}

static void
app_window_on_select_none (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	CheckerboardPage* _tmp1_;
	Page* _tmp2_;
#line 373 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 374 "../src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 374 "../src/AppWindow.vala"
	_tmp1_ = IS_CHECKERBOARD_PAGE (_tmp0_) ? ((CheckerboardPage*) _tmp0_) : NULL;
#line 374 "../src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 374 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 1735 "AppWindow.c"
	}
#line 374 "../src/AppWindow.vala"
	page = (Page*) _tmp1_;
#line 375 "../src/AppWindow.vala"
	_tmp2_ = page;
#line 375 "../src/AppWindow.vala"
	if (_tmp2_ != NULL) {
#line 1743 "AppWindow.c"
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
#line 376 "../src/AppWindow.vala"
		_tmp3_ = page;
#line 376 "../src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 376 "../src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 376 "../src/AppWindow.vala"
		view_collection_unselect_all (_tmp5_);
#line 376 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 1757 "AppWindow.c"
	}
#line 373 "../src/AppWindow.vala"
	_g_object_unref0 (page);
#line 1761 "AppWindow.c"
}

static gboolean
app_window_real_configure_event (GtkWidget* base,
                                 GdkEventConfigure* event)
{
	AppWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 379 "../src/AppWindow.vala"
	self = (AppWindow*) base;
#line 379 "../src/AppWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 380 "../src/AppWindow.vala"
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp0_, NULL);
#line 380 "../src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 380 "../src/AppWindow.vala"
	if (!_tmp1_) {
#line 1782 "AppWindow.c"
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 381 "../src/AppWindow.vala"
		gtk_window_get_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 381 "../src/AppWindow.vala"
		self->dimensions.width = _tmp2_;
#line 381 "../src/AppWindow.vala"
		self->dimensions.height = _tmp3_;
#line 1791 "AppWindow.c"
	}
#line 383 "../src/AppWindow.vala"
	result = GTK_WIDGET_CLASS (app_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), event);
#line 383 "../src/AppWindow.vala"
	return result;
#line 1797 "AppWindow.c"
}

static void
_app_window_on_command_manager_altered_command_manager_altered (CommandManager* _sender,
                                                                gboolean can_undo,
                                                                gboolean can_redo,
                                                                gpointer self)
{
#line 76 "../src/AppWindow.vala"
	app_window_on_command_manager_altered ((AppWindow*) self);
#line 1808 "AppWindow.c"
}

static GObject *
app_window_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppWindow * self;
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
	CommandManager* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	HdyHeaderBar* _tmp7_;
	HdyHeaderBar* _tmp8_;
	PhotosApplication* application_instance = NULL;
	GApplication* _tmp9_;
	PhotosApplication* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	PhotosApplication* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	PhotosApplication* _tmp18_;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	PhotosApplication* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	PhotosApplication* _tmp26_;
	gchar* _tmp27_;
	gchar** _tmp28_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	PhotosApplication* _tmp30_;
	gchar* _tmp31_;
	gchar** _tmp32_;
	gchar** _tmp33_;
	gint _tmp33__length1;
	PhotosApplication* _tmp34_;
	gchar* _tmp35_;
	gchar** _tmp36_;
	gchar** _tmp37_;
	gint _tmp37__length1;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp38_;
	GtkCssProvider* _tmp39_;
	GdkScreen* _tmp40_;
	GtkCssProvider* _tmp41_;
	GSettings* _tmp42_;
	gint _tmp43_ = 0;
	GtkActionGroup** _tmp44_;
	GtkActionGroup** _tmp45_;
	gint _tmp45__length1;
	GtkUIManager* _tmp55_;
	GtkUIManager* _tmp56_;
	GtkAccelGroup* _tmp57_;
	GError* _inner_error0_ = NULL;
#line 73 "../src/AppWindow.vala"
	parent_class = G_OBJECT_CLASS (app_window_parent_class);
#line 73 "../src/AppWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 73 "../src/AppWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_WINDOW, AppWindow);
#line 74 "../src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 74 "../src/AppWindow.vala"
	_vala_assert (_tmp0_ == NULL, "command_manager == null");
#line 75 "../src/AppWindow.vala"
	_tmp1_ = command_manager_new (COMMAND_MANAGER_DEFAULT_DEPTH);
#line 75 "../src/AppWindow.vala"
	_command_manager_unref0 (app_window_command_manager);
#line 75 "../src/AppWindow.vala"
	app_window_command_manager = _tmp1_;
#line 76 "../src/AppWindow.vala"
	_tmp2_ = app_window_command_manager;
#line 76 "../src/AppWindow.vala"
	g_signal_connect_object (_tmp2_, "altered", (GCallback) _app_window_on_command_manager_altered_command_manager_altered, self, 0);
#line 78 "../src/AppWindow.vala"
	_tmp3_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-redo", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 78 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 78 "../src/AppWindow.vala"
	_g_object_unref0 (self->redo_btn);
#line 78 "../src/AppWindow.vala"
	self->redo_btn = _tmp3_;
#line 79 "../src/AppWindow.vala"
	_tmp4_ = self->redo_btn;
#line 79 "../src/AppWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp4_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_REDO);
#line 81 "../src/AppWindow.vala"
	_tmp5_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 81 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 81 "../src/AppWindow.vala"
	_g_object_unref0 (self->undo_btn);
#line 81 "../src/AppWindow.vala"
	self->undo_btn = _tmp5_;
#line 82 "../src/AppWindow.vala"
	_tmp6_ = self->undo_btn;
#line 82 "../src/AppWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp6_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_UNDO);
#line 84 "../src/AppWindow.vala"
	_tmp7_ = (HdyHeaderBar*) hdy_header_bar_new ();
#line 84 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 84 "../src/AppWindow.vala"
	_g_object_unref0 (self->header);
#line 84 "../src/AppWindow.vala"
	self->header = _tmp7_;
#line 85 "../src/AppWindow.vala"
	_tmp8_ = self->header;
#line 85 "../src/AppWindow.vala"
	hdy_header_bar_set_show_close_button (_tmp8_, TRUE);
#line 87 "../src/AppWindow.vala"
	gtk_window_set_icon_name ((GtkWindow*) self, "io.elementary.photos");
#line 88 "../src/AppWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _ (RESOURCES_APP_TITLE));
#line 90 "../src/AppWindow.vala"
	g_action_map_add_action_entries ((GActionMap*) self, APP_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (APP_WINDOW_ACTION_ENTRIES), self);
#line 92 "../src/AppWindow.vala"
	_tmp9_ = g_application_get_default ();
#line 92 "../src/AppWindow.vala"
	application_instance = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, PHOTOS_TYPE_APPLICATION, PhotosApplication);
#line 93 "../src/AppWindow.vala"
	_tmp10_ = application_instance;
#line 93 "../src/AppWindow.vala"
	_tmp11_ = g_strdup ("F11");
#line 93 "../src/AppWindow.vala"
	_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 93 "../src/AppWindow.vala"
	_tmp12_[0] = _tmp11_;
#line 93 "../src/AppWindow.vala"
	_tmp13_ = _tmp12_;
#line 93 "../src/AppWindow.vala"
	_tmp13__length1 = 1;
#line 93 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp10_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_FULLSCREEN, _tmp13_);
#line 93 "../src/AppWindow.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/AppWindow.vala"
	_tmp14_ = application_instance;
#line 94 "../src/AppWindow.vala"
	_tmp15_ = g_strdup ("<Ctrl><Shift>M");
#line 94 "../src/AppWindow.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 94 "../src/AppWindow.vala"
	_tmp16_[0] = _tmp15_;
#line 94 "../src/AppWindow.vala"
	_tmp17_ = _tmp16_;
#line 94 "../src/AppWindow.vala"
	_tmp17__length1 = 1;
#line 94 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp14_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_JUMP_TO_FILE, _tmp17_);
#line 94 "../src/AppWindow.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 95 "../src/AppWindow.vala"
	_tmp18_ = application_instance;
#line 95 "../src/AppWindow.vala"
	_tmp19_ = g_strdup ("<Ctrl>Q");
#line 95 "../src/AppWindow.vala"
	_tmp20_ = g_new0 (gchar*, 1 + 1);
#line 95 "../src/AppWindow.vala"
	_tmp20_[0] = _tmp19_;
#line 95 "../src/AppWindow.vala"
	_tmp21_ = _tmp20_;
#line 95 "../src/AppWindow.vala"
	_tmp21__length1 = 1;
#line 95 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp18_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_QUIT, _tmp21_);
#line 95 "../src/AppWindow.vala"
	_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 96 "../src/AppWindow.vala"
	_tmp22_ = application_instance;
#line 96 "../src/AppWindow.vala"
	_tmp23_ = g_strdup ("<Ctrl><Shift>Z");
#line 96 "../src/AppWindow.vala"
	_tmp24_ = g_new0 (gchar*, 1 + 1);
#line 96 "../src/AppWindow.vala"
	_tmp24_[0] = _tmp23_;
#line 96 "../src/AppWindow.vala"
	_tmp25_ = _tmp24_;
#line 96 "../src/AppWindow.vala"
	_tmp25__length1 = 1;
#line 96 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp22_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_REDO, _tmp25_);
#line 96 "../src/AppWindow.vala"
	_tmp25_ = (_vala_array_free (_tmp25_, _tmp25__length1, (GDestroyNotify) g_free), NULL);
#line 97 "../src/AppWindow.vala"
	_tmp26_ = application_instance;
#line 97 "../src/AppWindow.vala"
	_tmp27_ = g_strdup ("<Ctrl>A");
#line 97 "../src/AppWindow.vala"
	_tmp28_ = g_new0 (gchar*, 1 + 1);
#line 97 "../src/AppWindow.vala"
	_tmp28_[0] = _tmp27_;
#line 97 "../src/AppWindow.vala"
	_tmp29_ = _tmp28_;
#line 97 "../src/AppWindow.vala"
	_tmp29__length1 = 1;
#line 97 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp26_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_SELECT_ALL, _tmp29_);
#line 97 "../src/AppWindow.vala"
	_tmp29_ = (_vala_array_free (_tmp29_, _tmp29__length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/AppWindow.vala"
	_tmp30_ = application_instance;
#line 98 "../src/AppWindow.vala"
	_tmp31_ = g_strdup ("<Ctrl><Shift>A");
#line 98 "../src/AppWindow.vala"
	_tmp32_ = g_new0 (gchar*, 1 + 1);
#line 98 "../src/AppWindow.vala"
	_tmp32_[0] = _tmp31_;
#line 98 "../src/AppWindow.vala"
	_tmp33_ = _tmp32_;
#line 98 "../src/AppWindow.vala"
	_tmp33__length1 = 1;
#line 98 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp30_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_SELECT_NONE, _tmp33_);
#line 98 "../src/AppWindow.vala"
	_tmp33_ = (_vala_array_free (_tmp33_, _tmp33__length1, (GDestroyNotify) g_free), NULL);
#line 99 "../src/AppWindow.vala"
	_tmp34_ = application_instance;
#line 99 "../src/AppWindow.vala"
	_tmp35_ = g_strdup ("<Ctrl>Z");
#line 99 "../src/AppWindow.vala"
	_tmp36_ = g_new0 (gchar*, 1 + 1);
#line 99 "../src/AppWindow.vala"
	_tmp36_[0] = _tmp35_;
#line 99 "../src/AppWindow.vala"
	_tmp37_ = _tmp36_;
#line 99 "../src/AppWindow.vala"
	_tmp37__length1 = 1;
#line 99 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp34_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_UNDO, _tmp37_);
#line 99 "../src/AppWindow.vala"
	_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
#line 101 "../src/AppWindow.vala"
	_tmp38_ = gtk_css_provider_new ();
#line 101 "../src/AppWindow.vala"
	css_provider = _tmp38_;
#line 102 "../src/AppWindow.vala"
	_tmp39_ = css_provider;
#line 102 "../src/AppWindow.vala"
	gtk_css_provider_load_from_resource (_tmp39_, "io/elementary/photos/application.css");
#line 103 "../src/AppWindow.vala"
	_tmp40_ = gdk_screen_get_default ();
#line 103 "../src/AppWindow.vala"
	_tmp41_ = css_provider;
#line 103 "../src/AppWindow.vala"
	gtk_style_context_add_provider_for_screen (_tmp40_, (GtkStyleProvider*) _tmp41_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 105 "../src/AppWindow.vala"
	_tmp42_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_WINDOW_PREFS_SCHEMA_NAME);
#line 105 "../src/AppWindow.vala"
	_g_object_unref0 (self->window_settings);
#line 105 "../src/AppWindow.vala"
	self->window_settings = _tmp42_;
#line 112 "../src/AppWindow.vala"
	_tmp44_ = app_window_create_common_action_groups (self, &_tmp43_);
#line 112 "../src/AppWindow.vala"
	self->common_action_groups = (_vala_array_free (self->common_action_groups, self->common_action_groups_length1, (GDestroyNotify) g_object_unref), NULL);
#line 112 "../src/AppWindow.vala"
	self->common_action_groups = _tmp44_;
#line 112 "../src/AppWindow.vala"
	self->common_action_groups_length1 = _tmp43_;
#line 113 "../src/AppWindow.vala"
	_tmp45_ = self->common_action_groups;
#line 113 "../src/AppWindow.vala"
	_tmp45__length1 = self->common_action_groups_length1;
#line 2089 "AppWindow.c"
	{
		GtkActionGroup** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
#line 113 "../src/AppWindow.vala"
		group_collection = _tmp45_;
#line 113 "../src/AppWindow.vala"
		group_collection_length1 = _tmp45__length1;
#line 113 "../src/AppWindow.vala"
		for (group_it = 0; group_it < group_collection_length1; group_it = group_it + 1) {
#line 2101 "AppWindow.c"
			GtkActionGroup* _tmp46_;
			GtkActionGroup* group = NULL;
#line 113 "../src/AppWindow.vala"
			_tmp46_ = _g_object_ref0 (group_collection[group_it]);
#line 113 "../src/AppWindow.vala"
			group = _tmp46_;
#line 2108 "AppWindow.c"
			{
				GtkUIManager* _tmp47_;
				GtkActionGroup* _tmp48_;
#line 114 "../src/AppWindow.vala"
				_tmp47_ = ((PageWindow*) self)->ui;
#line 114 "../src/AppWindow.vala"
				_tmp48_ = group;
#line 114 "../src/AppWindow.vala"
				gtk_ui_manager_insert_action_group (_tmp47_, _tmp48_, 0);
#line 113 "../src/AppWindow.vala"
				_g_object_unref0 (group);
#line 2120 "AppWindow.c"
			}
		}
	}
	{
		GtkUIManager* _tmp49_;
		GtkActionGroup** _tmp50_;
		gint _tmp50__length1;
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 117 "../src/AppWindow.vala"
		_tmp49_ = ((PageWindow*) self)->ui;
#line 117 "../src/AppWindow.vala"
		_tmp50_ = self->common_action_groups;
#line 117 "../src/AppWindow.vala"
		_tmp50__length1 = self->common_action_groups_length1;
#line 117 "../src/AppWindow.vala"
		_tmp51_ = build_dummy_ui_string (_tmp50_, (gint) _tmp50__length1);
#line 117 "../src/AppWindow.vala"
		_tmp52_ = _tmp51_;
#line 117 "../src/AppWindow.vala"
		gtk_ui_manager_add_ui_from_string (_tmp49_, _tmp52_, (gssize) -1, &_inner_error0_);
#line 117 "../src/AppWindow.vala"
		_g_free0 (_tmp52_);
#line 117 "../src/AppWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2146 "AppWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp53_;
		const gchar* _tmp54_;
#line 116 "../src/AppWindow.vala"
		err = _inner_error0_;
#line 116 "../src/AppWindow.vala"
		_inner_error0_ = NULL;
#line 119 "../src/AppWindow.vala"
		_tmp53_ = err;
#line 119 "../src/AppWindow.vala"
		_tmp54_ = _tmp53_->message;
#line 119 "../src/AppWindow.vala"
		g_error ("AppWindow.vala:119: Unable to add AppWindow UI: %s", _tmp54_);
#line 116 "../src/AppWindow.vala"
		_g_error_free0 (err);
#line 2168 "AppWindow.c"
	}
	__finally0:
#line 116 "../src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/AppWindow.vala"
		_g_object_unref0 (css_provider);
#line 116 "../src/AppWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/AppWindow.vala"
		g_clear_error (&_inner_error0_);
#line 2179 "AppWindow.c"
	}
#line 122 "../src/AppWindow.vala"
	_tmp55_ = ((PageWindow*) self)->ui;
#line 122 "../src/AppWindow.vala"
	gtk_ui_manager_ensure_update (_tmp55_);
#line 123 "../src/AppWindow.vala"
	_tmp56_ = ((PageWindow*) self)->ui;
#line 123 "../src/AppWindow.vala"
	_tmp57_ = gtk_ui_manager_get_accel_group (_tmp56_);
#line 123 "../src/AppWindow.vala"
	gtk_window_add_accel_group ((GtkWindow*) self, _tmp57_);
#line 73 "../src/AppWindow.vala"
	_g_object_unref0 (css_provider);
#line 73 "../src/AppWindow.vala"
	return obj;
#line 2195 "AppWindow.c"
}

static void
app_window_class_init (AppWindowClass * klass,
                       gpointer klass_data)
{
#line 27 "../src/AppWindow.vala"
	app_window_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/AppWindow.vala"
	g_type_class_adjust_private_offset (klass, &AppWindow_private_offset);
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->on_fullscreen = (void (*) (AppWindow*)) app_window_real_on_fullscreen;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->get_app_role = (gchar* (*) (AppWindow*)) app_window_real_get_app_role;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->on_quit = (void (*) (AppWindow*)) app_window_real_on_quit;
#line 27 "../src/AppWindow.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) app_window_real_destroy;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->create_common_action_groups = (GtkActionGroup** (*) (AppWindow*, gint*)) app_window_real_create_common_action_groups;
#line 27 "../src/AppWindow.vala"
	((PageWindowClass *) klass)->switched_pages = (void (*) (PageWindow*, Page*, Page*)) app_window_real_switched_pages;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->update_common_action_availability = (void (*) (AppWindow*, Page*, Page*)) app_window_real_update_common_action_availability;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->update_common_actions = (void (*) (AppWindow*, Page*, gint, gint)) app_window_real_update_common_actions;
#line 27 "../src/AppWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) app_window_real_configure_event;
#line 27 "../src/AppWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = app_window_constructor;
#line 27 "../src/AppWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = app_window_finalize;
#line 2228 "AppWindow.c"
}

static void
app_window_instance_init (AppWindow * self,
                          gpointer klass)
{
#line 27 "../src/AppWindow.vala"
	self->priv = app_window_get_instance_private (self);
#line 37 "../src/AppWindow.vala"
	self->priv->pos_x = 0;
#line 38 "../src/AppWindow.vala"
	self->priv->pos_y = 0;
#line 2241 "AppWindow.c"
}

static void
app_window_finalize (GObject * obj)
{
	AppWindow * self;
#line 27 "../src/AppWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_WINDOW, AppWindow);
#line 35 "../src/AppWindow.vala"
	self->common_action_groups = (_vala_array_free (self->common_action_groups, self->common_action_groups_length1, (GDestroyNotify) g_object_unref), NULL);
#line 39 "../src/AppWindow.vala"
	_g_object_unref0 (self->header);
#line 41 "../src/AppWindow.vala"
	_g_object_unref0 (self->redo_btn);
#line 42 "../src/AppWindow.vala"
	_g_object_unref0 (self->undo_btn);
#line 44 "../src/AppWindow.vala"
	_g_object_unref0 (self->window_settings);
#line 27 "../src/AppWindow.vala"
	G_OBJECT_CLASS (app_window_parent_class)->finalize (obj);
#line 2262 "AppWindow.c"
}

static GType
app_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AppWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppWindow), 0, (GInstanceInitFunc) app_window_instance_init, NULL };
	GType app_window_type_id;
	app_window_type_id = g_type_register_static (TYPE_PAGE_WINDOW, "AppWindow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	AppWindow_private_offset = g_type_add_instance_private (app_window_type_id, sizeof (AppWindowPrivate));
	return app_window_type_id;
}

GType
app_window_get_type (void)
{
	static volatile gsize app_window_type_id__once = 0;
	if (g_once_init_enter (&app_window_type_id__once)) {
		GType app_window_type_id;
		app_window_type_id = app_window_get_type_once ();
		g_once_init_leave (&app_window_type_id__once, app_window_type_id);
	}
	return app_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

