/* CustomComponents.c generated by valac 0.56.18, the Vala compiler
 * generated from CustomComponents.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2017 elementary LLC.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE 13
#define RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH (RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE / 2)
#define RGB_HISTOGRAM_MANIPULATOR_NUB_V_NUDGE 4
#define RGB_HISTOGRAM_MANIPULATOR_TROUGH_WIDTH (256 + (2 * RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH))
#define RGB_HISTOGRAM_MANIPULATOR_TROUGH_HEIGHT 4
#define RGB_HISTOGRAM_MANIPULATOR_TROUGH_BOTTOM_OFFSET 1
#define RGB_HISTOGRAM_MANIPULATOR_CONTROL_WIDTH (RGB_HISTOGRAM_MANIPULATOR_TROUGH_WIDTH + 2)
#define RGB_HISTOGRAM_MANIPULATOR_CONTROL_HEIGHT 118
#define RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION (((((RGB_HISTOGRAM_MANIPULATOR_CONTROL_HEIGHT - RGB_HISTOGRAM_MANIPULATOR_TROUGH_HEIGHT) - RGB_HISTOGRAM_MANIPULATOR_TROUGH_BOTTOM_OFFSET) - ((RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE - RGB_HISTOGRAM_MANIPULATOR_TROUGH_HEIGHT) / 2)) - RGB_HISTOGRAM_MANIPULATOR_NUB_V_NUDGE) - 2)
#define RGB_HISTOGRAM_GRAPHIC_WIDTH 256
#define RGB_HISTOGRAM_GRAPHIC_HEIGHT 100
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_RGB_HISTOGRAM (rgb_histogram_get_type ())
#define RGB_HISTOGRAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RGB_HISTOGRAM, RGBHistogram))
#define RGB_HISTOGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RGB_HISTOGRAM, RGBHistogramClass))
#define IS_RGB_HISTOGRAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RGB_HISTOGRAM))
#define IS_RGB_HISTOGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RGB_HISTOGRAM))
#define RGB_HISTOGRAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RGB_HISTOGRAM, RGBHistogramClass))

typedef struct _RGBHistogram RGBHistogram;
typedef struct _RGBHistogramClass RGBHistogramClass;
enum  {
	RGB_HISTOGRAM_MANIPULATOR_0_PROPERTY,
	RGB_HISTOGRAM_MANIPULATOR_NUM_PROPERTIES
};
static GParamSpec* rgb_histogram_manipulator_properties[RGB_HISTOGRAM_MANIPULATOR_NUM_PROPERTIES];
typedef enum  {
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB,
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB,
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH,
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH,
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA
} RGBHistogramManipulatorLocationCode;

#define RGB_HISTOGRAM_MANIPULATOR_TYPE_LOCATION_CODE (rgb_histogram_manipulator_location_code_get_type ())
#define _rgb_histogram_unref0(var) ((var == NULL) ? NULL : (var = (rgb_histogram_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL,
	RGB_HISTOGRAM_MANIPULATOR_NUM_SIGNALS
};
static guint rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _RGBHistogramManipulatorPrivate {
	gint left_nub_max;
	gint right_nub_min;
	RGBHistogram* histogram;
	gint left_nub_position;
	gint right_nub_position;
	gboolean is_left_nub_tracking;
	gboolean is_right_nub_tracking;
	gint track_start_x;
	gint track_nub_start_position;
	GdkPixbuf* drag_nub_pixbuf;
};

static gint RGBHistogramManipulator_private_offset;
static gpointer rgb_histogram_manipulator_parent_class = NULL;
static GtkWidget* rgb_histogram_manipulator_dummy_slider;
static GtkWidget* rgb_histogram_manipulator_dummy_slider = NULL;
static GtkWidget* rgb_histogram_manipulator_dummy_frame;
static GtkWidget* rgb_histogram_manipulator_dummy_frame = NULL;
static GtkWidgetPath* rgb_histogram_manipulator_slider_draw_path;
static GtkWidgetPath* rgb_histogram_manipulator_slider_draw_path = NULL;
static GtkWidgetPath* rgb_histogram_manipulator_frame_draw_path;
static GtkWidgetPath* rgb_histogram_manipulator_frame_draw_path = NULL;
static gboolean rgb_histogram_manipulator_paths_setup;
static gboolean rgb_histogram_manipulator_paths_setup = FALSE;

VALA_EXTERN gpointer rgb_histogram_ref (gpointer instance);
VALA_EXTERN void rgb_histogram_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_rgb_histogram (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_rgb_histogram (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_rgb_histogram (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_rgb_histogram (const GValue* value);
VALA_EXTERN GType rgb_histogram_get_type (void) G_GNUC_CONST ;
static GType rgb_histogram_manipulator_location_code_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GdkPixbuf* rgb_histogram_manipulator_get_drag_nub_pixbuf (RGBHistogramManipulator* self);
static gboolean rgb_histogram_manipulator_on_button_press (RGBHistogramManipulator* self,
                                                    GdkEventButton* event_record);
static gboolean _rgb_histogram_manipulator_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                   GdkEventButton* event,
                                                                                   gpointer self);
static gboolean rgb_histogram_manipulator_on_button_release (RGBHistogramManipulator* self,
                                                      GdkEventButton* event_record);
static gboolean _rgb_histogram_manipulator_on_button_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                       GdkEventButton* event,
                                                                                       gpointer self);
static gboolean rgb_histogram_manipulator_on_button_motion (RGBHistogramManipulator* self,
                                                     GdkEventMotion* event_record);
static gboolean _rgb_histogram_manipulator_on_button_motion_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                     GdkEventMotion* event,
                                                                                     gpointer self);
static RGBHistogramManipulatorLocationCode rgb_histogram_manipulator_hit_test_point (RGBHistogramManipulator* self,
                                                                              gint x,
                                                                              gint y);
static void rgb_histogram_manipulator_force_update (RGBHistogramManipulator* self);
static void rgb_histogram_manipulator_update_nub_extrema (RGBHistogramManipulator* self);
static gboolean rgb_histogram_manipulator_real_draw (GtkWidget* base,
                                              cairo_t* ctx);
static void rgb_histogram_manipulator_draw_histogram_frame (RGBHistogramManipulator* self,
                                                     cairo_t* ctx,
                                                     GdkRectangle* area);
static void rgb_histogram_manipulator_draw_histogram (RGBHistogramManipulator* self,
                                               cairo_t* ctx,
                                               GdkRectangle* area);
static void rgb_histogram_manipulator_draw_trough (RGBHistogramManipulator* self,
                                            cairo_t* ctx,
                                            GdkRectangle* area);
static void rgb_histogram_manipulator_draw_nub (RGBHistogramManipulator* self,
                                         cairo_t* ctx,
                                         GdkRectangle* area,
                                         gint position);
VALA_EXTERN GdkPixbuf* rgb_histogram_get_graphic (RGBHistogram* self);
VALA_EXTERN RGBHistogram* rgb_histogram_new (GdkPixbuf* pixbuf);
VALA_EXTERN RGBHistogram* rgb_histogram_construct (GType object_type,
                                       GdkPixbuf* pixbuf);
static void rgb_histogram_manipulator_finalize (GObject * obj);
static GType rgb_histogram_manipulator_get_type_once (void);

static inline gpointer
rgb_histogram_manipulator_get_instance_private (RGBHistogramManipulator* self)
{
	return G_STRUCT_MEMBER_P (self, RGBHistogramManipulator_private_offset);
}

static GType
rgb_histogram_manipulator_location_code_get_type_once (void)
{
	static const GEnumValue values[] = {{RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB", "left-nub"}, {RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB", "right-nub"}, {RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH", "left-trough"}, {RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH", "right-trough"}, {RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA", "insensitive-area"}, {0, NULL, NULL}};
	GType rgb_histogram_manipulator_location_code_type_id;
	rgb_histogram_manipulator_location_code_type_id = g_enum_register_static ("RGBHistogramManipulatorLocationCode", values);
	return rgb_histogram_manipulator_location_code_type_id;
}

static GType
rgb_histogram_manipulator_location_code_get_type (void)
{
	static volatile gsize rgb_histogram_manipulator_location_code_type_id__once = 0;
	if (g_once_init_enter (&rgb_histogram_manipulator_location_code_type_id__once)) {
		GType rgb_histogram_manipulator_location_code_type_id;
		rgb_histogram_manipulator_location_code_type_id = rgb_histogram_manipulator_location_code_get_type_once ();
		g_once_init_leave (&rgb_histogram_manipulator_location_code_type_id__once, rgb_histogram_manipulator_location_code_type_id);
	}
	return rgb_histogram_manipulator_location_code_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../src/CustomComponents.vala"
	return self ? g_object_ref (self) : NULL;
#line 208 "CustomComponents.c"
}

static GdkPixbuf*
rgb_histogram_manipulator_get_drag_nub_pixbuf (RGBHistogramManipulator* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 54 "../src/CustomComponents.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/CustomComponents.vala"
	_tmp0_ = self->priv->drag_nub_pixbuf;
#line 55 "../src/CustomComponents.vala"
	if (_tmp0_ == NULL) {
#line 225 "CustomComponents.c"
		{
			GdkPixbuf* _tmp1_ = NULL;
			GdkPixbuf* _tmp2_;
			GdkPixbuf* _tmp3_;
#line 57 "../src/CustomComponents.vala"
			_tmp2_ = gdk_pixbuf_new_from_resource ("/io/elementary/photos/icons/drag-nub.svg", &_inner_error0_);
#line 57 "../src/CustomComponents.vala"
			_tmp1_ = _tmp2_;
#line 57 "../src/CustomComponents.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 236 "CustomComponents.c"
				goto __catch0_g_error;
			}
#line 57 "../src/CustomComponents.vala"
			_tmp3_ = _tmp1_;
#line 57 "../src/CustomComponents.vala"
			_tmp1_ = NULL;
#line 57 "../src/CustomComponents.vala"
			_g_object_unref0 (self->priv->drag_nub_pixbuf);
#line 57 "../src/CustomComponents.vala"
			self->priv->drag_nub_pixbuf = _tmp3_;
#line 56 "../src/CustomComponents.vala"
			_g_object_unref0 (_tmp1_);
#line 249 "CustomComponents.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			const gchar* _tmp4_;
#line 56 "../src/CustomComponents.vala"
			err = _inner_error0_;
#line 56 "../src/CustomComponents.vala"
			_inner_error0_ = NULL;
#line 59 "../src/CustomComponents.vala"
			_tmp4_ = err->message;
#line 59 "../src/CustomComponents.vala"
			g_error ("CustomComponents.vala:59: Can't load drag nub image: %s", _tmp4_);
#line 56 "../src/CustomComponents.vala"
			_g_error_free0 (err);
#line 266 "CustomComponents.c"
		}
		__finally0:
#line 56 "../src/CustomComponents.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/CustomComponents.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "../src/CustomComponents.vala"
			g_clear_error (&_inner_error0_);
#line 56 "../src/CustomComponents.vala"
			return NULL;
#line 277 "CustomComponents.c"
		}
	}
#line 63 "../src/CustomComponents.vala"
	_tmp5_ = self->priv->drag_nub_pixbuf;
#line 63 "../src/CustomComponents.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 63 "../src/CustomComponents.vala"
	result = _tmp6_;
#line 63 "../src/CustomComponents.vala"
	return result;
#line 288 "CustomComponents.c"
}

static gboolean
_rgb_histogram_manipulator_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                          GdkEventButton* event,
                                                                          gpointer self)
{
	gboolean result;
	result = rgb_histogram_manipulator_on_button_press ((RGBHistogramManipulator*) self, event);
#line 90 "../src/CustomComponents.vala"
	return result;
#line 300 "CustomComponents.c"
}

static gboolean
_rgb_histogram_manipulator_on_button_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                              GdkEventButton* event,
                                                                              gpointer self)
{
	gboolean result;
	result = rgb_histogram_manipulator_on_button_release ((RGBHistogramManipulator*) self, event);
#line 91 "../src/CustomComponents.vala"
	return result;
#line 312 "CustomComponents.c"
}

static gboolean
_rgb_histogram_manipulator_on_button_motion_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                            GdkEventMotion* event,
                                                                            gpointer self)
{
	gboolean result;
	result = rgb_histogram_manipulator_on_button_motion ((RGBHistogramManipulator*) self, event);
#line 92 "../src/CustomComponents.vala"
	return result;
#line 324 "CustomComponents.c"
}

RGBHistogramManipulator*
rgb_histogram_manipulator_construct (GType object_type)
{
	RGBHistogramManipulator * self = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp2_;
#line 66 "../src/CustomComponents.vala"
	self = (RGBHistogramManipulator*) g_object_new (object_type, NULL);
#line 67 "../src/CustomComponents.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, RGB_HISTOGRAM_MANIPULATOR_CONTROL_WIDTH, RGB_HISTOGRAM_MANIPULATOR_CONTROL_HEIGHT);
#line 69 "../src/CustomComponents.vala"
	_tmp0_ = rgb_histogram_manipulator_dummy_slider;
#line 69 "../src/CustomComponents.vala"
	if (_tmp0_ == NULL) {
#line 341 "CustomComponents.c"
		GtkScale* _tmp1_;
#line 70 "../src/CustomComponents.vala"
		_tmp1_ = (GtkScale*) gtk_scale_new (GTK_ORIENTATION_HORIZONTAL, NULL);
#line 70 "../src/CustomComponents.vala"
		g_object_ref_sink (_tmp1_);
#line 70 "../src/CustomComponents.vala"
		_g_object_unref0 (rgb_histogram_manipulator_dummy_slider);
#line 70 "../src/CustomComponents.vala"
		rgb_histogram_manipulator_dummy_slider = (GtkWidget*) _tmp1_;
#line 351 "CustomComponents.c"
	}
#line 72 "../src/CustomComponents.vala"
	_tmp2_ = rgb_histogram_manipulator_dummy_frame;
#line 72 "../src/CustomComponents.vala"
	if (_tmp2_ == NULL) {
#line 357 "CustomComponents.c"
		GtkFrame* _tmp3_;
#line 73 "../src/CustomComponents.vala"
		_tmp3_ = (GtkFrame*) gtk_frame_new (NULL);
#line 73 "../src/CustomComponents.vala"
		g_object_ref_sink (_tmp3_);
#line 73 "../src/CustomComponents.vala"
		_g_object_unref0 (rgb_histogram_manipulator_dummy_frame);
#line 73 "../src/CustomComponents.vala"
		rgb_histogram_manipulator_dummy_frame = (GtkWidget*) _tmp3_;
#line 367 "CustomComponents.c"
	}
#line 75 "../src/CustomComponents.vala"
	if (!rgb_histogram_manipulator_paths_setup) {
#line 371 "CustomComponents.c"
		GtkWidgetPath* _tmp4_;
		GtkWidgetPath* _tmp5_;
		GtkWidgetPath* _tmp6_;
		GtkWidgetPath* _tmp7_;
		GtkWidgetPath* _tmp8_;
#line 76 "../src/CustomComponents.vala"
		_tmp4_ = rgb_histogram_manipulator_slider_draw_path;
#line 76 "../src/CustomComponents.vala"
		gtk_widget_path_append_type (_tmp4_, gtk_scale_get_type ());
#line 77 "../src/CustomComponents.vala"
		_tmp5_ = rgb_histogram_manipulator_slider_draw_path;
#line 77 "../src/CustomComponents.vala"
		gtk_widget_path_iter_add_class (_tmp5_, 0, "scale");
#line 78 "../src/CustomComponents.vala"
		_tmp6_ = rgb_histogram_manipulator_slider_draw_path;
#line 78 "../src/CustomComponents.vala"
		gtk_widget_path_iter_add_class (_tmp6_, 0, "range");
#line 80 "../src/CustomComponents.vala"
		_tmp7_ = rgb_histogram_manipulator_frame_draw_path;
#line 80 "../src/CustomComponents.vala"
		gtk_widget_path_append_type (_tmp7_, gtk_frame_get_type ());
#line 81 "../src/CustomComponents.vala"
		_tmp8_ = rgb_histogram_manipulator_frame_draw_path;
#line 81 "../src/CustomComponents.vala"
		gtk_widget_path_iter_add_class (_tmp8_, 0, "default");
#line 83 "../src/CustomComponents.vala"
		rgb_histogram_manipulator_paths_setup = TRUE;
#line 399 "CustomComponents.c"
	}
#line 86 "../src/CustomComponents.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_BUTTON_PRESS_MASK);
#line 87 "../src/CustomComponents.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_BUTTON_RELEASE_MASK);
#line 88 "../src/CustomComponents.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_BUTTON_MOTION_MASK);
#line 90 "../src/CustomComponents.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) _rgb_histogram_manipulator_on_button_press_gtk_widget_button_press_event, self, 0);
#line 91 "../src/CustomComponents.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _rgb_histogram_manipulator_on_button_release_gtk_widget_button_release_event, self, 0);
#line 92 "../src/CustomComponents.vala"
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _rgb_histogram_manipulator_on_button_motion_gtk_widget_motion_notify_event, self, 0);
#line 66 "../src/CustomComponents.vala"
	return self;
#line 415 "CustomComponents.c"
}

RGBHistogramManipulator*
rgb_histogram_manipulator_new (void)
{
#line 66 "../src/CustomComponents.vala"
	return rgb_histogram_manipulator_construct (TYPE_RGB_HISTOGRAM_MANIPULATOR);
#line 423 "CustomComponents.c"
}

static RGBHistogramManipulatorLocationCode
rgb_histogram_manipulator_hit_test_point (RGBHistogramManipulator* self,
                                          gint x,
                                          gint y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	RGBHistogramManipulatorLocationCode result;
#line 95 "../src/CustomComponents.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 96 "../src/CustomComponents.vala"
	if (y < RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION) {
#line 97 "../src/CustomComponents.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA;
#line 97 "../src/CustomComponents.vala"
		return result;
#line 442 "CustomComponents.c"
	}
#line 99 "../src/CustomComponents.vala"
	if (x > self->priv->left_nub_position) {
#line 99 "../src/CustomComponents.vala"
		_tmp0_ = x < (self->priv->left_nub_position + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE);
#line 448 "CustomComponents.c"
	} else {
#line 99 "../src/CustomComponents.vala"
		_tmp0_ = FALSE;
#line 452 "CustomComponents.c"
	}
#line 99 "../src/CustomComponents.vala"
	if (_tmp0_) {
#line 100 "../src/CustomComponents.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB;
#line 100 "../src/CustomComponents.vala"
		return result;
#line 460 "CustomComponents.c"
	}
#line 102 "../src/CustomComponents.vala"
	if (x > self->priv->right_nub_position) {
#line 102 "../src/CustomComponents.vala"
		_tmp1_ = x < (self->priv->right_nub_position + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE);
#line 466 "CustomComponents.c"
	} else {
#line 102 "../src/CustomComponents.vala"
		_tmp1_ = FALSE;
#line 470 "CustomComponents.c"
	}
#line 102 "../src/CustomComponents.vala"
	if (_tmp1_) {
#line 103 "../src/CustomComponents.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB;
#line 103 "../src/CustomComponents.vala"
		return result;
#line 478 "CustomComponents.c"
	}
#line 105 "../src/CustomComponents.vala"
	if (y < ((RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION + RGB_HISTOGRAM_MANIPULATOR_NUB_V_NUDGE) + 1)) {
#line 106 "../src/CustomComponents.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA;
#line 106 "../src/CustomComponents.vala"
		return result;
#line 486 "CustomComponents.c"
	}
#line 108 "../src/CustomComponents.vala"
	if (((x - self->priv->left_nub_position) * (x - self->priv->left_nub_position)) < ((x - self->priv->right_nub_position) * (x - self->priv->right_nub_position))) {
#line 110 "../src/CustomComponents.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH;
#line 110 "../src/CustomComponents.vala"
		return result;
#line 494 "CustomComponents.c"
	} else {
#line 112 "../src/CustomComponents.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH;
#line 112 "../src/CustomComponents.vala"
		return result;
#line 500 "CustomComponents.c"
	}
}

static gboolean
rgb_histogram_manipulator_on_button_press (RGBHistogramManipulator* self,
                                           GdkEventButton* event_record)
{
	RGBHistogramManipulatorLocationCode loc = 0;
	gboolean result;
#line 115 "../src/CustomComponents.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 115 "../src/CustomComponents.vala"
	g_return_val_if_fail (event_record != NULL, FALSE);
#line 116 "../src/CustomComponents.vala"
	loc = rgb_histogram_manipulator_hit_test_point (self, (gint) event_record->x, (gint) event_record->y);
#line 118 "../src/CustomComponents.vala"
	switch (loc) {
#line 118 "../src/CustomComponents.vala"
		case RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB:
#line 520 "CustomComponents.c"
		{
#line 120 "../src/CustomComponents.vala"
			self->priv->track_start_x = (gint) event_record->x;
#line 121 "../src/CustomComponents.vala"
			self->priv->track_nub_start_position = self->priv->left_nub_position;
#line 122 "../src/CustomComponents.vala"
			self->priv->is_left_nub_tracking = TRUE;
#line 123 "../src/CustomComponents.vala"
			result = TRUE;
#line 123 "../src/CustomComponents.vala"
			return result;
#line 532 "CustomComponents.c"
		}
#line 118 "../src/CustomComponents.vala"
		case RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB:
#line 536 "CustomComponents.c"
		{
#line 126 "../src/CustomComponents.vala"
			self->priv->track_start_x = (gint) event_record->x;
#line 127 "../src/CustomComponents.vala"
			self->priv->track_nub_start_position = self->priv->right_nub_position;
#line 128 "../src/CustomComponents.vala"
			self->priv->is_right_nub_tracking = TRUE;
#line 129 "../src/CustomComponents.vala"
			result = TRUE;
#line 129 "../src/CustomComponents.vala"
			return result;
#line 548 "CustomComponents.c"
		}
#line 118 "../src/CustomComponents.vala"
		case RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH:
#line 552 "CustomComponents.c"
		{
#line 132 "../src/CustomComponents.vala"
			self->priv->left_nub_position = ((gint) event_record->x) - RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH;
#line 133 "../src/CustomComponents.vala"
			self->priv->left_nub_position = CLAMP (self->priv->left_nub_position, 0, self->priv->left_nub_max);
#line 134 "../src/CustomComponents.vala"
			rgb_histogram_manipulator_force_update (self);
#line 135 "../src/CustomComponents.vala"
			g_signal_emit (self, rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL], 0);
#line 136 "../src/CustomComponents.vala"
			rgb_histogram_manipulator_update_nub_extrema (self);
#line 137 "../src/CustomComponents.vala"
			result = TRUE;
#line 137 "../src/CustomComponents.vala"
			return result;
#line 568 "CustomComponents.c"
		}
#line 118 "../src/CustomComponents.vala"
		case RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH:
#line 572 "CustomComponents.c"
		{
#line 140 "../src/CustomComponents.vala"
			self->priv->right_nub_position = ((gint) event_record->x) - RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH;
#line 141 "../src/CustomComponents.vala"
			self->priv->right_nub_position = CLAMP (self->priv->right_nub_position, self->priv->right_nub_min, 255);
#line 142 "../src/CustomComponents.vala"
			rgb_histogram_manipulator_force_update (self);
#line 143 "../src/CustomComponents.vala"
			g_signal_emit (self, rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL], 0);
#line 144 "../src/CustomComponents.vala"
			rgb_histogram_manipulator_update_nub_extrema (self);
#line 145 "../src/CustomComponents.vala"
			result = TRUE;
#line 145 "../src/CustomComponents.vala"
			return result;
#line 588 "CustomComponents.c"
		}
		default:
		{
#line 148 "../src/CustomComponents.vala"
			result = FALSE;
#line 148 "../src/CustomComponents.vala"
			return result;
#line 596 "CustomComponents.c"
		}
	}
}

static gboolean
rgb_histogram_manipulator_on_button_release (RGBHistogramManipulator* self,
                                             GdkEventButton* event_record)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 152 "../src/CustomComponents.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "../src/CustomComponents.vala"
	g_return_val_if_fail (event_record != NULL, FALSE);
#line 153 "../src/CustomComponents.vala"
	if (self->priv->is_left_nub_tracking) {
#line 153 "../src/CustomComponents.vala"
		_tmp0_ = TRUE;
#line 615 "CustomComponents.c"
	} else {
#line 153 "../src/CustomComponents.vala"
		_tmp0_ = self->priv->is_right_nub_tracking;
#line 619 "CustomComponents.c"
	}
#line 153 "../src/CustomComponents.vala"
	if (_tmp0_) {
#line 154 "../src/CustomComponents.vala"
		g_signal_emit (self, rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL], 0);
#line 155 "../src/CustomComponents.vala"
		rgb_histogram_manipulator_update_nub_extrema (self);
#line 627 "CustomComponents.c"
	}
#line 158 "../src/CustomComponents.vala"
	self->priv->is_left_nub_tracking = FALSE;
#line 159 "../src/CustomComponents.vala"
	self->priv->is_right_nub_tracking = FALSE;
#line 161 "../src/CustomComponents.vala"
	result = FALSE;
#line 161 "../src/CustomComponents.vala"
	return result;
#line 637 "CustomComponents.c"
}

static gboolean
rgb_histogram_manipulator_on_button_motion (RGBHistogramManipulator* self,
                                            GdkEventMotion* event_record)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 164 "../src/CustomComponents.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 164 "../src/CustomComponents.vala"
	g_return_val_if_fail (event_record != NULL, FALSE);
#line 165 "../src/CustomComponents.vala"
	if (!self->priv->is_left_nub_tracking) {
#line 165 "../src/CustomComponents.vala"
		_tmp0_ = !self->priv->is_right_nub_tracking;
#line 654 "CustomComponents.c"
	} else {
#line 165 "../src/CustomComponents.vala"
		_tmp0_ = FALSE;
#line 658 "CustomComponents.c"
	}
#line 165 "../src/CustomComponents.vala"
	if (_tmp0_) {
#line 166 "../src/CustomComponents.vala"
		result = FALSE;
#line 166 "../src/CustomComponents.vala"
		return result;
#line 666 "CustomComponents.c"
	}
#line 168 "../src/CustomComponents.vala"
	if (self->priv->is_left_nub_tracking) {
#line 670 "CustomComponents.c"
		gint track_x_delta = 0;
#line 169 "../src/CustomComponents.vala"
		track_x_delta = ((gint) event_record->x) - self->priv->track_start_x;
#line 170 "../src/CustomComponents.vala"
		self->priv->left_nub_position = self->priv->track_nub_start_position + track_x_delta;
#line 171 "../src/CustomComponents.vala"
		self->priv->left_nub_position = CLAMP (self->priv->left_nub_position, 0, self->priv->left_nub_max);
#line 678 "CustomComponents.c"
	} else {
		gint track_x_delta = 0;
#line 173 "../src/CustomComponents.vala"
		track_x_delta = ((gint) event_record->x) - self->priv->track_start_x;
#line 174 "../src/CustomComponents.vala"
		self->priv->right_nub_position = self->priv->track_nub_start_position + track_x_delta;
#line 175 "../src/CustomComponents.vala"
		self->priv->right_nub_position = CLAMP (self->priv->right_nub_position, self->priv->right_nub_min, 255);
#line 687 "CustomComponents.c"
	}
#line 178 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_force_update (self);
#line 179 "../src/CustomComponents.vala"
	result = TRUE;
#line 179 "../src/CustomComponents.vala"
	return result;
#line 695 "CustomComponents.c"
}

static gboolean
rgb_histogram_manipulator_real_draw (GtkWidget* base,
                                     cairo_t* ctx)
{
	RGBHistogramManipulator * self;
	GtkBorder padding = {0};
	GtkStyleContext* _tmp0_;
	GtkBorder _tmp1_ = {0};
	GdkRectangle area = {0};
	GtkBorder _tmp2_;
	GtkBorder _tmp3_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	gboolean result;
#line 182 "../src/CustomComponents.vala"
	self = (RGBHistogramManipulator*) base;
#line 182 "../src/CustomComponents.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 183 "../src/CustomComponents.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 183 "../src/CustomComponents.vala"
	gtk_style_context_get_padding (_tmp0_, GTK_STATE_FLAG_NORMAL, &_tmp1_);
#line 183 "../src/CustomComponents.vala"
	padding = _tmp1_;
#line 185 "../src/CustomComponents.vala"
	memset (&area, 0, sizeof (GdkRectangle));
#line 186 "../src/CustomComponents.vala"
	_tmp2_ = padding;
#line 186 "../src/CustomComponents.vala"
	area.x = (gint) _tmp2_.left;
#line 187 "../src/CustomComponents.vala"
	_tmp3_ = padding;
#line 187 "../src/CustomComponents.vala"
	area.y = (gint) _tmp3_.top;
#line 188 "../src/CustomComponents.vala"
	_tmp4_ = padding;
#line 188 "../src/CustomComponents.vala"
	area.width = RGB_HISTOGRAM_GRAPHIC_WIDTH + _tmp4_.right;
#line 189 "../src/CustomComponents.vala"
	_tmp5_ = padding;
#line 189 "../src/CustomComponents.vala"
	area.height = RGB_HISTOGRAM_GRAPHIC_HEIGHT + _tmp5_.bottom;
#line 191 "../src/CustomComponents.vala"
	_tmp6_ = area;
#line 191 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_draw_histogram_frame (self, ctx, &_tmp6_);
#line 192 "../src/CustomComponents.vala"
	_tmp7_ = area;
#line 192 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_draw_histogram (self, ctx, &_tmp7_);
#line 193 "../src/CustomComponents.vala"
	_tmp8_ = area;
#line 193 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_draw_trough (self, ctx, &_tmp8_);
#line 194 "../src/CustomComponents.vala"
	_tmp9_ = area;
#line 194 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_draw_nub (self, ctx, &_tmp9_, self->priv->left_nub_position);
#line 195 "../src/CustomComponents.vala"
	_tmp10_ = area;
#line 195 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_draw_nub (self, ctx, &_tmp10_, self->priv->right_nub_position);
#line 197 "../src/CustomComponents.vala"
	result = TRUE;
#line 197 "../src/CustomComponents.vala"
	return result;
#line 769 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_draw_histogram_frame (RGBHistogramManipulator* self,
                                                cairo_t* ctx,
                                                GdkRectangle* area)
{
	GdkRectangle framed_area = {0};
	GdkRectangle _tmp0_;
	GtkStyleContext* stylectx = NULL;
	GtkWidget* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkWidgetPath* _tmp4_;
	GtkWidgetPath* _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	GdkRectangle _tmp9_;
#line 200 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/CustomComponents.vala"
	g_return_if_fail (ctx != NULL);
#line 200 "../src/CustomComponents.vala"
	g_return_if_fail (area != NULL);
#line 203 "../src/CustomComponents.vala"
	_tmp0_ = *area;
#line 203 "../src/CustomComponents.vala"
	framed_area = _tmp0_;
#line 204 "../src/CustomComponents.vala"
	framed_area.x = framed_area.x + 5;
#line 205 "../src/CustomComponents.vala"
	framed_area.y = framed_area.y + 1;
#line 206 "../src/CustomComponents.vala"
	framed_area.width = framed_area.width - 8;
#line 207 "../src/CustomComponents.vala"
	framed_area.height = framed_area.height - 12;
#line 209 "../src/CustomComponents.vala"
	_tmp1_ = rgb_histogram_manipulator_dummy_frame;
#line 209 "../src/CustomComponents.vala"
	_tmp2_ = gtk_widget_get_style_context (_tmp1_);
#line 209 "../src/CustomComponents.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 209 "../src/CustomComponents.vala"
	stylectx = _tmp3_;
#line 210 "../src/CustomComponents.vala"
	gtk_style_context_save (stylectx);
#line 212 "../src/CustomComponents.vala"
	_tmp4_ = gtk_style_context_get_path (stylectx);
#line 212 "../src/CustomComponents.vala"
	gtk_widget_path_append_type (_tmp4_, gtk_frame_get_type ());
#line 213 "../src/CustomComponents.vala"
	_tmp5_ = gtk_style_context_get_path (stylectx);
#line 213 "../src/CustomComponents.vala"
	gtk_widget_path_iter_add_class (_tmp5_, 0, "default");
#line 214 "../src/CustomComponents.vala"
	gtk_style_context_add_class (stylectx, GTK_STYLE_CLASS_TROUGH);
#line 215 "../src/CustomComponents.vala"
	gtk_style_context_set_junction_sides (stylectx, ((GTK_JUNCTION_TOP | GTK_JUNCTION_BOTTOM) | GTK_JUNCTION_LEFT) | GTK_JUNCTION_RIGHT);
#line 218 "../src/CustomComponents.vala"
	_tmp6_ = framed_area;
#line 218 "../src/CustomComponents.vala"
	_tmp7_ = framed_area;
#line 218 "../src/CustomComponents.vala"
	_tmp8_ = framed_area;
#line 218 "../src/CustomComponents.vala"
	_tmp9_ = framed_area;
#line 218 "../src/CustomComponents.vala"
	gtk_render_frame (stylectx, ctx, (gdouble) _tmp6_.x, (gdouble) _tmp7_.y, (gdouble) _tmp8_.width, (gdouble) _tmp9_.height);
#line 221 "../src/CustomComponents.vala"
	gtk_style_context_restore (stylectx);
#line 200 "../src/CustomComponents.vala"
	_g_object_unref0 (stylectx);
#line 843 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_draw_histogram (RGBHistogramManipulator* self,
                                          cairo_t* ctx,
                                          GdkRectangle* area)
{
	RGBHistogram* _tmp0_;
	GdkPixbuf* histogram_graphic = NULL;
	RGBHistogram* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	guchar* pixel_data = NULL;
	GdkPixbuf* _tmp6_;
	guint8* _tmp7_;
	gint pixel_data_length1;
	gint _pixel_data_size_;
	gint edge_blend_red = 0;
	gint edge_blend_green = 0;
	gint edge_blend_blue = 0;
	gint body_blend_red = 0;
	gint body_blend_green = 0;
	gint body_blend_blue = 0;
	GdkPixbuf* _tmp90_;
	GdkRectangle _tmp91_;
	GdkRectangle _tmp92_;
#line 224 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/CustomComponents.vala"
	g_return_if_fail (ctx != NULL);
#line 224 "../src/CustomComponents.vala"
	g_return_if_fail (area != NULL);
#line 225 "../src/CustomComponents.vala"
	_tmp0_ = self->priv->histogram;
#line 225 "../src/CustomComponents.vala"
	if (_tmp0_ == NULL) {
#line 226 "../src/CustomComponents.vala"
		return;
#line 884 "CustomComponents.c"
	}
#line 228 "../src/CustomComponents.vala"
	_tmp1_ = self->priv->histogram;
#line 228 "../src/CustomComponents.vala"
	_tmp2_ = rgb_histogram_get_graphic (_tmp1_);
#line 228 "../src/CustomComponents.vala"
	_tmp3_ = _tmp2_;
#line 228 "../src/CustomComponents.vala"
	_tmp4_ = gdk_pixbuf_copy (_tmp3_);
#line 228 "../src/CustomComponents.vala"
	_tmp5_ = _tmp4_;
#line 228 "../src/CustomComponents.vala"
	_g_object_unref0 (_tmp3_);
#line 228 "../src/CustomComponents.vala"
	histogram_graphic = _tmp5_;
#line 229 "../src/CustomComponents.vala"
	_tmp6_ = histogram_graphic;
#line 229 "../src/CustomComponents.vala"
	_tmp7_ = gdk_pixbuf_get_pixels (_tmp6_);
#line 229 "../src/CustomComponents.vala"
	pixel_data = _tmp7_;
#line 229 "../src/CustomComponents.vala"
	pixel_data_length1 = -1;
#line 229 "../src/CustomComponents.vala"
	_pixel_data_size_ = pixel_data_length1;
#line 231 "../src/CustomComponents.vala"
	edge_blend_red = 0;
#line 232 "../src/CustomComponents.vala"
	edge_blend_green = 0;
#line 233 "../src/CustomComponents.vala"
	edge_blend_blue = 0;
#line 234 "../src/CustomComponents.vala"
	body_blend_red = 20;
#line 235 "../src/CustomComponents.vala"
	body_blend_green = 20;
#line 236 "../src/CustomComponents.vala"
	body_blend_blue = 20;
#line 238 "../src/CustomComponents.vala"
	if (self->priv->left_nub_position > 0) {
#line 924 "CustomComponents.c"
		gint edge_pixel_index = 0;
		GdkPixbuf* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 239 "../src/CustomComponents.vala"
		_tmp8_ = histogram_graphic;
#line 239 "../src/CustomComponents.vala"
		_tmp9_ = gdk_pixbuf_get_n_channels (_tmp8_);
#line 239 "../src/CustomComponents.vala"
		_tmp10_ = _tmp9_;
#line 239 "../src/CustomComponents.vala"
		edge_pixel_index = _tmp10_ * self->priv->left_nub_position;
#line 937 "CustomComponents.c"
		{
			gint i = 0;
#line 240 "../src/CustomComponents.vala"
			i = 0;
#line 942 "CustomComponents.c"
			{
				gboolean _tmp11_ = FALSE;
#line 240 "../src/CustomComponents.vala"
				_tmp11_ = TRUE;
#line 240 "../src/CustomComponents.vala"
				while (TRUE) {
#line 949 "CustomComponents.c"
					GdkPixbuf* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					gint body_pixel_index = 0;
					GdkPixbuf* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint row_last_pixel = 0;
					GdkPixbuf* _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					guchar* _tmp34_;
					gint _tmp34__length1;
					guchar* _tmp35_;
					gint _tmp35__length1;
					guchar _tmp36_;
					guchar* _tmp37_;
					gint _tmp37__length1;
					guchar* _tmp38_;
					gint _tmp38__length1;
					guchar _tmp39_;
					guchar* _tmp40_;
					gint _tmp40__length1;
					guchar* _tmp41_;
					gint _tmp41__length1;
					guchar _tmp42_;
					GdkPixbuf* _tmp43_;
					gint _tmp44_;
					gint _tmp45_;
#line 240 "../src/CustomComponents.vala"
					if (!_tmp11_) {
#line 981 "CustomComponents.c"
						gint _tmp12_;
#line 240 "../src/CustomComponents.vala"
						_tmp12_ = i;
#line 240 "../src/CustomComponents.vala"
						i = _tmp12_ + 1;
#line 987 "CustomComponents.c"
					}
#line 240 "../src/CustomComponents.vala"
					_tmp11_ = FALSE;
#line 240 "../src/CustomComponents.vala"
					_tmp13_ = histogram_graphic;
#line 240 "../src/CustomComponents.vala"
					_tmp14_ = gdk_pixbuf_get_height (_tmp13_);
#line 240 "../src/CustomComponents.vala"
					_tmp15_ = _tmp14_;
#line 240 "../src/CustomComponents.vala"
					if (!(i < _tmp15_)) {
#line 240 "../src/CustomComponents.vala"
						break;
#line 1001 "CustomComponents.c"
					}
#line 241 "../src/CustomComponents.vala"
					_tmp16_ = histogram_graphic;
#line 241 "../src/CustomComponents.vala"
					_tmp17_ = gdk_pixbuf_get_rowstride (_tmp16_);
#line 241 "../src/CustomComponents.vala"
					_tmp18_ = _tmp17_;
#line 241 "../src/CustomComponents.vala"
					body_pixel_index = i * _tmp18_;
#line 242 "../src/CustomComponents.vala"
					_tmp19_ = histogram_graphic;
#line 242 "../src/CustomComponents.vala"
					_tmp20_ = gdk_pixbuf_get_n_channels (_tmp19_);
#line 242 "../src/CustomComponents.vala"
					_tmp21_ = _tmp20_;
#line 242 "../src/CustomComponents.vala"
					row_last_pixel = body_pixel_index + (_tmp21_ * self->priv->left_nub_position);
#line 244 "../src/CustomComponents.vala"
					while (TRUE) {
#line 1021 "CustomComponents.c"
						guchar* _tmp22_;
						gint _tmp22__length1;
						guchar* _tmp23_;
						gint _tmp23__length1;
						guchar _tmp24_;
						guchar* _tmp25_;
						gint _tmp25__length1;
						guchar* _tmp26_;
						gint _tmp26__length1;
						guchar _tmp27_;
						guchar* _tmp28_;
						gint _tmp28__length1;
						guchar* _tmp29_;
						gint _tmp29__length1;
						guchar _tmp30_;
						GdkPixbuf* _tmp31_;
						gint _tmp32_;
						gint _tmp33_;
#line 244 "../src/CustomComponents.vala"
						if (!(body_pixel_index < row_last_pixel)) {
#line 244 "../src/CustomComponents.vala"
							break;
#line 1044 "CustomComponents.c"
						}
#line 245 "../src/CustomComponents.vala"
						_tmp22_ = pixel_data;
#line 245 "../src/CustomComponents.vala"
						_tmp22__length1 = pixel_data_length1;
#line 245 "../src/CustomComponents.vala"
						_tmp23_ = pixel_data;
#line 245 "../src/CustomComponents.vala"
						_tmp23__length1 = pixel_data_length1;
#line 245 "../src/CustomComponents.vala"
						_tmp24_ = _tmp23_[body_pixel_index];
#line 245 "../src/CustomComponents.vala"
						_tmp22_[body_pixel_index] = (guchar) ((_tmp24_ + body_blend_red) / 2);
#line 247 "../src/CustomComponents.vala"
						_tmp25_ = pixel_data;
#line 247 "../src/CustomComponents.vala"
						_tmp25__length1 = pixel_data_length1;
#line 247 "../src/CustomComponents.vala"
						_tmp26_ = pixel_data;
#line 247 "../src/CustomComponents.vala"
						_tmp26__length1 = pixel_data_length1;
#line 247 "../src/CustomComponents.vala"
						_tmp27_ = _tmp26_[body_pixel_index + 1];
#line 247 "../src/CustomComponents.vala"
						_tmp25_[body_pixel_index + 1] = (guchar) ((_tmp27_ + body_blend_green) / 2);
#line 249 "../src/CustomComponents.vala"
						_tmp28_ = pixel_data;
#line 249 "../src/CustomComponents.vala"
						_tmp28__length1 = pixel_data_length1;
#line 249 "../src/CustomComponents.vala"
						_tmp29_ = pixel_data;
#line 249 "../src/CustomComponents.vala"
						_tmp29__length1 = pixel_data_length1;
#line 249 "../src/CustomComponents.vala"
						_tmp30_ = _tmp29_[body_pixel_index + 2];
#line 249 "../src/CustomComponents.vala"
						_tmp28_[body_pixel_index + 2] = (guchar) ((_tmp30_ + body_blend_blue) / 2);
#line 252 "../src/CustomComponents.vala"
						_tmp31_ = histogram_graphic;
#line 252 "../src/CustomComponents.vala"
						_tmp32_ = gdk_pixbuf_get_n_channels (_tmp31_);
#line 252 "../src/CustomComponents.vala"
						_tmp33_ = _tmp32_;
#line 252 "../src/CustomComponents.vala"
						body_pixel_index += _tmp33_;
#line 1090 "CustomComponents.c"
					}
#line 255 "../src/CustomComponents.vala"
					_tmp34_ = pixel_data;
#line 255 "../src/CustomComponents.vala"
					_tmp34__length1 = pixel_data_length1;
#line 255 "../src/CustomComponents.vala"
					_tmp35_ = pixel_data;
#line 255 "../src/CustomComponents.vala"
					_tmp35__length1 = pixel_data_length1;
#line 255 "../src/CustomComponents.vala"
					_tmp36_ = _tmp35_[edge_pixel_index];
#line 255 "../src/CustomComponents.vala"
					_tmp34_[edge_pixel_index] = (guchar) ((_tmp36_ + edge_blend_red) / 2);
#line 257 "../src/CustomComponents.vala"
					_tmp37_ = pixel_data;
#line 257 "../src/CustomComponents.vala"
					_tmp37__length1 = pixel_data_length1;
#line 257 "../src/CustomComponents.vala"
					_tmp38_ = pixel_data;
#line 257 "../src/CustomComponents.vala"
					_tmp38__length1 = pixel_data_length1;
#line 257 "../src/CustomComponents.vala"
					_tmp39_ = _tmp38_[edge_pixel_index + 1];
#line 257 "../src/CustomComponents.vala"
					_tmp37_[edge_pixel_index + 1] = (guchar) ((_tmp39_ + edge_blend_green) / 2);
#line 259 "../src/CustomComponents.vala"
					_tmp40_ = pixel_data;
#line 259 "../src/CustomComponents.vala"
					_tmp40__length1 = pixel_data_length1;
#line 259 "../src/CustomComponents.vala"
					_tmp41_ = pixel_data;
#line 259 "../src/CustomComponents.vala"
					_tmp41__length1 = pixel_data_length1;
#line 259 "../src/CustomComponents.vala"
					_tmp42_ = _tmp41_[edge_pixel_index + 2];
#line 259 "../src/CustomComponents.vala"
					_tmp40_[edge_pixel_index + 2] = (guchar) ((_tmp42_ + edge_blend_blue) / 2);
#line 262 "../src/CustomComponents.vala"
					_tmp43_ = histogram_graphic;
#line 262 "../src/CustomComponents.vala"
					_tmp44_ = gdk_pixbuf_get_rowstride (_tmp43_);
#line 262 "../src/CustomComponents.vala"
					_tmp45_ = _tmp44_;
#line 262 "../src/CustomComponents.vala"
					edge_pixel_index += _tmp45_;
#line 1136 "CustomComponents.c"
				}
			}
		}
	}
#line 266 "../src/CustomComponents.vala"
	edge_blend_red = 250;
#line 267 "../src/CustomComponents.vala"
	edge_blend_green = 250;
#line 268 "../src/CustomComponents.vala"
	edge_blend_blue = 250;
#line 269 "../src/CustomComponents.vala"
	body_blend_red = 200;
#line 270 "../src/CustomComponents.vala"
	body_blend_green = 200;
#line 271 "../src/CustomComponents.vala"
	body_blend_blue = 200;
#line 273 "../src/CustomComponents.vala"
	if (self->priv->right_nub_position < 255) {
#line 1155 "CustomComponents.c"
		gint edge_pixel_index = 0;
		GdkPixbuf* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
#line 274 "../src/CustomComponents.vala"
		_tmp46_ = histogram_graphic;
#line 274 "../src/CustomComponents.vala"
		_tmp47_ = gdk_pixbuf_get_n_channels (_tmp46_);
#line 274 "../src/CustomComponents.vala"
		_tmp48_ = _tmp47_;
#line 274 "../src/CustomComponents.vala"
		edge_pixel_index = _tmp48_ * self->priv->right_nub_position;
#line 1168 "CustomComponents.c"
		{
			gint i = 0;
#line 275 "../src/CustomComponents.vala"
			i = 0;
#line 1173 "CustomComponents.c"
			{
				gboolean _tmp49_ = FALSE;
#line 275 "../src/CustomComponents.vala"
				_tmp49_ = TRUE;
#line 275 "../src/CustomComponents.vala"
				while (TRUE) {
#line 1180 "CustomComponents.c"
					GdkPixbuf* _tmp51_;
					gint _tmp52_;
					gint _tmp53_;
					gint body_pixel_index = 0;
					GdkPixbuf* _tmp54_;
					gint _tmp55_;
					gint _tmp56_;
					GdkPixbuf* _tmp57_;
					gint _tmp58_;
					gint _tmp59_;
					gint row_last_pixel = 0;
					GdkPixbuf* _tmp60_;
					gint _tmp61_;
					gint _tmp62_;
					GdkPixbuf* _tmp63_;
					gint _tmp64_;
					gint _tmp65_;
					guchar* _tmp78_;
					gint _tmp78__length1;
					guchar* _tmp79_;
					gint _tmp79__length1;
					guchar _tmp80_;
					guchar* _tmp81_;
					gint _tmp81__length1;
					guchar* _tmp82_;
					gint _tmp82__length1;
					guchar _tmp83_;
					guchar* _tmp84_;
					gint _tmp84__length1;
					guchar* _tmp85_;
					gint _tmp85__length1;
					guchar _tmp86_;
					GdkPixbuf* _tmp87_;
					gint _tmp88_;
					gint _tmp89_;
#line 275 "../src/CustomComponents.vala"
					if (!_tmp49_) {
#line 1218 "CustomComponents.c"
						gint _tmp50_;
#line 275 "../src/CustomComponents.vala"
						_tmp50_ = i;
#line 275 "../src/CustomComponents.vala"
						i = _tmp50_ + 1;
#line 1224 "CustomComponents.c"
					}
#line 275 "../src/CustomComponents.vala"
					_tmp49_ = FALSE;
#line 275 "../src/CustomComponents.vala"
					_tmp51_ = histogram_graphic;
#line 275 "../src/CustomComponents.vala"
					_tmp52_ = gdk_pixbuf_get_height (_tmp51_);
#line 275 "../src/CustomComponents.vala"
					_tmp53_ = _tmp52_;
#line 275 "../src/CustomComponents.vala"
					if (!(i < _tmp53_)) {
#line 275 "../src/CustomComponents.vala"
						break;
#line 1238 "CustomComponents.c"
					}
#line 276 "../src/CustomComponents.vala"
					_tmp54_ = histogram_graphic;
#line 276 "../src/CustomComponents.vala"
					_tmp55_ = gdk_pixbuf_get_rowstride (_tmp54_);
#line 276 "../src/CustomComponents.vala"
					_tmp56_ = _tmp55_;
#line 276 "../src/CustomComponents.vala"
					_tmp57_ = histogram_graphic;
#line 276 "../src/CustomComponents.vala"
					_tmp58_ = gdk_pixbuf_get_n_channels (_tmp57_);
#line 276 "../src/CustomComponents.vala"
					_tmp59_ = _tmp58_;
#line 276 "../src/CustomComponents.vala"
					body_pixel_index = (i * _tmp56_) + (_tmp59_ * 255);
#line 278 "../src/CustomComponents.vala"
					_tmp60_ = histogram_graphic;
#line 278 "../src/CustomComponents.vala"
					_tmp61_ = gdk_pixbuf_get_rowstride (_tmp60_);
#line 278 "../src/CustomComponents.vala"
					_tmp62_ = _tmp61_;
#line 278 "../src/CustomComponents.vala"
					_tmp63_ = histogram_graphic;
#line 278 "../src/CustomComponents.vala"
					_tmp64_ = gdk_pixbuf_get_n_channels (_tmp63_);
#line 278 "../src/CustomComponents.vala"
					_tmp65_ = _tmp64_;
#line 278 "../src/CustomComponents.vala"
					row_last_pixel = (i * _tmp62_) + (_tmp65_ * self->priv->right_nub_position);
#line 280 "../src/CustomComponents.vala"
					while (TRUE) {
#line 1270 "CustomComponents.c"
						guchar* _tmp66_;
						gint _tmp66__length1;
						guchar* _tmp67_;
						gint _tmp67__length1;
						guchar _tmp68_;
						guchar* _tmp69_;
						gint _tmp69__length1;
						guchar* _tmp70_;
						gint _tmp70__length1;
						guchar _tmp71_;
						guchar* _tmp72_;
						gint _tmp72__length1;
						guchar* _tmp73_;
						gint _tmp73__length1;
						guchar _tmp74_;
						GdkPixbuf* _tmp75_;
						gint _tmp76_;
						gint _tmp77_;
#line 280 "../src/CustomComponents.vala"
						if (!(body_pixel_index > row_last_pixel)) {
#line 280 "../src/CustomComponents.vala"
							break;
#line 1293 "CustomComponents.c"
						}
#line 281 "../src/CustomComponents.vala"
						_tmp66_ = pixel_data;
#line 281 "../src/CustomComponents.vala"
						_tmp66__length1 = pixel_data_length1;
#line 281 "../src/CustomComponents.vala"
						_tmp67_ = pixel_data;
#line 281 "../src/CustomComponents.vala"
						_tmp67__length1 = pixel_data_length1;
#line 281 "../src/CustomComponents.vala"
						_tmp68_ = _tmp67_[body_pixel_index];
#line 281 "../src/CustomComponents.vala"
						_tmp66_[body_pixel_index] = (guchar) ((_tmp68_ + body_blend_red) / 2);
#line 283 "../src/CustomComponents.vala"
						_tmp69_ = pixel_data;
#line 283 "../src/CustomComponents.vala"
						_tmp69__length1 = pixel_data_length1;
#line 283 "../src/CustomComponents.vala"
						_tmp70_ = pixel_data;
#line 283 "../src/CustomComponents.vala"
						_tmp70__length1 = pixel_data_length1;
#line 283 "../src/CustomComponents.vala"
						_tmp71_ = _tmp70_[body_pixel_index + 1];
#line 283 "../src/CustomComponents.vala"
						_tmp69_[body_pixel_index + 1] = (guchar) ((_tmp71_ + body_blend_green) / 2);
#line 285 "../src/CustomComponents.vala"
						_tmp72_ = pixel_data;
#line 285 "../src/CustomComponents.vala"
						_tmp72__length1 = pixel_data_length1;
#line 285 "../src/CustomComponents.vala"
						_tmp73_ = pixel_data;
#line 285 "../src/CustomComponents.vala"
						_tmp73__length1 = pixel_data_length1;
#line 285 "../src/CustomComponents.vala"
						_tmp74_ = _tmp73_[body_pixel_index + 2];
#line 285 "../src/CustomComponents.vala"
						_tmp72_[body_pixel_index + 2] = (guchar) ((_tmp74_ + body_blend_blue) / 2);
#line 288 "../src/CustomComponents.vala"
						_tmp75_ = histogram_graphic;
#line 288 "../src/CustomComponents.vala"
						_tmp76_ = gdk_pixbuf_get_n_channels (_tmp75_);
#line 288 "../src/CustomComponents.vala"
						_tmp77_ = _tmp76_;
#line 288 "../src/CustomComponents.vala"
						body_pixel_index -= _tmp77_;
#line 1339 "CustomComponents.c"
					}
#line 290 "../src/CustomComponents.vala"
					_tmp78_ = pixel_data;
#line 290 "../src/CustomComponents.vala"
					_tmp78__length1 = pixel_data_length1;
#line 290 "../src/CustomComponents.vala"
					_tmp79_ = pixel_data;
#line 290 "../src/CustomComponents.vala"
					_tmp79__length1 = pixel_data_length1;
#line 290 "../src/CustomComponents.vala"
					_tmp80_ = _tmp79_[edge_pixel_index];
#line 290 "../src/CustomComponents.vala"
					_tmp78_[edge_pixel_index] = (guchar) ((_tmp80_ + edge_blend_red) / 2);
#line 292 "../src/CustomComponents.vala"
					_tmp81_ = pixel_data;
#line 292 "../src/CustomComponents.vala"
					_tmp81__length1 = pixel_data_length1;
#line 292 "../src/CustomComponents.vala"
					_tmp82_ = pixel_data;
#line 292 "../src/CustomComponents.vala"
					_tmp82__length1 = pixel_data_length1;
#line 292 "../src/CustomComponents.vala"
					_tmp83_ = _tmp82_[edge_pixel_index + 1];
#line 292 "../src/CustomComponents.vala"
					_tmp81_[edge_pixel_index + 1] = (guchar) ((_tmp83_ + edge_blend_green) / 2);
#line 294 "../src/CustomComponents.vala"
					_tmp84_ = pixel_data;
#line 294 "../src/CustomComponents.vala"
					_tmp84__length1 = pixel_data_length1;
#line 294 "../src/CustomComponents.vala"
					_tmp85_ = pixel_data;
#line 294 "../src/CustomComponents.vala"
					_tmp85__length1 = pixel_data_length1;
#line 294 "../src/CustomComponents.vala"
					_tmp86_ = _tmp85_[edge_pixel_index + 2];
#line 294 "../src/CustomComponents.vala"
					_tmp84_[edge_pixel_index + 2] = (guchar) ((_tmp86_ + edge_blend_blue) / 2);
#line 297 "../src/CustomComponents.vala"
					_tmp87_ = histogram_graphic;
#line 297 "../src/CustomComponents.vala"
					_tmp88_ = gdk_pixbuf_get_rowstride (_tmp87_);
#line 297 "../src/CustomComponents.vala"
					_tmp89_ = _tmp88_;
#line 297 "../src/CustomComponents.vala"
					edge_pixel_index += _tmp89_;
#line 1385 "CustomComponents.c"
				}
			}
		}
	}
#line 301 "../src/CustomComponents.vala"
	_tmp90_ = histogram_graphic;
#line 301 "../src/CustomComponents.vala"
	_tmp91_ = *area;
#line 301 "../src/CustomComponents.vala"
	_tmp92_ = *area;
#line 301 "../src/CustomComponents.vala"
	gdk_cairo_set_source_pixbuf (ctx, _tmp90_, (gdouble) (_tmp91_.x + RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH), (gdouble) (_tmp92_.y + 2));
#line 302 "../src/CustomComponents.vala"
	cairo_paint (ctx);
#line 224 "../src/CustomComponents.vala"
	_g_object_unref0 (histogram_graphic);
#line 1402 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_draw_trough (RGBHistogramManipulator* self,
                                       cairo_t* ctx,
                                       GdkRectangle* area)
{
	gint trough_x = 0;
	GdkRectangle _tmp0_;
	gint trough_y = 0;
	GdkRectangle _tmp1_;
	GtkStyleContext* stylectx = NULL;
	GtkWidget* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkWidgetPath* _tmp5_;
	GtkWidgetPath* _tmp6_;
#line 305 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/CustomComponents.vala"
	g_return_if_fail (ctx != NULL);
#line 305 "../src/CustomComponents.vala"
	g_return_if_fail (area != NULL);
#line 306 "../src/CustomComponents.vala"
	_tmp0_ = *area;
#line 306 "../src/CustomComponents.vala"
	trough_x = _tmp0_.x;
#line 307 "../src/CustomComponents.vala"
	_tmp1_ = *area;
#line 307 "../src/CustomComponents.vala"
	trough_y = _tmp1_.y + (((RGB_HISTOGRAM_MANIPULATOR_CONTROL_HEIGHT - RGB_HISTOGRAM_MANIPULATOR_TROUGH_HEIGHT) - RGB_HISTOGRAM_MANIPULATOR_TROUGH_BOTTOM_OFFSET) - 3);
#line 309 "../src/CustomComponents.vala"
	_tmp2_ = rgb_histogram_manipulator_dummy_slider;
#line 309 "../src/CustomComponents.vala"
	_tmp3_ = gtk_widget_get_style_context (_tmp2_);
#line 309 "../src/CustomComponents.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 309 "../src/CustomComponents.vala"
	stylectx = _tmp4_;
#line 310 "../src/CustomComponents.vala"
	gtk_style_context_save (stylectx);
#line 312 "../src/CustomComponents.vala"
	_tmp5_ = gtk_style_context_get_path (stylectx);
#line 312 "../src/CustomComponents.vala"
	gtk_widget_path_append_type (_tmp5_, gtk_scale_get_type ());
#line 313 "../src/CustomComponents.vala"
	_tmp6_ = gtk_style_context_get_path (stylectx);
#line 313 "../src/CustomComponents.vala"
	gtk_widget_path_iter_add_class (_tmp6_, 0, "scale");
#line 314 "../src/CustomComponents.vala"
	gtk_style_context_add_class (stylectx, GTK_STYLE_CLASS_TROUGH);
#line 316 "../src/CustomComponents.vala"
	gtk_render_activity (stylectx, ctx, (gdouble) trough_x, (gdouble) trough_y, (gdouble) RGB_HISTOGRAM_MANIPULATOR_TROUGH_WIDTH, (gdouble) RGB_HISTOGRAM_MANIPULATOR_TROUGH_HEIGHT);
#line 318 "../src/CustomComponents.vala"
	gtk_style_context_restore (stylectx);
#line 305 "../src/CustomComponents.vala"
	_g_object_unref0 (stylectx);
#line 1460 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_draw_nub (RGBHistogramManipulator* self,
                                    cairo_t* ctx,
                                    GdkRectangle* area,
                                    gint position)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
#line 321 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/CustomComponents.vala"
	g_return_if_fail (ctx != NULL);
#line 321 "../src/CustomComponents.vala"
	g_return_if_fail (area != NULL);
#line 322 "../src/CustomComponents.vala"
	_tmp0_ = rgb_histogram_manipulator_get_drag_nub_pixbuf (self);
#line 322 "../src/CustomComponents.vala"
	_tmp1_ = _tmp0_;
#line 322 "../src/CustomComponents.vala"
	_tmp2_ = *area;
#line 322 "../src/CustomComponents.vala"
	_tmp3_ = *area;
#line 322 "../src/CustomComponents.vala"
	gdk_cairo_set_source_pixbuf (ctx, _tmp1_, (gdouble) (_tmp2_.x + position), (gdouble) (_tmp3_.y + RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION));
#line 322 "../src/CustomComponents.vala"
	_g_object_unref0 (_tmp1_);
#line 323 "../src/CustomComponents.vala"
	cairo_paint (ctx);
#line 1493 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_force_update (RGBHistogramManipulator* self)
{
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
#line 326 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 327 "../src/CustomComponents.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 327 "../src/CustomComponents.vala"
	gdk_window_invalidate_rect (_tmp0_, NULL, TRUE);
#line 328 "../src/CustomComponents.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 328 "../src/CustomComponents.vala"
	gdk_window_process_updates (_tmp1_, TRUE);
#line 1511 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_update_nub_extrema (RGBHistogramManipulator* self)
{
#line 331 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/CustomComponents.vala"
	self->priv->right_nub_min = (self->priv->left_nub_position + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE) + 1;
#line 333 "../src/CustomComponents.vala"
	self->priv->left_nub_max = (self->priv->right_nub_position - RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE) - 1;
#line 1523 "CustomComponents.c"
}

void
rgb_histogram_manipulator_update_histogram (RGBHistogramManipulator* self,
                                            GdkPixbuf* source_pixbuf)
{
	RGBHistogram* _tmp0_;
#line 338 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 338 "../src/CustomComponents.vala"
	g_return_if_fail (source_pixbuf != NULL);
#line 339 "../src/CustomComponents.vala"
	_tmp0_ = rgb_histogram_new (source_pixbuf);
#line 339 "../src/CustomComponents.vala"
	_rgb_histogram_unref0 (self->priv->histogram);
#line 339 "../src/CustomComponents.vala"
	self->priv->histogram = _tmp0_;
#line 340 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_force_update (self);
#line 1543 "CustomComponents.c"
}

gint
rgb_histogram_manipulator_get_left_nub_position (RGBHistogramManipulator* self)
{
	gint result;
#line 343 "../src/CustomComponents.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 344 "../src/CustomComponents.vala"
	result = self->priv->left_nub_position;
#line 344 "../src/CustomComponents.vala"
	return result;
#line 1556 "CustomComponents.c"
}

gint
rgb_histogram_manipulator_get_right_nub_position (RGBHistogramManipulator* self)
{
	gint result;
#line 347 "../src/CustomComponents.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 348 "../src/CustomComponents.vala"
	result = self->priv->right_nub_position;
#line 348 "../src/CustomComponents.vala"
	return result;
#line 1569 "CustomComponents.c"
}

void
rgb_histogram_manipulator_set_left_nub_position (RGBHistogramManipulator* self,
                                                 gint user_nub_pos)
{
	gboolean _tmp0_ = FALSE;
#line 351 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 352 "../src/CustomComponents.vala"
	if (user_nub_pos >= 0) {
#line 352 "../src/CustomComponents.vala"
		_tmp0_ = user_nub_pos <= 255;
#line 1583 "CustomComponents.c"
	} else {
#line 352 "../src/CustomComponents.vala"
		_tmp0_ = FALSE;
#line 1587 "CustomComponents.c"
	}
#line 352 "../src/CustomComponents.vala"
	_vala_assert (_tmp0_, "(user_nub_pos >= 0) && (user_nub_pos <= 255)");
#line 353 "../src/CustomComponents.vala"
	self->priv->left_nub_position = CLAMP (user_nub_pos, 0, self->priv->left_nub_max);
#line 354 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_update_nub_extrema (self);
#line 1595 "CustomComponents.c"
}

void
rgb_histogram_manipulator_set_right_nub_position (RGBHistogramManipulator* self,
                                                  gint user_nub_pos)
{
	gboolean _tmp0_ = FALSE;
#line 357 "../src/CustomComponents.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/CustomComponents.vala"
	if (user_nub_pos >= 0) {
#line 358 "../src/CustomComponents.vala"
		_tmp0_ = user_nub_pos <= 255;
#line 1609 "CustomComponents.c"
	} else {
#line 358 "../src/CustomComponents.vala"
		_tmp0_ = FALSE;
#line 1613 "CustomComponents.c"
	}
#line 358 "../src/CustomComponents.vala"
	_vala_assert (_tmp0_, "(user_nub_pos >= 0) && (user_nub_pos <= 255)");
#line 359 "../src/CustomComponents.vala"
	self->priv->right_nub_position = CLAMP (user_nub_pos, self->priv->right_nub_min, 255);
#line 360 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_update_nub_extrema (self);
#line 1621 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_class_init (RGBHistogramManipulatorClass * klass,
                                      gpointer klass_data)
{
	GtkWidgetPath* _tmp0_;
	GtkWidgetPath* _tmp1_;
#line 21 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/CustomComponents.vala"
	g_type_class_adjust_private_offset (klass, &RGBHistogramManipulator_private_offset);
#line 21 "../src/CustomComponents.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) rgb_histogram_manipulator_real_draw;
#line 21 "../src/CustomComponents.vala"
	G_OBJECT_CLASS (klass)->finalize = rgb_histogram_manipulator_finalize;
#line 21 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL] = g_signal_new ("nub-position-changed", TYPE_RGB_HISTOGRAM_MANIPULATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 40 "../src/CustomComponents.vala"
	_tmp0_ = gtk_widget_path_new ();
#line 40 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_slider_draw_path = _tmp0_;
#line 41 "../src/CustomComponents.vala"
	_tmp1_ = gtk_widget_path_new ();
#line 41 "../src/CustomComponents.vala"
	rgb_histogram_manipulator_frame_draw_path = _tmp1_;
#line 1648 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_instance_init (RGBHistogramManipulator * self,
                                         gpointer klass)
{
#line 21 "../src/CustomComponents.vala"
	self->priv = rgb_histogram_manipulator_get_instance_private (self);
#line 35 "../src/CustomComponents.vala"
	self->priv->left_nub_max = (255 - RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE) - 1;
#line 36 "../src/CustomComponents.vala"
	self->priv->right_nub_min = RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE + 1;
#line 44 "../src/CustomComponents.vala"
	self->priv->histogram = NULL;
#line 45 "../src/CustomComponents.vala"
	self->priv->left_nub_position = 0;
#line 46 "../src/CustomComponents.vala"
	self->priv->right_nub_position = 255;
#line 47 "../src/CustomComponents.vala"
	self->priv->is_left_nub_tracking = FALSE;
#line 48 "../src/CustomComponents.vala"
	self->priv->is_right_nub_tracking = FALSE;
#line 49 "../src/CustomComponents.vala"
	self->priv->track_start_x = 0;
#line 50 "../src/CustomComponents.vala"
	self->priv->track_nub_start_position = 0;
#line 52 "../src/CustomComponents.vala"
	self->priv->drag_nub_pixbuf = NULL;
#line 1677 "CustomComponents.c"
}

static void
rgb_histogram_manipulator_finalize (GObject * obj)
{
	RGBHistogramManipulator * self;
#line 21 "../src/CustomComponents.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulator);
#line 44 "../src/CustomComponents.vala"
	_rgb_histogram_unref0 (self->priv->histogram);
#line 52 "../src/CustomComponents.vala"
	_g_object_unref0 (self->priv->drag_nub_pixbuf);
#line 21 "../src/CustomComponents.vala"
	G_OBJECT_CLASS (rgb_histogram_manipulator_parent_class)->finalize (obj);
#line 1692 "CustomComponents.c"
}

static GType
rgb_histogram_manipulator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RGBHistogramManipulatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rgb_histogram_manipulator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RGBHistogramManipulator), 0, (GInstanceInitFunc) rgb_histogram_manipulator_instance_init, NULL };
	GType rgb_histogram_manipulator_type_id;
	rgb_histogram_manipulator_type_id = g_type_register_static (gtk_drawing_area_get_type (), "RGBHistogramManipulator", &g_define_type_info, 0);
	RGBHistogramManipulator_private_offset = g_type_add_instance_private (rgb_histogram_manipulator_type_id, sizeof (RGBHistogramManipulatorPrivate));
	return rgb_histogram_manipulator_type_id;
}

GType
rgb_histogram_manipulator_get_type (void)
{
	static volatile gsize rgb_histogram_manipulator_type_id__once = 0;
	if (g_once_init_enter (&rgb_histogram_manipulator_type_id__once)) {
		GType rgb_histogram_manipulator_type_id;
		rgb_histogram_manipulator_type_id = rgb_histogram_manipulator_get_type_once ();
		g_once_init_leave (&rgb_histogram_manipulator_type_id__once, rgb_histogram_manipulator_type_id);
	}
	return rgb_histogram_manipulator_type_id__once;
}

