/* AdjustDateTimeDialog.c generated by valac 0.56.18, the Vala compiler
 * generated from AdjustDateTimeDialog.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2017-2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define ADJUST_DATE_TIME_DIALOG_SECONDS_IN_DAY ((gint64) ((60 * 60) * 24))
#define ADJUST_DATE_TIME_DIALOG_SECONDS_IN_HOUR ((gint64) (60 * 60))
#define ADJUST_DATE_TIME_DIALOG_SECONDS_IN_MINUTE ((gint64) 60)
#define ADJUST_DATE_TIME_DIALOG_CALENDAR_THUMBNAIL_SCALE 1
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_AM,
	ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_PM,
	ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_24HR
} AdjustDateTimeDialogTimeSystem;

#define ADJUST_DATE_TIME_DIALOG_TYPE_TIME_SYSTEM (adjust_date_time_dialog_time_system_get_type ())
enum  {
	ADJUST_DATE_TIME_DIALOG_0_PROPERTY,
	ADJUST_DATE_TIME_DIALOG_NUM_PROPERTIES
};
static GParamSpec* adjust_date_time_dialog_properties[ADJUST_DATE_TIME_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _AdjustDateTimeDialogPrivate {
	gboolean no_original_time;
	gint64 original_time;
	GtkLabel* original_time_label;
	GtkCalendar* calendar;
	GtkSpinButton* hour;
	GtkSpinButton* minute;
	GtkSpinButton* second;
	GtkComboBoxText* system;
	GtkRadioButton* relativity_radio_button;
	GtkRadioButton* batch_radio_button;
	GtkCheckButton* modify_originals_check_button;
	GtkLabel* notification;
	GSettings* ui_settings;
	GSettings* file_settings;
	AdjustDateTimeDialogTimeSystem previous_time_system;
};

static gint AdjustDateTimeDialog_private_offset;
static gpointer adjust_date_time_dialog_parent_class = NULL;

static GType adjust_date_time_dialog_time_system_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void adjust_date_time_dialog_on_time_changed (AdjustDateTimeDialog* self);
static void _adjust_date_time_dialog_on_time_changed_gtk_calendar_day_selected (GtkCalendar* _sender,
                                                                         gpointer self);
static void _adjust_date_time_dialog_on_time_changed_gtk_calendar_month_changed (GtkCalendar* _sender,
                                                                          gpointer self);
static void _adjust_date_time_dialog_on_time_changed_gtk_calendar_next_year (GtkCalendar* _sender,
                                                                      gpointer self);
static void _adjust_date_time_dialog_on_time_changed_gtk_calendar_prev_year (GtkCalendar* _sender,
                                                                      gpointer self);
static gboolean adjust_date_time_dialog_on_spin_button_output (AdjustDateTimeDialog* self,
                                                        GtkSpinButton* button);
static gboolean _adjust_date_time_dialog_on_spin_button_output_gtk_spin_button_output (GtkSpinButton* _sender,
                                                                                gpointer self);
static void adjust_date_time_dialog_on_time_system_changed (AdjustDateTimeDialog* self);
static void _adjust_date_time_dialog_on_time_system_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                            gpointer self);
static void _adjust_date_time_dialog_on_time_changed_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                         gpointer self);
static void adjust_date_time_dialog_set_time (AdjustDateTimeDialog* self,
                                       GDateTime* time);
static void adjust_date_time_dialog_set_original_time_label (AdjustDateTimeDialog* self,
                                                      gboolean use_24_hr_format);
static gint64 adjust_date_time_dialog_get_time (AdjustDateTimeDialog* self);
static GObject * adjust_date_time_dialog_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void adjust_date_time_dialog_finalize (GObject * obj);
static GType adjust_date_time_dialog_get_type_once (void);

static inline gpointer
adjust_date_time_dialog_get_instance_private (AdjustDateTimeDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AdjustDateTimeDialog_private_offset);
}

static GType
adjust_date_time_dialog_time_system_get_type_once (void)
{
	static const GEnumValue values[] = {{ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_AM, "ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_AM", "am"}, {ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_PM, "ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_PM", "pm"}, {ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_24HR, "ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_24HR", "24hr"}, {0, NULL, NULL}};
	GType adjust_date_time_dialog_time_system_type_id;
	adjust_date_time_dialog_time_system_type_id = g_enum_register_static ("AdjustDateTimeDialogTimeSystem", values);
	return adjust_date_time_dialog_time_system_type_id;
}

static GType
adjust_date_time_dialog_time_system_get_type (void)
{
	static volatile gsize adjust_date_time_dialog_time_system_type_id__once = 0;
	if (g_once_init_enter (&adjust_date_time_dialog_time_system_type_id__once)) {
		GType adjust_date_time_dialog_time_system_type_id;
		adjust_date_time_dialog_time_system_type_id = adjust_date_time_dialog_time_system_get_type_once ();
		g_once_init_leave (&adjust_date_time_dialog_time_system_type_id__once, adjust_date_time_dialog_time_system_type_id);
	}
	return adjust_date_time_dialog_time_system_type_id__once;
}

static void
_adjust_date_time_dialog_on_time_changed_gtk_calendar_day_selected (GtkCalendar* _sender,
                                                                    gpointer self)
{
#line 73 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_on_time_changed ((AdjustDateTimeDialog*) self);
#line 156 "AdjustDateTimeDialog.c"
}

static void
_adjust_date_time_dialog_on_time_changed_gtk_calendar_month_changed (GtkCalendar* _sender,
                                                                     gpointer self)
{
#line 74 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_on_time_changed ((AdjustDateTimeDialog*) self);
#line 165 "AdjustDateTimeDialog.c"
}

static void
_adjust_date_time_dialog_on_time_changed_gtk_calendar_next_year (GtkCalendar* _sender,
                                                                 gpointer self)
{
#line 75 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_on_time_changed ((AdjustDateTimeDialog*) self);
#line 174 "AdjustDateTimeDialog.c"
}

static void
_adjust_date_time_dialog_on_time_changed_gtk_calendar_prev_year (GtkCalendar* _sender,
                                                                 gpointer self)
{
#line 76 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_on_time_changed ((AdjustDateTimeDialog*) self);
#line 183 "AdjustDateTimeDialog.c"
}

static gboolean
_adjust_date_time_dialog_on_spin_button_output_gtk_spin_button_output (GtkSpinButton* _sender,
                                                                       gpointer self)
{
	gboolean result;
	result = adjust_date_time_dialog_on_spin_button_output ((AdjustDateTimeDialog*) self, _sender);
#line 83 "../src/Dialogs/AdjustDateTimeDialog.vala"
	return result;
#line 194 "AdjustDateTimeDialog.c"
}

static void
_adjust_date_time_dialog_on_time_system_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self)
{
#line 98 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_on_time_system_changed ((AdjustDateTimeDialog*) self);
#line 203 "AdjustDateTimeDialog.c"
}

static void
_adjust_date_time_dialog_on_time_changed_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                    gpointer self)
{
#line 109 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_on_time_changed ((AdjustDateTimeDialog*) self);
#line 212 "AdjustDateTimeDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 220 "AdjustDateTimeDialog.c"
}

AdjustDateTimeDialog*
adjust_date_time_dialog_construct (GType object_type,
                                   Dateable* source,
                                   gint photo_count,
                                   gboolean display_options,
                                   gboolean contains_video,
                                   gboolean only_video)
{
	AdjustDateTimeDialog * self = NULL;
	GtkCalendar* _tmp0_;
	GtkCalendar* _tmp1_;
	GtkCalendar* _tmp2_;
	GtkCalendar* _tmp3_;
	GtkCalendar* _tmp4_;
	GSettings* _tmp5_;
	GtkSpinButton* _tmp8_;
	GtkSpinButton* _tmp9_;
	GtkSpinButton* _tmp10_;
	GtkSpinButton* _tmp11_;
	GtkSpinButton* _tmp12_;
	GtkSpinButton* _tmp13_;
	GtkSpinButton* _tmp14_;
	GtkSpinButton* _tmp15_;
	GtkComboBoxText* _tmp16_;
	GtkComboBoxText* _tmp17_;
	GtkComboBoxText* _tmp18_;
	GtkComboBoxText* _tmp19_;
	GtkComboBoxText* _tmp20_;
	GtkRadioButton* _tmp21_;
	GtkRadioButton* _tmp22_;
	GSettings* _tmp23_;
	gboolean _tmp24_ = FALSE;
	GtkRadioButton* _tmp25_;
	GtkRadioButton* _tmp26_;
	GSList* _tmp27_;
	GtkRadioButton* _tmp28_;
	GtkRadioButton* _tmp29_;
	GSettings* _tmp30_;
	gboolean _tmp31_ = FALSE;
	GtkRadioButton* _tmp32_;
	GtkRadioButton* _tmp33_;
	gboolean _tmp36_ = FALSE;
	GSettings* _tmp37_;
	GtkCheckButton* _tmp38_;
	gboolean _tmp39_ = FALSE;
	GtkCheckButton* _tmp42_;
	GdkPixbuf* preview = NULL;
	GtkImage* _tmp48_ = NULL;
	GdkPixbuf* _tmp49_;
	GtkImage* image = NULL;
	GtkImage* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	GtkLabel* _tmp56_;
	GtkLabel* _tmp57_;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkGrid* clock_grid = NULL;
	GtkGrid* _tmp60_;
	GtkGrid* _tmp61_;
	GtkGrid* _tmp62_;
	GtkSpinButton* _tmp63_;
	GtkGrid* _tmp64_;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkGrid* _tmp67_;
	GtkSpinButton* _tmp68_;
	GtkGrid* _tmp69_;
	GtkLabel* _tmp70_;
	GtkLabel* _tmp71_;
	GtkGrid* _tmp72_;
	GtkSpinButton* _tmp73_;
	GtkGrid* _tmp74_;
	GtkComboBoxText* _tmp75_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp76_;
	GtkGrid* _tmp77_;
	GtkGrid* _tmp78_;
	GtkGrid* _tmp79_;
	GtkGrid* _tmp80_;
	GtkImage* _tmp81_;
	GtkGrid* _tmp82_;
	GtkLabel* _tmp83_;
	GtkGrid* _tmp84_;
	GtkCalendar* _tmp85_;
	GtkGrid* _tmp86_;
	GtkGrid* _tmp87_;
	GtkGrid* _tmp88_;
	GtkLabel* _tmp89_;
	GtkBox* _tmp96_;
	GtkGrid* _tmp97_;
	GDateTime* _tmp99_;
	GDateTime* _tmp100_;
	GSettings* _tmp101_;
	GError* _inner_error0_ = NULL;
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self = (AdjustDateTimeDialog*) granite_dialog_construct (object_type);
#line 70 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_vala_assert (source != NULL, "source != null");
#line 72 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp0_ = (GtkCalendar*) gtk_calendar_new ();
#line 72 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp0_);
#line 72 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->calendar);
#line 72 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->calendar = _tmp0_;
#line 73 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp1_ = self->priv->calendar;
#line 73 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object (_tmp1_, "day-selected", (GCallback) _adjust_date_time_dialog_on_time_changed_gtk_calendar_day_selected, self, 0);
#line 74 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp2_ = self->priv->calendar;
#line 74 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object (_tmp2_, "month-changed", (GCallback) _adjust_date_time_dialog_on_time_changed_gtk_calendar_month_changed, self, 0);
#line 75 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp3_ = self->priv->calendar;
#line 75 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object (_tmp3_, "next-year", (GCallback) _adjust_date_time_dialog_on_time_changed_gtk_calendar_next_year, self, 0);
#line 76 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp4_ = self->priv->calendar;
#line 76 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object (_tmp4_, "prev-year", (GCallback) _adjust_date_time_dialog_on_time_changed_gtk_calendar_prev_year, self, 0);
#line 78 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp5_ = self->priv->ui_settings;
#line 78 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (g_settings_get_boolean (_tmp5_, "use-24-hour-time")) {
#line 352 "AdjustDateTimeDialog.c"
		GtkSpinButton* _tmp6_;
#line 79 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp6_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 23, (gdouble) 1);
#line 79 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_object_ref_sink (_tmp6_);
#line 79 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (self->priv->hour);
#line 79 "../src/Dialogs/AdjustDateTimeDialog.vala"
		self->priv->hour = _tmp6_;
#line 362 "AdjustDateTimeDialog.c"
	} else {
		GtkSpinButton* _tmp7_;
#line 81 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp7_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 12, (gdouble) 1);
#line 81 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_object_ref_sink (_tmp7_);
#line 81 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (self->priv->hour);
#line 81 "../src/Dialogs/AdjustDateTimeDialog.vala"
		self->priv->hour = _tmp7_;
#line 373 "AdjustDateTimeDialog.c"
	}
#line 83 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp8_ = self->priv->hour;
#line 83 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object (_tmp8_, "output", (GCallback) _adjust_date_time_dialog_on_spin_button_output_gtk_spin_button_output, self, 0);
#line 84 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp9_ = self->priv->hour;
#line 84 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_entry_set_width_chars ((GtkEntry*) _tmp9_, 2);
#line 86 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp10_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 59, (gdouble) 1);
#line 86 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp10_);
#line 86 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->minute);
#line 86 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->minute = _tmp10_;
#line 87 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp11_ = self->priv->minute;
#line 87 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_entry_set_width_chars ((GtkEntry*) _tmp11_, 2);
#line 88 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp12_ = self->priv->minute;
#line 88 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object (_tmp12_, "output", (GCallback) _adjust_date_time_dialog_on_spin_button_output_gtk_spin_button_output, self, 0);
#line 90 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp13_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 59, (gdouble) 1);
#line 90 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp13_);
#line 90 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->second);
#line 90 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->second = _tmp13_;
#line 91 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp14_ = self->priv->second;
#line 91 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_entry_set_width_chars ((GtkEntry*) _tmp14_, 2);
#line 92 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp15_ = self->priv->second;
#line 92 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object (_tmp15_, "output", (GCallback) _adjust_date_time_dialog_on_spin_button_output_gtk_spin_button_output, self, 0);
#line 94 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp16_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 94 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp16_);
#line 94 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->system);
#line 94 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->system = _tmp16_;
#line 95 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp17_ = self->priv->system;
#line 95 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_combo_box_text_append_text (_tmp17_, _ ("AM"));
#line 96 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp18_ = self->priv->system;
#line 96 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_combo_box_text_append_text (_tmp18_, _ ("PM"));
#line 97 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp19_ = self->priv->system;
#line 97 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_combo_box_text_append_text (_tmp19_, _ ("24 Hr"));
#line 98 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp20_ = self->priv->system;
#line 98 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp20_, "changed", (GCallback) _adjust_date_time_dialog_on_time_system_changed_gtk_combo_box_changed, self, 0);
#line 100 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp21_ = (GtkRadioButton*) gtk_radio_button_new_with_mnemonic (NULL, _ ("_Shift photos/videos by the same amount"));
#line 100 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp21_);
#line 100 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->relativity_radio_button);
#line 100 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->relativity_radio_button = _tmp21_;
#line 102 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp22_ = self->priv->relativity_radio_button;
#line 102 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp23_ = self->priv->ui_settings;
#line 102 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp22_, g_settings_get_boolean (_tmp23_, "keep-relativity"));
#line 103 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (display_options) {
#line 103 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp24_ = photo_count > 1;
#line 457 "AdjustDateTimeDialog.c"
	} else {
#line 103 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp24_ = FALSE;
#line 461 "AdjustDateTimeDialog.c"
	}
#line 103 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp25_ = self->priv->relativity_radio_button;
#line 103 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, _tmp24_);
#line 105 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp26_ = self->priv->relativity_radio_button;
#line 105 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp27_ = gtk_radio_button_get_group (_tmp26_);
#line 105 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp28_ = (GtkRadioButton*) gtk_radio_button_new_with_mnemonic (_tmp27_, _ ("Set _all photos/videos to this time"));
#line 105 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp28_);
#line 105 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->batch_radio_button);
#line 105 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->batch_radio_button = _tmp28_;
#line 107 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp29_ = self->priv->batch_radio_button;
#line 107 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp30_ = self->priv->ui_settings;
#line 107 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp29_, !g_settings_get_boolean (_tmp30_, "keep-relativity"));
#line 108 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (display_options) {
#line 108 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp31_ = photo_count > 1;
#line 489 "AdjustDateTimeDialog.c"
	} else {
#line 108 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp31_ = FALSE;
#line 493 "AdjustDateTimeDialog.c"
	}
#line 108 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp32_ = self->priv->batch_radio_button;
#line 108 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp32_, _tmp31_);
#line 109 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp33_ = self->priv->batch_radio_button;
#line 109 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp33_, "toggled", (GCallback) _adjust_date_time_dialog_on_time_changed_gtk_toggle_button_toggled, self, 0);
#line 111 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (contains_video) {
#line 505 "AdjustDateTimeDialog.c"
		GtkCheckButton* _tmp34_;
#line 112 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp34_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (ngettext ("_Modify original photo file", "_Modify original photo files", (gulong) photo_count));
#line 112 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_object_ref_sink (_tmp34_);
#line 112 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (self->priv->modify_originals_check_button);
#line 112 "../src/Dialogs/AdjustDateTimeDialog.vala"
		self->priv->modify_originals_check_button = _tmp34_;
#line 515 "AdjustDateTimeDialog.c"
	} else {
		GtkCheckButton* _tmp35_;
#line 115 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp35_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (ngettext ("_Modify original file", "_Modify original files", (gulong) photo_count));
#line 115 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_object_ref_sink (_tmp35_);
#line 115 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (self->priv->modify_originals_check_button);
#line 115 "../src/Dialogs/AdjustDateTimeDialog.vala"
		self->priv->modify_originals_check_button = _tmp35_;
#line 526 "AdjustDateTimeDialog.c"
	}
#line 119 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp37_ = self->priv->file_settings;
#line 119 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (g_settings_get_boolean (_tmp37_, "commit-metadata")) {
#line 119 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp36_ = display_options;
#line 534 "AdjustDateTimeDialog.c"
	} else {
#line 119 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp36_ = FALSE;
#line 538 "AdjustDateTimeDialog.c"
	}
#line 119 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp38_ = self->priv->modify_originals_check_button;
#line 119 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp38_, _tmp36_);
#line 120 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (!only_video) {
#line 546 "AdjustDateTimeDialog.c"
		gboolean _tmp40_ = FALSE;
		GSettings* _tmp41_;
#line 121 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp41_ = self->priv->file_settings;
#line 121 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (!g_settings_get_boolean (_tmp41_, "commit-metadata")) {
#line 121 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp40_ = display_options;
#line 555 "AdjustDateTimeDialog.c"
		} else {
#line 121 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp40_ = FALSE;
#line 559 "AdjustDateTimeDialog.c"
		}
#line 121 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp39_ = _tmp40_;
#line 563 "AdjustDateTimeDialog.c"
	} else {
#line 120 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp39_ = FALSE;
#line 567 "AdjustDateTimeDialog.c"
	}
#line 120 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp42_ = self->priv->modify_originals_check_button;
#line 120 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp42_, _tmp39_);
#line 123 "../src/Dialogs/AdjustDateTimeDialog.vala"
	preview = NULL;
#line 575 "AdjustDateTimeDialog.c"
	{
		GdkPixbuf* _tmp43_ = NULL;
		GdkPixbuf* _tmp44_;
		GdkPixbuf* _tmp45_;
#line 127 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp44_ = thumbnail_source_get_thumbnail ((ThumbnailSource*) source, ADJUST_DATE_TIME_DIALOG_CALENDAR_THUMBNAIL_SCALE, &_inner_error0_);
#line 127 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp43_ = _tmp44_;
#line 127 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 586 "AdjustDateTimeDialog.c"
			goto __catch0_g_error;
		}
#line 127 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp45_ = _tmp43_;
#line 127 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp43_ = NULL;
#line 127 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (preview);
#line 127 "../src/Dialogs/AdjustDateTimeDialog.vala"
		preview = _tmp45_;
#line 124 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (_tmp43_);
#line 599 "AdjustDateTimeDialog.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		gchar* _tmp46_;
		gchar* _tmp47_;
#line 124 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_clear_error (&_inner_error0_);
#line 129 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp46_ = data_object_to_string ((DataObject*) source);
#line 129 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp47_ = _tmp46_;
#line 129 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_warning ("AdjustDateTimeDialog.vala:129: Unable to fetch preview for %s", _tmp47_);
#line 129 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_free0 (_tmp47_);
#line 616 "AdjustDateTimeDialog.c"
	}
	__finally0:
#line 124 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (preview);
#line 124 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_clear_error (&_inner_error0_);
#line 124 "../src/Dialogs/AdjustDateTimeDialog.vala"
		return NULL;
#line 629 "AdjustDateTimeDialog.c"
	}
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp49_ = preview;
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (_tmp49_ != NULL) {
#line 635 "AdjustDateTimeDialog.c"
		GdkPixbuf* _tmp50_;
		GtkImage* _tmp51_;
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp50_ = preview;
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp51_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp50_);
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_object_ref_sink (_tmp51_);
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (_tmp48_);
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp48_ = _tmp51_;
#line 648 "AdjustDateTimeDialog.c"
	} else {
		GtkImage* _tmp52_;
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp52_ = (GtkImage*) gtk_image_new ();
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		g_object_ref_sink (_tmp52_);
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_object_unref0 (_tmp48_);
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp48_ = _tmp52_;
#line 659 "AdjustDateTimeDialog.c"
	}
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp53_ = _g_object_ref0 (_tmp48_);
#line 132 "../src/Dialogs/AdjustDateTimeDialog.vala"
	image = _tmp53_;
#line 133 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp54_ = (GtkLabel*) gtk_label_new (NULL);
#line 133 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp54_);
#line 133 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->original_time_label);
#line 133 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->original_time_label = _tmp54_;
#line 135 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp55_ = (GtkLabel*) gtk_label_new ("");
#line 135 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp55_);
#line 135 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->notification);
#line 135 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->notification = _tmp55_;
#line 136 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp56_ = self->priv->notification;
#line 136 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_label_set_line_wrap (_tmp56_, TRUE);
#line 137 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp57_ = self->priv->notification;
#line 137 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_label_set_justify (_tmp57_, GTK_JUSTIFY_CENTER);
#line 138 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp58_ = self->priv->notification;
#line 138 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp58_, -1, -1);
#line 139 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp59_ = self->priv->notification;
#line 139 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_misc_set_padding ((GtkMisc*) _tmp59_, 12, 6);
#line 141 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp60_ = (GtkGrid*) gtk_grid_new ();
#line 141 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp60_);
#line 141 "../src/Dialogs/AdjustDateTimeDialog.vala"
	clock_grid = _tmp60_;
#line 142 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp61_ = clock_grid;
#line 142 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_grid_set_column_spacing (_tmp61_, 3);
#line 143 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp62_ = clock_grid;
#line 143 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp63_ = self->priv->hour;
#line 143 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
#line 144 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp64_ = clock_grid;
#line 144 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp65_ = (GtkLabel*) gtk_label_new (":");
#line 144 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp65_);
#line 144 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp66_ = _tmp65_;
#line 144 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp66_);
#line 144 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (_tmp66_);
#line 145 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp67_ = clock_grid;
#line 145 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp68_ = self->priv->minute;
#line 145 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
#line 146 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp69_ = clock_grid;
#line 146 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp70_ = (GtkLabel*) gtk_label_new (":");
#line 146 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp70_);
#line 146 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp71_ = _tmp70_;
#line 146 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp69_, (GtkWidget*) _tmp71_);
#line 146 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (_tmp71_);
#line 147 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp72_ = clock_grid;
#line 147 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp73_ = self->priv->second;
#line 147 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp73_);
#line 148 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp74_ = clock_grid;
#line 148 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp75_ = self->priv->system;
#line 148 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp74_, (GtkWidget*) _tmp75_);
#line 150 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp76_ = (GtkGrid*) gtk_grid_new ();
#line 150 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_ref_sink (_tmp76_);
#line 150 "../src/Dialogs/AdjustDateTimeDialog.vala"
	grid = _tmp76_;
#line 151 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp77_ = grid;
#line 151 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_grid_set_column_spacing (_tmp77_, 12);
#line 152 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp78_ = grid;
#line 152 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_grid_set_row_spacing (_tmp78_, 12);
#line 153 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp79_ = grid;
#line 153 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_object_set ((GtkWidget*) _tmp79_, "margin", 6, NULL);
#line 154 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp80_ = grid;
#line 154 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp81_ = image;
#line 154 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_grid_attach (_tmp80_, (GtkWidget*) _tmp81_, 0, 0, 1, 1);
#line 155 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp82_ = grid;
#line 155 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp83_ = self->priv->original_time_label;
#line 155 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_grid_attach (_tmp82_, (GtkWidget*) _tmp83_, 0, 1, 1, 1);
#line 156 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp84_ = grid;
#line 156 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp85_ = self->priv->calendar;
#line 156 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_grid_attach (_tmp84_, (GtkWidget*) _tmp85_, 1, 0, 1, 1);
#line 157 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp86_ = grid;
#line 157 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp87_ = clock_grid;
#line 157 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_grid_attach (_tmp86_, (GtkWidget*) _tmp87_, 1, 1, 1, 1);
#line 158 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp88_ = grid;
#line 158 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp89_ = self->priv->notification;
#line 158 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_grid_attach (_tmp88_, (GtkWidget*) _tmp89_, 0, 5, 2, 1);
#line 160 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (display_options) {
#line 805 "AdjustDateTimeDialog.c"
		GtkGrid* _tmp90_;
		GtkRadioButton* _tmp91_;
		GtkGrid* _tmp92_;
		GtkRadioButton* _tmp93_;
		GtkGrid* _tmp94_;
		GtkCheckButton* _tmp95_;
#line 161 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp90_ = grid;
#line 161 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp91_ = self->priv->relativity_radio_button;
#line 161 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_grid_attach (_tmp90_, (GtkWidget*) _tmp91_, 1, 2, 1, 1);
#line 162 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp92_ = grid;
#line 162 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp93_ = self->priv->batch_radio_button;
#line 162 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_grid_attach (_tmp92_, (GtkWidget*) _tmp93_, 1, 3, 1, 1);
#line 163 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp94_ = grid;
#line 163 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp95_ = self->priv->modify_originals_check_button;
#line 163 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_grid_attach (_tmp94_, (GtkWidget*) _tmp95_, 1, 4, 1, 1);
#line 830 "AdjustDateTimeDialog.c"
	}
#line 166 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp96_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 166 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp97_ = grid;
#line 166 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp96_, (GtkWidget*) _tmp97_);
#line 168 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->original_time = dateable_get_exposure_time (source);
#line 170 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (self->priv->original_time == ((gint64) 0)) {
#line 842 "AdjustDateTimeDialog.c"
		time_t _tmp98_;
#line 171 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp98_ = time (NULL);
#line 171 "../src/Dialogs/AdjustDateTimeDialog.vala"
		self->priv->original_time = (gint64) _tmp98_;
#line 172 "../src/Dialogs/AdjustDateTimeDialog.vala"
		self->priv->no_original_time = TRUE;
#line 850 "AdjustDateTimeDialog.c"
	}
#line 175 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp99_ = g_date_time_new_from_unix_local (self->priv->original_time);
#line 175 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp100_ = _tmp99_;
#line 175 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_set_time (self, _tmp100_);
#line 175 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_date_time_unref0 (_tmp100_);
#line 176 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp101_ = self->priv->ui_settings;
#line 176 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_set_original_time_label (self, g_settings_get_boolean (_tmp101_, "use-24-hour-time"));
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (grid);
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (clock_grid);
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (image);
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (_tmp48_);
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (preview);
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	return self;
#line 876 "AdjustDateTimeDialog.c"
}

AdjustDateTimeDialog*
adjust_date_time_dialog_new (Dateable* source,
                             gint photo_count,
                             gboolean display_options,
                             gboolean contains_video,
                             gboolean only_video)
{
#line 68 "../src/Dialogs/AdjustDateTimeDialog.vala"
	return adjust_date_time_dialog_construct (TYPE_ADJUST_DATE_TIME_DIALOG, source, photo_count, display_options, contains_video, only_video);
#line 888 "AdjustDateTimeDialog.c"
}

static void
adjust_date_time_dialog_set_time (AdjustDateTimeDialog* self,
                                  GDateTime* time)
{
	GtkCalendar* _tmp0_;
	GtkCalendar* _tmp1_;
	GSettings* _tmp2_;
	GtkSpinButton* _tmp9_;
	GtkSpinButton* _tmp10_;
	GtkComboBoxText* _tmp11_;
#line 179 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_if_fail (time != NULL);
#line 180 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp0_ = self->priv->calendar;
#line 180 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_calendar_select_month (_tmp0_, (guint) g_date_time_get_month (time), (guint) g_date_time_get_year (time));
#line 181 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp1_ = self->priv->calendar;
#line 181 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_calendar_select_day (_tmp1_, (guint) g_date_time_get_day_of_month (time));
#line 183 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp2_ = self->priv->ui_settings;
#line 183 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (g_settings_get_boolean (_tmp2_, "use-24-hour-time")) {
#line 917 "AdjustDateTimeDialog.c"
		GtkSpinButton* _tmp3_;
		GtkComboBoxText* _tmp4_;
#line 184 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp3_ = self->priv->hour;
#line 184 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_spin_button_set_value (_tmp3_, (gdouble) g_date_time_get_hour (time));
#line 185 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp4_ = self->priv->system;
#line 185 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp4_, (gint) ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_24HR);
#line 928 "AdjustDateTimeDialog.c"
	} else {
		gint ampm_hour = 0;
		gint _tmp5_ = 0;
		GtkSpinButton* _tmp6_;
		AdjustDateTimeDialogTimeSystem _tmp7_ = 0;
		GtkComboBoxText* _tmp8_;
#line 187 "../src/Dialogs/AdjustDateTimeDialog.vala"
		ampm_hour = g_date_time_get_hour (time) % 12;
#line 188 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (ampm_hour == 0) {
#line 188 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp5_ = 12;
#line 941 "AdjustDateTimeDialog.c"
		} else {
#line 188 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp5_ = ampm_hour;
#line 945 "AdjustDateTimeDialog.c"
		}
#line 188 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp6_ = self->priv->hour;
#line 188 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_spin_button_set_value (_tmp6_, (gdouble) _tmp5_);
#line 189 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (g_date_time_get_hour (time) >= 12) {
#line 189 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp7_ = ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_PM;
#line 955 "AdjustDateTimeDialog.c"
		} else {
#line 189 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp7_ = ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_AM;
#line 959 "AdjustDateTimeDialog.c"
		}
#line 189 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp8_ = self->priv->system;
#line 189 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp8_, (gint) _tmp7_);
#line 965 "AdjustDateTimeDialog.c"
	}
#line 192 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp9_ = self->priv->minute;
#line 192 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_spin_button_set_value (_tmp9_, (gdouble) g_date_time_get_minute (time));
#line 193 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp10_ = self->priv->second;
#line 193 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_spin_button_set_value (_tmp10_, (gdouble) g_date_time_get_second (time));
#line 195 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp11_ = self->priv->system;
#line 195 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->previous_time_system = (AdjustDateTimeDialogTimeSystem) gtk_combo_box_get_active ((GtkComboBox*) _tmp11_);
#line 979 "AdjustDateTimeDialog.c"
}

static void
adjust_date_time_dialog_set_original_time_label (AdjustDateTimeDialog* self,
                                                 gboolean use_24_hr_format)
{
	const gchar* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 198 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (self->priv->no_original_time) {
#line 200 "../src/Dialogs/AdjustDateTimeDialog.vala"
		return;
#line 1000 "AdjustDateTimeDialog.c"
	}
#line 205 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (use_24_hr_format) {
#line 205 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp0_ = _ ("%m/%d/%Y, %H:%M:%S");
#line 1006 "AdjustDateTimeDialog.c"
	} else {
#line 205 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp0_ = _ ("%m/%d/%Y, %I:%M:%S %p");
#line 1010 "AdjustDateTimeDialog.c"
	}
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp1_ = self->priv->original_time_label;
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp2_ = g_date_time_new_from_unix_local (self->priv->original_time);
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp3_ = _tmp2_;
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp4_ = g_date_time_format (_tmp3_, _tmp0_);
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp5_ = _tmp4_;
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp6_ = g_strdup_printf (_ ("Original: %s"), _tmp5_);
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp7_ = _tmp6_;
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_label_set_text (_tmp1_, _tmp7_);
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_free0 (_tmp7_);
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_free0 (_tmp5_);
#line 202 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_date_time_unref0 (_tmp3_);
#line 1034 "AdjustDateTimeDialog.c"
}

static gint64
adjust_date_time_dialog_get_time (AdjustDateTimeDialog* self)
{
	gint hour = 0;
	GtkSpinButton* _tmp0_;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	gint _tmp4_ = 0;
	GtkComboBoxText* _tmp5_;
	guint year = 0U;
	guint month = 0U;
	guint day = 0U;
	GtkCalendar* _tmp6_;
	guint _tmp7_ = 0U;
	guint _tmp8_ = 0U;
	guint _tmp9_ = 0U;
	GDateTime* date_time = NULL;
	GtkSpinButton* _tmp10_;
	GtkSpinButton* _tmp11_;
	GDateTime* _tmp12_;
	gint64 result;
#line 211 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 213 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp0_ = self->priv->hour;
#line 213 "../src/Dialogs/AdjustDateTimeDialog.vala"
	hour = (gint) gtk_spin_button_get_value (_tmp0_);
#line 214 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (hour == 12) {
#line 1066 "AdjustDateTimeDialog.c"
		GtkComboBoxText* _tmp3_;
#line 214 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp3_ = self->priv->system;
#line 214 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp2_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp3_) != ((gint) ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_24HR);
#line 1072 "AdjustDateTimeDialog.c"
	} else {
#line 214 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp2_ = FALSE;
#line 1076 "AdjustDateTimeDialog.c"
	}
#line 214 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (_tmp2_) {
#line 214 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp1_ = 0;
#line 1082 "AdjustDateTimeDialog.c"
	} else {
#line 214 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp1_ = hour;
#line 1086 "AdjustDateTimeDialog.c"
	}
#line 214 "../src/Dialogs/AdjustDateTimeDialog.vala"
	hour = _tmp1_;
#line 215 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp5_ = self->priv->system;
#line 215 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (gtk_combo_box_get_active ((GtkComboBox*) _tmp5_) == ((gint) ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_PM)) {
#line 215 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp4_ = 12;
#line 1096 "AdjustDateTimeDialog.c"
	} else {
#line 215 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp4_ = 0;
#line 1100 "AdjustDateTimeDialog.c"
	}
#line 215 "../src/Dialogs/AdjustDateTimeDialog.vala"
	hour += _tmp4_;
#line 218 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp6_ = self->priv->calendar;
#line 218 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_calendar_get_date (_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 218 "../src/Dialogs/AdjustDateTimeDialog.vala"
	year = _tmp7_;
#line 218 "../src/Dialogs/AdjustDateTimeDialog.vala"
	month = _tmp8_;
#line 218 "../src/Dialogs/AdjustDateTimeDialog.vala"
	day = _tmp9_;
#line 219 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp10_ = self->priv->minute;
#line 219 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp11_ = self->priv->second;
#line 219 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp12_ = g_date_time_new_local ((gint) year, (gint) month, (gint) day, hour, (gint) gtk_spin_button_get_value (_tmp10_), gtk_spin_button_get_value (_tmp11_));
#line 219 "../src/Dialogs/AdjustDateTimeDialog.vala"
	date_time = _tmp12_;
#line 222 "../src/Dialogs/AdjustDateTimeDialog.vala"
	result = g_date_time_to_unix (date_time);
#line 222 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_date_time_unref0 (date_time);
#line 222 "../src/Dialogs/AdjustDateTimeDialog.vala"
	return result;
#line 1128 "AdjustDateTimeDialog.c"
}

gboolean
adjust_date_time_dialog_execute (AdjustDateTimeDialog* self,
                                 gint64* time_shift,
                                 gboolean* keep_relativity,
                                 gboolean* modify_originals)
{
	gint64 _vala_time_shift = 0LL;
	gboolean _vala_keep_relativity = FALSE;
	gboolean _vala_modify_originals = FALSE;
	gboolean response = FALSE;
	gboolean result;
#line 225 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 227 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 229 "../src/Dialogs/AdjustDateTimeDialog.vala"
	response = FALSE;
#line 231 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (gtk_dialog_run ((GtkDialog*) self) == ((gint) GTK_RESPONSE_OK)) {
#line 1150 "AdjustDateTimeDialog.c"
		GtkRadioButton* _tmp0_;
		GtkRadioButton* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GtkCheckButton* _tmp5_;
		GtkCheckButton* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 232 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (self->priv->no_original_time) {
#line 233 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_vala_time_shift = adjust_date_time_dialog_get_time (self);
#line 1163 "AdjustDateTimeDialog.c"
		} else {
#line 235 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_vala_time_shift = adjust_date_time_dialog_get_time (self) - self->priv->original_time;
#line 1167 "AdjustDateTimeDialog.c"
		}
#line 238 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp0_ = self->priv->relativity_radio_button;
#line 238 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_vala_keep_relativity = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 240 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp1_ = self->priv->relativity_radio_button;
#line 240 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp2_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp1_);
#line 240 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp3_ = _tmp2_;
#line 240 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (_tmp3_) {
#line 1181 "AdjustDateTimeDialog.c"
			GSettings* _tmp4_;
#line 241 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp4_ = self->priv->ui_settings;
#line 241 "../src/Dialogs/AdjustDateTimeDialog.vala"
			g_settings_set_boolean (_tmp4_, "keep-relativity", _vala_keep_relativity);
#line 1187 "AdjustDateTimeDialog.c"
		}
#line 243 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp5_ = self->priv->modify_originals_check_button;
#line 243 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_vala_modify_originals = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp5_);
#line 245 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp6_ = self->priv->modify_originals_check_button;
#line 245 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp7_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp6_);
#line 245 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp8_ = _tmp7_;
#line 245 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (_tmp8_) {
#line 1201 "AdjustDateTimeDialog.c"
			GSettings* _tmp9_;
#line 246 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp9_ = self->priv->ui_settings;
#line 246 "../src/Dialogs/AdjustDateTimeDialog.vala"
			g_settings_set_boolean (_tmp9_, "modify-originals", _vala_modify_originals);
#line 1207 "AdjustDateTimeDialog.c"
		}
#line 248 "../src/Dialogs/AdjustDateTimeDialog.vala"
		response = TRUE;
#line 1211 "AdjustDateTimeDialog.c"
	} else {
#line 250 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_vala_time_shift = (gint64) 0;
#line 251 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_vala_keep_relativity = TRUE;
#line 252 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_vala_modify_originals = FALSE;
#line 1219 "AdjustDateTimeDialog.c"
	}
#line 255 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 257 "../src/Dialogs/AdjustDateTimeDialog.vala"
	result = response;
#line 257 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (time_shift) {
#line 257 "../src/Dialogs/AdjustDateTimeDialog.vala"
		*time_shift = _vala_time_shift;
#line 1229 "AdjustDateTimeDialog.c"
	}
#line 257 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (keep_relativity) {
#line 257 "../src/Dialogs/AdjustDateTimeDialog.vala"
		*keep_relativity = _vala_keep_relativity;
#line 1235 "AdjustDateTimeDialog.c"
	}
#line 257 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (modify_originals) {
#line 257 "../src/Dialogs/AdjustDateTimeDialog.vala"
		*modify_originals = _vala_modify_originals;
#line 1241 "AdjustDateTimeDialog.c"
	}
#line 257 "../src/Dialogs/AdjustDateTimeDialog.vala"
	return result;
#line 1245 "AdjustDateTimeDialog.c"
}

static gboolean
adjust_date_time_dialog_on_spin_button_output (AdjustDateTimeDialog* self,
                                               GtkSpinButton* button)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean result;
#line 260 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 260 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_val_if_fail (button != NULL, FALSE);
#line 261 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp0_ = g_strdup_printf ("%02d", (gint) gtk_spin_button_get_value (button));
#line 261 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp1_ = _tmp0_;
#line 261 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_entry_set_text ((GtkEntry*) button, _tmp1_);
#line 261 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_free0 (_tmp1_);
#line 263 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_on_time_changed (self);
#line 265 "../src/Dialogs/AdjustDateTimeDialog.vala"
	result = TRUE;
#line 265 "../src/Dialogs/AdjustDateTimeDialog.vala"
	return result;
#line 1273 "AdjustDateTimeDialog.c"
}

static void
adjust_date_time_dialog_on_time_changed (AdjustDateTimeDialog* self)
{
	gint64 time_shift = 0LL;
	GtkComboBoxText* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 268 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/Dialogs/AdjustDateTimeDialog.vala"
	time_shift = adjust_date_time_dialog_get_time (self) - self->priv->original_time;
#line 271 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp0_ = self->priv->system;
#line 271 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->previous_time_system = (AdjustDateTimeDialogTimeSystem) gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (time_shift == ((gint64) 0)) {
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp2_ = TRUE;
#line 1295 "AdjustDateTimeDialog.c"
	} else {
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp2_ = self->priv->no_original_time;
#line 1299 "AdjustDateTimeDialog.c"
	}
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (_tmp2_) {
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp1_ = TRUE;
#line 1305 "AdjustDateTimeDialog.c"
	} else {
		gboolean _tmp3_ = FALSE;
		GtkRadioButton* _tmp4_;
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp4_ = self->priv->batch_radio_button;
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_)) {
#line 1313 "AdjustDateTimeDialog.c"
			GtkRadioButton* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 274 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp5_ = self->priv->batch_radio_button;
#line 274 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp6_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp5_);
#line 274 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp7_ = _tmp6_;
#line 274 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp3_ = _tmp7_;
#line 1325 "AdjustDateTimeDialog.c"
		} else {
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp3_ = FALSE;
#line 1329 "AdjustDateTimeDialog.c"
		}
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp1_ = _tmp3_;
#line 1333 "AdjustDateTimeDialog.c"
	}
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (_tmp1_) {
#line 1337 "AdjustDateTimeDialog.c"
		GtkLabel* _tmp8_;
#line 275 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp8_ = self->priv->notification;
#line 275 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_widget_hide ((GtkWidget*) _tmp8_);
#line 1343 "AdjustDateTimeDialog.c"
	} else {
		gboolean forward = FALSE;
		gint days = 0;
		gint hours = 0;
		gint minutes = 0;
		gint seconds = 0;
		const gchar* _tmp9_ = NULL;
		gchar* shift_status = NULL;
		gchar* _tmp10_;
		GtkLabel* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GtkLabel* _tmp15_;
#line 277 "../src/Dialogs/AdjustDateTimeDialog.vala"
		forward = time_shift > ((gint64) 0);
#line 280 "../src/Dialogs/AdjustDateTimeDialog.vala"
		time_shift = llabs (time_shift);
#line 282 "../src/Dialogs/AdjustDateTimeDialog.vala"
		days = (gint) (time_shift / ADJUST_DATE_TIME_DIALOG_SECONDS_IN_DAY);
#line 283 "../src/Dialogs/AdjustDateTimeDialog.vala"
		time_shift = time_shift % ADJUST_DATE_TIME_DIALOG_SECONDS_IN_DAY;
#line 284 "../src/Dialogs/AdjustDateTimeDialog.vala"
		hours = (gint) (time_shift / ADJUST_DATE_TIME_DIALOG_SECONDS_IN_HOUR);
#line 285 "../src/Dialogs/AdjustDateTimeDialog.vala"
		time_shift = time_shift % ADJUST_DATE_TIME_DIALOG_SECONDS_IN_HOUR;
#line 286 "../src/Dialogs/AdjustDateTimeDialog.vala"
		minutes = (gint) (time_shift / ADJUST_DATE_TIME_DIALOG_SECONDS_IN_MINUTE);
#line 287 "../src/Dialogs/AdjustDateTimeDialog.vala"
		seconds = (gint) (time_shift % ADJUST_DATE_TIME_DIALOG_SECONDS_IN_MINUTE);
#line 289 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (forward) {
#line 290 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp9_ = _ ("Exposure time will be shifted forward by\n" \
"%d %s, %d %s, %d %s, and %d %s.");
#line 1378 "AdjustDateTimeDialog.c"
		} else {
#line 291 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp9_ = _ ("Exposure time will be shifted backward by\n" \
"%d %s, %d %s, %d %s, and %d %s.");
#line 1382 "AdjustDateTimeDialog.c"
		}
#line 289 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 289 "../src/Dialogs/AdjustDateTimeDialog.vala"
		shift_status = _tmp10_;
#line 293 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp11_ = self->priv->notification;
#line 293 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp12_ = shift_status;
#line 293 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp13_ = g_strdup_printf (_tmp12_, days, ngettext ("day", "days", (gulong) days), hours, ngettext ("hour", "hours", (gulong) hours), minutes, ngettext ("minute", "minutes", (gulong) minutes), seconds, ngettext ("second", "seconds", (gulong) seconds));
#line 293 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp14_ = _tmp13_;
#line 293 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_label_set_text (_tmp11_, _tmp14_);
#line 293 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_free0 (_tmp14_);
#line 298 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp15_ = self->priv->notification;
#line 298 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_widget_show ((GtkWidget*) _tmp15_);
#line 273 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_g_free0 (shift_status);
#line 1406 "AdjustDateTimeDialog.c"
	}
}

static void
adjust_date_time_dialog_on_time_system_changed (AdjustDateTimeDialog* self)
{
	GtkComboBoxText* _tmp0_;
	GSettings* _tmp1_;
	GtkComboBoxText* _tmp2_;
	GtkComboBoxText* _tmp3_;
#line 302 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp0_ = self->priv->system;
#line 303 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (self->priv->previous_time_system == gtk_combo_box_get_active ((GtkComboBox*) _tmp0_)) {
#line 304 "../src/Dialogs/AdjustDateTimeDialog.vala"
		return;
#line 1425 "AdjustDateTimeDialog.c"
	}
#line 306 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp1_ = self->priv->ui_settings;
#line 306 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp2_ = self->priv->system;
#line 306 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_settings_set_boolean (_tmp1_, "use-24-hour-time", gtk_combo_box_get_active ((GtkComboBox*) _tmp2_) == ((gint) ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_24HR));
#line 308 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp3_ = self->priv->system;
#line 308 "../src/Dialogs/AdjustDateTimeDialog.vala"
	if (gtk_combo_box_get_active ((GtkComboBox*) _tmp3_) == ((gint) ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_24HR)) {
#line 1437 "AdjustDateTimeDialog.c"
		gint _tmp4_ = 0;
		GtkSpinButton* _tmp5_;
		gint time = 0;
		gint _tmp7_ = 0;
		GtkSpinButton* _tmp8_;
		GtkSpinButton* _tmp9_;
#line 309 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp5_ = self->priv->hour;
#line 309 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (gtk_spin_button_get_value (_tmp5_) == 12.0) {
#line 309 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp4_ = 0;
#line 1450 "AdjustDateTimeDialog.c"
		} else {
			GtkSpinButton* _tmp6_;
#line 309 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp6_ = self->priv->hour;
#line 309 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp4_ = (gint) gtk_spin_button_get_value (_tmp6_);
#line 1457 "AdjustDateTimeDialog.c"
		}
#line 309 "../src/Dialogs/AdjustDateTimeDialog.vala"
		time = _tmp4_;
#line 310 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (self->priv->previous_time_system == ADJUST_DATE_TIME_DIALOG_TIME_SYSTEM_PM) {
#line 310 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp7_ = 12;
#line 1465 "AdjustDateTimeDialog.c"
		} else {
#line 310 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp7_ = 0;
#line 1469 "AdjustDateTimeDialog.c"
		}
#line 310 "../src/Dialogs/AdjustDateTimeDialog.vala"
		time = time + _tmp7_;
#line 312 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp8_ = self->priv->hour;
#line 312 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_spin_button_set_range (_tmp8_, (gdouble) 0, (gdouble) 23);
#line 313 "../src/Dialogs/AdjustDateTimeDialog.vala"
		adjust_date_time_dialog_set_original_time_label (self, TRUE);
#line 315 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp9_ = self->priv->hour;
#line 315 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_spin_button_set_value (_tmp9_, (gdouble) time);
#line 1483 "AdjustDateTimeDialog.c"
	} else {
		gint ampm_hour = 0;
		GtkSpinButton* _tmp10_;
		GtkSpinButton* _tmp11_;
		gint _tmp12_ = 0;
		GtkSpinButton* _tmp13_;
#line 317 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp10_ = self->priv->hour;
#line 317 "../src/Dialogs/AdjustDateTimeDialog.vala"
		ampm_hour = ((gint) gtk_spin_button_get_value (_tmp10_)) % 12;
#line 319 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp11_ = self->priv->hour;
#line 319 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_spin_button_set_range (_tmp11_, (gdouble) 1, (gdouble) 12);
#line 320 "../src/Dialogs/AdjustDateTimeDialog.vala"
		adjust_date_time_dialog_set_original_time_label (self, FALSE);
#line 322 "../src/Dialogs/AdjustDateTimeDialog.vala"
		if (ampm_hour == 0) {
#line 322 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp12_ = 12;
#line 1504 "AdjustDateTimeDialog.c"
		} else {
#line 322 "../src/Dialogs/AdjustDateTimeDialog.vala"
			_tmp12_ = ampm_hour;
#line 1508 "AdjustDateTimeDialog.c"
		}
#line 322 "../src/Dialogs/AdjustDateTimeDialog.vala"
		_tmp13_ = self->priv->hour;
#line 322 "../src/Dialogs/AdjustDateTimeDialog.vala"
		gtk_spin_button_set_value (_tmp13_, (gdouble) _tmp12_);
#line 1514 "AdjustDateTimeDialog.c"
	}
#line 325 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_on_time_changed (self);
#line 1518 "AdjustDateTimeDialog.c"
}

static GObject *
adjust_date_time_dialog_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AdjustDateTimeDialog * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	AppWindow* _tmp2_;
	AppWindow* _tmp3_;
#line 51 "../src/Dialogs/AdjustDateTimeDialog.vala"
	parent_class = G_OBJECT_CLASS (adjust_date_time_dialog_parent_class);
#line 51 "../src/Dialogs/AdjustDateTimeDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADJUST_DATE_TIME_DIALOG, AdjustDateTimeDialog);
#line 52 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_UI_PREFS_SCHEMA_NAME);
#line 52 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->ui_settings);
#line 52 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->ui_settings = _tmp0_;
#line 53 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp1_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_FILES_PREFS_SCHEMA_NAME);
#line 53 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 53 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->file_settings = _tmp1_;
#line 55 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_dialog_add_buttons ((GtkDialog*) self, _ ("_Cancel"), GTK_RESPONSE_CANCEL, _ ("_Apply"), GTK_RESPONSE_OK, NULL);
#line 60 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 61 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 62 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 63 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_window_set_title ((GtkWindow*) self, _ (RESOURCES_ADJUST_DATE_TIME_LABEL));
#line 64 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp2_ = app_window_get_instance ();
#line 64 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_tmp3_ = _tmp2_;
#line 64 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp3_);
#line 64 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (_tmp3_);
#line 65 "../src/Dialogs/AdjustDateTimeDialog.vala"
	gtk_dialog_set_default_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
#line 51 "../src/Dialogs/AdjustDateTimeDialog.vala"
	return obj;
#line 1573 "AdjustDateTimeDialog.c"
}

static void
adjust_date_time_dialog_class_init (AdjustDateTimeDialogClass * klass,
                                    gpointer klass_data)
{
#line 21 "../src/Dialogs/AdjustDateTimeDialog.vala"
	adjust_date_time_dialog_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Dialogs/AdjustDateTimeDialog.vala"
	g_type_class_adjust_private_offset (klass, &AdjustDateTimeDialog_private_offset);
#line 21 "../src/Dialogs/AdjustDateTimeDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = adjust_date_time_dialog_constructor;
#line 21 "../src/Dialogs/AdjustDateTimeDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = adjust_date_time_dialog_finalize;
#line 1588 "AdjustDateTimeDialog.c"
}

static void
adjust_date_time_dialog_instance_init (AdjustDateTimeDialog * self,
                                       gpointer klass)
{
#line 21 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv = adjust_date_time_dialog_get_instance_private (self);
#line 25 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self->priv->no_original_time = FALSE;
#line 1599 "AdjustDateTimeDialog.c"
}

static void
adjust_date_time_dialog_finalize (GObject * obj)
{
	AdjustDateTimeDialog * self;
#line 21 "../src/Dialogs/AdjustDateTimeDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADJUST_DATE_TIME_DIALOG, AdjustDateTimeDialog);
#line 30 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->original_time_label);
#line 31 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->calendar);
#line 32 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->hour);
#line 33 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->minute);
#line 34 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->second);
#line 35 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->system);
#line 36 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->relativity_radio_button);
#line 37 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->batch_radio_button);
#line 38 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->modify_originals_check_button);
#line 39 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->notification);
#line 40 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->ui_settings);
#line 41 "../src/Dialogs/AdjustDateTimeDialog.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 21 "../src/Dialogs/AdjustDateTimeDialog.vala"
	G_OBJECT_CLASS (adjust_date_time_dialog_parent_class)->finalize (obj);
#line 1634 "AdjustDateTimeDialog.c"
}

static GType
adjust_date_time_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AdjustDateTimeDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adjust_date_time_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdjustDateTimeDialog), 0, (GInstanceInitFunc) adjust_date_time_dialog_instance_init, NULL };
	GType adjust_date_time_dialog_type_id;
	adjust_date_time_dialog_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "AdjustDateTimeDialog", &g_define_type_info, 0);
	AdjustDateTimeDialog_private_offset = g_type_add_instance_private (adjust_date_time_dialog_type_id, sizeof (AdjustDateTimeDialogPrivate));
	return adjust_date_time_dialog_type_id;
}

GType
adjust_date_time_dialog_get_type (void)
{
	static volatile gsize adjust_date_time_dialog_type_id__once = 0;
	if (g_once_init_enter (&adjust_date_time_dialog_type_id__once)) {
		GType adjust_date_time_dialog_type_id;
		adjust_date_time_dialog_type_id = adjust_date_time_dialog_get_type_once ();
		g_once_init_leave (&adjust_date_time_dialog_type_id__once, adjust_date_time_dialog_type_id);
	}
	return adjust_date_time_dialog_type_id__once;
}

