/* ExportDialog.c generated by valac 0.56.18, the Vala compiler
 * generated from ExportDialog.vala, do not modify */

/*
* Copyright 2009-2013 Yorba Foundation
*           2017-2021 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	EXPORT_DIALOG_0_PROPERTY,
	EXPORT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* export_dialog_properties[EXPORT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ExportDialogPrivate {
	GtkComboBoxText* quality_combo;
	GtkComboBoxText* constraint_combo;
	GtkComboBoxText* format_combo;
	GtkCheckButton* export_metadata;
	GeeArrayList* format_options;
	GtkSpinButton* pixels_spinbutton;
	GtkWidget* export_button;
};

static gint ExportDialog_private_offset;
static gpointer export_dialog_parent_class = NULL;
static ScaleConstraint export_dialog_current_constraint;
static ScaleConstraint export_dialog_current_constraint = SCALE_CONSTRAINT_ORIGINAL;
static ExportFormatParameters export_dialog_current_parameters;
static ExportFormatParameters export_dialog_current_parameters = {0};
static gint export_dialog_current_scale;
static gint export_dialog_current_scale = 1200;

static void export_dialog_format_add_option (ExportDialog* self,
                                      const gchar* format_name);
static void export_dialog_format_set_active_text (ExportDialog* self,
                                           const gchar* text);
static PhotoFileFormat export_dialog_get_specified_format (ExportDialog* self);
static gchar* export_dialog_get_label_for_parameters (ExportDialog* self,
                                               ExportFormatParameters* params);
static void export_dialog_on_format_changed (ExportDialog* self);
static void export_dialog_on_constraint_changed (ExportDialog* self);
static void export_dialog_on_pixels_changed (ExportDialog* self);
static GObject * export_dialog_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _export_dialog_on_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _export_dialog_on_format_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                             gpointer self);
static void _export_dialog_on_pixels_changed_gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self);
static void _export_dialog___lambda41_ (ExportDialog* self);
static void __export_dialog___lambda41__gtk_entry_activate (GtkEntry* _sender,
                                                     gpointer self);
static void export_dialog_finalize (GObject * obj);
static GType export_dialog_get_type_once (void);

const ScaleConstraint EXPORT_DIALOG_CONSTRAINT_ARRAY[4] = {SCALE_CONSTRAINT_ORIGINAL, SCALE_CONSTRAINT_DIMENSIONS, SCALE_CONSTRAINT_WIDTH, SCALE_CONSTRAINT_HEIGHT};
const JpegQuality EXPORT_DIALOG_QUALITY_ARRAY[4] = {JPEG_QUALITY_LOW, JPEG_QUALITY_MEDIUM, JPEG_QUALITY_HIGH, JPEG_QUALITY_MAXIMUM};

static inline gpointer
export_dialog_get_instance_private (ExportDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ExportDialog_private_offset);
}

ExportDialog*
export_dialog_construct (GType object_type,
                         const gchar* title)
{
	ExportDialog * self = NULL;
#line 49 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 50 "../src/Dialogs/ExportDialog.vala"
	self = (ExportDialog*) g_object_new (object_type, "resizable", FALSE, "title", title, NULL);
#line 49 "../src/Dialogs/ExportDialog.vala"
	return self;
#line 122 "ExportDialog.c"
}

ExportDialog*
export_dialog_new (const gchar* title)
{
#line 49 "../src/Dialogs/ExportDialog.vala"
	return export_dialog_construct (TYPE_EXPORT_DIALOG, title);
#line 130 "ExportDialog.c"
}

static void
export_dialog_format_add_option (ExportDialog* self,
                                 const gchar* format_name)
{
	GeeArrayList* _tmp0_;
	GtkComboBoxText* _tmp1_;
#line 159 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (format_name != NULL);
#line 160 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->format_options;
#line 160 "../src/Dialogs/ExportDialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, format_name);
#line 161 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = self->priv->format_combo;
#line 161 "../src/Dialogs/ExportDialog.vala"
	gtk_combo_box_text_append_text (_tmp1_, format_name);
#line 151 "ExportDialog.c"
}

static void
export_dialog_format_set_active_text (ExportDialog* self,
                                      const gchar* text)
{
	gint selection_ticker = 0;
#line 164 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (text != NULL);
#line 165 "../src/Dialogs/ExportDialog.vala"
	selection_ticker = 0;
#line 165 "ExportDialog.c"
	{
		GeeArrayList* _current_text_list = NULL;
		GeeArrayList* _tmp0_;
		gint _current_text_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _current_text_index = 0;
#line 167 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = self->priv->format_options;
#line 167 "../src/Dialogs/ExportDialog.vala"
		_current_text_list = _tmp0_;
#line 167 "../src/Dialogs/ExportDialog.vala"
		_tmp1_ = _current_text_list;
#line 167 "../src/Dialogs/ExportDialog.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 167 "../src/Dialogs/ExportDialog.vala"
		_tmp3_ = _tmp2_;
#line 167 "../src/Dialogs/ExportDialog.vala"
		_current_text_size = _tmp3_;
#line 167 "../src/Dialogs/ExportDialog.vala"
		_current_text_index = -1;
#line 167 "../src/Dialogs/ExportDialog.vala"
		while (TRUE) {
#line 190 "ExportDialog.c"
			gint _tmp4_;
			gint _tmp5_;
			gchar* current_text = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			gint _tmp10_;
#line 167 "../src/Dialogs/ExportDialog.vala"
			_current_text_index = _current_text_index + 1;
#line 167 "../src/Dialogs/ExportDialog.vala"
			_tmp4_ = _current_text_index;
#line 167 "../src/Dialogs/ExportDialog.vala"
			_tmp5_ = _current_text_size;
#line 167 "../src/Dialogs/ExportDialog.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 167 "../src/Dialogs/ExportDialog.vala"
				break;
#line 208 "ExportDialog.c"
			}
#line 167 "../src/Dialogs/ExportDialog.vala"
			_tmp6_ = _current_text_list;
#line 167 "../src/Dialogs/ExportDialog.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _current_text_index);
#line 167 "../src/Dialogs/ExportDialog.vala"
			current_text = (gchar*) _tmp7_;
#line 168 "../src/Dialogs/ExportDialog.vala"
			_tmp8_ = current_text;
#line 168 "../src/Dialogs/ExportDialog.vala"
			if (g_strcmp0 (_tmp8_, text) == 0) {
#line 220 "ExportDialog.c"
				GtkComboBoxText* _tmp9_;
#line 169 "../src/Dialogs/ExportDialog.vala"
				_tmp9_ = self->priv->format_combo;
#line 169 "../src/Dialogs/ExportDialog.vala"
				gtk_combo_box_set_active ((GtkComboBox*) _tmp9_, selection_ticker);
#line 170 "../src/Dialogs/ExportDialog.vala"
				_g_free0 (current_text);
#line 170 "../src/Dialogs/ExportDialog.vala"
				return;
#line 230 "ExportDialog.c"
			}
#line 172 "../src/Dialogs/ExportDialog.vala"
			_tmp10_ = selection_ticker;
#line 172 "../src/Dialogs/ExportDialog.vala"
			selection_ticker = _tmp10_ + 1;
#line 167 "../src/Dialogs/ExportDialog.vala"
			_g_free0 (current_text);
#line 238 "ExportDialog.c"
		}
	}
#line 175 "../src/Dialogs/ExportDialog.vala"
	g_error ("ExportDialog.vala:175: format_set_active_text: text '%s' isn't in comb" \
"o box", text);
#line 243 "ExportDialog.c"
}

static PhotoFileFormat
export_dialog_get_specified_format (ExportDialog* self)
{
	gint index = 0;
	GtkComboBoxText* _tmp0_;
	PhotoFileFormat* writeable_formats = NULL;
	gint _tmp1_ = 0;
	PhotoFileFormat* _tmp2_;
	gint writeable_formats_length1;
	gint _writeable_formats_size_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat result;
#line 178 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 179 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->format_combo;
#line 179 "../src/Dialogs/ExportDialog.vala"
	index = gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
#line 180 "../src/Dialogs/ExportDialog.vala"
	if (index < EXPORT_DIALOG_NUM_SPECIAL_FORMATS) {
#line 181 "../src/Dialogs/ExportDialog.vala"
		index = EXPORT_DIALOG_NUM_SPECIAL_FORMATS;
#line 268 "ExportDialog.c"
	}
#line 183 "../src/Dialogs/ExportDialog.vala"
	index -= EXPORT_DIALOG_NUM_SPECIAL_FORMATS;
#line 184 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = photo_file_format_get_writeable (&_tmp1_);
#line 184 "../src/Dialogs/ExportDialog.vala"
	writeable_formats = _tmp2_;
#line 184 "../src/Dialogs/ExportDialog.vala"
	writeable_formats_length1 = _tmp1_;
#line 184 "../src/Dialogs/ExportDialog.vala"
	_writeable_formats_size_ = writeable_formats_length1;
#line 185 "../src/Dialogs/ExportDialog.vala"
	_tmp3_ = writeable_formats[index];
#line 185 "../src/Dialogs/ExportDialog.vala"
	result = _tmp3_;
#line 185 "../src/Dialogs/ExportDialog.vala"
	writeable_formats = (g_free (writeable_formats), NULL);
#line 185 "../src/Dialogs/ExportDialog.vala"
	return result;
#line 288 "ExportDialog.c"
}

static gchar*
export_dialog_get_label_for_parameters (ExportDialog* self,
                                        ExportFormatParameters* params)
{
	ExportFormatParameters _tmp0_;
	gchar* result;
#line 188 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 188 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 189 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = *params;
#line 189 "../src/Dialogs/ExportDialog.vala"
	switch (_tmp0_.mode) {
#line 189 "../src/Dialogs/ExportDialog.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 307 "ExportDialog.c"
		{
			gchar* _tmp1_;
#line 191 "../src/Dialogs/ExportDialog.vala"
			_tmp1_ = g_strdup (EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL);
#line 191 "../src/Dialogs/ExportDialog.vala"
			result = _tmp1_;
#line 191 "../src/Dialogs/ExportDialog.vala"
			return result;
#line 316 "ExportDialog.c"
		}
#line 189 "../src/Dialogs/ExportDialog.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 320 "ExportDialog.c"
		{
			gchar* _tmp2_;
#line 194 "../src/Dialogs/ExportDialog.vala"
			_tmp2_ = g_strdup (EXPORT_DIALOG_CURRENT_FORMAT_LABEL);
#line 194 "../src/Dialogs/ExportDialog.vala"
			result = _tmp2_;
#line 194 "../src/Dialogs/ExportDialog.vala"
			return result;
#line 329 "ExportDialog.c"
		}
#line 189 "../src/Dialogs/ExportDialog.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 333 "ExportDialog.c"
		{
			ExportFormatParameters _tmp3_;
			PhotoFileFormatProperties* _tmp4_;
			PhotoFileFormatProperties* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 197 "../src/Dialogs/ExportDialog.vala"
			_tmp3_ = *params;
#line 197 "../src/Dialogs/ExportDialog.vala"
			_tmp4_ = photo_file_format_get_properties (_tmp3_.specified_format);
#line 197 "../src/Dialogs/ExportDialog.vala"
			_tmp5_ = _tmp4_;
#line 197 "../src/Dialogs/ExportDialog.vala"
			_tmp6_ = photo_file_format_properties_get_user_visible_name (_tmp5_);
#line 197 "../src/Dialogs/ExportDialog.vala"
			_tmp7_ = _tmp6_;
#line 197 "../src/Dialogs/ExportDialog.vala"
			_photo_file_format_properties_unref0 (_tmp5_);
#line 197 "../src/Dialogs/ExportDialog.vala"
			result = _tmp7_;
#line 197 "../src/Dialogs/ExportDialog.vala"
			return result;
#line 356 "ExportDialog.c"
		}
		default:
		{
#line 200 "../src/Dialogs/ExportDialog.vala"
			g_error ("ExportDialog.vala:200: get_label_for_parameters: unrecognized export f" \
"ormat mode");
#line 362 "ExportDialog.c"
		}
	}
}

gboolean
export_dialog_execute (ExportDialog* self,
                       gint* scale,
                       ScaleConstraint* constraint,
                       ExportFormatParameters* parameters)
{
	gint _vala_scale = 0;
	ScaleConstraint _vala_constraint = 0;
	ExportFormatParameters _tmp0_;
	ExportFormatParameters _tmp2_;
	ExportFormatParameters _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean ok = FALSE;
	gboolean result;
#line 207 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (parameters != NULL, FALSE);
#line 209 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 213 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = *parameters;
#line 213 "../src/Dialogs/ExportDialog.vala"
	if (_tmp0_.mode != EXPORT_FORMAT_MODE_LAST) {
#line 392 "ExportDialog.c"
		GtkComboBoxText* _tmp1_;
#line 214 "../src/Dialogs/ExportDialog.vala"
		_vala_constraint = SCALE_CONSTRAINT_ORIGINAL;
#line 214 "../src/Dialogs/ExportDialog.vala"
		export_dialog_current_constraint = _vala_constraint;
#line 215 "../src/Dialogs/ExportDialog.vala"
		_tmp1_ = self->priv->constraint_combo;
#line 215 "../src/Dialogs/ExportDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp1_, 0);
#line 402 "ExportDialog.c"
	}
#line 218 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = *parameters;
#line 218 "../src/Dialogs/ExportDialog.vala"
	if (_tmp2_.mode == EXPORT_FORMAT_MODE_LAST) {
#line 408 "ExportDialog.c"
		ExportFormatParameters _tmp3_;
#line 219 "../src/Dialogs/ExportDialog.vala"
		_tmp3_ = export_dialog_current_parameters;
#line 219 "../src/Dialogs/ExportDialog.vala"
		*parameters = _tmp3_;
#line 414 "ExportDialog.c"
	} else {
		gboolean _tmp4_ = FALSE;
		ExportFormatParameters _tmp5_;
#line 220 "../src/Dialogs/ExportDialog.vala"
		_tmp5_ = *parameters;
#line 220 "../src/Dialogs/ExportDialog.vala"
		if (_tmp5_.mode == EXPORT_FORMAT_MODE_SPECIFIED) {
#line 422 "ExportDialog.c"
			ExportFormatParameters _tmp6_;
#line 220 "../src/Dialogs/ExportDialog.vala"
			_tmp6_ = *parameters;
#line 220 "../src/Dialogs/ExportDialog.vala"
			_tmp4_ = !photo_file_format_can_write (_tmp6_.specified_format);
#line 428 "ExportDialog.c"
		} else {
#line 220 "../src/Dialogs/ExportDialog.vala"
			_tmp4_ = FALSE;
#line 432 "ExportDialog.c"
		}
#line 220 "../src/Dialogs/ExportDialog.vala"
		if (_tmp4_) {
#line 221 "../src/Dialogs/ExportDialog.vala"
			(*parameters).specified_format = photo_file_format_get_system_default_format ();
#line 438 "ExportDialog.c"
		}
	}
#line 223 "../src/Dialogs/ExportDialog.vala"
	_tmp7_ = *parameters;
#line 223 "../src/Dialogs/ExportDialog.vala"
	_tmp8_ = export_dialog_get_label_for_parameters (self, &_tmp7_);
#line 223 "../src/Dialogs/ExportDialog.vala"
	_tmp9_ = _tmp8_;
#line 223 "../src/Dialogs/ExportDialog.vala"
	export_dialog_format_set_active_text (self, _tmp9_);
#line 223 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp9_);
#line 224 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_format_changed (self);
#line 226 "../src/Dialogs/ExportDialog.vala"
	ok = gtk_dialog_run ((GtkDialog*) self) == ((gint) GTK_RESPONSE_OK);
#line 227 "../src/Dialogs/ExportDialog.vala"
	if (ok) {
#line 457 "ExportDialog.c"
		gint index = 0;
		GtkComboBoxText* _tmp10_;
		ScaleConstraint _tmp11_;
		GtkSpinButton* _tmp12_;
		gboolean _tmp13_ = FALSE;
		GtkCheckButton* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		GtkComboBoxText* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gboolean _tmp23_;
#line 228 "../src/Dialogs/ExportDialog.vala"
		_tmp10_ = self->priv->constraint_combo;
#line 228 "../src/Dialogs/ExportDialog.vala"
		index = gtk_combo_box_get_active ((GtkComboBox*) _tmp10_);
#line 229 "../src/Dialogs/ExportDialog.vala"
		_vala_assert (index >= 0, "index >= 0");
#line 230 "../src/Dialogs/ExportDialog.vala"
		_tmp11_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[index];
#line 230 "../src/Dialogs/ExportDialog.vala"
		_vala_constraint = _tmp11_;
#line 231 "../src/Dialogs/ExportDialog.vala"
		export_dialog_current_constraint = _vala_constraint;
#line 233 "../src/Dialogs/ExportDialog.vala"
		_tmp12_ = self->priv->pixels_spinbutton;
#line 233 "../src/Dialogs/ExportDialog.vala"
		_vala_scale = (gint) gtk_spin_button_get_value (_tmp12_);
#line 234 "../src/Dialogs/ExportDialog.vala"
		if (_vala_constraint != SCALE_CONSTRAINT_ORIGINAL) {
#line 235 "../src/Dialogs/ExportDialog.vala"
			_vala_assert (_vala_scale > 0, "scale > 0");
#line 490 "ExportDialog.c"
		}
#line 236 "../src/Dialogs/ExportDialog.vala"
		export_dialog_current_scale = _vala_scale;
#line 238 "../src/Dialogs/ExportDialog.vala"
		_tmp14_ = self->priv->export_metadata;
#line 238 "../src/Dialogs/ExportDialog.vala"
		_tmp15_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp14_);
#line 238 "../src/Dialogs/ExportDialog.vala"
		_tmp16_ = _tmp15_;
#line 238 "../src/Dialogs/ExportDialog.vala"
		if (_tmp16_) {
#line 502 "ExportDialog.c"
			GtkCheckButton* _tmp17_;
			gboolean _tmp18_;
			gboolean _tmp19_;
#line 238 "../src/Dialogs/ExportDialog.vala"
			_tmp17_ = self->priv->export_metadata;
#line 238 "../src/Dialogs/ExportDialog.vala"
			_tmp18_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp17_);
#line 238 "../src/Dialogs/ExportDialog.vala"
			_tmp19_ = _tmp18_;
#line 238 "../src/Dialogs/ExportDialog.vala"
			_tmp13_ = _tmp19_;
#line 514 "ExportDialog.c"
		} else {
#line 238 "../src/Dialogs/ExportDialog.vala"
			_tmp13_ = FALSE;
#line 518 "ExportDialog.c"
		}
#line 238 "../src/Dialogs/ExportDialog.vala"
		(*parameters).export_metadata = _tmp13_;
#line 240 "../src/Dialogs/ExportDialog.vala"
		_tmp20_ = self->priv->format_combo;
#line 240 "../src/Dialogs/ExportDialog.vala"
		_tmp21_ = gtk_combo_box_text_get_active_text (_tmp20_);
#line 240 "../src/Dialogs/ExportDialog.vala"
		_tmp22_ = _tmp21_;
#line 240 "../src/Dialogs/ExportDialog.vala"
		_tmp23_ = g_strcmp0 (_tmp22_, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL) == 0;
#line 240 "../src/Dialogs/ExportDialog.vala"
		_g_free0 (_tmp22_);
#line 240 "../src/Dialogs/ExportDialog.vala"
		if (_tmp23_) {
#line 241 "../src/Dialogs/ExportDialog.vala"
			export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_UNMODIFIED;
#line 241 "../src/Dialogs/ExportDialog.vala"
			(*parameters).mode = export_dialog_current_parameters.mode;
#line 538 "ExportDialog.c"
		} else {
			GtkComboBoxText* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gboolean _tmp27_;
#line 242 "../src/Dialogs/ExportDialog.vala"
			_tmp24_ = self->priv->format_combo;
#line 242 "../src/Dialogs/ExportDialog.vala"
			_tmp25_ = gtk_combo_box_text_get_active_text (_tmp24_);
#line 242 "../src/Dialogs/ExportDialog.vala"
			_tmp26_ = _tmp25_;
#line 242 "../src/Dialogs/ExportDialog.vala"
			_tmp27_ = g_strcmp0 (_tmp26_, EXPORT_DIALOG_CURRENT_FORMAT_LABEL) == 0;
#line 242 "../src/Dialogs/ExportDialog.vala"
			_g_free0 (_tmp26_);
#line 242 "../src/Dialogs/ExportDialog.vala"
			if (_tmp27_) {
#line 243 "../src/Dialogs/ExportDialog.vala"
				export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_CURRENT;
#line 243 "../src/Dialogs/ExportDialog.vala"
				(*parameters).mode = export_dialog_current_parameters.mode;
#line 560 "ExportDialog.c"
			} else {
				ExportFormatParameters _tmp28_;
#line 245 "../src/Dialogs/ExportDialog.vala"
				export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_SPECIFIED;
#line 245 "../src/Dialogs/ExportDialog.vala"
				(*parameters).mode = export_dialog_current_parameters.mode;
#line 246 "../src/Dialogs/ExportDialog.vala"
				export_dialog_current_parameters.specified_format = export_dialog_get_specified_format (self);
#line 246 "../src/Dialogs/ExportDialog.vala"
				(*parameters).specified_format = export_dialog_current_parameters.specified_format;
#line 247 "../src/Dialogs/ExportDialog.vala"
				_tmp28_ = export_dialog_current_parameters;
#line 247 "../src/Dialogs/ExportDialog.vala"
				if (_tmp28_.specified_format == PHOTO_FILE_FORMAT_JFIF) {
#line 575 "ExportDialog.c"
					GtkComboBoxText* _tmp29_;
					JpegQuality _tmp30_;
#line 248 "../src/Dialogs/ExportDialog.vala"
					_tmp29_ = self->priv->quality_combo;
#line 248 "../src/Dialogs/ExportDialog.vala"
					_tmp30_ = EXPORT_DIALOG_QUALITY_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp29_)];
#line 248 "../src/Dialogs/ExportDialog.vala"
					export_dialog_current_parameters.quality = _tmp30_;
#line 248 "../src/Dialogs/ExportDialog.vala"
					(*parameters).quality = export_dialog_current_parameters.quality;
#line 586 "ExportDialog.c"
				}
			}
		}
	} else {
#line 251 "../src/Dialogs/ExportDialog.vala"
		_vala_scale = 0;
#line 252 "../src/Dialogs/ExportDialog.vala"
		_vala_constraint = SCALE_CONSTRAINT_ORIGINAL;
#line 595 "ExportDialog.c"
	}
#line 255 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 257 "../src/Dialogs/ExportDialog.vala"
	result = ok;
#line 257 "../src/Dialogs/ExportDialog.vala"
	if (scale) {
#line 257 "../src/Dialogs/ExportDialog.vala"
		*scale = _vala_scale;
#line 605 "ExportDialog.c"
	}
#line 257 "../src/Dialogs/ExportDialog.vala"
	if (constraint) {
#line 257 "../src/Dialogs/ExportDialog.vala"
		*constraint = _vala_constraint;
#line 611 "ExportDialog.c"
	}
#line 257 "../src/Dialogs/ExportDialog.vala"
	return result;
#line 615 "ExportDialog.c"
}

static void
export_dialog_on_constraint_changed (ExportDialog* self)
{
	gboolean original = FALSE;
	GtkComboBoxText* _tmp0_;
	ScaleConstraint _tmp1_;
	gboolean jpeg = FALSE;
	GtkComboBoxText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoFileFormatProperties* _tmp5_;
	PhotoFileFormatProperties* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	GtkSpinButton* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GtkComboBoxText* _tmp12_;
#line 260 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->constraint_combo;
#line 261 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp0_)];
#line 261 "../src/Dialogs/ExportDialog.vala"
	original = _tmp1_ == SCALE_CONSTRAINT_ORIGINAL;
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = self->priv->format_combo;
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp3_ = gtk_combo_box_text_get_active_text (_tmp2_);
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp4_ = _tmp3_;
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp5_ = photo_file_format_get_properties (PHOTO_FILE_FORMAT_JFIF);
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp6_ = _tmp5_;
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp7_ = photo_file_format_properties_get_user_visible_name (_tmp6_);
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp8_ = _tmp7_;
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp9_ = g_strcmp0 (_tmp4_, _tmp8_) == 0;
#line 262 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp8_);
#line 262 "../src/Dialogs/ExportDialog.vala"
	_photo_file_format_properties_unref0 (_tmp6_);
#line 262 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp4_);
#line 262 "../src/Dialogs/ExportDialog.vala"
	jpeg = _tmp9_;
#line 264 "../src/Dialogs/ExportDialog.vala"
	_tmp10_ = self->priv->pixels_spinbutton;
#line 264 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, !original);
#line 265 "../src/Dialogs/ExportDialog.vala"
	if (!original) {
#line 265 "../src/Dialogs/ExportDialog.vala"
		_tmp11_ = jpeg;
#line 676 "ExportDialog.c"
	} else {
#line 265 "../src/Dialogs/ExportDialog.vala"
		_tmp11_ = FALSE;
#line 680 "ExportDialog.c"
	}
#line 265 "../src/Dialogs/ExportDialog.vala"
	_tmp12_ = self->priv->quality_combo;
#line 265 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, _tmp11_);
#line 266 "../src/Dialogs/ExportDialog.vala"
	if (original) {
#line 688 "ExportDialog.c"
		GtkWidget* _tmp13_;
#line 267 "../src/Dialogs/ExportDialog.vala"
		_tmp13_ = self->priv->export_button;
#line 267 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive (_tmp13_, TRUE);
#line 694 "ExportDialog.c"
	} else {
#line 269 "../src/Dialogs/ExportDialog.vala"
		export_dialog_on_pixels_changed (self);
#line 698 "ExportDialog.c"
	}
}

static void
export_dialog_on_format_changed (ExportDialog* self)
{
	gboolean original = FALSE;
	GtkComboBoxText* _tmp0_;
	ScaleConstraint _tmp1_;
	GtkComboBoxText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
#line 272 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 273 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->constraint_combo;
#line 273 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp0_)];
#line 273 "../src/Dialogs/ExportDialog.vala"
	original = _tmp1_ == SCALE_CONSTRAINT_ORIGINAL;
#line 275 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = self->priv->format_combo;
#line 275 "../src/Dialogs/ExportDialog.vala"
	_tmp3_ = gtk_combo_box_text_get_active_text (_tmp2_);
#line 275 "../src/Dialogs/ExportDialog.vala"
	_tmp4_ = _tmp3_;
#line 275 "../src/Dialogs/ExportDialog.vala"
	_tmp5_ = g_strcmp0 (_tmp4_, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL) == 0;
#line 275 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp4_);
#line 275 "../src/Dialogs/ExportDialog.vala"
	if (_tmp5_) {
#line 732 "ExportDialog.c"
		GtkComboBoxText* _tmp6_;
		GtkComboBoxText* _tmp7_;
		GtkComboBoxText* _tmp8_;
		GtkSpinButton* _tmp9_;
		GtkCheckButton* _tmp10_;
		GtkCheckButton* _tmp11_;
#line 280 "../src/Dialogs/ExportDialog.vala"
		_tmp6_ = self->priv->constraint_combo;
#line 280 "../src/Dialogs/ExportDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp6_, 0);
#line 281 "../src/Dialogs/ExportDialog.vala"
		_tmp7_ = self->priv->constraint_combo;
#line 281 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 282 "../src/Dialogs/ExportDialog.vala"
		_tmp8_ = self->priv->quality_combo;
#line 282 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 283 "../src/Dialogs/ExportDialog.vala"
		_tmp9_ = self->priv->pixels_spinbutton;
#line 283 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 284 "../src/Dialogs/ExportDialog.vala"
		_tmp10_ = self->priv->export_metadata;
#line 284 "../src/Dialogs/ExportDialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp10_, FALSE);
#line 285 "../src/Dialogs/ExportDialog.vala"
		_tmp11_ = self->priv->export_metadata;
#line 285 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 763 "ExportDialog.c"
	} else {
		GtkComboBoxText* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_;
#line 286 "../src/Dialogs/ExportDialog.vala"
		_tmp12_ = self->priv->format_combo;
#line 286 "../src/Dialogs/ExportDialog.vala"
		_tmp13_ = gtk_combo_box_text_get_active_text (_tmp12_);
#line 286 "../src/Dialogs/ExportDialog.vala"
		_tmp14_ = _tmp13_;
#line 286 "../src/Dialogs/ExportDialog.vala"
		_tmp15_ = g_strcmp0 (_tmp14_, EXPORT_DIALOG_CURRENT_FORMAT_LABEL) == 0;
#line 286 "../src/Dialogs/ExportDialog.vala"
		_g_free0 (_tmp14_);
#line 286 "../src/Dialogs/ExportDialog.vala"
		if (_tmp15_) {
#line 781 "ExportDialog.c"
			GtkComboBoxText* _tmp16_;
			GtkComboBoxText* _tmp17_;
			GtkSpinButton* _tmp18_;
			GtkCheckButton* _tmp19_;
#line 293 "../src/Dialogs/ExportDialog.vala"
			_tmp16_ = self->priv->constraint_combo;
#line 293 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, TRUE);
#line 294 "../src/Dialogs/ExportDialog.vala"
			_tmp17_ = self->priv->quality_combo;
#line 294 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, FALSE);
#line 295 "../src/Dialogs/ExportDialog.vala"
			_tmp18_ = self->priv->pixels_spinbutton;
#line 295 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, !original);
#line 296 "../src/Dialogs/ExportDialog.vala"
			_tmp19_ = self->priv->export_metadata;
#line 296 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, TRUE);
#line 802 "ExportDialog.c"
		} else {
			GtkComboBoxText* _tmp20_;
			gboolean jpeg = FALSE;
			gboolean _tmp21_ = FALSE;
			GtkComboBoxText* _tmp22_;
			GtkCheckButton* _tmp23_;
#line 301 "../src/Dialogs/ExportDialog.vala"
			_tmp20_ = self->priv->constraint_combo;
#line 301 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, TRUE);
#line 302 "../src/Dialogs/ExportDialog.vala"
			jpeg = export_dialog_get_specified_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 303 "../src/Dialogs/ExportDialog.vala"
			if (!original) {
#line 303 "../src/Dialogs/ExportDialog.vala"
				_tmp21_ = jpeg;
#line 819 "ExportDialog.c"
			} else {
#line 303 "../src/Dialogs/ExportDialog.vala"
				_tmp21_ = FALSE;
#line 823 "ExportDialog.c"
			}
#line 303 "../src/Dialogs/ExportDialog.vala"
			_tmp22_ = self->priv->quality_combo;
#line 303 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, _tmp21_);
#line 304 "../src/Dialogs/ExportDialog.vala"
			_tmp23_ = self->priv->export_metadata;
#line 304 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, TRUE);
#line 833 "ExportDialog.c"
		}
	}
}

static void
export_dialog_on_pixels_changed (ExportDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GtkSpinButton* _tmp1_;
#line 308 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = self->priv->pixels_spinbutton;
#line 309 "../src/Dialogs/ExportDialog.vala"
	if (((gint) gtk_entry_get_text_length ((GtkEntry*) _tmp1_)) > 0) {
#line 849 "ExportDialog.c"
		GtkSpinButton* _tmp2_;
#line 309 "../src/Dialogs/ExportDialog.vala"
		_tmp2_ = self->priv->pixels_spinbutton;
#line 309 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = gtk_spin_button_get_value (_tmp2_) > ((gdouble) 0);
#line 855 "ExportDialog.c"
	} else {
#line 309 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = FALSE;
#line 859 "ExportDialog.c"
	}
#line 309 "../src/Dialogs/ExportDialog.vala"
	if (_tmp0_) {
#line 863 "ExportDialog.c"
		GtkWidget* _tmp3_;
#line 310 "../src/Dialogs/ExportDialog.vala"
		_tmp3_ = self->priv->export_button;
#line 310 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive (_tmp3_, TRUE);
#line 869 "ExportDialog.c"
	} else {
		GtkWidget* _tmp4_;
#line 312 "../src/Dialogs/ExportDialog.vala"
		_tmp4_ = self->priv->export_button;
#line 312 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive (_tmp4_, FALSE);
#line 876 "ExportDialog.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 57 "../src/Dialogs/ExportDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 885 "ExportDialog.c"
}

static void
_export_dialog_on_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
#line 147 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_constraint_changed ((ExportDialog*) self);
#line 894 "ExportDialog.c"
}

static void
_export_dialog_on_format_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                        gpointer self)
{
#line 148 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_format_changed ((ExportDialog*) self);
#line 903 "ExportDialog.c"
}

static void
_export_dialog_on_pixels_changed_gtk_editable_changed (GtkEditable* _sender,
                                                       gpointer self)
{
#line 149 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_pixels_changed ((ExportDialog*) self);
#line 912 "ExportDialog.c"
}

static void
_export_dialog___lambda41_ (ExportDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GtkSpinButton* _tmp1_;
#line 151 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = self->priv->pixels_spinbutton;
#line 151 "../src/Dialogs/ExportDialog.vala"
	if (((gint) gtk_entry_get_text_length ((GtkEntry*) _tmp1_)) > 0) {
#line 924 "ExportDialog.c"
		GtkSpinButton* _tmp2_;
		const gchar* _tmp3_;
#line 151 "../src/Dialogs/ExportDialog.vala"
		_tmp2_ = self->priv->pixels_spinbutton;
#line 151 "../src/Dialogs/ExportDialog.vala"
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) _tmp2_);
#line 151 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = atoi (_tmp3_) > 0;
#line 933 "ExportDialog.c"
	} else {
#line 151 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = FALSE;
#line 937 "ExportDialog.c"
	}
#line 151 "../src/Dialogs/ExportDialog.vala"
	if (_tmp0_) {
#line 152 "../src/Dialogs/ExportDialog.vala"
		gtk_dialog_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
#line 943 "ExportDialog.c"
	} else {
		GtkSpinButton* _tmp4_;
#line 154 "../src/Dialogs/ExportDialog.vala"
		_tmp4_ = self->priv->pixels_spinbutton;
#line 154 "../src/Dialogs/ExportDialog.vala"
		gtk_spin_button_set_value (_tmp4_, (gdouble) export_dialog_current_scale);
#line 950 "ExportDialog.c"
	}
}

static void
__export_dialog___lambda41__gtk_entry_activate (GtkEntry* _sender,
                                                gpointer self)
{
#line 150 "../src/Dialogs/ExportDialog.vala"
	_export_dialog___lambda41_ ((ExportDialog*) self);
#line 960 "ExportDialog.c"
}

static GObject *
export_dialog_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ExportDialog * self;
	GtkLabel* format_label = NULL;
	GtkComboBoxText* _tmp0_;
	GtkWidget* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	GtkComboBoxText* _tmp3_;
	gint _tmp4_ = 0;
	PhotoFileFormat* _tmp5_;
	GtkLabel* quality_label = NULL;
	GtkComboBoxText* _tmp10_;
	GtkWidget* _tmp11_;
	GtkLabel* _tmp12_ = NULL;
	GtkComboBoxText* _tmp13_;
	gint ctr = 0;
	GtkLabel* constraint_label = NULL;
	GtkComboBoxText* _tmp20_;
	GtkWidget* _tmp21_;
	GtkLabel* _tmp22_ = NULL;
	GtkComboBoxText* _tmp23_;
	GtkSpinButton* _tmp29_ = NULL;
	GtkLabel* size_label = NULL;
	GtkSpinButton* _tmp30_;
	GtkWidget* _tmp31_;
	GtkLabel* _tmp32_ = NULL;
	GtkCheckButton* _tmp33_ = NULL;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp34_ = NULL;
	GtkGrid* _tmp35_;
	GtkLabel* _tmp36_;
	GtkGrid* _tmp37_;
	GtkComboBoxText* _tmp38_;
	GtkGrid* _tmp39_;
	GtkLabel* _tmp40_;
	GtkGrid* _tmp41_;
	GtkComboBoxText* _tmp42_;
	GtkGrid* _tmp43_;
	GtkLabel* _tmp44_;
	GtkGrid* _tmp45_;
	GtkComboBoxText* _tmp46_;
	GtkGrid* _tmp47_;
	GtkLabel* _tmp48_;
	GtkGrid* _tmp49_;
	GtkSpinButton* _tmp50_;
	GtkGrid* _tmp51_;
	GtkCheckButton* _tmp52_;
	GtkBox* _tmp53_;
	GtkGrid* _tmp54_;
	GtkWidget* _tmp55_;
	GtkWidget* _tmp56_;
	GtkWidget* _tmp57_;
	GtkWidget* _tmp58_;
	GtkWidget* _tmp59_;
	GtkStyleContext* _tmp60_;
	GtkWidget* _tmp61_;
	GtkComboBoxText* _tmp64_;
	GtkComboBoxText* _tmp65_;
	GtkSpinButton* _tmp66_;
	GtkSpinButton* _tmp67_;
#line 56 "../src/Dialogs/ExportDialog.vala"
	parent_class = G_OBJECT_CLASS (export_dialog_parent_class);
#line 56 "../src/Dialogs/ExportDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 56 "../src/Dialogs/ExportDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORT_DIALOG, ExportDialog);
#line 57 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->format_combo;
#line 57 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 57 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Format:"));
#line 57 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
#line 57 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_mnemonic_widget (_tmp2_, _tmp1_);
#line 57 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (_tmp1_);
#line 57 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_use_underline (_tmp2_, TRUE);
#line 57 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp2_);
#line 57 "../src/Dialogs/ExportDialog.vala"
	format_label = _tmp2_;
#line 63 "../src/Dialogs/ExportDialog.vala"
	_tmp3_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 63 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp3_);
#line 63 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->format_combo);
#line 63 "../src/Dialogs/ExportDialog.vala"
	self->priv->format_combo = _tmp3_;
#line 64 "../src/Dialogs/ExportDialog.vala"
	export_dialog_format_add_option (self, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL);
#line 65 "../src/Dialogs/ExportDialog.vala"
	export_dialog_format_add_option (self, EXPORT_DIALOG_CURRENT_FORMAT_LABEL);
#line 66 "../src/Dialogs/ExportDialog.vala"
	_tmp5_ = photo_file_format_get_writeable (&_tmp4_);
#line 1066 "ExportDialog.c"
	{
		PhotoFileFormat* format_collection = NULL;
		gint format_collection_length1 = 0;
		gint _format_collection_size_ = 0;
		gint format_it = 0;
#line 66 "../src/Dialogs/ExportDialog.vala"
		format_collection = _tmp5_;
#line 66 "../src/Dialogs/ExportDialog.vala"
		format_collection_length1 = _tmp4_;
#line 66 "../src/Dialogs/ExportDialog.vala"
		for (format_it = 0; format_it < format_collection_length1; format_it = format_it + 1) {
#line 1078 "ExportDialog.c"
			PhotoFileFormat format = 0;
#line 66 "../src/Dialogs/ExportDialog.vala"
			format = format_collection[format_it];
#line 1082 "ExportDialog.c"
			{
				PhotoFileFormatProperties* _tmp6_;
				PhotoFileFormatProperties* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 67 "../src/Dialogs/ExportDialog.vala"
				_tmp6_ = photo_file_format_get_properties (format);
#line 67 "../src/Dialogs/ExportDialog.vala"
				_tmp7_ = _tmp6_;
#line 67 "../src/Dialogs/ExportDialog.vala"
				_tmp8_ = photo_file_format_properties_get_user_visible_name (_tmp7_);
#line 67 "../src/Dialogs/ExportDialog.vala"
				_tmp9_ = _tmp8_;
#line 67 "../src/Dialogs/ExportDialog.vala"
				export_dialog_format_add_option (self, _tmp9_);
#line 67 "../src/Dialogs/ExportDialog.vala"
				_g_free0 (_tmp9_);
#line 67 "../src/Dialogs/ExportDialog.vala"
				_photo_file_format_properties_unref0 (_tmp7_);
#line 1102 "ExportDialog.c"
			}
		}
#line 66 "../src/Dialogs/ExportDialog.vala"
		format_collection = (g_free (format_collection), NULL);
#line 1107 "ExportDialog.c"
	}
#line 70 "../src/Dialogs/ExportDialog.vala"
	_tmp10_ = self->priv->quality_combo;
#line 70 "../src/Dialogs/ExportDialog.vala"
	_tmp11_ = _g_object_ref0 ((GtkWidget*) _tmp10_);
#line 70 "../src/Dialogs/ExportDialog.vala"
	_tmp12_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Quality:"));
#line 70 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp12_, GTK_ALIGN_END);
#line 70 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_mnemonic_widget (_tmp12_, _tmp11_);
#line 70 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (_tmp11_);
#line 70 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_use_underline (_tmp12_, TRUE);
#line 70 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp12_);
#line 70 "../src/Dialogs/ExportDialog.vala"
	quality_label = _tmp12_;
#line 76 "../src/Dialogs/ExportDialog.vala"
	_tmp13_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 76 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp13_);
#line 76 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->quality_combo);
#line 76 "../src/Dialogs/ExportDialog.vala"
	self->priv->quality_combo = _tmp13_;
#line 77 "../src/Dialogs/ExportDialog.vala"
	ctr = 0;
#line 1137 "ExportDialog.c"
	{
		JpegQuality* quality_collection = NULL;
		gint quality_collection_length1 = 0;
		gint _quality_collection_size_ = 0;
		gint quality_it = 0;
#line 78 "../src/Dialogs/ExportDialog.vala"
		quality_collection = EXPORT_DIALOG_QUALITY_ARRAY;
#line 78 "../src/Dialogs/ExportDialog.vala"
		quality_collection_length1 = G_N_ELEMENTS (EXPORT_DIALOG_QUALITY_ARRAY);
#line 78 "../src/Dialogs/ExportDialog.vala"
		for (quality_it = 0; quality_it < quality_collection_length1; quality_it = quality_it + 1) {
#line 1149 "ExportDialog.c"
			JpegQuality quality = 0;
#line 78 "../src/Dialogs/ExportDialog.vala"
			quality = quality_collection[quality_it];
#line 1153 "ExportDialog.c"
			{
				GtkComboBoxText* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				ExportFormatParameters _tmp17_;
				gint _tmp19_;
#line 79 "../src/Dialogs/ExportDialog.vala"
				_tmp14_ = self->priv->quality_combo;
#line 79 "../src/Dialogs/ExportDialog.vala"
				_tmp15_ = jpeg_quality_to_string (quality);
#line 79 "../src/Dialogs/ExportDialog.vala"
				_tmp16_ = _tmp15_;
#line 79 "../src/Dialogs/ExportDialog.vala"
				gtk_combo_box_text_append_text (_tmp14_, _tmp16_);
#line 79 "../src/Dialogs/ExportDialog.vala"
				_g_free0 (_tmp16_);
#line 80 "../src/Dialogs/ExportDialog.vala"
				_tmp17_ = export_dialog_current_parameters;
#line 80 "../src/Dialogs/ExportDialog.vala"
				if (quality == _tmp17_.quality) {
#line 1174 "ExportDialog.c"
					GtkComboBoxText* _tmp18_;
#line 81 "../src/Dialogs/ExportDialog.vala"
					_tmp18_ = self->priv->quality_combo;
#line 81 "../src/Dialogs/ExportDialog.vala"
					gtk_combo_box_set_active ((GtkComboBox*) _tmp18_, ctr);
#line 1180 "ExportDialog.c"
				}
#line 82 "../src/Dialogs/ExportDialog.vala"
				_tmp19_ = ctr;
#line 82 "../src/Dialogs/ExportDialog.vala"
				ctr = _tmp19_ + 1;
#line 1186 "ExportDialog.c"
			}
		}
	}
#line 85 "../src/Dialogs/ExportDialog.vala"
	_tmp20_ = self->priv->constraint_combo;
#line 85 "../src/Dialogs/ExportDialog.vala"
	_tmp21_ = _g_object_ref0 ((GtkWidget*) _tmp20_);
#line 85 "../src/Dialogs/ExportDialog.vala"
	_tmp22_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Scaling constraint:"));
#line 85 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_END);
#line 85 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_mnemonic_widget (_tmp22_, _tmp21_);
#line 85 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (_tmp21_);
#line 85 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_use_underline (_tmp22_, TRUE);
#line 85 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp22_);
#line 85 "../src/Dialogs/ExportDialog.vala"
	constraint_label = _tmp22_;
#line 91 "../src/Dialogs/ExportDialog.vala"
	_tmp23_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 91 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp23_);
#line 91 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->constraint_combo);
#line 91 "../src/Dialogs/ExportDialog.vala"
	self->priv->constraint_combo = _tmp23_;
#line 92 "../src/Dialogs/ExportDialog.vala"
	ctr = 0;
#line 1218 "ExportDialog.c"
	{
		ScaleConstraint* constraint_collection = NULL;
		gint constraint_collection_length1 = 0;
		gint _constraint_collection_size_ = 0;
		gint constraint_it = 0;
#line 93 "../src/Dialogs/ExportDialog.vala"
		constraint_collection = EXPORT_DIALOG_CONSTRAINT_ARRAY;
#line 93 "../src/Dialogs/ExportDialog.vala"
		constraint_collection_length1 = G_N_ELEMENTS (EXPORT_DIALOG_CONSTRAINT_ARRAY);
#line 93 "../src/Dialogs/ExportDialog.vala"
		for (constraint_it = 0; constraint_it < constraint_collection_length1; constraint_it = constraint_it + 1) {
#line 1230 "ExportDialog.c"
			ScaleConstraint constraint = 0;
#line 93 "../src/Dialogs/ExportDialog.vala"
			constraint = constraint_collection[constraint_it];
#line 1234 "ExportDialog.c"
			{
				GtkComboBoxText* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gint _tmp28_;
#line 94 "../src/Dialogs/ExportDialog.vala"
				_tmp24_ = self->priv->constraint_combo;
#line 94 "../src/Dialogs/ExportDialog.vala"
				_tmp25_ = scale_constraint_to_string (constraint);
#line 94 "../src/Dialogs/ExportDialog.vala"
				_tmp26_ = _tmp25_;
#line 94 "../src/Dialogs/ExportDialog.vala"
				gtk_combo_box_text_append_text (_tmp24_, _tmp26_);
#line 94 "../src/Dialogs/ExportDialog.vala"
				_g_free0 (_tmp26_);
#line 95 "../src/Dialogs/ExportDialog.vala"
				if (constraint == export_dialog_current_constraint) {
#line 1252 "ExportDialog.c"
					GtkComboBoxText* _tmp27_;
#line 96 "../src/Dialogs/ExportDialog.vala"
					_tmp27_ = self->priv->constraint_combo;
#line 96 "../src/Dialogs/ExportDialog.vala"
					gtk_combo_box_set_active ((GtkComboBox*) _tmp27_, ctr);
#line 1258 "ExportDialog.c"
				}
#line 97 "../src/Dialogs/ExportDialog.vala"
				_tmp28_ = ctr;
#line 97 "../src/Dialogs/ExportDialog.vala"
				ctr = _tmp28_ + 1;
#line 1264 "ExportDialog.c"
			}
		}
	}
#line 100 "../src/Dialogs/ExportDialog.vala"
	_tmp29_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 999999, (gdouble) 1);
#line 100 "../src/Dialogs/ExportDialog.vala"
	gtk_spin_button_set_digits (_tmp29_, (guint) 0);
#line 100 "../src/Dialogs/ExportDialog.vala"
	gtk_entry_set_max_length ((GtkEntry*) _tmp29_, 6);
#line 100 "../src/Dialogs/ExportDialog.vala"
	gtk_spin_button_set_value (_tmp29_, (gdouble) export_dialog_current_scale);
#line 100 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp29_);
#line 100 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->pixels_spinbutton);
#line 100 "../src/Dialogs/ExportDialog.vala"
	self->priv->pixels_spinbutton = _tmp29_;
#line 106 "../src/Dialogs/ExportDialog.vala"
	_tmp30_ = self->priv->pixels_spinbutton;
#line 106 "../src/Dialogs/ExportDialog.vala"
	_tmp31_ = _g_object_ref0 ((GtkWidget*) _tmp30_);
#line 106 "../src/Dialogs/ExportDialog.vala"
	_tmp32_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Size in pixels:"));
#line 106 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp32_, GTK_ALIGN_END);
#line 106 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_mnemonic_widget (_tmp32_, _tmp31_);
#line 106 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (_tmp31_);
#line 106 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_use_underline (_tmp32_, TRUE);
#line 106 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp32_);
#line 106 "../src/Dialogs/ExportDialog.vala"
	size_label = _tmp32_;
#line 112 "../src/Dialogs/ExportDialog.vala"
	_tmp33_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Export metadata"));
#line 112 "../src/Dialogs/ExportDialog.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp33_, TRUE);
#line 112 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp33_);
#line 112 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->export_metadata);
#line 112 "../src/Dialogs/ExportDialog.vala"
	self->priv->export_metadata = _tmp33_;
#line 116 "../src/Dialogs/ExportDialog.vala"
	_tmp34_ = (GtkGrid*) gtk_grid_new ();
#line 116 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_set_column_spacing (_tmp34_, 12);
#line 116 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_set_row_spacing (_tmp34_, 6);
#line 116 "../src/Dialogs/ExportDialog.vala"
	g_object_set ((GtkWidget*) _tmp34_, "margin", 12, NULL);
#line 116 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp34_, 0);
#line 116 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp34_);
#line 116 "../src/Dialogs/ExportDialog.vala"
	grid = _tmp34_;
#line 122 "../src/Dialogs/ExportDialog.vala"
	_tmp35_ = grid;
#line 122 "../src/Dialogs/ExportDialog.vala"
	_tmp36_ = format_label;
#line 122 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp35_, (GtkWidget*) _tmp36_, 0, 0, 1, 1);
#line 123 "../src/Dialogs/ExportDialog.vala"
	_tmp37_ = grid;
#line 123 "../src/Dialogs/ExportDialog.vala"
	_tmp38_ = self->priv->format_combo;
#line 123 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 1, 0, 1, 1);
#line 124 "../src/Dialogs/ExportDialog.vala"
	_tmp39_ = grid;
#line 124 "../src/Dialogs/ExportDialog.vala"
	_tmp40_ = quality_label;
#line 124 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp40_, 0, 1, 1, 1);
#line 125 "../src/Dialogs/ExportDialog.vala"
	_tmp41_ = grid;
#line 125 "../src/Dialogs/ExportDialog.vala"
	_tmp42_ = self->priv->quality_combo;
#line 125 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp42_, 1, 1, 1, 1);
#line 126 "../src/Dialogs/ExportDialog.vala"
	_tmp43_ = grid;
#line 126 "../src/Dialogs/ExportDialog.vala"
	_tmp44_ = constraint_label;
#line 126 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp43_, (GtkWidget*) _tmp44_, 0, 2, 1, 1);
#line 127 "../src/Dialogs/ExportDialog.vala"
	_tmp45_ = grid;
#line 127 "../src/Dialogs/ExportDialog.vala"
	_tmp46_ = self->priv->constraint_combo;
#line 127 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, 1, 2, 1, 1);
#line 128 "../src/Dialogs/ExportDialog.vala"
	_tmp47_ = grid;
#line 128 "../src/Dialogs/ExportDialog.vala"
	_tmp48_ = size_label;
#line 128 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp47_, (GtkWidget*) _tmp48_, 0, 3, 1, 1);
#line 129 "../src/Dialogs/ExportDialog.vala"
	_tmp49_ = grid;
#line 129 "../src/Dialogs/ExportDialog.vala"
	_tmp50_ = self->priv->pixels_spinbutton;
#line 129 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 1, 3, 1, 1);
#line 130 "../src/Dialogs/ExportDialog.vala"
	_tmp51_ = grid;
#line 130 "../src/Dialogs/ExportDialog.vala"
	_tmp52_ = self->priv->export_metadata;
#line 130 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 1, 4, 1, 1);
#line 132 "../src/Dialogs/ExportDialog.vala"
	_tmp53_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 132 "../src/Dialogs/ExportDialog.vala"
	_tmp54_ = grid;
#line 132 "../src/Dialogs/ExportDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
#line 134 "../src/Dialogs/ExportDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 136 "../src/Dialogs/ExportDialog.vala"
	_tmp55_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("_Export"), (gint) GTK_RESPONSE_OK);
#line 136 "../src/Dialogs/ExportDialog.vala"
	_tmp56_ = _g_object_ref0 (_tmp55_);
#line 136 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->export_button);
#line 136 "../src/Dialogs/ExportDialog.vala"
	self->priv->export_button = _tmp56_;
#line 137 "../src/Dialogs/ExportDialog.vala"
	_tmp57_ = self->priv->export_button;
#line 137 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_can_default (_tmp57_, TRUE);
#line 138 "../src/Dialogs/ExportDialog.vala"
	_tmp58_ = self->priv->export_button;
#line 138 "../src/Dialogs/ExportDialog.vala"
	g_object_set (_tmp58_, "has-default", TRUE, NULL);
#line 139 "../src/Dialogs/ExportDialog.vala"
	_tmp59_ = self->priv->export_button;
#line 139 "../src/Dialogs/ExportDialog.vala"
	_tmp60_ = gtk_widget_get_style_context (_tmp59_);
#line 139 "../src/Dialogs/ExportDialog.vala"
	gtk_style_context_add_class (_tmp60_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 140 "../src/Dialogs/ExportDialog.vala"
	_tmp61_ = self->priv->export_button;
#line 140 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_grab_focus (_tmp61_);
#line 142 "../src/Dialogs/ExportDialog.vala"
	if (export_dialog_current_constraint == SCALE_CONSTRAINT_ORIGINAL) {
#line 1414 "ExportDialog.c"
		GtkSpinButton* _tmp62_;
		GtkComboBoxText* _tmp63_;
#line 143 "../src/Dialogs/ExportDialog.vala"
		_tmp62_ = self->priv->pixels_spinbutton;
#line 143 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp62_, FALSE);
#line 144 "../src/Dialogs/ExportDialog.vala"
		_tmp63_ = self->priv->quality_combo;
#line 144 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp63_, FALSE);
#line 1425 "ExportDialog.c"
	}
#line 147 "../src/Dialogs/ExportDialog.vala"
	_tmp64_ = self->priv->constraint_combo;
#line 147 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp64_, "changed", (GCallback) _export_dialog_on_constraint_changed_gtk_combo_box_changed, self, 0);
#line 148 "../src/Dialogs/ExportDialog.vala"
	_tmp65_ = self->priv->format_combo;
#line 148 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp65_, "changed", (GCallback) _export_dialog_on_format_changed_gtk_combo_box_changed, self, 0);
#line 149 "../src/Dialogs/ExportDialog.vala"
	_tmp66_ = self->priv->pixels_spinbutton;
#line 149 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp66_, "changed", (GCallback) _export_dialog_on_pixels_changed_gtk_editable_changed, self, 0);
#line 150 "../src/Dialogs/ExportDialog.vala"
	_tmp67_ = self->priv->pixels_spinbutton;
#line 150 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object ((GtkEntry*) _tmp67_, "activate", (GCallback) __export_dialog___lambda41__gtk_entry_activate, self, 0);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (grid);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (size_label);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (constraint_label);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (quality_label);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (format_label);
#line 56 "../src/Dialogs/ExportDialog.vala"
	return obj;
#line 1455 "ExportDialog.c"
}

static void
export_dialog_class_init (ExportDialogClass * klass,
                          gpointer klass_data)
{
	ExportFormatParameters _tmp0_ = {0};
#line 21 "../src/Dialogs/ExportDialog.vala"
	export_dialog_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Dialogs/ExportDialog.vala"
	g_type_class_adjust_private_offset (klass, &ExportDialog_private_offset);
#line 21 "../src/Dialogs/ExportDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = export_dialog_constructor;
#line 21 "../src/Dialogs/ExportDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = export_dialog_finalize;
#line 38 "../src/Dialogs/ExportDialog.vala"
	export_format_parameters_current (&_tmp0_);
#line 38 "../src/Dialogs/ExportDialog.vala"
	export_dialog_current_parameters = _tmp0_;
#line 1475 "ExportDialog.c"
}

static void
export_dialog_instance_init (ExportDialog * self,
                             gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 21 "../src/Dialogs/ExportDialog.vala"
	self->priv = export_dialog_get_instance_private (self);
#line 45 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 45 "../src/Dialogs/ExportDialog.vala"
	self->priv->format_options = _tmp0_;
#line 1489 "ExportDialog.c"
}

static void
export_dialog_finalize (GObject * obj)
{
	ExportDialog * self;
#line 21 "../src/Dialogs/ExportDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORT_DIALOG, ExportDialog);
#line 41 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->quality_combo);
#line 42 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->constraint_combo);
#line 43 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->format_combo);
#line 44 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->export_metadata);
#line 45 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->format_options);
#line 46 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->pixels_spinbutton);
#line 47 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->export_button);
#line 21 "../src/Dialogs/ExportDialog.vala"
	G_OBJECT_CLASS (export_dialog_parent_class)->finalize (obj);
#line 1514 "ExportDialog.c"
}

static GType
export_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExportDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) export_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExportDialog), 0, (GInstanceInitFunc) export_dialog_instance_init, NULL };
	GType export_dialog_type_id;
	export_dialog_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "ExportDialog", &g_define_type_info, 0);
	ExportDialog_private_offset = g_type_add_instance_private (export_dialog_type_id, sizeof (ExportDialogPrivate));
	return export_dialog_type_id;
}

GType
export_dialog_get_type (void)
{
	static volatile gsize export_dialog_type_id__once = 0;
	if (g_once_init_enter (&export_dialog_type_id__once)) {
		GType export_dialog_type_id;
		export_dialog_type_id = export_dialog_get_type_once ();
		g_once_init_leave (&export_dialog_type_id__once, export_dialog_type_id);
	}
	return export_dialog_type_id__once;
}

