/* PreferencesDialog.c generated by valac 0.56.18, the Vala compiler
 * generated from PreferencesDialog.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2017 elementary  LLC. (https://github.com/elementary/photos)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <granite.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _preferences_dialog_unref0(var) ((var == NULL) ? NULL : (var = (preferences_dialog_unref (var), NULL)))

#define PREFERENCES_DIALOG_TYPE_PATH_FORMAT (preferences_dialog_path_format_get_type ())
#define PREFERENCES_DIALOG_PATH_FORMAT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PREFERENCES_DIALOG_TYPE_PATH_FORMAT, PreferencesDialogPathFormat))
#define PREFERENCES_DIALOG_PATH_FORMAT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PREFERENCES_DIALOG_TYPE_PATH_FORMAT, PreferencesDialogPathFormatClass))
#define PREFERENCES_DIALOG_IS_PATH_FORMAT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PREFERENCES_DIALOG_TYPE_PATH_FORMAT))
#define PREFERENCES_DIALOG_IS_PATH_FORMAT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PREFERENCES_DIALOG_TYPE_PATH_FORMAT))
#define PREFERENCES_DIALOG_PATH_FORMAT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PREFERENCES_DIALOG_TYPE_PATH_FORMAT, PreferencesDialogPathFormatClass))

typedef struct _PreferencesDialogPathFormat PreferencesDialogPathFormat;
typedef struct _PreferencesDialogPathFormatClass PreferencesDialogPathFormatClass;
typedef struct _PreferencesDialogPathFormatPrivate PreferencesDialogPathFormatPrivate;
typedef struct _PreferencesDialogParamSpecPathFormat PreferencesDialogParamSpecPathFormat;
typedef struct _ParamSpecPreferencesDialog ParamSpecPreferencesDialog;

struct _PreferencesDialogPrivate {
	GraniteDialog* dialog;
	GtkFileChooserButton* library_dir_button;
	gchar* lib_dir;
	GtkComboBoxText* default_raw_developer_combo;
	GSettings* file_settings;
};

struct _PreferencesDialogPathFormat {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PreferencesDialogPathFormatPrivate * priv;
	gchar* name;
	gchar* pattern;
};

struct _PreferencesDialogPathFormatClass {
	GTypeClass parent_class;
	void (*finalize) (PreferencesDialogPathFormat *self);
};

struct _PreferencesDialogParamSpecPathFormat {
	GParamSpec parent_instance;
};

struct _ParamSpecPreferencesDialog {
	GParamSpec parent_instance;
};

static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;
static PreferencesDialog* preferences_dialog_preferences_dialog;
static PreferencesDialog* preferences_dialog_preferences_dialog = NULL;
static gpointer preferences_dialog_path_format_parent_class = NULL;

static PreferencesDialog* preferences_dialog_new (void);
static PreferencesDialog* preferences_dialog_construct (GType object_type);
static gboolean preferences_dialog_on_delete (PreferencesDialog* self);
static gboolean _preferences_dialog_on_delete_gtk_widget_delete_event (GtkWidget* _sender,
                                                                GdkEventAny* event,
                                                                gpointer self);
static gboolean preferences_dialog_map_event_handler (PreferencesDialog* self);
static gboolean _preferences_dialog_map_event_handler_gtk_widget_map_event (GtkWidget* _sender,
                                                                     GdkEventAny* event,
                                                                     gpointer self);
static void preferences_dialog_set_raw_developer_combo (PreferencesDialog* self,
                                                 RawDeveloper d);
static void preferences_dialog_on_default_raw_developer_changed (PreferencesDialog* self);
static void _preferences_dialog_on_default_raw_developer_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                                 gpointer self);
static void preferences_dialog_on_close (PreferencesDialog* self);
static void _preferences_dialog_on_close_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
VALA_EXTERN GFile* app_dirs_get_import_dir (void);
static void preferences_dialog_commit_on_close (PreferencesDialog* self);
VALA_EXTERN void app_dirs_set_import_dir (const gchar* path);
static RawDeveloper preferences_dialog_raw_developer_from_combo (PreferencesDialog* self);
static void preferences_dialog_on_current_folder_changed (PreferencesDialog* self);
static void _preferences_dialog_on_current_folder_changed_gtk_file_chooser_current_folder_changed (GtkFileChooser* _sender,
                                                                                            gpointer self);
static gpointer preferences_dialog_path_format_ref (gpointer instance);
static void preferences_dialog_path_format_unref (gpointer instance);
static GParamSpec* preferences_dialog_param_spec_path_format (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags) G_GNUC_UNUSED ;
static void preferences_dialog_value_set_path_format (GValue* value,
                                               gpointer v_object) G_GNUC_UNUSED ;
static void preferences_dialog_value_take_path_format (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED ;
static gpointer preferences_dialog_value_get_path_format (const GValue* value) G_GNUC_UNUSED ;
static GType preferences_dialog_path_format_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static PreferencesDialogPathFormat* preferences_dialog_path_format_new (const gchar* name,
                                                                 const gchar* pattern);
static PreferencesDialogPathFormat* preferences_dialog_path_format_construct (GType object_type,
                                                                       const gchar* name,
                                                                       const gchar* pattern);
static void preferences_dialog_path_format_finalize (PreferencesDialogPathFormat * obj);
static GType preferences_dialog_path_format_get_type_once (void);
static void preferences_dialog_finalize (PreferencesDialog * obj);
static GType preferences_dialog_get_type_once (void);

static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}

static gboolean
_preferences_dialog_on_delete_gtk_widget_delete_event (GtkWidget* _sender,
                                                       GdkEventAny* event,
                                                       gpointer self)
{
	gboolean result;
	result = preferences_dialog_on_delete ((PreferencesDialog*) self);
#line 46 "../src/Dialogs/PreferencesDialog.vala"
	return result;
#line 161 "PreferencesDialog.c"
}

static gboolean
_preferences_dialog_map_event_handler_gtk_widget_map_event (GtkWidget* _sender,
                                                            GdkEventAny* event,
                                                            gpointer self)
{
	gboolean result;
	result = preferences_dialog_map_event_handler ((PreferencesDialog*) self);
#line 47 "../src/Dialogs/PreferencesDialog.vala"
	return result;
#line 173 "PreferencesDialog.c"
}

static void
_preferences_dialog_on_default_raw_developer_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                            gpointer self)
{
#line 84 "../src/Dialogs/PreferencesDialog.vala"
	preferences_dialog_on_default_raw_developer_changed ((PreferencesDialog*) self);
#line 182 "PreferencesDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 121 "../src/Dialogs/PreferencesDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 190 "PreferencesDialog.c"
}

static void
_preferences_dialog_on_close_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 128 "../src/Dialogs/PreferencesDialog.vala"
	preferences_dialog_on_close ((PreferencesDialog*) self);
#line 199 "PreferencesDialog.c"
}

static PreferencesDialog*
preferences_dialog_construct (GType object_type)
{
	PreferencesDialog* self = NULL;
	GSettings* _tmp0_;
	GraniteDialog* _tmp1_;
	GraniteDialog* _tmp2_;
	GraniteDialog* _tmp3_;
	GraniteDialog* _tmp4_;
	GraniteDialog* _tmp5_;
	GraniteDialog* _tmp6_;
	GraniteDialog* _tmp7_;
	AppWindow* _tmp8_;
	AppWindow* _tmp9_;
	GdkWindow* _tmp10_;
	GraniteHeaderLabel* library_header = NULL;
	GraniteHeaderLabel* _tmp11_;
	GtkFileChooserButton* _tmp12_;
	GtkLabel* library_dir_label = NULL;
	GtkLabel* _tmp13_;
	GtkFileChooserButton* _tmp14_;
	GtkLabel* auto_import_label = NULL;
	GtkLabel* _tmp15_;
	GtkSwitch* auto_import_switch = NULL;
	GtkSwitch* _tmp16_;
	GtkSwitch* lowercase_switch = NULL;
	GtkSwitch* _tmp17_;
	GtkLabel* lowercase_label = NULL;
	GtkLabel* _tmp18_;
	GtkSwitch* commit_metadata_switch = NULL;
	GtkSwitch* _tmp19_;
	GtkLabel* commit_metadata_label = NULL;
	GtkLabel* _tmp20_;
	GraniteHeaderLabel* raw_header = NULL;
	GraniteHeaderLabel* _tmp21_;
	GtkComboBoxText* _tmp22_;
	GtkComboBoxText* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkComboBoxText* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GSettings* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GtkComboBoxText* _tmp32_;
	GtkLabel* default_raw_developer_label = NULL;
	GtkLabel* _tmp33_;
	GtkComboBoxText* _tmp34_;
	GtkGrid* library_grid = NULL;
	GtkGrid* _tmp35_;
	GtkFileChooserButton* _tmp36_;
	GtkComboBoxText* _tmp37_;
	PluginsManifestWidget* manifest_widget = NULL;
	PluginsManifestWidget* _tmp38_;
	GtkStack* stack = NULL;
	GtkStack* _tmp39_;
	GtkStackSwitcher* switcher = NULL;
	GtkStackSwitcher* _tmp40_;
	GtkBox* content = NULL;
	GraniteDialog* _tmp41_;
	GtkBox* _tmp42_;
	GtkBox* _tmp43_;
	GtkWidget* close_button = NULL;
	GraniteDialog* _tmp44_;
	GtkWidget* _tmp45_;
	GtkWidget* _tmp46_;
	GSettings* file_settings = NULL;
	GSettings* _tmp47_;
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	self = (PreferencesDialog*) g_type_create_instance (object_type);
#line 40 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_FILES_PREFS_SCHEMA_NAME);
#line 40 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 40 "../src/Dialogs/PreferencesDialog.vala"
	self->priv->file_settings = _tmp0_;
#line 42 "../src/Dialogs/PreferencesDialog.vala"
	_tmp1_ = granite_dialog_new ();
#line 42 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp1_);
#line 42 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 42 "../src/Dialogs/PreferencesDialog.vala"
	self->priv->dialog = _tmp1_;
#line 43 "../src/Dialogs/PreferencesDialog.vala"
	_tmp2_ = self->priv->dialog;
#line 43 "../src/Dialogs/PreferencesDialog.vala"
	g_object_set ((GtkWidget*) _tmp2_, "width-request", 450, NULL);
#line 44 "../src/Dialogs/PreferencesDialog.vala"
	_tmp3_ = self->priv->dialog;
#line 44 "../src/Dialogs/PreferencesDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) _tmp3_, FALSE);
#line 45 "../src/Dialogs/PreferencesDialog.vala"
	_tmp4_ = self->priv->dialog;
#line 45 "../src/Dialogs/PreferencesDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) _tmp4_, FALSE);
#line 46 "../src/Dialogs/PreferencesDialog.vala"
	_tmp5_ = self->priv->dialog;
#line 46 "../src/Dialogs/PreferencesDialog.vala"
	g_signal_connect ((GtkWidget*) _tmp5_, "delete-event", (GCallback) _preferences_dialog_on_delete_gtk_widget_delete_event, self);
#line 47 "../src/Dialogs/PreferencesDialog.vala"
	_tmp6_ = self->priv->dialog;
#line 47 "../src/Dialogs/PreferencesDialog.vala"
	g_signal_connect ((GtkWidget*) _tmp6_, "map-event", (GCallback) _preferences_dialog_map_event_handler_gtk_widget_map_event, self);
#line 48 "../src/Dialogs/PreferencesDialog.vala"
	_tmp7_ = self->priv->dialog;
#line 48 "../src/Dialogs/PreferencesDialog.vala"
	_tmp8_ = app_window_get_instance ();
#line 48 "../src/Dialogs/PreferencesDialog.vala"
	_tmp9_ = _tmp8_;
#line 48 "../src/Dialogs/PreferencesDialog.vala"
	_tmp10_ = gtk_widget_get_parent_window ((GtkWidget*) _tmp9_);
#line 48 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_parent_window ((GtkWidget*) _tmp7_, _tmp10_);
#line 48 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (_tmp9_);
#line 50 "../src/Dialogs/PreferencesDialog.vala"
	_tmp11_ = granite_header_label_new (_ ("Library"));
#line 50 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp11_);
#line 50 "../src/Dialogs/PreferencesDialog.vala"
	library_header = _tmp11_;
#line 52 "../src/Dialogs/PreferencesDialog.vala"
	_tmp12_ = (GtkFileChooserButton*) gtk_file_chooser_button_new ("", GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
#line 52 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp12_);
#line 52 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (self->priv->library_dir_button);
#line 52 "../src/Dialogs/PreferencesDialog.vala"
	self->priv->library_dir_button = _tmp12_;
#line 54 "../src/Dialogs/PreferencesDialog.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Import photos to:"));
#line 54 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp13_);
#line 54 "../src/Dialogs/PreferencesDialog.vala"
	library_dir_label = _tmp13_;
#line 55 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) library_dir_label, GTK_ALIGN_END);
#line 56 "../src/Dialogs/PreferencesDialog.vala"
	_tmp14_ = self->priv->library_dir_button;
#line 56 "../src/Dialogs/PreferencesDialog.vala"
	gtk_label_set_mnemonic_widget (library_dir_label, (GtkWidget*) _tmp14_);
#line 58 "../src/Dialogs/PreferencesDialog.vala"
	_tmp15_ = (GtkLabel*) gtk_label_new (_ ("Watch library for new files:"));
#line 58 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp15_);
#line 58 "../src/Dialogs/PreferencesDialog.vala"
	auto_import_label = _tmp15_;
#line 59 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) auto_import_label, GTK_ALIGN_END);
#line 61 "../src/Dialogs/PreferencesDialog.vala"
	_tmp16_ = (GtkSwitch*) gtk_switch_new ();
#line 61 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp16_);
#line 61 "../src/Dialogs/PreferencesDialog.vala"
	auto_import_switch = _tmp16_;
#line 62 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) auto_import_switch, GTK_ALIGN_START);
#line 64 "../src/Dialogs/PreferencesDialog.vala"
	_tmp17_ = (GtkSwitch*) gtk_switch_new ();
#line 64 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp17_);
#line 64 "../src/Dialogs/PreferencesDialog.vala"
	lowercase_switch = _tmp17_;
#line 65 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) lowercase_switch, GTK_ALIGN_START);
#line 67 "../src/Dialogs/PreferencesDialog.vala"
	_tmp18_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("R_ename imported files to lowercase:"));
#line 67 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp18_);
#line 67 "../src/Dialogs/PreferencesDialog.vala"
	lowercase_label = _tmp18_;
#line 68 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) lowercase_label, GTK_ALIGN_END);
#line 69 "../src/Dialogs/PreferencesDialog.vala"
	gtk_label_set_mnemonic_widget (lowercase_label, (GtkWidget*) lowercase_switch);
#line 71 "../src/Dialogs/PreferencesDialog.vala"
	_tmp19_ = (GtkSwitch*) gtk_switch_new ();
#line 71 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp19_);
#line 71 "../src/Dialogs/PreferencesDialog.vala"
	commit_metadata_switch = _tmp19_;
#line 72 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) commit_metadata_switch, GTK_ALIGN_START);
#line 74 "../src/Dialogs/PreferencesDialog.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Write _metadata to files:"));
#line 74 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp20_);
#line 74 "../src/Dialogs/PreferencesDialog.vala"
	commit_metadata_label = _tmp20_;
#line 75 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) commit_metadata_label, GTK_ALIGN_END);
#line 76 "../src/Dialogs/PreferencesDialog.vala"
	gtk_label_set_mnemonic_widget (commit_metadata_label, (GtkWidget*) commit_metadata_switch);
#line 78 "../src/Dialogs/PreferencesDialog.vala"
	_tmp21_ = granite_header_label_new (_ ("RAW Developer"));
#line 78 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp21_);
#line 78 "../src/Dialogs/PreferencesDialog.vala"
	raw_header = _tmp21_;
#line 80 "../src/Dialogs/PreferencesDialog.vala"
	_tmp22_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 80 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp22_);
#line 80 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (self->priv->default_raw_developer_combo);
#line 80 "../src/Dialogs/PreferencesDialog.vala"
	self->priv->default_raw_developer_combo = _tmp22_;
#line 81 "../src/Dialogs/PreferencesDialog.vala"
	_tmp23_ = self->priv->default_raw_developer_combo;
#line 81 "../src/Dialogs/PreferencesDialog.vala"
	_tmp24_ = raw_developer_get_label (RAW_DEVELOPER_CAMERA);
#line 81 "../src/Dialogs/PreferencesDialog.vala"
	_tmp25_ = _tmp24_;
#line 81 "../src/Dialogs/PreferencesDialog.vala"
	gtk_combo_box_text_append_text (_tmp23_, _tmp25_);
#line 81 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (_tmp25_);
#line 82 "../src/Dialogs/PreferencesDialog.vala"
	_tmp26_ = self->priv->default_raw_developer_combo;
#line 82 "../src/Dialogs/PreferencesDialog.vala"
	_tmp27_ = raw_developer_get_label (RAW_DEVELOPER_SHOTWELL);
#line 82 "../src/Dialogs/PreferencesDialog.vala"
	_tmp28_ = _tmp27_;
#line 82 "../src/Dialogs/PreferencesDialog.vala"
	gtk_combo_box_text_append_text (_tmp26_, _tmp28_);
#line 82 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (_tmp28_);
#line 83 "../src/Dialogs/PreferencesDialog.vala"
	_tmp29_ = self->priv->file_settings;
#line 83 "../src/Dialogs/PreferencesDialog.vala"
	_tmp30_ = g_settings_get_string (_tmp29_, "raw-developer-default");
#line 83 "../src/Dialogs/PreferencesDialog.vala"
	_tmp31_ = _tmp30_;
#line 83 "../src/Dialogs/PreferencesDialog.vala"
	preferences_dialog_set_raw_developer_combo (self, raw_developer_from_string (_tmp31_));
#line 83 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (_tmp31_);
#line 84 "../src/Dialogs/PreferencesDialog.vala"
	_tmp32_ = self->priv->default_raw_developer_combo;
#line 84 "../src/Dialogs/PreferencesDialog.vala"
	g_signal_connect ((GtkComboBox*) _tmp32_, "changed", (GCallback) _preferences_dialog_on_default_raw_developer_changed_gtk_combo_box_changed, self);
#line 86 "../src/Dialogs/PreferencesDialog.vala"
	_tmp33_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("De_fault:"));
#line 86 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp33_);
#line 86 "../src/Dialogs/PreferencesDialog.vala"
	default_raw_developer_label = _tmp33_;
#line 87 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) default_raw_developer_label, GTK_ALIGN_END);
#line 88 "../src/Dialogs/PreferencesDialog.vala"
	_tmp34_ = self->priv->default_raw_developer_combo;
#line 88 "../src/Dialogs/PreferencesDialog.vala"
	gtk_label_set_mnemonic_widget (default_raw_developer_label, (GtkWidget*) _tmp34_);
#line 90 "../src/Dialogs/PreferencesDialog.vala"
	_tmp35_ = (GtkGrid*) gtk_grid_new ();
#line 90 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp35_);
#line 90 "../src/Dialogs/PreferencesDialog.vala"
	library_grid = _tmp35_;
#line 91 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_set_column_spacing (library_grid, 12);
#line 92 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_set_row_spacing (library_grid, 6);
#line 93 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) library_header, 0, 0, 2, 1);
#line 94 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) library_dir_label, 0, 1, 1, 1);
#line 95 "../src/Dialogs/PreferencesDialog.vala"
	_tmp36_ = self->priv->library_dir_button;
#line 95 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) _tmp36_, 1, 1, 1, 1);
#line 96 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) auto_import_label, 0, 2, 1, 1);
#line 97 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) auto_import_switch, 1, 2, 1, 1);
#line 98 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) lowercase_label, 0, 3, 1, 1);
#line 99 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) lowercase_switch, 1, 3, 1, 1);
#line 100 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) commit_metadata_label, 0, 4, 1, 1);
#line 101 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) commit_metadata_switch, 1, 4, 1, 1);
#line 102 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) raw_header, 0, 5, 2, 1);
#line 103 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) default_raw_developer_label, 0, 6, 1, 1);
#line 104 "../src/Dialogs/PreferencesDialog.vala"
	_tmp37_ = self->priv->default_raw_developer_combo;
#line 104 "../src/Dialogs/PreferencesDialog.vala"
	gtk_grid_attach (library_grid, (GtkWidget*) _tmp37_, 1, 6, 1, 1);
#line 106 "../src/Dialogs/PreferencesDialog.vala"
	_tmp38_ = plugins_manifest_widget_new ();
#line 106 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp38_);
#line 106 "../src/Dialogs/PreferencesDialog.vala"
	manifest_widget = _tmp38_;
#line 108 "../src/Dialogs/PreferencesDialog.vala"
	_tmp39_ = (GtkStack*) gtk_stack_new ();
#line 108 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp39_);
#line 108 "../src/Dialogs/PreferencesDialog.vala"
	stack = _tmp39_;
#line 109 "../src/Dialogs/PreferencesDialog.vala"
	g_object_set ((GtkWidget*) stack, "expand", TRUE, NULL);
#line 110 "../src/Dialogs/PreferencesDialog.vala"
	g_object_set ((GtkWidget*) stack, "margin", 6, NULL);
#line 111 "../src/Dialogs/PreferencesDialog.vala"
	gtk_stack_add_titled (stack, (GtkWidget*) library_grid, "library", _ ("Library"));
#line 112 "../src/Dialogs/PreferencesDialog.vala"
	gtk_stack_add_titled (stack, (GtkWidget*) manifest_widget, "plugins", _ ("Plugins"));
#line 114 "../src/Dialogs/PreferencesDialog.vala"
	_tmp40_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 114 "../src/Dialogs/PreferencesDialog.vala"
	g_object_ref_sink (_tmp40_);
#line 114 "../src/Dialogs/PreferencesDialog.vala"
	switcher = _tmp40_;
#line 115 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) switcher, GTK_ALIGN_CENTER);
#line 116 "../src/Dialogs/PreferencesDialog.vala"
	gtk_box_set_homogeneous ((GtkBox*) switcher, TRUE);
#line 117 "../src/Dialogs/PreferencesDialog.vala"
	g_object_set ((GtkWidget*) switcher, "expand", TRUE, NULL);
#line 118 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) switcher, 6);
#line 119 "../src/Dialogs/PreferencesDialog.vala"
	gtk_stack_switcher_set_stack (switcher, stack);
#line 121 "../src/Dialogs/PreferencesDialog.vala"
	_tmp41_ = self->priv->dialog;
#line 121 "../src/Dialogs/PreferencesDialog.vala"
	_tmp42_ = gtk_dialog_get_content_area ((GtkDialog*) _tmp41_);
#line 121 "../src/Dialogs/PreferencesDialog.vala"
	_tmp43_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, gtk_box_get_type ()) ? ((GtkBox*) _tmp42_) : NULL);
#line 121 "../src/Dialogs/PreferencesDialog.vala"
	content = _tmp43_;
#line 122 "../src/Dialogs/PreferencesDialog.vala"
	g_object_set ((GtkWidget*) content, "margin", 6, NULL);
#line 123 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) content, 0);
#line 124 "../src/Dialogs/PreferencesDialog.vala"
	gtk_container_add ((GtkContainer*) content, (GtkWidget*) switcher);
#line 125 "../src/Dialogs/PreferencesDialog.vala"
	gtk_container_add ((GtkContainer*) content, (GtkWidget*) stack);
#line 127 "../src/Dialogs/PreferencesDialog.vala"
	_tmp44_ = self->priv->dialog;
#line 127 "../src/Dialogs/PreferencesDialog.vala"
	_tmp45_ = gtk_dialog_add_button ((GtkDialog*) _tmp44_, _ ("_Close"), (gint) GTK_RESPONSE_CLOSE);
#line 127 "../src/Dialogs/PreferencesDialog.vala"
	_tmp46_ = _g_object_ref0 (_tmp45_);
#line 127 "../src/Dialogs/PreferencesDialog.vala"
	close_button = _tmp46_;
#line 128 "../src/Dialogs/PreferencesDialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (close_button, gtk_button_get_type (), GtkButton), "clicked", (GCallback) _preferences_dialog_on_close_gtk_button_clicked, self);
#line 130 "../src/Dialogs/PreferencesDialog.vala"
	_tmp47_ = g_settings_new ("io.elementary.photos.preferences.files");
#line 130 "../src/Dialogs/PreferencesDialog.vala"
	file_settings = _tmp47_;
#line 131 "../src/Dialogs/PreferencesDialog.vala"
	g_settings_bind (file_settings, "auto-import", (GObject*) auto_import_switch, "active", G_SETTINGS_BIND_DEFAULT);
#line 132 "../src/Dialogs/PreferencesDialog.vala"
	g_settings_bind (file_settings, "commit-metadata", (GObject*) commit_metadata_switch, "active", G_SETTINGS_BIND_DEFAULT);
#line 133 "../src/Dialogs/PreferencesDialog.vala"
	g_settings_bind (file_settings, "use-lowercase-filenames", (GObject*) lowercase_switch, "active", G_SETTINGS_BIND_DEFAULT);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (file_settings);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (close_button);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (content);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (switcher);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (stack);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (manifest_widget);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (library_grid);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (default_raw_developer_label);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (raw_header);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (commit_metadata_label);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (commit_metadata_switch);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (lowercase_label);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (lowercase_switch);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (auto_import_switch);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (auto_import_label);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (library_dir_label);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (library_header);
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	return self;
#line 603 "PreferencesDialog.c"
}

static PreferencesDialog*
preferences_dialog_new (void)
{
#line 39 "../src/Dialogs/PreferencesDialog.vala"
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG);
#line 611 "PreferencesDialog.c"
}

void
preferences_dialog_show (void)
{
	PreferencesDialog* _tmp0_;
	PreferencesDialog* _tmp2_;
	GraniteDialog* _tmp3_;
	PreferencesDialog* _tmp4_;
	GtkFileChooserButton* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	PreferencesDialog* _tmp10_;
	GraniteDialog* _tmp11_;
#line 137 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = preferences_dialog_preferences_dialog;
#line 137 "../src/Dialogs/PreferencesDialog.vala"
	if (_tmp0_ == NULL) {
#line 632 "PreferencesDialog.c"
		PreferencesDialog* _tmp1_;
#line 138 "../src/Dialogs/PreferencesDialog.vala"
		_tmp1_ = preferences_dialog_new ();
#line 138 "../src/Dialogs/PreferencesDialog.vala"
		_preferences_dialog_unref0 (preferences_dialog_preferences_dialog);
#line 138 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_preferences_dialog = _tmp1_;
#line 640 "PreferencesDialog.c"
	}
#line 141 "../src/Dialogs/PreferencesDialog.vala"
	_tmp2_ = preferences_dialog_preferences_dialog;
#line 141 "../src/Dialogs/PreferencesDialog.vala"
	_tmp3_ = _tmp2_->priv->dialog;
#line 141 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	_tmp4_ = preferences_dialog_preferences_dialog;
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	_tmp5_ = _tmp4_->priv->library_dir_button;
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	_tmp6_ = app_dirs_get_import_dir ();
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	_tmp7_ = _tmp6_;
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	_tmp8_ = g_file_get_path (_tmp7_);
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	_tmp9_ = _tmp8_;
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp5_, _tmp9_);
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (_tmp9_);
#line 142 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (_tmp7_);
#line 146 "../src/Dialogs/PreferencesDialog.vala"
	_tmp10_ = preferences_dialog_preferences_dialog;
#line 146 "../src/Dialogs/PreferencesDialog.vala"
	_tmp11_ = _tmp10_->priv->dialog;
#line 146 "../src/Dialogs/PreferencesDialog.vala"
	gtk_window_present ((GtkWindow*) _tmp11_);
#line 672 "PreferencesDialog.c"
}

static void
preferences_dialog_commit_on_close (PreferencesDialog* self)
{
	const gchar* _tmp0_;
#line 149 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = self->priv->lib_dir;
#line 150 "../src/Dialogs/PreferencesDialog.vala"
	if (_tmp0_ != NULL) {
#line 685 "PreferencesDialog.c"
		const gchar* _tmp1_;
#line 151 "../src/Dialogs/PreferencesDialog.vala"
		_tmp1_ = self->priv->lib_dir;
#line 151 "../src/Dialogs/PreferencesDialog.vala"
		app_dirs_set_import_dir (_tmp1_);
#line 691 "PreferencesDialog.c"
	}
}

static gboolean
preferences_dialog_on_delete (PreferencesDialog* self)
{
	GraniteDialog* _tmp0_;
	gboolean result;
#line 155 "../src/Dialogs/PreferencesDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "../src/Dialogs/PreferencesDialog.vala"
	preferences_dialog_commit_on_close (self);
#line 157 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = self->priv->dialog;
#line 157 "../src/Dialogs/PreferencesDialog.vala"
	result = gtk_widget_hide_on_delete ((GtkWidget*) _tmp0_);
#line 157 "../src/Dialogs/PreferencesDialog.vala"
	return result;
#line 710 "PreferencesDialog.c"
}

static void
preferences_dialog_on_close (PreferencesDialog* self)
{
	GraniteDialog* _tmp0_;
#line 160 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = self->priv->dialog;
#line 161 "../src/Dialogs/PreferencesDialog.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 162 "../src/Dialogs/PreferencesDialog.vala"
	preferences_dialog_commit_on_close (self);
#line 725 "PreferencesDialog.c"
}

static RawDeveloper
preferences_dialog_raw_developer_from_combo (PreferencesDialog* self)
{
	GtkComboBoxText* _tmp0_;
	RawDeveloper result;
#line 165 "../src/Dialogs/PreferencesDialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 166 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = self->priv->default_raw_developer_combo;
#line 166 "../src/Dialogs/PreferencesDialog.vala"
	if (gtk_combo_box_get_active ((GtkComboBox*) _tmp0_) == 0) {
#line 167 "../src/Dialogs/PreferencesDialog.vala"
		result = RAW_DEVELOPER_CAMERA;
#line 167 "../src/Dialogs/PreferencesDialog.vala"
		return result;
#line 743 "PreferencesDialog.c"
	}
#line 168 "../src/Dialogs/PreferencesDialog.vala"
	result = RAW_DEVELOPER_SHOTWELL;
#line 168 "../src/Dialogs/PreferencesDialog.vala"
	return result;
#line 749 "PreferencesDialog.c"
}

static void
preferences_dialog_set_raw_developer_combo (PreferencesDialog* self,
                                            RawDeveloper d)
{
#line 171 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/Dialogs/PreferencesDialog.vala"
	if (d == RAW_DEVELOPER_CAMERA) {
#line 760 "PreferencesDialog.c"
		GtkComboBoxText* _tmp0_;
#line 173 "../src/Dialogs/PreferencesDialog.vala"
		_tmp0_ = self->priv->default_raw_developer_combo;
#line 173 "../src/Dialogs/PreferencesDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp0_, 0);
#line 766 "PreferencesDialog.c"
	} else {
		GtkComboBoxText* _tmp1_;
#line 175 "../src/Dialogs/PreferencesDialog.vala"
		_tmp1_ = self->priv->default_raw_developer_combo;
#line 175 "../src/Dialogs/PreferencesDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp1_, 1);
#line 773 "PreferencesDialog.c"
	}
}

static void
preferences_dialog_on_default_raw_developer_changed (PreferencesDialog* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 178 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = self->priv->file_settings;
#line 179 "../src/Dialogs/PreferencesDialog.vala"
	_tmp1_ = raw_developer_to_string (preferences_dialog_raw_developer_from_combo (self));
#line 179 "../src/Dialogs/PreferencesDialog.vala"
	_tmp2_ = _tmp1_;
#line 179 "../src/Dialogs/PreferencesDialog.vala"
	g_settings_set_string (_tmp0_, "raw-developer-default", _tmp2_);
#line 179 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (_tmp2_);
#line 795 "PreferencesDialog.c"
}

static void
preferences_dialog_on_current_folder_changed (PreferencesDialog* self)
{
	GtkFileChooserButton* _tmp0_;
	gchar* _tmp1_;
#line 182 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = self->priv->library_dir_button;
#line 183 "../src/Dialogs/PreferencesDialog.vala"
	_tmp1_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp0_);
#line 183 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (self->priv->lib_dir);
#line 183 "../src/Dialogs/PreferencesDialog.vala"
	self->priv->lib_dir = _tmp1_;
#line 813 "PreferencesDialog.c"
}

static void
_preferences_dialog_on_current_folder_changed_gtk_file_chooser_current_folder_changed (GtkFileChooser* _sender,
                                                                                       gpointer self)
{
#line 191 "../src/Dialogs/PreferencesDialog.vala"
	preferences_dialog_on_current_folder_changed ((PreferencesDialog*) self);
#line 822 "PreferencesDialog.c"
}

static gboolean
preferences_dialog_map_event_handler (PreferencesDialog* self)
{
	GtkFileChooserButton* _tmp0_;
	gboolean result;
#line 186 "../src/Dialogs/PreferencesDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 191 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = self->priv->library_dir_button;
#line 191 "../src/Dialogs/PreferencesDialog.vala"
	g_signal_connect ((GtkFileChooser*) _tmp0_, "current-folder-changed", (GCallback) _preferences_dialog_on_current_folder_changed_gtk_file_chooser_current_folder_changed, self);
#line 192 "../src/Dialogs/PreferencesDialog.vala"
	result = TRUE;
#line 192 "../src/Dialogs/PreferencesDialog.vala"
	return result;
#line 840 "PreferencesDialog.c"
}

static PreferencesDialogPathFormat*
preferences_dialog_path_format_construct (GType object_type,
                                          const gchar* name,
                                          const gchar* pattern)
{
	PreferencesDialogPathFormat* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 23 "../src/Dialogs/PreferencesDialog.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 23 "../src/Dialogs/PreferencesDialog.vala"
	self = (PreferencesDialogPathFormat*) g_type_create_instance (object_type);
#line 24 "../src/Dialogs/PreferencesDialog.vala"
	_tmp0_ = g_strdup (name);
#line 24 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (self->name);
#line 24 "../src/Dialogs/PreferencesDialog.vala"
	self->name = _tmp0_;
#line 25 "../src/Dialogs/PreferencesDialog.vala"
	_tmp1_ = g_strdup (pattern);
#line 25 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (self->pattern);
#line 25 "../src/Dialogs/PreferencesDialog.vala"
	self->pattern = _tmp1_;
#line 23 "../src/Dialogs/PreferencesDialog.vala"
	return self;
#line 869 "PreferencesDialog.c"
}

static PreferencesDialogPathFormat*
preferences_dialog_path_format_new (const gchar* name,
                                    const gchar* pattern)
{
#line 23 "../src/Dialogs/PreferencesDialog.vala"
	return preferences_dialog_path_format_construct (PREFERENCES_DIALOG_TYPE_PATH_FORMAT, name, pattern);
#line 878 "PreferencesDialog.c"
}

static void
preferences_dialog_value_path_format_init (GValue* value)
{
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	value->data[0].v_pointer = NULL;
#line 886 "PreferencesDialog.c"
}

static void
preferences_dialog_value_path_format_free_value (GValue* value)
{
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (value->data[0].v_pointer) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_path_format_unref (value->data[0].v_pointer);
#line 896 "PreferencesDialog.c"
	}
}

static void
preferences_dialog_value_path_format_copy_value (const GValue* src_value,
                                                 GValue* dest_value)
{
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		dest_value->data[0].v_pointer = preferences_dialog_path_format_ref (src_value->data[0].v_pointer);
#line 908 "PreferencesDialog.c"
	} else {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		dest_value->data[0].v_pointer = NULL;
#line 912 "PreferencesDialog.c"
	}
}

static gpointer
preferences_dialog_value_path_format_peek_pointer (const GValue* value)
{
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	return value->data[0].v_pointer;
#line 921 "PreferencesDialog.c"
}

static gchar*
preferences_dialog_value_path_format_collect_value (GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (collect_values[0].v_pointer) {
#line 932 "PreferencesDialog.c"
		PreferencesDialogPathFormat * object;
		object = collect_values[0].v_pointer;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 939 "PreferencesDialog.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 943 "PreferencesDialog.c"
		}
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = preferences_dialog_path_format_ref (object);
#line 947 "PreferencesDialog.c"
	} else {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = NULL;
#line 951 "PreferencesDialog.c"
	}
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	return NULL;
#line 955 "PreferencesDialog.c"
}

static gchar*
preferences_dialog_value_path_format_lcopy_value (const GValue* value,
                                                  guint n_collect_values,
                                                  GTypeCValue* collect_values,
                                                  guint collect_flags)
{
	PreferencesDialogPathFormat ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (!object_p) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 970 "PreferencesDialog.c"
	}
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		*object_p = NULL;
#line 976 "PreferencesDialog.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		*object_p = value->data[0].v_pointer;
#line 980 "PreferencesDialog.c"
	} else {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		*object_p = preferences_dialog_path_format_ref (value->data[0].v_pointer);
#line 984 "PreferencesDialog.c"
	}
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	return NULL;
#line 988 "PreferencesDialog.c"
}

static GParamSpec*
preferences_dialog_param_spec_path_format (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags)
{
	PreferencesDialogParamSpecPathFormat* spec;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PREFERENCES_DIALOG_TYPE_PATH_FORMAT), NULL);
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	return G_PARAM_SPEC (spec);
#line 1007 "PreferencesDialog.c"
}

static gpointer
preferences_dialog_value_get_path_format (const GValue* value)
{
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PREFERENCES_DIALOG_TYPE_PATH_FORMAT), NULL);
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	return value->data[0].v_pointer;
#line 1017 "PreferencesDialog.c"
}

static void
preferences_dialog_value_set_path_format (GValue* value,
                                          gpointer v_object)
{
	PreferencesDialogPathFormat * old;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PREFERENCES_DIALOG_TYPE_PATH_FORMAT));
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (v_object) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PREFERENCES_DIALOG_TYPE_PATH_FORMAT));
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_path_format_ref (value->data[0].v_pointer);
#line 1039 "PreferencesDialog.c"
	} else {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = NULL;
#line 1043 "PreferencesDialog.c"
	}
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (old) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_path_format_unref (old);
#line 1049 "PreferencesDialog.c"
	}
}

static void
preferences_dialog_value_take_path_format (GValue* value,
                                           gpointer v_object)
{
	PreferencesDialogPathFormat * old;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PREFERENCES_DIALOG_TYPE_PATH_FORMAT));
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (v_object) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PREFERENCES_DIALOG_TYPE_PATH_FORMAT));
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = v_object;
#line 1070 "PreferencesDialog.c"
	} else {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = NULL;
#line 1074 "PreferencesDialog.c"
	}
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (old) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_path_format_unref (old);
#line 1080 "PreferencesDialog.c"
	}
}

static void
preferences_dialog_path_format_class_init (PreferencesDialogPathFormatClass * klass,
                                           gpointer klass_data)
{
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	preferences_dialog_path_format_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	((PreferencesDialogPathFormatClass *) klass)->finalize = preferences_dialog_path_format_finalize;
#line 1092 "PreferencesDialog.c"
}

static void
preferences_dialog_path_format_instance_init (PreferencesDialogPathFormat * self,
                                              gpointer klass)
{
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	self->ref_count = 1;
#line 1101 "PreferencesDialog.c"
}

static void
preferences_dialog_path_format_finalize (PreferencesDialogPathFormat * obj)
{
	PreferencesDialogPathFormat * self;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PREFERENCES_DIALOG_TYPE_PATH_FORMAT, PreferencesDialogPathFormat);
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	g_signal_handlers_destroy (self);
#line 27 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (self->name);
#line 28 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (self->pattern);
#line 1116 "PreferencesDialog.c"
}

static GType
preferences_dialog_path_format_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { preferences_dialog_value_path_format_init, preferences_dialog_value_path_format_free_value, preferences_dialog_value_path_format_copy_value, preferences_dialog_value_path_format_peek_pointer, "p", preferences_dialog_value_path_format_collect_value, "p", preferences_dialog_value_path_format_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogPathFormatClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_path_format_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialogPathFormat), 0, (GInstanceInitFunc) preferences_dialog_path_format_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType preferences_dialog_path_format_type_id;
	preferences_dialog_path_format_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PreferencesDialogPathFormat", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return preferences_dialog_path_format_type_id;
}

static GType
preferences_dialog_path_format_get_type (void)
{
	static volatile gsize preferences_dialog_path_format_type_id__once = 0;
	if (g_once_init_enter (&preferences_dialog_path_format_type_id__once)) {
		GType preferences_dialog_path_format_type_id;
		preferences_dialog_path_format_type_id = preferences_dialog_path_format_get_type_once ();
		g_once_init_leave (&preferences_dialog_path_format_type_id__once, preferences_dialog_path_format_type_id);
	}
	return preferences_dialog_path_format_type_id__once;
}

static gpointer
preferences_dialog_path_format_ref (gpointer instance)
{
	PreferencesDialogPathFormat * self;
	self = instance;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	return instance;
#line 1151 "PreferencesDialog.c"
}

static void
preferences_dialog_path_format_unref (gpointer instance)
{
	PreferencesDialogPathFormat * self;
	self = instance;
#line 22 "../src/Dialogs/PreferencesDialog.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		PREFERENCES_DIALOG_PATH_FORMAT_GET_CLASS (self)->finalize (self);
#line 22 "../src/Dialogs/PreferencesDialog.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1165 "PreferencesDialog.c"
	}
}

static void
value_preferences_dialog_init (GValue* value)
{
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	value->data[0].v_pointer = NULL;
#line 1174 "PreferencesDialog.c"
}

static void
value_preferences_dialog_free_value (GValue* value)
{
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_unref (value->data[0].v_pointer);
#line 1184 "PreferencesDialog.c"
	}
}

static void
value_preferences_dialog_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		dest_value->data[0].v_pointer = preferences_dialog_ref (src_value->data[0].v_pointer);
#line 1196 "PreferencesDialog.c"
	} else {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1200 "PreferencesDialog.c"
	}
}

static gpointer
value_preferences_dialog_peek_pointer (const GValue* value)
{
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	return value->data[0].v_pointer;
#line 1209 "PreferencesDialog.c"
}

static gchar*
value_preferences_dialog_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (collect_values[0].v_pointer) {
#line 1220 "PreferencesDialog.c"
		PreferencesDialog * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1227 "PreferencesDialog.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1231 "PreferencesDialog.c"
		}
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = preferences_dialog_ref (object);
#line 1235 "PreferencesDialog.c"
	} else {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = NULL;
#line 1239 "PreferencesDialog.c"
	}
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	return NULL;
#line 1243 "PreferencesDialog.c"
}

static gchar*
value_preferences_dialog_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	PreferencesDialog ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (!object_p) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1258 "PreferencesDialog.c"
	}
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		*object_p = NULL;
#line 1264 "PreferencesDialog.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		*object_p = value->data[0].v_pointer;
#line 1268 "PreferencesDialog.c"
	} else {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		*object_p = preferences_dialog_ref (value->data[0].v_pointer);
#line 1272 "PreferencesDialog.c"
	}
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	return NULL;
#line 1276 "PreferencesDialog.c"
}

GParamSpec*
param_spec_preferences_dialog (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	ParamSpecPreferencesDialog* spec;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PREFERENCES_DIALOG), NULL);
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	return G_PARAM_SPEC (spec);
#line 1295 "PreferencesDialog.c"
}

gpointer
value_get_preferences_dialog (const GValue* value)
{
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PREFERENCES_DIALOG), NULL);
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	return value->data[0].v_pointer;
#line 1305 "PreferencesDialog.c"
}

void
value_set_preferences_dialog (GValue* value,
                              gpointer v_object)
{
	PreferencesDialog * old;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PREFERENCES_DIALOG));
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (v_object) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PREFERENCES_DIALOG));
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_ref (value->data[0].v_pointer);
#line 1327 "PreferencesDialog.c"
	} else {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = NULL;
#line 1331 "PreferencesDialog.c"
	}
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (old) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_unref (old);
#line 1337 "PreferencesDialog.c"
	}
}

void
value_take_preferences_dialog (GValue* value,
                               gpointer v_object)
{
	PreferencesDialog * old;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PREFERENCES_DIALOG));
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (v_object) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PREFERENCES_DIALOG));
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = v_object;
#line 1358 "PreferencesDialog.c"
	} else {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		value->data[0].v_pointer = NULL;
#line 1362 "PreferencesDialog.c"
	}
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (old) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		preferences_dialog_unref (old);
#line 1368 "PreferencesDialog.c"
	}
}

static void
preferences_dialog_class_init (PreferencesDialogClass * klass,
                               gpointer klass_data)
{
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	((PreferencesDialogClass *) klass)->finalize = preferences_dialog_finalize;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
#line 1382 "PreferencesDialog.c"
}

static void
preferences_dialog_instance_init (PreferencesDialog * self,
                                  gpointer klass)
{
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	self->priv = preferences_dialog_get_instance_private (self);
#line 35 "../src/Dialogs/PreferencesDialog.vala"
	self->priv->lib_dir = NULL;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	self->ref_count = 1;
#line 1395 "PreferencesDialog.c"
}

static void
preferences_dialog_finalize (PreferencesDialog * obj)
{
	PreferencesDialog * self;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	g_signal_handlers_destroy (self);
#line 33 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 34 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (self->priv->library_dir_button);
#line 35 "../src/Dialogs/PreferencesDialog.vala"
	_g_free0 (self->priv->lib_dir);
#line 36 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (self->priv->default_raw_developer_combo);
#line 37 "../src/Dialogs/PreferencesDialog.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 1416 "PreferencesDialog.c"
}

static GType
preferences_dialog_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_preferences_dialog_init, value_preferences_dialog_free_value, value_preferences_dialog_copy_value, value_preferences_dialog_peek_pointer, "p", value_preferences_dialog_collect_value, "p", value_preferences_dialog_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType preferences_dialog_type_id;
	preferences_dialog_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PreferencesDialog", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
	return preferences_dialog_type_id;
}

GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__once = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__once)) {
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = preferences_dialog_get_type_once ();
		g_once_init_leave (&preferences_dialog_type_id__once, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__once;
}

gpointer
preferences_dialog_ref (gpointer instance)
{
	PreferencesDialog * self;
	self = instance;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	return instance;
#line 1452 "PreferencesDialog.c"
}

void
preferences_dialog_unref (gpointer instance)
{
	PreferencesDialog * self;
	self = instance;
#line 21 "../src/Dialogs/PreferencesDialog.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		PREFERENCES_DIALOG_GET_CLASS (self)->finalize (self);
#line 21 "../src/Dialogs/PreferencesDialog.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1466 "PreferencesDialog.c"
	}
}

