/* ProgressDialog.c generated by valac 0.56.18, the Vala compiler
 * generated from ProgressDialog.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2017-2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PROGRESS_DIALOG_0_PROPERTY,
	PROGRESS_DIALOG_NUM_PROPERTIES
};
static GParamSpec* progress_dialog_properties[PROGRESS_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ProgressDialogPrivate {
	GtkProgressBar* progress_bar;
	GtkButton* cancel_button;
	GCancellable* cancellable;
	guint64 last_count;
	gint update_every;
	gint minimum_on_screen_time_msec;
	gint64 time_started;
};

static gint ProgressDialog_private_offset;
static gpointer progress_dialog_parent_class = NULL;

static void progress_dialog_on_cancel (ProgressDialog* self);
static void _progress_dialog_on_cancel_gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self);
static gboolean progress_dialog_on_window_closed (ProgressDialog* self);
static gboolean _progress_dialog_on_window_closed_gtk_widget_delete_event (GtkWidget* _sender,
                                                                    GdkEventAny* event,
                                                                    gpointer self);
static void progress_dialog_real_realize (GtkWidget* base);
static void progress_dialog_maybe_show_all (ProgressDialog* self,
                                     gdouble pct);
static void progress_dialog_finalize (GObject * obj);
static GType progress_dialog_get_type_once (void);

static inline gpointer
progress_dialog_get_instance_private (ProgressDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ProgressDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../src/Dialogs/ProgressDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 96 "ProgressDialog.c"
}

static void
_progress_dialog_on_cancel_gtk_button_clicked (GtkButton* _sender,
                                               gpointer self)
{
#line 61 "../src/Dialogs/ProgressDialog.vala"
	progress_dialog_on_cancel ((ProgressDialog*) self);
#line 105 "ProgressDialog.c"
}

static gboolean
_progress_dialog_on_window_closed_gtk_widget_delete_event (GtkWidget* _sender,
                                                           GdkEventAny* event,
                                                           gpointer self)
{
	gboolean result;
	result = progress_dialog_on_window_closed ((ProgressDialog*) self);
#line 62 "../src/Dialogs/ProgressDialog.vala"
	return result;
#line 117 "ProgressDialog.c"
}

ProgressDialog*
progress_dialog_construct (GType object_type,
                           GtkWindow* owner,
                           const gchar* text,
                           GCancellable* cancellable)
{
	ProgressDialog * self = NULL;
	GCancellable* _tmp0_;
	GtkProgressBar* _tmp1_;
	GtkProgressBar* _tmp2_;
	GtkProgressBar* _tmp3_;
	GtkLabel* primary_text_label = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkLabel* _tmp14_;
	GtkGrid* _tmp15_;
	GtkProgressBar* _tmp16_;
	GtkBox* _tmp17_;
	GtkGrid* _tmp18_;
#line 30 "../src/Dialogs/ProgressDialog.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 30 "../src/Dialogs/ProgressDialog.vala"
	self = (ProgressDialog*) granite_dialog_construct (object_type);
#line 31 "../src/Dialogs/ProgressDialog.vala"
	_tmp0_ = _g_object_ref0 (cancellable);
#line 31 "../src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 31 "../src/Dialogs/ProgressDialog.vala"
	self->priv->cancellable = _tmp0_;
#line 33 "../src/Dialogs/ProgressDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 34 "../src/Dialogs/ProgressDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 35 "../src/Dialogs/ProgressDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 37 "../src/Dialogs/ProgressDialog.vala"
	if (owner != NULL) {
#line 38 "../src/Dialogs/ProgressDialog.vala"
		gtk_window_set_transient_for ((GtkWindow*) self, owner);
#line 168 "ProgressDialog.c"
	}
#line 41 "../src/Dialogs/ProgressDialog.vala"
	_tmp1_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 41 "../src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp1_);
#line 41 "../src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 41 "../src/Dialogs/ProgressDialog.vala"
	self->priv->progress_bar = _tmp1_;
#line 42 "../src/Dialogs/ProgressDialog.vala"
	_tmp2_ = self->priv->progress_bar;
#line 42 "../src/Dialogs/ProgressDialog.vala"
	g_object_set ((GtkWidget*) _tmp2_, "width-request", 300, NULL);
#line 43 "../src/Dialogs/ProgressDialog.vala"
	_tmp3_ = self->priv->progress_bar;
#line 43 "../src/Dialogs/ProgressDialog.vala"
	gtk_progress_bar_set_show_text (_tmp3_, TRUE);
#line 45 "../src/Dialogs/ProgressDialog.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (text);
#line 45 "../src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp4_);
#line 45 "../src/Dialogs/ProgressDialog.vala"
	primary_text_label = _tmp4_;
#line 46 "../src/Dialogs/ProgressDialog.vala"
	_tmp5_ = primary_text_label;
#line 46 "../src/Dialogs/ProgressDialog.vala"
	gtk_label_set_xalign (_tmp5_, (gfloat) 0);
#line 47 "../src/Dialogs/ProgressDialog.vala"
	_tmp6_ = primary_text_label;
#line 47 "../src/Dialogs/ProgressDialog.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
#line 47 "../src/Dialogs/ProgressDialog.vala"
	gtk_style_context_add_class (_tmp7_, GRANITE_STYLE_CLASS_PRIMARY_LABEL);
#line 49 "../src/Dialogs/ProgressDialog.vala"
	_tmp8_ = (GtkGrid*) gtk_grid_new ();
#line 49 "../src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp8_);
#line 49 "../src/Dialogs/ProgressDialog.vala"
	grid = _tmp8_;
#line 50 "../src/Dialogs/ProgressDialog.vala"
	_tmp9_ = grid;
#line 50 "../src/Dialogs/ProgressDialog.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp9_, GTK_ORIENTATION_VERTICAL);
#line 51 "../src/Dialogs/ProgressDialog.vala"
	_tmp10_ = grid;
#line 51 "../src/Dialogs/ProgressDialog.vala"
	gtk_grid_set_row_spacing (_tmp10_, 12);
#line 52 "../src/Dialogs/ProgressDialog.vala"
	_tmp11_ = grid;
#line 52 "../src/Dialogs/ProgressDialog.vala"
	g_object_set ((GtkWidget*) _tmp11_, "margin", 12, NULL);
#line 53 "../src/Dialogs/ProgressDialog.vala"
	_tmp12_ = grid;
#line 53 "../src/Dialogs/ProgressDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp12_, 0);
#line 54 "../src/Dialogs/ProgressDialog.vala"
	_tmp13_ = grid;
#line 54 "../src/Dialogs/ProgressDialog.vala"
	_tmp14_ = primary_text_label;
#line 54 "../src/Dialogs/ProgressDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 55 "../src/Dialogs/ProgressDialog.vala"
	_tmp15_ = grid;
#line 55 "../src/Dialogs/ProgressDialog.vala"
	_tmp16_ = self->priv->progress_bar;
#line 55 "../src/Dialogs/ProgressDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 57 "../src/Dialogs/ProgressDialog.vala"
	_tmp17_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 57 "../src/Dialogs/ProgressDialog.vala"
	_tmp18_ = grid;
#line 57 "../src/Dialogs/ProgressDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 59 "../src/Dialogs/ProgressDialog.vala"
	if (cancellable != NULL) {
#line 244 "ProgressDialog.c"
		GtkWidget* _tmp19_;
		GtkButton* _tmp20_;
		GtkButton* _tmp21_;
#line 60 "../src/Dialogs/ProgressDialog.vala"
		_tmp19_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 60 "../src/Dialogs/ProgressDialog.vala"
		_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_button_get_type (), GtkButton));
#line 60 "../src/Dialogs/ProgressDialog.vala"
		_g_object_unref0 (self->priv->cancel_button);
#line 60 "../src/Dialogs/ProgressDialog.vala"
		self->priv->cancel_button = _tmp20_;
#line 61 "../src/Dialogs/ProgressDialog.vala"
		_tmp21_ = self->priv->cancel_button;
#line 61 "../src/Dialogs/ProgressDialog.vala"
		g_signal_connect_object (_tmp21_, "clicked", (GCallback) _progress_dialog_on_cancel_gtk_button_clicked, self, 0);
#line 62 "../src/Dialogs/ProgressDialog.vala"
		g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) _progress_dialog_on_window_closed_gtk_widget_delete_event, self, 0);
#line 262 "ProgressDialog.c"
	}
#line 65 "../src/Dialogs/ProgressDialog.vala"
	self->priv->time_started = now_ms ();
#line 30 "../src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (grid);
#line 30 "../src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (primary_text_label);
#line 30 "../src/Dialogs/ProgressDialog.vala"
	return self;
#line 272 "ProgressDialog.c"
}

ProgressDialog*
progress_dialog_new (GtkWindow* owner,
                     const gchar* text,
                     GCancellable* cancellable)
{
#line 30 "../src/Dialogs/ProgressDialog.vala"
	return progress_dialog_construct (TYPE_PROGRESS_DIALOG, owner, text, cancellable);
#line 282 "ProgressDialog.c"
}

static void
progress_dialog_real_realize (GtkWidget* base)
{
	ProgressDialog * self;
	GCancellable* _tmp0_;
#line 68 "../src/Dialogs/ProgressDialog.vala"
	self = (ProgressDialog*) base;
#line 69 "../src/Dialogs/ProgressDialog.vala"
	GTK_WIDGET_CLASS (progress_dialog_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_TYPE_DIALOG, GraniteDialog));
#line 72 "../src/Dialogs/ProgressDialog.vala"
	_tmp0_ = self->priv->cancellable;
#line 72 "../src/Dialogs/ProgressDialog.vala"
	if (_tmp0_ == NULL) {
#line 298 "ProgressDialog.c"
		GdkWindow* _tmp1_;
#line 73 "../src/Dialogs/ProgressDialog.vala"
		_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 73 "../src/Dialogs/ProgressDialog.vala"
		gdk_window_set_functions (_tmp1_, GDK_FUNC_MOVE);
#line 304 "ProgressDialog.c"
	}
}

void
progress_dialog_update_display_every (ProgressDialog* self,
                                      gint update_every)
{
#line 76 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Dialogs/ProgressDialog.vala"
	_vala_assert (update_every >= 1, "update_every >= 1");
#line 79 "../src/Dialogs/ProgressDialog.vala"
	self->priv->update_every = update_every;
#line 318 "ProgressDialog.c"
}

void
progress_dialog_set_minimum_on_screen_time_msec (ProgressDialog* self,
                                                 gint minimum_on_screen_time_msec)
{
#line 82 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/Dialogs/ProgressDialog.vala"
	self->priv->minimum_on_screen_time_msec = minimum_on_screen_time_msec;
#line 329 "ProgressDialog.c"
}

void
progress_dialog_set_fraction (ProgressDialog* self,
                              gint current,
                              gint total)
{
#line 86 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/Dialogs/ProgressDialog.vala"
	progress_dialog_set_percentage (self, ((gdouble) current) / ((gdouble) total));
#line 341 "ProgressDialog.c"
}

void
progress_dialog_set_percentage (ProgressDialog* self,
                                gdouble pct)
{
	GtkProgressBar* _tmp0_;
	GtkProgressBar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 90 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/Dialogs/ProgressDialog.vala"
	pct = CLAMP (pct, 0.0, 1.0);
#line 93 "../src/Dialogs/ProgressDialog.vala"
	progress_dialog_maybe_show_all (self, pct);
#line 95 "../src/Dialogs/ProgressDialog.vala"
	_tmp0_ = self->priv->progress_bar;
#line 95 "../src/Dialogs/ProgressDialog.vala"
	gtk_progress_bar_set_fraction (_tmp0_, pct);
#line 96 "../src/Dialogs/ProgressDialog.vala"
	_tmp1_ = self->priv->progress_bar;
#line 96 "../src/Dialogs/ProgressDialog.vala"
	_tmp2_ = g_strdup_printf (_ ("%d%%"), (gint) (pct * 100.0));
#line 96 "../src/Dialogs/ProgressDialog.vala"
	_tmp3_ = _tmp2_;
#line 96 "../src/Dialogs/ProgressDialog.vala"
	gtk_progress_bar_set_text (_tmp1_, _tmp3_);
#line 96 "../src/Dialogs/ProgressDialog.vala"
	_g_free0 (_tmp3_);
#line 99 "../src/Dialogs/ProgressDialog.vala"
	granite_services_application_set_progress (pct, NULL, NULL);
#line 374 "ProgressDialog.c"
}

void
progress_dialog_set_status (ProgressDialog* self,
                            const gchar* text)
{
	GtkProgressBar* _tmp0_;
#line 102 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (text != NULL);
#line 103 "../src/Dialogs/ProgressDialog.vala"
	_tmp0_ = self->priv->progress_bar;
#line 103 "../src/Dialogs/ProgressDialog.vala"
	gtk_progress_bar_set_text (_tmp0_, text);
#line 106 "../src/Dialogs/ProgressDialog.vala"
	granite_services_application_set_progress_visible (TRUE, NULL, NULL);
#line 108 "../src/Dialogs/ProgressDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 394 "ProgressDialog.c"
}

gboolean
progress_dialog_monitor (ProgressDialog* self,
                         guint64 count,
                         guint64 total,
                         gboolean do_event_loop)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GCancellable* _tmp2_;
	gboolean keep_going = FALSE;
	gboolean result;
#line 112 "../src/Dialogs/ProgressDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 113 "../src/Dialogs/ProgressDialog.vala"
	if (self->priv->last_count == G_MAXUINT64) {
#line 113 "../src/Dialogs/ProgressDialog.vala"
		_tmp0_ = TRUE;
#line 414 "ProgressDialog.c"
	} else {
#line 113 "../src/Dialogs/ProgressDialog.vala"
		_tmp0_ = (count - self->priv->last_count) >= ((guint64) self->priv->update_every);
#line 418 "ProgressDialog.c"
	}
#line 113 "../src/Dialogs/ProgressDialog.vala"
	if (_tmp0_) {
#line 114 "../src/Dialogs/ProgressDialog.vala"
		progress_dialog_set_percentage (self, ((gdouble) count) / ((gdouble) total));
#line 115 "../src/Dialogs/ProgressDialog.vala"
		self->priv->last_count = count;
#line 426 "ProgressDialog.c"
	}
#line 118 "../src/Dialogs/ProgressDialog.vala"
	_tmp2_ = self->priv->cancellable;
#line 118 "../src/Dialogs/ProgressDialog.vala"
	if (_tmp2_ != NULL) {
#line 432 "ProgressDialog.c"
		GCancellable* _tmp3_;
#line 118 "../src/Dialogs/ProgressDialog.vala"
		_tmp3_ = self->priv->cancellable;
#line 118 "../src/Dialogs/ProgressDialog.vala"
		_tmp1_ = !g_cancellable_is_cancelled (_tmp3_);
#line 438 "ProgressDialog.c"
	} else {
#line 118 "../src/Dialogs/ProgressDialog.vala"
		_tmp1_ = TRUE;
#line 442 "ProgressDialog.c"
	}
#line 118 "../src/Dialogs/ProgressDialog.vala"
	keep_going = _tmp1_;
#line 126 "../src/Dialogs/ProgressDialog.vala"
	if (do_event_loop) {
#line 127 "../src/Dialogs/ProgressDialog.vala"
		spin_event_loop ();
#line 450 "ProgressDialog.c"
	}
#line 129 "../src/Dialogs/ProgressDialog.vala"
	result = keep_going;
#line 129 "../src/Dialogs/ProgressDialog.vala"
	return result;
#line 456 "ProgressDialog.c"
}

void
progress_dialog_close (ProgressDialog* self)
{
#line 132 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/Dialogs/ProgressDialog.vala"
	granite_services_application_set_progress_visible (FALSE, NULL, NULL);
#line 135 "../src/Dialogs/ProgressDialog.vala"
	granite_services_application_set_progress (0.0, NULL, NULL);
#line 137 "../src/Dialogs/ProgressDialog.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 138 "../src/Dialogs/ProgressDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 472 "ProgressDialog.c"
}

static gboolean
progress_dialog_on_window_closed (ProgressDialog* self)
{
	gboolean result;
#line 141 "../src/Dialogs/ProgressDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "../src/Dialogs/ProgressDialog.vala"
	progress_dialog_on_cancel (self);
#line 143 "../src/Dialogs/ProgressDialog.vala"
	result = FALSE;
#line 143 "../src/Dialogs/ProgressDialog.vala"
	return result;
#line 487 "ProgressDialog.c"
}

static void
progress_dialog_on_cancel (ProgressDialog* self)
{
	GCancellable* _tmp0_;
	GtkButton* _tmp2_;
#line 147 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/Dialogs/ProgressDialog.vala"
	_tmp0_ = self->priv->cancellable;
#line 148 "../src/Dialogs/ProgressDialog.vala"
	if (_tmp0_ != NULL) {
#line 501 "ProgressDialog.c"
		GCancellable* _tmp1_;
#line 149 "../src/Dialogs/ProgressDialog.vala"
		_tmp1_ = self->priv->cancellable;
#line 149 "../src/Dialogs/ProgressDialog.vala"
		g_cancellable_cancel (_tmp1_);
#line 507 "ProgressDialog.c"
	}
#line 151 "../src/Dialogs/ProgressDialog.vala"
	_tmp2_ = self->priv->cancel_button;
#line 151 "../src/Dialogs/ProgressDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
#line 513 "ProgressDialog.c"
}

static void
progress_dialog_maybe_show_all (ProgressDialog* self,
                                gdouble pct)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 154 "../src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Dialogs/ProgressDialog.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 157 "../src/Dialogs/ProgressDialog.vala"
	_tmp2_ = _tmp1_;
#line 157 "../src/Dialogs/ProgressDialog.vala"
	if (!_tmp2_) {
#line 157 "../src/Dialogs/ProgressDialog.vala"
		_tmp0_ = (now_ms () - self->priv->time_started) > ((gint64) self->priv->minimum_on_screen_time_msec);
#line 533 "ProgressDialog.c"
	} else {
#line 157 "../src/Dialogs/ProgressDialog.vala"
		_tmp0_ = FALSE;
#line 537 "ProgressDialog.c"
	}
#line 157 "../src/Dialogs/ProgressDialog.vala"
	if (_tmp0_) {
#line 541 "ProgressDialog.c"
		gdouble pps = 0.0;
		gdouble ttc = 0.0;
#line 159 "../src/Dialogs/ProgressDialog.vala"
		pps = (pct * 100.0) / self->priv->minimum_on_screen_time_msec;
#line 161 "../src/Dialogs/ProgressDialog.vala"
		ttc = 100.0 / pps;
#line 164 "../src/Dialogs/ProgressDialog.vala"
		if (ttc > ((gdouble) self->priv->minimum_on_screen_time_msec)) {
#line 167 "../src/Dialogs/ProgressDialog.vala"
			granite_services_application_set_progress_visible (TRUE, NULL, NULL);
#line 169 "../src/Dialogs/ProgressDialog.vala"
			gtk_widget_show_all ((GtkWidget*) self);
#line 170 "../src/Dialogs/ProgressDialog.vala"
			spin_event_loop ();
#line 556 "ProgressDialog.c"
		}
	}
}

static void
progress_dialog_class_init (ProgressDialogClass * klass,
                            gpointer klass_data)
{
#line 21 "../src/Dialogs/ProgressDialog.vala"
	progress_dialog_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Dialogs/ProgressDialog.vala"
	g_type_class_adjust_private_offset (klass, &ProgressDialog_private_offset);
#line 21 "../src/Dialogs/ProgressDialog.vala"
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) progress_dialog_real_realize;
#line 21 "../src/Dialogs/ProgressDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = progress_dialog_finalize;
#line 573 "ProgressDialog.c"
}

static void
progress_dialog_instance_init (ProgressDialog * self,
                               gpointer klass)
{
#line 21 "../src/Dialogs/ProgressDialog.vala"
	self->priv = progress_dialog_get_instance_private (self);
#line 23 "../src/Dialogs/ProgressDialog.vala"
	self->priv->cancel_button = NULL;
#line 25 "../src/Dialogs/ProgressDialog.vala"
	self->priv->last_count = G_MAXUINT64;
#line 26 "../src/Dialogs/ProgressDialog.vala"
	self->priv->update_every = 1;
#line 27 "../src/Dialogs/ProgressDialog.vala"
	self->priv->minimum_on_screen_time_msec = 500;
#line 590 "ProgressDialog.c"
}

static void
progress_dialog_finalize (GObject * obj)
{
	ProgressDialog * self;
#line 21 "../src/Dialogs/ProgressDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROGRESS_DIALOG, ProgressDialog);
#line 22 "../src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 23 "../src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->cancel_button);
#line 24 "../src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 21 "../src/Dialogs/ProgressDialog.vala"
	G_OBJECT_CLASS (progress_dialog_parent_class)->finalize (obj);
#line 607 "ProgressDialog.c"
}

static GType
progress_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ProgressDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) progress_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ProgressDialog), 0, (GInstanceInitFunc) progress_dialog_instance_init, NULL };
	GType progress_dialog_type_id;
	progress_dialog_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "ProgressDialog", &g_define_type_info, 0);
	ProgressDialog_private_offset = g_type_add_instance_private (progress_dialog_type_id, sizeof (ProgressDialogPrivate));
	return progress_dialog_type_id;
}

GType
progress_dialog_get_type (void)
{
	static volatile gsize progress_dialog_type_id__once = 0;
	if (g_once_init_enter (&progress_dialog_type_id__once)) {
		GType progress_dialog_type_id;
		progress_dialog_type_id = progress_dialog_get_type_once ();
		g_once_init_leave (&progress_dialog_type_id__once, progress_dialog_type_id);
	}
	return progress_dialog_type_id__once;
}

