/* SavedSearchDialog.c generated by valac 0.56.18, the Vala compiler
 * generated from SavedSearchDialog.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2018 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* This dialog displays a boolean search configuration.*/

#include "io.elementary.photos.h"
#include <granite.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SAVED_SEARCH_DIALOG_0_PROPERTY,
	SAVED_SEARCH_DIALOG_NUM_PROPERTIES
};
static GParamSpec* saved_search_dialog_properties[SAVED_SEARCH_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _saved_search_table_unref0(var) ((var == NULL) ? NULL : (var = (saved_search_table_unref (var), NULL)))
#define _search_condition_unref0(var) ((var == NULL) ? NULL : (var = (search_condition_unref (var), NULL)))

struct _SavedSearchDialogPrivate {
	GraniteDialog* dialog;
	GtkButton* add_criteria;
	GtkComboBoxText* operator;
	GtkGrid* row_box;
	GtkEntry* search_title;
	GeeArrayList* row_list;
	gboolean edit_mode;
	SavedSearch* previous_search;
	gboolean valid;
};

static gint SavedSearchDialog_private_offset;
static gpointer saved_search_dialog_parent_class = NULL;

static void saved_search_dialog_on_title_changed (SavedSearchDialog* self);
static void _saved_search_dialog_on_title_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                 gpointer self);
static void saved_search_dialog_add_text_search (SavedSearchDialog* self);
static void saved_search_dialog_set_valid (SavedSearchDialog* self,
                                    gboolean v);
static void saved_search_dialog_add_row (SavedSearchDialog* self,
                                  SearchRowContainer* row);
static gboolean saved_search_dialog_on_add_criteria (SavedSearchDialog* self,
                                              GdkEventButton* event);
static void saved_search_dialog_on_remove_row (SavedSearchDialog* self,
                                        SearchRowContainer* row);
static void _saved_search_dialog_on_remove_row_search_row_container_remove (SearchRowContainer* _sender,
                                                                     SearchRowContainer* this_row,
                                                                     gpointer self);
static void saved_search_dialog_on_row_changed (SavedSearchDialog* self,
                                         SearchRowContainer* row);
static void _saved_search_dialog_on_row_changed_search_row_container_changed (SearchRowContainer* _sender,
                                                                       SearchRowContainer* this_row,
                                                                       gpointer self);
static void saved_search_dialog_on_response (SavedSearchDialog* self,
                                      gint response_id);
static gboolean saved_search_dialog_is_title_valid (SavedSearchDialog* self);
static GObject * saved_search_dialog_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static gboolean _saved_search_dialog_on_add_criteria_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                             GdkEventButton* event,
                                                                             gpointer self);
static void _saved_search_dialog_on_response_gtk_dialog_response (GtkDialog* _sender,
                                                           gint response_id,
                                                           gpointer self);
static void saved_search_dialog_finalize (GObject * obj);
static GType saved_search_dialog_get_type_once (void);

static inline gpointer
saved_search_dialog_get_instance_private (SavedSearchDialog* self)
{
	return G_STRUCT_MEMBER_P (self, SavedSearchDialog_private_offset);
}

static void
_saved_search_dialog_on_title_changed_gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self)
{
#line 77 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_on_title_changed ((SavedSearchDialog*) self);
#line 120 "SavedSearchDialog.c"
}

SavedSearchDialog*
saved_search_dialog_construct (GType object_type)
{
	SavedSearchDialog * self = NULL;
	GtkEntry* _tmp0_;
	SavedSearchTable* _tmp1_;
	SavedSearchTable* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkEntry* _tmp5_;
	GeeArrayList* _tmp6_;
	gpointer _tmp7_;
	SearchRowContainer* _tmp8_;
	GtkButton* ok_button = NULL;
	GtkButton* _tmp9_;
	GraniteDialog* _tmp10_;
	GraniteDialog* _tmp11_;
#line 33 "../src/Dialogs/SavedSearchDialog.vala"
	self = (SavedSearchDialog*) g_object_new (object_type, NULL);
#line 35 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp0_ = self->priv->search_title;
#line 35 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp1_ = saved_search_table_get_instance ();
#line 35 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp3_ = saved_search_table_generate_unique_name (_tmp2_);
#line 35 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp4_ = _tmp3_;
#line 35 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_entry_set_text (_tmp0_, _tmp4_);
#line 35 "../src/Dialogs/SavedSearchDialog.vala"
	_g_free0 (_tmp4_);
#line 35 "../src/Dialogs/SavedSearchDialog.vala"
	_saved_search_table_unref0 (_tmp2_);
#line 36 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp5_ = self->priv->search_title;
#line 36 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_editable_select_region ((GtkEditable*) _tmp5_, 0, -1);
#line 39 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_add_text_search (self);
#line 40 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp6_ = self->priv->row_list;
#line 40 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, 0);
#line 40 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp8_ = (SearchRowContainer*) _tmp7_;
#line 40 "../src/Dialogs/SavedSearchDialog.vala"
	search_row_container_allow_removal (_tmp8_, FALSE);
#line 40 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (_tmp8_);
#line 42 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp9_ = (GtkButton*) gtk_button_new_with_label (_ ("Add"));
#line 42 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp9_);
#line 42 "../src/Dialogs/SavedSearchDialog.vala"
	ok_button = _tmp9_;
#line 43 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_widget_set_can_default ((GtkWidget*) ok_button, TRUE);
#line 45 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp10_ = self->priv->dialog;
#line 45 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_dialog_add_action_widget ((GtkDialog*) _tmp10_, (GtkWidget*) ok_button, (gint) GTK_RESPONSE_OK);
#line 47 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp11_ = self->priv->dialog;
#line 47 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp11_);
#line 48 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_set_valid (self, FALSE);
#line 33 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (ok_button);
#line 33 "../src/Dialogs/SavedSearchDialog.vala"
	return self;
#line 196 "SavedSearchDialog.c"
}

SavedSearchDialog*
saved_search_dialog_new (void)
{
#line 33 "../src/Dialogs/SavedSearchDialog.vala"
	return saved_search_dialog_construct (TYPE_SAVED_SEARCH_DIALOG);
#line 204 "SavedSearchDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/Dialogs/SavedSearchDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 212 "SavedSearchDialog.c"
}

SavedSearchDialog*
saved_search_dialog_construct_edit_existing (GType object_type,
                                             SavedSearch* saved_search)
{
	SavedSearchDialog * self = NULL;
	SavedSearch* _tmp0_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GraniteDialog* _tmp3_;
	GtkButton* _tmp4_;
	GraniteDialog* _tmp5_;
	GtkComboBoxText* _tmp6_;
	GtkEntry* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GeeArrayList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
#line 51 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_val_if_fail (saved_search != NULL, NULL);
#line 51 "../src/Dialogs/SavedSearchDialog.vala"
	self = (SavedSearchDialog*) g_object_new (object_type, NULL);
#line 52 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp0_ = _g_object_ref0 (saved_search);
#line 52 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->previous_search);
#line 52 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->previous_search = _tmp0_;
#line 53 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->edit_mode = TRUE;
#line 56 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp1_ = (GtkButton*) gtk_button_new_with_label (_ ("Save"));
#line 56 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp1_);
#line 56 "../src/Dialogs/SavedSearchDialog.vala"
	close_button = _tmp1_;
#line 57 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp2_ = close_button;
#line 57 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_widget_set_can_default ((GtkWidget*) _tmp2_, TRUE);
#line 59 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp3_ = self->priv->dialog;
#line 59 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp4_ = close_button;
#line 59 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_dialog_add_action_widget ((GtkDialog*) _tmp3_, (GtkWidget*) _tmp4_, (gint) GTK_RESPONSE_OK);
#line 61 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp5_ = self->priv->dialog;
#line 61 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp5_);
#line 64 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp6_ = self->priv->operator;
#line 64 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _tmp6_, (gint) ((SearchOperator) saved_search_get_operator (saved_search)));
#line 65 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp7_ = self->priv->search_title;
#line 65 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp8_ = data_object_get_name ((DataObject*) saved_search);
#line 65 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp9_ = _tmp8_;
#line 65 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_entry_set_text (_tmp7_, _tmp9_);
#line 65 "../src/Dialogs/SavedSearchDialog.vala"
	_g_free0 (_tmp9_);
#line 280 "SavedSearchDialog.c"
	{
		GeeList* _sc_list = NULL;
		GeeList* _tmp10_;
		gint _sc_size = 0;
		GeeList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _sc_index = 0;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp10_ = saved_search_get_conditions (saved_search);
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		_sc_list = _tmp10_;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp11_ = _sc_list;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp13_ = _tmp12_;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		_sc_size = _tmp13_;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		_sc_index = -1;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		while (TRUE) {
#line 305 "SavedSearchDialog.c"
			gint _tmp14_;
			gint _tmp15_;
			SearchCondition* sc = NULL;
			GeeList* _tmp16_;
			gpointer _tmp17_;
			SearchCondition* _tmp18_;
			SearchRowContainer* _tmp19_;
			SearchRowContainer* _tmp20_;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
			_sc_index = _sc_index + 1;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp14_ = _sc_index;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp15_ = _sc_size;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
			if (!(_tmp14_ < _tmp15_)) {
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
				break;
#line 324 "SavedSearchDialog.c"
			}
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp16_ = _sc_list;
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp17_ = gee_list_get (_tmp16_, _sc_index);
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
			sc = (SearchCondition*) _tmp17_;
#line 67 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp18_ = sc;
#line 67 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp19_ = search_row_container_new_edit_existing (_tmp18_);
#line 67 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp20_ = _tmp19_;
#line 67 "../src/Dialogs/SavedSearchDialog.vala"
			saved_search_dialog_add_row (self, _tmp20_);
#line 67 "../src/Dialogs/SavedSearchDialog.vala"
			_g_object_unref0 (_tmp20_);
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
			_search_condition_unref0 (sc);
#line 344 "SavedSearchDialog.c"
		}
#line 66 "../src/Dialogs/SavedSearchDialog.vala"
		_g_object_unref0 (_sc_list);
#line 348 "SavedSearchDialog.c"
	}
#line 70 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp21_ = self->priv->row_list;
#line 70 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp22_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp21_);
#line 70 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp23_ = _tmp22_;
#line 70 "../src/Dialogs/SavedSearchDialog.vala"
	if (_tmp23_ == 1) {
#line 358 "SavedSearchDialog.c"
		GeeArrayList* _tmp24_;
		gpointer _tmp25_;
		SearchRowContainer* _tmp26_;
#line 71 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp24_ = self->priv->row_list;
#line 71 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, 0);
#line 71 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp26_ = (SearchRowContainer*) _tmp25_;
#line 71 "../src/Dialogs/SavedSearchDialog.vala"
		search_row_container_allow_removal (_tmp26_, FALSE);
#line 71 "../src/Dialogs/SavedSearchDialog.vala"
		_g_object_unref0 (_tmp26_);
#line 372 "SavedSearchDialog.c"
	}
#line 73 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_set_valid (self, TRUE);
#line 51 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (close_button);
#line 51 "../src/Dialogs/SavedSearchDialog.vala"
	return self;
#line 380 "SavedSearchDialog.c"
}

SavedSearchDialog*
saved_search_dialog_new_edit_existing (SavedSearch* saved_search)
{
#line 51 "../src/Dialogs/SavedSearchDialog.vala"
	return saved_search_dialog_construct_edit_existing (TYPE_SAVED_SEARCH_DIALOG, saved_search);
#line 388 "SavedSearchDialog.c"
}

void
saved_search_dialog_show (SavedSearchDialog* self)
{
	GraniteDialog* _tmp0_;
	GraniteDialog* _tmp1_;
#line 135 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp0_ = self->priv->dialog;
#line 136 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_dialog_run ((GtkDialog*) _tmp0_);
#line 137 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp1_ = self->priv->dialog;
#line 137 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp1_);
#line 406 "SavedSearchDialog.c"
}

static gboolean
saved_search_dialog_on_add_criteria (SavedSearchDialog* self,
                                     GdkEventButton* event)
{
	gboolean result;
#line 141 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 141 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 142 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_add_text_search (self);
#line 143 "../src/Dialogs/SavedSearchDialog.vala"
	result = FALSE;
#line 143 "../src/Dialogs/SavedSearchDialog.vala"
	return result;
#line 424 "SavedSearchDialog.c"
}

static void
saved_search_dialog_add_text_search (SavedSearchDialog* self)
{
	SearchRowContainer* text = NULL;
	SearchRowContainer* _tmp0_;
#line 146 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp0_ = search_row_container_new ();
#line 147 "../src/Dialogs/SavedSearchDialog.vala"
	text = _tmp0_;
#line 148 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_add_row (self, text);
#line 146 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (text);
#line 442 "SavedSearchDialog.c"
}

static void
_saved_search_dialog_on_remove_row_search_row_container_remove (SearchRowContainer* _sender,
                                                                SearchRowContainer* this_row,
                                                                gpointer self)
{
#line 157 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_on_remove_row ((SavedSearchDialog*) self, this_row);
#line 452 "SavedSearchDialog.c"
}

static void
_saved_search_dialog_on_row_changed_search_row_container_changed (SearchRowContainer* _sender,
                                                                  SearchRowContainer* this_row,
                                                                  gpointer self)
{
#line 158 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_on_row_changed ((SavedSearchDialog*) self, this_row);
#line 462 "SavedSearchDialog.c"
}

static void
saved_search_dialog_add_row (SavedSearchDialog* self,
                             SearchRowContainer* row)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkGrid* _tmp6_;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	GeeArrayList* _tmp9_;
#line 152 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (row != NULL);
#line 153 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp0_ = self->priv->row_list;
#line 153 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 153 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp2_ = _tmp1_;
#line 153 "../src/Dialogs/SavedSearchDialog.vala"
	if (_tmp2_ == 1) {
#line 488 "SavedSearchDialog.c"
		GeeArrayList* _tmp3_;
		gpointer _tmp4_;
		SearchRowContainer* _tmp5_;
#line 154 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp3_ = self->priv->row_list;
#line 154 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, 0);
#line 154 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp5_ = (SearchRowContainer*) _tmp4_;
#line 154 "../src/Dialogs/SavedSearchDialog.vala"
		search_row_container_allow_removal (_tmp5_, TRUE);
#line 154 "../src/Dialogs/SavedSearchDialog.vala"
		_g_object_unref0 (_tmp5_);
#line 502 "SavedSearchDialog.c"
	}
#line 155 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp6_ = self->priv->row_box;
#line 155 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp7_ = search_row_container_get_widget (row);
#line 155 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp8_ = _tmp7_;
#line 155 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, _tmp8_);
#line 155 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (_tmp8_);
#line 156 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp9_ = self->priv->row_list;
#line 156 "../src/Dialogs/SavedSearchDialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, row);
#line 157 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_connect_object (row, "remove", (GCallback) _saved_search_dialog_on_remove_row_search_row_container_remove, self, 0);
#line 158 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_connect_object (row, "changed", (GCallback) _saved_search_dialog_on_row_changed_search_row_container_changed, self, 0);
#line 159 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_set_valid (self, search_row_container_is_complete (row));
#line 524 "SavedSearchDialog.c"
}

static void
saved_search_dialog_on_remove_row (SavedSearchDialog* self,
                                   SearchRowContainer* row)
{
	guint _tmp0_;
	guint _tmp1_;
	GtkGrid* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 163 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (row != NULL);
#line 164 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_parse_name ("remove", TYPE_SEARCH_ROW_CONTAINER, &_tmp0_, NULL, FALSE);
#line 164 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_handlers_disconnect_matched (row, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _saved_search_dialog_on_remove_row_search_row_container_remove, self);
#line 165 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_parse_name ("changed", TYPE_SEARCH_ROW_CONTAINER, &_tmp1_, NULL, FALSE);
#line 165 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_handlers_disconnect_matched (row, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _saved_search_dialog_on_row_changed_search_row_container_changed, self);
#line 166 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp2_ = self->priv->row_box;
#line 166 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp3_ = search_row_container_get_widget (row);
#line 166 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp4_ = _tmp3_;
#line 166 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_container_remove ((GtkContainer*) _tmp2_, _tmp4_);
#line 166 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (_tmp4_);
#line 167 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp5_ = self->priv->row_list;
#line 167 "../src/Dialogs/SavedSearchDialog.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp5_, row);
#line 168 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp6_ = self->priv->row_list;
#line 168 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 168 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp8_ = _tmp7_;
#line 168 "../src/Dialogs/SavedSearchDialog.vala"
	if (_tmp8_ == 1) {
#line 574 "SavedSearchDialog.c"
		GeeArrayList* _tmp9_;
		gpointer _tmp10_;
		SearchRowContainer* _tmp11_;
#line 169 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp9_ = self->priv->row_list;
#line 169 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, 0);
#line 169 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp11_ = (SearchRowContainer*) _tmp10_;
#line 169 "../src/Dialogs/SavedSearchDialog.vala"
		search_row_container_allow_removal (_tmp11_, FALSE);
#line 169 "../src/Dialogs/SavedSearchDialog.vala"
		_g_object_unref0 (_tmp11_);
#line 588 "SavedSearchDialog.c"
	}
#line 170 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_set_valid (self, TRUE);
#line 592 "SavedSearchDialog.c"
}

static void
saved_search_dialog_on_response (SavedSearchDialog* self,
                                 gint response_id)
{
#line 173 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/Dialogs/SavedSearchDialog.vala"
	if (response_id == ((gint) GTK_RESPONSE_OK)) {
#line 603 "SavedSearchDialog.c"
		gboolean _tmp0_ = FALSE;
		SavedSearchTable* _tmp1_;
		SavedSearchTable* _tmp2_;
		GtkEntry* _tmp3_;
		const gchar* _tmp4_;
		gboolean _tmp5_;
		GeeArrayList* conditions = NULL;
		GeeArrayList* _tmp19_;
		SearchOperator search_operator = 0;
		GtkComboBoxText* _tmp32_;
		SavedSearchTable* _tmp33_;
		SavedSearchTable* _tmp34_;
		GtkEntry* _tmp35_;
		const gchar* _tmp36_;
		GeeArrayList* _tmp37_;
		SavedSearch* _tmp38_;
		SavedSearch* _tmp39_;
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp1_ = saved_search_table_get_instance ();
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp2_ = _tmp1_;
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp3_ = self->priv->search_title;
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp4_ = gtk_entry_get_text (_tmp3_);
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp5_ = saved_search_table_exists (_tmp2_, _tmp4_);
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
		_saved_search_table_unref0 (_tmp2_);
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
		if (_tmp5_) {
#line 635 "SavedSearchDialog.c"
			gboolean _tmp6_ = FALSE;
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
			if (self->priv->edit_mode) {
#line 639 "SavedSearchDialog.c"
				SavedSearch* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				GtkEntry* _tmp10_;
				const gchar* _tmp11_;
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp7_ = self->priv->previous_search;
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp8_ = data_object_get_name ((DataObject*) _tmp7_);
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp9_ = _tmp8_;
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp10_ = self->priv->search_title;
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp11_ = gtk_entry_get_text (_tmp10_);
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp6_ = g_strcmp0 (_tmp9_, _tmp11_) == 0;
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
				_g_free0 (_tmp9_);
#line 659 "SavedSearchDialog.c"
			} else {
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp6_ = FALSE;
#line 663 "SavedSearchDialog.c"
			}
#line 176 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp0_ = !_tmp6_;
#line 667 "SavedSearchDialog.c"
		} else {
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp0_ = FALSE;
#line 671 "SavedSearchDialog.c"
		}
#line 175 "../src/Dialogs/SavedSearchDialog.vala"
		if (_tmp0_) {
#line 675 "SavedSearchDialog.c"
			GtkEntry* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 177 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp12_ = self->priv->search_title;
#line 177 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp13_ = gtk_entry_get_text (_tmp12_);
#line 177 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp14_ = resources_rename_search_exists_message (_tmp13_);
#line 177 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp15_ = _tmp14_;
#line 177 "../src/Dialogs/SavedSearchDialog.vala"
			app_window_error_message (_tmp15_, NULL, NULL);
#line 177 "../src/Dialogs/SavedSearchDialog.vala"
			_g_free0 (_tmp15_);
#line 178 "../src/Dialogs/SavedSearchDialog.vala"
			return;
#line 694 "SavedSearchDialog.c"
		}
#line 181 "../src/Dialogs/SavedSearchDialog.vala"
		if (self->priv->edit_mode) {
#line 698 "SavedSearchDialog.c"
			SavedSearchTable* _tmp16_;
			SavedSearchTable* _tmp17_;
			SavedSearch* _tmp18_;
#line 183 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp16_ = saved_search_table_get_instance ();
#line 183 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp17_ = _tmp16_;
#line 183 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp18_ = self->priv->previous_search;
#line 183 "../src/Dialogs/SavedSearchDialog.vala"
			saved_search_table_remove (_tmp17_, _tmp18_);
#line 183 "../src/Dialogs/SavedSearchDialog.vala"
			_saved_search_table_unref0 (_tmp17_);
#line 712 "SavedSearchDialog.c"
		}
#line 187 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp19_ = gee_array_list_new (TYPE_SEARCH_CONDITION, (GBoxedCopyFunc) search_condition_ref, (GDestroyNotify) search_condition_unref, NULL, NULL, NULL);
#line 187 "../src/Dialogs/SavedSearchDialog.vala"
		conditions = _tmp19_;
#line 718 "SavedSearchDialog.c"
		{
			GeeArrayList* _c_list = NULL;
			GeeArrayList* _tmp20_;
			gint _c_size = 0;
			GeeArrayList* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gint _c_index = 0;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp20_ = self->priv->row_list;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
			_c_list = _tmp20_;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp21_ = _c_list;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp22_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp21_);
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
			_tmp23_ = _tmp22_;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
			_c_size = _tmp23_;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
			_c_index = -1;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
			while (TRUE) {
#line 743 "SavedSearchDialog.c"
				gint _tmp24_;
				gint _tmp25_;
				SearchRowContainer* c = NULL;
				GeeArrayList* _tmp26_;
				gpointer _tmp27_;
				GeeArrayList* _tmp28_;
				SearchRowContainer* _tmp29_;
				SearchCondition* _tmp30_;
				SearchCondition* _tmp31_;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
				_c_index = _c_index + 1;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp24_ = _c_index;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp25_ = _c_size;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
				if (!(_tmp24_ < _tmp25_)) {
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
					break;
#line 763 "SavedSearchDialog.c"
				}
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp26_ = _c_list;
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, _c_index);
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
				c = (SearchRowContainer*) _tmp27_;
#line 189 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp28_ = conditions;
#line 189 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp29_ = c;
#line 189 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp30_ = search_row_container_get_search_condition (_tmp29_);
#line 189 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp31_ = _tmp30_;
#line 189 "../src/Dialogs/SavedSearchDialog.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp31_);
#line 189 "../src/Dialogs/SavedSearchDialog.vala"
				_search_condition_unref0 (_tmp31_);
#line 188 "../src/Dialogs/SavedSearchDialog.vala"
				_g_object_unref0 (c);
#line 785 "SavedSearchDialog.c"
			}
		}
#line 193 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp32_ = self->priv->operator;
#line 193 "../src/Dialogs/SavedSearchDialog.vala"
		search_operator = (SearchOperator) gtk_combo_box_get_active ((GtkComboBox*) _tmp32_);
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp33_ = saved_search_table_get_instance ();
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp34_ = _tmp33_;
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp35_ = self->priv->search_title;
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp36_ = gtk_entry_get_text (_tmp35_);
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp37_ = conditions;
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp38_ = saved_search_table_create (_tmp34_, _tmp36_, search_operator, _tmp37_);
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp39_ = _tmp38_;
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_g_object_unref0 (_tmp39_);
#line 194 "../src/Dialogs/SavedSearchDialog.vala"
		_saved_search_table_unref0 (_tmp34_);
#line 174 "../src/Dialogs/SavedSearchDialog.vala"
		_g_object_unref0 (conditions);
#line 812 "SavedSearchDialog.c"
	}
}

static void
saved_search_dialog_on_row_changed (SavedSearchDialog* self,
                                    SearchRowContainer* row)
{
#line 198 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (row != NULL);
#line 199 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_set_valid (self, search_row_container_is_complete (row));
#line 826 "SavedSearchDialog.c"
}

static void
saved_search_dialog_on_title_changed (SavedSearchDialog* self)
{
#line 202 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_set_valid (self, saved_search_dialog_is_title_valid (self));
#line 836 "SavedSearchDialog.c"
}

static gchar*
string_chomp (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1397 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1398 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1398 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1399 "glib-2.0.vapi"
	g_strchomp (_result_);
#line 1400 "glib-2.0.vapi"
	result = _result_;
#line 1400 "glib-2.0.vapi"
	return result;
#line 857 "SavedSearchDialog.c"
}

static gboolean
saved_search_dialog_is_title_valid (SavedSearchDialog* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkEntry* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_;
	SavedSearchTable* _tmp13_;
	SavedSearchTable* _tmp14_;
	GtkEntry* _tmp15_;
	const gchar* _tmp16_;
	gboolean _tmp17_;
	gboolean result;
#line 206 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "../src/Dialogs/SavedSearchDialog.vala"
	if (self->priv->edit_mode) {
#line 880 "SavedSearchDialog.c"
		SavedSearch* _tmp2_;
#line 207 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp2_ = self->priv->previous_search;
#line 207 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp1_ = _tmp2_ != NULL;
#line 886 "SavedSearchDialog.c"
	} else {
#line 207 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp1_ = FALSE;
#line 890 "SavedSearchDialog.c"
	}
#line 207 "../src/Dialogs/SavedSearchDialog.vala"
	if (_tmp1_) {
#line 894 "SavedSearchDialog.c"
		SavedSearch* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GtkEntry* _tmp6_;
		const gchar* _tmp7_;
#line 208 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp3_ = self->priv->previous_search;
#line 208 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp4_ = data_object_get_name ((DataObject*) _tmp3_);
#line 208 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp5_ = _tmp4_;
#line 208 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp6_ = self->priv->search_title;
#line 208 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp7_ = gtk_entry_get_text (_tmp6_);
#line 208 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp0_ = g_strcmp0 (_tmp5_, _tmp7_) == 0;
#line 208 "../src/Dialogs/SavedSearchDialog.vala"
		_g_free0 (_tmp5_);
#line 914 "SavedSearchDialog.c"
	} else {
#line 207 "../src/Dialogs/SavedSearchDialog.vala"
		_tmp0_ = FALSE;
#line 918 "SavedSearchDialog.c"
	}
#line 207 "../src/Dialogs/SavedSearchDialog.vala"
	if (_tmp0_) {
#line 209 "../src/Dialogs/SavedSearchDialog.vala"
		result = TRUE;
#line 209 "../src/Dialogs/SavedSearchDialog.vala"
		return result;
#line 926 "SavedSearchDialog.c"
	}
#line 210 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp8_ = self->priv->search_title;
#line 210 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 210 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp10_ = string_chomp (_tmp9_);
#line 210 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp11_ = _tmp10_;
#line 210 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp12_ = g_strcmp0 (_tmp11_, "") == 0;
#line 210 "../src/Dialogs/SavedSearchDialog.vala"
	_g_free0 (_tmp11_);
#line 210 "../src/Dialogs/SavedSearchDialog.vala"
	if (_tmp12_) {
#line 211 "../src/Dialogs/SavedSearchDialog.vala"
		result = FALSE;
#line 211 "../src/Dialogs/SavedSearchDialog.vala"
		return result;
#line 946 "SavedSearchDialog.c"
	}
#line 212 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp13_ = saved_search_table_get_instance ();
#line 212 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp14_ = _tmp13_;
#line 212 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp15_ = self->priv->search_title;
#line 212 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp16_ = gtk_entry_get_text (_tmp15_);
#line 212 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp17_ = saved_search_table_exists (_tmp14_, _tmp16_);
#line 212 "../src/Dialogs/SavedSearchDialog.vala"
	_saved_search_table_unref0 (_tmp14_);
#line 212 "../src/Dialogs/SavedSearchDialog.vala"
	if (_tmp17_) {
#line 213 "../src/Dialogs/SavedSearchDialog.vala"
		result = FALSE;
#line 213 "../src/Dialogs/SavedSearchDialog.vala"
		return result;
#line 966 "SavedSearchDialog.c"
	}
#line 214 "../src/Dialogs/SavedSearchDialog.vala"
	result = TRUE;
#line 214 "../src/Dialogs/SavedSearchDialog.vala"
	return result;
#line 972 "SavedSearchDialog.c"
}

static void
saved_search_dialog_set_valid (SavedSearchDialog* self,
                               gboolean v)
{
	GraniteDialog* _tmp13_;
#line 218 "../src/Dialogs/SavedSearchDialog.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/Dialogs/SavedSearchDialog.vala"
	if (!v) {
#line 220 "../src/Dialogs/SavedSearchDialog.vala"
		self->priv->valid = FALSE;
#line 986 "SavedSearchDialog.c"
	} else {
#line 221 "../src/Dialogs/SavedSearchDialog.vala"
		if (v != self->priv->valid) {
#line 222 "../src/Dialogs/SavedSearchDialog.vala"
			if (saved_search_dialog_is_title_valid (self)) {
#line 992 "SavedSearchDialog.c"
				gint valid_rows = 0;
				GeeArrayList* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
#line 224 "../src/Dialogs/SavedSearchDialog.vala"
				valid_rows = 0;
#line 999 "SavedSearchDialog.c"
				{
					GeeArrayList* _c_list = NULL;
					GeeArrayList* _tmp0_;
					gint _c_size = 0;
					GeeArrayList* _tmp1_;
					gint _tmp2_;
					gint _tmp3_;
					gint _c_index = 0;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
					_tmp0_ = self->priv->row_list;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
					_c_list = _tmp0_;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
					_tmp1_ = _c_list;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
					_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
					_tmp3_ = _tmp2_;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
					_c_size = _tmp3_;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
					_c_index = -1;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
					while (TRUE) {
#line 1024 "SavedSearchDialog.c"
						gint _tmp4_;
						gint _tmp5_;
						SearchRowContainer* c = NULL;
						GeeArrayList* _tmp6_;
						gpointer _tmp7_;
						SearchRowContainer* _tmp8_;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
						_c_index = _c_index + 1;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
						_tmp4_ = _c_index;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
						_tmp5_ = _c_size;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
						if (!(_tmp4_ < _tmp5_)) {
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
							break;
#line 1041 "SavedSearchDialog.c"
						}
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
						_tmp6_ = _c_list;
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
						_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _c_index);
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
						c = (SearchRowContainer*) _tmp7_;
#line 226 "../src/Dialogs/SavedSearchDialog.vala"
						_tmp8_ = c;
#line 226 "../src/Dialogs/SavedSearchDialog.vala"
						if (search_row_container_is_complete (_tmp8_)) {
#line 1053 "SavedSearchDialog.c"
							gint _tmp9_;
#line 227 "../src/Dialogs/SavedSearchDialog.vala"
							_tmp9_ = valid_rows;
#line 227 "../src/Dialogs/SavedSearchDialog.vala"
							valid_rows = _tmp9_ + 1;
#line 1059 "SavedSearchDialog.c"
						}
#line 225 "../src/Dialogs/SavedSearchDialog.vala"
						_g_object_unref0 (c);
#line 1063 "SavedSearchDialog.c"
					}
				}
#line 229 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp10_ = self->priv->row_list;
#line 229 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 229 "../src/Dialogs/SavedSearchDialog.vala"
				_tmp12_ = _tmp11_;
#line 229 "../src/Dialogs/SavedSearchDialog.vala"
				self->priv->valid = valid_rows == _tmp12_;
#line 1074 "SavedSearchDialog.c"
			} else {
#line 231 "../src/Dialogs/SavedSearchDialog.vala"
				self->priv->valid = FALSE;
#line 1078 "SavedSearchDialog.c"
			}
		}
	}
#line 235 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp13_ = self->priv->dialog;
#line 235 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_dialog_set_response_sensitive ((GtkDialog*) _tmp13_, (gint) GTK_RESPONSE_OK, self->priv->valid);
#line 1086 "SavedSearchDialog.c"
}

static gboolean
_saved_search_dialog_on_add_criteria_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                    GdkEventButton* event,
                                                                    gpointer self)
{
	gboolean result;
	result = saved_search_dialog_on_add_criteria ((SavedSearchDialog*) self, event);
#line 102 "../src/Dialogs/SavedSearchDialog.vala"
	return result;
#line 1098 "SavedSearchDialog.c"
}

static void
_saved_search_dialog_on_response_gtk_dialog_response (GtkDialog* _sender,
                                                      gint response_id,
                                                      gpointer self)
{
#line 126 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_on_response ((SavedSearchDialog*) self, response_id);
#line 1108 "SavedSearchDialog.c"
}

static GObject *
saved_search_dialog_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SavedSearchDialog * self;
	GtkLabel* search_label = NULL;
	GtkLabel* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	GtkEntry* _tmp4_;
	GtkLabel* match_label = NULL;
	GtkLabel* _tmp5_;
	GtkComboBoxText* _tmp6_;
	GtkComboBoxText* _tmp7_;
	GtkComboBoxText* _tmp8_;
	GtkComboBoxText* _tmp9_;
	GtkComboBoxText* _tmp10_;
	GtkLabel* match2_label = NULL;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkGrid* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* search_grid = NULL;
	GtkGrid* _tmp20_;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkEntry* _tmp27_;
	GtkGrid* _tmp28_;
	GtkSeparator* _tmp29_;
	GtkSeparator* _tmp30_;
	GtkGrid* _tmp31_;
	GtkLabel* _tmp32_;
	GtkGrid* _tmp33_;
	GtkComboBoxText* _tmp34_;
	GtkGrid* _tmp35_;
	GtkLabel* _tmp36_;
	GtkGrid* _tmp37_;
	GtkButton* _tmp38_;
	GtkGrid* _tmp39_;
	GtkSeparator* _tmp40_;
	GtkSeparator* _tmp41_;
	GtkGrid* _tmp42_;
	GtkGrid* _tmp43_;
	GraniteDialog* _tmp44_;
	GraniteDialog* _tmp45_;
	GraniteDialog* _tmp46_;
	GraniteDialog* _tmp47_;
	AppWindow* _tmp48_;
	AppWindow* _tmp49_;
	GraniteDialog* _tmp50_;
	GraniteDialog* _tmp51_;
	GraniteDialog* _tmp52_;
	GtkBox* _tmp53_;
	GtkGrid* _tmp54_;
	GraniteDialog* _tmp55_;
	GraniteDialog* _tmp56_;
	GtkButton* _tmp57_;
	GtkButton* _tmp58_;
#line 80 "../src/Dialogs/SavedSearchDialog.vala"
	parent_class = G_OBJECT_CLASS (saved_search_dialog_parent_class);
#line 80 "../src/Dialogs/SavedSearchDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 80 "../src/Dialogs/SavedSearchDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SAVED_SEARCH_DIALOG, SavedSearchDialog);
#line 81 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Name:"));
#line 81 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp0_);
#line 81 "../src/Dialogs/SavedSearchDialog.vala"
	search_label = _tmp0_;
#line 83 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp1_ = (GtkEntry*) gtk_entry_new ();
#line 83 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp1_);
#line 83 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->search_title);
#line 83 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->search_title = _tmp1_;
#line 84 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp2_ = self->priv->search_title;
#line 84 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_entry_set_activates_default (_tmp2_, TRUE);
#line 85 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp3_ = self->priv->search_title;
#line 85 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 86 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp4_ = self->priv->search_title;
#line 86 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp4_, "changed", (GCallback) _saved_search_dialog_on_title_changed_gtk_editable_changed, self, 0);
#line 88 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Match"));
#line 88 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 88 "../src/Dialogs/SavedSearchDialog.vala"
	match_label = _tmp5_;
#line 90 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp6_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 90 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp6_);
#line 90 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->operator);
#line 90 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->operator = _tmp6_;
#line 91 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp7_ = self->priv->operator;
#line 91 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_combo_box_text_append_text (_tmp7_, _ ("any"));
#line 92 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp8_ = self->priv->operator;
#line 92 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_combo_box_text_append_text (_tmp8_, _ ("all"));
#line 93 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp9_ = self->priv->operator;
#line 93 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_combo_box_text_append_text (_tmp9_, _ ("none"));
#line 94 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp10_ = self->priv->operator;
#line 94 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _tmp10_, 0);
#line 96 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("of the following:"));
#line 96 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp11_);
#line 96 "../src/Dialogs/SavedSearchDialog.vala"
	match2_label = _tmp11_;
#line 97 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp12_ = match2_label;
#line 97 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
#line 98 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp13_ = match2_label;
#line 98 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_label_set_xalign (_tmp13_, (gfloat) 0);
#line 100 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 100 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp14_);
#line 100 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->add_criteria);
#line 100 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->add_criteria = _tmp14_;
#line 101 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp15_ = self->priv->add_criteria;
#line 101 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp15_, _ ("Add rule"));
#line 102 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp16_ = self->priv->add_criteria;
#line 102 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_connect_object ((GtkWidget*) _tmp16_, "button-press-event", (GCallback) _saved_search_dialog_on_add_criteria_gtk_widget_button_press_event, self, 0);
#line 104 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
#line 104 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp17_);
#line 104 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->row_box);
#line 104 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->row_box = _tmp17_;
#line 105 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp18_ = self->priv->row_box;
#line 105 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp18_, GTK_ORIENTATION_VERTICAL);
#line 106 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp19_ = self->priv->row_box;
#line 106 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_set_row_spacing (_tmp19_, 12);
#line 108 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp20_ = (GtkGrid*) gtk_grid_new ();
#line 108 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp20_);
#line 108 "../src/Dialogs/SavedSearchDialog.vala"
	search_grid = _tmp20_;
#line 109 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp21_ = search_grid;
#line 109 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_set ((GtkWidget*) _tmp21_, "margin", 12, NULL);
#line 110 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp22_ = search_grid;
#line 110 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_set_column_spacing (_tmp22_, 6);
#line 111 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp23_ = search_grid;
#line 111 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_set_row_spacing (_tmp23_, 12);
#line 112 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp24_ = search_grid;
#line 112 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp25_ = search_label;
#line 112 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 0, 0, 1, 1);
#line 113 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp26_ = search_grid;
#line 113 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp27_ = self->priv->search_title;
#line 113 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp26_, (GtkWidget*) _tmp27_, 1, 0, 3, 1);
#line 114 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp28_ = search_grid;
#line 114 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp29_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 114 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp29_);
#line 114 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp30_ = _tmp29_;
#line 114 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp30_, 0, 1, 4, 1);
#line 114 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (_tmp30_);
#line 115 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp31_ = search_grid;
#line 115 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp32_ = match_label;
#line 115 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 0, 2, 1, 1);
#line 116 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp33_ = search_grid;
#line 116 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp34_ = self->priv->operator;
#line 116 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp33_, (GtkWidget*) _tmp34_, 1, 2, 1, 1);
#line 117 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp35_ = search_grid;
#line 117 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp36_ = match2_label;
#line 117 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp35_, (GtkWidget*) _tmp36_, 2, 2, 1, 1);
#line 118 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp37_ = search_grid;
#line 118 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp38_ = self->priv->add_criteria;
#line 118 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 3, 2, 1, 1);
#line 119 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp39_ = search_grid;
#line 119 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp40_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 119 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp40_);
#line 119 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp41_ = _tmp40_;
#line 119 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp41_, 0, 3, 4, 1);
#line 119 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (_tmp41_);
#line 120 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp42_ = search_grid;
#line 120 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp43_ = self->priv->row_box;
#line 120 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 0, 4, 4, 1);
#line 122 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp44_ = granite_dialog_new ();
#line 122 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp44_);
#line 122 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 122 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->dialog = _tmp44_;
#line 123 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp45_ = self->priv->dialog;
#line 123 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_window_set_title ((GtkWindow*) _tmp45_, _ ("Smart Album"));
#line 124 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp46_ = self->priv->dialog;
#line 124 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_window_set_modal ((GtkWindow*) _tmp46_, TRUE);
#line 125 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp47_ = self->priv->dialog;
#line 125 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp48_ = app_window_get_instance ();
#line 125 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp49_ = _tmp48_;
#line 125 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp47_, (GtkWindow*) _tmp49_);
#line 125 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (_tmp49_);
#line 126 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp50_ = self->priv->dialog;
#line 126 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_connect_object ((GtkDialog*) _tmp50_, "response", (GCallback) _saved_search_dialog_on_response_gtk_dialog_response, self, 0);
#line 127 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp51_ = self->priv->dialog;
#line 127 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) _tmp51_, FALSE);
#line 128 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp52_ = self->priv->dialog;
#line 128 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp53_ = gtk_dialog_get_content_area ((GtkDialog*) _tmp52_);
#line 128 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp54_ = search_grid;
#line 128 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
#line 129 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp55_ = self->priv->dialog;
#line 129 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_dialog_set_default_response ((GtkDialog*) _tmp55_, (gint) GTK_RESPONSE_OK);
#line 131 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp56_ = self->priv->dialog;
#line 131 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp57_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
#line 131 "../src/Dialogs/SavedSearchDialog.vala"
	g_object_ref_sink (_tmp57_);
#line 131 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp58_ = _tmp57_;
#line 131 "../src/Dialogs/SavedSearchDialog.vala"
	gtk_dialog_add_action_widget ((GtkDialog*) _tmp56_, (GtkWidget*) _tmp58_, (gint) GTK_RESPONSE_CANCEL);
#line 131 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (_tmp58_);
#line 80 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (search_grid);
#line 80 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (match2_label);
#line 80 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (match_label);
#line 80 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (search_label);
#line 80 "../src/Dialogs/SavedSearchDialog.vala"
	return obj;
#line 1442 "SavedSearchDialog.c"
}

static void
saved_search_dialog_class_init (SavedSearchDialogClass * klass,
                                gpointer klass_data)
{
#line 22 "../src/Dialogs/SavedSearchDialog.vala"
	saved_search_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Dialogs/SavedSearchDialog.vala"
	g_type_class_adjust_private_offset (klass, &SavedSearchDialog_private_offset);
#line 22 "../src/Dialogs/SavedSearchDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = saved_search_dialog_constructor;
#line 22 "../src/Dialogs/SavedSearchDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = saved_search_dialog_finalize;
#line 1457 "SavedSearchDialog.c"
}

static void
saved_search_dialog_instance_init (SavedSearchDialog * self,
                                   gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 22 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv = saved_search_dialog_get_instance_private (self);
#line 28 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp0_ = gee_array_list_new (TYPE_SEARCH_ROW_CONTAINER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 28 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->row_list = _tmp0_;
#line 29 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->edit_mode = FALSE;
#line 30 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->previous_search = NULL;
#line 31 "../src/Dialogs/SavedSearchDialog.vala"
	self->priv->valid = FALSE;
#line 1477 "SavedSearchDialog.c"
}

static void
saved_search_dialog_finalize (GObject * obj)
{
	SavedSearchDialog * self;
	GtkEntry* _tmp0_;
	guint _tmp1_;
#line 22 "../src/Dialogs/SavedSearchDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SAVED_SEARCH_DIALOG, SavedSearchDialog);
#line 77 "../src/Dialogs/SavedSearchDialog.vala"
	_tmp0_ = self->priv->search_title;
#line 77 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_parse_name ("changed", gtk_editable_get_type (), &_tmp1_, NULL, FALSE);
#line 77 "../src/Dialogs/SavedSearchDialog.vala"
	g_signal_handlers_disconnect_matched ((GtkEditable*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _saved_search_dialog_on_title_changed_gtk_editable_changed, self);
#line 23 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 24 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->add_criteria);
#line 25 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->operator);
#line 26 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->row_box);
#line 27 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->search_title);
#line 28 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->row_list);
#line 30 "../src/Dialogs/SavedSearchDialog.vala"
	_g_object_unref0 (self->priv->previous_search);
#line 22 "../src/Dialogs/SavedSearchDialog.vala"
	G_OBJECT_CLASS (saved_search_dialog_parent_class)->finalize (obj);
#line 1510 "SavedSearchDialog.c"
}

static GType
saved_search_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SavedSearchDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) saved_search_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SavedSearchDialog), 0, (GInstanceInitFunc) saved_search_dialog_instance_init, NULL };
	GType saved_search_dialog_type_id;
	saved_search_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "SavedSearchDialog", &g_define_type_info, 0);
	SavedSearchDialog_private_offset = g_type_add_instance_private (saved_search_dialog_type_id, sizeof (SavedSearchDialogPrivate));
	return saved_search_dialog_type_id;
}

GType
saved_search_dialog_get_type (void)
{
	static volatile gsize saved_search_dialog_type_id__once = 0;
	if (g_once_init_enter (&saved_search_dialog_type_id__once)) {
		GType saved_search_dialog_type_id;
		saved_search_dialog_type_id = saved_search_dialog_get_type_once ();
		g_once_init_leave (&saved_search_dialog_type_id__once, saved_search_dialog_type_id);
	}
	return saved_search_dialog_type_id__once;
}

