/* Dimensions.c generated by valac 0.56.18, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define SCALING_NO_SCALE 0
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

static void scaling_init (Scaling *self,
                   ScaleConstraint constraint,
                   gint scale,
                   Dimensions* viewport,
                   gboolean scale_up);
static gint scaling_scale_to_pixels (Scaling *self);
VALA_EXTERN GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf,
                         gint scale,
                         GdkInterpType interp,
                         gboolean scale_up);
VALA_EXTERN GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);

gchar*
scale_constraint_to_string (ScaleConstraint self)
{
	gchar* result;
#line 28 "../src/Dimensions.vala"
	switch (self) {
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 78 "Dimensions.c"
		{
			gchar* _tmp0_;
#line 30 "../src/Dimensions.vala"
			_tmp0_ = g_strdup (_ ("Original size"));
#line 30 "../src/Dimensions.vala"
			result = _tmp0_;
#line 30 "../src/Dimensions.vala"
			return result;
#line 87 "Dimensions.c"
		}
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 91 "Dimensions.c"
		{
			gchar* _tmp1_;
#line 33 "../src/Dimensions.vala"
			_tmp1_ = g_strdup (_ ("Width or height"));
#line 33 "../src/Dimensions.vala"
			result = _tmp1_;
#line 33 "../src/Dimensions.vala"
			return result;
#line 100 "Dimensions.c"
		}
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 104 "Dimensions.c"
		{
			gchar* _tmp2_;
#line 36 "../src/Dimensions.vala"
			_tmp2_ = g_strdup (_ ("Width"));
#line 36 "../src/Dimensions.vala"
			result = _tmp2_;
#line 36 "../src/Dimensions.vala"
			return result;
#line 113 "Dimensions.c"
		}
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 117 "Dimensions.c"
		{
			gchar* _tmp3_;
#line 39 "../src/Dimensions.vala"
			_tmp3_ = g_strdup (_ ("Height"));
#line 39 "../src/Dimensions.vala"
			result = _tmp3_;
#line 39 "../src/Dimensions.vala"
			return result;
#line 126 "Dimensions.c"
		}
#line 28 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 130 "Dimensions.c"
		{
			gchar* _tmp4_;
#line 43 "../src/Dimensions.vala"
			_tmp4_ = g_strdup ("Fill Viewport");
#line 43 "../src/Dimensions.vala"
			result = _tmp4_;
#line 43 "../src/Dimensions.vala"
			return result;
#line 139 "Dimensions.c"
		}
		default:
#line 28 "../src/Dimensions.vala"
		break;
#line 144 "Dimensions.c"
	}
#line 46 "../src/Dimensions.vala"
	g_warn_if_reached ();
#line 48 "../src/Dimensions.vala"
	result = NULL;
#line 48 "../src/Dimensions.vala"
	return result;
#line 152 "Dimensions.c"
}

static GType
scale_constraint_get_type_once (void)
{
	static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
	GType scale_constraint_type_id;
	scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
	return scale_constraint_type_id;
}

GType
scale_constraint_get_type (void)
{
	static volatile gsize scale_constraint_type_id__once = 0;
	if (g_once_init_enter (&scale_constraint_type_id__once)) {
		GType scale_constraint_type_id;
		scale_constraint_type_id = scale_constraint_get_type_once ();
		g_once_init_leave (&scale_constraint_type_id__once, scale_constraint_type_id);
	}
	return scale_constraint_type_id__once;
}

void
dimensions_init (Dimensions *self,
                 gint width,
                 gint height)
{
	gboolean _tmp0_ = FALSE;
#line 56 "../src/Dimensions.vala"
	memset (self, 0, sizeof (Dimensions));
#line 57 "../src/Dimensions.vala"
	if (width < 0) {
#line 57 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 188 "Dimensions.c"
	} else {
#line 57 "../src/Dimensions.vala"
		_tmp0_ = height < 0;
#line 192 "Dimensions.c"
	}
#line 57 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 58 "../src/Dimensions.vala"
		g_warning ("Dimensions.vala:58: Tried to construct a Dimensions object with negati" \
"ve width or height - forcing sensible default values.");
#line 198 "Dimensions.c"
	}
#line 60 "../src/Dimensions.vala"
	(*self).width = CLAMP (width, 0, width);
#line 61 "../src/Dimensions.vala"
	(*self).height = CLAMP (height, 0, height);
#line 204 "Dimensions.c"
}

void
dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                       Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 64 "../src/Dimensions.vala"
	g_return_if_fail (pixbuf != NULL);
#line 65 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, gdk_pixbuf_get_width (pixbuf), gdk_pixbuf_get_height (pixbuf));
#line 65 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 65 "../src/Dimensions.vala"
	return;
#line 220 "Dimensions.c"
}

void
dimensions_for_allocation (GtkAllocation* allocation,
                           Dimensions* result)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	Dimensions _tmp2_ = {0};
#line 68 "../src/Dimensions.vala"
	g_return_if_fail (allocation != NULL);
#line 69 "../src/Dimensions.vala"
	_tmp0_ = *allocation;
#line 69 "../src/Dimensions.vala"
	_tmp1_ = *allocation;
#line 69 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, _tmp0_.width, _tmp1_.height);
#line 69 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 69 "../src/Dimensions.vala"
	return;
#line 242 "Dimensions.c"
}

void
dimensions_for_widget_allocation (GtkWidget* widget,
                                  Dimensions* result)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	gint scale_factor = 0;
	gint _tmp1_;
	gint _tmp2_;
	GtkAllocation _tmp3_;
	GtkAllocation _tmp4_;
	Dimensions _tmp5_ = {0};
#line 72 "../src/Dimensions.vala"
	g_return_if_fail (widget != NULL);
#line 74 "../src/Dimensions.vala"
	gtk_widget_get_allocation (widget, &_tmp0_);
#line 74 "../src/Dimensions.vala"
	allocation = _tmp0_;
#line 75 "../src/Dimensions.vala"
	_tmp1_ = gtk_widget_get_scale_factor (widget);
#line 75 "../src/Dimensions.vala"
	_tmp2_ = _tmp1_;
#line 75 "../src/Dimensions.vala"
	scale_factor = _tmp2_;
#line 77 "../src/Dimensions.vala"
	_tmp3_ = allocation;
#line 77 "../src/Dimensions.vala"
	_tmp4_ = allocation;
#line 77 "../src/Dimensions.vala"
	dimensions_init (&_tmp5_, _tmp3_.width * scale_factor, _tmp4_.height * scale_factor);
#line 77 "../src/Dimensions.vala"
	*result = _tmp5_;
#line 77 "../src/Dimensions.vala"
	return;
#line 279 "Dimensions.c"
}

void
dimensions_for_rectangle (GdkRectangle* rect,
                          Dimensions* result)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	Dimensions _tmp2_ = {0};
#line 80 "../src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 81 "../src/Dimensions.vala"
	_tmp0_ = *rect;
#line 81 "../src/Dimensions.vala"
	_tmp1_ = *rect;
#line 81 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, _tmp0_.width, _tmp1_.height);
#line 81 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 81 "../src/Dimensions.vala"
	return;
#line 301 "Dimensions.c"
}

gboolean
dimensions_has_area (Dimensions *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 85 "../src/Dimensions.vala"
	if ((*self).width > 0) {
#line 85 "../src/Dimensions.vala"
		_tmp0_ = (*self).height > 0;
#line 313 "Dimensions.c"
	} else {
#line 85 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 317 "Dimensions.c"
	}
#line 85 "../src/Dimensions.vala"
	result = _tmp0_;
#line 85 "../src/Dimensions.vala"
	return result;
#line 323 "Dimensions.c"
}

void
dimensions_floor (Dimensions *self,
                  Dimensions* min,
                  Dimensions* result)
{
	gint _tmp0_ = 0;
	Dimensions _tmp1_;
	gint _tmp3_ = 0;
	Dimensions _tmp4_;
	Dimensions _tmp6_ = {0};
#line 88 "../src/Dimensions.vala"
	g_return_if_fail (min != NULL);
#line 89 "../src/Dimensions.vala"
	_tmp1_ = *min;
#line 89 "../src/Dimensions.vala"
	if ((*self).width > _tmp1_.width) {
#line 89 "../src/Dimensions.vala"
		_tmp0_ = (*self).width;
#line 344 "Dimensions.c"
	} else {
		Dimensions _tmp2_;
#line 89 "../src/Dimensions.vala"
		_tmp2_ = *min;
#line 89 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_.width;
#line 351 "Dimensions.c"
	}
#line 90 "../src/Dimensions.vala"
	_tmp4_ = *min;
#line 90 "../src/Dimensions.vala"
	if ((*self).height > _tmp4_.height) {
#line 90 "../src/Dimensions.vala"
		_tmp3_ = (*self).height;
#line 359 "Dimensions.c"
	} else {
		Dimensions _tmp5_;
#line 90 "../src/Dimensions.vala"
		_tmp5_ = *min;
#line 90 "../src/Dimensions.vala"
		_tmp3_ = _tmp5_.height;
#line 366 "Dimensions.c"
	}
#line 89 "../src/Dimensions.vala"
	dimensions_init (&_tmp6_, _tmp0_, _tmp3_);
#line 89 "../src/Dimensions.vala"
	*result = _tmp6_;
#line 89 "../src/Dimensions.vala"
	return;
#line 374 "Dimensions.c"
}

gchar*
dimensions_to_string (Dimensions *self)
{
	gchar* _tmp0_;
	gchar* result;
#line 94 "../src/Dimensions.vala"
	_tmp0_ = g_strdup_printf ("%dx%d", (*self).width, (*self).height);
#line 94 "../src/Dimensions.vala"
	result = _tmp0_;
#line 94 "../src/Dimensions.vala"
	return result;
#line 388 "Dimensions.c"
}

gboolean
dimensions_equals (Dimensions *self,
                   Dimensions* dim)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	gboolean result;
#line 97 "../src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 98 "../src/Dimensions.vala"
	_tmp1_ = *dim;
#line 98 "../src/Dimensions.vala"
	if ((*self).width == _tmp1_.width) {
#line 404 "Dimensions.c"
		Dimensions _tmp2_;
#line 98 "../src/Dimensions.vala"
		_tmp2_ = *dim;
#line 98 "../src/Dimensions.vala"
		_tmp0_ = (*self).height == _tmp2_.height;
#line 410 "Dimensions.c"
	} else {
#line 98 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 414 "Dimensions.c"
	}
#line 98 "../src/Dimensions.vala"
	result = _tmp0_;
#line 98 "../src/Dimensions.vala"
	return result;
#line 420 "Dimensions.c"
}

gboolean
dimensions_approx_equals (Dimensions *self,
                          Dimensions* dim,
                          gint fudge)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	gboolean result;
#line 102 "../src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 103 "../src/Dimensions.vala"
	_tmp1_ = *dim;
#line 103 "../src/Dimensions.vala"
	if (abs ((*self).width - _tmp1_.width) <= fudge) {
#line 437 "Dimensions.c"
		Dimensions _tmp2_;
#line 103 "../src/Dimensions.vala"
		_tmp2_ = *dim;
#line 103 "../src/Dimensions.vala"
		_tmp0_ = abs ((*self).height - _tmp2_.height) <= fudge;
#line 443 "Dimensions.c"
	} else {
#line 103 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 447 "Dimensions.c"
	}
#line 103 "../src/Dimensions.vala"
	result = _tmp0_;
#line 103 "../src/Dimensions.vala"
	return result;
#line 453 "Dimensions.c"
}

gboolean
dimensions_approx_scaled (Dimensions *self,
                          gint scale,
                          gint fudge)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 107 "../src/Dimensions.vala"
	if ((*self).width <= (scale + fudge)) {
#line 107 "../src/Dimensions.vala"
		_tmp0_ = (*self).height <= (scale + fudge);
#line 467 "Dimensions.c"
	} else {
#line 107 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 471 "Dimensions.c"
	}
#line 107 "../src/Dimensions.vala"
	result = _tmp0_;
#line 107 "../src/Dimensions.vala"
	return result;
#line 477 "Dimensions.c"
}

gint
dimensions_major_axis (Dimensions *self)
{
	gint result;
#line 111 "../src/Dimensions.vala"
	result = MAX ((*self).width, (*self).height);
#line 111 "../src/Dimensions.vala"
	return result;
#line 488 "Dimensions.c"
}

gint
dimensions_minor_axis (Dimensions *self)
{
	gint result;
#line 115 "../src/Dimensions.vala"
	result = MIN ((*self).width, (*self).height);
#line 115 "../src/Dimensions.vala"
	return result;
#line 499 "Dimensions.c"
}

void
dimensions_with_min (Dimensions *self,
                     gint min_width,
                     gint min_height,
                     Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 119 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, MAX ((*self).width, min_width), MAX ((*self).height, min_height));
#line 119 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 119 "../src/Dimensions.vala"
	return;
#line 515 "Dimensions.c"
}

void
dimensions_with_max (Dimensions *self,
                     gint max_width,
                     gint max_height,
                     Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 123 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, MIN ((*self).width, max_width), MIN ((*self).height, max_height));
#line 123 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 123 "../src/Dimensions.vala"
	return;
#line 531 "Dimensions.c"
}

void
dimensions_get_scaled (Dimensions *self,
                       gint scale,
                       gboolean scale_up,
                       Dimensions* result)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 127 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 130 "../src/Dimensions.vala"
	if ((*self).width == scale) {
#line 130 "../src/Dimensions.vala"
		_tmp1_ = (*self).height < scale;
#line 549 "Dimensions.c"
	} else {
#line 130 "../src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 553 "Dimensions.c"
	}
#line 130 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 130 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 559 "Dimensions.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 130 "../src/Dimensions.vala"
		if ((*self).height == scale) {
#line 130 "../src/Dimensions.vala"
			_tmp2_ = (*self).width < scale;
#line 566 "Dimensions.c"
		} else {
#line 130 "../src/Dimensions.vala"
			_tmp2_ = FALSE;
#line 570 "Dimensions.c"
		}
#line 130 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_;
#line 574 "Dimensions.c"
	}
#line 130 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 578 "Dimensions.c"
		Dimensions _tmp3_ = {0};
#line 131 "../src/Dimensions.vala"
		dimensions_init (&_tmp3_, (*self).width, (*self).height);
#line 131 "../src/Dimensions.vala"
		*result = _tmp3_;
#line 131 "../src/Dimensions.vala"
		return;
#line 586 "Dimensions.c"
	}
#line 134 "../src/Dimensions.vala"
	if (!scale_up) {
#line 590 "Dimensions.c"
		gboolean _tmp5_ = FALSE;
#line 134 "../src/Dimensions.vala"
		if ((*self).width < scale) {
#line 134 "../src/Dimensions.vala"
			_tmp5_ = (*self).height < scale;
#line 596 "Dimensions.c"
		} else {
#line 134 "../src/Dimensions.vala"
			_tmp5_ = FALSE;
#line 600 "Dimensions.c"
		}
#line 134 "../src/Dimensions.vala"
		_tmp4_ = _tmp5_;
#line 604 "Dimensions.c"
	} else {
#line 134 "../src/Dimensions.vala"
		_tmp4_ = FALSE;
#line 608 "Dimensions.c"
	}
#line 134 "../src/Dimensions.vala"
	if (_tmp4_) {
#line 612 "Dimensions.c"
		Dimensions _tmp6_ = {0};
#line 135 "../src/Dimensions.vala"
		dimensions_init (&_tmp6_, (*self).width, (*self).height);
#line 135 "../src/Dimensions.vala"
		*result = _tmp6_;
#line 135 "../src/Dimensions.vala"
		return;
#line 620 "Dimensions.c"
	}
#line 137 "../src/Dimensions.vala"
	if (((*self).width - scale) > ((*self).height - scale)) {
#line 624 "Dimensions.c"
		Dimensions _tmp7_ = {0};
#line 138 "../src/Dimensions.vala"
		dimensions_get_scaled_by_width (&(*self), scale, &_tmp7_);
#line 138 "../src/Dimensions.vala"
		*result = _tmp7_;
#line 138 "../src/Dimensions.vala"
		return;
#line 632 "Dimensions.c"
	} else {
		Dimensions _tmp8_ = {0};
#line 140 "../src/Dimensions.vala"
		dimensions_get_scaled_by_height (&(*self), scale, &_tmp8_);
#line 140 "../src/Dimensions.vala"
		*result = _tmp8_;
#line 140 "../src/Dimensions.vala"
		return;
#line 641 "Dimensions.c"
	}
}

void
dimensions_get_scale_ratios (Dimensions *self,
                             Dimensions* scaled,
                             gdouble* width_ratio,
                             gdouble* height_ratio)
{
	gdouble _vala_width_ratio = 0.0;
	gdouble _vala_height_ratio = 0.0;
	Dimensions _tmp0_;
	Dimensions _tmp1_;
#line 143 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 144 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 144 "../src/Dimensions.vala"
	_vala_width_ratio = ((gdouble) _tmp0_.width) / ((gdouble) (*self).width);
#line 145 "../src/Dimensions.vala"
	_tmp1_ = *scaled;
#line 145 "../src/Dimensions.vala"
	_vala_height_ratio = ((gdouble) _tmp1_.height) / ((gdouble) (*self).height);
#line 143 "../src/Dimensions.vala"
	if (width_ratio) {
#line 143 "../src/Dimensions.vala"
		*width_ratio = _vala_width_ratio;
#line 669 "Dimensions.c"
	}
#line 143 "../src/Dimensions.vala"
	if (height_ratio) {
#line 143 "../src/Dimensions.vala"
		*height_ratio = _vala_height_ratio;
#line 675 "Dimensions.c"
	}
}

gdouble
dimensions_get_aspect_ratio (Dimensions *self)
{
	gdouble result;
#line 149 "../src/Dimensions.vala"
	result = ((gdouble) (*self).width) / (*self).height;
#line 149 "../src/Dimensions.vala"
	return result;
#line 687 "Dimensions.c"
}

void
dimensions_get_scaled_proportional (Dimensions *self,
                                    Dimensions* viewport,
                                    Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	Dimensions scaled = {0};
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_;
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	Dimensions _tmp11_;
#line 152 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 154 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 154 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 154 "../src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 154 "../src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 157 "../src/Dimensions.vala"
	if (width_ratio < height_ratio) {
#line 722 "Dimensions.c"
		Dimensions _tmp3_;
#line 158 "../src/Dimensions.vala"
		_tmp3_ = *viewport;
#line 158 "../src/Dimensions.vala"
		scaled_width = (gdouble) _tmp3_.width;
#line 159 "../src/Dimensions.vala"
		scaled_height = ((gdouble) (*self).height) * width_ratio;
#line 730 "Dimensions.c"
	} else {
		Dimensions _tmp4_;
#line 161 "../src/Dimensions.vala"
		scaled_width = ((gdouble) (*self).width) * height_ratio;
#line 162 "../src/Dimensions.vala"
		_tmp4_ = *viewport;
#line 162 "../src/Dimensions.vala"
		scaled_height = (gdouble) _tmp4_.height;
#line 739 "Dimensions.c"
	}
#line 165 "../src/Dimensions.vala"
	dimensions_init (&_tmp5_, (gint) round (scaled_width), (gint) round (scaled_height));
#line 165 "../src/Dimensions.vala"
	dimensions_init (&_tmp6_, 1, 1);
#line 165 "../src/Dimensions.vala"
	dimensions_floor (&_tmp5_, &_tmp6_, &_tmp7_);
#line 165 "../src/Dimensions.vala"
	scaled = _tmp7_;
#line 167 "../src/Dimensions.vala"
	_tmp8_ = scaled;
#line 167 "../src/Dimensions.vala"
	_tmp9_ = *viewport;
#line 167 "../src/Dimensions.vala"
	_vala_assert (_tmp8_.height <= _tmp9_.height, "scaled.height <= viewport.height");
#line 168 "../src/Dimensions.vala"
	_tmp10_ = scaled;
#line 168 "../src/Dimensions.vala"
	_tmp11_ = *viewport;
#line 168 "../src/Dimensions.vala"
	_vala_assert (_tmp10_.width <= _tmp11_.width, "scaled.width <= viewport.width");
#line 170 "../src/Dimensions.vala"
	*result = scaled;
#line 170 "../src/Dimensions.vala"
	return;
#line 765 "Dimensions.c"
}

void
dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                        Dimensions* viewport,
                                        Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gboolean _tmp3_ = FALSE;
	Dimensions _tmp4_;
	Dimensions _tmp11_ = {0};
	Dimensions _tmp12_ = {0};
	Dimensions _tmp13_ = {0};
#line 173 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 175 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 175 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 175 "../src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 175 "../src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 178 "../src/Dimensions.vala"
	_tmp4_ = *viewport;
#line 178 "../src/Dimensions.vala"
	if ((*self).width < _tmp4_.width) {
#line 799 "Dimensions.c"
		Dimensions _tmp5_;
#line 178 "../src/Dimensions.vala"
		_tmp5_ = *viewport;
#line 178 "../src/Dimensions.vala"
		_tmp3_ = (*self).height >= _tmp5_.height;
#line 805 "Dimensions.c"
	} else {
#line 178 "../src/Dimensions.vala"
		_tmp3_ = FALSE;
#line 809 "Dimensions.c"
	}
#line 178 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 813 "Dimensions.c"
		Dimensions _tmp6_;
#line 180 "../src/Dimensions.vala"
		_tmp6_ = *viewport;
#line 180 "../src/Dimensions.vala"
		scaled_width = (gdouble) _tmp6_.width;
#line 181 "../src/Dimensions.vala"
		scaled_height = ((gdouble) (*self).height) * width_ratio;
#line 821 "Dimensions.c"
	} else {
		gboolean _tmp7_ = FALSE;
		Dimensions _tmp8_;
#line 182 "../src/Dimensions.vala"
		_tmp8_ = *viewport;
#line 182 "../src/Dimensions.vala"
		if ((*self).width >= _tmp8_.width) {
#line 829 "Dimensions.c"
			Dimensions _tmp9_;
#line 182 "../src/Dimensions.vala"
			_tmp9_ = *viewport;
#line 182 "../src/Dimensions.vala"
			_tmp7_ = (*self).height < _tmp9_.height;
#line 835 "Dimensions.c"
		} else {
#line 182 "../src/Dimensions.vala"
			_tmp7_ = FALSE;
#line 839 "Dimensions.c"
		}
#line 182 "../src/Dimensions.vala"
		if (_tmp7_) {
#line 843 "Dimensions.c"
			Dimensions _tmp10_;
#line 184 "../src/Dimensions.vala"
			scaled_width = ((gdouble) (*self).width) * height_ratio;
#line 185 "../src/Dimensions.vala"
			_tmp10_ = *viewport;
#line 185 "../src/Dimensions.vala"
			scaled_height = (gdouble) _tmp10_.height;
#line 851 "Dimensions.c"
		} else {
			gdouble ratio = 0.0;
#line 188 "../src/Dimensions.vala"
			ratio = MAX (width_ratio, height_ratio);
#line 190 "../src/Dimensions.vala"
			scaled_width = ((gdouble) (*self).width) * ratio;
#line 191 "../src/Dimensions.vala"
			scaled_height = ((gdouble) (*self).height) * ratio;
#line 860 "Dimensions.c"
		}
	}
#line 194 "../src/Dimensions.vala"
	dimensions_init (&_tmp11_, (gint) round (scaled_width), (gint) round (scaled_height));
#line 194 "../src/Dimensions.vala"
	dimensions_init (&_tmp12_, 1, 1);
#line 194 "../src/Dimensions.vala"
	dimensions_floor (&_tmp11_, &_tmp12_, &_tmp13_);
#line 194 "../src/Dimensions.vala"
	*result = _tmp13_;
#line 194 "../src/Dimensions.vala"
	return;
#line 873 "Dimensions.c"
}

void
dimensions_get_scaled_rectangle (Dimensions *self,
                                 Dimensions* scaled,
                                 GdkRectangle* rect,
                                 GdkRectangle* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GdkRectangle scaled_rect = {0};
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
#line 197 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 197 "../src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 199 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 199 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 199 "../src/Dimensions.vala"
	x_scale = _tmp1_;
#line 199 "../src/Dimensions.vala"
	y_scale = _tmp2_;
#line 201 "../src/Dimensions.vala"
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
#line 202 "../src/Dimensions.vala"
	_tmp3_ = *rect;
#line 202 "../src/Dimensions.vala"
	scaled_rect.x = (gint) round (((gdouble) _tmp3_.x) * x_scale);
#line 203 "../src/Dimensions.vala"
	_tmp4_ = *rect;
#line 203 "../src/Dimensions.vala"
	scaled_rect.y = (gint) round (((gdouble) _tmp4_.y) * y_scale);
#line 204 "../src/Dimensions.vala"
	_tmp5_ = *rect;
#line 204 "../src/Dimensions.vala"
	scaled_rect.width = (gint) round (((gdouble) _tmp5_.width) * x_scale);
#line 205 "../src/Dimensions.vala"
	_tmp6_ = *rect;
#line 205 "../src/Dimensions.vala"
	scaled_rect.height = (gint) round (((gdouble) _tmp6_.height) * y_scale);
#line 207 "../src/Dimensions.vala"
	_tmp7_ = scaled_rect;
#line 207 "../src/Dimensions.vala"
	if (_tmp7_.width <= 0) {
#line 208 "../src/Dimensions.vala"
		scaled_rect.width = 1;
#line 930 "Dimensions.c"
	}
#line 210 "../src/Dimensions.vala"
	_tmp8_ = scaled_rect;
#line 210 "../src/Dimensions.vala"
	if (_tmp8_.height <= 0) {
#line 211 "../src/Dimensions.vala"
		scaled_rect.height = 1;
#line 938 "Dimensions.c"
	}
#line 213 "../src/Dimensions.vala"
	*result = scaled_rect;
#line 213 "../src/Dimensions.vala"
	return;
#line 944 "Dimensions.c"
}

void
dimensions_get_scaled_similar (Dimensions *self,
                               Dimensions* original,
                               Dimensions* scaled,
                               Dimensions* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scale = 0.0;
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
#line 217 "../src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 217 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 219 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 219 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 219 "../src/Dimensions.vala"
	x_scale = _tmp1_;
#line 219 "../src/Dimensions.vala"
	y_scale = _tmp2_;
#line 221 "../src/Dimensions.vala"
	scale = MIN (x_scale, y_scale);
#line 223 "../src/Dimensions.vala"
	dimensions_init (&_tmp3_, (gint) round (((gdouble) (*self).width) * scale), (gint) round (((gdouble) (*self).height) * scale));
#line 223 "../src/Dimensions.vala"
	dimensions_init (&_tmp4_, 1, 1);
#line 223 "../src/Dimensions.vala"
	dimensions_floor (&_tmp3_, &_tmp4_, &_tmp5_);
#line 223 "../src/Dimensions.vala"
	*result = _tmp5_;
#line 223 "../src/Dimensions.vala"
	return;
#line 986 "Dimensions.c"
}

void
dimensions_get_scaled_by_width (Dimensions *self,
                                gint scale,
                                Dimensions* result)
{
	gdouble ratio = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 228 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 230 "../src/Dimensions.vala"
	ratio = ((gdouble) scale) / ((gdouble) (*self).width);
#line 232 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, scale, (gint) round (((gdouble) (*self).height) * ratio));
#line 232 "../src/Dimensions.vala"
	dimensions_init (&_tmp1_, 1, 1);
#line 232 "../src/Dimensions.vala"
	dimensions_floor (&_tmp0_, &_tmp1_, &_tmp2_);
#line 232 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 232 "../src/Dimensions.vala"
	return;
#line 1012 "Dimensions.c"
}

void
dimensions_get_scaled_by_height (Dimensions *self,
                                 gint scale,
                                 Dimensions* result)
{
	gdouble ratio = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 236 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 238 "../src/Dimensions.vala"
	ratio = ((gdouble) scale) / ((gdouble) (*self).height);
#line 240 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, (gint) round (((gdouble) (*self).width) * ratio), scale);
#line 240 "../src/Dimensions.vala"
	dimensions_init (&_tmp1_, 1, 1);
#line 240 "../src/Dimensions.vala"
	dimensions_floor (&_tmp0_, &_tmp1_, &_tmp2_);
#line 240 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 240 "../src/Dimensions.vala"
	return;
#line 1038 "Dimensions.c"
}

void
dimensions_get_scaled_by_constraint (Dimensions *self,
                                     gint scale,
                                     ScaleConstraint constraint,
                                     Dimensions* result)
{
#line 244 "../src/Dimensions.vala"
	switch (constraint) {
#line 244 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 1051 "Dimensions.c"
		{
			Dimensions _tmp0_ = {0};
#line 246 "../src/Dimensions.vala"
			dimensions_init (&_tmp0_, (*self).width, (*self).height);
#line 246 "../src/Dimensions.vala"
			*result = _tmp0_;
#line 246 "../src/Dimensions.vala"
			return;
#line 1060 "Dimensions.c"
		}
#line 244 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 1064 "Dimensions.c"
		{
			Dimensions _tmp1_ = {0};
#line 249 "../src/Dimensions.vala"
			if ((*self).width >= (*self).height) {
#line 1069 "Dimensions.c"
				Dimensions _tmp2_ = {0};
#line 249 "../src/Dimensions.vala"
				dimensions_get_scaled_by_width (&(*self), scale, &_tmp2_);
#line 249 "../src/Dimensions.vala"
				_tmp1_ = _tmp2_;
#line 1075 "Dimensions.c"
			} else {
				Dimensions _tmp3_ = {0};
#line 249 "../src/Dimensions.vala"
				dimensions_get_scaled_by_height (&(*self), scale, &_tmp3_);
#line 249 "../src/Dimensions.vala"
				_tmp1_ = _tmp3_;
#line 1082 "Dimensions.c"
			}
#line 249 "../src/Dimensions.vala"
			*result = _tmp1_;
#line 249 "../src/Dimensions.vala"
			return;
#line 1088 "Dimensions.c"
		}
#line 244 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 1092 "Dimensions.c"
		{
			Dimensions _tmp4_ = {0};
#line 252 "../src/Dimensions.vala"
			dimensions_get_scaled_by_width (&(*self), scale, &_tmp4_);
#line 252 "../src/Dimensions.vala"
			*result = _tmp4_;
#line 252 "../src/Dimensions.vala"
			return;
#line 1101 "Dimensions.c"
		}
#line 244 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 1105 "Dimensions.c"
		{
			Dimensions _tmp5_ = {0};
#line 255 "../src/Dimensions.vala"
			dimensions_get_scaled_by_height (&(*self), scale, &_tmp5_);
#line 255 "../src/Dimensions.vala"
			*result = _tmp5_;
#line 255 "../src/Dimensions.vala"
			return;
#line 1114 "Dimensions.c"
		}
		default:
		{
			Dimensions _tmp6_ = {0};
#line 258 "../src/Dimensions.vala"
			g_critical ("Dimensions.vala:258: Bad constraint: %d; returning original", (gint) constraint);
#line 259 "../src/Dimensions.vala"
			dimensions_init (&_tmp6_, (*self).width, (*self).height);
#line 259 "../src/Dimensions.vala"
			*result = _tmp6_;
#line 259 "../src/Dimensions.vala"
			return;
#line 1127 "Dimensions.c"
		}
	}
}

Dimensions*
dimensions_dup (const Dimensions* self)
{
	Dimensions* dup;
#line 52 "../src/Dimensions.vala"
	dup = g_new0 (Dimensions, 1);
#line 52 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (Dimensions));
#line 52 "../src/Dimensions.vala"
	return dup;
#line 1142 "Dimensions.c"
}

void
dimensions_free (Dimensions* self)
{
#line 52 "../src/Dimensions.vala"
	g_free (self);
#line 1150 "Dimensions.c"
}

static GType
dimensions_get_type_once (void)
{
	GType dimensions_type_id;
	dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
	return dimensions_type_id;
}

GType
dimensions_get_type (void)
{
	static volatile gsize dimensions_type_id__once = 0;
	if (g_once_init_enter (&dimensions_type_id__once)) {
		GType dimensions_type_id;
		dimensions_type_id = dimensions_get_type_once ();
		g_once_init_leave (&dimensions_type_id__once, dimensions_type_id);
	}
	return dimensions_type_id__once;
}

static void
scaling_init (Scaling *self,
              ScaleConstraint constraint,
              gint scale,
              Dimensions* viewport,
              gboolean scale_up)
{
	Dimensions _tmp0_;
#line 272 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 272 "../src/Dimensions.vala"
	memset (self, 0, sizeof (Scaling));
#line 273 "../src/Dimensions.vala"
	(*self).constraint = constraint;
#line 274 "../src/Dimensions.vala"
	(*self).scale = scale;
#line 275 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 275 "../src/Dimensions.vala"
	(*self).viewport = _tmp0_;
#line 276 "../src/Dimensions.vala"
	(*self).scale_up = scale_up;
#line 1195 "Dimensions.c"
}

void
scaling_for_original (Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 280 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 280 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, &_tmp0_, FALSE);
#line 280 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 280 "../src/Dimensions.vala"
	return;
#line 1211 "Dimensions.c"
}

void
scaling_for_screen (GtkWindow* window,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 283 "../src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 284 "../src/Dimensions.vala"
	scaling_get_screen_dimensions (window, &_tmp0_);
#line 284 "../src/Dimensions.vala"
	scaling_for_viewport (&_tmp0_, scale_up, &_tmp1_);
#line 284 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 284 "../src/Dimensions.vala"
	return;
#line 1231 "Dimensions.c"
}

void
scaling_for_best_fit (gint pixels,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 288 "../src/Dimensions.vala"
	_vala_assert (pixels > 0, "pixels > 0");
#line 290 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 290 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, pixels, &_tmp0_, scale_up);
#line 290 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 290 "../src/Dimensions.vala"
	return;
#line 1251 "Dimensions.c"
}

void
scaling_for_viewport (Dimensions* viewport,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_;
	Scaling _tmp1_ = {0};
#line 293 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 294 "../src/Dimensions.vala"
	_vala_assert (dimensions_has_area (viewport), "viewport.has_area ()");
#line 296 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 296 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp0_, scale_up);
#line 296 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 296 "../src/Dimensions.vala"
	return;
#line 1273 "Dimensions.c"
}

void
scaling_for_widget (GtkWidget* widget,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions viewport = {0};
	Dimensions _tmp0_ = {0};
	gint scale_factor = 0;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	Dimensions _tmp4_;
	Dimensions _tmp7_;
	Scaling _tmp8_ = {0};
#line 299 "../src/Dimensions.vala"
	g_return_if_fail (widget != NULL);
#line 300 "../src/Dimensions.vala"
	dimensions_for_widget_allocation (widget, &_tmp0_);
#line 300 "../src/Dimensions.vala"
	viewport = _tmp0_;
#line 301 "../src/Dimensions.vala"
	_tmp1_ = gtk_widget_get_scale_factor (widget);
#line 301 "../src/Dimensions.vala"
	_tmp2_ = _tmp1_;
#line 301 "../src/Dimensions.vala"
	scale_factor = _tmp2_;
#line 311 "../src/Dimensions.vala"
	_tmp4_ = viewport;
#line 311 "../src/Dimensions.vala"
	if (_tmp4_.width <= (1 * scale_factor)) {
#line 311 "../src/Dimensions.vala"
		_tmp3_ = TRUE;
#line 1308 "Dimensions.c"
	} else {
		Dimensions _tmp5_;
#line 311 "../src/Dimensions.vala"
		_tmp5_ = viewport;
#line 311 "../src/Dimensions.vala"
		_tmp3_ = _tmp5_.height <= (1 * scale_factor);
#line 1315 "Dimensions.c"
	}
#line 311 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 1319 "Dimensions.c"
		Scaling _tmp6_ = {0};
#line 312 "../src/Dimensions.vala"
		scaling_for_original (&_tmp6_);
#line 312 "../src/Dimensions.vala"
		*result = _tmp6_;
#line 312 "../src/Dimensions.vala"
		return;
#line 1327 "Dimensions.c"
	}
#line 314 "../src/Dimensions.vala"
	_tmp7_ = viewport;
#line 314 "../src/Dimensions.vala"
	scaling_init (&_tmp8_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp7_, scale_up);
#line 314 "../src/Dimensions.vala"
	*result = _tmp8_;
#line 314 "../src/Dimensions.vala"
	return;
#line 1337 "Dimensions.c"
}

void
scaling_to_fill_viewport (Dimensions* viewport,
                          Scaling* result)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	Dimensions _tmp4_;
	Scaling _tmp5_ = {0};
#line 317 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 320 "../src/Dimensions.vala"
	_tmp1_ = *viewport;
#line 320 "../src/Dimensions.vala"
	if (_tmp1_.width <= 1) {
#line 320 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 1356 "Dimensions.c"
	} else {
		Dimensions _tmp2_;
#line 320 "../src/Dimensions.vala"
		_tmp2_ = *viewport;
#line 320 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_.height <= 1;
#line 1363 "Dimensions.c"
	}
#line 320 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 1367 "Dimensions.c"
		Scaling _tmp3_ = {0};
#line 321 "../src/Dimensions.vala"
		scaling_for_original (&_tmp3_);
#line 321 "../src/Dimensions.vala"
		*result = _tmp3_;
#line 321 "../src/Dimensions.vala"
		return;
#line 1375 "Dimensions.c"
	}
#line 323 "../src/Dimensions.vala"
	_tmp4_ = *viewport;
#line 323 "../src/Dimensions.vala"
	scaling_init (&_tmp5_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, &_tmp4_, TRUE);
#line 323 "../src/Dimensions.vala"
	*result = _tmp5_;
#line 323 "../src/Dimensions.vala"
	return;
#line 1385 "Dimensions.c"
}

void
scaling_to_fill_screen (GtkWindow* window,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 326 "../src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 327 "../src/Dimensions.vala"
	scaling_get_screen_dimensions (window, &_tmp0_);
#line 327 "../src/Dimensions.vala"
	scaling_to_fill_viewport (&_tmp0_, &_tmp1_);
#line 327 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 327 "../src/Dimensions.vala"
	return;
#line 1404 "Dimensions.c"
}

void
scaling_for_constraint (ScaleConstraint constraint,
                        gint scale,
                        gboolean scale_up,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 331 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 331 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, constraint, scale, &_tmp0_, scale_up);
#line 331 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 331 "../src/Dimensions.vala"
	return;
#line 1423 "Dimensions.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 335 "../src/Dimensions.vala"
	return self ? g_object_ref (self) : NULL;
#line 1431 "Dimensions.c"
}

void
scaling_get_screen_dimensions (GtkWindow* window,
                               Dimensions* result)
{
	GdkDisplay* display = NULL;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkMonitor* monitor = NULL;
	GdkWindow* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
	GdkRectangle geometry = {0};
	GdkRectangle _tmp6_ = {0};
	gint scale_factor = 0;
	gint _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	Dimensions _tmp11_ = {0};
#line 334 "../src/Dimensions.vala"
	g_return_if_fail (window != NULL);
#line 335 "../src/Dimensions.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) window);
#line 335 "../src/Dimensions.vala"
	_tmp1_ = gdk_window_get_display (_tmp0_);
#line 335 "../src/Dimensions.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 335 "../src/Dimensions.vala"
	display = _tmp2_;
#line 336 "../src/Dimensions.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) window);
#line 336 "../src/Dimensions.vala"
	_tmp4_ = gdk_display_get_monitor_at_window (display, _tmp3_);
#line 336 "../src/Dimensions.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 336 "../src/Dimensions.vala"
	monitor = _tmp5_;
#line 337 "../src/Dimensions.vala"
	gdk_monitor_get_geometry (monitor, &_tmp6_);
#line 337 "../src/Dimensions.vala"
	geometry = _tmp6_;
#line 339 "../src/Dimensions.vala"
	_tmp7_ = gtk_widget_get_scale_factor ((GtkWidget*) window);
#line 339 "../src/Dimensions.vala"
	_tmp8_ = _tmp7_;
#line 339 "../src/Dimensions.vala"
	scale_factor = _tmp8_;
#line 341 "../src/Dimensions.vala"
	_tmp9_ = geometry;
#line 341 "../src/Dimensions.vala"
	_tmp10_ = geometry;
#line 341 "../src/Dimensions.vala"
	dimensions_init (&_tmp11_, _tmp9_.width * scale_factor, _tmp10_.height * scale_factor);
#line 341 "../src/Dimensions.vala"
	*result = _tmp11_;
#line 341 "../src/Dimensions.vala"
	_g_object_unref0 (monitor);
#line 341 "../src/Dimensions.vala"
	_g_object_unref0 (display);
#line 341 "../src/Dimensions.vala"
	return;
#line 1496 "Dimensions.c"
}

static gint
scaling_scale_to_pixels (Scaling *self)
{
	gint _tmp0_ = 0;
	gint result;
#line 345 "../src/Dimensions.vala"
	if ((*self).scale >= 0) {
#line 345 "../src/Dimensions.vala"
		_tmp0_ = (*self).scale;
#line 1508 "Dimensions.c"
	} else {
#line 345 "../src/Dimensions.vala"
		_tmp0_ = 0;
#line 1512 "Dimensions.c"
	}
#line 345 "../src/Dimensions.vala"
	result = _tmp0_;
#line 345 "../src/Dimensions.vala"
	return result;
#line 1518 "Dimensions.c"
}

gboolean
scaling_is_unscaled (Scaling *self)
{
	gboolean result;
#line 349 "../src/Dimensions.vala"
	result = (*self).constraint == SCALE_CONSTRAINT_ORIGINAL;
#line 349 "../src/Dimensions.vala"
	return result;
#line 1529 "Dimensions.c"
}

gboolean
scaling_is_best_fit (Scaling *self,
                     Dimensions* original,
                     gint* pixels)
{
	gint _vala_pixels = 0;
	gboolean result;
#line 352 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 353 "../src/Dimensions.vala"
	_vala_pixels = 0;
#line 355 "../src/Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 356 "../src/Dimensions.vala"
		result = FALSE;
#line 356 "../src/Dimensions.vala"
		if (pixels) {
#line 356 "../src/Dimensions.vala"
			*pixels = _vala_pixels;
#line 1551 "Dimensions.c"
		}
#line 356 "../src/Dimensions.vala"
		return result;
#line 1555 "Dimensions.c"
	}
#line 358 "../src/Dimensions.vala"
	switch ((*self).constraint) {
#line 358 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 358 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1563 "Dimensions.c"
		{
#line 361 "../src/Dimensions.vala"
			result = FALSE;
#line 361 "../src/Dimensions.vala"
			if (pixels) {
#line 361 "../src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 1571 "Dimensions.c"
			}
#line 361 "../src/Dimensions.vala"
			return result;
#line 1575 "Dimensions.c"
		}
		default:
		{
#line 364 "../src/Dimensions.vala"
			_vala_pixels = scaling_scale_to_pixels (&(*self));
#line 365 "../src/Dimensions.vala"
			_vala_assert (_vala_pixels > 0, "pixels > 0");
#line 367 "../src/Dimensions.vala"
			result = TRUE;
#line 367 "../src/Dimensions.vala"
			if (pixels) {
#line 367 "../src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 1589 "Dimensions.c"
			}
#line 367 "../src/Dimensions.vala"
			return result;
#line 1593 "Dimensions.c"
		}
	}
}

gboolean
scaling_is_best_fit_dimensions (Scaling *self,
                                Dimensions* original,
                                Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result;
#line 371 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 372 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 374 "../src/Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 375 "../src/Dimensions.vala"
		result = FALSE;
#line 375 "../src/Dimensions.vala"
		if (scaled) {
#line 375 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1617 "Dimensions.c"
		}
#line 375 "../src/Dimensions.vala"
		return result;
#line 1621 "Dimensions.c"
	}
#line 377 "../src/Dimensions.vala"
	switch ((*self).constraint) {
#line 377 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 377 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1629 "Dimensions.c"
		{
#line 380 "../src/Dimensions.vala"
			result = FALSE;
#line 380 "../src/Dimensions.vala"
			if (scaled) {
#line 380 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1637 "Dimensions.c"
			}
#line 380 "../src/Dimensions.vala"
			return result;
#line 1641 "Dimensions.c"
		}
		default:
		{
			gint pixels = 0;
			Dimensions _tmp0_ = {0};
#line 383 "../src/Dimensions.vala"
			pixels = scaling_scale_to_pixels (&(*self));
#line 384 "../src/Dimensions.vala"
			_vala_assert (pixels > 0, "pixels > 0");
#line 386 "../src/Dimensions.vala"
			dimensions_get_scaled_by_constraint (original, pixels, (*self).constraint, &_tmp0_);
#line 386 "../src/Dimensions.vala"
			_vala_scaled = _tmp0_;
#line 388 "../src/Dimensions.vala"
			result = TRUE;
#line 388 "../src/Dimensions.vala"
			if (scaled) {
#line 388 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1661 "Dimensions.c"
			}
#line 388 "../src/Dimensions.vala"
			return result;
#line 1665 "Dimensions.c"
		}
	}
}

gboolean
scaling_is_for_viewport (Scaling *self,
                         Dimensions* original,
                         Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result;
#line 392 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 393 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 395 "../src/Dimensions.vala"
	if ((*self).scale != SCALING_NO_SCALE) {
#line 396 "../src/Dimensions.vala"
		result = FALSE;
#line 396 "../src/Dimensions.vala"
		if (scaled) {
#line 396 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1689 "Dimensions.c"
		}
#line 396 "../src/Dimensions.vala"
		return result;
#line 1693 "Dimensions.c"
	}
#line 398 "../src/Dimensions.vala"
	switch ((*self).constraint) {
#line 398 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 398 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1701 "Dimensions.c"
		{
#line 401 "../src/Dimensions.vala"
			result = FALSE;
#line 401 "../src/Dimensions.vala"
			if (scaled) {
#line 401 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1709 "Dimensions.c"
			}
#line 401 "../src/Dimensions.vala"
			return result;
#line 1713 "Dimensions.c"
		}
		default:
		{
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
#line 404 "../src/Dimensions.vala"
			_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area ()");
#line 406 "../src/Dimensions.vala"
			if (!(*self).scale_up) {
#line 1723 "Dimensions.c"
				Dimensions _tmp2_;
				Dimensions _tmp3_;
#line 406 "../src/Dimensions.vala"
				_tmp2_ = *original;
#line 406 "../src/Dimensions.vala"
				_tmp3_ = (*self).viewport;
#line 406 "../src/Dimensions.vala"
				_tmp1_ = _tmp2_.width < _tmp3_.width;
#line 1732 "Dimensions.c"
			} else {
#line 406 "../src/Dimensions.vala"
				_tmp1_ = FALSE;
#line 1736 "Dimensions.c"
			}
#line 406 "../src/Dimensions.vala"
			if (_tmp1_) {
#line 1740 "Dimensions.c"
				Dimensions _tmp4_;
				Dimensions _tmp5_;
#line 406 "../src/Dimensions.vala"
				_tmp4_ = *original;
#line 406 "../src/Dimensions.vala"
				_tmp5_ = (*self).viewport;
#line 406 "../src/Dimensions.vala"
				_tmp0_ = _tmp4_.height < _tmp5_.height;
#line 1749 "Dimensions.c"
			} else {
#line 406 "../src/Dimensions.vala"
				_tmp0_ = FALSE;
#line 1753 "Dimensions.c"
			}
#line 406 "../src/Dimensions.vala"
			if (_tmp0_) {
#line 1757 "Dimensions.c"
				Dimensions _tmp6_;
#line 407 "../src/Dimensions.vala"
				_tmp6_ = *original;
#line 407 "../src/Dimensions.vala"
				_vala_scaled = _tmp6_;
#line 1763 "Dimensions.c"
			} else {
				Dimensions _tmp7_;
				Dimensions _tmp8_ = {0};
#line 409 "../src/Dimensions.vala"
				_tmp7_ = (*self).viewport;
#line 409 "../src/Dimensions.vala"
				dimensions_get_scaled_proportional (original, &_tmp7_, &_tmp8_);
#line 409 "../src/Dimensions.vala"
				_vala_scaled = _tmp8_;
#line 1773 "Dimensions.c"
			}
#line 411 "../src/Dimensions.vala"
			result = TRUE;
#line 411 "../src/Dimensions.vala"
			if (scaled) {
#line 411 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1781 "Dimensions.c"
			}
#line 411 "../src/Dimensions.vala"
			return result;
#line 1785 "Dimensions.c"
		}
	}
}

gboolean
scaling_is_fill_viewport (Scaling *self,
                          Dimensions* original,
                          Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	Dimensions _tmp0_;
	Dimensions _tmp1_ = {0};
	gboolean result;
#line 415 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 416 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 418 "../src/Dimensions.vala"
	if ((*self).constraint != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 419 "../src/Dimensions.vala"
		result = FALSE;
#line 419 "../src/Dimensions.vala"
		if (scaled) {
#line 419 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1811 "Dimensions.c"
		}
#line 419 "../src/Dimensions.vala"
		return result;
#line 1815 "Dimensions.c"
	}
#line 421 "../src/Dimensions.vala"
	_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area ()");
#line 422 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport;
#line 422 "../src/Dimensions.vala"
	dimensions_get_scaled_to_fill_viewport (original, &_tmp0_, &_tmp1_);
#line 422 "../src/Dimensions.vala"
	_vala_scaled = _tmp1_;
#line 424 "../src/Dimensions.vala"
	result = TRUE;
#line 424 "../src/Dimensions.vala"
	if (scaled) {
#line 424 "../src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 1831 "Dimensions.c"
	}
#line 424 "../src/Dimensions.vala"
	return result;
#line 1835 "Dimensions.c"
}

void
scaling_get_scaled_dimensions (Scaling *self,
                               Dimensions* original,
                               Dimensions* result)
{
	Dimensions scaled = {0};
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp5_ = {0};
	gboolean _tmp6_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp7_;
	Dimensions _tmp8_ = {0};
	gboolean _tmp9_;
#line 427 "../src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 428 "../src/Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 1858 "Dimensions.c"
		Dimensions _tmp0_;
#line 429 "../src/Dimensions.vala"
		_tmp0_ = *original;
#line 429 "../src/Dimensions.vala"
		*result = _tmp0_;
#line 429 "../src/Dimensions.vala"
		return;
#line 1866 "Dimensions.c"
	}
#line 432 "../src/Dimensions.vala"
	_tmp1_ = *original;
#line 432 "../src/Dimensions.vala"
	_tmp3_ = scaling_is_fill_viewport (&(*self), &_tmp1_, &_tmp2_);
#line 432 "../src/Dimensions.vala"
	scaled = _tmp2_;
#line 432 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 433 "../src/Dimensions.vala"
		*result = scaled;
#line 433 "../src/Dimensions.vala"
		return;
#line 1880 "Dimensions.c"
	}
#line 435 "../src/Dimensions.vala"
	_tmp4_ = *original;
#line 435 "../src/Dimensions.vala"
	_tmp6_ = scaling_is_best_fit_dimensions (&(*self), &_tmp4_, &_tmp5_);
#line 435 "../src/Dimensions.vala"
	scaled = _tmp5_;
#line 435 "../src/Dimensions.vala"
	if (_tmp6_) {
#line 436 "../src/Dimensions.vala"
		*result = scaled;
#line 436 "../src/Dimensions.vala"
		return;
#line 1894 "Dimensions.c"
	}
#line 438 "../src/Dimensions.vala"
	_tmp7_ = *original;
#line 438 "../src/Dimensions.vala"
	_tmp9_ = scaling_is_for_viewport (&(*self), &_tmp7_, &_tmp8_);
#line 438 "../src/Dimensions.vala"
	scaled = _tmp8_;
#line 438 "../src/Dimensions.vala"
	is_viewport = _tmp9_;
#line 439 "../src/Dimensions.vala"
	_vala_assert (is_viewport, "is_viewport");
#line 441 "../src/Dimensions.vala"
	*result = scaled;
#line 441 "../src/Dimensions.vala"
	return;
#line 1910 "Dimensions.c"
}

GdkPixbuf*
scaling_perform_on_pixbuf (Scaling *self,
                           GdkPixbuf* pixbuf,
                           GdkInterpType interp,
                           gboolean scale_up)
{
	Dimensions pixbuf_dim = {0};
	Dimensions _tmp1_ = {0};
	gint pixels = 0;
	Dimensions _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	Dimensions scaled = {0};
	Dimensions _tmp6_;
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp11_;
	Dimensions _tmp12_ = {0};
	gboolean _tmp13_;
	Dimensions _tmp14_;
	GdkPixbuf* _tmp15_;
	GdkPixbuf* result;
#line 444 "../src/Dimensions.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 445 "../src/Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 1940 "Dimensions.c"
		GdkPixbuf* _tmp0_;
#line 446 "../src/Dimensions.vala"
		_tmp0_ = _g_object_ref0 (pixbuf);
#line 446 "../src/Dimensions.vala"
		result = _tmp0_;
#line 446 "../src/Dimensions.vala"
		return result;
#line 1948 "Dimensions.c"
	}
#line 448 "../src/Dimensions.vala"
	dimensions_for_pixbuf (pixbuf, &_tmp1_);
#line 448 "../src/Dimensions.vala"
	pixbuf_dim = _tmp1_;
#line 451 "../src/Dimensions.vala"
	_tmp2_ = pixbuf_dim;
#line 451 "../src/Dimensions.vala"
	_tmp4_ = scaling_is_best_fit (&(*self), &_tmp2_, &_tmp3_);
#line 451 "../src/Dimensions.vala"
	pixels = _tmp3_;
#line 451 "../src/Dimensions.vala"
	if (_tmp4_) {
#line 1962 "Dimensions.c"
		GdkPixbuf* _tmp5_;
#line 452 "../src/Dimensions.vala"
		_tmp5_ = scale_pixbuf (pixbuf, pixels, interp, scale_up);
#line 452 "../src/Dimensions.vala"
		result = _tmp5_;
#line 452 "../src/Dimensions.vala"
		return result;
#line 1970 "Dimensions.c"
	}
#line 455 "../src/Dimensions.vala"
	_tmp6_ = pixbuf_dim;
#line 455 "../src/Dimensions.vala"
	_tmp8_ = scaling_is_fill_viewport (&(*self), &_tmp6_, &_tmp7_);
#line 455 "../src/Dimensions.vala"
	scaled = _tmp7_;
#line 455 "../src/Dimensions.vala"
	if (_tmp8_) {
#line 1980 "Dimensions.c"
		Dimensions _tmp9_;
		GdkPixbuf* _tmp10_;
#line 456 "../src/Dimensions.vala"
		_tmp9_ = scaled;
#line 456 "../src/Dimensions.vala"
		_tmp10_ = resize_pixbuf (pixbuf, &_tmp9_, interp);
#line 456 "../src/Dimensions.vala"
		result = _tmp10_;
#line 456 "../src/Dimensions.vala"
		return result;
#line 1991 "Dimensions.c"
	}
#line 458 "../src/Dimensions.vala"
	_tmp11_ = pixbuf_dim;
#line 458 "../src/Dimensions.vala"
	_tmp13_ = scaling_is_for_viewport (&(*self), &_tmp11_, &_tmp12_);
#line 458 "../src/Dimensions.vala"
	scaled = _tmp12_;
#line 458 "../src/Dimensions.vala"
	is_viewport = _tmp13_;
#line 459 "../src/Dimensions.vala"
	_vala_assert (is_viewport, "is_viewport");
#line 461 "../src/Dimensions.vala"
	_tmp14_ = scaled;
#line 461 "../src/Dimensions.vala"
	_tmp15_ = resize_pixbuf (pixbuf, &_tmp14_, interp);
#line 461 "../src/Dimensions.vala"
	result = _tmp15_;
#line 461 "../src/Dimensions.vala"
	return result;
#line 2011 "Dimensions.c"
}

gchar*
scaling_to_string (Scaling *self)
{
	gchar* result;
#line 465 "../src/Dimensions.vala"
	if ((*self).constraint == SCALE_CONSTRAINT_ORIGINAL) {
#line 2020 "Dimensions.c"
		gchar* _tmp0_;
#line 466 "../src/Dimensions.vala"
		_tmp0_ = g_strdup ("scaling: UNSCALED");
#line 466 "../src/Dimensions.vala"
		result = _tmp0_;
#line 466 "../src/Dimensions.vala"
		return result;
#line 2028 "Dimensions.c"
	} else {
#line 467 "../src/Dimensions.vala"
		if ((*self).constraint == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 2032 "Dimensions.c"
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 468 "../src/Dimensions.vala"
			_tmp1_ = dimensions_to_string (&(*self).viewport);
#line 468 "../src/Dimensions.vala"
			_tmp2_ = _tmp1_;
#line 468 "../src/Dimensions.vala"
			_tmp3_ = g_strdup_printf ("scaling: fill viewport %s", _tmp2_);
#line 468 "../src/Dimensions.vala"
			_tmp4_ = _tmp3_;
#line 468 "../src/Dimensions.vala"
			_g_free0 (_tmp2_);
#line 468 "../src/Dimensions.vala"
			result = _tmp4_;
#line 468 "../src/Dimensions.vala"
			return result;
#line 2051 "Dimensions.c"
		} else {
#line 469 "../src/Dimensions.vala"
			if ((*self).scale != SCALING_NO_SCALE) {
#line 2055 "Dimensions.c"
				const gchar* _tmp5_ = NULL;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 471 "../src/Dimensions.vala"
				if ((*self).scale_up) {
#line 471 "../src/Dimensions.vala"
					_tmp5_ = "scaled up";
#line 2065 "Dimensions.c"
				} else {
#line 471 "../src/Dimensions.vala"
					_tmp5_ = "not scaled up";
#line 2069 "Dimensions.c"
				}
#line 470 "../src/Dimensions.vala"
				_tmp6_ = scale_constraint_to_string ((*self).constraint);
#line 470 "../src/Dimensions.vala"
				_tmp7_ = _tmp6_;
#line 470 "../src/Dimensions.vala"
				_tmp8_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp7_, scaling_scale_to_pixels (&(*self)), _tmp5_);
#line 470 "../src/Dimensions.vala"
				_tmp9_ = _tmp8_;
#line 470 "../src/Dimensions.vala"
				_g_free0 (_tmp7_);
#line 470 "../src/Dimensions.vala"
				result = _tmp9_;
#line 470 "../src/Dimensions.vala"
				return result;
#line 2085 "Dimensions.c"
			} else {
				const gchar* _tmp10_ = NULL;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 474 "../src/Dimensions.vala"
				if ((*self).scale_up) {
#line 474 "../src/Dimensions.vala"
					_tmp10_ = "scaled up";
#line 2096 "Dimensions.c"
				} else {
#line 474 "../src/Dimensions.vala"
					_tmp10_ = "not scaled up";
#line 2100 "Dimensions.c"
				}
#line 473 "../src/Dimensions.vala"
				_tmp11_ = dimensions_to_string (&(*self).viewport);
#line 473 "../src/Dimensions.vala"
				_tmp12_ = _tmp11_;
#line 473 "../src/Dimensions.vala"
				_tmp13_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp12_, _tmp10_);
#line 473 "../src/Dimensions.vala"
				_tmp14_ = _tmp13_;
#line 473 "../src/Dimensions.vala"
				_g_free0 (_tmp12_);
#line 473 "../src/Dimensions.vala"
				result = _tmp14_;
#line 473 "../src/Dimensions.vala"
				return result;
#line 2116 "Dimensions.c"
			}
		}
	}
}

gboolean
scaling_equals (Scaling *self,
                Scaling* scaling)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Scaling _tmp2_;
	gboolean result;
#line 477 "../src/Dimensions.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 478 "../src/Dimensions.vala"
	_tmp2_ = *scaling;
#line 478 "../src/Dimensions.vala"
	if ((*self).constraint == _tmp2_.constraint) {
#line 2136 "Dimensions.c"
		Scaling _tmp3_;
#line 478 "../src/Dimensions.vala"
		_tmp3_ = *scaling;
#line 478 "../src/Dimensions.vala"
		_tmp1_ = (*self).scale == _tmp3_.scale;
#line 2142 "Dimensions.c"
	} else {
#line 478 "../src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 2146 "Dimensions.c"
	}
#line 478 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 2150 "Dimensions.c"
		Scaling _tmp4_;
		Dimensions _tmp5_;
#line 479 "../src/Dimensions.vala"
		_tmp4_ = *scaling;
#line 479 "../src/Dimensions.vala"
		_tmp5_ = _tmp4_.viewport;
#line 479 "../src/Dimensions.vala"
		_tmp0_ = dimensions_equals (&(*self).viewport, &_tmp5_);
#line 2159 "Dimensions.c"
	} else {
#line 478 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 2163 "Dimensions.c"
	}
#line 478 "../src/Dimensions.vala"
	result = _tmp0_;
#line 478 "../src/Dimensions.vala"
	return result;
#line 2169 "Dimensions.c"
}

Scaling*
scaling_dup (const Scaling* self)
{
	Scaling* dup;
#line 264 "../src/Dimensions.vala"
	dup = g_new0 (Scaling, 1);
#line 264 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (Scaling));
#line 264 "../src/Dimensions.vala"
	return dup;
#line 2182 "Dimensions.c"
}

void
scaling_free (Scaling* self)
{
#line 264 "../src/Dimensions.vala"
	g_free (self);
#line 2190 "Dimensions.c"
}

static GType
scaling_get_type_once (void)
{
	GType scaling_type_id;
	scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
	return scaling_type_id;
}

GType
scaling_get_type (void)
{
	static volatile gsize scaling_type_id__once = 0;
	if (g_once_init_enter (&scaling_type_id__once)) {
		GType scaling_type_id;
		scaling_type_id = scaling_get_type_once ();
		g_once_init_leave (&scaling_type_id__once, scaling_type_id);
	}
	return scaling_type_id__once;
}

void
zoom_state_init (ZoomState *self,
                 Dimensions* content_dimensions,
                 Dimensions* viewport_dimensions,
                 gdouble slider_val,
                 GdkPoint* viewport_center)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 492 "../src/Dimensions.vala"
	g_return_if_fail (content_dimensions != NULL);
#line 492 "../src/Dimensions.vala"
	g_return_if_fail (viewport_dimensions != NULL);
#line 492 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 494 "../src/Dimensions.vala"
	_tmp0_ = *content_dimensions;
#line 494 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp0_;
#line 495 "../src/Dimensions.vala"
	_tmp1_ = *viewport_dimensions;
#line 495 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp1_;
#line 496 "../src/Dimensions.vala"
	(*self).interpolation_factor = slider_val;
#line 498 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 500 "../src/Dimensions.vala"
	if (viewport_center == NULL) {
#line 500 "../src/Dimensions.vala"
		_tmp3_ = TRUE;
#line 2246 "Dimensions.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 500 "../src/Dimensions.vala"
		if ((*viewport_center).x == 0) {
#line 500 "../src/Dimensions.vala"
			_tmp4_ = (*viewport_center).y == 0;
#line 2253 "Dimensions.c"
		} else {
#line 500 "../src/Dimensions.vala"
			_tmp4_ = FALSE;
#line 2257 "Dimensions.c"
		}
#line 500 "../src/Dimensions.vala"
		_tmp3_ = _tmp4_;
#line 2261 "Dimensions.c"
	}
#line 500 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 500 "../src/Dimensions.vala"
		_tmp2_ = TRUE;
#line 2267 "Dimensions.c"
	} else {
#line 501 "../src/Dimensions.vala"
		_tmp2_ = slider_val == 0.0;
#line 2271 "Dimensions.c"
	}
#line 500 "../src/Dimensions.vala"
	if (_tmp2_) {
#line 502 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2277 "Dimensions.c"
	} else {
#line 504 "../src/Dimensions.vala"
		(*self).viewport_center = *viewport_center;
#line 505 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2283 "Dimensions.c"
	}
}

void
zoom_state_init_rescale (ZoomState *self,
                         ZoomState* existing,
                         gdouble new_slider_val)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
#line 509 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 509 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 510 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 510 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 510 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 511 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 511 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 511 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 512 "../src/Dimensions.vala"
	(*self).interpolation_factor = new_slider_val;
#line 514 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 516 "../src/Dimensions.vala"
	if (new_slider_val == 0.0) {
#line 517 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2320 "Dimensions.c"
	} else {
		ZoomState _tmp4_;
		GdkPoint _tmp5_;
		ZoomState _tmp6_;
		ZoomState _tmp7_;
		GdkPoint _tmp8_;
		ZoomState _tmp9_;
#line 519 "../src/Dimensions.vala"
		_tmp4_ = *existing;
#line 519 "../src/Dimensions.vala"
		_tmp5_ = _tmp4_.viewport_center;
#line 519 "../src/Dimensions.vala"
		_tmp6_ = *existing;
#line 519 "../src/Dimensions.vala"
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * (_tmp5_.x / _tmp6_.zoom_factor));
#line 521 "../src/Dimensions.vala"
		_tmp7_ = *existing;
#line 521 "../src/Dimensions.vala"
		_tmp8_ = _tmp7_.viewport_center;
#line 521 "../src/Dimensions.vala"
		_tmp9_ = *existing;
#line 521 "../src/Dimensions.vala"
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * (_tmp8_.y / _tmp9_.zoom_factor));
#line 523 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2346 "Dimensions.c"
	}
}

void
zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                       ZoomState* existing)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	ZoomState _tmp5_;
	ZoomState _tmp6_;
#line 527 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 527 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 528 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 528 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 528 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 529 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 529 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 529 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 530 "../src/Dimensions.vala"
	_tmp4_ = *existing;
#line 530 "../src/Dimensions.vala"
	_tmp5_ = *existing;
#line 530 "../src/Dimensions.vala"
	_tmp6_ = *existing;
#line 530 "../src/Dimensions.vala"
	(*self).interpolation_factor = log (1.0 / _tmp4_.min_factor) / log (_tmp5_.max_factor / _tmp6_.min_factor);
#line 533 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 535 "../src/Dimensions.vala"
	if ((*self).interpolation_factor == 0.0) {
#line 536 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2391 "Dimensions.c"
	} else {
		ZoomState _tmp7_;
		GdkPoint _tmp8_;
		ZoomState _tmp9_;
		ZoomState _tmp10_;
		GdkPoint _tmp11_;
		ZoomState _tmp12_;
#line 538 "../src/Dimensions.vala"
		_tmp7_ = *existing;
#line 538 "../src/Dimensions.vala"
		_tmp8_ = _tmp7_.viewport_center;
#line 538 "../src/Dimensions.vala"
		_tmp9_ = *existing;
#line 538 "../src/Dimensions.vala"
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * (_tmp8_.x / _tmp9_.zoom_factor));
#line 540 "../src/Dimensions.vala"
		_tmp10_ = *existing;
#line 540 "../src/Dimensions.vala"
		_tmp11_ = _tmp10_.viewport_center;
#line 540 "../src/Dimensions.vala"
		_tmp12_ = *existing;
#line 540 "../src/Dimensions.vala"
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * (_tmp11_.y / _tmp12_.zoom_factor));
#line 542 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2417 "Dimensions.c"
	}
}

void
zoom_state_init_pan (ZoomState *self,
                     ZoomState* existing,
                     GdkPoint* new_viewport_center)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	GdkPoint _tmp5_;
#line 546 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 546 "../src/Dimensions.vala"
	g_return_if_fail (new_viewport_center != NULL);
#line 546 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 547 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 547 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 547 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 548 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 548 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 548 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 549 "../src/Dimensions.vala"
	_tmp4_ = *existing;
#line 549 "../src/Dimensions.vala"
	(*self).interpolation_factor = _tmp4_.interpolation_factor;
#line 551 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 553 "../src/Dimensions.vala"
	_tmp5_ = *new_viewport_center;
#line 553 "../src/Dimensions.vala"
	(*self).viewport_center = _tmp5_;
#line 555 "../src/Dimensions.vala"
	zoom_state_clamp_viewport_center (&(*self));
#line 2462 "Dimensions.c"
}

static void
zoom_state_clamp_viewport_center (ZoomState *self)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkPoint _tmp0_;
	Dimensions _tmp1_;
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp5_;
#line 559 "../src/Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 560 "../src/Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 562 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 562 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport_dimensions;
#line 562 "../src/Dimensions.vala"
	_tmp2_ = (*self).viewport_dimensions;
#line 562 "../src/Dimensions.vala"
	(*self).viewport_center.x = CLAMP (_tmp0_.x, _tmp1_.width / 2, (zoomed_width - (_tmp2_.width / 2)) - 1);
#line 564 "../src/Dimensions.vala"
	_tmp3_ = (*self).viewport_center;
#line 564 "../src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 564 "../src/Dimensions.vala"
	_tmp5_ = (*self).viewport_dimensions;
#line 564 "../src/Dimensions.vala"
	(*self).viewport_center.y = CLAMP (_tmp3_.y, _tmp4_.height / 2, (zoomed_height - (_tmp5_.height / 2)) - 1);
#line 2496 "Dimensions.c"
}

static void
zoom_state_center_viewport (ZoomState *self)
{
#line 569 "../src/Dimensions.vala"
	(*self).viewport_center.x = zoom_state_get_zoomed_width (&(*self)) / 2;
#line 570 "../src/Dimensions.vala"
	(*self).viewport_center.y = zoom_state_get_zoomed_height (&(*self)) / 2;
#line 2506 "Dimensions.c"
}

static void
zoom_state_compute_zoom_factors (ZoomState *self)
{
	gdouble viewport_to_content_x = 0.0;
	gdouble viewport_to_content_y = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 574 "../src/Dimensions.vala"
	(*self).max_factor = 10.0;
#line 578 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 578 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self).content_dimensions, &_tmp0_, &_tmp1_, &_tmp2_);
#line 578 "../src/Dimensions.vala"
	viewport_to_content_x = _tmp1_;
#line 578 "../src/Dimensions.vala"
	viewport_to_content_y = _tmp2_;
#line 580 "../src/Dimensions.vala"
	(*self).min_factor = MIN (viewport_to_content_x, viewport_to_content_y);
#line 581 "../src/Dimensions.vala"
	if ((*self).min_factor > 1.0) {
#line 582 "../src/Dimensions.vala"
		(*self).min_factor = 1.0;
#line 2533 "Dimensions.c"
	}
#line 584 "../src/Dimensions.vala"
	(*self).zoom_factor = (*self).min_factor * pow ((*self).max_factor / (*self).min_factor, (*self).interpolation_factor);
#line 2537 "Dimensions.c"
}

gdouble
zoom_state_get_interpolation_factor (ZoomState *self)
{
	gdouble result;
#line 588 "../src/Dimensions.vala"
	result = (*self).interpolation_factor;
#line 588 "../src/Dimensions.vala"
	return result;
#line 2548 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                              GdkRectangle* result)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkRectangle _result_ = {0};
	Dimensions _tmp0_;
	GdkRectangle _tmp4_;
	Dimensions _tmp5_;
	GdkRectangle _tmp9_;
	gint right = 0;
	GdkRectangle _tmp10_;
	Dimensions _tmp11_;
	GdkRectangle _tmp12_;
	gint bottom = 0;
	GdkRectangle _tmp13_;
	Dimensions _tmp14_;
	GdkRectangle _tmp15_;
	GdkRectangle _tmp16_;
	GdkRectangle _tmp17_;
#line 593 "../src/Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 594 "../src/Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 596 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 598 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 598 "../src/Dimensions.vala"
	if (_tmp0_.width < zoomed_width) {
#line 2582 "Dimensions.c"
		GdkPoint _tmp1_;
		Dimensions _tmp2_;
#line 599 "../src/Dimensions.vala"
		_tmp1_ = (*self).viewport_center;
#line 599 "../src/Dimensions.vala"
		_tmp2_ = (*self).viewport_dimensions;
#line 599 "../src/Dimensions.vala"
		_result_.x = _tmp1_.x - (_tmp2_.width / 2);
#line 2591 "Dimensions.c"
	} else {
		Dimensions _tmp3_;
#line 601 "../src/Dimensions.vala"
		_tmp3_ = (*self).viewport_dimensions;
#line 601 "../src/Dimensions.vala"
		_result_.x = (zoomed_width - _tmp3_.width) / 2;
#line 2598 "Dimensions.c"
	}
#line 603 "../src/Dimensions.vala"
	_tmp4_ = _result_;
#line 603 "../src/Dimensions.vala"
	if (_tmp4_.x < 0) {
#line 604 "../src/Dimensions.vala"
		_result_.x = 0;
#line 2606 "Dimensions.c"
	}
#line 606 "../src/Dimensions.vala"
	_tmp5_ = (*self).viewport_dimensions;
#line 606 "../src/Dimensions.vala"
	if (_tmp5_.height < zoomed_height) {
#line 2612 "Dimensions.c"
		GdkPoint _tmp6_;
		Dimensions _tmp7_;
#line 607 "../src/Dimensions.vala"
		_tmp6_ = (*self).viewport_center;
#line 607 "../src/Dimensions.vala"
		_tmp7_ = (*self).viewport_dimensions;
#line 607 "../src/Dimensions.vala"
		_result_.y = _tmp6_.y - (_tmp7_.height / 2);
#line 2621 "Dimensions.c"
	} else {
		Dimensions _tmp8_;
#line 609 "../src/Dimensions.vala"
		_tmp8_ = (*self).viewport_dimensions;
#line 609 "../src/Dimensions.vala"
		_result_.y = (zoomed_height - _tmp8_.height) / 2;
#line 2628 "Dimensions.c"
	}
#line 611 "../src/Dimensions.vala"
	_tmp9_ = _result_;
#line 611 "../src/Dimensions.vala"
	if (_tmp9_.y < 0) {
#line 612 "../src/Dimensions.vala"
		_result_.y = 0;
#line 2636 "Dimensions.c"
	}
#line 614 "../src/Dimensions.vala"
	_tmp10_ = _result_;
#line 614 "../src/Dimensions.vala"
	_tmp11_ = (*self).viewport_dimensions;
#line 614 "../src/Dimensions.vala"
	right = _tmp10_.x + _tmp11_.width;
#line 615 "../src/Dimensions.vala"
	if (right > zoomed_width) {
#line 616 "../src/Dimensions.vala"
		right = zoomed_width;
#line 2648 "Dimensions.c"
	}
#line 617 "../src/Dimensions.vala"
	_tmp12_ = _result_;
#line 617 "../src/Dimensions.vala"
	_result_.width = right - _tmp12_.x;
#line 619 "../src/Dimensions.vala"
	_tmp13_ = _result_;
#line 619 "../src/Dimensions.vala"
	_tmp14_ = (*self).viewport_dimensions;
#line 619 "../src/Dimensions.vala"
	bottom = _tmp13_.y + _tmp14_.height;
#line 620 "../src/Dimensions.vala"
	if (bottom > zoomed_height) {
#line 621 "../src/Dimensions.vala"
		bottom = zoomed_height;
#line 2664 "Dimensions.c"
	}
#line 622 "../src/Dimensions.vala"
	_tmp15_ = _result_;
#line 622 "../src/Dimensions.vala"
	_result_.height = bottom - _tmp15_.y;
#line 624 "../src/Dimensions.vala"
	_tmp16_ = _result_;
#line 624 "../src/Dimensions.vala"
	_result_.width = CLAMP (_tmp16_.width, 1, G_MAXINT);
#line 625 "../src/Dimensions.vala"
	_tmp17_ = _result_;
#line 625 "../src/Dimensions.vala"
	_result_.height = CLAMP (_tmp17_.height, 1, G_MAXINT);
#line 627 "../src/Dimensions.vala"
	*result = _result_;
#line 627 "../src/Dimensions.vala"
	return;
#line 2682 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                             GdkRectangle* result)
{
	GdkRectangle wrt_content = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _result_ = {0};
	Dimensions _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	Dimensions _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
#line 633 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_);
#line 633 "../src/Dimensions.vala"
	wrt_content = _tmp0_;
#line 635 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 636 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport_dimensions;
#line 636 "../src/Dimensions.vala"
	_tmp2_ = wrt_content;
#line 636 "../src/Dimensions.vala"
	_result_.x = (_tmp1_.width / 2) - (_tmp2_.width / 2);
#line 637 "../src/Dimensions.vala"
	_tmp3_ = _result_;
#line 637 "../src/Dimensions.vala"
	if (_tmp3_.x < 0) {
#line 638 "../src/Dimensions.vala"
		_result_.x = 0;
#line 2718 "Dimensions.c"
	}
#line 639 "../src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 639 "../src/Dimensions.vala"
	_tmp5_ = wrt_content;
#line 639 "../src/Dimensions.vala"
	_result_.y = (_tmp4_.height / 2) - (_tmp5_.height / 2);
#line 640 "../src/Dimensions.vala"
	_tmp6_ = _result_;
#line 640 "../src/Dimensions.vala"
	if (_tmp6_.y < 0) {
#line 641 "../src/Dimensions.vala"
		_result_.y = 0;
#line 2732 "Dimensions.c"
	}
#line 642 "../src/Dimensions.vala"
	_tmp7_ = wrt_content;
#line 642 "../src/Dimensions.vala"
	_result_.width = _tmp7_.width;
#line 643 "../src/Dimensions.vala"
	_tmp8_ = wrt_content;
#line 643 "../src/Dimensions.vala"
	_result_.height = _tmp8_.height;
#line 645 "../src/Dimensions.vala"
	*result = _result_;
#line 645 "../src/Dimensions.vala"
	return;
#line 2746 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                             GdkPixbuf* for_pixbuf,
                                             GdkRectangle* result)
{
	gdouble zoomed_width = 0.0;
	gdouble zoomed_height = 0.0;
	gdouble horiz_scale = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble vert_scale = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble scale = 0.0;
	GdkRectangle viewing_rectangle = {0};
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _result_ = {0};
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint right = 0;
	GdkRectangle _tmp13_;
	GdkRectangle _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint bottom = 0;
	GdkRectangle _tmp17_;
	GdkRectangle _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GdkRectangle _tmp21_;
	GdkRectangle _tmp22_;
#line 649 "../src/Dimensions.vala"
	g_return_if_fail (for_pixbuf != NULL);
#line 650 "../src/Dimensions.vala"
	zoomed_width = (gdouble) zoom_state_get_zoomed_width (&(*self));
#line 651 "../src/Dimensions.vala"
	zoomed_height = (gdouble) zoom_state_get_zoomed_height (&(*self));
#line 653 "../src/Dimensions.vala"
	_tmp0_ = gdk_pixbuf_get_width (for_pixbuf);
#line 653 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_;
#line 653 "../src/Dimensions.vala"
	horiz_scale = _tmp1_ / zoomed_width;
#line 654 "../src/Dimensions.vala"
	_tmp2_ = gdk_pixbuf_get_height (for_pixbuf);
#line 654 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_;
#line 654 "../src/Dimensions.vala"
	vert_scale = _tmp3_ / zoomed_height;
#line 655 "../src/Dimensions.vala"
	scale = (horiz_scale + vert_scale) / 2.0;
#line 657 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp4_);
#line 657 "../src/Dimensions.vala"
	viewing_rectangle = _tmp4_;
#line 659 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 660 "../src/Dimensions.vala"
	_tmp5_ = viewing_rectangle;
#line 660 "../src/Dimensions.vala"
	_result_.x = (gint) (_tmp5_.x * scale);
#line 661 "../src/Dimensions.vala"
	_tmp6_ = _result_;
#line 661 "../src/Dimensions.vala"
	_tmp7_ = gdk_pixbuf_get_width (for_pixbuf);
#line 661 "../src/Dimensions.vala"
	_tmp8_ = _tmp7_;
#line 661 "../src/Dimensions.vala"
	_result_.x = CLAMP (_tmp6_.x, 0, _tmp8_);
#line 662 "../src/Dimensions.vala"
	_tmp9_ = viewing_rectangle;
#line 662 "../src/Dimensions.vala"
	_result_.y = (gint) (_tmp9_.y * scale);
#line 663 "../src/Dimensions.vala"
	_tmp10_ = _result_;
#line 663 "../src/Dimensions.vala"
	_tmp11_ = gdk_pixbuf_get_height (for_pixbuf);
#line 663 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_;
#line 663 "../src/Dimensions.vala"
	_result_.y = CLAMP (_tmp10_.y, 0, _tmp12_);
#line 664 "../src/Dimensions.vala"
	_tmp13_ = viewing_rectangle;
#line 664 "../src/Dimensions.vala"
	_tmp14_ = viewing_rectangle;
#line 664 "../src/Dimensions.vala"
	right = (gint) ((_tmp13_.x + _tmp14_.width) * scale);
#line 665 "../src/Dimensions.vala"
	_tmp15_ = gdk_pixbuf_get_width (for_pixbuf);
#line 665 "../src/Dimensions.vala"
	_tmp16_ = _tmp15_;
#line 665 "../src/Dimensions.vala"
	right = CLAMP (right, 0, _tmp16_);
#line 666 "../src/Dimensions.vala"
	_tmp17_ = viewing_rectangle;
#line 666 "../src/Dimensions.vala"
	_tmp18_ = viewing_rectangle;
#line 666 "../src/Dimensions.vala"
	bottom = (gint) ((_tmp17_.y + _tmp18_.height) * scale);
#line 667 "../src/Dimensions.vala"
	_tmp19_ = gdk_pixbuf_get_height (for_pixbuf);
#line 667 "../src/Dimensions.vala"
	_tmp20_ = _tmp19_;
#line 667 "../src/Dimensions.vala"
	bottom = CLAMP (bottom, 0, _tmp20_);
#line 668 "../src/Dimensions.vala"
	_tmp21_ = _result_;
#line 668 "../src/Dimensions.vala"
	_result_.width = right - _tmp21_.x;
#line 669 "../src/Dimensions.vala"
	_tmp22_ = _result_;
#line 669 "../src/Dimensions.vala"
	_result_.height = bottom - _tmp22_.y;
#line 671 "../src/Dimensions.vala"
	*result = _result_;
#line 671 "../src/Dimensions.vala"
	return;
#line 2872 "Dimensions.c"
}

gdouble
zoom_state_get_zoom_factor (ZoomState *self)
{
	gdouble result;
#line 676 "../src/Dimensions.vala"
	result = (*self).zoom_factor;
#line 676 "../src/Dimensions.vala"
	return result;
#line 2883 "Dimensions.c"
}

gint
zoom_state_get_zoomed_width (ZoomState *self)
{
	Dimensions _tmp0_;
	gint result;
#line 680 "../src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 680 "../src/Dimensions.vala"
	result = (gint) (_tmp0_.width * (*self).zoom_factor);
#line 680 "../src/Dimensions.vala"
	return result;
#line 2897 "Dimensions.c"
}

gint
zoom_state_get_zoomed_height (ZoomState *self)
{
	Dimensions _tmp0_;
	gint result;
#line 684 "../src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 684 "../src/Dimensions.vala"
	result = (gint) (_tmp0_.height * (*self).zoom_factor);
#line 684 "../src/Dimensions.vala"
	return result;
#line 2911 "Dimensions.c"
}

void
zoom_state_get_viewport_center (ZoomState *self,
                                GdkPoint* result)
{
	GdkPoint _tmp0_;
#line 688 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 688 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 688 "../src/Dimensions.vala"
	return;
#line 2925 "Dimensions.c"
}

gchar*
zoom_state_to_string (ZoomState *self)
{
	gchar* named_modes = NULL;
	gchar* _tmp0_;
	const gchar* _tmp17_;
	GdkRectangle viewing_rect = {0};
	GdkRectangle _tmp19_ = {0};
	Dimensions _tmp20_;
	Dimensions _tmp21_;
	Dimensions _tmp22_;
	Dimensions _tmp23_;
	const gchar* _tmp24_;
	GdkRectangle _tmp25_;
	GdkRectangle _tmp26_;
	GdkRectangle _tmp27_;
	GdkRectangle _tmp28_;
	GdkPoint _tmp29_;
	GdkPoint _tmp30_;
	gchar* _tmp31_;
	gchar* result;
#line 692 "../src/Dimensions.vala"
	_tmp0_ = g_strdup ("");
#line 692 "../src/Dimensions.vala"
	named_modes = _tmp0_;
#line 693 "../src/Dimensions.vala"
	if (zoom_state_is_min (&(*self))) {
#line 2955 "Dimensions.c"
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 694 "../src/Dimensions.vala"
		_tmp2_ = named_modes;
#line 694 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp2_, "") == 0) {
#line 694 "../src/Dimensions.vala"
			_tmp1_ = "MIN";
#line 2966 "Dimensions.c"
		} else {
#line 694 "../src/Dimensions.vala"
			_tmp1_ = ", MIN";
#line 2970 "Dimensions.c"
		}
#line 694 "../src/Dimensions.vala"
		_tmp3_ = named_modes;
#line 694 "../src/Dimensions.vala"
		_tmp4_ = g_strconcat (_tmp3_, _tmp1_, NULL);
#line 694 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 694 "../src/Dimensions.vala"
		named_modes = _tmp4_;
#line 2980 "Dimensions.c"
	}
#line 695 "../src/Dimensions.vala"
	if (zoom_state_is_default (&(*self))) {
#line 2984 "Dimensions.c"
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 696 "../src/Dimensions.vala"
		_tmp6_ = named_modes;
#line 696 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp6_, "") == 0) {
#line 696 "../src/Dimensions.vala"
			_tmp5_ = "DEFAULT";
#line 2995 "Dimensions.c"
		} else {
#line 696 "../src/Dimensions.vala"
			_tmp5_ = ", DEFAULT";
#line 2999 "Dimensions.c"
		}
#line 696 "../src/Dimensions.vala"
		_tmp7_ = named_modes;
#line 696 "../src/Dimensions.vala"
		_tmp8_ = g_strconcat (_tmp7_, _tmp5_, NULL);
#line 696 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 696 "../src/Dimensions.vala"
		named_modes = _tmp8_;
#line 3009 "Dimensions.c"
	}
#line 697 "../src/Dimensions.vala"
	if (zoom_state_is_isomorphic (&(*self))) {
#line 3013 "Dimensions.c"
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 698 "../src/Dimensions.vala"
		_tmp10_ = named_modes;
#line 698 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp10_, "") == 0) {
#line 698 "../src/Dimensions.vala"
			_tmp9_ = "ISOMORPHIC";
#line 3024 "Dimensions.c"
		} else {
#line 698 "../src/Dimensions.vala"
			_tmp9_ = ", ISOMORPHIC";
#line 3028 "Dimensions.c"
		}
#line 698 "../src/Dimensions.vala"
		_tmp11_ = named_modes;
#line 698 "../src/Dimensions.vala"
		_tmp12_ = g_strconcat (_tmp11_, _tmp9_, NULL);
#line 698 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 698 "../src/Dimensions.vala"
		named_modes = _tmp12_;
#line 3038 "Dimensions.c"
	}
#line 699 "../src/Dimensions.vala"
	if (zoom_state_is_max (&(*self))) {
#line 3042 "Dimensions.c"
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 700 "../src/Dimensions.vala"
		_tmp14_ = named_modes;
#line 700 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp14_, "") == 0) {
#line 700 "../src/Dimensions.vala"
			_tmp13_ = "MAX";
#line 3053 "Dimensions.c"
		} else {
#line 700 "../src/Dimensions.vala"
			_tmp13_ = ", MAX";
#line 3057 "Dimensions.c"
		}
#line 700 "../src/Dimensions.vala"
		_tmp15_ = named_modes;
#line 700 "../src/Dimensions.vala"
		_tmp16_ = g_strconcat (_tmp15_, _tmp13_, NULL);
#line 700 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 700 "../src/Dimensions.vala"
		named_modes = _tmp16_;
#line 3067 "Dimensions.c"
	}
#line 701 "../src/Dimensions.vala"
	_tmp17_ = named_modes;
#line 701 "../src/Dimensions.vala"
	if (g_strcmp0 (_tmp17_, "") == 0) {
#line 3073 "Dimensions.c"
		gchar* _tmp18_;
#line 702 "../src/Dimensions.vala"
		_tmp18_ = g_strdup ("(none)");
#line 702 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 702 "../src/Dimensions.vala"
		named_modes = _tmp18_;
#line 3081 "Dimensions.c"
	}
#line 704 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp19_);
#line 704 "../src/Dimensions.vala"
	viewing_rect = _tmp19_;
#line 706 "../src/Dimensions.vala"
	_tmp20_ = (*self).content_dimensions;
#line 706 "../src/Dimensions.vala"
	_tmp21_ = (*self).content_dimensions;
#line 706 "../src/Dimensions.vala"
	_tmp22_ = (*self).viewport_dimensions;
#line 706 "../src/Dimensions.vala"
	_tmp23_ = (*self).viewport_dimensions;
#line 706 "../src/Dimensions.vala"
	_tmp24_ = named_modes;
#line 706 "../src/Dimensions.vala"
	_tmp25_ = viewing_rect;
#line 706 "../src/Dimensions.vala"
	_tmp26_ = viewing_rect;
#line 706 "../src/Dimensions.vala"
	_tmp27_ = viewing_rect;
#line 706 "../src/Dimensions.vala"
	_tmp28_ = viewing_rect;
#line 706 "../src/Dimensions.vala"
	_tmp29_ = (*self).viewport_center;
#line 706 "../src/Dimensions.vala"
	_tmp30_ = (*self).viewport_center;
#line 706 "../src/Dimensions.vala"
	_tmp31_ = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", _tmp20_.width, _tmp21_.height, _tmp22_.width, _tmp23_.height, (*self).min_factor, (*self).max_factor, (*self).zoom_factor, zoom_state_get_zoomed_width (&(*self)), zoom_state_get_zoomed_height (&(*self)), _tmp24_, _tmp25_.x, _tmp26_.y, _tmp27_.width, _tmp28_.height, _tmp29_.x, _tmp30_.y);
#line 706 "../src/Dimensions.vala"
	result = _tmp31_;
#line 706 "../src/Dimensions.vala"
	_g_free0 (named_modes);
#line 706 "../src/Dimensions.vala"
	return result;
#line 3117 "Dimensions.c"
}

gboolean
zoom_state_is_min (ZoomState *self)
{
	gboolean result;
#line 718 "../src/Dimensions.vala"
	result = (*self).zoom_factor == (*self).min_factor;
#line 718 "../src/Dimensions.vala"
	return result;
#line 3128 "Dimensions.c"
}

gboolean
zoom_state_is_default (ZoomState *self)
{
	gboolean result;
#line 722 "../src/Dimensions.vala"
	result = zoom_state_is_min (&(*self));
#line 722 "../src/Dimensions.vala"
	return result;
#line 3139 "Dimensions.c"
}

gboolean
zoom_state_is_max (ZoomState *self)
{
	gboolean result;
#line 726 "../src/Dimensions.vala"
	result = (*self).zoom_factor == (*self).max_factor;
#line 726 "../src/Dimensions.vala"
	return result;
#line 3150 "Dimensions.c"
}

gboolean
zoom_state_is_isomorphic (ZoomState *self)
{
	gboolean result;
#line 730 "../src/Dimensions.vala"
	result = (*self).zoom_factor == 1.0;
#line 730 "../src/Dimensions.vala"
	return result;
#line 3161 "Dimensions.c"
}

gboolean
zoom_state_equals (ZoomState *self,
                   ZoomState* other)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	ZoomState _tmp5_;
	ZoomState _tmp6_;
	GdkPoint _tmp7_;
	ZoomState _tmp8_;
	GdkPoint _tmp9_;
	GdkPoint _tmp10_;
	ZoomState _tmp11_;
	GdkPoint _tmp12_;
	gboolean result;
#line 733 "../src/Dimensions.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 734 "../src/Dimensions.vala"
	_tmp0_ = *other;
#line 734 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 734 "../src/Dimensions.vala"
	if (!dimensions_equals (&(*self).content_dimensions, &_tmp1_)) {
#line 735 "../src/Dimensions.vala"
		result = FALSE;
#line 735 "../src/Dimensions.vala"
		return result;
#line 3194 "Dimensions.c"
	}
#line 736 "../src/Dimensions.vala"
	_tmp2_ = *other;
#line 736 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 736 "../src/Dimensions.vala"
	if (!dimensions_equals (&(*self).viewport_dimensions, &_tmp3_)) {
#line 737 "../src/Dimensions.vala"
		result = FALSE;
#line 737 "../src/Dimensions.vala"
		return result;
#line 3206 "Dimensions.c"
	}
#line 738 "../src/Dimensions.vala"
	_tmp4_ = *other;
#line 738 "../src/Dimensions.vala"
	if ((*self).zoom_factor != _tmp4_.zoom_factor) {
#line 739 "../src/Dimensions.vala"
		result = FALSE;
#line 739 "../src/Dimensions.vala"
		return result;
#line 3216 "Dimensions.c"
	}
#line 740 "../src/Dimensions.vala"
	_tmp5_ = *other;
#line 740 "../src/Dimensions.vala"
	if ((*self).min_factor != _tmp5_.min_factor) {
#line 741 "../src/Dimensions.vala"
		result = FALSE;
#line 741 "../src/Dimensions.vala"
		return result;
#line 3226 "Dimensions.c"
	}
#line 742 "../src/Dimensions.vala"
	_tmp6_ = *other;
#line 742 "../src/Dimensions.vala"
	if ((*self).max_factor != _tmp6_.max_factor) {
#line 743 "../src/Dimensions.vala"
		result = FALSE;
#line 743 "../src/Dimensions.vala"
		return result;
#line 3236 "Dimensions.c"
	}
#line 744 "../src/Dimensions.vala"
	_tmp7_ = (*self).viewport_center;
#line 744 "../src/Dimensions.vala"
	_tmp8_ = *other;
#line 744 "../src/Dimensions.vala"
	_tmp9_ = _tmp8_.viewport_center;
#line 744 "../src/Dimensions.vala"
	if (_tmp7_.x != _tmp9_.x) {
#line 745 "../src/Dimensions.vala"
		result = FALSE;
#line 745 "../src/Dimensions.vala"
		return result;
#line 3250 "Dimensions.c"
	}
#line 746 "../src/Dimensions.vala"
	_tmp10_ = (*self).viewport_center;
#line 746 "../src/Dimensions.vala"
	_tmp11_ = *other;
#line 746 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_.viewport_center;
#line 746 "../src/Dimensions.vala"
	if (_tmp10_.y != _tmp12_.y) {
#line 747 "../src/Dimensions.vala"
		result = FALSE;
#line 747 "../src/Dimensions.vala"
		return result;
#line 3264 "Dimensions.c"
	}
#line 749 "../src/Dimensions.vala"
	result = TRUE;
#line 749 "../src/Dimensions.vala"
	return result;
#line 3270 "Dimensions.c"
}

ZoomState*
zoom_state_dup (const ZoomState* self)
{
	ZoomState* dup;
#line 483 "../src/Dimensions.vala"
	dup = g_new0 (ZoomState, 1);
#line 483 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (ZoomState));
#line 483 "../src/Dimensions.vala"
	return dup;
#line 3283 "Dimensions.c"
}

void
zoom_state_free (ZoomState* self)
{
#line 483 "../src/Dimensions.vala"
	g_free (self);
#line 3291 "Dimensions.c"
}

static GType
zoom_state_get_type_once (void)
{
	GType zoom_state_type_id;
	zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
	return zoom_state_type_id;
}

GType
zoom_state_get_type (void)
{
	static volatile gsize zoom_state_type_id__once = 0;
	if (g_once_init_enter (&zoom_state_type_id__once)) {
		GType zoom_state_type_id;
		zoom_state_type_id = zoom_state_get_type_once ();
		g_once_init_leave (&zoom_state_type_id__once, zoom_state_type_id);
	}
	return zoom_state_type_id__once;
}

