/* Exporter.c generated by valac 0.56.18, the Vala compiler
 * generated from Exporter.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	EXPORTER_0_PROPERTY,
	EXPORTER_NUM_PROPERTIES
};
static GParamSpec* exporter_properties[EXPORTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))

#define EXPORTER_TYPE_EXPORT_JOB (exporter_export_job_get_type ())
#define EXPORTER_EXPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EXPORTER_TYPE_EXPORT_JOB, ExporterExportJob))
#define EXPORTER_EXPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EXPORTER_TYPE_EXPORT_JOB, ExporterExportJobClass))
#define EXPORTER_IS_EXPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EXPORTER_TYPE_EXPORT_JOB))
#define EXPORTER_IS_EXPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EXPORTER_TYPE_EXPORT_JOB))
#define EXPORTER_EXPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EXPORTER_TYPE_EXPORT_JOB, ExporterExportJobClass))

typedef struct _ExporterExportJob ExporterExportJob;
typedef struct _ExporterExportJobClass ExporterExportJobClass;
typedef struct _ExporterExportJobPrivate ExporterExportJobPrivate;
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _scaling_free0(var) ((var == NULL) ? NULL : (var = (scaling_free (var), NULL)))
typedef struct _ParamSpecExporterUI ParamSpecExporterUI;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ExporterPrivate {
	GeeCollection* to_export;
	GFile** exported_files;
	gint exported_files_length1;
	gint _exported_files_size_;
	GFile* dir;
	Scaling scaling;
	gint completed_count;
	Workers* workers;
	ExporterCompletionCallback completion_callback;
	gpointer completion_callback_target;
	ExporterExportFailedCallback error_callback;
	gpointer error_callback_target;
	ExporterOverwriteCallback overwrite_callback;
	gpointer overwrite_callback_target;
	ProgressMonitor monitor;
	gpointer monitor_target;
	GCancellable* cancellable;
	gboolean replace_all;
	gboolean aborted;
	ExportFormatParameters export_params;
};

struct _ExporterExportJob {
	BackgroundJob parent_instance;
	ExporterExportJobPrivate * priv;
	MediaSource* media;
	GFile* dest;
	Scaling* scaling;
	JpegQuality* quality;
	PhotoFileFormat* format;
	GError* err;
	gboolean direct_copy_unmodified;
	gboolean export_metadata;
};

struct _ExporterExportJobClass {
	BackgroundJobClass parent_class;
};

struct _ExporterUIPrivate {
	Exporter* exporter;
	GCancellable* cancellable;
	ProgressDialog* progress_dialog;
	ExporterCompletionCallback completion_callback;
	gpointer completion_callback_target;
};

struct _ParamSpecExporterUI {
	GParamSpec parent_instance;
};

static gint Exporter_private_offset;
static gpointer exporter_parent_class = NULL;
static gpointer exporter_export_job_parent_class = NULL;
static gint ExporterUI_private_offset;
static gpointer exporter_ui_parent_class = NULL;

static void export_format_parameters_init (ExportFormatParameters *self,
                                    ExportFormatMode mode,
                                    PhotoFileFormat specified_format,
                                    JpegQuality quality);
static gboolean exporter_process_queue (Exporter* self);
static void exporter_export_completed (Exporter* self,
                                gboolean is_cancelled);
static void exporter_on_exported (Exporter* self,
                           BackgroundJob* j);
static GType exporter_export_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void _vala_array_add1 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
static void exporter_on_export_cancelled (Exporter* self,
                                   BackgroundJob* j);
static GFile** _vala_array_dup2 (GFile** self,
                          gssize length);
static void _vala_array_add2 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
VALA_EXTERN GFile* app_dirs_get_temp_dir (void);
static ExporterExportJob* exporter_export_job_new (Exporter* owner,
                                            MediaSource* media,
                                            GFile* dest,
                                            Scaling* scaling,
                                            JpegQuality* quality,
                                            PhotoFileFormat* format,
                                            GCancellable* cancellable,
                                            gboolean direct_copy_unmodified,
                                            gboolean export_metadata);
static ExporterExportJob* exporter_export_job_construct (GType object_type,
                                                  Exporter* owner,
                                                  MediaSource* media,
                                                  GFile* dest,
                                                  Scaling* scaling,
                                                  JpegQuality* quality,
                                                  PhotoFileFormat* format,
                                                  GCancellable* cancellable,
                                                  gboolean direct_copy_unmodified,
                                                  gboolean export_metadata);
static void _exporter_on_exported_completion_callback (BackgroundJob* job,
                                                gpointer self);
static void _exporter_on_export_cancelled_cancellation_callback (BackgroundJob* job,
                                                          gpointer self);
static JpegQuality* _jpeg_quality_dup (JpegQuality* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
static void exporter_export_job_real_execute (BackgroundJob* base);
static void exporter_export_job_finalize (BackgroundJob * obj);
static GType exporter_export_job_get_type_once (void);
static void exporter_finalize (GObject * obj);
static GType exporter_get_type_once (void);
static void exporter_ui_on_export_completed (ExporterUI* self,
                                      Exporter* exporter,
                                      gboolean is_cancelled);
static void _exporter_ui_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                    gboolean is_cancelled,
                                                                    gpointer self);
static gboolean exporter_ui_on_export_failed (ExporterUI* self,
                                       Exporter* exporter,
                                       GFile* file,
                                       gint remaining,
                                       GError* err);
static gboolean _exporter_ui_on_export_failed_exporter_export_failed_callback (Exporter* exporter,
                                                                        GFile* file,
                                                                        gint remaining,
                                                                        GError* err,
                                                                        gpointer self);
static ExporterOverwrite exporter_ui_on_export_overwrite (ExporterUI* self,
                                                   Exporter* exporter,
                                                   GFile* file);
static ExporterOverwrite _exporter_ui_on_export_overwrite_exporter_overwrite_callback (Exporter* exporter,
                                                                                GFile* file,
                                                                                gpointer self);
static gboolean _progress_dialog_monitor_progress_monitor (guint64 current,
                                                    guint64 total,
                                                    gboolean do_event_loop,
                                                    gpointer self);
static void exporter_ui_finalize (ExporterUI * obj);
static GType exporter_ui_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static GType
export_format_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{EXPORT_FORMAT_MODE_UNMODIFIED, "EXPORT_FORMAT_MODE_UNMODIFIED", "unmodified"}, {EXPORT_FORMAT_MODE_CURRENT, "EXPORT_FORMAT_MODE_CURRENT", "current"}, {EXPORT_FORMAT_MODE_SPECIFIED, "EXPORT_FORMAT_MODE_SPECIFIED", "specified"}, {EXPORT_FORMAT_MODE_LAST, "EXPORT_FORMAT_MODE_LAST", "last"}, {0, NULL, NULL}};
	GType export_format_mode_type_id;
	export_format_mode_type_id = g_enum_register_static ("ExportFormatMode", values);
	return export_format_mode_type_id;
}

GType
export_format_mode_get_type (void)
{
	static volatile gsize export_format_mode_type_id__once = 0;
	if (g_once_init_enter (&export_format_mode_type_id__once)) {
		GType export_format_mode_type_id;
		export_format_mode_type_id = export_format_mode_get_type_once ();
		g_once_init_leave (&export_format_mode_type_id__once, export_format_mode_type_id);
	}
	return export_format_mode_type_id__once;
}

static void
export_format_parameters_init (ExportFormatParameters *self,
                               ExportFormatMode mode,
                               PhotoFileFormat specified_format,
                               JpegQuality quality)
{
#line 32 "../src/Exporter.vala"
	memset (self, 0, sizeof (ExportFormatParameters));
#line 34 "../src/Exporter.vala"
	(*self).mode = mode;
#line 35 "../src/Exporter.vala"
	(*self).specified_format = specified_format;
#line 36 "../src/Exporter.vala"
	(*self).quality = quality;
#line 37 "../src/Exporter.vala"
	(*self).export_metadata = TRUE;
#line 256 "Exporter.c"
}

void
export_format_parameters_current (ExportFormatParameters* result)
{
	ExportFormatParameters _tmp0_ = {0};
#line 41 "../src/Exporter.vala"
	export_format_parameters_init (&_tmp0_, EXPORT_FORMAT_MODE_CURRENT, photo_file_format_get_system_default_format (), JPEG_QUALITY_HIGH);
#line 41 "../src/Exporter.vala"
	*result = _tmp0_;
#line 41 "../src/Exporter.vala"
	return;
#line 269 "Exporter.c"
}

void
export_format_parameters_unmodified (ExportFormatParameters* result)
{
	ExportFormatParameters _tmp0_ = {0};
#line 46 "../src/Exporter.vala"
	export_format_parameters_init (&_tmp0_, EXPORT_FORMAT_MODE_UNMODIFIED, photo_file_format_get_system_default_format (), JPEG_QUALITY_HIGH);
#line 46 "../src/Exporter.vala"
	*result = _tmp0_;
#line 46 "../src/Exporter.vala"
	return;
#line 282 "Exporter.c"
}

void
export_format_parameters_for_format (PhotoFileFormat format,
                                     ExportFormatParameters* result)
{
	ExportFormatParameters _tmp0_ = {0};
#line 51 "../src/Exporter.vala"
	export_format_parameters_init (&_tmp0_, EXPORT_FORMAT_MODE_SPECIFIED, format, JPEG_QUALITY_HIGH);
#line 51 "../src/Exporter.vala"
	*result = _tmp0_;
#line 51 "../src/Exporter.vala"
	return;
#line 296 "Exporter.c"
}

void
export_format_parameters_last (ExportFormatParameters* result)
{
	ExportFormatParameters _tmp0_ = {0};
#line 55 "../src/Exporter.vala"
	export_format_parameters_init (&_tmp0_, EXPORT_FORMAT_MODE_LAST, photo_file_format_get_system_default_format (), JPEG_QUALITY_HIGH);
#line 55 "../src/Exporter.vala"
	*result = _tmp0_;
#line 55 "../src/Exporter.vala"
	return;
#line 309 "Exporter.c"
}

void
export_format_parameters_for_jpeg (JpegQuality quality,
                                   ExportFormatParameters* result)
{
	ExportFormatParameters _tmp0_ = {0};
#line 60 "../src/Exporter.vala"
	export_format_parameters_init (&_tmp0_, EXPORT_FORMAT_MODE_SPECIFIED, PHOTO_FILE_FORMAT_JFIF, quality);
#line 60 "../src/Exporter.vala"
	*result = _tmp0_;
#line 60 "../src/Exporter.vala"
	return;
#line 323 "Exporter.c"
}

ExportFormatParameters*
export_format_parameters_dup (const ExportFormatParameters* self)
{
	ExportFormatParameters* dup;
#line 26 "../src/Exporter.vala"
	dup = g_new0 (ExportFormatParameters, 1);
#line 26 "../src/Exporter.vala"
	memcpy (dup, self, sizeof (ExportFormatParameters));
#line 26 "../src/Exporter.vala"
	return dup;
#line 336 "Exporter.c"
}

void
export_format_parameters_free (ExportFormatParameters* self)
{
#line 26 "../src/Exporter.vala"
	g_free (self);
#line 344 "Exporter.c"
}

static GType
export_format_parameters_get_type_once (void)
{
	GType export_format_parameters_type_id;
	export_format_parameters_type_id = g_boxed_type_register_static ("ExportFormatParameters", (GBoxedCopyFunc) export_format_parameters_dup, (GBoxedFreeFunc) export_format_parameters_free);
	return export_format_parameters_type_id;
}

GType
export_format_parameters_get_type (void)
{
	static volatile gsize export_format_parameters_type_id__once = 0;
	if (g_once_init_enter (&export_format_parameters_type_id__once)) {
		GType export_format_parameters_type_id;
		export_format_parameters_type_id = export_format_parameters_get_type_once ();
		g_once_init_leave (&export_format_parameters_type_id__once, export_format_parameters_type_id);
	}
	return export_format_parameters_type_id__once;
}

static inline gpointer
exporter_get_instance_private (Exporter* self)
{
	return G_STRUCT_MEMBER_P (self, Exporter_private_offset);
}

static GType
exporter_overwrite_get_type_once (void)
{
	static const GEnumValue values[] = {{EXPORTER_OVERWRITE_YES, "EXPORTER_OVERWRITE_YES", "yes"}, {EXPORTER_OVERWRITE_NO, "EXPORTER_OVERWRITE_NO", "no"}, {EXPORTER_OVERWRITE_CANCEL, "EXPORTER_OVERWRITE_CANCEL", "cancel"}, {EXPORTER_OVERWRITE_REPLACE_ALL, "EXPORTER_OVERWRITE_REPLACE_ALL", "replace-all"}, {0, NULL, NULL}};
	GType exporter_overwrite_type_id;
	exporter_overwrite_type_id = g_enum_register_static ("ExporterOverwrite", values);
	return exporter_overwrite_type_id;
}

GType
exporter_overwrite_get_type (void)
{
	static volatile gsize exporter_overwrite_type_id__once = 0;
	if (g_once_init_enter (&exporter_overwrite_type_id__once)) {
		GType exporter_overwrite_type_id;
		exporter_overwrite_type_id = exporter_overwrite_get_type_once ();
		g_once_init_leave (&exporter_overwrite_type_id__once, exporter_overwrite_type_id);
	}
	return exporter_overwrite_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 137 "../src/Exporter.vala"
	return self ? g_object_ref (self) : NULL;
#line 399 "Exporter.c"
}

Exporter*
exporter_construct (GType object_type,
                    GeeCollection* to_export,
                    GFile* dir,
                    Scaling* scaling,
                    ExportFormatParameters* export_params,
                    gboolean auto_replace_all)
{
	Exporter * self = NULL;
	GeeCollection* _tmp0_;
	GFile* _tmp1_;
	Scaling _tmp2_;
	ExportFormatParameters _tmp3_;
#line 134 "../src/Exporter.vala"
	g_return_val_if_fail (to_export != NULL, NULL);
#line 134 "../src/Exporter.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 134 "../src/Exporter.vala"
	g_return_val_if_fail (export_params != NULL, NULL);
#line 134 "../src/Exporter.vala"
	self = (Exporter*) g_object_new (object_type, NULL);
#line 136 "../src/Exporter.vala"
	_tmp0_ = self->priv->to_export;
#line 136 "../src/Exporter.vala"
	gee_collection_add_all (_tmp0_, to_export);
#line 137 "../src/Exporter.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 137 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->dir);
#line 137 "../src/Exporter.vala"
	self->priv->dir = _tmp1_;
#line 138 "../src/Exporter.vala"
	_tmp2_ = *scaling;
#line 138 "../src/Exporter.vala"
	self->priv->scaling = _tmp2_;
#line 139 "../src/Exporter.vala"
	_tmp3_ = *export_params;
#line 139 "../src/Exporter.vala"
	self->priv->export_params = _tmp3_;
#line 140 "../src/Exporter.vala"
	self->priv->replace_all = auto_replace_all;
#line 134 "../src/Exporter.vala"
	return self;
#line 445 "Exporter.c"
}

Exporter*
exporter_new (GeeCollection* to_export,
              GFile* dir,
              Scaling* scaling,
              ExportFormatParameters* export_params,
              gboolean auto_replace_all)
{
#line 134 "../src/Exporter.vala"
	return exporter_construct (TYPE_EXPORTER, to_export, dir, scaling, export_params, auto_replace_all);
#line 457 "Exporter.c"
}

Exporter*
exporter_construct_for_temp_file (GType object_type,
                                  GeeCollection* to_export,
                                  Scaling* scaling,
                                  ExportFormatParameters* export_params)
{
	Exporter * self = NULL;
	GeeCollection* _tmp0_;
	Scaling _tmp1_;
	ExportFormatParameters _tmp2_;
#line 143 "../src/Exporter.vala"
	g_return_val_if_fail (to_export != NULL, NULL);
#line 143 "../src/Exporter.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 143 "../src/Exporter.vala"
	g_return_val_if_fail (export_params != NULL, NULL);
#line 143 "../src/Exporter.vala"
	self = (Exporter*) g_object_new (object_type, NULL);
#line 145 "../src/Exporter.vala"
	_tmp0_ = self->priv->to_export;
#line 145 "../src/Exporter.vala"
	gee_collection_add_all (_tmp0_, to_export);
#line 146 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->dir);
#line 146 "../src/Exporter.vala"
	self->priv->dir = NULL;
#line 147 "../src/Exporter.vala"
	_tmp1_ = *scaling;
#line 147 "../src/Exporter.vala"
	self->priv->scaling = _tmp1_;
#line 148 "../src/Exporter.vala"
	_tmp2_ = *export_params;
#line 148 "../src/Exporter.vala"
	self->priv->export_params = _tmp2_;
#line 143 "../src/Exporter.vala"
	return self;
#line 496 "Exporter.c"
}

Exporter*
exporter_new_for_temp_file (GeeCollection* to_export,
                            Scaling* scaling,
                            ExportFormatParameters* export_params)
{
#line 143 "../src/Exporter.vala"
	return exporter_construct_for_temp_file (TYPE_EXPORTER, to_export, scaling, export_params);
#line 506 "Exporter.c"
}

void
exporter_export (Exporter* self,
                 ExporterCompletionCallback completion_callback,
                 gpointer completion_callback_target,
                 ExporterExportFailedCallback error_callback,
                 gpointer error_callback_target,
                 ExporterOverwriteCallback overwrite_callback,
                 gpointer overwrite_callback_target,
                 GCancellable* cancellable,
                 ProgressMonitor monitor,
                 gpointer monitor_target)
{
	GCancellable* _tmp0_ = NULL;
	GCancellable* _tmp1_;
	GCancellable* _tmp3_;
#line 152 "../src/Exporter.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/Exporter.vala"
	self->priv->completion_callback = completion_callback;
#line 154 "../src/Exporter.vala"
	self->priv->completion_callback_target = completion_callback_target;
#line 155 "../src/Exporter.vala"
	self->priv->error_callback = error_callback;
#line 155 "../src/Exporter.vala"
	self->priv->error_callback_target = error_callback_target;
#line 156 "../src/Exporter.vala"
	self->priv->overwrite_callback = overwrite_callback;
#line 156 "../src/Exporter.vala"
	self->priv->overwrite_callback_target = overwrite_callback_target;
#line 157 "../src/Exporter.vala"
	self->priv->monitor = monitor;
#line 157 "../src/Exporter.vala"
	self->priv->monitor_target = monitor_target;
#line 158 "../src/Exporter.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 158 "../src/Exporter.vala"
	_tmp0_ = _tmp1_;
#line 158 "../src/Exporter.vala"
	if (_tmp0_ == NULL) {
#line 548 "Exporter.c"
		GCancellable* _tmp2_;
#line 158 "../src/Exporter.vala"
		_tmp2_ = g_cancellable_new ();
#line 158 "../src/Exporter.vala"
		_g_object_unref0 (_tmp0_);
#line 158 "../src/Exporter.vala"
		_tmp0_ = _tmp2_;
#line 556 "Exporter.c"
	}
#line 158 "../src/Exporter.vala"
	_tmp3_ = _tmp0_;
#line 158 "../src/Exporter.vala"
	_tmp0_ = NULL;
#line 158 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 158 "../src/Exporter.vala"
	self->priv->cancellable = _tmp3_;
#line 160 "../src/Exporter.vala"
	if (!exporter_process_queue (self)) {
#line 161 "../src/Exporter.vala"
		exporter_export_completed (self, TRUE);
#line 570 "Exporter.c"
	}
#line 152 "../src/Exporter.vala"
	_g_object_unref0 (_tmp0_);
#line 574 "Exporter.c"
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 165 "../src/Exporter.vala"
	return self ? background_job_ref (self) : NULL;
#line 582 "Exporter.c"
}

static void
_vala_array_add1 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
#line 189 "../src/Exporter.vala"
	if ((*length) == (*size)) {
#line 189 "../src/Exporter.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 189 "../src/Exporter.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 597 "Exporter.c"
	}
#line 189 "../src/Exporter.vala"
	(*array)[(*length)++] = value;
#line 189 "../src/Exporter.vala"
	(*array)[*length] = NULL;
#line 603 "Exporter.c"
}

static void
exporter_on_exported (Exporter* self,
                      BackgroundJob* j)
{
	ExporterExportJob* job = NULL;
	ExporterExportJob* _tmp0_;
	gint _tmp1_;
	gboolean completed = FALSE;
	GeeCollection* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp16_ = FALSE;
#line 164 "../src/Exporter.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Exporter.vala"
	g_return_if_fail (j != NULL);
#line 165 "../src/Exporter.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, EXPORTER_TYPE_EXPORT_JOB, ExporterExportJob));
#line 165 "../src/Exporter.vala"
	job = _tmp0_;
#line 167 "../src/Exporter.vala"
	_tmp1_ = self->priv->completed_count;
#line 167 "../src/Exporter.vala"
	self->priv->completed_count = _tmp1_ + 1;
#line 171 "../src/Exporter.vala"
	_tmp2_ = self->priv->to_export;
#line 171 "../src/Exporter.vala"
	_tmp3_ = gee_collection_get_size (_tmp2_);
#line 171 "../src/Exporter.vala"
	_tmp4_ = _tmp3_;
#line 171 "../src/Exporter.vala"
	completed = self->priv->completed_count == _tmp4_;
#line 173 "../src/Exporter.vala"
	if (!self->priv->aborted) {
#line 641 "Exporter.c"
		ExporterExportJob* _tmp6_;
		GError* _tmp7_;
#line 173 "../src/Exporter.vala"
		_tmp6_ = job;
#line 173 "../src/Exporter.vala"
		_tmp7_ = _tmp6_->err;
#line 173 "../src/Exporter.vala"
		_tmp5_ = _tmp7_ != NULL;
#line 650 "Exporter.c"
	} else {
#line 173 "../src/Exporter.vala"
		_tmp5_ = FALSE;
#line 654 "Exporter.c"
	}
#line 173 "../src/Exporter.vala"
	if (_tmp5_) {
#line 658 "Exporter.c"
		ExporterExportFailedCallback _tmp8_;
		gpointer _tmp8__target;
		ExporterExportJob* _tmp9_;
		GFile* _tmp10_;
		GeeCollection* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		ExporterExportJob* _tmp14_;
		GError* _tmp15_;
#line 174 "../src/Exporter.vala"
		_tmp8_ = self->priv->error_callback;
#line 174 "../src/Exporter.vala"
		_tmp8__target = self->priv->error_callback_target;
#line 174 "../src/Exporter.vala"
		_tmp9_ = job;
#line 174 "../src/Exporter.vala"
		_tmp10_ = _tmp9_->dest;
#line 174 "../src/Exporter.vala"
		_tmp11_ = self->priv->to_export;
#line 174 "../src/Exporter.vala"
		_tmp12_ = gee_collection_get_size (_tmp11_);
#line 174 "../src/Exporter.vala"
		_tmp13_ = _tmp12_;
#line 174 "../src/Exporter.vala"
		_tmp14_ = job;
#line 174 "../src/Exporter.vala"
		_tmp15_ = _tmp14_->err;
#line 174 "../src/Exporter.vala"
		if (!_tmp8_ (self, _tmp10_, _tmp13_ - self->priv->completed_count, _tmp15_, _tmp8__target)) {
#line 175 "../src/Exporter.vala"
			self->priv->aborted = TRUE;
#line 177 "../src/Exporter.vala"
			if (!completed) {
#line 178 "../src/Exporter.vala"
				_background_job_unref0 (job);
#line 178 "../src/Exporter.vala"
				return;
#line 696 "Exporter.c"
			}
		}
	}
#line 182 "../src/Exporter.vala"
	if (!self->priv->aborted) {
#line 702 "Exporter.c"
		ProgressMonitor _tmp17_;
		gpointer _tmp17__target;
#line 182 "../src/Exporter.vala"
		_tmp17_ = self->priv->monitor;
#line 182 "../src/Exporter.vala"
		_tmp17__target = self->priv->monitor_target;
#line 182 "../src/Exporter.vala"
		_tmp16_ = _tmp17_ != NULL;
#line 711 "Exporter.c"
	} else {
#line 182 "../src/Exporter.vala"
		_tmp16_ = FALSE;
#line 715 "Exporter.c"
	}
#line 182 "../src/Exporter.vala"
	if (_tmp16_) {
#line 719 "Exporter.c"
		ProgressMonitor _tmp18_;
		gpointer _tmp18__target;
		GeeCollection* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
#line 183 "../src/Exporter.vala"
		_tmp18_ = self->priv->monitor;
#line 183 "../src/Exporter.vala"
		_tmp18__target = self->priv->monitor_target;
#line 183 "../src/Exporter.vala"
		_tmp19_ = self->priv->to_export;
#line 183 "../src/Exporter.vala"
		_tmp20_ = gee_collection_get_size (_tmp19_);
#line 183 "../src/Exporter.vala"
		_tmp21_ = _tmp20_;
#line 183 "../src/Exporter.vala"
		if (!_tmp18_ ((guint64) self->priv->completed_count, (guint64) _tmp21_, FALSE, _tmp18__target)) {
#line 184 "../src/Exporter.vala"
			self->priv->aborted = TRUE;
#line 186 "../src/Exporter.vala"
			if (!completed) {
#line 187 "../src/Exporter.vala"
				_background_job_unref0 (job);
#line 187 "../src/Exporter.vala"
				return;
#line 745 "Exporter.c"
			}
		} else {
			ExporterExportJob* _tmp22_;
			GFile* _tmp23_;
			GFile* _tmp24_;
#line 189 "../src/Exporter.vala"
			_tmp22_ = job;
#line 189 "../src/Exporter.vala"
			_tmp23_ = _tmp22_->dest;
#line 189 "../src/Exporter.vala"
			_tmp24_ = _g_object_ref0 (_tmp23_);
#line 189 "../src/Exporter.vala"
			_vala_array_add1 (&self->priv->exported_files, &self->priv->exported_files_length1, &self->priv->_exported_files_size_, _tmp24_);
#line 759 "Exporter.c"
		}
	}
#line 193 "../src/Exporter.vala"
	if (completed) {
#line 194 "../src/Exporter.vala"
		exporter_export_completed (self, FALSE);
#line 766 "Exporter.c"
	}
#line 164 "../src/Exporter.vala"
	_background_job_unref0 (job);
#line 770 "Exporter.c"
}

static void
exporter_on_export_cancelled (Exporter* self,
                              BackgroundJob* j)
{
	gint _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 197 "../src/Exporter.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/Exporter.vala"
	g_return_if_fail (j != NULL);
#line 198 "../src/Exporter.vala"
	self->priv->completed_count = self->priv->completed_count + 1;
#line 198 "../src/Exporter.vala"
	_tmp0_ = self->priv->completed_count;
#line 198 "../src/Exporter.vala"
	_tmp1_ = self->priv->to_export;
#line 198 "../src/Exporter.vala"
	_tmp2_ = gee_collection_get_size (_tmp1_);
#line 198 "../src/Exporter.vala"
	_tmp3_ = _tmp2_;
#line 198 "../src/Exporter.vala"
	if (_tmp0_ == _tmp3_) {
#line 199 "../src/Exporter.vala"
		exporter_export_completed (self, TRUE);
#line 799 "Exporter.c"
	}
}

static GFile**
_vala_array_dup2 (GFile** self,
                  gssize length)
{
#line 203 "../src/Exporter.vala"
	if (length >= 0) {
#line 809 "Exporter.c"
		GFile** result;
		gssize i;
#line 203 "../src/Exporter.vala"
		result = g_new0 (GFile*, length + 1);
#line 203 "../src/Exporter.vala"
		for (i = 0; i < length; i++) {
#line 816 "Exporter.c"
			GFile* _tmp0_;
#line 203 "../src/Exporter.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 203 "../src/Exporter.vala"
			result[i] = _tmp0_;
#line 822 "Exporter.c"
		}
#line 203 "../src/Exporter.vala"
		return result;
#line 826 "Exporter.c"
	}
#line 203 "../src/Exporter.vala"
	return NULL;
#line 830 "Exporter.c"
}

GFile**
exporter_get_exported_files (Exporter* self,
                             gint* result_length1)
{
	GFile** _tmp0_;
	gint _tmp0__length1;
	GFile** _tmp1_;
	gint _tmp1__length1;
	GFile** _tmp2_;
	gint _tmp2__length1;
	GFile** result;
#line 202 "../src/Exporter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 203 "../src/Exporter.vala"
	_tmp0_ = self->priv->exported_files;
#line 203 "../src/Exporter.vala"
	_tmp0__length1 = self->priv->exported_files_length1;
#line 203 "../src/Exporter.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup2 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 203 "../src/Exporter.vala"
	_tmp1__length1 = _tmp0__length1;
#line 203 "../src/Exporter.vala"
	_tmp2_ = _tmp1_;
#line 203 "../src/Exporter.vala"
	_tmp2__length1 = _tmp1__length1;
#line 203 "../src/Exporter.vala"
	if (result_length1) {
#line 203 "../src/Exporter.vala"
		*result_length1 = _tmp2__length1;
#line 862 "Exporter.c"
	}
#line 203 "../src/Exporter.vala"
	result = _tmp2_;
#line 203 "../src/Exporter.vala"
	return result;
#line 868 "Exporter.c"
}

static void
_vala_array_add2 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
#line 222 "../src/Exporter.vala"
	if ((*length) == (*size)) {
#line 222 "../src/Exporter.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 222 "../src/Exporter.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 883 "Exporter.c"
	}
#line 222 "../src/Exporter.vala"
	(*array)[(*length)++] = value;
#line 222 "../src/Exporter.vala"
	(*array)[*length] = NULL;
#line 889 "Exporter.c"
}

static gboolean
exporter_process_queue (Exporter* self)
{
	gint submitted = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 206 "../src/Exporter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "../src/Exporter.vala"
	submitted = 0;
#line 902 "Exporter.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
#line 208 "../src/Exporter.vala"
		_tmp0_ = self->priv->to_export;
#line 208 "../src/Exporter.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 208 "../src/Exporter.vala"
		_source_it = _tmp1_;
#line 208 "../src/Exporter.vala"
		while (TRUE) {
#line 915 "Exporter.c"
			GeeIterator* _tmp2_;
			MediaSource* source = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GFile* use_source_file = NULL;
			PhotoFileFormat real_export_format = 0;
			gchar* basename = NULL;
			MediaSource* _tmp5_;
			const gchar* _tmp16_;
			GFile* _tmp17_;
			GFile* export_dir = NULL;
			GFile* _tmp27_;
			GFile* _tmp28_;
			GFile* dest = NULL;
			GFile* _tmp29_;
			Workers* _tmp63_;
			MediaSource* _tmp64_;
			GFile* _tmp65_;
			Scaling _tmp66_;
			ExportFormatParameters _tmp67_;
			GCancellable* _tmp68_;
			ExportFormatParameters _tmp69_;
			ExportFormatParameters _tmp70_;
			ExporterExportJob* _tmp71_;
			ExporterExportJob* _tmp72_;
			gint _tmp73_;
#line 208 "../src/Exporter.vala"
			_tmp2_ = _source_it;
#line 208 "../src/Exporter.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 208 "../src/Exporter.vala"
				break;
#line 948 "Exporter.c"
			}
#line 208 "../src/Exporter.vala"
			_tmp3_ = _source_it;
#line 208 "../src/Exporter.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 208 "../src/Exporter.vala"
			source = (MediaSource*) _tmp4_;
#line 209 "../src/Exporter.vala"
			use_source_file = NULL;
#line 210 "../src/Exporter.vala"
			real_export_format = photo_file_format_get_system_default_format ();
#line 211 "../src/Exporter.vala"
			basename = NULL;
#line 212 "../src/Exporter.vala"
			_tmp5_ = source;
#line 212 "../src/Exporter.vala"
			if (IS_PHOTO (_tmp5_)) {
#line 966 "Exporter.c"
				Photo* photo = NULL;
				MediaSource* _tmp6_;
				Photo* _tmp7_;
				Photo* _tmp8_;
				ExportFormatParameters _tmp9_;
				Photo* _tmp10_;
				ExportFormatParameters _tmp11_;
				gchar* _tmp12_;
#line 213 "../src/Exporter.vala"
				_tmp6_ = source;
#line 213 "../src/Exporter.vala"
				_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 213 "../src/Exporter.vala"
				photo = _tmp7_;
#line 214 "../src/Exporter.vala"
				_tmp8_ = photo;
#line 214 "../src/Exporter.vala"
				_tmp9_ = self->priv->export_params;
#line 214 "../src/Exporter.vala"
				real_export_format = photo_get_export_format_for_parameters (_tmp8_, &_tmp9_);
#line 215 "../src/Exporter.vala"
				_tmp10_ = photo;
#line 215 "../src/Exporter.vala"
				_tmp11_ = self->priv->export_params;
#line 215 "../src/Exporter.vala"
				_tmp12_ = photo_get_export_basename_for_parameters (_tmp10_, &_tmp11_);
#line 215 "../src/Exporter.vala"
				_g_free0 (basename);
#line 215 "../src/Exporter.vala"
				basename = _tmp12_;
#line 212 "../src/Exporter.vala"
				_g_object_unref0 (photo);
#line 999 "Exporter.c"
			} else {
				MediaSource* _tmp13_;
#line 216 "../src/Exporter.vala"
				_tmp13_ = source;
#line 216 "../src/Exporter.vala"
				if (IS_VIDEO (_tmp13_)) {
#line 1006 "Exporter.c"
					MediaSource* _tmp14_;
					gchar* _tmp15_;
#line 217 "../src/Exporter.vala"
					_tmp14_ = source;
#line 217 "../src/Exporter.vala"
					_tmp15_ = media_source_get_basename ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_VIDEO, Video));
#line 217 "../src/Exporter.vala"
					_g_free0 (basename);
#line 217 "../src/Exporter.vala"
					basename = _tmp15_;
#line 1017 "Exporter.c"
				}
			}
#line 219 "../src/Exporter.vala"
			_tmp16_ = basename;
#line 219 "../src/Exporter.vala"
			_vala_assert (_tmp16_ != NULL, "basename != null");
#line 221 "../src/Exporter.vala"
			_tmp17_ = use_source_file;
#line 221 "../src/Exporter.vala"
			if (_tmp17_ != NULL) {
#line 1028 "Exporter.c"
				GFile* _tmp18_;
				GFile* _tmp19_;
				gint _tmp20_;
				ProgressMonitor _tmp21_;
				gpointer _tmp21__target;
#line 222 "../src/Exporter.vala"
				_tmp18_ = use_source_file;
#line 222 "../src/Exporter.vala"
				_tmp19_ = _g_object_ref0 (_tmp18_);
#line 222 "../src/Exporter.vala"
				_vala_array_add2 (&self->priv->exported_files, &self->priv->exported_files_length1, &self->priv->_exported_files_size_, _tmp19_);
#line 224 "../src/Exporter.vala"
				_tmp20_ = self->priv->completed_count;
#line 224 "../src/Exporter.vala"
				self->priv->completed_count = _tmp20_ + 1;
#line 225 "../src/Exporter.vala"
				_tmp21_ = self->priv->monitor;
#line 225 "../src/Exporter.vala"
				_tmp21__target = self->priv->monitor_target;
#line 225 "../src/Exporter.vala"
				if (_tmp21_ != NULL) {
#line 1050 "Exporter.c"
					ProgressMonitor _tmp22_;
					gpointer _tmp22__target;
					GeeCollection* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
#line 226 "../src/Exporter.vala"
					_tmp22_ = self->priv->monitor;
#line 226 "../src/Exporter.vala"
					_tmp22__target = self->priv->monitor_target;
#line 226 "../src/Exporter.vala"
					_tmp23_ = self->priv->to_export;
#line 226 "../src/Exporter.vala"
					_tmp24_ = gee_collection_get_size (_tmp23_);
#line 226 "../src/Exporter.vala"
					_tmp25_ = _tmp24_;
#line 226 "../src/Exporter.vala"
					if (!_tmp22_ ((guint64) self->priv->completed_count, (guint64) _tmp25_, TRUE, _tmp22__target)) {
#line 1068 "Exporter.c"
						GCancellable* _tmp26_;
#line 227 "../src/Exporter.vala"
						_tmp26_ = self->priv->cancellable;
#line 227 "../src/Exporter.vala"
						g_cancellable_cancel (_tmp26_);
#line 229 "../src/Exporter.vala"
						result = FALSE;
#line 229 "../src/Exporter.vala"
						_g_free0 (basename);
#line 229 "../src/Exporter.vala"
						_g_object_unref0 (use_source_file);
#line 229 "../src/Exporter.vala"
						_g_object_unref0 (source);
#line 229 "../src/Exporter.vala"
						_g_object_unref0 (_source_it);
#line 229 "../src/Exporter.vala"
						return result;
#line 1086 "Exporter.c"
					}
				}
#line 233 "../src/Exporter.vala"
				_g_free0 (basename);
#line 233 "../src/Exporter.vala"
				_g_object_unref0 (use_source_file);
#line 233 "../src/Exporter.vala"
				_g_object_unref0 (source);
#line 233 "../src/Exporter.vala"
				continue;
#line 1097 "Exporter.c"
			}
#line 236 "../src/Exporter.vala"
			_tmp27_ = self->priv->dir;
#line 236 "../src/Exporter.vala"
			_tmp28_ = _g_object_ref0 (_tmp27_);
#line 236 "../src/Exporter.vala"
			export_dir = _tmp28_;
#line 237 "../src/Exporter.vala"
			dest = NULL;
#line 239 "../src/Exporter.vala"
			_tmp29_ = export_dir;
#line 239 "../src/Exporter.vala"
			if (_tmp29_ == NULL) {
#line 1111 "Exporter.c"
				{
					gboolean collision = FALSE;
					GFile* _tmp30_ = NULL;
					GFile* _tmp31_;
					GFile* _tmp32_;
					const gchar* _tmp33_;
					gboolean _tmp34_ = FALSE;
					GFile* _tmp35_;
					GFile* _tmp36_;
					GFile* _tmp37_;
#line 242 "../src/Exporter.vala"
					_tmp31_ = app_dirs_get_temp_dir ();
#line 242 "../src/Exporter.vala"
					_tmp32_ = _tmp31_;
#line 242 "../src/Exporter.vala"
					_tmp33_ = basename;
#line 242 "../src/Exporter.vala"
					_tmp35_ = generate_unique_file (_tmp32_, _tmp33_, &_tmp34_, &_inner_error0_);
#line 242 "../src/Exporter.vala"
					collision = _tmp34_;
#line 242 "../src/Exporter.vala"
					_tmp36_ = _tmp35_;
#line 242 "../src/Exporter.vala"
					_g_object_unref0 (_tmp32_);
#line 242 "../src/Exporter.vala"
					_tmp30_ = _tmp36_;
#line 242 "../src/Exporter.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1140 "Exporter.c"
						goto __catch0_g_error;
					}
#line 242 "../src/Exporter.vala"
					_tmp37_ = _tmp30_;
#line 242 "../src/Exporter.vala"
					_tmp30_ = NULL;
#line 242 "../src/Exporter.vala"
					_g_object_unref0 (dest);
#line 242 "../src/Exporter.vala"
					dest = _tmp37_;
#line 240 "../src/Exporter.vala"
					_g_object_unref0 (_tmp30_);
#line 1153 "Exporter.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* err = NULL;
					MediaSource* _tmp38_;
					GFile* _tmp39_;
					GFile* _tmp40_;
					gchar* _tmp41_;
					gchar* _tmp42_;
					GError* _tmp43_;
					const gchar* _tmp44_;
					gchar* _tmp45_;
					gchar* _tmp46_;
#line 240 "../src/Exporter.vala"
					err = _inner_error0_;
#line 240 "../src/Exporter.vala"
					_inner_error0_ = NULL;
#line 244 "../src/Exporter.vala"
					_tmp38_ = source;
#line 244 "../src/Exporter.vala"
					_tmp39_ = media_source_get_file (_tmp38_);
#line 244 "../src/Exporter.vala"
					_tmp40_ = _tmp39_;
#line 244 "../src/Exporter.vala"
					_tmp41_ = g_file_get_basename (_tmp40_);
#line 244 "../src/Exporter.vala"
					_tmp42_ = _tmp41_;
#line 244 "../src/Exporter.vala"
					_tmp43_ = err;
#line 244 "../src/Exporter.vala"
					_tmp44_ = _tmp43_->message;
#line 244 "../src/Exporter.vala"
					_tmp45_ = g_strdup_printf (_ ("Unable to generate a temporary file for %s: %s"), _tmp42_, _tmp44_);
#line 244 "../src/Exporter.vala"
					_tmp46_ = _tmp45_;
#line 244 "../src/Exporter.vala"
					app_window_error_message (_tmp46_, NULL, NULL);
#line 244 "../src/Exporter.vala"
					_g_free0 (_tmp46_);
#line 244 "../src/Exporter.vala"
					_g_free0 (_tmp42_);
#line 244 "../src/Exporter.vala"
					_g_object_unref0 (_tmp40_);
#line 247 "../src/Exporter.vala"
					_g_error_free0 (err);
#line 247 "../src/Exporter.vala"
					_g_object_unref0 (dest);
#line 247 "../src/Exporter.vala"
					_g_object_unref0 (export_dir);
#line 247 "../src/Exporter.vala"
					_g_free0 (basename);
#line 247 "../src/Exporter.vala"
					_g_object_unref0 (use_source_file);
#line 247 "../src/Exporter.vala"
					_g_object_unref0 (source);
#line 247 "../src/Exporter.vala"
					break;
#line 1212 "Exporter.c"
				}
				__finally0:
#line 240 "../src/Exporter.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1217 "Exporter.c"
					gboolean _tmp47_ = FALSE;
#line 240 "../src/Exporter.vala"
					_g_object_unref0 (dest);
#line 240 "../src/Exporter.vala"
					_g_object_unref0 (export_dir);
#line 240 "../src/Exporter.vala"
					_g_free0 (basename);
#line 240 "../src/Exporter.vala"
					_g_object_unref0 (use_source_file);
#line 240 "../src/Exporter.vala"
					_g_object_unref0 (source);
#line 240 "../src/Exporter.vala"
					_g_object_unref0 (_source_it);
#line 240 "../src/Exporter.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 240 "../src/Exporter.vala"
					g_clear_error (&_inner_error0_);
#line 240 "../src/Exporter.vala"
					return _tmp47_;
#line 1237 "Exporter.c"
				}
			} else {
				GFile* _tmp48_;
				const gchar* _tmp49_;
				GFile* _tmp50_;
				gboolean _tmp51_ = FALSE;
#line 250 "../src/Exporter.vala"
				_tmp48_ = self->priv->dir;
#line 250 "../src/Exporter.vala"
				_tmp49_ = basename;
#line 250 "../src/Exporter.vala"
				_tmp50_ = g_file_get_child (_tmp48_, _tmp49_);
#line 250 "../src/Exporter.vala"
				_g_object_unref0 (dest);
#line 250 "../src/Exporter.vala"
				dest = _tmp50_;
#line 252 "../src/Exporter.vala"
				if (!self->priv->replace_all) {
#line 1256 "Exporter.c"
					GFile* _tmp52_;
#line 252 "../src/Exporter.vala"
					_tmp52_ = dest;
#line 252 "../src/Exporter.vala"
					_tmp51_ = g_file_query_exists (_tmp52_, NULL);
#line 1262 "Exporter.c"
				} else {
#line 252 "../src/Exporter.vala"
					_tmp51_ = FALSE;
#line 1266 "Exporter.c"
				}
#line 252 "../src/Exporter.vala"
				if (_tmp51_) {
#line 1270 "Exporter.c"
					ExporterOverwriteCallback _tmp53_;
					gpointer _tmp53__target;
					GFile* _tmp54_;
#line 253 "../src/Exporter.vala"
					_tmp53_ = self->priv->overwrite_callback;
#line 253 "../src/Exporter.vala"
					_tmp53__target = self->priv->overwrite_callback_target;
#line 253 "../src/Exporter.vala"
					_tmp54_ = dest;
#line 253 "../src/Exporter.vala"
					switch (_tmp53_ (self, _tmp54_, _tmp53__target)) {
#line 253 "../src/Exporter.vala"
						case EXPORTER_OVERWRITE_YES:
#line 1284 "Exporter.c"
						{
#line 256 "../src/Exporter.vala"
							break;
#line 1288 "Exporter.c"
						}
#line 253 "../src/Exporter.vala"
						case EXPORTER_OVERWRITE_REPLACE_ALL:
#line 1292 "Exporter.c"
						{
#line 259 "../src/Exporter.vala"
							self->priv->replace_all = TRUE;
#line 260 "../src/Exporter.vala"
							break;
#line 1298 "Exporter.c"
						}
#line 253 "../src/Exporter.vala"
						case EXPORTER_OVERWRITE_CANCEL:
#line 1302 "Exporter.c"
						{
							GCancellable* _tmp55_;
#line 263 "../src/Exporter.vala"
							_tmp55_ = self->priv->cancellable;
#line 263 "../src/Exporter.vala"
							g_cancellable_cancel (_tmp55_);
#line 265 "../src/Exporter.vala"
							result = FALSE;
#line 265 "../src/Exporter.vala"
							_g_object_unref0 (dest);
#line 265 "../src/Exporter.vala"
							_g_object_unref0 (export_dir);
#line 265 "../src/Exporter.vala"
							_g_free0 (basename);
#line 265 "../src/Exporter.vala"
							_g_object_unref0 (use_source_file);
#line 265 "../src/Exporter.vala"
							_g_object_unref0 (source);
#line 265 "../src/Exporter.vala"
							_g_object_unref0 (_source_it);
#line 265 "../src/Exporter.vala"
							return result;
#line 1325 "Exporter.c"
						}
						default:
#line 253 "../src/Exporter.vala"
						case EXPORTER_OVERWRITE_NO:
#line 1330 "Exporter.c"
						{
							gint _tmp56_;
							ProgressMonitor _tmp57_;
							gpointer _tmp57__target;
#line 269 "../src/Exporter.vala"
							_tmp56_ = self->priv->completed_count;
#line 269 "../src/Exporter.vala"
							self->priv->completed_count = _tmp56_ + 1;
#line 270 "../src/Exporter.vala"
							_tmp57_ = self->priv->monitor;
#line 270 "../src/Exporter.vala"
							_tmp57__target = self->priv->monitor_target;
#line 270 "../src/Exporter.vala"
							if (_tmp57_ != NULL) {
#line 1345 "Exporter.c"
								ProgressMonitor _tmp58_;
								gpointer _tmp58__target;
								GeeCollection* _tmp59_;
								gint _tmp60_;
								gint _tmp61_;
#line 271 "../src/Exporter.vala"
								_tmp58_ = self->priv->monitor;
#line 271 "../src/Exporter.vala"
								_tmp58__target = self->priv->monitor_target;
#line 271 "../src/Exporter.vala"
								_tmp59_ = self->priv->to_export;
#line 271 "../src/Exporter.vala"
								_tmp60_ = gee_collection_get_size (_tmp59_);
#line 271 "../src/Exporter.vala"
								_tmp61_ = _tmp60_;
#line 271 "../src/Exporter.vala"
								if (!_tmp58_ ((guint64) self->priv->completed_count, (guint64) _tmp61_, TRUE, _tmp58__target)) {
#line 1363 "Exporter.c"
									GCancellable* _tmp62_;
#line 272 "../src/Exporter.vala"
									_tmp62_ = self->priv->cancellable;
#line 272 "../src/Exporter.vala"
									g_cancellable_cancel (_tmp62_);
#line 274 "../src/Exporter.vala"
									result = FALSE;
#line 274 "../src/Exporter.vala"
									_g_object_unref0 (dest);
#line 274 "../src/Exporter.vala"
									_g_object_unref0 (export_dir);
#line 274 "../src/Exporter.vala"
									_g_free0 (basename);
#line 274 "../src/Exporter.vala"
									_g_object_unref0 (use_source_file);
#line 274 "../src/Exporter.vala"
									_g_object_unref0 (source);
#line 274 "../src/Exporter.vala"
									_g_object_unref0 (_source_it);
#line 274 "../src/Exporter.vala"
									return result;
#line 1385 "Exporter.c"
								}
							}
#line 278 "../src/Exporter.vala"
							_g_object_unref0 (dest);
#line 278 "../src/Exporter.vala"
							_g_object_unref0 (export_dir);
#line 278 "../src/Exporter.vala"
							_g_free0 (basename);
#line 278 "../src/Exporter.vala"
							_g_object_unref0 (use_source_file);
#line 278 "../src/Exporter.vala"
							_g_object_unref0 (source);
#line 278 "../src/Exporter.vala"
							continue;
#line 1400 "Exporter.c"
						}
					}
				}
			}
#line 283 "../src/Exporter.vala"
			_tmp63_ = self->priv->workers;
#line 283 "../src/Exporter.vala"
			_tmp64_ = source;
#line 283 "../src/Exporter.vala"
			_tmp65_ = dest;
#line 283 "../src/Exporter.vala"
			_tmp66_ = self->priv->scaling;
#line 283 "../src/Exporter.vala"
			_tmp67_ = self->priv->export_params;
#line 283 "../src/Exporter.vala"
			_tmp68_ = self->priv->cancellable;
#line 283 "../src/Exporter.vala"
			_tmp69_ = self->priv->export_params;
#line 283 "../src/Exporter.vala"
			_tmp70_ = self->priv->export_params;
#line 283 "../src/Exporter.vala"
			_tmp71_ = exporter_export_job_new (self, _tmp64_, _tmp65_, &_tmp66_, &_tmp67_.quality, &real_export_format, _tmp68_, _tmp69_.mode == EXPORT_FORMAT_MODE_UNMODIFIED, _tmp70_.export_metadata);
#line 283 "../src/Exporter.vala"
			_tmp72_ = _tmp71_;
#line 283 "../src/Exporter.vala"
			workers_enqueue (_tmp63_, (BackgroundJob*) _tmp72_);
#line 283 "../src/Exporter.vala"
			_background_job_unref0 (_tmp72_);
#line 285 "../src/Exporter.vala"
			_tmp73_ = submitted;
#line 285 "../src/Exporter.vala"
			submitted = _tmp73_ + 1;
#line 208 "../src/Exporter.vala"
			_g_object_unref0 (dest);
#line 208 "../src/Exporter.vala"
			_g_object_unref0 (export_dir);
#line 208 "../src/Exporter.vala"
			_g_free0 (basename);
#line 208 "../src/Exporter.vala"
			_g_object_unref0 (use_source_file);
#line 208 "../src/Exporter.vala"
			_g_object_unref0 (source);
#line 1443 "Exporter.c"
		}
#line 208 "../src/Exporter.vala"
		_g_object_unref0 (_source_it);
#line 1447 "Exporter.c"
	}
#line 288 "../src/Exporter.vala"
	result = submitted > 0;
#line 288 "../src/Exporter.vala"
	return result;
#line 1453 "Exporter.c"
}

static void
exporter_export_completed (Exporter* self,
                           gboolean is_cancelled)
{
	ExporterCompletionCallback _tmp0_;
	gpointer _tmp0__target;
#line 291 "../src/Exporter.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/Exporter.vala"
	_tmp0_ = self->priv->completion_callback;
#line 292 "../src/Exporter.vala"
	_tmp0__target = self->priv->completion_callback_target;
#line 292 "../src/Exporter.vala"
	_tmp0_ (self, is_cancelled, _tmp0__target);
#line 1470 "Exporter.c"
}

static void
_exporter_on_exported_completion_callback (BackgroundJob* job,
                                           gpointer self)
{
#line 93 "../src/Exporter.vala"
	exporter_on_exported ((Exporter*) self, job);
#line 1479 "Exporter.c"
}

static void
_exporter_on_export_cancelled_cancellation_callback (BackgroundJob* job,
                                                     gpointer self)
{
#line 93 "../src/Exporter.vala"
	exporter_on_export_cancelled ((Exporter*) self, job);
#line 1488 "Exporter.c"
}

static gpointer
_scaling_dup0 (gpointer self)
{
#line 99 "../src/Exporter.vala"
	return self ? scaling_dup (self) : NULL;
#line 1496 "Exporter.c"
}

static JpegQuality*
_jpeg_quality_dup (JpegQuality* self)
{
	JpegQuality* dup;
#line 100 "../src/Exporter.vala"
	dup = g_new0 (JpegQuality, 1);
#line 100 "../src/Exporter.vala"
	memcpy (dup, self, sizeof (JpegQuality));
#line 100 "../src/Exporter.vala"
	return dup;
#line 1509 "Exporter.c"
}

static gpointer
__jpeg_quality_dup0 (gpointer self)
{
#line 100 "../src/Exporter.vala"
	return self ? _jpeg_quality_dup (self) : NULL;
#line 1517 "Exporter.c"
}

static PhotoFileFormat*
_photo_file_format_dup (PhotoFileFormat* self)
{
	PhotoFileFormat* dup;
#line 101 "../src/Exporter.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 101 "../src/Exporter.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 101 "../src/Exporter.vala"
	return dup;
#line 1530 "Exporter.c"
}

static gpointer
__photo_file_format_dup0 (gpointer self)
{
#line 101 "../src/Exporter.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 1538 "Exporter.c"
}

static ExporterExportJob*
exporter_export_job_construct (GType object_type,
                               Exporter* owner,
                               MediaSource* media,
                               GFile* dest,
                               Scaling* scaling,
                               JpegQuality* quality,
                               PhotoFileFormat* format,
                               GCancellable* cancellable,
                               gboolean direct_copy_unmodified,
                               gboolean export_metadata)
{
	ExporterExportJob* self = NULL;
	gboolean _tmp0_ = FALSE;
	MediaSource* _tmp1_;
	GFile* _tmp2_;
	Scaling* _tmp3_;
	JpegQuality* _tmp4_;
	PhotoFileFormat* _tmp5_;
#line 90 "../src/Exporter.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 90 "../src/Exporter.vala"
	g_return_val_if_fail (media != NULL, NULL);
#line 90 "../src/Exporter.vala"
	g_return_val_if_fail (dest != NULL, NULL);
#line 90 "../src/Exporter.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 93 "../src/Exporter.vala"
	self = (ExporterExportJob*) background_job_construct (object_type, (GObject*) owner, _exporter_on_exported_completion_callback, owner, cancellable, _exporter_on_export_cancelled_cancellation_callback, owner, NULL);
#line 95 "../src/Exporter.vala"
	if (IS_PHOTO (media)) {
#line 95 "../src/Exporter.vala"
		_tmp0_ = TRUE;
#line 1574 "Exporter.c"
	} else {
#line 95 "../src/Exporter.vala"
		_tmp0_ = IS_VIDEO (media);
#line 1578 "Exporter.c"
	}
#line 95 "../src/Exporter.vala"
	_vala_assert (_tmp0_, "media is Photo || media is Video");
#line 97 "../src/Exporter.vala"
	_tmp1_ = _g_object_ref0 (media);
#line 97 "../src/Exporter.vala"
	_g_object_unref0 (self->media);
#line 97 "../src/Exporter.vala"
	self->media = _tmp1_;
#line 98 "../src/Exporter.vala"
	_tmp2_ = _g_object_ref0 (dest);
#line 98 "../src/Exporter.vala"
	_g_object_unref0 (self->dest);
#line 98 "../src/Exporter.vala"
	self->dest = _tmp2_;
#line 99 "../src/Exporter.vala"
	_tmp3_ = _scaling_dup0 (scaling);
#line 99 "../src/Exporter.vala"
	_scaling_free0 (self->scaling);
#line 99 "../src/Exporter.vala"
	self->scaling = _tmp3_;
#line 100 "../src/Exporter.vala"
	_tmp4_ = __jpeg_quality_dup0 (quality);
#line 100 "../src/Exporter.vala"
	_g_free0 (self->quality);
#line 100 "../src/Exporter.vala"
	self->quality = _tmp4_;
#line 101 "../src/Exporter.vala"
	_tmp5_ = __photo_file_format_dup0 (format);
#line 101 "../src/Exporter.vala"
	_g_free0 (self->format);
#line 101 "../src/Exporter.vala"
	self->format = _tmp5_;
#line 102 "../src/Exporter.vala"
	self->direct_copy_unmodified = direct_copy_unmodified;
#line 103 "../src/Exporter.vala"
	self->export_metadata = export_metadata;
#line 90 "../src/Exporter.vala"
	return self;
#line 1618 "Exporter.c"
}

static ExporterExportJob*
exporter_export_job_new (Exporter* owner,
                         MediaSource* media,
                         GFile* dest,
                         Scaling* scaling,
                         JpegQuality* quality,
                         PhotoFileFormat* format,
                         GCancellable* cancellable,
                         gboolean direct_copy_unmodified,
                         gboolean export_metadata)
{
#line 90 "../src/Exporter.vala"
	return exporter_export_job_construct (EXPORTER_TYPE_EXPORT_JOB, owner, media, dest, scaling, quality, format, cancellable, direct_copy_unmodified, export_metadata);
#line 1634 "Exporter.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 114 "../src/Exporter.vala"
	return self ? g_error_copy (self) : NULL;
#line 1642 "Exporter.c"
}

static void
exporter_export_job_real_execute (BackgroundJob* base)
{
	ExporterExportJob * self;
	GError* _inner_error0_ = NULL;
#line 106 "../src/Exporter.vala"
	self = (ExporterExportJob*) base;
#line 1652 "Exporter.c"
	{
		MediaSource* _tmp0_;
#line 108 "../src/Exporter.vala"
		_tmp0_ = self->media;
#line 108 "../src/Exporter.vala"
		if (IS_PHOTO (_tmp0_)) {
#line 1659 "Exporter.c"
			MediaSource* _tmp1_;
			GFile* _tmp2_;
			Scaling* _tmp3_;
			JpegQuality* _tmp4_;
			PhotoFileFormat* _tmp5_;
			Scaling _tmp6_;
#line 109 "../src/Exporter.vala"
			_tmp1_ = self->media;
#line 109 "../src/Exporter.vala"
			_tmp2_ = self->dest;
#line 109 "../src/Exporter.vala"
			_tmp3_ = self->scaling;
#line 109 "../src/Exporter.vala"
			_tmp4_ = self->quality;
#line 109 "../src/Exporter.vala"
			_tmp5_ = self->format;
#line 109 "../src/Exporter.vala"
			_tmp6_ = *_tmp3_;
#line 109 "../src/Exporter.vala"
			photo_export (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO, Photo), _tmp2_, &_tmp6_, *_tmp4_, *_tmp5_, self->direct_copy_unmodified, self->export_metadata, &_inner_error0_);
#line 109 "../src/Exporter.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1682 "Exporter.c"
				goto __catch0_g_error;
			}
		} else {
			MediaSource* _tmp7_;
#line 110 "../src/Exporter.vala"
			_tmp7_ = self->media;
#line 110 "../src/Exporter.vala"
			if (IS_VIDEO (_tmp7_)) {
#line 1691 "Exporter.c"
				MediaSource* _tmp8_;
				GFile* _tmp9_;
#line 111 "../src/Exporter.vala"
				_tmp8_ = self->media;
#line 111 "../src/Exporter.vala"
				_tmp9_ = self->dest;
#line 111 "../src/Exporter.vala"
				video_export (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_VIDEO, Video), _tmp9_, &_inner_error0_);
#line 111 "../src/Exporter.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1702 "Exporter.c"
					goto __catch0_g_error;
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp10_;
		GError* _tmp11_;
#line 107 "../src/Exporter.vala"
		err = _inner_error0_;
#line 107 "../src/Exporter.vala"
		_inner_error0_ = NULL;
#line 114 "../src/Exporter.vala"
		_tmp10_ = err;
#line 114 "../src/Exporter.vala"
		_tmp11_ = _g_error_copy0 (_tmp10_);
#line 114 "../src/Exporter.vala"
		_g_error_free0 (self->err);
#line 114 "../src/Exporter.vala"
		self->err = _tmp11_;
#line 107 "../src/Exporter.vala"
		_g_error_free0 (err);
#line 1728 "Exporter.c"
	}
	__finally0:
#line 107 "../src/Exporter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 107 "../src/Exporter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 107 "../src/Exporter.vala"
		g_clear_error (&_inner_error0_);
#line 107 "../src/Exporter.vala"
		return;
#line 1739 "Exporter.c"
	}
}

static void
exporter_export_job_class_init (ExporterExportJobClass * klass,
                                gpointer klass_data)
{
#line 80 "../src/Exporter.vala"
	exporter_export_job_parent_class = g_type_class_peek_parent (klass);
#line 80 "../src/Exporter.vala"
	((BackgroundJobClass *) klass)->finalize = exporter_export_job_finalize;
#line 80 "../src/Exporter.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) exporter_export_job_real_execute;
#line 1753 "Exporter.c"
}

static void
exporter_export_job_instance_init (ExporterExportJob * self,
                                   gpointer klass)
{
#line 86 "../src/Exporter.vala"
	self->err = NULL;
#line 87 "../src/Exporter.vala"
	self->direct_copy_unmodified = FALSE;
#line 88 "../src/Exporter.vala"
	self->export_metadata = TRUE;
#line 1766 "Exporter.c"
}

static void
exporter_export_job_finalize (BackgroundJob * obj)
{
	ExporterExportJob * self;
#line 80 "../src/Exporter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EXPORTER_TYPE_EXPORT_JOB, ExporterExportJob);
#line 81 "../src/Exporter.vala"
	_g_object_unref0 (self->media);
#line 82 "../src/Exporter.vala"
	_g_object_unref0 (self->dest);
#line 83 "../src/Exporter.vala"
	_scaling_free0 (self->scaling);
#line 84 "../src/Exporter.vala"
	_g_free0 (self->quality);
#line 85 "../src/Exporter.vala"
	_g_free0 (self->format);
#line 86 "../src/Exporter.vala"
	_g_error_free0 (self->err);
#line 80 "../src/Exporter.vala"
	BACKGROUND_JOB_CLASS (exporter_export_job_parent_class)->finalize (obj);
#line 1789 "Exporter.c"
}

static GType
exporter_export_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExporterExportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) exporter_export_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExporterExportJob), 0, (GInstanceInitFunc) exporter_export_job_instance_init, NULL };
	GType exporter_export_job_type_id;
	exporter_export_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "ExporterExportJob", &g_define_type_info, 0);
	return exporter_export_job_type_id;
}

static GType
exporter_export_job_get_type (void)
{
	static volatile gsize exporter_export_job_type_id__once = 0;
	if (g_once_init_enter (&exporter_export_job_type_id__once)) {
		GType exporter_export_job_type_id;
		exporter_export_job_type_id = exporter_export_job_get_type_once ();
		g_once_init_leave (&exporter_export_job_type_id__once, exporter_export_job_type_id);
	}
	return exporter_export_job_type_id__once;
}

static void
exporter_class_init (ExporterClass * klass,
                     gpointer klass_data)
{
#line 65 "../src/Exporter.vala"
	exporter_parent_class = g_type_class_peek_parent (klass);
#line 65 "../src/Exporter.vala"
	g_type_class_adjust_private_offset (klass, &Exporter_private_offset);
#line 65 "../src/Exporter.vala"
	G_OBJECT_CLASS (klass)->finalize = exporter_finalize;
#line 1823 "Exporter.c"
}

static void
exporter_instance_init (Exporter * self,
                        gpointer klass)
{
	GeeArrayList* _tmp0_;
	Workers* _tmp1_;
#line 65 "../src/Exporter.vala"
	self->priv = exporter_get_instance_private (self);
#line 119 "../src/Exporter.vala"
	_tmp0_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 119 "../src/Exporter.vala"
	self->priv->to_export = (GeeCollection*) _tmp0_;
#line 123 "../src/Exporter.vala"
	self->priv->completed_count = 0;
#line 124 "../src/Exporter.vala"
	_tmp1_ = workers_new (workers_threads_per_cpu (1, 4), FALSE);
#line 124 "../src/Exporter.vala"
	self->priv->workers = _tmp1_;
#line 125 "../src/Exporter.vala"
	self->priv->completion_callback = NULL;
#line 125 "../src/Exporter.vala"
	self->priv->completion_callback_target = NULL;
#line 126 "../src/Exporter.vala"
	self->priv->error_callback = NULL;
#line 126 "../src/Exporter.vala"
	self->priv->error_callback_target = NULL;
#line 127 "../src/Exporter.vala"
	self->priv->overwrite_callback = NULL;
#line 127 "../src/Exporter.vala"
	self->priv->overwrite_callback_target = NULL;
#line 128 "../src/Exporter.vala"
	self->priv->monitor = NULL;
#line 128 "../src/Exporter.vala"
	self->priv->monitor_target = NULL;
#line 130 "../src/Exporter.vala"
	self->priv->replace_all = FALSE;
#line 131 "../src/Exporter.vala"
	self->priv->aborted = FALSE;
#line 1864 "Exporter.c"
}

static void
exporter_finalize (GObject * obj)
{
	Exporter * self;
#line 65 "../src/Exporter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORTER, Exporter);
#line 119 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->to_export);
#line 120 "../src/Exporter.vala"
	self->priv->exported_files = (_vala_array_free (self->priv->exported_files, self->priv->exported_files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 121 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->dir);
#line 124 "../src/Exporter.vala"
	_workers_unref0 (self->priv->workers);
#line 129 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 65 "../src/Exporter.vala"
	G_OBJECT_CLASS (exporter_parent_class)->finalize (obj);
#line 1885 "Exporter.c"
}

static GType
exporter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExporterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) exporter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Exporter), 0, (GInstanceInitFunc) exporter_instance_init, NULL };
	GType exporter_type_id;
	exporter_type_id = g_type_register_static (G_TYPE_OBJECT, "Exporter", &g_define_type_info, 0);
	Exporter_private_offset = g_type_add_instance_private (exporter_type_id, sizeof (ExporterPrivate));
	return exporter_type_id;
}

GType
exporter_get_type (void)
{
	static volatile gsize exporter_type_id__once = 0;
	if (g_once_init_enter (&exporter_type_id__once)) {
		GType exporter_type_id;
		exporter_type_id = exporter_get_type_once ();
		g_once_init_leave (&exporter_type_id__once, exporter_type_id);
	}
	return exporter_type_id__once;
}

static inline gpointer
exporter_ui_get_instance_private (ExporterUI* self)
{
	return G_STRUCT_MEMBER_P (self, ExporterUI_private_offset);
}

ExporterUI*
exporter_ui_construct (GType object_type,
                       Exporter* exporter)
{
	ExporterUI* self = NULL;
	Exporter* _tmp0_;
#line 302 "../src/Exporter.vala"
	g_return_val_if_fail (exporter != NULL, NULL);
#line 302 "../src/Exporter.vala"
	self = (ExporterUI*) g_type_create_instance (object_type);
#line 303 "../src/Exporter.vala"
	_tmp0_ = _g_object_ref0 (exporter);
#line 303 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->exporter);
#line 303 "../src/Exporter.vala"
	self->priv->exporter = _tmp0_;
#line 302 "../src/Exporter.vala"
	return self;
#line 1934 "Exporter.c"
}

ExporterUI*
exporter_ui_new (Exporter* exporter)
{
#line 302 "../src/Exporter.vala"
	return exporter_ui_construct (TYPE_EXPORTER_UI, exporter);
#line 1942 "Exporter.c"
}

static void
_exporter_ui_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                               gboolean is_cancelled,
                                                               gpointer self)
{
#line 312 "../src/Exporter.vala"
	exporter_ui_on_export_completed ((ExporterUI*) self, exporter, is_cancelled);
#line 1952 "Exporter.c"
}

static gboolean
_exporter_ui_on_export_failed_exporter_export_failed_callback (Exporter* exporter,
                                                               GFile* file,
                                                               gint remaining,
                                                               GError* err,
                                                               gpointer self)
{
	gboolean result;
	result = exporter_ui_on_export_failed ((ExporterUI*) self, exporter, file, remaining, err);
#line 312 "../src/Exporter.vala"
	return result;
#line 1966 "Exporter.c"
}

static ExporterOverwrite
_exporter_ui_on_export_overwrite_exporter_overwrite_callback (Exporter* exporter,
                                                              GFile* file,
                                                              gpointer self)
{
	ExporterOverwrite result;
	result = exporter_ui_on_export_overwrite ((ExporterUI*) self, exporter, file);
#line 312 "../src/Exporter.vala"
	return result;
#line 1978 "Exporter.c"
}

static gboolean
_progress_dialog_monitor_progress_monitor (guint64 current,
                                           guint64 total,
                                           gboolean do_event_loop,
                                           gpointer self)
{
	gboolean result;
	result = progress_dialog_monitor ((ProgressDialog*) self, current, total, do_event_loop);
#line 312 "../src/Exporter.vala"
	return result;
#line 1991 "Exporter.c"
}

void
exporter_ui_export (ExporterUI* self,
                    ExporterCompletionCallback completion_callback,
                    gpointer completion_callback_target)
{
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	AppWindow* _tmp2_;
	AppWindow* _tmp3_;
	GCancellable* _tmp4_;
	ProgressDialog* _tmp5_;
	Exporter* _tmp6_;
	GCancellable* _tmp7_;
	ProgressDialog* _tmp8_;
#line 306 "../src/Exporter.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/Exporter.vala"
	self->priv->completion_callback = completion_callback;
#line 307 "../src/Exporter.vala"
	self->priv->completion_callback_target = completion_callback_target;
#line 309 "../src/Exporter.vala"
	_tmp0_ = app_window_get_instance ();
#line 309 "../src/Exporter.vala"
	_tmp1_ = _tmp0_;
#line 309 "../src/Exporter.vala"
	page_window_set_busy_cursor ((PageWindow*) _tmp1_);
#line 309 "../src/Exporter.vala"
	_g_object_unref0 (_tmp1_);
#line 311 "../src/Exporter.vala"
	_tmp2_ = app_window_get_instance ();
#line 311 "../src/Exporter.vala"
	_tmp3_ = _tmp2_;
#line 311 "../src/Exporter.vala"
	_tmp4_ = self->priv->cancellable;
#line 311 "../src/Exporter.vala"
	_tmp5_ = progress_dialog_new ((GtkWindow*) _tmp3_, _ ("Exporting"), _tmp4_);
#line 311 "../src/Exporter.vala"
	g_object_ref_sink (_tmp5_);
#line 311 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->progress_dialog);
#line 311 "../src/Exporter.vala"
	self->priv->progress_dialog = _tmp5_;
#line 311 "../src/Exporter.vala"
	_g_object_unref0 (_tmp3_);
#line 312 "../src/Exporter.vala"
	_tmp6_ = self->priv->exporter;
#line 312 "../src/Exporter.vala"
	_tmp7_ = self->priv->cancellable;
#line 312 "../src/Exporter.vala"
	_tmp8_ = self->priv->progress_dialog;
#line 312 "../src/Exporter.vala"
	exporter_export (_tmp6_, _exporter_ui_on_export_completed_exporter_completion_callback, self, _exporter_ui_on_export_failed_exporter_export_failed_callback, self, _exporter_ui_on_export_overwrite_exporter_overwrite_callback, self, _tmp7_, _progress_dialog_monitor_progress_monitor, _tmp8_);
#line 2046 "Exporter.c"
}

static void
exporter_ui_on_export_completed (ExporterUI* self,
                                 Exporter* exporter,
                                 gboolean is_cancelled)
{
	ProgressDialog* _tmp0_;
	AppWindow* _tmp2_;
	AppWindow* _tmp3_;
	ExporterCompletionCallback _tmp4_;
	gpointer _tmp4__target;
#line 316 "../src/Exporter.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/Exporter.vala"
	g_return_if_fail (exporter != NULL);
#line 317 "../src/Exporter.vala"
	_tmp0_ = self->priv->progress_dialog;
#line 317 "../src/Exporter.vala"
	if (_tmp0_ != NULL) {
#line 2067 "Exporter.c"
		ProgressDialog* _tmp1_;
#line 318 "../src/Exporter.vala"
		_tmp1_ = self->priv->progress_dialog;
#line 318 "../src/Exporter.vala"
		progress_dialog_close (_tmp1_);
#line 319 "../src/Exporter.vala"
		_g_object_unref0 (self->priv->progress_dialog);
#line 319 "../src/Exporter.vala"
		self->priv->progress_dialog = NULL;
#line 2077 "Exporter.c"
	}
#line 322 "../src/Exporter.vala"
	_tmp2_ = app_window_get_instance ();
#line 322 "../src/Exporter.vala"
	_tmp3_ = _tmp2_;
#line 322 "../src/Exporter.vala"
	page_window_set_normal_cursor ((PageWindow*) _tmp3_);
#line 322 "../src/Exporter.vala"
	_g_object_unref0 (_tmp3_);
#line 324 "../src/Exporter.vala"
	_tmp4_ = self->priv->completion_callback;
#line 324 "../src/Exporter.vala"
	_tmp4__target = self->priv->completion_callback_target;
#line 324 "../src/Exporter.vala"
	_tmp4_ (exporter, is_cancelled, _tmp4__target);
#line 2093 "Exporter.c"
}

static ExporterOverwrite
exporter_ui_on_export_overwrite (ExporterUI* self,
                                 Exporter* exporter,
                                 GFile* file)
{
	ProgressDialog* _tmp0_;
	GraniteMessageDialog* dialog = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GraniteMessageDialog* _tmp5_;
	GraniteMessageDialog* _tmp6_;
	GraniteMessageDialog* _tmp7_;
	AppWindow* _tmp8_;
	AppWindow* _tmp9_;
	GraniteMessageDialog* _tmp10_;
	GtkButton* replace_button = NULL;
	GraniteMessageDialog* _tmp11_;
	GtkWidget* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	gint response = 0;
	GraniteMessageDialog* _tmp16_;
	GraniteMessageDialog* _tmp17_;
	ProgressDialog* _tmp18_;
	ExporterOverwrite result;
#line 327 "../src/Exporter.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 327 "../src/Exporter.vala"
	g_return_val_if_fail (exporter != NULL, 0);
#line 327 "../src/Exporter.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 328 "../src/Exporter.vala"
	_tmp0_ = self->priv->progress_dialog;
#line 328 "../src/Exporter.vala"
	gtk_window_set_modal ((GtkWindow*) _tmp0_, FALSE);
#line 330 "../src/Exporter.vala"
	_tmp1_ = g_file_get_basename (file);
#line 330 "../src/Exporter.vala"
	_tmp2_ = _tmp1_;
#line 330 "../src/Exporter.vala"
	_tmp3_ = g_strdup_printf (_ ("File %s already exists. Replace?"), _tmp2_);
#line 330 "../src/Exporter.vala"
	_tmp4_ = _tmp3_;
#line 330 "../src/Exporter.vala"
	_tmp5_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Export"), _tmp4_, "dialog-question", GTK_BUTTONS_NONE);
#line 330 "../src/Exporter.vala"
	g_object_ref_sink (_tmp5_);
#line 330 "../src/Exporter.vala"
	_tmp6_ = _tmp5_;
#line 330 "../src/Exporter.vala"
	_g_free0 (_tmp4_);
#line 330 "../src/Exporter.vala"
	_g_free0 (_tmp2_);
#line 330 "../src/Exporter.vala"
	dialog = _tmp6_;
#line 336 "../src/Exporter.vala"
	_tmp7_ = dialog;
#line 336 "../src/Exporter.vala"
	_tmp8_ = app_window_get_instance ();
#line 336 "../src/Exporter.vala"
	_tmp9_ = _tmp8_;
#line 336 "../src/Exporter.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp7_, (GtkWindow*) _tmp9_);
#line 336 "../src/Exporter.vala"
	_g_object_unref0 (_tmp9_);
#line 337 "../src/Exporter.vala"
	_tmp10_ = dialog;
#line 337 "../src/Exporter.vala"
	gtk_dialog_add_buttons ((GtkDialog*) _tmp10_, _ ("_Skip"), GTK_RESPONSE_NO, _ ("Replace _All"), GTK_RESPONSE_APPLY, _ ("_Cancel"), GTK_RESPONSE_CANCEL, NULL);
#line 342 "../src/Exporter.vala"
	_tmp11_ = dialog;
#line 342 "../src/Exporter.vala"
	_tmp12_ = gtk_dialog_add_button ((GtkDialog*) _tmp11_, _ ("_Replace"), (gint) GTK_RESPONSE_YES);
#line 342 "../src/Exporter.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_button_get_type (), GtkButton));
#line 342 "../src/Exporter.vala"
	replace_button = _tmp13_;
#line 343 "../src/Exporter.vala"
	_tmp14_ = replace_button;
#line 343 "../src/Exporter.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 343 "../src/Exporter.vala"
	gtk_style_context_add_class (_tmp15_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 345 "../src/Exporter.vala"
	_tmp16_ = dialog;
#line 345 "../src/Exporter.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp16_);
#line 346 "../src/Exporter.vala"
	_tmp17_ = dialog;
#line 346 "../src/Exporter.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp17_);
#line 348 "../src/Exporter.vala"
	_tmp18_ = self->priv->progress_dialog;
#line 348 "../src/Exporter.vala"
	gtk_window_set_modal ((GtkWindow*) _tmp18_, TRUE);
#line 350 "../src/Exporter.vala"
	switch (response) {
#line 350 "../src/Exporter.vala"
		case GTK_RESPONSE_APPLY:
#line 2198 "Exporter.c"
		{
#line 352 "../src/Exporter.vala"
			result = EXPORTER_OVERWRITE_REPLACE_ALL;
#line 352 "../src/Exporter.vala"
			_g_object_unref0 (replace_button);
#line 352 "../src/Exporter.vala"
			_g_object_unref0 (dialog);
#line 352 "../src/Exporter.vala"
			return result;
#line 2208 "Exporter.c"
		}
#line 350 "../src/Exporter.vala"
		case GTK_RESPONSE_YES:
#line 2212 "Exporter.c"
		{
#line 355 "../src/Exporter.vala"
			result = EXPORTER_OVERWRITE_YES;
#line 355 "../src/Exporter.vala"
			_g_object_unref0 (replace_button);
#line 355 "../src/Exporter.vala"
			_g_object_unref0 (dialog);
#line 355 "../src/Exporter.vala"
			return result;
#line 2222 "Exporter.c"
		}
#line 350 "../src/Exporter.vala"
		case GTK_RESPONSE_CANCEL:
#line 2226 "Exporter.c"
		{
#line 358 "../src/Exporter.vala"
			result = EXPORTER_OVERWRITE_CANCEL;
#line 358 "../src/Exporter.vala"
			_g_object_unref0 (replace_button);
#line 358 "../src/Exporter.vala"
			_g_object_unref0 (dialog);
#line 358 "../src/Exporter.vala"
			return result;
#line 2236 "Exporter.c"
		}
		default:
#line 350 "../src/Exporter.vala"
		case GTK_RESPONSE_NO:
#line 2241 "Exporter.c"
		{
#line 362 "../src/Exporter.vala"
			result = EXPORTER_OVERWRITE_NO;
#line 362 "../src/Exporter.vala"
			_g_object_unref0 (replace_button);
#line 362 "../src/Exporter.vala"
			_g_object_unref0 (dialog);
#line 362 "../src/Exporter.vala"
			return result;
#line 2251 "Exporter.c"
		}
	}
}

static gboolean
exporter_ui_on_export_failed (ExporterUI* self,
                              Exporter* exporter,
                              GFile* file,
                              gint remaining,
                              GError* err)
{
	gboolean result;
#line 366 "../src/Exporter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 366 "../src/Exporter.vala"
	g_return_val_if_fail (exporter != NULL, FALSE);
#line 366 "../src/Exporter.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 366 "../src/Exporter.vala"
	g_return_val_if_fail (err != NULL, FALSE);
#line 367 "../src/Exporter.vala"
	result = export_error_dialog (file, remaining > 0) != GTK_RESPONSE_CANCEL;
#line 367 "../src/Exporter.vala"
	return result;
#line 2276 "Exporter.c"
}

static void
value_exporter_ui_init (GValue* value)
{
#line 296 "../src/Exporter.vala"
	value->data[0].v_pointer = NULL;
#line 2284 "Exporter.c"
}

static void
value_exporter_ui_free_value (GValue* value)
{
#line 296 "../src/Exporter.vala"
	if (value->data[0].v_pointer) {
#line 296 "../src/Exporter.vala"
		exporter_ui_unref (value->data[0].v_pointer);
#line 2294 "Exporter.c"
	}
}

static void
value_exporter_ui_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 296 "../src/Exporter.vala"
	if (src_value->data[0].v_pointer) {
#line 296 "../src/Exporter.vala"
		dest_value->data[0].v_pointer = exporter_ui_ref (src_value->data[0].v_pointer);
#line 2306 "Exporter.c"
	} else {
#line 296 "../src/Exporter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2310 "Exporter.c"
	}
}

static gpointer
value_exporter_ui_peek_pointer (const GValue* value)
{
#line 296 "../src/Exporter.vala"
	return value->data[0].v_pointer;
#line 2319 "Exporter.c"
}

static gchar*
value_exporter_ui_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 296 "../src/Exporter.vala"
	if (collect_values[0].v_pointer) {
#line 2330 "Exporter.c"
		ExporterUI * object;
		object = collect_values[0].v_pointer;
#line 296 "../src/Exporter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 296 "../src/Exporter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2337 "Exporter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 296 "../src/Exporter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2341 "Exporter.c"
		}
#line 296 "../src/Exporter.vala"
		value->data[0].v_pointer = exporter_ui_ref (object);
#line 2345 "Exporter.c"
	} else {
#line 296 "../src/Exporter.vala"
		value->data[0].v_pointer = NULL;
#line 2349 "Exporter.c"
	}
#line 296 "../src/Exporter.vala"
	return NULL;
#line 2353 "Exporter.c"
}

static gchar*
value_exporter_ui_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	ExporterUI ** object_p;
	object_p = collect_values[0].v_pointer;
#line 296 "../src/Exporter.vala"
	if (!object_p) {
#line 296 "../src/Exporter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2368 "Exporter.c"
	}
#line 296 "../src/Exporter.vala"
	if (!value->data[0].v_pointer) {
#line 296 "../src/Exporter.vala"
		*object_p = NULL;
#line 2374 "Exporter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 296 "../src/Exporter.vala"
		*object_p = value->data[0].v_pointer;
#line 2378 "Exporter.c"
	} else {
#line 296 "../src/Exporter.vala"
		*object_p = exporter_ui_ref (value->data[0].v_pointer);
#line 2382 "Exporter.c"
	}
#line 296 "../src/Exporter.vala"
	return NULL;
#line 2386 "Exporter.c"
}

GParamSpec*
param_spec_exporter_ui (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecExporterUI* spec;
#line 296 "../src/Exporter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_EXPORTER_UI), NULL);
#line 296 "../src/Exporter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 296 "../src/Exporter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 296 "../src/Exporter.vala"
	return G_PARAM_SPEC (spec);
#line 2405 "Exporter.c"
}

gpointer
value_get_exporter_ui (const GValue* value)
{
#line 296 "../src/Exporter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EXPORTER_UI), NULL);
#line 296 "../src/Exporter.vala"
	return value->data[0].v_pointer;
#line 2415 "Exporter.c"
}

void
value_set_exporter_ui (GValue* value,
                       gpointer v_object)
{
	ExporterUI * old;
#line 296 "../src/Exporter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EXPORTER_UI));
#line 296 "../src/Exporter.vala"
	old = value->data[0].v_pointer;
#line 296 "../src/Exporter.vala"
	if (v_object) {
#line 296 "../src/Exporter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_EXPORTER_UI));
#line 296 "../src/Exporter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 296 "../src/Exporter.vala"
		value->data[0].v_pointer = v_object;
#line 296 "../src/Exporter.vala"
		exporter_ui_ref (value->data[0].v_pointer);
#line 2437 "Exporter.c"
	} else {
#line 296 "../src/Exporter.vala"
		value->data[0].v_pointer = NULL;
#line 2441 "Exporter.c"
	}
#line 296 "../src/Exporter.vala"
	if (old) {
#line 296 "../src/Exporter.vala"
		exporter_ui_unref (old);
#line 2447 "Exporter.c"
	}
}

void
value_take_exporter_ui (GValue* value,
                        gpointer v_object)
{
	ExporterUI * old;
#line 296 "../src/Exporter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EXPORTER_UI));
#line 296 "../src/Exporter.vala"
	old = value->data[0].v_pointer;
#line 296 "../src/Exporter.vala"
	if (v_object) {
#line 296 "../src/Exporter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_EXPORTER_UI));
#line 296 "../src/Exporter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 296 "../src/Exporter.vala"
		value->data[0].v_pointer = v_object;
#line 2468 "Exporter.c"
	} else {
#line 296 "../src/Exporter.vala"
		value->data[0].v_pointer = NULL;
#line 2472 "Exporter.c"
	}
#line 296 "../src/Exporter.vala"
	if (old) {
#line 296 "../src/Exporter.vala"
		exporter_ui_unref (old);
#line 2478 "Exporter.c"
	}
}

static void
exporter_ui_class_init (ExporterUIClass * klass,
                        gpointer klass_data)
{
#line 296 "../src/Exporter.vala"
	exporter_ui_parent_class = g_type_class_peek_parent (klass);
#line 296 "../src/Exporter.vala"
	((ExporterUIClass *) klass)->finalize = exporter_ui_finalize;
#line 296 "../src/Exporter.vala"
	g_type_class_adjust_private_offset (klass, &ExporterUI_private_offset);
#line 2492 "Exporter.c"
}

static void
exporter_ui_instance_init (ExporterUI * self,
                           gpointer klass)
{
	GCancellable* _tmp0_;
#line 296 "../src/Exporter.vala"
	self->priv = exporter_ui_get_instance_private (self);
#line 298 "../src/Exporter.vala"
	_tmp0_ = g_cancellable_new ();
#line 298 "../src/Exporter.vala"
	self->priv->cancellable = _tmp0_;
#line 299 "../src/Exporter.vala"
	self->priv->progress_dialog = NULL;
#line 300 "../src/Exporter.vala"
	self->priv->completion_callback = NULL;
#line 300 "../src/Exporter.vala"
	self->priv->completion_callback_target = NULL;
#line 296 "../src/Exporter.vala"
	self->ref_count = 1;
#line 2514 "Exporter.c"
}

static void
exporter_ui_finalize (ExporterUI * obj)
{
	ExporterUI * self;
#line 296 "../src/Exporter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORTER_UI, ExporterUI);
#line 296 "../src/Exporter.vala"
	g_signal_handlers_destroy (self);
#line 297 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->exporter);
#line 298 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 299 "../src/Exporter.vala"
	_g_object_unref0 (self->priv->progress_dialog);
#line 2531 "Exporter.c"
}

static GType
exporter_ui_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_exporter_ui_init, value_exporter_ui_free_value, value_exporter_ui_copy_value, value_exporter_ui_peek_pointer, "p", value_exporter_ui_collect_value, "p", value_exporter_ui_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ExporterUIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) exporter_ui_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExporterUI), 0, (GInstanceInitFunc) exporter_ui_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType exporter_ui_type_id;
	exporter_ui_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ExporterUI", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ExporterUI_private_offset = g_type_add_instance_private (exporter_ui_type_id, sizeof (ExporterUIPrivate));
	return exporter_ui_type_id;
}

GType
exporter_ui_get_type (void)
{
	static volatile gsize exporter_ui_type_id__once = 0;
	if (g_once_init_enter (&exporter_ui_type_id__once)) {
		GType exporter_ui_type_id;
		exporter_ui_type_id = exporter_ui_get_type_once ();
		g_once_init_leave (&exporter_ui_type_id__once, exporter_ui_type_id);
	}
	return exporter_ui_type_id__once;
}

gpointer
exporter_ui_ref (gpointer instance)
{
	ExporterUI * self;
	self = instance;
#line 296 "../src/Exporter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 296 "../src/Exporter.vala"
	return instance;
#line 2567 "Exporter.c"
}

void
exporter_ui_unref (gpointer instance)
{
	ExporterUI * self;
	self = instance;
#line 296 "../src/Exporter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 296 "../src/Exporter.vala"
		EXPORTER_UI_GET_CLASS (self)->finalize (self);
#line 296 "../src/Exporter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2581 "Exporter.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

