/* FullScreenWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from FullScreenWindow.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io)
*               2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FULLSCREEN_WINDOW_0_PROPERTY,
	FULLSCREEN_WINDOW_AUTO_DISMISS_TOOLBAR_PROPERTY,
	FULLSCREEN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* fullscreen_window_properties[FULLSCREEN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_SLIDESHOW_PAGE (slideshow_page_get_type ())
#define SLIDESHOW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SLIDESHOW_PAGE, SlideshowPage))
#define SLIDESHOW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SLIDESHOW_PAGE, SlideshowPageClass))
#define IS_SLIDESHOW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SLIDESHOW_PAGE))
#define IS_SLIDESHOW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SLIDESHOW_PAGE))
#define SLIDESHOW_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SLIDESHOW_PAGE, SlideshowPageClass))

typedef struct _SlideshowPage SlideshowPage;
typedef struct _SlideshowPageClass SlideshowPageClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FullscreenWindowPrivate {
	GtkRevealer* revealer;
	GtkActionBar* toolbar;
	GtkToggleButton* pin_button;
	gint64 left_toolbar_time;
	gboolean switched_to;
	gboolean _auto_dismiss_toolbar;
};

static gint FullscreenWindow_private_offset;
static gpointer fullscreen_window_parent_class = NULL;

static void fullscreen_window_get_monitor_geometry (FullscreenWindow* self,
                                             GdkRectangle* result);
static void fullscreen_window_on_close (FullscreenWindow* self);
static void _fullscreen_window_on_close_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
VALA_EXTERN GType slideshow_page_get_type (void) G_GNUC_CONST ;
static void fullscreen_window_hide_toolbar (FullscreenWindow* self);
static void _fullscreen_window_hide_toolbar_slideshow_page_hide_toolbar (SlideshowPage* _sender,
                                                                  gpointer self);
static void fullscreen_window_invoke_toolbar (FullscreenWindow* self);
static gboolean fullscreen_window_real_configure_event (GtkWidget* base,
                                                 GdkEventConfigure* event);
static gboolean fullscreen_window_real_key_press_event (GtkWidget* base,
                                                 GdkEventKey* event);
static void fullscreen_window_real_destroy (GtkWidget* base);
static gboolean fullscreen_window_real_delete_event (GtkWidget* base,
                                              GdkEventAny* event);
static gboolean fullscreen_window_real_motion_notify_event (GtkWidget* base,
                                                     GdkEventMotion* event);
static gboolean fullscreen_window_is_pointer_in_toolbar (FullscreenWindow* self);
static gboolean fullscreen_window_on_check_toolbar_dismissal (FullscreenWindow* self);
static gboolean _fullscreen_window_on_check_toolbar_dismissal_gsource_func (gpointer self);
static void fullscreen_window_finalize (GObject * obj);
static GType fullscreen_window_get_type_once (void);
static void _vala_fullscreen_window_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_fullscreen_window_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
fullscreen_window_get_instance_private (FullscreenWindow* self)
{
	return G_STRUCT_MEMBER_P (self, FullscreenWindow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/FullScreenWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 123 "FullScreenWindow.c"
}

static void
_fullscreen_window_on_close_gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 57 "../src/FullScreenWindow.vala"
	fullscreen_window_on_close ((FullscreenWindow*) self);
#line 132 "FullScreenWindow.c"
}

static void
_fullscreen_window_hide_toolbar_slideshow_page_hide_toolbar (SlideshowPage* _sender,
                                                             gpointer self)
{
#line 66 "../src/FullScreenWindow.vala"
	fullscreen_window_hide_toolbar ((FullscreenWindow*) self);
#line 141 "FullScreenWindow.c"
}

FullscreenWindow*
fullscreen_window_construct (GType object_type,
                             Page* page)
{
	FullscreenWindow * self = NULL;
	GtkUIManager* _tmp0_;
	GtkAccelGroup* accel_group = NULL;
	GtkUIManager* _tmp1_;
	GtkAccelGroup* _tmp2_;
	GtkAccelGroup* _tmp3_;
	GtkAccelGroup* _tmp4_;
	AppWindow* _tmp6_;
	AppWindow* _tmp7_;
	GdkScreen* _tmp8_;
	GdkRectangle monitor = {0};
	GdkRectangle _tmp9_ = {0};
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GtkToggleButton* _tmp12_;
	GtkToggleButton* _tmp13_;
	GtkImage* _tmp14_;
	GtkImage* _tmp15_;
	GtkToggleButton* _tmp16_;
	GtkToggleButton* _tmp17_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkActionBar* _tmp21_;
	GtkActionBar* _tmp22_;
	GtkActionBar* _tmp23_;
	GtkActionBar* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkActionBar* _tmp28_;
	GtkButton* _tmp29_;
	GtkRevealer* _tmp30_;
	GtkRevealer* _tmp31_;
	GtkRevealer* _tmp32_;
	GtkRevealer* _tmp33_;
	GtkRevealer* _tmp34_;
	GtkActionBar* _tmp35_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp36_;
	GtkRevealer* _tmp37_;
	GdkRectangle _tmp38_;
	GdkRectangle _tmp39_;
#line 33 "../src/FullScreenWindow.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 33 "../src/FullScreenWindow.vala"
	self = (FullscreenWindow*) page_window_construct (object_type);
#line 34 "../src/FullScreenWindow.vala"
	page_window_set_current_page ((PageWindow*) self, page);
#line 36 "../src/FullScreenWindow.vala"
	_tmp0_ = ((PageWindow*) self)->ui;
#line 36 "../src/FullScreenWindow.vala"
	gtk_ui_manager_ensure_update (_tmp0_);
#line 38 "../src/FullScreenWindow.vala"
	_tmp1_ = ((PageWindow*) self)->ui;
#line 38 "../src/FullScreenWindow.vala"
	_tmp2_ = gtk_ui_manager_get_accel_group (_tmp1_);
#line 38 "../src/FullScreenWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 38 "../src/FullScreenWindow.vala"
	accel_group = _tmp3_;
#line 39 "../src/FullScreenWindow.vala"
	_tmp4_ = accel_group;
#line 39 "../src/FullScreenWindow.vala"
	if (_tmp4_ != NULL) {
#line 212 "FullScreenWindow.c"
		GtkAccelGroup* _tmp5_;
#line 40 "../src/FullScreenWindow.vala"
		_tmp5_ = accel_group;
#line 40 "../src/FullScreenWindow.vala"
		gtk_window_add_accel_group ((GtkWindow*) self, _tmp5_);
#line 218 "FullScreenWindow.c"
	}
#line 42 "../src/FullScreenWindow.vala"
	_tmp6_ = app_window_get_instance ();
#line 42 "../src/FullScreenWindow.vala"
	_tmp7_ = _tmp6_;
#line 42 "../src/FullScreenWindow.vala"
	_tmp8_ = gtk_window_get_screen ((GtkWindow*) _tmp7_);
#line 42 "../src/FullScreenWindow.vala"
	gtk_window_set_screen ((GtkWindow*) self, _tmp8_);
#line 42 "../src/FullScreenWindow.vala"
	_g_object_unref0 (_tmp7_);
#line 45 "../src/FullScreenWindow.vala"
	fullscreen_window_get_monitor_geometry (self, &_tmp9_);
#line 45 "../src/FullScreenWindow.vala"
	monitor = _tmp9_;
#line 46 "../src/FullScreenWindow.vala"
	_tmp10_ = monitor;
#line 46 "../src/FullScreenWindow.vala"
	_tmp11_ = monitor;
#line 46 "../src/FullScreenWindow.vala"
	gtk_window_move ((GtkWindow*) self, _tmp10_.x, _tmp11_.y);
#line 48 "../src/FullScreenWindow.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 0);
#line 50 "../src/FullScreenWindow.vala"
	_tmp12_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 50 "../src/FullScreenWindow.vala"
	g_object_ref_sink (_tmp12_);
#line 50 "../src/FullScreenWindow.vala"
	_g_object_unref0 (self->priv->pin_button);
#line 50 "../src/FullScreenWindow.vala"
	self->priv->pin_button = _tmp12_;
#line 51 "../src/FullScreenWindow.vala"
	_tmp13_ = self->priv->pin_button;
#line 51 "../src/FullScreenWindow.vala"
	_tmp14_ = (GtkImage*) gtk_image_new_from_icon_name ("view-pin-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 51 "../src/FullScreenWindow.vala"
	g_object_ref_sink (_tmp14_);
#line 51 "../src/FullScreenWindow.vala"
	_tmp15_ = _tmp14_;
#line 51 "../src/FullScreenWindow.vala"
	gtk_button_set_image ((GtkButton*) _tmp13_, (GtkWidget*) _tmp15_);
#line 51 "../src/FullScreenWindow.vala"
	_g_object_unref0 (_tmp15_);
#line 52 "../src/FullScreenWindow.vala"
	_tmp16_ = self->priv->pin_button;
#line 52 "../src/FullScreenWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp16_, _ ("Pin the toolbar open"));
#line 53 "../src/FullScreenWindow.vala"
	_tmp17_ = self->priv->pin_button;
#line 53 "../src/FullScreenWindow.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp17_, "active", (GObject*) self, "auto-dismiss-toolbar", G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 55 "../src/FullScreenWindow.vala"
	_tmp18_ = (GtkButton*) gtk_button_new_from_icon_name ("window-restore-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 55 "../src/FullScreenWindow.vala"
	g_object_ref_sink (_tmp18_);
#line 55 "../src/FullScreenWindow.vala"
	close_button = _tmp18_;
#line 56 "../src/FullScreenWindow.vala"
	_tmp19_ = close_button;
#line 56 "../src/FullScreenWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp19_, _ ("Leave fullscreen"));
#line 57 "../src/FullScreenWindow.vala"
	_tmp20_ = close_button;
#line 57 "../src/FullScreenWindow.vala"
	g_signal_connect_object (_tmp20_, "clicked", (GCallback) _fullscreen_window_on_close_gtk_button_clicked, self, 0);
#line 59 "../src/FullScreenWindow.vala"
	_tmp21_ = page_get_toolbar (page, NULL, GTK_PACK_START);
#line 59 "../src/FullScreenWindow.vala"
	_g_object_unref0 (self->priv->toolbar);
#line 59 "../src/FullScreenWindow.vala"
	self->priv->toolbar = _tmp21_;
#line 60 "../src/FullScreenWindow.vala"
	_tmp22_ = self->priv->toolbar;
#line 60 "../src/FullScreenWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_CENTER);
#line 61 "../src/FullScreenWindow.vala"
	_tmp23_ = self->priv->toolbar;
#line 61 "../src/FullScreenWindow.vala"
	g_object_set ((GtkWidget*) _tmp23_, "margin", 6, NULL);
#line 62 "../src/FullScreenWindow.vala"
	_tmp24_ = self->priv->toolbar;
#line 62 "../src/FullScreenWindow.vala"
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
#line 62 "../src/FullScreenWindow.vala"
	gtk_style_context_add_class (_tmp25_, "overlay-toolbar");
#line 64 "../src/FullScreenWindow.vala"
	if (IS_SLIDESHOW_PAGE (page)) {
#line 66 "../src/FullScreenWindow.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (page, TYPE_SLIDESHOW_PAGE, SlideshowPage), "hide-toolbar", (GCallback) _fullscreen_window_hide_toolbar_slideshow_page_hide_toolbar, self, 0);
#line 308 "FullScreenWindow.c"
	} else {
		GtkActionBar* _tmp26_;
		GtkToggleButton* _tmp27_;
#line 69 "../src/FullScreenWindow.vala"
		_tmp26_ = self->priv->toolbar;
#line 69 "../src/FullScreenWindow.vala"
		_tmp27_ = self->priv->pin_button;
#line 69 "../src/FullScreenWindow.vala"
		gtk_action_bar_pack_end (_tmp26_, (GtkWidget*) _tmp27_);
#line 318 "FullScreenWindow.c"
	}
#line 72 "../src/FullScreenWindow.vala"
	page_set_cursor_hide_time (page, FULLSCREEN_WINDOW_TOOLBAR_DISMISSAL_SEC * 1000);
#line 73 "../src/FullScreenWindow.vala"
	page_start_cursor_hiding (page);
#line 75 "../src/FullScreenWindow.vala"
	_tmp28_ = self->priv->toolbar;
#line 75 "../src/FullScreenWindow.vala"
	_tmp29_ = close_button;
#line 75 "../src/FullScreenWindow.vala"
	gtk_action_bar_pack_end (_tmp28_, (GtkWidget*) _tmp29_);
#line 77 "../src/FullScreenWindow.vala"
	_tmp30_ = (GtkRevealer*) gtk_revealer_new ();
#line 77 "../src/FullScreenWindow.vala"
	g_object_ref_sink (_tmp30_);
#line 77 "../src/FullScreenWindow.vala"
	_g_object_unref0 (self->priv->revealer);
#line 77 "../src/FullScreenWindow.vala"
	self->priv->revealer = _tmp30_;
#line 78 "../src/FullScreenWindow.vala"
	_tmp31_ = self->priv->revealer;
#line 78 "../src/FullScreenWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp31_, GTK_ALIGN_CENTER);
#line 79 "../src/FullScreenWindow.vala"
	_tmp32_ = self->priv->revealer;
#line 79 "../src/FullScreenWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp32_, GTK_ALIGN_END);
#line 80 "../src/FullScreenWindow.vala"
	_tmp33_ = self->priv->revealer;
#line 80 "../src/FullScreenWindow.vala"
	gtk_revealer_set_transition_type (_tmp33_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 81 "../src/FullScreenWindow.vala"
	_tmp34_ = self->priv->revealer;
#line 81 "../src/FullScreenWindow.vala"
	_tmp35_ = self->priv->toolbar;
#line 81 "../src/FullScreenWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 83 "../src/FullScreenWindow.vala"
	_tmp36_ = (GtkOverlay*) gtk_overlay_new ();
#line 83 "../src/FullScreenWindow.vala"
	g_object_ref_sink (_tmp36_);
#line 83 "../src/FullScreenWindow.vala"
	overlay = _tmp36_;
#line 84 "../src/FullScreenWindow.vala"
	gtk_container_add ((GtkContainer*) overlay, (GtkWidget*) page);
#line 85 "../src/FullScreenWindow.vala"
	_tmp37_ = self->priv->revealer;
#line 85 "../src/FullScreenWindow.vala"
	gtk_overlay_add_overlay (overlay, (GtkWidget*) _tmp37_);
#line 87 "../src/FullScreenWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) overlay);
#line 92 "../src/FullScreenWindow.vala"
	_tmp38_ = monitor;
#line 92 "../src/FullScreenWindow.vala"
	_tmp39_ = monitor;
#line 92 "../src/FullScreenWindow.vala"
	gtk_window_set_default_size ((GtkWindow*) self, _tmp38_.width, _tmp39_.height);
#line 95 "../src/FullScreenWindow.vala"
	gtk_window_fullscreen ((GtkWindow*) self);
#line 96 "../src/FullScreenWindow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 99 "../src/FullScreenWindow.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_POINTER_MOTION_MASK);
#line 102 "../src/FullScreenWindow.vala"
	fullscreen_window_invoke_toolbar (self);
#line 104 "../src/FullScreenWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) page);
#line 33 "../src/FullScreenWindow.vala"
	_g_object_unref0 (overlay);
#line 33 "../src/FullScreenWindow.vala"
	_g_object_unref0 (close_button);
#line 33 "../src/FullScreenWindow.vala"
	_g_object_unref0 (accel_group);
#line 33 "../src/FullScreenWindow.vala"
	return self;
#line 394 "FullScreenWindow.c"
}

FullscreenWindow*
fullscreen_window_new (Page* page)
{
#line 33 "../src/FullScreenWindow.vala"
	return fullscreen_window_construct (TYPE_FULLSCREEN_WINDOW, page);
#line 402 "FullScreenWindow.c"
}

static void
fullscreen_window_get_monitor_geometry (FullscreenWindow* self,
                                        GdkRectangle* result)
{
	GdkMonitor* monitor = NULL;
	GdkDisplay* _tmp0_;
	AppWindow* _tmp1_;
	AppWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
	GdkMonitor* _tmp6_;
	GdkRectangle _tmp7_ = {0};
#line 107 "../src/FullScreenWindow.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/FullScreenWindow.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 108 "../src/FullScreenWindow.vala"
	_tmp1_ = app_window_get_instance ();
#line 108 "../src/FullScreenWindow.vala"
	_tmp2_ = _tmp1_;
#line 108 "../src/FullScreenWindow.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) _tmp2_);
#line 108 "../src/FullScreenWindow.vala"
	_tmp4_ = gdk_display_get_monitor_at_window (_tmp0_, _tmp3_);
#line 108 "../src/FullScreenWindow.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 108 "../src/FullScreenWindow.vala"
	_tmp6_ = _tmp5_;
#line 108 "../src/FullScreenWindow.vala"
	_g_object_unref0 (_tmp2_);
#line 108 "../src/FullScreenWindow.vala"
	monitor = _tmp6_;
#line 109 "../src/FullScreenWindow.vala"
	gdk_monitor_get_geometry (monitor, &_tmp7_);
#line 109 "../src/FullScreenWindow.vala"
	*result = _tmp7_;
#line 109 "../src/FullScreenWindow.vala"
	_g_object_unref0 (monitor);
#line 109 "../src/FullScreenWindow.vala"
	return;
#line 446 "FullScreenWindow.c"
}

static gboolean
fullscreen_window_real_configure_event (GtkWidget* base,
                                        GdkEventConfigure* event)
{
	FullscreenWindow * self;
	gboolean _result_ = FALSE;
	gboolean result;
#line 112 "../src/FullScreenWindow.vala"
	self = (FullscreenWindow*) base;
#line 112 "../src/FullScreenWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 113 "../src/FullScreenWindow.vala"
	_result_ = GTK_WIDGET_CLASS (fullscreen_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), event);
#line 115 "../src/FullScreenWindow.vala"
	if (!self->priv->switched_to) {
#line 464 "FullScreenWindow.c"
		Page* _tmp0_;
		Page* _tmp1_;
#line 116 "../src/FullScreenWindow.vala"
		_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 116 "../src/FullScreenWindow.vala"
		_tmp1_ = _tmp0_;
#line 116 "../src/FullScreenWindow.vala"
		page_switched_to (_tmp1_);
#line 116 "../src/FullScreenWindow.vala"
		_g_object_unref0 (_tmp1_);
#line 117 "../src/FullScreenWindow.vala"
		self->priv->switched_to = TRUE;
#line 477 "FullScreenWindow.c"
	}
#line 120 "../src/FullScreenWindow.vala"
	result = _result_;
#line 120 "../src/FullScreenWindow.vala"
	return result;
#line 483 "FullScreenWindow.c"
}

static gboolean
fullscreen_window_real_key_press_event (GtkWidget* base,
                                        GdkEventKey* event)
{
	FullscreenWindow * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 125 "../src/FullScreenWindow.vala"
	static GQuark _tmp2_label0 = 0;
#line 125 "../src/FullScreenWindow.vala"
	static GQuark _tmp2_label1 = 0;
#line 498 "FullScreenWindow.c"
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 123 "../src/FullScreenWindow.vala"
	self = (FullscreenWindow*) base;
#line 123 "../src/FullScreenWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 125 "../src/FullScreenWindow.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 125 "../src/FullScreenWindow.vala"
	_tmp1_ = _tmp0_;
#line 125 "../src/FullScreenWindow.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 125 "../src/FullScreenWindow.vala"
	if ((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("F11")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("Escape"))))) {
#line 125 "../src/FullScreenWindow.vala"
		switch (0) {
#line 515 "FullScreenWindow.c"
			default:
			{
#line 128 "../src/FullScreenWindow.vala"
				fullscreen_window_on_close (self);
#line 129 "../src/FullScreenWindow.vala"
				result = TRUE;
#line 129 "../src/FullScreenWindow.vala"
				return result;
#line 524 "FullScreenWindow.c"
			}
		}
	}
#line 132 "../src/FullScreenWindow.vala"
	if (GTK_WIDGET_CLASS (fullscreen_window_parent_class)->key_press_event != NULL) {
#line 132 "../src/FullScreenWindow.vala"
		_tmp4_ = GTK_WIDGET_CLASS (fullscreen_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), event);
#line 532 "FullScreenWindow.c"
	} else {
#line 132 "../src/FullScreenWindow.vala"
		_tmp4_ = FALSE;
#line 536 "FullScreenWindow.c"
	}
#line 132 "../src/FullScreenWindow.vala"
	result = _tmp4_;
#line 132 "../src/FullScreenWindow.vala"
	return result;
#line 542 "FullScreenWindow.c"
}

static void
fullscreen_window_on_close (FullscreenWindow* self)
{
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
#line 135 "../src/FullScreenWindow.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/FullScreenWindow.vala"
	fullscreen_window_hide_toolbar (self);
#line 138 "../src/FullScreenWindow.vala"
	_tmp0_ = app_window_get_instance ();
#line 138 "../src/FullScreenWindow.vala"
	_tmp1_ = _tmp0_;
#line 138 "../src/FullScreenWindow.vala"
	app_window_end_fullscreen (_tmp1_);
#line 138 "../src/FullScreenWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 562 "FullScreenWindow.c"
}

void
fullscreen_window_close (FullscreenWindow* self)
{
#line 141 "../src/FullScreenWindow.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/FullScreenWindow.vala"
	fullscreen_window_on_close (self);
#line 572 "FullScreenWindow.c"
}

static void
fullscreen_window_real_destroy (GtkWidget* base)
{
	FullscreenWindow * self;
	Page* page = NULL;
	Page* _tmp0_;
	Page* _tmp1_;
#line 145 "../src/FullScreenWindow.vala"
	self = (FullscreenWindow*) base;
#line 146 "../src/FullScreenWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 146 "../src/FullScreenWindow.vala"
	page = _tmp0_;
#line 147 "../src/FullScreenWindow.vala"
	page_window_clear_current_page ((PageWindow*) self);
#line 149 "../src/FullScreenWindow.vala"
	_tmp1_ = page;
#line 149 "../src/FullScreenWindow.vala"
	if (_tmp1_ != NULL) {
#line 594 "FullScreenWindow.c"
		Page* _tmp2_;
		Page* _tmp3_;
#line 150 "../src/FullScreenWindow.vala"
		_tmp2_ = page;
#line 150 "../src/FullScreenWindow.vala"
		page_stop_cursor_hiding (_tmp2_);
#line 151 "../src/FullScreenWindow.vala"
		_tmp3_ = page;
#line 151 "../src/FullScreenWindow.vala"
		page_switching_from (_tmp3_);
#line 605 "FullScreenWindow.c"
	}
#line 154 "../src/FullScreenWindow.vala"
	GTK_WIDGET_CLASS (fullscreen_window_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow));
#line 145 "../src/FullScreenWindow.vala"
	_g_object_unref0 (page);
#line 611 "FullScreenWindow.c"
}

static gboolean
fullscreen_window_real_delete_event (GtkWidget* base,
                                     GdkEventAny* event)
{
	FullscreenWindow * self;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	gboolean result;
#line 157 "../src/FullScreenWindow.vala"
	self = (FullscreenWindow*) base;
#line 157 "../src/FullScreenWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 158 "../src/FullScreenWindow.vala"
	fullscreen_window_on_close (self);
#line 159 "../src/FullScreenWindow.vala"
	_tmp0_ = app_window_get_instance ();
#line 159 "../src/FullScreenWindow.vala"
	_tmp1_ = _tmp0_;
#line 159 "../src/FullScreenWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp1_);
#line 159 "../src/FullScreenWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 161 "../src/FullScreenWindow.vala"
	result = TRUE;
#line 161 "../src/FullScreenWindow.vala"
	return result;
#line 640 "FullScreenWindow.c"
}

static gboolean
fullscreen_window_real_motion_notify_event (GtkWidget* base,
                                            GdkEventMotion* event)
{
	FullscreenWindow * self;
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 164 "../src/FullScreenWindow.vala"
	self = (FullscreenWindow*) base;
#line 164 "../src/FullScreenWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 165 "../src/FullScreenWindow.vala"
	_tmp0_ = self->priv->revealer;
#line 165 "../src/FullScreenWindow.vala"
	_tmp1_ = gtk_revealer_get_reveal_child (_tmp0_);
#line 165 "../src/FullScreenWindow.vala"
	_tmp2_ = _tmp1_;
#line 165 "../src/FullScreenWindow.vala"
	if (!_tmp2_) {
#line 166 "../src/FullScreenWindow.vala"
		fullscreen_window_invoke_toolbar (self);
#line 667 "FullScreenWindow.c"
	}
#line 169 "../src/FullScreenWindow.vala"
	if (GTK_WIDGET_CLASS (fullscreen_window_parent_class)->motion_notify_event != NULL) {
#line 169 "../src/FullScreenWindow.vala"
		_tmp3_ = GTK_WIDGET_CLASS (fullscreen_window_parent_class)->motion_notify_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), event);
#line 673 "FullScreenWindow.c"
	} else {
#line 169 "../src/FullScreenWindow.vala"
		_tmp3_ = FALSE;
#line 677 "FullScreenWindow.c"
	}
#line 169 "../src/FullScreenWindow.vala"
	result = _tmp3_;
#line 169 "../src/FullScreenWindow.vala"
	return result;
#line 683 "FullScreenWindow.c"
}

static gboolean
fullscreen_window_is_pointer_in_toolbar (FullscreenWindow* self)
{
	GdkSeat* seat = NULL;
	GdkDisplay* _tmp0_;
	GdkSeat* _tmp1_;
	GdkSeat* _tmp2_;
	GdkSeat* _tmp3_;
	gint py = 0;
	GdkSeat* _tmp4_;
	GdkDevice* _tmp5_;
	gint _tmp6_ = 0;
	GtkAllocation toolbar_alloc = {0};
	GtkActionBar* _tmp7_;
	GtkAllocation _tmp8_ = {0};
	GdkRectangle screen_rect = {0};
	GdkRectangle _tmp9_ = {0};
	gint threshold = 0;
	GdkRectangle _tmp10_;
	GtkRevealer* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	gboolean result;
#line 172 "../src/FullScreenWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 173 "../src/FullScreenWindow.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 173 "../src/FullScreenWindow.vala"
	_tmp1_ = gdk_display_get_default_seat (_tmp0_);
#line 173 "../src/FullScreenWindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 173 "../src/FullScreenWindow.vala"
	seat = _tmp2_;
#line 174 "../src/FullScreenWindow.vala"
	_tmp3_ = seat;
#line 174 "../src/FullScreenWindow.vala"
	if (_tmp3_ == NULL) {
#line 175 "../src/FullScreenWindow.vala"
		g_debug ("FullScreenWindow.vala:175: No seat for display");
#line 177 "../src/FullScreenWindow.vala"
		result = FALSE;
#line 177 "../src/FullScreenWindow.vala"
		_g_object_unref0 (seat);
#line 177 "../src/FullScreenWindow.vala"
		return result;
#line 731 "FullScreenWindow.c"
	}
#line 181 "../src/FullScreenWindow.vala"
	_tmp4_ = seat;
#line 181 "../src/FullScreenWindow.vala"
	_tmp5_ = gdk_seat_get_pointer (_tmp4_);
#line 181 "../src/FullScreenWindow.vala"
	gdk_device_get_position (_tmp5_, NULL, NULL, &_tmp6_);
#line 181 "../src/FullScreenWindow.vala"
	py = _tmp6_;
#line 184 "../src/FullScreenWindow.vala"
	_tmp7_ = self->priv->toolbar;
#line 184 "../src/FullScreenWindow.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp7_, &_tmp8_);
#line 184 "../src/FullScreenWindow.vala"
	toolbar_alloc = _tmp8_;
#line 186 "../src/FullScreenWindow.vala"
	fullscreen_window_get_monitor_geometry (self, &_tmp9_);
#line 186 "../src/FullScreenWindow.vala"
	screen_rect = _tmp9_;
#line 188 "../src/FullScreenWindow.vala"
	_tmp10_ = screen_rect;
#line 188 "../src/FullScreenWindow.vala"
	threshold = _tmp10_.height;
#line 189 "../src/FullScreenWindow.vala"
	_tmp11_ = self->priv->revealer;
#line 189 "../src/FullScreenWindow.vala"
	_tmp12_ = gtk_revealer_get_reveal_child (_tmp11_);
#line 189 "../src/FullScreenWindow.vala"
	_tmp13_ = _tmp12_;
#line 189 "../src/FullScreenWindow.vala"
	if (_tmp13_) {
#line 763 "FullScreenWindow.c"
		GtkAllocation _tmp14_;
#line 190 "../src/FullScreenWindow.vala"
		_tmp14_ = toolbar_alloc;
#line 190 "../src/FullScreenWindow.vala"
		threshold -= _tmp14_.height;
#line 769 "FullScreenWindow.c"
	}
#line 193 "../src/FullScreenWindow.vala"
	result = py >= threshold;
#line 193 "../src/FullScreenWindow.vala"
	_g_object_unref0 (seat);
#line 193 "../src/FullScreenWindow.vala"
	return result;
#line 777 "FullScreenWindow.c"
}

static gboolean
_fullscreen_window_on_check_toolbar_dismissal_gsource_func (gpointer self)
{
	gboolean result;
	result = fullscreen_window_on_check_toolbar_dismissal ((FullscreenWindow*) self);
#line 199 "../src/FullScreenWindow.vala"
	return result;
#line 787 "FullScreenWindow.c"
}

static void
fullscreen_window_invoke_toolbar (FullscreenWindow* self)
{
	GtkRevealer* _tmp0_;
#line 196 "../src/FullScreenWindow.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/FullScreenWindow.vala"
	_tmp0_ = self->priv->revealer;
#line 197 "../src/FullScreenWindow.vala"
	gtk_revealer_set_reveal_child (_tmp0_, TRUE);
#line 199 "../src/FullScreenWindow.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) FULLSCREEN_WINDOW_TOOLBAR_CHECK_DISMISSAL_MSEC, _fullscreen_window_on_check_toolbar_dismissal_gsource_func, g_object_ref (self), g_object_unref);
#line 802 "FullScreenWindow.c"
}

static gboolean
fullscreen_window_on_check_toolbar_dismissal (FullscreenWindow* self)
{
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint64 now = 0LL;
	time_t _tmp5_;
	gboolean result;
#line 202 "../src/FullScreenWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 203 "../src/FullScreenWindow.vala"
	_tmp0_ = self->priv->revealer;
#line 203 "../src/FullScreenWindow.vala"
	_tmp1_ = gtk_revealer_get_reveal_child (_tmp0_);
#line 203 "../src/FullScreenWindow.vala"
	_tmp2_ = _tmp1_;
#line 203 "../src/FullScreenWindow.vala"
	if (!_tmp2_) {
#line 204 "../src/FullScreenWindow.vala"
		result = FALSE;
#line 204 "../src/FullScreenWindow.vala"
		return result;
#line 829 "FullScreenWindow.c"
	}
#line 207 "../src/FullScreenWindow.vala"
	_tmp3_ = self->priv->_auto_dismiss_toolbar;
#line 207 "../src/FullScreenWindow.vala"
	if (!_tmp3_) {
#line 208 "../src/FullScreenWindow.vala"
		result = TRUE;
#line 208 "../src/FullScreenWindow.vala"
		return result;
#line 839 "FullScreenWindow.c"
	}
#line 212 "../src/FullScreenWindow.vala"
	if (fullscreen_window_is_pointer_in_toolbar (self)) {
#line 213 "../src/FullScreenWindow.vala"
		self->priv->left_toolbar_time = (gint64) 0;
#line 215 "../src/FullScreenWindow.vala"
		result = TRUE;
#line 215 "../src/FullScreenWindow.vala"
		return result;
#line 849 "FullScreenWindow.c"
	}
#line 219 "../src/FullScreenWindow.vala"
	if (self->priv->left_toolbar_time == ((gint64) 0)) {
#line 853 "FullScreenWindow.c"
		time_t _tmp4_;
#line 220 "../src/FullScreenWindow.vala"
		_tmp4_ = time (NULL);
#line 220 "../src/FullScreenWindow.vala"
		self->priv->left_toolbar_time = (gint64) _tmp4_;
#line 222 "../src/FullScreenWindow.vala"
		result = TRUE;
#line 222 "../src/FullScreenWindow.vala"
		return result;
#line 863 "FullScreenWindow.c"
	}
#line 226 "../src/FullScreenWindow.vala"
	_tmp5_ = time (NULL);
#line 226 "../src/FullScreenWindow.vala"
	now = (gint64) _tmp5_;
#line 227 "../src/FullScreenWindow.vala"
	_vala_assert (now >= self->priv->left_toolbar_time, "now >= left_toolbar_time");
#line 229 "../src/FullScreenWindow.vala"
	if ((now - self->priv->left_toolbar_time) < ((gint64) FULLSCREEN_WINDOW_TOOLBAR_DISMISSAL_SEC)) {
#line 230 "../src/FullScreenWindow.vala"
		result = TRUE;
#line 230 "../src/FullScreenWindow.vala"
		return result;
#line 877 "FullScreenWindow.c"
	}
#line 232 "../src/FullScreenWindow.vala"
	fullscreen_window_hide_toolbar (self);
#line 234 "../src/FullScreenWindow.vala"
	result = FALSE;
#line 234 "../src/FullScreenWindow.vala"
	return result;
#line 885 "FullScreenWindow.c"
}

static void
fullscreen_window_hide_toolbar (FullscreenWindow* self)
{
	GtkRevealer* _tmp0_;
#line 237 "../src/FullScreenWindow.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/FullScreenWindow.vala"
	_tmp0_ = self->priv->revealer;
#line 238 "../src/FullScreenWindow.vala"
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
#line 239 "../src/FullScreenWindow.vala"
	self->priv->left_toolbar_time = (gint64) 0;
#line 900 "FullScreenWindow.c"
}

gboolean
fullscreen_window_get_auto_dismiss_toolbar (FullscreenWindow* self)
{
	gboolean result;
#line 31 "../src/FullScreenWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/FullScreenWindow.vala"
	result = self->priv->_auto_dismiss_toolbar;
#line 31 "../src/FullScreenWindow.vala"
	return result;
#line 913 "FullScreenWindow.c"
}

void
fullscreen_window_set_auto_dismiss_toolbar (FullscreenWindow* self,
                                            gboolean value)
{
	gboolean old_value;
#line 31 "../src/FullScreenWindow.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/FullScreenWindow.vala"
	old_value = fullscreen_window_get_auto_dismiss_toolbar (self);
#line 31 "../src/FullScreenWindow.vala"
	if (old_value != value) {
#line 31 "../src/FullScreenWindow.vala"
		self->priv->_auto_dismiss_toolbar = value;
#line 31 "../src/FullScreenWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, fullscreen_window_properties[FULLSCREEN_WINDOW_AUTO_DISMISS_TOOLBAR_PROPERTY]);
#line 931 "FullScreenWindow.c"
	}
}

static void
fullscreen_window_class_init (FullscreenWindowClass * klass,
                              gpointer klass_data)
{
#line 21 "../src/FullScreenWindow.vala"
	fullscreen_window_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/FullScreenWindow.vala"
	g_type_class_adjust_private_offset (klass, &FullscreenWindow_private_offset);
#line 21 "../src/FullScreenWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) fullscreen_window_real_configure_event;
#line 21 "../src/FullScreenWindow.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) fullscreen_window_real_key_press_event;
#line 21 "../src/FullScreenWindow.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) fullscreen_window_real_destroy;
#line 21 "../src/FullScreenWindow.vala"
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) fullscreen_window_real_delete_event;
#line 21 "../src/FullScreenWindow.vala"
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) fullscreen_window_real_motion_notify_event;
#line 21 "../src/FullScreenWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_fullscreen_window_get_property;
#line 21 "../src/FullScreenWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_fullscreen_window_set_property;
#line 21 "../src/FullScreenWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = fullscreen_window_finalize;
#line 21 "../src/FullScreenWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FULLSCREEN_WINDOW_AUTO_DISMISS_TOOLBAR_PROPERTY, fullscreen_window_properties[FULLSCREEN_WINDOW_AUTO_DISMISS_TOOLBAR_PROPERTY] = g_param_spec_boolean ("auto-dismiss-toolbar", "auto-dismiss-toolbar", "auto-dismiss-toolbar", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 961 "FullScreenWindow.c"
}

static void
fullscreen_window_instance_init (FullscreenWindow * self,
                                 gpointer klass)
{
#line 21 "../src/FullScreenWindow.vala"
	self->priv = fullscreen_window_get_instance_private (self);
#line 28 "../src/FullScreenWindow.vala"
	self->priv->left_toolbar_time = (gint64) 0;
#line 29 "../src/FullScreenWindow.vala"
	self->priv->switched_to = FALSE;
#line 31 "../src/FullScreenWindow.vala"
	self->priv->_auto_dismiss_toolbar = TRUE;
#line 976 "FullScreenWindow.c"
}

static void
fullscreen_window_finalize (GObject * obj)
{
	FullscreenWindow * self;
#line 21 "../src/FullScreenWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FULLSCREEN_WINDOW, FullscreenWindow);
#line 25 "../src/FullScreenWindow.vala"
	_g_object_unref0 (self->priv->revealer);
#line 26 "../src/FullScreenWindow.vala"
	_g_object_unref0 (self->priv->toolbar);
#line 27 "../src/FullScreenWindow.vala"
	_g_object_unref0 (self->priv->pin_button);
#line 21 "../src/FullScreenWindow.vala"
	G_OBJECT_CLASS (fullscreen_window_parent_class)->finalize (obj);
#line 993 "FullScreenWindow.c"
}

static GType
fullscreen_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FullscreenWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fullscreen_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FullscreenWindow), 0, (GInstanceInitFunc) fullscreen_window_instance_init, NULL };
	GType fullscreen_window_type_id;
	fullscreen_window_type_id = g_type_register_static (TYPE_PAGE_WINDOW, "FullscreenWindow", &g_define_type_info, 0);
	FullscreenWindow_private_offset = g_type_add_instance_private (fullscreen_window_type_id, sizeof (FullscreenWindowPrivate));
	return fullscreen_window_type_id;
}

GType
fullscreen_window_get_type (void)
{
	static volatile gsize fullscreen_window_type_id__once = 0;
	if (g_once_init_enter (&fullscreen_window_type_id__once)) {
		GType fullscreen_window_type_id;
		fullscreen_window_type_id = fullscreen_window_get_type_once ();
		g_once_init_leave (&fullscreen_window_type_id__once, fullscreen_window_type_id);
	}
	return fullscreen_window_type_id__once;
}

static void
_vala_fullscreen_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	FullscreenWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FULLSCREEN_WINDOW, FullscreenWindow);
#line 21 "../src/FullScreenWindow.vala"
	switch (property_id) {
#line 21 "../src/FullScreenWindow.vala"
		case FULLSCREEN_WINDOW_AUTO_DISMISS_TOOLBAR_PROPERTY:
#line 21 "../src/FullScreenWindow.vala"
		g_value_set_boolean (value, fullscreen_window_get_auto_dismiss_toolbar (self));
#line 21 "../src/FullScreenWindow.vala"
		break;
#line 1034 "FullScreenWindow.c"
		default:
#line 21 "../src/FullScreenWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/FullScreenWindow.vala"
		break;
#line 1040 "FullScreenWindow.c"
	}
}

static void
_vala_fullscreen_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	FullscreenWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FULLSCREEN_WINDOW, FullscreenWindow);
#line 21 "../src/FullScreenWindow.vala"
	switch (property_id) {
#line 21 "../src/FullScreenWindow.vala"
		case FULLSCREEN_WINDOW_AUTO_DISMISS_TOOLBAR_PROPERTY:
#line 21 "../src/FullScreenWindow.vala"
		fullscreen_window_set_auto_dismiss_toolbar (self, g_value_get_boolean (value));
#line 21 "../src/FullScreenWindow.vala"
		break;
#line 1060 "FullScreenWindow.c"
		default:
#line 21 "../src/FullScreenWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/FullScreenWindow.vala"
		break;
#line 1066 "FullScreenWindow.c"
	}
}

