/* MediaInterfaces.c generated by valac 0.56.18, the Vala compiler
 * generated from MediaInterfaces.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* Going forward, Photos will use MediaInterfaces, which allow for various operations and features*/
/* to be added only to the MediaSources that support them (or make sense for).  For example, adding*/
/* a library-mode photo or video to an Event makes perfect sense, but does not make sense for a*/
/* direct-mode photo.  All three are MediaSources, and to make DirectPhoto descend from another*/
/* base class is only inviting chaos and a tremendous amount of replicated code.*/
/**/
/* A key point to make of all MediaInterfaces is that they require MediaSource as a base class.*/
/* Thus, any code dealing with one of these interfaces knows they are also dealing with a*/
/* MediaSource.*/
/**/
/* TODO: Make Eventable and Taggable interfaces, which are the only types Event and Tag will deal*/
/* with (rather than MediaSources).*/
/**/
/* TODO: Make Trashable interface, which are much like Flaggable.*/
/**/
/* TODO: ContainerSources may also have specific needs in the future; an interface-based system*/
/* may make sense as well when that need arises.*/
/**/
/**/
/* TransactionController*/
/**/
/* Because many operations in Photos need to be performed on collections of objects all at once,*/
/* and that most of these objects are backed by a database, the TransactionController object gives*/
/* a way to generically group a series of operations on one or more similar objects into a single*/
/* transaction. This class is listed here because it's used by the various media interfaces to offer*/
/* multiple operations.*/
/**/
/* begin () and commit () may be called multiple times in layering fashion.  The implementation*/
/* accounts for this.  If either throws an exception it should be assumed that the object is in*/
/* a "clean" state; that is, if begin () throws an exception, there is no need to call commit (),*/
/* and if commit () throws an exception, it does not need to be called again to revert the object*/
/* state.*/
/**/
/* This means that any user who calls begin () *must* match it with a corresponding commit (), even*/
/* if there is an error during the transaction.  It is up to the user to back out any undesired*/
/* changes.*/
/**/
/* Because of the nature of this object, it's assumed that every object type will share one*/
/* between all callers.*/
/**/
/* The object is thread-safe.  There is no guarantee that the underlying persistent store is,*/
/* however.*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>
#include <gee.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecTransactionController ParamSpecTransactionController;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TransactionControllerPrivate {
	gint count;
	GRecMutex __lock_count;
};

struct _ParamSpecTransactionController {
	GParamSpec parent_instance;
};

static gint TransactionController_private_offset;
static gpointer transaction_controller_parent_class = NULL;

static void transaction_controller_real_begin_impl (TransactionController* self,
                                             GError** error);
static void transaction_controller_real_commit_impl (TransactionController* self,
                                              GError** error);
static void transaction_controller_finalize (TransactionController * obj);
static GType transaction_controller_get_type_once (void);
static GType flaggable_get_type_once (void);
static GType monitorable_get_type_once (void);
static GType dateable_get_type_once (void);

static inline gpointer
transaction_controller_get_instance_private (TransactionController* self)
{
	return G_STRUCT_MEMBER_P (self, TransactionController_private_offset);
}

TransactionController*
transaction_controller_construct (GType object_type)
{
	TransactionController* self = NULL;
#line 67 "../src/MediaInterfaces.vala"
	self = (TransactionController*) g_type_create_instance (object_type);
#line 67 "../src/MediaInterfaces.vala"
	return self;
#line 130 "MediaInterfaces.c"
}

void
transaction_controller_begin (TransactionController* self)
{
	GError* _inner_error0_ = NULL;
#line 76 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 139 "MediaInterfaces.c"
	{
#line 77 "../src/MediaInterfaces.vala"
		g_rec_mutex_lock (&self->priv->__lock_count);
#line 143 "MediaInterfaces.c"
		{
			gint _tmp0_;
#line 78 "../src/MediaInterfaces.vala"
			_tmp0_ = self->priv->count;
#line 78 "../src/MediaInterfaces.vala"
			self->priv->count = _tmp0_ + 1;
#line 78 "../src/MediaInterfaces.vala"
			if (_tmp0_ != 0) {
#line 152 "MediaInterfaces.c"
				{
#line 77 "../src/MediaInterfaces.vala"
					g_rec_mutex_unlock (&self->priv->__lock_count);
#line 156 "MediaInterfaces.c"
				}
#line 79 "../src/MediaInterfaces.vala"
				return;
#line 160 "MediaInterfaces.c"
			}
			{
#line 82 "../src/MediaInterfaces.vala"
				transaction_controller_begin_impl (self, &_inner_error0_);
#line 82 "../src/MediaInterfaces.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "MediaInterfaces.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* err = NULL;
				gint _tmp1_;
				GError* _tmp2_;
#line 81 "../src/MediaInterfaces.vala"
				err = _inner_error0_;
#line 81 "../src/MediaInterfaces.vala"
				_inner_error0_ = NULL;
#line 85 "../src/MediaInterfaces.vala"
				_tmp1_ = self->priv->count;
#line 85 "../src/MediaInterfaces.vala"
				self->priv->count = _tmp1_ - 1;
#line 87 "../src/MediaInterfaces.vala"
				_tmp2_ = err;
#line 87 "../src/MediaInterfaces.vala"
				if (_tmp2_->domain == DATABASE_ERROR) {
#line 189 "MediaInterfaces.c"
					GError* _tmp3_;
#line 88 "../src/MediaInterfaces.vala"
					_tmp3_ = err;
#line 88 "../src/MediaInterfaces.vala"
					app_window_database_error ((GError*) _tmp3_);
#line 195 "MediaInterfaces.c"
				} else {
					GError* _tmp4_;
					const gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
#line 90 "../src/MediaInterfaces.vala"
					_tmp4_ = err;
#line 90 "../src/MediaInterfaces.vala"
					_tmp5_ = _tmp4_->message;
#line 90 "../src/MediaInterfaces.vala"
					_tmp6_ = g_strdup_printf ("%s", _tmp5_);
#line 90 "../src/MediaInterfaces.vala"
					_tmp7_ = _tmp6_;
#line 90 "../src/MediaInterfaces.vala"
					app_window_panic (_tmp7_);
#line 90 "../src/MediaInterfaces.vala"
					_g_free0 (_tmp7_);
#line 213 "MediaInterfaces.c"
				}
#line 81 "../src/MediaInterfaces.vala"
				_g_error_free0 (err);
#line 217 "MediaInterfaces.c"
			}
			__finally1:
#line 81 "../src/MediaInterfaces.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/MediaInterfaces.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/MediaInterfaces.vala"
				g_clear_error (&_inner_error0_);
#line 81 "../src/MediaInterfaces.vala"
				return;
#line 228 "MediaInterfaces.c"
			}
		}
		__finally0:
		{
#line 77 "../src/MediaInterfaces.vala"
			g_rec_mutex_unlock (&self->priv->__lock_count);
#line 235 "MediaInterfaces.c"
		}
#line 77 "../src/MediaInterfaces.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/MediaInterfaces.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/MediaInterfaces.vala"
			g_clear_error (&_inner_error0_);
#line 77 "../src/MediaInterfaces.vala"
			return;
#line 245 "MediaInterfaces.c"
		}
	}
}

static void
transaction_controller_real_begin_impl (TransactionController* self,
                                        GError** error)
{
#line 96 "../src/MediaInterfaces.vala"
	g_critical ("Type `%s' does not implement abstract method `transaction_controller_begin_impl'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 96 "../src/MediaInterfaces.vala"
	return;
#line 258 "MediaInterfaces.c"
}

void
transaction_controller_begin_impl (TransactionController* self,
                                   GError** error)
{
	TransactionControllerClass* _klass_;
#line 96 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/MediaInterfaces.vala"
	_klass_ = TRANSACTION_CONTROLLER_GET_CLASS (self);
#line 96 "../src/MediaInterfaces.vala"
	if (_klass_->begin_impl) {
#line 96 "../src/MediaInterfaces.vala"
		_klass_->begin_impl (self, error);
#line 274 "MediaInterfaces.c"
	}
}

void
transaction_controller_commit (TransactionController* self)
{
	GError* _inner_error0_ = NULL;
#line 98 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 284 "MediaInterfaces.c"
	{
#line 99 "../src/MediaInterfaces.vala"
		g_rec_mutex_lock (&self->priv->__lock_count);
#line 288 "MediaInterfaces.c"
		{
			gint _tmp0_;
#line 100 "../src/MediaInterfaces.vala"
			_vala_assert (self->priv->count > 0, "count > 0");
#line 101 "../src/MediaInterfaces.vala"
			self->priv->count = self->priv->count - 1;
#line 101 "../src/MediaInterfaces.vala"
			_tmp0_ = self->priv->count;
#line 101 "../src/MediaInterfaces.vala"
			if (_tmp0_ != 0) {
#line 299 "MediaInterfaces.c"
				{
#line 99 "../src/MediaInterfaces.vala"
					g_rec_mutex_unlock (&self->priv->__lock_count);
#line 303 "MediaInterfaces.c"
				}
#line 102 "../src/MediaInterfaces.vala"
				return;
#line 307 "MediaInterfaces.c"
			}
			{
#line 106 "../src/MediaInterfaces.vala"
				transaction_controller_commit_impl (self, &_inner_error0_);
#line 106 "../src/MediaInterfaces.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 314 "MediaInterfaces.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* err = NULL;
				GError* _tmp1_;
#line 105 "../src/MediaInterfaces.vala"
				err = _inner_error0_;
#line 105 "../src/MediaInterfaces.vala"
				_inner_error0_ = NULL;
#line 108 "../src/MediaInterfaces.vala"
				_tmp1_ = err;
#line 108 "../src/MediaInterfaces.vala"
				if (_tmp1_->domain == DATABASE_ERROR) {
#line 331 "MediaInterfaces.c"
					GError* _tmp2_;
#line 109 "../src/MediaInterfaces.vala"
					_tmp2_ = err;
#line 109 "../src/MediaInterfaces.vala"
					app_window_database_error ((GError*) _tmp2_);
#line 337 "MediaInterfaces.c"
				} else {
					GError* _tmp3_;
					const gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
#line 111 "../src/MediaInterfaces.vala"
					_tmp3_ = err;
#line 111 "../src/MediaInterfaces.vala"
					_tmp4_ = _tmp3_->message;
#line 111 "../src/MediaInterfaces.vala"
					_tmp5_ = g_strdup_printf ("%s", _tmp4_);
#line 111 "../src/MediaInterfaces.vala"
					_tmp6_ = _tmp5_;
#line 111 "../src/MediaInterfaces.vala"
					app_window_panic (_tmp6_);
#line 111 "../src/MediaInterfaces.vala"
					_g_free0 (_tmp6_);
#line 355 "MediaInterfaces.c"
				}
#line 105 "../src/MediaInterfaces.vala"
				_g_error_free0 (err);
#line 359 "MediaInterfaces.c"
			}
			__finally1:
#line 105 "../src/MediaInterfaces.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../src/MediaInterfaces.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/MediaInterfaces.vala"
				g_clear_error (&_inner_error0_);
#line 105 "../src/MediaInterfaces.vala"
				return;
#line 370 "MediaInterfaces.c"
			}
		}
		__finally0:
		{
#line 99 "../src/MediaInterfaces.vala"
			g_rec_mutex_unlock (&self->priv->__lock_count);
#line 377 "MediaInterfaces.c"
		}
#line 99 "../src/MediaInterfaces.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/MediaInterfaces.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/MediaInterfaces.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../src/MediaInterfaces.vala"
			return;
#line 387 "MediaInterfaces.c"
		}
	}
}

static void
transaction_controller_real_commit_impl (TransactionController* self,
                                         GError** error)
{
#line 117 "../src/MediaInterfaces.vala"
	g_critical ("Type `%s' does not implement abstract method `transaction_controller_commit_impl'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 117 "../src/MediaInterfaces.vala"
	return;
#line 400 "MediaInterfaces.c"
}

void
transaction_controller_commit_impl (TransactionController* self,
                                    GError** error)
{
	TransactionControllerClass* _klass_;
#line 117 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/MediaInterfaces.vala"
	_klass_ = TRANSACTION_CONTROLLER_GET_CLASS (self);
#line 117 "../src/MediaInterfaces.vala"
	if (_klass_->commit_impl) {
#line 117 "../src/MediaInterfaces.vala"
		_klass_->commit_impl (self, error);
#line 416 "MediaInterfaces.c"
	}
}

static void
value_transaction_controller_init (GValue* value)
{
#line 64 "../src/MediaInterfaces.vala"
	value->data[0].v_pointer = NULL;
#line 425 "MediaInterfaces.c"
}

static void
value_transaction_controller_free_value (GValue* value)
{
#line 64 "../src/MediaInterfaces.vala"
	if (value->data[0].v_pointer) {
#line 64 "../src/MediaInterfaces.vala"
		transaction_controller_unref (value->data[0].v_pointer);
#line 435 "MediaInterfaces.c"
	}
}

static void
value_transaction_controller_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 64 "../src/MediaInterfaces.vala"
	if (src_value->data[0].v_pointer) {
#line 64 "../src/MediaInterfaces.vala"
		dest_value->data[0].v_pointer = transaction_controller_ref (src_value->data[0].v_pointer);
#line 447 "MediaInterfaces.c"
	} else {
#line 64 "../src/MediaInterfaces.vala"
		dest_value->data[0].v_pointer = NULL;
#line 451 "MediaInterfaces.c"
	}
}

static gpointer
value_transaction_controller_peek_pointer (const GValue* value)
{
#line 64 "../src/MediaInterfaces.vala"
	return value->data[0].v_pointer;
#line 460 "MediaInterfaces.c"
}

static gchar*
value_transaction_controller_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 64 "../src/MediaInterfaces.vala"
	if (collect_values[0].v_pointer) {
#line 471 "MediaInterfaces.c"
		TransactionController * object;
		object = collect_values[0].v_pointer;
#line 64 "../src/MediaInterfaces.vala"
		if (object->parent_instance.g_class == NULL) {
#line 64 "../src/MediaInterfaces.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 478 "MediaInterfaces.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 64 "../src/MediaInterfaces.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 482 "MediaInterfaces.c"
		}
#line 64 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = transaction_controller_ref (object);
#line 486 "MediaInterfaces.c"
	} else {
#line 64 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = NULL;
#line 490 "MediaInterfaces.c"
	}
#line 64 "../src/MediaInterfaces.vala"
	return NULL;
#line 494 "MediaInterfaces.c"
}

static gchar*
value_transaction_controller_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	TransactionController ** object_p;
	object_p = collect_values[0].v_pointer;
#line 64 "../src/MediaInterfaces.vala"
	if (!object_p) {
#line 64 "../src/MediaInterfaces.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 509 "MediaInterfaces.c"
	}
#line 64 "../src/MediaInterfaces.vala"
	if (!value->data[0].v_pointer) {
#line 64 "../src/MediaInterfaces.vala"
		*object_p = NULL;
#line 515 "MediaInterfaces.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 64 "../src/MediaInterfaces.vala"
		*object_p = value->data[0].v_pointer;
#line 519 "MediaInterfaces.c"
	} else {
#line 64 "../src/MediaInterfaces.vala"
		*object_p = transaction_controller_ref (value->data[0].v_pointer);
#line 523 "MediaInterfaces.c"
	}
#line 64 "../src/MediaInterfaces.vala"
	return NULL;
#line 527 "MediaInterfaces.c"
}

GParamSpec*
param_spec_transaction_controller (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	ParamSpecTransactionController* spec;
#line 64 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TRANSACTION_CONTROLLER), NULL);
#line 64 "../src/MediaInterfaces.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 64 "../src/MediaInterfaces.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 64 "../src/MediaInterfaces.vala"
	return G_PARAM_SPEC (spec);
#line 546 "MediaInterfaces.c"
}

gpointer
value_get_transaction_controller (const GValue* value)
{
#line 64 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER), NULL);
#line 64 "../src/MediaInterfaces.vala"
	return value->data[0].v_pointer;
#line 556 "MediaInterfaces.c"
}

void
value_set_transaction_controller (GValue* value,
                                  gpointer v_object)
{
	TransactionController * old;
#line 64 "../src/MediaInterfaces.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER));
#line 64 "../src/MediaInterfaces.vala"
	old = value->data[0].v_pointer;
#line 64 "../src/MediaInterfaces.vala"
	if (v_object) {
#line 64 "../src/MediaInterfaces.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRANSACTION_CONTROLLER));
#line 64 "../src/MediaInterfaces.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 64 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = v_object;
#line 64 "../src/MediaInterfaces.vala"
		transaction_controller_ref (value->data[0].v_pointer);
#line 578 "MediaInterfaces.c"
	} else {
#line 64 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = NULL;
#line 582 "MediaInterfaces.c"
	}
#line 64 "../src/MediaInterfaces.vala"
	if (old) {
#line 64 "../src/MediaInterfaces.vala"
		transaction_controller_unref (old);
#line 588 "MediaInterfaces.c"
	}
}

void
value_take_transaction_controller (GValue* value,
                                   gpointer v_object)
{
	TransactionController * old;
#line 64 "../src/MediaInterfaces.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER));
#line 64 "../src/MediaInterfaces.vala"
	old = value->data[0].v_pointer;
#line 64 "../src/MediaInterfaces.vala"
	if (v_object) {
#line 64 "../src/MediaInterfaces.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRANSACTION_CONTROLLER));
#line 64 "../src/MediaInterfaces.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 64 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = v_object;
#line 609 "MediaInterfaces.c"
	} else {
#line 64 "../src/MediaInterfaces.vala"
		value->data[0].v_pointer = NULL;
#line 613 "MediaInterfaces.c"
	}
#line 64 "../src/MediaInterfaces.vala"
	if (old) {
#line 64 "../src/MediaInterfaces.vala"
		transaction_controller_unref (old);
#line 619 "MediaInterfaces.c"
	}
}

static void
transaction_controller_class_init (TransactionControllerClass * klass,
                                   gpointer klass_data)
{
#line 64 "../src/MediaInterfaces.vala"
	transaction_controller_parent_class = g_type_class_peek_parent (klass);
#line 64 "../src/MediaInterfaces.vala"
	((TransactionControllerClass *) klass)->finalize = transaction_controller_finalize;
#line 64 "../src/MediaInterfaces.vala"
	g_type_class_adjust_private_offset (klass, &TransactionController_private_offset);
#line 64 "../src/MediaInterfaces.vala"
	((TransactionControllerClass *) klass)->begin_impl = (void (*) (TransactionController*, GError**)) transaction_controller_real_begin_impl;
#line 64 "../src/MediaInterfaces.vala"
	((TransactionControllerClass *) klass)->commit_impl = (void (*) (TransactionController*, GError**)) transaction_controller_real_commit_impl;
#line 637 "MediaInterfaces.c"
}

static void
transaction_controller_instance_init (TransactionController * self,
                                      gpointer klass)
{
#line 64 "../src/MediaInterfaces.vala"
	self->priv = transaction_controller_get_instance_private (self);
#line 65 "../src/MediaInterfaces.vala"
	g_rec_mutex_init (&self->priv->__lock_count);
#line 65 "../src/MediaInterfaces.vala"
	self->priv->count = 0;
#line 64 "../src/MediaInterfaces.vala"
	self->ref_count = 1;
#line 652 "MediaInterfaces.c"
}

static void
transaction_controller_finalize (TransactionController * obj)
{
	TransactionController * self;
	GError* _inner_error0_ = NULL;
#line 64 "../src/MediaInterfaces.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TRANSACTION_CONTROLLER, TransactionController);
#line 64 "../src/MediaInterfaces.vala"
	g_signal_handlers_destroy (self);
#line 664 "MediaInterfaces.c"
	{
#line 71 "../src/MediaInterfaces.vala"
		g_rec_mutex_lock (&self->priv->__lock_count);
#line 668 "MediaInterfaces.c"
		{
#line 72 "../src/MediaInterfaces.vala"
			_vala_assert (self->priv->count == 0, "count == 0");
#line 672 "MediaInterfaces.c"
		}
		__finally0:
		{
#line 71 "../src/MediaInterfaces.vala"
			g_rec_mutex_unlock (&self->priv->__lock_count);
#line 678 "MediaInterfaces.c"
		}
#line 71 "../src/MediaInterfaces.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/MediaInterfaces.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 71 "../src/MediaInterfaces.vala"
			g_clear_error (&_inner_error0_);
#line 686 "MediaInterfaces.c"
		}
	}
#line 65 "../src/MediaInterfaces.vala"
	g_rec_mutex_clear (&self->priv->__lock_count);
#line 691 "MediaInterfaces.c"
}

static GType
transaction_controller_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_transaction_controller_init, value_transaction_controller_free_value, value_transaction_controller_copy_value, value_transaction_controller_peek_pointer, "p", value_transaction_controller_collect_value, "p", value_transaction_controller_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TransactionControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) transaction_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TransactionController), 0, (GInstanceInitFunc) transaction_controller_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType transaction_controller_type_id;
	transaction_controller_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TransactionController", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	TransactionController_private_offset = g_type_add_instance_private (transaction_controller_type_id, sizeof (TransactionControllerPrivate));
	return transaction_controller_type_id;
}

GType
transaction_controller_get_type (void)
{
	static volatile gsize transaction_controller_type_id__once = 0;
	if (g_once_init_enter (&transaction_controller_type_id__once)) {
		GType transaction_controller_type_id;
		transaction_controller_type_id = transaction_controller_get_type_once ();
		g_once_init_leave (&transaction_controller_type_id__once, transaction_controller_type_id);
	}
	return transaction_controller_type_id__once;
}

gpointer
transaction_controller_ref (gpointer instance)
{
	TransactionController * self;
	self = instance;
#line 64 "../src/MediaInterfaces.vala"
	g_atomic_int_inc (&self->ref_count);
#line 64 "../src/MediaInterfaces.vala"
	return instance;
#line 727 "MediaInterfaces.c"
}

void
transaction_controller_unref (gpointer instance)
{
	TransactionController * self;
	self = instance;
#line 64 "../src/MediaInterfaces.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 64 "../src/MediaInterfaces.vala"
		TRANSACTION_CONTROLLER_GET_CLASS (self)->finalize (self);
#line 64 "../src/MediaInterfaces.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 741 "MediaInterfaces.c"
	}
}

gboolean
flaggable_is_flagged (Flaggable* self)
{
	FlaggableIface* _iface_;
#line 128 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "../src/MediaInterfaces.vala"
	_iface_ = FLAGGABLE_GET_INTERFACE (self);
#line 128 "../src/MediaInterfaces.vala"
	if (_iface_->is_flagged) {
#line 128 "../src/MediaInterfaces.vala"
		return _iface_->is_flagged (self);
#line 757 "MediaInterfaces.c"
	}
#line 128 "../src/MediaInterfaces.vala"
	return FALSE;
#line 761 "MediaInterfaces.c"
}

void
flaggable_mark_flagged (Flaggable* self)
{
	FlaggableIface* _iface_;
#line 130 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/MediaInterfaces.vala"
	_iface_ = FLAGGABLE_GET_INTERFACE (self);
#line 130 "../src/MediaInterfaces.vala"
	if (_iface_->mark_flagged) {
#line 130 "../src/MediaInterfaces.vala"
		_iface_->mark_flagged (self);
#line 776 "MediaInterfaces.c"
	}
}

void
flaggable_mark_unflagged (Flaggable* self)
{
	FlaggableIface* _iface_;
#line 132 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/MediaInterfaces.vala"
	_iface_ = FLAGGABLE_GET_INTERFACE (self);
#line 132 "../src/MediaInterfaces.vala"
	if (_iface_->mark_unflagged) {
#line 132 "../src/MediaInterfaces.vala"
		_iface_->mark_unflagged (self);
#line 792 "MediaInterfaces.c"
	}
}

void
flaggable_mark_many_flagged_unflagged (GeeCollection* flag,
                                       GeeCollection* unflag,
                                       TransactionController* controller,
                                       GError** error)
{
#line 134 "../src/MediaInterfaces.vala"
	g_return_if_fail (controller != NULL);
#line 136 "../src/MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 138 "../src/MediaInterfaces.vala"
	if (flag != NULL) {
#line 808 "MediaInterfaces.c"
		{
			GeeIterator* _flaggable_it = NULL;
			GeeIterator* _tmp0_;
#line 139 "../src/MediaInterfaces.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) flag);
#line 139 "../src/MediaInterfaces.vala"
			_flaggable_it = _tmp0_;
#line 139 "../src/MediaInterfaces.vala"
			while (TRUE) {
#line 818 "MediaInterfaces.c"
				GeeIterator* _tmp1_;
				Flaggable* flaggable = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Flaggable* _tmp4_;
#line 139 "../src/MediaInterfaces.vala"
				_tmp1_ = _flaggable_it;
#line 139 "../src/MediaInterfaces.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 139 "../src/MediaInterfaces.vala"
					break;
#line 830 "MediaInterfaces.c"
				}
#line 139 "../src/MediaInterfaces.vala"
				_tmp2_ = _flaggable_it;
#line 139 "../src/MediaInterfaces.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 139 "../src/MediaInterfaces.vala"
				flaggable = (Flaggable*) _tmp3_;
#line 140 "../src/MediaInterfaces.vala"
				_tmp4_ = flaggable;
#line 140 "../src/MediaInterfaces.vala"
				flaggable_mark_flagged (_tmp4_);
#line 139 "../src/MediaInterfaces.vala"
				_g_object_unref0 (flaggable);
#line 844 "MediaInterfaces.c"
			}
#line 139 "../src/MediaInterfaces.vala"
			_g_object_unref0 (_flaggable_it);
#line 848 "MediaInterfaces.c"
		}
	}
#line 143 "../src/MediaInterfaces.vala"
	if (unflag != NULL) {
#line 853 "MediaInterfaces.c"
		{
			GeeIterator* _flaggable_it = NULL;
			GeeIterator* _tmp5_;
#line 144 "../src/MediaInterfaces.vala"
			_tmp5_ = gee_iterable_iterator ((GeeIterable*) unflag);
#line 144 "../src/MediaInterfaces.vala"
			_flaggable_it = _tmp5_;
#line 144 "../src/MediaInterfaces.vala"
			while (TRUE) {
#line 863 "MediaInterfaces.c"
				GeeIterator* _tmp6_;
				Flaggable* flaggable = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Flaggable* _tmp9_;
#line 144 "../src/MediaInterfaces.vala"
				_tmp6_ = _flaggable_it;
#line 144 "../src/MediaInterfaces.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 144 "../src/MediaInterfaces.vala"
					break;
#line 875 "MediaInterfaces.c"
				}
#line 144 "../src/MediaInterfaces.vala"
				_tmp7_ = _flaggable_it;
#line 144 "../src/MediaInterfaces.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 144 "../src/MediaInterfaces.vala"
				flaggable = (Flaggable*) _tmp8_;
#line 145 "../src/MediaInterfaces.vala"
				_tmp9_ = flaggable;
#line 145 "../src/MediaInterfaces.vala"
				flaggable_mark_unflagged (_tmp9_);
#line 144 "../src/MediaInterfaces.vala"
				_g_object_unref0 (flaggable);
#line 889 "MediaInterfaces.c"
			}
#line 144 "../src/MediaInterfaces.vala"
			_g_object_unref0 (_flaggable_it);
#line 893 "MediaInterfaces.c"
		}
	}
#line 148 "../src/MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 898 "MediaInterfaces.c"
}

static void
flaggable_default_init (FlaggableIface * iface,
                        gpointer iface_data)
{
}

static GType
flaggable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FlaggableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) flaggable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType flaggable_type_id;
	flaggable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Flaggable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (flaggable_type_id, TYPE_MEDIA_SOURCE);
	return flaggable_type_id;
}

GType
flaggable_get_type (void)
{
	static volatile gsize flaggable_type_id__once = 0;
	if (g_once_init_enter (&flaggable_type_id__once)) {
		GType flaggable_type_id;
		flaggable_type_id = flaggable_get_type_once ();
		g_once_init_leave (&flaggable_type_id__once, flaggable_type_id);
	}
	return flaggable_type_id__once;
}

gboolean
monitorable_is_offline (Monitorable* self)
{
	MonitorableIface* _iface_;
#line 166 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 166 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 166 "../src/MediaInterfaces.vala"
	if (_iface_->is_offline) {
#line 166 "../src/MediaInterfaces.vala"
		return _iface_->is_offline (self);
#line 941 "MediaInterfaces.c"
	}
#line 166 "../src/MediaInterfaces.vala"
	return FALSE;
#line 945 "MediaInterfaces.c"
}

void
monitorable_mark_online (Monitorable* self)
{
	MonitorableIface* _iface_;
#line 168 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 168 "../src/MediaInterfaces.vala"
	if (_iface_->mark_online) {
#line 168 "../src/MediaInterfaces.vala"
		_iface_->mark_online (self);
#line 960 "MediaInterfaces.c"
	}
}

void
monitorable_mark_offline (Monitorable* self)
{
	MonitorableIface* _iface_;
#line 170 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 170 "../src/MediaInterfaces.vala"
	if (_iface_->mark_offline) {
#line 170 "../src/MediaInterfaces.vala"
		_iface_->mark_offline (self);
#line 976 "MediaInterfaces.c"
	}
}

void
monitorable_mark_many_online_offline (GeeCollection* online,
                                      GeeCollection* offline,
                                      TransactionController* controller,
                                      GError** error)
{
#line 172 "../src/MediaInterfaces.vala"
	g_return_if_fail (controller != NULL);
#line 174 "../src/MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 176 "../src/MediaInterfaces.vala"
	if (online != NULL) {
#line 992 "MediaInterfaces.c"
		{
			GeeIterator* _monitorable_it = NULL;
			GeeIterator* _tmp0_;
#line 177 "../src/MediaInterfaces.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) online);
#line 177 "../src/MediaInterfaces.vala"
			_monitorable_it = _tmp0_;
#line 177 "../src/MediaInterfaces.vala"
			while (TRUE) {
#line 1002 "MediaInterfaces.c"
				GeeIterator* _tmp1_;
				Monitorable* monitorable = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Monitorable* _tmp4_;
#line 177 "../src/MediaInterfaces.vala"
				_tmp1_ = _monitorable_it;
#line 177 "../src/MediaInterfaces.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 177 "../src/MediaInterfaces.vala"
					break;
#line 1014 "MediaInterfaces.c"
				}
#line 177 "../src/MediaInterfaces.vala"
				_tmp2_ = _monitorable_it;
#line 177 "../src/MediaInterfaces.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 177 "../src/MediaInterfaces.vala"
				monitorable = (Monitorable*) _tmp3_;
#line 178 "../src/MediaInterfaces.vala"
				_tmp4_ = monitorable;
#line 178 "../src/MediaInterfaces.vala"
				monitorable_mark_online (_tmp4_);
#line 177 "../src/MediaInterfaces.vala"
				_g_object_unref0 (monitorable);
#line 1028 "MediaInterfaces.c"
			}
#line 177 "../src/MediaInterfaces.vala"
			_g_object_unref0 (_monitorable_it);
#line 1032 "MediaInterfaces.c"
		}
	}
#line 181 "../src/MediaInterfaces.vala"
	if (offline != NULL) {
#line 1037 "MediaInterfaces.c"
		{
			GeeIterator* _monitorable_it = NULL;
			GeeIterator* _tmp5_;
#line 182 "../src/MediaInterfaces.vala"
			_tmp5_ = gee_iterable_iterator ((GeeIterable*) offline);
#line 182 "../src/MediaInterfaces.vala"
			_monitorable_it = _tmp5_;
#line 182 "../src/MediaInterfaces.vala"
			while (TRUE) {
#line 1047 "MediaInterfaces.c"
				GeeIterator* _tmp6_;
				Monitorable* monitorable = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Monitorable* _tmp9_;
#line 182 "../src/MediaInterfaces.vala"
				_tmp6_ = _monitorable_it;
#line 182 "../src/MediaInterfaces.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 182 "../src/MediaInterfaces.vala"
					break;
#line 1059 "MediaInterfaces.c"
				}
#line 182 "../src/MediaInterfaces.vala"
				_tmp7_ = _monitorable_it;
#line 182 "../src/MediaInterfaces.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 182 "../src/MediaInterfaces.vala"
				monitorable = (Monitorable*) _tmp8_;
#line 183 "../src/MediaInterfaces.vala"
				_tmp9_ = monitorable;
#line 183 "../src/MediaInterfaces.vala"
				monitorable_mark_offline (_tmp9_);
#line 182 "../src/MediaInterfaces.vala"
				_g_object_unref0 (monitorable);
#line 1073 "MediaInterfaces.c"
			}
#line 182 "../src/MediaInterfaces.vala"
			_g_object_unref0 (_monitorable_it);
#line 1077 "MediaInterfaces.c"
		}
	}
#line 186 "../src/MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 1082 "MediaInterfaces.c"
}

void
monitorable_set_master_file (Monitorable* self,
                             GFile* file)
{
	MonitorableIface* _iface_;
#line 189 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 189 "../src/MediaInterfaces.vala"
	if (_iface_->set_master_file) {
#line 189 "../src/MediaInterfaces.vala"
		_iface_->set_master_file (self, file);
#line 1098 "MediaInterfaces.c"
	}
}

void
monitorable_set_many_master_file (GeeMap* map,
                                  TransactionController* controller,
                                  GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
#line 191 "../src/MediaInterfaces.vala"
	g_return_if_fail (map != NULL);
#line 191 "../src/MediaInterfaces.vala"
	g_return_if_fail (controller != NULL);
#line 193 "../src/MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 195 "../src/MediaInterfaces.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 195 "../src/MediaInterfaces.vala"
	map_iter = _tmp0_;
#line 196 "../src/MediaInterfaces.vala"
	while (TRUE) {
#line 1121 "MediaInterfaces.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Monitorable* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 196 "../src/MediaInterfaces.vala"
		_tmp1_ = map_iter;
#line 196 "../src/MediaInterfaces.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 196 "../src/MediaInterfaces.vala"
			break;
#line 1135 "MediaInterfaces.c"
		}
#line 197 "../src/MediaInterfaces.vala"
		_tmp2_ = map_iter;
#line 197 "../src/MediaInterfaces.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 197 "../src/MediaInterfaces.vala"
		_tmp4_ = (Monitorable*) _tmp3_;
#line 197 "../src/MediaInterfaces.vala"
		_tmp5_ = map_iter;
#line 197 "../src/MediaInterfaces.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 197 "../src/MediaInterfaces.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 197 "../src/MediaInterfaces.vala"
		monitorable_set_master_file (_tmp4_, _tmp7_);
#line 197 "../src/MediaInterfaces.vala"
		_g_object_unref0 (_tmp7_);
#line 197 "../src/MediaInterfaces.vala"
		_g_object_unref0 (_tmp4_);
#line 1155 "MediaInterfaces.c"
	}
#line 199 "../src/MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 191 "../src/MediaInterfaces.vala"
	_g_object_unref0 (map_iter);
#line 1161 "MediaInterfaces.c"
}

void
monitorable_set_master_timestamp (Monitorable* self,
                                  GFileInfo* info)
{
	MonitorableIface* _iface_;
#line 202 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/MediaInterfaces.vala"
	_iface_ = MONITORABLE_GET_INTERFACE (self);
#line 202 "../src/MediaInterfaces.vala"
	if (_iface_->set_master_timestamp) {
#line 202 "../src/MediaInterfaces.vala"
		_iface_->set_master_timestamp (self, info);
#line 1177 "MediaInterfaces.c"
	}
}

void
monitorable_set_many_master_timestamp (GeeMap* map,
                                       TransactionController* controller,
                                       GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
#line 204 "../src/MediaInterfaces.vala"
	g_return_if_fail (map != NULL);
#line 204 "../src/MediaInterfaces.vala"
	g_return_if_fail (controller != NULL);
#line 206 "../src/MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 208 "../src/MediaInterfaces.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 208 "../src/MediaInterfaces.vala"
	map_iter = _tmp0_;
#line 209 "../src/MediaInterfaces.vala"
	while (TRUE) {
#line 1200 "MediaInterfaces.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Monitorable* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFileInfo* _tmp7_;
#line 209 "../src/MediaInterfaces.vala"
		_tmp1_ = map_iter;
#line 209 "../src/MediaInterfaces.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 209 "../src/MediaInterfaces.vala"
			break;
#line 1214 "MediaInterfaces.c"
		}
#line 210 "../src/MediaInterfaces.vala"
		_tmp2_ = map_iter;
#line 210 "../src/MediaInterfaces.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 210 "../src/MediaInterfaces.vala"
		_tmp4_ = (Monitorable*) _tmp3_;
#line 210 "../src/MediaInterfaces.vala"
		_tmp5_ = map_iter;
#line 210 "../src/MediaInterfaces.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 210 "../src/MediaInterfaces.vala"
		_tmp7_ = (GFileInfo*) _tmp6_;
#line 210 "../src/MediaInterfaces.vala"
		monitorable_set_master_timestamp (_tmp4_, _tmp7_);
#line 210 "../src/MediaInterfaces.vala"
		_g_object_unref0 (_tmp7_);
#line 210 "../src/MediaInterfaces.vala"
		_g_object_unref0 (_tmp4_);
#line 1234 "MediaInterfaces.c"
	}
#line 212 "../src/MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 204 "../src/MediaInterfaces.vala"
	_g_object_unref0 (map_iter);
#line 1240 "MediaInterfaces.c"
}

static void
monitorable_default_init (MonitorableIface * iface,
                          gpointer iface_data)
{
}

static GType
monitorable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MonitorableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) monitorable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType monitorable_type_id;
	monitorable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Monitorable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (monitorable_type_id, TYPE_MEDIA_SOURCE);
	return monitorable_type_id;
}

GType
monitorable_get_type (void)
{
	static volatile gsize monitorable_type_id__once = 0;
	if (g_once_init_enter (&monitorable_type_id__once)) {
		GType monitorable_type_id;
		monitorable_type_id = monitorable_get_type_once ();
		g_once_init_leave (&monitorable_type_id__once, monitorable_type_id);
	}
	return monitorable_type_id__once;
}

void
dateable_set_exposure_time (Dateable* self,
                            gint64 target_time)
{
	DateableIface* _iface_;
#line 225 "../src/MediaInterfaces.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/MediaInterfaces.vala"
	_iface_ = DATEABLE_GET_INTERFACE (self);
#line 225 "../src/MediaInterfaces.vala"
	if (_iface_->set_exposure_time) {
#line 225 "../src/MediaInterfaces.vala"
		_iface_->set_exposure_time (self, target_time);
#line 1284 "MediaInterfaces.c"
	}
}

gint64
dateable_get_exposure_time (Dateable* self)
{
	DateableIface* _iface_;
#line 227 "../src/MediaInterfaces.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 227 "../src/MediaInterfaces.vala"
	_iface_ = DATEABLE_GET_INTERFACE (self);
#line 227 "../src/MediaInterfaces.vala"
	if (_iface_->get_exposure_time) {
#line 227 "../src/MediaInterfaces.vala"
		return _iface_->get_exposure_time (self);
#line 1300 "MediaInterfaces.c"
	}
#line 227 "../src/MediaInterfaces.vala"
	return -1LL;
#line 1304 "MediaInterfaces.c"
}

static void
dateable_default_init (DateableIface * iface,
                       gpointer iface_data)
{
}

static GType
dateable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dateable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dateable_type_id;
	dateable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Dateable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dateable_type_id, TYPE_MEDIA_SOURCE);
	return dateable_type_id;
}

GType
dateable_get_type (void)
{
	static volatile gsize dateable_type_id__once = 0;
	if (g_once_init_enter (&dateable_type_id__once)) {
		GType dateable_type_id;
		dateable_type_id = dateable_get_type_once ();
		g_once_init_leave (&dateable_type_id__once, dateable_type_id);
	}
	return dateable_type_id__once;
}

