/* MediaMetadata.c generated by valac 0.56.18, the Vala compiler
 * generated from MediaMetadata.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <stdio.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef struct _ParamSpecMediaMetadata ParamSpecMediaMetadata;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _ParamSpecMetadataDateTime ParamSpecMetadataDateTime;

struct _ParamSpecMediaMetadata {
	GParamSpec parent_instance;
};

struct _MetadataDateTimePrivate {
	gint64 timestamp;
};

struct _ParamSpecMetadataDateTime {
	GParamSpec parent_instance;
};

static gpointer media_metadata_parent_class = NULL;
static gint MetadataDateTime_private_offset;
static gpointer metadata_date_time_parent_class = NULL;

static void media_metadata_real_read_from_file (MediaMetadata* self,
                                         GFile* file,
                                         GError** error);
static MetadataDateTime* media_metadata_real_get_creation_date_time (MediaMetadata* self);
static gchar* media_metadata_real_get_title (MediaMetadata* self);
static gchar* media_metadata_real_get_comment (MediaMetadata* self);
static void media_metadata_finalize (MediaMetadata * obj);
static GType media_metadata_get_type_once (void);
static gboolean metadata_rational_is_component_valid (MetadataRational *self,
                                               gint component);
static gboolean metadata_date_time_from_exif_date_time (const gchar* date_time_s,
                                                 gint64* timestamp);
static void metadata_date_time_finalize (MetadataDateTime * obj);
static GType metadata_date_time_get_type_once (void);

MediaMetadata*
media_metadata_construct (GType object_type)
{
	MediaMetadata* self = NULL;
#line 21 "../src/MediaMetadata.vala"
	self = (MediaMetadata*) g_type_create_instance (object_type);
#line 21 "../src/MediaMetadata.vala"
	return self;
#line 89 "MediaMetadata.c"
}

static void
media_metadata_real_read_from_file (MediaMetadata* self,
                                    GFile* file,
                                    GError** error)
{
#line 24 "../src/MediaMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `media_metadata_read_from_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 24 "../src/MediaMetadata.vala"
	return;
#line 101 "MediaMetadata.c"
}

void
media_metadata_read_from_file (MediaMetadata* self,
                               GFile* file,
                               GError** error)
{
	MediaMetadataClass* _klass_;
#line 24 "../src/MediaMetadata.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/MediaMetadata.vala"
	_klass_ = MEDIA_METADATA_GET_CLASS (self);
#line 24 "../src/MediaMetadata.vala"
	if (_klass_->read_from_file) {
#line 24 "../src/MediaMetadata.vala"
		_klass_->read_from_file (self, file, error);
#line 118 "MediaMetadata.c"
	}
}

static MetadataDateTime*
media_metadata_real_get_creation_date_time (MediaMetadata* self)
{
#line 26 "../src/MediaMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_creation_date_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 26 "../src/MediaMetadata.vala"
	return NULL;
#line 129 "MediaMetadata.c"
}

MetadataDateTime*
media_metadata_get_creation_date_time (MediaMetadata* self)
{
	MediaMetadataClass* _klass_;
#line 26 "../src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/MediaMetadata.vala"
	_klass_ = MEDIA_METADATA_GET_CLASS (self);
#line 26 "../src/MediaMetadata.vala"
	if (_klass_->get_creation_date_time) {
#line 26 "../src/MediaMetadata.vala"
		return _klass_->get_creation_date_time (self);
#line 144 "MediaMetadata.c"
	}
#line 26 "../src/MediaMetadata.vala"
	return NULL;
#line 148 "MediaMetadata.c"
}

static gchar*
media_metadata_real_get_title (MediaMetadata* self)
{
#line 28 "../src/MediaMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_title'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 28 "../src/MediaMetadata.vala"
	return NULL;
#line 158 "MediaMetadata.c"
}

gchar*
media_metadata_get_title (MediaMetadata* self)
{
	MediaMetadataClass* _klass_;
#line 28 "../src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/MediaMetadata.vala"
	_klass_ = MEDIA_METADATA_GET_CLASS (self);
#line 28 "../src/MediaMetadata.vala"
	if (_klass_->get_title) {
#line 28 "../src/MediaMetadata.vala"
		return _klass_->get_title (self);
#line 173 "MediaMetadata.c"
	}
#line 28 "../src/MediaMetadata.vala"
	return NULL;
#line 177 "MediaMetadata.c"
}

static gchar*
media_metadata_real_get_comment (MediaMetadata* self)
{
#line 30 "../src/MediaMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_comment'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 30 "../src/MediaMetadata.vala"
	return NULL;
#line 187 "MediaMetadata.c"
}

gchar*
media_metadata_get_comment (MediaMetadata* self)
{
	MediaMetadataClass* _klass_;
#line 30 "../src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/MediaMetadata.vala"
	_klass_ = MEDIA_METADATA_GET_CLASS (self);
#line 30 "../src/MediaMetadata.vala"
	if (_klass_->get_comment) {
#line 30 "../src/MediaMetadata.vala"
		return _klass_->get_comment (self);
#line 202 "MediaMetadata.c"
	}
#line 30 "../src/MediaMetadata.vala"
	return NULL;
#line 206 "MediaMetadata.c"
}

static void
value_media_metadata_init (GValue* value)
{
#line 20 "../src/MediaMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 214 "MediaMetadata.c"
}

static void
value_media_metadata_free_value (GValue* value)
{
#line 20 "../src/MediaMetadata.vala"
	if (value->data[0].v_pointer) {
#line 20 "../src/MediaMetadata.vala"
		media_metadata_unref (value->data[0].v_pointer);
#line 224 "MediaMetadata.c"
	}
}

static void
value_media_metadata_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 20 "../src/MediaMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../src/MediaMetadata.vala"
		dest_value->data[0].v_pointer = media_metadata_ref (src_value->data[0].v_pointer);
#line 236 "MediaMetadata.c"
	} else {
#line 20 "../src/MediaMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 240 "MediaMetadata.c"
	}
}

static gpointer
value_media_metadata_peek_pointer (const GValue* value)
{
#line 20 "../src/MediaMetadata.vala"
	return value->data[0].v_pointer;
#line 249 "MediaMetadata.c"
}

static gchar*
value_media_metadata_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 20 "../src/MediaMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 260 "MediaMetadata.c"
		MediaMetadata * object;
		object = collect_values[0].v_pointer;
#line 20 "../src/MediaMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../src/MediaMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 267 "MediaMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../src/MediaMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 271 "MediaMetadata.c"
		}
#line 20 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = media_metadata_ref (object);
#line 275 "MediaMetadata.c"
	} else {
#line 20 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 279 "MediaMetadata.c"
	}
#line 20 "../src/MediaMetadata.vala"
	return NULL;
#line 283 "MediaMetadata.c"
}

static gchar*
value_media_metadata_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	MediaMetadata ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../src/MediaMetadata.vala"
	if (!object_p) {
#line 20 "../src/MediaMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 298 "MediaMetadata.c"
	}
#line 20 "../src/MediaMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../src/MediaMetadata.vala"
		*object_p = NULL;
#line 304 "MediaMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../src/MediaMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 308 "MediaMetadata.c"
	} else {
#line 20 "../src/MediaMetadata.vala"
		*object_p = media_metadata_ref (value->data[0].v_pointer);
#line 312 "MediaMetadata.c"
	}
#line 20 "../src/MediaMetadata.vala"
	return NULL;
#line 316 "MediaMetadata.c"
}

GParamSpec*
param_spec_media_metadata (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecMediaMetadata* spec;
#line 20 "../src/MediaMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MEDIA_METADATA), NULL);
#line 20 "../src/MediaMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../src/MediaMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../src/MediaMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 335 "MediaMetadata.c"
}

gpointer
value_get_media_metadata (const GValue* value)
{
#line 20 "../src/MediaMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA), NULL);
#line 20 "../src/MediaMetadata.vala"
	return value->data[0].v_pointer;
#line 345 "MediaMetadata.c"
}

void
value_set_media_metadata (GValue* value,
                          gpointer v_object)
{
	MediaMetadata * old;
#line 20 "../src/MediaMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA));
#line 20 "../src/MediaMetadata.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/MediaMetadata.vala"
	if (v_object) {
#line 20 "../src/MediaMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_METADATA));
#line 20 "../src/MediaMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../src/MediaMetadata.vala"
		media_metadata_ref (value->data[0].v_pointer);
#line 367 "MediaMetadata.c"
	} else {
#line 20 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 371 "MediaMetadata.c"
	}
#line 20 "../src/MediaMetadata.vala"
	if (old) {
#line 20 "../src/MediaMetadata.vala"
		media_metadata_unref (old);
#line 377 "MediaMetadata.c"
	}
}

void
value_take_media_metadata (GValue* value,
                           gpointer v_object)
{
	MediaMetadata * old;
#line 20 "../src/MediaMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA));
#line 20 "../src/MediaMetadata.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/MediaMetadata.vala"
	if (v_object) {
#line 20 "../src/MediaMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_METADATA));
#line 20 "../src/MediaMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 398 "MediaMetadata.c"
	} else {
#line 20 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 402 "MediaMetadata.c"
	}
#line 20 "../src/MediaMetadata.vala"
	if (old) {
#line 20 "../src/MediaMetadata.vala"
		media_metadata_unref (old);
#line 408 "MediaMetadata.c"
	}
}

static void
media_metadata_class_init (MediaMetadataClass * klass,
                           gpointer klass_data)
{
#line 20 "../src/MediaMetadata.vala"
	media_metadata_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->finalize = media_metadata_finalize;
#line 20 "../src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->read_from_file = (void (*) (MediaMetadata*, GFile*, GError**)) media_metadata_real_read_from_file;
#line 20 "../src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->get_creation_date_time = (MetadataDateTime* (*) (MediaMetadata*)) media_metadata_real_get_creation_date_time;
#line 20 "../src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->get_title = (gchar* (*) (MediaMetadata*)) media_metadata_real_get_title;
#line 20 "../src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->get_comment = (gchar* (*) (MediaMetadata*)) media_metadata_real_get_comment;
#line 428 "MediaMetadata.c"
}

static void
media_metadata_instance_init (MediaMetadata * self,
                              gpointer klass)
{
#line 20 "../src/MediaMetadata.vala"
	self->ref_count = 1;
#line 437 "MediaMetadata.c"
}

static void
media_metadata_finalize (MediaMetadata * obj)
{
	MediaMetadata * self;
#line 20 "../src/MediaMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_METADATA, MediaMetadata);
#line 20 "../src/MediaMetadata.vala"
	g_signal_handlers_destroy (self);
#line 448 "MediaMetadata.c"
}

static GType
media_metadata_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_media_metadata_init, value_media_metadata_free_value, value_media_metadata_copy_value, value_media_metadata_peek_pointer, "p", value_media_metadata_collect_value, "p", value_media_metadata_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MediaMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaMetadata), 0, (GInstanceInitFunc) media_metadata_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType media_metadata_type_id;
	media_metadata_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MediaMetadata", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return media_metadata_type_id;
}

GType
media_metadata_get_type (void)
{
	static volatile gsize media_metadata_type_id__once = 0;
	if (g_once_init_enter (&media_metadata_type_id__once)) {
		GType media_metadata_type_id;
		media_metadata_type_id = media_metadata_get_type_once ();
		g_once_init_leave (&media_metadata_type_id__once, media_metadata_type_id);
	}
	return media_metadata_type_id__once;
}

gpointer
media_metadata_ref (gpointer instance)
{
	MediaMetadata * self;
	self = instance;
#line 20 "../src/MediaMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../src/MediaMetadata.vala"
	return instance;
#line 483 "MediaMetadata.c"
}

void
media_metadata_unref (gpointer instance)
{
	MediaMetadata * self;
	self = instance;
#line 20 "../src/MediaMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../src/MediaMetadata.vala"
		MEDIA_METADATA_GET_CLASS (self)->finalize (self);
#line 20 "../src/MediaMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 497 "MediaMetadata.c"
	}
}

void
metadata_rational_init (MetadataRational *self,
                        gint numerator,
                        gint denominator)
{
#line 37 "../src/MediaMetadata.vala"
	memset (self, 0, sizeof (MetadataRational));
#line 38 "../src/MediaMetadata.vala"
	(*self).numerator = numerator;
#line 39 "../src/MediaMetadata.vala"
	(*self).denominator = denominator;
#line 512 "MediaMetadata.c"
}

static gboolean
metadata_rational_is_component_valid (MetadataRational *self,
                                      gint component)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 43 "../src/MediaMetadata.vala"
	if (component >= 0) {
#line 43 "../src/MediaMetadata.vala"
		_tmp0_ = component <= 1000000;
#line 525 "MediaMetadata.c"
	} else {
#line 43 "../src/MediaMetadata.vala"
		_tmp0_ = FALSE;
#line 529 "MediaMetadata.c"
	}
#line 43 "../src/MediaMetadata.vala"
	result = _tmp0_;
#line 43 "../src/MediaMetadata.vala"
	return result;
#line 535 "MediaMetadata.c"
}

gboolean
metadata_rational_is_valid (MetadataRational *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 47 "../src/MediaMetadata.vala"
	if (metadata_rational_is_component_valid (&(*self), (*self).numerator)) {
#line 47 "../src/MediaMetadata.vala"
		_tmp0_ = metadata_rational_is_component_valid (&(*self), (*self).denominator);
#line 547 "MediaMetadata.c"
	} else {
#line 47 "../src/MediaMetadata.vala"
		_tmp0_ = FALSE;
#line 551 "MediaMetadata.c"
	}
#line 47 "../src/MediaMetadata.vala"
	result = _tmp0_;
#line 47 "../src/MediaMetadata.vala"
	return result;
#line 557 "MediaMetadata.c"
}

gchar*
metadata_rational_to_string (MetadataRational *self)
{
	gchar* _tmp0_ = NULL;
	gchar* result;
#line 51 "../src/MediaMetadata.vala"
	if (metadata_rational_is_valid (&(*self))) {
#line 567 "MediaMetadata.c"
		gchar* _tmp1_;
#line 51 "../src/MediaMetadata.vala"
		_tmp1_ = g_strdup_printf ("%d/%d", (*self).numerator, (*self).denominator);
#line 51 "../src/MediaMetadata.vala"
		_g_free0 (_tmp0_);
#line 51 "../src/MediaMetadata.vala"
		_tmp0_ = _tmp1_;
#line 575 "MediaMetadata.c"
	} else {
		gchar* _tmp2_;
#line 51 "../src/MediaMetadata.vala"
		_tmp2_ = g_strdup ("");
#line 51 "../src/MediaMetadata.vala"
		_g_free0 (_tmp0_);
#line 51 "../src/MediaMetadata.vala"
		_tmp0_ = _tmp2_;
#line 584 "MediaMetadata.c"
	}
#line 51 "../src/MediaMetadata.vala"
	result = _tmp0_;
#line 51 "../src/MediaMetadata.vala"
	return result;
#line 590 "MediaMetadata.c"
}

MetadataRational*
metadata_rational_dup (const MetadataRational* self)
{
	MetadataRational* dup;
#line 33 "../src/MediaMetadata.vala"
	dup = g_new0 (MetadataRational, 1);
#line 33 "../src/MediaMetadata.vala"
	memcpy (dup, self, sizeof (MetadataRational));
#line 33 "../src/MediaMetadata.vala"
	return dup;
#line 603 "MediaMetadata.c"
}

void
metadata_rational_free (MetadataRational* self)
{
#line 33 "../src/MediaMetadata.vala"
	g_free (self);
#line 611 "MediaMetadata.c"
}

static GType
metadata_rational_get_type_once (void)
{
	GType metadata_rational_type_id;
	metadata_rational_type_id = g_boxed_type_register_static ("MetadataRational", (GBoxedCopyFunc) metadata_rational_dup, (GBoxedFreeFunc) metadata_rational_free);
	return metadata_rational_type_id;
}

GType
metadata_rational_get_type (void)
{
	static volatile gsize metadata_rational_type_id__once = 0;
	if (g_once_init_enter (&metadata_rational_type_id__once)) {
		GType metadata_rational_type_id;
		metadata_rational_type_id = metadata_rational_get_type_once ();
		g_once_init_leave (&metadata_rational_type_id__once, metadata_rational_type_id);
	}
	return metadata_rational_type_id__once;
}

GQuark
metadata_date_time_error_quark (void)
{
	return g_quark_from_static_string ("metadata-date-time-error-quark");
}

static GType
metadata_date_time_error_get_type_once (void)
{
	static const GEnumValue values[] = {{METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "METADATA_DATE_TIME_ERROR_INVALID_FORMAT", "invalid-format"}, {METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT, "METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT", "unsupported-format"}, {0, NULL, NULL}};
	GType metadata_date_time_error_type_id;
	metadata_date_time_error_type_id = g_enum_register_static ("MetadataDateTimeError", values);
	return metadata_date_time_error_type_id;
}

GType
metadata_date_time_error_get_type (void)
{
	static volatile gsize metadata_date_time_error_type_id__once = 0;
	if (g_once_init_enter (&metadata_date_time_error_type_id__once)) {
		GType metadata_date_time_error_type_id;
		metadata_date_time_error_type_id = metadata_date_time_error_get_type_once ();
		g_once_init_leave (&metadata_date_time_error_type_id__once, metadata_date_time_error_type_id);
	}
	return metadata_date_time_error_type_id__once;
}

static inline gpointer
metadata_date_time_get_instance_private (MetadataDateTime* self)
{
	return G_STRUCT_MEMBER_P (self, MetadataDateTime_private_offset);
}

MetadataDateTime*
metadata_date_time_construct (GType object_type,
                              gint64 timestamp)
{
	MetadataDateTime* self = NULL;
#line 63 "../src/MediaMetadata.vala"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 64 "../src/MediaMetadata.vala"
	self->priv->timestamp = timestamp;
#line 63 "../src/MediaMetadata.vala"
	return self;
#line 678 "MediaMetadata.c"
}

MetadataDateTime*
metadata_date_time_new (gint64 timestamp)
{
#line 63 "../src/MediaMetadata.vala"
	return metadata_date_time_construct (TYPE_METADATA_DATE_TIME, timestamp);
#line 686 "MediaMetadata.c"
}

MetadataDateTime*
metadata_date_time_construct_from_exif (GType object_type,
                                        const gchar* label,
                                        GError** error)
{
	MetadataDateTime* self = NULL;
	gint64 _tmp0_ = 0LL;
	gboolean _tmp1_;
	GError* _inner_error0_ = NULL;
#line 67 "../src/MediaMetadata.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 67 "../src/MediaMetadata.vala"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 68 "../src/MediaMetadata.vala"
	_tmp1_ = metadata_date_time_from_exif_date_time (label, &_tmp0_);
#line 68 "../src/MediaMetadata.vala"
	self->priv->timestamp = _tmp0_;
#line 68 "../src/MediaMetadata.vala"
	if (!_tmp1_) {
#line 708 "MediaMetadata.c"
		GError* _tmp2_;
#line 69 "../src/MediaMetadata.vala"
		_tmp2_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not EXIF format date/time", label);
#line 69 "../src/MediaMetadata.vala"
		_inner_error0_ = _tmp2_;
#line 69 "../src/MediaMetadata.vala"
		if (_inner_error0_->domain == METADATA_DATE_TIME_ERROR) {
#line 69 "../src/MediaMetadata.vala"
			g_propagate_error (error, _inner_error0_);
#line 69 "../src/MediaMetadata.vala"
			_metadata_date_time_unref0 (self);
#line 69 "../src/MediaMetadata.vala"
			return NULL;
#line 722 "MediaMetadata.c"
		} else {
#line 69 "../src/MediaMetadata.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/MediaMetadata.vala"
			g_clear_error (&_inner_error0_);
#line 69 "../src/MediaMetadata.vala"
			return NULL;
#line 730 "MediaMetadata.c"
		}
	}
#line 67 "../src/MediaMetadata.vala"
	return self;
#line 735 "MediaMetadata.c"
}

MetadataDateTime*
metadata_date_time_new_from_exif (const gchar* label,
                                  GError** error)
{
#line 67 "../src/MediaMetadata.vala"
	return metadata_date_time_construct_from_exif (TYPE_METADATA_DATE_TIME, label, error);
#line 744 "MediaMetadata.c"
}

MetadataDateTime*
metadata_date_time_construct_from_xmp (GType object_type,
                                       const gchar* label,
                                       GError** error)
{
	MetadataDateTime* self = NULL;
	GDateTime* date_time = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 72 "../src/MediaMetadata.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 72 "../src/MediaMetadata.vala"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 73 "../src/MediaMetadata.vala"
	_tmp0_ = g_date_time_new_from_iso8601 (label, NULL);
#line 73 "../src/MediaMetadata.vala"
	date_time = _tmp0_;
#line 74 "../src/MediaMetadata.vala"
	_tmp1_ = date_time;
#line 74 "../src/MediaMetadata.vala"
	if (_tmp1_ == NULL) {
#line 770 "MediaMetadata.c"
		GError* _tmp2_;
#line 75 "../src/MediaMetadata.vala"
		_tmp2_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not XMP format date/time", label);
#line 75 "../src/MediaMetadata.vala"
		_inner_error0_ = _tmp2_;
#line 75 "../src/MediaMetadata.vala"
		if (_inner_error0_->domain == METADATA_DATE_TIME_ERROR) {
#line 75 "../src/MediaMetadata.vala"
			g_propagate_error (error, _inner_error0_);
#line 75 "../src/MediaMetadata.vala"
			_g_date_time_unref0 (date_time);
#line 75 "../src/MediaMetadata.vala"
			_metadata_date_time_unref0 (self);
#line 75 "../src/MediaMetadata.vala"
			return NULL;
#line 786 "MediaMetadata.c"
		} else {
#line 75 "../src/MediaMetadata.vala"
			_g_date_time_unref0 (date_time);
#line 75 "../src/MediaMetadata.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/MediaMetadata.vala"
			g_clear_error (&_inner_error0_);
#line 75 "../src/MediaMetadata.vala"
			return NULL;
#line 796 "MediaMetadata.c"
		}
	}
#line 77 "../src/MediaMetadata.vala"
	_tmp3_ = date_time;
#line 77 "../src/MediaMetadata.vala"
	self->priv->timestamp = g_date_time_to_unix (_tmp3_);
#line 72 "../src/MediaMetadata.vala"
	_g_date_time_unref0 (date_time);
#line 72 "../src/MediaMetadata.vala"
	return self;
#line 807 "MediaMetadata.c"
}

MetadataDateTime*
metadata_date_time_new_from_xmp (const gchar* label,
                                 GError** error)
{
#line 72 "../src/MediaMetadata.vala"
	return metadata_date_time_construct_from_xmp (TYPE_METADATA_DATE_TIME, label, error);
#line 816 "MediaMetadata.c"
}

gint64
metadata_date_time_get_timestamp (MetadataDateTime* self)
{
	gint64 result;
#line 80 "../src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 81 "../src/MediaMetadata.vala"
	result = self->priv->timestamp;
#line 81 "../src/MediaMetadata.vala"
	return result;
#line 829 "MediaMetadata.c"
}

gchar*
metadata_date_time_get_exif_label (MetadataDateTime* self)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 84 "../src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../src/MediaMetadata.vala"
	_tmp0_ = g_date_time_new_from_unix_utc (self->priv->timestamp);
#line 85 "../src/MediaMetadata.vala"
	_tmp1_ = _tmp0_;
#line 85 "../src/MediaMetadata.vala"
	_tmp2_ = g_date_time_format (_tmp1_, "%Y:%m:%d %H:%M:%S");
#line 85 "../src/MediaMetadata.vala"
	_tmp3_ = _tmp2_;
#line 85 "../src/MediaMetadata.vala"
	_g_date_time_unref0 (_tmp1_);
#line 85 "../src/MediaMetadata.vala"
	result = _tmp3_;
#line 85 "../src/MediaMetadata.vala"
	return result;
#line 856 "MediaMetadata.c"
}

gchar*
metadata_date_time_get_xmp_label (MetadataDateTime* self)
{
	GDateTime* date_time = NULL;
	GDateTime* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 88 "../src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../src/MediaMetadata.vala"
	_tmp0_ = g_date_time_new_from_unix_utc (self->priv->timestamp);
#line 89 "../src/MediaMetadata.vala"
	date_time = _tmp0_;
#line 90 "../src/MediaMetadata.vala"
	_tmp1_ = g_date_time_format_iso8601 (date_time);
#line 90 "../src/MediaMetadata.vala"
	result = _tmp1_;
#line 90 "../src/MediaMetadata.vala"
	_g_date_time_unref0 (date_time);
#line 90 "../src/MediaMetadata.vala"
	return result;
#line 880 "MediaMetadata.c"
}

static gboolean
metadata_date_time_from_exif_date_time (const gchar* date_time_s,
                                        gint64* timestamp)
{
	gint64 _vala_timestamp = 0LL;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gint second = 0;
	GDateTime* date_time = NULL;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gboolean result;
#line 93 "../src/MediaMetadata.vala"
	g_return_val_if_fail (date_time_s != NULL, FALSE);
#line 94 "../src/MediaMetadata.vala"
	_vala_timestamp = (gint64) 0;
#line 97 "../src/MediaMetadata.vala"
	year = 0;
#line 98 "../src/MediaMetadata.vala"
	month = 0;
#line 99 "../src/MediaMetadata.vala"
	day = 0;
#line 100 "../src/MediaMetadata.vala"
	hour = 0;
#line 101 "../src/MediaMetadata.vala"
	minute = 0;
#line 102 "../src/MediaMetadata.vala"
	second = 0;
#line 104 "../src/MediaMetadata.vala"
	if (sscanf (date_time_s, "%d:%d:%d %d:%d:%d", &year, &month, &day, &hour, &minute, &second) != 6) {
#line 917 "MediaMetadata.c"
		gchar* tmp = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 107 "../src/MediaMetadata.vala"
		_tmp0_ = g_strdup (date_time_s);
#line 107 "../src/MediaMetadata.vala"
		tmp = _tmp0_;
#line 108 "../src/MediaMetadata.vala"
		_tmp1_ = tmp;
#line 108 "../src/MediaMetadata.vala"
		g_strcanon (_tmp1_, "0123456789", ' ');
#line 109 "../src/MediaMetadata.vala"
		_tmp2_ = tmp;
#line 109 "../src/MediaMetadata.vala"
		if (sscanf (_tmp2_, "%4d%2d%2d%2d%2d%2d", year, month, day, hour, minute, second) != 6) {
#line 111 "../src/MediaMetadata.vala"
			result = FALSE;
#line 111 "../src/MediaMetadata.vala"
			_g_free0 (tmp);
#line 111 "../src/MediaMetadata.vala"
			if (timestamp) {
#line 111 "../src/MediaMetadata.vala"
				*timestamp = _vala_timestamp;
#line 942 "MediaMetadata.c"
			}
#line 111 "../src/MediaMetadata.vala"
			return result;
#line 946 "MediaMetadata.c"
		}
#line 104 "../src/MediaMetadata.vala"
		_g_free0 (tmp);
#line 950 "MediaMetadata.c"
	}
#line 115 "../src/MediaMetadata.vala"
	_tmp3_ = g_date_time_new_local (year, month, day, hour, minute, (gdouble) second);
#line 115 "../src/MediaMetadata.vala"
	date_time = _tmp3_;
#line 117 "../src/MediaMetadata.vala"
	_tmp4_ = date_time;
#line 117 "../src/MediaMetadata.vala"
	if (_tmp4_ == NULL) {
#line 118 "../src/MediaMetadata.vala"
		result = FALSE;
#line 118 "../src/MediaMetadata.vala"
		_g_date_time_unref0 (date_time);
#line 118 "../src/MediaMetadata.vala"
		if (timestamp) {
#line 118 "../src/MediaMetadata.vala"
			*timestamp = _vala_timestamp;
#line 968 "MediaMetadata.c"
		}
#line 118 "../src/MediaMetadata.vala"
		return result;
#line 972 "MediaMetadata.c"
	}
#line 121 "../src/MediaMetadata.vala"
	_tmp5_ = date_time;
#line 121 "../src/MediaMetadata.vala"
	_vala_timestamp = g_date_time_to_unix (_tmp5_);
#line 123 "../src/MediaMetadata.vala"
	result = TRUE;
#line 123 "../src/MediaMetadata.vala"
	_g_date_time_unref0 (date_time);
#line 123 "../src/MediaMetadata.vala"
	if (timestamp) {
#line 123 "../src/MediaMetadata.vala"
		*timestamp = _vala_timestamp;
#line 986 "MediaMetadata.c"
	}
#line 123 "../src/MediaMetadata.vala"
	return result;
#line 990 "MediaMetadata.c"
}

static void
value_metadata_date_time_init (GValue* value)
{
#line 60 "../src/MediaMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 998 "MediaMetadata.c"
}

static void
value_metadata_date_time_free_value (GValue* value)
{
#line 60 "../src/MediaMetadata.vala"
	if (value->data[0].v_pointer) {
#line 60 "../src/MediaMetadata.vala"
		metadata_date_time_unref (value->data[0].v_pointer);
#line 1008 "MediaMetadata.c"
	}
}

static void
value_metadata_date_time_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
#line 60 "../src/MediaMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 60 "../src/MediaMetadata.vala"
		dest_value->data[0].v_pointer = metadata_date_time_ref (src_value->data[0].v_pointer);
#line 1020 "MediaMetadata.c"
	} else {
#line 60 "../src/MediaMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1024 "MediaMetadata.c"
	}
}

static gpointer
value_metadata_date_time_peek_pointer (const GValue* value)
{
#line 60 "../src/MediaMetadata.vala"
	return value->data[0].v_pointer;
#line 1033 "MediaMetadata.c"
}

static gchar*
value_metadata_date_time_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
#line 60 "../src/MediaMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1044 "MediaMetadata.c"
		MetadataDateTime * object;
		object = collect_values[0].v_pointer;
#line 60 "../src/MediaMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 60 "../src/MediaMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1051 "MediaMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 60 "../src/MediaMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1055 "MediaMetadata.c"
		}
#line 60 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = metadata_date_time_ref (object);
#line 1059 "MediaMetadata.c"
	} else {
#line 60 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1063 "MediaMetadata.c"
	}
#line 60 "../src/MediaMetadata.vala"
	return NULL;
#line 1067 "MediaMetadata.c"
}

static gchar*
value_metadata_date_time_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	MetadataDateTime ** object_p;
	object_p = collect_values[0].v_pointer;
#line 60 "../src/MediaMetadata.vala"
	if (!object_p) {
#line 60 "../src/MediaMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1082 "MediaMetadata.c"
	}
#line 60 "../src/MediaMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 60 "../src/MediaMetadata.vala"
		*object_p = NULL;
#line 1088 "MediaMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 60 "../src/MediaMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1092 "MediaMetadata.c"
	} else {
#line 60 "../src/MediaMetadata.vala"
		*object_p = metadata_date_time_ref (value->data[0].v_pointer);
#line 1096 "MediaMetadata.c"
	}
#line 60 "../src/MediaMetadata.vala"
	return NULL;
#line 1100 "MediaMetadata.c"
}

GParamSpec*
param_spec_metadata_date_time (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	ParamSpecMetadataDateTime* spec;
#line 60 "../src/MediaMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_METADATA_DATE_TIME), NULL);
#line 60 "../src/MediaMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 60 "../src/MediaMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 60 "../src/MediaMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1119 "MediaMetadata.c"
}

gpointer
value_get_metadata_date_time (const GValue* value)
{
#line 60 "../src/MediaMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME), NULL);
#line 60 "../src/MediaMetadata.vala"
	return value->data[0].v_pointer;
#line 1129 "MediaMetadata.c"
}

void
value_set_metadata_date_time (GValue* value,
                              gpointer v_object)
{
	MetadataDateTime * old;
#line 60 "../src/MediaMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
#line 60 "../src/MediaMetadata.vala"
	old = value->data[0].v_pointer;
#line 60 "../src/MediaMetadata.vala"
	if (v_object) {
#line 60 "../src/MediaMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
#line 60 "../src/MediaMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 60 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 60 "../src/MediaMetadata.vala"
		metadata_date_time_ref (value->data[0].v_pointer);
#line 1151 "MediaMetadata.c"
	} else {
#line 60 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1155 "MediaMetadata.c"
	}
#line 60 "../src/MediaMetadata.vala"
	if (old) {
#line 60 "../src/MediaMetadata.vala"
		metadata_date_time_unref (old);
#line 1161 "MediaMetadata.c"
	}
}

void
value_take_metadata_date_time (GValue* value,
                               gpointer v_object)
{
	MetadataDateTime * old;
#line 60 "../src/MediaMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
#line 60 "../src/MediaMetadata.vala"
	old = value->data[0].v_pointer;
#line 60 "../src/MediaMetadata.vala"
	if (v_object) {
#line 60 "../src/MediaMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
#line 60 "../src/MediaMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 60 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1182 "MediaMetadata.c"
	} else {
#line 60 "../src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1186 "MediaMetadata.c"
	}
#line 60 "../src/MediaMetadata.vala"
	if (old) {
#line 60 "../src/MediaMetadata.vala"
		metadata_date_time_unref (old);
#line 1192 "MediaMetadata.c"
	}
}

static void
metadata_date_time_class_init (MetadataDateTimeClass * klass,
                               gpointer klass_data)
{
#line 60 "../src/MediaMetadata.vala"
	metadata_date_time_parent_class = g_type_class_peek_parent (klass);
#line 60 "../src/MediaMetadata.vala"
	((MetadataDateTimeClass *) klass)->finalize = metadata_date_time_finalize;
#line 60 "../src/MediaMetadata.vala"
	g_type_class_adjust_private_offset (klass, &MetadataDateTime_private_offset);
#line 1206 "MediaMetadata.c"
}

static void
metadata_date_time_instance_init (MetadataDateTime * self,
                                  gpointer klass)
{
#line 60 "../src/MediaMetadata.vala"
	self->priv = metadata_date_time_get_instance_private (self);
#line 60 "../src/MediaMetadata.vala"
	self->ref_count = 1;
#line 1217 "MediaMetadata.c"
}

static void
metadata_date_time_finalize (MetadataDateTime * obj)
{
	MetadataDateTime * self;
#line 60 "../src/MediaMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_METADATA_DATE_TIME, MetadataDateTime);
#line 60 "../src/MediaMetadata.vala"
	g_signal_handlers_destroy (self);
#line 1228 "MediaMetadata.c"
}

static GType
metadata_date_time_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_metadata_date_time_init, value_metadata_date_time_free_value, value_metadata_date_time_copy_value, value_metadata_date_time_peek_pointer, "p", value_metadata_date_time_collect_value, "p", value_metadata_date_time_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MetadataDateTimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_date_time_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataDateTime), 0, (GInstanceInitFunc) metadata_date_time_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType metadata_date_time_type_id;
	metadata_date_time_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MetadataDateTime", &g_define_type_info, &g_define_type_fundamental_info, 0);
	MetadataDateTime_private_offset = g_type_add_instance_private (metadata_date_time_type_id, sizeof (MetadataDateTimePrivate));
	return metadata_date_time_type_id;
}

GType
metadata_date_time_get_type (void)
{
	static volatile gsize metadata_date_time_type_id__once = 0;
	if (g_once_init_enter (&metadata_date_time_type_id__once)) {
		GType metadata_date_time_type_id;
		metadata_date_time_type_id = metadata_date_time_get_type_once ();
		g_once_init_leave (&metadata_date_time_type_id__once, metadata_date_time_type_id);
	}
	return metadata_date_time_type_id__once;
}

gpointer
metadata_date_time_ref (gpointer instance)
{
	MetadataDateTime * self;
	self = instance;
#line 60 "../src/MediaMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 60 "../src/MediaMetadata.vala"
	return instance;
#line 1264 "MediaMetadata.c"
}

void
metadata_date_time_unref (gpointer instance)
{
	MetadataDateTime * self;
	self = instance;
#line 60 "../src/MediaMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 60 "../src/MediaMetadata.vala"
		METADATA_DATE_TIME_GET_CLASS (self)->finalize (self);
#line 60 "../src/MediaMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1278 "MediaMetadata.c"
	}
}

