/* MediaMonitor.c generated by valac 0.56.18, the Vala compiler
 * generated from MediaMonitor.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define MEDIA_MONITOR_FLUSH_PENDING_UPDATES_MSEC 500
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecMonitorableUpdates ParamSpecMonitorableUpdates;
enum  {
	MEDIA_MONITOR_0_PROPERTY,
	MEDIA_MONITOR_NUM_PROPERTIES
};
static GParamSpec* media_monitor_properties[MEDIA_MONITOR_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _monitorable_updates_unref0(var) ((var == NULL) ? NULL : (var = (monitorable_updates_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))

struct _MonitorableUpdatesPrivate {
	GFile* master_file;
	gboolean master_file_info_altered;
	GFileInfo* master_file_info;
	gboolean master_in_alteration;
	gboolean online;
	gboolean offline;
};

struct _ParamSpecMonitorableUpdates {
	GParamSpec parent_instance;
};

struct _MediaMonitorPrivate {
	MediaSourceCollection* sources;
	GCancellable* cancellable;
	GeeHashMap* pending_updates;
	guint pending_updates_timer_id;
};

static gint MonitorableUpdates_private_offset;
static gpointer monitorable_updates_parent_class = NULL;
static gint MediaMonitor_private_offset;
static gpointer media_monitor_parent_class = NULL;

static gboolean monitorable_updates_real_is_in_alteration (MonitorableUpdates* self);
static void monitorable_updates_real_set_master_file (MonitorableUpdates* self,
                                               GFile* file);
static void monitorable_updates_real_set_master_file_info_altered (MonitorableUpdates* self,
                                                            gboolean altered);
static void monitorable_updates_real_set_master_file_info (MonitorableUpdates* self,
                                                    GFileInfo* info);
static void monitorable_updates_real_set_master_in_alteration (MonitorableUpdates* self,
                                                        gboolean in_alteration);
static void monitorable_updates_real_set_master_alterations_complete (MonitorableUpdates* self,
                                                               GFileInfo* info);
static void monitorable_updates_real_mark_offline (MonitorableUpdates* self);
static void monitorable_updates_real_mark_online (MonitorableUpdates* self);
static void monitorable_updates_real_reset_online_offline (MonitorableUpdates* self);
static gboolean monitorable_updates_real_is_all_updated (MonitorableUpdates* self);
static void monitorable_updates_finalize (MonitorableUpdates * obj);
static GType monitorable_updates_get_type_once (void);
static void _media_monitor_on_media_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                DataSource* source,
                                                                                gpointer self);
static void _media_monitor_on_media_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender,
                                                                                    DataSource* source,
                                                                                    gpointer self);
static gboolean media_monitor_on_flush_pending_updates (MediaMonitor* self);
static gboolean _media_monitor_on_flush_pending_updates_gsource_func (gpointer self);
static MediaSourceCollection* media_monitor_real_get_media_source_collection (MediaMonitor* self);
static void media_monitor_real_close (MediaMonitor* self);
static gchar* media_monitor_real_to_string (MediaMonitor* self);
static MonitorableUpdates* media_monitor_real_create_updates (MediaMonitor* self,
                                                       Monitorable* monitorable);
static void media_monitor_real_on_media_source_destroyed (MediaMonitor* self,
                                                   DataSource* source);
static void media_monitor_real_notify_discovery_started (MediaMonitor* self);
static MediaMonitorDiscoveredFile media_monitor_real_notify_file_discovered (MediaMonitor* self,
                                                                      GFile* file,
                                                                      GFileInfo* info,
                                                                      Monitorable** monitorable);
static GeeCollection* media_monitor_real_candidates_for_unknown_file (MediaMonitor* self,
                                                               GFile* file,
                                                               GFileInfo* info,
                                                               MediaMonitorDiscoveredFile* _result_);
static GFile** media_monitor_real_get_auxilliary_backing_files (MediaMonitor* self,
                                                         Monitorable* monitorable,
                                                         gint* result_length1);
static void media_monitor_real_update_backing_file_info (MediaMonitor* self,
                                                  Monitorable* monitorable,
                                                  GFile* file,
                                                  GFileInfo* info);
static void media_monitor_real_notify_discovery_completing (MediaMonitor* self);
static gboolean media_monitor_real_is_file_represented (MediaMonitor* self,
                                                 GFile* file);
static gboolean media_monitor_real_notify_file_created (MediaMonitor* self,
                                                 GFile* file,
                                                 GFileInfo* info);
static gboolean media_monitor_real_notify_file_moved (MediaMonitor* self,
                                               GFile* old_file,
                                               GFile* new_file,
                                               GFileInfo* new_file_info);
static gboolean media_monitor_real_notify_file_altered (MediaMonitor* self,
                                                 GFile* file);
static gboolean media_monitor_real_notify_file_attributes_altered (MediaMonitor* self,
                                                            GFile* file);
static gboolean media_monitor_real_notify_file_alteration_completed (MediaMonitor* self,
                                                              GFile* file,
                                                              GFileInfo* info);
static gboolean media_monitor_real_notify_file_deleted (MediaMonitor* self,
                                                 GFile* file);
static void media_monitor_real_process_updates (MediaMonitor* self,
                                         GeeCollection* all_updates,
                                         TransactionController* controller,
                                         gint* op_count,
                                         GError** error);
static void media_monitor_finalize (GObject * obj);
static GType media_monitor_get_type_once (void);

static inline gpointer
monitorable_updates_get_instance_private (MonitorableUpdates* self)
{
	return G_STRUCT_MEMBER_P (self, MonitorableUpdates_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../src/MediaMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 171 "MediaMonitor.c"
}

MonitorableUpdates*
monitorable_updates_construct (GType object_type,
                               Monitorable* monitorable)
{
	MonitorableUpdates* self = NULL;
	Monitorable* _tmp0_;
#line 30 "../src/MediaMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 30 "../src/MediaMonitor.vala"
	self = (MonitorableUpdates*) g_type_create_instance (object_type);
#line 31 "../src/MediaMonitor.vala"
	_tmp0_ = _g_object_ref0 (monitorable);
#line 31 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->monitorable);
#line 31 "../src/MediaMonitor.vala"
	self->monitorable = _tmp0_;
#line 30 "../src/MediaMonitor.vala"
	return self;
#line 192 "MediaMonitor.c"
}

MonitorableUpdates*
monitorable_updates_new (Monitorable* monitorable)
{
#line 30 "../src/MediaMonitor.vala"
	return monitorable_updates_construct (TYPE_MONITORABLE_UPDATES, monitorable);
#line 200 "MediaMonitor.c"
}

GFile*
monitorable_updates_get_master_file (MonitorableUpdates* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
#line 34 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->master_file;
#line 35 "../src/MediaMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 35 "../src/MediaMonitor.vala"
	result = _tmp1_;
#line 35 "../src/MediaMonitor.vala"
	return result;
#line 219 "MediaMonitor.c"
}

GFileInfo*
monitorable_updates_get_master_file_info (MonitorableUpdates* self)
{
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* result;
#line 38 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->master_file_info;
#line 39 "../src/MediaMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 39 "../src/MediaMonitor.vala"
	result = _tmp1_;
#line 39 "../src/MediaMonitor.vala"
	return result;
#line 238 "MediaMonitor.c"
}

static gboolean
monitorable_updates_real_is_in_alteration (MonitorableUpdates* self)
{
	gboolean result;
#line 43 "../src/MediaMonitor.vala"
	result = self->priv->master_in_alteration;
#line 43 "../src/MediaMonitor.vala"
	return result;
#line 249 "MediaMonitor.c"
}

gboolean
monitorable_updates_is_in_alteration (MonitorableUpdates* self)
{
	MonitorableUpdatesClass* _klass_;
#line 42 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 42 "../src/MediaMonitor.vala"
	if (_klass_->is_in_alteration) {
#line 42 "../src/MediaMonitor.vala"
		return _klass_->is_in_alteration (self);
#line 264 "MediaMonitor.c"
	}
#line 42 "../src/MediaMonitor.vala"
	return FALSE;
#line 268 "MediaMonitor.c"
}

gboolean
monitorable_updates_is_set_offline (MonitorableUpdates* self)
{
	gboolean result;
#line 46 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../src/MediaMonitor.vala"
	result = self->priv->offline;
#line 47 "../src/MediaMonitor.vala"
	return result;
#line 281 "MediaMonitor.c"
}

gboolean
monitorable_updates_is_set_online (MonitorableUpdates* self)
{
	gboolean result;
#line 50 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/MediaMonitor.vala"
	result = self->priv->online;
#line 51 "../src/MediaMonitor.vala"
	return result;
#line 294 "MediaMonitor.c"
}

static void
monitorable_updates_real_set_master_file (MonitorableUpdates* self,
                                          GFile* file)
{
	GFile* _tmp0_;
#line 55 "../src/MediaMonitor.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 55 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->priv->master_file);
#line 55 "../src/MediaMonitor.vala"
	self->priv->master_file = _tmp0_;
#line 57 "../src/MediaMonitor.vala"
	if (file != NULL) {
#line 58 "../src/MediaMonitor.vala"
		monitorable_updates_mark_online (self);
#line 312 "MediaMonitor.c"
	}
}

void
monitorable_updates_set_master_file (MonitorableUpdates* self,
                                     GFile* file)
{
	MonitorableUpdatesClass* _klass_;
#line 54 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 54 "../src/MediaMonitor.vala"
	if (_klass_->set_master_file) {
#line 54 "../src/MediaMonitor.vala"
		_klass_->set_master_file (self, file);
#line 329 "MediaMonitor.c"
	}
}

static void
monitorable_updates_real_set_master_file_info_altered (MonitorableUpdates* self,
                                                       gboolean altered)
{
#line 62 "../src/MediaMonitor.vala"
	self->priv->master_file_info_altered = altered;
#line 64 "../src/MediaMonitor.vala"
	if (altered) {
#line 65 "../src/MediaMonitor.vala"
		monitorable_updates_mark_online (self);
#line 343 "MediaMonitor.c"
	}
}

void
monitorable_updates_set_master_file_info_altered (MonitorableUpdates* self,
                                                  gboolean altered)
{
	MonitorableUpdatesClass* _klass_;
#line 61 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 61 "../src/MediaMonitor.vala"
	if (_klass_->set_master_file_info_altered) {
#line 61 "../src/MediaMonitor.vala"
		_klass_->set_master_file_info_altered (self, altered);
#line 360 "MediaMonitor.c"
	}
}

static void
monitorable_updates_real_set_master_file_info (MonitorableUpdates* self,
                                               GFileInfo* info)
{
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
#line 69 "../src/MediaMonitor.vala"
	_tmp0_ = _g_object_ref0 (info);
#line 69 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->priv->master_file_info);
#line 69 "../src/MediaMonitor.vala"
	self->priv->master_file_info = _tmp0_;
#line 71 "../src/MediaMonitor.vala"
	_tmp1_ = self->priv->master_file_info;
#line 71 "../src/MediaMonitor.vala"
	if (_tmp1_ == NULL) {
#line 72 "../src/MediaMonitor.vala"
		monitorable_updates_set_master_file_info_altered (self, FALSE);
#line 382 "MediaMonitor.c"
	}
}

void
monitorable_updates_set_master_file_info (MonitorableUpdates* self,
                                          GFileInfo* info)
{
	MonitorableUpdatesClass* _klass_;
#line 68 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 68 "../src/MediaMonitor.vala"
	if (_klass_->set_master_file_info) {
#line 68 "../src/MediaMonitor.vala"
		_klass_->set_master_file_info (self, info);
#line 399 "MediaMonitor.c"
	}
}

static void
monitorable_updates_real_set_master_in_alteration (MonitorableUpdates* self,
                                                   gboolean in_alteration)
{
#line 76 "../src/MediaMonitor.vala"
	self->priv->master_in_alteration = in_alteration;
#line 409 "MediaMonitor.c"
}

void
monitorable_updates_set_master_in_alteration (MonitorableUpdates* self,
                                              gboolean in_alteration)
{
	MonitorableUpdatesClass* _klass_;
#line 75 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 75 "../src/MediaMonitor.vala"
	if (_klass_->set_master_in_alteration) {
#line 75 "../src/MediaMonitor.vala"
		_klass_->set_master_in_alteration (self, in_alteration);
#line 425 "MediaMonitor.c"
	}
}

static void
monitorable_updates_real_set_master_alterations_complete (MonitorableUpdates* self,
                                                          GFileInfo* info)
{
#line 79 "../src/MediaMonitor.vala"
	g_return_if_fail (info != NULL);
#line 80 "../src/MediaMonitor.vala"
	monitorable_updates_set_master_in_alteration (self, FALSE);
#line 81 "../src/MediaMonitor.vala"
	monitorable_updates_set_master_file_info (self, info);
#line 82 "../src/MediaMonitor.vala"
	monitorable_updates_mark_online (self);
#line 441 "MediaMonitor.c"
}

void
monitorable_updates_set_master_alterations_complete (MonitorableUpdates* self,
                                                     GFileInfo* info)
{
	MonitorableUpdatesClass* _klass_;
#line 79 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 79 "../src/MediaMonitor.vala"
	if (_klass_->set_master_alterations_complete) {
#line 79 "../src/MediaMonitor.vala"
		_klass_->set_master_alterations_complete (self, info);
#line 457 "MediaMonitor.c"
	}
}

static void
monitorable_updates_real_mark_offline (MonitorableUpdates* self)
{
#line 86 "../src/MediaMonitor.vala"
	self->priv->online = FALSE;
#line 87 "../src/MediaMonitor.vala"
	self->priv->offline = TRUE;
#line 89 "../src/MediaMonitor.vala"
	self->priv->master_file_info_altered = FALSE;
#line 90 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->priv->master_file_info);
#line 90 "../src/MediaMonitor.vala"
	self->priv->master_file_info = NULL;
#line 91 "../src/MediaMonitor.vala"
	self->priv->master_in_alteration = FALSE;
#line 476 "MediaMonitor.c"
}

void
monitorable_updates_mark_offline (MonitorableUpdates* self)
{
	MonitorableUpdatesClass* _klass_;
#line 85 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 85 "../src/MediaMonitor.vala"
	if (_klass_->mark_offline) {
#line 85 "../src/MediaMonitor.vala"
		_klass_->mark_offline (self);
#line 491 "MediaMonitor.c"
	}
}

static void
monitorable_updates_real_mark_online (MonitorableUpdates* self)
{
#line 95 "../src/MediaMonitor.vala"
	self->priv->online = TRUE;
#line 96 "../src/MediaMonitor.vala"
	self->priv->offline = FALSE;
#line 502 "MediaMonitor.c"
}

void
monitorable_updates_mark_online (MonitorableUpdates* self)
{
	MonitorableUpdatesClass* _klass_;
#line 94 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 94 "../src/MediaMonitor.vala"
	if (_klass_->mark_online) {
#line 94 "../src/MediaMonitor.vala"
		_klass_->mark_online (self);
#line 517 "MediaMonitor.c"
	}
}

static void
monitorable_updates_real_reset_online_offline (MonitorableUpdates* self)
{
#line 100 "../src/MediaMonitor.vala"
	self->priv->online = FALSE;
#line 101 "../src/MediaMonitor.vala"
	self->priv->offline = FALSE;
#line 528 "MediaMonitor.c"
}

void
monitorable_updates_reset_online_offline (MonitorableUpdates* self)
{
	MonitorableUpdatesClass* _klass_;
#line 99 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 99 "../src/MediaMonitor.vala"
	if (_klass_->reset_online_offline) {
#line 99 "../src/MediaMonitor.vala"
		_klass_->reset_online_offline (self);
#line 543 "MediaMonitor.c"
	}
}

static gboolean
monitorable_updates_real_is_all_updated (MonitorableUpdates* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GFile* _tmp5_;
	gboolean result;
#line 105 "../src/MediaMonitor.vala"
	_tmp5_ = self->priv->master_file;
#line 105 "../src/MediaMonitor.vala"
	if (_tmp5_ == NULL) {
#line 106 "../src/MediaMonitor.vala"
		_tmp4_ = self->priv->master_file_info_altered == FALSE;
#line 563 "MediaMonitor.c"
	} else {
#line 105 "../src/MediaMonitor.vala"
		_tmp4_ = FALSE;
#line 567 "MediaMonitor.c"
	}
#line 105 "../src/MediaMonitor.vala"
	if (_tmp4_) {
#line 571 "MediaMonitor.c"
		GFileInfo* _tmp6_;
#line 107 "../src/MediaMonitor.vala"
		_tmp6_ = self->priv->master_file_info;
#line 107 "../src/MediaMonitor.vala"
		_tmp3_ = _tmp6_ == NULL;
#line 577 "MediaMonitor.c"
	} else {
#line 105 "../src/MediaMonitor.vala"
		_tmp3_ = FALSE;
#line 581 "MediaMonitor.c"
	}
#line 105 "../src/MediaMonitor.vala"
	if (_tmp3_) {
#line 108 "../src/MediaMonitor.vala"
		_tmp2_ = self->priv->master_in_alteration == FALSE;
#line 587 "MediaMonitor.c"
	} else {
#line 105 "../src/MediaMonitor.vala"
		_tmp2_ = FALSE;
#line 591 "MediaMonitor.c"
	}
#line 105 "../src/MediaMonitor.vala"
	if (_tmp2_) {
#line 109 "../src/MediaMonitor.vala"
		_tmp1_ = self->priv->online == FALSE;
#line 597 "MediaMonitor.c"
	} else {
#line 105 "../src/MediaMonitor.vala"
		_tmp1_ = FALSE;
#line 601 "MediaMonitor.c"
	}
#line 105 "../src/MediaMonitor.vala"
	if (_tmp1_) {
#line 110 "../src/MediaMonitor.vala"
		_tmp0_ = self->priv->offline == FALSE;
#line 607 "MediaMonitor.c"
	} else {
#line 105 "../src/MediaMonitor.vala"
		_tmp0_ = FALSE;
#line 611 "MediaMonitor.c"
	}
#line 105 "../src/MediaMonitor.vala"
	result = _tmp0_;
#line 105 "../src/MediaMonitor.vala"
	return result;
#line 617 "MediaMonitor.c"
}

gboolean
monitorable_updates_is_all_updated (MonitorableUpdates* self)
{
	MonitorableUpdatesClass* _klass_;
#line 104 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 104 "../src/MediaMonitor.vala"
	_klass_ = MONITORABLE_UPDATES_GET_CLASS (self);
#line 104 "../src/MediaMonitor.vala"
	if (_klass_->is_all_updated) {
#line 104 "../src/MediaMonitor.vala"
		return _klass_->is_all_updated (self);
#line 632 "MediaMonitor.c"
	}
#line 104 "../src/MediaMonitor.vala"
	return FALSE;
#line 636 "MediaMonitor.c"
}

static void
value_monitorable_updates_init (GValue* value)
{
#line 20 "../src/MediaMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 644 "MediaMonitor.c"
}

static void
value_monitorable_updates_free_value (GValue* value)
{
#line 20 "../src/MediaMonitor.vala"
	if (value->data[0].v_pointer) {
#line 20 "../src/MediaMonitor.vala"
		monitorable_updates_unref (value->data[0].v_pointer);
#line 654 "MediaMonitor.c"
	}
}

static void
value_monitorable_updates_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 20 "../src/MediaMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../src/MediaMonitor.vala"
		dest_value->data[0].v_pointer = monitorable_updates_ref (src_value->data[0].v_pointer);
#line 666 "MediaMonitor.c"
	} else {
#line 20 "../src/MediaMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 670 "MediaMonitor.c"
	}
}

static gpointer
value_monitorable_updates_peek_pointer (const GValue* value)
{
#line 20 "../src/MediaMonitor.vala"
	return value->data[0].v_pointer;
#line 679 "MediaMonitor.c"
}

static gchar*
value_monitorable_updates_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 20 "../src/MediaMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 690 "MediaMonitor.c"
		MonitorableUpdates * object;
		object = collect_values[0].v_pointer;
#line 20 "../src/MediaMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../src/MediaMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 697 "MediaMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../src/MediaMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 701 "MediaMonitor.c"
		}
#line 20 "../src/MediaMonitor.vala"
		value->data[0].v_pointer = monitorable_updates_ref (object);
#line 705 "MediaMonitor.c"
	} else {
#line 20 "../src/MediaMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 709 "MediaMonitor.c"
	}
#line 20 "../src/MediaMonitor.vala"
	return NULL;
#line 713 "MediaMonitor.c"
}

static gchar*
value_monitorable_updates_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	MonitorableUpdates ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../src/MediaMonitor.vala"
	if (!object_p) {
#line 20 "../src/MediaMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 728 "MediaMonitor.c"
	}
#line 20 "../src/MediaMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../src/MediaMonitor.vala"
		*object_p = NULL;
#line 734 "MediaMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../src/MediaMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 738 "MediaMonitor.c"
	} else {
#line 20 "../src/MediaMonitor.vala"
		*object_p = monitorable_updates_ref (value->data[0].v_pointer);
#line 742 "MediaMonitor.c"
	}
#line 20 "../src/MediaMonitor.vala"
	return NULL;
#line 746 "MediaMonitor.c"
}

GParamSpec*
param_spec_monitorable_updates (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecMonitorableUpdates* spec;
#line 20 "../src/MediaMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MONITORABLE_UPDATES), NULL);
#line 20 "../src/MediaMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../src/MediaMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../src/MediaMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 765 "MediaMonitor.c"
}

gpointer
value_get_monitorable_updates (const GValue* value)
{
#line 20 "../src/MediaMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MONITORABLE_UPDATES), NULL);
#line 20 "../src/MediaMonitor.vala"
	return value->data[0].v_pointer;
#line 775 "MediaMonitor.c"
}

void
value_set_monitorable_updates (GValue* value,
                               gpointer v_object)
{
	MonitorableUpdates * old;
#line 20 "../src/MediaMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MONITORABLE_UPDATES));
#line 20 "../src/MediaMonitor.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/MediaMonitor.vala"
	if (v_object) {
#line 20 "../src/MediaMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MONITORABLE_UPDATES));
#line 20 "../src/MediaMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/MediaMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../src/MediaMonitor.vala"
		monitorable_updates_ref (value->data[0].v_pointer);
#line 797 "MediaMonitor.c"
	} else {
#line 20 "../src/MediaMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 801 "MediaMonitor.c"
	}
#line 20 "../src/MediaMonitor.vala"
	if (old) {
#line 20 "../src/MediaMonitor.vala"
		monitorable_updates_unref (old);
#line 807 "MediaMonitor.c"
	}
}

void
value_take_monitorable_updates (GValue* value,
                                gpointer v_object)
{
	MonitorableUpdates * old;
#line 20 "../src/MediaMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MONITORABLE_UPDATES));
#line 20 "../src/MediaMonitor.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/MediaMonitor.vala"
	if (v_object) {
#line 20 "../src/MediaMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MONITORABLE_UPDATES));
#line 20 "../src/MediaMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/MediaMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 828 "MediaMonitor.c"
	} else {
#line 20 "../src/MediaMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 832 "MediaMonitor.c"
	}
#line 20 "../src/MediaMonitor.vala"
	if (old) {
#line 20 "../src/MediaMonitor.vala"
		monitorable_updates_unref (old);
#line 838 "MediaMonitor.c"
	}
}

static void
monitorable_updates_class_init (MonitorableUpdatesClass * klass,
                                gpointer klass_data)
{
#line 20 "../src/MediaMonitor.vala"
	monitorable_updates_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->finalize = monitorable_updates_finalize;
#line 20 "../src/MediaMonitor.vala"
	g_type_class_adjust_private_offset (klass, &MonitorableUpdates_private_offset);
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->is_in_alteration = (gboolean (*) (MonitorableUpdates*)) monitorable_updates_real_is_in_alteration;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->set_master_file = (void (*) (MonitorableUpdates*, GFile*)) monitorable_updates_real_set_master_file;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->set_master_file_info_altered = (void (*) (MonitorableUpdates*, gboolean)) monitorable_updates_real_set_master_file_info_altered;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->set_master_file_info = (void (*) (MonitorableUpdates*, GFileInfo*)) monitorable_updates_real_set_master_file_info;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->set_master_in_alteration = (void (*) (MonitorableUpdates*, gboolean)) monitorable_updates_real_set_master_in_alteration;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->set_master_alterations_complete = (void (*) (MonitorableUpdates*, GFileInfo*)) monitorable_updates_real_set_master_alterations_complete;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->mark_offline = (void (*) (MonitorableUpdates*)) monitorable_updates_real_mark_offline;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->mark_online = (void (*) (MonitorableUpdates*)) monitorable_updates_real_mark_online;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->reset_online_offline = (void (*) (MonitorableUpdates*)) monitorable_updates_real_reset_online_offline;
#line 20 "../src/MediaMonitor.vala"
	((MonitorableUpdatesClass *) klass)->is_all_updated = (gboolean (*) (MonitorableUpdates*)) monitorable_updates_real_is_all_updated;
#line 872 "MediaMonitor.c"
}

static void
monitorable_updates_instance_init (MonitorableUpdates * self,
                                   gpointer klass)
{
#line 20 "../src/MediaMonitor.vala"
	self->priv = monitorable_updates_get_instance_private (self);
#line 23 "../src/MediaMonitor.vala"
	self->priv->master_file = NULL;
#line 24 "../src/MediaMonitor.vala"
	self->priv->master_file_info_altered = FALSE;
#line 25 "../src/MediaMonitor.vala"
	self->priv->master_file_info = NULL;
#line 26 "../src/MediaMonitor.vala"
	self->priv->master_in_alteration = FALSE;
#line 27 "../src/MediaMonitor.vala"
	self->priv->online = FALSE;
#line 28 "../src/MediaMonitor.vala"
	self->priv->offline = FALSE;
#line 20 "../src/MediaMonitor.vala"
	self->ref_count = 1;
#line 895 "MediaMonitor.c"
}

static void
monitorable_updates_finalize (MonitorableUpdates * obj)
{
	MonitorableUpdates * self;
#line 20 "../src/MediaMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MONITORABLE_UPDATES, MonitorableUpdates);
#line 20 "../src/MediaMonitor.vala"
	g_signal_handlers_destroy (self);
#line 21 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->monitorable);
#line 23 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->priv->master_file);
#line 25 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->priv->master_file_info);
#line 912 "MediaMonitor.c"
}

static GType
monitorable_updates_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_monitorable_updates_init, value_monitorable_updates_free_value, value_monitorable_updates_copy_value, value_monitorable_updates_peek_pointer, "p", value_monitorable_updates_collect_value, "p", value_monitorable_updates_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MonitorableUpdatesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) monitorable_updates_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MonitorableUpdates), 0, (GInstanceInitFunc) monitorable_updates_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType monitorable_updates_type_id;
	monitorable_updates_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MonitorableUpdates", &g_define_type_info, &g_define_type_fundamental_info, 0);
	MonitorableUpdates_private_offset = g_type_add_instance_private (monitorable_updates_type_id, sizeof (MonitorableUpdatesPrivate));
	return monitorable_updates_type_id;
}

GType
monitorable_updates_get_type (void)
{
	static volatile gsize monitorable_updates_type_id__once = 0;
	if (g_once_init_enter (&monitorable_updates_type_id__once)) {
		GType monitorable_updates_type_id;
		monitorable_updates_type_id = monitorable_updates_get_type_once ();
		g_once_init_leave (&monitorable_updates_type_id__once, monitorable_updates_type_id);
	}
	return monitorable_updates_type_id__once;
}

gpointer
monitorable_updates_ref (gpointer instance)
{
	MonitorableUpdates * self;
	self = instance;
#line 20 "../src/MediaMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../src/MediaMonitor.vala"
	return instance;
#line 948 "MediaMonitor.c"
}

void
monitorable_updates_unref (gpointer instance)
{
	MonitorableUpdates * self;
	self = instance;
#line 20 "../src/MediaMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../src/MediaMonitor.vala"
		MONITORABLE_UPDATES_GET_CLASS (self)->finalize (self);
#line 20 "../src/MediaMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 962 "MediaMonitor.c"
	}
}

static inline gpointer
media_monitor_get_instance_private (MediaMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, MediaMonitor_private_offset);
}

static void
_media_monitor_on_media_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                           DataSource* source,
                                                                           gpointer self)
{
#line 143 "../src/MediaMonitor.vala"
	media_monitor_on_media_source_destroyed ((MediaMonitor*) self, source);
#line 979 "MediaMonitor.c"
}

static void
_media_monitor_on_media_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender,
                                                                               DataSource* source,
                                                                               gpointer self)
{
#line 144 "../src/MediaMonitor.vala"
	media_monitor_on_media_source_destroyed ((MediaMonitor*) self, source);
#line 989 "MediaMonitor.c"
}

static GType
media_monitor_discovered_file_get_type_once (void)
{
	static const GEnumValue values[] = {{MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED, "MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED", "represented"}, {MEDIA_MONITOR_DISCOVERED_FILE_IGNORE, "MEDIA_MONITOR_DISCOVERED_FILE_IGNORE", "ignore"}, {MEDIA_MONITOR_DISCOVERED_FILE_UNKNOWN, "MEDIA_MONITOR_DISCOVERED_FILE_UNKNOWN", "unknown"}, {0, NULL, NULL}};
	GType media_monitor_discovered_file_type_id;
	media_monitor_discovered_file_type_id = g_enum_register_static ("MediaMonitorDiscoveredFile", values);
	return media_monitor_discovered_file_type_id;
}

GType
media_monitor_discovered_file_get_type (void)
{
	static volatile gsize media_monitor_discovered_file_type_id__once = 0;
	if (g_once_init_enter (&media_monitor_discovered_file_type_id__once)) {
		GType media_monitor_discovered_file_type_id;
		media_monitor_discovered_file_type_id = media_monitor_discovered_file_get_type_once ();
		g_once_init_leave (&media_monitor_discovered_file_type_id__once, media_monitor_discovered_file_type_id);
	}
	return media_monitor_discovered_file_type_id__once;
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 132 "../src/MediaMonitor.vala"
	return self ? data_collection_ref (self) : NULL;
#line 1018 "MediaMonitor.c"
}

static gboolean
_media_monitor_on_flush_pending_updates_gsource_func (gpointer self)
{
	gboolean result;
	result = media_monitor_on_flush_pending_updates ((MediaMonitor*) self);
#line 138 "../src/MediaMonitor.vala"
	return result;
#line 1028 "MediaMonitor.c"
}

MediaMonitor*
media_monitor_construct (GType object_type,
                         MediaSourceCollection* sources,
                         GCancellable* cancellable)
{
	MediaMonitor * self = NULL;
	MediaSourceCollection* _tmp0_;
	GCancellable* _tmp1_;
#line 131 "../src/MediaMonitor.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 131 "../src/MediaMonitor.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 131 "../src/MediaMonitor.vala"
	self = (MediaMonitor*) g_object_new (object_type, NULL);
#line 132 "../src/MediaMonitor.vala"
	_tmp0_ = _data_collection_ref0 (sources);
#line 132 "../src/MediaMonitor.vala"
	_data_collection_unref0 (self->priv->sources);
#line 132 "../src/MediaMonitor.vala"
	self->priv->sources = _tmp0_;
#line 133 "../src/MediaMonitor.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 133 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 133 "../src/MediaMonitor.vala"
	self->priv->cancellable = _tmp1_;
#line 135 "../src/MediaMonitor.vala"
	g_signal_connect_object ((SourceCollection*) sources, "item-destroyed", (GCallback) _media_monitor_on_media_source_destroyed_source_collection_item_destroyed, self, 0);
#line 136 "../src/MediaMonitor.vala"
	g_signal_connect_object ((SourceCollection*) sources, "unlinked-destroyed", (GCallback) _media_monitor_on_media_source_destroyed_source_collection_unlinked_destroyed, self, 0);
#line 138 "../src/MediaMonitor.vala"
	self->priv->pending_updates_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) MEDIA_MONITOR_FLUSH_PENDING_UPDATES_MSEC, _media_monitor_on_flush_pending_updates_gsource_func, g_object_ref (self), g_object_unref);
#line 131 "../src/MediaMonitor.vala"
	return self;
#line 1065 "MediaMonitor.c"
}

static MediaSourceCollection*
media_monitor_real_get_media_source_collection (MediaMonitor* self)
{
#line 147 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_get_media_source_collection'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 147 "../src/MediaMonitor.vala"
	return NULL;
#line 1075 "MediaMonitor.c"
}

MediaSourceCollection*
media_monitor_get_media_source_collection (MediaMonitor* self)
{
	MediaMonitorClass* _klass_;
#line 147 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 147 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 147 "../src/MediaMonitor.vala"
	if (_klass_->get_media_source_collection) {
#line 147 "../src/MediaMonitor.vala"
		return _klass_->get_media_source_collection (self);
#line 1090 "MediaMonitor.c"
	}
#line 147 "../src/MediaMonitor.vala"
	return NULL;
#line 1094 "MediaMonitor.c"
}

static void
media_monitor_real_close (MediaMonitor* self)
{
}

void
media_monitor_close (MediaMonitor* self)
{
	MediaMonitorClass* _klass_;
#line 149 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 149 "../src/MediaMonitor.vala"
	if (_klass_->close) {
#line 149 "../src/MediaMonitor.vala"
		_klass_->close (self);
#line 1114 "MediaMonitor.c"
	}
}

static gchar*
media_monitor_real_to_string (MediaMonitor* self)
{
	MediaSourceCollection* _tmp0_;
	MediaSourceCollection* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 153 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_get_media_source_collection (self);
#line 153 "../src/MediaMonitor.vala"
	_tmp1_ = _tmp0_;
#line 153 "../src/MediaMonitor.vala"
	_tmp2_ = data_collection_to_string ((DataCollection*) _tmp1_);
#line 153 "../src/MediaMonitor.vala"
	_tmp3_ = _tmp2_;
#line 153 "../src/MediaMonitor.vala"
	_tmp4_ = g_strdup_printf ("MediaMonitor for %s", _tmp3_);
#line 153 "../src/MediaMonitor.vala"
	_tmp5_ = _tmp4_;
#line 153 "../src/MediaMonitor.vala"
	_g_free0 (_tmp3_);
#line 153 "../src/MediaMonitor.vala"
	_data_collection_unref0 (_tmp1_);
#line 153 "../src/MediaMonitor.vala"
	result = _tmp5_;
#line 153 "../src/MediaMonitor.vala"
	return result;
#line 1148 "MediaMonitor.c"
}

gchar*
media_monitor_to_string (MediaMonitor* self)
{
	MediaMonitorClass* _klass_;
#line 152 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 152 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 152 "../src/MediaMonitor.vala"
	if (_klass_->to_string) {
#line 152 "../src/MediaMonitor.vala"
		return _klass_->to_string (self);
#line 1163 "MediaMonitor.c"
	}
#line 152 "../src/MediaMonitor.vala"
	return NULL;
#line 1167 "MediaMonitor.c"
}

static MonitorableUpdates*
media_monitor_real_create_updates (MediaMonitor* self,
                                   Monitorable* monitorable)
{
	MonitorableUpdates* _tmp0_;
	MonitorableUpdates* result;
#line 156 "../src/MediaMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 157 "../src/MediaMonitor.vala"
	_tmp0_ = monitorable_updates_new (monitorable);
#line 157 "../src/MediaMonitor.vala"
	result = _tmp0_;
#line 157 "../src/MediaMonitor.vala"
	return result;
#line 1184 "MediaMonitor.c"
}

MonitorableUpdates*
media_monitor_create_updates (MediaMonitor* self,
                              Monitorable* monitorable)
{
	MediaMonitorClass* _klass_;
#line 156 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 156 "../src/MediaMonitor.vala"
	if (_klass_->create_updates) {
#line 156 "../src/MediaMonitor.vala"
		return _klass_->create_updates (self, monitorable);
#line 1200 "MediaMonitor.c"
	}
#line 156 "../src/MediaMonitor.vala"
	return NULL;
#line 1204 "MediaMonitor.c"
}

static void
media_monitor_real_on_media_source_destroyed (MediaMonitor* self,
                                              DataSource* source)
{
#line 160 "../src/MediaMonitor.vala"
	g_return_if_fail (source != NULL);
#line 161 "../src/MediaMonitor.vala"
	media_monitor_remove_updates (self, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MONITORABLE, Monitorable));
#line 1215 "MediaMonitor.c"
}

void
media_monitor_on_media_source_destroyed (MediaMonitor* self,
                                         DataSource* source)
{
	MediaMonitorClass* _klass_;
#line 160 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 160 "../src/MediaMonitor.vala"
	if (_klass_->on_media_source_destroyed) {
#line 160 "../src/MediaMonitor.vala"
		_klass_->on_media_source_destroyed (self, source);
#line 1231 "MediaMonitor.c"
	}
}

static void
media_monitor_real_notify_discovery_started (MediaMonitor* self)
{
}

void
media_monitor_notify_discovery_started (MediaMonitor* self)
{
	MediaMonitorClass* _klass_;
#line 168 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 168 "../src/MediaMonitor.vala"
	if (_klass_->notify_discovery_started) {
#line 168 "../src/MediaMonitor.vala"
		_klass_->notify_discovery_started (self);
#line 1252 "MediaMonitor.c"
	}
}

static MediaMonitorDiscoveredFile
media_monitor_real_notify_file_discovered (MediaMonitor* self,
                                           GFile* file,
                                           GFileInfo* info,
                                           Monitorable** monitorable)
{
#line 173 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_notify_file_discovered'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 173 "../src/MediaMonitor.vala"
	return 0;
#line 1266 "MediaMonitor.c"
}

MediaMonitorDiscoveredFile
media_monitor_notify_file_discovered (MediaMonitor* self,
                                      GFile* file,
                                      GFileInfo* info,
                                      Monitorable** monitorable)
{
	MediaMonitorClass* _klass_;
#line 173 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 173 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 173 "../src/MediaMonitor.vala"
	if (_klass_->notify_file_discovered) {
#line 173 "../src/MediaMonitor.vala"
		return _klass_->notify_file_discovered (self, file, info, monitorable);
#line 1284 "MediaMonitor.c"
	}
#line 173 "../src/MediaMonitor.vala"
	return 0;
#line 1288 "MediaMonitor.c"
}

static GeeCollection*
media_monitor_real_candidates_for_unknown_file (MediaMonitor* self,
                                                GFile* file,
                                                GFileInfo* info,
                                                MediaMonitorDiscoveredFile* _result_)
{
#line 182 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_candidates_for_unknown_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 182 "../src/MediaMonitor.vala"
	return NULL;
#line 1301 "MediaMonitor.c"
}

GeeCollection*
media_monitor_candidates_for_unknown_file (MediaMonitor* self,
                                           GFile* file,
                                           GFileInfo* info,
                                           MediaMonitorDiscoveredFile* _result_)
{
	MediaMonitorClass* _klass_;
#line 182 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 182 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 182 "../src/MediaMonitor.vala"
	if (_klass_->candidates_for_unknown_file) {
#line 182 "../src/MediaMonitor.vala"
		return _klass_->candidates_for_unknown_file (self, file, info, _result_);
#line 1319 "MediaMonitor.c"
	}
#line 182 "../src/MediaMonitor.vala"
	return NULL;
#line 1323 "MediaMonitor.c"
}

static GFile**
media_monitor_real_get_auxilliary_backing_files (MediaMonitor* self,
                                                 Monitorable* monitorable,
                                                 gint* result_length1)
{
	GFile** _tmp0_;
	gint _tmp0__length1;
	GFile** result;
#line 185 "../src/MediaMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 186 "../src/MediaMonitor.vala"
	_tmp0_ = NULL;
#line 186 "../src/MediaMonitor.vala"
	_tmp0__length1 = 0;
#line 186 "../src/MediaMonitor.vala"
	if (result_length1) {
#line 186 "../src/MediaMonitor.vala"
		*result_length1 = _tmp0__length1;
#line 1344 "MediaMonitor.c"
	}
#line 186 "../src/MediaMonitor.vala"
	result = _tmp0_;
#line 186 "../src/MediaMonitor.vala"
	return result;
#line 1350 "MediaMonitor.c"
}

GFile**
media_monitor_get_auxilliary_backing_files (MediaMonitor* self,
                                            Monitorable* monitorable,
                                            gint* result_length1)
{
	MediaMonitorClass* _klass_;
#line 185 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 185 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 185 "../src/MediaMonitor.vala"
	if (_klass_->get_auxilliary_backing_files) {
#line 185 "../src/MediaMonitor.vala"
		return _klass_->get_auxilliary_backing_files (self, monitorable, result_length1);
#line 1367 "MediaMonitor.c"
	}
#line 185 "../src/MediaMonitor.vala"
	return NULL;
#line 1371 "MediaMonitor.c"
}

static void
media_monitor_real_update_backing_file_info (MediaMonitor* self,
                                             Monitorable* monitorable,
                                             GFile* file,
                                             GFileInfo* info)
{
#line 191 "../src/MediaMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 191 "../src/MediaMonitor.vala"
	g_return_if_fail (file != NULL);
#line 1384 "MediaMonitor.c"
}

void
media_monitor_update_backing_file_info (MediaMonitor* self,
                                        Monitorable* monitorable,
                                        GFile* file,
                                        GFileInfo* info)
{
	MediaMonitorClass* _klass_;
#line 191 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 191 "../src/MediaMonitor.vala"
	if (_klass_->update_backing_file_info) {
#line 191 "../src/MediaMonitor.vala"
		_klass_->update_backing_file_info (self, monitorable, file, info);
#line 1402 "MediaMonitor.c"
	}
}

static void
media_monitor_real_notify_discovery_completing (MediaMonitor* self)
{
}

void
media_monitor_notify_discovery_completing (MediaMonitor* self)
{
	MediaMonitorClass* _klass_;
#line 195 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 195 "../src/MediaMonitor.vala"
	if (_klass_->notify_discovery_completing) {
#line 195 "../src/MediaMonitor.vala"
		_klass_->notify_discovery_completing (self);
#line 1423 "MediaMonitor.c"
	}
}

static gboolean
media_monitor_real_is_file_represented (MediaMonitor* self,
                                        GFile* file)
{
	gboolean _tmp0_ = FALSE;
#line 202 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_is_file_represented'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 202 "../src/MediaMonitor.vala"
	return _tmp0_;
#line 1436 "MediaMonitor.c"
}

gboolean
media_monitor_is_file_represented (MediaMonitor* self,
                                   GFile* file)
{
	MediaMonitorClass* _klass_;
#line 202 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 202 "../src/MediaMonitor.vala"
	if (_klass_->is_file_represented) {
#line 202 "../src/MediaMonitor.vala"
		return _klass_->is_file_represented (self, file);
#line 1452 "MediaMonitor.c"
	}
#line 202 "../src/MediaMonitor.vala"
	return FALSE;
#line 1456 "MediaMonitor.c"
}

static gboolean
media_monitor_real_notify_file_created (MediaMonitor* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	gboolean _tmp0_ = FALSE;
#line 204 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_notify_file_created'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 204 "../src/MediaMonitor.vala"
	return _tmp0_;
#line 1469 "MediaMonitor.c"
}

gboolean
media_monitor_notify_file_created (MediaMonitor* self,
                                   GFile* file,
                                   GFileInfo* info)
{
	MediaMonitorClass* _klass_;
#line 204 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 204 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 204 "../src/MediaMonitor.vala"
	if (_klass_->notify_file_created) {
#line 204 "../src/MediaMonitor.vala"
		return _klass_->notify_file_created (self, file, info);
#line 1486 "MediaMonitor.c"
	}
#line 204 "../src/MediaMonitor.vala"
	return FALSE;
#line 1490 "MediaMonitor.c"
}

static gboolean
media_monitor_real_notify_file_moved (MediaMonitor* self,
                                      GFile* old_file,
                                      GFile* new_file,
                                      GFileInfo* new_file_info)
{
	gboolean _tmp0_ = FALSE;
#line 206 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_notify_file_moved'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 206 "../src/MediaMonitor.vala"
	return _tmp0_;
#line 1504 "MediaMonitor.c"
}

gboolean
media_monitor_notify_file_moved (MediaMonitor* self,
                                 GFile* old_file,
                                 GFile* new_file,
                                 GFileInfo* new_file_info)
{
	MediaMonitorClass* _klass_;
#line 206 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 206 "../src/MediaMonitor.vala"
	if (_klass_->notify_file_moved) {
#line 206 "../src/MediaMonitor.vala"
		return _klass_->notify_file_moved (self, old_file, new_file, new_file_info);
#line 1522 "MediaMonitor.c"
	}
#line 206 "../src/MediaMonitor.vala"
	return FALSE;
#line 1526 "MediaMonitor.c"
}

static gboolean
media_monitor_real_notify_file_altered (MediaMonitor* self,
                                        GFile* file)
{
	gboolean _tmp0_ = FALSE;
#line 208 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_notify_file_altered'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 208 "../src/MediaMonitor.vala"
	return _tmp0_;
#line 1538 "MediaMonitor.c"
}

gboolean
media_monitor_notify_file_altered (MediaMonitor* self,
                                   GFile* file)
{
	MediaMonitorClass* _klass_;
#line 208 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 208 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 208 "../src/MediaMonitor.vala"
	if (_klass_->notify_file_altered) {
#line 208 "../src/MediaMonitor.vala"
		return _klass_->notify_file_altered (self, file);
#line 1554 "MediaMonitor.c"
	}
#line 208 "../src/MediaMonitor.vala"
	return FALSE;
#line 1558 "MediaMonitor.c"
}

static gboolean
media_monitor_real_notify_file_attributes_altered (MediaMonitor* self,
                                                   GFile* file)
{
	gboolean _tmp0_ = FALSE;
#line 210 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_notify_file_attributes_altered'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 210 "../src/MediaMonitor.vala"
	return _tmp0_;
#line 1570 "MediaMonitor.c"
}

gboolean
media_monitor_notify_file_attributes_altered (MediaMonitor* self,
                                              GFile* file)
{
	MediaMonitorClass* _klass_;
#line 210 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 210 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 210 "../src/MediaMonitor.vala"
	if (_klass_->notify_file_attributes_altered) {
#line 210 "../src/MediaMonitor.vala"
		return _klass_->notify_file_attributes_altered (self, file);
#line 1586 "MediaMonitor.c"
	}
#line 210 "../src/MediaMonitor.vala"
	return FALSE;
#line 1590 "MediaMonitor.c"
}

static gboolean
media_monitor_real_notify_file_alteration_completed (MediaMonitor* self,
                                                     GFile* file,
                                                     GFileInfo* info)
{
	gboolean _tmp0_ = FALSE;
#line 212 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_notify_file_alteration_completed'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 212 "../src/MediaMonitor.vala"
	return _tmp0_;
#line 1603 "MediaMonitor.c"
}

gboolean
media_monitor_notify_file_alteration_completed (MediaMonitor* self,
                                                GFile* file,
                                                GFileInfo* info)
{
	MediaMonitorClass* _klass_;
#line 212 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 212 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 212 "../src/MediaMonitor.vala"
	if (_klass_->notify_file_alteration_completed) {
#line 212 "../src/MediaMonitor.vala"
		return _klass_->notify_file_alteration_completed (self, file, info);
#line 1620 "MediaMonitor.c"
	}
#line 212 "../src/MediaMonitor.vala"
	return FALSE;
#line 1624 "MediaMonitor.c"
}

static gboolean
media_monitor_real_notify_file_deleted (MediaMonitor* self,
                                        GFile* file)
{
	gboolean _tmp0_ = FALSE;
#line 214 "../src/MediaMonitor.vala"
	g_critical ("Type `%s' does not implement abstract method `media_monitor_notify_file_deleted'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 214 "../src/MediaMonitor.vala"
	return _tmp0_;
#line 1636 "MediaMonitor.c"
}

gboolean
media_monitor_notify_file_deleted (MediaMonitor* self,
                                   GFile* file)
{
	MediaMonitorClass* _klass_;
#line 214 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 214 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 214 "../src/MediaMonitor.vala"
	if (_klass_->notify_file_deleted) {
#line 214 "../src/MediaMonitor.vala"
		return _klass_->notify_file_deleted (self, file);
#line 1652 "MediaMonitor.c"
	}
#line 214 "../src/MediaMonitor.vala"
	return FALSE;
#line 1656 "MediaMonitor.c"
}

void
media_monitor_mdbg (const gchar* msg)
{
#line 216 "../src/MediaMonitor.vala"
	g_return_if_fail (msg != NULL);
#line 1664 "MediaMonitor.c"
}

gboolean
media_monitor_has_pending_updates (MediaMonitor* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 222 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 223 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->pending_updates;
#line 223 "../src/MediaMonitor.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 223 "../src/MediaMonitor.vala"
	_tmp2_ = _tmp1_;
#line 223 "../src/MediaMonitor.vala"
	result = _tmp2_ > 0;
#line 223 "../src/MediaMonitor.vala"
	return result;
#line 1686 "MediaMonitor.c"
}

GeeCollection*
media_monitor_get_monitorables (MediaMonitor* self)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeCollection* result;
#line 226 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 227 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->pending_updates;
#line 227 "../src/MediaMonitor.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 227 "../src/MediaMonitor.vala"
	_tmp2_ = _tmp1_;
#line 227 "../src/MediaMonitor.vala"
	result = (GeeCollection*) _tmp2_;
#line 227 "../src/MediaMonitor.vala"
	return result;
#line 1708 "MediaMonitor.c"
}

MonitorableUpdates*
media_monitor_fetch_updates (MediaMonitor* self,
                             Monitorable* monitorable)
{
	MonitorableUpdates* updates = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MonitorableUpdates* _tmp2_;
	MonitorableUpdates* _tmp3_;
	GeeHashMap* _tmp4_;
	MonitorableUpdates* _tmp5_;
	MonitorableUpdates* result;
#line 232 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 232 "../src/MediaMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 233 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->pending_updates;
#line 233 "../src/MediaMonitor.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, monitorable);
#line 233 "../src/MediaMonitor.vala"
	updates = (MonitorableUpdates*) _tmp1_;
#line 234 "../src/MediaMonitor.vala"
	_tmp2_ = updates;
#line 234 "../src/MediaMonitor.vala"
	if (_tmp2_ != NULL) {
#line 235 "../src/MediaMonitor.vala"
		result = updates;
#line 235 "../src/MediaMonitor.vala"
		return result;
#line 1741 "MediaMonitor.c"
	}
#line 237 "../src/MediaMonitor.vala"
	_tmp3_ = media_monitor_create_updates (self, monitorable);
#line 237 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (updates);
#line 237 "../src/MediaMonitor.vala"
	updates = _tmp3_;
#line 238 "../src/MediaMonitor.vala"
	_tmp4_ = self->priv->pending_updates;
#line 238 "../src/MediaMonitor.vala"
	_tmp5_ = updates;
#line 238 "../src/MediaMonitor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, monitorable, _tmp5_);
#line 240 "../src/MediaMonitor.vala"
	result = updates;
#line 240 "../src/MediaMonitor.vala"
	return result;
#line 1759 "MediaMonitor.c"
}

MonitorableUpdates*
media_monitor_get_existing_updates (MediaMonitor* self,
                                    Monitorable* monitorable)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MonitorableUpdates* result;
#line 243 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 243 "../src/MediaMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 244 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->pending_updates;
#line 244 "../src/MediaMonitor.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, monitorable);
#line 244 "../src/MediaMonitor.vala"
	result = (MonitorableUpdates*) _tmp1_;
#line 244 "../src/MediaMonitor.vala"
	return result;
#line 1781 "MediaMonitor.c"
}

void
media_monitor_remove_updates (MediaMonitor* self,
                              Monitorable* monitorable)
{
	GeeHashMap* _tmp0_;
#line 247 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/MediaMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 248 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->pending_updates;
#line 248 "../src/MediaMonitor.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, monitorable, NULL);
#line 1797 "MediaMonitor.c"
}

gboolean
media_monitor_is_online (MediaMonitor* self,
                         Monitorable* monitorable)
{
	MonitorableUpdates* updates = NULL;
	MonitorableUpdates* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MonitorableUpdates* _tmp2_;
	gboolean result;
#line 251 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 251 "../src/MediaMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, FALSE);
#line 252 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_get_existing_updates (self, monitorable);
#line 252 "../src/MediaMonitor.vala"
	updates = _tmp0_;
#line 254 "../src/MediaMonitor.vala"
	_tmp2_ = updates;
#line 254 "../src/MediaMonitor.vala"
	if (_tmp2_ != NULL) {
#line 1821 "MediaMonitor.c"
		MonitorableUpdates* _tmp3_;
#line 254 "../src/MediaMonitor.vala"
		_tmp3_ = updates;
#line 254 "../src/MediaMonitor.vala"
		_tmp1_ = monitorable_updates_is_set_online (_tmp3_);
#line 1827 "MediaMonitor.c"
	} else {
#line 254 "../src/MediaMonitor.vala"
		_tmp1_ = !monitorable_is_offline (monitorable);
#line 1831 "MediaMonitor.c"
	}
#line 254 "../src/MediaMonitor.vala"
	result = _tmp1_;
#line 254 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (updates);
#line 254 "../src/MediaMonitor.vala"
	return result;
#line 1839 "MediaMonitor.c"
}

gboolean
media_monitor_is_offline (MediaMonitor* self,
                          Monitorable* monitorable)
{
	MonitorableUpdates* updates = NULL;
	MonitorableUpdates* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MonitorableUpdates* _tmp2_;
	gboolean result;
#line 257 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 257 "../src/MediaMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, FALSE);
#line 258 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_get_existing_updates (self, monitorable);
#line 258 "../src/MediaMonitor.vala"
	updates = _tmp0_;
#line 260 "../src/MediaMonitor.vala"
	_tmp2_ = updates;
#line 260 "../src/MediaMonitor.vala"
	if (_tmp2_ != NULL) {
#line 1863 "MediaMonitor.c"
		MonitorableUpdates* _tmp3_;
#line 260 "../src/MediaMonitor.vala"
		_tmp3_ = updates;
#line 260 "../src/MediaMonitor.vala"
		_tmp1_ = monitorable_updates_is_set_offline (_tmp3_);
#line 1869 "MediaMonitor.c"
	} else {
#line 260 "../src/MediaMonitor.vala"
		_tmp1_ = monitorable_is_offline (monitorable);
#line 1873 "MediaMonitor.c"
	}
#line 260 "../src/MediaMonitor.vala"
	result = _tmp1_;
#line 260 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (updates);
#line 260 "../src/MediaMonitor.vala"
	return result;
#line 1881 "MediaMonitor.c"
}

GFile*
media_monitor_get_master_file (MediaMonitor* self,
                               Monitorable* monitorable)
{
	MonitorableUpdates* updates = NULL;
	MonitorableUpdates* _tmp0_;
	GFile* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	MonitorableUpdates* _tmp3_;
	GFile* result;
#line 263 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 263 "../src/MediaMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 264 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_get_existing_updates (self, monitorable);
#line 264 "../src/MediaMonitor.vala"
	updates = _tmp0_;
#line 266 "../src/MediaMonitor.vala"
	_tmp3_ = updates;
#line 266 "../src/MediaMonitor.vala"
	if (_tmp3_ != NULL) {
#line 1906 "MediaMonitor.c"
		MonitorableUpdates* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 266 "../src/MediaMonitor.vala"
		_tmp4_ = updates;
#line 266 "../src/MediaMonitor.vala"
		_tmp5_ = monitorable_updates_get_master_file (_tmp4_);
#line 266 "../src/MediaMonitor.vala"
		_tmp6_ = _tmp5_;
#line 266 "../src/MediaMonitor.vala"
		_tmp2_ = _tmp6_ != NULL;
#line 266 "../src/MediaMonitor.vala"
		_g_object_unref0 (_tmp6_);
#line 1920 "MediaMonitor.c"
	} else {
#line 266 "../src/MediaMonitor.vala"
		_tmp2_ = FALSE;
#line 1924 "MediaMonitor.c"
	}
#line 266 "../src/MediaMonitor.vala"
	if (_tmp2_) {
#line 1928 "MediaMonitor.c"
		MonitorableUpdates* _tmp7_;
		GFile* _tmp8_;
#line 266 "../src/MediaMonitor.vala"
		_tmp7_ = updates;
#line 266 "../src/MediaMonitor.vala"
		_tmp8_ = monitorable_updates_get_master_file (_tmp7_);
#line 266 "../src/MediaMonitor.vala"
		_g_object_unref0 (_tmp1_);
#line 266 "../src/MediaMonitor.vala"
		_tmp1_ = _tmp8_;
#line 1939 "MediaMonitor.c"
	} else {
		GFile* _tmp9_;
#line 267 "../src/MediaMonitor.vala"
		_tmp9_ = media_source_get_master_file ((MediaSource*) monitorable);
#line 267 "../src/MediaMonitor.vala"
		_g_object_unref0 (_tmp1_);
#line 267 "../src/MediaMonitor.vala"
		_tmp1_ = _tmp9_;
#line 1948 "MediaMonitor.c"
	}
#line 266 "../src/MediaMonitor.vala"
	result = _tmp1_;
#line 266 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (updates);
#line 266 "../src/MediaMonitor.vala"
	return result;
#line 1956 "MediaMonitor.c"
}

void
media_monitor_update_master_file (MediaMonitor* self,
                                  Monitorable* monitorable,
                                  GFile* file)
{
	MonitorableUpdates* _tmp0_;
	MonitorableUpdates* _tmp1_;
#line 270 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/MediaMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 270 "../src/MediaMonitor.vala"
	g_return_if_fail (file != NULL);
#line 271 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_fetch_updates (self, monitorable);
#line 271 "../src/MediaMonitor.vala"
	_tmp1_ = _tmp0_;
#line 271 "../src/MediaMonitor.vala"
	monitorable_updates_set_master_file (_tmp1_, file);
#line 271 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (_tmp1_);
#line 1980 "MediaMonitor.c"
}

void
media_monitor_update_master_file_info_altered (MediaMonitor* self,
                                               Monitorable* monitorable)
{
	MonitorableUpdates* _tmp0_;
	MonitorableUpdates* _tmp1_;
#line 274 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/MediaMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 275 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_fetch_updates (self, monitorable);
#line 275 "../src/MediaMonitor.vala"
	_tmp1_ = _tmp0_;
#line 275 "../src/MediaMonitor.vala"
	monitorable_updates_set_master_file_info_altered (_tmp1_, TRUE);
#line 275 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (_tmp1_);
#line 2001 "MediaMonitor.c"
}

void
media_monitor_update_master_file_in_alteration (MediaMonitor* self,
                                                Monitorable* monitorable,
                                                gboolean in_alteration)
{
	MonitorableUpdates* _tmp0_;
	MonitorableUpdates* _tmp1_;
#line 278 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/MediaMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 279 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_fetch_updates (self, monitorable);
#line 279 "../src/MediaMonitor.vala"
	_tmp1_ = _tmp0_;
#line 279 "../src/MediaMonitor.vala"
	monitorable_updates_set_master_in_alteration (_tmp1_, in_alteration);
#line 279 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (_tmp1_);
#line 2023 "MediaMonitor.c"
}

void
media_monitor_update_master_file_alterations_completed (MediaMonitor* self,
                                                        Monitorable* monitorable,
                                                        GFileInfo* info)
{
	MonitorableUpdates* _tmp0_;
	MonitorableUpdates* _tmp1_;
#line 282 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/MediaMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 282 "../src/MediaMonitor.vala"
	g_return_if_fail (info != NULL);
#line 283 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_fetch_updates (self, monitorable);
#line 283 "../src/MediaMonitor.vala"
	_tmp1_ = _tmp0_;
#line 283 "../src/MediaMonitor.vala"
	monitorable_updates_set_master_alterations_complete (_tmp1_, info);
#line 283 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (_tmp1_);
#line 2047 "MediaMonitor.c"
}

void
media_monitor_update_online (MediaMonitor* self,
                             Monitorable* monitorable)
{
	MonitorableUpdates* _tmp0_;
	MonitorableUpdates* _tmp1_;
#line 286 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/MediaMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 287 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_fetch_updates (self, monitorable);
#line 287 "../src/MediaMonitor.vala"
	_tmp1_ = _tmp0_;
#line 287 "../src/MediaMonitor.vala"
	monitorable_updates_mark_online (_tmp1_);
#line 287 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (_tmp1_);
#line 2068 "MediaMonitor.c"
}

void
media_monitor_update_offline (MediaMonitor* self,
                              Monitorable* monitorable)
{
	MonitorableUpdates* _tmp0_;
	MonitorableUpdates* _tmp1_;
#line 290 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/MediaMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 291 "../src/MediaMonitor.vala"
	_tmp0_ = media_monitor_fetch_updates (self, monitorable);
#line 291 "../src/MediaMonitor.vala"
	_tmp1_ = _tmp0_;
#line 291 "../src/MediaMonitor.vala"
	monitorable_updates_mark_offline (_tmp1_);
#line 291 "../src/MediaMonitor.vala"
	_monitorable_updates_unref0 (_tmp1_);
#line 2089 "MediaMonitor.c"
}

static void
media_monitor_real_process_updates (MediaMonitor* self,
                                    GeeCollection* all_updates,
                                    TransactionController* controller,
                                    gint* op_count,
                                    GError** error)
{
	GeeMap* set_master_file = NULL;
	GeeMap* set_master_file_info = NULL;
	GeeArrayList* to_offline = NULL;
	GeeArrayList* to_online = NULL;
	GeeMap* _tmp48_;
	GeeMap* _tmp57_;
	gboolean _tmp66_ = FALSE;
	GeeArrayList* _tmp67_;
	GError* _inner_error0_ = NULL;
#line 298 "../src/MediaMonitor.vala"
	g_return_if_fail (all_updates != NULL);
#line 298 "../src/MediaMonitor.vala"
	g_return_if_fail (controller != NULL);
#line 300 "../src/MediaMonitor.vala"
	set_master_file = NULL;
#line 301 "../src/MediaMonitor.vala"
	set_master_file_info = NULL;
#line 302 "../src/MediaMonitor.vala"
	to_offline = NULL;
#line 303 "../src/MediaMonitor.vala"
	to_online = NULL;
#line 2120 "MediaMonitor.c"
	{
		GeeIterator* _updates_it = NULL;
		GeeIterator* _tmp0_;
#line 305 "../src/MediaMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) all_updates);
#line 305 "../src/MediaMonitor.vala"
		_updates_it = _tmp0_;
#line 305 "../src/MediaMonitor.vala"
		while (TRUE) {
#line 2130 "MediaMonitor.c"
			GeeIterator* _tmp1_;
			MonitorableUpdates* updates = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			MonitorableUpdates* _tmp4_;
			GFile* _tmp5_;
			GFile* _tmp6_;
			gboolean _tmp7_;
			MonitorableUpdates* _tmp18_;
			GFileInfo* _tmp19_;
			GFileInfo* _tmp20_;
			gboolean _tmp21_;
			MonitorableUpdates* _tmp32_;
			MonitorableUpdates* _tmp40_;
#line 305 "../src/MediaMonitor.vala"
			_tmp1_ = _updates_it;
#line 305 "../src/MediaMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 305 "../src/MediaMonitor.vala"
				break;
#line 2151 "MediaMonitor.c"
			}
#line 305 "../src/MediaMonitor.vala"
			_tmp2_ = _updates_it;
#line 305 "../src/MediaMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 305 "../src/MediaMonitor.vala"
			updates = (MonitorableUpdates*) _tmp3_;
#line 306 "../src/MediaMonitor.vala"
			if ((*op_count) >= MEDIA_MONITOR_MAX_OPERATIONS_PER_CYCLE) {
#line 307 "../src/MediaMonitor.vala"
				_monitorable_updates_unref0 (updates);
#line 307 "../src/MediaMonitor.vala"
				break;
#line 2165 "MediaMonitor.c"
			}
#line 309 "../src/MediaMonitor.vala"
			_tmp4_ = updates;
#line 309 "../src/MediaMonitor.vala"
			_tmp5_ = monitorable_updates_get_master_file (_tmp4_);
#line 309 "../src/MediaMonitor.vala"
			_tmp6_ = _tmp5_;
#line 309 "../src/MediaMonitor.vala"
			_tmp7_ = _tmp6_ != NULL;
#line 309 "../src/MediaMonitor.vala"
			_g_object_unref0 (_tmp6_);
#line 309 "../src/MediaMonitor.vala"
			if (_tmp7_) {
#line 2179 "MediaMonitor.c"
				GeeMap* _tmp8_;
				GeeMap* _tmp10_;
				MonitorableUpdates* _tmp11_;
				Monitorable* _tmp12_;
				MonitorableUpdates* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
				MonitorableUpdates* _tmp16_;
				gint _tmp17_;
#line 310 "../src/MediaMonitor.vala"
				_tmp8_ = set_master_file;
#line 310 "../src/MediaMonitor.vala"
				if (_tmp8_ == NULL) {
#line 2193 "MediaMonitor.c"
					GeeHashMap* _tmp9_;
#line 311 "../src/MediaMonitor.vala"
					_tmp9_ = gee_hash_map_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 311 "../src/MediaMonitor.vala"
					_g_object_unref0 (set_master_file);
#line 311 "../src/MediaMonitor.vala"
					set_master_file = (GeeMap*) _tmp9_;
#line 2201 "MediaMonitor.c"
				}
#line 313 "../src/MediaMonitor.vala"
				_tmp10_ = set_master_file;
#line 313 "../src/MediaMonitor.vala"
				_tmp11_ = updates;
#line 313 "../src/MediaMonitor.vala"
				_tmp12_ = _tmp11_->monitorable;
#line 313 "../src/MediaMonitor.vala"
				_tmp13_ = updates;
#line 313 "../src/MediaMonitor.vala"
				_tmp14_ = monitorable_updates_get_master_file (_tmp13_);
#line 313 "../src/MediaMonitor.vala"
				_tmp15_ = _tmp14_;
#line 313 "../src/MediaMonitor.vala"
				gee_map_set (_tmp10_, _tmp12_, _tmp15_);
#line 313 "../src/MediaMonitor.vala"
				_g_object_unref0 (_tmp15_);
#line 314 "../src/MediaMonitor.vala"
				_tmp16_ = updates;
#line 314 "../src/MediaMonitor.vala"
				monitorable_updates_set_master_file (_tmp16_, NULL);
#line 315 "../src/MediaMonitor.vala"
				_tmp17_ = *op_count;
#line 315 "../src/MediaMonitor.vala"
				*op_count = _tmp17_ + 1;
#line 2227 "MediaMonitor.c"
			}
#line 318 "../src/MediaMonitor.vala"
			_tmp18_ = updates;
#line 318 "../src/MediaMonitor.vala"
			_tmp19_ = monitorable_updates_get_master_file_info (_tmp18_);
#line 318 "../src/MediaMonitor.vala"
			_tmp20_ = _tmp19_;
#line 318 "../src/MediaMonitor.vala"
			_tmp21_ = _tmp20_ != NULL;
#line 318 "../src/MediaMonitor.vala"
			_g_object_unref0 (_tmp20_);
#line 318 "../src/MediaMonitor.vala"
			if (_tmp21_) {
#line 2241 "MediaMonitor.c"
				GeeMap* _tmp22_;
				GeeMap* _tmp24_;
				MonitorableUpdates* _tmp25_;
				Monitorable* _tmp26_;
				MonitorableUpdates* _tmp27_;
				GFileInfo* _tmp28_;
				GFileInfo* _tmp29_;
				MonitorableUpdates* _tmp30_;
				gint _tmp31_;
#line 319 "../src/MediaMonitor.vala"
				_tmp22_ = set_master_file_info;
#line 319 "../src/MediaMonitor.vala"
				if (_tmp22_ == NULL) {
#line 2255 "MediaMonitor.c"
					GeeHashMap* _tmp23_;
#line 320 "../src/MediaMonitor.vala"
					_tmp23_ = gee_hash_map_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 320 "../src/MediaMonitor.vala"
					_g_object_unref0 (set_master_file_info);
#line 320 "../src/MediaMonitor.vala"
					set_master_file_info = (GeeMap*) _tmp23_;
#line 2263 "MediaMonitor.c"
				}
#line 322 "../src/MediaMonitor.vala"
				_tmp24_ = set_master_file_info;
#line 322 "../src/MediaMonitor.vala"
				_tmp25_ = updates;
#line 322 "../src/MediaMonitor.vala"
				_tmp26_ = _tmp25_->monitorable;
#line 322 "../src/MediaMonitor.vala"
				_tmp27_ = updates;
#line 322 "../src/MediaMonitor.vala"
				_tmp28_ = monitorable_updates_get_master_file_info (_tmp27_);
#line 322 "../src/MediaMonitor.vala"
				_tmp29_ = _tmp28_;
#line 322 "../src/MediaMonitor.vala"
				gee_map_set (_tmp24_, _tmp26_, _tmp29_);
#line 322 "../src/MediaMonitor.vala"
				_g_object_unref0 (_tmp29_);
#line 323 "../src/MediaMonitor.vala"
				_tmp30_ = updates;
#line 323 "../src/MediaMonitor.vala"
				monitorable_updates_set_master_file_info (_tmp30_, NULL);
#line 324 "../src/MediaMonitor.vala"
				_tmp31_ = *op_count;
#line 324 "../src/MediaMonitor.vala"
				*op_count = _tmp31_ + 1;
#line 2289 "MediaMonitor.c"
			}
#line 327 "../src/MediaMonitor.vala"
			_tmp32_ = updates;
#line 327 "../src/MediaMonitor.vala"
			if (monitorable_updates_is_set_offline (_tmp32_)) {
#line 2295 "MediaMonitor.c"
				GeeArrayList* _tmp33_;
				GeeArrayList* _tmp35_;
				MonitorableUpdates* _tmp36_;
				Monitorable* _tmp37_;
				MonitorableUpdates* _tmp38_;
				gint _tmp39_;
#line 328 "../src/MediaMonitor.vala"
				_tmp33_ = to_offline;
#line 328 "../src/MediaMonitor.vala"
				if (_tmp33_ == NULL) {
#line 2306 "MediaMonitor.c"
					GeeArrayList* _tmp34_;
#line 329 "../src/MediaMonitor.vala"
					_tmp34_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 329 "../src/MediaMonitor.vala"
					_g_object_unref0 (to_offline);
#line 329 "../src/MediaMonitor.vala"
					to_offline = _tmp34_;
#line 2314 "MediaMonitor.c"
				}
#line 331 "../src/MediaMonitor.vala"
				_tmp35_ = to_offline;
#line 331 "../src/MediaMonitor.vala"
				_tmp36_ = updates;
#line 331 "../src/MediaMonitor.vala"
				_tmp37_ = _tmp36_->monitorable;
#line 331 "../src/MediaMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, _tmp37_);
#line 332 "../src/MediaMonitor.vala"
				_tmp38_ = updates;
#line 332 "../src/MediaMonitor.vala"
				monitorable_updates_reset_online_offline (_tmp38_);
#line 333 "../src/MediaMonitor.vala"
				_tmp39_ = *op_count;
#line 333 "../src/MediaMonitor.vala"
				*op_count = _tmp39_ + 1;
#line 2332 "MediaMonitor.c"
			}
#line 336 "../src/MediaMonitor.vala"
			_tmp40_ = updates;
#line 336 "../src/MediaMonitor.vala"
			if (monitorable_updates_is_set_online (_tmp40_)) {
#line 2338 "MediaMonitor.c"
				GeeArrayList* _tmp41_;
				GeeArrayList* _tmp43_;
				MonitorableUpdates* _tmp44_;
				Monitorable* _tmp45_;
				MonitorableUpdates* _tmp46_;
				gint _tmp47_;
#line 337 "../src/MediaMonitor.vala"
				_tmp41_ = to_online;
#line 337 "../src/MediaMonitor.vala"
				if (_tmp41_ == NULL) {
#line 2349 "MediaMonitor.c"
					GeeArrayList* _tmp42_;
#line 338 "../src/MediaMonitor.vala"
					_tmp42_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 338 "../src/MediaMonitor.vala"
					_g_object_unref0 (to_online);
#line 338 "../src/MediaMonitor.vala"
					to_online = _tmp42_;
#line 2357 "MediaMonitor.c"
				}
#line 340 "../src/MediaMonitor.vala"
				_tmp43_ = to_online;
#line 340 "../src/MediaMonitor.vala"
				_tmp44_ = updates;
#line 340 "../src/MediaMonitor.vala"
				_tmp45_ = _tmp44_->monitorable;
#line 340 "../src/MediaMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, _tmp45_);
#line 341 "../src/MediaMonitor.vala"
				_tmp46_ = updates;
#line 341 "../src/MediaMonitor.vala"
				monitorable_updates_reset_online_offline (_tmp46_);
#line 342 "../src/MediaMonitor.vala"
				_tmp47_ = *op_count;
#line 342 "../src/MediaMonitor.vala"
				*op_count = _tmp47_ + 1;
#line 2375 "MediaMonitor.c"
			}
#line 305 "../src/MediaMonitor.vala"
			_monitorable_updates_unref0 (updates);
#line 2379 "MediaMonitor.c"
		}
#line 305 "../src/MediaMonitor.vala"
		_g_object_unref0 (_updates_it);
#line 2383 "MediaMonitor.c"
	}
#line 346 "../src/MediaMonitor.vala"
	_tmp48_ = set_master_file;
#line 346 "../src/MediaMonitor.vala"
	if (_tmp48_ != NULL) {
#line 2389 "MediaMonitor.c"
		GeeMap* _tmp49_;
		gint _tmp50_;
		gint _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
		GeeMap* _tmp56_;
#line 347 "../src/MediaMonitor.vala"
		_tmp49_ = set_master_file;
#line 347 "../src/MediaMonitor.vala"
		_tmp50_ = gee_map_get_size (_tmp49_);
#line 347 "../src/MediaMonitor.vala"
		_tmp51_ = _tmp50_;
#line 347 "../src/MediaMonitor.vala"
		_tmp52_ = media_monitor_to_string (self);
#line 347 "../src/MediaMonitor.vala"
		_tmp53_ = _tmp52_;
#line 347 "../src/MediaMonitor.vala"
		_tmp54_ = g_strdup_printf ("Changing master file of %d objects in %s", _tmp51_, _tmp53_);
#line 347 "../src/MediaMonitor.vala"
		_tmp55_ = _tmp54_;
#line 347 "../src/MediaMonitor.vala"
		media_monitor_mdbg (_tmp55_);
#line 347 "../src/MediaMonitor.vala"
		_g_free0 (_tmp55_);
#line 347 "../src/MediaMonitor.vala"
		_g_free0 (_tmp53_);
#line 349 "../src/MediaMonitor.vala"
		_tmp56_ = set_master_file;
#line 349 "../src/MediaMonitor.vala"
		monitorable_set_many_master_file (_tmp56_, controller, &_inner_error0_);
#line 349 "../src/MediaMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 349 "../src/MediaMonitor.vala"
			g_propagate_error (error, _inner_error0_);
#line 349 "../src/MediaMonitor.vala"
			_g_object_unref0 (to_online);
#line 349 "../src/MediaMonitor.vala"
			_g_object_unref0 (to_offline);
#line 349 "../src/MediaMonitor.vala"
			_g_object_unref0 (set_master_file_info);
#line 349 "../src/MediaMonitor.vala"
			_g_object_unref0 (set_master_file);
#line 349 "../src/MediaMonitor.vala"
			return;
#line 2436 "MediaMonitor.c"
		}
	}
#line 352 "../src/MediaMonitor.vala"
	_tmp57_ = set_master_file_info;
#line 352 "../src/MediaMonitor.vala"
	if (_tmp57_ != NULL) {
#line 2443 "MediaMonitor.c"
		GeeMap* _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		GeeMap* _tmp65_;
#line 353 "../src/MediaMonitor.vala"
		_tmp58_ = set_master_file_info;
#line 353 "../src/MediaMonitor.vala"
		_tmp59_ = gee_map_get_size (_tmp58_);
#line 353 "../src/MediaMonitor.vala"
		_tmp60_ = _tmp59_;
#line 353 "../src/MediaMonitor.vala"
		_tmp61_ = media_monitor_to_string (self);
#line 353 "../src/MediaMonitor.vala"
		_tmp62_ = _tmp61_;
#line 353 "../src/MediaMonitor.vala"
		_tmp63_ = g_strdup_printf ("Updating %d master files timestamps in %s", _tmp60_, _tmp62_);
#line 353 "../src/MediaMonitor.vala"
		_tmp64_ = _tmp63_;
#line 353 "../src/MediaMonitor.vala"
		media_monitor_mdbg (_tmp64_);
#line 353 "../src/MediaMonitor.vala"
		_g_free0 (_tmp64_);
#line 353 "../src/MediaMonitor.vala"
		_g_free0 (_tmp62_);
#line 356 "../src/MediaMonitor.vala"
		_tmp65_ = set_master_file_info;
#line 356 "../src/MediaMonitor.vala"
		monitorable_set_many_master_timestamp (_tmp65_, controller, &_inner_error0_);
#line 356 "../src/MediaMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "../src/MediaMonitor.vala"
			g_propagate_error (error, _inner_error0_);
#line 356 "../src/MediaMonitor.vala"
			_g_object_unref0 (to_online);
#line 356 "../src/MediaMonitor.vala"
			_g_object_unref0 (to_offline);
#line 356 "../src/MediaMonitor.vala"
			_g_object_unref0 (set_master_file_info);
#line 356 "../src/MediaMonitor.vala"
			_g_object_unref0 (set_master_file);
#line 356 "../src/MediaMonitor.vala"
			return;
#line 2490 "MediaMonitor.c"
		}
	}
#line 359 "../src/MediaMonitor.vala"
	_tmp67_ = to_offline;
#line 359 "../src/MediaMonitor.vala"
	if (_tmp67_ != NULL) {
#line 359 "../src/MediaMonitor.vala"
		_tmp66_ = TRUE;
#line 2499 "MediaMonitor.c"
	} else {
		GeeArrayList* _tmp68_;
#line 359 "../src/MediaMonitor.vala"
		_tmp68_ = to_online;
#line 359 "../src/MediaMonitor.vala"
		_tmp66_ = _tmp68_ != NULL;
#line 2506 "MediaMonitor.c"
	}
#line 359 "../src/MediaMonitor.vala"
	if (_tmp66_) {
#line 2510 "MediaMonitor.c"
		gint _tmp69_ = 0;
		GeeArrayList* _tmp70_;
		gint _tmp74_ = 0;
		GeeArrayList* _tmp75_;
		gchar* _tmp79_;
		gchar* _tmp80_;
		gchar* _tmp81_;
		gchar* _tmp82_;
		GeeArrayList* _tmp83_;
		GeeArrayList* _tmp84_;
#line 361 "../src/MediaMonitor.vala"
		_tmp70_ = to_online;
#line 361 "../src/MediaMonitor.vala"
		if (_tmp70_ != NULL) {
#line 2525 "MediaMonitor.c"
			GeeArrayList* _tmp71_;
			gint _tmp72_;
			gint _tmp73_;
#line 361 "../src/MediaMonitor.vala"
			_tmp71_ = to_online;
#line 361 "../src/MediaMonitor.vala"
			_tmp72_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp71_);
#line 361 "../src/MediaMonitor.vala"
			_tmp73_ = _tmp72_;
#line 361 "../src/MediaMonitor.vala"
			_tmp69_ = _tmp73_;
#line 2537 "MediaMonitor.c"
		} else {
#line 361 "../src/MediaMonitor.vala"
			_tmp69_ = 0;
#line 2541 "MediaMonitor.c"
		}
#line 362 "../src/MediaMonitor.vala"
		_tmp75_ = to_offline;
#line 362 "../src/MediaMonitor.vala"
		if (_tmp75_ != NULL) {
#line 2547 "MediaMonitor.c"
			GeeArrayList* _tmp76_;
			gint _tmp77_;
			gint _tmp78_;
#line 362 "../src/MediaMonitor.vala"
			_tmp76_ = to_offline;
#line 362 "../src/MediaMonitor.vala"
			_tmp77_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp76_);
#line 362 "../src/MediaMonitor.vala"
			_tmp78_ = _tmp77_;
#line 362 "../src/MediaMonitor.vala"
			_tmp74_ = _tmp78_;
#line 2559 "MediaMonitor.c"
		} else {
#line 362 "../src/MediaMonitor.vala"
			_tmp74_ = 0;
#line 2563 "MediaMonitor.c"
		}
#line 360 "../src/MediaMonitor.vala"
		_tmp79_ = media_monitor_to_string (self);
#line 360 "../src/MediaMonitor.vala"
		_tmp80_ = _tmp79_;
#line 360 "../src/MediaMonitor.vala"
		_tmp81_ = g_strdup_printf ("Marking %d online, %d offline in %s", _tmp69_, _tmp74_, _tmp80_);
#line 360 "../src/MediaMonitor.vala"
		_tmp82_ = _tmp81_;
#line 360 "../src/MediaMonitor.vala"
		media_monitor_mdbg (_tmp82_);
#line 360 "../src/MediaMonitor.vala"
		_g_free0 (_tmp82_);
#line 360 "../src/MediaMonitor.vala"
		_g_free0 (_tmp80_);
#line 365 "../src/MediaMonitor.vala"
		_tmp83_ = to_online;
#line 365 "../src/MediaMonitor.vala"
		_tmp84_ = to_offline;
#line 365 "../src/MediaMonitor.vala"
		monitorable_mark_many_online_offline ((GeeCollection*) _tmp83_, (GeeCollection*) _tmp84_, controller, &_inner_error0_);
#line 365 "../src/MediaMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 365 "../src/MediaMonitor.vala"
			g_propagate_error (error, _inner_error0_);
#line 365 "../src/MediaMonitor.vala"
			_g_object_unref0 (to_online);
#line 365 "../src/MediaMonitor.vala"
			_g_object_unref0 (to_offline);
#line 365 "../src/MediaMonitor.vala"
			_g_object_unref0 (set_master_file_info);
#line 365 "../src/MediaMonitor.vala"
			_g_object_unref0 (set_master_file);
#line 365 "../src/MediaMonitor.vala"
			return;
#line 2599 "MediaMonitor.c"
		}
	}
#line 298 "../src/MediaMonitor.vala"
	_g_object_unref0 (to_online);
#line 298 "../src/MediaMonitor.vala"
	_g_object_unref0 (to_offline);
#line 298 "../src/MediaMonitor.vala"
	_g_object_unref0 (set_master_file_info);
#line 298 "../src/MediaMonitor.vala"
	_g_object_unref0 (set_master_file);
#line 2610 "MediaMonitor.c"
}

void
media_monitor_process_updates (MediaMonitor* self,
                               GeeCollection* all_updates,
                               TransactionController* controller,
                               gint* op_count,
                               GError** error)
{
	MediaMonitorClass* _klass_;
#line 298 "../src/MediaMonitor.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/MediaMonitor.vala"
	_klass_ = MEDIA_MONITOR_GET_CLASS (self);
#line 298 "../src/MediaMonitor.vala"
	if (_klass_->process_updates) {
#line 298 "../src/MediaMonitor.vala"
		_klass_->process_updates (self, all_updates, controller, op_count, error);
#line 2629 "MediaMonitor.c"
	}
}

static gpointer
_transaction_controller_ref0 (gpointer self)
{
#line 403 "../src/MediaMonitor.vala"
	return self ? transaction_controller_ref (self) : NULL;
#line 2638 "MediaMonitor.c"
}

static gboolean
media_monitor_on_flush_pending_updates (MediaMonitor* self)
{
	GCancellable* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GTimer* timer = NULL;
	GTimer* _tmp4_;
	GeeArrayList* to_process = NULL;
	GeeArrayList* to_remove = NULL;
	gint op_count = 0;
	GeeArrayList* _tmp25_;
	GeeArrayList* _tmp43_;
	gdouble elapsed = 0.0;
	GTimer* _tmp53_;
	gboolean _tmp54_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 369 "../src/MediaMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 370 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 370 "../src/MediaMonitor.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 371 "../src/MediaMonitor.vala"
		result = FALSE;
#line 371 "../src/MediaMonitor.vala"
		return result;
#line 2670 "MediaMonitor.c"
	}
#line 373 "../src/MediaMonitor.vala"
	_tmp1_ = self->priv->pending_updates;
#line 373 "../src/MediaMonitor.vala"
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
#line 373 "../src/MediaMonitor.vala"
	_tmp3_ = _tmp2_;
#line 373 "../src/MediaMonitor.vala"
	if (_tmp3_ == 0) {
#line 374 "../src/MediaMonitor.vala"
		result = TRUE;
#line 374 "../src/MediaMonitor.vala"
		return result;
#line 2684 "MediaMonitor.c"
	}
#line 376 "../src/MediaMonitor.vala"
	_tmp4_ = g_timer_new ();
#line 376 "../src/MediaMonitor.vala"
	timer = _tmp4_;
#line 381 "../src/MediaMonitor.vala"
	to_process = NULL;
#line 382 "../src/MediaMonitor.vala"
	to_remove = NULL;
#line 2694 "MediaMonitor.c"
	{
		GeeIterator* _updates_it = NULL;
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
#line 383 "../src/MediaMonitor.vala"
		_tmp5_ = self->priv->pending_updates;
#line 383 "../src/MediaMonitor.vala"
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
#line 383 "../src/MediaMonitor.vala"
		_tmp7_ = _tmp6_;
#line 383 "../src/MediaMonitor.vala"
		_tmp8_ = _tmp7_;
#line 383 "../src/MediaMonitor.vala"
		_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 383 "../src/MediaMonitor.vala"
		_tmp10_ = _tmp9_;
#line 383 "../src/MediaMonitor.vala"
		_g_object_unref0 (_tmp8_);
#line 383 "../src/MediaMonitor.vala"
		_updates_it = _tmp10_;
#line 383 "../src/MediaMonitor.vala"
		while (TRUE) {
#line 2721 "MediaMonitor.c"
			GeeIterator* _tmp11_;
			MonitorableUpdates* updates = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			MonitorableUpdates* _tmp14_;
			MonitorableUpdates* _tmp15_;
			GeeArrayList* _tmp21_;
			GeeArrayList* _tmp23_;
			MonitorableUpdates* _tmp24_;
#line 383 "../src/MediaMonitor.vala"
			_tmp11_ = _updates_it;
#line 383 "../src/MediaMonitor.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 383 "../src/MediaMonitor.vala"
				break;
#line 2737 "MediaMonitor.c"
			}
#line 383 "../src/MediaMonitor.vala"
			_tmp12_ = _updates_it;
#line 383 "../src/MediaMonitor.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 383 "../src/MediaMonitor.vala"
			updates = (MonitorableUpdates*) _tmp13_;
#line 384 "../src/MediaMonitor.vala"
			_tmp14_ = updates;
#line 384 "../src/MediaMonitor.vala"
			if (monitorable_updates_is_in_alteration (_tmp14_)) {
#line 385 "../src/MediaMonitor.vala"
				_monitorable_updates_unref0 (updates);
#line 385 "../src/MediaMonitor.vala"
				continue;
#line 2753 "MediaMonitor.c"
			}
#line 387 "../src/MediaMonitor.vala"
			_tmp15_ = updates;
#line 387 "../src/MediaMonitor.vala"
			if (monitorable_updates_is_all_updated (_tmp15_)) {
#line 2759 "MediaMonitor.c"
				GeeArrayList* _tmp16_;
				GeeArrayList* _tmp18_;
				MonitorableUpdates* _tmp19_;
				Monitorable* _tmp20_;
#line 388 "../src/MediaMonitor.vala"
				_tmp16_ = to_remove;
#line 388 "../src/MediaMonitor.vala"
				if (_tmp16_ == NULL) {
#line 2768 "MediaMonitor.c"
					GeeArrayList* _tmp17_;
#line 389 "../src/MediaMonitor.vala"
					_tmp17_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 389 "../src/MediaMonitor.vala"
					_g_object_unref0 (to_remove);
#line 389 "../src/MediaMonitor.vala"
					to_remove = _tmp17_;
#line 2776 "MediaMonitor.c"
				}
#line 391 "../src/MediaMonitor.vala"
				_tmp18_ = to_remove;
#line 391 "../src/MediaMonitor.vala"
				_tmp19_ = updates;
#line 391 "../src/MediaMonitor.vala"
				_tmp20_ = _tmp19_->monitorable;
#line 391 "../src/MediaMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp20_);
#line 392 "../src/MediaMonitor.vala"
				_monitorable_updates_unref0 (updates);
#line 392 "../src/MediaMonitor.vala"
				continue;
#line 2790 "MediaMonitor.c"
			}
#line 395 "../src/MediaMonitor.vala"
			_tmp21_ = to_process;
#line 395 "../src/MediaMonitor.vala"
			if (_tmp21_ == NULL) {
#line 2796 "MediaMonitor.c"
				GeeArrayList* _tmp22_;
#line 396 "../src/MediaMonitor.vala"
				_tmp22_ = gee_array_list_new (TYPE_MONITORABLE_UPDATES, (GBoxedCopyFunc) monitorable_updates_ref, (GDestroyNotify) monitorable_updates_unref, NULL, NULL, NULL);
#line 396 "../src/MediaMonitor.vala"
				_g_object_unref0 (to_process);
#line 396 "../src/MediaMonitor.vala"
				to_process = _tmp22_;
#line 2804 "MediaMonitor.c"
			}
#line 398 "../src/MediaMonitor.vala"
			_tmp23_ = to_process;
#line 398 "../src/MediaMonitor.vala"
			_tmp24_ = updates;
#line 398 "../src/MediaMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 383 "../src/MediaMonitor.vala"
			_monitorable_updates_unref0 (updates);
#line 2814 "MediaMonitor.c"
		}
#line 383 "../src/MediaMonitor.vala"
		_g_object_unref0 (_updates_it);
#line 2818 "MediaMonitor.c"
	}
#line 401 "../src/MediaMonitor.vala"
	op_count = 0;
#line 402 "../src/MediaMonitor.vala"
	_tmp25_ = to_process;
#line 402 "../src/MediaMonitor.vala"
	if (_tmp25_ != NULL) {
#line 2826 "MediaMonitor.c"
		TransactionController* controller = NULL;
		MediaSourceCollection* _tmp26_;
		MediaSourceCollection* _tmp27_;
		TransactionController* _tmp28_;
		TransactionController* _tmp29_;
		TransactionController* _tmp30_;
		TransactionController* _tmp31_;
#line 403 "../src/MediaMonitor.vala"
		_tmp26_ = media_monitor_get_media_source_collection (self);
#line 403 "../src/MediaMonitor.vala"
		_tmp27_ = _tmp26_;
#line 403 "../src/MediaMonitor.vala"
		_tmp28_ = media_source_collection_get_transaction_controller (_tmp27_);
#line 403 "../src/MediaMonitor.vala"
		_tmp29_ = _tmp28_;
#line 403 "../src/MediaMonitor.vala"
		_tmp30_ = _transaction_controller_ref0 (_tmp29_);
#line 403 "../src/MediaMonitor.vala"
		_tmp31_ = _tmp30_;
#line 403 "../src/MediaMonitor.vala"
		_data_collection_unref0 (_tmp27_);
#line 403 "../src/MediaMonitor.vala"
		controller = _tmp31_;
#line 2850 "MediaMonitor.c"
		{
			TransactionController* _tmp32_;
			GeeArrayList* _tmp33_;
			TransactionController* _tmp34_;
			TransactionController* _tmp35_;
#line 406 "../src/MediaMonitor.vala"
			_tmp32_ = controller;
#line 406 "../src/MediaMonitor.vala"
			transaction_controller_begin (_tmp32_);
#line 407 "../src/MediaMonitor.vala"
			_tmp33_ = to_process;
#line 407 "../src/MediaMonitor.vala"
			_tmp34_ = controller;
#line 407 "../src/MediaMonitor.vala"
			media_monitor_process_updates (self, (GeeCollection*) _tmp33_, _tmp34_, &op_count, &_inner_error0_);
#line 407 "../src/MediaMonitor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2868 "MediaMonitor.c"
				goto __catch0_g_error;
			}
#line 408 "../src/MediaMonitor.vala"
			_tmp35_ = controller;
#line 408 "../src/MediaMonitor.vala"
			transaction_controller_commit (_tmp35_);
#line 2875 "MediaMonitor.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp36_;
#line 405 "../src/MediaMonitor.vala"
			err = _inner_error0_;
#line 405 "../src/MediaMonitor.vala"
			_inner_error0_ = NULL;
#line 410 "../src/MediaMonitor.vala"
			_tmp36_ = err;
#line 410 "../src/MediaMonitor.vala"
			if (_tmp36_->domain == DATABASE_ERROR) {
#line 2890 "MediaMonitor.c"
				GError* _tmp37_;
#line 411 "../src/MediaMonitor.vala"
				_tmp37_ = err;
#line 411 "../src/MediaMonitor.vala"
				app_window_database_error ((GError*) _tmp37_);
#line 2896 "MediaMonitor.c"
			} else {
				GError* _tmp38_;
				const gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
#line 413 "../src/MediaMonitor.vala"
				_tmp38_ = err;
#line 413 "../src/MediaMonitor.vala"
				_tmp39_ = _tmp38_->message;
#line 413 "../src/MediaMonitor.vala"
				_tmp40_ = g_strdup_printf (_ ("Unable to process monitoring updates: %s"), _tmp39_);
#line 413 "../src/MediaMonitor.vala"
				_tmp41_ = _tmp40_;
#line 413 "../src/MediaMonitor.vala"
				app_window_panic (_tmp41_);
#line 413 "../src/MediaMonitor.vala"
				_g_free0 (_tmp41_);
#line 2914 "MediaMonitor.c"
			}
#line 405 "../src/MediaMonitor.vala"
			_g_error_free0 (err);
#line 2918 "MediaMonitor.c"
		}
		__finally0:
#line 405 "../src/MediaMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2923 "MediaMonitor.c"
			gboolean _tmp42_ = FALSE;
#line 405 "../src/MediaMonitor.vala"
			_transaction_controller_unref0 (controller);
#line 405 "../src/MediaMonitor.vala"
			_g_object_unref0 (to_remove);
#line 405 "../src/MediaMonitor.vala"
			_g_object_unref0 (to_process);
#line 405 "../src/MediaMonitor.vala"
			_g_timer_destroy0 (timer);
#line 405 "../src/MediaMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 405 "../src/MediaMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 405 "../src/MediaMonitor.vala"
			return _tmp42_;
#line 2939 "MediaMonitor.c"
		}
#line 402 "../src/MediaMonitor.vala"
		_transaction_controller_unref0 (controller);
#line 2943 "MediaMonitor.c"
	}
#line 417 "../src/MediaMonitor.vala"
	_tmp43_ = to_remove;
#line 417 "../src/MediaMonitor.vala"
	if (_tmp43_ != NULL) {
#line 2949 "MediaMonitor.c"
		{
			GeeArrayList* _monitorable_list = NULL;
			GeeArrayList* _tmp44_;
			gint _monitorable_size = 0;
			GeeArrayList* _tmp45_;
			gint _tmp46_;
			gint _tmp47_;
			gint _monitorable_index = 0;
#line 418 "../src/MediaMonitor.vala"
			_tmp44_ = to_remove;
#line 418 "../src/MediaMonitor.vala"
			_monitorable_list = _tmp44_;
#line 418 "../src/MediaMonitor.vala"
			_tmp45_ = _monitorable_list;
#line 418 "../src/MediaMonitor.vala"
			_tmp46_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp45_);
#line 418 "../src/MediaMonitor.vala"
			_tmp47_ = _tmp46_;
#line 418 "../src/MediaMonitor.vala"
			_monitorable_size = _tmp47_;
#line 418 "../src/MediaMonitor.vala"
			_monitorable_index = -1;
#line 418 "../src/MediaMonitor.vala"
			while (TRUE) {
#line 2974 "MediaMonitor.c"
				gint _tmp48_;
				gint _tmp49_;
				Monitorable* monitorable = NULL;
				GeeArrayList* _tmp50_;
				gpointer _tmp51_;
				Monitorable* _tmp52_;
#line 418 "../src/MediaMonitor.vala"
				_monitorable_index = _monitorable_index + 1;
#line 418 "../src/MediaMonitor.vala"
				_tmp48_ = _monitorable_index;
#line 418 "../src/MediaMonitor.vala"
				_tmp49_ = _monitorable_size;
#line 418 "../src/MediaMonitor.vala"
				if (!(_tmp48_ < _tmp49_)) {
#line 418 "../src/MediaMonitor.vala"
					break;
#line 2991 "MediaMonitor.c"
				}
#line 418 "../src/MediaMonitor.vala"
				_tmp50_ = _monitorable_list;
#line 418 "../src/MediaMonitor.vala"
				_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) _tmp50_, _monitorable_index);
#line 418 "../src/MediaMonitor.vala"
				monitorable = (Monitorable*) _tmp51_;
#line 419 "../src/MediaMonitor.vala"
				_tmp52_ = monitorable;
#line 419 "../src/MediaMonitor.vala"
				media_monitor_remove_updates (self, _tmp52_);
#line 418 "../src/MediaMonitor.vala"
				_g_object_unref0 (monitorable);
#line 3005 "MediaMonitor.c"
			}
		}
	}
#line 422 "../src/MediaMonitor.vala"
	_tmp53_ = timer;
#line 422 "../src/MediaMonitor.vala"
	elapsed = g_timer_elapsed (_tmp53_, NULL);
#line 423 "../src/MediaMonitor.vala"
	if (elapsed > 0.01) {
#line 423 "../src/MediaMonitor.vala"
		_tmp54_ = TRUE;
#line 3017 "MediaMonitor.c"
	} else {
#line 423 "../src/MediaMonitor.vala"
		_tmp54_ = op_count > 0;
#line 3021 "MediaMonitor.c"
	}
#line 423 "../src/MediaMonitor.vala"
	if (_tmp54_) {
#line 3025 "MediaMonitor.c"
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
#line 424 "../src/MediaMonitor.vala"
		_tmp55_ = media_monitor_to_string (self);
#line 424 "../src/MediaMonitor.vala"
		_tmp56_ = _tmp55_;
#line 424 "../src/MediaMonitor.vala"
		_tmp57_ = g_strdup_printf ("Total pending queue time for %s: %lf (%d ops)", _tmp56_, elapsed, op_count);
#line 424 "../src/MediaMonitor.vala"
		_tmp58_ = _tmp57_;
#line 424 "../src/MediaMonitor.vala"
		media_monitor_mdbg (_tmp58_);
#line 424 "../src/MediaMonitor.vala"
		_g_free0 (_tmp58_);
#line 424 "../src/MediaMonitor.vala"
		_g_free0 (_tmp56_);
#line 3044 "MediaMonitor.c"
	}
#line 428 "../src/MediaMonitor.vala"
	result = TRUE;
#line 428 "../src/MediaMonitor.vala"
	_g_object_unref0 (to_remove);
#line 428 "../src/MediaMonitor.vala"
	_g_object_unref0 (to_process);
#line 428 "../src/MediaMonitor.vala"
	_g_timer_destroy0 (timer);
#line 428 "../src/MediaMonitor.vala"
	return result;
#line 3056 "MediaMonitor.c"
}

static void
media_monitor_class_init (MediaMonitorClass * klass,
                          gpointer klass_data)
{
#line 114 "../src/MediaMonitor.vala"
	media_monitor_parent_class = g_type_class_peek_parent (klass);
#line 114 "../src/MediaMonitor.vala"
	g_type_class_adjust_private_offset (klass, &MediaMonitor_private_offset);
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->get_media_source_collection = (MediaSourceCollection* (*) (MediaMonitor*)) media_monitor_real_get_media_source_collection;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->close = (void (*) (MediaMonitor*)) media_monitor_real_close;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->to_string = (gchar* (*) (MediaMonitor*)) media_monitor_real_to_string;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->create_updates = (MonitorableUpdates* (*) (MediaMonitor*, Monitorable*)) media_monitor_real_create_updates;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->on_media_source_destroyed = (void (*) (MediaMonitor*, DataSource*)) media_monitor_real_on_media_source_destroyed;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_discovery_started = (void (*) (MediaMonitor*)) media_monitor_real_notify_discovery_started;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_discovered = (MediaMonitorDiscoveredFile (*) (MediaMonitor*, GFile*, GFileInfo*, Monitorable**)) media_monitor_real_notify_file_discovered;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->candidates_for_unknown_file = (GeeCollection* (*) (MediaMonitor*, GFile*, GFileInfo*, MediaMonitorDiscoveredFile*)) media_monitor_real_candidates_for_unknown_file;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->get_auxilliary_backing_files = (GFile** (*) (MediaMonitor*, Monitorable*, gint*)) media_monitor_real_get_auxilliary_backing_files;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->update_backing_file_info = (void (*) (MediaMonitor*, Monitorable*, GFile*, GFileInfo*)) media_monitor_real_update_backing_file_info;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_discovery_completing = (void (*) (MediaMonitor*)) media_monitor_real_notify_discovery_completing;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->is_file_represented = (gboolean (*) (MediaMonitor*, GFile*)) media_monitor_real_is_file_represented;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_created = (gboolean (*) (MediaMonitor*, GFile*, GFileInfo*)) media_monitor_real_notify_file_created;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_moved = (gboolean (*) (MediaMonitor*, GFile*, GFile*, GFileInfo*)) media_monitor_real_notify_file_moved;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_altered = (gboolean (*) (MediaMonitor*, GFile*)) media_monitor_real_notify_file_altered;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_attributes_altered = (gboolean (*) (MediaMonitor*, GFile*)) media_monitor_real_notify_file_attributes_altered;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_alteration_completed = (gboolean (*) (MediaMonitor*, GFile*, GFileInfo*)) media_monitor_real_notify_file_alteration_completed;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_deleted = (gboolean (*) (MediaMonitor*, GFile*)) media_monitor_real_notify_file_deleted;
#line 114 "../src/MediaMonitor.vala"
	((MediaMonitorClass *) klass)->process_updates = (void (*) (MediaMonitor*, GeeCollection*, TransactionController*, gint*, GError**)) media_monitor_real_process_updates;
#line 114 "../src/MediaMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = media_monitor_finalize;
#line 3107 "MediaMonitor.c"
}

static void
media_monitor_instance_init (MediaMonitor * self,
                             gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 114 "../src/MediaMonitor.vala"
	self->priv = media_monitor_get_instance_private (self);
#line 127 "../src/MediaMonitor.vala"
	_tmp0_ = gee_hash_map_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_MONITORABLE_UPDATES, (GBoxedCopyFunc) monitorable_updates_ref, (GDestroyNotify) monitorable_updates_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 127 "../src/MediaMonitor.vala"
	self->priv->pending_updates = _tmp0_;
#line 129 "../src/MediaMonitor.vala"
	self->priv->pending_updates_timer_id = (guint) 0;
#line 3123 "MediaMonitor.c"
}

static void
media_monitor_finalize (GObject * obj)
{
	MediaMonitor * self;
	MediaSourceCollection* _tmp0_;
	guint _tmp1_;
	MediaSourceCollection* _tmp2_;
	guint _tmp3_;
#line 114 "../src/MediaMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_MONITOR, MediaMonitor);
#line 143 "../src/MediaMonitor.vala"
	_tmp0_ = self->priv->sources;
#line 143 "../src/MediaMonitor.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 143 "../src/MediaMonitor.vala"
	g_signal_handlers_disconnect_matched ((SourceCollection*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _media_monitor_on_media_source_destroyed_source_collection_item_destroyed, self);
#line 144 "../src/MediaMonitor.vala"
	_tmp2_ = self->priv->sources;
#line 144 "../src/MediaMonitor.vala"
	g_signal_parse_name ("unlinked-destroyed", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 144 "../src/MediaMonitor.vala"
	g_signal_handlers_disconnect_matched ((SourceCollection*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _media_monitor_on_media_source_destroyed_source_collection_unlinked_destroyed, self);
#line 125 "../src/MediaMonitor.vala"
	_data_collection_unref0 (self->priv->sources);
#line 126 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 127 "../src/MediaMonitor.vala"
	_g_object_unref0 (self->priv->pending_updates);
#line 114 "../src/MediaMonitor.vala"
	G_OBJECT_CLASS (media_monitor_parent_class)->finalize (obj);
#line 3156 "MediaMonitor.c"
}

static GType
media_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaMonitor), 0, (GInstanceInitFunc) media_monitor_instance_init, NULL };
	GType media_monitor_type_id;
	media_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "MediaMonitor", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MediaMonitor_private_offset = g_type_add_instance_private (media_monitor_type_id, sizeof (MediaMonitorPrivate));
	return media_monitor_type_id;
}

GType
media_monitor_get_type (void)
{
	static volatile gsize media_monitor_type_id__once = 0;
	if (g_once_init_enter (&media_monitor_type_id__once)) {
		GType media_monitor_type_id;
		media_monitor_type_id = media_monitor_get_type_once ();
		g_once_init_leave (&media_monitor_type_id__once, media_monitor_type_id);
	}
	return media_monitor_type_id__once;
}

