/* PageWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from PageWindow.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io),
                2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* PageWindow is a Gtk.Window with essential functions for hosting a Page.  There may be more than*/
/* one PageWindow in the system, and closing one does not imply exiting the application.*/
/**/
/* PageWindow offers support for hosting a single Page; multiple Pages must be handled by the*/
/* subclass.  A subclass should set current_page to the user-visible Page for it to receive*/
/* various notifications.  It is the responsibility of the subclass to notify Pages when they're*/
/* switched to and from, and other aspects of the Page interface.*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <handy.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PAGE_WINDOW_0_PROPERTY,
	PAGE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* page_window_properties[PAGE_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PageWindowPrivate {
	Page* current_page;
	gint busy_counter;
};

static gint PageWindow_private_offset;
static gpointer page_window_parent_class = NULL;

static void page_window_real_switched_pages (PageWindow* self,
                                      Page* old_page,
                                      Page* new_page);
static void page_window_real_set_current_page (PageWindow* self,
                                        Page* page);
static void page_window_real_clear_current_page (PageWindow* self);
static gboolean page_window_real_key_press_event (GtkWidget* base,
                                           GdkEventKey* event);
static gboolean page_window_real_key_release_event (GtkWidget* base,
                                             GdkEventKey* event);
static gboolean page_window_real_focus_in_event (GtkWidget* base,
                                          GdkEventFocus* event);
static gboolean page_window_real_focus_out_event (GtkWidget* base,
                                           GdkEventFocus* event);
static gboolean page_window_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event);
static GObject * page_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void page_window_finalize (GObject * obj);
static GType page_window_get_type_once (void);

static inline gpointer
page_window_get_instance_private (PageWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PageWindow_private_offset);
}

static void
page_window_real_switched_pages (PageWindow* self,
                                 Page* old_page,
                                 Page* new_page)
{
}

void
page_window_switched_pages (PageWindow* self,
                            Page* old_page,
                            Page* new_page)
{
	PageWindowClass* _klass_;
#line 34 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/PageWindow.vala"
	_klass_ = PAGE_WINDOW_GET_CLASS (self);
#line 34 "../src/PageWindow.vala"
	if (_klass_->switched_pages) {
#line 34 "../src/PageWindow.vala"
		_klass_->switched_pages (self, old_page, new_page);
#line 112 "PageWindow.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 51 "../src/PageWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 121 "PageWindow.c"
}

Page*
page_window_get_current_page (PageWindow* self)
{
	Page* _tmp0_;
	Page* _tmp1_;
	Page* result;
#line 50 "../src/PageWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 51 "../src/PageWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 51 "../src/PageWindow.vala"
	result = _tmp1_;
#line 51 "../src/PageWindow.vala"
	return result;
#line 140 "PageWindow.c"
}

static void
page_window_real_set_current_page (PageWindow* self,
                                   Page* page)
{
	Page* _tmp0_;
	Page* old_page = NULL;
	Page* _tmp2_;
	Page* _tmp3_;
	Page* _tmp4_;
	Page* _tmp5_;
#line 54 "../src/PageWindow.vala"
	g_return_if_fail (page != NULL);
#line 55 "../src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 55 "../src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 159 "PageWindow.c"
		Page* _tmp1_;
#line 56 "../src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 56 "../src/PageWindow.vala"
		page_clear_container (_tmp1_);
#line 165 "PageWindow.c"
	}
#line 58 "../src/PageWindow.vala"
	_tmp2_ = self->priv->current_page;
#line 58 "../src/PageWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 58 "../src/PageWindow.vala"
	old_page = _tmp3_;
#line 59 "../src/PageWindow.vala"
	_tmp4_ = _g_object_ref0 (page);
#line 59 "../src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 59 "../src/PageWindow.vala"
	self->priv->current_page = _tmp4_;
#line 60 "../src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 60 "../src/PageWindow.vala"
	page_set_container (_tmp5_, (GtkWindow*) self);
#line 62 "../src/PageWindow.vala"
	page_window_switched_pages (self, old_page, page);
#line 54 "../src/PageWindow.vala"
	_g_object_unref0 (old_page);
#line 187 "PageWindow.c"
}

void
page_window_set_current_page (PageWindow* self,
                              Page* page)
{
	PageWindowClass* _klass_;
#line 54 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/PageWindow.vala"
	_klass_ = PAGE_WINDOW_GET_CLASS (self);
#line 54 "../src/PageWindow.vala"
	if (_klass_->set_current_page) {
#line 54 "../src/PageWindow.vala"
		_klass_->set_current_page (self, page);
#line 203 "PageWindow.c"
	}
}

static void
page_window_real_clear_current_page (PageWindow* self)
{
	Page* _tmp0_;
	Page* old_page = NULL;
	Page* _tmp2_;
	Page* _tmp3_;
#line 66 "../src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 66 "../src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 218 "PageWindow.c"
		Page* _tmp1_;
#line 67 "../src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 67 "../src/PageWindow.vala"
		page_clear_container (_tmp1_);
#line 224 "PageWindow.c"
	}
#line 69 "../src/PageWindow.vala"
	_tmp2_ = self->priv->current_page;
#line 69 "../src/PageWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 69 "../src/PageWindow.vala"
	old_page = _tmp3_;
#line 70 "../src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 70 "../src/PageWindow.vala"
	self->priv->current_page = NULL;
#line 72 "../src/PageWindow.vala"
	page_window_switched_pages (self, old_page, NULL);
#line 65 "../src/PageWindow.vala"
	_g_object_unref0 (old_page);
#line 240 "PageWindow.c"
}

void
page_window_clear_current_page (PageWindow* self)
{
	PageWindowClass* _klass_;
#line 65 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/PageWindow.vala"
	_klass_ = PAGE_WINDOW_GET_CLASS (self);
#line 65 "../src/PageWindow.vala"
	if (_klass_->clear_current_page) {
#line 65 "../src/PageWindow.vala"
		_klass_->clear_current_page (self);
#line 255 "PageWindow.c"
	}
}

static gboolean
page_window_real_key_press_event (GtkWidget* base,
                                  GdkEventKey* event)
{
	PageWindow * self;
	gboolean _tmp0_ = FALSE;
	GtkWidget* _tmp1_;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	gboolean _tmp7_ = FALSE;
	gboolean result;
#line 75 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 75 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 76 "../src/PageWindow.vala"
	_tmp1_ = gtk_window_get_focus ((GtkWindow*) self);
#line 76 "../src/PageWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_entry_get_type ())) {
#line 278 "PageWindow.c"
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 76 "../src/PageWindow.vala"
		_tmp2_ = gtk_window_get_focus ((GtkWindow*) self);
#line 76 "../src/PageWindow.vala"
		g_signal_emit_by_name (_tmp2_, "key-press-event", event, &_tmp3_);
#line 76 "../src/PageWindow.vala"
		_tmp0_ = _tmp3_;
#line 287 "PageWindow.c"
	} else {
#line 76 "../src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 291 "PageWindow.c"
	}
#line 76 "../src/PageWindow.vala"
	if (_tmp0_) {
#line 77 "../src/PageWindow.vala"
		result = TRUE;
#line 77 "../src/PageWindow.vala"
		return result;
#line 299 "PageWindow.c"
	}
#line 79 "../src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 79 "../src/PageWindow.vala"
	if (_tmp5_ != NULL) {
#line 305 "PageWindow.c"
		Page* _tmp6_;
#line 79 "../src/PageWindow.vala"
		_tmp6_ = self->priv->current_page;
#line 79 "../src/PageWindow.vala"
		_tmp4_ = page_notify_app_key_pressed (_tmp6_, event);
#line 311 "PageWindow.c"
	} else {
#line 79 "../src/PageWindow.vala"
		_tmp4_ = FALSE;
#line 315 "PageWindow.c"
	}
#line 79 "../src/PageWindow.vala"
	if (_tmp4_) {
#line 80 "../src/PageWindow.vala"
		result = TRUE;
#line 80 "../src/PageWindow.vala"
		return result;
#line 323 "PageWindow.c"
	}
#line 82 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->key_press_event != NULL) {
#line 82 "../src/PageWindow.vala"
		_tmp7_ = GTK_WIDGET_CLASS (page_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 329 "PageWindow.c"
	} else {
#line 82 "../src/PageWindow.vala"
		_tmp7_ = FALSE;
#line 333 "PageWindow.c"
	}
#line 82 "../src/PageWindow.vala"
	result = _tmp7_;
#line 82 "../src/PageWindow.vala"
	return result;
#line 339 "PageWindow.c"
}

static gboolean
page_window_real_key_release_event (GtkWidget* base,
                                    GdkEventKey* event)
{
	PageWindow * self;
	gboolean _tmp0_ = FALSE;
	GtkWidget* _tmp1_;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	gboolean _tmp7_ = FALSE;
	gboolean result;
#line 85 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 85 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 86 "../src/PageWindow.vala"
	_tmp1_ = gtk_window_get_focus ((GtkWindow*) self);
#line 86 "../src/PageWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_entry_get_type ())) {
#line 361 "PageWindow.c"
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 86 "../src/PageWindow.vala"
		_tmp2_ = gtk_window_get_focus ((GtkWindow*) self);
#line 86 "../src/PageWindow.vala"
		g_signal_emit_by_name (_tmp2_, "key-release-event", event, &_tmp3_);
#line 86 "../src/PageWindow.vala"
		_tmp0_ = _tmp3_;
#line 370 "PageWindow.c"
	} else {
#line 86 "../src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 374 "PageWindow.c"
	}
#line 86 "../src/PageWindow.vala"
	if (_tmp0_) {
#line 87 "../src/PageWindow.vala"
		result = TRUE;
#line 87 "../src/PageWindow.vala"
		return result;
#line 382 "PageWindow.c"
	}
#line 89 "../src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 89 "../src/PageWindow.vala"
	if (_tmp5_ != NULL) {
#line 388 "PageWindow.c"
		Page* _tmp6_;
#line 89 "../src/PageWindow.vala"
		_tmp6_ = self->priv->current_page;
#line 89 "../src/PageWindow.vala"
		_tmp4_ = page_notify_app_key_released (_tmp6_, event);
#line 394 "PageWindow.c"
	} else {
#line 89 "../src/PageWindow.vala"
		_tmp4_ = FALSE;
#line 398 "PageWindow.c"
	}
#line 89 "../src/PageWindow.vala"
	if (_tmp4_) {
#line 90 "../src/PageWindow.vala"
		result = TRUE;
#line 90 "../src/PageWindow.vala"
		return result;
#line 406 "PageWindow.c"
	}
#line 92 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->key_release_event != NULL) {
#line 92 "../src/PageWindow.vala"
		_tmp7_ = GTK_WIDGET_CLASS (page_window_parent_class)->key_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 412 "PageWindow.c"
	} else {
#line 92 "../src/PageWindow.vala"
		_tmp7_ = FALSE;
#line 416 "PageWindow.c"
	}
#line 92 "../src/PageWindow.vala"
	result = _tmp7_;
#line 92 "../src/PageWindow.vala"
	return result;
#line 422 "PageWindow.c"
}

static gboolean
page_window_real_focus_in_event (GtkWidget* base,
                                 GdkEventFocus* event)
{
	PageWindow * self;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 95 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 95 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 96 "../src/PageWindow.vala"
	_tmp1_ = self->priv->current_page;
#line 96 "../src/PageWindow.vala"
	if (_tmp1_ != NULL) {
#line 442 "PageWindow.c"
		Page* _tmp2_;
#line 96 "../src/PageWindow.vala"
		_tmp2_ = self->priv->current_page;
#line 96 "../src/PageWindow.vala"
		_tmp0_ = page_notify_app_focus_in (_tmp2_, event);
#line 448 "PageWindow.c"
	} else {
#line 96 "../src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 452 "PageWindow.c"
	}
#line 96 "../src/PageWindow.vala"
	if (_tmp0_) {
#line 97 "../src/PageWindow.vala"
		result = TRUE;
#line 97 "../src/PageWindow.vala"
		return result;
#line 460 "PageWindow.c"
	}
#line 99 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->focus_in_event != NULL) {
#line 99 "../src/PageWindow.vala"
		_tmp3_ = GTK_WIDGET_CLASS (page_window_parent_class)->focus_in_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 466 "PageWindow.c"
	} else {
#line 99 "../src/PageWindow.vala"
		_tmp3_ = FALSE;
#line 470 "PageWindow.c"
	}
#line 99 "../src/PageWindow.vala"
	result = _tmp3_;
#line 99 "../src/PageWindow.vala"
	return result;
#line 476 "PageWindow.c"
}

static gboolean
page_window_real_focus_out_event (GtkWidget* base,
                                  GdkEventFocus* event)
{
	PageWindow * self;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 102 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 102 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 103 "../src/PageWindow.vala"
	_tmp1_ = self->priv->current_page;
#line 103 "../src/PageWindow.vala"
	if (_tmp1_ != NULL) {
#line 496 "PageWindow.c"
		Page* _tmp2_;
#line 103 "../src/PageWindow.vala"
		_tmp2_ = self->priv->current_page;
#line 103 "../src/PageWindow.vala"
		_tmp0_ = page_notify_app_focus_out (_tmp2_, event);
#line 502 "PageWindow.c"
	} else {
#line 103 "../src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 506 "PageWindow.c"
	}
#line 103 "../src/PageWindow.vala"
	if (_tmp0_) {
#line 104 "../src/PageWindow.vala"
		result = TRUE;
#line 104 "../src/PageWindow.vala"
		return result;
#line 514 "PageWindow.c"
	}
#line 106 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->focus_out_event != NULL) {
#line 106 "../src/PageWindow.vala"
		_tmp3_ = GTK_WIDGET_CLASS (page_window_parent_class)->focus_out_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 520 "PageWindow.c"
	} else {
#line 106 "../src/PageWindow.vala"
		_tmp3_ = FALSE;
#line 524 "PageWindow.c"
	}
#line 106 "../src/PageWindow.vala"
	result = _tmp3_;
#line 106 "../src/PageWindow.vala"
	return result;
#line 530 "PageWindow.c"
}

static gboolean
page_window_real_configure_event (GtkWidget* base,
                                  GdkEventConfigure* event)
{
	PageWindow * self;
	Page* _tmp0_;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 109 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 109 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 110 "../src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 110 "../src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 549 "PageWindow.c"
		Page* _tmp1_;
#line 111 "../src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 111 "../src/PageWindow.vala"
		if (page_notify_configure_event (_tmp1_, event)) {
#line 112 "../src/PageWindow.vala"
			result = TRUE;
#line 112 "../src/PageWindow.vala"
			return result;
#line 559 "PageWindow.c"
		}
	}
#line 115 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->configure_event != NULL) {
#line 115 "../src/PageWindow.vala"
		_tmp2_ = GTK_WIDGET_CLASS (page_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
#line 566 "PageWindow.c"
	} else {
#line 115 "../src/PageWindow.vala"
		_tmp2_ = FALSE;
#line 570 "PageWindow.c"
	}
#line 115 "../src/PageWindow.vala"
	result = _tmp2_;
#line 115 "../src/PageWindow.vala"
	return result;
#line 576 "PageWindow.c"
}

void
page_window_set_busy_cursor (PageWindow* self)
{
	gint _tmp0_;
	GdkWindow* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkCursor* _tmp4_;
#line 118 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/PageWindow.vala"
	_tmp0_ = self->priv->busy_counter;
#line 119 "../src/PageWindow.vala"
	self->priv->busy_counter = _tmp0_ + 1;
#line 119 "../src/PageWindow.vala"
	if (_tmp0_ > 0) {
#line 120 "../src/PageWindow.vala"
		return;
#line 597 "PageWindow.c"
	}
#line 122 "../src/PageWindow.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 122 "../src/PageWindow.vala"
	_tmp2_ = gdk_display_get_default ();
#line 122 "../src/PageWindow.vala"
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_WATCH);
#line 122 "../src/PageWindow.vala"
	_tmp4_ = _tmp3_;
#line 122 "../src/PageWindow.vala"
	gdk_window_set_cursor (_tmp1_, _tmp4_);
#line 122 "../src/PageWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 123 "../src/PageWindow.vala"
	spin_event_loop ();
#line 613 "PageWindow.c"
}

void
page_window_set_normal_cursor (PageWindow* self)
{
	GdkWindow* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkCursor* _tmp4_;
#line 126 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/PageWindow.vala"
	if (self->priv->busy_counter <= 0) {
#line 128 "../src/PageWindow.vala"
		self->priv->busy_counter = 0;
#line 129 "../src/PageWindow.vala"
		return;
#line 631 "PageWindow.c"
	} else {
		gint _tmp0_;
#line 130 "../src/PageWindow.vala"
		self->priv->busy_counter = self->priv->busy_counter - 1;
#line 130 "../src/PageWindow.vala"
		_tmp0_ = self->priv->busy_counter;
#line 130 "../src/PageWindow.vala"
		if (_tmp0_ > 0) {
#line 131 "../src/PageWindow.vala"
			return;
#line 642 "PageWindow.c"
		}
	}
#line 134 "../src/PageWindow.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 134 "../src/PageWindow.vala"
	_tmp2_ = gdk_display_get_default ();
#line 134 "../src/PageWindow.vala"
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_LEFT_PTR);
#line 134 "../src/PageWindow.vala"
	_tmp4_ = _tmp3_;
#line 134 "../src/PageWindow.vala"
	gdk_window_set_cursor (_tmp1_, _tmp4_);
#line 134 "../src/PageWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 135 "../src/PageWindow.vala"
	spin_event_loop ();
#line 659 "PageWindow.c"
}

PageWindow*
page_window_construct (GType object_type)
{
	PageWindow * self = NULL;
#line 28 "../src/PageWindow.vala"
	self = (PageWindow*) g_object_new (object_type, NULL);
#line 28 "../src/PageWindow.vala"
	return self;
#line 670 "PageWindow.c"
}

static GObject *
page_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PageWindow * self;
	GtkUIManager* _tmp0_;
#line 37 "../src/PageWindow.vala"
	parent_class = G_OBJECT_CLASS (page_window_parent_class);
#line 37 "../src/PageWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/PageWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_WINDOW, PageWindow);
#line 38 "../src/PageWindow.vala"
	hdy_init ();
#line 41 "../src/PageWindow.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((GDK_KEY_PRESS_MASK | GDK_KEY_RELEASE_MASK) | GDK_STRUCTURE_MASK));
#line 47 "../src/PageWindow.vala"
	_tmp0_ = gtk_ui_manager_new ();
#line 47 "../src/PageWindow.vala"
	_g_object_unref0 (self->ui);
#line 47 "../src/PageWindow.vala"
	self->ui = _tmp0_;
#line 37 "../src/PageWindow.vala"
	return obj;
#line 700 "PageWindow.c"
}

static void
page_window_class_init (PageWindowClass * klass,
                        gpointer klass_data)
{
#line 28 "../src/PageWindow.vala"
	page_window_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/PageWindow.vala"
	g_type_class_adjust_private_offset (klass, &PageWindow_private_offset);
#line 28 "../src/PageWindow.vala"
	((PageWindowClass *) klass)->switched_pages = (void (*) (PageWindow*, Page*, Page*)) page_window_real_switched_pages;
#line 28 "../src/PageWindow.vala"
	((PageWindowClass *) klass)->set_current_page = (void (*) (PageWindow*, Page*)) page_window_real_set_current_page;
#line 28 "../src/PageWindow.vala"
	((PageWindowClass *) klass)->clear_current_page = (void (*) (PageWindow*)) page_window_real_clear_current_page;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) page_window_real_key_press_event;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->key_release_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) page_window_real_key_release_event;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->focus_in_event = (gboolean (*) (GtkWidget*, GdkEventFocus*)) page_window_real_focus_in_event;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->focus_out_event = (gboolean (*) (GtkWidget*, GdkEventFocus*)) page_window_real_focus_out_event;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) page_window_real_configure_event;
#line 28 "../src/PageWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = page_window_constructor;
#line 28 "../src/PageWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = page_window_finalize;
#line 731 "PageWindow.c"
}

static void
page_window_instance_init (PageWindow * self,
                           gpointer klass)
{
#line 28 "../src/PageWindow.vala"
	self->priv = page_window_get_instance_private (self);
#line 31 "../src/PageWindow.vala"
	self->priv->current_page = NULL;
#line 32 "../src/PageWindow.vala"
	self->priv->busy_counter = 0;
#line 744 "PageWindow.c"
}

static void
page_window_finalize (GObject * obj)
{
	PageWindow * self;
#line 28 "../src/PageWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_WINDOW, PageWindow);
#line 29 "../src/PageWindow.vala"
	_g_object_unref0 (self->ui);
#line 31 "../src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 28 "../src/PageWindow.vala"
	G_OBJECT_CLASS (page_window_parent_class)->finalize (obj);
#line 759 "PageWindow.c"
}

static GType
page_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PageWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageWindow), 0, (GInstanceInitFunc) page_window_instance_init, NULL };
	GType page_window_type_id;
	page_window_type_id = g_type_register_static (hdy_application_window_get_type (), "PageWindow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PageWindow_private_offset = g_type_add_instance_private (page_window_type_id, sizeof (PageWindowPrivate));
	return page_window_type_id;
}

GType
page_window_get_type (void)
{
	static volatile gsize page_window_type_id__once = 0;
	if (g_once_init_enter (&page_window_type_id__once)) {
		GType page_window_type_id;
		page_window_type_id = page_window_get_type_once ();
		g_once_init_leave (&page_window_type_id__once, page_window_type_id);
	}
	return page_window_type_id__once;
}

