/* Printing.c generated by valac 0.56.18, the Vala compiler
 * generated from Printing.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io)
*               2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#define MEASUREMENT_CENTIMETERS_PER_INCH 2.54
#define MEASUREMENT_INCHES_PER_CENTIMETER (1.0 / 2.54)
#define PRINT_MANAGER_IMAGE_DISTANCE 0.24
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _print_manager_unref0(var) ((var == NULL) ? NULL : (var = (print_manager_unref (var), NULL)))
typedef struct _ParamSpecPrintSettings ParamSpecPrintSettings;
typedef enum  {
	PRINT_LAYOUT_ENTIRE_PAGE,
	PRINT_LAYOUT_TWO_PER_PAGE,
	PRINT_LAYOUT_FOUR_PER_PAGE,
	PRINT_LAYOUT_SIX_PER_PAGE,
	PRINT_LAYOUT_EIGHT_PER_PAGE,
	PRINT_LAYOUT_SIXTEEN_PER_PAGE,
	PRINT_LAYOUT_THIRTY_TWO_PER_PAGE
} PrintLayout;

#define TYPE_PRINT_LAYOUT (print_layout_get_type ())
enum  {
	PRINT_JOB_0_PROPERTY,
	PRINT_JOB_NUM_PROPERTIES
};
static GParamSpec* print_job_properties[PRINT_JOB_NUM_PROPERTIES];
#define _print_settings_unref0(var) ((var == NULL) ? NULL : (var = (print_settings_unref (var), NULL)))
typedef struct _ParamSpecStandardPrintSize ParamSpecStandardPrintSize;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
typedef struct _ParamSpecPrintManager ParamSpecPrintManager;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PrintSettingsPrivate {
	ContentLayout content_layout;
	Measurement content_width;
	Measurement content_height;
	gint content_ppi;
	gint image_per_page_selection;
	gint size_selection;
	gboolean match_aspect_ratio;
	gboolean print_titles;
	gchar* print_titles_font;
	GSettings* print_settings;
};

struct _ParamSpecPrintSettings {
	GParamSpec parent_instance;
};

struct _PrintJobPrivate {
	PrintSettings* settings;
	GeeArrayList* photos;
};

struct _ParamSpecStandardPrintSize {
	GParamSpec parent_instance;
};

struct _PrintManagerPrivate {
	PrintSettings* settings;
	GtkPageSetup* user_page_setup;
	CustomPrintTab* custom_tab;
	ProgressDialog* progress_dialog;
	GCancellable* cancellable;
};

struct _ParamSpecPrintManager {
	GParamSpec parent_instance;
};

static gint PrintSettings_private_offset;
static gpointer print_settings_parent_class = NULL;
static gint PrintJob_private_offset;
static gpointer print_job_parent_class = NULL;
static gpointer standard_print_size_parent_class = NULL;
static gint PrintManager_private_offset;
static gpointer print_manager_parent_class = NULL;
static PrintManager* print_manager_instance;
static PrintManager* print_manager_instance = NULL;

static void print_settings_finalize (PrintSettings * obj);
static GType print_settings_get_type_once (void);
VALA_EXTERN GType print_layout_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PrintLayout* print_layout_get_all (gint* result_length1);
VALA_EXTERN gint print_layout_get_per_page (PrintLayout self);
VALA_EXTERN gint print_layout_get_x (PrintLayout self);
VALA_EXTERN gint print_layout_get_y (PrintLayout self);
VALA_EXTERN gchar* print_layout_to_string (PrintLayout self);
static void print_job_finalize (GObject * obj);
static GType print_job_get_type_once (void);
static void standard_print_size_finalize (StandardPrintSize * obj);
static GType standard_print_size_get_type_once (void);
static PrintManager* print_manager_new (void);
static PrintManager* print_manager_construct (GType object_type);
static void _vala_array_add30 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add31 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add32 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add33 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add34 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add35 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add36 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add37 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add38 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add39 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add40 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add41 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add42 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add43 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void _vala_array_add44 (StandardPrintSize** * array,
                        gint* length,
                        gint* size,
                        StandardPrintSize* value);
static void print_manager_on_begin_print (PrintManager* self,
                                   GtkPrintOperation* emitting_object,
                                   GtkPrintContext* job_context);
static void _print_manager_on_begin_print_gtk_print_operation_begin_print (GtkPrintOperation* _sender,
                                                                    GtkPrintContext* context,
                                                                    gpointer self);
static void print_manager_on_draw_page (PrintManager* self,
                                 GtkPrintOperation* emitting_object,
                                 GtkPrintContext* job_context,
                                 gint page_num);
static void _print_manager_on_draw_page_gtk_print_operation_draw_page (GtkPrintOperation* _sender,
                                                                GtkPrintContext* context,
                                                                gint page_nr,
                                                                gpointer self);
static GObject* print_manager_on_create_custom_widget (PrintManager* self,
                                                GtkPrintOperation* emitting_object);
static GObject* _print_manager_on_create_custom_widget_gtk_print_operation_create_custom_widget (GtkPrintOperation* _sender,
                                                                                          gpointer self);
static void print_manager_on_status_changed (PrintManager* self,
                                      GtkPrintOperation* job);
static void _print_manager_on_status_changed_gtk_print_operation_status_changed (GtkPrintOperation* _sender,
                                                                          gpointer self);
static void print_manager_fit_image_to_canvas (PrintManager* self,
                                        Photo* photo,
                                        gdouble x,
                                        gdouble y,
                                        gdouble canvas_width,
                                        gdouble canvas_height,
                                        gboolean crop,
                                        PrintJob* job,
                                        GtkPrintContext* job_context);
static void print_manager_add_title_to_canvas (PrintManager* self,
                                        gdouble x,
                                        gdouble y,
                                        const gchar* title,
                                        PrintJob* job,
                                        GtkPrintContext* job_context);
static void print_manager_on_custom_widget_apply (PrintManager* self,
                                           GtkWidget* custom_widget);
static void _print_manager_on_custom_widget_apply_gtk_print_operation_custom_widget_apply (GtkPrintOperation* _sender,
                                                                                    GtkWidget* widget,
                                                                                    gpointer self);
static gboolean print_manager_are_approximately_equal (PrintManager* self,
                                                gdouble val1,
                                                gdouble val2);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void print_manager_finalize (PrintManager * obj);
static GType print_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static GType
content_layout_get_type_once (void)
{
	static const GEnumValue values[] = {{CONTENT_LAYOUT_STANDARD_SIZE, "CONTENT_LAYOUT_STANDARD_SIZE", "standard-size"}, {CONTENT_LAYOUT_CUSTOM_SIZE, "CONTENT_LAYOUT_CUSTOM_SIZE", "custom-size"}, {CONTENT_LAYOUT_IMAGE_PER_PAGE, "CONTENT_LAYOUT_IMAGE_PER_PAGE", "image-per-page"}, {0, NULL, NULL}};
	GType content_layout_type_id;
	content_layout_type_id = g_enum_register_static ("ContentLayout", values);
	return content_layout_type_id;
}

GType
content_layout_get_type (void)
{
	static volatile gsize content_layout_type_id__once = 0;
	if (g_once_init_enter (&content_layout_type_id__once)) {
		GType content_layout_type_id;
		content_layout_type_id = content_layout_get_type_once ();
		g_once_init_leave (&content_layout_type_id__once, content_layout_type_id);
	}
	return content_layout_type_id__once;
}

static inline gpointer
print_settings_get_instance_private (PrintSettings* self)
{
	return G_STRUCT_MEMBER_P (self, PrintSettings_private_offset);
}

PrintSettings*
print_settings_construct (GType object_type)
{
	PrintSettings* self = NULL;
	GSettings* _tmp0_;
	MeasurementUnit units = 0;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	gchar* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
#line 45 "../src/Printing.vala"
	self = (PrintSettings*) g_type_create_instance (object_type);
#line 46 "../src/Printing.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_PRINTING_SCHEMA_NAME);
#line 46 "../src/Printing.vala"
	_g_object_unref0 (self->priv->print_settings);
#line 46 "../src/Printing.vala"
	self->priv->print_settings = _tmp0_;
#line 48 "../src/Printing.vala"
	_tmp1_ = self->priv->print_settings;
#line 48 "../src/Printing.vala"
	units = ((MeasurementUnit) g_settings_get_int (_tmp1_, "content-units")) - 1;
#line 49 "../src/Printing.vala"
	_tmp2_ = self->priv->print_settings;
#line 49 "../src/Printing.vala"
	measurement_init (&self->priv->content_width, g_settings_get_double (_tmp2_, "content-width"), units);
#line 50 "../src/Printing.vala"
	_tmp3_ = self->priv->print_settings;
#line 50 "../src/Printing.vala"
	measurement_init (&self->priv->content_height, g_settings_get_double (_tmp3_, "content-height"), units);
#line 51 "../src/Printing.vala"
	_tmp4_ = self->priv->print_settings;
#line 51 "../src/Printing.vala"
	self->priv->size_selection = g_settings_get_int (_tmp4_, "size-selection") - 1;
#line 52 "../src/Printing.vala"
	_tmp5_ = self->priv->print_settings;
#line 52 "../src/Printing.vala"
	self->priv->content_layout = (ContentLayout) (g_settings_get_int (_tmp5_, "content-layout") - 1);
#line 53 "../src/Printing.vala"
	_tmp6_ = self->priv->print_settings;
#line 53 "../src/Printing.vala"
	self->priv->match_aspect_ratio = g_settings_get_boolean (_tmp6_, "match-aspect-ratio");
#line 54 "../src/Printing.vala"
	_tmp7_ = self->priv->print_settings;
#line 54 "../src/Printing.vala"
	self->priv->print_titles = g_settings_get_boolean (_tmp7_, "print-titles");
#line 55 "../src/Printing.vala"
	_tmp8_ = self->priv->print_settings;
#line 55 "../src/Printing.vala"
	_tmp9_ = g_settings_get_string (_tmp8_, "titles-font");
#line 55 "../src/Printing.vala"
	_g_free0 (self->priv->print_titles_font);
#line 55 "../src/Printing.vala"
	self->priv->print_titles_font = _tmp9_;
#line 56 "../src/Printing.vala"
	_tmp10_ = self->priv->print_settings;
#line 56 "../src/Printing.vala"
	self->priv->image_per_page_selection = g_settings_get_int (_tmp10_, "images-per-page") - 1;
#line 57 "../src/Printing.vala"
	_tmp11_ = self->priv->print_settings;
#line 57 "../src/Printing.vala"
	self->priv->content_ppi = g_settings_get_int (_tmp11_, "content-ppi");
#line 45 "../src/Printing.vala"
	return self;
#line 361 "Printing.c"
}

PrintSettings*
print_settings_new (void)
{
#line 45 "../src/Printing.vala"
	return print_settings_construct (TYPE_PRINT_SETTINGS);
#line 369 "Printing.c"
}

void
print_settings_save (PrintSettings* self)
{
	GSettings* _tmp0_;
	Measurement _tmp1_;
	GSettings* _tmp2_;
	Measurement _tmp3_;
	GSettings* _tmp4_;
	Measurement _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	const gchar* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
#line 60 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/Printing.vala"
	_tmp0_ = self->priv->print_settings;
#line 61 "../src/Printing.vala"
	_tmp1_ = self->priv->content_width;
#line 61 "../src/Printing.vala"
	g_settings_set_int (_tmp0_, "content-units", (gint) (_tmp1_.unit + 1));
#line 62 "../src/Printing.vala"
	_tmp2_ = self->priv->print_settings;
#line 62 "../src/Printing.vala"
	_tmp3_ = self->priv->content_width;
#line 62 "../src/Printing.vala"
	g_settings_set_double (_tmp2_, "content-width", _tmp3_.value);
#line 63 "../src/Printing.vala"
	_tmp4_ = self->priv->print_settings;
#line 63 "../src/Printing.vala"
	_tmp5_ = self->priv->content_height;
#line 63 "../src/Printing.vala"
	g_settings_set_double (_tmp4_, "content-height", _tmp5_.value);
#line 64 "../src/Printing.vala"
	_tmp6_ = self->priv->print_settings;
#line 64 "../src/Printing.vala"
	g_settings_set_int (_tmp6_, "size-selection", self->priv->size_selection + 1);
#line 65 "../src/Printing.vala"
	_tmp7_ = self->priv->print_settings;
#line 65 "../src/Printing.vala"
	g_settings_set_int (_tmp7_, "content-layout", (gint) (self->priv->content_layout + 1));
#line 66 "../src/Printing.vala"
	_tmp8_ = self->priv->print_settings;
#line 66 "../src/Printing.vala"
	g_settings_set_boolean (_tmp8_, "match-aspect-ratio", self->priv->match_aspect_ratio);
#line 67 "../src/Printing.vala"
	_tmp9_ = self->priv->print_settings;
#line 67 "../src/Printing.vala"
	g_settings_set_boolean (_tmp9_, "print-titles", self->priv->print_titles);
#line 68 "../src/Printing.vala"
	_tmp10_ = self->priv->print_settings;
#line 68 "../src/Printing.vala"
	_tmp11_ = self->priv->print_titles_font;
#line 68 "../src/Printing.vala"
	g_settings_set_string (_tmp10_, "titles-font", _tmp11_);
#line 69 "../src/Printing.vala"
	_tmp12_ = self->priv->print_settings;
#line 69 "../src/Printing.vala"
	g_settings_set_int (_tmp12_, "images-per-page", self->priv->image_per_page_selection + 1);
#line 70 "../src/Printing.vala"
	_tmp13_ = self->priv->print_settings;
#line 70 "../src/Printing.vala"
	g_settings_set_int (_tmp13_, "content-ppi", self->priv->content_ppi);
#line 439 "Printing.c"
}

void
print_settings_get_content_width (PrintSettings* self,
                                  Measurement* result)
{
#line 74 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/Printing.vala"
	switch (print_settings_get_content_layout (self)) {
#line 75 "../src/Printing.vala"
		case CONTENT_LAYOUT_STANDARD_SIZE:
#line 75 "../src/Printing.vala"
		case CONTENT_LAYOUT_IMAGE_PER_PAGE:
#line 454 "Printing.c"
		{
			PrintManager* _tmp0_;
			PrintManager* _tmp1_;
			gint _tmp2_ = 0;
			StandardPrintSize** _tmp3_;
			StandardPrintSize** _tmp4_;
			gint _tmp4__length1;
			StandardPrintSize* _tmp5_;
			Measurement _tmp6_;
			Measurement _tmp7_;
#line 78 "../src/Printing.vala"
			_tmp0_ = print_manager_get_instance ();
#line 78 "../src/Printing.vala"
			_tmp1_ = _tmp0_;
#line 78 "../src/Printing.vala"
			_tmp3_ = print_manager_get_standard_sizes (_tmp1_, &_tmp2_);
#line 78 "../src/Printing.vala"
			_tmp4_ = _tmp3_;
#line 78 "../src/Printing.vala"
			_tmp4__length1 = _tmp2_;
#line 78 "../src/Printing.vala"
			_tmp5_ = _tmp4_[print_settings_get_size_selection (self)];
#line 78 "../src/Printing.vala"
			_tmp6_ = _tmp5_->width;
#line 78 "../src/Printing.vala"
			_tmp7_ = _tmp6_;
#line 78 "../src/Printing.vala"
			_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) standard_print_size_unref), NULL);
#line 78 "../src/Printing.vala"
			_print_manager_unref0 (_tmp1_);
#line 78 "../src/Printing.vala"
			*result = _tmp7_;
#line 78 "../src/Printing.vala"
			return;
#line 489 "Printing.c"
		}
#line 75 "../src/Printing.vala"
		case CONTENT_LAYOUT_CUSTOM_SIZE:
#line 493 "Printing.c"
		{
			Measurement _tmp8_;
#line 82 "../src/Printing.vala"
			_tmp8_ = self->priv->content_width;
#line 82 "../src/Printing.vala"
			*result = _tmp8_;
#line 82 "../src/Printing.vala"
			return;
#line 502 "Printing.c"
		}
		default:
		{
#line 85 "../src/Printing.vala"
			g_error ("Printing.vala:85: unknown ContentLayout enumeration value");
#line 508 "Printing.c"
		}
	}
}

void
print_settings_get_content_height (PrintSettings* self,
                                   Measurement* result)
{
#line 89 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/Printing.vala"
	switch (print_settings_get_content_layout (self)) {
#line 90 "../src/Printing.vala"
		case CONTENT_LAYOUT_STANDARD_SIZE:
#line 90 "../src/Printing.vala"
		case CONTENT_LAYOUT_IMAGE_PER_PAGE:
#line 525 "Printing.c"
		{
			PrintManager* _tmp0_;
			PrintManager* _tmp1_;
			gint _tmp2_ = 0;
			StandardPrintSize** _tmp3_;
			StandardPrintSize** _tmp4_;
			gint _tmp4__length1;
			StandardPrintSize* _tmp5_;
			Measurement _tmp6_;
			Measurement _tmp7_;
#line 93 "../src/Printing.vala"
			_tmp0_ = print_manager_get_instance ();
#line 93 "../src/Printing.vala"
			_tmp1_ = _tmp0_;
#line 93 "../src/Printing.vala"
			_tmp3_ = print_manager_get_standard_sizes (_tmp1_, &_tmp2_);
#line 93 "../src/Printing.vala"
			_tmp4_ = _tmp3_;
#line 93 "../src/Printing.vala"
			_tmp4__length1 = _tmp2_;
#line 93 "../src/Printing.vala"
			_tmp5_ = _tmp4_[print_settings_get_size_selection (self)];
#line 93 "../src/Printing.vala"
			_tmp6_ = _tmp5_->height;
#line 93 "../src/Printing.vala"
			_tmp7_ = _tmp6_;
#line 93 "../src/Printing.vala"
			_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) standard_print_size_unref), NULL);
#line 93 "../src/Printing.vala"
			_print_manager_unref0 (_tmp1_);
#line 93 "../src/Printing.vala"
			*result = _tmp7_;
#line 93 "../src/Printing.vala"
			return;
#line 560 "Printing.c"
		}
#line 90 "../src/Printing.vala"
		case CONTENT_LAYOUT_CUSTOM_SIZE:
#line 564 "Printing.c"
		{
			Measurement _tmp8_;
#line 97 "../src/Printing.vala"
			_tmp8_ = self->priv->content_height;
#line 97 "../src/Printing.vala"
			*result = _tmp8_;
#line 97 "../src/Printing.vala"
			return;
#line 573 "Printing.c"
		}
		default:
		{
#line 100 "../src/Printing.vala"
			g_error ("Printing.vala:100: unknown ContentLayout enumeration value");
#line 579 "Printing.c"
		}
	}
}

void
print_settings_get_minimum_content_dimension (PrintSettings* self,
                                              Measurement* result)
{
	Measurement _tmp0_ = {0};
#line 104 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Printing.vala"
	measurement_init (&_tmp0_, 0.5, MEASUREMENT_UNIT_INCHES);
#line 105 "../src/Printing.vala"
	*result = _tmp0_;
#line 105 "../src/Printing.vala"
	return;
#line 597 "Printing.c"
}

void
print_settings_get_maximum_content_dimension (PrintSettings* self,
                                              Measurement* result)
{
	Measurement _tmp0_ = {0};
#line 108 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/Printing.vala"
	measurement_init (&_tmp0_, (gdouble) 30, MEASUREMENT_UNIT_INCHES);
#line 109 "../src/Printing.vala"
	*result = _tmp0_;
#line 109 "../src/Printing.vala"
	return;
#line 613 "Printing.c"
}

gboolean
print_settings_is_match_aspect_ratio_enabled (PrintSettings* self)
{
	gboolean result;
#line 112 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 113 "../src/Printing.vala"
	result = self->priv->match_aspect_ratio;
#line 113 "../src/Printing.vala"
	return result;
#line 626 "Printing.c"
}

gboolean
print_settings_is_print_titles_enabled (PrintSettings* self)
{
	gboolean result;
#line 116 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 117 "../src/Printing.vala"
	result = self->priv->print_titles;
#line 117 "../src/Printing.vala"
	return result;
#line 639 "Printing.c"
}

gint
print_settings_get_content_ppi (PrintSettings* self)
{
	gint result;
#line 120 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 121 "../src/Printing.vala"
	result = self->priv->content_ppi;
#line 121 "../src/Printing.vala"
	return result;
#line 652 "Printing.c"
}

gint
print_settings_get_image_per_page_selection (PrintSettings* self)
{
	gint result;
#line 124 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 125 "../src/Printing.vala"
	result = self->priv->image_per_page_selection;
#line 125 "../src/Printing.vala"
	return result;
#line 665 "Printing.c"
}

gint
print_settings_get_size_selection (PrintSettings* self)
{
	gint result;
#line 128 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 129 "../src/Printing.vala"
	result = self->priv->size_selection;
#line 129 "../src/Printing.vala"
	return result;
#line 678 "Printing.c"
}

ContentLayout
print_settings_get_content_layout (PrintSettings* self)
{
	ContentLayout result;
#line 132 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 133 "../src/Printing.vala"
	result = self->priv->content_layout;
#line 133 "../src/Printing.vala"
	return result;
#line 691 "Printing.c"
}

void
print_settings_set_content_layout (PrintSettings* self,
                                   ContentLayout content_layout)
{
#line 136 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Printing.vala"
	self->priv->content_layout = content_layout;
#line 702 "Printing.c"
}

void
print_settings_set_content_width (PrintSettings* self,
                                  Measurement* content_width)
{
	Measurement _tmp0_;
#line 140 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/Printing.vala"
	g_return_if_fail (content_width != NULL);
#line 141 "../src/Printing.vala"
	_tmp0_ = *content_width;
#line 141 "../src/Printing.vala"
	self->priv->content_width = _tmp0_;
#line 718 "Printing.c"
}

void
print_settings_set_content_height (PrintSettings* self,
                                   Measurement* content_height)
{
	Measurement _tmp0_;
#line 144 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/Printing.vala"
	g_return_if_fail (content_height != NULL);
#line 145 "../src/Printing.vala"
	_tmp0_ = *content_height;
#line 145 "../src/Printing.vala"
	self->priv->content_height = _tmp0_;
#line 734 "Printing.c"
}

void
print_settings_set_content_ppi (PrintSettings* self,
                                gint content_ppi)
{
#line 148 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/Printing.vala"
	self->priv->content_ppi = content_ppi;
#line 745 "Printing.c"
}

void
print_settings_set_image_per_page_selection (PrintSettings* self,
                                             gint image_per_page_selection)
{
#line 152 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/Printing.vala"
	self->priv->image_per_page_selection = image_per_page_selection;
#line 756 "Printing.c"
}

void
print_settings_set_size_selection (PrintSettings* self,
                                   gint size_selection)
{
#line 156 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Printing.vala"
	self->priv->size_selection = size_selection;
#line 767 "Printing.c"
}

void
print_settings_set_match_aspect_ratio_enabled (PrintSettings* self,
                                               gboolean enable_state)
{
#line 160 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/Printing.vala"
	self->priv->match_aspect_ratio = enable_state;
#line 778 "Printing.c"
}

void
print_settings_set_print_titles_enabled (PrintSettings* self,
                                         gboolean print_titles)
{
#line 164 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/Printing.vala"
	self->priv->print_titles = print_titles;
#line 789 "Printing.c"
}

void
print_settings_set_print_titles_font (PrintSettings* self,
                                      const gchar* fontname)
{
	gchar* _tmp0_;
#line 168 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Printing.vala"
	g_return_if_fail (fontname != NULL);
#line 169 "../src/Printing.vala"
	_tmp0_ = g_strdup (fontname);
#line 169 "../src/Printing.vala"
	_g_free0 (self->priv->print_titles_font);
#line 169 "../src/Printing.vala"
	self->priv->print_titles_font = _tmp0_;
#line 807 "Printing.c"
}

gchar*
print_settings_get_print_titles_font (PrintSettings* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 172 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 173 "../src/Printing.vala"
	_tmp0_ = self->priv->print_titles_font;
#line 173 "../src/Printing.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 173 "../src/Printing.vala"
	result = _tmp1_;
#line 173 "../src/Printing.vala"
	return result;
#line 826 "Printing.c"
}

static void
value_print_settings_init (GValue* value)
{
#line 27 "../src/Printing.vala"
	value->data[0].v_pointer = NULL;
#line 834 "Printing.c"
}

static void
value_print_settings_free_value (GValue* value)
{
#line 27 "../src/Printing.vala"
	if (value->data[0].v_pointer) {
#line 27 "../src/Printing.vala"
		print_settings_unref (value->data[0].v_pointer);
#line 844 "Printing.c"
	}
}

static void
value_print_settings_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 27 "../src/Printing.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "../src/Printing.vala"
		dest_value->data[0].v_pointer = print_settings_ref (src_value->data[0].v_pointer);
#line 856 "Printing.c"
	} else {
#line 27 "../src/Printing.vala"
		dest_value->data[0].v_pointer = NULL;
#line 860 "Printing.c"
	}
}

static gpointer
value_print_settings_peek_pointer (const GValue* value)
{
#line 27 "../src/Printing.vala"
	return value->data[0].v_pointer;
#line 869 "Printing.c"
}

static gchar*
value_print_settings_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 27 "../src/Printing.vala"
	if (collect_values[0].v_pointer) {
#line 880 "Printing.c"
		PrintSettings * object;
		object = collect_values[0].v_pointer;
#line 27 "../src/Printing.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "../src/Printing.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 887 "Printing.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "../src/Printing.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 891 "Printing.c"
		}
#line 27 "../src/Printing.vala"
		value->data[0].v_pointer = print_settings_ref (object);
#line 895 "Printing.c"
	} else {
#line 27 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 899 "Printing.c"
	}
#line 27 "../src/Printing.vala"
	return NULL;
#line 903 "Printing.c"
}

static gchar*
value_print_settings_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	PrintSettings ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "../src/Printing.vala"
	if (!object_p) {
#line 27 "../src/Printing.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 918 "Printing.c"
	}
#line 27 "../src/Printing.vala"
	if (!value->data[0].v_pointer) {
#line 27 "../src/Printing.vala"
		*object_p = NULL;
#line 924 "Printing.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "../src/Printing.vala"
		*object_p = value->data[0].v_pointer;
#line 928 "Printing.c"
	} else {
#line 27 "../src/Printing.vala"
		*object_p = print_settings_ref (value->data[0].v_pointer);
#line 932 "Printing.c"
	}
#line 27 "../src/Printing.vala"
	return NULL;
#line 936 "Printing.c"
}

GParamSpec*
param_spec_print_settings (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecPrintSettings* spec;
#line 27 "../src/Printing.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PRINT_SETTINGS), NULL);
#line 27 "../src/Printing.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "../src/Printing.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "../src/Printing.vala"
	return G_PARAM_SPEC (spec);
#line 955 "Printing.c"
}

gpointer
value_get_print_settings (const GValue* value)
{
#line 27 "../src/Printing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PRINT_SETTINGS), NULL);
#line 27 "../src/Printing.vala"
	return value->data[0].v_pointer;
#line 965 "Printing.c"
}

void
value_set_print_settings (GValue* value,
                          gpointer v_object)
{
	PrintSettings * old;
#line 27 "../src/Printing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PRINT_SETTINGS));
#line 27 "../src/Printing.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/Printing.vala"
	if (v_object) {
#line 27 "../src/Printing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PRINT_SETTINGS));
#line 27 "../src/Printing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/Printing.vala"
		value->data[0].v_pointer = v_object;
#line 27 "../src/Printing.vala"
		print_settings_ref (value->data[0].v_pointer);
#line 987 "Printing.c"
	} else {
#line 27 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 991 "Printing.c"
	}
#line 27 "../src/Printing.vala"
	if (old) {
#line 27 "../src/Printing.vala"
		print_settings_unref (old);
#line 997 "Printing.c"
	}
}

void
value_take_print_settings (GValue* value,
                           gpointer v_object)
{
	PrintSettings * old;
#line 27 "../src/Printing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PRINT_SETTINGS));
#line 27 "../src/Printing.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/Printing.vala"
	if (v_object) {
#line 27 "../src/Printing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PRINT_SETTINGS));
#line 27 "../src/Printing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/Printing.vala"
		value->data[0].v_pointer = v_object;
#line 1018 "Printing.c"
	} else {
#line 27 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 1022 "Printing.c"
	}
#line 27 "../src/Printing.vala"
	if (old) {
#line 27 "../src/Printing.vala"
		print_settings_unref (old);
#line 1028 "Printing.c"
	}
}

static void
print_settings_class_init (PrintSettingsClass * klass,
                           gpointer klass_data)
{
#line 27 "../src/Printing.vala"
	print_settings_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Printing.vala"
	((PrintSettingsClass *) klass)->finalize = print_settings_finalize;
#line 27 "../src/Printing.vala"
	g_type_class_adjust_private_offset (klass, &PrintSettings_private_offset);
#line 1042 "Printing.c"
}

static void
print_settings_instance_init (PrintSettings * self,
                              gpointer klass)
{
#line 27 "../src/Printing.vala"
	self->priv = print_settings_get_instance_private (self);
#line 27 "../src/Printing.vala"
	self->ref_count = 1;
#line 1053 "Printing.c"
}

static void
print_settings_finalize (PrintSettings * obj)
{
	PrintSettings * self;
#line 27 "../src/Printing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PRINT_SETTINGS, PrintSettings);
#line 27 "../src/Printing.vala"
	g_signal_handlers_destroy (self);
#line 42 "../src/Printing.vala"
	_g_free0 (self->priv->print_titles_font);
#line 43 "../src/Printing.vala"
	_g_object_unref0 (self->priv->print_settings);
#line 1068 "Printing.c"
}

static GType
print_settings_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_print_settings_init, value_print_settings_free_value, value_print_settings_copy_value, value_print_settings_peek_pointer, "p", value_print_settings_collect_value, "p", value_print_settings_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PrintSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) print_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintSettings), 0, (GInstanceInitFunc) print_settings_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType print_settings_type_id;
	print_settings_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PrintSettings", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PrintSettings_private_offset = g_type_add_instance_private (print_settings_type_id, sizeof (PrintSettingsPrivate));
	return print_settings_type_id;
}

GType
print_settings_get_type (void)
{
	static volatile gsize print_settings_type_id__once = 0;
	if (g_once_init_enter (&print_settings_type_id__once)) {
		GType print_settings_type_id;
		print_settings_type_id = print_settings_get_type_once ();
		g_once_init_leave (&print_settings_type_id__once, print_settings_type_id);
	}
	return print_settings_type_id__once;
}

gpointer
print_settings_ref (gpointer instance)
{
	PrintSettings * self;
	self = instance;
#line 27 "../src/Printing.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "../src/Printing.vala"
	return instance;
#line 1104 "Printing.c"
}

void
print_settings_unref (gpointer instance)
{
	PrintSettings * self;
	self = instance;
#line 27 "../src/Printing.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "../src/Printing.vala"
		PRINT_SETTINGS_GET_CLASS (self)->finalize (self);
#line 27 "../src/Printing.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1118 "Printing.c"
	}
}

static GType
measurement_unit_get_type_once (void)
{
	static const GEnumValue values[] = {{MEASUREMENT_UNIT_INCHES, "MEASUREMENT_UNIT_INCHES", "inches"}, {MEASUREMENT_UNIT_CENTIMETERS, "MEASUREMENT_UNIT_CENTIMETERS", "centimeters"}, {0, NULL, NULL}};
	GType measurement_unit_type_id;
	measurement_unit_type_id = g_enum_register_static ("MeasurementUnit", values);
	return measurement_unit_type_id;
}

GType
measurement_unit_get_type (void)
{
	static volatile gsize measurement_unit_type_id__once = 0;
	if (g_once_init_enter (&measurement_unit_type_id__once)) {
		GType measurement_unit_type_id;
		measurement_unit_type_id = measurement_unit_get_type_once ();
		g_once_init_leave (&measurement_unit_type_id__once, measurement_unit_type_id);
	}
	return measurement_unit_type_id__once;
}

void
measurement_init (Measurement *self,
                  gdouble value,
                  MeasurementUnit unit)
{
#line 197 "../src/Printing.vala"
	memset (self, 0, sizeof (Measurement));
#line 198 "../src/Printing.vala"
	(*self).value = value;
#line 199 "../src/Printing.vala"
	(*self).unit = unit;
#line 1154 "Printing.c"
}

void
measurement_convert_to (Measurement *self,
                        MeasurementUnit to_unit,
                        Measurement* result)
{
#line 203 "../src/Printing.vala"
	if ((*self).unit == to_unit) {
#line 204 "../src/Printing.vala"
		*result = (*self);
#line 204 "../src/Printing.vala"
		return;
#line 1168 "Printing.c"
	}
#line 206 "../src/Printing.vala"
	if (to_unit == MEASUREMENT_UNIT_INCHES) {
#line 1172 "Printing.c"
		Measurement _tmp0_ = {0};
#line 207 "../src/Printing.vala"
		measurement_init (&_tmp0_, (*self).value * MEASUREMENT_INCHES_PER_CENTIMETER, MEASUREMENT_UNIT_INCHES);
#line 207 "../src/Printing.vala"
		*result = _tmp0_;
#line 207 "../src/Printing.vala"
		return;
#line 1180 "Printing.c"
	} else {
#line 208 "../src/Printing.vala"
		if (to_unit == MEASUREMENT_UNIT_CENTIMETERS) {
#line 1184 "Printing.c"
			Measurement _tmp1_ = {0};
#line 209 "../src/Printing.vala"
			measurement_init (&_tmp1_, (*self).value * MEASUREMENT_CENTIMETERS_PER_INCH, MEASUREMENT_UNIT_CENTIMETERS);
#line 209 "../src/Printing.vala"
			*result = _tmp1_;
#line 209 "../src/Printing.vala"
			return;
#line 1192 "Printing.c"
		} else {
#line 211 "../src/Printing.vala"
			g_error ("Printing.vala:211: unrecognized unit");
#line 1196 "Printing.c"
		}
	}
}

gboolean
measurement_is_less_than (Measurement *self,
                          Measurement* rhs)
{
	Measurement _tmp0_ = {0};
	Measurement _tmp1_;
	Measurement converted_rhs = {0};
	Measurement _tmp4_;
	gboolean result;
#line 215 "../src/Printing.vala"
	g_return_val_if_fail (rhs != NULL, FALSE);
#line 216 "../src/Printing.vala"
	_tmp1_ = *rhs;
#line 216 "../src/Printing.vala"
	if ((*self).unit == _tmp1_.unit) {
#line 1216 "Printing.c"
		Measurement _tmp2_;
#line 216 "../src/Printing.vala"
		_tmp2_ = *rhs;
#line 216 "../src/Printing.vala"
		_tmp0_ = _tmp2_;
#line 1222 "Printing.c"
	} else {
		Measurement _tmp3_ = {0};
#line 216 "../src/Printing.vala"
		measurement_convert_to (rhs, (*self).unit, &_tmp3_);
#line 216 "../src/Printing.vala"
		_tmp0_ = _tmp3_;
#line 1229 "Printing.c"
	}
#line 216 "../src/Printing.vala"
	converted_rhs = _tmp0_;
#line 217 "../src/Printing.vala"
	_tmp4_ = converted_rhs;
#line 217 "../src/Printing.vala"
	result = (*self).value < _tmp4_.value;
#line 217 "../src/Printing.vala"
	return result;
#line 1239 "Printing.c"
}

gboolean
measurement_is_greater_than (Measurement *self,
                             Measurement* rhs)
{
	Measurement _tmp0_ = {0};
	Measurement _tmp1_;
	Measurement converted_rhs = {0};
	Measurement _tmp4_;
	gboolean result;
#line 220 "../src/Printing.vala"
	g_return_val_if_fail (rhs != NULL, FALSE);
#line 221 "../src/Printing.vala"
	_tmp1_ = *rhs;
#line 221 "../src/Printing.vala"
	if ((*self).unit == _tmp1_.unit) {
#line 1257 "Printing.c"
		Measurement _tmp2_;
#line 221 "../src/Printing.vala"
		_tmp2_ = *rhs;
#line 221 "../src/Printing.vala"
		_tmp0_ = _tmp2_;
#line 1263 "Printing.c"
	} else {
		Measurement _tmp3_ = {0};
#line 221 "../src/Printing.vala"
		measurement_convert_to (rhs, (*self).unit, &_tmp3_);
#line 221 "../src/Printing.vala"
		_tmp0_ = _tmp3_;
#line 1270 "Printing.c"
	}
#line 221 "../src/Printing.vala"
	converted_rhs = _tmp0_;
#line 222 "../src/Printing.vala"
	_tmp4_ = converted_rhs;
#line 222 "../src/Printing.vala"
	result = (*self).value > _tmp4_.value;
#line 222 "../src/Printing.vala"
	return result;
#line 1280 "Printing.c"
}

Measurement*
measurement_dup (const Measurement* self)
{
	Measurement* dup;
#line 190 "../src/Printing.vala"
	dup = g_new0 (Measurement, 1);
#line 190 "../src/Printing.vala"
	memcpy (dup, self, sizeof (Measurement));
#line 190 "../src/Printing.vala"
	return dup;
#line 1293 "Printing.c"
}

void
measurement_free (Measurement* self)
{
#line 190 "../src/Printing.vala"
	g_free (self);
#line 1301 "Printing.c"
}

static GType
measurement_get_type_once (void)
{
	GType measurement_type_id;
	measurement_type_id = g_boxed_type_register_static ("Measurement", (GBoxedCopyFunc) measurement_dup, (GBoxedFreeFunc) measurement_free);
	return measurement_type_id;
}

GType
measurement_get_type (void)
{
	static volatile gsize measurement_type_id__once = 0;
	if (g_once_init_enter (&measurement_type_id__once)) {
		GType measurement_type_id;
		measurement_type_id = measurement_get_type_once ();
		g_once_init_leave (&measurement_type_id__once, measurement_type_id);
	}
	return measurement_type_id__once;
}

PrintLayout*
print_layout_get_all (gint* result_length1)
{
	PrintLayout* _tmp0_;
	PrintLayout* _tmp1_;
	gint _tmp1__length1;
	PrintLayout* result;
#line 236 "../src/Printing.vala"
	_tmp0_ = g_new0 (PrintLayout, 7);
#line 236 "../src/Printing.vala"
	_tmp0_[0] = PRINT_LAYOUT_ENTIRE_PAGE;
#line 236 "../src/Printing.vala"
	_tmp0_[1] = PRINT_LAYOUT_TWO_PER_PAGE;
#line 236 "../src/Printing.vala"
	_tmp0_[2] = PRINT_LAYOUT_FOUR_PER_PAGE;
#line 236 "../src/Printing.vala"
	_tmp0_[3] = PRINT_LAYOUT_SIX_PER_PAGE;
#line 236 "../src/Printing.vala"
	_tmp0_[4] = PRINT_LAYOUT_EIGHT_PER_PAGE;
#line 236 "../src/Printing.vala"
	_tmp0_[5] = PRINT_LAYOUT_SIXTEEN_PER_PAGE;
#line 236 "../src/Printing.vala"
	_tmp0_[6] = PRINT_LAYOUT_THIRTY_TWO_PER_PAGE;
#line 236 "../src/Printing.vala"
	_tmp1_ = _tmp0_;
#line 236 "../src/Printing.vala"
	_tmp1__length1 = 7;
#line 236 "../src/Printing.vala"
	if (result_length1) {
#line 236 "../src/Printing.vala"
		*result_length1 = _tmp1__length1;
#line 1355 "Printing.c"
	}
#line 236 "../src/Printing.vala"
	result = _tmp1_;
#line 236 "../src/Printing.vala"
	return result;
#line 1361 "Printing.c"
}

gint
print_layout_get_per_page (PrintLayout self)
{
	gint* per_page = NULL;
	gint* _tmp0_;
	gint per_page_length1;
	gint _per_page_size_;
	gint _tmp1_;
	gint result;
#line 248 "../src/Printing.vala"
	_tmp0_ = g_new0 (gint, 7);
#line 248 "../src/Printing.vala"
	_tmp0_[0] = 1;
#line 248 "../src/Printing.vala"
	_tmp0_[1] = 2;
#line 248 "../src/Printing.vala"
	_tmp0_[2] = 4;
#line 248 "../src/Printing.vala"
	_tmp0_[3] = 6;
#line 248 "../src/Printing.vala"
	_tmp0_[4] = 8;
#line 248 "../src/Printing.vala"
	_tmp0_[5] = 16;
#line 248 "../src/Printing.vala"
	_tmp0_[6] = 32;
#line 248 "../src/Printing.vala"
	per_page = _tmp0_;
#line 248 "../src/Printing.vala"
	per_page_length1 = 7;
#line 248 "../src/Printing.vala"
	_per_page_size_ = per_page_length1;
#line 250 "../src/Printing.vala"
	_tmp1_ = per_page[self];
#line 250 "../src/Printing.vala"
	result = _tmp1_;
#line 250 "../src/Printing.vala"
	per_page = (g_free (per_page), NULL);
#line 250 "../src/Printing.vala"
	return result;
#line 1403 "Printing.c"
}

gint
print_layout_get_x (PrintLayout self)
{
	gint* x = NULL;
	gint* _tmp0_;
	gint x_length1;
	gint _x_size_;
	gint _tmp1_;
	gint result;
#line 254 "../src/Printing.vala"
	_tmp0_ = g_new0 (gint, 7);
#line 254 "../src/Printing.vala"
	_tmp0_[0] = 1;
#line 254 "../src/Printing.vala"
	_tmp0_[1] = 1;
#line 254 "../src/Printing.vala"
	_tmp0_[2] = 2;
#line 254 "../src/Printing.vala"
	_tmp0_[3] = 2;
#line 254 "../src/Printing.vala"
	_tmp0_[4] = 2;
#line 254 "../src/Printing.vala"
	_tmp0_[5] = 4;
#line 254 "../src/Printing.vala"
	_tmp0_[6] = 4;
#line 254 "../src/Printing.vala"
	x = _tmp0_;
#line 254 "../src/Printing.vala"
	x_length1 = 7;
#line 254 "../src/Printing.vala"
	_x_size_ = x_length1;
#line 256 "../src/Printing.vala"
	_tmp1_ = x[self];
#line 256 "../src/Printing.vala"
	result = _tmp1_;
#line 256 "../src/Printing.vala"
	x = (g_free (x), NULL);
#line 256 "../src/Printing.vala"
	return result;
#line 1445 "Printing.c"
}

gint
print_layout_get_y (PrintLayout self)
{
	gint* y = NULL;
	gint* _tmp0_;
	gint y_length1;
	gint _y_size_;
	gint _tmp1_;
	gint result;
#line 260 "../src/Printing.vala"
	_tmp0_ = g_new0 (gint, 7);
#line 260 "../src/Printing.vala"
	_tmp0_[0] = 1;
#line 260 "../src/Printing.vala"
	_tmp0_[1] = 2;
#line 260 "../src/Printing.vala"
	_tmp0_[2] = 2;
#line 260 "../src/Printing.vala"
	_tmp0_[3] = 3;
#line 260 "../src/Printing.vala"
	_tmp0_[4] = 4;
#line 260 "../src/Printing.vala"
	_tmp0_[5] = 4;
#line 260 "../src/Printing.vala"
	_tmp0_[6] = 8;
#line 260 "../src/Printing.vala"
	y = _tmp0_;
#line 260 "../src/Printing.vala"
	y_length1 = 7;
#line 260 "../src/Printing.vala"
	_y_size_ = y_length1;
#line 262 "../src/Printing.vala"
	_tmp1_ = y[self];
#line 262 "../src/Printing.vala"
	result = _tmp1_;
#line 262 "../src/Printing.vala"
	y = (g_free (y), NULL);
#line 262 "../src/Printing.vala"
	return result;
#line 1487 "Printing.c"
}

gchar*
print_layout_to_string (PrintLayout self)
{
	gchar** labels = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint labels_length1;
	gint _labels_size_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 266 "../src/Printing.vala"
	_tmp0_ = g_strdup (_ ("Fill the entire page"));
#line 266 "../src/Printing.vala"
	_tmp1_ = g_strdup (_ ("2 images per page"));
#line 266 "../src/Printing.vala"
	_tmp2_ = g_strdup (_ ("4 images per page"));
#line 266 "../src/Printing.vala"
	_tmp3_ = g_strdup (_ ("6 images per page"));
#line 266 "../src/Printing.vala"
	_tmp4_ = g_strdup (_ ("8 images per page"));
#line 266 "../src/Printing.vala"
	_tmp5_ = g_strdup (_ ("16 images per page"));
#line 266 "../src/Printing.vala"
	_tmp6_ = g_strdup (_ ("32 images per page"));
#line 266 "../src/Printing.vala"
	_tmp7_ = g_new0 (gchar*, 7 + 1);
#line 266 "../src/Printing.vala"
	_tmp7_[0] = _tmp0_;
#line 266 "../src/Printing.vala"
	_tmp7_[1] = _tmp1_;
#line 266 "../src/Printing.vala"
	_tmp7_[2] = _tmp2_;
#line 266 "../src/Printing.vala"
	_tmp7_[3] = _tmp3_;
#line 266 "../src/Printing.vala"
	_tmp7_[4] = _tmp4_;
#line 266 "../src/Printing.vala"
	_tmp7_[5] = _tmp5_;
#line 266 "../src/Printing.vala"
	_tmp7_[6] = _tmp6_;
#line 266 "../src/Printing.vala"
	labels = _tmp7_;
#line 266 "../src/Printing.vala"
	labels_length1 = 7;
#line 266 "../src/Printing.vala"
	_labels_size_ = labels_length1;
#line 276 "../src/Printing.vala"
	_tmp8_ = labels[self];
#line 276 "../src/Printing.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 276 "../src/Printing.vala"
	result = _tmp9_;
#line 276 "../src/Printing.vala"
	labels = (_vala_array_free (labels, labels_length1, (GDestroyNotify) g_free), NULL);
#line 276 "../src/Printing.vala"
	return result;
#line 1553 "Printing.c"
}

static GType
print_layout_get_type_once (void)
{
	static const GEnumValue values[] = {{PRINT_LAYOUT_ENTIRE_PAGE, "PRINT_LAYOUT_ENTIRE_PAGE", "entire-page"}, {PRINT_LAYOUT_TWO_PER_PAGE, "PRINT_LAYOUT_TWO_PER_PAGE", "two-per-page"}, {PRINT_LAYOUT_FOUR_PER_PAGE, "PRINT_LAYOUT_FOUR_PER_PAGE", "four-per-page"}, {PRINT_LAYOUT_SIX_PER_PAGE, "PRINT_LAYOUT_SIX_PER_PAGE", "six-per-page"}, {PRINT_LAYOUT_EIGHT_PER_PAGE, "PRINT_LAYOUT_EIGHT_PER_PAGE", "eight-per-page"}, {PRINT_LAYOUT_SIXTEEN_PER_PAGE, "PRINT_LAYOUT_SIXTEEN_PER_PAGE", "sixteen-per-page"}, {PRINT_LAYOUT_THIRTY_TWO_PER_PAGE, "PRINT_LAYOUT_THIRTY_TWO_PER_PAGE", "thirty-two-per-page"}, {0, NULL, NULL}};
	GType print_layout_type_id;
	print_layout_type_id = g_enum_register_static ("PrintLayout", values);
	return print_layout_type_id;
}

GType
print_layout_get_type (void)
{
	static volatile gsize print_layout_type_id__once = 0;
	if (g_once_init_enter (&print_layout_type_id__once)) {
		GType print_layout_type_id;
		print_layout_type_id = print_layout_get_type_once ();
		g_once_init_leave (&print_layout_type_id__once, print_layout_type_id);
	}
	return print_layout_type_id__once;
}

static inline gpointer
print_job_get_instance_private (PrintJob* self)
{
	return G_STRUCT_MEMBER_P (self, PrintJob_private_offset);
}

PrintJob*
print_job_construct (GType object_type,
                     GeeCollection* to_print)
{
	PrintJob * self = NULL;
	PrintManager* _tmp0_;
	PrintManager* _tmp1_;
	PrintSettings* _tmp2_;
	GeeArrayList* _tmp3_;
	gdouble photo_aspect_ratio = 0.0;
	GeeArrayList* _tmp4_;
	gpointer _tmp5_;
	Photo* _tmp6_;
	Dimensions _tmp7_ = {0};
	gdouble _tmp8_;
#line 284 "../src/Printing.vala"
	g_return_val_if_fail (to_print != NULL, NULL);
#line 284 "../src/Printing.vala"
	self = (PrintJob*) g_object_new (object_type, NULL);
#line 285 "../src/Printing.vala"
	_tmp0_ = print_manager_get_instance ();
#line 285 "../src/Printing.vala"
	_tmp1_ = _tmp0_;
#line 285 "../src/Printing.vala"
	_tmp2_ = print_manager_get_global_settings (_tmp1_);
#line 285 "../src/Printing.vala"
	_print_settings_unref0 (self->priv->settings);
#line 285 "../src/Printing.vala"
	self->priv->settings = _tmp2_;
#line 285 "../src/Printing.vala"
	_print_manager_unref0 (_tmp1_);
#line 286 "../src/Printing.vala"
	_tmp3_ = self->priv->photos;
#line 286 "../src/Printing.vala"
	gee_array_list_add_all (_tmp3_, to_print);
#line 288 "../src/Printing.vala"
	gtk_print_operation_set_embed_page_setup ((GtkPrintOperation*) self, TRUE);
#line 289 "../src/Printing.vala"
	_tmp4_ = self->priv->photos;
#line 289 "../src/Printing.vala"
	_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, 0);
#line 289 "../src/Printing.vala"
	_tmp6_ = (Photo*) _tmp5_;
#line 289 "../src/Printing.vala"
	media_source_get_dimensions ((MediaSource*) _tmp6_, PHOTO_EXCEPTION_NONE, &_tmp7_);
#line 289 "../src/Printing.vala"
	_tmp8_ = dimensions_get_aspect_ratio (&_tmp7_);
#line 289 "../src/Printing.vala"
	_g_object_unref0 (_tmp6_);
#line 289 "../src/Printing.vala"
	photo_aspect_ratio = _tmp8_;
#line 290 "../src/Printing.vala"
	if (photo_aspect_ratio < 1.0) {
#line 291 "../src/Printing.vala"
		photo_aspect_ratio = 1.0 / photo_aspect_ratio;
#line 1638 "Printing.c"
	}
#line 284 "../src/Printing.vala"
	return self;
#line 1642 "Printing.c"
}

PrintJob*
print_job_new (GeeCollection* to_print)
{
#line 284 "../src/Printing.vala"
	return print_job_construct (TYPE_PRINT_JOB, to_print);
#line 1650 "Printing.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 295 "../src/Printing.vala"
	return self ? g_object_ref (self) : NULL;
#line 1658 "Printing.c"
}

GeeList*
print_job_get_photos (PrintJob* self)
{
	GeeArrayList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 294 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 295 "../src/Printing.vala"
	_tmp0_ = self->priv->photos;
#line 295 "../src/Printing.vala"
	_tmp1_ = _g_object_ref0 ((GeeList*) _tmp0_);
#line 295 "../src/Printing.vala"
	result = _tmp1_;
#line 295 "../src/Printing.vala"
	return result;
#line 1677 "Printing.c"
}

Photo*
print_job_get_source_photo (PrintJob* self)
{
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	Photo* result;
#line 298 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 299 "../src/Printing.vala"
	_tmp0_ = self->priv->photos;
#line 299 "../src/Printing.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
#line 299 "../src/Printing.vala"
	result = (Photo*) _tmp1_;
#line 299 "../src/Printing.vala"
	return result;
#line 1696 "Printing.c"
}

gdouble
print_job_get_source_aspect_ratio (PrintJob* self)
{
	gdouble aspect_ratio = 0.0;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	Photo* _tmp2_;
	Dimensions _tmp3_ = {0};
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble result;
#line 302 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 303 "../src/Printing.vala"
	_tmp0_ = self->priv->photos;
#line 303 "../src/Printing.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
#line 303 "../src/Printing.vala"
	_tmp2_ = (Photo*) _tmp1_;
#line 303 "../src/Printing.vala"
	media_source_get_dimensions ((MediaSource*) _tmp2_, PHOTO_EXCEPTION_NONE, &_tmp3_);
#line 303 "../src/Printing.vala"
	_tmp4_ = dimensions_get_aspect_ratio (&_tmp3_);
#line 303 "../src/Printing.vala"
	_g_object_unref0 (_tmp2_);
#line 303 "../src/Printing.vala"
	aspect_ratio = _tmp4_;
#line 304 "../src/Printing.vala"
	if (aspect_ratio < 1.0) {
#line 304 "../src/Printing.vala"
		_tmp5_ = 1.0 / aspect_ratio;
#line 1730 "Printing.c"
	} else {
#line 304 "../src/Printing.vala"
		_tmp5_ = aspect_ratio;
#line 1734 "Printing.c"
	}
#line 304 "../src/Printing.vala"
	result = _tmp5_;
#line 304 "../src/Printing.vala"
	return result;
#line 1740 "Printing.c"
}

static gpointer
_print_settings_ref0 (gpointer self)
{
#line 308 "../src/Printing.vala"
	return self ? print_settings_ref (self) : NULL;
#line 1748 "Printing.c"
}

PrintSettings*
print_job_get_local_settings (PrintJob* self)
{
	PrintSettings* _tmp0_;
	PrintSettings* _tmp1_;
	PrintSettings* result;
#line 307 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "../src/Printing.vala"
	_tmp0_ = self->priv->settings;
#line 308 "../src/Printing.vala"
	_tmp1_ = _print_settings_ref0 (_tmp0_);
#line 308 "../src/Printing.vala"
	result = _tmp1_;
#line 308 "../src/Printing.vala"
	return result;
#line 1767 "Printing.c"
}

void
print_job_set_local_settings (PrintJob* self,
                              PrintSettings* settings)
{
	PrintSettings* _tmp0_;
#line 311 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/Printing.vala"
	g_return_if_fail (settings != NULL);
#line 312 "../src/Printing.vala"
	_tmp0_ = _print_settings_ref0 (settings);
#line 312 "../src/Printing.vala"
	_print_settings_unref0 (self->priv->settings);
#line 312 "../src/Printing.vala"
	self->priv->settings = _tmp0_;
#line 1785 "Printing.c"
}

static void
print_job_class_init (PrintJobClass * klass,
                      gpointer klass_data)
{
#line 280 "../src/Printing.vala"
	print_job_parent_class = g_type_class_peek_parent (klass);
#line 280 "../src/Printing.vala"
	g_type_class_adjust_private_offset (klass, &PrintJob_private_offset);
#line 280 "../src/Printing.vala"
	G_OBJECT_CLASS (klass)->finalize = print_job_finalize;
#line 1798 "Printing.c"
}

static void
print_job_instance_init (PrintJob * self,
                         gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 280 "../src/Printing.vala"
	self->priv = print_job_get_instance_private (self);
#line 282 "../src/Printing.vala"
	_tmp0_ = gee_array_list_new (TYPE_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 282 "../src/Printing.vala"
	self->priv->photos = _tmp0_;
#line 1812 "Printing.c"
}

static void
print_job_finalize (GObject * obj)
{
	PrintJob * self;
#line 280 "../src/Printing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PRINT_JOB, PrintJob);
#line 281 "../src/Printing.vala"
	_print_settings_unref0 (self->priv->settings);
#line 282 "../src/Printing.vala"
	_g_object_unref0 (self->priv->photos);
#line 280 "../src/Printing.vala"
	G_OBJECT_CLASS (print_job_parent_class)->finalize (obj);
#line 1827 "Printing.c"
}

static GType
print_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) print_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintJob), 0, (GInstanceInitFunc) print_job_instance_init, NULL };
	GType print_job_type_id;
	print_job_type_id = g_type_register_static (gtk_print_operation_get_type (), "PrintJob", &g_define_type_info, 0);
	PrintJob_private_offset = g_type_add_instance_private (print_job_type_id, sizeof (PrintJobPrivate));
	return print_job_type_id;
}

GType
print_job_get_type (void)
{
	static volatile gsize print_job_type_id__once = 0;
	if (g_once_init_enter (&print_job_type_id__once)) {
		GType print_job_type_id;
		print_job_type_id = print_job_get_type_once ();
		g_once_init_leave (&print_job_type_id__once, print_job_type_id);
	}
	return print_job_type_id__once;
}

StandardPrintSize*
standard_print_size_construct (GType object_type,
                               const gchar* name,
                               Measurement* width,
                               Measurement* height)
{
	StandardPrintSize* self = NULL;
	gchar* _tmp0_;
	Measurement _tmp1_;
	Measurement _tmp2_;
#line 317 "../src/Printing.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 317 "../src/Printing.vala"
	g_return_val_if_fail (width != NULL, NULL);
#line 317 "../src/Printing.vala"
	g_return_val_if_fail (height != NULL, NULL);
#line 317 "../src/Printing.vala"
	self = (StandardPrintSize*) g_type_create_instance (object_type);
#line 318 "../src/Printing.vala"
	_tmp0_ = g_strdup (name);
#line 318 "../src/Printing.vala"
	_g_free0 (self->name);
#line 318 "../src/Printing.vala"
	self->name = _tmp0_;
#line 319 "../src/Printing.vala"
	_tmp1_ = *width;
#line 319 "../src/Printing.vala"
	self->width = _tmp1_;
#line 320 "../src/Printing.vala"
	_tmp2_ = *height;
#line 320 "../src/Printing.vala"
	self->height = _tmp2_;
#line 317 "../src/Printing.vala"
	return self;
#line 1886 "Printing.c"
}

StandardPrintSize*
standard_print_size_new (const gchar* name,
                         Measurement* width,
                         Measurement* height)
{
#line 317 "../src/Printing.vala"
	return standard_print_size_construct (TYPE_STANDARD_PRINT_SIZE, name, width, height);
#line 1896 "Printing.c"
}

static void
value_standard_print_size_init (GValue* value)
{
#line 316 "../src/Printing.vala"
	value->data[0].v_pointer = NULL;
#line 1904 "Printing.c"
}

static void
value_standard_print_size_free_value (GValue* value)
{
#line 316 "../src/Printing.vala"
	if (value->data[0].v_pointer) {
#line 316 "../src/Printing.vala"
		standard_print_size_unref (value->data[0].v_pointer);
#line 1914 "Printing.c"
	}
}

static void
value_standard_print_size_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 316 "../src/Printing.vala"
	if (src_value->data[0].v_pointer) {
#line 316 "../src/Printing.vala"
		dest_value->data[0].v_pointer = standard_print_size_ref (src_value->data[0].v_pointer);
#line 1926 "Printing.c"
	} else {
#line 316 "../src/Printing.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1930 "Printing.c"
	}
}

static gpointer
value_standard_print_size_peek_pointer (const GValue* value)
{
#line 316 "../src/Printing.vala"
	return value->data[0].v_pointer;
#line 1939 "Printing.c"
}

static gchar*
value_standard_print_size_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 316 "../src/Printing.vala"
	if (collect_values[0].v_pointer) {
#line 1950 "Printing.c"
		StandardPrintSize * object;
		object = collect_values[0].v_pointer;
#line 316 "../src/Printing.vala"
		if (object->parent_instance.g_class == NULL) {
#line 316 "../src/Printing.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1957 "Printing.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 316 "../src/Printing.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1961 "Printing.c"
		}
#line 316 "../src/Printing.vala"
		value->data[0].v_pointer = standard_print_size_ref (object);
#line 1965 "Printing.c"
	} else {
#line 316 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 1969 "Printing.c"
	}
#line 316 "../src/Printing.vala"
	return NULL;
#line 1973 "Printing.c"
}

static gchar*
value_standard_print_size_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	StandardPrintSize ** object_p;
	object_p = collect_values[0].v_pointer;
#line 316 "../src/Printing.vala"
	if (!object_p) {
#line 316 "../src/Printing.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1988 "Printing.c"
	}
#line 316 "../src/Printing.vala"
	if (!value->data[0].v_pointer) {
#line 316 "../src/Printing.vala"
		*object_p = NULL;
#line 1994 "Printing.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 316 "../src/Printing.vala"
		*object_p = value->data[0].v_pointer;
#line 1998 "Printing.c"
	} else {
#line 316 "../src/Printing.vala"
		*object_p = standard_print_size_ref (value->data[0].v_pointer);
#line 2002 "Printing.c"
	}
#line 316 "../src/Printing.vala"
	return NULL;
#line 2006 "Printing.c"
}

GParamSpec*
param_spec_standard_print_size (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecStandardPrintSize* spec;
#line 316 "../src/Printing.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_STANDARD_PRINT_SIZE), NULL);
#line 316 "../src/Printing.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 316 "../src/Printing.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 316 "../src/Printing.vala"
	return G_PARAM_SPEC (spec);
#line 2025 "Printing.c"
}

gpointer
value_get_standard_print_size (const GValue* value)
{
#line 316 "../src/Printing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_STANDARD_PRINT_SIZE), NULL);
#line 316 "../src/Printing.vala"
	return value->data[0].v_pointer;
#line 2035 "Printing.c"
}

void
value_set_standard_print_size (GValue* value,
                               gpointer v_object)
{
	StandardPrintSize * old;
#line 316 "../src/Printing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_STANDARD_PRINT_SIZE));
#line 316 "../src/Printing.vala"
	old = value->data[0].v_pointer;
#line 316 "../src/Printing.vala"
	if (v_object) {
#line 316 "../src/Printing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_STANDARD_PRINT_SIZE));
#line 316 "../src/Printing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 316 "../src/Printing.vala"
		value->data[0].v_pointer = v_object;
#line 316 "../src/Printing.vala"
		standard_print_size_ref (value->data[0].v_pointer);
#line 2057 "Printing.c"
	} else {
#line 316 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 2061 "Printing.c"
	}
#line 316 "../src/Printing.vala"
	if (old) {
#line 316 "../src/Printing.vala"
		standard_print_size_unref (old);
#line 2067 "Printing.c"
	}
}

void
value_take_standard_print_size (GValue* value,
                                gpointer v_object)
{
	StandardPrintSize * old;
#line 316 "../src/Printing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_STANDARD_PRINT_SIZE));
#line 316 "../src/Printing.vala"
	old = value->data[0].v_pointer;
#line 316 "../src/Printing.vala"
	if (v_object) {
#line 316 "../src/Printing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_STANDARD_PRINT_SIZE));
#line 316 "../src/Printing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 316 "../src/Printing.vala"
		value->data[0].v_pointer = v_object;
#line 2088 "Printing.c"
	} else {
#line 316 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 2092 "Printing.c"
	}
#line 316 "../src/Printing.vala"
	if (old) {
#line 316 "../src/Printing.vala"
		standard_print_size_unref (old);
#line 2098 "Printing.c"
	}
}

static void
standard_print_size_class_init (StandardPrintSizeClass * klass,
                                gpointer klass_data)
{
#line 316 "../src/Printing.vala"
	standard_print_size_parent_class = g_type_class_peek_parent (klass);
#line 316 "../src/Printing.vala"
	((StandardPrintSizeClass *) klass)->finalize = standard_print_size_finalize;
#line 2110 "Printing.c"
}

static void
standard_print_size_instance_init (StandardPrintSize * self,
                                   gpointer klass)
{
#line 316 "../src/Printing.vala"
	self->ref_count = 1;
#line 2119 "Printing.c"
}

static void
standard_print_size_finalize (StandardPrintSize * obj)
{
	StandardPrintSize * self;
#line 316 "../src/Printing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STANDARD_PRINT_SIZE, StandardPrintSize);
#line 316 "../src/Printing.vala"
	g_signal_handlers_destroy (self);
#line 323 "../src/Printing.vala"
	_g_free0 (self->name);
#line 2132 "Printing.c"
}

static GType
standard_print_size_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_standard_print_size_init, value_standard_print_size_free_value, value_standard_print_size_copy_value, value_standard_print_size_peek_pointer, "p", value_standard_print_size_collect_value, "p", value_standard_print_size_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (StandardPrintSizeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) standard_print_size_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StandardPrintSize), 0, (GInstanceInitFunc) standard_print_size_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType standard_print_size_type_id;
	standard_print_size_type_id = g_type_register_fundamental (g_type_fundamental_next (), "StandardPrintSize", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return standard_print_size_type_id;
}

GType
standard_print_size_get_type (void)
{
	static volatile gsize standard_print_size_type_id__once = 0;
	if (g_once_init_enter (&standard_print_size_type_id__once)) {
		GType standard_print_size_type_id;
		standard_print_size_type_id = standard_print_size_get_type_once ();
		g_once_init_leave (&standard_print_size_type_id__once, standard_print_size_type_id);
	}
	return standard_print_size_type_id__once;
}

gpointer
standard_print_size_ref (gpointer instance)
{
	StandardPrintSize * self;
	self = instance;
#line 316 "../src/Printing.vala"
	g_atomic_int_inc (&self->ref_count);
#line 316 "../src/Printing.vala"
	return instance;
#line 2167 "Printing.c"
}

void
standard_print_size_unref (gpointer instance)
{
	StandardPrintSize * self;
	self = instance;
#line 316 "../src/Printing.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 316 "../src/Printing.vala"
		STANDARD_PRINT_SIZE_GET_CLASS (self)->finalize (self);
#line 316 "../src/Printing.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2181 "Printing.c"
	}
}

static inline gpointer
print_manager_get_instance_private (PrintManager* self)
{
	return G_STRUCT_MEMBER_P (self, PrintManager_private_offset);
}

static PrintManager*
print_manager_construct (GType object_type)
{
	PrintManager* self = NULL;
	GtkPageSetup* _tmp0_;
	PrintSettings* _tmp1_;
#line 339 "../src/Printing.vala"
	self = (PrintManager*) g_type_create_instance (object_type);
#line 340 "../src/Printing.vala"
	_tmp0_ = gtk_page_setup_new ();
#line 340 "../src/Printing.vala"
	_g_object_unref0 (self->priv->user_page_setup);
#line 340 "../src/Printing.vala"
	self->priv->user_page_setup = _tmp0_;
#line 341 "../src/Printing.vala"
	_tmp1_ = print_settings_new ();
#line 341 "../src/Printing.vala"
	_print_settings_unref0 (self->priv->settings);
#line 341 "../src/Printing.vala"
	self->priv->settings = _tmp1_;
#line 339 "../src/Printing.vala"
	return self;
#line 2213 "Printing.c"
}

static PrintManager*
print_manager_new (void)
{
#line 339 "../src/Printing.vala"
	return print_manager_construct (TYPE_PRINT_MANAGER);
#line 2221 "Printing.c"
}

static void
_vala_array_add30 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 347 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 347 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 347 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2236 "Printing.c"
	}
#line 347 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 347 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2242 "Printing.c"
}

static void
_vala_array_add31 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 350 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 350 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 350 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2257 "Printing.c"
	}
#line 350 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 350 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2263 "Printing.c"
}

static void
_vala_array_add32 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 353 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 353 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 353 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2278 "Printing.c"
	}
#line 353 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 353 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2284 "Printing.c"
}

static void
_vala_array_add33 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 356 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 356 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 356 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2299 "Printing.c"
	}
#line 356 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 356 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2305 "Printing.c"
}

static void
_vala_array_add34 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 359 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 359 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 359 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2320 "Printing.c"
	}
#line 359 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 359 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2326 "Printing.c"
}

static void
_vala_array_add35 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 362 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 362 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 362 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2341 "Printing.c"
	}
#line 362 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 362 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2347 "Printing.c"
}

static void
_vala_array_add36 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 365 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 365 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 365 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2362 "Printing.c"
	}
#line 365 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 365 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2368 "Printing.c"
}

static void
_vala_array_add37 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 368 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 368 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 368 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2383 "Printing.c"
	}
#line 368 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 368 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2389 "Printing.c"
}

static void
_vala_array_add38 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 371 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 371 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 371 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2404 "Printing.c"
	}
#line 371 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 371 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2410 "Printing.c"
}

static void
_vala_array_add39 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 374 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 374 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 374 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2425 "Printing.c"
	}
#line 374 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 374 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2431 "Printing.c"
}

static void
_vala_array_add40 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 377 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 377 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 377 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2446 "Printing.c"
	}
#line 377 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 377 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2452 "Printing.c"
}

static void
_vala_array_add41 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 380 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 380 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 380 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2467 "Printing.c"
	}
#line 380 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 380 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2473 "Printing.c"
}

static void
_vala_array_add42 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 383 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 383 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 383 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2488 "Printing.c"
	}
#line 383 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 383 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2494 "Printing.c"
}

static void
_vala_array_add43 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 386 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 386 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 386 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2509 "Printing.c"
	}
#line 386 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 386 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2515 "Printing.c"
}

static void
_vala_array_add44 (StandardPrintSize** * array,
                   gint* length,
                   gint* size,
                   StandardPrintSize* value)
{
#line 389 "../src/Printing.vala"
	if ((*length) == (*size)) {
#line 389 "../src/Printing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 389 "../src/Printing.vala"
		*array = g_renew (StandardPrintSize*, *array, (*size) + 1);
#line 2530 "Printing.c"
	}
#line 389 "../src/Printing.vala"
	(*array)[(*length)++] = value;
#line 389 "../src/Printing.vala"
	(*array)[*length] = NULL;
#line 2536 "Printing.c"
}

StandardPrintSize**
print_manager_get_standard_sizes (PrintManager* self,
                                  gint* result_length1)
{
	StandardPrintSize** _result_ = NULL;
	StandardPrintSize** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	Measurement _tmp1_ = {0};
	Measurement _tmp2_ = {0};
	StandardPrintSize* _tmp3_;
	Measurement _tmp4_ = {0};
	Measurement _tmp5_ = {0};
	StandardPrintSize* _tmp6_;
	Measurement _tmp7_ = {0};
	Measurement _tmp8_ = {0};
	StandardPrintSize* _tmp9_;
	Measurement _tmp10_ = {0};
	Measurement _tmp11_ = {0};
	StandardPrintSize* _tmp12_;
	Measurement _tmp13_ = {0};
	Measurement _tmp14_ = {0};
	StandardPrintSize* _tmp15_;
	Measurement _tmp16_ = {0};
	Measurement _tmp17_ = {0};
	StandardPrintSize* _tmp18_;
	Measurement _tmp19_ = {0};
	Measurement _tmp20_ = {0};
	StandardPrintSize* _tmp21_;
	Measurement _tmp22_ = {0};
	Measurement _tmp23_ = {0};
	StandardPrintSize* _tmp24_;
	Measurement _tmp25_ = {0};
	Measurement _tmp26_ = {0};
	StandardPrintSize* _tmp27_;
	Measurement _tmp28_ = {0};
	Measurement _tmp29_ = {0};
	StandardPrintSize* _tmp30_;
	Measurement _tmp31_ = {0};
	Measurement _tmp32_ = {0};
	StandardPrintSize* _tmp33_;
	Measurement _tmp34_ = {0};
	Measurement _tmp35_ = {0};
	StandardPrintSize* _tmp36_;
	Measurement _tmp37_ = {0};
	Measurement _tmp38_ = {0};
	StandardPrintSize* _tmp39_;
	Measurement _tmp40_ = {0};
	Measurement _tmp41_ = {0};
	StandardPrintSize* _tmp42_;
	Measurement _tmp43_ = {0};
	Measurement _tmp44_ = {0};
	StandardPrintSize* _tmp45_;
	StandardPrintSize** _tmp46_;
	gint _tmp46__length1;
	StandardPrintSize** result;
#line 344 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 345 "../src/Printing.vala"
	_tmp0_ = g_new0 (StandardPrintSize*, 0 + 1);
#line 345 "../src/Printing.vala"
	_result_ = _tmp0_;
#line 345 "../src/Printing.vala"
	_result__length1 = 0;
#line 345 "../src/Printing.vala"
	__result__size_ = _result__length1;
#line 347 "../src/Printing.vala"
	measurement_init (&_tmp1_, (gdouble) 3, MEASUREMENT_UNIT_INCHES);
#line 347 "../src/Printing.vala"
	measurement_init (&_tmp2_, (gdouble) 2, MEASUREMENT_UNIT_INCHES);
#line 347 "../src/Printing.vala"
	_tmp3_ = standard_print_size_new (_ ("Wallet (2 x 3 in.)"), &_tmp1_, &_tmp2_);
#line 347 "../src/Printing.vala"
	_vala_array_add30 (&_result_, &_result__length1, &__result__size_, _tmp3_);
#line 350 "../src/Printing.vala"
	measurement_init (&_tmp4_, (gdouble) 5, MEASUREMENT_UNIT_INCHES);
#line 350 "../src/Printing.vala"
	measurement_init (&_tmp5_, (gdouble) 3, MEASUREMENT_UNIT_INCHES);
#line 350 "../src/Printing.vala"
	_tmp6_ = standard_print_size_new (_ ("Notecard (3 x 5 in.)"), &_tmp4_, &_tmp5_);
#line 350 "../src/Printing.vala"
	_vala_array_add31 (&_result_, &_result__length1, &__result__size_, _tmp6_);
#line 353 "../src/Printing.vala"
	measurement_init (&_tmp7_, (gdouble) 6, MEASUREMENT_UNIT_INCHES);
#line 353 "../src/Printing.vala"
	measurement_init (&_tmp8_, (gdouble) 4, MEASUREMENT_UNIT_INCHES);
#line 353 "../src/Printing.vala"
	_tmp9_ = standard_print_size_new (_ ("4 x 6 in."), &_tmp7_, &_tmp8_);
#line 353 "../src/Printing.vala"
	_vala_array_add32 (&_result_, &_result__length1, &__result__size_, _tmp9_);
#line 356 "../src/Printing.vala"
	measurement_init (&_tmp10_, (gdouble) 7, MEASUREMENT_UNIT_INCHES);
#line 356 "../src/Printing.vala"
	measurement_init (&_tmp11_, (gdouble) 5, MEASUREMENT_UNIT_INCHES);
#line 356 "../src/Printing.vala"
	_tmp12_ = standard_print_size_new (_ ("5 x 7 in."), &_tmp10_, &_tmp11_);
#line 356 "../src/Printing.vala"
	_vala_array_add33 (&_result_, &_result__length1, &__result__size_, _tmp12_);
#line 359 "../src/Printing.vala"
	measurement_init (&_tmp13_, (gdouble) 10, MEASUREMENT_UNIT_INCHES);
#line 359 "../src/Printing.vala"
	measurement_init (&_tmp14_, (gdouble) 8, MEASUREMENT_UNIT_INCHES);
#line 359 "../src/Printing.vala"
	_tmp15_ = standard_print_size_new (_ ("8 x 10 in."), &_tmp13_, &_tmp14_);
#line 359 "../src/Printing.vala"
	_vala_array_add34 (&_result_, &_result__length1, &__result__size_, _tmp15_);
#line 362 "../src/Printing.vala"
	measurement_init (&_tmp16_, (gdouble) 14, MEASUREMENT_UNIT_INCHES);
#line 362 "../src/Printing.vala"
	measurement_init (&_tmp17_, (gdouble) 11, MEASUREMENT_UNIT_INCHES);
#line 362 "../src/Printing.vala"
	_tmp18_ = standard_print_size_new (_ ("11 x 14 in."), &_tmp16_, &_tmp17_);
#line 362 "../src/Printing.vala"
	_vala_array_add35 (&_result_, &_result__length1, &__result__size_, _tmp18_);
#line 365 "../src/Printing.vala"
	measurement_init (&_tmp19_, (gdouble) 20, MEASUREMENT_UNIT_INCHES);
#line 365 "../src/Printing.vala"
	measurement_init (&_tmp20_, (gdouble) 16, MEASUREMENT_UNIT_INCHES);
#line 365 "../src/Printing.vala"
	_tmp21_ = standard_print_size_new (_ ("16 x 20 in."), &_tmp19_, &_tmp20_);
#line 365 "../src/Printing.vala"
	_vala_array_add36 (&_result_, &_result__length1, &__result__size_, _tmp21_);
#line 368 "../src/Printing.vala"
	measurement_init (&_tmp22_, (gdouble) 0, MEASUREMENT_UNIT_INCHES);
#line 368 "../src/Printing.vala"
	measurement_init (&_tmp23_, (gdouble) 0, MEASUREMENT_UNIT_INCHES);
#line 368 "../src/Printing.vala"
	_tmp24_ = standard_print_size_new ("-", &_tmp22_, &_tmp23_);
#line 368 "../src/Printing.vala"
	_vala_array_add37 (&_result_, &_result__length1, &__result__size_, _tmp24_);
#line 371 "../src/Printing.vala"
	measurement_init (&_tmp25_, (gdouble) 13, MEASUREMENT_UNIT_CENTIMETERS);
#line 371 "../src/Printing.vala"
	measurement_init (&_tmp26_, (gdouble) 9, MEASUREMENT_UNIT_CENTIMETERS);
#line 371 "../src/Printing.vala"
	_tmp27_ = standard_print_size_new (_ ("Metric Wallet (9 x 13 cm)"), &_tmp25_, &_tmp26_);
#line 371 "../src/Printing.vala"
	_vala_array_add38 (&_result_, &_result__length1, &__result__size_, _tmp27_);
#line 374 "../src/Printing.vala"
	measurement_init (&_tmp28_, (gdouble) 15, MEASUREMENT_UNIT_CENTIMETERS);
#line 374 "../src/Printing.vala"
	measurement_init (&_tmp29_, (gdouble) 10, MEASUREMENT_UNIT_CENTIMETERS);
#line 374 "../src/Printing.vala"
	_tmp30_ = standard_print_size_new (_ ("Postcard (10 x 15 cm)"), &_tmp28_, &_tmp29_);
#line 374 "../src/Printing.vala"
	_vala_array_add39 (&_result_, &_result__length1, &__result__size_, _tmp30_);
#line 377 "../src/Printing.vala"
	measurement_init (&_tmp31_, (gdouble) 18, MEASUREMENT_UNIT_CENTIMETERS);
#line 377 "../src/Printing.vala"
	measurement_init (&_tmp32_, (gdouble) 13, MEASUREMENT_UNIT_CENTIMETERS);
#line 377 "../src/Printing.vala"
	_tmp33_ = standard_print_size_new (_ ("13 x 18 cm"), &_tmp31_, &_tmp32_);
#line 377 "../src/Printing.vala"
	_vala_array_add40 (&_result_, &_result__length1, &__result__size_, _tmp33_);
#line 380 "../src/Printing.vala"
	measurement_init (&_tmp34_, (gdouble) 24, MEASUREMENT_UNIT_CENTIMETERS);
#line 380 "../src/Printing.vala"
	measurement_init (&_tmp35_, (gdouble) 18, MEASUREMENT_UNIT_CENTIMETERS);
#line 380 "../src/Printing.vala"
	_tmp36_ = standard_print_size_new (_ ("18 x 24 cm"), &_tmp34_, &_tmp35_);
#line 380 "../src/Printing.vala"
	_vala_array_add41 (&_result_, &_result__length1, &__result__size_, _tmp36_);
#line 383 "../src/Printing.vala"
	measurement_init (&_tmp37_, (gdouble) 30, MEASUREMENT_UNIT_CENTIMETERS);
#line 383 "../src/Printing.vala"
	measurement_init (&_tmp38_, (gdouble) 20, MEASUREMENT_UNIT_CENTIMETERS);
#line 383 "../src/Printing.vala"
	_tmp39_ = standard_print_size_new (_ ("20 x 30 cm"), &_tmp37_, &_tmp38_);
#line 383 "../src/Printing.vala"
	_vala_array_add42 (&_result_, &_result__length1, &__result__size_, _tmp39_);
#line 386 "../src/Printing.vala"
	measurement_init (&_tmp40_, (gdouble) 40, MEASUREMENT_UNIT_CENTIMETERS);
#line 386 "../src/Printing.vala"
	measurement_init (&_tmp41_, (gdouble) 24, MEASUREMENT_UNIT_CENTIMETERS);
#line 386 "../src/Printing.vala"
	_tmp42_ = standard_print_size_new (_ ("24 x 40 cm"), &_tmp40_, &_tmp41_);
#line 386 "../src/Printing.vala"
	_vala_array_add43 (&_result_, &_result__length1, &__result__size_, _tmp42_);
#line 389 "../src/Printing.vala"
	measurement_init (&_tmp43_, (gdouble) 40, MEASUREMENT_UNIT_CENTIMETERS);
#line 389 "../src/Printing.vala"
	measurement_init (&_tmp44_, (gdouble) 30, MEASUREMENT_UNIT_CENTIMETERS);
#line 389 "../src/Printing.vala"
	_tmp45_ = standard_print_size_new (_ ("30 x 40 cm"), &_tmp43_, &_tmp44_);
#line 389 "../src/Printing.vala"
	_vala_array_add44 (&_result_, &_result__length1, &__result__size_, _tmp45_);
#line 393 "../src/Printing.vala"
	_tmp46_ = _result_;
#line 393 "../src/Printing.vala"
	_tmp46__length1 = _result__length1;
#line 393 "../src/Printing.vala"
	if (result_length1) {
#line 393 "../src/Printing.vala"
		*result_length1 = _tmp46__length1;
#line 2733 "Printing.c"
	}
#line 393 "../src/Printing.vala"
	result = _tmp46_;
#line 393 "../src/Printing.vala"
	return result;
#line 2739 "Printing.c"
}

static gpointer
_print_manager_ref0 (gpointer self)
{
#line 400 "../src/Printing.vala"
	return self ? print_manager_ref (self) : NULL;
#line 2747 "Printing.c"
}

PrintManager*
print_manager_get_instance (void)
{
	PrintManager* _tmp0_;
	PrintManager* _tmp2_;
	PrintManager* _tmp3_;
	PrintManager* result;
#line 397 "../src/Printing.vala"
	_tmp0_ = print_manager_instance;
#line 397 "../src/Printing.vala"
	if (_tmp0_ == NULL) {
#line 2761 "Printing.c"
		PrintManager* _tmp1_;
#line 398 "../src/Printing.vala"
		_tmp1_ = print_manager_new ();
#line 398 "../src/Printing.vala"
		_print_manager_unref0 (print_manager_instance);
#line 398 "../src/Printing.vala"
		print_manager_instance = _tmp1_;
#line 2769 "Printing.c"
	}
#line 400 "../src/Printing.vala"
	_tmp2_ = print_manager_instance;
#line 400 "../src/Printing.vala"
	_tmp3_ = _print_manager_ref0 (_tmp2_);
#line 400 "../src/Printing.vala"
	result = _tmp3_;
#line 400 "../src/Printing.vala"
	return result;
#line 2779 "Printing.c"
}

static void
_print_manager_on_begin_print_gtk_print_operation_begin_print (GtkPrintOperation* _sender,
                                                               GtkPrintContext* context,
                                                               gpointer self)
{
#line 410 "../src/Printing.vala"
	print_manager_on_begin_print ((PrintManager*) self, _sender, context);
#line 2789 "Printing.c"
}

static void
_print_manager_on_draw_page_gtk_print_operation_draw_page (GtkPrintOperation* _sender,
                                                           GtkPrintContext* context,
                                                           gint page_nr,
                                                           gpointer self)
{
#line 411 "../src/Printing.vala"
	print_manager_on_draw_page ((PrintManager*) self, _sender, context, page_nr);
#line 2800 "Printing.c"
}

static GObject*
_print_manager_on_create_custom_widget_gtk_print_operation_create_custom_widget (GtkPrintOperation* _sender,
                                                                                 gpointer self)
{
	GObject* result;
	result = print_manager_on_create_custom_widget ((PrintManager*) self, _sender);
#line 412 "../src/Printing.vala"
	return result;
#line 2811 "Printing.c"
}

static void
_print_manager_on_status_changed_gtk_print_operation_status_changed (GtkPrintOperation* _sender,
                                                                     gpointer self)
{
#line 413 "../src/Printing.vala"
	print_manager_on_status_changed ((PrintManager*) self, _sender);
#line 2820 "Printing.c"
}

void
print_manager_spool_photo (PrintManager* self,
                           GeeCollection* to_print)
{
	PrintJob* job = NULL;
	PrintJob* _tmp0_;
	Photo* _tmp1_;
	Photo* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkPageSetup* _tmp5_;
	AppWindow* _tmp6_;
	AppWindow* _tmp7_;
	GCancellable* _tmp8_;
	AppWindow* _tmp9_;
	AppWindow* _tmp10_;
	GCancellable* _tmp11_;
	ProgressDialog* _tmp12_;
	gchar* err_msg = NULL;
	ProgressDialog* _tmp21_;
	AppWindow* _tmp22_;
	AppWindow* _tmp23_;
	const gchar* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 403 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 403 "../src/Printing.vala"
	g_return_if_fail (to_print != NULL);
#line 404 "../src/Printing.vala"
	_tmp0_ = print_job_new (to_print);
#line 404 "../src/Printing.vala"
	job = _tmp0_;
#line 405 "../src/Printing.vala"
	gtk_print_operation_set_custom_tab_label ((GtkPrintOperation*) job, _ ("Image Settings"));
#line 406 "../src/Printing.vala"
	gtk_print_operation_set_unit ((GtkPrintOperation*) job, GTK_UNIT_INCH);
#line 407 "../src/Printing.vala"
	gtk_print_operation_set_n_pages ((GtkPrintOperation*) job, 1);
#line 408 "../src/Printing.vala"
	_tmp1_ = print_job_get_source_photo (job);
#line 408 "../src/Printing.vala"
	_tmp2_ = _tmp1_;
#line 408 "../src/Printing.vala"
	_tmp3_ = data_object_get_name ((DataObject*) _tmp2_);
#line 408 "../src/Printing.vala"
	_tmp4_ = _tmp3_;
#line 408 "../src/Printing.vala"
	gtk_print_operation_set_job_name ((GtkPrintOperation*) job, _tmp4_);
#line 408 "../src/Printing.vala"
	_g_free0 (_tmp4_);
#line 408 "../src/Printing.vala"
	_g_object_unref0 (_tmp2_);
#line 409 "../src/Printing.vala"
	_tmp5_ = self->priv->user_page_setup;
#line 409 "../src/Printing.vala"
	gtk_print_operation_set_default_page_setup ((GtkPrintOperation*) job, _tmp5_);
#line 410 "../src/Printing.vala"
	g_signal_connect ((GtkPrintOperation*) job, "begin-print", (GCallback) _print_manager_on_begin_print_gtk_print_operation_begin_print, self);
#line 411 "../src/Printing.vala"
	g_signal_connect ((GtkPrintOperation*) job, "draw-page", (GCallback) _print_manager_on_draw_page_gtk_print_operation_draw_page, self);
#line 412 "../src/Printing.vala"
	g_signal_connect ((GtkPrintOperation*) job, "create-custom-widget", (GCallback) _print_manager_on_create_custom_widget_gtk_print_operation_create_custom_widget, self);
#line 413 "../src/Printing.vala"
	g_signal_connect ((GtkPrintOperation*) job, "status-changed", (GCallback) _print_manager_on_status_changed_gtk_print_operation_status_changed, self);
#line 415 "../src/Printing.vala"
	_tmp6_ = app_window_get_instance ();
#line 415 "../src/Printing.vala"
	_tmp7_ = _tmp6_;
#line 415 "../src/Printing.vala"
	page_window_set_busy_cursor ((PageWindow*) _tmp7_);
#line 415 "../src/Printing.vala"
	_g_object_unref0 (_tmp7_);
#line 417 "../src/Printing.vala"
	_tmp8_ = g_cancellable_new ();
#line 417 "../src/Printing.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 417 "../src/Printing.vala"
	self->priv->cancellable = _tmp8_;
#line 418 "../src/Printing.vala"
	_tmp9_ = app_window_get_instance ();
#line 418 "../src/Printing.vala"
	_tmp10_ = _tmp9_;
#line 418 "../src/Printing.vala"
	_tmp11_ = self->priv->cancellable;
#line 418 "../src/Printing.vala"
	_tmp12_ = progress_dialog_new ((GtkWindow*) _tmp10_, _ ("Printing…"), _tmp11_);
#line 418 "../src/Printing.vala"
	g_object_ref_sink (_tmp12_);
#line 418 "../src/Printing.vala"
	_g_object_unref0 (self->priv->progress_dialog);
#line 418 "../src/Printing.vala"
	self->priv->progress_dialog = _tmp12_;
#line 418 "../src/Printing.vala"
	_g_object_unref0 (_tmp10_);
#line 420 "../src/Printing.vala"
	err_msg = NULL;
#line 2919 "Printing.c"
	{
		GtkPrintOperationResult _result_ = 0;
		AppWindow* _tmp13_;
		AppWindow* _tmp14_;
		GtkPrintOperationResult _tmp15_;
#line 422 "../src/Printing.vala"
		_tmp13_ = app_window_get_instance ();
#line 422 "../src/Printing.vala"
		_tmp14_ = _tmp13_;
#line 422 "../src/Printing.vala"
		_tmp15_ = gtk_print_operation_run ((GtkPrintOperation*) job, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG, (GtkWindow*) _tmp14_, &_inner_error0_);
#line 422 "../src/Printing.vala"
		_g_object_unref0 (_tmp14_);
#line 422 "../src/Printing.vala"
		_result_ = _tmp15_;
#line 422 "../src/Printing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2937 "Printing.c"
			goto __catch0_g_error;
		}
#line 424 "../src/Printing.vala"
		if (_result_ == GTK_PRINT_OPERATION_RESULT_APPLY) {
#line 2942 "Printing.c"
			GtkPageSetup* _tmp16_;
			GtkPageSetup* _tmp17_;
#line 425 "../src/Printing.vala"
			_tmp16_ = gtk_print_operation_get_default_page_setup ((GtkPrintOperation*) job);
#line 425 "../src/Printing.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 425 "../src/Printing.vala"
			_g_object_unref0 (self->priv->user_page_setup);
#line 425 "../src/Printing.vala"
			self->priv->user_page_setup = _tmp17_;
#line 2953 "Printing.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 421 "../src/Printing.vala"
		e = _inner_error0_;
#line 421 "../src/Printing.vala"
		_inner_error0_ = NULL;
#line 427 "../src/Printing.vala"
		gtk_print_operation_cancel ((GtkPrintOperation*) job);
#line 428 "../src/Printing.vala"
		_tmp18_ = e;
#line 428 "../src/Printing.vala"
		_tmp19_ = _tmp18_->message;
#line 428 "../src/Printing.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 428 "../src/Printing.vala"
		_g_free0 (err_msg);
#line 428 "../src/Printing.vala"
		err_msg = _tmp20_;
#line 421 "../src/Printing.vala"
		_g_error_free0 (e);
#line 2981 "Printing.c"
	}
	__finally0:
#line 421 "../src/Printing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 421 "../src/Printing.vala"
		_g_free0 (err_msg);
#line 421 "../src/Printing.vala"
		_g_object_unref0 (job);
#line 421 "../src/Printing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 421 "../src/Printing.vala"
		g_clear_error (&_inner_error0_);
#line 421 "../src/Printing.vala"
		return;
#line 2996 "Printing.c"
	}
#line 431 "../src/Printing.vala"
	_tmp21_ = self->priv->progress_dialog;
#line 431 "../src/Printing.vala"
	progress_dialog_close (_tmp21_);
#line 432 "../src/Printing.vala"
	_g_object_unref0 (self->priv->progress_dialog);
#line 432 "../src/Printing.vala"
	self->priv->progress_dialog = NULL;
#line 433 "../src/Printing.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 433 "../src/Printing.vala"
	self->priv->cancellable = NULL;
#line 435 "../src/Printing.vala"
	_tmp22_ = app_window_get_instance ();
#line 435 "../src/Printing.vala"
	_tmp23_ = _tmp22_;
#line 435 "../src/Printing.vala"
	page_window_set_normal_cursor ((PageWindow*) _tmp23_);
#line 435 "../src/Printing.vala"
	_g_object_unref0 (_tmp23_);
#line 437 "../src/Printing.vala"
	_tmp24_ = err_msg;
#line 437 "../src/Printing.vala"
	if (_tmp24_ != NULL) {
#line 3022 "Printing.c"
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 438 "../src/Printing.vala"
		_tmp25_ = err_msg;
#line 438 "../src/Printing.vala"
		_tmp26_ = g_strdup_printf (_ ("Unable to print photo:\n\n%s"), _tmp25_);
#line 438 "../src/Printing.vala"
		_tmp27_ = _tmp26_;
#line 438 "../src/Printing.vala"
		app_window_error_message (_tmp27_, NULL, NULL);
#line 438 "../src/Printing.vala"
		_g_free0 (_tmp27_);
#line 3036 "Printing.c"
	}
#line 403 "../src/Printing.vala"
	_g_free0 (err_msg);
#line 403 "../src/Printing.vala"
	_g_object_unref0 (job);
#line 3042 "Printing.c"
}

static void
print_manager_on_begin_print (PrintManager* self,
                              GtkPrintOperation* emitting_object,
                              GtkPrintContext* job_context)
{
	PrintJob* job = NULL;
	PrintJob* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GCancellable* _tmp2_;
	GeeList* photos = NULL;
	PrintJob* _tmp5_;
	GeeList* _tmp6_;
	PrintJob* _tmp7_;
	PrintSettings* _tmp8_;
	PrintSettings* _tmp9_;
	gboolean _tmp10_;
#line 441 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 441 "../src/Printing.vala"
	g_return_if_fail (emitting_object != NULL);
#line 441 "../src/Printing.vala"
	g_return_if_fail (job_context != NULL);
#line 442 "../src/Printing.vala"
	g_debug ("Printing.vala:442: on_begin_print");
#line 444 "../src/Printing.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (emitting_object, TYPE_PRINT_JOB, PrintJob));
#line 444 "../src/Printing.vala"
	job = _tmp0_;
#line 447 "../src/Printing.vala"
	_tmp2_ = self->priv->cancellable;
#line 447 "../src/Printing.vala"
	if (_tmp2_ != NULL) {
#line 3077 "Printing.c"
		GCancellable* _tmp3_;
#line 447 "../src/Printing.vala"
		_tmp3_ = self->priv->cancellable;
#line 447 "../src/Printing.vala"
		_tmp1_ = g_cancellable_is_cancelled (_tmp3_);
#line 3083 "Printing.c"
	} else {
#line 447 "../src/Printing.vala"
		_tmp1_ = FALSE;
#line 3087 "Printing.c"
	}
#line 447 "../src/Printing.vala"
	if (_tmp1_) {
#line 3091 "Printing.c"
		PrintJob* _tmp4_;
#line 448 "../src/Printing.vala"
		_tmp4_ = job;
#line 448 "../src/Printing.vala"
		gtk_print_operation_cancel ((GtkPrintOperation*) _tmp4_);
#line 450 "../src/Printing.vala"
		_g_object_unref0 (job);
#line 450 "../src/Printing.vala"
		return;
#line 3101 "Printing.c"
	}
#line 453 "../src/Printing.vala"
	_tmp5_ = job;
#line 453 "../src/Printing.vala"
	_tmp6_ = print_job_get_photos (_tmp5_);
#line 453 "../src/Printing.vala"
	photos = _tmp6_;
#line 454 "../src/Printing.vala"
	_tmp7_ = job;
#line 454 "../src/Printing.vala"
	_tmp8_ = print_job_get_local_settings (_tmp7_);
#line 454 "../src/Printing.vala"
	_tmp9_ = _tmp8_;
#line 454 "../src/Printing.vala"
	_tmp10_ = print_settings_get_content_layout (_tmp9_) == CONTENT_LAYOUT_IMAGE_PER_PAGE;
#line 454 "../src/Printing.vala"
	_print_settings_unref0 (_tmp9_);
#line 454 "../src/Printing.vala"
	if (_tmp10_) {
#line 3121 "Printing.c"
		PrintLayout layout = 0;
		PrintJob* _tmp11_;
		PrintSettings* _tmp12_;
		PrintSettings* _tmp13_;
		PrintLayout _tmp14_;
		PrintJob* _tmp15_;
		GeeList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 455 "../src/Printing.vala"
		_tmp11_ = job;
#line 455 "../src/Printing.vala"
		_tmp12_ = print_job_get_local_settings (_tmp11_);
#line 455 "../src/Printing.vala"
		_tmp13_ = _tmp12_;
#line 455 "../src/Printing.vala"
		_tmp14_ = (PrintLayout) print_settings_get_image_per_page_selection (_tmp13_);
#line 455 "../src/Printing.vala"
		_print_settings_unref0 (_tmp13_);
#line 455 "../src/Printing.vala"
		layout = _tmp14_;
#line 456 "../src/Printing.vala"
		_tmp15_ = job;
#line 456 "../src/Printing.vala"
		_tmp16_ = photos;
#line 456 "../src/Printing.vala"
		_tmp17_ = gee_collection_get_size ((GeeCollection*) _tmp16_);
#line 456 "../src/Printing.vala"
		_tmp18_ = _tmp17_;
#line 456 "../src/Printing.vala"
		gtk_print_operation_set_n_pages ((GtkPrintOperation*) _tmp15_, (gint) ceil (((gdouble) _tmp18_) / ((gdouble) print_layout_get_per_page (layout))));
#line 3153 "Printing.c"
	} else {
		PrintJob* _tmp19_;
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 458 "../src/Printing.vala"
		_tmp19_ = job;
#line 458 "../src/Printing.vala"
		_tmp20_ = photos;
#line 458 "../src/Printing.vala"
		_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 458 "../src/Printing.vala"
		_tmp22_ = _tmp21_;
#line 458 "../src/Printing.vala"
		gtk_print_operation_set_n_pages ((GtkPrintOperation*) _tmp19_, _tmp22_);
#line 3169 "Printing.c"
	}
#line 461 "../src/Printing.vala"
	spin_event_loop ();
#line 441 "../src/Printing.vala"
	_g_object_unref0 (photos);
#line 441 "../src/Printing.vala"
	_g_object_unref0 (job);
#line 3177 "Printing.c"
}

static void
print_manager_on_status_changed (PrintManager* self,
                                 GtkPrintOperation* job)
{
	const gchar* _tmp0_;
	ProgressDialog* _tmp1_;
#line 464 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 464 "../src/Printing.vala"
	g_return_if_fail (job != NULL);
#line 465 "../src/Printing.vala"
	_tmp0_ = gtk_print_operation_get_status_string (job);
#line 465 "../src/Printing.vala"
	g_debug ("Printing.vala:465: on_status_changed: %s", _tmp0_);
#line 467 "../src/Printing.vala"
	_tmp1_ = self->priv->progress_dialog;
#line 467 "../src/Printing.vala"
	if (_tmp1_ != NULL) {
#line 3198 "Printing.c"
		ProgressDialog* _tmp2_;
		const gchar* _tmp3_;
#line 468 "../src/Printing.vala"
		_tmp2_ = self->priv->progress_dialog;
#line 468 "../src/Printing.vala"
		_tmp3_ = gtk_print_operation_get_status_string (job);
#line 468 "../src/Printing.vala"
		progress_dialog_set_status (_tmp2_, _tmp3_);
#line 469 "../src/Printing.vala"
		spin_event_loop ();
#line 3209 "Printing.c"
	}
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 494 "../src/Printing.vala"
	return self ? cairo_reference (self) : NULL;
#line 3218 "Printing.c"
}

static void
print_manager_on_draw_page (PrintManager* self,
                            GtkPrintOperation* emitting_object,
                            GtkPrintContext* job_context,
                            gint page_num)
{
	PrintJob* job = NULL;
	PrintJob* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GCancellable* _tmp2_;
	GtkPageSetup* page_setup = NULL;
	GtkPageSetup* _tmp5_;
	GtkPageSetup* _tmp6_;
	gdouble page_width = 0.0;
	GtkPageSetup* _tmp7_;
	gdouble page_height = 0.0;
	GtkPageSetup* _tmp8_;
	gdouble dpi = 0.0;
	PrintJob* _tmp9_;
	PrintSettings* _tmp10_;
	PrintSettings* _tmp11_;
	gdouble _tmp12_;
	gdouble inv_dpi = 0.0;
	cairo_t* dc = NULL;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_t* _tmp15_;
	GeeList* photos = NULL;
	PrintJob* _tmp16_;
	GeeList* _tmp17_;
	ContentLayout content_layout = 0;
	PrintJob* _tmp18_;
	PrintSettings* _tmp19_;
	PrintSettings* _tmp20_;
	ContentLayout _tmp21_;
#line 473 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 473 "../src/Printing.vala"
	g_return_if_fail (emitting_object != NULL);
#line 473 "../src/Printing.vala"
	g_return_if_fail (job_context != NULL);
#line 475 "../src/Printing.vala"
	g_debug ("Printing.vala:475: on_draw_page");
#line 477 "../src/Printing.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (emitting_object, TYPE_PRINT_JOB, PrintJob));
#line 477 "../src/Printing.vala"
	job = _tmp0_;
#line 480 "../src/Printing.vala"
	_tmp2_ = self->priv->cancellable;
#line 480 "../src/Printing.vala"
	if (_tmp2_ != NULL) {
#line 3272 "Printing.c"
		GCancellable* _tmp3_;
#line 480 "../src/Printing.vala"
		_tmp3_ = self->priv->cancellable;
#line 480 "../src/Printing.vala"
		_tmp1_ = g_cancellable_is_cancelled (_tmp3_);
#line 3278 "Printing.c"
	} else {
#line 480 "../src/Printing.vala"
		_tmp1_ = FALSE;
#line 3282 "Printing.c"
	}
#line 480 "../src/Printing.vala"
	if (_tmp1_) {
#line 3286 "Printing.c"
		PrintJob* _tmp4_;
#line 481 "../src/Printing.vala"
		_tmp4_ = job;
#line 481 "../src/Printing.vala"
		gtk_print_operation_cancel ((GtkPrintOperation*) _tmp4_);
#line 483 "../src/Printing.vala"
		_g_object_unref0 (job);
#line 483 "../src/Printing.vala"
		return;
#line 3296 "Printing.c"
	}
#line 486 "../src/Printing.vala"
	spin_event_loop ();
#line 488 "../src/Printing.vala"
	_tmp5_ = gtk_print_context_get_page_setup (job_context);
#line 488 "../src/Printing.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 488 "../src/Printing.vala"
	page_setup = _tmp6_;
#line 489 "../src/Printing.vala"
	_tmp7_ = page_setup;
#line 489 "../src/Printing.vala"
	page_width = gtk_page_setup_get_page_width (_tmp7_, GTK_UNIT_INCH);
#line 490 "../src/Printing.vala"
	_tmp8_ = page_setup;
#line 490 "../src/Printing.vala"
	page_height = gtk_page_setup_get_page_height (_tmp8_, GTK_UNIT_INCH);
#line 492 "../src/Printing.vala"
	_tmp9_ = job;
#line 492 "../src/Printing.vala"
	_tmp10_ = print_job_get_local_settings (_tmp9_);
#line 492 "../src/Printing.vala"
	_tmp11_ = _tmp10_;
#line 492 "../src/Printing.vala"
	_tmp12_ = (gdouble) print_settings_get_content_ppi (_tmp11_);
#line 492 "../src/Printing.vala"
	_print_settings_unref0 (_tmp11_);
#line 492 "../src/Printing.vala"
	dpi = _tmp12_;
#line 493 "../src/Printing.vala"
	inv_dpi = 1.0 / dpi;
#line 494 "../src/Printing.vala"
	_tmp13_ = gtk_print_context_get_cairo_context (job_context);
#line 494 "../src/Printing.vala"
	_tmp14_ = _cairo_reference0 (_tmp13_);
#line 494 "../src/Printing.vala"
	dc = _tmp14_;
#line 495 "../src/Printing.vala"
	_tmp15_ = dc;
#line 495 "../src/Printing.vala"
	cairo_scale (_tmp15_, inv_dpi, inv_dpi);
#line 496 "../src/Printing.vala"
	_tmp16_ = job;
#line 496 "../src/Printing.vala"
	_tmp17_ = print_job_get_photos (_tmp16_);
#line 496 "../src/Printing.vala"
	photos = _tmp17_;
#line 498 "../src/Printing.vala"
	_tmp18_ = job;
#line 498 "../src/Printing.vala"
	_tmp19_ = print_job_get_local_settings (_tmp18_);
#line 498 "../src/Printing.vala"
	_tmp20_ = _tmp19_;
#line 498 "../src/Printing.vala"
	_tmp21_ = print_settings_get_content_layout (_tmp20_);
#line 498 "../src/Printing.vala"
	_print_settings_unref0 (_tmp20_);
#line 498 "../src/Printing.vala"
	content_layout = _tmp21_;
#line 499 "../src/Printing.vala"
	switch (content_layout) {
#line 499 "../src/Printing.vala"
		case CONTENT_LAYOUT_STANDARD_SIZE:
#line 499 "../src/Printing.vala"
		case CONTENT_LAYOUT_CUSTOM_SIZE:
#line 3362 "Printing.c"
		{
			gdouble canvas_width = 0.0;
			gdouble canvas_height = 0.0;
			GeeList* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
			ProgressDialog* _tmp70_;
#line 503 "../src/Printing.vala"
			if (content_layout == CONTENT_LAYOUT_STANDARD_SIZE) {
#line 3372 "Printing.c"
				gint _tmp22_ = 0;
				StandardPrintSize** _tmp23_;
				StandardPrintSize** _tmp24_;
				gint _tmp24__length1;
				PrintJob* _tmp25_;
				PrintSettings* _tmp26_;
				PrintSettings* _tmp27_;
				StandardPrintSize* _tmp28_;
				Measurement _tmp29_ = {0};
				gint _tmp30_ = 0;
				StandardPrintSize** _tmp31_;
				StandardPrintSize** _tmp32_;
				gint _tmp32__length1;
				PrintJob* _tmp33_;
				PrintSettings* _tmp34_;
				PrintSettings* _tmp35_;
				StandardPrintSize* _tmp36_;
				Measurement _tmp37_ = {0};
#line 504 "../src/Printing.vala"
				_tmp23_ = print_manager_get_standard_sizes (self, &_tmp22_);
#line 504 "../src/Printing.vala"
				_tmp24_ = _tmp23_;
#line 504 "../src/Printing.vala"
				_tmp24__length1 = _tmp22_;
#line 504 "../src/Printing.vala"
				_tmp25_ = job;
#line 504 "../src/Printing.vala"
				_tmp26_ = print_job_get_local_settings (_tmp25_);
#line 504 "../src/Printing.vala"
				_tmp27_ = _tmp26_;
#line 504 "../src/Printing.vala"
				_tmp28_ = _tmp24_[print_settings_get_size_selection (_tmp27_)];
#line 504 "../src/Printing.vala"
				measurement_convert_to (&_tmp28_->width, MEASUREMENT_UNIT_INCHES, &_tmp29_);
#line 504 "../src/Printing.vala"
				canvas_width = _tmp29_.value;
#line 504 "../src/Printing.vala"
				_print_settings_unref0 (_tmp27_);
#line 504 "../src/Printing.vala"
				_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) standard_print_size_unref), NULL);
#line 506 "../src/Printing.vala"
				_tmp31_ = print_manager_get_standard_sizes (self, &_tmp30_);
#line 506 "../src/Printing.vala"
				_tmp32_ = _tmp31_;
#line 506 "../src/Printing.vala"
				_tmp32__length1 = _tmp30_;
#line 506 "../src/Printing.vala"
				_tmp33_ = job;
#line 506 "../src/Printing.vala"
				_tmp34_ = print_job_get_local_settings (_tmp33_);
#line 506 "../src/Printing.vala"
				_tmp35_ = _tmp34_;
#line 506 "../src/Printing.vala"
				_tmp36_ = _tmp32_[print_settings_get_size_selection (_tmp35_)];
#line 506 "../src/Printing.vala"
				measurement_convert_to (&_tmp36_->height, MEASUREMENT_UNIT_INCHES, &_tmp37_);
#line 506 "../src/Printing.vala"
				canvas_height = _tmp37_.value;
#line 506 "../src/Printing.vala"
				_print_settings_unref0 (_tmp35_);
#line 506 "../src/Printing.vala"
				_tmp32_ = (_vala_array_free (_tmp32_, _tmp32__length1, (GDestroyNotify) standard_print_size_unref), NULL);
#line 3435 "Printing.c"
			} else {
				PrintJob* _tmp38_;
				PrintSettings* _tmp39_;
				PrintSettings* _tmp40_;
				Measurement _tmp41_ = {0};
				Measurement _tmp42_ = {0};
				PrintJob* _tmp43_;
				PrintSettings* _tmp44_;
				PrintSettings* _tmp45_;
				Measurement _tmp46_ = {0};
				Measurement _tmp47_ = {0};
#line 509 "../src/Printing.vala"
				_vala_assert (content_layout == CONTENT_LAYOUT_CUSTOM_SIZE, "content_layout == ContentLayout.CUSTOM_SIZE");
#line 510 "../src/Printing.vala"
				_tmp38_ = job;
#line 510 "../src/Printing.vala"
				_tmp39_ = print_job_get_local_settings (_tmp38_);
#line 510 "../src/Printing.vala"
				_tmp40_ = _tmp39_;
#line 510 "../src/Printing.vala"
				print_settings_get_content_width (_tmp40_, &_tmp41_);
#line 510 "../src/Printing.vala"
				measurement_convert_to (&_tmp41_, MEASUREMENT_UNIT_INCHES, &_tmp42_);
#line 510 "../src/Printing.vala"
				canvas_width = _tmp42_.value;
#line 510 "../src/Printing.vala"
				_print_settings_unref0 (_tmp40_);
#line 512 "../src/Printing.vala"
				_tmp43_ = job;
#line 512 "../src/Printing.vala"
				_tmp44_ = print_job_get_local_settings (_tmp43_);
#line 512 "../src/Printing.vala"
				_tmp45_ = _tmp44_;
#line 512 "../src/Printing.vala"
				print_settings_get_content_height (_tmp45_, &_tmp46_);
#line 512 "../src/Printing.vala"
				measurement_convert_to (&_tmp46_, MEASUREMENT_UNIT_INCHES, &_tmp47_);
#line 512 "../src/Printing.vala"
				canvas_height = _tmp47_.value;
#line 512 "../src/Printing.vala"
				_print_settings_unref0 (_tmp45_);
#line 3477 "Printing.c"
			}
#line 516 "../src/Printing.vala"
			_tmp48_ = photos;
#line 516 "../src/Printing.vala"
			_tmp49_ = gee_collection_get_size ((GeeCollection*) _tmp48_);
#line 516 "../src/Printing.vala"
			_tmp50_ = _tmp49_;
#line 516 "../src/Printing.vala"
			if (page_num < _tmp50_) {
#line 3487 "Printing.c"
				Dimensions photo_dimensions = {0};
				GeeList* _tmp51_;
				gpointer _tmp52_;
				Photo* _tmp53_;
				Dimensions _tmp54_ = {0};
				Dimensions _tmp55_;
				gdouble photo_aspect_ratio = 0.0;
				gdouble canvas_aspect_ratio = 0.0;
				gdouble dx = 0.0;
				gdouble dy = 0.0;
				GeeList* _tmp56_;
				gpointer _tmp57_;
				Photo* _tmp58_;
				PrintJob* _tmp59_;
				PrintJob* _tmp60_;
				PrintSettings* _tmp61_;
				PrintSettings* _tmp62_;
				gboolean _tmp63_;
#line 517 "../src/Printing.vala"
				_tmp51_ = photos;
#line 517 "../src/Printing.vala"
				_tmp52_ = gee_list_get (_tmp51_, page_num);
#line 517 "../src/Printing.vala"
				_tmp53_ = (Photo*) _tmp52_;
#line 517 "../src/Printing.vala"
				media_source_get_dimensions ((MediaSource*) _tmp53_, PHOTO_EXCEPTION_NONE, &_tmp54_);
#line 517 "../src/Printing.vala"
				_tmp55_ = _tmp54_;
#line 517 "../src/Printing.vala"
				_g_object_unref0 (_tmp53_);
#line 517 "../src/Printing.vala"
				photo_dimensions = _tmp55_;
#line 518 "../src/Printing.vala"
				photo_aspect_ratio = dimensions_get_aspect_ratio (&photo_dimensions);
#line 519 "../src/Printing.vala"
				canvas_aspect_ratio = ((gdouble) canvas_width) / canvas_height;
#line 520 "../src/Printing.vala"
				if (floor (canvas_aspect_ratio) != floor (photo_aspect_ratio)) {
#line 3526 "Printing.c"
					gdouble canvas_tmp = 0.0;
#line 521 "../src/Printing.vala"
					canvas_tmp = canvas_width;
#line 522 "../src/Printing.vala"
					canvas_width = canvas_height;
#line 523 "../src/Printing.vala"
					canvas_height = canvas_tmp;
#line 3534 "Printing.c"
				}
#line 526 "../src/Printing.vala"
				dx = (page_width - canvas_width) / 2.0;
#line 527 "../src/Printing.vala"
				dy = (page_height - canvas_height) / 2.0;
#line 528 "../src/Printing.vala"
				_tmp56_ = photos;
#line 528 "../src/Printing.vala"
				_tmp57_ = gee_list_get (_tmp56_, page_num);
#line 528 "../src/Printing.vala"
				_tmp58_ = (Photo*) _tmp57_;
#line 528 "../src/Printing.vala"
				_tmp59_ = job;
#line 528 "../src/Printing.vala"
				print_manager_fit_image_to_canvas (self, _tmp58_, dx, dy, canvas_width, canvas_height, TRUE, _tmp59_, job_context);
#line 528 "../src/Printing.vala"
				_g_object_unref0 (_tmp58_);
#line 530 "../src/Printing.vala"
				_tmp60_ = job;
#line 530 "../src/Printing.vala"
				_tmp61_ = print_job_get_local_settings (_tmp60_);
#line 530 "../src/Printing.vala"
				_tmp62_ = _tmp61_;
#line 530 "../src/Printing.vala"
				_tmp63_ = print_settings_is_print_titles_enabled (_tmp62_);
#line 530 "../src/Printing.vala"
				_print_settings_unref0 (_tmp62_);
#line 530 "../src/Printing.vala"
				if (_tmp63_) {
#line 3564 "Printing.c"
					GeeList* _tmp64_;
					gpointer _tmp65_;
					Photo* _tmp66_;
					gchar* _tmp67_;
					gchar* _tmp68_;
					PrintJob* _tmp69_;
#line 531 "../src/Printing.vala"
					_tmp64_ = photos;
#line 531 "../src/Printing.vala"
					_tmp65_ = gee_list_get (_tmp64_, page_num);
#line 531 "../src/Printing.vala"
					_tmp66_ = (Photo*) _tmp65_;
#line 531 "../src/Printing.vala"
					_tmp67_ = data_object_get_name ((DataObject*) _tmp66_);
#line 531 "../src/Printing.vala"
					_tmp68_ = _tmp67_;
#line 531 "../src/Printing.vala"
					_tmp69_ = job;
#line 531 "../src/Printing.vala"
					print_manager_add_title_to_canvas (self, page_width / 2, page_height, _tmp68_, _tmp69_, job_context);
#line 531 "../src/Printing.vala"
					_g_free0 (_tmp68_);
#line 531 "../src/Printing.vala"
					_g_object_unref0 (_tmp66_);
#line 3589 "Printing.c"
				}
			}
#line 536 "../src/Printing.vala"
			_tmp70_ = self->priv->progress_dialog;
#line 536 "../src/Printing.vala"
			if (_tmp70_ != NULL) {
#line 3596 "Printing.c"
				ProgressDialog* _tmp71_;
				GeeList* _tmp72_;
				gint _tmp73_;
				gint _tmp74_;
#line 537 "../src/Printing.vala"
				_tmp71_ = self->priv->progress_dialog;
#line 537 "../src/Printing.vala"
				_tmp72_ = photos;
#line 537 "../src/Printing.vala"
				_tmp73_ = gee_collection_get_size ((GeeCollection*) _tmp72_);
#line 537 "../src/Printing.vala"
				_tmp74_ = _tmp73_;
#line 537 "../src/Printing.vala"
				progress_dialog_monitor (_tmp71_, (guint64) page_num, (guint64) _tmp74_, TRUE);
#line 3611 "Printing.c"
			}
#line 538 "../src/Printing.vala"
			break;
#line 3615 "Printing.c"
		}
#line 499 "../src/Printing.vala"
		case CONTENT_LAYOUT_IMAGE_PER_PAGE:
#line 3619 "Printing.c"
		{
			PrintLayout layout = 0;
			PrintJob* _tmp75_;
			PrintSettings* _tmp76_;
			PrintSettings* _tmp77_;
			PrintLayout _tmp78_;
			gint nx = 0;
			gint ny = 0;
			gint start = 0;
			gdouble canvas_width = 0.0;
			gdouble canvas_height = 0.0;
#line 541 "../src/Printing.vala"
			_tmp75_ = job;
#line 541 "../src/Printing.vala"
			_tmp76_ = print_job_get_local_settings (_tmp75_);
#line 541 "../src/Printing.vala"
			_tmp77_ = _tmp76_;
#line 541 "../src/Printing.vala"
			_tmp78_ = (PrintLayout) print_settings_get_image_per_page_selection (_tmp77_);
#line 541 "../src/Printing.vala"
			_print_settings_unref0 (_tmp77_);
#line 541 "../src/Printing.vala"
			layout = _tmp78_;
#line 542 "../src/Printing.vala"
			nx = print_layout_get_x (layout);
#line 543 "../src/Printing.vala"
			ny = print_layout_get_y (layout);
#line 544 "../src/Printing.vala"
			start = page_num * print_layout_get_per_page (layout);
#line 545 "../src/Printing.vala"
			canvas_width = ((gdouble) (page_width - (PRINT_MANAGER_IMAGE_DISTANCE * (nx - 1)))) / nx;
#line 546 "../src/Printing.vala"
			canvas_height = ((gdouble) (page_height - (PRINT_MANAGER_IMAGE_DISTANCE * (ny - 1)))) / ny;
#line 3653 "Printing.c"
			{
				gint y = 0;
#line 547 "../src/Printing.vala"
				y = 0;
#line 3658 "Printing.c"
				{
					gboolean _tmp79_ = FALSE;
#line 547 "../src/Printing.vala"
					_tmp79_ = TRUE;
#line 547 "../src/Printing.vala"
					while (TRUE) {
#line 547 "../src/Printing.vala"
						if (!_tmp79_) {
#line 3667 "Printing.c"
							gint _tmp80_;
#line 547 "../src/Printing.vala"
							_tmp80_ = y;
#line 547 "../src/Printing.vala"
							y = _tmp80_ + 1;
#line 3673 "Printing.c"
						}
#line 547 "../src/Printing.vala"
						_tmp79_ = FALSE;
#line 547 "../src/Printing.vala"
						if (!(y < ny)) {
#line 547 "../src/Printing.vala"
							break;
#line 3681 "Printing.c"
						}
						{
							gint x = 0;
#line 548 "../src/Printing.vala"
							x = 0;
#line 3687 "Printing.c"
							{
								gboolean _tmp81_ = FALSE;
#line 548 "../src/Printing.vala"
								_tmp81_ = TRUE;
#line 548 "../src/Printing.vala"
								while (TRUE) {
#line 3694 "Printing.c"
									gint i = 0;
									GeeList* _tmp83_;
									gint _tmp84_;
									gint _tmp85_;
									ProgressDialog* _tmp100_;
#line 548 "../src/Printing.vala"
									if (!_tmp81_) {
#line 3702 "Printing.c"
										gint _tmp82_;
#line 548 "../src/Printing.vala"
										_tmp82_ = x;
#line 548 "../src/Printing.vala"
										x = _tmp82_ + 1;
#line 3708 "Printing.c"
									}
#line 548 "../src/Printing.vala"
									_tmp81_ = FALSE;
#line 548 "../src/Printing.vala"
									if (!(x < nx)) {
#line 548 "../src/Printing.vala"
										break;
#line 3716 "Printing.c"
									}
#line 549 "../src/Printing.vala"
									i = (start + (y * nx)) + x;
#line 550 "../src/Printing.vala"
									_tmp83_ = photos;
#line 550 "../src/Printing.vala"
									_tmp84_ = gee_collection_get_size ((GeeCollection*) _tmp83_);
#line 550 "../src/Printing.vala"
									_tmp85_ = _tmp84_;
#line 550 "../src/Printing.vala"
									if (i < _tmp85_) {
#line 3728 "Printing.c"
										gdouble dx = 0.0;
										gdouble dy = 0.0;
										GeeList* _tmp86_;
										gpointer _tmp87_;
										Photo* _tmp88_;
										PrintJob* _tmp89_;
										PrintJob* _tmp90_;
										PrintSettings* _tmp91_;
										PrintSettings* _tmp92_;
										gboolean _tmp93_;
#line 551 "../src/Printing.vala"
										dx = (x * canvas_width) + (x * PRINT_MANAGER_IMAGE_DISTANCE);
#line 552 "../src/Printing.vala"
										dy = (y * canvas_height) + (y * PRINT_MANAGER_IMAGE_DISTANCE);
#line 553 "../src/Printing.vala"
										_tmp86_ = photos;
#line 553 "../src/Printing.vala"
										_tmp87_ = gee_list_get (_tmp86_, i);
#line 553 "../src/Printing.vala"
										_tmp88_ = (Photo*) _tmp87_;
#line 553 "../src/Printing.vala"
										_tmp89_ = job;
#line 553 "../src/Printing.vala"
										print_manager_fit_image_to_canvas (self, _tmp88_, dx, dy, canvas_width, canvas_height, FALSE, _tmp89_, job_context);
#line 553 "../src/Printing.vala"
										_g_object_unref0 (_tmp88_);
#line 555 "../src/Printing.vala"
										_tmp90_ = job;
#line 555 "../src/Printing.vala"
										_tmp91_ = print_job_get_local_settings (_tmp90_);
#line 555 "../src/Printing.vala"
										_tmp92_ = _tmp91_;
#line 555 "../src/Printing.vala"
										_tmp93_ = print_settings_is_print_titles_enabled (_tmp92_);
#line 555 "../src/Printing.vala"
										_print_settings_unref0 (_tmp92_);
#line 555 "../src/Printing.vala"
										if (_tmp93_) {
#line 3767 "Printing.c"
											GeeList* _tmp94_;
											gpointer _tmp95_;
											Photo* _tmp96_;
											gchar* _tmp97_;
											gchar* _tmp98_;
											PrintJob* _tmp99_;
#line 556 "../src/Printing.vala"
											_tmp94_ = photos;
#line 556 "../src/Printing.vala"
											_tmp95_ = gee_list_get (_tmp94_, i);
#line 556 "../src/Printing.vala"
											_tmp96_ = (Photo*) _tmp95_;
#line 556 "../src/Printing.vala"
											_tmp97_ = data_object_get_name ((DataObject*) _tmp96_);
#line 556 "../src/Printing.vala"
											_tmp98_ = _tmp97_;
#line 556 "../src/Printing.vala"
											_tmp99_ = job;
#line 556 "../src/Printing.vala"
											print_manager_add_title_to_canvas (self, dx + (canvas_width / 2), dy + canvas_height, _tmp98_, _tmp99_, job_context);
#line 556 "../src/Printing.vala"
											_g_free0 (_tmp98_);
#line 556 "../src/Printing.vala"
											_g_object_unref0 (_tmp96_);
#line 3792 "Printing.c"
										}
									}
#line 561 "../src/Printing.vala"
									_tmp100_ = self->priv->progress_dialog;
#line 561 "../src/Printing.vala"
									if (_tmp100_ != NULL) {
#line 3799 "Printing.c"
										ProgressDialog* _tmp101_;
										GeeList* _tmp102_;
										gint _tmp103_;
										gint _tmp104_;
#line 562 "../src/Printing.vala"
										_tmp101_ = self->priv->progress_dialog;
#line 562 "../src/Printing.vala"
										_tmp102_ = photos;
#line 562 "../src/Printing.vala"
										_tmp103_ = gee_collection_get_size ((GeeCollection*) _tmp102_);
#line 562 "../src/Printing.vala"
										_tmp104_ = _tmp103_;
#line 562 "../src/Printing.vala"
										progress_dialog_monitor (_tmp101_, (guint64) i, (guint64) _tmp104_, TRUE);
#line 3814 "Printing.c"
									}
								}
							}
						}
					}
				}
			}
#line 565 "../src/Printing.vala"
			break;
#line 3824 "Printing.c"
		}
		default:
		{
#line 568 "../src/Printing.vala"
			g_error ("Printing.vala:568: unknown or unsupported layout mode");
#line 3830 "Printing.c"
		}
	}
#line 473 "../src/Printing.vala"
	_g_object_unref0 (photos);
#line 473 "../src/Printing.vala"
	_cairo_destroy0 (dc);
#line 473 "../src/Printing.vala"
	_g_object_unref0 (page_setup);
#line 473 "../src/Printing.vala"
	_g_object_unref0 (job);
#line 3841 "Printing.c"
}

static void
_print_manager_on_custom_widget_apply_gtk_print_operation_custom_widget_apply (GtkPrintOperation* _sender,
                                                                               GtkWidget* widget,
                                                                               gpointer self)
{
#line 574 "../src/Printing.vala"
	print_manager_on_custom_widget_apply ((PrintManager*) self, widget);
#line 3851 "Printing.c"
}

static GObject*
print_manager_on_create_custom_widget (PrintManager* self,
                                       GtkPrintOperation* emitting_object)
{
	CustomPrintTab* _tmp0_;
	CustomPrintTab* _tmp1_;
	GObject* result;
#line 572 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 572 "../src/Printing.vala"
	g_return_val_if_fail (emitting_object != NULL, NULL);
#line 573 "../src/Printing.vala"
	_tmp0_ = custom_print_tab_new (G_TYPE_CHECK_INSTANCE_CAST (emitting_object, TYPE_PRINT_JOB, PrintJob));
#line 573 "../src/Printing.vala"
	g_object_ref_sink (_tmp0_);
#line 573 "../src/Printing.vala"
	_g_object_unref0 (self->priv->custom_tab);
#line 573 "../src/Printing.vala"
	self->priv->custom_tab = _tmp0_;
#line 574 "../src/Printing.vala"
	g_signal_connect ((GtkPrintOperation*) G_TYPE_CHECK_INSTANCE_CAST (emitting_object, TYPE_PRINT_JOB, PrintJob), "custom-widget-apply", (GCallback) _print_manager_on_custom_widget_apply_gtk_print_operation_custom_widget_apply, self);
#line 575 "../src/Printing.vala"
	_tmp1_ = self->priv->custom_tab;
#line 575 "../src/Printing.vala"
	result = (GObject*) _tmp1_;
#line 575 "../src/Printing.vala"
	return result;
#line 3881 "Printing.c"
}

static void
print_manager_on_custom_widget_apply (PrintManager* self,
                                      GtkWidget* custom_widget)
{
	CustomPrintTab* tab = NULL;
	CustomPrintTab* _tmp0_;
	PrintJob* _tmp1_;
	PrintJob* _tmp2_;
	PrintSettings* _tmp3_;
	PrintSettings* _tmp4_;
	PrintSettings* _tmp5_;
	PrintSettings* _tmp6_;
#line 578 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/Printing.vala"
	g_return_if_fail (custom_widget != NULL);
#line 579 "../src/Printing.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (custom_widget, TYPE_CUSTOM_PRINT_TAB, CustomPrintTab));
#line 579 "../src/Printing.vala"
	tab = _tmp0_;
#line 580 "../src/Printing.vala"
	_tmp1_ = custom_print_tab_get_source_job (tab);
#line 580 "../src/Printing.vala"
	_tmp2_ = _tmp1_;
#line 580 "../src/Printing.vala"
	_tmp3_ = custom_print_tab_get_local_settings (tab);
#line 580 "../src/Printing.vala"
	_tmp4_ = _tmp3_;
#line 580 "../src/Printing.vala"
	print_job_set_local_settings (_tmp2_, _tmp4_);
#line 580 "../src/Printing.vala"
	_print_settings_unref0 (_tmp4_);
#line 581 "../src/Printing.vala"
	_tmp5_ = custom_print_tab_get_local_settings (tab);
#line 581 "../src/Printing.vala"
	_tmp6_ = _tmp5_;
#line 581 "../src/Printing.vala"
	print_manager_set_global_settings (self, _tmp6_);
#line 581 "../src/Printing.vala"
	_print_settings_unref0 (_tmp6_);
#line 578 "../src/Printing.vala"
	_g_object_unref0 (tab);
#line 3926 "Printing.c"
}

static void
print_manager_fit_image_to_canvas (PrintManager* self,
                                   Photo* photo,
                                   gdouble x,
                                   gdouble y,
                                   gdouble canvas_width,
                                   gdouble canvas_height,
                                   gboolean crop,
                                   PrintJob* job,
                                   GtkPrintContext* job_context)
{
	cairo_t* dc = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	Dimensions photo_dimensions = {0};
	Dimensions _tmp2_ = {0};
	gdouble photo_aspect_ratio = 0.0;
	gdouble canvas_aspect_ratio = 0.0;
	gdouble target_width = 0.0;
	gdouble target_height = 0.0;
	gdouble dpi = 0.0;
	PrintSettings* _tmp3_;
	PrintSettings* _tmp4_;
	gdouble _tmp5_;
	gdouble x_offset = 0.0;
	gdouble y_offset = 0.0;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	gint w = 0;
	gint h = 0;
	Dimensions viewport = {0};
	cairo_t* _tmp40_;
	GError* _inner_error0_ = NULL;
#line 584 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 584 "../src/Printing.vala"
	g_return_if_fail (photo != NULL);
#line 584 "../src/Printing.vala"
	g_return_if_fail (job != NULL);
#line 584 "../src/Printing.vala"
	g_return_if_fail (job_context != NULL);
#line 585 "../src/Printing.vala"
	_tmp0_ = gtk_print_context_get_cairo_context (job_context);
#line 585 "../src/Printing.vala"
	_tmp1_ = _cairo_reference0 (_tmp0_);
#line 585 "../src/Printing.vala"
	dc = _tmp1_;
#line 586 "../src/Printing.vala"
	media_source_get_dimensions ((MediaSource*) photo, PHOTO_EXCEPTION_NONE, &_tmp2_);
#line 586 "../src/Printing.vala"
	photo_dimensions = _tmp2_;
#line 587 "../src/Printing.vala"
	photo_aspect_ratio = dimensions_get_aspect_ratio (&photo_dimensions);
#line 588 "../src/Printing.vala"
	canvas_aspect_ratio = ((gdouble) canvas_width) / canvas_height;
#line 590 "../src/Printing.vala"
	target_width = 0.0;
#line 591 "../src/Printing.vala"
	target_height = 0.0;
#line 592 "../src/Printing.vala"
	_tmp3_ = print_job_get_local_settings (job);
#line 592 "../src/Printing.vala"
	_tmp4_ = _tmp3_;
#line 592 "../src/Printing.vala"
	_tmp5_ = (gdouble) print_settings_get_content_ppi (_tmp4_);
#line 592 "../src/Printing.vala"
	_print_settings_unref0 (_tmp4_);
#line 592 "../src/Printing.vala"
	dpi = _tmp5_;
#line 594 "../src/Printing.vala"
	if (!crop) {
#line 595 "../src/Printing.vala"
		if (canvas_aspect_ratio < photo_aspect_ratio) {
#line 596 "../src/Printing.vala"
			target_width = canvas_width;
#line 597 "../src/Printing.vala"
			target_height = target_width * (1.0 / photo_aspect_ratio);
#line 4006 "Printing.c"
		} else {
#line 599 "../src/Printing.vala"
			target_height = canvas_height;
#line 600 "../src/Printing.vala"
			target_width = target_height * photo_aspect_ratio;
#line 4012 "Printing.c"
		}
#line 602 "../src/Printing.vala"
		x = x + ((canvas_width - target_width) / 2.0);
#line 603 "../src/Printing.vala"
		y = y + ((canvas_height - target_height) / 2.0);
#line 4018 "Printing.c"
	}
#line 606 "../src/Printing.vala"
	x_offset = dpi * x;
#line 607 "../src/Printing.vala"
	y_offset = dpi * y;
#line 608 "../src/Printing.vala"
	_tmp6_ = dc;
#line 608 "../src/Printing.vala"
	cairo_save (_tmp6_);
#line 609 "../src/Printing.vala"
	_tmp7_ = dc;
#line 609 "../src/Printing.vala"
	cairo_translate (_tmp7_, x_offset, y_offset);
#line 611 "../src/Printing.vala"
	w = (gint) (dpi * canvas_width);
#line 612 "../src/Printing.vala"
	h = (gint) (dpi * canvas_height);
#line 613 "../src/Printing.vala"
	dimensions_init (&viewport, w, h);
#line 4038 "Printing.c"
	{
		gboolean _tmp8_ = FALSE;
		cairo_t* _tmp35_;
#line 616 "../src/Printing.vala"
		if (crop) {
#line 616 "../src/Printing.vala"
			_tmp8_ = !print_manager_are_approximately_equal (self, canvas_aspect_ratio, photo_aspect_ratio);
#line 4046 "Printing.c"
		} else {
#line 616 "../src/Printing.vala"
			_tmp8_ = FALSE;
#line 4050 "Printing.c"
		}
#line 616 "../src/Printing.vala"
		if (_tmp8_) {
#line 4054 "Printing.c"
			Scaling pixbuf_scaling = {0};
			Dimensions _tmp9_;
			Scaling _tmp10_ = {0};
			GdkPixbuf* photo_pixbuf = NULL;
			Scaling _tmp11_;
			GdkPixbuf* _tmp12_;
			Dimensions scaled_photo_dimensions = {0};
			GdkPixbuf* _tmp13_;
			Dimensions _tmp14_ = {0};
			gint shave_vertical = 0;
			gint shave_horizontal = 0;
			GdkPixbuf* shaved_pixbuf = NULL;
			GdkPixbuf* _tmp19_;
			Dimensions _tmp20_;
			Dimensions _tmp21_;
			GdkPixbuf* _tmp22_;
			GdkPixbuf* _tmp23_;
			GdkPixbuf* _tmp24_;
			cairo_t* _tmp25_;
			GdkPixbuf* _tmp26_;
#line 617 "../src/Printing.vala"
			_tmp9_ = viewport;
#line 617 "../src/Printing.vala"
			scaling_to_fill_viewport (&_tmp9_, &_tmp10_);
#line 617 "../src/Printing.vala"
			pixbuf_scaling = _tmp10_;
#line 618 "../src/Printing.vala"
			_tmp11_ = pixbuf_scaling;
#line 618 "../src/Printing.vala"
			_tmp12_ = photo_source_get_pixbuf ((PhotoSource*) photo, &_tmp11_, &_inner_error0_);
#line 618 "../src/Printing.vala"
			photo_pixbuf = _tmp12_;
#line 618 "../src/Printing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4089 "Printing.c"
				goto __catch0_g_error;
			}
#line 619 "../src/Printing.vala"
			_tmp13_ = photo_pixbuf;
#line 619 "../src/Printing.vala"
			dimensions_for_pixbuf (_tmp13_, &_tmp14_);
#line 619 "../src/Printing.vala"
			scaled_photo_dimensions = _tmp14_;
#line 620 "../src/Printing.vala"
			shave_vertical = 0;
#line 621 "../src/Printing.vala"
			shave_horizontal = 0;
#line 622 "../src/Printing.vala"
			if (canvas_aspect_ratio < photo_aspect_ratio) {
#line 4104 "Printing.c"
				Dimensions _tmp15_;
				Dimensions _tmp16_;
#line 623 "../src/Printing.vala"
				_tmp15_ = scaled_photo_dimensions;
#line 623 "../src/Printing.vala"
				_tmp16_ = scaled_photo_dimensions;
#line 623 "../src/Printing.vala"
				shave_vertical = (gint) ((_tmp15_.width - (_tmp16_.height * canvas_aspect_ratio)) / 2.0);
#line 4113 "Printing.c"
			} else {
				Dimensions _tmp17_;
				Dimensions _tmp18_;
#line 625 "../src/Printing.vala"
				_tmp17_ = scaled_photo_dimensions;
#line 625 "../src/Printing.vala"
				_tmp18_ = scaled_photo_dimensions;
#line 625 "../src/Printing.vala"
				shave_horizontal = (gint) ((_tmp17_.height - (_tmp18_.width * (1.0 / canvas_aspect_ratio))) / 2.0);
#line 4123 "Printing.c"
			}
#line 627 "../src/Printing.vala"
			_tmp19_ = photo_pixbuf;
#line 627 "../src/Printing.vala"
			_tmp20_ = scaled_photo_dimensions;
#line 627 "../src/Printing.vala"
			_tmp21_ = scaled_photo_dimensions;
#line 627 "../src/Printing.vala"
			_tmp22_ = gdk_pixbuf_new_subpixbuf (_tmp19_, shave_vertical, shave_horizontal, _tmp20_.width - (2 * shave_vertical), _tmp21_.height - (2 * shave_horizontal));
#line 627 "../src/Printing.vala"
			shaved_pixbuf = _tmp22_;
#line 629 "../src/Printing.vala"
			_tmp23_ = shaved_pixbuf;
#line 629 "../src/Printing.vala"
			_tmp24_ = scaling_perform_on_pixbuf (&pixbuf_scaling, _tmp23_, GDK_INTERP_HYPER, TRUE);
#line 629 "../src/Printing.vala"
			_g_object_unref0 (photo_pixbuf);
#line 629 "../src/Printing.vala"
			photo_pixbuf = _tmp24_;
#line 630 "../src/Printing.vala"
			_tmp25_ = dc;
#line 630 "../src/Printing.vala"
			_tmp26_ = photo_pixbuf;
#line 630 "../src/Printing.vala"
			gdk_cairo_set_source_pixbuf (_tmp25_, _tmp26_, 0.0, 0.0);
#line 616 "../src/Printing.vala"
			_g_object_unref0 (shaved_pixbuf);
#line 616 "../src/Printing.vala"
			_g_object_unref0 (photo_pixbuf);
#line 4153 "Printing.c"
		} else {
			Scaling pixbuf_scaling = {0};
			Dimensions _tmp27_;
			Scaling _tmp28_ = {0};
			GdkPixbuf* photo_pixbuf = NULL;
			Scaling _tmp29_;
			GdkPixbuf* _tmp30_;
			GdkPixbuf* _tmp31_;
			GdkPixbuf* _tmp32_;
			cairo_t* _tmp33_;
			GdkPixbuf* _tmp34_;
#line 632 "../src/Printing.vala"
			_tmp27_ = viewport;
#line 632 "../src/Printing.vala"
			scaling_for_viewport (&_tmp27_, TRUE, &_tmp28_);
#line 632 "../src/Printing.vala"
			pixbuf_scaling = _tmp28_;
#line 633 "../src/Printing.vala"
			_tmp29_ = pixbuf_scaling;
#line 633 "../src/Printing.vala"
			_tmp30_ = photo_source_get_pixbuf ((PhotoSource*) photo, &_tmp29_, &_inner_error0_);
#line 633 "../src/Printing.vala"
			photo_pixbuf = _tmp30_;
#line 633 "../src/Printing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4179 "Printing.c"
				goto __catch0_g_error;
			}
#line 634 "../src/Printing.vala"
			_tmp31_ = photo_pixbuf;
#line 634 "../src/Printing.vala"
			_tmp32_ = scaling_perform_on_pixbuf (&pixbuf_scaling, _tmp31_, GDK_INTERP_HYPER, TRUE);
#line 634 "../src/Printing.vala"
			_g_object_unref0 (photo_pixbuf);
#line 634 "../src/Printing.vala"
			photo_pixbuf = _tmp32_;
#line 635 "../src/Printing.vala"
			_tmp33_ = dc;
#line 635 "../src/Printing.vala"
			_tmp34_ = photo_pixbuf;
#line 635 "../src/Printing.vala"
			gdk_cairo_set_source_pixbuf (_tmp33_, _tmp34_, 0.0, 0.0);
#line 616 "../src/Printing.vala"
			_g_object_unref0 (photo_pixbuf);
#line 4198 "Printing.c"
		}
#line 637 "../src/Printing.vala"
		_tmp35_ = dc;
#line 637 "../src/Printing.vala"
		cairo_paint (_tmp35_);
#line 4204 "Printing.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
#line 615 "../src/Printing.vala"
		e = _inner_error0_;
#line 615 "../src/Printing.vala"
		_inner_error0_ = NULL;
#line 640 "../src/Printing.vala"
		gtk_print_operation_cancel ((GtkPrintOperation*) job);
#line 641 "../src/Printing.vala"
		_tmp36_ = e;
#line 641 "../src/Printing.vala"
		_tmp37_ = _tmp36_->message;
#line 641 "../src/Printing.vala"
		_tmp38_ = g_strdup_printf (_ ("Unable to print photo:\n\n%s"), _tmp37_);
#line 641 "../src/Printing.vala"
		_tmp39_ = _tmp38_;
#line 641 "../src/Printing.vala"
		app_window_error_message (_tmp39_, NULL, NULL);
#line 641 "../src/Printing.vala"
		_g_free0 (_tmp39_);
#line 615 "../src/Printing.vala"
		_g_error_free0 (e);
#line 4234 "Printing.c"
	}
	__finally0:
#line 615 "../src/Printing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 615 "../src/Printing.vala"
		_cairo_destroy0 (dc);
#line 615 "../src/Printing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 615 "../src/Printing.vala"
		g_clear_error (&_inner_error0_);
#line 615 "../src/Printing.vala"
		return;
#line 4247 "Printing.c"
	}
#line 643 "../src/Printing.vala"
	_tmp40_ = dc;
#line 643 "../src/Printing.vala"
	cairo_restore (_tmp40_);
#line 584 "../src/Printing.vala"
	_cairo_destroy0 (dc);
#line 4255 "Printing.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 646 "../src/Printing.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 4263 "Printing.c"
}

static void
print_manager_add_title_to_canvas (PrintManager* self,
                                   gdouble x,
                                   gdouble y,
                                   const gchar* title,
                                   PrintJob* job,
                                   GtkPrintContext* job_context)
{
	cairo_t* dc = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble dpi = 0.0;
	PrintSettings* _tmp2_;
	PrintSettings* _tmp3_;
	gdouble _tmp4_;
	PangoFontDescription* title_font_description = NULL;
	PrintSettings* _tmp5_;
	PrintSettings* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	PangoFontDescription* _tmp9_;
	PangoFontDescription* _tmp10_;
	PangoLayout* title_layout = NULL;
	PangoLayout* _tmp11_;
	PangoContext* context = NULL;
	PangoContext* _tmp12_;
	PangoContext* _tmp13_;
	gint title_width = 0;
	gint title_height = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
#line 646 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/Printing.vala"
	g_return_if_fail (title != NULL);
#line 646 "../src/Printing.vala"
	g_return_if_fail (job != NULL);
#line 646 "../src/Printing.vala"
	g_return_if_fail (job_context != NULL);
#line 647 "../src/Printing.vala"
	_tmp0_ = gtk_print_context_get_cairo_context (job_context);
#line 647 "../src/Printing.vala"
	_tmp1_ = _cairo_reference0 (_tmp0_);
#line 647 "../src/Printing.vala"
	dc = _tmp1_;
#line 648 "../src/Printing.vala"
	_tmp2_ = print_job_get_local_settings (job);
#line 648 "../src/Printing.vala"
	_tmp3_ = _tmp2_;
#line 648 "../src/Printing.vala"
	_tmp4_ = (gdouble) print_settings_get_content_ppi (_tmp3_);
#line 648 "../src/Printing.vala"
	_print_settings_unref0 (_tmp3_);
#line 648 "../src/Printing.vala"
	dpi = _tmp4_;
#line 649 "../src/Printing.vala"
	_tmp5_ = print_job_get_local_settings (job);
#line 649 "../src/Printing.vala"
	_tmp6_ = _tmp5_;
#line 649 "../src/Printing.vala"
	_tmp7_ = print_settings_get_print_titles_font (_tmp6_);
#line 649 "../src/Printing.vala"
	_tmp8_ = _tmp7_;
#line 649 "../src/Printing.vala"
	_tmp9_ = pango_font_description_from_string (_tmp8_);
#line 649 "../src/Printing.vala"
	_tmp10_ = _tmp9_;
#line 649 "../src/Printing.vala"
	_g_free0 (_tmp8_);
#line 649 "../src/Printing.vala"
	_print_settings_unref0 (_tmp6_);
#line 649 "../src/Printing.vala"
	title_font_description = _tmp10_;
#line 650 "../src/Printing.vala"
	_tmp11_ = pango_cairo_create_layout (dc);
#line 650 "../src/Printing.vala"
	title_layout = _tmp11_;
#line 651 "../src/Printing.vala"
	_tmp12_ = pango_layout_get_context (title_layout);
#line 651 "../src/Printing.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 651 "../src/Printing.vala"
	context = _tmp13_;
#line 652 "../src/Printing.vala"
	pango_cairo_context_set_resolution (context, dpi);
#line 653 "../src/Printing.vala"
	pango_layout_set_font_description (title_layout, title_font_description);
#line 654 "../src/Printing.vala"
	pango_layout_set_text (title_layout, title, -1);
#line 656 "../src/Printing.vala"
	pango_layout_get_pixel_size (title_layout, &_tmp14_, &_tmp15_);
#line 656 "../src/Printing.vala"
	title_width = _tmp14_;
#line 656 "../src/Printing.vala"
	title_height = _tmp15_;
#line 657 "../src/Printing.vala"
	tx = (dpi * x) - (title_width / 2);
#line 658 "../src/Printing.vala"
	ty = (dpi * y) - title_height;
#line 661 "../src/Printing.vala"
	cairo_rectangle (dc, tx - 10, ty + 2, (gdouble) (title_width + 20), (gdouble) title_height);
#line 662 "../src/Printing.vala"
	cairo_set_source_rgba (dc, (gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 663 "../src/Printing.vala"
	cairo_set_line_width (dc, (gdouble) 2);
#line 664 "../src/Printing.vala"
	cairo_stroke_preserve (dc);
#line 665 "../src/Printing.vala"
	cairo_set_source_rgba (dc, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.5);
#line 666 "../src/Printing.vala"
	cairo_fill (dc);
#line 667 "../src/Printing.vala"
	cairo_set_source_rgba (dc, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 1);
#line 669 "../src/Printing.vala"
	cairo_move_to (dc, tx, ty + 2);
#line 670 "../src/Printing.vala"
	pango_cairo_show_layout (dc, title_layout);
#line 646 "../src/Printing.vala"
	_g_object_unref0 (context);
#line 646 "../src/Printing.vala"
	_g_object_unref0 (title_layout);
#line 646 "../src/Printing.vala"
	__vala_PangoFontDescription_free0 (title_font_description);
#line 646 "../src/Printing.vala"
	_cairo_destroy0 (dc);
#line 4393 "Printing.c"
}

static gboolean
print_manager_are_approximately_equal (PrintManager* self,
                                       gdouble val1,
                                       gdouble val2)
{
	gdouble accept_err = 0.0;
	gboolean result;
#line 673 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 674 "../src/Printing.vala"
	accept_err = 0.005;
#line 675 "../src/Printing.vala"
	result = fabs (val1 - val2) <= accept_err;
#line 675 "../src/Printing.vala"
	return result;
#line 4411 "Printing.c"
}

PrintSettings*
print_manager_get_global_settings (PrintManager* self)
{
	PrintSettings* _tmp0_;
	PrintSettings* _tmp1_;
	PrintSettings* result;
#line 678 "../src/Printing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 679 "../src/Printing.vala"
	_tmp0_ = self->priv->settings;
#line 679 "../src/Printing.vala"
	_tmp1_ = _print_settings_ref0 (_tmp0_);
#line 679 "../src/Printing.vala"
	result = _tmp1_;
#line 679 "../src/Printing.vala"
	return result;
#line 4430 "Printing.c"
}

void
print_manager_set_global_settings (PrintManager* self,
                                   PrintSettings* settings)
{
	PrintSettings* _tmp0_;
#line 682 "../src/Printing.vala"
	g_return_if_fail (self != NULL);
#line 682 "../src/Printing.vala"
	g_return_if_fail (settings != NULL);
#line 683 "../src/Printing.vala"
	_tmp0_ = _print_settings_ref0 (settings);
#line 683 "../src/Printing.vala"
	_print_settings_unref0 (self->priv->settings);
#line 683 "../src/Printing.vala"
	self->priv->settings = _tmp0_;
#line 684 "../src/Printing.vala"
	print_settings_save (settings);
#line 4450 "Printing.c"
}

static void
value_print_manager_init (GValue* value)
{
#line 328 "../src/Printing.vala"
	value->data[0].v_pointer = NULL;
#line 4458 "Printing.c"
}

static void
value_print_manager_free_value (GValue* value)
{
#line 328 "../src/Printing.vala"
	if (value->data[0].v_pointer) {
#line 328 "../src/Printing.vala"
		print_manager_unref (value->data[0].v_pointer);
#line 4468 "Printing.c"
	}
}

static void
value_print_manager_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 328 "../src/Printing.vala"
	if (src_value->data[0].v_pointer) {
#line 328 "../src/Printing.vala"
		dest_value->data[0].v_pointer = print_manager_ref (src_value->data[0].v_pointer);
#line 4480 "Printing.c"
	} else {
#line 328 "../src/Printing.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4484 "Printing.c"
	}
}

static gpointer
value_print_manager_peek_pointer (const GValue* value)
{
#line 328 "../src/Printing.vala"
	return value->data[0].v_pointer;
#line 4493 "Printing.c"
}

static gchar*
value_print_manager_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 328 "../src/Printing.vala"
	if (collect_values[0].v_pointer) {
#line 4504 "Printing.c"
		PrintManager * object;
		object = collect_values[0].v_pointer;
#line 328 "../src/Printing.vala"
		if (object->parent_instance.g_class == NULL) {
#line 328 "../src/Printing.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4511 "Printing.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 328 "../src/Printing.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4515 "Printing.c"
		}
#line 328 "../src/Printing.vala"
		value->data[0].v_pointer = print_manager_ref (object);
#line 4519 "Printing.c"
	} else {
#line 328 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 4523 "Printing.c"
	}
#line 328 "../src/Printing.vala"
	return NULL;
#line 4527 "Printing.c"
}

static gchar*
value_print_manager_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	PrintManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 328 "../src/Printing.vala"
	if (!object_p) {
#line 328 "../src/Printing.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4542 "Printing.c"
	}
#line 328 "../src/Printing.vala"
	if (!value->data[0].v_pointer) {
#line 328 "../src/Printing.vala"
		*object_p = NULL;
#line 4548 "Printing.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 328 "../src/Printing.vala"
		*object_p = value->data[0].v_pointer;
#line 4552 "Printing.c"
	} else {
#line 328 "../src/Printing.vala"
		*object_p = print_manager_ref (value->data[0].v_pointer);
#line 4556 "Printing.c"
	}
#line 328 "../src/Printing.vala"
	return NULL;
#line 4560 "Printing.c"
}

GParamSpec*
param_spec_print_manager (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecPrintManager* spec;
#line 328 "../src/Printing.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PRINT_MANAGER), NULL);
#line 328 "../src/Printing.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 328 "../src/Printing.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 328 "../src/Printing.vala"
	return G_PARAM_SPEC (spec);
#line 4579 "Printing.c"
}

gpointer
value_get_print_manager (const GValue* value)
{
#line 328 "../src/Printing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PRINT_MANAGER), NULL);
#line 328 "../src/Printing.vala"
	return value->data[0].v_pointer;
#line 4589 "Printing.c"
}

void
value_set_print_manager (GValue* value,
                         gpointer v_object)
{
	PrintManager * old;
#line 328 "../src/Printing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PRINT_MANAGER));
#line 328 "../src/Printing.vala"
	old = value->data[0].v_pointer;
#line 328 "../src/Printing.vala"
	if (v_object) {
#line 328 "../src/Printing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PRINT_MANAGER));
#line 328 "../src/Printing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 328 "../src/Printing.vala"
		value->data[0].v_pointer = v_object;
#line 328 "../src/Printing.vala"
		print_manager_ref (value->data[0].v_pointer);
#line 4611 "Printing.c"
	} else {
#line 328 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 4615 "Printing.c"
	}
#line 328 "../src/Printing.vala"
	if (old) {
#line 328 "../src/Printing.vala"
		print_manager_unref (old);
#line 4621 "Printing.c"
	}
}

void
value_take_print_manager (GValue* value,
                          gpointer v_object)
{
	PrintManager * old;
#line 328 "../src/Printing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PRINT_MANAGER));
#line 328 "../src/Printing.vala"
	old = value->data[0].v_pointer;
#line 328 "../src/Printing.vala"
	if (v_object) {
#line 328 "../src/Printing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PRINT_MANAGER));
#line 328 "../src/Printing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 328 "../src/Printing.vala"
		value->data[0].v_pointer = v_object;
#line 4642 "Printing.c"
	} else {
#line 328 "../src/Printing.vala"
		value->data[0].v_pointer = NULL;
#line 4646 "Printing.c"
	}
#line 328 "../src/Printing.vala"
	if (old) {
#line 328 "../src/Printing.vala"
		print_manager_unref (old);
#line 4652 "Printing.c"
	}
}

static void
print_manager_class_init (PrintManagerClass * klass,
                          gpointer klass_data)
{
#line 328 "../src/Printing.vala"
	print_manager_parent_class = g_type_class_peek_parent (klass);
#line 328 "../src/Printing.vala"
	((PrintManagerClass *) klass)->finalize = print_manager_finalize;
#line 328 "../src/Printing.vala"
	g_type_class_adjust_private_offset (klass, &PrintManager_private_offset);
#line 4666 "Printing.c"
}

static void
print_manager_instance_init (PrintManager * self,
                             gpointer klass)
{
#line 328 "../src/Printing.vala"
	self->priv = print_manager_get_instance_private (self);
#line 336 "../src/Printing.vala"
	self->priv->progress_dialog = NULL;
#line 337 "../src/Printing.vala"
	self->priv->cancellable = NULL;
#line 328 "../src/Printing.vala"
	self->ref_count = 1;
#line 4681 "Printing.c"
}

static void
print_manager_finalize (PrintManager * obj)
{
	PrintManager * self;
#line 328 "../src/Printing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PRINT_MANAGER, PrintManager);
#line 328 "../src/Printing.vala"
	g_signal_handlers_destroy (self);
#line 333 "../src/Printing.vala"
	_print_settings_unref0 (self->priv->settings);
#line 334 "../src/Printing.vala"
	_g_object_unref0 (self->priv->user_page_setup);
#line 335 "../src/Printing.vala"
	_g_object_unref0 (self->priv->custom_tab);
#line 336 "../src/Printing.vala"
	_g_object_unref0 (self->priv->progress_dialog);
#line 337 "../src/Printing.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 4702 "Printing.c"
}

static GType
print_manager_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_print_manager_init, value_print_manager_free_value, value_print_manager_copy_value, value_print_manager_peek_pointer, "p", value_print_manager_collect_value, "p", value_print_manager_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PrintManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) print_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintManager), 0, (GInstanceInitFunc) print_manager_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType print_manager_type_id;
	print_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PrintManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PrintManager_private_offset = g_type_add_instance_private (print_manager_type_id, sizeof (PrintManagerPrivate));
	return print_manager_type_id;
}

GType
print_manager_get_type (void)
{
	static volatile gsize print_manager_type_id__once = 0;
	if (g_once_init_enter (&print_manager_type_id__once)) {
		GType print_manager_type_id;
		print_manager_type_id = print_manager_get_type_once ();
		g_once_init_leave (&print_manager_type_id__once, print_manager_type_id);
	}
	return print_manager_type_id__once;
}

gpointer
print_manager_ref (gpointer instance)
{
	PrintManager * self;
	self = instance;
#line 328 "../src/Printing.vala"
	g_atomic_int_inc (&self->ref_count);
#line 328 "../src/Printing.vala"
	return instance;
#line 4738 "Printing.c"
}

void
print_manager_unref (gpointer instance)
{
	PrintManager * self;
	self = instance;
#line 328 "../src/Printing.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 328 "../src/Printing.vala"
		PRINT_MANAGER_GET_CLASS (self)->finalize (self);
#line 328 "../src/Printing.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4752 "Printing.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

