/* SearchFilter.c generated by valac 0.56.18, the Vala compiler
 * generated from SearchFilter.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Bitfield values used to specify which search bar features we want.*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecTextAction ParamSpecTextAction;
enum  {
	TEXT_ACTION_TEXT_CHANGED_SIGNAL,
	TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL,
	TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL,
	TEXT_ACTION_NUM_SIGNALS
};
static guint text_action_signals[TEXT_ACTION_NUM_SIGNALS] = {0};
enum  {
	SEARCH_FILTER_ENTRY_0_PROPERTY,
	SEARCH_FILTER_ENTRY_NUM_PROPERTIES
};
static GParamSpec* search_filter_entry_properties[SEARCH_FILTER_ENTRY_NUM_PROPERTIES];
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SearchViewFilterPrivate {
	gboolean _flagged;
	gboolean _show_media_video;
	gboolean _show_media_photos;
	gboolean _show_media_raw;
	gchar* search_filter;
	gchar** search_filter_words;
	gint search_filter_words_length1;
	gint _search_filter_words_size_;
};

struct _TextActionPrivate {
	gchar* text;
	gboolean sensitive;
	gboolean visible;
};

struct _ParamSpecTextAction {
	GParamSpec parent_instance;
};

struct _SearchFilterEntryPrivate {
	SearchViewFilter* search_filter;
};

static gint SearchViewFilter_private_offset;
static gpointer search_view_filter_parent_class = NULL;
static gpointer default_search_view_filter_parent_class = NULL;
static gpointer disabled_view_filter_parent_class = NULL;
static gint TextAction_private_offset;
static gpointer text_action_parent_class = NULL;
static gint SearchFilterEntry_private_offset;
static gpointer search_filter_entry_parent_class = NULL;

static guint search_view_filter_real_get_criteria (SearchViewFilter* self);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
static void search_view_filter_finalize (ViewFilter * obj);
static GType search_view_filter_get_type_once (void);
static gboolean default_search_view_filter_real_predicate (ViewFilter* base,
                                                    DataView* view);
static GType default_search_view_filter_get_type_once (void);
static gboolean disabled_view_filter_real_predicate (ViewFilter* base,
                                              DataView* view);
static guint disabled_view_filter_real_get_criteria (SearchViewFilter* base);
static GType disabled_view_filter_get_type_once (void);
static void text_action_finalize (TextAction * obj);
static GType text_action_get_type_once (void);
static void __lambda54_ (SearchFilterEntry* self);
static void search_filter_entry_on_search_text_changed (SearchFilterEntry* self);
static void ___lambda54__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                   gpointer self);
static gboolean search_filter_entry_on_escape_key (SearchFilterEntry* self,
                                            GdkEventKey* e);
static gboolean _search_filter_entry_on_escape_key_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                        GdkEventKey* event,
                                                                        gpointer self);
static void search_filter_entry_finalize (GObject * obj);
static GType search_filter_entry_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static GType
search_filter_criteria_get_type_once (void)
{
	static const GFlagsValue values[] = {{SEARCH_FILTER_CRITERIA_NONE, "SEARCH_FILTER_CRITERIA_NONE", "none"}, {SEARCH_FILTER_CRITERIA_RECURSIVE, "SEARCH_FILTER_CRITERIA_RECURSIVE", "recursive"}, {SEARCH_FILTER_CRITERIA_TEXT, "SEARCH_FILTER_CRITERIA_TEXT", "text"}, {SEARCH_FILTER_CRITERIA_FLAG, "SEARCH_FILTER_CRITERIA_FLAG", "flag"}, {SEARCH_FILTER_CRITERIA_MEDIA, "SEARCH_FILTER_CRITERIA_MEDIA", "media"}, {SEARCH_FILTER_CRITERIA_ALL, "SEARCH_FILTER_CRITERIA_ALL", "all"}, {0, NULL, NULL}};
	GType search_filter_criteria_type_id;
	search_filter_criteria_type_id = g_flags_register_static ("SearchFilterCriteria", values);
	return search_filter_criteria_type_id;
}

GType
search_filter_criteria_get_type (void)
{
	static volatile gsize search_filter_criteria_type_id__once = 0;
	if (g_once_init_enter (&search_filter_criteria_type_id__once)) {
		GType search_filter_criteria_type_id;
		search_filter_criteria_type_id = search_filter_criteria_get_type_once ();
		g_once_init_leave (&search_filter_criteria_type_id__once, search_filter_criteria_type_id);
	}
	return search_filter_criteria_type_id__once;
}

static inline gpointer
search_view_filter_get_instance_private (SearchViewFilter* self)
{
	return G_STRUCT_MEMBER_P (self, SearchViewFilter_private_offset);
}

static guint
search_view_filter_real_get_criteria (SearchViewFilter* self)
{
	guint _tmp0_ = 0U;
#line 65 "../src/SearchFilter.vala"
	g_critical ("Type `%s' does not implement abstract method `search_view_filter_get_criteria'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 65 "../src/SearchFilter.vala"
	return _tmp0_;
#line 168 "SearchFilter.c"
}

guint
search_view_filter_get_criteria (SearchViewFilter* self)
{
	SearchViewFilterClass* _klass_;
#line 65 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 65 "../src/SearchFilter.vala"
	_klass_ = SEARCH_VIEW_FILTER_GET_CLASS (self);
#line 65 "../src/SearchFilter.vala"
	if (_klass_->get_criteria) {
#line 65 "../src/SearchFilter.vala"
		return _klass_->get_criteria (self);
#line 183 "SearchFilter.c"
	}
#line 65 "../src/SearchFilter.vala"
	return 0U;
#line 187 "SearchFilter.c"
}

gboolean
search_view_filter_has_search_filter (SearchViewFilter* self)
{
	const gchar* _tmp0_;
	gboolean result;
#line 68 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter;
#line 69 "../src/SearchFilter.vala"
	result = !is_string_empty (_tmp0_);
#line 69 "../src/SearchFilter.vala"
	return result;
#line 203 "SearchFilter.c"
}

const gchar*
search_view_filter_get_search_filter (SearchViewFilter* self)
{
	const gchar* _tmp0_;
	const gchar* result;
#line 72 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter;
#line 73 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 73 "../src/SearchFilter.vala"
	return result;
#line 219 "SearchFilter.c"
}

gchar**
search_view_filter_get_search_filter_words (SearchViewFilter* self,
                                            gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** result;
#line 76 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter_words;
#line 77 "../src/SearchFilter.vala"
	_tmp0__length1 = self->priv->search_filter_words_length1;
#line 77 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 77 "../src/SearchFilter.vala"
	_tmp1__length1 = _tmp0__length1;
#line 77 "../src/SearchFilter.vala"
	if (result_length1) {
#line 77 "../src/SearchFilter.vala"
		*result_length1 = _tmp1__length1;
#line 245 "SearchFilter.c"
	}
#line 77 "../src/SearchFilter.vala"
	result = _tmp1_;
#line 77 "../src/SearchFilter.vala"
	return result;
#line 251 "SearchFilter.c"
}

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
#line 82 "../src/SearchFilter.vala"
	if (length >= 0) {
#line 260 "SearchFilter.c"
		gchar** result;
		gssize i;
#line 82 "../src/SearchFilter.vala"
		result = g_new0 (gchar*, length + 1);
#line 82 "../src/SearchFilter.vala"
		for (i = 0; i < length; i++) {
#line 267 "SearchFilter.c"
			gchar* _tmp0_;
#line 82 "../src/SearchFilter.vala"
			_tmp0_ = g_strdup (self[i]);
#line 82 "../src/SearchFilter.vala"
			result[i] = _tmp0_;
#line 273 "SearchFilter.c"
		}
#line 82 "../src/SearchFilter.vala"
		return result;
#line 277 "SearchFilter.c"
	}
#line 82 "../src/SearchFilter.vala"
	return NULL;
#line 281 "SearchFilter.c"
}

void
search_view_filter_set_search_filter (SearchViewFilter* self,
                                      const gchar* text)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp2_;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gint __tmp3__size_ = 0;
	const gchar* _tmp4_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 80 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/SearchFilter.vala"
	if (!is_string_empty (text)) {
#line 300 "SearchFilter.c"
		gchar* _tmp1_;
#line 81 "../src/SearchFilter.vala"
		_tmp1_ = g_utf8_strdown (text, (gssize) -1);
#line 81 "../src/SearchFilter.vala"
		_g_free0 (_tmp0_);
#line 81 "../src/SearchFilter.vala"
		_tmp0_ = _tmp1_;
#line 308 "SearchFilter.c"
	} else {
#line 81 "../src/SearchFilter.vala"
		_g_free0 (_tmp0_);
#line 81 "../src/SearchFilter.vala"
		_tmp0_ = NULL;
#line 314 "SearchFilter.c"
	}
#line 81 "../src/SearchFilter.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 81 "../src/SearchFilter.vala"
	_g_free0 (self->priv->search_filter);
#line 81 "../src/SearchFilter.vala"
	self->priv->search_filter = _tmp2_;
#line 82 "../src/SearchFilter.vala"
	_tmp4_ = self->priv->search_filter;
#line 82 "../src/SearchFilter.vala"
	if (_tmp4_ != NULL) {
#line 326 "SearchFilter.c"
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
#line 82 "../src/SearchFilter.vala"
		_tmp5_ = self->priv->search_filter;
#line 82 "../src/SearchFilter.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, " ", 0);
#line 82 "../src/SearchFilter.vala"
		_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 82 "../src/SearchFilter.vala"
		_tmp3_ = _tmp7_;
#line 82 "../src/SearchFilter.vala"
		_tmp3__length1 = _vala_array_length (_tmp6_);
#line 82 "../src/SearchFilter.vala"
		__tmp3__size_ = _tmp3__length1;
#line 342 "SearchFilter.c"
	} else {
#line 82 "../src/SearchFilter.vala"
		_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 82 "../src/SearchFilter.vala"
		_tmp3_ = NULL;
#line 82 "../src/SearchFilter.vala"
		_tmp3__length1 = 0;
#line 82 "../src/SearchFilter.vala"
		__tmp3__size_ = _tmp3__length1;
#line 352 "SearchFilter.c"
	}
#line 82 "../src/SearchFilter.vala"
	_tmp8_ = (_tmp3_ != NULL) ? _vala_array_dup5 (_tmp3_, _tmp3__length1) : _tmp3_;
#line 82 "../src/SearchFilter.vala"
	_tmp8__length1 = _tmp3__length1;
#line 82 "../src/SearchFilter.vala"
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
#line 82 "../src/SearchFilter.vala"
	self->priv->search_filter_words = _tmp8_;
#line 82 "../src/SearchFilter.vala"
	self->priv->search_filter_words_length1 = _tmp8__length1;
#line 82 "../src/SearchFilter.vala"
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
#line 80 "../src/SearchFilter.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 80 "../src/SearchFilter.vala"
	_g_free0 (_tmp0_);
#line 370 "SearchFilter.c"
}

void
search_view_filter_clear_search_filter (SearchViewFilter* self)
{
#line 85 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/SearchFilter.vala"
	_g_free0 (self->priv->search_filter);
#line 86 "../src/SearchFilter.vala"
	self->priv->search_filter = NULL;
#line 87 "../src/SearchFilter.vala"
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
#line 87 "../src/SearchFilter.vala"
	self->priv->search_filter_words = NULL;
#line 87 "../src/SearchFilter.vala"
	self->priv->search_filter_words_length1 = 0;
#line 87 "../src/SearchFilter.vala"
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
#line 390 "SearchFilter.c"
}

gboolean
search_view_filter_filter_by_media_type (SearchViewFilter* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean result;
#line 90 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "../src/SearchFilter.vala"
	_tmp3_ = self->priv->_show_media_video;
#line 91 "../src/SearchFilter.vala"
	if (_tmp3_) {
#line 91 "../src/SearchFilter.vala"
		_tmp2_ = TRUE;
#line 409 "SearchFilter.c"
	} else {
		gboolean _tmp4_;
#line 91 "../src/SearchFilter.vala"
		_tmp4_ = self->priv->_show_media_photos;
#line 91 "../src/SearchFilter.vala"
		_tmp2_ = _tmp4_;
#line 416 "SearchFilter.c"
	}
#line 91 "../src/SearchFilter.vala"
	if (_tmp2_) {
#line 91 "../src/SearchFilter.vala"
		_tmp1_ = TRUE;
#line 422 "SearchFilter.c"
	} else {
		gboolean _tmp5_;
#line 91 "../src/SearchFilter.vala"
		_tmp5_ = self->priv->_show_media_raw;
#line 91 "../src/SearchFilter.vala"
		_tmp1_ = _tmp5_;
#line 429 "SearchFilter.c"
	}
#line 91 "../src/SearchFilter.vala"
	if (_tmp1_) {
#line 433 "SearchFilter.c"
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
#line 92 "../src/SearchFilter.vala"
		_tmp8_ = self->priv->_show_media_video;
#line 92 "../src/SearchFilter.vala"
		if (_tmp8_) {
#line 441 "SearchFilter.c"
			gboolean _tmp9_;
#line 92 "../src/SearchFilter.vala"
			_tmp9_ = self->priv->_show_media_photos;
#line 92 "../src/SearchFilter.vala"
			_tmp7_ = _tmp9_;
#line 447 "SearchFilter.c"
		} else {
#line 92 "../src/SearchFilter.vala"
			_tmp7_ = FALSE;
#line 451 "SearchFilter.c"
		}
#line 92 "../src/SearchFilter.vala"
		if (_tmp7_) {
#line 455 "SearchFilter.c"
			gboolean _tmp10_;
#line 92 "../src/SearchFilter.vala"
			_tmp10_ = self->priv->_show_media_raw;
#line 92 "../src/SearchFilter.vala"
			_tmp6_ = _tmp10_;
#line 461 "SearchFilter.c"
		} else {
#line 92 "../src/SearchFilter.vala"
			_tmp6_ = FALSE;
#line 465 "SearchFilter.c"
		}
#line 92 "../src/SearchFilter.vala"
		_tmp0_ = !_tmp6_;
#line 469 "SearchFilter.c"
	} else {
#line 91 "../src/SearchFilter.vala"
		_tmp0_ = FALSE;
#line 473 "SearchFilter.c"
	}
#line 91 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 91 "../src/SearchFilter.vala"
	return result;
#line 479 "SearchFilter.c"
}

SearchViewFilter*
search_view_filter_construct (GType object_type)
{
	SearchViewFilter* self = NULL;
#line 32 "../src/SearchFilter.vala"
	self = (SearchViewFilter*) view_filter_construct (object_type);
#line 32 "../src/SearchFilter.vala"
	return self;
#line 490 "SearchFilter.c"
}

gboolean
search_view_filter_get_flagged (SearchViewFilter* self)
{
	gboolean result;
#line 36 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/SearchFilter.vala"
	result = self->priv->_flagged;
#line 36 "../src/SearchFilter.vala"
	return result;
#line 503 "SearchFilter.c"
}

void
search_view_filter_set_flagged (SearchViewFilter* self,
                                gboolean value)
{
#line 37 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/SearchFilter.vala"
	self->priv->_flagged = value;
#line 514 "SearchFilter.c"
}

gboolean
search_view_filter_get_show_media_video (SearchViewFilter* self)
{
	gboolean result;
#line 43 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/SearchFilter.vala"
	result = self->priv->_show_media_video;
#line 43 "../src/SearchFilter.vala"
	return result;
#line 527 "SearchFilter.c"
}

void
search_view_filter_set_show_media_video (SearchViewFilter* self,
                                         gboolean value)
{
#line 44 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/SearchFilter.vala"
	self->priv->_show_media_video = value;
#line 538 "SearchFilter.c"
}

gboolean
search_view_filter_get_show_media_photos (SearchViewFilter* self)
{
	gboolean result;
#line 48 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/SearchFilter.vala"
	result = self->priv->_show_media_photos;
#line 48 "../src/SearchFilter.vala"
	return result;
#line 551 "SearchFilter.c"
}

void
search_view_filter_set_show_media_photos (SearchViewFilter* self,
                                          gboolean value)
{
#line 49 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/SearchFilter.vala"
	self->priv->_show_media_photos = value;
#line 562 "SearchFilter.c"
}

gboolean
search_view_filter_get_show_media_raw (SearchViewFilter* self)
{
	gboolean result;
#line 53 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 53 "../src/SearchFilter.vala"
	result = self->priv->_show_media_raw;
#line 53 "../src/SearchFilter.vala"
	return result;
#line 575 "SearchFilter.c"
}

void
search_view_filter_set_show_media_raw (SearchViewFilter* self,
                                       gboolean value)
{
#line 54 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/SearchFilter.vala"
	self->priv->_show_media_raw = value;
#line 586 "SearchFilter.c"
}

static void
search_view_filter_class_init (SearchViewFilterClass * klass,
                               gpointer klass_data)
{
#line 32 "../src/SearchFilter.vala"
	search_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/SearchFilter.vala"
	((ViewFilterClass *) klass)->finalize = search_view_filter_finalize;
#line 32 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchViewFilter_private_offset);
#line 32 "../src/SearchFilter.vala"
	((SearchViewFilterClass *) klass)->get_criteria = (guint (*) (SearchViewFilter*)) search_view_filter_real_get_criteria;
#line 601 "SearchFilter.c"
}

static void
search_view_filter_instance_init (SearchViewFilter * self,
                                  gpointer klass)
{
#line 32 "../src/SearchFilter.vala"
	self->priv = search_view_filter_get_instance_private (self);
#line 35 "../src/SearchFilter.vala"
	self->priv->_flagged = FALSE;
#line 42 "../src/SearchFilter.vala"
	self->priv->_show_media_video = TRUE;
#line 47 "../src/SearchFilter.vala"
	self->priv->_show_media_photos = TRUE;
#line 52 "../src/SearchFilter.vala"
	self->priv->_show_media_raw = TRUE;
#line 59 "../src/SearchFilter.vala"
	self->priv->search_filter = NULL;
#line 60 "../src/SearchFilter.vala"
	self->priv->search_filter_words = NULL;
#line 60 "../src/SearchFilter.vala"
	self->priv->search_filter_words_length1 = 0;
#line 60 "../src/SearchFilter.vala"
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
#line 626 "SearchFilter.c"
}

static void
search_view_filter_finalize (ViewFilter * obj)
{
	SearchViewFilter * self;
#line 32 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter);
#line 59 "../src/SearchFilter.vala"
	_g_free0 (self->priv->search_filter);
#line 60 "../src/SearchFilter.vala"
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
#line 32 "../src/SearchFilter.vala"
	VIEW_FILTER_CLASS (search_view_filter_parent_class)->finalize (obj);
#line 641 "SearchFilter.c"
}

static GType
search_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchViewFilter), 0, (GInstanceInitFunc) search_view_filter_instance_init, NULL };
	GType search_view_filter_type_id;
	search_view_filter_type_id = g_type_register_static (TYPE_VIEW_FILTER, "SearchViewFilter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SearchViewFilter_private_offset = g_type_add_instance_private (search_view_filter_type_id, sizeof (SearchViewFilterPrivate));
	return search_view_filter_type_id;
}

GType
search_view_filter_get_type (void)
{
	static volatile gsize search_view_filter_type_id__once = 0;
	if (g_once_init_enter (&search_view_filter_type_id__once)) {
		GType search_view_filter_type_id;
		search_view_filter_type_id = search_view_filter_get_type_once ();
		g_once_init_leave (&search_view_filter_type_id__once, search_view_filter_type_id);
	}
	return search_view_filter_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 115 "../src/SearchFilter.vala"
	return self ? g_object_ref (self) : NULL;
#line 671 "SearchFilter.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 690 "SearchFilter.c"
}

static gboolean
default_search_view_filter_real_predicate (ViewFilter* base,
                                           DataView* view)
{
	DefaultSearchViewFilter * self;
	MediaSource* source = NULL;
	MediaSource* _tmp0_;
	guint criteria = 0U;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean result;
#line 99 "../src/SearchFilter.vala"
	self = (DefaultSearchViewFilter*) base;
#line 99 "../src/SearchFilter.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 100 "../src/SearchFilter.vala"
	_tmp0_ = thumbnail_get_media_source (G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_THUMBNAIL, Thumbnail));
#line 100 "../src/SearchFilter.vala"
	source = _tmp0_;
#line 101 "../src/SearchFilter.vala"
	criteria = search_view_filter_get_criteria ((SearchViewFilter*) self);
#line 104 "../src/SearchFilter.vala"
	if ((SEARCH_FILTER_CRITERIA_FLAG & criteria) != 0) {
#line 716 "SearchFilter.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 105 "../src/SearchFilter.vala"
		_tmp3_ = search_view_filter_get_flagged ((SearchViewFilter*) self);
#line 105 "../src/SearchFilter.vala"
		_tmp4_ = _tmp3_;
#line 105 "../src/SearchFilter.vala"
		if (_tmp4_) {
#line 727 "SearchFilter.c"
			MediaSource* _tmp5_;
#line 105 "../src/SearchFilter.vala"
			_tmp5_ = source;
#line 105 "../src/SearchFilter.vala"
			_tmp2_ = IS_FLAGGABLE (_tmp5_);
#line 733 "SearchFilter.c"
		} else {
#line 105 "../src/SearchFilter.vala"
			_tmp2_ = FALSE;
#line 737 "SearchFilter.c"
		}
#line 105 "../src/SearchFilter.vala"
		if (_tmp2_) {
#line 741 "SearchFilter.c"
			MediaSource* _tmp6_;
#line 105 "../src/SearchFilter.vala"
			_tmp6_ = source;
#line 105 "../src/SearchFilter.vala"
			_tmp1_ = !flaggable_is_flagged (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_FLAGGABLE, Flaggable));
#line 747 "SearchFilter.c"
		} else {
#line 105 "../src/SearchFilter.vala"
			_tmp1_ = FALSE;
#line 751 "SearchFilter.c"
		}
#line 105 "../src/SearchFilter.vala"
		if (_tmp1_) {
#line 106 "../src/SearchFilter.vala"
			result = FALSE;
#line 106 "../src/SearchFilter.vala"
			_g_object_unref0 (source);
#line 106 "../src/SearchFilter.vala"
			return result;
#line 761 "SearchFilter.c"
		}
	}
#line 110 "../src/SearchFilter.vala"
	if ((SEARCH_FILTER_CRITERIA_MEDIA & criteria) != 0) {
#line 110 "../src/SearchFilter.vala"
		_tmp7_ = search_view_filter_filter_by_media_type ((SearchViewFilter*) self);
#line 768 "SearchFilter.c"
	} else {
#line 110 "../src/SearchFilter.vala"
		_tmp7_ = FALSE;
#line 772 "SearchFilter.c"
	}
#line 110 "../src/SearchFilter.vala"
	if (_tmp7_) {
#line 776 "SearchFilter.c"
		MediaSource* _tmp8_;
#line 111 "../src/SearchFilter.vala"
		_tmp8_ = source;
#line 111 "../src/SearchFilter.vala"
		if (IS_VIDEO_SOURCE (_tmp8_)) {
#line 782 "SearchFilter.c"
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 112 "../src/SearchFilter.vala"
			_tmp9_ = search_view_filter_get_show_media_video ((SearchViewFilter*) self);
#line 112 "../src/SearchFilter.vala"
			_tmp10_ = _tmp9_;
#line 112 "../src/SearchFilter.vala"
			if (!_tmp10_) {
#line 113 "../src/SearchFilter.vala"
				result = FALSE;
#line 113 "../src/SearchFilter.vala"
				_g_object_unref0 (source);
#line 113 "../src/SearchFilter.vala"
				return result;
#line 797 "SearchFilter.c"
			}
		} else {
			MediaSource* _tmp11_;
#line 114 "../src/SearchFilter.vala"
			_tmp11_ = source;
#line 114 "../src/SearchFilter.vala"
			if (IS_PHOTO (_tmp11_)) {
#line 805 "SearchFilter.c"
				Photo* photo = NULL;
				MediaSource* _tmp12_;
				Photo* _tmp13_;
				Photo* _tmp14_;
#line 115 "../src/SearchFilter.vala"
				_tmp12_ = source;
#line 115 "../src/SearchFilter.vala"
				_tmp13_ = _g_object_ref0 (IS_PHOTO (_tmp12_) ? ((Photo*) _tmp12_) : NULL);
#line 115 "../src/SearchFilter.vala"
				photo = _tmp13_;
#line 116 "../src/SearchFilter.vala"
				_tmp14_ = photo;
#line 116 "../src/SearchFilter.vala"
				if (photo_get_master_file_format (_tmp14_) == PHOTO_FILE_FORMAT_RAW) {
#line 820 "SearchFilter.c"
					Photo* _tmp15_;
#line 117 "../src/SearchFilter.vala"
					_tmp15_ = photo;
#line 117 "../src/SearchFilter.vala"
					if (photo_is_raw_developer_available (_tmp15_, RAW_DEVELOPER_CAMERA)) {
#line 826 "SearchFilter.c"
						gboolean _tmp16_ = FALSE;
						gboolean _tmp17_;
						gboolean _tmp18_;
#line 118 "../src/SearchFilter.vala"
						_tmp17_ = search_view_filter_get_show_media_photos ((SearchViewFilter*) self);
#line 118 "../src/SearchFilter.vala"
						_tmp18_ = _tmp17_;
#line 118 "../src/SearchFilter.vala"
						if (!_tmp18_) {
#line 836 "SearchFilter.c"
							gboolean _tmp19_;
							gboolean _tmp20_;
#line 118 "../src/SearchFilter.vala"
							_tmp19_ = search_view_filter_get_show_media_raw ((SearchViewFilter*) self);
#line 118 "../src/SearchFilter.vala"
							_tmp20_ = _tmp19_;
#line 118 "../src/SearchFilter.vala"
							_tmp16_ = !_tmp20_;
#line 845 "SearchFilter.c"
						} else {
#line 118 "../src/SearchFilter.vala"
							_tmp16_ = FALSE;
#line 849 "SearchFilter.c"
						}
#line 118 "../src/SearchFilter.vala"
						if (_tmp16_) {
#line 119 "../src/SearchFilter.vala"
							result = FALSE;
#line 119 "../src/SearchFilter.vala"
							_g_object_unref0 (photo);
#line 119 "../src/SearchFilter.vala"
							_g_object_unref0 (source);
#line 119 "../src/SearchFilter.vala"
							return result;
#line 861 "SearchFilter.c"
						}
					} else {
						gboolean _tmp21_;
						gboolean _tmp22_;
#line 120 "../src/SearchFilter.vala"
						_tmp21_ = search_view_filter_get_show_media_raw ((SearchViewFilter*) self);
#line 120 "../src/SearchFilter.vala"
						_tmp22_ = _tmp21_;
#line 120 "../src/SearchFilter.vala"
						if (!_tmp22_) {
#line 121 "../src/SearchFilter.vala"
							result = FALSE;
#line 121 "../src/SearchFilter.vala"
							_g_object_unref0 (photo);
#line 121 "../src/SearchFilter.vala"
							_g_object_unref0 (source);
#line 121 "../src/SearchFilter.vala"
							return result;
#line 880 "SearchFilter.c"
						}
					}
				} else {
					gboolean _tmp23_;
					gboolean _tmp24_;
#line 123 "../src/SearchFilter.vala"
					_tmp23_ = search_view_filter_get_show_media_photos ((SearchViewFilter*) self);
#line 123 "../src/SearchFilter.vala"
					_tmp24_ = _tmp23_;
#line 123 "../src/SearchFilter.vala"
					if (!_tmp24_) {
#line 124 "../src/SearchFilter.vala"
						result = FALSE;
#line 124 "../src/SearchFilter.vala"
						_g_object_unref0 (photo);
#line 124 "../src/SearchFilter.vala"
						_g_object_unref0 (source);
#line 124 "../src/SearchFilter.vala"
						return result;
#line 900 "SearchFilter.c"
					}
				}
#line 114 "../src/SearchFilter.vala"
				_g_object_unref0 (photo);
#line 905 "SearchFilter.c"
			}
		}
	}
#line 128 "../src/SearchFilter.vala"
	if ((SEARCH_FILTER_CRITERIA_TEXT & criteria) != 0) {
#line 128 "../src/SearchFilter.vala"
		_tmp25_ = search_view_filter_has_search_filter ((SearchViewFilter*) self);
#line 913 "SearchFilter.c"
	} else {
#line 128 "../src/SearchFilter.vala"
		_tmp25_ = FALSE;
#line 917 "SearchFilter.c"
	}
#line 128 "../src/SearchFilter.vala"
	if (_tmp25_) {
#line 921 "SearchFilter.c"
		const gchar* media_keywords = NULL;
		MediaSource* _tmp26_;
		const gchar* _tmp27_;
		const gchar* event_keywords = NULL;
		Event* event = NULL;
		MediaSource* _tmp28_;
		Event* _tmp29_;
		Event* _tmp30_;
		GeeList* tags = NULL;
		TagSourceCollection* _tmp33_;
		MediaSource* _tmp34_;
		GeeList* _tmp35_;
		gint _tmp36_ = 0;
		GeeList* _tmp37_;
		gint tags_size = 0;
		gint _tmp41_ = 0;
		gchar** _tmp42_;
#line 129 "../src/SearchFilter.vala"
		_tmp26_ = source;
#line 129 "../src/SearchFilter.vala"
		_tmp27_ = indexable_get_indexable_keywords ((Indexable*) _tmp26_);
#line 129 "../src/SearchFilter.vala"
		media_keywords = _tmp27_;
#line 131 "../src/SearchFilter.vala"
		event_keywords = NULL;
#line 132 "../src/SearchFilter.vala"
		_tmp28_ = source;
#line 132 "../src/SearchFilter.vala"
		_tmp29_ = media_source_get_event (_tmp28_);
#line 132 "../src/SearchFilter.vala"
		event = _tmp29_;
#line 133 "../src/SearchFilter.vala"
		_tmp30_ = event;
#line 133 "../src/SearchFilter.vala"
		if (_tmp30_ != NULL) {
#line 957 "SearchFilter.c"
			Event* _tmp31_;
			const gchar* _tmp32_;
#line 134 "../src/SearchFilter.vala"
			_tmp31_ = event;
#line 134 "../src/SearchFilter.vala"
			_tmp32_ = indexable_get_indexable_keywords ((Indexable*) _tmp31_);
#line 134 "../src/SearchFilter.vala"
			event_keywords = _tmp32_;
#line 966 "SearchFilter.c"
		}
#line 136 "../src/SearchFilter.vala"
		_tmp33_ = tag_global;
#line 136 "../src/SearchFilter.vala"
		_tmp34_ = source;
#line 136 "../src/SearchFilter.vala"
		_tmp35_ = tag_source_collection_fetch_for_source (_tmp33_, _tmp34_);
#line 136 "../src/SearchFilter.vala"
		tags = _tmp35_;
#line 137 "../src/SearchFilter.vala"
		_tmp37_ = tags;
#line 137 "../src/SearchFilter.vala"
		if (_tmp37_ != NULL) {
#line 980 "SearchFilter.c"
			GeeList* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
#line 137 "../src/SearchFilter.vala"
			_tmp38_ = tags;
#line 137 "../src/SearchFilter.vala"
			_tmp39_ = gee_collection_get_size ((GeeCollection*) _tmp38_);
#line 137 "../src/SearchFilter.vala"
			_tmp40_ = _tmp39_;
#line 137 "../src/SearchFilter.vala"
			_tmp36_ = _tmp40_;
#line 992 "SearchFilter.c"
		} else {
#line 137 "../src/SearchFilter.vala"
			_tmp36_ = 0;
#line 996 "SearchFilter.c"
		}
#line 137 "../src/SearchFilter.vala"
		tags_size = _tmp36_;
#line 139 "../src/SearchFilter.vala"
		_tmp42_ = search_view_filter_get_search_filter_words ((SearchViewFilter*) self, &_tmp41_);
#line 1002 "SearchFilter.c"
		{
			gchar** word_collection = NULL;
			gint word_collection_length1 = 0;
			gint _word_collection_size_ = 0;
			gint word_it = 0;
#line 139 "../src/SearchFilter.vala"
			word_collection = _tmp42_;
#line 139 "../src/SearchFilter.vala"
			word_collection_length1 = _tmp41_;
#line 139 "../src/SearchFilter.vala"
			for (word_it = 0; word_it < word_collection_length1; word_it = word_it + 1) {
#line 1014 "SearchFilter.c"
				const gchar* word = NULL;
#line 139 "../src/SearchFilter.vala"
				word = word_collection[word_it];
#line 1018 "SearchFilter.c"
				{
					gboolean _tmp43_ = FALSE;
					const gchar* _tmp44_;
					gboolean _tmp47_ = FALSE;
					const gchar* _tmp48_;
#line 140 "../src/SearchFilter.vala"
					_tmp44_ = media_keywords;
#line 140 "../src/SearchFilter.vala"
					if (_tmp44_ != NULL) {
#line 1028 "SearchFilter.c"
						const gchar* _tmp45_;
						const gchar* _tmp46_;
#line 140 "../src/SearchFilter.vala"
						_tmp45_ = media_keywords;
#line 140 "../src/SearchFilter.vala"
						_tmp46_ = word;
#line 140 "../src/SearchFilter.vala"
						_tmp43_ = string_contains (_tmp45_, _tmp46_);
#line 1037 "SearchFilter.c"
					} else {
#line 140 "../src/SearchFilter.vala"
						_tmp43_ = FALSE;
#line 1041 "SearchFilter.c"
					}
#line 140 "../src/SearchFilter.vala"
					if (_tmp43_) {
#line 141 "../src/SearchFilter.vala"
						continue;
#line 1047 "SearchFilter.c"
					}
#line 143 "../src/SearchFilter.vala"
					_tmp48_ = event_keywords;
#line 143 "../src/SearchFilter.vala"
					if (_tmp48_ != NULL) {
#line 1053 "SearchFilter.c"
						const gchar* _tmp49_;
						const gchar* _tmp50_;
#line 143 "../src/SearchFilter.vala"
						_tmp49_ = event_keywords;
#line 143 "../src/SearchFilter.vala"
						_tmp50_ = word;
#line 143 "../src/SearchFilter.vala"
						_tmp47_ = string_contains (_tmp49_, _tmp50_);
#line 1062 "SearchFilter.c"
					} else {
#line 143 "../src/SearchFilter.vala"
						_tmp47_ = FALSE;
#line 1066 "SearchFilter.c"
					}
#line 143 "../src/SearchFilter.vala"
					if (_tmp47_) {
#line 144 "../src/SearchFilter.vala"
						continue;
#line 1072 "SearchFilter.c"
					}
#line 146 "../src/SearchFilter.vala"
					if (tags_size > 0) {
#line 1076 "SearchFilter.c"
						gboolean found = FALSE;
#line 147 "../src/SearchFilter.vala"
						found = FALSE;
#line 1080 "SearchFilter.c"
						{
							gint ctr = 0;
#line 148 "../src/SearchFilter.vala"
							ctr = 0;
#line 1085 "SearchFilter.c"
							{
								gboolean _tmp51_ = FALSE;
#line 148 "../src/SearchFilter.vala"
								_tmp51_ = TRUE;
#line 148 "../src/SearchFilter.vala"
								while (TRUE) {
#line 1092 "SearchFilter.c"
									const gchar* tag_keywords = NULL;
									GeeList* _tmp53_;
									gpointer _tmp54_;
									Tag* _tmp55_;
									const gchar* _tmp56_;
									const gchar* _tmp57_;
									gboolean _tmp58_ = FALSE;
									const gchar* _tmp59_;
#line 148 "../src/SearchFilter.vala"
									if (!_tmp51_) {
#line 1103 "SearchFilter.c"
										gint _tmp52_;
#line 148 "../src/SearchFilter.vala"
										_tmp52_ = ctr;
#line 148 "../src/SearchFilter.vala"
										ctr = _tmp52_ + 1;
#line 1109 "SearchFilter.c"
									}
#line 148 "../src/SearchFilter.vala"
									_tmp51_ = FALSE;
#line 148 "../src/SearchFilter.vala"
									if (!(ctr < tags_size)) {
#line 148 "../src/SearchFilter.vala"
										break;
#line 1117 "SearchFilter.c"
									}
#line 149 "../src/SearchFilter.vala"
									_tmp53_ = tags;
#line 149 "../src/SearchFilter.vala"
									_tmp54_ = gee_list_get (_tmp53_, ctr);
#line 149 "../src/SearchFilter.vala"
									_tmp55_ = (Tag*) _tmp54_;
#line 149 "../src/SearchFilter.vala"
									_tmp56_ = indexable_get_indexable_keywords ((Indexable*) _tmp55_);
#line 149 "../src/SearchFilter.vala"
									_tmp57_ = _tmp56_;
#line 149 "../src/SearchFilter.vala"
									_g_object_unref0 (_tmp55_);
#line 149 "../src/SearchFilter.vala"
									tag_keywords = _tmp57_;
#line 150 "../src/SearchFilter.vala"
									_tmp59_ = tag_keywords;
#line 150 "../src/SearchFilter.vala"
									if (_tmp59_ != NULL) {
#line 1137 "SearchFilter.c"
										const gchar* _tmp60_;
										const gchar* _tmp61_;
#line 150 "../src/SearchFilter.vala"
										_tmp60_ = tag_keywords;
#line 150 "../src/SearchFilter.vala"
										_tmp61_ = word;
#line 150 "../src/SearchFilter.vala"
										_tmp58_ = string_contains (_tmp60_, _tmp61_);
#line 1146 "SearchFilter.c"
									} else {
#line 150 "../src/SearchFilter.vala"
										_tmp58_ = FALSE;
#line 1150 "SearchFilter.c"
									}
#line 150 "../src/SearchFilter.vala"
									if (_tmp58_) {
#line 151 "../src/SearchFilter.vala"
										found = TRUE;
#line 153 "../src/SearchFilter.vala"
										break;
#line 1158 "SearchFilter.c"
									}
								}
							}
						}
#line 157 "../src/SearchFilter.vala"
						if (found) {
#line 158 "../src/SearchFilter.vala"
							continue;
#line 1167 "SearchFilter.c"
						}
					}
#line 163 "../src/SearchFilter.vala"
					result = FALSE;
#line 163 "../src/SearchFilter.vala"
					_g_object_unref0 (tags);
#line 163 "../src/SearchFilter.vala"
					_g_object_unref0 (event);
#line 163 "../src/SearchFilter.vala"
					_g_object_unref0 (source);
#line 163 "../src/SearchFilter.vala"
					return result;
#line 1180 "SearchFilter.c"
				}
			}
		}
#line 128 "../src/SearchFilter.vala"
		_g_object_unref0 (tags);
#line 128 "../src/SearchFilter.vala"
		_g_object_unref0 (event);
#line 1188 "SearchFilter.c"
	}
#line 167 "../src/SearchFilter.vala"
	result = TRUE;
#line 167 "../src/SearchFilter.vala"
	_g_object_unref0 (source);
#line 167 "../src/SearchFilter.vala"
	return result;
#line 1196 "SearchFilter.c"
}

DefaultSearchViewFilter*
default_search_view_filter_construct (GType object_type)
{
	DefaultSearchViewFilter* self = NULL;
#line 98 "../src/SearchFilter.vala"
	self = (DefaultSearchViewFilter*) search_view_filter_construct (object_type);
#line 98 "../src/SearchFilter.vala"
	return self;
#line 1207 "SearchFilter.c"
}

static void
default_search_view_filter_class_init (DefaultSearchViewFilterClass * klass,
                                       gpointer klass_data)
{
#line 98 "../src/SearchFilter.vala"
	default_search_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 98 "../src/SearchFilter.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) default_search_view_filter_real_predicate;
#line 1218 "SearchFilter.c"
}

static void
default_search_view_filter_instance_init (DefaultSearchViewFilter * self,
                                          gpointer klass)
{
}

static GType
default_search_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DefaultSearchViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) default_search_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DefaultSearchViewFilter), 0, (GInstanceInitFunc) default_search_view_filter_instance_init, NULL };
	GType default_search_view_filter_type_id;
	default_search_view_filter_type_id = g_type_register_static (TYPE_SEARCH_VIEW_FILTER, "DefaultSearchViewFilter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return default_search_view_filter_type_id;
}

GType
default_search_view_filter_get_type (void)
{
	static volatile gsize default_search_view_filter_type_id__once = 0;
	if (g_once_init_enter (&default_search_view_filter_type_id__once)) {
		GType default_search_view_filter_type_id;
		default_search_view_filter_type_id = default_search_view_filter_get_type_once ();
		g_once_init_leave (&default_search_view_filter_type_id__once, default_search_view_filter_type_id);
	}
	return default_search_view_filter_type_id__once;
}

static gboolean
disabled_view_filter_real_predicate (ViewFilter* base,
                                     DataView* view)
{
	DisabledViewFilter * self;
	gboolean result;
#line 172 "../src/SearchFilter.vala"
	self = (DisabledViewFilter*) base;
#line 172 "../src/SearchFilter.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 173 "../src/SearchFilter.vala"
	result = TRUE;
#line 173 "../src/SearchFilter.vala"
	return result;
#line 1262 "SearchFilter.c"
}

static guint
disabled_view_filter_real_get_criteria (SearchViewFilter* base)
{
	DisabledViewFilter * self;
	guint result;
#line 176 "../src/SearchFilter.vala"
	self = (DisabledViewFilter*) base;
#line 177 "../src/SearchFilter.vala"
	result = (guint) SEARCH_FILTER_CRITERIA_NONE;
#line 177 "../src/SearchFilter.vala"
	return result;
#line 1276 "SearchFilter.c"
}

DisabledViewFilter*
disabled_view_filter_construct (GType object_type)
{
	DisabledViewFilter* self = NULL;
#line 171 "../src/SearchFilter.vala"
	self = (DisabledViewFilter*) search_view_filter_construct (object_type);
#line 171 "../src/SearchFilter.vala"
	return self;
#line 1287 "SearchFilter.c"
}

DisabledViewFilter*
disabled_view_filter_new (void)
{
#line 171 "../src/SearchFilter.vala"
	return disabled_view_filter_construct (TYPE_DISABLED_VIEW_FILTER);
#line 1295 "SearchFilter.c"
}

static void
disabled_view_filter_class_init (DisabledViewFilterClass * klass,
                                 gpointer klass_data)
{
#line 171 "../src/SearchFilter.vala"
	disabled_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 171 "../src/SearchFilter.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) disabled_view_filter_real_predicate;
#line 171 "../src/SearchFilter.vala"
	((SearchViewFilterClass *) klass)->get_criteria = (guint (*) (SearchViewFilter*)) disabled_view_filter_real_get_criteria;
#line 1308 "SearchFilter.c"
}

static void
disabled_view_filter_instance_init (DisabledViewFilter * self,
                                    gpointer klass)
{
}

static GType
disabled_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisabledViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) disabled_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisabledViewFilter), 0, (GInstanceInitFunc) disabled_view_filter_instance_init, NULL };
	GType disabled_view_filter_type_id;
	disabled_view_filter_type_id = g_type_register_static (TYPE_SEARCH_VIEW_FILTER, "DisabledViewFilter", &g_define_type_info, 0);
	return disabled_view_filter_type_id;
}

GType
disabled_view_filter_get_type (void)
{
	static volatile gsize disabled_view_filter_type_id__once = 0;
	if (g_once_init_enter (&disabled_view_filter_type_id__once)) {
		GType disabled_view_filter_type_id;
		disabled_view_filter_type_id = disabled_view_filter_get_type_once ();
		g_once_init_leave (&disabled_view_filter_type_id__once, disabled_view_filter_type_id);
	}
	return disabled_view_filter_type_id__once;
}

static inline gpointer
text_action_get_instance_private (TextAction* self)
{
	return G_STRUCT_MEMBER_P (self, TextAction_private_offset);
}

TextAction*
text_action_construct (GType object_type,
                       const gchar* init)
{
	TextAction* self = NULL;
	gchar* _tmp0_;
#line 198 "../src/SearchFilter.vala"
	self = (TextAction*) g_type_create_instance (object_type);
#line 199 "../src/SearchFilter.vala"
	_tmp0_ = g_strdup (init);
#line 199 "../src/SearchFilter.vala"
	_g_free0 (self->priv->text);
#line 199 "../src/SearchFilter.vala"
	self->priv->text = _tmp0_;
#line 198 "../src/SearchFilter.vala"
	return self;
#line 1360 "SearchFilter.c"
}

TextAction*
text_action_new (const gchar* init)
{
#line 198 "../src/SearchFilter.vala"
	return text_action_construct (TYPE_TEXT_ACTION, init);
#line 1368 "SearchFilter.c"
}

void
text_action_set_text (TextAction* self,
                      const gchar* text)
{
	const gchar* _tmp0_;
#line 202 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->text;
#line 203 "../src/SearchFilter.vala"
	if (g_strcmp0 (_tmp0_, text) != 0) {
#line 1382 "SearchFilter.c"
		gchar* _tmp1_;
#line 204 "../src/SearchFilter.vala"
		_tmp1_ = g_strdup (text);
#line 204 "../src/SearchFilter.vala"
		_g_free0 (self->priv->text);
#line 204 "../src/SearchFilter.vala"
		self->priv->text = _tmp1_;
#line 205 "../src/SearchFilter.vala"
		g_signal_emit (self, text_action_signals[TEXT_ACTION_TEXT_CHANGED_SIGNAL], 0, text);
#line 1392 "SearchFilter.c"
	}
}

void
text_action_clear (TextAction* self)
{
#line 209 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/SearchFilter.vala"
	text_action_set_text (self, NULL);
#line 1403 "SearchFilter.c"
}

gboolean
text_action_is_sensitive (TextAction* self)
{
	gboolean result;
#line 213 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 214 "../src/SearchFilter.vala"
	result = self->priv->sensitive;
#line 214 "../src/SearchFilter.vala"
	return result;
#line 1416 "SearchFilter.c"
}

void
text_action_set_sensitive (TextAction* self,
                           gboolean sensitive)
{
#line 217 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/SearchFilter.vala"
	if (self->priv->sensitive != sensitive) {
#line 219 "../src/SearchFilter.vala"
		self->priv->sensitive = sensitive;
#line 220 "../src/SearchFilter.vala"
		g_signal_emit (self, text_action_signals[TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL], 0, sensitive);
#line 1431 "SearchFilter.c"
	}
}

gboolean
text_action_is_visible (TextAction* self)
{
	gboolean result;
#line 224 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 225 "../src/SearchFilter.vala"
	result = self->priv->visible;
#line 225 "../src/SearchFilter.vala"
	return result;
#line 1445 "SearchFilter.c"
}

void
text_action_set_visible (TextAction* self,
                         gboolean visible)
{
#line 228 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/SearchFilter.vala"
	if (self->priv->visible != visible) {
#line 230 "../src/SearchFilter.vala"
		self->priv->visible = visible;
#line 231 "../src/SearchFilter.vala"
		g_signal_emit (self, text_action_signals[TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL], 0, visible);
#line 1460 "SearchFilter.c"
	}
}

const gchar*
text_action_get_value (TextAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 183 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 184 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->text;
#line 184 "../src/SearchFilter.vala"
	result = _tmp0_;
#line 184 "../src/SearchFilter.vala"
	return result;
#line 1477 "SearchFilter.c"
}

static void
value_text_action_init (GValue* value)
{
#line 181 "../src/SearchFilter.vala"
	value->data[0].v_pointer = NULL;
#line 1485 "SearchFilter.c"
}

static void
value_text_action_free_value (GValue* value)
{
#line 181 "../src/SearchFilter.vala"
	if (value->data[0].v_pointer) {
#line 181 "../src/SearchFilter.vala"
		text_action_unref (value->data[0].v_pointer);
#line 1495 "SearchFilter.c"
	}
}

static void
value_text_action_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 181 "../src/SearchFilter.vala"
	if (src_value->data[0].v_pointer) {
#line 181 "../src/SearchFilter.vala"
		dest_value->data[0].v_pointer = text_action_ref (src_value->data[0].v_pointer);
#line 1507 "SearchFilter.c"
	} else {
#line 181 "../src/SearchFilter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1511 "SearchFilter.c"
	}
}

static gpointer
value_text_action_peek_pointer (const GValue* value)
{
#line 181 "../src/SearchFilter.vala"
	return value->data[0].v_pointer;
#line 1520 "SearchFilter.c"
}

static gchar*
value_text_action_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 181 "../src/SearchFilter.vala"
	if (collect_values[0].v_pointer) {
#line 1531 "SearchFilter.c"
		TextAction * object;
		object = collect_values[0].v_pointer;
#line 181 "../src/SearchFilter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 181 "../src/SearchFilter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1538 "SearchFilter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 181 "../src/SearchFilter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1542 "SearchFilter.c"
		}
#line 181 "../src/SearchFilter.vala"
		value->data[0].v_pointer = text_action_ref (object);
#line 1546 "SearchFilter.c"
	} else {
#line 181 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 1550 "SearchFilter.c"
	}
#line 181 "../src/SearchFilter.vala"
	return NULL;
#line 1554 "SearchFilter.c"
}

static gchar*
value_text_action_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	TextAction ** object_p;
	object_p = collect_values[0].v_pointer;
#line 181 "../src/SearchFilter.vala"
	if (!object_p) {
#line 181 "../src/SearchFilter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1569 "SearchFilter.c"
	}
#line 181 "../src/SearchFilter.vala"
	if (!value->data[0].v_pointer) {
#line 181 "../src/SearchFilter.vala"
		*object_p = NULL;
#line 1575 "SearchFilter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 181 "../src/SearchFilter.vala"
		*object_p = value->data[0].v_pointer;
#line 1579 "SearchFilter.c"
	} else {
#line 181 "../src/SearchFilter.vala"
		*object_p = text_action_ref (value->data[0].v_pointer);
#line 1583 "SearchFilter.c"
	}
#line 181 "../src/SearchFilter.vala"
	return NULL;
#line 1587 "SearchFilter.c"
}

GParamSpec*
param_spec_text_action (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecTextAction* spec;
#line 181 "../src/SearchFilter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TEXT_ACTION), NULL);
#line 181 "../src/SearchFilter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 181 "../src/SearchFilter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 181 "../src/SearchFilter.vala"
	return G_PARAM_SPEC (spec);
#line 1606 "SearchFilter.c"
}

gpointer
value_get_text_action (const GValue* value)
{
#line 181 "../src/SearchFilter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION), NULL);
#line 181 "../src/SearchFilter.vala"
	return value->data[0].v_pointer;
#line 1616 "SearchFilter.c"
}

void
value_set_text_action (GValue* value,
                       gpointer v_object)
{
	TextAction * old;
#line 181 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION));
#line 181 "../src/SearchFilter.vala"
	old = value->data[0].v_pointer;
#line 181 "../src/SearchFilter.vala"
	if (v_object) {
#line 181 "../src/SearchFilter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEXT_ACTION));
#line 181 "../src/SearchFilter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 181 "../src/SearchFilter.vala"
		value->data[0].v_pointer = v_object;
#line 181 "../src/SearchFilter.vala"
		text_action_ref (value->data[0].v_pointer);
#line 1638 "SearchFilter.c"
	} else {
#line 181 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 1642 "SearchFilter.c"
	}
#line 181 "../src/SearchFilter.vala"
	if (old) {
#line 181 "../src/SearchFilter.vala"
		text_action_unref (old);
#line 1648 "SearchFilter.c"
	}
}

void
value_take_text_action (GValue* value,
                        gpointer v_object)
{
	TextAction * old;
#line 181 "../src/SearchFilter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION));
#line 181 "../src/SearchFilter.vala"
	old = value->data[0].v_pointer;
#line 181 "../src/SearchFilter.vala"
	if (v_object) {
#line 181 "../src/SearchFilter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEXT_ACTION));
#line 181 "../src/SearchFilter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 181 "../src/SearchFilter.vala"
		value->data[0].v_pointer = v_object;
#line 1669 "SearchFilter.c"
	} else {
#line 181 "../src/SearchFilter.vala"
		value->data[0].v_pointer = NULL;
#line 1673 "SearchFilter.c"
	}
#line 181 "../src/SearchFilter.vala"
	if (old) {
#line 181 "../src/SearchFilter.vala"
		text_action_unref (old);
#line 1679 "SearchFilter.c"
	}
}

static void
text_action_class_init (TextActionClass * klass,
                        gpointer klass_data)
{
#line 181 "../src/SearchFilter.vala"
	text_action_parent_class = g_type_class_peek_parent (klass);
#line 181 "../src/SearchFilter.vala"
	((TextActionClass *) klass)->finalize = text_action_finalize;
#line 181 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &TextAction_private_offset);
#line 181 "../src/SearchFilter.vala"
	text_action_signals[TEXT_ACTION_TEXT_CHANGED_SIGNAL] = g_signal_new ("text-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 181 "../src/SearchFilter.vala"
	text_action_signals[TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL] = g_signal_new ("sensitivity-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 181 "../src/SearchFilter.vala"
	text_action_signals[TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("visibility-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 1699 "SearchFilter.c"
}

static void
text_action_instance_init (TextAction * self,
                           gpointer klass)
{
#line 181 "../src/SearchFilter.vala"
	self->priv = text_action_get_instance_private (self);
#line 188 "../src/SearchFilter.vala"
	self->priv->text = NULL;
#line 189 "../src/SearchFilter.vala"
	self->priv->sensitive = TRUE;
#line 190 "../src/SearchFilter.vala"
	self->priv->visible = TRUE;
#line 181 "../src/SearchFilter.vala"
	self->ref_count = 1;
#line 1716 "SearchFilter.c"
}

static void
text_action_finalize (TextAction * obj)
{
	TextAction * self;
#line 181 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEXT_ACTION, TextAction);
#line 181 "../src/SearchFilter.vala"
	g_signal_handlers_destroy (self);
#line 188 "../src/SearchFilter.vala"
	_g_free0 (self->priv->text);
#line 1729 "SearchFilter.c"
}

static GType
text_action_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_text_action_init, value_text_action_free_value, value_text_action_copy_value, value_text_action_peek_pointer, "p", value_text_action_collect_value, "p", value_text_action_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TextActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextAction), 0, (GInstanceInitFunc) text_action_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType text_action_type_id;
	text_action_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TextAction", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TextAction_private_offset = g_type_add_instance_private (text_action_type_id, sizeof (TextActionPrivate));
	return text_action_type_id;
}

GType
text_action_get_type (void)
{
	static volatile gsize text_action_type_id__once = 0;
	if (g_once_init_enter (&text_action_type_id__once)) {
		GType text_action_type_id;
		text_action_type_id = text_action_get_type_once ();
		g_once_init_leave (&text_action_type_id__once, text_action_type_id);
	}
	return text_action_type_id__once;
}

gpointer
text_action_ref (gpointer instance)
{
	TextAction * self;
	self = instance;
#line 181 "../src/SearchFilter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 181 "../src/SearchFilter.vala"
	return instance;
#line 1765 "SearchFilter.c"
}

void
text_action_unref (gpointer instance)
{
	TextAction * self;
	self = instance;
#line 181 "../src/SearchFilter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 181 "../src/SearchFilter.vala"
		TEXT_ACTION_GET_CLASS (self)->finalize (self);
#line 181 "../src/SearchFilter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1779 "SearchFilter.c"
	}
}

static inline gpointer
search_filter_entry_get_instance_private (SearchFilterEntry* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterEntry_private_offset);
}

static void
__lambda54_ (SearchFilterEntry* self)
{
#line 241 "../src/SearchFilter.vala"
	search_filter_entry_on_search_text_changed (self);
#line 1794 "SearchFilter.c"
}

static void
___lambda54__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                              gpointer self)
{
#line 241 "../src/SearchFilter.vala"
	__lambda54_ ((SearchFilterEntry*) self);
#line 1803 "SearchFilter.c"
}

static gboolean
_search_filter_entry_on_escape_key_gtk_widget_key_press_event (GtkWidget* _sender,
                                                               GdkEventKey* event,
                                                               gpointer self)
{
	gboolean result;
	result = search_filter_entry_on_escape_key ((SearchFilterEntry*) self, event);
#line 242 "../src/SearchFilter.vala"
	return result;
#line 1815 "SearchFilter.c"
}

SearchFilterEntry*
search_filter_entry_construct (GType object_type)
{
	SearchFilterEntry * self = NULL;
#line 239 "../src/SearchFilter.vala"
	self = (SearchFilterEntry*) g_object_new (object_type, NULL);
#line 240 "../src/SearchFilter.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) self, _ ("Search Photos"));
#line 241 "../src/SearchFilter.vala"
	g_signal_connect_object ((GtkSearchEntry*) self, "search-changed", (GCallback) ___lambda54__gtk_search_entry_search_changed, self, 0);
#line 242 "../src/SearchFilter.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) _search_filter_entry_on_escape_key_gtk_widget_key_press_event, self, 0);
#line 239 "../src/SearchFilter.vala"
	return self;
#line 1832 "SearchFilter.c"
}

SearchFilterEntry*
search_filter_entry_new (void)
{
#line 239 "../src/SearchFilter.vala"
	return search_filter_entry_construct (TYPE_SEARCH_FILTER_ENTRY);
#line 1840 "SearchFilter.c"
}

static gboolean
search_filter_entry_on_escape_key (SearchFilterEntry* self,
                                   GdkEventKey* e)
{
	const gchar* _tmp0_;
	gboolean result;
#line 245 "../src/SearchFilter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 245 "../src/SearchFilter.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 246 "../src/SearchFilter.vala"
	_tmp0_ = gdk_keyval_name (e->keyval);
#line 246 "../src/SearchFilter.vala"
	if (g_strcmp0 (_tmp0_, "Escape") == 0) {
#line 247 "../src/SearchFilter.vala"
		gtk_entry_set_text ((GtkEntry*) self, "");
#line 1859 "SearchFilter.c"
	}
#line 250 "../src/SearchFilter.vala"
	result = FALSE;
#line 250 "../src/SearchFilter.vala"
	return result;
#line 1865 "SearchFilter.c"
}

static void
search_filter_entry_on_search_text_changed (SearchFilterEntry* self)
{
#line 253 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/SearchFilter.vala"
	search_filter_entry_update (self);
#line 1875 "SearchFilter.c"
}

static gpointer
_view_filter_ref0 (gpointer self)
{
#line 261 "../src/SearchFilter.vala"
	return self ? view_filter_ref (self) : NULL;
#line 1883 "SearchFilter.c"
}

void
search_filter_entry_set_view_filter (SearchFilterEntry* self,
                                     SearchViewFilter* search_filter)
{
	SearchViewFilter* _tmp0_;
	SearchViewFilter* _tmp1_;
#line 257 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/SearchFilter.vala"
	g_return_if_fail (search_filter != NULL);
#line 258 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter;
#line 258 "../src/SearchFilter.vala"
	if (search_filter == _tmp0_) {
#line 259 "../src/SearchFilter.vala"
		return;
#line 1902 "SearchFilter.c"
	}
#line 261 "../src/SearchFilter.vala"
	_tmp1_ = _view_filter_ref0 (search_filter);
#line 261 "../src/SearchFilter.vala"
	_view_filter_unref0 (self->priv->search_filter);
#line 261 "../src/SearchFilter.vala"
	self->priv->search_filter = _tmp1_;
#line 263 "../src/SearchFilter.vala"
	search_filter_entry_update (self);
#line 1912 "SearchFilter.c"
}

void
search_filter_entry_unset_view_filter (SearchFilterEntry* self)
{
	DisabledViewFilter* _tmp0_;
	DisabledViewFilter* _tmp1_;
#line 266 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/SearchFilter.vala"
	_tmp0_ = disabled_view_filter_new ();
#line 267 "../src/SearchFilter.vala"
	_tmp1_ = _tmp0_;
#line 267 "../src/SearchFilter.vala"
	search_filter_entry_set_view_filter (self, (SearchViewFilter*) _tmp1_);
#line 267 "../src/SearchFilter.vala"
	_view_filter_unref0 (_tmp1_);
#line 1930 "SearchFilter.c"
}

void
search_filter_entry_update (SearchFilterEntry* self)
{
	SearchViewFilter* _tmp0_;
	SearchViewFilter* _tmp1_;
	SearchViewFilter* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	SearchViewFilter* _tmp5_;
#line 271 "../src/SearchFilter.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/SearchFilter.vala"
	_tmp0_ = self->priv->search_filter;
#line 272 "../src/SearchFilter.vala"
	if (NULL == _tmp0_) {
#line 273 "../src/SearchFilter.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
#line 1950 "SearchFilter.c"
	} else {
#line 275 "../src/SearchFilter.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
#line 1954 "SearchFilter.c"
	}
#line 278 "../src/SearchFilter.vala"
	_tmp1_ = self->priv->search_filter;
#line 278 "../src/SearchFilter.vala"
	_vala_assert (NULL != _tmp1_, "null != search_filter");
#line 279 "../src/SearchFilter.vala"
	_tmp2_ = self->priv->search_filter;
#line 279 "../src/SearchFilter.vala"
	_tmp3_ = gtk_entry_get_text ((GtkEntry*) self);
#line 279 "../src/SearchFilter.vala"
	_tmp4_ = _tmp3_;
#line 279 "../src/SearchFilter.vala"
	search_view_filter_set_search_filter (_tmp2_, _tmp4_);
#line 282 "../src/SearchFilter.vala"
	_tmp5_ = self->priv->search_filter;
#line 282 "../src/SearchFilter.vala"
	g_signal_emit_by_name ((ViewFilter*) _tmp5_, "refresh");
#line 1972 "SearchFilter.c"
}

static void
search_filter_entry_class_init (SearchFilterEntryClass * klass,
                                gpointer klass_data)
{
#line 236 "../src/SearchFilter.vala"
	search_filter_entry_parent_class = g_type_class_peek_parent (klass);
#line 236 "../src/SearchFilter.vala"
	g_type_class_adjust_private_offset (klass, &SearchFilterEntry_private_offset);
#line 236 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (klass)->finalize = search_filter_entry_finalize;
#line 1985 "SearchFilter.c"
}

static void
search_filter_entry_instance_init (SearchFilterEntry * self,
                                   gpointer klass)
{
#line 236 "../src/SearchFilter.vala"
	self->priv = search_filter_entry_get_instance_private (self);
#line 237 "../src/SearchFilter.vala"
	self->priv->search_filter = NULL;
#line 1996 "SearchFilter.c"
}

static void
search_filter_entry_finalize (GObject * obj)
{
	SearchFilterEntry * self;
#line 236 "../src/SearchFilter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_FILTER_ENTRY, SearchFilterEntry);
#line 237 "../src/SearchFilter.vala"
	_view_filter_unref0 (self->priv->search_filter);
#line 236 "../src/SearchFilter.vala"
	G_OBJECT_CLASS (search_filter_entry_parent_class)->finalize (obj);
#line 2009 "SearchFilter.c"
}

static GType
search_filter_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterEntry), 0, (GInstanceInitFunc) search_filter_entry_instance_init, NULL };
	GType search_filter_entry_type_id;
	search_filter_entry_type_id = g_type_register_static (gtk_search_entry_get_type (), "SearchFilterEntry", &g_define_type_info, 0);
	SearchFilterEntry_private_offset = g_type_add_instance_private (search_filter_entry_type_id, sizeof (SearchFilterEntryPrivate));
	return search_filter_entry_type_id;
}

GType
search_filter_entry_get_type (void)
{
	static volatile gsize search_filter_entry_type_id__once = 0;
	if (g_once_init_enter (&search_filter_entry_type_id__once)) {
		GType search_filter_entry_type_id;
		search_filter_entry_type_id = search_filter_entry_get_type_once ();
		g_once_init_leave (&search_filter_entry_type_id__once, search_filter_entry_type_id);
	}
	return search_filter_entry_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

