/* Thumbnail.c generated by valac 0.56.18, the Vala compiler
 * generated from Thumbnail.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <pango/pango.h>
#include <granite.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define THUMBNAIL_HQ_IMPROVEMENT_MSEC 100
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	THUMBNAIL_0_PROPERTY,
	THUMBNAIL_NUM_PROPERTIES
};
static GParamSpec* thumbnail_properties[THUMBNAIL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ThumbnailPrivate {
	MediaSource* media;
	gint scale;
	Dimensions original_dim;
	Dimensions dim;
	GdkPixbuf* unscaled_pixbuf;
	GCancellable* cancellable;
	gboolean hq_scheduled;
	gboolean hq_reschedule;
	gboolean exposure;
};

static gint Thumbnail_private_offset;
static gpointer thumbnail_parent_class = NULL;
static gint thumbnail__scale_factor;
static gint thumbnail__scale_factor = 1;

static void thumbnail_on_tag_contents_altered (Thumbnail* self,
                                        ContainerSource* container,
                                        GeeCollection* added,
                                        gboolean relinking,
                                        GeeCollection* removed,
                                        gboolean unlinking);
static void _thumbnail_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender,
                                                                                                ContainerSource* container,
                                                                                                GeeCollection* added,
                                                                                                gboolean relinked,
                                                                                                GeeCollection* removed,
                                                                                                gboolean unlinked,
                                                                                                gpointer self);
static void thumbnail_on_tags_altered (Thumbnail* self,
                                GeeMap* altered);
static void _thumbnail_on_tags_altered_data_collection_items_altered (DataCollection* _sender,
                                                               GeeMap* items,
                                                               gpointer self);
static void thumbnail_set_scale_factor (Thumbnail* self,
                                 gint value);
static gint thumbnail_get_scale_factor (Thumbnail* self);
static void thumbnail_update_title (Thumbnail* self,
                             gboolean init);
static void thumbnail_update_comment (Thumbnail* self,
                               gboolean init);
static void thumbnail_update_tags (Thumbnail* self,
                            gboolean init);
static void thumbnail_real_notify_altered (DataObject* base,
                                    Alteration* alteration);
gchar* g_utf8_collate_key_for_filename (const gchar* str,
                                        gssize len);
static void thumbnail_real_thumbnail_altered (ThumbnailView* base);
static void thumbnail_delayed_high_quality_fetch (Thumbnail* self);
static void thumbnail_paint_empty (Thumbnail* self);
static void thumbnail_real_notify_collection_property_set (DataObject* base,
                                                    const gchar* name,
                                                    GValue* old,
                                                    GValue* val);
static void thumbnail_resize (Thumbnail* self,
                       gint new_scale);
static void thumbnail_cancel_async_fetch (Thumbnail* self);
VALA_EXTERN GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
static void thumbnail_schedule_low_quality_fetch (Thumbnail* self);
static void thumbnail_on_low_quality_fetched (Thumbnail* self,
                                       GdkPixbuf* pixbuf,
                                       GdkPixbuf* unscaled,
                                       Dimensions* dim,
                                       GdkInterpType interp,
                                       GError* err);
static void _thumbnail_on_low_quality_fetched_thumbnail_cache_async_fetch_callback (GdkPixbuf* pixbuf,
                                                                             GdkPixbuf* unscaled,
                                                                             Dimensions* dim,
                                                                             GdkInterpType interp,
                                                                             GError* err,
                                                                             gpointer self);
static gboolean thumbnail_on_schedule_high_quality (Thumbnail* self);
static gboolean _thumbnail_on_schedule_high_quality_gsource_func (gpointer self);
static void thumbnail_on_high_quality_fetched (Thumbnail* self,
                                        GdkPixbuf* pixbuf,
                                        GdkPixbuf* unscaled,
                                        Dimensions* dim,
                                        GdkInterpType interp,
                                        GError* err);
static void _thumbnail_on_high_quality_fetched_thumbnail_cache_async_fetch_callback (GdkPixbuf* pixbuf,
                                                                              GdkPixbuf* unscaled,
                                                                              Dimensions* dim,
                                                                              GdkInterpType interp,
                                                                              GError* err,
                                                                              gpointer self);
static void thumbnail_real_exposed (CheckerboardItem* base);
static void thumbnail_real_unexposed (CheckerboardItem* base);
static void thumbnail_real_paint (CheckerboardItem* base,
                           cairo_t* ctx,
                           GtkStyleContext* style_context);
static void thumbnail_finalize (GObject * obj);
static GType thumbnail_get_type_once (void);
static void _vala_thumbnail_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_thumbnail_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
thumbnail_get_instance_private (Thumbnail* self)
{
	return G_STRUCT_MEMBER_P (self, Thumbnail_private_offset);
}

static void
_thumbnail_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender,
                                                                                           ContainerSource* container,
                                                                                           GeeCollection* added,
                                                                                           gboolean relinked,
                                                                                           GeeCollection* removed,
                                                                                           gboolean unlinked,
                                                                                           gpointer self)
{
#line 101 "../src/Thumbnail.vala"
	thumbnail_on_tag_contents_altered ((Thumbnail*) self, container, added, relinked, removed, unlinked);
#line 183 "Thumbnail.c"
}

static void
_thumbnail_on_tags_altered_data_collection_items_altered (DataCollection* _sender,
                                                          GeeMap* items,
                                                          gpointer self)
{
#line 102 "../src/Thumbnail.vala"
	thumbnail_on_tags_altered ((Thumbnail*) self, items);
#line 193 "Thumbnail.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 81 "../src/Thumbnail.vala"
	return self ? g_object_ref (self) : NULL;
#line 201 "Thumbnail.c"
}

Thumbnail*
thumbnail_construct (GType object_type,
                     MediaSource* media,
                     gint scale)
{
	Thumbnail * self = NULL;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	MediaSource* _tmp8_;
	TagSourceCollection* _tmp9_;
	TagSourceCollection* _tmp10_;
	Dimensions _tmp11_ = {0};
	gint _tmp12_;
	gint _tmp13_;
	Dimensions _tmp14_ = {0};
#line 75 "../src/Thumbnail.vala"
	g_return_val_if_fail (media != NULL, NULL);
#line 76 "../src/Thumbnail.vala"
	media_source_get_dimensions (media, PHOTO_EXCEPTION_NONE, &_tmp0_);
#line 76 "../src/Thumbnail.vala"
	dimensions_get_scaled (&_tmp0_, scale, TRUE, &_tmp1_);
#line 76 "../src/Thumbnail.vala"
	_tmp2_ = data_object_get_name ((DataObject*) media);
#line 76 "../src/Thumbnail.vala"
	_tmp3_ = _tmp2_;
#line 76 "../src/Thumbnail.vala"
	_tmp4_ = media_source_get_comment (media);
#line 76 "../src/Thumbnail.vala"
	_tmp5_ = _tmp4_;
#line 76 "../src/Thumbnail.vala"
	self = (Thumbnail*) checkerboard_item_construct (object_type, (ThumbnailSource*) media, &_tmp1_, _tmp3_, _tmp5_, FALSE, PANGO_ALIGN_LEFT);
#line 76 "../src/Thumbnail.vala"
	_g_free0 (_tmp5_);
#line 76 "../src/Thumbnail.vala"
	_g_free0 (_tmp3_);
#line 79 "../src/Thumbnail.vala"
	_tmp6_ = thumbnail_cache_get_scale_factor ();
#line 79 "../src/Thumbnail.vala"
	_tmp7_ = _tmp6_;
#line 79 "../src/Thumbnail.vala"
	thumbnail_set_scale_factor (self, _tmp7_);
#line 81 "../src/Thumbnail.vala"
	_tmp8_ = _g_object_ref0 (media);
#line 81 "../src/Thumbnail.vala"
	_g_object_unref0 (self->priv->media);
#line 81 "../src/Thumbnail.vala"
	self->priv->media = _tmp8_;
#line 82 "../src/Thumbnail.vala"
	self->priv->scale = scale;
#line 84 "../src/Thumbnail.vala"
	_tmp9_ = tag_global;
#line 84 "../src/Thumbnail.vala"
	g_signal_connect_object ((ContainerSourceCollection*) _tmp9_, "container-contents-altered", (GCallback) _thumbnail_on_tag_contents_altered_container_source_collection_container_contents_altered, self, 0);
#line 85 "../src/Thumbnail.vala"
	_tmp10_ = tag_global;
#line 85 "../src/Thumbnail.vala"
	g_signal_connect_object ((DataCollection*) _tmp10_, "items-altered", (GCallback) _thumbnail_on_tags_altered_data_collection_items_altered, self, 0);
#line 87 "../src/Thumbnail.vala"
	media_source_get_dimensions (media, PHOTO_EXCEPTION_NONE, &_tmp11_);
#line 87 "../src/Thumbnail.vala"
	self->priv->original_dim = _tmp11_;
#line 88 "../src/Thumbnail.vala"
	_tmp12_ = thumbnail_get_scale_factor (self);
#line 88 "../src/Thumbnail.vala"
	_tmp13_ = _tmp12_;
#line 88 "../src/Thumbnail.vala"
	dimensions_get_scaled (&self->priv->original_dim, scale * _tmp13_, TRUE, &_tmp14_);
#line 88 "../src/Thumbnail.vala"
	self->priv->dim = _tmp14_;
#line 92 "../src/Thumbnail.vala"
	thumbnail_update_title (self, TRUE);
#line 93 "../src/Thumbnail.vala"
	thumbnail_update_comment (self, TRUE);
#line 94 "../src/Thumbnail.vala"
	thumbnail_update_tags (self, TRUE);
#line 75 "../src/Thumbnail.vala"
	return self;
#line 287 "Thumbnail.c"
}

Thumbnail*
thumbnail_new (MediaSource* media,
               gint scale)
{
#line 75 "../src/Thumbnail.vala"
	return thumbnail_construct (TYPE_THUMBNAIL, media, scale);
#line 296 "Thumbnail.c"
}

static void
thumbnail_update_tags (Thumbnail* self,
                       gboolean init)
{
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp0_;
	MediaSource* _tmp1_;
	GeeSortedSet* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeCollection* _tmp4_;
#line 105 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/Thumbnail.vala"
	_tmp0_ = tag_global;
#line 106 "../src/Thumbnail.vala"
	_tmp1_ = self->priv->media;
#line 106 "../src/Thumbnail.vala"
	_tmp2_ = tag_source_collection_fetch_sorted_for_source (_tmp0_, _tmp1_);
#line 106 "../src/Thumbnail.vala"
	tags = (GeeCollection*) _tmp2_;
#line 107 "../src/Thumbnail.vala"
	_tmp4_ = tags;
#line 107 "../src/Thumbnail.vala"
	if (_tmp4_ == NULL) {
#line 107 "../src/Thumbnail.vala"
		_tmp3_ = TRUE;
#line 325 "Thumbnail.c"
	} else {
		GeeCollection* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 107 "../src/Thumbnail.vala"
		_tmp5_ = tags;
#line 107 "../src/Thumbnail.vala"
		_tmp6_ = gee_collection_get_size (_tmp5_);
#line 107 "../src/Thumbnail.vala"
		_tmp7_ = _tmp6_;
#line 107 "../src/Thumbnail.vala"
		_tmp3_ = _tmp7_ == 0;
#line 338 "Thumbnail.c"
	}
#line 107 "../src/Thumbnail.vala"
	if (_tmp3_) {
#line 108 "../src/Thumbnail.vala"
		checkerboard_item_clear_subtitle ((CheckerboardItem*) self);
#line 344 "Thumbnail.c"
	} else {
#line 109 "../src/Thumbnail.vala"
		if (!init) {
#line 348 "Thumbnail.c"
			GeeCollection* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 110 "../src/Thumbnail.vala"
			_tmp8_ = tags;
#line 110 "../src/Thumbnail.vala"
			_tmp9_ = tag_make_tag_string (_tmp8_, "<small>", ", ", "</small>", TRUE);
#line 110 "../src/Thumbnail.vala"
			_tmp10_ = _tmp9_;
#line 110 "../src/Thumbnail.vala"
			checkerboard_item_set_subtitle ((CheckerboardItem*) self, _tmp10_, TRUE, PANGO_ALIGN_LEFT);
#line 110 "../src/Thumbnail.vala"
			_g_free0 (_tmp10_);
#line 362 "Thumbnail.c"
		} else {
#line 112 "../src/Thumbnail.vala"
			checkerboard_item_set_subtitle ((CheckerboardItem*) self, "<small>.</small>", TRUE, PANGO_ALIGN_LEFT);
#line 366 "Thumbnail.c"
		}
	}
#line 105 "../src/Thumbnail.vala"
	_g_object_unref0 (tags);
#line 371 "Thumbnail.c"
}

static void
thumbnail_on_tag_contents_altered (Thumbnail* self,
                                   ContainerSource* container,
                                   GeeCollection* added,
                                   gboolean relinking,
                                   GeeCollection* removed,
                                   gboolean unlinking)
{
	gboolean _tmp0_ = FALSE;
	gboolean tag_added = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean tag_removed = FALSE;
	gboolean _tmp4_ = FALSE;
#line 115 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/Thumbnail.vala"
	g_return_if_fail (container != NULL);
#line 117 "../src/Thumbnail.vala"
	if (!self->priv->exposure) {
#line 118 "../src/Thumbnail.vala"
		return;
#line 395 "Thumbnail.c"
	}
#line 120 "../src/Thumbnail.vala"
	if (added != NULL) {
#line 399 "Thumbnail.c"
		MediaSource* _tmp1_;
#line 120 "../src/Thumbnail.vala"
		_tmp1_ = self->priv->media;
#line 120 "../src/Thumbnail.vala"
		_tmp0_ = gee_collection_contains (added, (DataSource*) _tmp1_);
#line 405 "Thumbnail.c"
	} else {
#line 120 "../src/Thumbnail.vala"
		_tmp0_ = FALSE;
#line 409 "Thumbnail.c"
	}
#line 120 "../src/Thumbnail.vala"
	tag_added = _tmp0_;
#line 121 "../src/Thumbnail.vala"
	if (removed != NULL) {
#line 415 "Thumbnail.c"
		MediaSource* _tmp3_;
#line 121 "../src/Thumbnail.vala"
		_tmp3_ = self->priv->media;
#line 121 "../src/Thumbnail.vala"
		_tmp2_ = gee_collection_contains (removed, (DataSource*) _tmp3_);
#line 421 "Thumbnail.c"
	} else {
#line 121 "../src/Thumbnail.vala"
		_tmp2_ = FALSE;
#line 425 "Thumbnail.c"
	}
#line 121 "../src/Thumbnail.vala"
	tag_removed = _tmp2_;
#line 124 "../src/Thumbnail.vala"
	if (tag_added) {
#line 124 "../src/Thumbnail.vala"
		_tmp4_ = TRUE;
#line 433 "Thumbnail.c"
	} else {
#line 124 "../src/Thumbnail.vala"
		_tmp4_ = tag_removed;
#line 437 "Thumbnail.c"
	}
#line 124 "../src/Thumbnail.vala"
	if (_tmp4_) {
#line 125 "../src/Thumbnail.vala"
		thumbnail_update_tags (self, FALSE);
#line 443 "Thumbnail.c"
	}
}

static void
thumbnail_on_tags_altered (Thumbnail* self,
                           GeeMap* altered)
{
#line 128 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/Thumbnail.vala"
	g_return_if_fail (altered != NULL);
#line 129 "../src/Thumbnail.vala"
	if (!self->priv->exposure) {
#line 130 "../src/Thumbnail.vala"
		return;
#line 459 "Thumbnail.c"
	}
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 132 "../src/Thumbnail.vala"
		_tmp0_ = gee_map_get_keys (altered);
#line 132 "../src/Thumbnail.vala"
		_tmp1_ = _tmp0_;
#line 132 "../src/Thumbnail.vala"
		_tmp2_ = _tmp1_;
#line 132 "../src/Thumbnail.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 132 "../src/Thumbnail.vala"
		_tmp4_ = _tmp3_;
#line 132 "../src/Thumbnail.vala"
		_g_object_unref0 (_tmp2_);
#line 132 "../src/Thumbnail.vala"
		_object_it = _tmp4_;
#line 132 "../src/Thumbnail.vala"
		while (TRUE) {
#line 484 "Thumbnail.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Tag* tag = NULL;
			DataObject* _tmp8_;
			Tag* _tmp9_;
			Tag* _tmp10_;
			MediaSource* _tmp11_;
#line 132 "../src/Thumbnail.vala"
			_tmp5_ = _object_it;
#line 132 "../src/Thumbnail.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 132 "../src/Thumbnail.vala"
				break;
#line 500 "Thumbnail.c"
			}
#line 132 "../src/Thumbnail.vala"
			_tmp6_ = _object_it;
#line 132 "../src/Thumbnail.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 132 "../src/Thumbnail.vala"
			object = (DataObject*) _tmp7_;
#line 133 "../src/Thumbnail.vala"
			_tmp8_ = object;
#line 133 "../src/Thumbnail.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_TAG, Tag));
#line 133 "../src/Thumbnail.vala"
			tag = _tmp9_;
#line 135 "../src/Thumbnail.vala"
			_tmp10_ = tag;
#line 135 "../src/Thumbnail.vala"
			_tmp11_ = self->priv->media;
#line 135 "../src/Thumbnail.vala"
			if (tag_contains (_tmp10_, _tmp11_)) {
#line 136 "../src/Thumbnail.vala"
				thumbnail_update_tags (self, FALSE);
#line 138 "../src/Thumbnail.vala"
				_g_object_unref0 (tag);
#line 138 "../src/Thumbnail.vala"
				_g_object_unref0 (object);
#line 138 "../src/Thumbnail.vala"
				break;
#line 528 "Thumbnail.c"
			}
#line 132 "../src/Thumbnail.vala"
			_g_object_unref0 (tag);
#line 132 "../src/Thumbnail.vala"
			_g_object_unref0 (object);
#line 534 "Thumbnail.c"
		}
#line 132 "../src/Thumbnail.vala"
		_g_object_unref0 (_object_it);
#line 538 "Thumbnail.c"
	}
}

static void
thumbnail_update_title (Thumbnail* self,
                        gboolean init)
{
	gchar* title = NULL;
	MediaSource* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 143 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/Thumbnail.vala"
	_tmp0_ = self->priv->media;
#line 144 "../src/Thumbnail.vala"
	_tmp1_ = data_object_get_name ((DataObject*) _tmp0_);
#line 144 "../src/Thumbnail.vala"
	title = _tmp1_;
#line 145 "../src/Thumbnail.vala"
	_tmp2_ = title;
#line 145 "../src/Thumbnail.vala"
	if (is_string_empty (_tmp2_)) {
#line 146 "../src/Thumbnail.vala"
		checkerboard_item_clear_title ((CheckerboardItem*) self);
#line 564 "Thumbnail.c"
	} else {
#line 147 "../src/Thumbnail.vala"
		if (!init) {
#line 568 "Thumbnail.c"
			const gchar* _tmp3_;
#line 148 "../src/Thumbnail.vala"
			_tmp3_ = title;
#line 148 "../src/Thumbnail.vala"
			checkerboard_item_set_title ((CheckerboardItem*) self, _tmp3_, FALSE, PANGO_ALIGN_LEFT);
#line 574 "Thumbnail.c"
		} else {
#line 150 "../src/Thumbnail.vala"
			checkerboard_item_set_title ((CheckerboardItem*) self, "", FALSE, PANGO_ALIGN_LEFT);
#line 578 "Thumbnail.c"
		}
	}
#line 143 "../src/Thumbnail.vala"
	_g_free0 (title);
#line 583 "Thumbnail.c"
}

static void
thumbnail_update_comment (Thumbnail* self,
                          gboolean init)
{
	gchar* comment = NULL;
	MediaSource* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 153 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/Thumbnail.vala"
	_tmp0_ = self->priv->media;
#line 154 "../src/Thumbnail.vala"
	_tmp1_ = media_source_get_comment (_tmp0_);
#line 154 "../src/Thumbnail.vala"
	comment = _tmp1_;
#line 155 "../src/Thumbnail.vala"
	_tmp2_ = comment;
#line 155 "../src/Thumbnail.vala"
	if (is_string_empty (_tmp2_)) {
#line 156 "../src/Thumbnail.vala"
		checkerboard_item_clear_comment ((CheckerboardItem*) self);
#line 608 "Thumbnail.c"
	} else {
#line 157 "../src/Thumbnail.vala"
		if (!init) {
#line 612 "Thumbnail.c"
			const gchar* _tmp3_;
#line 158 "../src/Thumbnail.vala"
			_tmp3_ = comment;
#line 158 "../src/Thumbnail.vala"
			checkerboard_item_set_comment ((CheckerboardItem*) self, _tmp3_, FALSE, PANGO_ALIGN_LEFT);
#line 618 "Thumbnail.c"
		} else {
#line 160 "../src/Thumbnail.vala"
			checkerboard_item_set_comment ((CheckerboardItem*) self, "", FALSE, PANGO_ALIGN_LEFT);
#line 622 "Thumbnail.c"
		}
	}
#line 153 "../src/Thumbnail.vala"
	_g_free0 (comment);
#line 627 "Thumbnail.c"
}

static void
thumbnail_real_notify_altered (DataObject* base,
                               Alteration* alteration)
{
	Thumbnail * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 163 "../src/Thumbnail.vala"
	self = (Thumbnail*) base;
#line 163 "../src/Thumbnail.vala"
	g_return_if_fail (alteration != NULL);
#line 164 "../src/Thumbnail.vala"
	if (self->priv->exposure) {
#line 164 "../src/Thumbnail.vala"
		_tmp0_ = alteration_has_detail (alteration, "metadata", "name");
#line 645 "Thumbnail.c"
	} else {
#line 164 "../src/Thumbnail.vala"
		_tmp0_ = FALSE;
#line 649 "Thumbnail.c"
	}
#line 164 "../src/Thumbnail.vala"
	if (_tmp0_) {
#line 165 "../src/Thumbnail.vala"
		thumbnail_update_title (self, FALSE);
#line 655 "Thumbnail.c"
	}
#line 166 "../src/Thumbnail.vala"
	if (self->priv->exposure) {
#line 166 "../src/Thumbnail.vala"
		_tmp1_ = alteration_has_detail (alteration, "metadata", "comment");
#line 661 "Thumbnail.c"
	} else {
#line 166 "../src/Thumbnail.vala"
		_tmp1_ = FALSE;
#line 665 "Thumbnail.c"
	}
#line 166 "../src/Thumbnail.vala"
	if (_tmp1_) {
#line 167 "../src/Thumbnail.vala"
		thumbnail_update_comment (self, FALSE);
#line 671 "Thumbnail.c"
	}
#line 169 "../src/Thumbnail.vala"
	DATA_OBJECT_CLASS (thumbnail_parent_class)->notify_altered ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_ITEM, CheckerboardItem), alteration);
#line 675 "Thumbnail.c"
}

MediaSource*
thumbnail_get_media_source (Thumbnail* self)
{
	MediaSource* _tmp0_;
	MediaSource* _tmp1_;
	MediaSource* result;
#line 172 "../src/Thumbnail.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 173 "../src/Thumbnail.vala"
	_tmp0_ = self->priv->media;
#line 173 "../src/Thumbnail.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 173 "../src/Thumbnail.vala"
	result = _tmp1_;
#line 173 "../src/Thumbnail.vala"
	return result;
#line 694 "Thumbnail.c"
}

gint64
thumbnail_photo_id_ascending_comparator (void* a,
                                         void* b)
{
	MediaSource* _tmp0_;
	MediaSource* _tmp1_;
	gint64 result;
#line 181 "../src/Thumbnail.vala"
	_tmp0_ = ((Thumbnail*) a)->priv->media;
#line 181 "../src/Thumbnail.vala"
	_tmp1_ = ((Thumbnail*) b)->priv->media;
#line 181 "../src/Thumbnail.vala"
	result = data_source_get_instance_id ((DataSource*) _tmp0_) - data_source_get_instance_id ((DataSource*) _tmp1_);
#line 181 "../src/Thumbnail.vala"
	return result;
#line 712 "Thumbnail.c"
}

gint64
thumbnail_photo_id_descending_comparator (void* a,
                                          void* b)
{
	gint64 result;
#line 185 "../src/Thumbnail.vala"
	result = thumbnail_photo_id_ascending_comparator (b, a);
#line 185 "../src/Thumbnail.vala"
	return result;
#line 724 "Thumbnail.c"
}

gint64
thumbnail_title_ascending_comparator (void* a,
                                      void* b)
{
	gint64 _result_ = 0LL;
	GCompareFunc _tmp0_;
	MediaSource* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	MediaSource* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint64 _tmp7_;
	gint64 _tmp8_ = 0LL;
	gint64 result;
#line 189 "../src/Thumbnail.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 189 "../src/Thumbnail.vala"
	_tmp1_ = ((Thumbnail*) a)->priv->media;
#line 189 "../src/Thumbnail.vala"
	_tmp2_ = data_object_get_name ((DataObject*) _tmp1_);
#line 189 "../src/Thumbnail.vala"
	_tmp3_ = _tmp2_;
#line 189 "../src/Thumbnail.vala"
	_tmp4_ = ((Thumbnail*) b)->priv->media;
#line 189 "../src/Thumbnail.vala"
	_tmp5_ = data_object_get_name ((DataObject*) _tmp4_);
#line 189 "../src/Thumbnail.vala"
	_tmp6_ = _tmp5_;
#line 189 "../src/Thumbnail.vala"
	_tmp7_ = (gint64) _tmp0_ (_tmp3_, _tmp6_);
#line 189 "../src/Thumbnail.vala"
	_g_free0 (_tmp6_);
#line 189 "../src/Thumbnail.vala"
	_g_free0 (_tmp3_);
#line 189 "../src/Thumbnail.vala"
	_result_ = _tmp7_;
#line 191 "../src/Thumbnail.vala"
	if (_result_ != ((gint64) 0)) {
#line 191 "../src/Thumbnail.vala"
		_tmp8_ = _result_;
#line 768 "Thumbnail.c"
	} else {
#line 191 "../src/Thumbnail.vala"
		_tmp8_ = thumbnail_photo_id_ascending_comparator (a, b);
#line 772 "Thumbnail.c"
	}
#line 191 "../src/Thumbnail.vala"
	result = _tmp8_;
#line 191 "../src/Thumbnail.vala"
	return result;
#line 778 "Thumbnail.c"
}

gint64
thumbnail_title_descending_comparator (void* a,
                                       void* b)
{
	gint64 _result_ = 0LL;
	gint64 _tmp0_ = 0LL;
	gint64 result;
#line 195 "../src/Thumbnail.vala"
	_result_ = thumbnail_title_ascending_comparator (b, a);
#line 197 "../src/Thumbnail.vala"
	if (_result_ != ((gint64) 0)) {
#line 197 "../src/Thumbnail.vala"
		_tmp0_ = _result_;
#line 794 "Thumbnail.c"
	} else {
#line 197 "../src/Thumbnail.vala"
		_tmp0_ = thumbnail_photo_id_descending_comparator (a, b);
#line 798 "Thumbnail.c"
	}
#line 197 "../src/Thumbnail.vala"
	result = _tmp0_;
#line 197 "../src/Thumbnail.vala"
	return result;
#line 804 "Thumbnail.c"
}

gboolean
thumbnail_title_comparator_predicate (DataObject* object,
                                      Alteration* alteration)
{
	gboolean result;
#line 200 "../src/Thumbnail.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 200 "../src/Thumbnail.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 201 "../src/Thumbnail.vala"
	result = alteration_has_detail (alteration, "metadata", "title");
#line 201 "../src/Thumbnail.vala"
	return result;
#line 820 "Thumbnail.c"
}

gint64
thumbnail_exposure_time_ascending_comparator (void* a,
                                              void* b)
{
	gint64 time_a = 0LL;
	MediaSource* _tmp0_;
	gint64 time_b = 0LL;
	MediaSource* _tmp1_;
	gint64 _result_ = 0LL;
	gint64 _tmp2_ = 0LL;
	gint64 result;
#line 205 "../src/Thumbnail.vala"
	_tmp0_ = ((Thumbnail*) a)->priv->media;
#line 205 "../src/Thumbnail.vala"
	time_a = media_source_get_exposure_time (_tmp0_);
#line 206 "../src/Thumbnail.vala"
	_tmp1_ = ((Thumbnail*) b)->priv->media;
#line 206 "../src/Thumbnail.vala"
	time_b = media_source_get_exposure_time (_tmp1_);
#line 207 "../src/Thumbnail.vala"
	_result_ = time_a - time_b;
#line 209 "../src/Thumbnail.vala"
	if (_result_ != ((gint64) 0)) {
#line 209 "../src/Thumbnail.vala"
		_tmp2_ = _result_;
#line 848 "Thumbnail.c"
	} else {
#line 209 "../src/Thumbnail.vala"
		_tmp2_ = thumbnail_filename_ascending_comparator (a, b);
#line 852 "Thumbnail.c"
	}
#line 209 "../src/Thumbnail.vala"
	result = _tmp2_;
#line 209 "../src/Thumbnail.vala"
	return result;
#line 858 "Thumbnail.c"
}

gint64
thumbnail_exposure_time_descending_comparator (void* a,
                                               void* b)
{
	gint64 _result_ = 0LL;
	gint64 _tmp0_ = 0LL;
	gint64 result;
#line 213 "../src/Thumbnail.vala"
	_result_ = thumbnail_exposure_time_ascending_comparator (b, a);
#line 215 "../src/Thumbnail.vala"
	if (_result_ != ((gint64) 0)) {
#line 215 "../src/Thumbnail.vala"
		_tmp0_ = _result_;
#line 874 "Thumbnail.c"
	} else {
#line 215 "../src/Thumbnail.vala"
		_tmp0_ = thumbnail_filename_descending_comparator (a, b);
#line 878 "Thumbnail.c"
	}
#line 215 "../src/Thumbnail.vala"
	result = _tmp0_;
#line 215 "../src/Thumbnail.vala"
	return result;
#line 884 "Thumbnail.c"
}

gboolean
thumbnail_exposure_time_comparator_predicate (DataObject* object,
                                              Alteration* alteration)
{
	gboolean result;
#line 218 "../src/Thumbnail.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 218 "../src/Thumbnail.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 219 "../src/Thumbnail.vala"
	result = alteration_has_detail (alteration, "metadata", "exposure-time");
#line 219 "../src/Thumbnail.vala"
	return result;
#line 900 "Thumbnail.c"
}

gint64
thumbnail_timestamp_ascending_comparator (void* a,
                                          void* b)
{
	gint64 time_a = 0LL;
	MediaSource* _tmp0_;
	gint64 time_b = 0LL;
	MediaSource* _tmp1_;
	gint64 _result_ = 0LL;
	gint64 _tmp2_ = 0LL;
	gint64 result;
#line 223 "../src/Thumbnail.vala"
	_tmp0_ = ((Thumbnail*) a)->priv->media;
#line 223 "../src/Thumbnail.vala"
	time_a = (gint64) media_source_get_timestamp (_tmp0_);
#line 224 "../src/Thumbnail.vala"
	_tmp1_ = ((Thumbnail*) b)->priv->media;
#line 224 "../src/Thumbnail.vala"
	time_b = (gint64) media_source_get_timestamp (_tmp1_);
#line 225 "../src/Thumbnail.vala"
	_result_ = time_a - time_b;
#line 227 "../src/Thumbnail.vala"
	if (_result_ != ((gint64) 0)) {
#line 227 "../src/Thumbnail.vala"
		_tmp2_ = _result_;
#line 928 "Thumbnail.c"
	} else {
#line 227 "../src/Thumbnail.vala"
		_tmp2_ = thumbnail_exposure_time_ascending_comparator (a, b);
#line 932 "Thumbnail.c"
	}
#line 227 "../src/Thumbnail.vala"
	result = _tmp2_;
#line 227 "../src/Thumbnail.vala"
	return result;
#line 938 "Thumbnail.c"
}

gint64
thumbnail_timestamp_descending_comparator (void* a,
                                           void* b)
{
	gint64 _result_ = 0LL;
	gint64 _tmp0_ = 0LL;
	gint64 result;
#line 231 "../src/Thumbnail.vala"
	_result_ = thumbnail_timestamp_ascending_comparator (b, a);
#line 233 "../src/Thumbnail.vala"
	if (_result_ != ((gint64) 0)) {
#line 233 "../src/Thumbnail.vala"
		_tmp0_ = _result_;
#line 954 "Thumbnail.c"
	} else {
#line 233 "../src/Thumbnail.vala"
		_tmp0_ = thumbnail_exposure_time_descending_comparator (a, b);
#line 958 "Thumbnail.c"
	}
#line 233 "../src/Thumbnail.vala"
	result = _tmp0_;
#line 233 "../src/Thumbnail.vala"
	return result;
#line 964 "Thumbnail.c"
}

gboolean
thumbnail_timestamp_comparator_predicate (DataObject* object,
                                          Alteration* alteration)
{
	gboolean result;
#line 236 "../src/Thumbnail.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 236 "../src/Thumbnail.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 237 "../src/Thumbnail.vala"
	result = alteration_has_detail (alteration, "metadata", "timestamp");
#line 237 "../src/Thumbnail.vala"
	return result;
#line 980 "Thumbnail.c"
}

gint64
thumbnail_filename_ascending_comparator (void* a,
                                         void* b)
{
	gchar* path_a = NULL;
	MediaSource* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* path_b = NULL;
	MediaSource* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gint64 _result_ = 0LL;
	GCompareFunc _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gint64 _tmp21_;
	gint64 _tmp22_ = 0LL;
	gint64 result;
#line 241 "../src/Thumbnail.vala"
	_tmp0_ = ((Thumbnail*) a)->priv->media;
#line 241 "../src/Thumbnail.vala"
	_tmp1_ = media_source_get_file (_tmp0_);
#line 241 "../src/Thumbnail.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/Thumbnail.vala"
	_tmp3_ = g_file_get_basename (_tmp2_);
#line 241 "../src/Thumbnail.vala"
	_tmp4_ = _tmp3_;
#line 241 "../src/Thumbnail.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 241 "../src/Thumbnail.vala"
	_tmp6_ = _tmp5_;
#line 241 "../src/Thumbnail.vala"
	_g_free0 (_tmp4_);
#line 241 "../src/Thumbnail.vala"
	_g_object_unref0 (_tmp2_);
#line 241 "../src/Thumbnail.vala"
	path_a = _tmp6_;
#line 242 "../src/Thumbnail.vala"
	_tmp7_ = ((Thumbnail*) b)->priv->media;
#line 242 "../src/Thumbnail.vala"
	_tmp8_ = media_source_get_file (_tmp7_);
#line 242 "../src/Thumbnail.vala"
	_tmp9_ = _tmp8_;
#line 242 "../src/Thumbnail.vala"
	_tmp10_ = g_file_get_basename (_tmp9_);
#line 242 "../src/Thumbnail.vala"
	_tmp11_ = _tmp10_;
#line 242 "../src/Thumbnail.vala"
	_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 242 "../src/Thumbnail.vala"
	_tmp13_ = _tmp12_;
#line 242 "../src/Thumbnail.vala"
	_g_free0 (_tmp11_);
#line 242 "../src/Thumbnail.vala"
	_g_object_unref0 (_tmp9_);
#line 242 "../src/Thumbnail.vala"
	path_b = _tmp13_;
#line 244 "../src/Thumbnail.vala"
	_tmp14_ = ((GCompareFunc) g_strcmp0);
#line 244 "../src/Thumbnail.vala"
	_tmp15_ = path_a;
#line 244 "../src/Thumbnail.vala"
	_tmp16_ = g_utf8_collate_key_for_filename (_tmp15_, (gssize) -1);
#line 244 "../src/Thumbnail.vala"
	_tmp17_ = _tmp16_;
#line 244 "../src/Thumbnail.vala"
	_tmp18_ = path_b;
#line 244 "../src/Thumbnail.vala"
	_tmp19_ = g_utf8_collate_key_for_filename (_tmp18_, (gssize) -1);
#line 244 "../src/Thumbnail.vala"
	_tmp20_ = _tmp19_;
#line 244 "../src/Thumbnail.vala"
	_tmp21_ = (gint64) _tmp14_ (_tmp17_, _tmp20_);
#line 244 "../src/Thumbnail.vala"
	_g_free0 (_tmp20_);
#line 244 "../src/Thumbnail.vala"
	_g_free0 (_tmp17_);
#line 244 "../src/Thumbnail.vala"
	_result_ = _tmp21_;
#line 246 "../src/Thumbnail.vala"
	if (_result_ != ((gint64) 0)) {
#line 246 "../src/Thumbnail.vala"
		_tmp22_ = _result_;
#line 1080 "Thumbnail.c"
	} else {
#line 246 "../src/Thumbnail.vala"
		_tmp22_ = thumbnail_photo_id_ascending_comparator (a, b);
#line 1084 "Thumbnail.c"
	}
#line 246 "../src/Thumbnail.vala"
	result = _tmp22_;
#line 246 "../src/Thumbnail.vala"
	_g_free0 (path_b);
#line 246 "../src/Thumbnail.vala"
	_g_free0 (path_a);
#line 246 "../src/Thumbnail.vala"
	return result;
#line 1094 "Thumbnail.c"
}

gint64
thumbnail_filename_descending_comparator (void* a,
                                          void* b)
{
	gint64 _result_ = 0LL;
	gint64 _tmp0_ = 0LL;
	gint64 result;
#line 250 "../src/Thumbnail.vala"
	_result_ = thumbnail_filename_ascending_comparator (b, a);
#line 252 "../src/Thumbnail.vala"
	if (_result_ != ((gint64) 0)) {
#line 252 "../src/Thumbnail.vala"
		_tmp0_ = _result_;
#line 1110 "Thumbnail.c"
	} else {
#line 252 "../src/Thumbnail.vala"
		_tmp0_ = thumbnail_photo_id_descending_comparator (a, b);
#line 1114 "Thumbnail.c"
	}
#line 252 "../src/Thumbnail.vala"
	result = _tmp0_;
#line 252 "../src/Thumbnail.vala"
	return result;
#line 1120 "Thumbnail.c"
}

static void
thumbnail_real_thumbnail_altered (ThumbnailView* base)
{
	Thumbnail * self;
	MediaSource* _tmp0_;
	Dimensions _tmp1_ = {0};
	gint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
#line 255 "../src/Thumbnail.vala"
	self = (Thumbnail*) base;
#line 256 "../src/Thumbnail.vala"
	_tmp0_ = self->priv->media;
#line 256 "../src/Thumbnail.vala"
	media_source_get_dimensions (_tmp0_, PHOTO_EXCEPTION_NONE, &_tmp1_);
#line 256 "../src/Thumbnail.vala"
	self->priv->original_dim = _tmp1_;
#line 257 "../src/Thumbnail.vala"
	_tmp2_ = thumbnail_get_scale_factor (self);
#line 257 "../src/Thumbnail.vala"
	_tmp3_ = _tmp2_;
#line 257 "../src/Thumbnail.vala"
	dimensions_get_scaled (&self->priv->original_dim, self->priv->scale * _tmp3_, TRUE, &_tmp4_);
#line 257 "../src/Thumbnail.vala"
	self->priv->dim = _tmp4_;
#line 259 "../src/Thumbnail.vala"
	if (self->priv->exposure) {
#line 260 "../src/Thumbnail.vala"
		thumbnail_delayed_high_quality_fetch (self);
#line 1152 "Thumbnail.c"
	} else {
#line 262 "../src/Thumbnail.vala"
		thumbnail_paint_empty (self);
#line 1156 "Thumbnail.c"
	}
#line 264 "../src/Thumbnail.vala"
	THUMBNAIL_VIEW_CLASS (thumbnail_parent_class)->thumbnail_altered ((ThumbnailView*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_ITEM, CheckerboardItem));
#line 1160 "Thumbnail.c"
}

static void
thumbnail_real_notify_collection_property_set (DataObject* base,
                                               const gchar* name,
                                               GValue* old,
                                               GValue* val)
{
	Thumbnail * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 268 "../src/Thumbnail.vala"
	static GQuark _tmp1_label0 = 0;
#line 1174 "Thumbnail.c"
	GValue _tmp4_;
#line 267 "../src/Thumbnail.vala"
	self = (Thumbnail*) base;
#line 267 "../src/Thumbnail.vala"
	g_return_if_fail (name != NULL);
#line 267 "../src/Thumbnail.vala"
	g_return_if_fail (val != NULL);
#line 268 "../src/Thumbnail.vala"
	_tmp0_ = name;
#line 268 "../src/Thumbnail.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 268 "../src/Thumbnail.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (THUMBNAIL_PROP_SIZE)))) {
#line 268 "../src/Thumbnail.vala"
		switch (0) {
#line 1190 "Thumbnail.c"
			default:
			{
				GValue _tmp3_;
#line 270 "../src/Thumbnail.vala"
				_tmp3_ = *val;
#line 270 "../src/Thumbnail.vala"
				thumbnail_resize (self, g_value_get_int (&_tmp3_));
#line 271 "../src/Thumbnail.vala"
				break;
#line 1200 "Thumbnail.c"
			}
		}
	}
#line 274 "../src/Thumbnail.vala"
	_tmp4_ = *val;
#line 274 "../src/Thumbnail.vala"
	DATA_OBJECT_CLASS (thumbnail_parent_class)->notify_collection_property_set ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_ITEM, CheckerboardItem), name, old, &_tmp4_);
#line 1208 "Thumbnail.c"
}

static void
thumbnail_resize (Thumbnail* self,
                  gint new_scale)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	Dimensions _tmp6_ = {0};
#line 277 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/Thumbnail.vala"
	_tmp0_ = thumbnail_get_MIN_SCALE ();
#line 278 "../src/Thumbnail.vala"
	_tmp1_ = _tmp0_;
#line 278 "../src/Thumbnail.vala"
	_vala_assert (new_scale >= _tmp1_, "new_scale >= MIN_SCALE");
#line 279 "../src/Thumbnail.vala"
	_tmp2_ = thumbnail_get_MAX_SCALE ();
#line 279 "../src/Thumbnail.vala"
	_tmp3_ = _tmp2_;
#line 279 "../src/Thumbnail.vala"
	_vala_assert (new_scale <= _tmp3_, "new_scale <= MAX_SCALE");
#line 281 "../src/Thumbnail.vala"
	if (self->priv->scale == new_scale) {
#line 282 "../src/Thumbnail.vala"
		return;
#line 1240 "Thumbnail.c"
	}
#line 284 "../src/Thumbnail.vala"
	self->priv->scale = new_scale;
#line 285 "../src/Thumbnail.vala"
	_tmp4_ = thumbnail_get_scale_factor (self);
#line 285 "../src/Thumbnail.vala"
	_tmp5_ = _tmp4_;
#line 285 "../src/Thumbnail.vala"
	dimensions_get_scaled (&self->priv->original_dim, self->priv->scale * _tmp5_, TRUE, &_tmp6_);
#line 285 "../src/Thumbnail.vala"
	self->priv->dim = _tmp6_;
#line 287 "../src/Thumbnail.vala"
	thumbnail_cancel_async_fetch (self);
#line 289 "../src/Thumbnail.vala"
	if (self->priv->exposure) {
#line 1256 "Thumbnail.c"
		GdkPixbuf* resizable = NULL;
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp11_;
#line 294 "../src/Thumbnail.vala"
		resizable = NULL;
#line 295 "../src/Thumbnail.vala"
		_tmp7_ = self->priv->unscaled_pixbuf;
#line 295 "../src/Thumbnail.vala"
		if (_tmp7_ != NULL) {
#line 1266 "Thumbnail.c"
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 296 "../src/Thumbnail.vala"
			_tmp8_ = self->priv->unscaled_pixbuf;
#line 296 "../src/Thumbnail.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 296 "../src/Thumbnail.vala"
			_g_object_unref0 (resizable);
#line 296 "../src/Thumbnail.vala"
			resizable = _tmp9_;
#line 1277 "Thumbnail.c"
		} else {
#line 297 "../src/Thumbnail.vala"
			if (checkerboard_item_has_image ((CheckerboardItem*) self)) {
#line 1281 "Thumbnail.c"
				GdkPixbuf* _tmp10_;
#line 298 "../src/Thumbnail.vala"
				_tmp10_ = checkerboard_item_get_image ((CheckerboardItem*) self);
#line 298 "../src/Thumbnail.vala"
				_g_object_unref0 (resizable);
#line 298 "../src/Thumbnail.vala"
				resizable = _tmp10_;
#line 1289 "Thumbnail.c"
			}
		}
#line 300 "../src/Thumbnail.vala"
		_tmp11_ = resizable;
#line 300 "../src/Thumbnail.vala"
		if (_tmp11_ != NULL) {
#line 1296 "Thumbnail.c"
			GdkPixbuf* _tmp12_;
			Dimensions _tmp13_;
			GdkPixbuf* _tmp14_;
			GdkPixbuf* _tmp15_;
#line 301 "../src/Thumbnail.vala"
			_tmp12_ = resizable;
#line 301 "../src/Thumbnail.vala"
			_tmp13_ = self->priv->dim;
#line 301 "../src/Thumbnail.vala"
			_tmp14_ = resize_pixbuf (_tmp12_, &_tmp13_, THUMBNAIL_LOW_QUALITY_INTERP);
#line 301 "../src/Thumbnail.vala"
			_tmp15_ = _tmp14_;
#line 301 "../src/Thumbnail.vala"
			checkerboard_item_set_image ((CheckerboardItem*) self, _tmp15_);
#line 301 "../src/Thumbnail.vala"
			_g_object_unref0 (_tmp15_);
#line 1313 "Thumbnail.c"
		}
#line 303 "../src/Thumbnail.vala"
		thumbnail_delayed_high_quality_fetch (self);
#line 289 "../src/Thumbnail.vala"
		_g_object_unref0 (resizable);
#line 1319 "Thumbnail.c"
	} else {
		Dimensions _tmp16_;
#line 305 "../src/Thumbnail.vala"
		_tmp16_ = self->priv->dim;
#line 305 "../src/Thumbnail.vala"
		checkerboard_item_clear_image ((CheckerboardItem*) self, &_tmp16_);
#line 1326 "Thumbnail.c"
	}
}

static void
thumbnail_paint_empty (Thumbnail* self)
{
	Dimensions _tmp0_;
#line 309 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/Thumbnail.vala"
	thumbnail_cancel_async_fetch (self);
#line 311 "../src/Thumbnail.vala"
	_tmp0_ = self->priv->dim;
#line 311 "../src/Thumbnail.vala"
	checkerboard_item_clear_image ((CheckerboardItem*) self, &_tmp0_);
#line 312 "../src/Thumbnail.vala"
	_g_object_unref0 (self->priv->unscaled_pixbuf);
#line 312 "../src/Thumbnail.vala"
	self->priv->unscaled_pixbuf = NULL;
#line 1346 "Thumbnail.c"
}

static void
_thumbnail_on_low_quality_fetched_thumbnail_cache_async_fetch_callback (GdkPixbuf* pixbuf,
                                                                        GdkPixbuf* unscaled,
                                                                        Dimensions* dim,
                                                                        GdkInterpType interp,
                                                                        GError* err,
                                                                        gpointer self)
{
#line 319 "../src/Thumbnail.vala"
	thumbnail_on_low_quality_fetched ((Thumbnail*) self, pixbuf, unscaled, dim, interp, err);
#line 1359 "Thumbnail.c"
}

static void
thumbnail_schedule_low_quality_fetch (Thumbnail* self)
{
	GCancellable* _tmp0_;
	MediaSource* _tmp1_;
	Dimensions _tmp2_;
	GCancellable* _tmp3_;
#line 315 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/Thumbnail.vala"
	thumbnail_cancel_async_fetch (self);
#line 317 "../src/Thumbnail.vala"
	_tmp0_ = g_cancellable_new ();
#line 317 "../src/Thumbnail.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 317 "../src/Thumbnail.vala"
	self->priv->cancellable = _tmp0_;
#line 319 "../src/Thumbnail.vala"
	_tmp1_ = self->priv->media;
#line 319 "../src/Thumbnail.vala"
	_tmp2_ = self->priv->dim;
#line 319 "../src/Thumbnail.vala"
	_tmp3_ = self->priv->cancellable;
#line 319 "../src/Thumbnail.vala"
	thumbnail_cache_fetch_async_scaled ((ThumbnailSource*) _tmp1_, (gint) THUMBNAIL_CACHE_SIZE_SMALLEST, &_tmp2_, THUMBNAIL_LOW_QUALITY_INTERP, _thumbnail_on_low_quality_fetched_thumbnail_cache_async_fetch_callback, self, _tmp3_);
#line 1387 "Thumbnail.c"
}

static gboolean
_thumbnail_on_schedule_high_quality_gsource_func (gpointer self)
{
	gboolean result;
	result = thumbnail_on_schedule_high_quality ((Thumbnail*) self);
#line 330 "../src/Thumbnail.vala"
	return result;
#line 1397 "Thumbnail.c"
}

static void
thumbnail_delayed_high_quality_fetch (Thumbnail* self)
{
#line 323 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/Thumbnail.vala"
	if (self->priv->hq_scheduled) {
#line 325 "../src/Thumbnail.vala"
		self->priv->hq_reschedule = TRUE;
#line 327 "../src/Thumbnail.vala"
		return;
#line 1411 "Thumbnail.c"
	}
#line 330 "../src/Thumbnail.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) THUMBNAIL_HQ_IMPROVEMENT_MSEC, _thumbnail_on_schedule_high_quality_gsource_func, g_object_ref (self), g_object_unref);
#line 331 "../src/Thumbnail.vala"
	self->priv->hq_scheduled = TRUE;
#line 1417 "Thumbnail.c"
}

static void
_thumbnail_on_high_quality_fetched_thumbnail_cache_async_fetch_callback (GdkPixbuf* pixbuf,
                                                                         GdkPixbuf* unscaled,
                                                                         Dimensions* dim,
                                                                         GdkInterpType interp,
                                                                         GError* err,
                                                                         gpointer self)
{
#line 345 "../src/Thumbnail.vala"
	thumbnail_on_high_quality_fetched ((Thumbnail*) self, pixbuf, unscaled, dim, interp, err);
#line 1430 "Thumbnail.c"
}

static gboolean
thumbnail_on_schedule_high_quality (Thumbnail* self)
{
	GCancellable* _tmp0_;
	gboolean result;
#line 334 "../src/Thumbnail.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 335 "../src/Thumbnail.vala"
	if (self->priv->hq_reschedule) {
#line 336 "../src/Thumbnail.vala"
		self->priv->hq_reschedule = FALSE;
#line 338 "../src/Thumbnail.vala"
		result = TRUE;
#line 338 "../src/Thumbnail.vala"
		return result;
#line 1448 "Thumbnail.c"
	}
#line 341 "../src/Thumbnail.vala"
	thumbnail_cancel_async_fetch (self);
#line 342 "../src/Thumbnail.vala"
	_tmp0_ = g_cancellable_new ();
#line 342 "../src/Thumbnail.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 342 "../src/Thumbnail.vala"
	self->priv->cancellable = _tmp0_;
#line 344 "../src/Thumbnail.vala"
	if (self->priv->exposure) {
#line 1460 "Thumbnail.c"
		MediaSource* _tmp1_;
		Dimensions _tmp2_;
		GCancellable* _tmp3_;
#line 345 "../src/Thumbnail.vala"
		_tmp1_ = self->priv->media;
#line 345 "../src/Thumbnail.vala"
		_tmp2_ = self->priv->dim;
#line 345 "../src/Thumbnail.vala"
		_tmp3_ = self->priv->cancellable;
#line 345 "../src/Thumbnail.vala"
		thumbnail_cache_fetch_async_scaled ((ThumbnailSource*) _tmp1_, self->priv->scale, &_tmp2_, THUMBNAIL_HIGH_QUALITY_INTERP, _thumbnail_on_high_quality_fetched_thumbnail_cache_async_fetch_callback, self, _tmp3_);
#line 1472 "Thumbnail.c"
	}
#line 349 "../src/Thumbnail.vala"
	self->priv->hq_scheduled = FALSE;
#line 351 "../src/Thumbnail.vala"
	result = FALSE;
#line 351 "../src/Thumbnail.vala"
	return result;
#line 1480 "Thumbnail.c"
}

static void
thumbnail_cancel_async_fetch (Thumbnail* self)
{
	GCancellable* _tmp0_;
#line 354 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/Thumbnail.vala"
	_tmp0_ = self->priv->cancellable;
#line 356 "../src/Thumbnail.vala"
	if (_tmp0_ != NULL) {
#line 1493 "Thumbnail.c"
		GCancellable* _tmp1_;
#line 357 "../src/Thumbnail.vala"
		_tmp1_ = self->priv->cancellable;
#line 357 "../src/Thumbnail.vala"
		g_cancellable_cancel (_tmp1_);
#line 1499 "Thumbnail.c"
	}
}

static void
thumbnail_on_low_quality_fetched (Thumbnail* self,
                                  GdkPixbuf* pixbuf,
                                  GdkPixbuf* unscaled,
                                  Dimensions* dim,
                                  GdkInterpType interp,
                                  GError* err)
{
#line 360 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/Thumbnail.vala"
	g_return_if_fail (dim != NULL);
#line 362 "../src/Thumbnail.vala"
	if (err != NULL) {
#line 1517 "Thumbnail.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 363 "../src/Thumbnail.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 363 "../src/Thumbnail.vala"
		_tmp1_ = _tmp0_;
#line 363 "../src/Thumbnail.vala"
		_tmp2_ = err->message;
#line 363 "../src/Thumbnail.vala"
		g_critical ("Thumbnail.vala:363: Unable to fetch low-quality thumbnail for %s (scal" \
"e: %d): %s", _tmp1_, self->priv->scale, _tmp2_);
#line 363 "../src/Thumbnail.vala"
		_g_free0 (_tmp1_);
#line 1531 "Thumbnail.c"
	}
#line 366 "../src/Thumbnail.vala"
	if (pixbuf != NULL) {
#line 367 "../src/Thumbnail.vala"
		checkerboard_item_set_image ((CheckerboardItem*) self, pixbuf);
#line 1537 "Thumbnail.c"
	}
#line 369 "../src/Thumbnail.vala"
	if (unscaled != NULL) {
#line 1541 "Thumbnail.c"
		GdkPixbuf* _tmp3_;
#line 370 "../src/Thumbnail.vala"
		_tmp3_ = _g_object_ref0 (unscaled);
#line 370 "../src/Thumbnail.vala"
		_g_object_unref0 (self->priv->unscaled_pixbuf);
#line 370 "../src/Thumbnail.vala"
		self->priv->unscaled_pixbuf = _tmp3_;
#line 1549 "Thumbnail.c"
	}
#line 372 "../src/Thumbnail.vala"
	thumbnail_delayed_high_quality_fetch (self);
#line 1553 "Thumbnail.c"
}

static void
thumbnail_on_high_quality_fetched (Thumbnail* self,
                                   GdkPixbuf* pixbuf,
                                   GdkPixbuf* unscaled,
                                   Dimensions* dim,
                                   GdkInterpType interp,
                                   GError* err)
{
#line 375 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/Thumbnail.vala"
	g_return_if_fail (dim != NULL);
#line 377 "../src/Thumbnail.vala"
	if (err != NULL) {
#line 1570 "Thumbnail.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 378 "../src/Thumbnail.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 378 "../src/Thumbnail.vala"
		_tmp1_ = _tmp0_;
#line 378 "../src/Thumbnail.vala"
		_tmp2_ = err->message;
#line 378 "../src/Thumbnail.vala"
		g_critical ("Thumbnail.vala:378: Unable to fetch high-quality thumbnail for %s (sca" \
"le: %d): %s", _tmp1_, self->priv->scale, _tmp2_);
#line 378 "../src/Thumbnail.vala"
		_g_free0 (_tmp1_);
#line 1584 "Thumbnail.c"
	}
#line 381 "../src/Thumbnail.vala"
	if (pixbuf != NULL) {
#line 382 "../src/Thumbnail.vala"
		checkerboard_item_set_image ((CheckerboardItem*) self, pixbuf);
#line 1590 "Thumbnail.c"
	}
#line 384 "../src/Thumbnail.vala"
	if (unscaled != NULL) {
#line 1594 "Thumbnail.c"
		GdkPixbuf* _tmp3_;
#line 385 "../src/Thumbnail.vala"
		_tmp3_ = _g_object_ref0 (unscaled);
#line 385 "../src/Thumbnail.vala"
		_g_object_unref0 (self->priv->unscaled_pixbuf);
#line 385 "../src/Thumbnail.vala"
		self->priv->unscaled_pixbuf = _tmp3_;
#line 1602 "Thumbnail.c"
	}
}

static void
thumbnail_real_exposed (CheckerboardItem* base)
{
	Thumbnail * self;
#line 388 "../src/Thumbnail.vala"
	self = (Thumbnail*) base;
#line 389 "../src/Thumbnail.vala"
	self->priv->exposure = TRUE;
#line 391 "../src/Thumbnail.vala"
	if (!checkerboard_item_has_image ((CheckerboardItem*) self)) {
#line 392 "../src/Thumbnail.vala"
		thumbnail_schedule_low_quality_fetch (self);
#line 1618 "Thumbnail.c"
	}
#line 394 "../src/Thumbnail.vala"
	thumbnail_update_title (self, FALSE);
#line 395 "../src/Thumbnail.vala"
	thumbnail_update_comment (self, FALSE);
#line 396 "../src/Thumbnail.vala"
	thumbnail_update_tags (self, FALSE);
#line 398 "../src/Thumbnail.vala"
	CHECKERBOARD_ITEM_CLASS (thumbnail_parent_class)->exposed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_ITEM, CheckerboardItem));
#line 1628 "Thumbnail.c"
}

static void
thumbnail_real_unexposed (CheckerboardItem* base)
{
	Thumbnail * self;
#line 401 "../src/Thumbnail.vala"
	self = (Thumbnail*) base;
#line 402 "../src/Thumbnail.vala"
	self->priv->exposure = FALSE;
#line 404 "../src/Thumbnail.vala"
	thumbnail_paint_empty (self);
#line 406 "../src/Thumbnail.vala"
	CHECKERBOARD_ITEM_CLASS (thumbnail_parent_class)->unexposed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_ITEM, CheckerboardItem));
#line 1643 "Thumbnail.c"
}

static void
thumbnail_real_paint (CheckerboardItem* base,
                      cairo_t* ctx,
                      GtkStyleContext* style_context)
{
	Thumbnail * self;
	gboolean _tmp0_ = FALSE;
	MediaSource* _tmp1_;
#line 409 "../src/Thumbnail.vala"
	self = (Thumbnail*) base;
#line 409 "../src/Thumbnail.vala"
	g_return_if_fail (ctx != NULL);
#line 409 "../src/Thumbnail.vala"
	g_return_if_fail (style_context != NULL);
#line 410 "../src/Thumbnail.vala"
	CHECKERBOARD_ITEM_CLASS (thumbnail_parent_class)->paint (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_ITEM, CheckerboardItem), ctx, style_context);
#line 412 "../src/Thumbnail.vala"
	thumbnail_set_scale_factor (self, gtk_style_context_get_scale (style_context));
#line 414 "../src/Thumbnail.vala"
	_tmp1_ = self->priv->media;
#line 414 "../src/Thumbnail.vala"
	if (_tmp1_ != NULL) {
#line 1668 "Thumbnail.c"
		MediaSource* _tmp2_;
#line 414 "../src/Thumbnail.vala"
		_tmp2_ = self->priv->media;
#line 414 "../src/Thumbnail.vala"
		_tmp0_ = IS_FLAGGABLE (_tmp2_);
#line 1674 "Thumbnail.c"
	} else {
#line 414 "../src/Thumbnail.vala"
		_tmp0_ = FALSE;
#line 1678 "Thumbnail.c"
	}
#line 414 "../src/Thumbnail.vala"
	if (_tmp0_) {
#line 1682 "Thumbnail.c"
		MediaSource* _tmp3_;
#line 415 "../src/Thumbnail.vala"
		_tmp3_ = self->priv->media;
#line 415 "../src/Thumbnail.vala"
		if (flaggable_is_flagged (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_FLAGGABLE, Flaggable))) {
#line 1688 "Thumbnail.c"
			GdkPixbuf* flag_icon = NULL;
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
			GdkPixbuf* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			GdkRectangle _tmp11_;
#line 416 "../src/Thumbnail.vala"
			gtk_style_context_save (style_context);
#line 417 "../src/Thumbnail.vala"
			gtk_style_context_add_class (style_context, GRANITE_STYLE_CLASS_OVERLAY_BAR);
#line 418 "../src/Thumbnail.vala"
			_tmp4_ = resources_get_flag_trinket ();
#line 418 "../src/Thumbnail.vala"
			flag_icon = _tmp4_;
#line 419 "../src/Thumbnail.vala"
			_tmp5_ = flag_icon;
#line 419 "../src/Thumbnail.vala"
			_tmp6_ = ((CheckerboardItem*) self)->allocation;
#line 419 "../src/Thumbnail.vala"
			_tmp7_ = ((CheckerboardItem*) self)->allocation;
#line 419 "../src/Thumbnail.vala"
			_tmp8_ = flag_icon;
#line 419 "../src/Thumbnail.vala"
			_tmp9_ = gdk_pixbuf_get_width (_tmp8_);
#line 419 "../src/Thumbnail.vala"
			_tmp10_ = _tmp9_;
#line 419 "../src/Thumbnail.vala"
			_tmp11_ = ((CheckerboardItem*) self)->allocation;
#line 419 "../src/Thumbnail.vala"
			gtk_render_icon (style_context, ctx, _tmp5_, (gdouble) ((_tmp6_.x + _tmp7_.width) - (((_tmp10_ + CHECKERBOARD_ITEM_FRAME_WIDTH) + CHECKERBOARD_ITEM_BORDER_WIDTH) + THUMBNAIL_FLAG_OFFSET)), (gdouble) (((_tmp11_.y + CHECKERBOARD_ITEM_FRAME_WIDTH) + CHECKERBOARD_ITEM_BORDER_WIDTH) + THUMBNAIL_FLAG_OFFSET));
#line 420 "../src/Thumbnail.vala"
			gtk_style_context_restore (style_context);
#line 415 "../src/Thumbnail.vala"
			_g_object_unref0 (flag_icon);
#line 1726 "Thumbnail.c"
		}
	}
}

gint
thumbnail_get_MIN_SCALE (void)
{
	gint result;
#line 31 "../src/Thumbnail.vala"
	result = 92;
#line 31 "../src/Thumbnail.vala"
	return result;
#line 1739 "Thumbnail.c"
}

gint
thumbnail_get_MAX_SCALE (void)
{
	gint result;
#line 36 "../src/Thumbnail.vala"
	result = thumbnail_cache_size_get_scale (THUMBNAIL_CACHE_SIZE_LARGEST);
#line 36 "../src/Thumbnail.vala"
	return result;
#line 1750 "Thumbnail.c"
}

gint
thumbnail_get_DEFAULT_SCALE (void)
{
	gint result;
#line 41 "../src/Thumbnail.vala"
	result = thumbnail_cache_size_get_scale (THUMBNAIL_CACHE_SIZE_MEDIUM);
#line 41 "../src/Thumbnail.vala"
	return result;
#line 1761 "Thumbnail.c"
}

static gint
thumbnail_get_scale_factor (Thumbnail* self)
{
	gint result;
#line 47 "../src/Thumbnail.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "../src/Thumbnail.vala"
	result = thumbnail__scale_factor;
#line 48 "../src/Thumbnail.vala"
	return result;
#line 1774 "Thumbnail.c"
}

static void
thumbnail_set_scale_factor (Thumbnail* self,
                            gint value)
{
#line 50 "../src/Thumbnail.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Thumbnail.vala"
	if (thumbnail__scale_factor != value) {
#line 52 "../src/Thumbnail.vala"
		thumbnail__scale_factor = value;
#line 53 "../src/Thumbnail.vala"
		data_view_notify_view_altered ((DataView*) self);
#line 1789 "Thumbnail.c"
	}
}

static void
thumbnail_class_init (ThumbnailClass * klass,
                      gpointer klass_data)
{
#line 20 "../src/Thumbnail.vala"
	thumbnail_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Thumbnail.vala"
	g_type_class_adjust_private_offset (klass, &Thumbnail_private_offset);
#line 20 "../src/Thumbnail.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) thumbnail_real_notify_altered;
#line 20 "../src/Thumbnail.vala"
	((ThumbnailViewClass *) klass)->thumbnail_altered = (void (*) (ThumbnailView*)) thumbnail_real_thumbnail_altered;
#line 20 "../src/Thumbnail.vala"
	((DataObjectClass *) klass)->notify_collection_property_set = (void (*) (DataObject*, const gchar*, GValue*, GValue*)) thumbnail_real_notify_collection_property_set;
#line 20 "../src/Thumbnail.vala"
	((CheckerboardItemClass *) klass)->exposed = (void (*) (CheckerboardItem*)) thumbnail_real_exposed;
#line 20 "../src/Thumbnail.vala"
	((CheckerboardItemClass *) klass)->unexposed = (void (*) (CheckerboardItem*)) thumbnail_real_unexposed;
#line 20 "../src/Thumbnail.vala"
	((CheckerboardItemClass *) klass)->paint = (void (*) (CheckerboardItem*, cairo_t*, GtkStyleContext*)) thumbnail_real_paint;
#line 20 "../src/Thumbnail.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_thumbnail_get_property;
#line 20 "../src/Thumbnail.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_thumbnail_set_property;
#line 20 "../src/Thumbnail.vala"
	G_OBJECT_CLASS (klass)->finalize = thumbnail_finalize;
#line 1819 "Thumbnail.c"
}

static void
thumbnail_instance_init (Thumbnail * self,
                         gpointer klass)
{
#line 20 "../src/Thumbnail.vala"
	self->priv = thumbnail_get_instance_private (self);
#line 67 "../src/Thumbnail.vala"
	self->priv->unscaled_pixbuf = NULL;
#line 68 "../src/Thumbnail.vala"
	self->priv->cancellable = NULL;
#line 69 "../src/Thumbnail.vala"
	self->priv->hq_scheduled = FALSE;
#line 70 "../src/Thumbnail.vala"
	self->priv->hq_reschedule = FALSE;
#line 73 "../src/Thumbnail.vala"
	self->priv->exposure = FALSE;
#line 1838 "Thumbnail.c"
}

static void
thumbnail_finalize (GObject * obj)
{
	Thumbnail * self;
	GCancellable* _tmp0_;
	TagSourceCollection* _tmp2_;
	guint _tmp3_;
	TagSourceCollection* _tmp4_;
	guint _tmp5_;
#line 20 "../src/Thumbnail.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THUMBNAIL, Thumbnail);
#line 98 "../src/Thumbnail.vala"
	_tmp0_ = self->priv->cancellable;
#line 98 "../src/Thumbnail.vala"
	if (_tmp0_ != NULL) {
#line 1856 "Thumbnail.c"
		GCancellable* _tmp1_;
#line 99 "../src/Thumbnail.vala"
		_tmp1_ = self->priv->cancellable;
#line 99 "../src/Thumbnail.vala"
		g_cancellable_cancel (_tmp1_);
#line 1862 "Thumbnail.c"
	}
#line 101 "../src/Thumbnail.vala"
	_tmp2_ = tag_global;
#line 101 "../src/Thumbnail.vala"
	g_signal_parse_name ("container-contents-altered", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 101 "../src/Thumbnail.vala"
	g_signal_handlers_disconnect_matched ((ContainerSourceCollection*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _thumbnail_on_tag_contents_altered_container_source_collection_container_contents_altered, self);
#line 102 "../src/Thumbnail.vala"
	_tmp4_ = tag_global;
#line 102 "../src/Thumbnail.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp5_, NULL, FALSE);
#line 102 "../src/Thumbnail.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _thumbnail_on_tags_altered_data_collection_items_altered, self);
#line 63 "../src/Thumbnail.vala"
	_g_object_unref0 (self->priv->media);
#line 67 "../src/Thumbnail.vala"
	_g_object_unref0 (self->priv->unscaled_pixbuf);
#line 68 "../src/Thumbnail.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 20 "../src/Thumbnail.vala"
	G_OBJECT_CLASS (thumbnail_parent_class)->finalize (obj);
#line 1884 "Thumbnail.c"
}

static GType
thumbnail_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThumbnailClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Thumbnail), 0, (GInstanceInitFunc) thumbnail_instance_init, NULL };
	GType thumbnail_type_id;
	thumbnail_type_id = g_type_register_static (TYPE_CHECKERBOARD_ITEM, "Thumbnail", &g_define_type_info, 0);
	Thumbnail_private_offset = g_type_add_instance_private (thumbnail_type_id, sizeof (ThumbnailPrivate));
	return thumbnail_type_id;
}

GType
thumbnail_get_type (void)
{
	static volatile gsize thumbnail_type_id__once = 0;
	if (g_once_init_enter (&thumbnail_type_id__once)) {
		GType thumbnail_type_id;
		thumbnail_type_id = thumbnail_get_type_once ();
		g_once_init_leave (&thumbnail_type_id__once, thumbnail_type_id);
	}
	return thumbnail_type_id__once;
}

static void
_vala_thumbnail_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Thumbnail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THUMBNAIL, Thumbnail);
#line 20 "../src/Thumbnail.vala"
	switch (property_id) {
#line 1919 "Thumbnail.c"
		default:
#line 20 "../src/Thumbnail.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Thumbnail.vala"
		break;
#line 1925 "Thumbnail.c"
	}
}

static void
_vala_thumbnail_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Thumbnail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THUMBNAIL, Thumbnail);
#line 20 "../src/Thumbnail.vala"
	switch (property_id) {
#line 1939 "Thumbnail.c"
		default:
#line 20 "../src/Thumbnail.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Thumbnail.vala"
		break;
#line 1945 "Thumbnail.c"
	}
}

