/* Upgrades.c generated by valac 0.56.18, the Vala compiler
 * generated from Upgrades.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Class for aggregating one-off "upgrade" tasks that occur at startup, such as*/
/* moving or deleting files. This occurs after the UI is shown, so it's not appropriate*/
/* for database updates and such.*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_UPGRADE_TASK (upgrade_task_get_type ())
#define UPGRADE_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UPGRADE_TASK, UpgradeTask))
#define IS_UPGRADE_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UPGRADE_TASK))
#define UPGRADE_TASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_UPGRADE_TASK, UpgradeTaskIface))

typedef struct _UpgradeTask UpgradeTask;
typedef struct _UpgradeTaskIface UpgradeTaskIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MIMICS_REMOVAL_TASK (mimics_removal_task_get_type ())
#define MIMICS_REMOVAL_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTask))
#define MIMICS_REMOVAL_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTaskClass))
#define IS_MIMICS_REMOVAL_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIMICS_REMOVAL_TASK))
#define IS_MIMICS_REMOVAL_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIMICS_REMOVAL_TASK))
#define MIMICS_REMOVAL_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTaskClass))

typedef struct _MimicsRemovalTask MimicsRemovalTask;
typedef struct _MimicsRemovalTaskClass MimicsRemovalTaskClass;

#define TYPE_FIXUP_RAW_THUMBNAILS_TASK (fixup_raw_thumbnails_task_get_type ())
#define FIXUP_RAW_THUMBNAILS_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FIXUP_RAW_THUMBNAILS_TASK, FixupRawThumbnailsTask))
#define FIXUP_RAW_THUMBNAILS_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FIXUP_RAW_THUMBNAILS_TASK, FixupRawThumbnailsTaskClass))
#define IS_FIXUP_RAW_THUMBNAILS_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FIXUP_RAW_THUMBNAILS_TASK))
#define IS_FIXUP_RAW_THUMBNAILS_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FIXUP_RAW_THUMBNAILS_TASK))
#define FIXUP_RAW_THUMBNAILS_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FIXUP_RAW_THUMBNAILS_TASK, FixupRawThumbnailsTaskClass))

typedef struct _FixupRawThumbnailsTask FixupRawThumbnailsTask;
typedef struct _FixupRawThumbnailsTaskClass FixupRawThumbnailsTaskClass;
#define _upgrades_unref0(var) ((var == NULL) ? NULL : (var = (upgrades_unref (var), NULL)))
typedef struct _ParamSpecUpgrades ParamSpecUpgrades;
typedef struct _MimicsRemovalTaskPrivate MimicsRemovalTaskPrivate;
enum  {
	MIMICS_REMOVAL_TASK_0_PROPERTY,
	MIMICS_REMOVAL_TASK_NUM_PROPERTIES
};
static GParamSpec* mimics_removal_task_properties[MIMICS_REMOVAL_TASK_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FixupRawThumbnailsTaskPrivate FixupRawThumbnailsTaskPrivate;
enum  {
	FIXUP_RAW_THUMBNAILS_TASK_0_PROPERTY,
	FIXUP_RAW_THUMBNAILS_TASK_NUM_PROPERTIES
};
static GParamSpec* fixup_raw_thumbnails_task_properties[FIXUP_RAW_THUMBNAILS_TASK_NUM_PROPERTIES];
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _UpgradeTaskIface {
	GTypeInterface parent_iface;
	guint64 (*get_step_count) (UpgradeTask* self);
	void (*execute) (UpgradeTask* self, ProgressMonitor monitor, gpointer monitor_target);
};

struct _UpgradesPrivate {
	guint64 total_steps;
	GeeLinkedList* task_list;
};

struct _ParamSpecUpgrades {
	GParamSpec parent_instance;
};

struct _MimicsRemovalTask {
	GObject parent_instance;
	MimicsRemovalTaskPrivate * priv;
};

struct _MimicsRemovalTaskClass {
	GObjectClass parent_class;
};

struct _MimicsRemovalTaskPrivate {
	GFile* mimic_dir;
	guint64 num_mimics;
};

struct _FixupRawThumbnailsTask {
	GObject parent_instance;
	FixupRawThumbnailsTaskPrivate * priv;
};

struct _FixupRawThumbnailsTaskClass {
	GObjectClass parent_class;
};

static gint Upgrades_private_offset;
static gpointer upgrades_parent_class = NULL;
static Upgrades* upgrades_instance;
static Upgrades* upgrades_instance = NULL;
static gint MimicsRemovalTask_private_offset;
static gpointer mimics_removal_task_parent_class = NULL;
static UpgradeTaskIface * mimics_removal_task_upgrade_task_parent_iface = NULL;
static gpointer fixup_raw_thumbnails_task_parent_class = NULL;
static UpgradeTaskIface * fixup_raw_thumbnails_task_upgrade_task_parent_iface = NULL;

VALA_EXTERN GType upgrade_task_get_type (void) G_GNUC_CONST ;
static Upgrades* upgrades_new (void);
static Upgrades* upgrades_construct (GType object_type);
static void upgrades_add (Upgrades* self,
                   UpgradeTask* task);
VALA_EXTERN MimicsRemovalTask* mimics_removal_task_new (void);
VALA_EXTERN MimicsRemovalTask* mimics_removal_task_construct (GType object_type);
VALA_EXTERN GType mimics_removal_task_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FixupRawThumbnailsTask* fixup_raw_thumbnails_task_new (void);
VALA_EXTERN FixupRawThumbnailsTask* fixup_raw_thumbnails_task_construct (GType object_type);
VALA_EXTERN GType fixup_raw_thumbnails_task_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void upgrade_task_execute (UpgradeTask* self,
                           ProgressMonitor monitor,
                           gpointer monitor_target);
VALA_EXTERN guint64 upgrade_task_get_step_count (UpgradeTask* self);
static void upgrades_finalize (Upgrades * obj);
static GType upgrades_get_type_once (void);
static GType upgrade_task_get_type_once (void);
VALA_EXTERN GFile* app_dirs_get_data_dir (void);
static guint64 mimics_removal_task_real_get_step_count (UpgradeTask* base);
static void mimics_removal_task_real_execute (UpgradeTask* base,
                                       ProgressMonitor monitor,
                                       gpointer monitor_target);
static void mimics_removal_task_finalize (GObject * obj);
static GType mimics_removal_task_get_type_once (void);
static guint64 fixup_raw_thumbnails_task_real_get_step_count (UpgradeTask* base);
static void fixup_raw_thumbnails_task_real_execute (UpgradeTask* base,
                                             ProgressMonitor monitor,
                                             gpointer monitor_target);
static GType fixup_raw_thumbnails_task_get_type_once (void);

static inline gpointer
upgrades_get_instance_private (Upgrades* self)
{
	return G_STRUCT_MEMBER_P (self, Upgrades_private_offset);
}

static Upgrades*
upgrades_construct (GType object_type)
{
	Upgrades* self = NULL;
	MimicsRemovalTask* _tmp0_;
	MimicsRemovalTask* _tmp1_;
	GApplication* _tmp2_;
#line 28 "../src/Upgrades.vala"
	self = (Upgrades*) g_type_create_instance (object_type);
#line 30 "../src/Upgrades.vala"
	_tmp0_ = mimics_removal_task_new ();
#line 30 "../src/Upgrades.vala"
	_tmp1_ = _tmp0_;
#line 30 "../src/Upgrades.vala"
	upgrades_add (self, (UpgradeTask*) _tmp1_);
#line 30 "../src/Upgrades.vala"
	_g_object_unref0 (_tmp1_);
#line 32 "../src/Upgrades.vala"
	_tmp2_ = g_application_get_default ();
#line 32 "../src/Upgrades.vala"
	if (photos_application_get_raw_thumbs_fix_required (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, PHOTOS_TYPE_APPLICATION, PhotosApplication))) {
#line 201 "Upgrades.c"
		FixupRawThumbnailsTask* _tmp3_;
		FixupRawThumbnailsTask* _tmp4_;
#line 33 "../src/Upgrades.vala"
		_tmp3_ = fixup_raw_thumbnails_task_new ();
#line 33 "../src/Upgrades.vala"
		_tmp4_ = _tmp3_;
#line 33 "../src/Upgrades.vala"
		upgrades_add (self, (UpgradeTask*) _tmp4_);
#line 33 "../src/Upgrades.vala"
		_g_object_unref0 (_tmp4_);
#line 212 "Upgrades.c"
	}
#line 28 "../src/Upgrades.vala"
	return self;
#line 216 "Upgrades.c"
}

static Upgrades*
upgrades_new (void)
{
#line 28 "../src/Upgrades.vala"
	return upgrades_construct (TYPE_UPGRADES);
#line 224 "Upgrades.c"
}

void
upgrades_init (void)
{
	Upgrades* _tmp0_;
	Upgrades* _tmp1_;
#line 38 "../src/Upgrades.vala"
	_tmp0_ = upgrades_instance;
#line 38 "../src/Upgrades.vala"
	_vala_assert (_tmp0_ == NULL, "instance == null");
#line 39 "../src/Upgrades.vala"
	_tmp1_ = upgrades_new ();
#line 39 "../src/Upgrades.vala"
	_upgrades_unref0 (upgrades_instance);
#line 39 "../src/Upgrades.vala"
	upgrades_instance = _tmp1_;
#line 242 "Upgrades.c"
}

static gpointer
_upgrades_ref0 (gpointer self)
{
#line 43 "../src/Upgrades.vala"
	return self ? upgrades_ref (self) : NULL;
#line 250 "Upgrades.c"
}

Upgrades*
upgrades_get_instance (void)
{
	Upgrades* _tmp0_;
	Upgrades* _tmp1_;
	Upgrades* result;
#line 43 "../src/Upgrades.vala"
	_tmp0_ = upgrades_instance;
#line 43 "../src/Upgrades.vala"
	_tmp1_ = _upgrades_ref0 (_tmp0_);
#line 43 "../src/Upgrades.vala"
	result = _tmp1_;
#line 43 "../src/Upgrades.vala"
	return result;
#line 267 "Upgrades.c"
}

guint64
upgrades_get_step_count (Upgrades* self)
{
	guint64 result;
#line 47 "../src/Upgrades.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 48 "../src/Upgrades.vala"
	result = self->priv->total_steps;
#line 48 "../src/Upgrades.vala"
	return result;
#line 280 "Upgrades.c"
}

void
upgrades_execute (Upgrades* self,
                  ProgressMonitor monitor,
                  gpointer monitor_target)
{
#line 52 "../src/Upgrades.vala"
	g_return_if_fail (self != NULL);
#line 290 "Upgrades.c"
	{
		GeeLinkedList* _task_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _task_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _task_index = 0;
#line 53 "../src/Upgrades.vala"
		_tmp0_ = self->priv->task_list;
#line 53 "../src/Upgrades.vala"
		_task_list = _tmp0_;
#line 53 "../src/Upgrades.vala"
		_tmp1_ = _task_list;
#line 53 "../src/Upgrades.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 53 "../src/Upgrades.vala"
		_tmp3_ = _tmp2_;
#line 53 "../src/Upgrades.vala"
		_task_size = _tmp3_;
#line 53 "../src/Upgrades.vala"
		_task_index = -1;
#line 53 "../src/Upgrades.vala"
		while (TRUE) {
#line 315 "Upgrades.c"
			gint _tmp4_;
			gint _tmp5_;
			UpgradeTask* task = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			UpgradeTask* _tmp8_;
#line 53 "../src/Upgrades.vala"
			_task_index = _task_index + 1;
#line 53 "../src/Upgrades.vala"
			_tmp4_ = _task_index;
#line 53 "../src/Upgrades.vala"
			_tmp5_ = _task_size;
#line 53 "../src/Upgrades.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 53 "../src/Upgrades.vala"
				break;
#line 332 "Upgrades.c"
			}
#line 53 "../src/Upgrades.vala"
			_tmp6_ = _task_list;
#line 53 "../src/Upgrades.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _task_index);
#line 53 "../src/Upgrades.vala"
			task = (UpgradeTask*) _tmp7_;
#line 54 "../src/Upgrades.vala"
			_tmp8_ = task;
#line 54 "../src/Upgrades.vala"
			upgrade_task_execute (_tmp8_, monitor, monitor_target);
#line 53 "../src/Upgrades.vala"
			_g_object_unref0 (task);
#line 346 "Upgrades.c"
		}
	}
}

static void
upgrades_add (Upgrades* self,
              UpgradeTask* task)
{
	GeeLinkedList* _tmp0_;
#line 57 "../src/Upgrades.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/Upgrades.vala"
	g_return_if_fail (task != NULL);
#line 58 "../src/Upgrades.vala"
	self->priv->total_steps = self->priv->total_steps + upgrade_task_get_step_count (task);
#line 59 "../src/Upgrades.vala"
	_tmp0_ = self->priv->task_list;
#line 59 "../src/Upgrades.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, task);
#line 366 "Upgrades.c"
}

static void
value_upgrades_init (GValue* value)
{
#line 23 "../src/Upgrades.vala"
	value->data[0].v_pointer = NULL;
#line 374 "Upgrades.c"
}

static void
value_upgrades_free_value (GValue* value)
{
#line 23 "../src/Upgrades.vala"
	if (value->data[0].v_pointer) {
#line 23 "../src/Upgrades.vala"
		upgrades_unref (value->data[0].v_pointer);
#line 384 "Upgrades.c"
	}
}

static void
value_upgrades_copy_value (const GValue* src_value,
                           GValue* dest_value)
{
#line 23 "../src/Upgrades.vala"
	if (src_value->data[0].v_pointer) {
#line 23 "../src/Upgrades.vala"
		dest_value->data[0].v_pointer = upgrades_ref (src_value->data[0].v_pointer);
#line 396 "Upgrades.c"
	} else {
#line 23 "../src/Upgrades.vala"
		dest_value->data[0].v_pointer = NULL;
#line 400 "Upgrades.c"
	}
}

static gpointer
value_upgrades_peek_pointer (const GValue* value)
{
#line 23 "../src/Upgrades.vala"
	return value->data[0].v_pointer;
#line 409 "Upgrades.c"
}

static gchar*
value_upgrades_collect_value (GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
#line 23 "../src/Upgrades.vala"
	if (collect_values[0].v_pointer) {
#line 420 "Upgrades.c"
		Upgrades * object;
		object = collect_values[0].v_pointer;
#line 23 "../src/Upgrades.vala"
		if (object->parent_instance.g_class == NULL) {
#line 23 "../src/Upgrades.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 427 "Upgrades.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 23 "../src/Upgrades.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 431 "Upgrades.c"
		}
#line 23 "../src/Upgrades.vala"
		value->data[0].v_pointer = upgrades_ref (object);
#line 435 "Upgrades.c"
	} else {
#line 23 "../src/Upgrades.vala"
		value->data[0].v_pointer = NULL;
#line 439 "Upgrades.c"
	}
#line 23 "../src/Upgrades.vala"
	return NULL;
#line 443 "Upgrades.c"
}

static gchar*
value_upgrades_lcopy_value (const GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
	Upgrades ** object_p;
	object_p = collect_values[0].v_pointer;
#line 23 "../src/Upgrades.vala"
	if (!object_p) {
#line 23 "../src/Upgrades.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 458 "Upgrades.c"
	}
#line 23 "../src/Upgrades.vala"
	if (!value->data[0].v_pointer) {
#line 23 "../src/Upgrades.vala"
		*object_p = NULL;
#line 464 "Upgrades.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 23 "../src/Upgrades.vala"
		*object_p = value->data[0].v_pointer;
#line 468 "Upgrades.c"
	} else {
#line 23 "../src/Upgrades.vala"
		*object_p = upgrades_ref (value->data[0].v_pointer);
#line 472 "Upgrades.c"
	}
#line 23 "../src/Upgrades.vala"
	return NULL;
#line 476 "Upgrades.c"
}

GParamSpec*
param_spec_upgrades (const gchar* name,
                     const gchar* nick,
                     const gchar* blurb,
                     GType object_type,
                     GParamFlags flags)
{
	ParamSpecUpgrades* spec;
#line 23 "../src/Upgrades.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_UPGRADES), NULL);
#line 23 "../src/Upgrades.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 23 "../src/Upgrades.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 23 "../src/Upgrades.vala"
	return G_PARAM_SPEC (spec);
#line 495 "Upgrades.c"
}

gpointer
value_get_upgrades (const GValue* value)
{
#line 23 "../src/Upgrades.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES), NULL);
#line 23 "../src/Upgrades.vala"
	return value->data[0].v_pointer;
#line 505 "Upgrades.c"
}

void
value_set_upgrades (GValue* value,
                    gpointer v_object)
{
	Upgrades * old;
#line 23 "../src/Upgrades.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES));
#line 23 "../src/Upgrades.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/Upgrades.vala"
	if (v_object) {
#line 23 "../src/Upgrades.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UPGRADES));
#line 23 "../src/Upgrades.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/Upgrades.vala"
		value->data[0].v_pointer = v_object;
#line 23 "../src/Upgrades.vala"
		upgrades_ref (value->data[0].v_pointer);
#line 527 "Upgrades.c"
	} else {
#line 23 "../src/Upgrades.vala"
		value->data[0].v_pointer = NULL;
#line 531 "Upgrades.c"
	}
#line 23 "../src/Upgrades.vala"
	if (old) {
#line 23 "../src/Upgrades.vala"
		upgrades_unref (old);
#line 537 "Upgrades.c"
	}
}

void
value_take_upgrades (GValue* value,
                     gpointer v_object)
{
	Upgrades * old;
#line 23 "../src/Upgrades.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES));
#line 23 "../src/Upgrades.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/Upgrades.vala"
	if (v_object) {
#line 23 "../src/Upgrades.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UPGRADES));
#line 23 "../src/Upgrades.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/Upgrades.vala"
		value->data[0].v_pointer = v_object;
#line 558 "Upgrades.c"
	} else {
#line 23 "../src/Upgrades.vala"
		value->data[0].v_pointer = NULL;
#line 562 "Upgrades.c"
	}
#line 23 "../src/Upgrades.vala"
	if (old) {
#line 23 "../src/Upgrades.vala"
		upgrades_unref (old);
#line 568 "Upgrades.c"
	}
}

static void
upgrades_class_init (UpgradesClass * klass,
                     gpointer klass_data)
{
#line 23 "../src/Upgrades.vala"
	upgrades_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Upgrades.vala"
	((UpgradesClass *) klass)->finalize = upgrades_finalize;
#line 23 "../src/Upgrades.vala"
	g_type_class_adjust_private_offset (klass, &Upgrades_private_offset);
#line 582 "Upgrades.c"
}

static void
upgrades_instance_init (Upgrades * self,
                        gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 23 "../src/Upgrades.vala"
	self->priv = upgrades_get_instance_private (self);
#line 25 "../src/Upgrades.vala"
	self->priv->total_steps = (guint64) 0;
#line 26 "../src/Upgrades.vala"
	_tmp0_ = gee_linked_list_new (TYPE_UPGRADE_TASK, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 26 "../src/Upgrades.vala"
	self->priv->task_list = _tmp0_;
#line 23 "../src/Upgrades.vala"
	self->ref_count = 1;
#line 600 "Upgrades.c"
}

static void
upgrades_finalize (Upgrades * obj)
{
	Upgrades * self;
#line 23 "../src/Upgrades.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UPGRADES, Upgrades);
#line 23 "../src/Upgrades.vala"
	g_signal_handlers_destroy (self);
#line 26 "../src/Upgrades.vala"
	_g_object_unref0 (self->priv->task_list);
#line 613 "Upgrades.c"
}

static GType
upgrades_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_upgrades_init, value_upgrades_free_value, value_upgrades_copy_value, value_upgrades_peek_pointer, "p", value_upgrades_collect_value, "p", value_upgrades_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UpgradesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upgrades_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Upgrades), 0, (GInstanceInitFunc) upgrades_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType upgrades_type_id;
	upgrades_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Upgrades", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Upgrades_private_offset = g_type_add_instance_private (upgrades_type_id, sizeof (UpgradesPrivate));
	return upgrades_type_id;
}

GType
upgrades_get_type (void)
{
	static volatile gsize upgrades_type_id__once = 0;
	if (g_once_init_enter (&upgrades_type_id__once)) {
		GType upgrades_type_id;
		upgrades_type_id = upgrades_get_type_once ();
		g_once_init_leave (&upgrades_type_id__once, upgrades_type_id);
	}
	return upgrades_type_id__once;
}

gpointer
upgrades_ref (gpointer instance)
{
	Upgrades * self;
	self = instance;
#line 23 "../src/Upgrades.vala"
	g_atomic_int_inc (&self->ref_count);
#line 23 "../src/Upgrades.vala"
	return instance;
#line 649 "Upgrades.c"
}

void
upgrades_unref (gpointer instance)
{
	Upgrades * self;
	self = instance;
#line 23 "../src/Upgrades.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 23 "../src/Upgrades.vala"
		UPGRADES_GET_CLASS (self)->finalize (self);
#line 23 "../src/Upgrades.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 663 "Upgrades.c"
	}
}

guint64
upgrade_task_get_step_count (UpgradeTask* self)
{
	UpgradeTaskIface* _iface_;
#line 68 "../src/Upgrades.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 68 "../src/Upgrades.vala"
	_iface_ = UPGRADE_TASK_GET_INTERFACE (self);
#line 68 "../src/Upgrades.vala"
	if (_iface_->get_step_count) {
#line 68 "../src/Upgrades.vala"
		return _iface_->get_step_count (self);
#line 679 "Upgrades.c"
	}
#line 68 "../src/Upgrades.vala"
	return 0ULL;
#line 683 "Upgrades.c"
}

void
upgrade_task_execute (UpgradeTask* self,
                      ProgressMonitor monitor,
                      gpointer monitor_target)
{
	UpgradeTaskIface* _iface_;
#line 73 "../src/Upgrades.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/Upgrades.vala"
	_iface_ = UPGRADE_TASK_GET_INTERFACE (self);
#line 73 "../src/Upgrades.vala"
	if (_iface_->execute) {
#line 73 "../src/Upgrades.vala"
		_iface_->execute (self, monitor, monitor_target);
#line 700 "Upgrades.c"
	}
}

static void
upgrade_task_default_init (UpgradeTaskIface * iface,
                           gpointer iface_data)
{
}

static GType
upgrade_task_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UpgradeTaskIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upgrade_task_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType upgrade_task_type_id;
	upgrade_task_type_id = g_type_register_static (G_TYPE_INTERFACE, "UpgradeTask", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (upgrade_task_type_id, G_TYPE_OBJECT);
	return upgrade_task_type_id;
}

GType
upgrade_task_get_type (void)
{
	static volatile gsize upgrade_task_type_id__once = 0;
	if (g_once_init_enter (&upgrade_task_type_id__once)) {
		GType upgrade_task_type_id;
		upgrade_task_type_id = upgrade_task_get_type_once ();
		g_once_init_leave (&upgrade_task_type_id__once, upgrade_task_type_id);
	}
	return upgrade_task_type_id__once;
}

static inline gpointer
mimics_removal_task_get_instance_private (MimicsRemovalTask* self)
{
	return G_STRUCT_MEMBER_P (self, MimicsRemovalTask_private_offset);
}

static guint64
mimics_removal_task_real_get_step_count (UpgradeTask* base)
{
	MimicsRemovalTask * self;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 84 "../src/Upgrades.vala"
	self = (MimicsRemovalTask*) base;
#line 746 "Upgrades.c"
	{
		guint64 _tmp0_ = 0ULL;
		GFile* _tmp1_;
#line 86 "../src/Upgrades.vala"
		_tmp1_ = self->priv->mimic_dir;
#line 86 "../src/Upgrades.vala"
		_tmp0_ = count_files_in_directory (_tmp1_, &_inner_error0_);
#line 86 "../src/Upgrades.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 756 "Upgrades.c"
			goto __catch0_g_error;
		}
#line 86 "../src/Upgrades.vala"
		self->priv->num_mimics = _tmp0_;
#line 761 "Upgrades.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 85 "../src/Upgrades.vala"
		e = _inner_error0_;
#line 85 "../src/Upgrades.vala"
		_inner_error0_ = NULL;
#line 88 "../src/Upgrades.vala"
		_tmp2_ = e;
#line 88 "../src/Upgrades.vala"
		_tmp3_ = _tmp2_->message;
#line 88 "../src/Upgrades.vala"
		g_debug ("Upgrades.vala:88: Error on deleting mimics: %s", _tmp3_);
#line 85 "../src/Upgrades.vala"
		_g_error_free0 (e);
#line 781 "Upgrades.c"
	}
	__finally0:
#line 85 "../src/Upgrades.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 786 "Upgrades.c"
		guint64 _tmp4_ = 0ULL;
#line 85 "../src/Upgrades.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/Upgrades.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../src/Upgrades.vala"
		return _tmp4_;
#line 794 "Upgrades.c"
	}
#line 90 "../src/Upgrades.vala"
	result = self->priv->num_mimics;
#line 90 "../src/Upgrades.vala"
	return result;
#line 800 "Upgrades.c"
}

static void
mimics_removal_task_real_execute (UpgradeTask* base,
                                  ProgressMonitor monitor,
                                  gpointer monitor_target)
{
	MimicsRemovalTask * self;
	GError* _inner_error0_ = NULL;
#line 93 "../src/Upgrades.vala"
	self = (MimicsRemovalTask*) base;
#line 812 "Upgrades.c"
	{
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 95 "../src/Upgrades.vala"
		_tmp0_ = self->priv->mimic_dir;
#line 95 "../src/Upgrades.vala"
		delete_all_files (_tmp0_, NULL, monitor, monitor_target, self->priv->num_mimics, NULL, &_inner_error0_);
#line 95 "../src/Upgrades.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 822 "Upgrades.c"
			goto __catch0_g_error;
		}
#line 96 "../src/Upgrades.vala"
		_tmp1_ = self->priv->mimic_dir;
#line 96 "../src/Upgrades.vala"
		g_file_delete (_tmp1_, NULL, &_inner_error0_);
#line 96 "../src/Upgrades.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 831 "Upgrades.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 94 "../src/Upgrades.vala"
		e = _inner_error0_;
#line 94 "../src/Upgrades.vala"
		_inner_error0_ = NULL;
#line 98 "../src/Upgrades.vala"
		_tmp2_ = e;
#line 98 "../src/Upgrades.vala"
		_tmp3_ = _tmp2_->message;
#line 98 "../src/Upgrades.vala"
		g_debug ("Upgrades.vala:98: Could not delete mimics: %s", _tmp3_);
#line 94 "../src/Upgrades.vala"
		_g_error_free0 (e);
#line 853 "Upgrades.c"
	}
	__finally0:
#line 94 "../src/Upgrades.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/Upgrades.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/Upgrades.vala"
		g_clear_error (&_inner_error0_);
#line 94 "../src/Upgrades.vala"
		return;
#line 864 "Upgrades.c"
	}
}

MimicsRemovalTask*
mimics_removal_task_construct (GType object_type)
{
	MimicsRemovalTask * self = NULL;
#line 79 "../src/Upgrades.vala"
	self = (MimicsRemovalTask*) g_object_new (object_type, NULL);
#line 79 "../src/Upgrades.vala"
	return self;
#line 876 "Upgrades.c"
}

MimicsRemovalTask*
mimics_removal_task_new (void)
{
#line 79 "../src/Upgrades.vala"
	return mimics_removal_task_construct (TYPE_MIMICS_REMOVAL_TASK);
#line 884 "Upgrades.c"
}

static void
mimics_removal_task_class_init (MimicsRemovalTaskClass * klass,
                                gpointer klass_data)
{
#line 79 "../src/Upgrades.vala"
	mimics_removal_task_parent_class = g_type_class_peek_parent (klass);
#line 79 "../src/Upgrades.vala"
	g_type_class_adjust_private_offset (klass, &MimicsRemovalTask_private_offset);
#line 79 "../src/Upgrades.vala"
	G_OBJECT_CLASS (klass)->finalize = mimics_removal_task_finalize;
#line 897 "Upgrades.c"
}

static void
mimics_removal_task_upgrade_task_interface_init (UpgradeTaskIface * iface,
                                                 gpointer iface_data)
{
#line 79 "../src/Upgrades.vala"
	mimics_removal_task_upgrade_task_parent_iface = g_type_interface_peek_parent (iface);
#line 79 "../src/Upgrades.vala"
	iface->get_step_count = (guint64 (*) (UpgradeTask*)) mimics_removal_task_real_get_step_count;
#line 79 "../src/Upgrades.vala"
	iface->execute = (void (*) (UpgradeTask*, ProgressMonitor, gpointer)) mimics_removal_task_real_execute;
#line 910 "Upgrades.c"
}

static void
mimics_removal_task_instance_init (MimicsRemovalTask * self,
                                   gpointer klass)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 79 "../src/Upgrades.vala"
	self->priv = mimics_removal_task_get_instance_private (self);
#line 81 "../src/Upgrades.vala"
	_tmp0_ = app_dirs_get_data_dir ();
#line 81 "../src/Upgrades.vala"
	_tmp1_ = _tmp0_;
#line 81 "../src/Upgrades.vala"
	_tmp2_ = g_file_get_child (_tmp1_, "mimics");
#line 81 "../src/Upgrades.vala"
	self->priv->mimic_dir = _tmp2_;
#line 81 "../src/Upgrades.vala"
	_g_object_unref0 (_tmp1_);
#line 82 "../src/Upgrades.vala"
	self->priv->num_mimics = (guint64) 0;
#line 934 "Upgrades.c"
}

static void
mimics_removal_task_finalize (GObject * obj)
{
	MimicsRemovalTask * self;
#line 79 "../src/Upgrades.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTask);
#line 81 "../src/Upgrades.vala"
	_g_object_unref0 (self->priv->mimic_dir);
#line 79 "../src/Upgrades.vala"
	G_OBJECT_CLASS (mimics_removal_task_parent_class)->finalize (obj);
#line 947 "Upgrades.c"
}

static GType
mimics_removal_task_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MimicsRemovalTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mimics_removal_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MimicsRemovalTask), 0, (GInstanceInitFunc) mimics_removal_task_instance_init, NULL };
	static const GInterfaceInfo upgrade_task_info = { (GInterfaceInitFunc) mimics_removal_task_upgrade_task_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType mimics_removal_task_type_id;
	mimics_removal_task_type_id = g_type_register_static (G_TYPE_OBJECT, "MimicsRemovalTask", &g_define_type_info, 0);
	g_type_add_interface_static (mimics_removal_task_type_id, TYPE_UPGRADE_TASK, &upgrade_task_info);
	MimicsRemovalTask_private_offset = g_type_add_instance_private (mimics_removal_task_type_id, sizeof (MimicsRemovalTaskPrivate));
	return mimics_removal_task_type_id;
}

GType
mimics_removal_task_get_type (void)
{
	static volatile gsize mimics_removal_task_type_id__once = 0;
	if (g_once_init_enter (&mimics_removal_task_type_id__once)) {
		GType mimics_removal_task_type_id;
		mimics_removal_task_type_id = mimics_removal_task_get_type_once ();
		g_once_init_leave (&mimics_removal_task_type_id__once, mimics_removal_task_type_id);
	}
	return mimics_removal_task_type_id__once;
}

static guint64
fixup_raw_thumbnails_task_real_get_step_count (UpgradeTask* base)
{
	FixupRawThumbnailsTask * self;
	gint num_raw_files = 0;
	guint64 result;
#line 107 "../src/Upgrades.vala"
	self = (FixupRawThumbnailsTask*) base;
#line 108 "../src/Upgrades.vala"
	num_raw_files = 0;
#line 984 "Upgrades.c"
	{
		GeeArrayList* _phr_list = NULL;
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _phr_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _phr_index = 0;
#line 110 "../src/Upgrades.vala"
		_tmp0_ = photo_table_get_instance ();
#line 110 "../src/Upgrades.vala"
		_tmp1_ = _tmp0_;
#line 110 "../src/Upgrades.vala"
		_tmp2_ = photo_table_get_all (_tmp1_);
#line 110 "../src/Upgrades.vala"
		_tmp3_ = _tmp2_;
#line 110 "../src/Upgrades.vala"
		_database_table_unref0 (_tmp1_);
#line 110 "../src/Upgrades.vala"
		_phr_list = _tmp3_;
#line 110 "../src/Upgrades.vala"
		_tmp4_ = _phr_list;
#line 110 "../src/Upgrades.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 110 "../src/Upgrades.vala"
		_tmp6_ = _tmp5_;
#line 110 "../src/Upgrades.vala"
		_phr_size = _tmp6_;
#line 110 "../src/Upgrades.vala"
		_phr_index = -1;
#line 110 "../src/Upgrades.vala"
		while (TRUE) {
#line 1020 "Upgrades.c"
			gint _tmp7_;
			gint _tmp8_;
			PhotoRow* phr = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			PhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
#line 110 "../src/Upgrades.vala"
			_phr_index = _phr_index + 1;
#line 110 "../src/Upgrades.vala"
			_tmp7_ = _phr_index;
#line 110 "../src/Upgrades.vala"
			_tmp8_ = _phr_size;
#line 110 "../src/Upgrades.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 110 "../src/Upgrades.vala"
				break;
#line 1038 "Upgrades.c"
			}
#line 110 "../src/Upgrades.vala"
			_tmp9_ = _phr_list;
#line 110 "../src/Upgrades.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _phr_index);
#line 110 "../src/Upgrades.vala"
			phr = (PhotoRow*) _tmp10_;
#line 111 "../src/Upgrades.vala"
			_tmp11_ = phr;
#line 111 "../src/Upgrades.vala"
			_tmp12_ = _tmp11_->master;
#line 111 "../src/Upgrades.vala"
			if (_tmp12_->file_format == PHOTO_FILE_FORMAT_RAW) {
#line 1052 "Upgrades.c"
				gint _tmp13_;
#line 112 "../src/Upgrades.vala"
				_tmp13_ = num_raw_files;
#line 112 "../src/Upgrades.vala"
				num_raw_files = _tmp13_ + 1;
#line 1058 "Upgrades.c"
			}
#line 110 "../src/Upgrades.vala"
			_photo_row_unref0 (phr);
#line 1062 "Upgrades.c"
		}
#line 110 "../src/Upgrades.vala"
		_g_object_unref0 (_phr_list);
#line 1066 "Upgrades.c"
	}
#line 114 "../src/Upgrades.vala"
	result = (guint64) num_raw_files;
#line 114 "../src/Upgrades.vala"
	return result;
#line 1072 "Upgrades.c"
}

static void
fixup_raw_thumbnails_task_real_execute (UpgradeTask* base,
                                        ProgressMonitor monitor,
                                        gpointer monitor_target)
{
	FixupRawThumbnailsTask * self;
#line 117 "../src/Upgrades.vala"
	self = (FixupRawThumbnailsTask*) base;
#line 118 "../src/Upgrades.vala"
	g_debug ("Upgrades.vala:118: Executing thumbnail deletion and fixup");
#line 1085 "Upgrades.c"
	{
		GeeArrayList* _phr_list = NULL;
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _phr_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _phr_index = 0;
#line 120 "../src/Upgrades.vala"
		_tmp0_ = photo_table_get_instance ();
#line 120 "../src/Upgrades.vala"
		_tmp1_ = _tmp0_;
#line 120 "../src/Upgrades.vala"
		_tmp2_ = photo_table_get_all (_tmp1_);
#line 120 "../src/Upgrades.vala"
		_tmp3_ = _tmp2_;
#line 120 "../src/Upgrades.vala"
		_database_table_unref0 (_tmp1_);
#line 120 "../src/Upgrades.vala"
		_phr_list = _tmp3_;
#line 120 "../src/Upgrades.vala"
		_tmp4_ = _phr_list;
#line 120 "../src/Upgrades.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 120 "../src/Upgrades.vala"
		_tmp6_ = _tmp5_;
#line 120 "../src/Upgrades.vala"
		_phr_size = _tmp6_;
#line 120 "../src/Upgrades.vala"
		_phr_index = -1;
#line 120 "../src/Upgrades.vala"
		while (TRUE) {
#line 1121 "Upgrades.c"
			gint _tmp7_;
			gint _tmp8_;
			PhotoRow* phr = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_ = FALSE;
			PhotoRow* _tmp12_;
			BackingPhotoRow* _tmp13_;
#line 120 "../src/Upgrades.vala"
			_phr_index = _phr_index + 1;
#line 120 "../src/Upgrades.vala"
			_tmp7_ = _phr_index;
#line 120 "../src/Upgrades.vala"
			_tmp8_ = _phr_size;
#line 120 "../src/Upgrades.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 120 "../src/Upgrades.vala"
				break;
#line 1140 "Upgrades.c"
			}
#line 120 "../src/Upgrades.vala"
			_tmp9_ = _phr_list;
#line 120 "../src/Upgrades.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _phr_index);
#line 120 "../src/Upgrades.vala"
			phr = (PhotoRow*) _tmp10_;
#line 121 "../src/Upgrades.vala"
			_tmp12_ = phr;
#line 121 "../src/Upgrades.vala"
			_tmp13_ = _tmp12_->master;
#line 121 "../src/Upgrades.vala"
			if (_tmp13_->file_format == PHOTO_FILE_FORMAT_RAW) {
#line 1154 "Upgrades.c"
				PhotoRow* _tmp14_;
#line 122 "../src/Upgrades.vala"
				_tmp14_ = phr;
#line 122 "../src/Upgrades.vala"
				_tmp11_ = _tmp14_->developer == RAW_DEVELOPER_CAMERA;
#line 1160 "Upgrades.c"
			} else {
#line 121 "../src/Upgrades.vala"
				_tmp11_ = FALSE;
#line 1164 "Upgrades.c"
			}
#line 121 "../src/Upgrades.vala"
			if (_tmp11_) {
#line 1168 "Upgrades.c"
				LibraryPhotoSourceCollection* _tmp15_;
				PhotoRow* _tmp16_;
				PhotoID _tmp17_;
				LibraryPhoto* _tmp18_;
				LibraryPhoto* _tmp19_;
#line 123 "../src/Upgrades.vala"
				_tmp15_ = library_photo_global;
#line 123 "../src/Upgrades.vala"
				_tmp16_ = phr;
#line 123 "../src/Upgrades.vala"
				_tmp17_ = _tmp16_->photo_id;
#line 123 "../src/Upgrades.vala"
				_tmp18_ = library_photo_source_collection_fetch (_tmp15_, &_tmp17_);
#line 123 "../src/Upgrades.vala"
				_tmp19_ = _tmp18_;
#line 123 "../src/Upgrades.vala"
				thumbnail_cache_remove ((ThumbnailSource*) _tmp19_);
#line 123 "../src/Upgrades.vala"
				_g_object_unref0 (_tmp19_);
#line 1188 "Upgrades.c"
			}
#line 120 "../src/Upgrades.vala"
			_photo_row_unref0 (phr);
#line 1192 "Upgrades.c"
		}
#line 120 "../src/Upgrades.vala"
		_g_object_unref0 (_phr_list);
#line 1196 "Upgrades.c"
	}
}

FixupRawThumbnailsTask*
fixup_raw_thumbnails_task_construct (GType object_type)
{
	FixupRawThumbnailsTask * self = NULL;
#line 106 "../src/Upgrades.vala"
	self = (FixupRawThumbnailsTask*) g_object_new (object_type, NULL);
#line 106 "../src/Upgrades.vala"
	return self;
#line 1208 "Upgrades.c"
}

FixupRawThumbnailsTask*
fixup_raw_thumbnails_task_new (void)
{
#line 106 "../src/Upgrades.vala"
	return fixup_raw_thumbnails_task_construct (TYPE_FIXUP_RAW_THUMBNAILS_TASK);
#line 1216 "Upgrades.c"
}

static void
fixup_raw_thumbnails_task_class_init (FixupRawThumbnailsTaskClass * klass,
                                      gpointer klass_data)
{
#line 106 "../src/Upgrades.vala"
	fixup_raw_thumbnails_task_parent_class = g_type_class_peek_parent (klass);
#line 1225 "Upgrades.c"
}

static void
fixup_raw_thumbnails_task_upgrade_task_interface_init (UpgradeTaskIface * iface,
                                                       gpointer iface_data)
{
#line 106 "../src/Upgrades.vala"
	fixup_raw_thumbnails_task_upgrade_task_parent_iface = g_type_interface_peek_parent (iface);
#line 106 "../src/Upgrades.vala"
	iface->get_step_count = (guint64 (*) (UpgradeTask*)) fixup_raw_thumbnails_task_real_get_step_count;
#line 106 "../src/Upgrades.vala"
	iface->execute = (void (*) (UpgradeTask*, ProgressMonitor, gpointer)) fixup_raw_thumbnails_task_real_execute;
#line 1238 "Upgrades.c"
}

static void
fixup_raw_thumbnails_task_instance_init (FixupRawThumbnailsTask * self,
                                         gpointer klass)
{
}

static GType
fixup_raw_thumbnails_task_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FixupRawThumbnailsTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fixup_raw_thumbnails_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FixupRawThumbnailsTask), 0, (GInstanceInitFunc) fixup_raw_thumbnails_task_instance_init, NULL };
	static const GInterfaceInfo upgrade_task_info = { (GInterfaceInitFunc) fixup_raw_thumbnails_task_upgrade_task_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType fixup_raw_thumbnails_task_type_id;
	fixup_raw_thumbnails_task_type_id = g_type_register_static (G_TYPE_OBJECT, "FixupRawThumbnailsTask", &g_define_type_info, 0);
	g_type_add_interface_static (fixup_raw_thumbnails_task_type_id, TYPE_UPGRADE_TASK, &upgrade_task_info);
	return fixup_raw_thumbnails_task_type_id;
}

GType
fixup_raw_thumbnails_task_get_type (void)
{
	static volatile gsize fixup_raw_thumbnails_task_type_id__once = 0;
	if (g_once_init_enter (&fixup_raw_thumbnails_task_type_id__once)) {
		GType fixup_raw_thumbnails_task_type_id;
		fixup_raw_thumbnails_task_type_id = fixup_raw_thumbnails_task_get_type_once ();
		g_once_init_leave (&fixup_raw_thumbnails_task_type_id__once, fixup_raw_thumbnails_task_type_id);
	}
	return fixup_raw_thumbnails_task_type_id__once;
}

