/* VideoMonitor.c generated by valac 0.56.18, the Vala compiler
 * generated from VideoMonitor.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#define VIDEO_MONITOR_MAX_INTERPRETABLE_CHECKS_PER_CYCLE 5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_VIDEO_UPDATES (video_updates_get_type ())
#define VIDEO_UPDATES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_UPDATES, VideoUpdates))
#define VIDEO_UPDATES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_UPDATES, VideoUpdatesClass))
#define IS_VIDEO_UPDATES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_UPDATES))
#define IS_VIDEO_UPDATES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_UPDATES))
#define VIDEO_UPDATES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_UPDATES, VideoUpdatesClass))

typedef struct _VideoUpdates VideoUpdates;
typedef struct _VideoUpdatesClass VideoUpdatesClass;
typedef struct _VideoUpdatesPrivate VideoUpdatesPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_VIDEO_MONITOR (video_monitor_get_type ())
#define VIDEO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_MONITOR, VideoMonitor))
#define VIDEO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_MONITOR, VideoMonitorClass))
#define IS_VIDEO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_MONITOR))
#define IS_VIDEO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_MONITOR))
#define VIDEO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_MONITOR, VideoMonitorClass))

typedef struct _VideoMonitor VideoMonitor;
typedef struct _VideoMonitorClass VideoMonitorClass;
typedef struct _VideoMonitorPrivate VideoMonitorPrivate;
enum  {
	VIDEO_MONITOR_0_PROPERTY,
	VIDEO_MONITOR_NUM_PROPERTIES
};
static GParamSpec* video_monitor_properties[VIDEO_MONITOR_NUM_PROPERTIES];
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _monitorable_updates_unref0(var) ((var == NULL) ? NULL : (var = (monitorable_updates_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB (video_monitor_video_interpretable_check_job_get_type ())
#define VIDEO_MONITOR_VIDEO_INTERPRETABLE_CHECK_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB, VideoMonitorVideoInterpretableCheckJob))
#define VIDEO_MONITOR_VIDEO_INTERPRETABLE_CHECK_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB, VideoMonitorVideoInterpretableCheckJobClass))
#define VIDEO_MONITOR_IS_VIDEO_INTERPRETABLE_CHECK_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB))
#define VIDEO_MONITOR_IS_VIDEO_INTERPRETABLE_CHECK_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB))
#define VIDEO_MONITOR_VIDEO_INTERPRETABLE_CHECK_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB, VideoMonitorVideoInterpretableCheckJobClass))

typedef struct _VideoMonitorVideoInterpretableCheckJob VideoMonitorVideoInterpretableCheckJob;
typedef struct _VideoMonitorVideoInterpretableCheckJobClass VideoMonitorVideoInterpretableCheckJobClass;
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _VideoMonitorVideoInterpretableCheckJobPrivate VideoMonitorVideoInterpretableCheckJobPrivate;
#define _video_interpretable_results_unref0(var) ((var == NULL) ? NULL : (var = (video_interpretable_results_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _VideoUpdates {
	MonitorableUpdates parent_instance;
	VideoUpdatesPrivate * priv;
	Video* video;
};

struct _VideoUpdatesClass {
	MonitorableUpdatesClass parent_class;
	void (*set_check_interpretable) (VideoUpdates* self, gboolean check);
};

struct _VideoUpdatesPrivate {
	gboolean check_interpretable;
};

struct _VideoMonitor {
	MediaMonitor parent_instance;
	VideoMonitorPrivate * priv;
};

struct _VideoMonitorClass {
	MediaMonitorClass parent_class;
};

struct _VideoMonitorPrivate {
	Workers* workers;
	guint64 background_jobs;
};

struct _VideoMonitorVideoInterpretableCheckJob {
	BackgroundJob parent_instance;
	VideoMonitorVideoInterpretableCheckJobPrivate * priv;
	Video* video;
	VideoInterpretableResults* results;
};

struct _VideoMonitorVideoInterpretableCheckJobClass {
	BackgroundJobClass parent_class;
};

static gint VideoUpdates_private_offset;
static gpointer video_updates_parent_class = NULL;
static gint VideoMonitor_private_offset;
static gpointer video_monitor_parent_class = NULL;
static gpointer video_monitor_video_interpretable_check_job_parent_class = NULL;

VALA_EXTERN GType video_updates_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void video_updates_set_check_interpretable (VideoUpdates* self,
                                            gboolean check);
VALA_EXTERN VideoUpdates* video_updates_new (Video* video);
VALA_EXTERN VideoUpdates* video_updates_construct (GType object_type,
                                       Video* video);
static void video_updates_real_set_check_interpretable (VideoUpdates* self,
                                                 gboolean check);
static void video_updates_real_mark_online (MonitorableUpdates* base);
VALA_EXTERN gboolean video_updates_is_check_interpretable (VideoUpdates* self);
static gboolean video_updates_real_is_all_updated (MonitorableUpdates* base);
static void video_updates_finalize (MonitorableUpdates * obj);
static GType video_updates_get_type_once (void);
VALA_EXTERN GType video_monitor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VideoMonitor* video_monitor_new (GCancellable* cancellable);
VALA_EXTERN VideoMonitor* video_monitor_construct (GType object_type,
                                       GCancellable* cancellable);
VALA_EXTERN void video_monitor_set_check_interpretable (VideoMonitor* self,
                                            Video* video,
                                            gboolean check);
static MonitorableUpdates* video_monitor_real_create_updates (MediaMonitor* base,
                                                       Monitorable* monitorable);
static MediaSourceCollection* video_monitor_real_get_media_source_collection (MediaMonitor* base);
static gboolean video_monitor_real_is_file_represented (MediaMonitor* base,
                                                 GFile* file);
static Video* video_monitor_get_state (VideoMonitor* self,
                                GFile* file,
                                VideoSourceCollectionState* state);
static MediaMonitorDiscoveredFile video_monitor_real_notify_file_discovered (MediaMonitor* base,
                                                                      GFile* file,
                                                                      GFileInfo* info,
                                                                      Monitorable** monitorable);
static GeeCollection* video_monitor_real_candidates_for_unknown_file (MediaMonitor* base,
                                                               GFile* file,
                                                               GFileInfo* info,
                                                               MediaMonitorDiscoveredFile* _result_);
static gboolean video_monitor_real_notify_file_created (MediaMonitor* base,
                                                 GFile* file,
                                                 GFileInfo* info);
static gboolean video_monitor_real_notify_file_moved (MediaMonitor* base,
                                               GFile* old_file,
                                               GFile* new_file,
                                               GFileInfo* new_file_info);
static gboolean video_monitor_real_notify_file_altered (MediaMonitor* base,
                                                 GFile* file);
static gboolean video_monitor_real_notify_file_attributes_altered (MediaMonitor* base,
                                                            GFile* file);
static gboolean video_monitor_real_notify_file_alteration_completed (MediaMonitor* base,
                                                              GFile* file,
                                                              GFileInfo* info);
static gboolean video_monitor_real_notify_file_deleted (MediaMonitor* base,
                                                 GFile* file);
VALA_EXTERN VideoUpdates* video_monitor_get_existing_video_updates (VideoMonitor* self,
                                                        Video* video);
VALA_EXTERN VideoUpdates* video_monitor_fetch_video_updates (VideoMonitor* self,
                                                 Video* video);
static void video_monitor_real_process_updates (MediaMonitor* base,
                                         GeeCollection* all_updates,
                                         TransactionController* controller,
                                         gint* op_count,
                                         GError** error);
static void video_monitor_on_interpretable_check_complete (VideoMonitor* self,
                                                    BackgroundJob* j);
static void _video_monitor_on_interpretable_check_complete_completion_callback (BackgroundJob* job,
                                                                         gpointer self);
static VideoMonitorVideoInterpretableCheckJob* video_monitor_video_interpretable_check_job_new (Video* video,
                                                                                         CompletionCallback callback,
                                                                                         gpointer callback_target);
static VideoMonitorVideoInterpretableCheckJob* video_monitor_video_interpretable_check_job_construct (GType object_type,
                                                                                               Video* video,
                                                                                               CompletionCallback callback,
                                                                                               gpointer callback_target);
static GType video_monitor_video_interpretable_check_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void video_monitor_video_interpretable_check_job_real_execute (BackgroundJob* base);
static void video_monitor_video_interpretable_check_job_finalize (BackgroundJob * obj);
static GType video_monitor_video_interpretable_check_job_get_type_once (void);
static void video_monitor_finalize (GObject * obj);
static GType video_monitor_get_type_once (void);

static inline gpointer
video_updates_get_instance_private (VideoUpdates* self)
{
	return G_STRUCT_MEMBER_P (self, VideoUpdates_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../src/VideoMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 226 "VideoMonitor.c"
}

VideoUpdates*
video_updates_construct (GType object_type,
                         Video* video)
{
	VideoUpdates* self = NULL;
	Video* _tmp0_;
#line 25 "../src/VideoMonitor.vala"
	g_return_val_if_fail (video != NULL, NULL);
#line 26 "../src/VideoMonitor.vala"
	self = (VideoUpdates*) monitorable_updates_construct (object_type, (Monitorable*) video);
#line 28 "../src/VideoMonitor.vala"
	_tmp0_ = _g_object_ref0 (video);
#line 28 "../src/VideoMonitor.vala"
	_g_object_unref0 (self->video);
#line 28 "../src/VideoMonitor.vala"
	self->video = _tmp0_;
#line 25 "../src/VideoMonitor.vala"
	return self;
#line 247 "VideoMonitor.c"
}

VideoUpdates*
video_updates_new (Video* video)
{
#line 25 "../src/VideoMonitor.vala"
	return video_updates_construct (TYPE_VIDEO_UPDATES, video);
#line 255 "VideoMonitor.c"
}

static void
video_updates_real_set_check_interpretable (VideoUpdates* self,
                                            gboolean check)
{
#line 32 "../src/VideoMonitor.vala"
	self->priv->check_interpretable = check;
#line 264 "VideoMonitor.c"
}

void
video_updates_set_check_interpretable (VideoUpdates* self,
                                       gboolean check)
{
	VideoUpdatesClass* _klass_;
#line 31 "../src/VideoMonitor.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/VideoMonitor.vala"
	_klass_ = VIDEO_UPDATES_GET_CLASS (self);
#line 31 "../src/VideoMonitor.vala"
	if (_klass_->set_check_interpretable) {
#line 31 "../src/VideoMonitor.vala"
		_klass_->set_check_interpretable (self, check);
#line 280 "VideoMonitor.c"
	}
}

static void
video_updates_real_mark_online (MonitorableUpdates* base)
{
	VideoUpdates * self;
#line 35 "../src/VideoMonitor.vala"
	self = (VideoUpdates*) base;
#line 36 "../src/VideoMonitor.vala"
	MONITORABLE_UPDATES_CLASS (video_updates_parent_class)->mark_online (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MONITORABLE_UPDATES, MonitorableUpdates));
#line 38 "../src/VideoMonitor.vala"
	video_updates_set_check_interpretable (self, TRUE);
#line 294 "VideoMonitor.c"
}

gboolean
video_updates_is_check_interpretable (VideoUpdates* self)
{
	gboolean result;
#line 41 "../src/VideoMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/VideoMonitor.vala"
	result = self->priv->check_interpretable;
#line 42 "../src/VideoMonitor.vala"
	return result;
#line 307 "VideoMonitor.c"
}

static gboolean
video_updates_real_is_all_updated (MonitorableUpdates* base)
{
	VideoUpdates * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 45 "../src/VideoMonitor.vala"
	self = (VideoUpdates*) base;
#line 46 "../src/VideoMonitor.vala"
	if (self->priv->check_interpretable == FALSE) {
#line 46 "../src/VideoMonitor.vala"
		_tmp0_ = MONITORABLE_UPDATES_CLASS (video_updates_parent_class)->is_all_updated (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MONITORABLE_UPDATES, MonitorableUpdates));
#line 322 "VideoMonitor.c"
	} else {
#line 46 "../src/VideoMonitor.vala"
		_tmp0_ = FALSE;
#line 326 "VideoMonitor.c"
	}
#line 46 "../src/VideoMonitor.vala"
	result = _tmp0_;
#line 46 "../src/VideoMonitor.vala"
	return result;
#line 332 "VideoMonitor.c"
}

static void
video_updates_class_init (VideoUpdatesClass * klass,
                          gpointer klass_data)
{
#line 20 "../src/VideoMonitor.vala"
	video_updates_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/VideoMonitor.vala"
	((MonitorableUpdatesClass *) klass)->finalize = video_updates_finalize;
#line 20 "../src/VideoMonitor.vala"
	g_type_class_adjust_private_offset (klass, &VideoUpdates_private_offset);
#line 20 "../src/VideoMonitor.vala"
	((VideoUpdatesClass *) klass)->set_check_interpretable = (void (*) (VideoUpdates*, gboolean)) video_updates_real_set_check_interpretable;
#line 20 "../src/VideoMonitor.vala"
	((MonitorableUpdatesClass *) klass)->mark_online = (void (*) (MonitorableUpdates*)) video_updates_real_mark_online;
#line 20 "../src/VideoMonitor.vala"
	((MonitorableUpdatesClass *) klass)->is_all_updated = (gboolean (*) (MonitorableUpdates*)) video_updates_real_is_all_updated;
#line 351 "VideoMonitor.c"
}

static void
video_updates_instance_init (VideoUpdates * self,
                             gpointer klass)
{
#line 20 "../src/VideoMonitor.vala"
	self->priv = video_updates_get_instance_private (self);
#line 23 "../src/VideoMonitor.vala"
	self->priv->check_interpretable = FALSE;
#line 362 "VideoMonitor.c"
}

static void
video_updates_finalize (MonitorableUpdates * obj)
{
	VideoUpdates * self;
#line 20 "../src/VideoMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_UPDATES, VideoUpdates);
#line 21 "../src/VideoMonitor.vala"
	_g_object_unref0 (self->video);
#line 20 "../src/VideoMonitor.vala"
	MONITORABLE_UPDATES_CLASS (video_updates_parent_class)->finalize (obj);
#line 375 "VideoMonitor.c"
}

static GType
video_updates_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VideoUpdatesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_updates_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoUpdates), 0, (GInstanceInitFunc) video_updates_instance_init, NULL };
	GType video_updates_type_id;
	video_updates_type_id = g_type_register_static (TYPE_MONITORABLE_UPDATES, "VideoUpdates", &g_define_type_info, 0);
	VideoUpdates_private_offset = g_type_add_instance_private (video_updates_type_id, sizeof (VideoUpdatesPrivate));
	return video_updates_type_id;
}

GType
video_updates_get_type (void)
{
	static volatile gsize video_updates_type_id__once = 0;
	if (g_once_init_enter (&video_updates_type_id__once)) {
		GType video_updates_type_id;
		video_updates_type_id = video_updates_get_type_once ();
		g_once_init_leave (&video_updates_type_id__once, video_updates_type_id);
	}
	return video_updates_type_id__once;
}

static inline gpointer
video_monitor_get_instance_private (VideoMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, VideoMonitor_private_offset);
}

VideoMonitor*
video_monitor_construct (GType object_type,
                         GCancellable* cancellable)
{
	VideoMonitor * self = NULL;
	VideoSourceCollection* _tmp0_;
#line 78 "../src/VideoMonitor.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 79 "../src/VideoMonitor.vala"
	_tmp0_ = video_global;
#line 79 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) media_monitor_construct (object_type, (MediaSourceCollection*) _tmp0_, cancellable);
#line 418 "VideoMonitor.c"
	{
		GeeIterator* _obj_it = NULL;
		VideoSourceCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 81 "../src/VideoMonitor.vala"
		_tmp1_ = video_global;
#line 81 "../src/VideoMonitor.vala"
		_tmp2_ = data_collection_get_all ((DataCollection*) _tmp1_);
#line 81 "../src/VideoMonitor.vala"
		_tmp3_ = _tmp2_;
#line 81 "../src/VideoMonitor.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 81 "../src/VideoMonitor.vala"
		_tmp5_ = _tmp4_;
#line 81 "../src/VideoMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 81 "../src/VideoMonitor.vala"
		_obj_it = _tmp5_;
#line 81 "../src/VideoMonitor.vala"
		while (TRUE) {
#line 442 "VideoMonitor.c"
			GeeIterator* _tmp6_;
			DataObject* obj = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			Video* video = NULL;
			DataObject* _tmp9_;
			Video* _tmp10_;
			Video* _tmp11_;
			Video* _tmp12_;
#line 81 "../src/VideoMonitor.vala"
			_tmp6_ = _obj_it;
#line 81 "../src/VideoMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 81 "../src/VideoMonitor.vala"
				break;
#line 458 "VideoMonitor.c"
			}
#line 81 "../src/VideoMonitor.vala"
			_tmp7_ = _obj_it;
#line 81 "../src/VideoMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 81 "../src/VideoMonitor.vala"
			obj = (DataObject*) _tmp8_;
#line 82 "../src/VideoMonitor.vala"
			_tmp9_ = obj;
#line 82 "../src/VideoMonitor.vala"
			_tmp10_ = _g_object_ref0 (IS_VIDEO (_tmp9_) ? ((Video*) _tmp9_) : NULL);
#line 82 "../src/VideoMonitor.vala"
			video = _tmp10_;
#line 83 "../src/VideoMonitor.vala"
			_tmp11_ = video;
#line 83 "../src/VideoMonitor.vala"
			_vala_assert (_tmp11_ != NULL, "video != null");
#line 84 "../src/VideoMonitor.vala"
			_tmp12_ = video;
#line 84 "../src/VideoMonitor.vala"
			if (!video_get_is_interpretable (_tmp12_)) {
#line 480 "VideoMonitor.c"
				Video* _tmp13_;
#line 85 "../src/VideoMonitor.vala"
				_tmp13_ = video;
#line 85 "../src/VideoMonitor.vala"
				video_monitor_set_check_interpretable (self, _tmp13_, TRUE);
#line 486 "VideoMonitor.c"
			}
#line 81 "../src/VideoMonitor.vala"
			_g_object_unref0 (video);
#line 81 "../src/VideoMonitor.vala"
			_g_object_unref0 (obj);
#line 492 "VideoMonitor.c"
		}
#line 81 "../src/VideoMonitor.vala"
		_g_object_unref0 (_obj_it);
#line 496 "VideoMonitor.c"
	}
#line 78 "../src/VideoMonitor.vala"
	return self;
#line 500 "VideoMonitor.c"
}

VideoMonitor*
video_monitor_new (GCancellable* cancellable)
{
#line 78 "../src/VideoMonitor.vala"
	return video_monitor_construct (TYPE_VIDEO_MONITOR, cancellable);
#line 508 "VideoMonitor.c"
}

static MonitorableUpdates*
video_monitor_real_create_updates (MediaMonitor* base,
                                   Monitorable* monitorable)
{
	VideoMonitor * self;
	VideoUpdates* _tmp0_;
	MonitorableUpdates* result;
#line 89 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 89 "../src/VideoMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 90 "../src/VideoMonitor.vala"
	_vala_assert (IS_VIDEO (monitorable), "monitorable is Video");
#line 92 "../src/VideoMonitor.vala"
	_tmp0_ = video_updates_new (G_TYPE_CHECK_INSTANCE_CAST (monitorable, TYPE_VIDEO, Video));
#line 92 "../src/VideoMonitor.vala"
	result = (MonitorableUpdates*) _tmp0_;
#line 92 "../src/VideoMonitor.vala"
	return result;
#line 530 "VideoMonitor.c"
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 96 "../src/VideoMonitor.vala"
	return self ? data_collection_ref (self) : NULL;
#line 538 "VideoMonitor.c"
}

static MediaSourceCollection*
video_monitor_real_get_media_source_collection (MediaMonitor* base)
{
	VideoMonitor * self;
	VideoSourceCollection* _tmp0_;
	MediaSourceCollection* _tmp1_;
	MediaSourceCollection* result;
#line 95 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 96 "../src/VideoMonitor.vala"
	_tmp0_ = video_global;
#line 96 "../src/VideoMonitor.vala"
	_tmp1_ = _data_collection_ref0 ((MediaSourceCollection*) _tmp0_);
#line 96 "../src/VideoMonitor.vala"
	result = _tmp1_;
#line 96 "../src/VideoMonitor.vala"
	return result;
#line 558 "VideoMonitor.c"
}

static gboolean
video_monitor_real_is_file_represented (MediaMonitor* base,
                                        GFile* file)
{
	VideoMonitor * self;
	VideoSourceCollectionState state = 0;
	VideoSourceCollectionState _tmp0_ = 0;
	Video* _tmp1_;
	Video* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 99 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 99 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 101 "../src/VideoMonitor.vala"
	_tmp1_ = video_monitor_get_state (self, file, &_tmp0_);
#line 101 "../src/VideoMonitor.vala"
	state = _tmp0_;
#line 101 "../src/VideoMonitor.vala"
	_tmp2_ = _tmp1_;
#line 101 "../src/VideoMonitor.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 101 "../src/VideoMonitor.vala"
	_g_object_unref0 (_tmp2_);
#line 101 "../src/VideoMonitor.vala"
	result = _tmp3_;
#line 101 "../src/VideoMonitor.vala"
	return result;
#line 590 "VideoMonitor.c"
}

static MediaMonitorDiscoveredFile
video_monitor_real_notify_file_discovered (MediaMonitor* base,
                                           GFile* file,
                                           GFileInfo* info,
                                           Monitorable** monitorable)
{
	VideoMonitor * self;
	Monitorable* _vala_monitorable = NULL;
	VideoSourceCollectionState state = 0;
	Video* video = NULL;
	VideoSourceCollectionState _tmp0_ = 0;
	Video* _tmp1_;
	Video* _tmp2_;
	MediaMonitorDiscoveredFile result;
#line 104 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 104 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 104 "../src/VideoMonitor.vala"
	g_return_val_if_fail (info != NULL, 0);
#line 107 "../src/VideoMonitor.vala"
	_tmp1_ = video_monitor_get_state (self, file, &_tmp0_);
#line 107 "../src/VideoMonitor.vala"
	state = _tmp0_;
#line 107 "../src/VideoMonitor.vala"
	video = _tmp1_;
#line 108 "../src/VideoMonitor.vala"
	_tmp2_ = video;
#line 108 "../src/VideoMonitor.vala"
	if (_tmp2_ == NULL) {
#line 109 "../src/VideoMonitor.vala"
		_g_object_unref0 (_vala_monitorable);
#line 109 "../src/VideoMonitor.vala"
		_vala_monitorable = NULL;
#line 111 "../src/VideoMonitor.vala"
		result = MEDIA_MONITOR_DISCOVERED_FILE_UNKNOWN;
#line 111 "../src/VideoMonitor.vala"
		_g_object_unref0 (video);
#line 111 "../src/VideoMonitor.vala"
		if (monitorable) {
#line 111 "../src/VideoMonitor.vala"
			*monitorable = _vala_monitorable;
#line 635 "VideoMonitor.c"
		} else {
#line 111 "../src/VideoMonitor.vala"
			_g_object_unref0 (_vala_monitorable);
#line 639 "VideoMonitor.c"
		}
#line 111 "../src/VideoMonitor.vala"
		return result;
#line 643 "VideoMonitor.c"
	}
#line 114 "../src/VideoMonitor.vala"
	switch (state) {
#line 114 "../src/VideoMonitor.vala"
		case VIDEO_SOURCE_COLLECTION_STATE_ONLINE:
#line 114 "../src/VideoMonitor.vala"
		case VIDEO_SOURCE_COLLECTION_STATE_OFFLINE:
#line 651 "VideoMonitor.c"
		{
			Video* _tmp3_;
			Monitorable* _tmp4_;
#line 117 "../src/VideoMonitor.vala"
			_tmp3_ = video;
#line 117 "../src/VideoMonitor.vala"
			_tmp4_ = _g_object_ref0 ((Monitorable*) _tmp3_);
#line 117 "../src/VideoMonitor.vala"
			_g_object_unref0 (_vala_monitorable);
#line 117 "../src/VideoMonitor.vala"
			_vala_monitorable = _tmp4_;
#line 119 "../src/VideoMonitor.vala"
			result = MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED;
#line 119 "../src/VideoMonitor.vala"
			_g_object_unref0 (video);
#line 119 "../src/VideoMonitor.vala"
			if (monitorable) {
#line 119 "../src/VideoMonitor.vala"
				*monitorable = _vala_monitorable;
#line 671 "VideoMonitor.c"
			} else {
#line 119 "../src/VideoMonitor.vala"
				_g_object_unref0 (_vala_monitorable);
#line 675 "VideoMonitor.c"
			}
#line 119 "../src/VideoMonitor.vala"
			return result;
#line 679 "VideoMonitor.c"
		}
		default:
#line 114 "../src/VideoMonitor.vala"
		case VIDEO_SOURCE_COLLECTION_STATE_TRASH:
#line 684 "VideoMonitor.c"
		{
#line 124 "../src/VideoMonitor.vala"
			_g_object_unref0 (_vala_monitorable);
#line 124 "../src/VideoMonitor.vala"
			_vala_monitorable = NULL;
#line 126 "../src/VideoMonitor.vala"
			result = MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
#line 126 "../src/VideoMonitor.vala"
			_g_object_unref0 (video);
#line 126 "../src/VideoMonitor.vala"
			if (monitorable) {
#line 126 "../src/VideoMonitor.vala"
				*monitorable = _vala_monitorable;
#line 698 "VideoMonitor.c"
			} else {
#line 126 "../src/VideoMonitor.vala"
				_g_object_unref0 (_vala_monitorable);
#line 702 "VideoMonitor.c"
			}
#line 126 "../src/VideoMonitor.vala"
			return result;
#line 706 "VideoMonitor.c"
		}
	}
}

static GeeCollection*
video_monitor_real_candidates_for_unknown_file (MediaMonitor* base,
                                                GFile* file,
                                                GFileInfo* info,
                                                MediaMonitorDiscoveredFile* _result_)
{
	VideoMonitor * self;
	MediaMonitorDiscoveredFile _vala__result_ = 0;
	GeeCollection* matched = NULL;
	GeeArrayList* _tmp0_;
	VideoSourceCollection* _tmp1_;
	GeeCollection* result;
#line 130 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 130 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 130 "../src/VideoMonitor.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 132 "../src/VideoMonitor.vala"
	_tmp0_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 132 "../src/VideoMonitor.vala"
	matched = (GeeCollection*) _tmp0_;
#line 133 "../src/VideoMonitor.vala"
	_tmp1_ = video_global;
#line 133 "../src/VideoMonitor.vala"
	video_source_collection_fetch_by_matching_backing (_tmp1_, info, matched);
#line 135 "../src/VideoMonitor.vala"
	_vala__result_ = MEDIA_MONITOR_DISCOVERED_FILE_UNKNOWN;
#line 137 "../src/VideoMonitor.vala"
	result = matched;
#line 137 "../src/VideoMonitor.vala"
	if (_result_) {
#line 137 "../src/VideoMonitor.vala"
		*_result_ = _vala__result_;
#line 745 "VideoMonitor.c"
	}
#line 137 "../src/VideoMonitor.vala"
	return result;
#line 749 "VideoMonitor.c"
}

static gboolean
video_monitor_real_notify_file_created (MediaMonitor* base,
                                        GFile* file,
                                        GFileInfo* info)
{
	VideoMonitor * self;
	VideoSourceCollectionState state = 0;
	Video* video = NULL;
	VideoSourceCollectionState _tmp0_ = 0;
	Video* _tmp1_;
	Video* _tmp2_;
	Video* _tmp3_;
	gboolean result;
#line 140 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 140 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 140 "../src/VideoMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 142 "../src/VideoMonitor.vala"
	_tmp1_ = video_monitor_get_state (self, file, &_tmp0_);
#line 142 "../src/VideoMonitor.vala"
	state = _tmp0_;
#line 142 "../src/VideoMonitor.vala"
	video = _tmp1_;
#line 143 "../src/VideoMonitor.vala"
	_tmp2_ = video;
#line 143 "../src/VideoMonitor.vala"
	if (_tmp2_ == NULL) {
#line 144 "../src/VideoMonitor.vala"
		result = FALSE;
#line 144 "../src/VideoMonitor.vala"
		_g_object_unref0 (video);
#line 144 "../src/VideoMonitor.vala"
		return result;
#line 787 "VideoMonitor.c"
	}
#line 146 "../src/VideoMonitor.vala"
	_tmp3_ = video;
#line 146 "../src/VideoMonitor.vala"
	media_monitor_update_online ((MediaMonitor*) self, (Monitorable*) _tmp3_);
#line 148 "../src/VideoMonitor.vala"
	result = TRUE;
#line 148 "../src/VideoMonitor.vala"
	_g_object_unref0 (video);
#line 148 "../src/VideoMonitor.vala"
	return result;
#line 799 "VideoMonitor.c"
}

static gboolean
video_monitor_real_notify_file_moved (MediaMonitor* base,
                                      GFile* old_file,
                                      GFile* new_file,
                                      GFileInfo* new_file_info)
{
	VideoMonitor * self;
	VideoSourceCollectionState old_state = 0;
	Video* old_video = NULL;
	VideoSourceCollectionState _tmp0_ = 0;
	Video* _tmp1_;
	VideoSourceCollectionState new_state = 0;
	Video* new_video = NULL;
	VideoSourceCollectionState _tmp2_ = 0;
	Video* _tmp3_;
	gboolean _tmp4_ = FALSE;
	Video* _tmp5_;
	gboolean result;
#line 151 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 151 "../src/VideoMonitor.vala"
	g_return_val_if_fail (old_file != NULL, FALSE);
#line 151 "../src/VideoMonitor.vala"
	g_return_val_if_fail (new_file != NULL, FALSE);
#line 151 "../src/VideoMonitor.vala"
	g_return_val_if_fail (new_file_info != NULL, FALSE);
#line 153 "../src/VideoMonitor.vala"
	_tmp1_ = video_monitor_get_state (self, old_file, &_tmp0_);
#line 153 "../src/VideoMonitor.vala"
	old_state = _tmp0_;
#line 153 "../src/VideoMonitor.vala"
	old_video = _tmp1_;
#line 156 "../src/VideoMonitor.vala"
	_tmp3_ = video_monitor_get_state (self, new_file, &_tmp2_);
#line 156 "../src/VideoMonitor.vala"
	new_state = _tmp2_;
#line 156 "../src/VideoMonitor.vala"
	new_video = _tmp3_;
#line 170 "../src/VideoMonitor.vala"
	_tmp5_ = old_video;
#line 170 "../src/VideoMonitor.vala"
	if (_tmp5_ != NULL) {
#line 844 "VideoMonitor.c"
		Video* _tmp6_;
#line 170 "../src/VideoMonitor.vala"
		_tmp6_ = new_video;
#line 170 "../src/VideoMonitor.vala"
		_tmp4_ = _tmp6_ == NULL;
#line 850 "VideoMonitor.c"
	} else {
#line 170 "../src/VideoMonitor.vala"
		_tmp4_ = FALSE;
#line 854 "VideoMonitor.c"
	}
#line 170 "../src/VideoMonitor.vala"
	if (_tmp4_) {
#line 858 "VideoMonitor.c"
		Video* _tmp7_;
#line 172 "../src/VideoMonitor.vala"
		_tmp7_ = old_video;
#line 172 "../src/VideoMonitor.vala"
		media_monitor_update_master_file ((MediaMonitor*) self, (Monitorable*) _tmp7_, new_file);
#line 864 "VideoMonitor.c"
	} else {
		gboolean _tmp8_ = FALSE;
		Video* _tmp9_;
#line 173 "../src/VideoMonitor.vala"
		_tmp9_ = old_video;
#line 173 "../src/VideoMonitor.vala"
		if (_tmp9_ == NULL) {
#line 872 "VideoMonitor.c"
			Video* _tmp10_;
#line 173 "../src/VideoMonitor.vala"
			_tmp10_ = new_video;
#line 173 "../src/VideoMonitor.vala"
			_tmp8_ = _tmp10_ != NULL;
#line 878 "VideoMonitor.c"
		} else {
#line 173 "../src/VideoMonitor.vala"
			_tmp8_ = FALSE;
#line 882 "VideoMonitor.c"
		}
#line 173 "../src/VideoMonitor.vala"
		if (_tmp8_) {
#line 886 "VideoMonitor.c"
			Video* _tmp11_;
#line 175 "../src/VideoMonitor.vala"
			_tmp11_ = new_video;
#line 175 "../src/VideoMonitor.vala"
			video_monitor_set_check_interpretable (self, _tmp11_, TRUE);
#line 892 "VideoMonitor.c"
		} else {
			gboolean _tmp12_ = FALSE;
			Video* _tmp13_;
#line 176 "../src/VideoMonitor.vala"
			_tmp13_ = old_video;
#line 176 "../src/VideoMonitor.vala"
			if (_tmp13_ == NULL) {
#line 900 "VideoMonitor.c"
				Video* _tmp14_;
#line 176 "../src/VideoMonitor.vala"
				_tmp14_ = new_video;
#line 176 "../src/VideoMonitor.vala"
				_tmp12_ = _tmp14_ == NULL;
#line 906 "VideoMonitor.c"
			} else {
#line 176 "../src/VideoMonitor.vala"
				_tmp12_ = FALSE;
#line 910 "VideoMonitor.c"
			}
#line 176 "../src/VideoMonitor.vala"
			if (_tmp12_) {
#line 178 "../src/VideoMonitor.vala"
				result = FALSE;
#line 178 "../src/VideoMonitor.vala"
				_g_object_unref0 (new_video);
#line 178 "../src/VideoMonitor.vala"
				_g_object_unref0 (old_video);
#line 178 "../src/VideoMonitor.vala"
				return result;
#line 922 "VideoMonitor.c"
			} else {
				gboolean _tmp15_ = FALSE;
				Video* _tmp16_;
				Video* _tmp18_;
				Video* _tmp19_;
#line 180 "../src/VideoMonitor.vala"
				_tmp16_ = old_video;
#line 180 "../src/VideoMonitor.vala"
				if (_tmp16_ != NULL) {
#line 932 "VideoMonitor.c"
					Video* _tmp17_;
#line 180 "../src/VideoMonitor.vala"
					_tmp17_ = new_video;
#line 180 "../src/VideoMonitor.vala"
					_tmp15_ = _tmp17_ != NULL;
#line 938 "VideoMonitor.c"
				} else {
#line 180 "../src/VideoMonitor.vala"
					_tmp15_ = FALSE;
#line 942 "VideoMonitor.c"
				}
#line 180 "../src/VideoMonitor.vala"
				_vala_assert (_tmp15_, "old_video != null && new_video != null");
#line 183 "../src/VideoMonitor.vala"
				_tmp18_ = old_video;
#line 183 "../src/VideoMonitor.vala"
				media_monitor_update_offline ((MediaMonitor*) self, (Monitorable*) _tmp18_);
#line 184 "../src/VideoMonitor.vala"
				_tmp19_ = new_video;
#line 184 "../src/VideoMonitor.vala"
				video_monitor_set_check_interpretable (self, _tmp19_, TRUE);
#line 954 "VideoMonitor.c"
			}
		}
	}
#line 187 "../src/VideoMonitor.vala"
	result = TRUE;
#line 187 "../src/VideoMonitor.vala"
	_g_object_unref0 (new_video);
#line 187 "../src/VideoMonitor.vala"
	_g_object_unref0 (old_video);
#line 187 "../src/VideoMonitor.vala"
	return result;
#line 966 "VideoMonitor.c"
}

static gboolean
video_monitor_real_notify_file_altered (MediaMonitor* base,
                                        GFile* file)
{
	VideoMonitor * self;
	VideoSourceCollectionState state = 0;
	VideoSourceCollectionState _tmp0_ = 0;
	Video* _tmp1_;
	Video* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 190 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 190 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 192 "../src/VideoMonitor.vala"
	_tmp1_ = video_monitor_get_state (self, file, &_tmp0_);
#line 192 "../src/VideoMonitor.vala"
	state = _tmp0_;
#line 192 "../src/VideoMonitor.vala"
	_tmp2_ = _tmp1_;
#line 192 "../src/VideoMonitor.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 192 "../src/VideoMonitor.vala"
	_g_object_unref0 (_tmp2_);
#line 192 "../src/VideoMonitor.vala"
	result = _tmp3_;
#line 192 "../src/VideoMonitor.vala"
	return result;
#line 998 "VideoMonitor.c"
}

static gboolean
video_monitor_real_notify_file_attributes_altered (MediaMonitor* base,
                                                   GFile* file)
{
	VideoMonitor * self;
	VideoSourceCollectionState state = 0;
	Video* video = NULL;
	VideoSourceCollectionState _tmp0_ = 0;
	Video* _tmp1_;
	Video* _tmp2_;
	Video* _tmp3_;
	Video* _tmp4_;
	gboolean result;
#line 195 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 195 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 197 "../src/VideoMonitor.vala"
	_tmp1_ = video_monitor_get_state (self, file, &_tmp0_);
#line 197 "../src/VideoMonitor.vala"
	state = _tmp0_;
#line 197 "../src/VideoMonitor.vala"
	video = _tmp1_;
#line 198 "../src/VideoMonitor.vala"
	_tmp2_ = video;
#line 198 "../src/VideoMonitor.vala"
	if (_tmp2_ == NULL) {
#line 199 "../src/VideoMonitor.vala"
		result = FALSE;
#line 199 "../src/VideoMonitor.vala"
		_g_object_unref0 (video);
#line 199 "../src/VideoMonitor.vala"
		return result;
#line 1034 "VideoMonitor.c"
	}
#line 201 "../src/VideoMonitor.vala"
	_tmp3_ = video;
#line 201 "../src/VideoMonitor.vala"
	media_monitor_update_master_file_info_altered ((MediaMonitor*) self, (Monitorable*) _tmp3_);
#line 202 "../src/VideoMonitor.vala"
	_tmp4_ = video;
#line 202 "../src/VideoMonitor.vala"
	media_monitor_update_master_file_in_alteration ((MediaMonitor*) self, (Monitorable*) _tmp4_, TRUE);
#line 204 "../src/VideoMonitor.vala"
	result = TRUE;
#line 204 "../src/VideoMonitor.vala"
	_g_object_unref0 (video);
#line 204 "../src/VideoMonitor.vala"
	return result;
#line 1050 "VideoMonitor.c"
}

static gboolean
video_monitor_real_notify_file_alteration_completed (MediaMonitor* base,
                                                     GFile* file,
                                                     GFileInfo* info)
{
	VideoMonitor * self;
	VideoSourceCollectionState state = 0;
	Video* video = NULL;
	VideoSourceCollectionState _tmp0_ = 0;
	Video* _tmp1_;
	Video* _tmp2_;
	Video* _tmp3_;
	gboolean result;
#line 207 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 207 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 207 "../src/VideoMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 209 "../src/VideoMonitor.vala"
	_tmp1_ = video_monitor_get_state (self, file, &_tmp0_);
#line 209 "../src/VideoMonitor.vala"
	state = _tmp0_;
#line 209 "../src/VideoMonitor.vala"
	video = _tmp1_;
#line 210 "../src/VideoMonitor.vala"
	_tmp2_ = video;
#line 210 "../src/VideoMonitor.vala"
	if (_tmp2_ == NULL) {
#line 211 "../src/VideoMonitor.vala"
		result = FALSE;
#line 211 "../src/VideoMonitor.vala"
		_g_object_unref0 (video);
#line 211 "../src/VideoMonitor.vala"
		return result;
#line 1088 "VideoMonitor.c"
	}
#line 213 "../src/VideoMonitor.vala"
	_tmp3_ = video;
#line 213 "../src/VideoMonitor.vala"
	media_monitor_update_master_file_alterations_completed ((MediaMonitor*) self, (Monitorable*) _tmp3_, info);
#line 215 "../src/VideoMonitor.vala"
	result = TRUE;
#line 215 "../src/VideoMonitor.vala"
	_g_object_unref0 (video);
#line 215 "../src/VideoMonitor.vala"
	return result;
#line 1100 "VideoMonitor.c"
}

static gboolean
video_monitor_real_notify_file_deleted (MediaMonitor* base,
                                        GFile* file)
{
	VideoMonitor * self;
	VideoSourceCollectionState state = 0;
	Video* video = NULL;
	VideoSourceCollectionState _tmp0_ = 0;
	Video* _tmp1_;
	Video* _tmp2_;
	Video* _tmp3_;
	Video* _tmp4_;
	gboolean result;
#line 218 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 218 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 220 "../src/VideoMonitor.vala"
	_tmp1_ = video_monitor_get_state (self, file, &_tmp0_);
#line 220 "../src/VideoMonitor.vala"
	state = _tmp0_;
#line 220 "../src/VideoMonitor.vala"
	video = _tmp1_;
#line 221 "../src/VideoMonitor.vala"
	_tmp2_ = video;
#line 221 "../src/VideoMonitor.vala"
	if (_tmp2_ == NULL) {
#line 222 "../src/VideoMonitor.vala"
		result = FALSE;
#line 222 "../src/VideoMonitor.vala"
		_g_object_unref0 (video);
#line 222 "../src/VideoMonitor.vala"
		return result;
#line 1136 "VideoMonitor.c"
	}
#line 224 "../src/VideoMonitor.vala"
	_tmp3_ = video;
#line 224 "../src/VideoMonitor.vala"
	media_monitor_update_master_file_in_alteration ((MediaMonitor*) self, (Monitorable*) _tmp3_, FALSE);
#line 225 "../src/VideoMonitor.vala"
	_tmp4_ = video;
#line 225 "../src/VideoMonitor.vala"
	media_monitor_update_offline ((MediaMonitor*) self, (Monitorable*) _tmp4_);
#line 227 "../src/VideoMonitor.vala"
	result = TRUE;
#line 227 "../src/VideoMonitor.vala"
	_g_object_unref0 (video);
#line 227 "../src/VideoMonitor.vala"
	return result;
#line 1152 "VideoMonitor.c"
}

static Video*
video_monitor_get_state (VideoMonitor* self,
                         GFile* file,
                         VideoSourceCollectionState* state)
{
	VideoSourceCollectionState _vala_state = 0;
	GFile* real_file = NULL;
	GFile* _tmp22_ = NULL;
	GFile* _tmp23_;
	VideoSourceCollection* _tmp24_;
	VideoSourceCollectionState _tmp25_ = 0;
	Video* _tmp26_;
	Video* result;
#line 230 "../src/VideoMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 230 "../src/VideoMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 231 "../src/VideoMonitor.vala"
	real_file = NULL;
#line 1174 "VideoMonitor.c"
	{
		GeeIterator* _monitorable_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 232 "../src/VideoMonitor.vala"
		_tmp0_ = media_monitor_get_monitorables ((MediaMonitor*) self);
#line 232 "../src/VideoMonitor.vala"
		_tmp1_ = _tmp0_;
#line 232 "../src/VideoMonitor.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 232 "../src/VideoMonitor.vala"
		_tmp3_ = _tmp2_;
#line 232 "../src/VideoMonitor.vala"
		_g_object_unref0 (_tmp1_);
#line 232 "../src/VideoMonitor.vala"
		_monitorable_it = _tmp3_;
#line 232 "../src/VideoMonitor.vala"
		while (TRUE) {
#line 1195 "VideoMonitor.c"
			GeeIterator* _tmp4_;
			Monitorable* monitorable = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			Video* video = NULL;
			Monitorable* _tmp7_;
			Video* _tmp8_;
			VideoUpdates* updates = NULL;
			Video* _tmp9_;
			VideoUpdates* _tmp10_;
			VideoUpdates* _tmp11_;
			gboolean _tmp12_ = FALSE;
			VideoUpdates* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp15_;
			gboolean _tmp16_;
#line 232 "../src/VideoMonitor.vala"
			_tmp4_ = _monitorable_it;
#line 232 "../src/VideoMonitor.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 232 "../src/VideoMonitor.vala"
				break;
#line 1218 "VideoMonitor.c"
			}
#line 232 "../src/VideoMonitor.vala"
			_tmp5_ = _monitorable_it;
#line 232 "../src/VideoMonitor.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 232 "../src/VideoMonitor.vala"
			monitorable = (Monitorable*) _tmp6_;
#line 233 "../src/VideoMonitor.vala"
			_tmp7_ = monitorable;
#line 233 "../src/VideoMonitor.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_VIDEO, Video));
#line 233 "../src/VideoMonitor.vala"
			video = _tmp8_;
#line 235 "../src/VideoMonitor.vala"
			_tmp9_ = video;
#line 235 "../src/VideoMonitor.vala"
			_tmp10_ = video_monitor_get_existing_video_updates (self, _tmp9_);
#line 235 "../src/VideoMonitor.vala"
			updates = _tmp10_;
#line 236 "../src/VideoMonitor.vala"
			_tmp11_ = updates;
#line 236 "../src/VideoMonitor.vala"
			if (_tmp11_ == NULL) {
#line 237 "../src/VideoMonitor.vala"
				_monitorable_updates_unref0 (updates);
#line 237 "../src/VideoMonitor.vala"
				_g_object_unref0 (video);
#line 237 "../src/VideoMonitor.vala"
				_g_object_unref0 (monitorable);
#line 237 "../src/VideoMonitor.vala"
				continue;
#line 1250 "VideoMonitor.c"
			}
#line 239 "../src/VideoMonitor.vala"
			_tmp13_ = updates;
#line 239 "../src/VideoMonitor.vala"
			_tmp14_ = monitorable_updates_get_master_file ((MonitorableUpdates*) _tmp13_);
#line 239 "../src/VideoMonitor.vala"
			_tmp15_ = _tmp14_;
#line 239 "../src/VideoMonitor.vala"
			_tmp16_ = _tmp15_ != NULL;
#line 239 "../src/VideoMonitor.vala"
			_g_object_unref0 (_tmp15_);
#line 239 "../src/VideoMonitor.vala"
			if (_tmp16_) {
#line 1264 "VideoMonitor.c"
				VideoUpdates* _tmp17_;
				GFile* _tmp18_;
				GFile* _tmp19_;
#line 239 "../src/VideoMonitor.vala"
				_tmp17_ = updates;
#line 239 "../src/VideoMonitor.vala"
				_tmp18_ = monitorable_updates_get_master_file ((MonitorableUpdates*) _tmp17_);
#line 239 "../src/VideoMonitor.vala"
				_tmp19_ = _tmp18_;
#line 239 "../src/VideoMonitor.vala"
				_tmp12_ = g_file_equal (_tmp19_, file);
#line 239 "../src/VideoMonitor.vala"
				_g_object_unref0 (_tmp19_);
#line 1278 "VideoMonitor.c"
			} else {
#line 239 "../src/VideoMonitor.vala"
				_tmp12_ = FALSE;
#line 1282 "VideoMonitor.c"
			}
#line 239 "../src/VideoMonitor.vala"
			if (_tmp12_) {
#line 1286 "VideoMonitor.c"
				Video* _tmp20_;
				GFile* _tmp21_;
#line 240 "../src/VideoMonitor.vala"
				_tmp20_ = video;
#line 240 "../src/VideoMonitor.vala"
				_tmp21_ = media_source_get_master_file ((MediaSource*) _tmp20_);
#line 240 "../src/VideoMonitor.vala"
				_g_object_unref0 (real_file);
#line 240 "../src/VideoMonitor.vala"
				real_file = _tmp21_;
#line 242 "../src/VideoMonitor.vala"
				_monitorable_updates_unref0 (updates);
#line 242 "../src/VideoMonitor.vala"
				_g_object_unref0 (video);
#line 242 "../src/VideoMonitor.vala"
				_g_object_unref0 (monitorable);
#line 242 "../src/VideoMonitor.vala"
				break;
#line 1305 "VideoMonitor.c"
			}
#line 232 "../src/VideoMonitor.vala"
			_monitorable_updates_unref0 (updates);
#line 232 "../src/VideoMonitor.vala"
			_g_object_unref0 (video);
#line 232 "../src/VideoMonitor.vala"
			_g_object_unref0 (monitorable);
#line 1313 "VideoMonitor.c"
		}
#line 232 "../src/VideoMonitor.vala"
		_g_object_unref0 (_monitorable_it);
#line 1317 "VideoMonitor.c"
	}
#line 246 "../src/VideoMonitor.vala"
	_tmp23_ = real_file;
#line 246 "../src/VideoMonitor.vala"
	_tmp22_ = _tmp23_;
#line 246 "../src/VideoMonitor.vala"
	if (_tmp22_ == NULL) {
#line 246 "../src/VideoMonitor.vala"
		_tmp22_ = file;
#line 1327 "VideoMonitor.c"
	}
#line 246 "../src/VideoMonitor.vala"
	_tmp24_ = video_global;
#line 246 "../src/VideoMonitor.vala"
	_tmp26_ = video_source_collection_get_state_by_file (_tmp24_, _tmp22_, &_tmp25_);
#line 246 "../src/VideoMonitor.vala"
	_vala_state = _tmp25_;
#line 246 "../src/VideoMonitor.vala"
	result = _tmp26_;
#line 246 "../src/VideoMonitor.vala"
	_g_object_unref0 (real_file);
#line 246 "../src/VideoMonitor.vala"
	if (state) {
#line 246 "../src/VideoMonitor.vala"
		*state = _vala_state;
#line 1343 "VideoMonitor.c"
	}
#line 246 "../src/VideoMonitor.vala"
	return result;
#line 1347 "VideoMonitor.c"
}

VideoUpdates*
video_monitor_fetch_video_updates (VideoMonitor* self,
                                   Video* video)
{
	VideoUpdates* updates = NULL;
	MonitorableUpdates* _tmp0_;
	VideoUpdates* _tmp1_;
	VideoUpdates* result;
#line 249 "../src/VideoMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 249 "../src/VideoMonitor.vala"
	g_return_val_if_fail (video != NULL, NULL);
#line 250 "../src/VideoMonitor.vala"
	_tmp0_ = media_monitor_fetch_updates ((MediaMonitor*) self, (Monitorable*) video);
#line 250 "../src/VideoMonitor.vala"
	_tmp1_ = IS_VIDEO_UPDATES (_tmp0_) ? ((VideoUpdates*) _tmp0_) : NULL;
#line 250 "../src/VideoMonitor.vala"
	if (_tmp1_ == NULL) {
#line 250 "../src/VideoMonitor.vala"
		_monitorable_updates_unref0 (_tmp0_);
#line 1370 "VideoMonitor.c"
	}
#line 250 "../src/VideoMonitor.vala"
	updates = _tmp1_;
#line 251 "../src/VideoMonitor.vala"
	_vala_assert (updates != NULL, "updates != null");
#line 253 "../src/VideoMonitor.vala"
	result = updates;
#line 253 "../src/VideoMonitor.vala"
	return result;
#line 1380 "VideoMonitor.c"
}

VideoUpdates*
video_monitor_get_existing_video_updates (VideoMonitor* self,
                                          Video* video)
{
	MonitorableUpdates* _tmp0_;
	VideoUpdates* _tmp1_;
	VideoUpdates* result;
#line 256 "../src/VideoMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../src/VideoMonitor.vala"
	g_return_val_if_fail (video != NULL, NULL);
#line 257 "../src/VideoMonitor.vala"
	_tmp0_ = media_monitor_get_existing_updates ((MediaMonitor*) self, (Monitorable*) video);
#line 257 "../src/VideoMonitor.vala"
	_tmp1_ = IS_VIDEO_UPDATES (_tmp0_) ? ((VideoUpdates*) _tmp0_) : NULL;
#line 257 "../src/VideoMonitor.vala"
	if (_tmp1_ == NULL) {
#line 257 "../src/VideoMonitor.vala"
		_monitorable_updates_unref0 (_tmp0_);
#line 1402 "VideoMonitor.c"
	}
#line 257 "../src/VideoMonitor.vala"
	result = _tmp1_;
#line 257 "../src/VideoMonitor.vala"
	return result;
#line 1408 "VideoMonitor.c"
}

void
video_monitor_set_check_interpretable (VideoMonitor* self,
                                       Video* video,
                                       gboolean check)
{
	VideoUpdates* _tmp0_;
	VideoUpdates* _tmp1_;
#line 260 "../src/VideoMonitor.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/VideoMonitor.vala"
	g_return_if_fail (video != NULL);
#line 261 "../src/VideoMonitor.vala"
	_tmp0_ = video_monitor_fetch_video_updates (self, video);
#line 261 "../src/VideoMonitor.vala"
	_tmp1_ = _tmp0_;
#line 261 "../src/VideoMonitor.vala"
	video_updates_set_check_interpretable (_tmp1_, check);
#line 261 "../src/VideoMonitor.vala"
	_monitorable_updates_unref0 (_tmp1_);
#line 1430 "VideoMonitor.c"
}

static gpointer
_monitorable_updates_ref0 (gpointer self)
{
#line 279 "../src/VideoMonitor.vala"
	return self ? monitorable_updates_ref (self) : NULL;
#line 1438 "VideoMonitor.c"
}

static void
_video_monitor_on_interpretable_check_complete_completion_callback (BackgroundJob* job,
                                                                    gpointer self)
{
#line 300 "../src/VideoMonitor.vala"
	video_monitor_on_interpretable_check_complete ((VideoMonitor*) self, job);
#line 1447 "VideoMonitor.c"
}

static void
video_monitor_real_process_updates (MediaMonitor* base,
                                    GeeCollection* all_updates,
                                    TransactionController* controller,
                                    gint* op_count,
                                    GError** error)
{
	VideoMonitor * self;
	GeeArrayList* check = NULL;
	GeeArrayList* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 264 "../src/VideoMonitor.vala"
	self = (VideoMonitor*) base;
#line 264 "../src/VideoMonitor.vala"
	g_return_if_fail (all_updates != NULL);
#line 264 "../src/VideoMonitor.vala"
	g_return_if_fail (controller != NULL);
#line 266 "../src/VideoMonitor.vala"
	MEDIA_MONITOR_CLASS (video_monitor_parent_class)->process_updates (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_MONITOR, MediaMonitor), all_updates, controller, op_count, &_inner_error0_);
#line 266 "../src/VideoMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 266 "../src/VideoMonitor.vala"
		g_propagate_error (error, _inner_error0_);
#line 266 "../src/VideoMonitor.vala"
		return;
#line 1475 "VideoMonitor.c"
	}
#line 268 "../src/VideoMonitor.vala"
	check = NULL;
#line 1479 "VideoMonitor.c"
	{
		GeeIterator* _monitorable_updates_it = NULL;
		GeeIterator* _tmp0_;
#line 270 "../src/VideoMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) all_updates);
#line 270 "../src/VideoMonitor.vala"
		_monitorable_updates_it = _tmp0_;
#line 270 "../src/VideoMonitor.vala"
		while (TRUE) {
#line 1489 "VideoMonitor.c"
			GeeIterator* _tmp1_;
			MonitorableUpdates* monitorable_updates = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeArrayList* _tmp5_;
			VideoUpdates* updates = NULL;
			MonitorableUpdates* _tmp9_;
			VideoUpdates* _tmp10_;
			VideoUpdates* _tmp11_;
			VideoUpdates* _tmp12_;
#line 270 "../src/VideoMonitor.vala"
			_tmp1_ = _monitorable_updates_it;
#line 270 "../src/VideoMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 270 "../src/VideoMonitor.vala"
				break;
#line 1507 "VideoMonitor.c"
			}
#line 270 "../src/VideoMonitor.vala"
			_tmp2_ = _monitorable_updates_it;
#line 270 "../src/VideoMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 270 "../src/VideoMonitor.vala"
			monitorable_updates = (MonitorableUpdates*) _tmp3_;
#line 271 "../src/VideoMonitor.vala"
			if ((*op_count) >= MEDIA_MONITOR_MAX_OPERATIONS_PER_CYCLE) {
#line 272 "../src/VideoMonitor.vala"
				_monitorable_updates_unref0 (monitorable_updates);
#line 272 "../src/VideoMonitor.vala"
				break;
#line 1521 "VideoMonitor.c"
			}
#line 276 "../src/VideoMonitor.vala"
			_tmp5_ = check;
#line 276 "../src/VideoMonitor.vala"
			if (_tmp5_ != NULL) {
#line 1527 "VideoMonitor.c"
				GeeArrayList* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 276 "../src/VideoMonitor.vala"
				_tmp6_ = check;
#line 276 "../src/VideoMonitor.vala"
				_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 276 "../src/VideoMonitor.vala"
				_tmp8_ = _tmp7_;
#line 276 "../src/VideoMonitor.vala"
				_tmp4_ = _tmp8_ >= VIDEO_MONITOR_MAX_INTERPRETABLE_CHECKS_PER_CYCLE;
#line 1539 "VideoMonitor.c"
			} else {
#line 276 "../src/VideoMonitor.vala"
				_tmp4_ = FALSE;
#line 1543 "VideoMonitor.c"
			}
#line 276 "../src/VideoMonitor.vala"
			if (_tmp4_) {
#line 277 "../src/VideoMonitor.vala"
				_monitorable_updates_unref0 (monitorable_updates);
#line 277 "../src/VideoMonitor.vala"
				break;
#line 1551 "VideoMonitor.c"
			}
#line 279 "../src/VideoMonitor.vala"
			_tmp9_ = monitorable_updates;
#line 279 "../src/VideoMonitor.vala"
			_tmp10_ = _monitorable_updates_ref0 (IS_VIDEO_UPDATES (_tmp9_) ? ((VideoUpdates*) _tmp9_) : NULL);
#line 279 "../src/VideoMonitor.vala"
			updates = _tmp10_;
#line 280 "../src/VideoMonitor.vala"
			_tmp11_ = updates;
#line 280 "../src/VideoMonitor.vala"
			if (_tmp11_ == NULL) {
#line 281 "../src/VideoMonitor.vala"
				_monitorable_updates_unref0 (updates);
#line 281 "../src/VideoMonitor.vala"
				_monitorable_updates_unref0 (monitorable_updates);
#line 281 "../src/VideoMonitor.vala"
				continue;
#line 1569 "VideoMonitor.c"
			}
#line 283 "../src/VideoMonitor.vala"
			_tmp12_ = updates;
#line 283 "../src/VideoMonitor.vala"
			if (video_updates_is_check_interpretable (_tmp12_)) {
#line 1575 "VideoMonitor.c"
				GeeArrayList* _tmp13_;
				GeeArrayList* _tmp15_;
				VideoUpdates* _tmp16_;
				Video* _tmp17_;
				VideoUpdates* _tmp18_;
				gint _tmp19_;
#line 284 "../src/VideoMonitor.vala"
				_tmp13_ = check;
#line 284 "../src/VideoMonitor.vala"
				if (_tmp13_ == NULL) {
#line 1586 "VideoMonitor.c"
					GeeArrayList* _tmp14_;
#line 285 "../src/VideoMonitor.vala"
					_tmp14_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 285 "../src/VideoMonitor.vala"
					_g_object_unref0 (check);
#line 285 "../src/VideoMonitor.vala"
					check = _tmp14_;
#line 1594 "VideoMonitor.c"
				}
#line 287 "../src/VideoMonitor.vala"
				_tmp15_ = check;
#line 287 "../src/VideoMonitor.vala"
				_tmp16_ = updates;
#line 287 "../src/VideoMonitor.vala"
				_tmp17_ = _tmp16_->video;
#line 287 "../src/VideoMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp17_);
#line 288 "../src/VideoMonitor.vala"
				_tmp18_ = updates;
#line 288 "../src/VideoMonitor.vala"
				video_updates_set_check_interpretable (_tmp18_, FALSE);
#line 289 "../src/VideoMonitor.vala"
				_tmp19_ = *op_count;
#line 289 "../src/VideoMonitor.vala"
				*op_count = _tmp19_ + 1;
#line 1612 "VideoMonitor.c"
			}
#line 270 "../src/VideoMonitor.vala"
			_monitorable_updates_unref0 (updates);
#line 270 "../src/VideoMonitor.vala"
			_monitorable_updates_unref0 (monitorable_updates);
#line 1618 "VideoMonitor.c"
		}
#line 270 "../src/VideoMonitor.vala"
		_g_object_unref0 (_monitorable_updates_it);
#line 1622 "VideoMonitor.c"
	}
#line 293 "../src/VideoMonitor.vala"
	_tmp20_ = check;
#line 293 "../src/VideoMonitor.vala"
	if (_tmp20_ != NULL) {
#line 1628 "VideoMonitor.c"
		GeeArrayList* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GeeArrayList* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 294 "../src/VideoMonitor.vala"
		_tmp21_ = check;
#line 294 "../src/VideoMonitor.vala"
		_tmp22_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp21_);
#line 294 "../src/VideoMonitor.vala"
		_tmp23_ = _tmp22_;
#line 294 "../src/VideoMonitor.vala"
		_tmp24_ = g_strdup_printf ("Checking interpretable for %d videos", _tmp23_);
#line 294 "../src/VideoMonitor.vala"
		_tmp25_ = _tmp24_;
#line 294 "../src/VideoMonitor.vala"
		media_monitor_mdbg (_tmp25_);
#line 294 "../src/VideoMonitor.vala"
		_g_free0 (_tmp25_);
#line 296 "../src/VideoMonitor.vala"
		video_notify_offline_thumbs_regenerated ();
#line 298 "../src/VideoMonitor.vala"
		_tmp26_ = check;
#line 298 "../src/VideoMonitor.vala"
		_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
#line 298 "../src/VideoMonitor.vala"
		_tmp28_ = _tmp27_;
#line 298 "../src/VideoMonitor.vala"
		self->priv->background_jobs = self->priv->background_jobs + _tmp28_;
#line 1661 "VideoMonitor.c"
		{
			GeeArrayList* _video_list = NULL;
			GeeArrayList* _tmp29_;
			gint _video_size = 0;
			GeeArrayList* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gint _video_index = 0;
#line 299 "../src/VideoMonitor.vala"
			_tmp29_ = check;
#line 299 "../src/VideoMonitor.vala"
			_video_list = _tmp29_;
#line 299 "../src/VideoMonitor.vala"
			_tmp30_ = _video_list;
#line 299 "../src/VideoMonitor.vala"
			_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 299 "../src/VideoMonitor.vala"
			_tmp32_ = _tmp31_;
#line 299 "../src/VideoMonitor.vala"
			_video_size = _tmp32_;
#line 299 "../src/VideoMonitor.vala"
			_video_index = -1;
#line 299 "../src/VideoMonitor.vala"
			while (TRUE) {
#line 1686 "VideoMonitor.c"
				gint _tmp33_;
				gint _tmp34_;
				Video* video = NULL;
				GeeArrayList* _tmp35_;
				gpointer _tmp36_;
				Workers* _tmp37_;
				Video* _tmp38_;
				VideoMonitorVideoInterpretableCheckJob* _tmp39_;
				VideoMonitorVideoInterpretableCheckJob* _tmp40_;
#line 299 "../src/VideoMonitor.vala"
				_video_index = _video_index + 1;
#line 299 "../src/VideoMonitor.vala"
				_tmp33_ = _video_index;
#line 299 "../src/VideoMonitor.vala"
				_tmp34_ = _video_size;
#line 299 "../src/VideoMonitor.vala"
				if (!(_tmp33_ < _tmp34_)) {
#line 299 "../src/VideoMonitor.vala"
					break;
#line 1706 "VideoMonitor.c"
				}
#line 299 "../src/VideoMonitor.vala"
				_tmp35_ = _video_list;
#line 299 "../src/VideoMonitor.vala"
				_tmp36_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, _video_index);
#line 299 "../src/VideoMonitor.vala"
				video = (Video*) _tmp36_;
#line 300 "../src/VideoMonitor.vala"
				_tmp37_ = self->priv->workers;
#line 300 "../src/VideoMonitor.vala"
				_tmp38_ = video;
#line 300 "../src/VideoMonitor.vala"
				_tmp39_ = video_monitor_video_interpretable_check_job_new (_tmp38_, _video_monitor_on_interpretable_check_complete_completion_callback, self);
#line 300 "../src/VideoMonitor.vala"
				_tmp40_ = _tmp39_;
#line 300 "../src/VideoMonitor.vala"
				workers_enqueue (_tmp37_, (BackgroundJob*) _tmp40_);
#line 300 "../src/VideoMonitor.vala"
				_background_job_unref0 (_tmp40_);
#line 299 "../src/VideoMonitor.vala"
				_g_object_unref0 (video);
#line 1728 "VideoMonitor.c"
			}
		}
	}
#line 264 "../src/VideoMonitor.vala"
	_g_object_unref0 (check);
#line 1734 "VideoMonitor.c"
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 305 "../src/VideoMonitor.vala"
	return self ? background_job_ref (self) : NULL;
#line 1742 "VideoMonitor.c"
}

static void
video_monitor_on_interpretable_check_complete (VideoMonitor* self,
                                               BackgroundJob* j)
{
	VideoMonitorVideoInterpretableCheckJob* job = NULL;
	VideoMonitorVideoInterpretableCheckJob* _tmp0_;
	VideoMonitorVideoInterpretableCheckJob* _tmp1_;
	VideoInterpretableResults* _tmp2_;
	guint64 _tmp3_;
#line 304 "../src/VideoMonitor.vala"
	g_return_if_fail (self != NULL);
#line 304 "../src/VideoMonitor.vala"
	g_return_if_fail (j != NULL);
#line 305 "../src/VideoMonitor.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB, VideoMonitorVideoInterpretableCheckJob));
#line 305 "../src/VideoMonitor.vala"
	job = _tmp0_;
#line 307 "../src/VideoMonitor.vala"
	_tmp1_ = job;
#line 307 "../src/VideoMonitor.vala"
	_tmp2_ = _tmp1_->results;
#line 307 "../src/VideoMonitor.vala"
	video_interpretable_results_foreground_finish (_tmp2_);
#line 309 "../src/VideoMonitor.vala"
	self->priv->background_jobs = self->priv->background_jobs - 1;
#line 309 "../src/VideoMonitor.vala"
	_tmp3_ = self->priv->background_jobs;
#line 310 "../src/VideoMonitor.vala"
	if (self->priv->background_jobs <= ((guint64) 0)) {
#line 311 "../src/VideoMonitor.vala"
		video_notify_normal_thumbs_regenerated ();
#line 1776 "VideoMonitor.c"
	}
#line 304 "../src/VideoMonitor.vala"
	_background_job_unref0 (job);
#line 1780 "VideoMonitor.c"
}

static VideoMonitorVideoInterpretableCheckJob*
video_monitor_video_interpretable_check_job_construct (GType object_type,
                                                       Video* video,
                                                       CompletionCallback callback,
                                                       gpointer callback_target)
{
	VideoMonitorVideoInterpretableCheckJob* self = NULL;
	Video* _tmp0_;
#line 62 "../src/VideoMonitor.vala"
	g_return_val_if_fail (video != NULL, NULL);
#line 63 "../src/VideoMonitor.vala"
	self = (VideoMonitorVideoInterpretableCheckJob*) background_job_construct (object_type, (GObject*) video, callback, callback_target, NULL, NULL, NULL, NULL);
#line 64 "../src/VideoMonitor.vala"
	_tmp0_ = _g_object_ref0 (video);
#line 64 "../src/VideoMonitor.vala"
	_g_object_unref0 (self->video);
#line 64 "../src/VideoMonitor.vala"
	self->video = _tmp0_;
#line 62 "../src/VideoMonitor.vala"
	return self;
#line 1803 "VideoMonitor.c"
}

static VideoMonitorVideoInterpretableCheckJob*
video_monitor_video_interpretable_check_job_new (Video* video,
                                                 CompletionCallback callback,
                                                 gpointer callback_target)
{
#line 62 "../src/VideoMonitor.vala"
	return video_monitor_video_interpretable_check_job_construct (VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB, video, callback, callback_target);
#line 1813 "VideoMonitor.c"
}

static void
video_monitor_video_interpretable_check_job_real_execute (BackgroundJob* base)
{
	VideoMonitorVideoInterpretableCheckJob * self;
	Video* _tmp0_;
	VideoInterpretableResults* _tmp1_;
#line 67 "../src/VideoMonitor.vala"
	self = (VideoMonitorVideoInterpretableCheckJob*) base;
#line 68 "../src/VideoMonitor.vala"
	_tmp0_ = self->video;
#line 68 "../src/VideoMonitor.vala"
	_tmp1_ = video_check_is_interpretable (_tmp0_);
#line 68 "../src/VideoMonitor.vala"
	_video_interpretable_results_unref0 (self->results);
#line 68 "../src/VideoMonitor.vala"
	self->results = _tmp1_;
#line 1832 "VideoMonitor.c"
}

static void
video_monitor_video_interpretable_check_job_class_init (VideoMonitorVideoInterpretableCheckJobClass * klass,
                                                        gpointer klass_data)
{
#line 55 "../src/VideoMonitor.vala"
	video_monitor_video_interpretable_check_job_parent_class = g_type_class_peek_parent (klass);
#line 55 "../src/VideoMonitor.vala"
	((BackgroundJobClass *) klass)->finalize = video_monitor_video_interpretable_check_job_finalize;
#line 55 "../src/VideoMonitor.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) video_monitor_video_interpretable_check_job_real_execute;
#line 1845 "VideoMonitor.c"
}

static void
video_monitor_video_interpretable_check_job_instance_init (VideoMonitorVideoInterpretableCheckJob * self,
                                                           gpointer klass)
{
#line 60 "../src/VideoMonitor.vala"
	self->results = NULL;
#line 1854 "VideoMonitor.c"
}

static void
video_monitor_video_interpretable_check_job_finalize (BackgroundJob * obj)
{
	VideoMonitorVideoInterpretableCheckJob * self;
#line 55 "../src/VideoMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIDEO_MONITOR_TYPE_VIDEO_INTERPRETABLE_CHECK_JOB, VideoMonitorVideoInterpretableCheckJob);
#line 57 "../src/VideoMonitor.vala"
	_g_object_unref0 (self->video);
#line 60 "../src/VideoMonitor.vala"
	_video_interpretable_results_unref0 (self->results);
#line 55 "../src/VideoMonitor.vala"
	BACKGROUND_JOB_CLASS (video_monitor_video_interpretable_check_job_parent_class)->finalize (obj);
#line 1869 "VideoMonitor.c"
}

static GType
video_monitor_video_interpretable_check_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VideoMonitorVideoInterpretableCheckJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_monitor_video_interpretable_check_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoMonitorVideoInterpretableCheckJob), 0, (GInstanceInitFunc) video_monitor_video_interpretable_check_job_instance_init, NULL };
	GType video_monitor_video_interpretable_check_job_type_id;
	video_monitor_video_interpretable_check_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "VideoMonitorVideoInterpretableCheckJob", &g_define_type_info, 0);
	return video_monitor_video_interpretable_check_job_type_id;
}

static GType
video_monitor_video_interpretable_check_job_get_type (void)
{
	static volatile gsize video_monitor_video_interpretable_check_job_type_id__once = 0;
	if (g_once_init_enter (&video_monitor_video_interpretable_check_job_type_id__once)) {
		GType video_monitor_video_interpretable_check_job_type_id;
		video_monitor_video_interpretable_check_job_type_id = video_monitor_video_interpretable_check_job_get_type_once ();
		g_once_init_leave (&video_monitor_video_interpretable_check_job_type_id__once, video_monitor_video_interpretable_check_job_type_id);
	}
	return video_monitor_video_interpretable_check_job_type_id__once;
}

static void
video_monitor_class_init (VideoMonitorClass * klass,
                          gpointer klass_data)
{
#line 50 "../src/VideoMonitor.vala"
	video_monitor_parent_class = g_type_class_peek_parent (klass);
#line 50 "../src/VideoMonitor.vala"
	g_type_class_adjust_private_offset (klass, &VideoMonitor_private_offset);
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->create_updates = (MonitorableUpdates* (*) (MediaMonitor*, Monitorable*)) video_monitor_real_create_updates;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->get_media_source_collection = (MediaSourceCollection* (*) (MediaMonitor*)) video_monitor_real_get_media_source_collection;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->is_file_represented = (gboolean (*) (MediaMonitor*, GFile*)) video_monitor_real_is_file_represented;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_discovered = (MediaMonitorDiscoveredFile (*) (MediaMonitor*, GFile*, GFileInfo*, Monitorable**)) video_monitor_real_notify_file_discovered;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->candidates_for_unknown_file = (GeeCollection* (*) (MediaMonitor*, GFile*, GFileInfo*, MediaMonitorDiscoveredFile*)) video_monitor_real_candidates_for_unknown_file;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_created = (gboolean (*) (MediaMonitor*, GFile*, GFileInfo*)) video_monitor_real_notify_file_created;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_moved = (gboolean (*) (MediaMonitor*, GFile*, GFile*, GFileInfo*)) video_monitor_real_notify_file_moved;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_altered = (gboolean (*) (MediaMonitor*, GFile*)) video_monitor_real_notify_file_altered;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_attributes_altered = (gboolean (*) (MediaMonitor*, GFile*)) video_monitor_real_notify_file_attributes_altered;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_alteration_completed = (gboolean (*) (MediaMonitor*, GFile*, GFileInfo*)) video_monitor_real_notify_file_alteration_completed;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->notify_file_deleted = (gboolean (*) (MediaMonitor*, GFile*)) video_monitor_real_notify_file_deleted;
#line 50 "../src/VideoMonitor.vala"
	((MediaMonitorClass *) klass)->process_updates = (void (*) (MediaMonitor*, GeeCollection*, TransactionController*, gint*, GError**)) video_monitor_real_process_updates;
#line 50 "../src/VideoMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = video_monitor_finalize;
#line 1927 "VideoMonitor.c"
}

static void
video_monitor_instance_init (VideoMonitor * self,
                             gpointer klass)
{
	Workers* _tmp0_;
#line 50 "../src/VideoMonitor.vala"
	self->priv = video_monitor_get_instance_private (self);
#line 75 "../src/VideoMonitor.vala"
	_tmp0_ = workers_new (1, FALSE);
#line 75 "../src/VideoMonitor.vala"
	self->priv->workers = _tmp0_;
#line 76 "../src/VideoMonitor.vala"
	self->priv->background_jobs = (guint64) 0;
#line 1943 "VideoMonitor.c"
}

static void
video_monitor_finalize (GObject * obj)
{
	VideoMonitor * self;
#line 50 "../src/VideoMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_MONITOR, VideoMonitor);
#line 75 "../src/VideoMonitor.vala"
	_workers_unref0 (self->priv->workers);
#line 50 "../src/VideoMonitor.vala"
	G_OBJECT_CLASS (video_monitor_parent_class)->finalize (obj);
#line 1956 "VideoMonitor.c"
}

static GType
video_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VideoMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoMonitor), 0, (GInstanceInitFunc) video_monitor_instance_init, NULL };
	GType video_monitor_type_id;
	video_monitor_type_id = g_type_register_static (TYPE_MEDIA_MONITOR, "VideoMonitor", &g_define_type_info, 0);
	VideoMonitor_private_offset = g_type_add_instance_private (video_monitor_type_id, sizeof (VideoMonitorPrivate));
	return video_monitor_type_id;
}

GType
video_monitor_get_type (void)
{
	static volatile gsize video_monitor_type_id__once = 0;
	if (g_once_init_enter (&video_monitor_type_id__once)) {
		GType video_monitor_type_id;
		video_monitor_type_id = video_monitor_get_type_once ();
		g_once_init_leave (&video_monitor_type_id__once, video_monitor_type_id);
	}
	return video_monitor_type_id__once;
}

