/* CheckerboardPage.c generated by valac 0.56.18, the Vala compiler
 * generated from CheckerboardPage.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>

#define CHECKERBOARD_PAGE_AUTOSCROLL_PIXELS 50
#define CHECKERBOARD_PAGE_AUTOSCROLL_TICKS_MSEC 50
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CHECKERBOARD_PAGE_0_PROPERTY,
	CHECKERBOARD_PAGE_NUM_PROPERTIES
};
static GParamSpec* checkerboard_page_properties[CHECKERBOARD_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _CheckerboardPagePrivate {
	CheckerboardLayout* layout;
	gchar* page_sidebar_menu_path;
	GtkViewport* viewport;
	CheckerboardItem* highlighted;
	gboolean autoscroll_scheduled;
	gboolean selection_button_clicked;
	CheckerboardItem* activated_item;
	GeeArrayList* previously_selected;
};

static gint CheckerboardPage_private_offset;
static gpointer checkerboard_page_parent_class = NULL;

static gchar* checkerboard_page_real_get_back_name (CheckerboardPage* self);
static GtkMenu* checkerboard_page_real_get_item_context_menu (CheckerboardPage* self);
static gboolean checkerboard_page_real_on_context_keypress (Page* base);
static gchar* checkerboard_page_real_get_view_empty_message (CheckerboardPage* self);
static gchar* checkerboard_page_real_get_filter_no_match_message (CheckerboardPage* self);
static void checkerboard_page_real_on_item_activated (CheckerboardPage* self,
                                               CheckerboardItem* item);
static SearchViewFilter* checkerboard_page_real_get_search_view_filter (CheckerboardPage* self);
static CoreViewTracker* checkerboard_page_real_get_view_tracker (CheckerboardPage* self);
static void checkerboard_page_real_switching_from (Page* base);
static void checkerboard_page_on_view_filter_refresh (CheckerboardPage* self);
static void _checkerboard_page_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender,
                                                                    gpointer self);
static void checkerboard_page_real_switched_to (Page* base);
static void checkerboard_page_update_view_filter_message (CheckerboardPage* self);
static void checkerboard_page_on_contents_altered (CheckerboardPage* self,
                                            GeeIterable* added,
                                            GeeIterable* removed);
static void checkerboard_page_on_items_state_changed (CheckerboardPage* self,
                                               GeeIterable* changed);
static void checkerboard_page_on_items_visibility_changed (CheckerboardPage* self,
                                                    GeeCollection* changed);
static void checkerboard_page_on_items_hidden (CheckerboardPage* self,
                                        GeeIterable* hidden);
static gboolean checkerboard_page_real_key_press_event (GtkWidget* base,
                                                 GdkEventKey* event);
static void checkerboard_page_move_cursor (CheckerboardPage* self,
                                    GtkDirectionType direction);
static gboolean checkerboard_page_real_is_point_on_item_selection_button (CheckerboardPage* self,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   CheckerboardItem* item);
static gboolean checkerboard_page_real_on_left_click (Page* base,
                                               GdkEventButton* event);
static gboolean checkerboard_page_real_on_left_released (Page* base,
                                                  GdkEventButton* event);
static gboolean checkerboard_page_real_on_right_click (Page* base,
                                                GdkEventButton* event);
static gboolean checkerboard_page_real_on_mouse_over (CheckerboardPage* self,
                                               CheckerboardItem* item,
                                               gint x,
                                               gint y,
                                               GdkModifierType mask);
static gboolean checkerboard_page_real_on_motion (Page* base,
                                           GdkEventMotion* event,
                                           gint x,
                                           gint y,
                                           GdkModifierType mask);
static void checkerboard_page_updated_selection_band (CheckerboardPage* self);
static gboolean checkerboard_page_selection_autoscroll (CheckerboardPage* self);
static gboolean _checkerboard_page_selection_autoscroll_gsource_func (gpointer self);
static void checkerboard_page_real_set_display_titles (CheckerboardPage* self,
                                                gboolean display);
static void checkerboard_page_real_set_display_comments (CheckerboardPage* self,
                                                  gboolean display);
static GObject * checkerboard_page_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _checkerboard_page_on_items_hidden_view_collection_items_hidden (ViewCollection* _sender,
                                                                      GeeCollection* hidden,
                                                                      gpointer self);
static void _checkerboard_page_on_contents_altered_data_collection_contents_altered (DataCollection* _sender,
                                                                              GeeIterable* added,
                                                                              GeeIterable* removed,
                                                                              gpointer self);
static void _checkerboard_page_on_items_state_changed_view_collection_items_state_changed (ViewCollection* _sender,
                                                                                    GeeIterable* changed,
                                                                                    gpointer self);
static void _checkerboard_page_on_items_visibility_changed_view_collection_items_visibility_changed (ViewCollection* _sender,
                                                                                              GeeCollection* changed,
                                                                                              gpointer self);
static void _checkerboard_page___lambda116_ (CheckerboardPage* self);
static void __checkerboard_page___lambda116__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void checkerboard_page_finalize (GObject * obj);
static GType checkerboard_page_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
checkerboard_page_get_instance_private (CheckerboardPage* self)
{
	return G_STRUCT_MEMBER_P (self, CheckerboardPage_private_offset);
}

CheckerboardPage*
checkerboard_page_construct (GType object_type,
                             const gchar* page_name)
{
	CheckerboardPage * self = NULL;
#line 35 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (page_name != NULL, NULL);
#line 36 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) g_object_new (object_type, "page-name", page_name, NULL);
#line 35 "../src/Views/CheckerboardPage.vala"
	return self;
#line 173 "CheckerboardPage.c"
}

static gchar*
checkerboard_page_real_get_back_name (CheckerboardPage* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 69 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = page_get_page_name ((Page*) self);
#line 69 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 69 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 69 "../src/Views/CheckerboardPage.vala"
	result = _tmp2_;
#line 69 "../src/Views/CheckerboardPage.vala"
	return result;
#line 193 "CheckerboardPage.c"
}

gchar*
checkerboard_page_get_back_name (CheckerboardPage* self)
{
	CheckerboardPageClass* _klass_;
#line 68 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 68 "../src/Views/CheckerboardPage.vala"
	if (_klass_->get_back_name) {
#line 68 "../src/Views/CheckerboardPage.vala"
		return _klass_->get_back_name (self);
#line 208 "CheckerboardPage.c"
	}
#line 68 "../src/Views/CheckerboardPage.vala"
	return NULL;
#line 212 "CheckerboardPage.c"
}

void
checkerboard_page_init_page_sidebar_menu (CheckerboardPage* self,
                                          const gchar* path)
{
	gchar* _tmp0_;
#line 72 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (path != NULL);
#line 73 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = g_strdup (path);
#line 73 "../src/Views/CheckerboardPage.vala"
	_g_free0 (self->priv->page_sidebar_menu_path);
#line 73 "../src/Views/CheckerboardPage.vala"
	self->priv->page_sidebar_menu_path = _tmp0_;
#line 230 "CheckerboardPage.c"
}

GtkMenu*
checkerboard_page_get_context_menu (CheckerboardPage* self)
{
	GtkMenu* _tmp0_ = NULL;
	ViewCollection* _tmp1_;
	ViewCollection* _tmp2_;
	gboolean _tmp3_;
	GtkMenu* result;
#line 76 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = page_get_view ((Page*) self);
#line 78 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = _tmp1_;
#line 78 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = view_collection_get_selected_count (_tmp2_) != 0;
#line 78 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp2_);
#line 78 "../src/Views/CheckerboardPage.vala"
	if (_tmp3_) {
#line 253 "CheckerboardPage.c"
		GtkMenu* _tmp4_;
#line 78 "../src/Views/CheckerboardPage.vala"
		_tmp4_ = checkerboard_page_get_item_context_menu (self);
#line 78 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (_tmp0_);
#line 78 "../src/Views/CheckerboardPage.vala"
		_tmp0_ = _tmp4_;
#line 261 "CheckerboardPage.c"
	} else {
		GtkMenu* _tmp5_;
#line 79 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = page_get_page_context_menu ((Page*) self);
#line 79 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (_tmp0_);
#line 79 "../src/Views/CheckerboardPage.vala"
		_tmp0_ = _tmp5_;
#line 270 "CheckerboardPage.c"
	}
#line 78 "../src/Views/CheckerboardPage.vala"
	result = _tmp0_;
#line 78 "../src/Views/CheckerboardPage.vala"
	return result;
#line 276 "CheckerboardPage.c"
}

static GtkMenu*
checkerboard_page_real_get_item_context_menu (CheckerboardPage* self)
{
	GtkMenu* result;
#line 83 "../src/Views/CheckerboardPage.vala"
	result = NULL;
#line 83 "../src/Views/CheckerboardPage.vala"
	return result;
#line 287 "CheckerboardPage.c"
}

GtkMenu*
checkerboard_page_get_item_context_menu (CheckerboardPage* self)
{
	CheckerboardPageClass* _klass_;
#line 82 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 82 "../src/Views/CheckerboardPage.vala"
	if (_klass_->get_item_context_menu) {
#line 82 "../src/Views/CheckerboardPage.vala"
		return _klass_->get_item_context_menu (self);
#line 302 "CheckerboardPage.c"
	}
#line 82 "../src/Views/CheckerboardPage.vala"
	return NULL;
#line 306 "CheckerboardPage.c"
}

static gboolean
checkerboard_page_real_on_context_keypress (Page* base)
{
	CheckerboardPage * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 86 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) base;
#line 87 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = checkerboard_page_get_context_menu (self);
#line 87 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 87 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = page_popup_context_menu ((Page*) self, _tmp1_, NULL);
#line 87 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (_tmp1_);
#line 87 "../src/Views/CheckerboardPage.vala"
	result = _tmp2_;
#line 87 "../src/Views/CheckerboardPage.vala"
	return result;
#line 331 "CheckerboardPage.c"
}

static gchar*
checkerboard_page_real_get_view_empty_message (CheckerboardPage* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 91 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = g_strdup (_ ("No photos/videos"));
#line 91 "../src/Views/CheckerboardPage.vala"
	result = _tmp0_;
#line 91 "../src/Views/CheckerboardPage.vala"
	return result;
#line 345 "CheckerboardPage.c"
}

gchar*
checkerboard_page_get_view_empty_message (CheckerboardPage* self)
{
	CheckerboardPageClass* _klass_;
#line 90 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 90 "../src/Views/CheckerboardPage.vala"
	if (_klass_->get_view_empty_message) {
#line 90 "../src/Views/CheckerboardPage.vala"
		return _klass_->get_view_empty_message (self);
#line 360 "CheckerboardPage.c"
	}
#line 90 "../src/Views/CheckerboardPage.vala"
	return NULL;
#line 364 "CheckerboardPage.c"
}

static gchar*
checkerboard_page_real_get_filter_no_match_message (CheckerboardPage* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 95 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = g_strdup (_ ("No photos/videos found"));
#line 95 "../src/Views/CheckerboardPage.vala"
	result = _tmp0_;
#line 95 "../src/Views/CheckerboardPage.vala"
	return result;
#line 378 "CheckerboardPage.c"
}

gchar*
checkerboard_page_get_filter_no_match_message (CheckerboardPage* self)
{
	CheckerboardPageClass* _klass_;
#line 94 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 94 "../src/Views/CheckerboardPage.vala"
	if (_klass_->get_filter_no_match_message) {
#line 94 "../src/Views/CheckerboardPage.vala"
		return _klass_->get_filter_no_match_message (self);
#line 393 "CheckerboardPage.c"
	}
#line 94 "../src/Views/CheckerboardPage.vala"
	return NULL;
#line 397 "CheckerboardPage.c"
}

static void
checkerboard_page_real_on_item_activated (CheckerboardPage* self,
                                          CheckerboardItem* item)
{
#line 98 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (item != NULL);
#line 406 "CheckerboardPage.c"
}

void
checkerboard_page_on_item_activated (CheckerboardPage* self,
                                     CheckerboardItem* item)
{
	CheckerboardPageClass* _klass_;
#line 98 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 98 "../src/Views/CheckerboardPage.vala"
	if (_klass_->on_item_activated) {
#line 98 "../src/Views/CheckerboardPage.vala"
		_klass_->on_item_activated (self, item);
#line 422 "CheckerboardPage.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 102 "../src/Views/CheckerboardPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 431 "CheckerboardPage.c"
}

CheckerboardLayout*
checkerboard_page_get_checkerboard_layout (CheckerboardPage* self)
{
	CheckerboardLayout* _tmp0_;
	CheckerboardLayout* _tmp1_;
	CheckerboardLayout* result;
#line 101 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 102 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 102 "../src/Views/CheckerboardPage.vala"
	result = _tmp1_;
#line 102 "../src/Views/CheckerboardPage.vala"
	return result;
#line 450 "CheckerboardPage.c"
}

static SearchViewFilter*
checkerboard_page_real_get_search_view_filter (CheckerboardPage* self)
{
#line 106 "../src/Views/CheckerboardPage.vala"
	g_critical ("Type `%s' does not implement abstract method `checkerboard_page_get_search_view_filter'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 106 "../src/Views/CheckerboardPage.vala"
	return NULL;
#line 460 "CheckerboardPage.c"
}

SearchViewFilter*
checkerboard_page_get_search_view_filter (CheckerboardPage* self)
{
	CheckerboardPageClass* _klass_;
#line 106 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 106 "../src/Views/CheckerboardPage.vala"
	if (_klass_->get_search_view_filter) {
#line 106 "../src/Views/CheckerboardPage.vala"
		return _klass_->get_search_view_filter (self);
#line 475 "CheckerboardPage.c"
	}
#line 106 "../src/Views/CheckerboardPage.vala"
	return NULL;
#line 479 "CheckerboardPage.c"
}

static CoreViewTracker*
checkerboard_page_real_get_view_tracker (CheckerboardPage* self)
{
	CoreViewTracker* result;
#line 109 "../src/Views/CheckerboardPage.vala"
	result = NULL;
#line 109 "../src/Views/CheckerboardPage.vala"
	return result;
#line 490 "CheckerboardPage.c"
}

CoreViewTracker*
checkerboard_page_get_view_tracker (CheckerboardPage* self)
{
	CheckerboardPageClass* _klass_;
#line 108 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 108 "../src/Views/CheckerboardPage.vala"
	if (_klass_->get_view_tracker) {
#line 108 "../src/Views/CheckerboardPage.vala"
		return _klass_->get_view_tracker (self);
#line 505 "CheckerboardPage.c"
	}
#line 108 "../src/Views/CheckerboardPage.vala"
	return NULL;
#line 509 "CheckerboardPage.c"
}

static void
_checkerboard_page_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender,
                                                               gpointer self)
{
#line 114 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_on_view_filter_refresh ((CheckerboardPage*) self);
#line 518 "CheckerboardPage.c"
}

static void
checkerboard_page_real_switching_from (Page* base)
{
	CheckerboardPage * self;
	CheckerboardLayout* _tmp0_;
	SearchViewFilter* _tmp1_;
	SearchViewFilter* _tmp2_;
	guint _tmp3_;
	ViewCollection* _tmp4_;
	ViewCollection* _tmp5_;
#line 112 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) base;
#line 113 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 113 "../src/Views/CheckerboardPage.vala"
	checkerboard_layout_set_in_view (_tmp0_, FALSE);
#line 114 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = checkerboard_page_get_search_view_filter (self);
#line 114 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = _tmp1_;
#line 114 "../src/Views/CheckerboardPage.vala"
	g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp3_, NULL, FALSE);
#line 114 "../src/Views/CheckerboardPage.vala"
	g_signal_handlers_disconnect_matched ((ViewFilter*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _checkerboard_page_on_view_filter_refresh_view_filter_refresh, self);
#line 114 "../src/Views/CheckerboardPage.vala"
	_view_filter_unref0 (_tmp2_);
#line 117 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = page_get_view ((Page*) self);
#line 117 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = _tmp4_;
#line 117 "../src/Views/CheckerboardPage.vala"
	view_collection_unselect_all (_tmp5_);
#line 117 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp5_);
#line 118 "../src/Views/CheckerboardPage.vala"
	PAGE_CLASS (checkerboard_page_parent_class)->switching_from (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE, Page));
#line 557 "CheckerboardPage.c"
}

static void
checkerboard_page_real_switched_to (Page* base)
{
	CheckerboardPage * self;
	CheckerboardLayout* _tmp0_;
	SearchViewFilter* _tmp1_;
	SearchViewFilter* _tmp2_;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	gboolean _tmp5_;
#line 121 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) base;
#line 122 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 122 "../src/Views/CheckerboardPage.vala"
	checkerboard_layout_set_in_view (_tmp0_, TRUE);
#line 123 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = checkerboard_page_get_search_view_filter (self);
#line 123 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = _tmp1_;
#line 123 "../src/Views/CheckerboardPage.vala"
	g_signal_connect_object ((ViewFilter*) _tmp2_, "refresh", (GCallback) _checkerboard_page_on_view_filter_refresh_view_filter_refresh, self, 0);
#line 123 "../src/Views/CheckerboardPage.vala"
	_view_filter_unref0 (_tmp2_);
#line 124 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_on_view_filter_refresh (self);
#line 126 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 126 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = _tmp3_;
#line 126 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = view_collection_get_selected_count (_tmp4_) > 0;
#line 126 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 126 "../src/Views/CheckerboardPage.vala"
	if (_tmp5_) {
#line 596 "CheckerboardPage.c"
		CheckerboardItem* item = NULL;
		ViewCollection* _tmp6_;
		ViewCollection* _tmp7_;
		DataView* _tmp8_;
		CheckerboardItem* _tmp9_;
		GtkAdjustment* vadj = NULL;
		GtkAdjustment* _tmp10_;
		GtkAdjustment* _tmp11_;
		gboolean _tmp12_ = FALSE;
		GtkAdjustment* _tmp13_;
		CheckerboardItem* _tmp14_;
		GdkRectangle _tmp15_;
#line 127 "../src/Views/CheckerboardPage.vala"
		_tmp6_ = page_get_view ((Page*) self);
#line 127 "../src/Views/CheckerboardPage.vala"
		_tmp7_ = _tmp6_;
#line 127 "../src/Views/CheckerboardPage.vala"
		_tmp8_ = view_collection_get_selected_at (_tmp7_, 0);
#line 127 "../src/Views/CheckerboardPage.vala"
		_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 127 "../src/Views/CheckerboardPage.vala"
		_data_collection_unref0 (_tmp7_);
#line 127 "../src/Views/CheckerboardPage.vala"
		item = _tmp9_;
#line 130 "../src/Views/CheckerboardPage.vala"
		_tmp10_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 130 "../src/Views/CheckerboardPage.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 130 "../src/Views/CheckerboardPage.vala"
		vadj = _tmp11_;
#line 131 "../src/Views/CheckerboardPage.vala"
		_tmp13_ = vadj;
#line 131 "../src/Views/CheckerboardPage.vala"
		_tmp14_ = item;
#line 131 "../src/Views/CheckerboardPage.vala"
		_tmp15_ = _tmp14_->allocation;
#line 131 "../src/Views/CheckerboardPage.vala"
		if (get_adjustment_relation (_tmp13_, _tmp15_.y) == ADJUSTMENT_RELATION_IN_RANGE) {
#line 635 "CheckerboardPage.c"
			GtkAdjustment* _tmp16_;
			CheckerboardItem* _tmp17_;
			GdkRectangle _tmp18_;
			CheckerboardItem* _tmp19_;
			GdkRectangle _tmp20_;
#line 132 "../src/Views/CheckerboardPage.vala"
			_tmp16_ = vadj;
#line 132 "../src/Views/CheckerboardPage.vala"
			_tmp17_ = item;
#line 132 "../src/Views/CheckerboardPage.vala"
			_tmp18_ = _tmp17_->allocation;
#line 132 "../src/Views/CheckerboardPage.vala"
			_tmp19_ = item;
#line 132 "../src/Views/CheckerboardPage.vala"
			_tmp20_ = _tmp19_->allocation;
#line 132 "../src/Views/CheckerboardPage.vala"
			_tmp12_ = get_adjustment_relation (_tmp16_, _tmp18_.y + _tmp20_.height) == ADJUSTMENT_RELATION_IN_RANGE;
#line 653 "CheckerboardPage.c"
		} else {
#line 131 "../src/Views/CheckerboardPage.vala"
			_tmp12_ = FALSE;
#line 657 "CheckerboardPage.c"
		}
#line 131 "../src/Views/CheckerboardPage.vala"
		if (!_tmp12_) {
#line 661 "CheckerboardPage.c"
			gint top = 0;
			CheckerboardItem* _tmp21_;
			GdkRectangle _tmp22_;
			GtkAdjustment* _tmp23_;
			GtkAdjustment* _tmp31_;
#line 135 "../src/Views/CheckerboardPage.vala"
			top = 0;
#line 136 "../src/Views/CheckerboardPage.vala"
			_tmp21_ = item;
#line 136 "../src/Views/CheckerboardPage.vala"
			_tmp22_ = _tmp21_->allocation;
#line 136 "../src/Views/CheckerboardPage.vala"
			_tmp23_ = vadj;
#line 136 "../src/Views/CheckerboardPage.vala"
			if (((gdouble) _tmp22_.y) < gtk_adjustment_get_value (_tmp23_)) {
#line 677 "CheckerboardPage.c"
				CheckerboardItem* _tmp24_;
				GdkRectangle _tmp25_;
#line 137 "../src/Views/CheckerboardPage.vala"
				_tmp24_ = item;
#line 137 "../src/Views/CheckerboardPage.vala"
				_tmp25_ = _tmp24_->allocation;
#line 137 "../src/Views/CheckerboardPage.vala"
				top = _tmp25_.y;
#line 138 "../src/Views/CheckerboardPage.vala"
				top -= CHECKERBOARD_LAYOUT_ROW_GUTTER_PADDING / 2;
#line 688 "CheckerboardPage.c"
			} else {
				CheckerboardItem* _tmp26_;
				GdkRectangle _tmp27_;
				CheckerboardItem* _tmp28_;
				GdkRectangle _tmp29_;
				GtkAdjustment* _tmp30_;
#line 140 "../src/Views/CheckerboardPage.vala"
				_tmp26_ = item;
#line 140 "../src/Views/CheckerboardPage.vala"
				_tmp27_ = _tmp26_->allocation;
#line 140 "../src/Views/CheckerboardPage.vala"
				_tmp28_ = item;
#line 140 "../src/Views/CheckerboardPage.vala"
				_tmp29_ = _tmp28_->allocation;
#line 140 "../src/Views/CheckerboardPage.vala"
				_tmp30_ = vadj;
#line 140 "../src/Views/CheckerboardPage.vala"
				top = (_tmp27_.y + _tmp29_.height) - ((gint) gtk_adjustment_get_page_size (_tmp30_));
#line 141 "../src/Views/CheckerboardPage.vala"
				top += CHECKERBOARD_LAYOUT_ROW_GUTTER_PADDING / 2;
#line 709 "CheckerboardPage.c"
			}
#line 144 "../src/Views/CheckerboardPage.vala"
			_tmp31_ = vadj;
#line 144 "../src/Views/CheckerboardPage.vala"
			gtk_adjustment_set_value (_tmp31_, (gdouble) top);
#line 715 "CheckerboardPage.c"
		}
#line 126 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (vadj);
#line 126 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (item);
#line 721 "CheckerboardPage.c"
	}
#line 148 "../src/Views/CheckerboardPage.vala"
	PAGE_CLASS (checkerboard_page_parent_class)->switched_to (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE, Page));
#line 725 "CheckerboardPage.c"
}

static void
checkerboard_page_on_view_filter_refresh (CheckerboardPage* self)
{
#line 151 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_update_view_filter_message (self);
#line 735 "CheckerboardPage.c"
}

static void
checkerboard_page_on_contents_altered (CheckerboardPage* self,
                                       GeeIterable* added,
                                       GeeIterable* removed)
{
#line 155 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_update_view_filter_message (self);
#line 747 "CheckerboardPage.c"
}

static void
checkerboard_page_on_items_state_changed (CheckerboardPage* self,
                                          GeeIterable* changed)
{
#line 160 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (changed != NULL);
#line 161 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_update_view_filter_message (self);
#line 760 "CheckerboardPage.c"
}

static void
checkerboard_page_on_items_visibility_changed (CheckerboardPage* self,
                                               GeeCollection* changed)
{
#line 164 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (changed != NULL);
#line 165 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_update_view_filter_message (self);
#line 773 "CheckerboardPage.c"
}

static void
checkerboard_page_update_view_filter_message (CheckerboardPage* self)
{
	LibraryWindow* window = NULL;
	AppWindow* _tmp0_;
	LibraryWindow* _tmp1_;
	LibraryWindow* _tmp2_;
	LibraryWindow* _tmp3_;
	gboolean _tmp5_ = FALSE;
	ViewCollection* _tmp6_;
	ViewCollection* _tmp7_;
	gboolean _tmp8_;
#line 168 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = app_window_get_instance ();
#line 169 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = IS_LIBRARY_WINDOW (_tmp0_) ? ((LibraryWindow*) _tmp0_) : NULL;
#line 169 "../src/Views/CheckerboardPage.vala"
	if (_tmp1_ == NULL) {
#line 169 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (_tmp0_);
#line 798 "CheckerboardPage.c"
	}
#line 169 "../src/Views/CheckerboardPage.vala"
	window = _tmp1_;
#line 170 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = window;
#line 170 "../src/Views/CheckerboardPage.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 171 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = window;
#line 171 "../src/Views/CheckerboardPage.vala"
	if (_tmp3_ != NULL) {
#line 810 "CheckerboardPage.c"
		LibraryWindow* _tmp4_;
#line 172 "../src/Views/CheckerboardPage.vala"
		_tmp4_ = window;
#line 172 "../src/Views/CheckerboardPage.vala"
		library_window_toggle_welcome_page (_tmp4_, FALSE, "", "", FALSE);
#line 816 "CheckerboardPage.c"
	}
#line 174 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = page_get_view ((Page*) self);
#line 174 "../src/Views/CheckerboardPage.vala"
	_tmp7_ = _tmp6_;
#line 174 "../src/Views/CheckerboardPage.vala"
	_tmp8_ = view_collection_are_items_filtered_out (_tmp7_);
#line 174 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp7_);
#line 174 "../src/Views/CheckerboardPage.vala"
	if (_tmp8_) {
#line 828 "CheckerboardPage.c"
		ViewCollection* _tmp9_;
		ViewCollection* _tmp10_;
#line 174 "../src/Views/CheckerboardPage.vala"
		_tmp9_ = page_get_view ((Page*) self);
#line 174 "../src/Views/CheckerboardPage.vala"
		_tmp10_ = _tmp9_;
#line 174 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = data_collection_get_count ((DataCollection*) _tmp10_) == 0;
#line 174 "../src/Views/CheckerboardPage.vala"
		_data_collection_unref0 (_tmp10_);
#line 839 "CheckerboardPage.c"
	} else {
#line 174 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = FALSE;
#line 843 "CheckerboardPage.c"
	}
#line 174 "../src/Views/CheckerboardPage.vala"
	if (_tmp5_) {
#line 847 "CheckerboardPage.c"
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 175 "../src/Views/CheckerboardPage.vala"
		_tmp11_ = checkerboard_page_get_filter_no_match_message (self);
#line 175 "../src/Views/CheckerboardPage.vala"
		_tmp12_ = _tmp11_;
#line 175 "../src/Views/CheckerboardPage.vala"
		checkerboard_page_set_page_message (self, _tmp12_);
#line 175 "../src/Views/CheckerboardPage.vala"
		_g_free0 (_tmp12_);
#line 858 "CheckerboardPage.c"
	} else {
		ViewCollection* _tmp13_;
		ViewCollection* _tmp14_;
		gboolean _tmp15_;
#line 176 "../src/Views/CheckerboardPage.vala"
		_tmp13_ = page_get_view ((Page*) self);
#line 176 "../src/Views/CheckerboardPage.vala"
		_tmp14_ = _tmp13_;
#line 176 "../src/Views/CheckerboardPage.vala"
		_tmp15_ = data_collection_get_count ((DataCollection*) _tmp14_) == 0;
#line 176 "../src/Views/CheckerboardPage.vala"
		_data_collection_unref0 (_tmp14_);
#line 176 "../src/Views/CheckerboardPage.vala"
		if (_tmp15_) {
#line 873 "CheckerboardPage.c"
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 177 "../src/Views/CheckerboardPage.vala"
			_tmp16_ = checkerboard_page_get_view_empty_message (self);
#line 177 "../src/Views/CheckerboardPage.vala"
			_tmp17_ = _tmp16_;
#line 177 "../src/Views/CheckerboardPage.vala"
			checkerboard_page_set_page_message (self, _tmp17_);
#line 177 "../src/Views/CheckerboardPage.vala"
			_g_free0 (_tmp17_);
#line 884 "CheckerboardPage.c"
		} else {
#line 179 "../src/Views/CheckerboardPage.vala"
			checkerboard_page_unset_page_message (self);
#line 888 "CheckerboardPage.c"
		}
	}
#line 168 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (window);
#line 893 "CheckerboardPage.c"
}

void
checkerboard_page_set_page_message (CheckerboardPage* self,
                                    const gchar* message)
{
	CheckerboardLayout* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 183 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (message != NULL);
#line 184 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 184 "../src/Views/CheckerboardPage.vala"
	checkerboard_layout_set_message (_tmp0_, message);
#line 185 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = page_get_in_view ((Page*) self);
#line 185 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = _tmp1_;
#line 185 "../src/Views/CheckerboardPage.vala"
	if (_tmp2_) {
#line 917 "CheckerboardPage.c"
		CheckerboardLayout* _tmp3_;
#line 186 "../src/Views/CheckerboardPage.vala"
		_tmp3_ = self->priv->layout;
#line 186 "../src/Views/CheckerboardPage.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
#line 923 "CheckerboardPage.c"
	}
}

void
checkerboard_page_unset_page_message (CheckerboardPage* self)
{
	CheckerboardLayout* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 189 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 190 "../src/Views/CheckerboardPage.vala"
	checkerboard_layout_unset_message (_tmp0_);
#line 191 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = page_get_in_view ((Page*) self);
#line 191 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = _tmp1_;
#line 191 "../src/Views/CheckerboardPage.vala"
	if (_tmp2_) {
#line 945 "CheckerboardPage.c"
		CheckerboardLayout* _tmp3_;
#line 192 "../src/Views/CheckerboardPage.vala"
		_tmp3_ = self->priv->layout;
#line 192 "../src/Views/CheckerboardPage.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
#line 951 "CheckerboardPage.c"
	}
}

CheckerboardItem*
checkerboard_page_get_item_at_pixel (CheckerboardPage* self,
                                     gdouble x,
                                     gdouble y)
{
	CheckerboardLayout* _tmp0_;
	CheckerboardItem* _tmp1_;
	CheckerboardItem* result;
#line 195 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 196 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 196 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = checkerboard_layout_get_item_at_pixel (_tmp0_, x, y);
#line 196 "../src/Views/CheckerboardPage.vala"
	result = _tmp1_;
#line 196 "../src/Views/CheckerboardPage.vala"
	return result;
#line 973 "CheckerboardPage.c"
}

static void
checkerboard_page_on_items_hidden (CheckerboardPage* self,
                                   GeeIterable* hidden)
{
#line 199 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (hidden != NULL);
#line 984 "CheckerboardPage.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp0_;
#line 200 "../src/Views/CheckerboardPage.vala"
		_tmp0_ = gee_iterable_iterator (hidden);
#line 200 "../src/Views/CheckerboardPage.vala"
		_view_it = _tmp0_;
#line 200 "../src/Views/CheckerboardPage.vala"
		while (TRUE) {
#line 994 "CheckerboardPage.c"
			GeeIterator* _tmp1_;
			DataView* view = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			CheckerboardItem* item = NULL;
			DataView* _tmp4_;
			CheckerboardItem* _tmp5_;
			CheckerboardItem* _tmp6_;
			CheckerboardItem* _tmp7_;
			CheckerboardItem* _tmp8_;
			CheckerboardItem* _tmp9_;
			CheckerboardItem* _tmp10_;
			CheckerboardItem* _tmp11_;
#line 200 "../src/Views/CheckerboardPage.vala"
			_tmp1_ = _view_it;
#line 200 "../src/Views/CheckerboardPage.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 200 "../src/Views/CheckerboardPage.vala"
				break;
#line 1014 "CheckerboardPage.c"
			}
#line 200 "../src/Views/CheckerboardPage.vala"
			_tmp2_ = _view_it;
#line 200 "../src/Views/CheckerboardPage.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 200 "../src/Views/CheckerboardPage.vala"
			view = (DataView*) _tmp3_;
#line 201 "../src/Views/CheckerboardPage.vala"
			_tmp4_ = view;
#line 201 "../src/Views/CheckerboardPage.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem));
#line 201 "../src/Views/CheckerboardPage.vala"
			item = _tmp5_;
#line 203 "../src/Views/CheckerboardPage.vala"
			_tmp6_ = self->anchor;
#line 203 "../src/Views/CheckerboardPage.vala"
			_tmp7_ = item;
#line 203 "../src/Views/CheckerboardPage.vala"
			if (_tmp6_ == _tmp7_) {
#line 204 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (self->anchor);
#line 204 "../src/Views/CheckerboardPage.vala"
				self->anchor = NULL;
#line 1038 "CheckerboardPage.c"
			}
#line 206 "../src/Views/CheckerboardPage.vala"
			_tmp8_ = self->cursor;
#line 206 "../src/Views/CheckerboardPage.vala"
			_tmp9_ = item;
#line 206 "../src/Views/CheckerboardPage.vala"
			if (_tmp8_ == _tmp9_) {
#line 207 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (self->cursor);
#line 207 "../src/Views/CheckerboardPage.vala"
				self->cursor = NULL;
#line 1050 "CheckerboardPage.c"
			}
#line 209 "../src/Views/CheckerboardPage.vala"
			_tmp10_ = self->priv->highlighted;
#line 209 "../src/Views/CheckerboardPage.vala"
			_tmp11_ = item;
#line 209 "../src/Views/CheckerboardPage.vala"
			if (_tmp10_ == _tmp11_) {
#line 210 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (self->priv->highlighted);
#line 210 "../src/Views/CheckerboardPage.vala"
				self->priv->highlighted = NULL;
#line 1062 "CheckerboardPage.c"
			}
#line 200 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (item);
#line 200 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (view);
#line 1068 "CheckerboardPage.c"
		}
#line 200 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (_view_it);
#line 1072 "CheckerboardPage.c"
	}
}

static gboolean
checkerboard_page_real_key_press_event (GtkWidget* base,
                                        GdkEventKey* event)
{
	CheckerboardPage * self;
	gboolean handled = FALSE;
	guint state = 0U;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label0 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label1 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label2 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label3 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label4 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label5 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label6 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label7 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label8 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label9 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label10 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label11 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label12 = 0;
#line 220 "../src/Views/CheckerboardPage.vala"
	static GQuark _tmp2_label13 = 0;
#line 1114 "CheckerboardPage.c"
	gboolean _tmp23_ = FALSE;
	gboolean result;
#line 214 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) base;
#line 214 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 215 "../src/Views/CheckerboardPage.vala"
	handled = TRUE;
#line 218 "../src/Views/CheckerboardPage.vala"
	state = (guint) (event->state & GDK_SHIFT_MASK);
#line 220 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 220 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 220 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 220 "../src/Views/CheckerboardPage.vala"
	if ((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Up")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("KP_Up"))))) {
#line 220 "../src/Views/CheckerboardPage.vala"
		switch (0) {
#line 1135 "CheckerboardPage.c"
			default:
			{
#line 223 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_move_cursor (self, GTK_DIR_UP);
#line 224 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_select_anchor_to_cursor (self, state);
#line 225 "../src/Views/CheckerboardPage.vala"
				break;
#line 1144 "CheckerboardPage.c"
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("Down")))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("KP_Down"))))) {
#line 220 "../src/Views/CheckerboardPage.vala"
		switch (0) {
#line 1150 "CheckerboardPage.c"
			default:
			{
#line 229 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_move_cursor (self, GTK_DIR_DOWN);
#line 230 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_select_anchor_to_cursor (self, state);
#line 231 "../src/Views/CheckerboardPage.vala"
				break;
#line 1159 "CheckerboardPage.c"
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("Left")))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("KP_Left"))))) {
#line 220 "../src/Views/CheckerboardPage.vala"
		switch (0) {
#line 1165 "CheckerboardPage.c"
			default:
			{
#line 235 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_move_cursor (self, GTK_DIR_LEFT);
#line 236 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_select_anchor_to_cursor (self, state);
#line 237 "../src/Views/CheckerboardPage.vala"
				break;
#line 1174 "CheckerboardPage.c"
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("Right")))) || (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("KP_Right"))))) {
#line 220 "../src/Views/CheckerboardPage.vala"
		switch (0) {
#line 1180 "CheckerboardPage.c"
			default:
			{
#line 241 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_move_cursor (self, GTK_DIR_RIGHT);
#line 242 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_select_anchor_to_cursor (self, state);
#line 243 "../src/Views/CheckerboardPage.vala"
				break;
#line 1189 "CheckerboardPage.c"
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("Home")))) || (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("KP_Home"))))) {
#line 220 "../src/Views/CheckerboardPage.vala"
		switch (0) {
#line 1195 "CheckerboardPage.c"
			default:
			{
				CheckerboardItem* first = NULL;
				ViewCollection* _tmp4_;
				ViewCollection* _tmp5_;
				DataView* _tmp6_;
				CheckerboardItem* _tmp7_;
				CheckerboardItem* _tmp8_;
#line 247 "../src/Views/CheckerboardPage.vala"
				_tmp4_ = page_get_view ((Page*) self);
#line 247 "../src/Views/CheckerboardPage.vala"
				_tmp5_ = _tmp4_;
#line 247 "../src/Views/CheckerboardPage.vala"
				_tmp6_ = view_collection_get_first (_tmp5_);
#line 247 "../src/Views/CheckerboardPage.vala"
				_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 247 "../src/Views/CheckerboardPage.vala"
				_data_collection_unref0 (_tmp5_);
#line 247 "../src/Views/CheckerboardPage.vala"
				first = _tmp7_;
#line 248 "../src/Views/CheckerboardPage.vala"
				_tmp8_ = first;
#line 248 "../src/Views/CheckerboardPage.vala"
				if (_tmp8_ != NULL) {
#line 1220 "CheckerboardPage.c"
					CheckerboardItem* _tmp9_;
#line 249 "../src/Views/CheckerboardPage.vala"
					_tmp9_ = first;
#line 249 "../src/Views/CheckerboardPage.vala"
					checkerboard_page_cursor_to_item (self, _tmp9_);
#line 1226 "CheckerboardPage.c"
				}
#line 250 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_select_anchor_to_cursor (self, state);
#line 251 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (first);
#line 251 "../src/Views/CheckerboardPage.vala"
				break;
#line 1234 "CheckerboardPage.c"
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("End")))) || (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("KP_End"))))) {
#line 220 "../src/Views/CheckerboardPage.vala"
		switch (0) {
#line 1240 "CheckerboardPage.c"
			default:
			{
				CheckerboardItem* last = NULL;
				ViewCollection* _tmp10_;
				ViewCollection* _tmp11_;
				DataView* _tmp12_;
				CheckerboardItem* _tmp13_;
				CheckerboardItem* _tmp14_;
#line 255 "../src/Views/CheckerboardPage.vala"
				_tmp10_ = page_get_view ((Page*) self);
#line 255 "../src/Views/CheckerboardPage.vala"
				_tmp11_ = _tmp10_;
#line 255 "../src/Views/CheckerboardPage.vala"
				_tmp12_ = view_collection_get_last (_tmp11_);
#line 255 "../src/Views/CheckerboardPage.vala"
				_tmp13_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 255 "../src/Views/CheckerboardPage.vala"
				_data_collection_unref0 (_tmp11_);
#line 255 "../src/Views/CheckerboardPage.vala"
				last = _tmp13_;
#line 256 "../src/Views/CheckerboardPage.vala"
				_tmp14_ = last;
#line 256 "../src/Views/CheckerboardPage.vala"
				if (_tmp14_ != NULL) {
#line 1265 "CheckerboardPage.c"
					CheckerboardItem* _tmp15_;
#line 257 "../src/Views/CheckerboardPage.vala"
					_tmp15_ = last;
#line 257 "../src/Views/CheckerboardPage.vala"
					checkerboard_page_cursor_to_item (self, _tmp15_);
#line 1271 "CheckerboardPage.c"
				}
#line 258 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_select_anchor_to_cursor (self, state);
#line 259 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (last);
#line 259 "../src/Views/CheckerboardPage.vala"
				break;
#line 1279 "CheckerboardPage.c"
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("Return")))) || (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("KP_Enter"))))) {
#line 220 "../src/Views/CheckerboardPage.vala"
		switch (0) {
#line 1285 "CheckerboardPage.c"
			default:
			{
				ViewCollection* _tmp16_;
				ViewCollection* _tmp17_;
				gboolean _tmp18_;
#line 263 "../src/Views/CheckerboardPage.vala"
				_tmp16_ = page_get_view ((Page*) self);
#line 263 "../src/Views/CheckerboardPage.vala"
				_tmp17_ = _tmp16_;
#line 263 "../src/Views/CheckerboardPage.vala"
				_tmp18_ = view_collection_get_selected_count (_tmp17_) == 1;
#line 263 "../src/Views/CheckerboardPage.vala"
				_data_collection_unref0 (_tmp17_);
#line 263 "../src/Views/CheckerboardPage.vala"
				if (_tmp18_) {
#line 1301 "CheckerboardPage.c"
					ViewCollection* _tmp19_;
					ViewCollection* _tmp20_;
					DataView* _tmp21_;
					CheckerboardItem* _tmp22_;
#line 264 "../src/Views/CheckerboardPage.vala"
					_tmp19_ = page_get_view ((Page*) self);
#line 264 "../src/Views/CheckerboardPage.vala"
					_tmp20_ = _tmp19_;
#line 264 "../src/Views/CheckerboardPage.vala"
					_tmp21_ = view_collection_get_selected_at (_tmp20_, 0);
#line 264 "../src/Views/CheckerboardPage.vala"
					_tmp22_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 264 "../src/Views/CheckerboardPage.vala"
					checkerboard_page_on_item_activated (self, _tmp22_);
#line 264 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (_tmp22_);
#line 264 "../src/Views/CheckerboardPage.vala"
					_data_collection_unref0 (_tmp20_);
#line 1320 "CheckerboardPage.c"
				} else {
#line 266 "../src/Views/CheckerboardPage.vala"
					handled = FALSE;
#line 1324 "CheckerboardPage.c"
				}
#line 267 "../src/Views/CheckerboardPage.vala"
				break;
#line 1328 "CheckerboardPage.c"
			}
		}
	} else {
#line 220 "../src/Views/CheckerboardPage.vala"
		switch (0) {
#line 1334 "CheckerboardPage.c"
			default:
			{
#line 270 "../src/Views/CheckerboardPage.vala"
				handled = FALSE;
#line 271 "../src/Views/CheckerboardPage.vala"
				break;
#line 1341 "CheckerboardPage.c"
			}
		}
	}
#line 274 "../src/Views/CheckerboardPage.vala"
	if (handled) {
#line 275 "../src/Views/CheckerboardPage.vala"
		result = TRUE;
#line 275 "../src/Views/CheckerboardPage.vala"
		return result;
#line 1351 "CheckerboardPage.c"
	}
#line 277 "../src/Views/CheckerboardPage.vala"
	if (GTK_WIDGET_CLASS (checkerboard_page_parent_class)->key_press_event != NULL) {
#line 277 "../src/Views/CheckerboardPage.vala"
		_tmp23_ = GTK_WIDGET_CLASS (checkerboard_page_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE, Page), event);
#line 1357 "CheckerboardPage.c"
	} else {
#line 277 "../src/Views/CheckerboardPage.vala"
		_tmp23_ = TRUE;
#line 1361 "CheckerboardPage.c"
	}
#line 277 "../src/Views/CheckerboardPage.vala"
	result = _tmp23_;
#line 277 "../src/Views/CheckerboardPage.vala"
	return result;
#line 1367 "CheckerboardPage.c"
}

static gboolean
checkerboard_page_real_is_point_on_item_selection_button (CheckerboardPage* self,
                                                          gdouble x,
                                                          gdouble y,
                                                          CheckerboardItem* item)
{
	GdkRectangle button_area = {0};
	GdkRectangle _tmp0_ = {0};
#line 284 "../src/Views/CheckerboardPage.vala"
	static const gint X_ERROR_MARGIN = 3;
#line 285 "../src/Views/CheckerboardPage.vala"
	static const gint Y_ERROR_MARGIN = 3;
#line 1382 "CheckerboardPage.c"
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GdkRectangle _tmp4_;
	gboolean result;
#line 280 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 281 "../src/Views/CheckerboardPage.vala"
	checkerboard_item_get_selection_button_area (item, &_tmp0_);
#line 281 "../src/Views/CheckerboardPage.vala"
	button_area = _tmp0_;
#line 287 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = button_area;
#line 287 "../src/Views/CheckerboardPage.vala"
	if (x >= ((gdouble) (_tmp4_.x - X_ERROR_MARGIN))) {
#line 1398 "CheckerboardPage.c"
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_;
#line 288 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = button_area;
#line 288 "../src/Views/CheckerboardPage.vala"
		_tmp6_ = button_area;
#line 288 "../src/Views/CheckerboardPage.vala"
		_tmp3_ = x <= ((gdouble) ((_tmp5_.x + _tmp6_.width) + X_ERROR_MARGIN));
#line 1407 "CheckerboardPage.c"
	} else {
#line 287 "../src/Views/CheckerboardPage.vala"
		_tmp3_ = FALSE;
#line 1411 "CheckerboardPage.c"
	}
#line 287 "../src/Views/CheckerboardPage.vala"
	if (_tmp3_) {
#line 1415 "CheckerboardPage.c"
		GdkRectangle _tmp7_;
#line 289 "../src/Views/CheckerboardPage.vala"
		_tmp7_ = button_area;
#line 289 "../src/Views/CheckerboardPage.vala"
		_tmp2_ = y >= ((gdouble) (_tmp7_.y - Y_ERROR_MARGIN));
#line 1421 "CheckerboardPage.c"
	} else {
#line 287 "../src/Views/CheckerboardPage.vala"
		_tmp2_ = FALSE;
#line 1425 "CheckerboardPage.c"
	}
#line 287 "../src/Views/CheckerboardPage.vala"
	if (_tmp2_) {
#line 1429 "CheckerboardPage.c"
		GdkRectangle _tmp8_;
		GdkRectangle _tmp9_;
#line 290 "../src/Views/CheckerboardPage.vala"
		_tmp8_ = button_area;
#line 290 "../src/Views/CheckerboardPage.vala"
		_tmp9_ = button_area;
#line 290 "../src/Views/CheckerboardPage.vala"
		_tmp1_ = y <= ((gdouble) ((_tmp8_.y + _tmp9_.height) + Y_ERROR_MARGIN));
#line 1438 "CheckerboardPage.c"
	} else {
#line 287 "../src/Views/CheckerboardPage.vala"
		_tmp1_ = FALSE;
#line 1442 "CheckerboardPage.c"
	}
#line 287 "../src/Views/CheckerboardPage.vala"
	result = _tmp1_;
#line 287 "../src/Views/CheckerboardPage.vala"
	return result;
#line 1448 "CheckerboardPage.c"
}

gboolean
checkerboard_page_is_point_on_item_selection_button (CheckerboardPage* self,
                                                     gdouble x,
                                                     gdouble y,
                                                     CheckerboardItem* item)
{
	CheckerboardPageClass* _klass_;
#line 280 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 280 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 280 "../src/Views/CheckerboardPage.vala"
	if (_klass_->is_point_on_item_selection_button) {
#line 280 "../src/Views/CheckerboardPage.vala"
		return _klass_->is_point_on_item_selection_button (self, x, y, item);
#line 1466 "CheckerboardPage.c"
	}
#line 280 "../src/Views/CheckerboardPage.vala"
	return FALSE;
#line 1470 "CheckerboardPage.c"
}

static gboolean
checkerboard_page_real_on_left_click (Page* base,
                                      GdkEventButton* event)
{
	CheckerboardPage * self;
	gboolean _tmp0_ = FALSE;
	guint state = 0U;
	CheckerboardItem* item = NULL;
	CheckerboardItem* _tmp1_;
	CheckerboardItem* _tmp2_;
	ViewCollection* _tmp69_;
	ViewCollection* _tmp70_;
	gboolean _tmp71_;
	gboolean result;
#line 293 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) base;
#line 293 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 294 "../src/Views/CheckerboardPage.vala"
	self->priv->selection_button_clicked = FALSE;
#line 297 "../src/Views/CheckerboardPage.vala"
	if (event->type != GDK_BUTTON_PRESS) {
#line 297 "../src/Views/CheckerboardPage.vala"
		_tmp0_ = event->type != GDK_2BUTTON_PRESS;
#line 1497 "CheckerboardPage.c"
	} else {
#line 297 "../src/Views/CheckerboardPage.vala"
		_tmp0_ = FALSE;
#line 1501 "CheckerboardPage.c"
	}
#line 297 "../src/Views/CheckerboardPage.vala"
	if (_tmp0_) {
#line 298 "../src/Views/CheckerboardPage.vala"
		result = FALSE;
#line 298 "../src/Views/CheckerboardPage.vala"
		return result;
#line 1509 "CheckerboardPage.c"
	}
#line 301 "../src/Views/CheckerboardPage.vala"
	state = (guint) (event->state & (GDK_CONTROL_MASK | GDK_SHIFT_MASK));
#line 305 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = checkerboard_page_get_item_at_pixel (self, event->x, event->y);
#line 305 "../src/Views/CheckerboardPage.vala"
	item = _tmp1_;
#line 307 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = item;
#line 307 "../src/Views/CheckerboardPage.vala"
	if (_tmp2_ != NULL) {
#line 308 "../src/Views/CheckerboardPage.vala"
		switch (state) {
#line 308 "../src/Views/CheckerboardPage.vala"
			case GDK_CONTROL_MASK:
#line 1525 "CheckerboardPage.c"
			{
				Marker* marker = NULL;
				ViewCollection* _tmp3_;
				ViewCollection* _tmp4_;
				CheckerboardItem* _tmp5_;
				Marker* _tmp6_;
				Marker* _tmp7_;
				ViewCollection* _tmp8_;
				ViewCollection* _tmp9_;
				Marker* _tmp10_;
				CheckerboardItem* _tmp11_;
#line 312 "../src/Views/CheckerboardPage.vala"
				_tmp3_ = page_get_view ((Page*) self);
#line 312 "../src/Views/CheckerboardPage.vala"
				_tmp4_ = _tmp3_;
#line 312 "../src/Views/CheckerboardPage.vala"
				_tmp5_ = item;
#line 312 "../src/Views/CheckerboardPage.vala"
				_tmp6_ = data_collection_mark ((DataCollection*) _tmp4_, (DataObject*) _tmp5_);
#line 312 "../src/Views/CheckerboardPage.vala"
				_tmp7_ = _tmp6_;
#line 312 "../src/Views/CheckerboardPage.vala"
				_data_collection_unref0 (_tmp4_);
#line 312 "../src/Views/CheckerboardPage.vala"
				marker = _tmp7_;
#line 313 "../src/Views/CheckerboardPage.vala"
				_tmp8_ = page_get_view ((Page*) self);
#line 313 "../src/Views/CheckerboardPage.vala"
				_tmp9_ = _tmp8_;
#line 313 "../src/Views/CheckerboardPage.vala"
				_tmp10_ = marker;
#line 313 "../src/Views/CheckerboardPage.vala"
				view_collection_toggle_marked (_tmp9_, _tmp10_);
#line 313 "../src/Views/CheckerboardPage.vala"
				_data_collection_unref0 (_tmp9_);
#line 315 "../src/Views/CheckerboardPage.vala"
				_tmp11_ = item;
#line 315 "../src/Views/CheckerboardPage.vala"
				if (data_view_is_selected ((DataView*) _tmp11_)) {
#line 1565 "CheckerboardPage.c"
					CheckerboardItem* _tmp12_;
					CheckerboardItem* _tmp13_;
					CheckerboardItem* _tmp14_;
					CheckerboardItem* _tmp15_;
#line 316 "../src/Views/CheckerboardPage.vala"
					_tmp12_ = item;
#line 316 "../src/Views/CheckerboardPage.vala"
					_tmp13_ = _g_object_ref0 (_tmp12_);
#line 316 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (self->anchor);
#line 316 "../src/Views/CheckerboardPage.vala"
					self->anchor = _tmp13_;
#line 317 "../src/Views/CheckerboardPage.vala"
					_tmp14_ = item;
#line 317 "../src/Views/CheckerboardPage.vala"
					_tmp15_ = _g_object_ref0 (_tmp14_);
#line 317 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (self->cursor);
#line 317 "../src/Views/CheckerboardPage.vala"
					self->cursor = _tmp15_;
#line 1586 "CheckerboardPage.c"
				}
#line 319 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (marker);
#line 319 "../src/Views/CheckerboardPage.vala"
				break;
#line 1592 "CheckerboardPage.c"
			}
#line 308 "../src/Views/CheckerboardPage.vala"
			case GDK_SHIFT_MASK:
#line 1596 "CheckerboardPage.c"
			{
				ViewCollection* _tmp16_;
				ViewCollection* _tmp17_;
				CheckerboardItem* _tmp18_;
				CheckerboardItem* _tmp21_;
				CheckerboardItem* _tmp22_;
				CheckerboardItem* _tmp23_;
				CheckerboardItem* _tmp24_;
#line 322 "../src/Views/CheckerboardPage.vala"
				_tmp16_ = page_get_view ((Page*) self);
#line 322 "../src/Views/CheckerboardPage.vala"
				_tmp17_ = _tmp16_;
#line 322 "../src/Views/CheckerboardPage.vala"
				view_collection_unselect_all (_tmp17_);
#line 322 "../src/Views/CheckerboardPage.vala"
				_data_collection_unref0 (_tmp17_);
#line 324 "../src/Views/CheckerboardPage.vala"
				_tmp18_ = self->anchor;
#line 324 "../src/Views/CheckerboardPage.vala"
				if (_tmp18_ == NULL) {
#line 1617 "CheckerboardPage.c"
					CheckerboardItem* _tmp19_;
					CheckerboardItem* _tmp20_;
#line 325 "../src/Views/CheckerboardPage.vala"
					_tmp19_ = item;
#line 325 "../src/Views/CheckerboardPage.vala"
					_tmp20_ = _g_object_ref0 (_tmp19_);
#line 325 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (self->anchor);
#line 325 "../src/Views/CheckerboardPage.vala"
					self->anchor = _tmp20_;
#line 1628 "CheckerboardPage.c"
				}
#line 327 "../src/Views/CheckerboardPage.vala"
				_tmp21_ = self->anchor;
#line 327 "../src/Views/CheckerboardPage.vala"
				_tmp22_ = item;
#line 327 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_select_between_items (self, _tmp21_, _tmp22_);
#line 329 "../src/Views/CheckerboardPage.vala"
				_tmp23_ = item;
#line 329 "../src/Views/CheckerboardPage.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 329 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (self->cursor);
#line 329 "../src/Views/CheckerboardPage.vala"
				self->cursor = _tmp24_;
#line 330 "../src/Views/CheckerboardPage.vala"
				break;
#line 1646 "CheckerboardPage.c"
			}
#line 308 "../src/Views/CheckerboardPage.vala"
			case GDK_CONTROL_MASK | GDK_SHIFT_MASK:
#line 1650 "CheckerboardPage.c"
			{
				CheckerboardItem* _tmp25_;
				CheckerboardItem* _tmp28_;
				CheckerboardItem* _tmp29_;
				CheckerboardItem* _tmp30_;
				CheckerboardItem* _tmp31_;
#line 337 "../src/Views/CheckerboardPage.vala"
				_tmp25_ = self->anchor;
#line 337 "../src/Views/CheckerboardPage.vala"
				if (_tmp25_ == NULL) {
#line 1661 "CheckerboardPage.c"
					CheckerboardItem* _tmp26_;
					CheckerboardItem* _tmp27_;
#line 338 "../src/Views/CheckerboardPage.vala"
					_tmp26_ = item;
#line 338 "../src/Views/CheckerboardPage.vala"
					_tmp27_ = _g_object_ref0 (_tmp26_);
#line 338 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (self->anchor);
#line 338 "../src/Views/CheckerboardPage.vala"
					self->anchor = _tmp27_;
#line 1672 "CheckerboardPage.c"
				}
#line 340 "../src/Views/CheckerboardPage.vala"
				_tmp28_ = self->anchor;
#line 340 "../src/Views/CheckerboardPage.vala"
				_tmp29_ = item;
#line 340 "../src/Views/CheckerboardPage.vala"
				checkerboard_page_select_between_items (self, _tmp28_, _tmp29_);
#line 342 "../src/Views/CheckerboardPage.vala"
				_tmp30_ = item;
#line 342 "../src/Views/CheckerboardPage.vala"
				_tmp31_ = _g_object_ref0 (_tmp30_);
#line 342 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (self->cursor);
#line 342 "../src/Views/CheckerboardPage.vala"
				self->cursor = _tmp31_;
#line 343 "../src/Views/CheckerboardPage.vala"
				break;
#line 1690 "CheckerboardPage.c"
			}
			default:
			{
				CheckerboardItem* _tmp32_;
#line 347 "../src/Views/CheckerboardPage.vala"
				_tmp32_ = item;
#line 347 "../src/Views/CheckerboardPage.vala"
				if (checkerboard_page_is_point_on_item_selection_button (self, event->x, event->y, _tmp32_)) {
#line 1699 "CheckerboardPage.c"
					Marker* marker = NULL;
					ViewCollection* _tmp33_;
					ViewCollection* _tmp34_;
					CheckerboardItem* _tmp35_;
					Marker* _tmp36_;
					Marker* _tmp37_;
					ViewCollection* _tmp38_;
					ViewCollection* _tmp39_;
					Marker* _tmp40_;
					CheckerboardItem* _tmp41_;
#line 349 "../src/Views/CheckerboardPage.vala"
					g_debug ("CheckerboardPage.vala:349: Selection button clicked");
#line 352 "../src/Views/CheckerboardPage.vala"
					self->priv->selection_button_clicked = TRUE;
#line 356 "../src/Views/CheckerboardPage.vala"
					_tmp33_ = page_get_view ((Page*) self);
#line 356 "../src/Views/CheckerboardPage.vala"
					_tmp34_ = _tmp33_;
#line 356 "../src/Views/CheckerboardPage.vala"
					_tmp35_ = item;
#line 356 "../src/Views/CheckerboardPage.vala"
					_tmp36_ = data_collection_mark ((DataCollection*) _tmp34_, (DataObject*) _tmp35_);
#line 356 "../src/Views/CheckerboardPage.vala"
					_tmp37_ = _tmp36_;
#line 356 "../src/Views/CheckerboardPage.vala"
					_data_collection_unref0 (_tmp34_);
#line 356 "../src/Views/CheckerboardPage.vala"
					marker = _tmp37_;
#line 357 "../src/Views/CheckerboardPage.vala"
					_tmp38_ = page_get_view ((Page*) self);
#line 357 "../src/Views/CheckerboardPage.vala"
					_tmp39_ = _tmp38_;
#line 357 "../src/Views/CheckerboardPage.vala"
					_tmp40_ = marker;
#line 357 "../src/Views/CheckerboardPage.vala"
					view_collection_toggle_marked (_tmp39_, _tmp40_);
#line 357 "../src/Views/CheckerboardPage.vala"
					_data_collection_unref0 (_tmp39_);
#line 359 "../src/Views/CheckerboardPage.vala"
					_tmp41_ = item;
#line 359 "../src/Views/CheckerboardPage.vala"
					if (data_view_is_selected ((DataView*) _tmp41_)) {
#line 1742 "CheckerboardPage.c"
						CheckerboardItem* _tmp42_;
						CheckerboardItem* _tmp43_;
						CheckerboardItem* _tmp44_;
						CheckerboardItem* _tmp45_;
#line 360 "../src/Views/CheckerboardPage.vala"
						_tmp42_ = item;
#line 360 "../src/Views/CheckerboardPage.vala"
						_tmp43_ = _g_object_ref0 (_tmp42_);
#line 360 "../src/Views/CheckerboardPage.vala"
						_g_object_unref0 (self->anchor);
#line 360 "../src/Views/CheckerboardPage.vala"
						self->anchor = _tmp43_;
#line 361 "../src/Views/CheckerboardPage.vala"
						_tmp44_ = item;
#line 361 "../src/Views/CheckerboardPage.vala"
						_tmp45_ = _g_object_ref0 (_tmp44_);
#line 361 "../src/Views/CheckerboardPage.vala"
						_g_object_unref0 (self->cursor);
#line 361 "../src/Views/CheckerboardPage.vala"
						self->cursor = _tmp45_;
#line 1763 "CheckerboardPage.c"
					}
#line 347 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (marker);
#line 1767 "CheckerboardPage.c"
				} else {
					CheckerboardItem* _tmp46_;
					CheckerboardItem* _tmp47_;
					CheckerboardItem* _tmp48_;
					CheckerboardItem* _tmp49_;
					CheckerboardItem* _tmp50_;
					CheckerboardItem* _tmp51_;
#line 364 "../src/Views/CheckerboardPage.vala"
					_tmp46_ = item;
#line 364 "../src/Views/CheckerboardPage.vala"
					_tmp47_ = _g_object_ref0 (_tmp46_);
#line 364 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (self->priv->activated_item);
#line 364 "../src/Views/CheckerboardPage.vala"
					self->priv->activated_item = _tmp47_;
#line 366 "../src/Views/CheckerboardPage.vala"
					_tmp48_ = item;
#line 366 "../src/Views/CheckerboardPage.vala"
					_tmp49_ = _g_object_ref0 (_tmp48_);
#line 366 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (self->anchor);
#line 366 "../src/Views/CheckerboardPage.vala"
					self->anchor = _tmp49_;
#line 367 "../src/Views/CheckerboardPage.vala"
					_tmp50_ = item;
#line 367 "../src/Views/CheckerboardPage.vala"
					_tmp51_ = _g_object_ref0 (_tmp50_);
#line 367 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (self->cursor);
#line 367 "../src/Views/CheckerboardPage.vala"
					self->cursor = _tmp51_;
#line 1799 "CheckerboardPage.c"
				}
#line 369 "../src/Views/CheckerboardPage.vala"
				break;
#line 1803 "CheckerboardPage.c"
			}
		}
	} else {
		GeeArrayList* _tmp54_;
		CheckerboardLayout* _tmp68_;
#line 374 "../src/Views/CheckerboardPage.vala"
		if (state != ((guint) GDK_CONTROL_MASK)) {
#line 1811 "CheckerboardPage.c"
			ViewCollection* _tmp52_;
			ViewCollection* _tmp53_;
#line 375 "../src/Views/CheckerboardPage.vala"
			_tmp52_ = page_get_view ((Page*) self);
#line 375 "../src/Views/CheckerboardPage.vala"
			_tmp53_ = _tmp52_;
#line 375 "../src/Views/CheckerboardPage.vala"
			view_collection_unselect_all (_tmp53_);
#line 375 "../src/Views/CheckerboardPage.vala"
			_data_collection_unref0 (_tmp53_);
#line 1822 "CheckerboardPage.c"
		}
#line 378 "../src/Views/CheckerboardPage.vala"
		_tmp54_ = gee_array_list_new (TYPE_CHECKERBOARD_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 378 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (self->priv->previously_selected);
#line 378 "../src/Views/CheckerboardPage.vala"
		self->priv->previously_selected = _tmp54_;
#line 1830 "CheckerboardPage.c"
		{
			GeeList* _view_list = NULL;
			ViewCollection* _tmp55_;
			ViewCollection* _tmp56_;
			GeeList* _tmp57_;
			GeeList* _tmp58_;
			gint _view_size = 0;
			GeeList* _tmp59_;
			gint _tmp60_;
			gint _tmp61_;
			gint _view_index = 0;
#line 379 "../src/Views/CheckerboardPage.vala"
			_tmp55_ = page_get_view ((Page*) self);
#line 379 "../src/Views/CheckerboardPage.vala"
			_tmp56_ = _tmp55_;
#line 379 "../src/Views/CheckerboardPage.vala"
			_tmp57_ = view_collection_get_selected (_tmp56_);
#line 379 "../src/Views/CheckerboardPage.vala"
			_tmp58_ = _tmp57_;
#line 379 "../src/Views/CheckerboardPage.vala"
			_data_collection_unref0 (_tmp56_);
#line 379 "../src/Views/CheckerboardPage.vala"
			_view_list = _tmp58_;
#line 379 "../src/Views/CheckerboardPage.vala"
			_tmp59_ = _view_list;
#line 379 "../src/Views/CheckerboardPage.vala"
			_tmp60_ = gee_collection_get_size ((GeeCollection*) _tmp59_);
#line 379 "../src/Views/CheckerboardPage.vala"
			_tmp61_ = _tmp60_;
#line 379 "../src/Views/CheckerboardPage.vala"
			_view_size = _tmp61_;
#line 379 "../src/Views/CheckerboardPage.vala"
			_view_index = -1;
#line 379 "../src/Views/CheckerboardPage.vala"
			while (TRUE) {
#line 1866 "CheckerboardPage.c"
				gint _tmp62_;
				gint _tmp63_;
				DataView* view = NULL;
				GeeList* _tmp64_;
				gpointer _tmp65_;
				GeeArrayList* _tmp66_;
				DataView* _tmp67_;
#line 379 "../src/Views/CheckerboardPage.vala"
				_view_index = _view_index + 1;
#line 379 "../src/Views/CheckerboardPage.vala"
				_tmp62_ = _view_index;
#line 379 "../src/Views/CheckerboardPage.vala"
				_tmp63_ = _view_size;
#line 379 "../src/Views/CheckerboardPage.vala"
				if (!(_tmp62_ < _tmp63_)) {
#line 379 "../src/Views/CheckerboardPage.vala"
					break;
#line 1884 "CheckerboardPage.c"
				}
#line 379 "../src/Views/CheckerboardPage.vala"
				_tmp64_ = _view_list;
#line 379 "../src/Views/CheckerboardPage.vala"
				_tmp65_ = gee_list_get (_tmp64_, _view_index);
#line 379 "../src/Views/CheckerboardPage.vala"
				view = (DataView*) _tmp65_;
#line 380 "../src/Views/CheckerboardPage.vala"
				_tmp66_ = self->priv->previously_selected;
#line 380 "../src/Views/CheckerboardPage.vala"
				_tmp67_ = view;
#line 380 "../src/Views/CheckerboardPage.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp66_, G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem));
#line 379 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (view);
#line 1900 "CheckerboardPage.c"
			}
#line 379 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (_view_list);
#line 1904 "CheckerboardPage.c"
		}
#line 382 "../src/Views/CheckerboardPage.vala"
		_tmp68_ = self->priv->layout;
#line 382 "../src/Views/CheckerboardPage.vala"
		checkerboard_layout_set_drag_select_origin (_tmp68_, (gint) event->x, (gint) event->y);
#line 384 "../src/Views/CheckerboardPage.vala"
		result = TRUE;
#line 384 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (item);
#line 384 "../src/Views/CheckerboardPage.vala"
		return result;
#line 1916 "CheckerboardPage.c"
	}
#line 390 "../src/Views/CheckerboardPage.vala"
	_tmp69_ = page_get_view ((Page*) self);
#line 390 "../src/Views/CheckerboardPage.vala"
	_tmp70_ = _tmp69_;
#line 390 "../src/Views/CheckerboardPage.vala"
	_tmp71_ = view_collection_get_selected_count (_tmp70_) == 0;
#line 390 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp70_);
#line 390 "../src/Views/CheckerboardPage.vala"
	result = _tmp71_;
#line 390 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (item);
#line 390 "../src/Views/CheckerboardPage.vala"
	return result;
#line 1932 "CheckerboardPage.c"
}

static gboolean
checkerboard_page_real_on_left_released (Page* base,
                                         GdkEventButton* event)
{
	CheckerboardPage * self;
	CheckerboardLayout* _tmp0_;
	CheckerboardItem* _tmp4_;
	CheckerboardItem* item = NULL;
	CheckerboardItem* _tmp6_;
	CheckerboardItem* _tmp7_;
	CheckerboardItem* _tmp8_;
	CheckerboardItem* _tmp9_;
	gboolean result;
#line 393 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) base;
#line 393 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 394 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->priv->previously_selected);
#line 394 "../src/Views/CheckerboardPage.vala"
	self->priv->previously_selected = NULL;
#line 397 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 397 "../src/Views/CheckerboardPage.vala"
	if (checkerboard_layout_is_drag_select_active (_tmp0_)) {
#line 1960 "CheckerboardPage.c"
		CheckerboardLayout* _tmp1_;
		CheckerboardItem* _tmp2_;
		CheckerboardItem* _tmp3_;
#line 398 "../src/Views/CheckerboardPage.vala"
		_tmp1_ = self->priv->layout;
#line 398 "../src/Views/CheckerboardPage.vala"
		checkerboard_layout_clear_drag_select (_tmp1_);
#line 399 "../src/Views/CheckerboardPage.vala"
		_tmp2_ = self->cursor;
#line 399 "../src/Views/CheckerboardPage.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 399 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (self->anchor);
#line 399 "../src/Views/CheckerboardPage.vala"
		self->anchor = _tmp3_;
#line 401 "../src/Views/CheckerboardPage.vala"
		result = TRUE;
#line 401 "../src/Views/CheckerboardPage.vala"
		return result;
#line 1980 "CheckerboardPage.c"
	}
#line 405 "../src/Views/CheckerboardPage.vala"
	if ((event->state & (GDK_CONTROL_MASK | GDK_SHIFT_MASK)) != 0) {
#line 406 "../src/Views/CheckerboardPage.vala"
		result = FALSE;
#line 406 "../src/Views/CheckerboardPage.vala"
		return result;
#line 1988 "CheckerboardPage.c"
	}
#line 409 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = self->priv->activated_item;
#line 409 "../src/Views/CheckerboardPage.vala"
	if (_tmp4_ != NULL) {
#line 1994 "CheckerboardPage.c"
		CheckerboardItem* _tmp5_;
#line 410 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = self->priv->activated_item;
#line 410 "../src/Views/CheckerboardPage.vala"
		checkerboard_page_on_item_activated (self, _tmp5_);
#line 411 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (self->priv->activated_item);
#line 411 "../src/Views/CheckerboardPage.vala"
		self->priv->activated_item = NULL;
#line 413 "../src/Views/CheckerboardPage.vala"
		result = TRUE;
#line 413 "../src/Views/CheckerboardPage.vala"
		return result;
#line 2008 "CheckerboardPage.c"
	}
#line 416 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = checkerboard_page_get_item_at_pixel (self, event->x, event->y);
#line 416 "../src/Views/CheckerboardPage.vala"
	item = _tmp6_;
#line 417 "../src/Views/CheckerboardPage.vala"
	_tmp7_ = item;
#line 417 "../src/Views/CheckerboardPage.vala"
	if (_tmp7_ == NULL) {
#line 419 "../src/Views/CheckerboardPage.vala"
		result = TRUE;
#line 419 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (item);
#line 419 "../src/Views/CheckerboardPage.vala"
		return result;
#line 2024 "CheckerboardPage.c"
	}
#line 422 "../src/Views/CheckerboardPage.vala"
	if (self->priv->selection_button_clicked) {
#line 423 "../src/Views/CheckerboardPage.vala"
		self->priv->selection_button_clicked = FALSE;
#line 424 "../src/Views/CheckerboardPage.vala"
		result = TRUE;
#line 424 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (item);
#line 424 "../src/Views/CheckerboardPage.vala"
		return result;
#line 2036 "CheckerboardPage.c"
	}
#line 427 "../src/Views/CheckerboardPage.vala"
	_tmp8_ = self->cursor;
#line 427 "../src/Views/CheckerboardPage.vala"
	_tmp9_ = item;
#line 427 "../src/Views/CheckerboardPage.vala"
	if (_tmp8_ != _tmp9_) {
#line 2044 "CheckerboardPage.c"
		ViewCollection* _tmp10_;
		ViewCollection* _tmp11_;
#line 430 "../src/Views/CheckerboardPage.vala"
		_tmp10_ = page_get_view ((Page*) self);
#line 430 "../src/Views/CheckerboardPage.vala"
		_tmp11_ = _tmp10_;
#line 430 "../src/Views/CheckerboardPage.vala"
		view_collection_unselect_all (_tmp11_);
#line 430 "../src/Views/CheckerboardPage.vala"
		_data_collection_unref0 (_tmp11_);
#line 2055 "CheckerboardPage.c"
	} else {
		CheckerboardItem* _tmp12_;
#line 436 "../src/Views/CheckerboardPage.vala"
		_tmp12_ = item;
#line 436 "../src/Views/CheckerboardPage.vala"
		if (data_view_is_selected ((DataView*) _tmp12_)) {
#line 2062 "CheckerboardPage.c"
			ViewCollection* _tmp13_;
			ViewCollection* _tmp14_;
			CheckerboardItem* _tmp15_;
#line 437 "../src/Views/CheckerboardPage.vala"
			_tmp13_ = page_get_view ((Page*) self);
#line 437 "../src/Views/CheckerboardPage.vala"
			_tmp14_ = _tmp13_;
#line 437 "../src/Views/CheckerboardPage.vala"
			_tmp15_ = item;
#line 437 "../src/Views/CheckerboardPage.vala"
			view_collection_unselect_all_but (_tmp14_, (DataView*) _tmp15_);
#line 437 "../src/Views/CheckerboardPage.vala"
			_data_collection_unref0 (_tmp14_);
#line 2076 "CheckerboardPage.c"
		}
	}
#line 440 "../src/Views/CheckerboardPage.vala"
	result = TRUE;
#line 440 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (item);
#line 440 "../src/Views/CheckerboardPage.vala"
	return result;
#line 2085 "CheckerboardPage.c"
}

static gboolean
checkerboard_page_real_on_right_click (Page* base,
                                       GdkEventButton* event)
{
	CheckerboardPage * self;
	CheckerboardItem* item = NULL;
	CheckerboardItem* _tmp0_;
	CheckerboardItem* _tmp1_;
	GtkMenu* context_menu = NULL;
	GtkMenu* _tmp30_;
	GtkMenu* _tmp31_;
	gboolean result;
#line 443 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) base;
#line 443 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 445 "../src/Views/CheckerboardPage.vala"
	if (event->type != GDK_BUTTON_PRESS) {
#line 446 "../src/Views/CheckerboardPage.vala"
		result = FALSE;
#line 446 "../src/Views/CheckerboardPage.vala"
		return result;
#line 2110 "CheckerboardPage.c"
	}
#line 449 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = checkerboard_page_get_item_at_pixel (self, event->x, event->y);
#line 449 "../src/Views/CheckerboardPage.vala"
	item = _tmp0_;
#line 450 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = item;
#line 450 "../src/Views/CheckerboardPage.vala"
	if (_tmp1_ != NULL) {
#line 452 "../src/Views/CheckerboardPage.vala"
		switch (event->state & (GDK_CONTROL_MASK | GDK_SHIFT_MASK)) {
#line 452 "../src/Views/CheckerboardPage.vala"
			case GDK_CONTROL_MASK:
#line 2124 "CheckerboardPage.c"
			{
				Marker* marker = NULL;
				ViewCollection* _tmp2_;
				ViewCollection* _tmp3_;
				CheckerboardItem* _tmp4_;
				Marker* _tmp5_;
				Marker* _tmp6_;
				ViewCollection* _tmp7_;
				ViewCollection* _tmp8_;
				Marker* _tmp9_;
#line 455 "../src/Views/CheckerboardPage.vala"
				_tmp2_ = page_get_view ((Page*) self);
#line 455 "../src/Views/CheckerboardPage.vala"
				_tmp3_ = _tmp2_;
#line 455 "../src/Views/CheckerboardPage.vala"
				_tmp4_ = item;
#line 455 "../src/Views/CheckerboardPage.vala"
				_tmp5_ = data_collection_mark ((DataCollection*) _tmp3_, (DataObject*) _tmp4_);
#line 455 "../src/Views/CheckerboardPage.vala"
				_tmp6_ = _tmp5_;
#line 455 "../src/Views/CheckerboardPage.vala"
				_data_collection_unref0 (_tmp3_);
#line 455 "../src/Views/CheckerboardPage.vala"
				marker = _tmp6_;
#line 456 "../src/Views/CheckerboardPage.vala"
				_tmp7_ = page_get_view ((Page*) self);
#line 456 "../src/Views/CheckerboardPage.vala"
				_tmp8_ = _tmp7_;
#line 456 "../src/Views/CheckerboardPage.vala"
				_tmp9_ = marker;
#line 456 "../src/Views/CheckerboardPage.vala"
				view_collection_toggle_marked (_tmp8_, _tmp9_);
#line 456 "../src/Views/CheckerboardPage.vala"
				_data_collection_unref0 (_tmp8_);
#line 457 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (marker);
#line 457 "../src/Views/CheckerboardPage.vala"
				break;
#line 2163 "CheckerboardPage.c"
			}
#line 452 "../src/Views/CheckerboardPage.vala"
			case GDK_SHIFT_MASK:
#line 2167 "CheckerboardPage.c"
			{
#line 461 "../src/Views/CheckerboardPage.vala"
				break;
#line 2171 "CheckerboardPage.c"
			}
#line 452 "../src/Views/CheckerboardPage.vala"
			case GDK_CONTROL_MASK | GDK_SHIFT_MASK:
#line 2175 "CheckerboardPage.c"
			{
#line 465 "../src/Views/CheckerboardPage.vala"
				break;
#line 2179 "CheckerboardPage.c"
			}
			default:
			{
				CheckerboardItem* _tmp10_;
#line 470 "../src/Views/CheckerboardPage.vala"
				_tmp10_ = item;
#line 470 "../src/Views/CheckerboardPage.vala"
				if (!data_view_is_selected ((DataView*) _tmp10_)) {
#line 2188 "CheckerboardPage.c"
					Marker* all = NULL;
					ViewCollection* _tmp11_;
					ViewCollection* _tmp12_;
					Marker* _tmp13_;
					Marker* _tmp14_;
					Marker* _tmp15_;
					ViewCollection* _tmp16_;
					ViewCollection* _tmp17_;
					GeeList* _tmp18_;
					GeeList* _tmp19_;
					ViewCollection* _tmp20_;
					ViewCollection* _tmp21_;
					Marker* _tmp22_;
					ViewCollection* _tmp23_;
					ViewCollection* _tmp24_;
					CheckerboardItem* _tmp25_;
					Marker* _tmp26_;
					Marker* _tmp27_;
#line 471 "../src/Views/CheckerboardPage.vala"
					_tmp11_ = page_get_view ((Page*) self);
#line 471 "../src/Views/CheckerboardPage.vala"
					_tmp12_ = _tmp11_;
#line 471 "../src/Views/CheckerboardPage.vala"
					_tmp13_ = data_collection_start_marking ((DataCollection*) _tmp12_);
#line 471 "../src/Views/CheckerboardPage.vala"
					_tmp14_ = _tmp13_;
#line 471 "../src/Views/CheckerboardPage.vala"
					_data_collection_unref0 (_tmp12_);
#line 471 "../src/Views/CheckerboardPage.vala"
					all = _tmp14_;
#line 472 "../src/Views/CheckerboardPage.vala"
					_tmp15_ = all;
#line 472 "../src/Views/CheckerboardPage.vala"
					_tmp16_ = page_get_view ((Page*) self);
#line 472 "../src/Views/CheckerboardPage.vala"
					_tmp17_ = _tmp16_;
#line 472 "../src/Views/CheckerboardPage.vala"
					_tmp18_ = view_collection_get_selected (_tmp17_);
#line 472 "../src/Views/CheckerboardPage.vala"
					_tmp19_ = _tmp18_;
#line 472 "../src/Views/CheckerboardPage.vala"
					marker_mark_many (_tmp15_, (GeeCollection*) _tmp19_);
#line 472 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (_tmp19_);
#line 472 "../src/Views/CheckerboardPage.vala"
					_data_collection_unref0 (_tmp17_);
#line 474 "../src/Views/CheckerboardPage.vala"
					_tmp20_ = page_get_view ((Page*) self);
#line 474 "../src/Views/CheckerboardPage.vala"
					_tmp21_ = _tmp20_;
#line 474 "../src/Views/CheckerboardPage.vala"
					_tmp22_ = all;
#line 474 "../src/Views/CheckerboardPage.vala"
					_tmp23_ = page_get_view ((Page*) self);
#line 474 "../src/Views/CheckerboardPage.vala"
					_tmp24_ = _tmp23_;
#line 474 "../src/Views/CheckerboardPage.vala"
					_tmp25_ = item;
#line 474 "../src/Views/CheckerboardPage.vala"
					_tmp26_ = data_collection_mark ((DataCollection*) _tmp24_, (DataObject*) _tmp25_);
#line 474 "../src/Views/CheckerboardPage.vala"
					_tmp27_ = _tmp26_;
#line 474 "../src/Views/CheckerboardPage.vala"
					view_collection_unselect_and_select_marked (_tmp21_, _tmp22_, _tmp27_);
#line 474 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (_tmp27_);
#line 474 "../src/Views/CheckerboardPage.vala"
					_data_collection_unref0 (_tmp24_);
#line 474 "../src/Views/CheckerboardPage.vala"
					_data_collection_unref0 (_tmp21_);
#line 470 "../src/Views/CheckerboardPage.vala"
					_g_object_unref0 (all);
#line 2261 "CheckerboardPage.c"
				}
#line 476 "../src/Views/CheckerboardPage.vala"
				break;
#line 2265 "CheckerboardPage.c"
			}
		}
	} else {
		ViewCollection* _tmp28_;
		ViewCollection* _tmp29_;
#line 480 "../src/Views/CheckerboardPage.vala"
		_tmp28_ = page_get_view ((Page*) self);
#line 480 "../src/Views/CheckerboardPage.vala"
		_tmp29_ = _tmp28_;
#line 480 "../src/Views/CheckerboardPage.vala"
		view_collection_unselect_all (_tmp29_);
#line 480 "../src/Views/CheckerboardPage.vala"
		_data_collection_unref0 (_tmp29_);
#line 2279 "CheckerboardPage.c"
	}
#line 483 "../src/Views/CheckerboardPage.vala"
	_tmp30_ = checkerboard_page_get_context_menu (self);
#line 483 "../src/Views/CheckerboardPage.vala"
	context_menu = _tmp30_;
#line 484 "../src/Views/CheckerboardPage.vala"
	_tmp31_ = context_menu;
#line 484 "../src/Views/CheckerboardPage.vala"
	result = page_popup_context_menu ((Page*) self, _tmp31_, event);
#line 484 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (context_menu);
#line 484 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (item);
#line 484 "../src/Views/CheckerboardPage.vala"
	return result;
#line 2295 "CheckerboardPage.c"
}

static gboolean
checkerboard_page_real_on_mouse_over (CheckerboardPage* self,
                                      CheckerboardItem* item,
                                      gint x,
                                      gint y,
                                      GdkModifierType mask)
{
	CheckerboardItem* _tmp0_;
	GdkCursorType _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
	GdkCursorType cursor_type = 0;
	gboolean result;
#line 490 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->highlighted;
#line 490 "../src/Views/CheckerboardPage.vala"
	if (item != _tmp0_) {
#line 2314 "CheckerboardPage.c"
		CheckerboardItem* _tmp1_;
#line 492 "../src/Views/CheckerboardPage.vala"
		_tmp1_ = self->priv->highlighted;
#line 492 "../src/Views/CheckerboardPage.vala"
		if (_tmp1_ != NULL) {
#line 2320 "CheckerboardPage.c"
			CheckerboardItem* _tmp2_;
#line 493 "../src/Views/CheckerboardPage.vala"
			_tmp2_ = self->priv->highlighted;
#line 493 "../src/Views/CheckerboardPage.vala"
			checkerboard_item_unbrighten (_tmp2_);
#line 494 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (self->priv->highlighted);
#line 494 "../src/Views/CheckerboardPage.vala"
			self->priv->highlighted = NULL;
#line 2330 "CheckerboardPage.c"
		}
#line 498 "../src/Views/CheckerboardPage.vala"
		if (item != NULL) {
#line 2334 "CheckerboardPage.c"
			CheckerboardItem* _tmp3_;
#line 500 "../src/Views/CheckerboardPage.vala"
			checkerboard_item_brighten (item);
#line 501 "../src/Views/CheckerboardPage.vala"
			_tmp3_ = _g_object_ref0 (item);
#line 501 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (self->priv->highlighted);
#line 501 "../src/Views/CheckerboardPage.vala"
			self->priv->highlighted = _tmp3_;
#line 2344 "CheckerboardPage.c"
		}
	}
#line 506 "../src/Views/CheckerboardPage.vala"
	if (item != NULL) {
#line 506 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = !checkerboard_page_is_point_on_item_selection_button (self, (gdouble) x, (gdouble) y, item);
#line 2351 "CheckerboardPage.c"
	} else {
#line 506 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = FALSE;
#line 2355 "CheckerboardPage.c"
	}
#line 506 "../src/Views/CheckerboardPage.vala"
	if (_tmp5_) {
#line 507 "../src/Views/CheckerboardPage.vala"
		_tmp4_ = GDK_HAND1;
#line 2361 "CheckerboardPage.c"
	} else {
#line 507 "../src/Views/CheckerboardPage.vala"
		_tmp4_ = GDK_ARROW;
#line 2365 "CheckerboardPage.c"
	}
#line 506 "../src/Views/CheckerboardPage.vala"
	cursor_type = _tmp4_;
#line 508 "../src/Views/CheckerboardPage.vala"
	page_set_page_cursor ((Page*) self, cursor_type);
#line 510 "../src/Views/CheckerboardPage.vala"
	result = TRUE;
#line 510 "../src/Views/CheckerboardPage.vala"
	return result;
#line 2375 "CheckerboardPage.c"
}

gboolean
checkerboard_page_on_mouse_over (CheckerboardPage* self,
                                 CheckerboardItem* item,
                                 gint x,
                                 gint y,
                                 GdkModifierType mask)
{
	CheckerboardPageClass* _klass_;
#line 487 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 487 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 487 "../src/Views/CheckerboardPage.vala"
	if (_klass_->on_mouse_over) {
#line 487 "../src/Views/CheckerboardPage.vala"
		return _klass_->on_mouse_over (self, item, x, y, mask);
#line 2394 "CheckerboardPage.c"
	}
#line 487 "../src/Views/CheckerboardPage.vala"
	return FALSE;
#line 2398 "CheckerboardPage.c"
}

static gboolean
_checkerboard_page_selection_autoscroll_gsource_func (gpointer self)
{
	gboolean result;
	result = checkerboard_page_selection_autoscroll ((CheckerboardPage*) self);
#line 530 "../src/Views/CheckerboardPage.vala"
	return result;
#line 2408 "CheckerboardPage.c"
}

static gboolean
checkerboard_page_real_on_motion (Page* base,
                                  GdkEventMotion* event,
                                  gint x,
                                  gint y,
                                  GdkModifierType mask)
{
	CheckerboardPage * self;
	CheckerboardItem* _tmp0_;
	CheckerboardItem* _tmp1_;
	gboolean _tmp2_;
	CheckerboardLayout* _tmp3_;
	CheckerboardLayout* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean result;
#line 513 "../src/Views/CheckerboardPage.vala"
	self = (CheckerboardPage*) base;
#line 513 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 515 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = checkerboard_page_get_item_at_pixel (self, (gdouble) x, (gdouble) y);
#line 515 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 515 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = !checkerboard_page_on_mouse_over (self, _tmp1_, x, y, mask);
#line 515 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (_tmp1_);
#line 515 "../src/Views/CheckerboardPage.vala"
	if (_tmp2_) {
#line 516 "../src/Views/CheckerboardPage.vala"
		result = FALSE;
#line 516 "../src/Views/CheckerboardPage.vala"
		return result;
#line 2444 "CheckerboardPage.c"
	}
#line 519 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = self->priv->layout;
#line 519 "../src/Views/CheckerboardPage.vala"
	if (!checkerboard_layout_is_drag_select_active (_tmp3_)) {
#line 520 "../src/Views/CheckerboardPage.vala"
		result = FALSE;
#line 520 "../src/Views/CheckerboardPage.vala"
		return result;
#line 2454 "CheckerboardPage.c"
	}
#line 523 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = self->priv->layout;
#line 523 "../src/Views/CheckerboardPage.vala"
	checkerboard_layout_set_drag_select_endpoint (_tmp4_, x, y);
#line 525 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_updated_selection_band (self);
#line 528 "../src/Views/CheckerboardPage.vala"
	if (!self->priv->autoscroll_scheduled) {
#line 2464 "CheckerboardPage.c"
		GtkAdjustment* _tmp6_;
#line 529 "../src/Views/CheckerboardPage.vala"
		_tmp6_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 529 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = get_adjustment_relation (_tmp6_, y) != ADJUSTMENT_RELATION_IN_RANGE;
#line 2470 "CheckerboardPage.c"
	} else {
#line 528 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = FALSE;
#line 2474 "CheckerboardPage.c"
	}
#line 528 "../src/Views/CheckerboardPage.vala"
	if (_tmp5_) {
#line 530 "../src/Views/CheckerboardPage.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) CHECKERBOARD_PAGE_AUTOSCROLL_TICKS_MSEC, _checkerboard_page_selection_autoscroll_gsource_func, g_object_ref (self), g_object_unref);
#line 531 "../src/Views/CheckerboardPage.vala"
		self->priv->autoscroll_scheduled = TRUE;
#line 2482 "CheckerboardPage.c"
	}
#line 535 "../src/Views/CheckerboardPage.vala"
	result = TRUE;
#line 535 "../src/Views/CheckerboardPage.vala"
	return result;
#line 2488 "CheckerboardPage.c"
}

static void
checkerboard_page_updated_selection_band (CheckerboardPage* self)
{
	CheckerboardLayout* _tmp0_;
	GeeList* intersection = NULL;
	CheckerboardLayout* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	Marker* to_unselect = NULL;
	ViewCollection* _tmp4_;
	ViewCollection* _tmp5_;
	Marker* _tmp6_;
	Marker* _tmp7_;
	Marker* to_select = NULL;
	ViewCollection* _tmp8_;
	ViewCollection* _tmp9_;
	Marker* _tmp10_;
	Marker* _tmp11_;
	Marker* _tmp12_;
	ViewCollection* _tmp13_;
	ViewCollection* _tmp14_;
	GeeList* _tmp15_;
	GeeList* _tmp16_;
	GeeArrayList* _tmp17_;
	Marker* _tmp18_;
	GeeArrayList* _tmp19_;
	Marker* _tmp20_;
	GeeArrayList* _tmp21_;
	ViewCollection* _tmp39_;
	ViewCollection* _tmp40_;
	Marker* _tmp41_;
	ViewCollection* _tmp42_;
	ViewCollection* _tmp43_;
	Marker* _tmp44_;
#line 538 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 539 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 539 "../src/Views/CheckerboardPage.vala"
	_vala_assert (checkerboard_layout_is_drag_select_active (_tmp0_), "layout.is_drag_select_active ()");
#line 542 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = self->priv->layout;
#line 542 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = checkerboard_layout_items_in_selection_band (_tmp1_);
#line 542 "../src/Views/CheckerboardPage.vala"
	intersection = _tmp2_;
#line 543 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = intersection;
#line 543 "../src/Views/CheckerboardPage.vala"
	if (_tmp3_ == NULL) {
#line 544 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (intersection);
#line 544 "../src/Views/CheckerboardPage.vala"
		return;
#line 2545 "CheckerboardPage.c"
	}
#line 546 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = page_get_view ((Page*) self);
#line 546 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = _tmp4_;
#line 546 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = data_collection_start_marking ((DataCollection*) _tmp5_);
#line 546 "../src/Views/CheckerboardPage.vala"
	_tmp7_ = _tmp6_;
#line 546 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp5_);
#line 546 "../src/Views/CheckerboardPage.vala"
	to_unselect = _tmp7_;
#line 547 "../src/Views/CheckerboardPage.vala"
	_tmp8_ = page_get_view ((Page*) self);
#line 547 "../src/Views/CheckerboardPage.vala"
	_tmp9_ = _tmp8_;
#line 547 "../src/Views/CheckerboardPage.vala"
	_tmp10_ = data_collection_start_marking ((DataCollection*) _tmp9_);
#line 547 "../src/Views/CheckerboardPage.vala"
	_tmp11_ = _tmp10_;
#line 547 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp9_);
#line 547 "../src/Views/CheckerboardPage.vala"
	to_select = _tmp11_;
#line 550 "../src/Views/CheckerboardPage.vala"
	_tmp12_ = to_unselect;
#line 550 "../src/Views/CheckerboardPage.vala"
	_tmp13_ = page_get_view ((Page*) self);
#line 550 "../src/Views/CheckerboardPage.vala"
	_tmp14_ = _tmp13_;
#line 550 "../src/Views/CheckerboardPage.vala"
	_tmp15_ = view_collection_get_selected (_tmp14_);
#line 550 "../src/Views/CheckerboardPage.vala"
	_tmp16_ = _tmp15_;
#line 550 "../src/Views/CheckerboardPage.vala"
	marker_mark_many (_tmp12_, (GeeCollection*) _tmp16_);
#line 550 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (_tmp16_);
#line 550 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp14_);
#line 553 "../src/Views/CheckerboardPage.vala"
	_tmp17_ = self->priv->previously_selected;
#line 553 "../src/Views/CheckerboardPage.vala"
	_vala_assert (_tmp17_ != NULL, "previously_selected != null");
#line 554 "../src/Views/CheckerboardPage.vala"
	_tmp18_ = to_unselect;
#line 554 "../src/Views/CheckerboardPage.vala"
	_tmp19_ = self->priv->previously_selected;
#line 554 "../src/Views/CheckerboardPage.vala"
	marker_unmark_many (_tmp18_, (GeeCollection*) _tmp19_);
#line 555 "../src/Views/CheckerboardPage.vala"
	_tmp20_ = to_select;
#line 555 "../src/Views/CheckerboardPage.vala"
	_tmp21_ = self->priv->previously_selected;
#line 555 "../src/Views/CheckerboardPage.vala"
	marker_mark_many (_tmp20_, (GeeCollection*) _tmp21_);
#line 558 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->cursor);
#line 558 "../src/Views/CheckerboardPage.vala"
	self->cursor = NULL;
#line 2607 "CheckerboardPage.c"
	{
		GeeList* _item_list = NULL;
		GeeList* _tmp22_;
		gint _item_size = 0;
		GeeList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _item_index = 0;
#line 560 "../src/Views/CheckerboardPage.vala"
		_tmp22_ = intersection;
#line 560 "../src/Views/CheckerboardPage.vala"
		_item_list = _tmp22_;
#line 560 "../src/Views/CheckerboardPage.vala"
		_tmp23_ = _item_list;
#line 560 "../src/Views/CheckerboardPage.vala"
		_tmp24_ = gee_collection_get_size ((GeeCollection*) _tmp23_);
#line 560 "../src/Views/CheckerboardPage.vala"
		_tmp25_ = _tmp24_;
#line 560 "../src/Views/CheckerboardPage.vala"
		_item_size = _tmp25_;
#line 560 "../src/Views/CheckerboardPage.vala"
		_item_index = -1;
#line 560 "../src/Views/CheckerboardPage.vala"
		while (TRUE) {
#line 2632 "CheckerboardPage.c"
			gint _tmp26_;
			gint _tmp27_;
			CheckerboardItem* item = NULL;
			GeeList* _tmp28_;
			gpointer _tmp29_;
			Marker* _tmp30_;
			CheckerboardItem* _tmp31_;
			CheckerboardItem* _tmp36_;
#line 560 "../src/Views/CheckerboardPage.vala"
			_item_index = _item_index + 1;
#line 560 "../src/Views/CheckerboardPage.vala"
			_tmp26_ = _item_index;
#line 560 "../src/Views/CheckerboardPage.vala"
			_tmp27_ = _item_size;
#line 560 "../src/Views/CheckerboardPage.vala"
			if (!(_tmp26_ < _tmp27_)) {
#line 560 "../src/Views/CheckerboardPage.vala"
				break;
#line 2651 "CheckerboardPage.c"
			}
#line 560 "../src/Views/CheckerboardPage.vala"
			_tmp28_ = _item_list;
#line 560 "../src/Views/CheckerboardPage.vala"
			_tmp29_ = gee_list_get (_tmp28_, _item_index);
#line 560 "../src/Views/CheckerboardPage.vala"
			item = (CheckerboardItem*) _tmp29_;
#line 561 "../src/Views/CheckerboardPage.vala"
			_tmp30_ = to_select;
#line 561 "../src/Views/CheckerboardPage.vala"
			_tmp31_ = item;
#line 561 "../src/Views/CheckerboardPage.vala"
			if (marker_toggle (_tmp30_, (DataObject*) _tmp31_)) {
#line 2665 "CheckerboardPage.c"
				Marker* _tmp32_;
				CheckerboardItem* _tmp33_;
#line 562 "../src/Views/CheckerboardPage.vala"
				_tmp32_ = to_unselect;
#line 562 "../src/Views/CheckerboardPage.vala"
				_tmp33_ = item;
#line 562 "../src/Views/CheckerboardPage.vala"
				marker_unmark (_tmp32_, (DataObject*) _tmp33_);
#line 2674 "CheckerboardPage.c"
			} else {
				Marker* _tmp34_;
				CheckerboardItem* _tmp35_;
#line 564 "../src/Views/CheckerboardPage.vala"
				_tmp34_ = to_unselect;
#line 564 "../src/Views/CheckerboardPage.vala"
				_tmp35_ = item;
#line 564 "../src/Views/CheckerboardPage.vala"
				marker_mark (_tmp34_, (DataObject*) _tmp35_);
#line 2684 "CheckerboardPage.c"
			}
#line 566 "../src/Views/CheckerboardPage.vala"
			_tmp36_ = self->cursor;
#line 566 "../src/Views/CheckerboardPage.vala"
			if (_tmp36_ == NULL) {
#line 2690 "CheckerboardPage.c"
				CheckerboardItem* _tmp37_;
				CheckerboardItem* _tmp38_;
#line 567 "../src/Views/CheckerboardPage.vala"
				_tmp37_ = item;
#line 567 "../src/Views/CheckerboardPage.vala"
				_tmp38_ = _g_object_ref0 (_tmp37_);
#line 567 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (self->cursor);
#line 567 "../src/Views/CheckerboardPage.vala"
				self->cursor = _tmp38_;
#line 2701 "CheckerboardPage.c"
			}
#line 560 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (item);
#line 2705 "CheckerboardPage.c"
		}
	}
#line 570 "../src/Views/CheckerboardPage.vala"
	_tmp39_ = page_get_view ((Page*) self);
#line 570 "../src/Views/CheckerboardPage.vala"
	_tmp40_ = _tmp39_;
#line 570 "../src/Views/CheckerboardPage.vala"
	_tmp41_ = to_select;
#line 570 "../src/Views/CheckerboardPage.vala"
	view_collection_select_marked (_tmp40_, _tmp41_);
#line 570 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp40_);
#line 571 "../src/Views/CheckerboardPage.vala"
	_tmp42_ = page_get_view ((Page*) self);
#line 571 "../src/Views/CheckerboardPage.vala"
	_tmp43_ = _tmp42_;
#line 571 "../src/Views/CheckerboardPage.vala"
	_tmp44_ = to_unselect;
#line 571 "../src/Views/CheckerboardPage.vala"
	view_collection_unselect_marked (_tmp43_, _tmp44_);
#line 571 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp43_);
#line 538 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (to_select);
#line 538 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (to_unselect);
#line 538 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (intersection);
#line 2734 "CheckerboardPage.c"
}

static gboolean
checkerboard_page_selection_autoscroll (CheckerboardPage* self)
{
	CheckerboardLayout* _tmp0_;
	GtkAdjustment* vadj = NULL;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	gint x = 0;
	gint y = 0;
	GdkModifierType mask = 0U;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	GdkModifierType _tmp5_ = 0U;
	gint new_value = 0;
	GtkAdjustment* _tmp6_;
	GtkAdjustment* _tmp7_;
	GtkAdjustment* _tmp11_;
	GtkAdjustment* _tmp12_;
	GtkAdjustment* _tmp13_;
	GtkAdjustment* _tmp14_;
	gboolean result;
#line 574 "../src/Views/CheckerboardPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 575 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 575 "../src/Views/CheckerboardPage.vala"
	if (!checkerboard_layout_is_drag_select_active (_tmp0_)) {
#line 576 "../src/Views/CheckerboardPage.vala"
		self->priv->autoscroll_scheduled = FALSE;
#line 578 "../src/Views/CheckerboardPage.vala"
		result = FALSE;
#line 578 "../src/Views/CheckerboardPage.vala"
		return result;
#line 2770 "CheckerboardPage.c"
	}
#line 582 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 582 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 582 "../src/Views/CheckerboardPage.vala"
	vadj = _tmp2_;
#line 586 "../src/Views/CheckerboardPage.vala"
	page_get_event_source_pointer ((Page*) self, &_tmp3_, &_tmp4_, &_tmp5_);
#line 586 "../src/Views/CheckerboardPage.vala"
	x = _tmp3_;
#line 586 "../src/Views/CheckerboardPage.vala"
	y = _tmp4_;
#line 586 "../src/Views/CheckerboardPage.vala"
	mask = _tmp5_;
#line 588 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = vadj;
#line 588 "../src/Views/CheckerboardPage.vala"
	new_value = (gint) gtk_adjustment_get_value (_tmp6_);
#line 589 "../src/Views/CheckerboardPage.vala"
	_tmp7_ = vadj;
#line 589 "../src/Views/CheckerboardPage.vala"
	switch (get_adjustment_relation (_tmp7_, y)) {
#line 589 "../src/Views/CheckerboardPage.vala"
		case ADJUSTMENT_RELATION_BELOW:
#line 2796 "CheckerboardPage.c"
		{
			CheckerboardLayout* _tmp8_;
#line 592 "../src/Views/CheckerboardPage.vala"
			new_value -= CHECKERBOARD_PAGE_AUTOSCROLL_PIXELS;
#line 593 "../src/Views/CheckerboardPage.vala"
			_tmp8_ = self->priv->layout;
#line 593 "../src/Views/CheckerboardPage.vala"
			checkerboard_layout_set_drag_select_endpoint (_tmp8_, x, new_value);
#line 594 "../src/Views/CheckerboardPage.vala"
			break;
#line 2807 "CheckerboardPage.c"
		}
#line 589 "../src/Views/CheckerboardPage.vala"
		case ADJUSTMENT_RELATION_ABOVE:
#line 2811 "CheckerboardPage.c"
		{
			CheckerboardLayout* _tmp9_;
			GtkAdjustment* _tmp10_;
#line 598 "../src/Views/CheckerboardPage.vala"
			new_value += CHECKERBOARD_PAGE_AUTOSCROLL_PIXELS;
#line 599 "../src/Views/CheckerboardPage.vala"
			_tmp9_ = self->priv->layout;
#line 599 "../src/Views/CheckerboardPage.vala"
			_tmp10_ = vadj;
#line 599 "../src/Views/CheckerboardPage.vala"
			checkerboard_layout_set_drag_select_endpoint (_tmp9_, x, new_value + ((gint) gtk_adjustment_get_page_size (_tmp10_)));
#line 600 "../src/Views/CheckerboardPage.vala"
			break;
#line 2825 "CheckerboardPage.c"
		}
#line 589 "../src/Views/CheckerboardPage.vala"
		case ADJUSTMENT_RELATION_IN_RANGE:
#line 2829 "CheckerboardPage.c"
		{
#line 603 "../src/Views/CheckerboardPage.vala"
			self->priv->autoscroll_scheduled = FALSE;
#line 605 "../src/Views/CheckerboardPage.vala"
			result = FALSE;
#line 605 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (vadj);
#line 605 "../src/Views/CheckerboardPage.vala"
			return result;
#line 2839 "CheckerboardPage.c"
		}
		default:
		{
#line 608 "../src/Views/CheckerboardPage.vala"
			g_warn_if_reached ();
#line 609 "../src/Views/CheckerboardPage.vala"
			break;
#line 2847 "CheckerboardPage.c"
		}
	}
#line 615 "../src/Views/CheckerboardPage.vala"
	_tmp11_ = vadj;
#line 615 "../src/Views/CheckerboardPage.vala"
	_tmp12_ = vadj;
#line 615 "../src/Views/CheckerboardPage.vala"
	_tmp13_ = vadj;
#line 615 "../src/Views/CheckerboardPage.vala"
	_tmp14_ = vadj;
#line 615 "../src/Views/CheckerboardPage.vala"
	gtk_adjustment_set_value (_tmp11_, (gdouble) CLAMP (new_value, (gint) gtk_adjustment_get_lower (_tmp12_), ((gint) gtk_adjustment_get_upper (_tmp13_)) - ((gint) gtk_adjustment_get_page_size (_tmp14_))));
#line 618 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_updated_selection_band (self);
#line 620 "../src/Views/CheckerboardPage.vala"
	result = TRUE;
#line 620 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (vadj);
#line 620 "../src/Views/CheckerboardPage.vala"
	return result;
#line 2868 "CheckerboardPage.c"
}

void
checkerboard_page_cursor_to_item (CheckerboardPage* self,
                                  CheckerboardItem* item)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	CheckerboardItem* _tmp2_;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	Marker* marker = NULL;
	ViewCollection* _tmp5_;
	ViewCollection* _tmp6_;
	Marker* _tmp7_;
	Marker* _tmp8_;
	ViewCollection* _tmp9_;
	ViewCollection* _tmp10_;
	Marker* _tmp11_;
	GtkAdjustment* vadj = NULL;
	GtkAdjustment* _tmp12_;
	GtkAdjustment* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GtkAdjustment* _tmp15_;
	GdkRectangle _tmp16_;
	gint top = 0;
	GdkRectangle _tmp20_;
	GtkAdjustment* _tmp21_;
	GtkAdjustment* _tmp26_;
#line 623 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 623 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (item != NULL);
#line 624 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 624 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 624 "../src/Views/CheckerboardPage.vala"
	_vala_assert (data_collection_contains ((DataCollection*) _tmp1_, (DataObject*) item), "get_view ().contains (item)");
#line 624 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 626 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = _g_object_ref0 (item);
#line 626 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->cursor);
#line 626 "../src/Views/CheckerboardPage.vala"
	self->cursor = _tmp2_;
#line 628 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 628 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = _tmp3_;
#line 628 "../src/Views/CheckerboardPage.vala"
	view_collection_unselect_all (_tmp4_);
#line 628 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 630 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = page_get_view ((Page*) self);
#line 630 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = _tmp5_;
#line 630 "../src/Views/CheckerboardPage.vala"
	_tmp7_ = data_collection_mark ((DataCollection*) _tmp6_, (DataObject*) item);
#line 630 "../src/Views/CheckerboardPage.vala"
	_tmp8_ = _tmp7_;
#line 630 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp6_);
#line 630 "../src/Views/CheckerboardPage.vala"
	marker = _tmp8_;
#line 631 "../src/Views/CheckerboardPage.vala"
	_tmp9_ = page_get_view ((Page*) self);
#line 631 "../src/Views/CheckerboardPage.vala"
	_tmp10_ = _tmp9_;
#line 631 "../src/Views/CheckerboardPage.vala"
	_tmp11_ = marker;
#line 631 "../src/Views/CheckerboardPage.vala"
	view_collection_select_marked (_tmp10_, _tmp11_);
#line 631 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp10_);
#line 634 "../src/Views/CheckerboardPage.vala"
	_tmp12_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 634 "../src/Views/CheckerboardPage.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 634 "../src/Views/CheckerboardPage.vala"
	vadj = _tmp13_;
#line 635 "../src/Views/CheckerboardPage.vala"
	_tmp15_ = vadj;
#line 635 "../src/Views/CheckerboardPage.vala"
	_tmp16_ = item->allocation;
#line 635 "../src/Views/CheckerboardPage.vala"
	if (get_adjustment_relation (_tmp15_, _tmp16_.y) == ADJUSTMENT_RELATION_IN_RANGE) {
#line 2958 "CheckerboardPage.c"
		GtkAdjustment* _tmp17_;
		GdkRectangle _tmp18_;
		GdkRectangle _tmp19_;
#line 636 "../src/Views/CheckerboardPage.vala"
		_tmp17_ = vadj;
#line 636 "../src/Views/CheckerboardPage.vala"
		_tmp18_ = item->allocation;
#line 636 "../src/Views/CheckerboardPage.vala"
		_tmp19_ = item->allocation;
#line 636 "../src/Views/CheckerboardPage.vala"
		_tmp14_ = get_adjustment_relation (_tmp17_, _tmp18_.y + _tmp19_.height) == ADJUSTMENT_RELATION_IN_RANGE;
#line 2970 "CheckerboardPage.c"
	} else {
#line 635 "../src/Views/CheckerboardPage.vala"
		_tmp14_ = FALSE;
#line 2974 "CheckerboardPage.c"
	}
#line 635 "../src/Views/CheckerboardPage.vala"
	if (_tmp14_) {
#line 637 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (vadj);
#line 637 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (marker);
#line 637 "../src/Views/CheckerboardPage.vala"
		return;
#line 2984 "CheckerboardPage.c"
	}
#line 640 "../src/Views/CheckerboardPage.vala"
	top = 0;
#line 641 "../src/Views/CheckerboardPage.vala"
	_tmp20_ = item->allocation;
#line 641 "../src/Views/CheckerboardPage.vala"
	_tmp21_ = vadj;
#line 641 "../src/Views/CheckerboardPage.vala"
	if (((gdouble) _tmp20_.y) < gtk_adjustment_get_value (_tmp21_)) {
#line 2994 "CheckerboardPage.c"
		GdkRectangle _tmp22_;
#line 642 "../src/Views/CheckerboardPage.vala"
		_tmp22_ = item->allocation;
#line 642 "../src/Views/CheckerboardPage.vala"
		top = _tmp22_.y;
#line 643 "../src/Views/CheckerboardPage.vala"
		top -= CHECKERBOARD_LAYOUT_ROW_GUTTER_PADDING / 2;
#line 3002 "CheckerboardPage.c"
	} else {
		GdkRectangle _tmp23_;
		GdkRectangle _tmp24_;
		GtkAdjustment* _tmp25_;
#line 645 "../src/Views/CheckerboardPage.vala"
		_tmp23_ = item->allocation;
#line 645 "../src/Views/CheckerboardPage.vala"
		_tmp24_ = item->allocation;
#line 645 "../src/Views/CheckerboardPage.vala"
		_tmp25_ = vadj;
#line 645 "../src/Views/CheckerboardPage.vala"
		top = (_tmp23_.y + _tmp24_.height) - ((gint) gtk_adjustment_get_page_size (_tmp25_));
#line 646 "../src/Views/CheckerboardPage.vala"
		top += CHECKERBOARD_LAYOUT_ROW_GUTTER_PADDING / 2;
#line 3017 "CheckerboardPage.c"
	}
#line 649 "../src/Views/CheckerboardPage.vala"
	_tmp26_ = vadj;
#line 649 "../src/Views/CheckerboardPage.vala"
	gtk_adjustment_set_value (_tmp26_, (gdouble) top);
#line 623 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (vadj);
#line 623 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (marker);
#line 3027 "CheckerboardPage.c"
}

static void
checkerboard_page_move_cursor (CheckerboardPage* self,
                               GtkDirectionType direction)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	ViewCollection* _tmp4_;
	ViewCollection* _tmp5_;
	gboolean _tmp6_;
	CheckerboardItem* item = NULL;
	CheckerboardLayout* _tmp13_;
	CheckerboardItem* _tmp14_;
	CheckerboardItem* _tmp15_;
	CheckerboardItem* _tmp16_;
#line 652 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 654 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 654 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 654 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = data_collection_get_count ((DataCollection*) _tmp1_) == 0;
#line 654 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 654 "../src/Views/CheckerboardPage.vala"
	if (_tmp2_) {
#line 655 "../src/Views/CheckerboardPage.vala"
		return;
#line 3060 "CheckerboardPage.c"
	}
#line 658 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = page_get_view ((Page*) self);
#line 658 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = _tmp4_;
#line 658 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = view_collection_get_selected_count (_tmp5_) == 0;
#line 658 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp5_);
#line 658 "../src/Views/CheckerboardPage.vala"
	if (_tmp6_) {
#line 658 "../src/Views/CheckerboardPage.vala"
		_tmp3_ = TRUE;
#line 3074 "CheckerboardPage.c"
	} else {
		CheckerboardItem* _tmp7_;
#line 658 "../src/Views/CheckerboardPage.vala"
		_tmp7_ = self->cursor;
#line 658 "../src/Views/CheckerboardPage.vala"
		_tmp3_ = _tmp7_ == NULL;
#line 3081 "CheckerboardPage.c"
	}
#line 658 "../src/Views/CheckerboardPage.vala"
	if (_tmp3_) {
#line 3085 "CheckerboardPage.c"
		CheckerboardItem* item = NULL;
		CheckerboardLayout* _tmp8_;
		CheckerboardItem* _tmp9_;
		CheckerboardItem* _tmp10_;
		CheckerboardItem* _tmp11_;
		CheckerboardItem* _tmp12_;
#line 659 "../src/Views/CheckerboardPage.vala"
		_tmp8_ = self->priv->layout;
#line 659 "../src/Views/CheckerboardPage.vala"
		_tmp9_ = checkerboard_layout_get_item_at_coordinate (_tmp8_, 0, 0);
#line 659 "../src/Views/CheckerboardPage.vala"
		item = _tmp9_;
#line 660 "../src/Views/CheckerboardPage.vala"
		_tmp10_ = item;
#line 660 "../src/Views/CheckerboardPage.vala"
		checkerboard_page_cursor_to_item (self, _tmp10_);
#line 661 "../src/Views/CheckerboardPage.vala"
		_tmp11_ = item;
#line 661 "../src/Views/CheckerboardPage.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 661 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (self->anchor);
#line 661 "../src/Views/CheckerboardPage.vala"
		self->anchor = _tmp12_;
#line 663 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (item);
#line 663 "../src/Views/CheckerboardPage.vala"
		return;
#line 3114 "CheckerboardPage.c"
	}
#line 667 "../src/Views/CheckerboardPage.vala"
	_tmp13_ = self->priv->layout;
#line 667 "../src/Views/CheckerboardPage.vala"
	_tmp14_ = self->cursor;
#line 667 "../src/Views/CheckerboardPage.vala"
	_tmp15_ = checkerboard_layout_get_item_relative_to (_tmp13_, _tmp14_, direction);
#line 667 "../src/Views/CheckerboardPage.vala"
	item = _tmp15_;
#line 668 "../src/Views/CheckerboardPage.vala"
	_tmp16_ = item;
#line 668 "../src/Views/CheckerboardPage.vala"
	if (_tmp16_ != NULL) {
#line 3128 "CheckerboardPage.c"
		CheckerboardItem* _tmp17_;
#line 669 "../src/Views/CheckerboardPage.vala"
		_tmp17_ = item;
#line 669 "../src/Views/CheckerboardPage.vala"
		checkerboard_page_cursor_to_item (self, _tmp17_);
#line 3134 "CheckerboardPage.c"
	}
#line 652 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (item);
#line 3138 "CheckerboardPage.c"
}

void
checkerboard_page_set_cursor (CheckerboardPage* self,
                              CheckerboardItem* item)
{
	Marker* marker = NULL;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	Marker* _tmp2_;
	Marker* _tmp3_;
	ViewCollection* _tmp4_;
	ViewCollection* _tmp5_;
	CheckerboardItem* _tmp6_;
	CheckerboardItem* _tmp7_;
#line 672 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 672 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (item != NULL);
#line 673 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 673 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 673 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = data_collection_mark ((DataCollection*) _tmp1_, (DataObject*) item);
#line 673 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = _tmp2_;
#line 673 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 673 "../src/Views/CheckerboardPage.vala"
	marker = _tmp3_;
#line 674 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = page_get_view ((Page*) self);
#line 674 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = _tmp4_;
#line 674 "../src/Views/CheckerboardPage.vala"
	view_collection_select_marked (_tmp5_, marker);
#line 674 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp5_);
#line 676 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = _g_object_ref0 (item);
#line 676 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->cursor);
#line 676 "../src/Views/CheckerboardPage.vala"
	self->cursor = _tmp6_;
#line 677 "../src/Views/CheckerboardPage.vala"
	_tmp7_ = _g_object_ref0 (item);
#line 677 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->anchor);
#line 677 "../src/Views/CheckerboardPage.vala"
	self->anchor = _tmp7_;
#line 672 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (marker);
#line 3192 "CheckerboardPage.c"
}

void
checkerboard_page_select_between_items (CheckerboardPage* self,
                                        CheckerboardItem* item_start,
                                        CheckerboardItem* item_end)
{
	Marker* marker = NULL;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	Marker* _tmp2_;
	Marker* _tmp3_;
	gboolean passed_start = FALSE;
	gboolean passed_end = FALSE;
	ViewCollection* _tmp21_;
	ViewCollection* _tmp22_;
	Marker* _tmp23_;
#line 680 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 680 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (item_start != NULL);
#line 680 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (item_end != NULL);
#line 681 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 681 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 681 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = data_collection_start_marking ((DataCollection*) _tmp1_);
#line 681 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = _tmp2_;
#line 681 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 681 "../src/Views/CheckerboardPage.vala"
	marker = _tmp3_;
#line 683 "../src/Views/CheckerboardPage.vala"
	passed_start = FALSE;
#line 684 "../src/Views/CheckerboardPage.vala"
	passed_end = FALSE;
#line 3232 "CheckerboardPage.c"
	{
		GeeIterator* _object_it = NULL;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
#line 686 "../src/Views/CheckerboardPage.vala"
		_tmp4_ = page_get_view ((Page*) self);
#line 686 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = _tmp4_;
#line 686 "../src/Views/CheckerboardPage.vala"
		_tmp6_ = data_collection_get_all ((DataCollection*) _tmp5_);
#line 686 "../src/Views/CheckerboardPage.vala"
		_tmp7_ = _tmp6_;
#line 686 "../src/Views/CheckerboardPage.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 686 "../src/Views/CheckerboardPage.vala"
		_tmp9_ = _tmp8_;
#line 686 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (_tmp7_);
#line 686 "../src/Views/CheckerboardPage.vala"
		_data_collection_unref0 (_tmp5_);
#line 686 "../src/Views/CheckerboardPage.vala"
		_object_it = _tmp9_;
#line 686 "../src/Views/CheckerboardPage.vala"
		while (TRUE) {
#line 3261 "CheckerboardPage.c"
			GeeIterator* _tmp10_;
			DataObject* object = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			CheckerboardItem* item = NULL;
			DataObject* _tmp13_;
			CheckerboardItem* _tmp14_;
			CheckerboardItem* _tmp15_;
			CheckerboardItem* _tmp16_;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp20_ = FALSE;
#line 686 "../src/Views/CheckerboardPage.vala"
			_tmp10_ = _object_it;
#line 686 "../src/Views/CheckerboardPage.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 686 "../src/Views/CheckerboardPage.vala"
				break;
#line 3279 "CheckerboardPage.c"
			}
#line 686 "../src/Views/CheckerboardPage.vala"
			_tmp11_ = _object_it;
#line 686 "../src/Views/CheckerboardPage.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 686 "../src/Views/CheckerboardPage.vala"
			object = (DataObject*) _tmp12_;
#line 687 "../src/Views/CheckerboardPage.vala"
			_tmp13_ = object;
#line 687 "../src/Views/CheckerboardPage.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem));
#line 687 "../src/Views/CheckerboardPage.vala"
			item = _tmp14_;
#line 689 "../src/Views/CheckerboardPage.vala"
			_tmp15_ = item;
#line 689 "../src/Views/CheckerboardPage.vala"
			if (item_start == _tmp15_) {
#line 690 "../src/Views/CheckerboardPage.vala"
				passed_start = TRUE;
#line 3299 "CheckerboardPage.c"
			}
#line 692 "../src/Views/CheckerboardPage.vala"
			_tmp16_ = item;
#line 692 "../src/Views/CheckerboardPage.vala"
			if (item_end == _tmp16_) {
#line 693 "../src/Views/CheckerboardPage.vala"
				passed_end = TRUE;
#line 3307 "CheckerboardPage.c"
			}
#line 695 "../src/Views/CheckerboardPage.vala"
			if (passed_start) {
#line 695 "../src/Views/CheckerboardPage.vala"
				_tmp17_ = TRUE;
#line 3313 "CheckerboardPage.c"
			} else {
#line 695 "../src/Views/CheckerboardPage.vala"
				_tmp17_ = passed_end;
#line 3317 "CheckerboardPage.c"
			}
#line 695 "../src/Views/CheckerboardPage.vala"
			if (_tmp17_) {
#line 3321 "CheckerboardPage.c"
				Marker* _tmp18_;
				DataObject* _tmp19_;
#line 696 "../src/Views/CheckerboardPage.vala"
				_tmp18_ = marker;
#line 696 "../src/Views/CheckerboardPage.vala"
				_tmp19_ = object;
#line 696 "../src/Views/CheckerboardPage.vala"
				marker_mark (_tmp18_, (DataObject*) G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_DATA_VIEW, DataView));
#line 3330 "CheckerboardPage.c"
			}
#line 698 "../src/Views/CheckerboardPage.vala"
			if (passed_start) {
#line 698 "../src/Views/CheckerboardPage.vala"
				_tmp20_ = passed_end;
#line 3336 "CheckerboardPage.c"
			} else {
#line 698 "../src/Views/CheckerboardPage.vala"
				_tmp20_ = FALSE;
#line 3340 "CheckerboardPage.c"
			}
#line 698 "../src/Views/CheckerboardPage.vala"
			if (_tmp20_) {
#line 699 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (item);
#line 699 "../src/Views/CheckerboardPage.vala"
				_g_object_unref0 (object);
#line 699 "../src/Views/CheckerboardPage.vala"
				break;
#line 3350 "CheckerboardPage.c"
			}
#line 686 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (item);
#line 686 "../src/Views/CheckerboardPage.vala"
			_g_object_unref0 (object);
#line 3356 "CheckerboardPage.c"
		}
#line 686 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (_object_it);
#line 3360 "CheckerboardPage.c"
	}
#line 702 "../src/Views/CheckerboardPage.vala"
	_tmp21_ = page_get_view ((Page*) self);
#line 702 "../src/Views/CheckerboardPage.vala"
	_tmp22_ = _tmp21_;
#line 702 "../src/Views/CheckerboardPage.vala"
	_tmp23_ = marker;
#line 702 "../src/Views/CheckerboardPage.vala"
	view_collection_select_marked (_tmp22_, _tmp23_);
#line 702 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp22_);
#line 680 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (marker);
#line 3374 "CheckerboardPage.c"
}

void
checkerboard_page_select_anchor_to_cursor (CheckerboardPage* self,
                                           guint state)
{
	gboolean _tmp0_ = FALSE;
	CheckerboardItem* _tmp1_;
#line 705 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 706 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = self->cursor;
#line 706 "../src/Views/CheckerboardPage.vala"
	if (_tmp1_ == NULL) {
#line 706 "../src/Views/CheckerboardPage.vala"
		_tmp0_ = TRUE;
#line 3391 "CheckerboardPage.c"
	} else {
		CheckerboardItem* _tmp2_;
#line 706 "../src/Views/CheckerboardPage.vala"
		_tmp2_ = self->anchor;
#line 706 "../src/Views/CheckerboardPage.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 3398 "CheckerboardPage.c"
	}
#line 706 "../src/Views/CheckerboardPage.vala"
	if (_tmp0_) {
#line 707 "../src/Views/CheckerboardPage.vala"
		return;
#line 3404 "CheckerboardPage.c"
	}
#line 709 "../src/Views/CheckerboardPage.vala"
	if (state == ((guint) GDK_SHIFT_MASK)) {
#line 3408 "CheckerboardPage.c"
		ViewCollection* _tmp3_;
		ViewCollection* _tmp4_;
		CheckerboardItem* _tmp5_;
		CheckerboardItem* _tmp6_;
#line 710 "../src/Views/CheckerboardPage.vala"
		_tmp3_ = page_get_view ((Page*) self);
#line 710 "../src/Views/CheckerboardPage.vala"
		_tmp4_ = _tmp3_;
#line 710 "../src/Views/CheckerboardPage.vala"
		view_collection_unselect_all (_tmp4_);
#line 710 "../src/Views/CheckerboardPage.vala"
		_data_collection_unref0 (_tmp4_);
#line 711 "../src/Views/CheckerboardPage.vala"
		_tmp5_ = self->anchor;
#line 711 "../src/Views/CheckerboardPage.vala"
		_tmp6_ = self->cursor;
#line 711 "../src/Views/CheckerboardPage.vala"
		checkerboard_page_select_between_items (self, _tmp5_, _tmp6_);
#line 3427 "CheckerboardPage.c"
	} else {
		CheckerboardItem* _tmp7_;
		CheckerboardItem* _tmp8_;
#line 713 "../src/Views/CheckerboardPage.vala"
		_tmp7_ = self->cursor;
#line 713 "../src/Views/CheckerboardPage.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 713 "../src/Views/CheckerboardPage.vala"
		_g_object_unref0 (self->anchor);
#line 713 "../src/Views/CheckerboardPage.vala"
		self->anchor = _tmp8_;
#line 3439 "CheckerboardPage.c"
	}
}

static void
checkerboard_page_real_set_display_titles (CheckerboardPage* self,
                                           gboolean display)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	ViewCollection* _tmp2_;
	ViewCollection* _tmp3_;
	GValue _tmp4_ = {0};
	ViewCollection* _tmp5_;
	ViewCollection* _tmp6_;
#line 718 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 718 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 718 "../src/Views/CheckerboardPage.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp1_);
#line 718 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 719 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = page_get_view ((Page*) self);
#line 719 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = _tmp2_;
#line 719 "../src/Views/CheckerboardPage.vala"
	g_value_init (&_tmp4_, G_TYPE_BOOLEAN);
#line 719 "../src/Views/CheckerboardPage.vala"
	g_value_set_boolean (&_tmp4_, display);
#line 719 "../src/Views/CheckerboardPage.vala"
	data_collection_set_property ((DataCollection*) _tmp3_, CHECKERBOARD_ITEM_PROP_SHOW_TITLES, &_tmp4_, NULL, NULL);
#line 719 "../src/Views/CheckerboardPage.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 719 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp3_);
#line 720 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = page_get_view ((Page*) self);
#line 720 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = _tmp5_;
#line 720 "../src/Views/CheckerboardPage.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp6_);
#line 720 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp6_);
#line 3484 "CheckerboardPage.c"
}

void
checkerboard_page_set_display_titles (CheckerboardPage* self,
                                      gboolean display)
{
	CheckerboardPageClass* _klass_;
#line 717 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 717 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 717 "../src/Views/CheckerboardPage.vala"
	if (_klass_->set_display_titles) {
#line 717 "../src/Views/CheckerboardPage.vala"
		_klass_->set_display_titles (self, display);
#line 3500 "CheckerboardPage.c"
	}
}

static void
checkerboard_page_real_set_display_comments (CheckerboardPage* self,
                                             gboolean display)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	ViewCollection* _tmp2_;
	ViewCollection* _tmp3_;
	GValue _tmp4_ = {0};
	ViewCollection* _tmp5_;
	ViewCollection* _tmp6_;
#line 724 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 724 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 724 "../src/Views/CheckerboardPage.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp1_);
#line 724 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 725 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = page_get_view ((Page*) self);
#line 725 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = _tmp2_;
#line 725 "../src/Views/CheckerboardPage.vala"
	g_value_init (&_tmp4_, G_TYPE_BOOLEAN);
#line 725 "../src/Views/CheckerboardPage.vala"
	g_value_set_boolean (&_tmp4_, display);
#line 725 "../src/Views/CheckerboardPage.vala"
	data_collection_set_property ((DataCollection*) _tmp3_, CHECKERBOARD_ITEM_PROP_SHOW_COMMENTS, &_tmp4_, NULL, NULL);
#line 725 "../src/Views/CheckerboardPage.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 725 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp3_);
#line 726 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = page_get_view ((Page*) self);
#line 726 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = _tmp5_;
#line 726 "../src/Views/CheckerboardPage.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp6_);
#line 726 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp6_);
#line 3545 "CheckerboardPage.c"
}

void
checkerboard_page_set_display_comments (CheckerboardPage* self,
                                        gboolean display)
{
	CheckerboardPageClass* _klass_;
#line 723 "../src/Views/CheckerboardPage.vala"
	g_return_if_fail (self != NULL);
#line 723 "../src/Views/CheckerboardPage.vala"
	_klass_ = CHECKERBOARD_PAGE_GET_CLASS (self);
#line 723 "../src/Views/CheckerboardPage.vala"
	if (_klass_->set_display_comments) {
#line 723 "../src/Views/CheckerboardPage.vala"
		_klass_->set_display_comments (self, display);
#line 3561 "CheckerboardPage.c"
	}
}

static void
_checkerboard_page_on_items_hidden_view_collection_items_hidden (ViewCollection* _sender,
                                                                 GeeCollection* hidden,
                                                                 gpointer self)
{
#line 54 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_on_items_hidden ((CheckerboardPage*) self, hidden);
#line 3572 "CheckerboardPage.c"
}

static void
_checkerboard_page_on_contents_altered_data_collection_contents_altered (DataCollection* _sender,
                                                                         GeeIterable* added,
                                                                         GeeIterable* removed,
                                                                         gpointer self)
{
#line 55 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_on_contents_altered ((CheckerboardPage*) self, added, removed);
#line 3583 "CheckerboardPage.c"
}

static void
_checkerboard_page_on_items_state_changed_view_collection_items_state_changed (ViewCollection* _sender,
                                                                               GeeIterable* changed,
                                                                               gpointer self)
{
#line 56 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_on_items_state_changed ((CheckerboardPage*) self, changed);
#line 3593 "CheckerboardPage.c"
}

static void
_checkerboard_page_on_items_visibility_changed_view_collection_items_visibility_changed (ViewCollection* _sender,
                                                                                         GeeCollection* changed,
                                                                                         gpointer self)
{
#line 57 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_on_items_visibility_changed ((CheckerboardPage*) self, changed);
#line 3603 "CheckerboardPage.c"
}

static void
_checkerboard_page___lambda116_ (CheckerboardPage* self)
{
	CheckerboardLayout* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 63 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = self->priv->layout;
#line 63 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = page_get_page_name ((Page*) self);
#line 63 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = _tmp1_;
#line 63 "../src/Views/CheckerboardPage.vala"
	checkerboard_layout_set_name (_tmp0_, _tmp2_);
#line 3620 "CheckerboardPage.c"
}

static void
__checkerboard_page___lambda116__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 62 "../src/Views/CheckerboardPage.vala"
	_checkerboard_page___lambda116_ ((CheckerboardPage*) self);
#line 3630 "CheckerboardPage.c"
}

static GObject *
checkerboard_page_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CheckerboardPage * self;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	CheckerboardLayout* _tmp2_;
	CheckerboardLayout* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	CheckerboardLayout* _tmp6_;
	GtkViewport* _tmp7_;
	CheckerboardLayout* _tmp8_;
	CheckerboardLayout* _tmp9_;
	GtkAdjustment* _tmp10_;
	GtkAdjustment* _tmp11_;
	GtkViewport* _tmp12_;
	ViewCollection* _tmp13_;
	ViewCollection* _tmp14_;
	ViewCollection* _tmp15_;
	ViewCollection* _tmp16_;
	ViewCollection* _tmp17_;
	ViewCollection* _tmp18_;
	ViewCollection* _tmp19_;
	ViewCollection* _tmp20_;
#line 39 "../src/Views/CheckerboardPage.vala"
	parent_class = G_OBJECT_CLASS (checkerboard_page_parent_class);
#line 39 "../src/Views/CheckerboardPage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/Views/CheckerboardPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHECKERBOARD_PAGE, CheckerboardPage);
#line 40 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 40 "../src/Views/CheckerboardPage.vala"
	_tmp1_ = _tmp0_;
#line 40 "../src/Views/CheckerboardPage.vala"
	_tmp2_ = checkerboard_layout_new (_tmp1_);
#line 40 "../src/Views/CheckerboardPage.vala"
	g_object_ref_sink (_tmp2_);
#line 40 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->priv->layout);
#line 40 "../src/Views/CheckerboardPage.vala"
	self->priv->layout = _tmp2_;
#line 40 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 41 "../src/Views/CheckerboardPage.vala"
	_tmp3_ = self->priv->layout;
#line 41 "../src/Views/CheckerboardPage.vala"
	_tmp4_ = page_get_page_name ((Page*) self);
#line 41 "../src/Views/CheckerboardPage.vala"
	_tmp5_ = _tmp4_;
#line 41 "../src/Views/CheckerboardPage.vala"
	checkerboard_layout_set_name (_tmp3_, _tmp5_);
#line 43 "../src/Views/CheckerboardPage.vala"
	_tmp6_ = self->priv->layout;
#line 43 "../src/Views/CheckerboardPage.vala"
	page_set_event_source ((Page*) self, (GtkWidget*) _tmp6_);
#line 45 "../src/Views/CheckerboardPage.vala"
	_tmp7_ = self->priv->viewport;
#line 45 "../src/Views/CheckerboardPage.vala"
	_tmp8_ = self->priv->layout;
#line 45 "../src/Views/CheckerboardPage.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 49 "../src/Views/CheckerboardPage.vala"
	_tmp9_ = self->priv->layout;
#line 49 "../src/Views/CheckerboardPage.vala"
	_tmp10_ = gtk_scrolled_window_get_hadjustment ((GtkScrolledWindow*) self);
#line 49 "../src/Views/CheckerboardPage.vala"
	_tmp11_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 49 "../src/Views/CheckerboardPage.vala"
	checkerboard_layout_set_adjustments (_tmp9_, _tmp10_, _tmp11_);
#line 51 "../src/Views/CheckerboardPage.vala"
	_tmp12_ = self->priv->viewport;
#line 51 "../src/Views/CheckerboardPage.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
#line 54 "../src/Views/CheckerboardPage.vala"
	_tmp13_ = page_get_view ((Page*) self);
#line 54 "../src/Views/CheckerboardPage.vala"
	_tmp14_ = _tmp13_;
#line 54 "../src/Views/CheckerboardPage.vala"
	g_signal_connect_object (_tmp14_, "items-hidden", (GCallback) _checkerboard_page_on_items_hidden_view_collection_items_hidden, self, 0);
#line 54 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp14_);
#line 55 "../src/Views/CheckerboardPage.vala"
	_tmp15_ = page_get_view ((Page*) self);
#line 55 "../src/Views/CheckerboardPage.vala"
	_tmp16_ = _tmp15_;
#line 55 "../src/Views/CheckerboardPage.vala"
	g_signal_connect_object ((DataCollection*) _tmp16_, "contents-altered", (GCallback) _checkerboard_page_on_contents_altered_data_collection_contents_altered, self, 0);
#line 55 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp16_);
#line 56 "../src/Views/CheckerboardPage.vala"
	_tmp17_ = page_get_view ((Page*) self);
#line 56 "../src/Views/CheckerboardPage.vala"
	_tmp18_ = _tmp17_;
#line 56 "../src/Views/CheckerboardPage.vala"
	g_signal_connect_object (_tmp18_, "items-state-changed", (GCallback) _checkerboard_page_on_items_state_changed_view_collection_items_state_changed, self, 0);
#line 56 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp18_);
#line 57 "../src/Views/CheckerboardPage.vala"
	_tmp19_ = page_get_view ((Page*) self);
#line 57 "../src/Views/CheckerboardPage.vala"
	_tmp20_ = _tmp19_;
#line 57 "../src/Views/CheckerboardPage.vala"
	g_signal_connect_object (_tmp20_, "items-visibility-changed", (GCallback) _checkerboard_page_on_items_visibility_changed_view_collection_items_visibility_changed, self, 0);
#line 57 "../src/Views/CheckerboardPage.vala"
	_data_collection_unref0 (_tmp20_);
#line 60 "../src/Views/CheckerboardPage.vala"
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 62 "../src/Views/CheckerboardPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::page_name", (GCallback) __checkerboard_page___lambda116__g_object_notify, self, 0);
#line 39 "../src/Views/CheckerboardPage.vala"
	return obj;
#line 3750 "CheckerboardPage.c"
}

static void
checkerboard_page_class_init (CheckerboardPageClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/Views/CheckerboardPage.vala"
	checkerboard_page_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Views/CheckerboardPage.vala"
	g_type_class_adjust_private_offset (klass, &CheckerboardPage_private_offset);
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->get_back_name = (gchar* (*) (CheckerboardPage*)) checkerboard_page_real_get_back_name;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->get_item_context_menu = (GtkMenu* (*) (CheckerboardPage*)) checkerboard_page_real_get_item_context_menu;
#line 20 "../src/Views/CheckerboardPage.vala"
	((PageClass *) klass)->on_context_keypress = (gboolean (*) (Page*)) checkerboard_page_real_on_context_keypress;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->get_view_empty_message = (gchar* (*) (CheckerboardPage*)) checkerboard_page_real_get_view_empty_message;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->get_filter_no_match_message = (gchar* (*) (CheckerboardPage*)) checkerboard_page_real_get_filter_no_match_message;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->on_item_activated = (void (*) (CheckerboardPage*, CheckerboardItem*)) checkerboard_page_real_on_item_activated;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->get_search_view_filter = (SearchViewFilter* (*) (CheckerboardPage*)) checkerboard_page_real_get_search_view_filter;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->get_view_tracker = (CoreViewTracker* (*) (CheckerboardPage*)) checkerboard_page_real_get_view_tracker;
#line 20 "../src/Views/CheckerboardPage.vala"
	((PageClass *) klass)->switching_from = (void (*) (Page*)) checkerboard_page_real_switching_from;
#line 20 "../src/Views/CheckerboardPage.vala"
	((PageClass *) klass)->switched_to = (void (*) (Page*)) checkerboard_page_real_switched_to;
#line 20 "../src/Views/CheckerboardPage.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) checkerboard_page_real_key_press_event;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->is_point_on_item_selection_button = (gboolean (*) (CheckerboardPage*, gdouble, gdouble, CheckerboardItem*)) checkerboard_page_real_is_point_on_item_selection_button;
#line 20 "../src/Views/CheckerboardPage.vala"
	((PageClass *) klass)->on_left_click = (gboolean (*) (Page*, GdkEventButton*)) checkerboard_page_real_on_left_click;
#line 20 "../src/Views/CheckerboardPage.vala"
	((PageClass *) klass)->on_left_released = (gboolean (*) (Page*, GdkEventButton*)) checkerboard_page_real_on_left_released;
#line 20 "../src/Views/CheckerboardPage.vala"
	((PageClass *) klass)->on_right_click = (gboolean (*) (Page*, GdkEventButton*)) checkerboard_page_real_on_right_click;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->on_mouse_over = (gboolean (*) (CheckerboardPage*, CheckerboardItem*, gint, gint, GdkModifierType)) checkerboard_page_real_on_mouse_over;
#line 20 "../src/Views/CheckerboardPage.vala"
	((PageClass *) klass)->on_motion = (gboolean (*) (Page*, GdkEventMotion*, gint, gint, GdkModifierType)) checkerboard_page_real_on_motion;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->set_display_titles = (void (*) (CheckerboardPage*, gboolean)) checkerboard_page_real_set_display_titles;
#line 20 "../src/Views/CheckerboardPage.vala"
	((CheckerboardPageClass *) klass)->set_display_comments = (void (*) (CheckerboardPage*, gboolean)) checkerboard_page_real_set_display_comments;
#line 20 "../src/Views/CheckerboardPage.vala"
	G_OBJECT_CLASS (klass)->constructor = checkerboard_page_constructor;
#line 20 "../src/Views/CheckerboardPage.vala"
	G_OBJECT_CLASS (klass)->finalize = checkerboard_page_finalize;
#line 3803 "CheckerboardPage.c"
}

static void
checkerboard_page_instance_init (CheckerboardPage * self,
                                 gpointer klass)
{
	GtkViewport* _tmp0_;
#line 20 "../src/Views/CheckerboardPage.vala"
	self->priv = checkerboard_page_get_instance_private (self);
#line 25 "../src/Views/CheckerboardPage.vala"
	self->priv->page_sidebar_menu_path = NULL;
#line 26 "../src/Views/CheckerboardPage.vala"
	_tmp0_ = (GtkViewport*) gtk_viewport_new (NULL, NULL);
#line 26 "../src/Views/CheckerboardPage.vala"
	g_object_ref_sink (_tmp0_);
#line 26 "../src/Views/CheckerboardPage.vala"
	self->priv->viewport = _tmp0_;
#line 27 "../src/Views/CheckerboardPage.vala"
	self->anchor = NULL;
#line 28 "../src/Views/CheckerboardPage.vala"
	self->cursor = NULL;
#line 29 "../src/Views/CheckerboardPage.vala"
	self->priv->highlighted = NULL;
#line 30 "../src/Views/CheckerboardPage.vala"
	self->priv->autoscroll_scheduled = FALSE;
#line 31 "../src/Views/CheckerboardPage.vala"
	self->priv->selection_button_clicked = FALSE;
#line 32 "../src/Views/CheckerboardPage.vala"
	self->priv->activated_item = NULL;
#line 33 "../src/Views/CheckerboardPage.vala"
	self->priv->previously_selected = NULL;
#line 3835 "CheckerboardPage.c"
}

static void
checkerboard_page_finalize (GObject * obj)
{
	CheckerboardPage * self;
#line 20 "../src/Views/CheckerboardPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHECKERBOARD_PAGE, CheckerboardPage);
#line 24 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->priv->layout);
#line 25 "../src/Views/CheckerboardPage.vala"
	_g_free0 (self->priv->page_sidebar_menu_path);
#line 26 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->priv->viewport);
#line 27 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->anchor);
#line 28 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->cursor);
#line 29 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->priv->highlighted);
#line 32 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->priv->activated_item);
#line 33 "../src/Views/CheckerboardPage.vala"
	_g_object_unref0 (self->priv->previously_selected);
#line 20 "../src/Views/CheckerboardPage.vala"
	G_OBJECT_CLASS (checkerboard_page_parent_class)->finalize (obj);
#line 3862 "CheckerboardPage.c"
}

static GType
checkerboard_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CheckerboardPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) checkerboard_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CheckerboardPage), 0, (GInstanceInitFunc) checkerboard_page_instance_init, NULL };
	GType checkerboard_page_type_id;
	checkerboard_page_type_id = g_type_register_static (TYPE_PAGE, "CheckerboardPage", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	CheckerboardPage_private_offset = g_type_add_instance_private (checkerboard_page_type_id, sizeof (CheckerboardPagePrivate));
	return checkerboard_page_type_id;
}

GType
checkerboard_page_get_type (void)
{
	static volatile gsize checkerboard_page_type_id__once = 0;
	if (g_once_init_enter (&checkerboard_page_type_id__once)) {
		GType checkerboard_page_type_id;
		checkerboard_page_type_id = checkerboard_page_get_type_once ();
		g_once_init_leave (&checkerboard_page_type_id__once, checkerboard_page_type_id);
	}
	return checkerboard_page_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

