/* SinglePhotoPage.c generated by valac 0.56.18, the Vala compiler
 * generated from SinglePhotoPage.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io),
*               2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <string.h>
#include <glib-object.h>
#include <stdlib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>
#include <granite.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SINGLE_PHOTO_PAGE_0_PROPERTY,
	SINGLE_PHOTO_PAGE_SCALE_UP_TO_VIEWPORT_PROPERTY,
	SINGLE_PHOTO_PAGE_NUM_PROPERTIES
};
static GParamSpec* single_photo_page_properties[SINGLE_PHOTO_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _transition_clock_unref0(var) ((var == NULL) ? NULL : (var = (transition_clock_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _transition_effects_manager_unref0(var) ((var == NULL) ? NULL : (var = (transition_effects_manager_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SinglePhotoPagePrivate {
	TransitionClock* transition_clock;
	gint transition_duration_msec;
	cairo_surface_t* pixmap;
	cairo_t* pixmap_ctx;
	cairo_t* text_ctx;
	Dimensions pixmap_dim;
	GdkPixbuf* unscaled;
	Dimensions max_dim;
	GdkPixbuf* scaled;
	GdkPixbuf* old_scaled;
	GdkRectangle scaled_pos;
	ZoomState static_zoom_state;
	gboolean zoom_high_quality;
	ZoomState saved_zoom_state;
	gboolean has_saved_zoom_state;
	guint32 last_nav_key;
	gboolean _scale_up_to_viewport;
};

static gint SinglePhotoPage_private_offset;
static gpointer single_photo_page_parent_class = NULL;

static void single_photo_page_cancel_transition (SinglePhotoPage* self);
static void single_photo_page_render_zoomed_to_pixmap (SinglePhotoPage* self,
                                                ZoomState* zoom_state);
static gboolean single_photo_page_real_is_zoom_supported (SinglePhotoPage* self);
static void single_photo_page_real_cancel_zoom (SinglePhotoPage* self);
static void single_photo_page_real_save_zoom_state (SinglePhotoPage* self);
static void single_photo_page_real_restore_zoom_state (SinglePhotoPage* self);
static ZoomBuffer* single_photo_page_real_get_zoom_buffer (SinglePhotoPage* self);
static void single_photo_page_real_switched_to (Page* base);
static void single_photo_page_real_set_container (Page* base,
                                           GtkWindow* container);
static void single_photo_page_invalidate_all (SinglePhotoPage* self);
VALA_EXTERN gboolean coord_in_rectangle (gint x,
                             gint y,
                             GdkRectangle* rect);
static void single_photo_page_on_viewport_resize (SinglePhotoPage* self);
static void single_photo_page_internal_repaint (SinglePhotoPage* self,
                                         gboolean fast,
                                         Direction* direction);
static void single_photo_page_real_on_resize_finished (Page* base,
                                                GdkRectangle* rect);
static gboolean single_photo_page_on_canvas_exposed (SinglePhotoPage* self,
                                              cairo_t* exposed_ctx);
static void single_photo_page_real_new_surface (SinglePhotoPage* self,
                                         cairo_t* ctx,
                                         Dimensions* ctx_dim);
static void single_photo_page_real_updated_pixbuf (SinglePhotoPage* self,
                                            GdkPixbuf* pixbuf,
                                            SinglePhotoPageUpdateReason reason,
                                            Dimensions* old_dim);
static void single_photo_page_real_paint (SinglePhotoPage* self,
                                   cairo_t* ctx,
                                   Dimensions* ctx_dim);
static void single_photo_page_repaint_pixmap (SinglePhotoPage* self);
static void single_photo_page_init_pixmap (SinglePhotoPage* self,
                                    gint width,
                                    gint height);
VALA_EXTERN GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
VALA_EXTERN void parse_color (const gchar* spec,
                  GdkRGBA* result);
static void _single_photo_page_repaint_pixmap_transition_clock_repaint_callback (gpointer self);
VALA_EXTERN void set_source_color_from_string (cairo_t* ctx,
                                   const gchar* spec);
static gboolean single_photo_page_real_on_context_keypress (Page* base);
static void single_photo_page_real_on_previous_photo (SinglePhotoPage* self);
static void single_photo_page_real_on_next_photo (SinglePhotoPage* self);
static gboolean single_photo_page_real_key_press_event (GtkWidget* base,
                                                 GdkEventKey* event);
static GObject * single_photo_page_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _single_photo_page_on_viewport_resize_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                     GtkAllocation* allocation,
                                                                     gpointer self);
static gboolean _single_photo_page_on_canvas_exposed_gtk_widget_draw (GtkWidget* _sender,
                                                               cairo_t* cr,
                                                               gpointer self);
static void single_photo_page_finalize (GObject * obj);
static GType single_photo_page_get_type_once (void);
static void _vala_single_photo_page_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_single_photo_page_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
single_photo_page_get_instance_private (SinglePhotoPage* self)
{
	return G_STRUCT_MEMBER_P (self, SinglePhotoPage_private_offset);
}

static GType
single_photo_page_update_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{SINGLE_PHOTO_PAGE_UPDATE_REASON_NEW_PIXBUF, "SINGLE_PHOTO_PAGE_UPDATE_REASON_NEW_PIXBUF", "new-pixbuf"}, {SINGLE_PHOTO_PAGE_UPDATE_REASON_QUALITY_IMPROVEMENT, "SINGLE_PHOTO_PAGE_UPDATE_REASON_QUALITY_IMPROVEMENT", "quality-improvement"}, {SINGLE_PHOTO_PAGE_UPDATE_REASON_RESIZED_CANVAS, "SINGLE_PHOTO_PAGE_UPDATE_REASON_RESIZED_CANVAS", "resized-canvas"}, {0, NULL, NULL}};
	GType single_photo_page_update_reason_type_id;
	single_photo_page_update_reason_type_id = g_enum_register_static ("SinglePhotoPageUpdateReason", values);
	return single_photo_page_update_reason_type_id;
}

GType
single_photo_page_update_reason_get_type (void)
{
	static volatile gsize single_photo_page_update_reason_type_id__once = 0;
	if (g_once_init_enter (&single_photo_page_update_reason_type_id__once)) {
		GType single_photo_page_update_reason_type_id;
		single_photo_page_update_reason_type_id = single_photo_page_update_reason_get_type_once ();
		g_once_init_leave (&single_photo_page_update_reason_type_id__once, single_photo_page_update_reason_type_id);
	}
	return single_photo_page_update_reason_type_id__once;
}

SinglePhotoPage*
single_photo_page_construct (GType object_type,
                             const gchar* page_name,
                             gboolean scale_up_to_viewport)
{
	SinglePhotoPage * self = NULL;
#line 50 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (page_name != NULL, NULL);
#line 51 "../src/Views/SinglePhotoPage.vala"
	self = (SinglePhotoPage*) g_object_new (object_type, "page-name", page_name, "scale-up-to-viewport", scale_up_to_viewport, NULL);
#line 50 "../src/Views/SinglePhotoPage.vala"
	return self;
#line 199 "SinglePhotoPage.c"
}

gboolean
single_photo_page_is_transition_in_progress (SinglePhotoPage* self)
{
	TransitionClock* _tmp0_;
	gboolean result;
#line 85 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->transition_clock;
#line 86 "../src/Views/SinglePhotoPage.vala"
	result = transition_clock_is_in_progress (_tmp0_);
#line 86 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 215 "SinglePhotoPage.c"
}

static void
single_photo_page_cancel_transition (SinglePhotoPage* self)
{
	TransitionClock* _tmp0_;
#line 89 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->transition_clock;
#line 90 "../src/Views/SinglePhotoPage.vala"
	if (transition_clock_is_in_progress (_tmp0_)) {
#line 228 "SinglePhotoPage.c"
		TransitionClock* _tmp1_;
#line 91 "../src/Views/SinglePhotoPage.vala"
		_tmp1_ = self->priv->transition_clock;
#line 91 "../src/Views/SinglePhotoPage.vala"
		transition_clock_cancel (_tmp1_);
#line 234 "SinglePhotoPage.c"
	}
}

void
single_photo_page_set_transition (SinglePhotoPage* self,
                                  const gchar* effect_id,
                                  gint duration_msec)
{
	TransitionEffectsManager* _tmp0_;
	TransitionEffectsManager* _tmp1_;
	TransitionClock* _tmp2_;
	TransitionClock* _tmp3_;
#line 94 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (effect_id != NULL);
#line 95 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_cancel_transition (self);
#line 97 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = transition_effects_manager_get_instance ();
#line 97 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _tmp0_;
#line 97 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = transition_effects_manager_create_transition_clock (_tmp1_, effect_id);
#line 97 "../src/Views/SinglePhotoPage.vala"
	_transition_clock_unref0 (self->priv->transition_clock);
#line 97 "../src/Views/SinglePhotoPage.vala"
	self->priv->transition_clock = _tmp2_;
#line 97 "../src/Views/SinglePhotoPage.vala"
	_transition_effects_manager_unref0 (_tmp1_);
#line 98 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = self->priv->transition_clock;
#line 98 "../src/Views/SinglePhotoPage.vala"
	if (_tmp3_ == NULL) {
#line 269 "SinglePhotoPage.c"
		TransitionEffectsManager* _tmp4_;
		TransitionEffectsManager* _tmp5_;
		TransitionClock* _tmp6_;
#line 99 "../src/Views/SinglePhotoPage.vala"
		_tmp4_ = transition_effects_manager_get_instance ();
#line 99 "../src/Views/SinglePhotoPage.vala"
		_tmp5_ = _tmp4_;
#line 99 "../src/Views/SinglePhotoPage.vala"
		_tmp6_ = transition_effects_manager_create_null_transition_clock (_tmp5_);
#line 99 "../src/Views/SinglePhotoPage.vala"
		_transition_clock_unref0 (self->priv->transition_clock);
#line 99 "../src/Views/SinglePhotoPage.vala"
		self->priv->transition_clock = _tmp6_;
#line 99 "../src/Views/SinglePhotoPage.vala"
		_transition_effects_manager_unref0 (_tmp5_);
#line 285 "SinglePhotoPage.c"
	}
#line 101 "../src/Views/SinglePhotoPage.vala"
	self->priv->transition_duration_msec = duration_msec;
#line 289 "SinglePhotoPage.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 112 "../src/Views/SinglePhotoPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 297 "SinglePhotoPage.c"
}

static void
single_photo_page_render_zoomed_to_pixmap (SinglePhotoPage* self,
                                           ZoomState* zoom_state)
{
	GdkRectangle view_rect = {0};
	GdkRectangle _tmp0_ = {0};
	GdkPixbuf* zoomed = NULL;
	ZoomBuffer* _tmp1_;
	ZoomBuffer* _tmp2_;
	gboolean _tmp3_;
	GdkPixbuf* _tmp26_;
	gint draw_x = 0;
	Dimensions _tmp27_;
	GdkRectangle _tmp28_;
	gint draw_y = 0;
	Dimensions _tmp29_;
	GdkRectangle _tmp30_;
	cairo_t* _tmp31_;
	GdkPixbuf* _tmp32_;
	cairo_t* _tmp33_;
#line 105 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (zoom_state != NULL);
#line 106 "../src/Views/SinglePhotoPage.vala"
	_vala_assert (single_photo_page_is_zoom_supported (self), "is_zoom_supported ()");
#line 108 "../src/Views/SinglePhotoPage.vala"
	zoom_state_get_viewing_rectangle_wrt_content (zoom_state, &_tmp0_);
#line 108 "../src/Views/SinglePhotoPage.vala"
	view_rect = _tmp0_;
#line 111 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = single_photo_page_get_zoom_buffer (self);
#line 111 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = _tmp1_;
#line 111 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 111 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (_tmp2_);
#line 111 "../src/Views/SinglePhotoPage.vala"
	if (_tmp3_) {
#line 340 "SinglePhotoPage.c"
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp13_;
#line 112 "../src/Views/SinglePhotoPage.vala"
		if (self->priv->zoom_high_quality) {
#line 345 "SinglePhotoPage.c"
			ZoomBuffer* _tmp5_;
			ZoomBuffer* _tmp6_;
			ZoomState _tmp7_;
			GdkPixbuf* _tmp8_;
#line 112 "../src/Views/SinglePhotoPage.vala"
			_tmp5_ = single_photo_page_get_zoom_buffer (self);
#line 112 "../src/Views/SinglePhotoPage.vala"
			_tmp6_ = _tmp5_;
#line 112 "../src/Views/SinglePhotoPage.vala"
			_tmp7_ = *zoom_state;
#line 112 "../src/Views/SinglePhotoPage.vala"
			_tmp8_ = zoom_buffer_get_zoomed_image (_tmp6_, &_tmp7_);
#line 112 "../src/Views/SinglePhotoPage.vala"
			_g_object_unref0 (_tmp4_);
#line 112 "../src/Views/SinglePhotoPage.vala"
			_tmp4_ = _tmp8_;
#line 112 "../src/Views/SinglePhotoPage.vala"
			_g_object_unref0 (_tmp6_);
#line 364 "SinglePhotoPage.c"
		} else {
			ZoomBuffer* _tmp9_;
			ZoomBuffer* _tmp10_;
			ZoomState _tmp11_;
			GdkPixbuf* _tmp12_;
#line 113 "../src/Views/SinglePhotoPage.vala"
			_tmp9_ = single_photo_page_get_zoom_buffer (self);
#line 113 "../src/Views/SinglePhotoPage.vala"
			_tmp10_ = _tmp9_;
#line 113 "../src/Views/SinglePhotoPage.vala"
			_tmp11_ = *zoom_state;
#line 113 "../src/Views/SinglePhotoPage.vala"
			_tmp12_ = zoom_buffer_get_zoom_preview_image (_tmp10_, &_tmp11_);
#line 113 "../src/Views/SinglePhotoPage.vala"
			_g_object_unref0 (_tmp4_);
#line 113 "../src/Views/SinglePhotoPage.vala"
			_tmp4_ = _tmp12_;
#line 113 "../src/Views/SinglePhotoPage.vala"
			_g_object_unref0 (_tmp10_);
#line 384 "SinglePhotoPage.c"
		}
#line 112 "../src/Views/SinglePhotoPage.vala"
		_tmp13_ = _g_object_ref0 (_tmp4_);
#line 112 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (zoomed);
#line 112 "../src/Views/SinglePhotoPage.vala"
		zoomed = _tmp13_;
#line 111 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (_tmp4_);
#line 394 "SinglePhotoPage.c"
	} else {
		GdkRectangle view_rect_proj = {0};
		GdkPixbuf* _tmp14_;
		GdkRectangle _tmp15_ = {0};
		GdkPixbuf* proj_subpixbuf = NULL;
		GdkPixbuf* _tmp16_;
		GdkRectangle _tmp17_;
		GdkRectangle _tmp18_;
		GdkRectangle _tmp19_;
		GdkRectangle _tmp20_;
		GdkPixbuf* _tmp21_;
		GdkPixbuf* _tmp22_;
		GdkRectangle _tmp23_;
		GdkRectangle _tmp24_;
		GdkPixbuf* _tmp25_;
#line 115 "../src/Views/SinglePhotoPage.vala"
		_tmp14_ = self->priv->unscaled;
#line 115 "../src/Views/SinglePhotoPage.vala"
		zoom_state_get_viewing_rectangle_projection (zoom_state, _tmp14_, &_tmp15_);
#line 115 "../src/Views/SinglePhotoPage.vala"
		view_rect_proj = _tmp15_;
#line 117 "../src/Views/SinglePhotoPage.vala"
		_tmp16_ = self->priv->unscaled;
#line 117 "../src/Views/SinglePhotoPage.vala"
		_tmp17_ = view_rect_proj;
#line 117 "../src/Views/SinglePhotoPage.vala"
		_tmp18_ = view_rect_proj;
#line 117 "../src/Views/SinglePhotoPage.vala"
		_tmp19_ = view_rect_proj;
#line 117 "../src/Views/SinglePhotoPage.vala"
		_tmp20_ = view_rect_proj;
#line 117 "../src/Views/SinglePhotoPage.vala"
		_tmp21_ = gdk_pixbuf_new_subpixbuf (_tmp16_, _tmp17_.x, _tmp18_.y, _tmp19_.width, _tmp20_.height);
#line 117 "../src/Views/SinglePhotoPage.vala"
		proj_subpixbuf = _tmp21_;
#line 120 "../src/Views/SinglePhotoPage.vala"
		_tmp22_ = proj_subpixbuf;
#line 120 "../src/Views/SinglePhotoPage.vala"
		_tmp23_ = view_rect;
#line 120 "../src/Views/SinglePhotoPage.vala"
		_tmp24_ = view_rect;
#line 120 "../src/Views/SinglePhotoPage.vala"
		_tmp25_ = gdk_pixbuf_scale_simple (_tmp22_, _tmp23_.width, _tmp24_.height, GDK_INTERP_BILINEAR);
#line 120 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (zoomed);
#line 120 "../src/Views/SinglePhotoPage.vala"
		zoomed = _tmp25_;
#line 111 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (proj_subpixbuf);
#line 444 "SinglePhotoPage.c"
	}
#line 124 "../src/Views/SinglePhotoPage.vala"
	_tmp26_ = zoomed;
#line 124 "../src/Views/SinglePhotoPage.vala"
	if (_tmp26_ == NULL) {
#line 125 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (zoomed);
#line 125 "../src/Views/SinglePhotoPage.vala"
		return;
#line 454 "SinglePhotoPage.c"
	}
#line 128 "../src/Views/SinglePhotoPage.vala"
	_tmp27_ = self->priv->pixmap_dim;
#line 128 "../src/Views/SinglePhotoPage.vala"
	_tmp28_ = view_rect;
#line 128 "../src/Views/SinglePhotoPage.vala"
	draw_x = (_tmp27_.width - _tmp28_.width) / 2;
#line 129 "../src/Views/SinglePhotoPage.vala"
	draw_x = CLAMP (draw_x, 0, G_MAXINT);
#line 131 "../src/Views/SinglePhotoPage.vala"
	_tmp29_ = self->priv->pixmap_dim;
#line 131 "../src/Views/SinglePhotoPage.vala"
	_tmp30_ = view_rect;
#line 131 "../src/Views/SinglePhotoPage.vala"
	draw_y = (_tmp29_.height - _tmp30_.height) / 2;
#line 132 "../src/Views/SinglePhotoPage.vala"
	draw_y = CLAMP (draw_y, 0, G_MAXINT);
#line 134 "../src/Views/SinglePhotoPage.vala"
	_tmp31_ = self->priv->pixmap_ctx;
#line 134 "../src/Views/SinglePhotoPage.vala"
	_tmp32_ = zoomed;
#line 134 "../src/Views/SinglePhotoPage.vala"
	gdk_cairo_set_source_pixbuf (_tmp31_, _tmp32_, (gdouble) draw_x, (gdouble) draw_y);
#line 135 "../src/Views/SinglePhotoPage.vala"
	_tmp33_ = self->priv->pixmap_ctx;
#line 135 "../src/Views/SinglePhotoPage.vala"
	cairo_paint (_tmp33_);
#line 105 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (zoomed);
#line 484 "SinglePhotoPage.c"
}

void
single_photo_page_on_interactive_pan (SinglePhotoPage* self,
                                      ZoomState* interactive_zoom_state)
{
	cairo_t* canvas_ctx = NULL;
	GtkDrawingArea* _tmp0_;
	GdkWindow* _tmp1_;
	cairo_t* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkStyleContext* _tmp4_;
	cairo_t* _tmp5_;
	Dimensions _tmp6_;
	Dimensions _tmp7_;
	gboolean old_quality_setting = FALSE;
	ZoomState _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	cairo_surface_t* _tmp13_;
#line 138 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (interactive_zoom_state != NULL);
#line 139 "../src/Views/SinglePhotoPage.vala"
	_vala_assert (single_photo_page_is_zoom_supported (self), "is_zoom_supported ()");
#line 140 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->canvas;
#line 140 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) _tmp0_);
#line 140 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = gdk_cairo_create (_tmp1_);
#line 140 "../src/Views/SinglePhotoPage.vala"
	canvas_ctx = _tmp2_;
#line 142 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = self->canvas;
#line 142 "../src/Views/SinglePhotoPage.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 142 "../src/Views/SinglePhotoPage.vala"
	_tmp5_ = self->priv->pixmap_ctx;
#line 142 "../src/Views/SinglePhotoPage.vala"
	_tmp6_ = self->priv->pixmap_dim;
#line 142 "../src/Views/SinglePhotoPage.vala"
	_tmp7_ = self->priv->pixmap_dim;
#line 142 "../src/Views/SinglePhotoPage.vala"
	gtk_render_background (_tmp4_, _tmp5_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp6_.width, (gdouble) _tmp7_.height);
#line 144 "../src/Views/SinglePhotoPage.vala"
	old_quality_setting = self->priv->zoom_high_quality;
#line 145 "../src/Views/SinglePhotoPage.vala"
	self->priv->zoom_high_quality = TRUE;
#line 146 "../src/Views/SinglePhotoPage.vala"
	_tmp8_ = *interactive_zoom_state;
#line 146 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_render_zoomed_to_pixmap (self, &_tmp8_);
#line 147 "../src/Views/SinglePhotoPage.vala"
	self->priv->zoom_high_quality = old_quality_setting;
#line 149 "../src/Views/SinglePhotoPage.vala"
	cairo_save (canvas_ctx);
#line 150 "../src/Views/SinglePhotoPage.vala"
	_tmp9_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 150 "../src/Views/SinglePhotoPage.vala"
	_tmp10_ = _tmp9_;
#line 150 "../src/Views/SinglePhotoPage.vala"
	_tmp11_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 150 "../src/Views/SinglePhotoPage.vala"
	_tmp12_ = _tmp11_;
#line 150 "../src/Views/SinglePhotoPage.vala"
	cairo_scale (canvas_ctx, (gdouble) (1.0f / _tmp10_), (gdouble) (1.0f / _tmp12_));
#line 151 "../src/Views/SinglePhotoPage.vala"
	_tmp13_ = self->priv->pixmap;
#line 151 "../src/Views/SinglePhotoPage.vala"
	cairo_set_source_surface (canvas_ctx, _tmp13_, (gdouble) 0, (gdouble) 0);
#line 152 "../src/Views/SinglePhotoPage.vala"
	cairo_paint (canvas_ctx);
#line 153 "../src/Views/SinglePhotoPage.vala"
	cairo_restore (canvas_ctx);
#line 138 "../src/Views/SinglePhotoPage.vala"
	_cairo_destroy0 (canvas_ctx);
#line 565 "SinglePhotoPage.c"
}

static gboolean
single_photo_page_real_is_zoom_supported (SinglePhotoPage* self)
{
	gboolean result;
#line 157 "../src/Views/SinglePhotoPage.vala"
	result = FALSE;
#line 157 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 576 "SinglePhotoPage.c"
}

gboolean
single_photo_page_is_zoom_supported (SinglePhotoPage* self)
{
	SinglePhotoPageClass* _klass_;
#line 156 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 156 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->is_zoom_supported) {
#line 156 "../src/Views/SinglePhotoPage.vala"
		return _klass_->is_zoom_supported (self);
#line 591 "SinglePhotoPage.c"
	}
#line 156 "../src/Views/SinglePhotoPage.vala"
	return FALSE;
#line 595 "SinglePhotoPage.c"
}

static void
single_photo_page_real_cancel_zoom (SinglePhotoPage* self)
{
	cairo_surface_t* _tmp0_;
#line 161 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->pixmap;
#line 161 "../src/Views/SinglePhotoPage.vala"
	if (_tmp0_ != NULL) {
#line 606 "SinglePhotoPage.c"
		GtkDrawingArea* _tmp1_;
		GtkStyleContext* _tmp2_;
		cairo_t* _tmp3_;
		Dimensions _tmp4_;
		Dimensions _tmp5_;
#line 162 "../src/Views/SinglePhotoPage.vala"
		_tmp1_ = self->canvas;
#line 162 "../src/Views/SinglePhotoPage.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 162 "../src/Views/SinglePhotoPage.vala"
		_tmp3_ = self->priv->pixmap_ctx;
#line 162 "../src/Views/SinglePhotoPage.vala"
		_tmp4_ = self->priv->pixmap_dim;
#line 162 "../src/Views/SinglePhotoPage.vala"
		_tmp5_ = self->priv->pixmap_dim;
#line 162 "../src/Views/SinglePhotoPage.vala"
		gtk_render_background (_tmp2_, _tmp3_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp4_.width, (gdouble) _tmp5_.height);
#line 624 "SinglePhotoPage.c"
	}
}

void
single_photo_page_cancel_zoom (SinglePhotoPage* self)
{
	SinglePhotoPageClass* _klass_;
#line 160 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 160 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->cancel_zoom) {
#line 160 "../src/Views/SinglePhotoPage.vala"
		_klass_->cancel_zoom (self);
#line 640 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_real_save_zoom_state (SinglePhotoPage* self)
{
	ZoomState _tmp0_;
#line 167 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->static_zoom_state;
#line 167 "../src/Views/SinglePhotoPage.vala"
	self->priv->saved_zoom_state = _tmp0_;
#line 168 "../src/Views/SinglePhotoPage.vala"
	self->priv->has_saved_zoom_state = TRUE;
#line 654 "SinglePhotoPage.c"
}

void
single_photo_page_save_zoom_state (SinglePhotoPage* self)
{
	SinglePhotoPageClass* _klass_;
#line 166 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 166 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->save_zoom_state) {
#line 166 "../src/Views/SinglePhotoPage.vala"
		_klass_->save_zoom_state (self);
#line 669 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_real_restore_zoom_state (SinglePhotoPage* self)
{
	ZoomState _tmp0_;
#line 172 "../src/Views/SinglePhotoPage.vala"
	if (!self->priv->has_saved_zoom_state) {
#line 173 "../src/Views/SinglePhotoPage.vala"
		return;
#line 681 "SinglePhotoPage.c"
	}
#line 175 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->saved_zoom_state;
#line 175 "../src/Views/SinglePhotoPage.vala"
	self->priv->static_zoom_state = _tmp0_;
#line 176 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_repaint (self, NULL);
#line 177 "../src/Views/SinglePhotoPage.vala"
	self->priv->has_saved_zoom_state = FALSE;
#line 691 "SinglePhotoPage.c"
}

void
single_photo_page_restore_zoom_state (SinglePhotoPage* self)
{
	SinglePhotoPageClass* _klass_;
#line 171 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 171 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->restore_zoom_state) {
#line 171 "../src/Views/SinglePhotoPage.vala"
		_klass_->restore_zoom_state (self);
#line 706 "SinglePhotoPage.c"
	}
}

static ZoomBuffer*
single_photo_page_real_get_zoom_buffer (SinglePhotoPage* self)
{
	ZoomBuffer* result;
#line 181 "../src/Views/SinglePhotoPage.vala"
	result = NULL;
#line 181 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 718 "SinglePhotoPage.c"
}

ZoomBuffer*
single_photo_page_get_zoom_buffer (SinglePhotoPage* self)
{
	SinglePhotoPageClass* _klass_;
#line 180 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 180 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 180 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->get_zoom_buffer) {
#line 180 "../src/Views/SinglePhotoPage.vala"
		return _klass_->get_zoom_buffer (self);
#line 733 "SinglePhotoPage.c"
	}
#line 180 "../src/Views/SinglePhotoPage.vala"
	return NULL;
#line 737 "SinglePhotoPage.c"
}

void
single_photo_page_get_saved_zoom_state (SinglePhotoPage* self,
                                        ZoomState* result)
{
	ZoomState _tmp0_;
#line 184 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 185 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->saved_zoom_state;
#line 185 "../src/Views/SinglePhotoPage.vala"
	*result = _tmp0_;
#line 185 "../src/Views/SinglePhotoPage.vala"
	return;
#line 753 "SinglePhotoPage.c"
}

void
single_photo_page_set_zoom_state (SinglePhotoPage* self,
                                  ZoomState* zoom_state)
{
	ZoomState _tmp0_;
#line 188 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (zoom_state != NULL);
#line 189 "../src/Views/SinglePhotoPage.vala"
	_vala_assert (single_photo_page_is_zoom_supported (self), "is_zoom_supported ()");
#line 191 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = *zoom_state;
#line 191 "../src/Views/SinglePhotoPage.vala"
	self->priv->static_zoom_state = _tmp0_;
#line 771 "SinglePhotoPage.c"
}

void
single_photo_page_get_zoom_state (SinglePhotoPage* self,
                                  ZoomState* result)
{
	ZoomState _tmp0_;
#line 194 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Views/SinglePhotoPage.vala"
	_vala_assert (single_photo_page_is_zoom_supported (self), "is_zoom_supported ()");
#line 197 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->static_zoom_state;
#line 197 "../src/Views/SinglePhotoPage.vala"
	*result = _tmp0_;
#line 197 "../src/Views/SinglePhotoPage.vala"
	return;
#line 789 "SinglePhotoPage.c"
}

static void
single_photo_page_real_switched_to (Page* base)
{
	SinglePhotoPage * self;
	GdkPixbuf* _tmp0_;
#line 200 "../src/Views/SinglePhotoPage.vala"
	self = (SinglePhotoPage*) base;
#line 201 "../src/Views/SinglePhotoPage.vala"
	PAGE_CLASS (single_photo_page_parent_class)->switched_to (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE, Page));
#line 203 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->unscaled;
#line 203 "../src/Views/SinglePhotoPage.vala"
	if (_tmp0_ != NULL) {
#line 204 "../src/Views/SinglePhotoPage.vala"
		single_photo_page_repaint (self, NULL);
#line 807 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_real_set_container (Page* base,
                                      GtkWindow* container)
{
	SinglePhotoPage * self;
#line 207 "../src/Views/SinglePhotoPage.vala"
	self = (SinglePhotoPage*) base;
#line 207 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (container != NULL);
#line 208 "../src/Views/SinglePhotoPage.vala"
	PAGE_CLASS (single_photo_page_parent_class)->set_container (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE, Page), container);
#line 212 "../src/Views/SinglePhotoPage.vala"
	if (IS_FULLSCREEN_WINDOW (container)) {
#line 213 "../src/Views/SinglePhotoPage.vala"
		gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 826 "SinglePhotoPage.c"
	}
}

void
single_photo_page_set_pixbuf (SinglePhotoPage* self,
                              GdkPixbuf* unscaled,
                              Dimensions* max_dim,
                              Direction* direction)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_;
	GdkPoint _tmp2_ = {0};
	GdkPixbuf* _tmp3_;
	Dimensions _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
	GtkDrawingArea* _tmp7_;
#line 220 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (unscaled != NULL);
#line 220 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (max_dim != NULL);
#line 221 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = *max_dim;
#line 221 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = self->priv->pixmap_dim;
#line 221 "../src/Views/SinglePhotoPage.vala"
	zoom_state_get_viewport_center (&self->priv->static_zoom_state, &_tmp2_);
#line 221 "../src/Views/SinglePhotoPage.vala"
	zoom_state_init (&self->priv->static_zoom_state, &_tmp0_, &_tmp1_, zoom_state_get_interpolation_factor (&self->priv->static_zoom_state), &_tmp2_);
#line 225 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_cancel_transition (self);
#line 227 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = _g_object_ref0 (unscaled);
#line 227 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->unscaled);
#line 227 "../src/Views/SinglePhotoPage.vala"
	self->priv->unscaled = _tmp3_;
#line 228 "../src/Views/SinglePhotoPage.vala"
	_tmp4_ = *max_dim;
#line 228 "../src/Views/SinglePhotoPage.vala"
	self->priv->max_dim = _tmp4_;
#line 229 "../src/Views/SinglePhotoPage.vala"
	_tmp5_ = self->priv->scaled;
#line 229 "../src/Views/SinglePhotoPage.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 229 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->old_scaled);
#line 229 "../src/Views/SinglePhotoPage.vala"
	self->priv->old_scaled = _tmp6_;
#line 230 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->scaled);
#line 230 "../src/Views/SinglePhotoPage.vala"
	self->priv->scaled = NULL;
#line 233 "../src/Views/SinglePhotoPage.vala"
	_tmp7_ = self->canvas;
#line 233 "../src/Views/SinglePhotoPage.vala"
	gtk_widget_realize ((GtkWidget*) _tmp7_);
#line 235 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_repaint (self, direction);
#line 888 "SinglePhotoPage.c"
}

void
single_photo_page_blank_display (SinglePhotoPage* self)
{
	GtkDrawingArea* _tmp0_;
#line 238 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->unscaled);
#line 239 "../src/Views/SinglePhotoPage.vala"
	self->priv->unscaled = NULL;
#line 240 "../src/Views/SinglePhotoPage.vala"
	dimensions_init (&self->priv->max_dim, 0, 0);
#line 241 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->scaled);
#line 241 "../src/Views/SinglePhotoPage.vala"
	self->priv->scaled = NULL;
#line 242 "../src/Views/SinglePhotoPage.vala"
	_cairo_surface_destroy0 (self->priv->pixmap);
#line 242 "../src/Views/SinglePhotoPage.vala"
	self->priv->pixmap = NULL;
#line 245 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->canvas;
#line 245 "../src/Views/SinglePhotoPage.vala"
	gtk_widget_realize ((GtkWidget*) _tmp0_);
#line 248 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_invalidate_all (self);
#line 917 "SinglePhotoPage.c"
}

void
single_photo_page_get_surface_dim (SinglePhotoPage* self,
                                   Dimensions* result)
{
	Dimensions _tmp0_;
#line 251 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->pixmap_dim;
#line 252 "../src/Views/SinglePhotoPage.vala"
	*result = _tmp0_;
#line 252 "../src/Views/SinglePhotoPage.vala"
	return;
#line 933 "SinglePhotoPage.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 256 "../src/Views/SinglePhotoPage.vala"
	return self ? cairo_reference (self) : NULL;
#line 941 "SinglePhotoPage.c"
}

cairo_t*
single_photo_page_get_cairo_context (SinglePhotoPage* self)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* result;
#line 255 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->pixmap_ctx;
#line 256 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _cairo_reference0 (_tmp0_);
#line 256 "../src/Views/SinglePhotoPage.vala"
	result = _tmp1_;
#line 256 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 960 "SinglePhotoPage.c"
}

void
single_photo_page_paint_text (SinglePhotoPage* self,
                              PangoLayout* pango_layout,
                              gint x,
                              gint y)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
#line 259 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 259 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (pango_layout != NULL);
#line 260 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->text_ctx;
#line 260 "../src/Views/SinglePhotoPage.vala"
	cairo_move_to (_tmp0_, (gdouble) x, (gdouble) y);
#line 261 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = self->priv->text_ctx;
#line 261 "../src/Views/SinglePhotoPage.vala"
	pango_cairo_show_layout (_tmp1_, pango_layout);
#line 983 "SinglePhotoPage.c"
}

void
single_photo_page_get_canvas_scaling (SinglePhotoPage* self,
                                      Scaling* result)
{
	Scaling _tmp0_ = {0};
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	gboolean _tmp3_;
#line 264 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = page_get_container ((Page*) self);
#line 265 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = _tmp1_;
#line 265 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = IS_FULLSCREEN_WINDOW (_tmp2_);
#line 265 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (_tmp2_);
#line 265 "../src/Views/SinglePhotoPage.vala"
	if (_tmp3_) {
#line 1006 "SinglePhotoPage.c"
		AppWindow* _tmp4_;
		AppWindow* _tmp5_;
		gboolean _tmp6_;
		Scaling _tmp7_ = {0};
#line 265 "../src/Views/SinglePhotoPage.vala"
		_tmp4_ = app_window_get_instance ();
#line 265 "../src/Views/SinglePhotoPage.vala"
		_tmp5_ = _tmp4_;
#line 265 "../src/Views/SinglePhotoPage.vala"
		_tmp6_ = self->priv->_scale_up_to_viewport;
#line 265 "../src/Views/SinglePhotoPage.vala"
		scaling_for_screen ((GtkWindow*) _tmp5_, _tmp6_, &_tmp7_);
#line 265 "../src/Views/SinglePhotoPage.vala"
		_tmp0_ = _tmp7_;
#line 265 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (_tmp5_);
#line 1023 "SinglePhotoPage.c"
	} else {
		GtkViewport* _tmp8_;
		gboolean _tmp9_;
		Scaling _tmp10_ = {0};
#line 266 "../src/Views/SinglePhotoPage.vala"
		_tmp8_ = self->viewport;
#line 266 "../src/Views/SinglePhotoPage.vala"
		_tmp9_ = self->priv->_scale_up_to_viewport;
#line 266 "../src/Views/SinglePhotoPage.vala"
		scaling_for_widget ((GtkWidget*) _tmp8_, _tmp9_, &_tmp10_);
#line 266 "../src/Views/SinglePhotoPage.vala"
		_tmp0_ = _tmp10_;
#line 1036 "SinglePhotoPage.c"
	}
#line 265 "../src/Views/SinglePhotoPage.vala"
	*result = _tmp0_;
#line 265 "../src/Views/SinglePhotoPage.vala"
	return;
#line 1042 "SinglePhotoPage.c"
}

GdkPixbuf*
single_photo_page_get_unscaled_pixbuf (SinglePhotoPage* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* result;
#line 269 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 270 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->unscaled;
#line 270 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 270 "../src/Views/SinglePhotoPage.vala"
	result = _tmp1_;
#line 270 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 1061 "SinglePhotoPage.c"
}

GdkPixbuf*
single_photo_page_get_scaled_pixbuf (SinglePhotoPage* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* result;
#line 273 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 274 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->scaled;
#line 274 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 274 "../src/Views/SinglePhotoPage.vala"
	result = _tmp1_;
#line 274 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 1080 "SinglePhotoPage.c"
}

void
single_photo_page_get_scaled_pixbuf_position (SinglePhotoPage* self,
                                              GdkRectangle* result)
{
	GdkRectangle _tmp0_;
#line 278 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->scaled_pos;
#line 279 "../src/Views/SinglePhotoPage.vala"
	*result = _tmp0_;
#line 279 "../src/Views/SinglePhotoPage.vala"
	return;
#line 1096 "SinglePhotoPage.c"
}

gboolean
single_photo_page_is_inside_pixbuf (SinglePhotoPage* self,
                                    gint x,
                                    gint y)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gboolean result;
#line 282 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 283 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 283 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _tmp0_;
#line 283 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 283 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = _tmp2_;
#line 283 "../src/Views/SinglePhotoPage.vala"
	_tmp4_ = self->priv->scaled_pos;
#line 283 "../src/Views/SinglePhotoPage.vala"
	result = coord_in_rectangle (x * _tmp1_, y * _tmp3_, &_tmp4_);
#line 283 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 1126 "SinglePhotoPage.c"
}

static void
single_photo_page_invalidate_all (SinglePhotoPage* self)
{
	GtkDrawingArea* _tmp0_;
	GdkWindow* _tmp1_;
#line 286 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->canvas;
#line 287 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) _tmp0_);
#line 287 "../src/Views/SinglePhotoPage.vala"
	if (_tmp1_ != NULL) {
#line 1142 "SinglePhotoPage.c"
		GtkDrawingArea* _tmp2_;
		GdkWindow* _tmp3_;
#line 288 "../src/Views/SinglePhotoPage.vala"
		_tmp2_ = self->canvas;
#line 288 "../src/Views/SinglePhotoPage.vala"
		_tmp3_ = gtk_widget_get_window ((GtkWidget*) _tmp2_);
#line 288 "../src/Views/SinglePhotoPage.vala"
		gdk_window_invalidate_rect (_tmp3_, NULL, FALSE);
#line 1151 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_on_viewport_resize (SinglePhotoPage* self)
{
#line 291 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_internal_repaint (self, TRUE, NULL);
#line 1162 "SinglePhotoPage.c"
}

static void
single_photo_page_real_on_resize_finished (Page* base,
                                           GdkRectangle* rect)
{
	SinglePhotoPage * self;
	GdkRectangle _tmp0_;
#line 296 "../src/Views/SinglePhotoPage.vala"
	self = (SinglePhotoPage*) base;
#line 296 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (rect != NULL);
#line 297 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = *rect;
#line 297 "../src/Views/SinglePhotoPage.vala"
	PAGE_CLASS (single_photo_page_parent_class)->on_resize_finished (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE, Page), &_tmp0_);
#line 300 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_repaint (self, NULL);
#line 1181 "SinglePhotoPage.c"
}

static gboolean
single_photo_page_on_canvas_exposed (SinglePhotoPage* self,
                                     cairo_t* exposed_ctx)
{
	cairo_surface_t* _tmp0_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gboolean result;
#line 303 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 303 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (exposed_ctx != NULL, FALSE);
#line 306 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->pixmap;
#line 306 "../src/Views/SinglePhotoPage.vala"
	if (_tmp0_ != NULL) {
#line 1202 "SinglePhotoPage.c"
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		cairo_surface_t* _tmp5_;
#line 307 "../src/Views/SinglePhotoPage.vala"
		cairo_save (exposed_ctx);
#line 308 "../src/Views/SinglePhotoPage.vala"
		_tmp1_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 308 "../src/Views/SinglePhotoPage.vala"
		_tmp2_ = _tmp1_;
#line 308 "../src/Views/SinglePhotoPage.vala"
		_tmp3_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 308 "../src/Views/SinglePhotoPage.vala"
		_tmp4_ = _tmp3_;
#line 308 "../src/Views/SinglePhotoPage.vala"
		cairo_scale (exposed_ctx, (gdouble) (1.0f / _tmp2_), (gdouble) (1.0f / _tmp4_));
#line 309 "../src/Views/SinglePhotoPage.vala"
		_tmp5_ = self->priv->pixmap;
#line 309 "../src/Views/SinglePhotoPage.vala"
		cairo_set_source_surface (exposed_ctx, _tmp5_, (gdouble) 0, (gdouble) 0);
#line 1224 "SinglePhotoPage.c"
	} else {
		GtkDrawingArea* _tmp6_;
		GtkStyleContext* _tmp7_;
#line 311 "../src/Views/SinglePhotoPage.vala"
		_tmp6_ = self->canvas;
#line 311 "../src/Views/SinglePhotoPage.vala"
		_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
#line 311 "../src/Views/SinglePhotoPage.vala"
		gtk_render_background (_tmp7_, exposed_ctx, (gdouble) 0, (gdouble) 0, (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self), (gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 1234 "SinglePhotoPage.c"
	}
#line 314 "../src/Views/SinglePhotoPage.vala"
	_tmp8_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 314 "../src/Views/SinglePhotoPage.vala"
	_tmp9_ = _tmp8_;
#line 314 "../src/Views/SinglePhotoPage.vala"
	_tmp10_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 314 "../src/Views/SinglePhotoPage.vala"
	_tmp11_ = _tmp10_;
#line 314 "../src/Views/SinglePhotoPage.vala"
	cairo_rectangle (exposed_ctx, (gdouble) 0, (gdouble) 0, (gdouble) (gtk_widget_get_allocated_width ((GtkWidget*) self) * _tmp9_), (gdouble) (gtk_widget_get_allocated_height ((GtkWidget*) self) * _tmp11_));
#line 315 "../src/Views/SinglePhotoPage.vala"
	cairo_paint (exposed_ctx);
#line 316 "../src/Views/SinglePhotoPage.vala"
	cairo_restore (exposed_ctx);
#line 318 "../src/Views/SinglePhotoPage.vala"
	result = TRUE;
#line 318 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 1254 "SinglePhotoPage.c"
}

static void
single_photo_page_real_new_surface (SinglePhotoPage* self,
                                    cairo_t* ctx,
                                    Dimensions* ctx_dim)
{
#line 321 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (ctx != NULL);
#line 321 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (ctx_dim != NULL);
#line 1266 "SinglePhotoPage.c"
}

void
single_photo_page_new_surface (SinglePhotoPage* self,
                               cairo_t* ctx,
                               Dimensions* ctx_dim)
{
	SinglePhotoPageClass* _klass_;
#line 321 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 321 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->new_surface) {
#line 321 "../src/Views/SinglePhotoPage.vala"
		_klass_->new_surface (self, ctx, ctx_dim);
#line 1283 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_real_updated_pixbuf (SinglePhotoPage* self,
                                       GdkPixbuf* pixbuf,
                                       SinglePhotoPageUpdateReason reason,
                                       Dimensions* old_dim)
{
#line 324 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (pixbuf != NULL);
#line 324 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (old_dim != NULL);
#line 1297 "SinglePhotoPage.c"
}

void
single_photo_page_updated_pixbuf (SinglePhotoPage* self,
                                  GdkPixbuf* pixbuf,
                                  SinglePhotoPageUpdateReason reason,
                                  Dimensions* old_dim)
{
	SinglePhotoPageClass* _klass_;
#line 324 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 324 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->updated_pixbuf) {
#line 324 "../src/Views/SinglePhotoPage.vala"
		_klass_->updated_pixbuf (self, pixbuf, reason, old_dim);
#line 1315 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_real_paint (SinglePhotoPage* self,
                              cairo_t* ctx,
                              Dimensions* ctx_dim)
{
	gboolean _tmp0_ = FALSE;
#line 327 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (ctx != NULL);
#line 327 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (ctx_dim != NULL);
#line 328 "../src/Views/SinglePhotoPage.vala"
	if (single_photo_page_is_zoom_supported (self)) {
#line 328 "../src/Views/SinglePhotoPage.vala"
		_tmp0_ = !zoom_state_is_default (&self->priv->static_zoom_state);
#line 1333 "SinglePhotoPage.c"
	} else {
#line 328 "../src/Views/SinglePhotoPage.vala"
		_tmp0_ = FALSE;
#line 1337 "SinglePhotoPage.c"
	}
#line 328 "../src/Views/SinglePhotoPage.vala"
	if (_tmp0_) {
#line 1341 "SinglePhotoPage.c"
		GtkDrawingArea* _tmp1_;
		GtkStyleContext* _tmp2_;
		Dimensions _tmp3_;
		Dimensions _tmp4_;
		ZoomState _tmp5_;
#line 329 "../src/Views/SinglePhotoPage.vala"
		_tmp1_ = self->canvas;
#line 329 "../src/Views/SinglePhotoPage.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 329 "../src/Views/SinglePhotoPage.vala"
		_tmp3_ = *ctx_dim;
#line 329 "../src/Views/SinglePhotoPage.vala"
		_tmp4_ = *ctx_dim;
#line 329 "../src/Views/SinglePhotoPage.vala"
		gtk_render_background (_tmp2_, ctx, (gdouble) 0, (gdouble) 0, (gdouble) _tmp3_.width, (gdouble) _tmp4_.height);
#line 330 "../src/Views/SinglePhotoPage.vala"
		_tmp5_ = self->priv->static_zoom_state;
#line 330 "../src/Views/SinglePhotoPage.vala"
		single_photo_page_render_zoomed_to_pixmap (self, &_tmp5_);
#line 1361 "SinglePhotoPage.c"
	} else {
		TransitionClock* _tmp6_;
		Dimensions _tmp7_;
		Dimensions _tmp8_;
#line 331 "../src/Views/SinglePhotoPage.vala"
		_tmp6_ = self->priv->transition_clock;
#line 331 "../src/Views/SinglePhotoPage.vala"
		_tmp7_ = *ctx_dim;
#line 331 "../src/Views/SinglePhotoPage.vala"
		_tmp8_ = *ctx_dim;
#line 331 "../src/Views/SinglePhotoPage.vala"
		if (!transition_clock_paint (_tmp6_, ctx, _tmp7_.width, _tmp8_.height)) {
#line 1374 "SinglePhotoPage.c"
			GtkDrawingArea* _tmp9_;
			GtkStyleContext* _tmp10_;
			Dimensions _tmp11_;
			Dimensions _tmp12_;
			GdkPixbuf* _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
#line 333 "../src/Views/SinglePhotoPage.vala"
			_tmp9_ = self->canvas;
#line 333 "../src/Views/SinglePhotoPage.vala"
			_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
#line 333 "../src/Views/SinglePhotoPage.vala"
			_tmp11_ = *ctx_dim;
#line 333 "../src/Views/SinglePhotoPage.vala"
			_tmp12_ = *ctx_dim;
#line 333 "../src/Views/SinglePhotoPage.vala"
			gtk_render_background (_tmp10_, ctx, (gdouble) 0, (gdouble) 0, (gdouble) _tmp11_.width, (gdouble) _tmp12_.height);
#line 334 "../src/Views/SinglePhotoPage.vala"
			_tmp13_ = self->priv->scaled;
#line 334 "../src/Views/SinglePhotoPage.vala"
			_tmp14_ = self->priv->scaled_pos;
#line 334 "../src/Views/SinglePhotoPage.vala"
			_tmp15_ = self->priv->scaled_pos;
#line 334 "../src/Views/SinglePhotoPage.vala"
			gdk_cairo_set_source_pixbuf (ctx, _tmp13_, (gdouble) _tmp14_.x, (gdouble) _tmp15_.y);
#line 335 "../src/Views/SinglePhotoPage.vala"
			cairo_paint (ctx);
#line 1402 "SinglePhotoPage.c"
		}
	}
}

void
single_photo_page_paint (SinglePhotoPage* self,
                         cairo_t* ctx,
                         Dimensions* ctx_dim)
{
	SinglePhotoPageClass* _klass_;
#line 327 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 327 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 327 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->paint) {
#line 327 "../src/Views/SinglePhotoPage.vala"
		_klass_->paint (self, ctx, ctx_dim);
#line 1421 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_repaint_pixmap (SinglePhotoPage* self)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	Dimensions _tmp2_;
#line 339 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->pixmap_ctx;
#line 340 "../src/Views/SinglePhotoPage.vala"
	if (_tmp0_ == NULL) {
#line 341 "../src/Views/SinglePhotoPage.vala"
		return;
#line 1439 "SinglePhotoPage.c"
	}
#line 343 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = self->priv->pixmap_ctx;
#line 343 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = self->priv->pixmap_dim;
#line 343 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_paint (self, _tmp1_, &_tmp2_);
#line 344 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_invalidate_all (self);
#line 1449 "SinglePhotoPage.c"
}

void
single_photo_page_repaint (SinglePhotoPage* self,
                           Direction* direction)
{
#line 347 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 348 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_internal_repaint (self, FALSE, direction);
#line 1460 "SinglePhotoPage.c"
}

static void
_single_photo_page_repaint_pixmap_transition_clock_repaint_callback (gpointer self)
{
#line 437 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_repaint_pixmap ((SinglePhotoPage*) self);
#line 1468 "SinglePhotoPage.c"
}

static void
single_photo_page_internal_repaint (SinglePhotoPage* self,
                                    gboolean fast,
                                    Direction* direction)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp3_;
	GtkAllocation allocation = {0};
	GtkViewport* _tmp6_;
	GtkAllocation _tmp7_ = {0};
	gint width = 0;
	GtkAllocation _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint height = 0;
	GtkAllocation _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_ = FALSE;
	gboolean new_pixbuf = FALSE;
	GdkPixbuf* _tmp15_;
	Dimensions old_scaled_dim = {0};
	GdkRectangle _tmp16_;
	Dimensions _tmp17_ = {0};
	GdkRectangle old_scaled_pos = {0};
	GdkRectangle _tmp18_;
	gboolean _tmp19_ = FALSE;
	Dimensions _tmp20_;
	gboolean new_pixmap = FALSE;
	cairo_surface_t* _tmp22_;
	gboolean _tmp23_ = FALSE;
	GdkInterpType _tmp41_ = 0;
	GdkInterpType interp = 0;
	GdkPixbuf* _tmp42_;
	gboolean _tmp53_ = FALSE;
	TransitionClock* _tmp63_;
#line 351 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = page_get_in_view ((Page*) self);
#line 353 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _tmp0_;
#line 353 "../src/Views/SinglePhotoPage.vala"
	if (!_tmp1_) {
#line 354 "../src/Views/SinglePhotoPage.vala"
		_cairo_surface_destroy0 (self->priv->pixmap);
#line 354 "../src/Views/SinglePhotoPage.vala"
		self->priv->pixmap = NULL;
#line 355 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (self->priv->scaled);
#line 355 "../src/Views/SinglePhotoPage.vala"
		self->priv->scaled = NULL;
#line 357 "../src/Views/SinglePhotoPage.vala"
		return;
#line 1527 "SinglePhotoPage.c"
	}
#line 361 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = self->priv->unscaled;
#line 361 "../src/Views/SinglePhotoPage.vala"
	if (_tmp3_ == NULL) {
#line 361 "../src/Views/SinglePhotoPage.vala"
		_tmp2_ = TRUE;
#line 1535 "SinglePhotoPage.c"
	} else {
		GtkDrawingArea* _tmp4_;
		GdkWindow* _tmp5_;
#line 361 "../src/Views/SinglePhotoPage.vala"
		_tmp4_ = self->canvas;
#line 361 "../src/Views/SinglePhotoPage.vala"
		_tmp5_ = gtk_widget_get_window ((GtkWidget*) _tmp4_);
#line 361 "../src/Views/SinglePhotoPage.vala"
		_tmp2_ = _tmp5_ == NULL;
#line 1545 "SinglePhotoPage.c"
	}
#line 361 "../src/Views/SinglePhotoPage.vala"
	if (_tmp2_) {
#line 362 "../src/Views/SinglePhotoPage.vala"
		return;
#line 1551 "SinglePhotoPage.c"
	}
#line 365 "../src/Views/SinglePhotoPage.vala"
	_tmp6_ = self->viewport;
#line 365 "../src/Views/SinglePhotoPage.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp6_, &_tmp7_);
#line 365 "../src/Views/SinglePhotoPage.vala"
	allocation = _tmp7_;
#line 367 "../src/Views/SinglePhotoPage.vala"
	_tmp8_ = allocation;
#line 367 "../src/Views/SinglePhotoPage.vala"
	_tmp9_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 367 "../src/Views/SinglePhotoPage.vala"
	_tmp10_ = _tmp9_;
#line 367 "../src/Views/SinglePhotoPage.vala"
	width = _tmp8_.width * _tmp10_;
#line 368 "../src/Views/SinglePhotoPage.vala"
	_tmp11_ = allocation;
#line 368 "../src/Views/SinglePhotoPage.vala"
	_tmp12_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 368 "../src/Views/SinglePhotoPage.vala"
	_tmp13_ = _tmp12_;
#line 368 "../src/Views/SinglePhotoPage.vala"
	height = _tmp11_.height * _tmp13_;
#line 370 "../src/Views/SinglePhotoPage.vala"
	if (width <= 0) {
#line 370 "../src/Views/SinglePhotoPage.vala"
		_tmp14_ = TRUE;
#line 1579 "SinglePhotoPage.c"
	} else {
#line 370 "../src/Views/SinglePhotoPage.vala"
		_tmp14_ = height <= 0;
#line 1583 "SinglePhotoPage.c"
	}
#line 370 "../src/Views/SinglePhotoPage.vala"
	if (_tmp14_) {
#line 371 "../src/Views/SinglePhotoPage.vala"
		return;
#line 1589 "SinglePhotoPage.c"
	}
#line 373 "../src/Views/SinglePhotoPage.vala"
	_tmp15_ = self->priv->scaled;
#line 373 "../src/Views/SinglePhotoPage.vala"
	new_pixbuf = _tmp15_ == NULL;
#line 376 "../src/Views/SinglePhotoPage.vala"
	_tmp16_ = self->priv->scaled_pos;
#line 376 "../src/Views/SinglePhotoPage.vala"
	dimensions_for_rectangle (&_tmp16_, &_tmp17_);
#line 376 "../src/Views/SinglePhotoPage.vala"
	old_scaled_dim = _tmp17_;
#line 377 "../src/Views/SinglePhotoPage.vala"
	_tmp18_ = self->priv->scaled_pos;
#line 377 "../src/Views/SinglePhotoPage.vala"
	old_scaled_pos = _tmp18_;
#line 380 "../src/Views/SinglePhotoPage.vala"
	_tmp20_ = self->priv->pixmap_dim;
#line 380 "../src/Views/SinglePhotoPage.vala"
	if (_tmp20_.width != width) {
#line 380 "../src/Views/SinglePhotoPage.vala"
		_tmp19_ = TRUE;
#line 1611 "SinglePhotoPage.c"
	} else {
		Dimensions _tmp21_;
#line 380 "../src/Views/SinglePhotoPage.vala"
		_tmp21_ = self->priv->pixmap_dim;
#line 380 "../src/Views/SinglePhotoPage.vala"
		_tmp19_ = _tmp21_.height != height;
#line 1618 "SinglePhotoPage.c"
	}
#line 380 "../src/Views/SinglePhotoPage.vala"
	if (_tmp19_) {
#line 381 "../src/Views/SinglePhotoPage.vala"
		_cairo_surface_destroy0 (self->priv->pixmap);
#line 381 "../src/Views/SinglePhotoPage.vala"
		self->priv->pixmap = NULL;
#line 1626 "SinglePhotoPage.c"
	}
#line 384 "../src/Views/SinglePhotoPage.vala"
	new_pixmap = FALSE;
#line 385 "../src/Views/SinglePhotoPage.vala"
	_tmp22_ = self->priv->pixmap;
#line 385 "../src/Views/SinglePhotoPage.vala"
	if (_tmp22_ == NULL) {
#line 386 "../src/Views/SinglePhotoPage.vala"
		single_photo_page_init_pixmap (self, width, height);
#line 387 "../src/Views/SinglePhotoPage.vala"
		new_pixmap = TRUE;
#line 1638 "SinglePhotoPage.c"
	}
#line 390 "../src/Views/SinglePhotoPage.vala"
	if (new_pixbuf) {
#line 390 "../src/Views/SinglePhotoPage.vala"
		_tmp23_ = TRUE;
#line 1644 "SinglePhotoPage.c"
	} else {
#line 390 "../src/Views/SinglePhotoPage.vala"
		_tmp23_ = new_pixmap;
#line 1648 "SinglePhotoPage.c"
	}
#line 390 "../src/Views/SinglePhotoPage.vala"
	if (_tmp23_) {
#line 1652 "SinglePhotoPage.c"
		Dimensions unscaled_dim = {0};
		GdkPixbuf* _tmp24_;
		Dimensions _tmp25_ = {0};
		Dimensions scaled_dim = {0};
		gboolean _tmp26_ = FALSE;
		gboolean _tmp27_ = FALSE;
		gboolean _tmp28_ = FALSE;
		gboolean _tmp29_;
		Dimensions _tmp35_;
		Dimensions _tmp36_;
		Dimensions _tmp37_;
		Dimensions _tmp38_;
		Dimensions _tmp39_;
		Dimensions _tmp40_;
#line 391 "../src/Views/SinglePhotoPage.vala"
		_tmp24_ = self->priv->unscaled;
#line 391 "../src/Views/SinglePhotoPage.vala"
		dimensions_for_pixbuf (_tmp24_, &_tmp25_);
#line 391 "../src/Views/SinglePhotoPage.vala"
		unscaled_dim = _tmp25_;
#line 395 "../src/Views/SinglePhotoPage.vala"
		dimensions_init (&scaled_dim, 0, 0);
#line 396 "../src/Views/SinglePhotoPage.vala"
		_tmp29_ = self->priv->_scale_up_to_viewport;
#line 396 "../src/Views/SinglePhotoPage.vala"
		if (!_tmp29_) {
#line 396 "../src/Views/SinglePhotoPage.vala"
			_tmp28_ = dimensions_has_area (&self->priv->max_dim);
#line 1681 "SinglePhotoPage.c"
		} else {
#line 396 "../src/Views/SinglePhotoPage.vala"
			_tmp28_ = FALSE;
#line 1685 "SinglePhotoPage.c"
		}
#line 396 "../src/Views/SinglePhotoPage.vala"
		if (_tmp28_) {
#line 1689 "SinglePhotoPage.c"
			Dimensions _tmp30_;
#line 396 "../src/Views/SinglePhotoPage.vala"
			_tmp30_ = self->priv->max_dim;
#line 396 "../src/Views/SinglePhotoPage.vala"
			_tmp27_ = _tmp30_.width < width;
#line 1695 "SinglePhotoPage.c"
		} else {
#line 396 "../src/Views/SinglePhotoPage.vala"
			_tmp27_ = FALSE;
#line 1699 "SinglePhotoPage.c"
		}
#line 396 "../src/Views/SinglePhotoPage.vala"
		if (_tmp27_) {
#line 1703 "SinglePhotoPage.c"
			Dimensions _tmp31_;
#line 396 "../src/Views/SinglePhotoPage.vala"
			_tmp31_ = self->priv->max_dim;
#line 396 "../src/Views/SinglePhotoPage.vala"
			_tmp26_ = _tmp31_.height < height;
#line 1709 "SinglePhotoPage.c"
		} else {
#line 396 "../src/Views/SinglePhotoPage.vala"
			_tmp26_ = FALSE;
#line 1713 "SinglePhotoPage.c"
		}
#line 396 "../src/Views/SinglePhotoPage.vala"
		if (_tmp26_) {
#line 1717 "SinglePhotoPage.c"
			Dimensions _tmp32_;
#line 397 "../src/Views/SinglePhotoPage.vala"
			_tmp32_ = self->priv->max_dim;
#line 397 "../src/Views/SinglePhotoPage.vala"
			scaled_dim = _tmp32_;
#line 1723 "SinglePhotoPage.c"
		} else {
			Dimensions _tmp33_;
			Dimensions _tmp34_ = {0};
#line 399 "../src/Views/SinglePhotoPage.vala"
			_tmp33_ = self->priv->pixmap_dim;
#line 399 "../src/Views/SinglePhotoPage.vala"
			dimensions_get_scaled_proportional (&unscaled_dim, &_tmp33_, &_tmp34_);
#line 399 "../src/Views/SinglePhotoPage.vala"
			scaled_dim = _tmp34_;
#line 1733 "SinglePhotoPage.c"
		}
#line 401 "../src/Views/SinglePhotoPage.vala"
		_tmp35_ = scaled_dim;
#line 401 "../src/Views/SinglePhotoPage.vala"
		_vala_assert (width >= _tmp35_.width, "width >= scaled_dim.width");
#line 402 "../src/Views/SinglePhotoPage.vala"
		_tmp36_ = scaled_dim;
#line 402 "../src/Views/SinglePhotoPage.vala"
		_vala_assert (height >= _tmp36_.height, "height >= scaled_dim.height");
#line 405 "../src/Views/SinglePhotoPage.vala"
		_tmp37_ = scaled_dim;
#line 405 "../src/Views/SinglePhotoPage.vala"
		self->priv->scaled_pos.x = (width - _tmp37_.width) / 2;
#line 406 "../src/Views/SinglePhotoPage.vala"
		_tmp38_ = scaled_dim;
#line 406 "../src/Views/SinglePhotoPage.vala"
		self->priv->scaled_pos.y = (height - _tmp38_.height) / 2;
#line 407 "../src/Views/SinglePhotoPage.vala"
		_tmp39_ = scaled_dim;
#line 407 "../src/Views/SinglePhotoPage.vala"
		self->priv->scaled_pos.width = _tmp39_.width;
#line 408 "../src/Views/SinglePhotoPage.vala"
		_tmp40_ = scaled_dim;
#line 408 "../src/Views/SinglePhotoPage.vala"
		self->priv->scaled_pos.height = _tmp40_.height;
#line 1759 "SinglePhotoPage.c"
	}
#line 411 "../src/Views/SinglePhotoPage.vala"
	if (fast) {
#line 411 "../src/Views/SinglePhotoPage.vala"
		_tmp41_ = GDK_INTERP_NEAREST;
#line 1765 "SinglePhotoPage.c"
	} else {
#line 411 "../src/Views/SinglePhotoPage.vala"
		_tmp41_ = GDK_INTERP_BILINEAR;
#line 1769 "SinglePhotoPage.c"
	}
#line 411 "../src/Views/SinglePhotoPage.vala"
	interp = _tmp41_;
#line 414 "../src/Views/SinglePhotoPage.vala"
	_tmp42_ = self->priv->scaled;
#line 414 "../src/Views/SinglePhotoPage.vala"
	if (_tmp42_ == NULL) {
#line 1777 "SinglePhotoPage.c"
		GdkPixbuf* _tmp43_;
		GdkRectangle _tmp44_;
		Dimensions _tmp45_ = {0};
		GdkPixbuf* _tmp46_;
		SinglePhotoPageUpdateReason reason = 0;
		Dimensions _tmp48_;
		Dimensions _tmp49_;
		GdkPoint _tmp50_ = {0};
		GdkPixbuf* _tmp51_;
		Dimensions _tmp52_;
#line 415 "../src/Views/SinglePhotoPage.vala"
		_tmp43_ = self->priv->unscaled;
#line 415 "../src/Views/SinglePhotoPage.vala"
		_tmp44_ = self->priv->scaled_pos;
#line 415 "../src/Views/SinglePhotoPage.vala"
		dimensions_for_rectangle (&_tmp44_, &_tmp45_);
#line 415 "../src/Views/SinglePhotoPage.vala"
		_tmp46_ = resize_pixbuf (_tmp43_, &_tmp45_, interp);
#line 415 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (self->priv->scaled);
#line 415 "../src/Views/SinglePhotoPage.vala"
		self->priv->scaled = _tmp46_;
#line 417 "../src/Views/SinglePhotoPage.vala"
		reason = SINGLE_PHOTO_PAGE_UPDATE_REASON_RESIZED_CANVAS;
#line 418 "../src/Views/SinglePhotoPage.vala"
		if (new_pixbuf) {
#line 419 "../src/Views/SinglePhotoPage.vala"
			reason = SINGLE_PHOTO_PAGE_UPDATE_REASON_NEW_PIXBUF;
#line 1806 "SinglePhotoPage.c"
		} else {
			gboolean _tmp47_ = FALSE;
#line 420 "../src/Views/SinglePhotoPage.vala"
			if (!new_pixmap) {
#line 420 "../src/Views/SinglePhotoPage.vala"
				_tmp47_ = interp == GDK_INTERP_BILINEAR;
#line 1813 "SinglePhotoPage.c"
			} else {
#line 420 "../src/Views/SinglePhotoPage.vala"
				_tmp47_ = FALSE;
#line 1817 "SinglePhotoPage.c"
			}
#line 420 "../src/Views/SinglePhotoPage.vala"
			if (_tmp47_) {
#line 421 "../src/Views/SinglePhotoPage.vala"
				reason = SINGLE_PHOTO_PAGE_UPDATE_REASON_QUALITY_IMPROVEMENT;
#line 1823 "SinglePhotoPage.c"
			}
		}
#line 424 "../src/Views/SinglePhotoPage.vala"
		_tmp48_ = self->priv->max_dim;
#line 424 "../src/Views/SinglePhotoPage.vala"
		_tmp49_ = self->priv->pixmap_dim;
#line 424 "../src/Views/SinglePhotoPage.vala"
		zoom_state_get_viewport_center (&self->priv->static_zoom_state, &_tmp50_);
#line 424 "../src/Views/SinglePhotoPage.vala"
		zoom_state_init (&self->priv->static_zoom_state, &_tmp48_, &_tmp49_, zoom_state_get_interpolation_factor (&self->priv->static_zoom_state), &_tmp50_);
#line 428 "../src/Views/SinglePhotoPage.vala"
		_tmp51_ = self->priv->scaled;
#line 428 "../src/Views/SinglePhotoPage.vala"
		_tmp52_ = old_scaled_dim;
#line 428 "../src/Views/SinglePhotoPage.vala"
		single_photo_page_updated_pixbuf (self, _tmp51_, reason, &_tmp52_);
#line 1840 "SinglePhotoPage.c"
	}
#line 431 "../src/Views/SinglePhotoPage.vala"
	self->priv->zoom_high_quality = !fast;
#line 433 "../src/Views/SinglePhotoPage.vala"
	if (direction != NULL) {
#line 1846 "SinglePhotoPage.c"
		TransitionClock* _tmp54_;
#line 433 "../src/Views/SinglePhotoPage.vala"
		_tmp54_ = self->priv->transition_clock;
#line 433 "../src/Views/SinglePhotoPage.vala"
		_tmp53_ = !transition_clock_is_in_progress (_tmp54_);
#line 1852 "SinglePhotoPage.c"
	} else {
#line 433 "../src/Views/SinglePhotoPage.vala"
		_tmp53_ = FALSE;
#line 1856 "SinglePhotoPage.c"
	}
#line 433 "../src/Views/SinglePhotoPage.vala"
	if (_tmp53_) {
#line 1860 "SinglePhotoPage.c"
		SpitTransitionsVisuals* visuals = NULL;
		GdkPixbuf* _tmp55_;
		GdkRectangle _tmp56_;
		GdkPixbuf* _tmp57_;
		GdkRectangle _tmp58_;
		GdkRGBA _tmp59_ = {0};
		SpitTransitionsVisuals* _tmp60_;
		TransitionClock* _tmp61_;
		SpitTransitionsVisuals* _tmp62_;
#line 434 "../src/Views/SinglePhotoPage.vala"
		_tmp55_ = self->priv->old_scaled;
#line 434 "../src/Views/SinglePhotoPage.vala"
		_tmp56_ = old_scaled_pos;
#line 434 "../src/Views/SinglePhotoPage.vala"
		_tmp57_ = self->priv->scaled;
#line 434 "../src/Views/SinglePhotoPage.vala"
		_tmp58_ = self->priv->scaled_pos;
#line 434 "../src/Views/SinglePhotoPage.vala"
		parse_color ("#000", &_tmp59_);
#line 434 "../src/Views/SinglePhotoPage.vala"
		_tmp60_ = spit_transitions_visuals_new (_tmp55_, &_tmp56_, _tmp57_, &_tmp58_, &_tmp59_);
#line 434 "../src/Views/SinglePhotoPage.vala"
		visuals = _tmp60_;
#line 437 "../src/Views/SinglePhotoPage.vala"
		_tmp61_ = self->priv->transition_clock;
#line 437 "../src/Views/SinglePhotoPage.vala"
		_tmp62_ = visuals;
#line 437 "../src/Views/SinglePhotoPage.vala"
		transition_clock_start (_tmp61_, _tmp62_, direction_to_transition_direction (*direction), self->priv->transition_duration_msec, _single_photo_page_repaint_pixmap_transition_clock_repaint_callback, self);
#line 433 "../src/Views/SinglePhotoPage.vala"
		_g_object_unref0 (visuals);
#line 1892 "SinglePhotoPage.c"
	}
#line 441 "../src/Views/SinglePhotoPage.vala"
	_tmp63_ = self->priv->transition_clock;
#line 441 "../src/Views/SinglePhotoPage.vala"
	if (!transition_clock_is_in_progress (_tmp63_)) {
#line 442 "../src/Views/SinglePhotoPage.vala"
		single_photo_page_repaint_pixmap (self);
#line 1900 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_init_pixmap (SinglePhotoPage* self,
                               gint width,
                               gint height)
{
	GdkPixbuf* _tmp0_;
	GtkDrawingArea* _tmp1_;
	GdkWindow* _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_surface_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	Dimensions _tmp10_;
#line 445 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 446 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = self->priv->unscaled;
#line 446 "../src/Views/SinglePhotoPage.vala"
	_vala_assert (_tmp0_ != NULL, "unscaled != null");
#line 447 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = self->canvas;
#line 447 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) _tmp1_);
#line 447 "../src/Views/SinglePhotoPage.vala"
	_vala_assert (_tmp2_ != NULL, "canvas.get_window () != null");
#line 450 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
#line 450 "../src/Views/SinglePhotoPage.vala"
	_cairo_surface_destroy0 (self->priv->pixmap);
#line 450 "../src/Views/SinglePhotoPage.vala"
	self->priv->pixmap = _tmp3_;
#line 451 "../src/Views/SinglePhotoPage.vala"
	dimensions_init (&self->priv->pixmap_dim, width, height);
#line 454 "../src/Views/SinglePhotoPage.vala"
	_tmp4_ = self->priv->pixmap;
#line 454 "../src/Views/SinglePhotoPage.vala"
	_tmp5_ = cairo_create (_tmp4_);
#line 454 "../src/Views/SinglePhotoPage.vala"
	_cairo_destroy0 (self->priv->pixmap_ctx);
#line 454 "../src/Views/SinglePhotoPage.vala"
	self->priv->pixmap_ctx = _tmp5_;
#line 457 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->scaled);
#line 457 "../src/Views/SinglePhotoPage.vala"
	self->priv->scaled = NULL;
#line 460 "../src/Views/SinglePhotoPage.vala"
	_tmp6_ = self->priv->pixmap;
#line 460 "../src/Views/SinglePhotoPage.vala"
	_tmp7_ = cairo_create (_tmp6_);
#line 460 "../src/Views/SinglePhotoPage.vala"
	_cairo_destroy0 (self->priv->text_ctx);
#line 460 "../src/Views/SinglePhotoPage.vala"
	self->priv->text_ctx = _tmp7_;
#line 461 "../src/Views/SinglePhotoPage.vala"
	_tmp8_ = self->priv->text_ctx;
#line 461 "../src/Views/SinglePhotoPage.vala"
	set_source_color_from_string (_tmp8_, "#fff");
#line 466 "../src/Views/SinglePhotoPage.vala"
	_tmp9_ = self->priv->pixmap_ctx;
#line 466 "../src/Views/SinglePhotoPage.vala"
	_tmp10_ = self->priv->pixmap_dim;
#line 466 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_new_surface (self, _tmp9_, &_tmp10_);
#line 1970 "SinglePhotoPage.c"
}

static gboolean
single_photo_page_real_on_context_keypress (Page* base)
{
	SinglePhotoPage * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 469 "../src/Views/SinglePhotoPage.vala"
	self = (SinglePhotoPage*) base;
#line 470 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = page_get_page_context_menu ((Page*) self);
#line 470 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _tmp0_;
#line 470 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = page_popup_context_menu ((Page*) self, _tmp1_, NULL);
#line 470 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (_tmp1_);
#line 470 "../src/Views/SinglePhotoPage.vala"
	result = _tmp2_;
#line 470 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 1995 "SinglePhotoPage.c"
}

static void
single_photo_page_real_on_previous_photo (SinglePhotoPage* self)
{
}

void
single_photo_page_on_previous_photo (SinglePhotoPage* self)
{
	SinglePhotoPageClass* _klass_;
#line 473 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 473 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 473 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->on_previous_photo) {
#line 473 "../src/Views/SinglePhotoPage.vala"
		_klass_->on_previous_photo (self);
#line 2015 "SinglePhotoPage.c"
	}
}

static void
single_photo_page_real_on_next_photo (SinglePhotoPage* self)
{
}

void
single_photo_page_on_next_photo (SinglePhotoPage* self)
{
	SinglePhotoPageClass* _klass_;
#line 476 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 476 "../src/Views/SinglePhotoPage.vala"
	_klass_ = SINGLE_PHOTO_PAGE_GET_CLASS (self);
#line 476 "../src/Views/SinglePhotoPage.vala"
	if (_klass_->on_next_photo) {
#line 476 "../src/Views/SinglePhotoPage.vala"
		_klass_->on_next_photo (self);
#line 2036 "SinglePhotoPage.c"
	}
}

static gboolean
single_photo_page_real_key_press_event (GtkWidget* base,
                                        GdkEventKey* event)
{
	SinglePhotoPage * self;
	gboolean nav_ok = FALSE;
	gboolean handled = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 486 "../src/Views/SinglePhotoPage.vala"
	static GQuark _tmp2_label0 = 0;
#line 486 "../src/Views/SinglePhotoPage.vala"
	static GQuark _tmp2_label1 = 0;
#line 486 "../src/Views/SinglePhotoPage.vala"
	static GQuark _tmp2_label2 = 0;
#line 486 "../src/Views/SinglePhotoPage.vala"
	static GQuark _tmp2_label3 = 0;
#line 486 "../src/Views/SinglePhotoPage.vala"
	static GQuark _tmp2_label4 = 0;
#line 2060 "SinglePhotoPage.c"
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 479 "../src/Views/SinglePhotoPage.vala"
	self = (SinglePhotoPage*) base;
#line 479 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 483 "../src/Views/SinglePhotoPage.vala"
	nav_ok = (event->time - self->priv->last_nav_key) > ((guint32) 200);
#line 485 "../src/Views/SinglePhotoPage.vala"
	handled = TRUE;
#line 486 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 486 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _tmp0_;
#line 486 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 486 "../src/Views/SinglePhotoPage.vala"
	if ((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Left")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("KP_Left"))))) {
#line 486 "../src/Views/SinglePhotoPage.vala"
		switch (0) {
#line 2081 "SinglePhotoPage.c"
			default:
			{
#line 489 "../src/Views/SinglePhotoPage.vala"
				if (nav_ok) {
#line 490 "../src/Views/SinglePhotoPage.vala"
					single_photo_page_on_previous_photo (self);
#line 491 "../src/Views/SinglePhotoPage.vala"
					self->priv->last_nav_key = event->time;
#line 2090 "SinglePhotoPage.c"
				}
#line 493 "../src/Views/SinglePhotoPage.vala"
				break;
#line 2094 "SinglePhotoPage.c"
			}
		}
	} else if (((_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("Right")))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("KP_Right"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("space"))))) {
#line 486 "../src/Views/SinglePhotoPage.vala"
		switch (0) {
#line 2100 "SinglePhotoPage.c"
			default:
			{
#line 498 "../src/Views/SinglePhotoPage.vala"
				if (nav_ok) {
#line 499 "../src/Views/SinglePhotoPage.vala"
					single_photo_page_on_next_photo (self);
#line 500 "../src/Views/SinglePhotoPage.vala"
					self->priv->last_nav_key = event->time;
#line 2109 "SinglePhotoPage.c"
				}
#line 502 "../src/Views/SinglePhotoPage.vala"
				break;
#line 2113 "SinglePhotoPage.c"
			}
		}
	} else {
#line 486 "../src/Views/SinglePhotoPage.vala"
		switch (0) {
#line 2119 "SinglePhotoPage.c"
			default:
			{
#line 505 "../src/Views/SinglePhotoPage.vala"
				handled = FALSE;
#line 506 "../src/Views/SinglePhotoPage.vala"
				break;
#line 2126 "SinglePhotoPage.c"
			}
		}
	}
#line 509 "../src/Views/SinglePhotoPage.vala"
	if (handled) {
#line 510 "../src/Views/SinglePhotoPage.vala"
		result = TRUE;
#line 510 "../src/Views/SinglePhotoPage.vala"
		return result;
#line 2136 "SinglePhotoPage.c"
	}
#line 512 "../src/Views/SinglePhotoPage.vala"
	if (GTK_WIDGET_CLASS (single_photo_page_parent_class)->key_press_event != NULL) {
#line 512 "../src/Views/SinglePhotoPage.vala"
		_tmp4_ = GTK_WIDGET_CLASS (single_photo_page_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE, Page), event);
#line 2142 "SinglePhotoPage.c"
	} else {
#line 512 "../src/Views/SinglePhotoPage.vala"
		_tmp4_ = TRUE;
#line 2146 "SinglePhotoPage.c"
	}
#line 512 "../src/Views/SinglePhotoPage.vala"
	result = _tmp4_;
#line 512 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 2152 "SinglePhotoPage.c"
}

gboolean
single_photo_page_get_scale_up_to_viewport (SinglePhotoPage* self)
{
	gboolean result;
#line 48 "../src/Views/SinglePhotoPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/Views/SinglePhotoPage.vala"
	result = self->priv->_scale_up_to_viewport;
#line 48 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 2165 "SinglePhotoPage.c"
}

static void
single_photo_page_set_scale_up_to_viewport (SinglePhotoPage* self,
                                            gboolean value)
{
	gboolean old_value;
#line 48 "../src/Views/SinglePhotoPage.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Views/SinglePhotoPage.vala"
	old_value = single_photo_page_get_scale_up_to_viewport (self);
#line 48 "../src/Views/SinglePhotoPage.vala"
	if (old_value != value) {
#line 48 "../src/Views/SinglePhotoPage.vala"
		self->priv->_scale_up_to_viewport = value;
#line 48 "../src/Views/SinglePhotoPage.vala"
		g_object_notify_by_pspec ((GObject *) self, single_photo_page_properties[SINGLE_PHOTO_PAGE_SCALE_UP_TO_VIEWPORT_PROPERTY]);
#line 2183 "SinglePhotoPage.c"
	}
}

static void
_single_photo_page_on_viewport_resize_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                GtkAllocation* allocation,
                                                                gpointer self)
{
#line 79 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_on_viewport_resize ((SinglePhotoPage*) self);
#line 2194 "SinglePhotoPage.c"
}

static gboolean
_single_photo_page_on_canvas_exposed_gtk_widget_draw (GtkWidget* _sender,
                                                      cairo_t* cr,
                                                      gpointer self)
{
	gboolean result;
	result = single_photo_page_on_canvas_exposed ((SinglePhotoPage*) self, cr);
#line 80 "../src/Views/SinglePhotoPage.vala"
	return result;
#line 2206 "SinglePhotoPage.c"
}

static GObject *
single_photo_page_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SinglePhotoPage * self;
	TransitionEffectsManager* _tmp0_;
	TransitionEffectsManager* _tmp1_;
	TransitionClock* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkViewport* _tmp5_;
	GtkDrawingArea* _tmp6_;
	GtkViewport* _tmp7_;
	GtkDrawingArea* _tmp8_;
	GtkViewport* _tmp9_;
	GtkDrawingArea* _tmp10_;
	GtkDrawingArea* _tmp11_;
#line 57 "../src/Views/SinglePhotoPage.vala"
	parent_class = G_OBJECT_CLASS (single_photo_page_parent_class);
#line 57 "../src/Views/SinglePhotoPage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 57 "../src/Views/SinglePhotoPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage);
#line 58 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = transition_effects_manager_get_instance ();
#line 58 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Views/SinglePhotoPage.vala"
	_tmp2_ = transition_effects_manager_create_null_transition_clock (_tmp1_);
#line 58 "../src/Views/SinglePhotoPage.vala"
	_transition_clock_unref0 (self->priv->transition_clock);
#line 58 "../src/Views/SinglePhotoPage.vala"
	self->priv->transition_clock = _tmp2_;
#line 58 "../src/Views/SinglePhotoPage.vala"
	_transition_effects_manager_unref0 (_tmp1_);
#line 62 "../src/Views/SinglePhotoPage.vala"
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 64 "../src/Views/SinglePhotoPage.vala"
	_tmp3_ = self->canvas;
#line 64 "../src/Views/SinglePhotoPage.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 64 "../src/Views/SinglePhotoPage.vala"
	gtk_style_context_add_class (_tmp4_, GRANITE_STYLE_CLASS_CHECKERBOARD);
#line 66 "../src/Views/SinglePhotoPage.vala"
	_tmp5_ = self->viewport;
#line 66 "../src/Views/SinglePhotoPage.vala"
	_tmp6_ = self->canvas;
#line 66 "../src/Views/SinglePhotoPage.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 68 "../src/Views/SinglePhotoPage.vala"
	_tmp7_ = self->viewport;
#line 68 "../src/Views/SinglePhotoPage.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
#line 76 "../src/Views/SinglePhotoPage.vala"
	_tmp8_ = self->canvas;
#line 76 "../src/Views/SinglePhotoPage.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp8_, (gint) ((GDK_EXPOSURE_MASK | GDK_STRUCTURE_MASK) | GDK_SUBSTRUCTURE_MASK));
#line 79 "../src/Views/SinglePhotoPage.vala"
	_tmp9_ = self->viewport;
#line 79 "../src/Views/SinglePhotoPage.vala"
	g_signal_connect_object ((GtkWidget*) _tmp9_, "size-allocate", (GCallback) _single_photo_page_on_viewport_resize_gtk_widget_size_allocate, self, 0);
#line 80 "../src/Views/SinglePhotoPage.vala"
	_tmp10_ = self->canvas;
#line 80 "../src/Views/SinglePhotoPage.vala"
	g_signal_connect_object ((GtkWidget*) _tmp10_, "draw", (GCallback) _single_photo_page_on_canvas_exposed_gtk_widget_draw, self, 0);
#line 82 "../src/Views/SinglePhotoPage.vala"
	_tmp11_ = self->canvas;
#line 82 "../src/Views/SinglePhotoPage.vala"
	page_set_event_source ((Page*) self, (GtkWidget*) _tmp11_);
#line 57 "../src/Views/SinglePhotoPage.vala"
	return obj;
#line 2283 "SinglePhotoPage.c"
}

static void
single_photo_page_class_init (SinglePhotoPageClass * klass,
                              gpointer klass_data)
{
#line 21 "../src/Views/SinglePhotoPage.vala"
	single_photo_page_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Views/SinglePhotoPage.vala"
	g_type_class_adjust_private_offset (klass, &SinglePhotoPage_private_offset);
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->is_zoom_supported = (gboolean (*) (SinglePhotoPage*)) single_photo_page_real_is_zoom_supported;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->cancel_zoom = (void (*) (SinglePhotoPage*)) single_photo_page_real_cancel_zoom;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->save_zoom_state = (void (*) (SinglePhotoPage*)) single_photo_page_real_save_zoom_state;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->restore_zoom_state = (void (*) (SinglePhotoPage*)) single_photo_page_real_restore_zoom_state;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->get_zoom_buffer = (ZoomBuffer* (*) (SinglePhotoPage*)) single_photo_page_real_get_zoom_buffer;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((PageClass *) klass)->switched_to = (void (*) (Page*)) single_photo_page_real_switched_to;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((PageClass *) klass)->set_container = (void (*) (Page*, GtkWindow*)) single_photo_page_real_set_container;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((PageClass *) klass)->on_resize_finished = (void (*) (Page*, GdkRectangle*)) single_photo_page_real_on_resize_finished;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->new_surface = (void (*) (SinglePhotoPage*, cairo_t*, Dimensions*)) single_photo_page_real_new_surface;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->updated_pixbuf = (void (*) (SinglePhotoPage*, GdkPixbuf*, SinglePhotoPageUpdateReason, Dimensions*)) single_photo_page_real_updated_pixbuf;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->paint = (void (*) (SinglePhotoPage*, cairo_t*, Dimensions*)) single_photo_page_real_paint;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((PageClass *) klass)->on_context_keypress = (gboolean (*) (Page*)) single_photo_page_real_on_context_keypress;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->on_previous_photo = (void (*) (SinglePhotoPage*)) single_photo_page_real_on_previous_photo;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((SinglePhotoPageClass *) klass)->on_next_photo = (void (*) (SinglePhotoPage*)) single_photo_page_real_on_next_photo;
#line 21 "../src/Views/SinglePhotoPage.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) single_photo_page_real_key_press_event;
#line 21 "../src/Views/SinglePhotoPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_single_photo_page_get_property;
#line 21 "../src/Views/SinglePhotoPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_single_photo_page_set_property;
#line 21 "../src/Views/SinglePhotoPage.vala"
	G_OBJECT_CLASS (klass)->constructor = single_photo_page_constructor;
#line 21 "../src/Views/SinglePhotoPage.vala"
	G_OBJECT_CLASS (klass)->finalize = single_photo_page_finalize;
#line 21 "../src/Views/SinglePhotoPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLE_PHOTO_PAGE_SCALE_UP_TO_VIEWPORT_PROPERTY, single_photo_page_properties[SINGLE_PHOTO_PAGE_SCALE_UP_TO_VIEWPORT_PROPERTY] = g_param_spec_boolean ("scale-up-to-viewport", "scale-up-to-viewport", "scale-up-to-viewport", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2334 "SinglePhotoPage.c"
}

static void
single_photo_page_instance_init (SinglePhotoPage * self,
                                 gpointer klass)
{
	GtkDrawingArea* _tmp0_;
	GtkViewport* _tmp1_;
#line 21 "../src/Views/SinglePhotoPage.vala"
	self->priv = single_photo_page_get_instance_private (self);
#line 28 "../src/Views/SinglePhotoPage.vala"
	_tmp0_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 28 "../src/Views/SinglePhotoPage.vala"
	g_object_ref_sink (_tmp0_);
#line 28 "../src/Views/SinglePhotoPage.vala"
	self->canvas = _tmp0_;
#line 29 "../src/Views/SinglePhotoPage.vala"
	_tmp1_ = (GtkViewport*) gtk_viewport_new (NULL, NULL);
#line 29 "../src/Views/SinglePhotoPage.vala"
	g_object_ref_sink (_tmp1_);
#line 29 "../src/Views/SinglePhotoPage.vala"
	self->viewport = _tmp1_;
#line 32 "../src/Views/SinglePhotoPage.vala"
	self->priv->transition_duration_msec = 0;
#line 33 "../src/Views/SinglePhotoPage.vala"
	self->priv->pixmap = NULL;
#line 34 "../src/Views/SinglePhotoPage.vala"
	self->priv->pixmap_ctx = NULL;
#line 35 "../src/Views/SinglePhotoPage.vala"
	self->priv->text_ctx = NULL;
#line 36 "../src/Views/SinglePhotoPage.vala"
	dimensions_init (&self->priv->pixmap_dim, 0, 0);
#line 37 "../src/Views/SinglePhotoPage.vala"
	self->priv->unscaled = NULL;
#line 38 "../src/Views/SinglePhotoPage.vala"
	dimensions_init (&self->priv->max_dim, 0, 0);
#line 39 "../src/Views/SinglePhotoPage.vala"
	self->priv->scaled = NULL;
#line 40 "../src/Views/SinglePhotoPage.vala"
	self->priv->old_scaled = NULL;
#line 41 "../src/Views/SinglePhotoPage.vala"
	memset (&self->priv->scaled_pos, 0, sizeof (GdkRectangle));
#line 43 "../src/Views/SinglePhotoPage.vala"
	self->priv->zoom_high_quality = TRUE;
#line 45 "../src/Views/SinglePhotoPage.vala"
	self->priv->has_saved_zoom_state = FALSE;
#line 46 "../src/Views/SinglePhotoPage.vala"
	self->priv->last_nav_key = (guint32) 0;
#line 2383 "SinglePhotoPage.c"
}

static void
single_photo_page_finalize (GObject * obj)
{
	SinglePhotoPage * self;
#line 21 "../src/Views/SinglePhotoPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage);
#line 28 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->canvas);
#line 29 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->viewport);
#line 31 "../src/Views/SinglePhotoPage.vala"
	_transition_clock_unref0 (self->priv->transition_clock);
#line 33 "../src/Views/SinglePhotoPage.vala"
	_cairo_surface_destroy0 (self->priv->pixmap);
#line 34 "../src/Views/SinglePhotoPage.vala"
	_cairo_destroy0 (self->priv->pixmap_ctx);
#line 35 "../src/Views/SinglePhotoPage.vala"
	_cairo_destroy0 (self->priv->text_ctx);
#line 37 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->unscaled);
#line 39 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->scaled);
#line 40 "../src/Views/SinglePhotoPage.vala"
	_g_object_unref0 (self->priv->old_scaled);
#line 21 "../src/Views/SinglePhotoPage.vala"
	G_OBJECT_CLASS (single_photo_page_parent_class)->finalize (obj);
#line 2412 "SinglePhotoPage.c"
}

static GType
single_photo_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SinglePhotoPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) single_photo_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SinglePhotoPage), 0, (GInstanceInitFunc) single_photo_page_instance_init, NULL };
	GType single_photo_page_type_id;
	single_photo_page_type_id = g_type_register_static (TYPE_PAGE, "SinglePhotoPage", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SinglePhotoPage_private_offset = g_type_add_instance_private (single_photo_page_type_id, sizeof (SinglePhotoPagePrivate));
	return single_photo_page_type_id;
}

GType
single_photo_page_get_type (void)
{
	static volatile gsize single_photo_page_type_id__once = 0;
	if (g_once_init_enter (&single_photo_page_type_id__once)) {
		GType single_photo_page_type_id;
		single_photo_page_type_id = single_photo_page_get_type_once ();
		g_once_init_leave (&single_photo_page_type_id__once, single_photo_page_type_id);
	}
	return single_photo_page_type_id__once;
}

static void
_vala_single_photo_page_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	SinglePhotoPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage);
#line 21 "../src/Views/SinglePhotoPage.vala"
	switch (property_id) {
#line 21 "../src/Views/SinglePhotoPage.vala"
		case SINGLE_PHOTO_PAGE_SCALE_UP_TO_VIEWPORT_PROPERTY:
#line 21 "../src/Views/SinglePhotoPage.vala"
		g_value_set_boolean (value, single_photo_page_get_scale_up_to_viewport (self));
#line 21 "../src/Views/SinglePhotoPage.vala"
		break;
#line 2453 "SinglePhotoPage.c"
		default:
#line 21 "../src/Views/SinglePhotoPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Views/SinglePhotoPage.vala"
		break;
#line 2459 "SinglePhotoPage.c"
	}
}

static void
_vala_single_photo_page_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	SinglePhotoPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage);
#line 21 "../src/Views/SinglePhotoPage.vala"
	switch (property_id) {
#line 21 "../src/Views/SinglePhotoPage.vala"
		case SINGLE_PHOTO_PAGE_SCALE_UP_TO_VIEWPORT_PROPERTY:
#line 21 "../src/Views/SinglePhotoPage.vala"
		single_photo_page_set_scale_up_to_viewport (self, g_value_get_boolean (value));
#line 21 "../src/Views/SinglePhotoPage.vala"
		break;
#line 2479 "SinglePhotoPage.c"
		default:
#line 21 "../src/Views/SinglePhotoPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Views/SinglePhotoPage.vala"
		break;
#line 2485 "SinglePhotoPage.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

