/* SlideshowPage.c generated by valac 0.56.18, the Vala compiler
 * generated from SlideshowPage.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2017 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#define SLIDESHOW_PAGE_READAHEAD_COUNT 5
#define SLIDESHOW_PAGE_CHECK_ADVANCE_MSEC 250
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_SLIDESHOW_PAGE (slideshow_page_get_type ())
#define SLIDESHOW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SLIDESHOW_PAGE, SlideshowPage))
#define SLIDESHOW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SLIDESHOW_PAGE, SlideshowPageClass))
#define IS_SLIDESHOW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SLIDESHOW_PAGE))
#define IS_SLIDESHOW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SLIDESHOW_PAGE))
#define SLIDESHOW_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SLIDESHOW_PAGE, SlideshowPageClass))

typedef struct _SlideshowPage SlideshowPage;
typedef struct _SlideshowPageClass SlideshowPageClass;
typedef struct _SlideshowPagePrivate SlideshowPagePrivate;
enum  {
	SLIDESHOW_PAGE_0_PROPERTY,
	SLIDESHOW_PAGE_SOURCES_PROPERTY,
	SLIDESHOW_PAGE_CONTROLLER_PROPERTY,
	SLIDESHOW_PAGE_NUM_PROPERTIES
};
static GParamSpec* slideshow_page_properties[SLIDESHOW_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block24Data Block24Data;
#define _transition_effects_manager_unref0(var) ((var == NULL) ? NULL : (var = (transition_effects_manager_unref (var), NULL)))
enum  {
	SLIDESHOW_PAGE_HIDE_TOOLBAR_SIGNAL,
	SLIDESHOW_PAGE_NUM_SIGNALS
};
static guint slideshow_page_signals[SLIDESHOW_PAGE_NUM_SIGNALS] = {0};

struct _SlideshowPage {
	SinglePhotoPage parent_instance;
	SlideshowPagePrivate * priv;
};

struct _SlideshowPageClass {
	SinglePhotoPageClass parent_class;
};

struct _SlideshowPagePrivate {
	Photo* current;
	GtkButton* play_pause_button;
	PixbufCache* cache;
	GTimer* timer;
	gboolean playing;
	gboolean exiting;
	gchar** transitions;
	gint transitions_length1;
	gint _transitions_size_;
	guint32 cookie;
	GSettings* slideshow_settings;
	SourceCollection* _sources;
	ViewCollection* _controller;
};

struct _Block24Data {
	int _ref_count_;
	SlideshowPage* self;
	GtkToggleButton* titles_toggle;
	GtkScale* slider;
};

static gint SlideshowPage_private_offset;
static gpointer slideshow_page_parent_class = NULL;

VALA_EXTERN GType slideshow_page_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SlideshowPage* slideshow_page_new (SourceCollection* sources,
                                   ViewCollection* controller,
                                   Photo* start);
VALA_EXTERN SlideshowPage* slideshow_page_construct (GType object_type,
                                         SourceCollection* sources,
                                         ViewCollection* controller,
                                         Photo* start);
static void slideshow_page_real_switched_to (Page* base);
VALA_EXTERN SourceCollection* slideshow_page_get_sources (SlideshowPage* self);
static gboolean slideshow_page_get_next_photo (SlideshowPage* self,
                                        Photo* start,
                                        Direction direction,
                                        Photo** next,
                                        GdkPixbuf** next_pixbuf);
static gboolean slideshow_page_auto_advance (SlideshowPage* self);
static gboolean _slideshow_page_auto_advance_gsource_func (gpointer self);
static void slideshow_page_inhibit_screensaver (SlideshowPage* self);
static void slideshow_page_real_switching_from (Page* base);
static void slideshow_page_uninhibit_screensaver (SlideshowPage* self);
VALA_EXTERN ViewCollection* slideshow_page_get_controller (SlideshowPage* self);
static void slideshow_page_on_play_pause (SlideshowPage* self);
static void slideshow_page_real_on_previous_photo (SinglePhotoPage* base);
static void slideshow_page_advance (SlideshowPage* self,
                             Photo* photo,
                             Direction direction);
static void slideshow_page_real_on_next_photo (SinglePhotoPage* base);
static void slideshow_page_random_transition_effect (SlideshowPage* self);
static gboolean slideshow_page_real_button_press_event (GtkWidget* base,
                                                 GdkEventButton* event);
static gboolean slideshow_page_real_key_press_event (GtkWidget* base,
                                              GdkEventKey* event);
static void slideshow_page_update_transition_effect (SlideshowPage* self);
static gdouble slideshow_page_calculate_effect_delay (SlideshowPage* self);
static void slideshow_page_paint_title (SlideshowPage* self,
                                 cairo_t* ctx,
                                 Dimensions* ctx_dim);
VALA_EXTERN void set_source_color_from_string (cairo_t* ctx,
                                   const gchar* spec);
static void slideshow_page_real_paint (SinglePhotoPage* base,
                                cairo_t* ctx,
                                Dimensions* ctx_dim);
static void slideshow_page_set_sources (SlideshowPage* self,
                                 SourceCollection* value);
static void slideshow_page_set_controller (SlideshowPage* self,
                                    ViewCollection* value);
static GObject * slideshow_page_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void _slideshow_page___lambda32_ (SlideshowPage* self);
static void __slideshow_page___lambda32__g_settings_changed (GSettings* _sender,
                                                      const gchar* key,
                                                      gpointer self);
static void _single_photo_page_on_previous_photo_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void _slideshow_page_on_play_pause_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _single_photo_page_on_next_photo_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static void _slideshow_page___lambda38_ (Block24Data* _data24_);
static void __slideshow_page___lambda38__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self);
static void _slideshow_page___lambda39_ (Block24Data* _data24_);
static void __slideshow_page___lambda39__gtk_range_value_changed (GtkRange* _sender,
                                                           gpointer self);
static void slideshow_page_finalize (GObject * obj);
static GType slideshow_page_get_type_once (void);
static void _vala_slideshow_page_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_slideshow_page_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
slideshow_page_get_instance_private (SlideshowPage* self)
{
	return G_STRUCT_MEMBER_P (self, SlideshowPage_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "../src/Views/SlideshowPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 217 "SlideshowPage.c"
}

SlideshowPage*
slideshow_page_construct (GType object_type,
                          SourceCollection* sources,
                          ViewCollection* controller,
                          Photo* start)
{
	SlideshowPage * self = NULL;
	Photo* _tmp0_;
#line 40 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 40 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 40 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (start != NULL, NULL);
#line 41 "../src/Views/SlideshowPage.vala"
	self = (SlideshowPage*) g_object_new (object_type, "controller", controller, "page-name", _ ("Slideshow"), "scale-up-to-viewport", TRUE, "sources", sources, NULL);
#line 48 "../src/Views/SlideshowPage.vala"
	_tmp0_ = _g_object_ref0 (start);
#line 48 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->current);
#line 48 "../src/Views/SlideshowPage.vala"
	self->priv->current = _tmp0_;
#line 40 "../src/Views/SlideshowPage.vala"
	return self;
#line 244 "SlideshowPage.c"
}

SlideshowPage*
slideshow_page_new (SourceCollection* sources,
                    ViewCollection* controller,
                    Photo* start)
{
#line 40 "../src/Views/SlideshowPage.vala"
	return slideshow_page_construct (TYPE_SLIDESHOW_PAGE, sources, controller, start);
#line 254 "SlideshowPage.c"
}

static gboolean
_slideshow_page_auto_advance_gsource_func (gpointer self)
{
	gboolean result;
	result = slideshow_page_auto_advance ((SlideshowPage*) self);
#line 132 "../src/Views/SlideshowPage.vala"
	return result;
#line 264 "SlideshowPage.c"
}

static void
slideshow_page_real_switched_to (Page* base)
{
	SlideshowPage * self;
	SourceCollection* _tmp0_;
	Scaling _tmp1_ = {0};
	PixbufCache* _tmp2_;
	GdkPixbuf* pixbuf = NULL;
	Photo* _tmp3_;
	Photo* _tmp4_ = NULL;
	GdkPixbuf* _tmp5_ = NULL;
	gboolean _tmp6_;
	GTimer* _tmp11_;
#line 120 "../src/Views/SlideshowPage.vala"
	self = (SlideshowPage*) base;
#line 121 "../src/Views/SlideshowPage.vala"
	PAGE_CLASS (slideshow_page_parent_class)->switched_to ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage));
#line 124 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->_sources;
#line 124 "../src/Views/SlideshowPage.vala"
	single_photo_page_get_canvas_scaling ((SinglePhotoPage*) self, &_tmp1_);
#line 124 "../src/Views/SlideshowPage.vala"
	_tmp2_ = pixbuf_cache_new (_tmp0_, PIXBUF_CACHE_PHOTO_TYPE_BASELINE, &_tmp1_, SLIDESHOW_PAGE_READAHEAD_COUNT, NULL, NULL);
#line 124 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->cache);
#line 124 "../src/Views/SlideshowPage.vala"
	self->priv->cache = _tmp2_;
#line 128 "../src/Views/SlideshowPage.vala"
	_tmp3_ = self->priv->current;
#line 128 "../src/Views/SlideshowPage.vala"
	_tmp6_ = slideshow_page_get_next_photo (self, _tmp3_, DIRECTION_FORWARD, &_tmp4_, &_tmp5_);
#line 128 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->current);
#line 128 "../src/Views/SlideshowPage.vala"
	self->priv->current = _tmp4_;
#line 128 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (pixbuf);
#line 128 "../src/Views/SlideshowPage.vala"
	pixbuf = _tmp5_;
#line 128 "../src/Views/SlideshowPage.vala"
	if (_tmp6_) {
#line 308 "SlideshowPage.c"
		GdkPixbuf* _tmp7_;
		Photo* _tmp8_;
		Dimensions _tmp9_ = {0};
		Direction _tmp10_;
#line 129 "../src/Views/SlideshowPage.vala"
		_tmp7_ = pixbuf;
#line 129 "../src/Views/SlideshowPage.vala"
		_tmp8_ = self->priv->current;
#line 129 "../src/Views/SlideshowPage.vala"
		media_source_get_dimensions ((MediaSource*) _tmp8_, PHOTO_EXCEPTION_NONE, &_tmp9_);
#line 129 "../src/Views/SlideshowPage.vala"
		_tmp10_ = DIRECTION_FORWARD;
#line 129 "../src/Views/SlideshowPage.vala"
		single_photo_page_set_pixbuf ((SinglePhotoPage*) self, _tmp7_, &_tmp9_, &_tmp10_);
#line 323 "SlideshowPage.c"
	}
#line 132 "../src/Views/SlideshowPage.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) SLIDESHOW_PAGE_CHECK_ADVANCE_MSEC, _slideshow_page_auto_advance_gsource_func, g_object_ref (self), g_object_unref);
#line 133 "../src/Views/SlideshowPage.vala"
	_tmp11_ = self->priv->timer;
#line 133 "../src/Views/SlideshowPage.vala"
	g_timer_start (_tmp11_);
#line 135 "../src/Views/SlideshowPage.vala"
	slideshow_page_inhibit_screensaver (self);
#line 120 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (pixbuf);
#line 335 "SlideshowPage.c"
}

static void
slideshow_page_real_switching_from (Page* base)
{
	SlideshowPage * self;
#line 138 "../src/Views/SlideshowPage.vala"
	self = (SlideshowPage*) base;
#line 139 "../src/Views/SlideshowPage.vala"
	PAGE_CLASS (slideshow_page_parent_class)->switching_from ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage));
#line 140 "../src/Views/SlideshowPage.vala"
	slideshow_page_uninhibit_screensaver (self);
#line 141 "../src/Views/SlideshowPage.vala"
	self->priv->exiting = TRUE;
#line 350 "SlideshowPage.c"
}

static gboolean
slideshow_page_get_next_photo (SlideshowPage* self,
                               Photo* start,
                               Direction direction,
                               Photo** next,
                               GdkPixbuf** next_pixbuf)
{
	Photo* _vala_next = NULL;
	GdkPixbuf* _vala_next_pixbuf = NULL;
	Photo* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 144 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 144 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (start != NULL, FALSE);
#line 146 "../src/Views/SlideshowPage.vala"
	_tmp0_ = _g_object_ref0 (start);
#line 146 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (_vala_next);
#line 146 "../src/Views/SlideshowPage.vala"
	_vala_next = _tmp0_;
#line 375 "SlideshowPage.c"
	{
		gboolean _tmp1_ = FALSE;
#line 148 "../src/Views/SlideshowPage.vala"
		_tmp1_ = TRUE;
#line 148 "../src/Views/SlideshowPage.vala"
		while (TRUE) {
#line 382 "SlideshowPage.c"
			DataSource* forward = NULL;
			DataSource* back = NULL;
			ViewCollection* _tmp39_;
			Photo* _tmp40_;
			DataSource* _tmp41_ = NULL;
			DataSource* _tmp42_ = NULL;
			PixbufCache* _tmp43_;
			DataSource* _tmp44_;
			PixbufCache* _tmp45_;
			DataSource* _tmp46_;
			GeeSet* neighbors = NULL;
			ViewCollection* _tmp47_;
			Photo* _tmp48_;
			GeeSet* _tmp49_;
			GeeSet* _tmp50_;
			DataSource* _tmp51_;
			GeeSet* _tmp52_;
			DataSource* _tmp53_;
			PixbufCache* _tmp54_;
			GeeSet* _tmp55_;
#line 148 "../src/Views/SlideshowPage.vala"
			if (!_tmp1_) {
#line 405 "SlideshowPage.c"
			}
#line 148 "../src/Views/SlideshowPage.vala"
			_tmp1_ = FALSE;
#line 409 "SlideshowPage.c"
			{
				GdkPixbuf* _tmp2_ = NULL;
				PixbufCache* _tmp3_;
				Photo* _tmp4_;
				GdkPixbuf* _tmp5_;
				GdkPixbuf* _tmp6_;
#line 151 "../src/Views/SlideshowPage.vala"
				_tmp3_ = self->priv->cache;
#line 151 "../src/Views/SlideshowPage.vala"
				_tmp4_ = _vala_next;
#line 151 "../src/Views/SlideshowPage.vala"
				_tmp5_ = pixbuf_cache_fetch (_tmp3_, _tmp4_, &_inner_error0_);
#line 151 "../src/Views/SlideshowPage.vala"
				_tmp2_ = _tmp5_;
#line 151 "../src/Views/SlideshowPage.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 426 "SlideshowPage.c"
					goto __catch0_g_error;
				}
#line 151 "../src/Views/SlideshowPage.vala"
				_tmp6_ = _tmp2_;
#line 151 "../src/Views/SlideshowPage.vala"
				_tmp2_ = NULL;
#line 151 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (_vala_next_pixbuf);
#line 151 "../src/Views/SlideshowPage.vala"
				_vala_next_pixbuf = _tmp6_;
#line 149 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (_tmp2_);
#line 439 "SlideshowPage.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				Photo* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				GError* _tmp10_;
				const gchar* _tmp11_;
				DataView* view = NULL;
				ViewCollection* _tmp12_;
				Photo* _tmp13_;
				DataView* _tmp14_;
				DataView* _tmp15_ = NULL;
				DataView* _tmp22_;
				DataView* _tmp23_;
				DataSource* _tmp24_;
				DataSource* _tmp25_;
				Photo* _tmp26_;
				gboolean _tmp27_ = FALSE;
				gboolean _tmp28_ = FALSE;
				Photo* _tmp29_;
#line 149 "../src/Views/SlideshowPage.vala"
				err = _inner_error0_;
#line 149 "../src/Views/SlideshowPage.vala"
				_inner_error0_ = NULL;
#line 153 "../src/Views/SlideshowPage.vala"
				_tmp7_ = _vala_next;
#line 153 "../src/Views/SlideshowPage.vala"
				_tmp8_ = data_object_to_string ((DataObject*) _tmp7_);
#line 153 "../src/Views/SlideshowPage.vala"
				_tmp9_ = _tmp8_;
#line 153 "../src/Views/SlideshowPage.vala"
				_tmp10_ = err;
#line 153 "../src/Views/SlideshowPage.vala"
				_tmp11_ = _tmp10_->message;
#line 153 "../src/Views/SlideshowPage.vala"
				g_warning ("SlideshowPage.vala:153: Unable to fetch pixbuf for %s: %s", _tmp9_, _tmp11_);
#line 153 "../src/Views/SlideshowPage.vala"
				_g_free0 (_tmp9_);
#line 156 "../src/Views/SlideshowPage.vala"
				_tmp12_ = self->priv->_controller;
#line 156 "../src/Views/SlideshowPage.vala"
				_tmp13_ = _vala_next;
#line 156 "../src/Views/SlideshowPage.vala"
				_tmp14_ = view_collection_get_view_for_source (_tmp12_, (DataSource*) _tmp13_);
#line 156 "../src/Views/SlideshowPage.vala"
				view = _tmp14_;
#line 157 "../src/Views/SlideshowPage.vala"
				if (direction == DIRECTION_FORWARD) {
#line 491 "SlideshowPage.c"
					ViewCollection* _tmp16_;
					DataView* _tmp17_;
					DataView* _tmp18_;
#line 158 "../src/Views/SlideshowPage.vala"
					_tmp16_ = self->priv->_controller;
#line 158 "../src/Views/SlideshowPage.vala"
					_tmp17_ = view;
#line 158 "../src/Views/SlideshowPage.vala"
					_tmp18_ = view_collection_get_next (_tmp16_, _tmp17_);
#line 158 "../src/Views/SlideshowPage.vala"
					_g_object_unref0 (_tmp15_);
#line 158 "../src/Views/SlideshowPage.vala"
					_tmp15_ = _tmp18_;
#line 505 "SlideshowPage.c"
				} else {
					ViewCollection* _tmp19_;
					DataView* _tmp20_;
					DataView* _tmp21_;
#line 159 "../src/Views/SlideshowPage.vala"
					_tmp19_ = self->priv->_controller;
#line 159 "../src/Views/SlideshowPage.vala"
					_tmp20_ = view;
#line 159 "../src/Views/SlideshowPage.vala"
					_tmp21_ = view_collection_get_previous (_tmp19_, _tmp20_);
#line 159 "../src/Views/SlideshowPage.vala"
					_g_object_unref0 (_tmp15_);
#line 159 "../src/Views/SlideshowPage.vala"
					_tmp15_ = _tmp21_;
#line 520 "SlideshowPage.c"
				}
#line 157 "../src/Views/SlideshowPage.vala"
				_tmp22_ = _g_object_ref0 (_tmp15_);
#line 157 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (view);
#line 157 "../src/Views/SlideshowPage.vala"
				view = _tmp22_;
#line 160 "../src/Views/SlideshowPage.vala"
				_tmp23_ = view;
#line 160 "../src/Views/SlideshowPage.vala"
				_tmp24_ = data_view_get_source (_tmp23_);
#line 160 "../src/Views/SlideshowPage.vala"
				_tmp25_ = _tmp24_;
#line 160 "../src/Views/SlideshowPage.vala"
				_tmp26_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO, Photo));
#line 160 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (_vala_next);
#line 160 "../src/Views/SlideshowPage.vala"
				_vala_next = _tmp26_;
#line 163 "../src/Views/SlideshowPage.vala"
				_tmp29_ = _vala_next;
#line 163 "../src/Views/SlideshowPage.vala"
				if (_tmp29_ == start) {
#line 544 "SlideshowPage.c"
					Photo* _tmp30_;
					Photo* _tmp31_;
#line 163 "../src/Views/SlideshowPage.vala"
					_tmp30_ = _vala_next;
#line 163 "../src/Views/SlideshowPage.vala"
					_tmp31_ = self->priv->current;
#line 163 "../src/Views/SlideshowPage.vala"
					_tmp28_ = _tmp30_ != _tmp31_;
#line 553 "SlideshowPage.c"
				} else {
#line 163 "../src/Views/SlideshowPage.vala"
					_tmp28_ = FALSE;
#line 557 "SlideshowPage.c"
				}
#line 163 "../src/Views/SlideshowPage.vala"
				if (_tmp28_) {
#line 163 "../src/Views/SlideshowPage.vala"
					_tmp27_ = TRUE;
#line 563 "SlideshowPage.c"
				} else {
					Photo* _tmp32_;
					Photo* _tmp33_;
#line 163 "../src/Views/SlideshowPage.vala"
					_tmp32_ = _vala_next;
#line 163 "../src/Views/SlideshowPage.vala"
					_tmp33_ = self->priv->current;
#line 163 "../src/Views/SlideshowPage.vala"
					_tmp27_ = _tmp32_ == _tmp33_;
#line 573 "SlideshowPage.c"
				}
#line 163 "../src/Views/SlideshowPage.vala"
				if (_tmp27_) {
#line 577 "SlideshowPage.c"
					GtkWindow* _tmp34_;
					GtkWindow* _tmp35_;
					AppWindow* _tmp36_;
					AppWindow* _tmp37_;
#line 164 "../src/Views/SlideshowPage.vala"
					_tmp34_ = page_get_container ((Page*) self);
#line 164 "../src/Views/SlideshowPage.vala"
					_tmp35_ = _tmp34_;
#line 164 "../src/Views/SlideshowPage.vala"
					app_window_error_message (_ ("All photo source files are missing."), NULL, _tmp35_);
#line 164 "../src/Views/SlideshowPage.vala"
					_g_object_unref0 (_tmp35_);
#line 165 "../src/Views/SlideshowPage.vala"
					_tmp36_ = app_window_get_instance ();
#line 165 "../src/Views/SlideshowPage.vala"
					_tmp37_ = _tmp36_;
#line 165 "../src/Views/SlideshowPage.vala"
					app_window_end_fullscreen (_tmp37_);
#line 165 "../src/Views/SlideshowPage.vala"
					_g_object_unref0 (_tmp37_);
#line 167 "../src/Views/SlideshowPage.vala"
					_g_object_unref0 (_vala_next);
#line 167 "../src/Views/SlideshowPage.vala"
					_vala_next = NULL;
#line 168 "../src/Views/SlideshowPage.vala"
					_g_object_unref0 (_vala_next_pixbuf);
#line 168 "../src/Views/SlideshowPage.vala"
					_vala_next_pixbuf = NULL;
#line 170 "../src/Views/SlideshowPage.vala"
					result = FALSE;
#line 170 "../src/Views/SlideshowPage.vala"
					_g_object_unref0 (_tmp15_);
#line 170 "../src/Views/SlideshowPage.vala"
					_g_object_unref0 (view);
#line 170 "../src/Views/SlideshowPage.vala"
					_g_error_free0 (err);
#line 170 "../src/Views/SlideshowPage.vala"
					if (next) {
#line 170 "../src/Views/SlideshowPage.vala"
						*next = _vala_next;
#line 618 "SlideshowPage.c"
					} else {
#line 170 "../src/Views/SlideshowPage.vala"
						_g_object_unref0 (_vala_next);
#line 622 "SlideshowPage.c"
					}
#line 170 "../src/Views/SlideshowPage.vala"
					if (next_pixbuf) {
#line 170 "../src/Views/SlideshowPage.vala"
						*next_pixbuf = _vala_next_pixbuf;
#line 628 "SlideshowPage.c"
					} else {
#line 170 "../src/Views/SlideshowPage.vala"
						_g_object_unref0 (_vala_next_pixbuf);
#line 632 "SlideshowPage.c"
					}
#line 170 "../src/Views/SlideshowPage.vala"
					return result;
#line 636 "SlideshowPage.c"
				}
#line 173 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (_tmp15_);
#line 173 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (view);
#line 173 "../src/Views/SlideshowPage.vala"
				_g_error_free0 (err);
#line 173 "../src/Views/SlideshowPage.vala"
				continue;
#line 646 "SlideshowPage.c"
			}
			__finally0:
#line 149 "../src/Views/SlideshowPage.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 651 "SlideshowPage.c"
				gboolean _tmp38_ = FALSE;
#line 149 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (_vala_next);
#line 149 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (_vala_next_pixbuf);
#line 149 "../src/Views/SlideshowPage.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/Views/SlideshowPage.vala"
				g_clear_error (&_inner_error0_);
#line 149 "../src/Views/SlideshowPage.vala"
				return _tmp38_;
#line 663 "SlideshowPage.c"
			}
#line 179 "../src/Views/SlideshowPage.vala"
			_tmp39_ = self->priv->_controller;
#line 179 "../src/Views/SlideshowPage.vala"
			_tmp40_ = _vala_next;
#line 179 "../src/Views/SlideshowPage.vala"
			view_collection_get_immediate_neighbors (_tmp39_, (DataSource*) _tmp40_, &_tmp41_, &_tmp42_, PHOTO_TYPENAME);
#line 179 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (forward);
#line 179 "../src/Views/SlideshowPage.vala"
			forward = _tmp41_;
#line 179 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (back);
#line 179 "../src/Views/SlideshowPage.vala"
			back = _tmp42_;
#line 180 "../src/Views/SlideshowPage.vala"
			_tmp43_ = self->priv->cache;
#line 180 "../src/Views/SlideshowPage.vala"
			_tmp44_ = forward;
#line 180 "../src/Views/SlideshowPage.vala"
			pixbuf_cache_prefetch (_tmp43_, G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, TYPE_PHOTO, Photo), BACKGROUND_JOB_JOB_PRIORITY_HIGHEST, FALSE);
#line 181 "../src/Views/SlideshowPage.vala"
			_tmp45_ = self->priv->cache;
#line 181 "../src/Views/SlideshowPage.vala"
			_tmp46_ = back;
#line 181 "../src/Views/SlideshowPage.vala"
			pixbuf_cache_prefetch (_tmp45_, G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, TYPE_PHOTO, Photo), BACKGROUND_JOB_JOB_PRIORITY_NORMAL, FALSE);
#line 183 "../src/Views/SlideshowPage.vala"
			_tmp47_ = self->priv->_controller;
#line 183 "../src/Views/SlideshowPage.vala"
			_tmp48_ = _vala_next;
#line 183 "../src/Views/SlideshowPage.vala"
			_tmp49_ = view_collection_get_extended_neighbors (_tmp47_, (DataSource*) _tmp48_, PHOTO_TYPENAME);
#line 183 "../src/Views/SlideshowPage.vala"
			neighbors = _tmp49_;
#line 184 "../src/Views/SlideshowPage.vala"
			_tmp50_ = neighbors;
#line 184 "../src/Views/SlideshowPage.vala"
			_tmp51_ = forward;
#line 184 "../src/Views/SlideshowPage.vala"
			gee_collection_remove ((GeeCollection*) _tmp50_, _tmp51_);
#line 185 "../src/Views/SlideshowPage.vala"
			_tmp52_ = neighbors;
#line 185 "../src/Views/SlideshowPage.vala"
			_tmp53_ = back;
#line 185 "../src/Views/SlideshowPage.vala"
			gee_collection_remove ((GeeCollection*) _tmp52_, _tmp53_);
#line 187 "../src/Views/SlideshowPage.vala"
			_tmp54_ = self->priv->cache;
#line 187 "../src/Views/SlideshowPage.vala"
			_tmp55_ = neighbors;
#line 187 "../src/Views/SlideshowPage.vala"
			pixbuf_cache_prefetch_many (_tmp54_, G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, GEE_TYPE_COLLECTION, GeeCollection), BACKGROUND_JOB_JOB_PRIORITY_LOWEST, FALSE);
#line 189 "../src/Views/SlideshowPage.vala"
			result = TRUE;
#line 189 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (neighbors);
#line 189 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (back);
#line 189 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (forward);
#line 189 "../src/Views/SlideshowPage.vala"
			if (next) {
#line 189 "../src/Views/SlideshowPage.vala"
				*next = _vala_next;
#line 729 "SlideshowPage.c"
			} else {
#line 189 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (_vala_next);
#line 733 "SlideshowPage.c"
			}
#line 189 "../src/Views/SlideshowPage.vala"
			if (next_pixbuf) {
#line 189 "../src/Views/SlideshowPage.vala"
				*next_pixbuf = _vala_next_pixbuf;
#line 739 "SlideshowPage.c"
			} else {
#line 189 "../src/Views/SlideshowPage.vala"
				_g_object_unref0 (_vala_next_pixbuf);
#line 743 "SlideshowPage.c"
			}
#line 189 "../src/Views/SlideshowPage.vala"
			return result;
#line 747 "SlideshowPage.c"
		}
	}
}

static void
slideshow_page_on_play_pause (SlideshowPage* self)
{
	GTimer* _tmp8_;
#line 193 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/Views/SlideshowPage.vala"
	if (self->priv->playing) {
#line 760 "SlideshowPage.c"
		GtkButton* _tmp0_;
		GtkImage* _tmp1_;
		GtkImage* _tmp2_;
		GtkButton* _tmp3_;
#line 195 "../src/Views/SlideshowPage.vala"
		_tmp0_ = self->priv->play_pause_button;
#line 195 "../src/Views/SlideshowPage.vala"
		_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 195 "../src/Views/SlideshowPage.vala"
		g_object_ref_sink (_tmp1_);
#line 195 "../src/Views/SlideshowPage.vala"
		_tmp2_ = _tmp1_;
#line 195 "../src/Views/SlideshowPage.vala"
		gtk_button_set_image (_tmp0_, (GtkWidget*) _tmp2_);
#line 195 "../src/Views/SlideshowPage.vala"
		_g_object_unref0 (_tmp2_);
#line 197 "../src/Views/SlideshowPage.vala"
		_tmp3_ = self->priv->play_pause_button;
#line 197 "../src/Views/SlideshowPage.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _ ("Continue the slideshow"));
#line 781 "SlideshowPage.c"
	} else {
		GtkButton* _tmp4_;
		GtkImage* _tmp5_;
		GtkImage* _tmp6_;
		GtkButton* _tmp7_;
#line 199 "../src/Views/SlideshowPage.vala"
		_tmp4_ = self->priv->play_pause_button;
#line 199 "../src/Views/SlideshowPage.vala"
		_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 199 "../src/Views/SlideshowPage.vala"
		g_object_ref_sink (_tmp5_);
#line 199 "../src/Views/SlideshowPage.vala"
		_tmp6_ = _tmp5_;
#line 199 "../src/Views/SlideshowPage.vala"
		gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp6_);
#line 199 "../src/Views/SlideshowPage.vala"
		_g_object_unref0 (_tmp6_);
#line 201 "../src/Views/SlideshowPage.vala"
		_tmp7_ = self->priv->play_pause_button;
#line 201 "../src/Views/SlideshowPage.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _ ("Pause the slideshow"));
#line 803 "SlideshowPage.c"
	}
#line 204 "../src/Views/SlideshowPage.vala"
	self->priv->playing = !self->priv->playing;
#line 207 "../src/Views/SlideshowPage.vala"
	_tmp8_ = self->priv->timer;
#line 207 "../src/Views/SlideshowPage.vala"
	g_timer_start (_tmp8_);
#line 811 "SlideshowPage.c"
}

static void
slideshow_page_real_on_previous_photo (SinglePhotoPage* base)
{
	SlideshowPage * self;
	DataView* view = NULL;
	ViewCollection* _tmp0_;
	Photo* _tmp1_;
	DataView* _tmp2_;
	Photo* prev_photo = NULL;
	DataView* start_view = NULL;
	ViewCollection* _tmp3_;
	DataView* _tmp4_;
	DataView* _tmp5_;
	DataView* prev_view = NULL;
	DataView* _tmp6_;
	DataView* _tmp7_;
	Photo* _tmp21_;
#line 210 "../src/Views/SlideshowPage.vala"
	self = (SlideshowPage*) base;
#line 211 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->_controller;
#line 211 "../src/Views/SlideshowPage.vala"
	_tmp1_ = self->priv->current;
#line 211 "../src/Views/SlideshowPage.vala"
	_tmp2_ = view_collection_get_view_for_source (_tmp0_, (DataSource*) _tmp1_);
#line 211 "../src/Views/SlideshowPage.vala"
	view = _tmp2_;
#line 213 "../src/Views/SlideshowPage.vala"
	prev_photo = NULL;
#line 214 "../src/Views/SlideshowPage.vala"
	_tmp3_ = self->priv->_controller;
#line 214 "../src/Views/SlideshowPage.vala"
	_tmp4_ = view;
#line 214 "../src/Views/SlideshowPage.vala"
	_tmp5_ = view_collection_get_previous (_tmp3_, _tmp4_);
#line 214 "../src/Views/SlideshowPage.vala"
	start_view = _tmp5_;
#line 215 "../src/Views/SlideshowPage.vala"
	_tmp6_ = start_view;
#line 215 "../src/Views/SlideshowPage.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 215 "../src/Views/SlideshowPage.vala"
	prev_view = _tmp7_;
#line 217 "../src/Views/SlideshowPage.vala"
	while (TRUE) {
#line 859 "SlideshowPage.c"
		DataView* _tmp8_;
		DataView* _tmp9_;
		DataSource* _tmp10_;
		DataSource* _tmp11_;
		ViewCollection* _tmp16_;
		DataView* _tmp17_;
		DataView* _tmp18_;
		DataView* _tmp19_;
		DataView* _tmp20_;
#line 217 "../src/Views/SlideshowPage.vala"
		_tmp8_ = prev_view;
#line 217 "../src/Views/SlideshowPage.vala"
		if (!(_tmp8_ != NULL)) {
#line 217 "../src/Views/SlideshowPage.vala"
			break;
#line 875 "SlideshowPage.c"
		}
#line 218 "../src/Views/SlideshowPage.vala"
		_tmp9_ = prev_view;
#line 218 "../src/Views/SlideshowPage.vala"
		_tmp10_ = data_view_get_source (_tmp9_);
#line 218 "../src/Views/SlideshowPage.vala"
		_tmp11_ = _tmp10_;
#line 218 "../src/Views/SlideshowPage.vala"
		if (IS_PHOTO (_tmp11_)) {
#line 885 "SlideshowPage.c"
			DataView* _tmp12_;
			DataSource* _tmp13_;
			DataSource* _tmp14_;
			Photo* _tmp15_;
#line 219 "../src/Views/SlideshowPage.vala"
			_tmp12_ = prev_view;
#line 219 "../src/Views/SlideshowPage.vala"
			_tmp13_ = data_view_get_source (_tmp12_);
#line 219 "../src/Views/SlideshowPage.vala"
			_tmp14_ = _tmp13_;
#line 219 "../src/Views/SlideshowPage.vala"
			_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO, Photo));
#line 219 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (prev_photo);
#line 219 "../src/Views/SlideshowPage.vala"
			prev_photo = _tmp15_;
#line 220 "../src/Views/SlideshowPage.vala"
			break;
#line 904 "SlideshowPage.c"
		}
#line 223 "../src/Views/SlideshowPage.vala"
		_tmp16_ = self->priv->_controller;
#line 223 "../src/Views/SlideshowPage.vala"
		_tmp17_ = prev_view;
#line 223 "../src/Views/SlideshowPage.vala"
		_tmp18_ = view_collection_get_previous (_tmp16_, _tmp17_);
#line 223 "../src/Views/SlideshowPage.vala"
		_g_object_unref0 (prev_view);
#line 223 "../src/Views/SlideshowPage.vala"
		prev_view = _tmp18_;
#line 225 "../src/Views/SlideshowPage.vala"
		_tmp19_ = prev_view;
#line 225 "../src/Views/SlideshowPage.vala"
		_tmp20_ = start_view;
#line 225 "../src/Views/SlideshowPage.vala"
		if (_tmp19_ == _tmp20_) {
#line 226 "../src/Views/SlideshowPage.vala"
			g_warning ("SlideshowPage.vala:226: on_previous( ): can't advance to previous phot" \
"o: collection has only videos");
#line 227 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (prev_view);
#line 227 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (start_view);
#line 227 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (prev_photo);
#line 227 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (view);
#line 227 "../src/Views/SlideshowPage.vala"
			return;
#line 934 "SlideshowPage.c"
		}
	}
#line 231 "../src/Views/SlideshowPage.vala"
	_tmp21_ = prev_photo;
#line 231 "../src/Views/SlideshowPage.vala"
	slideshow_page_advance (self, _tmp21_, DIRECTION_BACKWARD);
#line 210 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (prev_view);
#line 210 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (start_view);
#line 210 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (prev_photo);
#line 210 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (view);
#line 949 "SlideshowPage.c"
}

static void
slideshow_page_real_on_next_photo (SinglePhotoPage* base)
{
	SlideshowPage * self;
	DataView* view = NULL;
	ViewCollection* _tmp0_;
	Photo* _tmp1_;
	DataView* _tmp2_;
	Photo* next_photo = NULL;
	DataView* start_view = NULL;
	ViewCollection* _tmp3_;
	DataView* _tmp4_;
	DataView* _tmp5_;
	DataView* next_view = NULL;
	DataView* _tmp6_;
	DataView* _tmp7_;
	GSettings* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gboolean _tmp24_;
	Photo* _tmp25_;
#line 234 "../src/Views/SlideshowPage.vala"
	self = (SlideshowPage*) base;
#line 235 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->_controller;
#line 235 "../src/Views/SlideshowPage.vala"
	_tmp1_ = self->priv->current;
#line 235 "../src/Views/SlideshowPage.vala"
	_tmp2_ = view_collection_get_view_for_source (_tmp0_, (DataSource*) _tmp1_);
#line 235 "../src/Views/SlideshowPage.vala"
	view = _tmp2_;
#line 237 "../src/Views/SlideshowPage.vala"
	next_photo = NULL;
#line 238 "../src/Views/SlideshowPage.vala"
	_tmp3_ = self->priv->_controller;
#line 238 "../src/Views/SlideshowPage.vala"
	_tmp4_ = view;
#line 238 "../src/Views/SlideshowPage.vala"
	_tmp5_ = view_collection_get_next (_tmp3_, _tmp4_);
#line 238 "../src/Views/SlideshowPage.vala"
	start_view = _tmp5_;
#line 239 "../src/Views/SlideshowPage.vala"
	_tmp6_ = start_view;
#line 239 "../src/Views/SlideshowPage.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 239 "../src/Views/SlideshowPage.vala"
	next_view = _tmp7_;
#line 241 "../src/Views/SlideshowPage.vala"
	while (TRUE) {
#line 1001 "SlideshowPage.c"
		DataView* _tmp8_;
		DataView* _tmp9_;
		DataSource* _tmp10_;
		DataSource* _tmp11_;
		ViewCollection* _tmp16_;
		DataView* _tmp17_;
		DataView* _tmp18_;
		DataView* _tmp19_;
		DataView* _tmp20_;
#line 241 "../src/Views/SlideshowPage.vala"
		_tmp8_ = next_view;
#line 241 "../src/Views/SlideshowPage.vala"
		if (!(_tmp8_ != NULL)) {
#line 241 "../src/Views/SlideshowPage.vala"
			break;
#line 1017 "SlideshowPage.c"
		}
#line 242 "../src/Views/SlideshowPage.vala"
		_tmp9_ = next_view;
#line 242 "../src/Views/SlideshowPage.vala"
		_tmp10_ = data_view_get_source (_tmp9_);
#line 242 "../src/Views/SlideshowPage.vala"
		_tmp11_ = _tmp10_;
#line 242 "../src/Views/SlideshowPage.vala"
		if (IS_PHOTO (_tmp11_)) {
#line 1027 "SlideshowPage.c"
			DataView* _tmp12_;
			DataSource* _tmp13_;
			DataSource* _tmp14_;
			Photo* _tmp15_;
#line 243 "../src/Views/SlideshowPage.vala"
			_tmp12_ = next_view;
#line 243 "../src/Views/SlideshowPage.vala"
			_tmp13_ = data_view_get_source (_tmp12_);
#line 243 "../src/Views/SlideshowPage.vala"
			_tmp14_ = _tmp13_;
#line 243 "../src/Views/SlideshowPage.vala"
			_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO, Photo));
#line 243 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (next_photo);
#line 243 "../src/Views/SlideshowPage.vala"
			next_photo = _tmp15_;
#line 244 "../src/Views/SlideshowPage.vala"
			break;
#line 1046 "SlideshowPage.c"
		}
#line 247 "../src/Views/SlideshowPage.vala"
		_tmp16_ = self->priv->_controller;
#line 247 "../src/Views/SlideshowPage.vala"
		_tmp17_ = next_view;
#line 247 "../src/Views/SlideshowPage.vala"
		_tmp18_ = view_collection_get_next (_tmp16_, _tmp17_);
#line 247 "../src/Views/SlideshowPage.vala"
		_g_object_unref0 (next_view);
#line 247 "../src/Views/SlideshowPage.vala"
		next_view = _tmp18_;
#line 249 "../src/Views/SlideshowPage.vala"
		_tmp19_ = next_view;
#line 249 "../src/Views/SlideshowPage.vala"
		_tmp20_ = start_view;
#line 249 "../src/Views/SlideshowPage.vala"
		if (_tmp19_ == _tmp20_) {
#line 250 "../src/Views/SlideshowPage.vala"
			g_warning ("SlideshowPage.vala:250: on_next( ): can't advance to next photo: colle" \
"ction has only videos");
#line 251 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (next_view);
#line 251 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (start_view);
#line 251 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (next_photo);
#line 251 "../src/Views/SlideshowPage.vala"
			_g_object_unref0 (view);
#line 251 "../src/Views/SlideshowPage.vala"
			return;
#line 1076 "SlideshowPage.c"
		}
	}
#line 255 "../src/Views/SlideshowPage.vala"
	_tmp21_ = self->priv->slideshow_settings;
#line 255 "../src/Views/SlideshowPage.vala"
	_tmp22_ = g_settings_get_string (_tmp21_, "transition-effect-id");
#line 255 "../src/Views/SlideshowPage.vala"
	_tmp23_ = _tmp22_;
#line 255 "../src/Views/SlideshowPage.vala"
	_tmp24_ = g_strcmp0 (_tmp23_, RANDOM_EFFECT_DESCRIPTOR_EFFECT_ID) == 0;
#line 255 "../src/Views/SlideshowPage.vala"
	_g_free0 (_tmp23_);
#line 255 "../src/Views/SlideshowPage.vala"
	if (_tmp24_) {
#line 256 "../src/Views/SlideshowPage.vala"
		slideshow_page_random_transition_effect (self);
#line 1093 "SlideshowPage.c"
	}
#line 259 "../src/Views/SlideshowPage.vala"
	_tmp25_ = next_photo;
#line 259 "../src/Views/SlideshowPage.vala"
	slideshow_page_advance (self, _tmp25_, DIRECTION_FORWARD);
#line 234 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (next_view);
#line 234 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (start_view);
#line 234 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (next_photo);
#line 234 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (view);
#line 1107 "SlideshowPage.c"
}

static void
slideshow_page_advance (SlideshowPage* self,
                        Photo* photo,
                        Direction direction)
{
	Photo* _tmp0_;
	GdkPixbuf* next_pixbuf = NULL;
	Photo* _tmp1_;
	Photo* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	gboolean _tmp4_;
	GTimer* _tmp8_;
#line 262 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (photo != NULL);
#line 263 "../src/Views/SlideshowPage.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 263 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->current);
#line 263 "../src/Views/SlideshowPage.vala"
	self->priv->current = _tmp0_;
#line 267 "../src/Views/SlideshowPage.vala"
	_tmp1_ = self->priv->current;
#line 267 "../src/Views/SlideshowPage.vala"
	_tmp4_ = slideshow_page_get_next_photo (self, _tmp1_, direction, &_tmp2_, &_tmp3_);
#line 267 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->current);
#line 267 "../src/Views/SlideshowPage.vala"
	self->priv->current = _tmp2_;
#line 267 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (next_pixbuf);
#line 267 "../src/Views/SlideshowPage.vala"
	next_pixbuf = _tmp3_;
#line 267 "../src/Views/SlideshowPage.vala"
	if (_tmp4_) {
#line 1146 "SlideshowPage.c"
		GdkPixbuf* _tmp5_;
		Photo* _tmp6_;
		Dimensions _tmp7_ = {0};
#line 268 "../src/Views/SlideshowPage.vala"
		_tmp5_ = next_pixbuf;
#line 268 "../src/Views/SlideshowPage.vala"
		_tmp6_ = self->priv->current;
#line 268 "../src/Views/SlideshowPage.vala"
		media_source_get_dimensions ((MediaSource*) _tmp6_, PHOTO_EXCEPTION_NONE, &_tmp7_);
#line 268 "../src/Views/SlideshowPage.vala"
		single_photo_page_set_pixbuf ((SinglePhotoPage*) self, _tmp5_, &_tmp7_, &direction);
#line 1158 "SlideshowPage.c"
	}
#line 271 "../src/Views/SlideshowPage.vala"
	_tmp8_ = self->priv->timer;
#line 271 "../src/Views/SlideshowPage.vala"
	g_timer_start (_tmp8_);
#line 262 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (next_pixbuf);
#line 1166 "SlideshowPage.c"
}

static gboolean
slideshow_page_auto_advance (SlideshowPage* self)
{
	GTimer* _tmp0_;
	GSettings* _tmp1_;
	gboolean result;
#line 274 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 275 "../src/Views/SlideshowPage.vala"
	if (self->priv->exiting) {
#line 276 "../src/Views/SlideshowPage.vala"
		result = FALSE;
#line 276 "../src/Views/SlideshowPage.vala"
		return result;
#line 1183 "SlideshowPage.c"
	}
#line 278 "../src/Views/SlideshowPage.vala"
	if (!self->priv->playing) {
#line 279 "../src/Views/SlideshowPage.vala"
		result = TRUE;
#line 279 "../src/Views/SlideshowPage.vala"
		return result;
#line 1191 "SlideshowPage.c"
	}
#line 281 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->timer;
#line 281 "../src/Views/SlideshowPage.vala"
	_tmp1_ = self->priv->slideshow_settings;
#line 281 "../src/Views/SlideshowPage.vala"
	if (g_timer_elapsed (_tmp0_, NULL) < g_settings_get_double (_tmp1_, "delay")) {
#line 282 "../src/Views/SlideshowPage.vala"
		result = TRUE;
#line 282 "../src/Views/SlideshowPage.vala"
		return result;
#line 1203 "SlideshowPage.c"
	}
#line 284 "../src/Views/SlideshowPage.vala"
	single_photo_page_on_next_photo ((SinglePhotoPage*) self);
#line 286 "../src/Views/SlideshowPage.vala"
	result = TRUE;
#line 286 "../src/Views/SlideshowPage.vala"
	return result;
#line 1211 "SlideshowPage.c"
}

static gboolean
slideshow_page_real_button_press_event (GtkWidget* base,
                                        GdkEventButton* event)
{
	SlideshowPage * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 289 "../src/Views/SlideshowPage.vala"
	self = (SlideshowPage*) base;
#line 289 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 290 "../src/Views/SlideshowPage.vala"
	if (event->type == GDK_DOUBLE_BUTTON_PRESS) {
#line 290 "../src/Views/SlideshowPage.vala"
		_tmp0_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
#line 1229 "SlideshowPage.c"
	} else {
#line 290 "../src/Views/SlideshowPage.vala"
		_tmp0_ = FALSE;
#line 1233 "SlideshowPage.c"
	}
#line 290 "../src/Views/SlideshowPage.vala"
	if (_tmp0_) {
#line 1237 "SlideshowPage.c"
		AppWindow* _tmp1_;
		AppWindow* _tmp2_;
#line 291 "../src/Views/SlideshowPage.vala"
		g_signal_emit (self, slideshow_page_signals[SLIDESHOW_PAGE_HIDE_TOOLBAR_SIGNAL], 0);
#line 292 "../src/Views/SlideshowPage.vala"
		_tmp1_ = app_window_get_instance ();
#line 292 "../src/Views/SlideshowPage.vala"
		_tmp2_ = _tmp1_;
#line 292 "../src/Views/SlideshowPage.vala"
		app_window_end_fullscreen (_tmp2_);
#line 292 "../src/Views/SlideshowPage.vala"
		_g_object_unref0 (_tmp2_);
#line 293 "../src/Views/SlideshowPage.vala"
		page_switching_from ((Page*) self);
#line 1252 "SlideshowPage.c"
	}
#line 295 "../src/Views/SlideshowPage.vala"
	result = FALSE;
#line 295 "../src/Views/SlideshowPage.vala"
	return result;
#line 1258 "SlideshowPage.c"
}

static gboolean
slideshow_page_real_key_press_event (GtkWidget* base,
                                     GdkEventKey* event)
{
	SlideshowPage * self;
	gboolean handled = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 300 "../src/Views/SlideshowPage.vala"
	static GQuark _tmp2_label0 = 0;
#line 1272 "SlideshowPage.c"
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 298 "../src/Views/SlideshowPage.vala"
	self = (SlideshowPage*) base;
#line 298 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 299 "../src/Views/SlideshowPage.vala"
	handled = TRUE;
#line 300 "../src/Views/SlideshowPage.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 300 "../src/Views/SlideshowPage.vala"
	_tmp1_ = _tmp0_;
#line 300 "../src/Views/SlideshowPage.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 300 "../src/Views/SlideshowPage.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("space")))) {
#line 300 "../src/Views/SlideshowPage.vala"
		switch (0) {
#line 1291 "SlideshowPage.c"
			default:
			{
#line 302 "../src/Views/SlideshowPage.vala"
				slideshow_page_on_play_pause (self);
#line 303 "../src/Views/SlideshowPage.vala"
				break;
#line 1298 "SlideshowPage.c"
			}
		}
	} else {
#line 300 "../src/Views/SlideshowPage.vala"
		switch (0) {
#line 1304 "SlideshowPage.c"
			default:
			{
#line 306 "../src/Views/SlideshowPage.vala"
				handled = FALSE;
#line 307 "../src/Views/SlideshowPage.vala"
				break;
#line 1311 "SlideshowPage.c"
			}
		}
	}
#line 310 "../src/Views/SlideshowPage.vala"
	if (handled) {
#line 311 "../src/Views/SlideshowPage.vala"
		result = TRUE;
#line 311 "../src/Views/SlideshowPage.vala"
		return result;
#line 1321 "SlideshowPage.c"
	}
#line 313 "../src/Views/SlideshowPage.vala"
	if (GTK_WIDGET_CLASS (slideshow_page_parent_class)->key_press_event != NULL) {
#line 313 "../src/Views/SlideshowPage.vala"
		_tmp4_ = GTK_WIDGET_CLASS (slideshow_page_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage), event);
#line 1327 "SlideshowPage.c"
	} else {
#line 313 "../src/Views/SlideshowPage.vala"
		_tmp4_ = TRUE;
#line 1331 "SlideshowPage.c"
	}
#line 313 "../src/Views/SlideshowPage.vala"
	result = _tmp4_;
#line 313 "../src/Views/SlideshowPage.vala"
	return result;
#line 1337 "SlideshowPage.c"
}

static void
slideshow_page_update_transition_effect (SlideshowPage* self)
{
	gchar* effect_id = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gdouble effect_delay = 0.0;
#line 316 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 317 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->slideshow_settings;
#line 317 "../src/Views/SlideshowPage.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "transition-effect-id");
#line 317 "../src/Views/SlideshowPage.vala"
	effect_id = _tmp1_;
#line 318 "../src/Views/SlideshowPage.vala"
	effect_delay = slideshow_page_calculate_effect_delay (self);
#line 320 "../src/Views/SlideshowPage.vala"
	single_photo_page_set_transition ((SinglePhotoPage*) self, effect_id, (gint) (effect_delay * 1000.0));
#line 316 "../src/Views/SlideshowPage.vala"
	_g_free0 (effect_id);
#line 1361 "SlideshowPage.c"
}

static void
slideshow_page_random_transition_effect (SlideshowPage* self)
{
	gdouble effect_delay = 0.0;
	gchar* effect_id = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp6_;
#line 323 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/Views/SlideshowPage.vala"
	effect_delay = slideshow_page_calculate_effect_delay (self);
#line 325 "../src/Views/SlideshowPage.vala"
	_tmp0_ = g_strdup (TRANSITION_EFFECTS_MANAGER_NULL_EFFECT_ID);
#line 325 "../src/Views/SlideshowPage.vala"
	effect_id = _tmp0_;
#line 326 "../src/Views/SlideshowPage.vala"
	_tmp1_ = self->priv->transitions;
#line 326 "../src/Views/SlideshowPage.vala"
	_tmp1__length1 = self->priv->transitions_length1;
#line 326 "../src/Views/SlideshowPage.vala"
	if (0 < _tmp1__length1) {
#line 1387 "SlideshowPage.c"
		gint random = 0;
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 327 "../src/Views/SlideshowPage.vala"
		_tmp2_ = self->priv->transitions;
#line 327 "../src/Views/SlideshowPage.vala"
		_tmp2__length1 = self->priv->transitions_length1;
#line 327 "../src/Views/SlideshowPage.vala"
		random = (gint) g_random_int_range ((gint32) 0, (gint32) _tmp2__length1);
#line 328 "../src/Views/SlideshowPage.vala"
		_tmp3_ = self->priv->transitions;
#line 328 "../src/Views/SlideshowPage.vala"
		_tmp3__length1 = self->priv->transitions_length1;
#line 328 "../src/Views/SlideshowPage.vala"
		_tmp4_ = _tmp3_[random];
#line 328 "../src/Views/SlideshowPage.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 328 "../src/Views/SlideshowPage.vala"
		_g_free0 (effect_id);
#line 328 "../src/Views/SlideshowPage.vala"
		effect_id = _tmp5_;
#line 1413 "SlideshowPage.c"
	}
#line 330 "../src/Views/SlideshowPage.vala"
	_tmp6_ = effect_id;
#line 330 "../src/Views/SlideshowPage.vala"
	single_photo_page_set_transition ((SinglePhotoPage*) self, _tmp6_, (gint) (effect_delay * 1000.0));
#line 323 "../src/Views/SlideshowPage.vala"
	_g_free0 (effect_id);
#line 1421 "SlideshowPage.c"
}

static gdouble
slideshow_page_calculate_effect_delay (SlideshowPage* self)
{
	gdouble photo_delay = 0.0;
	GSettings* _tmp0_;
	gdouble effect_delay = 0.0;
	gdouble result;
#line 333 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 334 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->slideshow_settings;
#line 334 "../src/Views/SlideshowPage.vala"
	photo_delay = g_settings_get_double (_tmp0_, "delay");
#line 335 "../src/Views/SlideshowPage.vala"
	effect_delay = photo_delay / 7.0;
#line 337 "../src/Views/SlideshowPage.vala"
	if (effect_delay < 0.1) {
#line 338 "../src/Views/SlideshowPage.vala"
		effect_delay = 0.1;
#line 1443 "SlideshowPage.c"
	}
#line 341 "../src/Views/SlideshowPage.vala"
	if (effect_delay > 1.0) {
#line 342 "../src/Views/SlideshowPage.vala"
		effect_delay = 1.0;
#line 1449 "SlideshowPage.c"
	}
#line 345 "../src/Views/SlideshowPage.vala"
	result = effect_delay;
#line 345 "../src/Views/SlideshowPage.vala"
	return result;
#line 1455 "SlideshowPage.c"
}

static void
slideshow_page_paint_title (SlideshowPage* self,
                            cairo_t* ctx,
                            Dimensions* ctx_dim)
{
	gchar* title = NULL;
	Photo* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	PangoLayout* layout = NULL;
	const gchar* _tmp5_;
	PangoLayout* _tmp6_;
	PangoAttrList* list = NULL;
	PangoAttrList* _tmp7_;
	PangoAttribute* size = NULL;
	PangoAttribute* _tmp8_;
	PangoAttrList* _tmp9_;
	PangoAttribute* _tmp10_;
	PangoAttribute* _tmp11_;
	PangoLayout* _tmp12_;
	PangoAttrList* _tmp13_;
	PangoLayout* _tmp14_;
	Dimensions _tmp15_;
	gint title_width = 0;
	gint title_height = 0;
	PangoLayout* _tmp16_;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gdouble x = 0.0;
	Dimensions _tmp19_;
	gdouble y = 0.0;
	Dimensions _tmp20_;
	Dimensions _tmp21_;
	Dimensions _tmp23_;
	PangoLayout* _tmp25_;
	PangoLayout* _tmp26_;
#line 349 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 349 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (ctx != NULL);
#line 349 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (ctx_dim != NULL);
#line 350 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->current;
#line 350 "../src/Views/SlideshowPage.vala"
	_tmp1_ = media_source_get_title ((MediaSource*) _tmp0_);
#line 350 "../src/Views/SlideshowPage.vala"
	title = _tmp1_;
#line 353 "../src/Views/SlideshowPage.vala"
	_tmp3_ = title;
#line 353 "../src/Views/SlideshowPage.vala"
	if (_tmp3_ == NULL) {
#line 353 "../src/Views/SlideshowPage.vala"
		_tmp2_ = TRUE;
#line 1513 "SlideshowPage.c"
	} else {
		const gchar* _tmp4_;
#line 353 "../src/Views/SlideshowPage.vala"
		_tmp4_ = title;
#line 353 "../src/Views/SlideshowPage.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 1520 "SlideshowPage.c"
	}
#line 353 "../src/Views/SlideshowPage.vala"
	if (_tmp2_) {
#line 354 "../src/Views/SlideshowPage.vala"
		_g_free0 (title);
#line 354 "../src/Views/SlideshowPage.vala"
		return;
#line 1528 "SlideshowPage.c"
	}
#line 356 "../src/Views/SlideshowPage.vala"
	_tmp5_ = title;
#line 356 "../src/Views/SlideshowPage.vala"
	_tmp6_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp5_);
#line 356 "../src/Views/SlideshowPage.vala"
	layout = _tmp6_;
#line 357 "../src/Views/SlideshowPage.vala"
	_tmp7_ = pango_attr_list_new ();
#line 357 "../src/Views/SlideshowPage.vala"
	list = _tmp7_;
#line 358 "../src/Views/SlideshowPage.vala"
	_tmp8_ = pango_attr_scale_new ((gdouble) 3);
#line 358 "../src/Views/SlideshowPage.vala"
	size = _tmp8_;
#line 359 "../src/Views/SlideshowPage.vala"
	_tmp9_ = list;
#line 359 "../src/Views/SlideshowPage.vala"
	_tmp10_ = size;
#line 359 "../src/Views/SlideshowPage.vala"
	_tmp11_ = pango_attribute_copy (_tmp10_);
#line 359 "../src/Views/SlideshowPage.vala"
	pango_attr_list_insert (_tmp9_, _tmp11_);
#line 360 "../src/Views/SlideshowPage.vala"
	_tmp12_ = layout;
#line 360 "../src/Views/SlideshowPage.vala"
	_tmp13_ = list;
#line 360 "../src/Views/SlideshowPage.vala"
	pango_layout_set_attributes (_tmp12_, _tmp13_);
#line 361 "../src/Views/SlideshowPage.vala"
	_tmp14_ = layout;
#line 361 "../src/Views/SlideshowPage.vala"
	_tmp15_ = *ctx_dim;
#line 361 "../src/Views/SlideshowPage.vala"
	pango_layout_set_width (_tmp14_, (gint) ((_tmp15_.width * 0.9) * PANGO_SCALE));
#line 365 "../src/Views/SlideshowPage.vala"
	_tmp16_ = layout;
#line 365 "../src/Views/SlideshowPage.vala"
	pango_layout_get_pixel_size (_tmp16_, &_tmp17_, &_tmp18_);
#line 365 "../src/Views/SlideshowPage.vala"
	title_width = _tmp17_;
#line 365 "../src/Views/SlideshowPage.vala"
	title_height = _tmp18_;
#line 366 "../src/Views/SlideshowPage.vala"
	_tmp19_ = *ctx_dim;
#line 366 "../src/Views/SlideshowPage.vala"
	x = _tmp19_.width * 0.2;
#line 367 "../src/Views/SlideshowPage.vala"
	_tmp20_ = *ctx_dim;
#line 367 "../src/Views/SlideshowPage.vala"
	y = _tmp20_.height * 0.90;
#line 370 "../src/Views/SlideshowPage.vala"
	_tmp21_ = *ctx_dim;
#line 370 "../src/Views/SlideshowPage.vala"
	if ((y + title_height) >= (_tmp21_.height * 0.95)) {
#line 1584 "SlideshowPage.c"
		Dimensions _tmp22_;
#line 371 "../src/Views/SlideshowPage.vala"
		_tmp22_ = *ctx_dim;
#line 371 "../src/Views/SlideshowPage.vala"
		y = (_tmp22_.height * 0.95) - title_height;
#line 1590 "SlideshowPage.c"
	}
#line 373 "../src/Views/SlideshowPage.vala"
	_tmp23_ = *ctx_dim;
#line 373 "../src/Views/SlideshowPage.vala"
	if ((x + title_width) >= (_tmp23_.width * 0.95)) {
#line 1596 "SlideshowPage.c"
		Dimensions _tmp24_;
#line 374 "../src/Views/SlideshowPage.vala"
		_tmp24_ = *ctx_dim;
#line 374 "../src/Views/SlideshowPage.vala"
		x = (gdouble) ((_tmp24_.width / 2) - (title_width / 2));
#line 1602 "SlideshowPage.c"
	}
#line 376 "../src/Views/SlideshowPage.vala"
	set_source_color_from_string (ctx, "#fff");
#line 377 "../src/Views/SlideshowPage.vala"
	cairo_move_to (ctx, x, y);
#line 378 "../src/Views/SlideshowPage.vala"
	_tmp25_ = layout;
#line 378 "../src/Views/SlideshowPage.vala"
	pango_cairo_show_layout (ctx, _tmp25_);
#line 379 "../src/Views/SlideshowPage.vala"
	_tmp26_ = layout;
#line 379 "../src/Views/SlideshowPage.vala"
	pango_cairo_layout_path (ctx, _tmp26_);
#line 380 "../src/Views/SlideshowPage.vala"
	cairo_set_line_width (ctx, 1.5);
#line 381 "../src/Views/SlideshowPage.vala"
	set_source_color_from_string (ctx, "#000");
#line 382 "../src/Views/SlideshowPage.vala"
	cairo_stroke (ctx);
#line 349 "../src/Views/SlideshowPage.vala"
	_pango_attribute_destroy0 (size);
#line 349 "../src/Views/SlideshowPage.vala"
	_pango_attr_list_unref0 (list);
#line 349 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (layout);
#line 349 "../src/Views/SlideshowPage.vala"
	_g_free0 (title);
#line 1630 "SlideshowPage.c"
}

static void
slideshow_page_real_paint (SinglePhotoPage* base,
                           cairo_t* ctx,
                           Dimensions* ctx_dim)
{
	SlideshowPage * self;
	Dimensions _tmp0_;
	gboolean _tmp1_ = FALSE;
	GSettings* _tmp2_;
#line 385 "../src/Views/SlideshowPage.vala"
	self = (SlideshowPage*) base;
#line 385 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (ctx != NULL);
#line 385 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (ctx_dim != NULL);
#line 386 "../src/Views/SlideshowPage.vala"
	_tmp0_ = *ctx_dim;
#line 386 "../src/Views/SlideshowPage.vala"
	SINGLE_PHOTO_PAGE_CLASS (slideshow_page_parent_class)->paint (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage), ctx, &_tmp0_);
#line 388 "../src/Views/SlideshowPage.vala"
	_tmp2_ = self->priv->slideshow_settings;
#line 388 "../src/Views/SlideshowPage.vala"
	if (g_settings_get_boolean (_tmp2_, "show-title")) {
#line 388 "../src/Views/SlideshowPage.vala"
		_tmp1_ = !single_photo_page_is_transition_in_progress ((SinglePhotoPage*) self);
#line 1658 "SlideshowPage.c"
	} else {
#line 388 "../src/Views/SlideshowPage.vala"
		_tmp1_ = FALSE;
#line 1662 "SlideshowPage.c"
	}
#line 388 "../src/Views/SlideshowPage.vala"
	if (_tmp1_) {
#line 1666 "SlideshowPage.c"
		Dimensions _tmp3_;
#line 389 "../src/Views/SlideshowPage.vala"
		_tmp3_ = *ctx_dim;
#line 389 "../src/Views/SlideshowPage.vala"
		slideshow_page_paint_title (self, ctx, &_tmp3_);
#line 1672 "SlideshowPage.c"
	}
}

static void
slideshow_page_inhibit_screensaver (SlideshowPage* self)
{
	GApplication* _tmp0_;
#line 392 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 393 "../src/Views/SlideshowPage.vala"
	if (self->priv->cookie != ((guint32) 0)) {
#line 394 "../src/Views/SlideshowPage.vala"
		return;
#line 1686 "SlideshowPage.c"
	}
#line 397 "../src/Views/SlideshowPage.vala"
	_tmp0_ = g_application_get_default ();
#line 397 "../src/Views/SlideshowPage.vala"
	self->priv->cookie = (guint32) photos_application_app_inhibit (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTOS_TYPE_APPLICATION, PhotosApplication), GTK_APPLICATION_INHIBIT_IDLE | GTK_APPLICATION_INHIBIT_SUSPEND, _ ("Slideshow"));
#line 1692 "SlideshowPage.c"
}

static void
slideshow_page_uninhibit_screensaver (SlideshowPage* self)
{
	GApplication* _tmp0_;
#line 403 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 404 "../src/Views/SlideshowPage.vala"
	if (self->priv->cookie == ((guint32) 0)) {
#line 405 "../src/Views/SlideshowPage.vala"
		return;
#line 1705 "SlideshowPage.c"
	}
#line 408 "../src/Views/SlideshowPage.vala"
	_tmp0_ = g_application_get_default ();
#line 408 "../src/Views/SlideshowPage.vala"
	gtk_application_uninhibit ((GtkApplication*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTOS_TYPE_APPLICATION, PhotosApplication), (guint) self->priv->cookie);
#line 409 "../src/Views/SlideshowPage.vala"
	self->priv->cookie = (guint32) 0;
#line 1713 "SlideshowPage.c"
}

SourceCollection*
slideshow_page_get_sources (SlideshowPage* self)
{
	SourceCollection* result;
	SourceCollection* _tmp0_;
#line 37 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->_sources;
#line 37 "../src/Views/SlideshowPage.vala"
	result = _tmp0_;
#line 37 "../src/Views/SlideshowPage.vala"
	return result;
#line 1729 "SlideshowPage.c"
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 37 "../src/Views/SlideshowPage.vala"
	return self ? data_collection_ref (self) : NULL;
#line 1737 "SlideshowPage.c"
}

static void
slideshow_page_set_sources (SlideshowPage* self,
                            SourceCollection* value)
{
	SourceCollection* old_value;
#line 37 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Views/SlideshowPage.vala"
	old_value = slideshow_page_get_sources (self);
#line 37 "../src/Views/SlideshowPage.vala"
	if (old_value != value) {
#line 1751 "SlideshowPage.c"
		SourceCollection* _tmp0_;
#line 37 "../src/Views/SlideshowPage.vala"
		_tmp0_ = _data_collection_ref0 (value);
#line 37 "../src/Views/SlideshowPage.vala"
		_data_collection_unref0 (self->priv->_sources);
#line 37 "../src/Views/SlideshowPage.vala"
		self->priv->_sources = _tmp0_;
#line 37 "../src/Views/SlideshowPage.vala"
		g_object_notify_by_pspec ((GObject *) self, slideshow_page_properties[SLIDESHOW_PAGE_SOURCES_PROPERTY]);
#line 1761 "SlideshowPage.c"
	}
}

ViewCollection*
slideshow_page_get_controller (SlideshowPage* self)
{
	ViewCollection* result;
	ViewCollection* _tmp0_;
#line 38 "../src/Views/SlideshowPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->_controller;
#line 38 "../src/Views/SlideshowPage.vala"
	result = _tmp0_;
#line 38 "../src/Views/SlideshowPage.vala"
	return result;
#line 1778 "SlideshowPage.c"
}

static void
slideshow_page_set_controller (SlideshowPage* self,
                               ViewCollection* value)
{
	ViewCollection* old_value;
#line 38 "../src/Views/SlideshowPage.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Views/SlideshowPage.vala"
	old_value = slideshow_page_get_controller (self);
#line 38 "../src/Views/SlideshowPage.vala"
	if (old_value != value) {
#line 1792 "SlideshowPage.c"
		ViewCollection* _tmp0_;
#line 38 "../src/Views/SlideshowPage.vala"
		_tmp0_ = _data_collection_ref0 (value);
#line 38 "../src/Views/SlideshowPage.vala"
		_data_collection_unref0 (self->priv->_controller);
#line 38 "../src/Views/SlideshowPage.vala"
		self->priv->_controller = _tmp0_;
#line 38 "../src/Views/SlideshowPage.vala"
		g_object_notify_by_pspec ((GObject *) self, slideshow_page_properties[SLIDESHOW_PAGE_CONTROLLER_PROPERTY]);
#line 1802 "SlideshowPage.c"
	}
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 51 "../src/Views/SlideshowPage.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 51 "../src/Views/SlideshowPage.vala"
	return _data24_;
#line 1813 "SlideshowPage.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 51 "../src/Views/SlideshowPage.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 1823 "SlideshowPage.c"
		SlideshowPage* self;
#line 51 "../src/Views/SlideshowPage.vala"
		self = _data24_->self;
#line 51 "../src/Views/SlideshowPage.vala"
		_g_object_unref0 (_data24_->slider);
#line 51 "../src/Views/SlideshowPage.vala"
		_g_object_unref0 (_data24_->titles_toggle);
#line 51 "../src/Views/SlideshowPage.vala"
		_g_object_unref0 (self);
#line 51 "../src/Views/SlideshowPage.vala"
		g_slice_free (Block24Data, _data24_);
#line 1835 "SlideshowPage.c"
	}
}

static void
_slideshow_page___lambda32_ (SlideshowPage* self)
{
#line 60 "../src/Views/SlideshowPage.vala"
	slideshow_page_update_transition_effect (self);
#line 1844 "SlideshowPage.c"
}

static void
__slideshow_page___lambda32__g_settings_changed (GSettings* _sender,
                                                 const gchar* key,
                                                 gpointer self)
{
#line 60 "../src/Views/SlideshowPage.vala"
	_slideshow_page___lambda32_ ((SlideshowPage*) self);
#line 1854 "SlideshowPage.c"
}

static void
_single_photo_page_on_previous_photo_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 66 "../src/Views/SlideshowPage.vala"
	single_photo_page_on_previous_photo ((SinglePhotoPage*) self);
#line 1863 "SlideshowPage.c"
}

static void
_slideshow_page_on_play_pause_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 70 "../src/Views/SlideshowPage.vala"
	slideshow_page_on_play_pause ((SlideshowPage*) self);
#line 1872 "SlideshowPage.c"
}

static void
_single_photo_page_on_next_photo_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
#line 74 "../src/Views/SlideshowPage.vala"
	single_photo_page_on_next_photo ((SinglePhotoPage*) self);
#line 1881 "SlideshowPage.c"
}

static void
_slideshow_page___lambda38_ (Block24Data* _data24_)
{
	SlideshowPage* self;
	GSettings* _tmp0_;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 85 "../src/Views/SlideshowPage.vala"
	self = _data24_->self;
#line 86 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->slideshow_settings;
#line 86 "../src/Views/SlideshowPage.vala"
	_tmp1_ = _data24_->titles_toggle;
#line 86 "../src/Views/SlideshowPage.vala"
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
#line 86 "../src/Views/SlideshowPage.vala"
	_tmp3_ = _tmp2_;
#line 86 "../src/Views/SlideshowPage.vala"
	g_settings_set_boolean (_tmp0_, "show-title", _tmp3_);
#line 1904 "SlideshowPage.c"
}

static void
__slideshow_page___lambda38__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                        gpointer self)
{
#line 85 "../src/Views/SlideshowPage.vala"
	_slideshow_page___lambda38_ (self);
#line 1913 "SlideshowPage.c"
}

static void
_slideshow_page___lambda39_ (Block24Data* _data24_)
{
	SlideshowPage* self;
	GSettings* _tmp0_;
	GtkScale* _tmp1_;
#line 101 "../src/Views/SlideshowPage.vala"
	self = _data24_->self;
#line 102 "../src/Views/SlideshowPage.vala"
	_tmp0_ = self->priv->slideshow_settings;
#line 102 "../src/Views/SlideshowPage.vala"
	_tmp1_ = _data24_->slider;
#line 102 "../src/Views/SlideshowPage.vala"
	g_settings_set_double (_tmp0_, "delay", gtk_range_get_value ((GtkRange*) _tmp1_));
#line 1930 "SlideshowPage.c"
}

static void
__slideshow_page___lambda39__gtk_range_value_changed (GtkRange* _sender,
                                                      gpointer self)
{
#line 101 "../src/Views/SlideshowPage.vala"
	_slideshow_page___lambda39_ (self);
#line 1939 "SlideshowPage.c"
}

static GObject *
slideshow_page_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlideshowPage * self;
	Block24Data* _data24_;
	GeeCollection* pluggables = NULL;
	TransitionEffectsManager* _tmp0_;
	TransitionEffectsManager* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeArrayList* a = NULL;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeCollection* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
	gint _tmp10_ = 0;
	gpointer* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GtkButton* previous_button = NULL;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* next_button = NULL;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	TransitionEffectSelector* effect_selector = NULL;
	TransitionEffectSelector* _tmp23_;
	GtkToggleButton* _tmp24_;
	GtkToggleButton* _tmp25_;
	GtkImage* _tmp26_;
	GtkImage* _tmp27_;
	GtkToggleButton* _tmp28_;
	GtkToggleButton* _tmp29_;
	GtkToggleButton* _tmp30_;
	GSettings* _tmp31_;
	GtkToggleButton* _tmp32_;
	GtkToggleButton* _tmp33_;
	GtkSizeGroup* dropdown_sizegroup = NULL;
	GtkSizeGroup* _tmp34_;
	GtkSizeGroup* _tmp35_;
	TransitionEffectSelector* _tmp36_;
	GtkSizeGroup* _tmp37_;
	GtkToggleButton* _tmp38_;
	GtkScale* _tmp39_;
	GtkScale* _tmp40_;
	GtkScale* _tmp41_;
	GtkScale* _tmp42_;
	GtkScale* _tmp43_;
	GtkScale* _tmp44_;
	GtkScale* _tmp45_;
	GtkScale* _tmp46_;
	GSettings* _tmp47_;
	GtkScale* _tmp48_;
	GtkToolItem* slider_wrapper = NULL;
	GtkToolItem* _tmp49_;
	GtkToolItem* _tmp50_;
	GtkToolItem* _tmp51_;
	GtkScale* _tmp52_;
	GtkActionBar* toolbar = NULL;
	GtkActionBar* _tmp53_;
	GtkActionBar* _tmp54_;
	GtkButton* _tmp55_;
	GtkActionBar* _tmp56_;
	GtkButton* _tmp57_;
	GtkActionBar* _tmp58_;
	GtkButton* _tmp59_;
	GtkActionBar* _tmp60_;
	GtkSeparator* _tmp61_;
	GtkSeparator* _tmp62_;
	GtkActionBar* _tmp63_;
	TransitionEffectSelector* _tmp64_;
	GtkActionBar* _tmp65_;
	GtkToggleButton* _tmp66_;
	GtkActionBar* _tmp67_;
	GtkToolItem* _tmp68_;
	GtkActionBar* _tmp69_;
	GtkSeparator* _tmp70_;
	GtkSeparator* _tmp71_;
#line 51 "../src/Views/SlideshowPage.vala"
	parent_class = G_OBJECT_CLASS (slideshow_page_parent_class);
#line 51 "../src/Views/SlideshowPage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/Views/SlideshowPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SLIDESHOW_PAGE, SlideshowPage);
#line 51 "../src/Views/SlideshowPage.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 51 "../src/Views/SlideshowPage.vala"
	_data24_->_ref_count_ = 1;
#line 51 "../src/Views/SlideshowPage.vala"
	_data24_->self = g_object_ref (self);
#line 52 "../src/Views/SlideshowPage.vala"
	_tmp0_ = transition_effects_manager_get_instance ();
#line 52 "../src/Views/SlideshowPage.vala"
	_tmp1_ = _tmp0_;
#line 52 "../src/Views/SlideshowPage.vala"
	_tmp2_ = transition_effects_manager_get_effect_ids (_tmp1_);
#line 52 "../src/Views/SlideshowPage.vala"
	_tmp3_ = _tmp2_;
#line 52 "../src/Views/SlideshowPage.vala"
	_transition_effects_manager_unref0 (_tmp1_);
#line 52 "../src/Views/SlideshowPage.vala"
	pluggables = _tmp3_;
#line 53 "../src/Views/SlideshowPage.vala"
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 53 "../src/Views/SlideshowPage.vala"
	a = _tmp4_;
#line 54 "../src/Views/SlideshowPage.vala"
	_tmp5_ = a;
#line 54 "../src/Views/SlideshowPage.vala"
	_tmp6_ = pluggables;
#line 54 "../src/Views/SlideshowPage.vala"
	gee_array_list_add_all (_tmp5_, _tmp6_);
#line 55 "../src/Views/SlideshowPage.vala"
	_tmp7_ = a;
#line 55 "../src/Views/SlideshowPage.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp7_, NULL_TRANSITION_DESCRIPTOR_EFFECT_ID);
#line 56 "../src/Views/SlideshowPage.vala"
	_tmp8_ = a;
#line 56 "../src/Views/SlideshowPage.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp8_, RANDOM_EFFECT_DESCRIPTOR_EFFECT_ID);
#line 57 "../src/Views/SlideshowPage.vala"
	_tmp9_ = a;
#line 57 "../src/Views/SlideshowPage.vala"
	_tmp11_ = gee_collection_to_array ((GeeCollection*) _tmp9_, &_tmp10_);
#line 57 "../src/Views/SlideshowPage.vala"
	self->priv->transitions = (_vala_array_free (self->priv->transitions, self->priv->transitions_length1, (GDestroyNotify) g_free), NULL);
#line 57 "../src/Views/SlideshowPage.vala"
	self->priv->transitions = _tmp11_;
#line 57 "../src/Views/SlideshowPage.vala"
	self->priv->transitions_length1 = _tmp10_;
#line 57 "../src/Views/SlideshowPage.vala"
	self->priv->_transitions_size_ = self->priv->transitions_length1;
#line 59 "../src/Views/SlideshowPage.vala"
	_tmp12_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_SLIDESHOW_PREFS_SCHEMA_NAME);
#line 59 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->slideshow_settings);
#line 59 "../src/Views/SlideshowPage.vala"
	self->priv->slideshow_settings = _tmp12_;
#line 60 "../src/Views/SlideshowPage.vala"
	_tmp13_ = self->priv->slideshow_settings;
#line 60 "../src/Views/SlideshowPage.vala"
	g_signal_connect_object (_tmp13_, "changed", (GCallback) __slideshow_page___lambda32__g_settings_changed, self, 0);
#line 62 "../src/Views/SlideshowPage.vala"
	slideshow_page_update_transition_effect (self);
#line 64 "../src/Views/SlideshowPage.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_from_icon_name ("go-previous-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 64 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp14_);
#line 64 "../src/Views/SlideshowPage.vala"
	previous_button = _tmp14_;
#line 65 "../src/Views/SlideshowPage.vala"
	_tmp15_ = previous_button;
#line 65 "../src/Views/SlideshowPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp15_, _ ("Go to the previous photo"));
#line 66 "../src/Views/SlideshowPage.vala"
	_tmp16_ = previous_button;
#line 66 "../src/Views/SlideshowPage.vala"
	g_signal_connect_object (_tmp16_, "clicked", (GCallback) _single_photo_page_on_previous_photo_gtk_button_clicked, (SinglePhotoPage*) self, 0);
#line 68 "../src/Views/SlideshowPage.vala"
	_tmp17_ = (GtkButton*) gtk_button_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 68 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp17_);
#line 68 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->play_pause_button);
#line 68 "../src/Views/SlideshowPage.vala"
	self->priv->play_pause_button = _tmp17_;
#line 69 "../src/Views/SlideshowPage.vala"
	_tmp18_ = self->priv->play_pause_button;
#line 69 "../src/Views/SlideshowPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp18_, _ ("Pause the slideshow"));
#line 70 "../src/Views/SlideshowPage.vala"
	_tmp19_ = self->priv->play_pause_button;
#line 70 "../src/Views/SlideshowPage.vala"
	g_signal_connect_object (_tmp19_, "clicked", (GCallback) _slideshow_page_on_play_pause_gtk_button_clicked, self, 0);
#line 72 "../src/Views/SlideshowPage.vala"
	_tmp20_ = (GtkButton*) gtk_button_new_from_icon_name ("go-next-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 72 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp20_);
#line 72 "../src/Views/SlideshowPage.vala"
	next_button = _tmp20_;
#line 73 "../src/Views/SlideshowPage.vala"
	_tmp21_ = next_button;
#line 73 "../src/Views/SlideshowPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp21_, _ ("Go to the next photo"));
#line 74 "../src/Views/SlideshowPage.vala"
	_tmp22_ = next_button;
#line 74 "../src/Views/SlideshowPage.vala"
	g_signal_connect_object (_tmp22_, "clicked", (GCallback) _single_photo_page_on_next_photo_gtk_button_clicked, (SinglePhotoPage*) self, 0);
#line 76 "../src/Views/SlideshowPage.vala"
	_tmp23_ = transition_effect_selector_new ();
#line 76 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp23_);
#line 76 "../src/Views/SlideshowPage.vala"
	effect_selector = _tmp23_;
#line 78 "../src/Views/SlideshowPage.vala"
	_tmp24_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 78 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp24_);
#line 78 "../src/Views/SlideshowPage.vala"
	_data24_->titles_toggle = _tmp24_;
#line 79 "../src/Views/SlideshowPage.vala"
	_tmp25_ = _data24_->titles_toggle;
#line 79 "../src/Views/SlideshowPage.vala"
	_tmp26_ = (GtkImage*) gtk_image_new_from_icon_name ("preferences-desktop-font-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 79 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp26_);
#line 79 "../src/Views/SlideshowPage.vala"
	_tmp27_ = _tmp26_;
#line 79 "../src/Views/SlideshowPage.vala"
	gtk_button_set_image ((GtkButton*) _tmp25_, (GtkWidget*) _tmp27_);
#line 79 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (_tmp27_);
#line 81 "../src/Views/SlideshowPage.vala"
	_tmp28_ = _data24_->titles_toggle;
#line 81 "../src/Views/SlideshowPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp28_, _ ("Show Photo Titles"));
#line 82 "../src/Views/SlideshowPage.vala"
	_tmp29_ = _data24_->titles_toggle;
#line 82 "../src/Views/SlideshowPage.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp29_, 6);
#line 83 "../src/Views/SlideshowPage.vala"
	_tmp30_ = _data24_->titles_toggle;
#line 83 "../src/Views/SlideshowPage.vala"
	_tmp31_ = self->priv->slideshow_settings;
#line 83 "../src/Views/SlideshowPage.vala"
	gtk_toggle_button_set_active (_tmp30_, g_settings_get_boolean (_tmp31_, "show-title"));
#line 84 "../src/Views/SlideshowPage.vala"
	_tmp32_ = _data24_->titles_toggle;
#line 84 "../src/Views/SlideshowPage.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp32_, GTK_ALIGN_CENTER);
#line 85 "../src/Views/SlideshowPage.vala"
	_tmp33_ = _data24_->titles_toggle;
#line 85 "../src/Views/SlideshowPage.vala"
	g_signal_connect_data (_tmp33_, "toggled", (GCallback) __slideshow_page___lambda38__gtk_toggle_button_toggled, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
#line 89 "../src/Views/SlideshowPage.vala"
	_tmp34_ = gtk_size_group_new (GTK_SIZE_GROUP_VERTICAL);
#line 89 "../src/Views/SlideshowPage.vala"
	dropdown_sizegroup = _tmp34_;
#line 90 "../src/Views/SlideshowPage.vala"
	_tmp35_ = dropdown_sizegroup;
#line 90 "../src/Views/SlideshowPage.vala"
	_tmp36_ = effect_selector;
#line 90 "../src/Views/SlideshowPage.vala"
	gtk_size_group_add_widget (_tmp35_, (GtkWidget*) _tmp36_);
#line 91 "../src/Views/SlideshowPage.vala"
	_tmp37_ = dropdown_sizegroup;
#line 91 "../src/Views/SlideshowPage.vala"
	_tmp38_ = _data24_->titles_toggle;
#line 91 "../src/Views/SlideshowPage.vala"
	gtk_size_group_add_widget (_tmp37_, (GtkWidget*) _tmp38_);
#line 93 "../src/Views/SlideshowPage.vala"
	_tmp39_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, 0.5, 15.0, 0.5);
#line 93 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp39_);
#line 93 "../src/Views/SlideshowPage.vala"
	_data24_->slider = _tmp39_;
#line 94 "../src/Views/SlideshowPage.vala"
	_tmp40_ = _data24_->slider;
#line 94 "../src/Views/SlideshowPage.vala"
	gtk_scale_set_draw_value (_tmp40_, FALSE);
#line 95 "../src/Views/SlideshowPage.vala"
	_tmp41_ = _data24_->slider;
#line 95 "../src/Views/SlideshowPage.vala"
	gtk_range_set_inverted ((GtkRange*) _tmp41_, TRUE);
#line 96 "../src/Views/SlideshowPage.vala"
	_tmp42_ = _data24_->slider;
#line 96 "../src/Views/SlideshowPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp42_, _ ("Transition Speed"));
#line 97 "../src/Views/SlideshowPage.vala"
	_tmp43_ = _data24_->slider;
#line 97 "../src/Views/SlideshowPage.vala"
	g_object_set ((GtkWidget*) _tmp43_, "width-request", 150, NULL);
#line 98 "../src/Views/SlideshowPage.vala"
	_tmp44_ = _data24_->slider;
#line 98 "../src/Views/SlideshowPage.vala"
	gtk_scale_add_mark (_tmp44_, 0.5, GTK_POS_BOTTOM, _ ("Faster"));
#line 99 "../src/Views/SlideshowPage.vala"
	_tmp45_ = _data24_->slider;
#line 99 "../src/Views/SlideshowPage.vala"
	gtk_scale_add_mark (_tmp45_, 15.0, GTK_POS_BOTTOM, _ ("Slower"));
#line 100 "../src/Views/SlideshowPage.vala"
	_tmp46_ = _data24_->slider;
#line 100 "../src/Views/SlideshowPage.vala"
	_tmp47_ = self->priv->slideshow_settings;
#line 100 "../src/Views/SlideshowPage.vala"
	gtk_range_set_value ((GtkRange*) _tmp46_, g_settings_get_double (_tmp47_, "delay"));
#line 101 "../src/Views/SlideshowPage.vala"
	_tmp48_ = _data24_->slider;
#line 101 "../src/Views/SlideshowPage.vala"
	g_signal_connect_data ((GtkRange*) _tmp48_, "value-changed", (GCallback) __slideshow_page___lambda39__gtk_range_value_changed, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
#line 105 "../src/Views/SlideshowPage.vala"
	_tmp49_ = gtk_tool_item_new ();
#line 105 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp49_);
#line 105 "../src/Views/SlideshowPage.vala"
	slider_wrapper = _tmp49_;
#line 106 "../src/Views/SlideshowPage.vala"
	_tmp50_ = slider_wrapper;
#line 106 "../src/Views/SlideshowPage.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp50_, 6);
#line 107 "../src/Views/SlideshowPage.vala"
	_tmp51_ = slider_wrapper;
#line 107 "../src/Views/SlideshowPage.vala"
	_tmp52_ = _data24_->slider;
#line 107 "../src/Views/SlideshowPage.vala"
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
#line 109 "../src/Views/SlideshowPage.vala"
	_tmp53_ = page_get_toolbar ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage), NULL, GTK_PACK_START);
#line 109 "../src/Views/SlideshowPage.vala"
	toolbar = _tmp53_;
#line 110 "../src/Views/SlideshowPage.vala"
	_tmp54_ = toolbar;
#line 110 "../src/Views/SlideshowPage.vala"
	_tmp55_ = previous_button;
#line 110 "../src/Views/SlideshowPage.vala"
	gtk_action_bar_pack_start (_tmp54_, (GtkWidget*) _tmp55_);
#line 111 "../src/Views/SlideshowPage.vala"
	_tmp56_ = toolbar;
#line 111 "../src/Views/SlideshowPage.vala"
	_tmp57_ = self->priv->play_pause_button;
#line 111 "../src/Views/SlideshowPage.vala"
	gtk_action_bar_pack_start (_tmp56_, (GtkWidget*) _tmp57_);
#line 112 "../src/Views/SlideshowPage.vala"
	_tmp58_ = toolbar;
#line 112 "../src/Views/SlideshowPage.vala"
	_tmp59_ = next_button;
#line 112 "../src/Views/SlideshowPage.vala"
	gtk_action_bar_pack_start (_tmp58_, (GtkWidget*) _tmp59_);
#line 113 "../src/Views/SlideshowPage.vala"
	_tmp60_ = toolbar;
#line 113 "../src/Views/SlideshowPage.vala"
	_tmp61_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
#line 113 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp61_);
#line 113 "../src/Views/SlideshowPage.vala"
	_tmp62_ = _tmp61_;
#line 113 "../src/Views/SlideshowPage.vala"
	gtk_container_add ((GtkContainer*) _tmp60_, (GtkWidget*) _tmp62_);
#line 113 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (_tmp62_);
#line 114 "../src/Views/SlideshowPage.vala"
	_tmp63_ = toolbar;
#line 114 "../src/Views/SlideshowPage.vala"
	_tmp64_ = effect_selector;
#line 114 "../src/Views/SlideshowPage.vala"
	gtk_action_bar_pack_start (_tmp63_, (GtkWidget*) _tmp64_);
#line 115 "../src/Views/SlideshowPage.vala"
	_tmp65_ = toolbar;
#line 115 "../src/Views/SlideshowPage.vala"
	_tmp66_ = _data24_->titles_toggle;
#line 115 "../src/Views/SlideshowPage.vala"
	gtk_action_bar_pack_start (_tmp65_, (GtkWidget*) _tmp66_);
#line 116 "../src/Views/SlideshowPage.vala"
	_tmp67_ = toolbar;
#line 116 "../src/Views/SlideshowPage.vala"
	_tmp68_ = slider_wrapper;
#line 116 "../src/Views/SlideshowPage.vala"
	gtk_action_bar_pack_start (_tmp67_, (GtkWidget*) _tmp68_);
#line 117 "../src/Views/SlideshowPage.vala"
	_tmp69_ = toolbar;
#line 117 "../src/Views/SlideshowPage.vala"
	_tmp70_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
#line 117 "../src/Views/SlideshowPage.vala"
	g_object_ref_sink (_tmp70_);
#line 117 "../src/Views/SlideshowPage.vala"
	_tmp71_ = _tmp70_;
#line 117 "../src/Views/SlideshowPage.vala"
	gtk_container_add ((GtkContainer*) _tmp69_, (GtkWidget*) _tmp71_);
#line 117 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (_tmp71_);
#line 51 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (toolbar);
#line 51 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (slider_wrapper);
#line 51 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (dropdown_sizegroup);
#line 51 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (effect_selector);
#line 51 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (next_button);
#line 51 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (previous_button);
#line 51 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (a);
#line 51 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (pluggables);
#line 51 "../src/Views/SlideshowPage.vala"
	block24_data_unref (_data24_);
#line 51 "../src/Views/SlideshowPage.vala"
	_data24_ = NULL;
#line 51 "../src/Views/SlideshowPage.vala"
	return obj;
#line 2345 "SlideshowPage.c"
}

static void
slideshow_page_class_init (SlideshowPageClass * klass,
                           gpointer klass_data)
{
#line 21 "../src/Views/SlideshowPage.vala"
	slideshow_page_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Views/SlideshowPage.vala"
	g_type_class_adjust_private_offset (klass, &SlideshowPage_private_offset);
#line 21 "../src/Views/SlideshowPage.vala"
	((PageClass *) klass)->switched_to = (void (*) (Page*)) slideshow_page_real_switched_to;
#line 21 "../src/Views/SlideshowPage.vala"
	((PageClass *) klass)->switching_from = (void (*) (Page*)) slideshow_page_real_switching_from;
#line 21 "../src/Views/SlideshowPage.vala"
	((SinglePhotoPageClass *) klass)->on_previous_photo = (void (*) (SinglePhotoPage*)) slideshow_page_real_on_previous_photo;
#line 21 "../src/Views/SlideshowPage.vala"
	((SinglePhotoPageClass *) klass)->on_next_photo = (void (*) (SinglePhotoPage*)) slideshow_page_real_on_next_photo;
#line 21 "../src/Views/SlideshowPage.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) slideshow_page_real_button_press_event;
#line 21 "../src/Views/SlideshowPage.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) slideshow_page_real_key_press_event;
#line 21 "../src/Views/SlideshowPage.vala"
	((SinglePhotoPageClass *) klass)->paint = (void (*) (SinglePhotoPage*, cairo_t*, Dimensions*)) slideshow_page_real_paint;
#line 21 "../src/Views/SlideshowPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slideshow_page_get_property;
#line 21 "../src/Views/SlideshowPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slideshow_page_set_property;
#line 21 "../src/Views/SlideshowPage.vala"
	G_OBJECT_CLASS (klass)->constructor = slideshow_page_constructor;
#line 21 "../src/Views/SlideshowPage.vala"
	G_OBJECT_CLASS (klass)->finalize = slideshow_page_finalize;
#line 21 "../src/Views/SlideshowPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLIDESHOW_PAGE_SOURCES_PROPERTY, slideshow_page_properties[SLIDESHOW_PAGE_SOURCES_PROPERTY] = param_spec_data_collection ("sources", "sources", "sources", TYPE_SOURCE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Views/SlideshowPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLIDESHOW_PAGE_CONTROLLER_PROPERTY, slideshow_page_properties[SLIDESHOW_PAGE_CONTROLLER_PROPERTY] = param_spec_data_collection ("controller", "controller", "controller", TYPE_VIEW_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Views/SlideshowPage.vala"
	slideshow_page_signals[SLIDESHOW_PAGE_HIDE_TOOLBAR_SIGNAL] = g_signal_new ("hide-toolbar", TYPE_SLIDESHOW_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2384 "SlideshowPage.c"
}

static void
slideshow_page_instance_init (SlideshowPage * self,
                              gpointer klass)
{
	GTimer* _tmp0_;
#line 21 "../src/Views/SlideshowPage.vala"
	self->priv = slideshow_page_get_instance_private (self);
#line 27 "../src/Views/SlideshowPage.vala"
	self->priv->cache = NULL;
#line 28 "../src/Views/SlideshowPage.vala"
	_tmp0_ = g_timer_new ();
#line 28 "../src/Views/SlideshowPage.vala"
	self->priv->timer = _tmp0_;
#line 29 "../src/Views/SlideshowPage.vala"
	self->priv->playing = TRUE;
#line 30 "../src/Views/SlideshowPage.vala"
	self->priv->exiting = FALSE;
#line 32 "../src/Views/SlideshowPage.vala"
	self->priv->cookie = (guint32) 0;
#line 2406 "SlideshowPage.c"
}

static void
slideshow_page_finalize (GObject * obj)
{
	SlideshowPage * self;
#line 21 "../src/Views/SlideshowPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SLIDESHOW_PAGE, SlideshowPage);
#line 25 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->current);
#line 26 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->play_pause_button);
#line 27 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->cache);
#line 28 "../src/Views/SlideshowPage.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 31 "../src/Views/SlideshowPage.vala"
	self->priv->transitions = (_vala_array_free (self->priv->transitions, self->priv->transitions_length1, (GDestroyNotify) g_free), NULL);
#line 33 "../src/Views/SlideshowPage.vala"
	_g_object_unref0 (self->priv->slideshow_settings);
#line 37 "../src/Views/SlideshowPage.vala"
	_data_collection_unref0 (self->priv->_sources);
#line 38 "../src/Views/SlideshowPage.vala"
	_data_collection_unref0 (self->priv->_controller);
#line 21 "../src/Views/SlideshowPage.vala"
	G_OBJECT_CLASS (slideshow_page_parent_class)->finalize (obj);
#line 2433 "SlideshowPage.c"
}

static GType
slideshow_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlideshowPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slideshow_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlideshowPage), 0, (GInstanceInitFunc) slideshow_page_instance_init, NULL };
	GType slideshow_page_type_id;
	slideshow_page_type_id = g_type_register_static (TYPE_SINGLE_PHOTO_PAGE, "SlideshowPage", &g_define_type_info, 0);
	SlideshowPage_private_offset = g_type_add_instance_private (slideshow_page_type_id, sizeof (SlideshowPagePrivate));
	return slideshow_page_type_id;
}

GType
slideshow_page_get_type (void)
{
	static volatile gsize slideshow_page_type_id__once = 0;
	if (g_once_init_enter (&slideshow_page_type_id__once)) {
		GType slideshow_page_type_id;
		slideshow_page_type_id = slideshow_page_get_type_once ();
		g_once_init_leave (&slideshow_page_type_id__once, slideshow_page_type_id);
	}
	return slideshow_page_type_id__once;
}

static void
_vala_slideshow_page_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	SlideshowPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SLIDESHOW_PAGE, SlideshowPage);
#line 21 "../src/Views/SlideshowPage.vala"
	switch (property_id) {
#line 21 "../src/Views/SlideshowPage.vala"
		case SLIDESHOW_PAGE_SOURCES_PROPERTY:
#line 21 "../src/Views/SlideshowPage.vala"
		value_set_data_collection (value, slideshow_page_get_sources (self));
#line 21 "../src/Views/SlideshowPage.vala"
		break;
#line 21 "../src/Views/SlideshowPage.vala"
		case SLIDESHOW_PAGE_CONTROLLER_PROPERTY:
#line 21 "../src/Views/SlideshowPage.vala"
		value_set_data_collection (value, slideshow_page_get_controller (self));
#line 21 "../src/Views/SlideshowPage.vala"
		break;
#line 2480 "SlideshowPage.c"
		default:
#line 21 "../src/Views/SlideshowPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Views/SlideshowPage.vala"
		break;
#line 2486 "SlideshowPage.c"
	}
}

static void
_vala_slideshow_page_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	SlideshowPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SLIDESHOW_PAGE, SlideshowPage);
#line 21 "../src/Views/SlideshowPage.vala"
	switch (property_id) {
#line 21 "../src/Views/SlideshowPage.vala"
		case SLIDESHOW_PAGE_SOURCES_PROPERTY:
#line 21 "../src/Views/SlideshowPage.vala"
		slideshow_page_set_sources (self, value_get_data_collection (value));
#line 21 "../src/Views/SlideshowPage.vala"
		break;
#line 21 "../src/Views/SlideshowPage.vala"
		case SLIDESHOW_PAGE_CONTROLLER_PROPERTY:
#line 21 "../src/Views/SlideshowPage.vala"
		slideshow_page_set_controller (self, value_get_data_collection (value));
#line 21 "../src/Views/SlideshowPage.vala"
		break;
#line 2512 "SlideshowPage.c"
		default:
#line 21 "../src/Views/SlideshowPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Views/SlideshowPage.vala"
		break;
#line 2518 "SlideshowPage.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

