/* CustomPrintTab.c generated by valac 0.56.18, the Vala compiler
 * generated from CustomPrintTab.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io)
*               2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include "locale.h"
#include <glib/gi18n-lib.h>
#include <granite.h>

#define CUSTOM_PRINT_TAB_INCHES_COMBO_CHOICE 0
#define CUSTOM_PRINT_TAB_CENTIMETERS_COMBO_CHOICE 1
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CUSTOM_PRINT_TAB_0_PROPERTY,
	CUSTOM_PRINT_TAB_SOURCE_JOB_PROPERTY,
	CUSTOM_PRINT_TAB_NUM_PROPERTIES
};
static GParamSpec* custom_print_tab_properties[CUSTOM_PRINT_TAB_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _print_settings_unref0(var) ((var == NULL) ? NULL : (var = (print_settings_unref (var), NULL)))
typedef enum  {
	PRINT_LAYOUT_ENTIRE_PAGE,
	PRINT_LAYOUT_TWO_PER_PAGE,
	PRINT_LAYOUT_FOUR_PER_PAGE,
	PRINT_LAYOUT_SIX_PER_PAGE,
	PRINT_LAYOUT_EIGHT_PER_PAGE,
	PRINT_LAYOUT_SIXTEEN_PER_PAGE,
	PRINT_LAYOUT_THIRTY_TWO_PER_PAGE
} PrintLayout;

#define TYPE_PRINT_LAYOUT (print_layout_get_type ())
#define _print_manager_unref0(var) ((var == NULL) ? NULL : (var = (print_manager_unref (var), NULL)))
#define _standard_print_size_unref0(var) ((var == NULL) ? NULL : (var = (standard_print_size_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _CustomPrintTabPrivate {
	GtkRadioButton* standard_size_radio;
	GtkRadioButton* custom_size_radio;
	GtkRadioButton* image_per_page_radio;
	GtkComboBox* image_per_page_combo;
	GtkComboBox* standard_sizes_combo;
	GtkComboBoxText* units_combo;
	GtkEntry* custom_width_entry;
	GtkEntry* custom_height_entry;
	GtkCheckButton* aspect_ratio_check;
	GtkCheckButton* title_print_check;
	GtkFontButton* title_print_font;
	GtkSpinButton* ppi_entry;
	Measurement local_content_width;
	Measurement local_content_height;
	gboolean is_text_insertion_in_progress;
	PrintJob* _source_job;
};

static gint CustomPrintTab_private_offset;
static gpointer custom_print_tab_parent_class = NULL;

static void custom_print_tab_on_aspect_ratio_check_clicked (CustomPrintTab* self);
static gchar* custom_print_tab_format_measurement (CustomPrintTab* self,
                                            Measurement* measurement);
static gboolean custom_print_tab_on_width_entry_focus_out (CustomPrintTab* self,
                                                    GdkEventFocus* event);
static gchar* custom_print_tab_format_measurement_as (CustomPrintTab* self,
                                               Measurement* measurement,
                                               MeasurementUnit to_unit);
static MeasurementUnit custom_print_tab_get_user_unit_choice (CustomPrintTab* self);
static void custom_print_tab_get_width_entry_value (CustomPrintTab* self,
                                             Measurement* result);
static gboolean custom_print_tab_is_match_aspect_ratio_enabled (CustomPrintTab* self);
static void custom_print_tab_on_ppi_entry_insert_text (CustomPrintTab* self,
                                                GtkEditable* editable,
                                                const gchar* text,
                                                gint length,
                                                gint* position);
static gboolean custom_print_tab_on_height_entry_focus_out (CustomPrintTab* self,
                                                     GdkEventFocus* event);
static void custom_print_tab_get_height_entry_value (CustomPrintTab* self,
                                              Measurement* result);
static void custom_print_tab_set_user_unit_choice (CustomPrintTab* self,
                                            MeasurementUnit unit);
static void custom_print_tab_on_entry_insert_text (CustomPrintTab* self,
                                            GtkEditable* editable,
                                            const gchar* text,
                                            gint length,
                                            gint* position);
static void custom_print_tab_sync_state_from_job (CustomPrintTab* self,
                                           PrintJob* job);
static void custom_print_tab_set_content_width (CustomPrintTab* self,
                                         Measurement* content_width);
static void custom_print_tab_set_content_height (CustomPrintTab* self,
                                          Measurement* content_height);
static void custom_print_tab_set_content_layout (CustomPrintTab* self,
                                          ContentLayout content_layout);
static void custom_print_tab_set_image_per_page_selection (CustomPrintTab* self,
                                                    gint image_per_page);
static void custom_print_tab_set_size_selection (CustomPrintTab* self,
                                          gint size_selection);
static void custom_print_tab_set_match_aspect_ratio_enabled (CustomPrintTab* self,
                                                      gboolean enable_state);
static void custom_print_tab_set_print_titles_enabled (CustomPrintTab* self,
                                                gboolean print_titles);
static void custom_print_tab_set_print_titles_font (CustomPrintTab* self,
                                             const gchar* fontname);
static void custom_print_tab_on_radio_group_click (CustomPrintTab* self,
                                            GtkButton* b);
static void custom_print_tab_set_content_layout_control_state (CustomPrintTab* self,
                                                        ContentLayout layout);
static void custom_print_tab_on_units_combo_changed (CustomPrintTab* self);
static gboolean custom_print_tab_standard_sizes_combo_separator_func (GtkTreeModel* model,
                                                               GtkTreeIter* iter);
static ContentLayout custom_print_tab_get_content_layout (CustomPrintTab* self);
static void custom_print_tab_get_content_width (CustomPrintTab* self,
                                         Measurement* result);
static void custom_print_tab_get_content_height (CustomPrintTab* self,
                                          Measurement* result);
static gint custom_print_tab_get_image_per_page_selection (CustomPrintTab* self);
static gint custom_print_tab_get_size_selection (CustomPrintTab* self);
static gboolean custom_print_tab_is_print_titles_enabled (CustomPrintTab* self);
static gchar* custom_print_tab_get_print_titles_font (CustomPrintTab* self);
static GObject * custom_print_tab_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
VALA_EXTERN GType print_layout_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PrintLayout* print_layout_get_all (gint* result_length1);
VALA_EXTERN gchar* print_layout_to_string (PrintLayout self);
static gboolean _custom_print_tab_standard_sizes_combo_separator_func_gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                                                                 GtkTreeIter* iter,
                                                                                                 gpointer self);
static void _custom_print_tab_on_radio_group_click_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _custom_print_tab_on_entry_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                      const gchar* new_text,
                                                                      gint new_text_length,
                                                                      gint* position,
                                                                      gpointer self);
static gboolean _custom_print_tab_on_width_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                GdkEventFocus* event,
                                                                                gpointer self);
static gboolean _custom_print_tab_on_height_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                 GdkEventFocus* event,
                                                                                 gpointer self);
static void _custom_print_tab_on_units_combo_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
static void _custom_print_tab_on_ppi_entry_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                          const gchar* new_text,
                                                                          gint new_text_length,
                                                                          gint* position,
                                                                          gpointer self);
static void _custom_print_tab_on_aspect_ratio_check_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self);
static void custom_print_tab_finalize (GObject * obj);
static GType custom_print_tab_get_type_once (void);
static void _vala_custom_print_tab_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_custom_print_tab_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
custom_print_tab_get_instance_private (CustomPrintTab* self)
{
	return G_STRUCT_MEMBER_P (self, CustomPrintTab_private_offset);
}

CustomPrintTab*
custom_print_tab_construct (GType object_type,
                            PrintJob* source_job)
{
	CustomPrintTab * self = NULL;
#line 43 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (source_job != NULL, NULL);
#line 44 "../src/Widgets/CustomPrintTab.vala"
	self = (CustomPrintTab*) g_object_new (object_type, "source-job", source_job, NULL);
#line 43 "../src/Widgets/CustomPrintTab.vala"
	return self;
#line 227 "CustomPrintTab.c"
}

CustomPrintTab*
custom_print_tab_new (PrintJob* source_job)
{
#line 43 "../src/Widgets/CustomPrintTab.vala"
	return custom_print_tab_construct (TYPE_CUSTOM_PRINT_TAB, source_job);
#line 235 "CustomPrintTab.c"
}

static void
custom_print_tab_on_aspect_ratio_check_clicked (CustomPrintTab* self)
{
	GtkCheckButton* _tmp0_;
#line 174 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->aspect_ratio_check;
#line 175 "../src/Widgets/CustomPrintTab.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_)) {
#line 248 "CustomPrintTab.c"
		Measurement _tmp1_;
		PrintJob* _tmp2_;
		Measurement _tmp3_;
		GtkEntry* _tmp4_;
		Measurement _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 176 "../src/Widgets/CustomPrintTab.vala"
		_tmp1_ = self->priv->local_content_height;
#line 176 "../src/Widgets/CustomPrintTab.vala"
		_tmp2_ = self->priv->_source_job;
#line 176 "../src/Widgets/CustomPrintTab.vala"
		_tmp3_ = self->priv->local_content_height;
#line 176 "../src/Widgets/CustomPrintTab.vala"
		measurement_init (&self->priv->local_content_width, _tmp1_.value * print_job_get_source_aspect_ratio (_tmp2_), _tmp3_.unit);
#line 179 "../src/Widgets/CustomPrintTab.vala"
		_tmp4_ = self->priv->custom_width_entry;
#line 179 "../src/Widgets/CustomPrintTab.vala"
		_tmp5_ = self->priv->local_content_width;
#line 179 "../src/Widgets/CustomPrintTab.vala"
		_tmp6_ = custom_print_tab_format_measurement (self, &_tmp5_);
#line 179 "../src/Widgets/CustomPrintTab.vala"
		_tmp7_ = _tmp6_;
#line 179 "../src/Widgets/CustomPrintTab.vala"
		gtk_entry_set_text (_tmp4_, _tmp7_);
#line 179 "../src/Widgets/CustomPrintTab.vala"
		_g_free0 (_tmp7_);
#line 276 "CustomPrintTab.c"
	}
}

static gboolean
custom_print_tab_on_width_entry_focus_out (CustomPrintTab* self,
                                           GdkEventFocus* event)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	Measurement _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	Measurement new_width = {0};
	Measurement _tmp6_ = {0};
	Measurement min_width = {0};
	PrintJob* _tmp7_;
	PrintSettings* _tmp8_;
	PrintSettings* _tmp9_;
	Measurement _tmp10_ = {0};
	Measurement _tmp11_;
	Measurement max_width = {0};
	PrintJob* _tmp12_;
	PrintSettings* _tmp13_;
	PrintSettings* _tmp14_;
	Measurement _tmp15_ = {0};
	Measurement _tmp16_;
	gboolean _tmp17_ = FALSE;
	Measurement _tmp18_;
	Measurement _tmp32_;
	GtkEntry* _tmp33_;
	Measurement _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gboolean result;
#line 183 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 183 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 184 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->custom_width_entry;
#line 184 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 184 "../src/Widgets/CustomPrintTab.vala"
	_tmp2_ = self->priv->local_content_width;
#line 184 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = custom_print_tab_format_measurement_as (self, &_tmp2_, custom_print_tab_get_user_unit_choice (self));
#line 184 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = _tmp3_;
#line 184 "../src/Widgets/CustomPrintTab.vala"
	_tmp5_ = g_strcmp0 (_tmp1_, _tmp4_) == 0;
#line 184 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp4_);
#line 184 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp5_) {
#line 186 "../src/Widgets/CustomPrintTab.vala"
		result = FALSE;
#line 186 "../src/Widgets/CustomPrintTab.vala"
		return result;
#line 336 "CustomPrintTab.c"
	}
#line 188 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_get_width_entry_value (self, &_tmp6_);
#line 188 "../src/Widgets/CustomPrintTab.vala"
	new_width = _tmp6_;
#line 189 "../src/Widgets/CustomPrintTab.vala"
	_tmp7_ = self->priv->_source_job;
#line 189 "../src/Widgets/CustomPrintTab.vala"
	_tmp8_ = print_job_get_local_settings (_tmp7_);
#line 189 "../src/Widgets/CustomPrintTab.vala"
	_tmp9_ = _tmp8_;
#line 189 "../src/Widgets/CustomPrintTab.vala"
	print_settings_get_minimum_content_dimension (_tmp9_, &_tmp10_);
#line 189 "../src/Widgets/CustomPrintTab.vala"
	_tmp11_ = _tmp10_;
#line 189 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp9_);
#line 189 "../src/Widgets/CustomPrintTab.vala"
	min_width = _tmp11_;
#line 190 "../src/Widgets/CustomPrintTab.vala"
	_tmp12_ = self->priv->_source_job;
#line 190 "../src/Widgets/CustomPrintTab.vala"
	_tmp13_ = print_job_get_local_settings (_tmp12_);
#line 190 "../src/Widgets/CustomPrintTab.vala"
	_tmp14_ = _tmp13_;
#line 190 "../src/Widgets/CustomPrintTab.vala"
	print_settings_get_maximum_content_dimension (_tmp14_, &_tmp15_);
#line 190 "../src/Widgets/CustomPrintTab.vala"
	_tmp16_ = _tmp15_;
#line 190 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp14_);
#line 190 "../src/Widgets/CustomPrintTab.vala"
	max_width = _tmp16_;
#line 192 "../src/Widgets/CustomPrintTab.vala"
	_tmp18_ = min_width;
#line 192 "../src/Widgets/CustomPrintTab.vala"
	if (measurement_is_less_than (&new_width, &_tmp18_)) {
#line 192 "../src/Widgets/CustomPrintTab.vala"
		_tmp17_ = TRUE;
#line 376 "CustomPrintTab.c"
	} else {
		Measurement _tmp19_;
#line 192 "../src/Widgets/CustomPrintTab.vala"
		_tmp19_ = max_width;
#line 192 "../src/Widgets/CustomPrintTab.vala"
		_tmp17_ = measurement_is_greater_than (&new_width, &_tmp19_);
#line 383 "CustomPrintTab.c"
	}
#line 192 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp17_) {
#line 387 "CustomPrintTab.c"
		GtkEntry* _tmp20_;
		Measurement _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 193 "../src/Widgets/CustomPrintTab.vala"
		_tmp20_ = self->priv->custom_width_entry;
#line 193 "../src/Widgets/CustomPrintTab.vala"
		_tmp21_ = self->priv->local_content_width;
#line 193 "../src/Widgets/CustomPrintTab.vala"
		_tmp22_ = custom_print_tab_format_measurement (self, &_tmp21_);
#line 193 "../src/Widgets/CustomPrintTab.vala"
		_tmp23_ = _tmp22_;
#line 193 "../src/Widgets/CustomPrintTab.vala"
		gtk_entry_set_text (_tmp20_, _tmp23_);
#line 193 "../src/Widgets/CustomPrintTab.vala"
		_g_free0 (_tmp23_);
#line 194 "../src/Widgets/CustomPrintTab.vala"
		result = FALSE;
#line 194 "../src/Widgets/CustomPrintTab.vala"
		return result;
#line 408 "CustomPrintTab.c"
	}
#line 197 "../src/Widgets/CustomPrintTab.vala"
	if (custom_print_tab_is_match_aspect_ratio_enabled (self)) {
#line 412 "CustomPrintTab.c"
		Measurement new_height = {0};
		Measurement _tmp24_;
		PrintJob* _tmp25_;
		Measurement _tmp26_;
		Measurement _tmp27_;
		GtkEntry* _tmp28_;
		Measurement _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 198 "../src/Widgets/CustomPrintTab.vala"
		_tmp24_ = new_width;
#line 198 "../src/Widgets/CustomPrintTab.vala"
		_tmp25_ = self->priv->_source_job;
#line 198 "../src/Widgets/CustomPrintTab.vala"
		_tmp26_ = new_width;
#line 198 "../src/Widgets/CustomPrintTab.vala"
		measurement_init (&new_height, _tmp24_.value / print_job_get_source_aspect_ratio (_tmp25_), _tmp26_.unit);
#line 201 "../src/Widgets/CustomPrintTab.vala"
		_tmp27_ = new_height;
#line 201 "../src/Widgets/CustomPrintTab.vala"
		self->priv->local_content_height = _tmp27_;
#line 202 "../src/Widgets/CustomPrintTab.vala"
		_tmp28_ = self->priv->custom_height_entry;
#line 202 "../src/Widgets/CustomPrintTab.vala"
		_tmp29_ = new_height;
#line 202 "../src/Widgets/CustomPrintTab.vala"
		_tmp30_ = custom_print_tab_format_measurement (self, &_tmp29_);
#line 202 "../src/Widgets/CustomPrintTab.vala"
		_tmp31_ = _tmp30_;
#line 202 "../src/Widgets/CustomPrintTab.vala"
		gtk_entry_set_text (_tmp28_, _tmp31_);
#line 202 "../src/Widgets/CustomPrintTab.vala"
		_g_free0 (_tmp31_);
#line 446 "CustomPrintTab.c"
	}
#line 205 "../src/Widgets/CustomPrintTab.vala"
	_tmp32_ = new_width;
#line 205 "../src/Widgets/CustomPrintTab.vala"
	self->priv->local_content_width = _tmp32_;
#line 206 "../src/Widgets/CustomPrintTab.vala"
	_tmp33_ = self->priv->custom_width_entry;
#line 206 "../src/Widgets/CustomPrintTab.vala"
	_tmp34_ = new_width;
#line 206 "../src/Widgets/CustomPrintTab.vala"
	_tmp35_ = custom_print_tab_format_measurement (self, &_tmp34_);
#line 206 "../src/Widgets/CustomPrintTab.vala"
	_tmp36_ = _tmp35_;
#line 206 "../src/Widgets/CustomPrintTab.vala"
	gtk_entry_set_text (_tmp33_, _tmp36_);
#line 206 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp36_);
#line 207 "../src/Widgets/CustomPrintTab.vala"
	result = FALSE;
#line 207 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 468 "CustomPrintTab.c"
}

static gchar*
custom_print_tab_format_measurement (CustomPrintTab* self,
                                     Measurement* measurement)
{
	Measurement _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 210 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (measurement != NULL, NULL);
#line 211 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = *measurement;
#line 211 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = g_strdup_printf ("%.2f", _tmp0_.value);
#line 211 "../src/Widgets/CustomPrintTab.vala"
	result = _tmp1_;
#line 211 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 490 "CustomPrintTab.c"
}

static gchar*
custom_print_tab_format_measurement_as (CustomPrintTab* self,
                                        Measurement* measurement,
                                        MeasurementUnit to_unit)
{
	Measurement _tmp0_ = {0};
	Measurement _tmp1_;
	Measurement converted_measurement = {0};
	Measurement _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 214 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 214 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (measurement != NULL, NULL);
#line 215 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = *measurement;
#line 215 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp1_.unit == to_unit) {
#line 512 "CustomPrintTab.c"
		Measurement _tmp2_;
#line 215 "../src/Widgets/CustomPrintTab.vala"
		_tmp2_ = *measurement;
#line 215 "../src/Widgets/CustomPrintTab.vala"
		_tmp0_ = _tmp2_;
#line 518 "CustomPrintTab.c"
	} else {
		Measurement _tmp3_ = {0};
#line 216 "../src/Widgets/CustomPrintTab.vala"
		measurement_convert_to (measurement, to_unit, &_tmp3_);
#line 216 "../src/Widgets/CustomPrintTab.vala"
		_tmp0_ = _tmp3_;
#line 525 "CustomPrintTab.c"
	}
#line 215 "../src/Widgets/CustomPrintTab.vala"
	converted_measurement = _tmp0_;
#line 217 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = converted_measurement;
#line 217 "../src/Widgets/CustomPrintTab.vala"
	_tmp5_ = custom_print_tab_format_measurement (self, &_tmp4_);
#line 217 "../src/Widgets/CustomPrintTab.vala"
	result = _tmp5_;
#line 217 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 537 "CustomPrintTab.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 222 "../src/Widgets/CustomPrintTab.vala"
	return self ? g_object_ref (self) : NULL;
#line 545 "CustomPrintTab.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 562 "CustomPrintTab.c"
}

static void
custom_print_tab_on_ppi_entry_insert_text (CustomPrintTab* self,
                                           GtkEditable* editable,
                                           const gchar* text,
                                           gint length,
                                           gint* position)
{
	GtkEntry* sender = NULL;
	GtkEntry* _tmp0_;
	gchar* new_text = NULL;
	gchar* _tmp3_;
	const gchar* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GtkEntry* _tmp18_;
#line 220 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (editable != NULL);
#line 220 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (text != NULL);
#line 222 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (editable, gtk_entry_get_type (), GtkEntry));
#line 222 "../src/Widgets/CustomPrintTab.vala"
	sender = _tmp0_;
#line 224 "../src/Widgets/CustomPrintTab.vala"
	if (self->priv->is_text_insertion_in_progress) {
#line 225 "../src/Widgets/CustomPrintTab.vala"
		_g_object_unref0 (sender);
#line 225 "../src/Widgets/CustomPrintTab.vala"
		return;
#line 596 "CustomPrintTab.c"
	}
#line 227 "../src/Widgets/CustomPrintTab.vala"
	self->priv->is_text_insertion_in_progress = TRUE;
#line 229 "../src/Widgets/CustomPrintTab.vala"
	if (length == -1) {
#line 602 "CustomPrintTab.c"
		gint _tmp1_;
		gint _tmp2_;
#line 230 "../src/Widgets/CustomPrintTab.vala"
		_tmp1_ = strlen (text);
#line 230 "../src/Widgets/CustomPrintTab.vala"
		_tmp2_ = _tmp1_;
#line 230 "../src/Widgets/CustomPrintTab.vala"
		length = (gint) _tmp2_;
#line 611 "CustomPrintTab.c"
	}
#line 232 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = g_strdup ("");
#line 232 "../src/Widgets/CustomPrintTab.vala"
	new_text = _tmp3_;
#line 617 "CustomPrintTab.c"
	{
		gint ctr = 0;
#line 233 "../src/Widgets/CustomPrintTab.vala"
		ctr = 0;
#line 622 "CustomPrintTab.c"
		{
			gboolean _tmp4_ = FALSE;
#line 233 "../src/Widgets/CustomPrintTab.vala"
			_tmp4_ = TRUE;
#line 233 "../src/Widgets/CustomPrintTab.vala"
			while (TRUE) {
#line 233 "../src/Widgets/CustomPrintTab.vala"
				if (!_tmp4_) {
#line 631 "CustomPrintTab.c"
					gint _tmp5_;
#line 233 "../src/Widgets/CustomPrintTab.vala"
					_tmp5_ = ctr;
#line 233 "../src/Widgets/CustomPrintTab.vala"
					ctr = _tmp5_ + 1;
#line 637 "CustomPrintTab.c"
				}
#line 233 "../src/Widgets/CustomPrintTab.vala"
				_tmp4_ = FALSE;
#line 233 "../src/Widgets/CustomPrintTab.vala"
				if (!(ctr < length)) {
#line 233 "../src/Widgets/CustomPrintTab.vala"
					break;
#line 645 "CustomPrintTab.c"
				}
#line 234 "../src/Widgets/CustomPrintTab.vala"
				if (g_ascii_isdigit (string_get (text, (glong) ctr))) {
#line 649 "CustomPrintTab.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
#line 235 "../src/Widgets/CustomPrintTab.vala"
					_tmp6_ = new_text;
#line 235 "../src/Widgets/CustomPrintTab.vala"
					_tmp7_ = g_strdup_printf ("%c", (gchar) string_get (text, (glong) ctr));
#line 235 "../src/Widgets/CustomPrintTab.vala"
					_tmp8_ = _tmp7_;
#line 235 "../src/Widgets/CustomPrintTab.vala"
					_tmp9_ = g_strconcat (_tmp6_, _tmp8_, NULL);
#line 235 "../src/Widgets/CustomPrintTab.vala"
					_g_free0 (new_text);
#line 235 "../src/Widgets/CustomPrintTab.vala"
					new_text = _tmp9_;
#line 235 "../src/Widgets/CustomPrintTab.vala"
					_g_free0 (_tmp8_);
#line 668 "CustomPrintTab.c"
				}
			}
		}
	}
#line 238 "../src/Widgets/CustomPrintTab.vala"
	_tmp10_ = new_text;
#line 238 "../src/Widgets/CustomPrintTab.vala"
	_tmp11_ = strlen (_tmp10_);
#line 238 "../src/Widgets/CustomPrintTab.vala"
	_tmp12_ = _tmp11_;
#line 238 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp12_ > 0) {
#line 681 "CustomPrintTab.c"
		GtkEntry* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
#line 239 "../src/Widgets/CustomPrintTab.vala"
		_tmp13_ = sender;
#line 239 "../src/Widgets/CustomPrintTab.vala"
		_tmp14_ = new_text;
#line 239 "../src/Widgets/CustomPrintTab.vala"
		_tmp15_ = new_text;
#line 239 "../src/Widgets/CustomPrintTab.vala"
		_tmp16_ = strlen (_tmp15_);
#line 239 "../src/Widgets/CustomPrintTab.vala"
		_tmp17_ = _tmp16_;
#line 239 "../src/Widgets/CustomPrintTab.vala"
		g_signal_emit_by_name ((GtkEditable*) _tmp13_, "insert-text", _tmp14_, (gint) _tmp17_, position);
#line 699 "CustomPrintTab.c"
	}
#line 241 "../src/Widgets/CustomPrintTab.vala"
	_tmp18_ = sender;
#line 241 "../src/Widgets/CustomPrintTab.vala"
	g_signal_stop_emission_by_name (_tmp18_, "insert-text");
#line 243 "../src/Widgets/CustomPrintTab.vala"
	self->priv->is_text_insertion_in_progress = FALSE;
#line 220 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (new_text);
#line 220 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (sender);
#line 711 "CustomPrintTab.c"
}

static gboolean
custom_print_tab_on_height_entry_focus_out (CustomPrintTab* self,
                                            GdkEventFocus* event)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	Measurement _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	Measurement new_height = {0};
	Measurement _tmp6_ = {0};
	Measurement min_height = {0};
	PrintJob* _tmp7_;
	PrintSettings* _tmp8_;
	PrintSettings* _tmp9_;
	Measurement _tmp10_ = {0};
	Measurement _tmp11_;
	Measurement max_height = {0};
	PrintJob* _tmp12_;
	PrintSettings* _tmp13_;
	PrintSettings* _tmp14_;
	Measurement _tmp15_ = {0};
	Measurement _tmp16_;
	gboolean _tmp17_ = FALSE;
	Measurement _tmp18_;
	Measurement _tmp32_;
	GtkEntry* _tmp33_;
	Measurement _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gboolean result;
#line 246 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 246 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 247 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->custom_height_entry;
#line 247 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 247 "../src/Widgets/CustomPrintTab.vala"
	_tmp2_ = self->priv->local_content_height;
#line 247 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = custom_print_tab_format_measurement_as (self, &_tmp2_, custom_print_tab_get_user_unit_choice (self));
#line 247 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = _tmp3_;
#line 247 "../src/Widgets/CustomPrintTab.vala"
	_tmp5_ = g_strcmp0 (_tmp1_, _tmp4_) == 0;
#line 247 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp4_);
#line 247 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp5_) {
#line 249 "../src/Widgets/CustomPrintTab.vala"
		result = FALSE;
#line 249 "../src/Widgets/CustomPrintTab.vala"
		return result;
#line 770 "CustomPrintTab.c"
	}
#line 251 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_get_height_entry_value (self, &_tmp6_);
#line 251 "../src/Widgets/CustomPrintTab.vala"
	new_height = _tmp6_;
#line 252 "../src/Widgets/CustomPrintTab.vala"
	_tmp7_ = self->priv->_source_job;
#line 252 "../src/Widgets/CustomPrintTab.vala"
	_tmp8_ = print_job_get_local_settings (_tmp7_);
#line 252 "../src/Widgets/CustomPrintTab.vala"
	_tmp9_ = _tmp8_;
#line 252 "../src/Widgets/CustomPrintTab.vala"
	print_settings_get_minimum_content_dimension (_tmp9_, &_tmp10_);
#line 252 "../src/Widgets/CustomPrintTab.vala"
	_tmp11_ = _tmp10_;
#line 252 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp9_);
#line 252 "../src/Widgets/CustomPrintTab.vala"
	min_height = _tmp11_;
#line 253 "../src/Widgets/CustomPrintTab.vala"
	_tmp12_ = self->priv->_source_job;
#line 253 "../src/Widgets/CustomPrintTab.vala"
	_tmp13_ = print_job_get_local_settings (_tmp12_);
#line 253 "../src/Widgets/CustomPrintTab.vala"
	_tmp14_ = _tmp13_;
#line 253 "../src/Widgets/CustomPrintTab.vala"
	print_settings_get_maximum_content_dimension (_tmp14_, &_tmp15_);
#line 253 "../src/Widgets/CustomPrintTab.vala"
	_tmp16_ = _tmp15_;
#line 253 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp14_);
#line 253 "../src/Widgets/CustomPrintTab.vala"
	max_height = _tmp16_;
#line 255 "../src/Widgets/CustomPrintTab.vala"
	_tmp18_ = min_height;
#line 255 "../src/Widgets/CustomPrintTab.vala"
	if (measurement_is_less_than (&new_height, &_tmp18_)) {
#line 255 "../src/Widgets/CustomPrintTab.vala"
		_tmp17_ = TRUE;
#line 810 "CustomPrintTab.c"
	} else {
		Measurement _tmp19_;
#line 255 "../src/Widgets/CustomPrintTab.vala"
		_tmp19_ = max_height;
#line 255 "../src/Widgets/CustomPrintTab.vala"
		_tmp17_ = measurement_is_greater_than (&new_height, &_tmp19_);
#line 817 "CustomPrintTab.c"
	}
#line 255 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp17_) {
#line 821 "CustomPrintTab.c"
		GtkEntry* _tmp20_;
		Measurement _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 256 "../src/Widgets/CustomPrintTab.vala"
		_tmp20_ = self->priv->custom_height_entry;
#line 256 "../src/Widgets/CustomPrintTab.vala"
		_tmp21_ = self->priv->local_content_height;
#line 256 "../src/Widgets/CustomPrintTab.vala"
		_tmp22_ = custom_print_tab_format_measurement (self, &_tmp21_);
#line 256 "../src/Widgets/CustomPrintTab.vala"
		_tmp23_ = _tmp22_;
#line 256 "../src/Widgets/CustomPrintTab.vala"
		gtk_entry_set_text (_tmp20_, _tmp23_);
#line 256 "../src/Widgets/CustomPrintTab.vala"
		_g_free0 (_tmp23_);
#line 257 "../src/Widgets/CustomPrintTab.vala"
		result = FALSE;
#line 257 "../src/Widgets/CustomPrintTab.vala"
		return result;
#line 842 "CustomPrintTab.c"
	}
#line 260 "../src/Widgets/CustomPrintTab.vala"
	if (custom_print_tab_is_match_aspect_ratio_enabled (self)) {
#line 846 "CustomPrintTab.c"
		Measurement new_width = {0};
		Measurement _tmp24_;
		PrintJob* _tmp25_;
		Measurement _tmp26_;
		Measurement _tmp27_;
		GtkEntry* _tmp28_;
		Measurement _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 261 "../src/Widgets/CustomPrintTab.vala"
		_tmp24_ = new_height;
#line 261 "../src/Widgets/CustomPrintTab.vala"
		_tmp25_ = self->priv->_source_job;
#line 261 "../src/Widgets/CustomPrintTab.vala"
		_tmp26_ = new_height;
#line 261 "../src/Widgets/CustomPrintTab.vala"
		measurement_init (&new_width, _tmp24_.value * print_job_get_source_aspect_ratio (_tmp25_), _tmp26_.unit);
#line 264 "../src/Widgets/CustomPrintTab.vala"
		_tmp27_ = new_width;
#line 264 "../src/Widgets/CustomPrintTab.vala"
		self->priv->local_content_width = _tmp27_;
#line 265 "../src/Widgets/CustomPrintTab.vala"
		_tmp28_ = self->priv->custom_width_entry;
#line 265 "../src/Widgets/CustomPrintTab.vala"
		_tmp29_ = new_width;
#line 265 "../src/Widgets/CustomPrintTab.vala"
		_tmp30_ = custom_print_tab_format_measurement (self, &_tmp29_);
#line 265 "../src/Widgets/CustomPrintTab.vala"
		_tmp31_ = _tmp30_;
#line 265 "../src/Widgets/CustomPrintTab.vala"
		gtk_entry_set_text (_tmp28_, _tmp31_);
#line 265 "../src/Widgets/CustomPrintTab.vala"
		_g_free0 (_tmp31_);
#line 880 "CustomPrintTab.c"
	}
#line 268 "../src/Widgets/CustomPrintTab.vala"
	_tmp32_ = new_height;
#line 268 "../src/Widgets/CustomPrintTab.vala"
	self->priv->local_content_height = _tmp32_;
#line 269 "../src/Widgets/CustomPrintTab.vala"
	_tmp33_ = self->priv->custom_height_entry;
#line 269 "../src/Widgets/CustomPrintTab.vala"
	_tmp34_ = new_height;
#line 269 "../src/Widgets/CustomPrintTab.vala"
	_tmp35_ = custom_print_tab_format_measurement (self, &_tmp34_);
#line 269 "../src/Widgets/CustomPrintTab.vala"
	_tmp36_ = _tmp35_;
#line 269 "../src/Widgets/CustomPrintTab.vala"
	gtk_entry_set_text (_tmp33_, _tmp36_);
#line 269 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp36_);
#line 270 "../src/Widgets/CustomPrintTab.vala"
	result = FALSE;
#line 270 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 902 "CustomPrintTab.c"
}

static MeasurementUnit
custom_print_tab_get_user_unit_choice (CustomPrintTab* self)
{
	GtkComboBoxText* _tmp0_;
	MeasurementUnit result;
#line 273 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 274 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->units_combo;
#line 274 "../src/Widgets/CustomPrintTab.vala"
	if (gtk_combo_box_get_active ((GtkComboBox*) _tmp0_) == CUSTOM_PRINT_TAB_INCHES_COMBO_CHOICE) {
#line 275 "../src/Widgets/CustomPrintTab.vala"
		result = MEASUREMENT_UNIT_INCHES;
#line 275 "../src/Widgets/CustomPrintTab.vala"
		return result;
#line 920 "CustomPrintTab.c"
	} else {
		GtkComboBoxText* _tmp1_;
#line 276 "../src/Widgets/CustomPrintTab.vala"
		_tmp1_ = self->priv->units_combo;
#line 276 "../src/Widgets/CustomPrintTab.vala"
		if (gtk_combo_box_get_active ((GtkComboBox*) _tmp1_) == CUSTOM_PRINT_TAB_CENTIMETERS_COMBO_CHOICE) {
#line 277 "../src/Widgets/CustomPrintTab.vala"
			result = MEASUREMENT_UNIT_CENTIMETERS;
#line 277 "../src/Widgets/CustomPrintTab.vala"
			return result;
#line 931 "CustomPrintTab.c"
		} else {
#line 279 "../src/Widgets/CustomPrintTab.vala"
			g_error ("CustomPrintTab.vala:279: unknown unit combo box choice");
#line 935 "CustomPrintTab.c"
		}
	}
}

static void
custom_print_tab_set_user_unit_choice (CustomPrintTab* self,
                                       MeasurementUnit unit)
{
#line 283 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/Widgets/CustomPrintTab.vala"
	if (unit == MEASUREMENT_UNIT_INCHES) {
#line 948 "CustomPrintTab.c"
		GtkComboBoxText* _tmp0_;
#line 285 "../src/Widgets/CustomPrintTab.vala"
		_tmp0_ = self->priv->units_combo;
#line 285 "../src/Widgets/CustomPrintTab.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp0_, CUSTOM_PRINT_TAB_INCHES_COMBO_CHOICE);
#line 954 "CustomPrintTab.c"
	} else {
#line 286 "../src/Widgets/CustomPrintTab.vala"
		if (unit == MEASUREMENT_UNIT_CENTIMETERS) {
#line 958 "CustomPrintTab.c"
			GtkComboBoxText* _tmp1_;
#line 287 "../src/Widgets/CustomPrintTab.vala"
			_tmp1_ = self->priv->units_combo;
#line 287 "../src/Widgets/CustomPrintTab.vala"
			gtk_combo_box_set_active ((GtkComboBox*) _tmp1_, CUSTOM_PRINT_TAB_CENTIMETERS_COMBO_CHOICE);
#line 964 "CustomPrintTab.c"
		} else {
#line 289 "../src/Widgets/CustomPrintTab.vala"
			g_error ("CustomPrintTab.vala:289: unknown MeasurementUnit enumeration");
#line 968 "CustomPrintTab.c"
		}
	}
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 983 "CustomPrintTab.c"
}

static void
custom_print_tab_get_width_entry_value (CustomPrintTab* self,
                                        Measurement* result)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	Measurement _tmp2_ = {0};
#line 293 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 294 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->custom_width_entry;
#line 294 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 294 "../src/Widgets/CustomPrintTab.vala"
	measurement_init (&_tmp2_, double_parse (_tmp1_), custom_print_tab_get_user_unit_choice (self));
#line 294 "../src/Widgets/CustomPrintTab.vala"
	*result = _tmp2_;
#line 294 "../src/Widgets/CustomPrintTab.vala"
	return;
#line 1005 "CustomPrintTab.c"
}

static void
custom_print_tab_get_height_entry_value (CustomPrintTab* self,
                                         Measurement* result)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	Measurement _tmp2_ = {0};
#line 297 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->custom_height_entry;
#line 298 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 298 "../src/Widgets/CustomPrintTab.vala"
	measurement_init (&_tmp2_, double_parse (_tmp1_), custom_print_tab_get_user_unit_choice (self));
#line 298 "../src/Widgets/CustomPrintTab.vala"
	*result = _tmp2_;
#line 298 "../src/Widgets/CustomPrintTab.vala"
	return;
#line 1027 "CustomPrintTab.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1046 "CustomPrintTab.c"
}

static void
custom_print_tab_on_entry_insert_text (CustomPrintTab* self,
                                       GtkEditable* editable,
                                       const gchar* text,
                                       gint length,
                                       gint* position)
{
	GtkEntry* sender = NULL;
	GtkEntry* _tmp0_;
	gchar* decimal_point = NULL;
	struct lconv* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean contains_decimal_point = FALSE;
	GtkEntry* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* new_text = NULL;
	gchar* _tmp9_;
	const gchar* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GtkEntry* _tmp30_;
#line 301 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (editable != NULL);
#line 301 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (text != NULL);
#line 304 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (editable, gtk_entry_get_type (), GtkEntry));
#line 304 "../src/Widgets/CustomPrintTab.vala"
	sender = _tmp0_;
#line 306 "../src/Widgets/CustomPrintTab.vala"
	if (self->priv->is_text_insertion_in_progress) {
#line 307 "../src/Widgets/CustomPrintTab.vala"
		_g_object_unref0 (sender);
#line 307 "../src/Widgets/CustomPrintTab.vala"
		return;
#line 1088 "CustomPrintTab.c"
	}
#line 309 "../src/Widgets/CustomPrintTab.vala"
	self->priv->is_text_insertion_in_progress = TRUE;
#line 311 "../src/Widgets/CustomPrintTab.vala"
	if (length == -1) {
#line 1094 "CustomPrintTab.c"
		gint _tmp1_;
		gint _tmp2_;
#line 312 "../src/Widgets/CustomPrintTab.vala"
		_tmp1_ = strlen (text);
#line 312 "../src/Widgets/CustomPrintTab.vala"
		_tmp2_ = _tmp1_;
#line 312 "../src/Widgets/CustomPrintTab.vala"
		length = (gint) _tmp2_;
#line 1103 "CustomPrintTab.c"
	}
#line 314 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = localeconv ();
#line 314 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = _tmp3_->decimal_point;
#line 314 "../src/Widgets/CustomPrintTab.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 314 "../src/Widgets/CustomPrintTab.vala"
	decimal_point = _tmp5_;
#line 315 "../src/Widgets/CustomPrintTab.vala"
	_tmp6_ = sender;
#line 315 "../src/Widgets/CustomPrintTab.vala"
	_tmp7_ = gtk_entry_get_text (_tmp6_);
#line 315 "../src/Widgets/CustomPrintTab.vala"
	_tmp8_ = decimal_point;
#line 315 "../src/Widgets/CustomPrintTab.vala"
	contains_decimal_point = string_contains (_tmp7_, _tmp8_);
#line 317 "../src/Widgets/CustomPrintTab.vala"
	_tmp9_ = g_strdup ("");
#line 317 "../src/Widgets/CustomPrintTab.vala"
	new_text = _tmp9_;
#line 1125 "CustomPrintTab.c"
	{
		gint ctr = 0;
#line 318 "../src/Widgets/CustomPrintTab.vala"
		ctr = 0;
#line 1130 "CustomPrintTab.c"
		{
			gboolean _tmp10_ = FALSE;
#line 318 "../src/Widgets/CustomPrintTab.vala"
			_tmp10_ = TRUE;
#line 318 "../src/Widgets/CustomPrintTab.vala"
			while (TRUE) {
#line 318 "../src/Widgets/CustomPrintTab.vala"
				if (!_tmp10_) {
#line 1139 "CustomPrintTab.c"
					gint _tmp11_;
#line 318 "../src/Widgets/CustomPrintTab.vala"
					_tmp11_ = ctr;
#line 318 "../src/Widgets/CustomPrintTab.vala"
					ctr = _tmp11_ + 1;
#line 1145 "CustomPrintTab.c"
				}
#line 318 "../src/Widgets/CustomPrintTab.vala"
				_tmp10_ = FALSE;
#line 318 "../src/Widgets/CustomPrintTab.vala"
				if (!(ctr < length)) {
#line 318 "../src/Widgets/CustomPrintTab.vala"
					break;
#line 1153 "CustomPrintTab.c"
				}
#line 319 "../src/Widgets/CustomPrintTab.vala"
				if (g_ascii_isdigit (string_get (text, (glong) ctr))) {
#line 1157 "CustomPrintTab.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
#line 320 "../src/Widgets/CustomPrintTab.vala"
					_tmp12_ = new_text;
#line 320 "../src/Widgets/CustomPrintTab.vala"
					_tmp13_ = g_strdup_printf ("%c", (gchar) string_get (text, (glong) ctr));
#line 320 "../src/Widgets/CustomPrintTab.vala"
					_tmp14_ = _tmp13_;
#line 320 "../src/Widgets/CustomPrintTab.vala"
					_tmp15_ = g_strconcat (_tmp12_, _tmp14_, NULL);
#line 320 "../src/Widgets/CustomPrintTab.vala"
					_g_free0 (new_text);
#line 320 "../src/Widgets/CustomPrintTab.vala"
					new_text = _tmp15_;
#line 320 "../src/Widgets/CustomPrintTab.vala"
					_g_free0 (_tmp14_);
#line 1176 "CustomPrintTab.c"
				} else {
					gboolean _tmp16_ = FALSE;
#line 321 "../src/Widgets/CustomPrintTab.vala"
					if (!contains_decimal_point) {
#line 1181 "CustomPrintTab.c"
						const gchar* _tmp17_;
#line 321 "../src/Widgets/CustomPrintTab.vala"
						_tmp17_ = decimal_point;
#line 321 "../src/Widgets/CustomPrintTab.vala"
						_tmp16_ = string_get (text, (glong) ctr) == string_get (_tmp17_, (glong) 0);
#line 1187 "CustomPrintTab.c"
					} else {
#line 321 "../src/Widgets/CustomPrintTab.vala"
						_tmp16_ = FALSE;
#line 1191 "CustomPrintTab.c"
					}
#line 321 "../src/Widgets/CustomPrintTab.vala"
					if (_tmp16_) {
#line 1195 "CustomPrintTab.c"
						const gchar* _tmp18_;
						gchar* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
#line 322 "../src/Widgets/CustomPrintTab.vala"
						_tmp18_ = new_text;
#line 322 "../src/Widgets/CustomPrintTab.vala"
						_tmp19_ = g_strdup_printf ("%c", (gchar) string_get (text, (glong) ctr));
#line 322 "../src/Widgets/CustomPrintTab.vala"
						_tmp20_ = _tmp19_;
#line 322 "../src/Widgets/CustomPrintTab.vala"
						_tmp21_ = g_strconcat (_tmp18_, _tmp20_, NULL);
#line 322 "../src/Widgets/CustomPrintTab.vala"
						_g_free0 (new_text);
#line 322 "../src/Widgets/CustomPrintTab.vala"
						new_text = _tmp21_;
#line 322 "../src/Widgets/CustomPrintTab.vala"
						_g_free0 (_tmp20_);
#line 1214 "CustomPrintTab.c"
					}
				}
			}
		}
	}
#line 326 "../src/Widgets/CustomPrintTab.vala"
	_tmp22_ = new_text;
#line 326 "../src/Widgets/CustomPrintTab.vala"
	_tmp23_ = strlen (_tmp22_);
#line 326 "../src/Widgets/CustomPrintTab.vala"
	_tmp24_ = _tmp23_;
#line 326 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp24_ > 0) {
#line 1228 "CustomPrintTab.c"
		GtkEntry* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
#line 327 "../src/Widgets/CustomPrintTab.vala"
		_tmp25_ = sender;
#line 327 "../src/Widgets/CustomPrintTab.vala"
		_tmp26_ = new_text;
#line 327 "../src/Widgets/CustomPrintTab.vala"
		_tmp27_ = new_text;
#line 327 "../src/Widgets/CustomPrintTab.vala"
		_tmp28_ = strlen (_tmp27_);
#line 327 "../src/Widgets/CustomPrintTab.vala"
		_tmp29_ = _tmp28_;
#line 327 "../src/Widgets/CustomPrintTab.vala"
		g_signal_emit_by_name ((GtkEditable*) _tmp25_, "insert-text", _tmp26_, (gint) _tmp29_, position);
#line 1246 "CustomPrintTab.c"
	}
#line 329 "../src/Widgets/CustomPrintTab.vala"
	_tmp30_ = sender;
#line 329 "../src/Widgets/CustomPrintTab.vala"
	g_signal_stop_emission_by_name (_tmp30_, "insert-text");
#line 331 "../src/Widgets/CustomPrintTab.vala"
	self->priv->is_text_insertion_in_progress = FALSE;
#line 301 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (new_text);
#line 301 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (decimal_point);
#line 301 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (sender);
#line 1260 "CustomPrintTab.c"
}

static void
custom_print_tab_sync_state_from_job (CustomPrintTab* self,
                                      PrintJob* job)
{
	PrintSettings* _tmp0_;
	PrintSettings* _tmp1_;
	Measurement _tmp2_ = {0};
	PrintSettings* _tmp3_;
	PrintSettings* _tmp4_;
	Measurement _tmp5_ = {0};
	Measurement constrained_width = {0};
	PrintSettings* _tmp6_;
	PrintSettings* _tmp7_;
	Measurement _tmp8_ = {0};
	Measurement _tmp9_;
	PrintSettings* _tmp10_;
	PrintSettings* _tmp11_;
	gboolean _tmp12_;
	Measurement _tmp19_;
	PrintSettings* _tmp20_;
	PrintSettings* _tmp21_;
	Measurement _tmp22_ = {0};
	PrintSettings* _tmp23_;
	PrintSettings* _tmp24_;
	GtkSpinButton* _tmp25_;
	PrintSettings* _tmp26_;
	PrintSettings* _tmp27_;
	PrintSettings* _tmp28_;
	PrintSettings* _tmp29_;
	PrintSettings* _tmp30_;
	PrintSettings* _tmp31_;
	PrintSettings* _tmp32_;
	PrintSettings* _tmp33_;
	PrintSettings* _tmp34_;
	PrintSettings* _tmp35_;
	PrintSettings* _tmp36_;
	PrintSettings* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
#line 334 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (job != NULL);
#line 335 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = print_job_get_local_settings (job);
#line 335 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = _tmp0_;
#line 335 "../src/Widgets/CustomPrintTab.vala"
	print_settings_get_content_width (_tmp1_, &_tmp2_);
#line 335 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = print_job_get_local_settings (job);
#line 335 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = _tmp3_;
#line 335 "../src/Widgets/CustomPrintTab.vala"
	print_settings_get_content_height (_tmp4_, &_tmp5_);
#line 335 "../src/Widgets/CustomPrintTab.vala"
	_vala_assert (_tmp2_.unit == _tmp5_.unit, "job.get_local_settings ().get_content_width ().unit ==                 job.get_local_settings ().get_content_height ().unit");
#line 335 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp4_);
#line 335 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp1_);
#line 338 "../src/Widgets/CustomPrintTab.vala"
	_tmp6_ = print_job_get_local_settings (job);
#line 338 "../src/Widgets/CustomPrintTab.vala"
	_tmp7_ = _tmp6_;
#line 338 "../src/Widgets/CustomPrintTab.vala"
	print_settings_get_content_width (_tmp7_, &_tmp8_);
#line 338 "../src/Widgets/CustomPrintTab.vala"
	_tmp9_ = _tmp8_;
#line 338 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp7_);
#line 338 "../src/Widgets/CustomPrintTab.vala"
	constrained_width = _tmp9_;
#line 339 "../src/Widgets/CustomPrintTab.vala"
	_tmp10_ = print_job_get_local_settings (job);
#line 339 "../src/Widgets/CustomPrintTab.vala"
	_tmp11_ = _tmp10_;
#line 339 "../src/Widgets/CustomPrintTab.vala"
	_tmp12_ = print_settings_is_match_aspect_ratio_enabled (_tmp11_);
#line 339 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp11_);
#line 339 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp12_) {
#line 1346 "CustomPrintTab.c"
		PrintSettings* _tmp13_;
		PrintSettings* _tmp14_;
		Measurement _tmp15_ = {0};
		PrintSettings* _tmp16_;
		PrintSettings* _tmp17_;
		Measurement _tmp18_ = {0};
#line 340 "../src/Widgets/CustomPrintTab.vala"
		_tmp13_ = print_job_get_local_settings (job);
#line 340 "../src/Widgets/CustomPrintTab.vala"
		_tmp14_ = _tmp13_;
#line 340 "../src/Widgets/CustomPrintTab.vala"
		print_settings_get_content_height (_tmp14_, &_tmp15_);
#line 340 "../src/Widgets/CustomPrintTab.vala"
		_tmp16_ = print_job_get_local_settings (job);
#line 340 "../src/Widgets/CustomPrintTab.vala"
		_tmp17_ = _tmp16_;
#line 340 "../src/Widgets/CustomPrintTab.vala"
		print_settings_get_content_height (_tmp17_, &_tmp18_);
#line 340 "../src/Widgets/CustomPrintTab.vala"
		measurement_init (&constrained_width, _tmp15_.value * print_job_get_source_aspect_ratio (job), _tmp18_.unit);
#line 340 "../src/Widgets/CustomPrintTab.vala"
		_print_settings_unref0 (_tmp17_);
#line 340 "../src/Widgets/CustomPrintTab.vala"
		_print_settings_unref0 (_tmp14_);
#line 1371 "CustomPrintTab.c"
	}
#line 342 "../src/Widgets/CustomPrintTab.vala"
	_tmp19_ = constrained_width;
#line 342 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_content_width (self, &_tmp19_);
#line 343 "../src/Widgets/CustomPrintTab.vala"
	_tmp20_ = print_job_get_local_settings (job);
#line 343 "../src/Widgets/CustomPrintTab.vala"
	_tmp21_ = _tmp20_;
#line 343 "../src/Widgets/CustomPrintTab.vala"
	print_settings_get_content_height (_tmp21_, &_tmp22_);
#line 343 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_content_height (self, &_tmp22_);
#line 343 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp21_);
#line 344 "../src/Widgets/CustomPrintTab.vala"
	_tmp23_ = print_job_get_local_settings (job);
#line 344 "../src/Widgets/CustomPrintTab.vala"
	_tmp24_ = _tmp23_;
#line 344 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_content_layout (self, print_settings_get_content_layout (_tmp24_));
#line 344 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp24_);
#line 345 "../src/Widgets/CustomPrintTab.vala"
	_tmp25_ = self->priv->ppi_entry;
#line 345 "../src/Widgets/CustomPrintTab.vala"
	_tmp26_ = print_job_get_local_settings (job);
#line 345 "../src/Widgets/CustomPrintTab.vala"
	_tmp27_ = _tmp26_;
#line 345 "../src/Widgets/CustomPrintTab.vala"
	gtk_spin_button_set_value (_tmp25_, (gdouble) print_settings_get_content_ppi (_tmp27_));
#line 345 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp27_);
#line 346 "../src/Widgets/CustomPrintTab.vala"
	_tmp28_ = print_job_get_local_settings (job);
#line 346 "../src/Widgets/CustomPrintTab.vala"
	_tmp29_ = _tmp28_;
#line 346 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_image_per_page_selection (self, print_settings_get_image_per_page_selection (_tmp29_));
#line 346 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp29_);
#line 347 "../src/Widgets/CustomPrintTab.vala"
	_tmp30_ = print_job_get_local_settings (job);
#line 347 "../src/Widgets/CustomPrintTab.vala"
	_tmp31_ = _tmp30_;
#line 347 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_size_selection (self, print_settings_get_size_selection (_tmp31_));
#line 347 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp31_);
#line 348 "../src/Widgets/CustomPrintTab.vala"
	_tmp32_ = print_job_get_local_settings (job);
#line 348 "../src/Widgets/CustomPrintTab.vala"
	_tmp33_ = _tmp32_;
#line 348 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_match_aspect_ratio_enabled (self, print_settings_is_match_aspect_ratio_enabled (_tmp33_));
#line 348 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp33_);
#line 349 "../src/Widgets/CustomPrintTab.vala"
	_tmp34_ = print_job_get_local_settings (job);
#line 349 "../src/Widgets/CustomPrintTab.vala"
	_tmp35_ = _tmp34_;
#line 349 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_print_titles_enabled (self, print_settings_is_print_titles_enabled (_tmp35_));
#line 349 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp35_);
#line 350 "../src/Widgets/CustomPrintTab.vala"
	_tmp36_ = print_job_get_local_settings (job);
#line 350 "../src/Widgets/CustomPrintTab.vala"
	_tmp37_ = _tmp36_;
#line 350 "../src/Widgets/CustomPrintTab.vala"
	_tmp38_ = print_settings_get_print_titles_font (_tmp37_);
#line 350 "../src/Widgets/CustomPrintTab.vala"
	_tmp39_ = _tmp38_;
#line 350 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_print_titles_font (self, _tmp39_);
#line 350 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp39_);
#line 350 "../src/Widgets/CustomPrintTab.vala"
	_print_settings_unref0 (_tmp37_);
#line 1451 "CustomPrintTab.c"
}

static void
custom_print_tab_on_radio_group_click (CustomPrintTab* self,
                                       GtkButton* b)
{
	GtkRadioButton* sender = NULL;
	GtkRadioButton* _tmp0_;
	GtkRadioButton* _tmp1_;
	GtkRadioButton* _tmp2_;
#line 353 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (b != NULL);
#line 354 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (b, gtk_radio_button_get_type (), GtkRadioButton));
#line 354 "../src/Widgets/CustomPrintTab.vala"
	sender = _tmp0_;
#line 356 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = sender;
#line 356 "../src/Widgets/CustomPrintTab.vala"
	_tmp2_ = self->priv->standard_size_radio;
#line 356 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp1_ == _tmp2_) {
#line 1476 "CustomPrintTab.c"
		GtkComboBox* _tmp3_;
#line 357 "../src/Widgets/CustomPrintTab.vala"
		custom_print_tab_set_content_layout_control_state (self, CONTENT_LAYOUT_STANDARD_SIZE);
#line 358 "../src/Widgets/CustomPrintTab.vala"
		_tmp3_ = self->priv->standard_sizes_combo;
#line 358 "../src/Widgets/CustomPrintTab.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 1484 "CustomPrintTab.c"
	} else {
		GtkRadioButton* _tmp4_;
		GtkRadioButton* _tmp5_;
#line 359 "../src/Widgets/CustomPrintTab.vala"
		_tmp4_ = sender;
#line 359 "../src/Widgets/CustomPrintTab.vala"
		_tmp5_ = self->priv->custom_size_radio;
#line 359 "../src/Widgets/CustomPrintTab.vala"
		if (_tmp4_ == _tmp5_) {
#line 1494 "CustomPrintTab.c"
			GtkEntry* _tmp6_;
#line 360 "../src/Widgets/CustomPrintTab.vala"
			custom_print_tab_set_content_layout_control_state (self, CONTENT_LAYOUT_CUSTOM_SIZE);
#line 361 "../src/Widgets/CustomPrintTab.vala"
			_tmp6_ = self->priv->custom_height_entry;
#line 361 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 1502 "CustomPrintTab.c"
		} else {
			GtkRadioButton* _tmp7_;
			GtkRadioButton* _tmp8_;
#line 362 "../src/Widgets/CustomPrintTab.vala"
			_tmp7_ = sender;
#line 362 "../src/Widgets/CustomPrintTab.vala"
			_tmp8_ = self->priv->image_per_page_radio;
#line 362 "../src/Widgets/CustomPrintTab.vala"
			if (_tmp7_ == _tmp8_) {
#line 363 "../src/Widgets/CustomPrintTab.vala"
				custom_print_tab_set_content_layout_control_state (self, CONTENT_LAYOUT_IMAGE_PER_PAGE);
#line 1514 "CustomPrintTab.c"
			}
		}
	}
#line 353 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (sender);
#line 1520 "CustomPrintTab.c"
}

static void
custom_print_tab_on_units_combo_changed (CustomPrintTab* self)
{
	GtkEntry* _tmp0_;
	Measurement _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkEntry* _tmp4_;
	Measurement _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 367 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 368 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->custom_height_entry;
#line 368 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = self->priv->local_content_height;
#line 368 "../src/Widgets/CustomPrintTab.vala"
	_tmp2_ = custom_print_tab_format_measurement_as (self, &_tmp1_, custom_print_tab_get_user_unit_choice (self));
#line 368 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = _tmp2_;
#line 368 "../src/Widgets/CustomPrintTab.vala"
	gtk_entry_set_text (_tmp0_, _tmp3_);
#line 368 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp3_);
#line 370 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = self->priv->custom_width_entry;
#line 370 "../src/Widgets/CustomPrintTab.vala"
	_tmp5_ = self->priv->local_content_width;
#line 370 "../src/Widgets/CustomPrintTab.vala"
	_tmp6_ = custom_print_tab_format_measurement_as (self, &_tmp5_, custom_print_tab_get_user_unit_choice (self));
#line 370 "../src/Widgets/CustomPrintTab.vala"
	_tmp7_ = _tmp6_;
#line 370 "../src/Widgets/CustomPrintTab.vala"
	gtk_entry_set_text (_tmp4_, _tmp7_);
#line 370 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp7_);
#line 1560 "CustomPrintTab.c"
}

static void
custom_print_tab_set_content_layout_control_state (CustomPrintTab* self,
                                                   ContentLayout layout)
{
#line 374 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/Widgets/CustomPrintTab.vala"
	switch (layout) {
#line 375 "../src/Widgets/CustomPrintTab.vala"
		case CONTENT_LAYOUT_STANDARD_SIZE:
#line 1573 "CustomPrintTab.c"
		{
			GtkComboBox* _tmp0_;
			GtkComboBoxText* _tmp1_;
			GtkEntry* _tmp2_;
			GtkEntry* _tmp3_;
			GtkCheckButton* _tmp4_;
			GtkComboBox* _tmp5_;
#line 377 "../src/Widgets/CustomPrintTab.vala"
			_tmp0_ = self->priv->standard_sizes_combo;
#line 377 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 378 "../src/Widgets/CustomPrintTab.vala"
			_tmp1_ = self->priv->units_combo;
#line 378 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 379 "../src/Widgets/CustomPrintTab.vala"
			_tmp2_ = self->priv->custom_width_entry;
#line 379 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
#line 380 "../src/Widgets/CustomPrintTab.vala"
			_tmp3_ = self->priv->custom_height_entry;
#line 380 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
#line 381 "../src/Widgets/CustomPrintTab.vala"
			_tmp4_ = self->priv->aspect_ratio_check;
#line 381 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, FALSE);
#line 382 "../src/Widgets/CustomPrintTab.vala"
			_tmp5_ = self->priv->image_per_page_combo;
#line 382 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
#line 383 "../src/Widgets/CustomPrintTab.vala"
			break;
#line 1607 "CustomPrintTab.c"
		}
#line 375 "../src/Widgets/CustomPrintTab.vala"
		case CONTENT_LAYOUT_CUSTOM_SIZE:
#line 1611 "CustomPrintTab.c"
		{
			GtkComboBox* _tmp6_;
			GtkComboBoxText* _tmp7_;
			GtkEntry* _tmp8_;
			GtkEntry* _tmp9_;
			GtkCheckButton* _tmp10_;
			GtkComboBox* _tmp11_;
#line 386 "../src/Widgets/CustomPrintTab.vala"
			_tmp6_ = self->priv->standard_sizes_combo;
#line 386 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 387 "../src/Widgets/CustomPrintTab.vala"
			_tmp7_ = self->priv->units_combo;
#line 387 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
#line 388 "../src/Widgets/CustomPrintTab.vala"
			_tmp8_ = self->priv->custom_width_entry;
#line 388 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, TRUE);
#line 389 "../src/Widgets/CustomPrintTab.vala"
			_tmp9_ = self->priv->custom_height_entry;
#line 389 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, TRUE);
#line 390 "../src/Widgets/CustomPrintTab.vala"
			_tmp10_ = self->priv->aspect_ratio_check;
#line 390 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
#line 391 "../src/Widgets/CustomPrintTab.vala"
			_tmp11_ = self->priv->image_per_page_combo;
#line 391 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 392 "../src/Widgets/CustomPrintTab.vala"
			break;
#line 1645 "CustomPrintTab.c"
		}
#line 375 "../src/Widgets/CustomPrintTab.vala"
		case CONTENT_LAYOUT_IMAGE_PER_PAGE:
#line 1649 "CustomPrintTab.c"
		{
			GtkComboBox* _tmp12_;
			GtkComboBoxText* _tmp13_;
			GtkEntry* _tmp14_;
			GtkEntry* _tmp15_;
			GtkCheckButton* _tmp16_;
			GtkComboBox* _tmp17_;
#line 395 "../src/Widgets/CustomPrintTab.vala"
			_tmp12_ = self->priv->standard_sizes_combo;
#line 395 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, FALSE);
#line 396 "../src/Widgets/CustomPrintTab.vala"
			_tmp13_ = self->priv->units_combo;
#line 396 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, FALSE);
#line 397 "../src/Widgets/CustomPrintTab.vala"
			_tmp14_ = self->priv->custom_width_entry;
#line 397 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
#line 398 "../src/Widgets/CustomPrintTab.vala"
			_tmp15_ = self->priv->custom_height_entry;
#line 398 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, FALSE);
#line 399 "../src/Widgets/CustomPrintTab.vala"
			_tmp16_ = self->priv->aspect_ratio_check;
#line 399 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, FALSE);
#line 400 "../src/Widgets/CustomPrintTab.vala"
			_tmp17_ = self->priv->image_per_page_combo;
#line 400 "../src/Widgets/CustomPrintTab.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, TRUE);
#line 401 "../src/Widgets/CustomPrintTab.vala"
			break;
#line 1683 "CustomPrintTab.c"
		}
		default:
		{
#line 404 "../src/Widgets/CustomPrintTab.vala"
			g_error ("CustomPrintTab.vala:404: unknown ContentLayout enumeration value");
#line 1689 "CustomPrintTab.c"
		}
	}
}

static gboolean
custom_print_tab_standard_sizes_combo_separator_func (GtkTreeModel* model,
                                                      GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 408 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 408 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 411 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = *iter;
#line 411 "../src/Widgets/CustomPrintTab.vala"
	gtk_tree_model_get_value (model, &_tmp0_, 0, &_tmp1_);
#line 411 "../src/Widgets/CustomPrintTab.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 411 "../src/Widgets/CustomPrintTab.vala"
	val = _tmp1_;
#line 413 "../src/Widgets/CustomPrintTab.vala"
	_tmp2_ = g_value_dup_string (&val);
#line 413 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = _tmp2_;
#line 413 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "-") == 0;
#line 413 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp3_);
#line 413 "../src/Widgets/CustomPrintTab.vala"
	result = _tmp4_;
#line 413 "../src/Widgets/CustomPrintTab.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 413 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 1731 "CustomPrintTab.c"
}

static void
custom_print_tab_set_content_layout (CustomPrintTab* self,
                                     ContentLayout content_layout)
{
#line 416 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 417 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_set_content_layout_control_state (self, content_layout);
#line 418 "../src/Widgets/CustomPrintTab.vala"
	switch (content_layout) {
#line 418 "../src/Widgets/CustomPrintTab.vala"
		case CONTENT_LAYOUT_STANDARD_SIZE:
#line 1746 "CustomPrintTab.c"
		{
			GtkRadioButton* _tmp0_;
#line 420 "../src/Widgets/CustomPrintTab.vala"
			_tmp0_ = self->priv->standard_size_radio;
#line 420 "../src/Widgets/CustomPrintTab.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 421 "../src/Widgets/CustomPrintTab.vala"
			break;
#line 1755 "CustomPrintTab.c"
		}
#line 418 "../src/Widgets/CustomPrintTab.vala"
		case CONTENT_LAYOUT_CUSTOM_SIZE:
#line 1759 "CustomPrintTab.c"
		{
			GtkRadioButton* _tmp1_;
#line 424 "../src/Widgets/CustomPrintTab.vala"
			_tmp1_ = self->priv->custom_size_radio;
#line 424 "../src/Widgets/CustomPrintTab.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
#line 425 "../src/Widgets/CustomPrintTab.vala"
			break;
#line 1768 "CustomPrintTab.c"
		}
#line 418 "../src/Widgets/CustomPrintTab.vala"
		case CONTENT_LAYOUT_IMAGE_PER_PAGE:
#line 1772 "CustomPrintTab.c"
		{
			GtkRadioButton* _tmp2_;
#line 428 "../src/Widgets/CustomPrintTab.vala"
			_tmp2_ = self->priv->image_per_page_radio;
#line 428 "../src/Widgets/CustomPrintTab.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
#line 429 "../src/Widgets/CustomPrintTab.vala"
			break;
#line 1781 "CustomPrintTab.c"
		}
		default:
		{
#line 432 "../src/Widgets/CustomPrintTab.vala"
			g_error ("CustomPrintTab.vala:432: unknown ContentLayout enumeration value");
#line 1787 "CustomPrintTab.c"
		}
	}
}

static ContentLayout
custom_print_tab_get_content_layout (CustomPrintTab* self)
{
	GtkRadioButton* _tmp0_;
	GtkRadioButton* _tmp1_;
	GtkRadioButton* _tmp2_;
	ContentLayout result;
#line 436 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 437 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->standard_size_radio;
#line 437 "../src/Widgets/CustomPrintTab.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_)) {
#line 438 "../src/Widgets/CustomPrintTab.vala"
		result = CONTENT_LAYOUT_STANDARD_SIZE;
#line 438 "../src/Widgets/CustomPrintTab.vala"
		return result;
#line 1809 "CustomPrintTab.c"
	}
#line 439 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = self->priv->custom_size_radio;
#line 439 "../src/Widgets/CustomPrintTab.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_)) {
#line 440 "../src/Widgets/CustomPrintTab.vala"
		result = CONTENT_LAYOUT_CUSTOM_SIZE;
#line 440 "../src/Widgets/CustomPrintTab.vala"
		return result;
#line 1819 "CustomPrintTab.c"
	}
#line 441 "../src/Widgets/CustomPrintTab.vala"
	_tmp2_ = self->priv->image_per_page_radio;
#line 441 "../src/Widgets/CustomPrintTab.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp2_)) {
#line 442 "../src/Widgets/CustomPrintTab.vala"
		result = CONTENT_LAYOUT_IMAGE_PER_PAGE;
#line 442 "../src/Widgets/CustomPrintTab.vala"
		return result;
#line 1829 "CustomPrintTab.c"
	}
#line 444 "../src/Widgets/CustomPrintTab.vala"
	g_error ("CustomPrintTab.vala:444: inconsistent content layout radio button grou" \
"p state");
#line 1833 "CustomPrintTab.c"
}

static void
custom_print_tab_set_content_width (CustomPrintTab* self,
                                    Measurement* content_width)
{
	Measurement _tmp0_;
	Measurement _tmp1_;
	Measurement _tmp9_;
	GtkEntry* _tmp10_;
	Measurement _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 447 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 447 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (content_width != NULL);
#line 448 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = *content_width;
#line 448 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = self->priv->local_content_height;
#line 448 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp0_.unit != _tmp1_.unit) {
#line 1857 "CustomPrintTab.c"
		Measurement _tmp2_;
		Measurement _tmp3_;
		Measurement _tmp4_ = {0};
		GtkEntry* _tmp5_;
		Measurement _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 449 "../src/Widgets/CustomPrintTab.vala"
		_tmp2_ = *content_width;
#line 449 "../src/Widgets/CustomPrintTab.vala"
		custom_print_tab_set_user_unit_choice (self, _tmp2_.unit);
#line 450 "../src/Widgets/CustomPrintTab.vala"
		_tmp3_ = *content_width;
#line 450 "../src/Widgets/CustomPrintTab.vala"
		measurement_convert_to (&self->priv->local_content_height, _tmp3_.unit, &_tmp4_);
#line 450 "../src/Widgets/CustomPrintTab.vala"
		self->priv->local_content_height = _tmp4_;
#line 451 "../src/Widgets/CustomPrintTab.vala"
		_tmp5_ = self->priv->custom_height_entry;
#line 451 "../src/Widgets/CustomPrintTab.vala"
		_tmp6_ = self->priv->local_content_height;
#line 451 "../src/Widgets/CustomPrintTab.vala"
		_tmp7_ = custom_print_tab_format_measurement (self, &_tmp6_);
#line 451 "../src/Widgets/CustomPrintTab.vala"
		_tmp8_ = _tmp7_;
#line 451 "../src/Widgets/CustomPrintTab.vala"
		gtk_entry_set_text (_tmp5_, _tmp8_);
#line 451 "../src/Widgets/CustomPrintTab.vala"
		_g_free0 (_tmp8_);
#line 1887 "CustomPrintTab.c"
	}
#line 453 "../src/Widgets/CustomPrintTab.vala"
	_tmp9_ = *content_width;
#line 453 "../src/Widgets/CustomPrintTab.vala"
	self->priv->local_content_width = _tmp9_;
#line 454 "../src/Widgets/CustomPrintTab.vala"
	_tmp10_ = self->priv->custom_width_entry;
#line 454 "../src/Widgets/CustomPrintTab.vala"
	_tmp11_ = *content_width;
#line 454 "../src/Widgets/CustomPrintTab.vala"
	_tmp12_ = custom_print_tab_format_measurement (self, &_tmp11_);
#line 454 "../src/Widgets/CustomPrintTab.vala"
	_tmp13_ = _tmp12_;
#line 454 "../src/Widgets/CustomPrintTab.vala"
	gtk_entry_set_text (_tmp10_, _tmp13_);
#line 454 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp13_);
#line 1905 "CustomPrintTab.c"
}

static void
custom_print_tab_get_content_width (CustomPrintTab* self,
                                    Measurement* result)
{
	Measurement _tmp0_;
#line 457 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->local_content_width;
#line 458 "../src/Widgets/CustomPrintTab.vala"
	*result = _tmp0_;
#line 458 "../src/Widgets/CustomPrintTab.vala"
	return;
#line 1921 "CustomPrintTab.c"
}

static void
custom_print_tab_set_content_height (CustomPrintTab* self,
                                     Measurement* content_height)
{
	Measurement _tmp0_;
	Measurement _tmp1_;
	Measurement _tmp9_;
	GtkEntry* _tmp10_;
	Measurement _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 461 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 461 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (content_height != NULL);
#line 462 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = *content_height;
#line 462 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = self->priv->local_content_width;
#line 462 "../src/Widgets/CustomPrintTab.vala"
	if (_tmp0_.unit != _tmp1_.unit) {
#line 1945 "CustomPrintTab.c"
		Measurement _tmp2_;
		Measurement _tmp3_;
		Measurement _tmp4_ = {0};
		GtkEntry* _tmp5_;
		Measurement _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 463 "../src/Widgets/CustomPrintTab.vala"
		_tmp2_ = *content_height;
#line 463 "../src/Widgets/CustomPrintTab.vala"
		custom_print_tab_set_user_unit_choice (self, _tmp2_.unit);
#line 464 "../src/Widgets/CustomPrintTab.vala"
		_tmp3_ = *content_height;
#line 464 "../src/Widgets/CustomPrintTab.vala"
		measurement_convert_to (&self->priv->local_content_width, _tmp3_.unit, &_tmp4_);
#line 464 "../src/Widgets/CustomPrintTab.vala"
		self->priv->local_content_width = _tmp4_;
#line 465 "../src/Widgets/CustomPrintTab.vala"
		_tmp5_ = self->priv->custom_width_entry;
#line 465 "../src/Widgets/CustomPrintTab.vala"
		_tmp6_ = self->priv->local_content_width;
#line 465 "../src/Widgets/CustomPrintTab.vala"
		_tmp7_ = custom_print_tab_format_measurement (self, &_tmp6_);
#line 465 "../src/Widgets/CustomPrintTab.vala"
		_tmp8_ = _tmp7_;
#line 465 "../src/Widgets/CustomPrintTab.vala"
		gtk_entry_set_text (_tmp5_, _tmp8_);
#line 465 "../src/Widgets/CustomPrintTab.vala"
		_g_free0 (_tmp8_);
#line 1975 "CustomPrintTab.c"
	}
#line 467 "../src/Widgets/CustomPrintTab.vala"
	_tmp9_ = *content_height;
#line 467 "../src/Widgets/CustomPrintTab.vala"
	self->priv->local_content_height = _tmp9_;
#line 468 "../src/Widgets/CustomPrintTab.vala"
	_tmp10_ = self->priv->custom_height_entry;
#line 468 "../src/Widgets/CustomPrintTab.vala"
	_tmp11_ = *content_height;
#line 468 "../src/Widgets/CustomPrintTab.vala"
	_tmp12_ = custom_print_tab_format_measurement (self, &_tmp11_);
#line 468 "../src/Widgets/CustomPrintTab.vala"
	_tmp13_ = _tmp12_;
#line 468 "../src/Widgets/CustomPrintTab.vala"
	gtk_entry_set_text (_tmp10_, _tmp13_);
#line 468 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp13_);
#line 1993 "CustomPrintTab.c"
}

static void
custom_print_tab_get_content_height (CustomPrintTab* self,
                                     Measurement* result)
{
	Measurement _tmp0_;
#line 471 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->local_content_height;
#line 472 "../src/Widgets/CustomPrintTab.vala"
	*result = _tmp0_;
#line 472 "../src/Widgets/CustomPrintTab.vala"
	return;
#line 2009 "CustomPrintTab.c"
}

static void
custom_print_tab_set_image_per_page_selection (CustomPrintTab* self,
                                               gint image_per_page)
{
	GtkComboBox* _tmp0_;
#line 475 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 476 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->image_per_page_combo;
#line 476 "../src/Widgets/CustomPrintTab.vala"
	gtk_combo_box_set_active (_tmp0_, image_per_page);
#line 2023 "CustomPrintTab.c"
}

static gint
custom_print_tab_get_image_per_page_selection (CustomPrintTab* self)
{
	GtkComboBox* _tmp0_;
	gint result;
#line 479 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 480 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->image_per_page_combo;
#line 480 "../src/Widgets/CustomPrintTab.vala"
	result = gtk_combo_box_get_active (_tmp0_);
#line 480 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2039 "CustomPrintTab.c"
}

static void
custom_print_tab_set_size_selection (CustomPrintTab* self,
                                     gint size_selection)
{
	GtkComboBox* _tmp0_;
#line 483 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 484 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->standard_sizes_combo;
#line 484 "../src/Widgets/CustomPrintTab.vala"
	gtk_combo_box_set_active (_tmp0_, size_selection);
#line 2053 "CustomPrintTab.c"
}

static gint
custom_print_tab_get_size_selection (CustomPrintTab* self)
{
	GtkComboBox* _tmp0_;
	gint result;
#line 487 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 488 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->standard_sizes_combo;
#line 488 "../src/Widgets/CustomPrintTab.vala"
	result = gtk_combo_box_get_active (_tmp0_);
#line 488 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2069 "CustomPrintTab.c"
}

static void
custom_print_tab_set_match_aspect_ratio_enabled (CustomPrintTab* self,
                                                 gboolean enable_state)
{
	GtkCheckButton* _tmp0_;
#line 491 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 492 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->aspect_ratio_check;
#line 492 "../src/Widgets/CustomPrintTab.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, enable_state);
#line 2083 "CustomPrintTab.c"
}

static void
custom_print_tab_set_print_titles_enabled (CustomPrintTab* self,
                                           gboolean print_titles)
{
	GtkCheckButton* _tmp0_;
#line 495 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 496 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->title_print_check;
#line 496 "../src/Widgets/CustomPrintTab.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, print_titles);
#line 2097 "CustomPrintTab.c"
}

static void
custom_print_tab_set_print_titles_font (CustomPrintTab* self,
                                        const gchar* fontname)
{
	GtkFontButton* _tmp0_;
#line 499 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 499 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (fontname != NULL);
#line 500 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->title_print_font;
#line 500 "../src/Widgets/CustomPrintTab.vala"
	gtk_font_chooser_set_font ((GtkFontChooser*) _tmp0_, fontname);
#line 2113 "CustomPrintTab.c"
}

static gboolean
custom_print_tab_is_match_aspect_ratio_enabled (CustomPrintTab* self)
{
	GtkCheckButton* _tmp0_;
	gboolean result;
#line 504 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 505 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->aspect_ratio_check;
#line 505 "../src/Widgets/CustomPrintTab.vala"
	result = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 505 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2129 "CustomPrintTab.c"
}

static gboolean
custom_print_tab_is_print_titles_enabled (CustomPrintTab* self)
{
	GtkCheckButton* _tmp0_;
	gboolean result;
#line 508 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 509 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->title_print_check;
#line 509 "../src/Widgets/CustomPrintTab.vala"
	result = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 509 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2145 "CustomPrintTab.c"
}

static gchar*
custom_print_tab_get_print_titles_font (CustomPrintTab* self)
{
	GtkFontButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 512 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 513 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->title_print_font;
#line 513 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = gtk_font_chooser_get_font ((GtkFontChooser*) _tmp0_);
#line 513 "../src/Widgets/CustomPrintTab.vala"
	_tmp2_ = _tmp1_;
#line 513 "../src/Widgets/CustomPrintTab.vala"
	result = _tmp2_;
#line 513 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2167 "CustomPrintTab.c"
}

PrintSettings*
custom_print_tab_get_local_settings (CustomPrintTab* self)
{
	PrintSettings* _result_ = NULL;
	PrintSettings* _tmp0_;
	Measurement _tmp1_ = {0};
	Measurement _tmp2_ = {0};
	GtkSpinButton* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	PrintSettings* result;
#line 516 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 517 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = print_settings_new ();
#line 517 "../src/Widgets/CustomPrintTab.vala"
	_result_ = _tmp0_;
#line 519 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_get_content_width (self, &_tmp1_);
#line 519 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_content_width (_result_, &_tmp1_);
#line 520 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_get_content_height (self, &_tmp2_);
#line 520 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_content_height (_result_, &_tmp2_);
#line 521 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_content_layout (_result_, custom_print_tab_get_content_layout (self));
#line 522 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = self->priv->ppi_entry;
#line 522 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = gtk_spin_button_get_value (_tmp3_);
#line 522 "../src/Widgets/CustomPrintTab.vala"
	_tmp5_ = _tmp4_;
#line 522 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_content_ppi (_result_, (gint) _tmp5_);
#line 523 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_image_per_page_selection (_result_, custom_print_tab_get_image_per_page_selection (self));
#line 524 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_size_selection (_result_, custom_print_tab_get_size_selection (self));
#line 525 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_match_aspect_ratio_enabled (_result_, custom_print_tab_is_match_aspect_ratio_enabled (self));
#line 526 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_print_titles_enabled (_result_, custom_print_tab_is_print_titles_enabled (self));
#line 527 "../src/Widgets/CustomPrintTab.vala"
	_tmp6_ = custom_print_tab_get_print_titles_font (self);
#line 527 "../src/Widgets/CustomPrintTab.vala"
	_tmp7_ = _tmp6_;
#line 527 "../src/Widgets/CustomPrintTab.vala"
	print_settings_set_print_titles_font (_result_, _tmp7_);
#line 527 "../src/Widgets/CustomPrintTab.vala"
	_g_free0 (_tmp7_);
#line 529 "../src/Widgets/CustomPrintTab.vala"
	result = _result_;
#line 529 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2227 "CustomPrintTab.c"
}

PrintJob*
custom_print_tab_get_source_job (CustomPrintTab* self)
{
	PrintJob* result;
	PrintJob* _tmp0_;
#line 41 "../src/Widgets/CustomPrintTab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = self->priv->_source_job;
#line 41 "../src/Widgets/CustomPrintTab.vala"
	result = _tmp0_;
#line 41 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2243 "CustomPrintTab.c"
}

static void
custom_print_tab_set_source_job (CustomPrintTab* self,
                                 PrintJob* value)
{
	PrintJob* old_value;
#line 41 "../src/Widgets/CustomPrintTab.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Widgets/CustomPrintTab.vala"
	old_value = custom_print_tab_get_source_job (self);
#line 41 "../src/Widgets/CustomPrintTab.vala"
	if (old_value != value) {
#line 2257 "CustomPrintTab.c"
		PrintJob* _tmp0_;
#line 41 "../src/Widgets/CustomPrintTab.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/Widgets/CustomPrintTab.vala"
		_g_object_unref0 (self->priv->_source_job);
#line 41 "../src/Widgets/CustomPrintTab.vala"
		self->priv->_source_job = _tmp0_;
#line 41 "../src/Widgets/CustomPrintTab.vala"
		g_object_notify_by_pspec ((GObject *) self, custom_print_tab_properties[CUSTOM_PRINT_TAB_SOURCE_JOB_PROPERTY]);
#line 2267 "CustomPrintTab.c"
	}
}

static gpointer
_standard_print_size_ref0 (gpointer self)
{
#line 77 "../src/Widgets/CustomPrintTab.vala"
	return self ? standard_print_size_ref (self) : NULL;
#line 2276 "CustomPrintTab.c"
}

static gboolean
_custom_print_tab_standard_sizes_combo_separator_func_gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                                                        GtkTreeIter* iter,
                                                                                        gpointer self)
{
	gboolean result;
	result = custom_print_tab_standard_sizes_combo_separator_func (model, iter);
#line 88 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2288 "CustomPrintTab.c"
}

static void
_custom_print_tab_on_radio_group_click_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 156 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_on_radio_group_click ((CustomPrintTab*) self, _sender);
#line 2297 "CustomPrintTab.c"
}

static void
_custom_print_tab_on_entry_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                 const gchar* new_text,
                                                                 gint new_text_length,
                                                                 gint* position,
                                                                 gpointer self)
{
#line 159 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_on_entry_insert_text ((CustomPrintTab*) self, _sender, new_text, new_text_length, position);
#line 2309 "CustomPrintTab.c"
}

static gboolean
_custom_print_tab_on_width_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                       GdkEventFocus* event,
                                                                       gpointer self)
{
	gboolean result;
	result = custom_print_tab_on_width_entry_focus_out ((CustomPrintTab*) self, event);
#line 160 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2321 "CustomPrintTab.c"
}

static gboolean
_custom_print_tab_on_height_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                        GdkEventFocus* event,
                                                                        gpointer self)
{
	gboolean result;
	result = custom_print_tab_on_height_entry_focus_out ((CustomPrintTab*) self, event);
#line 162 "../src/Widgets/CustomPrintTab.vala"
	return result;
#line 2333 "CustomPrintTab.c"
}

static void
_custom_print_tab_on_units_combo_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
#line 163 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_on_units_combo_changed ((CustomPrintTab*) self);
#line 2342 "CustomPrintTab.c"
}

static void
_custom_print_tab_on_ppi_entry_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                     const gchar* new_text,
                                                                     gint new_text_length,
                                                                     gint* position,
                                                                     gpointer self)
{
#line 164 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_on_ppi_entry_insert_text ((CustomPrintTab*) self, _sender, new_text, new_text_length, position);
#line 2354 "CustomPrintTab.c"
}

static void
_custom_print_tab_on_aspect_ratio_check_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self)
{
#line 171 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_on_aspect_ratio_check_clicked ((CustomPrintTab*) self);
#line 2363 "CustomPrintTab.c"
}

static GObject *
custom_print_tab_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CustomPrintTab * self;
	GtkLabel* printed_size_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkRadioButton* _tmp4_;
	GtkRadioButton* _tmp5_;
	GtkRadioButton* _tmp6_;
	GtkRadioButton* _tmp7_;
	GtkRadioButton* _tmp8_;
	GtkRadioButton* _tmp9_;
	GtkRadioButton* _tmp10_;
	GtkRadioButton* _tmp11_;
	GtkListStore* image_per_page_combo_store = NULL;
	GtkListStore* _tmp12_;
	gint _tmp13_ = 0;
	PrintLayout* _tmp14_;
	GtkCellRendererText* image_per_page_combo_text_renderer = NULL;
	GtkCellRendererText* _tmp21_;
	GtkListStore* _tmp22_;
	GtkComboBox* _tmp23_;
	GtkComboBox* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkComboBox* _tmp26_;
	GtkCellRendererText* _tmp27_;
	StandardPrintSize** standard_sizes = NULL;
	PrintManager* _tmp28_;
	PrintManager* _tmp29_;
	gint _tmp30_ = 0;
	StandardPrintSize** _tmp31_;
	StandardPrintSize** _tmp32_;
	gint _tmp32__length1;
	gint standard_sizes_length1;
	gint _standard_sizes_size_;
	GtkListStore* standard_sizes_combo_store = NULL;
	GtkListStore* _tmp33_;
	StandardPrintSize** _tmp34_;
	gint _tmp34__length1;
	GtkCellRendererText* standard_sizes_combo_text_renderer = NULL;
	GtkCellRendererText* _tmp43_;
	GtkListStore* _tmp44_;
	GtkComboBox* _tmp45_;
	GtkComboBox* _tmp46_;
	GtkCellRendererText* _tmp47_;
	GtkComboBox* _tmp48_;
	GtkCellRendererText* _tmp49_;
	GtkComboBox* _tmp50_;
	GtkEntry* _tmp51_;
	GtkLabel* mult_label = NULL;
	GtkLabel* _tmp52_;
	GtkEntry* _tmp53_;
	GtkComboBoxText* _tmp54_;
	GtkComboBoxText* _tmp55_;
	GtkComboBoxText* _tmp56_;
	GtkComboBoxText* _tmp57_;
	GtkGrid* custom_grid = NULL;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	GtkEntry* _tmp61_;
	GtkGrid* _tmp62_;
	GtkLabel* _tmp63_;
	GtkGrid* _tmp64_;
	GtkEntry* _tmp65_;
	GtkGrid* _tmp66_;
	GtkComboBoxText* _tmp67_;
	GtkCheckButton* _tmp68_;
	GtkLabel* titles_label = NULL;
	GtkLabel* _tmp69_;
	GtkLabel* _tmp70_;
	GtkLabel* _tmp71_;
	GtkStyleContext* _tmp72_;
	GtkCheckButton* _tmp73_;
	GtkCheckButton* _tmp74_;
	GtkFontButton* _tmp75_;
	GtkFontButton* _tmp76_;
	GtkLabel* resolution_label = NULL;
	GtkLabel* _tmp77_;
	GtkLabel* _tmp78_;
	GtkLabel* _tmp79_;
	GtkStyleContext* _tmp80_;
	GtkSpinButton* _tmp81_;
	GtkSpinButton* _tmp82_;
	GtkLabel* ppi_label = NULL;
	GtkLabel* _tmp83_;
	GtkLabel* _tmp84_;
	GtkLabel* _tmp85_;
	GtkSpinButton* _tmp86_;
	GtkLabel* _tmp87_;
	GtkLabel* _tmp88_;
	GtkLabel* unit_label = NULL;
	GtkLabel* _tmp89_;
	GtkLabel* _tmp90_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp91_;
	GtkGrid* _tmp92_;
	GtkGrid* _tmp93_;
	GtkGrid* _tmp94_;
	GtkGrid* _tmp95_;
	GtkLabel* _tmp96_;
	GtkGrid* _tmp97_;
	GtkRadioButton* _tmp98_;
	GtkGrid* _tmp99_;
	GtkComboBox* _tmp100_;
	GtkGrid* _tmp101_;
	GtkRadioButton* _tmp102_;
	GtkGrid* _tmp103_;
	GtkGrid* _tmp104_;
	GtkGrid* _tmp105_;
	GtkCheckButton* _tmp106_;
	GtkGrid* _tmp107_;
	GtkRadioButton* _tmp108_;
	GtkGrid* _tmp109_;
	GtkComboBox* _tmp110_;
	GtkGrid* _tmp111_;
	GtkLabel* _tmp112_;
	GtkGrid* _tmp113_;
	GtkCheckButton* _tmp114_;
	GtkGrid* _tmp115_;
	GtkFontButton* _tmp116_;
	GtkGrid* _tmp117_;
	GtkLabel* _tmp118_;
	GtkGrid* _tmp119_;
	GtkLabel* _tmp120_;
	GtkGrid* _tmp121_;
	GtkSpinButton* _tmp122_;
	GtkGrid* _tmp123_;
	GtkLabel* _tmp124_;
	GtkGrid* _tmp125_;
	GtkRadioButton* _tmp126_;
	GtkRadioButton* _tmp127_;
	GtkRadioButton* _tmp128_;
	GtkEntry* _tmp129_;
	GtkEntry* _tmp130_;
	GtkEntry* _tmp131_;
	GtkEntry* _tmp132_;
	GtkComboBoxText* _tmp133_;
	GtkSpinButton* _tmp134_;
	PrintJob* _tmp135_;
	GtkCheckButton* _tmp136_;
#line 47 "../src/Widgets/CustomPrintTab.vala"
	parent_class = G_OBJECT_CLASS (custom_print_tab_parent_class);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CUSTOM_PRINT_TAB, CustomPrintTab);
#line 48 "../src/Widgets/CustomPrintTab.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Printed Image Size"));
#line 48 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp0_);
#line 48 "../src/Widgets/CustomPrintTab.vala"
	printed_size_label = _tmp0_;
#line 49 "../src/Widgets/CustomPrintTab.vala"
	_tmp1_ = printed_size_label;
#line 49 "../src/Widgets/CustomPrintTab.vala"
	gtk_label_set_xalign (_tmp1_, (gfloat) 0);
#line 50 "../src/Widgets/CustomPrintTab.vala"
	_tmp2_ = printed_size_label;
#line 50 "../src/Widgets/CustomPrintTab.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 50 "../src/Widgets/CustomPrintTab.vala"
	gtk_style_context_add_class (_tmp3_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 52 "../src/Widgets/CustomPrintTab.vala"
	_tmp4_ = (GtkRadioButton*) gtk_radio_button_new_with_mnemonic (NULL, _ ("Use a _standard size:"));
#line 52 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp4_);
#line 52 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->standard_size_radio);
#line 52 "../src/Widgets/CustomPrintTab.vala"
	self->priv->standard_size_radio = _tmp4_;
#line 53 "../src/Widgets/CustomPrintTab.vala"
	_tmp5_ = self->priv->standard_size_radio;
#line 53 "../src/Widgets/CustomPrintTab.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp5_, 12);
#line 55 "../src/Widgets/CustomPrintTab.vala"
	_tmp6_ = self->priv->standard_size_radio;
#line 55 "../src/Widgets/CustomPrintTab.vala"
	_tmp7_ = (GtkRadioButton*) gtk_radio_button_new_with_mnemonic_from_widget (_tmp6_, _ ("Use a c_ustom size:"));
#line 55 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp7_);
#line 55 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->custom_size_radio);
#line 55 "../src/Widgets/CustomPrintTab.vala"
	self->priv->custom_size_radio = _tmp7_;
#line 56 "../src/Widgets/CustomPrintTab.vala"
	_tmp8_ = self->priv->custom_size_radio;
#line 56 "../src/Widgets/CustomPrintTab.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 12);
#line 58 "../src/Widgets/CustomPrintTab.vala"
	_tmp9_ = self->priv->standard_size_radio;
#line 58 "../src/Widgets/CustomPrintTab.vala"
	_tmp10_ = (GtkRadioButton*) gtk_radio_button_new_with_mnemonic_from_widget (_tmp9_, _ ("_Autosize:"));
#line 58 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp10_);
#line 58 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->image_per_page_radio);
#line 58 "../src/Widgets/CustomPrintTab.vala"
	self->priv->image_per_page_radio = _tmp10_;
#line 59 "../src/Widgets/CustomPrintTab.vala"
	_tmp11_ = self->priv->image_per_page_radio;
#line 59 "../src/Widgets/CustomPrintTab.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp11_, 12);
#line 61 "../src/Widgets/CustomPrintTab.vala"
	_tmp12_ = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_STRING, -1);
#line 61 "../src/Widgets/CustomPrintTab.vala"
	image_per_page_combo_store = _tmp12_;
#line 62 "../src/Widgets/CustomPrintTab.vala"
	_tmp14_ = print_layout_get_all (&_tmp13_);
#line 2582 "CustomPrintTab.c"
	{
		PrintLayout* layout_collection = NULL;
		gint layout_collection_length1 = 0;
		gint _layout_collection_size_ = 0;
		gint layout_it = 0;
#line 62 "../src/Widgets/CustomPrintTab.vala"
		layout_collection = _tmp14_;
#line 62 "../src/Widgets/CustomPrintTab.vala"
		layout_collection_length1 = _tmp13_;
#line 62 "../src/Widgets/CustomPrintTab.vala"
		for (layout_it = 0; layout_it < layout_collection_length1; layout_it = layout_it + 1) {
#line 2594 "CustomPrintTab.c"
			PrintLayout layout = 0;
#line 62 "../src/Widgets/CustomPrintTab.vala"
			layout = layout_collection[layout_it];
#line 2598 "CustomPrintTab.c"
			{
				GtkTreeIter iter = {0};
				GtkListStore* _tmp15_;
				GtkTreeIter _tmp16_ = {0};
				GtkListStore* _tmp17_;
				GtkTreeIter _tmp18_;
				gchar* _tmp19_;
				GValue _tmp20_ = {0};
#line 64 "../src/Widgets/CustomPrintTab.vala"
				_tmp15_ = image_per_page_combo_store;
#line 64 "../src/Widgets/CustomPrintTab.vala"
				gtk_list_store_append (_tmp15_, &_tmp16_);
#line 64 "../src/Widgets/CustomPrintTab.vala"
				iter = _tmp16_;
#line 65 "../src/Widgets/CustomPrintTab.vala"
				_tmp17_ = image_per_page_combo_store;
#line 65 "../src/Widgets/CustomPrintTab.vala"
				_tmp18_ = iter;
#line 65 "../src/Widgets/CustomPrintTab.vala"
				_tmp19_ = print_layout_to_string (layout);
#line 65 "../src/Widgets/CustomPrintTab.vala"
				g_value_init (&_tmp20_, G_TYPE_STRING);
#line 65 "../src/Widgets/CustomPrintTab.vala"
				g_value_take_string (&_tmp20_, _tmp19_);
#line 65 "../src/Widgets/CustomPrintTab.vala"
				gtk_list_store_set_value (_tmp17_, &_tmp18_, 0, &_tmp20_);
#line 65 "../src/Widgets/CustomPrintTab.vala"
				G_IS_VALUE (&_tmp20_) ? (g_value_unset (&_tmp20_), NULL) : NULL;
#line 2627 "CustomPrintTab.c"
			}
		}
#line 62 "../src/Widgets/CustomPrintTab.vala"
		layout_collection = (g_free (layout_collection), NULL);
#line 2632 "CustomPrintTab.c"
	}
#line 68 "../src/Widgets/CustomPrintTab.vala"
	_tmp21_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 68 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp21_);
#line 68 "../src/Widgets/CustomPrintTab.vala"
	image_per_page_combo_text_renderer = _tmp21_;
#line 70 "../src/Widgets/CustomPrintTab.vala"
	_tmp22_ = image_per_page_combo_store;
#line 70 "../src/Widgets/CustomPrintTab.vala"
	_tmp23_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp22_);
#line 70 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp23_);
#line 70 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->image_per_page_combo);
#line 70 "../src/Widgets/CustomPrintTab.vala"
	self->priv->image_per_page_combo = _tmp23_;
#line 71 "../src/Widgets/CustomPrintTab.vala"
	_tmp24_ = self->priv->image_per_page_combo;
#line 71 "../src/Widgets/CustomPrintTab.vala"
	_tmp25_ = image_per_page_combo_text_renderer;
#line 71 "../src/Widgets/CustomPrintTab.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp24_, (GtkCellRenderer*) _tmp25_, TRUE);
#line 72 "../src/Widgets/CustomPrintTab.vala"
	_tmp26_ = self->priv->image_per_page_combo;
#line 72 "../src/Widgets/CustomPrintTab.vala"
	_tmp27_ = image_per_page_combo_text_renderer;
#line 72 "../src/Widgets/CustomPrintTab.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp26_, (GtkCellRenderer*) _tmp27_, "text", 0);
#line 74 "../src/Widgets/CustomPrintTab.vala"
	_tmp28_ = print_manager_get_instance ();
#line 74 "../src/Widgets/CustomPrintTab.vala"
	_tmp29_ = _tmp28_;
#line 74 "../src/Widgets/CustomPrintTab.vala"
	_tmp31_ = print_manager_get_standard_sizes (_tmp29_, &_tmp30_);
#line 74 "../src/Widgets/CustomPrintTab.vala"
	_tmp32_ = _tmp31_;
#line 74 "../src/Widgets/CustomPrintTab.vala"
	_tmp32__length1 = _tmp30_;
#line 74 "../src/Widgets/CustomPrintTab.vala"
	_print_manager_unref0 (_tmp29_);
#line 74 "../src/Widgets/CustomPrintTab.vala"
	standard_sizes = _tmp32_;
#line 74 "../src/Widgets/CustomPrintTab.vala"
	standard_sizes_length1 = _tmp32__length1;
#line 74 "../src/Widgets/CustomPrintTab.vala"
	_standard_sizes_size_ = standard_sizes_length1;
#line 76 "../src/Widgets/CustomPrintTab.vala"
	_tmp33_ = gtk_list_store_new (1, G_TYPE_STRING, G_TYPE_STRING, -1);
#line 76 "../src/Widgets/CustomPrintTab.vala"
	standard_sizes_combo_store = _tmp33_;
#line 77 "../src/Widgets/CustomPrintTab.vala"
	_tmp34_ = standard_sizes;
#line 77 "../src/Widgets/CustomPrintTab.vala"
	_tmp34__length1 = standard_sizes_length1;
#line 2688 "CustomPrintTab.c"
	{
		StandardPrintSize** size_collection = NULL;
		gint size_collection_length1 = 0;
		gint _size_collection_size_ = 0;
		gint size_it = 0;
#line 77 "../src/Widgets/CustomPrintTab.vala"
		size_collection = _tmp34_;
#line 77 "../src/Widgets/CustomPrintTab.vala"
		size_collection_length1 = _tmp34__length1;
#line 77 "../src/Widgets/CustomPrintTab.vala"
		for (size_it = 0; size_it < size_collection_length1; size_it = size_it + 1) {
#line 2700 "CustomPrintTab.c"
			StandardPrintSize* _tmp35_;
			StandardPrintSize* size = NULL;
#line 77 "../src/Widgets/CustomPrintTab.vala"
			_tmp35_ = _standard_print_size_ref0 (size_collection[size_it]);
#line 77 "../src/Widgets/CustomPrintTab.vala"
			size = _tmp35_;
#line 2707 "CustomPrintTab.c"
			{
				GtkTreeIter iter = {0};
				GtkListStore* _tmp36_;
				GtkTreeIter _tmp37_ = {0};
				GtkListStore* _tmp38_;
				GtkTreeIter _tmp39_;
				StandardPrintSize* _tmp40_;
				const gchar* _tmp41_;
				GValue _tmp42_ = {0};
#line 79 "../src/Widgets/CustomPrintTab.vala"
				_tmp36_ = standard_sizes_combo_store;
#line 79 "../src/Widgets/CustomPrintTab.vala"
				gtk_list_store_append (_tmp36_, &_tmp37_);
#line 79 "../src/Widgets/CustomPrintTab.vala"
				iter = _tmp37_;
#line 80 "../src/Widgets/CustomPrintTab.vala"
				_tmp38_ = standard_sizes_combo_store;
#line 80 "../src/Widgets/CustomPrintTab.vala"
				_tmp39_ = iter;
#line 80 "../src/Widgets/CustomPrintTab.vala"
				_tmp40_ = size;
#line 80 "../src/Widgets/CustomPrintTab.vala"
				_tmp41_ = _tmp40_->name;
#line 80 "../src/Widgets/CustomPrintTab.vala"
				g_value_init (&_tmp42_, G_TYPE_STRING);
#line 80 "../src/Widgets/CustomPrintTab.vala"
				g_value_set_string (&_tmp42_, _tmp41_);
#line 80 "../src/Widgets/CustomPrintTab.vala"
				gtk_list_store_set_value (_tmp38_, &_tmp39_, 0, &_tmp42_);
#line 80 "../src/Widgets/CustomPrintTab.vala"
				G_IS_VALUE (&_tmp42_) ? (g_value_unset (&_tmp42_), NULL) : NULL;
#line 77 "../src/Widgets/CustomPrintTab.vala"
				_standard_print_size_unref0 (size);
#line 2741 "CustomPrintTab.c"
			}
		}
	}
#line 83 "../src/Widgets/CustomPrintTab.vala"
	_tmp43_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 83 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp43_);
#line 83 "../src/Widgets/CustomPrintTab.vala"
	standard_sizes_combo_text_renderer = _tmp43_;
#line 85 "../src/Widgets/CustomPrintTab.vala"
	_tmp44_ = standard_sizes_combo_store;
#line 85 "../src/Widgets/CustomPrintTab.vala"
	_tmp45_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp44_);
#line 85 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp45_);
#line 85 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->standard_sizes_combo);
#line 85 "../src/Widgets/CustomPrintTab.vala"
	self->priv->standard_sizes_combo = _tmp45_;
#line 86 "../src/Widgets/CustomPrintTab.vala"
	_tmp46_ = self->priv->standard_sizes_combo;
#line 86 "../src/Widgets/CustomPrintTab.vala"
	_tmp47_ = standard_sizes_combo_text_renderer;
#line 86 "../src/Widgets/CustomPrintTab.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp46_, (GtkCellRenderer*) _tmp47_, TRUE);
#line 87 "../src/Widgets/CustomPrintTab.vala"
	_tmp48_ = self->priv->standard_sizes_combo;
#line 87 "../src/Widgets/CustomPrintTab.vala"
	_tmp49_ = standard_sizes_combo_text_renderer;
#line 87 "../src/Widgets/CustomPrintTab.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp48_, (GtkCellRenderer*) _tmp49_, "text", 0);
#line 88 "../src/Widgets/CustomPrintTab.vala"
	_tmp50_ = self->priv->standard_sizes_combo;
#line 88 "../src/Widgets/CustomPrintTab.vala"
	gtk_combo_box_set_row_separator_func (_tmp50_, _custom_print_tab_standard_sizes_combo_separator_func_gtk_tree_view_row_separator_func, NULL, NULL);
#line 90 "../src/Widgets/CustomPrintTab.vala"
	_tmp51_ = (GtkEntry*) gtk_entry_new ();
#line 90 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp51_);
#line 90 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->custom_width_entry);
#line 90 "../src/Widgets/CustomPrintTab.vala"
	self->priv->custom_width_entry = _tmp51_;
#line 91 "../src/Widgets/CustomPrintTab.vala"
	_tmp52_ = (GtkLabel*) gtk_label_new ("×");
#line 91 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp52_);
#line 91 "../src/Widgets/CustomPrintTab.vala"
	mult_label = _tmp52_;
#line 92 "../src/Widgets/CustomPrintTab.vala"
	_tmp53_ = (GtkEntry*) gtk_entry_new ();
#line 92 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp53_);
#line 92 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->custom_height_entry);
#line 92 "../src/Widgets/CustomPrintTab.vala"
	self->priv->custom_height_entry = _tmp53_;
#line 94 "../src/Widgets/CustomPrintTab.vala"
	_tmp54_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 94 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp54_);
#line 94 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->units_combo);
#line 94 "../src/Widgets/CustomPrintTab.vala"
	self->priv->units_combo = _tmp54_;
#line 95 "../src/Widgets/CustomPrintTab.vala"
	_tmp55_ = self->priv->units_combo;
#line 95 "../src/Widgets/CustomPrintTab.vala"
	gtk_combo_box_text_append_text (_tmp55_, _ ("in."));
#line 96 "../src/Widgets/CustomPrintTab.vala"
	_tmp56_ = self->priv->units_combo;
#line 96 "../src/Widgets/CustomPrintTab.vala"
	gtk_combo_box_text_append_text (_tmp56_, _ ("cm"));
#line 97 "../src/Widgets/CustomPrintTab.vala"
	_tmp57_ = self->priv->units_combo;
#line 97 "../src/Widgets/CustomPrintTab.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _tmp57_, 0);
#line 99 "../src/Widgets/CustomPrintTab.vala"
	_tmp58_ = (GtkGrid*) gtk_grid_new ();
#line 99 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp58_);
#line 99 "../src/Widgets/CustomPrintTab.vala"
	custom_grid = _tmp58_;
#line 100 "../src/Widgets/CustomPrintTab.vala"
	_tmp59_ = custom_grid;
#line 100 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_set_column_spacing (_tmp59_, 3);
#line 101 "../src/Widgets/CustomPrintTab.vala"
	_tmp60_ = custom_grid;
#line 101 "../src/Widgets/CustomPrintTab.vala"
	_tmp61_ = self->priv->custom_width_entry;
#line 101 "../src/Widgets/CustomPrintTab.vala"
	gtk_container_add ((GtkContainer*) _tmp60_, (GtkWidget*) _tmp61_);
#line 102 "../src/Widgets/CustomPrintTab.vala"
	_tmp62_ = custom_grid;
#line 102 "../src/Widgets/CustomPrintTab.vala"
	_tmp63_ = mult_label;
#line 102 "../src/Widgets/CustomPrintTab.vala"
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
#line 103 "../src/Widgets/CustomPrintTab.vala"
	_tmp64_ = custom_grid;
#line 103 "../src/Widgets/CustomPrintTab.vala"
	_tmp65_ = self->priv->custom_height_entry;
#line 103 "../src/Widgets/CustomPrintTab.vala"
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp65_);
#line 104 "../src/Widgets/CustomPrintTab.vala"
	_tmp66_ = custom_grid;
#line 104 "../src/Widgets/CustomPrintTab.vala"
	_tmp67_ = self->priv->units_combo;
#line 104 "../src/Widgets/CustomPrintTab.vala"
	gtk_container_add ((GtkContainer*) _tmp66_, (GtkWidget*) _tmp67_);
#line 106 "../src/Widgets/CustomPrintTab.vala"
	_tmp68_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_ ("_Match photo aspect ratio"));
#line 106 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp68_);
#line 106 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->aspect_ratio_check);
#line 106 "../src/Widgets/CustomPrintTab.vala"
	self->priv->aspect_ratio_check = _tmp68_;
#line 108 "../src/Widgets/CustomPrintTab.vala"
	_tmp69_ = (GtkLabel*) gtk_label_new (_ ("Titles"));
#line 108 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp69_);
#line 108 "../src/Widgets/CustomPrintTab.vala"
	titles_label = _tmp69_;
#line 109 "../src/Widgets/CustomPrintTab.vala"
	_tmp70_ = titles_label;
#line 109 "../src/Widgets/CustomPrintTab.vala"
	gtk_label_set_xalign (_tmp70_, (gfloat) 0);
#line 110 "../src/Widgets/CustomPrintTab.vala"
	_tmp71_ = titles_label;
#line 110 "../src/Widgets/CustomPrintTab.vala"
	_tmp72_ = gtk_widget_get_style_context ((GtkWidget*) _tmp71_);
#line 110 "../src/Widgets/CustomPrintTab.vala"
	gtk_style_context_add_class (_tmp72_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 112 "../src/Widgets/CustomPrintTab.vala"
	_tmp73_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_ ("Print image _title"));
#line 112 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp73_);
#line 112 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->title_print_check);
#line 112 "../src/Widgets/CustomPrintTab.vala"
	self->priv->title_print_check = _tmp73_;
#line 113 "../src/Widgets/CustomPrintTab.vala"
	_tmp74_ = self->priv->title_print_check;
#line 113 "../src/Widgets/CustomPrintTab.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp74_, 12);
#line 115 "../src/Widgets/CustomPrintTab.vala"
	_tmp75_ = (GtkFontButton*) gtk_font_button_new ();
#line 115 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp75_);
#line 115 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->title_print_font);
#line 115 "../src/Widgets/CustomPrintTab.vala"
	self->priv->title_print_font = _tmp75_;
#line 116 "../src/Widgets/CustomPrintTab.vala"
	_tmp76_ = self->priv->title_print_font;
#line 116 "../src/Widgets/CustomPrintTab.vala"
	gtk_font_button_set_use_font (_tmp76_, TRUE);
#line 118 "../src/Widgets/CustomPrintTab.vala"
	_tmp77_ = (GtkLabel*) gtk_label_new (_ ("Pixel Resolution"));
#line 118 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp77_);
#line 118 "../src/Widgets/CustomPrintTab.vala"
	resolution_label = _tmp77_;
#line 119 "../src/Widgets/CustomPrintTab.vala"
	_tmp78_ = resolution_label;
#line 119 "../src/Widgets/CustomPrintTab.vala"
	gtk_label_set_xalign (_tmp78_, (gfloat) 0);
#line 120 "../src/Widgets/CustomPrintTab.vala"
	_tmp79_ = resolution_label;
#line 120 "../src/Widgets/CustomPrintTab.vala"
	_tmp80_ = gtk_widget_get_style_context ((GtkWidget*) _tmp79_);
#line 120 "../src/Widgets/CustomPrintTab.vala"
	gtk_style_context_add_class (_tmp80_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 122 "../src/Widgets/CustomPrintTab.vala"
	_tmp81_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) PRINT_SETTINGS_MIN_CONTENT_PPI, (gdouble) PRINT_SETTINGS_MAX_CONTENT_PPI, (gdouble) 100);
#line 122 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp81_);
#line 122 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->ppi_entry);
#line 122 "../src/Widgets/CustomPrintTab.vala"
	self->priv->ppi_entry = _tmp81_;
#line 123 "../src/Widgets/CustomPrintTab.vala"
	_tmp82_ = self->priv->ppi_entry;
#line 123 "../src/Widgets/CustomPrintTab.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp82_, TRUE);
#line 125 "../src/Widgets/CustomPrintTab.vala"
	_tmp83_ = (GtkLabel*) gtk_label_new (_ ("_Output photo at:"));
#line 125 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp83_);
#line 125 "../src/Widgets/CustomPrintTab.vala"
	ppi_label = _tmp83_;
#line 126 "../src/Widgets/CustomPrintTab.vala"
	_tmp84_ = ppi_label;
#line 126 "../src/Widgets/CustomPrintTab.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp84_, 12);
#line 127 "../src/Widgets/CustomPrintTab.vala"
	_tmp85_ = ppi_label;
#line 127 "../src/Widgets/CustomPrintTab.vala"
	_tmp86_ = self->priv->ppi_entry;
#line 127 "../src/Widgets/CustomPrintTab.vala"
	gtk_label_set_mnemonic_widget (_tmp85_, (GtkWidget*) _tmp86_);
#line 128 "../src/Widgets/CustomPrintTab.vala"
	_tmp87_ = ppi_label;
#line 128 "../src/Widgets/CustomPrintTab.vala"
	gtk_label_set_use_underline (_tmp87_, TRUE);
#line 129 "../src/Widgets/CustomPrintTab.vala"
	_tmp88_ = ppi_label;
#line 129 "../src/Widgets/CustomPrintTab.vala"
	gtk_label_set_xalign (_tmp88_, (gfloat) 1);
#line 131 "../src/Widgets/CustomPrintTab.vala"
	_tmp89_ = (GtkLabel*) gtk_label_new (_ ("pixels per inch"));
#line 131 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp89_);
#line 131 "../src/Widgets/CustomPrintTab.vala"
	unit_label = _tmp89_;
#line 132 "../src/Widgets/CustomPrintTab.vala"
	_tmp90_ = unit_label;
#line 132 "../src/Widgets/CustomPrintTab.vala"
	gtk_label_set_xalign (_tmp90_, (gfloat) 0);
#line 134 "../src/Widgets/CustomPrintTab.vala"
	_tmp91_ = (GtkGrid*) gtk_grid_new ();
#line 134 "../src/Widgets/CustomPrintTab.vala"
	g_object_ref_sink (_tmp91_);
#line 134 "../src/Widgets/CustomPrintTab.vala"
	grid = _tmp91_;
#line 135 "../src/Widgets/CustomPrintTab.vala"
	_tmp92_ = grid;
#line 135 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_set_column_spacing (_tmp92_, 12);
#line 136 "../src/Widgets/CustomPrintTab.vala"
	_tmp93_ = grid;
#line 136 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_set_row_spacing (_tmp93_, 12);
#line 137 "../src/Widgets/CustomPrintTab.vala"
	_tmp94_ = grid;
#line 137 "../src/Widgets/CustomPrintTab.vala"
	g_object_set ((GtkWidget*) _tmp94_, "margin", 12, NULL);
#line 138 "../src/Widgets/CustomPrintTab.vala"
	_tmp95_ = grid;
#line 138 "../src/Widgets/CustomPrintTab.vala"
	_tmp96_ = printed_size_label;
#line 138 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp95_, (GtkWidget*) _tmp96_, 0, 0, 3, 1);
#line 139 "../src/Widgets/CustomPrintTab.vala"
	_tmp97_ = grid;
#line 139 "../src/Widgets/CustomPrintTab.vala"
	_tmp98_ = self->priv->standard_size_radio;
#line 139 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp97_, (GtkWidget*) _tmp98_, 0, 1, 1, 1);
#line 140 "../src/Widgets/CustomPrintTab.vala"
	_tmp99_ = grid;
#line 140 "../src/Widgets/CustomPrintTab.vala"
	_tmp100_ = self->priv->standard_sizes_combo;
#line 140 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp99_, (GtkWidget*) _tmp100_, 1, 1, 2, 1);
#line 141 "../src/Widgets/CustomPrintTab.vala"
	_tmp101_ = grid;
#line 141 "../src/Widgets/CustomPrintTab.vala"
	_tmp102_ = self->priv->custom_size_radio;
#line 141 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp101_, (GtkWidget*) _tmp102_, 0, 2, 1, 1);
#line 142 "../src/Widgets/CustomPrintTab.vala"
	_tmp103_ = grid;
#line 142 "../src/Widgets/CustomPrintTab.vala"
	_tmp104_ = custom_grid;
#line 142 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp103_, (GtkWidget*) _tmp104_, 1, 2, 2, 1);
#line 143 "../src/Widgets/CustomPrintTab.vala"
	_tmp105_ = grid;
#line 143 "../src/Widgets/CustomPrintTab.vala"
	_tmp106_ = self->priv->aspect_ratio_check;
#line 143 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp105_, (GtkWidget*) _tmp106_, 1, 3, 2, 1);
#line 144 "../src/Widgets/CustomPrintTab.vala"
	_tmp107_ = grid;
#line 144 "../src/Widgets/CustomPrintTab.vala"
	_tmp108_ = self->priv->image_per_page_radio;
#line 144 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp107_, (GtkWidget*) _tmp108_, 0, 4, 1, 1);
#line 145 "../src/Widgets/CustomPrintTab.vala"
	_tmp109_ = grid;
#line 145 "../src/Widgets/CustomPrintTab.vala"
	_tmp110_ = self->priv->image_per_page_combo;
#line 145 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp109_, (GtkWidget*) _tmp110_, 1, 4, 2, 1);
#line 146 "../src/Widgets/CustomPrintTab.vala"
	_tmp111_ = grid;
#line 146 "../src/Widgets/CustomPrintTab.vala"
	_tmp112_ = titles_label;
#line 146 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp111_, (GtkWidget*) _tmp112_, 0, 5, 3, 1);
#line 147 "../src/Widgets/CustomPrintTab.vala"
	_tmp113_ = grid;
#line 147 "../src/Widgets/CustomPrintTab.vala"
	_tmp114_ = self->priv->title_print_check;
#line 147 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp113_, (GtkWidget*) _tmp114_, 0, 6, 1, 1);
#line 148 "../src/Widgets/CustomPrintTab.vala"
	_tmp115_ = grid;
#line 148 "../src/Widgets/CustomPrintTab.vala"
	_tmp116_ = self->priv->title_print_font;
#line 148 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp115_, (GtkWidget*) _tmp116_, 1, 6, 2, 1);
#line 149 "../src/Widgets/CustomPrintTab.vala"
	_tmp117_ = grid;
#line 149 "../src/Widgets/CustomPrintTab.vala"
	_tmp118_ = resolution_label;
#line 149 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp117_, (GtkWidget*) _tmp118_, 0, 7, 3, 1);
#line 150 "../src/Widgets/CustomPrintTab.vala"
	_tmp119_ = grid;
#line 150 "../src/Widgets/CustomPrintTab.vala"
	_tmp120_ = ppi_label;
#line 150 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp119_, (GtkWidget*) _tmp120_, 0, 8, 1, 1);
#line 151 "../src/Widgets/CustomPrintTab.vala"
	_tmp121_ = grid;
#line 151 "../src/Widgets/CustomPrintTab.vala"
	_tmp122_ = self->priv->ppi_entry;
#line 151 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp121_, (GtkWidget*) _tmp122_, 1, 8, 1, 1);
#line 152 "../src/Widgets/CustomPrintTab.vala"
	_tmp123_ = grid;
#line 152 "../src/Widgets/CustomPrintTab.vala"
	_tmp124_ = unit_label;
#line 152 "../src/Widgets/CustomPrintTab.vala"
	gtk_grid_attach (_tmp123_, (GtkWidget*) _tmp124_, 2, 8, 1, 1);
#line 154 "../src/Widgets/CustomPrintTab.vala"
	_tmp125_ = grid;
#line 154 "../src/Widgets/CustomPrintTab.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp125_);
#line 156 "../src/Widgets/CustomPrintTab.vala"
	_tmp126_ = self->priv->standard_size_radio;
#line 156 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkButton*) _tmp126_, "clicked", (GCallback) _custom_print_tab_on_radio_group_click_gtk_button_clicked, self, 0);
#line 157 "../src/Widgets/CustomPrintTab.vala"
	_tmp127_ = self->priv->custom_size_radio;
#line 157 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkButton*) _tmp127_, "clicked", (GCallback) _custom_print_tab_on_radio_group_click_gtk_button_clicked, self, 0);
#line 158 "../src/Widgets/CustomPrintTab.vala"
	_tmp128_ = self->priv->image_per_page_radio;
#line 158 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkButton*) _tmp128_, "clicked", (GCallback) _custom_print_tab_on_radio_group_click_gtk_button_clicked, self, 0);
#line 159 "../src/Widgets/CustomPrintTab.vala"
	_tmp129_ = self->priv->custom_width_entry;
#line 159 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkEditable*) _tmp129_, "insert-text", (GCallback) _custom_print_tab_on_entry_insert_text_gtk_editable_insert_text, self, 0);
#line 160 "../src/Widgets/CustomPrintTab.vala"
	_tmp130_ = self->priv->custom_width_entry;
#line 160 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkWidget*) _tmp130_, "focus-out-event", (GCallback) _custom_print_tab_on_width_entry_focus_out_gtk_widget_focus_out_event, self, 0);
#line 161 "../src/Widgets/CustomPrintTab.vala"
	_tmp131_ = self->priv->custom_height_entry;
#line 161 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkEditable*) _tmp131_, "insert-text", (GCallback) _custom_print_tab_on_entry_insert_text_gtk_editable_insert_text, self, 0);
#line 162 "../src/Widgets/CustomPrintTab.vala"
	_tmp132_ = self->priv->custom_height_entry;
#line 162 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkWidget*) _tmp132_, "focus-out-event", (GCallback) _custom_print_tab_on_height_entry_focus_out_gtk_widget_focus_out_event, self, 0);
#line 163 "../src/Widgets/CustomPrintTab.vala"
	_tmp133_ = self->priv->units_combo;
#line 163 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp133_, "changed", (GCallback) _custom_print_tab_on_units_combo_changed_gtk_combo_box_changed, self, 0);
#line 164 "../src/Widgets/CustomPrintTab.vala"
	_tmp134_ = self->priv->ppi_entry;
#line 164 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkEditable*) _tmp134_, "insert-text", (GCallback) _custom_print_tab_on_ppi_entry_insert_text_gtk_editable_insert_text, self, 0);
#line 166 "../src/Widgets/CustomPrintTab.vala"
	_tmp135_ = self->priv->_source_job;
#line 166 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_sync_state_from_job (self, _tmp135_);
#line 168 "../src/Widgets/CustomPrintTab.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 171 "../src/Widgets/CustomPrintTab.vala"
	_tmp136_ = self->priv->aspect_ratio_check;
#line 171 "../src/Widgets/CustomPrintTab.vala"
	g_signal_connect_object ((GtkButton*) _tmp136_, "clicked", (GCallback) _custom_print_tab_on_aspect_ratio_check_clicked_gtk_button_clicked, self, 0);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (grid);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (unit_label);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (ppi_label);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (resolution_label);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (titles_label);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (custom_grid);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (mult_label);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (standard_sizes_combo_text_renderer);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (standard_sizes_combo_store);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	standard_sizes = (_vala_array_free (standard_sizes, standard_sizes_length1, (GDestroyNotify) standard_print_size_unref), NULL);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (image_per_page_combo_text_renderer);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (image_per_page_combo_store);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (printed_size_label);
#line 47 "../src/Widgets/CustomPrintTab.vala"
	return obj;
#line 3149 "CustomPrintTab.c"
}

static void
custom_print_tab_class_init (CustomPrintTabClass * klass,
                             gpointer klass_data)
{
#line 21 "../src/Widgets/CustomPrintTab.vala"
	custom_print_tab_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/CustomPrintTab.vala"
	g_type_class_adjust_private_offset (klass, &CustomPrintTab_private_offset);
#line 21 "../src/Widgets/CustomPrintTab.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_custom_print_tab_get_property;
#line 21 "../src/Widgets/CustomPrintTab.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_custom_print_tab_set_property;
#line 21 "../src/Widgets/CustomPrintTab.vala"
	G_OBJECT_CLASS (klass)->constructor = custom_print_tab_constructor;
#line 21 "../src/Widgets/CustomPrintTab.vala"
	G_OBJECT_CLASS (klass)->finalize = custom_print_tab_finalize;
#line 21 "../src/Widgets/CustomPrintTab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CUSTOM_PRINT_TAB_SOURCE_JOB_PROPERTY, custom_print_tab_properties[CUSTOM_PRINT_TAB_SOURCE_JOB_PROPERTY] = g_param_spec_object ("source-job", "source-job", "source-job", TYPE_PRINT_JOB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3170 "CustomPrintTab.c"
}

static void
custom_print_tab_instance_init (CustomPrintTab * self,
                                gpointer klass)
{
#line 21 "../src/Widgets/CustomPrintTab.vala"
	self->priv = custom_print_tab_get_instance_private (self);
#line 25 "../src/Widgets/CustomPrintTab.vala"
	self->priv->standard_size_radio = NULL;
#line 26 "../src/Widgets/CustomPrintTab.vala"
	self->priv->custom_size_radio = NULL;
#line 27 "../src/Widgets/CustomPrintTab.vala"
	self->priv->image_per_page_radio = NULL;
#line 28 "../src/Widgets/CustomPrintTab.vala"
	self->priv->image_per_page_combo = NULL;
#line 29 "../src/Widgets/CustomPrintTab.vala"
	self->priv->standard_sizes_combo = NULL;
#line 30 "../src/Widgets/CustomPrintTab.vala"
	self->priv->units_combo = NULL;
#line 31 "../src/Widgets/CustomPrintTab.vala"
	self->priv->custom_width_entry = NULL;
#line 32 "../src/Widgets/CustomPrintTab.vala"
	self->priv->custom_height_entry = NULL;
#line 33 "../src/Widgets/CustomPrintTab.vala"
	self->priv->aspect_ratio_check = NULL;
#line 34 "../src/Widgets/CustomPrintTab.vala"
	self->priv->title_print_check = NULL;
#line 35 "../src/Widgets/CustomPrintTab.vala"
	self->priv->title_print_font = NULL;
#line 37 "../src/Widgets/CustomPrintTab.vala"
	measurement_init (&self->priv->local_content_width, 5.0, MEASUREMENT_UNIT_INCHES);
#line 38 "../src/Widgets/CustomPrintTab.vala"
	measurement_init (&self->priv->local_content_height, 5.0, MEASUREMENT_UNIT_INCHES);
#line 39 "../src/Widgets/CustomPrintTab.vala"
	self->priv->is_text_insertion_in_progress = FALSE;
#line 3207 "CustomPrintTab.c"
}

static void
custom_print_tab_finalize (GObject * obj)
{
	CustomPrintTab * self;
#line 21 "../src/Widgets/CustomPrintTab.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CUSTOM_PRINT_TAB, CustomPrintTab);
#line 25 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->standard_size_radio);
#line 26 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->custom_size_radio);
#line 27 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->image_per_page_radio);
#line 28 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->image_per_page_combo);
#line 29 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->standard_sizes_combo);
#line 30 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->units_combo);
#line 31 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->custom_width_entry);
#line 32 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->custom_height_entry);
#line 33 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->aspect_ratio_check);
#line 34 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->title_print_check);
#line 35 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->title_print_font);
#line 36 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->ppi_entry);
#line 41 "../src/Widgets/CustomPrintTab.vala"
	_g_object_unref0 (self->priv->_source_job);
#line 21 "../src/Widgets/CustomPrintTab.vala"
	G_OBJECT_CLASS (custom_print_tab_parent_class)->finalize (obj);
#line 3244 "CustomPrintTab.c"
}

static GType
custom_print_tab_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CustomPrintTabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) custom_print_tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CustomPrintTab), 0, (GInstanceInitFunc) custom_print_tab_instance_init, NULL };
	GType custom_print_tab_type_id;
	custom_print_tab_type_id = g_type_register_static (gtk_fixed_get_type (), "CustomPrintTab", &g_define_type_info, 0);
	CustomPrintTab_private_offset = g_type_add_instance_private (custom_print_tab_type_id, sizeof (CustomPrintTabPrivate));
	return custom_print_tab_type_id;
}

GType
custom_print_tab_get_type (void)
{
	static volatile gsize custom_print_tab_type_id__once = 0;
	if (g_once_init_enter (&custom_print_tab_type_id__once)) {
		GType custom_print_tab_type_id;
		custom_print_tab_type_id = custom_print_tab_get_type_once ();
		g_once_init_leave (&custom_print_tab_type_id__once, custom_print_tab_type_id);
	}
	return custom_print_tab_type_id__once;
}

static void
_vala_custom_print_tab_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	CustomPrintTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CUSTOM_PRINT_TAB, CustomPrintTab);
#line 21 "../src/Widgets/CustomPrintTab.vala"
	switch (property_id) {
#line 21 "../src/Widgets/CustomPrintTab.vala"
		case CUSTOM_PRINT_TAB_SOURCE_JOB_PROPERTY:
#line 21 "../src/Widgets/CustomPrintTab.vala"
		g_value_set_object (value, custom_print_tab_get_source_job (self));
#line 21 "../src/Widgets/CustomPrintTab.vala"
		break;
#line 3285 "CustomPrintTab.c"
		default:
#line 21 "../src/Widgets/CustomPrintTab.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/CustomPrintTab.vala"
		break;
#line 3291 "CustomPrintTab.c"
	}
}

static void
_vala_custom_print_tab_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	CustomPrintTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CUSTOM_PRINT_TAB, CustomPrintTab);
#line 21 "../src/Widgets/CustomPrintTab.vala"
	switch (property_id) {
#line 21 "../src/Widgets/CustomPrintTab.vala"
		case CUSTOM_PRINT_TAB_SOURCE_JOB_PROPERTY:
#line 21 "../src/Widgets/CustomPrintTab.vala"
		custom_print_tab_set_source_job (self, g_value_get_object (value));
#line 21 "../src/Widgets/CustomPrintTab.vala"
		break;
#line 3311 "CustomPrintTab.c"
		default:
#line 21 "../src/Widgets/CustomPrintTab.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/CustomPrintTab.vala"
		break;
#line 3317 "CustomPrintTab.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

