/* SearchRowContainer.c generated by valac 0.56.18, the Vala compiler
 * generated from SearchRowContainer.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2018 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEARCH_ROW_CONTAINER_0_PROPERTY,
	SEARCH_ROW_CONTAINER_NUM_PROPERTIES
};
static GParamSpec* search_row_container_properties[SEARCH_ROW_CONTAINER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SEARCH_ROW_CONTAINER_REMOVE_SIGNAL,
	SEARCH_ROW_CONTAINER_CHANGED_SIGNAL,
	SEARCH_ROW_CONTAINER_NUM_SIGNALS
};
static guint search_row_container_signals[SEARCH_ROW_CONTAINER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SearchRowContainerPrivate {
	GtkComboBoxText* type_combo;
	GtkGrid* grid;
	GtkGrid* align;
	GtkButton* remove_button;
	SearchConditionSearchType* search_types;
	gint search_types_length1;
	gint _search_types_size_;
	GeeHashMap* search_types_index;
	SearchRow* my_row;
};

static gint SearchRowContainer_private_offset;
static gpointer search_row_container_parent_class = NULL;

static void search_row_container_setup_gui (SearchRowContainer* self);
static void search_row_container_set_type (SearchRowContainer* self,
                                    SearchConditionSearchType type);
static void search_row_container_set_type_combo_box (SearchRowContainer* self,
                                              SearchConditionSearchType st);
static void search_row_container_on_type_changed (SearchRowContainer* self);
static void _search_row_container_on_type_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self);
static gboolean search_row_container_on_removed (SearchRowContainer* self,
                                          GdkEventButton* event);
static gboolean _search_row_container_on_removed_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self);
static void search_row_container_finalize (GObject * obj);
static GType search_row_container_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
search_row_container_get_instance_private (SearchRowContainer* self)
{
	return G_STRUCT_MEMBER_P (self, SearchRowContainer_private_offset);
}

SearchRowContainer*
search_row_container_construct (GType object_type)
{
	SearchRowContainer * self = NULL;
#line 34 "../src/Widgets/SearchRowContainer.vala"
	self = (SearchRowContainer*) g_object_new (object_type, NULL);
#line 35 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_setup_gui (self);
#line 36 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_set_type (self, SEARCH_CONDITION_SEARCH_TYPE_ANY_TEXT);
#line 34 "../src/Widgets/SearchRowContainer.vala"
	return self;
#line 113 "SearchRowContainer.c"
}

SearchRowContainer*
search_row_container_new (void)
{
#line 34 "../src/Widgets/SearchRowContainer.vala"
	return search_row_container_construct (TYPE_SEARCH_ROW_CONTAINER);
#line 121 "SearchRowContainer.c"
}

SearchRowContainer*
search_row_container_construct_edit_existing (GType object_type,
                                              SearchCondition* sc)
{
	SearchRowContainer * self = NULL;
	SearchConditionSearchType _tmp0_;
	SearchConditionSearchType _tmp1_;
	SearchConditionSearchType _tmp2_;
	SearchConditionSearchType _tmp3_;
	SearchRow* _tmp4_;
#line 39 "../src/Widgets/SearchRowContainer.vala"
	g_return_val_if_fail (sc != NULL, NULL);
#line 39 "../src/Widgets/SearchRowContainer.vala"
	self = (SearchRowContainer*) g_object_new (object_type, NULL);
#line 40 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_setup_gui (self);
#line 41 "../src/Widgets/SearchRowContainer.vala"
	_tmp0_ = search_condition_get_search_type (sc);
#line 41 "../src/Widgets/SearchRowContainer.vala"
	_tmp1_ = _tmp0_;
#line 41 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_set_type (self, _tmp1_);
#line 42 "../src/Widgets/SearchRowContainer.vala"
	_tmp2_ = search_condition_get_search_type (sc);
#line 42 "../src/Widgets/SearchRowContainer.vala"
	_tmp3_ = _tmp2_;
#line 42 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_set_type_combo_box (self, _tmp3_);
#line 43 "../src/Widgets/SearchRowContainer.vala"
	_tmp4_ = self->priv->my_row;
#line 43 "../src/Widgets/SearchRowContainer.vala"
	search_row_populate (_tmp4_, sc);
#line 39 "../src/Widgets/SearchRowContainer.vala"
	return self;
#line 158 "SearchRowContainer.c"
}

SearchRowContainer*
search_row_container_new_edit_existing (SearchCondition* sc)
{
#line 39 "../src/Widgets/SearchRowContainer.vala"
	return search_row_container_construct_edit_existing (TYPE_SEARCH_ROW_CONTAINER, sc);
#line 166 "SearchRowContainer.c"
}

static void
_search_row_container_on_type_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                             gpointer self)
{
#line 58 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_on_type_changed ((SearchRowContainer*) self);
#line 175 "SearchRowContainer.c"
}

static gboolean
_search_row_container_on_removed_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                GdkEventButton* event,
                                                                gpointer self)
{
	gboolean result;
	result = search_row_container_on_removed ((SearchRowContainer*) self, event);
#line 64 "../src/Widgets/SearchRowContainer.vala"
	return result;
#line 187 "SearchRowContainer.c"
}

static void
search_row_container_setup_gui (SearchRowContainer* self)
{
	gint _tmp0_ = 0;
	SearchConditionSearchType* _tmp1_;
	GeeHashMap* _tmp2_;
	GtkComboBoxText* _tmp3_;
	GtkComboBoxText* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkComboBoxText* _tmp23_;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkGrid* _tmp26_;
	GtkButton* _tmp27_;
	GtkGrid* _tmp28_;
#line 46 "../src/Widgets/SearchRowContainer.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/Widgets/SearchRowContainer.vala"
	_tmp1_ = search_condition_search_type_as_array (&_tmp0_);
#line 47 "../src/Widgets/SearchRowContainer.vala"
	self->priv->search_types = (g_free (self->priv->search_types), NULL);
#line 47 "../src/Widgets/SearchRowContainer.vala"
	self->priv->search_types = _tmp1_;
#line 47 "../src/Widgets/SearchRowContainer.vala"
	self->priv->search_types_length1 = _tmp0_;
#line 47 "../src/Widgets/SearchRowContainer.vala"
	self->priv->_search_types_size_ = self->priv->search_types_length1;
#line 48 "../src/Widgets/SearchRowContainer.vala"
	_tmp2_ = gee_hash_map_new (SEARCH_CONDITION_TYPE_SEARCH_TYPE, NULL, NULL, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->search_types_index);
#line 48 "../src/Widgets/SearchRowContainer.vala"
	self->priv->search_types_index = _tmp2_;
#line 49 "../src/Widgets/SearchRowContainer.vala"
	search_condition_search_type_sort_array (&self->priv->search_types, (gint*) (&self->priv->search_types_length1));
#line 49 "../src/Widgets/SearchRowContainer.vala"
	self->priv->_search_types_size_ = self->priv->search_types_length1;
#line 51 "../src/Widgets/SearchRowContainer.vala"
	_tmp3_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 51 "../src/Widgets/SearchRowContainer.vala"
	g_object_ref_sink (_tmp3_);
#line 51 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->type_combo);
#line 51 "../src/Widgets/SearchRowContainer.vala"
	self->priv->type_combo = _tmp3_;
#line 243 "SearchRowContainer.c"
	{
		gint i = 0;
#line 52 "../src/Widgets/SearchRowContainer.vala"
		i = 0;
#line 248 "SearchRowContainer.c"
		{
			gboolean _tmp4_ = FALSE;
#line 52 "../src/Widgets/SearchRowContainer.vala"
			_tmp4_ = TRUE;
#line 52 "../src/Widgets/SearchRowContainer.vala"
			while (TRUE) {
#line 255 "SearchRowContainer.c"
				SearchConditionSearchType* _tmp6_;
				gint _tmp6__length1;
				SearchConditionSearchType st = 0;
				SearchConditionSearchType* _tmp7_;
				gint _tmp7__length1;
				SearchConditionSearchType _tmp8_;
				GeeHashMap* _tmp9_;
				GtkComboBoxText* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 52 "../src/Widgets/SearchRowContainer.vala"
				if (!_tmp4_) {
#line 268 "SearchRowContainer.c"
					gint _tmp5_;
#line 52 "../src/Widgets/SearchRowContainer.vala"
					_tmp5_ = i;
#line 52 "../src/Widgets/SearchRowContainer.vala"
					i = _tmp5_ + 1;
#line 274 "SearchRowContainer.c"
				}
#line 52 "../src/Widgets/SearchRowContainer.vala"
				_tmp4_ = FALSE;
#line 52 "../src/Widgets/SearchRowContainer.vala"
				_tmp6_ = self->priv->search_types;
#line 52 "../src/Widgets/SearchRowContainer.vala"
				_tmp6__length1 = self->priv->search_types_length1;
#line 52 "../src/Widgets/SearchRowContainer.vala"
				if (!(i < _tmp6__length1)) {
#line 52 "../src/Widgets/SearchRowContainer.vala"
					break;
#line 286 "SearchRowContainer.c"
				}
#line 53 "../src/Widgets/SearchRowContainer.vala"
				_tmp7_ = self->priv->search_types;
#line 53 "../src/Widgets/SearchRowContainer.vala"
				_tmp7__length1 = self->priv->search_types_length1;
#line 53 "../src/Widgets/SearchRowContainer.vala"
				_tmp8_ = _tmp7_[i];
#line 53 "../src/Widgets/SearchRowContainer.vala"
				st = _tmp8_;
#line 54 "../src/Widgets/SearchRowContainer.vala"
				_tmp9_ = self->priv->search_types_index;
#line 54 "../src/Widgets/SearchRowContainer.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) st), (gpointer) ((gintptr) i));
#line 55 "../src/Widgets/SearchRowContainer.vala"
				_tmp10_ = self->priv->type_combo;
#line 55 "../src/Widgets/SearchRowContainer.vala"
				_tmp11_ = search_condition_search_type_display_text (st);
#line 55 "../src/Widgets/SearchRowContainer.vala"
				_tmp12_ = _tmp11_;
#line 55 "../src/Widgets/SearchRowContainer.vala"
				gtk_combo_box_text_append_text (_tmp10_, _tmp12_);
#line 55 "../src/Widgets/SearchRowContainer.vala"
				_g_free0 (_tmp12_);
#line 310 "SearchRowContainer.c"
			}
		}
	}
#line 57 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_set_type_combo_box (self, SEARCH_CONDITION_SEARCH_TYPE_ANY_TEXT);
#line 58 "../src/Widgets/SearchRowContainer.vala"
	_tmp13_ = self->priv->type_combo;
#line 58 "../src/Widgets/SearchRowContainer.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp13_, "changed", (GCallback) _search_row_container_on_type_changed_gtk_combo_box_changed, self, 0);
#line 60 "../src/Widgets/SearchRowContainer.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 60 "../src/Widgets/SearchRowContainer.vala"
	g_object_ref_sink (_tmp14_);
#line 60 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 60 "../src/Widgets/SearchRowContainer.vala"
	self->priv->remove_button = _tmp14_;
#line 61 "../src/Widgets/SearchRowContainer.vala"
	_tmp15_ = self->priv->remove_button;
#line 61 "../src/Widgets/SearchRowContainer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp15_, GTK_ALIGN_END);
#line 62 "../src/Widgets/SearchRowContainer.vala"
	_tmp16_ = self->priv->remove_button;
#line 62 "../src/Widgets/SearchRowContainer.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
#line 63 "../src/Widgets/SearchRowContainer.vala"
	_tmp17_ = self->priv->remove_button;
#line 63 "../src/Widgets/SearchRowContainer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp17_, _ ("Remove rule"));
#line 64 "../src/Widgets/SearchRowContainer.vala"
	_tmp18_ = self->priv->remove_button;
#line 64 "../src/Widgets/SearchRowContainer.vala"
	g_signal_connect_object ((GtkWidget*) _tmp18_, "button-press-event", (GCallback) _search_row_container_on_removed_gtk_widget_button_press_event, self, 0);
#line 66 "../src/Widgets/SearchRowContainer.vala"
	_tmp19_ = (GtkGrid*) gtk_grid_new ();
#line 66 "../src/Widgets/SearchRowContainer.vala"
	g_object_ref_sink (_tmp19_);
#line 66 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->align);
#line 66 "../src/Widgets/SearchRowContainer.vala"
	self->priv->align = _tmp19_;
#line 68 "../src/Widgets/SearchRowContainer.vala"
	_tmp20_ = (GtkGrid*) gtk_grid_new ();
#line 68 "../src/Widgets/SearchRowContainer.vala"
	g_object_ref_sink (_tmp20_);
#line 68 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->grid);
#line 68 "../src/Widgets/SearchRowContainer.vala"
	self->priv->grid = _tmp20_;
#line 69 "../src/Widgets/SearchRowContainer.vala"
	_tmp21_ = self->priv->grid;
#line 69 "../src/Widgets/SearchRowContainer.vala"
	gtk_grid_set_column_spacing (_tmp21_, 6);
#line 70 "../src/Widgets/SearchRowContainer.vala"
	_tmp22_ = self->priv->grid;
#line 70 "../src/Widgets/SearchRowContainer.vala"
	_tmp23_ = self->priv->type_combo;
#line 70 "../src/Widgets/SearchRowContainer.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 71 "../src/Widgets/SearchRowContainer.vala"
	_tmp24_ = self->priv->grid;
#line 71 "../src/Widgets/SearchRowContainer.vala"
	_tmp25_ = self->priv->align;
#line 71 "../src/Widgets/SearchRowContainer.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 72 "../src/Widgets/SearchRowContainer.vala"
	_tmp26_ = self->priv->grid;
#line 72 "../src/Widgets/SearchRowContainer.vala"
	_tmp27_ = self->priv->remove_button;
#line 72 "../src/Widgets/SearchRowContainer.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 73 "../src/Widgets/SearchRowContainer.vala"
	_tmp28_ = self->priv->grid;
#line 73 "../src/Widgets/SearchRowContainer.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
#line 386 "SearchRowContainer.c"
}

static void
search_row_container_on_type_changed (SearchRowContainer* self)
{
#line 76 "../src/Widgets/SearchRowContainer.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_set_type (self, search_row_container_get_search_type (self));
#line 78 "../src/Widgets/SearchRowContainer.vala"
	g_signal_emit (self, search_row_container_signals[SEARCH_ROW_CONTAINER_CHANGED_SIGNAL], 0, self);
#line 398 "SearchRowContainer.c"
}

static void
search_row_container_set_type_combo_box (SearchRowContainer* self,
                                         SearchConditionSearchType st)
{
	GtkComboBoxText* _tmp0_;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
#line 81 "../src/Widgets/SearchRowContainer.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/Widgets/SearchRowContainer.vala"
	_tmp0_ = self->priv->type_combo;
#line 82 "../src/Widgets/SearchRowContainer.vala"
	_tmp1_ = self->priv->search_types_index;
#line 82 "../src/Widgets/SearchRowContainer.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) st));
#line 82 "../src/Widgets/SearchRowContainer.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _tmp0_, (gint) ((gintptr) _tmp2_));
#line 418 "SearchRowContainer.c"
}

static void
search_row_container_set_type (SearchRowContainer* self,
                               SearchConditionSearchType type)
{
	SearchRow* _tmp0_;
	GtkGrid* _tmp8_;
	SearchRow* _tmp9_;
#line 85 "../src/Widgets/SearchRowContainer.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/Widgets/SearchRowContainer.vala"
	_tmp0_ = self->priv->my_row;
#line 86 "../src/Widgets/SearchRowContainer.vala"
	if (_tmp0_ != NULL) {
#line 434 "SearchRowContainer.c"
		GtkGrid* _tmp1_;
		SearchRow* _tmp2_;
#line 87 "../src/Widgets/SearchRowContainer.vala"
		_tmp1_ = self->priv->align;
#line 87 "../src/Widgets/SearchRowContainer.vala"
		_tmp2_ = self->priv->my_row;
#line 87 "../src/Widgets/SearchRowContainer.vala"
		gtk_container_remove ((GtkContainer*) _tmp1_, (GtkWidget*) _tmp2_);
#line 443 "SearchRowContainer.c"
	}
#line 89 "../src/Widgets/SearchRowContainer.vala"
	switch (type) {
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_ANY_TEXT:
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_EVENT_NAME:
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_FILE_NAME:
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_TAG:
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_COMMENT:
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_TITLE:
#line 459 "SearchRowContainer.c"
		{
			SearchRowText* _tmp3_;
#line 96 "../src/Widgets/SearchRowContainer.vala"
			_tmp3_ = search_row_text_new (self);
#line 96 "../src/Widgets/SearchRowContainer.vala"
			g_object_ref_sink (_tmp3_);
#line 96 "../src/Widgets/SearchRowContainer.vala"
			_g_object_unref0 (self->priv->my_row);
#line 96 "../src/Widgets/SearchRowContainer.vala"
			self->priv->my_row = (SearchRow*) _tmp3_;
#line 97 "../src/Widgets/SearchRowContainer.vala"
			break;
#line 472 "SearchRowContainer.c"
		}
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_MEDIA_TYPE:
#line 476 "SearchRowContainer.c"
		{
			SearchRowMediaType* _tmp4_;
#line 100 "../src/Widgets/SearchRowContainer.vala"
			_tmp4_ = search_row_media_type_new (self);
#line 100 "../src/Widgets/SearchRowContainer.vala"
			g_object_ref_sink (_tmp4_);
#line 100 "../src/Widgets/SearchRowContainer.vala"
			_g_object_unref0 (self->priv->my_row);
#line 100 "../src/Widgets/SearchRowContainer.vala"
			self->priv->my_row = (SearchRow*) _tmp4_;
#line 101 "../src/Widgets/SearchRowContainer.vala"
			break;
#line 489 "SearchRowContainer.c"
		}
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_FLAG_STATE:
#line 493 "SearchRowContainer.c"
		{
			SearchRowFlagged* _tmp5_;
#line 104 "../src/Widgets/SearchRowContainer.vala"
			_tmp5_ = search_row_flagged_new (self);
#line 104 "../src/Widgets/SearchRowContainer.vala"
			g_object_ref_sink (_tmp5_);
#line 104 "../src/Widgets/SearchRowContainer.vala"
			_g_object_unref0 (self->priv->my_row);
#line 104 "../src/Widgets/SearchRowContainer.vala"
			self->priv->my_row = (SearchRow*) _tmp5_;
#line 105 "../src/Widgets/SearchRowContainer.vala"
			break;
#line 506 "SearchRowContainer.c"
		}
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_MODIFIED_STATE:
#line 510 "SearchRowContainer.c"
		{
			SearchRowModified* _tmp6_;
#line 108 "../src/Widgets/SearchRowContainer.vala"
			_tmp6_ = search_row_modified_new (self);
#line 108 "../src/Widgets/SearchRowContainer.vala"
			g_object_ref_sink (_tmp6_);
#line 108 "../src/Widgets/SearchRowContainer.vala"
			_g_object_unref0 (self->priv->my_row);
#line 108 "../src/Widgets/SearchRowContainer.vala"
			self->priv->my_row = (SearchRow*) _tmp6_;
#line 109 "../src/Widgets/SearchRowContainer.vala"
			break;
#line 523 "SearchRowContainer.c"
		}
#line 89 "../src/Widgets/SearchRowContainer.vala"
		case SEARCH_CONDITION_SEARCH_TYPE_DATE:
#line 527 "SearchRowContainer.c"
		{
			SearchRowDate* _tmp7_;
#line 112 "../src/Widgets/SearchRowContainer.vala"
			_tmp7_ = search_row_date_new (self);
#line 112 "../src/Widgets/SearchRowContainer.vala"
			g_object_ref_sink (_tmp7_);
#line 112 "../src/Widgets/SearchRowContainer.vala"
			_g_object_unref0 (self->priv->my_row);
#line 112 "../src/Widgets/SearchRowContainer.vala"
			self->priv->my_row = (SearchRow*) _tmp7_;
#line 113 "../src/Widgets/SearchRowContainer.vala"
			break;
#line 540 "SearchRowContainer.c"
		}
		default:
		{
#line 116 "../src/Widgets/SearchRowContainer.vala"
			_vala_assert (FALSE, "false");
#line 117 "../src/Widgets/SearchRowContainer.vala"
			break;
#line 548 "SearchRowContainer.c"
		}
	}
#line 120 "../src/Widgets/SearchRowContainer.vala"
	_tmp8_ = self->priv->align;
#line 120 "../src/Widgets/SearchRowContainer.vala"
	_tmp9_ = self->priv->my_row;
#line 120 "../src/Widgets/SearchRowContainer.vala"
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 557 "SearchRowContainer.c"
}

SearchConditionSearchType
search_row_container_get_search_type (SearchRowContainer* self)
{
	SearchConditionSearchType* _tmp0_;
	gint _tmp0__length1;
	GtkComboBoxText* _tmp1_;
	SearchConditionSearchType _tmp2_;
	SearchConditionSearchType result;
#line 123 "../src/Widgets/SearchRowContainer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 124 "../src/Widgets/SearchRowContainer.vala"
	_tmp0_ = self->priv->search_types;
#line 124 "../src/Widgets/SearchRowContainer.vala"
	_tmp0__length1 = self->priv->search_types_length1;
#line 124 "../src/Widgets/SearchRowContainer.vala"
	_tmp1_ = self->priv->type_combo;
#line 124 "../src/Widgets/SearchRowContainer.vala"
	_tmp2_ = _tmp0_[gtk_combo_box_get_active ((GtkComboBox*) _tmp1_)];
#line 124 "../src/Widgets/SearchRowContainer.vala"
	result = _tmp2_;
#line 124 "../src/Widgets/SearchRowContainer.vala"
	return result;
#line 582 "SearchRowContainer.c"
}

static gboolean
search_row_container_on_removed (SearchRowContainer* self,
                                 GdkEventButton* event)
{
	gboolean result;
#line 127 "../src/Widgets/SearchRowContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../src/Widgets/SearchRowContainer.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 128 "../src/Widgets/SearchRowContainer.vala"
	g_signal_emit (self, search_row_container_signals[SEARCH_ROW_CONTAINER_REMOVE_SIGNAL], 0, self);
#line 129 "../src/Widgets/SearchRowContainer.vala"
	result = FALSE;
#line 129 "../src/Widgets/SearchRowContainer.vala"
	return result;
#line 600 "SearchRowContainer.c"
}

void
search_row_container_allow_removal (SearchRowContainer* self,
                                    gboolean allow)
{
	GtkButton* _tmp0_;
#line 132 "../src/Widgets/SearchRowContainer.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/Widgets/SearchRowContainer.vala"
	_tmp0_ = self->priv->remove_button;
#line 133 "../src/Widgets/SearchRowContainer.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, allow);
#line 614 "SearchRowContainer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 137 "../src/Widgets/SearchRowContainer.vala"
	return self ? g_object_ref (self) : NULL;
#line 622 "SearchRowContainer.c"
}

GtkWidget*
search_row_container_get_widget (SearchRowContainer* self)
{
	GtkGrid* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result;
#line 136 "../src/Widgets/SearchRowContainer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 137 "../src/Widgets/SearchRowContainer.vala"
	_tmp0_ = self->priv->grid;
#line 137 "../src/Widgets/SearchRowContainer.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 137 "../src/Widgets/SearchRowContainer.vala"
	result = _tmp1_;
#line 137 "../src/Widgets/SearchRowContainer.vala"
	return result;
#line 641 "SearchRowContainer.c"
}

SearchCondition*
search_row_container_get_search_condition (SearchRowContainer* self)
{
	SearchRow* _tmp0_;
	SearchCondition* _tmp1_;
	SearchCondition* result;
#line 140 "../src/Widgets/SearchRowContainer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 141 "../src/Widgets/SearchRowContainer.vala"
	_tmp0_ = self->priv->my_row;
#line 141 "../src/Widgets/SearchRowContainer.vala"
	_tmp1_ = search_row_get_search_condition (_tmp0_);
#line 141 "../src/Widgets/SearchRowContainer.vala"
	result = _tmp1_;
#line 141 "../src/Widgets/SearchRowContainer.vala"
	return result;
#line 660 "SearchRowContainer.c"
}

gboolean
search_row_container_is_complete (SearchRowContainer* self)
{
	SearchRow* _tmp0_;
	gboolean result;
#line 144 "../src/Widgets/SearchRowContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/Widgets/SearchRowContainer.vala"
	_tmp0_ = self->priv->my_row;
#line 145 "../src/Widgets/SearchRowContainer.vala"
	result = search_row_is_complete (_tmp0_);
#line 145 "../src/Widgets/SearchRowContainer.vala"
	return result;
#line 676 "SearchRowContainer.c"
}

static void
search_row_container_class_init (SearchRowContainerClass * klass,
                                 gpointer klass_data)
{
#line 21 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/SearchRowContainer.vala"
	g_type_class_adjust_private_offset (klass, &SearchRowContainer_private_offset);
#line 21 "../src/Widgets/SearchRowContainer.vala"
	G_OBJECT_CLASS (klass)->finalize = search_row_container_finalize;
#line 21 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_signals[SEARCH_ROW_CONTAINER_REMOVE_SIGNAL] = g_signal_new ("remove", TYPE_SEARCH_ROW_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SEARCH_ROW_CONTAINER);
#line 21 "../src/Widgets/SearchRowContainer.vala"
	search_row_container_signals[SEARCH_ROW_CONTAINER_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_SEARCH_ROW_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SEARCH_ROW_CONTAINER);
#line 693 "SearchRowContainer.c"
}

static void
search_row_container_instance_init (SearchRowContainer * self,
                                    gpointer klass)
{
#line 21 "../src/Widgets/SearchRowContainer.vala"
	self->priv = search_row_container_get_instance_private (self);
#line 32 "../src/Widgets/SearchRowContainer.vala"
	self->priv->my_row = NULL;
#line 704 "SearchRowContainer.c"
}

static void
search_row_container_finalize (GObject * obj)
{
	SearchRowContainer * self;
#line 21 "../src/Widgets/SearchRowContainer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_ROW_CONTAINER, SearchRowContainer);
#line 25 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->type_combo);
#line 26 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->grid);
#line 27 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->align);
#line 28 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 29 "../src/Widgets/SearchRowContainer.vala"
	self->priv->search_types = (g_free (self->priv->search_types), NULL);
#line 30 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->search_types_index);
#line 32 "../src/Widgets/SearchRowContainer.vala"
	_g_object_unref0 (self->priv->my_row);
#line 21 "../src/Widgets/SearchRowContainer.vala"
	G_OBJECT_CLASS (search_row_container_parent_class)->finalize (obj);
#line 729 "SearchRowContainer.c"
}

static GType
search_row_container_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchRowContainerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_row_container_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchRowContainer), 0, (GInstanceInitFunc) search_row_container_instance_init, NULL };
	GType search_row_container_type_id;
	search_row_container_type_id = g_type_register_static (G_TYPE_OBJECT, "SearchRowContainer", &g_define_type_info, 0);
	SearchRowContainer_private_offset = g_type_add_instance_private (search_row_container_type_id, sizeof (SearchRowContainerPrivate));
	return search_row_container_type_id;
}

GType
search_row_container_get_type (void)
{
	static volatile gsize search_row_container_type_id__once = 0;
	if (g_once_init_enter (&search_row_container_type_id__once)) {
		GType search_row_container_type_id;
		search_row_container_type_id = search_row_container_get_type_once ();
		g_once_init_leave (&search_row_container_type_id__once, search_row_container_type_id);
	}
	return search_row_container_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

