/* ZoomBuffer.c generated by valac 0.56.18, the Vala compiler
 * generated from ZoomBuffer.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <string.h>

#define ZOOM_BUFFER_MEGAPIXEL 1048576
#define ZOOM_BUFFER_USE_REDUCED_THRESHOLD (((gint) 2.0) * ZOOM_BUFFER_MEGAPIXEL)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_LOADED,
	ZOOM_BUFFER_OBJECT_STATE_SOURCE_LOAD_IN_PROGRESS,
	ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_TRANSFORMED,
	ZOOM_BUFFER_OBJECT_STATE_TRANSFORMED_READY
} ZoomBufferObjectState;

#define ZOOM_BUFFER_TYPE_OBJECT_STATE (zoom_buffer_object_state_get_type ())

#define ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB (zoom_buffer_transformation_job_get_type ())
#define ZOOM_BUFFER_TRANSFORMATION_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB, ZoomBufferTransformationJob))
#define ZOOM_BUFFER_TRANSFORMATION_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB, ZoomBufferTransformationJobClass))
#define ZOOM_BUFFER_IS_TRANSFORMATION_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB))
#define ZOOM_BUFFER_IS_TRANSFORMATION_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB))
#define ZOOM_BUFFER_TRANSFORMATION_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB, ZoomBufferTransformationJobClass))

typedef struct _ZoomBufferTransformationJob ZoomBufferTransformationJob;
typedef struct _ZoomBufferTransformationJobClass ZoomBufferTransformationJobClass;
enum  {
	ZOOM_BUFFER_0_PROPERTY,
	ZOOM_BUFFER_NUM_PROPERTIES
};
static GParamSpec* zoom_buffer_properties[ZOOM_BUFFER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))

#define ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB (zoom_buffer_iso_source_fetch_job_get_type ())
#define ZOOM_BUFFER_ISO_SOURCE_FETCH_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB, ZoomBufferIsoSourceFetchJob))
#define ZOOM_BUFFER_ISO_SOURCE_FETCH_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB, ZoomBufferIsoSourceFetchJobClass))
#define ZOOM_BUFFER_IS_ISO_SOURCE_FETCH_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB))
#define ZOOM_BUFFER_IS_ISO_SOURCE_FETCH_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB))
#define ZOOM_BUFFER_ISO_SOURCE_FETCH_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB, ZoomBufferIsoSourceFetchJobClass))

typedef struct _ZoomBufferIsoSourceFetchJob ZoomBufferIsoSourceFetchJob;
typedef struct _ZoomBufferIsoSourceFetchJobClass ZoomBufferIsoSourceFetchJobClass;
typedef struct _ZoomBufferIsoSourceFetchJobPrivate ZoomBufferIsoSourceFetchJobPrivate;
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
typedef struct _ZoomBufferTransformationJobPrivate ZoomBufferTransformationJobPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ZoomBufferPrivate {
	GdkPixbuf* iso_source_image;
	GdkPixbuf* reduced_source_image;
	GdkPixbuf* iso_transformed_image;
	GdkPixbuf* reduced_transformed_image;
	GdkPixbuf* preview_image;
	Photo* backing_photo;
	ZoomBufferObjectState object_state;
	GdkPixbuf* demand_transform_cached_pixbuf;
	ZoomState demand_transform_zoom_state;
	ZoomBufferTransformationJob* demand_transform_job;
	Workers* workers;
	SinglePhotoPage* parent_page;
	gboolean is_interactive_redraw_in_progress;
};

struct _ZoomBufferIsoSourceFetchJob {
	BackgroundJob parent_instance;
	ZoomBufferIsoSourceFetchJobPrivate * priv;
	GdkPixbuf* fetched;
};

struct _ZoomBufferIsoSourceFetchJobClass {
	BackgroundJobClass parent_class;
};

struct _ZoomBufferTransformationJob {
	BackgroundJob parent_instance;
	ZoomBufferTransformationJobPrivate * priv;
	GdkPixbuf* transformed;
};

struct _ZoomBufferTransformationJobClass {
	BackgroundJobClass parent_class;
};

struct _ZoomBufferIsoSourceFetchJobPrivate {
	Photo* to_fetch;
};

struct _ZoomBufferTransformationJobPrivate {
	GdkPixbuf* to_transform;
	PixelTransformer* transformer;
	GCancellable* cancellable;
};

static gint ZoomBuffer_private_offset;
static gpointer zoom_buffer_parent_class = NULL;
static gint ZoomBufferIsoSourceFetchJob_private_offset;
static gpointer zoom_buffer_iso_source_fetch_job_parent_class = NULL;
static gint ZoomBufferTransformationJob_private_offset;
static gpointer zoom_buffer_transformation_job_parent_class = NULL;

static GType zoom_buffer_object_state_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType zoom_buffer_transformation_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void zoom_buffer_on_iso_source_fetch_complete (ZoomBuffer* self,
                                               BackgroundJob* job);
static GType zoom_buffer_iso_source_fetch_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void zoom_buffer_on_iso_transformation_complete (ZoomBuffer* self,
                                                 BackgroundJob* job);
static void _zoom_buffer_on_iso_transformation_complete_completion_callback (BackgroundJob* job,
                                                                      gpointer self);
static ZoomBufferTransformationJob* zoom_buffer_transformation_job_new (ZoomBuffer* owner,
                                                                 GdkPixbuf* to_transform,
                                                                 PixelTransformer* transformer,
                                                                 CompletionCallback completion_callback,
                                                                 gpointer completion_callback_target,
                                                                 GCancellable* cancellable);
static ZoomBufferTransformationJob* zoom_buffer_transformation_job_construct (GType object_type,
                                                                       ZoomBuffer* owner,
                                                                       GdkPixbuf* to_transform,
                                                                       PixelTransformer* transformer,
                                                                       CompletionCallback completion_callback,
                                                                       gpointer completion_callback_target,
                                                                       GCancellable* cancellable);
static void zoom_buffer_on_demand_transform_complete (ZoomBuffer* self,
                                               BackgroundJob* job);
static GdkPixbuf* zoom_buffer_get_view_projection_pixbuf (ZoomBuffer* self,
                                                   ZoomState* zoom_state,
                                                   GdkPixbuf* iso_pixbuf,
                                                   GdkPixbuf* reduced_pixbuf);
static GdkPixbuf* zoom_buffer_get_zoomed_image_source_not_transformed (ZoomBuffer* self,
                                                                ZoomState* zoom_state);
static void _zoom_buffer_on_demand_transform_complete_completion_callback (BackgroundJob* job,
                                                                    gpointer self);
static void _zoom_buffer_on_iso_source_fetch_complete_completion_callback (BackgroundJob* job,
                                                                    gpointer self);
static ZoomBufferIsoSourceFetchJob* zoom_buffer_iso_source_fetch_job_new (ZoomBuffer* owner,
                                                                   Photo* to_fetch,
                                                                   CompletionCallback completion_callback,
                                                                   gpointer completion_callback_target);
static ZoomBufferIsoSourceFetchJob* zoom_buffer_iso_source_fetch_job_construct (GType object_type,
                                                                         ZoomBuffer* owner,
                                                                         Photo* to_fetch,
                                                                         CompletionCallback completion_callback,
                                                                         gpointer completion_callback_target);
static void zoom_buffer_iso_source_fetch_job_real_execute (BackgroundJob* base);
static void zoom_buffer_iso_source_fetch_job_finalize (BackgroundJob * obj);
static GType zoom_buffer_iso_source_fetch_job_get_type_once (void);
static void zoom_buffer_transformation_job_real_execute (BackgroundJob* base);
static void zoom_buffer_transformation_job_finalize (BackgroundJob * obj);
static GType zoom_buffer_transformation_job_get_type_once (void);
static void zoom_buffer_finalize (GObject * obj);
static GType zoom_buffer_get_type_once (void);

static inline gpointer
zoom_buffer_get_instance_private (ZoomBuffer* self)
{
	return G_STRUCT_MEMBER_P (self, ZoomBuffer_private_offset);
}

static GType
zoom_buffer_object_state_get_type_once (void)
{
	static const GEnumValue values[] = {{ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_LOADED, "ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_LOADED", "source-not-loaded"}, {ZOOM_BUFFER_OBJECT_STATE_SOURCE_LOAD_IN_PROGRESS, "ZOOM_BUFFER_OBJECT_STATE_SOURCE_LOAD_IN_PROGRESS", "source-load-in-progress"}, {ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_TRANSFORMED, "ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_TRANSFORMED", "source-not-transformed"}, {ZOOM_BUFFER_OBJECT_STATE_TRANSFORMED_READY, "ZOOM_BUFFER_OBJECT_STATE_TRANSFORMED_READY", "transformed-ready"}, {0, NULL, NULL}};
	GType zoom_buffer_object_state_type_id;
	zoom_buffer_object_state_type_id = g_enum_register_static ("ZoomBufferObjectState", values);
	return zoom_buffer_object_state_type_id;
}

static GType
zoom_buffer_object_state_get_type (void)
{
	static volatile gsize zoom_buffer_object_state_type_id__once = 0;
	if (g_once_init_enter (&zoom_buffer_object_state_type_id__once)) {
		GType zoom_buffer_object_state_type_id;
		zoom_buffer_object_state_type_id = zoom_buffer_object_state_get_type_once ();
		g_once_init_leave (&zoom_buffer_object_state_type_id__once, zoom_buffer_object_state_type_id);
	}
	return zoom_buffer_object_state_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 99 "../src/ZoomBuffer.vala"
	return self ? g_object_ref (self) : NULL;
#line 225 "ZoomBuffer.c"
}

ZoomBuffer*
zoom_buffer_construct (GType object_type,
                       SinglePhotoPage* parent_page,
                       Photo* backing_photo,
                       GdkPixbuf* preview_image)
{
	ZoomBuffer * self = NULL;
	SinglePhotoPage* _tmp0_;
	GdkPixbuf* _tmp1_;
	Photo* _tmp2_;
	Workers* _tmp3_;
#line 97 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (parent_page != NULL, NULL);
#line 97 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (backing_photo != NULL, NULL);
#line 97 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (preview_image != NULL, NULL);
#line 97 "../src/ZoomBuffer.vala"
	self = (ZoomBuffer*) g_object_new (object_type, NULL);
#line 99 "../src/ZoomBuffer.vala"
	_tmp0_ = _g_object_ref0 (parent_page);
#line 99 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->parent_page);
#line 99 "../src/ZoomBuffer.vala"
	self->priv->parent_page = _tmp0_;
#line 100 "../src/ZoomBuffer.vala"
	_tmp1_ = _g_object_ref0 (preview_image);
#line 100 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->preview_image);
#line 100 "../src/ZoomBuffer.vala"
	self->priv->preview_image = _tmp1_;
#line 101 "../src/ZoomBuffer.vala"
	_tmp2_ = _g_object_ref0 (backing_photo);
#line 101 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->backing_photo);
#line 101 "../src/ZoomBuffer.vala"
	self->priv->backing_photo = _tmp2_;
#line 102 "../src/ZoomBuffer.vala"
	_tmp3_ = workers_new (2, FALSE);
#line 102 "../src/ZoomBuffer.vala"
	_workers_unref0 (self->priv->workers);
#line 102 "../src/ZoomBuffer.vala"
	self->priv->workers = _tmp3_;
#line 97 "../src/ZoomBuffer.vala"
	return self;
#line 273 "ZoomBuffer.c"
}

ZoomBuffer*
zoom_buffer_new (SinglePhotoPage* parent_page,
                 Photo* backing_photo,
                 GdkPixbuf* preview_image)
{
#line 97 "../src/ZoomBuffer.vala"
	return zoom_buffer_construct (TYPE_ZOOM_BUFFER, parent_page, backing_photo, preview_image);
#line 283 "ZoomBuffer.c"
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 106 "../src/ZoomBuffer.vala"
	return self ? background_job_ref (self) : NULL;
#line 291 "ZoomBuffer.c"
}

static void
_zoom_buffer_on_iso_transformation_complete_completion_callback (BackgroundJob* job,
                                                                 gpointer self)
{
#line 122 "../src/ZoomBuffer.vala"
	zoom_buffer_on_iso_transformation_complete ((ZoomBuffer*) self, job);
#line 300 "ZoomBuffer.c"
}

static void
zoom_buffer_on_iso_source_fetch_complete (ZoomBuffer* self,
                                          BackgroundJob* job)
{
	ZoomBufferIsoSourceFetchJob* fetch_job = NULL;
	ZoomBufferIsoSourceFetchJob* _tmp0_;
	ZoomBufferIsoSourceFetchJob* _tmp1_;
	GdkPixbuf* _tmp2_;
	ZoomBufferIsoSourceFetchJob* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkPixbuf* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	BackgroundJob* transformation_job = NULL;
	GdkPixbuf* _tmp21_;
	Photo* _tmp22_;
	PixelTransformer* _tmp23_;
	PixelTransformer* _tmp24_;
	GCancellable* _tmp25_;
	GCancellable* _tmp26_;
	ZoomBufferTransformationJob* _tmp27_;
	BackgroundJob* _tmp28_;
	Workers* _tmp29_;
	BackgroundJob* _tmp30_;
#line 105 "../src/ZoomBuffer.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/ZoomBuffer.vala"
	g_return_if_fail (job != NULL);
#line 106 "../src/ZoomBuffer.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (job, ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB, ZoomBufferIsoSourceFetchJob));
#line 106 "../src/ZoomBuffer.vala"
	fetch_job = _tmp0_;
#line 107 "../src/ZoomBuffer.vala"
	_tmp1_ = fetch_job;
#line 107 "../src/ZoomBuffer.vala"
	_tmp2_ = _tmp1_->fetched;
#line 107 "../src/ZoomBuffer.vala"
	if (_tmp2_ == NULL) {
#line 108 "../src/ZoomBuffer.vala"
		g_critical ("ZoomBuffer.vala:108: ZoomBuffer: iso_source_fetch_complete( ): fetch j" \
"ob has null image member");
#line 109 "../src/ZoomBuffer.vala"
		_background_job_unref0 (fetch_job);
#line 109 "../src/ZoomBuffer.vala"
		return;
#line 351 "ZoomBuffer.c"
	}
#line 112 "../src/ZoomBuffer.vala"
	_tmp3_ = fetch_job;
#line 112 "../src/ZoomBuffer.vala"
	_tmp4_ = _tmp3_->fetched;
#line 112 "../src/ZoomBuffer.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 112 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->iso_source_image);
#line 112 "../src/ZoomBuffer.vala"
	self->priv->iso_source_image = _tmp5_;
#line 113 "../src/ZoomBuffer.vala"
	_tmp6_ = self->priv->iso_source_image;
#line 113 "../src/ZoomBuffer.vala"
	_tmp7_ = gdk_pixbuf_get_width (_tmp6_);
#line 113 "../src/ZoomBuffer.vala"
	_tmp8_ = _tmp7_;
#line 113 "../src/ZoomBuffer.vala"
	_tmp9_ = self->priv->iso_source_image;
#line 113 "../src/ZoomBuffer.vala"
	_tmp10_ = gdk_pixbuf_get_height (_tmp9_);
#line 113 "../src/ZoomBuffer.vala"
	_tmp11_ = _tmp10_;
#line 113 "../src/ZoomBuffer.vala"
	if ((_tmp8_ * _tmp11_) > ZOOM_BUFFER_USE_REDUCED_THRESHOLD) {
#line 377 "ZoomBuffer.c"
		GdkPixbuf* _tmp12_;
		GdkPixbuf* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GdkPixbuf* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		GdkPixbuf* _tmp19_;
#line 114 "../src/ZoomBuffer.vala"
		_tmp12_ = self->priv->iso_source_image;
#line 114 "../src/ZoomBuffer.vala"
		_tmp13_ = self->priv->iso_source_image;
#line 114 "../src/ZoomBuffer.vala"
		_tmp14_ = gdk_pixbuf_get_width (_tmp13_);
#line 114 "../src/ZoomBuffer.vala"
		_tmp15_ = _tmp14_;
#line 114 "../src/ZoomBuffer.vala"
		_tmp16_ = self->priv->iso_source_image;
#line 114 "../src/ZoomBuffer.vala"
		_tmp17_ = gdk_pixbuf_get_height (_tmp16_);
#line 114 "../src/ZoomBuffer.vala"
		_tmp18_ = _tmp17_;
#line 114 "../src/ZoomBuffer.vala"
		_tmp19_ = gdk_pixbuf_scale_simple (_tmp12_, _tmp15_ / 2, _tmp18_ / 2, GDK_INTERP_BILINEAR);
#line 114 "../src/ZoomBuffer.vala"
		_g_object_unref0 (self->priv->reduced_source_image);
#line 114 "../src/ZoomBuffer.vala"
		self->priv->reduced_source_image = _tmp19_;
#line 406 "ZoomBuffer.c"
	}
#line 117 "../src/ZoomBuffer.vala"
	self->priv->object_state = ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_TRANSFORMED;
#line 119 "../src/ZoomBuffer.vala"
	if (!self->priv->is_interactive_redraw_in_progress) {
#line 412 "ZoomBuffer.c"
		SinglePhotoPage* _tmp20_;
#line 120 "../src/ZoomBuffer.vala"
		_tmp20_ = self->priv->parent_page;
#line 120 "../src/ZoomBuffer.vala"
		single_photo_page_repaint (_tmp20_, NULL);
#line 418 "ZoomBuffer.c"
	}
#line 122 "../src/ZoomBuffer.vala"
	_tmp21_ = self->priv->iso_source_image;
#line 122 "../src/ZoomBuffer.vala"
	_tmp22_ = self->priv->backing_photo;
#line 122 "../src/ZoomBuffer.vala"
	_tmp23_ = photo_get_pixel_transformer (_tmp22_);
#line 122 "../src/ZoomBuffer.vala"
	_tmp24_ = _tmp23_;
#line 122 "../src/ZoomBuffer.vala"
	_tmp25_ = g_cancellable_new ();
#line 122 "../src/ZoomBuffer.vala"
	_tmp26_ = _tmp25_;
#line 122 "../src/ZoomBuffer.vala"
	_tmp27_ = zoom_buffer_transformation_job_new (self, _tmp21_, _tmp24_, _zoom_buffer_on_iso_transformation_complete_completion_callback, self, _tmp26_);
#line 122 "../src/ZoomBuffer.vala"
	_tmp28_ = (BackgroundJob*) _tmp27_;
#line 122 "../src/ZoomBuffer.vala"
	_g_object_unref0 (_tmp26_);
#line 122 "../src/ZoomBuffer.vala"
	_pixel_transformer_unref0 (_tmp24_);
#line 122 "../src/ZoomBuffer.vala"
	transformation_job = _tmp28_;
#line 125 "../src/ZoomBuffer.vala"
	_tmp29_ = self->priv->workers;
#line 125 "../src/ZoomBuffer.vala"
	_tmp30_ = transformation_job;
#line 125 "../src/ZoomBuffer.vala"
	workers_enqueue (_tmp29_, _tmp30_);
#line 105 "../src/ZoomBuffer.vala"
	_background_job_unref0 (transformation_job);
#line 105 "../src/ZoomBuffer.vala"
	_background_job_unref0 (fetch_job);
#line 452 "ZoomBuffer.c"
}

static void
zoom_buffer_on_iso_transformation_complete (ZoomBuffer* self,
                                            BackgroundJob* job)
{
	ZoomBufferTransformationJob* transform_job = NULL;
	ZoomBufferTransformationJob* _tmp0_;
	ZoomBufferTransformationJob* _tmp1_;
	GdkPixbuf* _tmp2_;
	ZoomBufferTransformationJob* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkPixbuf* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 128 "../src/ZoomBuffer.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/ZoomBuffer.vala"
	g_return_if_fail (job != NULL);
#line 129 "../src/ZoomBuffer.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (job, ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB, ZoomBufferTransformationJob));
#line 129 "../src/ZoomBuffer.vala"
	transform_job = _tmp0_;
#line 130 "../src/ZoomBuffer.vala"
	_tmp1_ = transform_job;
#line 130 "../src/ZoomBuffer.vala"
	_tmp2_ = _tmp1_->transformed;
#line 130 "../src/ZoomBuffer.vala"
	if (_tmp2_ == NULL) {
#line 131 "../src/ZoomBuffer.vala"
		g_critical ("ZoomBuffer.vala:131: %s", "ZoomBuffer: on_iso_transformation_complete( ): completed job has null " "image");
#line 133 "../src/ZoomBuffer.vala"
		_background_job_unref0 (transform_job);
#line 133 "../src/ZoomBuffer.vala"
		return;
#line 492 "ZoomBuffer.c"
	}
#line 136 "../src/ZoomBuffer.vala"
	_tmp3_ = transform_job;
#line 136 "../src/ZoomBuffer.vala"
	_tmp4_ = _tmp3_->transformed;
#line 136 "../src/ZoomBuffer.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 136 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->iso_transformed_image);
#line 136 "../src/ZoomBuffer.vala"
	self->priv->iso_transformed_image = _tmp5_;
#line 137 "../src/ZoomBuffer.vala"
	_tmp6_ = self->priv->iso_transformed_image;
#line 137 "../src/ZoomBuffer.vala"
	_tmp7_ = gdk_pixbuf_get_width (_tmp6_);
#line 137 "../src/ZoomBuffer.vala"
	_tmp8_ = _tmp7_;
#line 137 "../src/ZoomBuffer.vala"
	_tmp9_ = self->priv->iso_transformed_image;
#line 137 "../src/ZoomBuffer.vala"
	_tmp10_ = gdk_pixbuf_get_height (_tmp9_);
#line 137 "../src/ZoomBuffer.vala"
	_tmp11_ = _tmp10_;
#line 137 "../src/ZoomBuffer.vala"
	if ((_tmp8_ * _tmp11_) > ZOOM_BUFFER_USE_REDUCED_THRESHOLD) {
#line 518 "ZoomBuffer.c"
		GdkPixbuf* _tmp12_;
		GdkPixbuf* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GdkPixbuf* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		GdkPixbuf* _tmp19_;
#line 138 "../src/ZoomBuffer.vala"
		_tmp12_ = self->priv->iso_transformed_image;
#line 138 "../src/ZoomBuffer.vala"
		_tmp13_ = self->priv->iso_transformed_image;
#line 138 "../src/ZoomBuffer.vala"
		_tmp14_ = gdk_pixbuf_get_width (_tmp13_);
#line 138 "../src/ZoomBuffer.vala"
		_tmp15_ = _tmp14_;
#line 138 "../src/ZoomBuffer.vala"
		_tmp16_ = self->priv->iso_transformed_image;
#line 138 "../src/ZoomBuffer.vala"
		_tmp17_ = gdk_pixbuf_get_height (_tmp16_);
#line 138 "../src/ZoomBuffer.vala"
		_tmp18_ = _tmp17_;
#line 138 "../src/ZoomBuffer.vala"
		_tmp19_ = gdk_pixbuf_scale_simple (_tmp12_, _tmp15_ / 2, _tmp18_ / 2, GDK_INTERP_BILINEAR);
#line 138 "../src/ZoomBuffer.vala"
		_g_object_unref0 (self->priv->reduced_transformed_image);
#line 138 "../src/ZoomBuffer.vala"
		self->priv->reduced_transformed_image = _tmp19_;
#line 547 "ZoomBuffer.c"
	}
#line 142 "../src/ZoomBuffer.vala"
	self->priv->object_state = ZOOM_BUFFER_OBJECT_STATE_TRANSFORMED_READY;
#line 128 "../src/ZoomBuffer.vala"
	_background_job_unref0 (transform_job);
#line 553 "ZoomBuffer.c"
}

static void
zoom_buffer_on_demand_transform_complete (ZoomBuffer* self,
                                          BackgroundJob* job)
{
	ZoomBufferTransformationJob* transform_job = NULL;
	ZoomBufferTransformationJob* _tmp0_;
	ZoomBufferTransformationJob* _tmp1_;
	GdkPixbuf* _tmp2_;
	ZoomBufferTransformationJob* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	SinglePhotoPage* _tmp6_;
#line 145 "../src/ZoomBuffer.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/ZoomBuffer.vala"
	g_return_if_fail (job != NULL);
#line 146 "../src/ZoomBuffer.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (job, ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB, ZoomBufferTransformationJob));
#line 146 "../src/ZoomBuffer.vala"
	transform_job = _tmp0_;
#line 147 "../src/ZoomBuffer.vala"
	_tmp1_ = transform_job;
#line 147 "../src/ZoomBuffer.vala"
	_tmp2_ = _tmp1_->transformed;
#line 147 "../src/ZoomBuffer.vala"
	if (_tmp2_ == NULL) {
#line 148 "../src/ZoomBuffer.vala"
		g_critical ("ZoomBuffer.vala:148: %s", "ZoomBuffer: on_demand_transform_complete( ): completed job has null " "image");
#line 150 "../src/ZoomBuffer.vala"
		_background_job_unref0 (transform_job);
#line 150 "../src/ZoomBuffer.vala"
		return;
#line 588 "ZoomBuffer.c"
	}
#line 153 "../src/ZoomBuffer.vala"
	_tmp3_ = transform_job;
#line 153 "../src/ZoomBuffer.vala"
	_tmp4_ = _tmp3_->transformed;
#line 153 "../src/ZoomBuffer.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 153 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->demand_transform_cached_pixbuf);
#line 153 "../src/ZoomBuffer.vala"
	self->priv->demand_transform_cached_pixbuf = _tmp5_;
#line 154 "../src/ZoomBuffer.vala"
	_background_job_unref0 (self->priv->demand_transform_job);
#line 154 "../src/ZoomBuffer.vala"
	self->priv->demand_transform_job = NULL;
#line 156 "../src/ZoomBuffer.vala"
	_tmp6_ = self->priv->parent_page;
#line 156 "../src/ZoomBuffer.vala"
	single_photo_page_repaint (_tmp6_, NULL);
#line 145 "../src/ZoomBuffer.vala"
	_background_job_unref0 (transform_job);
#line 610 "ZoomBuffer.c"
}

static GdkPixbuf*
zoom_buffer_get_view_projection_pixbuf (ZoomBuffer* self,
                                        ZoomState* zoom_state,
                                        GdkPixbuf* iso_pixbuf,
                                        GdkPixbuf* reduced_pixbuf)
{
	GdkRectangle view_rect = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle view_rect_proj = {0};
	GdkRectangle _tmp1_ = {0};
	GdkPixbuf* sample_source_pixbuf = NULL;
	GdkPixbuf* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	GdkPixbuf* proj_subpixbuf = NULL;
	GdkPixbuf* _tmp9_;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp13_;
	GdkPixbuf* _tmp14_;
	GdkPixbuf* zoomed = NULL;
	GdkRectangle _tmp15_;
	GdkRectangle _tmp16_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* result;
#line 162 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 162 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (zoom_state != NULL, NULL);
#line 162 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (iso_pixbuf != NULL, NULL);
#line 164 "../src/ZoomBuffer.vala"
	zoom_state_get_viewing_rectangle_wrt_content (zoom_state, &_tmp0_);
#line 164 "../src/ZoomBuffer.vala"
	view_rect = _tmp0_;
#line 165 "../src/ZoomBuffer.vala"
	zoom_state_get_viewing_rectangle_projection (zoom_state, iso_pixbuf, &_tmp1_);
#line 165 "../src/ZoomBuffer.vala"
	view_rect_proj = _tmp1_;
#line 167 "../src/ZoomBuffer.vala"
	_tmp2_ = _g_object_ref0 (iso_pixbuf);
#line 167 "../src/ZoomBuffer.vala"
	sample_source_pixbuf = _tmp2_;
#line 169 "../src/ZoomBuffer.vala"
	if (reduced_pixbuf != NULL) {
#line 169 "../src/ZoomBuffer.vala"
		_tmp3_ = zoom_state_get_zoom_factor (zoom_state) < 0.5;
#line 664 "ZoomBuffer.c"
	} else {
#line 169 "../src/ZoomBuffer.vala"
		_tmp3_ = FALSE;
#line 668 "ZoomBuffer.c"
	}
#line 169 "../src/ZoomBuffer.vala"
	if (_tmp3_) {
#line 672 "ZoomBuffer.c"
		GdkPixbuf* _tmp4_;
#line 170 "../src/ZoomBuffer.vala"
		_tmp4_ = _g_object_ref0 (reduced_pixbuf);
#line 170 "../src/ZoomBuffer.vala"
		_g_object_unref0 (sample_source_pixbuf);
#line 170 "../src/ZoomBuffer.vala"
		sample_source_pixbuf = _tmp4_;
#line 171 "../src/ZoomBuffer.vala"
		view_rect_proj.x = view_rect_proj.x / 2;
#line 172 "../src/ZoomBuffer.vala"
		view_rect_proj.y = view_rect_proj.y / 2;
#line 173 "../src/ZoomBuffer.vala"
		view_rect_proj.width = view_rect_proj.width / 2;
#line 174 "../src/ZoomBuffer.vala"
		view_rect_proj.height = view_rect_proj.height / 2;
#line 688 "ZoomBuffer.c"
	}
#line 180 "../src/ZoomBuffer.vala"
	_tmp5_ = view_rect_proj;
#line 180 "../src/ZoomBuffer.vala"
	view_rect_proj.width = CLAMP (_tmp5_.width, 1, G_MAXINT);
#line 181 "../src/ZoomBuffer.vala"
	_tmp6_ = view_rect_proj;
#line 181 "../src/ZoomBuffer.vala"
	view_rect_proj.height = CLAMP (_tmp6_.height, 1, G_MAXINT);
#line 183 "../src/ZoomBuffer.vala"
	_tmp7_ = view_rect;
#line 183 "../src/ZoomBuffer.vala"
	view_rect.width = CLAMP (_tmp7_.width, 1, G_MAXINT);
#line 184 "../src/ZoomBuffer.vala"
	_tmp8_ = view_rect;
#line 184 "../src/ZoomBuffer.vala"
	view_rect.height = CLAMP (_tmp8_.height, 1, G_MAXINT);
#line 186 "../src/ZoomBuffer.vala"
	_tmp9_ = sample_source_pixbuf;
#line 186 "../src/ZoomBuffer.vala"
	_tmp10_ = view_rect_proj;
#line 186 "../src/ZoomBuffer.vala"
	_tmp11_ = view_rect_proj;
#line 186 "../src/ZoomBuffer.vala"
	_tmp12_ = view_rect_proj;
#line 186 "../src/ZoomBuffer.vala"
	_tmp13_ = view_rect_proj;
#line 186 "../src/ZoomBuffer.vala"
	_tmp14_ = gdk_pixbuf_new_subpixbuf (_tmp9_, _tmp10_.x, _tmp11_.y, _tmp12_.width, _tmp13_.height);
#line 186 "../src/ZoomBuffer.vala"
	proj_subpixbuf = _tmp14_;
#line 189 "../src/ZoomBuffer.vala"
	_tmp15_ = view_rect;
#line 189 "../src/ZoomBuffer.vala"
	_tmp16_ = view_rect;
#line 189 "../src/ZoomBuffer.vala"
	_tmp17_ = gdk_pixbuf_scale_simple (proj_subpixbuf, _tmp15_.width, _tmp16_.height, GDK_INTERP_BILINEAR);
#line 189 "../src/ZoomBuffer.vala"
	zoomed = _tmp17_;
#line 192 "../src/ZoomBuffer.vala"
	_vala_assert (zoomed != NULL, "zoomed != null");
#line 194 "../src/ZoomBuffer.vala"
	result = zoomed;
#line 194 "../src/ZoomBuffer.vala"
	_g_object_unref0 (proj_subpixbuf);
#line 194 "../src/ZoomBuffer.vala"
	_g_object_unref0 (sample_source_pixbuf);
#line 194 "../src/ZoomBuffer.vala"
	return result;
#line 738 "ZoomBuffer.c"
}

static void
_zoom_buffer_on_demand_transform_complete_completion_callback (BackgroundJob* job,
                                                               gpointer self)
{
#line 265 "../src/ZoomBuffer.vala"
	zoom_buffer_on_demand_transform_complete ((ZoomBuffer*) self, job);
#line 747 "ZoomBuffer.c"
}

static GdkPixbuf*
zoom_buffer_get_zoomed_image_source_not_transformed (ZoomBuffer* self,
                                                     ZoomState* zoom_state)
{
	GdkPixbuf* _tmp0_;
	ZoomBufferTransformationJob* _tmp46_;
	ZoomBufferTransformationJob* _tmp67_;
	ZoomState _tmp84_;
	GdkPixbuf* _tmp85_;
	GdkPixbuf* result;
#line 197 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 197 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (zoom_state != NULL, NULL);
#line 198 "../src/ZoomBuffer.vala"
	_tmp0_ = self->priv->demand_transform_cached_pixbuf;
#line 198 "../src/ZoomBuffer.vala"
	if (_tmp0_ != NULL) {
#line 768 "ZoomBuffer.c"
		ZoomState _tmp1_;
#line 199 "../src/ZoomBuffer.vala"
		_tmp1_ = self->priv->demand_transform_zoom_state;
#line 199 "../src/ZoomBuffer.vala"
		if (zoom_state_equals (zoom_state, &_tmp1_)) {
#line 774 "ZoomBuffer.c"
			GdkPixbuf* _tmp2_;
			GdkPixbuf* _tmp3_;
#line 203 "../src/ZoomBuffer.vala"
			_tmp2_ = self->priv->demand_transform_cached_pixbuf;
#line 203 "../src/ZoomBuffer.vala"
			_tmp3_ = _g_object_ref0 (_tmp2_);
#line 203 "../src/ZoomBuffer.vala"
			result = _tmp3_;
#line 203 "../src/ZoomBuffer.vala"
			return result;
#line 785 "ZoomBuffer.c"
		} else {
#line 204 "../src/ZoomBuffer.vala"
			if (zoom_state_get_zoom_factor (zoom_state) == zoom_state_get_zoom_factor (&self->priv->demand_transform_zoom_state)) {
#line 789 "ZoomBuffer.c"
				GdkRectangle curr_rect = {0};
				GdkRectangle _tmp4_ = {0};
				GdkRectangle pre_rect = {0};
				GdkRectangle _tmp5_ = {0};
				GdkRectangle transfer_src_rect = {0};
				GdkRectangle transfer_dest_rect = {0};
				GdkRectangle _tmp6_;
				GdkRectangle _tmp7_;
				GdkRectangle _tmp8_;
				GdkRectangle _tmp9_;
				GdkRectangle _tmp10_;
				GdkRectangle _tmp11_;
				gint transfer_src_right = 0;
				GdkRectangle _tmp12_;
				GdkRectangle _tmp13_;
				GdkRectangle _tmp14_;
				GdkRectangle _tmp15_;
				GdkRectangle _tmp16_;
				gint transfer_src_bottom = 0;
				GdkRectangle _tmp17_;
				GdkRectangle _tmp18_;
				GdkRectangle _tmp19_;
				GdkRectangle _tmp20_;
				GdkRectangle _tmp21_;
				GdkRectangle _tmp22_;
				GdkRectangle _tmp23_;
				GdkRectangle _tmp24_;
				GdkRectangle _tmp25_;
				GdkRectangle _tmp26_;
				GdkRectangle _tmp27_;
				gint transfer_dest_right = 0;
				GdkRectangle _tmp28_;
				GdkRectangle _tmp29_;
				GdkRectangle _tmp30_;
				GdkRectangle _tmp31_;
				gint transfer_dest_bottom = 0;
				GdkRectangle _tmp32_;
				GdkRectangle _tmp33_;
				GdkRectangle _tmp34_;
				GdkRectangle _tmp35_;
				GdkPixbuf* composited_result = NULL;
				ZoomState _tmp36_;
				GdkPixbuf* _tmp37_;
				GdkPixbuf* _tmp38_;
				GdkRectangle _tmp39_;
				GdkRectangle _tmp40_;
				GdkRectangle _tmp41_;
				GdkRectangle _tmp42_;
				GdkPixbuf* _tmp43_;
				GdkRectangle _tmp44_;
				GdkRectangle _tmp45_;
#line 215 "../src/ZoomBuffer.vala"
				zoom_state_get_viewing_rectangle_wrt_content (zoom_state, &_tmp4_);
#line 215 "../src/ZoomBuffer.vala"
				curr_rect = _tmp4_;
#line 216 "../src/ZoomBuffer.vala"
				zoom_state_get_viewing_rectangle_wrt_content (&self->priv->demand_transform_zoom_state, &_tmp5_);
#line 216 "../src/ZoomBuffer.vala"
				pre_rect = _tmp5_;
#line 218 "../src/ZoomBuffer.vala"
				memset (&transfer_src_rect, 0, sizeof (GdkRectangle));
#line 219 "../src/ZoomBuffer.vala"
				memset (&transfer_dest_rect, 0, sizeof (GdkRectangle));
#line 221 "../src/ZoomBuffer.vala"
				_tmp6_ = curr_rect;
#line 221 "../src/ZoomBuffer.vala"
				_tmp7_ = pre_rect;
#line 221 "../src/ZoomBuffer.vala"
				_tmp8_ = pre_rect;
#line 221 "../src/ZoomBuffer.vala"
				transfer_src_rect.x = CLAMP (_tmp6_.x - _tmp7_.x, 0, _tmp8_.width);
#line 222 "../src/ZoomBuffer.vala"
				_tmp9_ = curr_rect;
#line 222 "../src/ZoomBuffer.vala"
				_tmp10_ = pre_rect;
#line 222 "../src/ZoomBuffer.vala"
				_tmp11_ = pre_rect;
#line 222 "../src/ZoomBuffer.vala"
				transfer_src_rect.y = CLAMP (_tmp9_.y - _tmp10_.y, 0, _tmp11_.height);
#line 223 "../src/ZoomBuffer.vala"
				_tmp12_ = curr_rect;
#line 223 "../src/ZoomBuffer.vala"
				_tmp13_ = curr_rect;
#line 223 "../src/ZoomBuffer.vala"
				_tmp14_ = pre_rect;
#line 223 "../src/ZoomBuffer.vala"
				_tmp15_ = pre_rect;
#line 223 "../src/ZoomBuffer.vala"
				transfer_src_right = CLAMP ((_tmp12_.x + _tmp13_.width) - _tmp14_.width, 0, _tmp15_.width);
#line 225 "../src/ZoomBuffer.vala"
				_tmp16_ = transfer_src_rect;
#line 225 "../src/ZoomBuffer.vala"
				transfer_src_rect.width = transfer_src_right - _tmp16_.x;
#line 226 "../src/ZoomBuffer.vala"
				_tmp17_ = curr_rect;
#line 226 "../src/ZoomBuffer.vala"
				_tmp18_ = curr_rect;
#line 226 "../src/ZoomBuffer.vala"
				_tmp19_ = pre_rect;
#line 226 "../src/ZoomBuffer.vala"
				_tmp20_ = pre_rect;
#line 226 "../src/ZoomBuffer.vala"
				transfer_src_bottom = CLAMP ((_tmp17_.y + _tmp18_.height) - _tmp19_.width, 0, _tmp20_.height);
#line 228 "../src/ZoomBuffer.vala"
				_tmp21_ = transfer_src_rect;
#line 228 "../src/ZoomBuffer.vala"
				transfer_src_rect.height = transfer_src_bottom - _tmp21_.y;
#line 230 "../src/ZoomBuffer.vala"
				_tmp22_ = pre_rect;
#line 230 "../src/ZoomBuffer.vala"
				_tmp23_ = curr_rect;
#line 230 "../src/ZoomBuffer.vala"
				_tmp24_ = curr_rect;
#line 230 "../src/ZoomBuffer.vala"
				transfer_dest_rect.x = CLAMP (_tmp22_.x - _tmp23_.x, 0, _tmp24_.width);
#line 231 "../src/ZoomBuffer.vala"
				_tmp25_ = pre_rect;
#line 231 "../src/ZoomBuffer.vala"
				_tmp26_ = curr_rect;
#line 231 "../src/ZoomBuffer.vala"
				_tmp27_ = curr_rect;
#line 231 "../src/ZoomBuffer.vala"
				transfer_dest_rect.y = CLAMP (_tmp25_.y - _tmp26_.y, 0, _tmp27_.height);
#line 232 "../src/ZoomBuffer.vala"
				_tmp28_ = transfer_dest_rect;
#line 232 "../src/ZoomBuffer.vala"
				_tmp29_ = transfer_src_rect;
#line 232 "../src/ZoomBuffer.vala"
				_tmp30_ = curr_rect;
#line 232 "../src/ZoomBuffer.vala"
				transfer_dest_right = CLAMP (_tmp28_.x + _tmp29_.width, 0, _tmp30_.width);
#line 234 "../src/ZoomBuffer.vala"
				_tmp31_ = transfer_dest_rect;
#line 234 "../src/ZoomBuffer.vala"
				transfer_dest_rect.width = transfer_dest_right - _tmp31_.x;
#line 235 "../src/ZoomBuffer.vala"
				_tmp32_ = transfer_dest_rect;
#line 235 "../src/ZoomBuffer.vala"
				_tmp33_ = transfer_src_rect;
#line 235 "../src/ZoomBuffer.vala"
				_tmp34_ = curr_rect;
#line 235 "../src/ZoomBuffer.vala"
				transfer_dest_bottom = CLAMP (_tmp32_.y + _tmp33_.height, 0, _tmp34_.height);
#line 237 "../src/ZoomBuffer.vala"
				_tmp35_ = transfer_dest_rect;
#line 237 "../src/ZoomBuffer.vala"
				transfer_dest_rect.height = transfer_dest_bottom - _tmp35_.y;
#line 239 "../src/ZoomBuffer.vala"
				_tmp36_ = *zoom_state;
#line 239 "../src/ZoomBuffer.vala"
				_tmp37_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp36_);
#line 239 "../src/ZoomBuffer.vala"
				composited_result = _tmp37_;
#line 240 "../src/ZoomBuffer.vala"
				_tmp38_ = self->priv->demand_transform_cached_pixbuf;
#line 240 "../src/ZoomBuffer.vala"
				_tmp39_ = transfer_src_rect;
#line 240 "../src/ZoomBuffer.vala"
				_tmp40_ = transfer_src_rect;
#line 240 "../src/ZoomBuffer.vala"
				_tmp41_ = transfer_dest_rect;
#line 240 "../src/ZoomBuffer.vala"
				_tmp42_ = transfer_dest_rect;
#line 240 "../src/ZoomBuffer.vala"
				_tmp43_ = composited_result;
#line 240 "../src/ZoomBuffer.vala"
				_tmp44_ = transfer_dest_rect;
#line 240 "../src/ZoomBuffer.vala"
				_tmp45_ = transfer_dest_rect;
#line 240 "../src/ZoomBuffer.vala"
				gdk_pixbuf_copy_area (_tmp38_, _tmp39_.x, _tmp40_.y, _tmp41_.width, _tmp42_.height, _tmp43_, _tmp44_.x, _tmp45_.y);
#line 244 "../src/ZoomBuffer.vala"
				result = composited_result;
#line 244 "../src/ZoomBuffer.vala"
				return result;
#line 965 "ZoomBuffer.c"
			}
		}
	}
#line 255 "../src/ZoomBuffer.vala"
	_tmp46_ = self->priv->demand_transform_job;
#line 255 "../src/ZoomBuffer.vala"
	if (_tmp46_ != NULL) {
#line 973 "ZoomBuffer.c"
		ZoomState _tmp47_;
#line 256 "../src/ZoomBuffer.vala"
		_tmp47_ = self->priv->demand_transform_zoom_state;
#line 256 "../src/ZoomBuffer.vala"
		if (zoom_state_equals (zoom_state, &_tmp47_)) {
#line 979 "ZoomBuffer.c"
			ZoomState _tmp48_;
			GdkPixbuf* _tmp49_;
#line 257 "../src/ZoomBuffer.vala"
			_tmp48_ = *zoom_state;
#line 257 "../src/ZoomBuffer.vala"
			_tmp49_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp48_);
#line 257 "../src/ZoomBuffer.vala"
			result = _tmp49_;
#line 257 "../src/ZoomBuffer.vala"
			return result;
#line 990 "ZoomBuffer.c"
		} else {
			ZoomBufferTransformationJob* _tmp50_;
			GdkPixbuf* zoomed = NULL;
			ZoomState _tmp51_;
			GdkPixbuf* _tmp52_;
			GdkPixbuf* _tmp53_;
			GdkPixbuf* _tmp54_;
			GdkPixbuf* _tmp55_;
			Photo* _tmp56_;
			PixelTransformer* _tmp57_;
			PixelTransformer* _tmp58_;
			GCancellable* _tmp59_;
			GCancellable* _tmp60_;
			ZoomBufferTransformationJob* _tmp61_;
			ZoomState _tmp62_;
			Workers* _tmp63_;
			ZoomBufferTransformationJob* _tmp64_;
			ZoomState _tmp65_;
			GdkPixbuf* _tmp66_;
#line 259 "../src/ZoomBuffer.vala"
			_tmp50_ = self->priv->demand_transform_job;
#line 259 "../src/ZoomBuffer.vala"
			background_job_cancel ((BackgroundJob*) _tmp50_);
#line 260 "../src/ZoomBuffer.vala"
			_background_job_unref0 (self->priv->demand_transform_job);
#line 260 "../src/ZoomBuffer.vala"
			self->priv->demand_transform_job = NULL;
#line 262 "../src/ZoomBuffer.vala"
			_tmp51_ = *zoom_state;
#line 262 "../src/ZoomBuffer.vala"
			_tmp52_ = self->priv->iso_source_image;
#line 262 "../src/ZoomBuffer.vala"
			_tmp53_ = self->priv->reduced_source_image;
#line 262 "../src/ZoomBuffer.vala"
			_tmp54_ = zoom_buffer_get_view_projection_pixbuf (self, &_tmp51_, _tmp52_, _tmp53_);
#line 262 "../src/ZoomBuffer.vala"
			zoomed = _tmp54_;
#line 265 "../src/ZoomBuffer.vala"
			_tmp55_ = zoomed;
#line 265 "../src/ZoomBuffer.vala"
			_tmp56_ = self->priv->backing_photo;
#line 265 "../src/ZoomBuffer.vala"
			_tmp57_ = photo_get_pixel_transformer (_tmp56_);
#line 265 "../src/ZoomBuffer.vala"
			_tmp58_ = _tmp57_;
#line 265 "../src/ZoomBuffer.vala"
			_tmp59_ = g_cancellable_new ();
#line 265 "../src/ZoomBuffer.vala"
			_tmp60_ = _tmp59_;
#line 265 "../src/ZoomBuffer.vala"
			_tmp61_ = zoom_buffer_transformation_job_new (self, _tmp55_, _tmp58_, _zoom_buffer_on_demand_transform_complete_completion_callback, self, _tmp60_);
#line 265 "../src/ZoomBuffer.vala"
			_background_job_unref0 (self->priv->demand_transform_job);
#line 265 "../src/ZoomBuffer.vala"
			self->priv->demand_transform_job = _tmp61_;
#line 265 "../src/ZoomBuffer.vala"
			_g_object_unref0 (_tmp60_);
#line 265 "../src/ZoomBuffer.vala"
			_pixel_transformer_unref0 (_tmp58_);
#line 268 "../src/ZoomBuffer.vala"
			_tmp62_ = *zoom_state;
#line 268 "../src/ZoomBuffer.vala"
			self->priv->demand_transform_zoom_state = _tmp62_;
#line 269 "../src/ZoomBuffer.vala"
			_tmp63_ = self->priv->workers;
#line 269 "../src/ZoomBuffer.vala"
			_tmp64_ = self->priv->demand_transform_job;
#line 269 "../src/ZoomBuffer.vala"
			workers_enqueue (_tmp63_, (BackgroundJob*) _tmp64_);
#line 271 "../src/ZoomBuffer.vala"
			_tmp65_ = *zoom_state;
#line 271 "../src/ZoomBuffer.vala"
			_tmp66_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp65_);
#line 271 "../src/ZoomBuffer.vala"
			result = _tmp66_;
#line 271 "../src/ZoomBuffer.vala"
			_g_object_unref0 (zoomed);
#line 271 "../src/ZoomBuffer.vala"
			return result;
#line 1070 "ZoomBuffer.c"
		}
	}
#line 276 "../src/ZoomBuffer.vala"
	_tmp67_ = self->priv->demand_transform_job;
#line 276 "../src/ZoomBuffer.vala"
	if (_tmp67_ == NULL) {
#line 1077 "ZoomBuffer.c"
		GdkPixbuf* zoomed = NULL;
		ZoomState _tmp68_;
		GdkPixbuf* _tmp69_;
		GdkPixbuf* _tmp70_;
		GdkPixbuf* _tmp71_;
		GdkPixbuf* _tmp72_;
		Photo* _tmp73_;
		PixelTransformer* _tmp74_;
		PixelTransformer* _tmp75_;
		GCancellable* _tmp76_;
		GCancellable* _tmp77_;
		ZoomBufferTransformationJob* _tmp78_;
		ZoomState _tmp79_;
		Workers* _tmp80_;
		ZoomBufferTransformationJob* _tmp81_;
		ZoomState _tmp82_;
		GdkPixbuf* _tmp83_;
#line 277 "../src/ZoomBuffer.vala"
		_tmp68_ = *zoom_state;
#line 277 "../src/ZoomBuffer.vala"
		_tmp69_ = self->priv->iso_source_image;
#line 277 "../src/ZoomBuffer.vala"
		_tmp70_ = self->priv->reduced_source_image;
#line 277 "../src/ZoomBuffer.vala"
		_tmp71_ = zoom_buffer_get_view_projection_pixbuf (self, &_tmp68_, _tmp69_, _tmp70_);
#line 277 "../src/ZoomBuffer.vala"
		zoomed = _tmp71_;
#line 280 "../src/ZoomBuffer.vala"
		_tmp72_ = zoomed;
#line 280 "../src/ZoomBuffer.vala"
		_tmp73_ = self->priv->backing_photo;
#line 280 "../src/ZoomBuffer.vala"
		_tmp74_ = photo_get_pixel_transformer (_tmp73_);
#line 280 "../src/ZoomBuffer.vala"
		_tmp75_ = _tmp74_;
#line 280 "../src/ZoomBuffer.vala"
		_tmp76_ = g_cancellable_new ();
#line 280 "../src/ZoomBuffer.vala"
		_tmp77_ = _tmp76_;
#line 280 "../src/ZoomBuffer.vala"
		_tmp78_ = zoom_buffer_transformation_job_new (self, _tmp72_, _tmp75_, _zoom_buffer_on_demand_transform_complete_completion_callback, self, _tmp77_);
#line 280 "../src/ZoomBuffer.vala"
		_background_job_unref0 (self->priv->demand_transform_job);
#line 280 "../src/ZoomBuffer.vala"
		self->priv->demand_transform_job = _tmp78_;
#line 280 "../src/ZoomBuffer.vala"
		_g_object_unref0 (_tmp77_);
#line 280 "../src/ZoomBuffer.vala"
		_pixel_transformer_unref0 (_tmp75_);
#line 284 "../src/ZoomBuffer.vala"
		_tmp79_ = *zoom_state;
#line 284 "../src/ZoomBuffer.vala"
		self->priv->demand_transform_zoom_state = _tmp79_;
#line 286 "../src/ZoomBuffer.vala"
		_tmp80_ = self->priv->workers;
#line 286 "../src/ZoomBuffer.vala"
		_tmp81_ = self->priv->demand_transform_job;
#line 286 "../src/ZoomBuffer.vala"
		workers_enqueue (_tmp80_, (BackgroundJob*) _tmp81_);
#line 288 "../src/ZoomBuffer.vala"
		_tmp82_ = *zoom_state;
#line 288 "../src/ZoomBuffer.vala"
		_tmp83_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp82_);
#line 288 "../src/ZoomBuffer.vala"
		result = _tmp83_;
#line 288 "../src/ZoomBuffer.vala"
		_g_object_unref0 (zoomed);
#line 288 "../src/ZoomBuffer.vala"
		return result;
#line 1147 "ZoomBuffer.c"
	}
#line 296 "../src/ZoomBuffer.vala"
	g_critical ("ZoomBuffer.vala:296: %s", "ZoomBuffer: get_zoomed_image( ): in SOURCE-NOT-TRANSFORMED but can't t" \
"ransform " "on-screen projection on-demand; using preview image");
#line 298 "../src/ZoomBuffer.vala"
	_tmp84_ = *zoom_state;
#line 298 "../src/ZoomBuffer.vala"
	_tmp85_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp84_);
#line 298 "../src/ZoomBuffer.vala"
	result = _tmp85_;
#line 298 "../src/ZoomBuffer.vala"
	return result;
#line 1159 "ZoomBuffer.c"
}

static void
_zoom_buffer_on_iso_source_fetch_complete_completion_callback (BackgroundJob* job,
                                                               gpointer self)
{
#line 303 "../src/ZoomBuffer.vala"
	zoom_buffer_on_iso_source_fetch_complete ((ZoomBuffer*) self, job);
#line 1168 "ZoomBuffer.c"
}

GdkPixbuf*
zoom_buffer_get_zoom_preview_image_internal (ZoomBuffer* self,
                                             ZoomState* zoom_state)
{
	GdkRectangle view_rect = {0};
	GdkRectangle _tmp4_ = {0};
	GdkRectangle view_rect_proj = {0};
	GdkPixbuf* _tmp5_;
	GdkRectangle _tmp6_ = {0};
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	GdkPixbuf* proj_subpixbuf = NULL;
	GdkPixbuf* _tmp9_;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp13_;
	GdkPixbuf* _tmp14_;
	GdkPixbuf* zoomed = NULL;
	GdkRectangle _tmp15_;
	GdkRectangle _tmp16_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* result;
#line 301 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 301 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (zoom_state != NULL, NULL);
#line 302 "../src/ZoomBuffer.vala"
	if (self->priv->object_state == ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_LOADED) {
#line 1200 "ZoomBuffer.c"
		BackgroundJob* iso_source_fetch_job = NULL;
		Photo* _tmp0_;
		ZoomBufferIsoSourceFetchJob* _tmp1_;
		Workers* _tmp2_;
		BackgroundJob* _tmp3_;
#line 303 "../src/ZoomBuffer.vala"
		_tmp0_ = self->priv->backing_photo;
#line 303 "../src/ZoomBuffer.vala"
		_tmp1_ = zoom_buffer_iso_source_fetch_job_new (self, _tmp0_, _zoom_buffer_on_iso_source_fetch_complete_completion_callback, self);
#line 303 "../src/ZoomBuffer.vala"
		iso_source_fetch_job = (BackgroundJob*) _tmp1_;
#line 305 "../src/ZoomBuffer.vala"
		_tmp2_ = self->priv->workers;
#line 305 "../src/ZoomBuffer.vala"
		_tmp3_ = iso_source_fetch_job;
#line 305 "../src/ZoomBuffer.vala"
		workers_enqueue (_tmp2_, _tmp3_);
#line 307 "../src/ZoomBuffer.vala"
		self->priv->object_state = ZOOM_BUFFER_OBJECT_STATE_SOURCE_LOAD_IN_PROGRESS;
#line 302 "../src/ZoomBuffer.vala"
		_background_job_unref0 (iso_source_fetch_job);
#line 1222 "ZoomBuffer.c"
	}
#line 309 "../src/ZoomBuffer.vala"
	zoom_state_get_viewing_rectangle_wrt_content (zoom_state, &_tmp4_);
#line 309 "../src/ZoomBuffer.vala"
	view_rect = _tmp4_;
#line 310 "../src/ZoomBuffer.vala"
	_tmp5_ = self->priv->preview_image;
#line 310 "../src/ZoomBuffer.vala"
	zoom_state_get_viewing_rectangle_projection (zoom_state, _tmp5_, &_tmp6_);
#line 310 "../src/ZoomBuffer.vala"
	view_rect_proj = _tmp6_;
#line 313 "../src/ZoomBuffer.vala"
	_tmp7_ = view_rect_proj;
#line 313 "../src/ZoomBuffer.vala"
	view_rect_proj.width = CLAMP (_tmp7_.width, 1, G_MAXINT);
#line 314 "../src/ZoomBuffer.vala"
	_tmp8_ = view_rect_proj;
#line 314 "../src/ZoomBuffer.vala"
	view_rect_proj.height = CLAMP (_tmp8_.height, 1, G_MAXINT);
#line 316 "../src/ZoomBuffer.vala"
	_tmp9_ = self->priv->preview_image;
#line 316 "../src/ZoomBuffer.vala"
	_tmp10_ = view_rect_proj;
#line 316 "../src/ZoomBuffer.vala"
	_tmp11_ = view_rect_proj;
#line 316 "../src/ZoomBuffer.vala"
	_tmp12_ = view_rect_proj;
#line 316 "../src/ZoomBuffer.vala"
	_tmp13_ = view_rect_proj;
#line 316 "../src/ZoomBuffer.vala"
	_tmp14_ = gdk_pixbuf_new_subpixbuf (_tmp9_, _tmp10_.x, _tmp11_.y, _tmp12_.width, _tmp13_.height);
#line 316 "../src/ZoomBuffer.vala"
	proj_subpixbuf = _tmp14_;
#line 319 "../src/ZoomBuffer.vala"
	_tmp15_ = view_rect;
#line 319 "../src/ZoomBuffer.vala"
	_tmp16_ = view_rect;
#line 319 "../src/ZoomBuffer.vala"
	_tmp17_ = gdk_pixbuf_scale_simple (proj_subpixbuf, _tmp15_.width, _tmp16_.height, GDK_INTERP_BILINEAR);
#line 319 "../src/ZoomBuffer.vala"
	zoomed = _tmp17_;
#line 322 "../src/ZoomBuffer.vala"
	result = zoomed;
#line 322 "../src/ZoomBuffer.vala"
	_g_object_unref0 (proj_subpixbuf);
#line 322 "../src/ZoomBuffer.vala"
	return result;
#line 1270 "ZoomBuffer.c"
}

Photo*
zoom_buffer_get_backing_photo (ZoomBuffer* self)
{
	Photo* _tmp0_;
	Photo* _tmp1_;
	Photo* result;
#line 325 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "../src/ZoomBuffer.vala"
	_tmp0_ = self->priv->backing_photo;
#line 326 "../src/ZoomBuffer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 326 "../src/ZoomBuffer.vala"
	result = _tmp1_;
#line 326 "../src/ZoomBuffer.vala"
	return result;
#line 1289 "ZoomBuffer.c"
}

void
zoom_buffer_update_preview_image (ZoomBuffer* self,
                                  GdkPixbuf* preview_image)
{
	GdkPixbuf* _tmp0_;
#line 329 "../src/ZoomBuffer.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/ZoomBuffer.vala"
	g_return_if_fail (preview_image != NULL);
#line 330 "../src/ZoomBuffer.vala"
	_tmp0_ = _g_object_ref0 (preview_image);
#line 330 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->preview_image);
#line 330 "../src/ZoomBuffer.vala"
	self->priv->preview_image = _tmp0_;
#line 1307 "ZoomBuffer.c"
}

void
zoom_buffer_flush_demand_cache (ZoomBuffer* self,
                                ZoomState* initial_zoom_state)
{
#line 335 "../src/ZoomBuffer.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->demand_transform_cached_pixbuf);
#line 336 "../src/ZoomBuffer.vala"
	self->priv->demand_transform_cached_pixbuf = NULL;
#line 337 "../src/ZoomBuffer.vala"
	if (initial_zoom_state != NULL) {
#line 1322 "ZoomBuffer.c"
		ZoomState _tmp0_;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 338 "../src/ZoomBuffer.vala"
		_tmp0_ = *initial_zoom_state;
#line 338 "../src/ZoomBuffer.vala"
		_tmp1_ = zoom_buffer_get_zoomed_image (self, &_tmp0_);
#line 338 "../src/ZoomBuffer.vala"
		_tmp2_ = _tmp1_;
#line 338 "../src/ZoomBuffer.vala"
		_g_object_unref0 (_tmp2_);
#line 1334 "ZoomBuffer.c"
	}
}

GdkPixbuf*
zoom_buffer_get_zoomed_image (ZoomBuffer* self,
                              ZoomState* zoom_state)
{
	GdkPixbuf* result;
#line 341 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 341 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (zoom_state != NULL, NULL);
#line 342 "../src/ZoomBuffer.vala"
	self->priv->is_interactive_redraw_in_progress = FALSE;
#line 346 "../src/ZoomBuffer.vala"
	if (zoom_state_get_interpolation_factor (zoom_state) == 0.0) {
#line 1351 "ZoomBuffer.c"
		ZoomState _tmp0_;
		GdkPixbuf* _tmp1_;
#line 347 "../src/ZoomBuffer.vala"
		_tmp0_ = *zoom_state;
#line 347 "../src/ZoomBuffer.vala"
		_tmp1_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp0_);
#line 347 "../src/ZoomBuffer.vala"
		result = _tmp1_;
#line 347 "../src/ZoomBuffer.vala"
		return result;
#line 1362 "ZoomBuffer.c"
	}
#line 350 "../src/ZoomBuffer.vala"
	switch (self->priv->object_state) {
#line 350 "../src/ZoomBuffer.vala"
		case ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_LOADED:
#line 350 "../src/ZoomBuffer.vala"
		case ZOOM_BUFFER_OBJECT_STATE_SOURCE_LOAD_IN_PROGRESS:
#line 1370 "ZoomBuffer.c"
		{
			ZoomState _tmp2_;
			GdkPixbuf* _tmp3_;
#line 353 "../src/ZoomBuffer.vala"
			_tmp2_ = *zoom_state;
#line 353 "../src/ZoomBuffer.vala"
			_tmp3_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp2_);
#line 353 "../src/ZoomBuffer.vala"
			result = _tmp3_;
#line 353 "../src/ZoomBuffer.vala"
			return result;
#line 1382 "ZoomBuffer.c"
		}
#line 350 "../src/ZoomBuffer.vala"
		case ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_TRANSFORMED:
#line 1386 "ZoomBuffer.c"
		{
			ZoomState _tmp4_;
			GdkPixbuf* _tmp5_;
#line 356 "../src/ZoomBuffer.vala"
			_tmp4_ = *zoom_state;
#line 356 "../src/ZoomBuffer.vala"
			_tmp5_ = zoom_buffer_get_zoomed_image_source_not_transformed (self, &_tmp4_);
#line 356 "../src/ZoomBuffer.vala"
			result = _tmp5_;
#line 356 "../src/ZoomBuffer.vala"
			return result;
#line 1398 "ZoomBuffer.c"
		}
#line 350 "../src/ZoomBuffer.vala"
		case ZOOM_BUFFER_OBJECT_STATE_TRANSFORMED_READY:
#line 1402 "ZoomBuffer.c"
		{
			ZoomState _tmp6_;
			GdkPixbuf* _tmp7_;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 361 "../src/ZoomBuffer.vala"
			_tmp6_ = *zoom_state;
#line 361 "../src/ZoomBuffer.vala"
			_tmp7_ = self->priv->iso_transformed_image;
#line 361 "../src/ZoomBuffer.vala"
			_tmp8_ = self->priv->reduced_transformed_image;
#line 361 "../src/ZoomBuffer.vala"
			_tmp9_ = zoom_buffer_get_view_projection_pixbuf (self, &_tmp6_, _tmp7_, _tmp8_);
#line 361 "../src/ZoomBuffer.vala"
			result = _tmp9_;
#line 361 "../src/ZoomBuffer.vala"
			return result;
#line 1420 "ZoomBuffer.c"
		}
		default:
		{
			ZoomState _tmp10_;
			GdkPixbuf* _tmp11_;
#line 365 "../src/ZoomBuffer.vala"
			g_critical ("ZoomBuffer.vala:365: ZoomBuffer: get_zoomed_image( ): object is an inc" \
"onsistent state");
#line 366 "../src/ZoomBuffer.vala"
			_tmp10_ = *zoom_state;
#line 366 "../src/ZoomBuffer.vala"
			_tmp11_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp10_);
#line 366 "../src/ZoomBuffer.vala"
			result = _tmp11_;
#line 366 "../src/ZoomBuffer.vala"
			return result;
#line 1436 "ZoomBuffer.c"
		}
	}
}

GdkPixbuf*
zoom_buffer_get_zoom_preview_image (ZoomBuffer* self,
                                    ZoomState* zoom_state)
{
	ZoomState _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* result;
#line 370 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 370 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (zoom_state != NULL, NULL);
#line 371 "../src/ZoomBuffer.vala"
	self->priv->is_interactive_redraw_in_progress = TRUE;
#line 373 "../src/ZoomBuffer.vala"
	_tmp0_ = *zoom_state;
#line 373 "../src/ZoomBuffer.vala"
	_tmp1_ = zoom_buffer_get_zoom_preview_image_internal (self, &_tmp0_);
#line 373 "../src/ZoomBuffer.vala"
	result = _tmp1_;
#line 373 "../src/ZoomBuffer.vala"
	return result;
#line 1462 "ZoomBuffer.c"
}

static inline gpointer
zoom_buffer_iso_source_fetch_job_get_instance_private (ZoomBufferIsoSourceFetchJob* self)
{
	return G_STRUCT_MEMBER_P (self, ZoomBufferIsoSourceFetchJob_private_offset);
}

static ZoomBufferIsoSourceFetchJob*
zoom_buffer_iso_source_fetch_job_construct (GType object_type,
                                            ZoomBuffer* owner,
                                            Photo* to_fetch,
                                            CompletionCallback completion_callback,
                                            gpointer completion_callback_target)
{
	ZoomBufferIsoSourceFetchJob* self = NULL;
	Photo* _tmp0_;
#line 33 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 33 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (to_fetch != NULL, NULL);
#line 35 "../src/ZoomBuffer.vala"
	self = (ZoomBufferIsoSourceFetchJob*) background_job_construct (object_type, (GObject*) owner, completion_callback, completion_callback_target, NULL, NULL, NULL, NULL);
#line 37 "../src/ZoomBuffer.vala"
	_tmp0_ = _g_object_ref0 (to_fetch);
#line 37 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->to_fetch);
#line 37 "../src/ZoomBuffer.vala"
	self->priv->to_fetch = _tmp0_;
#line 33 "../src/ZoomBuffer.vala"
	return self;
#line 1494 "ZoomBuffer.c"
}

static ZoomBufferIsoSourceFetchJob*
zoom_buffer_iso_source_fetch_job_new (ZoomBuffer* owner,
                                      Photo* to_fetch,
                                      CompletionCallback completion_callback,
                                      gpointer completion_callback_target)
{
#line 33 "../src/ZoomBuffer.vala"
	return zoom_buffer_iso_source_fetch_job_construct (ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB, owner, to_fetch, completion_callback, completion_callback_target);
#line 1505 "ZoomBuffer.c"
}

static void
zoom_buffer_iso_source_fetch_job_real_execute (BackgroundJob* base)
{
	ZoomBufferIsoSourceFetchJob * self;
	GError* _inner_error0_ = NULL;
#line 40 "../src/ZoomBuffer.vala"
	self = (ZoomBufferIsoSourceFetchJob*) base;
#line 1515 "ZoomBuffer.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Photo* _tmp1_;
		Scaling _tmp2_ = {0};
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 42 "../src/ZoomBuffer.vala"
		_tmp1_ = self->priv->to_fetch;
#line 42 "../src/ZoomBuffer.vala"
		scaling_for_original (&_tmp2_);
#line 42 "../src/ZoomBuffer.vala"
		_tmp3_ = photo_get_pixbuf_with_options (_tmp1_, &_tmp2_, PHOTO_EXCEPTION_ADJUST, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 42 "../src/ZoomBuffer.vala"
		_tmp0_ = _tmp3_;
#line 42 "../src/ZoomBuffer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1532 "ZoomBuffer.c"
			goto __catch0_g_error;
		}
#line 42 "../src/ZoomBuffer.vala"
		_tmp4_ = _tmp0_;
#line 42 "../src/ZoomBuffer.vala"
		_tmp0_ = NULL;
#line 42 "../src/ZoomBuffer.vala"
		_g_object_unref0 (self->fetched);
#line 42 "../src/ZoomBuffer.vala"
		self->fetched = _tmp4_;
#line 41 "../src/ZoomBuffer.vala"
		_g_object_unref0 (_tmp0_);
#line 1545 "ZoomBuffer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 41 "../src/ZoomBuffer.vala"
		g_clear_error (&_inner_error0_);
#line 45 "../src/ZoomBuffer.vala"
		g_critical ("ZoomBuffer.vala:45: IsoSourceFetchJob: execute( ): can't get pixbuf fr" \
"om backing photo");
#line 1554 "ZoomBuffer.c"
	}
	__finally0:
#line 41 "../src/ZoomBuffer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 41 "../src/ZoomBuffer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 41 "../src/ZoomBuffer.vala"
		g_clear_error (&_inner_error0_);
#line 41 "../src/ZoomBuffer.vala"
		return;
#line 1565 "ZoomBuffer.c"
	}
}

static void
zoom_buffer_iso_source_fetch_job_class_init (ZoomBufferIsoSourceFetchJobClass * klass,
                                             gpointer klass_data)
{
#line 28 "../src/ZoomBuffer.vala"
	zoom_buffer_iso_source_fetch_job_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/ZoomBuffer.vala"
	((BackgroundJobClass *) klass)->finalize = zoom_buffer_iso_source_fetch_job_finalize;
#line 28 "../src/ZoomBuffer.vala"
	g_type_class_adjust_private_offset (klass, &ZoomBufferIsoSourceFetchJob_private_offset);
#line 28 "../src/ZoomBuffer.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) zoom_buffer_iso_source_fetch_job_real_execute;
#line 1581 "ZoomBuffer.c"
}

static void
zoom_buffer_iso_source_fetch_job_instance_init (ZoomBufferIsoSourceFetchJob * self,
                                                gpointer klass)
{
#line 28 "../src/ZoomBuffer.vala"
	self->priv = zoom_buffer_iso_source_fetch_job_get_instance_private (self);
#line 31 "../src/ZoomBuffer.vala"
	self->fetched = NULL;
#line 1592 "ZoomBuffer.c"
}

static void
zoom_buffer_iso_source_fetch_job_finalize (BackgroundJob * obj)
{
	ZoomBufferIsoSourceFetchJob * self;
#line 28 "../src/ZoomBuffer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ZOOM_BUFFER_TYPE_ISO_SOURCE_FETCH_JOB, ZoomBufferIsoSourceFetchJob);
#line 29 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->to_fetch);
#line 31 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->fetched);
#line 28 "../src/ZoomBuffer.vala"
	BACKGROUND_JOB_CLASS (zoom_buffer_iso_source_fetch_job_parent_class)->finalize (obj);
#line 1607 "ZoomBuffer.c"
}

static GType
zoom_buffer_iso_source_fetch_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ZoomBufferIsoSourceFetchJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) zoom_buffer_iso_source_fetch_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ZoomBufferIsoSourceFetchJob), 0, (GInstanceInitFunc) zoom_buffer_iso_source_fetch_job_instance_init, NULL };
	GType zoom_buffer_iso_source_fetch_job_type_id;
	zoom_buffer_iso_source_fetch_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "ZoomBufferIsoSourceFetchJob", &g_define_type_info, 0);
	ZoomBufferIsoSourceFetchJob_private_offset = g_type_add_instance_private (zoom_buffer_iso_source_fetch_job_type_id, sizeof (ZoomBufferIsoSourceFetchJobPrivate));
	return zoom_buffer_iso_source_fetch_job_type_id;
}

static GType
zoom_buffer_iso_source_fetch_job_get_type (void)
{
	static volatile gsize zoom_buffer_iso_source_fetch_job_type_id__once = 0;
	if (g_once_init_enter (&zoom_buffer_iso_source_fetch_job_type_id__once)) {
		GType zoom_buffer_iso_source_fetch_job_type_id;
		zoom_buffer_iso_source_fetch_job_type_id = zoom_buffer_iso_source_fetch_job_get_type_once ();
		g_once_init_leave (&zoom_buffer_iso_source_fetch_job_type_id__once, zoom_buffer_iso_source_fetch_job_type_id);
	}
	return zoom_buffer_iso_source_fetch_job_type_id__once;
}

static inline gpointer
zoom_buffer_transformation_job_get_instance_private (ZoomBufferTransformationJob* self)
{
	return G_STRUCT_MEMBER_P (self, ZoomBufferTransformationJob_private_offset);
}

static gpointer
_pixel_transformer_ref0 (gpointer self)
{
#line 68 "../src/ZoomBuffer.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 1643 "ZoomBuffer.c"
}

static ZoomBufferTransformationJob*
zoom_buffer_transformation_job_construct (GType object_type,
                                          ZoomBuffer* owner,
                                          GdkPixbuf* to_transform,
                                          PixelTransformer* transformer,
                                          CompletionCallback completion_callback,
                                          gpointer completion_callback_target,
                                          GCancellable* cancellable)
{
	ZoomBufferTransformationJob* self = NULL;
	GCancellable* _tmp0_;
	GdkPixbuf* _tmp1_;
	PixelTransformer* _tmp2_;
	GdkPixbuf* _tmp3_;
#line 62 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 62 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (to_transform != NULL, NULL);
#line 62 "../src/ZoomBuffer.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 64 "../src/ZoomBuffer.vala"
	self = (ZoomBufferTransformationJob*) background_job_construct (object_type, (GObject*) owner, completion_callback, completion_callback_target, cancellable, NULL, NULL, NULL);
#line 66 "../src/ZoomBuffer.vala"
	_tmp0_ = _g_object_ref0 (cancellable);
#line 66 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 66 "../src/ZoomBuffer.vala"
	self->priv->cancellable = _tmp0_;
#line 67 "../src/ZoomBuffer.vala"
	_tmp1_ = _g_object_ref0 (to_transform);
#line 67 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->to_transform);
#line 67 "../src/ZoomBuffer.vala"
	self->priv->to_transform = _tmp1_;
#line 68 "../src/ZoomBuffer.vala"
	_tmp2_ = _pixel_transformer_ref0 (transformer);
#line 68 "../src/ZoomBuffer.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 68 "../src/ZoomBuffer.vala"
	self->priv->transformer = _tmp2_;
#line 69 "../src/ZoomBuffer.vala"
	_tmp3_ = gdk_pixbuf_copy (to_transform);
#line 69 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->transformed);
#line 69 "../src/ZoomBuffer.vala"
	self->transformed = _tmp3_;
#line 62 "../src/ZoomBuffer.vala"
	return self;
#line 1694 "ZoomBuffer.c"
}

static ZoomBufferTransformationJob*
zoom_buffer_transformation_job_new (ZoomBuffer* owner,
                                    GdkPixbuf* to_transform,
                                    PixelTransformer* transformer,
                                    CompletionCallback completion_callback,
                                    gpointer completion_callback_target,
                                    GCancellable* cancellable)
{
#line 62 "../src/ZoomBuffer.vala"
	return zoom_buffer_transformation_job_construct (ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB, owner, to_transform, transformer, completion_callback, completion_callback_target, cancellable);
#line 1707 "ZoomBuffer.c"
}

static void
zoom_buffer_transformation_job_real_execute (BackgroundJob* base)
{
	ZoomBufferTransformationJob * self;
	PixelTransformer* _tmp0_;
#line 72 "../src/ZoomBuffer.vala"
	self = (ZoomBufferTransformationJob*) base;
#line 73 "../src/ZoomBuffer.vala"
	_tmp0_ = self->priv->transformer;
#line 73 "../src/ZoomBuffer.vala"
	if (_tmp0_ != NULL) {
#line 1721 "ZoomBuffer.c"
		PixelTransformer* _tmp1_;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		GCancellable* _tmp4_;
#line 74 "../src/ZoomBuffer.vala"
		_tmp1_ = self->priv->transformer;
#line 74 "../src/ZoomBuffer.vala"
		_tmp2_ = self->priv->to_transform;
#line 74 "../src/ZoomBuffer.vala"
		_tmp3_ = self->transformed;
#line 74 "../src/ZoomBuffer.vala"
		_tmp4_ = self->priv->cancellable;
#line 74 "../src/ZoomBuffer.vala"
		pixel_transformer_transform_to_other_pixbuf (_tmp1_, _tmp2_, _tmp3_, _tmp4_);
#line 1736 "ZoomBuffer.c"
	}
}

static void
zoom_buffer_transformation_job_class_init (ZoomBufferTransformationJobClass * klass,
                                           gpointer klass_data)
{
#line 55 "../src/ZoomBuffer.vala"
	zoom_buffer_transformation_job_parent_class = g_type_class_peek_parent (klass);
#line 55 "../src/ZoomBuffer.vala"
	((BackgroundJobClass *) klass)->finalize = zoom_buffer_transformation_job_finalize;
#line 55 "../src/ZoomBuffer.vala"
	g_type_class_adjust_private_offset (klass, &ZoomBufferTransformationJob_private_offset);
#line 55 "../src/ZoomBuffer.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) zoom_buffer_transformation_job_real_execute;
#line 1752 "ZoomBuffer.c"
}

static void
zoom_buffer_transformation_job_instance_init (ZoomBufferTransformationJob * self,
                                              gpointer klass)
{
#line 55 "../src/ZoomBuffer.vala"
	self->priv = zoom_buffer_transformation_job_get_instance_private (self);
#line 60 "../src/ZoomBuffer.vala"
	self->transformed = NULL;
#line 1763 "ZoomBuffer.c"
}

static void
zoom_buffer_transformation_job_finalize (BackgroundJob * obj)
{
	ZoomBufferTransformationJob * self;
#line 55 "../src/ZoomBuffer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ZOOM_BUFFER_TYPE_TRANSFORMATION_JOB, ZoomBufferTransformationJob);
#line 56 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->to_transform);
#line 57 "../src/ZoomBuffer.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 58 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 60 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->transformed);
#line 55 "../src/ZoomBuffer.vala"
	BACKGROUND_JOB_CLASS (zoom_buffer_transformation_job_parent_class)->finalize (obj);
#line 1782 "ZoomBuffer.c"
}

static GType
zoom_buffer_transformation_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ZoomBufferTransformationJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) zoom_buffer_transformation_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ZoomBufferTransformationJob), 0, (GInstanceInitFunc) zoom_buffer_transformation_job_instance_init, NULL };
	GType zoom_buffer_transformation_job_type_id;
	zoom_buffer_transformation_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "ZoomBufferTransformationJob", &g_define_type_info, 0);
	ZoomBufferTransformationJob_private_offset = g_type_add_instance_private (zoom_buffer_transformation_job_type_id, sizeof (ZoomBufferTransformationJobPrivate));
	return zoom_buffer_transformation_job_type_id;
}

static GType
zoom_buffer_transformation_job_get_type (void)
{
	static volatile gsize zoom_buffer_transformation_job_type_id__once = 0;
	if (g_once_init_enter (&zoom_buffer_transformation_job_type_id__once)) {
		GType zoom_buffer_transformation_job_type_id;
		zoom_buffer_transformation_job_type_id = zoom_buffer_transformation_job_get_type_once ();
		g_once_init_leave (&zoom_buffer_transformation_job_type_id__once, zoom_buffer_transformation_job_type_id);
	}
	return zoom_buffer_transformation_job_type_id__once;
}

static void
zoom_buffer_class_init (ZoomBufferClass * klass,
                        gpointer klass_data)
{
#line 20 "../src/ZoomBuffer.vala"
	zoom_buffer_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/ZoomBuffer.vala"
	g_type_class_adjust_private_offset (klass, &ZoomBuffer_private_offset);
#line 20 "../src/ZoomBuffer.vala"
	G_OBJECT_CLASS (klass)->finalize = zoom_buffer_finalize;
#line 1817 "ZoomBuffer.c"
}

static void
zoom_buffer_instance_init (ZoomBuffer * self,
                           gpointer klass)
{
#line 20 "../src/ZoomBuffer.vala"
	self->priv = zoom_buffer_get_instance_private (self);
#line 82 "../src/ZoomBuffer.vala"
	self->priv->iso_source_image = NULL;
#line 83 "../src/ZoomBuffer.vala"
	self->priv->reduced_source_image = NULL;
#line 84 "../src/ZoomBuffer.vala"
	self->priv->iso_transformed_image = NULL;
#line 85 "../src/ZoomBuffer.vala"
	self->priv->reduced_transformed_image = NULL;
#line 86 "../src/ZoomBuffer.vala"
	self->priv->preview_image = NULL;
#line 87 "../src/ZoomBuffer.vala"
	self->priv->backing_photo = NULL;
#line 88 "../src/ZoomBuffer.vala"
	self->priv->object_state = ZOOM_BUFFER_OBJECT_STATE_SOURCE_NOT_LOADED;
#line 89 "../src/ZoomBuffer.vala"
	self->priv->demand_transform_cached_pixbuf = NULL;
#line 91 "../src/ZoomBuffer.vala"
	self->priv->demand_transform_job = NULL;
#line 93 "../src/ZoomBuffer.vala"
	self->priv->workers = NULL;
#line 95 "../src/ZoomBuffer.vala"
	self->priv->is_interactive_redraw_in_progress = FALSE;
#line 1848 "ZoomBuffer.c"
}

static void
zoom_buffer_finalize (GObject * obj)
{
	ZoomBuffer * self;
#line 20 "../src/ZoomBuffer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ZOOM_BUFFER, ZoomBuffer);
#line 82 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->iso_source_image);
#line 83 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->reduced_source_image);
#line 84 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->iso_transformed_image);
#line 85 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->reduced_transformed_image);
#line 86 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->preview_image);
#line 87 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->backing_photo);
#line 89 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->demand_transform_cached_pixbuf);
#line 91 "../src/ZoomBuffer.vala"
	_background_job_unref0 (self->priv->demand_transform_job);
#line 93 "../src/ZoomBuffer.vala"
	_workers_unref0 (self->priv->workers);
#line 94 "../src/ZoomBuffer.vala"
	_g_object_unref0 (self->priv->parent_page);
#line 20 "../src/ZoomBuffer.vala"
	G_OBJECT_CLASS (zoom_buffer_parent_class)->finalize (obj);
#line 1879 "ZoomBuffer.c"
}

static GType
zoom_buffer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ZoomBufferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) zoom_buffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ZoomBuffer), 0, (GInstanceInitFunc) zoom_buffer_instance_init, NULL };
	GType zoom_buffer_type_id;
	zoom_buffer_type_id = g_type_register_static (G_TYPE_OBJECT, "ZoomBuffer", &g_define_type_info, 0);
	ZoomBuffer_private_offset = g_type_add_instance_private (zoom_buffer_type_id, sizeof (ZoomBufferPrivate));
	return zoom_buffer_type_id;
}

GType
zoom_buffer_get_type (void)
{
	static volatile gsize zoom_buffer_type_id__once = 0;
	if (g_once_init_enter (&zoom_buffer_type_id__once)) {
		GType zoom_buffer_type_id;
		zoom_buffer_type_id = zoom_buffer_get_type_once ();
		g_once_init_leave (&zoom_buffer_type_id__once, zoom_buffer_type_id);
	}
	return zoom_buffer_type_id__once;
}

