/* Alteration.c generated by valac 0.56.18, the Vala compiler
 * generated from Alteration.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* Alteration represents a description of what has changed in the DataObject (reported via the*/
/* "altered" signal).  Since the descriptions can vary wildly depending on the semantics of each*/
/* DataObject, no assumptions or requirements are placed on Alteration other than it must have*/
/* one or more "subjects", each with a "detail".  Subscribers to the "altered" signal can query*/
/* the Alteration object to determine if the change is important to them.*/
/**/
/* Alteration is an immutable type.  This means it's possible to store const Alterations of oft-used*/
/* values for reuse.*/
/**/
/* Alterations may be compressed, merging their subjects and details into a new aggregated*/
/* Alteration.  Generally this is handled automatically by DataObject and DataCollection, when*/
/* necessary.*/
/**/
/* NOTE: subjects and details should be ASCII labels (as in, plain-old ASCII, no code pages).*/
/* They are treated as case-sensitive strings.*/
/**/
/* Recommended subjects include: image, thumbnail, metadata.*/
/**/

#include "io.elementary.photos.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecAlteration ParamSpecAlteration;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _AlterationPrivate {
	gchar* subject;
	gchar* detail;
	GeeMultiMap* map;
};

struct _ParamSpecAlteration {
	GParamSpec parent_instance;
};

static gint Alteration_private_offset;
static gpointer alteration_parent_class = NULL;

static void alteration_add_detail (Alteration* self,
                            const gchar* sub,
                            const gchar* det);
static Alteration* alteration_new_from_map (GeeMultiMap* map);
static Alteration* alteration_construct_from_map (GType object_type,
                                           GeeMultiMap* map);
static GeeMultiMap* alteration_create_map (Alteration* self);
static guint alteration_case_hash (const gchar* a);
static guint _alteration_case_hash_gee_hash_data_func (gconstpointer v,
                                                gpointer self);
static gboolean alteration_case_equal (const gchar* a,
                                const gchar* b);
static gboolean _alteration_case_equal_gee_equal_data_func (gconstpointer a,
                                                     gconstpointer b,
                                                     gpointer self);
static inline gboolean alteration_equal_values (const gchar* str1,
                                  const gchar* str2);
static inline guint alteration_hash_value (const gchar* str);
static void alteration_multimap_add_all (GeeMultiMap* dest,
                                  GeeMultiMap* src);
static void alteration_finalize (Alteration * obj);
static GType alteration_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
alteration_get_instance_private (Alteration* self)
{
	return G_STRUCT_MEMBER_P (self, Alteration_private_offset);
}

Alteration*
alteration_construct (GType object_type,
                      const gchar* subject,
                      const gchar* detail)
{
	Alteration* self = NULL;
#line 45 "../src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 45 "../src/core/Alteration.vala"
	g_return_val_if_fail (detail != NULL, NULL);
#line 45 "../src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 46 "../src/core/Alteration.vala"
	alteration_add_detail (self, subject, detail);
#line 45 "../src/core/Alteration.vala"
	return self;
#line 133 "Alteration.c"
}

Alteration*
alteration_new (const gchar* subject,
                const gchar* detail)
{
#line 45 "../src/core/Alteration.vala"
	return alteration_construct (TYPE_ALTERATION, subject, detail);
#line 142 "Alteration.c"
}

Alteration*
alteration_construct_from_list (GType object_type,
                                const gchar* list)
{
	Alteration* self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar** pairs = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint pairs_length1;
	gint _pairs_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 51 "../src/core/Alteration.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 51 "../src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 51 "../src/core/Alteration.vala"
	_tmp0_ = strlen (list);
#line 51 "../src/core/Alteration.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/core/Alteration.vala"
	_vala_return_val_if_fail (_tmp1_ > 0, "list.length > 0", NULL);
#line 52 "../src/core/Alteration.vala"
	_tmp3_ = _tmp2_ = g_strsplit (list, ",", 0);
#line 52 "../src/core/Alteration.vala"
	pairs = _tmp3_;
#line 52 "../src/core/Alteration.vala"
	pairs_length1 = _vala_array_length (_tmp2_);
#line 52 "../src/core/Alteration.vala"
	_pairs_size_ = pairs_length1;
#line 53 "../src/core/Alteration.vala"
	_tmp4_ = pairs;
#line 53 "../src/core/Alteration.vala"
	_tmp4__length1 = pairs_length1;
#line 53 "../src/core/Alteration.vala"
	_vala_assert (_tmp4__length1 >= 1, "pairs.length >= 1");
#line 55 "../src/core/Alteration.vala"
	_tmp5_ = pairs;
#line 55 "../src/core/Alteration.vala"
	_tmp5__length1 = pairs_length1;
#line 189 "Alteration.c"
	{
		gchar** pair_collection = NULL;
		gint pair_collection_length1 = 0;
		gint _pair_collection_size_ = 0;
		gint pair_it = 0;
#line 55 "../src/core/Alteration.vala"
		pair_collection = _tmp5_;
#line 55 "../src/core/Alteration.vala"
		pair_collection_length1 = _tmp5__length1;
#line 55 "../src/core/Alteration.vala"
		for (pair_it = 0; pair_it < pair_collection_length1; pair_it = pair_it + 1) {
#line 201 "Alteration.c"
			gchar* _tmp6_;
			gchar* pair = NULL;
#line 55 "../src/core/Alteration.vala"
			_tmp6_ = g_strdup (pair_collection[pair_it]);
#line 55 "../src/core/Alteration.vala"
			pair = _tmp6_;
#line 208 "Alteration.c"
			{
				gchar** subject_detail = NULL;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gint subject_detail_length1;
				gint _subject_detail_size_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
#line 56 "../src/core/Alteration.vala"
				_tmp7_ = pair;
#line 56 "../src/core/Alteration.vala"
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, ":", 2);
#line 56 "../src/core/Alteration.vala"
				subject_detail = _tmp9_;
#line 56 "../src/core/Alteration.vala"
				subject_detail_length1 = _vala_array_length (_tmp8_);
#line 56 "../src/core/Alteration.vala"
				_subject_detail_size_ = subject_detail_length1;
#line 57 "../src/core/Alteration.vala"
				_tmp10_ = subject_detail;
#line 57 "../src/core/Alteration.vala"
				_tmp10__length1 = subject_detail_length1;
#line 57 "../src/core/Alteration.vala"
				_vala_assert (_tmp10__length1 == 2, "subject_detail.length == 2");
#line 59 "../src/core/Alteration.vala"
				_tmp11_ = subject_detail;
#line 59 "../src/core/Alteration.vala"
				_tmp11__length1 = subject_detail_length1;
#line 59 "../src/core/Alteration.vala"
				_tmp12_ = _tmp11_[0];
#line 59 "../src/core/Alteration.vala"
				_tmp13_ = subject_detail;
#line 59 "../src/core/Alteration.vala"
				_tmp13__length1 = subject_detail_length1;
#line 59 "../src/core/Alteration.vala"
				_tmp14_ = _tmp13_[1];
#line 59 "../src/core/Alteration.vala"
				alteration_add_detail (self, _tmp12_, _tmp14_);
#line 55 "../src/core/Alteration.vala"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
#line 55 "../src/core/Alteration.vala"
				_g_free0 (pair);
#line 258 "Alteration.c"
			}
		}
	}
#line 51 "../src/core/Alteration.vala"
	pairs = (_vala_array_free (pairs, pairs_length1, (GDestroyNotify) g_free), NULL);
#line 51 "../src/core/Alteration.vala"
	return self;
#line 266 "Alteration.c"
}

Alteration*
alteration_new_from_list (const gchar* list)
{
#line 51 "../src/core/Alteration.vala"
	return alteration_construct_from_list (TYPE_ALTERATION, list);
#line 274 "Alteration.c"
}

Alteration*
alteration_construct_from_array (GType object_type,
                                 gchar** array,
                                 gint array_length1)
{
	Alteration* self = NULL;
#line 65 "../src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 65 "../src/core/Alteration.vala"
	_vala_return_val_if_fail (array_length1 > 0, "array.length > 0", NULL);
#line 287 "Alteration.c"
	{
		gchar** pair_collection = NULL;
		gint pair_collection_length1 = 0;
		gint _pair_collection_size_ = 0;
		gint pair_it = 0;
#line 66 "../src/core/Alteration.vala"
		pair_collection = array;
#line 66 "../src/core/Alteration.vala"
		pair_collection_length1 = array_length1;
#line 66 "../src/core/Alteration.vala"
		for (pair_it = 0; pair_it < pair_collection_length1; pair_it = pair_it + 1) {
#line 299 "Alteration.c"
			gchar* _tmp0_;
			gchar* pair = NULL;
#line 66 "../src/core/Alteration.vala"
			_tmp0_ = g_strdup (pair_collection[pair_it]);
#line 66 "../src/core/Alteration.vala"
			pair = _tmp0_;
#line 306 "Alteration.c"
			{
				gchar** subject_detail = NULL;
				const gchar* _tmp1_;
				gchar** _tmp2_;
				gchar** _tmp3_;
				gint subject_detail_length1;
				gint _subject_detail_size_;
				gchar** _tmp4_;
				gint _tmp4__length1;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
#line 67 "../src/core/Alteration.vala"
				_tmp1_ = pair;
#line 67 "../src/core/Alteration.vala"
				_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ":", 2);
#line 67 "../src/core/Alteration.vala"
				subject_detail = _tmp3_;
#line 67 "../src/core/Alteration.vala"
				subject_detail_length1 = _vala_array_length (_tmp2_);
#line 67 "../src/core/Alteration.vala"
				_subject_detail_size_ = subject_detail_length1;
#line 68 "../src/core/Alteration.vala"
				_tmp4_ = subject_detail;
#line 68 "../src/core/Alteration.vala"
				_tmp4__length1 = subject_detail_length1;
#line 68 "../src/core/Alteration.vala"
				_vala_assert (_tmp4__length1 == 2, "subject_detail.length == 2");
#line 70 "../src/core/Alteration.vala"
				_tmp5_ = subject_detail;
#line 70 "../src/core/Alteration.vala"
				_tmp5__length1 = subject_detail_length1;
#line 70 "../src/core/Alteration.vala"
				_tmp6_ = _tmp5_[0];
#line 70 "../src/core/Alteration.vala"
				_tmp7_ = subject_detail;
#line 70 "../src/core/Alteration.vala"
				_tmp7__length1 = subject_detail_length1;
#line 70 "../src/core/Alteration.vala"
				_tmp8_ = _tmp7_[1];
#line 70 "../src/core/Alteration.vala"
				alteration_add_detail (self, _tmp6_, _tmp8_);
#line 66 "../src/core/Alteration.vala"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/core/Alteration.vala"
				_g_free0 (pair);
#line 356 "Alteration.c"
			}
		}
	}
#line 65 "../src/core/Alteration.vala"
	return self;
#line 362 "Alteration.c"
}

Alteration*
alteration_new_from_array (gchar** array,
                           gint array_length1)
{
#line 65 "../src/core/Alteration.vala"
	return alteration_construct_from_array (TYPE_ALTERATION, array, array_length1);
#line 371 "Alteration.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../src/core/Alteration.vala"
	return self ? g_object_ref (self) : NULL;
#line 379 "Alteration.c"
}

static Alteration*
alteration_construct_from_map (GType object_type,
                               GeeMultiMap* map)
{
	Alteration* self = NULL;
	GeeMultiMap* _tmp0_;
#line 75 "../src/core/Alteration.vala"
	g_return_val_if_fail (map != NULL, NULL);
#line 75 "../src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 76 "../src/core/Alteration.vala"
	_tmp0_ = _g_object_ref0 (map);
#line 76 "../src/core/Alteration.vala"
	_g_object_unref0 (self->priv->map);
#line 76 "../src/core/Alteration.vala"
	self->priv->map = _tmp0_;
#line 75 "../src/core/Alteration.vala"
	return self;
#line 400 "Alteration.c"
}

static Alteration*
alteration_new_from_map (GeeMultiMap* map)
{
#line 75 "../src/core/Alteration.vala"
	return alteration_construct_from_map (TYPE_ALTERATION, map);
#line 408 "Alteration.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 429 "Alteration.c"
}

static void
alteration_add_detail (Alteration* self,
                       const gchar* sub,
                       const gchar* det)
{
	gchar* subject = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* detail = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	GeeMultiMap* _tmp16_;
	const gchar* _tmp18_;
	GeeMultiMap* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
#line 79 "../src/core/Alteration.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/core/Alteration.vala"
	g_return_if_fail (sub != NULL);
#line 79 "../src/core/Alteration.vala"
	g_return_if_fail (det != NULL);
#line 81 "../src/core/Alteration.vala"
	_tmp0_ = string_strip (sub);
#line 81 "../src/core/Alteration.vala"
	subject = _tmp0_;
#line 82 "../src/core/Alteration.vala"
	_tmp1_ = subject;
#line 82 "../src/core/Alteration.vala"
	_tmp2_ = strlen (_tmp1_);
#line 82 "../src/core/Alteration.vala"
	_tmp3_ = _tmp2_;
#line 82 "../src/core/Alteration.vala"
	_vala_assert (_tmp3_ > 0, "subject.length > 0");
#line 84 "../src/core/Alteration.vala"
	_tmp4_ = string_strip (det);
#line 84 "../src/core/Alteration.vala"
	detail = _tmp4_;
#line 85 "../src/core/Alteration.vala"
	_tmp5_ = detail;
#line 85 "../src/core/Alteration.vala"
	_tmp6_ = strlen (_tmp5_);
#line 85 "../src/core/Alteration.vala"
	_tmp7_ = _tmp6_;
#line 85 "../src/core/Alteration.vala"
	_vala_assert (_tmp7_ > 0, "detail.length > 0");
#line 88 "../src/core/Alteration.vala"
	_tmp9_ = self->priv->subject;
#line 88 "../src/core/Alteration.vala"
	if (_tmp9_ == NULL) {
#line 488 "Alteration.c"
		GeeMultiMap* _tmp10_;
#line 88 "../src/core/Alteration.vala"
		_tmp10_ = self->priv->map;
#line 88 "../src/core/Alteration.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 494 "Alteration.c"
	} else {
#line 88 "../src/core/Alteration.vala"
		_tmp8_ = FALSE;
#line 498 "Alteration.c"
	}
#line 88 "../src/core/Alteration.vala"
	if (_tmp8_) {
#line 502 "Alteration.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 89 "../src/core/Alteration.vala"
		_tmp11_ = self->priv->detail;
#line 89 "../src/core/Alteration.vala"
		_vala_assert (_tmp11_ == NULL, "this.detail == null");
#line 91 "../src/core/Alteration.vala"
		_tmp12_ = subject;
#line 91 "../src/core/Alteration.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 91 "../src/core/Alteration.vala"
		_g_free0 (self->priv->subject);
#line 91 "../src/core/Alteration.vala"
		self->priv->subject = _tmp13_;
#line 92 "../src/core/Alteration.vala"
		_tmp14_ = detail;
#line 92 "../src/core/Alteration.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 92 "../src/core/Alteration.vala"
		_g_free0 (self->priv->detail);
#line 92 "../src/core/Alteration.vala"
		self->priv->detail = _tmp15_;
#line 94 "../src/core/Alteration.vala"
		_g_free0 (detail);
#line 94 "../src/core/Alteration.vala"
		_g_free0 (subject);
#line 94 "../src/core/Alteration.vala"
		return;
#line 534 "Alteration.c"
	}
#line 98 "../src/core/Alteration.vala"
	_tmp16_ = self->priv->map;
#line 98 "../src/core/Alteration.vala"
	if (_tmp16_ == NULL) {
#line 540 "Alteration.c"
		GeeMultiMap* _tmp17_;
#line 99 "../src/core/Alteration.vala"
		_tmp17_ = alteration_create_map (self);
#line 99 "../src/core/Alteration.vala"
		_g_object_unref0 (self->priv->map);
#line 99 "../src/core/Alteration.vala"
		self->priv->map = _tmp17_;
#line 548 "Alteration.c"
	}
#line 102 "../src/core/Alteration.vala"
	_tmp18_ = self->priv->subject;
#line 102 "../src/core/Alteration.vala"
	if (_tmp18_ != NULL) {
#line 554 "Alteration.c"
		const gchar* _tmp19_;
		GeeMultiMap* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 103 "../src/core/Alteration.vala"
		_tmp19_ = self->priv->detail;
#line 103 "../src/core/Alteration.vala"
		_vala_assert (_tmp19_ != NULL, "this.detail != null");
#line 105 "../src/core/Alteration.vala"
		_tmp20_ = self->priv->map;
#line 105 "../src/core/Alteration.vala"
		_tmp21_ = self->priv->subject;
#line 105 "../src/core/Alteration.vala"
		_tmp22_ = self->priv->detail;
#line 105 "../src/core/Alteration.vala"
		gee_multi_map_set (_tmp20_, _tmp21_, _tmp22_);
#line 106 "../src/core/Alteration.vala"
		_g_free0 (self->priv->subject);
#line 106 "../src/core/Alteration.vala"
		self->priv->subject = NULL;
#line 107 "../src/core/Alteration.vala"
		_g_free0 (self->priv->detail);
#line 107 "../src/core/Alteration.vala"
		self->priv->detail = NULL;
#line 579 "Alteration.c"
	}
#line 111 "../src/core/Alteration.vala"
	_tmp23_ = self->priv->map;
#line 111 "../src/core/Alteration.vala"
	_tmp24_ = subject;
#line 111 "../src/core/Alteration.vala"
	_tmp25_ = detail;
#line 111 "../src/core/Alteration.vala"
	gee_multi_map_set (_tmp23_, _tmp24_, _tmp25_);
#line 79 "../src/core/Alteration.vala"
	_g_free0 (detail);
#line 79 "../src/core/Alteration.vala"
	_g_free0 (subject);
#line 593 "Alteration.c"
}

static guint
_alteration_case_hash_gee_hash_data_func (gconstpointer v,
                                          gpointer self)
{
	guint result;
	result = alteration_case_hash ((const gchar*) v);
#line 115 "../src/core/Alteration.vala"
	return result;
#line 604 "Alteration.c"
}

static gboolean
_alteration_case_equal_gee_equal_data_func (gconstpointer a,
                                            gconstpointer b,
                                            gpointer self)
{
	gboolean result;
	result = alteration_case_equal ((const gchar*) a, (const gchar*) b);
#line 115 "../src/core/Alteration.vala"
	return result;
#line 616 "Alteration.c"
}

static GeeMultiMap*
alteration_create_map (Alteration* self)
{
	GeeHashMultiMap* _tmp0_;
	GeeMultiMap* result;
#line 114 "../src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../src/core/Alteration.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _alteration_case_hash_gee_hash_data_func, NULL, NULL, _alteration_case_equal_gee_equal_data_func, NULL, NULL, _alteration_case_hash_gee_hash_data_func, NULL, NULL, _alteration_case_equal_gee_equal_data_func, NULL, NULL);
#line 115 "../src/core/Alteration.vala"
	result = (GeeMultiMap*) _tmp0_;
#line 115 "../src/core/Alteration.vala"
	return result;
#line 632 "Alteration.c"
}

static gboolean
alteration_case_equal (const gchar* a,
                       const gchar* b)
{
	gboolean result;
#line 119 "../src/core/Alteration.vala"
	result = alteration_equal_values (a, b);
#line 119 "../src/core/Alteration.vala"
	return result;
#line 644 "Alteration.c"
}

static guint
alteration_case_hash (const gchar* a)
{
	guint result;
#line 123 "../src/core/Alteration.vala"
	result = alteration_hash_value (a);
#line 123 "../src/core/Alteration.vala"
	return result;
#line 655 "Alteration.c"
}

static inline gboolean
alteration_equal_values (const gchar* str1,
                         const gchar* str2)
{
	gboolean result;
#line 126 "../src/core/Alteration.vala"
	g_return_val_if_fail (str1 != NULL, FALSE);
#line 126 "../src/core/Alteration.vala"
	g_return_val_if_fail (str2 != NULL, FALSE);
#line 127 "../src/core/Alteration.vala"
	result = g_ascii_strcasecmp (str1, str2) == 0;
#line 127 "../src/core/Alteration.vala"
	return result;
#line 671 "Alteration.c"
}

static inline guint
alteration_hash_value (const gchar* str)
{
	GHashFunc _tmp0_;
	guint result;
#line 130 "../src/core/Alteration.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 131 "../src/core/Alteration.vala"
	_tmp0_ = g_str_hash;
#line 131 "../src/core/Alteration.vala"
	result = _tmp0_ (str);
#line 131 "../src/core/Alteration.vala"
	return result;
#line 687 "Alteration.c"
}

gboolean
alteration_has_subject (Alteration* self,
                        const gchar* subject)
{
	const gchar* _tmp0_;
	GeeMultiMap* _tmp2_;
	GeeSet* keys = NULL;
	GeeMultiMap* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	gboolean result;
#line 134 "../src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 134 "../src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 135 "../src/core/Alteration.vala"
	_tmp0_ = self->priv->subject;
#line 135 "../src/core/Alteration.vala"
	if (_tmp0_ != NULL) {
#line 709 "Alteration.c"
		const gchar* _tmp1_;
#line 136 "../src/core/Alteration.vala"
		_tmp1_ = self->priv->subject;
#line 136 "../src/core/Alteration.vala"
		result = alteration_equal_values (_tmp1_, subject);
#line 136 "../src/core/Alteration.vala"
		return result;
#line 717 "Alteration.c"
	}
#line 138 "../src/core/Alteration.vala"
	_tmp2_ = self->priv->map;
#line 138 "../src/core/Alteration.vala"
	_vala_assert (_tmp2_ != NULL, "map != null");
#line 139 "../src/core/Alteration.vala"
	_tmp3_ = self->priv->map;
#line 139 "../src/core/Alteration.vala"
	_tmp4_ = gee_multi_map_get_keys (_tmp3_);
#line 139 "../src/core/Alteration.vala"
	keys = _tmp4_;
#line 140 "../src/core/Alteration.vala"
	_tmp5_ = keys;
#line 140 "../src/core/Alteration.vala"
	if (_tmp5_ != NULL) {
#line 733 "Alteration.c"
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp6_;
			GeeIterator* _tmp7_;
#line 141 "../src/core/Alteration.vala"
			_tmp6_ = keys;
#line 141 "../src/core/Alteration.vala"
			_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 141 "../src/core/Alteration.vala"
			_key_it = _tmp7_;
#line 141 "../src/core/Alteration.vala"
			while (TRUE) {
#line 746 "Alteration.c"
				GeeIterator* _tmp8_;
				gchar* key = NULL;
				GeeIterator* _tmp9_;
				gpointer _tmp10_;
				const gchar* _tmp11_;
#line 141 "../src/core/Alteration.vala"
				_tmp8_ = _key_it;
#line 141 "../src/core/Alteration.vala"
				if (!gee_iterator_next (_tmp8_)) {
#line 141 "../src/core/Alteration.vala"
					break;
#line 758 "Alteration.c"
				}
#line 141 "../src/core/Alteration.vala"
				_tmp9_ = _key_it;
#line 141 "../src/core/Alteration.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 141 "../src/core/Alteration.vala"
				key = (gchar*) _tmp10_;
#line 142 "../src/core/Alteration.vala"
				_tmp11_ = key;
#line 142 "../src/core/Alteration.vala"
				if (alteration_equal_values (_tmp11_, subject)) {
#line 143 "../src/core/Alteration.vala"
					result = TRUE;
#line 143 "../src/core/Alteration.vala"
					_g_free0 (key);
#line 143 "../src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 143 "../src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 143 "../src/core/Alteration.vala"
					return result;
#line 780 "Alteration.c"
				}
#line 141 "../src/core/Alteration.vala"
				_g_free0 (key);
#line 784 "Alteration.c"
			}
#line 141 "../src/core/Alteration.vala"
			_g_object_unref0 (_key_it);
#line 788 "Alteration.c"
		}
	}
#line 147 "../src/core/Alteration.vala"
	result = FALSE;
#line 147 "../src/core/Alteration.vala"
	_g_object_unref0 (keys);
#line 147 "../src/core/Alteration.vala"
	return result;
#line 797 "Alteration.c"
}

gboolean
alteration_has_detail (Alteration* self,
                       const gchar* subject,
                       const gchar* detail)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GeeMultiMap* _tmp6_;
	GeeCollection* values = NULL;
	GeeMultiMap* _tmp7_;
	GeeCollection* _tmp8_;
	GeeCollection* _tmp9_;
	gboolean result;
#line 150 "../src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 150 "../src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 150 "../src/core/Alteration.vala"
	g_return_val_if_fail (detail != NULL, FALSE);
#line 151 "../src/core/Alteration.vala"
	_tmp1_ = self->priv->subject;
#line 151 "../src/core/Alteration.vala"
	if (_tmp1_ != NULL) {
#line 823 "Alteration.c"
		const gchar* _tmp2_;
#line 151 "../src/core/Alteration.vala"
		_tmp2_ = self->priv->detail;
#line 151 "../src/core/Alteration.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 829 "Alteration.c"
	} else {
#line 151 "../src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 833 "Alteration.c"
	}
#line 151 "../src/core/Alteration.vala"
	if (_tmp0_) {
#line 837 "Alteration.c"
		gboolean _tmp3_ = FALSE;
		const gchar* _tmp4_;
#line 152 "../src/core/Alteration.vala"
		_tmp4_ = self->priv->subject;
#line 152 "../src/core/Alteration.vala"
		if (alteration_equal_values (_tmp4_, subject)) {
#line 844 "Alteration.c"
			const gchar* _tmp5_;
#line 152 "../src/core/Alteration.vala"
			_tmp5_ = self->priv->detail;
#line 152 "../src/core/Alteration.vala"
			_tmp3_ = alteration_equal_values (_tmp5_, detail);
#line 850 "Alteration.c"
		} else {
#line 152 "../src/core/Alteration.vala"
			_tmp3_ = FALSE;
#line 854 "Alteration.c"
		}
#line 152 "../src/core/Alteration.vala"
		result = _tmp3_;
#line 152 "../src/core/Alteration.vala"
		return result;
#line 860 "Alteration.c"
	}
#line 154 "../src/core/Alteration.vala"
	_tmp6_ = self->priv->map;
#line 154 "../src/core/Alteration.vala"
	_vala_assert (_tmp6_ != NULL, "map != null");
#line 155 "../src/core/Alteration.vala"
	_tmp7_ = self->priv->map;
#line 155 "../src/core/Alteration.vala"
	_tmp8_ = gee_multi_map_get (_tmp7_, subject);
#line 155 "../src/core/Alteration.vala"
	values = _tmp8_;
#line 156 "../src/core/Alteration.vala"
	_tmp9_ = values;
#line 156 "../src/core/Alteration.vala"
	if (_tmp9_ != NULL) {
#line 876 "Alteration.c"
		{
			GeeIterator* _value_it = NULL;
			GeeCollection* _tmp10_;
			GeeIterator* _tmp11_;
#line 157 "../src/core/Alteration.vala"
			_tmp10_ = values;
#line 157 "../src/core/Alteration.vala"
			_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 157 "../src/core/Alteration.vala"
			_value_it = _tmp11_;
#line 157 "../src/core/Alteration.vala"
			while (TRUE) {
#line 889 "Alteration.c"
				GeeIterator* _tmp12_;
				gchar* value = NULL;
				GeeIterator* _tmp13_;
				gpointer _tmp14_;
				const gchar* _tmp15_;
#line 157 "../src/core/Alteration.vala"
				_tmp12_ = _value_it;
#line 157 "../src/core/Alteration.vala"
				if (!gee_iterator_next (_tmp12_)) {
#line 157 "../src/core/Alteration.vala"
					break;
#line 901 "Alteration.c"
				}
#line 157 "../src/core/Alteration.vala"
				_tmp13_ = _value_it;
#line 157 "../src/core/Alteration.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 157 "../src/core/Alteration.vala"
				value = (gchar*) _tmp14_;
#line 158 "../src/core/Alteration.vala"
				_tmp15_ = value;
#line 158 "../src/core/Alteration.vala"
				if (alteration_equal_values (_tmp15_, detail)) {
#line 159 "../src/core/Alteration.vala"
					result = TRUE;
#line 159 "../src/core/Alteration.vala"
					_g_free0 (value);
#line 159 "../src/core/Alteration.vala"
					_g_object_unref0 (_value_it);
#line 159 "../src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 159 "../src/core/Alteration.vala"
					return result;
#line 923 "Alteration.c"
				}
#line 157 "../src/core/Alteration.vala"
				_g_free0 (value);
#line 927 "Alteration.c"
			}
#line 157 "../src/core/Alteration.vala"
			_g_object_unref0 (_value_it);
#line 931 "Alteration.c"
		}
	}
#line 163 "../src/core/Alteration.vala"
	result = FALSE;
#line 163 "../src/core/Alteration.vala"
	_g_object_unref0 (values);
#line 163 "../src/core/Alteration.vala"
	return result;
#line 940 "Alteration.c"
}

GeeCollection*
alteration_get_details (Alteration* self,
                        const gchar* subject)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GeeCollection* _tmp8_ = NULL;
	GeeMultiMap* _tmp9_;
	GeeCollection* result;
#line 166 "../src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 166 "../src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 167 "../src/core/Alteration.vala"
	_tmp2_ = self->priv->subject;
#line 167 "../src/core/Alteration.vala"
	if (_tmp2_ != NULL) {
#line 961 "Alteration.c"
		const gchar* _tmp3_;
#line 167 "../src/core/Alteration.vala"
		_tmp3_ = self->priv->detail;
#line 167 "../src/core/Alteration.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 967 "Alteration.c"
	} else {
#line 167 "../src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 971 "Alteration.c"
	}
#line 167 "../src/core/Alteration.vala"
	if (_tmp1_) {
#line 975 "Alteration.c"
		const gchar* _tmp4_;
#line 167 "../src/core/Alteration.vala"
		_tmp4_ = self->priv->subject;
#line 167 "../src/core/Alteration.vala"
		_tmp0_ = alteration_equal_values (_tmp4_, subject);
#line 981 "Alteration.c"
	} else {
#line 167 "../src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 985 "Alteration.c"
	}
#line 167 "../src/core/Alteration.vala"
	if (_tmp0_) {
#line 989 "Alteration.c"
		GeeArrayList* details = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		const gchar* _tmp7_;
#line 168 "../src/core/Alteration.vala"
		_tmp5_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 168 "../src/core/Alteration.vala"
		details = _tmp5_;
#line 169 "../src/core/Alteration.vala"
		_tmp6_ = details;
#line 169 "../src/core/Alteration.vala"
		_tmp7_ = self->priv->detail;
#line 169 "../src/core/Alteration.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 171 "../src/core/Alteration.vala"
		result = (GeeCollection*) details;
#line 171 "../src/core/Alteration.vala"
		return result;
#line 1008 "Alteration.c"
	}
#line 174 "../src/core/Alteration.vala"
	_tmp9_ = self->priv->map;
#line 174 "../src/core/Alteration.vala"
	if (_tmp9_ != NULL) {
#line 1014 "Alteration.c"
		GeeMultiMap* _tmp10_;
		GeeCollection* _tmp11_;
#line 174 "../src/core/Alteration.vala"
		_tmp10_ = self->priv->map;
#line 174 "../src/core/Alteration.vala"
		_tmp11_ = gee_multi_map_get (_tmp10_, subject);
#line 174 "../src/core/Alteration.vala"
		_g_object_unref0 (_tmp8_);
#line 174 "../src/core/Alteration.vala"
		_tmp8_ = _tmp11_;
#line 1025 "Alteration.c"
	} else {
#line 174 "../src/core/Alteration.vala"
		_g_object_unref0 (_tmp8_);
#line 174 "../src/core/Alteration.vala"
		_tmp8_ = NULL;
#line 1031 "Alteration.c"
	}
#line 174 "../src/core/Alteration.vala"
	result = _tmp8_;
#line 174 "../src/core/Alteration.vala"
	return result;
#line 1037 "Alteration.c"
}

gchar*
alteration_to_string (Alteration* self)
{
	const gchar* _tmp0_;
	GeeMultiMap* _tmp5_;
	gchar* str = NULL;
	gchar* _tmp6_;
	gchar* result;
#line 177 "../src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "../src/core/Alteration.vala"
	_tmp0_ = self->priv->subject;
#line 178 "../src/core/Alteration.vala"
	if (_tmp0_ != NULL) {
#line 1054 "Alteration.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 179 "../src/core/Alteration.vala"
		_tmp1_ = self->priv->detail;
#line 179 "../src/core/Alteration.vala"
		_vala_assert (_tmp1_ != NULL, "detail != null");
#line 181 "../src/core/Alteration.vala"
		_tmp2_ = self->priv->subject;
#line 181 "../src/core/Alteration.vala"
		_tmp3_ = self->priv->detail;
#line 181 "../src/core/Alteration.vala"
		_tmp4_ = g_strdup_printf ("%s:%s", _tmp2_, _tmp3_);
#line 181 "../src/core/Alteration.vala"
		result = _tmp4_;
#line 181 "../src/core/Alteration.vala"
		return result;
#line 1073 "Alteration.c"
	}
#line 184 "../src/core/Alteration.vala"
	_tmp5_ = self->priv->map;
#line 184 "../src/core/Alteration.vala"
	_vala_assert (_tmp5_ != NULL, "map != null");
#line 186 "../src/core/Alteration.vala"
	_tmp6_ = g_strdup ("");
#line 186 "../src/core/Alteration.vala"
	str = _tmp6_;
#line 1083 "Alteration.c"
	{
		GeeIterator* _key_it = NULL;
		GeeMultiMap* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 187 "../src/core/Alteration.vala"
		_tmp7_ = self->priv->map;
#line 187 "../src/core/Alteration.vala"
		_tmp8_ = gee_multi_map_get_keys (_tmp7_);
#line 187 "../src/core/Alteration.vala"
		_tmp9_ = _tmp8_;
#line 187 "../src/core/Alteration.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 187 "../src/core/Alteration.vala"
		_tmp11_ = _tmp10_;
#line 187 "../src/core/Alteration.vala"
		_g_object_unref0 (_tmp9_);
#line 187 "../src/core/Alteration.vala"
		_key_it = _tmp11_;
#line 187 "../src/core/Alteration.vala"
		while (TRUE) {
#line 1107 "Alteration.c"
			GeeIterator* _tmp12_;
			gchar* key = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
#line 187 "../src/core/Alteration.vala"
			_tmp12_ = _key_it;
#line 187 "../src/core/Alteration.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 187 "../src/core/Alteration.vala"
				break;
#line 1118 "Alteration.c"
			}
#line 187 "../src/core/Alteration.vala"
			_tmp13_ = _key_it;
#line 187 "../src/core/Alteration.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 187 "../src/core/Alteration.vala"
			key = (gchar*) _tmp14_;
#line 1126 "Alteration.c"
			{
				GeeIterator* _value_it = NULL;
				GeeMultiMap* _tmp15_;
				const gchar* _tmp16_;
				GeeCollection* _tmp17_;
				GeeCollection* _tmp18_;
				GeeIterator* _tmp19_;
				GeeIterator* _tmp20_;
#line 188 "../src/core/Alteration.vala"
				_tmp15_ = self->priv->map;
#line 188 "../src/core/Alteration.vala"
				_tmp16_ = key;
#line 188 "../src/core/Alteration.vala"
				_tmp17_ = gee_multi_map_get (_tmp15_, _tmp16_);
#line 188 "../src/core/Alteration.vala"
				_tmp18_ = _tmp17_;
#line 188 "../src/core/Alteration.vala"
				_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
#line 188 "../src/core/Alteration.vala"
				_tmp20_ = _tmp19_;
#line 188 "../src/core/Alteration.vala"
				_g_object_unref0 (_tmp18_);
#line 188 "../src/core/Alteration.vala"
				_value_it = _tmp20_;
#line 188 "../src/core/Alteration.vala"
				while (TRUE) {
#line 1153 "Alteration.c"
					GeeIterator* _tmp21_;
					gchar* value = NULL;
					GeeIterator* _tmp22_;
					gpointer _tmp23_;
					const gchar* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 188 "../src/core/Alteration.vala"
					_tmp21_ = _value_it;
#line 188 "../src/core/Alteration.vala"
					if (!gee_iterator_next (_tmp21_)) {
#line 188 "../src/core/Alteration.vala"
						break;
#line 1173 "Alteration.c"
					}
#line 188 "../src/core/Alteration.vala"
					_tmp22_ = _value_it;
#line 188 "../src/core/Alteration.vala"
					_tmp23_ = gee_iterator_get (_tmp22_);
#line 188 "../src/core/Alteration.vala"
					value = (gchar*) _tmp23_;
#line 189 "../src/core/Alteration.vala"
					_tmp24_ = str;
#line 189 "../src/core/Alteration.vala"
					_tmp25_ = strlen (_tmp24_);
#line 189 "../src/core/Alteration.vala"
					_tmp26_ = _tmp25_;
#line 189 "../src/core/Alteration.vala"
					if (_tmp26_ != 0) {
#line 1189 "Alteration.c"
						const gchar* _tmp27_;
						gchar* _tmp28_;
#line 190 "../src/core/Alteration.vala"
						_tmp27_ = str;
#line 190 "../src/core/Alteration.vala"
						_tmp28_ = g_strconcat (_tmp27_, ", ", NULL);
#line 190 "../src/core/Alteration.vala"
						_g_free0 (str);
#line 190 "../src/core/Alteration.vala"
						str = _tmp28_;
#line 1200 "Alteration.c"
					}
#line 192 "../src/core/Alteration.vala"
					_tmp29_ = str;
#line 192 "../src/core/Alteration.vala"
					_tmp30_ = key;
#line 192 "../src/core/Alteration.vala"
					_tmp31_ = value;
#line 192 "../src/core/Alteration.vala"
					_tmp32_ = g_strdup_printf ("%s:%s", _tmp30_, _tmp31_);
#line 192 "../src/core/Alteration.vala"
					_tmp33_ = _tmp32_;
#line 192 "../src/core/Alteration.vala"
					_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 192 "../src/core/Alteration.vala"
					_g_free0 (str);
#line 192 "../src/core/Alteration.vala"
					str = _tmp34_;
#line 192 "../src/core/Alteration.vala"
					_g_free0 (_tmp33_);
#line 188 "../src/core/Alteration.vala"
					_g_free0 (value);
#line 1222 "Alteration.c"
				}
#line 188 "../src/core/Alteration.vala"
				_g_object_unref0 (_value_it);
#line 1226 "Alteration.c"
			}
#line 187 "../src/core/Alteration.vala"
			_g_free0 (key);
#line 1230 "Alteration.c"
		}
#line 187 "../src/core/Alteration.vala"
		_g_object_unref0 (_key_it);
#line 1234 "Alteration.c"
	}
#line 196 "../src/core/Alteration.vala"
	result = str;
#line 196 "../src/core/Alteration.vala"
	return result;
#line 1240 "Alteration.c"
}

gboolean
alteration_contains_any (Alteration* self,
                         Alteration* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	GeeMultiMap* _tmp14_;
	gboolean _tmp42_ = FALSE;
	GeeMultiMap* _tmp43_;
	gboolean result;
#line 200 "../src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 200 "../src/core/Alteration.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 202 "../src/core/Alteration.vala"
	if (self == other) {
#line 203 "../src/core/Alteration.vala"
		result = TRUE;
#line 203 "../src/core/Alteration.vala"
		return result;
#line 1267 "Alteration.c"
	}
#line 206 "../src/core/Alteration.vala"
	_tmp3_ = self->priv->subject;
#line 206 "../src/core/Alteration.vala"
	if (_tmp3_ != NULL) {
#line 1273 "Alteration.c"
		const gchar* _tmp4_;
#line 206 "../src/core/Alteration.vala"
		_tmp4_ = other->priv->subject;
#line 206 "../src/core/Alteration.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 1279 "Alteration.c"
	} else {
#line 206 "../src/core/Alteration.vala"
		_tmp2_ = FALSE;
#line 1283 "Alteration.c"
	}
#line 206 "../src/core/Alteration.vala"
	if (_tmp2_) {
#line 1287 "Alteration.c"
		const gchar* _tmp5_;
#line 206 "../src/core/Alteration.vala"
		_tmp5_ = self->priv->detail;
#line 206 "../src/core/Alteration.vala"
		_tmp1_ = _tmp5_ != NULL;
#line 1293 "Alteration.c"
	} else {
#line 206 "../src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 1297 "Alteration.c"
	}
#line 206 "../src/core/Alteration.vala"
	if (_tmp1_) {
#line 1301 "Alteration.c"
		const gchar* _tmp6_;
#line 206 "../src/core/Alteration.vala"
		_tmp6_ = other->priv->detail;
#line 206 "../src/core/Alteration.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 1307 "Alteration.c"
	} else {
#line 206 "../src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 1311 "Alteration.c"
	}
#line 206 "../src/core/Alteration.vala"
	if (_tmp0_) {
#line 1315 "Alteration.c"
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 207 "../src/core/Alteration.vala"
		_tmp8_ = self->priv->subject;
#line 207 "../src/core/Alteration.vala"
		_tmp9_ = other->priv->subject;
#line 207 "../src/core/Alteration.vala"
		if (alteration_equal_values (_tmp8_, _tmp9_)) {
#line 1325 "Alteration.c"
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 207 "../src/core/Alteration.vala"
			_tmp10_ = self->priv->detail;
#line 207 "../src/core/Alteration.vala"
			_tmp11_ = other->priv->detail;
#line 207 "../src/core/Alteration.vala"
			_tmp7_ = alteration_equal_values (_tmp10_, _tmp11_);
#line 1334 "Alteration.c"
		} else {
#line 207 "../src/core/Alteration.vala"
			_tmp7_ = FALSE;
#line 1338 "Alteration.c"
		}
#line 207 "../src/core/Alteration.vala"
		result = _tmp7_;
#line 207 "../src/core/Alteration.vala"
		return result;
#line 1344 "Alteration.c"
	}
#line 210 "../src/core/Alteration.vala"
	_tmp14_ = self->priv->map;
#line 210 "../src/core/Alteration.vala"
	if (_tmp14_ != NULL) {
#line 1350 "Alteration.c"
		GeeMultiMap* _tmp15_;
#line 210 "../src/core/Alteration.vala"
		_tmp15_ = other->priv->map;
#line 210 "../src/core/Alteration.vala"
		_tmp13_ = _tmp15_ == NULL;
#line 1356 "Alteration.c"
	} else {
#line 210 "../src/core/Alteration.vala"
		_tmp13_ = FALSE;
#line 1360 "Alteration.c"
	}
#line 210 "../src/core/Alteration.vala"
	if (_tmp13_) {
#line 210 "../src/core/Alteration.vala"
		_tmp12_ = TRUE;
#line 1366 "Alteration.c"
	} else {
		gboolean _tmp16_ = FALSE;
		GeeMultiMap* _tmp17_;
#line 210 "../src/core/Alteration.vala"
		_tmp17_ = self->priv->map;
#line 210 "../src/core/Alteration.vala"
		if (_tmp17_ == NULL) {
#line 1374 "Alteration.c"
			GeeMultiMap* _tmp18_;
#line 210 "../src/core/Alteration.vala"
			_tmp18_ = other->priv->map;
#line 210 "../src/core/Alteration.vala"
			_tmp16_ = _tmp18_ != NULL;
#line 1380 "Alteration.c"
		} else {
#line 210 "../src/core/Alteration.vala"
			_tmp16_ = FALSE;
#line 1384 "Alteration.c"
		}
#line 210 "../src/core/Alteration.vala"
		_tmp12_ = _tmp16_;
#line 1388 "Alteration.c"
	}
#line 210 "../src/core/Alteration.vala"
	if (_tmp12_) {
#line 1392 "Alteration.c"
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		gchar* single_subject = NULL;
		gchar* _tmp23_;
		const gchar* _tmp24_ = NULL;
		const gchar* _tmp25_;
		gchar* single_detail = NULL;
		gchar* _tmp28_;
		GeeMultiMap* _tmp29_ = NULL;
		GeeMultiMap* _tmp30_;
		GeeMultiMap* multimap = NULL;
		GeeMultiMap* _tmp33_;
		gboolean _tmp34_ = FALSE;
		GeeMultiMap* _tmp35_;
		const gchar* _tmp36_;
#line 211 "../src/core/Alteration.vala"
		_tmp20_ = self->priv->subject;
#line 211 "../src/core/Alteration.vala"
		if (_tmp20_ != NULL) {
#line 1412 "Alteration.c"
			const gchar* _tmp21_;
#line 211 "../src/core/Alteration.vala"
			_tmp21_ = self->priv->subject;
#line 211 "../src/core/Alteration.vala"
			_tmp19_ = _tmp21_;
#line 1418 "Alteration.c"
		} else {
			const gchar* _tmp22_;
#line 211 "../src/core/Alteration.vala"
			_tmp22_ = other->priv->subject;
#line 211 "../src/core/Alteration.vala"
			_tmp19_ = _tmp22_;
#line 1425 "Alteration.c"
		}
#line 211 "../src/core/Alteration.vala"
		_tmp23_ = g_strdup (_tmp19_);
#line 211 "../src/core/Alteration.vala"
		single_subject = _tmp23_;
#line 212 "../src/core/Alteration.vala"
		_tmp25_ = self->priv->detail;
#line 212 "../src/core/Alteration.vala"
		if (_tmp25_ != NULL) {
#line 1435 "Alteration.c"
			const gchar* _tmp26_;
#line 212 "../src/core/Alteration.vala"
			_tmp26_ = self->priv->detail;
#line 212 "../src/core/Alteration.vala"
			_tmp24_ = _tmp26_;
#line 1441 "Alteration.c"
		} else {
			const gchar* _tmp27_;
#line 212 "../src/core/Alteration.vala"
			_tmp27_ = other->priv->detail;
#line 212 "../src/core/Alteration.vala"
			_tmp24_ = _tmp27_;
#line 1448 "Alteration.c"
		}
#line 212 "../src/core/Alteration.vala"
		_tmp28_ = g_strdup (_tmp24_);
#line 212 "../src/core/Alteration.vala"
		single_detail = _tmp28_;
#line 213 "../src/core/Alteration.vala"
		_tmp30_ = self->priv->map;
#line 213 "../src/core/Alteration.vala"
		if (_tmp30_ != NULL) {
#line 1458 "Alteration.c"
			GeeMultiMap* _tmp31_;
#line 213 "../src/core/Alteration.vala"
			_tmp31_ = self->priv->map;
#line 213 "../src/core/Alteration.vala"
			_tmp29_ = _tmp31_;
#line 1464 "Alteration.c"
		} else {
			GeeMultiMap* _tmp32_;
#line 213 "../src/core/Alteration.vala"
			_tmp32_ = other->priv->map;
#line 213 "../src/core/Alteration.vala"
			_tmp29_ = _tmp32_;
#line 1471 "Alteration.c"
		}
#line 213 "../src/core/Alteration.vala"
		_tmp33_ = _g_object_ref0 (_tmp29_);
#line 213 "../src/core/Alteration.vala"
		multimap = _tmp33_;
#line 215 "../src/core/Alteration.vala"
		_tmp35_ = multimap;
#line 215 "../src/core/Alteration.vala"
		_tmp36_ = single_subject;
#line 215 "../src/core/Alteration.vala"
		if (gee_multi_map_contains (_tmp35_, _tmp36_)) {
#line 1483 "Alteration.c"
			GeeMultiMap* _tmp37_;
			const gchar* _tmp38_;
			GeeCollection* _tmp39_;
			GeeCollection* _tmp40_;
			const gchar* _tmp41_;
#line 215 "../src/core/Alteration.vala"
			_tmp37_ = self->priv->map;
#line 215 "../src/core/Alteration.vala"
			_tmp38_ = single_subject;
#line 215 "../src/core/Alteration.vala"
			_tmp39_ = gee_multi_map_get (_tmp37_, _tmp38_);
#line 215 "../src/core/Alteration.vala"
			_tmp40_ = _tmp39_;
#line 215 "../src/core/Alteration.vala"
			_tmp41_ = single_detail;
#line 215 "../src/core/Alteration.vala"
			_tmp34_ = gee_collection_contains (_tmp40_, _tmp41_);
#line 215 "../src/core/Alteration.vala"
			_g_object_unref0 (_tmp40_);
#line 1503 "Alteration.c"
		} else {
#line 215 "../src/core/Alteration.vala"
			_tmp34_ = FALSE;
#line 1507 "Alteration.c"
		}
#line 215 "../src/core/Alteration.vala"
		result = _tmp34_;
#line 215 "../src/core/Alteration.vala"
		_g_object_unref0 (multimap);
#line 215 "../src/core/Alteration.vala"
		_g_free0 (single_detail);
#line 215 "../src/core/Alteration.vala"
		_g_free0 (single_subject);
#line 215 "../src/core/Alteration.vala"
		return result;
#line 1519 "Alteration.c"
	}
#line 219 "../src/core/Alteration.vala"
	_tmp43_ = self->priv->map;
#line 219 "../src/core/Alteration.vala"
	if (_tmp43_ != NULL) {
#line 1525 "Alteration.c"
		GeeMultiMap* _tmp44_;
#line 219 "../src/core/Alteration.vala"
		_tmp44_ = other->priv->map;
#line 219 "../src/core/Alteration.vala"
		_tmp42_ = _tmp44_ != NULL;
#line 1531 "Alteration.c"
	} else {
#line 219 "../src/core/Alteration.vala"
		_tmp42_ = FALSE;
#line 1535 "Alteration.c"
	}
#line 219 "../src/core/Alteration.vala"
	if (_tmp42_) {
#line 1539 "Alteration.c"
		GeeSet* keys = NULL;
		GeeMultiMap* _tmp45_;
		GeeSet* _tmp46_;
		GeeSet* _tmp47_;
		GeeSet* other_keys = NULL;
		GeeMultiMap* _tmp48_;
		GeeSet* _tmp49_;
		GeeSet* _tmp50_;
#line 220 "../src/core/Alteration.vala"
		_tmp45_ = self->priv->map;
#line 220 "../src/core/Alteration.vala"
		_tmp46_ = gee_multi_map_get_keys (_tmp45_);
#line 220 "../src/core/Alteration.vala"
		keys = _tmp46_;
#line 221 "../src/core/Alteration.vala"
		_tmp47_ = keys;
#line 221 "../src/core/Alteration.vala"
		_vala_assert (_tmp47_ != NULL, "keys != null");
#line 222 "../src/core/Alteration.vala"
		_tmp48_ = other->priv->map;
#line 222 "../src/core/Alteration.vala"
		_tmp49_ = gee_multi_map_get_keys (_tmp48_);
#line 222 "../src/core/Alteration.vala"
		other_keys = _tmp49_;
#line 223 "../src/core/Alteration.vala"
		_tmp50_ = other_keys;
#line 223 "../src/core/Alteration.vala"
		_vala_assert (_tmp50_ != NULL, "other_keys != null");
#line 1568 "Alteration.c"
		{
			GeeIterator* _subject_it = NULL;
			GeeSet* _tmp51_;
			GeeIterator* _tmp52_;
#line 225 "../src/core/Alteration.vala"
			_tmp51_ = other_keys;
#line 225 "../src/core/Alteration.vala"
			_tmp52_ = gee_iterable_iterator ((GeeIterable*) _tmp51_);
#line 225 "../src/core/Alteration.vala"
			_subject_it = _tmp52_;
#line 225 "../src/core/Alteration.vala"
			while (TRUE) {
#line 1581 "Alteration.c"
				GeeIterator* _tmp53_;
				gchar* subject = NULL;
				GeeIterator* _tmp54_;
				gpointer _tmp55_;
				GeeSet* _tmp56_;
				const gchar* _tmp57_;
				GeeCollection* details = NULL;
				GeeMultiMap* _tmp58_;
				const gchar* _tmp59_;
				GeeCollection* _tmp60_;
				GeeCollection* other_details = NULL;
				GeeMultiMap* _tmp61_;
				const gchar* _tmp62_;
				GeeCollection* _tmp63_;
				gboolean _tmp64_ = FALSE;
				GeeCollection* _tmp65_;
#line 225 "../src/core/Alteration.vala"
				_tmp53_ = _subject_it;
#line 225 "../src/core/Alteration.vala"
				if (!gee_iterator_next (_tmp53_)) {
#line 225 "../src/core/Alteration.vala"
					break;
#line 1604 "Alteration.c"
				}
#line 225 "../src/core/Alteration.vala"
				_tmp54_ = _subject_it;
#line 225 "../src/core/Alteration.vala"
				_tmp55_ = gee_iterator_get (_tmp54_);
#line 225 "../src/core/Alteration.vala"
				subject = (gchar*) _tmp55_;
#line 226 "../src/core/Alteration.vala"
				_tmp56_ = keys;
#line 226 "../src/core/Alteration.vala"
				_tmp57_ = subject;
#line 226 "../src/core/Alteration.vala"
				if (!gee_collection_contains ((GeeCollection*) _tmp56_, _tmp57_)) {
#line 227 "../src/core/Alteration.vala"
					_g_free0 (subject);
#line 227 "../src/core/Alteration.vala"
					continue;
#line 1622 "Alteration.c"
				}
#line 229 "../src/core/Alteration.vala"
				_tmp58_ = self->priv->map;
#line 229 "../src/core/Alteration.vala"
				_tmp59_ = subject;
#line 229 "../src/core/Alteration.vala"
				_tmp60_ = gee_multi_map_get (_tmp58_, _tmp59_);
#line 229 "../src/core/Alteration.vala"
				details = _tmp60_;
#line 230 "../src/core/Alteration.vala"
				_tmp61_ = other->priv->map;
#line 230 "../src/core/Alteration.vala"
				_tmp62_ = subject;
#line 230 "../src/core/Alteration.vala"
				_tmp63_ = gee_multi_map_get (_tmp61_, _tmp62_);
#line 230 "../src/core/Alteration.vala"
				other_details = _tmp63_;
#line 232 "../src/core/Alteration.vala"
				_tmp65_ = details;
#line 232 "../src/core/Alteration.vala"
				if (_tmp65_ != NULL) {
#line 1644 "Alteration.c"
					GeeCollection* _tmp66_;
#line 232 "../src/core/Alteration.vala"
					_tmp66_ = other_details;
#line 232 "../src/core/Alteration.vala"
					_tmp64_ = _tmp66_ != NULL;
#line 1650 "Alteration.c"
				} else {
#line 232 "../src/core/Alteration.vala"
					_tmp64_ = FALSE;
#line 1654 "Alteration.c"
				}
#line 232 "../src/core/Alteration.vala"
				if (_tmp64_) {
#line 1658 "Alteration.c"
					{
						GeeIterator* _detail_it = NULL;
						GeeCollection* _tmp67_;
						GeeIterator* _tmp68_;
#line 233 "../src/core/Alteration.vala"
						_tmp67_ = other_details;
#line 233 "../src/core/Alteration.vala"
						_tmp68_ = gee_iterable_iterator ((GeeIterable*) _tmp67_);
#line 233 "../src/core/Alteration.vala"
						_detail_it = _tmp68_;
#line 233 "../src/core/Alteration.vala"
						while (TRUE) {
#line 1671 "Alteration.c"
							GeeIterator* _tmp69_;
							gchar* detail = NULL;
							GeeIterator* _tmp70_;
							gpointer _tmp71_;
							GeeCollection* _tmp72_;
							const gchar* _tmp73_;
#line 233 "../src/core/Alteration.vala"
							_tmp69_ = _detail_it;
#line 233 "../src/core/Alteration.vala"
							if (!gee_iterator_next (_tmp69_)) {
#line 233 "../src/core/Alteration.vala"
								break;
#line 1684 "Alteration.c"
							}
#line 233 "../src/core/Alteration.vala"
							_tmp70_ = _detail_it;
#line 233 "../src/core/Alteration.vala"
							_tmp71_ = gee_iterator_get (_tmp70_);
#line 233 "../src/core/Alteration.vala"
							detail = (gchar*) _tmp71_;
#line 234 "../src/core/Alteration.vala"
							_tmp72_ = details;
#line 234 "../src/core/Alteration.vala"
							_tmp73_ = detail;
#line 234 "../src/core/Alteration.vala"
							if (gee_collection_contains (_tmp72_, _tmp73_)) {
#line 235 "../src/core/Alteration.vala"
								result = TRUE;
#line 235 "../src/core/Alteration.vala"
								_g_free0 (detail);
#line 235 "../src/core/Alteration.vala"
								_g_object_unref0 (_detail_it);
#line 235 "../src/core/Alteration.vala"
								_g_object_unref0 (other_details);
#line 235 "../src/core/Alteration.vala"
								_g_object_unref0 (details);
#line 235 "../src/core/Alteration.vala"
								_g_free0 (subject);
#line 235 "../src/core/Alteration.vala"
								_g_object_unref0 (_subject_it);
#line 235 "../src/core/Alteration.vala"
								_g_object_unref0 (other_keys);
#line 235 "../src/core/Alteration.vala"
								_g_object_unref0 (keys);
#line 235 "../src/core/Alteration.vala"
								return result;
#line 1718 "Alteration.c"
							}
#line 233 "../src/core/Alteration.vala"
							_g_free0 (detail);
#line 1722 "Alteration.c"
						}
#line 233 "../src/core/Alteration.vala"
						_g_object_unref0 (_detail_it);
#line 1726 "Alteration.c"
					}
				}
#line 225 "../src/core/Alteration.vala"
				_g_object_unref0 (other_details);
#line 225 "../src/core/Alteration.vala"
				_g_object_unref0 (details);
#line 225 "../src/core/Alteration.vala"
				_g_free0 (subject);
#line 1735 "Alteration.c"
			}
#line 225 "../src/core/Alteration.vala"
			_g_object_unref0 (_subject_it);
#line 1739 "Alteration.c"
		}
#line 219 "../src/core/Alteration.vala"
		_g_object_unref0 (other_keys);
#line 219 "../src/core/Alteration.vala"
		_g_object_unref0 (keys);
#line 1745 "Alteration.c"
	}
#line 241 "../src/core/Alteration.vala"
	result = FALSE;
#line 241 "../src/core/Alteration.vala"
	return result;
#line 1751 "Alteration.c"
}

gboolean
alteration_equals (Alteration* self,
                   Alteration* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp12_ = FALSE;
	GeeMultiMap* _tmp13_;
	gboolean result;
#line 244 "../src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 244 "../src/core/Alteration.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 246 "../src/core/Alteration.vala"
	if (self == other) {
#line 247 "../src/core/Alteration.vala"
		result = TRUE;
#line 247 "../src/core/Alteration.vala"
		return result;
#line 1775 "Alteration.c"
	}
#line 250 "../src/core/Alteration.vala"
	_tmp3_ = self->priv->subject;
#line 250 "../src/core/Alteration.vala"
	if (_tmp3_ != NULL) {
#line 1781 "Alteration.c"
		const gchar* _tmp4_;
#line 250 "../src/core/Alteration.vala"
		_tmp4_ = other->priv->subject;
#line 250 "../src/core/Alteration.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 1787 "Alteration.c"
	} else {
#line 250 "../src/core/Alteration.vala"
		_tmp2_ = FALSE;
#line 1791 "Alteration.c"
	}
#line 250 "../src/core/Alteration.vala"
	if (_tmp2_) {
#line 1795 "Alteration.c"
		const gchar* _tmp5_;
#line 250 "../src/core/Alteration.vala"
		_tmp5_ = self->priv->detail;
#line 250 "../src/core/Alteration.vala"
		_tmp1_ = _tmp5_ != NULL;
#line 1801 "Alteration.c"
	} else {
#line 250 "../src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 1805 "Alteration.c"
	}
#line 250 "../src/core/Alteration.vala"
	if (_tmp1_) {
#line 1809 "Alteration.c"
		const gchar* _tmp6_;
#line 250 "../src/core/Alteration.vala"
		_tmp6_ = other->priv->detail;
#line 250 "../src/core/Alteration.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 1815 "Alteration.c"
	} else {
#line 250 "../src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 1819 "Alteration.c"
	}
#line 250 "../src/core/Alteration.vala"
	if (_tmp0_) {
#line 1823 "Alteration.c"
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 251 "../src/core/Alteration.vala"
		_tmp8_ = self->priv->subject;
#line 251 "../src/core/Alteration.vala"
		_tmp9_ = other->priv->subject;
#line 251 "../src/core/Alteration.vala"
		if (alteration_equal_values (_tmp8_, _tmp9_)) {
#line 1833 "Alteration.c"
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 251 "../src/core/Alteration.vala"
			_tmp10_ = self->priv->detail;
#line 251 "../src/core/Alteration.vala"
			_tmp11_ = other->priv->detail;
#line 251 "../src/core/Alteration.vala"
			_tmp7_ = alteration_equal_values (_tmp10_, _tmp11_);
#line 1842 "Alteration.c"
		} else {
#line 251 "../src/core/Alteration.vala"
			_tmp7_ = FALSE;
#line 1846 "Alteration.c"
		}
#line 251 "../src/core/Alteration.vala"
		result = _tmp7_;
#line 251 "../src/core/Alteration.vala"
		return result;
#line 1852 "Alteration.c"
	}
#line 254 "../src/core/Alteration.vala"
	_tmp13_ = self->priv->map;
#line 254 "../src/core/Alteration.vala"
	if (_tmp13_ != NULL) {
#line 1858 "Alteration.c"
		GeeMultiMap* _tmp14_;
#line 254 "../src/core/Alteration.vala"
		_tmp14_ = other->priv->map;
#line 254 "../src/core/Alteration.vala"
		_tmp12_ = _tmp14_ != NULL;
#line 1864 "Alteration.c"
	} else {
#line 254 "../src/core/Alteration.vala"
		_tmp12_ = FALSE;
#line 1868 "Alteration.c"
	}
#line 254 "../src/core/Alteration.vala"
	if (_tmp12_) {
#line 1872 "Alteration.c"
		GeeSet* keys = NULL;
		GeeMultiMap* _tmp15_;
		GeeSet* _tmp16_;
		GeeSet* _tmp17_;
		GeeSet* other_keys = NULL;
		GeeMultiMap* _tmp18_;
		GeeSet* _tmp19_;
		GeeSet* _tmp20_;
		GeeSet* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		GeeSet* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		GeeSet* _tmp27_;
		GeeSet* _tmp28_;
		GeeSet* _tmp29_;
		GeeSet* _tmp30_;
#line 256 "../src/core/Alteration.vala"
		_tmp15_ = self->priv->map;
#line 256 "../src/core/Alteration.vala"
		_tmp16_ = gee_multi_map_get_keys (_tmp15_);
#line 256 "../src/core/Alteration.vala"
		keys = _tmp16_;
#line 257 "../src/core/Alteration.vala"
		_tmp17_ = keys;
#line 257 "../src/core/Alteration.vala"
		_vala_assert (_tmp17_ != NULL, "keys != null");
#line 258 "../src/core/Alteration.vala"
		_tmp18_ = other->priv->map;
#line 258 "../src/core/Alteration.vala"
		_tmp19_ = gee_multi_map_get_keys (_tmp18_);
#line 258 "../src/core/Alteration.vala"
		other_keys = _tmp19_;
#line 259 "../src/core/Alteration.vala"
		_tmp20_ = other_keys;
#line 259 "../src/core/Alteration.vala"
		_vala_assert (_tmp20_ != NULL, "other_keys != null");
#line 261 "../src/core/Alteration.vala"
		_tmp21_ = keys;
#line 261 "../src/core/Alteration.vala"
		_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
#line 261 "../src/core/Alteration.vala"
		_tmp23_ = _tmp22_;
#line 261 "../src/core/Alteration.vala"
		_tmp24_ = other_keys;
#line 261 "../src/core/Alteration.vala"
		_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
#line 261 "../src/core/Alteration.vala"
		_tmp26_ = _tmp25_;
#line 261 "../src/core/Alteration.vala"
		if (_tmp23_ != _tmp26_) {
#line 262 "../src/core/Alteration.vala"
			result = FALSE;
#line 262 "../src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 262 "../src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 262 "../src/core/Alteration.vala"
			return result;
#line 1933 "Alteration.c"
		}
#line 264 "../src/core/Alteration.vala"
		_tmp27_ = keys;
#line 264 "../src/core/Alteration.vala"
		_tmp28_ = other_keys;
#line 264 "../src/core/Alteration.vala"
		if (!gee_collection_contains_all ((GeeCollection*) _tmp27_, (GeeCollection*) _tmp28_)) {
#line 265 "../src/core/Alteration.vala"
			result = FALSE;
#line 265 "../src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 265 "../src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 265 "../src/core/Alteration.vala"
			return result;
#line 1949 "Alteration.c"
		}
#line 267 "../src/core/Alteration.vala"
		_tmp29_ = other_keys;
#line 267 "../src/core/Alteration.vala"
		_tmp30_ = keys;
#line 267 "../src/core/Alteration.vala"
		if (!gee_collection_contains_all ((GeeCollection*) _tmp29_, (GeeCollection*) _tmp30_)) {
#line 268 "../src/core/Alteration.vala"
			result = FALSE;
#line 268 "../src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 268 "../src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 268 "../src/core/Alteration.vala"
			return result;
#line 1965 "Alteration.c"
		}
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp31_;
			GeeIterator* _tmp32_;
#line 270 "../src/core/Alteration.vala"
			_tmp31_ = keys;
#line 270 "../src/core/Alteration.vala"
			_tmp32_ = gee_iterable_iterator ((GeeIterable*) _tmp31_);
#line 270 "../src/core/Alteration.vala"
			_key_it = _tmp32_;
#line 270 "../src/core/Alteration.vala"
			while (TRUE) {
#line 1979 "Alteration.c"
				GeeIterator* _tmp33_;
				gchar* key = NULL;
				GeeIterator* _tmp34_;
				gpointer _tmp35_;
				GeeCollection* values = NULL;
				GeeMultiMap* _tmp36_;
				const gchar* _tmp37_;
				GeeCollection* _tmp38_;
				GeeCollection* other_values = NULL;
				GeeMultiMap* _tmp39_;
				const gchar* _tmp40_;
				GeeCollection* _tmp41_;
				GeeCollection* _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				GeeCollection* _tmp45_;
				gint _tmp46_;
				gint _tmp47_;
				GeeCollection* _tmp48_;
				GeeCollection* _tmp49_;
				GeeCollection* _tmp50_;
				GeeCollection* _tmp51_;
#line 270 "../src/core/Alteration.vala"
				_tmp33_ = _key_it;
#line 270 "../src/core/Alteration.vala"
				if (!gee_iterator_next (_tmp33_)) {
#line 270 "../src/core/Alteration.vala"
					break;
#line 2008 "Alteration.c"
				}
#line 270 "../src/core/Alteration.vala"
				_tmp34_ = _key_it;
#line 270 "../src/core/Alteration.vala"
				_tmp35_ = gee_iterator_get (_tmp34_);
#line 270 "../src/core/Alteration.vala"
				key = (gchar*) _tmp35_;
#line 271 "../src/core/Alteration.vala"
				_tmp36_ = self->priv->map;
#line 271 "../src/core/Alteration.vala"
				_tmp37_ = key;
#line 271 "../src/core/Alteration.vala"
				_tmp38_ = gee_multi_map_get (_tmp36_, _tmp37_);
#line 271 "../src/core/Alteration.vala"
				values = _tmp38_;
#line 272 "../src/core/Alteration.vala"
				_tmp39_ = other->priv->map;
#line 272 "../src/core/Alteration.vala"
				_tmp40_ = key;
#line 272 "../src/core/Alteration.vala"
				_tmp41_ = gee_multi_map_get (_tmp39_, _tmp40_);
#line 272 "../src/core/Alteration.vala"
				other_values = _tmp41_;
#line 274 "../src/core/Alteration.vala"
				_tmp42_ = values;
#line 274 "../src/core/Alteration.vala"
				_tmp43_ = gee_collection_get_size (_tmp42_);
#line 274 "../src/core/Alteration.vala"
				_tmp44_ = _tmp43_;
#line 274 "../src/core/Alteration.vala"
				_tmp45_ = other_values;
#line 274 "../src/core/Alteration.vala"
				_tmp46_ = gee_collection_get_size (_tmp45_);
#line 274 "../src/core/Alteration.vala"
				_tmp47_ = _tmp46_;
#line 274 "../src/core/Alteration.vala"
				if (_tmp44_ != _tmp47_) {
#line 275 "../src/core/Alteration.vala"
					result = FALSE;
#line 275 "../src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 275 "../src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 275 "../src/core/Alteration.vala"
					_g_free0 (key);
#line 275 "../src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 275 "../src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 275 "../src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 275 "../src/core/Alteration.vala"
					return result;
#line 2062 "Alteration.c"
				}
#line 277 "../src/core/Alteration.vala"
				_tmp48_ = values;
#line 277 "../src/core/Alteration.vala"
				_tmp49_ = other_values;
#line 277 "../src/core/Alteration.vala"
				if (!gee_collection_contains_all (_tmp48_, _tmp49_)) {
#line 278 "../src/core/Alteration.vala"
					result = FALSE;
#line 278 "../src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 278 "../src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 278 "../src/core/Alteration.vala"
					_g_free0 (key);
#line 278 "../src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 278 "../src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 278 "../src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 278 "../src/core/Alteration.vala"
					return result;
#line 2086 "Alteration.c"
				}
#line 280 "../src/core/Alteration.vala"
				_tmp50_ = other_values;
#line 280 "../src/core/Alteration.vala"
				_tmp51_ = values;
#line 280 "../src/core/Alteration.vala"
				if (!gee_collection_contains_all (_tmp50_, _tmp51_)) {
#line 281 "../src/core/Alteration.vala"
					result = FALSE;
#line 281 "../src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 281 "../src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 281 "../src/core/Alteration.vala"
					_g_free0 (key);
#line 281 "../src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 281 "../src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 281 "../src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 281 "../src/core/Alteration.vala"
					return result;
#line 2110 "Alteration.c"
				}
#line 270 "../src/core/Alteration.vala"
				_g_object_unref0 (other_values);
#line 270 "../src/core/Alteration.vala"
				_g_object_unref0 (values);
#line 270 "../src/core/Alteration.vala"
				_g_free0 (key);
#line 2118 "Alteration.c"
			}
#line 270 "../src/core/Alteration.vala"
			_g_object_unref0 (_key_it);
#line 2122 "Alteration.c"
		}
#line 285 "../src/core/Alteration.vala"
		result = TRUE;
#line 285 "../src/core/Alteration.vala"
		_g_object_unref0 (other_keys);
#line 285 "../src/core/Alteration.vala"
		_g_object_unref0 (keys);
#line 285 "../src/core/Alteration.vala"
		return result;
#line 2132 "Alteration.c"
	}
#line 289 "../src/core/Alteration.vala"
	result = FALSE;
#line 289 "../src/core/Alteration.vala"
	return result;
#line 2138 "Alteration.c"
}

static void
alteration_multimap_add_all (GeeMultiMap* dest,
                             GeeMultiMap* src)
{
	GeeSet* keys = NULL;
	GeeSet* _tmp0_;
#line 292 "../src/core/Alteration.vala"
	g_return_if_fail (dest != NULL);
#line 292 "../src/core/Alteration.vala"
	g_return_if_fail (src != NULL);
#line 294 "../src/core/Alteration.vala"
	_tmp0_ = gee_multi_map_get_keys (src);
#line 294 "../src/core/Alteration.vala"
	keys = _tmp0_;
#line 2155 "Alteration.c"
	{
		GeeIterator* _key_it = NULL;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 295 "../src/core/Alteration.vala"
		_tmp1_ = keys;
#line 295 "../src/core/Alteration.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 295 "../src/core/Alteration.vala"
		_key_it = _tmp2_;
#line 295 "../src/core/Alteration.vala"
		while (TRUE) {
#line 2168 "Alteration.c"
			GeeIterator* _tmp3_;
			gchar* key = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GeeCollection* values = NULL;
			const gchar* _tmp6_;
			GeeCollection* _tmp7_;
#line 295 "../src/core/Alteration.vala"
			_tmp3_ = _key_it;
#line 295 "../src/core/Alteration.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 295 "../src/core/Alteration.vala"
				break;
#line 2182 "Alteration.c"
			}
#line 295 "../src/core/Alteration.vala"
			_tmp4_ = _key_it;
#line 295 "../src/core/Alteration.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 295 "../src/core/Alteration.vala"
			key = (gchar*) _tmp5_;
#line 296 "../src/core/Alteration.vala"
			_tmp6_ = key;
#line 296 "../src/core/Alteration.vala"
			_tmp7_ = gee_multi_map_get (src, _tmp6_);
#line 296 "../src/core/Alteration.vala"
			values = _tmp7_;
#line 2196 "Alteration.c"
			{
				GeeIterator* _value_it = NULL;
				GeeCollection* _tmp8_;
				GeeIterator* _tmp9_;
#line 297 "../src/core/Alteration.vala"
				_tmp8_ = values;
#line 297 "../src/core/Alteration.vala"
				_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 297 "../src/core/Alteration.vala"
				_value_it = _tmp9_;
#line 297 "../src/core/Alteration.vala"
				while (TRUE) {
#line 2209 "Alteration.c"
					GeeIterator* _tmp10_;
					gchar* value = NULL;
					GeeIterator* _tmp11_;
					gpointer _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 297 "../src/core/Alteration.vala"
					_tmp10_ = _value_it;
#line 297 "../src/core/Alteration.vala"
					if (!gee_iterator_next (_tmp10_)) {
#line 297 "../src/core/Alteration.vala"
						break;
#line 2222 "Alteration.c"
					}
#line 297 "../src/core/Alteration.vala"
					_tmp11_ = _value_it;
#line 297 "../src/core/Alteration.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 297 "../src/core/Alteration.vala"
					value = (gchar*) _tmp12_;
#line 298 "../src/core/Alteration.vala"
					_tmp13_ = key;
#line 298 "../src/core/Alteration.vala"
					_tmp14_ = value;
#line 298 "../src/core/Alteration.vala"
					gee_multi_map_set (dest, _tmp13_, _tmp14_);
#line 297 "../src/core/Alteration.vala"
					_g_free0 (value);
#line 2238 "Alteration.c"
				}
#line 297 "../src/core/Alteration.vala"
				_g_object_unref0 (_value_it);
#line 2242 "Alteration.c"
			}
#line 295 "../src/core/Alteration.vala"
			_g_object_unref0 (values);
#line 295 "../src/core/Alteration.vala"
			_g_free0 (key);
#line 2248 "Alteration.c"
		}
#line 295 "../src/core/Alteration.vala"
		_g_object_unref0 (_key_it);
#line 2252 "Alteration.c"
	}
#line 292 "../src/core/Alteration.vala"
	_g_object_unref0 (keys);
#line 2256 "Alteration.c"
}

static gpointer
_alteration_ref0 (gpointer self)
{
#line 306 "../src/core/Alteration.vala"
	return self ? alteration_ref (self) : NULL;
#line 2264 "Alteration.c"
}

Alteration*
alteration_compress (Alteration* self,
                     Alteration* other)
{
	GeeMultiMap* compressed = NULL;
	GeeMultiMap* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	GeeMultiMap* _tmp20_;
	Alteration* _tmp21_;
	Alteration* result;
#line 304 "../src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 304 "../src/core/Alteration.vala"
	g_return_val_if_fail (other != NULL, NULL);
#line 305 "../src/core/Alteration.vala"
	if (alteration_equals (self, other)) {
#line 2286 "Alteration.c"
		Alteration* _tmp0_;
#line 306 "../src/core/Alteration.vala"
		_tmp0_ = _alteration_ref0 (self);
#line 306 "../src/core/Alteration.vala"
		result = _tmp0_;
#line 306 "../src/core/Alteration.vala"
		return result;
#line 2294 "Alteration.c"
	}
#line 310 "../src/core/Alteration.vala"
	_tmp1_ = alteration_create_map (self);
#line 310 "../src/core/Alteration.vala"
	compressed = _tmp1_;
#line 312 "../src/core/Alteration.vala"
	_tmp3_ = self->priv->subject;
#line 312 "../src/core/Alteration.vala"
	if (_tmp3_ != NULL) {
#line 2304 "Alteration.c"
		const gchar* _tmp4_;
#line 312 "../src/core/Alteration.vala"
		_tmp4_ = self->priv->detail;
#line 312 "../src/core/Alteration.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 2310 "Alteration.c"
	} else {
#line 312 "../src/core/Alteration.vala"
		_tmp2_ = FALSE;
#line 2314 "Alteration.c"
	}
#line 312 "../src/core/Alteration.vala"
	if (_tmp2_) {
#line 2318 "Alteration.c"
		GeeMultiMap* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 313 "../src/core/Alteration.vala"
		_tmp5_ = compressed;
#line 313 "../src/core/Alteration.vala"
		_tmp6_ = self->priv->subject;
#line 313 "../src/core/Alteration.vala"
		_tmp7_ = self->priv->detail;
#line 313 "../src/core/Alteration.vala"
		gee_multi_map_set (_tmp5_, _tmp6_, _tmp7_);
#line 2330 "Alteration.c"
	} else {
		GeeMultiMap* _tmp8_;
		GeeMultiMap* _tmp9_;
		GeeMultiMap* _tmp10_;
#line 315 "../src/core/Alteration.vala"
		_tmp8_ = self->priv->map;
#line 315 "../src/core/Alteration.vala"
		_vala_assert (_tmp8_ != NULL, "map != null");
#line 316 "../src/core/Alteration.vala"
		_tmp9_ = compressed;
#line 316 "../src/core/Alteration.vala"
		_tmp10_ = self->priv->map;
#line 316 "../src/core/Alteration.vala"
		alteration_multimap_add_all (_tmp9_, _tmp10_);
#line 2345 "Alteration.c"
	}
#line 319 "../src/core/Alteration.vala"
	_tmp12_ = other->priv->subject;
#line 319 "../src/core/Alteration.vala"
	if (_tmp12_ != NULL) {
#line 2351 "Alteration.c"
		const gchar* _tmp13_;
#line 319 "../src/core/Alteration.vala"
		_tmp13_ = other->priv->detail;
#line 319 "../src/core/Alteration.vala"
		_tmp11_ = _tmp13_ != NULL;
#line 2357 "Alteration.c"
	} else {
#line 319 "../src/core/Alteration.vala"
		_tmp11_ = FALSE;
#line 2361 "Alteration.c"
	}
#line 319 "../src/core/Alteration.vala"
	if (_tmp11_) {
#line 2365 "Alteration.c"
		GeeMultiMap* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 320 "../src/core/Alteration.vala"
		_tmp14_ = compressed;
#line 320 "../src/core/Alteration.vala"
		_tmp15_ = other->priv->subject;
#line 320 "../src/core/Alteration.vala"
		_tmp16_ = other->priv->detail;
#line 320 "../src/core/Alteration.vala"
		gee_multi_map_set (_tmp14_, _tmp15_, _tmp16_);
#line 2377 "Alteration.c"
	} else {
		GeeMultiMap* _tmp17_;
		GeeMultiMap* _tmp18_;
		GeeMultiMap* _tmp19_;
#line 322 "../src/core/Alteration.vala"
		_tmp17_ = other->priv->map;
#line 322 "../src/core/Alteration.vala"
		_vala_assert (_tmp17_ != NULL, "other.map != null");
#line 323 "../src/core/Alteration.vala"
		_tmp18_ = compressed;
#line 323 "../src/core/Alteration.vala"
		_tmp19_ = other->priv->map;
#line 323 "../src/core/Alteration.vala"
		alteration_multimap_add_all (_tmp18_, _tmp19_);
#line 2392 "Alteration.c"
	}
#line 326 "../src/core/Alteration.vala"
	_tmp20_ = compressed;
#line 326 "../src/core/Alteration.vala"
	_tmp21_ = alteration_new_from_map (_tmp20_);
#line 326 "../src/core/Alteration.vala"
	result = _tmp21_;
#line 326 "../src/core/Alteration.vala"
	_g_object_unref0 (compressed);
#line 326 "../src/core/Alteration.vala"
	return result;
#line 2404 "Alteration.c"
}

static void
value_alteration_init (GValue* value)
{
#line 40 "../src/core/Alteration.vala"
	value->data[0].v_pointer = NULL;
#line 2412 "Alteration.c"
}

static void
value_alteration_free_value (GValue* value)
{
#line 40 "../src/core/Alteration.vala"
	if (value->data[0].v_pointer) {
#line 40 "../src/core/Alteration.vala"
		alteration_unref (value->data[0].v_pointer);
#line 2422 "Alteration.c"
	}
}

static void
value_alteration_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 40 "../src/core/Alteration.vala"
	if (src_value->data[0].v_pointer) {
#line 40 "../src/core/Alteration.vala"
		dest_value->data[0].v_pointer = alteration_ref (src_value->data[0].v_pointer);
#line 2434 "Alteration.c"
	} else {
#line 40 "../src/core/Alteration.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2438 "Alteration.c"
	}
}

static gpointer
value_alteration_peek_pointer (const GValue* value)
{
#line 40 "../src/core/Alteration.vala"
	return value->data[0].v_pointer;
#line 2447 "Alteration.c"
}

static gchar*
value_alteration_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 40 "../src/core/Alteration.vala"
	if (collect_values[0].v_pointer) {
#line 2458 "Alteration.c"
		Alteration * object;
		object = collect_values[0].v_pointer;
#line 40 "../src/core/Alteration.vala"
		if (object->parent_instance.g_class == NULL) {
#line 40 "../src/core/Alteration.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2465 "Alteration.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 40 "../src/core/Alteration.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2469 "Alteration.c"
		}
#line 40 "../src/core/Alteration.vala"
		value->data[0].v_pointer = alteration_ref (object);
#line 2473 "Alteration.c"
	} else {
#line 40 "../src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2477 "Alteration.c"
	}
#line 40 "../src/core/Alteration.vala"
	return NULL;
#line 2481 "Alteration.c"
}

static gchar*
value_alteration_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	Alteration ** object_p;
	object_p = collect_values[0].v_pointer;
#line 40 "../src/core/Alteration.vala"
	if (!object_p) {
#line 40 "../src/core/Alteration.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2496 "Alteration.c"
	}
#line 40 "../src/core/Alteration.vala"
	if (!value->data[0].v_pointer) {
#line 40 "../src/core/Alteration.vala"
		*object_p = NULL;
#line 2502 "Alteration.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 40 "../src/core/Alteration.vala"
		*object_p = value->data[0].v_pointer;
#line 2506 "Alteration.c"
	} else {
#line 40 "../src/core/Alteration.vala"
		*object_p = alteration_ref (value->data[0].v_pointer);
#line 2510 "Alteration.c"
	}
#line 40 "../src/core/Alteration.vala"
	return NULL;
#line 2514 "Alteration.c"
}

GParamSpec*
param_spec_alteration (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecAlteration* spec;
#line 40 "../src/core/Alteration.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ALTERATION), NULL);
#line 40 "../src/core/Alteration.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 40 "../src/core/Alteration.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 40 "../src/core/Alteration.vala"
	return G_PARAM_SPEC (spec);
#line 2533 "Alteration.c"
}

gpointer
value_get_alteration (const GValue* value)
{
#line 40 "../src/core/Alteration.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION), NULL);
#line 40 "../src/core/Alteration.vala"
	return value->data[0].v_pointer;
#line 2543 "Alteration.c"
}

void
value_set_alteration (GValue* value,
                      gpointer v_object)
{
	Alteration * old;
#line 40 "../src/core/Alteration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
#line 40 "../src/core/Alteration.vala"
	old = value->data[0].v_pointer;
#line 40 "../src/core/Alteration.vala"
	if (v_object) {
#line 40 "../src/core/Alteration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
#line 40 "../src/core/Alteration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 40 "../src/core/Alteration.vala"
		value->data[0].v_pointer = v_object;
#line 40 "../src/core/Alteration.vala"
		alteration_ref (value->data[0].v_pointer);
#line 2565 "Alteration.c"
	} else {
#line 40 "../src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2569 "Alteration.c"
	}
#line 40 "../src/core/Alteration.vala"
	if (old) {
#line 40 "../src/core/Alteration.vala"
		alteration_unref (old);
#line 2575 "Alteration.c"
	}
}

void
value_take_alteration (GValue* value,
                       gpointer v_object)
{
	Alteration * old;
#line 40 "../src/core/Alteration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
#line 40 "../src/core/Alteration.vala"
	old = value->data[0].v_pointer;
#line 40 "../src/core/Alteration.vala"
	if (v_object) {
#line 40 "../src/core/Alteration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
#line 40 "../src/core/Alteration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 40 "../src/core/Alteration.vala"
		value->data[0].v_pointer = v_object;
#line 2596 "Alteration.c"
	} else {
#line 40 "../src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2600 "Alteration.c"
	}
#line 40 "../src/core/Alteration.vala"
	if (old) {
#line 40 "../src/core/Alteration.vala"
		alteration_unref (old);
#line 2606 "Alteration.c"
	}
}

static void
alteration_class_init (AlterationClass * klass,
                       gpointer klass_data)
{
#line 40 "../src/core/Alteration.vala"
	alteration_parent_class = g_type_class_peek_parent (klass);
#line 40 "../src/core/Alteration.vala"
	((AlterationClass *) klass)->finalize = alteration_finalize;
#line 40 "../src/core/Alteration.vala"
	g_type_class_adjust_private_offset (klass, &Alteration_private_offset);
#line 2620 "Alteration.c"
}

static void
alteration_instance_init (Alteration * self,
                          gpointer klass)
{
#line 40 "../src/core/Alteration.vala"
	self->priv = alteration_get_instance_private (self);
#line 41 "../src/core/Alteration.vala"
	self->priv->subject = NULL;
#line 42 "../src/core/Alteration.vala"
	self->priv->detail = NULL;
#line 43 "../src/core/Alteration.vala"
	self->priv->map = NULL;
#line 40 "../src/core/Alteration.vala"
	self->ref_count = 1;
#line 2637 "Alteration.c"
}

static void
alteration_finalize (Alteration * obj)
{
	Alteration * self;
#line 40 "../src/core/Alteration.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ALTERATION, Alteration);
#line 40 "../src/core/Alteration.vala"
	g_signal_handlers_destroy (self);
#line 41 "../src/core/Alteration.vala"
	_g_free0 (self->priv->subject);
#line 42 "../src/core/Alteration.vala"
	_g_free0 (self->priv->detail);
#line 43 "../src/core/Alteration.vala"
	_g_object_unref0 (self->priv->map);
#line 2654 "Alteration.c"
}

static GType
alteration_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_alteration_init, value_alteration_free_value, value_alteration_copy_value, value_alteration_peek_pointer, "p", value_alteration_collect_value, "p", value_alteration_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AlterationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) alteration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Alteration), 0, (GInstanceInitFunc) alteration_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType alteration_type_id;
	alteration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Alteration", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Alteration_private_offset = g_type_add_instance_private (alteration_type_id, sizeof (AlterationPrivate));
	return alteration_type_id;
}

GType
alteration_get_type (void)
{
	static volatile gsize alteration_type_id__once = 0;
	if (g_once_init_enter (&alteration_type_id__once)) {
		GType alteration_type_id;
		alteration_type_id = alteration_get_type_once ();
		g_once_init_leave (&alteration_type_id__once, alteration_type_id);
	}
	return alteration_type_id__once;
}

gpointer
alteration_ref (gpointer instance)
{
	Alteration * self;
	self = instance;
#line 40 "../src/core/Alteration.vala"
	g_atomic_int_inc (&self->ref_count);
#line 40 "../src/core/Alteration.vala"
	return instance;
#line 2690 "Alteration.c"
}

void
alteration_unref (gpointer instance)
{
	Alteration * self;
	self = instance;
#line 40 "../src/core/Alteration.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 40 "../src/core/Alteration.vala"
		ALTERATION_GET_CLASS (self)->finalize (self);
#line 40 "../src/core/Alteration.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2704 "Alteration.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

