/* ContainerSourceCollection.c generated by valac 0.56.18, the Vala compiler
 * generated from ContainerSourceCollection.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* A ContainerSourceCollection is for DataSources which maintain links to one or more other*/
/* DataSources, assumed to be of a different type.  ContainerSourceCollection automates the task*/
/* of handling unlinking and relinking and maintaining backlinks.  Unlinked DataSources are*/
/* held in a holding tank, until they are either relinked or destroyed.*/
/**/
/* If the ContainerSourceCollection's DataSources are types that "evaporate" (i.e. they disappear*/
/* when they hold no items), they should use the evaporate () method, which will either destroy*/
/* the DataSource or hold it in the tank (if backlinks are outstanding).*/

#include "io.elementary.photos.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))
enum  {
	CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_ADDED_SIGNAL,
	CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_REMOVED_SIGNAL,
	CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_ALTERED_SIGNAL,
	CONTAINER_SOURCE_COLLECTION_BACKLINK_TO_CONTAINER_REMOVED_SIGNAL,
	CONTAINER_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ContainerSourceCollectionPrivate {
	GeeHashSet* attached_collections;
	gchar* backlink_name;
	GeeHashSet* holding_tank;
};

static gint ContainerSourceCollection_private_offset;
static gpointer container_source_collection_parent_class = NULL;

static void container_source_collection_real_notify_backlink_removed (SourceCollection* base,
                                                               SourceBacklink* backlink,
                                                               GeeCollection* sources);
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self,
                                                                       ContainerSource* container,
                                                                       GeeCollection* added,
                                                                       gboolean relinked);
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self,
                                                                         ContainerSource* container,
                                                                         GeeCollection* removed,
                                                                         gboolean unlinked);
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self,
                                                                         ContainerSource* container,
                                                                         GeeCollection* added,
                                                                         gboolean relinked,
                                                                         GeeCollection* removed,
                                                                         gboolean unlinked);
static void container_source_collection_real_notify_backlink_to_container_removed (ContainerSourceCollection* self,
                                                                            ContainerSource* container,
                                                                            GeeCollection* sources);
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self,
                                                                               DataSource* source);
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self,
                                                                                 SourceBacklink* backlink);
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self,
                                                                 GeeCollection* unlinking);
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self,
                                                                GeeCollection* relinked);
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self,
                                                                DataSource* source);
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base,
                                                             DataSource* source);
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender,
                                                                                                    GeeCollection* unlinking,
                                                                                                    gpointer self);
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender,
                                                                                                  GeeCollection* relinked,
                                                                                                  gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                                  DataSource* source,
                                                                                                  gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender,
                                                                                                      DataSource* source,
                                                                                                      gpointer self);
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self,
                                                                ContainerSource* container,
                                                                GeeCollection* added,
                                                                gboolean relinked);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data);
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self,
                                                                  ContainerSource* container,
                                                                  GeeCollection* removed,
                                                                  gboolean unlinked);
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self,
                                                                  ContainerSource* container,
                                                                  GeeCollection* added,
                                                                  gboolean relinked,
                                                                  GeeCollection* removed,
                                                                  gboolean unlinked);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN (GClosure * closure,
                                                                         GValue * return_value,
                                                                         guint n_param_values,
                                                                         const GValue * param_values,
                                                                         gpointer invocation_hint,
                                                                         gpointer marshal_data);
static void container_source_collection_real_backlink_to_container_removed (ContainerSourceCollection* self,
                                                                     ContainerSource* container,
                                                                     GeeCollection* sources);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void container_source_collection_finalize (DataCollection * obj);
static GType container_source_collection_get_type_once (void);

static inline gpointer
container_source_collection_get_instance_private (ContainerSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, ContainerSourceCollection_private_offset);
}

ContainerSourceCollection*
container_source_collection_construct (GType object_type,
                                       const gchar* backlink_name,
                                       const gchar* name,
                                       GetSourceDatabaseKey source_key_func,
                                       gpointer source_key_func_target)
{
	ContainerSourceCollection* self = NULL;
	gchar* _tmp0_;
#line 50 "../src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (backlink_name != NULL, NULL);
#line 50 "../src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 52 "../src/core/ContainerSourceCollection.vala"
	self = (ContainerSourceCollection*) database_source_collection_construct (object_type, name, source_key_func, source_key_func_target);
#line 54 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = g_strdup (backlink_name);
#line 54 "../src/core/ContainerSourceCollection.vala"
	_g_free0 (self->priv->backlink_name);
#line 54 "../src/core/ContainerSourceCollection.vala"
	self->priv->backlink_name = _tmp0_;
#line 50 "../src/core/ContainerSourceCollection.vala"
	return self;
#line 185 "ContainerSourceCollection.c"
}

static void
container_source_collection_real_notify_backlink_removed (SourceCollection* base,
                                                          SourceBacklink* backlink,
                                                          GeeCollection* sources)
{
	ContainerSourceCollection * self;
	ContainerSource* container = NULL;
	ContainerSource* _tmp0_;
	ContainerSource* _tmp1_;
#line 61 "../src/core/ContainerSourceCollection.vala"
	self = (ContainerSourceCollection*) base;
#line 61 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (backlink != NULL);
#line 61 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (sources != NULL);
#line 63 "../src/core/ContainerSourceCollection.vala"
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_backlink_removed ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), backlink, sources);
#line 65 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = container_source_collection_convert_backlink_to_container (self, backlink);
#line 65 "../src/core/ContainerSourceCollection.vala"
	container = _tmp0_;
#line 66 "../src/core/ContainerSourceCollection.vala"
	_tmp1_ = container;
#line 66 "../src/core/ContainerSourceCollection.vala"
	if (_tmp1_ != NULL) {
#line 213 "ContainerSourceCollection.c"
		ContainerSource* _tmp2_;
#line 67 "../src/core/ContainerSourceCollection.vala"
		_tmp2_ = container;
#line 67 "../src/core/ContainerSourceCollection.vala"
		container_source_collection_notify_backlink_to_container_removed (self, _tmp2_, sources);
#line 219 "ContainerSourceCollection.c"
	}
#line 61 "../src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (container);
#line 223 "ContainerSourceCollection.c"
}

static void
container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self,
                                                                  ContainerSource* container,
                                                                  GeeCollection* added,
                                                                  gboolean relinked)
{
	GeeHashSet* _tmp0_;
#line 70 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 70 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (added != NULL);
#line 73 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 73 "../src/core/ContainerSourceCollection.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, container)) {
#line 241 "ContainerSourceCollection.c"
		gboolean removed = FALSE;
		GeeHashSet* _tmp1_;
#line 74 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = self->priv->holding_tank;
#line 74 "../src/core/ContainerSourceCollection.vala"
		removed = gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, container);
#line 75 "../src/core/ContainerSourceCollection.vala"
		_vala_assert (removed, "removed");
#line 77 "../src/core/ContainerSourceCollection.vala"
		source_collection_relink ((SourceCollection*) self, (DataSource*) container);
#line 252 "ContainerSourceCollection.c"
	}
#line 80 "../src/core/ContainerSourceCollection.vala"
	g_signal_emit (self, container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_ADDED_SIGNAL], 0, container, added, relinked);
#line 256 "ContainerSourceCollection.c"
}

void
container_source_collection_notify_container_contents_added (ContainerSourceCollection* self,
                                                             ContainerSource* container,
                                                             GeeCollection* added,
                                                             gboolean relinked)
{
	ContainerSourceCollectionClass* _klass_;
#line 70 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/core/ContainerSourceCollection.vala"
	_klass_ = CONTAINER_SOURCE_COLLECTION_GET_CLASS (self);
#line 70 "../src/core/ContainerSourceCollection.vala"
	if (_klass_->notify_container_contents_added) {
#line 70 "../src/core/ContainerSourceCollection.vala"
		_klass_->notify_container_contents_added (self, container, added, relinked);
#line 274 "ContainerSourceCollection.c"
	}
}

static void
container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self,
                                                                    ContainerSource* container,
                                                                    GeeCollection* removed,
                                                                    gboolean unlinked)
{
#line 83 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 83 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (removed != NULL);
#line 85 "../src/core/ContainerSourceCollection.vala"
	g_signal_emit (self, container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_REMOVED_SIGNAL], 0, container, removed, unlinked);
#line 290 "ContainerSourceCollection.c"
}

void
container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self,
                                                               ContainerSource* container,
                                                               GeeCollection* removed,
                                                               gboolean unlinked)
{
	ContainerSourceCollectionClass* _klass_;
#line 83 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/core/ContainerSourceCollection.vala"
	_klass_ = CONTAINER_SOURCE_COLLECTION_GET_CLASS (self);
#line 83 "../src/core/ContainerSourceCollection.vala"
	if (_klass_->notify_container_contents_removed) {
#line 83 "../src/core/ContainerSourceCollection.vala"
		_klass_->notify_container_contents_removed (self, container, removed, unlinked);
#line 308 "ContainerSourceCollection.c"
	}
}

static void
container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self,
                                                                    ContainerSource* container,
                                                                    GeeCollection* added,
                                                                    gboolean relinked,
                                                                    GeeCollection* removed,
                                                                    gboolean unlinked)
{
#line 88 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 91 "../src/core/ContainerSourceCollection.vala"
	g_signal_emit (self, container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_ALTERED_SIGNAL], 0, container, added, relinked, removed, unlinked);
#line 324 "ContainerSourceCollection.c"
}

void
container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self,
                                                               ContainerSource* container,
                                                               GeeCollection* added,
                                                               gboolean relinked,
                                                               GeeCollection* removed,
                                                               gboolean unlinked)
{
	ContainerSourceCollectionClass* _klass_;
#line 88 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/core/ContainerSourceCollection.vala"
	_klass_ = CONTAINER_SOURCE_COLLECTION_GET_CLASS (self);
#line 88 "../src/core/ContainerSourceCollection.vala"
	if (_klass_->notify_container_contents_altered) {
#line 88 "../src/core/ContainerSourceCollection.vala"
		_klass_->notify_container_contents_altered (self, container, added, relinked, removed, unlinked);
#line 344 "ContainerSourceCollection.c"
	}
}

static void
container_source_collection_real_notify_backlink_to_container_removed (ContainerSourceCollection* self,
                                                                       ContainerSource* container,
                                                                       GeeCollection* sources)
{
#line 94 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 94 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (sources != NULL);
#line 96 "../src/core/ContainerSourceCollection.vala"
	g_signal_emit (self, container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_BACKLINK_TO_CONTAINER_REMOVED_SIGNAL], 0, container, sources);
#line 359 "ContainerSourceCollection.c"
}

void
container_source_collection_notify_backlink_to_container_removed (ContainerSourceCollection* self,
                                                                  ContainerSource* container,
                                                                  GeeCollection* sources)
{
	ContainerSourceCollectionClass* _klass_;
#line 94 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/core/ContainerSourceCollection.vala"
	_klass_ = CONTAINER_SOURCE_COLLECTION_GET_CLASS (self);
#line 94 "../src/core/ContainerSourceCollection.vala"
	if (_klass_->notify_backlink_to_container_removed) {
#line 94 "../src/core/ContainerSourceCollection.vala"
		_klass_->notify_backlink_to_container_removed (self, container, sources);
#line 376 "ContainerSourceCollection.c"
	}
}

static GeeCollection*
container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self,
                                                                DataSource* source)
{
#line 99 "../src/core/ContainerSourceCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_get_containers_holding_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 99 "../src/core/ContainerSourceCollection.vala"
	return NULL;
#line 388 "ContainerSourceCollection.c"
}

GeeCollection*
container_source_collection_get_containers_holding_source (ContainerSourceCollection* self,
                                                           DataSource* source)
{
	ContainerSourceCollectionClass* _klass_;
#line 99 "../src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../src/core/ContainerSourceCollection.vala"
	_klass_ = CONTAINER_SOURCE_COLLECTION_GET_CLASS (self);
#line 99 "../src/core/ContainerSourceCollection.vala"
	if (_klass_->get_containers_holding_source) {
#line 99 "../src/core/ContainerSourceCollection.vala"
		return _klass_->get_containers_holding_source (self, source);
#line 404 "ContainerSourceCollection.c"
	}
#line 99 "../src/core/ContainerSourceCollection.vala"
	return NULL;
#line 408 "ContainerSourceCollection.c"
}

static ContainerSource*
container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self,
                                                                SourceBacklink* backlink)
{
#line 102 "../src/core/ContainerSourceCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_convert_backlink_to_container'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 102 "../src/core/ContainerSourceCollection.vala"
	return NULL;
#line 419 "ContainerSourceCollection.c"
}

ContainerSource*
container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self,
                                                           SourceBacklink* backlink)
{
	ContainerSourceCollectionClass* _klass_;
#line 102 "../src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/core/ContainerSourceCollection.vala"
	_klass_ = CONTAINER_SOURCE_COLLECTION_GET_CLASS (self);
#line 102 "../src/core/ContainerSourceCollection.vala"
	if (_klass_->convert_backlink_to_container) {
#line 102 "../src/core/ContainerSourceCollection.vala"
		return _klass_->convert_backlink_to_container (self, backlink);
#line 435 "ContainerSourceCollection.c"
	}
#line 102 "../src/core/ContainerSourceCollection.vala"
	return NULL;
#line 439 "ContainerSourceCollection.c"
}

void
container_source_collection_freeze_attached_notifications (ContainerSourceCollection* self)
{
#line 104 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 447 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 105 "../src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 105 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 105 "../src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 105 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 460 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			SourceCollection* _tmp5_;
#line 105 "../src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 105 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 105 "../src/core/ContainerSourceCollection.vala"
				break;
#line 472 "ContainerSourceCollection.c"
			}
#line 105 "../src/core/ContainerSourceCollection.vala"
			_tmp3_ = _collection_it;
#line 105 "../src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 105 "../src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp4_;
#line 106 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = collection;
#line 106 "../src/core/ContainerSourceCollection.vala"
			data_collection_freeze_notifications ((DataCollection*) _tmp5_);
#line 105 "../src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 486 "ContainerSourceCollection.c"
		}
#line 105 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 490 "ContainerSourceCollection.c"
	}
}

void
container_source_collection_thaw_attached_notifications (ContainerSourceCollection* self)
{
#line 109 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 499 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 110 "../src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 110 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 110 "../src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 110 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 512 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			SourceCollection* _tmp5_;
#line 110 "../src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 110 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 110 "../src/core/ContainerSourceCollection.vala"
				break;
#line 524 "ContainerSourceCollection.c"
			}
#line 110 "../src/core/ContainerSourceCollection.vala"
			_tmp3_ = _collection_it;
#line 110 "../src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 110 "../src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp4_;
#line 111 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = collection;
#line 111 "../src/core/ContainerSourceCollection.vala"
			data_collection_thaw_notifications ((DataCollection*) _tmp5_);
#line 110 "../src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 538 "ContainerSourceCollection.c"
		}
#line 110 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 542 "ContainerSourceCollection.c"
	}
}

GeeCollection*
container_source_collection_get_holding_tank (ContainerSourceCollection* self)
{
	GeeHashSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeCollection* result;
#line 114 "../src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 115 "../src/core/ContainerSourceCollection.vala"
	_tmp1_ = gee_abstract_set_get_read_only_view ((GeeAbstractSet*) _tmp0_);
#line 115 "../src/core/ContainerSourceCollection.vala"
	_tmp2_ = _tmp1_;
#line 115 "../src/core/ContainerSourceCollection.vala"
	result = (GeeCollection*) _tmp2_;
#line 115 "../src/core/ContainerSourceCollection.vala"
	return result;
#line 565 "ContainerSourceCollection.c"
}

void
container_source_collection_init_add_unlinked (ContainerSourceCollection* self,
                                               ContainerSource* unlinked)
{
	GeeHashSet* _tmp0_;
#line 118 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (unlinked != NULL);
#line 119 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 119 "../src/core/ContainerSourceCollection.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, unlinked);
#line 581 "ContainerSourceCollection.c"
}

void
container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self,
                                                    GeeCollection* unlinked)
{
	GeeHashSet* _tmp0_;
#line 122 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (unlinked != NULL);
#line 123 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 123 "../src/core/ContainerSourceCollection.vala"
	gee_collection_add_all ((GeeCollection*) _tmp0_, unlinked);
#line 597 "ContainerSourceCollection.c"
}

gboolean
container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self,
                                                      ContainerSource* source)
{
	GeeHashSet* _tmp0_;
	gboolean result;
#line 126 "../src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 126 "../src/core/ContainerSourceCollection.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 127 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 127 "../src/core/ContainerSourceCollection.vala"
	if (!gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, source)) {
#line 128 "../src/core/ContainerSourceCollection.vala"
		result = FALSE;
#line 128 "../src/core/ContainerSourceCollection.vala"
		return result;
#line 618 "ContainerSourceCollection.c"
	}
#line 130 "../src/core/ContainerSourceCollection.vala"
	source_collection_relink ((SourceCollection*) self, (DataSource*) source);
#line 132 "../src/core/ContainerSourceCollection.vala"
	result = TRUE;
#line 132 "../src/core/ContainerSourceCollection.vala"
	return result;
#line 626 "ContainerSourceCollection.c"
}

static void
container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self,
                                                            GeeCollection* unlinking)
{
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 135 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (unlinking != NULL);
#line 136 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_freeze_attached_notifications (self);
#line 138 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 138 "../src/core/ContainerSourceCollection.vala"
	map = _tmp0_;
#line 645 "ContainerSourceCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp1_;
#line 141 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) unlinking);
#line 141 "../src/core/ContainerSourceCollection.vala"
		_source_it = _tmp1_;
#line 141 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 655 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_;
			DataSource* source = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeCollection* containers = NULL;
			DataSource* _tmp5_;
			GeeCollection* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeCollection* _tmp8_;
#line 141 "../src/core/ContainerSourceCollection.vala"
			_tmp2_ = _source_it;
#line 141 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 141 "../src/core/ContainerSourceCollection.vala"
				break;
#line 671 "ContainerSourceCollection.c"
			}
#line 141 "../src/core/ContainerSourceCollection.vala"
			_tmp3_ = _source_it;
#line 141 "../src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 141 "../src/core/ContainerSourceCollection.vala"
			source = (DataSource*) _tmp4_;
#line 142 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = source;
#line 142 "../src/core/ContainerSourceCollection.vala"
			_tmp6_ = container_source_collection_get_containers_holding_source (self, _tmp5_);
#line 142 "../src/core/ContainerSourceCollection.vala"
			containers = _tmp6_;
#line 143 "../src/core/ContainerSourceCollection.vala"
			_tmp8_ = containers;
#line 143 "../src/core/ContainerSourceCollection.vala"
			if (_tmp8_ == NULL) {
#line 143 "../src/core/ContainerSourceCollection.vala"
				_tmp7_ = TRUE;
#line 691 "ContainerSourceCollection.c"
			} else {
				GeeCollection* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 143 "../src/core/ContainerSourceCollection.vala"
				_tmp9_ = containers;
#line 143 "../src/core/ContainerSourceCollection.vala"
				_tmp10_ = gee_collection_get_size (_tmp9_);
#line 143 "../src/core/ContainerSourceCollection.vala"
				_tmp11_ = _tmp10_;
#line 143 "../src/core/ContainerSourceCollection.vala"
				_tmp7_ = _tmp11_ == 0;
#line 704 "ContainerSourceCollection.c"
			}
#line 143 "../src/core/ContainerSourceCollection.vala"
			if (_tmp7_) {
#line 144 "../src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (containers);
#line 144 "../src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (source);
#line 144 "../src/core/ContainerSourceCollection.vala"
				continue;
#line 714 "ContainerSourceCollection.c"
			}
			{
				GeeIterator* _container_it = NULL;
				GeeCollection* _tmp12_;
				GeeIterator* _tmp13_;
#line 146 "../src/core/ContainerSourceCollection.vala"
				_tmp12_ = containers;
#line 146 "../src/core/ContainerSourceCollection.vala"
				_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 146 "../src/core/ContainerSourceCollection.vala"
				_container_it = _tmp13_;
#line 146 "../src/core/ContainerSourceCollection.vala"
				while (TRUE) {
#line 728 "ContainerSourceCollection.c"
					GeeIterator* _tmp14_;
					ContainerSource* container = NULL;
					GeeIterator* _tmp15_;
					gpointer _tmp16_;
					GeeHashMultiMap* _tmp17_;
					ContainerSource* _tmp18_;
					DataSource* _tmp19_;
					DataSource* _tmp20_;
					ContainerSource* _tmp21_;
					SourceBacklink* _tmp22_;
					SourceBacklink* _tmp23_;
#line 146 "../src/core/ContainerSourceCollection.vala"
					_tmp14_ = _container_it;
#line 146 "../src/core/ContainerSourceCollection.vala"
					if (!gee_iterator_next (_tmp14_)) {
#line 146 "../src/core/ContainerSourceCollection.vala"
						break;
#line 746 "ContainerSourceCollection.c"
					}
#line 146 "../src/core/ContainerSourceCollection.vala"
					_tmp15_ = _container_it;
#line 146 "../src/core/ContainerSourceCollection.vala"
					_tmp16_ = gee_iterator_get (_tmp15_);
#line 146 "../src/core/ContainerSourceCollection.vala"
					container = (ContainerSource*) _tmp16_;
#line 147 "../src/core/ContainerSourceCollection.vala"
					_tmp17_ = map;
#line 147 "../src/core/ContainerSourceCollection.vala"
					_tmp18_ = container;
#line 147 "../src/core/ContainerSourceCollection.vala"
					_tmp19_ = source;
#line 147 "../src/core/ContainerSourceCollection.vala"
					gee_multi_map_set ((GeeMultiMap*) _tmp17_, _tmp18_, _tmp19_);
#line 148 "../src/core/ContainerSourceCollection.vala"
					_tmp20_ = source;
#line 148 "../src/core/ContainerSourceCollection.vala"
					_tmp21_ = container;
#line 148 "../src/core/ContainerSourceCollection.vala"
					_tmp22_ = container_source_get_backlink (_tmp21_);
#line 148 "../src/core/ContainerSourceCollection.vala"
					_tmp23_ = _tmp22_;
#line 148 "../src/core/ContainerSourceCollection.vala"
					data_source_set_backlink (_tmp20_, _tmp23_);
#line 148 "../src/core/ContainerSourceCollection.vala"
					_source_backlink_unref0 (_tmp23_);
#line 146 "../src/core/ContainerSourceCollection.vala"
					_g_object_unref0 (container);
#line 776 "ContainerSourceCollection.c"
				}
#line 146 "../src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_container_it);
#line 780 "ContainerSourceCollection.c"
			}
#line 141 "../src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (containers);
#line 141 "../src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (source);
#line 786 "ContainerSourceCollection.c"
		}
#line 141 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_source_it);
#line 790 "ContainerSourceCollection.c"
	}
	{
		GeeIterator* _container_it = NULL;
		GeeHashMultiMap* _tmp24_;
		GeeSet* _tmp25_;
		GeeSet* _tmp26_;
		GeeIterator* _tmp27_;
		GeeIterator* _tmp28_;
#line 152 "../src/core/ContainerSourceCollection.vala"
		_tmp24_ = map;
#line 152 "../src/core/ContainerSourceCollection.vala"
		_tmp25_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp24_);
#line 152 "../src/core/ContainerSourceCollection.vala"
		_tmp26_ = _tmp25_;
#line 152 "../src/core/ContainerSourceCollection.vala"
		_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 152 "../src/core/ContainerSourceCollection.vala"
		_tmp28_ = _tmp27_;
#line 152 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_tmp26_);
#line 152 "../src/core/ContainerSourceCollection.vala"
		_container_it = _tmp28_;
#line 152 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 815 "ContainerSourceCollection.c"
			GeeIterator* _tmp29_;
			ContainerSource* container = NULL;
			GeeIterator* _tmp30_;
			gpointer _tmp31_;
			ContainerSource* _tmp32_;
			GeeHashMultiMap* _tmp33_;
			ContainerSource* _tmp34_;
			GeeCollection* _tmp35_;
			GeeCollection* _tmp36_;
#line 152 "../src/core/ContainerSourceCollection.vala"
			_tmp29_ = _container_it;
#line 152 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp29_)) {
#line 152 "../src/core/ContainerSourceCollection.vala"
				break;
#line 831 "ContainerSourceCollection.c"
			}
#line 152 "../src/core/ContainerSourceCollection.vala"
			_tmp30_ = _container_it;
#line 152 "../src/core/ContainerSourceCollection.vala"
			_tmp31_ = gee_iterator_get (_tmp30_);
#line 152 "../src/core/ContainerSourceCollection.vala"
			container = (ContainerSource*) _tmp31_;
#line 153 "../src/core/ContainerSourceCollection.vala"
			_tmp32_ = container;
#line 153 "../src/core/ContainerSourceCollection.vala"
			_tmp33_ = map;
#line 153 "../src/core/ContainerSourceCollection.vala"
			_tmp34_ = container;
#line 153 "../src/core/ContainerSourceCollection.vala"
			_tmp35_ = gee_multi_map_get ((GeeMultiMap*) _tmp33_, _tmp34_);
#line 153 "../src/core/ContainerSourceCollection.vala"
			_tmp36_ = _tmp35_;
#line 153 "../src/core/ContainerSourceCollection.vala"
			container_source_break_link_many (_tmp32_, _tmp36_);
#line 153 "../src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (_tmp36_);
#line 152 "../src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (container);
#line 855 "ContainerSourceCollection.c"
		}
#line 152 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_container_it);
#line 859 "ContainerSourceCollection.c"
	}
#line 155 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_thaw_attached_notifications (self);
#line 135 "../src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (map);
#line 865 "ContainerSourceCollection.c"
}

static void
container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self,
                                                           GeeCollection* relinked)
{
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 158 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (relinked != NULL);
#line 159 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_freeze_attached_notifications (self);
#line 161 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 161 "../src/core/ContainerSourceCollection.vala"
	map = _tmp0_;
#line 884 "ContainerSourceCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp1_;
#line 164 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) relinked);
#line 164 "../src/core/ContainerSourceCollection.vala"
		_source_it = _tmp1_;
#line 164 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 894 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_;
			DataSource* source = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeList* backlinks = NULL;
			DataSource* _tmp5_;
			const gchar* _tmp6_;
			GeeList* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GeeList* _tmp9_;
#line 164 "../src/core/ContainerSourceCollection.vala"
			_tmp2_ = _source_it;
#line 164 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 164 "../src/core/ContainerSourceCollection.vala"
				break;
#line 911 "ContainerSourceCollection.c"
			}
#line 164 "../src/core/ContainerSourceCollection.vala"
			_tmp3_ = _source_it;
#line 164 "../src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 164 "../src/core/ContainerSourceCollection.vala"
			source = (DataSource*) _tmp4_;
#line 165 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = source;
#line 165 "../src/core/ContainerSourceCollection.vala"
			_tmp6_ = self->priv->backlink_name;
#line 165 "../src/core/ContainerSourceCollection.vala"
			_tmp7_ = data_source_get_backlinks (_tmp5_, _tmp6_);
#line 165 "../src/core/ContainerSourceCollection.vala"
			backlinks = _tmp7_;
#line 166 "../src/core/ContainerSourceCollection.vala"
			_tmp9_ = backlinks;
#line 166 "../src/core/ContainerSourceCollection.vala"
			if (_tmp9_ == NULL) {
#line 166 "../src/core/ContainerSourceCollection.vala"
				_tmp8_ = TRUE;
#line 933 "ContainerSourceCollection.c"
			} else {
				GeeList* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
#line 166 "../src/core/ContainerSourceCollection.vala"
				_tmp10_ = backlinks;
#line 166 "../src/core/ContainerSourceCollection.vala"
				_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 166 "../src/core/ContainerSourceCollection.vala"
				_tmp12_ = _tmp11_;
#line 166 "../src/core/ContainerSourceCollection.vala"
				_tmp8_ = _tmp12_ == 0;
#line 946 "ContainerSourceCollection.c"
			}
#line 166 "../src/core/ContainerSourceCollection.vala"
			if (_tmp8_) {
#line 167 "../src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (backlinks);
#line 167 "../src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (source);
#line 167 "../src/core/ContainerSourceCollection.vala"
				continue;
#line 956 "ContainerSourceCollection.c"
			}
			{
				GeeList* _backlink_list = NULL;
				GeeList* _tmp13_;
				gint _backlink_size = 0;
				GeeList* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _backlink_index = 0;
#line 169 "../src/core/ContainerSourceCollection.vala"
				_tmp13_ = backlinks;
#line 169 "../src/core/ContainerSourceCollection.vala"
				_backlink_list = _tmp13_;
#line 169 "../src/core/ContainerSourceCollection.vala"
				_tmp14_ = _backlink_list;
#line 169 "../src/core/ContainerSourceCollection.vala"
				_tmp15_ = gee_collection_get_size ((GeeCollection*) _tmp14_);
#line 169 "../src/core/ContainerSourceCollection.vala"
				_tmp16_ = _tmp15_;
#line 169 "../src/core/ContainerSourceCollection.vala"
				_backlink_size = _tmp16_;
#line 169 "../src/core/ContainerSourceCollection.vala"
				_backlink_index = -1;
#line 169 "../src/core/ContainerSourceCollection.vala"
				while (TRUE) {
#line 982 "ContainerSourceCollection.c"
					gint _tmp17_;
					gint _tmp18_;
					SourceBacklink* backlink = NULL;
					GeeList* _tmp19_;
					gpointer _tmp20_;
					ContainerSource* container = NULL;
					SourceBacklink* _tmp21_;
					ContainerSource* _tmp22_;
					ContainerSource* _tmp23_;
#line 169 "../src/core/ContainerSourceCollection.vala"
					_backlink_index = _backlink_index + 1;
#line 169 "../src/core/ContainerSourceCollection.vala"
					_tmp17_ = _backlink_index;
#line 169 "../src/core/ContainerSourceCollection.vala"
					_tmp18_ = _backlink_size;
#line 169 "../src/core/ContainerSourceCollection.vala"
					if (!(_tmp17_ < _tmp18_)) {
#line 169 "../src/core/ContainerSourceCollection.vala"
						break;
#line 1002 "ContainerSourceCollection.c"
					}
#line 169 "../src/core/ContainerSourceCollection.vala"
					_tmp19_ = _backlink_list;
#line 169 "../src/core/ContainerSourceCollection.vala"
					_tmp20_ = gee_list_get (_tmp19_, _backlink_index);
#line 169 "../src/core/ContainerSourceCollection.vala"
					backlink = (SourceBacklink*) _tmp20_;
#line 170 "../src/core/ContainerSourceCollection.vala"
					_tmp21_ = backlink;
#line 170 "../src/core/ContainerSourceCollection.vala"
					_tmp22_ = container_source_collection_convert_backlink_to_container (self, _tmp21_);
#line 170 "../src/core/ContainerSourceCollection.vala"
					container = _tmp22_;
#line 171 "../src/core/ContainerSourceCollection.vala"
					_tmp23_ = container;
#line 171 "../src/core/ContainerSourceCollection.vala"
					if (_tmp23_ != NULL) {
#line 1020 "ContainerSourceCollection.c"
						GeeHashMultiMap* _tmp24_;
						ContainerSource* _tmp25_;
						DataSource* _tmp26_;
#line 172 "../src/core/ContainerSourceCollection.vala"
						_tmp24_ = map;
#line 172 "../src/core/ContainerSourceCollection.vala"
						_tmp25_ = container;
#line 172 "../src/core/ContainerSourceCollection.vala"
						_tmp26_ = source;
#line 172 "../src/core/ContainerSourceCollection.vala"
						gee_multi_map_set ((GeeMultiMap*) _tmp24_, _tmp25_, _tmp26_);
#line 1032 "ContainerSourceCollection.c"
					} else {
						DataSource* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						SourceBacklink* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
#line 174 "../src/core/ContainerSourceCollection.vala"
						_tmp27_ = source;
#line 174 "../src/core/ContainerSourceCollection.vala"
						_tmp28_ = data_object_to_string ((DataObject*) _tmp27_);
#line 174 "../src/core/ContainerSourceCollection.vala"
						_tmp29_ = _tmp28_;
#line 174 "../src/core/ContainerSourceCollection.vala"
						_tmp30_ = backlink;
#line 174 "../src/core/ContainerSourceCollection.vala"
						_tmp31_ = source_backlink_to_string (_tmp30_);
#line 174 "../src/core/ContainerSourceCollection.vala"
						_tmp32_ = _tmp31_;
#line 174 "../src/core/ContainerSourceCollection.vala"
						g_warning ("ContainerSourceCollection.vala:174: Unable to relink %s to container b" \
"acklink %s", _tmp29_, _tmp32_);
#line 174 "../src/core/ContainerSourceCollection.vala"
						_g_free0 (_tmp32_);
#line 174 "../src/core/ContainerSourceCollection.vala"
						_g_free0 (_tmp29_);
#line 1058 "ContainerSourceCollection.c"
					}
#line 169 "../src/core/ContainerSourceCollection.vala"
					_g_object_unref0 (container);
#line 169 "../src/core/ContainerSourceCollection.vala"
					_source_backlink_unref0 (backlink);
#line 1064 "ContainerSourceCollection.c"
				}
			}
#line 164 "../src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (backlinks);
#line 164 "../src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (source);
#line 1071 "ContainerSourceCollection.c"
		}
#line 164 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_source_it);
#line 1075 "ContainerSourceCollection.c"
	}
	{
		GeeIterator* _container_it = NULL;
		GeeHashMultiMap* _tmp33_;
		GeeSet* _tmp34_;
		GeeSet* _tmp35_;
		GeeIterator* _tmp36_;
		GeeIterator* _tmp37_;
#line 180 "../src/core/ContainerSourceCollection.vala"
		_tmp33_ = map;
#line 180 "../src/core/ContainerSourceCollection.vala"
		_tmp34_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp33_);
#line 180 "../src/core/ContainerSourceCollection.vala"
		_tmp35_ = _tmp34_;
#line 180 "../src/core/ContainerSourceCollection.vala"
		_tmp36_ = gee_iterable_iterator ((GeeIterable*) _tmp35_);
#line 180 "../src/core/ContainerSourceCollection.vala"
		_tmp37_ = _tmp36_;
#line 180 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_tmp35_);
#line 180 "../src/core/ContainerSourceCollection.vala"
		_container_it = _tmp37_;
#line 180 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1100 "ContainerSourceCollection.c"
			GeeIterator* _tmp38_;
			ContainerSource* container = NULL;
			GeeIterator* _tmp39_;
			gpointer _tmp40_;
			ContainerSource* _tmp41_;
			GeeHashMultiMap* _tmp42_;
			ContainerSource* _tmp43_;
			GeeCollection* _tmp44_;
			GeeCollection* _tmp45_;
#line 180 "../src/core/ContainerSourceCollection.vala"
			_tmp38_ = _container_it;
#line 180 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp38_)) {
#line 180 "../src/core/ContainerSourceCollection.vala"
				break;
#line 1116 "ContainerSourceCollection.c"
			}
#line 180 "../src/core/ContainerSourceCollection.vala"
			_tmp39_ = _container_it;
#line 180 "../src/core/ContainerSourceCollection.vala"
			_tmp40_ = gee_iterator_get (_tmp39_);
#line 180 "../src/core/ContainerSourceCollection.vala"
			container = (ContainerSource*) _tmp40_;
#line 181 "../src/core/ContainerSourceCollection.vala"
			_tmp41_ = container;
#line 181 "../src/core/ContainerSourceCollection.vala"
			_tmp42_ = map;
#line 181 "../src/core/ContainerSourceCollection.vala"
			_tmp43_ = container;
#line 181 "../src/core/ContainerSourceCollection.vala"
			_tmp44_ = gee_multi_map_get ((GeeMultiMap*) _tmp42_, _tmp43_);
#line 181 "../src/core/ContainerSourceCollection.vala"
			_tmp45_ = _tmp44_;
#line 181 "../src/core/ContainerSourceCollection.vala"
			container_source_establish_link_many (_tmp41_, _tmp45_);
#line 181 "../src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (_tmp45_);
#line 180 "../src/core/ContainerSourceCollection.vala"
			_g_object_unref0 (container);
#line 1140 "ContainerSourceCollection.c"
		}
#line 180 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_container_it);
#line 1144 "ContainerSourceCollection.c"
	}
#line 183 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_thaw_attached_notifications (self);
#line 158 "../src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (map);
#line 1150 "ContainerSourceCollection.c"
}

static void
container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self,
                                                           DataSource* source)
{
	GeeIterator* iter = NULL;
	GeeHashSet* _tmp0_;
	GeeIterator* _tmp1_;
#line 186 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (source != NULL);
#line 187 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->holding_tank;
#line 187 "../src/core/ContainerSourceCollection.vala"
	_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 187 "../src/core/ContainerSourceCollection.vala"
	iter = _tmp1_;
#line 188 "../src/core/ContainerSourceCollection.vala"
	while (TRUE) {
#line 1172 "ContainerSourceCollection.c"
		GeeIterator* _tmp2_;
		ContainerSource* container = NULL;
		GeeIterator* _tmp3_;
		gpointer _tmp4_;
		gboolean _tmp5_ = FALSE;
		ContainerSource* _tmp6_;
#line 188 "../src/core/ContainerSourceCollection.vala"
		_tmp2_ = iter;
#line 188 "../src/core/ContainerSourceCollection.vala"
		if (!gee_iterator_next (_tmp2_)) {
#line 188 "../src/core/ContainerSourceCollection.vala"
			break;
#line 1185 "ContainerSourceCollection.c"
		}
#line 189 "../src/core/ContainerSourceCollection.vala"
		_tmp3_ = iter;
#line 189 "../src/core/ContainerSourceCollection.vala"
		_tmp4_ = gee_iterator_get (_tmp3_);
#line 189 "../src/core/ContainerSourceCollection.vala"
		container = (ContainerSource*) _tmp4_;
#line 193 "../src/core/ContainerSourceCollection.vala"
		_tmp6_ = container;
#line 193 "../src/core/ContainerSourceCollection.vala"
		if (!container_source_has_links (_tmp6_)) {
#line 1197 "ContainerSourceCollection.c"
			ContainerSource* _tmp7_;
#line 193 "../src/core/ContainerSourceCollection.vala"
			_tmp7_ = container;
#line 193 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = !IS_TAG (_tmp7_);
#line 1203 "ContainerSourceCollection.c"
		} else {
#line 193 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = FALSE;
#line 1207 "ContainerSourceCollection.c"
		}
#line 193 "../src/core/ContainerSourceCollection.vala"
		if (_tmp5_) {
#line 1211 "ContainerSourceCollection.c"
			GeeIterator* _tmp8_;
			ContainerSource* _tmp9_;
#line 194 "../src/core/ContainerSourceCollection.vala"
			_tmp8_ = iter;
#line 194 "../src/core/ContainerSourceCollection.vala"
			gee_iterator_remove (_tmp8_);
#line 195 "../src/core/ContainerSourceCollection.vala"
			_tmp9_ = container;
#line 195 "../src/core/ContainerSourceCollection.vala"
			data_source_destroy_orphan ((DataSource*) _tmp9_, TRUE);
#line 1222 "ContainerSourceCollection.c"
		}
#line 188 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (container);
#line 1226 "ContainerSourceCollection.c"
	}
#line 186 "../src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (iter);
#line 1230 "ContainerSourceCollection.c"
}

static void
container_source_collection_real_notify_item_destroyed (SourceCollection* base,
                                                        DataSource* source)
{
	ContainerSourceCollection * self;
#line 200 "../src/core/ContainerSourceCollection.vala"
	self = (ContainerSourceCollection*) base;
#line 200 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (source != NULL);
#line 1242 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 201 "../src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 201 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 201 "../src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 201 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1255 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			SourceCollection* _tmp5_;
			SourceBacklink* _tmp6_;
			SourceBacklink* _tmp7_;
#line 201 "../src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 201 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 201 "../src/core/ContainerSourceCollection.vala"
				break;
#line 1269 "ContainerSourceCollection.c"
			}
#line 201 "../src/core/ContainerSourceCollection.vala"
			_tmp3_ = _collection_it;
#line 201 "../src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 201 "../src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp4_;
#line 202 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = collection;
#line 202 "../src/core/ContainerSourceCollection.vala"
			_tmp6_ = container_source_get_backlink (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_CONTAINER_SOURCE, ContainerSource));
#line 202 "../src/core/ContainerSourceCollection.vala"
			_tmp7_ = _tmp6_;
#line 202 "../src/core/ContainerSourceCollection.vala"
			source_collection_remove_backlink (_tmp5_, _tmp7_);
#line 202 "../src/core/ContainerSourceCollection.vala"
			_source_backlink_unref0 (_tmp7_);
#line 201 "../src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 1289 "ContainerSourceCollection.c"
		}
#line 201 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 1293 "ContainerSourceCollection.c"
	}
#line 205 "../src/core/ContainerSourceCollection.vala"
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_item_destroyed ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), source);
#line 1297 "ContainerSourceCollection.c"
}

void
container_source_collection_evaporate (ContainerSourceCollection* self,
                                       ContainerSource* container)
{
	Marker* _tmp14_;
	Marker* _tmp15_;
#line 212 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 1310 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 213 "../src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 213 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 213 "../src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 213 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1323 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			SourceCollection* _tmp5_;
			SourceBacklink* _tmp6_;
			SourceBacklink* _tmp7_;
			gboolean _tmp8_;
#line 213 "../src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 213 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 213 "../src/core/ContainerSourceCollection.vala"
				break;
#line 1338 "ContainerSourceCollection.c"
			}
#line 213 "../src/core/ContainerSourceCollection.vala"
			_tmp3_ = _collection_it;
#line 213 "../src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 213 "../src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp4_;
#line 214 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = collection;
#line 214 "../src/core/ContainerSourceCollection.vala"
			_tmp6_ = container_source_get_backlink (container);
#line 214 "../src/core/ContainerSourceCollection.vala"
			_tmp7_ = _tmp6_;
#line 214 "../src/core/ContainerSourceCollection.vala"
			_tmp8_ = source_collection_has_backlink (_tmp5_, _tmp7_);
#line 214 "../src/core/ContainerSourceCollection.vala"
			_source_backlink_unref0 (_tmp7_);
#line 214 "../src/core/ContainerSourceCollection.vala"
			if (_tmp8_) {
#line 1358 "ContainerSourceCollection.c"
				Marker* _tmp9_;
				Marker* _tmp10_;
				GeeCollection* _tmp11_;
				GeeCollection* _tmp12_;
				gboolean added = FALSE;
				GeeHashSet* _tmp13_;
#line 215 "../src/core/ContainerSourceCollection.vala"
				_tmp9_ = data_collection_mark ((DataCollection*) self, (DataObject*) container);
#line 215 "../src/core/ContainerSourceCollection.vala"
				_tmp10_ = _tmp9_;
#line 215 "../src/core/ContainerSourceCollection.vala"
				_tmp11_ = source_collection_unlink_marked ((SourceCollection*) self, _tmp10_, NULL, NULL);
#line 215 "../src/core/ContainerSourceCollection.vala"
				_tmp12_ = _tmp11_;
#line 215 "../src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_tmp12_);
#line 215 "../src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_tmp10_);
#line 216 "../src/core/ContainerSourceCollection.vala"
				_tmp13_ = self->priv->holding_tank;
#line 216 "../src/core/ContainerSourceCollection.vala"
				added = gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, container);
#line 217 "../src/core/ContainerSourceCollection.vala"
				_vala_assert (added, "added");
#line 218 "../src/core/ContainerSourceCollection.vala"
				_data_collection_unref0 (collection);
#line 218 "../src/core/ContainerSourceCollection.vala"
				_g_object_unref0 (_collection_it);
#line 218 "../src/core/ContainerSourceCollection.vala"
				return;
#line 1389 "ContainerSourceCollection.c"
			}
#line 213 "../src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 1393 "ContainerSourceCollection.c"
		}
#line 213 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 1397 "ContainerSourceCollection.c"
	}
#line 222 "../src/core/ContainerSourceCollection.vala"
	_tmp14_ = data_collection_mark ((DataCollection*) self, (DataObject*) container);
#line 222 "../src/core/ContainerSourceCollection.vala"
	_tmp15_ = _tmp14_;
#line 222 "../src/core/ContainerSourceCollection.vala"
	source_collection_destroy_marked ((SourceCollection*) self, _tmp15_, TRUE, NULL, NULL, NULL);
#line 222 "../src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (_tmp15_);
#line 1407 "ContainerSourceCollection.c"
}

static void
_container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender,
                                                                                               GeeCollection* unlinking,
                                                                                               gpointer self)
{
#line 233 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_on_contained_sources_unlinking ((ContainerSourceCollection*) self, unlinking);
#line 1417 "ContainerSourceCollection.c"
}

static void
_container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender,
                                                                                             GeeCollection* relinked,
                                                                                             gpointer self)
{
#line 234 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_on_contained_sources_relinked ((ContainerSourceCollection*) self, relinked);
#line 1427 "ContainerSourceCollection.c"
}

static void
_container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                             DataSource* source,
                                                                                             gpointer self)
{
#line 235 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_on_contained_source_destroyed ((ContainerSourceCollection*) self, source);
#line 1437 "ContainerSourceCollection.c"
}

static void
_container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender,
                                                                                                 DataSource* source,
                                                                                                 gpointer self)
{
#line 236 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_on_contained_source_destroyed ((ContainerSourceCollection*) self, source);
#line 1447 "ContainerSourceCollection.c"
}

void
container_source_collection_attach_collection (ContainerSourceCollection* self,
                                               SourceCollection* collection)
{
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp5_;
#line 225 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (collection != NULL);
#line 226 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = self->priv->attached_collections;
#line 226 "../src/core/ContainerSourceCollection.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, collection)) {
#line 1464 "ContainerSourceCollection.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 227 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = data_collection_to_string ((DataCollection*) collection);
#line 227 "../src/core/ContainerSourceCollection.vala"
		_tmp2_ = _tmp1_;
#line 227 "../src/core/ContainerSourceCollection.vala"
		_tmp3_ = data_collection_to_string ((DataCollection*) self);
#line 227 "../src/core/ContainerSourceCollection.vala"
		_tmp4_ = _tmp3_;
#line 227 "../src/core/ContainerSourceCollection.vala"
		g_warning ("ContainerSourceCollection.vala:227: attempted to multiple-attach '%s' " \
"to '%s'", _tmp2_, _tmp4_);
#line 227 "../src/core/ContainerSourceCollection.vala"
		_g_free0 (_tmp4_);
#line 227 "../src/core/ContainerSourceCollection.vala"
		_g_free0 (_tmp2_);
#line 228 "../src/core/ContainerSourceCollection.vala"
		return;
#line 1485 "ContainerSourceCollection.c"
	}
#line 231 "../src/core/ContainerSourceCollection.vala"
	_tmp5_ = self->priv->attached_collections;
#line 231 "../src/core/ContainerSourceCollection.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, collection);
#line 233 "../src/core/ContainerSourceCollection.vala"
	g_signal_connect (collection, "items-unlinking", (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 234 "../src/core/ContainerSourceCollection.vala"
	g_signal_connect (collection, "items-relinked", (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 235 "../src/core/ContainerSourceCollection.vala"
	g_signal_connect (collection, "item-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 236 "../src/core/ContainerSourceCollection.vala"
	g_signal_connect (collection, "unlinked-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
#line 1499 "ContainerSourceCollection.c"
}

void
container_source_collection_detach_all_collections (ContainerSourceCollection* self)
{
	GeeHashSet* _tmp13_;
#line 239 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (self != NULL);
#line 1508 "ContainerSourceCollection.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 240 "../src/core/ContainerSourceCollection.vala"
		_tmp0_ = self->priv->attached_collections;
#line 240 "../src/core/ContainerSourceCollection.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 240 "../src/core/ContainerSourceCollection.vala"
		_collection_it = _tmp1_;
#line 240 "../src/core/ContainerSourceCollection.vala"
		while (TRUE) {
#line 1521 "ContainerSourceCollection.c"
			GeeIterator* _tmp2_;
			SourceCollection* collection = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			SourceCollection* _tmp5_;
			guint _tmp6_;
			SourceCollection* _tmp7_;
			guint _tmp8_;
			SourceCollection* _tmp9_;
			guint _tmp10_;
			SourceCollection* _tmp11_;
			guint _tmp12_;
#line 240 "../src/core/ContainerSourceCollection.vala"
			_tmp2_ = _collection_it;
#line 240 "../src/core/ContainerSourceCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 240 "../src/core/ContainerSourceCollection.vala"
				break;
#line 1540 "ContainerSourceCollection.c"
			}
#line 240 "../src/core/ContainerSourceCollection.vala"
			_tmp3_ = _collection_it;
#line 240 "../src/core/ContainerSourceCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 240 "../src/core/ContainerSourceCollection.vala"
			collection = (SourceCollection*) _tmp4_;
#line 241 "../src/core/ContainerSourceCollection.vala"
			_tmp5_ = collection;
#line 241 "../src/core/ContainerSourceCollection.vala"
			g_signal_parse_name ("items-unlinking", TYPE_SOURCE_COLLECTION, &_tmp6_, NULL, FALSE);
#line 241 "../src/core/ContainerSourceCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 242 "../src/core/ContainerSourceCollection.vala"
			_tmp7_ = collection;
#line 242 "../src/core/ContainerSourceCollection.vala"
			g_signal_parse_name ("items-relinked", TYPE_SOURCE_COLLECTION, &_tmp8_, NULL, FALSE);
#line 242 "../src/core/ContainerSourceCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 243 "../src/core/ContainerSourceCollection.vala"
			_tmp9_ = collection;
#line 243 "../src/core/ContainerSourceCollection.vala"
			g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp10_, NULL, FALSE);
#line 243 "../src/core/ContainerSourceCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 244 "../src/core/ContainerSourceCollection.vala"
			_tmp11_ = collection;
#line 244 "../src/core/ContainerSourceCollection.vala"
			g_signal_parse_name ("unlinked-destroyed", TYPE_SOURCE_COLLECTION, &_tmp12_, NULL, FALSE);
#line 244 "../src/core/ContainerSourceCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
#line 240 "../src/core/ContainerSourceCollection.vala"
			_data_collection_unref0 (collection);
#line 1574 "ContainerSourceCollection.c"
		}
#line 240 "../src/core/ContainerSourceCollection.vala"
		_g_object_unref0 (_collection_it);
#line 1578 "ContainerSourceCollection.c"
	}
#line 247 "../src/core/ContainerSourceCollection.vala"
	_tmp13_ = self->priv->attached_collections;
#line 247 "../src/core/ContainerSourceCollection.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp13_);
#line 1584 "ContainerSourceCollection.c"
}

static void
container_source_collection_real_container_contents_added (ContainerSourceCollection* self,
                                                           ContainerSource* container,
                                                           GeeCollection* added,
                                                           gboolean relinked)
{
#line 33 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 33 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (added != NULL);
#line 1597 "ContainerSourceCollection.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gboolean arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 28 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (n_param_values == 4);
#line 28 "../src/core/ContainerSourceCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 28 "../src/core/ContainerSourceCollection.vala"
		data1 = closure->data;
#line 28 "../src/core/ContainerSourceCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 1622 "ContainerSourceCollection.c"
	} else {
#line 28 "../src/core/ContainerSourceCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 28 "../src/core/ContainerSourceCollection.vala"
		data2 = closure->data;
#line 1628 "ContainerSourceCollection.c"
	}
#line 28 "../src/core/ContainerSourceCollection.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 28 "../src/core/ContainerSourceCollection.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boolean (param_values + 3), data2);
#line 1634 "ContainerSourceCollection.c"
}

static void
container_source_collection_real_container_contents_removed (ContainerSourceCollection* self,
                                                             ContainerSource* container,
                                                             GeeCollection* removed,
                                                             gboolean unlinked)
{
#line 37 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 37 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (removed != NULL);
#line 1647 "ContainerSourceCollection.c"
}

static void
container_source_collection_real_container_contents_altered (ContainerSourceCollection* self,
                                                             ContainerSource* container,
                                                             GeeCollection* added,
                                                             gboolean relinked,
                                                             GeeCollection* removed,
                                                             gboolean unlinked)
{
#line 41 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 1660 "ContainerSourceCollection.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN (GClosure * closure,
                                                                    GValue * return_value,
                                                                    guint n_param_values,
                                                                    const GValue * param_values,
                                                                    gpointer invocation_hint,
                                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gboolean arg_3, gpointer arg_4, gboolean arg_5, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 28 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (n_param_values == 6);
#line 28 "../src/core/ContainerSourceCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 28 "../src/core/ContainerSourceCollection.vala"
		data1 = closure->data;
#line 28 "../src/core/ContainerSourceCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 1685 "ContainerSourceCollection.c"
	} else {
#line 28 "../src/core/ContainerSourceCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 28 "../src/core/ContainerSourceCollection.vala"
		data2 = closure->data;
#line 1691 "ContainerSourceCollection.c"
	}
#line 28 "../src/core/ContainerSourceCollection.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 28 "../src/core/ContainerSourceCollection.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boolean (param_values + 3), g_value_get_object (param_values + 4), g_value_get_boolean (param_values + 5), data2);
#line 1697 "ContainerSourceCollection.c"
}

static void
container_source_collection_real_backlink_to_container_removed (ContainerSourceCollection* self,
                                                                ContainerSource* container,
                                                                GeeCollection* sources)
{
#line 46 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (container != NULL);
#line 46 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (sources != NULL);
#line 1709 "ContainerSourceCollection.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 28 "../src/core/ContainerSourceCollection.vala"
	g_return_if_fail (n_param_values == 3);
#line 28 "../src/core/ContainerSourceCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 28 "../src/core/ContainerSourceCollection.vala"
		data1 = closure->data;
#line 28 "../src/core/ContainerSourceCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 1734 "ContainerSourceCollection.c"
	} else {
#line 28 "../src/core/ContainerSourceCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 28 "../src/core/ContainerSourceCollection.vala"
		data2 = closure->data;
#line 1740 "ContainerSourceCollection.c"
	}
#line 28 "../src/core/ContainerSourceCollection.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 28 "../src/core/ContainerSourceCollection.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1746 "ContainerSourceCollection.c"
}

static void
container_source_collection_class_init (ContainerSourceCollectionClass * klass,
                                        gpointer klass_data)
{
#line 28 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/core/ContainerSourceCollection.vala"
	((DataCollectionClass *) klass)->finalize = container_source_collection_finalize;
#line 28 "../src/core/ContainerSourceCollection.vala"
	g_type_class_adjust_private_offset (klass, &ContainerSourceCollection_private_offset);
#line 28 "../src/core/ContainerSourceCollection.vala"
	((SourceCollectionClass *) klass)->notify_backlink_removed = (void (*) (SourceCollection*, SourceBacklink*, GeeCollection*)) container_source_collection_real_notify_backlink_removed;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->notify_container_contents_added = (void (*) (ContainerSourceCollection*, ContainerSource*, GeeCollection*, gboolean)) container_source_collection_real_notify_container_contents_added;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->notify_container_contents_removed = (void (*) (ContainerSourceCollection*, ContainerSource*, GeeCollection*, gboolean)) container_source_collection_real_notify_container_contents_removed;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->notify_container_contents_altered = (void (*) (ContainerSourceCollection*, ContainerSource*, GeeCollection*, gboolean, GeeCollection*, gboolean)) container_source_collection_real_notify_container_contents_altered;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->notify_backlink_to_container_removed = (void (*) (ContainerSourceCollection*, ContainerSource*, GeeCollection*)) container_source_collection_real_notify_backlink_to_container_removed;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->get_containers_holding_source = (GeeCollection* (*) (ContainerSourceCollection*, DataSource*)) container_source_collection_real_get_containers_holding_source;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->convert_backlink_to_container = (ContainerSource* (*) (ContainerSourceCollection*, SourceBacklink*)) container_source_collection_real_convert_backlink_to_container;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((SourceCollectionClass *) klass)->notify_item_destroyed = (void (*) (SourceCollection*, DataSource*)) container_source_collection_real_notify_item_destroyed;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->container_contents_added = container_source_collection_real_container_contents_added;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->container_contents_removed = container_source_collection_real_container_contents_removed;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->container_contents_altered = container_source_collection_real_container_contents_altered;
#line 28 "../src/core/ContainerSourceCollection.vala"
	((ContainerSourceCollectionClass *) klass)->backlink_to_container_removed = container_source_collection_real_backlink_to_container_removed;
#line 28 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_ADDED_SIGNAL] = g_signal_new ("container-contents-added", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_added), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
#line 28 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_REMOVED_SIGNAL] = g_signal_new ("container-contents-removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
#line 28 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_CONTAINER_CONTENTS_ALTERED_SIGNAL] = g_signal_new ("container-contents-altered", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN, G_TYPE_NONE, 5, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
#line 28 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_signals[CONTAINER_SOURCE_COLLECTION_BACKLINK_TO_CONTAINER_REMOVED_SIGNAL] = g_signal_new ("backlink-to-container-removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, backlink_to_container_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION);
#line 1791 "ContainerSourceCollection.c"
}

static void
container_source_collection_instance_init (ContainerSourceCollection * self,
                                           gpointer klass)
{
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
#line 28 "../src/core/ContainerSourceCollection.vala"
	self->priv = container_source_collection_get_instance_private (self);
#line 29 "../src/core/ContainerSourceCollection.vala"
	_tmp0_ = gee_hash_set_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, (GDestroyNotify) data_collection_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 29 "../src/core/ContainerSourceCollection.vala"
	self->priv->attached_collections = _tmp0_;
#line 31 "../src/core/ContainerSourceCollection.vala"
	_tmp1_ = gee_hash_set_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 31 "../src/core/ContainerSourceCollection.vala"
	self->priv->holding_tank = _tmp1_;
#line 1810 "ContainerSourceCollection.c"
}

static void
container_source_collection_finalize (DataCollection * obj)
{
	ContainerSourceCollection * self;
#line 28 "../src/core/ContainerSourceCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection);
#line 58 "../src/core/ContainerSourceCollection.vala"
	container_source_collection_detach_all_collections (self);
#line 29 "../src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (self->priv->attached_collections);
#line 30 "../src/core/ContainerSourceCollection.vala"
	_g_free0 (self->priv->backlink_name);
#line 31 "../src/core/ContainerSourceCollection.vala"
	_g_object_unref0 (self->priv->holding_tank);
#line 28 "../src/core/ContainerSourceCollection.vala"
	DATA_COLLECTION_CLASS (container_source_collection_parent_class)->finalize (obj);
#line 1829 "ContainerSourceCollection.c"
}

static GType
container_source_collection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) container_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContainerSourceCollection), 0, (GInstanceInitFunc) container_source_collection_instance_init, NULL };
	GType container_source_collection_type_id;
	container_source_collection_type_id = g_type_register_static (TYPE_DATABASE_SOURCE_COLLECTION, "ContainerSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	ContainerSourceCollection_private_offset = g_type_add_instance_private (container_source_collection_type_id, sizeof (ContainerSourceCollectionPrivate));
	return container_source_collection_type_id;
}

GType
container_source_collection_get_type (void)
{
	static volatile gsize container_source_collection_type_id__once = 0;
	if (g_once_init_enter (&container_source_collection_type_id__once)) {
		GType container_source_collection_type_id;
		container_source_collection_type_id = container_source_collection_get_type_once ();
		g_once_init_leave (&container_source_collection_type_id__once, container_source_collection_type_id);
	}
	return container_source_collection_type_id__once;
}

