/* DataSource.c generated by valac 0.56.18, the Vala compiler
 * generated from DataSource.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* DataSource*/
/**/
/* A DataSource is an object that is unique throughout the system.  DataSources*/
/* commonly have external and/or persistent representations, hence they have a notion of being*/
/* destroyed (versus removed or freed).  Several DataViews may exist that reference a single*/
/* DataSource.  Note that DataSources MUST be destroyed (rather than simply removed) from their*/
/* SourceCollection, and that they MUST be destroyed via their SourceCollection (rather than*/
/* calling DataSource.destroy () directly.)*/
/**/
/* Destroying a DataSource indicates it should remove all secondary and tertiary structures (such*/
/* as thumbnails) and any records pointing to its backing store.  SourceCollection.destroy_marked ()*/
/* has a parameter indicating if the backing should be destroyed as well; that is when*/
/* internal_delete_backing () is called.*/
/**/
/* There are no provisions (currently) for a DataSource to be removed from its SourceCollection*/
/* without destroying its backing and/or secondary and tertiary structures.  DataSources are intended*/
/* to go to the grave with their SourceCollection otherwise.  If a need arises for a DataSource to*/
/* be peaceably removed from its SourceCollection, code will need to be written.  SourceSnapshots*/
/* may be one solution to this problem.*/
/**/
/* Some DataSources cannot be reconstituted (for example, if its backing file is deleted).  In*/
/* that case, dehydrate () should return null.  When reconstituted, it is the responsibility of the*/
/* implementation to ensure an exact clone is produced, minus any details that are not relevant or*/
/* exposed (such as a database ID).*/
/**/
/* If other DataSources refer to this DataSource, their state will *not* be*/
/* saved/restored.  This must be achieved via other means.  However, implementations *should**/
/* track when changes to external state would break the proxy and call notify_broken ();*/
/**/

#include "io.elementary.photos.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DATA_SOURCE_0_PROPERTY,
	DATA_SOURCE_NUM_PROPERTIES
};
static GParamSpec* data_source_properties[DATA_SOURCE_NUM_PROPERTIES];
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	DATA_SOURCE_UNLINKED_SIGNAL,
	DATA_SOURCE_RELINKED_SIGNAL,
	DATA_SOURCE_DESTROYED_SIGNAL,
	DATA_SOURCE_NUM_SIGNALS
};
static guint data_source_signals[DATA_SOURCE_NUM_SIGNALS] = {0};
typedef struct _ParamSpecSourceSnapshot ParamSpecSourceSnapshot;
enum  {
	SOURCE_SNAPSHOT_BROKEN_SIGNAL,
	SOURCE_SNAPSHOT_NUM_SIGNALS
};
static guint source_snapshot_signals[SOURCE_SNAPSHOT_NUM_SIGNALS] = {0};
typedef struct _ParamSpecSourceBacklink ParamSpecSourceBacklink;
#define _source_snapshot_unref0(var) ((var == NULL) ? NULL : (var = (source_snapshot_unref (var), NULL)))
typedef struct _ParamSpecSourceProxy ParamSpecSourceProxy;
enum  {
	SOURCE_PROXY_RECONSTITUTED_SIGNAL,
	SOURCE_PROXY_DEHYDRATED_SIGNAL,
	SOURCE_PROXY_BROKEN_SIGNAL,
	SOURCE_PROXY_NUM_SIGNALS
};
static guint source_proxy_signals[SOURCE_PROXY_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DataSourcePrivate {
	DataView** subscribers;
	gint subscribers_length1;
	gint _subscribers_size_;
	SourceHoldingTank* holding_tank;
	SourceCollection* unlinked_from_collection;
	GeeHashMap* backlinks;
	gboolean in_contact;
	gboolean marked_for_destroy;
	gboolean is_destroyed;
};

struct _SourceSnapshotPrivate {
	gboolean snapshot_broken;
};

struct _ParamSpecSourceSnapshot {
	GParamSpec parent_instance;
};

struct _SourceBacklinkPrivate {
	gchar* _name;
	gchar* _value;
};

struct _ParamSpecSourceBacklink {
	GParamSpec parent_instance;
};

struct _SourceProxyPrivate {
	gint64 object_id;
	gchar* source_string;
	DataSource* source;
	SourceSnapshot* snapshot;
	SourceCollection* membership;
};

struct _ParamSpecSourceProxy {
	GParamSpec parent_instance;
};

static gint DataSource_private_offset;
static gpointer data_source_parent_class = NULL;
static gint SourceSnapshot_private_offset;
static gpointer source_snapshot_parent_class = NULL;
static gint SourceBacklink_private_offset;
static gpointer source_backlink_parent_class = NULL;
static gint SourceProxy_private_offset;
static gpointer source_proxy_parent_class = NULL;

static void data_source_real_notify_membership_changed (DataObject* base,
                                                 DataCollection* collection);
static void data_source_real_notify_held_in_tank (DataSource* self,
                                           SourceHoldingTank* holding_tank);
static void data_source_real_notify_altered (DataObject* base,
                                      Alteration* alteration);
static void data_source_real_notify_unlinking (DataSource* self,
                                        SourceCollection* collection);
static void data_source_real_notify_unlinked (DataSource* self);
static gchar* data_source_dehydrate_backlinks (DataSource* self);
static void data_source_real_notify_relinking (DataSource* self,
                                        SourceCollection* collection);
static void data_source_real_notify_relinked (DataSource* self);
static gchar* data_source_real_get_typename (DataSource* self);
static gint64 data_source_real_get_instance_id (DataSource* self);
static gchar* data_source_real_get_source_id (DataSource* self);
static void data_source_real_commit_backlinks (DataSource* self,
                                        SourceCollection* sources,
                                        const gchar* dehydrated);
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self);
static gboolean data_source_real_internal_delete_backing (DataSource* self,
                                                   GError** error);
static gboolean data_source_real_equals (DataSource* self,
                                  DataSource* source);
static void data_source_real_destroy (DataSource* self);
static void _vala_array_add48 (DataView** * array,
                        gint* length,
                        gint* size,
                        DataView* value);
static void data_source_real_unlinked (DataSource* self,
                                SourceCollection* sources);
static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void data_source_real_relinked (DataSource* self,
                                SourceCollection* sources);
static void data_source_real_destroyed (DataSource* self);
static void data_source_finalize (GObject * obj);
static GType data_source_get_type_once (void);
static void source_snapshot_real_notify_broken (SourceSnapshot* self);
static void source_snapshot_real_broken (SourceSnapshot* self);
static void source_snapshot_finalize (SourceSnapshot * obj);
static GType source_snapshot_get_type_once (void);
static gboolean source_backlink_validate_name_value (const gchar* name,
                                              const gchar* value);
static void source_backlink_finalize (SourceBacklink * obj);
static GType source_backlink_get_type_once (void);
static void source_proxy_drop_source (SourceProxy* self);
static void source_proxy_on_source_added (SourceProxy* self,
                                   GeeIterable* added);
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender,
                                                                GeeIterable* added,
                                                                gpointer self);
static void source_proxy_on_snapshot_broken (SourceProxy* self);
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender,
                                                              gpointer self);
static void source_proxy_set_source (SourceProxy* self,
                              DataSource* source);
static DataSource* source_proxy_real_reconstitute (SourceProxy* self,
                                            gint64 object_id,
                                            SourceSnapshot* snapshot);
static void source_proxy_real_notify_reconstituted (SourceProxy* self,
                                             DataSource* source);
static void source_proxy_real_notify_dehydrated (SourceProxy* self);
static void source_proxy_real_notify_broken (SourceProxy* self);
static void source_proxy_on_destroyed (SourceProxy* self);
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender,
                                                       gpointer self);
static void source_proxy_real_reconstituted (SourceProxy* self,
                                      DataSource* source);
static void source_proxy_real_dehydrated (SourceProxy* self);
static void source_proxy_real_broken (SourceProxy* self);
static void source_proxy_finalize (SourceProxy * obj);
static GType source_proxy_get_type_once (void);
static GType proxyable_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
data_source_get_instance_private (DataSource* self)
{
	return G_STRUCT_MEMBER_P (self, DataSource_private_offset);
}

DataSource*
data_source_construct (GType object_type,
                       gint64 object_id)
{
	DataSource * self = NULL;
#line 77 "../src/core/DataSource.vala"
	self = (DataSource*) data_object_construct (object_type, object_id);
#line 76 "../src/core/DataSource.vala"
	return self;
#line 262 "DataSource.c"
}

static void
data_source_real_notify_membership_changed (DataObject* base,
                                            DataCollection* collection)
{
	DataSource * self;
	gboolean _tmp2_ = FALSE;
#line 86 "../src/core/DataSource.vala"
	self = (DataSource*) base;
#line 88 "../src/core/DataSource.vala"
	if (collection == NULL) {
#line 275 "DataSource.c"
		gboolean _tmp0_ = FALSE;
#line 89 "../src/core/DataSource.vala"
		if (self->priv->is_destroyed) {
#line 89 "../src/core/DataSource.vala"
			_tmp0_ = TRUE;
#line 281 "DataSource.c"
		} else {
			GeeHashMap* _tmp1_;
#line 89 "../src/core/DataSource.vala"
			_tmp1_ = self->priv->backlinks;
#line 89 "../src/core/DataSource.vala"
			_tmp0_ = _tmp1_ != NULL;
#line 288 "DataSource.c"
		}
#line 89 "../src/core/DataSource.vala"
		_vala_assert (_tmp0_, "is_destroyed || backlinks != null");
#line 292 "DataSource.c"
	} else {
#line 91 "../src/core/DataSource.vala"
		_vala_assert (!self->priv->is_destroyed, "!is_destroyed");
#line 296 "DataSource.c"
	}
#line 95 "../src/core/DataSource.vala"
	if (collection == NULL) {
#line 300 "DataSource.c"
		GeeHashMap* _tmp3_;
#line 95 "../src/core/DataSource.vala"
		_tmp3_ = self->priv->backlinks;
#line 95 "../src/core/DataSource.vala"
		_tmp2_ = _tmp3_ != NULL;
#line 306 "DataSource.c"
	} else {
#line 95 "../src/core/DataSource.vala"
		_tmp2_ = FALSE;
#line 310 "DataSource.c"
	}
#line 95 "../src/core/DataSource.vala"
	if (_tmp2_) {
#line 96 "../src/core/DataSource.vala"
		data_source_notify_unlinked (self);
#line 316 "DataSource.c"
	}
#line 98 "../src/core/DataSource.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_membership_changed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), collection);
#line 320 "DataSource.c"
}

static gpointer
_source_holding_tank_ref0 (gpointer self)
{
#line 113 "../src/core/DataSource.vala"
	return self ? source_holding_tank_ref (self) : NULL;
#line 328 "DataSource.c"
}

static void
data_source_real_notify_held_in_tank (DataSource* self,
                                      SourceHoldingTank* holding_tank)
{
	DataCollection* _tmp0_;
	DataCollection* _tmp1_;
	SourceHoldingTank* _tmp4_;
#line 103 "../src/core/DataSource.vala"
	_tmp0_ = data_object_get_membership ((DataObject*) self);
#line 103 "../src/core/DataSource.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/core/DataSource.vala"
	_vala_assert (_tmp1_ == NULL, "get_membership () == null");
#line 103 "../src/core/DataSource.vala"
	_data_collection_unref0 (_tmp1_);
#line 107 "../src/core/DataSource.vala"
	if (holding_tank != NULL) {
#line 348 "DataSource.c"
		SourceHoldingTank* _tmp2_;
#line 108 "../src/core/DataSource.vala"
		_tmp2_ = self->priv->holding_tank;
#line 108 "../src/core/DataSource.vala"
		_vala_assert (_tmp2_ == NULL, "this.holding_tank == null");
#line 354 "DataSource.c"
	} else {
		SourceHoldingTank* _tmp3_;
#line 110 "../src/core/DataSource.vala"
		_tmp3_ = self->priv->holding_tank;
#line 110 "../src/core/DataSource.vala"
		_vala_assert (_tmp3_ != NULL, "this.holding_tank != null");
#line 361 "DataSource.c"
	}
#line 113 "../src/core/DataSource.vala"
	_tmp4_ = _source_holding_tank_ref0 (holding_tank);
#line 113 "../src/core/DataSource.vala"
	_source_holding_tank_unref0 (self->priv->holding_tank);
#line 113 "../src/core/DataSource.vala"
	self->priv->holding_tank = _tmp4_;
#line 369 "DataSource.c"
}

void
data_source_notify_held_in_tank (DataSource* self,
                                 SourceHoldingTank* holding_tank)
{
	DataSourceClass* _klass_;
#line 101 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 101 "../src/core/DataSource.vala"
	if (_klass_->notify_held_in_tank) {
#line 101 "../src/core/DataSource.vala"
		_klass_->notify_held_in_tank (self, holding_tank);
#line 385 "DataSource.c"
	}
}

static void
data_source_real_notify_altered (DataObject* base,
                                 Alteration* alteration)
{
	DataSource * self;
	SourceHoldingTank* _tmp0_;
#line 116 "../src/core/DataSource.vala"
	self = (DataSource*) base;
#line 116 "../src/core/DataSource.vala"
	g_return_if_fail (alteration != NULL);
#line 118 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->holding_tank;
#line 118 "../src/core/DataSource.vala"
	if (_tmp0_ != NULL) {
#line 403 "DataSource.c"
		SourceHoldingTank* _tmp1_;
#line 119 "../src/core/DataSource.vala"
		_tmp1_ = self->priv->holding_tank;
#line 119 "../src/core/DataSource.vala"
		source_holding_tank_internal_notify_altered (_tmp1_, self, alteration);
#line 409 "DataSource.c"
	} else {
#line 121 "../src/core/DataSource.vala"
		data_source_contact_subscribers_alteration (self, alteration);
#line 123 "../src/core/DataSource.vala"
		DATA_OBJECT_CLASS (data_source_parent_class)->notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), alteration);
#line 415 "DataSource.c"
	}
}

static void
data_source_real_notify_unlinking (DataSource* self,
                                   SourceCollection* collection)
{
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp3_;
#line 128 "../src/core/DataSource.vala"
	g_return_if_fail (collection != NULL);
#line 129 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 129 "../src/core/DataSource.vala"
	if (_tmp1_ == NULL) {
#line 432 "DataSource.c"
		SourceCollection* _tmp2_;
#line 129 "../src/core/DataSource.vala"
		_tmp2_ = self->priv->unlinked_from_collection;
#line 129 "../src/core/DataSource.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 438 "DataSource.c"
	} else {
#line 129 "../src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 442 "DataSource.c"
	}
#line 129 "../src/core/DataSource.vala"
	_vala_assert (_tmp0_, "backlinks == null && unlinked_from_collection == null");
#line 131 "../src/core/DataSource.vala"
	self->priv->unlinked_from_collection = collection;
#line 132 "../src/core/DataSource.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 132 "../src/core/DataSource.vala"
	_g_object_unref0 (self->priv->backlinks);
#line 132 "../src/core/DataSource.vala"
	self->priv->backlinks = _tmp3_;
#line 454 "DataSource.c"
}

void
data_source_notify_unlinking (DataSource* self,
                              SourceCollection* collection)
{
	DataSourceClass* _klass_;
#line 128 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 128 "../src/core/DataSource.vala"
	if (_klass_->notify_unlinking) {
#line 128 "../src/core/DataSource.vala"
		_klass_->notify_unlinking (self, collection);
#line 470 "DataSource.c"
	}
}

static void
data_source_real_notify_unlinked (DataSource* self)
{
	gboolean _tmp0_ = FALSE;
	SourceCollection* _tmp1_;
	SourceCollection* _tmp3_;
	GeeHashMap* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 137 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->unlinked_from_collection;
#line 137 "../src/core/DataSource.vala"
	if (_tmp1_ != NULL) {
#line 487 "DataSource.c"
		GeeHashMap* _tmp2_;
#line 137 "../src/core/DataSource.vala"
		_tmp2_ = self->priv->backlinks;
#line 137 "../src/core/DataSource.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 493 "DataSource.c"
	} else {
#line 137 "../src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 497 "DataSource.c"
	}
#line 137 "../src/core/DataSource.vala"
	_vala_assert (_tmp0_, "unlinked_from_collection != null && backlinks != null");
#line 139 "../src/core/DataSource.vala"
	_tmp3_ = self->priv->unlinked_from_collection;
#line 139 "../src/core/DataSource.vala"
	g_signal_emit (self, data_source_signals[DATA_SOURCE_UNLINKED_SIGNAL], 0, _tmp3_);
#line 142 "../src/core/DataSource.vala"
	_tmp4_ = self->priv->backlinks;
#line 142 "../src/core/DataSource.vala"
	_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
#line 142 "../src/core/DataSource.vala"
	_tmp6_ = _tmp5_;
#line 142 "../src/core/DataSource.vala"
	if (_tmp6_ > 0) {
#line 513 "DataSource.c"
		SourceCollection* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 143 "../src/core/DataSource.vala"
		_tmp7_ = self->priv->unlinked_from_collection;
#line 143 "../src/core/DataSource.vala"
		_tmp8_ = data_source_dehydrate_backlinks (self);
#line 143 "../src/core/DataSource.vala"
		_tmp9_ = _tmp8_;
#line 143 "../src/core/DataSource.vala"
		data_source_commit_backlinks (self, _tmp7_, _tmp9_);
#line 143 "../src/core/DataSource.vala"
		_g_free0 (_tmp9_);
#line 527 "DataSource.c"
	}
}

void
data_source_notify_unlinked (DataSource* self)
{
	DataSourceClass* _klass_;
#line 136 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 136 "../src/core/DataSource.vala"
	if (_klass_->notify_unlinked) {
#line 136 "../src/core/DataSource.vala"
		_klass_->notify_unlinked (self);
#line 543 "DataSource.c"
	}
}

static void
data_source_real_notify_relinking (DataSource* self,
                                   SourceCollection* collection)
{
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_;
#line 147 "../src/core/DataSource.vala"
	g_return_if_fail (collection != NULL);
#line 148 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 148 "../src/core/DataSource.vala"
	if (_tmp1_ != NULL) {
#line 559 "DataSource.c"
		SourceCollection* _tmp2_;
#line 148 "../src/core/DataSource.vala"
		_tmp2_ = self->priv->unlinked_from_collection;
#line 148 "../src/core/DataSource.vala"
		_tmp0_ = _tmp2_ == collection;
#line 565 "DataSource.c"
	} else {
#line 148 "../src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 569 "DataSource.c"
	}
#line 148 "../src/core/DataSource.vala"
	_vala_assert (_tmp0_, "(backlinks != null) && (unlinked_from_collection == collection)");
#line 573 "DataSource.c"
}

void
data_source_notify_relinking (DataSource* self,
                              SourceCollection* collection)
{
	DataSourceClass* _klass_;
#line 147 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 147 "../src/core/DataSource.vala"
	if (_klass_->notify_relinking) {
#line 147 "../src/core/DataSource.vala"
		_klass_->notify_relinking (self, collection);
#line 589 "DataSource.c"
	}
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 155 "../src/core/DataSource.vala"
	return self ? data_collection_ref (self) : NULL;
#line 598 "DataSource.c"
}

static void
data_source_real_notify_relinked (DataSource* self)
{
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_;
	SourceCollection* relinked_to = NULL;
	SourceCollection* _tmp3_;
	SourceCollection* _tmp4_;
#line 153 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 153 "../src/core/DataSource.vala"
	if (_tmp1_ != NULL) {
#line 613 "DataSource.c"
		SourceCollection* _tmp2_;
#line 153 "../src/core/DataSource.vala"
		_tmp2_ = self->priv->unlinked_from_collection;
#line 153 "../src/core/DataSource.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 619 "DataSource.c"
	} else {
#line 153 "../src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 623 "DataSource.c"
	}
#line 153 "../src/core/DataSource.vala"
	_vala_assert (_tmp0_, "backlinks != null && unlinked_from_collection != null");
#line 155 "../src/core/DataSource.vala"
	_tmp3_ = self->priv->unlinked_from_collection;
#line 155 "../src/core/DataSource.vala"
	_tmp4_ = _data_collection_ref0 (_tmp3_);
#line 155 "../src/core/DataSource.vala"
	relinked_to = _tmp4_;
#line 156 "../src/core/DataSource.vala"
	_g_object_unref0 (self->priv->backlinks);
#line 156 "../src/core/DataSource.vala"
	self->priv->backlinks = NULL;
#line 157 "../src/core/DataSource.vala"
	self->priv->unlinked_from_collection = NULL;
#line 158 "../src/core/DataSource.vala"
	g_signal_emit (self, data_source_signals[DATA_SOURCE_RELINKED_SIGNAL], 0, relinked_to);
#line 161 "../src/core/DataSource.vala"
	data_source_commit_backlinks (self, NULL, NULL);
#line 152 "../src/core/DataSource.vala"
	_data_collection_unref0 (relinked_to);
#line 645 "DataSource.c"
}

void
data_source_notify_relinked (DataSource* self)
{
	DataSourceClass* _klass_;
#line 152 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 152 "../src/core/DataSource.vala"
	if (_klass_->notify_relinked) {
#line 152 "../src/core/DataSource.vala"
		_klass_->notify_relinked (self);
#line 660 "DataSource.c"
	}
}

static gchar*
data_source_real_get_typename (DataSource* self)
{
#line 169 "../src/core/DataSource.vala"
	g_critical ("Type `%s' does not implement abstract method `data_source_get_typename'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 169 "../src/core/DataSource.vala"
	return NULL;
#line 671 "DataSource.c"
}

gchar*
data_source_get_typename (DataSource* self)
{
	DataSourceClass* _klass_;
#line 169 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 169 "../src/core/DataSource.vala"
	if (_klass_->get_typename) {
#line 169 "../src/core/DataSource.vala"
		return _klass_->get_typename (self);
#line 686 "DataSource.c"
	}
#line 169 "../src/core/DataSource.vala"
	return NULL;
#line 690 "DataSource.c"
}

static gint64
data_source_real_get_instance_id (DataSource* self)
{
	gint64 _tmp0_ = 0LL;
#line 175 "../src/core/DataSource.vala"
	g_critical ("Type `%s' does not implement abstract method `data_source_get_instance_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 175 "../src/core/DataSource.vala"
	return _tmp0_;
#line 701 "DataSource.c"
}

gint64
data_source_get_instance_id (DataSource* self)
{
	DataSourceClass* _klass_;
#line 175 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 175 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 175 "../src/core/DataSource.vala"
	if (_klass_->get_instance_id) {
#line 175 "../src/core/DataSource.vala"
		return _klass_->get_instance_id (self);
#line 716 "DataSource.c"
	}
#line 175 "../src/core/DataSource.vala"
	return -1LL;
#line 720 "DataSource.c"
}

static gchar*
data_source_real_get_source_id (DataSource* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 180 "../src/core/DataSource.vala"
	_tmp0_ = data_source_get_typename (self);
#line 180 "../src/core/DataSource.vala"
	_tmp1_ = _tmp0_;
#line 180 "../src/core/DataSource.vala"
	_tmp2_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id (self));
#line 180 "../src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 180 "../src/core/DataSource.vala"
	_g_free0 (_tmp1_);
#line 180 "../src/core/DataSource.vala"
	result = _tmp3_;
#line 180 "../src/core/DataSource.vala"
	return result;
#line 745 "DataSource.c"
}

gchar*
data_source_get_source_id (DataSource* self)
{
	DataSourceClass* _klass_;
#line 179 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 179 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 179 "../src/core/DataSource.vala"
	if (_klass_->get_source_id) {
#line 179 "../src/core/DataSource.vala"
		return _klass_->get_source_id (self);
#line 760 "DataSource.c"
	}
#line 179 "../src/core/DataSource.vala"
	return NULL;
#line 764 "DataSource.c"
}

gboolean
data_source_has_backlink (DataSource* self,
                          SourceBacklink* backlink)
{
	GeeHashMap* _tmp0_;
	GeeList* values = NULL;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	gboolean _tmp5_ = FALSE;
	GeeList* _tmp6_;
	gboolean result;
#line 183 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 183 "../src/core/DataSource.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 184 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->backlinks;
#line 184 "../src/core/DataSource.vala"
	if (_tmp0_ == NULL) {
#line 185 "../src/core/DataSource.vala"
		result = FALSE;
#line 185 "../src/core/DataSource.vala"
		return result;
#line 792 "DataSource.c"
	}
#line 187 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 187 "../src/core/DataSource.vala"
	_tmp2_ = source_backlink_get_name (backlink);
#line 187 "../src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 187 "../src/core/DataSource.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp3_);
#line 187 "../src/core/DataSource.vala"
	values = (GeeList*) _tmp4_;
#line 189 "../src/core/DataSource.vala"
	_tmp6_ = values;
#line 189 "../src/core/DataSource.vala"
	if (_tmp6_ != NULL) {
#line 808 "DataSource.c"
		GeeList* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 189 "../src/core/DataSource.vala"
		_tmp7_ = values;
#line 189 "../src/core/DataSource.vala"
		_tmp8_ = source_backlink_get_value (backlink);
#line 189 "../src/core/DataSource.vala"
		_tmp9_ = _tmp8_;
#line 189 "../src/core/DataSource.vala"
		_tmp5_ = gee_collection_contains ((GeeCollection*) _tmp7_, _tmp9_);
#line 820 "DataSource.c"
	} else {
#line 189 "../src/core/DataSource.vala"
		_tmp5_ = FALSE;
#line 824 "DataSource.c"
	}
#line 189 "../src/core/DataSource.vala"
	result = _tmp5_;
#line 189 "../src/core/DataSource.vala"
	_g_object_unref0 (values);
#line 189 "../src/core/DataSource.vala"
	return result;
#line 832 "DataSource.c"
}

GeeList*
data_source_get_backlinks (DataSource* self,
                           const gchar* name)
{
	GeeHashMap* _tmp0_;
	GeeList* values = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeList* _tmp4_;
	GeeList* backlinks = NULL;
	GeeArrayList* _tmp8_;
	GeeList* result;
#line 192 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 192 "../src/core/DataSource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 193 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->backlinks;
#line 193 "../src/core/DataSource.vala"
	if (_tmp0_ == NULL) {
#line 194 "../src/core/DataSource.vala"
		result = NULL;
#line 194 "../src/core/DataSource.vala"
		return result;
#line 860 "DataSource.c"
	}
#line 196 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 196 "../src/core/DataSource.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, name);
#line 196 "../src/core/DataSource.vala"
	values = (GeeList*) _tmp2_;
#line 197 "../src/core/DataSource.vala"
	_tmp4_ = values;
#line 197 "../src/core/DataSource.vala"
	if (_tmp4_ == NULL) {
#line 197 "../src/core/DataSource.vala"
		_tmp3_ = TRUE;
#line 874 "DataSource.c"
	} else {
		GeeList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 197 "../src/core/DataSource.vala"
		_tmp5_ = values;
#line 197 "../src/core/DataSource.vala"
		_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 197 "../src/core/DataSource.vala"
		_tmp7_ = _tmp6_;
#line 197 "../src/core/DataSource.vala"
		_tmp3_ = _tmp7_ == 0;
#line 887 "DataSource.c"
	}
#line 197 "../src/core/DataSource.vala"
	if (_tmp3_) {
#line 198 "../src/core/DataSource.vala"
		result = NULL;
#line 198 "../src/core/DataSource.vala"
		_g_object_unref0 (values);
#line 198 "../src/core/DataSource.vala"
		return result;
#line 897 "DataSource.c"
	}
#line 200 "../src/core/DataSource.vala"
	_tmp8_ = gee_array_list_new (TYPE_SOURCE_BACKLINK, (GBoxedCopyFunc) source_backlink_ref, (GDestroyNotify) source_backlink_unref, NULL, NULL, NULL);
#line 200 "../src/core/DataSource.vala"
	backlinks = (GeeList*) _tmp8_;
#line 903 "DataSource.c"
	{
		GeeList* _value_list = NULL;
		GeeList* _tmp9_;
		gint _value_size = 0;
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _value_index = 0;
#line 201 "../src/core/DataSource.vala"
		_tmp9_ = values;
#line 201 "../src/core/DataSource.vala"
		_value_list = _tmp9_;
#line 201 "../src/core/DataSource.vala"
		_tmp10_ = _value_list;
#line 201 "../src/core/DataSource.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 201 "../src/core/DataSource.vala"
		_tmp12_ = _tmp11_;
#line 201 "../src/core/DataSource.vala"
		_value_size = _tmp12_;
#line 201 "../src/core/DataSource.vala"
		_value_index = -1;
#line 201 "../src/core/DataSource.vala"
		while (TRUE) {
#line 928 "DataSource.c"
			gint _tmp13_;
			gint _tmp14_;
			gchar* value = NULL;
			GeeList* _tmp15_;
			gpointer _tmp16_;
			GeeList* _tmp17_;
			const gchar* _tmp18_;
			SourceBacklink* _tmp19_;
			SourceBacklink* _tmp20_;
#line 201 "../src/core/DataSource.vala"
			_value_index = _value_index + 1;
#line 201 "../src/core/DataSource.vala"
			_tmp13_ = _value_index;
#line 201 "../src/core/DataSource.vala"
			_tmp14_ = _value_size;
#line 201 "../src/core/DataSource.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 201 "../src/core/DataSource.vala"
				break;
#line 948 "DataSource.c"
			}
#line 201 "../src/core/DataSource.vala"
			_tmp15_ = _value_list;
#line 201 "../src/core/DataSource.vala"
			_tmp16_ = gee_list_get (_tmp15_, _value_index);
#line 201 "../src/core/DataSource.vala"
			value = (gchar*) _tmp16_;
#line 202 "../src/core/DataSource.vala"
			_tmp17_ = backlinks;
#line 202 "../src/core/DataSource.vala"
			_tmp18_ = value;
#line 202 "../src/core/DataSource.vala"
			_tmp19_ = source_backlink_new (name, _tmp18_);
#line 202 "../src/core/DataSource.vala"
			_tmp20_ = _tmp19_;
#line 202 "../src/core/DataSource.vala"
			gee_collection_add ((GeeCollection*) _tmp17_, _tmp20_);
#line 202 "../src/core/DataSource.vala"
			_source_backlink_unref0 (_tmp20_);
#line 201 "../src/core/DataSource.vala"
			_g_free0 (value);
#line 970 "DataSource.c"
		}
	}
#line 204 "../src/core/DataSource.vala"
	result = backlinks;
#line 204 "../src/core/DataSource.vala"
	_g_object_unref0 (values);
#line 204 "../src/core/DataSource.vala"
	return result;
#line 979 "DataSource.c"
}

void
data_source_set_backlink (DataSource* self,
                          SourceBacklink* backlink)
{
	GeeHashMap* _tmp0_;
	GeeList* values = NULL;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	GeeList* _tmp5_;
	GeeList* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	SourceCollection* sources = NULL;
	DataCollection* _tmp14_;
	SourceCollection* _tmp15_;
#line 207 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/core/DataSource.vala"
	g_return_if_fail (backlink != NULL);
#line 209 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->backlinks;
#line 209 "../src/core/DataSource.vala"
	_vala_assert (_tmp0_ != NULL, "backlinks != null");
#line 211 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 211 "../src/core/DataSource.vala"
	_tmp2_ = source_backlink_get_name (backlink);
#line 211 "../src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 211 "../src/core/DataSource.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp3_);
#line 211 "../src/core/DataSource.vala"
	values = (GeeList*) _tmp4_;
#line 212 "../src/core/DataSource.vala"
	_tmp5_ = values;
#line 212 "../src/core/DataSource.vala"
	if (_tmp5_ == NULL) {
#line 1021 "DataSource.c"
		GeeArrayList* _tmp6_;
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GeeList* _tmp10_;
#line 213 "../src/core/DataSource.vala"
		_tmp6_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 213 "../src/core/DataSource.vala"
		_g_object_unref0 (values);
#line 213 "../src/core/DataSource.vala"
		values = (GeeList*) _tmp6_;
#line 214 "../src/core/DataSource.vala"
		_tmp7_ = self->priv->backlinks;
#line 214 "../src/core/DataSource.vala"
		_tmp8_ = source_backlink_get_name (backlink);
#line 214 "../src/core/DataSource.vala"
		_tmp9_ = _tmp8_;
#line 214 "../src/core/DataSource.vala"
		_tmp10_ = values;
#line 214 "../src/core/DataSource.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, _tmp9_, _tmp10_);
#line 1043 "DataSource.c"
	}
#line 217 "../src/core/DataSource.vala"
	_tmp11_ = values;
#line 217 "../src/core/DataSource.vala"
	_tmp12_ = source_backlink_get_value (backlink);
#line 217 "../src/core/DataSource.vala"
	_tmp13_ = _tmp12_;
#line 217 "../src/core/DataSource.vala"
	gee_collection_add ((GeeCollection*) _tmp11_, _tmp13_);
#line 219 "../src/core/DataSource.vala"
	_tmp14_ = data_object_get_membership ((DataObject*) self);
#line 219 "../src/core/DataSource.vala"
	sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_SOURCE_COLLECTION, SourceCollection);
#line 220 "../src/core/DataSource.vala"
	_tmp15_ = sources;
#line 220 "../src/core/DataSource.vala"
	if (_tmp15_ != NULL) {
#line 1061 "DataSource.c"
		SourceCollection* _tmp16_;
#line 221 "../src/core/DataSource.vala"
		_tmp16_ = sources;
#line 221 "../src/core/DataSource.vala"
		source_collection_internal_backlink_set (_tmp16_, self, backlink);
#line 1067 "DataSource.c"
	}
#line 207 "../src/core/DataSource.vala"
	_data_collection_unref0 (sources);
#line 207 "../src/core/DataSource.vala"
	_g_object_unref0 (values);
#line 1073 "DataSource.c"
}

gboolean
data_source_remove_backlink (DataSource* self,
                             SourceBacklink* backlink)
{
	GeeHashMap* _tmp0_;
	GeeList* values = NULL;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	GeeList* _tmp5_;
	gint original_size = 0;
	GeeList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GeeIterator* iter = NULL;
	GeeList* _tmp9_;
	GeeIterator* _tmp10_;
	GeeList* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	SourceCollection* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	SourceCollection* sources = NULL;
	DataCollection* _tmp28_;
	SourceCollection* _tmp29_;
	GeeList* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	gboolean result;
#line 224 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../src/core/DataSource.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 225 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->backlinks;
#line 225 "../src/core/DataSource.vala"
	if (_tmp0_ == NULL) {
#line 226 "../src/core/DataSource.vala"
		result = FALSE;
#line 226 "../src/core/DataSource.vala"
		return result;
#line 1119 "DataSource.c"
	}
#line 228 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 228 "../src/core/DataSource.vala"
	_tmp2_ = source_backlink_get_name (backlink);
#line 228 "../src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 228 "../src/core/DataSource.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp3_);
#line 228 "../src/core/DataSource.vala"
	values = (GeeList*) _tmp4_;
#line 229 "../src/core/DataSource.vala"
	_tmp5_ = values;
#line 229 "../src/core/DataSource.vala"
	if (_tmp5_ == NULL) {
#line 230 "../src/core/DataSource.vala"
		result = FALSE;
#line 230 "../src/core/DataSource.vala"
		_g_object_unref0 (values);
#line 230 "../src/core/DataSource.vala"
		return result;
#line 1141 "DataSource.c"
	}
#line 232 "../src/core/DataSource.vala"
	_tmp6_ = values;
#line 232 "../src/core/DataSource.vala"
	_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 232 "../src/core/DataSource.vala"
	_tmp8_ = _tmp7_;
#line 232 "../src/core/DataSource.vala"
	original_size = _tmp8_;
#line 233 "../src/core/DataSource.vala"
	_vala_assert (original_size > 0, "original_size > 0");
#line 235 "../src/core/DataSource.vala"
	_tmp9_ = values;
#line 235 "../src/core/DataSource.vala"
	_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 235 "../src/core/DataSource.vala"
	iter = _tmp10_;
#line 236 "../src/core/DataSource.vala"
	while (TRUE) {
#line 1161 "DataSource.c"
		GeeIterator* _tmp11_;
		GeeIterator* _tmp12_;
		gpointer _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gboolean _tmp17_;
#line 236 "../src/core/DataSource.vala"
		_tmp11_ = iter;
#line 236 "../src/core/DataSource.vala"
		if (!gee_iterator_next (_tmp11_)) {
#line 236 "../src/core/DataSource.vala"
			break;
#line 1175 "DataSource.c"
		}
#line 237 "../src/core/DataSource.vala"
		_tmp12_ = iter;
#line 237 "../src/core/DataSource.vala"
		_tmp13_ = gee_iterator_get (_tmp12_);
#line 237 "../src/core/DataSource.vala"
		_tmp14_ = (gchar*) _tmp13_;
#line 237 "../src/core/DataSource.vala"
		_tmp15_ = source_backlink_get_value (backlink);
#line 237 "../src/core/DataSource.vala"
		_tmp16_ = _tmp15_;
#line 237 "../src/core/DataSource.vala"
		_tmp17_ = g_strcmp0 (_tmp14_, _tmp16_) == 0;
#line 237 "../src/core/DataSource.vala"
		_g_free0 (_tmp14_);
#line 237 "../src/core/DataSource.vala"
		if (_tmp17_) {
#line 1193 "DataSource.c"
			GeeIterator* _tmp18_;
#line 238 "../src/core/DataSource.vala"
			_tmp18_ = iter;
#line 238 "../src/core/DataSource.vala"
			gee_iterator_remove (_tmp18_);
#line 1199 "DataSource.c"
		}
	}
#line 241 "../src/core/DataSource.vala"
	_tmp19_ = values;
#line 241 "../src/core/DataSource.vala"
	_tmp20_ = gee_collection_get_size ((GeeCollection*) _tmp19_);
#line 241 "../src/core/DataSource.vala"
	_tmp21_ = _tmp20_;
#line 241 "../src/core/DataSource.vala"
	if (_tmp21_ == 0) {
#line 1210 "DataSource.c"
		GeeHashMap* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
#line 242 "../src/core/DataSource.vala"
		_tmp22_ = self->priv->backlinks;
#line 242 "../src/core/DataSource.vala"
		_tmp23_ = source_backlink_get_name (backlink);
#line 242 "../src/core/DataSource.vala"
		_tmp24_ = _tmp23_;
#line 242 "../src/core/DataSource.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp22_, _tmp24_, NULL);
#line 1222 "DataSource.c"
	}
#line 246 "../src/core/DataSource.vala"
	_tmp25_ = self->priv->unlinked_from_collection;
#line 246 "../src/core/DataSource.vala"
	_tmp26_ = data_source_dehydrate_backlinks (self);
#line 246 "../src/core/DataSource.vala"
	_tmp27_ = _tmp26_;
#line 246 "../src/core/DataSource.vala"
	data_source_commit_backlinks (self, _tmp25_, _tmp27_);
#line 246 "../src/core/DataSource.vala"
	_g_free0 (_tmp27_);
#line 248 "../src/core/DataSource.vala"
	_tmp28_ = data_object_get_membership ((DataObject*) self);
#line 248 "../src/core/DataSource.vala"
	sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_SOURCE_COLLECTION, SourceCollection);
#line 249 "../src/core/DataSource.vala"
	_tmp29_ = sources;
#line 249 "../src/core/DataSource.vala"
	if (_tmp29_ != NULL) {
#line 1242 "DataSource.c"
		SourceCollection* _tmp30_;
#line 250 "../src/core/DataSource.vala"
		_tmp30_ = sources;
#line 250 "../src/core/DataSource.vala"
		source_collection_internal_backlink_removed (_tmp30_, self, backlink);
#line 1248 "DataSource.c"
	}
#line 252 "../src/core/DataSource.vala"
	_tmp31_ = values;
#line 252 "../src/core/DataSource.vala"
	_tmp32_ = gee_collection_get_size ((GeeCollection*) _tmp31_);
#line 252 "../src/core/DataSource.vala"
	_tmp33_ = _tmp32_;
#line 252 "../src/core/DataSource.vala"
	result = _tmp33_ != original_size;
#line 252 "../src/core/DataSource.vala"
	_data_collection_unref0 (sources);
#line 252 "../src/core/DataSource.vala"
	_g_object_unref0 (iter);
#line 252 "../src/core/DataSource.vala"
	_g_object_unref0 (values);
#line 252 "../src/core/DataSource.vala"
	return result;
#line 1266 "DataSource.c"
}

static void
data_source_real_commit_backlinks (DataSource* self,
                                   SourceCollection* sources,
                                   const gchar* dehydrated)
{
	gboolean _tmp0_ = FALSE;
#line 262 "../src/core/DataSource.vala"
	if (sources != NULL) {
#line 262 "../src/core/DataSource.vala"
		_tmp0_ = TRUE;
#line 1279 "DataSource.c"
	} else {
#line 262 "../src/core/DataSource.vala"
		_tmp0_ = dehydrated != NULL;
#line 1283 "DataSource.c"
	}
#line 262 "../src/core/DataSource.vala"
	if (_tmp0_) {
#line 1287 "DataSource.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 263 "../src/core/DataSource.vala"
		_tmp1_ = data_object_to_string ((DataObject*) self);
#line 263 "../src/core/DataSource.vala"
		_tmp2_ = _tmp1_;
#line 263 "../src/core/DataSource.vala"
		g_warning ("DataSource.vala:263: No implementation to commit link state for %s", _tmp2_);
#line 263 "../src/core/DataSource.vala"
		_g_free0 (_tmp2_);
#line 1298 "DataSource.c"
	}
}

void
data_source_commit_backlinks (DataSource* self,
                              SourceCollection* sources,
                              const gchar* dehydrated)
{
	DataSourceClass* _klass_;
#line 261 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 261 "../src/core/DataSource.vala"
	if (_klass_->commit_backlinks) {
#line 261 "../src/core/DataSource.vala"
		_klass_->commit_backlinks (self, sources, dehydrated);
#line 1316 "DataSource.c"
	}
}

static gchar*
data_source_dehydrate_backlinks (DataSource* self)
{
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_;
	GString* builder = NULL;
	GString* _tmp5_;
	const gchar* _tmp46_ = NULL;
	GString* _tmp47_;
	const gchar* _tmp48_;
	gint _tmp49_;
	gint _tmp50_;
	gchar* _tmp53_;
	gchar* result;
#line 266 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 267 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->backlinks;
#line 267 "../src/core/DataSource.vala"
	if (_tmp1_ == NULL) {
#line 267 "../src/core/DataSource.vala"
		_tmp0_ = TRUE;
#line 1342 "DataSource.c"
	} else {
		GeeHashMap* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 267 "../src/core/DataSource.vala"
		_tmp2_ = self->priv->backlinks;
#line 267 "../src/core/DataSource.vala"
		_tmp3_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp2_);
#line 267 "../src/core/DataSource.vala"
		_tmp4_ = _tmp3_;
#line 267 "../src/core/DataSource.vala"
		_tmp0_ = _tmp4_ == 0;
#line 1355 "DataSource.c"
	}
#line 267 "../src/core/DataSource.vala"
	if (_tmp0_) {
#line 268 "../src/core/DataSource.vala"
		result = NULL;
#line 268 "../src/core/DataSource.vala"
		return result;
#line 1363 "DataSource.c"
	}
#line 270 "../src/core/DataSource.vala"
	_tmp5_ = g_string_new ("");
#line 270 "../src/core/DataSource.vala"
	builder = _tmp5_;
#line 1369 "DataSource.c"
	{
		GeeIterator* _name_it = NULL;
		GeeHashMap* _tmp6_;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 271 "../src/core/DataSource.vala"
		_tmp6_ = self->priv->backlinks;
#line 271 "../src/core/DataSource.vala"
		_tmp7_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp6_);
#line 271 "../src/core/DataSource.vala"
		_tmp8_ = _tmp7_;
#line 271 "../src/core/DataSource.vala"
		_tmp9_ = _tmp8_;
#line 271 "../src/core/DataSource.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 271 "../src/core/DataSource.vala"
		_tmp11_ = _tmp10_;
#line 271 "../src/core/DataSource.vala"
		_g_object_unref0 (_tmp9_);
#line 271 "../src/core/DataSource.vala"
		_name_it = _tmp11_;
#line 271 "../src/core/DataSource.vala"
		while (TRUE) {
#line 1396 "DataSource.c"
			GeeIterator* _tmp12_;
			gchar* name = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			GeeList* values = NULL;
			GeeHashMap* _tmp15_;
			const gchar* _tmp16_;
			gpointer _tmp17_;
			gboolean _tmp18_ = FALSE;
			GeeList* _tmp19_;
			gchar* value_field = NULL;
			gchar* _tmp23_;
			const gchar* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
#line 271 "../src/core/DataSource.vala"
			_tmp12_ = _name_it;
#line 271 "../src/core/DataSource.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 271 "../src/core/DataSource.vala"
				break;
#line 1418 "DataSource.c"
			}
#line 271 "../src/core/DataSource.vala"
			_tmp13_ = _name_it;
#line 271 "../src/core/DataSource.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 271 "../src/core/DataSource.vala"
			name = (gchar*) _tmp14_;
#line 272 "../src/core/DataSource.vala"
			_tmp15_ = self->priv->backlinks;
#line 272 "../src/core/DataSource.vala"
			_tmp16_ = name;
#line 272 "../src/core/DataSource.vala"
			_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 272 "../src/core/DataSource.vala"
			values = (GeeList*) _tmp17_;
#line 273 "../src/core/DataSource.vala"
			_tmp19_ = values;
#line 273 "../src/core/DataSource.vala"
			if (_tmp19_ == NULL) {
#line 273 "../src/core/DataSource.vala"
				_tmp18_ = TRUE;
#line 1440 "DataSource.c"
			} else {
				GeeList* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 273 "../src/core/DataSource.vala"
				_tmp20_ = values;
#line 273 "../src/core/DataSource.vala"
				_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 273 "../src/core/DataSource.vala"
				_tmp22_ = _tmp21_;
#line 273 "../src/core/DataSource.vala"
				_tmp18_ = _tmp22_ == 0;
#line 1453 "DataSource.c"
			}
#line 273 "../src/core/DataSource.vala"
			if (_tmp18_) {
#line 274 "../src/core/DataSource.vala"
				_g_object_unref0 (values);
#line 274 "../src/core/DataSource.vala"
				_g_free0 (name);
#line 274 "../src/core/DataSource.vala"
				continue;
#line 1463 "DataSource.c"
			}
#line 276 "../src/core/DataSource.vala"
			_tmp23_ = g_strdup ("");
#line 276 "../src/core/DataSource.vala"
			value_field = _tmp23_;
#line 1469 "DataSource.c"
			{
				GeeList* _value_list = NULL;
				GeeList* _tmp24_;
				gint _value_size = 0;
				GeeList* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				gint _value_index = 0;
#line 277 "../src/core/DataSource.vala"
				_tmp24_ = values;
#line 277 "../src/core/DataSource.vala"
				_value_list = _tmp24_;
#line 277 "../src/core/DataSource.vala"
				_tmp25_ = _value_list;
#line 277 "../src/core/DataSource.vala"
				_tmp26_ = gee_collection_get_size ((GeeCollection*) _tmp25_);
#line 277 "../src/core/DataSource.vala"
				_tmp27_ = _tmp26_;
#line 277 "../src/core/DataSource.vala"
				_value_size = _tmp27_;
#line 277 "../src/core/DataSource.vala"
				_value_index = -1;
#line 277 "../src/core/DataSource.vala"
				while (TRUE) {
#line 1494 "DataSource.c"
					gint _tmp28_;
					gint _tmp29_;
					gchar* value = NULL;
					GeeList* _tmp30_;
					gpointer _tmp31_;
					const gchar* _tmp32_;
#line 277 "../src/core/DataSource.vala"
					_value_index = _value_index + 1;
#line 277 "../src/core/DataSource.vala"
					_tmp28_ = _value_index;
#line 277 "../src/core/DataSource.vala"
					_tmp29_ = _value_size;
#line 277 "../src/core/DataSource.vala"
					if (!(_tmp28_ < _tmp29_)) {
#line 277 "../src/core/DataSource.vala"
						break;
#line 1511 "DataSource.c"
					}
#line 277 "../src/core/DataSource.vala"
					_tmp30_ = _value_list;
#line 277 "../src/core/DataSource.vala"
					_tmp31_ = gee_list_get (_tmp30_, _value_index);
#line 277 "../src/core/DataSource.vala"
					value = (gchar*) _tmp31_;
#line 278 "../src/core/DataSource.vala"
					_tmp32_ = value;
#line 278 "../src/core/DataSource.vala"
					if (!is_string_empty (_tmp32_)) {
#line 1523 "DataSource.c"
						const gchar* _tmp33_;
						const gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
#line 279 "../src/core/DataSource.vala"
						_tmp33_ = value_field;
#line 279 "../src/core/DataSource.vala"
						_tmp34_ = value;
#line 279 "../src/core/DataSource.vala"
						_tmp35_ = g_strconcat (_tmp34_, "|", NULL);
#line 279 "../src/core/DataSource.vala"
						_tmp36_ = _tmp35_;
#line 279 "../src/core/DataSource.vala"
						_tmp37_ = g_strconcat (_tmp33_, _tmp36_, NULL);
#line 279 "../src/core/DataSource.vala"
						_g_free0 (value_field);
#line 279 "../src/core/DataSource.vala"
						value_field = _tmp37_;
#line 279 "../src/core/DataSource.vala"
						_g_free0 (_tmp36_);
#line 1545 "DataSource.c"
					}
#line 277 "../src/core/DataSource.vala"
					_g_free0 (value);
#line 1549 "DataSource.c"
				}
			}
#line 282 "../src/core/DataSource.vala"
			_tmp38_ = value_field;
#line 282 "../src/core/DataSource.vala"
			_tmp39_ = strlen (_tmp38_);
#line 282 "../src/core/DataSource.vala"
			_tmp40_ = _tmp39_;
#line 282 "../src/core/DataSource.vala"
			if (_tmp40_ > 0) {
#line 1560 "DataSource.c"
				GString* _tmp41_;
				const gchar* _tmp42_;
				const gchar* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
#line 283 "../src/core/DataSource.vala"
				_tmp41_ = builder;
#line 283 "../src/core/DataSource.vala"
				_tmp42_ = name;
#line 283 "../src/core/DataSource.vala"
				_tmp43_ = value_field;
#line 283 "../src/core/DataSource.vala"
				_tmp44_ = g_strdup_printf ("%s=%s\n", _tmp42_, _tmp43_);
#line 283 "../src/core/DataSource.vala"
				_tmp45_ = _tmp44_;
#line 283 "../src/core/DataSource.vala"
				g_string_append (_tmp41_, _tmp45_);
#line 283 "../src/core/DataSource.vala"
				_g_free0 (_tmp45_);
#line 1580 "DataSource.c"
			}
#line 271 "../src/core/DataSource.vala"
			_g_free0 (value_field);
#line 271 "../src/core/DataSource.vala"
			_g_object_unref0 (values);
#line 271 "../src/core/DataSource.vala"
			_g_free0 (name);
#line 1588 "DataSource.c"
		}
#line 271 "../src/core/DataSource.vala"
		_g_object_unref0 (_name_it);
#line 1592 "DataSource.c"
	}
#line 286 "../src/core/DataSource.vala"
	_tmp47_ = builder;
#line 286 "../src/core/DataSource.vala"
	_tmp48_ = _tmp47_->str;
#line 286 "../src/core/DataSource.vala"
	_tmp49_ = strlen (_tmp48_);
#line 286 "../src/core/DataSource.vala"
	_tmp50_ = _tmp49_;
#line 286 "../src/core/DataSource.vala"
	if (_tmp50_ > 0) {
#line 1604 "DataSource.c"
		GString* _tmp51_;
		const gchar* _tmp52_;
#line 286 "../src/core/DataSource.vala"
		_tmp51_ = builder;
#line 286 "../src/core/DataSource.vala"
		_tmp52_ = _tmp51_->str;
#line 286 "../src/core/DataSource.vala"
		_tmp46_ = _tmp52_;
#line 1613 "DataSource.c"
	} else {
#line 286 "../src/core/DataSource.vala"
		_tmp46_ = NULL;
#line 1617 "DataSource.c"
	}
#line 286 "../src/core/DataSource.vala"
	_tmp53_ = g_strdup (_tmp46_);
#line 286 "../src/core/DataSource.vala"
	result = _tmp53_;
#line 286 "../src/core/DataSource.vala"
	_g_string_free0 (builder);
#line 286 "../src/core/DataSource.vala"
	return result;
#line 1627 "DataSource.c"
}

void
data_source_rehydrate_backlinks (DataSource* self,
                                 SourceCollection* unlinked_from,
                                 const gchar* dehydrated)
{
	GeeHashMap* _tmp0_;
	gchar** lines = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 291 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 291 "../src/core/DataSource.vala"
	g_return_if_fail (unlinked_from != NULL);
#line 292 "../src/core/DataSource.vala"
	self->priv->unlinked_from_collection = unlinked_from;
#line 293 "../src/core/DataSource.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 293 "../src/core/DataSource.vala"
	_g_object_unref0 (self->priv->backlinks);
#line 293 "../src/core/DataSource.vala"
	self->priv->backlinks = _tmp0_;
#line 295 "../src/core/DataSource.vala"
	if (dehydrated == NULL) {
#line 296 "../src/core/DataSource.vala"
		return;
#line 1659 "DataSource.c"
	}
#line 298 "../src/core/DataSource.vala"
	_tmp2_ = _tmp1_ = g_strsplit (dehydrated, "\n", 0);
#line 298 "../src/core/DataSource.vala"
	lines = _tmp2_;
#line 298 "../src/core/DataSource.vala"
	lines_length1 = _vala_array_length (_tmp1_);
#line 298 "../src/core/DataSource.vala"
	_lines_size_ = lines_length1;
#line 299 "../src/core/DataSource.vala"
	_tmp3_ = lines;
#line 299 "../src/core/DataSource.vala"
	_tmp3__length1 = lines_length1;
#line 1673 "DataSource.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 299 "../src/core/DataSource.vala"
		line_collection = _tmp3_;
#line 299 "../src/core/DataSource.vala"
		line_collection_length1 = _tmp3__length1;
#line 299 "../src/core/DataSource.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1685 "DataSource.c"
			gchar* _tmp4_;
			gchar* line = NULL;
#line 299 "../src/core/DataSource.vala"
			_tmp4_ = g_strdup (line_collection[line_it]);
#line 299 "../src/core/DataSource.vala"
			line = _tmp4_;
#line 1692 "DataSource.c"
			{
				const gchar* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gchar** tokens = NULL;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint tokens_length1;
				gint _tokens_size_;
				gchar** _tmp11_;
				gint _tmp11__length1;
				gchar** decoded_values = NULL;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gchar** _tmp17_;
				gchar** _tmp18_;
				gint decoded_values_length1;
				gint _decoded_values_size_;
				GeeList* values = NULL;
				GeeArrayList* _tmp19_;
				gchar** _tmp20_;
				gint _tmp20__length1;
				GeeList* _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
#line 300 "../src/core/DataSource.vala"
				_tmp5_ = line;
#line 300 "../src/core/DataSource.vala"
				_tmp6_ = strlen (_tmp5_);
#line 300 "../src/core/DataSource.vala"
				_tmp7_ = _tmp6_;
#line 300 "../src/core/DataSource.vala"
				if (_tmp7_ == 0) {
#line 301 "../src/core/DataSource.vala"
					_g_free0 (line);
#line 301 "../src/core/DataSource.vala"
					continue;
#line 1732 "DataSource.c"
				}
#line 303 "../src/core/DataSource.vala"
				_tmp8_ = line;
#line 303 "../src/core/DataSource.vala"
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "=", 2);
#line 303 "../src/core/DataSource.vala"
				tokens = _tmp10_;
#line 303 "../src/core/DataSource.vala"
				tokens_length1 = _vala_array_length (_tmp9_);
#line 303 "../src/core/DataSource.vala"
				_tokens_size_ = tokens_length1;
#line 304 "../src/core/DataSource.vala"
				_tmp11_ = tokens;
#line 304 "../src/core/DataSource.vala"
				_tmp11__length1 = tokens_length1;
#line 304 "../src/core/DataSource.vala"
				if (_tmp11__length1 < 2) {
#line 1750 "DataSource.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
#line 305 "../src/core/DataSource.vala"
					_tmp12_ = line;
#line 305 "../src/core/DataSource.vala"
					_tmp13_ = data_object_to_string ((DataObject*) self);
#line 305 "../src/core/DataSource.vala"
					_tmp14_ = _tmp13_;
#line 305 "../src/core/DataSource.vala"
					g_warning ("DataSource.vala:305: Unable to rehydrate \"%s\" for %s: name and value" \
" not present", _tmp12_, _tmp14_);
#line 305 "../src/core/DataSource.vala"
					_g_free0 (_tmp14_);
#line 308 "../src/core/DataSource.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 308 "../src/core/DataSource.vala"
					_g_free0 (line);
#line 308 "../src/core/DataSource.vala"
					continue;
#line 1770 "DataSource.c"
				}
#line 311 "../src/core/DataSource.vala"
				_tmp15_ = tokens;
#line 311 "../src/core/DataSource.vala"
				_tmp15__length1 = tokens_length1;
#line 311 "../src/core/DataSource.vala"
				_tmp16_ = _tmp15_[1];
#line 311 "../src/core/DataSource.vala"
				_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, "|", 0);
#line 311 "../src/core/DataSource.vala"
				decoded_values = _tmp18_;
#line 311 "../src/core/DataSource.vala"
				decoded_values_length1 = _vala_array_length (_tmp17_);
#line 311 "../src/core/DataSource.vala"
				_decoded_values_size_ = decoded_values_length1;
#line 312 "../src/core/DataSource.vala"
				_tmp19_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 312 "../src/core/DataSource.vala"
				values = (GeeList*) _tmp19_;
#line 313 "../src/core/DataSource.vala"
				_tmp20_ = decoded_values;
#line 313 "../src/core/DataSource.vala"
				_tmp20__length1 = decoded_values_length1;
#line 1794 "DataSource.c"
				{
					gchar** value_collection = NULL;
					gint value_collection_length1 = 0;
					gint _value_collection_size_ = 0;
					gint value_it = 0;
#line 313 "../src/core/DataSource.vala"
					value_collection = _tmp20_;
#line 313 "../src/core/DataSource.vala"
					value_collection_length1 = _tmp20__length1;
#line 313 "../src/core/DataSource.vala"
					for (value_it = 0; value_it < value_collection_length1; value_it = value_it + 1) {
#line 1806 "DataSource.c"
						gchar* _tmp21_;
						gchar* value = NULL;
#line 313 "../src/core/DataSource.vala"
						_tmp21_ = g_strdup (value_collection[value_it]);
#line 313 "../src/core/DataSource.vala"
						value = _tmp21_;
#line 1813 "DataSource.c"
						{
							gboolean _tmp22_ = FALSE;
							const gchar* _tmp23_;
#line 314 "../src/core/DataSource.vala"
							_tmp23_ = value;
#line 314 "../src/core/DataSource.vala"
							if (_tmp23_ != NULL) {
#line 1821 "DataSource.c"
								const gchar* _tmp24_;
								gint _tmp25_;
								gint _tmp26_;
#line 314 "../src/core/DataSource.vala"
								_tmp24_ = value;
#line 314 "../src/core/DataSource.vala"
								_tmp25_ = strlen (_tmp24_);
#line 314 "../src/core/DataSource.vala"
								_tmp26_ = _tmp25_;
#line 314 "../src/core/DataSource.vala"
								_tmp22_ = _tmp26_ > 0;
#line 1833 "DataSource.c"
							} else {
#line 314 "../src/core/DataSource.vala"
								_tmp22_ = FALSE;
#line 1837 "DataSource.c"
							}
#line 314 "../src/core/DataSource.vala"
							if (_tmp22_) {
#line 1841 "DataSource.c"
								GeeList* _tmp27_;
								const gchar* _tmp28_;
#line 315 "../src/core/DataSource.vala"
								_tmp27_ = values;
#line 315 "../src/core/DataSource.vala"
								_tmp28_ = value;
#line 315 "../src/core/DataSource.vala"
								gee_collection_add ((GeeCollection*) _tmp27_, _tmp28_);
#line 1850 "DataSource.c"
							}
#line 313 "../src/core/DataSource.vala"
							_g_free0 (value);
#line 1854 "DataSource.c"
						}
					}
				}
#line 318 "../src/core/DataSource.vala"
				_tmp29_ = values;
#line 318 "../src/core/DataSource.vala"
				_tmp30_ = gee_collection_get_size ((GeeCollection*) _tmp29_);
#line 318 "../src/core/DataSource.vala"
				_tmp31_ = _tmp30_;
#line 318 "../src/core/DataSource.vala"
				if (_tmp31_ > 0) {
#line 1866 "DataSource.c"
					GeeHashMap* _tmp32_;
					gchar** _tmp33_;
					gint _tmp33__length1;
					const gchar* _tmp34_;
					GeeList* _tmp35_;
#line 319 "../src/core/DataSource.vala"
					_tmp32_ = self->priv->backlinks;
#line 319 "../src/core/DataSource.vala"
					_tmp33_ = tokens;
#line 319 "../src/core/DataSource.vala"
					_tmp33__length1 = tokens_length1;
#line 319 "../src/core/DataSource.vala"
					_tmp34_ = _tmp33_[0];
#line 319 "../src/core/DataSource.vala"
					_tmp35_ = values;
#line 319 "../src/core/DataSource.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, _tmp34_, _tmp35_);
#line 1884 "DataSource.c"
				}
#line 299 "../src/core/DataSource.vala"
				_g_object_unref0 (values);
#line 299 "../src/core/DataSource.vala"
				decoded_values = (_vala_array_free (decoded_values, decoded_values_length1, (GDestroyNotify) g_free), NULL);
#line 299 "../src/core/DataSource.vala"
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 299 "../src/core/DataSource.vala"
				_g_free0 (line);
#line 1894 "DataSource.c"
			}
		}
	}
#line 291 "../src/core/DataSource.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 1900 "DataSource.c"
}

static SourceSnapshot*
data_source_real_save_snapshot (DataSource* self)
{
	SourceSnapshot* result;
#line 325 "../src/core/DataSource.vala"
	result = NULL;
#line 325 "../src/core/DataSource.vala"
	return result;
#line 1911 "DataSource.c"
}

SourceSnapshot*
data_source_save_snapshot (DataSource* self)
{
	DataSourceClass* _klass_;
#line 324 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 324 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 324 "../src/core/DataSource.vala"
	if (_klass_->save_snapshot) {
#line 324 "../src/core/DataSource.vala"
		return _klass_->save_snapshot (self);
#line 1926 "DataSource.c"
	}
#line 324 "../src/core/DataSource.vala"
	return NULL;
#line 1930 "DataSource.c"
}

void
data_source_internal_mark_for_destroy (DataSource* self)
{
#line 329 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 330 "../src/core/DataSource.vala"
	self->priv->marked_for_destroy = TRUE;
#line 1940 "DataSource.c"
}

static gboolean
data_source_real_internal_delete_backing (DataSource* self,
                                          GError** error)
{
	gboolean result;
#line 338 "../src/core/DataSource.vala"
	result = TRUE;
#line 338 "../src/core/DataSource.vala"
	return result;
#line 1952 "DataSource.c"
}

gboolean
data_source_internal_delete_backing (DataSource* self,
                                     GError** error)
{
	DataSourceClass* _klass_;
#line 337 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 337 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 337 "../src/core/DataSource.vala"
	if (_klass_->internal_delete_backing) {
#line 337 "../src/core/DataSource.vala"
		return _klass_->internal_delete_backing (self, error);
#line 1968 "DataSource.c"
	}
#line 337 "../src/core/DataSource.vala"
	return FALSE;
#line 1972 "DataSource.c"
}

static gboolean
data_source_real_equals (DataSource* self,
                         DataSource* source)
{
	gboolean result;
#line 344 "../src/core/DataSource.vala"
	result = self == source;
#line 344 "../src/core/DataSource.vala"
	return result;
#line 1984 "DataSource.c"
}

gboolean
data_source_equals (DataSource* self,
                    DataSource* source)
{
	DataSourceClass* _klass_;
#line 343 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 343 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 343 "../src/core/DataSource.vala"
	if (_klass_->equals) {
#line 343 "../src/core/DataSource.vala"
		return _klass_->equals (self, source);
#line 2000 "DataSource.c"
	}
#line 343 "../src/core/DataSource.vala"
	return FALSE;
#line 2004 "DataSource.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 362 "../src/core/DataSource.vala"
	return self ? g_object_ref (self) : NULL;
#line 2012 "DataSource.c"
}

static void
data_source_real_destroy (DataSource* self)
{
#line 354 "../src/core/DataSource.vala"
	_vala_assert (self->priv->marked_for_destroy, "marked_for_destroy");
#line 357 "../src/core/DataSource.vala"
	self->priv->is_destroyed = TRUE;
#line 2022 "DataSource.c"
	{
		gint ctr = 0;
#line 360 "../src/core/DataSource.vala"
		ctr = 0;
#line 2027 "DataSource.c"
		{
			gboolean _tmp0_ = FALSE;
#line 360 "../src/core/DataSource.vala"
			_tmp0_ = TRUE;
#line 360 "../src/core/DataSource.vala"
			while (TRUE) {
#line 2034 "DataSource.c"
				DataView** _tmp2_;
				gint _tmp2__length1;
				DataView** _tmp3_;
				gint _tmp3__length1;
				DataView* _tmp4_;
#line 360 "../src/core/DataSource.vala"
				if (!_tmp0_) {
#line 2042 "DataSource.c"
					gint _tmp1_;
#line 360 "../src/core/DataSource.vala"
					_tmp1_ = ctr;
#line 360 "../src/core/DataSource.vala"
					ctr = _tmp1_ + 1;
#line 2048 "DataSource.c"
				}
#line 360 "../src/core/DataSource.vala"
				_tmp0_ = FALSE;
#line 360 "../src/core/DataSource.vala"
				_tmp2_ = self->priv->subscribers;
#line 360 "../src/core/DataSource.vala"
				_tmp2__length1 = self->priv->subscribers_length1;
#line 360 "../src/core/DataSource.vala"
				if (!(ctr < _tmp2__length1)) {
#line 360 "../src/core/DataSource.vala"
					break;
#line 2060 "DataSource.c"
				}
#line 361 "../src/core/DataSource.vala"
				_tmp3_ = self->priv->subscribers;
#line 361 "../src/core/DataSource.vala"
				_tmp3__length1 = self->priv->subscribers_length1;
#line 361 "../src/core/DataSource.vala"
				_tmp4_ = _tmp3_[ctr];
#line 361 "../src/core/DataSource.vala"
				if (_tmp4_ != NULL) {
#line 2070 "DataSource.c"
					DataView* view = NULL;
					DataView** _tmp5_;
					gint _tmp5__length1;
					DataView* _tmp6_;
					DataView* _tmp7_;
					DataView** _tmp8_;
					gint _tmp8__length1;
					DataView* _tmp9_;
#line 362 "../src/core/DataSource.vala"
					_tmp5_ = self->priv->subscribers;
#line 362 "../src/core/DataSource.vala"
					_tmp5__length1 = self->priv->subscribers_length1;
#line 362 "../src/core/DataSource.vala"
					_tmp6_ = _tmp5_[ctr];
#line 362 "../src/core/DataSource.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 362 "../src/core/DataSource.vala"
					view = _tmp7_;
#line 363 "../src/core/DataSource.vala"
					_tmp8_ = self->priv->subscribers;
#line 363 "../src/core/DataSource.vala"
					_tmp8__length1 = self->priv->subscribers_length1;
#line 363 "../src/core/DataSource.vala"
					_g_object_unref0 (_tmp8_[ctr]);
#line 363 "../src/core/DataSource.vala"
					_tmp8_[ctr] = NULL;
#line 365 "../src/core/DataSource.vala"
					_tmp9_ = view;
#line 365 "../src/core/DataSource.vala"
					data_view_notify_unsubscribed (_tmp9_, self);
#line 361 "../src/core/DataSource.vala"
					_g_object_unref0 (view);
#line 2103 "DataSource.c"
				}
			}
		}
	}
#line 370 "../src/core/DataSource.vala"
	g_signal_emit (self, data_source_signals[DATA_SOURCE_DESTROYED_SIGNAL], 0);
#line 2110 "DataSource.c"
}

void
data_source_destroy (DataSource* self)
{
	DataSourceClass* _klass_;
#line 353 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/core/DataSource.vala"
	_klass_ = DATA_SOURCE_GET_CLASS (self);
#line 353 "../src/core/DataSource.vala"
	if (_klass_->destroy) {
#line 353 "../src/core/DataSource.vala"
		_klass_->destroy (self);
#line 2125 "DataSource.c"
	}
}

gboolean
data_source_destroy_orphan (DataSource* self,
                            gboolean delete_backing)
{
	gboolean ret = FALSE;
	SourceCollection* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 379 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 380 "../src/core/DataSource.vala"
	ret = TRUE;
#line 381 "../src/core/DataSource.vala"
	if (delete_backing) {
#line 2143 "DataSource.c"
		{
			gboolean _tmp0_ = FALSE;
#line 383 "../src/core/DataSource.vala"
			_tmp0_ = data_source_internal_delete_backing (self, &_inner_error0_);
#line 383 "../src/core/DataSource.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2150 "DataSource.c"
				goto __catch0_g_error;
			}
#line 383 "../src/core/DataSource.vala"
			ret = _tmp0_;
#line 384 "../src/core/DataSource.vala"
			if (!ret) {
#line 2157 "DataSource.c"
				gchar* _tmp1_;
				gchar* _tmp2_;
#line 385 "../src/core/DataSource.vala"
				_tmp1_ = data_object_to_string ((DataObject*) self);
#line 385 "../src/core/DataSource.vala"
				_tmp2_ = _tmp1_;
#line 385 "../src/core/DataSource.vala"
				g_warning ("DataSource.vala:385: Unable to delete backing for %s", _tmp2_);
#line 385 "../src/core/DataSource.vala"
				_g_free0 (_tmp2_);
#line 2168 "DataSource.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 382 "../src/core/DataSource.vala"
			err = _inner_error0_;
#line 382 "../src/core/DataSource.vala"
			_inner_error0_ = NULL;
#line 388 "../src/core/DataSource.vala"
			_tmp3_ = data_object_to_string ((DataObject*) self);
#line 388 "../src/core/DataSource.vala"
			_tmp4_ = _tmp3_;
#line 388 "../src/core/DataSource.vala"
			_tmp5_ = err;
#line 388 "../src/core/DataSource.vala"
			_tmp6_ = _tmp5_->message;
#line 388 "../src/core/DataSource.vala"
			g_warning ("DataSource.vala:388: Unable to delete backing for %s: %s", _tmp4_, _tmp6_);
#line 388 "../src/core/DataSource.vala"
			_g_free0 (_tmp4_);
#line 389 "../src/core/DataSource.vala"
			ret = FALSE;
#line 382 "../src/core/DataSource.vala"
			_g_error_free0 (err);
#line 2199 "DataSource.c"
		}
		__finally0:
#line 382 "../src/core/DataSource.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2204 "DataSource.c"
			gboolean _tmp7_ = FALSE;
#line 382 "../src/core/DataSource.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 382 "../src/core/DataSource.vala"
			g_clear_error (&_inner_error0_);
#line 382 "../src/core/DataSource.vala"
			return _tmp7_;
#line 2212 "DataSource.c"
		}
	}
#line 393 "../src/core/DataSource.vala"
	data_source_internal_mark_for_destroy (self);
#line 394 "../src/core/DataSource.vala"
	data_source_destroy (self);
#line 396 "../src/core/DataSource.vala"
	_tmp8_ = self->priv->unlinked_from_collection;
#line 396 "../src/core/DataSource.vala"
	if (_tmp8_ != NULL) {
#line 2223 "DataSource.c"
		SourceCollection* _tmp9_;
#line 397 "../src/core/DataSource.vala"
		_tmp9_ = self->priv->unlinked_from_collection;
#line 397 "../src/core/DataSource.vala"
		source_collection_notify_unlinked_destroyed (_tmp9_, self);
#line 2229 "DataSource.c"
	}
#line 399 "../src/core/DataSource.vala"
	result = ret;
#line 399 "../src/core/DataSource.vala"
	return result;
#line 2235 "DataSource.c"
}

static void
_vala_array_add48 (DataView** * array,
                   gint* length,
                   gint* size,
                   DataView* value)
{
#line 419 "../src/core/DataSource.vala"
	if ((*length) == (*size)) {
#line 419 "../src/core/DataSource.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 419 "../src/core/DataSource.vala"
		*array = g_renew (DataView*, *array, (*size) + 1);
#line 2250 "DataSource.c"
	}
#line 419 "../src/core/DataSource.vala"
	(*array)[(*length)++] = value;
#line 419 "../src/core/DataSource.vala"
	(*array)[*length] = NULL;
#line 2256 "DataSource.c"
}

void
data_source_internal_subscribe (DataSource* self,
                                DataView* view)
{
	DataView* _tmp7_;
#line 408 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 408 "../src/core/DataSource.vala"
	g_return_if_fail (view != NULL);
#line 409 "../src/core/DataSource.vala"
	_vala_assert (!self->priv->in_contact, "!in_contact");
#line 2270 "DataSource.c"
	{
		gint ctr = 0;
#line 411 "../src/core/DataSource.vala"
		ctr = 0;
#line 2275 "DataSource.c"
		{
			gboolean _tmp0_ = FALSE;
#line 411 "../src/core/DataSource.vala"
			_tmp0_ = TRUE;
#line 411 "../src/core/DataSource.vala"
			while (TRUE) {
#line 2282 "DataSource.c"
				DataView** _tmp2_;
				gint _tmp2__length1;
				DataView** _tmp3_;
				gint _tmp3__length1;
				DataView* _tmp4_;
#line 411 "../src/core/DataSource.vala"
				if (!_tmp0_) {
#line 2290 "DataSource.c"
					gint _tmp1_;
#line 411 "../src/core/DataSource.vala"
					_tmp1_ = ctr;
#line 411 "../src/core/DataSource.vala"
					ctr = _tmp1_ + 1;
#line 2296 "DataSource.c"
				}
#line 411 "../src/core/DataSource.vala"
				_tmp0_ = FALSE;
#line 411 "../src/core/DataSource.vala"
				_tmp2_ = self->priv->subscribers;
#line 411 "../src/core/DataSource.vala"
				_tmp2__length1 = self->priv->subscribers_length1;
#line 411 "../src/core/DataSource.vala"
				if (!(ctr < _tmp2__length1)) {
#line 411 "../src/core/DataSource.vala"
					break;
#line 2308 "DataSource.c"
				}
#line 412 "../src/core/DataSource.vala"
				_tmp3_ = self->priv->subscribers;
#line 412 "../src/core/DataSource.vala"
				_tmp3__length1 = self->priv->subscribers_length1;
#line 412 "../src/core/DataSource.vala"
				_tmp4_ = _tmp3_[ctr];
#line 412 "../src/core/DataSource.vala"
				if (_tmp4_ == NULL) {
#line 2318 "DataSource.c"
					DataView** _tmp5_;
					gint _tmp5__length1;
					DataView* _tmp6_;
#line 413 "../src/core/DataSource.vala"
					_tmp5_ = self->priv->subscribers;
#line 413 "../src/core/DataSource.vala"
					_tmp5__length1 = self->priv->subscribers_length1;
#line 413 "../src/core/DataSource.vala"
					_tmp6_ = _g_object_ref0 (view);
#line 413 "../src/core/DataSource.vala"
					_g_object_unref0 (_tmp5_[ctr]);
#line 413 "../src/core/DataSource.vala"
					_tmp5_[ctr] = _tmp6_;
#line 415 "../src/core/DataSource.vala"
					return;
#line 2334 "DataSource.c"
				}
			}
		}
	}
#line 419 "../src/core/DataSource.vala"
	_tmp7_ = _g_object_ref0 (view);
#line 419 "../src/core/DataSource.vala"
	_vala_array_add48 (&self->priv->subscribers, &self->priv->subscribers_length1, &self->priv->_subscribers_size_, _tmp7_);
#line 2343 "DataSource.c"
}

void
data_source_internal_unsubscribe (DataSource* self,
                                  DataView* view)
{
#line 424 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 424 "../src/core/DataSource.vala"
	g_return_if_fail (view != NULL);
#line 425 "../src/core/DataSource.vala"
	_vala_assert (!self->priv->in_contact, "!in_contact");
#line 2356 "DataSource.c"
	{
		gint ctr = 0;
#line 427 "../src/core/DataSource.vala"
		ctr = 0;
#line 2361 "DataSource.c"
		{
			gboolean _tmp0_ = FALSE;
#line 427 "../src/core/DataSource.vala"
			_tmp0_ = TRUE;
#line 427 "../src/core/DataSource.vala"
			while (TRUE) {
#line 2368 "DataSource.c"
				DataView** _tmp2_;
				gint _tmp2__length1;
				DataView** _tmp3_;
				gint _tmp3__length1;
				DataView* _tmp4_;
#line 427 "../src/core/DataSource.vala"
				if (!_tmp0_) {
#line 2376 "DataSource.c"
					gint _tmp1_;
#line 427 "../src/core/DataSource.vala"
					_tmp1_ = ctr;
#line 427 "../src/core/DataSource.vala"
					ctr = _tmp1_ + 1;
#line 2382 "DataSource.c"
				}
#line 427 "../src/core/DataSource.vala"
				_tmp0_ = FALSE;
#line 427 "../src/core/DataSource.vala"
				_tmp2_ = self->priv->subscribers;
#line 427 "../src/core/DataSource.vala"
				_tmp2__length1 = self->priv->subscribers_length1;
#line 427 "../src/core/DataSource.vala"
				if (!(ctr < _tmp2__length1)) {
#line 427 "../src/core/DataSource.vala"
					break;
#line 2394 "DataSource.c"
				}
#line 428 "../src/core/DataSource.vala"
				_tmp3_ = self->priv->subscribers;
#line 428 "../src/core/DataSource.vala"
				_tmp3__length1 = self->priv->subscribers_length1;
#line 428 "../src/core/DataSource.vala"
				_tmp4_ = _tmp3_[ctr];
#line 428 "../src/core/DataSource.vala"
				if (_tmp4_ == view) {
#line 2404 "DataSource.c"
					DataView** _tmp5_;
					gint _tmp5__length1;
#line 429 "../src/core/DataSource.vala"
					_tmp5_ = self->priv->subscribers;
#line 429 "../src/core/DataSource.vala"
					_tmp5__length1 = self->priv->subscribers_length1;
#line 429 "../src/core/DataSource.vala"
					_g_object_unref0 (_tmp5_[ctr]);
#line 429 "../src/core/DataSource.vala"
					_tmp5_[ctr] = NULL;
#line 431 "../src/core/DataSource.vala"
					return;
#line 2417 "DataSource.c"
				}
			}
		}
	}
}

void
data_source_contact_subscribers (DataSource* self,
                                 DataSourceContactSubscriber contact_subscriber,
                                 gpointer contact_subscriber_target)
{
#line 436 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 437 "../src/core/DataSource.vala"
	_vala_assert (!self->priv->in_contact, "!in_contact");
#line 439 "../src/core/DataSource.vala"
	self->priv->in_contact = TRUE;
#line 2435 "DataSource.c"
	{
		gint ctr = 0;
#line 440 "../src/core/DataSource.vala"
		ctr = 0;
#line 2440 "DataSource.c"
		{
			gboolean _tmp0_ = FALSE;
#line 440 "../src/core/DataSource.vala"
			_tmp0_ = TRUE;
#line 440 "../src/core/DataSource.vala"
			while (TRUE) {
#line 2447 "DataSource.c"
				DataView** _tmp2_;
				gint _tmp2__length1;
				DataView** _tmp3_;
				gint _tmp3__length1;
				DataView* _tmp4_;
#line 440 "../src/core/DataSource.vala"
				if (!_tmp0_) {
#line 2455 "DataSource.c"
					gint _tmp1_;
#line 440 "../src/core/DataSource.vala"
					_tmp1_ = ctr;
#line 440 "../src/core/DataSource.vala"
					ctr = _tmp1_ + 1;
#line 2461 "DataSource.c"
				}
#line 440 "../src/core/DataSource.vala"
				_tmp0_ = FALSE;
#line 440 "../src/core/DataSource.vala"
				_tmp2_ = self->priv->subscribers;
#line 440 "../src/core/DataSource.vala"
				_tmp2__length1 = self->priv->subscribers_length1;
#line 440 "../src/core/DataSource.vala"
				if (!(ctr < _tmp2__length1)) {
#line 440 "../src/core/DataSource.vala"
					break;
#line 2473 "DataSource.c"
				}
#line 441 "../src/core/DataSource.vala"
				_tmp3_ = self->priv->subscribers;
#line 441 "../src/core/DataSource.vala"
				_tmp3__length1 = self->priv->subscribers_length1;
#line 441 "../src/core/DataSource.vala"
				_tmp4_ = _tmp3_[ctr];
#line 441 "../src/core/DataSource.vala"
				if (_tmp4_ != NULL) {
#line 2483 "DataSource.c"
					DataView** _tmp5_;
					gint _tmp5__length1;
					DataView* _tmp6_;
#line 442 "../src/core/DataSource.vala"
					_tmp5_ = self->priv->subscribers;
#line 442 "../src/core/DataSource.vala"
					_tmp5__length1 = self->priv->subscribers_length1;
#line 442 "../src/core/DataSource.vala"
					_tmp6_ = _tmp5_[ctr];
#line 442 "../src/core/DataSource.vala"
					contact_subscriber (_tmp6_, contact_subscriber_target);
#line 2495 "DataSource.c"
				}
			}
		}
	}
#line 444 "../src/core/DataSource.vala"
	self->priv->in_contact = FALSE;
#line 2502 "DataSource.c"
}

void
data_source_contact_subscribers_alteration (DataSource* self,
                                            Alteration* alteration)
{
#line 447 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 447 "../src/core/DataSource.vala"
	g_return_if_fail (alteration != NULL);
#line 448 "../src/core/DataSource.vala"
	_vala_assert (!self->priv->in_contact, "!in_contact");
#line 450 "../src/core/DataSource.vala"
	self->priv->in_contact = TRUE;
#line 2517 "DataSource.c"
	{
		gint ctr = 0;
#line 451 "../src/core/DataSource.vala"
		ctr = 0;
#line 2522 "DataSource.c"
		{
			gboolean _tmp0_ = FALSE;
#line 451 "../src/core/DataSource.vala"
			_tmp0_ = TRUE;
#line 451 "../src/core/DataSource.vala"
			while (TRUE) {
#line 2529 "DataSource.c"
				DataView** _tmp2_;
				gint _tmp2__length1;
				DataView** _tmp3_;
				gint _tmp3__length1;
				DataView* _tmp4_;
#line 451 "../src/core/DataSource.vala"
				if (!_tmp0_) {
#line 2537 "DataSource.c"
					gint _tmp1_;
#line 451 "../src/core/DataSource.vala"
					_tmp1_ = ctr;
#line 451 "../src/core/DataSource.vala"
					ctr = _tmp1_ + 1;
#line 2543 "DataSource.c"
				}
#line 451 "../src/core/DataSource.vala"
				_tmp0_ = FALSE;
#line 451 "../src/core/DataSource.vala"
				_tmp2_ = self->priv->subscribers;
#line 451 "../src/core/DataSource.vala"
				_tmp2__length1 = self->priv->subscribers_length1;
#line 451 "../src/core/DataSource.vala"
				if (!(ctr < _tmp2__length1)) {
#line 451 "../src/core/DataSource.vala"
					break;
#line 2555 "DataSource.c"
				}
#line 452 "../src/core/DataSource.vala"
				_tmp3_ = self->priv->subscribers;
#line 452 "../src/core/DataSource.vala"
				_tmp3__length1 = self->priv->subscribers_length1;
#line 452 "../src/core/DataSource.vala"
				_tmp4_ = _tmp3_[ctr];
#line 452 "../src/core/DataSource.vala"
				if (_tmp4_ != NULL) {
#line 2565 "DataSource.c"
					DataView** _tmp5_;
					gint _tmp5__length1;
					DataView* _tmp6_;
#line 453 "../src/core/DataSource.vala"
					_tmp5_ = self->priv->subscribers;
#line 453 "../src/core/DataSource.vala"
					_tmp5__length1 = self->priv->subscribers_length1;
#line 453 "../src/core/DataSource.vala"
					_tmp6_ = _tmp5_[ctr];
#line 453 "../src/core/DataSource.vala"
					data_object_notify_altered ((DataObject*) _tmp6_, alteration);
#line 2577 "DataSource.c"
				}
			}
		}
	}
#line 455 "../src/core/DataSource.vala"
	self->priv->in_contact = FALSE;
#line 2584 "DataSource.c"
}

static void
data_source_real_unlinked (DataSource* self,
                           SourceCollection* sources)
{
#line 64 "../src/core/DataSource.vala"
	g_return_if_fail (sources != NULL);
#line 2593 "DataSource.c"
}

static void
g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DATA_COLLECTION) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__DATA_COLLECTION callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 51 "../src/core/DataSource.vala"
	g_return_if_fail (n_param_values == 2);
#line 51 "../src/core/DataSource.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 51 "../src/core/DataSource.vala"
		data1 = closure->data;
#line 51 "../src/core/DataSource.vala"
		data2 = param_values->data[0].v_pointer;
#line 2618 "DataSource.c"
	} else {
#line 51 "../src/core/DataSource.vala"
		data1 = param_values->data[0].v_pointer;
#line 51 "../src/core/DataSource.vala"
		data2 = closure->data;
#line 2624 "DataSource.c"
	}
#line 51 "../src/core/DataSource.vala"
	callback = (GMarshalFunc_VOID__DATA_COLLECTION) (marshal_data ? marshal_data : cc->callback);
#line 51 "../src/core/DataSource.vala"
	callback (data1, value_get_data_collection (param_values + 1), data2);
#line 2630 "DataSource.c"
}

static void
data_source_real_relinked (DataSource* self,
                           SourceCollection* sources)
{
#line 68 "../src/core/DataSource.vala"
	g_return_if_fail (sources != NULL);
#line 2639 "DataSource.c"
}

static void
data_source_real_destroyed (DataSource* self)
{
}

static void
data_source_class_init (DataSourceClass * klass,
                        gpointer klass_data)
{
#line 51 "../src/core/DataSource.vala"
	data_source_parent_class = g_type_class_peek_parent (klass);
#line 51 "../src/core/DataSource.vala"
	g_type_class_adjust_private_offset (klass, &DataSource_private_offset);
#line 51 "../src/core/DataSource.vala"
	((DataObjectClass *) klass)->notify_membership_changed = (void (*) (DataObject*, DataCollection*)) data_source_real_notify_membership_changed;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_held_in_tank = (void (*) (DataSource*, SourceHoldingTank*)) data_source_real_notify_held_in_tank;
#line 51 "../src/core/DataSource.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) data_source_real_notify_altered;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_unlinking = (void (*) (DataSource*, SourceCollection*)) data_source_real_notify_unlinking;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_unlinked = (void (*) (DataSource*)) data_source_real_notify_unlinked;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_relinking = (void (*) (DataSource*, SourceCollection*)) data_source_real_notify_relinking;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->notify_relinked = (void (*) (DataSource*)) data_source_real_notify_relinked;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) data_source_real_get_typename;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) data_source_real_get_instance_id;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource*)) data_source_real_get_source_id;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) data_source_real_commit_backlinks;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->save_snapshot = (SourceSnapshot* (*) (DataSource*)) data_source_real_save_snapshot;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) data_source_real_internal_delete_backing;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource*, DataSource*)) data_source_real_equals;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) data_source_real_destroy;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->unlinked = data_source_real_unlinked;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->relinked = data_source_real_relinked;
#line 51 "../src/core/DataSource.vala"
	((DataSourceClass *) klass)->destroyed = data_source_real_destroyed;
#line 51 "../src/core/DataSource.vala"
	G_OBJECT_CLASS (klass)->finalize = data_source_finalize;
#line 51 "../src/core/DataSource.vala"
	data_source_signals[DATA_SOURCE_UNLINKED_SIGNAL] = g_signal_new ("unlinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, unlinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
#line 51 "../src/core/DataSource.vala"
	data_source_signals[DATA_SOURCE_RELINKED_SIGNAL] = g_signal_new ("relinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, relinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
#line 51 "../src/core/DataSource.vala"
	data_source_signals[DATA_SOURCE_DESTROYED_SIGNAL] = g_signal_new ("destroyed", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, destroyed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2699 "DataSource.c"
}

static void
data_source_instance_init (DataSource * self,
                           gpointer klass)
{
	DataView** _tmp0_;
#line 51 "../src/core/DataSource.vala"
	self->priv = data_source_get_instance_private (self);
#line 55 "../src/core/DataSource.vala"
	_tmp0_ = g_new0 (DataView*, 4 + 1);
#line 55 "../src/core/DataSource.vala"
	self->priv->subscribers = _tmp0_;
#line 55 "../src/core/DataSource.vala"
	self->priv->subscribers_length1 = 4;
#line 55 "../src/core/DataSource.vala"
	self->priv->_subscribers_size_ = self->priv->subscribers_length1;
#line 56 "../src/core/DataSource.vala"
	self->priv->holding_tank = NULL;
#line 57 "../src/core/DataSource.vala"
	self->priv->unlinked_from_collection = NULL;
#line 58 "../src/core/DataSource.vala"
	self->priv->backlinks = NULL;
#line 59 "../src/core/DataSource.vala"
	self->priv->in_contact = FALSE;
#line 60 "../src/core/DataSource.vala"
	self->priv->marked_for_destroy = FALSE;
#line 61 "../src/core/DataSource.vala"
	self->priv->is_destroyed = FALSE;
#line 2729 "DataSource.c"
}

static void
data_source_finalize (GObject * obj)
{
	DataSource * self;
#line 51 "../src/core/DataSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATA_SOURCE, DataSource);
#line 55 "../src/core/DataSource.vala"
	self->priv->subscribers = (_vala_array_free (self->priv->subscribers, self->priv->subscribers_length1, (GDestroyNotify) g_object_unref), NULL);
#line 56 "../src/core/DataSource.vala"
	_source_holding_tank_unref0 (self->priv->holding_tank);
#line 58 "../src/core/DataSource.vala"
	_g_object_unref0 (self->priv->backlinks);
#line 51 "../src/core/DataSource.vala"
	G_OBJECT_CLASS (data_source_parent_class)->finalize (obj);
#line 2746 "DataSource.c"
}

static GType
data_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSource), 0, (GInstanceInitFunc) data_source_instance_init, NULL };
	GType data_source_type_id;
	data_source_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	DataSource_private_offset = g_type_add_instance_private (data_source_type_id, sizeof (DataSourcePrivate));
	return data_source_type_id;
}

GType
data_source_get_type (void)
{
	static volatile gsize data_source_type_id__once = 0;
	if (g_once_init_enter (&data_source_type_id__once)) {
		GType data_source_type_id;
		data_source_type_id = data_source_get_type_once ();
		g_once_init_leave (&data_source_type_id__once, data_source_type_id);
	}
	return data_source_type_id__once;
}

static inline gpointer
source_snapshot_get_instance_private (SourceSnapshot* self)
{
	return G_STRUCT_MEMBER_P (self, SourceSnapshot_private_offset);
}

static void
source_snapshot_real_notify_broken (SourceSnapshot* self)
{
#line 468 "../src/core/DataSource.vala"
	self->priv->snapshot_broken = TRUE;
#line 470 "../src/core/DataSource.vala"
	g_signal_emit (self, source_snapshot_signals[SOURCE_SNAPSHOT_BROKEN_SIGNAL], 0);
#line 2784 "DataSource.c"
}

void
source_snapshot_notify_broken (SourceSnapshot* self)
{
	SourceSnapshotClass* _klass_;
#line 467 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 467 "../src/core/DataSource.vala"
	_klass_ = SOURCE_SNAPSHOT_GET_CLASS (self);
#line 467 "../src/core/DataSource.vala"
	if (_klass_->notify_broken) {
#line 467 "../src/core/DataSource.vala"
		_klass_->notify_broken (self);
#line 2799 "DataSource.c"
	}
}

gboolean
source_snapshot_is_broken (SourceSnapshot* self)
{
	gboolean result;
#line 473 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 474 "../src/core/DataSource.vala"
	result = self->priv->snapshot_broken;
#line 474 "../src/core/DataSource.vala"
	return result;
#line 2813 "DataSource.c"
}

SourceSnapshot*
source_snapshot_construct (GType object_type)
{
	SourceSnapshot* self = NULL;
#line 459 "../src/core/DataSource.vala"
	self = (SourceSnapshot*) g_type_create_instance (object_type);
#line 459 "../src/core/DataSource.vala"
	return self;
#line 2824 "DataSource.c"
}

static void
source_snapshot_real_broken (SourceSnapshot* self)
{
}

static void
value_source_snapshot_init (GValue* value)
{
#line 459 "../src/core/DataSource.vala"
	value->data[0].v_pointer = NULL;
#line 2837 "DataSource.c"
}

static void
value_source_snapshot_free_value (GValue* value)
{
#line 459 "../src/core/DataSource.vala"
	if (value->data[0].v_pointer) {
#line 459 "../src/core/DataSource.vala"
		source_snapshot_unref (value->data[0].v_pointer);
#line 2847 "DataSource.c"
	}
}

static void
value_source_snapshot_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 459 "../src/core/DataSource.vala"
	if (src_value->data[0].v_pointer) {
#line 459 "../src/core/DataSource.vala"
		dest_value->data[0].v_pointer = source_snapshot_ref (src_value->data[0].v_pointer);
#line 2859 "DataSource.c"
	} else {
#line 459 "../src/core/DataSource.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2863 "DataSource.c"
	}
}

static gpointer
value_source_snapshot_peek_pointer (const GValue* value)
{
#line 459 "../src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 2872 "DataSource.c"
}

static gchar*
value_source_snapshot_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 459 "../src/core/DataSource.vala"
	if (collect_values[0].v_pointer) {
#line 2883 "DataSource.c"
		SourceSnapshot * object;
		object = collect_values[0].v_pointer;
#line 459 "../src/core/DataSource.vala"
		if (object->parent_instance.g_class == NULL) {
#line 459 "../src/core/DataSource.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2890 "DataSource.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 459 "../src/core/DataSource.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2894 "DataSource.c"
		}
#line 459 "../src/core/DataSource.vala"
		value->data[0].v_pointer = source_snapshot_ref (object);
#line 2898 "DataSource.c"
	} else {
#line 459 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 2902 "DataSource.c"
	}
#line 459 "../src/core/DataSource.vala"
	return NULL;
#line 2906 "DataSource.c"
}

static gchar*
value_source_snapshot_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	SourceSnapshot ** object_p;
	object_p = collect_values[0].v_pointer;
#line 459 "../src/core/DataSource.vala"
	if (!object_p) {
#line 459 "../src/core/DataSource.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2921 "DataSource.c"
	}
#line 459 "../src/core/DataSource.vala"
	if (!value->data[0].v_pointer) {
#line 459 "../src/core/DataSource.vala"
		*object_p = NULL;
#line 2927 "DataSource.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 459 "../src/core/DataSource.vala"
		*object_p = value->data[0].v_pointer;
#line 2931 "DataSource.c"
	} else {
#line 459 "../src/core/DataSource.vala"
		*object_p = source_snapshot_ref (value->data[0].v_pointer);
#line 2935 "DataSource.c"
	}
#line 459 "../src/core/DataSource.vala"
	return NULL;
#line 2939 "DataSource.c"
}

GParamSpec*
param_spec_source_snapshot (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecSourceSnapshot* spec;
#line 459 "../src/core/DataSource.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_SNAPSHOT), NULL);
#line 459 "../src/core/DataSource.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 459 "../src/core/DataSource.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 459 "../src/core/DataSource.vala"
	return G_PARAM_SPEC (spec);
#line 2958 "DataSource.c"
}

gpointer
value_get_source_snapshot (const GValue* value)
{
#line 459 "../src/core/DataSource.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT), NULL);
#line 459 "../src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 2968 "DataSource.c"
}

void
value_set_source_snapshot (GValue* value,
                           gpointer v_object)
{
	SourceSnapshot * old;
#line 459 "../src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
#line 459 "../src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 459 "../src/core/DataSource.vala"
	if (v_object) {
#line 459 "../src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
#line 459 "../src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 459 "../src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 459 "../src/core/DataSource.vala"
		source_snapshot_ref (value->data[0].v_pointer);
#line 2990 "DataSource.c"
	} else {
#line 459 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 2994 "DataSource.c"
	}
#line 459 "../src/core/DataSource.vala"
	if (old) {
#line 459 "../src/core/DataSource.vala"
		source_snapshot_unref (old);
#line 3000 "DataSource.c"
	}
}

void
value_take_source_snapshot (GValue* value,
                            gpointer v_object)
{
	SourceSnapshot * old;
#line 459 "../src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
#line 459 "../src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 459 "../src/core/DataSource.vala"
	if (v_object) {
#line 459 "../src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
#line 459 "../src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 459 "../src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 3021 "DataSource.c"
	} else {
#line 459 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 3025 "DataSource.c"
	}
#line 459 "../src/core/DataSource.vala"
	if (old) {
#line 459 "../src/core/DataSource.vala"
		source_snapshot_unref (old);
#line 3031 "DataSource.c"
	}
}

static void
source_snapshot_class_init (SourceSnapshotClass * klass,
                            gpointer klass_data)
{
#line 459 "../src/core/DataSource.vala"
	source_snapshot_parent_class = g_type_class_peek_parent (klass);
#line 459 "../src/core/DataSource.vala"
	((SourceSnapshotClass *) klass)->finalize = source_snapshot_finalize;
#line 459 "../src/core/DataSource.vala"
	g_type_class_adjust_private_offset (klass, &SourceSnapshot_private_offset);
#line 459 "../src/core/DataSource.vala"
	((SourceSnapshotClass *) klass)->notify_broken = (void (*) (SourceSnapshot*)) source_snapshot_real_notify_broken;
#line 459 "../src/core/DataSource.vala"
	((SourceSnapshotClass *) klass)->broken = source_snapshot_real_broken;
#line 459 "../src/core/DataSource.vala"
	source_snapshot_signals[SOURCE_SNAPSHOT_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_SOURCE_SNAPSHOT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceSnapshotClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3051 "DataSource.c"
}

static void
source_snapshot_instance_init (SourceSnapshot * self,
                               gpointer klass)
{
#line 459 "../src/core/DataSource.vala"
	self->priv = source_snapshot_get_instance_private (self);
#line 460 "../src/core/DataSource.vala"
	self->priv->snapshot_broken = FALSE;
#line 459 "../src/core/DataSource.vala"
	self->ref_count = 1;
#line 3064 "DataSource.c"
}

static void
source_snapshot_finalize (SourceSnapshot * obj)
{
	SourceSnapshot * self;
#line 459 "../src/core/DataSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOURCE_SNAPSHOT, SourceSnapshot);
#line 459 "../src/core/DataSource.vala"
	g_signal_handlers_destroy (self);
#line 3075 "DataSource.c"
}

static GType
source_snapshot_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_source_snapshot_init, value_source_snapshot_free_value, value_source_snapshot_copy_value, value_source_snapshot_peek_pointer, "p", value_source_snapshot_collect_value, "p", value_source_snapshot_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SourceSnapshotClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_snapshot_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceSnapshot), 0, (GInstanceInitFunc) source_snapshot_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType source_snapshot_type_id;
	source_snapshot_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceSnapshot", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	SourceSnapshot_private_offset = g_type_add_instance_private (source_snapshot_type_id, sizeof (SourceSnapshotPrivate));
	return source_snapshot_type_id;
}

GType
source_snapshot_get_type (void)
{
	static volatile gsize source_snapshot_type_id__once = 0;
	if (g_once_init_enter (&source_snapshot_type_id__once)) {
		GType source_snapshot_type_id;
		source_snapshot_type_id = source_snapshot_get_type_once ();
		g_once_init_leave (&source_snapshot_type_id__once, source_snapshot_type_id);
	}
	return source_snapshot_type_id__once;
}

gpointer
source_snapshot_ref (gpointer instance)
{
	SourceSnapshot * self;
	self = instance;
#line 459 "../src/core/DataSource.vala"
	g_atomic_int_inc (&self->ref_count);
#line 459 "../src/core/DataSource.vala"
	return instance;
#line 3111 "DataSource.c"
}

void
source_snapshot_unref (gpointer instance)
{
	SourceSnapshot * self;
	self = instance;
#line 459 "../src/core/DataSource.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 459 "../src/core/DataSource.vala"
		SOURCE_SNAPSHOT_GET_CLASS (self)->finalize (self);
#line 459 "../src/core/DataSource.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3125 "DataSource.c"
	}
}

static inline gpointer
source_backlink_get_instance_private (SourceBacklink* self)
{
	return G_STRUCT_MEMBER_P (self, SourceBacklink_private_offset);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 3153 "DataSource.c"
}

SourceBacklink*
source_backlink_construct (GType object_type,
                           const gchar* name,
                           const gchar* value)
{
	SourceBacklink* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 511 "../src/core/DataSource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 511 "../src/core/DataSource.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 511 "../src/core/DataSource.vala"
	self = (SourceBacklink*) g_type_create_instance (object_type);
#line 512 "../src/core/DataSource.vala"
	_vala_assert (source_backlink_validate_name_value (name, value), "validate_name_value (name, value)");
#line 514 "../src/core/DataSource.vala"
	_tmp0_ = string_strip (name);
#line 514 "../src/core/DataSource.vala"
	_g_free0 (self->priv->_name);
#line 514 "../src/core/DataSource.vala"
	self->priv->_name = _tmp0_;
#line 515 "../src/core/DataSource.vala"
	_tmp1_ = string_strip (value);
#line 515 "../src/core/DataSource.vala"
	_g_free0 (self->priv->_value);
#line 515 "../src/core/DataSource.vala"
	self->priv->_value = _tmp1_;
#line 511 "../src/core/DataSource.vala"
	return self;
#line 3186 "DataSource.c"
}

SourceBacklink*
source_backlink_new (const gchar* name,
                     const gchar* value)
{
#line 511 "../src/core/DataSource.vala"
	return source_backlink_construct (TYPE_SOURCE_BACKLINK, name, value);
#line 3195 "DataSource.c"
}

SourceBacklink*
source_backlink_construct_from_source (GType object_type,
                                       DataSource* source)
{
	SourceBacklink* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 518 "../src/core/DataSource.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 518 "../src/core/DataSource.vala"
	self = (SourceBacklink*) g_type_create_instance (object_type);
#line 519 "../src/core/DataSource.vala"
	_tmp0_ = data_source_get_typename (source);
#line 519 "../src/core/DataSource.vala"
	_tmp1_ = _tmp0_;
#line 519 "../src/core/DataSource.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 519 "../src/core/DataSource.vala"
	_g_free0 (self->priv->_name);
#line 519 "../src/core/DataSource.vala"
	self->priv->_name = _tmp2_;
#line 519 "../src/core/DataSource.vala"
	_g_free0 (_tmp1_);
#line 520 "../src/core/DataSource.vala"
	_tmp3_ = g_strdup_printf ("%" G_GINT64_FORMAT, data_source_get_instance_id (source));
#line 520 "../src/core/DataSource.vala"
	_tmp4_ = _tmp3_;
#line 520 "../src/core/DataSource.vala"
	_tmp5_ = string_strip (_tmp4_);
#line 520 "../src/core/DataSource.vala"
	_g_free0 (self->priv->_value);
#line 520 "../src/core/DataSource.vala"
	self->priv->_value = _tmp5_;
#line 520 "../src/core/DataSource.vala"
	_g_free0 (_tmp4_);
#line 522 "../src/core/DataSource.vala"
	_tmp6_ = self->priv->_name;
#line 522 "../src/core/DataSource.vala"
	_tmp7_ = self->priv->_value;
#line 522 "../src/core/DataSource.vala"
	_vala_assert (source_backlink_validate_name_value (_tmp6_, _tmp7_), "validate_name_value (_name, _value)");
#line 518 "../src/core/DataSource.vala"
	return self;
#line 3247 "DataSource.c"
}

SourceBacklink*
source_backlink_new_from_source (DataSource* source)
{
#line 518 "../src/core/DataSource.vala"
	return source_backlink_construct_from_source (TYPE_SOURCE_BACKLINK, source);
#line 3255 "DataSource.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 3274 "DataSource.c"
}

static gboolean
source_backlink_validate_name_value (const gchar* name,
                                     const gchar* value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 525 "../src/core/DataSource.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 525 "../src/core/DataSource.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 526 "../src/core/DataSource.vala"
	if (!string_contains (name, "=")) {
#line 526 "../src/core/DataSource.vala"
		_tmp1_ = !string_contains (name, "|");
#line 3292 "DataSource.c"
	} else {
#line 526 "../src/core/DataSource.vala"
		_tmp1_ = FALSE;
#line 3296 "DataSource.c"
	}
#line 526 "../src/core/DataSource.vala"
	if (_tmp1_) {
#line 526 "../src/core/DataSource.vala"
		_tmp0_ = !string_contains (value, "|");
#line 3302 "DataSource.c"
	} else {
#line 526 "../src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 3306 "DataSource.c"
	}
#line 526 "../src/core/DataSource.vala"
	result = _tmp0_;
#line 526 "../src/core/DataSource.vala"
	return result;
#line 3312 "DataSource.c"
}

gchar*
source_backlink_to_string (SourceBacklink* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 529 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 530 "../src/core/DataSource.vala"
	_tmp0_ = source_backlink_get_name (self);
#line 530 "../src/core/DataSource.vala"
	_tmp1_ = _tmp0_;
#line 530 "../src/core/DataSource.vala"
	_tmp2_ = source_backlink_get_value (self);
#line 530 "../src/core/DataSource.vala"
	_tmp3_ = _tmp2_;
#line 530 "../src/core/DataSource.vala"
	_tmp4_ = g_strdup_printf ("Backlink %s=%s", _tmp1_, _tmp3_);
#line 530 "../src/core/DataSource.vala"
	result = _tmp4_;
#line 530 "../src/core/DataSource.vala"
	return result;
#line 3340 "DataSource.c"
}

guint
source_backlink_hash_func (SourceBacklink* backlink)
{
	GHashFunc _tmp0_;
	const gchar* _tmp1_;
	GHashFunc _tmp2_;
	const gchar* _tmp3_;
	guint result;
#line 534 "../src/core/DataSource.vala"
	_tmp0_ = g_str_hash;
#line 534 "../src/core/DataSource.vala"
	_tmp1_ = backlink->priv->_name;
#line 534 "../src/core/DataSource.vala"
	_tmp2_ = g_str_hash;
#line 534 "../src/core/DataSource.vala"
	_tmp3_ = backlink->priv->_value;
#line 534 "../src/core/DataSource.vala"
	result = _tmp0_ (_tmp1_) ^ _tmp2_ (_tmp3_);
#line 534 "../src/core/DataSource.vala"
	return result;
#line 3363 "DataSource.c"
}

gboolean
source_backlink_equal_func (SourceBacklink* alink,
                            SourceBacklink* blink)
{
	gboolean _tmp0_ = FALSE;
	GEqualFunc _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 538 "../src/core/DataSource.vala"
	_tmp1_ = g_str_equal;
#line 538 "../src/core/DataSource.vala"
	_tmp2_ = alink->priv->_name;
#line 538 "../src/core/DataSource.vala"
	_tmp3_ = blink->priv->_name;
#line 538 "../src/core/DataSource.vala"
	if (_tmp1_ (_tmp2_, _tmp3_)) {
#line 3383 "DataSource.c"
		GEqualFunc _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 538 "../src/core/DataSource.vala"
		_tmp4_ = g_str_equal;
#line 538 "../src/core/DataSource.vala"
		_tmp5_ = alink->priv->_value;
#line 538 "../src/core/DataSource.vala"
		_tmp6_ = blink->priv->_value;
#line 538 "../src/core/DataSource.vala"
		_tmp0_ = _tmp4_ (_tmp5_, _tmp6_);
#line 3395 "DataSource.c"
	} else {
#line 538 "../src/core/DataSource.vala"
		_tmp0_ = FALSE;
#line 3399 "DataSource.c"
	}
#line 538 "../src/core/DataSource.vala"
	result = _tmp0_;
#line 538 "../src/core/DataSource.vala"
	return result;
#line 3405 "DataSource.c"
}

const gchar*
source_backlink_get_name (SourceBacklink* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 486 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 487 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->_name;
#line 487 "../src/core/DataSource.vala"
	result = _tmp0_;
#line 487 "../src/core/DataSource.vala"
	return result;
#line 3421 "DataSource.c"
}

const gchar*
source_backlink_get_value (SourceBacklink* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 492 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 493 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->_value;
#line 493 "../src/core/DataSource.vala"
	result = _tmp0_;
#line 493 "../src/core/DataSource.vala"
	return result;
#line 3437 "DataSource.c"
}

const gchar*
source_backlink_get_typename (SourceBacklink* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 499 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 500 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->_name;
#line 500 "../src/core/DataSource.vala"
	result = _tmp0_;
#line 500 "../src/core/DataSource.vala"
	return result;
#line 3453 "DataSource.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 3467 "DataSource.c"
}

gint64
source_backlink_get_instance_id (SourceBacklink* self)
{
	gint64 result;
	const gchar* _tmp0_;
#line 506 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 507 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->_value;
#line 507 "../src/core/DataSource.vala"
	result = int64_parse (_tmp0_, (guint) 0);
#line 507 "../src/core/DataSource.vala"
	return result;
#line 3483 "DataSource.c"
}

static void
value_source_backlink_init (GValue* value)
{
#line 481 "../src/core/DataSource.vala"
	value->data[0].v_pointer = NULL;
#line 3491 "DataSource.c"
}

static void
value_source_backlink_free_value (GValue* value)
{
#line 481 "../src/core/DataSource.vala"
	if (value->data[0].v_pointer) {
#line 481 "../src/core/DataSource.vala"
		source_backlink_unref (value->data[0].v_pointer);
#line 3501 "DataSource.c"
	}
}

static void
value_source_backlink_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 481 "../src/core/DataSource.vala"
	if (src_value->data[0].v_pointer) {
#line 481 "../src/core/DataSource.vala"
		dest_value->data[0].v_pointer = source_backlink_ref (src_value->data[0].v_pointer);
#line 3513 "DataSource.c"
	} else {
#line 481 "../src/core/DataSource.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3517 "DataSource.c"
	}
}

static gpointer
value_source_backlink_peek_pointer (const GValue* value)
{
#line 481 "../src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 3526 "DataSource.c"
}

static gchar*
value_source_backlink_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 481 "../src/core/DataSource.vala"
	if (collect_values[0].v_pointer) {
#line 3537 "DataSource.c"
		SourceBacklink * object;
		object = collect_values[0].v_pointer;
#line 481 "../src/core/DataSource.vala"
		if (object->parent_instance.g_class == NULL) {
#line 481 "../src/core/DataSource.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3544 "DataSource.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 481 "../src/core/DataSource.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3548 "DataSource.c"
		}
#line 481 "../src/core/DataSource.vala"
		value->data[0].v_pointer = source_backlink_ref (object);
#line 3552 "DataSource.c"
	} else {
#line 481 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 3556 "DataSource.c"
	}
#line 481 "../src/core/DataSource.vala"
	return NULL;
#line 3560 "DataSource.c"
}

static gchar*
value_source_backlink_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	SourceBacklink ** object_p;
	object_p = collect_values[0].v_pointer;
#line 481 "../src/core/DataSource.vala"
	if (!object_p) {
#line 481 "../src/core/DataSource.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3575 "DataSource.c"
	}
#line 481 "../src/core/DataSource.vala"
	if (!value->data[0].v_pointer) {
#line 481 "../src/core/DataSource.vala"
		*object_p = NULL;
#line 3581 "DataSource.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 481 "../src/core/DataSource.vala"
		*object_p = value->data[0].v_pointer;
#line 3585 "DataSource.c"
	} else {
#line 481 "../src/core/DataSource.vala"
		*object_p = source_backlink_ref (value->data[0].v_pointer);
#line 3589 "DataSource.c"
	}
#line 481 "../src/core/DataSource.vala"
	return NULL;
#line 3593 "DataSource.c"
}

GParamSpec*
param_spec_source_backlink (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecSourceBacklink* spec;
#line 481 "../src/core/DataSource.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_BACKLINK), NULL);
#line 481 "../src/core/DataSource.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 481 "../src/core/DataSource.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 481 "../src/core/DataSource.vala"
	return G_PARAM_SPEC (spec);
#line 3612 "DataSource.c"
}

gpointer
value_get_source_backlink (const GValue* value)
{
#line 481 "../src/core/DataSource.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK), NULL);
#line 481 "../src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 3622 "DataSource.c"
}

void
value_set_source_backlink (GValue* value,
                           gpointer v_object)
{
	SourceBacklink * old;
#line 481 "../src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
#line 481 "../src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 481 "../src/core/DataSource.vala"
	if (v_object) {
#line 481 "../src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
#line 481 "../src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 481 "../src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 481 "../src/core/DataSource.vala"
		source_backlink_ref (value->data[0].v_pointer);
#line 3644 "DataSource.c"
	} else {
#line 481 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 3648 "DataSource.c"
	}
#line 481 "../src/core/DataSource.vala"
	if (old) {
#line 481 "../src/core/DataSource.vala"
		source_backlink_unref (old);
#line 3654 "DataSource.c"
	}
}

void
value_take_source_backlink (GValue* value,
                            gpointer v_object)
{
	SourceBacklink * old;
#line 481 "../src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
#line 481 "../src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 481 "../src/core/DataSource.vala"
	if (v_object) {
#line 481 "../src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
#line 481 "../src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 481 "../src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 3675 "DataSource.c"
	} else {
#line 481 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 3679 "DataSource.c"
	}
#line 481 "../src/core/DataSource.vala"
	if (old) {
#line 481 "../src/core/DataSource.vala"
		source_backlink_unref (old);
#line 3685 "DataSource.c"
	}
}

static void
source_backlink_class_init (SourceBacklinkClass * klass,
                            gpointer klass_data)
{
#line 481 "../src/core/DataSource.vala"
	source_backlink_parent_class = g_type_class_peek_parent (klass);
#line 481 "../src/core/DataSource.vala"
	((SourceBacklinkClass *) klass)->finalize = source_backlink_finalize;
#line 481 "../src/core/DataSource.vala"
	g_type_class_adjust_private_offset (klass, &SourceBacklink_private_offset);
#line 3699 "DataSource.c"
}

static void
source_backlink_instance_init (SourceBacklink * self,
                               gpointer klass)
{
#line 481 "../src/core/DataSource.vala"
	self->priv = source_backlink_get_instance_private (self);
#line 481 "../src/core/DataSource.vala"
	self->ref_count = 1;
#line 3710 "DataSource.c"
}

static void
source_backlink_finalize (SourceBacklink * obj)
{
	SourceBacklink * self;
#line 481 "../src/core/DataSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOURCE_BACKLINK, SourceBacklink);
#line 481 "../src/core/DataSource.vala"
	g_signal_handlers_destroy (self);
#line 482 "../src/core/DataSource.vala"
	_g_free0 (self->priv->_name);
#line 483 "../src/core/DataSource.vala"
	_g_free0 (self->priv->_value);
#line 3725 "DataSource.c"
}

static GType
source_backlink_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_source_backlink_init, value_source_backlink_free_value, value_source_backlink_copy_value, value_source_backlink_peek_pointer, "p", value_source_backlink_collect_value, "p", value_source_backlink_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SourceBacklinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_backlink_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceBacklink), 0, (GInstanceInitFunc) source_backlink_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType source_backlink_type_id;
	source_backlink_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceBacklink", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SourceBacklink_private_offset = g_type_add_instance_private (source_backlink_type_id, sizeof (SourceBacklinkPrivate));
	return source_backlink_type_id;
}

GType
source_backlink_get_type (void)
{
	static volatile gsize source_backlink_type_id__once = 0;
	if (g_once_init_enter (&source_backlink_type_id__once)) {
		GType source_backlink_type_id;
		source_backlink_type_id = source_backlink_get_type_once ();
		g_once_init_leave (&source_backlink_type_id__once, source_backlink_type_id);
	}
	return source_backlink_type_id__once;
}

gpointer
source_backlink_ref (gpointer instance)
{
	SourceBacklink * self;
	self = instance;
#line 481 "../src/core/DataSource.vala"
	g_atomic_int_inc (&self->ref_count);
#line 481 "../src/core/DataSource.vala"
	return instance;
#line 3761 "DataSource.c"
}

void
source_backlink_unref (gpointer instance)
{
	SourceBacklink * self;
	self = instance;
#line 481 "../src/core/DataSource.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 481 "../src/core/DataSource.vala"
		SOURCE_BACKLINK_GET_CLASS (self)->finalize (self);
#line 481 "../src/core/DataSource.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3775 "DataSource.c"
	}
}

static inline gpointer
source_proxy_get_instance_private (SourceProxy* self)
{
	return G_STRUCT_MEMBER_P (self, SourceProxy_private_offset);
}

static void
_source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender,
                                                           GeeIterable* added,
                                                           gpointer self)
{
#line 601 "../src/core/DataSource.vala"
	source_proxy_on_source_added ((SourceProxy*) self, added);
#line 3792 "DataSource.c"
}

static void
_source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender,
                                                         gpointer self)
{
#line 590 "../src/core/DataSource.vala"
	source_proxy_on_snapshot_broken ((SourceProxy*) self);
#line 3801 "DataSource.c"
}

SourceProxy*
source_proxy_construct (GType object_type,
                        DataSource* source)
{
	SourceProxy* self = NULL;
	gchar* _tmp0_;
	SourceSnapshot* _tmp1_;
	SourceSnapshot* _tmp2_;
	SourceSnapshot* _tmp3_;
	DataCollection* _tmp4_;
	SourceCollection* _tmp5_;
	SourceCollection* _tmp6_;
#line 584 "../src/core/DataSource.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 584 "../src/core/DataSource.vala"
	self = (SourceProxy*) g_type_create_instance (object_type);
#line 585 "../src/core/DataSource.vala"
	self->priv->object_id = data_object_get_object_id ((DataObject*) source);
#line 586 "../src/core/DataSource.vala"
	_tmp0_ = data_object_to_string ((DataObject*) source);
#line 586 "../src/core/DataSource.vala"
	_g_free0 (self->priv->source_string);
#line 586 "../src/core/DataSource.vala"
	self->priv->source_string = _tmp0_;
#line 588 "../src/core/DataSource.vala"
	_tmp1_ = data_source_save_snapshot (source);
#line 588 "../src/core/DataSource.vala"
	_source_snapshot_unref0 (self->priv->snapshot);
#line 588 "../src/core/DataSource.vala"
	self->priv->snapshot = _tmp1_;
#line 589 "../src/core/DataSource.vala"
	_tmp2_ = self->priv->snapshot;
#line 589 "../src/core/DataSource.vala"
	_vala_assert (_tmp2_ != NULL, "snapshot != null");
#line 590 "../src/core/DataSource.vala"
	_tmp3_ = self->priv->snapshot;
#line 590 "../src/core/DataSource.vala"
	g_signal_connect (_tmp3_, "broken", (GCallback) _source_proxy_on_snapshot_broken_source_snapshot_broken, self);
#line 592 "../src/core/DataSource.vala"
	source_proxy_set_source (self, source);
#line 594 "../src/core/DataSource.vala"
	_tmp4_ = data_object_get_membership ((DataObject*) source);
#line 594 "../src/core/DataSource.vala"
	_data_collection_unref0 (self->priv->membership);
#line 594 "../src/core/DataSource.vala"
	self->priv->membership = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_COLLECTION, SourceCollection);
#line 595 "../src/core/DataSource.vala"
	_tmp5_ = self->priv->membership;
#line 595 "../src/core/DataSource.vala"
	_vala_assert (_tmp5_ != NULL, "membership != null");
#line 596 "../src/core/DataSource.vala"
	_tmp6_ = self->priv->membership;
#line 596 "../src/core/DataSource.vala"
	g_signal_connect ((DataCollection*) _tmp6_, "items-added", (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 584 "../src/core/DataSource.vala"
	return self;
#line 3860 "DataSource.c"
}

static DataSource*
source_proxy_real_reconstitute (SourceProxy* self,
                                gint64 object_id,
                                SourceSnapshot* snapshot)
{
#line 604 "../src/core/DataSource.vala"
	g_critical ("Type `%s' does not implement abstract method `source_proxy_reconstitute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 604 "../src/core/DataSource.vala"
	return NULL;
#line 3872 "DataSource.c"
}

DataSource*
source_proxy_reconstitute (SourceProxy* self,
                           gint64 object_id,
                           SourceSnapshot* snapshot)
{
	SourceProxyClass* _klass_;
#line 604 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 604 "../src/core/DataSource.vala"
	_klass_ = SOURCE_PROXY_GET_CLASS (self);
#line 604 "../src/core/DataSource.vala"
	if (_klass_->reconstitute) {
#line 604 "../src/core/DataSource.vala"
		return _klass_->reconstitute (self, object_id, snapshot);
#line 3889 "DataSource.c"
	}
#line 604 "../src/core/DataSource.vala"
	return NULL;
#line 3893 "DataSource.c"
}

static void
source_proxy_real_notify_reconstituted (SourceProxy* self,
                                        DataSource* source)
{
#line 606 "../src/core/DataSource.vala"
	g_return_if_fail (source != NULL);
#line 607 "../src/core/DataSource.vala"
	g_signal_emit (self, source_proxy_signals[SOURCE_PROXY_RECONSTITUTED_SIGNAL], 0, source);
#line 3904 "DataSource.c"
}

void
source_proxy_notify_reconstituted (SourceProxy* self,
                                   DataSource* source)
{
	SourceProxyClass* _klass_;
#line 606 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 606 "../src/core/DataSource.vala"
	_klass_ = SOURCE_PROXY_GET_CLASS (self);
#line 606 "../src/core/DataSource.vala"
	if (_klass_->notify_reconstituted) {
#line 606 "../src/core/DataSource.vala"
		_klass_->notify_reconstituted (self, source);
#line 3920 "DataSource.c"
	}
}

static void
source_proxy_real_notify_dehydrated (SourceProxy* self)
{
#line 611 "../src/core/DataSource.vala"
	g_signal_emit (self, source_proxy_signals[SOURCE_PROXY_DEHYDRATED_SIGNAL], 0);
#line 3929 "DataSource.c"
}

void
source_proxy_notify_dehydrated (SourceProxy* self)
{
	SourceProxyClass* _klass_;
#line 610 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 610 "../src/core/DataSource.vala"
	_klass_ = SOURCE_PROXY_GET_CLASS (self);
#line 610 "../src/core/DataSource.vala"
	if (_klass_->notify_dehydrated) {
#line 610 "../src/core/DataSource.vala"
		_klass_->notify_dehydrated (self);
#line 3944 "DataSource.c"
	}
}

static void
source_proxy_real_notify_broken (SourceProxy* self)
{
#line 615 "../src/core/DataSource.vala"
	g_signal_emit (self, source_proxy_signals[SOURCE_PROXY_BROKEN_SIGNAL], 0);
#line 3953 "DataSource.c"
}

void
source_proxy_notify_broken (SourceProxy* self)
{
	SourceProxyClass* _klass_;
#line 614 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 614 "../src/core/DataSource.vala"
	_klass_ = SOURCE_PROXY_GET_CLASS (self);
#line 614 "../src/core/DataSource.vala"
	if (_klass_->notify_broken) {
#line 614 "../src/core/DataSource.vala"
		_klass_->notify_broken (self);
#line 3968 "DataSource.c"
	}
}

static void
source_proxy_on_snapshot_broken (SourceProxy* self)
{
#line 618 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 619 "../src/core/DataSource.vala"
	source_proxy_drop_source (self);
#line 621 "../src/core/DataSource.vala"
	source_proxy_notify_broken (self);
#line 3981 "DataSource.c"
}

static void
_source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender,
                                                  gpointer self)
{
#line 628 "../src/core/DataSource.vala"
	source_proxy_on_destroyed ((SourceProxy*) self);
#line 3990 "DataSource.c"
}

static void
source_proxy_set_source (SourceProxy* self,
                         DataSource* source)
{
	DataSource* _tmp0_;
#line 624 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 624 "../src/core/DataSource.vala"
	g_return_if_fail (source != NULL);
#line 625 "../src/core/DataSource.vala"
	source_proxy_drop_source (self);
#line 627 "../src/core/DataSource.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 627 "../src/core/DataSource.vala"
	_g_object_unref0 (self->priv->source);
#line 627 "../src/core/DataSource.vala"
	self->priv->source = _tmp0_;
#line 628 "../src/core/DataSource.vala"
	g_signal_connect (source, "destroyed", (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 4012 "DataSource.c"
}

static void
source_proxy_drop_source (SourceProxy* self)
{
	DataSource* _tmp0_;
	DataSource* _tmp1_;
	guint _tmp2_;
#line 631 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 632 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->source;
#line 632 "../src/core/DataSource.vala"
	if (_tmp0_ == NULL) {
#line 633 "../src/core/DataSource.vala"
		return;
#line 4029 "DataSource.c"
	}
#line 635 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->source;
#line 635 "../src/core/DataSource.vala"
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp2_, NULL, FALSE);
#line 635 "../src/core/DataSource.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 636 "../src/core/DataSource.vala"
	_g_object_unref0 (self->priv->source);
#line 636 "../src/core/DataSource.vala"
	self->priv->source = NULL;
#line 4041 "DataSource.c"
}

DataSource*
source_proxy_get_source (SourceProxy* self)
{
	SourceSnapshot* _tmp0_;
	DataSource* _tmp1_;
	DataSource* new_source = NULL;
	SourceSnapshot* _tmp4_;
	DataSource* _tmp5_;
	DataSource* _tmp6_;
	DataSource* _tmp7_;
	DataSource* _tmp10_;
	DataSource* _tmp12_;
	SourceCollection* _tmp13_;
	DataSource* _tmp14_;
	DataSource* _tmp15_;
	DataSource* _tmp16_;
	DataSource* result;
#line 639 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 640 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->snapshot;
#line 640 "../src/core/DataSource.vala"
	if (source_snapshot_is_broken (_tmp0_)) {
#line 641 "../src/core/DataSource.vala"
		result = NULL;
#line 641 "../src/core/DataSource.vala"
		return result;
#line 4071 "DataSource.c"
	}
#line 643 "../src/core/DataSource.vala"
	_tmp1_ = self->priv->source;
#line 643 "../src/core/DataSource.vala"
	if (_tmp1_ != NULL) {
#line 4077 "DataSource.c"
		DataSource* _tmp2_;
		DataSource* _tmp3_;
#line 644 "../src/core/DataSource.vala"
		_tmp2_ = self->priv->source;
#line 644 "../src/core/DataSource.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 644 "../src/core/DataSource.vala"
		result = _tmp3_;
#line 644 "../src/core/DataSource.vala"
		return result;
#line 4088 "DataSource.c"
	}
#line 649 "../src/core/DataSource.vala"
	_tmp4_ = self->priv->snapshot;
#line 649 "../src/core/DataSource.vala"
	_tmp5_ = source_proxy_reconstitute (self, self->priv->object_id, _tmp4_);
#line 649 "../src/core/DataSource.vala"
	new_source = _tmp5_;
#line 650 "../src/core/DataSource.vala"
	_tmp6_ = self->priv->source;
#line 650 "../src/core/DataSource.vala"
	_tmp7_ = new_source;
#line 650 "../src/core/DataSource.vala"
	if (_tmp6_ != _tmp7_) {
#line 4102 "DataSource.c"
		DataSource* _tmp8_;
		DataSource* _tmp9_;
#line 651 "../src/core/DataSource.vala"
		_tmp8_ = new_source;
#line 651 "../src/core/DataSource.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 651 "../src/core/DataSource.vala"
		_g_object_unref0 (self->priv->source);
#line 651 "../src/core/DataSource.vala"
		self->priv->source = _tmp9_;
#line 4113 "DataSource.c"
	}
#line 652 "../src/core/DataSource.vala"
	_tmp10_ = self->priv->source;
#line 652 "../src/core/DataSource.vala"
	if (self->priv->object_id != data_object_get_object_id ((DataObject*) _tmp10_)) {
#line 4119 "DataSource.c"
		DataSource* _tmp11_;
#line 653 "../src/core/DataSource.vala"
		_tmp11_ = new_source;
#line 653 "../src/core/DataSource.vala"
		self->priv->object_id = data_object_get_object_id ((DataObject*) _tmp11_);
#line 4125 "DataSource.c"
	}
#line 654 "../src/core/DataSource.vala"
	_tmp12_ = self->priv->source;
#line 654 "../src/core/DataSource.vala"
	_vala_assert (data_object_get_object_id ((DataObject*) _tmp12_) == self->priv->object_id, "source.get_object_id () == object_id");
#line 655 "../src/core/DataSource.vala"
	_tmp13_ = self->priv->membership;
#line 655 "../src/core/DataSource.vala"
	_tmp14_ = self->priv->source;
#line 655 "../src/core/DataSource.vala"
	_vala_assert (data_collection_contains ((DataCollection*) _tmp13_, (DataObject*) _tmp14_), "membership.contains (source)");
#line 657 "../src/core/DataSource.vala"
	_tmp15_ = self->priv->source;
#line 657 "../src/core/DataSource.vala"
	_tmp16_ = _g_object_ref0 (_tmp15_);
#line 657 "../src/core/DataSource.vala"
	result = _tmp16_;
#line 657 "../src/core/DataSource.vala"
	_g_object_unref0 (new_source);
#line 657 "../src/core/DataSource.vala"
	return result;
#line 4147 "DataSource.c"
}

static void
source_proxy_on_destroyed (SourceProxy* self)
{
	DataSource* _tmp0_;
#line 660 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 661 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->source;
#line 661 "../src/core/DataSource.vala"
	_vala_assert (_tmp0_ != NULL, "source != null");
#line 664 "../src/core/DataSource.vala"
	source_proxy_drop_source (self);
#line 666 "../src/core/DataSource.vala"
	source_proxy_notify_dehydrated (self);
#line 4164 "DataSource.c"
}

static void
source_proxy_on_source_added (SourceProxy* self,
                              GeeIterable* added)
{
	DataSource* _tmp0_;
#line 669 "../src/core/DataSource.vala"
	g_return_if_fail (self != NULL);
#line 669 "../src/core/DataSource.vala"
	g_return_if_fail (added != NULL);
#line 671 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->source;
#line 671 "../src/core/DataSource.vala"
	if (_tmp0_ != NULL) {
#line 672 "../src/core/DataSource.vala"
		return;
#line 4182 "DataSource.c"
	}
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp1_;
#line 674 "../src/core/DataSource.vala"
		_tmp1_ = gee_iterable_iterator (added);
#line 674 "../src/core/DataSource.vala"
		_object_it = _tmp1_;
#line 674 "../src/core/DataSource.vala"
		while (TRUE) {
#line 4193 "DataSource.c"
			GeeIterator* _tmp2_;
			DataObject* object = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataObject* _tmp5_;
			DataObject* _tmp6_;
			DataObject* _tmp7_;
#line 674 "../src/core/DataSource.vala"
			_tmp2_ = _object_it;
#line 674 "../src/core/DataSource.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 674 "../src/core/DataSource.vala"
				break;
#line 4207 "DataSource.c"
			}
#line 674 "../src/core/DataSource.vala"
			_tmp3_ = _object_it;
#line 674 "../src/core/DataSource.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 674 "../src/core/DataSource.vala"
			object = (DataObject*) _tmp4_;
#line 676 "../src/core/DataSource.vala"
			_tmp5_ = object;
#line 676 "../src/core/DataSource.vala"
			if (data_object_get_object_id (_tmp5_) != self->priv->object_id) {
#line 677 "../src/core/DataSource.vala"
				_g_object_unref0 (object);
#line 677 "../src/core/DataSource.vala"
				continue;
#line 4223 "DataSource.c"
			}
#line 680 "../src/core/DataSource.vala"
			_tmp6_ = object;
#line 680 "../src/core/DataSource.vala"
			source_proxy_set_source (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_SOURCE, DataSource));
#line 682 "../src/core/DataSource.vala"
			_tmp7_ = object;
#line 682 "../src/core/DataSource.vala"
			source_proxy_notify_reconstituted (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_SOURCE, DataSource));
#line 684 "../src/core/DataSource.vala"
			_g_object_unref0 (object);
#line 684 "../src/core/DataSource.vala"
			break;
#line 4237 "DataSource.c"
		}
#line 674 "../src/core/DataSource.vala"
		_g_object_unref0 (_object_it);
#line 4241 "DataSource.c"
	}
}

static void
source_proxy_real_reconstituted (SourceProxy* self,
                                 DataSource* source)
{
#line 571 "../src/core/DataSource.vala"
	g_return_if_fail (source != NULL);
#line 4251 "DataSource.c"
}

static void
source_proxy_real_dehydrated (SourceProxy* self)
{
}

static void
source_proxy_real_broken (SourceProxy* self)
{
}

static void
value_source_proxy_init (GValue* value)
{
#line 562 "../src/core/DataSource.vala"
	value->data[0].v_pointer = NULL;
#line 4269 "DataSource.c"
}

static void
value_source_proxy_free_value (GValue* value)
{
#line 562 "../src/core/DataSource.vala"
	if (value->data[0].v_pointer) {
#line 562 "../src/core/DataSource.vala"
		source_proxy_unref (value->data[0].v_pointer);
#line 4279 "DataSource.c"
	}
}

static void
value_source_proxy_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 562 "../src/core/DataSource.vala"
	if (src_value->data[0].v_pointer) {
#line 562 "../src/core/DataSource.vala"
		dest_value->data[0].v_pointer = source_proxy_ref (src_value->data[0].v_pointer);
#line 4291 "DataSource.c"
	} else {
#line 562 "../src/core/DataSource.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4295 "DataSource.c"
	}
}

static gpointer
value_source_proxy_peek_pointer (const GValue* value)
{
#line 562 "../src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 4304 "DataSource.c"
}

static gchar*
value_source_proxy_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 562 "../src/core/DataSource.vala"
	if (collect_values[0].v_pointer) {
#line 4315 "DataSource.c"
		SourceProxy * object;
		object = collect_values[0].v_pointer;
#line 562 "../src/core/DataSource.vala"
		if (object->parent_instance.g_class == NULL) {
#line 562 "../src/core/DataSource.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4322 "DataSource.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 562 "../src/core/DataSource.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4326 "DataSource.c"
		}
#line 562 "../src/core/DataSource.vala"
		value->data[0].v_pointer = source_proxy_ref (object);
#line 4330 "DataSource.c"
	} else {
#line 562 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4334 "DataSource.c"
	}
#line 562 "../src/core/DataSource.vala"
	return NULL;
#line 4338 "DataSource.c"
}

static gchar*
value_source_proxy_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	SourceProxy ** object_p;
	object_p = collect_values[0].v_pointer;
#line 562 "../src/core/DataSource.vala"
	if (!object_p) {
#line 562 "../src/core/DataSource.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4353 "DataSource.c"
	}
#line 562 "../src/core/DataSource.vala"
	if (!value->data[0].v_pointer) {
#line 562 "../src/core/DataSource.vala"
		*object_p = NULL;
#line 4359 "DataSource.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 562 "../src/core/DataSource.vala"
		*object_p = value->data[0].v_pointer;
#line 4363 "DataSource.c"
	} else {
#line 562 "../src/core/DataSource.vala"
		*object_p = source_proxy_ref (value->data[0].v_pointer);
#line 4367 "DataSource.c"
	}
#line 562 "../src/core/DataSource.vala"
	return NULL;
#line 4371 "DataSource.c"
}

GParamSpec*
param_spec_source_proxy (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecSourceProxy* spec;
#line 562 "../src/core/DataSource.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_PROXY), NULL);
#line 562 "../src/core/DataSource.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 562 "../src/core/DataSource.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 562 "../src/core/DataSource.vala"
	return G_PARAM_SPEC (spec);
#line 4390 "DataSource.c"
}

gpointer
value_get_source_proxy (const GValue* value)
{
#line 562 "../src/core/DataSource.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY), NULL);
#line 562 "../src/core/DataSource.vala"
	return value->data[0].v_pointer;
#line 4400 "DataSource.c"
}

void
value_set_source_proxy (GValue* value,
                        gpointer v_object)
{
	SourceProxy * old;
#line 562 "../src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
#line 562 "../src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 562 "../src/core/DataSource.vala"
	if (v_object) {
#line 562 "../src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
#line 562 "../src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 562 "../src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 562 "../src/core/DataSource.vala"
		source_proxy_ref (value->data[0].v_pointer);
#line 4422 "DataSource.c"
	} else {
#line 562 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4426 "DataSource.c"
	}
#line 562 "../src/core/DataSource.vala"
	if (old) {
#line 562 "../src/core/DataSource.vala"
		source_proxy_unref (old);
#line 4432 "DataSource.c"
	}
}

void
value_take_source_proxy (GValue* value,
                         gpointer v_object)
{
	SourceProxy * old;
#line 562 "../src/core/DataSource.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
#line 562 "../src/core/DataSource.vala"
	old = value->data[0].v_pointer;
#line 562 "../src/core/DataSource.vala"
	if (v_object) {
#line 562 "../src/core/DataSource.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
#line 562 "../src/core/DataSource.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 562 "../src/core/DataSource.vala"
		value->data[0].v_pointer = v_object;
#line 4453 "DataSource.c"
	} else {
#line 562 "../src/core/DataSource.vala"
		value->data[0].v_pointer = NULL;
#line 4457 "DataSource.c"
	}
#line 562 "../src/core/DataSource.vala"
	if (old) {
#line 562 "../src/core/DataSource.vala"
		source_proxy_unref (old);
#line 4463 "DataSource.c"
	}
}

static void
source_proxy_class_init (SourceProxyClass * klass,
                         gpointer klass_data)
{
#line 562 "../src/core/DataSource.vala"
	source_proxy_parent_class = g_type_class_peek_parent (klass);
#line 562 "../src/core/DataSource.vala"
	((SourceProxyClass *) klass)->finalize = source_proxy_finalize;
#line 562 "../src/core/DataSource.vala"
	g_type_class_adjust_private_offset (klass, &SourceProxy_private_offset);
#line 562 "../src/core/DataSource.vala"
	((SourceProxyClass *) klass)->reconstitute = (DataSource* (*) (SourceProxy*, gint64, SourceSnapshot*)) source_proxy_real_reconstitute;
#line 562 "../src/core/DataSource.vala"
	((SourceProxyClass *) klass)->notify_reconstituted = (void (*) (SourceProxy*, DataSource*)) source_proxy_real_notify_reconstituted;
#line 562 "../src/core/DataSource.vala"
	((SourceProxyClass *) klass)->notify_dehydrated = (void (*) (SourceProxy*)) source_proxy_real_notify_dehydrated;
#line 562 "../src/core/DataSource.vala"
	((SourceProxyClass *) klass)->notify_broken = (void (*) (SourceProxy*)) source_proxy_real_notify_broken;
#line 562 "../src/core/DataSource.vala"
	((SourceProxyClass *) klass)->reconstituted = source_proxy_real_reconstituted;
#line 562 "../src/core/DataSource.vala"
	((SourceProxyClass *) klass)->dehydrated = source_proxy_real_dehydrated;
#line 562 "../src/core/DataSource.vala"
	((SourceProxyClass *) klass)->broken = source_proxy_real_broken;
#line 562 "../src/core/DataSource.vala"
	source_proxy_signals[SOURCE_PROXY_RECONSTITUTED_SIGNAL] = g_signal_new ("reconstituted", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, reconstituted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
#line 562 "../src/core/DataSource.vala"
	source_proxy_signals[SOURCE_PROXY_DEHYDRATED_SIGNAL] = g_signal_new ("dehydrated", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, dehydrated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 562 "../src/core/DataSource.vala"
	source_proxy_signals[SOURCE_PROXY_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4497 "DataSource.c"
}

static void
source_proxy_instance_init (SourceProxy * self,
                            gpointer klass)
{
#line 562 "../src/core/DataSource.vala"
	self->priv = source_proxy_get_instance_private (self);
#line 562 "../src/core/DataSource.vala"
	self->ref_count = 1;
#line 4508 "DataSource.c"
}

static void
source_proxy_finalize (SourceProxy * obj)
{
	SourceProxy * self;
	SourceCollection* _tmp0_;
	guint _tmp1_;
#line 562 "../src/core/DataSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOURCE_PROXY, SourceProxy);
#line 562 "../src/core/DataSource.vala"
	g_signal_handlers_destroy (self);
#line 600 "../src/core/DataSource.vala"
	source_proxy_drop_source (self);
#line 601 "../src/core/DataSource.vala"
	_tmp0_ = self->priv->membership;
#line 601 "../src/core/DataSource.vala"
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 601 "../src/core/DataSource.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 564 "../src/core/DataSource.vala"
	_g_free0 (self->priv->source_string);
#line 565 "../src/core/DataSource.vala"
	_g_object_unref0 (self->priv->source);
#line 566 "../src/core/DataSource.vala"
	_source_snapshot_unref0 (self->priv->snapshot);
#line 567 "../src/core/DataSource.vala"
	_data_collection_unref0 (self->priv->membership);
#line 4537 "DataSource.c"
}

static GType
source_proxy_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_source_proxy_init, value_source_proxy_free_value, value_source_proxy_copy_value, value_source_proxy_peek_pointer, "p", value_source_proxy_collect_value, "p", value_source_proxy_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SourceProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceProxy), 0, (GInstanceInitFunc) source_proxy_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType source_proxy_type_id;
	source_proxy_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceProxy", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	SourceProxy_private_offset = g_type_add_instance_private (source_proxy_type_id, sizeof (SourceProxyPrivate));
	return source_proxy_type_id;
}

GType
source_proxy_get_type (void)
{
	static volatile gsize source_proxy_type_id__once = 0;
	if (g_once_init_enter (&source_proxy_type_id__once)) {
		GType source_proxy_type_id;
		source_proxy_type_id = source_proxy_get_type_once ();
		g_once_init_leave (&source_proxy_type_id__once, source_proxy_type_id);
	}
	return source_proxy_type_id__once;
}

gpointer
source_proxy_ref (gpointer instance)
{
	SourceProxy * self;
	self = instance;
#line 562 "../src/core/DataSource.vala"
	g_atomic_int_inc (&self->ref_count);
#line 562 "../src/core/DataSource.vala"
	return instance;
#line 4573 "DataSource.c"
}

void
source_proxy_unref (gpointer instance)
{
	SourceProxy * self;
	self = instance;
#line 562 "../src/core/DataSource.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 562 "../src/core/DataSource.vala"
		SOURCE_PROXY_GET_CLASS (self)->finalize (self);
#line 562 "../src/core/DataSource.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4587 "DataSource.c"
	}
}

SourceProxy*
proxyable_get_proxy (Proxyable* self)
{
	ProxyableIface* _iface_;
#line 690 "../src/core/DataSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 690 "../src/core/DataSource.vala"
	_iface_ = PROXYABLE_GET_INTERFACE (self);
#line 690 "../src/core/DataSource.vala"
	if (_iface_->get_proxy) {
#line 690 "../src/core/DataSource.vala"
		return _iface_->get_proxy (self);
#line 4603 "DataSource.c"
	}
#line 690 "../src/core/DataSource.vala"
	return NULL;
#line 4607 "DataSource.c"
}

static void
proxyable_default_init (ProxyableIface * iface,
                        gpointer iface_data)
{
}

static GType
proxyable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ProxyableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) proxyable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType proxyable_type_id;
	proxyable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Proxyable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (proxyable_type_id, G_TYPE_OBJECT);
	return proxyable_type_id;
}

GType
proxyable_get_type (void)
{
	static volatile gsize proxyable_type_id__once = 0;
	if (g_once_init_enter (&proxyable_type_id__once)) {
		GType proxyable_type_id;
		proxyable_type_id = proxyable_get_type_once ();
		g_once_init_leave (&proxyable_type_id__once, proxyable_type_id);
	}
	return proxyable_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

