/* DataSourceTypes.c generated by valac 0.56.18, the Vala compiler
 * generated from DataSourceTypes.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* Media sources*/
/**/

#include "io.elementary.photos.h"
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	THUMBNAIL_SOURCE_0_PROPERTY,
	THUMBNAIL_SOURCE_NUM_PROPERTIES
};
static GParamSpec* thumbnail_source_properties[THUMBNAIL_SOURCE_NUM_PROPERTIES];
enum  {
	THUMBNAIL_SOURCE_THUMBNAIL_ALTERED_SIGNAL,
	THUMBNAIL_SOURCE_NUM_SIGNALS
};
static guint thumbnail_source_signals[THUMBNAIL_SOURCE_NUM_SIGNALS] = {0};
enum  {
	PHOTO_SOURCE_0_PROPERTY,
	PHOTO_SOURCE_NUM_PROPERTIES
};
static GParamSpec* photo_source_properties[PHOTO_SOURCE_NUM_PROPERTIES];
enum  {
	VIDEO_SOURCE_0_PROPERTY,
	VIDEO_SOURCE_NUM_PROPERTIES
};
static GParamSpec* video_source_properties[VIDEO_SOURCE_NUM_PROPERTIES];
enum  {
	EVENT_SOURCE_0_PROPERTY,
	EVENT_SOURCE_NUM_PROPERTIES
};
static GParamSpec* event_source_properties[EVENT_SOURCE_NUM_PROPERTIES];

static gpointer thumbnail_source_parent_class = NULL;
static gpointer photo_source_parent_class = NULL;
static gpointer video_source_parent_class = NULL;
static gpointer event_source_parent_class = NULL;

static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self,
                                                    DataView* view);
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view,
                                                                                    gpointer self);
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self,
                                                gint scale,
                                                GError** error);
static GdkPixbuf* thumbnail_source_real_create_thumbnail (ThumbnailSource* self,
                                                   gint scale,
                                                   GError** error);
static gchar* thumbnail_source_real_get_representative_id (ThumbnailSource* self);
static PhotoFileFormat thumbnail_source_real_get_preferred_thumbnail_format (ThumbnailSource* self);
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self);
static GType thumbnail_source_get_type_once (void);
static PhotoMetadata* photo_source_real_get_metadata (PhotoSource* self);
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self,
                                         Scaling* scaling,
                                         GError** error);
static GType photo_source_get_type_once (void);
static GType video_source_get_type_once (void);
static gint64 event_source_real_get_start_time (EventSource* self);
static gint64 event_source_real_get_end_time (EventSource* self);
static guint64 event_source_real_get_total_filesize (EventSource* self);
static gint event_source_real_get_media_count (EventSource* self);
static GeeCollection* event_source_real_get_media (EventSource* self);
static gchar* event_source_real_get_comment (EventSource* self);
static gboolean event_source_real_set_comment (EventSource* self,
                                        const gchar* comment);
static GType event_source_get_type_once (void);
static GType container_source_get_type_once (void);

ThumbnailSource*
thumbnail_source_construct (GType object_type,
                            gint64 object_id)
{
	ThumbnailSource * self = NULL;
#line 29 "../src/core/DataSourceTypes.vala"
	self = (ThumbnailSource*) data_source_construct (object_type, object_id);
#line 28 "../src/core/DataSourceTypes.vala"
	return self;
#line 116 "DataSourceTypes.c"
}

static void
_thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view,
                                                                               gpointer self)
{
#line 37 "../src/core/DataSourceTypes.vala"
	thumbnail_source_subscriber_thumbnail_altered ((ThumbnailSource*) self, view);
#line 125 "DataSourceTypes.c"
}

static void
thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self)
{
#line 34 "../src/core/DataSourceTypes.vala"
	g_signal_emit (self, thumbnail_source_signals[THUMBNAIL_SOURCE_THUMBNAIL_ALTERED_SIGNAL], 0);
#line 37 "../src/core/DataSourceTypes.vala"
	data_source_contact_subscribers ((DataSource*) self, _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber, self);
#line 135 "DataSourceTypes.c"
}

void
thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self)
{
	ThumbnailSourceClass* _klass_;
#line 32 "../src/core/DataSourceTypes.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/core/DataSourceTypes.vala"
	_klass_ = THUMBNAIL_SOURCE_GET_CLASS (self);
#line 32 "../src/core/DataSourceTypes.vala"
	if (_klass_->notify_thumbnail_altered) {
#line 32 "../src/core/DataSourceTypes.vala"
		_klass_->notify_thumbnail_altered (self);
#line 150 "DataSourceTypes.c"
	}
}

static void
thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self,
                                               DataView* view)
{
#line 40 "../src/core/DataSourceTypes.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/core/DataSourceTypes.vala"
	g_return_if_fail (view != NULL);
#line 41 "../src/core/DataSourceTypes.vala"
	thumbnail_view_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_THUMBNAIL_VIEW, ThumbnailView));
#line 164 "DataSourceTypes.c"
}

static GdkPixbuf*
thumbnail_source_real_get_thumbnail (ThumbnailSource* self,
                                     gint scale,
                                     GError** error)
{
#line 44 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_thumbnail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 44 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 176 "DataSourceTypes.c"
}

GdkPixbuf*
thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                gint scale,
                                GError** error)
{
	ThumbnailSourceClass* _klass_;
#line 44 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/core/DataSourceTypes.vala"
	_klass_ = THUMBNAIL_SOURCE_GET_CLASS (self);
#line 44 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_thumbnail) {
#line 44 "../src/core/DataSourceTypes.vala"
		return _klass_->get_thumbnail (self, scale, error);
#line 193 "DataSourceTypes.c"
	}
#line 44 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 197 "DataSourceTypes.c"
}

static GdkPixbuf*
thumbnail_source_real_create_thumbnail (ThumbnailSource* self,
                                        gint scale,
                                        GError** error)
{
#line 48 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_create_thumbnail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 48 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 209 "DataSourceTypes.c"
}

GdkPixbuf*
thumbnail_source_create_thumbnail (ThumbnailSource* self,
                                   gint scale,
                                   GError** error)
{
	ThumbnailSourceClass* _klass_;
#line 48 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/core/DataSourceTypes.vala"
	_klass_ = THUMBNAIL_SOURCE_GET_CLASS (self);
#line 48 "../src/core/DataSourceTypes.vala"
	if (_klass_->create_thumbnail) {
#line 48 "../src/core/DataSourceTypes.vala"
		return _klass_->create_thumbnail (self, scale, error);
#line 226 "DataSourceTypes.c"
	}
#line 48 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 230 "DataSourceTypes.c"
}

static gchar*
thumbnail_source_real_get_representative_id (ThumbnailSource* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 60 "../src/core/DataSourceTypes.vala"
	_tmp0_ = data_source_get_source_id ((DataSource*) self);
#line 60 "../src/core/DataSourceTypes.vala"
	result = _tmp0_;
#line 60 "../src/core/DataSourceTypes.vala"
	return result;
#line 244 "DataSourceTypes.c"
}

gchar*
thumbnail_source_get_representative_id (ThumbnailSource* self)
{
	ThumbnailSourceClass* _klass_;
#line 59 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/core/DataSourceTypes.vala"
	_klass_ = THUMBNAIL_SOURCE_GET_CLASS (self);
#line 59 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_representative_id) {
#line 59 "../src/core/DataSourceTypes.vala"
		return _klass_->get_representative_id (self);
#line 259 "DataSourceTypes.c"
	}
#line 59 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 263 "DataSourceTypes.c"
}

static PhotoFileFormat
thumbnail_source_real_get_preferred_thumbnail_format (ThumbnailSource* self)
{
#line 63 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_preferred_thumbnail_format'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 63 "../src/core/DataSourceTypes.vala"
	return 0;
#line 273 "DataSourceTypes.c"
}

PhotoFileFormat
thumbnail_source_get_preferred_thumbnail_format (ThumbnailSource* self)
{
	ThumbnailSourceClass* _klass_;
#line 63 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 63 "../src/core/DataSourceTypes.vala"
	_klass_ = THUMBNAIL_SOURCE_GET_CLASS (self);
#line 63 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_preferred_thumbnail_format) {
#line 63 "../src/core/DataSourceTypes.vala"
		return _klass_->get_preferred_thumbnail_format (self);
#line 288 "DataSourceTypes.c"
	}
#line 63 "../src/core/DataSourceTypes.vala"
	return 0;
#line 292 "DataSourceTypes.c"
}

static void
thumbnail_source_real_thumbnail_altered (ThumbnailSource* self)
{
}

static void
thumbnail_source_class_init (ThumbnailSourceClass * klass,
                             gpointer klass_data)
{
#line 24 "../src/core/DataSourceTypes.vala"
	thumbnail_source_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/core/DataSourceTypes.vala"
	((ThumbnailSourceClass *) klass)->notify_thumbnail_altered = (void (*) (ThumbnailSource*)) thumbnail_source_real_notify_thumbnail_altered;
#line 24 "../src/core/DataSourceTypes.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) thumbnail_source_real_get_thumbnail;
#line 24 "../src/core/DataSourceTypes.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) thumbnail_source_real_create_thumbnail;
#line 24 "../src/core/DataSourceTypes.vala"
	((ThumbnailSourceClass *) klass)->get_representative_id = (gchar* (*) (ThumbnailSource*)) thumbnail_source_real_get_representative_id;
#line 24 "../src/core/DataSourceTypes.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) thumbnail_source_real_get_preferred_thumbnail_format;
#line 24 "../src/core/DataSourceTypes.vala"
	((ThumbnailSourceClass *) klass)->thumbnail_altered = thumbnail_source_real_thumbnail_altered;
#line 24 "../src/core/DataSourceTypes.vala"
	thumbnail_source_signals[THUMBNAIL_SOURCE_THUMBNAIL_ALTERED_SIGNAL] = g_signal_new ("thumbnail-altered", TYPE_THUMBNAIL_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailSourceClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 320 "DataSourceTypes.c"
}

static void
thumbnail_source_instance_init (ThumbnailSource * self,
                                gpointer klass)
{
}

static GType
thumbnail_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThumbnailSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailSource), 0, (GInstanceInitFunc) thumbnail_source_instance_init, NULL };
	GType thumbnail_source_type_id;
	thumbnail_source_type_id = g_type_register_static (TYPE_DATA_SOURCE, "ThumbnailSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return thumbnail_source_type_id;
}

GType
thumbnail_source_get_type (void)
{
	static volatile gsize thumbnail_source_type_id__once = 0;
	if (g_once_init_enter (&thumbnail_source_type_id__once)) {
		GType thumbnail_source_type_id;
		thumbnail_source_type_id = thumbnail_source_get_type_once ();
		g_once_init_leave (&thumbnail_source_type_id__once, thumbnail_source_type_id);
	}
	return thumbnail_source_type_id__once;
}

PhotoSource*
photo_source_construct (GType object_type,
                        gint64 object_id)
{
	PhotoSource * self = NULL;
#line 68 "../src/core/DataSourceTypes.vala"
	self = (PhotoSource*) media_source_construct (object_type, object_id);
#line 67 "../src/core/DataSourceTypes.vala"
	return self;
#line 359 "DataSourceTypes.c"
}

static PhotoMetadata*
photo_source_real_get_metadata (PhotoSource* self)
{
#line 71 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 71 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 369 "DataSourceTypes.c"
}

PhotoMetadata*
photo_source_get_metadata (PhotoSource* self)
{
	PhotoSourceClass* _klass_;
#line 71 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/core/DataSourceTypes.vala"
	_klass_ = PHOTO_SOURCE_GET_CLASS (self);
#line 71 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_metadata) {
#line 71 "../src/core/DataSourceTypes.vala"
		return _klass_->get_metadata (self);
#line 384 "DataSourceTypes.c"
	}
#line 71 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 388 "DataSourceTypes.c"
}

static GdkPixbuf*
photo_source_real_get_pixbuf (PhotoSource* self,
                              Scaling* scaling,
                              GError** error)
{
#line 73 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_pixbuf'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 73 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 400 "DataSourceTypes.c"
}

GdkPixbuf*
photo_source_get_pixbuf (PhotoSource* self,
                         Scaling* scaling,
                         GError** error)
{
	PhotoSourceClass* _klass_;
#line 73 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/core/DataSourceTypes.vala"
	_klass_ = PHOTO_SOURCE_GET_CLASS (self);
#line 73 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_pixbuf) {
#line 73 "../src/core/DataSourceTypes.vala"
		return _klass_->get_pixbuf (self, scaling, error);
#line 417 "DataSourceTypes.c"
	}
#line 73 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 421 "DataSourceTypes.c"
}

static void
photo_source_class_init (PhotoSourceClass * klass,
                         gpointer klass_data)
{
#line 66 "../src/core/DataSourceTypes.vala"
	photo_source_parent_class = g_type_class_peek_parent (klass);
#line 66 "../src/core/DataSourceTypes.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*) (PhotoSource*)) photo_source_real_get_metadata;
#line 66 "../src/core/DataSourceTypes.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoSource*, Scaling*, GError**)) photo_source_real_get_pixbuf;
#line 434 "DataSourceTypes.c"
}

static void
photo_source_instance_init (PhotoSource * self,
                            gpointer klass)
{
}

static GType
photo_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoSource), 0, (GInstanceInitFunc) photo_source_instance_init, NULL };
	GType photo_source_type_id;
	photo_source_type_id = g_type_register_static (TYPE_MEDIA_SOURCE, "PhotoSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return photo_source_type_id;
}

GType
photo_source_get_type (void)
{
	static volatile gsize photo_source_type_id__once = 0;
	if (g_once_init_enter (&photo_source_type_id__once)) {
		GType photo_source_type_id;
		photo_source_type_id = photo_source_get_type_once ();
		g_once_init_leave (&photo_source_type_id__once, photo_source_type_id);
	}
	return photo_source_type_id__once;
}

VideoSource*
video_source_construct (GType object_type)
{
	VideoSource * self = NULL;
#line 76 "../src/core/DataSourceTypes.vala"
	self = (VideoSource*) media_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 76 "../src/core/DataSourceTypes.vala"
	return self;
#line 472 "DataSourceTypes.c"
}

static void
video_source_class_init (VideoSourceClass * klass,
                         gpointer klass_data)
{
#line 76 "../src/core/DataSourceTypes.vala"
	video_source_parent_class = g_type_class_peek_parent (klass);
#line 481 "DataSourceTypes.c"
}

static void
video_source_instance_init (VideoSource * self,
                            gpointer klass)
{
}

static GType
video_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VideoSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoSource), 0, (GInstanceInitFunc) video_source_instance_init, NULL };
	GType video_source_type_id;
	video_source_type_id = g_type_register_static (TYPE_MEDIA_SOURCE, "VideoSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return video_source_type_id;
}

GType
video_source_get_type (void)
{
	static volatile gsize video_source_type_id__once = 0;
	if (g_once_init_enter (&video_source_type_id__once)) {
		GType video_source_type_id;
		video_source_type_id = video_source_get_type_once ();
		g_once_init_leave (&video_source_type_id__once, video_source_type_id);
	}
	return video_source_type_id__once;
}

EventSource*
event_source_construct (GType object_type,
                        gint64 object_id)
{
	EventSource * self = NULL;
#line 85 "../src/core/DataSourceTypes.vala"
	self = (EventSource*) thumbnail_source_construct (object_type, object_id);
#line 84 "../src/core/DataSourceTypes.vala"
	return self;
#line 520 "DataSourceTypes.c"
}

static gint64
event_source_real_get_start_time (EventSource* self)
{
	gint64 _tmp0_ = 0LL;
#line 88 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_start_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 88 "../src/core/DataSourceTypes.vala"
	return _tmp0_;
#line 531 "DataSourceTypes.c"
}

gint64
event_source_get_start_time (EventSource* self)
{
	EventSourceClass* _klass_;
#line 88 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 88 "../src/core/DataSourceTypes.vala"
	_klass_ = EVENT_SOURCE_GET_CLASS (self);
#line 88 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_start_time) {
#line 88 "../src/core/DataSourceTypes.vala"
		return _klass_->get_start_time (self);
#line 546 "DataSourceTypes.c"
	}
#line 88 "../src/core/DataSourceTypes.vala"
	return -1LL;
#line 550 "DataSourceTypes.c"
}

static gint64
event_source_real_get_end_time (EventSource* self)
{
	gint64 _tmp0_ = 0LL;
#line 90 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_end_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 90 "../src/core/DataSourceTypes.vala"
	return _tmp0_;
#line 561 "DataSourceTypes.c"
}

gint64
event_source_get_end_time (EventSource* self)
{
	EventSourceClass* _klass_;
#line 90 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 90 "../src/core/DataSourceTypes.vala"
	_klass_ = EVENT_SOURCE_GET_CLASS (self);
#line 90 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_end_time) {
#line 90 "../src/core/DataSourceTypes.vala"
		return _klass_->get_end_time (self);
#line 576 "DataSourceTypes.c"
	}
#line 90 "../src/core/DataSourceTypes.vala"
	return -1LL;
#line 580 "DataSourceTypes.c"
}

static guint64
event_source_real_get_total_filesize (EventSource* self)
{
	guint64 _tmp0_ = 0ULL;
#line 92 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_total_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 92 "../src/core/DataSourceTypes.vala"
	return _tmp0_;
#line 591 "DataSourceTypes.c"
}

guint64
event_source_get_total_filesize (EventSource* self)
{
	EventSourceClass* _klass_;
#line 92 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 92 "../src/core/DataSourceTypes.vala"
	_klass_ = EVENT_SOURCE_GET_CLASS (self);
#line 92 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_total_filesize) {
#line 92 "../src/core/DataSourceTypes.vala"
		return _klass_->get_total_filesize (self);
#line 606 "DataSourceTypes.c"
	}
#line 92 "../src/core/DataSourceTypes.vala"
	return 0ULL;
#line 610 "DataSourceTypes.c"
}

static gint
event_source_real_get_media_count (EventSource* self)
{
	gint _tmp0_ = 0;
#line 94 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_media_count'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 94 "../src/core/DataSourceTypes.vala"
	return _tmp0_;
#line 621 "DataSourceTypes.c"
}

gint
event_source_get_media_count (EventSource* self)
{
	EventSourceClass* _klass_;
#line 94 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 94 "../src/core/DataSourceTypes.vala"
	_klass_ = EVENT_SOURCE_GET_CLASS (self);
#line 94 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_media_count) {
#line 94 "../src/core/DataSourceTypes.vala"
		return _klass_->get_media_count (self);
#line 636 "DataSourceTypes.c"
	}
#line 94 "../src/core/DataSourceTypes.vala"
	return -1;
#line 640 "DataSourceTypes.c"
}

static GeeCollection*
event_source_real_get_media (EventSource* self)
{
#line 96 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 96 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 650 "DataSourceTypes.c"
}

GeeCollection*
event_source_get_media (EventSource* self)
{
	EventSourceClass* _klass_;
#line 96 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "../src/core/DataSourceTypes.vala"
	_klass_ = EVENT_SOURCE_GET_CLASS (self);
#line 96 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_media) {
#line 96 "../src/core/DataSourceTypes.vala"
		return _klass_->get_media (self);
#line 665 "DataSourceTypes.c"
	}
#line 96 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 669 "DataSourceTypes.c"
}

static gchar*
event_source_real_get_comment (EventSource* self)
{
#line 98 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_comment'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 98 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 679 "DataSourceTypes.c"
}

gchar*
event_source_get_comment (EventSource* self)
{
	EventSourceClass* _klass_;
#line 98 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/core/DataSourceTypes.vala"
	_klass_ = EVENT_SOURCE_GET_CLASS (self);
#line 98 "../src/core/DataSourceTypes.vala"
	if (_klass_->get_comment) {
#line 98 "../src/core/DataSourceTypes.vala"
		return _klass_->get_comment (self);
#line 694 "DataSourceTypes.c"
	}
#line 98 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 698 "DataSourceTypes.c"
}

static gboolean
event_source_real_set_comment (EventSource* self,
                               const gchar* comment)
{
	gboolean _tmp0_ = FALSE;
#line 100 "../src/core/DataSourceTypes.vala"
	g_critical ("Type `%s' does not implement abstract method `event_source_set_comment'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 100 "../src/core/DataSourceTypes.vala"
	return _tmp0_;
#line 710 "DataSourceTypes.c"
}

gboolean
event_source_set_comment (EventSource* self,
                          const gchar* comment)
{
	EventSourceClass* _klass_;
#line 100 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../src/core/DataSourceTypes.vala"
	_klass_ = EVENT_SOURCE_GET_CLASS (self);
#line 100 "../src/core/DataSourceTypes.vala"
	if (_klass_->set_comment) {
#line 100 "../src/core/DataSourceTypes.vala"
		return _klass_->set_comment (self, comment);
#line 726 "DataSourceTypes.c"
	}
#line 100 "../src/core/DataSourceTypes.vala"
	return FALSE;
#line 730 "DataSourceTypes.c"
}

static void
event_source_class_init (EventSourceClass * klass,
                         gpointer klass_data)
{
#line 83 "../src/core/DataSourceTypes.vala"
	event_source_parent_class = g_type_class_peek_parent (klass);
#line 83 "../src/core/DataSourceTypes.vala"
	((EventSourceClass *) klass)->get_start_time = (gint64 (*) (EventSource*)) event_source_real_get_start_time;
#line 83 "../src/core/DataSourceTypes.vala"
	((EventSourceClass *) klass)->get_end_time = (gint64 (*) (EventSource*)) event_source_real_get_end_time;
#line 83 "../src/core/DataSourceTypes.vala"
	((EventSourceClass *) klass)->get_total_filesize = (guint64 (*) (EventSource*)) event_source_real_get_total_filesize;
#line 83 "../src/core/DataSourceTypes.vala"
	((EventSourceClass *) klass)->get_media_count = (gint (*) (EventSource*)) event_source_real_get_media_count;
#line 83 "../src/core/DataSourceTypes.vala"
	((EventSourceClass *) klass)->get_media = (GeeCollection* (*) (EventSource*)) event_source_real_get_media;
#line 83 "../src/core/DataSourceTypes.vala"
	((EventSourceClass *) klass)->get_comment = (gchar* (*) (EventSource*)) event_source_real_get_comment;
#line 83 "../src/core/DataSourceTypes.vala"
	((EventSourceClass *) klass)->set_comment = (gboolean (*) (EventSource*, const gchar*)) event_source_real_set_comment;
#line 753 "DataSourceTypes.c"
}

static void
event_source_instance_init (EventSource * self,
                            gpointer klass)
{
}

static GType
event_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EventSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventSource), 0, (GInstanceInitFunc) event_source_instance_init, NULL };
	GType event_source_type_id;
	event_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "EventSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return event_source_type_id;
}

GType
event_source_get_type (void)
{
	static volatile gsize event_source_type_id__once = 0;
	if (g_once_init_enter (&event_source_type_id__once)) {
		GType event_source_type_id;
		event_source_type_id = event_source_get_type_once ();
		g_once_init_leave (&event_source_type_id__once, event_source_type_id);
	}
	return event_source_type_id__once;
}

gboolean
container_source_has_links (ContainerSource* self)
{
	ContainerSourceIface* _iface_;
#line 108 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 108 "../src/core/DataSourceTypes.vala"
	_iface_ = CONTAINER_SOURCE_GET_INTERFACE (self);
#line 108 "../src/core/DataSourceTypes.vala"
	if (_iface_->has_links) {
#line 108 "../src/core/DataSourceTypes.vala"
		return _iface_->has_links (self);
#line 795 "DataSourceTypes.c"
	}
#line 108 "../src/core/DataSourceTypes.vala"
	return FALSE;
#line 799 "DataSourceTypes.c"
}

SourceBacklink*
container_source_get_backlink (ContainerSource* self)
{
	ContainerSourceIface* _iface_;
#line 110 "../src/core/DataSourceTypes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../src/core/DataSourceTypes.vala"
	_iface_ = CONTAINER_SOURCE_GET_INTERFACE (self);
#line 110 "../src/core/DataSourceTypes.vala"
	if (_iface_->get_backlink) {
#line 110 "../src/core/DataSourceTypes.vala"
		return _iface_->get_backlink (self);
#line 814 "DataSourceTypes.c"
	}
#line 110 "../src/core/DataSourceTypes.vala"
	return NULL;
#line 818 "DataSourceTypes.c"
}

void
container_source_break_link (ContainerSource* self,
                             DataSource* source)
{
	ContainerSourceIface* _iface_;
#line 112 "../src/core/DataSourceTypes.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/core/DataSourceTypes.vala"
	_iface_ = CONTAINER_SOURCE_GET_INTERFACE (self);
#line 112 "../src/core/DataSourceTypes.vala"
	if (_iface_->break_link) {
#line 112 "../src/core/DataSourceTypes.vala"
		_iface_->break_link (self, source);
#line 834 "DataSourceTypes.c"
	}
}

void
container_source_break_link_many (ContainerSource* self,
                                  GeeCollection* sources)
{
	ContainerSourceIface* _iface_;
#line 114 "../src/core/DataSourceTypes.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/core/DataSourceTypes.vala"
	_iface_ = CONTAINER_SOURCE_GET_INTERFACE (self);
#line 114 "../src/core/DataSourceTypes.vala"
	if (_iface_->break_link_many) {
#line 114 "../src/core/DataSourceTypes.vala"
		_iface_->break_link_many (self, sources);
#line 851 "DataSourceTypes.c"
	}
}

void
container_source_establish_link (ContainerSource* self,
                                 DataSource* source)
{
	ContainerSourceIface* _iface_;
#line 116 "../src/core/DataSourceTypes.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/core/DataSourceTypes.vala"
	_iface_ = CONTAINER_SOURCE_GET_INTERFACE (self);
#line 116 "../src/core/DataSourceTypes.vala"
	if (_iface_->establish_link) {
#line 116 "../src/core/DataSourceTypes.vala"
		_iface_->establish_link (self, source);
#line 868 "DataSourceTypes.c"
	}
}

void
container_source_establish_link_many (ContainerSource* self,
                                      GeeCollection* sources)
{
	ContainerSourceIface* _iface_;
#line 118 "../src/core/DataSourceTypes.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/core/DataSourceTypes.vala"
	_iface_ = CONTAINER_SOURCE_GET_INTERFACE (self);
#line 118 "../src/core/DataSourceTypes.vala"
	if (_iface_->establish_link_many) {
#line 118 "../src/core/DataSourceTypes.vala"
		_iface_->establish_link_many (self, sources);
#line 885 "DataSourceTypes.c"
	}
}

static void
container_source_default_init (ContainerSourceIface * iface,
                               gpointer iface_data)
{
}

static GType
container_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) container_source_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType container_source_type_id;
	container_source_type_id = g_type_register_static (G_TYPE_INTERFACE, "ContainerSource", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (container_source_type_id, TYPE_DATA_SOURCE);
	return container_source_type_id;
}

GType
container_source_get_type (void)
{
	static volatile gsize container_source_type_id__once = 0;
	if (g_once_init_enter (&container_source_type_id__once)) {
		GType container_source_type_id;
		container_source_type_id = container_source_get_type_once ();
		g_once_init_leave (&container_source_type_id__once, container_source_type_id);
	}
	return container_source_type_id__once;
}

