/* DataView.c generated by valac 0.56.18, the Vala compiler
 * generated from DataView.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DATA_VIEW_0_PROPERTY,
	DATA_VIEW_SOURCE_PROPERTY,
	DATA_VIEW_NUM_PROPERTIES
};
static GParamSpec* data_view_properties[DATA_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
enum  {
	DATA_VIEW_STATE_CHANGED_SIGNAL,
	DATA_VIEW_VISIBILITY_CHANGED_SIGNAL,
	DATA_VIEW_VIEW_ALTERED_SIGNAL,
	DATA_VIEW_GEOMETRY_ALTERED_SIGNAL,
	DATA_VIEW_UNSUBSCRIBED_SIGNAL,
	DATA_VIEW_NUM_SIGNALS
};
static guint data_view_signals[DATA_VIEW_NUM_SIGNALS] = {0};

struct _DataViewPrivate {
	DataSource* _source;
	gboolean selected;
	gboolean visible;
};

static gint DataView_private_offset;
static gpointer data_view_parent_class = NULL;

static gchar* data_view_real_get_name (DataObject* base);
static gchar* data_view_real_to_string (DataObject* base);
static void data_view_real_notify_view_altered (DataView* self);
static void data_view_real_notify_geometry_altered (DataView* self);
static void data_view_real_notify_unsubscribed (DataView* self,
                                         DataSource* source);
static void data_view_real_state_changed (DataView* self,
                                   gboolean selected);
static void data_view_real_visibility_changed (DataView* self,
                                        gboolean visible);
static void data_view_real_view_altered (DataView* self);
static void data_view_real_geometry_altered (DataView* self);
static void data_view_real_unsubscribed (DataView* self,
                                  DataSource* source);
static GObject * data_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void data_view_finalize (GObject * obj);
static GType data_view_get_type_once (void);
static void _vala_data_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_data_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
data_view_get_instance_private (DataView* self)
{
	return G_STRUCT_MEMBER_P (self, DataView_private_offset);
}

DataView*
data_view_construct (GType object_type,
                     DataSource* source)
{
	DataView * self = NULL;
#line 46 "../src/core/DataView.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 47 "../src/core/DataView.vala"
	self = (DataView*) g_object_new (object_type, "source", source, NULL);
#line 46 "../src/core/DataView.vala"
	return self;
#line 112 "DataView.c"
}

DataView*
data_view_new (DataSource* source)
{
#line 46 "../src/core/DataView.vala"
	return data_view_construct (TYPE_DATA_VIEW, source);
#line 120 "DataView.c"
}

static gchar*
data_view_real_get_name (DataObject* base)
{
	DataView * self;
	DataSource* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 63 "../src/core/DataView.vala"
	self = (DataView*) base;
#line 64 "../src/core/DataView.vala"
	_tmp0_ = self->priv->_source;
#line 64 "../src/core/DataView.vala"
	_tmp1_ = data_object_get_name ((DataObject*) _tmp0_);
#line 64 "../src/core/DataView.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/core/DataView.vala"
	_tmp3_ = g_strdup_printf ("View of %s", _tmp2_);
#line 64 "../src/core/DataView.vala"
	_tmp4_ = _tmp3_;
#line 64 "../src/core/DataView.vala"
	_g_free0 (_tmp2_);
#line 64 "../src/core/DataView.vala"
	result = _tmp4_;
#line 64 "../src/core/DataView.vala"
	return result;
#line 151 "DataView.c"
}

static gchar*
data_view_real_to_string (DataObject* base)
{
	DataView * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	DataSource* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 67 "../src/core/DataView.vala"
	self = (DataView*) base;
#line 68 "../src/core/DataView.vala"
	_tmp0_ = data_object_get_name ((DataObject*) self);
#line 68 "../src/core/DataView.vala"
	_tmp1_ = _tmp0_;
#line 68 "../src/core/DataView.vala"
	_tmp2_ = self->priv->_source;
#line 68 "../src/core/DataView.vala"
	_tmp3_ = data_object_to_string ((DataObject*) _tmp2_);
#line 68 "../src/core/DataView.vala"
	_tmp4_ = _tmp3_;
#line 68 "../src/core/DataView.vala"
	_tmp5_ = g_strdup_printf ("DataView %s [DataSource %s]", _tmp1_, _tmp4_);
#line 68 "../src/core/DataView.vala"
	_tmp6_ = _tmp5_;
#line 68 "../src/core/DataView.vala"
	_g_free0 (_tmp4_);
#line 68 "../src/core/DataView.vala"
	_g_free0 (_tmp1_);
#line 68 "../src/core/DataView.vala"
	result = _tmp6_;
#line 68 "../src/core/DataView.vala"
	return result;
#line 190 "DataView.c"
}

gboolean
data_view_is_selected (DataView* self)
{
	gboolean result;
#line 71 "../src/core/DataView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "../src/core/DataView.vala"
	result = self->priv->selected;
#line 72 "../src/core/DataView.vala"
	return result;
#line 203 "DataView.c"
}

void
data_view_internal_set_selected (DataView* self,
                                 gboolean selected)
{
#line 76 "../src/core/DataView.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/core/DataView.vala"
	if (self->priv->selected == selected) {
#line 78 "../src/core/DataView.vala"
		return;
#line 216 "DataView.c"
	}
#line 80 "../src/core/DataView.vala"
	self->priv->selected = selected;
#line 81 "../src/core/DataView.vala"
	g_signal_emit (self, data_view_signals[DATA_VIEW_STATE_CHANGED_SIGNAL], 0, selected);
#line 222 "DataView.c"
}

gboolean
data_view_internal_toggle (DataView* self)
{
	gboolean result;
#line 85 "../src/core/DataView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "../src/core/DataView.vala"
	self->priv->selected = !self->priv->selected;
#line 87 "../src/core/DataView.vala"
	g_signal_emit (self, data_view_signals[DATA_VIEW_STATE_CHANGED_SIGNAL], 0, self->priv->selected);
#line 89 "../src/core/DataView.vala"
	result = self->priv->selected;
#line 89 "../src/core/DataView.vala"
	return result;
#line 239 "DataView.c"
}

gboolean
data_view_is_visible (DataView* self)
{
	gboolean result;
#line 92 "../src/core/DataView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/core/DataView.vala"
	result = self->priv->visible;
#line 93 "../src/core/DataView.vala"
	return result;
#line 252 "DataView.c"
}

void
data_view_internal_set_visible (DataView* self,
                                gboolean visible)
{
#line 97 "../src/core/DataView.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/core/DataView.vala"
	if (self->priv->visible == visible) {
#line 99 "../src/core/DataView.vala"
		return;
#line 265 "DataView.c"
	}
#line 101 "../src/core/DataView.vala"
	self->priv->visible = visible;
#line 102 "../src/core/DataView.vala"
	g_signal_emit (self, data_view_signals[DATA_VIEW_VISIBILITY_CHANGED_SIGNAL], 0, visible);
#line 271 "DataView.c"
}

static void
data_view_real_notify_view_altered (DataView* self)
{
	ViewCollection* vc = NULL;
	DataCollection* _tmp0_;
	ViewCollection* _tmp1_;
	ViewCollection* _tmp2_;
#line 107 "../src/core/DataView.vala"
	if (!self->priv->visible) {
#line 108 "../src/core/DataView.vala"
		return;
#line 285 "DataView.c"
	}
#line 110 "../src/core/DataView.vala"
	_tmp0_ = data_object_get_membership ((DataObject*) self);
#line 110 "../src/core/DataView.vala"
	_tmp1_ = IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL;
#line 110 "../src/core/DataView.vala"
	if (_tmp1_ == NULL) {
#line 110 "../src/core/DataView.vala"
		_data_collection_unref0 (_tmp0_);
#line 295 "DataView.c"
	}
#line 110 "../src/core/DataView.vala"
	vc = _tmp1_;
#line 111 "../src/core/DataView.vala"
	_tmp2_ = vc;
#line 111 "../src/core/DataView.vala"
	if (_tmp2_ != NULL) {
#line 303 "DataView.c"
		ViewCollection* _tmp3_;
		ViewCollection* _tmp4_;
#line 112 "../src/core/DataView.vala"
		_tmp3_ = vc;
#line 112 "../src/core/DataView.vala"
		if (!data_collection_are_notifications_frozen ((DataCollection*) _tmp3_)) {
#line 113 "../src/core/DataView.vala"
			g_signal_emit (self, data_view_signals[DATA_VIEW_VIEW_ALTERED_SIGNAL], 0);
#line 312 "DataView.c"
		}
#line 116 "../src/core/DataView.vala"
		_tmp4_ = vc;
#line 116 "../src/core/DataView.vala"
		view_collection_internal_notify_view_altered (_tmp4_, self);
#line 318 "DataView.c"
	} else {
#line 118 "../src/core/DataView.vala"
		g_signal_emit (self, data_view_signals[DATA_VIEW_VIEW_ALTERED_SIGNAL], 0);
#line 322 "DataView.c"
	}
#line 105 "../src/core/DataView.vala"
	_data_collection_unref0 (vc);
#line 326 "DataView.c"
}

void
data_view_notify_view_altered (DataView* self)
{
	DataViewClass* _klass_;
#line 105 "../src/core/DataView.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/core/DataView.vala"
	_klass_ = DATA_VIEW_GET_CLASS (self);
#line 105 "../src/core/DataView.vala"
	if (_klass_->notify_view_altered) {
#line 105 "../src/core/DataView.vala"
		_klass_->notify_view_altered (self);
#line 341 "DataView.c"
	}
}

static void
data_view_real_notify_geometry_altered (DataView* self)
{
	ViewCollection* vc = NULL;
	DataCollection* _tmp0_;
	ViewCollection* _tmp1_;
	ViewCollection* _tmp2_;
#line 124 "../src/core/DataView.vala"
	if (!self->priv->visible) {
#line 125 "../src/core/DataView.vala"
		return;
#line 356 "DataView.c"
	}
#line 127 "../src/core/DataView.vala"
	_tmp0_ = data_object_get_membership ((DataObject*) self);
#line 127 "../src/core/DataView.vala"
	_tmp1_ = IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL;
#line 127 "../src/core/DataView.vala"
	if (_tmp1_ == NULL) {
#line 127 "../src/core/DataView.vala"
		_data_collection_unref0 (_tmp0_);
#line 366 "DataView.c"
	}
#line 127 "../src/core/DataView.vala"
	vc = _tmp1_;
#line 128 "../src/core/DataView.vala"
	_tmp2_ = vc;
#line 128 "../src/core/DataView.vala"
	if (_tmp2_ != NULL) {
#line 374 "DataView.c"
		ViewCollection* _tmp3_;
		ViewCollection* _tmp4_;
#line 129 "../src/core/DataView.vala"
		_tmp3_ = vc;
#line 129 "../src/core/DataView.vala"
		if (!data_collection_are_notifications_frozen ((DataCollection*) _tmp3_)) {
#line 130 "../src/core/DataView.vala"
			g_signal_emit (self, data_view_signals[DATA_VIEW_GEOMETRY_ALTERED_SIGNAL], 0);
#line 383 "DataView.c"
		}
#line 133 "../src/core/DataView.vala"
		_tmp4_ = vc;
#line 133 "../src/core/DataView.vala"
		view_collection_internal_notify_geometry_altered (_tmp4_, self);
#line 389 "DataView.c"
	} else {
#line 135 "../src/core/DataView.vala"
		g_signal_emit (self, data_view_signals[DATA_VIEW_GEOMETRY_ALTERED_SIGNAL], 0);
#line 393 "DataView.c"
	}
#line 122 "../src/core/DataView.vala"
	_data_collection_unref0 (vc);
#line 397 "DataView.c"
}

void
data_view_notify_geometry_altered (DataView* self)
{
	DataViewClass* _klass_;
#line 122 "../src/core/DataView.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/core/DataView.vala"
	_klass_ = DATA_VIEW_GET_CLASS (self);
#line 122 "../src/core/DataView.vala"
	if (_klass_->notify_geometry_altered) {
#line 122 "../src/core/DataView.vala"
		_klass_->notify_geometry_altered (self);
#line 412 "DataView.c"
	}
}

static void
data_view_real_notify_unsubscribed (DataView* self,
                                    DataSource* source)
{
#line 140 "../src/core/DataView.vala"
	g_return_if_fail (source != NULL);
#line 141 "../src/core/DataView.vala"
	g_signal_emit (self, data_view_signals[DATA_VIEW_UNSUBSCRIBED_SIGNAL], 0, source);
#line 424 "DataView.c"
}

void
data_view_notify_unsubscribed (DataView* self,
                               DataSource* source)
{
	DataViewClass* _klass_;
#line 140 "../src/core/DataView.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/core/DataView.vala"
	_klass_ = DATA_VIEW_GET_CLASS (self);
#line 140 "../src/core/DataView.vala"
	if (_klass_->notify_unsubscribed) {
#line 140 "../src/core/DataView.vala"
		_klass_->notify_unsubscribed (self, source);
#line 440 "DataView.c"
	}
}

DataSource*
data_view_get_source (DataView* self)
{
	DataSource* result;
	DataSource* _tmp0_;
#line 21 "../src/core/DataView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/core/DataView.vala"
	_tmp0_ = self->priv->_source;
#line 21 "../src/core/DataView.vala"
	result = _tmp0_;
#line 21 "../src/core/DataView.vala"
	return result;
#line 457 "DataView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 21 "../src/core/DataView.vala"
	return self ? g_object_ref (self) : NULL;
#line 465 "DataView.c"
}

static void
data_view_set_source (DataView* self,
                      DataSource* value)
{
	DataSource* old_value;
#line 21 "../src/core/DataView.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/core/DataView.vala"
	old_value = data_view_get_source (self);
#line 21 "../src/core/DataView.vala"
	if (old_value != value) {
#line 479 "DataView.c"
		DataSource* _tmp0_;
#line 21 "../src/core/DataView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/core/DataView.vala"
		_g_object_unref0 (self->priv->_source);
#line 21 "../src/core/DataView.vala"
		self->priv->_source = _tmp0_;
#line 21 "../src/core/DataView.vala"
		g_object_notify_by_pspec ((GObject *) self, data_view_properties[DATA_VIEW_SOURCE_PROPERTY]);
#line 489 "DataView.c"
	}
}

static void
data_view_real_state_changed (DataView* self,
                              gboolean selected)
{
}

static void
data_view_real_visibility_changed (DataView* self,
                                   gboolean visible)
{
}

static void
data_view_real_view_altered (DataView* self)
{
}

static void
data_view_real_geometry_altered (DataView* self)
{
}

static void
data_view_real_unsubscribed (DataView* self,
                             DataSource* source)
{
#line 43 "../src/core/DataView.vala"
	g_return_if_fail (source != NULL);
#line 521 "DataView.c"
}

static GObject *
data_view_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DataView * self;
	DataSource* _tmp0_;
#line 50 "../src/core/DataView.vala"
	parent_class = G_OBJECT_CLASS (data_view_parent_class);
#line 50 "../src/core/DataView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "../src/core/DataView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATA_VIEW, DataView);
#line 53 "../src/core/DataView.vala"
	_tmp0_ = self->priv->_source;
#line 53 "../src/core/DataView.vala"
	data_source_internal_subscribe (_tmp0_, self);
#line 50 "../src/core/DataView.vala"
	return obj;
#line 545 "DataView.c"
}

static void
data_view_class_init (DataViewClass * klass,
                      gpointer klass_data)
{
#line 20 "../src/core/DataView.vala"
	data_view_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/core/DataView.vala"
	g_type_class_adjust_private_offset (klass, &DataView_private_offset);
#line 20 "../src/core/DataView.vala"
	((DataObjectClass *) klass)->get_name = (gchar* (*) (DataObject*)) data_view_real_get_name;
#line 20 "../src/core/DataView.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) data_view_real_to_string;
#line 20 "../src/core/DataView.vala"
	((DataViewClass *) klass)->notify_view_altered = (void (*) (DataView*)) data_view_real_notify_view_altered;
#line 20 "../src/core/DataView.vala"
	((DataViewClass *) klass)->notify_geometry_altered = (void (*) (DataView*)) data_view_real_notify_geometry_altered;
#line 20 "../src/core/DataView.vala"
	((DataViewClass *) klass)->notify_unsubscribed = (void (*) (DataView*, DataSource*)) data_view_real_notify_unsubscribed;
#line 20 "../src/core/DataView.vala"
	((DataViewClass *) klass)->state_changed = data_view_real_state_changed;
#line 20 "../src/core/DataView.vala"
	((DataViewClass *) klass)->visibility_changed = data_view_real_visibility_changed;
#line 20 "../src/core/DataView.vala"
	((DataViewClass *) klass)->view_altered = data_view_real_view_altered;
#line 20 "../src/core/DataView.vala"
	((DataViewClass *) klass)->geometry_altered = data_view_real_geometry_altered;
#line 20 "../src/core/DataView.vala"
	((DataViewClass *) klass)->unsubscribed = data_view_real_unsubscribed;
#line 20 "../src/core/DataView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_data_view_get_property;
#line 20 "../src/core/DataView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_data_view_set_property;
#line 20 "../src/core/DataView.vala"
	G_OBJECT_CLASS (klass)->constructor = data_view_constructor;
#line 20 "../src/core/DataView.vala"
	G_OBJECT_CLASS (klass)->finalize = data_view_finalize;
#line 20 "../src/core/DataView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATA_VIEW_SOURCE_PROPERTY, data_view_properties[DATA_VIEW_SOURCE_PROPERTY] = g_param_spec_object ("source", "source", "source", TYPE_DATA_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/core/DataView.vala"
	data_view_signals[DATA_VIEW_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, state_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 20 "../src/core/DataView.vala"
	data_view_signals[DATA_VIEW_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("visibility-changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 20 "../src/core/DataView.vala"
	data_view_signals[DATA_VIEW_VIEW_ALTERED_SIGNAL] = g_signal_new ("view-altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, view_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/core/DataView.vala"
	data_view_signals[DATA_VIEW_GEOMETRY_ALTERED_SIGNAL] = g_signal_new ("geometry-altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/core/DataView.vala"
	data_view_signals[DATA_VIEW_UNSUBSCRIBED_SIGNAL] = g_signal_new ("unsubscribed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, unsubscribed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
#line 596 "DataView.c"
}

static void
data_view_instance_init (DataView * self,
                         gpointer klass)
{
#line 20 "../src/core/DataView.vala"
	self->priv = data_view_get_instance_private (self);
#line 23 "../src/core/DataView.vala"
	self->priv->selected = FALSE;
#line 24 "../src/core/DataView.vala"
	self->priv->visible = TRUE;
#line 609 "DataView.c"
}

static void
data_view_finalize (GObject * obj)
{
	DataView * self;
	DataSource* _tmp0_;
#line 20 "../src/core/DataView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATA_VIEW, DataView);
#line 60 "../src/core/DataView.vala"
	_tmp0_ = self->priv->_source;
#line 60 "../src/core/DataView.vala"
	data_source_internal_unsubscribe (_tmp0_, self);
#line 21 "../src/core/DataView.vala"
	_g_object_unref0 (self->priv->_source);
#line 20 "../src/core/DataView.vala"
	G_OBJECT_CLASS (data_view_parent_class)->finalize (obj);
#line 627 "DataView.c"
}

static GType
data_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DataViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataView), 0, (GInstanceInitFunc) data_view_instance_init, NULL };
	GType data_view_type_id;
	data_view_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataView", &g_define_type_info, 0);
	DataView_private_offset = g_type_add_instance_private (data_view_type_id, sizeof (DataViewPrivate));
	return data_view_type_id;
}

GType
data_view_get_type (void)
{
	static volatile gsize data_view_type_id__once = 0;
	if (g_once_init_enter (&data_view_type_id__once)) {
		GType data_view_type_id;
		data_view_type_id = data_view_get_type_once ();
		g_once_init_leave (&data_view_type_id__once, data_view_type_id);
	}
	return data_view_type_id__once;
}

static void
_vala_data_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	DataView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView);
#line 20 "../src/core/DataView.vala"
	switch (property_id) {
#line 20 "../src/core/DataView.vala"
		case DATA_VIEW_SOURCE_PROPERTY:
#line 20 "../src/core/DataView.vala"
		g_value_set_object (value, data_view_get_source (self));
#line 20 "../src/core/DataView.vala"
		break;
#line 668 "DataView.c"
		default:
#line 20 "../src/core/DataView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/core/DataView.vala"
		break;
#line 674 "DataView.c"
	}
}

static void
_vala_data_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	DataView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView);
#line 20 "../src/core/DataView.vala"
	switch (property_id) {
#line 20 "../src/core/DataView.vala"
		case DATA_VIEW_SOURCE_PROPERTY:
#line 20 "../src/core/DataView.vala"
		data_view_set_source (self, g_value_get_object (value));
#line 20 "../src/core/DataView.vala"
		break;
#line 694 "DataView.c"
		default:
#line 20 "../src/core/DataView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/core/DataView.vala"
		break;
#line 700 "DataView.c"
	}
}

