/* SourceInterfaces.c generated by valac 0.56.18, the Vala compiler
 * generated from SourceInterfaces.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* See the note in MediaInterfaces.vala for some thoughts on the theory of expanding Photos'*/
/* features via interfaces rather than class heirarchies.*/
/* Indexable DataSources provide raw strings that may be searched against (and, in the future,*/
/* indexed) for free-text search queries.  DataSources implementing Indexable must prepare and*/
/* store (i.e. cache) these strings using prepare_indexable_string(s), as preparing the strings*/
/* for each call is expensive.*/
/**/
/* When the indexable string has changed, the object should fire an alteration of*/
/* "indexable:keywords".  The prepare methods will not do this.*/

#include "io.elementary.photos.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

static GType indexable_get_type_once (void);

const gchar*
indexable_get_indexable_keywords (Indexable* self)
{
	IndexableIface* _iface_;
#line 32 "../src/core/SourceInterfaces.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/core/SourceInterfaces.vala"
	_iface_ = INDEXABLE_GET_INTERFACE (self);
#line 32 "../src/core/SourceInterfaces.vala"
	if (_iface_->get_indexable_keywords) {
#line 32 "../src/core/SourceInterfaces.vala"
		return _iface_->get_indexable_keywords (self);
#line 64 "SourceInterfaces.c"
	}
#line 32 "../src/core/SourceInterfaces.vala"
	return NULL;
#line 68 "SourceInterfaces.c"
}

gchar*
indexable_prepare_indexable_string (const gchar* str)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 35 "../src/core/SourceInterfaces.vala"
	if (is_string_empty (str)) {
#line 36 "../src/core/SourceInterfaces.vala"
		result = NULL;
#line 36 "../src/core/SourceInterfaces.vala"
		return result;
#line 85 "SourceInterfaces.c"
	}
#line 37 "../src/core/SourceInterfaces.vala"
	_tmp0_ = g_utf8_strdown (str, (gssize) -1);
#line 37 "../src/core/SourceInterfaces.vala"
	_tmp1_ = _tmp0_;
#line 37 "../src/core/SourceInterfaces.vala"
	_tmp2_ = string_remove_diacritics (_tmp1_);
#line 37 "../src/core/SourceInterfaces.vala"
	_tmp3_ = _tmp2_;
#line 37 "../src/core/SourceInterfaces.vala"
	_g_free0 (_tmp1_);
#line 37 "../src/core/SourceInterfaces.vala"
	result = _tmp3_;
#line 37 "../src/core/SourceInterfaces.vala"
	return result;
#line 101 "SourceInterfaces.c"
}

gchar*
indexable_prepare_indexable_strings (gchar** strs,
                                     gint strs_length1)
{
	gboolean _tmp0_ = FALSE;
	GString* builder = NULL;
	GString* _tmp1_;
	gint ctr = 0;
	const gchar* _tmp10_ = NULL;
	GString* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp15_;
	gchar* result;
#line 41 "../src/core/SourceInterfaces.vala"
	if (strs == NULL) {
#line 41 "../src/core/SourceInterfaces.vala"
		_tmp0_ = TRUE;
#line 121 "SourceInterfaces.c"
	} else {
#line 41 "../src/core/SourceInterfaces.vala"
		_tmp0_ = strs_length1 == 0;
#line 125 "SourceInterfaces.c"
	}
#line 41 "../src/core/SourceInterfaces.vala"
	if (_tmp0_) {
#line 42 "../src/core/SourceInterfaces.vala"
		result = NULL;
#line 42 "../src/core/SourceInterfaces.vala"
		return result;
#line 133 "SourceInterfaces.c"
	}
#line 44 "../src/core/SourceInterfaces.vala"
	_tmp1_ = g_string_new ("");
#line 44 "../src/core/SourceInterfaces.vala"
	builder = _tmp1_;
#line 45 "../src/core/SourceInterfaces.vala"
	ctr = 0;
#line 141 "SourceInterfaces.c"
	{
		gboolean _tmp2_ = FALSE;
#line 46 "../src/core/SourceInterfaces.vala"
		_tmp2_ = TRUE;
#line 46 "../src/core/SourceInterfaces.vala"
		while (TRUE) {
#line 148 "SourceInterfaces.c"
			const gchar* _tmp4_;
#line 46 "../src/core/SourceInterfaces.vala"
			if (!_tmp2_) {
#line 152 "SourceInterfaces.c"
				gint _tmp3_;
#line 52 "../src/core/SourceInterfaces.vala"
				ctr = ctr + 1;
#line 52 "../src/core/SourceInterfaces.vala"
				_tmp3_ = ctr;
#line 52 "../src/core/SourceInterfaces.vala"
				if (!(_tmp3_ < strs_length1)) {
#line 52 "../src/core/SourceInterfaces.vala"
					break;
#line 162 "SourceInterfaces.c"
				}
			}
#line 46 "../src/core/SourceInterfaces.vala"
			_tmp2_ = FALSE;
#line 47 "../src/core/SourceInterfaces.vala"
			_tmp4_ = strs[ctr];
#line 47 "../src/core/SourceInterfaces.vala"
			if (!is_string_empty (_tmp4_)) {
#line 171 "SourceInterfaces.c"
				GString* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 48 "../src/core/SourceInterfaces.vala"
				_tmp5_ = builder;
#line 48 "../src/core/SourceInterfaces.vala"
				_tmp6_ = strs[ctr];
#line 48 "../src/core/SourceInterfaces.vala"
				_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
#line 48 "../src/core/SourceInterfaces.vala"
				_tmp8_ = _tmp7_;
#line 48 "../src/core/SourceInterfaces.vala"
				g_string_append (_tmp5_, _tmp8_);
#line 48 "../src/core/SourceInterfaces.vala"
				_g_free0 (_tmp8_);
#line 49 "../src/core/SourceInterfaces.vala"
				if (ctr < (strs_length1 - 1)) {
#line 190 "SourceInterfaces.c"
					GString* _tmp9_;
#line 50 "../src/core/SourceInterfaces.vala"
					_tmp9_ = builder;
#line 50 "../src/core/SourceInterfaces.vala"
					g_string_append_c (_tmp9_, ' ');
#line 196 "SourceInterfaces.c"
				}
			}
		}
	}
#line 54 "../src/core/SourceInterfaces.vala"
	_tmp11_ = builder;
#line 54 "../src/core/SourceInterfaces.vala"
	_tmp12_ = _tmp11_->str;
#line 54 "../src/core/SourceInterfaces.vala"
	if (!is_string_empty (_tmp12_)) {
#line 207 "SourceInterfaces.c"
		GString* _tmp13_;
		const gchar* _tmp14_;
#line 54 "../src/core/SourceInterfaces.vala"
		_tmp13_ = builder;
#line 54 "../src/core/SourceInterfaces.vala"
		_tmp14_ = _tmp13_->str;
#line 54 "../src/core/SourceInterfaces.vala"
		_tmp10_ = _tmp14_;
#line 216 "SourceInterfaces.c"
	} else {
#line 54 "../src/core/SourceInterfaces.vala"
		_tmp10_ = NULL;
#line 220 "SourceInterfaces.c"
	}
#line 54 "../src/core/SourceInterfaces.vala"
	_tmp15_ = g_strdup (_tmp10_);
#line 54 "../src/core/SourceInterfaces.vala"
	result = _tmp15_;
#line 54 "../src/core/SourceInterfaces.vala"
	_g_string_free0 (builder);
#line 54 "../src/core/SourceInterfaces.vala"
	return result;
#line 230 "SourceInterfaces.c"
}

static void
indexable_default_init (IndexableIface * iface,
                        gpointer iface_data)
{
}

static GType
indexable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndexableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indexable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType indexable_type_id;
	indexable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Indexable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (indexable_type_id, TYPE_DATA_SOURCE);
	return indexable_type_id;
}

GType
indexable_get_type (void)
{
	static volatile gsize indexable_type_id__once = 0;
	if (g_once_init_enter (&indexable_type_id__once)) {
		GType indexable_type_id;
		indexable_type_id = indexable_get_type_once ();
		g_once_init_leave (&indexable_type_id__once, indexable_type_id);
	}
	return indexable_type_id__once;
}

