/* EventTable.c generated by valac 0.56.18, the Vala compiler
 * generated from EventTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <string.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecEventRow ParamSpecEventRow;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))
#define _event_row_unref0(var) ((var == NULL) ? NULL : (var = (event_row_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ParamSpecEventRow {
	GParamSpec parent_instance;
};

static gpointer event_row_parent_class = NULL;
static gpointer event_table_parent_class = NULL;
static EventTable* event_table_instance;
static EventTable* event_table_instance = NULL;

static void event_row_finalize (EventRow * obj);
static GType event_row_get_type_once (void);
static EventTable* event_table_new (void);
static EventTable* event_table_construct (GType object_type);
static gchar* event_table_source_id_upgrade (EventTable* self,
                                      gint64 primary_photo_id,
                                      const gchar* primary_source_id);
static void event_table_finalize (DatabaseTable * obj);
static GType event_table_get_type_once (void);

void
event_id_init (EventID *self,
               gint64 id)
{
#line 25 "../src/db/EventTable.vala"
	memset (self, 0, sizeof (EventID));
#line 26 "../src/db/EventTable.vala"
	(*self).id = id;
#line 80 "EventTable.c"
}

gboolean
event_id_is_invalid (EventID *self)
{
	gboolean result;
#line 30 "../src/db/EventTable.vala"
	result = (*self).id == EVENT_ID_INVALID;
#line 30 "../src/db/EventTable.vala"
	return result;
#line 91 "EventTable.c"
}

gboolean
event_id_is_valid (EventID *self)
{
	gboolean result;
#line 34 "../src/db/EventTable.vala"
	result = (*self).id != EVENT_ID_INVALID;
#line 34 "../src/db/EventTable.vala"
	return result;
#line 102 "EventTable.c"
}

EventID*
event_id_dup (const EventID* self)
{
	EventID* dup;
#line 20 "../src/db/EventTable.vala"
	dup = g_new0 (EventID, 1);
#line 20 "../src/db/EventTable.vala"
	memcpy (dup, self, sizeof (EventID));
#line 20 "../src/db/EventTable.vala"
	return dup;
#line 115 "EventTable.c"
}

void
event_id_free (EventID* self)
{
#line 20 "../src/db/EventTable.vala"
	g_free (self);
#line 123 "EventTable.c"
}

static GType
event_id_get_type_once (void)
{
	GType event_id_type_id;
	event_id_type_id = g_boxed_type_register_static ("EventID", (GBoxedCopyFunc) event_id_dup, (GBoxedFreeFunc) event_id_free);
	return event_id_type_id;
}

GType
event_id_get_type (void)
{
	static volatile gsize event_id_type_id__once = 0;
	if (g_once_init_enter (&event_id_type_id__once)) {
		GType event_id_type_id;
		event_id_type_id = event_id_get_type_once ();
		g_once_init_leave (&event_id_type_id__once, event_id_type_id);
	}
	return event_id_type_id__once;
}

EventRow*
event_row_construct (GType object_type)
{
	EventRow* self = NULL;
#line 38 "../src/db/EventTable.vala"
	self = (EventRow*) g_type_create_instance (object_type);
#line 38 "../src/db/EventTable.vala"
	return self;
#line 154 "EventTable.c"
}

EventRow*
event_row_new (void)
{
#line 38 "../src/db/EventTable.vala"
	return event_row_construct (TYPE_EVENT_ROW);
#line 162 "EventTable.c"
}

static void
value_event_row_init (GValue* value)
{
#line 38 "../src/db/EventTable.vala"
	value->data[0].v_pointer = NULL;
#line 170 "EventTable.c"
}

static void
value_event_row_free_value (GValue* value)
{
#line 38 "../src/db/EventTable.vala"
	if (value->data[0].v_pointer) {
#line 38 "../src/db/EventTable.vala"
		event_row_unref (value->data[0].v_pointer);
#line 180 "EventTable.c"
	}
}

static void
value_event_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 38 "../src/db/EventTable.vala"
	if (src_value->data[0].v_pointer) {
#line 38 "../src/db/EventTable.vala"
		dest_value->data[0].v_pointer = event_row_ref (src_value->data[0].v_pointer);
#line 192 "EventTable.c"
	} else {
#line 38 "../src/db/EventTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 196 "EventTable.c"
	}
}

static gpointer
value_event_row_peek_pointer (const GValue* value)
{
#line 38 "../src/db/EventTable.vala"
	return value->data[0].v_pointer;
#line 205 "EventTable.c"
}

static gchar*
value_event_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 38 "../src/db/EventTable.vala"
	if (collect_values[0].v_pointer) {
#line 216 "EventTable.c"
		EventRow * object;
		object = collect_values[0].v_pointer;
#line 38 "../src/db/EventTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 38 "../src/db/EventTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 223 "EventTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 38 "../src/db/EventTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 227 "EventTable.c"
		}
#line 38 "../src/db/EventTable.vala"
		value->data[0].v_pointer = event_row_ref (object);
#line 231 "EventTable.c"
	} else {
#line 38 "../src/db/EventTable.vala"
		value->data[0].v_pointer = NULL;
#line 235 "EventTable.c"
	}
#line 38 "../src/db/EventTable.vala"
	return NULL;
#line 239 "EventTable.c"
}

static gchar*
value_event_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	EventRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 38 "../src/db/EventTable.vala"
	if (!object_p) {
#line 38 "../src/db/EventTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 254 "EventTable.c"
	}
#line 38 "../src/db/EventTable.vala"
	if (!value->data[0].v_pointer) {
#line 38 "../src/db/EventTable.vala"
		*object_p = NULL;
#line 260 "EventTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 38 "../src/db/EventTable.vala"
		*object_p = value->data[0].v_pointer;
#line 264 "EventTable.c"
	} else {
#line 38 "../src/db/EventTable.vala"
		*object_p = event_row_ref (value->data[0].v_pointer);
#line 268 "EventTable.c"
	}
#line 38 "../src/db/EventTable.vala"
	return NULL;
#line 272 "EventTable.c"
}

GParamSpec*
param_spec_event_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecEventRow* spec;
#line 38 "../src/db/EventTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_EVENT_ROW), NULL);
#line 38 "../src/db/EventTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 38 "../src/db/EventTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 38 "../src/db/EventTable.vala"
	return G_PARAM_SPEC (spec);
#line 291 "EventTable.c"
}

gpointer
value_get_event_row (const GValue* value)
{
#line 38 "../src/db/EventTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EVENT_ROW), NULL);
#line 38 "../src/db/EventTable.vala"
	return value->data[0].v_pointer;
#line 301 "EventTable.c"
}

void
value_set_event_row (GValue* value,
                     gpointer v_object)
{
	EventRow * old;
#line 38 "../src/db/EventTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EVENT_ROW));
#line 38 "../src/db/EventTable.vala"
	old = value->data[0].v_pointer;
#line 38 "../src/db/EventTable.vala"
	if (v_object) {
#line 38 "../src/db/EventTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_EVENT_ROW));
#line 38 "../src/db/EventTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 38 "../src/db/EventTable.vala"
		value->data[0].v_pointer = v_object;
#line 38 "../src/db/EventTable.vala"
		event_row_ref (value->data[0].v_pointer);
#line 323 "EventTable.c"
	} else {
#line 38 "../src/db/EventTable.vala"
		value->data[0].v_pointer = NULL;
#line 327 "EventTable.c"
	}
#line 38 "../src/db/EventTable.vala"
	if (old) {
#line 38 "../src/db/EventTable.vala"
		event_row_unref (old);
#line 333 "EventTable.c"
	}
}

void
value_take_event_row (GValue* value,
                      gpointer v_object)
{
	EventRow * old;
#line 38 "../src/db/EventTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EVENT_ROW));
#line 38 "../src/db/EventTable.vala"
	old = value->data[0].v_pointer;
#line 38 "../src/db/EventTable.vala"
	if (v_object) {
#line 38 "../src/db/EventTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_EVENT_ROW));
#line 38 "../src/db/EventTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 38 "../src/db/EventTable.vala"
		value->data[0].v_pointer = v_object;
#line 354 "EventTable.c"
	} else {
#line 38 "../src/db/EventTable.vala"
		value->data[0].v_pointer = NULL;
#line 358 "EventTable.c"
	}
#line 38 "../src/db/EventTable.vala"
	if (old) {
#line 38 "../src/db/EventTable.vala"
		event_row_unref (old);
#line 364 "EventTable.c"
	}
}

static void
event_row_class_init (EventRowClass * klass,
                      gpointer klass_data)
{
#line 38 "../src/db/EventTable.vala"
	event_row_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/db/EventTable.vala"
	((EventRowClass *) klass)->finalize = event_row_finalize;
#line 376 "EventTable.c"
}

static void
event_row_instance_init (EventRow * self,
                         gpointer klass)
{
#line 38 "../src/db/EventTable.vala"
	self->ref_count = 1;
#line 385 "EventTable.c"
}

static void
event_row_finalize (EventRow * obj)
{
	EventRow * self;
#line 38 "../src/db/EventTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EVENT_ROW, EventRow);
#line 38 "../src/db/EventTable.vala"
	g_signal_handlers_destroy (self);
#line 40 "../src/db/EventTable.vala"
	_g_free0 (self->name);
#line 42 "../src/db/EventTable.vala"
	_g_free0 (self->primary_source_id);
#line 43 "../src/db/EventTable.vala"
	_g_free0 (self->comment);
#line 402 "EventTable.c"
}

static GType
event_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_event_row_init, value_event_row_free_value, value_event_row_copy_value, value_event_row_peek_pointer, "p", value_event_row_collect_value, "p", value_event_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (EventRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventRow), 0, (GInstanceInitFunc) event_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType event_row_type_id;
	event_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "EventRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return event_row_type_id;
}

GType
event_row_get_type (void)
{
	static volatile gsize event_row_type_id__once = 0;
	if (g_once_init_enter (&event_row_type_id__once)) {
		GType event_row_type_id;
		event_row_type_id = event_row_get_type_once ();
		g_once_init_leave (&event_row_type_id__once, event_row_type_id);
	}
	return event_row_type_id__once;
}

gpointer
event_row_ref (gpointer instance)
{
	EventRow * self;
	self = instance;
#line 38 "../src/db/EventTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 38 "../src/db/EventTable.vala"
	return instance;
#line 437 "EventTable.c"
}

void
event_row_unref (gpointer instance)
{
	EventRow * self;
	self = instance;
#line 38 "../src/db/EventTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 38 "../src/db/EventTable.vala"
		EVENT_ROW_GET_CLASS (self)->finalize (self);
#line 38 "../src/db/EventTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 451 "EventTable.c"
	}
}

static EventTable*
event_table_construct (GType object_type)
{
	EventTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
#line 49 "../src/db/EventTable.vala"
	self = (EventTable*) database_table_construct (object_type);
#line 50 "../src/db/EventTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS EventTable (" "id INTEGER PRIMARY KEY, " "name TEXT, " "primary_photo_id INTEGER, " "time_created INTEGER," "primary_source_id TEXT," "comment TEXT" ")");
#line 50 "../src/db/EventTable.vala"
	stmt = _tmp0_;
#line 60 "../src/db/EventTable.vala"
	_tmp1_ = stmt;
#line 60 "../src/db/EventTable.vala"
	res = sqlite3_step (_tmp1_);
#line 61 "../src/db/EventTable.vala"
	if (res != SQLITE_DONE) {
#line 62 "../src/db/EventTable.vala"
		database_table_fatal ("create photo table", res);
#line 477 "EventTable.c"
	}
#line 64 "../src/db/EventTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "EventTable");
#line 49 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 49 "../src/db/EventTable.vala"
	return self;
#line 485 "EventTable.c"
}

static EventTable*
event_table_new (void)
{
#line 49 "../src/db/EventTable.vala"
	return event_table_construct (TYPE_EVENT_TABLE);
#line 493 "EventTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 71 "../src/db/EventTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 501 "EventTable.c"
}

EventTable*
event_table_get_instance (void)
{
	EventTable* _tmp0_;
	EventTable* _tmp2_;
	EventTable* _tmp3_;
	EventTable* result;
#line 68 "../src/db/EventTable.vala"
	_tmp0_ = event_table_instance;
#line 68 "../src/db/EventTable.vala"
	if (_tmp0_ == NULL) {
#line 515 "EventTable.c"
		EventTable* _tmp1_;
#line 69 "../src/db/EventTable.vala"
		_tmp1_ = event_table_new ();
#line 69 "../src/db/EventTable.vala"
		_database_table_unref0 (event_table_instance);
#line 69 "../src/db/EventTable.vala"
		event_table_instance = _tmp1_;
#line 523 "EventTable.c"
	}
#line 71 "../src/db/EventTable.vala"
	_tmp2_ = event_table_instance;
#line 71 "../src/db/EventTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 71 "../src/db/EventTable.vala"
	result = _tmp3_;
#line 71 "../src/db/EventTable.vala"
	return result;
#line 533 "EventTable.c"
}

static gchar*
event_table_source_id_upgrade (EventTable* self,
                               gint64 primary_photo_id,
                               const gchar* primary_source_id)
{
	MediaCollectionRegistry* _tmp0_;
	MediaCollectionRegistry* _tmp1_;
	gboolean _tmp2_;
	gchar* result;
#line 75 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../src/db/EventTable.vala"
	_tmp0_ = media_collection_registry_get_instance ();
#line 76 "../src/db/EventTable.vala"
	_tmp1_ = _tmp0_;
#line 76 "../src/db/EventTable.vala"
	_tmp2_ = media_collection_registry_is_valid_source_id (_tmp1_, primary_source_id);
#line 76 "../src/db/EventTable.vala"
	_media_collection_registry_unref0 (_tmp1_);
#line 76 "../src/db/EventTable.vala"
	if (_tmp2_) {
#line 557 "EventTable.c"
		gchar* _tmp3_;
#line 77 "../src/db/EventTable.vala"
		_tmp3_ = g_strdup (primary_source_id);
#line 77 "../src/db/EventTable.vala"
		result = _tmp3_;
#line 77 "../src/db/EventTable.vala"
		return result;
#line 565 "EventTable.c"
	}
#line 79 "../src/db/EventTable.vala"
	if (primary_photo_id != PHOTO_ID_INVALID) {
#line 569 "EventTable.c"
		PhotoID _tmp4_ = {0};
		gchar* _tmp5_;
#line 81 "../src/db/EventTable.vala"
		photo_id_init (&_tmp4_, primary_photo_id);
#line 81 "../src/db/EventTable.vala"
		_tmp5_ = photo_id_upgrade_photo_id_to_source_id (&_tmp4_);
#line 81 "../src/db/EventTable.vala"
		result = _tmp5_;
#line 81 "../src/db/EventTable.vala"
		return result;
#line 580 "EventTable.c"
	}
#line 83 "../src/db/EventTable.vala"
	result = NULL;
#line 83 "../src/db/EventTable.vala"
	return result;
#line 586 "EventTable.c"
}

EventRow*
event_table_create (EventTable* self,
                    const gchar* primary_source_id,
                    const gchar* comment,
                    GError** error)
{
	gboolean _tmp0_ = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp1_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint res = 0;
	sqlite3_stmt* _tmp5_;
	EventRow* row = NULL;
	EventRow* _tmp6_;
	EventRow* _tmp7_;
	sqlite3* _tmp8_;
	EventRow* _tmp9_;
	EventRow* _tmp10_;
	gchar* _tmp11_;
	EventRow* _tmp12_;
	EventRow* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	EventRow* result;
#line 86 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/db/EventTable.vala"
	if (primary_source_id != NULL) {
#line 87 "../src/db/EventTable.vala"
		_tmp0_ = g_strcmp0 (primary_source_id, "") != 0;
#line 622 "EventTable.c"
	} else {
#line 87 "../src/db/EventTable.vala"
		_tmp0_ = FALSE;
#line 626 "EventTable.c"
	}
#line 87 "../src/db/EventTable.vala"
	_vala_assert (_tmp0_, "primary_source_id != null && primary_source_id != \"\"");
#line 89 "../src/db/EventTable.vala"
	_tmp1_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO EventTable (primary_source_id, time_created, comment) VALU" \
"ES (?, ?, ?)");
#line 89 "../src/db/EventTable.vala"
	stmt = _tmp1_;
#line 91 "../src/db/EventTable.vala"
	time_created = now_sec ();
#line 93 "../src/db/EventTable.vala"
	_tmp2_ = stmt;
#line 93 "../src/db/EventTable.vala"
	database_table_bind_text (_tmp2_, 1, primary_source_id);
#line 94 "../src/db/EventTable.vala"
	_tmp3_ = stmt;
#line 94 "../src/db/EventTable.vala"
	database_table_bind_int64 (_tmp3_, 2, time_created);
#line 95 "../src/db/EventTable.vala"
	_tmp4_ = stmt;
#line 95 "../src/db/EventTable.vala"
	database_table_bind_text (_tmp4_, 3, comment);
#line 97 "../src/db/EventTable.vala"
	_tmp5_ = stmt;
#line 97 "../src/db/EventTable.vala"
	res = sqlite3_step (_tmp5_);
#line 98 "../src/db/EventTable.vala"
	if (res != SQLITE_DONE) {
#line 99 "../src/db/EventTable.vala"
		database_table_throw_error ("EventTable.create", res, &_inner_error0_);
#line 99 "../src/db/EventTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/db/EventTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 99 "../src/db/EventTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 99 "../src/db/EventTable.vala"
				_sqlite3_finalize0 (stmt);
#line 99 "../src/db/EventTable.vala"
				return NULL;
#line 666 "EventTable.c"
			} else {
#line 99 "../src/db/EventTable.vala"
				_sqlite3_finalize0 (stmt);
#line 99 "../src/db/EventTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/db/EventTable.vala"
				g_clear_error (&_inner_error0_);
#line 99 "../src/db/EventTable.vala"
				return NULL;
#line 676 "EventTable.c"
			}
		}
	}
#line 101 "../src/db/EventTable.vala"
	_tmp6_ = event_row_new ();
#line 101 "../src/db/EventTable.vala"
	row = _tmp6_;
#line 102 "../src/db/EventTable.vala"
	_tmp7_ = row;
#line 102 "../src/db/EventTable.vala"
	_tmp8_ = database_table_db;
#line 102 "../src/db/EventTable.vala"
	event_id_init (&_tmp7_->event_id, sqlite3_last_insert_rowid (_tmp8_));
#line 103 "../src/db/EventTable.vala"
	_tmp9_ = row;
#line 103 "../src/db/EventTable.vala"
	_g_free0 (_tmp9_->name);
#line 103 "../src/db/EventTable.vala"
	_tmp9_->name = NULL;
#line 104 "../src/db/EventTable.vala"
	_tmp10_ = row;
#line 104 "../src/db/EventTable.vala"
	_tmp11_ = g_strdup (primary_source_id);
#line 104 "../src/db/EventTable.vala"
	_g_free0 (_tmp10_->primary_source_id);
#line 104 "../src/db/EventTable.vala"
	_tmp10_->primary_source_id = _tmp11_;
#line 105 "../src/db/EventTable.vala"
	_tmp12_ = row;
#line 105 "../src/db/EventTable.vala"
	_tmp12_->time_created = time_created;
#line 106 "../src/db/EventTable.vala"
	_tmp13_ = row;
#line 106 "../src/db/EventTable.vala"
	_tmp14_ = g_strdup (comment);
#line 106 "../src/db/EventTable.vala"
	_g_free0 (_tmp13_->comment);
#line 106 "../src/db/EventTable.vala"
	_tmp13_->comment = _tmp14_;
#line 108 "../src/db/EventTable.vala"
	result = row;
#line 108 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 108 "../src/db/EventTable.vala"
	return result;
#line 722 "EventTable.c"
}

void
event_table_create_from_row (EventTable* self,
                             EventRow* row,
                             EventID* result)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	const gchar* _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	gint res = 0;
	sqlite3_stmt* _tmp9_;
	sqlite3* _tmp11_;
	EventID _tmp12_ = {0};
#line 114 "../src/db/EventTable.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/db/EventTable.vala"
	g_return_if_fail (row != NULL);
#line 115 "../src/db/EventTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO EventTable (name, primary_photo_id, primary_source_id, tim" \
"e_created, comment) VALUES (?, ?, ?, ?, ?)");
#line 115 "../src/db/EventTable.vala"
	stmt = _tmp0_;
#line 117 "../src/db/EventTable.vala"
	_tmp1_ = stmt;
#line 117 "../src/db/EventTable.vala"
	_tmp2_ = row->name;
#line 117 "../src/db/EventTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp2_);
#line 118 "../src/db/EventTable.vala"
	_tmp3_ = stmt;
#line 118 "../src/db/EventTable.vala"
	database_table_bind_int64 (_tmp3_, 2, PHOTO_ID_INVALID);
#line 119 "../src/db/EventTable.vala"
	_tmp4_ = stmt;
#line 119 "../src/db/EventTable.vala"
	_tmp5_ = row->primary_source_id;
#line 119 "../src/db/EventTable.vala"
	database_table_bind_text (_tmp4_, 3, _tmp5_);
#line 120 "../src/db/EventTable.vala"
	_tmp6_ = stmt;
#line 120 "../src/db/EventTable.vala"
	database_table_bind_int64 (_tmp6_, 4, row->time_created);
#line 121 "../src/db/EventTable.vala"
	_tmp7_ = stmt;
#line 121 "../src/db/EventTable.vala"
	_tmp8_ = row->comment;
#line 121 "../src/db/EventTable.vala"
	database_table_bind_text (_tmp7_, 5, _tmp8_);
#line 123 "../src/db/EventTable.vala"
	_tmp9_ = stmt;
#line 123 "../src/db/EventTable.vala"
	res = sqlite3_step (_tmp9_);
#line 124 "../src/db/EventTable.vala"
	if (res != SQLITE_DONE) {
#line 784 "EventTable.c"
		EventID _tmp10_ = {0};
#line 125 "../src/db/EventTable.vala"
		database_table_fatal ("Event create_from_row", res);
#line 127 "../src/db/EventTable.vala"
		event_id_init (&_tmp10_, EVENT_ID_INVALID);
#line 127 "../src/db/EventTable.vala"
		*result = _tmp10_;
#line 127 "../src/db/EventTable.vala"
		_sqlite3_finalize0 (stmt);
#line 127 "../src/db/EventTable.vala"
		return;
#line 796 "EventTable.c"
	}
#line 130 "../src/db/EventTable.vala"
	_tmp11_ = database_table_db;
#line 130 "../src/db/EventTable.vala"
	event_id_init (&_tmp12_, sqlite3_last_insert_rowid (_tmp11_));
#line 130 "../src/db/EventTable.vala"
	*result = _tmp12_;
#line 130 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 130 "../src/db/EventTable.vala"
	return;
#line 808 "EventTable.c"
}

EventRow*
event_table_get_row (EventTable* self,
                     EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	EventID _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventRow* row = NULL;
	EventRow* _tmp4_;
	EventRow* _tmp5_;
	EventID _tmp6_;
	EventRow* _tmp7_;
	sqlite3_stmt* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	EventRow* _tmp12_;
	const gchar* _tmp13_;
	EventRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	sqlite3_stmt* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	EventRow* _tmp24_;
	sqlite3_stmt* _tmp25_;
	EventRow* _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	EventRow* result;
#line 133 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../src/db/EventTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 134 "../src/db/EventTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT name, primary_photo_id, primary_source_id, time_created, commen" \
"t FROM EventTable WHERE id=?");
#line 134 "../src/db/EventTable.vala"
	stmt = _tmp0_;
#line 136 "../src/db/EventTable.vala"
	_tmp1_ = stmt;
#line 136 "../src/db/EventTable.vala"
	_tmp2_ = *event_id;
#line 136 "../src/db/EventTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 138 "../src/db/EventTable.vala"
	_tmp3_ = stmt;
#line 138 "../src/db/EventTable.vala"
	if (sqlite3_step (_tmp3_) != SQLITE_ROW) {
#line 139 "../src/db/EventTable.vala"
		result = NULL;
#line 139 "../src/db/EventTable.vala"
		_sqlite3_finalize0 (stmt);
#line 139 "../src/db/EventTable.vala"
		return result;
#line 867 "EventTable.c"
	}
#line 142 "../src/db/EventTable.vala"
	_tmp4_ = event_row_new ();
#line 142 "../src/db/EventTable.vala"
	row = _tmp4_;
#line 143 "../src/db/EventTable.vala"
	_tmp5_ = row;
#line 143 "../src/db/EventTable.vala"
	_tmp6_ = *event_id;
#line 143 "../src/db/EventTable.vala"
	_tmp5_->event_id = _tmp6_;
#line 144 "../src/db/EventTable.vala"
	_tmp7_ = row;
#line 144 "../src/db/EventTable.vala"
	_tmp8_ = stmt;
#line 144 "../src/db/EventTable.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 0);
#line 144 "../src/db/EventTable.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 144 "../src/db/EventTable.vala"
	_g_free0 (_tmp7_->name);
#line 144 "../src/db/EventTable.vala"
	_tmp7_->name = _tmp10_;
#line 145 "../src/db/EventTable.vala"
	_tmp12_ = row;
#line 145 "../src/db/EventTable.vala"
	_tmp13_ = _tmp12_->name;
#line 145 "../src/db/EventTable.vala"
	if (_tmp13_ != NULL) {
#line 897 "EventTable.c"
		EventRow* _tmp14_;
		const gchar* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
#line 145 "../src/db/EventTable.vala"
		_tmp14_ = row;
#line 145 "../src/db/EventTable.vala"
		_tmp15_ = _tmp14_->name;
#line 145 "../src/db/EventTable.vala"
		_tmp16_ = strlen (_tmp15_);
#line 145 "../src/db/EventTable.vala"
		_tmp17_ = _tmp16_;
#line 145 "../src/db/EventTable.vala"
		_tmp11_ = _tmp17_ == 0;
#line 912 "EventTable.c"
	} else {
#line 145 "../src/db/EventTable.vala"
		_tmp11_ = FALSE;
#line 916 "EventTable.c"
	}
#line 145 "../src/db/EventTable.vala"
	if (_tmp11_) {
#line 920 "EventTable.c"
		EventRow* _tmp18_;
#line 146 "../src/db/EventTable.vala"
		_tmp18_ = row;
#line 146 "../src/db/EventTable.vala"
		_g_free0 (_tmp18_->name);
#line 146 "../src/db/EventTable.vala"
		_tmp18_->name = NULL;
#line 928 "EventTable.c"
	}
#line 147 "../src/db/EventTable.vala"
	_tmp19_ = row;
#line 147 "../src/db/EventTable.vala"
	_tmp20_ = stmt;
#line 147 "../src/db/EventTable.vala"
	_tmp21_ = stmt;
#line 147 "../src/db/EventTable.vala"
	_tmp22_ = (const gchar*) sqlite3_column_text (_tmp21_, 2);
#line 147 "../src/db/EventTable.vala"
	_tmp23_ = event_table_source_id_upgrade (self, sqlite3_column_int64 (_tmp20_, 1), _tmp22_);
#line 147 "../src/db/EventTable.vala"
	_g_free0 (_tmp19_->primary_source_id);
#line 147 "../src/db/EventTable.vala"
	_tmp19_->primary_source_id = _tmp23_;
#line 148 "../src/db/EventTable.vala"
	_tmp24_ = row;
#line 148 "../src/db/EventTable.vala"
	_tmp25_ = stmt;
#line 148 "../src/db/EventTable.vala"
	_tmp24_->time_created = sqlite3_column_int64 (_tmp25_, 3);
#line 149 "../src/db/EventTable.vala"
	_tmp26_ = row;
#line 149 "../src/db/EventTable.vala"
	_tmp27_ = stmt;
#line 149 "../src/db/EventTable.vala"
	_tmp28_ = (const gchar*) sqlite3_column_text (_tmp27_, 4);
#line 149 "../src/db/EventTable.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 149 "../src/db/EventTable.vala"
	_g_free0 (_tmp26_->comment);
#line 149 "../src/db/EventTable.vala"
	_tmp26_->comment = _tmp29_;
#line 151 "../src/db/EventTable.vala"
	result = row;
#line 151 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 151 "../src/db/EventTable.vala"
	return result;
#line 968 "EventTable.c"
}

void
event_table_remove (EventTable* self,
                    EventID* event_id,
                    GError** error)
{
	EventID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 154 "../src/db/EventTable.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/db/EventTable.vala"
	g_return_if_fail (event_id != NULL);
#line 155 "../src/db/EventTable.vala"
	_tmp0_ = *event_id;
#line 155 "../src/db/EventTable.vala"
	database_table_delete_by_id ((DatabaseTable*) self, _tmp0_.id, &_inner_error0_);
#line 155 "../src/db/EventTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "../src/db/EventTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 155 "../src/db/EventTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 155 "../src/db/EventTable.vala"
			return;
#line 994 "EventTable.c"
		} else {
#line 155 "../src/db/EventTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 155 "../src/db/EventTable.vala"
			g_clear_error (&_inner_error0_);
#line 155 "../src/db/EventTable.vala"
			return;
#line 1002 "EventTable.c"
		}
	}
}

GeeArrayList*
event_table_get_events (EventTable* self)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* event_rows = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* result;
#line 158 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 159 "../src/db/EventTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id, name, primary_photo_id, primary_source_id, time_created, co" \
"mment FROM EventTable");
#line 159 "../src/db/EventTable.vala"
	stmt = _tmp0_;
#line 161 "../src/db/EventTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_EVENT_ROW, (GBoxedCopyFunc) event_row_ref, (GDestroyNotify) event_row_unref, NULL, NULL, NULL);
#line 161 "../src/db/EventTable.vala"
	event_rows = _tmp1_;
#line 1025 "EventTable.c"
	{
		gboolean _tmp2_ = FALSE;
#line 162 "../src/db/EventTable.vala"
		_tmp2_ = TRUE;
#line 162 "../src/db/EventTable.vala"
		while (TRUE) {
#line 1032 "EventTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp3_;
			EventRow* row = NULL;
			EventRow* _tmp4_;
			EventRow* _tmp5_;
			sqlite3_stmt* _tmp6_;
			EventRow* _tmp7_;
			sqlite3_stmt* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			EventRow* _tmp11_;
			sqlite3_stmt* _tmp12_;
			sqlite3_stmt* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			EventRow* _tmp16_;
			sqlite3_stmt* _tmp17_;
			EventRow* _tmp18_;
			sqlite3_stmt* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			GeeArrayList* _tmp22_;
			EventRow* _tmp23_;
#line 162 "../src/db/EventTable.vala"
			if (!_tmp2_) {
#line 1058 "EventTable.c"
			}
#line 162 "../src/db/EventTable.vala"
			_tmp2_ = FALSE;
#line 163 "../src/db/EventTable.vala"
			_tmp3_ = stmt;
#line 163 "../src/db/EventTable.vala"
			res = sqlite3_step (_tmp3_);
#line 164 "../src/db/EventTable.vala"
			if (res == SQLITE_DONE) {
#line 165 "../src/db/EventTable.vala"
				break;
#line 1070 "EventTable.c"
			} else {
#line 166 "../src/db/EventTable.vala"
				if (res != SQLITE_ROW) {
#line 167 "../src/db/EventTable.vala"
					database_table_fatal ("get_events", res);
#line 169 "../src/db/EventTable.vala"
					break;
#line 1078 "EventTable.c"
				}
			}
#line 172 "../src/db/EventTable.vala"
			_tmp4_ = event_row_new ();
#line 172 "../src/db/EventTable.vala"
			row = _tmp4_;
#line 174 "../src/db/EventTable.vala"
			_tmp5_ = row;
#line 174 "../src/db/EventTable.vala"
			_tmp6_ = stmt;
#line 174 "../src/db/EventTable.vala"
			event_id_init (&_tmp5_->event_id, sqlite3_column_int64 (_tmp6_, 0));
#line 175 "../src/db/EventTable.vala"
			_tmp7_ = row;
#line 175 "../src/db/EventTable.vala"
			_tmp8_ = stmt;
#line 175 "../src/db/EventTable.vala"
			_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 1);
#line 175 "../src/db/EventTable.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 175 "../src/db/EventTable.vala"
			_g_free0 (_tmp7_->name);
#line 175 "../src/db/EventTable.vala"
			_tmp7_->name = _tmp10_;
#line 176 "../src/db/EventTable.vala"
			_tmp11_ = row;
#line 176 "../src/db/EventTable.vala"
			_tmp12_ = stmt;
#line 176 "../src/db/EventTable.vala"
			_tmp13_ = stmt;
#line 176 "../src/db/EventTable.vala"
			_tmp14_ = (const gchar*) sqlite3_column_text (_tmp13_, 3);
#line 176 "../src/db/EventTable.vala"
			_tmp15_ = event_table_source_id_upgrade (self, sqlite3_column_int64 (_tmp12_, 2), _tmp14_);
#line 176 "../src/db/EventTable.vala"
			_g_free0 (_tmp11_->primary_source_id);
#line 176 "../src/db/EventTable.vala"
			_tmp11_->primary_source_id = _tmp15_;
#line 177 "../src/db/EventTable.vala"
			_tmp16_ = row;
#line 177 "../src/db/EventTable.vala"
			_tmp17_ = stmt;
#line 177 "../src/db/EventTable.vala"
			_tmp16_->time_created = sqlite3_column_int64 (_tmp17_, 4);
#line 178 "../src/db/EventTable.vala"
			_tmp18_ = row;
#line 178 "../src/db/EventTable.vala"
			_tmp19_ = stmt;
#line 178 "../src/db/EventTable.vala"
			_tmp20_ = (const gchar*) sqlite3_column_text (_tmp19_, 5);
#line 178 "../src/db/EventTable.vala"
			_tmp21_ = g_strdup (_tmp20_);
#line 178 "../src/db/EventTable.vala"
			_g_free0 (_tmp18_->comment);
#line 178 "../src/db/EventTable.vala"
			_tmp18_->comment = _tmp21_;
#line 180 "../src/db/EventTable.vala"
			_tmp22_ = event_rows;
#line 180 "../src/db/EventTable.vala"
			_tmp23_ = row;
#line 180 "../src/db/EventTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 162 "../src/db/EventTable.vala"
			_event_row_unref0 (row);
#line 1143 "EventTable.c"
		}
	}
#line 183 "../src/db/EventTable.vala"
	result = event_rows;
#line 183 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 183 "../src/db/EventTable.vala"
	return result;
#line 1152 "EventTable.c"
}

gboolean
event_table_rename (EventTable* self,
                    EventID* event_id,
                    const gchar* name)
{
	const gchar* _tmp0_ = NULL;
	EventID _tmp1_;
	gboolean result;
#line 186 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../src/db/EventTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 187 "../src/db/EventTable.vala"
	if (name != NULL) {
#line 187 "../src/db/EventTable.vala"
		_tmp0_ = name;
#line 1171 "EventTable.c"
	} else {
#line 187 "../src/db/EventTable.vala"
		_tmp0_ = "";
#line 1175 "EventTable.c"
	}
#line 187 "../src/db/EventTable.vala"
	_tmp1_ = *event_id;
#line 187 "../src/db/EventTable.vala"
	result = database_table_update_text_by_id ((DatabaseTable*) self, _tmp1_.id, "name", _tmp0_);
#line 187 "../src/db/EventTable.vala"
	return result;
#line 1183 "EventTable.c"
}

gchar*
event_table_get_name (EventTable* self,
                      EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	EventID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	gchar* name = NULL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	gchar* _tmp13_;
	gchar* result;
#line 190 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../src/db/EventTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 192 "../src/db/EventTable.vala"
	_tmp0_ = *event_id;
#line 192 "../src/db/EventTable.vala"
	_tmp2_ = database_table_select_by_id ((DatabaseTable*) self, _tmp0_.id, "name", &_tmp1_);
#line 192 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 192 "../src/db/EventTable.vala"
	stmt = _tmp1_;
#line 192 "../src/db/EventTable.vala"
	if (!_tmp2_) {
#line 193 "../src/db/EventTable.vala"
		result = NULL;
#line 193 "../src/db/EventTable.vala"
		_sqlite3_finalize0 (stmt);
#line 193 "../src/db/EventTable.vala"
		return result;
#line 1223 "EventTable.c"
	}
#line 195 "../src/db/EventTable.vala"
	_tmp3_ = stmt;
#line 195 "../src/db/EventTable.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 195 "../src/db/EventTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 195 "../src/db/EventTable.vala"
	name = _tmp5_;
#line 197 "../src/db/EventTable.vala"
	_tmp8_ = name;
#line 197 "../src/db/EventTable.vala"
	if (_tmp8_ != NULL) {
#line 1237 "EventTable.c"
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 197 "../src/db/EventTable.vala"
		_tmp9_ = name;
#line 197 "../src/db/EventTable.vala"
		_tmp10_ = strlen (_tmp9_);
#line 197 "../src/db/EventTable.vala"
		_tmp11_ = _tmp10_;
#line 197 "../src/db/EventTable.vala"
		_tmp7_ = _tmp11_ > 0;
#line 1249 "EventTable.c"
	} else {
#line 197 "../src/db/EventTable.vala"
		_tmp7_ = FALSE;
#line 1253 "EventTable.c"
	}
#line 197 "../src/db/EventTable.vala"
	if (_tmp7_) {
#line 1257 "EventTable.c"
		const gchar* _tmp12_;
#line 197 "../src/db/EventTable.vala"
		_tmp12_ = name;
#line 197 "../src/db/EventTable.vala"
		_tmp6_ = _tmp12_;
#line 1263 "EventTable.c"
	} else {
#line 197 "../src/db/EventTable.vala"
		_tmp6_ = NULL;
#line 1267 "EventTable.c"
	}
#line 197 "../src/db/EventTable.vala"
	_tmp13_ = g_strdup (_tmp6_);
#line 197 "../src/db/EventTable.vala"
	result = _tmp13_;
#line 197 "../src/db/EventTable.vala"
	_g_free0 (name);
#line 197 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 197 "../src/db/EventTable.vala"
	return result;
#line 1279 "EventTable.c"
}

gchar*
event_table_get_primary_source_id (EventTable* self,
                                   EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	EventID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 200 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 200 "../src/db/EventTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 202 "../src/db/EventTable.vala"
	_tmp0_ = *event_id;
#line 202 "../src/db/EventTable.vala"
	_tmp2_ = database_table_select_by_id ((DatabaseTable*) self, _tmp0_.id, "primary_source_id", &_tmp1_);
#line 202 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 202 "../src/db/EventTable.vala"
	stmt = _tmp1_;
#line 202 "../src/db/EventTable.vala"
	if (!_tmp2_) {
#line 203 "../src/db/EventTable.vala"
		result = NULL;
#line 203 "../src/db/EventTable.vala"
		_sqlite3_finalize0 (stmt);
#line 203 "../src/db/EventTable.vala"
		return result;
#line 1314 "EventTable.c"
	}
#line 205 "../src/db/EventTable.vala"
	_tmp3_ = stmt;
#line 205 "../src/db/EventTable.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 205 "../src/db/EventTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 205 "../src/db/EventTable.vala"
	result = _tmp5_;
#line 205 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 205 "../src/db/EventTable.vala"
	return result;
#line 1328 "EventTable.c"
}

gboolean
event_table_set_primary_source_id (EventTable* self,
                                   EventID* event_id,
                                   const gchar* primary_source_id)
{
	EventID _tmp0_;
	gboolean result;
#line 208 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 208 "../src/db/EventTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 208 "../src/db/EventTable.vala"
	g_return_val_if_fail (primary_source_id != NULL, FALSE);
#line 209 "../src/db/EventTable.vala"
	_tmp0_ = *event_id;
#line 209 "../src/db/EventTable.vala"
	result = database_table_update_text_by_id ((DatabaseTable*) self, _tmp0_.id, "primary_source_id", primary_source_id);
#line 209 "../src/db/EventTable.vala"
	return result;
#line 1350 "EventTable.c"
}

gint64
event_table_get_time_created (EventTable* self,
                              EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	EventID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	sqlite3_stmt* _tmp3_;
	gint64 result;
#line 212 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 212 "../src/db/EventTable.vala"
	g_return_val_if_fail (event_id != NULL, 0LL);
#line 214 "../src/db/EventTable.vala"
	_tmp0_ = *event_id;
#line 214 "../src/db/EventTable.vala"
	_tmp2_ = database_table_select_by_id ((DatabaseTable*) self, _tmp0_.id, "time_created", &_tmp1_);
#line 214 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 214 "../src/db/EventTable.vala"
	stmt = _tmp1_;
#line 214 "../src/db/EventTable.vala"
	if (!_tmp2_) {
#line 215 "../src/db/EventTable.vala"
		result = (gint64) 0;
#line 215 "../src/db/EventTable.vala"
		_sqlite3_finalize0 (stmt);
#line 215 "../src/db/EventTable.vala"
		return result;
#line 1383 "EventTable.c"
	}
#line 217 "../src/db/EventTable.vala"
	_tmp3_ = stmt;
#line 217 "../src/db/EventTable.vala"
	result = sqlite3_column_int64 (_tmp3_, 0);
#line 217 "../src/db/EventTable.vala"
	_sqlite3_finalize0 (stmt);
#line 217 "../src/db/EventTable.vala"
	return result;
#line 1393 "EventTable.c"
}

gboolean
event_table_set_comment (EventTable* self,
                         EventID* event_id,
                         const gchar* new_comment)
{
	const gchar* _tmp0_ = NULL;
	EventID _tmp1_;
	gboolean result;
#line 220 "../src/db/EventTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 220 "../src/db/EventTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 220 "../src/db/EventTable.vala"
	g_return_val_if_fail (new_comment != NULL, FALSE);
#line 221 "../src/db/EventTable.vala"
	if (new_comment != NULL) {
#line 221 "../src/db/EventTable.vala"
		_tmp0_ = new_comment;
#line 1414 "EventTable.c"
	} else {
#line 221 "../src/db/EventTable.vala"
		_tmp0_ = "";
#line 1418 "EventTable.c"
	}
#line 221 "../src/db/EventTable.vala"
	_tmp1_ = *event_id;
#line 221 "../src/db/EventTable.vala"
	result = database_table_update_text_by_id ((DatabaseTable*) self, _tmp1_.id, "comment", _tmp0_);
#line 221 "../src/db/EventTable.vala"
	return result;
#line 1426 "EventTable.c"
}

static void
event_table_class_init (EventTableClass * klass,
                        gpointer klass_data)
{
#line 46 "../src/db/EventTable.vala"
	event_table_parent_class = g_type_class_peek_parent (klass);
#line 46 "../src/db/EventTable.vala"
	((DatabaseTableClass *) klass)->finalize = event_table_finalize;
#line 1437 "EventTable.c"
}

static void
event_table_instance_init (EventTable * self,
                           gpointer klass)
{
}

static void
event_table_finalize (DatabaseTable * obj)
{
	EventTable * self;
#line 46 "../src/db/EventTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EVENT_TABLE, EventTable);
#line 46 "../src/db/EventTable.vala"
	DATABASE_TABLE_CLASS (event_table_parent_class)->finalize (obj);
#line 1454 "EventTable.c"
}

static GType
event_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EventTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventTable), 0, (GInstanceInitFunc) event_table_instance_init, NULL };
	GType event_table_type_id;
	event_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "EventTable", &g_define_type_info, 0);
	return event_table_type_id;
}

GType
event_table_get_type (void)
{
	static volatile gsize event_table_type_id__once = 0;
	if (g_once_init_enter (&event_table_type_id__once)) {
		GType event_table_type_id;
		event_table_type_id = event_table_get_type_once ();
		g_once_init_leave (&event_table_type_id__once, event_table_type_id);
	}
	return event_table_type_id__once;
}

