/* SavedSearchDBTable.c generated by valac 0.56.18, the Vala compiler
 * generated from SavedSearchDBTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <string.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecSavedSearchRow ParamSpecSavedSearchRow;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _search_condition_unref0(var) ((var == NULL) ? NULL : (var = (search_condition_unref (var), NULL)))
#define _saved_search_row_unref0(var) ((var == NULL) ? NULL : (var = (saved_search_row_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _ParamSpecSavedSearchRow {
	GParamSpec parent_instance;
};

static gpointer saved_search_row_parent_class = NULL;
static gpointer saved_search_db_table_parent_class = NULL;
static SavedSearchDBTable* saved_search_db_table_instance;
static SavedSearchDBTable* saved_search_db_table_instance = NULL;

static void saved_search_row_finalize (SavedSearchRow * obj);
static GType saved_search_row_get_type_once (void);
static SavedSearchDBTable* saved_search_db_table_new (void);
static SavedSearchDBTable* saved_search_db_table_construct (GType object_type);
static void saved_search_db_table_add_condition (SavedSearchDBTable* self,
                                          SavedSearchID* id,
                                          SearchCondition* condition,
                                          GError** error);
static void saved_search_db_table_remove_conditions_for_search_id (SavedSearchDBTable* self,
                                                            SavedSearchID* search_id,
                                                            GError** error);
static void saved_search_db_table_remove_conditions_for_table (SavedSearchDBTable* self,
                                                        const gchar* table_name,
                                                        SavedSearchID* search_id,
                                                        GError** error);
static GeeList* saved_search_db_table_get_conditions_for_id (SavedSearchDBTable* self,
                                                      SavedSearchID* search_id,
                                                      GError** error);
static void saved_search_db_table_finalize (DatabaseTable * obj);
static GType saved_search_db_table_get_type_once (void);

void
saved_search_id_init (SavedSearchID *self,
                      gint64 id)
{
#line 25 "../src/db/SavedSearchDBTable.vala"
	memset (self, 0, sizeof (SavedSearchID));
#line 26 "../src/db/SavedSearchDBTable.vala"
	(*self).id = id;
#line 89 "SavedSearchDBTable.c"
}

gboolean
saved_search_id_is_invalid (SavedSearchID *self)
{
	gboolean result;
#line 30 "../src/db/SavedSearchDBTable.vala"
	result = (*self).id == SAVED_SEARCH_ID_INVALID;
#line 30 "../src/db/SavedSearchDBTable.vala"
	return result;
#line 100 "SavedSearchDBTable.c"
}

gboolean
saved_search_id_is_valid (SavedSearchID *self)
{
	gboolean result;
#line 34 "../src/db/SavedSearchDBTable.vala"
	result = (*self).id != SAVED_SEARCH_ID_INVALID;
#line 34 "../src/db/SavedSearchDBTable.vala"
	return result;
#line 111 "SavedSearchDBTable.c"
}

SavedSearchID*
saved_search_id_dup (const SavedSearchID* self)
{
	SavedSearchID* dup;
#line 20 "../src/db/SavedSearchDBTable.vala"
	dup = g_new0 (SavedSearchID, 1);
#line 20 "../src/db/SavedSearchDBTable.vala"
	memcpy (dup, self, sizeof (SavedSearchID));
#line 20 "../src/db/SavedSearchDBTable.vala"
	return dup;
#line 124 "SavedSearchDBTable.c"
}

void
saved_search_id_free (SavedSearchID* self)
{
#line 20 "../src/db/SavedSearchDBTable.vala"
	g_free (self);
#line 132 "SavedSearchDBTable.c"
}

static GType
saved_search_id_get_type_once (void)
{
	GType saved_search_id_type_id;
	saved_search_id_type_id = g_boxed_type_register_static ("SavedSearchID", (GBoxedCopyFunc) saved_search_id_dup, (GBoxedFreeFunc) saved_search_id_free);
	return saved_search_id_type_id;
}

GType
saved_search_id_get_type (void)
{
	static volatile gsize saved_search_id_type_id__once = 0;
	if (g_once_init_enter (&saved_search_id_type_id__once)) {
		GType saved_search_id_type_id;
		saved_search_id_type_id = saved_search_id_get_type_once ();
		g_once_init_leave (&saved_search_id_type_id__once, saved_search_id_type_id);
	}
	return saved_search_id_type_id__once;
}

SavedSearchRow*
saved_search_row_construct (GType object_type)
{
	SavedSearchRow* self = NULL;
#line 38 "../src/db/SavedSearchDBTable.vala"
	self = (SavedSearchRow*) g_type_create_instance (object_type);
#line 38 "../src/db/SavedSearchDBTable.vala"
	return self;
#line 163 "SavedSearchDBTable.c"
}

SavedSearchRow*
saved_search_row_new (void)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	return saved_search_row_construct (TYPE_SAVED_SEARCH_ROW);
#line 171 "SavedSearchDBTable.c"
}

static void
value_saved_search_row_init (GValue* value)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	value->data[0].v_pointer = NULL;
#line 179 "SavedSearchDBTable.c"
}

static void
value_saved_search_row_free_value (GValue* value)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (value->data[0].v_pointer) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		saved_search_row_unref (value->data[0].v_pointer);
#line 189 "SavedSearchDBTable.c"
	}
}

static void
value_saved_search_row_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (src_value->data[0].v_pointer) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		dest_value->data[0].v_pointer = saved_search_row_ref (src_value->data[0].v_pointer);
#line 201 "SavedSearchDBTable.c"
	} else {
#line 38 "../src/db/SavedSearchDBTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 205 "SavedSearchDBTable.c"
	}
}

static gpointer
value_saved_search_row_peek_pointer (const GValue* value)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	return value->data[0].v_pointer;
#line 214 "SavedSearchDBTable.c"
}

static gchar*
value_saved_search_row_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (collect_values[0].v_pointer) {
#line 225 "SavedSearchDBTable.c"
		SavedSearchRow * object;
		object = collect_values[0].v_pointer;
#line 38 "../src/db/SavedSearchDBTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 38 "../src/db/SavedSearchDBTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 232 "SavedSearchDBTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 38 "../src/db/SavedSearchDBTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 236 "SavedSearchDBTable.c"
		}
#line 38 "../src/db/SavedSearchDBTable.vala"
		value->data[0].v_pointer = saved_search_row_ref (object);
#line 240 "SavedSearchDBTable.c"
	} else {
#line 38 "../src/db/SavedSearchDBTable.vala"
		value->data[0].v_pointer = NULL;
#line 244 "SavedSearchDBTable.c"
	}
#line 38 "../src/db/SavedSearchDBTable.vala"
	return NULL;
#line 248 "SavedSearchDBTable.c"
}

static gchar*
value_saved_search_row_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	SavedSearchRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (!object_p) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 263 "SavedSearchDBTable.c"
	}
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (!value->data[0].v_pointer) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		*object_p = NULL;
#line 269 "SavedSearchDBTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		*object_p = value->data[0].v_pointer;
#line 273 "SavedSearchDBTable.c"
	} else {
#line 38 "../src/db/SavedSearchDBTable.vala"
		*object_p = saved_search_row_ref (value->data[0].v_pointer);
#line 277 "SavedSearchDBTable.c"
	}
#line 38 "../src/db/SavedSearchDBTable.vala"
	return NULL;
#line 281 "SavedSearchDBTable.c"
}

GParamSpec*
param_spec_saved_search_row (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecSavedSearchRow* spec;
#line 38 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SAVED_SEARCH_ROW), NULL);
#line 38 "../src/db/SavedSearchDBTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 38 "../src/db/SavedSearchDBTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 38 "../src/db/SavedSearchDBTable.vala"
	return G_PARAM_SPEC (spec);
#line 300 "SavedSearchDBTable.c"
}

gpointer
value_get_saved_search_row (const GValue* value)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SAVED_SEARCH_ROW), NULL);
#line 38 "../src/db/SavedSearchDBTable.vala"
	return value->data[0].v_pointer;
#line 310 "SavedSearchDBTable.c"
}

void
value_set_saved_search_row (GValue* value,
                            gpointer v_object)
{
	SavedSearchRow * old;
#line 38 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SAVED_SEARCH_ROW));
#line 38 "../src/db/SavedSearchDBTable.vala"
	old = value->data[0].v_pointer;
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (v_object) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SAVED_SEARCH_ROW));
#line 38 "../src/db/SavedSearchDBTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 38 "../src/db/SavedSearchDBTable.vala"
		value->data[0].v_pointer = v_object;
#line 38 "../src/db/SavedSearchDBTable.vala"
		saved_search_row_ref (value->data[0].v_pointer);
#line 332 "SavedSearchDBTable.c"
	} else {
#line 38 "../src/db/SavedSearchDBTable.vala"
		value->data[0].v_pointer = NULL;
#line 336 "SavedSearchDBTable.c"
	}
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (old) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		saved_search_row_unref (old);
#line 342 "SavedSearchDBTable.c"
	}
}

void
value_take_saved_search_row (GValue* value,
                             gpointer v_object)
{
	SavedSearchRow * old;
#line 38 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SAVED_SEARCH_ROW));
#line 38 "../src/db/SavedSearchDBTable.vala"
	old = value->data[0].v_pointer;
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (v_object) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SAVED_SEARCH_ROW));
#line 38 "../src/db/SavedSearchDBTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 38 "../src/db/SavedSearchDBTable.vala"
		value->data[0].v_pointer = v_object;
#line 363 "SavedSearchDBTable.c"
	} else {
#line 38 "../src/db/SavedSearchDBTable.vala"
		value->data[0].v_pointer = NULL;
#line 367 "SavedSearchDBTable.c"
	}
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (old) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		saved_search_row_unref (old);
#line 373 "SavedSearchDBTable.c"
	}
}

static void
saved_search_row_class_init (SavedSearchRowClass * klass,
                             gpointer klass_data)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	saved_search_row_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/db/SavedSearchDBTable.vala"
	((SavedSearchRowClass *) klass)->finalize = saved_search_row_finalize;
#line 385 "SavedSearchDBTable.c"
}

static void
saved_search_row_instance_init (SavedSearchRow * self,
                                gpointer klass)
{
#line 38 "../src/db/SavedSearchDBTable.vala"
	self->ref_count = 1;
#line 394 "SavedSearchDBTable.c"
}

static void
saved_search_row_finalize (SavedSearchRow * obj)
{
	SavedSearchRow * self;
#line 38 "../src/db/SavedSearchDBTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SAVED_SEARCH_ROW, SavedSearchRow);
#line 38 "../src/db/SavedSearchDBTable.vala"
	g_signal_handlers_destroy (self);
#line 41 "../src/db/SavedSearchDBTable.vala"
	_g_free0 (self->name);
#line 43 "../src/db/SavedSearchDBTable.vala"
	_g_object_unref0 (self->conditions);
#line 409 "SavedSearchDBTable.c"
}

static GType
saved_search_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_saved_search_row_init, value_saved_search_row_free_value, value_saved_search_row_copy_value, value_saved_search_row_peek_pointer, "p", value_saved_search_row_collect_value, "p", value_saved_search_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SavedSearchRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) saved_search_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SavedSearchRow), 0, (GInstanceInitFunc) saved_search_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType saved_search_row_type_id;
	saved_search_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SavedSearchRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return saved_search_row_type_id;
}

GType
saved_search_row_get_type (void)
{
	static volatile gsize saved_search_row_type_id__once = 0;
	if (g_once_init_enter (&saved_search_row_type_id__once)) {
		GType saved_search_row_type_id;
		saved_search_row_type_id = saved_search_row_get_type_once ();
		g_once_init_leave (&saved_search_row_type_id__once, saved_search_row_type_id);
	}
	return saved_search_row_type_id__once;
}

gpointer
saved_search_row_ref (gpointer instance)
{
	SavedSearchRow * self;
	self = instance;
#line 38 "../src/db/SavedSearchDBTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 38 "../src/db/SavedSearchDBTable.vala"
	return instance;
#line 444 "SavedSearchDBTable.c"
}

void
saved_search_row_unref (gpointer instance)
{
	SavedSearchRow * self;
	self = instance;
#line 38 "../src/db/SavedSearchDBTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 38 "../src/db/SavedSearchDBTable.vala"
		SAVED_SEARCH_ROW_GET_CLASS (self)->finalize (self);
#line 38 "../src/db/SavedSearchDBTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 458 "SavedSearchDBTable.c"
	}
}

static SavedSearchDBTable*
saved_search_db_table_construct (GType object_type)
{
	SavedSearchDBTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp11_;
	sqlite3_stmt* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp14_;
	sqlite3_stmt* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp17_;
	sqlite3_stmt* _tmp18_;
	sqlite3_stmt* _tmp19_;
	sqlite3_stmt* _tmp20_;
	sqlite3_stmt* _tmp21_;
#line 49 "../src/db/SavedSearchDBTable.vala"
	self = (SavedSearchDBTable*) database_table_construct (object_type);
#line 50 "../src/db/SavedSearchDBTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "SavedSearchDBTable");
#line 53 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS " "SavedSearchDBTable " "(" "id INTEGER PRIMARY KEY, " "name TEXT UNIQUE NOT NULL, " "operator TEXT NOT NULL" ")");
#line 53 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp0_;
#line 62 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = stmt;
#line 62 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp1_);
#line 63 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 64 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable", res);
#line 506 "SavedSearchDBTable.c"
	}
#line 67 "../src/db/SavedSearchDBTable.vala"
	_tmp2_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS " "SavedSearchDBTable_Text " "(" "id INTEGER PRIMARY KEY, " "search_id INTEGER NOT NULL, " "search_type TEXT NOT NULL, " "context TEXT NOT NULL, " "text TEXT" ")");
#line 67 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 67 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp2_;
#line 76 "../src/db/SavedSearchDBTable.vala"
	_tmp3_ = stmt;
#line 76 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp3_);
#line 77 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 78 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_Text", res);
#line 522 "SavedSearchDBTable.c"
	}
#line 81 "../src/db/SavedSearchDBTable.vala"
	_tmp4_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS " "SavedSearchDBTable_MediaType " "(" "id INTEGER PRIMARY KEY, " "search_id INTEGER NOT NULL, " "search_type TEXT NOT NULL, " "context TEXT NOT NULL, " "type TEXT NOT_NULL" ")");
#line 81 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 81 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp4_;
#line 91 "../src/db/SavedSearchDBTable.vala"
	_tmp5_ = stmt;
#line 91 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp5_);
#line 92 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 93 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_MediaType", res);
#line 538 "SavedSearchDBTable.c"
	}
#line 96 "../src/db/SavedSearchDBTable.vala"
	_tmp6_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS " "SavedSearchDBTable_Flagged " "(" "id INTEGER PRIMARY KEY, " "search_id INTEGER NOT NULL, " "search_type TEXT NOT NULL, " "flag_state TEXT NOT NULL" ")");
#line 96 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 96 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp6_;
#line 105 "../src/db/SavedSearchDBTable.vala"
	_tmp7_ = stmt;
#line 105 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp7_);
#line 106 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 107 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_Flagged", res);
#line 554 "SavedSearchDBTable.c"
	}
#line 110 "../src/db/SavedSearchDBTable.vala"
	_tmp8_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS " "SavedSearchDBTable_Modified " "(" "id INTEGER PRIMARY KEY, " "search_id INTEGER NOT NULL, " "search_type TEXT NOT NULL, " "context TEXT NOT NULL, " "modified_state TEXT NOT NULL" ")");
#line 110 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 110 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp8_;
#line 120 "../src/db/SavedSearchDBTable.vala"
	_tmp9_ = stmt;
#line 120 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp9_);
#line 121 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 122 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_Modified", res);
#line 570 "SavedSearchDBTable.c"
	}
#line 125 "../src/db/SavedSearchDBTable.vala"
	_tmp10_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS " "SavedSearchDBTable_Date " "(" "id INTEGER PRIMARY KEY, " "search_id INTEGER NOT NULL, " "search_type TEXT NOT NULL, " "context TEXT NOT NULL, " "date_one INTEGER NOT_NULL, " "date_two INTEGER NOT_NULL" ")");
#line 125 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 125 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp10_;
#line 136 "../src/db/SavedSearchDBTable.vala"
	_tmp11_ = stmt;
#line 136 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp11_);
#line 137 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 138 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_Date", res);
#line 586 "SavedSearchDBTable.c"
	}
#line 140 "../src/db/SavedSearchDBTable.vala"
	_tmp12_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS " "SavedSearchDBTable_Date_Index " "ON SavedSearchDBTable_Date(search_id)");
#line 140 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 140 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp12_;
#line 144 "../src/db/SavedSearchDBTable.vala"
	_tmp13_ = stmt;
#line 144 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp13_);
#line 146 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 147 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_Date_Index", res);
#line 602 "SavedSearchDBTable.c"
	}
#line 150 "../src/db/SavedSearchDBTable.vala"
	_tmp14_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS " "SavedSearchDBTable_Text_Index " "ON SavedSearchDBTable_Text(search_id)");
#line 150 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 150 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp14_;
#line 153 "../src/db/SavedSearchDBTable.vala"
	_tmp15_ = stmt;
#line 153 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp15_);
#line 154 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 155 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_Text_Index", res);
#line 618 "SavedSearchDBTable.c"
	}
#line 157 "../src/db/SavedSearchDBTable.vala"
	_tmp16_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS " "SavedSearchDBTable_MediaType_Index " "ON SavedSearchDBTable_MediaType(search_id)");
#line 157 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 157 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp16_;
#line 160 "../src/db/SavedSearchDBTable.vala"
	_tmp17_ = stmt;
#line 160 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp17_);
#line 161 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 162 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_MediaType_Index", res);
#line 634 "SavedSearchDBTable.c"
	}
#line 164 "../src/db/SavedSearchDBTable.vala"
	_tmp18_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS " "SavedSearchDBTable_Flagged_Index " "ON SavedSearchDBTable_Flagged(search_id)");
#line 164 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 164 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp18_;
#line 167 "../src/db/SavedSearchDBTable.vala"
	_tmp19_ = stmt;
#line 167 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp19_);
#line 168 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 169 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_Flagged_Index", res);
#line 650 "SavedSearchDBTable.c"
	}
#line 171 "../src/db/SavedSearchDBTable.vala"
	_tmp20_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS " "SavedSearchDBTable_Modified_Index " "ON SavedSearchDBTable_Modified(search_id)");
#line 171 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 171 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp20_;
#line 174 "../src/db/SavedSearchDBTable.vala"
	_tmp21_ = stmt;
#line 174 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp21_);
#line 176 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 177 "../src/db/SavedSearchDBTable.vala"
		database_table_fatal ("create SavedSearchDBTable_Modified_Index", res);
#line 666 "SavedSearchDBTable.c"
	}
#line 49 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 49 "../src/db/SavedSearchDBTable.vala"
	return self;
#line 672 "SavedSearchDBTable.c"
}

static SavedSearchDBTable*
saved_search_db_table_new (void)
{
#line 49 "../src/db/SavedSearchDBTable.vala"
	return saved_search_db_table_construct (TYPE_SAVED_SEARCH_DB_TABLE);
#line 680 "SavedSearchDBTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 184 "../src/db/SavedSearchDBTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 688 "SavedSearchDBTable.c"
}

SavedSearchDBTable*
saved_search_db_table_get_instance (void)
{
	SavedSearchDBTable* _tmp0_;
	SavedSearchDBTable* _tmp2_;
	SavedSearchDBTable* _tmp3_;
	SavedSearchDBTable* result;
#line 181 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = saved_search_db_table_instance;
#line 181 "../src/db/SavedSearchDBTable.vala"
	if (_tmp0_ == NULL) {
#line 702 "SavedSearchDBTable.c"
		SavedSearchDBTable* _tmp1_;
#line 182 "../src/db/SavedSearchDBTable.vala"
		_tmp1_ = saved_search_db_table_new ();
#line 182 "../src/db/SavedSearchDBTable.vala"
		_database_table_unref0 (saved_search_db_table_instance);
#line 182 "../src/db/SavedSearchDBTable.vala"
		saved_search_db_table_instance = _tmp1_;
#line 710 "SavedSearchDBTable.c"
	}
#line 184 "../src/db/SavedSearchDBTable.vala"
	_tmp2_ = saved_search_db_table_instance;
#line 184 "../src/db/SavedSearchDBTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 184 "../src/db/SavedSearchDBTable.vala"
	result = _tmp3_;
#line 184 "../src/db/SavedSearchDBTable.vala"
	return result;
#line 720 "SavedSearchDBTable.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 202 "../src/db/SavedSearchDBTable.vala"
	return self ? g_object_ref (self) : NULL;
#line 728 "SavedSearchDBTable.c"
}

SavedSearchRow*
saved_search_db_table_add (SavedSearchDBTable* self,
                           const gchar* name,
                           SearchOperator operator,
                           GeeArrayList* conditions,
                           GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint res = 0;
	sqlite3_stmt* _tmp5_;
	SavedSearchRow* row = NULL;
	SavedSearchRow* _tmp6_;
	SavedSearchRow* _tmp7_;
	sqlite3* _tmp8_;
	SavedSearchRow* _tmp9_;
	gchar* _tmp10_;
	SavedSearchRow* _tmp11_;
	SavedSearchRow* _tmp12_;
	GeeList* _tmp13_;
	GError* _inner_error0_ = NULL;
	SavedSearchRow* result;
#line 187 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 187 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (conditions != NULL, NULL);
#line 189 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO SavedSearchDBTable (name, operator) VALUES (?, ?)");
#line 189 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp0_;
#line 191 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = stmt;
#line 191 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_text (_tmp1_, 1, name);
#line 192 "../src/db/SavedSearchDBTable.vala"
	_tmp2_ = stmt;
#line 192 "../src/db/SavedSearchDBTable.vala"
	_tmp3_ = search_operator_to_string (operator);
#line 192 "../src/db/SavedSearchDBTable.vala"
	_tmp4_ = _tmp3_;
#line 192 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_text (_tmp2_, 2, _tmp4_);
#line 192 "../src/db/SavedSearchDBTable.vala"
	_g_free0 (_tmp4_);
#line 194 "../src/db/SavedSearchDBTable.vala"
	_tmp5_ = stmt;
#line 194 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp5_);
#line 195 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 196 "../src/db/SavedSearchDBTable.vala"
		database_table_throw_error ("SavedSearchDBTable.add", res, &_inner_error0_);
#line 196 "../src/db/SavedSearchDBTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/db/SavedSearchDBTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 196 "../src/db/SavedSearchDBTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 196 "../src/db/SavedSearchDBTable.vala"
				_sqlite3_finalize0 (stmt);
#line 196 "../src/db/SavedSearchDBTable.vala"
				return NULL;
#line 799 "SavedSearchDBTable.c"
			} else {
#line 196 "../src/db/SavedSearchDBTable.vala"
				_sqlite3_finalize0 (stmt);
#line 196 "../src/db/SavedSearchDBTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "../src/db/SavedSearchDBTable.vala"
				g_clear_error (&_inner_error0_);
#line 196 "../src/db/SavedSearchDBTable.vala"
				return NULL;
#line 809 "SavedSearchDBTable.c"
			}
		}
	}
#line 198 "../src/db/SavedSearchDBTable.vala"
	_tmp6_ = saved_search_row_new ();
#line 198 "../src/db/SavedSearchDBTable.vala"
	row = _tmp6_;
#line 199 "../src/db/SavedSearchDBTable.vala"
	_tmp7_ = row;
#line 199 "../src/db/SavedSearchDBTable.vala"
	_tmp8_ = database_table_db;
#line 199 "../src/db/SavedSearchDBTable.vala"
	saved_search_id_init (&_tmp7_->search_id, sqlite3_last_insert_rowid (_tmp8_));
#line 200 "../src/db/SavedSearchDBTable.vala"
	_tmp9_ = row;
#line 200 "../src/db/SavedSearchDBTable.vala"
	_tmp10_ = g_strdup (name);
#line 200 "../src/db/SavedSearchDBTable.vala"
	_g_free0 (_tmp9_->name);
#line 200 "../src/db/SavedSearchDBTable.vala"
	_tmp9_->name = _tmp10_;
#line 201 "../src/db/SavedSearchDBTable.vala"
	_tmp11_ = row;
#line 201 "../src/db/SavedSearchDBTable.vala"
	_tmp11_->operator = operator;
#line 202 "../src/db/SavedSearchDBTable.vala"
	_tmp12_ = row;
#line 202 "../src/db/SavedSearchDBTable.vala"
	_tmp13_ = _g_object_ref0 ((GeeList*) conditions);
#line 202 "../src/db/SavedSearchDBTable.vala"
	_g_object_unref0 (_tmp12_->conditions);
#line 202 "../src/db/SavedSearchDBTable.vala"
	_tmp12_->conditions = _tmp13_;
#line 843 "SavedSearchDBTable.c"
	{
		GeeArrayList* _sc_list = NULL;
		gint _sc_size = 0;
		GeeArrayList* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _sc_index = 0;
#line 204 "../src/db/SavedSearchDBTable.vala"
		_sc_list = conditions;
#line 204 "../src/db/SavedSearchDBTable.vala"
		_tmp14_ = _sc_list;
#line 204 "../src/db/SavedSearchDBTable.vala"
		_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 204 "../src/db/SavedSearchDBTable.vala"
		_tmp16_ = _tmp15_;
#line 204 "../src/db/SavedSearchDBTable.vala"
		_sc_size = _tmp16_;
#line 204 "../src/db/SavedSearchDBTable.vala"
		_sc_index = -1;
#line 204 "../src/db/SavedSearchDBTable.vala"
		while (TRUE) {
#line 865 "SavedSearchDBTable.c"
			gint _tmp17_;
			gint _tmp18_;
			SearchCondition* sc = NULL;
			GeeArrayList* _tmp19_;
			gpointer _tmp20_;
			SavedSearchRow* _tmp21_;
			SavedSearchID _tmp22_;
			SearchCondition* _tmp23_;
#line 204 "../src/db/SavedSearchDBTable.vala"
			_sc_index = _sc_index + 1;
#line 204 "../src/db/SavedSearchDBTable.vala"
			_tmp17_ = _sc_index;
#line 204 "../src/db/SavedSearchDBTable.vala"
			_tmp18_ = _sc_size;
#line 204 "../src/db/SavedSearchDBTable.vala"
			if (!(_tmp17_ < _tmp18_)) {
#line 204 "../src/db/SavedSearchDBTable.vala"
				break;
#line 884 "SavedSearchDBTable.c"
			}
#line 204 "../src/db/SavedSearchDBTable.vala"
			_tmp19_ = _sc_list;
#line 204 "../src/db/SavedSearchDBTable.vala"
			_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _sc_index);
#line 204 "../src/db/SavedSearchDBTable.vala"
			sc = (SearchCondition*) _tmp20_;
#line 205 "../src/db/SavedSearchDBTable.vala"
			_tmp21_ = row;
#line 205 "../src/db/SavedSearchDBTable.vala"
			_tmp22_ = _tmp21_->search_id;
#line 205 "../src/db/SavedSearchDBTable.vala"
			_tmp23_ = sc;
#line 205 "../src/db/SavedSearchDBTable.vala"
			saved_search_db_table_add_condition (self, &_tmp22_, _tmp23_, &_inner_error0_);
#line 205 "../src/db/SavedSearchDBTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "../src/db/SavedSearchDBTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 205 "../src/db/SavedSearchDBTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 205 "../src/db/SavedSearchDBTable.vala"
					_search_condition_unref0 (sc);
#line 205 "../src/db/SavedSearchDBTable.vala"
					_saved_search_row_unref0 (row);
#line 205 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 205 "../src/db/SavedSearchDBTable.vala"
					return NULL;
#line 914 "SavedSearchDBTable.c"
				} else {
#line 205 "../src/db/SavedSearchDBTable.vala"
					_search_condition_unref0 (sc);
#line 205 "../src/db/SavedSearchDBTable.vala"
					_saved_search_row_unref0 (row);
#line 205 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 205 "../src/db/SavedSearchDBTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 205 "../src/db/SavedSearchDBTable.vala"
					g_clear_error (&_inner_error0_);
#line 205 "../src/db/SavedSearchDBTable.vala"
					return NULL;
#line 928 "SavedSearchDBTable.c"
				}
			}
#line 204 "../src/db/SavedSearchDBTable.vala"
			_search_condition_unref0 (sc);
#line 933 "SavedSearchDBTable.c"
		}
	}
#line 208 "../src/db/SavedSearchDBTable.vala"
	result = row;
#line 208 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 208 "../src/db/SavedSearchDBTable.vala"
	return result;
#line 942 "SavedSearchDBTable.c"
}

static gpointer
_search_condition_ref0 (gpointer self)
{
#line 213 "../src/db/SavedSearchDBTable.vala"
	return self ? search_condition_ref (self) : NULL;
#line 950 "SavedSearchDBTable.c"
}

static void
saved_search_db_table_add_condition (SavedSearchDBTable* self,
                                     SavedSearchID* id,
                                     SearchCondition* condition,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 211 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (id != NULL);
#line 211 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (condition != NULL);
#line 212 "../src/db/SavedSearchDBTable.vala"
	if (IS_SEARCH_CONDITION_TEXT (condition)) {
#line 968 "SavedSearchDBTable.c"
		SearchConditionText* text = NULL;
		SearchConditionText* _tmp0_;
		sqlite3_stmt* stmt = NULL;
		sqlite3_stmt* _tmp1_;
		sqlite3_stmt* _tmp2_;
		SavedSearchID _tmp3_;
		sqlite3_stmt* _tmp4_;
		SearchConditionText* _tmp5_;
		SearchConditionSearchType _tmp6_;
		SearchConditionSearchType _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		sqlite3_stmt* _tmp10_;
		SearchConditionText* _tmp11_;
		SearchConditionTextContext _tmp12_;
		SearchConditionTextContext _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		sqlite3_stmt* _tmp16_;
		SearchConditionText* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gint res = 0;
		sqlite3_stmt* _tmp20_;
#line 213 "../src/db/SavedSearchDBTable.vala"
		_tmp0_ = _search_condition_ref0 (IS_SEARCH_CONDITION_TEXT (condition) ? ((SearchConditionText*) condition) : NULL);
#line 213 "../src/db/SavedSearchDBTable.vala"
		text = _tmp0_;
#line 215 "../src/db/SavedSearchDBTable.vala"
		_tmp1_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO SavedSearchDBTable_Text (search_id, search_type, context, " "text) VALUES (?, ?, ?, ?)");
#line 215 "../src/db/SavedSearchDBTable.vala"
		stmt = _tmp1_;
#line 218 "../src/db/SavedSearchDBTable.vala"
		_tmp2_ = stmt;
#line 218 "../src/db/SavedSearchDBTable.vala"
		_tmp3_ = *id;
#line 218 "../src/db/SavedSearchDBTable.vala"
		database_table_bind_int64 (_tmp2_, 1, _tmp3_.id);
#line 219 "../src/db/SavedSearchDBTable.vala"
		_tmp4_ = stmt;
#line 219 "../src/db/SavedSearchDBTable.vala"
		_tmp5_ = text;
#line 219 "../src/db/SavedSearchDBTable.vala"
		_tmp6_ = search_condition_get_search_type ((SearchCondition*) _tmp5_);
#line 219 "../src/db/SavedSearchDBTable.vala"
		_tmp7_ = _tmp6_;
#line 219 "../src/db/SavedSearchDBTable.vala"
		_tmp8_ = search_condition_search_type_to_string (_tmp7_);
#line 219 "../src/db/SavedSearchDBTable.vala"
		_tmp9_ = _tmp8_;
#line 219 "../src/db/SavedSearchDBTable.vala"
		database_table_bind_text (_tmp4_, 2, _tmp9_);
#line 219 "../src/db/SavedSearchDBTable.vala"
		_g_free0 (_tmp9_);
#line 220 "../src/db/SavedSearchDBTable.vala"
		_tmp10_ = stmt;
#line 220 "../src/db/SavedSearchDBTable.vala"
		_tmp11_ = text;
#line 220 "../src/db/SavedSearchDBTable.vala"
		_tmp12_ = search_condition_text_get_context (_tmp11_);
#line 220 "../src/db/SavedSearchDBTable.vala"
		_tmp13_ = _tmp12_;
#line 220 "../src/db/SavedSearchDBTable.vala"
		_tmp14_ = search_condition_text_context_to_string (_tmp13_);
#line 220 "../src/db/SavedSearchDBTable.vala"
		_tmp15_ = _tmp14_;
#line 220 "../src/db/SavedSearchDBTable.vala"
		database_table_bind_text (_tmp10_, 3, _tmp15_);
#line 220 "../src/db/SavedSearchDBTable.vala"
		_g_free0 (_tmp15_);
#line 221 "../src/db/SavedSearchDBTable.vala"
		_tmp16_ = stmt;
#line 221 "../src/db/SavedSearchDBTable.vala"
		_tmp17_ = text;
#line 221 "../src/db/SavedSearchDBTable.vala"
		_tmp18_ = search_condition_text_get_text (_tmp17_);
#line 221 "../src/db/SavedSearchDBTable.vala"
		_tmp19_ = _tmp18_;
#line 221 "../src/db/SavedSearchDBTable.vala"
		database_table_bind_text (_tmp16_, 4, _tmp19_);
#line 223 "../src/db/SavedSearchDBTable.vala"
		_tmp20_ = stmt;
#line 223 "../src/db/SavedSearchDBTable.vala"
		res = sqlite3_step (_tmp20_);
#line 224 "../src/db/SavedSearchDBTable.vala"
		if (res != SQLITE_DONE) {
#line 225 "../src/db/SavedSearchDBTable.vala"
			database_table_throw_error ("SavedSearchDBTable_Text.add", res, &_inner_error0_);
#line 225 "../src/db/SavedSearchDBTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/db/SavedSearchDBTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 225 "../src/db/SavedSearchDBTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 225 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 225 "../src/db/SavedSearchDBTable.vala"
					_search_condition_unref0 (text);
#line 225 "../src/db/SavedSearchDBTable.vala"
					return;
#line 1069 "SavedSearchDBTable.c"
				} else {
#line 225 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 225 "../src/db/SavedSearchDBTable.vala"
					_search_condition_unref0 (text);
#line 225 "../src/db/SavedSearchDBTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 225 "../src/db/SavedSearchDBTable.vala"
					g_clear_error (&_inner_error0_);
#line 225 "../src/db/SavedSearchDBTable.vala"
					return;
#line 1081 "SavedSearchDBTable.c"
				}
			}
		}
#line 212 "../src/db/SavedSearchDBTable.vala"
		_sqlite3_finalize0 (stmt);
#line 212 "../src/db/SavedSearchDBTable.vala"
		_search_condition_unref0 (text);
#line 1089 "SavedSearchDBTable.c"
	} else {
#line 226 "../src/db/SavedSearchDBTable.vala"
		if (IS_SEARCH_CONDITION_MEDIA_TYPE (condition)) {
#line 1093 "SavedSearchDBTable.c"
			SearchConditionMediaType* media_type = NULL;
			SearchConditionMediaType* _tmp21_;
			sqlite3_stmt* stmt = NULL;
			sqlite3_stmt* _tmp22_;
			sqlite3_stmt* _tmp23_;
			SavedSearchID _tmp24_;
			sqlite3_stmt* _tmp25_;
			SearchConditionMediaType* _tmp26_;
			SearchConditionSearchType _tmp27_;
			SearchConditionSearchType _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			sqlite3_stmt* _tmp31_;
			SearchConditionMediaType* _tmp32_;
			SearchConditionMediaTypeContext _tmp33_;
			SearchConditionMediaTypeContext _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			sqlite3_stmt* _tmp37_;
			SearchConditionMediaType* _tmp38_;
			SearchConditionMediaTypeMediaType _tmp39_;
			SearchConditionMediaTypeMediaType _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gint res = 0;
			sqlite3_stmt* _tmp43_;
#line 227 "../src/db/SavedSearchDBTable.vala"
			_tmp21_ = _search_condition_ref0 (IS_SEARCH_CONDITION_MEDIA_TYPE (condition) ? ((SearchConditionMediaType*) condition) : NULL);
#line 227 "../src/db/SavedSearchDBTable.vala"
			media_type = _tmp21_;
#line 228 "../src/db/SavedSearchDBTable.vala"
			_tmp22_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO SavedSearchDBTable_MediaType (search_id, search_type, cont" \
"ext, " "type) VALUES (?, ?, ?, ?)");
#line 228 "../src/db/SavedSearchDBTable.vala"
			stmt = _tmp22_;
#line 231 "../src/db/SavedSearchDBTable.vala"
			_tmp23_ = stmt;
#line 231 "../src/db/SavedSearchDBTable.vala"
			_tmp24_ = *id;
#line 231 "../src/db/SavedSearchDBTable.vala"
			database_table_bind_int64 (_tmp23_, 1, _tmp24_.id);
#line 232 "../src/db/SavedSearchDBTable.vala"
			_tmp25_ = stmt;
#line 232 "../src/db/SavedSearchDBTable.vala"
			_tmp26_ = media_type;
#line 232 "../src/db/SavedSearchDBTable.vala"
			_tmp27_ = search_condition_get_search_type ((SearchCondition*) _tmp26_);
#line 232 "../src/db/SavedSearchDBTable.vala"
			_tmp28_ = _tmp27_;
#line 232 "../src/db/SavedSearchDBTable.vala"
			_tmp29_ = search_condition_search_type_to_string (_tmp28_);
#line 232 "../src/db/SavedSearchDBTable.vala"
			_tmp30_ = _tmp29_;
#line 232 "../src/db/SavedSearchDBTable.vala"
			database_table_bind_text (_tmp25_, 2, _tmp30_);
#line 232 "../src/db/SavedSearchDBTable.vala"
			_g_free0 (_tmp30_);
#line 233 "../src/db/SavedSearchDBTable.vala"
			_tmp31_ = stmt;
#line 233 "../src/db/SavedSearchDBTable.vala"
			_tmp32_ = media_type;
#line 233 "../src/db/SavedSearchDBTable.vala"
			_tmp33_ = search_condition_media_type_get_context (_tmp32_);
#line 233 "../src/db/SavedSearchDBTable.vala"
			_tmp34_ = _tmp33_;
#line 233 "../src/db/SavedSearchDBTable.vala"
			_tmp35_ = search_condition_media_type_context_to_string (_tmp34_);
#line 233 "../src/db/SavedSearchDBTable.vala"
			_tmp36_ = _tmp35_;
#line 233 "../src/db/SavedSearchDBTable.vala"
			database_table_bind_text (_tmp31_, 3, _tmp36_);
#line 233 "../src/db/SavedSearchDBTable.vala"
			_g_free0 (_tmp36_);
#line 234 "../src/db/SavedSearchDBTable.vala"
			_tmp37_ = stmt;
#line 234 "../src/db/SavedSearchDBTable.vala"
			_tmp38_ = media_type;
#line 234 "../src/db/SavedSearchDBTable.vala"
			_tmp39_ = search_condition_media_type_get_media_type (_tmp38_);
#line 234 "../src/db/SavedSearchDBTable.vala"
			_tmp40_ = _tmp39_;
#line 234 "../src/db/SavedSearchDBTable.vala"
			_tmp41_ = search_condition_media_type_media_type_to_string (_tmp40_);
#line 234 "../src/db/SavedSearchDBTable.vala"
			_tmp42_ = _tmp41_;
#line 234 "../src/db/SavedSearchDBTable.vala"
			database_table_bind_text (_tmp37_, 4, _tmp42_);
#line 234 "../src/db/SavedSearchDBTable.vala"
			_g_free0 (_tmp42_);
#line 236 "../src/db/SavedSearchDBTable.vala"
			_tmp43_ = stmt;
#line 236 "../src/db/SavedSearchDBTable.vala"
			res = sqlite3_step (_tmp43_);
#line 237 "../src/db/SavedSearchDBTable.vala"
			if (res != SQLITE_DONE) {
#line 238 "../src/db/SavedSearchDBTable.vala"
				database_table_throw_error ("SavedSearchDBTable_MediaType.add", res, &_inner_error0_);
#line 238 "../src/db/SavedSearchDBTable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 238 "../src/db/SavedSearchDBTable.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 238 "../src/db/SavedSearchDBTable.vala"
						g_propagate_error (error, _inner_error0_);
#line 238 "../src/db/SavedSearchDBTable.vala"
						_sqlite3_finalize0 (stmt);
#line 238 "../src/db/SavedSearchDBTable.vala"
						_search_condition_unref0 (media_type);
#line 238 "../src/db/SavedSearchDBTable.vala"
						return;
#line 1202 "SavedSearchDBTable.c"
					} else {
#line 238 "../src/db/SavedSearchDBTable.vala"
						_sqlite3_finalize0 (stmt);
#line 238 "../src/db/SavedSearchDBTable.vala"
						_search_condition_unref0 (media_type);
#line 238 "../src/db/SavedSearchDBTable.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 238 "../src/db/SavedSearchDBTable.vala"
						g_clear_error (&_inner_error0_);
#line 238 "../src/db/SavedSearchDBTable.vala"
						return;
#line 1214 "SavedSearchDBTable.c"
					}
				}
			}
#line 226 "../src/db/SavedSearchDBTable.vala"
			_sqlite3_finalize0 (stmt);
#line 226 "../src/db/SavedSearchDBTable.vala"
			_search_condition_unref0 (media_type);
#line 1222 "SavedSearchDBTable.c"
		} else {
#line 239 "../src/db/SavedSearchDBTable.vala"
			if (IS_SEARCH_CONDITION_FLAGGED (condition)) {
#line 1226 "SavedSearchDBTable.c"
				SearchConditionFlagged* flag_state = NULL;
				SearchConditionFlagged* _tmp44_;
				sqlite3_stmt* stmt = NULL;
				sqlite3_stmt* _tmp45_;
				sqlite3_stmt* _tmp46_;
				SavedSearchID _tmp47_;
				sqlite3_stmt* _tmp48_;
				SearchConditionFlagged* _tmp49_;
				SearchConditionSearchType _tmp50_;
				SearchConditionSearchType _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				sqlite3_stmt* _tmp54_;
				SearchConditionFlagged* _tmp55_;
				SearchConditionFlaggedState _tmp56_;
				SearchConditionFlaggedState _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gint res = 0;
				sqlite3_stmt* _tmp60_;
#line 240 "../src/db/SavedSearchDBTable.vala"
				_tmp44_ = _search_condition_ref0 (IS_SEARCH_CONDITION_FLAGGED (condition) ? ((SearchConditionFlagged*) condition) : NULL);
#line 240 "../src/db/SavedSearchDBTable.vala"
				flag_state = _tmp44_;
#line 241 "../src/db/SavedSearchDBTable.vala"
				_tmp45_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO SavedSearchDBTable_Flagged (search_id, search_type, " "flag_state) VALUES (?, ?, ?)");
#line 241 "../src/db/SavedSearchDBTable.vala"
				stmt = _tmp45_;
#line 244 "../src/db/SavedSearchDBTable.vala"
				_tmp46_ = stmt;
#line 244 "../src/db/SavedSearchDBTable.vala"
				_tmp47_ = *id;
#line 244 "../src/db/SavedSearchDBTable.vala"
				database_table_bind_int64 (_tmp46_, 1, _tmp47_.id);
#line 245 "../src/db/SavedSearchDBTable.vala"
				_tmp48_ = stmt;
#line 245 "../src/db/SavedSearchDBTable.vala"
				_tmp49_ = flag_state;
#line 245 "../src/db/SavedSearchDBTable.vala"
				_tmp50_ = search_condition_get_search_type ((SearchCondition*) _tmp49_);
#line 245 "../src/db/SavedSearchDBTable.vala"
				_tmp51_ = _tmp50_;
#line 245 "../src/db/SavedSearchDBTable.vala"
				_tmp52_ = search_condition_search_type_to_string (_tmp51_);
#line 245 "../src/db/SavedSearchDBTable.vala"
				_tmp53_ = _tmp52_;
#line 245 "../src/db/SavedSearchDBTable.vala"
				database_table_bind_text (_tmp48_, 2, _tmp53_);
#line 245 "../src/db/SavedSearchDBTable.vala"
				_g_free0 (_tmp53_);
#line 246 "../src/db/SavedSearchDBTable.vala"
				_tmp54_ = stmt;
#line 246 "../src/db/SavedSearchDBTable.vala"
				_tmp55_ = flag_state;
#line 246 "../src/db/SavedSearchDBTable.vala"
				_tmp56_ = search_condition_flagged_get_state (_tmp55_);
#line 246 "../src/db/SavedSearchDBTable.vala"
				_tmp57_ = _tmp56_;
#line 246 "../src/db/SavedSearchDBTable.vala"
				_tmp58_ = search_condition_flagged_state_to_string (_tmp57_);
#line 246 "../src/db/SavedSearchDBTable.vala"
				_tmp59_ = _tmp58_;
#line 246 "../src/db/SavedSearchDBTable.vala"
				database_table_bind_text (_tmp54_, 3, _tmp59_);
#line 246 "../src/db/SavedSearchDBTable.vala"
				_g_free0 (_tmp59_);
#line 248 "../src/db/SavedSearchDBTable.vala"
				_tmp60_ = stmt;
#line 248 "../src/db/SavedSearchDBTable.vala"
				res = sqlite3_step (_tmp60_);
#line 249 "../src/db/SavedSearchDBTable.vala"
				if (res != SQLITE_DONE) {
#line 250 "../src/db/SavedSearchDBTable.vala"
					database_table_throw_error ("SavedSearchDBTable_Flagged.add", res, &_inner_error0_);
#line 250 "../src/db/SavedSearchDBTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../src/db/SavedSearchDBTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 250 "../src/db/SavedSearchDBTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 250 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 250 "../src/db/SavedSearchDBTable.vala"
							_search_condition_unref0 (flag_state);
#line 250 "../src/db/SavedSearchDBTable.vala"
							return;
#line 1313 "SavedSearchDBTable.c"
						} else {
#line 250 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 250 "../src/db/SavedSearchDBTable.vala"
							_search_condition_unref0 (flag_state);
#line 250 "../src/db/SavedSearchDBTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 250 "../src/db/SavedSearchDBTable.vala"
							g_clear_error (&_inner_error0_);
#line 250 "../src/db/SavedSearchDBTable.vala"
							return;
#line 1325 "SavedSearchDBTable.c"
						}
					}
				}
#line 239 "../src/db/SavedSearchDBTable.vala"
				_sqlite3_finalize0 (stmt);
#line 239 "../src/db/SavedSearchDBTable.vala"
				_search_condition_unref0 (flag_state);
#line 1333 "SavedSearchDBTable.c"
			} else {
#line 251 "../src/db/SavedSearchDBTable.vala"
				if (IS_SEARCH_CONDITION_MODIFIED (condition)) {
#line 1337 "SavedSearchDBTable.c"
					SearchConditionModified* modified_state = NULL;
					SearchConditionModified* _tmp61_;
					sqlite3_stmt* stmt = NULL;
					sqlite3_stmt* _tmp62_;
					sqlite3_stmt* _tmp63_;
					SavedSearchID _tmp64_;
					sqlite3_stmt* _tmp65_;
					SearchConditionModified* _tmp66_;
					SearchConditionSearchType _tmp67_;
					SearchConditionSearchType _tmp68_;
					gchar* _tmp69_;
					gchar* _tmp70_;
					sqlite3_stmt* _tmp71_;
					SearchConditionModified* _tmp72_;
					SearchConditionModifiedContext _tmp73_;
					SearchConditionModifiedContext _tmp74_;
					gchar* _tmp75_;
					gchar* _tmp76_;
					sqlite3_stmt* _tmp77_;
					SearchConditionModified* _tmp78_;
					SearchConditionModifiedState _tmp79_;
					SearchConditionModifiedState _tmp80_;
					gchar* _tmp81_;
					gchar* _tmp82_;
					gint res = 0;
					sqlite3_stmt* _tmp83_;
#line 252 "../src/db/SavedSearchDBTable.vala"
					_tmp61_ = _search_condition_ref0 (IS_SEARCH_CONDITION_MODIFIED (condition) ? ((SearchConditionModified*) condition) : NULL);
#line 252 "../src/db/SavedSearchDBTable.vala"
					modified_state = _tmp61_;
#line 253 "../src/db/SavedSearchDBTable.vala"
					_tmp62_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO SavedSearchDBTable_Modified (search_id, search_type, conte" \
"xt, " "modified_state) VALUES (?, ?, ?, ?)");
#line 253 "../src/db/SavedSearchDBTable.vala"
					stmt = _tmp62_;
#line 256 "../src/db/SavedSearchDBTable.vala"
					_tmp63_ = stmt;
#line 256 "../src/db/SavedSearchDBTable.vala"
					_tmp64_ = *id;
#line 256 "../src/db/SavedSearchDBTable.vala"
					database_table_bind_int64 (_tmp63_, 1, _tmp64_.id);
#line 257 "../src/db/SavedSearchDBTable.vala"
					_tmp65_ = stmt;
#line 257 "../src/db/SavedSearchDBTable.vala"
					_tmp66_ = modified_state;
#line 257 "../src/db/SavedSearchDBTable.vala"
					_tmp67_ = search_condition_get_search_type ((SearchCondition*) _tmp66_);
#line 257 "../src/db/SavedSearchDBTable.vala"
					_tmp68_ = _tmp67_;
#line 257 "../src/db/SavedSearchDBTable.vala"
					_tmp69_ = search_condition_search_type_to_string (_tmp68_);
#line 257 "../src/db/SavedSearchDBTable.vala"
					_tmp70_ = _tmp69_;
#line 257 "../src/db/SavedSearchDBTable.vala"
					database_table_bind_text (_tmp65_, 2, _tmp70_);
#line 257 "../src/db/SavedSearchDBTable.vala"
					_g_free0 (_tmp70_);
#line 258 "../src/db/SavedSearchDBTable.vala"
					_tmp71_ = stmt;
#line 258 "../src/db/SavedSearchDBTable.vala"
					_tmp72_ = modified_state;
#line 258 "../src/db/SavedSearchDBTable.vala"
					_tmp73_ = search_condition_modified_get_context (_tmp72_);
#line 258 "../src/db/SavedSearchDBTable.vala"
					_tmp74_ = _tmp73_;
#line 258 "../src/db/SavedSearchDBTable.vala"
					_tmp75_ = search_condition_modified_context_to_string (_tmp74_);
#line 258 "../src/db/SavedSearchDBTable.vala"
					_tmp76_ = _tmp75_;
#line 258 "../src/db/SavedSearchDBTable.vala"
					database_table_bind_text (_tmp71_, 3, _tmp76_);
#line 258 "../src/db/SavedSearchDBTable.vala"
					_g_free0 (_tmp76_);
#line 259 "../src/db/SavedSearchDBTable.vala"
					_tmp77_ = stmt;
#line 259 "../src/db/SavedSearchDBTable.vala"
					_tmp78_ = modified_state;
#line 259 "../src/db/SavedSearchDBTable.vala"
					_tmp79_ = search_condition_modified_get_state (_tmp78_);
#line 259 "../src/db/SavedSearchDBTable.vala"
					_tmp80_ = _tmp79_;
#line 259 "../src/db/SavedSearchDBTable.vala"
					_tmp81_ = search_condition_modified_state_to_string (_tmp80_);
#line 259 "../src/db/SavedSearchDBTable.vala"
					_tmp82_ = _tmp81_;
#line 259 "../src/db/SavedSearchDBTable.vala"
					database_table_bind_text (_tmp77_, 4, _tmp82_);
#line 259 "../src/db/SavedSearchDBTable.vala"
					_g_free0 (_tmp82_);
#line 261 "../src/db/SavedSearchDBTable.vala"
					_tmp83_ = stmt;
#line 261 "../src/db/SavedSearchDBTable.vala"
					res = sqlite3_step (_tmp83_);
#line 262 "../src/db/SavedSearchDBTable.vala"
					if (res != SQLITE_DONE) {
#line 263 "../src/db/SavedSearchDBTable.vala"
						database_table_throw_error ("SavedSearchDBTable_Modified.add", res, &_inner_error0_);
#line 263 "../src/db/SavedSearchDBTable.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../src/db/SavedSearchDBTable.vala"
							if (_inner_error0_->domain == DATABASE_ERROR) {
#line 263 "../src/db/SavedSearchDBTable.vala"
								g_propagate_error (error, _inner_error0_);
#line 263 "../src/db/SavedSearchDBTable.vala"
								_sqlite3_finalize0 (stmt);
#line 263 "../src/db/SavedSearchDBTable.vala"
								_search_condition_unref0 (modified_state);
#line 263 "../src/db/SavedSearchDBTable.vala"
								return;
#line 1446 "SavedSearchDBTable.c"
							} else {
#line 263 "../src/db/SavedSearchDBTable.vala"
								_sqlite3_finalize0 (stmt);
#line 263 "../src/db/SavedSearchDBTable.vala"
								_search_condition_unref0 (modified_state);
#line 263 "../src/db/SavedSearchDBTable.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 263 "../src/db/SavedSearchDBTable.vala"
								g_clear_error (&_inner_error0_);
#line 263 "../src/db/SavedSearchDBTable.vala"
								return;
#line 1458 "SavedSearchDBTable.c"
							}
						}
					}
#line 251 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 251 "../src/db/SavedSearchDBTable.vala"
					_search_condition_unref0 (modified_state);
#line 1466 "SavedSearchDBTable.c"
				} else {
#line 264 "../src/db/SavedSearchDBTable.vala"
					if (IS_SEARCH_CONDITION_DATE (condition)) {
#line 1470 "SavedSearchDBTable.c"
						SearchConditionDate* date = NULL;
						SearchConditionDate* _tmp84_;
						sqlite3_stmt* stmt = NULL;
						sqlite3_stmt* _tmp85_;
						sqlite3_stmt* _tmp86_;
						SavedSearchID _tmp87_;
						sqlite3_stmt* _tmp88_;
						SearchConditionDate* _tmp89_;
						SearchConditionSearchType _tmp90_;
						SearchConditionSearchType _tmp91_;
						gchar* _tmp92_;
						gchar* _tmp93_;
						sqlite3_stmt* _tmp94_;
						SearchConditionDate* _tmp95_;
						SearchConditionDateContext _tmp96_;
						SearchConditionDateContext _tmp97_;
						gchar* _tmp98_;
						gchar* _tmp99_;
						sqlite3_stmt* _tmp100_;
						SearchConditionDate* _tmp101_;
						GDateTime* _tmp102_;
						GDateTime* _tmp103_;
						sqlite3_stmt* _tmp104_;
						SearchConditionDate* _tmp105_;
						GDateTime* _tmp106_;
						GDateTime* _tmp107_;
						gint res = 0;
						sqlite3_stmt* _tmp108_;
#line 265 "../src/db/SavedSearchDBTable.vala"
						_tmp84_ = _search_condition_ref0 (IS_SEARCH_CONDITION_DATE (condition) ? ((SearchConditionDate*) condition) : NULL);
#line 265 "../src/db/SavedSearchDBTable.vala"
						date = _tmp84_;
#line 266 "../src/db/SavedSearchDBTable.vala"
						_tmp85_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO SavedSearchDBTable_Date (search_id, search_type, " "context, date_one, date_two) VALUES (?, ?, ?, ?, ?)");
#line 266 "../src/db/SavedSearchDBTable.vala"
						stmt = _tmp85_;
#line 269 "../src/db/SavedSearchDBTable.vala"
						_tmp86_ = stmt;
#line 269 "../src/db/SavedSearchDBTable.vala"
						_tmp87_ = *id;
#line 269 "../src/db/SavedSearchDBTable.vala"
						database_table_bind_int64 (_tmp86_, 1, _tmp87_.id);
#line 270 "../src/db/SavedSearchDBTable.vala"
						_tmp88_ = stmt;
#line 270 "../src/db/SavedSearchDBTable.vala"
						_tmp89_ = date;
#line 270 "../src/db/SavedSearchDBTable.vala"
						_tmp90_ = search_condition_get_search_type ((SearchCondition*) _tmp89_);
#line 270 "../src/db/SavedSearchDBTable.vala"
						_tmp91_ = _tmp90_;
#line 270 "../src/db/SavedSearchDBTable.vala"
						_tmp92_ = search_condition_search_type_to_string (_tmp91_);
#line 270 "../src/db/SavedSearchDBTable.vala"
						_tmp93_ = _tmp92_;
#line 270 "../src/db/SavedSearchDBTable.vala"
						database_table_bind_text (_tmp88_, 2, _tmp93_);
#line 270 "../src/db/SavedSearchDBTable.vala"
						_g_free0 (_tmp93_);
#line 271 "../src/db/SavedSearchDBTable.vala"
						_tmp94_ = stmt;
#line 271 "../src/db/SavedSearchDBTable.vala"
						_tmp95_ = date;
#line 271 "../src/db/SavedSearchDBTable.vala"
						_tmp96_ = search_condition_date_get_context (_tmp95_);
#line 271 "../src/db/SavedSearchDBTable.vala"
						_tmp97_ = _tmp96_;
#line 271 "../src/db/SavedSearchDBTable.vala"
						_tmp98_ = search_condition_date_context_to_string (_tmp97_);
#line 271 "../src/db/SavedSearchDBTable.vala"
						_tmp99_ = _tmp98_;
#line 271 "../src/db/SavedSearchDBTable.vala"
						database_table_bind_text (_tmp94_, 3, _tmp99_);
#line 271 "../src/db/SavedSearchDBTable.vala"
						_g_free0 (_tmp99_);
#line 272 "../src/db/SavedSearchDBTable.vala"
						_tmp100_ = stmt;
#line 272 "../src/db/SavedSearchDBTable.vala"
						_tmp101_ = date;
#line 272 "../src/db/SavedSearchDBTable.vala"
						_tmp102_ = search_condition_date_get_date_one (_tmp101_);
#line 272 "../src/db/SavedSearchDBTable.vala"
						_tmp103_ = _tmp102_;
#line 272 "../src/db/SavedSearchDBTable.vala"
						database_table_bind_int64 (_tmp100_, 4, g_date_time_to_unix (_tmp103_));
#line 273 "../src/db/SavedSearchDBTable.vala"
						_tmp104_ = stmt;
#line 273 "../src/db/SavedSearchDBTable.vala"
						_tmp105_ = date;
#line 273 "../src/db/SavedSearchDBTable.vala"
						_tmp106_ = search_condition_date_get_date_two (_tmp105_);
#line 273 "../src/db/SavedSearchDBTable.vala"
						_tmp107_ = _tmp106_;
#line 273 "../src/db/SavedSearchDBTable.vala"
						database_table_bind_int64 (_tmp104_, 5, g_date_time_to_unix (_tmp107_));
#line 275 "../src/db/SavedSearchDBTable.vala"
						_tmp108_ = stmt;
#line 275 "../src/db/SavedSearchDBTable.vala"
						res = sqlite3_step (_tmp108_);
#line 276 "../src/db/SavedSearchDBTable.vala"
						if (res != SQLITE_DONE) {
#line 277 "../src/db/SavedSearchDBTable.vala"
							database_table_throw_error ("SavedSearchDBTable_Date.add", res, &_inner_error0_);
#line 277 "../src/db/SavedSearchDBTable.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "../src/db/SavedSearchDBTable.vala"
								if (_inner_error0_->domain == DATABASE_ERROR) {
#line 277 "../src/db/SavedSearchDBTable.vala"
									g_propagate_error (error, _inner_error0_);
#line 277 "../src/db/SavedSearchDBTable.vala"
									_sqlite3_finalize0 (stmt);
#line 277 "../src/db/SavedSearchDBTable.vala"
									_search_condition_unref0 (date);
#line 277 "../src/db/SavedSearchDBTable.vala"
									return;
#line 1585 "SavedSearchDBTable.c"
								} else {
#line 277 "../src/db/SavedSearchDBTable.vala"
									_sqlite3_finalize0 (stmt);
#line 277 "../src/db/SavedSearchDBTable.vala"
									_search_condition_unref0 (date);
#line 277 "../src/db/SavedSearchDBTable.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 277 "../src/db/SavedSearchDBTable.vala"
									g_clear_error (&_inner_error0_);
#line 277 "../src/db/SavedSearchDBTable.vala"
									return;
#line 1597 "SavedSearchDBTable.c"
								}
							}
						}
#line 264 "../src/db/SavedSearchDBTable.vala"
						_sqlite3_finalize0 (stmt);
#line 264 "../src/db/SavedSearchDBTable.vala"
						_search_condition_unref0 (date);
#line 1605 "SavedSearchDBTable.c"
					} else {
#line 279 "../src/db/SavedSearchDBTable.vala"
						g_assert_not_reached ();
#line 1609 "SavedSearchDBTable.c"
					}
				}
			}
		}
	}
}

static void
saved_search_db_table_remove_conditions_for_search_id (SavedSearchDBTable* self,
                                                       SavedSearchID* search_id,
                                                       GError** error)
{
	SavedSearchID _tmp0_;
	SavedSearchID _tmp1_;
	SavedSearchID _tmp2_;
	SavedSearchID _tmp3_;
	SavedSearchID _tmp4_;
	GError* _inner_error0_ = NULL;
#line 284 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (search_id != NULL);
#line 285 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = *search_id;
#line 285 "../src/db/SavedSearchDBTable.vala"
	saved_search_db_table_remove_conditions_for_table (self, "SavedSearchDBTable_Text", &_tmp0_, &_inner_error0_);
#line 285 "../src/db/SavedSearchDBTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "../src/db/SavedSearchDBTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 285 "../src/db/SavedSearchDBTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 285 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1644 "SavedSearchDBTable.c"
		} else {
#line 285 "../src/db/SavedSearchDBTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 285 "../src/db/SavedSearchDBTable.vala"
			g_clear_error (&_inner_error0_);
#line 285 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1652 "SavedSearchDBTable.c"
		}
	}
#line 286 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = *search_id;
#line 286 "../src/db/SavedSearchDBTable.vala"
	saved_search_db_table_remove_conditions_for_table (self, "SavedSearchDBTable_MediaType", &_tmp1_, &_inner_error0_);
#line 286 "../src/db/SavedSearchDBTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 286 "../src/db/SavedSearchDBTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 286 "../src/db/SavedSearchDBTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 286 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1667 "SavedSearchDBTable.c"
		} else {
#line 286 "../src/db/SavedSearchDBTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 286 "../src/db/SavedSearchDBTable.vala"
			g_clear_error (&_inner_error0_);
#line 286 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1675 "SavedSearchDBTable.c"
		}
	}
#line 287 "../src/db/SavedSearchDBTable.vala"
	_tmp2_ = *search_id;
#line 287 "../src/db/SavedSearchDBTable.vala"
	saved_search_db_table_remove_conditions_for_table (self, "SavedSearchDBTable_Flagged", &_tmp2_, &_inner_error0_);
#line 287 "../src/db/SavedSearchDBTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "../src/db/SavedSearchDBTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 287 "../src/db/SavedSearchDBTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 287 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1690 "SavedSearchDBTable.c"
		} else {
#line 287 "../src/db/SavedSearchDBTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 287 "../src/db/SavedSearchDBTable.vala"
			g_clear_error (&_inner_error0_);
#line 287 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1698 "SavedSearchDBTable.c"
		}
	}
#line 288 "../src/db/SavedSearchDBTable.vala"
	_tmp3_ = *search_id;
#line 288 "../src/db/SavedSearchDBTable.vala"
	saved_search_db_table_remove_conditions_for_table (self, "SavedSearchDBTable_Modified", &_tmp3_, &_inner_error0_);
#line 288 "../src/db/SavedSearchDBTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../src/db/SavedSearchDBTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 288 "../src/db/SavedSearchDBTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 288 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1713 "SavedSearchDBTable.c"
		} else {
#line 288 "../src/db/SavedSearchDBTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 288 "../src/db/SavedSearchDBTable.vala"
			g_clear_error (&_inner_error0_);
#line 288 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1721 "SavedSearchDBTable.c"
		}
	}
#line 289 "../src/db/SavedSearchDBTable.vala"
	_tmp4_ = *search_id;
#line 289 "../src/db/SavedSearchDBTable.vala"
	saved_search_db_table_remove_conditions_for_table (self, "SavedSearchDBTable_Date", &_tmp4_, &_inner_error0_);
#line 289 "../src/db/SavedSearchDBTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 289 "../src/db/SavedSearchDBTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 289 "../src/db/SavedSearchDBTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 289 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1736 "SavedSearchDBTable.c"
		} else {
#line 289 "../src/db/SavedSearchDBTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 289 "../src/db/SavedSearchDBTable.vala"
			g_clear_error (&_inner_error0_);
#line 289 "../src/db/SavedSearchDBTable.vala"
			return;
#line 1744 "SavedSearchDBTable.c"
		}
	}
}

static void
saved_search_db_table_remove_conditions_for_table (SavedSearchDBTable* self,
                                                   const gchar* table_name,
                                                   SavedSearchID* search_id,
                                                   GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	SavedSearchID _tmp5_;
	gint res = 0;
	sqlite3_stmt* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 292 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (table_name != NULL);
#line 292 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (search_id != NULL);
#line 294 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = g_strdup_printf ("DELETE FROM %s WHERE search_id=?", table_name);
#line 294 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = _tmp0_;
#line 294 "../src/db/SavedSearchDBTable.vala"
	_tmp2_ = database_table_create_stmt ((DatabaseTable*) self, _tmp1_);
#line 294 "../src/db/SavedSearchDBTable.vala"
	_tmp3_ = _tmp2_;
#line 294 "../src/db/SavedSearchDBTable.vala"
	_g_free0 (_tmp1_);
#line 294 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp3_;
#line 296 "../src/db/SavedSearchDBTable.vala"
	_tmp4_ = stmt;
#line 296 "../src/db/SavedSearchDBTable.vala"
	_tmp5_ = *search_id;
#line 296 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_int64 (_tmp4_, 1, _tmp5_.id);
#line 298 "../src/db/SavedSearchDBTable.vala"
	_tmp6_ = stmt;
#line 298 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp6_);
#line 299 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 1795 "SavedSearchDBTable.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 300 "../src/db/SavedSearchDBTable.vala"
		_tmp7_ = g_strdup_printf ("%s.remove", table_name);
#line 300 "../src/db/SavedSearchDBTable.vala"
		_tmp8_ = _tmp7_;
#line 300 "../src/db/SavedSearchDBTable.vala"
		database_table_throw_error (_tmp8_, res, &_inner_error0_);
#line 300 "../src/db/SavedSearchDBTable.vala"
		_g_free0 (_tmp8_);
#line 300 "../src/db/SavedSearchDBTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 300 "../src/db/SavedSearchDBTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 300 "../src/db/SavedSearchDBTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 300 "../src/db/SavedSearchDBTable.vala"
				_sqlite3_finalize0 (stmt);
#line 300 "../src/db/SavedSearchDBTable.vala"
				return;
#line 1816 "SavedSearchDBTable.c"
			} else {
#line 300 "../src/db/SavedSearchDBTable.vala"
				_sqlite3_finalize0 (stmt);
#line 300 "../src/db/SavedSearchDBTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 300 "../src/db/SavedSearchDBTable.vala"
				g_clear_error (&_inner_error0_);
#line 300 "../src/db/SavedSearchDBTable.vala"
				return;
#line 1826 "SavedSearchDBTable.c"
			}
		}
	}
#line 292 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1832 "SavedSearchDBTable.c"
}

static GeeList*
saved_search_db_table_get_conditions_for_id (SavedSearchDBTable* self,
                                             SavedSearchID* search_id,
                                             GError** error)
{
	GeeList* list = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	SavedSearchID _tmp3_;
	sqlite3_stmt* _tmp15_;
	sqlite3_stmt* _tmp16_;
	SavedSearchID _tmp17_;
	sqlite3_stmt* _tmp29_;
	sqlite3_stmt* _tmp30_;
	SavedSearchID _tmp31_;
	sqlite3_stmt* _tmp41_;
	sqlite3_stmt* _tmp42_;
	SavedSearchID _tmp43_;
	sqlite3_stmt* _tmp55_;
	sqlite3_stmt* _tmp56_;
	SavedSearchID _tmp57_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 304 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 304 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (search_id != NULL, NULL);
#line 306 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = gee_array_list_new (TYPE_SEARCH_CONDITION, (GBoxedCopyFunc) search_condition_ref, (GDestroyNotify) search_condition_unref, NULL, NULL, NULL);
#line 306 "../src/db/SavedSearchDBTable.vala"
	list = (GeeList*) _tmp0_;
#line 309 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT search_type, context, text FROM SavedSearchDBTable_Text " "WHERE search_id=?");
#line 309 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp1_;
#line 312 "../src/db/SavedSearchDBTable.vala"
	_tmp2_ = stmt;
#line 312 "../src/db/SavedSearchDBTable.vala"
	_tmp3_ = *search_id;
#line 312 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_int64 (_tmp2_, 1, _tmp3_.id);
#line 1878 "SavedSearchDBTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 314 "../src/db/SavedSearchDBTable.vala"
		_tmp4_ = TRUE;
#line 314 "../src/db/SavedSearchDBTable.vala"
		while (TRUE) {
#line 1885 "SavedSearchDBTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp5_;
			SearchConditionText* condition = NULL;
			sqlite3_stmt* _tmp6_;
			const gchar* _tmp7_;
			sqlite3_stmt* _tmp8_;
			const gchar* _tmp9_;
			sqlite3_stmt* _tmp10_;
			const gchar* _tmp11_;
			SearchConditionText* _tmp12_;
			GeeList* _tmp13_;
			SearchConditionText* _tmp14_;
#line 314 "../src/db/SavedSearchDBTable.vala"
			if (!_tmp4_) {
#line 1900 "SavedSearchDBTable.c"
			}
#line 314 "../src/db/SavedSearchDBTable.vala"
			_tmp4_ = FALSE;
#line 315 "../src/db/SavedSearchDBTable.vala"
			_tmp5_ = stmt;
#line 315 "../src/db/SavedSearchDBTable.vala"
			res = sqlite3_step (_tmp5_);
#line 316 "../src/db/SavedSearchDBTable.vala"
			if (res == SQLITE_DONE) {
#line 317 "../src/db/SavedSearchDBTable.vala"
				break;
#line 1912 "SavedSearchDBTable.c"
			} else {
#line 318 "../src/db/SavedSearchDBTable.vala"
				if (res != SQLITE_ROW) {
#line 319 "../src/db/SavedSearchDBTable.vala"
					database_table_throw_error ("SavedSearchDBTable_Text.get_all_rows", res, &_inner_error0_);
#line 319 "../src/db/SavedSearchDBTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 319 "../src/db/SavedSearchDBTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 319 "../src/db/SavedSearchDBTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 319 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 319 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 319 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 1930 "SavedSearchDBTable.c"
						} else {
#line 319 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 319 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 319 "../src/db/SavedSearchDBTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 319 "../src/db/SavedSearchDBTable.vala"
							g_clear_error (&_inner_error0_);
#line 319 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 1942 "SavedSearchDBTable.c"
						}
					}
				}
			}
#line 321 "../src/db/SavedSearchDBTable.vala"
			_tmp6_ = stmt;
#line 321 "../src/db/SavedSearchDBTable.vala"
			_tmp7_ = (const gchar*) sqlite3_column_text (_tmp6_, 0);
#line 321 "../src/db/SavedSearchDBTable.vala"
			_tmp8_ = stmt;
#line 321 "../src/db/SavedSearchDBTable.vala"
			_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 2);
#line 321 "../src/db/SavedSearchDBTable.vala"
			_tmp10_ = stmt;
#line 321 "../src/db/SavedSearchDBTable.vala"
			_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 321 "../src/db/SavedSearchDBTable.vala"
			_tmp12_ = search_condition_text_new (search_condition_search_type_from_string (_tmp7_), _tmp9_, search_condition_text_context_from_string (_tmp11_));
#line 321 "../src/db/SavedSearchDBTable.vala"
			condition = _tmp12_;
#line 326 "../src/db/SavedSearchDBTable.vala"
			_tmp13_ = list;
#line 326 "../src/db/SavedSearchDBTable.vala"
			_tmp14_ = condition;
#line 326 "../src/db/SavedSearchDBTable.vala"
			gee_collection_add ((GeeCollection*) _tmp13_, (SearchCondition*) _tmp14_);
#line 314 "../src/db/SavedSearchDBTable.vala"
			_search_condition_unref0 (condition);
#line 1971 "SavedSearchDBTable.c"
		}
	}
#line 330 "../src/db/SavedSearchDBTable.vala"
	_tmp15_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT search_type, context, type FROM SavedSearchDBTable_MediaType " "WHERE search_id=?");
#line 330 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 330 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp15_;
#line 333 "../src/db/SavedSearchDBTable.vala"
	_tmp16_ = stmt;
#line 333 "../src/db/SavedSearchDBTable.vala"
	_tmp17_ = *search_id;
#line 333 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_int64 (_tmp16_, 1, _tmp17_.id);
#line 1986 "SavedSearchDBTable.c"
	{
		gboolean _tmp18_ = FALSE;
#line 335 "../src/db/SavedSearchDBTable.vala"
		_tmp18_ = TRUE;
#line 335 "../src/db/SavedSearchDBTable.vala"
		while (TRUE) {
#line 1993 "SavedSearchDBTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp19_;
			SearchConditionMediaType* condition = NULL;
			sqlite3_stmt* _tmp20_;
			const gchar* _tmp21_;
			sqlite3_stmt* _tmp22_;
			const gchar* _tmp23_;
			sqlite3_stmt* _tmp24_;
			const gchar* _tmp25_;
			SearchConditionMediaType* _tmp26_;
			GeeList* _tmp27_;
			SearchConditionMediaType* _tmp28_;
#line 335 "../src/db/SavedSearchDBTable.vala"
			if (!_tmp18_) {
#line 2008 "SavedSearchDBTable.c"
			}
#line 335 "../src/db/SavedSearchDBTable.vala"
			_tmp18_ = FALSE;
#line 336 "../src/db/SavedSearchDBTable.vala"
			_tmp19_ = stmt;
#line 336 "../src/db/SavedSearchDBTable.vala"
			res = sqlite3_step (_tmp19_);
#line 337 "../src/db/SavedSearchDBTable.vala"
			if (res == SQLITE_DONE) {
#line 338 "../src/db/SavedSearchDBTable.vala"
				break;
#line 2020 "SavedSearchDBTable.c"
			} else {
#line 339 "../src/db/SavedSearchDBTable.vala"
				if (res != SQLITE_ROW) {
#line 340 "../src/db/SavedSearchDBTable.vala"
					database_table_throw_error ("SavedSearchDBTable_MediaType.get_all_rows", res, &_inner_error0_);
#line 340 "../src/db/SavedSearchDBTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 340 "../src/db/SavedSearchDBTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 340 "../src/db/SavedSearchDBTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 340 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 340 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 340 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2038 "SavedSearchDBTable.c"
						} else {
#line 340 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 340 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 340 "../src/db/SavedSearchDBTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 340 "../src/db/SavedSearchDBTable.vala"
							g_clear_error (&_inner_error0_);
#line 340 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2050 "SavedSearchDBTable.c"
						}
					}
				}
			}
#line 342 "../src/db/SavedSearchDBTable.vala"
			_tmp20_ = stmt;
#line 342 "../src/db/SavedSearchDBTable.vala"
			_tmp21_ = (const gchar*) sqlite3_column_text (_tmp20_, 0);
#line 342 "../src/db/SavedSearchDBTable.vala"
			_tmp22_ = stmt;
#line 342 "../src/db/SavedSearchDBTable.vala"
			_tmp23_ = (const gchar*) sqlite3_column_text (_tmp22_, 1);
#line 342 "../src/db/SavedSearchDBTable.vala"
			_tmp24_ = stmt;
#line 342 "../src/db/SavedSearchDBTable.vala"
			_tmp25_ = (const gchar*) sqlite3_column_text (_tmp24_, 2);
#line 342 "../src/db/SavedSearchDBTable.vala"
			_tmp26_ = search_condition_media_type_new (search_condition_search_type_from_string (_tmp21_), search_condition_media_type_context_from_string (_tmp23_), search_condition_media_type_media_type_from_string (_tmp25_));
#line 342 "../src/db/SavedSearchDBTable.vala"
			condition = _tmp26_;
#line 347 "../src/db/SavedSearchDBTable.vala"
			_tmp27_ = list;
#line 347 "../src/db/SavedSearchDBTable.vala"
			_tmp28_ = condition;
#line 347 "../src/db/SavedSearchDBTable.vala"
			gee_collection_add ((GeeCollection*) _tmp27_, (SearchCondition*) _tmp28_);
#line 335 "../src/db/SavedSearchDBTable.vala"
			_search_condition_unref0 (condition);
#line 2079 "SavedSearchDBTable.c"
		}
	}
#line 351 "../src/db/SavedSearchDBTable.vala"
	_tmp29_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT search_type, flag_state FROM SavedSearchDBTable_Flagged " "WHERE search_id=?");
#line 351 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 351 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp29_;
#line 354 "../src/db/SavedSearchDBTable.vala"
	_tmp30_ = stmt;
#line 354 "../src/db/SavedSearchDBTable.vala"
	_tmp31_ = *search_id;
#line 354 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_int64 (_tmp30_, 1, _tmp31_.id);
#line 2094 "SavedSearchDBTable.c"
	{
		gboolean _tmp32_ = FALSE;
#line 356 "../src/db/SavedSearchDBTable.vala"
		_tmp32_ = TRUE;
#line 356 "../src/db/SavedSearchDBTable.vala"
		while (TRUE) {
#line 2101 "SavedSearchDBTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp33_;
			SearchConditionFlagged* condition = NULL;
			sqlite3_stmt* _tmp34_;
			const gchar* _tmp35_;
			sqlite3_stmt* _tmp36_;
			const gchar* _tmp37_;
			SearchConditionFlagged* _tmp38_;
			GeeList* _tmp39_;
			SearchConditionFlagged* _tmp40_;
#line 356 "../src/db/SavedSearchDBTable.vala"
			if (!_tmp32_) {
#line 2114 "SavedSearchDBTable.c"
			}
#line 356 "../src/db/SavedSearchDBTable.vala"
			_tmp32_ = FALSE;
#line 357 "../src/db/SavedSearchDBTable.vala"
			_tmp33_ = stmt;
#line 357 "../src/db/SavedSearchDBTable.vala"
			res = sqlite3_step (_tmp33_);
#line 358 "../src/db/SavedSearchDBTable.vala"
			if (res == SQLITE_DONE) {
#line 359 "../src/db/SavedSearchDBTable.vala"
				break;
#line 2126 "SavedSearchDBTable.c"
			} else {
#line 360 "../src/db/SavedSearchDBTable.vala"
				if (res != SQLITE_ROW) {
#line 361 "../src/db/SavedSearchDBTable.vala"
					database_table_throw_error ("SavedSearchDBTable_Flagged.get_all_rows", res, &_inner_error0_);
#line 361 "../src/db/SavedSearchDBTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 361 "../src/db/SavedSearchDBTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 361 "../src/db/SavedSearchDBTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 361 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 361 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 361 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2144 "SavedSearchDBTable.c"
						} else {
#line 361 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 361 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 361 "../src/db/SavedSearchDBTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 361 "../src/db/SavedSearchDBTable.vala"
							g_clear_error (&_inner_error0_);
#line 361 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2156 "SavedSearchDBTable.c"
						}
					}
				}
			}
#line 363 "../src/db/SavedSearchDBTable.vala"
			_tmp34_ = stmt;
#line 363 "../src/db/SavedSearchDBTable.vala"
			_tmp35_ = (const gchar*) sqlite3_column_text (_tmp34_, 0);
#line 363 "../src/db/SavedSearchDBTable.vala"
			_tmp36_ = stmt;
#line 363 "../src/db/SavedSearchDBTable.vala"
			_tmp37_ = (const gchar*) sqlite3_column_text (_tmp36_, 1);
#line 363 "../src/db/SavedSearchDBTable.vala"
			_tmp38_ = search_condition_flagged_new (search_condition_search_type_from_string (_tmp35_), search_condition_flagged_state_from_string (_tmp37_));
#line 363 "../src/db/SavedSearchDBTable.vala"
			condition = _tmp38_;
#line 367 "../src/db/SavedSearchDBTable.vala"
			_tmp39_ = list;
#line 367 "../src/db/SavedSearchDBTable.vala"
			_tmp40_ = condition;
#line 367 "../src/db/SavedSearchDBTable.vala"
			gee_collection_add ((GeeCollection*) _tmp39_, (SearchCondition*) _tmp40_);
#line 356 "../src/db/SavedSearchDBTable.vala"
			_search_condition_unref0 (condition);
#line 2181 "SavedSearchDBTable.c"
		}
	}
#line 371 "../src/db/SavedSearchDBTable.vala"
	_tmp41_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT search_type, context, modified_state FROM SavedSearchDBTable_Mo" \
"dified " "WHERE search_id=?");
#line 371 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 371 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp41_;
#line 374 "../src/db/SavedSearchDBTable.vala"
	_tmp42_ = stmt;
#line 374 "../src/db/SavedSearchDBTable.vala"
	_tmp43_ = *search_id;
#line 374 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_int64 (_tmp42_, 1, _tmp43_.id);
#line 2196 "SavedSearchDBTable.c"
	{
		gboolean _tmp44_ = FALSE;
#line 376 "../src/db/SavedSearchDBTable.vala"
		_tmp44_ = TRUE;
#line 376 "../src/db/SavedSearchDBTable.vala"
		while (TRUE) {
#line 2203 "SavedSearchDBTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp45_;
			SearchConditionModified* condition = NULL;
			sqlite3_stmt* _tmp46_;
			const gchar* _tmp47_;
			sqlite3_stmt* _tmp48_;
			const gchar* _tmp49_;
			sqlite3_stmt* _tmp50_;
			const gchar* _tmp51_;
			SearchConditionModified* _tmp52_;
			GeeList* _tmp53_;
			SearchConditionModified* _tmp54_;
#line 376 "../src/db/SavedSearchDBTable.vala"
			if (!_tmp44_) {
#line 2218 "SavedSearchDBTable.c"
			}
#line 376 "../src/db/SavedSearchDBTable.vala"
			_tmp44_ = FALSE;
#line 377 "../src/db/SavedSearchDBTable.vala"
			_tmp45_ = stmt;
#line 377 "../src/db/SavedSearchDBTable.vala"
			res = sqlite3_step (_tmp45_);
#line 378 "../src/db/SavedSearchDBTable.vala"
			if (res == SQLITE_DONE) {
#line 379 "../src/db/SavedSearchDBTable.vala"
				break;
#line 2230 "SavedSearchDBTable.c"
			} else {
#line 380 "../src/db/SavedSearchDBTable.vala"
				if (res != SQLITE_ROW) {
#line 381 "../src/db/SavedSearchDBTable.vala"
					database_table_throw_error ("SavedSearchDBTable_Modified.get_all_rows", res, &_inner_error0_);
#line 381 "../src/db/SavedSearchDBTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 381 "../src/db/SavedSearchDBTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 381 "../src/db/SavedSearchDBTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 381 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 381 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 381 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2248 "SavedSearchDBTable.c"
						} else {
#line 381 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 381 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 381 "../src/db/SavedSearchDBTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 381 "../src/db/SavedSearchDBTable.vala"
							g_clear_error (&_inner_error0_);
#line 381 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2260 "SavedSearchDBTable.c"
						}
					}
				}
			}
#line 383 "../src/db/SavedSearchDBTable.vala"
			_tmp46_ = stmt;
#line 383 "../src/db/SavedSearchDBTable.vala"
			_tmp47_ = (const gchar*) sqlite3_column_text (_tmp46_, 0);
#line 383 "../src/db/SavedSearchDBTable.vala"
			_tmp48_ = stmt;
#line 383 "../src/db/SavedSearchDBTable.vala"
			_tmp49_ = (const gchar*) sqlite3_column_text (_tmp48_, 1);
#line 383 "../src/db/SavedSearchDBTable.vala"
			_tmp50_ = stmt;
#line 383 "../src/db/SavedSearchDBTable.vala"
			_tmp51_ = (const gchar*) sqlite3_column_text (_tmp50_, 2);
#line 383 "../src/db/SavedSearchDBTable.vala"
			_tmp52_ = search_condition_modified_new (search_condition_search_type_from_string (_tmp47_), search_condition_modified_context_from_string (_tmp49_), search_condition_modified_state_from_string (_tmp51_));
#line 383 "../src/db/SavedSearchDBTable.vala"
			condition = _tmp52_;
#line 388 "../src/db/SavedSearchDBTable.vala"
			_tmp53_ = list;
#line 388 "../src/db/SavedSearchDBTable.vala"
			_tmp54_ = condition;
#line 388 "../src/db/SavedSearchDBTable.vala"
			gee_collection_add ((GeeCollection*) _tmp53_, (SearchCondition*) _tmp54_);
#line 376 "../src/db/SavedSearchDBTable.vala"
			_search_condition_unref0 (condition);
#line 2289 "SavedSearchDBTable.c"
		}
	}
#line 392 "../src/db/SavedSearchDBTable.vala"
	_tmp55_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT search_type, context, date_one, date_two FROM SavedSearchDBTabl" \
"e_Date " "WHERE search_id=?");
#line 392 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 392 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp55_;
#line 395 "../src/db/SavedSearchDBTable.vala"
	_tmp56_ = stmt;
#line 395 "../src/db/SavedSearchDBTable.vala"
	_tmp57_ = *search_id;
#line 395 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_int64 (_tmp56_, 1, _tmp57_.id);
#line 2304 "SavedSearchDBTable.c"
	{
		gboolean _tmp58_ = FALSE;
#line 397 "../src/db/SavedSearchDBTable.vala"
		_tmp58_ = TRUE;
#line 397 "../src/db/SavedSearchDBTable.vala"
		while (TRUE) {
#line 2311 "SavedSearchDBTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp59_;
			SearchConditionDate* condition = NULL;
			sqlite3_stmt* _tmp60_;
			const gchar* _tmp61_;
			sqlite3_stmt* _tmp62_;
			const gchar* _tmp63_;
			sqlite3_stmt* _tmp64_;
			GDateTime* _tmp65_;
			GDateTime* _tmp66_;
			sqlite3_stmt* _tmp67_;
			GDateTime* _tmp68_;
			GDateTime* _tmp69_;
			SearchConditionDate* _tmp70_;
			SearchConditionDate* _tmp71_;
			GeeList* _tmp72_;
			SearchConditionDate* _tmp73_;
#line 397 "../src/db/SavedSearchDBTable.vala"
			if (!_tmp58_) {
#line 2331 "SavedSearchDBTable.c"
			}
#line 397 "../src/db/SavedSearchDBTable.vala"
			_tmp58_ = FALSE;
#line 398 "../src/db/SavedSearchDBTable.vala"
			_tmp59_ = stmt;
#line 398 "../src/db/SavedSearchDBTable.vala"
			res = sqlite3_step (_tmp59_);
#line 399 "../src/db/SavedSearchDBTable.vala"
			if (res == SQLITE_DONE) {
#line 400 "../src/db/SavedSearchDBTable.vala"
				break;
#line 2343 "SavedSearchDBTable.c"
			} else {
#line 401 "../src/db/SavedSearchDBTable.vala"
				if (res != SQLITE_ROW) {
#line 402 "../src/db/SavedSearchDBTable.vala"
					database_table_throw_error ("SavedSearchDBTable_Date.get_all_rows", res, &_inner_error0_);
#line 402 "../src/db/SavedSearchDBTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 402 "../src/db/SavedSearchDBTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 402 "../src/db/SavedSearchDBTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 402 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 402 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 402 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2361 "SavedSearchDBTable.c"
						} else {
#line 402 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 402 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (list);
#line 402 "../src/db/SavedSearchDBTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 402 "../src/db/SavedSearchDBTable.vala"
							g_clear_error (&_inner_error0_);
#line 402 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2373 "SavedSearchDBTable.c"
						}
					}
				}
			}
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp60_ = stmt;
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp61_ = (const gchar*) sqlite3_column_text (_tmp60_, 0);
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp62_ = stmt;
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp63_ = (const gchar*) sqlite3_column_text (_tmp62_, 1);
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp64_ = stmt;
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp65_ = g_date_time_new_from_unix_local (sqlite3_column_int64 (_tmp64_, 2));
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp66_ = _tmp65_;
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp67_ = stmt;
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp68_ = g_date_time_new_from_unix_local (sqlite3_column_int64 (_tmp67_, 3));
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp69_ = _tmp68_;
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp70_ = search_condition_date_new (search_condition_search_type_from_string (_tmp61_), search_condition_date_context_from_string (_tmp63_), _tmp66_, _tmp69_);
#line 404 "../src/db/SavedSearchDBTable.vala"
			_tmp71_ = _tmp70_;
#line 404 "../src/db/SavedSearchDBTable.vala"
			_g_date_time_unref0 (_tmp69_);
#line 404 "../src/db/SavedSearchDBTable.vala"
			_g_date_time_unref0 (_tmp66_);
#line 404 "../src/db/SavedSearchDBTable.vala"
			condition = _tmp71_;
#line 409 "../src/db/SavedSearchDBTable.vala"
			_tmp72_ = list;
#line 409 "../src/db/SavedSearchDBTable.vala"
			_tmp73_ = condition;
#line 409 "../src/db/SavedSearchDBTable.vala"
			gee_collection_add ((GeeCollection*) _tmp72_, (SearchCondition*) _tmp73_);
#line 397 "../src/db/SavedSearchDBTable.vala"
			_search_condition_unref0 (condition);
#line 2416 "SavedSearchDBTable.c"
		}
	}
#line 412 "../src/db/SavedSearchDBTable.vala"
	result = list;
#line 412 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 412 "../src/db/SavedSearchDBTable.vala"
	return result;
#line 2425 "SavedSearchDBTable.c"
}

void
saved_search_db_table_create_from_row (SavedSearchDBTable* self,
                                       SavedSearchRow* row,
                                       SavedSearchID* result,
                                       GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint res = 0;
	sqlite3_stmt* _tmp6_;
	SavedSearchID search_id = {0};
	sqlite3* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 416 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (self != NULL);
#line 416 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (row != NULL);
#line 417 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO SavedSearchDBTable (name, operator) VALUES (?, ?)");
#line 417 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp0_;
#line 419 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = stmt;
#line 419 "../src/db/SavedSearchDBTable.vala"
	_tmp2_ = row->name;
#line 419 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp2_);
#line 420 "../src/db/SavedSearchDBTable.vala"
	_tmp3_ = stmt;
#line 420 "../src/db/SavedSearchDBTable.vala"
	_tmp4_ = search_operator_to_string (row->operator);
#line 420 "../src/db/SavedSearchDBTable.vala"
	_tmp5_ = _tmp4_;
#line 420 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_text (_tmp3_, 2, _tmp5_);
#line 420 "../src/db/SavedSearchDBTable.vala"
	_g_free0 (_tmp5_);
#line 422 "../src/db/SavedSearchDBTable.vala"
	_tmp6_ = stmt;
#line 422 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp6_);
#line 423 "../src/db/SavedSearchDBTable.vala"
	if (res != SQLITE_DONE) {
#line 424 "../src/db/SavedSearchDBTable.vala"
		database_table_throw_error ("SavedSearchDBTable.create_from_row", res, &_inner_error0_);
#line 424 "../src/db/SavedSearchDBTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "../src/db/SavedSearchDBTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 424 "../src/db/SavedSearchDBTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 424 "../src/db/SavedSearchDBTable.vala"
				_sqlite3_finalize0 (stmt);
#line 424 "../src/db/SavedSearchDBTable.vala"
				return;
#line 2488 "SavedSearchDBTable.c"
			} else {
#line 424 "../src/db/SavedSearchDBTable.vala"
				_sqlite3_finalize0 (stmt);
#line 424 "../src/db/SavedSearchDBTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 424 "../src/db/SavedSearchDBTable.vala"
				g_clear_error (&_inner_error0_);
#line 424 "../src/db/SavedSearchDBTable.vala"
				return;
#line 2498 "SavedSearchDBTable.c"
			}
		}
	}
#line 426 "../src/db/SavedSearchDBTable.vala"
	_tmp7_ = database_table_db;
#line 426 "../src/db/SavedSearchDBTable.vala"
	saved_search_id_init (&search_id, sqlite3_last_insert_rowid (_tmp7_));
#line 2506 "SavedSearchDBTable.c"
	{
		GeeList* _sc_list = NULL;
		GeeList* _tmp8_;
		gint _sc_size = 0;
		GeeList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _sc_index = 0;
#line 428 "../src/db/SavedSearchDBTable.vala"
		_tmp8_ = row->conditions;
#line 428 "../src/db/SavedSearchDBTable.vala"
		_sc_list = _tmp8_;
#line 428 "../src/db/SavedSearchDBTable.vala"
		_tmp9_ = _sc_list;
#line 428 "../src/db/SavedSearchDBTable.vala"
		_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
#line 428 "../src/db/SavedSearchDBTable.vala"
		_tmp11_ = _tmp10_;
#line 428 "../src/db/SavedSearchDBTable.vala"
		_sc_size = _tmp11_;
#line 428 "../src/db/SavedSearchDBTable.vala"
		_sc_index = -1;
#line 428 "../src/db/SavedSearchDBTable.vala"
		while (TRUE) {
#line 2531 "SavedSearchDBTable.c"
			gint _tmp12_;
			gint _tmp13_;
			SearchCondition* sc = NULL;
			GeeList* _tmp14_;
			gpointer _tmp15_;
			SavedSearchID _tmp16_;
			SearchCondition* _tmp17_;
#line 428 "../src/db/SavedSearchDBTable.vala"
			_sc_index = _sc_index + 1;
#line 428 "../src/db/SavedSearchDBTable.vala"
			_tmp12_ = _sc_index;
#line 428 "../src/db/SavedSearchDBTable.vala"
			_tmp13_ = _sc_size;
#line 428 "../src/db/SavedSearchDBTable.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 428 "../src/db/SavedSearchDBTable.vala"
				break;
#line 2549 "SavedSearchDBTable.c"
			}
#line 428 "../src/db/SavedSearchDBTable.vala"
			_tmp14_ = _sc_list;
#line 428 "../src/db/SavedSearchDBTable.vala"
			_tmp15_ = gee_list_get (_tmp14_, _sc_index);
#line 428 "../src/db/SavedSearchDBTable.vala"
			sc = (SearchCondition*) _tmp15_;
#line 429 "../src/db/SavedSearchDBTable.vala"
			_tmp16_ = search_id;
#line 429 "../src/db/SavedSearchDBTable.vala"
			_tmp17_ = sc;
#line 429 "../src/db/SavedSearchDBTable.vala"
			saved_search_db_table_add_condition (self, &_tmp16_, _tmp17_, &_inner_error0_);
#line 429 "../src/db/SavedSearchDBTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 429 "../src/db/SavedSearchDBTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 429 "../src/db/SavedSearchDBTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 429 "../src/db/SavedSearchDBTable.vala"
					_search_condition_unref0 (sc);
#line 429 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 429 "../src/db/SavedSearchDBTable.vala"
					return;
#line 2575 "SavedSearchDBTable.c"
				} else {
#line 429 "../src/db/SavedSearchDBTable.vala"
					_search_condition_unref0 (sc);
#line 429 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 429 "../src/db/SavedSearchDBTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 429 "../src/db/SavedSearchDBTable.vala"
					g_clear_error (&_inner_error0_);
#line 429 "../src/db/SavedSearchDBTable.vala"
					return;
#line 2587 "SavedSearchDBTable.c"
				}
			}
#line 428 "../src/db/SavedSearchDBTable.vala"
			_search_condition_unref0 (sc);
#line 2592 "SavedSearchDBTable.c"
		}
	}
#line 432 "../src/db/SavedSearchDBTable.vala"
	*result = search_id;
#line 432 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 432 "../src/db/SavedSearchDBTable.vala"
	return;
#line 2601 "SavedSearchDBTable.c"
}

void
saved_search_db_table_remove (SavedSearchDBTable* self,
                              SavedSearchID* search_id,
                              GError** error)
{
	SavedSearchID _tmp0_;
	SavedSearchID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 435 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (search_id != NULL);
#line 436 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = *search_id;
#line 436 "../src/db/SavedSearchDBTable.vala"
	saved_search_db_table_remove_conditions_for_search_id (self, &_tmp0_, &_inner_error0_);
#line 436 "../src/db/SavedSearchDBTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 436 "../src/db/SavedSearchDBTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 436 "../src/db/SavedSearchDBTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 436 "../src/db/SavedSearchDBTable.vala"
			return;
#line 2628 "SavedSearchDBTable.c"
		} else {
#line 436 "../src/db/SavedSearchDBTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 436 "../src/db/SavedSearchDBTable.vala"
			g_clear_error (&_inner_error0_);
#line 436 "../src/db/SavedSearchDBTable.vala"
			return;
#line 2636 "SavedSearchDBTable.c"
		}
	}
#line 437 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = *search_id;
#line 437 "../src/db/SavedSearchDBTable.vala"
	database_table_delete_by_id ((DatabaseTable*) self, _tmp1_.id, &_inner_error0_);
#line 437 "../src/db/SavedSearchDBTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 437 "../src/db/SavedSearchDBTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 437 "../src/db/SavedSearchDBTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 437 "../src/db/SavedSearchDBTable.vala"
			return;
#line 2651 "SavedSearchDBTable.c"
		} else {
#line 437 "../src/db/SavedSearchDBTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 437 "../src/db/SavedSearchDBTable.vala"
			g_clear_error (&_inner_error0_);
#line 437 "../src/db/SavedSearchDBTable.vala"
			return;
#line 2659 "SavedSearchDBTable.c"
		}
	}
}

SavedSearchRow*
saved_search_db_table_get_row (SavedSearchDBTable* self,
                               SavedSearchID* search_id,
                               GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	SavedSearchID _tmp2_;
	gint res = 0;
	sqlite3_stmt* _tmp3_;
	SavedSearchRow* row = NULL;
	SavedSearchRow* _tmp4_;
	SavedSearchRow* _tmp5_;
	SavedSearchID _tmp6_;
	SavedSearchRow* _tmp7_;
	sqlite3_stmt* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	SavedSearchRow* _tmp11_;
	sqlite3_stmt* _tmp12_;
	const gchar* _tmp13_;
	GError* _inner_error0_ = NULL;
	SavedSearchRow* result;
#line 440 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 440 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (search_id != NULL, NULL);
#line 441 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT name, operator FROM SavedSearchDBTable WHERE id=?");
#line 441 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp0_;
#line 443 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = stmt;
#line 443 "../src/db/SavedSearchDBTable.vala"
	_tmp2_ = *search_id;
#line 443 "../src/db/SavedSearchDBTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 445 "../src/db/SavedSearchDBTable.vala"
	_tmp3_ = stmt;
#line 445 "../src/db/SavedSearchDBTable.vala"
	res = sqlite3_step (_tmp3_);
#line 446 "../src/db/SavedSearchDBTable.vala"
	if (res == SQLITE_DONE) {
#line 447 "../src/db/SavedSearchDBTable.vala"
		result = NULL;
#line 447 "../src/db/SavedSearchDBTable.vala"
		_sqlite3_finalize0 (stmt);
#line 447 "../src/db/SavedSearchDBTable.vala"
		return result;
#line 2714 "SavedSearchDBTable.c"
	} else {
#line 448 "../src/db/SavedSearchDBTable.vala"
		if (res != SQLITE_ROW) {
#line 449 "../src/db/SavedSearchDBTable.vala"
			database_table_throw_error ("SavedSearchDBTable.get_row", res, &_inner_error0_);
#line 449 "../src/db/SavedSearchDBTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 449 "../src/db/SavedSearchDBTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 449 "../src/db/SavedSearchDBTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 449 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 449 "../src/db/SavedSearchDBTable.vala"
					return NULL;
#line 2730 "SavedSearchDBTable.c"
				} else {
#line 449 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 449 "../src/db/SavedSearchDBTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 449 "../src/db/SavedSearchDBTable.vala"
					g_clear_error (&_inner_error0_);
#line 449 "../src/db/SavedSearchDBTable.vala"
					return NULL;
#line 2740 "SavedSearchDBTable.c"
				}
			}
		}
	}
#line 451 "../src/db/SavedSearchDBTable.vala"
	_tmp4_ = saved_search_row_new ();
#line 451 "../src/db/SavedSearchDBTable.vala"
	row = _tmp4_;
#line 452 "../src/db/SavedSearchDBTable.vala"
	_tmp5_ = row;
#line 452 "../src/db/SavedSearchDBTable.vala"
	_tmp6_ = *search_id;
#line 452 "../src/db/SavedSearchDBTable.vala"
	_tmp5_->search_id = _tmp6_;
#line 453 "../src/db/SavedSearchDBTable.vala"
	_tmp7_ = row;
#line 453 "../src/db/SavedSearchDBTable.vala"
	_tmp8_ = stmt;
#line 453 "../src/db/SavedSearchDBTable.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 0);
#line 453 "../src/db/SavedSearchDBTable.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 453 "../src/db/SavedSearchDBTable.vala"
	_g_free0 (_tmp7_->name);
#line 453 "../src/db/SavedSearchDBTable.vala"
	_tmp7_->name = _tmp10_;
#line 454 "../src/db/SavedSearchDBTable.vala"
	_tmp11_ = row;
#line 454 "../src/db/SavedSearchDBTable.vala"
	_tmp12_ = stmt;
#line 454 "../src/db/SavedSearchDBTable.vala"
	_tmp13_ = (const gchar*) sqlite3_column_text (_tmp12_, 1);
#line 454 "../src/db/SavedSearchDBTable.vala"
	_tmp11_->operator = search_operator_from_string (_tmp13_);
#line 456 "../src/db/SavedSearchDBTable.vala"
	result = row;
#line 456 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 456 "../src/db/SavedSearchDBTable.vala"
	return result;
#line 2781 "SavedSearchDBTable.c"
}

GeeList*
saved_search_db_table_get_all_rows (SavedSearchDBTable* self,
                                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeList* rows = NULL;
	GeeArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 459 "../src/db/SavedSearchDBTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 460 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id, name, operator FROM SavedSearchDBTable");
#line 460 "../src/db/SavedSearchDBTable.vala"
	stmt = _tmp0_;
#line 462 "../src/db/SavedSearchDBTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_SAVED_SEARCH_ROW, (GBoxedCopyFunc) saved_search_row_ref, (GDestroyNotify) saved_search_row_unref, NULL, NULL, NULL);
#line 462 "../src/db/SavedSearchDBTable.vala"
	rows = (GeeList*) _tmp1_;
#line 2804 "SavedSearchDBTable.c"
	{
		gboolean _tmp2_ = FALSE;
#line 464 "../src/db/SavedSearchDBTable.vala"
		_tmp2_ = TRUE;
#line 464 "../src/db/SavedSearchDBTable.vala"
		while (TRUE) {
#line 2811 "SavedSearchDBTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp3_;
			SavedSearchRow* row = NULL;
			SavedSearchRow* _tmp4_;
			SavedSearchRow* _tmp5_;
			sqlite3_stmt* _tmp6_;
			SavedSearchRow* _tmp7_;
			sqlite3_stmt* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			SavedSearchRow* _tmp11_;
			sqlite3_stmt* _tmp12_;
			const gchar* _tmp13_;
			GeeList* _tmp14_ = NULL;
			SavedSearchRow* _tmp15_;
			SavedSearchID _tmp16_;
			GeeList* _tmp17_;
			SavedSearchRow* _tmp18_;
			GeeList* _tmp19_;
			GeeList* _tmp20_;
			SavedSearchRow* _tmp21_;
#line 464 "../src/db/SavedSearchDBTable.vala"
			if (!_tmp2_) {
#line 2835 "SavedSearchDBTable.c"
			}
#line 464 "../src/db/SavedSearchDBTable.vala"
			_tmp2_ = FALSE;
#line 465 "../src/db/SavedSearchDBTable.vala"
			_tmp3_ = stmt;
#line 465 "../src/db/SavedSearchDBTable.vala"
			res = sqlite3_step (_tmp3_);
#line 466 "../src/db/SavedSearchDBTable.vala"
			if (res == SQLITE_DONE) {
#line 467 "../src/db/SavedSearchDBTable.vala"
				break;
#line 2847 "SavedSearchDBTable.c"
			} else {
#line 468 "../src/db/SavedSearchDBTable.vala"
				if (res != SQLITE_ROW) {
#line 469 "../src/db/SavedSearchDBTable.vala"
					database_table_throw_error ("SavedSearchDBTable.get_all_rows", res, &_inner_error0_);
#line 469 "../src/db/SavedSearchDBTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 469 "../src/db/SavedSearchDBTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 469 "../src/db/SavedSearchDBTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 469 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (rows);
#line 469 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 469 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2865 "SavedSearchDBTable.c"
						} else {
#line 469 "../src/db/SavedSearchDBTable.vala"
							_g_object_unref0 (rows);
#line 469 "../src/db/SavedSearchDBTable.vala"
							_sqlite3_finalize0 (stmt);
#line 469 "../src/db/SavedSearchDBTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 469 "../src/db/SavedSearchDBTable.vala"
							g_clear_error (&_inner_error0_);
#line 469 "../src/db/SavedSearchDBTable.vala"
							return NULL;
#line 2877 "SavedSearchDBTable.c"
						}
					}
				}
			}
#line 471 "../src/db/SavedSearchDBTable.vala"
			_tmp4_ = saved_search_row_new ();
#line 471 "../src/db/SavedSearchDBTable.vala"
			row = _tmp4_;
#line 472 "../src/db/SavedSearchDBTable.vala"
			_tmp5_ = row;
#line 472 "../src/db/SavedSearchDBTable.vala"
			_tmp6_ = stmt;
#line 472 "../src/db/SavedSearchDBTable.vala"
			saved_search_id_init (&_tmp5_->search_id, sqlite3_column_int64 (_tmp6_, 0));
#line 473 "../src/db/SavedSearchDBTable.vala"
			_tmp7_ = row;
#line 473 "../src/db/SavedSearchDBTable.vala"
			_tmp8_ = stmt;
#line 473 "../src/db/SavedSearchDBTable.vala"
			_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 1);
#line 473 "../src/db/SavedSearchDBTable.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 473 "../src/db/SavedSearchDBTable.vala"
			_g_free0 (_tmp7_->name);
#line 473 "../src/db/SavedSearchDBTable.vala"
			_tmp7_->name = _tmp10_;
#line 474 "../src/db/SavedSearchDBTable.vala"
			_tmp11_ = row;
#line 474 "../src/db/SavedSearchDBTable.vala"
			_tmp12_ = stmt;
#line 474 "../src/db/SavedSearchDBTable.vala"
			_tmp13_ = (const gchar*) sqlite3_column_text (_tmp12_, 2);
#line 474 "../src/db/SavedSearchDBTable.vala"
			_tmp11_->operator = search_operator_from_string (_tmp13_);
#line 475 "../src/db/SavedSearchDBTable.vala"
			_tmp15_ = row;
#line 475 "../src/db/SavedSearchDBTable.vala"
			_tmp16_ = _tmp15_->search_id;
#line 475 "../src/db/SavedSearchDBTable.vala"
			_tmp17_ = saved_search_db_table_get_conditions_for_id (self, &_tmp16_, &_inner_error0_);
#line 475 "../src/db/SavedSearchDBTable.vala"
			_tmp14_ = _tmp17_;
#line 475 "../src/db/SavedSearchDBTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 475 "../src/db/SavedSearchDBTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 475 "../src/db/SavedSearchDBTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 475 "../src/db/SavedSearchDBTable.vala"
					_saved_search_row_unref0 (row);
#line 475 "../src/db/SavedSearchDBTable.vala"
					_g_object_unref0 (rows);
#line 475 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 475 "../src/db/SavedSearchDBTable.vala"
					return NULL;
#line 2934 "SavedSearchDBTable.c"
				} else {
#line 475 "../src/db/SavedSearchDBTable.vala"
					_saved_search_row_unref0 (row);
#line 475 "../src/db/SavedSearchDBTable.vala"
					_g_object_unref0 (rows);
#line 475 "../src/db/SavedSearchDBTable.vala"
					_sqlite3_finalize0 (stmt);
#line 475 "../src/db/SavedSearchDBTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 475 "../src/db/SavedSearchDBTable.vala"
					g_clear_error (&_inner_error0_);
#line 475 "../src/db/SavedSearchDBTable.vala"
					return NULL;
#line 2948 "SavedSearchDBTable.c"
				}
			}
#line 475 "../src/db/SavedSearchDBTable.vala"
			_tmp18_ = row;
#line 475 "../src/db/SavedSearchDBTable.vala"
			_tmp19_ = _tmp14_;
#line 475 "../src/db/SavedSearchDBTable.vala"
			_tmp14_ = NULL;
#line 475 "../src/db/SavedSearchDBTable.vala"
			_g_object_unref0 (_tmp18_->conditions);
#line 475 "../src/db/SavedSearchDBTable.vala"
			_tmp18_->conditions = _tmp19_;
#line 477 "../src/db/SavedSearchDBTable.vala"
			_tmp20_ = rows;
#line 477 "../src/db/SavedSearchDBTable.vala"
			_tmp21_ = row;
#line 477 "../src/db/SavedSearchDBTable.vala"
			gee_collection_add ((GeeCollection*) _tmp20_, _tmp21_);
#line 464 "../src/db/SavedSearchDBTable.vala"
			_g_object_unref0 (_tmp14_);
#line 464 "../src/db/SavedSearchDBTable.vala"
			_saved_search_row_unref0 (row);
#line 2971 "SavedSearchDBTable.c"
		}
	}
#line 480 "../src/db/SavedSearchDBTable.vala"
	result = rows;
#line 480 "../src/db/SavedSearchDBTable.vala"
	_sqlite3_finalize0 (stmt);
#line 480 "../src/db/SavedSearchDBTable.vala"
	return result;
#line 2980 "SavedSearchDBTable.c"
}

void
saved_search_db_table_rename (SavedSearchDBTable* self,
                              SavedSearchID* search_id,
                              const gchar* new_name,
                              GError** error)
{
	SavedSearchID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 483 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (self != NULL);
#line 483 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (search_id != NULL);
#line 483 "../src/db/SavedSearchDBTable.vala"
	g_return_if_fail (new_name != NULL);
#line 484 "../src/db/SavedSearchDBTable.vala"
	_tmp0_ = *search_id;
#line 484 "../src/db/SavedSearchDBTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "name", new_name, &_inner_error0_);
#line 484 "../src/db/SavedSearchDBTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 484 "../src/db/SavedSearchDBTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 484 "../src/db/SavedSearchDBTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 484 "../src/db/SavedSearchDBTable.vala"
			return;
#line 3009 "SavedSearchDBTable.c"
		} else {
#line 484 "../src/db/SavedSearchDBTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 484 "../src/db/SavedSearchDBTable.vala"
			g_clear_error (&_inner_error0_);
#line 484 "../src/db/SavedSearchDBTable.vala"
			return;
#line 3017 "SavedSearchDBTable.c"
		}
	}
}

static void
saved_search_db_table_class_init (SavedSearchDBTableClass * klass,
                                  gpointer klass_data)
{
#line 46 "../src/db/SavedSearchDBTable.vala"
	saved_search_db_table_parent_class = g_type_class_peek_parent (klass);
#line 46 "../src/db/SavedSearchDBTable.vala"
	((DatabaseTableClass *) klass)->finalize = saved_search_db_table_finalize;
#line 3030 "SavedSearchDBTable.c"
}

static void
saved_search_db_table_instance_init (SavedSearchDBTable * self,
                                     gpointer klass)
{
}

static void
saved_search_db_table_finalize (DatabaseTable * obj)
{
	SavedSearchDBTable * self;
#line 46 "../src/db/SavedSearchDBTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SAVED_SEARCH_DB_TABLE, SavedSearchDBTable);
#line 46 "../src/db/SavedSearchDBTable.vala"
	DATABASE_TABLE_CLASS (saved_search_db_table_parent_class)->finalize (obj);
#line 3047 "SavedSearchDBTable.c"
}

static GType
saved_search_db_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SavedSearchDBTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) saved_search_db_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SavedSearchDBTable), 0, (GInstanceInitFunc) saved_search_db_table_instance_init, NULL };
	GType saved_search_db_table_type_id;
	saved_search_db_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "SavedSearchDBTable", &g_define_type_info, 0);
	return saved_search_db_table_type_id;
}

GType
saved_search_db_table_get_type (void)
{
	static volatile gsize saved_search_db_table_type_id__once = 0;
	if (g_once_init_enter (&saved_search_db_table_type_id__once)) {
		GType saved_search_db_table_type_id;
		saved_search_db_table_type_id = saved_search_db_table_get_type_once ();
		g_once_init_leave (&saved_search_db_table_type_id__once, saved_search_db_table_type_id);
	}
	return saved_search_db_table_type_id__once;
}

