/* VideoTable.c generated by valac 0.56.18, the Vala compiler
 * generated from VideoTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <gee.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecVideoRow ParamSpecVideoRow;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _video_row_unref0(var) ((var == NULL) ? NULL : (var = (video_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ParamSpecVideoRow {
	GParamSpec parent_instance;
};

static gpointer video_row_parent_class = NULL;
static gpointer video_table_parent_class = NULL;
static VideoTable* video_table_instance;
static VideoTable* video_table_instance = NULL;

static void video_row_finalize (VideoRow * obj);
static GType video_row_get_type_once (void);
static VideoTable* video_table_new (void);
static VideoTable* video_table_construct (GType object_type);
static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self,
                                              GFile* file,
                                              const gchar* md5);
static void _vala_array_add50 (VideoID* * array,
                        gint* length,
                        gint* size,
                        const VideoID* value);
static void video_table_finalize (DatabaseTable * obj);
static GType video_table_get_type_once (void);

void
video_id_init (VideoID *self,
               gint64 id)
{
#line 25 "../src/db/VideoTable.vala"
	memset (self, 0, sizeof (VideoID));
#line 26 "../src/db/VideoTable.vala"
	(*self).id = id;
#line 85 "VideoTable.c"
}

gboolean
video_id_is_invalid (VideoID *self)
{
	gboolean result;
#line 30 "../src/db/VideoTable.vala"
	result = (*self).id == VIDEO_ID_INVALID;
#line 30 "../src/db/VideoTable.vala"
	return result;
#line 96 "VideoTable.c"
}

gboolean
video_id_is_valid (VideoID *self)
{
	gboolean result;
#line 34 "../src/db/VideoTable.vala"
	result = (*self).id != VIDEO_ID_INVALID;
#line 34 "../src/db/VideoTable.vala"
	return result;
#line 107 "VideoTable.c"
}

guint
video_id_hash (VideoID* a)
{
	guint result;
#line 38 "../src/db/VideoTable.vala"
	result = int64_hash (&(*a).id);
#line 38 "../src/db/VideoTable.vala"
	return result;
#line 118 "VideoTable.c"
}

gboolean
video_id_equal (void* a,
                void* b)
{
	gboolean result;
#line 42 "../src/db/VideoTable.vala"
	result = (*((VideoID*) a)).id == (*((VideoID*) b)).id;
#line 42 "../src/db/VideoTable.vala"
	return result;
#line 130 "VideoTable.c"
}

gchar*
video_id_upgrade_video_id_to_source_id (VideoID* video_id)
{
	VideoID _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 45 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 46 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 46 "../src/db/VideoTable.vala"
	_tmp1_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", VIDEO_TYPENAME, _tmp0_.id);
#line 46 "../src/db/VideoTable.vala"
	result = _tmp1_;
#line 46 "../src/db/VideoTable.vala"
	return result;
#line 149 "VideoTable.c"
}

VideoID*
video_id_dup (const VideoID* self)
{
	VideoID* dup;
#line 20 "../src/db/VideoTable.vala"
	dup = g_new0 (VideoID, 1);
#line 20 "../src/db/VideoTable.vala"
	memcpy (dup, self, sizeof (VideoID));
#line 20 "../src/db/VideoTable.vala"
	return dup;
#line 162 "VideoTable.c"
}

void
video_id_free (VideoID* self)
{
#line 20 "../src/db/VideoTable.vala"
	g_free (self);
#line 170 "VideoTable.c"
}

static GType
video_id_get_type_once (void)
{
	GType video_id_type_id;
	video_id_type_id = g_boxed_type_register_static ("VideoID", (GBoxedCopyFunc) video_id_dup, (GBoxedFreeFunc) video_id_free);
	return video_id_type_id;
}

GType
video_id_get_type (void)
{
	static volatile gsize video_id_type_id__once = 0;
	if (g_once_init_enter (&video_id_type_id__once)) {
		GType video_id_type_id;
		video_id_type_id = video_id_get_type_once ();
		g_once_init_leave (&video_id_type_id__once, video_id_type_id);
	}
	return video_id_type_id__once;
}

VideoRow*
video_row_construct (GType object_type)
{
	VideoRow* self = NULL;
#line 50 "../src/db/VideoTable.vala"
	self = (VideoRow*) g_type_create_instance (object_type);
#line 50 "../src/db/VideoTable.vala"
	return self;
#line 201 "VideoTable.c"
}

VideoRow*
video_row_new (void)
{
#line 50 "../src/db/VideoTable.vala"
	return video_row_construct (TYPE_VIDEO_ROW);
#line 209 "VideoTable.c"
}

static void
value_video_row_init (GValue* value)
{
#line 50 "../src/db/VideoTable.vala"
	value->data[0].v_pointer = NULL;
#line 217 "VideoTable.c"
}

static void
value_video_row_free_value (GValue* value)
{
#line 50 "../src/db/VideoTable.vala"
	if (value->data[0].v_pointer) {
#line 50 "../src/db/VideoTable.vala"
		video_row_unref (value->data[0].v_pointer);
#line 227 "VideoTable.c"
	}
}

static void
value_video_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 50 "../src/db/VideoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 50 "../src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = video_row_ref (src_value->data[0].v_pointer);
#line 239 "VideoTable.c"
	} else {
#line 50 "../src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 243 "VideoTable.c"
	}
}

static gpointer
value_video_row_peek_pointer (const GValue* value)
{
#line 50 "../src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 252 "VideoTable.c"
}

static gchar*
value_video_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 50 "../src/db/VideoTable.vala"
	if (collect_values[0].v_pointer) {
#line 263 "VideoTable.c"
		VideoRow * object;
		object = collect_values[0].v_pointer;
#line 50 "../src/db/VideoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 50 "../src/db/VideoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 270 "VideoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 50 "../src/db/VideoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 274 "VideoTable.c"
		}
#line 50 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = video_row_ref (object);
#line 278 "VideoTable.c"
	} else {
#line 50 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 282 "VideoTable.c"
	}
#line 50 "../src/db/VideoTable.vala"
	return NULL;
#line 286 "VideoTable.c"
}

static gchar*
value_video_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	VideoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 50 "../src/db/VideoTable.vala"
	if (!object_p) {
#line 50 "../src/db/VideoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 301 "VideoTable.c"
	}
#line 50 "../src/db/VideoTable.vala"
	if (!value->data[0].v_pointer) {
#line 50 "../src/db/VideoTable.vala"
		*object_p = NULL;
#line 307 "VideoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 50 "../src/db/VideoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 311 "VideoTable.c"
	} else {
#line 50 "../src/db/VideoTable.vala"
		*object_p = video_row_ref (value->data[0].v_pointer);
#line 315 "VideoTable.c"
	}
#line 50 "../src/db/VideoTable.vala"
	return NULL;
#line 319 "VideoTable.c"
}

GParamSpec*
param_spec_video_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecVideoRow* spec;
#line 50 "../src/db/VideoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_ROW), NULL);
#line 50 "../src/db/VideoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 50 "../src/db/VideoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 50 "../src/db/VideoTable.vala"
	return G_PARAM_SPEC (spec);
#line 338 "VideoTable.c"
}

gpointer
value_get_video_row (const GValue* value)
{
#line 50 "../src/db/VideoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW), NULL);
#line 50 "../src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 348 "VideoTable.c"
}

void
value_set_video_row (GValue* value,
                     gpointer v_object)
{
	VideoRow * old;
#line 50 "../src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 50 "../src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 50 "../src/db/VideoTable.vala"
	if (v_object) {
#line 50 "../src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 50 "../src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 50 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 50 "../src/db/VideoTable.vala"
		video_row_ref (value->data[0].v_pointer);
#line 370 "VideoTable.c"
	} else {
#line 50 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 374 "VideoTable.c"
	}
#line 50 "../src/db/VideoTable.vala"
	if (old) {
#line 50 "../src/db/VideoTable.vala"
		video_row_unref (old);
#line 380 "VideoTable.c"
	}
}

void
value_take_video_row (GValue* value,
                      gpointer v_object)
{
	VideoRow * old;
#line 50 "../src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 50 "../src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 50 "../src/db/VideoTable.vala"
	if (v_object) {
#line 50 "../src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 50 "../src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 50 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 401 "VideoTable.c"
	} else {
#line 50 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 405 "VideoTable.c"
	}
#line 50 "../src/db/VideoTable.vala"
	if (old) {
#line 50 "../src/db/VideoTable.vala"
		video_row_unref (old);
#line 411 "VideoTable.c"
	}
}

static void
video_row_class_init (VideoRowClass * klass,
                      gpointer klass_data)
{
#line 50 "../src/db/VideoTable.vala"
	video_row_parent_class = g_type_class_peek_parent (klass);
#line 50 "../src/db/VideoTable.vala"
	((VideoRowClass *) klass)->finalize = video_row_finalize;
#line 423 "VideoTable.c"
}

static void
video_row_instance_init (VideoRow * self,
                         gpointer klass)
{
#line 50 "../src/db/VideoTable.vala"
	self->ref_count = 1;
#line 432 "VideoTable.c"
}

static void
video_row_finalize (VideoRow * obj)
{
	VideoRow * self;
#line 50 "../src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_ROW, VideoRow);
#line 50 "../src/db/VideoTable.vala"
	g_signal_handlers_destroy (self);
#line 52 "../src/db/VideoTable.vala"
	_g_free0 (self->filepath);
#line 62 "../src/db/VideoTable.vala"
	_g_free0 (self->md5);
#line 64 "../src/db/VideoTable.vala"
	_g_free0 (self->title);
#line 65 "../src/db/VideoTable.vala"
	_g_free0 (self->backlinks);
#line 68 "../src/db/VideoTable.vala"
	_g_free0 (self->comment);
#line 453 "VideoTable.c"
}

static GType
video_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_video_row_init, value_video_row_free_value, value_video_row_copy_value, value_video_row_peek_pointer, "p", value_video_row_collect_value, "p", value_video_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (VideoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoRow), 0, (GInstanceInitFunc) video_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType video_row_type_id;
	video_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return video_row_type_id;
}

GType
video_row_get_type (void)
{
	static volatile gsize video_row_type_id__once = 0;
	if (g_once_init_enter (&video_row_type_id__once)) {
		GType video_row_type_id;
		video_row_type_id = video_row_get_type_once ();
		g_once_init_leave (&video_row_type_id__once, video_row_type_id);
	}
	return video_row_type_id__once;
}

gpointer
video_row_ref (gpointer instance)
{
	VideoRow * self;
	self = instance;
#line 50 "../src/db/VideoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 50 "../src/db/VideoTable.vala"
	return instance;
#line 488 "VideoTable.c"
}

void
video_row_unref (gpointer instance)
{
	VideoRow * self;
	self = instance;
#line 50 "../src/db/VideoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 50 "../src/db/VideoTable.vala"
		VIDEO_ROW_GET_CLASS (self)->finalize (self);
#line 50 "../src/db/VideoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 502 "VideoTable.c"
	}
}

static VideoTable*
video_table_construct (GType object_type)
{
	VideoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
#line 74 "../src/db/VideoTable.vala"
	self = (VideoTable*) database_table_construct (object_type);
#line 75 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS VideoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "clip_duration REAL, " "is_interpretable INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "md5 TEXT, " "time_created INTEGER, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "flags INTEGER DEFAULT 0, " "comment TEXT " ")");
#line 75 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 96 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 96 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 97 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 98 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", res);
#line 530 "VideoTable.c"
	}
#line 101 "../src/db/VideoTable.vala"
	_tmp2_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS VideoEventIDIndex ON VideoTable (event_id)");
#line 101 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 101 "../src/db/VideoTable.vala"
	stmt = _tmp2_;
#line 102 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 102 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 103 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 104 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", res);
#line 546 "VideoTable.c"
	}
#line 106 "../src/db/VideoTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "VideoTable");
#line 74 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 74 "../src/db/VideoTable.vala"
	return self;
#line 554 "VideoTable.c"
}

static VideoTable*
video_table_new (void)
{
#line 74 "../src/db/VideoTable.vala"
	return video_table_construct (TYPE_VIDEO_TABLE);
#line 562 "VideoTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 113 "../src/db/VideoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 570 "VideoTable.c"
}

VideoTable*
video_table_get_instance (void)
{
	VideoTable* _tmp0_;
	VideoTable* _tmp2_;
	VideoTable* _tmp3_;
	VideoTable* result;
#line 110 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_instance;
#line 110 "../src/db/VideoTable.vala"
	if (_tmp0_ == NULL) {
#line 584 "VideoTable.c"
		VideoTable* _tmp1_;
#line 111 "../src/db/VideoTable.vala"
		_tmp1_ = video_table_new ();
#line 111 "../src/db/VideoTable.vala"
		_database_table_unref0 (video_table_instance);
#line 111 "../src/db/VideoTable.vala"
		video_table_instance = _tmp1_;
#line 592 "VideoTable.c"
	}
#line 113 "../src/db/VideoTable.vala"
	_tmp2_ = video_table_instance;
#line 113 "../src/db/VideoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 113 "../src/db/VideoTable.vala"
	result = _tmp3_;
#line 113 "../src/db/VideoTable.vala"
	return result;
#line 602 "VideoTable.c"
}

void
video_table_add (VideoTable* self,
                 VideoRow* video_row,
                 VideoID* result,
                 GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_ = 0;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp11_;
	ImportID _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	const gchar* _tmp20_;
	gint res = 0;
	sqlite3_stmt* _tmp21_;
	sqlite3* _tmp22_;
	VideoID _tmp23_;
	GError* _inner_error0_ = NULL;
#line 118 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/db/VideoTable.vala"
	g_return_if_fail (video_row != NULL);
#line 119 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO VideoTable (filename, width, height, clip_duration, is_int" \
"erpretable, " "filesize, timestamp, exposure_time, import_id, event_id, md5, time_cre" \
"ated, title, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
#line 119 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 124 "../src/db/VideoTable.vala"
	time_created = now_sec ();
#line 126 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 126 "../src/db/VideoTable.vala"
	_tmp2_ = video_row->filepath;
#line 126 "../src/db/VideoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp2_);
#line 127 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 127 "../src/db/VideoTable.vala"
	database_table_bind_int (_tmp3_, 2, video_row->width);
#line 128 "../src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 128 "../src/db/VideoTable.vala"
	database_table_bind_int (_tmp4_, 3, video_row->height);
#line 129 "../src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 129 "../src/db/VideoTable.vala"
	database_table_bind_double (_tmp5_, 4, video_row->clip_duration);
#line 130 "../src/db/VideoTable.vala"
	if (video_row->is_interpretable) {
#line 130 "../src/db/VideoTable.vala"
		_tmp6_ = 1;
#line 671 "VideoTable.c"
	} else {
#line 130 "../src/db/VideoTable.vala"
		_tmp6_ = 0;
#line 675 "VideoTable.c"
	}
#line 130 "../src/db/VideoTable.vala"
	_tmp7_ = stmt;
#line 130 "../src/db/VideoTable.vala"
	database_table_bind_int (_tmp7_, 5, _tmp6_);
#line 131 "../src/db/VideoTable.vala"
	_tmp8_ = stmt;
#line 131 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp8_, 6, video_row->filesize);
#line 132 "../src/db/VideoTable.vala"
	_tmp9_ = stmt;
#line 132 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp9_, 7, video_row->timestamp);
#line 133 "../src/db/VideoTable.vala"
	_tmp10_ = stmt;
#line 133 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp10_, 8, video_row->exposure_time);
#line 134 "../src/db/VideoTable.vala"
	_tmp11_ = stmt;
#line 134 "../src/db/VideoTable.vala"
	_tmp12_ = video_row->import_id;
#line 134 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp11_, 9, _tmp12_.id);
#line 135 "../src/db/VideoTable.vala"
	_tmp13_ = stmt;
#line 135 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp13_, 10, EVENT_ID_INVALID);
#line 136 "../src/db/VideoTable.vala"
	_tmp14_ = stmt;
#line 136 "../src/db/VideoTable.vala"
	_tmp15_ = video_row->md5;
#line 136 "../src/db/VideoTable.vala"
	database_table_bind_text (_tmp14_, 11, _tmp15_);
#line 137 "../src/db/VideoTable.vala"
	_tmp16_ = stmt;
#line 137 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp16_, 12, time_created);
#line 138 "../src/db/VideoTable.vala"
	_tmp17_ = stmt;
#line 138 "../src/db/VideoTable.vala"
	_tmp18_ = video_row->title;
#line 138 "../src/db/VideoTable.vala"
	database_table_bind_text (_tmp17_, 13, _tmp18_);
#line 139 "../src/db/VideoTable.vala"
	_tmp19_ = stmt;
#line 139 "../src/db/VideoTable.vala"
	_tmp20_ = video_row->comment;
#line 139 "../src/db/VideoTable.vala"
	database_table_bind_text (_tmp19_, 14, _tmp20_);
#line 141 "../src/db/VideoTable.vala"
	_tmp21_ = stmt;
#line 141 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp21_);
#line 142 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 143 "../src/db/VideoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 144 "../src/db/VideoTable.vala"
			database_table_throw_error ("VideoTable.add", res, &_inner_error0_);
#line 144 "../src/db/VideoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/db/VideoTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 144 "../src/db/VideoTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 144 "../src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 144 "../src/db/VideoTable.vala"
					return;
#line 745 "VideoTable.c"
				} else {
#line 144 "../src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 144 "../src/db/VideoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/db/VideoTable.vala"
					g_clear_error (&_inner_error0_);
#line 144 "../src/db/VideoTable.vala"
					return;
#line 755 "VideoTable.c"
				}
			}
		}
	}
#line 148 "../src/db/VideoTable.vala"
	_tmp22_ = database_table_db;
#line 148 "../src/db/VideoTable.vala"
	video_id_init (&video_row->video_id, sqlite3_last_insert_rowid (_tmp22_));
#line 149 "../src/db/VideoTable.vala"
	event_id_init (&video_row->event_id, EVENT_ID_INVALID);
#line 150 "../src/db/VideoTable.vala"
	video_row->time_created = time_created;
#line 151 "../src/db/VideoTable.vala"
	video_row->flags = (guint64) 0;
#line 153 "../src/db/VideoTable.vala"
	_tmp23_ = video_row->video_id;
#line 153 "../src/db/VideoTable.vala"
	*result = _tmp23_;
#line 153 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 153 "../src/db/VideoTable.vala"
	return;
#line 778 "VideoTable.c"
}

gboolean
video_table_drop_event (VideoTable* self,
                        EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	EventID _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	gboolean result;
#line 156 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 157 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE VideoTable SET event_id = ? WHERE event_id = ?");
#line 157 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 159 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 159 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, EVENT_ID_INVALID);
#line 160 "../src/db/VideoTable.vala"
	_tmp2_ = stmt;
#line 160 "../src/db/VideoTable.vala"
	_tmp3_ = *event_id;
#line 160 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp2_, 2, _tmp3_.id);
#line 162 "../src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 162 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 163 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 164 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable.drop_event", res);
#line 166 "../src/db/VideoTable.vala"
		result = FALSE;
#line 166 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 166 "../src/db/VideoTable.vala"
		return result;
#line 825 "VideoTable.c"
	}
#line 169 "../src/db/VideoTable.vala"
	result = TRUE;
#line 169 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 169 "../src/db/VideoTable.vala"
	return result;
#line 833 "VideoTable.c"
}

VideoRow*
video_table_get_row (VideoTable* self,
                     VideoID* video_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	VideoID _tmp2_;
	sqlite3_stmt* _tmp3_;
	VideoRow* row = NULL;
	VideoRow* _tmp4_;
	VideoRow* _tmp5_;
	VideoID _tmp6_;
	VideoRow* _tmp7_;
	sqlite3_stmt* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	VideoRow* _tmp11_;
	sqlite3_stmt* _tmp12_;
	VideoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	VideoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	VideoRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	VideoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	VideoRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	VideoRow* _tmp23_;
	sqlite3_stmt* _tmp24_;
	VideoRow* _tmp25_;
	sqlite3_stmt* _tmp26_;
	VideoRow* _tmp27_;
	sqlite3_stmt* _tmp28_;
	VideoRow* _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	VideoRow* _tmp33_;
	sqlite3_stmt* _tmp34_;
	VideoRow* _tmp35_;
	sqlite3_stmt* _tmp36_;
	const gchar* _tmp37_;
	gchar* _tmp38_;
	VideoRow* _tmp39_;
	sqlite3_stmt* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	VideoRow* _tmp43_;
	sqlite3_stmt* _tmp44_;
	VideoRow* _tmp45_;
	sqlite3_stmt* _tmp46_;
	VideoRow* _tmp47_;
	sqlite3_stmt* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	VideoRow* result;
#line 172 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 172 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 173 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT filename, width, height, clip_duration, is_interpretable, files" \
"ize, timestamp, " "exposure_time, import_id, event_id, md5, time_created, title, backlink" \
"s, " "time_reimported, flags, comment FROM VideoTable WHERE id=?");
#line 173 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 178 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 178 "../src/db/VideoTable.vala"
	_tmp2_ = *video_id;
#line 178 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 180 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 180 "../src/db/VideoTable.vala"
	if (sqlite3_step (_tmp3_) != SQLITE_ROW) {
#line 181 "../src/db/VideoTable.vala"
		result = NULL;
#line 181 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 181 "../src/db/VideoTable.vala"
		return result;
#line 918 "VideoTable.c"
	}
#line 183 "../src/db/VideoTable.vala"
	_tmp4_ = video_row_new ();
#line 183 "../src/db/VideoTable.vala"
	row = _tmp4_;
#line 184 "../src/db/VideoTable.vala"
	_tmp5_ = row;
#line 184 "../src/db/VideoTable.vala"
	_tmp6_ = *video_id;
#line 184 "../src/db/VideoTable.vala"
	_tmp5_->video_id = _tmp6_;
#line 185 "../src/db/VideoTable.vala"
	_tmp7_ = row;
#line 185 "../src/db/VideoTable.vala"
	_tmp8_ = stmt;
#line 185 "../src/db/VideoTable.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 0);
#line 185 "../src/db/VideoTable.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 185 "../src/db/VideoTable.vala"
	_g_free0 (_tmp7_->filepath);
#line 185 "../src/db/VideoTable.vala"
	_tmp7_->filepath = _tmp10_;
#line 186 "../src/db/VideoTable.vala"
	_tmp11_ = row;
#line 186 "../src/db/VideoTable.vala"
	_tmp12_ = stmt;
#line 186 "../src/db/VideoTable.vala"
	_tmp11_->width = sqlite3_column_int (_tmp12_, 1);
#line 187 "../src/db/VideoTable.vala"
	_tmp13_ = row;
#line 187 "../src/db/VideoTable.vala"
	_tmp14_ = stmt;
#line 187 "../src/db/VideoTable.vala"
	_tmp13_->height = sqlite3_column_int (_tmp14_, 2);
#line 188 "../src/db/VideoTable.vala"
	_tmp15_ = row;
#line 188 "../src/db/VideoTable.vala"
	_tmp16_ = stmt;
#line 188 "../src/db/VideoTable.vala"
	_tmp15_->clip_duration = sqlite3_column_double (_tmp16_, 3);
#line 189 "../src/db/VideoTable.vala"
	_tmp17_ = row;
#line 189 "../src/db/VideoTable.vala"
	_tmp18_ = stmt;
#line 189 "../src/db/VideoTable.vala"
	_tmp17_->is_interpretable = sqlite3_column_int (_tmp18_, 4) == 1;
#line 190 "../src/db/VideoTable.vala"
	_tmp19_ = row;
#line 190 "../src/db/VideoTable.vala"
	_tmp20_ = stmt;
#line 190 "../src/db/VideoTable.vala"
	_tmp19_->filesize = sqlite3_column_int64 (_tmp20_, 5);
#line 191 "../src/db/VideoTable.vala"
	_tmp21_ = row;
#line 191 "../src/db/VideoTable.vala"
	_tmp22_ = stmt;
#line 191 "../src/db/VideoTable.vala"
	_tmp21_->timestamp = sqlite3_column_int64 (_tmp22_, 6);
#line 192 "../src/db/VideoTable.vala"
	_tmp23_ = row;
#line 192 "../src/db/VideoTable.vala"
	_tmp24_ = stmt;
#line 192 "../src/db/VideoTable.vala"
	_tmp23_->exposure_time = sqlite3_column_int64 (_tmp24_, 7);
#line 193 "../src/db/VideoTable.vala"
	_tmp25_ = row;
#line 193 "../src/db/VideoTable.vala"
	_tmp26_ = stmt;
#line 193 "../src/db/VideoTable.vala"
	_tmp25_->import_id.id = sqlite3_column_int64 (_tmp26_, 8);
#line 194 "../src/db/VideoTable.vala"
	_tmp27_ = row;
#line 194 "../src/db/VideoTable.vala"
	_tmp28_ = stmt;
#line 194 "../src/db/VideoTable.vala"
	_tmp27_->event_id.id = sqlite3_column_int64 (_tmp28_, 9);
#line 195 "../src/db/VideoTable.vala"
	_tmp29_ = row;
#line 195 "../src/db/VideoTable.vala"
	_tmp30_ = stmt;
#line 195 "../src/db/VideoTable.vala"
	_tmp31_ = (const gchar*) sqlite3_column_text (_tmp30_, 10);
#line 195 "../src/db/VideoTable.vala"
	_tmp32_ = g_strdup (_tmp31_);
#line 195 "../src/db/VideoTable.vala"
	_g_free0 (_tmp29_->md5);
#line 195 "../src/db/VideoTable.vala"
	_tmp29_->md5 = _tmp32_;
#line 196 "../src/db/VideoTable.vala"
	_tmp33_ = row;
#line 196 "../src/db/VideoTable.vala"
	_tmp34_ = stmt;
#line 196 "../src/db/VideoTable.vala"
	_tmp33_->time_created = sqlite3_column_int64 (_tmp34_, 11);
#line 197 "../src/db/VideoTable.vala"
	_tmp35_ = row;
#line 197 "../src/db/VideoTable.vala"
	_tmp36_ = stmt;
#line 197 "../src/db/VideoTable.vala"
	_tmp37_ = (const gchar*) sqlite3_column_text (_tmp36_, 12);
#line 197 "../src/db/VideoTable.vala"
	_tmp38_ = g_strdup (_tmp37_);
#line 197 "../src/db/VideoTable.vala"
	_g_free0 (_tmp35_->title);
#line 197 "../src/db/VideoTable.vala"
	_tmp35_->title = _tmp38_;
#line 198 "../src/db/VideoTable.vala"
	_tmp39_ = row;
#line 198 "../src/db/VideoTable.vala"
	_tmp40_ = stmt;
#line 198 "../src/db/VideoTable.vala"
	_tmp41_ = (const gchar*) sqlite3_column_text (_tmp40_, 13);
#line 198 "../src/db/VideoTable.vala"
	_tmp42_ = g_strdup (_tmp41_);
#line 198 "../src/db/VideoTable.vala"
	_g_free0 (_tmp39_->backlinks);
#line 198 "../src/db/VideoTable.vala"
	_tmp39_->backlinks = _tmp42_;
#line 199 "../src/db/VideoTable.vala"
	_tmp43_ = row;
#line 199 "../src/db/VideoTable.vala"
	_tmp44_ = stmt;
#line 199 "../src/db/VideoTable.vala"
	_tmp43_->time_reimported = sqlite3_column_int64 (_tmp44_, 14);
#line 200 "../src/db/VideoTable.vala"
	_tmp45_ = row;
#line 200 "../src/db/VideoTable.vala"
	_tmp46_ = stmt;
#line 200 "../src/db/VideoTable.vala"
	_tmp45_->flags = (guint64) sqlite3_column_int64 (_tmp46_, 15);
#line 201 "../src/db/VideoTable.vala"
	_tmp47_ = row;
#line 201 "../src/db/VideoTable.vala"
	_tmp48_ = stmt;
#line 201 "../src/db/VideoTable.vala"
	_tmp49_ = (const gchar*) sqlite3_column_text (_tmp48_, 16);
#line 201 "../src/db/VideoTable.vala"
	_tmp50_ = g_strdup (_tmp49_);
#line 201 "../src/db/VideoTable.vala"
	_g_free0 (_tmp47_->comment);
#line 201 "../src/db/VideoTable.vala"
	_tmp47_->comment = _tmp50_;
#line 203 "../src/db/VideoTable.vala"
	result = row;
#line 203 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 203 "../src/db/VideoTable.vala"
	return result;
#line 1068 "VideoTable.c"
}

GeeArrayList*
video_table_get_all (VideoTable* self)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* result;
#line 206 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id, filename, width, height, clip_duration, is_interpretable, f" \
"ilesize, " "timestamp, exposure_time, import_id, event_id, md5, time_created, titl" \
"e, " "backlinks, time_reimported, flags, comment FROM VideoTable");
#line 208 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 213 "../src/db/VideoTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_VIDEO_ROW, (GBoxedCopyFunc) video_row_ref, (GDestroyNotify) video_row_unref, NULL, NULL, NULL);
#line 213 "../src/db/VideoTable.vala"
	all = _tmp1_;
#line 215 "../src/db/VideoTable.vala"
	while (TRUE) {
#line 1091 "VideoTable.c"
		sqlite3_stmt* _tmp2_;
		VideoRow* row = NULL;
		VideoRow* _tmp3_;
		VideoRow* _tmp4_;
		sqlite3_stmt* _tmp5_;
		VideoRow* _tmp6_;
		sqlite3_stmt* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		VideoRow* _tmp10_;
		sqlite3_stmt* _tmp11_;
		VideoRow* _tmp12_;
		sqlite3_stmt* _tmp13_;
		VideoRow* _tmp14_;
		sqlite3_stmt* _tmp15_;
		VideoRow* _tmp16_;
		sqlite3_stmt* _tmp17_;
		VideoRow* _tmp18_;
		sqlite3_stmt* _tmp19_;
		VideoRow* _tmp20_;
		sqlite3_stmt* _tmp21_;
		VideoRow* _tmp22_;
		sqlite3_stmt* _tmp23_;
		VideoRow* _tmp24_;
		sqlite3_stmt* _tmp25_;
		VideoRow* _tmp26_;
		sqlite3_stmt* _tmp27_;
		VideoRow* _tmp28_;
		sqlite3_stmt* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		VideoRow* _tmp32_;
		sqlite3_stmt* _tmp33_;
		VideoRow* _tmp34_;
		sqlite3_stmt* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		VideoRow* _tmp38_;
		sqlite3_stmt* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		VideoRow* _tmp42_;
		sqlite3_stmt* _tmp43_;
		VideoRow* _tmp44_;
		sqlite3_stmt* _tmp45_;
		VideoRow* _tmp46_;
		sqlite3_stmt* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		GeeArrayList* _tmp50_;
		VideoRow* _tmp51_;
#line 215 "../src/db/VideoTable.vala"
		_tmp2_ = stmt;
#line 215 "../src/db/VideoTable.vala"
		if (!(sqlite3_step (_tmp2_) == SQLITE_ROW)) {
#line 215 "../src/db/VideoTable.vala"
			break;
#line 1149 "VideoTable.c"
		}
#line 216 "../src/db/VideoTable.vala"
		_tmp3_ = video_row_new ();
#line 216 "../src/db/VideoTable.vala"
		row = _tmp3_;
#line 217 "../src/db/VideoTable.vala"
		_tmp4_ = row;
#line 217 "../src/db/VideoTable.vala"
		_tmp5_ = stmt;
#line 217 "../src/db/VideoTable.vala"
		_tmp4_->video_id.id = sqlite3_column_int64 (_tmp5_, 0);
#line 218 "../src/db/VideoTable.vala"
		_tmp6_ = row;
#line 218 "../src/db/VideoTable.vala"
		_tmp7_ = stmt;
#line 218 "../src/db/VideoTable.vala"
		_tmp8_ = (const gchar*) sqlite3_column_text (_tmp7_, 1);
#line 218 "../src/db/VideoTable.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 218 "../src/db/VideoTable.vala"
		_g_free0 (_tmp6_->filepath);
#line 218 "../src/db/VideoTable.vala"
		_tmp6_->filepath = _tmp9_;
#line 219 "../src/db/VideoTable.vala"
		_tmp10_ = row;
#line 219 "../src/db/VideoTable.vala"
		_tmp11_ = stmt;
#line 219 "../src/db/VideoTable.vala"
		_tmp10_->width = sqlite3_column_int (_tmp11_, 2);
#line 220 "../src/db/VideoTable.vala"
		_tmp12_ = row;
#line 220 "../src/db/VideoTable.vala"
		_tmp13_ = stmt;
#line 220 "../src/db/VideoTable.vala"
		_tmp12_->height = sqlite3_column_int (_tmp13_, 3);
#line 221 "../src/db/VideoTable.vala"
		_tmp14_ = row;
#line 221 "../src/db/VideoTable.vala"
		_tmp15_ = stmt;
#line 221 "../src/db/VideoTable.vala"
		_tmp14_->clip_duration = sqlite3_column_double (_tmp15_, 4);
#line 222 "../src/db/VideoTable.vala"
		_tmp16_ = row;
#line 222 "../src/db/VideoTable.vala"
		_tmp17_ = stmt;
#line 222 "../src/db/VideoTable.vala"
		_tmp16_->is_interpretable = sqlite3_column_int (_tmp17_, 5) == 1;
#line 223 "../src/db/VideoTable.vala"
		_tmp18_ = row;
#line 223 "../src/db/VideoTable.vala"
		_tmp19_ = stmt;
#line 223 "../src/db/VideoTable.vala"
		_tmp18_->filesize = sqlite3_column_int64 (_tmp19_, 6);
#line 224 "../src/db/VideoTable.vala"
		_tmp20_ = row;
#line 224 "../src/db/VideoTable.vala"
		_tmp21_ = stmt;
#line 224 "../src/db/VideoTable.vala"
		_tmp20_->timestamp = sqlite3_column_int64 (_tmp21_, 7);
#line 225 "../src/db/VideoTable.vala"
		_tmp22_ = row;
#line 225 "../src/db/VideoTable.vala"
		_tmp23_ = stmt;
#line 225 "../src/db/VideoTable.vala"
		_tmp22_->exposure_time = sqlite3_column_int64 (_tmp23_, 8);
#line 226 "../src/db/VideoTable.vala"
		_tmp24_ = row;
#line 226 "../src/db/VideoTable.vala"
		_tmp25_ = stmt;
#line 226 "../src/db/VideoTable.vala"
		_tmp24_->import_id.id = sqlite3_column_int64 (_tmp25_, 9);
#line 227 "../src/db/VideoTable.vala"
		_tmp26_ = row;
#line 227 "../src/db/VideoTable.vala"
		_tmp27_ = stmt;
#line 227 "../src/db/VideoTable.vala"
		_tmp26_->event_id.id = sqlite3_column_int64 (_tmp27_, 10);
#line 228 "../src/db/VideoTable.vala"
		_tmp28_ = row;
#line 228 "../src/db/VideoTable.vala"
		_tmp29_ = stmt;
#line 228 "../src/db/VideoTable.vala"
		_tmp30_ = (const gchar*) sqlite3_column_text (_tmp29_, 11);
#line 228 "../src/db/VideoTable.vala"
		_tmp31_ = g_strdup (_tmp30_);
#line 228 "../src/db/VideoTable.vala"
		_g_free0 (_tmp28_->md5);
#line 228 "../src/db/VideoTable.vala"
		_tmp28_->md5 = _tmp31_;
#line 229 "../src/db/VideoTable.vala"
		_tmp32_ = row;
#line 229 "../src/db/VideoTable.vala"
		_tmp33_ = stmt;
#line 229 "../src/db/VideoTable.vala"
		_tmp32_->time_created = sqlite3_column_int64 (_tmp33_, 12);
#line 230 "../src/db/VideoTable.vala"
		_tmp34_ = row;
#line 230 "../src/db/VideoTable.vala"
		_tmp35_ = stmt;
#line 230 "../src/db/VideoTable.vala"
		_tmp36_ = (const gchar*) sqlite3_column_text (_tmp35_, 13);
#line 230 "../src/db/VideoTable.vala"
		_tmp37_ = g_strdup (_tmp36_);
#line 230 "../src/db/VideoTable.vala"
		_g_free0 (_tmp34_->title);
#line 230 "../src/db/VideoTable.vala"
		_tmp34_->title = _tmp37_;
#line 231 "../src/db/VideoTable.vala"
		_tmp38_ = row;
#line 231 "../src/db/VideoTable.vala"
		_tmp39_ = stmt;
#line 231 "../src/db/VideoTable.vala"
		_tmp40_ = (const gchar*) sqlite3_column_text (_tmp39_, 14);
#line 231 "../src/db/VideoTable.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 231 "../src/db/VideoTable.vala"
		_g_free0 (_tmp38_->backlinks);
#line 231 "../src/db/VideoTable.vala"
		_tmp38_->backlinks = _tmp41_;
#line 232 "../src/db/VideoTable.vala"
		_tmp42_ = row;
#line 232 "../src/db/VideoTable.vala"
		_tmp43_ = stmt;
#line 232 "../src/db/VideoTable.vala"
		_tmp42_->time_reimported = sqlite3_column_int64 (_tmp43_, 15);
#line 233 "../src/db/VideoTable.vala"
		_tmp44_ = row;
#line 233 "../src/db/VideoTable.vala"
		_tmp45_ = stmt;
#line 233 "../src/db/VideoTable.vala"
		_tmp44_->flags = (guint64) sqlite3_column_int64 (_tmp45_, 16);
#line 234 "../src/db/VideoTable.vala"
		_tmp46_ = row;
#line 234 "../src/db/VideoTable.vala"
		_tmp47_ = stmt;
#line 234 "../src/db/VideoTable.vala"
		_tmp48_ = (const gchar*) sqlite3_column_text (_tmp47_, 17);
#line 234 "../src/db/VideoTable.vala"
		_tmp49_ = g_strdup (_tmp48_);
#line 234 "../src/db/VideoTable.vala"
		_g_free0 (_tmp46_->comment);
#line 234 "../src/db/VideoTable.vala"
		_tmp46_->comment = _tmp49_;
#line 236 "../src/db/VideoTable.vala"
		_tmp50_ = all;
#line 236 "../src/db/VideoTable.vala"
		_tmp51_ = row;
#line 236 "../src/db/VideoTable.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, _tmp51_);
#line 215 "../src/db/VideoTable.vala"
		_video_row_unref0 (row);
#line 1301 "VideoTable.c"
	}
#line 239 "../src/db/VideoTable.vala"
	result = all;
#line 239 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 239 "../src/db/VideoTable.vala"
	return result;
#line 1309 "VideoTable.c"
}

void
video_table_set_filepath (VideoTable* self,
                          VideoID* video_id,
                          const gchar* filepath,
                          GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 242 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 242 "../src/db/VideoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 243 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 243 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "filename", filepath, &_inner_error0_);
#line 243 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 243 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 243 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 243 "../src/db/VideoTable.vala"
			return;
#line 1338 "VideoTable.c"
		} else {
#line 243 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 243 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 243 "../src/db/VideoTable.vala"
			return;
#line 1346 "VideoTable.c"
		}
	}
}

void
video_table_set_title (VideoTable* self,
                       VideoID* video_id,
                       const gchar* new_title,
                       GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 246 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 247 "../src/db/VideoTable.vala"
	if (new_title != NULL) {
#line 247 "../src/db/VideoTable.vala"
		_tmp0_ = new_title;
#line 1368 "VideoTable.c"
	} else {
#line 247 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1372 "VideoTable.c"
	}
#line 247 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 247 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp1_.id, "title", _tmp0_, &_inner_error0_);
#line 247 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 247 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 247 "../src/db/VideoTable.vala"
			return;
#line 1386 "VideoTable.c"
		} else {
#line 247 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 247 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 247 "../src/db/VideoTable.vala"
			return;
#line 1394 "VideoTable.c"
		}
	}
}

void
video_table_set_comment (VideoTable* self,
                         VideoID* video_id,
                         const gchar* new_comment,
                         GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 250 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 251 "../src/db/VideoTable.vala"
	if (new_comment != NULL) {
#line 251 "../src/db/VideoTable.vala"
		_tmp0_ = new_comment;
#line 1416 "VideoTable.c"
	} else {
#line 251 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1420 "VideoTable.c"
	}
#line 251 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 251 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp1_.id, "comment", _tmp0_, &_inner_error0_);
#line 251 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 251 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 251 "../src/db/VideoTable.vala"
			return;
#line 1434 "VideoTable.c"
		} else {
#line 251 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 251 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 251 "../src/db/VideoTable.vala"
			return;
#line 1442 "VideoTable.c"
		}
	}
}

void
video_table_set_exposure_time (VideoTable* self,
                               VideoID* video_id,
                               gint64 time,
                               GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 254 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 255 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 255 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "exposure_time", time, &_inner_error0_);
#line 255 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 255 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 255 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 255 "../src/db/VideoTable.vala"
			return;
#line 1471 "VideoTable.c"
		} else {
#line 255 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 255 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 255 "../src/db/VideoTable.vala"
			return;
#line 1479 "VideoTable.c"
		}
	}
}

void
video_table_set_flags (VideoTable* self,
                       VideoID* video_id,
                       guint64 flags,
                       GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 258 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 259 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 259 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "flags", (gint64) flags, &_inner_error0_);
#line 259 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 259 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 259 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 259 "../src/db/VideoTable.vala"
			return;
#line 1508 "VideoTable.c"
		} else {
#line 259 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 259 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 259 "../src/db/VideoTable.vala"
			return;
#line 1516 "VideoTable.c"
		}
	}
}

void
video_table_update_backlinks (VideoTable* self,
                              VideoID* video_id,
                              const gchar* backlinks,
                              GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 262 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 263 "../src/db/VideoTable.vala"
	if (backlinks != NULL) {
#line 263 "../src/db/VideoTable.vala"
		_tmp0_ = backlinks;
#line 1538 "VideoTable.c"
	} else {
#line 263 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1542 "VideoTable.c"
	}
#line 263 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 263 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp1_.id, "backlinks", _tmp0_, &_inner_error0_);
#line 263 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 263 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 263 "../src/db/VideoTable.vala"
			return;
#line 1556 "VideoTable.c"
		} else {
#line 263 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 263 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 263 "../src/db/VideoTable.vala"
			return;
#line 1564 "VideoTable.c"
		}
	}
}

void
video_table_update_is_interpretable (VideoTable* self,
                                     VideoID* video_id,
                                     gboolean is_interpretable,
                                     GError** error)
{
	gint _tmp0_ = 0;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 266 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 266 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 267 "../src/db/VideoTable.vala"
	if (is_interpretable) {
#line 267 "../src/db/VideoTable.vala"
		_tmp0_ = 1;
#line 1586 "VideoTable.c"
	} else {
#line 267 "../src/db/VideoTable.vala"
		_tmp0_ = 0;
#line 1590 "VideoTable.c"
	}
#line 267 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 267 "../src/db/VideoTable.vala"
	database_table_update_int_by_id_2 ((DatabaseTable*) self, _tmp1_.id, "is_interpretable", _tmp0_, &_inner_error0_);
#line 267 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 267 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 267 "../src/db/VideoTable.vala"
			return;
#line 1604 "VideoTable.c"
		} else {
#line 267 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 267 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 267 "../src/db/VideoTable.vala"
			return;
#line 1612 "VideoTable.c"
		}
	}
}

gboolean
video_table_set_event (VideoTable* self,
                       VideoID* video_id,
                       EventID* event_id)
{
	VideoID _tmp0_;
	EventID _tmp1_;
	gboolean result;
#line 270 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 270 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, FALSE);
#line 270 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 271 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 271 "../src/db/VideoTable.vala"
	_tmp1_ = *event_id;
#line 271 "../src/db/VideoTable.vala"
	result = database_table_update_int64_by_id ((DatabaseTable*) self, _tmp0_.id, "event_id", _tmp1_.id);
#line 271 "../src/db/VideoTable.vala"
	return result;
#line 1639 "VideoTable.c"
}

void
video_table_remove_by_file (VideoTable* self,
                            GFile* file,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 274 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/db/VideoTable.vala"
	g_return_if_fail (file != NULL);
#line 275 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "DELETE FROM VideoTable WHERE filename=?");
#line 275 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 277 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 277 "../src/db/VideoTable.vala"
	_tmp2_ = g_file_get_path (file);
#line 277 "../src/db/VideoTable.vala"
	_tmp3_ = _tmp2_;
#line 277 "../src/db/VideoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp3_);
#line 277 "../src/db/VideoTable.vala"
	_g_free0 (_tmp3_);
#line 279 "../src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 279 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 280 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 281 "../src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove_by_file", res, &_inner_error0_);
#line 281 "../src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 281 "../src/db/VideoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 281 "../src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 281 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 281 "../src/db/VideoTable.vala"
				return;
#line 1691 "VideoTable.c"
			} else {
#line 281 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 281 "../src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 281 "../src/db/VideoTable.vala"
				g_clear_error (&_inner_error0_);
#line 281 "../src/db/VideoTable.vala"
				return;
#line 1701 "VideoTable.c"
			}
		}
	}
#line 274 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1707 "VideoTable.c"
}

void
video_table_remove (VideoTable* self,
                    VideoID* video_id,
                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	VideoID _tmp2_;
	gint res = 0;
	sqlite3_stmt* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 284 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 285 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "DELETE FROM VideoTable WHERE id=?");
#line 285 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 287 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 287 "../src/db/VideoTable.vala"
	_tmp2_ = *video_id;
#line 287 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 289 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 289 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 290 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 291 "../src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove", res, &_inner_error0_);
#line 291 "../src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "../src/db/VideoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 291 "../src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 291 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 291 "../src/db/VideoTable.vala"
				return;
#line 1754 "VideoTable.c"
			} else {
#line 291 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 291 "../src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 291 "../src/db/VideoTable.vala"
				g_clear_error (&_inner_error0_);
#line 291 "../src/db/VideoTable.vala"
				return;
#line 1764 "VideoTable.c"
			}
		}
	}
#line 284 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1770 "VideoTable.c"
}

gboolean
video_table_is_video_stored (VideoTable* self,
                             GFile* file)
{
	VideoID _tmp0_ = {0};
	gboolean result;
#line 294 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 294 "../src/db/VideoTable.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 295 "../src/db/VideoTable.vala"
	video_table_get_id (self, file, &_tmp0_);
#line 295 "../src/db/VideoTable.vala"
	result = video_id_is_valid (&_tmp0_);
#line 295 "../src/db/VideoTable.vala"
	return result;
#line 1789 "VideoTable.c"
}

void
video_table_get_id (VideoTable* self,
                    GFile* file,
                    VideoID* result)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	VideoID _tmp5_ = {0};
#line 298 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/db/VideoTable.vala"
	g_return_if_fail (file != NULL);
#line 299 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT ID FROM VideoTable WHERE filename=?");
#line 299 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 301 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 301 "../src/db/VideoTable.vala"
	_tmp2_ = g_file_get_path (file);
#line 301 "../src/db/VideoTable.vala"
	_tmp3_ = _tmp2_;
#line 301 "../src/db/VideoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp3_);
#line 301 "../src/db/VideoTable.vala"
	_g_free0 (_tmp3_);
#line 303 "../src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 303 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 304 "../src/db/VideoTable.vala"
	if (res == SQLITE_ROW) {
#line 1829 "VideoTable.c"
		sqlite3_stmt* _tmp6_;
#line 304 "../src/db/VideoTable.vala"
		_tmp6_ = stmt;
#line 304 "../src/db/VideoTable.vala"
		video_id_init (&_tmp5_, sqlite3_column_int64 (_tmp6_, 0));
#line 1835 "VideoTable.c"
	} else {
#line 304 "../src/db/VideoTable.vala"
		video_id_init (&_tmp5_, VIDEO_ID_INVALID);
#line 1839 "VideoTable.c"
	}
#line 304 "../src/db/VideoTable.vala"
	*result = _tmp5_;
#line 304 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 304 "../src/db/VideoTable.vala"
	return;
#line 1847 "VideoTable.c"
}

GeeArrayList*
video_table_get_videos (VideoTable* self,
                        GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* video_ids = NULL;
	GeeArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 307 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM VideoTable");
#line 308 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 310 "../src/db/VideoTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_VIDEO_ID, (GBoxedCopyFunc) video_id_dup, (GDestroyNotify) video_id_free, NULL, NULL, NULL);
#line 310 "../src/db/VideoTable.vala"
	video_ids = _tmp1_;
#line 1870 "VideoTable.c"
	{
		gboolean _tmp2_ = FALSE;
#line 311 "../src/db/VideoTable.vala"
		_tmp2_ = TRUE;
#line 311 "../src/db/VideoTable.vala"
		while (TRUE) {
#line 1877 "VideoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp3_;
			GeeArrayList* _tmp4_;
			sqlite3_stmt* _tmp5_;
			VideoID _tmp6_ = {0};
#line 311 "../src/db/VideoTable.vala"
			if (!_tmp2_) {
#line 1885 "VideoTable.c"
			}
#line 311 "../src/db/VideoTable.vala"
			_tmp2_ = FALSE;
#line 312 "../src/db/VideoTable.vala"
			_tmp3_ = stmt;
#line 312 "../src/db/VideoTable.vala"
			res = sqlite3_step (_tmp3_);
#line 313 "../src/db/VideoTable.vala"
			if (res == SQLITE_DONE) {
#line 314 "../src/db/VideoTable.vala"
				break;
#line 1897 "VideoTable.c"
			} else {
#line 315 "../src/db/VideoTable.vala"
				if (res != SQLITE_ROW) {
#line 316 "../src/db/VideoTable.vala"
					database_table_throw_error ("VideoTable.get_videos", res, &_inner_error0_);
#line 316 "../src/db/VideoTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 316 "../src/db/VideoTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 316 "../src/db/VideoTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 316 "../src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 316 "../src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 316 "../src/db/VideoTable.vala"
							return NULL;
#line 1915 "VideoTable.c"
						} else {
#line 316 "../src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 316 "../src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 316 "../src/db/VideoTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 316 "../src/db/VideoTable.vala"
							g_clear_error (&_inner_error0_);
#line 316 "../src/db/VideoTable.vala"
							return NULL;
#line 1927 "VideoTable.c"
						}
					}
				}
			}
#line 319 "../src/db/VideoTable.vala"
			_tmp4_ = video_ids;
#line 319 "../src/db/VideoTable.vala"
			_tmp5_ = stmt;
#line 319 "../src/db/VideoTable.vala"
			video_id_init (&_tmp6_, sqlite3_column_int64 (_tmp5_, 0));
#line 319 "../src/db/VideoTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, &_tmp6_);
#line 1940 "VideoTable.c"
		}
	}
#line 322 "../src/db/VideoTable.vala"
	result = video_ids;
#line 322 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 322 "../src/db/VideoTable.vala"
	return result;
#line 1949 "VideoTable.c"
}

static sqlite3_stmt*
video_table_get_duplicate_stmt (VideoTable* self,
                                GFile* file,
                                const gchar* md5)
{
	gboolean _tmp0_ = FALSE;
	gchar* sql = NULL;
	gchar* _tmp1_;
	gboolean first = FALSE;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint col = 0;
	sqlite3_stmt* result;
#line 325 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 326 "../src/db/VideoTable.vala"
		_tmp0_ = TRUE;
#line 1972 "VideoTable.c"
	} else {
#line 326 "../src/db/VideoTable.vala"
		_tmp0_ = md5 != NULL;
#line 1976 "VideoTable.c"
	}
#line 326 "../src/db/VideoTable.vala"
	_vala_assert (_tmp0_, "file != null || md5 != null");
#line 328 "../src/db/VideoTable.vala"
	_tmp1_ = g_strdup ("SELECT id FROM VideoTable WHERE");
#line 328 "../src/db/VideoTable.vala"
	sql = _tmp1_;
#line 329 "../src/db/VideoTable.vala"
	first = TRUE;
#line 331 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 1988 "VideoTable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 332 "../src/db/VideoTable.vala"
		_tmp2_ = sql;
#line 332 "../src/db/VideoTable.vala"
		_tmp3_ = g_strconcat (_tmp2_, " filename=?", NULL);
#line 332 "../src/db/VideoTable.vala"
		_g_free0 (sql);
#line 332 "../src/db/VideoTable.vala"
		sql = _tmp3_;
#line 333 "../src/db/VideoTable.vala"
		first = FALSE;
#line 2001 "VideoTable.c"
	}
#line 336 "../src/db/VideoTable.vala"
	if (md5 != NULL) {
#line 2005 "VideoTable.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 337 "../src/db/VideoTable.vala"
		if (!first) {
#line 2010 "VideoTable.c"
			const gchar* _tmp4_;
			gchar* _tmp5_;
#line 338 "../src/db/VideoTable.vala"
			_tmp4_ = sql;
#line 338 "../src/db/VideoTable.vala"
			_tmp5_ = g_strconcat (_tmp4_, " OR ", NULL);
#line 338 "../src/db/VideoTable.vala"
			_g_free0 (sql);
#line 338 "../src/db/VideoTable.vala"
			sql = _tmp5_;
#line 2021 "VideoTable.c"
		}
#line 340 "../src/db/VideoTable.vala"
		_tmp6_ = sql;
#line 340 "../src/db/VideoTable.vala"
		_tmp7_ = g_strconcat (_tmp6_, " md5=?", NULL);
#line 340 "../src/db/VideoTable.vala"
		_g_free0 (sql);
#line 340 "../src/db/VideoTable.vala"
		sql = _tmp7_;
#line 2031 "VideoTable.c"
	}
#line 344 "../src/db/VideoTable.vala"
	_tmp8_ = sql;
#line 344 "../src/db/VideoTable.vala"
	_tmp9_ = database_table_create_stmt ((DatabaseTable*) self, _tmp8_);
#line 344 "../src/db/VideoTable.vala"
	stmt = _tmp9_;
#line 346 "../src/db/VideoTable.vala"
	col = 1;
#line 348 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 2043 "VideoTable.c"
		sqlite3_stmt* _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 349 "../src/db/VideoTable.vala"
		_tmp10_ = stmt;
#line 349 "../src/db/VideoTable.vala"
		_tmp11_ = col;
#line 349 "../src/db/VideoTable.vala"
		col = _tmp11_ + 1;
#line 349 "../src/db/VideoTable.vala"
		_tmp12_ = g_file_get_path (file);
#line 349 "../src/db/VideoTable.vala"
		_tmp13_ = _tmp12_;
#line 349 "../src/db/VideoTable.vala"
		database_table_bind_text (_tmp10_, _tmp11_, _tmp13_);
#line 349 "../src/db/VideoTable.vala"
		_g_free0 (_tmp13_);
#line 2062 "VideoTable.c"
	}
#line 352 "../src/db/VideoTable.vala"
	if (md5 != NULL) {
#line 2066 "VideoTable.c"
		sqlite3_stmt* _tmp14_;
		gint _tmp15_;
		const gchar* _tmp16_;
#line 353 "../src/db/VideoTable.vala"
		_tmp14_ = stmt;
#line 353 "../src/db/VideoTable.vala"
		_tmp15_ = col;
#line 353 "../src/db/VideoTable.vala"
		col = _tmp15_ + 1;
#line 353 "../src/db/VideoTable.vala"
		_tmp16_ = md5;
#line 353 "../src/db/VideoTable.vala"
		database_table_bind_text (_tmp14_, _tmp15_, _tmp16_);
#line 2080 "VideoTable.c"
	}
#line 356 "../src/db/VideoTable.vala"
	result = stmt;
#line 356 "../src/db/VideoTable.vala"
	_g_free0 (sql);
#line 356 "../src/db/VideoTable.vala"
	return result;
#line 2088 "VideoTable.c"
}

gboolean
video_table_has_duplicate (VideoTable* self,
                           GFile* file,
                           const gchar* md5)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gboolean result;
#line 359 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 360 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
#line 360 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 361 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 361 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 363 "../src/db/VideoTable.vala"
	if (res == SQLITE_DONE) {
#line 365 "../src/db/VideoTable.vala"
		result = FALSE;
#line 365 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 365 "../src/db/VideoTable.vala"
		return result;
#line 2119 "VideoTable.c"
	} else {
#line 366 "../src/db/VideoTable.vala"
		if (res == SQLITE_ROW) {
#line 368 "../src/db/VideoTable.vala"
			result = TRUE;
#line 368 "../src/db/VideoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 368 "../src/db/VideoTable.vala"
			return result;
#line 2129 "VideoTable.c"
		} else {
#line 370 "../src/db/VideoTable.vala"
			database_table_fatal ("VideoTable.has_duplicate", res);
#line 2133 "VideoTable.c"
		}
	}
#line 373 "../src/db/VideoTable.vala"
	result = FALSE;
#line 373 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 373 "../src/db/VideoTable.vala"
	return result;
#line 2142 "VideoTable.c"
}

static void
_vala_array_add50 (VideoID* * array,
                   gint* length,
                   gint* size,
                   const VideoID* value)
{
#line 383 "../src/db/VideoTable.vala"
	if ((*length) == (*size)) {
#line 383 "../src/db/VideoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 383 "../src/db/VideoTable.vala"
		*array = g_renew (VideoID, *array, *size);
#line 2157 "VideoTable.c"
	}
#line 383 "../src/db/VideoTable.vala"
	(*array)[(*length)++] = *value;
#line 2161 "VideoTable.c"
}

VideoID*
video_table_get_duplicate_ids (VideoTable* self,
                               GFile* file,
                               const gchar* md5,
                               gint* result_length1)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	VideoID* ids = NULL;
	VideoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp2_;
	VideoID* _tmp6_;
	gint _tmp6__length1;
	VideoID* result;
#line 376 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 377 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
#line 377 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 379 "../src/db/VideoTable.vala"
	_tmp1_ = g_new0 (VideoID, 0);
#line 379 "../src/db/VideoTable.vala"
	ids = _tmp1_;
#line 379 "../src/db/VideoTable.vala"
	ids_length1 = 0;
#line 379 "../src/db/VideoTable.vala"
	_ids_size_ = ids_length1;
#line 381 "../src/db/VideoTable.vala"
	_tmp2_ = stmt;
#line 381 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp2_);
#line 382 "../src/db/VideoTable.vala"
	while (TRUE) {
#line 2201 "VideoTable.c"
		sqlite3_stmt* _tmp3_;
		VideoID _tmp4_ = {0};
		sqlite3_stmt* _tmp5_;
#line 382 "../src/db/VideoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 382 "../src/db/VideoTable.vala"
			break;
#line 2209 "VideoTable.c"
		}
#line 383 "../src/db/VideoTable.vala"
		_tmp3_ = stmt;
#line 383 "../src/db/VideoTable.vala"
		video_id_init (&_tmp4_, sqlite3_column_int64 (_tmp3_, 0));
#line 383 "../src/db/VideoTable.vala"
		_vala_array_add50 (&ids, &ids_length1, &_ids_size_, &_tmp4_);
#line 384 "../src/db/VideoTable.vala"
		_tmp5_ = stmt;
#line 384 "../src/db/VideoTable.vala"
		res = sqlite3_step (_tmp5_);
#line 2221 "VideoTable.c"
	}
#line 387 "../src/db/VideoTable.vala"
	_tmp6_ = ids;
#line 387 "../src/db/VideoTable.vala"
	_tmp6__length1 = ids_length1;
#line 387 "../src/db/VideoTable.vala"
	if (result_length1) {
#line 387 "../src/db/VideoTable.vala"
		*result_length1 = _tmp6__length1;
#line 2231 "VideoTable.c"
	}
#line 387 "../src/db/VideoTable.vala"
	result = _tmp6_;
#line 387 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 387 "../src/db/VideoTable.vala"
	return result;
#line 2239 "VideoTable.c"
}

GeeArrayList*
video_table_get_event_source_ids (VideoTable* self,
                                  EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* result;
#line 390 "../src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 390 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 391 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM VideoTable WHERE event_id = ?");
#line 391 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 393 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 393 "../src/db/VideoTable.vala"
	_tmp2_ = *event_id;
#line 393 "../src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 395 "../src/db/VideoTable.vala"
	_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 395 "../src/db/VideoTable.vala"
	_result_ = _tmp3_;
#line 2271 "VideoTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 396 "../src/db/VideoTable.vala"
		_tmp4_ = TRUE;
#line 396 "../src/db/VideoTable.vala"
		while (TRUE) {
#line 2278 "VideoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp5_;
			GeeArrayList* _tmp6_;
			sqlite3_stmt* _tmp7_;
			VideoID _tmp8_ = {0};
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 396 "../src/db/VideoTable.vala"
			if (!_tmp4_) {
#line 2288 "VideoTable.c"
			}
#line 396 "../src/db/VideoTable.vala"
			_tmp4_ = FALSE;
#line 397 "../src/db/VideoTable.vala"
			_tmp5_ = stmt;
#line 397 "../src/db/VideoTable.vala"
			res = sqlite3_step (_tmp5_);
#line 398 "../src/db/VideoTable.vala"
			if (res == SQLITE_DONE) {
#line 399 "../src/db/VideoTable.vala"
				break;
#line 2300 "VideoTable.c"
			} else {
#line 400 "../src/db/VideoTable.vala"
				if (res != SQLITE_ROW) {
#line 401 "../src/db/VideoTable.vala"
					database_table_fatal ("get_event_source_ids", res);
#line 403 "../src/db/VideoTable.vala"
					break;
#line 2308 "VideoTable.c"
				}
			}
#line 406 "../src/db/VideoTable.vala"
			_tmp6_ = _result_;
#line 406 "../src/db/VideoTable.vala"
			_tmp7_ = stmt;
#line 406 "../src/db/VideoTable.vala"
			video_id_init (&_tmp8_, sqlite3_column_int64 (_tmp7_, 0));
#line 406 "../src/db/VideoTable.vala"
			_tmp9_ = video_id_upgrade_video_id_to_source_id (&_tmp8_);
#line 406 "../src/db/VideoTable.vala"
			_tmp10_ = _tmp9_;
#line 406 "../src/db/VideoTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp10_);
#line 406 "../src/db/VideoTable.vala"
			_g_free0 (_tmp10_);
#line 2325 "VideoTable.c"
		}
	}
#line 409 "../src/db/VideoTable.vala"
	result = _result_;
#line 409 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 409 "../src/db/VideoTable.vala"
	return result;
#line 2334 "VideoTable.c"
}

void
video_table_set_timestamp (VideoTable* self,
                           VideoID* video_id,
                           gint64 timestamp,
                           GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 412 "../src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 412 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 413 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 413 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "timestamp", timestamp, &_inner_error0_);
#line 413 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 413 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 413 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 413 "../src/db/VideoTable.vala"
			return;
#line 2361 "VideoTable.c"
		} else {
#line 413 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 413 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 413 "../src/db/VideoTable.vala"
			return;
#line 2369 "VideoTable.c"
		}
	}
}

static void
video_table_class_init (VideoTableClass * klass,
                        gpointer klass_data)
{
#line 71 "../src/db/VideoTable.vala"
	video_table_parent_class = g_type_class_peek_parent (klass);
#line 71 "../src/db/VideoTable.vala"
	((DatabaseTableClass *) klass)->finalize = video_table_finalize;
#line 2382 "VideoTable.c"
}

static void
video_table_instance_init (VideoTable * self,
                           gpointer klass)
{
}

static void
video_table_finalize (DatabaseTable * obj)
{
	VideoTable * self;
#line 71 "../src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_TABLE, VideoTable);
#line 71 "../src/db/VideoTable.vala"
	DATABASE_TABLE_CLASS (video_table_parent_class)->finalize (obj);
#line 2399 "VideoTable.c"
}

static GType
video_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VideoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoTable), 0, (GInstanceInitFunc) video_table_instance_init, NULL };
	GType video_table_type_id;
	video_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VideoTable", &g_define_type_info, 0);
	return video_table_type_id;
}

GType
video_table_get_type (void)
{
	static volatile gsize video_table_type_id__once = 0;
	if (g_once_init_enter (&video_table_type_id__once)) {
		GType video_table_type_id;
		video_table_type_id = video_table_get_type_once ();
		g_once_init_leave (&video_table_type_id__once, video_table_type_id);
	}
	return video_table_type_id__once;
}

