/* PhotoCanvas.c generated by valac 0.56.18, the Vala compiler
 * generated from PhotoCanvas.vala, do not modify */

/*
* Copyright 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* This file is the master unit file for the EditingTools unit.  It should be edited to include
 * whatever code is deemed necessary.
 *
 * The init () and terminate () methods are mandatory.
 *
 * If the unit needs to be configured prior to initialization, add the proper parameters to
 * the preconfigure () method, implement it, and ensure in init () that it's been called.
 */
/* The PhotoCanvas is an interface object between an EditingTool and its host.  It provides objects*/
/* and primitives for an EditingTool to obtain information about the image, to draw on the host's*/
/* canvas, and to be signalled when the canvas and its pixbuf changes (is resized).*/

#include "io.elementary.photos.h"
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	EDITING_TOOLS_PHOTO_CANVAS_0_PROPERTY,
	EDITING_TOOLS_PHOTO_CANVAS_DEFAULT_CTX_PROPERTY,
	EDITING_TOOLS_PHOTO_CANVAS_SURFACE_DIM_PROPERTY,
	EDITING_TOOLS_PHOTO_CANVAS_SCALED_PIXBUF_PROPERTY,
	EDITING_TOOLS_PHOTO_CANVAS_SCALED_POSITION_PROPERTY,
	EDITING_TOOLS_PHOTO_CANVAS_DRAWING_WINDOW_PROPERTY,
	EDITING_TOOLS_PHOTO_CANVAS_CONTAINER_PROPERTY,
	EDITING_TOOLS_PHOTO_CANVAS_PHOTO_PROPERTY,
	EDITING_TOOLS_PHOTO_CANVAS_NUM_PROPERTIES
};
static GParamSpec* editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_NUM_PROPERTIES];
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
enum  {
	EDITING_TOOLS_PHOTO_CANVAS_NEW_SURFACE_SIGNAL,
	EDITING_TOOLS_PHOTO_CANVAS_RESIZED_SCALED_PIXBUF_SIGNAL,
	EDITING_TOOLS_PHOTO_CANVAS_NUM_SIGNALS
};
static guint editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_NUM_SIGNALS] = {0};

struct _EditingToolsPhotoCanvasPrivate {
	cairo_t* _default_ctx;
	Dimensions _surface_dim;
	GdkPixbuf* _scaled_pixbuf;
	GdkRectangle _scaled_position;
	GdkWindow* _drawing_window;
	GtkWindow* _container;
	Photo* _photo;
	cairo_surface_t* scaled;
};

static gint EditingToolsPhotoCanvas_private_offset;
static gpointer editing_tools_photo_canvas_parent_class = NULL;

static void editing_tools_photo_canvas_active_to_unscaled_point (EditingToolsPhotoCanvas* self,
                                                          GdkPoint* active_point,
                                                          GdkPoint* result);
static cairo_surface_t* editing_tools_photo_canvas_pixbuf_to_surface (EditingToolsPhotoCanvas* self,
                                                               cairo_t* default_ctx,
                                                               GdkPixbuf* pixbuf,
                                                               GdkRectangle* pos);
static void editing_tools_photo_canvas_real_repaint (EditingToolsPhotoCanvas* self);
VALA_EXTERN void set_source_color_from_string (cairo_t* ctx,
                                   const gchar* spec);
static GtkStyleContext* editing_tools_photo_canvas_real_get_style_context (EditingToolsPhotoCanvas* self);
static gboolean _dimensions_equal (const Dimensions * s1,
                            const Dimensions * s2);
static gboolean _cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                                     const cairo_rectangle_int_t * s2);
static void g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__BOXED_OBJECT_BOXED (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static GObject * editing_tools_photo_canvas_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void editing_tools_photo_canvas_finalize (GObject * obj);
static GType editing_tools_photo_canvas_get_type_once (void);
static void _vala_editing_tools_photo_canvas_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_editing_tools_photo_canvas_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
editing_tools_photo_canvas_get_instance_private (EditingToolsPhotoCanvas* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsPhotoCanvas_private_offset);
}

EditingToolsPhotoCanvas*
editing_tools_photo_canvas_construct (GType object_type,
                                      GtkWindow* container,
                                      GdkWindow* drawing_window,
                                      Photo* photo,
                                      cairo_t* default_ctx,
                                      Dimensions* surface_dim,
                                      GdkPixbuf* scaled_pixbuf,
                                      GdkRectangle* scaled_position)
{
	EditingToolsPhotoCanvas * self = NULL;
	Dimensions _tmp0_;
	GdkRectangle _tmp1_;
#line 46 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (container != NULL, NULL);
#line 46 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (drawing_window != NULL, NULL);
#line 46 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 46 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (default_ctx != NULL, NULL);
#line 46 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (surface_dim != NULL, NULL);
#line 46 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (scaled_pixbuf != NULL, NULL);
#line 46 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (scaled_position != NULL, NULL);
#line 48 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = *surface_dim;
#line 48 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = *scaled_position;
#line 48 "../src/editing_tools/PhotoCanvas.vala"
	self = (EditingToolsPhotoCanvas*) g_object_new (object_type, "container", container, "drawing-window", drawing_window, "photo", photo, "default-ctx", default_ctx, "surface-dim", &_tmp0_, "scaled-position", &_tmp1_, "scaled-pixbuf", scaled_pixbuf, NULL);
#line 46 "../src/editing_tools/PhotoCanvas.vala"
	return self;
#line 174 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_unscaled_to_raw_rect (EditingToolsPhotoCanvas* self,
                                                 GdkRectangle* rectangle,
                                                 GdkRectangle* result)
{
	Photo* _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_ = {0};
#line 63 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (rectangle != NULL);
#line 64 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_photo;
#line 64 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = *rectangle;
#line 64 "../src/editing_tools/PhotoCanvas.vala"
	photo_unscaled_to_raw_rect (_tmp0_, &_tmp1_, &_tmp2_);
#line 64 "../src/editing_tools/PhotoCanvas.vala"
	*result = _tmp2_;
#line 64 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 199 "PhotoCanvas.c"
}

static void
editing_tools_photo_canvas_active_to_unscaled_point (EditingToolsPhotoCanvas* self,
                                                     GdkPoint* active_point,
                                                     GdkPoint* result)
{
	Dimensions unscaled_dims = {0};
	Photo* _tmp0_;
	Dimensions _tmp1_ = {0};
	gdouble scale_factor_x = 0.0;
	Dimensions _tmp2_;
	GdkRectangle _tmp3_;
	gdouble scale_factor_y = 0.0;
	Dimensions _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _result_ = {0};
	GdkPoint _tmp6_ = {0};
	GdkPoint _tmp7_;
	GdkPoint _tmp8_;
#line 67 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (active_point != NULL);
#line 68 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_photo;
#line 68 "../src/editing_tools/PhotoCanvas.vala"
	media_source_get_dimensions ((MediaSource*) _tmp0_, PHOTO_EXCEPTION_NONE, &_tmp1_);
#line 68 "../src/editing_tools/PhotoCanvas.vala"
	unscaled_dims = _tmp1_;
#line 70 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = unscaled_dims;
#line 70 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = self->priv->_scaled_position;
#line 70 "../src/editing_tools/PhotoCanvas.vala"
	scale_factor_x = ((gdouble) _tmp2_.width) / ((gdouble) _tmp3_.width);
#line 72 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = unscaled_dims;
#line 72 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = self->priv->_scaled_position;
#line 72 "../src/editing_tools/PhotoCanvas.vala"
	scale_factor_y = ((gdouble) _tmp4_.height) / ((gdouble) _tmp5_.height);
#line 75 "../src/editing_tools/PhotoCanvas.vala"
	_tmp6_.x = 0;
#line 75 "../src/editing_tools/PhotoCanvas.vala"
	_result_ = _tmp6_;
#line 76 "../src/editing_tools/PhotoCanvas.vala"
	_tmp7_ = *active_point;
#line 76 "../src/editing_tools/PhotoCanvas.vala"
	_result_.x = (gint) ((((gdouble) _tmp7_.x) * scale_factor_x) + 0.5);
#line 77 "../src/editing_tools/PhotoCanvas.vala"
	_tmp8_ = *active_point;
#line 77 "../src/editing_tools/PhotoCanvas.vala"
	_result_.y = (gint) ((((gdouble) _tmp8_.y) * scale_factor_y) + 0.5);
#line 79 "../src/editing_tools/PhotoCanvas.vala"
	*result = _result_;
#line 79 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 258 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_active_to_unscaled_rect (EditingToolsPhotoCanvas* self,
                                                    GdkRectangle* active_rect,
                                                    GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _tmp6_;
	GdkRectangle _tmp7_;
	GdkPoint _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	GdkRectangle unscaled_rect = {0};
	GdkPoint _tmp12_;
	GdkPoint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
#line 82 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (active_rect != NULL);
#line 83 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_.x = 0;
#line 83 "../src/editing_tools/PhotoCanvas.vala"
	upper_left = _tmp0_;
#line 84 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_.x = 0;
#line 84 "../src/editing_tools/PhotoCanvas.vala"
	lower_right = _tmp1_;
#line 85 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = *active_rect;
#line 85 "../src/editing_tools/PhotoCanvas.vala"
	upper_left.x = _tmp2_.x;
#line 86 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = *active_rect;
#line 86 "../src/editing_tools/PhotoCanvas.vala"
	upper_left.y = _tmp3_.y;
#line 87 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = upper_left;
#line 87 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = *active_rect;
#line 87 "../src/editing_tools/PhotoCanvas.vala"
	lower_right.x = _tmp4_.x + _tmp5_.width;
#line 88 "../src/editing_tools/PhotoCanvas.vala"
	_tmp6_ = upper_left;
#line 88 "../src/editing_tools/PhotoCanvas.vala"
	_tmp7_ = *active_rect;
#line 88 "../src/editing_tools/PhotoCanvas.vala"
	lower_right.y = _tmp6_.y + _tmp7_.height;
#line 90 "../src/editing_tools/PhotoCanvas.vala"
	_tmp8_ = upper_left;
#line 90 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_active_to_unscaled_point (self, &_tmp8_, &_tmp9_);
#line 90 "../src/editing_tools/PhotoCanvas.vala"
	upper_left = _tmp9_;
#line 91 "../src/editing_tools/PhotoCanvas.vala"
	_tmp10_ = lower_right;
#line 91 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_active_to_unscaled_point (self, &_tmp10_, &_tmp11_);
#line 91 "../src/editing_tools/PhotoCanvas.vala"
	lower_right = _tmp11_;
#line 93 "../src/editing_tools/PhotoCanvas.vala"
	memset (&unscaled_rect, 0, sizeof (GdkRectangle));
#line 94 "../src/editing_tools/PhotoCanvas.vala"
	_tmp12_ = upper_left;
#line 94 "../src/editing_tools/PhotoCanvas.vala"
	unscaled_rect.x = _tmp12_.x;
#line 95 "../src/editing_tools/PhotoCanvas.vala"
	_tmp13_ = upper_left;
#line 95 "../src/editing_tools/PhotoCanvas.vala"
	unscaled_rect.y = _tmp13_.y;
#line 96 "../src/editing_tools/PhotoCanvas.vala"
	_tmp14_ = lower_right;
#line 96 "../src/editing_tools/PhotoCanvas.vala"
	_tmp15_ = upper_left;
#line 96 "../src/editing_tools/PhotoCanvas.vala"
	unscaled_rect.width = _tmp14_.x - _tmp15_.x;
#line 97 "../src/editing_tools/PhotoCanvas.vala"
	_tmp16_ = lower_right;
#line 97 "../src/editing_tools/PhotoCanvas.vala"
	_tmp17_ = upper_left;
#line 97 "../src/editing_tools/PhotoCanvas.vala"
	unscaled_rect.height = _tmp16_.y - _tmp17_.y;
#line 99 "../src/editing_tools/PhotoCanvas.vala"
	*result = unscaled_rect;
#line 99 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 357 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_user_to_active_point (EditingToolsPhotoCanvas* self,
                                                 GdkPoint* user_point,
                                                 GdkPoint* result)
{
	GdkPoint _result_ = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_;
	GdkRectangle _tmp2_;
	GdkPoint _tmp3_;
	GdkRectangle _tmp4_;
#line 102 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (user_point != NULL);
#line 103 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_.x = 0;
#line 103 "../src/editing_tools/PhotoCanvas.vala"
	_result_ = _tmp0_;
#line 104 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = *user_point;
#line 104 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = self->priv->_scaled_position;
#line 104 "../src/editing_tools/PhotoCanvas.vala"
	_result_.x = _tmp1_.x - _tmp2_.x;
#line 105 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = *user_point;
#line 105 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = self->priv->_scaled_position;
#line 105 "../src/editing_tools/PhotoCanvas.vala"
	_result_.y = _tmp3_.y - _tmp4_.y;
#line 107 "../src/editing_tools/PhotoCanvas.vala"
	*result = _result_;
#line 107 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 395 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_user_to_active_rect (EditingToolsPhotoCanvas* self,
                                                GdkRectangle* user_rect,
                                                GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _tmp6_;
	GdkRectangle _tmp7_;
	GdkPoint _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	GdkRectangle active_rect = {0};
	GdkPoint _tmp12_;
	GdkPoint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
#line 110 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (user_rect != NULL);
#line 111 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_.x = 0;
#line 111 "../src/editing_tools/PhotoCanvas.vala"
	upper_left = _tmp0_;
#line 112 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_.x = 0;
#line 112 "../src/editing_tools/PhotoCanvas.vala"
	lower_right = _tmp1_;
#line 113 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = *user_rect;
#line 113 "../src/editing_tools/PhotoCanvas.vala"
	upper_left.x = _tmp2_.x;
#line 114 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = *user_rect;
#line 114 "../src/editing_tools/PhotoCanvas.vala"
	upper_left.y = _tmp3_.y;
#line 115 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = upper_left;
#line 115 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = *user_rect;
#line 115 "../src/editing_tools/PhotoCanvas.vala"
	lower_right.x = _tmp4_.x + _tmp5_.width;
#line 116 "../src/editing_tools/PhotoCanvas.vala"
	_tmp6_ = upper_left;
#line 116 "../src/editing_tools/PhotoCanvas.vala"
	_tmp7_ = *user_rect;
#line 116 "../src/editing_tools/PhotoCanvas.vala"
	lower_right.y = _tmp6_.y + _tmp7_.height;
#line 118 "../src/editing_tools/PhotoCanvas.vala"
	_tmp8_ = upper_left;
#line 118 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_user_to_active_point (self, &_tmp8_, &_tmp9_);
#line 118 "../src/editing_tools/PhotoCanvas.vala"
	upper_left = _tmp9_;
#line 119 "../src/editing_tools/PhotoCanvas.vala"
	_tmp10_ = lower_right;
#line 119 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_user_to_active_point (self, &_tmp10_, &_tmp11_);
#line 119 "../src/editing_tools/PhotoCanvas.vala"
	lower_right = _tmp11_;
#line 121 "../src/editing_tools/PhotoCanvas.vala"
	memset (&active_rect, 0, sizeof (GdkRectangle));
#line 122 "../src/editing_tools/PhotoCanvas.vala"
	_tmp12_ = upper_left;
#line 122 "../src/editing_tools/PhotoCanvas.vala"
	active_rect.x = _tmp12_.x;
#line 123 "../src/editing_tools/PhotoCanvas.vala"
	_tmp13_ = upper_left;
#line 123 "../src/editing_tools/PhotoCanvas.vala"
	active_rect.y = _tmp13_.y;
#line 124 "../src/editing_tools/PhotoCanvas.vala"
	_tmp14_ = lower_right;
#line 124 "../src/editing_tools/PhotoCanvas.vala"
	_tmp15_ = upper_left;
#line 124 "../src/editing_tools/PhotoCanvas.vala"
	active_rect.width = _tmp14_.x - _tmp15_.x;
#line 125 "../src/editing_tools/PhotoCanvas.vala"
	_tmp16_ = lower_right;
#line 125 "../src/editing_tools/PhotoCanvas.vala"
	_tmp17_ = upper_left;
#line 125 "../src/editing_tools/PhotoCanvas.vala"
	active_rect.height = _tmp16_.y - _tmp17_.y;
#line 127 "../src/editing_tools/PhotoCanvas.vala"
	*result = active_rect;
#line 127 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 494 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_get_scaling (EditingToolsPhotoCanvas* self,
                                        Scaling* result)
{
	Dimensions _tmp0_;
	Scaling _tmp1_ = {0};
#line 130 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_surface_dim;
#line 131 "../src/editing_tools/PhotoCanvas.vala"
	scaling_for_viewport (&_tmp0_, FALSE, &_tmp1_);
#line 131 "../src/editing_tools/PhotoCanvas.vala"
	*result = _tmp1_;
#line 131 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 513 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_set_surface (EditingToolsPhotoCanvas* self,
                                        cairo_t* default_ctx,
                                        Dimensions* surface_dim)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_;
#line 134 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (default_ctx != NULL);
#line 134 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (surface_dim != NULL);
#line 135 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_set_default_ctx (self, default_ctx);
#line 136 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = *surface_dim;
#line 136 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_set_surface_dim (self, &_tmp0_);
#line 138 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = *surface_dim;
#line 138 "../src/editing_tools/PhotoCanvas.vala"
	g_signal_emit (self, editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_NEW_SURFACE_SIGNAL], 0, default_ctx, &_tmp1_);
#line 539 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_resized_pixbuf (EditingToolsPhotoCanvas* self,
                                           Dimensions* old_dim,
                                           GdkPixbuf* scaled,
                                           GdkRectangle* scaled_position)
{
	cairo_t* _tmp0_;
	GdkRectangle _tmp1_;
	cairo_surface_t* _tmp2_;
	GdkRectangle _tmp3_;
	Dimensions _tmp4_;
	GdkRectangle _tmp5_;
#line 141 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (old_dim != NULL);
#line 141 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (scaled != NULL);
#line 141 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (scaled_position != NULL);
#line 142 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_default_ctx;
#line 142 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = *scaled_position;
#line 142 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = editing_tools_photo_canvas_pixbuf_to_surface (self, _tmp0_, scaled, &_tmp1_);
#line 142 "../src/editing_tools/PhotoCanvas.vala"
	_cairo_surface_destroy0 (self->priv->scaled);
#line 142 "../src/editing_tools/PhotoCanvas.vala"
	self->priv->scaled = _tmp2_;
#line 143 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_set_scaled_pixbuf (self, scaled);
#line 144 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = *scaled_position;
#line 144 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_set_scaled_position (self, &_tmp3_);
#line 146 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = *old_dim;
#line 146 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = *scaled_position;
#line 146 "../src/editing_tools/PhotoCanvas.vala"
	g_signal_emit (self, editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_RESIZED_SCALED_PIXBUF_SIGNAL], 0, &_tmp4_, scaled, &_tmp5_);
#line 584 "PhotoCanvas.c"
}

static void
editing_tools_photo_canvas_real_repaint (EditingToolsPhotoCanvas* self)
{
#line 149 "../src/editing_tools/PhotoCanvas.vala"
	g_critical ("Type `%s' does not implement abstract method `editing_tools_photo_canvas_repaint'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 149 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 594 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_repaint (EditingToolsPhotoCanvas* self)
{
	EditingToolsPhotoCanvasClass* _klass_;
#line 149 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/editing_tools/PhotoCanvas.vala"
	_klass_ = EDITING_TOOLS_PHOTO_CANVAS_GET_CLASS (self);
#line 149 "../src/editing_tools/PhotoCanvas.vala"
	if (_klass_->repaint) {
#line 149 "../src/editing_tools/PhotoCanvas.vala"
		_klass_->repaint (self);
#line 609 "PhotoCanvas.c"
	}
}

void
editing_tools_photo_canvas_paint_pixbuf (EditingToolsPhotoCanvas* self,
                                         GdkPixbuf* pixbuf)
{
	cairo_t* _tmp0_;
	GtkStyleContext* _tmp1_;
	cairo_t* _tmp2_;
	Dimensions _tmp3_;
	Dimensions _tmp4_;
	cairo_t* _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	cairo_t* _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
#line 157 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (pixbuf != NULL);
#line 158 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_default_ctx;
#line 158 "../src/editing_tools/PhotoCanvas.vala"
	cairo_save (_tmp0_);
#line 161 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = editing_tools_photo_canvas_get_style_context (self);
#line 161 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = self->priv->_default_ctx;
#line 161 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = self->priv->_surface_dim;
#line 161 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = self->priv->_surface_dim;
#line 161 "../src/editing_tools/PhotoCanvas.vala"
	gtk_render_background (_tmp1_, _tmp2_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp3_.width, (gdouble) _tmp4_.height);
#line 164 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = self->priv->_default_ctx;
#line 164 "../src/editing_tools/PhotoCanvas.vala"
	_tmp6_ = self->priv->_scaled_position;
#line 164 "../src/editing_tools/PhotoCanvas.vala"
	_tmp7_ = self->priv->_scaled_position;
#line 164 "../src/editing_tools/PhotoCanvas.vala"
	gdk_cairo_set_source_pixbuf (_tmp5_, pixbuf, (gdouble) _tmp6_.x, (gdouble) _tmp7_.y);
#line 165 "../src/editing_tools/PhotoCanvas.vala"
	_tmp8_ = self->priv->_default_ctx;
#line 165 "../src/editing_tools/PhotoCanvas.vala"
	_tmp9_ = self->priv->_scaled_position;
#line 165 "../src/editing_tools/PhotoCanvas.vala"
	_tmp10_ = self->priv->_scaled_position;
#line 165 "../src/editing_tools/PhotoCanvas.vala"
	cairo_rectangle (_tmp8_, (gdouble) _tmp9_.x, (gdouble) _tmp10_.y, (gdouble) gdk_pixbuf_get_width (pixbuf), (gdouble) gdk_pixbuf_get_height (pixbuf));
#line 167 "../src/editing_tools/PhotoCanvas.vala"
	_tmp11_ = self->priv->_default_ctx;
#line 167 "../src/editing_tools/PhotoCanvas.vala"
	cairo_fill (_tmp11_);
#line 168 "../src/editing_tools/PhotoCanvas.vala"
	_tmp12_ = self->priv->_default_ctx;
#line 168 "../src/editing_tools/PhotoCanvas.vala"
	cairo_restore (_tmp12_);
#line 672 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_paint_surface (EditingToolsPhotoCanvas* self,
                                          cairo_surface_t* surface,
                                          gboolean over)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
#line 172 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (surface != NULL);
#line 173 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_default_ctx;
#line 173 "../src/editing_tools/PhotoCanvas.vala"
	cairo_save (_tmp0_);
#line 174 "../src/editing_tools/PhotoCanvas.vala"
	if (over == FALSE) {
#line 701 "PhotoCanvas.c"
		cairo_t* _tmp1_;
#line 175 "../src/editing_tools/PhotoCanvas.vala"
		_tmp1_ = self->priv->_default_ctx;
#line 175 "../src/editing_tools/PhotoCanvas.vala"
		cairo_set_operator (_tmp1_, CAIRO_OPERATOR_SOURCE);
#line 707 "PhotoCanvas.c"
	} else {
		cairo_t* _tmp2_;
#line 177 "../src/editing_tools/PhotoCanvas.vala"
		_tmp2_ = self->priv->_default_ctx;
#line 177 "../src/editing_tools/PhotoCanvas.vala"
		cairo_set_operator (_tmp2_, CAIRO_OPERATOR_OVER);
#line 714 "PhotoCanvas.c"
	}
#line 180 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = self->priv->_default_ctx;
#line 180 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = self->priv->scaled;
#line 180 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = self->priv->_scaled_position;
#line 180 "../src/editing_tools/PhotoCanvas.vala"
	_tmp6_ = self->priv->_scaled_position;
#line 180 "../src/editing_tools/PhotoCanvas.vala"
	cairo_set_source_surface (_tmp3_, _tmp4_, (gdouble) _tmp5_.x, (gdouble) _tmp6_.y);
#line 181 "../src/editing_tools/PhotoCanvas.vala"
	_tmp7_ = self->priv->_default_ctx;
#line 181 "../src/editing_tools/PhotoCanvas.vala"
	cairo_paint (_tmp7_);
#line 182 "../src/editing_tools/PhotoCanvas.vala"
	_tmp8_ = self->priv->_default_ctx;
#line 182 "../src/editing_tools/PhotoCanvas.vala"
	_tmp9_ = self->priv->_scaled_position;
#line 182 "../src/editing_tools/PhotoCanvas.vala"
	_tmp10_ = self->priv->_scaled_position;
#line 182 "../src/editing_tools/PhotoCanvas.vala"
	cairo_set_source_surface (_tmp8_, surface, (gdouble) _tmp9_.x, (gdouble) _tmp10_.y);
#line 183 "../src/editing_tools/PhotoCanvas.vala"
	_tmp11_ = self->priv->_default_ctx;
#line 183 "../src/editing_tools/PhotoCanvas.vala"
	cairo_paint (_tmp11_);
#line 184 "../src/editing_tools/PhotoCanvas.vala"
	_tmp12_ = self->priv->_default_ctx;
#line 184 "../src/editing_tools/PhotoCanvas.vala"
	cairo_restore (_tmp12_);
#line 746 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_paint_surface_area (EditingToolsPhotoCanvas* self,
                                               cairo_surface_t* surface,
                                               Box* source_area,
                                               gboolean over)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	cairo_t* _tmp7_;
	GdkRectangle _tmp8_;
	Box _tmp9_;
	GdkRectangle _tmp10_;
	Box _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
	cairo_t* _tmp16_;
	GdkRectangle _tmp17_;
	Box _tmp18_;
	GdkRectangle _tmp19_;
	Box _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
#line 187 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (surface != NULL);
#line 187 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (source_area != NULL);
#line 188 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_default_ctx;
#line 188 "../src/editing_tools/PhotoCanvas.vala"
	cairo_save (_tmp0_);
#line 189 "../src/editing_tools/PhotoCanvas.vala"
	if (over == FALSE) {
#line 788 "PhotoCanvas.c"
		cairo_t* _tmp1_;
#line 190 "../src/editing_tools/PhotoCanvas.vala"
		_tmp1_ = self->priv->_default_ctx;
#line 190 "../src/editing_tools/PhotoCanvas.vala"
		cairo_set_operator (_tmp1_, CAIRO_OPERATOR_SOURCE);
#line 794 "PhotoCanvas.c"
	} else {
		cairo_t* _tmp2_;
#line 192 "../src/editing_tools/PhotoCanvas.vala"
		_tmp2_ = self->priv->_default_ctx;
#line 192 "../src/editing_tools/PhotoCanvas.vala"
		cairo_set_operator (_tmp2_, CAIRO_OPERATOR_OVER);
#line 801 "PhotoCanvas.c"
	}
#line 195 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = self->priv->_default_ctx;
#line 195 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = self->priv->scaled;
#line 195 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = self->priv->_scaled_position;
#line 195 "../src/editing_tools/PhotoCanvas.vala"
	_tmp6_ = self->priv->_scaled_position;
#line 195 "../src/editing_tools/PhotoCanvas.vala"
	cairo_set_source_surface (_tmp3_, _tmp4_, (gdouble) _tmp5_.x, (gdouble) _tmp6_.y);
#line 196 "../src/editing_tools/PhotoCanvas.vala"
	_tmp7_ = self->priv->_default_ctx;
#line 196 "../src/editing_tools/PhotoCanvas.vala"
	_tmp8_ = self->priv->_scaled_position;
#line 196 "../src/editing_tools/PhotoCanvas.vala"
	_tmp9_ = *source_area;
#line 196 "../src/editing_tools/PhotoCanvas.vala"
	_tmp10_ = self->priv->_scaled_position;
#line 196 "../src/editing_tools/PhotoCanvas.vala"
	_tmp11_ = *source_area;
#line 196 "../src/editing_tools/PhotoCanvas.vala"
	cairo_rectangle (_tmp7_, (gdouble) (_tmp8_.x + _tmp9_.left), (gdouble) (_tmp10_.y + _tmp11_.top), (gdouble) box_get_width (source_area), (gdouble) box_get_height (source_area));
#line 199 "../src/editing_tools/PhotoCanvas.vala"
	_tmp12_ = self->priv->_default_ctx;
#line 199 "../src/editing_tools/PhotoCanvas.vala"
	cairo_fill (_tmp12_);
#line 201 "../src/editing_tools/PhotoCanvas.vala"
	_tmp13_ = self->priv->_default_ctx;
#line 201 "../src/editing_tools/PhotoCanvas.vala"
	_tmp14_ = self->priv->_scaled_position;
#line 201 "../src/editing_tools/PhotoCanvas.vala"
	_tmp15_ = self->priv->_scaled_position;
#line 201 "../src/editing_tools/PhotoCanvas.vala"
	cairo_set_source_surface (_tmp13_, surface, (gdouble) _tmp14_.x, (gdouble) _tmp15_.y);
#line 202 "../src/editing_tools/PhotoCanvas.vala"
	_tmp16_ = self->priv->_default_ctx;
#line 202 "../src/editing_tools/PhotoCanvas.vala"
	_tmp17_ = self->priv->_scaled_position;
#line 202 "../src/editing_tools/PhotoCanvas.vala"
	_tmp18_ = *source_area;
#line 202 "../src/editing_tools/PhotoCanvas.vala"
	_tmp19_ = self->priv->_scaled_position;
#line 202 "../src/editing_tools/PhotoCanvas.vala"
	_tmp20_ = *source_area;
#line 202 "../src/editing_tools/PhotoCanvas.vala"
	cairo_rectangle (_tmp16_, (gdouble) (_tmp17_.x + _tmp18_.left), (gdouble) (_tmp19_.y + _tmp20_.top), (gdouble) box_get_width (source_area), (gdouble) box_get_height (source_area));
#line 205 "../src/editing_tools/PhotoCanvas.vala"
	_tmp21_ = self->priv->_default_ctx;
#line 205 "../src/editing_tools/PhotoCanvas.vala"
	cairo_fill (_tmp21_);
#line 206 "../src/editing_tools/PhotoCanvas.vala"
	_tmp22_ = self->priv->_default_ctx;
#line 206 "../src/editing_tools/PhotoCanvas.vala"
	cairo_restore (_tmp22_);
#line 857 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_draw_box (EditingToolsPhotoCanvas* self,
                                     cairo_t* ctx,
                                     Box* box)
{
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
#line 209 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (ctx != NULL);
#line 209 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (box != NULL);
#line 210 "../src/editing_tools/PhotoCanvas.vala"
	box_get_rectangle (box, &_tmp0_);
#line 210 "../src/editing_tools/PhotoCanvas.vala"
	rect = _tmp0_;
#line 211 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = self->priv->_scaled_position;
#line 211 "../src/editing_tools/PhotoCanvas.vala"
	rect.x = rect.x + _tmp1_.x;
#line 212 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = self->priv->_scaled_position;
#line 212 "../src/editing_tools/PhotoCanvas.vala"
	rect.y = rect.y + _tmp2_.y;
#line 214 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = rect;
#line 214 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = rect;
#line 214 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = rect;
#line 214 "../src/editing_tools/PhotoCanvas.vala"
	_tmp6_ = rect;
#line 214 "../src/editing_tools/PhotoCanvas.vala"
	cairo_rectangle (ctx, _tmp3_.x + 0.5, _tmp4_.y + 0.5, (gdouble) (_tmp5_.width - 1), (gdouble) (_tmp6_.height - 1));
#line 215 "../src/editing_tools/PhotoCanvas.vala"
	cairo_stroke (ctx);
#line 903 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_draw_text (EditingToolsPhotoCanvas* self,
                                      cairo_t* ctx,
                                      const gchar* text,
                                      gint x,
                                      gint y,
                                      gboolean use_scaled_pos)
{
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp2_ = {0};
	cairo_text_extents_t _tmp3_;
	gint pane_border = 0;
	cairo_text_extents_t _tmp4_;
	cairo_text_extents_t _tmp5_;
	cairo_text_extents_t _tmp6_;
#line 218 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (ctx != NULL);
#line 218 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (text != NULL);
#line 219 "../src/editing_tools/PhotoCanvas.vala"
	if (use_scaled_pos) {
#line 929 "PhotoCanvas.c"
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
#line 220 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = self->priv->_scaled_position;
#line 220 "../src/editing_tools/PhotoCanvas.vala"
		x = x + _tmp0_.x;
#line 221 "../src/editing_tools/PhotoCanvas.vala"
		_tmp1_ = self->priv->_scaled_position;
#line 221 "../src/editing_tools/PhotoCanvas.vala"
		y = y + _tmp1_.y;
#line 940 "PhotoCanvas.c"
	}
#line 225 "../src/editing_tools/PhotoCanvas.vala"
	cairo_text_extents (ctx, text, &_tmp2_);
#line 225 "../src/editing_tools/PhotoCanvas.vala"
	extents = _tmp2_;
#line 226 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = extents;
#line 226 "../src/editing_tools/PhotoCanvas.vala"
	x = x - (((gint) _tmp3_.width) / 2);
#line 228 "../src/editing_tools/PhotoCanvas.vala"
	set_source_color_from_string (ctx, RESOURCES_ONIMAGE_FONT_BACKGROUND);
#line 230 "../src/editing_tools/PhotoCanvas.vala"
	pane_border = 5;
#line 231 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = extents;
#line 231 "../src/editing_tools/PhotoCanvas.vala"
	_tmp5_ = extents;
#line 231 "../src/editing_tools/PhotoCanvas.vala"
	_tmp6_ = extents;
#line 231 "../src/editing_tools/PhotoCanvas.vala"
	cairo_rectangle (ctx, (gdouble) (x - pane_border), (y - pane_border) - _tmp4_.height, _tmp5_.width + (2 * pane_border), _tmp6_.height + (2 * pane_border));
#line 234 "../src/editing_tools/PhotoCanvas.vala"
	cairo_fill (ctx);
#line 236 "../src/editing_tools/PhotoCanvas.vala"
	cairo_move_to (ctx, (gdouble) x, (gdouble) y);
#line 237 "../src/editing_tools/PhotoCanvas.vala"
	set_source_color_from_string (ctx, RESOURCES_ONIMAGE_FONT_COLOR);
#line 238 "../src/editing_tools/PhotoCanvas.vala"
	cairo_show_text (ctx, text);
#line 970 "PhotoCanvas.c"
}

/**
     * Draw a horizontal line into the specified Cairo context at the specified position, taking
     * into account the scaled position of the image unless directed otherwise.
     *
     * @param ctx The drawing context of the surface we're drawing to.
     * @param x The horizontal position to place the line at.
     * @param y The vertical position to place the line at.
     * @param width The length of the line.
     * @param use_scaled_pos Whether to use absolute window positioning or take into account the
     *      position of the scaled image.
     */
void
editing_tools_photo_canvas_draw_horizontal_line (EditingToolsPhotoCanvas* self,
                                                 cairo_t* ctx,
                                                 gint x,
                                                 gint y,
                                                 gint width,
                                                 gboolean use_scaled_pos)
{
#line 252 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (ctx != NULL);
#line 253 "../src/editing_tools/PhotoCanvas.vala"
	if (use_scaled_pos) {
#line 998 "PhotoCanvas.c"
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
#line 254 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = self->priv->_scaled_position;
#line 254 "../src/editing_tools/PhotoCanvas.vala"
		x = x + _tmp0_.x;
#line 255 "../src/editing_tools/PhotoCanvas.vala"
		_tmp1_ = self->priv->_scaled_position;
#line 255 "../src/editing_tools/PhotoCanvas.vala"
		y = y + _tmp1_.y;
#line 1009 "PhotoCanvas.c"
	}
#line 258 "../src/editing_tools/PhotoCanvas.vala"
	cairo_move_to (ctx, x + 0.5, y + 0.5);
#line 259 "../src/editing_tools/PhotoCanvas.vala"
	cairo_line_to (ctx, (gdouble) ((x + width) - 1), y + 0.5);
#line 260 "../src/editing_tools/PhotoCanvas.vala"
	cairo_stroke (ctx);
#line 1017 "PhotoCanvas.c"
}

/**
     * Draw a vertical line into the specified Cairo context at the specified position, taking
     * into account the scaled position of the image unless directed otherwise.
     *
     * @param ctx The drawing context of the surface we're drawing to.
     * @param x The horizontal position to place the line at.
     * @param y The vertical position to place the line at.
     * @param width The length of the line.
     * @param use_scaled_pos Whether to use absolute window positioning or take into account the
     *      position of the scaled image.
     */
void
editing_tools_photo_canvas_draw_vertical_line (EditingToolsPhotoCanvas* self,
                                               cairo_t* ctx,
                                               gint x,
                                               gint y,
                                               gint height,
                                               gboolean use_scaled_pos)
{
#line 274 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (ctx != NULL);
#line 275 "../src/editing_tools/PhotoCanvas.vala"
	if (use_scaled_pos) {
#line 1045 "PhotoCanvas.c"
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
#line 276 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = self->priv->_scaled_position;
#line 276 "../src/editing_tools/PhotoCanvas.vala"
		x = x + _tmp0_.x;
#line 277 "../src/editing_tools/PhotoCanvas.vala"
		_tmp1_ = self->priv->_scaled_position;
#line 277 "../src/editing_tools/PhotoCanvas.vala"
		y = y + _tmp1_.y;
#line 1056 "PhotoCanvas.c"
	}
#line 280 "../src/editing_tools/PhotoCanvas.vala"
	cairo_move_to (ctx, x + 0.5, y + 0.5);
#line 281 "../src/editing_tools/PhotoCanvas.vala"
	cairo_line_to (ctx, x + 0.5, (gdouble) ((y + height) - 1));
#line 282 "../src/editing_tools/PhotoCanvas.vala"
	cairo_stroke (ctx);
#line 1064 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_draw_circle (EditingToolsPhotoCanvas* self,
                                        cairo_t* ctx,
                                        gint active_center_x,
                                        gint active_center_y,
                                        gint radius)
{
	gint center_x = 0;
	GdkRectangle _tmp0_;
	gint center_y = 0;
	GdkRectangle _tmp1_;
	gint scale_factor = 0;
	GtkWindow* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 285 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (ctx != NULL);
#line 287 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_scaled_position;
#line 287 "../src/editing_tools/PhotoCanvas.vala"
	center_x = active_center_x + _tmp0_.x;
#line 288 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = self->priv->_scaled_position;
#line 288 "../src/editing_tools/PhotoCanvas.vala"
	center_y = active_center_y + _tmp1_.y;
#line 290 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = self->priv->_container;
#line 290 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp2_);
#line 290 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = _tmp3_;
#line 290 "../src/editing_tools/PhotoCanvas.vala"
	scale_factor = _tmp4_;
#line 291 "../src/editing_tools/PhotoCanvas.vala"
	cairo_arc (ctx, (gdouble) (center_x * scale_factor), (gdouble) (center_y * scale_factor), (gdouble) (radius * scale_factor), (gdouble) 0, 2 * G_PI);
#line 292 "../src/editing_tools/PhotoCanvas.vala"
	cairo_stroke (ctx);
#line 1106 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_invalidate_area (EditingToolsPhotoCanvas* self,
                                            Box* area)
{
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GdkRectangle _tmp4_;
#line 295 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 295 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (area != NULL);
#line 296 "../src/editing_tools/PhotoCanvas.vala"
	box_get_rectangle (area, &_tmp0_);
#line 296 "../src/editing_tools/PhotoCanvas.vala"
	rect = _tmp0_;
#line 297 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = self->priv->_scaled_position;
#line 297 "../src/editing_tools/PhotoCanvas.vala"
	rect.x = rect.x + _tmp1_.x;
#line 298 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = self->priv->_scaled_position;
#line 298 "../src/editing_tools/PhotoCanvas.vala"
	rect.y = rect.y + _tmp2_.y;
#line 300 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = self->priv->_drawing_window;
#line 300 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = rect;
#line 300 "../src/editing_tools/PhotoCanvas.vala"
	gdk_window_invalidate_rect (_tmp3_, &_tmp4_, FALSE);
#line 1141 "PhotoCanvas.c"
}

static cairo_surface_t*
editing_tools_photo_canvas_pixbuf_to_surface (EditingToolsPhotoCanvas* self,
                                              cairo_t* default_ctx,
                                              GdkPixbuf* pixbuf,
                                              GdkRectangle* pos)
{
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_t* ctx = NULL;
	cairo_t* _tmp4_;
	cairo_surface_t* result;
#line 303 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 303 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (default_ctx != NULL, NULL);
#line 303 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 303 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (pos != NULL, NULL);
#line 305 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = cairo_get_target (default_ctx);
#line 305 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = *pos;
#line 305 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = *pos;
#line 305 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, _tmp1_.width, _tmp2_.height);
#line 305 "../src/editing_tools/PhotoCanvas.vala"
	surface = _tmp3_;
#line 307 "../src/editing_tools/PhotoCanvas.vala"
	_tmp4_ = cairo_create (surface);
#line 307 "../src/editing_tools/PhotoCanvas.vala"
	ctx = _tmp4_;
#line 308 "../src/editing_tools/PhotoCanvas.vala"
	gdk_cairo_set_source_pixbuf (ctx, pixbuf, (gdouble) 0, (gdouble) 0);
#line 309 "../src/editing_tools/PhotoCanvas.vala"
	cairo_paint (ctx);
#line 310 "../src/editing_tools/PhotoCanvas.vala"
	result = surface;
#line 310 "../src/editing_tools/PhotoCanvas.vala"
	_cairo_destroy0 (ctx);
#line 310 "../src/editing_tools/PhotoCanvas.vala"
	return result;
#line 1190 "PhotoCanvas.c"
}

/**
     * Returns the style context associated to this.
     *
     * @return a StyleContext. This memory is owned by this and must not be freed.
     */
static GtkStyleContext*
editing_tools_photo_canvas_real_get_style_context (EditingToolsPhotoCanvas* self)
{
#line 318 "../src/editing_tools/PhotoCanvas.vala"
	g_critical ("Type `%s' does not implement abstract method `editing_tools_photo_canvas_get_style_context'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 318 "../src/editing_tools/PhotoCanvas.vala"
	return NULL;
#line 1205 "PhotoCanvas.c"
}

GtkStyleContext*
editing_tools_photo_canvas_get_style_context (EditingToolsPhotoCanvas* self)
{
	EditingToolsPhotoCanvasClass* _klass_;
#line 318 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 318 "../src/editing_tools/PhotoCanvas.vala"
	_klass_ = EDITING_TOOLS_PHOTO_CANVAS_GET_CLASS (self);
#line 318 "../src/editing_tools/PhotoCanvas.vala"
	if (_klass_->get_style_context) {
#line 318 "../src/editing_tools/PhotoCanvas.vala"
		return _klass_->get_style_context (self);
#line 1220 "PhotoCanvas.c"
	}
#line 318 "../src/editing_tools/PhotoCanvas.vala"
	return NULL;
#line 1224 "PhotoCanvas.c"
}

cairo_t*
editing_tools_photo_canvas_get_default_ctx (EditingToolsPhotoCanvas* self)
{
	cairo_t* result;
	cairo_t* _tmp0_;
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_default_ctx;
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	result = _tmp0_;
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	return result;
#line 1240 "PhotoCanvas.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	return self ? cairo_reference (self) : NULL;
#line 1248 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_set_default_ctx (EditingToolsPhotoCanvas* self,
                                            cairo_t* value)
{
	cairo_t* old_value;
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	old_value = editing_tools_photo_canvas_get_default_ctx (self);
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	if (old_value != value) {
#line 1262 "PhotoCanvas.c"
		cairo_t* _tmp0_;
#line 36 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = _cairo_reference0 (value);
#line 36 "../src/editing_tools/PhotoCanvas.vala"
		_cairo_destroy0 (self->priv->_default_ctx);
#line 36 "../src/editing_tools/PhotoCanvas.vala"
		self->priv->_default_ctx = _tmp0_;
#line 36 "../src/editing_tools/PhotoCanvas.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_DEFAULT_CTX_PROPERTY]);
#line 1272 "PhotoCanvas.c"
	}
}

void
editing_tools_photo_canvas_get_surface_dim (EditingToolsPhotoCanvas* self,
                                            Dimensions * result)
{
	Dimensions _tmp0_;
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_surface_dim;
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	*result = _tmp0_;
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 1289 "PhotoCanvas.c"
}

static gboolean
_dimensions_equal (const Dimensions * s1,
                   const Dimensions * s2)
{
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	if (s1 == s2) {
#line 37 "../src/editing_tools/PhotoCanvas.vala"
		return TRUE;
#line 1300 "PhotoCanvas.c"
	}
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	if (s1 == NULL) {
#line 37 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1306 "PhotoCanvas.c"
	}
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	if (s2 == NULL) {
#line 37 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1312 "PhotoCanvas.c"
	}
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	if (s1->width != s2->width) {
#line 37 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1318 "PhotoCanvas.c"
	}
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	if (s1->height != s2->height) {
#line 37 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1324 "PhotoCanvas.c"
	}
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	return TRUE;
#line 1328 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_set_surface_dim (EditingToolsPhotoCanvas* self,
                                            Dimensions * value)
{
	Dimensions old_value;
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_get_surface_dim (self, &old_value);
#line 37 "../src/editing_tools/PhotoCanvas.vala"
	if (_dimensions_equal (value, &old_value) != TRUE) {
#line 1342 "PhotoCanvas.c"
		Dimensions _tmp0_;
#line 37 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = *value;
#line 37 "../src/editing_tools/PhotoCanvas.vala"
		self->priv->_surface_dim = _tmp0_;
#line 37 "../src/editing_tools/PhotoCanvas.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_SURFACE_DIM_PROPERTY]);
#line 1350 "PhotoCanvas.c"
	}
}

GdkPixbuf*
editing_tools_photo_canvas_get_scaled_pixbuf (EditingToolsPhotoCanvas* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_scaled_pixbuf;
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	result = _tmp0_;
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	return result;
#line 1367 "PhotoCanvas.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	return self ? g_object_ref (self) : NULL;
#line 1375 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_set_scaled_pixbuf (EditingToolsPhotoCanvas* self,
                                              GdkPixbuf* value)
{
	GdkPixbuf* old_value;
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	old_value = editing_tools_photo_canvas_get_scaled_pixbuf (self);
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	if (old_value != value) {
#line 1389 "PhotoCanvas.c"
		GdkPixbuf* _tmp0_;
#line 38 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/editing_tools/PhotoCanvas.vala"
		_g_object_unref0 (self->priv->_scaled_pixbuf);
#line 38 "../src/editing_tools/PhotoCanvas.vala"
		self->priv->_scaled_pixbuf = _tmp0_;
#line 38 "../src/editing_tools/PhotoCanvas.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_SCALED_PIXBUF_PROPERTY]);
#line 1399 "PhotoCanvas.c"
	}
}

void
editing_tools_photo_canvas_get_scaled_position (EditingToolsPhotoCanvas* self,
                                                GdkRectangle * result)
{
	GdkRectangle _tmp0_;
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_scaled_position;
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	*result = _tmp0_;
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	return;
#line 1416 "PhotoCanvas.c"
}

static gboolean
_cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                            const cairo_rectangle_int_t * s2)
{
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	if (s1 == s2) {
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		return TRUE;
#line 1427 "PhotoCanvas.c"
	}
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	if (s1 == NULL) {
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1433 "PhotoCanvas.c"
	}
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	if (s2 == NULL) {
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1439 "PhotoCanvas.c"
	}
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	if (s1->x != s2->x) {
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1445 "PhotoCanvas.c"
	}
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	if (s1->y != s2->y) {
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1451 "PhotoCanvas.c"
	}
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	if (s1->width != s2->width) {
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1457 "PhotoCanvas.c"
	}
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	if (s1->height != s2->height) {
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		return FALSE;
#line 1463 "PhotoCanvas.c"
	}
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	return TRUE;
#line 1467 "PhotoCanvas.c"
}

void
editing_tools_photo_canvas_set_scaled_position (EditingToolsPhotoCanvas* self,
                                                GdkRectangle * value)
{
	GdkRectangle old_value;
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_get_scaled_position (self, &old_value);
#line 39 "../src/editing_tools/PhotoCanvas.vala"
	if (_cairo_rectangle_int_equal (value, &old_value) != TRUE) {
#line 1481 "PhotoCanvas.c"
		GdkRectangle _tmp0_;
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = *value;
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		self->priv->_scaled_position = _tmp0_;
#line 39 "../src/editing_tools/PhotoCanvas.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_SCALED_POSITION_PROPERTY]);
#line 1489 "PhotoCanvas.c"
	}
}

GdkWindow*
editing_tools_photo_canvas_get_drawing_window (EditingToolsPhotoCanvas* self)
{
	GdkWindow* result;
	GdkWindow* _tmp0_;
#line 40 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_drawing_window;
#line 40 "../src/editing_tools/PhotoCanvas.vala"
	result = _tmp0_;
#line 40 "../src/editing_tools/PhotoCanvas.vala"
	return result;
#line 1506 "PhotoCanvas.c"
}

static void
editing_tools_photo_canvas_set_drawing_window (EditingToolsPhotoCanvas* self,
                                               GdkWindow* value)
{
	GdkWindow* old_value;
#line 40 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/editing_tools/PhotoCanvas.vala"
	old_value = editing_tools_photo_canvas_get_drawing_window (self);
#line 40 "../src/editing_tools/PhotoCanvas.vala"
	if (old_value != value) {
#line 1520 "PhotoCanvas.c"
		GdkWindow* _tmp0_;
#line 40 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 40 "../src/editing_tools/PhotoCanvas.vala"
		_g_object_unref0 (self->priv->_drawing_window);
#line 40 "../src/editing_tools/PhotoCanvas.vala"
		self->priv->_drawing_window = _tmp0_;
#line 40 "../src/editing_tools/PhotoCanvas.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_DRAWING_WINDOW_PROPERTY]);
#line 1530 "PhotoCanvas.c"
	}
}

GtkWindow*
editing_tools_photo_canvas_get_container (EditingToolsPhotoCanvas* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 41 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_container;
#line 41 "../src/editing_tools/PhotoCanvas.vala"
	result = _tmp0_;
#line 41 "../src/editing_tools/PhotoCanvas.vala"
	return result;
#line 1547 "PhotoCanvas.c"
}

static void
editing_tools_photo_canvas_set_container (EditingToolsPhotoCanvas* self,
                                          GtkWindow* value)
{
	GtkWindow* old_value;
#line 41 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/editing_tools/PhotoCanvas.vala"
	old_value = editing_tools_photo_canvas_get_container (self);
#line 41 "../src/editing_tools/PhotoCanvas.vala"
	if (old_value != value) {
#line 1561 "PhotoCanvas.c"
		GtkWindow* _tmp0_;
#line 41 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/editing_tools/PhotoCanvas.vala"
		_g_object_unref0 (self->priv->_container);
#line 41 "../src/editing_tools/PhotoCanvas.vala"
		self->priv->_container = _tmp0_;
#line 41 "../src/editing_tools/PhotoCanvas.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_CONTAINER_PROPERTY]);
#line 1571 "PhotoCanvas.c"
	}
}

Photo*
editing_tools_photo_canvas_get_photo (EditingToolsPhotoCanvas* self)
{
	Photo* result;
	Photo* _tmp0_;
#line 42 "../src/editing_tools/PhotoCanvas.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_photo;
#line 42 "../src/editing_tools/PhotoCanvas.vala"
	result = _tmp0_;
#line 42 "../src/editing_tools/PhotoCanvas.vala"
	return result;
#line 1588 "PhotoCanvas.c"
}

static void
editing_tools_photo_canvas_set_photo (EditingToolsPhotoCanvas* self,
                                      Photo* value)
{
	Photo* old_value;
#line 42 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/editing_tools/PhotoCanvas.vala"
	old_value = editing_tools_photo_canvas_get_photo (self);
#line 42 "../src/editing_tools/PhotoCanvas.vala"
	if (old_value != value) {
#line 1602 "PhotoCanvas.c"
		Photo* _tmp0_;
#line 42 "../src/editing_tools/PhotoCanvas.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../src/editing_tools/PhotoCanvas.vala"
		_g_object_unref0 (self->priv->_photo);
#line 42 "../src/editing_tools/PhotoCanvas.vala"
		self->priv->_photo = _tmp0_;
#line 42 "../src/editing_tools/PhotoCanvas.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_PHOTO_PROPERTY]);
#line 1612 "PhotoCanvas.c"
	}
}

static void
g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_BOXED) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (n_param_values == 3);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		data1 = closure->data;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		data2 = param_values->data[0].v_pointer;
#line 1638 "PhotoCanvas.c"
	} else {
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		data1 = param_values->data[0].v_pointer;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		data2 = closure->data;
#line 1644 "PhotoCanvas.c"
	}
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	callback = (GMarshalFunc_VOID__BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 1650 "PhotoCanvas.c"
}

static void
g_cclosure_user_marshal_VOID__BOXED_OBJECT_BOXED (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_OBJECT_BOXED) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__BOXED_OBJECT_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_return_if_fail (n_param_values == 4);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		data1 = closure->data;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		data2 = param_values->data[0].v_pointer;
#line 1675 "PhotoCanvas.c"
	} else {
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		data1 = param_values->data[0].v_pointer;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		data2 = closure->data;
#line 1681 "PhotoCanvas.c"
	}
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	callback = (GMarshalFunc_VOID__BOXED_OBJECT_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boxed (param_values + 3), data2);
#line 1687 "PhotoCanvas.c"
}

static GObject *
editing_tools_photo_canvas_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	EditingToolsPhotoCanvas * self;
	cairo_t* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkRectangle _tmp2_;
	cairo_surface_t* _tmp3_;
#line 59 "../src/editing_tools/PhotoCanvas.vala"
	parent_class = G_OBJECT_CLASS (editing_tools_photo_canvas_parent_class);
#line 59 "../src/editing_tools/PhotoCanvas.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/editing_tools/PhotoCanvas.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_PHOTO_CANVAS, EditingToolsPhotoCanvas);
#line 60 "../src/editing_tools/PhotoCanvas.vala"
	_tmp0_ = self->priv->_default_ctx;
#line 60 "../src/editing_tools/PhotoCanvas.vala"
	_tmp1_ = self->priv->_scaled_pixbuf;
#line 60 "../src/editing_tools/PhotoCanvas.vala"
	_tmp2_ = self->priv->_scaled_position;
#line 60 "../src/editing_tools/PhotoCanvas.vala"
	_tmp3_ = editing_tools_photo_canvas_pixbuf_to_surface (self, _tmp0_, _tmp1_, &_tmp2_);
#line 60 "../src/editing_tools/PhotoCanvas.vala"
	_cairo_surface_destroy0 (self->priv->scaled);
#line 60 "../src/editing_tools/PhotoCanvas.vala"
	self->priv->scaled = _tmp3_;
#line 59 "../src/editing_tools/PhotoCanvas.vala"
	return obj;
#line 1722 "PhotoCanvas.c"
}

static void
editing_tools_photo_canvas_class_init (EditingToolsPhotoCanvasClass * klass,
                                       gpointer klass_data)
{
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsPhotoCanvas_private_offset);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	((EditingToolsPhotoCanvasClass *) klass)->repaint = (void (*) (EditingToolsPhotoCanvas*)) editing_tools_photo_canvas_real_repaint;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	((EditingToolsPhotoCanvasClass *) klass)->get_style_context = (GtkStyleContext* (*) (EditingToolsPhotoCanvas*)) editing_tools_photo_canvas_real_get_style_context;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_editing_tools_photo_canvas_get_property;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_editing_tools_photo_canvas_set_property;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	G_OBJECT_CLASS (klass)->constructor = editing_tools_photo_canvas_constructor;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_photo_canvas_finalize;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_PHOTO_CANVAS_DEFAULT_CTX_PROPERTY, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_DEFAULT_CTX_PROPERTY] = g_param_spec_boxed ("default-ctx", "default-ctx", "default-ctx", cairo_gobject_context_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_PHOTO_CANVAS_SURFACE_DIM_PROPERTY, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_SURFACE_DIM_PROPERTY] = g_param_spec_boxed ("surface-dim", "surface-dim", "surface-dim", TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_PHOTO_CANVAS_SCALED_PIXBUF_PROPERTY, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_SCALED_PIXBUF_PROPERTY] = g_param_spec_object ("scaled-pixbuf", "scaled-pixbuf", "scaled-pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_PHOTO_CANVAS_SCALED_POSITION_PROPERTY, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_SCALED_POSITION_PROPERTY] = g_param_spec_boxed ("scaled-position", "scaled-position", "scaled-position", gdk_rectangle_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_PHOTO_CANVAS_DRAWING_WINDOW_PROPERTY, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_DRAWING_WINDOW_PROPERTY] = g_param_spec_object ("drawing-window", "drawing-window", "drawing-window", gdk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_PHOTO_CANVAS_CONTAINER_PROPERTY, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_CONTAINER_PROPERTY] = g_param_spec_object ("container", "container", "container", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_PHOTO_CANVAS_PHOTO_PROPERTY, editing_tools_photo_canvas_properties[EDITING_TOOLS_PHOTO_CANVAS_PHOTO_PROPERTY] = g_param_spec_object ("photo", "photo", "photo", TYPE_PHOTO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_NEW_SURFACE_SIGNAL] = g_signal_new ("new-surface", EDITING_TOOLS_TYPE_PHOTO_CANVAS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_BOXED, G_TYPE_NONE, 2, cairo_gobject_context_get_type (), TYPE_DIMENSIONS);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_RESIZED_SCALED_PIXBUF_SIGNAL] = g_signal_new ("resized-scaled-pixbuf", EDITING_TOOLS_TYPE_PHOTO_CANVAS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_OBJECT_BOXED, G_TYPE_NONE, 3, TYPE_DIMENSIONS, gdk_pixbuf_get_type (), gdk_rectangle_get_type ());
#line 1763 "PhotoCanvas.c"
}

static void
editing_tools_photo_canvas_instance_init (EditingToolsPhotoCanvas * self,
                                          gpointer klass)
{
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	self->priv = editing_tools_photo_canvas_get_instance_private (self);
#line 1772 "PhotoCanvas.c"
}

static void
editing_tools_photo_canvas_finalize (GObject * obj)
{
	EditingToolsPhotoCanvas * self;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_PHOTO_CANVAS, EditingToolsPhotoCanvas);
#line 36 "../src/editing_tools/PhotoCanvas.vala"
	_cairo_destroy0 (self->priv->_default_ctx);
#line 38 "../src/editing_tools/PhotoCanvas.vala"
	_g_object_unref0 (self->priv->_scaled_pixbuf);
#line 40 "../src/editing_tools/PhotoCanvas.vala"
	_g_object_unref0 (self->priv->_drawing_window);
#line 41 "../src/editing_tools/PhotoCanvas.vala"
	_g_object_unref0 (self->priv->_container);
#line 42 "../src/editing_tools/PhotoCanvas.vala"
	_g_object_unref0 (self->priv->_photo);
#line 44 "../src/editing_tools/PhotoCanvas.vala"
	_cairo_surface_destroy0 (self->priv->scaled);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	G_OBJECT_CLASS (editing_tools_photo_canvas_parent_class)->finalize (obj);
#line 1795 "PhotoCanvas.c"
}

static GType
editing_tools_photo_canvas_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsPhotoCanvasClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_photo_canvas_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsPhotoCanvas), 0, (GInstanceInitFunc) editing_tools_photo_canvas_instance_init, NULL };
	GType editing_tools_photo_canvas_type_id;
	editing_tools_photo_canvas_type_id = g_type_register_static (G_TYPE_OBJECT, "EditingToolsPhotoCanvas", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	EditingToolsPhotoCanvas_private_offset = g_type_add_instance_private (editing_tools_photo_canvas_type_id, sizeof (EditingToolsPhotoCanvasPrivate));
	return editing_tools_photo_canvas_type_id;
}

GType
editing_tools_photo_canvas_get_type (void)
{
	static volatile gsize editing_tools_photo_canvas_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_photo_canvas_type_id__once)) {
		GType editing_tools_photo_canvas_type_id;
		editing_tools_photo_canvas_type_id = editing_tools_photo_canvas_get_type_once ();
		g_once_init_leave (&editing_tools_photo_canvas_type_id__once, editing_tools_photo_canvas_type_id);
	}
	return editing_tools_photo_canvas_type_id__once;
}

static void
_vala_editing_tools_photo_canvas_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	EditingToolsPhotoCanvas * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, EDITING_TOOLS_TYPE_PHOTO_CANVAS, EditingToolsPhotoCanvas);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	switch (property_id) {
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_DEFAULT_CTX_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		g_value_set_boxed (value, editing_tools_photo_canvas_get_default_ctx (self));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_SURFACE_DIM_PROPERTY:
#line 1838 "PhotoCanvas.c"
		{
			Dimensions boxed;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
			editing_tools_photo_canvas_get_surface_dim (self, &boxed);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
			g_value_set_boxed (value, &boxed);
#line 1845 "PhotoCanvas.c"
		}
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_SCALED_PIXBUF_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		g_value_set_object (value, editing_tools_photo_canvas_get_scaled_pixbuf (self));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_SCALED_POSITION_PROPERTY:
#line 1857 "PhotoCanvas.c"
		{
			GdkRectangle boxed;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
			editing_tools_photo_canvas_get_scaled_position (self, &boxed);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
			g_value_set_boxed (value, &boxed);
#line 1864 "PhotoCanvas.c"
		}
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_DRAWING_WINDOW_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		g_value_set_object (value, editing_tools_photo_canvas_get_drawing_window (self));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_CONTAINER_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		g_value_set_object (value, editing_tools_photo_canvas_get_container (self));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_PHOTO_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		g_value_set_object (value, editing_tools_photo_canvas_get_photo (self));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 1886 "PhotoCanvas.c"
		default:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 1892 "PhotoCanvas.c"
	}
}

static void
_vala_editing_tools_photo_canvas_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	EditingToolsPhotoCanvas * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, EDITING_TOOLS_TYPE_PHOTO_CANVAS, EditingToolsPhotoCanvas);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
	switch (property_id) {
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_DEFAULT_CTX_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		editing_tools_photo_canvas_set_default_ctx (self, g_value_get_boxed (value));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_SURFACE_DIM_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		editing_tools_photo_canvas_set_surface_dim (self, g_value_get_boxed (value));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_SCALED_PIXBUF_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		editing_tools_photo_canvas_set_scaled_pixbuf (self, g_value_get_object (value));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_SCALED_POSITION_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		editing_tools_photo_canvas_set_scaled_position (self, g_value_get_boxed (value));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_DRAWING_WINDOW_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		editing_tools_photo_canvas_set_drawing_window (self, g_value_get_object (value));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_CONTAINER_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		editing_tools_photo_canvas_set_container (self, g_value_get_object (value));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		case EDITING_TOOLS_PHOTO_CANVAS_PHOTO_PROPERTY:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		editing_tools_photo_canvas_set_photo (self, g_value_get_object (value));
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 1948 "PhotoCanvas.c"
		default:
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/editing_tools/PhotoCanvas.vala"
		break;
#line 1954 "PhotoCanvas.c"
	}
}

