/* TopDisplay.c generated by valac 0.56.18, the Vala compiler
 * generated from TopDisplay.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <pango/pango.h>

#define TOP_DISPLAY_BACKGROUND_PROGRESS_PULSE_MSEC 250
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	TOP_DISPLAY_0_PROPERTY,
	TOP_DISPLAY_TITLE_PROPERTY,
	TOP_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* top_display_properties[TOP_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TopDisplayPrivate {
	GtkLabel* title_label;
	GtkLabel* background_progress_label;
	GtkProgressBar* background_progress_bar;
	gint current_priority;
	guint background_progress_pulse_id;
};

static gint TopDisplay_private_offset;
static gpointer top_display_parent_class = NULL;

static void top_display_set_show_progress (TopDisplay* self,
                                    gboolean value);
static gboolean top_display_on_pulse_background_progress_bar (TopDisplay* self);
static gboolean _top_display_on_pulse_background_progress_bar_gsource_func (gpointer self);
static GObject * top_display_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void top_display_finalize (GObject * obj);
static GType top_display_get_type_once (void);
static void _vala_top_display_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
top_display_get_instance_private (TopDisplay* self)
{
	return G_STRUCT_MEMBER_P (self, TopDisplay_private_offset);
}

TopDisplay*
top_display_construct (GType object_type)
{
	TopDisplay * self = NULL;
#line 46 "../src/library/TopDisplay.vala"
	self = (TopDisplay*) g_object_new (object_type, "transition-type", GTK_STACK_TRANSITION_TYPE_CROSSFADE, NULL);
#line 45 "../src/library/TopDisplay.vala"
	return self;
#line 94 "TopDisplay.c"
}

TopDisplay*
top_display_new (void)
{
#line 45 "../src/library/TopDisplay.vala"
	return top_display_construct (TYPE_TOP_DISPLAY);
#line 102 "TopDisplay.c"
}

static gboolean
_top_display_on_pulse_background_progress_bar_gsource_func (gpointer self)
{
	gboolean result;
	result = top_display_on_pulse_background_progress_bar ((TopDisplay*) self);
#line 89 "../src/library/TopDisplay.vala"
	return result;
#line 112 "TopDisplay.c"
}

void
top_display_start_pulse_background_progress_bar (TopDisplay* self,
                                                 const gchar* label,
                                                 gint priority)
{
	GtkLabel* _tmp0_;
	GtkProgressBar* _tmp1_;
#line 73 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/library/TopDisplay.vala"
	g_return_if_fail (label != NULL);
#line 74 "../src/library/TopDisplay.vala"
	if (priority < self->priv->current_priority) {
#line 75 "../src/library/TopDisplay.vala"
		return;
#line 130 "TopDisplay.c"
	}
#line 77 "../src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, priority, FALSE);
#line 79 "../src/library/TopDisplay.vala"
	self->priv->current_priority = priority;
#line 81 "../src/library/TopDisplay.vala"
	_tmp0_ = self->priv->background_progress_label;
#line 81 "../src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp0_, label);
#line 82 "../src/library/TopDisplay.vala"
	_tmp1_ = self->priv->background_progress_bar;
#line 82 "../src/library/TopDisplay.vala"
	gtk_progress_bar_pulse (_tmp1_);
#line 83 "../src/library/TopDisplay.vala"
	top_display_set_show_progress (self, TRUE);
#line 85 "../src/library/TopDisplay.vala"
	if (self->priv->background_progress_pulse_id > ((guint) 0)) {
#line 86 "../src/library/TopDisplay.vala"
		g_source_remove (self->priv->background_progress_pulse_id);
#line 150 "TopDisplay.c"
	}
#line 89 "../src/library/TopDisplay.vala"
	self->priv->background_progress_pulse_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) TOP_DISPLAY_BACKGROUND_PROGRESS_PULSE_MSEC, _top_display_on_pulse_background_progress_bar_gsource_func, g_object_ref (self), g_object_unref);
#line 154 "TopDisplay.c"
}

static gboolean
top_display_on_pulse_background_progress_bar (TopDisplay* self)
{
	GtkProgressBar* _tmp0_;
	gboolean result;
#line 92 "../src/library/TopDisplay.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/library/TopDisplay.vala"
	_tmp0_ = self->priv->background_progress_bar;
#line 93 "../src/library/TopDisplay.vala"
	gtk_progress_bar_pulse (_tmp0_);
#line 94 "../src/library/TopDisplay.vala"
	result = TRUE;
#line 94 "../src/library/TopDisplay.vala"
	return result;
#line 172 "TopDisplay.c"
}

void
top_display_stop_pulse_background_progress_bar (TopDisplay* self,
                                                gint priority,
                                                gboolean clear)
{
#line 97 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/library/TopDisplay.vala"
	if (priority < self->priv->current_priority) {
#line 99 "../src/library/TopDisplay.vala"
		return;
#line 186 "TopDisplay.c"
	}
#line 101 "../src/library/TopDisplay.vala"
	if (self->priv->background_progress_pulse_id > ((guint) 0)) {
#line 102 "../src/library/TopDisplay.vala"
		g_source_remove (self->priv->background_progress_pulse_id);
#line 103 "../src/library/TopDisplay.vala"
		self->priv->background_progress_pulse_id = (guint) 0;
#line 194 "TopDisplay.c"
	}
#line 106 "../src/library/TopDisplay.vala"
	if (clear) {
#line 107 "../src/library/TopDisplay.vala"
		top_display_clear_background_progress_bar (self, priority);
#line 200 "TopDisplay.c"
	}
}

void
top_display_update_background_progress_bar (TopDisplay* self,
                                            const gchar* label,
                                            gint priority,
                                            gdouble count,
                                            gdouble total)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gdouble fraction = 0.0;
	GtkProgressBar* _tmp2_;
	GtkLabel* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 110 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/library/TopDisplay.vala"
	g_return_if_fail (label != NULL);
#line 111 "../src/library/TopDisplay.vala"
	if (priority < self->priv->current_priority) {
#line 112 "../src/library/TopDisplay.vala"
		return;
#line 226 "TopDisplay.c"
	}
#line 115 "../src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, priority, FALSE);
#line 117 "../src/library/TopDisplay.vala"
	if (count <= 0.0) {
#line 117 "../src/library/TopDisplay.vala"
		_tmp1_ = TRUE;
#line 234 "TopDisplay.c"
	} else {
#line 117 "../src/library/TopDisplay.vala"
		_tmp1_ = total <= 0.0;
#line 238 "TopDisplay.c"
	}
#line 117 "../src/library/TopDisplay.vala"
	if (_tmp1_) {
#line 117 "../src/library/TopDisplay.vala"
		_tmp0_ = TRUE;
#line 244 "TopDisplay.c"
	} else {
#line 117 "../src/library/TopDisplay.vala"
		_tmp0_ = count >= total;
#line 248 "TopDisplay.c"
	}
#line 117 "../src/library/TopDisplay.vala"
	if (_tmp0_) {
#line 118 "../src/library/TopDisplay.vala"
		top_display_clear_background_progress_bar (self, priority);
#line 119 "../src/library/TopDisplay.vala"
		return;
#line 256 "TopDisplay.c"
	}
#line 122 "../src/library/TopDisplay.vala"
	self->priv->current_priority = priority;
#line 124 "../src/library/TopDisplay.vala"
	fraction = count / total;
#line 125 "../src/library/TopDisplay.vala"
	_tmp2_ = self->priv->background_progress_bar;
#line 125 "../src/library/TopDisplay.vala"
	gtk_progress_bar_set_fraction (_tmp2_, fraction);
#line 126 "../src/library/TopDisplay.vala"
	_tmp3_ = self->priv->background_progress_label;
#line 126 "../src/library/TopDisplay.vala"
	_tmp4_ = g_strdup_printf (_ ("%s (%d%%)"), label, (gint) (fraction * 100.0));
#line 126 "../src/library/TopDisplay.vala"
	_tmp5_ = _tmp4_;
#line 126 "../src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp3_, _tmp5_);
#line 126 "../src/library/TopDisplay.vala"
	_g_free0 (_tmp5_);
#line 127 "../src/library/TopDisplay.vala"
	top_display_set_show_progress (self, TRUE);
#line 130 "../src/library/TopDisplay.vala"
	granite_services_application_set_progress_visible (TRUE, NULL, NULL);
#line 131 "../src/library/TopDisplay.vala"
	granite_services_application_set_progress (fraction, NULL, NULL);
#line 282 "TopDisplay.c"
}

void
top_display_clear_background_progress_bar (TopDisplay* self,
                                           gint priority)
{
	GtkProgressBar* _tmp0_;
	GtkLabel* _tmp1_;
#line 135 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/library/TopDisplay.vala"
	if (priority < self->priv->current_priority) {
#line 137 "../src/library/TopDisplay.vala"
		return;
#line 297 "TopDisplay.c"
	}
#line 140 "../src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, priority, FALSE);
#line 142 "../src/library/TopDisplay.vala"
	self->priv->current_priority = 0;
#line 144 "../src/library/TopDisplay.vala"
	_tmp0_ = self->priv->background_progress_bar;
#line 144 "../src/library/TopDisplay.vala"
	gtk_progress_bar_set_fraction (_tmp0_, 0.0);
#line 145 "../src/library/TopDisplay.vala"
	_tmp1_ = self->priv->background_progress_label;
#line 145 "../src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp1_, "");
#line 146 "../src/library/TopDisplay.vala"
	top_display_set_show_progress (self, FALSE);
#line 149 "../src/library/TopDisplay.vala"
	granite_services_application_set_progress_visible (FALSE, NULL, NULL);
#line 150 "../src/library/TopDisplay.vala"
	granite_services_application_set_progress (0.0, NULL, NULL);
#line 317 "TopDisplay.c"
}

static void
top_display_set_show_progress (TopDisplay* self,
                               gboolean value)
{
#line 30 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/library/TopDisplay.vala"
	if (value) {
#line 32 "../src/library/TopDisplay.vala"
		gtk_stack_set_visible_child_name ((GtkStack*) self, "progress");
#line 330 "TopDisplay.c"
	} else {
		GtkLabel* _tmp0_;
#line 34 "../src/library/TopDisplay.vala"
		_tmp0_ = self->priv->title_label;
#line 34 "../src/library/TopDisplay.vala"
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp0_);
#line 337 "TopDisplay.c"
	}
}

void
top_display_set_title (TopDisplay* self,
                       const gchar* value)
{
	GtkLabel* _tmp0_;
#line 40 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/library/TopDisplay.vala"
	_tmp0_ = self->priv->title_label;
#line 41 "../src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp0_, value);
#line 40 "../src/library/TopDisplay.vala"
	g_object_notify_by_pspec ((GObject *) self, top_display_properties[TOP_DISPLAY_TITLE_PROPERTY]);
#line 354 "TopDisplay.c"
}

static GObject *
top_display_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TopDisplay * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkProgressBar* _tmp6_;
	GtkProgressBar* _tmp7_;
	GtkGrid* progress_grid = NULL;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkLabel* _tmp13_;
	GtkGrid* _tmp14_;
	GtkProgressBar* _tmp15_;
	GtkLabel* _tmp16_;
	GtkGrid* _tmp17_;
#line 49 "../src/library/TopDisplay.vala"
	parent_class = G_OBJECT_CLASS (top_display_parent_class);
#line 49 "../src/library/TopDisplay.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 49 "../src/library/TopDisplay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOP_DISPLAY, TopDisplay);
#line 50 "../src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, FALSE);
#line 52 "../src/library/TopDisplay.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Photos"));
#line 52 "../src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp0_);
#line 52 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->title_label);
#line 52 "../src/library/TopDisplay.vala"
	self->priv->title_label = _tmp0_;
#line 53 "../src/library/TopDisplay.vala"
	_tmp1_ = self->priv->title_label;
#line 53 "../src/library/TopDisplay.vala"
	gtk_label_set_ellipsize (_tmp1_, PANGO_ELLIPSIZE_MIDDLE);
#line 54 "../src/library/TopDisplay.vala"
	_tmp2_ = self->priv->title_label;
#line 54 "../src/library/TopDisplay.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 54 "../src/library/TopDisplay.vala"
	gtk_style_context_add_class (_tmp3_, GTK_STYLE_CLASS_TITLE);
#line 56 "../src/library/TopDisplay.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
#line 56 "../src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp4_);
#line 56 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_label);
#line 56 "../src/library/TopDisplay.vala"
	self->priv->background_progress_label = _tmp4_;
#line 57 "../src/library/TopDisplay.vala"
	_tmp5_ = self->priv->background_progress_label;
#line 57 "../src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp5_, TRUE);
#line 59 "../src/library/TopDisplay.vala"
	_tmp6_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 59 "../src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp6_);
#line 59 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_bar);
#line 59 "../src/library/TopDisplay.vala"
	self->priv->background_progress_bar = _tmp6_;
#line 60 "../src/library/TopDisplay.vala"
	_tmp7_ = self->priv->background_progress_bar;
#line 60 "../src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, TRUE);
#line 62 "../src/library/TopDisplay.vala"
	_tmp8_ = (GtkGrid*) gtk_grid_new ();
#line 62 "../src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp8_);
#line 62 "../src/library/TopDisplay.vala"
	progress_grid = _tmp8_;
#line 63 "../src/library/TopDisplay.vala"
	_tmp9_ = progress_grid;
#line 63 "../src/library/TopDisplay.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp9_, GTK_ORIENTATION_VERTICAL);
#line 64 "../src/library/TopDisplay.vala"
	_tmp10_ = progress_grid;
#line 64 "../src/library/TopDisplay.vala"
	gtk_grid_set_row_spacing (_tmp10_, 6);
#line 65 "../src/library/TopDisplay.vala"
	_tmp11_ = progress_grid;
#line 65 "../src/library/TopDisplay.vala"
	g_object_set ((GtkWidget*) _tmp11_, "width-request", 200, NULL);
#line 66 "../src/library/TopDisplay.vala"
	_tmp12_ = progress_grid;
#line 66 "../src/library/TopDisplay.vala"
	_tmp13_ = self->priv->background_progress_label;
#line 66 "../src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 67 "../src/library/TopDisplay.vala"
	_tmp14_ = progress_grid;
#line 67 "../src/library/TopDisplay.vala"
	_tmp15_ = self->priv->background_progress_bar;
#line 67 "../src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 69 "../src/library/TopDisplay.vala"
	_tmp16_ = self->priv->title_label;
#line 69 "../src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp16_);
#line 70 "../src/library/TopDisplay.vala"
	_tmp17_ = progress_grid;
#line 70 "../src/library/TopDisplay.vala"
	gtk_stack_add_named ((GtkStack*) self, (GtkWidget*) _tmp17_, "progress");
#line 49 "../src/library/TopDisplay.vala"
	_g_object_unref0 (progress_grid);
#line 49 "../src/library/TopDisplay.vala"
	return obj;
#line 476 "TopDisplay.c"
}

static void
top_display_class_init (TopDisplayClass * klass,
                        gpointer klass_data)
{
#line 20 "../src/library/TopDisplay.vala"
	top_display_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/library/TopDisplay.vala"
	g_type_class_adjust_private_offset (klass, &TopDisplay_private_offset);
#line 20 "../src/library/TopDisplay.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_top_display_set_property;
#line 20 "../src/library/TopDisplay.vala"
	G_OBJECT_CLASS (klass)->constructor = top_display_constructor;
#line 20 "../src/library/TopDisplay.vala"
	G_OBJECT_CLASS (klass)->finalize = top_display_finalize;
#line 20 "../src/library/TopDisplay.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOP_DISPLAY_TITLE_PROPERTY, top_display_properties[TOP_DISPLAY_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 495 "TopDisplay.c"
}

static void
top_display_instance_init (TopDisplay * self,
                           gpointer klass)
{
#line 20 "../src/library/TopDisplay.vala"
	self->priv = top_display_get_instance_private (self);
#line 25 "../src/library/TopDisplay.vala"
	self->priv->current_priority = 0;
#line 26 "../src/library/TopDisplay.vala"
	self->priv->background_progress_pulse_id = 0U;
#line 508 "TopDisplay.c"
}

static void
top_display_finalize (GObject * obj)
{
	TopDisplay * self;
#line 20 "../src/library/TopDisplay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOP_DISPLAY, TopDisplay);
#line 21 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->title_label);
#line 22 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_label);
#line 23 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_bar);
#line 20 "../src/library/TopDisplay.vala"
	G_OBJECT_CLASS (top_display_parent_class)->finalize (obj);
#line 525 "TopDisplay.c"
}

static GType
top_display_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TopDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) top_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TopDisplay), 0, (GInstanceInitFunc) top_display_instance_init, NULL };
	GType top_display_type_id;
	top_display_type_id = g_type_register_static (gtk_stack_get_type (), "TopDisplay", &g_define_type_info, 0);
	TopDisplay_private_offset = g_type_add_instance_private (top_display_type_id, sizeof (TopDisplayPrivate));
	return top_display_type_id;
}

GType
top_display_get_type (void)
{
	static volatile gsize top_display_type_id__once = 0;
	if (g_once_init_enter (&top_display_type_id__once)) {
		GType top_display_type_id;
		top_display_type_id = top_display_get_type_once ();
		g_once_init_leave (&top_display_type_id__once, top_display_type_id);
	}
	return top_display_type_id__once;
}

static void
_vala_top_display_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	TopDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TOP_DISPLAY, TopDisplay);
#line 20 "../src/library/TopDisplay.vala"
	switch (property_id) {
#line 20 "../src/library/TopDisplay.vala"
		case TOP_DISPLAY_TITLE_PROPERTY:
#line 20 "../src/library/TopDisplay.vala"
		top_display_set_title (self, g_value_get_string (value));
#line 20 "../src/library/TopDisplay.vala"
		break;
#line 566 "TopDisplay.c"
		default:
#line 20 "../src/library/TopDisplay.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/library/TopDisplay.vala"
		break;
#line 572 "TopDisplay.c"
	}
}

