/* GdkSupport.c generated by valac 0.56.18, the Vala compiler
 * generated from GdkSupport.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))
#define _g_checksum_free0(var) ((var == NULL) ? NULL : (var = (g_checksum_free (var), NULL)))

struct _GdkSnifferPrivate {
	DetectedPhotoInformation* detected;
	gboolean size_ready;
	gboolean area_prepared;
};

static gpointer gdk_reader_parent_class = NULL;
static gint GdkSniffer_private_offset;
static gpointer gdk_sniffer_parent_class = NULL;

static PhotoMetadata* gdk_reader_real_read_metadata (PhotoFileReader* base,
                                              GError** error);
static GdkPixbuf* gdk_reader_real_unscaled_read (PhotoFileReader* base,
                                          GError** error);
static GdkPixbuf* gdk_reader_real_scaled_read (PhotoFileReader* base,
                                        Dimensions* full,
                                        Dimensions* scaled,
                                        GError** error);
static GType gdk_reader_get_type_once (void);
static DetectedPhotoInformation* gdk_sniffer_real_sniff (PhotoFileSniffer* base,
                                                  GError** error);
static void gdk_sniffer_on_size_prepared (GdkSniffer* self,
                                   GdkPixbufLoader* loader,
                                   gint width,
                                   gint height);
static void _gdk_sniffer_on_size_prepared_gdk_pixbuf_loader_size_prepared (GdkPixbufLoader* _sender,
                                                                    gint width,
                                                                    gint height,
                                                                    gpointer self);
static void gdk_sniffer_on_area_prepared (GdkSniffer* self,
                                   GdkPixbufLoader* pixbuf_loader);
static void _gdk_sniffer_on_area_prepared_gdk_pixbuf_loader_area_prepared (GdkPixbufLoader* _sender,
                                                                    gpointer self);
static guint8* _vala_array_dup8 (guint8* self,
                          gssize length);
static void gdk_sniffer_finalize (PhotoFileSniffer * obj);
static GType gdk_sniffer_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GdkReader*
gdk_reader_construct (GType object_type,
                      const gchar* filepath,
                      PhotoFileFormat file_format)
{
	GdkReader* self = NULL;
#line 21 "../src/photos/GdkSupport.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 22 "../src/photos/GdkSupport.vala"
	self = (GdkReader*) photo_file_reader_construct (object_type, filepath, file_format);
#line 21 "../src/photos/GdkSupport.vala"
	return self;
#line 99 "GdkSupport.c"
}

static PhotoMetadata*
gdk_reader_real_read_metadata (PhotoFileReader* base,
                               GError** error)
{
	GdkReader * self;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result;
#line 25 "../src/photos/GdkSupport.vala"
	self = (GdkReader*) base;
#line 26 "../src/photos/GdkSupport.vala"
	_tmp0_ = photo_metadata_new ();
#line 26 "../src/photos/GdkSupport.vala"
	metadata = _tmp0_;
#line 27 "../src/photos/GdkSupport.vala"
	_tmp1_ = photo_file_adapter_get_file ((PhotoFileAdapter*) self);
#line 27 "../src/photos/GdkSupport.vala"
	_tmp2_ = _tmp1_;
#line 27 "../src/photos/GdkSupport.vala"
	media_metadata_read_from_file ((MediaMetadata*) metadata, _tmp2_, &_inner_error0_);
#line 27 "../src/photos/GdkSupport.vala"
	_g_object_unref0 (_tmp2_);
#line 27 "../src/photos/GdkSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27 "../src/photos/GdkSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 27 "../src/photos/GdkSupport.vala"
		_media_metadata_unref0 (metadata);
#line 27 "../src/photos/GdkSupport.vala"
		return NULL;
#line 135 "GdkSupport.c"
	}
#line 29 "../src/photos/GdkSupport.vala"
	result = metadata;
#line 29 "../src/photos/GdkSupport.vala"
	return result;
#line 141 "GdkSupport.c"
}

static GdkPixbuf*
gdk_reader_real_unscaled_read (PhotoFileReader* base,
                               GError** error)
{
	GdkReader * self;
	GdkPixbuf* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 32 "../src/photos/GdkSupport.vala"
	self = (GdkReader*) base;
#line 33 "../src/photos/GdkSupport.vala"
	_tmp1_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) self);
#line 33 "../src/photos/GdkSupport.vala"
	_tmp2_ = _tmp1_;
#line 33 "../src/photos/GdkSupport.vala"
	_tmp3_ = gdk_pixbuf_new_from_file (_tmp2_, &_inner_error0_);
#line 33 "../src/photos/GdkSupport.vala"
	_tmp4_ = _tmp3_;
#line 33 "../src/photos/GdkSupport.vala"
	_g_free0 (_tmp2_);
#line 33 "../src/photos/GdkSupport.vala"
	_tmp0_ = _tmp4_;
#line 33 "../src/photos/GdkSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 33 "../src/photos/GdkSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 33 "../src/photos/GdkSupport.vala"
		return NULL;
#line 177 "GdkSupport.c"
	}
#line 33 "../src/photos/GdkSupport.vala"
	_tmp5_ = _tmp0_;
#line 33 "../src/photos/GdkSupport.vala"
	_tmp0_ = NULL;
#line 33 "../src/photos/GdkSupport.vala"
	result = _tmp5_;
#line 33 "../src/photos/GdkSupport.vala"
	_g_object_unref0 (_tmp0_);
#line 33 "../src/photos/GdkSupport.vala"
	return result;
#line 189 "GdkSupport.c"
}

static GdkPixbuf*
gdk_reader_real_scaled_read (PhotoFileReader* base,
                             Dimensions* full,
                             Dimensions* scaled,
                             GError** error)
{
	GdkReader * self;
	GdkPixbuf* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	Dimensions _tmp3_;
	Dimensions _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 36 "../src/photos/GdkSupport.vala"
	self = (GdkReader*) base;
#line 36 "../src/photos/GdkSupport.vala"
	g_return_val_if_fail (full != NULL, NULL);
#line 36 "../src/photos/GdkSupport.vala"
	g_return_val_if_fail (scaled != NULL, NULL);
#line 37 "../src/photos/GdkSupport.vala"
	_tmp1_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) self);
#line 37 "../src/photos/GdkSupport.vala"
	_tmp2_ = _tmp1_;
#line 37 "../src/photos/GdkSupport.vala"
	_tmp3_ = *scaled;
#line 37 "../src/photos/GdkSupport.vala"
	_tmp4_ = *scaled;
#line 37 "../src/photos/GdkSupport.vala"
	_tmp5_ = gdk_pixbuf_new_from_file_at_scale (_tmp2_, _tmp3_.width, _tmp4_.height, FALSE, &_inner_error0_);
#line 37 "../src/photos/GdkSupport.vala"
	_tmp6_ = _tmp5_;
#line 37 "../src/photos/GdkSupport.vala"
	_g_free0 (_tmp2_);
#line 37 "../src/photos/GdkSupport.vala"
	_tmp0_ = _tmp6_;
#line 37 "../src/photos/GdkSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "../src/photos/GdkSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 37 "../src/photos/GdkSupport.vala"
		return NULL;
#line 237 "GdkSupport.c"
	}
#line 37 "../src/photos/GdkSupport.vala"
	_tmp7_ = _tmp0_;
#line 37 "../src/photos/GdkSupport.vala"
	_tmp0_ = NULL;
#line 37 "../src/photos/GdkSupport.vala"
	result = _tmp7_;
#line 37 "../src/photos/GdkSupport.vala"
	_g_object_unref0 (_tmp0_);
#line 37 "../src/photos/GdkSupport.vala"
	return result;
#line 249 "GdkSupport.c"
}

static void
gdk_reader_class_init (GdkReaderClass * klass,
                       gpointer klass_data)
{
#line 20 "../src/photos/GdkSupport.vala"
	gdk_reader_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/photos/GdkSupport.vala"
	((PhotoFileReaderClass *) klass)->read_metadata = (PhotoMetadata* (*) (PhotoFileReader*, GError**)) gdk_reader_real_read_metadata;
#line 20 "../src/photos/GdkSupport.vala"
	((PhotoFileReaderClass *) klass)->unscaled_read = (GdkPixbuf* (*) (PhotoFileReader*, GError**)) gdk_reader_real_unscaled_read;
#line 20 "../src/photos/GdkSupport.vala"
	((PhotoFileReaderClass *) klass)->scaled_read = (GdkPixbuf* (*) (PhotoFileReader*, Dimensions*, Dimensions*, GError**)) gdk_reader_real_scaled_read;
#line 264 "GdkSupport.c"
}

static void
gdk_reader_instance_init (GdkReader * self,
                          gpointer klass)
{
}

static GType
gdk_reader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GdkReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gdk_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GdkReader), 0, (GInstanceInitFunc) gdk_reader_instance_init, NULL };
	GType gdk_reader_type_id;
	gdk_reader_type_id = g_type_register_static (TYPE_PHOTO_FILE_READER, "GdkReader", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return gdk_reader_type_id;
}

GType
gdk_reader_get_type (void)
{
	static volatile gsize gdk_reader_type_id__once = 0;
	if (g_once_init_enter (&gdk_reader_type_id__once)) {
		GType gdk_reader_type_id;
		gdk_reader_type_id = gdk_reader_get_type_once ();
		g_once_init_leave (&gdk_reader_type_id__once, gdk_reader_type_id);
	}
	return gdk_reader_type_id__once;
}

static inline gpointer
gdk_sniffer_get_instance_private (GdkSniffer* self)
{
	return G_STRUCT_MEMBER_P (self, GdkSniffer_private_offset);
}

GdkSniffer*
gdk_sniffer_construct (GType object_type,
                       GFile* file,
                       PhotoFileSnifferOptions options)
{
	GdkSniffer* self = NULL;
#line 46 "../src/photos/GdkSupport.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 47 "../src/photos/GdkSupport.vala"
	self = (GdkSniffer*) photo_file_sniffer_construct (object_type, file, options);
#line 46 "../src/photos/GdkSupport.vala"
	return self;
#line 312 "GdkSupport.c"
}

static void
_gdk_sniffer_on_size_prepared_gdk_pixbuf_loader_size_prepared (GdkPixbufLoader* _sender,
                                                               gint width,
                                                               gint height,
                                                               gpointer self)
{
#line 54 "../src/photos/GdkSupport.vala"
	gdk_sniffer_on_size_prepared ((GdkSniffer*) self, _sender, width, height);
#line 323 "GdkSupport.c"
}

static void
_gdk_sniffer_on_area_prepared_gdk_pixbuf_loader_area_prepared (GdkPixbufLoader* _sender,
                                                               gpointer self)
{
#line 55 "../src/photos/GdkSupport.vala"
	gdk_sniffer_on_area_prepared ((GdkSniffer*) self, _sender);
#line 332 "GdkSupport.c"
}

static guint8*
_vala_array_dup8 (guint8* self,
                  gssize length)
{
#line 82 "../src/photos/GdkSupport.vala"
	if (length > 0) {
#line 82 "../src/photos/GdkSupport.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 343 "GdkSupport.c"
	}
#line 82 "../src/photos/GdkSupport.vala"
	return NULL;
#line 347 "GdkSupport.c"
}

static gpointer
_detected_photo_information_ref0 (gpointer self)
{
#line 118 "../src/photos/GdkSupport.vala"
	return self ? detected_photo_information_ref (self) : NULL;
#line 355 "GdkSupport.c"
}

static DetectedPhotoInformation*
gdk_sniffer_real_sniff (PhotoFileSniffer* base,
                        GError** error)
{
	GdkSniffer * self;
	DetectedPhotoInformation* _tmp0_;
	GdkPixbufLoader* pixbuf_loader = NULL;
	GdkPixbufLoader* _tmp1_;
	GdkPixbufLoader* _tmp2_;
	GdkPixbufLoader* _tmp3_;
	GChecksum* md5_checksum = NULL;
	DetectedPhotoInformation* _tmp5_;
	PhotoMetadata* _tmp6_;
	gboolean _tmp11_ = FALSE;
	guint8* _tmp36_ = NULL;
	gint _tmp36__length1 = 0;
	gint __tmp36__size_ = 0;
	guint8* buffer = NULL;
	guint8* _tmp39_;
	gint _tmp39__length1;
	gint buffer_length1;
	gint _buffer_size_;
	gsize count = 0UL;
	GFileInputStream* fins = NULL;
	GFile* _tmp40_;
	GFileInputStream* _tmp41_;
	GFileInputStream* _tmp53_;
	DetectedPhotoInformation* _tmp59_;
	DetectedPhotoInformation* _tmp60_;
	GError* _inner_error0_ = NULL;
	DetectedPhotoInformation* result;
#line 50 "../src/photos/GdkSupport.vala"
	self = (GdkSniffer*) base;
#line 51 "../src/photos/GdkSupport.vala"
	_tmp0_ = detected_photo_information_new ();
#line 51 "../src/photos/GdkSupport.vala"
	_detected_photo_information_unref0 (self->priv->detected);
#line 51 "../src/photos/GdkSupport.vala"
	self->priv->detected = _tmp0_;
#line 53 "../src/photos/GdkSupport.vala"
	_tmp1_ = gdk_pixbuf_loader_new ();
#line 53 "../src/photos/GdkSupport.vala"
	pixbuf_loader = _tmp1_;
#line 54 "../src/photos/GdkSupport.vala"
	_tmp2_ = pixbuf_loader;
#line 54 "../src/photos/GdkSupport.vala"
	g_signal_connect (_tmp2_, "size-prepared", (GCallback) _gdk_sniffer_on_size_prepared_gdk_pixbuf_loader_size_prepared, self);
#line 55 "../src/photos/GdkSupport.vala"
	_tmp3_ = pixbuf_loader;
#line 55 "../src/photos/GdkSupport.vala"
	g_signal_connect (_tmp3_, "area-prepared", (GCallback) _gdk_sniffer_on_area_prepared_gdk_pixbuf_loader_area_prepared, self);
#line 58 "../src/photos/GdkSupport.vala"
	md5_checksum = NULL;
#line 59 "../src/photos/GdkSupport.vala"
	if (((PhotoFileSniffer*) self)->calc_md5) {
#line 413 "GdkSupport.c"
		GChecksum* _tmp4_;
#line 60 "../src/photos/GdkSupport.vala"
		_tmp4_ = g_checksum_new (G_CHECKSUM_MD5);
#line 60 "../src/photos/GdkSupport.vala"
		_g_checksum_free0 (md5_checksum);
#line 60 "../src/photos/GdkSupport.vala"
		md5_checksum = _tmp4_;
#line 421 "GdkSupport.c"
	}
#line 62 "../src/photos/GdkSupport.vala"
	_tmp5_ = self->priv->detected;
#line 62 "../src/photos/GdkSupport.vala"
	_tmp6_ = photo_metadata_new ();
#line 62 "../src/photos/GdkSupport.vala"
	_media_metadata_unref0 (_tmp5_->metadata);
#line 62 "../src/photos/GdkSupport.vala"
	_tmp5_->metadata = _tmp6_;
#line 431 "GdkSupport.c"
	{
		DetectedPhotoInformation* _tmp7_;
		PhotoMetadata* _tmp8_;
		GFile* _tmp9_;
#line 64 "../src/photos/GdkSupport.vala"
		_tmp7_ = self->priv->detected;
#line 64 "../src/photos/GdkSupport.vala"
		_tmp8_ = _tmp7_->metadata;
#line 64 "../src/photos/GdkSupport.vala"
		_tmp9_ = ((PhotoFileSniffer*) self)->file;
#line 64 "../src/photos/GdkSupport.vala"
		media_metadata_read_from_file ((MediaMetadata*) _tmp8_, _tmp9_, &_inner_error0_);
#line 64 "../src/photos/GdkSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 446 "GdkSupport.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		DetectedPhotoInformation* _tmp10_;
#line 63 "../src/photos/GdkSupport.vala"
		g_clear_error (&_inner_error0_);
#line 67 "../src/photos/GdkSupport.vala"
		_tmp10_ = self->priv->detected;
#line 67 "../src/photos/GdkSupport.vala"
		_media_metadata_unref0 (_tmp10_->metadata);
#line 67 "../src/photos/GdkSupport.vala"
		_tmp10_->metadata = NULL;
#line 462 "GdkSupport.c"
	}
	__finally0:
#line 63 "../src/photos/GdkSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../src/photos/GdkSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 63 "../src/photos/GdkSupport.vala"
		_g_checksum_free0 (md5_checksum);
#line 63 "../src/photos/GdkSupport.vala"
		_g_object_unref0 (pixbuf_loader);
#line 63 "../src/photos/GdkSupport.vala"
		return NULL;
#line 475 "GdkSupport.c"
	}
#line 70 "../src/photos/GdkSupport.vala"
	if (((PhotoFileSniffer*) self)->calc_md5) {
#line 479 "GdkSupport.c"
		DetectedPhotoInformation* _tmp12_;
		PhotoMetadata* _tmp13_;
#line 70 "../src/photos/GdkSupport.vala"
		_tmp12_ = self->priv->detected;
#line 70 "../src/photos/GdkSupport.vala"
		_tmp13_ = _tmp12_->metadata;
#line 70 "../src/photos/GdkSupport.vala"
		_tmp11_ = _tmp13_ != NULL;
#line 488 "GdkSupport.c"
	} else {
#line 70 "../src/photos/GdkSupport.vala"
		_tmp11_ = FALSE;
#line 492 "GdkSupport.c"
	}
#line 70 "../src/photos/GdkSupport.vala"
	if (_tmp11_) {
#line 496 "GdkSupport.c"
		guint8* flattened_sans_thumbnail = NULL;
		DetectedPhotoInformation* _tmp14_;
		PhotoMetadata* _tmp15_;
		gint _tmp16_ = 0;
		guint8* _tmp17_;
		gint flattened_sans_thumbnail_length1;
		gint _flattened_sans_thumbnail_size_;
		gboolean _tmp18_ = FALSE;
		guint8* _tmp19_;
		gint _tmp19__length1;
		guint8* flattened_thumbnail = NULL;
		DetectedPhotoInformation* _tmp25_;
		PhotoMetadata* _tmp26_;
		gint _tmp27_ = 0;
		guint8* _tmp28_;
		gint flattened_thumbnail_length1;
		gint _flattened_thumbnail_size_;
		gboolean _tmp29_ = FALSE;
		guint8* _tmp30_;
		gint _tmp30__length1;
#line 71 "../src/photos/GdkSupport.vala"
		_tmp14_ = self->priv->detected;
#line 71 "../src/photos/GdkSupport.vala"
		_tmp15_ = _tmp14_->metadata;
#line 71 "../src/photos/GdkSupport.vala"
		_tmp17_ = photo_metadata_flatten_exif (_tmp15_, FALSE, &_tmp16_);
#line 71 "../src/photos/GdkSupport.vala"
		flattened_sans_thumbnail = _tmp17_;
#line 71 "../src/photos/GdkSupport.vala"
		flattened_sans_thumbnail_length1 = _tmp16_;
#line 71 "../src/photos/GdkSupport.vala"
		_flattened_sans_thumbnail_size_ = flattened_sans_thumbnail_length1;
#line 72 "../src/photos/GdkSupport.vala"
		_tmp19_ = flattened_sans_thumbnail;
#line 72 "../src/photos/GdkSupport.vala"
		_tmp19__length1 = flattened_sans_thumbnail_length1;
#line 72 "../src/photos/GdkSupport.vala"
		if (_tmp19_ != NULL) {
#line 535 "GdkSupport.c"
			guint8* _tmp20_;
			gint _tmp20__length1;
#line 72 "../src/photos/GdkSupport.vala"
			_tmp20_ = flattened_sans_thumbnail;
#line 72 "../src/photos/GdkSupport.vala"
			_tmp20__length1 = flattened_sans_thumbnail_length1;
#line 72 "../src/photos/GdkSupport.vala"
			_tmp18_ = _tmp20__length1 > 0;
#line 544 "GdkSupport.c"
		} else {
#line 72 "../src/photos/GdkSupport.vala"
			_tmp18_ = FALSE;
#line 548 "GdkSupport.c"
		}
#line 72 "../src/photos/GdkSupport.vala"
		if (_tmp18_) {
#line 552 "GdkSupport.c"
			DetectedPhotoInformation* _tmp21_;
			guint8* _tmp22_;
			gint _tmp22__length1;
			guint8* _tmp23_;
			gint _tmp23__length1;
			gchar* _tmp24_;
#line 73 "../src/photos/GdkSupport.vala"
			_tmp21_ = self->priv->detected;
#line 73 "../src/photos/GdkSupport.vala"
			_tmp22_ = flattened_sans_thumbnail;
#line 73 "../src/photos/GdkSupport.vala"
			_tmp22__length1 = flattened_sans_thumbnail_length1;
#line 73 "../src/photos/GdkSupport.vala"
			_tmp23_ = flattened_sans_thumbnail;
#line 73 "../src/photos/GdkSupport.vala"
			_tmp23__length1 = flattened_sans_thumbnail_length1;
#line 73 "../src/photos/GdkSupport.vala"
			_tmp24_ = md5_binary (_tmp22_, (gsize) _tmp23__length1);
#line 73 "../src/photos/GdkSupport.vala"
			_g_free0 (_tmp21_->exif_md5);
#line 73 "../src/photos/GdkSupport.vala"
			_tmp21_->exif_md5 = _tmp24_;
#line 575 "GdkSupport.c"
		}
#line 75 "../src/photos/GdkSupport.vala"
		_tmp25_ = self->priv->detected;
#line 75 "../src/photos/GdkSupport.vala"
		_tmp26_ = _tmp25_->metadata;
#line 75 "../src/photos/GdkSupport.vala"
		_tmp28_ = photo_metadata_flatten_exif_preview (_tmp26_, &_tmp27_);
#line 75 "../src/photos/GdkSupport.vala"
		flattened_thumbnail = _tmp28_;
#line 75 "../src/photos/GdkSupport.vala"
		flattened_thumbnail_length1 = _tmp27_;
#line 75 "../src/photos/GdkSupport.vala"
		_flattened_thumbnail_size_ = flattened_thumbnail_length1;
#line 76 "../src/photos/GdkSupport.vala"
		_tmp30_ = flattened_thumbnail;
#line 76 "../src/photos/GdkSupport.vala"
		_tmp30__length1 = flattened_thumbnail_length1;
#line 76 "../src/photos/GdkSupport.vala"
		if (_tmp30_ != NULL) {
#line 595 "GdkSupport.c"
			guint8* _tmp31_;
			gint _tmp31__length1;
#line 76 "../src/photos/GdkSupport.vala"
			_tmp31_ = flattened_thumbnail;
#line 76 "../src/photos/GdkSupport.vala"
			_tmp31__length1 = flattened_thumbnail_length1;
#line 76 "../src/photos/GdkSupport.vala"
			_tmp29_ = _tmp31__length1 > 0;
#line 604 "GdkSupport.c"
		} else {
#line 76 "../src/photos/GdkSupport.vala"
			_tmp29_ = FALSE;
#line 608 "GdkSupport.c"
		}
#line 76 "../src/photos/GdkSupport.vala"
		if (_tmp29_) {
#line 612 "GdkSupport.c"
			DetectedPhotoInformation* _tmp32_;
			guint8* _tmp33_;
			gint _tmp33__length1;
			guint8* _tmp34_;
			gint _tmp34__length1;
			gchar* _tmp35_;
#line 77 "../src/photos/GdkSupport.vala"
			_tmp32_ = self->priv->detected;
#line 77 "../src/photos/GdkSupport.vala"
			_tmp33_ = flattened_thumbnail;
#line 77 "../src/photos/GdkSupport.vala"
			_tmp33__length1 = flattened_thumbnail_length1;
#line 77 "../src/photos/GdkSupport.vala"
			_tmp34_ = flattened_thumbnail;
#line 77 "../src/photos/GdkSupport.vala"
			_tmp34__length1 = flattened_thumbnail_length1;
#line 77 "../src/photos/GdkSupport.vala"
			_tmp35_ = md5_binary (_tmp33_, (gsize) _tmp34__length1);
#line 77 "../src/photos/GdkSupport.vala"
			_g_free0 (_tmp32_->thumbnail_md5);
#line 77 "../src/photos/GdkSupport.vala"
			_tmp32_->thumbnail_md5 = _tmp35_;
#line 635 "GdkSupport.c"
		}
#line 70 "../src/photos/GdkSupport.vala"
		flattened_thumbnail = (g_free (flattened_thumbnail), NULL);
#line 70 "../src/photos/GdkSupport.vala"
		flattened_sans_thumbnail = (g_free (flattened_sans_thumbnail), NULL);
#line 641 "GdkSupport.c"
	}
#line 82 "../src/photos/GdkSupport.vala"
	if (((PhotoFileSniffer*) self)->calc_md5) {
#line 645 "GdkSupport.c"
		guint8* _tmp37_;
#line 82 "../src/photos/GdkSupport.vala"
		_tmp37_ = g_new0 (guint8, 64 * 1024);
#line 82 "../src/photos/GdkSupport.vala"
		_tmp36_ = (g_free (_tmp36_), NULL);
#line 82 "../src/photos/GdkSupport.vala"
		_tmp36_ = _tmp37_;
#line 82 "../src/photos/GdkSupport.vala"
		_tmp36__length1 = 64 * 1024;
#line 82 "../src/photos/GdkSupport.vala"
		__tmp36__size_ = _tmp36__length1;
#line 657 "GdkSupport.c"
	} else {
		guint8* _tmp38_;
#line 82 "../src/photos/GdkSupport.vala"
		_tmp38_ = g_new0 (guint8, 8 * 1024);
#line 82 "../src/photos/GdkSupport.vala"
		_tmp36_ = (g_free (_tmp36_), NULL);
#line 82 "../src/photos/GdkSupport.vala"
		_tmp36_ = _tmp38_;
#line 82 "../src/photos/GdkSupport.vala"
		_tmp36__length1 = 8 * 1024;
#line 82 "../src/photos/GdkSupport.vala"
		__tmp36__size_ = _tmp36__length1;
#line 670 "GdkSupport.c"
	}
#line 82 "../src/photos/GdkSupport.vala"
	_tmp39_ = (_tmp36_ != NULL) ? _vala_array_dup8 (_tmp36_, _tmp36__length1) : _tmp36_;
#line 82 "../src/photos/GdkSupport.vala"
	_tmp39__length1 = _tmp36__length1;
#line 82 "../src/photos/GdkSupport.vala"
	buffer = _tmp39_;
#line 82 "../src/photos/GdkSupport.vala"
	buffer_length1 = _tmp39__length1;
#line 82 "../src/photos/GdkSupport.vala"
	_buffer_size_ = buffer_length1;
#line 83 "../src/photos/GdkSupport.vala"
	count = (gsize) 0;
#line 86 "../src/photos/GdkSupport.vala"
	_tmp40_ = ((PhotoFileSniffer*) self)->file;
#line 86 "../src/photos/GdkSupport.vala"
	_tmp41_ = g_file_read (_tmp40_, NULL, &_inner_error0_);
#line 86 "../src/photos/GdkSupport.vala"
	fins = _tmp41_;
#line 86 "../src/photos/GdkSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/photos/GdkSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 86 "../src/photos/GdkSupport.vala"
		buffer = (g_free (buffer), NULL);
#line 86 "../src/photos/GdkSupport.vala"
		_tmp36_ = (g_free (_tmp36_), NULL);
#line 86 "../src/photos/GdkSupport.vala"
		_g_checksum_free0 (md5_checksum);
#line 86 "../src/photos/GdkSupport.vala"
		_g_object_unref0 (pixbuf_loader);
#line 86 "../src/photos/GdkSupport.vala"
		return NULL;
#line 704 "GdkSupport.c"
	}
	{
		gboolean _tmp42_ = FALSE;
#line 87 "../src/photos/GdkSupport.vala"
		_tmp42_ = TRUE;
#line 87 "../src/photos/GdkSupport.vala"
		while (TRUE) {
#line 712 "GdkSupport.c"
			gsize bytes_read = 0UL;
			GFileInputStream* _tmp43_;
			guint8* _tmp44_;
			gint _tmp44__length1;
			gboolean _tmp47_ = FALSE;
			gboolean _tmp50_ = FALSE;
			gboolean _tmp51_ = FALSE;
#line 87 "../src/photos/GdkSupport.vala"
			if (!_tmp42_) {
#line 722 "GdkSupport.c"
			}
#line 87 "../src/photos/GdkSupport.vala"
			_tmp42_ = FALSE;
#line 88 "../src/photos/GdkSupport.vala"
			_tmp43_ = fins;
#line 88 "../src/photos/GdkSupport.vala"
			_tmp44_ = buffer;
#line 88 "../src/photos/GdkSupport.vala"
			_tmp44__length1 = buffer_length1;
#line 88 "../src/photos/GdkSupport.vala"
			bytes_read = (gsize) g_input_stream_read ((GInputStream*) _tmp43_, _tmp44_, (gsize) _tmp44__length1, NULL, &_inner_error0_);
#line 88 "../src/photos/GdkSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../src/photos/GdkSupport.vala"
				g_propagate_error (error, _inner_error0_);
#line 88 "../src/photos/GdkSupport.vala"
				_g_object_unref0 (fins);
#line 88 "../src/photos/GdkSupport.vala"
				buffer = (g_free (buffer), NULL);
#line 88 "../src/photos/GdkSupport.vala"
				_tmp36_ = (g_free (_tmp36_), NULL);
#line 88 "../src/photos/GdkSupport.vala"
				_g_checksum_free0 (md5_checksum);
#line 88 "../src/photos/GdkSupport.vala"
				_g_object_unref0 (pixbuf_loader);
#line 88 "../src/photos/GdkSupport.vala"
				return NULL;
#line 750 "GdkSupport.c"
			}
#line 89 "../src/photos/GdkSupport.vala"
			if (bytes_read <= ((gsize) 0)) {
#line 90 "../src/photos/GdkSupport.vala"
				break;
#line 756 "GdkSupport.c"
			}
#line 92 "../src/photos/GdkSupport.vala"
			count += bytes_read;
#line 94 "../src/photos/GdkSupport.vala"
			if (((PhotoFileSniffer*) self)->calc_md5) {
#line 762 "GdkSupport.c"
				GChecksum* _tmp45_;
				guint8* _tmp46_;
				gint _tmp46__length1;
#line 95 "../src/photos/GdkSupport.vala"
				_tmp45_ = md5_checksum;
#line 95 "../src/photos/GdkSupport.vala"
				_tmp46_ = buffer;
#line 95 "../src/photos/GdkSupport.vala"
				_tmp46__length1 = buffer_length1;
#line 95 "../src/photos/GdkSupport.vala"
				g_checksum_update (_tmp45_, _tmp46_, bytes_read);
#line 774 "GdkSupport.c"
			}
#line 98 "../src/photos/GdkSupport.vala"
			if (!self->priv->size_ready) {
#line 98 "../src/photos/GdkSupport.vala"
				_tmp47_ = TRUE;
#line 780 "GdkSupport.c"
			} else {
#line 98 "../src/photos/GdkSupport.vala"
				_tmp47_ = !self->priv->area_prepared;
#line 784 "GdkSupport.c"
			}
#line 98 "../src/photos/GdkSupport.vala"
			if (_tmp47_) {
#line 788 "GdkSupport.c"
				GdkPixbufLoader* _tmp48_;
				guint8* _tmp49_;
				gint _tmp49__length1;
#line 99 "../src/photos/GdkSupport.vala"
				_tmp48_ = pixbuf_loader;
#line 99 "../src/photos/GdkSupport.vala"
				_tmp49_ = buffer;
#line 99 "../src/photos/GdkSupport.vala"
				_tmp49__length1 = buffer_length1;
#line 99 "../src/photos/GdkSupport.vala"
				gdk_pixbuf_loader_write (_tmp48_, _tmp49_ + 0, (gsize) (((gint) bytes_read) - 0), &_inner_error0_);
#line 99 "../src/photos/GdkSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/photos/GdkSupport.vala"
					g_propagate_error (error, _inner_error0_);
#line 99 "../src/photos/GdkSupport.vala"
					_g_object_unref0 (fins);
#line 99 "../src/photos/GdkSupport.vala"
					buffer = (g_free (buffer), NULL);
#line 99 "../src/photos/GdkSupport.vala"
					_tmp36_ = (g_free (_tmp36_), NULL);
#line 99 "../src/photos/GdkSupport.vala"
					_g_checksum_free0 (md5_checksum);
#line 99 "../src/photos/GdkSupport.vala"
					_g_object_unref0 (pixbuf_loader);
#line 99 "../src/photos/GdkSupport.vala"
					return NULL;
#line 816 "GdkSupport.c"
				}
			}
#line 102 "../src/photos/GdkSupport.vala"
			if (!((PhotoFileSniffer*) self)->calc_md5) {
#line 102 "../src/photos/GdkSupport.vala"
				_tmp51_ = self->priv->size_ready;
#line 823 "GdkSupport.c"
			} else {
#line 102 "../src/photos/GdkSupport.vala"
				_tmp51_ = FALSE;
#line 827 "GdkSupport.c"
			}
#line 102 "../src/photos/GdkSupport.vala"
			if (_tmp51_) {
#line 102 "../src/photos/GdkSupport.vala"
				_tmp50_ = self->priv->area_prepared;
#line 833 "GdkSupport.c"
			} else {
#line 102 "../src/photos/GdkSupport.vala"
				_tmp50_ = FALSE;
#line 837 "GdkSupport.c"
			}
#line 102 "../src/photos/GdkSupport.vala"
			if (_tmp50_) {
#line 103 "../src/photos/GdkSupport.vala"
				break;
#line 843 "GdkSupport.c"
			}
		}
	}
	{
		GdkPixbufLoader* _tmp52_;
#line 108 "../src/photos/GdkSupport.vala"
		_tmp52_ = pixbuf_loader;
#line 108 "../src/photos/GdkSupport.vala"
		gdk_pixbuf_loader_close (_tmp52_, &_inner_error0_);
#line 108 "../src/photos/GdkSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 855 "GdkSupport.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 107 "../src/photos/GdkSupport.vala"
		g_clear_error (&_inner_error0_);
#line 864 "GdkSupport.c"
	}
	__finally1:
#line 107 "../src/photos/GdkSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 107 "../src/photos/GdkSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 107 "../src/photos/GdkSupport.vala"
		_g_object_unref0 (fins);
#line 107 "../src/photos/GdkSupport.vala"
		buffer = (g_free (buffer), NULL);
#line 107 "../src/photos/GdkSupport.vala"
		_tmp36_ = (g_free (_tmp36_), NULL);
#line 107 "../src/photos/GdkSupport.vala"
		_g_checksum_free0 (md5_checksum);
#line 107 "../src/photos/GdkSupport.vala"
		_g_object_unref0 (pixbuf_loader);
#line 107 "../src/photos/GdkSupport.vala"
		return NULL;
#line 883 "GdkSupport.c"
	}
#line 112 "../src/photos/GdkSupport.vala"
	_tmp53_ = fins;
#line 112 "../src/photos/GdkSupport.vala"
	if (_tmp53_ != NULL) {
#line 889 "GdkSupport.c"
		GFileInputStream* _tmp54_;
#line 113 "../src/photos/GdkSupport.vala"
		_tmp54_ = fins;
#line 113 "../src/photos/GdkSupport.vala"
		g_input_stream_close ((GInputStream*) _tmp54_, NULL, &_inner_error0_);
#line 113 "../src/photos/GdkSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/photos/GdkSupport.vala"
			g_propagate_error (error, _inner_error0_);
#line 113 "../src/photos/GdkSupport.vala"
			_g_object_unref0 (fins);
#line 113 "../src/photos/GdkSupport.vala"
			buffer = (g_free (buffer), NULL);
#line 113 "../src/photos/GdkSupport.vala"
			_tmp36_ = (g_free (_tmp36_), NULL);
#line 113 "../src/photos/GdkSupport.vala"
			_g_checksum_free0 (md5_checksum);
#line 113 "../src/photos/GdkSupport.vala"
			_g_object_unref0 (pixbuf_loader);
#line 113 "../src/photos/GdkSupport.vala"
			return NULL;
#line 911 "GdkSupport.c"
		}
	}
#line 115 "../src/photos/GdkSupport.vala"
	if (((PhotoFileSniffer*) self)->calc_md5) {
#line 916 "GdkSupport.c"
		DetectedPhotoInformation* _tmp55_;
		GChecksum* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
#line 116 "../src/photos/GdkSupport.vala"
		_tmp55_ = self->priv->detected;
#line 116 "../src/photos/GdkSupport.vala"
		_tmp56_ = md5_checksum;
#line 116 "../src/photos/GdkSupport.vala"
		_tmp57_ = g_checksum_get_string (_tmp56_);
#line 116 "../src/photos/GdkSupport.vala"
		_tmp58_ = g_strdup (_tmp57_);
#line 116 "../src/photos/GdkSupport.vala"
		_g_free0 (_tmp55_->md5);
#line 116 "../src/photos/GdkSupport.vala"
		_tmp55_->md5 = _tmp58_;
#line 933 "GdkSupport.c"
	}
#line 118 "../src/photos/GdkSupport.vala"
	_tmp59_ = self->priv->detected;
#line 118 "../src/photos/GdkSupport.vala"
	_tmp60_ = _detected_photo_information_ref0 (_tmp59_);
#line 118 "../src/photos/GdkSupport.vala"
	result = _tmp60_;
#line 118 "../src/photos/GdkSupport.vala"
	_g_object_unref0 (fins);
#line 118 "../src/photos/GdkSupport.vala"
	buffer = (g_free (buffer), NULL);
#line 118 "../src/photos/GdkSupport.vala"
	_tmp36_ = (g_free (_tmp36_), NULL);
#line 118 "../src/photos/GdkSupport.vala"
	_g_checksum_free0 (md5_checksum);
#line 118 "../src/photos/GdkSupport.vala"
	_g_object_unref0 (pixbuf_loader);
#line 118 "../src/photos/GdkSupport.vala"
	return result;
#line 953 "GdkSupport.c"
}

static void
gdk_sniffer_on_size_prepared (GdkSniffer* self,
                              GdkPixbufLoader* loader,
                              gint width,
                              gint height)
{
	DetectedPhotoInformation* _tmp0_;
#line 121 "../src/photos/GdkSupport.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/photos/GdkSupport.vala"
	g_return_if_fail (loader != NULL);
#line 122 "../src/photos/GdkSupport.vala"
	_tmp0_ = self->priv->detected;
#line 122 "../src/photos/GdkSupport.vala"
	dimensions_init (&_tmp0_->image_dim, width, height);
#line 123 "../src/photos/GdkSupport.vala"
	self->priv->size_ready = TRUE;
#line 973 "GdkSupport.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 127 "../src/photos/GdkSupport.vala"
	return self ? g_object_ref (self) : NULL;
#line 981 "GdkSupport.c"
}

static void
gdk_sniffer_on_area_prepared (GdkSniffer* self,
                              GdkPixbufLoader* pixbuf_loader)
{
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	DetectedPhotoInformation* _tmp3_;
	GdkPixbuf* _tmp4_;
	DetectedPhotoInformation* _tmp5_;
	GdkPixbuf* _tmp6_;
	DetectedPhotoInformation* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbufFormat* format = NULL;
	GdkPixbufFormat* _tmp9_;
	DetectedPhotoInformation* _tmp10_;
	GdkPixbufFormat* _tmp11_;
	gchar* _tmp12_;
	DetectedPhotoInformation* _tmp13_;
	DetectedPhotoInformation* _tmp14_;
	const gchar* _tmp15_;
#line 126 "../src/photos/GdkSupport.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/photos/GdkSupport.vala"
	g_return_if_fail (pixbuf_loader != NULL);
#line 127 "../src/photos/GdkSupport.vala"
	_tmp0_ = gdk_pixbuf_loader_get_pixbuf (pixbuf_loader);
#line 127 "../src/photos/GdkSupport.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 127 "../src/photos/GdkSupport.vala"
	pixbuf = _tmp1_;
#line 128 "../src/photos/GdkSupport.vala"
	_tmp2_ = pixbuf;
#line 128 "../src/photos/GdkSupport.vala"
	if (_tmp2_ == NULL) {
#line 129 "../src/photos/GdkSupport.vala"
		_g_object_unref0 (pixbuf);
#line 129 "../src/photos/GdkSupport.vala"
		return;
#line 1024 "GdkSupport.c"
	}
#line 131 "../src/photos/GdkSupport.vala"
	_tmp3_ = self->priv->detected;
#line 131 "../src/photos/GdkSupport.vala"
	_tmp4_ = pixbuf;
#line 131 "../src/photos/GdkSupport.vala"
	_tmp3_->colorspace = gdk_pixbuf_get_colorspace (_tmp4_);
#line 132 "../src/photos/GdkSupport.vala"
	_tmp5_ = self->priv->detected;
#line 132 "../src/photos/GdkSupport.vala"
	_tmp6_ = pixbuf;
#line 132 "../src/photos/GdkSupport.vala"
	_tmp5_->channels = gdk_pixbuf_get_n_channels (_tmp6_);
#line 133 "../src/photos/GdkSupport.vala"
	_tmp7_ = self->priv->detected;
#line 133 "../src/photos/GdkSupport.vala"
	_tmp8_ = pixbuf;
#line 133 "../src/photos/GdkSupport.vala"
	_tmp7_->bits_per_channel = gdk_pixbuf_get_bits_per_sample (_tmp8_);
#line 135 "../src/photos/GdkSupport.vala"
	_tmp9_ = gdk_pixbuf_loader_get_format (pixbuf_loader);
#line 135 "../src/photos/GdkSupport.vala"
	format = _tmp9_;
#line 136 "../src/photos/GdkSupport.vala"
	_tmp10_ = self->priv->detected;
#line 136 "../src/photos/GdkSupport.vala"
	_tmp11_ = format;
#line 136 "../src/photos/GdkSupport.vala"
	_tmp12_ = gdk_pixbuf_format_get_name (_tmp11_);
#line 136 "../src/photos/GdkSupport.vala"
	_g_free0 (_tmp10_->format_name);
#line 136 "../src/photos/GdkSupport.vala"
	_tmp10_->format_name = _tmp12_;
#line 137 "../src/photos/GdkSupport.vala"
	_tmp13_ = self->priv->detected;
#line 137 "../src/photos/GdkSupport.vala"
	_tmp14_ = self->priv->detected;
#line 137 "../src/photos/GdkSupport.vala"
	_tmp15_ = _tmp14_->format_name;
#line 137 "../src/photos/GdkSupport.vala"
	_tmp13_->file_format = photo_file_format_from_pixbuf_name (_tmp15_);
#line 139 "../src/photos/GdkSupport.vala"
	self->priv->area_prepared = TRUE;
#line 126 "../src/photos/GdkSupport.vala"
	_g_object_unref0 (pixbuf);
#line 1070 "GdkSupport.c"
}

static void
gdk_sniffer_class_init (GdkSnifferClass * klass,
                        gpointer klass_data)
{
#line 41 "../src/photos/GdkSupport.vala"
	gdk_sniffer_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/photos/GdkSupport.vala"
	((PhotoFileSnifferClass *) klass)->finalize = gdk_sniffer_finalize;
#line 41 "../src/photos/GdkSupport.vala"
	g_type_class_adjust_private_offset (klass, &GdkSniffer_private_offset);
#line 41 "../src/photos/GdkSupport.vala"
	((PhotoFileSnifferClass *) klass)->sniff = (DetectedPhotoInformation* (*) (PhotoFileSniffer*, GError**)) gdk_sniffer_real_sniff;
#line 1085 "GdkSupport.c"
}

static void
gdk_sniffer_instance_init (GdkSniffer * self,
                           gpointer klass)
{
#line 41 "../src/photos/GdkSupport.vala"
	self->priv = gdk_sniffer_get_instance_private (self);
#line 42 "../src/photos/GdkSupport.vala"
	self->priv->detected = NULL;
#line 43 "../src/photos/GdkSupport.vala"
	self->priv->size_ready = FALSE;
#line 44 "../src/photos/GdkSupport.vala"
	self->priv->area_prepared = FALSE;
#line 1100 "GdkSupport.c"
}

static void
gdk_sniffer_finalize (PhotoFileSniffer * obj)
{
	GdkSniffer * self;
#line 41 "../src/photos/GdkSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GDK_SNIFFER, GdkSniffer);
#line 42 "../src/photos/GdkSupport.vala"
	_detected_photo_information_unref0 (self->priv->detected);
#line 41 "../src/photos/GdkSupport.vala"
	PHOTO_FILE_SNIFFER_CLASS (gdk_sniffer_parent_class)->finalize (obj);
#line 1113 "GdkSupport.c"
}

static GType
gdk_sniffer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GdkSnifferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gdk_sniffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GdkSniffer), 0, (GInstanceInitFunc) gdk_sniffer_instance_init, NULL };
	GType gdk_sniffer_type_id;
	gdk_sniffer_type_id = g_type_register_static (TYPE_PHOTO_FILE_SNIFFER, "GdkSniffer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	GdkSniffer_private_offset = g_type_add_instance_private (gdk_sniffer_type_id, sizeof (GdkSnifferPrivate));
	return gdk_sniffer_type_id;
}

GType
gdk_sniffer_get_type (void)
{
	static volatile gsize gdk_sniffer_type_id__once = 0;
	if (g_once_init_enter (&gdk_sniffer_type_id__once)) {
		GType gdk_sniffer_type_id;
		gdk_sniffer_type_id = gdk_sniffer_get_type_once ();
		g_once_init_leave (&gdk_sniffer_type_id__once, gdk_sniffer_type_id);
	}
	return gdk_sniffer_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

