/* PhotoFileAdapter.c generated by valac 0.56.18, the Vala compiler
 * generated from PhotoFileAdapter.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* PhotoFileAdapter*/
/**/
/* PhotoFileAdapter (and its immediate children, PhotoFileReader and PhotoFileWriter) are drivers*/
/* hiding details of reading and writing image files and their metadata.  They should keep*/
/* minimal state beyond the filename, if any stat at all.  In particular, they should avoid caching*/
/* values, especially the readers, as writers may be created at any time and invalidate that*/
/* information, unless the readers monitor the file for these changes.*/
/**/
/* PhotoFileAdapters should be entirely thread-safe.  They are not, however, responsible for*/
/* atomicity on the filesystem.*/
/**/

#include "io.elementary.photos.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecPhotoFileAdapter ParamSpecPhotoFileAdapter;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

struct _PhotoFileAdapterPrivate {
	gchar* filepath;
	PhotoFileFormat file_format;
	GFile* file;
	GRecMutex __lock_file;
};

struct _ParamSpecPhotoFileAdapter {
	GParamSpec parent_instance;
};

static gint PhotoFileAdapter_private_offset;
static gpointer photo_file_adapter_parent_class = NULL;
static gpointer photo_file_reader_parent_class = NULL;
static gpointer photo_file_writer_parent_class = NULL;
static gpointer photo_file_metadata_writer_parent_class = NULL;

static void photo_file_adapter_finalize (PhotoFileAdapter * obj);
static GType photo_file_adapter_get_type_once (void);
static PhotoMetadata* photo_file_reader_real_read_metadata (PhotoFileReader* self,
                                                     GError** error);
static GdkPixbuf* photo_file_reader_real_unscaled_read (PhotoFileReader* self,
                                                 GError** error);
static GdkPixbuf* photo_file_reader_real_scaled_read (PhotoFileReader* self,
                                               Dimensions* full,
                                               Dimensions* scaled,
                                               GError** error);
VALA_EXTERN GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
static GType photo_file_reader_get_type_once (void);
static void photo_file_writer_real_write (PhotoFileWriter* self,
                                   GdkPixbuf* pixbuf,
                                   JpegQuality quality,
                                   GError** error);
static GType photo_file_writer_get_type_once (void);
static void photo_file_metadata_writer_real_write_metadata (PhotoFileMetadataWriter* self,
                                                     PhotoMetadata* metadata,
                                                     GError** error);
static GType photo_file_metadata_writer_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
photo_file_adapter_get_instance_private (PhotoFileAdapter* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoFileAdapter_private_offset);
}

PhotoFileAdapter*
photo_file_adapter_construct (GType object_type,
                              const gchar* filepath,
                              PhotoFileFormat file_format)
{
	PhotoFileAdapter* self = NULL;
	gchar* _tmp0_;
#line 38 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 38 "../src/photos/PhotoFileAdapter.vala"
	self = (PhotoFileAdapter*) g_type_create_instance (object_type);
#line 39 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = g_strdup (filepath);
#line 39 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (self->priv->filepath);
#line 39 "../src/photos/PhotoFileAdapter.vala"
	self->priv->filepath = _tmp0_;
#line 40 "../src/photos/PhotoFileAdapter.vala"
	self->priv->file_format = file_format;
#line 38 "../src/photos/PhotoFileAdapter.vala"
	return self;
#line 130 "PhotoFileAdapter.c"
}

gboolean
photo_file_adapter_file_exists (PhotoFileAdapter* self)
{
	const gchar* _tmp0_;
	gboolean result;
#line 43 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = self->priv->filepath;
#line 44 "../src/photos/PhotoFileAdapter.vala"
	result = g_file_test (_tmp0_, G_FILE_TEST_IS_REGULAR);
#line 44 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 146 "PhotoFileAdapter.c"
}

gchar*
photo_file_adapter_get_filepath (PhotoFileAdapter* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 47 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = self->priv->filepath;
#line 48 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 48 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp1_;
#line 48 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 165 "PhotoFileAdapter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 57 "../src/photos/PhotoFileAdapter.vala"
	return self ? g_object_ref (self) : NULL;
#line 173 "PhotoFileAdapter.c"
}

GFile*
photo_file_adapter_get_file (PhotoFileAdapter* self)
{
	GFile* _result_ = NULL;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 51 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 184 "PhotoFileAdapter.c"
	{
		GFile* _tmp0_;
#line 53 "../src/photos/PhotoFileAdapter.vala"
		_tmp0_ = self->priv->file;
#line 53 "../src/photos/PhotoFileAdapter.vala"
		g_rec_mutex_lock (&self->priv->__lock_file);
#line 191 "PhotoFileAdapter.c"
		{
			GFile* _tmp1_;
			GFile* _tmp4_;
			GFile* _tmp5_;
#line 54 "../src/photos/PhotoFileAdapter.vala"
			_tmp1_ = self->priv->file;
#line 54 "../src/photos/PhotoFileAdapter.vala"
			if (_tmp1_ == NULL) {
#line 200 "PhotoFileAdapter.c"
				const gchar* _tmp2_;
				GFile* _tmp3_;
#line 55 "../src/photos/PhotoFileAdapter.vala"
				_tmp2_ = self->priv->filepath;
#line 55 "../src/photos/PhotoFileAdapter.vala"
				_tmp3_ = g_file_new_for_path (_tmp2_);
#line 55 "../src/photos/PhotoFileAdapter.vala"
				_g_object_unref0 (self->priv->file);
#line 55 "../src/photos/PhotoFileAdapter.vala"
				self->priv->file = _tmp3_;
#line 211 "PhotoFileAdapter.c"
			}
#line 57 "../src/photos/PhotoFileAdapter.vala"
			_tmp4_ = self->priv->file;
#line 57 "../src/photos/PhotoFileAdapter.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 57 "../src/photos/PhotoFileAdapter.vala"
			_g_object_unref0 (_result_);
#line 57 "../src/photos/PhotoFileAdapter.vala"
			_result_ = _tmp5_;
#line 221 "PhotoFileAdapter.c"
		}
		__finally0:
		{
			GFile* _tmp6_;
#line 53 "../src/photos/PhotoFileAdapter.vala"
			_tmp6_ = self->priv->file;
#line 53 "../src/photos/PhotoFileAdapter.vala"
			g_rec_mutex_unlock (&self->priv->__lock_file);
#line 230 "PhotoFileAdapter.c"
		}
#line 53 "../src/photos/PhotoFileAdapter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 53 "../src/photos/PhotoFileAdapter.vala"
			_g_object_unref0 (_result_);
#line 53 "../src/photos/PhotoFileAdapter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 53 "../src/photos/PhotoFileAdapter.vala"
			g_clear_error (&_inner_error0_);
#line 53 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 242 "PhotoFileAdapter.c"
		}
	}
#line 60 "../src/photos/PhotoFileAdapter.vala"
	result = _result_;
#line 60 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 249 "PhotoFileAdapter.c"
}

PhotoFileFormat
photo_file_adapter_get_file_format (PhotoFileAdapter* self)
{
	PhotoFileFormat result;
#line 63 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 64 "../src/photos/PhotoFileAdapter.vala"
	result = self->priv->file_format;
#line 64 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 262 "PhotoFileAdapter.c"
}

static void
value_photo_file_adapter_init (GValue* value)
{
#line 33 "../src/photos/PhotoFileAdapter.vala"
	value->data[0].v_pointer = NULL;
#line 270 "PhotoFileAdapter.c"
}

static void
value_photo_file_adapter_free_value (GValue* value)
{
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (value->data[0].v_pointer) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		photo_file_adapter_unref (value->data[0].v_pointer);
#line 280 "PhotoFileAdapter.c"
	}
}

static void
value_photo_file_adapter_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (src_value->data[0].v_pointer) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		dest_value->data[0].v_pointer = photo_file_adapter_ref (src_value->data[0].v_pointer);
#line 292 "PhotoFileAdapter.c"
	} else {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 296 "PhotoFileAdapter.c"
	}
}

static gpointer
value_photo_file_adapter_peek_pointer (const GValue* value)
{
#line 33 "../src/photos/PhotoFileAdapter.vala"
	return value->data[0].v_pointer;
#line 305 "PhotoFileAdapter.c"
}

static gchar*
value_photo_file_adapter_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (collect_values[0].v_pointer) {
#line 316 "PhotoFileAdapter.c"
		PhotoFileAdapter * object;
		object = collect_values[0].v_pointer;
#line 33 "../src/photos/PhotoFileAdapter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 323 "PhotoFileAdapter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 327 "PhotoFileAdapter.c"
		}
#line 33 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = photo_file_adapter_ref (object);
#line 331 "PhotoFileAdapter.c"
	} else {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = NULL;
#line 335 "PhotoFileAdapter.c"
	}
#line 33 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 339 "PhotoFileAdapter.c"
}

static gchar*
value_photo_file_adapter_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	PhotoFileAdapter ** object_p;
	object_p = collect_values[0].v_pointer;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (!object_p) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 354 "PhotoFileAdapter.c"
	}
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (!value->data[0].v_pointer) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		*object_p = NULL;
#line 360 "PhotoFileAdapter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		*object_p = value->data[0].v_pointer;
#line 364 "PhotoFileAdapter.c"
	} else {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		*object_p = photo_file_adapter_ref (value->data[0].v_pointer);
#line 368 "PhotoFileAdapter.c"
	}
#line 33 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 372 "PhotoFileAdapter.c"
}

GParamSpec*
param_spec_photo_file_adapter (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	ParamSpecPhotoFileAdapter* spec;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_FILE_ADAPTER), NULL);
#line 33 "../src/photos/PhotoFileAdapter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 33 "../src/photos/PhotoFileAdapter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	return G_PARAM_SPEC (spec);
#line 391 "PhotoFileAdapter.c"
}

gpointer
value_get_photo_file_adapter (const GValue* value)
{
#line 33 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER), NULL);
#line 33 "../src/photos/PhotoFileAdapter.vala"
	return value->data[0].v_pointer;
#line 401 "PhotoFileAdapter.c"
}

void
value_set_photo_file_adapter (GValue* value,
                              gpointer v_object)
{
	PhotoFileAdapter * old;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER));
#line 33 "../src/photos/PhotoFileAdapter.vala"
	old = value->data[0].v_pointer;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (v_object) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_FILE_ADAPTER));
#line 33 "../src/photos/PhotoFileAdapter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 33 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = v_object;
#line 33 "../src/photos/PhotoFileAdapter.vala"
		photo_file_adapter_ref (value->data[0].v_pointer);
#line 423 "PhotoFileAdapter.c"
	} else {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = NULL;
#line 427 "PhotoFileAdapter.c"
	}
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (old) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		photo_file_adapter_unref (old);
#line 433 "PhotoFileAdapter.c"
	}
}

void
value_take_photo_file_adapter (GValue* value,
                               gpointer v_object)
{
	PhotoFileAdapter * old;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER));
#line 33 "../src/photos/PhotoFileAdapter.vala"
	old = value->data[0].v_pointer;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (v_object) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_FILE_ADAPTER));
#line 33 "../src/photos/PhotoFileAdapter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 33 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = v_object;
#line 454 "PhotoFileAdapter.c"
	} else {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = NULL;
#line 458 "PhotoFileAdapter.c"
	}
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (old) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		photo_file_adapter_unref (old);
#line 464 "PhotoFileAdapter.c"
	}
}

static void
photo_file_adapter_class_init (PhotoFileAdapterClass * klass,
                               gpointer klass_data)
{
#line 33 "../src/photos/PhotoFileAdapter.vala"
	photo_file_adapter_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileAdapterClass *) klass)->finalize = photo_file_adapter_finalize;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	g_type_class_adjust_private_offset (klass, &PhotoFileAdapter_private_offset);
#line 478 "PhotoFileAdapter.c"
}

static void
photo_file_adapter_instance_init (PhotoFileAdapter * self,
                                  gpointer klass)
{
#line 33 "../src/photos/PhotoFileAdapter.vala"
	self->priv = photo_file_adapter_get_instance_private (self);
#line 36 "../src/photos/PhotoFileAdapter.vala"
	g_rec_mutex_init (&self->priv->__lock_file);
#line 36 "../src/photos/PhotoFileAdapter.vala"
	self->priv->file = NULL;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	self->ref_count = 1;
#line 493 "PhotoFileAdapter.c"
}

static void
photo_file_adapter_finalize (PhotoFileAdapter * obj)
{
	PhotoFileAdapter * self;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter);
#line 33 "../src/photos/PhotoFileAdapter.vala"
	g_signal_handlers_destroy (self);
#line 34 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (self->priv->filepath);
#line 36 "../src/photos/PhotoFileAdapter.vala"
	g_rec_mutex_clear (&self->priv->__lock_file);
#line 36 "../src/photos/PhotoFileAdapter.vala"
	_g_object_unref0 (self->priv->file);
#line 510 "PhotoFileAdapter.c"
}

static GType
photo_file_adapter_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_file_adapter_init, value_photo_file_adapter_free_value, value_photo_file_adapter_copy_value, value_photo_file_adapter_peek_pointer, "p", value_photo_file_adapter_collect_value, "p", value_photo_file_adapter_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoFileAdapterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_adapter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileAdapter), 0, (GInstanceInitFunc) photo_file_adapter_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_file_adapter_type_id;
	photo_file_adapter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoFileAdapter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	PhotoFileAdapter_private_offset = g_type_add_instance_private (photo_file_adapter_type_id, sizeof (PhotoFileAdapterPrivate));
	return photo_file_adapter_type_id;
}

GType
photo_file_adapter_get_type (void)
{
	static volatile gsize photo_file_adapter_type_id__once = 0;
	if (g_once_init_enter (&photo_file_adapter_type_id__once)) {
		GType photo_file_adapter_type_id;
		photo_file_adapter_type_id = photo_file_adapter_get_type_once ();
		g_once_init_leave (&photo_file_adapter_type_id__once, photo_file_adapter_type_id);
	}
	return photo_file_adapter_type_id__once;
}

gpointer
photo_file_adapter_ref (gpointer instance)
{
	PhotoFileAdapter * self;
	self = instance;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 33 "../src/photos/PhotoFileAdapter.vala"
	return instance;
#line 546 "PhotoFileAdapter.c"
}

void
photo_file_adapter_unref (gpointer instance)
{
	PhotoFileAdapter * self;
	self = instance;
#line 33 "../src/photos/PhotoFileAdapter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 33 "../src/photos/PhotoFileAdapter.vala"
		PHOTO_FILE_ADAPTER_GET_CLASS (self)->finalize (self);
#line 33 "../src/photos/PhotoFileAdapter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 560 "PhotoFileAdapter.c"
	}
}

PhotoFileReader*
photo_file_reader_construct (GType object_type,
                             const gchar* filepath,
                             PhotoFileFormat file_format)
{
	PhotoFileReader* self = NULL;
#line 73 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 74 "../src/photos/PhotoFileAdapter.vala"
	self = (PhotoFileReader*) photo_file_adapter_construct (object_type, filepath, file_format);
#line 73 "../src/photos/PhotoFileAdapter.vala"
	return self;
#line 576 "PhotoFileAdapter.c"
}

PhotoFileWriter*
photo_file_reader_create_writer (PhotoFileReader* self,
                                 GError** error)
{
	PhotoFileWriter* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	PhotoFileWriter* _tmp3_;
	PhotoFileWriter* _tmp4_;
	PhotoFileWriter* _tmp5_;
	GError* _inner_error0_ = NULL;
	PhotoFileWriter* result;
#line 77 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) self);
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = _tmp1_;
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = photo_file_format_create_writer (photo_file_adapter_get_file_format ((PhotoFileAdapter*) self), _tmp2_, &_inner_error0_);
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_tmp4_ = _tmp3_;
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (_tmp2_);
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = _tmp4_;
#line 78 "../src/photos/PhotoFileAdapter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../src/photos/PhotoFileAdapter.vala"
		if (_inner_error0_->domain == PHOTO_FORMAT_ERROR) {
#line 78 "../src/photos/PhotoFileAdapter.vala"
			g_propagate_error (error, _inner_error0_);
#line 78 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 613 "PhotoFileAdapter.c"
		} else {
#line 78 "../src/photos/PhotoFileAdapter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../src/photos/PhotoFileAdapter.vala"
			g_clear_error (&_inner_error0_);
#line 78 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 621 "PhotoFileAdapter.c"
		}
	}
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_tmp5_ = _tmp0_;
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = NULL;
#line 78 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp5_;
#line 78 "../src/photos/PhotoFileAdapter.vala"
	_photo_file_adapter_unref0 (_tmp0_);
#line 78 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 634 "PhotoFileAdapter.c"
}

PhotoFileMetadataWriter*
photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                          GError** error)
{
	PhotoFileMetadataWriter* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	GError* _inner_error0_ = NULL;
	PhotoFileMetadataWriter* result;
#line 81 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) self);
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = _tmp1_;
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format ((PhotoFileAdapter*) self), _tmp2_, &_inner_error0_);
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_tmp4_ = _tmp3_;
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (_tmp2_);
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = _tmp4_;
#line 82 "../src/photos/PhotoFileAdapter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../src/photos/PhotoFileAdapter.vala"
		if (_inner_error0_->domain == PHOTO_FORMAT_ERROR) {
#line 82 "../src/photos/PhotoFileAdapter.vala"
			g_propagate_error (error, _inner_error0_);
#line 82 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 671 "PhotoFileAdapter.c"
		} else {
#line 82 "../src/photos/PhotoFileAdapter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "../src/photos/PhotoFileAdapter.vala"
			g_clear_error (&_inner_error0_);
#line 82 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 679 "PhotoFileAdapter.c"
		}
	}
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_tmp5_ = _tmp0_;
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = NULL;
#line 82 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp5_;
#line 82 "../src/photos/PhotoFileAdapter.vala"
	_photo_file_adapter_unref0 (_tmp0_);
#line 82 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 692 "PhotoFileAdapter.c"
}

static PhotoMetadata*
photo_file_reader_real_read_metadata (PhotoFileReader* self,
                                      GError** error)
{
#line 85 "../src/photos/PhotoFileAdapter.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_file_reader_read_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 85 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 703 "PhotoFileAdapter.c"
}

PhotoMetadata*
photo_file_reader_read_metadata (PhotoFileReader* self,
                                 GError** error)
{
	PhotoFileReaderClass* _klass_;
#line 85 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_READER_GET_CLASS (self);
#line 85 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->read_metadata) {
#line 85 "../src/photos/PhotoFileAdapter.vala"
		return _klass_->read_metadata (self, error);
#line 719 "PhotoFileAdapter.c"
	}
#line 85 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 723 "PhotoFileAdapter.c"
}

static GdkPixbuf*
photo_file_reader_real_unscaled_read (PhotoFileReader* self,
                                      GError** error)
{
#line 87 "../src/photos/PhotoFileAdapter.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_file_reader_unscaled_read'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 87 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 734 "PhotoFileAdapter.c"
}

GdkPixbuf*
photo_file_reader_unscaled_read (PhotoFileReader* self,
                                 GError** error)
{
	PhotoFileReaderClass* _klass_;
#line 87 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_READER_GET_CLASS (self);
#line 87 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->unscaled_read) {
#line 87 "../src/photos/PhotoFileAdapter.vala"
		return _klass_->unscaled_read (self, error);
#line 750 "PhotoFileAdapter.c"
	}
#line 87 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 754 "PhotoFileAdapter.c"
}

static GdkPixbuf*
photo_file_reader_real_scaled_read (PhotoFileReader* self,
                                    Dimensions* full,
                                    Dimensions* scaled,
                                    GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	Dimensions _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 89 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (full != NULL, NULL);
#line 89 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (scaled != NULL, NULL);
#line 90 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = photo_file_reader_unscaled_read (self, &_inner_error0_);
#line 90 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = _tmp1_;
#line 90 "../src/photos/PhotoFileAdapter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../src/photos/PhotoFileAdapter.vala"
		g_propagate_error (error, _inner_error0_);
#line 90 "../src/photos/PhotoFileAdapter.vala"
		return NULL;
#line 783 "PhotoFileAdapter.c"
	}
#line 90 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = *scaled;
#line 90 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = resize_pixbuf (_tmp0_, &_tmp2_, GDK_INTERP_BILINEAR);
#line 90 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp3_;
#line 90 "../src/photos/PhotoFileAdapter.vala"
	_g_object_unref0 (_tmp0_);
#line 90 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 795 "PhotoFileAdapter.c"
}

GdkPixbuf*
photo_file_reader_scaled_read (PhotoFileReader* self,
                               Dimensions* full,
                               Dimensions* scaled,
                               GError** error)
{
	PhotoFileReaderClass* _klass_;
#line 89 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_READER_GET_CLASS (self);
#line 89 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->scaled_read) {
#line 89 "../src/photos/PhotoFileAdapter.vala"
		return _klass_->scaled_read (self, full, scaled, error);
#line 813 "PhotoFileAdapter.c"
	}
#line 89 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 817 "PhotoFileAdapter.c"
}

static void
photo_file_reader_class_init (PhotoFileReaderClass * klass,
                              gpointer klass_data)
{
#line 72 "../src/photos/PhotoFileAdapter.vala"
	photo_file_reader_parent_class = g_type_class_peek_parent (klass);
#line 72 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileReaderClass *) klass)->read_metadata = (PhotoMetadata* (*) (PhotoFileReader*, GError**)) photo_file_reader_real_read_metadata;
#line 72 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileReaderClass *) klass)->unscaled_read = (GdkPixbuf* (*) (PhotoFileReader*, GError**)) photo_file_reader_real_unscaled_read;
#line 72 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileReaderClass *) klass)->scaled_read = (GdkPixbuf* (*) (PhotoFileReader*, Dimensions*, Dimensions*, GError**)) photo_file_reader_real_scaled_read;
#line 832 "PhotoFileAdapter.c"
}

static void
photo_file_reader_instance_init (PhotoFileReader * self,
                                 gpointer klass)
{
}

static GType
photo_file_reader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoFileReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileReader), 0, (GInstanceInitFunc) photo_file_reader_instance_init, NULL };
	GType photo_file_reader_type_id;
	photo_file_reader_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileReader", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return photo_file_reader_type_id;
}

GType
photo_file_reader_get_type (void)
{
	static volatile gsize photo_file_reader_type_id__once = 0;
	if (g_once_init_enter (&photo_file_reader_type_id__once)) {
		GType photo_file_reader_type_id;
		photo_file_reader_type_id = photo_file_reader_get_type_once ();
		g_once_init_leave (&photo_file_reader_type_id__once, photo_file_reader_type_id);
	}
	return photo_file_reader_type_id__once;
}

PhotoFileWriter*
photo_file_writer_construct (GType object_type,
                             const gchar* filepath,
                             PhotoFileFormat file_format)
{
	PhotoFileWriter* self = NULL;
#line 99 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 100 "../src/photos/PhotoFileAdapter.vala"
	self = (PhotoFileWriter*) photo_file_adapter_construct (object_type, filepath, file_format);
#line 99 "../src/photos/PhotoFileAdapter.vala"
	return self;
#line 874 "PhotoFileAdapter.c"
}

PhotoFileReader*
photo_file_writer_create_reader (PhotoFileWriter* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	PhotoFileReader* result;
#line 103 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) self);
#line 104 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = _tmp0_;
#line 104 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = photo_file_format_create_reader (photo_file_adapter_get_file_format ((PhotoFileAdapter*) self), _tmp1_);
#line 104 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = _tmp2_;
#line 104 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (_tmp1_);
#line 104 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp3_;
#line 104 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 901 "PhotoFileAdapter.c"
}

static void
photo_file_writer_real_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error)
{
#line 107 "../src/photos/PhotoFileAdapter.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_file_writer_write'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 107 "../src/photos/PhotoFileAdapter.vala"
	return;
#line 914 "PhotoFileAdapter.c"
}

void
photo_file_writer_write (PhotoFileWriter* self,
                         GdkPixbuf* pixbuf,
                         JpegQuality quality,
                         GError** error)
{
	PhotoFileWriterClass* _klass_;
#line 107 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_WRITER_GET_CLASS (self);
#line 107 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->write) {
#line 107 "../src/photos/PhotoFileAdapter.vala"
		_klass_->write (self, pixbuf, quality, error);
#line 932 "PhotoFileAdapter.c"
	}
}

static void
photo_file_writer_class_init (PhotoFileWriterClass * klass,
                              gpointer klass_data)
{
#line 98 "../src/photos/PhotoFileAdapter.vala"
	photo_file_writer_parent_class = g_type_class_peek_parent (klass);
#line 98 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileWriterClass *) klass)->write = (void (*) (PhotoFileWriter*, GdkPixbuf*, JpegQuality, GError**)) photo_file_writer_real_write;
#line 944 "PhotoFileAdapter.c"
}

static void
photo_file_writer_instance_init (PhotoFileWriter * self,
                                 gpointer klass)
{
}

static GType
photo_file_writer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoFileWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileWriter), 0, (GInstanceInitFunc) photo_file_writer_instance_init, NULL };
	GType photo_file_writer_type_id;
	photo_file_writer_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileWriter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return photo_file_writer_type_id;
}

GType
photo_file_writer_get_type (void)
{
	static volatile gsize photo_file_writer_type_id__once = 0;
	if (g_once_init_enter (&photo_file_writer_type_id__once)) {
		GType photo_file_writer_type_id;
		photo_file_writer_type_id = photo_file_writer_get_type_once ();
		g_once_init_leave (&photo_file_writer_type_id__once, photo_file_writer_type_id);
	}
	return photo_file_writer_type_id__once;
}

PhotoFileMetadataWriter*
photo_file_metadata_writer_construct (GType object_type,
                                      const gchar* filepath,
                                      PhotoFileFormat file_format)
{
	PhotoFileMetadataWriter* self = NULL;
#line 115 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 116 "../src/photos/PhotoFileAdapter.vala"
	self = (PhotoFileMetadataWriter*) photo_file_adapter_construct (object_type, filepath, file_format);
#line 115 "../src/photos/PhotoFileAdapter.vala"
	return self;
#line 986 "PhotoFileAdapter.c"
}

PhotoFileReader*
photo_file_metadata_writer_create_reader (PhotoFileMetadataWriter* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	PhotoFileReader* result;
#line 119 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) self);
#line 120 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = _tmp0_;
#line 120 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = photo_file_format_create_reader (photo_file_adapter_get_file_format ((PhotoFileAdapter*) self), _tmp1_);
#line 120 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = _tmp2_;
#line 120 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (_tmp1_);
#line 120 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp3_;
#line 120 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 1013 "PhotoFileAdapter.c"
}

static void
photo_file_metadata_writer_real_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error)
{
#line 123 "../src/photos/PhotoFileAdapter.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_file_metadata_writer_write_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 123 "../src/photos/PhotoFileAdapter.vala"
	return;
#line 1025 "PhotoFileAdapter.c"
}

void
photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                           PhotoMetadata* metadata,
                                           GError** error)
{
	PhotoFileMetadataWriterClass* _klass_;
#line 123 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_METADATA_WRITER_GET_CLASS (self);
#line 123 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->write_metadata) {
#line 123 "../src/photos/PhotoFileAdapter.vala"
		_klass_->write_metadata (self, metadata, error);
#line 1042 "PhotoFileAdapter.c"
	}
}

static void
photo_file_metadata_writer_class_init (PhotoFileMetadataWriterClass * klass,
                                       gpointer klass_data)
{
#line 114 "../src/photos/PhotoFileAdapter.vala"
	photo_file_metadata_writer_parent_class = g_type_class_peek_parent (klass);
#line 114 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileMetadataWriterClass *) klass)->write_metadata = (void (*) (PhotoFileMetadataWriter*, PhotoMetadata*, GError**)) photo_file_metadata_writer_real_write_metadata;
#line 1054 "PhotoFileAdapter.c"
}

static void
photo_file_metadata_writer_instance_init (PhotoFileMetadataWriter * self,
                                          gpointer klass)
{
}

static GType
photo_file_metadata_writer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoFileMetadataWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_metadata_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileMetadataWriter), 0, (GInstanceInitFunc) photo_file_metadata_writer_instance_init, NULL };
	GType photo_file_metadata_writer_type_id;
	photo_file_metadata_writer_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileMetadataWriter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return photo_file_metadata_writer_type_id;
}

GType
photo_file_metadata_writer_get_type (void)
{
	static volatile gsize photo_file_metadata_writer_type_id__once = 0;
	if (g_once_init_enter (&photo_file_metadata_writer_type_id__once)) {
		GType photo_file_metadata_writer_type_id;
		photo_file_metadata_writer_type_id = photo_file_metadata_writer_get_type_once ();
		g_once_init_leave (&photo_file_metadata_writer_type_id__once, photo_file_metadata_writer_type_id);
	}
	return photo_file_metadata_writer_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

