/* Properties.c generated by valac 0.56.18, the Vala compiler
 * generated from Properties.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2016 elementary LLC. (https://github.com/elementary/photos)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PROPERTIES_0_PROPERTY,
	PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* properties_properties[PROPERTIES_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
enum  {
	PROPERTIES_HEADER_0_PROPERTY,
	PROPERTIES_HEADER_NUM_PROPERTIES
};
static GParamSpec* properties_header_properties[PROPERTIES_HEADER_NUM_PROPERTIES];
enum  {
	PROPERTIES_LABEL_0_PROPERTY,
	PROPERTIES_LABEL_NUM_PROPERTIES
};
static GParamSpec* properties_label_properties[PROPERTIES_LABEL_NUM_PROPERTIES];

static gpointer properties_parent_class = NULL;
static gpointer properties_header_parent_class = NULL;
static gpointer properties_label_parent_class = NULL;

static void properties_real_get_single_properties (Properties* self,
                                            DataView* view);
static void properties_real_get_multiple_properties (Properties* self,
                                              GeeIterable* iter);
static void properties_real_get_properties (Properties* self,
                                     Page* current_page);
static void properties_real_clear_properties (Properties* self);
static void properties_real_update_properties (Properties* self,
                                        Page* page);
static void properties_real_internal_update_properties (Properties* self,
                                                 Page* page);
static void properties_real_save_changes_to_source (Properties* self);
static GType properties_header_get_type_once (void);
static GType properties_label_get_type_once (void);
static void properties_finalize (GObject * obj);
static GType properties_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

Properties*
properties_construct (GType object_type)
{
	Properties * self = NULL;
#line 24 "../src/sidebar/metadata/Properties.vala"
	self = (Properties*) g_object_new (object_type, NULL);
#line 25 "../src/sidebar/metadata/Properties.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 0);
#line 26 "../src/sidebar/metadata/Properties.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 6);
#line 24 "../src/sidebar/metadata/Properties.vala"
	return self;
#line 102 "Properties.c"
}

void
properties_add_line (Properties* self,
                     const gchar* label_text,
                     const gchar* info_text)
{
	gboolean _tmp0_ = FALSE;
	PropertiesHeader* label = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	PropertiesHeader* _tmp3_;
	PropertiesHeader* _tmp4_;
	const gchar* _tmp5_ = NULL;
	PropertiesLabel* info_label = NULL;
	PropertiesLabel* _tmp6_;
	PropertiesHeader* _tmp7_;
	PropertiesLabel* _tmp8_;
	guint _tmp9_;
#line 29 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (label_text != NULL);
#line 29 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (info_text != NULL);
#line 30 "../src/sidebar/metadata/Properties.vala"
	if (info_text == NULL) {
#line 30 "../src/sidebar/metadata/Properties.vala"
		_tmp0_ = TRUE;
#line 132 "Properties.c"
	} else {
#line 30 "../src/sidebar/metadata/Properties.vala"
		_tmp0_ = g_strcmp0 (info_text, "") == 0;
#line 136 "Properties.c"
	}
#line 30 "../src/sidebar/metadata/Properties.vala"
	if (_tmp0_) {
#line 31 "../src/sidebar/metadata/Properties.vala"
		return;
#line 142 "Properties.c"
	}
#line 34 "../src/sidebar/metadata/Properties.vala"
	_tmp1_ = g_markup_printf_escaped ("%s", label_text);
#line 34 "../src/sidebar/metadata/Properties.vala"
	_tmp2_ = _tmp1_;
#line 34 "../src/sidebar/metadata/Properties.vala"
	_tmp3_ = properties_header_new (_tmp2_);
#line 34 "../src/sidebar/metadata/Properties.vala"
	g_object_ref_sink (_tmp3_);
#line 34 "../src/sidebar/metadata/Properties.vala"
	_tmp4_ = _tmp3_;
#line 34 "../src/sidebar/metadata/Properties.vala"
	_g_free0 (_tmp2_);
#line 34 "../src/sidebar/metadata/Properties.vala"
	label = _tmp4_;
#line 35 "../src/sidebar/metadata/Properties.vala"
	if (is_string_empty (info_text)) {
#line 35 "../src/sidebar/metadata/Properties.vala"
		_tmp5_ = "";
#line 162 "Properties.c"
	} else {
#line 35 "../src/sidebar/metadata/Properties.vala"
		_tmp5_ = info_text;
#line 166 "Properties.c"
	}
#line 35 "../src/sidebar/metadata/Properties.vala"
	_tmp6_ = properties_label_new (_tmp5_);
#line 35 "../src/sidebar/metadata/Properties.vala"
	g_object_ref_sink (_tmp6_);
#line 35 "../src/sidebar/metadata/Properties.vala"
	info_label = _tmp6_;
#line 37 "../src/sidebar/metadata/Properties.vala"
	_tmp7_ = label;
#line 37 "../src/sidebar/metadata/Properties.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp7_, 0, (gint) self->line_count, 1, 1);
#line 38 "../src/sidebar/metadata/Properties.vala"
	_tmp8_ = info_label;
#line 38 "../src/sidebar/metadata/Properties.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp8_, 1, (gint) self->line_count, 1, 1);
#line 40 "../src/sidebar/metadata/Properties.vala"
	_tmp9_ = self->line_count;
#line 40 "../src/sidebar/metadata/Properties.vala"
	self->line_count = _tmp9_ + 1;
#line 29 "../src/sidebar/metadata/Properties.vala"
	_g_object_unref0 (info_label);
#line 29 "../src/sidebar/metadata/Properties.vala"
	_g_object_unref0 (label);
#line 190 "Properties.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 207 "Properties.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 230 "Properties.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 239 "Properties.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 258 "Properties.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 262 "Properties.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 268 "Properties.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 278 "Properties.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 286 "Properties.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 290 "Properties.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 296 "Properties.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 306 "Properties.c"
}

gchar*
properties_get_prettyprint_time (Properties* self,
                                 GDateTime* time)
{
	gchar* timestring = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* result;
#line 43 "../src/sidebar/metadata/Properties.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/sidebar/metadata/Properties.vala"
	g_return_val_if_fail (time != NULL, NULL);
#line 44 "../src/sidebar/metadata/Properties.vala"
	_tmp0_ = resources_get_hh_mm_format_string ();
#line 44 "../src/sidebar/metadata/Properties.vala"
	_tmp1_ = _tmp0_;
#line 44 "../src/sidebar/metadata/Properties.vala"
	_tmp2_ = g_date_time_format (time, _tmp1_);
#line 44 "../src/sidebar/metadata/Properties.vala"
	_tmp3_ = _tmp2_;
#line 44 "../src/sidebar/metadata/Properties.vala"
	_g_free0 (_tmp1_);
#line 44 "../src/sidebar/metadata/Properties.vala"
	timestring = _tmp3_;
#line 46 "../src/sidebar/metadata/Properties.vala"
	_tmp4_ = timestring;
#line 46 "../src/sidebar/metadata/Properties.vala"
	if (string_get (_tmp4_, (glong) 0) == '0') {
#line 340 "Properties.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 47 "../src/sidebar/metadata/Properties.vala"
		_tmp5_ = timestring;
#line 47 "../src/sidebar/metadata/Properties.vala"
		_tmp6_ = string_substring (_tmp5_, (glong) 1, (glong) -1);
#line 47 "../src/sidebar/metadata/Properties.vala"
		_g_free0 (timestring);
#line 47 "../src/sidebar/metadata/Properties.vala"
		timestring = _tmp6_;
#line 351 "Properties.c"
	}
#line 49 "../src/sidebar/metadata/Properties.vala"
	result = timestring;
#line 49 "../src/sidebar/metadata/Properties.vala"
	return result;
#line 357 "Properties.c"
}

gchar*
properties_get_prettyprint_time_with_seconds (Properties* self,
                                              GDateTime* time)
{
	gchar* timestring = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* result;
#line 52 "../src/sidebar/metadata/Properties.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/sidebar/metadata/Properties.vala"
	g_return_val_if_fail (time != NULL, NULL);
#line 53 "../src/sidebar/metadata/Properties.vala"
	_tmp0_ = resources_get_hh_mm_ss_format_string ();
#line 53 "../src/sidebar/metadata/Properties.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/sidebar/metadata/Properties.vala"
	_tmp2_ = g_date_time_format (time, _tmp1_);
#line 53 "../src/sidebar/metadata/Properties.vala"
	_tmp3_ = _tmp2_;
#line 53 "../src/sidebar/metadata/Properties.vala"
	_g_free0 (_tmp1_);
#line 53 "../src/sidebar/metadata/Properties.vala"
	timestring = _tmp3_;
#line 55 "../src/sidebar/metadata/Properties.vala"
	_tmp4_ = timestring;
#line 55 "../src/sidebar/metadata/Properties.vala"
	if (string_get (_tmp4_, (glong) 0) == '0') {
#line 391 "Properties.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 56 "../src/sidebar/metadata/Properties.vala"
		_tmp5_ = timestring;
#line 56 "../src/sidebar/metadata/Properties.vala"
		_tmp6_ = string_substring (_tmp5_, (glong) 1, (glong) -1);
#line 56 "../src/sidebar/metadata/Properties.vala"
		_g_free0 (timestring);
#line 56 "../src/sidebar/metadata/Properties.vala"
		timestring = _tmp6_;
#line 402 "Properties.c"
	}
#line 58 "../src/sidebar/metadata/Properties.vala"
	result = timestring;
#line 58 "../src/sidebar/metadata/Properties.vala"
	return result;
#line 408 "Properties.c"
}

gchar*
properties_get_prettyprint_date (Properties* self,
                                 GDateTime* date)
{
	gchar* date_string = NULL;
	GDateTime* today = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GDateTime* _tmp5_;
	gchar* result;
#line 61 "../src/sidebar/metadata/Properties.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/sidebar/metadata/Properties.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 62 "../src/sidebar/metadata/Properties.vala"
	date_string = NULL;
#line 63 "../src/sidebar/metadata/Properties.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 63 "../src/sidebar/metadata/Properties.vala"
	_tmp1_ = _tmp0_;
#line 63 "../src/sidebar/metadata/Properties.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 63 "../src/sidebar/metadata/Properties.vala"
	_tmp3_ = _tmp2_;
#line 63 "../src/sidebar/metadata/Properties.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 63 "../src/sidebar/metadata/Properties.vala"
	today = _tmp3_;
#line 64 "../src/sidebar/metadata/Properties.vala"
	_tmp5_ = today;
#line 64 "../src/sidebar/metadata/Properties.vala"
	if (g_date_time_get_day_of_year (date) == g_date_time_get_day_of_year (_tmp5_)) {
#line 446 "Properties.c"
		GDateTime* _tmp6_;
#line 64 "../src/sidebar/metadata/Properties.vala"
		_tmp6_ = today;
#line 64 "../src/sidebar/metadata/Properties.vala"
		_tmp4_ = g_date_time_get_year (date) == g_date_time_get_year (_tmp6_);
#line 452 "Properties.c"
	} else {
#line 64 "../src/sidebar/metadata/Properties.vala"
		_tmp4_ = FALSE;
#line 456 "Properties.c"
	}
#line 64 "../src/sidebar/metadata/Properties.vala"
	if (_tmp4_) {
#line 460 "Properties.c"
		gchar* _tmp7_;
#line 65 "../src/sidebar/metadata/Properties.vala"
		_tmp7_ = g_strdup (_ ("Today"));
#line 65 "../src/sidebar/metadata/Properties.vala"
		_g_free0 (date_string);
#line 65 "../src/sidebar/metadata/Properties.vala"
		date_string = _tmp7_;
#line 468 "Properties.c"
	} else {
		gboolean _tmp8_ = FALSE;
		GDateTime* _tmp9_;
#line 66 "../src/sidebar/metadata/Properties.vala"
		_tmp9_ = today;
#line 66 "../src/sidebar/metadata/Properties.vala"
		if (g_date_time_get_day_of_year (date) == (g_date_time_get_day_of_year (_tmp9_) - 1)) {
#line 476 "Properties.c"
			GDateTime* _tmp10_;
#line 66 "../src/sidebar/metadata/Properties.vala"
			_tmp10_ = today;
#line 66 "../src/sidebar/metadata/Properties.vala"
			_tmp8_ = g_date_time_get_year (date) == g_date_time_get_year (_tmp10_);
#line 482 "Properties.c"
		} else {
#line 66 "../src/sidebar/metadata/Properties.vala"
			_tmp8_ = FALSE;
#line 486 "Properties.c"
		}
#line 66 "../src/sidebar/metadata/Properties.vala"
		if (_tmp8_) {
#line 490 "Properties.c"
			gchar* _tmp11_;
#line 67 "../src/sidebar/metadata/Properties.vala"
			_tmp11_ = g_strdup (_ ("Yesterday"));
#line 67 "../src/sidebar/metadata/Properties.vala"
			_g_free0 (date_string);
#line 67 "../src/sidebar/metadata/Properties.vala"
			date_string = _tmp11_;
#line 498 "Properties.c"
		} else {
			gchar* _tmp12_;
#line 69 "../src/sidebar/metadata/Properties.vala"
			_tmp12_ = format_local_date (date);
#line 69 "../src/sidebar/metadata/Properties.vala"
			_g_free0 (date_string);
#line 69 "../src/sidebar/metadata/Properties.vala"
			date_string = _tmp12_;
#line 507 "Properties.c"
		}
	}
#line 72 "../src/sidebar/metadata/Properties.vala"
	result = date_string;
#line 72 "../src/sidebar/metadata/Properties.vala"
	_g_date_time_unref0 (today);
#line 72 "../src/sidebar/metadata/Properties.vala"
	return result;
#line 516 "Properties.c"
}

static void
properties_real_get_single_properties (Properties* self,
                                       DataView* view)
{
#line 75 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (view != NULL);
#line 525 "Properties.c"
}

void
properties_get_single_properties (Properties* self,
                                  DataView* view)
{
	PropertiesClass* _klass_;
#line 75 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/sidebar/metadata/Properties.vala"
	_klass_ = PROPERTIES_GET_CLASS (self);
#line 75 "../src/sidebar/metadata/Properties.vala"
	if (_klass_->get_single_properties) {
#line 75 "../src/sidebar/metadata/Properties.vala"
		_klass_->get_single_properties (self, view);
#line 541 "Properties.c"
	}
}

static void
properties_real_get_multiple_properties (Properties* self,
                                         GeeIterable* iter)
{
}

void
properties_get_multiple_properties (Properties* self,
                                    GeeIterable* iter)
{
	PropertiesClass* _klass_;
#line 78 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/sidebar/metadata/Properties.vala"
	_klass_ = PROPERTIES_GET_CLASS (self);
#line 78 "../src/sidebar/metadata/Properties.vala"
	if (_klass_->get_multiple_properties) {
#line 78 "../src/sidebar/metadata/Properties.vala"
		_klass_->get_multiple_properties (self, iter);
#line 564 "Properties.c"
	}
}

static void
properties_real_get_properties (Properties* self,
                                Page* current_page)
{
	ViewCollection* view = NULL;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gint count = 0;
	ViewCollection* _tmp2_;
	GeeIterable* iter = NULL;
	gboolean _tmp8_ = FALSE;
	GeeIterable* _tmp9_;
#line 81 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (current_page != NULL);
#line 82 "../src/sidebar/metadata/Properties.vala"
	_tmp0_ = page_get_view (current_page);
#line 82 "../src/sidebar/metadata/Properties.vala"
	view = _tmp0_;
#line 83 "../src/sidebar/metadata/Properties.vala"
	_tmp1_ = view;
#line 83 "../src/sidebar/metadata/Properties.vala"
	if (_tmp1_ == NULL) {
#line 84 "../src/sidebar/metadata/Properties.vala"
		_data_collection_unref0 (view);
#line 84 "../src/sidebar/metadata/Properties.vala"
		return;
#line 594 "Properties.c"
	}
#line 87 "../src/sidebar/metadata/Properties.vala"
	_tmp2_ = view;
#line 87 "../src/sidebar/metadata/Properties.vala"
	count = view_collection_get_selected_count (_tmp2_);
#line 88 "../src/sidebar/metadata/Properties.vala"
	iter = NULL;
#line 89 "../src/sidebar/metadata/Properties.vala"
	if (count != 0) {
#line 604 "Properties.c"
		ViewCollection* _tmp3_;
		GeeList* _tmp4_;
#line 90 "../src/sidebar/metadata/Properties.vala"
		_tmp3_ = view;
#line 90 "../src/sidebar/metadata/Properties.vala"
		_tmp4_ = view_collection_get_selected (_tmp3_);
#line 90 "../src/sidebar/metadata/Properties.vala"
		_g_object_unref0 (iter);
#line 90 "../src/sidebar/metadata/Properties.vala"
		iter = (GeeIterable*) _tmp4_;
#line 615 "Properties.c"
	} else {
		ViewCollection* _tmp5_;
		ViewCollection* _tmp6_;
		GeeCollection* _tmp7_;
#line 92 "../src/sidebar/metadata/Properties.vala"
		_tmp5_ = view;
#line 92 "../src/sidebar/metadata/Properties.vala"
		count = data_collection_get_count ((DataCollection*) _tmp5_);
#line 93 "../src/sidebar/metadata/Properties.vala"
		_tmp6_ = view;
#line 93 "../src/sidebar/metadata/Properties.vala"
		_tmp7_ = data_collection_get_all ((DataCollection*) _tmp6_);
#line 93 "../src/sidebar/metadata/Properties.vala"
		_g_object_unref0 (iter);
#line 93 "../src/sidebar/metadata/Properties.vala"
		iter = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable);
#line 632 "Properties.c"
	}
#line 96 "../src/sidebar/metadata/Properties.vala"
	_tmp9_ = iter;
#line 96 "../src/sidebar/metadata/Properties.vala"
	if (_tmp9_ == NULL) {
#line 96 "../src/sidebar/metadata/Properties.vala"
		_tmp8_ = TRUE;
#line 640 "Properties.c"
	} else {
#line 96 "../src/sidebar/metadata/Properties.vala"
		_tmp8_ = count == 0;
#line 644 "Properties.c"
	}
#line 96 "../src/sidebar/metadata/Properties.vala"
	if (_tmp8_) {
#line 97 "../src/sidebar/metadata/Properties.vala"
		_g_object_unref0 (iter);
#line 97 "../src/sidebar/metadata/Properties.vala"
		_data_collection_unref0 (view);
#line 97 "../src/sidebar/metadata/Properties.vala"
		return;
#line 654 "Properties.c"
	}
#line 99 "../src/sidebar/metadata/Properties.vala"
	if (count == 1) {
#line 658 "Properties.c"
		{
			GeeIterator* _item_it = NULL;
			GeeIterable* _tmp10_;
			GeeIterator* _tmp11_;
#line 100 "../src/sidebar/metadata/Properties.vala"
			_tmp10_ = iter;
#line 100 "../src/sidebar/metadata/Properties.vala"
			_tmp11_ = gee_iterable_iterator (_tmp10_);
#line 100 "../src/sidebar/metadata/Properties.vala"
			_item_it = _tmp11_;
#line 100 "../src/sidebar/metadata/Properties.vala"
			while (TRUE) {
#line 671 "Properties.c"
				GeeIterator* _tmp12_;
				DataView* item = NULL;
				GeeIterator* _tmp13_;
				gpointer _tmp14_;
				DataView* _tmp15_;
#line 100 "../src/sidebar/metadata/Properties.vala"
				_tmp12_ = _item_it;
#line 100 "../src/sidebar/metadata/Properties.vala"
				if (!gee_iterator_next (_tmp12_)) {
#line 100 "../src/sidebar/metadata/Properties.vala"
					break;
#line 683 "Properties.c"
				}
#line 100 "../src/sidebar/metadata/Properties.vala"
				_tmp13_ = _item_it;
#line 100 "../src/sidebar/metadata/Properties.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 100 "../src/sidebar/metadata/Properties.vala"
				item = (DataView*) _tmp14_;
#line 101 "../src/sidebar/metadata/Properties.vala"
				_tmp15_ = item;
#line 101 "../src/sidebar/metadata/Properties.vala"
				properties_get_single_properties (self, _tmp15_);
#line 102 "../src/sidebar/metadata/Properties.vala"
				_g_object_unref0 (item);
#line 102 "../src/sidebar/metadata/Properties.vala"
				break;
#line 699 "Properties.c"
			}
#line 100 "../src/sidebar/metadata/Properties.vala"
			_g_object_unref0 (_item_it);
#line 703 "Properties.c"
		}
	} else {
		GeeIterable* _tmp16_;
#line 105 "../src/sidebar/metadata/Properties.vala"
		_tmp16_ = iter;
#line 105 "../src/sidebar/metadata/Properties.vala"
		properties_get_multiple_properties (self, _tmp16_);
#line 711 "Properties.c"
	}
#line 81 "../src/sidebar/metadata/Properties.vala"
	_g_object_unref0 (iter);
#line 81 "../src/sidebar/metadata/Properties.vala"
	_data_collection_unref0 (view);
#line 717 "Properties.c"
}

void
properties_get_properties (Properties* self,
                           Page* current_page)
{
	PropertiesClass* _klass_;
#line 81 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/sidebar/metadata/Properties.vala"
	_klass_ = PROPERTIES_GET_CLASS (self);
#line 81 "../src/sidebar/metadata/Properties.vala"
	if (_klass_->get_properties) {
#line 81 "../src/sidebar/metadata/Properties.vala"
		_klass_->get_properties (self, current_page);
#line 733 "Properties.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 110 "../src/sidebar/metadata/Properties.vala"
	return self ? g_object_ref (self) : NULL;
#line 742 "Properties.c"
}

static void
properties_real_clear_properties (Properties* self)
{
	GList* _tmp0_;
#line 110 "../src/sidebar/metadata/Properties.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 751 "Properties.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 110 "../src/sidebar/metadata/Properties.vala"
		child_collection = _tmp0_;
#line 110 "../src/sidebar/metadata/Properties.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 759 "Properties.c"
			GtkWidget* _tmp1_;
			GtkWidget* child = NULL;
#line 110 "../src/sidebar/metadata/Properties.vala"
			_tmp1_ = _g_object_ref0 ((GtkWidget*) child_it->data);
#line 110 "../src/sidebar/metadata/Properties.vala"
			child = _tmp1_;
#line 766 "Properties.c"
			{
				GtkWidget* _tmp2_;
#line 111 "../src/sidebar/metadata/Properties.vala"
				_tmp2_ = child;
#line 111 "../src/sidebar/metadata/Properties.vala"
				gtk_container_remove ((GtkContainer*) self, _tmp2_);
#line 110 "../src/sidebar/metadata/Properties.vala"
				_g_object_unref0 (child);
#line 775 "Properties.c"
			}
		}
#line 110 "../src/sidebar/metadata/Properties.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 780 "Properties.c"
	}
#line 113 "../src/sidebar/metadata/Properties.vala"
	self->line_count = (guint) 0;
#line 784 "Properties.c"
}

void
properties_clear_properties (Properties* self)
{
	PropertiesClass* _klass_;
#line 109 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/sidebar/metadata/Properties.vala"
	_klass_ = PROPERTIES_GET_CLASS (self);
#line 109 "../src/sidebar/metadata/Properties.vala"
	if (_klass_->clear_properties) {
#line 109 "../src/sidebar/metadata/Properties.vala"
		_klass_->clear_properties (self);
#line 799 "Properties.c"
	}
}

static void
properties_real_update_properties (Properties* self,
                                   Page* page)
{
#line 116 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (page != NULL);
#line 117 "../src/sidebar/metadata/Properties.vala"
	properties_clear_properties (self);
#line 118 "../src/sidebar/metadata/Properties.vala"
	properties_internal_update_properties (self, page);
#line 119 "../src/sidebar/metadata/Properties.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 815 "Properties.c"
}

void
properties_update_properties (Properties* self,
                              Page* page)
{
	PropertiesClass* _klass_;
#line 116 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/sidebar/metadata/Properties.vala"
	_klass_ = PROPERTIES_GET_CLASS (self);
#line 116 "../src/sidebar/metadata/Properties.vala"
	if (_klass_->update_properties) {
#line 116 "../src/sidebar/metadata/Properties.vala"
		_klass_->update_properties (self, page);
#line 831 "Properties.c"
	}
}

static void
properties_real_internal_update_properties (Properties* self,
                                            Page* page)
{
#line 122 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (page != NULL);
#line 123 "../src/sidebar/metadata/Properties.vala"
	properties_get_properties (self, page);
#line 843 "Properties.c"
}

void
properties_internal_update_properties (Properties* self,
                                       Page* page)
{
	PropertiesClass* _klass_;
#line 122 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/sidebar/metadata/Properties.vala"
	_klass_ = PROPERTIES_GET_CLASS (self);
#line 122 "../src/sidebar/metadata/Properties.vala"
	if (_klass_->internal_update_properties) {
#line 122 "../src/sidebar/metadata/Properties.vala"
		_klass_->internal_update_properties (self, page);
#line 859 "Properties.c"
	}
}

void
properties_unselect_text (Properties* self)
{
	GList* _tmp0_;
#line 126 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/sidebar/metadata/Properties.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 871 "Properties.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 127 "../src/sidebar/metadata/Properties.vala"
		child_collection = _tmp0_;
#line 127 "../src/sidebar/metadata/Properties.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 879 "Properties.c"
			GtkWidget* _tmp1_;
			GtkWidget* child = NULL;
#line 127 "../src/sidebar/metadata/Properties.vala"
			_tmp1_ = _g_object_ref0 ((GtkWidget*) child_it->data);
#line 127 "../src/sidebar/metadata/Properties.vala"
			child = _tmp1_;
#line 886 "Properties.c"
			{
				GtkWidget* _tmp2_;
#line 128 "../src/sidebar/metadata/Properties.vala"
				_tmp2_ = child;
#line 128 "../src/sidebar/metadata/Properties.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_label_get_type ())) {
#line 893 "Properties.c"
					GtkWidget* _tmp3_;
#line 129 "../src/sidebar/metadata/Properties.vala"
					_tmp3_ = child;
#line 129 "../src/sidebar/metadata/Properties.vala"
					gtk_label_select_region (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_label_get_type (), GtkLabel), 0, 0);
#line 899 "Properties.c"
				}
#line 127 "../src/sidebar/metadata/Properties.vala"
				_g_object_unref0 (child);
#line 903 "Properties.c"
			}
		}
#line 127 "../src/sidebar/metadata/Properties.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 908 "Properties.c"
	}
}

static void
properties_real_save_changes_to_source (Properties* self)
{
}

void
properties_save_changes_to_source (Properties* self)
{
	PropertiesClass* _klass_;
#line 133 "../src/sidebar/metadata/Properties.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/sidebar/metadata/Properties.vala"
	_klass_ = PROPERTIES_GET_CLASS (self);
#line 133 "../src/sidebar/metadata/Properties.vala"
	if (_klass_->save_changes_to_source) {
#line 133 "../src/sidebar/metadata/Properties.vala"
		_klass_->save_changes_to_source (self);
#line 929 "Properties.c"
	}
}

PropertiesHeader*
properties_header_construct (GType object_type,
                             const gchar* text)
{
	PropertiesHeader * self = NULL;
#line 137 "../src/sidebar/metadata/Properties.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 137 "../src/sidebar/metadata/Properties.vala"
	self = (PropertiesHeader*) g_object_new (object_type, NULL);
#line 138 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_label ((GtkLabel*) self, text);
#line 139 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_lines ((GtkLabel*) self, 8);
#line 140 "../src/sidebar/metadata/Properties.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
#line 141 "../src/sidebar/metadata/Properties.vala"
	g_object_set ((GtkLabel*) self, "wrap", TRUE, NULL);
#line 142 "../src/sidebar/metadata/Properties.vala"
	g_object_set ((GtkLabel*) self, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 143 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_xalign ((GtkLabel*) self, (gfloat) 1);
#line 137 "../src/sidebar/metadata/Properties.vala"
	return self;
#line 956 "Properties.c"
}

PropertiesHeader*
properties_header_new (const gchar* text)
{
#line 137 "../src/sidebar/metadata/Properties.vala"
	return properties_header_construct (PROPERTIES_TYPE_HEADER, text);
#line 964 "Properties.c"
}

static void
properties_header_class_init (PropertiesHeaderClass * klass,
                              gpointer klass_data)
{
#line 136 "../src/sidebar/metadata/Properties.vala"
	properties_header_parent_class = g_type_class_peek_parent (klass);
#line 973 "Properties.c"
}

static void
properties_header_instance_init (PropertiesHeader * self,
                                 gpointer klass)
{
}

static GType
properties_header_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PropertiesHeaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) properties_header_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PropertiesHeader), 0, (GInstanceInitFunc) properties_header_instance_init, NULL };
	GType properties_header_type_id;
	properties_header_type_id = g_type_register_static (gtk_label_get_type (), "PropertiesHeader", &g_define_type_info, 0);
	return properties_header_type_id;
}

GType
properties_header_get_type (void)
{
	static volatile gsize properties_header_type_id__once = 0;
	if (g_once_init_enter (&properties_header_type_id__once)) {
		GType properties_header_type_id;
		properties_header_type_id = properties_header_get_type_once ();
		g_once_init_leave (&properties_header_type_id__once, properties_header_type_id);
	}
	return properties_header_type_id__once;
}

PropertiesLabel*
properties_label_construct (GType object_type,
                            const gchar* text)
{
	PropertiesLabel * self = NULL;
#line 148 "../src/sidebar/metadata/Properties.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 148 "../src/sidebar/metadata/Properties.vala"
	self = (PropertiesLabel*) g_object_new (object_type, NULL);
#line 149 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_ellipsize ((GtkLabel*) self, PANGO_ELLIPSIZE_END);
#line 150 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_label ((GtkLabel*) self, text);
#line 151 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_lines ((GtkLabel*) self, 8);
#line 152 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_selectable ((GtkLabel*) self, TRUE);
#line 153 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_use_markup ((GtkLabel*) self, TRUE);
#line 154 "../src/sidebar/metadata/Properties.vala"
	g_object_set ((GtkLabel*) self, "wrap", TRUE, NULL);
#line 155 "../src/sidebar/metadata/Properties.vala"
	g_object_set ((GtkLabel*) self, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 156 "../src/sidebar/metadata/Properties.vala"
	gtk_label_set_xalign ((GtkLabel*) self, (gfloat) 0);
#line 148 "../src/sidebar/metadata/Properties.vala"
	return self;
#line 1030 "Properties.c"
}

PropertiesLabel*
properties_label_new (const gchar* text)
{
#line 148 "../src/sidebar/metadata/Properties.vala"
	return properties_label_construct (PROPERTIES_TYPE_LABEL, text);
#line 1038 "Properties.c"
}

static void
properties_label_class_init (PropertiesLabelClass * klass,
                             gpointer klass_data)
{
#line 147 "../src/sidebar/metadata/Properties.vala"
	properties_label_parent_class = g_type_class_peek_parent (klass);
#line 1047 "Properties.c"
}

static void
properties_label_instance_init (PropertiesLabel * self,
                                gpointer klass)
{
}

static GType
properties_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PropertiesLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) properties_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PropertiesLabel), 0, (GInstanceInitFunc) properties_label_instance_init, NULL };
	GType properties_label_type_id;
	properties_label_type_id = g_type_register_static (gtk_label_get_type (), "PropertiesLabel", &g_define_type_info, 0);
	return properties_label_type_id;
}

GType
properties_label_get_type (void)
{
	static volatile gsize properties_label_type_id__once = 0;
	if (g_once_init_enter (&properties_label_type_id__once)) {
		GType properties_label_type_id;
		properties_label_type_id = properties_label_get_type_once ();
		g_once_init_leave (&properties_label_type_id__once, properties_label_type_id);
	}
	return properties_label_type_id__once;
}

static void
properties_class_init (PropertiesClass * klass,
                       gpointer klass_data)
{
#line 21 "../src/sidebar/metadata/Properties.vala"
	properties_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/sidebar/metadata/Properties.vala"
	((PropertiesClass *) klass)->get_single_properties = (void (*) (Properties*, DataView*)) properties_real_get_single_properties;
#line 21 "../src/sidebar/metadata/Properties.vala"
	((PropertiesClass *) klass)->get_multiple_properties = (void (*) (Properties*, GeeIterable*)) properties_real_get_multiple_properties;
#line 21 "../src/sidebar/metadata/Properties.vala"
	((PropertiesClass *) klass)->get_properties = (void (*) (Properties*, Page*)) properties_real_get_properties;
#line 21 "../src/sidebar/metadata/Properties.vala"
	((PropertiesClass *) klass)->clear_properties = (void (*) (Properties*)) properties_real_clear_properties;
#line 21 "../src/sidebar/metadata/Properties.vala"
	((PropertiesClass *) klass)->update_properties = (void (*) (Properties*, Page*)) properties_real_update_properties;
#line 21 "../src/sidebar/metadata/Properties.vala"
	((PropertiesClass *) klass)->internal_update_properties = (void (*) (Properties*, Page*)) properties_real_internal_update_properties;
#line 21 "../src/sidebar/metadata/Properties.vala"
	((PropertiesClass *) klass)->save_changes_to_source = (void (*) (Properties*)) properties_real_save_changes_to_source;
#line 21 "../src/sidebar/metadata/Properties.vala"
	G_OBJECT_CLASS (klass)->finalize = properties_finalize;
#line 1099 "Properties.c"
}

static void
properties_instance_init (Properties * self,
                          gpointer klass)
{
#line 22 "../src/sidebar/metadata/Properties.vala"
	self->line_count = (guint) 0;
#line 1108 "Properties.c"
}

static void
properties_finalize (GObject * obj)
{
	Properties * self;
#line 21 "../src/sidebar/metadata/Properties.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROPERTIES, Properties);
#line 21 "../src/sidebar/metadata/Properties.vala"
	G_OBJECT_CLASS (properties_parent_class)->finalize (obj);
#line 1119 "Properties.c"
}

static GType
properties_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Properties), 0, (GInstanceInitFunc) properties_instance_init, NULL };
	GType properties_type_id;
	properties_type_id = g_type_register_static (gtk_grid_get_type (), "Properties", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return properties_type_id;
}

GType
properties_get_type (void)
{
	static volatile gsize properties_type_id__once = 0;
	if (g_once_init_enter (&properties_type_id__once)) {
		GType properties_type_id;
		properties_type_id = properties_get_type_once ();
		g_once_init_leave (&properties_type_id__once, properties_type_id);
	}
	return properties_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

