/* Semaphore.c generated by valac 0.56.18, the Vala compiler
 * generated from Semaphore.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Semaphores may be used to be notified when a job is completed.  This provides an alternate*/
/* mechanism (essentially, a blocking mechanism) to the system of callbacks that BackgroundJob*/
/* offers.  They can also be used for other job-dependent notification mechanisms.*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef struct _ParamSpecAbstractSemaphore ParamSpecAbstractSemaphore;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _AbstractSemaphorePrivate {
	AbstractSemaphoreType type;
	GMutex mutex;
	GCond monitor;
};

struct _ParamSpecAbstractSemaphore {
	GParamSpec parent_instance;
};

struct _SemaphorePrivate {
	gboolean passed;
};

struct _CountdownSemaphorePrivate {
	gint total;
	gint passed;
};

struct _EventSemaphorePrivate {
	gboolean fired;
};

static gint AbstractSemaphore_private_offset;
static gpointer abstract_semaphore_parent_class = NULL;
static gint Semaphore_private_offset;
static gpointer semaphore_parent_class = NULL;
static gint CountdownSemaphore_private_offset;
static gpointer countdown_semaphore_parent_class = NULL;
static gint EventSemaphore_private_offset;
static gpointer event_semaphore_parent_class = NULL;

static void abstract_semaphore_trigger (AbstractSemaphore* self);
static AbstractSemaphoreNotifyAction abstract_semaphore_real_do_notify (AbstractSemaphore* self);
static AbstractSemaphoreWaitAction abstract_semaphore_real_do_wait (AbstractSemaphore* self);
static gboolean abstract_semaphore_real_do_reset (AbstractSemaphore* self);
static void abstract_semaphore_finalize (AbstractSemaphore * obj);
static GType abstract_semaphore_get_type_once (void);
static AbstractSemaphoreNotifyAction semaphore_real_do_notify (AbstractSemaphore* base);
static AbstractSemaphoreWaitAction semaphore_real_do_wait (AbstractSemaphore* base);
static void semaphore_finalize (AbstractSemaphore * obj);
static GType semaphore_get_type_once (void);
static AbstractSemaphoreNotifyAction countdown_semaphore_real_do_notify (AbstractSemaphore* base);
static AbstractSemaphoreWaitAction countdown_semaphore_real_do_wait (AbstractSemaphore* base);
static void countdown_semaphore_finalize (AbstractSemaphore * obj);
static GType countdown_semaphore_get_type_once (void);
static AbstractSemaphoreNotifyAction event_semaphore_real_do_notify (AbstractSemaphore* base);
static AbstractSemaphoreWaitAction event_semaphore_real_do_wait (AbstractSemaphore* base);
static gboolean event_semaphore_real_do_reset (AbstractSemaphore* base);
static void event_semaphore_finalize (AbstractSemaphore * obj);
static GType event_semaphore_get_type_once (void);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
abstract_semaphore_get_instance_private (AbstractSemaphore* self)
{
	return G_STRUCT_MEMBER_P (self, AbstractSemaphore_private_offset);
}

static GType
abstract_semaphore_type_get_type_once (void)
{
	static const GEnumValue values[] = {{ABSTRACT_SEMAPHORE_TYPE_SERIAL, "ABSTRACT_SEMAPHORE_TYPE_SERIAL", "serial"}, {ABSTRACT_SEMAPHORE_TYPE_BROADCAST, "ABSTRACT_SEMAPHORE_TYPE_BROADCAST", "broadcast"}, {0, NULL, NULL}};
	GType abstract_semaphore_type_type_id;
	abstract_semaphore_type_type_id = g_enum_register_static ("AbstractSemaphoreType", values);
	return abstract_semaphore_type_type_id;
}

GType
abstract_semaphore_type_get_type (void)
{
	static volatile gsize abstract_semaphore_type_type_id__once = 0;
	if (g_once_init_enter (&abstract_semaphore_type_type_id__once)) {
		GType abstract_semaphore_type_type_id;
		abstract_semaphore_type_type_id = abstract_semaphore_type_get_type_once ();
		g_once_init_leave (&abstract_semaphore_type_type_id__once, abstract_semaphore_type_type_id);
	}
	return abstract_semaphore_type_type_id__once;
}

static GType
abstract_semaphore_notify_action_get_type_once (void)
{
	static const GEnumValue values[] = {{ABSTRACT_SEMAPHORE_NOTIFY_ACTION_NONE, "ABSTRACT_SEMAPHORE_NOTIFY_ACTION_NONE", "none"}, {ABSTRACT_SEMAPHORE_NOTIFY_ACTION_SIGNAL, "ABSTRACT_SEMAPHORE_NOTIFY_ACTION_SIGNAL", "signal"}, {0, NULL, NULL}};
	GType abstract_semaphore_notify_action_type_id;
	abstract_semaphore_notify_action_type_id = g_enum_register_static ("AbstractSemaphoreNotifyAction", values);
	return abstract_semaphore_notify_action_type_id;
}

GType
abstract_semaphore_notify_action_get_type (void)
{
	static volatile gsize abstract_semaphore_notify_action_type_id__once = 0;
	if (g_once_init_enter (&abstract_semaphore_notify_action_type_id__once)) {
		GType abstract_semaphore_notify_action_type_id;
		abstract_semaphore_notify_action_type_id = abstract_semaphore_notify_action_get_type_once ();
		g_once_init_leave (&abstract_semaphore_notify_action_type_id__once, abstract_semaphore_notify_action_type_id);
	}
	return abstract_semaphore_notify_action_type_id__once;
}

static GType
abstract_semaphore_wait_action_get_type_once (void)
{
	static const GEnumValue values[] = {{ABSTRACT_SEMAPHORE_WAIT_ACTION_SLEEP, "ABSTRACT_SEMAPHORE_WAIT_ACTION_SLEEP", "sleep"}, {ABSTRACT_SEMAPHORE_WAIT_ACTION_READY, "ABSTRACT_SEMAPHORE_WAIT_ACTION_READY", "ready"}, {0, NULL, NULL}};
	GType abstract_semaphore_wait_action_type_id;
	abstract_semaphore_wait_action_type_id = g_enum_register_static ("AbstractSemaphoreWaitAction", values);
	return abstract_semaphore_wait_action_type_id;
}

GType
abstract_semaphore_wait_action_get_type (void)
{
	static volatile gsize abstract_semaphore_wait_action_type_id__once = 0;
	if (g_once_init_enter (&abstract_semaphore_wait_action_type_id__once)) {
		GType abstract_semaphore_wait_action_type_id;
		abstract_semaphore_wait_action_type_id = abstract_semaphore_wait_action_get_type_once ();
		g_once_init_leave (&abstract_semaphore_wait_action_type_id__once, abstract_semaphore_wait_action_type_id);
	}
	return abstract_semaphore_wait_action_type_id__once;
}

AbstractSemaphore*
abstract_semaphore_construct (GType object_type,
                              AbstractSemaphoreType type)
{
	AbstractSemaphore* self = NULL;
	gboolean _tmp0_ = FALSE;
#line 43 "../src/threads/Semaphore.vala"
	self = (AbstractSemaphore*) g_type_create_instance (object_type);
#line 44 "../src/threads/Semaphore.vala"
	if (type == ABSTRACT_SEMAPHORE_TYPE_SERIAL) {
#line 44 "../src/threads/Semaphore.vala"
		_tmp0_ = TRUE;
#line 187 "Semaphore.c"
	} else {
#line 44 "../src/threads/Semaphore.vala"
		_tmp0_ = type == ABSTRACT_SEMAPHORE_TYPE_BROADCAST;
#line 191 "Semaphore.c"
	}
#line 44 "../src/threads/Semaphore.vala"
	_vala_assert (_tmp0_, "type == Type.SERIAL || type == Type.BROADCAST");
#line 46 "../src/threads/Semaphore.vala"
	self->priv->type = type;
#line 43 "../src/threads/Semaphore.vala"
	return self;
#line 199 "Semaphore.c"
}

static void
abstract_semaphore_trigger (AbstractSemaphore* self)
{
#line 49 "../src/threads/Semaphore.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/threads/Semaphore.vala"
	if (self->priv->type == ABSTRACT_SEMAPHORE_TYPE_SERIAL) {
#line 51 "../src/threads/Semaphore.vala"
		g_cond_signal (&self->priv->monitor);
#line 211 "Semaphore.c"
	} else {
#line 53 "../src/threads/Semaphore.vala"
		g_cond_broadcast (&self->priv->monitor);
#line 215 "Semaphore.c"
	}
}

void
abstract_semaphore_notify (AbstractSemaphore* self)
{
	AbstractSemaphoreNotifyAction action = 0;
#line 56 "../src/threads/Semaphore.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/threads/Semaphore.vala"
	g_mutex_lock (&self->priv->mutex);
#line 59 "../src/threads/Semaphore.vala"
	action = abstract_semaphore_do_notify (self);
#line 60 "../src/threads/Semaphore.vala"
	switch (action) {
#line 60 "../src/threads/Semaphore.vala"
		case ABSTRACT_SEMAPHORE_NOTIFY_ACTION_NONE:
#line 233 "Semaphore.c"
		{
#line 63 "../src/threads/Semaphore.vala"
			break;
#line 237 "Semaphore.c"
		}
#line 60 "../src/threads/Semaphore.vala"
		case ABSTRACT_SEMAPHORE_NOTIFY_ACTION_SIGNAL:
#line 241 "Semaphore.c"
		{
#line 66 "../src/threads/Semaphore.vala"
			abstract_semaphore_trigger (self);
#line 67 "../src/threads/Semaphore.vala"
			break;
#line 247 "Semaphore.c"
		}
		default:
		{
			GEnumValue* _tmp0_;
#line 70 "../src/threads/Semaphore.vala"
			_tmp0_ = g_enum_get_value (g_type_class_ref (ABSTRACT_SEMAPHORE_TYPE_NOTIFY_ACTION), action);
#line 70 "../src/threads/Semaphore.vala"
			g_error ("Semaphore.vala:70: Unknown semaphore action: %s", (_tmp0_ != NULL) ? _tmp0_->value_name : NULL);
#line 256 "Semaphore.c"
		}
	}
#line 73 "../src/threads/Semaphore.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 261 "Semaphore.c"
}

static AbstractSemaphoreNotifyAction
abstract_semaphore_real_do_notify (AbstractSemaphore* self)
{
#line 77 "../src/threads/Semaphore.vala"
	g_critical ("Type `%s' does not implement abstract method `abstract_semaphore_do_notify'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 77 "../src/threads/Semaphore.vala"
	return 0;
#line 271 "Semaphore.c"
}

AbstractSemaphoreNotifyAction
abstract_semaphore_do_notify (AbstractSemaphore* self)
{
	AbstractSemaphoreClass* _klass_;
#line 77 "../src/threads/Semaphore.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../src/threads/Semaphore.vala"
	_klass_ = ABSTRACT_SEMAPHORE_GET_CLASS (self);
#line 77 "../src/threads/Semaphore.vala"
	if (_klass_->do_notify) {
#line 77 "../src/threads/Semaphore.vala"
		return _klass_->do_notify (self);
#line 286 "Semaphore.c"
	}
#line 77 "../src/threads/Semaphore.vala"
	return 0;
#line 290 "Semaphore.c"
}

void
abstract_semaphore_wait (AbstractSemaphore* self)
{
#line 79 "../src/threads/Semaphore.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/threads/Semaphore.vala"
	g_mutex_lock (&self->priv->mutex);
#line 82 "../src/threads/Semaphore.vala"
	while (TRUE) {
#line 82 "../src/threads/Semaphore.vala"
		if (!(abstract_semaphore_do_wait (self) == ABSTRACT_SEMAPHORE_WAIT_ACTION_SLEEP)) {
#line 82 "../src/threads/Semaphore.vala"
			break;
#line 306 "Semaphore.c"
		}
#line 83 "../src/threads/Semaphore.vala"
		g_cond_wait (&self->priv->monitor, &self->priv->mutex);
#line 310 "Semaphore.c"
	}
#line 85 "../src/threads/Semaphore.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 314 "Semaphore.c"
}

static AbstractSemaphoreWaitAction
abstract_semaphore_real_do_wait (AbstractSemaphore* self)
{
#line 89 "../src/threads/Semaphore.vala"
	g_critical ("Type `%s' does not implement abstract method `abstract_semaphore_do_wait'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 89 "../src/threads/Semaphore.vala"
	return 0;
#line 324 "Semaphore.c"
}

AbstractSemaphoreWaitAction
abstract_semaphore_do_wait (AbstractSemaphore* self)
{
	AbstractSemaphoreClass* _klass_;
#line 89 "../src/threads/Semaphore.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 89 "../src/threads/Semaphore.vala"
	_klass_ = ABSTRACT_SEMAPHORE_GET_CLASS (self);
#line 89 "../src/threads/Semaphore.vala"
	if (_klass_->do_wait) {
#line 89 "../src/threads/Semaphore.vala"
		return _klass_->do_wait (self);
#line 339 "Semaphore.c"
	}
#line 89 "../src/threads/Semaphore.vala"
	return 0;
#line 343 "Semaphore.c"
}

gboolean
abstract_semaphore_reset (AbstractSemaphore* self)
{
	gboolean is_reset = FALSE;
	gboolean result;
#line 92 "../src/threads/Semaphore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/threads/Semaphore.vala"
	g_mutex_lock (&self->priv->mutex);
#line 94 "../src/threads/Semaphore.vala"
	is_reset = abstract_semaphore_do_reset (self);
#line 95 "../src/threads/Semaphore.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 97 "../src/threads/Semaphore.vala"
	result = is_reset;
#line 97 "../src/threads/Semaphore.vala"
	return result;
#line 363 "Semaphore.c"
}

static gboolean
abstract_semaphore_real_do_reset (AbstractSemaphore* self)
{
	gboolean result;
#line 103 "../src/threads/Semaphore.vala"
	result = FALSE;
#line 103 "../src/threads/Semaphore.vala"
	return result;
#line 374 "Semaphore.c"
}

gboolean
abstract_semaphore_do_reset (AbstractSemaphore* self)
{
	AbstractSemaphoreClass* _klass_;
#line 102 "../src/threads/Semaphore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 102 "../src/threads/Semaphore.vala"
	_klass_ = ABSTRACT_SEMAPHORE_GET_CLASS (self);
#line 102 "../src/threads/Semaphore.vala"
	if (_klass_->do_reset) {
#line 102 "../src/threads/Semaphore.vala"
		return _klass_->do_reset (self);
#line 389 "Semaphore.c"
	}
#line 102 "../src/threads/Semaphore.vala"
	return FALSE;
#line 393 "Semaphore.c"
}

static void
value_abstract_semaphore_init (GValue* value)
{
#line 23 "../src/threads/Semaphore.vala"
	value->data[0].v_pointer = NULL;
#line 401 "Semaphore.c"
}

static void
value_abstract_semaphore_free_value (GValue* value)
{
#line 23 "../src/threads/Semaphore.vala"
	if (value->data[0].v_pointer) {
#line 23 "../src/threads/Semaphore.vala"
		abstract_semaphore_unref (value->data[0].v_pointer);
#line 411 "Semaphore.c"
	}
}

static void
value_abstract_semaphore_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
#line 23 "../src/threads/Semaphore.vala"
	if (src_value->data[0].v_pointer) {
#line 23 "../src/threads/Semaphore.vala"
		dest_value->data[0].v_pointer = abstract_semaphore_ref (src_value->data[0].v_pointer);
#line 423 "Semaphore.c"
	} else {
#line 23 "../src/threads/Semaphore.vala"
		dest_value->data[0].v_pointer = NULL;
#line 427 "Semaphore.c"
	}
}

static gpointer
value_abstract_semaphore_peek_pointer (const GValue* value)
{
#line 23 "../src/threads/Semaphore.vala"
	return value->data[0].v_pointer;
#line 436 "Semaphore.c"
}

static gchar*
value_abstract_semaphore_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
#line 23 "../src/threads/Semaphore.vala"
	if (collect_values[0].v_pointer) {
#line 447 "Semaphore.c"
		AbstractSemaphore * object;
		object = collect_values[0].v_pointer;
#line 23 "../src/threads/Semaphore.vala"
		if (object->parent_instance.g_class == NULL) {
#line 23 "../src/threads/Semaphore.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 454 "Semaphore.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 23 "../src/threads/Semaphore.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 458 "Semaphore.c"
		}
#line 23 "../src/threads/Semaphore.vala"
		value->data[0].v_pointer = abstract_semaphore_ref (object);
#line 462 "Semaphore.c"
	} else {
#line 23 "../src/threads/Semaphore.vala"
		value->data[0].v_pointer = NULL;
#line 466 "Semaphore.c"
	}
#line 23 "../src/threads/Semaphore.vala"
	return NULL;
#line 470 "Semaphore.c"
}

static gchar*
value_abstract_semaphore_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	AbstractSemaphore ** object_p;
	object_p = collect_values[0].v_pointer;
#line 23 "../src/threads/Semaphore.vala"
	if (!object_p) {
#line 23 "../src/threads/Semaphore.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 485 "Semaphore.c"
	}
#line 23 "../src/threads/Semaphore.vala"
	if (!value->data[0].v_pointer) {
#line 23 "../src/threads/Semaphore.vala"
		*object_p = NULL;
#line 491 "Semaphore.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 23 "../src/threads/Semaphore.vala"
		*object_p = value->data[0].v_pointer;
#line 495 "Semaphore.c"
	} else {
#line 23 "../src/threads/Semaphore.vala"
		*object_p = abstract_semaphore_ref (value->data[0].v_pointer);
#line 499 "Semaphore.c"
	}
#line 23 "../src/threads/Semaphore.vala"
	return NULL;
#line 503 "Semaphore.c"
}

GParamSpec*
param_spec_abstract_semaphore (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	ParamSpecAbstractSemaphore* spec;
#line 23 "../src/threads/Semaphore.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ABSTRACT_SEMAPHORE), NULL);
#line 23 "../src/threads/Semaphore.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 23 "../src/threads/Semaphore.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 23 "../src/threads/Semaphore.vala"
	return G_PARAM_SPEC (spec);
#line 522 "Semaphore.c"
}

gpointer
value_get_abstract_semaphore (const GValue* value)
{
#line 23 "../src/threads/Semaphore.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ABSTRACT_SEMAPHORE), NULL);
#line 23 "../src/threads/Semaphore.vala"
	return value->data[0].v_pointer;
#line 532 "Semaphore.c"
}

void
value_set_abstract_semaphore (GValue* value,
                              gpointer v_object)
{
	AbstractSemaphore * old;
#line 23 "../src/threads/Semaphore.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ABSTRACT_SEMAPHORE));
#line 23 "../src/threads/Semaphore.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/threads/Semaphore.vala"
	if (v_object) {
#line 23 "../src/threads/Semaphore.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ABSTRACT_SEMAPHORE));
#line 23 "../src/threads/Semaphore.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/threads/Semaphore.vala"
		value->data[0].v_pointer = v_object;
#line 23 "../src/threads/Semaphore.vala"
		abstract_semaphore_ref (value->data[0].v_pointer);
#line 554 "Semaphore.c"
	} else {
#line 23 "../src/threads/Semaphore.vala"
		value->data[0].v_pointer = NULL;
#line 558 "Semaphore.c"
	}
#line 23 "../src/threads/Semaphore.vala"
	if (old) {
#line 23 "../src/threads/Semaphore.vala"
		abstract_semaphore_unref (old);
#line 564 "Semaphore.c"
	}
}

void
value_take_abstract_semaphore (GValue* value,
                               gpointer v_object)
{
	AbstractSemaphore * old;
#line 23 "../src/threads/Semaphore.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ABSTRACT_SEMAPHORE));
#line 23 "../src/threads/Semaphore.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/threads/Semaphore.vala"
	if (v_object) {
#line 23 "../src/threads/Semaphore.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ABSTRACT_SEMAPHORE));
#line 23 "../src/threads/Semaphore.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/threads/Semaphore.vala"
		value->data[0].v_pointer = v_object;
#line 585 "Semaphore.c"
	} else {
#line 23 "../src/threads/Semaphore.vala"
		value->data[0].v_pointer = NULL;
#line 589 "Semaphore.c"
	}
#line 23 "../src/threads/Semaphore.vala"
	if (old) {
#line 23 "../src/threads/Semaphore.vala"
		abstract_semaphore_unref (old);
#line 595 "Semaphore.c"
	}
}

static void
abstract_semaphore_class_init (AbstractSemaphoreClass * klass,
                               gpointer klass_data)
{
#line 23 "../src/threads/Semaphore.vala"
	abstract_semaphore_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->finalize = abstract_semaphore_finalize;
#line 23 "../src/threads/Semaphore.vala"
	g_type_class_adjust_private_offset (klass, &AbstractSemaphore_private_offset);
#line 23 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_notify = (AbstractSemaphoreNotifyAction (*) (AbstractSemaphore*)) abstract_semaphore_real_do_notify;
#line 23 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_wait = (AbstractSemaphoreWaitAction (*) (AbstractSemaphore*)) abstract_semaphore_real_do_wait;
#line 23 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_reset = (gboolean (*) (AbstractSemaphore*)) abstract_semaphore_real_do_reset;
#line 615 "Semaphore.c"
}

static void
abstract_semaphore_instance_init (AbstractSemaphore * self,
                                  gpointer klass)
{
#line 23 "../src/threads/Semaphore.vala"
	self->priv = abstract_semaphore_get_instance_private (self);
#line 40 "../src/threads/Semaphore.vala"
	g_mutex_init (&self->priv->mutex);
#line 41 "../src/threads/Semaphore.vala"
	g_cond_init (&self->priv->monitor);
#line 23 "../src/threads/Semaphore.vala"
	self->ref_count = 1;
#line 630 "Semaphore.c"
}

static void
abstract_semaphore_finalize (AbstractSemaphore * obj)
{
	AbstractSemaphore * self;
#line 23 "../src/threads/Semaphore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore);
#line 23 "../src/threads/Semaphore.vala"
	g_signal_handlers_destroy (self);
#line 40 "../src/threads/Semaphore.vala"
	_vala_clear_GMutex (&self->priv->mutex);
#line 41 "../src/threads/Semaphore.vala"
	_vala_clear_GCond (&self->priv->monitor);
#line 645 "Semaphore.c"
}

static GType
abstract_semaphore_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_abstract_semaphore_init, value_abstract_semaphore_free_value, value_abstract_semaphore_copy_value, value_abstract_semaphore_peek_pointer, "p", value_abstract_semaphore_collect_value, "p", value_abstract_semaphore_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AbstractSemaphoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) abstract_semaphore_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AbstractSemaphore), 0, (GInstanceInitFunc) abstract_semaphore_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType abstract_semaphore_type_id;
	abstract_semaphore_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AbstractSemaphore", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	AbstractSemaphore_private_offset = g_type_add_instance_private (abstract_semaphore_type_id, sizeof (AbstractSemaphorePrivate));
	return abstract_semaphore_type_id;
}

GType
abstract_semaphore_get_type (void)
{
	static volatile gsize abstract_semaphore_type_id__once = 0;
	if (g_once_init_enter (&abstract_semaphore_type_id__once)) {
		GType abstract_semaphore_type_id;
		abstract_semaphore_type_id = abstract_semaphore_get_type_once ();
		g_once_init_leave (&abstract_semaphore_type_id__once, abstract_semaphore_type_id);
	}
	return abstract_semaphore_type_id__once;
}

gpointer
abstract_semaphore_ref (gpointer instance)
{
	AbstractSemaphore * self;
	self = instance;
#line 23 "../src/threads/Semaphore.vala"
	g_atomic_int_inc (&self->ref_count);
#line 23 "../src/threads/Semaphore.vala"
	return instance;
#line 681 "Semaphore.c"
}

void
abstract_semaphore_unref (gpointer instance)
{
	AbstractSemaphore * self;
	self = instance;
#line 23 "../src/threads/Semaphore.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 23 "../src/threads/Semaphore.vala"
		ABSTRACT_SEMAPHORE_GET_CLASS (self)->finalize (self);
#line 23 "../src/threads/Semaphore.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 695 "Semaphore.c"
	}
}

static inline gpointer
semaphore_get_instance_private (Semaphore* self)
{
	return G_STRUCT_MEMBER_P (self, Semaphore_private_offset);
}

Semaphore*
semaphore_construct (GType object_type)
{
	Semaphore* self = NULL;
#line 111 "../src/threads/Semaphore.vala"
	self = (Semaphore*) abstract_semaphore_construct (object_type, ABSTRACT_SEMAPHORE_TYPE_BROADCAST);
#line 110 "../src/threads/Semaphore.vala"
	return self;
#line 713 "Semaphore.c"
}

Semaphore*
semaphore_new (void)
{
#line 110 "../src/threads/Semaphore.vala"
	return semaphore_construct (TYPE_SEMAPHORE);
#line 721 "Semaphore.c"
}

static AbstractSemaphoreNotifyAction
semaphore_real_do_notify (AbstractSemaphore* base)
{
	Semaphore * self;
	AbstractSemaphoreNotifyAction result;
#line 114 "../src/threads/Semaphore.vala"
	self = (Semaphore*) base;
#line 115 "../src/threads/Semaphore.vala"
	if (self->priv->passed) {
#line 116 "../src/threads/Semaphore.vala"
		result = ABSTRACT_SEMAPHORE_NOTIFY_ACTION_NONE;
#line 116 "../src/threads/Semaphore.vala"
		return result;
#line 737 "Semaphore.c"
	}
#line 118 "../src/threads/Semaphore.vala"
	self->priv->passed = TRUE;
#line 120 "../src/threads/Semaphore.vala"
	result = ABSTRACT_SEMAPHORE_NOTIFY_ACTION_SIGNAL;
#line 120 "../src/threads/Semaphore.vala"
	return result;
#line 745 "Semaphore.c"
}

static AbstractSemaphoreWaitAction
semaphore_real_do_wait (AbstractSemaphore* base)
{
	Semaphore * self;
	AbstractSemaphoreWaitAction _tmp0_ = 0;
	AbstractSemaphoreWaitAction result;
#line 123 "../src/threads/Semaphore.vala"
	self = (Semaphore*) base;
#line 124 "../src/threads/Semaphore.vala"
	if (self->priv->passed) {
#line 124 "../src/threads/Semaphore.vala"
		_tmp0_ = ABSTRACT_SEMAPHORE_WAIT_ACTION_READY;
#line 760 "Semaphore.c"
	} else {
#line 124 "../src/threads/Semaphore.vala"
		_tmp0_ = ABSTRACT_SEMAPHORE_WAIT_ACTION_SLEEP;
#line 764 "Semaphore.c"
	}
#line 124 "../src/threads/Semaphore.vala"
	result = _tmp0_;
#line 124 "../src/threads/Semaphore.vala"
	return result;
#line 770 "Semaphore.c"
}

static void
semaphore_class_init (SemaphoreClass * klass,
                      gpointer klass_data)
{
#line 107 "../src/threads/Semaphore.vala"
	semaphore_parent_class = g_type_class_peek_parent (klass);
#line 107 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->finalize = semaphore_finalize;
#line 107 "../src/threads/Semaphore.vala"
	g_type_class_adjust_private_offset (klass, &Semaphore_private_offset);
#line 107 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_notify = (AbstractSemaphoreNotifyAction (*) (AbstractSemaphore*)) semaphore_real_do_notify;
#line 107 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_wait = (AbstractSemaphoreWaitAction (*) (AbstractSemaphore*)) semaphore_real_do_wait;
#line 787 "Semaphore.c"
}

static void
semaphore_instance_init (Semaphore * self,
                         gpointer klass)
{
#line 107 "../src/threads/Semaphore.vala"
	self->priv = semaphore_get_instance_private (self);
#line 108 "../src/threads/Semaphore.vala"
	self->priv->passed = FALSE;
#line 798 "Semaphore.c"
}

static void
semaphore_finalize (AbstractSemaphore * obj)
{
	Semaphore * self;
#line 107 "../src/threads/Semaphore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEMAPHORE, Semaphore);
#line 107 "../src/threads/Semaphore.vala"
	ABSTRACT_SEMAPHORE_CLASS (semaphore_parent_class)->finalize (obj);
#line 809 "Semaphore.c"
}

static GType
semaphore_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SemaphoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) semaphore_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Semaphore), 0, (GInstanceInitFunc) semaphore_instance_init, NULL };
	GType semaphore_type_id;
	semaphore_type_id = g_type_register_static (TYPE_ABSTRACT_SEMAPHORE, "Semaphore", &g_define_type_info, 0);
	Semaphore_private_offset = g_type_add_instance_private (semaphore_type_id, sizeof (SemaphorePrivate));
	return semaphore_type_id;
}

GType
semaphore_get_type (void)
{
	static volatile gsize semaphore_type_id__once = 0;
	if (g_once_init_enter (&semaphore_type_id__once)) {
		GType semaphore_type_id;
		semaphore_type_id = semaphore_get_type_once ();
		g_once_init_leave (&semaphore_type_id__once, semaphore_type_id);
	}
	return semaphore_type_id__once;
}

static inline gpointer
countdown_semaphore_get_instance_private (CountdownSemaphore* self)
{
	return G_STRUCT_MEMBER_P (self, CountdownSemaphore_private_offset);
}

CountdownSemaphore*
countdown_semaphore_construct (GType object_type,
                               gint total)
{
	CountdownSemaphore* self = NULL;
#line 133 "../src/threads/Semaphore.vala"
	self = (CountdownSemaphore*) abstract_semaphore_construct (object_type, ABSTRACT_SEMAPHORE_TYPE_BROADCAST);
#line 135 "../src/threads/Semaphore.vala"
	self->priv->total = total;
#line 132 "../src/threads/Semaphore.vala"
	return self;
#line 851 "Semaphore.c"
}

CountdownSemaphore*
countdown_semaphore_new (gint total)
{
#line 132 "../src/threads/Semaphore.vala"
	return countdown_semaphore_construct (TYPE_COUNTDOWN_SEMAPHORE, total);
#line 859 "Semaphore.c"
}

static AbstractSemaphoreNotifyAction
countdown_semaphore_real_do_notify (AbstractSemaphore* base)
{
	CountdownSemaphore * self;
	AbstractSemaphoreNotifyAction _tmp0_ = 0;
	gint _tmp1_;
	gint _tmp2_;
	AbstractSemaphoreNotifyAction result;
#line 138 "../src/threads/Semaphore.vala"
	self = (CountdownSemaphore*) base;
#line 139 "../src/threads/Semaphore.vala"
	if (self->priv->passed >= self->priv->total) {
#line 140 "../src/threads/Semaphore.vala"
		g_critical ("Semaphore.vala:140: CountdownSemaphore overrun: %d/%d", self->priv->passed + 1, self->priv->total);
#line 876 "Semaphore.c"
	}
#line 142 "../src/threads/Semaphore.vala"
	self->priv->passed = self->priv->passed + 1;
#line 142 "../src/threads/Semaphore.vala"
	_tmp1_ = self->priv->passed;
#line 142 "../src/threads/Semaphore.vala"
	_tmp2_ = self->priv->total;
#line 142 "../src/threads/Semaphore.vala"
	if (_tmp1_ >= _tmp2_) {
#line 142 "../src/threads/Semaphore.vala"
		_tmp0_ = ABSTRACT_SEMAPHORE_NOTIFY_ACTION_SIGNAL;
#line 888 "Semaphore.c"
	} else {
#line 142 "../src/threads/Semaphore.vala"
		_tmp0_ = ABSTRACT_SEMAPHORE_NOTIFY_ACTION_NONE;
#line 892 "Semaphore.c"
	}
#line 142 "../src/threads/Semaphore.vala"
	result = _tmp0_;
#line 142 "../src/threads/Semaphore.vala"
	return result;
#line 898 "Semaphore.c"
}

static AbstractSemaphoreWaitAction
countdown_semaphore_real_do_wait (AbstractSemaphore* base)
{
	CountdownSemaphore * self;
	AbstractSemaphoreWaitAction _tmp0_ = 0;
	AbstractSemaphoreWaitAction result;
#line 145 "../src/threads/Semaphore.vala"
	self = (CountdownSemaphore*) base;
#line 146 "../src/threads/Semaphore.vala"
	if (self->priv->passed < self->priv->total) {
#line 146 "../src/threads/Semaphore.vala"
		_tmp0_ = ABSTRACT_SEMAPHORE_WAIT_ACTION_SLEEP;
#line 913 "Semaphore.c"
	} else {
#line 146 "../src/threads/Semaphore.vala"
		_tmp0_ = ABSTRACT_SEMAPHORE_WAIT_ACTION_READY;
#line 917 "Semaphore.c"
	}
#line 146 "../src/threads/Semaphore.vala"
	result = _tmp0_;
#line 146 "../src/threads/Semaphore.vala"
	return result;
#line 923 "Semaphore.c"
}

static void
countdown_semaphore_class_init (CountdownSemaphoreClass * klass,
                                gpointer klass_data)
{
#line 128 "../src/threads/Semaphore.vala"
	countdown_semaphore_parent_class = g_type_class_peek_parent (klass);
#line 128 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->finalize = countdown_semaphore_finalize;
#line 128 "../src/threads/Semaphore.vala"
	g_type_class_adjust_private_offset (klass, &CountdownSemaphore_private_offset);
#line 128 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_notify = (AbstractSemaphoreNotifyAction (*) (AbstractSemaphore*)) countdown_semaphore_real_do_notify;
#line 128 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_wait = (AbstractSemaphoreWaitAction (*) (AbstractSemaphore*)) countdown_semaphore_real_do_wait;
#line 940 "Semaphore.c"
}

static void
countdown_semaphore_instance_init (CountdownSemaphore * self,
                                   gpointer klass)
{
#line 128 "../src/threads/Semaphore.vala"
	self->priv = countdown_semaphore_get_instance_private (self);
#line 130 "../src/threads/Semaphore.vala"
	self->priv->passed = 0;
#line 951 "Semaphore.c"
}

static void
countdown_semaphore_finalize (AbstractSemaphore * obj)
{
	CountdownSemaphore * self;
#line 128 "../src/threads/Semaphore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COUNTDOWN_SEMAPHORE, CountdownSemaphore);
#line 128 "../src/threads/Semaphore.vala"
	ABSTRACT_SEMAPHORE_CLASS (countdown_semaphore_parent_class)->finalize (obj);
#line 962 "Semaphore.c"
}

static GType
countdown_semaphore_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CountdownSemaphoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) countdown_semaphore_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CountdownSemaphore), 0, (GInstanceInitFunc) countdown_semaphore_instance_init, NULL };
	GType countdown_semaphore_type_id;
	countdown_semaphore_type_id = g_type_register_static (TYPE_ABSTRACT_SEMAPHORE, "CountdownSemaphore", &g_define_type_info, 0);
	CountdownSemaphore_private_offset = g_type_add_instance_private (countdown_semaphore_type_id, sizeof (CountdownSemaphorePrivate));
	return countdown_semaphore_type_id;
}

GType
countdown_semaphore_get_type (void)
{
	static volatile gsize countdown_semaphore_type_id__once = 0;
	if (g_once_init_enter (&countdown_semaphore_type_id__once)) {
		GType countdown_semaphore_type_id;
		countdown_semaphore_type_id = countdown_semaphore_get_type_once ();
		g_once_init_leave (&countdown_semaphore_type_id__once, countdown_semaphore_type_id);
	}
	return countdown_semaphore_type_id__once;
}

static inline gpointer
event_semaphore_get_instance_private (EventSemaphore* self)
{
	return G_STRUCT_MEMBER_P (self, EventSemaphore_private_offset);
}

EventSemaphore*
event_semaphore_construct (GType object_type)
{
	EventSemaphore* self = NULL;
#line 154 "../src/threads/Semaphore.vala"
	self = (EventSemaphore*) abstract_semaphore_construct (object_type, ABSTRACT_SEMAPHORE_TYPE_BROADCAST);
#line 153 "../src/threads/Semaphore.vala"
	return self;
#line 1001 "Semaphore.c"
}

EventSemaphore*
event_semaphore_new (void)
{
#line 153 "../src/threads/Semaphore.vala"
	return event_semaphore_construct (TYPE_EVENT_SEMAPHORE);
#line 1009 "Semaphore.c"
}

static AbstractSemaphoreNotifyAction
event_semaphore_real_do_notify (AbstractSemaphore* base)
{
	EventSemaphore * self;
	AbstractSemaphoreNotifyAction result;
#line 157 "../src/threads/Semaphore.vala"
	self = (EventSemaphore*) base;
#line 158 "../src/threads/Semaphore.vala"
	self->priv->fired = TRUE;
#line 160 "../src/threads/Semaphore.vala"
	result = ABSTRACT_SEMAPHORE_NOTIFY_ACTION_SIGNAL;
#line 160 "../src/threads/Semaphore.vala"
	return result;
#line 1025 "Semaphore.c"
}

static AbstractSemaphoreWaitAction
event_semaphore_real_do_wait (AbstractSemaphore* base)
{
	EventSemaphore * self;
	AbstractSemaphoreWaitAction _tmp0_ = 0;
	AbstractSemaphoreWaitAction result;
#line 163 "../src/threads/Semaphore.vala"
	self = (EventSemaphore*) base;
#line 164 "../src/threads/Semaphore.vala"
	if (self->priv->fired) {
#line 164 "../src/threads/Semaphore.vala"
		_tmp0_ = ABSTRACT_SEMAPHORE_WAIT_ACTION_READY;
#line 1040 "Semaphore.c"
	} else {
#line 164 "../src/threads/Semaphore.vala"
		_tmp0_ = ABSTRACT_SEMAPHORE_WAIT_ACTION_SLEEP;
#line 1044 "Semaphore.c"
	}
#line 164 "../src/threads/Semaphore.vala"
	result = _tmp0_;
#line 164 "../src/threads/Semaphore.vala"
	return result;
#line 1050 "Semaphore.c"
}

static gboolean
event_semaphore_real_do_reset (AbstractSemaphore* base)
{
	EventSemaphore * self;
	gboolean result;
#line 167 "../src/threads/Semaphore.vala"
	self = (EventSemaphore*) base;
#line 168 "../src/threads/Semaphore.vala"
	self->priv->fired = FALSE;
#line 170 "../src/threads/Semaphore.vala"
	result = TRUE;
#line 170 "../src/threads/Semaphore.vala"
	return result;
#line 1066 "Semaphore.c"
}

static void
event_semaphore_class_init (EventSemaphoreClass * klass,
                            gpointer klass_data)
{
#line 150 "../src/threads/Semaphore.vala"
	event_semaphore_parent_class = g_type_class_peek_parent (klass);
#line 150 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->finalize = event_semaphore_finalize;
#line 150 "../src/threads/Semaphore.vala"
	g_type_class_adjust_private_offset (klass, &EventSemaphore_private_offset);
#line 150 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_notify = (AbstractSemaphoreNotifyAction (*) (AbstractSemaphore*)) event_semaphore_real_do_notify;
#line 150 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_wait = (AbstractSemaphoreWaitAction (*) (AbstractSemaphore*)) event_semaphore_real_do_wait;
#line 150 "../src/threads/Semaphore.vala"
	((AbstractSemaphoreClass *) klass)->do_reset = (gboolean (*) (AbstractSemaphore*)) event_semaphore_real_do_reset;
#line 1085 "Semaphore.c"
}

static void
event_semaphore_instance_init (EventSemaphore * self,
                               gpointer klass)
{
#line 150 "../src/threads/Semaphore.vala"
	self->priv = event_semaphore_get_instance_private (self);
#line 151 "../src/threads/Semaphore.vala"
	self->priv->fired = FALSE;
#line 1096 "Semaphore.c"
}

static void
event_semaphore_finalize (AbstractSemaphore * obj)
{
	EventSemaphore * self;
#line 150 "../src/threads/Semaphore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EVENT_SEMAPHORE, EventSemaphore);
#line 150 "../src/threads/Semaphore.vala"
	ABSTRACT_SEMAPHORE_CLASS (event_semaphore_parent_class)->finalize (obj);
#line 1107 "Semaphore.c"
}

static GType
event_semaphore_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EventSemaphoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_semaphore_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventSemaphore), 0, (GInstanceInitFunc) event_semaphore_instance_init, NULL };
	GType event_semaphore_type_id;
	event_semaphore_type_id = g_type_register_static (TYPE_ABSTRACT_SEMAPHORE, "EventSemaphore", &g_define_type_info, 0);
	EventSemaphore_private_offset = g_type_add_instance_private (event_semaphore_type_id, sizeof (EventSemaphorePrivate));
	return event_semaphore_type_id;
}

GType
event_semaphore_get_type (void)
{
	static volatile gsize event_semaphore_type_id__once = 0;
	if (g_once_init_enter (&event_semaphore_type_id__once)) {
		GType event_semaphore_type_id;
		event_semaphore_type_id = event_semaphore_get_type_once ();
		g_once_init_leave (&event_semaphore_type_id__once, event_semaphore_type_id);
	}
	return event_semaphore_type_id__once;
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

