/* DragAndDropHandler.c generated by valac 0.56.18, the Vala compiler
 * generated from DragAndDropHandler.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* DragAndDropHandler attaches signals to a Page to properly handle drag-and-drop requests for the*/
/* Page as a DnD Source.  (DnD Destination handling is handled by the appropriate AppWindow, i.e.*/
/* LibraryWindow and DirectWindow). Assumes the Page's ViewCollection holds MediaSources.*/
/**/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS,
	DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST
} DragAndDropHandlerTargetType;

#define DRAG_AND_DROP_HANDLER_TYPE_TARGET_TYPE (drag_and_drop_handler_target_type_get_type ())
#define _exporter_ui_unref0(var) ((var == NULL) ? NULL : (var = (exporter_ui_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecDragAndDropHandler ParamSpecDragAndDropHandler;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DragAndDropHandlerPrivate {
	Page* page;
	GtkWidget* event_source;
	GFile* drag_destination;
	ExporterUI* exporter;
};

struct _ParamSpecDragAndDropHandler {
	GParamSpec parent_instance;
};

static gint DragAndDropHandler_private_offset;
static gpointer drag_and_drop_handler_parent_class = NULL;
static GdkAtom* drag_and_drop_handler_xds_atom;
static GdkAtom* drag_and_drop_handler_xds_atom = NULL;
static GdkAtom* drag_and_drop_handler_text_atom;
static GdkAtom* drag_and_drop_handler_text_atom = NULL;
static guint8* drag_and_drop_handler_xds_fake_target;
static gint drag_and_drop_handler_xds_fake_target_length1;
static guint8* drag_and_drop_handler_xds_fake_target = NULL;
static gint drag_and_drop_handler_xds_fake_target_length1 = 0;
static gint _drag_and_drop_handler_xds_fake_target_size_ = 0;

static void drag_and_drop_handler_on_drag_begin (DragAndDropHandler* self,
                                          GdkDragContext* context);
static void _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                 GdkDragContext* context,
                                                                 gpointer self);
static void drag_and_drop_handler_on_drag_data_get (DragAndDropHandler* self,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint target_type,
                                             guint time);
static void _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       GtkSelectionData* selection_data,
                                                                       guint info,
                                                                       guint time_,
                                                                       gpointer self);
static void drag_and_drop_handler_on_drag_end (DragAndDropHandler* self);
static void _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self);
static gboolean drag_and_drop_handler_on_drag_failed (DragAndDropHandler* self,
                                               GdkDragContext* context,
                                               GtkDragResult drag_result);
static gboolean _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       GtkDragResult _result_,
                                                                       gpointer self);
static GType drag_and_drop_handler_target_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GdkAtom* _gdk_atom_dup (GdkAtom* self);
static void drag_and_drop_handler_on_export_completed (DragAndDropHandler* self);
static void _drag_and_drop_handler_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                              gboolean is_cancelled,
                                                                              gpointer self);
static void drag_and_drop_handler_finalize (DragAndDropHandler * obj);
static GType drag_and_drop_handler_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GtkTargetEntry DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES[2] = {{"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS}, {"shotwell/media-id-atom", (guint) GTK_TARGET_SAME_APP, (guint) DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST}};

static inline gpointer
drag_and_drop_handler_get_instance_private (DragAndDropHandler* self)
{
	return G_STRUCT_MEMBER_P (self, DragAndDropHandler_private_offset);
}

static void
_drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                            GdkDragContext* context,
                                                            gpointer self)
{
#line 76 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_begin ((DragAndDropHandler*) self, context);
#line 144 "DragAndDropHandler.c"
}

static void
_drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                  GdkDragContext* context,
                                                                  GtkSelectionData* selection_data,
                                                                  guint info,
                                                                  guint time_,
                                                                  gpointer self)
{
#line 77 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_data_get ((DragAndDropHandler*) self, context, selection_data, info, time_);
#line 157 "DragAndDropHandler.c"
}

static void
_drag_and_drop_handler_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        gpointer self)
{
#line 78 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_end ((DragAndDropHandler*) self);
#line 167 "DragAndDropHandler.c"
}

static gboolean
_drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              GtkDragResult _result_,
                                                              gpointer self)
{
	gboolean result;
	result = drag_and_drop_handler_on_drag_failed ((DragAndDropHandler*) self, context, _result_);
#line 79 "../src/util/DragAndDropHandler.vala"
	return result;
#line 180 "DragAndDropHandler.c"
}

static GType
drag_and_drop_handler_target_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS, "DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS", "xds"}, {DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST, "DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST", "media-list"}, {0, NULL, NULL}};
	GType drag_and_drop_handler_target_type_type_id;
	drag_and_drop_handler_target_type_type_id = g_enum_register_static ("DragAndDropHandlerTargetType", values);
	return drag_and_drop_handler_target_type_type_id;
}

static GType
drag_and_drop_handler_target_type_get_type (void)
{
	static volatile gsize drag_and_drop_handler_target_type_type_id__once = 0;
	if (g_once_init_enter (&drag_and_drop_handler_target_type_type_id__once)) {
		GType drag_and_drop_handler_target_type_type_id;
		drag_and_drop_handler_target_type_type_id = drag_and_drop_handler_target_type_get_type_once ();
		g_once_init_leave (&drag_and_drop_handler_target_type_type_id__once, drag_and_drop_handler_target_type_type_id);
	}
	return drag_and_drop_handler_target_type_type_id__once;
}

static GdkAtom*
_gdk_atom_dup (GdkAtom* self)
{
	GdkAtom* dup;
#line 54 "../src/util/DragAndDropHandler.vala"
	dup = g_new0 (GdkAtom, 1);
#line 54 "../src/util/DragAndDropHandler.vala"
	memcpy (dup, self, sizeof (GdkAtom));
#line 54 "../src/util/DragAndDropHandler.vala"
	return dup;
#line 214 "DragAndDropHandler.c"
}

static gpointer
__gdk_atom_dup0 (gpointer self)
{
#line 54 "../src/util/DragAndDropHandler.vala"
	return self ? _gdk_atom_dup (self) : NULL;
#line 222 "DragAndDropHandler.c"
}

DragAndDropHandler*
drag_and_drop_handler_construct (GType object_type,
                                 Page* page)
{
	DragAndDropHandler* self = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GdkAtom* _tmp3_;
	GdkAtom* _tmp6_;
	guint8* _tmp9_;
	gint _tmp9__length1;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkWidget* _tmp14_;
	GtkWidget* _tmp15_;
	GtkWidget* _tmp16_;
#line 46 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 46 "../src/util/DragAndDropHandler.vala"
	self = (DragAndDropHandler*) g_type_create_instance (object_type);
#line 47 "../src/util/DragAndDropHandler.vala"
	self->priv->page = page;
#line 48 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = page_get_event_source (page);
#line 48 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 48 "../src/util/DragAndDropHandler.vala"
	self->priv->event_source = _tmp0_;
#line 49 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = self->priv->event_source;
#line 49 "../src/util/DragAndDropHandler.vala"
	_vala_assert (_tmp1_ != NULL, "event_source != null");
#line 50 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = self->priv->event_source;
#line 50 "../src/util/DragAndDropHandler.vala"
	_vala_assert (gtk_widget_get_has_window (_tmp2_), "event_source.get_has_window ()");
#line 53 "../src/util/DragAndDropHandler.vala"
	_tmp3_ = drag_and_drop_handler_xds_atom;
#line 53 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_ == NULL) {
#line 266 "DragAndDropHandler.c"
		GdkAtom _tmp4_;
		GdkAtom* _tmp5_;
#line 54 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = gdk_atom_intern_static_string ("XdndDirectSave0");
#line 54 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = __gdk_atom_dup0 (&_tmp4_);
#line 54 "../src/util/DragAndDropHandler.vala"
		_g_free0 (drag_and_drop_handler_xds_atom);
#line 54 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_xds_atom = _tmp5_;
#line 277 "DragAndDropHandler.c"
	}
#line 56 "../src/util/DragAndDropHandler.vala"
	_tmp6_ = drag_and_drop_handler_text_atom;
#line 56 "../src/util/DragAndDropHandler.vala"
	if (_tmp6_ == NULL) {
#line 283 "DragAndDropHandler.c"
		GdkAtom _tmp7_;
		GdkAtom* _tmp8_;
#line 57 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = gdk_atom_intern_static_string ("text/plain");
#line 57 "../src/util/DragAndDropHandler.vala"
		_tmp8_ = __gdk_atom_dup0 (&_tmp7_);
#line 57 "../src/util/DragAndDropHandler.vala"
		_g_free0 (drag_and_drop_handler_text_atom);
#line 57 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_text_atom = _tmp8_;
#line 294 "DragAndDropHandler.c"
	}
#line 59 "../src/util/DragAndDropHandler.vala"
	_tmp9_ = drag_and_drop_handler_xds_fake_target;
#line 59 "../src/util/DragAndDropHandler.vala"
	_tmp9__length1 = drag_and_drop_handler_xds_fake_target_length1;
#line 59 "../src/util/DragAndDropHandler.vala"
	if (_tmp9_ == NULL) {
#line 302 "DragAndDropHandler.c"
		gint _tmp10_ = 0;
		guchar* _tmp11_;
#line 60 "../src/util/DragAndDropHandler.vala"
		_tmp11_ = string_to_uchar_array ("shotwell.txt", &_tmp10_);
#line 60 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_xds_fake_target = (g_free (drag_and_drop_handler_xds_fake_target), NULL);
#line 60 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_xds_fake_target = _tmp11_;
#line 60 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_xds_fake_target_length1 = _tmp10_;
#line 60 "../src/util/DragAndDropHandler.vala"
		_drag_and_drop_handler_xds_fake_target_size_ = drag_and_drop_handler_xds_fake_target_length1;
#line 315 "DragAndDropHandler.c"
	}
#line 63 "../src/util/DragAndDropHandler.vala"
	_tmp12_ = self->priv->event_source;
#line 63 "../src/util/DragAndDropHandler.vala"
	gtk_drag_source_set (_tmp12_, GDK_BUTTON1_MASK, DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES, (gint) G_N_ELEMENTS (DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES), GDK_ACTION_COPY);
#line 68 "../src/util/DragAndDropHandler.vala"
	_tmp13_ = self->priv->event_source;
#line 68 "../src/util/DragAndDropHandler.vala"
	g_signal_connect (_tmp13_, "drag-begin", (GCallback) _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin, self);
#line 69 "../src/util/DragAndDropHandler.vala"
	_tmp14_ = self->priv->event_source;
#line 69 "../src/util/DragAndDropHandler.vala"
	g_signal_connect (_tmp14_, "drag-data-get", (GCallback) _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get, self);
#line 70 "../src/util/DragAndDropHandler.vala"
	_tmp15_ = self->priv->event_source;
#line 70 "../src/util/DragAndDropHandler.vala"
	g_signal_connect (_tmp15_, "drag-end", (GCallback) _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end, self);
#line 71 "../src/util/DragAndDropHandler.vala"
	_tmp16_ = self->priv->event_source;
#line 71 "../src/util/DragAndDropHandler.vala"
	g_signal_connect (_tmp16_, "drag-failed", (GCallback) _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed, self);
#line 46 "../src/util/DragAndDropHandler.vala"
	return self;
#line 339 "DragAndDropHandler.c"
}

DragAndDropHandler*
drag_and_drop_handler_new (Page* page)
{
#line 46 "../src/util/DragAndDropHandler.vala"
	return drag_and_drop_handler_construct (TYPE_DRAG_AND_DROP_HANDLER, page);
#line 347 "DragAndDropHandler.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 95 "../src/util/DragAndDropHandler.vala"
	return self ? g_object_ref (self) : NULL;
#line 355 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_on_drag_begin (DragAndDropHandler* self,
                                     GdkDragContext* context)
{
	Page* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	ThumbnailSource* thumb = NULL;
	Page* _tmp10_;
	ViewCollection* _tmp11_;
	ViewCollection* _tmp12_;
	DataView* _tmp13_;
	DataView* _tmp14_;
	DataSource* _tmp15_;
	DataSource* _tmp16_;
	ThumbnailSource* _tmp17_;
	ThumbnailSource* _tmp18_;
	GdkWindow* _tmp28_;
	GdkAtom* _tmp29_;
	GdkAtom* _tmp30_;
	guint8* _tmp31_;
	gint _tmp31__length1;
	GError* _inner_error0_ = NULL;
#line 86 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (context != NULL);
#line 87 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 87 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 87 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 87 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:87: on_drag_begin (%s)", _tmp2_);
#line 89 "../src/util/DragAndDropHandler.vala"
	_tmp5_ = self->priv->page;
#line 89 "../src/util/DragAndDropHandler.vala"
	if (_tmp5_ == NULL) {
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = TRUE;
#line 402 "DragAndDropHandler.c"
	} else {
		Page* _tmp6_;
		ViewCollection* _tmp7_;
		ViewCollection* _tmp8_;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp6_ = self->priv->page;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = page_get_view (_tmp6_);
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp8_ = _tmp7_;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = view_collection_get_selected_count (_tmp8_) == 0;
#line 89 "../src/util/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp8_);
#line 417 "DragAndDropHandler.c"
	}
#line 89 "../src/util/DragAndDropHandler.vala"
	if (_tmp4_) {
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 423 "DragAndDropHandler.c"
	} else {
		ExporterUI* _tmp9_;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp9_ = self->priv->exporter;
#line 89 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = _tmp9_ != NULL;
#line 430 "DragAndDropHandler.c"
	}
#line 89 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 90 "../src/util/DragAndDropHandler.vala"
		return;
#line 436 "DragAndDropHandler.c"
	}
#line 92 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 92 "../src/util/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp10_ = self->priv->page;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp11_ = page_get_view (_tmp10_);
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp12_ = _tmp11_;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp13_ = view_collection_get_selected_at (_tmp12_, 0);
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp14_ = _tmp13_;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp15_ = data_view_get_source (_tmp14_);
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp16_ = _tmp15_;
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 95 "../src/util/DragAndDropHandler.vala"
	_tmp18_ = _tmp17_;
#line 95 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (_tmp14_);
#line 95 "../src/util/DragAndDropHandler.vala"
	_data_collection_unref0 (_tmp12_);
#line 95 "../src/util/DragAndDropHandler.vala"
	thumb = _tmp18_;
#line 466 "DragAndDropHandler.c"
	{
		GdkPixbuf* icon = NULL;
		ThumbnailSource* _tmp19_;
		GdkPixbuf* _tmp20_;
		GtkWidget* _tmp21_;
		GdkPixbuf* _tmp22_;
#line 98 "../src/util/DragAndDropHandler.vala"
		_tmp19_ = thumb;
#line 98 "../src/util/DragAndDropHandler.vala"
		_tmp20_ = thumbnail_source_get_thumbnail (_tmp19_, 128, &_inner_error0_);
#line 98 "../src/util/DragAndDropHandler.vala"
		icon = _tmp20_;
#line 98 "../src/util/DragAndDropHandler.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "DragAndDropHandler.c"
			goto __catch0_g_error;
		}
#line 99 "../src/util/DragAndDropHandler.vala"
		_tmp21_ = self->priv->event_source;
#line 99 "../src/util/DragAndDropHandler.vala"
		_tmp22_ = icon;
#line 99 "../src/util/DragAndDropHandler.vala"
		gtk_drag_source_set_icon_pixbuf (_tmp21_, _tmp22_);
#line 97 "../src/util/DragAndDropHandler.vala"
		_g_object_unref0 (icon);
#line 492 "DragAndDropHandler.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		ThumbnailSource* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GError* _tmp26_;
		const gchar* _tmp27_;
#line 97 "../src/util/DragAndDropHandler.vala"
		err = _inner_error0_;
#line 97 "../src/util/DragAndDropHandler.vala"
		_inner_error0_ = NULL;
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp23_ = thumb;
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp24_ = data_object_to_string ((DataObject*) _tmp23_);
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp25_ = _tmp24_;
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp26_ = err;
#line 101 "../src/util/DragAndDropHandler.vala"
		_tmp27_ = _tmp26_->message;
#line 101 "../src/util/DragAndDropHandler.vala"
		g_warning ("DragAndDropHandler.vala:101: Unable to fetch icon for drag-and-drop fr" \
"om %s: %s", _tmp25_, _tmp27_);
#line 101 "../src/util/DragAndDropHandler.vala"
		_g_free0 (_tmp25_);
#line 97 "../src/util/DragAndDropHandler.vala"
		_g_error_free0 (err);
#line 523 "DragAndDropHandler.c"
	}
	__finally0:
#line 97 "../src/util/DragAndDropHandler.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "../src/util/DragAndDropHandler.vala"
		_g_object_unref0 (thumb);
#line 97 "../src/util/DragAndDropHandler.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "../src/util/DragAndDropHandler.vala"
		g_clear_error (&_inner_error0_);
#line 97 "../src/util/DragAndDropHandler.vala"
		return;
#line 536 "DragAndDropHandler.c"
	}
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp28_ = gdk_drag_context_get_source_window (context);
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp29_ = drag_and_drop_handler_xds_atom;
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp30_ = drag_and_drop_handler_text_atom;
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp31_ = drag_and_drop_handler_xds_fake_target;
#line 107 "../src/util/DragAndDropHandler.vala"
	_tmp31__length1 = drag_and_drop_handler_xds_fake_target_length1;
#line 107 "../src/util/DragAndDropHandler.vala"
	gdk_property_change (_tmp28_, *_tmp29_, *_tmp30_, 8, GDK_PROP_MODE_REPLACE, (const guchar*) _tmp31_, 1);
#line 86 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (thumb);
#line 552 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_on_drag_data_get (DragAndDropHandler* self,
                                        GdkDragContext* context,
                                        GtkSelectionData* selection_data,
                                        guint target_type,
                                        guint time)
{
	Page* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Page* _tmp4_;
#line 115 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (context != NULL);
#line 115 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (selection_data != NULL);
#line 117 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 117 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 117 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 117 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:117: on_drag_data_get (%s)", _tmp2_);
#line 119 "../src/util/DragAndDropHandler.vala"
	_tmp4_ = self->priv->page;
#line 119 "../src/util/DragAndDropHandler.vala"
	if (_tmp4_ == NULL) {
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 587 "DragAndDropHandler.c"
	} else {
		Page* _tmp5_;
		ViewCollection* _tmp6_;
		ViewCollection* _tmp7_;
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = self->priv->page;
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp6_ = page_get_view (_tmp5_);
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = _tmp6_;
#line 119 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = view_collection_get_selected_count (_tmp7_) == 0;
#line 119 "../src/util/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp7_);
#line 602 "DragAndDropHandler.c"
	}
#line 119 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 120 "../src/util/DragAndDropHandler.vala"
		return;
#line 608 "DragAndDropHandler.c"
	}
#line 122 "../src/util/DragAndDropHandler.vala"
	switch (target_type) {
#line 122 "../src/util/DragAndDropHandler.vala"
		case DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS:
#line 614 "DragAndDropHandler.c"
		{
			guchar* data = NULL;
			guchar* _tmp8_;
			gint data_length1;
			gint _data_size_;
			GdkAtom actual_type = (GdkAtom) 0U;
			gint actual_format = 0;
			gboolean fetched = FALSE;
			GdkWindow* _tmp9_;
			GdkAtom* _tmp10_;
			GdkAtom* _tmp11_;
			guchar* _tmp12_;
			gint _tmp12__length1;
			GdkAtom _tmp13_ = (GdkAtom) 0U;
			gint _tmp14_ = 0;
			guint8* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gboolean _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gchar* _tmp28_ = NULL;
			GFile* _tmp29_;
			Page* _tmp33_;
			const gchar* _tmp34_;
			const gchar* _tmp35_;
			const gchar* _tmp36_ = NULL;
			GFile* _tmp37_;
			GdkAtom* _tmp38_;
			gint _tmp39_ = 0;
			guchar* _tmp40_;
			guchar* _tmp41_;
			gint _tmp41__length1;
#line 125 "../src/util/DragAndDropHandler.vala"
			_tmp8_ = g_new0 (guchar, 4096);
#line 125 "../src/util/DragAndDropHandler.vala"
			data = _tmp8_;
#line 125 "../src/util/DragAndDropHandler.vala"
			data_length1 = 4096;
#line 125 "../src/util/DragAndDropHandler.vala"
			_data_size_ = data_length1;
#line 127 "../src/util/DragAndDropHandler.vala"
			actual_format = 0;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp9_ = gdk_drag_context_get_source_window (context);
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp10_ = drag_and_drop_handler_xds_atom;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp11_ = drag_and_drop_handler_text_atom;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp12_ = data;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp12__length1 = data_length1;
#line 128 "../src/util/DragAndDropHandler.vala"
			_tmp17_ = gdk_property_get (_tmp9_, *_tmp10_, *_tmp11_, (gulong) 0, (gulong) _tmp12__length1, 0, &_tmp13_, &_tmp14_, &_tmp16_, &_tmp15_);
#line 128 "../src/util/DragAndDropHandler.vala"
			actual_type = _tmp13_;
#line 128 "../src/util/DragAndDropHandler.vala"
			actual_format = _tmp14_;
#line 128 "../src/util/DragAndDropHandler.vala"
			data = (g_free (data), NULL);
#line 128 "../src/util/DragAndDropHandler.vala"
			data = _tmp15_;
#line 128 "../src/util/DragAndDropHandler.vala"
			data_length1 = _tmp16_;
#line 128 "../src/util/DragAndDropHandler.vala"
			_data_size_ = data_length1;
#line 128 "../src/util/DragAndDropHandler.vala"
			fetched = _tmp17_;
#line 133 "../src/util/DragAndDropHandler.vala"
			if (fetched) {
#line 685 "DragAndDropHandler.c"
				guchar* _tmp20_;
				gint _tmp20__length1;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp20_ = data;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp20__length1 = data_length1;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp19_ = _tmp20_ != NULL;
#line 694 "DragAndDropHandler.c"
			} else {
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp19_ = FALSE;
#line 698 "DragAndDropHandler.c"
			}
#line 133 "../src/util/DragAndDropHandler.vala"
			if (_tmp19_) {
#line 702 "DragAndDropHandler.c"
				guchar* _tmp21_;
				gint _tmp21__length1;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp21_ = data;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp21__length1 = data_length1;
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp18_ = _tmp21__length1 > 0;
#line 711 "DragAndDropHandler.c"
			} else {
#line 133 "../src/util/DragAndDropHandler.vala"
				_tmp18_ = FALSE;
#line 715 "DragAndDropHandler.c"
			}
#line 133 "../src/util/DragAndDropHandler.vala"
			if (_tmp18_) {
#line 719 "DragAndDropHandler.c"
				guchar* _tmp22_;
				gint _tmp22__length1;
				gchar* _tmp23_;
				gchar* _tmp24_;
				GFile* _tmp25_;
				GFile* _tmp26_;
				GFile* _tmp27_;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp22_ = data;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp22__length1 = data_length1;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp23_ = uchar_array_to_string (_tmp22_, (gint) _tmp22__length1, -1);
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp24_ = _tmp23_;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp26_ = _tmp25_;
#line 134 "../src/util/DragAndDropHandler.vala"
				_tmp27_ = g_file_get_parent (_tmp26_);
#line 134 "../src/util/DragAndDropHandler.vala"
				_g_object_unref0 (self->priv->drag_destination);
#line 134 "../src/util/DragAndDropHandler.vala"
				self->priv->drag_destination = _tmp27_;
#line 134 "../src/util/DragAndDropHandler.vala"
				_g_object_unref0 (_tmp26_);
#line 134 "../src/util/DragAndDropHandler.vala"
				_g_free0 (_tmp24_);
#line 749 "DragAndDropHandler.c"
			}
#line 137 "../src/util/DragAndDropHandler.vala"
			_tmp29_ = self->priv->drag_destination;
#line 137 "../src/util/DragAndDropHandler.vala"
			if (_tmp29_ != NULL) {
#line 755 "DragAndDropHandler.c"
				GFile* _tmp30_;
				gchar* _tmp31_;
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp30_ = self->priv->drag_destination;
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp31_ = g_file_get_path (_tmp30_);
#line 137 "../src/util/DragAndDropHandler.vala"
				_g_free0 (_tmp28_);
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp28_ = _tmp31_;
#line 766 "DragAndDropHandler.c"
			} else {
				gchar* _tmp32_;
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp32_ = g_strdup ("(no path)");
#line 137 "../src/util/DragAndDropHandler.vala"
				_g_free0 (_tmp28_);
#line 137 "../src/util/DragAndDropHandler.vala"
				_tmp28_ = _tmp32_;
#line 775 "DragAndDropHandler.c"
			}
#line 136 "../src/util/DragAndDropHandler.vala"
			_tmp33_ = self->priv->page;
#line 136 "../src/util/DragAndDropHandler.vala"
			_tmp34_ = page_get_page_name (_tmp33_);
#line 136 "../src/util/DragAndDropHandler.vala"
			_tmp35_ = _tmp34_;
#line 136 "../src/util/DragAndDropHandler.vala"
			g_debug ("DragAndDropHandler.vala:136: on_drag_data_get (%s): %s", _tmp35_, _tmp28_);
#line 141 "../src/util/DragAndDropHandler.vala"
			_tmp37_ = self->priv->drag_destination;
#line 141 "../src/util/DragAndDropHandler.vala"
			if (_tmp37_ != NULL) {
#line 141 "../src/util/DragAndDropHandler.vala"
				_tmp36_ = "S";
#line 791 "DragAndDropHandler.c"
			} else {
#line 141 "../src/util/DragAndDropHandler.vala"
				_tmp36_ = "E";
#line 795 "DragAndDropHandler.c"
			}
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp38_ = drag_and_drop_handler_xds_atom;
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp40_ = string_to_uchar_array (_tmp36_, &_tmp39_);
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp41_ = _tmp40_;
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp41__length1 = _tmp39_;
#line 140 "../src/util/DragAndDropHandler.vala"
			gtk_selection_data_set (selection_data, *_tmp38_, 8, _tmp41_, (gint) _tmp39_);
#line 140 "../src/util/DragAndDropHandler.vala"
			_tmp41_ = (g_free (_tmp41_), NULL);
#line 142 "../src/util/DragAndDropHandler.vala"
			_g_free0 (_tmp28_);
#line 142 "../src/util/DragAndDropHandler.vala"
			data = (g_free (data), NULL);
#line 142 "../src/util/DragAndDropHandler.vala"
			break;
#line 815 "DragAndDropHandler.c"
		}
#line 122 "../src/util/DragAndDropHandler.vala"
		case DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST:
#line 819 "DragAndDropHandler.c"
		{
			GeeCollection* sources = NULL;
			Page* _tmp42_;
			ViewCollection* _tmp43_;
			ViewCollection* _tmp44_;
			GeeList* _tmp45_;
			GeeCollection* _tmp46_;
			GeeCollection* _tmp47_;
			gint _tmp48_ = 0;
			guchar* _tmp49_;
			guchar* _tmp50_;
			gint _tmp50__length1;
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp42_ = self->priv->page;
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp43_ = page_get_view (_tmp42_);
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp44_ = _tmp43_;
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp45_ = view_collection_get_selected_sources (_tmp44_);
#line 145 "../src/util/DragAndDropHandler.vala"
			_tmp46_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_COLLECTION, GeeCollection);
#line 145 "../src/util/DragAndDropHandler.vala"
			_data_collection_unref0 (_tmp44_);
#line 145 "../src/util/DragAndDropHandler.vala"
			sources = _tmp46_;
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp47_ = sources;
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp49_ = serialize_media_sources (_tmp47_, &_tmp48_);
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp50_ = _tmp49_;
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp50__length1 = _tmp48_;
#line 150 "../src/util/DragAndDropHandler.vala"
			gtk_selection_data_set (selection_data, gdk_atom_intern_static_string ("SourceIDAtom"), (gint) sizeof (GdkAtom), _tmp50_, (gint) _tmp48_);
#line 150 "../src/util/DragAndDropHandler.vala"
			_tmp50_ = (g_free (_tmp50_), NULL);
#line 152 "../src/util/DragAndDropHandler.vala"
			_g_object_unref0 (sources);
#line 152 "../src/util/DragAndDropHandler.vala"
			break;
#line 862 "DragAndDropHandler.c"
		}
		default:
		{
			Page* _tmp51_;
			const gchar* _tmp52_;
			const gchar* _tmp53_;
#line 155 "../src/util/DragAndDropHandler.vala"
			_tmp51_ = self->priv->page;
#line 155 "../src/util/DragAndDropHandler.vala"
			_tmp52_ = page_get_page_name (_tmp51_);
#line 155 "../src/util/DragAndDropHandler.vala"
			_tmp53_ = _tmp52_;
#line 155 "../src/util/DragAndDropHandler.vala"
			g_warning ("DragAndDropHandler.vala:155: on_drag_data_get (%s): unknown target typ" \
"e %u", _tmp53_, target_type);
#line 157 "../src/util/DragAndDropHandler.vala"
			break;
#line 879 "DragAndDropHandler.c"
		}
	}
}

static void
_drag_and_drop_handler_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                         gboolean is_cancelled,
                                                                         gpointer self)
{
#line 178 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_on_export_completed ((DragAndDropHandler*) self);
#line 891 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_on_drag_end (DragAndDropHandler* self)
{
	Page* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	Page* _tmp6_;
	GFile* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean _tmp18_;
#line 161 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 162 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 162 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 162 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:162: on_drag_end (%s)", _tmp2_);
#line 164 "../src/util/DragAndDropHandler.vala"
	_tmp6_ = self->priv->page;
#line 164 "../src/util/DragAndDropHandler.vala"
	if (_tmp6_ == NULL) {
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = TRUE;
#line 927 "DragAndDropHandler.c"
	} else {
		Page* _tmp7_;
		ViewCollection* _tmp8_;
		ViewCollection* _tmp9_;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = self->priv->page;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp8_ = page_get_view (_tmp7_);
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp9_ = _tmp8_;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = view_collection_get_selected_count (_tmp9_) == 0;
#line 164 "../src/util/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp9_);
#line 942 "DragAndDropHandler.c"
	}
#line 164 "../src/util/DragAndDropHandler.vala"
	if (_tmp5_) {
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = TRUE;
#line 948 "DragAndDropHandler.c"
	} else {
		GFile* _tmp10_;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp10_ = self->priv->drag_destination;
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp4_ = _tmp10_ == NULL;
#line 955 "DragAndDropHandler.c"
	}
#line 164 "../src/util/DragAndDropHandler.vala"
	if (_tmp4_) {
#line 164 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 961 "DragAndDropHandler.c"
	} else {
		ExporterUI* _tmp11_;
#line 165 "../src/util/DragAndDropHandler.vala"
		_tmp11_ = self->priv->exporter;
#line 165 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = _tmp11_ != NULL;
#line 968 "DragAndDropHandler.c"
	}
#line 164 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 166 "../src/util/DragAndDropHandler.vala"
		return;
#line 974 "DragAndDropHandler.c"
	}
#line 169 "../src/util/DragAndDropHandler.vala"
	_tmp12_ = self->priv->drag_destination;
#line 169 "../src/util/DragAndDropHandler.vala"
	_tmp13_ = g_file_get_path (_tmp12_);
#line 169 "../src/util/DragAndDropHandler.vala"
	_tmp14_ = _tmp13_;
#line 169 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:169: Exporting to %s", _tmp14_);
#line 169 "../src/util/DragAndDropHandler.vala"
	_g_free0 (_tmp14_);
#line 174 "../src/util/DragAndDropHandler.vala"
	_tmp15_ = self->priv->drag_destination;
#line 174 "../src/util/DragAndDropHandler.vala"
	_tmp16_ = g_file_get_path (_tmp15_);
#line 174 "../src/util/DragAndDropHandler.vala"
	_tmp17_ = _tmp16_;
#line 174 "../src/util/DragAndDropHandler.vala"
	_tmp18_ = _tmp17_ != NULL;
#line 174 "../src/util/DragAndDropHandler.vala"
	_g_free0 (_tmp17_);
#line 174 "../src/util/DragAndDropHandler.vala"
	if (_tmp18_) {
#line 998 "DragAndDropHandler.c"
		Page* _tmp19_;
		ViewCollection* _tmp20_;
		ViewCollection* _tmp21_;
		GeeList* _tmp22_;
		GeeCollection* _tmp23_;
		GFile* _tmp24_;
		Scaling _tmp25_ = {0};
		ExportFormatParameters _tmp26_ = {0};
		Exporter* _tmp27_;
		Exporter* _tmp28_;
		ExporterUI* _tmp29_;
		ExporterUI* _tmp30_;
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp19_ = self->priv->page;
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp20_ = page_get_view (_tmp19_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp21_ = _tmp20_;
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp22_ = view_collection_get_selected_sources (_tmp21_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp23_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp24_ = self->priv->drag_destination;
#line 175 "../src/util/DragAndDropHandler.vala"
		scaling_for_original (&_tmp25_);
#line 175 "../src/util/DragAndDropHandler.vala"
		export_format_parameters_current (&_tmp26_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp27_ = exporter_new (_tmp23_, _tmp24_, &_tmp25_, &_tmp26_, FALSE);
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp28_ = _tmp27_;
#line 175 "../src/util/DragAndDropHandler.vala"
		_tmp29_ = exporter_ui_new (_tmp28_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_exporter_ui_unref0 (self->priv->exporter);
#line 175 "../src/util/DragAndDropHandler.vala"
		self->priv->exporter = _tmp29_;
#line 175 "../src/util/DragAndDropHandler.vala"
		_g_object_unref0 (_tmp28_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_g_object_unref0 (_tmp23_);
#line 175 "../src/util/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp21_);
#line 178 "../src/util/DragAndDropHandler.vala"
		_tmp30_ = self->priv->exporter;
#line 178 "../src/util/DragAndDropHandler.vala"
		exporter_ui_export (_tmp30_, _drag_and_drop_handler_on_export_completed_exporter_completion_callback, self);
#line 1047 "DragAndDropHandler.c"
	} else {
#line 180 "../src/util/DragAndDropHandler.vala"
		app_window_error_message (_ ("Photos cannot be exported to this directory."), NULL, NULL);
#line 1051 "DragAndDropHandler.c"
	}
#line 183 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 183 "../src/util/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 1057 "DragAndDropHandler.c"
}

static gboolean
drag_and_drop_handler_on_drag_failed (DragAndDropHandler* self,
                                      GdkDragContext* context,
                                      GtkDragResult drag_result)
{
	Page* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	Page* _tmp3_;
	gboolean result;
#line 186 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 187 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 187 "../src/util/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 187 "../src/util/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 187 "../src/util/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:187: on_drag_failed (%s): %d", _tmp2_, (gint) drag_result);
#line 189 "../src/util/DragAndDropHandler.vala"
	_tmp3_ = self->priv->page;
#line 189 "../src/util/DragAndDropHandler.vala"
	if (_tmp3_ == NULL) {
#line 190 "../src/util/DragAndDropHandler.vala"
		result = FALSE;
#line 190 "../src/util/DragAndDropHandler.vala"
		return result;
#line 1090 "DragAndDropHandler.c"
	}
#line 192 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 192 "../src/util/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 194 "../src/util/DragAndDropHandler.vala"
	result = FALSE;
#line 194 "../src/util/DragAndDropHandler.vala"
	return result;
#line 1100 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_on_export_completed (DragAndDropHandler* self)
{
#line 197 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/util/DragAndDropHandler.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 198 "../src/util/DragAndDropHandler.vala"
	self->priv->exporter = NULL;
#line 1112 "DragAndDropHandler.c"
}

static void
value_drag_and_drop_handler_init (GValue* value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	value->data[0].v_pointer = NULL;
#line 1120 "DragAndDropHandler.c"
}

static void
value_drag_and_drop_handler_free_value (GValue* value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (value->data[0].v_pointer);
#line 1130 "DragAndDropHandler.c"
	}
}

static void
value_drag_and_drop_handler_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/util/DragAndDropHandler.vala"
		dest_value->data[0].v_pointer = drag_and_drop_handler_ref (src_value->data[0].v_pointer);
#line 1142 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1146 "DragAndDropHandler.c"
	}
}

static gpointer
value_drag_and_drop_handler_peek_pointer (const GValue* value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	return value->data[0].v_pointer;
#line 1155 "DragAndDropHandler.c"
}

static gchar*
value_drag_and_drop_handler_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	if (collect_values[0].v_pointer) {
#line 1166 "DragAndDropHandler.c"
		DragAndDropHandler * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/util/DragAndDropHandler.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/util/DragAndDropHandler.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1173 "DragAndDropHandler.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/util/DragAndDropHandler.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1177 "DragAndDropHandler.c"
		}
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = drag_and_drop_handler_ref (object);
#line 1181 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1185 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	return NULL;
#line 1189 "DragAndDropHandler.c"
}

static gchar*
value_drag_and_drop_handler_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	DragAndDropHandler ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/util/DragAndDropHandler.vala"
	if (!object_p) {
#line 26 "../src/util/DragAndDropHandler.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1204 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/util/DragAndDropHandler.vala"
		*object_p = NULL;
#line 1210 "DragAndDropHandler.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/util/DragAndDropHandler.vala"
		*object_p = value->data[0].v_pointer;
#line 1214 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		*object_p = drag_and_drop_handler_ref (value->data[0].v_pointer);
#line 1218 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	return NULL;
#line 1222 "DragAndDropHandler.c"
}

GParamSpec*
param_spec_drag_and_drop_handler (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	ParamSpecDragAndDropHandler* spec;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DRAG_AND_DROP_HANDLER), NULL);
#line 26 "../src/util/DragAndDropHandler.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/util/DragAndDropHandler.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/util/DragAndDropHandler.vala"
	return G_PARAM_SPEC (spec);
#line 1241 "DragAndDropHandler.c"
}

gpointer
value_get_drag_and_drop_handler (const GValue* value)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER), NULL);
#line 26 "../src/util/DragAndDropHandler.vala"
	return value->data[0].v_pointer;
#line 1251 "DragAndDropHandler.c"
}

void
value_set_drag_and_drop_handler (GValue* value,
                                 gpointer v_object)
{
	DragAndDropHandler * old;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER));
#line 26 "../src/util/DragAndDropHandler.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/util/DragAndDropHandler.vala"
	if (v_object) {
#line 26 "../src/util/DragAndDropHandler.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DRAG_AND_DROP_HANDLER));
#line 26 "../src/util/DragAndDropHandler.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_ref (value->data[0].v_pointer);
#line 1273 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1277 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	if (old) {
#line 26 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (old);
#line 1283 "DragAndDropHandler.c"
	}
}

void
value_take_drag_and_drop_handler (GValue* value,
                                  gpointer v_object)
{
	DragAndDropHandler * old;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER));
#line 26 "../src/util/DragAndDropHandler.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/util/DragAndDropHandler.vala"
	if (v_object) {
#line 26 "../src/util/DragAndDropHandler.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DRAG_AND_DROP_HANDLER));
#line 26 "../src/util/DragAndDropHandler.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = v_object;
#line 1304 "DragAndDropHandler.c"
	} else {
#line 26 "../src/util/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1308 "DragAndDropHandler.c"
	}
#line 26 "../src/util/DragAndDropHandler.vala"
	if (old) {
#line 26 "../src/util/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (old);
#line 1314 "DragAndDropHandler.c"
	}
}

static void
drag_and_drop_handler_class_init (DragAndDropHandlerClass * klass,
                                  gpointer klass_data)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	drag_and_drop_handler_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/util/DragAndDropHandler.vala"
	((DragAndDropHandlerClass *) klass)->finalize = drag_and_drop_handler_finalize;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_type_class_adjust_private_offset (klass, &DragAndDropHandler_private_offset);
#line 1328 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_instance_init (DragAndDropHandler * self,
                                     gpointer klass)
{
#line 26 "../src/util/DragAndDropHandler.vala"
	self->priv = drag_and_drop_handler_get_instance_private (self);
#line 43 "../src/util/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 44 "../src/util/DragAndDropHandler.vala"
	self->priv->exporter = NULL;
#line 26 "../src/util/DragAndDropHandler.vala"
	self->ref_count = 1;
#line 1343 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_finalize (DragAndDropHandler * obj)
{
	DragAndDropHandler * self;
	GtkWidget* _tmp0_;
#line 26 "../src/util/DragAndDropHandler.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandler);
#line 26 "../src/util/DragAndDropHandler.vala"
	g_signal_handlers_destroy (self);
#line 75 "../src/util/DragAndDropHandler.vala"
	_tmp0_ = self->priv->event_source;
#line 75 "../src/util/DragAndDropHandler.vala"
	if (_tmp0_ != NULL) {
#line 1359 "DragAndDropHandler.c"
		GtkWidget* _tmp1_;
		guint _tmp2_;
		GtkWidget* _tmp3_;
		guint _tmp4_;
		GtkWidget* _tmp5_;
		guint _tmp6_;
		GtkWidget* _tmp7_;
		guint _tmp8_;
#line 76 "../src/util/DragAndDropHandler.vala"
		_tmp1_ = self->priv->event_source;
#line 76 "../src/util/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-begin", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 76 "../src/util/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin, self);
#line 77 "../src/util/DragAndDropHandler.vala"
		_tmp3_ = self->priv->event_source;
#line 77 "../src/util/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-data-get", gtk_widget_get_type (), &_tmp4_, NULL, FALSE);
#line 77 "../src/util/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get, self);
#line 78 "../src/util/DragAndDropHandler.vala"
		_tmp5_ = self->priv->event_source;
#line 78 "../src/util/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-end", gtk_widget_get_type (), &_tmp6_, NULL, FALSE);
#line 78 "../src/util/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end, self);
#line 79 "../src/util/DragAndDropHandler.vala"
		_tmp7_ = self->priv->event_source;
#line 79 "../src/util/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-failed", gtk_widget_get_type (), &_tmp8_, NULL, FALSE);
#line 79 "../src/util/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed, self);
#line 1392 "DragAndDropHandler.c"
	}
#line 82 "../src/util/DragAndDropHandler.vala"
	self->priv->page = NULL;
#line 83 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 83 "../src/util/DragAndDropHandler.vala"
	self->priv->event_source = NULL;
#line 42 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 43 "../src/util/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 44 "../src/util/DragAndDropHandler.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 1406 "DragAndDropHandler.c"
}

static GType
drag_and_drop_handler_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_drag_and_drop_handler_init, value_drag_and_drop_handler_free_value, value_drag_and_drop_handler_copy_value, value_drag_and_drop_handler_peek_pointer, "p", value_drag_and_drop_handler_collect_value, "p", value_drag_and_drop_handler_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DragAndDropHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drag_and_drop_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DragAndDropHandler), 0, (GInstanceInitFunc) drag_and_drop_handler_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType drag_and_drop_handler_type_id;
	drag_and_drop_handler_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DragAndDropHandler", &g_define_type_info, &g_define_type_fundamental_info, 0);
	DragAndDropHandler_private_offset = g_type_add_instance_private (drag_and_drop_handler_type_id, sizeof (DragAndDropHandlerPrivate));
	return drag_and_drop_handler_type_id;
}

GType
drag_and_drop_handler_get_type (void)
{
	static volatile gsize drag_and_drop_handler_type_id__once = 0;
	if (g_once_init_enter (&drag_and_drop_handler_type_id__once)) {
		GType drag_and_drop_handler_type_id;
		drag_and_drop_handler_type_id = drag_and_drop_handler_get_type_once ();
		g_once_init_leave (&drag_and_drop_handler_type_id__once, drag_and_drop_handler_type_id);
	}
	return drag_and_drop_handler_type_id__once;
}

gpointer
drag_and_drop_handler_ref (gpointer instance)
{
	DragAndDropHandler * self;
	self = instance;
#line 26 "../src/util/DragAndDropHandler.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/util/DragAndDropHandler.vala"
	return instance;
#line 1442 "DragAndDropHandler.c"
}

void
drag_and_drop_handler_unref (gpointer instance)
{
	DragAndDropHandler * self;
	self = instance;
#line 26 "../src/util/DragAndDropHandler.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/util/DragAndDropHandler.vala"
		DRAG_AND_DROP_HANDLER_GET_CLASS (self)->finalize (self);
#line 26 "../src/util/DragAndDropHandler.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1456 "DragAndDropHandler.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

