/* file.c generated by valac 0.56.18, the Vala compiler
 * generated from file.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existence.*/
/**/
/* This function is thread-safe.*/

#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gpointer
_g_error_copy0 (gpointer self)
{
#line 36 "../src/util/file.vala"
	return self ? g_error_copy (self) : NULL;
#line 59 "file.c"
}

gboolean
claim_file (GFile* file,
            GError** error)
{
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 25 "../src/util/file.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 71 "file.c"
	{
		GFileOutputStream* _tmp0_;
		GFileOutputStream* _tmp1_;
#line 27 "../src/util/file.vala"
		_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 27 "../src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 27 "../src/util/file.vala"
		_g_object_unref0 (_tmp1_);
#line 27 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 83 "file.c"
			goto __catch0_g_error;
		}
#line 30 "../src/util/file.vala"
		result = TRUE;
#line 30 "../src/util/file.vala"
		return result;
#line 90 "file.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
#line 26 "../src/util/file.vala"
		err = _inner_error0_;
#line 26 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 33 "../src/util/file.vala"
		_tmp2_ = err;
#line 33 "../src/util/file.vala"
		if (!g_error_matches (_tmp2_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 105 "file.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
			GError* _tmp7_;
			GError* _tmp8_;
#line 34 "../src/util/file.vala"
			_tmp3_ = g_file_get_path (file);
#line 34 "../src/util/file.vala"
			_tmp4_ = _tmp3_;
#line 34 "../src/util/file.vala"
			_tmp5_ = err;
#line 34 "../src/util/file.vala"
			_tmp6_ = _tmp5_->message;
#line 34 "../src/util/file.vala"
			g_warning ("file.vala:34: claim_file %s: %s", _tmp4_, _tmp6_);
#line 34 "../src/util/file.vala"
			_g_free0 (_tmp4_);
#line 36 "../src/util/file.vala"
			_tmp7_ = err;
#line 36 "../src/util/file.vala"
			_tmp8_ = _g_error_copy0 (_tmp7_);
#line 36 "../src/util/file.vala"
			_inner_error0_ = _tmp8_;
#line 36 "../src/util/file.vala"
			_g_error_free0 (err);
#line 132 "file.c"
			goto __finally0;
		}
#line 39 "../src/util/file.vala"
		result = FALSE;
#line 39 "../src/util/file.vala"
		_g_error_free0 (err);
#line 39 "../src/util/file.vala"
		return result;
#line 141 "file.c"
	}
	__finally0:
#line 26 "../src/util/file.vala"
	g_propagate_error (error, _inner_error0_);
#line 26 "../src/util/file.vala"
	return _tmp9_;
#line 148 "file.c"
}

GFile*
generate_unique_file (GFile* dir,
                      const gchar* basename,
                      gboolean* collision,
                      GError** error)
{
	gboolean _vala_collision = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GFile* _tmp2_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 49 "../src/util/file.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 49 "../src/util/file.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 51 "../src/util/file.vala"
	_tmp0_ = g_file_get_child (dir, basename);
#line 51 "../src/util/file.vala"
	file = _tmp0_;
#line 52 "../src/util/file.vala"
	_tmp2_ = file;
#line 52 "../src/util/file.vala"
	_tmp1_ = claim_file (_tmp2_, &_inner_error0_);
#line 52 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 52 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 52 "../src/util/file.vala"
		return NULL;
#line 190 "file.c"
	}
#line 52 "../src/util/file.vala"
	if (_tmp1_) {
#line 53 "../src/util/file.vala"
		_vala_collision = FALSE;
#line 55 "../src/util/file.vala"
		result = file;
#line 55 "../src/util/file.vala"
		if (collision) {
#line 55 "../src/util/file.vala"
			*collision = _vala_collision;
#line 202 "file.c"
		}
#line 55 "../src/util/file.vala"
		return result;
#line 206 "file.c"
	}
#line 59 "../src/util/file.vala"
	_vala_collision = TRUE;
#line 62 "../src/util/file.vala"
	disassemble_filename (basename, &_tmp3_, &_tmp4_);
#line 62 "../src/util/file.vala"
	_g_free0 (name);
#line 62 "../src/util/file.vala"
	name = _tmp3_;
#line 62 "../src/util/file.vala"
	_g_free0 (ext);
#line 62 "../src/util/file.vala"
	ext = _tmp4_;
#line 220 "file.c"
	{
		gint ctr = 0;
#line 65 "../src/util/file.vala"
		ctr = 1;
#line 225 "file.c"
		{
			gboolean _tmp5_ = FALSE;
#line 65 "../src/util/file.vala"
			_tmp5_ = TRUE;
#line 65 "../src/util/file.vala"
			while (TRUE) {
#line 232 "file.c"
				gchar* _tmp7_ = NULL;
				const gchar* _tmp8_;
				gchar* new_name = NULL;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				GFile* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GFile* _tmp18_;
#line 65 "../src/util/file.vala"
				if (!_tmp5_) {
#line 243 "file.c"
					gint _tmp6_;
#line 65 "../src/util/file.vala"
					_tmp6_ = ctr;
#line 65 "../src/util/file.vala"
					ctr = _tmp6_ + 1;
#line 249 "file.c"
				}
#line 65 "../src/util/file.vala"
				_tmp5_ = FALSE;
#line 65 "../src/util/file.vala"
				if (!(ctr < G_MAXINT)) {
#line 65 "../src/util/file.vala"
					break;
#line 257 "file.c"
				}
#line 66 "../src/util/file.vala"
				_tmp8_ = ext;
#line 66 "../src/util/file.vala"
				if (_tmp8_ != NULL) {
#line 263 "file.c"
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 66 "../src/util/file.vala"
					_tmp9_ = name;
#line 66 "../src/util/file.vala"
					_tmp10_ = ext;
#line 66 "../src/util/file.vala"
					_tmp11_ = g_strdup_printf ("%s_%d.%s", _tmp9_, ctr, _tmp10_);
#line 66 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 66 "../src/util/file.vala"
					_tmp7_ = _tmp11_;
#line 277 "file.c"
				} else {
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 66 "../src/util/file.vala"
					_tmp12_ = name;
#line 66 "../src/util/file.vala"
					_tmp13_ = g_strdup_printf ("%s_%d", _tmp12_, ctr);
#line 66 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 66 "../src/util/file.vala"
					_tmp7_ = _tmp13_;
#line 289 "file.c"
				}
#line 66 "../src/util/file.vala"
				_tmp14_ = g_strdup (_tmp7_);
#line 66 "../src/util/file.vala"
				new_name = _tmp14_;
#line 68 "../src/util/file.vala"
				_tmp15_ = new_name;
#line 68 "../src/util/file.vala"
				_tmp16_ = g_file_get_child (dir, _tmp15_);
#line 68 "../src/util/file.vala"
				_g_object_unref0 (file);
#line 68 "../src/util/file.vala"
				file = _tmp16_;
#line 69 "../src/util/file.vala"
				_tmp18_ = file;
#line 69 "../src/util/file.vala"
				_tmp17_ = claim_file (_tmp18_, &_inner_error0_);
#line 69 "../src/util/file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/util/file.vala"
					g_propagate_error (error, _inner_error0_);
#line 69 "../src/util/file.vala"
					_g_free0 (new_name);
#line 69 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 69 "../src/util/file.vala"
					_g_free0 (ext);
#line 69 "../src/util/file.vala"
					_g_free0 (name);
#line 69 "../src/util/file.vala"
					_g_object_unref0 (file);
#line 69 "../src/util/file.vala"
					return NULL;
#line 323 "file.c"
				}
#line 69 "../src/util/file.vala"
				if (_tmp17_) {
#line 70 "../src/util/file.vala"
					result = file;
#line 70 "../src/util/file.vala"
					_g_free0 (new_name);
#line 70 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 70 "../src/util/file.vala"
					_g_free0 (ext);
#line 70 "../src/util/file.vala"
					_g_free0 (name);
#line 70 "../src/util/file.vala"
					if (collision) {
#line 70 "../src/util/file.vala"
						*collision = _vala_collision;
#line 341 "file.c"
					}
#line 70 "../src/util/file.vala"
					return result;
#line 345 "file.c"
				}
#line 65 "../src/util/file.vala"
				_g_free0 (new_name);
#line 65 "../src/util/file.vala"
				_g_free0 (_tmp7_);
#line 351 "file.c"
			}
		}
	}
#line 73 "../src/util/file.vala"
	_tmp19_ = g_file_get_path (dir);
#line 73 "../src/util/file.vala"
	_tmp20_ = _tmp19_;
#line 73 "../src/util/file.vala"
	g_warning ("file.vala:73: generate_unique_filename %s for %s: unable to claim file", _tmp20_, basename);
#line 73 "../src/util/file.vala"
	_g_free0 (_tmp20_);
#line 75 "../src/util/file.vala"
	result = NULL;
#line 75 "../src/util/file.vala"
	_g_free0 (ext);
#line 75 "../src/util/file.vala"
	_g_free0 (name);
#line 75 "../src/util/file.vala"
	_g_object_unref0 (file);
#line 75 "../src/util/file.vala"
	if (collision) {
#line 75 "../src/util/file.vala"
		*collision = _vala_collision;
#line 375 "file.c"
	}
#line 75 "../src/util/file.vala"
	return result;
#line 379 "file.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 402 "file.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 411 "file.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 430 "file.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 434 "file.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 440 "file.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 450 "file.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 458 "file.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 462 "file.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 468 "file.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 478 "file.c"
}

void
disassemble_filename (const gchar* basename,
                      gchar** name,
                      gchar** ext)
{
	gchar* _vala_name = NULL;
	gchar* _vala_ext = NULL;
	glong offset = 0L;
#line 78 "../src/util/file.vala"
	g_return_if_fail (basename != NULL);
#line 79 "../src/util/file.vala"
	offset = find_last_offset (basename, '.');
#line 80 "../src/util/file.vala"
	if (offset <= ((glong) 0)) {
#line 495 "file.c"
		gchar* _tmp0_;
#line 81 "../src/util/file.vala"
		_tmp0_ = g_strdup (basename);
#line 81 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 81 "../src/util/file.vala"
		_vala_name = _tmp0_;
#line 82 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 82 "../src/util/file.vala"
		_vala_ext = NULL;
#line 507 "file.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 84 "../src/util/file.vala"
		_tmp1_ = string_substring (basename, (glong) 0, offset);
#line 84 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 84 "../src/util/file.vala"
		_vala_name = _tmp1_;
#line 85 "../src/util/file.vala"
		_tmp2_ = string_substring (basename, offset + 1, (glong) -1);
#line 85 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 85 "../src/util/file.vala"
		_vala_ext = _tmp2_;
#line 523 "file.c"
	}
#line 78 "../src/util/file.vala"
	if (name) {
#line 78 "../src/util/file.vala"
		*name = _vala_name;
#line 529 "file.c"
	} else {
#line 78 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 533 "file.c"
	}
#line 78 "../src/util/file.vala"
	if (ext) {
#line 78 "../src/util/file.vala"
		*ext = _vala_ext;
#line 539 "file.c"
	} else {
#line 78 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 543 "file.c"
	}
}

guint64
query_total_file_size (GFile* file_or_dir,
                       GCancellable* cancellable,
                       GError** error)
{
	GFileType type = 0;
	GFileEnumerator* enumerator = NULL;
	guint64 total_bytes = 0ULL;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 90 "../src/util/file.vala"
	g_return_val_if_fail (file_or_dir != NULL, 0ULL);
#line 91 "../src/util/file.vala"
	type = g_file_query_file_type (file_or_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 92 "../src/util/file.vala"
	if (type == G_FILE_TYPE_REGULAR) {
#line 564 "file.c"
		GFileInfo* info = NULL;
		GFileInfo* _tmp11_;
#line 93 "../src/util/file.vala"
		info = NULL;
#line 569 "file.c"
		{
			GFileInfo* _tmp0_ = NULL;
			GFileInfo* _tmp1_;
			GFileInfo* _tmp2_;
#line 95 "../src/util/file.vala"
			_tmp1_ = g_file_query_info (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 95 "../src/util/file.vala"
			_tmp0_ = _tmp1_;
#line 95 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 580 "file.c"
				goto __catch0_g_error;
			}
#line 95 "../src/util/file.vala"
			_tmp2_ = _tmp0_;
#line 95 "../src/util/file.vala"
			_tmp0_ = NULL;
#line 95 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 95 "../src/util/file.vala"
			info = _tmp2_;
#line 94 "../src/util/file.vala"
			_g_object_unref0 (_tmp0_);
#line 593 "file.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp3_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 94 "../src/util/file.vala"
			err = _inner_error0_;
#line 94 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 98 "../src/util/file.vala"
			_tmp3_ = err;
#line 98 "../src/util/file.vala"
			if (g_error_matches (_tmp3_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 612 "file.c"
				GError* _tmp4_;
				GError* _tmp5_;
#line 99 "../src/util/file.vala"
				_tmp4_ = err;
#line 99 "../src/util/file.vala"
				_tmp5_ = _g_error_copy0 (_tmp4_);
#line 99 "../src/util/file.vala"
				_inner_error0_ = _tmp5_;
#line 99 "../src/util/file.vala"
				_g_error_free0 (err);
#line 623 "file.c"
				goto __finally0;
			}
#line 101 "../src/util/file.vala"
			_tmp6_ = g_file_get_path (file_or_dir);
#line 101 "../src/util/file.vala"
			_tmp7_ = _tmp6_;
#line 101 "../src/util/file.vala"
			_tmp8_ = err;
#line 101 "../src/util/file.vala"
			_tmp9_ = _tmp8_->message;
#line 101 "../src/util/file.vala"
			g_debug ("file.vala:101: Unable to query filesize for %s: %s", _tmp7_, _tmp9_);
#line 101 "../src/util/file.vala"
			_g_free0 (_tmp7_);
#line 103 "../src/util/file.vala"
			result = (guint64) 0;
#line 103 "../src/util/file.vala"
			_g_error_free0 (err);
#line 103 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 103 "../src/util/file.vala"
			return result;
#line 646 "file.c"
		}
		__finally0:
#line 94 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 651 "file.c"
			guint64 _tmp10_ = 0ULL;
#line 94 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 94 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 94 "../src/util/file.vala"
			return _tmp10_;
#line 659 "file.c"
		}
#line 106 "../src/util/file.vala"
		_tmp11_ = info;
#line 106 "../src/util/file.vala"
		result = (guint64) g_file_info_get_size (_tmp11_);
#line 106 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 106 "../src/util/file.vala"
		return result;
#line 669 "file.c"
	} else {
#line 107 "../src/util/file.vala"
		if (type != G_FILE_TYPE_DIRECTORY) {
#line 108 "../src/util/file.vala"
			result = (guint64) 0;
#line 108 "../src/util/file.vala"
			return result;
#line 677 "file.c"
		}
	}
	{
		GFileEnumerator* _tmp12_ = NULL;
		GFileEnumerator* _tmp13_;
		GFileEnumerator* _tmp14_;
		GFileEnumerator* _tmp15_;
#line 113 "../src/util/file.vala"
		_tmp13_ = g_file_enumerate_children (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 113 "../src/util/file.vala"
		_tmp12_ = _tmp13_;
#line 113 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 691 "file.c"
			goto __catch1_g_error;
		}
#line 113 "../src/util/file.vala"
		_tmp14_ = _tmp12_;
#line 113 "../src/util/file.vala"
		_tmp12_ = NULL;
#line 113 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 113 "../src/util/file.vala"
		enumerator = _tmp14_;
#line 115 "../src/util/file.vala"
		_tmp15_ = enumerator;
#line 115 "../src/util/file.vala"
		if (_tmp15_ == NULL) {
#line 116 "../src/util/file.vala"
			result = (guint64) 0;
#line 116 "../src/util/file.vala"
			_g_object_unref0 (_tmp12_);
#line 116 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 116 "../src/util/file.vala"
			return result;
#line 714 "file.c"
		}
#line 112 "../src/util/file.vala"
		_g_object_unref0 (_tmp12_);
#line 718 "file.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		gboolean _tmp16_ = FALSE;
		GError* _tmp17_;
		GError* _tmp19_;
		GError* _tmp20_;
#line 112 "../src/util/file.vala"
		err = _inner_error0_;
#line 112 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 119 "../src/util/file.vala"
		_tmp17_ = err;
#line 119 "../src/util/file.vala"
		if (g_error_matches (_tmp17_, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 119 "../src/util/file.vala"
			_tmp16_ = TRUE;
#line 738 "file.c"
		} else {
			GError* _tmp18_;
#line 119 "../src/util/file.vala"
			_tmp18_ = err;
#line 119 "../src/util/file.vala"
			_tmp16_ = g_error_matches (_tmp18_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
#line 745 "file.c"
		}
#line 119 "../src/util/file.vala"
		if (_tmp16_) {
#line 120 "../src/util/file.vala"
			result = (guint64) 0;
#line 120 "../src/util/file.vala"
			_g_error_free0 (err);
#line 120 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 120 "../src/util/file.vala"
			return result;
#line 757 "file.c"
		}
#line 122 "../src/util/file.vala"
		_tmp19_ = err;
#line 122 "../src/util/file.vala"
		_tmp20_ = _g_error_copy0 (_tmp19_);
#line 122 "../src/util/file.vala"
		_inner_error0_ = _tmp20_;
#line 122 "../src/util/file.vala"
		_g_error_free0 (err);
#line 767 "file.c"
		goto __finally1;
	}
	__finally1:
#line 112 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 773 "file.c"
		guint64 _tmp21_ = 0ULL;
#line 112 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 112 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 112 "../src/util/file.vala"
		return _tmp21_;
#line 781 "file.c"
	}
#line 125 "../src/util/file.vala"
	total_bytes = (guint64) 0;
#line 127 "../src/util/file.vala"
	info = NULL;
#line 128 "../src/util/file.vala"
	while (TRUE) {
#line 789 "file.c"
		GFileInfo* _tmp22_ = NULL;
		GFileEnumerator* _tmp23_;
		GFileInfo* _tmp24_;
		GFileInfo* _tmp26_;
		GFileInfo* _tmp27_;
		guint64 _tmp28_ = 0ULL;
		GFileInfo* _tmp29_;
		const gchar* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		guint64 _tmp33_;
#line 128 "../src/util/file.vala"
		_tmp23_ = enumerator;
#line 128 "../src/util/file.vala"
		_tmp24_ = g_file_enumerator_next_file (_tmp23_, cancellable, &_inner_error0_);
#line 128 "../src/util/file.vala"
		_tmp22_ = _tmp24_;
#line 128 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 809 "file.c"
			guint64 _tmp25_ = 0ULL;
#line 128 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 128 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 128 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 128 "../src/util/file.vala"
			return _tmp25_;
#line 819 "file.c"
		}
#line 128 "../src/util/file.vala"
		_tmp26_ = _tmp22_;
#line 128 "../src/util/file.vala"
		_tmp22_ = NULL;
#line 128 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 128 "../src/util/file.vala"
		info = _tmp26_;
#line 128 "../src/util/file.vala"
		_tmp27_ = info;
#line 128 "../src/util/file.vala"
		if (!(_tmp27_ != NULL)) {
#line 128 "../src/util/file.vala"
			_g_object_unref0 (_tmp22_);
#line 128 "../src/util/file.vala"
			break;
#line 837 "file.c"
		}
#line 129 "../src/util/file.vala"
		_tmp29_ = info;
#line 129 "../src/util/file.vala"
		_tmp30_ = g_file_info_get_name (_tmp29_);
#line 129 "../src/util/file.vala"
		_tmp31_ = g_file_get_child (file_or_dir, _tmp30_);
#line 129 "../src/util/file.vala"
		_tmp32_ = _tmp31_;
#line 129 "../src/util/file.vala"
		_tmp33_ = query_total_file_size (_tmp32_, cancellable, &_inner_error0_);
#line 129 "../src/util/file.vala"
		_g_object_unref0 (_tmp32_);
#line 129 "../src/util/file.vala"
		_tmp28_ = _tmp33_;
#line 129 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 855 "file.c"
			guint64 _tmp34_ = 0ULL;
#line 129 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 129 "../src/util/file.vala"
			_g_object_unref0 (_tmp22_);
#line 129 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 129 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 129 "../src/util/file.vala"
			return _tmp34_;
#line 867 "file.c"
		}
#line 129 "../src/util/file.vala"
		total_bytes += _tmp28_;
#line 128 "../src/util/file.vala"
		_g_object_unref0 (_tmp22_);
#line 873 "file.c"
	}
#line 131 "../src/util/file.vala"
	result = total_bytes;
#line 131 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 131 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 131 "../src/util/file.vala"
	return result;
#line 883 "file.c"
}

void
delete_all_files (GFile* dir,
                  GeeSet* exceptions,
                  ProgressMonitor monitor,
                  gpointer monitor_target,
                  guint64 file_count,
                  GCancellable* cancellable,
                  GError** error)
{
	GFileType type = 0;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp6_;
	GFileInfo* info = NULL;
	guint64 i = 0ULL;
	GError* _inner_error0_ = NULL;
#line 138 "../src/util/file.vala"
	g_return_if_fail (dir != NULL);
#line 140 "../src/util/file.vala"
	type = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 141 "../src/util/file.vala"
	if (type != G_FILE_TYPE_DIRECTORY) {
#line 907 "file.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 142 "../src/util/file.vala"
		_tmp0_ = g_file_get_path (dir);
#line 142 "../src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 142 "../src/util/file.vala"
		_tmp2_ = g_strdup_printf ("%s is not a directory", _tmp1_);
#line 142 "../src/util/file.vala"
		_tmp3_ = _tmp2_;
#line 142 "../src/util/file.vala"
		_tmp4_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp3_);
#line 142 "../src/util/file.vala"
		_tmp5_ = _tmp4_;
#line 142 "../src/util/file.vala"
		_g_free0 (_tmp3_);
#line 142 "../src/util/file.vala"
		_g_free0 (_tmp1_);
#line 142 "../src/util/file.vala"
		_inner_error0_ = _tmp5_;
#line 142 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 142 "../src/util/file.vala"
		return;
#line 936 "file.c"
	}
#line 144 "../src/util/file.vala"
	_tmp6_ = g_file_enumerate_children (dir, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 144 "../src/util/file.vala"
	enumerator = _tmp6_;
#line 144 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 144 "../src/util/file.vala"
		return;
#line 948 "file.c"
	}
#line 146 "../src/util/file.vala"
	info = NULL;
#line 147 "../src/util/file.vala"
	i = (guint64) 0;
#line 148 "../src/util/file.vala"
	while (TRUE) {
#line 956 "file.c"
		GFileInfo* _tmp7_ = NULL;
		GFileEnumerator* _tmp8_;
		GFileInfo* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		gboolean _tmp13_ = FALSE;
		GFile* file = NULL;
		GFileInfo* _tmp16_;
		const gchar* _tmp17_;
		GFile* _tmp18_;
		gboolean _tmp25_ = FALSE;
#line 148 "../src/util/file.vala"
		_tmp8_ = enumerator;
#line 148 "../src/util/file.vala"
		_tmp9_ = g_file_enumerator_next_file (_tmp8_, cancellable, &_inner_error0_);
#line 148 "../src/util/file.vala"
		_tmp7_ = _tmp9_;
#line 148 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 148 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 148 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 148 "../src/util/file.vala"
			return;
#line 985 "file.c"
		}
#line 148 "../src/util/file.vala"
		_tmp10_ = _tmp7_;
#line 148 "../src/util/file.vala"
		_tmp7_ = NULL;
#line 148 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 148 "../src/util/file.vala"
		info = _tmp10_;
#line 148 "../src/util/file.vala"
		_tmp11_ = info;
#line 148 "../src/util/file.vala"
		if (!(_tmp11_ != NULL)) {
#line 148 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 148 "../src/util/file.vala"
			break;
#line 1003 "file.c"
		}
#line 149 "../src/util/file.vala"
		_tmp12_ = info;
#line 149 "../src/util/file.vala"
		if (g_file_info_get_file_type (_tmp12_) != G_FILE_TYPE_REGULAR) {
#line 150 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 150 "../src/util/file.vala"
			continue;
#line 1013 "file.c"
		}
#line 152 "../src/util/file.vala"
		if (exceptions != NULL) {
#line 1017 "file.c"
			GFileInfo* _tmp14_;
			const gchar* _tmp15_;
#line 152 "../src/util/file.vala"
			_tmp14_ = info;
#line 152 "../src/util/file.vala"
			_tmp15_ = g_file_info_get_name (_tmp14_);
#line 152 "../src/util/file.vala"
			_tmp13_ = gee_collection_contains ((GeeCollection*) exceptions, _tmp15_);
#line 1026 "file.c"
		} else {
#line 152 "../src/util/file.vala"
			_tmp13_ = FALSE;
#line 1030 "file.c"
		}
#line 152 "../src/util/file.vala"
		if (_tmp13_) {
#line 153 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 153 "../src/util/file.vala"
			continue;
#line 1038 "file.c"
		}
#line 155 "../src/util/file.vala"
		_tmp16_ = info;
#line 155 "../src/util/file.vala"
		_tmp17_ = g_file_info_get_name (_tmp16_);
#line 155 "../src/util/file.vala"
		_tmp18_ = g_file_get_child (dir, _tmp17_);
#line 155 "../src/util/file.vala"
		file = _tmp18_;
#line 1048 "file.c"
		{
			GFile* _tmp19_;
#line 157 "../src/util/file.vala"
			_tmp19_ = file;
#line 157 "../src/util/file.vala"
			g_file_delete (_tmp19_, cancellable, &_inner_error0_);
#line 157 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1057 "file.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GFile* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 156 "../src/util/file.vala"
			err = _inner_error0_;
#line 156 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 159 "../src/util/file.vala"
			_tmp20_ = file;
#line 159 "../src/util/file.vala"
			_tmp21_ = g_file_get_path (_tmp20_);
#line 159 "../src/util/file.vala"
			_tmp22_ = _tmp21_;
#line 159 "../src/util/file.vala"
			_tmp23_ = err;
#line 159 "../src/util/file.vala"
			_tmp24_ = _tmp23_->message;
#line 159 "../src/util/file.vala"
			g_warning ("file.vala:159: Unable to delete file %s: %s", _tmp22_, _tmp24_);
#line 159 "../src/util/file.vala"
			_g_free0 (_tmp22_);
#line 156 "../src/util/file.vala"
			_g_error_free0 (err);
#line 1090 "file.c"
		}
		__finally0:
#line 156 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 156 "../src/util/file.vala"
			_g_object_unref0 (file);
#line 156 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 156 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 156 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 156 "../src/util/file.vala"
			return;
#line 1107 "file.c"
		}
#line 162 "../src/util/file.vala"
		if (monitor != NULL) {
#line 162 "../src/util/file.vala"
			_tmp25_ = file_count > ((guint64) 0);
#line 1113 "file.c"
		} else {
#line 162 "../src/util/file.vala"
			_tmp25_ = FALSE;
#line 1117 "file.c"
		}
#line 162 "../src/util/file.vala"
		if (_tmp25_) {
#line 1121 "file.c"
			ProgressMonitor _tmp26_;
			gpointer _tmp26__target;
			guint64 _tmp27_;
			guint64 _tmp28_;
#line 163 "../src/util/file.vala"
			_tmp26_ = monitor;
#line 163 "../src/util/file.vala"
			_tmp26__target = monitor_target;
#line 163 "../src/util/file.vala"
			_tmp27_ = file_count;
#line 163 "../src/util/file.vala"
			i = i + 1;
#line 163 "../src/util/file.vala"
			_tmp28_ = i;
#line 163 "../src/util/file.vala"
			_tmp26_ (_tmp27_, _tmp28_, TRUE, _tmp26__target);
#line 1138 "file.c"
		}
#line 148 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 148 "../src/util/file.vala"
		_g_object_unref0 (_tmp7_);
#line 1144 "file.c"
	}
#line 138 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 138 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 1150 "file.c"
}

gint64
query_file_modified (GFile* file,
                     GError** error)
{
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gint64 _tmp4_;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 167 "../src/util/file.vala"
	g_return_val_if_fail (file != NULL, 0LL);
#line 168 "../src/util/file.vala"
	_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 168 "../src/util/file.vala"
	info = _tmp0_;
#line 168 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1172 "file.c"
		gint64 _tmp1_ = -1LL;
#line 168 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 168 "../src/util/file.vala"
		return _tmp1_;
#line 1178 "file.c"
	}
#line 171 "../src/util/file.vala"
	_tmp2_ = g_file_info_get_modification_date_time (info);
#line 171 "../src/util/file.vala"
	_tmp3_ = _tmp2_;
#line 171 "../src/util/file.vala"
	_tmp4_ = g_date_time_to_unix (_tmp3_);
#line 171 "../src/util/file.vala"
	_g_date_time_unref0 (_tmp3_);
#line 171 "../src/util/file.vala"
	result = _tmp4_;
#line 171 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 171 "../src/util/file.vala"
	return result;
#line 1194 "file.c"
}

gboolean
query_is_directory (GFile* file)
{
	gboolean result;
#line 174 "../src/util/file.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 175 "../src/util/file.vala"
	result = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) == G_FILE_TYPE_DIRECTORY;
#line 175 "../src/util/file.vala"
	return result;
#line 1207 "file.c"
}

gboolean
query_is_directory_empty (GFile* dir,
                          GError** error)
{
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileEnumerator* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_;
	GFileInfo* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 178 "../src/util/file.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 179 "../src/util/file.vala"
	if (g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 180 "../src/util/file.vala"
		result = FALSE;
#line 180 "../src/util/file.vala"
		return result;
#line 1230 "file.c"
	}
#line 182 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 182 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 182 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1238 "file.c"
		gboolean _tmp1_ = FALSE;
#line 182 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 182 "../src/util/file.vala"
		return _tmp1_;
#line 1244 "file.c"
	}
#line 184 "../src/util/file.vala"
	_tmp2_ = enumerator;
#line 184 "../src/util/file.vala"
	if (_tmp2_ == NULL) {
#line 185 "../src/util/file.vala"
		result = FALSE;
#line 185 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 185 "../src/util/file.vala"
		return result;
#line 1256 "file.c"
	}
#line 187 "../src/util/file.vala"
	_tmp4_ = enumerator;
#line 187 "../src/util/file.vala"
	_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 187 "../src/util/file.vala"
	_tmp3_ = _tmp5_;
#line 187 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1266 "file.c"
		gboolean _tmp6_ = FALSE;
#line 187 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 187 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 187 "../src/util/file.vala"
		return _tmp6_;
#line 1274 "file.c"
	}
#line 187 "../src/util/file.vala"
	result = _tmp3_ == NULL;
#line 187 "../src/util/file.vala"
	_g_object_unref0 (_tmp3_);
#line 187 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 187 "../src/util/file.vala"
	return result;
#line 1284 "file.c"
}

gchar*
get_display_pathname (GFile* file)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* home = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* result;
#line 190 "../src/util/file.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 192 "../src/util/file.vala"
	_tmp0_ = g_file_get_parse_name (file);
#line 192 "../src/util/file.vala"
	path = _tmp0_;
#line 193 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 193 "../src/util/file.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 193 "../src/util/file.vala"
	home = _tmp2_;
#line 195 "../src/util/file.vala"
	_tmp3_ = path;
#line 195 "../src/util/file.vala"
	_tmp4_ = home;
#line 195 "../src/util/file.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 1318 "file.c"
		gchar* _tmp5_;
#line 196 "../src/util/file.vala"
		_tmp5_ = g_strdup ("~");
#line 196 "../src/util/file.vala"
		result = _tmp5_;
#line 196 "../src/util/file.vala"
		_g_free0 (home);
#line 196 "../src/util/file.vala"
		_g_free0 (path);
#line 196 "../src/util/file.vala"
		return result;
#line 1330 "file.c"
	}
#line 198 "../src/util/file.vala"
	_tmp6_ = path;
#line 198 "../src/util/file.vala"
	_tmp7_ = home;
#line 198 "../src/util/file.vala"
	if (g_str_has_prefix (_tmp6_, _tmp7_)) {
#line 1338 "file.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 199 "../src/util/file.vala"
		_tmp8_ = path;
#line 199 "../src/util/file.vala"
		_tmp9_ = home;
#line 199 "../src/util/file.vala"
		_tmp10_ = strlen (_tmp9_);
#line 199 "../src/util/file.vala"
		_tmp11_ = _tmp10_;
#line 199 "../src/util/file.vala"
		_tmp12_ = string_substring (_tmp8_, (glong) _tmp11_, (glong) -1);
#line 199 "../src/util/file.vala"
		_tmp13_ = _tmp12_;
#line 199 "../src/util/file.vala"
		_tmp14_ = g_strdup_printf ("~%s", _tmp13_);
#line 199 "../src/util/file.vala"
		_tmp15_ = _tmp14_;
#line 199 "../src/util/file.vala"
		_g_free0 (_tmp13_);
#line 199 "../src/util/file.vala"
		result = _tmp15_;
#line 199 "../src/util/file.vala"
		_g_free0 (home);
#line 199 "../src/util/file.vala"
		_g_free0 (path);
#line 199 "../src/util/file.vala"
		return result;
#line 1373 "file.c"
	}
#line 201 "../src/util/file.vala"
	result = path;
#line 201 "../src/util/file.vala"
	_g_free0 (home);
#line 201 "../src/util/file.vala"
	return result;
#line 1381 "file.c"
}

gchar*
strip_pretty_path (const gchar* path)
{
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 204 "../src/util/file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 205 "../src/util/file.vala"
	if (!g_str_has_prefix (path, "~")) {
#line 1397 "file.c"
		gchar* _tmp0_;
#line 206 "../src/util/file.vala"
		_tmp0_ = g_strdup (path);
#line 206 "../src/util/file.vala"
		result = _tmp0_;
#line 206 "../src/util/file.vala"
		return result;
#line 1405 "file.c"
	}
#line 208 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 208 "../src/util/file.vala"
	_tmp2_ = string_substring (path, (glong) 1, (glong) -1);
#line 208 "../src/util/file.vala"
	_tmp3_ = _tmp2_;
#line 208 "../src/util/file.vala"
	_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 208 "../src/util/file.vala"
	_tmp5_ = _tmp4_;
#line 208 "../src/util/file.vala"
	_g_free0 (_tmp3_);
#line 208 "../src/util/file.vala"
	result = _tmp5_;
#line 208 "../src/util/file.vala"
	return result;
#line 1423 "file.c"
}

gchar*
get_file_info_id (GFileInfo* info)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 211 "../src/util/file.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 212 "../src/util/file.vala"
	_tmp0_ = g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE);
#line 212 "../src/util/file.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 212 "../src/util/file.vala"
	result = _tmp1_;
#line 212 "../src/util/file.vala"
	return result;
#line 1442 "file.c"
}

void
skip_uint64 (GInputStream* input,
             guint64 skip_amount,
             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 216 "../src/util/file.vala"
	g_return_if_fail (input != NULL);
#line 217 "../src/util/file.vala"
	while (TRUE) {
#line 217 "../src/util/file.vala"
		if (!(skip_amount > ((guint64) 0))) {
#line 217 "../src/util/file.vala"
			break;
#line 1459 "file.c"
		}
#line 219 "../src/util/file.vala"
		if (skip_amount >= ((guint64) G_MAXSSIZE)) {
#line 220 "../src/util/file.vala"
			g_input_stream_skip (input, (gsize) G_MAXSSIZE, NULL, &_inner_error0_);
#line 220 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../src/util/file.vala"
				g_propagate_error (error, _inner_error0_);
#line 220 "../src/util/file.vala"
				return;
#line 1471 "file.c"
			}
#line 221 "../src/util/file.vala"
			skip_amount = skip_amount - G_MAXSSIZE;
#line 1475 "file.c"
		} else {
#line 223 "../src/util/file.vala"
			g_input_stream_skip (input, (gsize) skip_amount, NULL, &_inner_error0_);
#line 223 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/util/file.vala"
				g_propagate_error (error, _inner_error0_);
#line 223 "../src/util/file.vala"
				return;
#line 1485 "file.c"
			}
#line 224 "../src/util/file.vala"
			skip_amount = (guint64) 0;
#line 1489 "file.c"
		}
	}
}

guint64
count_files_in_directory (GFile* dir,
                          GError** error)
{
	guint64 count = 0ULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 230 "../src/util/file.vala"
	g_return_val_if_fail (dir != NULL, 0ULL);
#line 231 "../src/util/file.vala"
	if (!query_is_directory (dir)) {
#line 232 "../src/util/file.vala"
		result = (guint64) 0;
#line 232 "../src/util/file.vala"
		return result;
#line 1512 "file.c"
	}
#line 234 "../src/util/file.vala"
	count = (guint64) 0;
#line 235 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 235 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 235 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1522 "file.c"
		guint64 _tmp1_ = 0ULL;
#line 235 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 235 "../src/util/file.vala"
		return _tmp1_;
#line 1528 "file.c"
	}
#line 238 "../src/util/file.vala"
	info = NULL;
#line 239 "../src/util/file.vala"
	while (TRUE) {
#line 1534 "file.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		guint64 _tmp8_;
#line 239 "../src/util/file.vala"
		_tmp3_ = enumerator;
#line 239 "../src/util/file.vala"
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
#line 239 "../src/util/file.vala"
		_tmp2_ = _tmp4_;
#line 239 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1549 "file.c"
			guint64 _tmp5_ = 0ULL;
#line 239 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 239 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 239 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 239 "../src/util/file.vala"
			return _tmp5_;
#line 1559 "file.c"
		}
#line 239 "../src/util/file.vala"
		_tmp6_ = _tmp2_;
#line 239 "../src/util/file.vala"
		_tmp2_ = NULL;
#line 239 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 239 "../src/util/file.vala"
		info = _tmp6_;
#line 239 "../src/util/file.vala"
		_tmp7_ = info;
#line 239 "../src/util/file.vala"
		if (!(_tmp7_ != NULL)) {
#line 239 "../src/util/file.vala"
			_g_object_unref0 (_tmp2_);
#line 239 "../src/util/file.vala"
			break;
#line 1577 "file.c"
		}
#line 240 "../src/util/file.vala"
		_tmp8_ = count;
#line 240 "../src/util/file.vala"
		count = _tmp8_ + 1;
#line 239 "../src/util/file.vala"
		_g_object_unref0 (_tmp2_);
#line 1585 "file.c"
	}
#line 242 "../src/util/file.vala"
	result = count;
#line 242 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 242 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 242 "../src/util/file.vala"
	return result;
#line 1595 "file.c"
}

gboolean
file_equal (GFile* a,
            GFile* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 247 "../src/util/file.vala"
	if (a != NULL) {
#line 247 "../src/util/file.vala"
		_tmp1_ = b != NULL;
#line 1609 "file.c"
	} else {
#line 247 "../src/util/file.vala"
		_tmp1_ = FALSE;
#line 1613 "file.c"
	}
#line 247 "../src/util/file.vala"
	if (_tmp1_) {
#line 247 "../src/util/file.vala"
		_tmp0_ = g_file_equal (a, b);
#line 1619 "file.c"
	} else {
#line 247 "../src/util/file.vala"
		_tmp0_ = FALSE;
#line 1623 "file.c"
	}
#line 247 "../src/util/file.vala"
	result = _tmp0_;
#line 247 "../src/util/file.vala"
	return result;
#line 1629 "file.c"
}

guint
file_hash (GFile* file)
{
	guint _tmp0_ = 0U;
	guint result;
#line 252 "../src/util/file.vala"
	if (file != NULL) {
#line 252 "../src/util/file.vala"
		_tmp0_ = g_file_hash (file);
#line 1641 "file.c"
	} else {
#line 252 "../src/util/file.vala"
		_tmp0_ = (guint) 0;
#line 1645 "file.c"
	}
#line 252 "../src/util/file.vala"
	result = _tmp0_;
#line 252 "../src/util/file.vala"
	return result;
#line 1651 "file.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

