/* image.c generated by valac 0.56.18, the Vala compiler
 * generated from image.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "io.elementary.photos.h"
#include <float.h>
#include <math.h>

#define MIN_SCALED_WIDTH 10
#define MIN_SCALED_HEIGHT 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

VALA_EXTERN void parse_color (const gchar* spec,
                  GdkRGBA* result);
VALA_EXTERN void fetch_color (const gchar* spec,
                  GdkRGBA* result);
VALA_EXTERN void set_source_color_from_string (cairo_t* ctx,
                                   const gchar* spec);
VALA_EXTERN GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf,
                         gint scale,
                         GdkInterpType interp,
                         gboolean scale_up);
VALA_EXTERN GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
VALA_EXTERN guchar shift_color_byte (gint b,
                         gint shift);
VALA_EXTERN gboolean coord_in_rectangle (gint x,
                             gint y,
                             GdkRectangle* rect);
VALA_EXTERN void fix_cairo_pixbuf (GdkPixbuf* pixbuf);
VALA_EXTERN void compute_arb_rotated_size (gdouble src_width,
                               gdouble src_height,
                               gdouble angle,
                               gdouble* dest_width,
                               gdouble* dest_height);
VALA_EXTERN gdouble degrees_to_radians (gdouble theta);
VALA_EXTERN GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf,
                       gdouble angle);
VALA_EXTERN void rotate_point_arb (GdkPoint* source_point,
                       gint img_w,
                       gint img_h,
                       gdouble angle,
                       gboolean invert,
                       GdkPoint* result);
VALA_EXTERN void derotate_point_arb (GdkPoint* source_point,
                         gint img_w,
                         gint img_h,
                         gdouble angle,
                         GdkPoint* result);
VALA_EXTERN void clamp_inside_rotated_image (Box* src,
                                 gint img_w,
                                 gint img_h,
                                 gdouble angle_deg,
                                 gboolean preserve_geom,
                                 Box* result);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

void
parse_color (const gchar* spec,
             GdkRGBA* result)
{
	GdkRGBA _tmp0_ = {0};
#line 20 "../src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 21 "../src/util/image.vala"
	fetch_color (spec, &_tmp0_);
#line 21 "../src/util/image.vala"
	*result = _tmp0_;
#line 21 "../src/util/image.vala"
	return;
#line 114 "image.c"
}

void
fetch_color (const gchar* spec,
             GdkRGBA* result)
{
	GdkRGBA rgba = {0};
#line 24 "../src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 25 "../src/util/image.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 26 "../src/util/image.vala"
	if (!gdk_rgba_parse (&rgba, spec)) {
#line 27 "../src/util/image.vala"
		g_error ("image.vala:27: Can't parse color %s", spec);
#line 130 "image.c"
	}
#line 29 "../src/util/image.vala"
	*result = rgba;
#line 29 "../src/util/image.vala"
	return;
#line 136 "image.c"
}

void
set_source_color_from_string (cairo_t* ctx,
                              const gchar* spec)
{
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_ = {0};
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
	GdkRGBA _tmp4_;
#line 32 "../src/util/image.vala"
	g_return_if_fail (ctx != NULL);
#line 32 "../src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 33 "../src/util/image.vala"
	fetch_color (spec, &_tmp0_);
#line 33 "../src/util/image.vala"
	rgba = _tmp0_;
#line 34 "../src/util/image.vala"
	_tmp1_ = rgba;
#line 34 "../src/util/image.vala"
	_tmp2_ = rgba;
#line 34 "../src/util/image.vala"
	_tmp3_ = rgba;
#line 34 "../src/util/image.vala"
	_tmp4_ = rgba;
#line 34 "../src/util/image.vala"
	cairo_set_source_rgba (ctx, _tmp1_.red, _tmp2_.green, _tmp3_.blue, _tmp4_.alpha);
#line 167 "image.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../src/util/image.vala"
	return self ? g_object_ref (self) : NULL;
#line 175 "image.c"
}

GdkPixbuf*
scale_pixbuf (GdkPixbuf* pixbuf,
              gint scale,
              GdkInterpType interp,
              gboolean scale_up)
{
	Dimensions original = {0};
	Dimensions _tmp0_ = {0};
	Dimensions scaled = {0};
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	Dimensions _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* result;
#line 40 "../src/util/image.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 41 "../src/util/image.vala"
	dimensions_for_pixbuf (pixbuf, &_tmp0_);
#line 41 "../src/util/image.vala"
	original = _tmp0_;
#line 42 "../src/util/image.vala"
	dimensions_get_scaled (&original, scale, scale_up, &_tmp1_);
#line 42 "../src/util/image.vala"
	scaled = _tmp1_;
#line 43 "../src/util/image.vala"
	_tmp3_ = original;
#line 43 "../src/util/image.vala"
	_tmp4_ = scaled;
#line 43 "../src/util/image.vala"
	if (_tmp3_.width == _tmp4_.width) {
#line 212 "image.c"
		Dimensions _tmp5_;
		Dimensions _tmp6_;
#line 43 "../src/util/image.vala"
		_tmp5_ = original;
#line 43 "../src/util/image.vala"
		_tmp6_ = scaled;
#line 43 "../src/util/image.vala"
		_tmp2_ = _tmp5_.height == _tmp6_.height;
#line 221 "image.c"
	} else {
#line 43 "../src/util/image.vala"
		_tmp2_ = FALSE;
#line 225 "image.c"
	}
#line 43 "../src/util/image.vala"
	if (_tmp2_) {
#line 229 "image.c"
		GdkPixbuf* _tmp7_;
#line 44 "../src/util/image.vala"
		_tmp7_ = _g_object_ref0 (pixbuf);
#line 44 "../src/util/image.vala"
		result = _tmp7_;
#line 44 "../src/util/image.vala"
		return result;
#line 237 "image.c"
	}
#line 47 "../src/util/image.vala"
	dimensions_with_min (&scaled, MIN_SCALED_WIDTH, MIN_SCALED_HEIGHT, &_tmp8_);
#line 47 "../src/util/image.vala"
	scaled = _tmp8_;
#line 49 "../src/util/image.vala"
	_tmp9_ = scaled;
#line 49 "../src/util/image.vala"
	_tmp10_ = scaled;
#line 49 "../src/util/image.vala"
	_tmp11_ = gdk_pixbuf_scale_simple (pixbuf, _tmp9_.width, _tmp10_.height, interp);
#line 49 "../src/util/image.vala"
	result = _tmp11_;
#line 49 "../src/util/image.vala"
	return result;
#line 253 "image.c"
}

GdkPixbuf*
resize_pixbuf (GdkPixbuf* pixbuf,
               Dimensions* resized,
               GdkInterpType interp)
{
	Dimensions original = {0};
	Dimensions _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_;
	Dimensions _tmp3_;
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_;
	Dimensions _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* result;
#line 52 "../src/util/image.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 52 "../src/util/image.vala"
	g_return_val_if_fail (resized != NULL, NULL);
#line 53 "../src/util/image.vala"
	dimensions_for_pixbuf (pixbuf, &_tmp0_);
#line 53 "../src/util/image.vala"
	original = _tmp0_;
#line 54 "../src/util/image.vala"
	_tmp2_ = original;
#line 54 "../src/util/image.vala"
	_tmp3_ = *resized;
#line 54 "../src/util/image.vala"
	if (_tmp2_.width == _tmp3_.width) {
#line 285 "image.c"
		Dimensions _tmp4_;
		Dimensions _tmp5_;
#line 54 "../src/util/image.vala"
		_tmp4_ = original;
#line 54 "../src/util/image.vala"
		_tmp5_ = *resized;
#line 54 "../src/util/image.vala"
		_tmp1_ = _tmp4_.height == _tmp5_.height;
#line 294 "image.c"
	} else {
#line 54 "../src/util/image.vala"
		_tmp1_ = FALSE;
#line 298 "image.c"
	}
#line 54 "../src/util/image.vala"
	if (_tmp1_) {
#line 302 "image.c"
		GdkPixbuf* _tmp6_;
#line 55 "../src/util/image.vala"
		_tmp6_ = _g_object_ref0 (pixbuf);
#line 55 "../src/util/image.vala"
		result = _tmp6_;
#line 55 "../src/util/image.vala"
		return result;
#line 310 "image.c"
	}
#line 58 "../src/util/image.vala"
	dimensions_with_min (resized, MIN_SCALED_WIDTH, MIN_SCALED_HEIGHT, &_tmp7_);
#line 58 "../src/util/image.vala"
	*resized = _tmp7_;
#line 60 "../src/util/image.vala"
	_tmp8_ = *resized;
#line 60 "../src/util/image.vala"
	_tmp9_ = *resized;
#line 60 "../src/util/image.vala"
	_tmp10_ = gdk_pixbuf_scale_simple (pixbuf, _tmp8_.width, _tmp9_.height, interp);
#line 60 "../src/util/image.vala"
	result = _tmp10_;
#line 60 "../src/util/image.vala"
	return result;
#line 326 "image.c"
}

inline guchar
shift_color_byte (gint b,
                  gint shift)
{
	guchar result;
#line 64 "../src/util/image.vala"
	result = (guchar) CLAMP (b + shift, 0, 255);
#line 64 "../src/util/image.vala"
	return result;
#line 338 "image.c"
}

void
shift_colors (GdkPixbuf* pixbuf,
              gint red,
              gint green,
              gint blue,
              gint alpha)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint width = 0;
	gint height = 0;
	gint rowstride = 0;
	gint channels = 0;
	guchar* pixels = NULL;
	guint8* _tmp4_;
#line 67 "../src/util/image.vala"
	g_return_if_fail (pixbuf != NULL);
#line 68 "../src/util/image.vala"
	if (red >= -255) {
#line 68 "../src/util/image.vala"
		_tmp0_ = red <= 255;
#line 364 "image.c"
	} else {
#line 68 "../src/util/image.vala"
		_tmp0_ = FALSE;
#line 368 "image.c"
	}
#line 68 "../src/util/image.vala"
	_vala_assert (_tmp0_, "red >= -255 && red <= 255");
#line 69 "../src/util/image.vala"
	if (green >= -255) {
#line 69 "../src/util/image.vala"
		_tmp1_ = green <= 255;
#line 376 "image.c"
	} else {
#line 69 "../src/util/image.vala"
		_tmp1_ = FALSE;
#line 380 "image.c"
	}
#line 69 "../src/util/image.vala"
	_vala_assert (_tmp1_, "green >= -255 && green <= 255");
#line 70 "../src/util/image.vala"
	if (blue >= -255) {
#line 70 "../src/util/image.vala"
		_tmp2_ = blue <= 255;
#line 388 "image.c"
	} else {
#line 70 "../src/util/image.vala"
		_tmp2_ = FALSE;
#line 392 "image.c"
	}
#line 70 "../src/util/image.vala"
	_vala_assert (_tmp2_, "blue >= -255 && blue <= 255");
#line 71 "../src/util/image.vala"
	if (alpha >= -255) {
#line 71 "../src/util/image.vala"
		_tmp3_ = alpha <= 255;
#line 400 "image.c"
	} else {
#line 71 "../src/util/image.vala"
		_tmp3_ = FALSE;
#line 404 "image.c"
	}
#line 71 "../src/util/image.vala"
	_vala_assert (_tmp3_, "alpha >= -255 && alpha <= 255");
#line 73 "../src/util/image.vala"
	width = gdk_pixbuf_get_width (pixbuf);
#line 74 "../src/util/image.vala"
	height = gdk_pixbuf_get_height (pixbuf);
#line 75 "../src/util/image.vala"
	rowstride = gdk_pixbuf_get_rowstride (pixbuf);
#line 76 "../src/util/image.vala"
	channels = gdk_pixbuf_get_n_channels (pixbuf);
#line 77 "../src/util/image.vala"
	_tmp4_ = gdk_pixbuf_get_pixels (pixbuf);
#line 77 "../src/util/image.vala"
	pixels = _tmp4_;
#line 79 "../src/util/image.vala"
	_vala_assert (channels >= 3, "channels >= 3");
#line 80 "../src/util/image.vala"
	_vala_assert (gdk_pixbuf_get_colorspace (pixbuf) == GDK_COLORSPACE_RGB, "pixbuf.get_colorspace () == Gdk.Colorspace.RGB");
#line 81 "../src/util/image.vala"
	_vala_assert (gdk_pixbuf_get_bits_per_sample (pixbuf) == 8, "pixbuf.get_bits_per_sample () == 8");
#line 426 "image.c"
	{
		gint y = 0;
#line 83 "../src/util/image.vala"
		y = 0;
#line 431 "image.c"
		{
			gboolean _tmp5_ = FALSE;
#line 83 "../src/util/image.vala"
			_tmp5_ = TRUE;
#line 83 "../src/util/image.vala"
			while (TRUE) {
#line 438 "image.c"
				gint y_offset = 0;
#line 83 "../src/util/image.vala"
				if (!_tmp5_) {
#line 442 "image.c"
					gint _tmp6_;
#line 83 "../src/util/image.vala"
					_tmp6_ = y;
#line 83 "../src/util/image.vala"
					y = _tmp6_ + 1;
#line 448 "image.c"
				}
#line 83 "../src/util/image.vala"
				_tmp5_ = FALSE;
#line 83 "../src/util/image.vala"
				if (!(y < height)) {
#line 83 "../src/util/image.vala"
					break;
#line 456 "image.c"
				}
#line 84 "../src/util/image.vala"
				y_offset = y * rowstride;
#line 460 "image.c"
				{
					gint x = 0;
#line 86 "../src/util/image.vala"
					x = 0;
#line 465 "image.c"
					{
						gboolean _tmp7_ = FALSE;
#line 86 "../src/util/image.vala"
						_tmp7_ = TRUE;
#line 86 "../src/util/image.vala"
						while (TRUE) {
#line 472 "image.c"
							gint offset = 0;
							gboolean _tmp18_ = FALSE;
#line 86 "../src/util/image.vala"
							if (!_tmp7_) {
#line 477 "image.c"
								gint _tmp8_;
#line 86 "../src/util/image.vala"
								_tmp8_ = x;
#line 86 "../src/util/image.vala"
								x = _tmp8_ + 1;
#line 483 "image.c"
							}
#line 86 "../src/util/image.vala"
							_tmp7_ = FALSE;
#line 86 "../src/util/image.vala"
							if (!(x < width)) {
#line 86 "../src/util/image.vala"
								break;
#line 491 "image.c"
							}
#line 87 "../src/util/image.vala"
							offset = y_offset + (x * channels);
#line 89 "../src/util/image.vala"
							if (red != 0) {
#line 497 "image.c"
								guchar* _tmp9_;
								guchar* _tmp10_;
								guchar _tmp11_;
#line 90 "../src/util/image.vala"
								_tmp9_ = pixels;
#line 90 "../src/util/image.vala"
								_tmp10_ = pixels;
#line 90 "../src/util/image.vala"
								_tmp11_ = _tmp10_[offset];
#line 90 "../src/util/image.vala"
								_tmp9_[offset] = shift_color_byte ((gint) _tmp11_, red);
#line 509 "image.c"
							}
#line 92 "../src/util/image.vala"
							if (green != 0) {
#line 513 "image.c"
								guchar* _tmp12_;
								guchar* _tmp13_;
								guchar _tmp14_;
#line 93 "../src/util/image.vala"
								_tmp12_ = pixels;
#line 93 "../src/util/image.vala"
								_tmp13_ = pixels;
#line 93 "../src/util/image.vala"
								_tmp14_ = _tmp13_[offset + 1];
#line 93 "../src/util/image.vala"
								_tmp12_[offset + 1] = shift_color_byte ((gint) _tmp14_, green);
#line 525 "image.c"
							}
#line 95 "../src/util/image.vala"
							if (blue != 0) {
#line 529 "image.c"
								guchar* _tmp15_;
								guchar* _tmp16_;
								guchar _tmp17_;
#line 96 "../src/util/image.vala"
								_tmp15_ = pixels;
#line 96 "../src/util/image.vala"
								_tmp16_ = pixels;
#line 96 "../src/util/image.vala"
								_tmp17_ = _tmp16_[offset + 2];
#line 96 "../src/util/image.vala"
								_tmp15_[offset + 2] = shift_color_byte ((gint) _tmp17_, blue);
#line 541 "image.c"
							}
#line 98 "../src/util/image.vala"
							if (alpha != 0) {
#line 98 "../src/util/image.vala"
								_tmp18_ = channels >= 4;
#line 547 "image.c"
							} else {
#line 98 "../src/util/image.vala"
								_tmp18_ = FALSE;
#line 551 "image.c"
							}
#line 98 "../src/util/image.vala"
							if (_tmp18_) {
#line 555 "image.c"
								guchar* _tmp19_;
								guchar* _tmp20_;
								guchar _tmp21_;
#line 99 "../src/util/image.vala"
								_tmp19_ = pixels;
#line 99 "../src/util/image.vala"
								_tmp20_ = pixels;
#line 99 "../src/util/image.vala"
								_tmp21_ = _tmp20_[offset + 3];
#line 99 "../src/util/image.vala"
								_tmp19_[offset + 3] = shift_color_byte ((gint) _tmp21_, alpha);
#line 567 "image.c"
							}
						}
					}
				}
			}
		}
	}
}

void
dim_pixbuf (GdkPixbuf* pixbuf)
{
	PixelTransformer* transformer = NULL;
	PixelTransformer* _tmp0_;
	SaturationTransformation* sat = NULL;
	SaturationTransformation* _tmp1_;
#line 104 "../src/util/image.vala"
	g_return_if_fail (pixbuf != NULL);
#line 105 "../src/util/image.vala"
	_tmp0_ = pixel_transformer_new ();
#line 105 "../src/util/image.vala"
	transformer = _tmp0_;
#line 106 "../src/util/image.vala"
	_tmp1_ = saturation_transformation_new (SATURATION_TRANSFORMATION_MIN_PARAMETER);
#line 106 "../src/util/image.vala"
	sat = _tmp1_;
#line 107 "../src/util/image.vala"
	pixel_transformer_attach_transformation (transformer, (PixelTransformation*) sat);
#line 108 "../src/util/image.vala"
	pixel_transformer_transform_pixbuf (transformer, pixbuf, NULL);
#line 109 "../src/util/image.vala"
	shift_colors (pixbuf, 0, 0, 0, -100);
#line 104 "../src/util/image.vala"
	_pixel_transformation_unref0 (sat);
#line 104 "../src/util/image.vala"
	_pixel_transformer_unref0 (transformer);
#line 604 "image.c"
}

gboolean
coord_in_rectangle (gint x,
                    gint y,
                    GdkRectangle* rect)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	gboolean result;
#line 112 "../src/util/image.vala"
	g_return_val_if_fail (rect != NULL, FALSE);
#line 113 "../src/util/image.vala"
	_tmp3_ = *rect;
#line 113 "../src/util/image.vala"
	if (x >= _tmp3_.x) {
#line 623 "image.c"
		GdkRectangle _tmp4_;
		GdkRectangle _tmp5_;
#line 113 "../src/util/image.vala"
		_tmp4_ = *rect;
#line 113 "../src/util/image.vala"
		_tmp5_ = *rect;
#line 113 "../src/util/image.vala"
		_tmp2_ = x < (_tmp4_.x + _tmp5_.width);
#line 632 "image.c"
	} else {
#line 113 "../src/util/image.vala"
		_tmp2_ = FALSE;
#line 636 "image.c"
	}
#line 113 "../src/util/image.vala"
	if (_tmp2_) {
#line 640 "image.c"
		GdkRectangle _tmp6_;
#line 113 "../src/util/image.vala"
		_tmp6_ = *rect;
#line 113 "../src/util/image.vala"
		_tmp1_ = y >= _tmp6_.y;
#line 646 "image.c"
	} else {
#line 113 "../src/util/image.vala"
		_tmp1_ = FALSE;
#line 650 "image.c"
	}
#line 113 "../src/util/image.vala"
	if (_tmp1_) {
#line 654 "image.c"
		GdkRectangle _tmp7_;
		GdkRectangle _tmp8_;
#line 113 "../src/util/image.vala"
		_tmp7_ = *rect;
#line 113 "../src/util/image.vala"
		_tmp8_ = *rect;
#line 113 "../src/util/image.vala"
		_tmp0_ = y <= (_tmp7_.y + _tmp8_.height);
#line 663 "image.c"
	} else {
#line 113 "../src/util/image.vala"
		_tmp0_ = FALSE;
#line 667 "image.c"
	}
#line 113 "../src/util/image.vala"
	result = _tmp0_;
#line 113 "../src/util/image.vala"
	return result;
#line 673 "image.c"
}

gboolean
rectangles_equal (GdkRectangle* a,
                  GdkRectangle* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	gboolean result;
#line 116 "../src/util/image.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 116 "../src/util/image.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 117 "../src/util/image.vala"
	_tmp3_ = *a;
#line 117 "../src/util/image.vala"
	_tmp4_ = *b;
#line 117 "../src/util/image.vala"
	if (_tmp3_.x == _tmp4_.x) {
#line 696 "image.c"
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_;
#line 117 "../src/util/image.vala"
		_tmp5_ = *a;
#line 117 "../src/util/image.vala"
		_tmp6_ = *b;
#line 117 "../src/util/image.vala"
		_tmp2_ = _tmp5_.y == _tmp6_.y;
#line 705 "image.c"
	} else {
#line 117 "../src/util/image.vala"
		_tmp2_ = FALSE;
#line 709 "image.c"
	}
#line 117 "../src/util/image.vala"
	if (_tmp2_) {
#line 713 "image.c"
		GdkRectangle _tmp7_;
		GdkRectangle _tmp8_;
#line 117 "../src/util/image.vala"
		_tmp7_ = *a;
#line 117 "../src/util/image.vala"
		_tmp8_ = *b;
#line 117 "../src/util/image.vala"
		_tmp1_ = _tmp7_.width == _tmp8_.width;
#line 722 "image.c"
	} else {
#line 117 "../src/util/image.vala"
		_tmp1_ = FALSE;
#line 726 "image.c"
	}
#line 117 "../src/util/image.vala"
	if (_tmp1_) {
#line 730 "image.c"
		GdkRectangle _tmp9_;
		GdkRectangle _tmp10_;
#line 117 "../src/util/image.vala"
		_tmp9_ = *a;
#line 117 "../src/util/image.vala"
		_tmp10_ = *b;
#line 117 "../src/util/image.vala"
		_tmp0_ = _tmp9_.height == _tmp10_.height;
#line 739 "image.c"
	} else {
#line 117 "../src/util/image.vala"
		_tmp0_ = FALSE;
#line 743 "image.c"
	}
#line 117 "../src/util/image.vala"
	result = _tmp0_;
#line 117 "../src/util/image.vala"
	return result;
#line 749 "image.c"
}

gchar*
rectangle_to_string (GdkRectangle* rect)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 120 "../src/util/image.vala"
	g_return_val_if_fail (rect != NULL, NULL);
#line 121 "../src/util/image.vala"
	_tmp0_ = *rect;
#line 121 "../src/util/image.vala"
	_tmp1_ = *rect;
#line 121 "../src/util/image.vala"
	_tmp2_ = *rect;
#line 121 "../src/util/image.vala"
	_tmp3_ = *rect;
#line 121 "../src/util/image.vala"
	_tmp4_ = g_strdup_printf ("%d,%d %dx%d", _tmp0_.x, _tmp1_.y, _tmp2_.width, _tmp3_.height);
#line 121 "../src/util/image.vala"
	result = _tmp4_;
#line 121 "../src/util/image.vala"
	return result;
#line 777 "image.c"
}

void
clamp_rectangle (GdkRectangle* original,
                 Dimensions* max,
                 GdkRectangle* result)
{
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_;
	Dimensions _tmp1_;
	GdkRectangle _tmp2_;
	Dimensions _tmp3_;
	GdkRectangle _tmp4_;
	Dimensions _tmp5_;
	GdkRectangle _tmp6_;
	Dimensions _tmp7_;
#line 124 "../src/util/image.vala"
	g_return_if_fail (original != NULL);
#line 124 "../src/util/image.vala"
	g_return_if_fail (max != NULL);
#line 125 "../src/util/image.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 126 "../src/util/image.vala"
	_tmp0_ = *original;
#line 126 "../src/util/image.vala"
	_tmp1_ = *max;
#line 126 "../src/util/image.vala"
	rect.x = CLAMP (_tmp0_.x, 0, _tmp1_.width);
#line 127 "../src/util/image.vala"
	_tmp2_ = *original;
#line 127 "../src/util/image.vala"
	_tmp3_ = *max;
#line 127 "../src/util/image.vala"
	rect.y = CLAMP (_tmp2_.y, 0, _tmp3_.height);
#line 128 "../src/util/image.vala"
	_tmp4_ = *original;
#line 128 "../src/util/image.vala"
	_tmp5_ = *max;
#line 128 "../src/util/image.vala"
	rect.width = CLAMP (_tmp4_.width, 0, _tmp5_.width);
#line 129 "../src/util/image.vala"
	_tmp6_ = *original;
#line 129 "../src/util/image.vala"
	_tmp7_ = *max;
#line 129 "../src/util/image.vala"
	rect.height = CLAMP (_tmp6_.height, 0, _tmp7_.height);
#line 131 "../src/util/image.vala"
	*result = rect;
#line 131 "../src/util/image.vala"
	return;
#line 828 "image.c"
}

void
scale_point (GdkPoint* p,
             gdouble factor,
             GdkPoint* result)
{
	GdkPoint _result_ = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_;
	GdkPoint _tmp2_;
#line 134 "../src/util/image.vala"
	g_return_if_fail (p != NULL);
#line 135 "../src/util/image.vala"
	_tmp0_.x = 0;
#line 135 "../src/util/image.vala"
	_result_ = _tmp0_;
#line 136 "../src/util/image.vala"
	_tmp1_ = *p;
#line 136 "../src/util/image.vala"
	_result_.x = (gint) ((factor * _tmp1_.x) + 0.5);
#line 137 "../src/util/image.vala"
	_tmp2_ = *p;
#line 137 "../src/util/image.vala"
	_result_.y = (gint) ((factor * _tmp2_.y) + 0.5);
#line 139 "../src/util/image.vala"
	*result = _result_;
#line 139 "../src/util/image.vala"
	return;
#line 858 "image.c"
}

void
add_points (GdkPoint* p1,
            GdkPoint* p2,
            GdkPoint* result)
{
	GdkPoint _result_ = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_;
	GdkPoint _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_;
#line 142 "../src/util/image.vala"
	g_return_if_fail (p1 != NULL);
#line 142 "../src/util/image.vala"
	g_return_if_fail (p2 != NULL);
#line 143 "../src/util/image.vala"
	_tmp0_.x = 0;
#line 143 "../src/util/image.vala"
	_result_ = _tmp0_;
#line 144 "../src/util/image.vala"
	_tmp1_ = *p1;
#line 144 "../src/util/image.vala"
	_tmp2_ = *p2;
#line 144 "../src/util/image.vala"
	_result_.x = _tmp1_.x + _tmp2_.x;
#line 145 "../src/util/image.vala"
	_tmp3_ = *p1;
#line 145 "../src/util/image.vala"
	_tmp4_ = *p2;
#line 145 "../src/util/image.vala"
	_result_.y = _tmp3_.y + _tmp4_.y;
#line 147 "../src/util/image.vala"
	*result = _result_;
#line 147 "../src/util/image.vala"
	return;
#line 896 "image.c"
}

void
subtract_points (GdkPoint* p1,
                 GdkPoint* p2,
                 GdkPoint* result)
{
	GdkPoint _result_ = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_;
	GdkPoint _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_;
#line 150 "../src/util/image.vala"
	g_return_if_fail (p1 != NULL);
#line 150 "../src/util/image.vala"
	g_return_if_fail (p2 != NULL);
#line 151 "../src/util/image.vala"
	_tmp0_.x = 0;
#line 151 "../src/util/image.vala"
	_result_ = _tmp0_;
#line 152 "../src/util/image.vala"
	_tmp1_ = *p1;
#line 152 "../src/util/image.vala"
	_tmp2_ = *p2;
#line 152 "../src/util/image.vala"
	_result_.x = _tmp1_.x - _tmp2_.x;
#line 153 "../src/util/image.vala"
	_tmp3_ = *p1;
#line 153 "../src/util/image.vala"
	_tmp4_ = *p2;
#line 153 "../src/util/image.vala"
	_result_.y = _tmp3_.y - _tmp4_.y;
#line 155 "../src/util/image.vala"
	*result = _result_;
#line 155 "../src/util/image.vala"
	return;
#line 934 "image.c"
}

void
fix_cairo_pixbuf (GdkPixbuf* pixbuf)
{
	guchar* gdk_pixels = NULL;
	void* _tmp0_;
	void* _tmp1_;
#line 159 "../src/util/image.vala"
	g_return_if_fail (pixbuf != NULL);
#line 160 "../src/util/image.vala"
	_tmp0_ = gdk_pixbuf_get_pixels (pixbuf);
#line 160 "../src/util/image.vala"
	_tmp1_ = _tmp0_;
#line 160 "../src/util/image.vala"
	gdk_pixels = _tmp1_;
#line 951 "image.c"
	{
		gint j = 0;
#line 161 "../src/util/image.vala"
		j = 0;
#line 956 "image.c"
		{
			gboolean _tmp2_ = FALSE;
#line 161 "../src/util/image.vala"
			_tmp2_ = TRUE;
#line 161 "../src/util/image.vala"
			while (TRUE) {
#line 963 "image.c"
				gint _tmp4_;
				gint _tmp5_;
				guchar* p = NULL;
				guchar* _tmp6_;
				guchar* end = NULL;
				guchar* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				guchar* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 161 "../src/util/image.vala"
				if (!_tmp2_) {
#line 977 "image.c"
					gint _tmp3_;
#line 161 "../src/util/image.vala"
					j = j + 1;
#line 161 "../src/util/image.vala"
					_tmp3_ = j;
#line 983 "image.c"
				}
#line 161 "../src/util/image.vala"
				_tmp2_ = FALSE;
#line 161 "../src/util/image.vala"
				_tmp4_ = gdk_pixbuf_get_height (pixbuf);
#line 161 "../src/util/image.vala"
				_tmp5_ = _tmp4_;
#line 161 "../src/util/image.vala"
				if (!(j < _tmp5_)) {
#line 161 "../src/util/image.vala"
					break;
#line 995 "image.c"
				}
#line 162 "../src/util/image.vala"
				_tmp6_ = gdk_pixels;
#line 162 "../src/util/image.vala"
				p = _tmp6_;
#line 163 "../src/util/image.vala"
				_tmp7_ = p;
#line 163 "../src/util/image.vala"
				_tmp8_ = gdk_pixbuf_get_width (pixbuf);
#line 163 "../src/util/image.vala"
				_tmp9_ = _tmp8_;
#line 163 "../src/util/image.vala"
				end = _tmp7_ + (4 * _tmp9_);
#line 165 "../src/util/image.vala"
				while (TRUE) {
#line 1011 "image.c"
					guchar* _tmp10_;
					guchar* _tmp11_;
					guchar tmp = '\0';
					guchar* _tmp12_;
					guchar _tmp13_;
					guchar* _tmp14_;
					guchar* _tmp15_;
					guchar _tmp16_;
					guchar* _tmp17_;
					guchar* _tmp18_;
#line 165 "../src/util/image.vala"
					_tmp10_ = p;
#line 165 "../src/util/image.vala"
					_tmp11_ = end;
#line 165 "../src/util/image.vala"
					if (!(_tmp10_ < _tmp11_)) {
#line 165 "../src/util/image.vala"
						break;
#line 1030 "image.c"
					}
#line 166 "../src/util/image.vala"
					_tmp12_ = p;
#line 166 "../src/util/image.vala"
					_tmp13_ = _tmp12_[0];
#line 166 "../src/util/image.vala"
					tmp = _tmp13_;
#line 168 "../src/util/image.vala"
					_tmp14_ = p;
#line 168 "../src/util/image.vala"
					_tmp15_ = p;
#line 168 "../src/util/image.vala"
					_tmp16_ = _tmp15_[2];
#line 168 "../src/util/image.vala"
					_tmp14_[0] = _tmp16_;
#line 169 "../src/util/image.vala"
					_tmp17_ = p;
#line 169 "../src/util/image.vala"
					_tmp17_[2] = tmp;
#line 176 "../src/util/image.vala"
					_tmp18_ = p;
#line 176 "../src/util/image.vala"
					p = _tmp18_ + 4;
#line 1054 "image.c"
				}
#line 179 "../src/util/image.vala"
				_tmp19_ = gdk_pixels;
#line 179 "../src/util/image.vala"
				_tmp20_ = gdk_pixbuf_get_rowstride (pixbuf);
#line 179 "../src/util/image.vala"
				_tmp21_ = _tmp20_;
#line 179 "../src/util/image.vala"
				gdk_pixels = _tmp19_ + _tmp21_;
#line 1064 "image.c"
			}
		}
	}
}

/**
 * Finds the size of the smallest axially-aligned rectangle that could contain
 * a rectangle src_width by src_height, rotated by angle.
 *
 * @param src_width The width of the incoming rectangle.
 * @param src_height The height of the incoming rectangle.
 * @param angle The amount to rotate by, given in degrees.
 * @param dest_width The width of the computed rectangle.
 * @param dest_height The height of the computed rectangle.
 */
void
compute_arb_rotated_size (gdouble src_width,
                          gdouble src_height,
                          gdouble angle,
                          gdouble* dest_width,
                          gdouble* dest_height)
{
	gdouble _vala_dest_width = 0.0;
	gdouble _vala_dest_height = 0.0;
#line 196 "../src/util/image.vala"
	angle = fabs (degrees_to_radians (angle));
#line 197 "../src/util/image.vala"
	_vala_assert (angle <= G_PI_2, "angle <= Math.PI_2");
#line 198 "../src/util/image.vala"
	_vala_dest_width = (src_width * cos (angle)) + (src_height * sin (angle));
#line 199 "../src/util/image.vala"
	_vala_dest_height = (src_height * cos (angle)) + (src_width * sin (angle));
#line 193 "../src/util/image.vala"
	if (dest_width) {
#line 193 "../src/util/image.vala"
		*dest_width = _vala_dest_width;
#line 1101 "image.c"
	}
#line 193 "../src/util/image.vala"
	if (dest_height) {
#line 193 "../src/util/image.vala"
		*dest_height = _vala_dest_height;
#line 1107 "image.c"
	}
}

/**
 * Rotates a pixbuf to an arbitrary angle, given in degrees, and returns the rotated pixbuf.
 *
 * @param source_pixbuf The source image that needs to be angled.
 * @param angle The angle the source image should be rotated by.
 */
GdkPixbuf*
rotate_arb (GdkPixbuf* source_pixbuf,
            gdouble angle)
{
	gdouble x_tmp = 0.0;
	gdouble y_tmp = 0.0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	GdkPixbuf* dest_pixbuf = NULL;
	GdkPixbuf* _tmp7_;
	cairo_format_t _tmp8_ = 0;
	gboolean _tmp9_;
	gboolean _tmp10_;
	cairo_surface_t* surface = NULL;
	GdkPixbuf* _tmp11_;
	void* _tmp12_;
	void* _tmp13_;
	GdkPixbuf* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GdkPixbuf* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	GdkPixbuf* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	cairo_surface_t* _tmp23_;
	cairo_t* context = NULL;
	cairo_surface_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	GdkPixbuf* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	GdkPixbuf* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	cairo_t* _tmp34_;
	cairo_t* _tmp35_;
	GdkPixbuf* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	GdkPixbuf* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	cairo_t* _tmp48_;
	cairo_t* _tmp49_;
	cairo_pattern_t* _tmp50_;
	cairo_t* _tmp51_;
	GdkPixbuf* _tmp52_;
	GdkPixbuf* result;
#line 208 "../src/util/image.vala"
	g_return_val_if_fail (source_pixbuf != NULL, NULL);
#line 212 "../src/util/image.vala"
	if (angle == 0.0) {
#line 1183 "image.c"
		GdkPixbuf* _tmp0_;
#line 213 "../src/util/image.vala"
		_tmp0_ = _g_object_ref0 (source_pixbuf);
#line 213 "../src/util/image.vala"
		result = _tmp0_;
#line 213 "../src/util/image.vala"
		return result;
#line 1191 "image.c"
	}
#line 220 "../src/util/image.vala"
	_tmp1_ = gdk_pixbuf_get_width (source_pixbuf);
#line 220 "../src/util/image.vala"
	_tmp2_ = _tmp1_;
#line 220 "../src/util/image.vala"
	_tmp3_ = gdk_pixbuf_get_height (source_pixbuf);
#line 220 "../src/util/image.vala"
	_tmp4_ = _tmp3_;
#line 220 "../src/util/image.vala"
	compute_arb_rotated_size ((gdouble) _tmp2_, (gdouble) _tmp4_, angle, &_tmp5_, &_tmp6_);
#line 220 "../src/util/image.vala"
	x_tmp = _tmp5_;
#line 220 "../src/util/image.vala"
	y_tmp = _tmp6_;
#line 223 "../src/util/image.vala"
	_tmp7_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, (gint) round (x_tmp), (gint) round (y_tmp));
#line 223 "../src/util/image.vala"
	dest_pixbuf = _tmp7_;
#line 228 "../src/util/image.vala"
	_tmp9_ = gdk_pixbuf_get_has_alpha (source_pixbuf);
#line 228 "../src/util/image.vala"
	_tmp10_ = _tmp9_;
#line 228 "../src/util/image.vala"
	if (_tmp10_) {
#line 228 "../src/util/image.vala"
		_tmp8_ = CAIRO_FORMAT_ARGB32;
#line 1219 "image.c"
	} else {
#line 228 "../src/util/image.vala"
		_tmp8_ = CAIRO_FORMAT_RGB24;
#line 1223 "image.c"
	}
#line 226 "../src/util/image.vala"
	_tmp11_ = dest_pixbuf;
#line 226 "../src/util/image.vala"
	_tmp12_ = gdk_pixbuf_get_pixels (_tmp11_);
#line 226 "../src/util/image.vala"
	_tmp13_ = _tmp12_;
#line 226 "../src/util/image.vala"
	_tmp14_ = dest_pixbuf;
#line 226 "../src/util/image.vala"
	_tmp15_ = gdk_pixbuf_get_width (_tmp14_);
#line 226 "../src/util/image.vala"
	_tmp16_ = _tmp15_;
#line 226 "../src/util/image.vala"
	_tmp17_ = dest_pixbuf;
#line 226 "../src/util/image.vala"
	_tmp18_ = gdk_pixbuf_get_height (_tmp17_);
#line 226 "../src/util/image.vala"
	_tmp19_ = _tmp18_;
#line 226 "../src/util/image.vala"
	_tmp20_ = dest_pixbuf;
#line 226 "../src/util/image.vala"
	_tmp21_ = gdk_pixbuf_get_rowstride (_tmp20_);
#line 226 "../src/util/image.vala"
	_tmp22_ = _tmp21_;
#line 226 "../src/util/image.vala"
	_tmp23_ = cairo_image_surface_create_for_data ((guchar*) _tmp13_, _tmp8_, _tmp16_, _tmp19_, _tmp22_);
#line 226 "../src/util/image.vala"
	surface = _tmp23_;
#line 231 "../src/util/image.vala"
	_tmp24_ = surface;
#line 231 "../src/util/image.vala"
	_tmp25_ = cairo_create (_tmp24_);
#line 231 "../src/util/image.vala"
	context = _tmp25_;
#line 233 "../src/util/image.vala"
	_tmp26_ = context;
#line 233 "../src/util/image.vala"
	cairo_set_source_rgb (_tmp26_, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 234 "../src/util/image.vala"
	_tmp27_ = context;
#line 234 "../src/util/image.vala"
	_tmp28_ = dest_pixbuf;
#line 234 "../src/util/image.vala"
	_tmp29_ = gdk_pixbuf_get_width (_tmp28_);
#line 234 "../src/util/image.vala"
	_tmp30_ = _tmp29_;
#line 234 "../src/util/image.vala"
	_tmp31_ = dest_pixbuf;
#line 234 "../src/util/image.vala"
	_tmp32_ = gdk_pixbuf_get_height (_tmp31_);
#line 234 "../src/util/image.vala"
	_tmp33_ = _tmp32_;
#line 234 "../src/util/image.vala"
	cairo_rectangle (_tmp27_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp30_, (gdouble) _tmp33_);
#line 235 "../src/util/image.vala"
	_tmp34_ = context;
#line 235 "../src/util/image.vala"
	cairo_fill (_tmp34_);
#line 237 "../src/util/image.vala"
	_tmp35_ = context;
#line 237 "../src/util/image.vala"
	_tmp36_ = dest_pixbuf;
#line 237 "../src/util/image.vala"
	_tmp37_ = gdk_pixbuf_get_width (_tmp36_);
#line 237 "../src/util/image.vala"
	_tmp38_ = _tmp37_;
#line 237 "../src/util/image.vala"
	_tmp39_ = dest_pixbuf;
#line 237 "../src/util/image.vala"
	_tmp40_ = gdk_pixbuf_get_height (_tmp39_);
#line 237 "../src/util/image.vala"
	_tmp41_ = _tmp40_;
#line 237 "../src/util/image.vala"
	cairo_translate (_tmp35_, (gdouble) (_tmp38_ / 2), (gdouble) (_tmp41_ / 2));
#line 238 "../src/util/image.vala"
	_tmp42_ = context;
#line 238 "../src/util/image.vala"
	cairo_rotate (_tmp42_, degrees_to_radians (angle));
#line 239 "../src/util/image.vala"
	_tmp43_ = context;
#line 239 "../src/util/image.vala"
	_tmp44_ = gdk_pixbuf_get_width (source_pixbuf);
#line 239 "../src/util/image.vala"
	_tmp45_ = _tmp44_;
#line 239 "../src/util/image.vala"
	_tmp46_ = gdk_pixbuf_get_height (source_pixbuf);
#line 239 "../src/util/image.vala"
	_tmp47_ = _tmp46_;
#line 239 "../src/util/image.vala"
	cairo_translate (_tmp43_, (gdouble) ((-_tmp45_) / 2), (gdouble) ((-_tmp47_) / 2));
#line 241 "../src/util/image.vala"
	_tmp48_ = context;
#line 241 "../src/util/image.vala"
	gdk_cairo_set_source_pixbuf (_tmp48_, source_pixbuf, (gdouble) 0, (gdouble) 0);
#line 242 "../src/util/image.vala"
	_tmp49_ = context;
#line 242 "../src/util/image.vala"
	_tmp50_ = cairo_get_source (_tmp49_);
#line 242 "../src/util/image.vala"
	cairo_pattern_set_filter (_tmp50_, CAIRO_FILTER_BEST);
#line 243 "../src/util/image.vala"
	_tmp51_ = context;
#line 243 "../src/util/image.vala"
	cairo_paint (_tmp51_);
#line 247 "../src/util/image.vala"
	_tmp52_ = dest_pixbuf;
#line 247 "../src/util/image.vala"
	fix_cairo_pixbuf (_tmp52_);
#line 249 "../src/util/image.vala"
	result = dest_pixbuf;
#line 249 "../src/util/image.vala"
	_cairo_destroy0 (context);
#line 249 "../src/util/image.vala"
	_cairo_surface_destroy0 (surface);
#line 249 "../src/util/image.vala"
	return result;
#line 1341 "image.c"
}

/**
 * Rotates a point around the upper left corner of an image to an arbitrary angle,
 * given in degrees, and returns the rotated point, translated such that it, along with its attendant
 * image, are in positive x, positive y.
 *
 * Note: May be subject to slight inaccuracy as Gdk points' coordinates may only be in whole pixels,
 * so the fractional component is lost.
 *
 * @param source_point The point to be rotated and scaled.
 * @param img_w The width of the source image (unrotated).
 * @param img_h The height of the source image (unrotated).
 * @param angle The angle the source image is to be rotated by to straighten it.
 */
void
rotate_point_arb (GdkPoint* source_point,
                  gint img_w,
                  gint img_h,
                  gdouble angle,
                  gboolean invert,
                  GdkPoint* result)
{
	gdouble dest_width = 0.0;
	gdouble dest_height = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	cairo_matrix_t matrix = {0};
	gdouble dest_x = 0.0;
	GdkPoint _tmp3_;
	gdouble dest_y = 0.0;
	GdkPoint _tmp4_;
	GdkPoint _tmp5_ = {0};
#line 265 "../src/util/image.vala"
	g_return_if_fail (source_point != NULL);
#line 268 "../src/util/image.vala"
	if (angle == 0.0) {
#line 1379 "image.c"
		GdkPoint _tmp0_;
#line 270 "../src/util/image.vala"
		_tmp0_ = *source_point;
#line 270 "../src/util/image.vala"
		*result = _tmp0_;
#line 270 "../src/util/image.vala"
		return;
#line 1387 "image.c"
	}
#line 275 "../src/util/image.vala"
	compute_arb_rotated_size ((gdouble) img_w, (gdouble) img_h, angle, &_tmp1_, &_tmp2_);
#line 275 "../src/util/image.vala"
	dest_width = _tmp1_;
#line 275 "../src/util/image.vala"
	dest_height = _tmp2_;
#line 277 "../src/util/image.vala"
	cairo_matrix_init_identity (&matrix);
#line 278 "../src/util/image.vala"
	cairo_matrix_translate (&matrix, dest_width / 2, dest_height / 2);
#line 279 "../src/util/image.vala"
	cairo_matrix_rotate (&matrix, degrees_to_radians (angle));
#line 280 "../src/util/image.vala"
	cairo_matrix_translate (&matrix, (gdouble) ((-img_w) / 2), (gdouble) ((-img_h) / 2));
#line 281 "../src/util/image.vala"
	if (invert) {
#line 282 "../src/util/image.vala"
		_vala_assert (cairo_matrix_invert (&matrix) == CAIRO_STATUS_SUCCESS, "matrix.invert () == Cairo.Status.SUCCESS");
#line 1407 "image.c"
	}
#line 284 "../src/util/image.vala"
	_tmp3_ = *source_point;
#line 284 "../src/util/image.vala"
	dest_x = (gdouble) _tmp3_.x;
#line 285 "../src/util/image.vala"
	_tmp4_ = *source_point;
#line 285 "../src/util/image.vala"
	dest_y = (gdouble) _tmp4_.y;
#line 286 "../src/util/image.vala"
	cairo_matrix_transform_point (&matrix, &dest_x, &dest_y);
#line 288 "../src/util/image.vala"
	_tmp5_.x = (gint) dest_x;
#line 288 "../src/util/image.vala"
	_tmp5_.y = (gint) dest_y;
#line 288 "../src/util/image.vala"
	*result = _tmp5_;
#line 288 "../src/util/image.vala"
	return;
#line 1427 "image.c"
}

/**
 * <u>De</u>rotates a point around the upper left corner of an image from an arbitrary angle,
 * given in degrees, and returns the de-rotated point, taking into account any translation necessary
 * to make sure all of the rotated image stays in positive x, positive y.
 *
 * Note: May be subject to slight inaccuracy as Gdk points' coordinates may only be in whole pixels,
 * so the fractional component is lost.
 *
 * @param source_point The point to be de-rotated.
 * @param img_w The width of the source image (unrotated).
 * @param img_h The height of the source image (unrotated).
 * @param angle The angle the source image is to be rotated by to straighten it.
 */
void
derotate_point_arb (GdkPoint* source_point,
                    gint img_w,
                    gint img_h,
                    gdouble angle,
                    GdkPoint* result)
{
	GdkPoint _tmp0_;
	GdkPoint _tmp1_ = {0};
#line 304 "../src/util/image.vala"
	g_return_if_fail (source_point != NULL);
#line 305 "../src/util/image.vala"
	_tmp0_ = *source_point;
#line 305 "../src/util/image.vala"
	rotate_point_arb (&_tmp0_, img_w, img_h, angle, TRUE, &_tmp1_);
#line 305 "../src/util/image.vala"
	*result = _tmp1_;
#line 305 "../src/util/image.vala"
	return;
#line 1462 "image.c"
}

void
clamp_inside_rotated_image (Box* src,
                            gint img_w,
                            gint img_h,
                            gdouble angle_deg,
                            gboolean preserve_geom,
                            Box* result)
{
	GdkPoint top_left = {0};
	Box _tmp0_;
	Box _tmp1_;
	GdkPoint _tmp2_ = {0};
	GdkPoint _tmp3_ = {0};
	GdkPoint top_right = {0};
	Box _tmp4_;
	Box _tmp5_;
	GdkPoint _tmp6_ = {0};
	GdkPoint _tmp7_ = {0};
	GdkPoint bottom_left = {0};
	Box _tmp8_;
	Box _tmp9_;
	GdkPoint _tmp10_ = {0};
	GdkPoint _tmp11_ = {0};
	GdkPoint bottom_right = {0};
	Box _tmp12_;
	Box _tmp13_;
	GdkPoint _tmp14_ = {0};
	GdkPoint _tmp15_ = {0};
	gdouble angle = 0.0;
	gint top_offset = 0;
	gint bottom_offset = 0;
	gint left_offset = 0;
	gint right_offset = 0;
	gint top = 0;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
	gint bottom = 0;
	GdkPoint _tmp18_;
	GdkPoint _tmp19_;
	gint left = 0;
	GdkPoint _tmp20_;
	GdkPoint _tmp21_;
	gint right = 0;
	GdkPoint _tmp22_;
	GdkPoint _tmp23_;
	Box _tmp24_ = {0};
#line 310 "../src/util/image.vala"
	g_return_if_fail (src != NULL);
#line 313 "../src/util/image.vala"
	_tmp0_ = *src;
#line 313 "../src/util/image.vala"
	_tmp1_ = *src;
#line 313 "../src/util/image.vala"
	_tmp2_.x = _tmp0_.left;
#line 313 "../src/util/image.vala"
	_tmp2_.y = _tmp1_.top;
#line 313 "../src/util/image.vala"
	derotate_point_arb (&_tmp2_, img_w, img_h, angle_deg, &_tmp3_);
#line 313 "../src/util/image.vala"
	top_left = _tmp3_;
#line 314 "../src/util/image.vala"
	_tmp4_ = *src;
#line 314 "../src/util/image.vala"
	_tmp5_ = *src;
#line 314 "../src/util/image.vala"
	_tmp6_.x = _tmp4_.right;
#line 314 "../src/util/image.vala"
	_tmp6_.y = _tmp5_.top;
#line 314 "../src/util/image.vala"
	derotate_point_arb (&_tmp6_, img_w, img_h, angle_deg, &_tmp7_);
#line 314 "../src/util/image.vala"
	top_right = _tmp7_;
#line 315 "../src/util/image.vala"
	_tmp8_ = *src;
#line 315 "../src/util/image.vala"
	_tmp9_ = *src;
#line 315 "../src/util/image.vala"
	_tmp10_.x = _tmp8_.left;
#line 315 "../src/util/image.vala"
	_tmp10_.y = _tmp9_.bottom;
#line 315 "../src/util/image.vala"
	derotate_point_arb (&_tmp10_, img_w, img_h, angle_deg, &_tmp11_);
#line 315 "../src/util/image.vala"
	bottom_left = _tmp11_;
#line 316 "../src/util/image.vala"
	_tmp12_ = *src;
#line 316 "../src/util/image.vala"
	_tmp13_ = *src;
#line 316 "../src/util/image.vala"
	_tmp14_.x = _tmp12_.right;
#line 316 "../src/util/image.vala"
	_tmp14_.y = _tmp13_.bottom;
#line 316 "../src/util/image.vala"
	derotate_point_arb (&_tmp14_, img_w, img_h, angle_deg, &_tmp15_);
#line 316 "../src/util/image.vala"
	bottom_right = _tmp15_;
#line 318 "../src/util/image.vala"
	angle = degrees_to_radians (angle_deg);
#line 319 "../src/util/image.vala"
	top_offset = 0;
#line 319 "../src/util/image.vala"
	bottom_offset = 0;
#line 319 "../src/util/image.vala"
	left_offset = 0;
#line 319 "../src/util/image.vala"
	right_offset = 0;
#line 321 "../src/util/image.vala"
	_tmp16_ = top_left;
#line 321 "../src/util/image.vala"
	_tmp17_ = top_right;
#line 321 "../src/util/image.vala"
	top = MIN (_tmp16_.y, _tmp17_.y);
#line 322 "../src/util/image.vala"
	if (top < 0) {
#line 323 "../src/util/image.vala"
		top_offset = (gint) ((0 - top) * cos (angle));
#line 1581 "image.c"
	}
#line 325 "../src/util/image.vala"
	_tmp18_ = bottom_left;
#line 325 "../src/util/image.vala"
	_tmp19_ = bottom_right;
#line 325 "../src/util/image.vala"
	bottom = MAX (_tmp18_.y, _tmp19_.y);
#line 326 "../src/util/image.vala"
	if (bottom > img_h) {
#line 327 "../src/util/image.vala"
		bottom_offset = (gint) ((img_h - bottom) * cos (angle));
#line 1593 "image.c"
	}
#line 329 "../src/util/image.vala"
	_tmp20_ = top_left;
#line 329 "../src/util/image.vala"
	_tmp21_ = bottom_left;
#line 329 "../src/util/image.vala"
	left = MIN (_tmp20_.x, _tmp21_.x);
#line 330 "../src/util/image.vala"
	if (left < 0) {
#line 331 "../src/util/image.vala"
		left_offset = (gint) ((0 - left) * cos (angle));
#line 1605 "image.c"
	}
#line 333 "../src/util/image.vala"
	_tmp22_ = top_right;
#line 333 "../src/util/image.vala"
	_tmp23_ = bottom_right;
#line 333 "../src/util/image.vala"
	right = MAX (_tmp22_.x, _tmp23_.x);
#line 334 "../src/util/image.vala"
	if (right > img_w) {
#line 335 "../src/util/image.vala"
		right_offset = (gint) ((img_w - right) * cos (angle));
#line 1617 "image.c"
	}
#line 337 "../src/util/image.vala"
	if (preserve_geom) {
#line 1621 "image.c"
		Box _tmp25_ = {0};
#line 337 "../src/util/image.vala"
		box_get_offset (src, left_offset + right_offset, top_offset + bottom_offset, &_tmp25_);
#line 337 "../src/util/image.vala"
		_tmp24_ = _tmp25_;
#line 1627 "image.c"
	} else {
		Box _tmp26_;
		Box _tmp27_;
		Box _tmp28_;
		Box _tmp29_;
#line 338 "../src/util/image.vala"
		_tmp26_ = *src;
#line 338 "../src/util/image.vala"
		_tmp27_ = *src;
#line 338 "../src/util/image.vala"
		_tmp28_ = *src;
#line 338 "../src/util/image.vala"
		_tmp29_ = *src;
#line 338 "../src/util/image.vala"
		box_init (&_tmp24_, _tmp26_.left + left_offset, _tmp27_.top + top_offset, _tmp28_.right + right_offset, _tmp29_.bottom + bottom_offset);
#line 1643 "image.c"
	}
#line 337 "../src/util/image.vala"
	*result = _tmp24_;
#line 337 "../src/util/image.vala"
	return;
#line 1649 "image.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

