/* CheckerboardLayout.c generated by valac 0.56.18, the Vala compiler
 * generated from CheckerboardLayout.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <granite.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>
#include <gobject/gvaluecollector.h>

#define CHECKERBOARD_LAYOUT_SCROLLBAR_PLACEHOLDER_WIDTH 1
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW (checkerboard_layout_layout_row_get_type ())
#define CHECKERBOARD_LAYOUT_LAYOUT_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW, CheckerboardLayoutLayoutRow))
#define CHECKERBOARD_LAYOUT_LAYOUT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW, CheckerboardLayoutLayoutRowClass))
#define CHECKERBOARD_LAYOUT_IS_LAYOUT_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW))
#define CHECKERBOARD_LAYOUT_IS_LAYOUT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW))
#define CHECKERBOARD_LAYOUT_LAYOUT_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW, CheckerboardLayoutLayoutRowClass))

typedef struct _CheckerboardLayoutLayoutRow CheckerboardLayoutLayoutRow;
typedef struct _CheckerboardLayoutLayoutRowClass CheckerboardLayoutLayoutRowClass;
enum  {
	CHECKERBOARD_LAYOUT_0_PROPERTY,
	CHECKERBOARD_LAYOUT_NUM_PROPERTIES
};
static GParamSpec* checkerboard_layout_properties[CHECKERBOARD_LAYOUT_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _CheckerboardLayoutLayoutRowPrivate CheckerboardLayoutLayoutRowPrivate;
#define _checkerboard_layout_layout_row_unref0(var) ((var == NULL) ? NULL : (var = (checkerboard_layout_layout_row_unref (var), NULL)))
#define _gtk_widget_path_unref0(var) ((var == NULL) ? NULL : (var = (gtk_widget_path_unref (var), NULL)))
typedef struct _CheckerboardLayoutParamSpecLayoutRow CheckerboardLayoutParamSpecLayoutRow;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _CheckerboardLayoutPrivate {
	ViewCollection* view;
	gchar* page_name;
	CheckerboardLayoutLayoutRow** item_rows;
	gint item_rows_length1;
	gint _item_rows_size_;
	GeeHashSet* exposed_items;
	GtkAdjustment* hadjustment;
	GtkAdjustment* vadjustment;
	gchar* message;
	GdkRectangle visible_page;
	gint last_width;
	gint columns;
	gint rows;
	GdkPoint drag_origin;
	GdkPoint drag_endpoint;
	GdkRectangle selection_band;
	gint scale;
	gboolean flow_scheduled;
	gboolean exposure_dirty;
	CheckerboardItem* anchor;
	gboolean in_center_on_anchor;
	gboolean size_allocate_due_to_reflow;
	gboolean is_in_view;
	gboolean reflow_needed;
};

struct _CheckerboardLayoutLayoutRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CheckerboardLayoutLayoutRowPrivate * priv;
	gint y;
	gint height;
	CheckerboardItem** items;
	gint items_length1;
	gint _items_size_;
};

struct _CheckerboardLayoutLayoutRowClass {
	GTypeClass parent_class;
	void (*finalize) (CheckerboardLayoutLayoutRow *self);
};

struct _CheckerboardLayoutParamSpecLayoutRow {
	GParamSpec parent_instance;
};

static gint CheckerboardLayout_private_offset;
static gpointer checkerboard_layout_parent_class = NULL;
static gpointer checkerboard_layout_layout_row_parent_class = NULL;

static gpointer checkerboard_layout_layout_row_ref (gpointer instance);
static void checkerboard_layout_layout_row_unref (gpointer instance);
static GParamSpec* checkerboard_layout_param_spec_layout_row (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags) G_GNUC_UNUSED ;
static void checkerboard_layout_value_set_layout_row (GValue* value,
                                               gpointer v_object) G_GNUC_UNUSED ;
static void checkerboard_layout_value_take_layout_row (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED ;
static gpointer checkerboard_layout_value_get_layout_row (const GValue* value) G_GNUC_UNUSED ;
static GType checkerboard_layout_layout_row_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void checkerboard_layout_on_contents_altered (CheckerboardLayout* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
static void _checkerboard_layout_on_contents_altered_data_collection_contents_altered (DataCollection* _sender,
                                                                                GeeIterable* added,
                                                                                GeeIterable* removed,
                                                                                gpointer self);
static void checkerboard_layout_on_items_altered (CheckerboardLayout* self);
static void _checkerboard_layout_on_items_altered_data_collection_items_altered (DataCollection* _sender,
                                                                          GeeMap* items,
                                                                          gpointer self);
static void checkerboard_layout_on_items_state_changed (CheckerboardLayout* self,
                                                 GeeIterable* changed);
static void _checkerboard_layout_on_items_state_changed_view_collection_items_state_changed (ViewCollection* _sender,
                                                                                      GeeIterable* changed,
                                                                                      gpointer self);
static void checkerboard_layout_on_items_visibility_changed (CheckerboardLayout* self,
                                                      GeeIterable* changed);
static void _checkerboard_layout_on_items_visibility_changed_view_collection_items_visibility_changed (ViewCollection* _sender,
                                                                                                GeeCollection* changed,
                                                                                                gpointer self);
static void checkerboard_layout_on_ordering_changed (CheckerboardLayout* self);
static void _checkerboard_layout_on_ordering_changed_data_collection_ordering_changed (DataCollection* _sender,
                                                                                gpointer self);
static void checkerboard_layout_on_views_altered (CheckerboardLayout* self,
                                           GeeCollection* altered);
static void _checkerboard_layout_on_views_altered_view_collection_views_altered (ViewCollection* _sender,
                                                                          GeeCollection* views,
                                                                          gpointer self);
static void checkerboard_layout_on_geometries_altered (CheckerboardLayout* self);
static void _checkerboard_layout_on_geometries_altered_view_collection_geometries_altered (ViewCollection* _sender,
                                                                                    GeeCollection* views,
                                                                                    gpointer self);
static void checkerboard_layout_on_items_selection_changed (CheckerboardLayout* self);
static void _checkerboard_layout_on_items_selection_changed_view_collection_items_selected (ViewCollection* _sender,
                                                                                     GeeIterable* selected,
                                                                                     gpointer self);
static void _checkerboard_layout_on_items_selection_changed_view_collection_items_unselected (ViewCollection* _sender,
                                                                                       GeeIterable* unselected,
                                                                                       gpointer self);
static void checkerboard_layout_on_viewport_shifted (CheckerboardLayout* self);
static void _checkerboard_layout_on_viewport_shifted_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                            gpointer self);
static void checkerboard_layout_on_viewport_resized (CheckerboardLayout* self);
static void _checkerboard_layout_on_viewport_resized_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                        GtkAllocation* allocation,
                                                                        gpointer self);
static void checkerboard_layout_viewport_resized (CheckerboardLayout* self);
static void checkerboard_layout_clear_anchor (CheckerboardLayout* self);
static void checkerboard_layout_update_visible_page (CheckerboardLayout* self);
static void checkerboard_layout_need_exposure (CheckerboardLayout* self,
                                        const gchar* caller);
static void checkerboard_layout_update_anchor (CheckerboardLayout* self);
static void checkerboard_layout_center_on_anchor (CheckerboardLayout* self,
                                           gdouble upper);
static void checkerboard_layout_need_reflow (CheckerboardLayout* self,
                                      const gchar* caller);
static void checkerboard_layout_items_dirty (CheckerboardLayout* self,
                                      const gchar* reason,
                                      GeeIterable* items);
static gboolean checkerboard_layout_do_reflow (CheckerboardLayout* self);
static gboolean _checkerboard_layout_do_reflow_gsource_func (gpointer self);
static void checkerboard_layout_reflow (CheckerboardLayout* self,
                                 const gchar* caller);
static void checkerboard_layout_unexpose_items (CheckerboardLayout* self,
                                         const gchar* caller);
static void checkerboard_layout_expose_items (CheckerboardLayout* self,
                                       const gchar* caller);
static CheckerboardLayoutLayoutRow* checkerboard_layout_layout_row_new (gint y,
                                                                 gint height,
                                                                 gint num_in_row);
static CheckerboardLayoutLayoutRow* checkerboard_layout_layout_row_construct (GType object_type,
                                                                       gint y,
                                                                       gint height,
                                                                       gint num_in_row);
static void checkerboard_layout_real_size_allocate (GtkWidget* base,
                                             GtkAllocation* allocation);
static gboolean checkerboard_layout_real_draw (GtkWidget* base,
                                        cairo_t* ctx);
static void checkerboard_layout_draw_selection_band (CheckerboardLayout* self,
                                              cairo_t* ctx);
static gboolean checkerboard_layout_real_query_tooltip (GtkWidget* base,
                                                 gint x,
                                                 gint y,
                                                 gboolean keyboard_mode,
                                                 GtkTooltip* tooltip);
static gboolean checkerboard_layout_real_focus_in_event (GtkWidget* base,
                                                  GdkEventFocus* event);
static gboolean checkerboard_layout_real_focus_out_event (GtkWidget* base,
                                                   GdkEventFocus* event);
static void checkerboard_layout_layout_row_finalize (CheckerboardLayoutLayoutRow * obj);
static GType checkerboard_layout_layout_row_get_type_once (void);
static void checkerboard_layout_finalize (GObject * obj);
static GType checkerboard_layout_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
checkerboard_layout_get_instance_private (CheckerboardLayout* self)
{
	return G_STRUCT_MEMBER_P (self, CheckerboardLayout_private_offset);
}

static void
_checkerboard_layout_on_contents_altered_data_collection_contents_altered (DataCollection* _sender,
                                                                           GeeIterable* added,
                                                                           GeeIterable* removed,
                                                                           gpointer self)
{
#line 94 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_contents_altered ((CheckerboardLayout*) self, added, removed);
#line 255 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_items_altered_data_collection_items_altered (DataCollection* _sender,
                                                                     GeeMap* items,
                                                                     gpointer self)
{
#line 95 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_items_altered ((CheckerboardLayout*) self);
#line 265 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_items_state_changed_view_collection_items_state_changed (ViewCollection* _sender,
                                                                                 GeeIterable* changed,
                                                                                 gpointer self)
{
#line 96 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_items_state_changed ((CheckerboardLayout*) self, changed);
#line 275 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_items_visibility_changed_view_collection_items_visibility_changed (ViewCollection* _sender,
                                                                                           GeeCollection* changed,
                                                                                           gpointer self)
{
#line 97 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_items_visibility_changed ((CheckerboardLayout*) self, changed);
#line 285 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_ordering_changed_data_collection_ordering_changed (DataCollection* _sender,
                                                                           gpointer self)
{
#line 98 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_ordering_changed ((CheckerboardLayout*) self);
#line 294 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_views_altered_view_collection_views_altered (ViewCollection* _sender,
                                                                     GeeCollection* views,
                                                                     gpointer self)
{
#line 99 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_views_altered ((CheckerboardLayout*) self, views);
#line 304 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_geometries_altered_view_collection_geometries_altered (ViewCollection* _sender,
                                                                               GeeCollection* views,
                                                                               gpointer self)
{
#line 100 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_geometries_altered ((CheckerboardLayout*) self);
#line 314 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_items_selection_changed_view_collection_items_selected (ViewCollection* _sender,
                                                                                GeeIterable* selected,
                                                                                gpointer self)
{
#line 101 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_items_selection_changed ((CheckerboardLayout*) self);
#line 324 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_items_selection_changed_view_collection_items_unselected (ViewCollection* _sender,
                                                                                  GeeIterable* unselected,
                                                                                  gpointer self)
{
#line 102 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_items_selection_changed ((CheckerboardLayout*) self);
#line 334 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_viewport_shifted_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                       gpointer self)
{
#line 105 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_viewport_shifted ((CheckerboardLayout*) self);
#line 343 "CheckerboardLayout.c"
}

static void
_checkerboard_layout_on_viewport_resized_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                   GtkAllocation* allocation,
                                                                   gpointer self)
{
#line 111 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_on_viewport_resized ((CheckerboardLayout*) self);
#line 353 "CheckerboardLayout.c"
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 70 "../src/Checkerboard/CheckerboardLayout.vala"
	return self ? data_collection_ref (self) : NULL;
#line 361 "CheckerboardLayout.c"
}

CheckerboardLayout*
checkerboard_layout_construct (GType object_type,
                               ViewCollection* view)
{
	CheckerboardLayout * self = NULL;
	ViewCollection* _tmp0_;
#line 69 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 69 "../src/Checkerboard/CheckerboardLayout.vala"
	self = (CheckerboardLayout*) g_object_new (object_type, NULL);
#line 70 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = _data_collection_ref0 (view);
#line 70 "../src/Checkerboard/CheckerboardLayout.vala"
	_data_collection_unref0 (self->priv->view);
#line 70 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->view = _tmp0_;
#line 72 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_clear_drag_select (self);
#line 75 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object ((DataCollection*) view, "contents-altered", (GCallback) _checkerboard_layout_on_contents_altered_data_collection_contents_altered, self, 0);
#line 76 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object ((DataCollection*) view, "items-altered", (GCallback) _checkerboard_layout_on_items_altered_data_collection_items_altered, self, 0);
#line 77 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object (view, "items-state-changed", (GCallback) _checkerboard_layout_on_items_state_changed_view_collection_items_state_changed, self, 0);
#line 78 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object (view, "items-visibility-changed", (GCallback) _checkerboard_layout_on_items_visibility_changed_view_collection_items_visibility_changed, self, 0);
#line 79 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object ((DataCollection*) view, "ordering-changed", (GCallback) _checkerboard_layout_on_ordering_changed_data_collection_ordering_changed, self, 0);
#line 80 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object (view, "views-altered", (GCallback) _checkerboard_layout_on_views_altered_view_collection_views_altered, self, 0);
#line 81 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object (view, "geometries-altered", (GCallback) _checkerboard_layout_on_geometries_altered_view_collection_geometries_altered, self, 0);
#line 82 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object (view, "items-selected", (GCallback) _checkerboard_layout_on_items_selection_changed_view_collection_items_selected, self, 0);
#line 83 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object (view, "items-unselected", (GCallback) _checkerboard_layout_on_items_selection_changed_view_collection_items_unselected, self, 0);
#line 86 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_set_has_tooltip ((GtkWidget*) self, TRUE);
#line 69 "../src/Checkerboard/CheckerboardLayout.vala"
	return self;
#line 404 "CheckerboardLayout.c"
}

CheckerboardLayout*
checkerboard_layout_new (ViewCollection* view)
{
#line 69 "../src/Checkerboard/CheckerboardLayout.vala"
	return checkerboard_layout_construct (TYPE_CHECKERBOARD_LAYOUT, view);
#line 412 "CheckerboardLayout.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 115 "../src/Checkerboard/CheckerboardLayout.vala"
	return self ? g_object_ref (self) : NULL;
#line 420 "CheckerboardLayout.c"
}

void
checkerboard_layout_set_adjustments (CheckerboardLayout* self,
                                     GtkAdjustment* hadjustment,
                                     GtkAdjustment* vadjustment)
{
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkContainer* _tmp2_;
	GtkContainer* _tmp3_;
#line 114 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (hadjustment != NULL);
#line 114 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (vadjustment != NULL);
#line 115 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = _g_object_ref0 (hadjustment);
#line 115 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->hadjustment);
#line 115 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->hadjustment = _tmp0_;
#line 116 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = _g_object_ref0 (vadjustment);
#line 116 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->vadjustment);
#line 116 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->vadjustment = _tmp1_;
#line 119 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object (hadjustment, "value-changed", (GCallback) _checkerboard_layout_on_viewport_shifted_gtk_adjustment_value_changed, self, 0);
#line 120 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object (vadjustment, "value-changed", (GCallback) _checkerboard_layout_on_viewport_shifted_gtk_adjustment_value_changed, self, 0);
#line 123 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 123 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3_ = _tmp2_;
#line 123 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_connect_object ((GtkWidget*) _tmp3_, "size-allocate", (GCallback) _checkerboard_layout_on_viewport_resized_gtk_widget_size_allocate, self, 0);
#line 460 "CheckerboardLayout.c"
}

void
checkerboard_layout_set_scale (CheckerboardLayout* self,
                               gint scale)
{
#line 128 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->scale = scale;
#line 471 "CheckerboardLayout.c"
}

gint
checkerboard_layout_get_scale (CheckerboardLayout* self)
{
	gint result;
#line 132 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 133 "../src/Checkerboard/CheckerboardLayout.vala"
	result = self->priv->scale;
#line 133 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 484 "CheckerboardLayout.c"
}

void
checkerboard_layout_set_name (CheckerboardLayout* self,
                              const gchar* name)
{
	gchar* _tmp0_;
#line 136 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (name != NULL);
#line 137 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = g_strdup (name);
#line 137 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_free0 (self->priv->page_name);
#line 137 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->page_name = _tmp0_;
#line 502 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_viewport_resized (CheckerboardLayout* self)
{
	GtkRequisition req = {0};
	GtkRequisition _tmp0_ = {0};
	GtkAllocation parent_allocation = {0};
	GtkContainer* _tmp1_;
	GtkContainer* _tmp2_;
	GtkAllocation _tmp3_ = {0};
	const gchar* _tmp4_;
#line 140 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) self, NULL, &_tmp0_);
#line 142 "../src/Checkerboard/CheckerboardLayout.vala"
	req = _tmp0_;
#line 145 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 145 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = _tmp1_;
#line 145 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp2_, &_tmp3_);
#line 145 "../src/Checkerboard/CheckerboardLayout.vala"
	parent_allocation = _tmp3_;
#line 147 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp4_ = self->priv->message;
#line 147 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp4_ == NULL) {
#line 533 "CheckerboardLayout.c"
		GtkAllocation _tmp5_;
		GtkRequisition _tmp6_;
#line 154 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp5_ = parent_allocation;
#line 154 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp6_ = req;
#line 154 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, _tmp5_.width - CHECKERBOARD_LAYOUT_SCROLLBAR_PLACEHOLDER_WIDTH, _tmp6_.height);
#line 542 "CheckerboardLayout.c"
	} else {
		GtkAllocation _tmp7_;
		GtkAllocation _tmp8_;
#line 157 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp7_ = parent_allocation;
#line 157 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp8_ = parent_allocation;
#line 157 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, _tmp7_.width, _tmp8_.height);
#line 552 "CheckerboardLayout.c"
	}
#line 162 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_viewport_resized (self);
#line 164 "../src/Checkerboard/CheckerboardLayout.vala"
	if (!self->priv->size_allocate_due_to_reflow) {
#line 165 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_clear_anchor (self);
#line 560 "CheckerboardLayout.c"
	} else {
#line 167 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->size_allocate_due_to_reflow = FALSE;
#line 564 "CheckerboardLayout.c"
	}
}

static void
checkerboard_layout_on_viewport_shifted (CheckerboardLayout* self)
{
#line 170 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_update_visible_page (self);
#line 172 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_need_exposure (self, "on_viewport_shift");
#line 174 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_clear_anchor (self);
#line 579 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_items_selection_changed (CheckerboardLayout* self)
{
#line 177 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_clear_anchor (self);
#line 589 "CheckerboardLayout.c"
}

static void
checkerboard_layout_clear_anchor (CheckerboardLayout* self)
{
#line 181 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/Checkerboard/CheckerboardLayout.vala"
	if (self->priv->in_center_on_anchor) {
#line 183 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 601 "CheckerboardLayout.c"
	}
#line 185 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->anchor);
#line 185 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->anchor = NULL;
#line 607 "CheckerboardLayout.c"
}

static void
checkerboard_layout_update_anchor (CheckerboardLayout* self)
{
	GeeList* items_on_page = NULL;
	GdkRectangle _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkAdjustment* _tmp16_;
	GeeList* _tmp17_;
	GeeList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gpointer _tmp21_;
#line 188 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/Checkerboard/CheckerboardLayout.vala"
	_vala_assert (!self->priv->in_center_on_anchor, "!in_center_on_anchor");
#line 191 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->visible_page;
#line 191 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = checkerboard_layout_intersection (self, &_tmp0_);
#line 191 "../src/Checkerboard/CheckerboardLayout.vala"
	items_on_page = _tmp1_;
#line 192 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = items_on_page;
#line 192 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 192 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp4_ = _tmp3_;
#line 192 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp4_ == 0) {
#line 193 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (self->priv->anchor);
#line 193 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->anchor = NULL;
#line 194 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (items_on_page);
#line 194 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 651 "CheckerboardLayout.c"
	}
	{
		GeeList* _item_list = NULL;
		GeeList* _tmp5_;
		gint _item_size = 0;
		GeeList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _item_index = 0;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp5_ = items_on_page;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
		_item_list = _tmp5_;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp6_ = _item_list;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp8_ = _tmp7_;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
		_item_size = _tmp8_;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
		_item_index = -1;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
		while (TRUE) {
#line 677 "CheckerboardLayout.c"
			gint _tmp9_;
			gint _tmp10_;
			CheckerboardItem* item = NULL;
			GeeList* _tmp11_;
			gpointer _tmp12_;
			CheckerboardItem* _tmp13_;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
			_item_index = _item_index + 1;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp9_ = _item_index;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp10_ = _item_size;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 694 "CheckerboardLayout.c"
			}
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp11_ = _item_list;
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp12_ = gee_list_get (_tmp11_, _item_index);
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
			item = (CheckerboardItem*) _tmp12_;
#line 198 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp13_ = item;
#line 198 "../src/Checkerboard/CheckerboardLayout.vala"
			if (data_view_is_selected ((DataView*) _tmp13_)) {
#line 706 "CheckerboardLayout.c"
				CheckerboardItem* _tmp14_;
				CheckerboardItem* _tmp15_;
#line 199 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp14_ = item;
#line 199 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp15_ = _g_object_ref0 (_tmp14_);
#line 199 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (self->priv->anchor);
#line 199 "../src/Checkerboard/CheckerboardLayout.vala"
				self->priv->anchor = _tmp15_;
#line 200 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (item);
#line 200 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (items_on_page);
#line 200 "../src/Checkerboard/CheckerboardLayout.vala"
				return;
#line 723 "CheckerboardLayout.c"
			}
#line 197 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (item);
#line 727 "CheckerboardLayout.c"
		}
	}
#line 204 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp16_ = self->priv->vadjustment;
#line 204 "../src/Checkerboard/CheckerboardLayout.vala"
	if (gtk_adjustment_get_value (_tmp16_) == ((gdouble) 0)) {
#line 205 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (self->priv->anchor);
#line 205 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->anchor = NULL;
#line 206 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (items_on_page);
#line 206 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 742 "CheckerboardLayout.c"
	}
#line 211 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp17_ = items_on_page;
#line 211 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp18_ = items_on_page;
#line 211 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 211 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp20_ = _tmp19_;
#line 211 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp21_ = gee_list_get (_tmp17_, ((gint) _tmp20_) / 2);
#line 211 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->anchor);
#line 211 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->anchor = (CheckerboardItem*) _tmp21_;
#line 188 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (items_on_page);
#line 760 "CheckerboardLayout.c"
}

static void
checkerboard_layout_center_on_anchor (CheckerboardLayout* self,
                                      gdouble upper)
{
	CheckerboardItem* _tmp0_;
	gdouble anchor_pos = 0.0;
	CheckerboardItem* _tmp1_;
	GdkRectangle _tmp2_;
	CheckerboardItem* _tmp3_;
	GdkRectangle _tmp4_;
	GtkAdjustment* _tmp5_;
	GtkAdjustment* _tmp6_;
	GtkAdjustment* _tmp7_;
	GtkAdjustment* _tmp8_;
	GtkAdjustment* _tmp9_;
#line 214 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->anchor;
#line 215 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp0_ == NULL) {
#line 216 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 786 "CheckerboardLayout.c"
	}
#line 218 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->in_center_on_anchor = TRUE;
#line 220 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = self->priv->anchor;
#line 220 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = _tmp1_->allocation;
#line 220 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3_ = self->priv->anchor;
#line 220 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp4_ = _tmp3_->allocation;
#line 220 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp5_ = self->priv->vadjustment;
#line 220 "../src/Checkerboard/CheckerboardLayout.vala"
	anchor_pos = (_tmp2_.y + (_tmp4_.height / 2)) - (gtk_adjustment_get_page_size (_tmp5_) / 2);
#line 222 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp6_ = self->priv->vadjustment;
#line 222 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp7_ = self->priv->vadjustment;
#line 222 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp8_ = self->priv->vadjustment;
#line 222 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp9_ = self->priv->vadjustment;
#line 222 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_adjustment_set_value (_tmp6_, CLAMP (anchor_pos, gtk_adjustment_get_lower (_tmp7_), gtk_adjustment_get_upper (_tmp8_) - gtk_adjustment_get_page_size (_tmp9_)));
#line 225 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->in_center_on_anchor = FALSE;
#line 814 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_contents_altered (CheckerboardLayout* self,
                                         GeeIterable* added,
                                         GeeIterable* removed)
{
#line 228 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/Checkerboard/CheckerboardLayout.vala"
	if (added != NULL) {
#line 231 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_free0 (self->priv->message);
#line 231 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->message = NULL;
#line 830 "CheckerboardLayout.c"
	}
#line 233 "../src/Checkerboard/CheckerboardLayout.vala"
	if (removed != NULL) {
#line 834 "CheckerboardLayout.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp0_ = gee_iterable_iterator (removed);
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
			_object_it = _tmp0_;
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
			while (TRUE) {
#line 844 "CheckerboardLayout.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				GeeHashSet* _tmp4_;
				DataObject* _tmp5_;
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp1_ = _object_it;
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
					break;
#line 857 "CheckerboardLayout.c"
				}
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp2_ = _object_it;
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
				object = (DataObject*) _tmp3_;
#line 235 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp4_ = self->priv->exposed_items;
#line 235 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp5_ = object;
#line 235 "../src/Checkerboard/CheckerboardLayout.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem));
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (object);
#line 873 "CheckerboardLayout.c"
			}
#line 234 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (_object_it);
#line 877 "CheckerboardLayout.c"
		}
	}
#line 240 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows = (_vala_array_free (self->priv->item_rows, self->priv->item_rows_length1, (GDestroyNotify) checkerboard_layout_layout_row_unref), NULL);
#line 240 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows = NULL;
#line 240 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows_length1 = 0;
#line 240 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->_item_rows_size_ = self->priv->item_rows_length1;
#line 242 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_need_reflow (self, "on_contents_altered");
#line 890 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_items_altered (CheckerboardLayout* self)
{
#line 245 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_need_reflow (self, "on_items_altered");
#line 900 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_items_state_changed (CheckerboardLayout* self,
                                            GeeIterable* changed)
{
#line 249 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (changed != NULL);
#line 250 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_items_dirty (self, "on_items_state_changed", changed);
#line 913 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_items_visibility_changed (CheckerboardLayout* self,
                                                 GeeIterable* changed)
{
#line 253 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (changed != NULL);
#line 254 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_need_reflow (self, "on_items_visibility_changed");
#line 926 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_ordering_changed (CheckerboardLayout* self)
{
#line 257 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_need_reflow (self, "on_ordering_changed");
#line 936 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_views_altered (CheckerboardLayout* self,
                                      GeeCollection* altered)
{
#line 261 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (altered != NULL);
#line 262 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_items_dirty (self, "on_views_altered", (GeeIterable*) altered);
#line 949 "CheckerboardLayout.c"
}

static void
checkerboard_layout_on_geometries_altered (CheckerboardLayout* self)
{
#line 265 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 266 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_need_reflow (self, "on_geometries_altered");
#line 959 "CheckerboardLayout.c"
}

static gboolean
_checkerboard_layout_do_reflow_gsource_func (gpointer self)
{
	gboolean result;
	result = checkerboard_layout_do_reflow ((CheckerboardLayout*) self);
#line 282 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 969 "CheckerboardLayout.c"
}

static void
checkerboard_layout_need_reflow (CheckerboardLayout* self,
                                 const gchar* caller)
{
#line 269 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (caller != NULL);
#line 270 "../src/Checkerboard/CheckerboardLayout.vala"
	if (self->priv->flow_scheduled) {
#line 271 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 984 "CheckerboardLayout.c"
	}
#line 273 "../src/Checkerboard/CheckerboardLayout.vala"
	if (!self->priv->is_in_view) {
#line 274 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->reflow_needed = TRUE;
#line 275 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 992 "CheckerboardLayout.c"
	}
#line 281 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->flow_scheduled = TRUE;
#line 282 "../src/Checkerboard/CheckerboardLayout.vala"
	g_idle_add_full (G_PRIORITY_HIGH, _checkerboard_layout_do_reflow_gsource_func, g_object_ref (self), g_object_unref);
#line 998 "CheckerboardLayout.c"
}

static gboolean
checkerboard_layout_do_reflow (CheckerboardLayout* self)
{
	gboolean result;
#line 285 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 286 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_reflow (self, "do_reflow");
#line 287 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_need_exposure (self, "do_reflow");
#line 289 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->flow_scheduled = FALSE;
#line 291 "../src/Checkerboard/CheckerboardLayout.vala"
	result = FALSE;
#line 291 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 1017 "CheckerboardLayout.c"
}

static void
checkerboard_layout_need_exposure (CheckerboardLayout* self,
                                   const gchar* caller)
{
#line 294 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 294 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (caller != NULL);
#line 298 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->exposure_dirty = TRUE;
#line 299 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1032 "CheckerboardLayout.c"
}

void
checkerboard_layout_set_message (CheckerboardLayout* self,
                                 const gchar* text)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 302 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->message;
#line 303 "../src/Checkerboard/CheckerboardLayout.vala"
	if (g_strcmp0 (text, _tmp0_) == 0) {
#line 304 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 1049 "CheckerboardLayout.c"
	}
#line 306 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = g_strdup (text);
#line 306 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_free0 (self->priv->message);
#line 306 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->message = _tmp1_;
#line 308 "../src/Checkerboard/CheckerboardLayout.vala"
	if (text != NULL) {
#line 1059 "CheckerboardLayout.c"
		GtkContainer* _tmp2_;
		GtkContainer* _tmp3_;
#line 311 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 311 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = _tmp2_;
#line 311 "../src/Checkerboard/CheckerboardLayout.vala"
		if (_tmp3_ != NULL) {
#line 1068 "CheckerboardLayout.c"
			GtkAllocation parent_allocation = {0};
			GtkContainer* _tmp4_;
			GtkContainer* _tmp5_;
			GtkAllocation _tmp6_ = {0};
			GtkAllocation _tmp7_;
			GtkAllocation _tmp8_;
#line 313 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp4_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 313 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp5_ = _tmp4_;
#line 313 "../src/Checkerboard/CheckerboardLayout.vala"
			gtk_widget_get_allocation ((GtkWidget*) _tmp5_, &_tmp6_);
#line 313 "../src/Checkerboard/CheckerboardLayout.vala"
			parent_allocation = _tmp6_;
#line 315 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp7_ = parent_allocation;
#line 315 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp8_ = parent_allocation;
#line 315 "../src/Checkerboard/CheckerboardLayout.vala"
			gtk_widget_set_size_request ((GtkWidget*) self, _tmp7_.width, _tmp8_.height);
#line 1089 "CheckerboardLayout.c"
		}
	} else {
#line 319 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_need_reflow (self, "set_message");
#line 1094 "CheckerboardLayout.c"
	}
}

void
checkerboard_layout_unset_message (CheckerboardLayout* self)
{
#line 323 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_set_message (self, NULL);
#line 1105 "CheckerboardLayout.c"
}

static void
checkerboard_layout_update_visible_page (CheckerboardLayout* self)
{
	gboolean _tmp0_ = FALSE;
	GtkAdjustment* _tmp1_;
#line 327 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 328 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = self->priv->hadjustment;
#line 328 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp1_ != NULL) {
#line 1119 "CheckerboardLayout.c"
		GtkAdjustment* _tmp2_;
#line 328 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = self->priv->vadjustment;
#line 328 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 1125 "CheckerboardLayout.c"
	} else {
#line 328 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = FALSE;
#line 1129 "CheckerboardLayout.c"
	}
#line 328 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp0_) {
#line 1133 "CheckerboardLayout.c"
		GtkAdjustment* _tmp3_;
		GtkAdjustment* _tmp4_;
		GdkRectangle _tmp5_ = {0};
#line 329 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = self->priv->hadjustment;
#line 329 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp4_ = self->priv->vadjustment;
#line 329 "../src/Checkerboard/CheckerboardLayout.vala"
		get_adjustment_page (_tmp3_, _tmp4_, &_tmp5_);
#line 329 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->visible_page = _tmp5_;
#line 1145 "CheckerboardLayout.c"
	}
}

void
checkerboard_layout_set_in_view (CheckerboardLayout* self,
                                 gboolean in_view)
{
#line 332 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->is_in_view = in_view;
#line 335 "../src/Checkerboard/CheckerboardLayout.vala"
	if (in_view) {
#line 336 "../src/Checkerboard/CheckerboardLayout.vala"
		if (self->priv->reflow_needed) {
#line 337 "../src/Checkerboard/CheckerboardLayout.vala"
			checkerboard_layout_need_reflow (self, "set_in_view (true)");
#line 1163 "CheckerboardLayout.c"
		} else {
#line 339 "../src/Checkerboard/CheckerboardLayout.vala"
			checkerboard_layout_need_exposure (self, "set_in_view (true)");
#line 1167 "CheckerboardLayout.c"
		}
	} else {
#line 341 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_unexpose_items (self, "set_in_view (false)");
#line 1172 "CheckerboardLayout.c"
	}
}

static gpointer
_checkerboard_layout_layout_row_ref0 (gpointer self)
{
#line 357 "../src/Checkerboard/CheckerboardLayout.vala"
	return self ? checkerboard_layout_layout_row_ref (self) : NULL;
#line 1181 "CheckerboardLayout.c"
}

CheckerboardItem*
checkerboard_layout_get_item_at_pixel (CheckerboardLayout* self,
                                       gdouble xd,
                                       gdouble yd)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gint x = 0;
	gint y = 0;
	CheckerboardLayoutLayoutRow* in_range = NULL;
	gint min = 0;
	gint max = 0;
	CheckerboardLayoutLayoutRow** _tmp3_;
	gint _tmp3__length1;
	CheckerboardLayoutLayoutRow* _tmp15_;
	CheckerboardLayoutLayoutRow* _tmp16_;
	CheckerboardItem** _tmp17_;
	gint _tmp17__length1;
	CheckerboardItem* result;
#line 344 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 345 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = self->priv->message;
#line 345 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp1_ != NULL) {
#line 345 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = TRUE;
#line 1211 "CheckerboardLayout.c"
	} else {
		CheckerboardLayoutLayoutRow** _tmp2_;
		gint _tmp2__length1;
#line 345 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = self->priv->item_rows;
#line 345 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2__length1 = self->priv->item_rows_length1;
#line 345 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1221 "CheckerboardLayout.c"
	}
#line 345 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp0_) {
#line 346 "../src/Checkerboard/CheckerboardLayout.vala"
		result = NULL;
#line 346 "../src/Checkerboard/CheckerboardLayout.vala"
		return result;
#line 1229 "CheckerboardLayout.c"
	}
#line 348 "../src/Checkerboard/CheckerboardLayout.vala"
	x = (gint) xd;
#line 349 "../src/Checkerboard/CheckerboardLayout.vala"
	y = (gint) yd;
#line 352 "../src/Checkerboard/CheckerboardLayout.vala"
	in_range = NULL;
#line 353 "../src/Checkerboard/CheckerboardLayout.vala"
	min = 0;
#line 354 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3_ = self->priv->item_rows;
#line 354 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3__length1 = self->priv->item_rows_length1;
#line 354 "../src/Checkerboard/CheckerboardLayout.vala"
	max = _tmp3__length1;
#line 1245 "CheckerboardLayout.c"
	{
		gboolean _tmp4_ = FALSE;
#line 355 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp4_ = TRUE;
#line 355 "../src/Checkerboard/CheckerboardLayout.vala"
		while (TRUE) {
#line 1252 "CheckerboardLayout.c"
			gint mid = 0;
			CheckerboardLayoutLayoutRow* row = NULL;
			CheckerboardLayoutLayoutRow** _tmp5_;
			gint _tmp5__length1;
			CheckerboardLayoutLayoutRow* _tmp6_;
			CheckerboardLayoutLayoutRow* _tmp7_;
			gboolean _tmp8_ = FALSE;
			CheckerboardLayoutLayoutRow* _tmp9_;
#line 355 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!_tmp4_) {
#line 1263 "CheckerboardLayout.c"
			}
#line 355 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp4_ = FALSE;
#line 356 "../src/Checkerboard/CheckerboardLayout.vala"
			mid = min + ((max - min) / 2);
#line 357 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp5_ = self->priv->item_rows;
#line 357 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp5__length1 = self->priv->item_rows_length1;
#line 357 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp6_ = _tmp5_[mid];
#line 357 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp7_ = _checkerboard_layout_layout_row_ref0 (_tmp6_);
#line 357 "../src/Checkerboard/CheckerboardLayout.vala"
			row = _tmp7_;
#line 359 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp9_ = row;
#line 359 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp9_ == NULL) {
#line 359 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp8_ = TRUE;
#line 1285 "CheckerboardLayout.c"
			} else {
				CheckerboardLayoutLayoutRow* _tmp10_;
#line 359 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp10_ = row;
#line 359 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp8_ = y < _tmp10_->y;
#line 1292 "CheckerboardLayout.c"
			}
#line 359 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp8_) {
#line 362 "../src/Checkerboard/CheckerboardLayout.vala"
				max = mid - 1;
#line 1298 "CheckerboardLayout.c"
			} else {
				CheckerboardLayoutLayoutRow* _tmp11_;
				CheckerboardLayoutLayoutRow* _tmp12_;
#line 363 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp11_ = row;
#line 363 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp12_ = row;
#line 363 "../src/Checkerboard/CheckerboardLayout.vala"
				if (y > (_tmp11_->y + _tmp12_->height)) {
#line 365 "../src/Checkerboard/CheckerboardLayout.vala"
					min = mid + 1;
#line 1310 "CheckerboardLayout.c"
				} else {
					CheckerboardLayoutLayoutRow* _tmp13_;
					CheckerboardLayoutLayoutRow* _tmp14_;
#line 368 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp13_ = row;
#line 368 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp14_ = _checkerboard_layout_layout_row_ref0 (_tmp13_);
#line 368 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (in_range);
#line 368 "../src/Checkerboard/CheckerboardLayout.vala"
					in_range = _tmp14_;
#line 370 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (row);
#line 370 "../src/Checkerboard/CheckerboardLayout.vala"
					break;
#line 1326 "CheckerboardLayout.c"
				}
			}
#line 373 "../src/Checkerboard/CheckerboardLayout.vala"
			if (min > max) {
#line 374 "../src/Checkerboard/CheckerboardLayout.vala"
				_checkerboard_layout_layout_row_unref0 (row);
#line 374 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 1335 "CheckerboardLayout.c"
			}
#line 355 "../src/Checkerboard/CheckerboardLayout.vala"
			_checkerboard_layout_layout_row_unref0 (row);
#line 1339 "CheckerboardLayout.c"
		}
	}
#line 377 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp15_ = in_range;
#line 377 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp15_ == NULL) {
#line 378 "../src/Checkerboard/CheckerboardLayout.vala"
		result = NULL;
#line 378 "../src/Checkerboard/CheckerboardLayout.vala"
		_checkerboard_layout_layout_row_unref0 (in_range);
#line 378 "../src/Checkerboard/CheckerboardLayout.vala"
		return result;
#line 1352 "CheckerboardLayout.c"
	}
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp16_ = in_range;
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp17_ = _tmp16_->items;
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp17__length1 = _tmp16_->items_length1;
#line 1360 "CheckerboardLayout.c"
	{
		CheckerboardItem** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
		item_collection = _tmp17_;
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
		item_collection_length1 = _tmp17__length1;
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
		for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 1372 "CheckerboardLayout.c"
			CheckerboardItem* _tmp18_;
			CheckerboardItem* item = NULL;
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp18_ = _g_object_ref0 (item_collection[item_it]);
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
			item = _tmp18_;
#line 1379 "CheckerboardLayout.c"
			{
				CheckerboardItem* _tmp19_;
				CheckerboardItem* _tmp20_;
				GdkRectangle _tmp21_;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp23_ = FALSE;
				CheckerboardItem* _tmp24_;
				GdkRectangle _tmp25_;
				CheckerboardItem* _tmp26_;
				GdkRectangle _tmp27_;
#line 384 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp19_ = item;
#line 384 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp19_ == NULL) {
#line 385 "../src/Checkerboard/CheckerboardLayout.vala"
					_g_object_unref0 (item);
#line 385 "../src/Checkerboard/CheckerboardLayout.vala"
					continue;
#line 1398 "CheckerboardLayout.c"
				}
#line 387 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp20_ = item;
#line 387 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp21_ = _tmp20_->allocation;
#line 387 "../src/Checkerboard/CheckerboardLayout.vala"
				if (x < _tmp21_.x) {
#line 389 "../src/Checkerboard/CheckerboardLayout.vala"
					_g_object_unref0 (item);
#line 389 "../src/Checkerboard/CheckerboardLayout.vala"
					break;
#line 1410 "CheckerboardLayout.c"
				}
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp24_ = item;
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp25_ = _tmp24_->allocation;
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp26_ = item;
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp27_ = _tmp26_->allocation;
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
				if (x <= (_tmp25_.x + _tmp27_.width)) {
#line 1422 "CheckerboardLayout.c"
					CheckerboardItem* _tmp28_;
					GdkRectangle _tmp29_;
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp28_ = item;
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp29_ = _tmp28_->allocation;
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp23_ = y >= _tmp29_.y;
#line 1431 "CheckerboardLayout.c"
				} else {
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp23_ = FALSE;
#line 1435 "CheckerboardLayout.c"
				}
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp23_) {
#line 1439 "CheckerboardLayout.c"
					CheckerboardItem* _tmp30_;
					GdkRectangle _tmp31_;
					CheckerboardItem* _tmp32_;
					GdkRectangle _tmp33_;
#line 395 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp30_ = item;
#line 395 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp31_ = _tmp30_->allocation;
#line 395 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp32_ = item;
#line 395 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp33_ = _tmp32_->allocation;
#line 395 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp22_ = y <= (_tmp31_.y + _tmp33_.height);
#line 1454 "CheckerboardLayout.c"
				} else {
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp22_ = FALSE;
#line 1458 "CheckerboardLayout.c"
				}
#line 394 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp22_) {
#line 396 "../src/Checkerboard/CheckerboardLayout.vala"
					result = item;
#line 396 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (in_range);
#line 396 "../src/Checkerboard/CheckerboardLayout.vala"
					return result;
#line 1468 "CheckerboardLayout.c"
				}
#line 381 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (item);
#line 1472 "CheckerboardLayout.c"
			}
		}
	}
#line 399 "../src/Checkerboard/CheckerboardLayout.vala"
	result = NULL;
#line 399 "../src/Checkerboard/CheckerboardLayout.vala"
	_checkerboard_layout_layout_row_unref0 (in_range);
#line 399 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 1482 "CheckerboardLayout.c"
}

GeeList*
checkerboard_layout_get_visible_items (CheckerboardLayout* self)
{
	GdkRectangle _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 402 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 403 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->visible_page;
#line 403 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = checkerboard_layout_intersection (self, &_tmp0_);
#line 403 "../src/Checkerboard/CheckerboardLayout.vala"
	result = _tmp1_;
#line 403 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 1501 "CheckerboardLayout.c"
}

GeeList*
checkerboard_layout_intersection (CheckerboardLayout* self,
                                  GdkRectangle* area)
{
	GeeArrayList* intersects = NULL;
	GeeArrayList* _tmp0_;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp1_ = {0};
	GdkRectangle bitbucket = {0};
	CheckerboardLayoutLayoutRow** _tmp2_;
	gint _tmp2__length1;
	GeeList* result;
#line 406 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 406 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (area != NULL, NULL);
#line 407 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = gee_array_list_new (TYPE_CHECKERBOARD_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 407 "../src/Checkerboard/CheckerboardLayout.vala"
	intersects = _tmp0_;
#line 410 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp1_);
#line 410 "../src/Checkerboard/CheckerboardLayout.vala"
	allocation = _tmp1_;
#line 412 "../src/Checkerboard/CheckerboardLayout.vala"
	memset (&bitbucket, 0, sizeof (GdkRectangle));
#line 413 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = self->priv->item_rows;
#line 413 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2__length1 = self->priv->item_rows_length1;
#line 1534 "CheckerboardLayout.c"
	{
		CheckerboardLayoutLayoutRow** row_collection = NULL;
		gint row_collection_length1 = 0;
		gint _row_collection_size_ = 0;
		gint row_it = 0;
#line 413 "../src/Checkerboard/CheckerboardLayout.vala"
		row_collection = _tmp2_;
#line 413 "../src/Checkerboard/CheckerboardLayout.vala"
		row_collection_length1 = _tmp2__length1;
#line 413 "../src/Checkerboard/CheckerboardLayout.vala"
		for (row_it = 0; row_it < row_collection_length1; row_it = row_it + 1) {
#line 1546 "CheckerboardLayout.c"
			CheckerboardLayoutLayoutRow* _tmp3_;
			CheckerboardLayoutLayoutRow* row = NULL;
#line 413 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp3_ = _checkerboard_layout_layout_row_ref0 (row_collection[row_it]);
#line 413 "../src/Checkerboard/CheckerboardLayout.vala"
			row = _tmp3_;
#line 1553 "CheckerboardLayout.c"
			{
				CheckerboardLayoutLayoutRow* _tmp4_;
				GdkRectangle _tmp5_;
				GdkRectangle _tmp6_;
				CheckerboardLayoutLayoutRow* _tmp7_;
				CheckerboardLayoutLayoutRow* _tmp8_;
				CheckerboardLayoutLayoutRow* _tmp9_;
				GdkRectangle _tmp10_;
				GdkRectangle row_rect = {0};
				CheckerboardLayoutLayoutRow* _tmp11_;
				GtkAllocation _tmp12_;
				CheckerboardLayoutLayoutRow* _tmp13_;
				GdkRectangle _tmp14_;
				GdkRectangle _tmp15_ = {0};
				gboolean _tmp16_;
#line 414 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp4_ = row;
#line 414 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp4_ == NULL) {
#line 415 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (row);
#line 415 "../src/Checkerboard/CheckerboardLayout.vala"
					continue;
#line 1577 "CheckerboardLayout.c"
				}
#line 417 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp5_ = *area;
#line 417 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp6_ = *area;
#line 417 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp7_ = row;
#line 417 "../src/Checkerboard/CheckerboardLayout.vala"
				if ((_tmp5_.y + _tmp6_.height) < _tmp7_->y) {
#line 419 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (row);
#line 419 "../src/Checkerboard/CheckerboardLayout.vala"
					break;
#line 1591 "CheckerboardLayout.c"
				}
#line 422 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp8_ = row;
#line 422 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp9_ = row;
#line 422 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp10_ = *area;
#line 422 "../src/Checkerboard/CheckerboardLayout.vala"
				if ((_tmp8_->y + _tmp9_->height) < _tmp10_.y) {
#line 424 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (row);
#line 424 "../src/Checkerboard/CheckerboardLayout.vala"
					continue;
#line 1605 "CheckerboardLayout.c"
				}
#line 428 "../src/Checkerboard/CheckerboardLayout.vala"
				memset (&row_rect, 0, sizeof (GdkRectangle));
#line 429 "../src/Checkerboard/CheckerboardLayout.vala"
				row_rect.x = 0;
#line 430 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp11_ = row;
#line 430 "../src/Checkerboard/CheckerboardLayout.vala"
				row_rect.y = _tmp11_->y;
#line 431 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp12_ = allocation;
#line 431 "../src/Checkerboard/CheckerboardLayout.vala"
				row_rect.width = _tmp12_.width;
#line 432 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp13_ = row;
#line 432 "../src/Checkerboard/CheckerboardLayout.vala"
				row_rect.height = _tmp13_->height;
#line 434 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp14_ = row_rect;
#line 434 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp16_ = gdk_rectangle_intersect (area, &_tmp14_, &_tmp15_);
#line 434 "../src/Checkerboard/CheckerboardLayout.vala"
				bitbucket = _tmp15_;
#line 434 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp16_) {
#line 1631 "CheckerboardLayout.c"
					CheckerboardLayoutLayoutRow* _tmp17_;
					CheckerboardItem** _tmp18_;
					gint _tmp18__length1;
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp17_ = row;
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp18_ = _tmp17_->items;
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp18__length1 = _tmp17_->items_length1;
#line 1641 "CheckerboardLayout.c"
					{
						CheckerboardItem** item_collection = NULL;
						gint item_collection_length1 = 0;
						gint _item_collection_size_ = 0;
						gint item_it = 0;
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
						item_collection = _tmp18_;
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
						item_collection_length1 = _tmp18__length1;
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
						for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 1653 "CheckerboardLayout.c"
							CheckerboardItem* _tmp19_;
							CheckerboardItem* item = NULL;
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp19_ = _g_object_ref0 (item_collection[item_it]);
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
							item = _tmp19_;
#line 1660 "CheckerboardLayout.c"
							{
								CheckerboardItem* _tmp20_;
								CheckerboardItem* _tmp21_;
								GdkRectangle _tmp22_;
								GdkRectangle _tmp23_ = {0};
								gboolean _tmp24_;
#line 437 "../src/Checkerboard/CheckerboardLayout.vala"
								_tmp20_ = item;
#line 437 "../src/Checkerboard/CheckerboardLayout.vala"
								if (_tmp20_ == NULL) {
#line 438 "../src/Checkerboard/CheckerboardLayout.vala"
									_g_object_unref0 (item);
#line 438 "../src/Checkerboard/CheckerboardLayout.vala"
									continue;
#line 1675 "CheckerboardLayout.c"
								}
#line 440 "../src/Checkerboard/CheckerboardLayout.vala"
								_tmp21_ = item;
#line 440 "../src/Checkerboard/CheckerboardLayout.vala"
								_tmp22_ = _tmp21_->allocation;
#line 440 "../src/Checkerboard/CheckerboardLayout.vala"
								_tmp24_ = gdk_rectangle_intersect (area, &_tmp22_, &_tmp23_);
#line 440 "../src/Checkerboard/CheckerboardLayout.vala"
								bitbucket = _tmp23_;
#line 440 "../src/Checkerboard/CheckerboardLayout.vala"
								if (_tmp24_) {
#line 1687 "CheckerboardLayout.c"
									GeeArrayList* _tmp25_;
									CheckerboardItem* _tmp26_;
#line 441 "../src/Checkerboard/CheckerboardLayout.vala"
									_tmp25_ = intersects;
#line 441 "../src/Checkerboard/CheckerboardLayout.vala"
									_tmp26_ = item;
#line 441 "../src/Checkerboard/CheckerboardLayout.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
#line 1696 "CheckerboardLayout.c"
								}
#line 436 "../src/Checkerboard/CheckerboardLayout.vala"
								_g_object_unref0 (item);
#line 1700 "CheckerboardLayout.c"
							}
						}
					}
				}
#line 413 "../src/Checkerboard/CheckerboardLayout.vala"
				_checkerboard_layout_layout_row_unref0 (row);
#line 1707 "CheckerboardLayout.c"
			}
		}
	}
#line 446 "../src/Checkerboard/CheckerboardLayout.vala"
	result = (GeeList*) intersects;
#line 446 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 1715 "CheckerboardLayout.c"
}

CheckerboardItem*
checkerboard_layout_get_item_relative_to (CheckerboardLayout* self,
                                          CheckerboardItem* item,
                                          GtkDirectionType direction)
{
	ViewCollection* _tmp0_;
	gint col = 0;
	gint row = 0;
	gboolean _tmp1_ = FALSE;
	CheckerboardItem* new_item = NULL;
	CheckerboardItem* _tmp13_;
	gboolean _tmp14_ = FALSE;
	CheckerboardItem* _tmp15_;
	CheckerboardItem* _tmp19_ = NULL;
	CheckerboardItem* _tmp20_;
	CheckerboardItem* _tmp22_;
	CheckerboardItem* result;
#line 449 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 449 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 450 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->view;
#line 450 "../src/Checkerboard/CheckerboardLayout.vala"
	if (data_collection_get_count ((DataCollection*) _tmp0_) == 0) {
#line 451 "../src/Checkerboard/CheckerboardLayout.vala"
		result = NULL;
#line 451 "../src/Checkerboard/CheckerboardLayout.vala"
		return result;
#line 1747 "CheckerboardLayout.c"
	}
#line 453 "../src/Checkerboard/CheckerboardLayout.vala"
	_vala_assert (self->priv->columns > 0, "columns > 0");
#line 454 "../src/Checkerboard/CheckerboardLayout.vala"
	_vala_assert (self->priv->rows > 0, "rows > 0");
#line 456 "../src/Checkerboard/CheckerboardLayout.vala"
	col = checkerboard_item_get_column (item);
#line 457 "../src/Checkerboard/CheckerboardLayout.vala"
	row = checkerboard_item_get_row (item);
#line 459 "../src/Checkerboard/CheckerboardLayout.vala"
	if (col < 0) {
#line 459 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp1_ = TRUE;
#line 1761 "CheckerboardLayout.c"
	} else {
#line 459 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp1_ = row < 0;
#line 1765 "CheckerboardLayout.c"
	}
#line 459 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp1_) {
#line 1769 "CheckerboardLayout.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 460 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = checkerboard_item_get_title (item);
#line 460 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = _tmp2_;
#line 460 "../src/Checkerboard/CheckerboardLayout.vala"
		g_critical ("CheckerboardLayout.vala:460: Attempting to locate item not placed in l" \
"ayout: %s", _tmp3_);
#line 460 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_free0 (_tmp3_);
#line 462 "../src/Checkerboard/CheckerboardLayout.vala"
		result = NULL;
#line 462 "../src/Checkerboard/CheckerboardLayout.vala"
		return result;
#line 1784 "CheckerboardLayout.c"
	}
#line 465 "../src/Checkerboard/CheckerboardLayout.vala"
	switch (direction) {
#line 465 "../src/Checkerboard/CheckerboardLayout.vala"
		case GTK_DIR_UP:
#line 1790 "CheckerboardLayout.c"
		{
			gint _tmp4_;
#line 467 "../src/Checkerboard/CheckerboardLayout.vala"
			row = row - 1;
#line 467 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp4_ = row;
#line 467 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp4_ < 0) {
#line 468 "../src/Checkerboard/CheckerboardLayout.vala"
				row = 0;
#line 1801 "CheckerboardLayout.c"
			}
#line 469 "../src/Checkerboard/CheckerboardLayout.vala"
			break;
#line 1805 "CheckerboardLayout.c"
		}
#line 465 "../src/Checkerboard/CheckerboardLayout.vala"
		case GTK_DIR_DOWN:
#line 1809 "CheckerboardLayout.c"
		{
			gint _tmp5_;
			gint _tmp6_;
#line 472 "../src/Checkerboard/CheckerboardLayout.vala"
			row = row + 1;
#line 472 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp5_ = row;
#line 472 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp6_ = self->priv->rows;
#line 472 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp5_ >= _tmp6_) {
#line 473 "../src/Checkerboard/CheckerboardLayout.vala"
				row = self->priv->rows - 1;
#line 1823 "CheckerboardLayout.c"
			}
#line 474 "../src/Checkerboard/CheckerboardLayout.vala"
			break;
#line 1827 "CheckerboardLayout.c"
		}
#line 465 "../src/Checkerboard/CheckerboardLayout.vala"
		case GTK_DIR_RIGHT:
#line 1831 "CheckerboardLayout.c"
		{
			gint _tmp7_;
			gint _tmp8_;
#line 477 "../src/Checkerboard/CheckerboardLayout.vala"
			col = col + 1;
#line 477 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp7_ = col;
#line 477 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp8_ = self->priv->columns;
#line 477 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp7_ >= _tmp8_) {
#line 1843 "CheckerboardLayout.c"
				gint _tmp9_;
				gint _tmp10_;
#line 478 "../src/Checkerboard/CheckerboardLayout.vala"
				row = row + 1;
#line 478 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp9_ = row;
#line 478 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp10_ = self->priv->rows;
#line 478 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp9_ >= _tmp10_) {
#line 479 "../src/Checkerboard/CheckerboardLayout.vala"
					row = self->priv->rows - 1;
#line 480 "../src/Checkerboard/CheckerboardLayout.vala"
					col = self->priv->columns - 1;
#line 1858 "CheckerboardLayout.c"
				} else {
#line 482 "../src/Checkerboard/CheckerboardLayout.vala"
					col = 0;
#line 1862 "CheckerboardLayout.c"
				}
			}
#line 485 "../src/Checkerboard/CheckerboardLayout.vala"
			break;
#line 1867 "CheckerboardLayout.c"
		}
#line 465 "../src/Checkerboard/CheckerboardLayout.vala"
		case GTK_DIR_LEFT:
#line 1871 "CheckerboardLayout.c"
		{
			gint _tmp11_;
#line 488 "../src/Checkerboard/CheckerboardLayout.vala"
			col = col - 1;
#line 488 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp11_ = col;
#line 488 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp11_ < 0) {
#line 1880 "CheckerboardLayout.c"
				gint _tmp12_;
#line 489 "../src/Checkerboard/CheckerboardLayout.vala"
				row = row - 1;
#line 489 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp12_ = row;
#line 489 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp12_ < 0) {
#line 490 "../src/Checkerboard/CheckerboardLayout.vala"
					row = 0;
#line 491 "../src/Checkerboard/CheckerboardLayout.vala"
					col = 0;
#line 1892 "CheckerboardLayout.c"
				} else {
#line 493 "../src/Checkerboard/CheckerboardLayout.vala"
					col = self->priv->columns - 1;
#line 1896 "CheckerboardLayout.c"
				}
			}
#line 496 "../src/Checkerboard/CheckerboardLayout.vala"
			break;
#line 1901 "CheckerboardLayout.c"
		}
		default:
		{
#line 499 "../src/Checkerboard/CheckerboardLayout.vala"
			g_error ("CheckerboardLayout.vala:499: Bad compass direction %d", (gint) direction);
#line 1907 "CheckerboardLayout.c"
		}
	}
#line 502 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp13_ = checkerboard_layout_get_item_at_coordinate (self, col, row);
#line 502 "../src/Checkerboard/CheckerboardLayout.vala"
	new_item = _tmp13_;
#line 504 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp15_ = new_item;
#line 504 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp15_ == NULL) {
#line 504 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp14_ = direction == GTK_DIR_DOWN;
#line 1920 "CheckerboardLayout.c"
	} else {
#line 504 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp14_ = FALSE;
#line 1924 "CheckerboardLayout.c"
	}
#line 504 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp14_) {
#line 1928 "CheckerboardLayout.c"
		ViewCollection* _tmp16_;
		DataView* _tmp17_;
		CheckerboardItem* _tmp18_;
#line 506 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp16_ = self->priv->view;
#line 506 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp17_ = view_collection_get_last (_tmp16_);
#line 506 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (new_item);
#line 506 "../src/Checkerboard/CheckerboardLayout.vala"
		new_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 507 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp18_ = new_item;
#line 507 "../src/Checkerboard/CheckerboardLayout.vala"
		if (checkerboard_item_get_row (_tmp18_) <= checkerboard_item_get_row (item)) {
#line 508 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (new_item);
#line 508 "../src/Checkerboard/CheckerboardLayout.vala"
			new_item = NULL;
#line 1948 "CheckerboardLayout.c"
		}
	}
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp20_ = new_item;
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp20_ != NULL) {
#line 1955 "CheckerboardLayout.c"
		CheckerboardItem* _tmp21_;
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp21_ = new_item;
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp19_ = _tmp21_;
#line 1961 "CheckerboardLayout.c"
	} else {
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp19_ = item;
#line 1965 "CheckerboardLayout.c"
	}
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp22_ = _g_object_ref0 (_tmp19_);
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
	result = _tmp22_;
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (new_item);
#line 511 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 1975 "CheckerboardLayout.c"
}

CheckerboardItem*
checkerboard_layout_get_item_at_coordinate (CheckerboardLayout* self,
                                            gint col,
                                            gint row)
{
	CheckerboardLayoutLayoutRow** _tmp0_;
	gint _tmp0__length1;
	CheckerboardLayoutLayoutRow* item_row = NULL;
	CheckerboardLayoutLayoutRow** _tmp1_;
	gint _tmp1__length1;
	CheckerboardLayoutLayoutRow* _tmp2_;
	CheckerboardLayoutLayoutRow* _tmp3_;
	CheckerboardLayoutLayoutRow* _tmp4_;
	CheckerboardLayoutLayoutRow* _tmp5_;
	CheckerboardItem** _tmp6_;
	gint _tmp6__length1;
	CheckerboardLayoutLayoutRow* _tmp7_;
	CheckerboardItem** _tmp8_;
	gint _tmp8__length1;
	CheckerboardItem* _tmp9_;
	CheckerboardItem* _tmp10_;
	CheckerboardItem* result;
#line 514 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 515 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->item_rows;
#line 515 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0__length1 = self->priv->item_rows_length1;
#line 515 "../src/Checkerboard/CheckerboardLayout.vala"
	if (row >= _tmp0__length1) {
#line 516 "../src/Checkerboard/CheckerboardLayout.vala"
		result = NULL;
#line 516 "../src/Checkerboard/CheckerboardLayout.vala"
		return result;
#line 2012 "CheckerboardLayout.c"
	}
#line 518 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = self->priv->item_rows;
#line 518 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1__length1 = self->priv->item_rows_length1;
#line 518 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = _tmp1_[row];
#line 518 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3_ = _checkerboard_layout_layout_row_ref0 (_tmp2_);
#line 518 "../src/Checkerboard/CheckerboardLayout.vala"
	item_row = _tmp3_;
#line 519 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp4_ = item_row;
#line 519 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp4_ == NULL) {
#line 520 "../src/Checkerboard/CheckerboardLayout.vala"
		result = NULL;
#line 520 "../src/Checkerboard/CheckerboardLayout.vala"
		_checkerboard_layout_layout_row_unref0 (item_row);
#line 520 "../src/Checkerboard/CheckerboardLayout.vala"
		return result;
#line 2034 "CheckerboardLayout.c"
	}
#line 522 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp5_ = item_row;
#line 522 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp6_ = _tmp5_->items;
#line 522 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp6__length1 = _tmp5_->items_length1;
#line 522 "../src/Checkerboard/CheckerboardLayout.vala"
	if (col >= _tmp6__length1) {
#line 523 "../src/Checkerboard/CheckerboardLayout.vala"
		result = NULL;
#line 523 "../src/Checkerboard/CheckerboardLayout.vala"
		_checkerboard_layout_layout_row_unref0 (item_row);
#line 523 "../src/Checkerboard/CheckerboardLayout.vala"
		return result;
#line 2050 "CheckerboardLayout.c"
	}
#line 525 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp7_ = item_row;
#line 525 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp8_ = _tmp7_->items;
#line 525 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp8__length1 = _tmp7_->items_length1;
#line 525 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp9_ = _tmp8_[col];
#line 525 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 525 "../src/Checkerboard/CheckerboardLayout.vala"
	result = _tmp10_;
#line 525 "../src/Checkerboard/CheckerboardLayout.vala"
	_checkerboard_layout_layout_row_unref0 (item_row);
#line 525 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 2068 "CheckerboardLayout.c"
}

void
checkerboard_layout_set_drag_select_origin (CheckerboardLayout* self,
                                            gint x,
                                            gint y)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
#line 528 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 529 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_clear_drag_select (self);
#line 532 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 532 "../src/Checkerboard/CheckerboardLayout.vala"
	allocation = _tmp0_;
#line 534 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = allocation;
#line 534 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->drag_origin.x = CLAMP (x, 0, _tmp1_.width);
#line 535 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = allocation;
#line 535 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->drag_origin.y = CLAMP (y, 0, _tmp2_.height);
#line 2096 "CheckerboardLayout.c"
}

void
checkerboard_layout_set_drag_select_endpoint (CheckerboardLayout* self,
                                              gint x,
                                              gint y)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	GdkRectangle old_selection_band = {0};
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkPoint _tmp5_;
	Box _tmp6_ = {0};
	GdkRectangle _tmp7_ = {0};
	GdkWindow* _tmp8_;
#line 538 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 540 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 540 "../src/Checkerboard/CheckerboardLayout.vala"
	allocation = _tmp0_;
#line 542 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = allocation;
#line 542 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->drag_endpoint.x = CLAMP (x, 0, _tmp1_.width);
#line 543 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = allocation;
#line 543 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->drag_endpoint.y = CLAMP (y, 0, _tmp2_.height);
#line 547 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3_ = self->priv->selection_band;
#line 547 "../src/Checkerboard/CheckerboardLayout.vala"
	old_selection_band = _tmp3_;
#line 548 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp4_ = self->priv->drag_origin;
#line 548 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp5_ = self->priv->drag_endpoint;
#line 548 "../src/Checkerboard/CheckerboardLayout.vala"
	box_from_points (&_tmp4_, &_tmp5_, &_tmp6_);
#line 548 "../src/Checkerboard/CheckerboardLayout.vala"
	box_get_rectangle (&_tmp6_, &_tmp7_);
#line 548 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->selection_band = _tmp7_;
#line 551 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp8_ = gtk_widget_get_window ((GtkWidget*) self);
#line 551 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp8_ != NULL) {
#line 2147 "CheckerboardLayout.c"
		GdkRectangle _union_ = {0};
		GdkRectangle _tmp9_;
		GdkRectangle _tmp10_ = {0};
		GdkWindow* _tmp11_;
		GdkRectangle _tmp12_;
#line 553 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp9_ = old_selection_band;
#line 553 "../src/Checkerboard/CheckerboardLayout.vala"
		gdk_rectangle_union (&self->priv->selection_band, &_tmp9_, &_tmp10_);
#line 553 "../src/Checkerboard/CheckerboardLayout.vala"
		_union_ = _tmp10_;
#line 555 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp11_ = gtk_widget_get_window ((GtkWidget*) self);
#line 555 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp12_ = _union_;
#line 555 "../src/Checkerboard/CheckerboardLayout.vala"
		gdk_window_invalidate_rect (_tmp11_, &_tmp12_, FALSE);
#line 2165 "CheckerboardLayout.c"
	}
}

GeeList*
checkerboard_layout_items_in_selection_band (CheckerboardLayout* self)
{
	GdkRectangle _tmp0_;
	Dimensions _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GeeList* _tmp3_;
	GeeList* result;
#line 559 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 560 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->selection_band;
#line 560 "../src/Checkerboard/CheckerboardLayout.vala"
	dimensions_for_rectangle (&_tmp0_, &_tmp1_);
#line 560 "../src/Checkerboard/CheckerboardLayout.vala"
	if (!dimensions_has_area (&_tmp1_)) {
#line 561 "../src/Checkerboard/CheckerboardLayout.vala"
		result = NULL;
#line 561 "../src/Checkerboard/CheckerboardLayout.vala"
		return result;
#line 2189 "CheckerboardLayout.c"
	}
#line 563 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = self->priv->selection_band;
#line 563 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3_ = checkerboard_layout_intersection (self, &_tmp2_);
#line 563 "../src/Checkerboard/CheckerboardLayout.vala"
	result = _tmp3_;
#line 563 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 2199 "CheckerboardLayout.c"
}

gboolean
checkerboard_layout_is_drag_select_active (CheckerboardLayout* self)
{
	gboolean _tmp0_ = FALSE;
	GdkPoint _tmp1_;
	gboolean result;
#line 566 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 567 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = self->priv->drag_origin;
#line 567 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp1_.x >= 0) {
#line 2214 "CheckerboardLayout.c"
		GdkPoint _tmp2_;
#line 567 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = self->priv->drag_origin;
#line 567 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = _tmp2_.y >= 0;
#line 2220 "CheckerboardLayout.c"
	} else {
#line 567 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = FALSE;
#line 2224 "CheckerboardLayout.c"
	}
#line 567 "../src/Checkerboard/CheckerboardLayout.vala"
	result = _tmp0_;
#line 567 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 2230 "CheckerboardLayout.c"
}

void
checkerboard_layout_clear_drag_select (CheckerboardLayout* self)
{
#line 570 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/Checkerboard/CheckerboardLayout.vala"
	memset (&self->priv->selection_band, 0, sizeof (GdkRectangle));
#line 572 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->drag_origin.x = -1;
#line 573 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->drag_origin.y = -1;
#line 574 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->drag_endpoint.x = -1;
#line 575 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->drag_endpoint.y = -1;
#line 578 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2250 "CheckerboardLayout.c"
}

static void
checkerboard_layout_viewport_resized (CheckerboardLayout* self)
{
	GdkRectangle _tmp0_;
#line 581 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 583 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_update_visible_page (self);
#line 586 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->visible_page;
#line 586 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp0_.width != self->priv->last_width) {
#line 2265 "CheckerboardLayout.c"
		gint old_width = 0;
		GdkRectangle _tmp1_;
		GdkRectangle _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 587 "../src/Checkerboard/CheckerboardLayout.vala"
		old_width = self->priv->last_width;
#line 588 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp1_ = self->priv->visible_page;
#line 588 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->last_width = _tmp1_.width;
#line 590 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = self->priv->visible_page;
#line 590 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = g_strdup_printf ("viewport_resized (%d -> %d)", old_width, _tmp2_.width);
#line 590 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp4_ = _tmp3_;
#line 590 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_need_reflow (self, _tmp4_);
#line 590 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_free0 (_tmp4_);
#line 2287 "CheckerboardLayout.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 593 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp5_ = g_strdup_printf ("viewport_resized (same width=%d)", self->priv->last_width);
#line 593 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp6_ = _tmp5_;
#line 593 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_need_exposure (self, _tmp6_);
#line 593 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_free0 (_tmp6_);
#line 2299 "CheckerboardLayout.c"
	}
}

static void
checkerboard_layout_expose_items (CheckerboardLayout* self,
                                  const gchar* caller)
{
	GeeHashSet* new_exposed_items = NULL;
	GeeHashSet* _tmp0_;
	ViewCollection* _tmp1_;
	GeeList* items = NULL;
	GeeList* _tmp2_;
	GeeHashSet* _tmp22_;
	GeeHashSet* _tmp23_;
	ViewCollection* _tmp24_;
#line 597 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 597 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (caller != NULL);
#line 600 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = gee_hash_set_new (TYPE_CHECKERBOARD_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 600 "../src/Checkerboard/CheckerboardLayout.vala"
	new_exposed_items = _tmp0_;
#line 602 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = self->priv->view;
#line 602 "../src/Checkerboard/CheckerboardLayout.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp1_);
#line 604 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = checkerboard_layout_get_visible_items (self);
#line 604 "../src/Checkerboard/CheckerboardLayout.vala"
	items = _tmp2_;
#line 2331 "CheckerboardLayout.c"
	{
		GeeList* _item_list = NULL;
		GeeList* _tmp3_;
		gint _item_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _item_index = 0;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = items;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
		_item_list = _tmp3_;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp4_ = _item_list;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp6_ = _tmp5_;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
		_item_size = _tmp6_;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
		_item_index = -1;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
		while (TRUE) {
#line 2356 "CheckerboardLayout.c"
			gint _tmp7_;
			gint _tmp8_;
			CheckerboardItem* item = NULL;
			GeeList* _tmp9_;
			gpointer _tmp10_;
			GeeHashSet* _tmp11_;
			CheckerboardItem* _tmp12_;
			GeeHashSet* _tmp13_;
			CheckerboardItem* _tmp14_;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
			_item_index = _item_index + 1;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp7_ = _item_index;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp8_ = _item_size;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 2376 "CheckerboardLayout.c"
			}
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp9_ = _item_list;
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp10_ = gee_list_get (_tmp9_, _item_index);
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
			item = (CheckerboardItem*) _tmp10_;
#line 606 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp11_ = new_exposed_items;
#line 606 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp12_ = item;
#line 606 "../src/Checkerboard/CheckerboardLayout.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 609 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp13_ = self->priv->exposed_items;
#line 609 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp14_ = item;
#line 609 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp13_, _tmp14_)) {
#line 2396 "CheckerboardLayout.c"
				CheckerboardItem* _tmp15_;
#line 610 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp15_ = item;
#line 610 "../src/Checkerboard/CheckerboardLayout.vala"
				checkerboard_item_exposed (_tmp15_);
#line 2402 "CheckerboardLayout.c"
			}
#line 605 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (item);
#line 2406 "CheckerboardLayout.c"
		}
	}
	{
		GeeIterator* _item_it = NULL;
		GeeHashSet* _tmp16_;
		GeeIterator* _tmp17_;
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp16_ = self->priv->exposed_items;
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp17_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp16_);
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
		_item_it = _tmp17_;
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
		while (TRUE) {
#line 2421 "CheckerboardLayout.c"
			GeeIterator* _tmp18_;
			CheckerboardItem* item = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			CheckerboardItem* _tmp21_;
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp18_ = _item_it;
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 2433 "CheckerboardLayout.c"
			}
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp19_ = _item_it;
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
			item = (CheckerboardItem*) _tmp20_;
#line 615 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp21_ = item;
#line 615 "../src/Checkerboard/CheckerboardLayout.vala"
			checkerboard_item_unexposed (_tmp21_);
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (item);
#line 2447 "CheckerboardLayout.c"
		}
#line 614 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (_item_it);
#line 2451 "CheckerboardLayout.c"
	}
#line 618 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp22_ = new_exposed_items;
#line 618 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 618 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->exposed_items);
#line 618 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->exposed_items = _tmp23_;
#line 619 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->exposure_dirty = FALSE;
#line 624 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp24_ = self->priv->view;
#line 624 "../src/Checkerboard/CheckerboardLayout.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp24_);
#line 597 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (items);
#line 597 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (new_exposed_items);
#line 2471 "CheckerboardLayout.c"
}

static void
checkerboard_layout_unexpose_items (CheckerboardLayout* self,
                                    const gchar* caller)
{
	ViewCollection* _tmp0_;
	GeeHashSet* _tmp7_;
	ViewCollection* _tmp8_;
#line 630 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 630 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (caller != NULL);
#line 631 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->view;
#line 631 "../src/Checkerboard/CheckerboardLayout.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp0_);
#line 2489 "CheckerboardLayout.c"
	{
		GeeIterator* _item_it = NULL;
		GeeHashSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp1_ = self->priv->exposed_items;
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
		_item_it = _tmp2_;
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
		while (TRUE) {
#line 2502 "CheckerboardLayout.c"
			GeeIterator* _tmp3_;
			CheckerboardItem* item = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			CheckerboardItem* _tmp6_;
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp3_ = _item_it;
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 2514 "CheckerboardLayout.c"
			}
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp4_ = _item_it;
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
			item = (CheckerboardItem*) _tmp5_;
#line 634 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp6_ = item;
#line 634 "../src/Checkerboard/CheckerboardLayout.vala"
			checkerboard_item_unexposed (_tmp6_);
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (item);
#line 2528 "CheckerboardLayout.c"
		}
#line 633 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (_item_it);
#line 2532 "CheckerboardLayout.c"
	}
#line 636 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp7_ = self->priv->exposed_items;
#line 636 "../src/Checkerboard/CheckerboardLayout.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp7_);
#line 637 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->exposure_dirty = FALSE;
#line 642 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp8_ = self->priv->view;
#line 642 "../src/Checkerboard/CheckerboardLayout.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp8_);
#line 2544 "CheckerboardLayout.c"
}

static void
checkerboard_layout_reflow (CheckerboardLayout* self,
                            const gchar* caller)
{
	const gchar* _tmp0_;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp1_ = {0};
	gint _tmp2_ = 0;
	GdkRectangle _tmp3_;
	gint visible_width = 0;
	gint total_items = 0;
	ViewCollection* _tmp6_;
	gboolean _tmp8_ = FALSE;
	CheckerboardItem* _tmp9_;
	gint max_cols = 0;
	gint max_rows = 0;
	gint row = 0;
	gint tallest = 0;
	gint widest = 0;
	gint row_alignment_point = 0;
	gint total_width = 0;
	gint col = 0;
	gint* column_widths = NULL;
	gint* _tmp23_;
	gint column_widths_length1;
	gint _column_widths_size_;
	gint* row_heights = NULL;
	gint* _tmp24_;
	gint row_heights_length1;
	gint _row_heights_size_;
	gint* alignment_points = NULL;
	gint* _tmp25_;
	gint alignment_points_length1;
	gint _alignment_points_size_;
	gint gutter = 0;
	CheckerboardLayoutLayoutRow** _tmp76_;
	gint x = 0;
	gint y = 0;
	CheckerboardLayoutLayoutRow* current_row = NULL;
	CheckerboardLayoutLayoutRow* _tmp115_;
	gint total_height = 0;
	gint* _tmp119_;
	gint _tmp119__length1;
	gint _tmp120_;
	gboolean _tmp121_ = FALSE;
	GtkAllocation _tmp122_;
#line 648 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 648 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (caller != NULL);
#line 649 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->reflow_needed = FALSE;
#line 652 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->message;
#line 652 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp0_ != NULL) {
#line 653 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 2605 "CheckerboardLayout.c"
	}
#line 656 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp1_);
#line 656 "../src/Checkerboard/CheckerboardLayout.vala"
	allocation = _tmp1_;
#line 658 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp3_ = self->priv->visible_page;
#line 658 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp3_.width > 0) {
#line 2615 "CheckerboardLayout.c"
		GdkRectangle _tmp4_;
#line 658 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp4_ = self->priv->visible_page;
#line 658 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = _tmp4_.width;
#line 2621 "CheckerboardLayout.c"
	} else {
		GtkAllocation _tmp5_;
#line 658 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp5_ = allocation;
#line 658 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = _tmp5_.width;
#line 2628 "CheckerboardLayout.c"
	}
#line 658 "../src/Checkerboard/CheckerboardLayout.vala"
	visible_width = _tmp2_;
#line 666 "../src/Checkerboard/CheckerboardLayout.vala"
	if (visible_width <= 1) {
#line 667 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 2636 "CheckerboardLayout.c"
	}
#line 669 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp6_ = self->priv->view;
#line 669 "../src/Checkerboard/CheckerboardLayout.vala"
	total_items = data_collection_get_count ((DataCollection*) _tmp6_);
#line 672 "../src/Checkerboard/CheckerboardLayout.vala"
	if (total_items == 0) {
#line 2644 "CheckerboardLayout.c"
		CheckerboardLayoutLayoutRow** _tmp7_;
#line 673 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, visible_width, 0);
#line 674 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp7_ = g_new0 (CheckerboardLayoutLayoutRow*, 0 + 1);
#line 674 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->item_rows = (_vala_array_free (self->priv->item_rows, self->priv->item_rows_length1, (GDestroyNotify) checkerboard_layout_layout_row_unref), NULL);
#line 674 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->item_rows = _tmp7_;
#line 674 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->item_rows_length1 = 0;
#line 674 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->_item_rows_size_ = self->priv->item_rows_length1;
#line 676 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 2660 "CheckerboardLayout.c"
	}
#line 684 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp9_ = self->priv->anchor;
#line 684 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp9_ == NULL) {
#line 684 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp8_ = TRUE;
#line 2668 "CheckerboardLayout.c"
	} else {
		CheckerboardItem* _tmp10_;
#line 684 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp10_ = self->priv->anchor;
#line 684 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp8_ = !data_view_is_visible ((DataView*) _tmp10_);
#line 2675 "CheckerboardLayout.c"
	}
#line 684 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp8_) {
#line 685 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_update_anchor (self);
#line 2681 "CheckerboardLayout.c"
	}
#line 688 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows = (_vala_array_free (self->priv->item_rows, self->priv->item_rows_length1, (GDestroyNotify) checkerboard_layout_layout_row_unref), NULL);
#line 688 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows = NULL;
#line 688 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows_length1 = 0;
#line 688 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->_item_rows_size_ = self->priv->item_rows_length1;
#line 693 "../src/Checkerboard/CheckerboardLayout.vala"
	max_cols = 0;
#line 694 "../src/Checkerboard/CheckerboardLayout.vala"
	if (self->priv->scale > 0) {
#line 2695 "CheckerboardLayout.c"
		gint remaining_width = 0;
		gint max_item_width = 0;
#line 696 "../src/Checkerboard/CheckerboardLayout.vala"
		remaining_width = visible_width - (CHECKERBOARD_LAYOUT_COLUMN_GUTTER_PADDING * 2);
#line 697 "../src/Checkerboard/CheckerboardLayout.vala"
		max_item_width = checkerboard_item_get_max_width (self->priv->scale);
#line 698 "../src/Checkerboard/CheckerboardLayout.vala"
		max_cols = remaining_width / max_item_width;
#line 699 "../src/Checkerboard/CheckerboardLayout.vala"
		if (max_cols <= 0) {
#line 700 "../src/Checkerboard/CheckerboardLayout.vala"
			max_cols = 1;
#line 2708 "CheckerboardLayout.c"
		}
#line 703 "../src/Checkerboard/CheckerboardLayout.vala"
		while (TRUE) {
#line 2712 "CheckerboardLayout.c"
			gboolean _tmp11_ = FALSE;
			gint _tmp12_;
#line 703 "../src/Checkerboard/CheckerboardLayout.vala"
			if (max_cols > 1) {
#line 704 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp11_ = ((max_cols * max_item_width) + ((max_cols - 1) * CHECKERBOARD_LAYOUT_COLUMN_GUTTER_PADDING)) > remaining_width;
#line 2719 "CheckerboardLayout.c"
			} else {
#line 703 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp11_ = FALSE;
#line 2723 "CheckerboardLayout.c"
			}
#line 703 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!_tmp11_) {
#line 703 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 2729 "CheckerboardLayout.c"
			}
#line 709 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp12_ = max_cols;
#line 709 "../src/Checkerboard/CheckerboardLayout.vala"
			max_cols = _tmp12_ - 1;
#line 2735 "CheckerboardLayout.c"
		}
#line 713 "../src/Checkerboard/CheckerboardLayout.vala"
		if (total_items < max_cols) {
#line 714 "../src/Checkerboard/CheckerboardLayout.vala"
			max_cols = total_items;
#line 2741 "CheckerboardLayout.c"
		}
	} else {
		gint x = 0;
		gint col = 0;
		gint row_width = 0;
		gint widest_row = 0;
#line 721 "../src/Checkerboard/CheckerboardLayout.vala"
		x = CHECKERBOARD_LAYOUT_COLUMN_GUTTER_PADDING;
#line 722 "../src/Checkerboard/CheckerboardLayout.vala"
		col = 0;
#line 723 "../src/Checkerboard/CheckerboardLayout.vala"
		row_width = 0;
#line 724 "../src/Checkerboard/CheckerboardLayout.vala"
		widest_row = 0;
#line 2756 "CheckerboardLayout.c"
		{
			gint ctr = 0;
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
			ctr = 0;
#line 2761 "CheckerboardLayout.c"
			{
				gboolean _tmp13_ = FALSE;
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp13_ = TRUE;
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
				while (TRUE) {
#line 2768 "CheckerboardLayout.c"
					CheckerboardItem* item = NULL;
					ViewCollection* _tmp15_;
					DataObject* _tmp16_;
					Dimensions req = {0};
					CheckerboardItem* _tmp17_;
					Dimensions _tmp18_;
					Dimensions _tmp19_;
					Dimensions _tmp20_;
					Dimensions _tmp21_;
					gint _tmp22_;
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
					if (!_tmp13_) {
#line 2781 "CheckerboardLayout.c"
						gint _tmp14_;
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp14_ = ctr;
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
						ctr = _tmp14_ + 1;
#line 2787 "CheckerboardLayout.c"
					}
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp13_ = FALSE;
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
					if (!(ctr < total_items)) {
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
						break;
#line 2795 "CheckerboardLayout.c"
					}
#line 727 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp15_ = self->priv->view;
#line 727 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp16_ = data_collection_get_at ((DataCollection*) _tmp15_, ctr);
#line 727 "../src/Checkerboard/CheckerboardLayout.vala"
					item = G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 728 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp17_ = item;
#line 728 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp18_ = _tmp17_->requisition;
#line 728 "../src/Checkerboard/CheckerboardLayout.vala"
					req = _tmp18_;
#line 731 "../src/Checkerboard/CheckerboardLayout.vala"
					_vala_assert (dimensions_has_area (&req), "req.has_area ()");
#line 734 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp19_ = req;
#line 734 "../src/Checkerboard/CheckerboardLayout.vala"
					if (((x + _tmp19_.width) + CHECKERBOARD_LAYOUT_COLUMN_GUTTER_PADDING) > visible_width) {
#line 735 "../src/Checkerboard/CheckerboardLayout.vala"
						if (row_width > widest_row) {
#line 736 "../src/Checkerboard/CheckerboardLayout.vala"
							widest_row = row_width;
#line 737 "../src/Checkerboard/CheckerboardLayout.vala"
							max_cols = col;
#line 2821 "CheckerboardLayout.c"
						}
#line 740 "../src/Checkerboard/CheckerboardLayout.vala"
						col = 0;
#line 741 "../src/Checkerboard/CheckerboardLayout.vala"
						x = CHECKERBOARD_LAYOUT_COLUMN_GUTTER_PADDING;
#line 742 "../src/Checkerboard/CheckerboardLayout.vala"
						row_width = 0;
#line 2829 "CheckerboardLayout.c"
					}
#line 745 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp20_ = req;
#line 745 "../src/Checkerboard/CheckerboardLayout.vala"
					x += _tmp20_.width + CHECKERBOARD_LAYOUT_COLUMN_GUTTER_PADDING;
#line 746 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp21_ = req;
#line 746 "../src/Checkerboard/CheckerboardLayout.vala"
					row_width += _tmp21_.width;
#line 748 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp22_ = col;
#line 748 "../src/Checkerboard/CheckerboardLayout.vala"
					col = _tmp22_ + 1;
#line 726 "../src/Checkerboard/CheckerboardLayout.vala"
					_g_object_unref0 (item);
#line 2845 "CheckerboardLayout.c"
				}
			}
		}
#line 752 "../src/Checkerboard/CheckerboardLayout.vala"
		if (row_width > widest_row) {
#line 753 "../src/Checkerboard/CheckerboardLayout.vala"
			max_cols = col;
#line 2853 "CheckerboardLayout.c"
		}
	}
#line 761 "../src/Checkerboard/CheckerboardLayout.vala"
	_vala_assert (max_cols > 0, "max_cols > 0");
#line 762 "../src/Checkerboard/CheckerboardLayout.vala"
	max_rows = (total_items / max_cols) + 1;
#line 766 "../src/Checkerboard/CheckerboardLayout.vala"
	row = 0;
#line 767 "../src/Checkerboard/CheckerboardLayout.vala"
	tallest = 0;
#line 768 "../src/Checkerboard/CheckerboardLayout.vala"
	widest = 0;
#line 769 "../src/Checkerboard/CheckerboardLayout.vala"
	row_alignment_point = 0;
#line 770 "../src/Checkerboard/CheckerboardLayout.vala"
	total_width = 0;
#line 771 "../src/Checkerboard/CheckerboardLayout.vala"
	col = 0;
#line 772 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp23_ = g_new0 (gint, max_cols);
#line 772 "../src/Checkerboard/CheckerboardLayout.vala"
	column_widths = _tmp23_;
#line 772 "../src/Checkerboard/CheckerboardLayout.vala"
	column_widths_length1 = max_cols;
#line 772 "../src/Checkerboard/CheckerboardLayout.vala"
	_column_widths_size_ = column_widths_length1;
#line 773 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp24_ = g_new0 (gint, max_rows);
#line 773 "../src/Checkerboard/CheckerboardLayout.vala"
	row_heights = _tmp24_;
#line 773 "../src/Checkerboard/CheckerboardLayout.vala"
	row_heights_length1 = max_rows;
#line 773 "../src/Checkerboard/CheckerboardLayout.vala"
	_row_heights_size_ = row_heights_length1;
#line 774 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp25_ = g_new0 (gint, max_rows);
#line 774 "../src/Checkerboard/CheckerboardLayout.vala"
	alignment_points = _tmp25_;
#line 774 "../src/Checkerboard/CheckerboardLayout.vala"
	alignment_points_length1 = max_rows;
#line 774 "../src/Checkerboard/CheckerboardLayout.vala"
	_alignment_points_size_ = alignment_points_length1;
#line 775 "../src/Checkerboard/CheckerboardLayout.vala"
	gutter = 0;
#line 2898 "CheckerboardLayout.c"
	{
		gboolean _tmp26_ = FALSE;
#line 777 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp26_ = TRUE;
#line 777 "../src/Checkerboard/CheckerboardLayout.vala"
		while (TRUE) {
#line 777 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!_tmp26_) {
#line 2907 "CheckerboardLayout.c"
			}
#line 777 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp26_ = FALSE;
#line 2911 "CheckerboardLayout.c"
			{
				gint ctr = 0;
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
				ctr = 0;
#line 2916 "CheckerboardLayout.c"
				{
					gboolean _tmp27_ = FALSE;
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp27_ = TRUE;
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
					while (TRUE) {
#line 2923 "CheckerboardLayout.c"
						CheckerboardItem* item = NULL;
						ViewCollection* _tmp29_;
						DataObject* _tmp30_;
						Dimensions req = {0};
						CheckerboardItem* _tmp31_;
						Dimensions _tmp32_;
						gint alignment_point = 0;
						CheckerboardItem* _tmp33_;
						Dimensions _tmp34_;
						Dimensions _tmp35_;
						Dimensions _tmp37_;
						gint* _tmp39_;
						gint _tmp39__length1;
						gint _tmp40_;
						Dimensions _tmp41_;
						gint _tmp47_;
						gint _tmp48_;
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
						if (!_tmp27_) {
#line 2943 "CheckerboardLayout.c"
							gint _tmp28_;
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp28_ = ctr;
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
							ctr = _tmp28_ + 1;
#line 2949 "CheckerboardLayout.c"
						}
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp27_ = FALSE;
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
						if (!(ctr < total_items)) {
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
							break;
#line 2957 "CheckerboardLayout.c"
						}
#line 779 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp29_ = self->priv->view;
#line 779 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp30_ = data_collection_get_at ((DataCollection*) _tmp29_, ctr);
#line 779 "../src/Checkerboard/CheckerboardLayout.vala"
						item = G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 780 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp31_ = item;
#line 780 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp32_ = _tmp31_->requisition;
#line 780 "../src/Checkerboard/CheckerboardLayout.vala"
						req = _tmp32_;
#line 781 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp33_ = item;
#line 781 "../src/Checkerboard/CheckerboardLayout.vala"
						alignment_point = checkerboard_item_get_alignment_point (_tmp33_);
#line 784 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp34_ = req;
#line 784 "../src/Checkerboard/CheckerboardLayout.vala"
						_vala_assert (alignment_point < _tmp34_.height, "alignment_point < req.height");
#line 786 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp35_ = req;
#line 786 "../src/Checkerboard/CheckerboardLayout.vala"
						if (_tmp35_.height > tallest) {
#line 2983 "CheckerboardLayout.c"
							Dimensions _tmp36_;
#line 787 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp36_ = req;
#line 787 "../src/Checkerboard/CheckerboardLayout.vala"
							tallest = _tmp36_.height;
#line 2989 "CheckerboardLayout.c"
						}
#line 789 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp37_ = req;
#line 789 "../src/Checkerboard/CheckerboardLayout.vala"
						if (_tmp37_.width > widest) {
#line 2995 "CheckerboardLayout.c"
							Dimensions _tmp38_;
#line 790 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp38_ = req;
#line 790 "../src/Checkerboard/CheckerboardLayout.vala"
							widest = _tmp38_.width;
#line 3001 "CheckerboardLayout.c"
						}
#line 792 "../src/Checkerboard/CheckerboardLayout.vala"
						if (alignment_point > row_alignment_point) {
#line 793 "../src/Checkerboard/CheckerboardLayout.vala"
							row_alignment_point = alignment_point;
#line 3007 "CheckerboardLayout.c"
						}
#line 797 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp39_ = column_widths;
#line 797 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp39__length1 = column_widths_length1;
#line 797 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp40_ = _tmp39_[col];
#line 797 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp41_ = req;
#line 797 "../src/Checkerboard/CheckerboardLayout.vala"
						if (_tmp40_ < _tmp41_.width) {
#line 3019 "CheckerboardLayout.c"
							gint* _tmp42_;
							gint _tmp42__length1;
							gint _tmp43_;
							gint* _tmp44_;
							gint _tmp44__length1;
							Dimensions _tmp45_;
							Dimensions _tmp46_;
#line 798 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp42_ = column_widths;
#line 798 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp42__length1 = column_widths_length1;
#line 798 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp43_ = _tmp42_[col];
#line 798 "../src/Checkerboard/CheckerboardLayout.vala"
							total_width -= _tmp43_;
#line 799 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp44_ = column_widths;
#line 799 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp44__length1 = column_widths_length1;
#line 799 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp45_ = req;
#line 799 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp44_[col] = _tmp45_.width;
#line 800 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp46_ = req;
#line 800 "../src/Checkerboard/CheckerboardLayout.vala"
							total_width += _tmp46_.width;
#line 3047 "CheckerboardLayout.c"
						}
#line 803 "../src/Checkerboard/CheckerboardLayout.vala"
						col = col + 1;
#line 803 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp47_ = col;
#line 803 "../src/Checkerboard/CheckerboardLayout.vala"
						_tmp48_ = max_cols;
#line 803 "../src/Checkerboard/CheckerboardLayout.vala"
						if (_tmp47_ >= _tmp48_) {
#line 3057 "CheckerboardLayout.c"
							gint* _tmp49_;
							gint _tmp49__length1;
							gint* _tmp50_;
							gint _tmp50__length1;
							gint _tmp51_;
							gint _tmp52_;
#line 804 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp49_ = alignment_points;
#line 804 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp49__length1 = alignment_points_length1;
#line 804 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp49_[row] = row_alignment_point;
#line 805 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp50_ = row_heights;
#line 805 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp50__length1 = row_heights_length1;
#line 805 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp51_ = row;
#line 805 "../src/Checkerboard/CheckerboardLayout.vala"
							row = _tmp51_ + 1;
#line 805 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp52_ = tallest;
#line 805 "../src/Checkerboard/CheckerboardLayout.vala"
							_tmp50_[_tmp51_] = _tmp52_;
#line 807 "../src/Checkerboard/CheckerboardLayout.vala"
							col = 0;
#line 808 "../src/Checkerboard/CheckerboardLayout.vala"
							row_alignment_point = 0;
#line 809 "../src/Checkerboard/CheckerboardLayout.vala"
							tallest = 0;
#line 3088 "CheckerboardLayout.c"
						}
#line 778 "../src/Checkerboard/CheckerboardLayout.vala"
						_g_object_unref0 (item);
#line 3092 "CheckerboardLayout.c"
					}
				}
			}
#line 814 "../src/Checkerboard/CheckerboardLayout.vala"
			if (col != 0) {
#line 3098 "CheckerboardLayout.c"
				gint* _tmp53_;
				gint _tmp53__length1;
				gint* _tmp54_;
				gint _tmp54__length1;
#line 815 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp53_ = alignment_points;
#line 815 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp53__length1 = alignment_points_length1;
#line 815 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp53_[row] = row_alignment_point;
#line 816 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp54_ = row_heights;
#line 816 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp54__length1 = row_heights_length1;
#line 816 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp54_[row] = tallest;
#line 3115 "CheckerboardLayout.c"
			}
#line 821 "../src/Checkerboard/CheckerboardLayout.vala"
			gutter = (visible_width - total_width) / (max_cols + 1);
#line 824 "../src/Checkerboard/CheckerboardLayout.vala"
			if (max_cols == 1) {
#line 825 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 3123 "CheckerboardLayout.c"
			}
#line 830 "../src/Checkerboard/CheckerboardLayout.vala"
			if (gutter < CHECKERBOARD_LAYOUT_COLUMN_GUTTER_PADDING) {
#line 3127 "CheckerboardLayout.c"
				gint _tmp55_;
				gint* _tmp56_;
				gint* _tmp57_;
				gint* _tmp58_;
#line 831 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp55_ = max_cols;
#line 831 "../src/Checkerboard/CheckerboardLayout.vala"
				max_cols = _tmp55_ - 1;
#line 832 "../src/Checkerboard/CheckerboardLayout.vala"
				max_rows = (total_items / max_cols) + 1;
#line 839 "../src/Checkerboard/CheckerboardLayout.vala"
				col = 0;
#line 840 "../src/Checkerboard/CheckerboardLayout.vala"
				row = 0;
#line 841 "../src/Checkerboard/CheckerboardLayout.vala"
				tallest = 0;
#line 842 "../src/Checkerboard/CheckerboardLayout.vala"
				widest = 0;
#line 843 "../src/Checkerboard/CheckerboardLayout.vala"
				total_width = 0;
#line 844 "../src/Checkerboard/CheckerboardLayout.vala"
				row_alignment_point = 0;
#line 845 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp56_ = g_new0 (gint, max_cols);
#line 845 "../src/Checkerboard/CheckerboardLayout.vala"
				column_widths = (g_free (column_widths), NULL);
#line 845 "../src/Checkerboard/CheckerboardLayout.vala"
				column_widths = _tmp56_;
#line 845 "../src/Checkerboard/CheckerboardLayout.vala"
				column_widths_length1 = max_cols;
#line 845 "../src/Checkerboard/CheckerboardLayout.vala"
				_column_widths_size_ = column_widths_length1;
#line 846 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp57_ = g_new0 (gint, max_rows);
#line 846 "../src/Checkerboard/CheckerboardLayout.vala"
				row_heights = (g_free (row_heights), NULL);
#line 846 "../src/Checkerboard/CheckerboardLayout.vala"
				row_heights = _tmp57_;
#line 846 "../src/Checkerboard/CheckerboardLayout.vala"
				row_heights_length1 = max_rows;
#line 846 "../src/Checkerboard/CheckerboardLayout.vala"
				_row_heights_size_ = row_heights_length1;
#line 847 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp58_ = g_new0 (gint, max_rows);
#line 847 "../src/Checkerboard/CheckerboardLayout.vala"
				alignment_points = (g_free (alignment_points), NULL);
#line 847 "../src/Checkerboard/CheckerboardLayout.vala"
				alignment_points = _tmp58_;
#line 847 "../src/Checkerboard/CheckerboardLayout.vala"
				alignment_points_length1 = max_rows;
#line 847 "../src/Checkerboard/CheckerboardLayout.vala"
				_alignment_points_size_ = alignment_points_length1;
#line 3180 "CheckerboardLayout.c"
			} else {
#line 849 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 3184 "CheckerboardLayout.c"
			}
		}
	}
#line 861 "../src/Checkerboard/CheckerboardLayout.vala"
	col = 0;
#line 862 "../src/Checkerboard/CheckerboardLayout.vala"
	row = 0;
#line 3192 "CheckerboardLayout.c"
	{
		gint ctr = 0;
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
		ctr = 0;
#line 3197 "CheckerboardLayout.c"
		{
			gboolean _tmp59_ = FALSE;
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp59_ = TRUE;
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
			while (TRUE) {
#line 3204 "CheckerboardLayout.c"
				CheckerboardItem* item = NULL;
				ViewCollection* _tmp61_;
				DataObject* _tmp62_;
				Dimensions req = {0};
				CheckerboardItem* _tmp63_;
				Dimensions _tmp64_;
				gint true_height = 0;
				Dimensions _tmp65_;
				gint* _tmp66_;
				gint _tmp66__length1;
				gint _tmp67_;
				CheckerboardItem* _tmp68_;
				Dimensions _tmp69_;
				gint* _tmp70_;
				gint _tmp70__length1;
				gint _tmp71_;
				gint _tmp73_;
				gint _tmp74_;
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
				if (!_tmp59_) {
#line 3225 "CheckerboardLayout.c"
					gint _tmp60_;
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp60_ = ctr;
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
					ctr = _tmp60_ + 1;
#line 3231 "CheckerboardLayout.c"
				}
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp59_ = FALSE;
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
				if (!(ctr < total_items)) {
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
					break;
#line 3239 "CheckerboardLayout.c"
				}
#line 865 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp61_ = self->priv->view;
#line 865 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp62_ = data_collection_get_at ((DataCollection*) _tmp61_, ctr);
#line 865 "../src/Checkerboard/CheckerboardLayout.vala"
				item = G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 866 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp63_ = item;
#line 866 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp64_ = _tmp63_->requisition;
#line 866 "../src/Checkerboard/CheckerboardLayout.vala"
				req = _tmp64_;
#line 871 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp65_ = req;
#line 871 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp66_ = alignment_points;
#line 871 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp66__length1 = alignment_points_length1;
#line 871 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp67_ = _tmp66_[row];
#line 871 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp68_ = item;
#line 871 "../src/Checkerboard/CheckerboardLayout.vala"
				true_height = _tmp65_.height + (_tmp67_ - checkerboard_item_get_alignment_point (_tmp68_));
#line 872 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp69_ = req;
#line 872 "../src/Checkerboard/CheckerboardLayout.vala"
				_vala_assert (true_height >= _tmp69_.height, "true_height >= req.height");
#line 875 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp70_ = row_heights;
#line 875 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp70__length1 = row_heights_length1;
#line 875 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp71_ = _tmp70_[row];
#line 875 "../src/Checkerboard/CheckerboardLayout.vala"
				if (true_height > _tmp71_) {
#line 3277 "CheckerboardLayout.c"
					gint* _tmp72_;
					gint _tmp72__length1;
#line 880 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp72_ = row_heights;
#line 880 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp72__length1 = row_heights_length1;
#line 880 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp72_[row] = true_height;
#line 3286 "CheckerboardLayout.c"
				}
#line 884 "../src/Checkerboard/CheckerboardLayout.vala"
				col = col + 1;
#line 884 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp73_ = col;
#line 884 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp74_ = max_cols;
#line 884 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp73_ >= _tmp74_) {
#line 3296 "CheckerboardLayout.c"
					gint _tmp75_;
#line 885 "../src/Checkerboard/CheckerboardLayout.vala"
					col = 0;
#line 886 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp75_ = row;
#line 886 "../src/Checkerboard/CheckerboardLayout.vala"
					row = _tmp75_ + 1;
#line 3304 "CheckerboardLayout.c"
				}
#line 864 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (item);
#line 3308 "CheckerboardLayout.c"
			}
		}
	}
#line 891 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp76_ = g_new0 (CheckerboardLayoutLayoutRow*, max_rows + 1);
#line 891 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows = (_vala_array_free (self->priv->item_rows, self->priv->item_rows_length1, (GDestroyNotify) checkerboard_layout_layout_row_unref), NULL);
#line 891 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows = _tmp76_;
#line 891 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows_length1 = max_rows;
#line 891 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->_item_rows_size_ = self->priv->item_rows_length1;
#line 894 "../src/Checkerboard/CheckerboardLayout.vala"
	x = gutter;
#line 895 "../src/Checkerboard/CheckerboardLayout.vala"
	y = CHECKERBOARD_LAYOUT_TOP_PADDING;
#line 896 "../src/Checkerboard/CheckerboardLayout.vala"
	col = 0;
#line 897 "../src/Checkerboard/CheckerboardLayout.vala"
	row = 0;
#line 898 "../src/Checkerboard/CheckerboardLayout.vala"
	current_row = NULL;
#line 3332 "CheckerboardLayout.c"
	{
		gint ctr = 0;
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
		ctr = 0;
#line 3337 "CheckerboardLayout.c"
		{
			gboolean _tmp77_ = FALSE;
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp77_ = TRUE;
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
			while (TRUE) {
#line 3344 "CheckerboardLayout.c"
				CheckerboardItem* item = NULL;
				ViewCollection* _tmp79_;
				DataObject* _tmp80_;
				Dimensions req = {0};
				CheckerboardItem* _tmp81_;
				Dimensions _tmp82_;
				gint xpadding = 0;
				gint* _tmp83_;
				gint _tmp83__length1;
				gint _tmp84_;
				Dimensions _tmp85_;
				gint ypadding = 0;
				gint* _tmp86_;
				gint _tmp86__length1;
				gint _tmp87_;
				CheckerboardItem* _tmp88_;
				CheckerboardItem* _tmp89_;
				CheckerboardItem* _tmp90_;
				CheckerboardItem* _tmp91_;
				Dimensions _tmp92_;
				CheckerboardItem* _tmp93_;
				Dimensions _tmp94_;
				CheckerboardItem* _tmp95_;
				CheckerboardLayoutLayoutRow* _tmp96_;
				CheckerboardLayoutLayoutRow* _tmp100_;
				CheckerboardItem** _tmp101_;
				gint _tmp101__length1;
				CheckerboardItem* _tmp102_;
				CheckerboardItem* _tmp103_;
				gint* _tmp104_;
				gint _tmp104__length1;
				gint _tmp105_;
				gint _tmp106_;
				gint _tmp107_;
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
				if (!_tmp77_) {
#line 3381 "CheckerboardLayout.c"
					gint _tmp78_;
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp78_ = ctr;
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
					ctr = _tmp78_ + 1;
#line 3387 "CheckerboardLayout.c"
				}
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp77_ = FALSE;
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
				if (!(ctr < total_items)) {
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
					break;
#line 3395 "CheckerboardLayout.c"
				}
#line 901 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp79_ = self->priv->view;
#line 901 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp80_ = data_collection_get_at ((DataCollection*) _tmp79_, ctr);
#line 901 "../src/Checkerboard/CheckerboardLayout.vala"
				item = G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem);
#line 902 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp81_ = item;
#line 902 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp82_ = _tmp81_->requisition;
#line 902 "../src/Checkerboard/CheckerboardLayout.vala"
				req = _tmp82_;
#line 905 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp83_ = column_widths;
#line 905 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp83__length1 = column_widths_length1;
#line 905 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp84_ = _tmp83_[col];
#line 905 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp85_ = req;
#line 905 "../src/Checkerboard/CheckerboardLayout.vala"
				xpadding = (_tmp84_ - _tmp85_.width) / 2;
#line 906 "../src/Checkerboard/CheckerboardLayout.vala"
				_vala_assert (xpadding >= 0, "xpadding >= 0");
#line 909 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp86_ = alignment_points;
#line 909 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp86__length1 = alignment_points_length1;
#line 909 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp87_ = _tmp86_[row];
#line 909 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp88_ = item;
#line 909 "../src/Checkerboard/CheckerboardLayout.vala"
				ypadding = _tmp87_ - checkerboard_item_get_alignment_point (_tmp88_);
#line 910 "../src/Checkerboard/CheckerboardLayout.vala"
				_vala_assert (ypadding >= 0, "ypadding >= 0");
#line 913 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp89_ = item;
#line 913 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp89_->allocation.x = x + xpadding;
#line 914 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp90_ = item;
#line 914 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp90_->allocation.y = y + ypadding;
#line 915 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp91_ = item;
#line 915 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp92_ = req;
#line 915 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp91_->allocation.width = _tmp92_.width;
#line 916 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp93_ = item;
#line 916 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp94_ = req;
#line 916 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp93_->allocation.height = _tmp94_.height;
#line 917 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp95_ = item;
#line 917 "../src/Checkerboard/CheckerboardLayout.vala"
				checkerboard_item_set_grid_coordinates (_tmp95_, col, row);
#line 920 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp96_ = current_row;
#line 920 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp96_ == NULL) {
#line 3461 "CheckerboardLayout.c"
					gint* _tmp97_;
					gint _tmp97__length1;
					gint _tmp98_;
					CheckerboardLayoutLayoutRow* _tmp99_;
#line 921 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp97_ = row_heights;
#line 921 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp97__length1 = row_heights_length1;
#line 921 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp98_ = _tmp97_[row];
#line 921 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp99_ = checkerboard_layout_layout_row_new (y, _tmp98_, max_cols);
#line 921 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (current_row);
#line 921 "../src/Checkerboard/CheckerboardLayout.vala"
					current_row = _tmp99_;
#line 3478 "CheckerboardLayout.c"
				}
#line 923 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp100_ = current_row;
#line 923 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp101_ = _tmp100_->items;
#line 923 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp101__length1 = _tmp100_->items_length1;
#line 923 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp102_ = item;
#line 923 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp103_ = _g_object_ref0 (_tmp102_);
#line 923 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (_tmp101_[col]);
#line 923 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp101_[col] = _tmp103_;
#line 925 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp104_ = column_widths;
#line 925 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp104__length1 = column_widths_length1;
#line 925 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp105_ = _tmp104_[col];
#line 925 "../src/Checkerboard/CheckerboardLayout.vala"
				x += _tmp105_ + gutter;
#line 928 "../src/Checkerboard/CheckerboardLayout.vala"
				col = col + 1;
#line 928 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp106_ = col;
#line 928 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp107_ = max_cols;
#line 928 "../src/Checkerboard/CheckerboardLayout.vala"
				if (_tmp106_ >= _tmp107_) {
#line 3510 "CheckerboardLayout.c"
					CheckerboardLayoutLayoutRow* _tmp108_;
					CheckerboardLayoutLayoutRow** _tmp109_;
					gint _tmp109__length1;
					CheckerboardLayoutLayoutRow* _tmp110_;
					CheckerboardLayoutLayoutRow* _tmp111_;
					gint* _tmp112_;
					gint _tmp112__length1;
					gint _tmp113_;
					gint _tmp114_;
#line 929 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp108_ = current_row;
#line 929 "../src/Checkerboard/CheckerboardLayout.vala"
					_vala_assert (_tmp108_ != NULL, "current_row != null");
#line 930 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp109_ = self->priv->item_rows;
#line 930 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp109__length1 = self->priv->item_rows_length1;
#line 930 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp110_ = current_row;
#line 930 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp111_ = _checkerboard_layout_layout_row_ref0 (_tmp110_);
#line 930 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (_tmp109_[row]);
#line 930 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp109_[row] = _tmp111_;
#line 931 "../src/Checkerboard/CheckerboardLayout.vala"
					_checkerboard_layout_layout_row_unref0 (current_row);
#line 931 "../src/Checkerboard/CheckerboardLayout.vala"
					current_row = NULL;
#line 933 "../src/Checkerboard/CheckerboardLayout.vala"
					x = gutter;
#line 934 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp112_ = row_heights;
#line 934 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp112__length1 = row_heights_length1;
#line 934 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp113_ = _tmp112_[row];
#line 934 "../src/Checkerboard/CheckerboardLayout.vala"
					y += _tmp113_ + CHECKERBOARD_LAYOUT_ROW_GUTTER_PADDING;
#line 935 "../src/Checkerboard/CheckerboardLayout.vala"
					col = 0;
#line 936 "../src/Checkerboard/CheckerboardLayout.vala"
					_tmp114_ = row;
#line 936 "../src/Checkerboard/CheckerboardLayout.vala"
					row = _tmp114_ + 1;
#line 3556 "CheckerboardLayout.c"
				}
#line 900 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (item);
#line 3560 "CheckerboardLayout.c"
			}
		}
	}
#line 941 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp115_ = current_row;
#line 941 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp115_ != NULL) {
#line 3568 "CheckerboardLayout.c"
		CheckerboardLayoutLayoutRow** _tmp116_;
		gint _tmp116__length1;
		CheckerboardLayoutLayoutRow* _tmp117_;
		CheckerboardLayoutLayoutRow* _tmp118_;
#line 942 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp116_ = self->priv->item_rows;
#line 942 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp116__length1 = self->priv->item_rows_length1;
#line 942 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp117_ = current_row;
#line 942 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp118_ = _checkerboard_layout_layout_row_ref0 (_tmp117_);
#line 942 "../src/Checkerboard/CheckerboardLayout.vala"
		_checkerboard_layout_layout_row_unref0 (_tmp116_[row]);
#line 942 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp116_[row] = _tmp118_;
#line 3585 "CheckerboardLayout.c"
	}
#line 945 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->columns = max_cols;
#line 946 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->rows = row + 1;
#line 947 "../src/Checkerboard/CheckerboardLayout.vala"
	_vala_assert (self->priv->rows == max_rows, "rows == max_rows");
#line 951 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp119_ = row_heights;
#line 951 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp119__length1 = row_heights_length1;
#line 951 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp120_ = _tmp119_[row];
#line 951 "../src/Checkerboard/CheckerboardLayout.vala"
	total_height = (y + _tmp120_) + CHECKERBOARD_LAYOUT_BOTTOM_PADDING;
#line 952 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp122_ = allocation;
#line 952 "../src/Checkerboard/CheckerboardLayout.vala"
	if (visible_width != _tmp122_.width) {
#line 952 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp121_ = TRUE;
#line 3607 "CheckerboardLayout.c"
	} else {
		GtkAllocation _tmp123_;
#line 952 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp123_ = allocation;
#line 952 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp121_ = total_height != _tmp123_.height;
#line 3614 "CheckerboardLayout.c"
	}
#line 952 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp121_) {
#line 957 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, visible_width, total_height);
#line 958 "../src/Checkerboard/CheckerboardLayout.vala"
		self->priv->size_allocate_due_to_reflow = TRUE;
#line 961 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_center_on_anchor (self, (gdouble) total_height);
#line 3624 "CheckerboardLayout.c"
	}
#line 648 "../src/Checkerboard/CheckerboardLayout.vala"
	_checkerboard_layout_layout_row_unref0 (current_row);
#line 648 "../src/Checkerboard/CheckerboardLayout.vala"
	alignment_points = (g_free (alignment_points), NULL);
#line 648 "../src/Checkerboard/CheckerboardLayout.vala"
	row_heights = (g_free (row_heights), NULL);
#line 648 "../src/Checkerboard/CheckerboardLayout.vala"
	column_widths = (g_free (column_widths), NULL);
#line 3634 "CheckerboardLayout.c"
}

static void
checkerboard_layout_items_dirty (CheckerboardLayout* self,
                                 const gchar* reason,
                                 GeeIterable* items)
{
	GdkRectangle dirty = {0};
	gboolean _tmp26_ = FALSE;
	GdkRectangle _tmp27_;
#line 965 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 965 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (reason != NULL);
#line 965 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (items != NULL);
#line 966 "../src/Checkerboard/CheckerboardLayout.vala"
	memset (&dirty, 0, sizeof (GdkRectangle));
#line 3653 "CheckerboardLayout.c"
	{
		GeeIterator* _data_view_it = NULL;
		GeeIterator* _tmp0_;
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = gee_iterable_iterator (items);
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
		_data_view_it = _tmp0_;
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
		while (TRUE) {
#line 3663 "CheckerboardLayout.c"
			GeeIterator* _tmp1_;
			DataView* data_view = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			CheckerboardItem* item = NULL;
			DataView* _tmp4_;
			CheckerboardItem* _tmp5_;
			CheckerboardItem* _tmp6_;
			ViewCollection* _tmp7_;
			CheckerboardItem* _tmp8_;
			gboolean _tmp9_ = FALSE;
			CheckerboardItem* _tmp10_;
			GdkRectangle _tmp11_;
			GdkRectangle intersection = {0};
			CheckerboardItem* _tmp16_;
			GdkRectangle _tmp17_;
			GdkRectangle _tmp18_ = {0};
			gboolean _tmp19_;
			gboolean _tmp20_ = FALSE;
			GdkRectangle _tmp21_;
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp1_ = _data_view_it;
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
				break;
#line 3690 "CheckerboardLayout.c"
			}
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp2_ = _data_view_it;
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
			data_view = (DataView*) _tmp3_;
#line 968 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp4_ = data_view;
#line 968 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_CHECKERBOARD_ITEM, CheckerboardItem));
#line 968 "../src/Checkerboard/CheckerboardLayout.vala"
			item = _tmp5_;
#line 970 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp6_ = item;
#line 970 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!data_view_is_visible ((DataView*) _tmp6_)) {
#line 971 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (item);
#line 971 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (data_view);
#line 971 "../src/Checkerboard/CheckerboardLayout.vala"
				continue;
#line 3714 "CheckerboardLayout.c"
			}
#line 973 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp7_ = self->priv->view;
#line 973 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp8_ = item;
#line 973 "../src/Checkerboard/CheckerboardLayout.vala"
			_vala_assert (data_collection_contains ((DataCollection*) _tmp7_, (DataObject*) _tmp8_), "view.contains (item)");
#line 977 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp10_ = item;
#line 977 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp11_ = _tmp10_->allocation;
#line 977 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp11_.width <= 0) {
#line 977 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp9_ = TRUE;
#line 3730 "CheckerboardLayout.c"
			} else {
				CheckerboardItem* _tmp12_;
				GdkRectangle _tmp13_;
#line 977 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp12_ = item;
#line 977 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp13_ = _tmp12_->allocation;
#line 977 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp9_ = _tmp13_.height <= 0;
#line 3740 "CheckerboardLayout.c"
			}
#line 977 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp9_) {
#line 3744 "CheckerboardLayout.c"
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 978 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp14_ = g_strdup_printf ("items_dirty: %s", reason);
#line 978 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp15_ = _tmp14_;
#line 978 "../src/Checkerboard/CheckerboardLayout.vala"
				checkerboard_layout_need_reflow (self, _tmp15_);
#line 978 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_free0 (_tmp15_);
#line 980 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (item);
#line 980 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (data_view);
#line 980 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (_data_view_it);
#line 980 "../src/Checkerboard/CheckerboardLayout.vala"
				return;
#line 3763 "CheckerboardLayout.c"
			}
#line 984 "../src/Checkerboard/CheckerboardLayout.vala"
			memset (&intersection, 0, sizeof (GdkRectangle));
#line 985 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp16_ = item;
#line 985 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp17_ = _tmp16_->allocation;
#line 985 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp19_ = gdk_rectangle_intersect (&self->priv->visible_page, &_tmp17_, &_tmp18_);
#line 985 "../src/Checkerboard/CheckerboardLayout.vala"
			intersection = _tmp18_;
#line 985 "../src/Checkerboard/CheckerboardLayout.vala"
			if (!_tmp19_) {
#line 986 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (item);
#line 986 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (data_view);
#line 986 "../src/Checkerboard/CheckerboardLayout.vala"
				continue;
#line 3783 "CheckerboardLayout.c"
			}
#line 989 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp21_ = dirty;
#line 989 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp21_.width == 0) {
#line 989 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp20_ = TRUE;
#line 3791 "CheckerboardLayout.c"
			} else {
				GdkRectangle _tmp22_;
#line 989 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp22_ = dirty;
#line 989 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp20_ = _tmp22_.height == 0;
#line 3798 "CheckerboardLayout.c"
			}
#line 989 "../src/Checkerboard/CheckerboardLayout.vala"
			if (_tmp20_) {
#line 3802 "CheckerboardLayout.c"
				GdkRectangle _tmp23_;
#line 990 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp23_ = intersection;
#line 990 "../src/Checkerboard/CheckerboardLayout.vala"
				dirty = _tmp23_;
#line 3808 "CheckerboardLayout.c"
			} else {
				GdkRectangle _tmp24_;
				GdkRectangle _tmp25_ = {0};
#line 992 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp24_ = intersection;
#line 992 "../src/Checkerboard/CheckerboardLayout.vala"
				gdk_rectangle_union (&dirty, &_tmp24_, &_tmp25_);
#line 992 "../src/Checkerboard/CheckerboardLayout.vala"
				dirty = _tmp25_;
#line 3818 "CheckerboardLayout.c"
			}
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (item);
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (data_view);
#line 3824 "CheckerboardLayout.c"
		}
#line 967 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (_data_view_it);
#line 3828 "CheckerboardLayout.c"
	}
#line 995 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp27_ = dirty;
#line 995 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp27_.width > 0) {
#line 3834 "CheckerboardLayout.c"
		GdkRectangle _tmp28_;
#line 995 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp28_ = dirty;
#line 995 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp26_ = _tmp28_.height > 0;
#line 3840 "CheckerboardLayout.c"
	} else {
#line 995 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp26_ = FALSE;
#line 3844 "CheckerboardLayout.c"
	}
#line 995 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp26_) {
#line 3848 "CheckerboardLayout.c"
		GdkRectangle _tmp29_;
		GdkRectangle _tmp30_;
		GdkRectangle _tmp31_;
		GdkRectangle _tmp32_;
#line 1000 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp29_ = dirty;
#line 1000 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp30_ = dirty;
#line 1000 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp31_ = dirty;
#line 1000 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp32_ = dirty;
#line 1000 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_widget_queue_draw_area ((GtkWidget*) self, _tmp29_.x, _tmp30_.y, _tmp31_.width, _tmp32_.height);
#line 3863 "CheckerboardLayout.c"
	}
}

static void
checkerboard_layout_real_size_allocate (GtkWidget* base,
                                        GtkAllocation* allocation)
{
	CheckerboardLayout * self;
	GtkAllocation _tmp0_;
#line 1004 "../src/Checkerboard/CheckerboardLayout.vala"
	self = (CheckerboardLayout*) base;
#line 1004 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (allocation != NULL);
#line 1005 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = *allocation;
#line 1005 "../src/Checkerboard/CheckerboardLayout.vala"
	GTK_WIDGET_CLASS (checkerboard_layout_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), &_tmp0_);
#line 1007 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_viewport_resized (self);
#line 3883 "CheckerboardLayout.c"
}

static gboolean
checkerboard_layout_real_draw (GtkWidget* base,
                               cairo_t* ctx)
{
	CheckerboardLayout * self;
	const gchar* _tmp0_;
	gboolean _tmp33_ = FALSE;
	gboolean _result_ = FALSE;
	gboolean result;
#line 1010 "../src/Checkerboard/CheckerboardLayout.vala"
	self = (CheckerboardLayout*) base;
#line 1010 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 1019 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->message;
#line 1019 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp0_ == NULL) {
#line 3903 "CheckerboardLayout.c"
		GtkStyleContext* style_context = NULL;
		GtkStyleContext* _tmp1_;
		GtkStyleContext* _tmp2_;
		GdkRectangle _tmp3_;
		GdkRectangle _tmp4_;
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_;
		GtkStyleContext* _tmp7_;
		GtkStyleContext* _tmp8_;
		GtkStyleContext* _tmp9_;
		GtkStyleContext* _tmp21_;
#line 1024 "../src/Checkerboard/CheckerboardLayout.vala"
		if (self->priv->exposure_dirty) {
#line 1025 "../src/Checkerboard/CheckerboardLayout.vala"
			checkerboard_layout_expose_items (self, "draw");
#line 3919 "CheckerboardLayout.c"
		}
#line 1029 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 1029 "../src/Checkerboard/CheckerboardLayout.vala"
		style_context = _tmp1_;
#line 1030 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = style_context;
#line 1030 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = self->priv->visible_page;
#line 1030 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp4_ = self->priv->visible_page;
#line 1030 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp5_ = self->priv->visible_page;
#line 1030 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp6_ = self->priv->visible_page;
#line 1030 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_render_background (_tmp2_, ctx, (gdouble) _tmp3_.x, (gdouble) _tmp4_.y, (gdouble) _tmp5_.width, (gdouble) _tmp6_.height);
#line 1032 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp7_ = style_context;
#line 1032 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_style_context_save (_tmp7_);
#line 1033 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp8_ = style_context;
#line 1033 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_style_context_add_class (_tmp8_, GRANITE_STYLE_CLASS_CARD);
#line 1034 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp9_ = style_context;
#line 1034 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_style_context_add_class (_tmp9_, GRANITE_STYLE_CLASS_CHECKERBOARD);
#line 3949 "CheckerboardLayout.c"
		{
			GeeList* _item_list = NULL;
			GdkRectangle _tmp10_;
			GeeList* _tmp11_;
			gint _item_size = 0;
			GeeList* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _item_index = 0;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp10_ = self->priv->visible_page;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp11_ = checkerboard_layout_intersection (self, &_tmp10_);
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_item_list = _tmp11_;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp12_ = _item_list;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp13_ = gee_collection_get_size ((GeeCollection*) _tmp12_);
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp14_ = _tmp13_;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_item_size = _tmp14_;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_item_index = -1;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			while (TRUE) {
#line 3977 "CheckerboardLayout.c"
				gint _tmp15_;
				gint _tmp16_;
				CheckerboardItem* item = NULL;
				GeeList* _tmp17_;
				gpointer _tmp18_;
				CheckerboardItem* _tmp19_;
				GtkStyleContext* _tmp20_;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
				_item_index = _item_index + 1;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp15_ = _item_index;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp16_ = _item_size;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
				if (!(_tmp15_ < _tmp16_)) {
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
					break;
#line 3995 "CheckerboardLayout.c"
				}
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp17_ = _item_list;
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp18_ = gee_list_get (_tmp17_, _item_index);
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
				item = (CheckerboardItem*) _tmp18_;
#line 1036 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp19_ = item;
#line 1036 "../src/Checkerboard/CheckerboardLayout.vala"
				_tmp20_ = style_context;
#line 1036 "../src/Checkerboard/CheckerboardLayout.vala"
				checkerboard_item_paint (_tmp19_, ctx, _tmp20_);
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
				_g_object_unref0 (item);
#line 4011 "CheckerboardLayout.c"
			}
#line 1035 "../src/Checkerboard/CheckerboardLayout.vala"
			_g_object_unref0 (_item_list);
#line 4015 "CheckerboardLayout.c"
		}
#line 1039 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp21_ = style_context;
#line 1039 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_style_context_restore (_tmp21_);
#line 4021 "CheckerboardLayout.c"
	} else {
		PangoLayout* pango_layout = NULL;
		const gchar* _tmp22_;
		PangoLayout* _tmp23_;
		gint text_width = 0;
		gint text_height = 0;
		PangoLayout* _tmp24_;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		GtkAllocation allocation = {0};
		GtkAllocation _tmp27_ = {0};
		gint x = 0;
		GtkAllocation _tmp28_;
		gint _tmp29_ = 0;
		gint y = 0;
		GtkAllocation _tmp30_;
		gint _tmp31_ = 0;
		PangoLayout* _tmp32_;
#line 1042 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp22_ = self->priv->message;
#line 1042 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp23_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp22_);
#line 1042 "../src/Checkerboard/CheckerboardLayout.vala"
		pango_layout = _tmp23_;
#line 1044 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp24_ = pango_layout;
#line 1044 "../src/Checkerboard/CheckerboardLayout.vala"
		pango_layout_get_pixel_size (_tmp24_, &_tmp25_, &_tmp26_);
#line 1044 "../src/Checkerboard/CheckerboardLayout.vala"
		text_width = _tmp25_;
#line 1044 "../src/Checkerboard/CheckerboardLayout.vala"
		text_height = _tmp26_;
#line 1047 "../src/Checkerboard/CheckerboardLayout.vala"
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp27_);
#line 1047 "../src/Checkerboard/CheckerboardLayout.vala"
		allocation = _tmp27_;
#line 1049 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp28_ = allocation;
#line 1049 "../src/Checkerboard/CheckerboardLayout.vala"
		x = _tmp28_.width - text_width;
#line 1050 "../src/Checkerboard/CheckerboardLayout.vala"
		if (x > 0) {
#line 1050 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp29_ = x / 2;
#line 4066 "CheckerboardLayout.c"
		} else {
#line 1050 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp29_ = 0;
#line 4070 "CheckerboardLayout.c"
		}
#line 1050 "../src/Checkerboard/CheckerboardLayout.vala"
		x = _tmp29_;
#line 1052 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp30_ = allocation;
#line 1052 "../src/Checkerboard/CheckerboardLayout.vala"
		y = _tmp30_.height - text_height;
#line 1053 "../src/Checkerboard/CheckerboardLayout.vala"
		if (y > 0) {
#line 1053 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp31_ = y / 2;
#line 4082 "CheckerboardLayout.c"
		} else {
#line 1053 "../src/Checkerboard/CheckerboardLayout.vala"
			_tmp31_ = 0;
#line 4086 "CheckerboardLayout.c"
		}
#line 1053 "../src/Checkerboard/CheckerboardLayout.vala"
		y = _tmp31_;
#line 1055 "../src/Checkerboard/CheckerboardLayout.vala"
		cairo_move_to (ctx, (gdouble) x, (gdouble) y);
#line 1056 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp32_ = pango_layout;
#line 1056 "../src/Checkerboard/CheckerboardLayout.vala"
		pango_cairo_show_layout (ctx, _tmp32_);
#line 1019 "../src/Checkerboard/CheckerboardLayout.vala"
		_g_object_unref0 (pango_layout);
#line 4098 "CheckerboardLayout.c"
	}
#line 1059 "../src/Checkerboard/CheckerboardLayout.vala"
	if (GTK_WIDGET_CLASS (checkerboard_layout_parent_class)->draw != NULL) {
#line 1059 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp33_ = GTK_WIDGET_CLASS (checkerboard_layout_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), ctx);
#line 4104 "CheckerboardLayout.c"
	} else {
#line 1059 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp33_ = TRUE;
#line 4108 "CheckerboardLayout.c"
	}
#line 1059 "../src/Checkerboard/CheckerboardLayout.vala"
	_result_ = _tmp33_;
#line 1062 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_draw_selection_band (self, ctx);
#line 1064 "../src/Checkerboard/CheckerboardLayout.vala"
	result = _result_;
#line 1064 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 4118 "CheckerboardLayout.c"
}

static void
checkerboard_layout_draw_selection_band (CheckerboardLayout* self,
                                         cairo_t* ctx)
{
	gboolean _tmp0_ = FALSE;
	GdkRectangle _tmp1_;
	gboolean _tmp3_ = FALSE;
	GtkAdjustment* _tmp4_;
	GdkRectangle visible_page = {0};
	GtkAdjustment* _tmp6_;
	GtkAdjustment* _tmp7_;
	GdkRectangle _tmp8_ = {0};
	GdkRectangle visible_band = {0};
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_ = {0};
	GtkWidgetPath* label_widget_path = NULL;
	GtkWidgetPath* _tmp11_;
	GtkWidgetPath* _tmp12_;
	GtkWidgetPath* _tmp13_;
	GtkStyleContext* rubberband_context = NULL;
	GtkStyleContext* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkWidgetPath* _tmp16_;
	GtkStyleContext* _tmp17_;
	GdkRectangle _tmp18_;
	GdkRectangle _tmp19_;
	GdkRectangle _tmp20_;
	GdkRectangle _tmp21_;
	GtkStyleContext* _tmp22_;
	GdkRectangle _tmp23_;
	GdkRectangle _tmp24_;
	GdkRectangle _tmp25_;
	GdkRectangle _tmp26_;
#line 1067 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (self != NULL);
#line 1067 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (ctx != NULL);
#line 1069 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = self->priv->selection_band;
#line 1069 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp1_.width <= 1) {
#line 1069 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = TRUE;
#line 4164 "CheckerboardLayout.c"
	} else {
		GdkRectangle _tmp2_;
#line 1069 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp2_ = self->priv->selection_band;
#line 1069 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp0_ = _tmp2_.height <= 1;
#line 4171 "CheckerboardLayout.c"
	}
#line 1069 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp0_) {
#line 1070 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 4177 "CheckerboardLayout.c"
	}
#line 1073 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp4_ = self->priv->hadjustment;
#line 1073 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp4_ == NULL) {
#line 1073 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = TRUE;
#line 4185 "CheckerboardLayout.c"
	} else {
		GtkAdjustment* _tmp5_;
#line 1073 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp5_ = self->priv->vadjustment;
#line 1073 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = _tmp5_ == NULL;
#line 4192 "CheckerboardLayout.c"
	}
#line 1073 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp3_) {
#line 1074 "../src/Checkerboard/CheckerboardLayout.vala"
		return;
#line 4198 "CheckerboardLayout.c"
	}
#line 1076 "../src/Checkerboard/CheckerboardLayout.vala"
	cairo_save (ctx);
#line 1078 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp6_ = self->priv->hadjustment;
#line 1078 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp7_ = self->priv->vadjustment;
#line 1078 "../src/Checkerboard/CheckerboardLayout.vala"
	get_adjustment_page (_tmp6_, _tmp7_, &_tmp8_);
#line 1078 "../src/Checkerboard/CheckerboardLayout.vala"
	visible_page = _tmp8_;
#line 1079 "../src/Checkerboard/CheckerboardLayout.vala"
	memset (&visible_band, 0, sizeof (GdkRectangle));
#line 1081 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp9_ = self->priv->selection_band;
#line 1081 "../src/Checkerboard/CheckerboardLayout.vala"
	gdk_rectangle_intersect (&visible_page, &_tmp9_, &_tmp10_);
#line 1081 "../src/Checkerboard/CheckerboardLayout.vala"
	visible_band = _tmp10_;
#line 1084 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp11_ = gtk_widget_path_new ();
#line 1084 "../src/Checkerboard/CheckerboardLayout.vala"
	label_widget_path = _tmp11_;
#line 1085 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp12_ = label_widget_path;
#line 1085 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_path_append_type (_tmp12_, gtk_icon_view_get_type ());
#line 1086 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp13_ = label_widget_path;
#line 1086 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_widget_path_iter_set_object_name (_tmp13_, -1, "rubberband");
#line 1087 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp14_ = gtk_style_context_new ();
#line 1087 "../src/Checkerboard/CheckerboardLayout.vala"
	rubberband_context = _tmp14_;
#line 1088 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp15_ = rubberband_context;
#line 1088 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp16_ = label_widget_path;
#line 1088 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_style_context_set_path (_tmp15_, _tmp16_);
#line 1090 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp17_ = rubberband_context;
#line 1090 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp18_ = visible_band;
#line 1090 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp19_ = visible_band;
#line 1090 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp20_ = visible_band;
#line 1090 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp21_ = visible_band;
#line 1090 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_render_background (_tmp17_, ctx, (gdouble) _tmp18_.x, (gdouble) _tmp19_.y, (gdouble) _tmp20_.width, (gdouble) _tmp21_.height);
#line 1091 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp22_ = rubberband_context;
#line 1091 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp23_ = visible_band;
#line 1091 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp24_ = visible_band;
#line 1091 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp25_ = visible_band;
#line 1091 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp26_ = visible_band;
#line 1091 "../src/Checkerboard/CheckerboardLayout.vala"
	gtk_render_frame (_tmp22_, ctx, (gdouble) _tmp23_.x, (gdouble) _tmp24_.y, (gdouble) _tmp25_.width, (gdouble) _tmp26_.height);
#line 1092 "../src/Checkerboard/CheckerboardLayout.vala"
	cairo_restore (ctx);
#line 1067 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (rubberband_context);
#line 1067 "../src/Checkerboard/CheckerboardLayout.vala"
	_gtk_widget_path_unref0 (label_widget_path);
#line 4270 "CheckerboardLayout.c"
}

static gboolean
checkerboard_layout_real_query_tooltip (GtkWidget* base,
                                        gint x,
                                        gint y,
                                        gboolean keyboard_mode,
                                        GtkTooltip* tooltip)
{
	CheckerboardLayout * self;
	CheckerboardItem* item = NULL;
	CheckerboardItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	CheckerboardItem* _tmp2_;
	gboolean result;
#line 1095 "../src/Checkerboard/CheckerboardLayout.vala"
	self = (CheckerboardLayout*) base;
#line 1095 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (tooltip != NULL, FALSE);
#line 1096 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = checkerboard_layout_get_item_at_pixel (self, (gdouble) x, (gdouble) y);
#line 1096 "../src/Checkerboard/CheckerboardLayout.vala"
	item = _tmp0_;
#line 1098 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = item;
#line 1098 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp2_ != NULL) {
#line 4298 "CheckerboardLayout.c"
		CheckerboardItem* _tmp3_;
#line 1098 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp3_ = item;
#line 1098 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp1_ = checkerboard_item_query_tooltip (_tmp3_, x, y, tooltip);
#line 4304 "CheckerboardLayout.c"
	} else {
#line 1098 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp1_ = FALSE;
#line 4308 "CheckerboardLayout.c"
	}
#line 1098 "../src/Checkerboard/CheckerboardLayout.vala"
	result = _tmp1_;
#line 1098 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (item);
#line 1098 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 4316 "CheckerboardLayout.c"
}

static gboolean
checkerboard_layout_real_focus_in_event (GtkWidget* base,
                                         GdkEventFocus* event)
{
	CheckerboardLayout * self;
	ViewCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	gboolean result;
#line 1101 "../src/Checkerboard/CheckerboardLayout.vala"
	self = (CheckerboardLayout*) base;
#line 1101 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1102 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->view;
#line 1102 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = view_collection_get_selected (_tmp0_);
#line 1102 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = _tmp1_;
#line 1102 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_items_dirty (self, "focus_in_event", (GeeIterable*) _tmp2_);
#line 1102 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (_tmp2_);
#line 1104 "../src/Checkerboard/CheckerboardLayout.vala"
	result = GTK_WIDGET_CLASS (checkerboard_layout_parent_class)->focus_in_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), event);
#line 1104 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 4346 "CheckerboardLayout.c"
}

static gboolean
checkerboard_layout_real_focus_out_event (GtkWidget* base,
                                          GdkEventFocus* event)
{
	CheckerboardLayout * self;
	ViewCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	gboolean result;
#line 1107 "../src/Checkerboard/CheckerboardLayout.vala"
	self = (CheckerboardLayout*) base;
#line 1107 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1108 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->view;
#line 1108 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = view_collection_get_selected (_tmp0_);
#line 1108 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = _tmp1_;
#line 1108 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_items_dirty (self, "focus_out_event", (GeeIterable*) _tmp2_);
#line 1108 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (_tmp2_);
#line 1110 "../src/Checkerboard/CheckerboardLayout.vala"
	result = GTK_WIDGET_CLASS (checkerboard_layout_parent_class)->focus_out_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), event);
#line 1110 "../src/Checkerboard/CheckerboardLayout.vala"
	return result;
#line 4376 "CheckerboardLayout.c"
}

static CheckerboardLayoutLayoutRow*
checkerboard_layout_layout_row_construct (GType object_type,
                                          gint y,
                                          gint height,
                                          gint num_in_row)
{
	CheckerboardLayoutLayoutRow* self = NULL;
	CheckerboardItem** _tmp0_;
#line 39 "../src/Checkerboard/CheckerboardLayout.vala"
	self = (CheckerboardLayoutLayoutRow*) g_type_create_instance (object_type);
#line 40 "../src/Checkerboard/CheckerboardLayout.vala"
	self->y = y;
#line 41 "../src/Checkerboard/CheckerboardLayout.vala"
	self->height = height;
#line 42 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = g_new0 (CheckerboardItem*, num_in_row + 1);
#line 42 "../src/Checkerboard/CheckerboardLayout.vala"
	self->items = (_vala_array_free (self->items, self->items_length1, (GDestroyNotify) g_object_unref), NULL);
#line 42 "../src/Checkerboard/CheckerboardLayout.vala"
	self->items = _tmp0_;
#line 42 "../src/Checkerboard/CheckerboardLayout.vala"
	self->items_length1 = num_in_row;
#line 42 "../src/Checkerboard/CheckerboardLayout.vala"
	self->_items_size_ = self->items_length1;
#line 39 "../src/Checkerboard/CheckerboardLayout.vala"
	return self;
#line 4405 "CheckerboardLayout.c"
}

static CheckerboardLayoutLayoutRow*
checkerboard_layout_layout_row_new (gint y,
                                    gint height,
                                    gint num_in_row)
{
#line 39 "../src/Checkerboard/CheckerboardLayout.vala"
	return checkerboard_layout_layout_row_construct (CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW, y, height, num_in_row);
#line 4415 "CheckerboardLayout.c"
}

static void
checkerboard_layout_value_layout_row_init (GValue* value)
{
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	value->data[0].v_pointer = NULL;
#line 4423 "CheckerboardLayout.c"
}

static void
checkerboard_layout_value_layout_row_free_value (GValue* value)
{
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (value->data[0].v_pointer) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_layout_row_unref (value->data[0].v_pointer);
#line 4433 "CheckerboardLayout.c"
	}
}

static void
checkerboard_layout_value_layout_row_copy_value (const GValue* src_value,
                                                 GValue* dest_value)
{
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		dest_value->data[0].v_pointer = checkerboard_layout_layout_row_ref (src_value->data[0].v_pointer);
#line 4445 "CheckerboardLayout.c"
	} else {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4449 "CheckerboardLayout.c"
	}
}

static gpointer
checkerboard_layout_value_layout_row_peek_pointer (const GValue* value)
{
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	return value->data[0].v_pointer;
#line 4458 "CheckerboardLayout.c"
}

static gchar*
checkerboard_layout_value_layout_row_collect_value (GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (collect_values[0].v_pointer) {
#line 4469 "CheckerboardLayout.c"
		CheckerboardLayoutLayoutRow * object;
		object = collect_values[0].v_pointer;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4476 "CheckerboardLayout.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4480 "CheckerboardLayout.c"
		}
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		value->data[0].v_pointer = checkerboard_layout_layout_row_ref (object);
#line 4484 "CheckerboardLayout.c"
	} else {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		value->data[0].v_pointer = NULL;
#line 4488 "CheckerboardLayout.c"
	}
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	return NULL;
#line 4492 "CheckerboardLayout.c"
}

static gchar*
checkerboard_layout_value_layout_row_lcopy_value (const GValue* value,
                                                  guint n_collect_values,
                                                  GTypeCValue* collect_values,
                                                  guint collect_flags)
{
	CheckerboardLayoutLayoutRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (!object_p) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4507 "CheckerboardLayout.c"
	}
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (!value->data[0].v_pointer) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		*object_p = NULL;
#line 4513 "CheckerboardLayout.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		*object_p = value->data[0].v_pointer;
#line 4517 "CheckerboardLayout.c"
	} else {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		*object_p = checkerboard_layout_layout_row_ref (value->data[0].v_pointer);
#line 4521 "CheckerboardLayout.c"
	}
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	return NULL;
#line 4525 "CheckerboardLayout.c"
}

static GParamSpec*
checkerboard_layout_param_spec_layout_row (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags)
{
	CheckerboardLayoutParamSpecLayoutRow* spec;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (g_type_is_a (object_type, CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW), NULL);
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	return G_PARAM_SPEC (spec);
#line 4544 "CheckerboardLayout.c"
}

static gpointer
checkerboard_layout_value_get_layout_row (const GValue* value)
{
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW), NULL);
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	return value->data[0].v_pointer;
#line 4554 "CheckerboardLayout.c"
}

static void
checkerboard_layout_value_set_layout_row (GValue* value,
                                          gpointer v_object)
{
	CheckerboardLayoutLayoutRow * old;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW));
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (v_object) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW));
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		value->data[0].v_pointer = v_object;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_layout_row_ref (value->data[0].v_pointer);
#line 4576 "CheckerboardLayout.c"
	} else {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		value->data[0].v_pointer = NULL;
#line 4580 "CheckerboardLayout.c"
	}
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (old) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_layout_row_unref (old);
#line 4586 "CheckerboardLayout.c"
	}
}

static void
checkerboard_layout_value_take_layout_row (GValue* value,
                                           gpointer v_object)
{
	CheckerboardLayoutLayoutRow * old;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW));
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (v_object) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW));
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		value->data[0].v_pointer = v_object;
#line 4607 "CheckerboardLayout.c"
	} else {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		value->data[0].v_pointer = NULL;
#line 4611 "CheckerboardLayout.c"
	}
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (old) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		checkerboard_layout_layout_row_unref (old);
#line 4617 "CheckerboardLayout.c"
	}
}

static void
checkerboard_layout_layout_row_class_init (CheckerboardLayoutLayoutRowClass * klass,
                                           gpointer klass_data)
{
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_layout_row_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	((CheckerboardLayoutLayoutRowClass *) klass)->finalize = checkerboard_layout_layout_row_finalize;
#line 4629 "CheckerboardLayout.c"
}

static void
checkerboard_layout_layout_row_instance_init (CheckerboardLayoutLayoutRow * self,
                                              gpointer klass)
{
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	self->ref_count = 1;
#line 4638 "CheckerboardLayout.c"
}

static void
checkerboard_layout_layout_row_finalize (CheckerboardLayoutLayoutRow * obj)
{
	CheckerboardLayoutLayoutRow * self;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CHECKERBOARD_LAYOUT_TYPE_LAYOUT_ROW, CheckerboardLayoutLayoutRow);
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_destroy (self);
#line 37 "../src/Checkerboard/CheckerboardLayout.vala"
	self->items = (_vala_array_free (self->items, self->items_length1, (GDestroyNotify) g_object_unref), NULL);
#line 4651 "CheckerboardLayout.c"
}

static GType
checkerboard_layout_layout_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { checkerboard_layout_value_layout_row_init, checkerboard_layout_value_layout_row_free_value, checkerboard_layout_value_layout_row_copy_value, checkerboard_layout_value_layout_row_peek_pointer, "p", checkerboard_layout_value_layout_row_collect_value, "p", checkerboard_layout_value_layout_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (CheckerboardLayoutLayoutRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) checkerboard_layout_layout_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CheckerboardLayoutLayoutRow), 0, (GInstanceInitFunc) checkerboard_layout_layout_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType checkerboard_layout_layout_row_type_id;
	checkerboard_layout_layout_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CheckerboardLayoutLayoutRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return checkerboard_layout_layout_row_type_id;
}

static GType
checkerboard_layout_layout_row_get_type (void)
{
	static volatile gsize checkerboard_layout_layout_row_type_id__once = 0;
	if (g_once_init_enter (&checkerboard_layout_layout_row_type_id__once)) {
		GType checkerboard_layout_layout_row_type_id;
		checkerboard_layout_layout_row_type_id = checkerboard_layout_layout_row_get_type_once ();
		g_once_init_leave (&checkerboard_layout_layout_row_type_id__once, checkerboard_layout_layout_row_type_id);
	}
	return checkerboard_layout_layout_row_type_id__once;
}

static gpointer
checkerboard_layout_layout_row_ref (gpointer instance)
{
	CheckerboardLayoutLayoutRow * self;
	self = instance;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	return instance;
#line 4686 "CheckerboardLayout.c"
}

static void
checkerboard_layout_layout_row_unref (gpointer instance)
{
	CheckerboardLayoutLayoutRow * self;
	self = instance;
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		CHECKERBOARD_LAYOUT_LAYOUT_ROW_GET_CLASS (self)->finalize (self);
#line 34 "../src/Checkerboard/CheckerboardLayout.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4700 "CheckerboardLayout.c"
	}
}

static void
checkerboard_layout_class_init (CheckerboardLayoutClass * klass,
                                gpointer klass_data)
{
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	checkerboard_layout_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	g_type_class_adjust_private_offset (klass, &CheckerboardLayout_private_offset);
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) checkerboard_layout_real_size_allocate;
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) checkerboard_layout_real_draw;
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	((GtkWidgetClass *) klass)->query_tooltip = (gboolean (*) (GtkWidget*, gint, gint, gboolean, GtkTooltip*)) checkerboard_layout_real_query_tooltip;
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	((GtkWidgetClass *) klass)->focus_in_event = (gboolean (*) (GtkWidget*, GdkEventFocus*)) checkerboard_layout_real_focus_in_event;
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	((GtkWidgetClass *) klass)->focus_out_event = (gboolean (*) (GtkWidget*, GdkEventFocus*)) checkerboard_layout_real_focus_out_event;
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	G_OBJECT_CLASS (klass)->finalize = checkerboard_layout_finalize;
#line 4724 "CheckerboardLayout.c"
}

static void
checkerboard_layout_instance_init (CheckerboardLayout * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
	GeeHashSet* _tmp1_;
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv = checkerboard_layout_get_instance_private (self);
#line 47 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = g_strdup ("");
#line 47 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->page_name = _tmp0_;
#line 48 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows = NULL;
#line 48 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows_length1 = 0;
#line 48 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->_item_rows_size_ = self->priv->item_rows_length1;
#line 49 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp1_ = gee_hash_set_new (TYPE_CHECKERBOARD_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 49 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->exposed_items = _tmp1_;
#line 50 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->hadjustment = NULL;
#line 51 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->vadjustment = NULL;
#line 52 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->message = NULL;
#line 53 "../src/Checkerboard/CheckerboardLayout.vala"
	memset (&self->priv->visible_page, 0, sizeof (GdkRectangle));
#line 54 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->last_width = 0;
#line 55 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->columns = 0;
#line 56 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->rows = 0;
#line 57 "../src/Checkerboard/CheckerboardLayout.vala"
	memset (&self->priv->drag_origin, 0, sizeof (GdkPoint));
#line 58 "../src/Checkerboard/CheckerboardLayout.vala"
	memset (&self->priv->drag_endpoint, 0, sizeof (GdkPoint));
#line 59 "../src/Checkerboard/CheckerboardLayout.vala"
	memset (&self->priv->selection_band, 0, sizeof (GdkRectangle));
#line 60 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->scale = 0;
#line 61 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->flow_scheduled = FALSE;
#line 62 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->exposure_dirty = TRUE;
#line 63 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->anchor = NULL;
#line 64 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->in_center_on_anchor = FALSE;
#line 65 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->size_allocate_due_to_reflow = FALSE;
#line 66 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->is_in_view = FALSE;
#line 67 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->reflow_needed = FALSE;
#line 4785 "CheckerboardLayout.c"
}

static void
checkerboard_layout_finalize (GObject * obj)
{
	CheckerboardLayout * self;
	ViewCollection* _tmp0_;
	guint _tmp1_;
	ViewCollection* _tmp2_;
	guint _tmp3_;
	ViewCollection* _tmp4_;
	guint _tmp5_;
	ViewCollection* _tmp6_;
	guint _tmp7_;
	ViewCollection* _tmp8_;
	guint _tmp9_;
	ViewCollection* _tmp10_;
	guint _tmp11_;
	ViewCollection* _tmp12_;
	guint _tmp13_;
	ViewCollection* _tmp14_;
	guint _tmp15_;
	ViewCollection* _tmp16_;
	guint _tmp17_;
	GtkAdjustment* _tmp18_;
	GtkAdjustment* _tmp21_;
	GtkContainer* _tmp24_;
	GtkContainer* _tmp25_;
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHECKERBOARD_LAYOUT, CheckerboardLayout);
#line 94 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp0_ = self->priv->view;
#line 94 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 94 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _checkerboard_layout_on_contents_altered_data_collection_contents_altered, self);
#line 95 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp2_ = self->priv->view;
#line 95 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp3_, NULL, FALSE);
#line 95 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _checkerboard_layout_on_items_altered_data_collection_items_altered, self);
#line 96 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp4_ = self->priv->view;
#line 96 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("items-state-changed", TYPE_VIEW_COLLECTION, &_tmp5_, NULL, FALSE);
#line 96 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _checkerboard_layout_on_items_state_changed_view_collection_items_state_changed, self);
#line 97 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp6_ = self->priv->view;
#line 97 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("items-visibility-changed", TYPE_VIEW_COLLECTION, &_tmp7_, NULL, FALSE);
#line 97 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _checkerboard_layout_on_items_visibility_changed_view_collection_items_visibility_changed, self);
#line 98 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp8_ = self->priv->view;
#line 98 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("ordering-changed", TYPE_DATA_COLLECTION, &_tmp9_, NULL, FALSE);
#line 98 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _checkerboard_layout_on_ordering_changed_data_collection_ordering_changed, self);
#line 99 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp10_ = self->priv->view;
#line 99 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("views-altered", TYPE_VIEW_COLLECTION, &_tmp11_, NULL, FALSE);
#line 99 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _checkerboard_layout_on_views_altered_view_collection_views_altered, self);
#line 100 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp12_ = self->priv->view;
#line 100 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("geometries-altered", TYPE_VIEW_COLLECTION, &_tmp13_, NULL, FALSE);
#line 100 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _checkerboard_layout_on_geometries_altered_view_collection_geometries_altered, self);
#line 101 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp14_ = self->priv->view;
#line 101 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("items-selected", TYPE_VIEW_COLLECTION, &_tmp15_, NULL, FALSE);
#line 101 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _checkerboard_layout_on_items_selection_changed_view_collection_items_selected, self);
#line 102 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp16_ = self->priv->view;
#line 102 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_parse_name ("items-unselected", TYPE_VIEW_COLLECTION, &_tmp17_, NULL, FALSE);
#line 102 "../src/Checkerboard/CheckerboardLayout.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _checkerboard_layout_on_items_selection_changed_view_collection_items_unselected, self);
#line 104 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp18_ = self->priv->hadjustment;
#line 104 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp18_ != NULL) {
#line 4874 "CheckerboardLayout.c"
		GtkAdjustment* _tmp19_;
		guint _tmp20_;
#line 105 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp19_ = self->priv->hadjustment;
#line 105 "../src/Checkerboard/CheckerboardLayout.vala"
		g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp20_, NULL, FALSE);
#line 105 "../src/Checkerboard/CheckerboardLayout.vala"
		g_signal_handlers_disconnect_matched (_tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _checkerboard_layout_on_viewport_shifted_gtk_adjustment_value_changed, self);
#line 4883 "CheckerboardLayout.c"
	}
#line 107 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp21_ = self->priv->vadjustment;
#line 107 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp21_ != NULL) {
#line 4889 "CheckerboardLayout.c"
		GtkAdjustment* _tmp22_;
		guint _tmp23_;
#line 108 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp22_ = self->priv->vadjustment;
#line 108 "../src/Checkerboard/CheckerboardLayout.vala"
		g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp23_, NULL, FALSE);
#line 108 "../src/Checkerboard/CheckerboardLayout.vala"
		g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _checkerboard_layout_on_viewport_shifted_gtk_adjustment_value_changed, self);
#line 4898 "CheckerboardLayout.c"
	}
#line 110 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp24_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 110 "../src/Checkerboard/CheckerboardLayout.vala"
	_tmp25_ = _tmp24_;
#line 110 "../src/Checkerboard/CheckerboardLayout.vala"
	if (_tmp25_ != NULL) {
#line 4906 "CheckerboardLayout.c"
		GtkContainer* _tmp26_;
		GtkContainer* _tmp27_;
		guint _tmp28_;
#line 111 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp26_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 111 "../src/Checkerboard/CheckerboardLayout.vala"
		_tmp27_ = _tmp26_;
#line 111 "../src/Checkerboard/CheckerboardLayout.vala"
		g_signal_parse_name ("size-allocate", gtk_widget_get_type (), &_tmp28_, NULL, FALSE);
#line 111 "../src/Checkerboard/CheckerboardLayout.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp27_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp28_, 0, NULL, (GCallback) _checkerboard_layout_on_viewport_resized_gtk_widget_size_allocate, self);
#line 4918 "CheckerboardLayout.c"
	}
#line 46 "../src/Checkerboard/CheckerboardLayout.vala"
	_data_collection_unref0 (self->priv->view);
#line 47 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_free0 (self->priv->page_name);
#line 48 "../src/Checkerboard/CheckerboardLayout.vala"
	self->priv->item_rows = (_vala_array_free (self->priv->item_rows, self->priv->item_rows_length1, (GDestroyNotify) checkerboard_layout_layout_row_unref), NULL);
#line 49 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->exposed_items);
#line 50 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->hadjustment);
#line 51 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->vadjustment);
#line 52 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_free0 (self->priv->message);
#line 63 "../src/Checkerboard/CheckerboardLayout.vala"
	_g_object_unref0 (self->priv->anchor);
#line 20 "../src/Checkerboard/CheckerboardLayout.vala"
	G_OBJECT_CLASS (checkerboard_layout_parent_class)->finalize (obj);
#line 4938 "CheckerboardLayout.c"
}

static GType
checkerboard_layout_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CheckerboardLayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) checkerboard_layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CheckerboardLayout), 0, (GInstanceInitFunc) checkerboard_layout_instance_init, NULL };
	GType checkerboard_layout_type_id;
	checkerboard_layout_type_id = g_type_register_static (gtk_drawing_area_get_type (), "CheckerboardLayout", &g_define_type_info, 0);
	CheckerboardLayout_private_offset = g_type_add_instance_private (checkerboard_layout_type_id, sizeof (CheckerboardLayoutPrivate));
	return checkerboard_layout_type_id;
}

GType
checkerboard_layout_get_type (void)
{
	static volatile gsize checkerboard_layout_type_id__once = 0;
	if (g_once_init_enter (&checkerboard_layout_type_id__once)) {
		GType checkerboard_layout_type_id;
		checkerboard_layout_type_id = checkerboard_layout_get_type_once ();
		g_once_init_leave (&checkerboard_layout_type_id__once, checkerboard_layout_type_id);
	}
	return checkerboard_layout_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

