/* ColorTransformation.c generated by valac 0.56.18, the Vala compiler
 * generated from ColorTransformation.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <stdio.h>

#define RGB_ANALYTIC_PIXEL_INV_255 (1.0f / 255.0f)
#define HSV_ANALYTIC_PIXEL_INV_255 (1.0f / 255.0f)
#define TINT_TRANSFORMATION_INTENSITY_FACTOR 0.25f
#define TEMPERATURE_TRANSFORMATION_INTENSITY_FACTOR 0.33f
#define RGB_HISTOGRAM_MARKED_BACKGROUND ((guchar) 30)
#define RGB_HISTOGRAM_MARKED_FOREGROUND ((guchar) 210)
#define RGB_HISTOGRAM_UNMARKED_BACKGROUND ((guchar) 120)
#define RGB_HISTOGRAM_GRAPHIC_WIDTH 256
#define RGB_HISTOGRAM_GRAPHIC_HEIGHT 100
#define EXPANSION_TRANSFORMATION_LOW_DISCARD_MASS 0.02f
#define EXPANSION_TRANSFORMATION_HIGH_DISCARD_MASS 0.02f
#define SHADOW_DETAIL_TRANSFORMATION_MAX_EFFECT_SHIFT 0.5f
#define SHADOW_DETAIL_TRANSFORMATION_MIN_TONAL_WIDTH 0.1f
#define SHADOW_DETAIL_TRANSFORMATION_MAX_TONAL_WIDTH 1.0f
#define SHADOW_DETAIL_TRANSFORMATION_TONAL_WIDTH 1.0f
#define HIGHLIGHT_DETAIL_TRANSFORMATION_MAX_EFFECT_SHIFT 0.5f
#define HIGHLIGHT_DETAIL_TRANSFORMATION_MIN_TONAL_WIDTH 0.1f
#define HIGHLIGHT_DETAIL_TRANSFORMATION_MAX_TONAL_WIDTH 1.0f
#define HIGHLIGHT_DETAIL_TRANSFORMATION_TONAL_WIDTH 1.0f
#define AUTO_ENHANCE_SHADOW_DETECT_MIN_INTENSITY 8
#define AUTO_ENHANCE_SHADOW_DETECT_MAX_INTENSITY 100
#define AUTO_ENHANCE_SHADOW_DETECT_INTENSITY_RANGE (AUTO_ENHANCE_SHADOW_DETECT_MAX_INTENSITY - AUTO_ENHANCE_SHADOW_DETECT_MIN_INTENSITY)
#define AUTO_ENHANCE_SHADOW_MODE_HIGH_DISCARD_MASS 0.02f
#define AUTO_ENHANCE_SHADOW_AGGRESSIVENESS_MUL 0.4f
#define AUTO_ENHANCE_EMPIRICAL_DARK 30
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPixelTransformationBundle ParamSpecPixelTransformationBundle;
typedef struct _ParamSpecPixelTransformation ParamSpecPixelTransformation;
typedef struct _ParamSpecPixelTransformer ParamSpecPixelTransformer;

#define TYPE_RGB_HISTOGRAM (rgb_histogram_get_type ())
#define RGB_HISTOGRAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RGB_HISTOGRAM, RGBHistogram))
#define RGB_HISTOGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RGB_HISTOGRAM, RGBHistogramClass))
#define IS_RGB_HISTOGRAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RGB_HISTOGRAM))
#define IS_RGB_HISTOGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RGB_HISTOGRAM))
#define RGB_HISTOGRAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RGB_HISTOGRAM, RGBHistogramClass))

typedef struct _RGBHistogram RGBHistogram;
typedef struct _RGBHistogramClass RGBHistogramClass;
typedef struct _RGBHistogramPrivate RGBHistogramPrivate;
typedef struct _ParamSpecRGBHistogram ParamSpecRGBHistogram;
typedef struct _ParamSpecIntensityHistogram ParamSpecIntensityHistogram;
#define _hermite_gamma_approximation_function_unref0(var) ((var == NULL) ? NULL : (var = (hermite_gamma_approximation_function_unref (var), NULL)))
typedef struct _ParamSpecHermiteGammaApproximationFunction ParamSpecHermiteGammaApproximationFunction;
#define _intensity_histogram_unref0(var) ((var == NULL) ? NULL : (var = (intensity_histogram_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PixelTransformationBundlePrivate {
	GeeHashMap* map;
};

struct _ParamSpecPixelTransformationBundle {
	GParamSpec parent_instance;
};

struct _PixelTransformationPrivate {
	PixelTransformationType type;
};

struct _ParamSpecPixelTransformation {
	GParamSpec parent_instance;
};

struct _TintTransformationPrivate {
	gfloat parameter;
};

struct _TemperatureTransformationPrivate {
	gfloat parameter;
};

struct _SaturationTransformationPrivate {
	gfloat parameter;
};

struct _ExposureTransformationPrivate {
	gfloat parameter;
};

struct _PixelTransformerPrivate {
	GeeArrayList* transformations;
	PixelTransformation** optimized_transformations;
	gint optimized_transformations_length1;
	gint _optimized_transformations_size_;
	gint optimized_slots_used;
};

struct _ParamSpecPixelTransformer {
	GParamSpec parent_instance;
};

struct _RGBHistogram {
	GTypeInstance parent_instance;
	volatile int ref_count;
	RGBHistogramPrivate * priv;
};

struct _RGBHistogramClass {
	GTypeClass parent_class;
	void (*finalize) (RGBHistogram *self);
};

struct _RGBHistogramPrivate {
	gint* red_counts;
	gint red_counts_length1;
	gint _red_counts_size_;
	gint* green_counts;
	gint green_counts_length1;
	gint _green_counts_size_;
	gint* blue_counts;
	gint blue_counts_length1;
	gint _blue_counts_size_;
	gint* qualitative_red_counts;
	gint qualitative_red_counts_length1;
	gint _qualitative_red_counts_size_;
	gint* qualitative_green_counts;
	gint qualitative_green_counts_length1;
	gint _qualitative_green_counts_size_;
	gint* qualitative_blue_counts;
	gint qualitative_blue_counts_length1;
	gint _qualitative_blue_counts_size_;
	GdkPixbuf* graphic;
};

struct _ParamSpecRGBHistogram {
	GParamSpec parent_instance;
};

struct _IntensityHistogramPrivate {
	gint* counts;
	gint counts_length1;
	gint _counts_size_;
	gfloat* probabilities;
	gint probabilities_length1;
	gint _probabilities_size_;
	gfloat* cumulative_probabilities;
	gint cumulative_probabilities_length1;
	gint _cumulative_probabilities_size_;
};

struct _ParamSpecIntensityHistogram {
	GParamSpec parent_instance;
};

struct _ExpansionTransformationPrivate {
	gfloat* remap_table;
	gint remap_table_length1;
	gint _remap_table_size_;
	gint low_kink;
	gint high_kink;
};

struct _ShadowDetailTransformationPrivate {
	gfloat intensity;
	gfloat* remap_table;
	gint remap_table_length1;
	gint _remap_table_size_;
};

struct _HermiteGammaApproximationFunctionPrivate {
	gfloat x_scale;
	gfloat nonzero_interval_upper;
};

struct _ParamSpecHermiteGammaApproximationFunction {
	GParamSpec parent_instance;
};

struct _HighlightDetailTransformationPrivate {
	gfloat intensity;
	gfloat* remap_table;
	gint remap_table_length1;
	gint _remap_table_size_;
};

static gint PixelTransformationBundle_private_offset;
static gpointer pixel_transformation_bundle_parent_class = NULL;
static PixelTransformationBundle* pixel_transformation_bundle_copied_color_adjustments;
static PixelTransformationBundle* pixel_transformation_bundle_copied_color_adjustments = NULL;
static gint PixelTransformation_private_offset;
static gpointer pixel_transformation_parent_class = NULL;
static gpointer rgb_transformation_parent_class = NULL;
static gpointer hsv_transformation_parent_class = NULL;
static gint TintTransformation_private_offset;
static gpointer tint_transformation_parent_class = NULL;
static gint TemperatureTransformation_private_offset;
static gpointer temperature_transformation_parent_class = NULL;
static gint SaturationTransformation_private_offset;
static gpointer saturation_transformation_parent_class = NULL;
static gint ExposureTransformation_private_offset;
static gpointer exposure_transformation_parent_class = NULL;
static gint PixelTransformer_private_offset;
static gpointer pixel_transformer_parent_class = NULL;
static gint RGBHistogram_private_offset;
static gpointer rgb_histogram_parent_class = NULL;
static gint IntensityHistogram_private_offset;
static gpointer intensity_histogram_parent_class = NULL;
static gint ExpansionTransformation_private_offset;
static gpointer expansion_transformation_parent_class = NULL;
static gint ShadowDetailTransformation_private_offset;
static gpointer shadow_detail_transformation_parent_class = NULL;
static gint HermiteGammaApproximationFunction_private_offset;
static gpointer hermite_gamma_approximation_function_parent_class = NULL;
static gint HighlightDetailTransformation_private_offset;
static gpointer highlight_detail_transformation_parent_class = NULL;

static void pixel_transformation_bundle_finalize (PixelTransformationBundle * obj);
static GType pixel_transformation_bundle_get_type_once (void);
static PixelFormat pixel_transformation_real_get_preferred_format (PixelTransformation* self);
static CompositionMode pixel_transformation_real_get_composition_mode (PixelTransformation* self);
static void pixel_transformation_real_compose_with (PixelTransformation* self,
                                             PixelTransformation* other);
static gboolean pixel_transformation_real_is_identity (PixelTransformation* self);
static void pixel_transformation_real_transform_pixel_hsv (PixelTransformation* self,
                                                    HSVAnalyticPixel* p,
                                                    HSVAnalyticPixel* result);
static void pixel_transformation_real_transform_pixel_rgb (PixelTransformation* self,
                                                    RGBAnalyticPixel* p,
                                                    RGBAnalyticPixel* result);
static gchar* pixel_transformation_real_to_string (PixelTransformation* self);
static PixelTransformation* pixel_transformation_real_copy (PixelTransformation* self);
static void pixel_transformation_finalize (PixelTransformation * obj);
static GType pixel_transformation_get_type_once (void);
static PixelFormat rgb_transformation_real_get_preferred_format (PixelTransformation* base);
static CompositionMode rgb_transformation_real_get_composition_mode (PixelTransformation* base);
static void rgb_transformation_real_compose_with (PixelTransformation* base,
                                           PixelTransformation* other);
static void rgb_transformation_real_transform_pixel_hsv (PixelTransformation* base,
                                                  HSVAnalyticPixel* p,
                                                  HSVAnalyticPixel* result);
static void rgb_transformation_real_transform_pixel_rgb (PixelTransformation* base,
                                                  RGBAnalyticPixel* p,
                                                  RGBAnalyticPixel* result);
static gboolean rgb_transformation_real_is_identity (PixelTransformation* base);
static PixelTransformation* rgb_transformation_real_copy (PixelTransformation* base);
static void rgb_transformation_finalize (PixelTransformation * obj);
static GType rgb_transformation_get_type_once (void);
static PixelFormat hsv_transformation_real_get_preferred_format (PixelTransformation* base);
static void hsv_transformation_real_transform_pixel_rgb (PixelTransformation* base,
                                                  RGBAnalyticPixel* p,
                                                  RGBAnalyticPixel* result);
static GType hsv_transformation_get_type_once (void);
static void tint_transformation_finalize (PixelTransformation * obj);
static GType tint_transformation_get_type_once (void);
static void temperature_transformation_finalize (PixelTransformation * obj);
static GType temperature_transformation_get_type_once (void);
static void saturation_transformation_finalize (PixelTransformation * obj);
static GType saturation_transformation_get_type_once (void);
static void exposure_transformation_finalize (PixelTransformation * obj);
static GType exposure_transformation_get_type_once (void);
static void pixel_transformer_build_optimized_transformations (PixelTransformer* self);
static void pixel_transformer_apply_transformations (PixelTransformer* self,
                                              RGBAnalyticPixel* p,
                                              RGBAnalyticPixel* result);
static void pixel_transformer_finalize (PixelTransformer * obj);
static GType pixel_transformer_get_type_once (void);
VALA_EXTERN gpointer rgb_histogram_ref (gpointer instance);
VALA_EXTERN void rgb_histogram_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_rgb_histogram (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_rgb_histogram (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_rgb_histogram (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_rgb_histogram (const GValue* value);
VALA_EXTERN GType rgb_histogram_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RGBHistogram* rgb_histogram_new (GdkPixbuf* pixbuf);
VALA_EXTERN RGBHistogram* rgb_histogram_construct (GType object_type,
                                       GdkPixbuf* pixbuf);
static gint rgb_histogram_correct_snap_to_quantization (RGBHistogram* self,
                                                 gint* buckets,
                                                 gint buckets_length1,
                                                 gint i);
static gint rgb_histogram_correct_snap_from_quantization (RGBHistogram* self,
                                                   gint* buckets,
                                                   gint buckets_length1,
                                                   gint i);
static void rgb_histogram_smooth_extrema (RGBHistogram* self,
                                   gint** count_data,
                                   gint* count_data_length1);
static void rgb_histogram_prepare_qualitative_counts (RGBHistogram* self);
VALA_EXTERN GdkPixbuf* rgb_histogram_get_graphic (RGBHistogram* self);
static void rgb_histogram_finalize (RGBHistogram * obj);
static GType rgb_histogram_get_type_once (void);
static void intensity_histogram_finalize (IntensityHistogram * obj);
static GType intensity_histogram_get_type_once (void);
static void expansion_transformation_build_remap_table (ExpansionTransformation* self);
static void expansion_transformation_real_transform_pixel_hsv (PixelTransformation* base,
                                                        HSVAnalyticPixel* pixel,
                                                        HSVAnalyticPixel* result);
static gchar* expansion_transformation_real_to_string (PixelTransformation* base);
static gboolean expansion_transformation_real_is_identity (PixelTransformation* base);
static PixelTransformation* expansion_transformation_real_copy (PixelTransformation* base);
static void expansion_transformation_finalize (PixelTransformation * obj);
static GType expansion_transformation_get_type_once (void);
static void shadow_detail_transformation_real_transform_pixel_hsv (PixelTransformation* base,
                                                            HSVAnalyticPixel* pixel,
                                                            HSVAnalyticPixel* result);
static PixelTransformation* shadow_detail_transformation_real_copy (PixelTransformation* base);
static gboolean shadow_detail_transformation_real_is_identity (PixelTransformation* base);
static void shadow_detail_transformation_finalize (PixelTransformation * obj);
static GType shadow_detail_transformation_get_type_once (void);
static void hermite_gamma_approximation_function_finalize (HermiteGammaApproximationFunction * obj);
static GType hermite_gamma_approximation_function_get_type_once (void);
static void highlight_detail_transformation_real_transform_pixel_hsv (PixelTransformation* base,
                                                               HSVAnalyticPixel* pixel,
                                                               HSVAnalyticPixel* result);
static PixelTransformation* highlight_detail_transformation_real_copy (PixelTransformation* base);
static gboolean highlight_detail_transformation_real_is_identity (PixelTransformation* base);
static void highlight_detail_transformation_finalize (PixelTransformation * obj);
static GType highlight_detail_transformation_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
rgb_analytic_pixel_init (RGBAnalyticPixel *self)
{
#line 27 "../src/ColorTransformation.vala"
	memset (self, 0, sizeof (RGBAnalyticPixel));
#line 28 "../src/ColorTransformation.vala"
	(*self).red = 0.0f;
#line 29 "../src/ColorTransformation.vala"
	(*self).green = 0.0f;
#line 30 "../src/ColorTransformation.vala"
	(*self).blue = 0.0f;
#line 384 "ColorTransformation.c"
}

void
rgb_analytic_pixel_init_from_components (RGBAnalyticPixel *self,
                                         gfloat red,
                                         gfloat green,
                                         gfloat blue)
{
#line 33 "../src/ColorTransformation.vala"
	memset (self, 0, sizeof (RGBAnalyticPixel));
#line 35 "../src/ColorTransformation.vala"
	(*self).red = CLAMP (red, 0.0f, 1.0f);
#line 36 "../src/ColorTransformation.vala"
	(*self).green = CLAMP (green, 0.0f, 1.0f);
#line 37 "../src/ColorTransformation.vala"
	(*self).blue = CLAMP (blue, 0.0f, 1.0f);
#line 401 "ColorTransformation.c"
}

void
rgb_analytic_pixel_init_from_quantized_components (RGBAnalyticPixel *self,
                                                   guchar red_quantized,
                                                   guchar green_quantized,
                                                   guchar blue_quantized)
{
#line 40 "../src/ColorTransformation.vala"
	memset (self, 0, sizeof (RGBAnalyticPixel));
#line 42 "../src/ColorTransformation.vala"
	(*self).red = ((gfloat) red_quantized) * RGB_ANALYTIC_PIXEL_INV_255;
#line 43 "../src/ColorTransformation.vala"
	(*self).green = ((gfloat) green_quantized) * RGB_ANALYTIC_PIXEL_INV_255;
#line 44 "../src/ColorTransformation.vala"
	(*self).blue = ((gfloat) blue_quantized) * RGB_ANALYTIC_PIXEL_INV_255;
#line 418 "ColorTransformation.c"
}

void
rgb_analytic_pixel_init_from_hsv (RGBAnalyticPixel *self,
                                  HSVAnalyticPixel* hsv_pixel)
{
	RGBAnalyticPixel from_hsv = {0};
	RGBAnalyticPixel _tmp0_ = {0};
	RGBAnalyticPixel _tmp1_;
	RGBAnalyticPixel _tmp2_;
	RGBAnalyticPixel _tmp3_;
#line 47 "../src/ColorTransformation.vala"
	g_return_if_fail (hsv_pixel != NULL);
#line 47 "../src/ColorTransformation.vala"
	memset (self, 0, sizeof (RGBAnalyticPixel));
#line 48 "../src/ColorTransformation.vala"
	hsv_analytic_pixel_to_rgb (hsv_pixel, &_tmp0_);
#line 48 "../src/ColorTransformation.vala"
	from_hsv = _tmp0_;
#line 49 "../src/ColorTransformation.vala"
	_tmp1_ = from_hsv;
#line 49 "../src/ColorTransformation.vala"
	(*self).red = _tmp1_.red;
#line 50 "../src/ColorTransformation.vala"
	_tmp2_ = from_hsv;
#line 50 "../src/ColorTransformation.vala"
	(*self).green = _tmp2_.green;
#line 51 "../src/ColorTransformation.vala"
	_tmp3_ = from_hsv;
#line 51 "../src/ColorTransformation.vala"
	(*self).blue = _tmp3_.blue;
#line 450 "ColorTransformation.c"
}

guchar
rgb_analytic_pixel_quantized_red (RGBAnalyticPixel *self)
{
	guchar result;
#line 55 "../src/ColorTransformation.vala"
	result = (guchar) ((*self).red * 255.0f);
#line 55 "../src/ColorTransformation.vala"
	return result;
#line 461 "ColorTransformation.c"
}

guchar
rgb_analytic_pixel_quantized_green (RGBAnalyticPixel *self)
{
	guchar result;
#line 59 "../src/ColorTransformation.vala"
	result = (guchar) ((*self).green * 255.0f);
#line 59 "../src/ColorTransformation.vala"
	return result;
#line 472 "ColorTransformation.c"
}

guchar
rgb_analytic_pixel_quantized_blue (RGBAnalyticPixel *self)
{
	guchar result;
#line 63 "../src/ColorTransformation.vala"
	result = (guchar) ((*self).blue * 255.0f);
#line 63 "../src/ColorTransformation.vala"
	return result;
#line 483 "ColorTransformation.c"
}

gboolean
rgb_analytic_pixel_equals (RGBAnalyticPixel *self,
                           RGBAnalyticPixel* rhs)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 67 "../src/ColorTransformation.vala"
	if ((*self).red == (*rhs).red) {
#line 67 "../src/ColorTransformation.vala"
		_tmp1_ = (*self).green == (*rhs).green;
#line 497 "ColorTransformation.c"
	} else {
#line 67 "../src/ColorTransformation.vala"
		_tmp1_ = FALSE;
#line 501 "ColorTransformation.c"
	}
#line 67 "../src/ColorTransformation.vala"
	if (_tmp1_) {
#line 67 "../src/ColorTransformation.vala"
		_tmp0_ = (*self).blue == (*rhs).blue;
#line 507 "ColorTransformation.c"
	} else {
#line 67 "../src/ColorTransformation.vala"
		_tmp0_ = FALSE;
#line 511 "ColorTransformation.c"
	}
#line 67 "../src/ColorTransformation.vala"
	result = _tmp0_;
#line 67 "../src/ColorTransformation.vala"
	return result;
#line 517 "ColorTransformation.c"
}

guint
rgb_analytic_pixel_hash_code (RGBAnalyticPixel *self)
{
	guint result;
#line 71 "../src/ColorTransformation.vala"
	result = ((((guint) ((*self).red * 255.0f)) << 16) + (((guint) ((*self).green * 255.0f)) << 8)) + ((guint) ((*self).blue * 255.0f));
#line 71 "../src/ColorTransformation.vala"
	return result;
#line 528 "ColorTransformation.c"
}

void
rgb_analytic_pixel_to_hsv (RGBAnalyticPixel *self,
                           HSVAnalyticPixel* result)
{
	HSVAnalyticPixel _tmp0_ = {0};
#line 76 "../src/ColorTransformation.vala"
	hsv_analytic_pixel_init_from_rgb (&_tmp0_, &(*self));
#line 76 "../src/ColorTransformation.vala"
	*result = _tmp0_;
#line 76 "../src/ColorTransformation.vala"
	return;
#line 542 "ColorTransformation.c"
}

RGBAnalyticPixel*
rgb_analytic_pixel_dup (const RGBAnalyticPixel* self)
{
	RGBAnalyticPixel* dup;
#line 20 "../src/ColorTransformation.vala"
	dup = g_new0 (RGBAnalyticPixel, 1);
#line 20 "../src/ColorTransformation.vala"
	memcpy (dup, self, sizeof (RGBAnalyticPixel));
#line 20 "../src/ColorTransformation.vala"
	return dup;
#line 555 "ColorTransformation.c"
}

void
rgb_analytic_pixel_free (RGBAnalyticPixel* self)
{
#line 20 "../src/ColorTransformation.vala"
	g_free (self);
#line 563 "ColorTransformation.c"
}

static GType
rgb_analytic_pixel_get_type_once (void)
{
	GType rgb_analytic_pixel_type_id;
	rgb_analytic_pixel_type_id = g_boxed_type_register_static ("RGBAnalyticPixel", (GBoxedCopyFunc) rgb_analytic_pixel_dup, (GBoxedFreeFunc) rgb_analytic_pixel_free);
	return rgb_analytic_pixel_type_id;
}

GType
rgb_analytic_pixel_get_type (void)
{
	static volatile gsize rgb_analytic_pixel_type_id__once = 0;
	if (g_once_init_enter (&rgb_analytic_pixel_type_id__once)) {
		GType rgb_analytic_pixel_type_id;
		rgb_analytic_pixel_type_id = rgb_analytic_pixel_get_type_once ();
		g_once_init_leave (&rgb_analytic_pixel_type_id__once, rgb_analytic_pixel_type_id);
	}
	return rgb_analytic_pixel_type_id__once;
}

void
hsv_analytic_pixel_init (HSVAnalyticPixel *self)
{
#line 87 "../src/ColorTransformation.vala"
	memset (self, 0, sizeof (HSVAnalyticPixel));
#line 88 "../src/ColorTransformation.vala"
	(*self).hue = 0.0f;
#line 89 "../src/ColorTransformation.vala"
	(*self).saturation = 0.0f;
#line 90 "../src/ColorTransformation.vala"
	(*self).light_value = 0.0f;
#line 597 "ColorTransformation.c"
}

void
hsv_analytic_pixel_init_from_components (HSVAnalyticPixel *self,
                                         gfloat hue,
                                         gfloat saturation,
                                         gfloat light_value)
{
#line 93 "../src/ColorTransformation.vala"
	memset (self, 0, sizeof (HSVAnalyticPixel));
#line 95 "../src/ColorTransformation.vala"
	(*self).hue = CLAMP (hue, 0.0f, 1.0f);
#line 96 "../src/ColorTransformation.vala"
	(*self).saturation = CLAMP (saturation, 0.0f, 1.0f);
#line 97 "../src/ColorTransformation.vala"
	(*self).light_value = CLAMP (light_value, 0.0f, 1.0f);
#line 614 "ColorTransformation.c"
}

void
hsv_analytic_pixel_init_from_quantized_components (HSVAnalyticPixel *self,
                                                   guchar hue_quantized,
                                                   guchar saturation_quantized,
                                                   guchar light_value_quantized)
{
#line 100 "../src/ColorTransformation.vala"
	memset (self, 0, sizeof (HSVAnalyticPixel));
#line 102 "../src/ColorTransformation.vala"
	(*self).hue = ((gfloat) hue_quantized) * HSV_ANALYTIC_PIXEL_INV_255;
#line 103 "../src/ColorTransformation.vala"
	(*self).saturation = ((gfloat) saturation_quantized) * HSV_ANALYTIC_PIXEL_INV_255;
#line 104 "../src/ColorTransformation.vala"
	(*self).light_value = ((gfloat) light_value_quantized) * HSV_ANALYTIC_PIXEL_INV_255;
#line 631 "ColorTransformation.c"
}

void
hsv_analytic_pixel_init_from_rgb (HSVAnalyticPixel *self,
                                  RGBAnalyticPixel* p)
{
	gfloat max_component = 0.0F;
	RGBAnalyticPixel _tmp0_;
	RGBAnalyticPixel _tmp1_;
	RGBAnalyticPixel _tmp2_;
	gfloat min_component = 0.0F;
	RGBAnalyticPixel _tmp3_;
	RGBAnalyticPixel _tmp4_;
	RGBAnalyticPixel _tmp5_;
	gfloat _tmp6_ = 0.0F;
#line 107 "../src/ColorTransformation.vala"
	g_return_if_fail (p != NULL);
#line 107 "../src/ColorTransformation.vala"
	memset (self, 0, sizeof (HSVAnalyticPixel));
#line 108 "../src/ColorTransformation.vala"
	_tmp0_ = *p;
#line 108 "../src/ColorTransformation.vala"
	_tmp1_ = *p;
#line 108 "../src/ColorTransformation.vala"
	_tmp2_ = *p;
#line 108 "../src/ColorTransformation.vala"
	max_component = MAX (MAX (_tmp0_.red, _tmp1_.green), _tmp2_.blue);
#line 109 "../src/ColorTransformation.vala"
	_tmp3_ = *p;
#line 109 "../src/ColorTransformation.vala"
	_tmp4_ = *p;
#line 109 "../src/ColorTransformation.vala"
	_tmp5_ = *p;
#line 109 "../src/ColorTransformation.vala"
	min_component = MIN (MIN (_tmp3_.red, _tmp4_.green), _tmp5_.blue);
#line 111 "../src/ColorTransformation.vala"
	(*self).light_value = max_component;
#line 112 "../src/ColorTransformation.vala"
	if (max_component != 0.0f) {
#line 112 "../src/ColorTransformation.vala"
		_tmp6_ = (max_component - min_component) / max_component;
#line 673 "ColorTransformation.c"
	} else {
#line 113 "../src/ColorTransformation.vala"
		_tmp6_ = 0.0f;
#line 677 "ColorTransformation.c"
	}
#line 112 "../src/ColorTransformation.vala"
	(*self).saturation = _tmp6_;
#line 115 "../src/ColorTransformation.vala"
	if ((*self).saturation == 0.0f) {
#line 116 "../src/ColorTransformation.vala"
		(*self).hue = 0.0f;
#line 685 "ColorTransformation.c"
	} else {
		gfloat delta = 0.0F;
		RGBAnalyticPixel _tmp7_;
#line 118 "../src/ColorTransformation.vala"
		delta = max_component - min_component;
#line 119 "../src/ColorTransformation.vala"
		_tmp7_ = *p;
#line 119 "../src/ColorTransformation.vala"
		if (_tmp7_.red == max_component) {
#line 695 "ColorTransformation.c"
			RGBAnalyticPixel _tmp8_;
			RGBAnalyticPixel _tmp9_;
#line 120 "../src/ColorTransformation.vala"
			_tmp8_ = *p;
#line 120 "../src/ColorTransformation.vala"
			_tmp9_ = *p;
#line 120 "../src/ColorTransformation.vala"
			(*self).hue = (_tmp8_.green - _tmp9_.blue) / delta;
#line 704 "ColorTransformation.c"
		} else {
			RGBAnalyticPixel _tmp10_;
#line 121 "../src/ColorTransformation.vala"
			_tmp10_ = *p;
#line 121 "../src/ColorTransformation.vala"
			if (_tmp10_.green == max_component) {
#line 711 "ColorTransformation.c"
				RGBAnalyticPixel _tmp11_;
				RGBAnalyticPixel _tmp12_;
#line 122 "../src/ColorTransformation.vala"
				_tmp11_ = *p;
#line 122 "../src/ColorTransformation.vala"
				_tmp12_ = *p;
#line 122 "../src/ColorTransformation.vala"
				(*self).hue = 2.0f + ((_tmp11_.blue - _tmp12_.red) / delta);
#line 720 "ColorTransformation.c"
			} else {
				RGBAnalyticPixel _tmp13_;
#line 123 "../src/ColorTransformation.vala"
				_tmp13_ = *p;
#line 123 "../src/ColorTransformation.vala"
				if (_tmp13_.blue == max_component) {
#line 727 "ColorTransformation.c"
					RGBAnalyticPixel _tmp14_;
					RGBAnalyticPixel _tmp15_;
#line 124 "../src/ColorTransformation.vala"
					_tmp14_ = *p;
#line 124 "../src/ColorTransformation.vala"
					_tmp15_ = *p;
#line 124 "../src/ColorTransformation.vala"
					(*self).hue = 4.0f + ((_tmp14_.red - _tmp15_.green) / delta);
#line 736 "ColorTransformation.c"
				}
			}
		}
#line 127 "../src/ColorTransformation.vala"
		(*self).hue = (*self).hue * 60.0f;
#line 128 "../src/ColorTransformation.vala"
		if ((*self).hue < 0.0f) {
#line 129 "../src/ColorTransformation.vala"
			(*self).hue = (*self).hue + 360.0f;
#line 746 "ColorTransformation.c"
		}
#line 131 "../src/ColorTransformation.vala"
		(*self).hue = (*self).hue / 360.0f;
#line 750 "ColorTransformation.c"
	}
#line 134 "../src/ColorTransformation.vala"
	(*self).hue = CLAMP ((*self).hue, 0.0f, 1.0f);
#line 135 "../src/ColorTransformation.vala"
	(*self).saturation = CLAMP ((*self).saturation, 0.0f, 1.0f);
#line 136 "../src/ColorTransformation.vala"
	(*self).light_value = CLAMP ((*self).light_value, 0.0f, 1.0f);
#line 758 "ColorTransformation.c"
}

void
hsv_analytic_pixel_to_rgb (HSVAnalyticPixel *self,
                           RGBAnalyticPixel* result)
{
	RGBAnalyticPixel _result_ = {0};
#line 140 "../src/ColorTransformation.vala"
	rgb_analytic_pixel_init (&_result_);
#line 142 "../src/ColorTransformation.vala"
	if ((*self).saturation == 0.0f) {
#line 143 "../src/ColorTransformation.vala"
		_result_.red = (*self).light_value;
#line 144 "../src/ColorTransformation.vala"
		_result_.green = (*self).light_value;
#line 145 "../src/ColorTransformation.vala"
		_result_.blue = (*self).light_value;
#line 776 "ColorTransformation.c"
	} else {
		gfloat hue_denorm = 0.0F;
		gfloat hue_hexant = 0.0F;
		gint hexant_i_part = 0;
		gfloat hexant_f_part = 0.0F;
		gfloat p = 0.0F;
		gfloat q = 0.0F;
		gfloat t = 0.0F;
#line 147 "../src/ColorTransformation.vala"
		hue_denorm = (*self).hue * 360.0f;
#line 148 "../src/ColorTransformation.vala"
		if (hue_denorm == 360.0f) {
#line 149 "../src/ColorTransformation.vala"
			hue_denorm = 0.0f;
#line 791 "ColorTransformation.c"
		}
#line 151 "../src/ColorTransformation.vala"
		hue_hexant = hue_denorm / 60.0f;
#line 153 "../src/ColorTransformation.vala"
		hexant_i_part = (gint) hue_hexant;
#line 155 "../src/ColorTransformation.vala"
		hexant_f_part = hue_hexant - ((gfloat) hexant_i_part);
#line 158 "../src/ColorTransformation.vala"
		p = (*self).light_value * (1.0f - (*self).saturation);
#line 159 "../src/ColorTransformation.vala"
		q = (*self).light_value * (1.0f - ((*self).saturation * hexant_f_part));
#line 160 "../src/ColorTransformation.vala"
		t = (*self).light_value * (1.0f - ((*self).saturation * (1.0f - hexant_f_part)));
#line 161 "../src/ColorTransformation.vala"
		switch (hexant_i_part) {
#line 161 "../src/ColorTransformation.vala"
			case 0:
#line 809 "ColorTransformation.c"
			{
#line 172 "../src/ColorTransformation.vala"
				_result_.red = (*self).light_value;
#line 173 "../src/ColorTransformation.vala"
				_result_.green = t;
#line 174 "../src/ColorTransformation.vala"
				_result_.blue = p;
#line 175 "../src/ColorTransformation.vala"
				break;
#line 819 "ColorTransformation.c"
			}
#line 161 "../src/ColorTransformation.vala"
			case 1:
#line 823 "ColorTransformation.c"
			{
#line 178 "../src/ColorTransformation.vala"
				_result_.red = q;
#line 179 "../src/ColorTransformation.vala"
				_result_.green = (*self).light_value;
#line 180 "../src/ColorTransformation.vala"
				_result_.blue = p;
#line 181 "../src/ColorTransformation.vala"
				break;
#line 833 "ColorTransformation.c"
			}
#line 161 "../src/ColorTransformation.vala"
			case 2:
#line 837 "ColorTransformation.c"
			{
#line 184 "../src/ColorTransformation.vala"
				_result_.red = p;
#line 185 "../src/ColorTransformation.vala"
				_result_.green = (*self).light_value;
#line 186 "../src/ColorTransformation.vala"
				_result_.blue = t;
#line 187 "../src/ColorTransformation.vala"
				break;
#line 847 "ColorTransformation.c"
			}
#line 161 "../src/ColorTransformation.vala"
			case 3:
#line 851 "ColorTransformation.c"
			{
#line 190 "../src/ColorTransformation.vala"
				_result_.red = p;
#line 191 "../src/ColorTransformation.vala"
				_result_.green = q;
#line 192 "../src/ColorTransformation.vala"
				_result_.blue = (*self).light_value;
#line 193 "../src/ColorTransformation.vala"
				break;
#line 861 "ColorTransformation.c"
			}
#line 161 "../src/ColorTransformation.vala"
			case 4:
#line 865 "ColorTransformation.c"
			{
#line 196 "../src/ColorTransformation.vala"
				_result_.red = t;
#line 197 "../src/ColorTransformation.vala"
				_result_.green = p;
#line 198 "../src/ColorTransformation.vala"
				_result_.blue = (*self).light_value;
#line 199 "../src/ColorTransformation.vala"
				break;
#line 875 "ColorTransformation.c"
			}
#line 161 "../src/ColorTransformation.vala"
			case 5:
#line 879 "ColorTransformation.c"
			{
#line 202 "../src/ColorTransformation.vala"
				_result_.red = (*self).light_value;
#line 203 "../src/ColorTransformation.vala"
				_result_.green = p;
#line 204 "../src/ColorTransformation.vala"
				_result_.blue = q;
#line 205 "../src/ColorTransformation.vala"
				break;
#line 889 "ColorTransformation.c"
			}
			default:
			{
#line 208 "../src/ColorTransformation.vala"
				g_error ("ColorTransformation.vala:208: bad color hexant in HSV-to-RGB conversio" \
"n");
#line 895 "ColorTransformation.c"
			}
		}
	}
#line 212 "../src/ColorTransformation.vala"
	*result = _result_;
#line 212 "../src/ColorTransformation.vala"
	return;
#line 903 "ColorTransformation.c"
}

gboolean
hsv_analytic_pixel_equals (HSVAnalyticPixel *self,
                           HSVAnalyticPixel* rhs)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HSVAnalyticPixel _tmp2_;
	gboolean result;
#line 215 "../src/ColorTransformation.vala"
	g_return_val_if_fail (rhs != NULL, FALSE);
#line 216 "../src/ColorTransformation.vala"
	_tmp2_ = *rhs;
#line 216 "../src/ColorTransformation.vala"
	if ((*self).hue == _tmp2_.hue) {
#line 920 "ColorTransformation.c"
		HSVAnalyticPixel _tmp3_;
#line 216 "../src/ColorTransformation.vala"
		_tmp3_ = *rhs;
#line 216 "../src/ColorTransformation.vala"
		_tmp1_ = (*self).saturation == _tmp3_.saturation;
#line 926 "ColorTransformation.c"
	} else {
#line 216 "../src/ColorTransformation.vala"
		_tmp1_ = FALSE;
#line 930 "ColorTransformation.c"
	}
#line 216 "../src/ColorTransformation.vala"
	if (_tmp1_) {
#line 934 "ColorTransformation.c"
		HSVAnalyticPixel _tmp4_;
#line 217 "../src/ColorTransformation.vala"
		_tmp4_ = *rhs;
#line 217 "../src/ColorTransformation.vala"
		_tmp0_ = (*self).light_value == _tmp4_.light_value;
#line 940 "ColorTransformation.c"
	} else {
#line 216 "../src/ColorTransformation.vala"
		_tmp0_ = FALSE;
#line 944 "ColorTransformation.c"
	}
#line 216 "../src/ColorTransformation.vala"
	result = _tmp0_;
#line 216 "../src/ColorTransformation.vala"
	return result;
#line 950 "ColorTransformation.c"
}

guint
hsv_analytic_pixel_hash_code (HSVAnalyticPixel *self)
{
	guint result;
#line 221 "../src/ColorTransformation.vala"
	result = ((((guint) ((*self).hue * 255.0f)) << 16) + (((guint) ((*self).saturation * 255.0f)) << 8)) + ((guint) ((*self).light_value * 255.0f));
#line 221 "../src/ColorTransformation.vala"
	return result;
#line 961 "ColorTransformation.c"
}

HSVAnalyticPixel*
hsv_analytic_pixel_dup (const HSVAnalyticPixel* self)
{
	HSVAnalyticPixel* dup;
#line 80 "../src/ColorTransformation.vala"
	dup = g_new0 (HSVAnalyticPixel, 1);
#line 80 "../src/ColorTransformation.vala"
	memcpy (dup, self, sizeof (HSVAnalyticPixel));
#line 80 "../src/ColorTransformation.vala"
	return dup;
#line 974 "ColorTransformation.c"
}

void
hsv_analytic_pixel_free (HSVAnalyticPixel* self)
{
#line 80 "../src/ColorTransformation.vala"
	g_free (self);
#line 982 "ColorTransformation.c"
}

static GType
hsv_analytic_pixel_get_type_once (void)
{
	GType hsv_analytic_pixel_type_id;
	hsv_analytic_pixel_type_id = g_boxed_type_register_static ("HSVAnalyticPixel", (GBoxedCopyFunc) hsv_analytic_pixel_dup, (GBoxedFreeFunc) hsv_analytic_pixel_free);
	return hsv_analytic_pixel_type_id;
}

GType
hsv_analytic_pixel_get_type (void)
{
	static volatile gsize hsv_analytic_pixel_type_id__once = 0;
	if (g_once_init_enter (&hsv_analytic_pixel_type_id__once)) {
		GType hsv_analytic_pixel_type_id;
		hsv_analytic_pixel_type_id = hsv_analytic_pixel_get_type_once ();
		g_once_init_leave (&hsv_analytic_pixel_type_id__once, hsv_analytic_pixel_type_id);
	}
	return hsv_analytic_pixel_type_id__once;
}

static GType
composition_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{COMPOSITION_MODE_NONE, "COMPOSITION_MODE_NONE", "none"}, {COMPOSITION_MODE_RGB_MATRIX, "COMPOSITION_MODE_RGB_MATRIX", "rgb-matrix"}, {0, NULL, NULL}};
	GType composition_mode_type_id;
	composition_mode_type_id = g_enum_register_static ("CompositionMode", values);
	return composition_mode_type_id;
}

GType
composition_mode_get_type (void)
{
	static volatile gsize composition_mode_type_id__once = 0;
	if (g_once_init_enter (&composition_mode_type_id__once)) {
		GType composition_mode_type_id;
		composition_mode_type_id = composition_mode_get_type_once ();
		g_once_init_leave (&composition_mode_type_id__once, composition_mode_type_id);
	}
	return composition_mode_type_id__once;
}

static GType
pixel_format_get_type_once (void)
{
	static const GEnumValue values[] = {{PIXEL_FORMAT_RGB, "PIXEL_FORMAT_RGB", "rgb"}, {PIXEL_FORMAT_HSV, "PIXEL_FORMAT_HSV", "hsv"}, {0, NULL, NULL}};
	GType pixel_format_type_id;
	pixel_format_type_id = g_enum_register_static ("PixelFormat", values);
	return pixel_format_type_id;
}

GType
pixel_format_get_type (void)
{
	static volatile gsize pixel_format_type_id__once = 0;
	if (g_once_init_enter (&pixel_format_type_id__once)) {
		GType pixel_format_type_id;
		pixel_format_type_id = pixel_format_get_type_once ();
		g_once_init_leave (&pixel_format_type_id__once, pixel_format_type_id);
	}
	return pixel_format_type_id__once;
}

static GType
pixel_transformation_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION, "PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION", "tone-expansion"}, {PIXEL_TRANSFORMATION_TYPE_SHADOWS, "PIXEL_TRANSFORMATION_TYPE_SHADOWS", "shadows"}, {PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS, "PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS", "highlights"}, {PIXEL_TRANSFORMATION_TYPE_TEMPERATURE, "PIXEL_TRANSFORMATION_TYPE_TEMPERATURE", "temperature"}, {PIXEL_TRANSFORMATION_TYPE_TINT, "PIXEL_TRANSFORMATION_TYPE_TINT", "tint"}, {PIXEL_TRANSFORMATION_TYPE_SATURATION, "PIXEL_TRANSFORMATION_TYPE_SATURATION", "saturation"}, {PIXEL_TRANSFORMATION_TYPE_EXPOSURE, "PIXEL_TRANSFORMATION_TYPE_EXPOSURE", "exposure"}, {0, NULL, NULL}};
	GType pixel_transformation_type_type_id;
	pixel_transformation_type_type_id = g_enum_register_static ("PixelTransformationType", values);
	return pixel_transformation_type_type_id;
}

GType
pixel_transformation_type_get_type (void)
{
	static volatile gsize pixel_transformation_type_type_id__once = 0;
	if (g_once_init_enter (&pixel_transformation_type_type_id__once)) {
		GType pixel_transformation_type_type_id;
		pixel_transformation_type_type_id = pixel_transformation_type_get_type_once ();
		g_once_init_leave (&pixel_transformation_type_type_id__once, pixel_transformation_type_type_id);
	}
	return pixel_transformation_type_type_id__once;
}

static inline gpointer
pixel_transformation_bundle_get_instance_private (PixelTransformationBundle* self)
{
	return G_STRUCT_MEMBER_P (self, PixelTransformationBundle_private_offset);
}

PixelTransformationBundle*
pixel_transformation_bundle_construct (GType object_type)
{
	PixelTransformationBundle* self = NULL;
#line 252 "../src/ColorTransformation.vala"
	self = (PixelTransformationBundle*) g_type_create_instance (object_type);
#line 252 "../src/ColorTransformation.vala"
	return self;
#line 1082 "ColorTransformation.c"
}

PixelTransformationBundle*
pixel_transformation_bundle_new (void)
{
#line 252 "../src/ColorTransformation.vala"
	return pixel_transformation_bundle_construct (TYPE_PIXEL_TRANSFORMATION_BUNDLE);
#line 1090 "ColorTransformation.c"
}

static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 256 "../src/ColorTransformation.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 1098 "ColorTransformation.c"
}

PixelTransformationBundle*
pixel_transformation_bundle_get_copied_color_adjustments (void)
{
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformationBundle* result;
#line 256 "../src/ColorTransformation.vala"
	_tmp0_ = pixel_transformation_bundle_copied_color_adjustments;
#line 256 "../src/ColorTransformation.vala"
	_tmp1_ = _pixel_transformation_bundle_ref0 (_tmp0_);
#line 256 "../src/ColorTransformation.vala"
	result = _tmp1_;
#line 256 "../src/ColorTransformation.vala"
	return result;
#line 1115 "ColorTransformation.c"
}

void
pixel_transformation_bundle_set_copied_color_adjustments (PixelTransformationBundle* adjustments)
{
	PixelTransformationBundle* _tmp0_;
#line 259 "../src/ColorTransformation.vala"
	g_return_if_fail (adjustments != NULL);
#line 260 "../src/ColorTransformation.vala"
	_tmp0_ = _pixel_transformation_bundle_ref0 (adjustments);
#line 260 "../src/ColorTransformation.vala"
	_pixel_transformation_bundle_unref0 (pixel_transformation_bundle_copied_color_adjustments);
#line 260 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_copied_color_adjustments = _tmp0_;
#line 1130 "ColorTransformation.c"
}

gboolean
pixel_transformation_bundle_has_copied_color_adjustments (void)
{
	PixelTransformationBundle* _tmp0_;
	gboolean result;
#line 264 "../src/ColorTransformation.vala"
	_tmp0_ = pixel_transformation_bundle_copied_color_adjustments;
#line 264 "../src/ColorTransformation.vala"
	result = _tmp0_ != NULL;
#line 264 "../src/ColorTransformation.vala"
	return result;
#line 1144 "ColorTransformation.c"
}

void
pixel_transformation_bundle_set (PixelTransformationBundle* self,
                                 PixelTransformation* transformation)
{
	GeeHashMap* _tmp0_;
#line 267 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/ColorTransformation.vala"
	g_return_if_fail (transformation != NULL);
#line 268 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->map;
#line 268 "../src/ColorTransformation.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) pixel_transformation_get_transformation_type (transformation)), transformation);
#line 1160 "ColorTransformation.c"
}

void
pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self)
{
	ExpansionTransformation* _tmp0_;
	ExpansionTransformation* _tmp1_;
	ShadowDetailTransformation* _tmp2_;
	ShadowDetailTransformation* _tmp3_;
	HighlightDetailTransformation* _tmp4_;
	HighlightDetailTransformation* _tmp5_;
	TemperatureTransformation* _tmp6_;
	TemperatureTransformation* _tmp7_;
	TintTransformation* _tmp8_;
	TintTransformation* _tmp9_;
	SaturationTransformation* _tmp10_;
	SaturationTransformation* _tmp11_;
	ExposureTransformation* _tmp12_;
	ExposureTransformation* _tmp13_;
#line 271 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/ColorTransformation.vala"
	_tmp0_ = expansion_transformation_new_from_extrema (0, 255);
#line 272 "../src/ColorTransformation.vala"
	_tmp1_ = _tmp0_;
#line 272 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp1_);
#line 272 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp1_);
#line 273 "../src/ColorTransformation.vala"
	_tmp2_ = shadow_detail_transformation_new (0.0f);
#line 273 "../src/ColorTransformation.vala"
	_tmp3_ = _tmp2_;
#line 273 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp3_);
#line 273 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp3_);
#line 274 "../src/ColorTransformation.vala"
	_tmp4_ = highlight_detail_transformation_new (0.0f);
#line 274 "../src/ColorTransformation.vala"
	_tmp5_ = _tmp4_;
#line 274 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp5_);
#line 274 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp5_);
#line 275 "../src/ColorTransformation.vala"
	_tmp6_ = temperature_transformation_new (0.0f);
#line 275 "../src/ColorTransformation.vala"
	_tmp7_ = _tmp6_;
#line 275 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp7_);
#line 275 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp7_);
#line 276 "../src/ColorTransformation.vala"
	_tmp8_ = tint_transformation_new (0.0f);
#line 276 "../src/ColorTransformation.vala"
	_tmp9_ = _tmp8_;
#line 276 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp9_);
#line 276 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp9_);
#line 277 "../src/ColorTransformation.vala"
	_tmp10_ = saturation_transformation_new (0.0f);
#line 277 "../src/ColorTransformation.vala"
	_tmp11_ = _tmp10_;
#line 277 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp11_);
#line 277 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp11_);
#line 278 "../src/ColorTransformation.vala"
	_tmp12_ = exposure_transformation_new (0.0f);
#line 278 "../src/ColorTransformation.vala"
	_tmp13_ = _tmp12_;
#line 278 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp13_);
#line 278 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp13_);
#line 1238 "ColorTransformation.c"
}

void
pixel_transformation_bundle_load (PixelTransformationBundle* self,
                                  KeyValueMap* store)
{
	gchar* expansion_params_encoded = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	ShadowDetailTransformation* _tmp7_;
	ShadowDetailTransformation* _tmp8_;
	HighlightDetailTransformation* _tmp9_;
	HighlightDetailTransformation* _tmp10_;
	TemperatureTransformation* _tmp11_;
	TemperatureTransformation* _tmp12_;
	TintTransformation* _tmp13_;
	TintTransformation* _tmp14_;
	SaturationTransformation* _tmp15_;
	SaturationTransformation* _tmp16_;
	ExposureTransformation* _tmp17_;
	ExposureTransformation* _tmp18_;
#line 281 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/ColorTransformation.vala"
	g_return_if_fail (store != NULL);
#line 282 "../src/ColorTransformation.vala"
	_tmp0_ = key_value_map_get_string (store, "expansion", "-");
#line 282 "../src/ColorTransformation.vala"
	expansion_params_encoded = _tmp0_;
#line 283 "../src/ColorTransformation.vala"
	_tmp1_ = expansion_params_encoded;
#line 283 "../src/ColorTransformation.vala"
	if (g_strcmp0 (_tmp1_, "-") == 0) {
#line 1272 "ColorTransformation.c"
		ExpansionTransformation* _tmp2_;
		ExpansionTransformation* _tmp3_;
#line 284 "../src/ColorTransformation.vala"
		_tmp2_ = expansion_transformation_new_from_extrema (0, 255);
#line 284 "../src/ColorTransformation.vala"
		_tmp3_ = _tmp2_;
#line 284 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp3_);
#line 284 "../src/ColorTransformation.vala"
		_pixel_transformation_unref0 (_tmp3_);
#line 1283 "ColorTransformation.c"
	} else {
		const gchar* _tmp4_;
		ExpansionTransformation* _tmp5_;
		ExpansionTransformation* _tmp6_;
#line 286 "../src/ColorTransformation.vala"
		_tmp4_ = expansion_params_encoded;
#line 286 "../src/ColorTransformation.vala"
		_tmp5_ = expansion_transformation_new_from_string (_tmp4_);
#line 286 "../src/ColorTransformation.vala"
		_tmp6_ = _tmp5_;
#line 286 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp6_);
#line 286 "../src/ColorTransformation.vala"
		_pixel_transformation_unref0 (_tmp6_);
#line 1298 "ColorTransformation.c"
	}
#line 288 "../src/ColorTransformation.vala"
	_tmp7_ = shadow_detail_transformation_new (key_value_map_get_float (store, "shadows", 0.0f));
#line 288 "../src/ColorTransformation.vala"
	_tmp8_ = _tmp7_;
#line 288 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp8_);
#line 288 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp8_);
#line 289 "../src/ColorTransformation.vala"
	_tmp9_ = highlight_detail_transformation_new (key_value_map_get_float (store, "highlights", 0.0f));
#line 289 "../src/ColorTransformation.vala"
	_tmp10_ = _tmp9_;
#line 289 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp10_);
#line 289 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp10_);
#line 290 "../src/ColorTransformation.vala"
	_tmp11_ = temperature_transformation_new (key_value_map_get_float (store, "temperature", 0.0f));
#line 290 "../src/ColorTransformation.vala"
	_tmp12_ = _tmp11_;
#line 290 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp12_);
#line 290 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp12_);
#line 291 "../src/ColorTransformation.vala"
	_tmp13_ = tint_transformation_new (key_value_map_get_float (store, "tint", 0.0f));
#line 291 "../src/ColorTransformation.vala"
	_tmp14_ = _tmp13_;
#line 291 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp14_);
#line 291 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp14_);
#line 292 "../src/ColorTransformation.vala"
	_tmp15_ = saturation_transformation_new (key_value_map_get_float (store, "saturation", 0.0f));
#line 292 "../src/ColorTransformation.vala"
	_tmp16_ = _tmp15_;
#line 292 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp16_);
#line 292 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp16_);
#line 293 "../src/ColorTransformation.vala"
	_tmp17_ = exposure_transformation_new (key_value_map_get_float (store, "exposure", 0.0f));
#line 293 "../src/ColorTransformation.vala"
	_tmp18_ = _tmp17_;
#line 293 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (self, (PixelTransformation*) _tmp18_);
#line 293 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp18_);
#line 281 "../src/ColorTransformation.vala"
	_g_free0 (expansion_params_encoded);
#line 1350 "ColorTransformation.c"
}

KeyValueMap*
pixel_transformation_bundle_save (PixelTransformationBundle* self,
                                  const gchar* group)
{
	KeyValueMap* store = NULL;
	KeyValueMap* _tmp0_;
	ExpansionTransformation* new_expansion_trans = NULL;
	PixelTransformation* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ShadowDetailTransformation* new_shadows_trans = NULL;
	PixelTransformation* _tmp4_;
	HighlightDetailTransformation* new_highlight_trans = NULL;
	PixelTransformation* _tmp5_;
	TemperatureTransformation* new_temp_trans = NULL;
	PixelTransformation* _tmp6_;
	TintTransformation* new_tint_trans = NULL;
	PixelTransformation* _tmp7_;
	SaturationTransformation* new_sat_trans = NULL;
	PixelTransformation* _tmp8_;
	ExposureTransformation* new_exposure_trans = NULL;
	PixelTransformation* _tmp9_;
	KeyValueMap* result;
#line 296 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 296 "../src/ColorTransformation.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 297 "../src/ColorTransformation.vala"
	_tmp0_ = key_value_map_new (group);
#line 297 "../src/ColorTransformation.vala"
	store = _tmp0_;
#line 299 "../src/ColorTransformation.vala"
	_tmp1_ = pixel_transformation_bundle_get_transformation (self, PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION);
#line 299 "../src/ColorTransformation.vala"
	new_expansion_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_EXPANSION_TRANSFORMATION, ExpansionTransformation);
#line 301 "../src/ColorTransformation.vala"
	_vala_assert (new_expansion_trans != NULL, "new_expansion_trans != null");
#line 302 "../src/ColorTransformation.vala"
	_tmp2_ = pixel_transformation_to_string ((PixelTransformation*) new_expansion_trans);
#line 302 "../src/ColorTransformation.vala"
	_tmp3_ = _tmp2_;
#line 302 "../src/ColorTransformation.vala"
	key_value_map_set_string (store, "expansion", _tmp3_);
#line 302 "../src/ColorTransformation.vala"
	_g_free0 (_tmp3_);
#line 304 "../src/ColorTransformation.vala"
	_tmp4_ = pixel_transformation_bundle_get_transformation (self, PIXEL_TRANSFORMATION_TYPE_SHADOWS);
#line 304 "../src/ColorTransformation.vala"
	new_shadows_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SHADOW_DETAIL_TRANSFORMATION, ShadowDetailTransformation);
#line 306 "../src/ColorTransformation.vala"
	_vala_assert (new_shadows_trans != NULL, "new_shadows_trans != null");
#line 307 "../src/ColorTransformation.vala"
	key_value_map_set_float (store, "shadows", shadow_detail_transformation_get_parameter (new_shadows_trans));
#line 309 "../src/ColorTransformation.vala"
	_tmp5_ = pixel_transformation_bundle_get_transformation (self, PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS);
#line 309 "../src/ColorTransformation.vala"
	new_highlight_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_HIGHLIGHT_DETAIL_TRANSFORMATION, HighlightDetailTransformation);
#line 311 "../src/ColorTransformation.vala"
	_vala_assert (new_highlight_trans != NULL, "new_highlight_trans != null");
#line 312 "../src/ColorTransformation.vala"
	key_value_map_set_float (store, "highlights", highlight_detail_transformation_get_parameter (new_highlight_trans));
#line 314 "../src/ColorTransformation.vala"
	_tmp6_ = pixel_transformation_bundle_get_transformation (self, PIXEL_TRANSFORMATION_TYPE_TEMPERATURE);
#line 314 "../src/ColorTransformation.vala"
	new_temp_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_TEMPERATURE_TRANSFORMATION, TemperatureTransformation);
#line 316 "../src/ColorTransformation.vala"
	_vala_assert (new_temp_trans != NULL, "new_temp_trans != null");
#line 317 "../src/ColorTransformation.vala"
	key_value_map_set_float (store, "temperature", temperature_transformation_get_parameter (new_temp_trans));
#line 319 "../src/ColorTransformation.vala"
	_tmp7_ = pixel_transformation_bundle_get_transformation (self, PIXEL_TRANSFORMATION_TYPE_TINT);
#line 319 "../src/ColorTransformation.vala"
	new_tint_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_TINT_TRANSFORMATION, TintTransformation);
#line 321 "../src/ColorTransformation.vala"
	_vala_assert (new_tint_trans != NULL, "new_tint_trans != null");
#line 322 "../src/ColorTransformation.vala"
	key_value_map_set_float (store, "tint", tint_transformation_get_parameter (new_tint_trans));
#line 324 "../src/ColorTransformation.vala"
	_tmp8_ = pixel_transformation_bundle_get_transformation (self, PIXEL_TRANSFORMATION_TYPE_SATURATION);
#line 324 "../src/ColorTransformation.vala"
	new_sat_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_SATURATION_TRANSFORMATION, SaturationTransformation);
#line 326 "../src/ColorTransformation.vala"
	_vala_assert (new_sat_trans != NULL, "new_sat_trans != null");
#line 327 "../src/ColorTransformation.vala"
	key_value_map_set_float (store, "saturation", saturation_transformation_get_parameter (new_sat_trans));
#line 329 "../src/ColorTransformation.vala"
	_tmp9_ = pixel_transformation_bundle_get_transformation (self, PIXEL_TRANSFORMATION_TYPE_EXPOSURE);
#line 329 "../src/ColorTransformation.vala"
	new_exposure_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_EXPOSURE_TRANSFORMATION, ExposureTransformation);
#line 331 "../src/ColorTransformation.vala"
	_vala_assert (new_exposure_trans != NULL, "new_exposure_trans != null");
#line 332 "../src/ColorTransformation.vala"
	key_value_map_set_float (store, "exposure", exposure_transformation_get_parameter (new_exposure_trans));
#line 334 "../src/ColorTransformation.vala"
	result = store;
#line 334 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (new_exposure_trans);
#line 334 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (new_sat_trans);
#line 334 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (new_tint_trans);
#line 334 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (new_temp_trans);
#line 334 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (new_highlight_trans);
#line 334 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (new_shadows_trans);
#line 334 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (new_expansion_trans);
#line 334 "../src/ColorTransformation.vala"
	return result;
#line 1464 "ColorTransformation.c"
}

gint
pixel_transformation_bundle_get_count (PixelTransformationBundle* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 337 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 338 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->map;
#line 338 "../src/ColorTransformation.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 338 "../src/ColorTransformation.vala"
	_tmp2_ = _tmp1_;
#line 338 "../src/ColorTransformation.vala"
	result = _tmp2_;
#line 338 "../src/ColorTransformation.vala"
	return result;
#line 1486 "ColorTransformation.c"
}

PixelTransformation*
pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self,
                                                PixelTransformationType type)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	PixelTransformation* result;
#line 341 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 342 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->map;
#line 342 "../src/ColorTransformation.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) type));
#line 342 "../src/ColorTransformation.vala"
	result = (PixelTransformation*) _tmp1_;
#line 342 "../src/ColorTransformation.vala"
	return result;
#line 1506 "ColorTransformation.c"
}

GeeIterable*
pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeIterable* result;
#line 345 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 346 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->map;
#line 346 "../src/ColorTransformation.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 346 "../src/ColorTransformation.vala"
	_tmp2_ = _tmp1_;
#line 346 "../src/ColorTransformation.vala"
	result = (GeeIterable*) _tmp2_;
#line 346 "../src/ColorTransformation.vala"
	return result;
#line 1528 "ColorTransformation.c"
}

gboolean
pixel_transformation_bundle_is_identity (PixelTransformationBundle* self)
{
	gboolean result;
#line 349 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1537 "ColorTransformation.c"
	{
		GeeIterator* _adjustment_it = NULL;
		GeeIterable* _tmp0_;
		GeeIterable* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 350 "../src/ColorTransformation.vala"
		_tmp0_ = pixel_transformation_bundle_get_transformations (self);
#line 350 "../src/ColorTransformation.vala"
		_tmp1_ = _tmp0_;
#line 350 "../src/ColorTransformation.vala"
		_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 350 "../src/ColorTransformation.vala"
		_tmp3_ = _tmp2_;
#line 350 "../src/ColorTransformation.vala"
		_g_object_unref0 (_tmp1_);
#line 350 "../src/ColorTransformation.vala"
		_adjustment_it = _tmp3_;
#line 350 "../src/ColorTransformation.vala"
		while (TRUE) {
#line 1558 "ColorTransformation.c"
			GeeIterator* _tmp4_;
			PixelTransformation* adjustment = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PixelTransformation* _tmp7_;
#line 350 "../src/ColorTransformation.vala"
			_tmp4_ = _adjustment_it;
#line 350 "../src/ColorTransformation.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 350 "../src/ColorTransformation.vala"
				break;
#line 1570 "ColorTransformation.c"
			}
#line 350 "../src/ColorTransformation.vala"
			_tmp5_ = _adjustment_it;
#line 350 "../src/ColorTransformation.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 350 "../src/ColorTransformation.vala"
			adjustment = (PixelTransformation*) _tmp6_;
#line 351 "../src/ColorTransformation.vala"
			_tmp7_ = adjustment;
#line 351 "../src/ColorTransformation.vala"
			if (!pixel_transformation_is_identity (_tmp7_)) {
#line 352 "../src/ColorTransformation.vala"
				result = FALSE;
#line 352 "../src/ColorTransformation.vala"
				_pixel_transformation_unref0 (adjustment);
#line 352 "../src/ColorTransformation.vala"
				_g_object_unref0 (_adjustment_it);
#line 352 "../src/ColorTransformation.vala"
				return result;
#line 1590 "ColorTransformation.c"
			}
#line 350 "../src/ColorTransformation.vala"
			_pixel_transformation_unref0 (adjustment);
#line 1594 "ColorTransformation.c"
		}
#line 350 "../src/ColorTransformation.vala"
		_g_object_unref0 (_adjustment_it);
#line 1598 "ColorTransformation.c"
	}
#line 355 "../src/ColorTransformation.vala"
	result = TRUE;
#line 355 "../src/ColorTransformation.vala"
	return result;
#line 1604 "ColorTransformation.c"
}

PixelTransformer*
pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self)
{
	PixelTransformer* transformer = NULL;
	PixelTransformer* _tmp0_;
	PixelTransformer* result;
#line 358 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 359 "../src/ColorTransformation.vala"
	_tmp0_ = pixel_transformer_new ();
#line 359 "../src/ColorTransformation.vala"
	transformer = _tmp0_;
#line 1619 "ColorTransformation.c"
	{
		GeeIterator* _transformation_it = NULL;
		GeeIterable* _tmp1_;
		GeeIterable* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 360 "../src/ColorTransformation.vala"
		_tmp1_ = pixel_transformation_bundle_get_transformations (self);
#line 360 "../src/ColorTransformation.vala"
		_tmp2_ = _tmp1_;
#line 360 "../src/ColorTransformation.vala"
		_tmp3_ = gee_iterable_iterator (_tmp2_);
#line 360 "../src/ColorTransformation.vala"
		_tmp4_ = _tmp3_;
#line 360 "../src/ColorTransformation.vala"
		_g_object_unref0 (_tmp2_);
#line 360 "../src/ColorTransformation.vala"
		_transformation_it = _tmp4_;
#line 360 "../src/ColorTransformation.vala"
		while (TRUE) {
#line 1640 "ColorTransformation.c"
			GeeIterator* _tmp5_;
			PixelTransformation* transformation = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			PixelTransformer* _tmp8_;
			PixelTransformation* _tmp9_;
#line 360 "../src/ColorTransformation.vala"
			_tmp5_ = _transformation_it;
#line 360 "../src/ColorTransformation.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 360 "../src/ColorTransformation.vala"
				break;
#line 1653 "ColorTransformation.c"
			}
#line 360 "../src/ColorTransformation.vala"
			_tmp6_ = _transformation_it;
#line 360 "../src/ColorTransformation.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 360 "../src/ColorTransformation.vala"
			transformation = (PixelTransformation*) _tmp7_;
#line 361 "../src/ColorTransformation.vala"
			_tmp8_ = transformer;
#line 361 "../src/ColorTransformation.vala"
			_tmp9_ = transformation;
#line 361 "../src/ColorTransformation.vala"
			pixel_transformer_attach_transformation (_tmp8_, _tmp9_);
#line 360 "../src/ColorTransformation.vala"
			_pixel_transformation_unref0 (transformation);
#line 1669 "ColorTransformation.c"
		}
#line 360 "../src/ColorTransformation.vala"
		_g_object_unref0 (_transformation_it);
#line 1673 "ColorTransformation.c"
	}
#line 363 "../src/ColorTransformation.vala"
	result = transformer;
#line 363 "../src/ColorTransformation.vala"
	return result;
#line 1679 "ColorTransformation.c"
}

PixelTransformationBundle*
pixel_transformation_bundle_copy (PixelTransformationBundle* self)
{
	PixelTransformationBundle* bundle = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* result;
#line 366 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 367 "../src/ColorTransformation.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 367 "../src/ColorTransformation.vala"
	bundle = _tmp0_;
#line 1694 "ColorTransformation.c"
	{
		GeeIterator* _transformation_it = NULL;
		GeeIterable* _tmp1_;
		GeeIterable* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 368 "../src/ColorTransformation.vala"
		_tmp1_ = pixel_transformation_bundle_get_transformations (self);
#line 368 "../src/ColorTransformation.vala"
		_tmp2_ = _tmp1_;
#line 368 "../src/ColorTransformation.vala"
		_tmp3_ = gee_iterable_iterator (_tmp2_);
#line 368 "../src/ColorTransformation.vala"
		_tmp4_ = _tmp3_;
#line 368 "../src/ColorTransformation.vala"
		_g_object_unref0 (_tmp2_);
#line 368 "../src/ColorTransformation.vala"
		_transformation_it = _tmp4_;
#line 368 "../src/ColorTransformation.vala"
		while (TRUE) {
#line 1715 "ColorTransformation.c"
			GeeIterator* _tmp5_;
			PixelTransformation* transformation = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			PixelTransformationBundle* _tmp8_;
			PixelTransformation* _tmp9_;
#line 368 "../src/ColorTransformation.vala"
			_tmp5_ = _transformation_it;
#line 368 "../src/ColorTransformation.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 368 "../src/ColorTransformation.vala"
				break;
#line 1728 "ColorTransformation.c"
			}
#line 368 "../src/ColorTransformation.vala"
			_tmp6_ = _transformation_it;
#line 368 "../src/ColorTransformation.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 368 "../src/ColorTransformation.vala"
			transformation = (PixelTransformation*) _tmp7_;
#line 369 "../src/ColorTransformation.vala"
			_tmp8_ = bundle;
#line 369 "../src/ColorTransformation.vala"
			_tmp9_ = transformation;
#line 369 "../src/ColorTransformation.vala"
			pixel_transformation_bundle_set (_tmp8_, _tmp9_);
#line 368 "../src/ColorTransformation.vala"
			_pixel_transformation_unref0 (transformation);
#line 1744 "ColorTransformation.c"
		}
#line 368 "../src/ColorTransformation.vala"
		_g_object_unref0 (_transformation_it);
#line 1748 "ColorTransformation.c"
	}
#line 371 "../src/ColorTransformation.vala"
	result = bundle;
#line 371 "../src/ColorTransformation.vala"
	return result;
#line 1754 "ColorTransformation.c"
}

static void
value_pixel_transformation_bundle_init (GValue* value)
{
#line 246 "../src/ColorTransformation.vala"
	value->data[0].v_pointer = NULL;
#line 1762 "ColorTransformation.c"
}

static void
value_pixel_transformation_bundle_free_value (GValue* value)
{
#line 246 "../src/ColorTransformation.vala"
	if (value->data[0].v_pointer) {
#line 246 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_unref (value->data[0].v_pointer);
#line 1772 "ColorTransformation.c"
	}
}

static void
value_pixel_transformation_bundle_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 246 "../src/ColorTransformation.vala"
	if (src_value->data[0].v_pointer) {
#line 246 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = pixel_transformation_bundle_ref (src_value->data[0].v_pointer);
#line 1784 "ColorTransformation.c"
	} else {
#line 246 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1788 "ColorTransformation.c"
	}
}

static gpointer
value_pixel_transformation_bundle_peek_pointer (const GValue* value)
{
#line 246 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 1797 "ColorTransformation.c"
}

static gchar*
value_pixel_transformation_bundle_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 246 "../src/ColorTransformation.vala"
	if (collect_values[0].v_pointer) {
#line 1808 "ColorTransformation.c"
		PixelTransformationBundle * object;
		object = collect_values[0].v_pointer;
#line 246 "../src/ColorTransformation.vala"
		if (object->parent_instance.g_class == NULL) {
#line 246 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1815 "ColorTransformation.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 246 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1819 "ColorTransformation.c"
		}
#line 246 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = pixel_transformation_bundle_ref (object);
#line 1823 "ColorTransformation.c"
	} else {
#line 246 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 1827 "ColorTransformation.c"
	}
#line 246 "../src/ColorTransformation.vala"
	return NULL;
#line 1831 "ColorTransformation.c"
}

static gchar*
value_pixel_transformation_bundle_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	PixelTransformationBundle ** object_p;
	object_p = collect_values[0].v_pointer;
#line 246 "../src/ColorTransformation.vala"
	if (!object_p) {
#line 246 "../src/ColorTransformation.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1846 "ColorTransformation.c"
	}
#line 246 "../src/ColorTransformation.vala"
	if (!value->data[0].v_pointer) {
#line 246 "../src/ColorTransformation.vala"
		*object_p = NULL;
#line 1852 "ColorTransformation.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 246 "../src/ColorTransformation.vala"
		*object_p = value->data[0].v_pointer;
#line 1856 "ColorTransformation.c"
	} else {
#line 246 "../src/ColorTransformation.vala"
		*object_p = pixel_transformation_bundle_ref (value->data[0].v_pointer);
#line 1860 "ColorTransformation.c"
	}
#line 246 "../src/ColorTransformation.vala"
	return NULL;
#line 1864 "ColorTransformation.c"
}

GParamSpec*
param_spec_pixel_transformation_bundle (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	ParamSpecPixelTransformationBundle* spec;
#line 246 "../src/ColorTransformation.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PIXEL_TRANSFORMATION_BUNDLE), NULL);
#line 246 "../src/ColorTransformation.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 246 "../src/ColorTransformation.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 246 "../src/ColorTransformation.vala"
	return G_PARAM_SPEC (spec);
#line 1883 "ColorTransformation.c"
}

gpointer
value_get_pixel_transformation_bundle (const GValue* value)
{
#line 246 "../src/ColorTransformation.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMATION_BUNDLE), NULL);
#line 246 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 1893 "ColorTransformation.c"
}

void
value_set_pixel_transformation_bundle (GValue* value,
                                       gpointer v_object)
{
	PixelTransformationBundle * old;
#line 246 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 246 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 246 "../src/ColorTransformation.vala"
	if (v_object) {
#line 246 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 246 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 246 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 246 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_ref (value->data[0].v_pointer);
#line 1915 "ColorTransformation.c"
	} else {
#line 246 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 1919 "ColorTransformation.c"
	}
#line 246 "../src/ColorTransformation.vala"
	if (old) {
#line 246 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_unref (old);
#line 1925 "ColorTransformation.c"
	}
}

void
value_take_pixel_transformation_bundle (GValue* value,
                                        gpointer v_object)
{
	PixelTransformationBundle * old;
#line 246 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 246 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 246 "../src/ColorTransformation.vala"
	if (v_object) {
#line 246 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 246 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 246 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 1946 "ColorTransformation.c"
	} else {
#line 246 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 1950 "ColorTransformation.c"
	}
#line 246 "../src/ColorTransformation.vala"
	if (old) {
#line 246 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_unref (old);
#line 1956 "ColorTransformation.c"
	}
}

static void
pixel_transformation_bundle_class_init (PixelTransformationBundleClass * klass,
                                        gpointer klass_data)
{
#line 246 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_parent_class = g_type_class_peek_parent (klass);
#line 246 "../src/ColorTransformation.vala"
	((PixelTransformationBundleClass *) klass)->finalize = pixel_transformation_bundle_finalize;
#line 246 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &PixelTransformationBundle_private_offset);
#line 1970 "ColorTransformation.c"
}

static void
pixel_transformation_bundle_instance_init (PixelTransformationBundle * self,
                                           gpointer klass)
{
	gpointer _tmp0_ = NULL;
	GDestroyNotify _tmp1_ = NULL;
	GeeHashDataFunc _tmp2_;
	gpointer _tmp3_ = NULL;
	GDestroyNotify _tmp4_ = NULL;
	GeeEqualDataFunc _tmp5_;
	GeeHashMap* _tmp6_;
#line 246 "../src/ColorTransformation.vala"
	self->priv = pixel_transformation_bundle_get_instance_private (self);
#line 249 "../src/ColorTransformation.vala"
	_tmp2_ = gee_functions_get_hash_func_for (G_TYPE_INT, &_tmp0_, &_tmp1_);
#line 249 "../src/ColorTransformation.vala"
	_tmp5_ = gee_functions_get_equal_func_for (G_TYPE_INT, &_tmp3_, &_tmp4_);
#line 249 "../src/ColorTransformation.vala"
	_tmp6_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, TYPE_PIXEL_TRANSFORMATION, (GBoxedCopyFunc) pixel_transformation_ref, (GDestroyNotify) pixel_transformation_unref, _tmp2_, _tmp0_, _tmp1_, _tmp5_, _tmp3_, _tmp4_, NULL, NULL, NULL);
#line 249 "../src/ColorTransformation.vala"
	self->priv->map = _tmp6_;
#line 246 "../src/ColorTransformation.vala"
	self->ref_count = 1;
#line 1996 "ColorTransformation.c"
}

static void
pixel_transformation_bundle_finalize (PixelTransformationBundle * obj)
{
	PixelTransformationBundle * self;
#line 246 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle);
#line 246 "../src/ColorTransformation.vala"
	g_signal_handlers_destroy (self);
#line 249 "../src/ColorTransformation.vala"
	_g_object_unref0 (self->priv->map);
#line 2009 "ColorTransformation.c"
}

static GType
pixel_transformation_bundle_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_pixel_transformation_bundle_init, value_pixel_transformation_bundle_free_value, value_pixel_transformation_bundle_copy_value, value_pixel_transformation_bundle_peek_pointer, "p", value_pixel_transformation_bundle_collect_value, "p", value_pixel_transformation_bundle_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PixelTransformationBundleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pixel_transformation_bundle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PixelTransformationBundle), 0, (GInstanceInitFunc) pixel_transformation_bundle_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pixel_transformation_bundle_type_id;
	pixel_transformation_bundle_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PixelTransformationBundle", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PixelTransformationBundle_private_offset = g_type_add_instance_private (pixel_transformation_bundle_type_id, sizeof (PixelTransformationBundlePrivate));
	return pixel_transformation_bundle_type_id;
}

GType
pixel_transformation_bundle_get_type (void)
{
	static volatile gsize pixel_transformation_bundle_type_id__once = 0;
	if (g_once_init_enter (&pixel_transformation_bundle_type_id__once)) {
		GType pixel_transformation_bundle_type_id;
		pixel_transformation_bundle_type_id = pixel_transformation_bundle_get_type_once ();
		g_once_init_leave (&pixel_transformation_bundle_type_id__once, pixel_transformation_bundle_type_id);
	}
	return pixel_transformation_bundle_type_id__once;
}

gpointer
pixel_transformation_bundle_ref (gpointer instance)
{
	PixelTransformationBundle * self;
	self = instance;
#line 246 "../src/ColorTransformation.vala"
	g_atomic_int_inc (&self->ref_count);
#line 246 "../src/ColorTransformation.vala"
	return instance;
#line 2045 "ColorTransformation.c"
}

void
pixel_transformation_bundle_unref (gpointer instance)
{
	PixelTransformationBundle * self;
	self = instance;
#line 246 "../src/ColorTransformation.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 246 "../src/ColorTransformation.vala"
		PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS (self)->finalize (self);
#line 246 "../src/ColorTransformation.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2059 "ColorTransformation.c"
	}
}

static inline gpointer
pixel_transformation_get_instance_private (PixelTransformation* self)
{
	return G_STRUCT_MEMBER_P (self, PixelTransformation_private_offset);
}

PixelTransformation*
pixel_transformation_construct (GType object_type,
                                PixelTransformationType type)
{
	PixelTransformation* self = NULL;
#line 378 "../src/ColorTransformation.vala"
	self = (PixelTransformation*) g_type_create_instance (object_type);
#line 379 "../src/ColorTransformation.vala"
	self->priv->type = type;
#line 378 "../src/ColorTransformation.vala"
	return self;
#line 2080 "ColorTransformation.c"
}

PixelTransformationType
pixel_transformation_get_transformation_type (PixelTransformation* self)
{
	PixelTransformationType result;
#line 382 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 383 "../src/ColorTransformation.vala"
	result = self->priv->type;
#line 383 "../src/ColorTransformation.vala"
	return result;
#line 2093 "ColorTransformation.c"
}

static PixelFormat
pixel_transformation_real_get_preferred_format (PixelTransformation* self)
{
#line 386 "../src/ColorTransformation.vala"
	g_critical ("Type `%s' does not implement abstract method `pixel_transformation_get_preferred_format'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 386 "../src/ColorTransformation.vala"
	return 0;
#line 2103 "ColorTransformation.c"
}

PixelFormat
pixel_transformation_get_preferred_format (PixelTransformation* self)
{
	PixelTransformationClass* _klass_;
#line 386 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 386 "../src/ColorTransformation.vala"
	_klass_ = PIXEL_TRANSFORMATION_GET_CLASS (self);
#line 386 "../src/ColorTransformation.vala"
	if (_klass_->get_preferred_format) {
#line 386 "../src/ColorTransformation.vala"
		return _klass_->get_preferred_format (self);
#line 2118 "ColorTransformation.c"
	}
#line 386 "../src/ColorTransformation.vala"
	return 0;
#line 2122 "ColorTransformation.c"
}

static CompositionMode
pixel_transformation_real_get_composition_mode (PixelTransformation* self)
{
	CompositionMode result;
#line 389 "../src/ColorTransformation.vala"
	result = COMPOSITION_MODE_NONE;
#line 389 "../src/ColorTransformation.vala"
	return result;
#line 2133 "ColorTransformation.c"
}

CompositionMode
pixel_transformation_get_composition_mode (PixelTransformation* self)
{
	PixelTransformationClass* _klass_;
#line 388 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 388 "../src/ColorTransformation.vala"
	_klass_ = PIXEL_TRANSFORMATION_GET_CLASS (self);
#line 388 "../src/ColorTransformation.vala"
	if (_klass_->get_composition_mode) {
#line 388 "../src/ColorTransformation.vala"
		return _klass_->get_composition_mode (self);
#line 2148 "ColorTransformation.c"
	}
#line 388 "../src/ColorTransformation.vala"
	return 0;
#line 2152 "ColorTransformation.c"
}

static void
pixel_transformation_real_compose_with (PixelTransformation* self,
                                        PixelTransformation* other)
{
#line 392 "../src/ColorTransformation.vala"
	g_return_if_fail (other != NULL);
#line 393 "../src/ColorTransformation.vala"
	g_error ("ColorTransformation.vala:393: %s", "PixelTransformation: compose_with( ): this type of pixel " "transformation doesn't support composition.");
#line 2163 "ColorTransformation.c"
}

void
pixel_transformation_compose_with (PixelTransformation* self,
                                   PixelTransformation* other)
{
	PixelTransformationClass* _klass_;
#line 392 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 392 "../src/ColorTransformation.vala"
	_klass_ = PIXEL_TRANSFORMATION_GET_CLASS (self);
#line 392 "../src/ColorTransformation.vala"
	if (_klass_->compose_with) {
#line 392 "../src/ColorTransformation.vala"
		_klass_->compose_with (self, other);
#line 2179 "ColorTransformation.c"
	}
}

static gboolean
pixel_transformation_real_is_identity (PixelTransformation* self)
{
	gboolean result;
#line 398 "../src/ColorTransformation.vala"
	result = TRUE;
#line 398 "../src/ColorTransformation.vala"
	return result;
#line 2191 "ColorTransformation.c"
}

gboolean
pixel_transformation_is_identity (PixelTransformation* self)
{
	PixelTransformationClass* _klass_;
#line 397 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 397 "../src/ColorTransformation.vala"
	_klass_ = PIXEL_TRANSFORMATION_GET_CLASS (self);
#line 397 "../src/ColorTransformation.vala"
	if (_klass_->is_identity) {
#line 397 "../src/ColorTransformation.vala"
		return _klass_->is_identity (self);
#line 2206 "ColorTransformation.c"
	}
#line 397 "../src/ColorTransformation.vala"
	return FALSE;
#line 2210 "ColorTransformation.c"
}

static void
pixel_transformation_real_transform_pixel_hsv (PixelTransformation* self,
                                               HSVAnalyticPixel* p,
                                               HSVAnalyticPixel* result)
{
	HSVAnalyticPixel _tmp0_;
#line 401 "../src/ColorTransformation.vala"
	g_return_if_fail (p != NULL);
#line 402 "../src/ColorTransformation.vala"
	_tmp0_ = *p;
#line 402 "../src/ColorTransformation.vala"
	*result = _tmp0_;
#line 402 "../src/ColorTransformation.vala"
	return;
#line 2227 "ColorTransformation.c"
}

void
pixel_transformation_transform_pixel_hsv (PixelTransformation* self,
                                          HSVAnalyticPixel* p,
                                          HSVAnalyticPixel* result)
{
	PixelTransformationClass* _klass_;
#line 401 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 401 "../src/ColorTransformation.vala"
	_klass_ = PIXEL_TRANSFORMATION_GET_CLASS (self);
#line 401 "../src/ColorTransformation.vala"
	if (_klass_->transform_pixel_hsv) {
#line 401 "../src/ColorTransformation.vala"
		_klass_->transform_pixel_hsv (self, p, result);
#line 2244 "ColorTransformation.c"
	}
}

static void
pixel_transformation_real_transform_pixel_rgb (PixelTransformation* self,
                                               RGBAnalyticPixel* p,
                                               RGBAnalyticPixel* result)
{
	RGBAnalyticPixel _tmp0_;
#line 405 "../src/ColorTransformation.vala"
	g_return_if_fail (p != NULL);
#line 406 "../src/ColorTransformation.vala"
	_tmp0_ = *p;
#line 406 "../src/ColorTransformation.vala"
	*result = _tmp0_;
#line 406 "../src/ColorTransformation.vala"
	return;
#line 2262 "ColorTransformation.c"
}

void
pixel_transformation_transform_pixel_rgb (PixelTransformation* self,
                                          RGBAnalyticPixel* p,
                                          RGBAnalyticPixel* result)
{
	PixelTransformationClass* _klass_;
#line 405 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 405 "../src/ColorTransformation.vala"
	_klass_ = PIXEL_TRANSFORMATION_GET_CLASS (self);
#line 405 "../src/ColorTransformation.vala"
	if (_klass_->transform_pixel_rgb) {
#line 405 "../src/ColorTransformation.vala"
		_klass_->transform_pixel_rgb (self, p, result);
#line 2279 "ColorTransformation.c"
	}
}

static gchar*
pixel_transformation_real_to_string (PixelTransformation* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 410 "../src/ColorTransformation.vala"
	_tmp0_ = g_strdup ("PixelTransformation");
#line 410 "../src/ColorTransformation.vala"
	result = _tmp0_;
#line 410 "../src/ColorTransformation.vala"
	return result;
#line 2294 "ColorTransformation.c"
}

gchar*
pixel_transformation_to_string (PixelTransformation* self)
{
	PixelTransformationClass* _klass_;
#line 409 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 409 "../src/ColorTransformation.vala"
	_klass_ = PIXEL_TRANSFORMATION_GET_CLASS (self);
#line 409 "../src/ColorTransformation.vala"
	if (_klass_->to_string) {
#line 409 "../src/ColorTransformation.vala"
		return _klass_->to_string (self);
#line 2309 "ColorTransformation.c"
	}
#line 409 "../src/ColorTransformation.vala"
	return NULL;
#line 2313 "ColorTransformation.c"
}

static PixelTransformation*
pixel_transformation_real_copy (PixelTransformation* self)
{
#line 413 "../src/ColorTransformation.vala"
	g_critical ("Type `%s' does not implement abstract method `pixel_transformation_copy'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 413 "../src/ColorTransformation.vala"
	return NULL;
#line 2323 "ColorTransformation.c"
}

PixelTransformation*
pixel_transformation_copy (PixelTransformation* self)
{
	PixelTransformationClass* _klass_;
#line 413 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 413 "../src/ColorTransformation.vala"
	_klass_ = PIXEL_TRANSFORMATION_GET_CLASS (self);
#line 413 "../src/ColorTransformation.vala"
	if (_klass_->copy) {
#line 413 "../src/ColorTransformation.vala"
		return _klass_->copy (self);
#line 2338 "ColorTransformation.c"
	}
#line 413 "../src/ColorTransformation.vala"
	return NULL;
#line 2342 "ColorTransformation.c"
}

static void
value_pixel_transformation_init (GValue* value)
{
#line 375 "../src/ColorTransformation.vala"
	value->data[0].v_pointer = NULL;
#line 2350 "ColorTransformation.c"
}

static void
value_pixel_transformation_free_value (GValue* value)
{
#line 375 "../src/ColorTransformation.vala"
	if (value->data[0].v_pointer) {
#line 375 "../src/ColorTransformation.vala"
		pixel_transformation_unref (value->data[0].v_pointer);
#line 2360 "ColorTransformation.c"
	}
}

static void
value_pixel_transformation_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
#line 375 "../src/ColorTransformation.vala"
	if (src_value->data[0].v_pointer) {
#line 375 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = pixel_transformation_ref (src_value->data[0].v_pointer);
#line 2372 "ColorTransformation.c"
	} else {
#line 375 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2376 "ColorTransformation.c"
	}
}

static gpointer
value_pixel_transformation_peek_pointer (const GValue* value)
{
#line 375 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 2385 "ColorTransformation.c"
}

static gchar*
value_pixel_transformation_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
#line 375 "../src/ColorTransformation.vala"
	if (collect_values[0].v_pointer) {
#line 2396 "ColorTransformation.c"
		PixelTransformation * object;
		object = collect_values[0].v_pointer;
#line 375 "../src/ColorTransformation.vala"
		if (object->parent_instance.g_class == NULL) {
#line 375 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2403 "ColorTransformation.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 375 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2407 "ColorTransformation.c"
		}
#line 375 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = pixel_transformation_ref (object);
#line 2411 "ColorTransformation.c"
	} else {
#line 375 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 2415 "ColorTransformation.c"
	}
#line 375 "../src/ColorTransformation.vala"
	return NULL;
#line 2419 "ColorTransformation.c"
}

static gchar*
value_pixel_transformation_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	PixelTransformation ** object_p;
	object_p = collect_values[0].v_pointer;
#line 375 "../src/ColorTransformation.vala"
	if (!object_p) {
#line 375 "../src/ColorTransformation.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2434 "ColorTransformation.c"
	}
#line 375 "../src/ColorTransformation.vala"
	if (!value->data[0].v_pointer) {
#line 375 "../src/ColorTransformation.vala"
		*object_p = NULL;
#line 2440 "ColorTransformation.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 375 "../src/ColorTransformation.vala"
		*object_p = value->data[0].v_pointer;
#line 2444 "ColorTransformation.c"
	} else {
#line 375 "../src/ColorTransformation.vala"
		*object_p = pixel_transformation_ref (value->data[0].v_pointer);
#line 2448 "ColorTransformation.c"
	}
#line 375 "../src/ColorTransformation.vala"
	return NULL;
#line 2452 "ColorTransformation.c"
}

GParamSpec*
param_spec_pixel_transformation (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	ParamSpecPixelTransformation* spec;
#line 375 "../src/ColorTransformation.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PIXEL_TRANSFORMATION), NULL);
#line 375 "../src/ColorTransformation.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 375 "../src/ColorTransformation.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 375 "../src/ColorTransformation.vala"
	return G_PARAM_SPEC (spec);
#line 2471 "ColorTransformation.c"
}

gpointer
value_get_pixel_transformation (const GValue* value)
{
#line 375 "../src/ColorTransformation.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMATION), NULL);
#line 375 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 2481 "ColorTransformation.c"
}

void
value_set_pixel_transformation (GValue* value,
                                gpointer v_object)
{
	PixelTransformation * old;
#line 375 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMATION));
#line 375 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 375 "../src/ColorTransformation.vala"
	if (v_object) {
#line 375 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PIXEL_TRANSFORMATION));
#line 375 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 375 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 375 "../src/ColorTransformation.vala"
		pixel_transformation_ref (value->data[0].v_pointer);
#line 2503 "ColorTransformation.c"
	} else {
#line 375 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 2507 "ColorTransformation.c"
	}
#line 375 "../src/ColorTransformation.vala"
	if (old) {
#line 375 "../src/ColorTransformation.vala"
		pixel_transformation_unref (old);
#line 2513 "ColorTransformation.c"
	}
}

void
value_take_pixel_transformation (GValue* value,
                                 gpointer v_object)
{
	PixelTransformation * old;
#line 375 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMATION));
#line 375 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 375 "../src/ColorTransformation.vala"
	if (v_object) {
#line 375 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PIXEL_TRANSFORMATION));
#line 375 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 375 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 2534 "ColorTransformation.c"
	} else {
#line 375 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 2538 "ColorTransformation.c"
	}
#line 375 "../src/ColorTransformation.vala"
	if (old) {
#line 375 "../src/ColorTransformation.vala"
		pixel_transformation_unref (old);
#line 2544 "ColorTransformation.c"
	}
}

static void
pixel_transformation_class_init (PixelTransformationClass * klass,
                                 gpointer klass_data)
{
#line 375 "../src/ColorTransformation.vala"
	pixel_transformation_parent_class = g_type_class_peek_parent (klass);
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = pixel_transformation_finalize;
#line 375 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &PixelTransformation_private_offset);
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->get_preferred_format = (PixelFormat (*) (PixelTransformation*)) pixel_transformation_real_get_preferred_format;
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->get_composition_mode = (CompositionMode (*) (PixelTransformation*)) pixel_transformation_real_get_composition_mode;
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->compose_with = (void (*) (PixelTransformation*, PixelTransformation*)) pixel_transformation_real_compose_with;
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->is_identity = (gboolean (*) (PixelTransformation*)) pixel_transformation_real_is_identity;
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->transform_pixel_hsv = (void (*) (PixelTransformation*, HSVAnalyticPixel*, HSVAnalyticPixel*)) pixel_transformation_real_transform_pixel_hsv;
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->transform_pixel_rgb = (void (*) (PixelTransformation*, RGBAnalyticPixel*, RGBAnalyticPixel*)) pixel_transformation_real_transform_pixel_rgb;
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->to_string = (gchar* (*) (PixelTransformation*)) pixel_transformation_real_to_string;
#line 375 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->copy = (PixelTransformation* (*) (PixelTransformation*)) pixel_transformation_real_copy;
#line 2574 "ColorTransformation.c"
}

static void
pixel_transformation_instance_init (PixelTransformation * self,
                                    gpointer klass)
{
#line 375 "../src/ColorTransformation.vala"
	self->priv = pixel_transformation_get_instance_private (self);
#line 375 "../src/ColorTransformation.vala"
	self->ref_count = 1;
#line 2585 "ColorTransformation.c"
}

static void
pixel_transformation_finalize (PixelTransformation * obj)
{
	PixelTransformation * self;
#line 375 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PIXEL_TRANSFORMATION, PixelTransformation);
#line 375 "../src/ColorTransformation.vala"
	g_signal_handlers_destroy (self);
#line 2596 "ColorTransformation.c"
}

static GType
pixel_transformation_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_pixel_transformation_init, value_pixel_transformation_free_value, value_pixel_transformation_copy_value, value_pixel_transformation_peek_pointer, "p", value_pixel_transformation_collect_value, "p", value_pixel_transformation_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PixelTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pixel_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PixelTransformation), 0, (GInstanceInitFunc) pixel_transformation_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pixel_transformation_type_id;
	pixel_transformation_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PixelTransformation", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	PixelTransformation_private_offset = g_type_add_instance_private (pixel_transformation_type_id, sizeof (PixelTransformationPrivate));
	return pixel_transformation_type_id;
}

GType
pixel_transformation_get_type (void)
{
	static volatile gsize pixel_transformation_type_id__once = 0;
	if (g_once_init_enter (&pixel_transformation_type_id__once)) {
		GType pixel_transformation_type_id;
		pixel_transformation_type_id = pixel_transformation_get_type_once ();
		g_once_init_leave (&pixel_transformation_type_id__once, pixel_transformation_type_id);
	}
	return pixel_transformation_type_id__once;
}

gpointer
pixel_transformation_ref (gpointer instance)
{
	PixelTransformation * self;
	self = instance;
#line 375 "../src/ColorTransformation.vala"
	g_atomic_int_inc (&self->ref_count);
#line 375 "../src/ColorTransformation.vala"
	return instance;
#line 2632 "ColorTransformation.c"
}

void
pixel_transformation_unref (gpointer instance)
{
	PixelTransformation * self;
	self = instance;
#line 375 "../src/ColorTransformation.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 375 "../src/ColorTransformation.vala"
		PIXEL_TRANSFORMATION_GET_CLASS (self)->finalize (self);
#line 375 "../src/ColorTransformation.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2646 "ColorTransformation.c"
	}
}

RGBTransformation*
rgb_transformation_construct (GType object_type,
                              PixelTransformationType type)
{
	RGBTransformation* self = NULL;
	gfloat* _tmp0_;
#line 426 "../src/ColorTransformation.vala"
	self = (RGBTransformation*) pixel_transformation_construct (object_type, type);
#line 432 "../src/ColorTransformation.vala"
	_tmp0_ = g_new0 (gfloat, 16);
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[0] = 1.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[1] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[2] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[3] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[4] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[5] = 1.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[6] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[7] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[8] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[9] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[10] = 1.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[11] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[12] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[13] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[14] = 0.0f;
#line 432 "../src/ColorTransformation.vala"
	_tmp0_[15] = 1.0f;
#line 432 "../src/ColorTransformation.vala"
	self->matrix_entries = (g_free (self->matrix_entries), NULL);
#line 432 "../src/ColorTransformation.vala"
	self->matrix_entries = _tmp0_;
#line 432 "../src/ColorTransformation.vala"
	self->matrix_entries_length1 = 16;
#line 425 "../src/ColorTransformation.vala"
	return self;
#line 2700 "ColorTransformation.c"
}

RGBTransformation*
rgb_transformation_new (PixelTransformationType type)
{
#line 425 "../src/ColorTransformation.vala"
	return rgb_transformation_construct (TYPE_RGB_TRANSFORMATION, type);
#line 2708 "ColorTransformation.c"
}

static PixelFormat
rgb_transformation_real_get_preferred_format (PixelTransformation* base)
{
	RGBTransformation * self;
	PixelFormat result;
#line 440 "../src/ColorTransformation.vala"
	self = (RGBTransformation*) base;
#line 441 "../src/ColorTransformation.vala"
	result = PIXEL_FORMAT_RGB;
#line 441 "../src/ColorTransformation.vala"
	return result;
#line 2722 "ColorTransformation.c"
}

static CompositionMode
rgb_transformation_real_get_composition_mode (PixelTransformation* base)
{
	RGBTransformation * self;
	CompositionMode result;
#line 444 "../src/ColorTransformation.vala"
	self = (RGBTransformation*) base;
#line 445 "../src/ColorTransformation.vala"
	result = COMPOSITION_MODE_RGB_MATRIX;
#line 445 "../src/ColorTransformation.vala"
	return result;
#line 2736 "ColorTransformation.c"
}

static gpointer
_pixel_transformation_ref0 (gpointer self)
{
#line 453 "../src/ColorTransformation.vala"
	return self ? pixel_transformation_ref (self) : NULL;
#line 2744 "ColorTransformation.c"
}

static void
rgb_transformation_real_compose_with (PixelTransformation* base,
                                      PixelTransformation* other)
{
	RGBTransformation * self;
	RGBTransformation* transform = NULL;
	RGBTransformation* _tmp0_;
	gfloat* result_matrix_entries = NULL;
	gfloat* _tmp1_;
	gint result_matrix_entries_length1;
	gint _result_matrix_entries_size_;
	gfloat* _tmp2_;
	gint _tmp2__length1;
	RGBTransformation* _tmp3_;
	gfloat* _tmp4_;
	gint _tmp4__length1;
	gfloat _tmp5_;
	gfloat* _tmp6_;
	gint _tmp6__length1;
	gfloat _tmp7_;
	RGBTransformation* _tmp8_;
	gfloat* _tmp9_;
	gint _tmp9__length1;
	gfloat _tmp10_;
	gfloat* _tmp11_;
	gint _tmp11__length1;
	gfloat _tmp12_;
	RGBTransformation* _tmp13_;
	gfloat* _tmp14_;
	gint _tmp14__length1;
	gfloat _tmp15_;
	gfloat* _tmp16_;
	gint _tmp16__length1;
	gfloat _tmp17_;
	RGBTransformation* _tmp18_;
	gfloat* _tmp19_;
	gint _tmp19__length1;
	gfloat _tmp20_;
	gfloat* _tmp21_;
	gint _tmp21__length1;
	gfloat _tmp22_;
	gfloat* _tmp23_;
	gint _tmp23__length1;
	RGBTransformation* _tmp24_;
	gfloat* _tmp25_;
	gint _tmp25__length1;
	gfloat _tmp26_;
	gfloat* _tmp27_;
	gint _tmp27__length1;
	gfloat _tmp28_;
	RGBTransformation* _tmp29_;
	gfloat* _tmp30_;
	gint _tmp30__length1;
	gfloat _tmp31_;
	gfloat* _tmp32_;
	gint _tmp32__length1;
	gfloat _tmp33_;
	RGBTransformation* _tmp34_;
	gfloat* _tmp35_;
	gint _tmp35__length1;
	gfloat _tmp36_;
	gfloat* _tmp37_;
	gint _tmp37__length1;
	gfloat _tmp38_;
	RGBTransformation* _tmp39_;
	gfloat* _tmp40_;
	gint _tmp40__length1;
	gfloat _tmp41_;
	gfloat* _tmp42_;
	gint _tmp42__length1;
	gfloat _tmp43_;
	gfloat* _tmp44_;
	gint _tmp44__length1;
	RGBTransformation* _tmp45_;
	gfloat* _tmp46_;
	gint _tmp46__length1;
	gfloat _tmp47_;
	gfloat* _tmp48_;
	gint _tmp48__length1;
	gfloat _tmp49_;
	RGBTransformation* _tmp50_;
	gfloat* _tmp51_;
	gint _tmp51__length1;
	gfloat _tmp52_;
	gfloat* _tmp53_;
	gint _tmp53__length1;
	gfloat _tmp54_;
	RGBTransformation* _tmp55_;
	gfloat* _tmp56_;
	gint _tmp56__length1;
	gfloat _tmp57_;
	gfloat* _tmp58_;
	gint _tmp58__length1;
	gfloat _tmp59_;
	RGBTransformation* _tmp60_;
	gfloat* _tmp61_;
	gint _tmp61__length1;
	gfloat _tmp62_;
	gfloat* _tmp63_;
	gint _tmp63__length1;
	gfloat _tmp64_;
	gfloat* _tmp65_;
	gint _tmp65__length1;
	RGBTransformation* _tmp66_;
	gfloat* _tmp67_;
	gint _tmp67__length1;
	gfloat _tmp68_;
	gfloat* _tmp69_;
	gint _tmp69__length1;
	gfloat _tmp70_;
	RGBTransformation* _tmp71_;
	gfloat* _tmp72_;
	gint _tmp72__length1;
	gfloat _tmp73_;
	gfloat* _tmp74_;
	gint _tmp74__length1;
	gfloat _tmp75_;
	RGBTransformation* _tmp76_;
	gfloat* _tmp77_;
	gint _tmp77__length1;
	gfloat _tmp78_;
	gfloat* _tmp79_;
	gint _tmp79__length1;
	gfloat _tmp80_;
	RGBTransformation* _tmp81_;
	gfloat* _tmp82_;
	gint _tmp82__length1;
	gfloat _tmp83_;
	gfloat* _tmp84_;
	gint _tmp84__length1;
	gfloat _tmp85_;
	gfloat* _tmp86_;
	gint _tmp86__length1;
	RGBTransformation* _tmp87_;
	gfloat* _tmp88_;
	gint _tmp88__length1;
	gfloat _tmp89_;
	gfloat* _tmp90_;
	gint _tmp90__length1;
	gfloat _tmp91_;
	RGBTransformation* _tmp92_;
	gfloat* _tmp93_;
	gint _tmp93__length1;
	gfloat _tmp94_;
	gfloat* _tmp95_;
	gint _tmp95__length1;
	gfloat _tmp96_;
	RGBTransformation* _tmp97_;
	gfloat* _tmp98_;
	gint _tmp98__length1;
	gfloat _tmp99_;
	gfloat* _tmp100_;
	gint _tmp100__length1;
	gfloat _tmp101_;
	RGBTransformation* _tmp102_;
	gfloat* _tmp103_;
	gint _tmp103__length1;
	gfloat _tmp104_;
	gfloat* _tmp105_;
	gint _tmp105__length1;
	gfloat _tmp106_;
	gfloat* _tmp107_;
	gint _tmp107__length1;
	RGBTransformation* _tmp108_;
	gfloat* _tmp109_;
	gint _tmp109__length1;
	gfloat _tmp110_;
	gfloat* _tmp111_;
	gint _tmp111__length1;
	gfloat _tmp112_;
	RGBTransformation* _tmp113_;
	gfloat* _tmp114_;
	gint _tmp114__length1;
	gfloat _tmp115_;
	gfloat* _tmp116_;
	gint _tmp116__length1;
	gfloat _tmp117_;
	RGBTransformation* _tmp118_;
	gfloat* _tmp119_;
	gint _tmp119__length1;
	gfloat _tmp120_;
	gfloat* _tmp121_;
	gint _tmp121__length1;
	gfloat _tmp122_;
	RGBTransformation* _tmp123_;
	gfloat* _tmp124_;
	gint _tmp124__length1;
	gfloat _tmp125_;
	gfloat* _tmp126_;
	gint _tmp126__length1;
	gfloat _tmp127_;
	gfloat* _tmp128_;
	gint _tmp128__length1;
	RGBTransformation* _tmp129_;
	gfloat* _tmp130_;
	gint _tmp130__length1;
	gfloat _tmp131_;
	gfloat* _tmp132_;
	gint _tmp132__length1;
	gfloat _tmp133_;
	RGBTransformation* _tmp134_;
	gfloat* _tmp135_;
	gint _tmp135__length1;
	gfloat _tmp136_;
	gfloat* _tmp137_;
	gint _tmp137__length1;
	gfloat _tmp138_;
	RGBTransformation* _tmp139_;
	gfloat* _tmp140_;
	gint _tmp140__length1;
	gfloat _tmp141_;
	gfloat* _tmp142_;
	gint _tmp142__length1;
	gfloat _tmp143_;
	RGBTransformation* _tmp144_;
	gfloat* _tmp145_;
	gint _tmp145__length1;
	gfloat _tmp146_;
	gfloat* _tmp147_;
	gint _tmp147__length1;
	gfloat _tmp148_;
	gfloat* _tmp149_;
	gint _tmp149__length1;
	RGBTransformation* _tmp150_;
	gfloat* _tmp151_;
	gint _tmp151__length1;
	gfloat _tmp152_;
	gfloat* _tmp153_;
	gint _tmp153__length1;
	gfloat _tmp154_;
	RGBTransformation* _tmp155_;
	gfloat* _tmp156_;
	gint _tmp156__length1;
	gfloat _tmp157_;
	gfloat* _tmp158_;
	gint _tmp158__length1;
	gfloat _tmp159_;
	RGBTransformation* _tmp160_;
	gfloat* _tmp161_;
	gint _tmp161__length1;
	gfloat _tmp162_;
	gfloat* _tmp163_;
	gint _tmp163__length1;
	gfloat _tmp164_;
	RGBTransformation* _tmp165_;
	gfloat* _tmp166_;
	gint _tmp166__length1;
	gfloat _tmp167_;
	gfloat* _tmp168_;
	gint _tmp168__length1;
	gfloat _tmp169_;
	gfloat* _tmp170_;
	gint _tmp170__length1;
	RGBTransformation* _tmp171_;
	gfloat* _tmp172_;
	gint _tmp172__length1;
	gfloat _tmp173_;
	gfloat* _tmp174_;
	gint _tmp174__length1;
	gfloat _tmp175_;
	RGBTransformation* _tmp176_;
	gfloat* _tmp177_;
	gint _tmp177__length1;
	gfloat _tmp178_;
	gfloat* _tmp179_;
	gint _tmp179__length1;
	gfloat _tmp180_;
	RGBTransformation* _tmp181_;
	gfloat* _tmp182_;
	gint _tmp182__length1;
	gfloat _tmp183_;
	gfloat* _tmp184_;
	gint _tmp184__length1;
	gfloat _tmp185_;
	RGBTransformation* _tmp186_;
	gfloat* _tmp187_;
	gint _tmp187__length1;
	gfloat _tmp188_;
	gfloat* _tmp189_;
	gint _tmp189__length1;
	gfloat _tmp190_;
	gfloat* _tmp191_;
	gint _tmp191__length1;
	RGBTransformation* _tmp192_;
	gfloat* _tmp193_;
	gint _tmp193__length1;
	gfloat _tmp194_;
	gfloat* _tmp195_;
	gint _tmp195__length1;
	gfloat _tmp196_;
	RGBTransformation* _tmp197_;
	gfloat* _tmp198_;
	gint _tmp198__length1;
	gfloat _tmp199_;
	gfloat* _tmp200_;
	gint _tmp200__length1;
	gfloat _tmp201_;
	RGBTransformation* _tmp202_;
	gfloat* _tmp203_;
	gint _tmp203__length1;
	gfloat _tmp204_;
	gfloat* _tmp205_;
	gint _tmp205__length1;
	gfloat _tmp206_;
	RGBTransformation* _tmp207_;
	gfloat* _tmp208_;
	gint _tmp208__length1;
	gfloat _tmp209_;
	gfloat* _tmp210_;
	gint _tmp210__length1;
	gfloat _tmp211_;
	gfloat* _tmp212_;
	gint _tmp212__length1;
	RGBTransformation* _tmp213_;
	gfloat* _tmp214_;
	gint _tmp214__length1;
	gfloat _tmp215_;
	gfloat* _tmp216_;
	gint _tmp216__length1;
	gfloat _tmp217_;
	RGBTransformation* _tmp218_;
	gfloat* _tmp219_;
	gint _tmp219__length1;
	gfloat _tmp220_;
	gfloat* _tmp221_;
	gint _tmp221__length1;
	gfloat _tmp222_;
	RGBTransformation* _tmp223_;
	gfloat* _tmp224_;
	gint _tmp224__length1;
	gfloat _tmp225_;
	gfloat* _tmp226_;
	gint _tmp226__length1;
	gfloat _tmp227_;
	RGBTransformation* _tmp228_;
	gfloat* _tmp229_;
	gint _tmp229__length1;
	gfloat _tmp230_;
	gfloat* _tmp231_;
	gint _tmp231__length1;
	gfloat _tmp232_;
	gfloat* _tmp233_;
	gint _tmp233__length1;
	RGBTransformation* _tmp234_;
	gfloat* _tmp235_;
	gint _tmp235__length1;
	gfloat _tmp236_;
	gfloat* _tmp237_;
	gint _tmp237__length1;
	gfloat _tmp238_;
	RGBTransformation* _tmp239_;
	gfloat* _tmp240_;
	gint _tmp240__length1;
	gfloat _tmp241_;
	gfloat* _tmp242_;
	gint _tmp242__length1;
	gfloat _tmp243_;
	RGBTransformation* _tmp244_;
	gfloat* _tmp245_;
	gint _tmp245__length1;
	gfloat _tmp246_;
	gfloat* _tmp247_;
	gint _tmp247__length1;
	gfloat _tmp248_;
	RGBTransformation* _tmp249_;
	gfloat* _tmp250_;
	gint _tmp250__length1;
	gfloat _tmp251_;
	gfloat* _tmp252_;
	gint _tmp252__length1;
	gfloat _tmp253_;
	gfloat* _tmp254_;
	gint _tmp254__length1;
	RGBTransformation* _tmp255_;
	gfloat* _tmp256_;
	gint _tmp256__length1;
	gfloat _tmp257_;
	gfloat* _tmp258_;
	gint _tmp258__length1;
	gfloat _tmp259_;
	RGBTransformation* _tmp260_;
	gfloat* _tmp261_;
	gint _tmp261__length1;
	gfloat _tmp262_;
	gfloat* _tmp263_;
	gint _tmp263__length1;
	gfloat _tmp264_;
	RGBTransformation* _tmp265_;
	gfloat* _tmp266_;
	gint _tmp266__length1;
	gfloat _tmp267_;
	gfloat* _tmp268_;
	gint _tmp268__length1;
	gfloat _tmp269_;
	RGBTransformation* _tmp270_;
	gfloat* _tmp271_;
	gint _tmp271__length1;
	gfloat _tmp272_;
	gfloat* _tmp273_;
	gint _tmp273__length1;
	gfloat _tmp274_;
	gfloat* _tmp275_;
	gint _tmp275__length1;
	RGBTransformation* _tmp276_;
	gfloat* _tmp277_;
	gint _tmp277__length1;
	gfloat _tmp278_;
	gfloat* _tmp279_;
	gint _tmp279__length1;
	gfloat _tmp280_;
	RGBTransformation* _tmp281_;
	gfloat* _tmp282_;
	gint _tmp282__length1;
	gfloat _tmp283_;
	gfloat* _tmp284_;
	gint _tmp284__length1;
	gfloat _tmp285_;
	RGBTransformation* _tmp286_;
	gfloat* _tmp287_;
	gint _tmp287__length1;
	gfloat _tmp288_;
	gfloat* _tmp289_;
	gint _tmp289__length1;
	gfloat _tmp290_;
	RGBTransformation* _tmp291_;
	gfloat* _tmp292_;
	gint _tmp292__length1;
	gfloat _tmp293_;
	gfloat* _tmp294_;
	gint _tmp294__length1;
	gfloat _tmp295_;
	gfloat* _tmp296_;
	gint _tmp296__length1;
	RGBTransformation* _tmp297_;
	gfloat* _tmp298_;
	gint _tmp298__length1;
	gfloat _tmp299_;
	gfloat* _tmp300_;
	gint _tmp300__length1;
	gfloat _tmp301_;
	RGBTransformation* _tmp302_;
	gfloat* _tmp303_;
	gint _tmp303__length1;
	gfloat _tmp304_;
	gfloat* _tmp305_;
	gint _tmp305__length1;
	gfloat _tmp306_;
	RGBTransformation* _tmp307_;
	gfloat* _tmp308_;
	gint _tmp308__length1;
	gfloat _tmp309_;
	gfloat* _tmp310_;
	gint _tmp310__length1;
	gfloat _tmp311_;
	RGBTransformation* _tmp312_;
	gfloat* _tmp313_;
	gint _tmp313__length1;
	gfloat _tmp314_;
	gfloat* _tmp315_;
	gint _tmp315__length1;
	gfloat _tmp316_;
	gfloat* _tmp317_;
	gint _tmp317__length1;
	RGBTransformation* _tmp318_;
	gfloat* _tmp319_;
	gint _tmp319__length1;
	gfloat _tmp320_;
	gfloat* _tmp321_;
	gint _tmp321__length1;
	gfloat _tmp322_;
	RGBTransformation* _tmp323_;
	gfloat* _tmp324_;
	gint _tmp324__length1;
	gfloat _tmp325_;
	gfloat* _tmp326_;
	gint _tmp326__length1;
	gfloat _tmp327_;
	RGBTransformation* _tmp328_;
	gfloat* _tmp329_;
	gint _tmp329__length1;
	gfloat _tmp330_;
	gfloat* _tmp331_;
	gint _tmp331__length1;
	gfloat _tmp332_;
	RGBTransformation* _tmp333_;
	gfloat* _tmp334_;
	gint _tmp334__length1;
	gfloat _tmp335_;
	gfloat* _tmp336_;
	gint _tmp336__length1;
	gfloat _tmp337_;
	gboolean _tmp343_ = FALSE;
#line 448 "../src/ColorTransformation.vala"
	self = (RGBTransformation*) base;
#line 448 "../src/ColorTransformation.vala"
	g_return_if_fail (other != NULL);
#line 449 "../src/ColorTransformation.vala"
	if (pixel_transformation_get_composition_mode (other) != COMPOSITION_MODE_RGB_MATRIX) {
#line 450 "../src/ColorTransformation.vala"
		g_error ("ColorTransformation.vala:450: %s", "RGBTransformation: compose_with( ): 'other' transformation " "does not support RGB_MATRIX composition mode");
#line 3247 "ColorTransformation.c"
	}
#line 453 "../src/ColorTransformation.vala"
	_tmp0_ = _pixel_transformation_ref0 (G_TYPE_CHECK_INSTANCE_CAST (other, TYPE_RGB_TRANSFORMATION, RGBTransformation));
#line 453 "../src/ColorTransformation.vala"
	transform = _tmp0_;
#line 455 "../src/ColorTransformation.vala"
	_tmp1_ = g_new0 (gfloat, 16);
#line 455 "../src/ColorTransformation.vala"
	result_matrix_entries = _tmp1_;
#line 455 "../src/ColorTransformation.vala"
	result_matrix_entries_length1 = 16;
#line 455 "../src/ColorTransformation.vala"
	_result_matrix_entries_size_ = result_matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp2_ = result_matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp2__length1 = result_matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp3_ = transform;
#line 458 "../src/ColorTransformation.vala"
	_tmp4_ = _tmp3_->matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp4__length1 = _tmp3_->matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp5_ = _tmp4_[0];
#line 458 "../src/ColorTransformation.vala"
	_tmp6_ = self->matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp6__length1 = self->matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp7_ = _tmp6_[0];
#line 458 "../src/ColorTransformation.vala"
	_tmp8_ = transform;
#line 458 "../src/ColorTransformation.vala"
	_tmp9_ = _tmp8_->matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp9__length1 = _tmp8_->matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp10_ = _tmp9_[1];
#line 458 "../src/ColorTransformation.vala"
	_tmp11_ = self->matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp11__length1 = self->matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp12_ = _tmp11_[4];
#line 458 "../src/ColorTransformation.vala"
	_tmp13_ = transform;
#line 458 "../src/ColorTransformation.vala"
	_tmp14_ = _tmp13_->matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp14__length1 = _tmp13_->matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp15_ = _tmp14_[2];
#line 458 "../src/ColorTransformation.vala"
	_tmp16_ = self->matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp16__length1 = self->matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp17_ = _tmp16_[8];
#line 458 "../src/ColorTransformation.vala"
	_tmp18_ = transform;
#line 458 "../src/ColorTransformation.vala"
	_tmp19_ = _tmp18_->matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp19__length1 = _tmp18_->matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp20_ = _tmp19_[3];
#line 458 "../src/ColorTransformation.vala"
	_tmp21_ = self->matrix_entries;
#line 458 "../src/ColorTransformation.vala"
	_tmp21__length1 = self->matrix_entries_length1;
#line 458 "../src/ColorTransformation.vala"
	_tmp22_ = _tmp21_[12];
#line 458 "../src/ColorTransformation.vala"
	_tmp2_[0] = (((_tmp5_ * _tmp7_) + (_tmp10_ * _tmp12_)) + (_tmp15_ * _tmp17_)) + (_tmp20_ * _tmp22_);
#line 464 "../src/ColorTransformation.vala"
	_tmp23_ = result_matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp23__length1 = result_matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp24_ = transform;
#line 464 "../src/ColorTransformation.vala"
	_tmp25_ = _tmp24_->matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp25__length1 = _tmp24_->matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp26_ = _tmp25_[0];
#line 464 "../src/ColorTransformation.vala"
	_tmp27_ = self->matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp27__length1 = self->matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp28_ = _tmp27_[1];
#line 464 "../src/ColorTransformation.vala"
	_tmp29_ = transform;
#line 464 "../src/ColorTransformation.vala"
	_tmp30_ = _tmp29_->matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp30__length1 = _tmp29_->matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp31_ = _tmp30_[1];
#line 464 "../src/ColorTransformation.vala"
	_tmp32_ = self->matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp32__length1 = self->matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp33_ = _tmp32_[5];
#line 464 "../src/ColorTransformation.vala"
	_tmp34_ = transform;
#line 464 "../src/ColorTransformation.vala"
	_tmp35_ = _tmp34_->matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp35__length1 = _tmp34_->matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp36_ = _tmp35_[2];
#line 464 "../src/ColorTransformation.vala"
	_tmp37_ = self->matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp37__length1 = self->matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp38_ = _tmp37_[9];
#line 464 "../src/ColorTransformation.vala"
	_tmp39_ = transform;
#line 464 "../src/ColorTransformation.vala"
	_tmp40_ = _tmp39_->matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp40__length1 = _tmp39_->matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp41_ = _tmp40_[3];
#line 464 "../src/ColorTransformation.vala"
	_tmp42_ = self->matrix_entries;
#line 464 "../src/ColorTransformation.vala"
	_tmp42__length1 = self->matrix_entries_length1;
#line 464 "../src/ColorTransformation.vala"
	_tmp43_ = _tmp42_[13];
#line 464 "../src/ColorTransformation.vala"
	_tmp23_[1] = (((_tmp26_ * _tmp28_) + (_tmp31_ * _tmp33_)) + (_tmp36_ * _tmp38_)) + (_tmp41_ * _tmp43_);
#line 470 "../src/ColorTransformation.vala"
	_tmp44_ = result_matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp44__length1 = result_matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp45_ = transform;
#line 470 "../src/ColorTransformation.vala"
	_tmp46_ = _tmp45_->matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp46__length1 = _tmp45_->matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp47_ = _tmp46_[0];
#line 470 "../src/ColorTransformation.vala"
	_tmp48_ = self->matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp48__length1 = self->matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp49_ = _tmp48_[2];
#line 470 "../src/ColorTransformation.vala"
	_tmp50_ = transform;
#line 470 "../src/ColorTransformation.vala"
	_tmp51_ = _tmp50_->matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp51__length1 = _tmp50_->matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp52_ = _tmp51_[1];
#line 470 "../src/ColorTransformation.vala"
	_tmp53_ = self->matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp53__length1 = self->matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp54_ = _tmp53_[6];
#line 470 "../src/ColorTransformation.vala"
	_tmp55_ = transform;
#line 470 "../src/ColorTransformation.vala"
	_tmp56_ = _tmp55_->matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp56__length1 = _tmp55_->matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp57_ = _tmp56_[2];
#line 470 "../src/ColorTransformation.vala"
	_tmp58_ = self->matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp58__length1 = self->matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp59_ = _tmp58_[10];
#line 470 "../src/ColorTransformation.vala"
	_tmp60_ = transform;
#line 470 "../src/ColorTransformation.vala"
	_tmp61_ = _tmp60_->matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp61__length1 = _tmp60_->matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp62_ = _tmp61_[3];
#line 470 "../src/ColorTransformation.vala"
	_tmp63_ = self->matrix_entries;
#line 470 "../src/ColorTransformation.vala"
	_tmp63__length1 = self->matrix_entries_length1;
#line 470 "../src/ColorTransformation.vala"
	_tmp64_ = _tmp63_[14];
#line 470 "../src/ColorTransformation.vala"
	_tmp44_[2] = (((_tmp47_ * _tmp49_) + (_tmp52_ * _tmp54_)) + (_tmp57_ * _tmp59_)) + (_tmp62_ * _tmp64_);
#line 476 "../src/ColorTransformation.vala"
	_tmp65_ = result_matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp65__length1 = result_matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp66_ = transform;
#line 476 "../src/ColorTransformation.vala"
	_tmp67_ = _tmp66_->matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp67__length1 = _tmp66_->matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp68_ = _tmp67_[0];
#line 476 "../src/ColorTransformation.vala"
	_tmp69_ = self->matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp69__length1 = self->matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp70_ = _tmp69_[3];
#line 476 "../src/ColorTransformation.vala"
	_tmp71_ = transform;
#line 476 "../src/ColorTransformation.vala"
	_tmp72_ = _tmp71_->matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp72__length1 = _tmp71_->matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp73_ = _tmp72_[1];
#line 476 "../src/ColorTransformation.vala"
	_tmp74_ = self->matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp74__length1 = self->matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp75_ = _tmp74_[7];
#line 476 "../src/ColorTransformation.vala"
	_tmp76_ = transform;
#line 476 "../src/ColorTransformation.vala"
	_tmp77_ = _tmp76_->matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp77__length1 = _tmp76_->matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp78_ = _tmp77_[2];
#line 476 "../src/ColorTransformation.vala"
	_tmp79_ = self->matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp79__length1 = self->matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp80_ = _tmp79_[11];
#line 476 "../src/ColorTransformation.vala"
	_tmp81_ = transform;
#line 476 "../src/ColorTransformation.vala"
	_tmp82_ = _tmp81_->matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp82__length1 = _tmp81_->matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp83_ = _tmp82_[3];
#line 476 "../src/ColorTransformation.vala"
	_tmp84_ = self->matrix_entries;
#line 476 "../src/ColorTransformation.vala"
	_tmp84__length1 = self->matrix_entries_length1;
#line 476 "../src/ColorTransformation.vala"
	_tmp85_ = _tmp84_[15];
#line 476 "../src/ColorTransformation.vala"
	_tmp65_[3] = (((_tmp68_ * _tmp70_) + (_tmp73_ * _tmp75_)) + (_tmp78_ * _tmp80_)) + (_tmp83_ * _tmp85_);
#line 483 "../src/ColorTransformation.vala"
	_tmp86_ = result_matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp86__length1 = result_matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp87_ = transform;
#line 483 "../src/ColorTransformation.vala"
	_tmp88_ = _tmp87_->matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp88__length1 = _tmp87_->matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp89_ = _tmp88_[4];
#line 483 "../src/ColorTransformation.vala"
	_tmp90_ = self->matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp90__length1 = self->matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp91_ = _tmp90_[0];
#line 483 "../src/ColorTransformation.vala"
	_tmp92_ = transform;
#line 483 "../src/ColorTransformation.vala"
	_tmp93_ = _tmp92_->matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp93__length1 = _tmp92_->matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp94_ = _tmp93_[5];
#line 483 "../src/ColorTransformation.vala"
	_tmp95_ = self->matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp95__length1 = self->matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp96_ = _tmp95_[4];
#line 483 "../src/ColorTransformation.vala"
	_tmp97_ = transform;
#line 483 "../src/ColorTransformation.vala"
	_tmp98_ = _tmp97_->matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp98__length1 = _tmp97_->matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp99_ = _tmp98_[6];
#line 483 "../src/ColorTransformation.vala"
	_tmp100_ = self->matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp100__length1 = self->matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp101_ = _tmp100_[8];
#line 483 "../src/ColorTransformation.vala"
	_tmp102_ = transform;
#line 483 "../src/ColorTransformation.vala"
	_tmp103_ = _tmp102_->matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp103__length1 = _tmp102_->matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp104_ = _tmp103_[7];
#line 483 "../src/ColorTransformation.vala"
	_tmp105_ = self->matrix_entries;
#line 483 "../src/ColorTransformation.vala"
	_tmp105__length1 = self->matrix_entries_length1;
#line 483 "../src/ColorTransformation.vala"
	_tmp106_ = _tmp105_[12];
#line 483 "../src/ColorTransformation.vala"
	_tmp86_[4] = (((_tmp89_ * _tmp91_) + (_tmp94_ * _tmp96_)) + (_tmp99_ * _tmp101_)) + (_tmp104_ * _tmp106_);
#line 489 "../src/ColorTransformation.vala"
	_tmp107_ = result_matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp107__length1 = result_matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp108_ = transform;
#line 489 "../src/ColorTransformation.vala"
	_tmp109_ = _tmp108_->matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp109__length1 = _tmp108_->matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp110_ = _tmp109_[4];
#line 489 "../src/ColorTransformation.vala"
	_tmp111_ = self->matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp111__length1 = self->matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp112_ = _tmp111_[1];
#line 489 "../src/ColorTransformation.vala"
	_tmp113_ = transform;
#line 489 "../src/ColorTransformation.vala"
	_tmp114_ = _tmp113_->matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp114__length1 = _tmp113_->matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp115_ = _tmp114_[5];
#line 489 "../src/ColorTransformation.vala"
	_tmp116_ = self->matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp116__length1 = self->matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp117_ = _tmp116_[5];
#line 489 "../src/ColorTransformation.vala"
	_tmp118_ = transform;
#line 489 "../src/ColorTransformation.vala"
	_tmp119_ = _tmp118_->matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp119__length1 = _tmp118_->matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp120_ = _tmp119_[6];
#line 489 "../src/ColorTransformation.vala"
	_tmp121_ = self->matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp121__length1 = self->matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp122_ = _tmp121_[9];
#line 489 "../src/ColorTransformation.vala"
	_tmp123_ = transform;
#line 489 "../src/ColorTransformation.vala"
	_tmp124_ = _tmp123_->matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp124__length1 = _tmp123_->matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp125_ = _tmp124_[7];
#line 489 "../src/ColorTransformation.vala"
	_tmp126_ = self->matrix_entries;
#line 489 "../src/ColorTransformation.vala"
	_tmp126__length1 = self->matrix_entries_length1;
#line 489 "../src/ColorTransformation.vala"
	_tmp127_ = _tmp126_[13];
#line 489 "../src/ColorTransformation.vala"
	_tmp107_[5] = (((_tmp110_ * _tmp112_) + (_tmp115_ * _tmp117_)) + (_tmp120_ * _tmp122_)) + (_tmp125_ * _tmp127_);
#line 495 "../src/ColorTransformation.vala"
	_tmp128_ = result_matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp128__length1 = result_matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp129_ = transform;
#line 495 "../src/ColorTransformation.vala"
	_tmp130_ = _tmp129_->matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp130__length1 = _tmp129_->matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp131_ = _tmp130_[4];
#line 495 "../src/ColorTransformation.vala"
	_tmp132_ = self->matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp132__length1 = self->matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp133_ = _tmp132_[2];
#line 495 "../src/ColorTransformation.vala"
	_tmp134_ = transform;
#line 495 "../src/ColorTransformation.vala"
	_tmp135_ = _tmp134_->matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp135__length1 = _tmp134_->matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp136_ = _tmp135_[5];
#line 495 "../src/ColorTransformation.vala"
	_tmp137_ = self->matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp137__length1 = self->matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp138_ = _tmp137_[6];
#line 495 "../src/ColorTransformation.vala"
	_tmp139_ = transform;
#line 495 "../src/ColorTransformation.vala"
	_tmp140_ = _tmp139_->matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp140__length1 = _tmp139_->matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp141_ = _tmp140_[6];
#line 495 "../src/ColorTransformation.vala"
	_tmp142_ = self->matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp142__length1 = self->matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp143_ = _tmp142_[10];
#line 495 "../src/ColorTransformation.vala"
	_tmp144_ = transform;
#line 495 "../src/ColorTransformation.vala"
	_tmp145_ = _tmp144_->matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp145__length1 = _tmp144_->matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp146_ = _tmp145_[7];
#line 495 "../src/ColorTransformation.vala"
	_tmp147_ = self->matrix_entries;
#line 495 "../src/ColorTransformation.vala"
	_tmp147__length1 = self->matrix_entries_length1;
#line 495 "../src/ColorTransformation.vala"
	_tmp148_ = _tmp147_[14];
#line 495 "../src/ColorTransformation.vala"
	_tmp128_[6] = (((_tmp131_ * _tmp133_) + (_tmp136_ * _tmp138_)) + (_tmp141_ * _tmp143_)) + (_tmp146_ * _tmp148_);
#line 501 "../src/ColorTransformation.vala"
	_tmp149_ = result_matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp149__length1 = result_matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp150_ = transform;
#line 501 "../src/ColorTransformation.vala"
	_tmp151_ = _tmp150_->matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp151__length1 = _tmp150_->matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp152_ = _tmp151_[4];
#line 501 "../src/ColorTransformation.vala"
	_tmp153_ = self->matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp153__length1 = self->matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp154_ = _tmp153_[3];
#line 501 "../src/ColorTransformation.vala"
	_tmp155_ = transform;
#line 501 "../src/ColorTransformation.vala"
	_tmp156_ = _tmp155_->matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp156__length1 = _tmp155_->matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp157_ = _tmp156_[5];
#line 501 "../src/ColorTransformation.vala"
	_tmp158_ = self->matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp158__length1 = self->matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp159_ = _tmp158_[7];
#line 501 "../src/ColorTransformation.vala"
	_tmp160_ = transform;
#line 501 "../src/ColorTransformation.vala"
	_tmp161_ = _tmp160_->matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp161__length1 = _tmp160_->matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp162_ = _tmp161_[6];
#line 501 "../src/ColorTransformation.vala"
	_tmp163_ = self->matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp163__length1 = self->matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp164_ = _tmp163_[11];
#line 501 "../src/ColorTransformation.vala"
	_tmp165_ = transform;
#line 501 "../src/ColorTransformation.vala"
	_tmp166_ = _tmp165_->matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp166__length1 = _tmp165_->matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp167_ = _tmp166_[7];
#line 501 "../src/ColorTransformation.vala"
	_tmp168_ = self->matrix_entries;
#line 501 "../src/ColorTransformation.vala"
	_tmp168__length1 = self->matrix_entries_length1;
#line 501 "../src/ColorTransformation.vala"
	_tmp169_ = _tmp168_[15];
#line 501 "../src/ColorTransformation.vala"
	_tmp149_[7] = (((_tmp152_ * _tmp154_) + (_tmp157_ * _tmp159_)) + (_tmp162_ * _tmp164_)) + (_tmp167_ * _tmp169_);
#line 508 "../src/ColorTransformation.vala"
	_tmp170_ = result_matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp170__length1 = result_matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp171_ = transform;
#line 508 "../src/ColorTransformation.vala"
	_tmp172_ = _tmp171_->matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp172__length1 = _tmp171_->matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp173_ = _tmp172_[8];
#line 508 "../src/ColorTransformation.vala"
	_tmp174_ = self->matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp174__length1 = self->matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp175_ = _tmp174_[0];
#line 508 "../src/ColorTransformation.vala"
	_tmp176_ = transform;
#line 508 "../src/ColorTransformation.vala"
	_tmp177_ = _tmp176_->matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp177__length1 = _tmp176_->matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp178_ = _tmp177_[9];
#line 508 "../src/ColorTransformation.vala"
	_tmp179_ = self->matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp179__length1 = self->matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp180_ = _tmp179_[4];
#line 508 "../src/ColorTransformation.vala"
	_tmp181_ = transform;
#line 508 "../src/ColorTransformation.vala"
	_tmp182_ = _tmp181_->matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp182__length1 = _tmp181_->matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp183_ = _tmp182_[10];
#line 508 "../src/ColorTransformation.vala"
	_tmp184_ = self->matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp184__length1 = self->matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp185_ = _tmp184_[8];
#line 508 "../src/ColorTransformation.vala"
	_tmp186_ = transform;
#line 508 "../src/ColorTransformation.vala"
	_tmp187_ = _tmp186_->matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp187__length1 = _tmp186_->matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp188_ = _tmp187_[11];
#line 508 "../src/ColorTransformation.vala"
	_tmp189_ = self->matrix_entries;
#line 508 "../src/ColorTransformation.vala"
	_tmp189__length1 = self->matrix_entries_length1;
#line 508 "../src/ColorTransformation.vala"
	_tmp190_ = _tmp189_[12];
#line 508 "../src/ColorTransformation.vala"
	_tmp170_[8] = (((_tmp173_ * _tmp175_) + (_tmp178_ * _tmp180_)) + (_tmp183_ * _tmp185_)) + (_tmp188_ * _tmp190_);
#line 514 "../src/ColorTransformation.vala"
	_tmp191_ = result_matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp191__length1 = result_matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp192_ = transform;
#line 514 "../src/ColorTransformation.vala"
	_tmp193_ = _tmp192_->matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp193__length1 = _tmp192_->matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp194_ = _tmp193_[8];
#line 514 "../src/ColorTransformation.vala"
	_tmp195_ = self->matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp195__length1 = self->matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp196_ = _tmp195_[1];
#line 514 "../src/ColorTransformation.vala"
	_tmp197_ = transform;
#line 514 "../src/ColorTransformation.vala"
	_tmp198_ = _tmp197_->matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp198__length1 = _tmp197_->matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp199_ = _tmp198_[9];
#line 514 "../src/ColorTransformation.vala"
	_tmp200_ = self->matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp200__length1 = self->matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp201_ = _tmp200_[5];
#line 514 "../src/ColorTransformation.vala"
	_tmp202_ = transform;
#line 514 "../src/ColorTransformation.vala"
	_tmp203_ = _tmp202_->matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp203__length1 = _tmp202_->matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp204_ = _tmp203_[10];
#line 514 "../src/ColorTransformation.vala"
	_tmp205_ = self->matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp205__length1 = self->matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp206_ = _tmp205_[9];
#line 514 "../src/ColorTransformation.vala"
	_tmp207_ = transform;
#line 514 "../src/ColorTransformation.vala"
	_tmp208_ = _tmp207_->matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp208__length1 = _tmp207_->matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp209_ = _tmp208_[11];
#line 514 "../src/ColorTransformation.vala"
	_tmp210_ = self->matrix_entries;
#line 514 "../src/ColorTransformation.vala"
	_tmp210__length1 = self->matrix_entries_length1;
#line 514 "../src/ColorTransformation.vala"
	_tmp211_ = _tmp210_[13];
#line 514 "../src/ColorTransformation.vala"
	_tmp191_[9] = (((_tmp194_ * _tmp196_) + (_tmp199_ * _tmp201_)) + (_tmp204_ * _tmp206_)) + (_tmp209_ * _tmp211_);
#line 520 "../src/ColorTransformation.vala"
	_tmp212_ = result_matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp212__length1 = result_matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp213_ = transform;
#line 520 "../src/ColorTransformation.vala"
	_tmp214_ = _tmp213_->matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp214__length1 = _tmp213_->matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp215_ = _tmp214_[8];
#line 520 "../src/ColorTransformation.vala"
	_tmp216_ = self->matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp216__length1 = self->matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp217_ = _tmp216_[2];
#line 520 "../src/ColorTransformation.vala"
	_tmp218_ = transform;
#line 520 "../src/ColorTransformation.vala"
	_tmp219_ = _tmp218_->matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp219__length1 = _tmp218_->matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp220_ = _tmp219_[9];
#line 520 "../src/ColorTransformation.vala"
	_tmp221_ = self->matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp221__length1 = self->matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp222_ = _tmp221_[6];
#line 520 "../src/ColorTransformation.vala"
	_tmp223_ = transform;
#line 520 "../src/ColorTransformation.vala"
	_tmp224_ = _tmp223_->matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp224__length1 = _tmp223_->matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp225_ = _tmp224_[10];
#line 520 "../src/ColorTransformation.vala"
	_tmp226_ = self->matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp226__length1 = self->matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp227_ = _tmp226_[10];
#line 520 "../src/ColorTransformation.vala"
	_tmp228_ = transform;
#line 520 "../src/ColorTransformation.vala"
	_tmp229_ = _tmp228_->matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp229__length1 = _tmp228_->matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp230_ = _tmp229_[11];
#line 520 "../src/ColorTransformation.vala"
	_tmp231_ = self->matrix_entries;
#line 520 "../src/ColorTransformation.vala"
	_tmp231__length1 = self->matrix_entries_length1;
#line 520 "../src/ColorTransformation.vala"
	_tmp232_ = _tmp231_[14];
#line 520 "../src/ColorTransformation.vala"
	_tmp212_[10] = (((_tmp215_ * _tmp217_) + (_tmp220_ * _tmp222_)) + (_tmp225_ * _tmp227_)) + (_tmp230_ * _tmp232_);
#line 526 "../src/ColorTransformation.vala"
	_tmp233_ = result_matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp233__length1 = result_matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp234_ = transform;
#line 526 "../src/ColorTransformation.vala"
	_tmp235_ = _tmp234_->matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp235__length1 = _tmp234_->matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp236_ = _tmp235_[8];
#line 526 "../src/ColorTransformation.vala"
	_tmp237_ = self->matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp237__length1 = self->matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp238_ = _tmp237_[3];
#line 526 "../src/ColorTransformation.vala"
	_tmp239_ = transform;
#line 526 "../src/ColorTransformation.vala"
	_tmp240_ = _tmp239_->matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp240__length1 = _tmp239_->matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp241_ = _tmp240_[9];
#line 526 "../src/ColorTransformation.vala"
	_tmp242_ = self->matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp242__length1 = self->matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp243_ = _tmp242_[7];
#line 526 "../src/ColorTransformation.vala"
	_tmp244_ = transform;
#line 526 "../src/ColorTransformation.vala"
	_tmp245_ = _tmp244_->matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp245__length1 = _tmp244_->matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp246_ = _tmp245_[10];
#line 526 "../src/ColorTransformation.vala"
	_tmp247_ = self->matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp247__length1 = self->matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp248_ = _tmp247_[11];
#line 526 "../src/ColorTransformation.vala"
	_tmp249_ = transform;
#line 526 "../src/ColorTransformation.vala"
	_tmp250_ = _tmp249_->matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp250__length1 = _tmp249_->matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp251_ = _tmp250_[11];
#line 526 "../src/ColorTransformation.vala"
	_tmp252_ = self->matrix_entries;
#line 526 "../src/ColorTransformation.vala"
	_tmp252__length1 = self->matrix_entries_length1;
#line 526 "../src/ColorTransformation.vala"
	_tmp253_ = _tmp252_[15];
#line 526 "../src/ColorTransformation.vala"
	_tmp233_[11] = (((_tmp236_ * _tmp238_) + (_tmp241_ * _tmp243_)) + (_tmp246_ * _tmp248_)) + (_tmp251_ * _tmp253_);
#line 533 "../src/ColorTransformation.vala"
	_tmp254_ = result_matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp254__length1 = result_matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp255_ = transform;
#line 533 "../src/ColorTransformation.vala"
	_tmp256_ = _tmp255_->matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp256__length1 = _tmp255_->matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp257_ = _tmp256_[12];
#line 533 "../src/ColorTransformation.vala"
	_tmp258_ = self->matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp258__length1 = self->matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp259_ = _tmp258_[0];
#line 533 "../src/ColorTransformation.vala"
	_tmp260_ = transform;
#line 533 "../src/ColorTransformation.vala"
	_tmp261_ = _tmp260_->matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp261__length1 = _tmp260_->matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp262_ = _tmp261_[13];
#line 533 "../src/ColorTransformation.vala"
	_tmp263_ = self->matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp263__length1 = self->matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp264_ = _tmp263_[4];
#line 533 "../src/ColorTransformation.vala"
	_tmp265_ = transform;
#line 533 "../src/ColorTransformation.vala"
	_tmp266_ = _tmp265_->matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp266__length1 = _tmp265_->matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp267_ = _tmp266_[14];
#line 533 "../src/ColorTransformation.vala"
	_tmp268_ = self->matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp268__length1 = self->matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp269_ = _tmp268_[8];
#line 533 "../src/ColorTransformation.vala"
	_tmp270_ = transform;
#line 533 "../src/ColorTransformation.vala"
	_tmp271_ = _tmp270_->matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp271__length1 = _tmp270_->matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp272_ = _tmp271_[15];
#line 533 "../src/ColorTransformation.vala"
	_tmp273_ = self->matrix_entries;
#line 533 "../src/ColorTransformation.vala"
	_tmp273__length1 = self->matrix_entries_length1;
#line 533 "../src/ColorTransformation.vala"
	_tmp274_ = _tmp273_[12];
#line 533 "../src/ColorTransformation.vala"
	_tmp254_[12] = (((_tmp257_ * _tmp259_) + (_tmp262_ * _tmp264_)) + (_tmp267_ * _tmp269_)) + (_tmp272_ * _tmp274_);
#line 539 "../src/ColorTransformation.vala"
	_tmp275_ = result_matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp275__length1 = result_matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp276_ = transform;
#line 539 "../src/ColorTransformation.vala"
	_tmp277_ = _tmp276_->matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp277__length1 = _tmp276_->matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp278_ = _tmp277_[12];
#line 539 "../src/ColorTransformation.vala"
	_tmp279_ = self->matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp279__length1 = self->matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp280_ = _tmp279_[1];
#line 539 "../src/ColorTransformation.vala"
	_tmp281_ = transform;
#line 539 "../src/ColorTransformation.vala"
	_tmp282_ = _tmp281_->matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp282__length1 = _tmp281_->matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp283_ = _tmp282_[13];
#line 539 "../src/ColorTransformation.vala"
	_tmp284_ = self->matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp284__length1 = self->matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp285_ = _tmp284_[5];
#line 539 "../src/ColorTransformation.vala"
	_tmp286_ = transform;
#line 539 "../src/ColorTransformation.vala"
	_tmp287_ = _tmp286_->matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp287__length1 = _tmp286_->matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp288_ = _tmp287_[14];
#line 539 "../src/ColorTransformation.vala"
	_tmp289_ = self->matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp289__length1 = self->matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp290_ = _tmp289_[9];
#line 539 "../src/ColorTransformation.vala"
	_tmp291_ = transform;
#line 539 "../src/ColorTransformation.vala"
	_tmp292_ = _tmp291_->matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp292__length1 = _tmp291_->matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp293_ = _tmp292_[15];
#line 539 "../src/ColorTransformation.vala"
	_tmp294_ = self->matrix_entries;
#line 539 "../src/ColorTransformation.vala"
	_tmp294__length1 = self->matrix_entries_length1;
#line 539 "../src/ColorTransformation.vala"
	_tmp295_ = _tmp294_[13];
#line 539 "../src/ColorTransformation.vala"
	_tmp275_[13] = (((_tmp278_ * _tmp280_) + (_tmp283_ * _tmp285_)) + (_tmp288_ * _tmp290_)) + (_tmp293_ * _tmp295_);
#line 545 "../src/ColorTransformation.vala"
	_tmp296_ = result_matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp296__length1 = result_matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp297_ = transform;
#line 545 "../src/ColorTransformation.vala"
	_tmp298_ = _tmp297_->matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp298__length1 = _tmp297_->matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp299_ = _tmp298_[12];
#line 545 "../src/ColorTransformation.vala"
	_tmp300_ = self->matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp300__length1 = self->matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp301_ = _tmp300_[2];
#line 545 "../src/ColorTransformation.vala"
	_tmp302_ = transform;
#line 545 "../src/ColorTransformation.vala"
	_tmp303_ = _tmp302_->matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp303__length1 = _tmp302_->matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp304_ = _tmp303_[13];
#line 545 "../src/ColorTransformation.vala"
	_tmp305_ = self->matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp305__length1 = self->matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp306_ = _tmp305_[6];
#line 545 "../src/ColorTransformation.vala"
	_tmp307_ = transform;
#line 545 "../src/ColorTransformation.vala"
	_tmp308_ = _tmp307_->matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp308__length1 = _tmp307_->matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp309_ = _tmp308_[14];
#line 545 "../src/ColorTransformation.vala"
	_tmp310_ = self->matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp310__length1 = self->matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp311_ = _tmp310_[10];
#line 545 "../src/ColorTransformation.vala"
	_tmp312_ = transform;
#line 545 "../src/ColorTransformation.vala"
	_tmp313_ = _tmp312_->matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp313__length1 = _tmp312_->matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp314_ = _tmp313_[15];
#line 545 "../src/ColorTransformation.vala"
	_tmp315_ = self->matrix_entries;
#line 545 "../src/ColorTransformation.vala"
	_tmp315__length1 = self->matrix_entries_length1;
#line 545 "../src/ColorTransformation.vala"
	_tmp316_ = _tmp315_[14];
#line 545 "../src/ColorTransformation.vala"
	_tmp296_[14] = (((_tmp299_ * _tmp301_) + (_tmp304_ * _tmp306_)) + (_tmp309_ * _tmp311_)) + (_tmp314_ * _tmp316_);
#line 551 "../src/ColorTransformation.vala"
	_tmp317_ = result_matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp317__length1 = result_matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp318_ = transform;
#line 551 "../src/ColorTransformation.vala"
	_tmp319_ = _tmp318_->matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp319__length1 = _tmp318_->matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp320_ = _tmp319_[12];
#line 551 "../src/ColorTransformation.vala"
	_tmp321_ = self->matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp321__length1 = self->matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp322_ = _tmp321_[3];
#line 551 "../src/ColorTransformation.vala"
	_tmp323_ = transform;
#line 551 "../src/ColorTransformation.vala"
	_tmp324_ = _tmp323_->matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp324__length1 = _tmp323_->matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp325_ = _tmp324_[13];
#line 551 "../src/ColorTransformation.vala"
	_tmp326_ = self->matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp326__length1 = self->matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp327_ = _tmp326_[7];
#line 551 "../src/ColorTransformation.vala"
	_tmp328_ = transform;
#line 551 "../src/ColorTransformation.vala"
	_tmp329_ = _tmp328_->matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp329__length1 = _tmp328_->matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp330_ = _tmp329_[14];
#line 551 "../src/ColorTransformation.vala"
	_tmp331_ = self->matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp331__length1 = self->matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp332_ = _tmp331_[11];
#line 551 "../src/ColorTransformation.vala"
	_tmp333_ = transform;
#line 551 "../src/ColorTransformation.vala"
	_tmp334_ = _tmp333_->matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp334__length1 = _tmp333_->matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp335_ = _tmp334_[15];
#line 551 "../src/ColorTransformation.vala"
	_tmp336_ = self->matrix_entries;
#line 551 "../src/ColorTransformation.vala"
	_tmp336__length1 = self->matrix_entries_length1;
#line 551 "../src/ColorTransformation.vala"
	_tmp337_ = _tmp336_[15];
#line 551 "../src/ColorTransformation.vala"
	_tmp317_[15] = (((_tmp320_ * _tmp322_) + (_tmp325_ * _tmp327_)) + (_tmp330_ * _tmp332_)) + (_tmp335_ * _tmp337_);
#line 4253 "ColorTransformation.c"
	{
		gint i = 0;
#line 557 "../src/ColorTransformation.vala"
		i = 0;
#line 4258 "ColorTransformation.c"
		{
			gboolean _tmp338_ = FALSE;
#line 557 "../src/ColorTransformation.vala"
			_tmp338_ = TRUE;
#line 557 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 4265 "ColorTransformation.c"
				gfloat* _tmp340_;
				gint _tmp340__length1;
				gfloat* _tmp341_;
				gint _tmp341__length1;
				gfloat _tmp342_;
#line 557 "../src/ColorTransformation.vala"
				if (!_tmp338_) {
#line 4273 "ColorTransformation.c"
					gint _tmp339_;
#line 557 "../src/ColorTransformation.vala"
					_tmp339_ = i;
#line 557 "../src/ColorTransformation.vala"
					i = _tmp339_ + 1;
#line 4279 "ColorTransformation.c"
				}
#line 557 "../src/ColorTransformation.vala"
				_tmp338_ = FALSE;
#line 557 "../src/ColorTransformation.vala"
				if (!(i < RGB_TRANSFORMATION_MATRIX_SIZE)) {
#line 557 "../src/ColorTransformation.vala"
					break;
#line 4287 "ColorTransformation.c"
				}
#line 558 "../src/ColorTransformation.vala"
				_tmp340_ = self->matrix_entries;
#line 558 "../src/ColorTransformation.vala"
				_tmp340__length1 = self->matrix_entries_length1;
#line 558 "../src/ColorTransformation.vala"
				_tmp341_ = result_matrix_entries;
#line 558 "../src/ColorTransformation.vala"
				_tmp341__length1 = result_matrix_entries_length1;
#line 558 "../src/ColorTransformation.vala"
				_tmp342_ = _tmp341_[i];
#line 558 "../src/ColorTransformation.vala"
				_tmp340_[i] = _tmp342_;
#line 4301 "ColorTransformation.c"
			}
		}
	}
#line 560 "../src/ColorTransformation.vala"
	if (self->identity) {
#line 4307 "ColorTransformation.c"
		RGBTransformation* _tmp344_;
#line 560 "../src/ColorTransformation.vala"
		_tmp344_ = transform;
#line 560 "../src/ColorTransformation.vala"
		_tmp343_ = _tmp344_->identity;
#line 4313 "ColorTransformation.c"
	} else {
#line 560 "../src/ColorTransformation.vala"
		_tmp343_ = FALSE;
#line 4317 "ColorTransformation.c"
	}
#line 560 "../src/ColorTransformation.vala"
	self->identity = _tmp343_;
#line 448 "../src/ColorTransformation.vala"
	result_matrix_entries = (g_free (result_matrix_entries), NULL);
#line 448 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (transform);
#line 4325 "ColorTransformation.c"
}

static void
rgb_transformation_real_transform_pixel_hsv (PixelTransformation* base,
                                             HSVAnalyticPixel* p,
                                             HSVAnalyticPixel* result)
{
	RGBTransformation * self;
	RGBAnalyticPixel _tmp0_ = {0};
	RGBAnalyticPixel _tmp1_ = {0};
	HSVAnalyticPixel _tmp2_ = {0};
#line 563 "../src/ColorTransformation.vala"
	self = (RGBTransformation*) base;
#line 563 "../src/ColorTransformation.vala"
	g_return_if_fail (p != NULL);
#line 564 "../src/ColorTransformation.vala"
	hsv_analytic_pixel_to_rgb (p, &_tmp0_);
#line 564 "../src/ColorTransformation.vala"
	pixel_transformation_transform_pixel_rgb ((PixelTransformation*) self, &_tmp0_, &_tmp1_);
#line 564 "../src/ColorTransformation.vala"
	rgb_analytic_pixel_to_hsv (&_tmp1_, &_tmp2_);
#line 564 "../src/ColorTransformation.vala"
	*result = _tmp2_;
#line 564 "../src/ColorTransformation.vala"
	return;
#line 4351 "ColorTransformation.c"
}

static void
rgb_transformation_real_transform_pixel_rgb (PixelTransformation* base,
                                             RGBAnalyticPixel* p,
                                             RGBAnalyticPixel* result)
{
	RGBTransformation * self;
	gfloat red_out = 0.0F;
	RGBAnalyticPixel _tmp0_;
	gfloat* _tmp1_;
	gint _tmp1__length1;
	gfloat _tmp2_;
	RGBAnalyticPixel _tmp3_;
	gfloat* _tmp4_;
	gint _tmp4__length1;
	gfloat _tmp5_;
	RGBAnalyticPixel _tmp6_;
	gfloat* _tmp7_;
	gint _tmp7__length1;
	gfloat _tmp8_;
	gfloat* _tmp9_;
	gint _tmp9__length1;
	gfloat _tmp10_;
	gfloat green_out = 0.0F;
	RGBAnalyticPixel _tmp11_;
	gfloat* _tmp12_;
	gint _tmp12__length1;
	gfloat _tmp13_;
	RGBAnalyticPixel _tmp14_;
	gfloat* _tmp15_;
	gint _tmp15__length1;
	gfloat _tmp16_;
	RGBAnalyticPixel _tmp17_;
	gfloat* _tmp18_;
	gint _tmp18__length1;
	gfloat _tmp19_;
	gfloat* _tmp20_;
	gint _tmp20__length1;
	gfloat _tmp21_;
	gfloat blue_out = 0.0F;
	RGBAnalyticPixel _tmp22_;
	gfloat* _tmp23_;
	gint _tmp23__length1;
	gfloat _tmp24_;
	RGBAnalyticPixel _tmp25_;
	gfloat* _tmp26_;
	gint _tmp26__length1;
	gfloat _tmp27_;
	RGBAnalyticPixel _tmp28_;
	gfloat* _tmp29_;
	gint _tmp29__length1;
	gfloat _tmp30_;
	gfloat* _tmp31_;
	gint _tmp31__length1;
	gfloat _tmp32_;
	RGBAnalyticPixel _tmp33_ = {0};
#line 567 "../src/ColorTransformation.vala"
	self = (RGBTransformation*) base;
#line 567 "../src/ColorTransformation.vala"
	g_return_if_fail (p != NULL);
#line 568 "../src/ColorTransformation.vala"
	_tmp0_ = *p;
#line 568 "../src/ColorTransformation.vala"
	_tmp1_ = self->matrix_entries;
#line 568 "../src/ColorTransformation.vala"
	_tmp1__length1 = self->matrix_entries_length1;
#line 568 "../src/ColorTransformation.vala"
	_tmp2_ = _tmp1_[0];
#line 568 "../src/ColorTransformation.vala"
	_tmp3_ = *p;
#line 568 "../src/ColorTransformation.vala"
	_tmp4_ = self->matrix_entries;
#line 568 "../src/ColorTransformation.vala"
	_tmp4__length1 = self->matrix_entries_length1;
#line 568 "../src/ColorTransformation.vala"
	_tmp5_ = _tmp4_[1];
#line 568 "../src/ColorTransformation.vala"
	_tmp6_ = *p;
#line 568 "../src/ColorTransformation.vala"
	_tmp7_ = self->matrix_entries;
#line 568 "../src/ColorTransformation.vala"
	_tmp7__length1 = self->matrix_entries_length1;
#line 568 "../src/ColorTransformation.vala"
	_tmp8_ = _tmp7_[2];
#line 568 "../src/ColorTransformation.vala"
	_tmp9_ = self->matrix_entries;
#line 568 "../src/ColorTransformation.vala"
	_tmp9__length1 = self->matrix_entries_length1;
#line 568 "../src/ColorTransformation.vala"
	_tmp10_ = _tmp9_[3];
#line 568 "../src/ColorTransformation.vala"
	red_out = (((_tmp0_.red * _tmp2_) + (_tmp3_.green * _tmp5_)) + (_tmp6_.blue * _tmp8_)) + _tmp10_;
#line 572 "../src/ColorTransformation.vala"
	red_out = CLAMP (red_out, 0.0f, 1.0f);
#line 574 "../src/ColorTransformation.vala"
	_tmp11_ = *p;
#line 574 "../src/ColorTransformation.vala"
	_tmp12_ = self->matrix_entries;
#line 574 "../src/ColorTransformation.vala"
	_tmp12__length1 = self->matrix_entries_length1;
#line 574 "../src/ColorTransformation.vala"
	_tmp13_ = _tmp12_[4];
#line 574 "../src/ColorTransformation.vala"
	_tmp14_ = *p;
#line 574 "../src/ColorTransformation.vala"
	_tmp15_ = self->matrix_entries;
#line 574 "../src/ColorTransformation.vala"
	_tmp15__length1 = self->matrix_entries_length1;
#line 574 "../src/ColorTransformation.vala"
	_tmp16_ = _tmp15_[5];
#line 574 "../src/ColorTransformation.vala"
	_tmp17_ = *p;
#line 574 "../src/ColorTransformation.vala"
	_tmp18_ = self->matrix_entries;
#line 574 "../src/ColorTransformation.vala"
	_tmp18__length1 = self->matrix_entries_length1;
#line 574 "../src/ColorTransformation.vala"
	_tmp19_ = _tmp18_[6];
#line 574 "../src/ColorTransformation.vala"
	_tmp20_ = self->matrix_entries;
#line 574 "../src/ColorTransformation.vala"
	_tmp20__length1 = self->matrix_entries_length1;
#line 574 "../src/ColorTransformation.vala"
	_tmp21_ = _tmp20_[7];
#line 574 "../src/ColorTransformation.vala"
	green_out = (((_tmp11_.red * _tmp13_) + (_tmp14_.green * _tmp16_)) + (_tmp17_.blue * _tmp19_)) + _tmp21_;
#line 578 "../src/ColorTransformation.vala"
	green_out = CLAMP (green_out, 0.0f, 1.0f);
#line 580 "../src/ColorTransformation.vala"
	_tmp22_ = *p;
#line 580 "../src/ColorTransformation.vala"
	_tmp23_ = self->matrix_entries;
#line 580 "../src/ColorTransformation.vala"
	_tmp23__length1 = self->matrix_entries_length1;
#line 580 "../src/ColorTransformation.vala"
	_tmp24_ = _tmp23_[8];
#line 580 "../src/ColorTransformation.vala"
	_tmp25_ = *p;
#line 580 "../src/ColorTransformation.vala"
	_tmp26_ = self->matrix_entries;
#line 580 "../src/ColorTransformation.vala"
	_tmp26__length1 = self->matrix_entries_length1;
#line 580 "../src/ColorTransformation.vala"
	_tmp27_ = _tmp26_[9];
#line 580 "../src/ColorTransformation.vala"
	_tmp28_ = *p;
#line 580 "../src/ColorTransformation.vala"
	_tmp29_ = self->matrix_entries;
#line 580 "../src/ColorTransformation.vala"
	_tmp29__length1 = self->matrix_entries_length1;
#line 580 "../src/ColorTransformation.vala"
	_tmp30_ = _tmp29_[10];
#line 580 "../src/ColorTransformation.vala"
	_tmp31_ = self->matrix_entries;
#line 580 "../src/ColorTransformation.vala"
	_tmp31__length1 = self->matrix_entries_length1;
#line 580 "../src/ColorTransformation.vala"
	_tmp32_ = _tmp31_[11];
#line 580 "../src/ColorTransformation.vala"
	blue_out = (((_tmp22_.red * _tmp24_) + (_tmp25_.green * _tmp27_)) + (_tmp28_.blue * _tmp30_)) + _tmp32_;
#line 584 "../src/ColorTransformation.vala"
	blue_out = CLAMP (blue_out, 0.0f, 1.0f);
#line 586 "../src/ColorTransformation.vala"
	rgb_analytic_pixel_init_from_components (&_tmp33_, red_out, green_out, blue_out);
#line 586 "../src/ColorTransformation.vala"
	*result = _tmp33_;
#line 586 "../src/ColorTransformation.vala"
	return;
#line 4521 "ColorTransformation.c"
}

static gboolean
rgb_transformation_real_is_identity (PixelTransformation* base)
{
	RGBTransformation * self;
	gboolean result;
#line 589 "../src/ColorTransformation.vala"
	self = (RGBTransformation*) base;
#line 590 "../src/ColorTransformation.vala"
	result = self->identity;
#line 590 "../src/ColorTransformation.vala"
	return result;
#line 4535 "ColorTransformation.c"
}

static PixelTransformation*
rgb_transformation_real_copy (PixelTransformation* base)
{
	RGBTransformation * self;
	RGBTransformation* _result_ = NULL;
	RGBTransformation* _tmp0_;
	PixelTransformation* result;
#line 593 "../src/ColorTransformation.vala"
	self = (RGBTransformation*) base;
#line 594 "../src/ColorTransformation.vala"
	_tmp0_ = rgb_transformation_new (pixel_transformation_get_transformation_type ((PixelTransformation*) self));
#line 594 "../src/ColorTransformation.vala"
	_result_ = _tmp0_;
#line 4551 "ColorTransformation.c"
	{
		gint i = 0;
#line 596 "../src/ColorTransformation.vala"
		i = 0;
#line 4556 "ColorTransformation.c"
		{
			gboolean _tmp1_ = FALSE;
#line 596 "../src/ColorTransformation.vala"
			_tmp1_ = TRUE;
#line 596 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 4563 "ColorTransformation.c"
				RGBTransformation* _tmp3_;
				gfloat* _tmp4_;
				gint _tmp4__length1;
				gfloat* _tmp5_;
				gint _tmp5__length1;
				gfloat _tmp6_;
#line 596 "../src/ColorTransformation.vala"
				if (!_tmp1_) {
#line 4572 "ColorTransformation.c"
					gint _tmp2_;
#line 596 "../src/ColorTransformation.vala"
					_tmp2_ = i;
#line 596 "../src/ColorTransformation.vala"
					i = _tmp2_ + 1;
#line 4578 "ColorTransformation.c"
				}
#line 596 "../src/ColorTransformation.vala"
				_tmp1_ = FALSE;
#line 596 "../src/ColorTransformation.vala"
				if (!(i < RGB_TRANSFORMATION_MATRIX_SIZE)) {
#line 596 "../src/ColorTransformation.vala"
					break;
#line 4586 "ColorTransformation.c"
				}
#line 597 "../src/ColorTransformation.vala"
				_tmp3_ = _result_;
#line 597 "../src/ColorTransformation.vala"
				_tmp4_ = _tmp3_->matrix_entries;
#line 597 "../src/ColorTransformation.vala"
				_tmp4__length1 = _tmp3_->matrix_entries_length1;
#line 597 "../src/ColorTransformation.vala"
				_tmp5_ = self->matrix_entries;
#line 597 "../src/ColorTransformation.vala"
				_tmp5__length1 = self->matrix_entries_length1;
#line 597 "../src/ColorTransformation.vala"
				_tmp6_ = _tmp5_[i];
#line 597 "../src/ColorTransformation.vala"
				_tmp4_[i] = _tmp6_;
#line 4602 "ColorTransformation.c"
			}
		}
	}
#line 600 "../src/ColorTransformation.vala"
	result = (PixelTransformation*) _result_;
#line 600 "../src/ColorTransformation.vala"
	return result;
#line 4610 "ColorTransformation.c"
}

static void
rgb_transformation_class_init (RGBTransformationClass * klass,
                               gpointer klass_data)
{
#line 416 "../src/ColorTransformation.vala"
	rgb_transformation_parent_class = g_type_class_peek_parent (klass);
#line 416 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = rgb_transformation_finalize;
#line 416 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->get_preferred_format = (PixelFormat (*) (PixelTransformation*)) rgb_transformation_real_get_preferred_format;
#line 416 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->get_composition_mode = (CompositionMode (*) (PixelTransformation*)) rgb_transformation_real_get_composition_mode;
#line 416 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->compose_with = (void (*) (PixelTransformation*, PixelTransformation*)) rgb_transformation_real_compose_with;
#line 416 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->transform_pixel_hsv = (void (*) (PixelTransformation*, HSVAnalyticPixel*, HSVAnalyticPixel*)) rgb_transformation_real_transform_pixel_hsv;
#line 416 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->transform_pixel_rgb = (void (*) (PixelTransformation*, RGBAnalyticPixel*, RGBAnalyticPixel*)) rgb_transformation_real_transform_pixel_rgb;
#line 416 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->is_identity = (gboolean (*) (PixelTransformation*)) rgb_transformation_real_is_identity;
#line 416 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->copy = (PixelTransformation* (*) (PixelTransformation*)) rgb_transformation_real_copy;
#line 4635 "ColorTransformation.c"
}

static void
rgb_transformation_instance_init (RGBTransformation * self,
                                  gpointer klass)
{
#line 423 "../src/ColorTransformation.vala"
	self->identity = TRUE;
#line 4644 "ColorTransformation.c"
}

static void
rgb_transformation_finalize (PixelTransformation * obj)
{
	RGBTransformation * self;
#line 416 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RGB_TRANSFORMATION, RGBTransformation);
#line 419 "../src/ColorTransformation.vala"
	self->matrix_entries = (g_free (self->matrix_entries), NULL);
#line 416 "../src/ColorTransformation.vala"
	PIXEL_TRANSFORMATION_CLASS (rgb_transformation_parent_class)->finalize (obj);
#line 4657 "ColorTransformation.c"
}

static GType
rgb_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RGBTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rgb_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RGBTransformation), 0, (GInstanceInitFunc) rgb_transformation_instance_init, NULL };
	GType rgb_transformation_type_id;
	rgb_transformation_type_id = g_type_register_static (TYPE_PIXEL_TRANSFORMATION, "RGBTransformation", &g_define_type_info, 0);
	return rgb_transformation_type_id;
}

GType
rgb_transformation_get_type (void)
{
	static volatile gsize rgb_transformation_type_id__once = 0;
	if (g_once_init_enter (&rgb_transformation_type_id__once)) {
		GType rgb_transformation_type_id;
		rgb_transformation_type_id = rgb_transformation_get_type_once ();
		g_once_init_leave (&rgb_transformation_type_id__once, rgb_transformation_type_id);
	}
	return rgb_transformation_type_id__once;
}

HSVTransformation*
hsv_transformation_construct (GType object_type,
                              PixelTransformationType type)
{
	HSVTransformation* self = NULL;
#line 606 "../src/ColorTransformation.vala"
	self = (HSVTransformation*) pixel_transformation_construct (object_type, type);
#line 605 "../src/ColorTransformation.vala"
	return self;
#line 4690 "ColorTransformation.c"
}

static PixelFormat
hsv_transformation_real_get_preferred_format (PixelTransformation* base)
{
	HSVTransformation * self;
	PixelFormat result;
#line 609 "../src/ColorTransformation.vala"
	self = (HSVTransformation*) base;
#line 610 "../src/ColorTransformation.vala"
	result = PIXEL_FORMAT_HSV;
#line 610 "../src/ColorTransformation.vala"
	return result;
#line 4704 "ColorTransformation.c"
}

static void
hsv_transformation_real_transform_pixel_rgb (PixelTransformation* base,
                                             RGBAnalyticPixel* p,
                                             RGBAnalyticPixel* result)
{
	HSVTransformation * self;
	HSVAnalyticPixel _tmp0_ = {0};
	HSVAnalyticPixel _tmp1_ = {0};
	RGBAnalyticPixel _tmp2_ = {0};
#line 613 "../src/ColorTransformation.vala"
	self = (HSVTransformation*) base;
#line 613 "../src/ColorTransformation.vala"
	g_return_if_fail (p != NULL);
#line 614 "../src/ColorTransformation.vala"
	rgb_analytic_pixel_to_hsv (p, &_tmp0_);
#line 614 "../src/ColorTransformation.vala"
	pixel_transformation_transform_pixel_hsv ((PixelTransformation*) self, &_tmp0_, &_tmp1_);
#line 614 "../src/ColorTransformation.vala"
	hsv_analytic_pixel_to_rgb (&_tmp1_, &_tmp2_);
#line 614 "../src/ColorTransformation.vala"
	*result = _tmp2_;
#line 614 "../src/ColorTransformation.vala"
	return;
#line 4730 "ColorTransformation.c"
}

static void
hsv_transformation_class_init (HSVTransformationClass * klass,
                               gpointer klass_data)
{
#line 604 "../src/ColorTransformation.vala"
	hsv_transformation_parent_class = g_type_class_peek_parent (klass);
#line 604 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->get_preferred_format = (PixelFormat (*) (PixelTransformation*)) hsv_transformation_real_get_preferred_format;
#line 604 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->transform_pixel_rgb = (void (*) (PixelTransformation*, RGBAnalyticPixel*, RGBAnalyticPixel*)) hsv_transformation_real_transform_pixel_rgb;
#line 4743 "ColorTransformation.c"
}

static void
hsv_transformation_instance_init (HSVTransformation * self,
                                  gpointer klass)
{
}

static GType
hsv_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HSVTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hsv_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HSVTransformation), 0, (GInstanceInitFunc) hsv_transformation_instance_init, NULL };
	GType hsv_transformation_type_id;
	hsv_transformation_type_id = g_type_register_static (TYPE_PIXEL_TRANSFORMATION, "HSVTransformation", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return hsv_transformation_type_id;
}

GType
hsv_transformation_get_type (void)
{
	static volatile gsize hsv_transformation_type_id__once = 0;
	if (g_once_init_enter (&hsv_transformation_type_id__once)) {
		GType hsv_transformation_type_id;
		hsv_transformation_type_id = hsv_transformation_get_type_once ();
		g_once_init_leave (&hsv_transformation_type_id__once, hsv_transformation_type_id);
	}
	return hsv_transformation_type_id__once;
}

static inline gpointer
tint_transformation_get_instance_private (TintTransformation* self)
{
	return G_STRUCT_MEMBER_P (self, TintTransformation_private_offset);
}

TintTransformation*
tint_transformation_construct (GType object_type,
                               gfloat client_param)
{
	TintTransformation* self = NULL;
#line 626 "../src/ColorTransformation.vala"
	self = (TintTransformation*) rgb_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_TINT);
#line 628 "../src/ColorTransformation.vala"
	self->priv->parameter = CLAMP (client_param, TINT_TRANSFORMATION_MIN_PARAMETER, TINT_TRANSFORMATION_MAX_PARAMETER);
#line 630 "../src/ColorTransformation.vala"
	if (self->priv->parameter != 0.0f) {
#line 4790 "ColorTransformation.c"
		gfloat adjusted_param = 0.0F;
		gfloat* _tmp0_;
		gint _tmp0__length1;
		gfloat* _tmp1_;
		gint _tmp1__length1;
		gfloat* _tmp2_;
		gint _tmp2__length1;
#line 631 "../src/ColorTransformation.vala"
		adjusted_param = self->priv->parameter / TINT_TRANSFORMATION_MAX_PARAMETER;
#line 632 "../src/ColorTransformation.vala"
		adjusted_param *= TINT_TRANSFORMATION_INTENSITY_FACTOR;
#line 634 "../src/ColorTransformation.vala"
		_tmp0_ = ((RGBTransformation*) self)->matrix_entries;
#line 634 "../src/ColorTransformation.vala"
		_tmp0__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 634 "../src/ColorTransformation.vala"
		_tmp0_[11] -= adjusted_param / 2;
#line 635 "../src/ColorTransformation.vala"
		_tmp1_ = ((RGBTransformation*) self)->matrix_entries;
#line 635 "../src/ColorTransformation.vala"
		_tmp1__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 635 "../src/ColorTransformation.vala"
		_tmp1_[7] += adjusted_param;
#line 636 "../src/ColorTransformation.vala"
		_tmp2_ = ((RGBTransformation*) self)->matrix_entries;
#line 636 "../src/ColorTransformation.vala"
		_tmp2__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 636 "../src/ColorTransformation.vala"
		_tmp2_[3] -= adjusted_param / 2;
#line 638 "../src/ColorTransformation.vala"
		((RGBTransformation*) self)->identity = FALSE;
#line 4822 "ColorTransformation.c"
	}
#line 625 "../src/ColorTransformation.vala"
	return self;
#line 4826 "ColorTransformation.c"
}

TintTransformation*
tint_transformation_new (gfloat client_param)
{
#line 625 "../src/ColorTransformation.vala"
	return tint_transformation_construct (TYPE_TINT_TRANSFORMATION, client_param);
#line 4834 "ColorTransformation.c"
}

gfloat
tint_transformation_get_parameter (TintTransformation* self)
{
	gfloat result;
#line 642 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 643 "../src/ColorTransformation.vala"
	result = self->priv->parameter;
#line 643 "../src/ColorTransformation.vala"
	return result;
#line 4847 "ColorTransformation.c"
}

static void
tint_transformation_class_init (TintTransformationClass * klass,
                                gpointer klass_data)
{
#line 618 "../src/ColorTransformation.vala"
	tint_transformation_parent_class = g_type_class_peek_parent (klass);
#line 618 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = tint_transformation_finalize;
#line 618 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &TintTransformation_private_offset);
#line 4860 "ColorTransformation.c"
}

static void
tint_transformation_instance_init (TintTransformation * self,
                                   gpointer klass)
{
#line 618 "../src/ColorTransformation.vala"
	self->priv = tint_transformation_get_instance_private (self);
#line 4869 "ColorTransformation.c"
}

static void
tint_transformation_finalize (PixelTransformation * obj)
{
	TintTransformation * self;
#line 618 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TINT_TRANSFORMATION, TintTransformation);
#line 618 "../src/ColorTransformation.vala"
	PIXEL_TRANSFORMATION_CLASS (tint_transformation_parent_class)->finalize (obj);
#line 4880 "ColorTransformation.c"
}

static GType
tint_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TintTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tint_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TintTransformation), 0, (GInstanceInitFunc) tint_transformation_instance_init, NULL };
	GType tint_transformation_type_id;
	tint_transformation_type_id = g_type_register_static (TYPE_RGB_TRANSFORMATION, "TintTransformation", &g_define_type_info, 0);
	TintTransformation_private_offset = g_type_add_instance_private (tint_transformation_type_id, sizeof (TintTransformationPrivate));
	return tint_transformation_type_id;
}

GType
tint_transformation_get_type (void)
{
	static volatile gsize tint_transformation_type_id__once = 0;
	if (g_once_init_enter (&tint_transformation_type_id__once)) {
		GType tint_transformation_type_id;
		tint_transformation_type_id = tint_transformation_get_type_once ();
		g_once_init_leave (&tint_transformation_type_id__once, tint_transformation_type_id);
	}
	return tint_transformation_type_id__once;
}

static inline gpointer
temperature_transformation_get_instance_private (TemperatureTransformation* self)
{
	return G_STRUCT_MEMBER_P (self, TemperatureTransformation_private_offset);
}

TemperatureTransformation*
temperature_transformation_construct (GType object_type,
                                      gfloat client_parameter)
{
	TemperatureTransformation* self = NULL;
#line 655 "../src/ColorTransformation.vala"
	self = (TemperatureTransformation*) rgb_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_TEMPERATURE);
#line 657 "../src/ColorTransformation.vala"
	self->priv->parameter = CLAMP (client_parameter, TEMPERATURE_TRANSFORMATION_MIN_PARAMETER, TEMPERATURE_TRANSFORMATION_MAX_PARAMETER);
#line 659 "../src/ColorTransformation.vala"
	if (self->priv->parameter != 0.0f) {
#line 4922 "ColorTransformation.c"
		gfloat adjusted_param = 0.0F;
		gfloat* _tmp0_;
		gint _tmp0__length1;
		gfloat* _tmp1_;
		gint _tmp1__length1;
		gfloat* _tmp2_;
		gint _tmp2__length1;
#line 660 "../src/ColorTransformation.vala"
		adjusted_param = self->priv->parameter / TEMPERATURE_TRANSFORMATION_MAX_PARAMETER;
#line 661 "../src/ColorTransformation.vala"
		adjusted_param *= TEMPERATURE_TRANSFORMATION_INTENSITY_FACTOR;
#line 663 "../src/ColorTransformation.vala"
		_tmp0_ = ((RGBTransformation*) self)->matrix_entries;
#line 663 "../src/ColorTransformation.vala"
		_tmp0__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 663 "../src/ColorTransformation.vala"
		_tmp0_[11] -= adjusted_param;
#line 664 "../src/ColorTransformation.vala"
		_tmp1_ = ((RGBTransformation*) self)->matrix_entries;
#line 664 "../src/ColorTransformation.vala"
		_tmp1__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 664 "../src/ColorTransformation.vala"
		_tmp1_[7] += adjusted_param / 2;
#line 665 "../src/ColorTransformation.vala"
		_tmp2_ = ((RGBTransformation*) self)->matrix_entries;
#line 665 "../src/ColorTransformation.vala"
		_tmp2__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 665 "../src/ColorTransformation.vala"
		_tmp2_[3] += adjusted_param / 2;
#line 667 "../src/ColorTransformation.vala"
		((RGBTransformation*) self)->identity = FALSE;
#line 4954 "ColorTransformation.c"
	}
#line 654 "../src/ColorTransformation.vala"
	return self;
#line 4958 "ColorTransformation.c"
}

TemperatureTransformation*
temperature_transformation_new (gfloat client_parameter)
{
#line 654 "../src/ColorTransformation.vala"
	return temperature_transformation_construct (TYPE_TEMPERATURE_TRANSFORMATION, client_parameter);
#line 4966 "ColorTransformation.c"
}

gfloat
temperature_transformation_get_parameter (TemperatureTransformation* self)
{
	gfloat result;
#line 671 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 672 "../src/ColorTransformation.vala"
	result = self->priv->parameter;
#line 672 "../src/ColorTransformation.vala"
	return result;
#line 4979 "ColorTransformation.c"
}

static void
temperature_transformation_class_init (TemperatureTransformationClass * klass,
                                       gpointer klass_data)
{
#line 647 "../src/ColorTransformation.vala"
	temperature_transformation_parent_class = g_type_class_peek_parent (klass);
#line 647 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = temperature_transformation_finalize;
#line 647 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &TemperatureTransformation_private_offset);
#line 4992 "ColorTransformation.c"
}

static void
temperature_transformation_instance_init (TemperatureTransformation * self,
                                          gpointer klass)
{
#line 647 "../src/ColorTransformation.vala"
	self->priv = temperature_transformation_get_instance_private (self);
#line 5001 "ColorTransformation.c"
}

static void
temperature_transformation_finalize (PixelTransformation * obj)
{
	TemperatureTransformation * self;
#line 647 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEMPERATURE_TRANSFORMATION, TemperatureTransformation);
#line 647 "../src/ColorTransformation.vala"
	PIXEL_TRANSFORMATION_CLASS (temperature_transformation_parent_class)->finalize (obj);
#line 5012 "ColorTransformation.c"
}

static GType
temperature_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TemperatureTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) temperature_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TemperatureTransformation), 0, (GInstanceInitFunc) temperature_transformation_instance_init, NULL };
	GType temperature_transformation_type_id;
	temperature_transformation_type_id = g_type_register_static (TYPE_RGB_TRANSFORMATION, "TemperatureTransformation", &g_define_type_info, 0);
	TemperatureTransformation_private_offset = g_type_add_instance_private (temperature_transformation_type_id, sizeof (TemperatureTransformationPrivate));
	return temperature_transformation_type_id;
}

GType
temperature_transformation_get_type (void)
{
	static volatile gsize temperature_transformation_type_id__once = 0;
	if (g_once_init_enter (&temperature_transformation_type_id__once)) {
		GType temperature_transformation_type_id;
		temperature_transformation_type_id = temperature_transformation_get_type_once ();
		g_once_init_leave (&temperature_transformation_type_id__once, temperature_transformation_type_id);
	}
	return temperature_transformation_type_id__once;
}

static inline gpointer
saturation_transformation_get_instance_private (SaturationTransformation* self)
{
	return G_STRUCT_MEMBER_P (self, SaturationTransformation_private_offset);
}

SaturationTransformation*
saturation_transformation_construct (GType object_type,
                                     gfloat client_parameter)
{
	SaturationTransformation* self = NULL;
#line 683 "../src/ColorTransformation.vala"
	self = (SaturationTransformation*) rgb_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_SATURATION);
#line 685 "../src/ColorTransformation.vala"
	self->priv->parameter = CLAMP (client_parameter, SATURATION_TRANSFORMATION_MIN_PARAMETER, SATURATION_TRANSFORMATION_MAX_PARAMETER);
#line 687 "../src/ColorTransformation.vala"
	if (self->priv->parameter != 0.0f) {
#line 5054 "ColorTransformation.c"
		gfloat adjusted_param = 0.0F;
		gfloat one_third = 0.0F;
		gfloat* _tmp0_;
		gint _tmp0__length1;
		gfloat* _tmp1_;
		gint _tmp1__length1;
		gfloat* _tmp2_;
		gint _tmp2__length1;
		gfloat* _tmp3_;
		gint _tmp3__length1;
		gfloat* _tmp4_;
		gint _tmp4__length1;
		gfloat* _tmp5_;
		gint _tmp5__length1;
		gfloat* _tmp6_;
		gint _tmp6__length1;
		gfloat* _tmp7_;
		gint _tmp7__length1;
		gfloat* _tmp8_;
		gint _tmp8__length1;
#line 688 "../src/ColorTransformation.vala"
		adjusted_param = self->priv->parameter / SATURATION_TRANSFORMATION_MAX_PARAMETER;
#line 689 "../src/ColorTransformation.vala"
		adjusted_param += 1.0f;
#line 691 "../src/ColorTransformation.vala"
		one_third = 0.3333333f;
#line 693 "../src/ColorTransformation.vala"
		_tmp0_ = ((RGBTransformation*) self)->matrix_entries;
#line 693 "../src/ColorTransformation.vala"
		_tmp0__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 693 "../src/ColorTransformation.vala"
		_tmp0_[0] = ((1.0f - adjusted_param) * one_third) + adjusted_param;
#line 695 "../src/ColorTransformation.vala"
		_tmp1_ = ((RGBTransformation*) self)->matrix_entries;
#line 695 "../src/ColorTransformation.vala"
		_tmp1__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 695 "../src/ColorTransformation.vala"
		_tmp1_[1] = (1.0f - adjusted_param) * one_third;
#line 696 "../src/ColorTransformation.vala"
		_tmp2_ = ((RGBTransformation*) self)->matrix_entries;
#line 696 "../src/ColorTransformation.vala"
		_tmp2__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 696 "../src/ColorTransformation.vala"
		_tmp2_[2] = (1.0f - adjusted_param) * one_third;
#line 698 "../src/ColorTransformation.vala"
		_tmp3_ = ((RGBTransformation*) self)->matrix_entries;
#line 698 "../src/ColorTransformation.vala"
		_tmp3__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 698 "../src/ColorTransformation.vala"
		_tmp3_[4] = (1.0f - adjusted_param) * one_third;
#line 699 "../src/ColorTransformation.vala"
		_tmp4_ = ((RGBTransformation*) self)->matrix_entries;
#line 699 "../src/ColorTransformation.vala"
		_tmp4__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 699 "../src/ColorTransformation.vala"
		_tmp4_[5] = ((1.0f - adjusted_param) * one_third) + adjusted_param;
#line 701 "../src/ColorTransformation.vala"
		_tmp5_ = ((RGBTransformation*) self)->matrix_entries;
#line 701 "../src/ColorTransformation.vala"
		_tmp5__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 701 "../src/ColorTransformation.vala"
		_tmp5_[6] = (1.0f - adjusted_param) * one_third;
#line 703 "../src/ColorTransformation.vala"
		_tmp6_ = ((RGBTransformation*) self)->matrix_entries;
#line 703 "../src/ColorTransformation.vala"
		_tmp6__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 703 "../src/ColorTransformation.vala"
		_tmp6_[8] = (1.0f - adjusted_param) * one_third;
#line 704 "../src/ColorTransformation.vala"
		_tmp7_ = ((RGBTransformation*) self)->matrix_entries;
#line 704 "../src/ColorTransformation.vala"
		_tmp7__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 704 "../src/ColorTransformation.vala"
		_tmp7_[9] = (1.0f - adjusted_param) * one_third;
#line 705 "../src/ColorTransformation.vala"
		_tmp8_ = ((RGBTransformation*) self)->matrix_entries;
#line 705 "../src/ColorTransformation.vala"
		_tmp8__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 705 "../src/ColorTransformation.vala"
		_tmp8_[10] = ((1.0f - adjusted_param) * one_third) + adjusted_param;
#line 708 "../src/ColorTransformation.vala"
		((RGBTransformation*) self)->identity = FALSE;
#line 5137 "ColorTransformation.c"
	}
#line 682 "../src/ColorTransformation.vala"
	return self;
#line 5141 "ColorTransformation.c"
}

SaturationTransformation*
saturation_transformation_new (gfloat client_parameter)
{
#line 682 "../src/ColorTransformation.vala"
	return saturation_transformation_construct (TYPE_SATURATION_TRANSFORMATION, client_parameter);
#line 5149 "ColorTransformation.c"
}

gfloat
saturation_transformation_get_parameter (SaturationTransformation* self)
{
	gfloat result;
#line 712 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 713 "../src/ColorTransformation.vala"
	result = self->priv->parameter;
#line 713 "../src/ColorTransformation.vala"
	return result;
#line 5162 "ColorTransformation.c"
}

static void
saturation_transformation_class_init (SaturationTransformationClass * klass,
                                      gpointer klass_data)
{
#line 676 "../src/ColorTransformation.vala"
	saturation_transformation_parent_class = g_type_class_peek_parent (klass);
#line 676 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = saturation_transformation_finalize;
#line 676 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &SaturationTransformation_private_offset);
#line 5175 "ColorTransformation.c"
}

static void
saturation_transformation_instance_init (SaturationTransformation * self,
                                         gpointer klass)
{
#line 676 "../src/ColorTransformation.vala"
	self->priv = saturation_transformation_get_instance_private (self);
#line 5184 "ColorTransformation.c"
}

static void
saturation_transformation_finalize (PixelTransformation * obj)
{
	SaturationTransformation * self;
#line 676 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SATURATION_TRANSFORMATION, SaturationTransformation);
#line 676 "../src/ColorTransformation.vala"
	PIXEL_TRANSFORMATION_CLASS (saturation_transformation_parent_class)->finalize (obj);
#line 5195 "ColorTransformation.c"
}

static GType
saturation_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SaturationTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) saturation_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SaturationTransformation), 0, (GInstanceInitFunc) saturation_transformation_instance_init, NULL };
	GType saturation_transformation_type_id;
	saturation_transformation_type_id = g_type_register_static (TYPE_RGB_TRANSFORMATION, "SaturationTransformation", &g_define_type_info, 0);
	SaturationTransformation_private_offset = g_type_add_instance_private (saturation_transformation_type_id, sizeof (SaturationTransformationPrivate));
	return saturation_transformation_type_id;
}

GType
saturation_transformation_get_type (void)
{
	static volatile gsize saturation_transformation_type_id__once = 0;
	if (g_once_init_enter (&saturation_transformation_type_id__once)) {
		GType saturation_transformation_type_id;
		saturation_transformation_type_id = saturation_transformation_get_type_once ();
		g_once_init_leave (&saturation_transformation_type_id__once, saturation_transformation_type_id);
	}
	return saturation_transformation_type_id__once;
}

static inline gpointer
exposure_transformation_get_instance_private (ExposureTransformation* self)
{
	return G_STRUCT_MEMBER_P (self, ExposureTransformation_private_offset);
}

ExposureTransformation*
exposure_transformation_construct (GType object_type,
                                   gfloat client_parameter)
{
	ExposureTransformation* self = NULL;
#line 724 "../src/ColorTransformation.vala"
	self = (ExposureTransformation*) rgb_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_EXPOSURE);
#line 726 "../src/ColorTransformation.vala"
	self->priv->parameter = CLAMP (client_parameter, EXPOSURE_TRANSFORMATION_MIN_PARAMETER, EXPOSURE_TRANSFORMATION_MAX_PARAMETER);
#line 728 "../src/ColorTransformation.vala"
	if (self->priv->parameter != 0.0f) {
#line 5237 "ColorTransformation.c"
		gfloat adjusted_param = 0.0F;
		gfloat* _tmp0_;
		gint _tmp0__length1;
		gfloat* _tmp1_;
		gint _tmp1__length1;
		gfloat* _tmp2_;
		gint _tmp2__length1;
#line 730 "../src/ColorTransformation.vala"
		adjusted_param = ((self->priv->parameter + 16.0f) / 32.0f) + 0.5f;
#line 732 "../src/ColorTransformation.vala"
		_tmp0_ = ((RGBTransformation*) self)->matrix_entries;
#line 732 "../src/ColorTransformation.vala"
		_tmp0__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 732 "../src/ColorTransformation.vala"
		_tmp0_[0] = adjusted_param;
#line 733 "../src/ColorTransformation.vala"
		_tmp1_ = ((RGBTransformation*) self)->matrix_entries;
#line 733 "../src/ColorTransformation.vala"
		_tmp1__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 733 "../src/ColorTransformation.vala"
		_tmp1_[5] = adjusted_param;
#line 734 "../src/ColorTransformation.vala"
		_tmp2_ = ((RGBTransformation*) self)->matrix_entries;
#line 734 "../src/ColorTransformation.vala"
		_tmp2__length1 = ((RGBTransformation*) self)->matrix_entries_length1;
#line 734 "../src/ColorTransformation.vala"
		_tmp2_[10] = adjusted_param;
#line 736 "../src/ColorTransformation.vala"
		((RGBTransformation*) self)->identity = FALSE;
#line 5267 "ColorTransformation.c"
	}
#line 723 "../src/ColorTransformation.vala"
	return self;
#line 5271 "ColorTransformation.c"
}

ExposureTransformation*
exposure_transformation_new (gfloat client_parameter)
{
#line 723 "../src/ColorTransformation.vala"
	return exposure_transformation_construct (TYPE_EXPOSURE_TRANSFORMATION, client_parameter);
#line 5279 "ColorTransformation.c"
}

gfloat
exposure_transformation_get_parameter (ExposureTransformation* self)
{
	gfloat result;
#line 740 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 741 "../src/ColorTransformation.vala"
	result = self->priv->parameter;
#line 741 "../src/ColorTransformation.vala"
	return result;
#line 5292 "ColorTransformation.c"
}

static void
exposure_transformation_class_init (ExposureTransformationClass * klass,
                                    gpointer klass_data)
{
#line 717 "../src/ColorTransformation.vala"
	exposure_transformation_parent_class = g_type_class_peek_parent (klass);
#line 717 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = exposure_transformation_finalize;
#line 717 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &ExposureTransformation_private_offset);
#line 5305 "ColorTransformation.c"
}

static void
exposure_transformation_instance_init (ExposureTransformation * self,
                                       gpointer klass)
{
#line 717 "../src/ColorTransformation.vala"
	self->priv = exposure_transformation_get_instance_private (self);
#line 5314 "ColorTransformation.c"
}

static void
exposure_transformation_finalize (PixelTransformation * obj)
{
	ExposureTransformation * self;
#line 717 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPOSURE_TRANSFORMATION, ExposureTransformation);
#line 717 "../src/ColorTransformation.vala"
	PIXEL_TRANSFORMATION_CLASS (exposure_transformation_parent_class)->finalize (obj);
#line 5325 "ColorTransformation.c"
}

static GType
exposure_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExposureTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) exposure_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExposureTransformation), 0, (GInstanceInitFunc) exposure_transformation_instance_init, NULL };
	GType exposure_transformation_type_id;
	exposure_transformation_type_id = g_type_register_static (TYPE_RGB_TRANSFORMATION, "ExposureTransformation", &g_define_type_info, 0);
	ExposureTransformation_private_offset = g_type_add_instance_private (exposure_transformation_type_id, sizeof (ExposureTransformationPrivate));
	return exposure_transformation_type_id;
}

GType
exposure_transformation_get_type (void)
{
	static volatile gsize exposure_transformation_type_id__once = 0;
	if (g_once_init_enter (&exposure_transformation_type_id__once)) {
		GType exposure_transformation_type_id;
		exposure_transformation_type_id = exposure_transformation_get_type_once ();
		g_once_init_leave (&exposure_transformation_type_id__once, exposure_transformation_type_id);
	}
	return exposure_transformation_type_id__once;
}

static inline gpointer
pixel_transformer_get_instance_private (PixelTransformer* self)
{
	return G_STRUCT_MEMBER_P (self, PixelTransformer_private_offset);
}

PixelTransformer*
pixel_transformer_construct (GType object_type)
{
	PixelTransformer* self = NULL;
#line 751 "../src/ColorTransformation.vala"
	self = (PixelTransformer*) g_type_create_instance (object_type);
#line 751 "../src/ColorTransformation.vala"
	return self;
#line 5364 "ColorTransformation.c"
}

PixelTransformer*
pixel_transformer_new (void)
{
#line 751 "../src/ColorTransformation.vala"
	return pixel_transformer_construct (TYPE_PIXEL_TRANSFORMER);
#line 5372 "ColorTransformation.c"
}

PixelTransformer*
pixel_transformer_copy (PixelTransformer* self)
{
	PixelTransformer* clone = NULL;
	PixelTransformer* _tmp0_;
	PixelTransformer* result;
#line 754 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 755 "../src/ColorTransformation.vala"
	_tmp0_ = pixel_transformer_new ();
#line 755 "../src/ColorTransformation.vala"
	clone = _tmp0_;
#line 5387 "ColorTransformation.c"
	{
		GeeArrayList* _transformation_list = NULL;
		GeeArrayList* _tmp1_;
		gint _transformation_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _transformation_index = 0;
#line 757 "../src/ColorTransformation.vala"
		_tmp1_ = self->priv->transformations;
#line 757 "../src/ColorTransformation.vala"
		_transformation_list = _tmp1_;
#line 757 "../src/ColorTransformation.vala"
		_tmp2_ = _transformation_list;
#line 757 "../src/ColorTransformation.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 757 "../src/ColorTransformation.vala"
		_tmp4_ = _tmp3_;
#line 757 "../src/ColorTransformation.vala"
		_transformation_size = _tmp4_;
#line 757 "../src/ColorTransformation.vala"
		_transformation_index = -1;
#line 757 "../src/ColorTransformation.vala"
		while (TRUE) {
#line 5412 "ColorTransformation.c"
			gint _tmp5_;
			gint _tmp6_;
			PixelTransformation* transformation = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			PixelTransformer* _tmp9_;
			GeeArrayList* _tmp10_;
			PixelTransformation* _tmp11_;
#line 757 "../src/ColorTransformation.vala"
			_transformation_index = _transformation_index + 1;
#line 757 "../src/ColorTransformation.vala"
			_tmp5_ = _transformation_index;
#line 757 "../src/ColorTransformation.vala"
			_tmp6_ = _transformation_size;
#line 757 "../src/ColorTransformation.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 757 "../src/ColorTransformation.vala"
				break;
#line 5431 "ColorTransformation.c"
			}
#line 757 "../src/ColorTransformation.vala"
			_tmp7_ = _transformation_list;
#line 757 "../src/ColorTransformation.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _transformation_index);
#line 757 "../src/ColorTransformation.vala"
			transformation = (PixelTransformation*) _tmp8_;
#line 758 "../src/ColorTransformation.vala"
			_tmp9_ = clone;
#line 758 "../src/ColorTransformation.vala"
			_tmp10_ = _tmp9_->priv->transformations;
#line 758 "../src/ColorTransformation.vala"
			_tmp11_ = transformation;
#line 758 "../src/ColorTransformation.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 757 "../src/ColorTransformation.vala"
			_pixel_transformation_unref0 (transformation);
#line 5449 "ColorTransformation.c"
		}
	}
#line 760 "../src/ColorTransformation.vala"
	result = clone;
#line 760 "../src/ColorTransformation.vala"
	return result;
#line 5456 "ColorTransformation.c"
}

static void
pixel_transformer_build_optimized_transformations (PixelTransformer* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	PixelTransformation** _tmp3_;
	PixelTransformation* pre_trans = NULL;
#line 763 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 764 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->transformations;
#line 764 "../src/ColorTransformation.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 764 "../src/ColorTransformation.vala"
	_tmp2_ = _tmp1_;
#line 764 "../src/ColorTransformation.vala"
	_tmp3_ = g_new0 (PixelTransformation*, _tmp2_ + 1);
#line 764 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations = (_vala_array_free (self->priv->optimized_transformations, self->priv->optimized_transformations_length1, (GDestroyNotify) pixel_transformation_unref), NULL);
#line 764 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations = _tmp3_;
#line 764 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations_length1 = _tmp2_;
#line 764 "../src/ColorTransformation.vala"
	self->priv->_optimized_transformations_size_ = self->priv->optimized_transformations_length1;
#line 766 "../src/ColorTransformation.vala"
	pre_trans = NULL;
#line 767 "../src/ColorTransformation.vala"
	self->priv->optimized_slots_used = 0;
#line 5489 "ColorTransformation.c"
	{
		gint i = 0;
#line 768 "../src/ColorTransformation.vala"
		i = 0;
#line 5494 "ColorTransformation.c"
		{
			gboolean _tmp4_ = FALSE;
#line 768 "../src/ColorTransformation.vala"
			_tmp4_ = TRUE;
#line 768 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 5501 "ColorTransformation.c"
				GeeArrayList* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				PixelTransformation* trans = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				PixelTransformation* _tmp11_;
				PixelTransformation* this_trans = NULL;
				PixelTransformation* _tmp12_;
				gboolean _tmp17_ = FALSE;
				gboolean _tmp18_ = FALSE;
				PixelTransformation* _tmp19_;
#line 768 "../src/ColorTransformation.vala"
				if (!_tmp4_) {
#line 5516 "ColorTransformation.c"
					gint _tmp5_;
#line 768 "../src/ColorTransformation.vala"
					_tmp5_ = i;
#line 768 "../src/ColorTransformation.vala"
					i = _tmp5_ + 1;
#line 5522 "ColorTransformation.c"
				}
#line 768 "../src/ColorTransformation.vala"
				_tmp4_ = FALSE;
#line 768 "../src/ColorTransformation.vala"
				_tmp6_ = self->priv->transformations;
#line 768 "../src/ColorTransformation.vala"
				_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 768 "../src/ColorTransformation.vala"
				_tmp8_ = _tmp7_;
#line 768 "../src/ColorTransformation.vala"
				if (!(i < _tmp8_)) {
#line 768 "../src/ColorTransformation.vala"
					break;
#line 5536 "ColorTransformation.c"
				}
#line 769 "../src/ColorTransformation.vala"
				_tmp9_ = self->priv->transformations;
#line 769 "../src/ColorTransformation.vala"
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, i);
#line 769 "../src/ColorTransformation.vala"
				trans = (PixelTransformation*) _tmp10_;
#line 771 "../src/ColorTransformation.vala"
				_tmp11_ = trans;
#line 771 "../src/ColorTransformation.vala"
				if (pixel_transformation_is_identity (_tmp11_)) {
#line 772 "../src/ColorTransformation.vala"
					_pixel_transformation_unref0 (trans);
#line 772 "../src/ColorTransformation.vala"
					continue;
#line 5552 "ColorTransformation.c"
				}
#line 774 "../src/ColorTransformation.vala"
				this_trans = NULL;
#line 775 "../src/ColorTransformation.vala"
				_tmp12_ = trans;
#line 775 "../src/ColorTransformation.vala"
				if (pixel_transformation_get_composition_mode (_tmp12_) == COMPOSITION_MODE_NONE) {
#line 5560 "ColorTransformation.c"
					PixelTransformation* _tmp13_;
					PixelTransformation* _tmp14_;
#line 776 "../src/ColorTransformation.vala"
					_tmp13_ = trans;
#line 776 "../src/ColorTransformation.vala"
					_tmp14_ = _pixel_transformation_ref0 (_tmp13_);
#line 776 "../src/ColorTransformation.vala"
					_pixel_transformation_unref0 (this_trans);
#line 776 "../src/ColorTransformation.vala"
					this_trans = _tmp14_;
#line 5571 "ColorTransformation.c"
				} else {
					PixelTransformation* _tmp15_;
					PixelTransformation* _tmp16_;
#line 778 "../src/ColorTransformation.vala"
					_tmp15_ = trans;
#line 778 "../src/ColorTransformation.vala"
					_tmp16_ = pixel_transformation_copy (_tmp15_);
#line 778 "../src/ColorTransformation.vala"
					_pixel_transformation_unref0 (this_trans);
#line 778 "../src/ColorTransformation.vala"
					this_trans = _tmp16_;
#line 5583 "ColorTransformation.c"
				}
#line 780 "../src/ColorTransformation.vala"
				_tmp19_ = pre_trans;
#line 780 "../src/ColorTransformation.vala"
				if (_tmp19_ != NULL) {
#line 5589 "ColorTransformation.c"
					PixelTransformation* _tmp20_;
#line 780 "../src/ColorTransformation.vala"
					_tmp20_ = this_trans;
#line 780 "../src/ColorTransformation.vala"
					_tmp18_ = pixel_transformation_get_composition_mode (_tmp20_) != COMPOSITION_MODE_NONE;
#line 5595 "ColorTransformation.c"
				} else {
#line 780 "../src/ColorTransformation.vala"
					_tmp18_ = FALSE;
#line 5599 "ColorTransformation.c"
				}
#line 780 "../src/ColorTransformation.vala"
				if (_tmp18_) {
#line 5603 "ColorTransformation.c"
					PixelTransformation* _tmp21_;
					PixelTransformation* _tmp22_;
#line 781 "../src/ColorTransformation.vala"
					_tmp21_ = this_trans;
#line 781 "../src/ColorTransformation.vala"
					_tmp22_ = pre_trans;
#line 781 "../src/ColorTransformation.vala"
					_tmp17_ = pixel_transformation_get_composition_mode (_tmp21_) == pixel_transformation_get_composition_mode (_tmp22_);
#line 5612 "ColorTransformation.c"
				} else {
#line 780 "../src/ColorTransformation.vala"
					_tmp17_ = FALSE;
#line 5616 "ColorTransformation.c"
				}
#line 780 "../src/ColorTransformation.vala"
				if (_tmp17_) {
#line 5620 "ColorTransformation.c"
					PixelTransformation* _tmp23_;
					PixelTransformation* _tmp24_;
#line 782 "../src/ColorTransformation.vala"
					_tmp23_ = pre_trans;
#line 782 "../src/ColorTransformation.vala"
					_tmp24_ = this_trans;
#line 782 "../src/ColorTransformation.vala"
					pixel_transformation_compose_with (_tmp23_, _tmp24_);
#line 5629 "ColorTransformation.c"
				} else {
					PixelTransformation** _tmp25_;
					gint _tmp25__length1;
					gint _tmp26_;
					PixelTransformation* _tmp27_;
					PixelTransformation* _tmp28_;
					PixelTransformation* _tmp29_;
					PixelTransformation* _tmp30_;
#line 784 "../src/ColorTransformation.vala"
					_tmp25_ = self->priv->optimized_transformations;
#line 784 "../src/ColorTransformation.vala"
					_tmp25__length1 = self->priv->optimized_transformations_length1;
#line 784 "../src/ColorTransformation.vala"
					_tmp26_ = self->priv->optimized_slots_used;
#line 784 "../src/ColorTransformation.vala"
					self->priv->optimized_slots_used = _tmp26_ + 1;
#line 784 "../src/ColorTransformation.vala"
					_tmp27_ = this_trans;
#line 784 "../src/ColorTransformation.vala"
					_tmp28_ = _pixel_transformation_ref0 (_tmp27_);
#line 784 "../src/ColorTransformation.vala"
					_pixel_transformation_unref0 (_tmp25_[_tmp26_]);
#line 784 "../src/ColorTransformation.vala"
					_tmp25_[_tmp26_] = _tmp28_;
#line 785 "../src/ColorTransformation.vala"
					_tmp29_ = this_trans;
#line 785 "../src/ColorTransformation.vala"
					_tmp30_ = _pixel_transformation_ref0 (_tmp29_);
#line 785 "../src/ColorTransformation.vala"
					_pixel_transformation_unref0 (pre_trans);
#line 785 "../src/ColorTransformation.vala"
					pre_trans = _tmp30_;
#line 5662 "ColorTransformation.c"
				}
#line 768 "../src/ColorTransformation.vala"
				_pixel_transformation_unref0 (this_trans);
#line 768 "../src/ColorTransformation.vala"
				_pixel_transformation_unref0 (trans);
#line 5668 "ColorTransformation.c"
			}
		}
	}
#line 763 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (pre_trans);
#line 5674 "ColorTransformation.c"
}

static void
pixel_transformer_apply_transformations (PixelTransformer* self,
                                         RGBAnalyticPixel* p,
                                         RGBAnalyticPixel* result)
{
	PixelFormat current_format = 0;
	RGBAnalyticPixel p_rgb = {0};
	RGBAnalyticPixel _tmp0_;
	HSVAnalyticPixel p_hsv = {0};
#line 790 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 790 "../src/ColorTransformation.vala"
	g_return_if_fail (p != NULL);
#line 791 "../src/ColorTransformation.vala"
	current_format = PIXEL_FORMAT_RGB;
#line 792 "../src/ColorTransformation.vala"
	_tmp0_ = *p;
#line 792 "../src/ColorTransformation.vala"
	p_rgb = _tmp0_;
#line 793 "../src/ColorTransformation.vala"
	hsv_analytic_pixel_init (&p_hsv);
#line 5698 "ColorTransformation.c"
	{
		gint i = 0;
#line 795 "../src/ColorTransformation.vala"
		i = 0;
#line 5703 "ColorTransformation.c"
		{
			gboolean _tmp1_ = FALSE;
#line 795 "../src/ColorTransformation.vala"
			_tmp1_ = TRUE;
#line 795 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 5710 "ColorTransformation.c"
				PixelTransformation* trans = NULL;
				PixelTransformation** _tmp3_;
				gint _tmp3__length1;
				PixelTransformation* _tmp4_;
				PixelTransformation* _tmp5_;
				PixelTransformation* _tmp6_;
#line 795 "../src/ColorTransformation.vala"
				if (!_tmp1_) {
#line 5719 "ColorTransformation.c"
					gint _tmp2_;
#line 795 "../src/ColorTransformation.vala"
					_tmp2_ = i;
#line 795 "../src/ColorTransformation.vala"
					i = _tmp2_ + 1;
#line 5725 "ColorTransformation.c"
				}
#line 795 "../src/ColorTransformation.vala"
				_tmp1_ = FALSE;
#line 795 "../src/ColorTransformation.vala"
				if (!(i < self->priv->optimized_slots_used)) {
#line 795 "../src/ColorTransformation.vala"
					break;
#line 5733 "ColorTransformation.c"
				}
#line 796 "../src/ColorTransformation.vala"
				_tmp3_ = self->priv->optimized_transformations;
#line 796 "../src/ColorTransformation.vala"
				_tmp3__length1 = self->priv->optimized_transformations_length1;
#line 796 "../src/ColorTransformation.vala"
				_tmp4_ = _tmp3_[i];
#line 796 "../src/ColorTransformation.vala"
				_tmp5_ = _pixel_transformation_ref0 (_tmp4_);
#line 796 "../src/ColorTransformation.vala"
				trans = _tmp5_;
#line 797 "../src/ColorTransformation.vala"
				_tmp6_ = trans;
#line 797 "../src/ColorTransformation.vala"
				if (pixel_transformation_get_preferred_format (_tmp6_) == PIXEL_FORMAT_RGB) {
#line 5749 "ColorTransformation.c"
					PixelTransformation* _tmp8_;
					RGBAnalyticPixel _tmp9_;
					RGBAnalyticPixel _tmp10_ = {0};
#line 798 "../src/ColorTransformation.vala"
					if (current_format == PIXEL_FORMAT_HSV) {
#line 5755 "ColorTransformation.c"
						RGBAnalyticPixel _tmp7_ = {0};
#line 799 "../src/ColorTransformation.vala"
						hsv_analytic_pixel_to_rgb (&p_hsv, &_tmp7_);
#line 799 "../src/ColorTransformation.vala"
						p_rgb = _tmp7_;
#line 800 "../src/ColorTransformation.vala"
						current_format = PIXEL_FORMAT_RGB;
#line 5763 "ColorTransformation.c"
					}
#line 802 "../src/ColorTransformation.vala"
					_tmp8_ = trans;
#line 802 "../src/ColorTransformation.vala"
					_tmp9_ = p_rgb;
#line 802 "../src/ColorTransformation.vala"
					pixel_transformation_transform_pixel_rgb (_tmp8_, &_tmp9_, &_tmp10_);
#line 802 "../src/ColorTransformation.vala"
					p_rgb = _tmp10_;
#line 5773 "ColorTransformation.c"
				} else {
					PixelTransformation* _tmp12_;
					HSVAnalyticPixel _tmp13_;
					HSVAnalyticPixel _tmp14_ = {0};
#line 804 "../src/ColorTransformation.vala"
					if (current_format == PIXEL_FORMAT_RGB) {
#line 5780 "ColorTransformation.c"
						HSVAnalyticPixel _tmp11_ = {0};
#line 805 "../src/ColorTransformation.vala"
						rgb_analytic_pixel_to_hsv (&p_rgb, &_tmp11_);
#line 805 "../src/ColorTransformation.vala"
						p_hsv = _tmp11_;
#line 806 "../src/ColorTransformation.vala"
						current_format = PIXEL_FORMAT_HSV;
#line 5788 "ColorTransformation.c"
					}
#line 808 "../src/ColorTransformation.vala"
					_tmp12_ = trans;
#line 808 "../src/ColorTransformation.vala"
					_tmp13_ = p_hsv;
#line 808 "../src/ColorTransformation.vala"
					pixel_transformation_transform_pixel_hsv (_tmp12_, &_tmp13_, &_tmp14_);
#line 808 "../src/ColorTransformation.vala"
					p_hsv = _tmp14_;
#line 5798 "ColorTransformation.c"
				}
#line 795 "../src/ColorTransformation.vala"
				_pixel_transformation_unref0 (trans);
#line 5802 "ColorTransformation.c"
			}
		}
	}
#line 812 "../src/ColorTransformation.vala"
	if (current_format == PIXEL_FORMAT_HSV) {
#line 5808 "ColorTransformation.c"
		RGBAnalyticPixel _tmp15_ = {0};
#line 813 "../src/ColorTransformation.vala"
		hsv_analytic_pixel_to_rgb (&p_hsv, &_tmp15_);
#line 813 "../src/ColorTransformation.vala"
		p_rgb = _tmp15_;
#line 5814 "ColorTransformation.c"
	}
#line 815 "../src/ColorTransformation.vala"
	*result = p_rgb;
#line 815 "../src/ColorTransformation.vala"
	return;
#line 5820 "ColorTransformation.c"
}

void
pixel_transformer_attach_transformation (PixelTransformer* self,
                                         PixelTransformation* trans)
{
	GeeArrayList* _tmp0_;
#line 821 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 821 "../src/ColorTransformation.vala"
	g_return_if_fail (trans != NULL);
#line 822 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->transformations;
#line 822 "../src/ColorTransformation.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, trans);
#line 823 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations = (_vala_array_free (self->priv->optimized_transformations, self->priv->optimized_transformations_length1, (GDestroyNotify) pixel_transformation_unref), NULL);
#line 823 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations = NULL;
#line 823 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations_length1 = 0;
#line 823 "../src/ColorTransformation.vala"
	self->priv->_optimized_transformations_size_ = self->priv->optimized_transformations_length1;
#line 5844 "ColorTransformation.c"
}

void
pixel_transformer_detach_transformation (PixelTransformer* self,
                                         PixelTransformation* victim)
{
	GeeArrayList* _tmp0_;
#line 828 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 828 "../src/ColorTransformation.vala"
	g_return_if_fail (victim != NULL);
#line 829 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->transformations;
#line 829 "../src/ColorTransformation.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, victim);
#line 830 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations = (_vala_array_free (self->priv->optimized_transformations, self->priv->optimized_transformations_length1, (GDestroyNotify) pixel_transformation_unref), NULL);
#line 830 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations = NULL;
#line 830 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations_length1 = 0;
#line 830 "../src/ColorTransformation.vala"
	self->priv->_optimized_transformations_size_ = self->priv->optimized_transformations_length1;
#line 5868 "ColorTransformation.c"
}

void
pixel_transformer_replace_transformation (PixelTransformer* self,
                                          PixelTransformation* old_trans,
                                          PixelTransformation* new_trans)
{
#line 835 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 835 "../src/ColorTransformation.vala"
	g_return_if_fail (old_trans != NULL);
#line 835 "../src/ColorTransformation.vala"
	g_return_if_fail (new_trans != NULL);
#line 5882 "ColorTransformation.c"
	{
		gint i = 0;
#line 837 "../src/ColorTransformation.vala"
		i = 0;
#line 5887 "ColorTransformation.c"
		{
			gboolean _tmp0_ = FALSE;
#line 837 "../src/ColorTransformation.vala"
			_tmp0_ = TRUE;
#line 837 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 5894 "ColorTransformation.c"
				GeeArrayList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				GeeArrayList* _tmp5_;
				gpointer _tmp6_;
				PixelTransformation* _tmp7_;
				gboolean _tmp8_;
#line 837 "../src/ColorTransformation.vala"
				if (!_tmp0_) {
#line 5904 "ColorTransformation.c"
					gint _tmp1_;
#line 837 "../src/ColorTransformation.vala"
					_tmp1_ = i;
#line 837 "../src/ColorTransformation.vala"
					i = _tmp1_ + 1;
#line 5910 "ColorTransformation.c"
				}
#line 837 "../src/ColorTransformation.vala"
				_tmp0_ = FALSE;
#line 837 "../src/ColorTransformation.vala"
				_tmp2_ = self->priv->transformations;
#line 837 "../src/ColorTransformation.vala"
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 837 "../src/ColorTransformation.vala"
				_tmp4_ = _tmp3_;
#line 837 "../src/ColorTransformation.vala"
				if (!(i < _tmp4_)) {
#line 837 "../src/ColorTransformation.vala"
					break;
#line 5924 "ColorTransformation.c"
				}
#line 838 "../src/ColorTransformation.vala"
				_tmp5_ = self->priv->transformations;
#line 838 "../src/ColorTransformation.vala"
				_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, i);
#line 838 "../src/ColorTransformation.vala"
				_tmp7_ = (PixelTransformation*) _tmp6_;
#line 838 "../src/ColorTransformation.vala"
				_tmp8_ = _tmp7_ == old_trans;
#line 838 "../src/ColorTransformation.vala"
				_pixel_transformation_unref0 (_tmp7_);
#line 838 "../src/ColorTransformation.vala"
				if (_tmp8_) {
#line 5938 "ColorTransformation.c"
					GeeArrayList* _tmp9_;
#line 839 "../src/ColorTransformation.vala"
					_tmp9_ = self->priv->transformations;
#line 839 "../src/ColorTransformation.vala"
					gee_abstract_list_set ((GeeAbstractList*) _tmp9_, i, new_trans);
#line 841 "../src/ColorTransformation.vala"
					self->priv->optimized_transformations = (_vala_array_free (self->priv->optimized_transformations, self->priv->optimized_transformations_length1, (GDestroyNotify) pixel_transformation_unref), NULL);
#line 841 "../src/ColorTransformation.vala"
					self->priv->optimized_transformations = NULL;
#line 841 "../src/ColorTransformation.vala"
					self->priv->optimized_transformations_length1 = 0;
#line 841 "../src/ColorTransformation.vala"
					self->priv->_optimized_transformations_size_ = self->priv->optimized_transformations_length1;
#line 842 "../src/ColorTransformation.vala"
					return;
#line 5954 "ColorTransformation.c"
				}
			}
		}
	}
#line 845 "../src/ColorTransformation.vala"
	g_error ("ColorTransformation.vala:845: %s", "PixelTransformer: replace_transformation( ): old_trans is not present " \
"in " "transformation collection");
#line 5961 "ColorTransformation.c"
}

void
pixel_transformer_transform_pixbuf (PixelTransformer* self,
                                    GdkPixbuf* pixbuf,
                                    GCancellable* cancellable)
{
#line 849 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 849 "../src/ColorTransformation.vala"
	g_return_if_fail (pixbuf != NULL);
#line 850 "../src/ColorTransformation.vala"
	pixel_transformer_transform_to_other_pixbuf (self, pixbuf, pixbuf, cancellable);
#line 5975 "ColorTransformation.c"
}

void
pixel_transformer_transform_from_fp (PixelTransformer* self,
                                     gfloat** fp_pixel_cache,
                                     gint* fp_pixel_cache_length1,
                                     GdkPixbuf* dest)
{
	PixelTransformation** _tmp0_;
	gint _tmp0__length1;
	gint dest_width = 0;
	gint dest_height = 0;
	gint dest_num_channels = 0;
	gint dest_rowstride = 0;
	guchar* dest_pixels = NULL;
	guint8* _tmp1_;
	gint dest_pixels_length1;
	gint _dest_pixels_size_;
	gint cache_pixel_ticker = 0;
#line 853 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 853 "../src/ColorTransformation.vala"
	g_return_if_fail (dest != NULL);
#line 854 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->optimized_transformations;
#line 854 "../src/ColorTransformation.vala"
	_tmp0__length1 = self->priv->optimized_transformations_length1;
#line 854 "../src/ColorTransformation.vala"
	if (_tmp0_ == NULL) {
#line 855 "../src/ColorTransformation.vala"
		pixel_transformer_build_optimized_transformations (self);
#line 6007 "ColorTransformation.c"
	}
#line 857 "../src/ColorTransformation.vala"
	dest_width = gdk_pixbuf_get_width (dest);
#line 858 "../src/ColorTransformation.vala"
	dest_height = gdk_pixbuf_get_height (dest);
#line 859 "../src/ColorTransformation.vala"
	dest_num_channels = gdk_pixbuf_get_n_channels (dest);
#line 860 "../src/ColorTransformation.vala"
	dest_rowstride = gdk_pixbuf_get_rowstride (dest);
#line 861 "../src/ColorTransformation.vala"
	_tmp1_ = gdk_pixbuf_get_pixels (dest);
#line 861 "../src/ColorTransformation.vala"
	dest_pixels = _tmp1_;
#line 861 "../src/ColorTransformation.vala"
	dest_pixels_length1 = -1;
#line 861 "../src/ColorTransformation.vala"
	_dest_pixels_size_ = dest_pixels_length1;
#line 863 "../src/ColorTransformation.vala"
	cache_pixel_ticker = 0;
#line 6027 "ColorTransformation.c"
	{
		gint j = 0;
#line 865 "../src/ColorTransformation.vala"
		j = 0;
#line 6032 "ColorTransformation.c"
		{
			gboolean _tmp2_ = FALSE;
#line 865 "../src/ColorTransformation.vala"
			_tmp2_ = TRUE;
#line 865 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 6039 "ColorTransformation.c"
				gint row_start_index = 0;
				gint row_end_index = 0;
#line 865 "../src/ColorTransformation.vala"
				if (!_tmp2_) {
#line 6044 "ColorTransformation.c"
					gint _tmp3_;
#line 865 "../src/ColorTransformation.vala"
					_tmp3_ = j;
#line 865 "../src/ColorTransformation.vala"
					j = _tmp3_ + 1;
#line 6050 "ColorTransformation.c"
				}
#line 865 "../src/ColorTransformation.vala"
				_tmp2_ = FALSE;
#line 865 "../src/ColorTransformation.vala"
				if (!(j < dest_height)) {
#line 865 "../src/ColorTransformation.vala"
					break;
#line 6058 "ColorTransformation.c"
				}
#line 866 "../src/ColorTransformation.vala"
				row_start_index = j * dest_rowstride;
#line 867 "../src/ColorTransformation.vala"
				row_end_index = row_start_index + (dest_width * dest_num_channels);
#line 6064 "ColorTransformation.c"
				{
					gint i = 0;
#line 868 "../src/ColorTransformation.vala"
					i = row_start_index;
#line 6069 "ColorTransformation.c"
					{
						gboolean _tmp4_ = FALSE;
#line 868 "../src/ColorTransformation.vala"
						_tmp4_ = TRUE;
#line 868 "../src/ColorTransformation.vala"
						while (TRUE) {
#line 6076 "ColorTransformation.c"
							RGBAnalyticPixel pixel = {0};
							gfloat _tmp5_;
							gfloat _tmp6_;
							gfloat _tmp7_;
							RGBAnalyticPixel _tmp8_;
							RGBAnalyticPixel _tmp9_ = {0};
							guchar* _tmp10_;
							gint _tmp10__length1;
							RGBAnalyticPixel _tmp11_;
							guchar* _tmp12_;
							gint _tmp12__length1;
							RGBAnalyticPixel _tmp13_;
							guchar* _tmp14_;
							gint _tmp14__length1;
							RGBAnalyticPixel _tmp15_;
#line 868 "../src/ColorTransformation.vala"
							if (!_tmp4_) {
#line 868 "../src/ColorTransformation.vala"
								i += dest_num_channels;
#line 6096 "ColorTransformation.c"
							}
#line 868 "../src/ColorTransformation.vala"
							_tmp4_ = FALSE;
#line 868 "../src/ColorTransformation.vala"
							if (!(i < row_end_index)) {
#line 868 "../src/ColorTransformation.vala"
								break;
#line 6104 "ColorTransformation.c"
							}
#line 869 "../src/ColorTransformation.vala"
							_tmp5_ = (*fp_pixel_cache)[cache_pixel_ticker];
#line 869 "../src/ColorTransformation.vala"
							_tmp6_ = (*fp_pixel_cache)[cache_pixel_ticker + 1];
#line 869 "../src/ColorTransformation.vala"
							_tmp7_ = (*fp_pixel_cache)[cache_pixel_ticker + 2];
#line 869 "../src/ColorTransformation.vala"
							rgb_analytic_pixel_init_from_components (&pixel, _tmp5_, _tmp6_, _tmp7_);
#line 874 "../src/ColorTransformation.vala"
							cache_pixel_ticker += 3;
#line 876 "../src/ColorTransformation.vala"
							_tmp8_ = pixel;
#line 876 "../src/ColorTransformation.vala"
							pixel_transformer_apply_transformations (self, &_tmp8_, &_tmp9_);
#line 876 "../src/ColorTransformation.vala"
							pixel = _tmp9_;
#line 878 "../src/ColorTransformation.vala"
							_tmp10_ = dest_pixels;
#line 878 "../src/ColorTransformation.vala"
							_tmp10__length1 = dest_pixels_length1;
#line 878 "../src/ColorTransformation.vala"
							_tmp11_ = pixel;
#line 878 "../src/ColorTransformation.vala"
							_tmp10_[i] = (guchar) (_tmp11_.red * 255.0f);
#line 879 "../src/ColorTransformation.vala"
							_tmp12_ = dest_pixels;
#line 879 "../src/ColorTransformation.vala"
							_tmp12__length1 = dest_pixels_length1;
#line 879 "../src/ColorTransformation.vala"
							_tmp13_ = pixel;
#line 879 "../src/ColorTransformation.vala"
							_tmp12_[i + 1] = (guchar) (_tmp13_.green * 255.0f);
#line 880 "../src/ColorTransformation.vala"
							_tmp14_ = dest_pixels;
#line 880 "../src/ColorTransformation.vala"
							_tmp14__length1 = dest_pixels_length1;
#line 880 "../src/ColorTransformation.vala"
							_tmp15_ = pixel;
#line 880 "../src/ColorTransformation.vala"
							_tmp14_[i + 2] = (guchar) (_tmp15_.blue * 255.0f);
#line 6146 "ColorTransformation.c"
						}
					}
				}
			}
		}
	}
}

void
pixel_transformer_transform_to_other_pixbuf (PixelTransformer* self,
                                             GdkPixbuf* source,
                                             GdkPixbuf* dest,
                                             GCancellable* cancellable)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	PixelTransformation** _tmp12_;
	gint _tmp12__length1;
	gint n_channels = 0;
	gint rowstride = 0;
	gint width = 0;
	gint height = 0;
	gint rowbytes = 0;
	guchar* source_pixels = NULL;
	guint8* _tmp13_;
	gint source_pixels_length1;
	gint _source_pixels_size_;
	guchar* dest_pixels = NULL;
	guint8* _tmp14_;
	gint dest_pixels_length1;
	gint _dest_pixels_size_;
#line 885 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 885 "../src/ColorTransformation.vala"
	g_return_if_fail (source != NULL);
#line 885 "../src/ColorTransformation.vala"
	g_return_if_fail (dest != NULL);
#line 887 "../src/ColorTransformation.vala"
	_tmp0_ = gdk_pixbuf_get_width (source);
#line 887 "../src/ColorTransformation.vala"
	_tmp1_ = _tmp0_;
#line 887 "../src/ColorTransformation.vala"
	_tmp2_ = gdk_pixbuf_get_width (dest);
#line 887 "../src/ColorTransformation.vala"
	_tmp3_ = _tmp2_;
#line 887 "../src/ColorTransformation.vala"
	if (_tmp1_ != _tmp3_) {
#line 888 "../src/ColorTransformation.vala"
		g_error ("ColorTransformation.vala:888: PixelTransformer: source and destination" \
" pixbufs must have the same width");
#line 6206 "ColorTransformation.c"
	}
#line 890 "../src/ColorTransformation.vala"
	_tmp4_ = gdk_pixbuf_get_height (source);
#line 890 "../src/ColorTransformation.vala"
	_tmp5_ = _tmp4_;
#line 890 "../src/ColorTransformation.vala"
	_tmp6_ = gdk_pixbuf_get_height (dest);
#line 890 "../src/ColorTransformation.vala"
	_tmp7_ = _tmp6_;
#line 890 "../src/ColorTransformation.vala"
	if (_tmp5_ != _tmp7_) {
#line 891 "../src/ColorTransformation.vala"
		g_error ("ColorTransformation.vala:891: PixelTransformer: source and destination" \
" pixbufs must have the same height");
#line 6220 "ColorTransformation.c"
	}
#line 893 "../src/ColorTransformation.vala"
	_tmp8_ = gdk_pixbuf_get_n_channels (source);
#line 893 "../src/ColorTransformation.vala"
	_tmp9_ = _tmp8_;
#line 893 "../src/ColorTransformation.vala"
	_tmp10_ = gdk_pixbuf_get_n_channels (dest);
#line 893 "../src/ColorTransformation.vala"
	_tmp11_ = _tmp10_;
#line 893 "../src/ColorTransformation.vala"
	if (_tmp9_ != _tmp11_) {
#line 894 "../src/ColorTransformation.vala"
		g_error ("ColorTransformation.vala:894: %s", "PixelTransformer: source and destination pixbufs must have the same nu" \
"mber " "of channels");
#line 6234 "ColorTransformation.c"
	}
#line 897 "../src/ColorTransformation.vala"
	_tmp12_ = self->priv->optimized_transformations;
#line 897 "../src/ColorTransformation.vala"
	_tmp12__length1 = self->priv->optimized_transformations_length1;
#line 897 "../src/ColorTransformation.vala"
	if (_tmp12_ == NULL) {
#line 898 "../src/ColorTransformation.vala"
		pixel_transformer_build_optimized_transformations (self);
#line 6244 "ColorTransformation.c"
	}
#line 900 "../src/ColorTransformation.vala"
	n_channels = gdk_pixbuf_get_n_channels (source);
#line 901 "../src/ColorTransformation.vala"
	rowstride = gdk_pixbuf_get_rowstride (source);
#line 902 "../src/ColorTransformation.vala"
	width = gdk_pixbuf_get_width (source);
#line 903 "../src/ColorTransformation.vala"
	height = gdk_pixbuf_get_height (source);
#line 904 "../src/ColorTransformation.vala"
	rowbytes = n_channels * width;
#line 905 "../src/ColorTransformation.vala"
	_tmp13_ = gdk_pixbuf_get_pixels (source);
#line 905 "../src/ColorTransformation.vala"
	source_pixels = _tmp13_;
#line 905 "../src/ColorTransformation.vala"
	source_pixels_length1 = -1;
#line 905 "../src/ColorTransformation.vala"
	_source_pixels_size_ = source_pixels_length1;
#line 906 "../src/ColorTransformation.vala"
	_tmp14_ = gdk_pixbuf_get_pixels (dest);
#line 906 "../src/ColorTransformation.vala"
	dest_pixels = _tmp14_;
#line 906 "../src/ColorTransformation.vala"
	dest_pixels_length1 = -1;
#line 906 "../src/ColorTransformation.vala"
	_dest_pixels_size_ = dest_pixels_length1;
#line 6272 "ColorTransformation.c"
	{
		gint j = 0;
#line 907 "../src/ColorTransformation.vala"
		j = 0;
#line 6277 "ColorTransformation.c"
		{
			gboolean _tmp15_ = FALSE;
#line 907 "../src/ColorTransformation.vala"
			_tmp15_ = TRUE;
#line 907 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 6284 "ColorTransformation.c"
				gint row_start_index = 0;
				gint row_end_index = 0;
				gboolean _tmp29_ = FALSE;
#line 907 "../src/ColorTransformation.vala"
				if (!_tmp15_) {
#line 6290 "ColorTransformation.c"
					gint _tmp16_;
#line 907 "../src/ColorTransformation.vala"
					_tmp16_ = j;
#line 907 "../src/ColorTransformation.vala"
					j = _tmp16_ + 1;
#line 6296 "ColorTransformation.c"
				}
#line 907 "../src/ColorTransformation.vala"
				_tmp15_ = FALSE;
#line 907 "../src/ColorTransformation.vala"
				if (!(j < height)) {
#line 907 "../src/ColorTransformation.vala"
					break;
#line 6304 "ColorTransformation.c"
				}
#line 908 "../src/ColorTransformation.vala"
				row_start_index = j * rowstride;
#line 909 "../src/ColorTransformation.vala"
				row_end_index = row_start_index + rowbytes;
#line 6310 "ColorTransformation.c"
				{
					gint i = 0;
#line 910 "../src/ColorTransformation.vala"
					i = row_start_index;
#line 6315 "ColorTransformation.c"
					{
						gboolean _tmp17_ = FALSE;
#line 910 "../src/ColorTransformation.vala"
						_tmp17_ = TRUE;
#line 910 "../src/ColorTransformation.vala"
						while (TRUE) {
#line 6322 "ColorTransformation.c"
							RGBAnalyticPixel current_pixel = {0};
							guchar* _tmp18_;
							gint _tmp18__length1;
							guchar _tmp19_;
							guchar* _tmp20_;
							gint _tmp20__length1;
							guchar _tmp21_;
							guchar* _tmp22_;
							gint _tmp22__length1;
							guchar _tmp23_;
							RGBAnalyticPixel _tmp24_;
							RGBAnalyticPixel _tmp25_ = {0};
							guchar* _tmp26_;
							gint _tmp26__length1;
							guchar* _tmp27_;
							gint _tmp27__length1;
							guchar* _tmp28_;
							gint _tmp28__length1;
#line 910 "../src/ColorTransformation.vala"
							if (!_tmp17_) {
#line 910 "../src/ColorTransformation.vala"
								i += n_channels;
#line 6345 "ColorTransformation.c"
							}
#line 910 "../src/ColorTransformation.vala"
							_tmp17_ = FALSE;
#line 910 "../src/ColorTransformation.vala"
							if (!(i < row_end_index)) {
#line 910 "../src/ColorTransformation.vala"
								break;
#line 6353 "ColorTransformation.c"
							}
#line 911 "../src/ColorTransformation.vala"
							_tmp18_ = source_pixels;
#line 911 "../src/ColorTransformation.vala"
							_tmp18__length1 = source_pixels_length1;
#line 911 "../src/ColorTransformation.vala"
							_tmp19_ = _tmp18_[i];
#line 911 "../src/ColorTransformation.vala"
							_tmp20_ = source_pixels;
#line 911 "../src/ColorTransformation.vala"
							_tmp20__length1 = source_pixels_length1;
#line 911 "../src/ColorTransformation.vala"
							_tmp21_ = _tmp20_[i + 1];
#line 911 "../src/ColorTransformation.vala"
							_tmp22_ = source_pixels;
#line 911 "../src/ColorTransformation.vala"
							_tmp22__length1 = source_pixels_length1;
#line 911 "../src/ColorTransformation.vala"
							_tmp23_ = _tmp22_[i + 2];
#line 911 "../src/ColorTransformation.vala"
							rgb_analytic_pixel_init_from_quantized_components (&current_pixel, _tmp19_, _tmp21_, _tmp23_);
#line 914 "../src/ColorTransformation.vala"
							_tmp24_ = current_pixel;
#line 914 "../src/ColorTransformation.vala"
							pixel_transformer_apply_transformations (self, &_tmp24_, &_tmp25_);
#line 914 "../src/ColorTransformation.vala"
							current_pixel = _tmp25_;
#line 916 "../src/ColorTransformation.vala"
							_tmp26_ = dest_pixels;
#line 916 "../src/ColorTransformation.vala"
							_tmp26__length1 = dest_pixels_length1;
#line 916 "../src/ColorTransformation.vala"
							_tmp26_[i] = rgb_analytic_pixel_quantized_red (&current_pixel);
#line 917 "../src/ColorTransformation.vala"
							_tmp27_ = dest_pixels;
#line 917 "../src/ColorTransformation.vala"
							_tmp27__length1 = dest_pixels_length1;
#line 917 "../src/ColorTransformation.vala"
							_tmp27_[i + 1] = rgb_analytic_pixel_quantized_green (&current_pixel);
#line 918 "../src/ColorTransformation.vala"
							_tmp28_ = dest_pixels;
#line 918 "../src/ColorTransformation.vala"
							_tmp28__length1 = dest_pixels_length1;
#line 918 "../src/ColorTransformation.vala"
							_tmp28_[i + 2] = rgb_analytic_pixel_quantized_blue (&current_pixel);
#line 6399 "ColorTransformation.c"
						}
					}
				}
#line 921 "../src/ColorTransformation.vala"
				if (cancellable != NULL) {
#line 921 "../src/ColorTransformation.vala"
					_tmp29_ = g_cancellable_is_cancelled (cancellable);
#line 6407 "ColorTransformation.c"
				} else {
#line 921 "../src/ColorTransformation.vala"
					_tmp29_ = FALSE;
#line 6411 "ColorTransformation.c"
				}
#line 921 "../src/ColorTransformation.vala"
				if (_tmp29_) {
#line 922 "../src/ColorTransformation.vala"
					return;
#line 6417 "ColorTransformation.c"
				}
			}
		}
	}
}

static void
value_pixel_transformer_init (GValue* value)
{
#line 745 "../src/ColorTransformation.vala"
	value->data[0].v_pointer = NULL;
#line 6429 "ColorTransformation.c"
}

static void
value_pixel_transformer_free_value (GValue* value)
{
#line 745 "../src/ColorTransformation.vala"
	if (value->data[0].v_pointer) {
#line 745 "../src/ColorTransformation.vala"
		pixel_transformer_unref (value->data[0].v_pointer);
#line 6439 "ColorTransformation.c"
	}
}

static void
value_pixel_transformer_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 745 "../src/ColorTransformation.vala"
	if (src_value->data[0].v_pointer) {
#line 745 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = pixel_transformer_ref (src_value->data[0].v_pointer);
#line 6451 "ColorTransformation.c"
	} else {
#line 745 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6455 "ColorTransformation.c"
	}
}

static gpointer
value_pixel_transformer_peek_pointer (const GValue* value)
{
#line 745 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 6464 "ColorTransformation.c"
}

static gchar*
value_pixel_transformer_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 745 "../src/ColorTransformation.vala"
	if (collect_values[0].v_pointer) {
#line 6475 "ColorTransformation.c"
		PixelTransformer * object;
		object = collect_values[0].v_pointer;
#line 745 "../src/ColorTransformation.vala"
		if (object->parent_instance.g_class == NULL) {
#line 745 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6482 "ColorTransformation.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 745 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6486 "ColorTransformation.c"
		}
#line 745 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = pixel_transformer_ref (object);
#line 6490 "ColorTransformation.c"
	} else {
#line 745 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 6494 "ColorTransformation.c"
	}
#line 745 "../src/ColorTransformation.vala"
	return NULL;
#line 6498 "ColorTransformation.c"
}

static gchar*
value_pixel_transformer_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	PixelTransformer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 745 "../src/ColorTransformation.vala"
	if (!object_p) {
#line 745 "../src/ColorTransformation.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6513 "ColorTransformation.c"
	}
#line 745 "../src/ColorTransformation.vala"
	if (!value->data[0].v_pointer) {
#line 745 "../src/ColorTransformation.vala"
		*object_p = NULL;
#line 6519 "ColorTransformation.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 745 "../src/ColorTransformation.vala"
		*object_p = value->data[0].v_pointer;
#line 6523 "ColorTransformation.c"
	} else {
#line 745 "../src/ColorTransformation.vala"
		*object_p = pixel_transformer_ref (value->data[0].v_pointer);
#line 6527 "ColorTransformation.c"
	}
#line 745 "../src/ColorTransformation.vala"
	return NULL;
#line 6531 "ColorTransformation.c"
}

GParamSpec*
param_spec_pixel_transformer (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecPixelTransformer* spec;
#line 745 "../src/ColorTransformation.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PIXEL_TRANSFORMER), NULL);
#line 745 "../src/ColorTransformation.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 745 "../src/ColorTransformation.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 745 "../src/ColorTransformation.vala"
	return G_PARAM_SPEC (spec);
#line 6550 "ColorTransformation.c"
}

gpointer
value_get_pixel_transformer (const GValue* value)
{
#line 745 "../src/ColorTransformation.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMER), NULL);
#line 745 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 6560 "ColorTransformation.c"
}

void
value_set_pixel_transformer (GValue* value,
                             gpointer v_object)
{
	PixelTransformer * old;
#line 745 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMER));
#line 745 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 745 "../src/ColorTransformation.vala"
	if (v_object) {
#line 745 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PIXEL_TRANSFORMER));
#line 745 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 745 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 745 "../src/ColorTransformation.vala"
		pixel_transformer_ref (value->data[0].v_pointer);
#line 6582 "ColorTransformation.c"
	} else {
#line 745 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 6586 "ColorTransformation.c"
	}
#line 745 "../src/ColorTransformation.vala"
	if (old) {
#line 745 "../src/ColorTransformation.vala"
		pixel_transformer_unref (old);
#line 6592 "ColorTransformation.c"
	}
}

void
value_take_pixel_transformer (GValue* value,
                              gpointer v_object)
{
	PixelTransformer * old;
#line 745 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PIXEL_TRANSFORMER));
#line 745 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 745 "../src/ColorTransformation.vala"
	if (v_object) {
#line 745 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PIXEL_TRANSFORMER));
#line 745 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 745 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 6613 "ColorTransformation.c"
	} else {
#line 745 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 6617 "ColorTransformation.c"
	}
#line 745 "../src/ColorTransformation.vala"
	if (old) {
#line 745 "../src/ColorTransformation.vala"
		pixel_transformer_unref (old);
#line 6623 "ColorTransformation.c"
	}
}

static void
pixel_transformer_class_init (PixelTransformerClass * klass,
                              gpointer klass_data)
{
#line 745 "../src/ColorTransformation.vala"
	pixel_transformer_parent_class = g_type_class_peek_parent (klass);
#line 745 "../src/ColorTransformation.vala"
	((PixelTransformerClass *) klass)->finalize = pixel_transformer_finalize;
#line 745 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &PixelTransformer_private_offset);
#line 6637 "ColorTransformation.c"
}

static void
pixel_transformer_instance_init (PixelTransformer * self,
                                 gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 745 "../src/ColorTransformation.vala"
	self->priv = pixel_transformer_get_instance_private (self);
#line 746 "../src/ColorTransformation.vala"
	_tmp0_ = gee_array_list_new (TYPE_PIXEL_TRANSFORMATION, (GBoxedCopyFunc) pixel_transformation_ref, (GDestroyNotify) pixel_transformation_unref, NULL, NULL, NULL);
#line 746 "../src/ColorTransformation.vala"
	self->priv->transformations = _tmp0_;
#line 748 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations = NULL;
#line 748 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations_length1 = 0;
#line 748 "../src/ColorTransformation.vala"
	self->priv->_optimized_transformations_size_ = self->priv->optimized_transformations_length1;
#line 749 "../src/ColorTransformation.vala"
	self->priv->optimized_slots_used = 0;
#line 745 "../src/ColorTransformation.vala"
	self->ref_count = 1;
#line 6661 "ColorTransformation.c"
}

static void
pixel_transformer_finalize (PixelTransformer * obj)
{
	PixelTransformer * self;
#line 745 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PIXEL_TRANSFORMER, PixelTransformer);
#line 745 "../src/ColorTransformation.vala"
	g_signal_handlers_destroy (self);
#line 746 "../src/ColorTransformation.vala"
	_g_object_unref0 (self->priv->transformations);
#line 748 "../src/ColorTransformation.vala"
	self->priv->optimized_transformations = (_vala_array_free (self->priv->optimized_transformations, self->priv->optimized_transformations_length1, (GDestroyNotify) pixel_transformation_unref), NULL);
#line 6676 "ColorTransformation.c"
}

static GType
pixel_transformer_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_pixel_transformer_init, value_pixel_transformer_free_value, value_pixel_transformer_copy_value, value_pixel_transformer_peek_pointer, "p", value_pixel_transformer_collect_value, "p", value_pixel_transformer_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PixelTransformerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pixel_transformer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PixelTransformer), 0, (GInstanceInitFunc) pixel_transformer_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pixel_transformer_type_id;
	pixel_transformer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PixelTransformer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PixelTransformer_private_offset = g_type_add_instance_private (pixel_transformer_type_id, sizeof (PixelTransformerPrivate));
	return pixel_transformer_type_id;
}

GType
pixel_transformer_get_type (void)
{
	static volatile gsize pixel_transformer_type_id__once = 0;
	if (g_once_init_enter (&pixel_transformer_type_id__once)) {
		GType pixel_transformer_type_id;
		pixel_transformer_type_id = pixel_transformer_get_type_once ();
		g_once_init_leave (&pixel_transformer_type_id__once, pixel_transformer_type_id);
	}
	return pixel_transformer_type_id__once;
}

gpointer
pixel_transformer_ref (gpointer instance)
{
	PixelTransformer * self;
	self = instance;
#line 745 "../src/ColorTransformation.vala"
	g_atomic_int_inc (&self->ref_count);
#line 745 "../src/ColorTransformation.vala"
	return instance;
#line 6712 "ColorTransformation.c"
}

void
pixel_transformer_unref (gpointer instance)
{
	PixelTransformer * self;
	self = instance;
#line 745 "../src/ColorTransformation.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 745 "../src/ColorTransformation.vala"
		PIXEL_TRANSFORMER_GET_CLASS (self)->finalize (self);
#line 745 "../src/ColorTransformation.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6726 "ColorTransformation.c"
	}
}

static inline gpointer
rgb_histogram_get_instance_private (RGBHistogram* self)
{
	return G_STRUCT_MEMBER_P (self, RGBHistogram_private_offset);
}

RGBHistogram*
rgb_histogram_construct (GType object_type,
                         GdkPixbuf* pixbuf)
{
	RGBHistogram* self = NULL;
	gint sample_bytes = 0;
	gint pixel_bytes = 0;
	gint row_length_bytes = 0;
	gint _tmp0_;
	gint _tmp1_;
	guchar* pixel_data = NULL;
	guint8* _tmp2_;
	gint pixel_data_length1;
	gint _pixel_data_size_;
#line 944 "../src/ColorTransformation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 944 "../src/ColorTransformation.vala"
	self = (RGBHistogram*) g_type_create_instance (object_type);
#line 945 "../src/ColorTransformation.vala"
	sample_bytes = gdk_pixbuf_get_bits_per_sample (pixbuf) / 8;
#line 946 "../src/ColorTransformation.vala"
	pixel_bytes = sample_bytes * gdk_pixbuf_get_n_channels (pixbuf);
#line 947 "../src/ColorTransformation.vala"
	_tmp0_ = gdk_pixbuf_get_width (pixbuf);
#line 947 "../src/ColorTransformation.vala"
	_tmp1_ = _tmp0_;
#line 947 "../src/ColorTransformation.vala"
	row_length_bytes = pixel_bytes * _tmp1_;
#line 949 "../src/ColorTransformation.vala"
	_tmp2_ = gdk_pixbuf_get_pixels (pixbuf);
#line 949 "../src/ColorTransformation.vala"
	pixel_data = _tmp2_;
#line 949 "../src/ColorTransformation.vala"
	pixel_data_length1 = -1;
#line 949 "../src/ColorTransformation.vala"
	_pixel_data_size_ = pixel_data_length1;
#line 6772 "ColorTransformation.c"
	{
		gint y = 0;
#line 951 "../src/ColorTransformation.vala"
		y = 0;
#line 6777 "ColorTransformation.c"
		{
			gboolean _tmp3_ = FALSE;
#line 951 "../src/ColorTransformation.vala"
			_tmp3_ = TRUE;
#line 951 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 6784 "ColorTransformation.c"
				gint _tmp5_;
				gint _tmp6_;
				gint row_start_offset = 0;
				gint _tmp7_;
				gint _tmp8_;
				gint r_offset = 0;
				gint g_offset = 0;
				gint b_offset = 0;
#line 951 "../src/ColorTransformation.vala"
				if (!_tmp3_) {
#line 6795 "ColorTransformation.c"
					gint _tmp4_;
#line 951 "../src/ColorTransformation.vala"
					_tmp4_ = y;
#line 951 "../src/ColorTransformation.vala"
					y = _tmp4_ + 1;
#line 6801 "ColorTransformation.c"
				}
#line 951 "../src/ColorTransformation.vala"
				_tmp3_ = FALSE;
#line 951 "../src/ColorTransformation.vala"
				_tmp5_ = gdk_pixbuf_get_height (pixbuf);
#line 951 "../src/ColorTransformation.vala"
				_tmp6_ = _tmp5_;
#line 951 "../src/ColorTransformation.vala"
				if (!(y < _tmp6_)) {
#line 951 "../src/ColorTransformation.vala"
					break;
#line 6813 "ColorTransformation.c"
				}
#line 952 "../src/ColorTransformation.vala"
				_tmp7_ = gdk_pixbuf_get_rowstride (pixbuf);
#line 952 "../src/ColorTransformation.vala"
				_tmp8_ = _tmp7_;
#line 952 "../src/ColorTransformation.vala"
				row_start_offset = y * _tmp8_;
#line 954 "../src/ColorTransformation.vala"
				r_offset = row_start_offset;
#line 955 "../src/ColorTransformation.vala"
				g_offset = row_start_offset + sample_bytes;
#line 956 "../src/ColorTransformation.vala"
				b_offset = (row_start_offset + sample_bytes) + sample_bytes;
#line 958 "../src/ColorTransformation.vala"
				while (TRUE) {
#line 6829 "ColorTransformation.c"
					gint* _tmp9_;
					gint _tmp9__length1;
					guchar* _tmp10_;
					gint _tmp10__length1;
					guchar _tmp11_;
					gint* _tmp12_;
					gint _tmp12__length1;
					guchar* _tmp13_;
					gint _tmp13__length1;
					guchar _tmp14_;
					gint* _tmp15_;
					gint _tmp15__length1;
					guchar* _tmp16_;
					gint _tmp16__length1;
					guchar _tmp17_;
#line 958 "../src/ColorTransformation.vala"
					if (!(b_offset < (row_start_offset + row_length_bytes))) {
#line 958 "../src/ColorTransformation.vala"
						break;
#line 6849 "ColorTransformation.c"
					}
#line 959 "../src/ColorTransformation.vala"
					_tmp9_ = self->priv->red_counts;
#line 959 "../src/ColorTransformation.vala"
					_tmp9__length1 = self->priv->red_counts_length1;
#line 959 "../src/ColorTransformation.vala"
					_tmp10_ = pixel_data;
#line 959 "../src/ColorTransformation.vala"
					_tmp10__length1 = pixel_data_length1;
#line 959 "../src/ColorTransformation.vala"
					_tmp11_ = _tmp10_[r_offset];
#line 959 "../src/ColorTransformation.vala"
					_tmp9_[_tmp11_] += 1;
#line 960 "../src/ColorTransformation.vala"
					_tmp12_ = self->priv->green_counts;
#line 960 "../src/ColorTransformation.vala"
					_tmp12__length1 = self->priv->green_counts_length1;
#line 960 "../src/ColorTransformation.vala"
					_tmp13_ = pixel_data;
#line 960 "../src/ColorTransformation.vala"
					_tmp13__length1 = pixel_data_length1;
#line 960 "../src/ColorTransformation.vala"
					_tmp14_ = _tmp13_[g_offset];
#line 960 "../src/ColorTransformation.vala"
					_tmp12_[_tmp14_] += 1;
#line 961 "../src/ColorTransformation.vala"
					_tmp15_ = self->priv->blue_counts;
#line 961 "../src/ColorTransformation.vala"
					_tmp15__length1 = self->priv->blue_counts_length1;
#line 961 "../src/ColorTransformation.vala"
					_tmp16_ = pixel_data;
#line 961 "../src/ColorTransformation.vala"
					_tmp16__length1 = pixel_data_length1;
#line 961 "../src/ColorTransformation.vala"
					_tmp17_ = _tmp16_[b_offset];
#line 961 "../src/ColorTransformation.vala"
					_tmp15_[_tmp17_] += 1;
#line 963 "../src/ColorTransformation.vala"
					r_offset += pixel_bytes;
#line 964 "../src/ColorTransformation.vala"
					g_offset += pixel_bytes;
#line 965 "../src/ColorTransformation.vala"
					b_offset += pixel_bytes;
#line 6893 "ColorTransformation.c"
				}
			}
		}
	}
#line 944 "../src/ColorTransformation.vala"
	return self;
#line 6900 "ColorTransformation.c"
}

RGBHistogram*
rgb_histogram_new (GdkPixbuf* pixbuf)
{
#line 944 "../src/ColorTransformation.vala"
	return rgb_histogram_construct (TYPE_RGB_HISTOGRAM, pixbuf);
#line 6908 "ColorTransformation.c"
}

static gint
rgb_histogram_correct_snap_to_quantization (RGBHistogram* self,
                                            gint* buckets,
                                            gint buckets_length1,
                                            gint i)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp17_;
	gint result;
#line 970 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 971 "../src/ColorTransformation.vala"
	_vala_assert (buckets_length1 == 256, "buckets.length == 256");
#line 972 "../src/ColorTransformation.vala"
	if (i >= 0) {
#line 972 "../src/ColorTransformation.vala"
		_tmp0_ = i <= 255;
#line 6928 "ColorTransformation.c"
	} else {
#line 972 "../src/ColorTransformation.vala"
		_tmp0_ = FALSE;
#line 6932 "ColorTransformation.c"
	}
#line 972 "../src/ColorTransformation.vala"
	_vala_assert (_tmp0_, "(i >= 0) && (i <= 255)");
#line 974 "../src/ColorTransformation.vala"
	if (i == 0) {
#line 6938 "ColorTransformation.c"
		gint _tmp1_;
#line 975 "../src/ColorTransformation.vala"
		_tmp1_ = buckets[i];
#line 975 "../src/ColorTransformation.vala"
		if (_tmp1_ > 0) {
#line 6944 "ColorTransformation.c"
			gint _tmp2_;
#line 976 "../src/ColorTransformation.vala"
			_tmp2_ = buckets[i + 1];
#line 976 "../src/ColorTransformation.vala"
			if (_tmp2_ > 0) {
#line 6950 "ColorTransformation.c"
				gint _tmp3_;
				gint _tmp4_;
#line 977 "../src/ColorTransformation.vala"
				_tmp3_ = buckets[i];
#line 977 "../src/ColorTransformation.vala"
				_tmp4_ = buckets[i + 1];
#line 977 "../src/ColorTransformation.vala"
				if (_tmp3_ > (2 * _tmp4_)) {
#line 6959 "ColorTransformation.c"
					gint _tmp5_;
#line 978 "../src/ColorTransformation.vala"
					_tmp5_ = buckets[i + 1];
#line 978 "../src/ColorTransformation.vala"
					result = _tmp5_;
#line 978 "../src/ColorTransformation.vala"
					return result;
#line 6967 "ColorTransformation.c"
				}
			}
		}
	} else {
#line 979 "../src/ColorTransformation.vala"
		if (i == 255) {
#line 6974 "ColorTransformation.c"
			gint _tmp6_;
#line 980 "../src/ColorTransformation.vala"
			_tmp6_ = buckets[i];
#line 980 "../src/ColorTransformation.vala"
			if (_tmp6_ > 0) {
#line 6980 "ColorTransformation.c"
				gint _tmp7_;
#line 981 "../src/ColorTransformation.vala"
				_tmp7_ = buckets[i - 1];
#line 981 "../src/ColorTransformation.vala"
				if (_tmp7_ > 0) {
#line 6986 "ColorTransformation.c"
					gint _tmp8_;
					gint _tmp9_;
#line 982 "../src/ColorTransformation.vala"
					_tmp8_ = buckets[i];
#line 982 "../src/ColorTransformation.vala"
					_tmp9_ = buckets[i - 1];
#line 982 "../src/ColorTransformation.vala"
					if (_tmp8_ > (2 * _tmp9_)) {
#line 6995 "ColorTransformation.c"
						gint _tmp10_;
#line 983 "../src/ColorTransformation.vala"
						_tmp10_ = buckets[i - 1];
#line 983 "../src/ColorTransformation.vala"
						result = _tmp10_;
#line 983 "../src/ColorTransformation.vala"
						return result;
#line 7003 "ColorTransformation.c"
					}
				}
			}
		} else {
			gint _tmp11_;
#line 985 "../src/ColorTransformation.vala"
			_tmp11_ = buckets[i];
#line 985 "../src/ColorTransformation.vala"
			if (_tmp11_ > 0) {
#line 7013 "ColorTransformation.c"
				gint _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 986 "../src/ColorTransformation.vala"
				_tmp12_ = buckets[i];
#line 986 "../src/ColorTransformation.vala"
				_tmp13_ = buckets[i - 1];
#line 986 "../src/ColorTransformation.vala"
				_tmp14_ = buckets[i + 1];
#line 986 "../src/ColorTransformation.vala"
				if (_tmp12_ > ((_tmp13_ + _tmp14_) / 2)) {
#line 7025 "ColorTransformation.c"
					gint _tmp15_;
					gint _tmp16_;
#line 987 "../src/ColorTransformation.vala"
					_tmp15_ = buckets[i - 1];
#line 987 "../src/ColorTransformation.vala"
					_tmp16_ = buckets[i + 1];
#line 987 "../src/ColorTransformation.vala"
					result = (_tmp15_ + _tmp16_) / 2;
#line 987 "../src/ColorTransformation.vala"
					return result;
#line 7036 "ColorTransformation.c"
				}
			}
		}
	}
#line 990 "../src/ColorTransformation.vala"
	_tmp17_ = buckets[i];
#line 990 "../src/ColorTransformation.vala"
	result = _tmp17_;
#line 990 "../src/ColorTransformation.vala"
	return result;
#line 7047 "ColorTransformation.c"
}

static gint
rgb_histogram_correct_snap_from_quantization (RGBHistogram* self,
                                              gint* buckets,
                                              gint buckets_length1,
                                              gint i)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp8_;
	gint result;
#line 993 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 994 "../src/ColorTransformation.vala"
	_vala_assert (buckets_length1 == 256, "buckets.length == 256");
#line 995 "../src/ColorTransformation.vala"
	if (i >= 0) {
#line 995 "../src/ColorTransformation.vala"
		_tmp0_ = i <= 255;
#line 7067 "ColorTransformation.c"
	} else {
#line 995 "../src/ColorTransformation.vala"
		_tmp0_ = FALSE;
#line 7071 "ColorTransformation.c"
	}
#line 995 "../src/ColorTransformation.vala"
	_vala_assert (_tmp0_, "(i >= 0) && (i <= 255)");
#line 997 "../src/ColorTransformation.vala"
	if (i == 0) {
#line 7077 "ColorTransformation.c"
		gint _tmp1_;
#line 998 "../src/ColorTransformation.vala"
		_tmp1_ = buckets[i];
#line 998 "../src/ColorTransformation.vala"
		result = _tmp1_;
#line 998 "../src/ColorTransformation.vala"
		return result;
#line 7085 "ColorTransformation.c"
	} else {
#line 999 "../src/ColorTransformation.vala"
		if (i == 255) {
#line 7089 "ColorTransformation.c"
			gint _tmp2_;
#line 1000 "../src/ColorTransformation.vala"
			_tmp2_ = buckets[i];
#line 1000 "../src/ColorTransformation.vala"
			result = _tmp2_;
#line 1000 "../src/ColorTransformation.vala"
			return result;
#line 7097 "ColorTransformation.c"
		} else {
			gint _tmp3_;
#line 1002 "../src/ColorTransformation.vala"
			_tmp3_ = buckets[i];
#line 1002 "../src/ColorTransformation.vala"
			if (_tmp3_ == 0) {
#line 7104 "ColorTransformation.c"
				gint _tmp4_;
#line 1003 "../src/ColorTransformation.vala"
				_tmp4_ = buckets[i - 1];
#line 1003 "../src/ColorTransformation.vala"
				if (_tmp4_ > 0) {
#line 7110 "ColorTransformation.c"
					gint _tmp5_;
#line 1004 "../src/ColorTransformation.vala"
					_tmp5_ = buckets[i + 1];
#line 1004 "../src/ColorTransformation.vala"
					if (_tmp5_ > 0) {
#line 7116 "ColorTransformation.c"
						gint _tmp6_;
						gint _tmp7_;
#line 1005 "../src/ColorTransformation.vala"
						_tmp6_ = buckets[i - 1];
#line 1005 "../src/ColorTransformation.vala"
						_tmp7_ = buckets[i + 1];
#line 1005 "../src/ColorTransformation.vala"
						result = (_tmp6_ + _tmp7_) / 2;
#line 1005 "../src/ColorTransformation.vala"
						return result;
#line 7127 "ColorTransformation.c"
					}
				}
			}
		}
	}
#line 1008 "../src/ColorTransformation.vala"
	_tmp8_ = buckets[i];
#line 1008 "../src/ColorTransformation.vala"
	result = _tmp8_;
#line 1008 "../src/ColorTransformation.vala"
	return result;
#line 7139 "ColorTransformation.c"
}

static void
rgb_histogram_smooth_extrema (RGBHistogram* self,
                              gint** count_data,
                              gint* count_data_length1)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
#line 1011 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 1012 "../src/ColorTransformation.vala"
	_vala_assert ((*count_data_length1) == 256, "count_data.length == 256");
#line 1018 "../src/ColorTransformation.vala"
	_tmp0_ = (*count_data)[0];
#line 1018 "../src/ColorTransformation.vala"
	_tmp1_ = (*count_data)[1];
#line 1018 "../src/ColorTransformation.vala"
	_tmp2_ = (*count_data)[2];
#line 1018 "../src/ColorTransformation.vala"
	(*count_data)[0] = (((5 * _tmp0_) + (3 * _tmp1_)) + (2 * _tmp2_)) / 10;
#line 1020 "../src/ColorTransformation.vala"
	_tmp3_ = (*count_data)[0];
#line 1020 "../src/ColorTransformation.vala"
	_tmp4_ = (*count_data)[1];
#line 1020 "../src/ColorTransformation.vala"
	_tmp5_ = (*count_data)[2];
#line 1020 "../src/ColorTransformation.vala"
	_tmp6_ = (*count_data)[3];
#line 1020 "../src/ColorTransformation.vala"
	(*count_data)[1] = ((((3 * _tmp3_) + (5 * _tmp4_)) + (3 * _tmp5_)) + (2 * _tmp6_)) / 13;
#line 1022 "../src/ColorTransformation.vala"
	_tmp7_ = (*count_data)[0];
#line 1022 "../src/ColorTransformation.vala"
	_tmp8_ = (*count_data)[1];
#line 1022 "../src/ColorTransformation.vala"
	_tmp9_ = (*count_data)[2];
#line 1022 "../src/ColorTransformation.vala"
	_tmp10_ = (*count_data)[3];
#line 1022 "../src/ColorTransformation.vala"
	_tmp11_ = (*count_data)[4];
#line 1022 "../src/ColorTransformation.vala"
	(*count_data)[2] = (((((2 * _tmp7_) + (3 * _tmp8_)) + (5 * _tmp9_)) + (3 * _tmp10_)) + (2 * _tmp11_)) / 15;
#line 1024 "../src/ColorTransformation.vala"
	_tmp12_ = (*count_data)[1];
#line 1024 "../src/ColorTransformation.vala"
	_tmp13_ = (*count_data)[2];
#line 1024 "../src/ColorTransformation.vala"
	_tmp14_ = (*count_data)[3];
#line 1024 "../src/ColorTransformation.vala"
	_tmp15_ = (*count_data)[4];
#line 1024 "../src/ColorTransformation.vala"
	_tmp16_ = (*count_data)[5];
#line 1024 "../src/ColorTransformation.vala"
	(*count_data)[3] = (((((2 * _tmp12_) + (3 * _tmp13_)) + (5 * _tmp14_)) + (3 * _tmp15_)) + (2 * _tmp16_)) / 15;
#line 1026 "../src/ColorTransformation.vala"
	_tmp17_ = (*count_data)[2];
#line 1026 "../src/ColorTransformation.vala"
	_tmp18_ = (*count_data)[3];
#line 1026 "../src/ColorTransformation.vala"
	_tmp19_ = (*count_data)[4];
#line 1026 "../src/ColorTransformation.vala"
	_tmp20_ = (*count_data)[5];
#line 1026 "../src/ColorTransformation.vala"
	_tmp21_ = (*count_data)[6];
#line 1026 "../src/ColorTransformation.vala"
	(*count_data)[4] = (((((2 * _tmp17_) + (3 * _tmp18_)) + (5 * _tmp19_)) + (3 * _tmp20_)) + (2 * _tmp21_)) / 15;
#line 1029 "../src/ColorTransformation.vala"
	_tmp22_ = (*count_data)[255];
#line 1029 "../src/ColorTransformation.vala"
	_tmp23_ = (*count_data)[254];
#line 1029 "../src/ColorTransformation.vala"
	_tmp24_ = (*count_data)[253];
#line 1029 "../src/ColorTransformation.vala"
	(*count_data)[255] = (((5 * _tmp22_) + (3 * _tmp23_)) + (2 * _tmp24_)) / 10;
#line 1031 "../src/ColorTransformation.vala"
	_tmp25_ = (*count_data)[255];
#line 1031 "../src/ColorTransformation.vala"
	_tmp26_ = (*count_data)[254];
#line 1031 "../src/ColorTransformation.vala"
	_tmp27_ = (*count_data)[253];
#line 1031 "../src/ColorTransformation.vala"
	_tmp28_ = (*count_data)[252];
#line 1031 "../src/ColorTransformation.vala"
	(*count_data)[254] = ((((3 * _tmp25_) + (5 * _tmp26_)) + (3 * _tmp27_)) + (2 * _tmp28_)) / 13;
#line 1033 "../src/ColorTransformation.vala"
	_tmp29_ = (*count_data)[255];
#line 1033 "../src/ColorTransformation.vala"
	_tmp30_ = (*count_data)[254];
#line 1033 "../src/ColorTransformation.vala"
	_tmp31_ = (*count_data)[253];
#line 1033 "../src/ColorTransformation.vala"
	_tmp32_ = (*count_data)[252];
#line 1033 "../src/ColorTransformation.vala"
	_tmp33_ = (*count_data)[251];
#line 1033 "../src/ColorTransformation.vala"
	(*count_data)[253] = (((((2 * _tmp29_) + (3 * _tmp30_)) + (5 * _tmp31_)) + (3 * _tmp32_)) + (2 * _tmp33_)) / 15;
#line 1035 "../src/ColorTransformation.vala"
	_tmp34_ = (*count_data)[254];
#line 1035 "../src/ColorTransformation.vala"
	_tmp35_ = (*count_data)[253];
#line 1035 "../src/ColorTransformation.vala"
	_tmp36_ = (*count_data)[252];
#line 1035 "../src/ColorTransformation.vala"
	_tmp37_ = (*count_data)[251];
#line 1035 "../src/ColorTransformation.vala"
	_tmp38_ = (*count_data)[250];
#line 1035 "../src/ColorTransformation.vala"
	(*count_data)[252] = (((((2 * _tmp34_) + (3 * _tmp35_)) + (5 * _tmp36_)) + (3 * _tmp37_)) + (2 * _tmp38_)) / 15;
#line 1037 "../src/ColorTransformation.vala"
	_tmp39_ = (*count_data)[253];
#line 1037 "../src/ColorTransformation.vala"
	_tmp40_ = (*count_data)[252];
#line 1037 "../src/ColorTransformation.vala"
	_tmp41_ = (*count_data)[251];
#line 1037 "../src/ColorTransformation.vala"
	_tmp42_ = (*count_data)[250];
#line 1037 "../src/ColorTransformation.vala"
	_tmp43_ = (*count_data)[249];
#line 1037 "../src/ColorTransformation.vala"
	(*count_data)[251] = (((((2 * _tmp39_) + (3 * _tmp40_)) + (5 * _tmp41_)) + (3 * _tmp42_)) + (2 * _tmp43_)) / 15;
#line 7303 "ColorTransformation.c"
}

static void
rgb_histogram_prepare_qualitative_counts (RGBHistogram* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint* _tmp5_;
	gint* _tmp6_;
	gint* _tmp7_;
	gint* temp_red_counts = NULL;
	gint* _tmp8_;
	gint temp_red_counts_length1;
	gint _temp_red_counts_size_;
	gint* temp_green_counts = NULL;
	gint* _tmp9_;
	gint temp_green_counts_length1;
	gint _temp_green_counts_size_;
	gint* temp_blue_counts = NULL;
	gint* _tmp10_;
	gint temp_blue_counts_length1;
	gint _temp_blue_counts_size_;
	gint mean_qual_count = 0;
	gint constrained_max_qual_count = 0;
#line 1041 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 1042 "../src/ColorTransformation.vala"
	_tmp2_ = self->priv->qualitative_red_counts;
#line 1042 "../src/ColorTransformation.vala"
	_tmp2__length1 = self->priv->qualitative_red_counts_length1;
#line 1042 "../src/ColorTransformation.vala"
	if (_tmp2_ != NULL) {
#line 7338 "ColorTransformation.c"
		gint* _tmp3_;
		gint _tmp3__length1;
#line 1042 "../src/ColorTransformation.vala"
		_tmp3_ = self->priv->qualitative_green_counts;
#line 1042 "../src/ColorTransformation.vala"
		_tmp3__length1 = self->priv->qualitative_green_counts_length1;
#line 1042 "../src/ColorTransformation.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 7347 "ColorTransformation.c"
	} else {
#line 1042 "../src/ColorTransformation.vala"
		_tmp1_ = FALSE;
#line 7351 "ColorTransformation.c"
	}
#line 1042 "../src/ColorTransformation.vala"
	if (_tmp1_) {
#line 7355 "ColorTransformation.c"
		gint* _tmp4_;
		gint _tmp4__length1;
#line 1043 "../src/ColorTransformation.vala"
		_tmp4_ = self->priv->qualitative_blue_counts;
#line 1043 "../src/ColorTransformation.vala"
		_tmp4__length1 = self->priv->qualitative_blue_counts_length1;
#line 1043 "../src/ColorTransformation.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 7364 "ColorTransformation.c"
	} else {
#line 1042 "../src/ColorTransformation.vala"
		_tmp0_ = FALSE;
#line 7368 "ColorTransformation.c"
	}
#line 1042 "../src/ColorTransformation.vala"
	if (_tmp0_) {
#line 1044 "../src/ColorTransformation.vala"
		return;
#line 7374 "ColorTransformation.c"
	}
#line 1046 "../src/ColorTransformation.vala"
	_tmp5_ = g_new0 (gint, 256);
#line 1046 "../src/ColorTransformation.vala"
	self->priv->qualitative_red_counts = (g_free (self->priv->qualitative_red_counts), NULL);
#line 1046 "../src/ColorTransformation.vala"
	self->priv->qualitative_red_counts = _tmp5_;
#line 1046 "../src/ColorTransformation.vala"
	self->priv->qualitative_red_counts_length1 = 256;
#line 1046 "../src/ColorTransformation.vala"
	self->priv->_qualitative_red_counts_size_ = self->priv->qualitative_red_counts_length1;
#line 1047 "../src/ColorTransformation.vala"
	_tmp6_ = g_new0 (gint, 256);
#line 1047 "../src/ColorTransformation.vala"
	self->priv->qualitative_green_counts = (g_free (self->priv->qualitative_green_counts), NULL);
#line 1047 "../src/ColorTransformation.vala"
	self->priv->qualitative_green_counts = _tmp6_;
#line 1047 "../src/ColorTransformation.vala"
	self->priv->qualitative_green_counts_length1 = 256;
#line 1047 "../src/ColorTransformation.vala"
	self->priv->_qualitative_green_counts_size_ = self->priv->qualitative_green_counts_length1;
#line 1048 "../src/ColorTransformation.vala"
	_tmp7_ = g_new0 (gint, 256);
#line 1048 "../src/ColorTransformation.vala"
	self->priv->qualitative_blue_counts = (g_free (self->priv->qualitative_blue_counts), NULL);
#line 1048 "../src/ColorTransformation.vala"
	self->priv->qualitative_blue_counts = _tmp7_;
#line 1048 "../src/ColorTransformation.vala"
	self->priv->qualitative_blue_counts_length1 = 256;
#line 1048 "../src/ColorTransformation.vala"
	self->priv->_qualitative_blue_counts_size_ = self->priv->qualitative_blue_counts_length1;
#line 1050 "../src/ColorTransformation.vala"
	_tmp8_ = g_new0 (gint, 256);
#line 1050 "../src/ColorTransformation.vala"
	temp_red_counts = _tmp8_;
#line 1050 "../src/ColorTransformation.vala"
	temp_red_counts_length1 = 256;
#line 1050 "../src/ColorTransformation.vala"
	_temp_red_counts_size_ = temp_red_counts_length1;
#line 1051 "../src/ColorTransformation.vala"
	_tmp9_ = g_new0 (gint, 256);
#line 1051 "../src/ColorTransformation.vala"
	temp_green_counts = _tmp9_;
#line 1051 "../src/ColorTransformation.vala"
	temp_green_counts_length1 = 256;
#line 1051 "../src/ColorTransformation.vala"
	_temp_green_counts_size_ = temp_green_counts_length1;
#line 1052 "../src/ColorTransformation.vala"
	_tmp10_ = g_new0 (gint, 256);
#line 1052 "../src/ColorTransformation.vala"
	temp_blue_counts = _tmp10_;
#line 1052 "../src/ColorTransformation.vala"
	temp_blue_counts_length1 = 256;
#line 1052 "../src/ColorTransformation.vala"
	_temp_blue_counts_size_ = temp_blue_counts_length1;
#line 7430 "ColorTransformation.c"
	{
		gint i = 0;
#line 1058 "../src/ColorTransformation.vala"
		i = 0;
#line 7435 "ColorTransformation.c"
		{
			gboolean _tmp11_ = FALSE;
#line 1058 "../src/ColorTransformation.vala"
			_tmp11_ = TRUE;
#line 1058 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 7442 "ColorTransformation.c"
				gint* _tmp13_;
				gint _tmp13__length1;
				gint* _tmp14_;
				gint _tmp14__length1;
				gint* _tmp15_;
				gint _tmp15__length1;
				gint* _tmp16_;
				gint _tmp16__length1;
				gint* _tmp17_;
				gint _tmp17__length1;
				gint* _tmp18_;
				gint _tmp18__length1;
#line 1058 "../src/ColorTransformation.vala"
				if (!_tmp11_) {
#line 7457 "ColorTransformation.c"
					gint _tmp12_;
#line 1058 "../src/ColorTransformation.vala"
					_tmp12_ = i;
#line 1058 "../src/ColorTransformation.vala"
					i = _tmp12_ + 1;
#line 7463 "ColorTransformation.c"
				}
#line 1058 "../src/ColorTransformation.vala"
				_tmp11_ = FALSE;
#line 1058 "../src/ColorTransformation.vala"
				if (!(i < 256)) {
#line 1058 "../src/ColorTransformation.vala"
					break;
#line 7471 "ColorTransformation.c"
				}
#line 1059 "../src/ColorTransformation.vala"
				_tmp13_ = self->priv->qualitative_red_counts;
#line 1059 "../src/ColorTransformation.vala"
				_tmp13__length1 = self->priv->qualitative_red_counts_length1;
#line 1059 "../src/ColorTransformation.vala"
				_tmp14_ = self->priv->red_counts;
#line 1059 "../src/ColorTransformation.vala"
				_tmp14__length1 = self->priv->red_counts_length1;
#line 1059 "../src/ColorTransformation.vala"
				_tmp13_[i] = rgb_histogram_correct_snap_from_quantization (self, _tmp14_, (gint) _tmp14__length1, i);
#line 1061 "../src/ColorTransformation.vala"
				_tmp15_ = self->priv->qualitative_green_counts;
#line 1061 "../src/ColorTransformation.vala"
				_tmp15__length1 = self->priv->qualitative_green_counts_length1;
#line 1061 "../src/ColorTransformation.vala"
				_tmp16_ = self->priv->green_counts;
#line 1061 "../src/ColorTransformation.vala"
				_tmp16__length1 = self->priv->green_counts_length1;
#line 1061 "../src/ColorTransformation.vala"
				_tmp15_[i] = rgb_histogram_correct_snap_from_quantization (self, _tmp16_, (gint) _tmp16__length1, i);
#line 1063 "../src/ColorTransformation.vala"
				_tmp17_ = self->priv->qualitative_blue_counts;
#line 1063 "../src/ColorTransformation.vala"
				_tmp17__length1 = self->priv->qualitative_blue_counts_length1;
#line 1063 "../src/ColorTransformation.vala"
				_tmp18_ = self->priv->blue_counts;
#line 1063 "../src/ColorTransformation.vala"
				_tmp18__length1 = self->priv->blue_counts_length1;
#line 1063 "../src/ColorTransformation.vala"
				_tmp17_[i] = rgb_histogram_correct_snap_from_quantization (self, _tmp18_, (gint) _tmp18__length1, i);
#line 7503 "ColorTransformation.c"
			}
		}
	}
	{
		gint i = 0;
#line 1067 "../src/ColorTransformation.vala"
		i = 0;
#line 7511 "ColorTransformation.c"
		{
			gboolean _tmp19_ = FALSE;
#line 1067 "../src/ColorTransformation.vala"
			_tmp19_ = TRUE;
#line 1067 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 7518 "ColorTransformation.c"
				gint* _tmp21_;
				gint _tmp21__length1;
				gint* _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_;
				gint* _tmp24_;
				gint _tmp24__length1;
				gint* _tmp25_;
				gint _tmp25__length1;
				gint _tmp26_;
				gint* _tmp27_;
				gint _tmp27__length1;
				gint* _tmp28_;
				gint _tmp28__length1;
				gint _tmp29_;
#line 1067 "../src/ColorTransformation.vala"
				if (!_tmp19_) {
#line 7536 "ColorTransformation.c"
					gint _tmp20_;
#line 1067 "../src/ColorTransformation.vala"
					_tmp20_ = i;
#line 1067 "../src/ColorTransformation.vala"
					i = _tmp20_ + 1;
#line 7542 "ColorTransformation.c"
				}
#line 1067 "../src/ColorTransformation.vala"
				_tmp19_ = FALSE;
#line 1067 "../src/ColorTransformation.vala"
				if (!(i < 256)) {
#line 1067 "../src/ColorTransformation.vala"
					break;
#line 7550 "ColorTransformation.c"
				}
#line 1068 "../src/ColorTransformation.vala"
				_tmp21_ = temp_red_counts;
#line 1068 "../src/ColorTransformation.vala"
				_tmp21__length1 = temp_red_counts_length1;
#line 1068 "../src/ColorTransformation.vala"
				_tmp22_ = self->priv->qualitative_red_counts;
#line 1068 "../src/ColorTransformation.vala"
				_tmp22__length1 = self->priv->qualitative_red_counts_length1;
#line 1068 "../src/ColorTransformation.vala"
				_tmp23_ = _tmp22_[i];
#line 1068 "../src/ColorTransformation.vala"
				_tmp21_[i] = _tmp23_;
#line 1069 "../src/ColorTransformation.vala"
				_tmp24_ = temp_green_counts;
#line 1069 "../src/ColorTransformation.vala"
				_tmp24__length1 = temp_green_counts_length1;
#line 1069 "../src/ColorTransformation.vala"
				_tmp25_ = self->priv->qualitative_green_counts;
#line 1069 "../src/ColorTransformation.vala"
				_tmp25__length1 = self->priv->qualitative_green_counts_length1;
#line 1069 "../src/ColorTransformation.vala"
				_tmp26_ = _tmp25_[i];
#line 1069 "../src/ColorTransformation.vala"
				_tmp24_[i] = _tmp26_;
#line 1070 "../src/ColorTransformation.vala"
				_tmp27_ = temp_blue_counts;
#line 1070 "../src/ColorTransformation.vala"
				_tmp27__length1 = temp_blue_counts_length1;
#line 1070 "../src/ColorTransformation.vala"
				_tmp28_ = self->priv->qualitative_blue_counts;
#line 1070 "../src/ColorTransformation.vala"
				_tmp28__length1 = self->priv->qualitative_blue_counts_length1;
#line 1070 "../src/ColorTransformation.vala"
				_tmp29_ = _tmp28_[i];
#line 1070 "../src/ColorTransformation.vala"
				_tmp27_[i] = _tmp29_;
#line 7588 "ColorTransformation.c"
			}
		}
	}
	{
		gint i = 0;
#line 1075 "../src/ColorTransformation.vala"
		i = 0;
#line 7596 "ColorTransformation.c"
		{
			gboolean _tmp30_ = FALSE;
#line 1075 "../src/ColorTransformation.vala"
			_tmp30_ = TRUE;
#line 1075 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 7603 "ColorTransformation.c"
				gint* _tmp32_;
				gint _tmp32__length1;
				gint* _tmp33_;
				gint _tmp33__length1;
				gint* _tmp34_;
				gint _tmp34__length1;
				gint* _tmp35_;
				gint _tmp35__length1;
				gint* _tmp36_;
				gint _tmp36__length1;
				gint* _tmp37_;
				gint _tmp37__length1;
#line 1075 "../src/ColorTransformation.vala"
				if (!_tmp30_) {
#line 7618 "ColorTransformation.c"
					gint _tmp31_;
#line 1075 "../src/ColorTransformation.vala"
					_tmp31_ = i;
#line 1075 "../src/ColorTransformation.vala"
					i = _tmp31_ + 1;
#line 7624 "ColorTransformation.c"
				}
#line 1075 "../src/ColorTransformation.vala"
				_tmp30_ = FALSE;
#line 1075 "../src/ColorTransformation.vala"
				if (!(i < 256)) {
#line 1075 "../src/ColorTransformation.vala"
					break;
#line 7632 "ColorTransformation.c"
				}
#line 1076 "../src/ColorTransformation.vala"
				_tmp32_ = self->priv->qualitative_red_counts;
#line 1076 "../src/ColorTransformation.vala"
				_tmp32__length1 = self->priv->qualitative_red_counts_length1;
#line 1076 "../src/ColorTransformation.vala"
				_tmp33_ = temp_red_counts;
#line 1076 "../src/ColorTransformation.vala"
				_tmp33__length1 = temp_red_counts_length1;
#line 1076 "../src/ColorTransformation.vala"
				_tmp32_[i] = rgb_histogram_correct_snap_to_quantization (self, _tmp33_, (gint) _tmp33__length1, i);
#line 1078 "../src/ColorTransformation.vala"
				_tmp34_ = self->priv->qualitative_green_counts;
#line 1078 "../src/ColorTransformation.vala"
				_tmp34__length1 = self->priv->qualitative_green_counts_length1;
#line 1078 "../src/ColorTransformation.vala"
				_tmp35_ = temp_green_counts;
#line 1078 "../src/ColorTransformation.vala"
				_tmp35__length1 = temp_green_counts_length1;
#line 1078 "../src/ColorTransformation.vala"
				_tmp34_[i] = rgb_histogram_correct_snap_to_quantization (self, _tmp35_, (gint) _tmp35__length1, i);
#line 1080 "../src/ColorTransformation.vala"
				_tmp36_ = self->priv->qualitative_blue_counts;
#line 1080 "../src/ColorTransformation.vala"
				_tmp36__length1 = self->priv->qualitative_blue_counts_length1;
#line 1080 "../src/ColorTransformation.vala"
				_tmp37_ = temp_blue_counts;
#line 1080 "../src/ColorTransformation.vala"
				_tmp37__length1 = temp_blue_counts_length1;
#line 1080 "../src/ColorTransformation.vala"
				_tmp36_[i] = rgb_histogram_correct_snap_to_quantization (self, _tmp37_, (gint) _tmp37__length1, i);
#line 7664 "ColorTransformation.c"
			}
		}
	}
#line 1086 "../src/ColorTransformation.vala"
	mean_qual_count = 0;
#line 7670 "ColorTransformation.c"
	{
		gint i = 0;
#line 1087 "../src/ColorTransformation.vala"
		i = 0;
#line 7675 "ColorTransformation.c"
		{
			gboolean _tmp38_ = FALSE;
#line 1087 "../src/ColorTransformation.vala"
			_tmp38_ = TRUE;
#line 1087 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 7682 "ColorTransformation.c"
				gint* _tmp40_;
				gint _tmp40__length1;
				gint _tmp41_;
				gint* _tmp42_;
				gint _tmp42__length1;
				gint _tmp43_;
				gint* _tmp44_;
				gint _tmp44__length1;
				gint _tmp45_;
#line 1087 "../src/ColorTransformation.vala"
				if (!_tmp38_) {
#line 7694 "ColorTransformation.c"
					gint _tmp39_;
#line 1087 "../src/ColorTransformation.vala"
					_tmp39_ = i;
#line 1087 "../src/ColorTransformation.vala"
					i = _tmp39_ + 1;
#line 7700 "ColorTransformation.c"
				}
#line 1087 "../src/ColorTransformation.vala"
				_tmp38_ = FALSE;
#line 1087 "../src/ColorTransformation.vala"
				if (!(i < 256)) {
#line 1087 "../src/ColorTransformation.vala"
					break;
#line 7708 "ColorTransformation.c"
				}
#line 1088 "../src/ColorTransformation.vala"
				_tmp40_ = self->priv->qualitative_red_counts;
#line 1088 "../src/ColorTransformation.vala"
				_tmp40__length1 = self->priv->qualitative_red_counts_length1;
#line 1088 "../src/ColorTransformation.vala"
				_tmp41_ = _tmp40_[i];
#line 1088 "../src/ColorTransformation.vala"
				_tmp42_ = self->priv->qualitative_green_counts;
#line 1088 "../src/ColorTransformation.vala"
				_tmp42__length1 = self->priv->qualitative_green_counts_length1;
#line 1088 "../src/ColorTransformation.vala"
				_tmp43_ = _tmp42_[i];
#line 1088 "../src/ColorTransformation.vala"
				_tmp44_ = self->priv->qualitative_blue_counts;
#line 1088 "../src/ColorTransformation.vala"
				_tmp44__length1 = self->priv->qualitative_blue_counts_length1;
#line 1088 "../src/ColorTransformation.vala"
				_tmp45_ = _tmp44_[i];
#line 1088 "../src/ColorTransformation.vala"
				mean_qual_count += (_tmp41_ + _tmp43_) + _tmp45_;
#line 7730 "ColorTransformation.c"
			}
		}
	}
#line 1091 "../src/ColorTransformation.vala"
	mean_qual_count /= 256 * 3;
#line 1092 "../src/ColorTransformation.vala"
	constrained_max_qual_count = 8 * mean_qual_count;
#line 7738 "ColorTransformation.c"
	{
		gint i = 0;
#line 1093 "../src/ColorTransformation.vala"
		i = 0;
#line 7743 "ColorTransformation.c"
		{
			gboolean _tmp46_ = FALSE;
#line 1093 "../src/ColorTransformation.vala"
			_tmp46_ = TRUE;
#line 1093 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 7750 "ColorTransformation.c"
				gint* _tmp48_;
				gint _tmp48__length1;
				gint _tmp49_;
				gint* _tmp51_;
				gint _tmp51__length1;
				gint _tmp52_;
				gint* _tmp54_;
				gint _tmp54__length1;
				gint _tmp55_;
#line 1093 "../src/ColorTransformation.vala"
				if (!_tmp46_) {
#line 7762 "ColorTransformation.c"
					gint _tmp47_;
#line 1093 "../src/ColorTransformation.vala"
					_tmp47_ = i;
#line 1093 "../src/ColorTransformation.vala"
					i = _tmp47_ + 1;
#line 7768 "ColorTransformation.c"
				}
#line 1093 "../src/ColorTransformation.vala"
				_tmp46_ = FALSE;
#line 1093 "../src/ColorTransformation.vala"
				if (!(i < 256)) {
#line 1093 "../src/ColorTransformation.vala"
					break;
#line 7776 "ColorTransformation.c"
				}
#line 1094 "../src/ColorTransformation.vala"
				_tmp48_ = self->priv->qualitative_red_counts;
#line 1094 "../src/ColorTransformation.vala"
				_tmp48__length1 = self->priv->qualitative_red_counts_length1;
#line 1094 "../src/ColorTransformation.vala"
				_tmp49_ = _tmp48_[i];
#line 1094 "../src/ColorTransformation.vala"
				if (_tmp49_ > constrained_max_qual_count) {
#line 7786 "ColorTransformation.c"
					gint* _tmp50_;
					gint _tmp50__length1;
#line 1095 "../src/ColorTransformation.vala"
					_tmp50_ = self->priv->qualitative_red_counts;
#line 1095 "../src/ColorTransformation.vala"
					_tmp50__length1 = self->priv->qualitative_red_counts_length1;
#line 1095 "../src/ColorTransformation.vala"
					_tmp50_[i] = constrained_max_qual_count;
#line 7795 "ColorTransformation.c"
				}
#line 1097 "../src/ColorTransformation.vala"
				_tmp51_ = self->priv->qualitative_green_counts;
#line 1097 "../src/ColorTransformation.vala"
				_tmp51__length1 = self->priv->qualitative_green_counts_length1;
#line 1097 "../src/ColorTransformation.vala"
				_tmp52_ = _tmp51_[i];
#line 1097 "../src/ColorTransformation.vala"
				if (_tmp52_ > constrained_max_qual_count) {
#line 7805 "ColorTransformation.c"
					gint* _tmp53_;
					gint _tmp53__length1;
#line 1098 "../src/ColorTransformation.vala"
					_tmp53_ = self->priv->qualitative_green_counts;
#line 1098 "../src/ColorTransformation.vala"
					_tmp53__length1 = self->priv->qualitative_green_counts_length1;
#line 1098 "../src/ColorTransformation.vala"
					_tmp53_[i] = constrained_max_qual_count;
#line 7814 "ColorTransformation.c"
				}
#line 1100 "../src/ColorTransformation.vala"
				_tmp54_ = self->priv->qualitative_blue_counts;
#line 1100 "../src/ColorTransformation.vala"
				_tmp54__length1 = self->priv->qualitative_blue_counts_length1;
#line 1100 "../src/ColorTransformation.vala"
				_tmp55_ = _tmp54_[i];
#line 1100 "../src/ColorTransformation.vala"
				if (_tmp55_ > constrained_max_qual_count) {
#line 7824 "ColorTransformation.c"
					gint* _tmp56_;
					gint _tmp56__length1;
#line 1101 "../src/ColorTransformation.vala"
					_tmp56_ = self->priv->qualitative_blue_counts;
#line 1101 "../src/ColorTransformation.vala"
					_tmp56__length1 = self->priv->qualitative_blue_counts_length1;
#line 1101 "../src/ColorTransformation.vala"
					_tmp56_[i] = constrained_max_qual_count;
#line 7833 "ColorTransformation.c"
				}
			}
		}
	}
#line 1104 "../src/ColorTransformation.vala"
	rgb_histogram_smooth_extrema (self, &self->priv->qualitative_red_counts, (gint*) (&self->priv->qualitative_red_counts_length1));
#line 1104 "../src/ColorTransformation.vala"
	self->priv->_qualitative_red_counts_size_ = self->priv->qualitative_red_counts_length1;
#line 1105 "../src/ColorTransformation.vala"
	rgb_histogram_smooth_extrema (self, &self->priv->qualitative_green_counts, (gint*) (&self->priv->qualitative_green_counts_length1));
#line 1105 "../src/ColorTransformation.vala"
	self->priv->_qualitative_green_counts_size_ = self->priv->qualitative_green_counts_length1;
#line 1106 "../src/ColorTransformation.vala"
	rgb_histogram_smooth_extrema (self, &self->priv->qualitative_blue_counts, (gint*) (&self->priv->qualitative_blue_counts_length1));
#line 1106 "../src/ColorTransformation.vala"
	self->priv->_qualitative_blue_counts_size_ = self->priv->qualitative_blue_counts_length1;
#line 1041 "../src/ColorTransformation.vala"
	temp_blue_counts = (g_free (temp_blue_counts), NULL);
#line 1041 "../src/ColorTransformation.vala"
	temp_green_counts = (g_free (temp_green_counts), NULL);
#line 1041 "../src/ColorTransformation.vala"
	temp_red_counts = (g_free (temp_red_counts), NULL);
#line 7856 "ColorTransformation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 1140 "../src/ColorTransformation.vala"
	return self ? g_object_ref (self) : NULL;
#line 7864 "ColorTransformation.c"
}

GdkPixbuf*
rgb_histogram_get_graphic (RGBHistogram* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp55_;
	GdkPixbuf* _tmp56_;
	GdkPixbuf* result;
#line 1109 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1110 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->graphic;
#line 1110 "../src/ColorTransformation.vala"
	if (_tmp0_ == NULL) {
#line 7880 "ColorTransformation.c"
		gint max_count = 0;
		GdkPixbuf* _tmp15_;
		gint rowstride = 0;
		GdkPixbuf* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint sample_bytes = 0;
		GdkPixbuf* _tmp19_;
		gint pixel_bytes = 0;
		GdkPixbuf* _tmp20_;
		gdouble scale_bar = 0.0;
		guchar* pixel_data = NULL;
		GdkPixbuf* _tmp21_;
		guint8* _tmp22_;
		gint pixel_data_length1;
		gint _pixel_data_size_;
#line 1111 "../src/ColorTransformation.vala"
		rgb_histogram_prepare_qualitative_counts (self);
#line 1112 "../src/ColorTransformation.vala"
		max_count = 0;
#line 7901 "ColorTransformation.c"
		{
			gint i = 0;
#line 1113 "../src/ColorTransformation.vala"
			i = 0;
#line 7906 "ColorTransformation.c"
			{
				gboolean _tmp1_ = FALSE;
#line 1113 "../src/ColorTransformation.vala"
				_tmp1_ = TRUE;
#line 1113 "../src/ColorTransformation.vala"
				while (TRUE) {
#line 7913 "ColorTransformation.c"
					gint* _tmp3_;
					gint _tmp3__length1;
					gint _tmp4_;
					gint* _tmp7_;
					gint _tmp7__length1;
					gint _tmp8_;
					gint* _tmp11_;
					gint _tmp11__length1;
					gint _tmp12_;
#line 1113 "../src/ColorTransformation.vala"
					if (!_tmp1_) {
#line 7925 "ColorTransformation.c"
						gint _tmp2_;
#line 1113 "../src/ColorTransformation.vala"
						_tmp2_ = i;
#line 1113 "../src/ColorTransformation.vala"
						i = _tmp2_ + 1;
#line 7931 "ColorTransformation.c"
					}
#line 1113 "../src/ColorTransformation.vala"
					_tmp1_ = FALSE;
#line 1113 "../src/ColorTransformation.vala"
					if (!(i < 256)) {
#line 1113 "../src/ColorTransformation.vala"
						break;
#line 7939 "ColorTransformation.c"
					}
#line 1114 "../src/ColorTransformation.vala"
					_tmp3_ = self->priv->qualitative_red_counts;
#line 1114 "../src/ColorTransformation.vala"
					_tmp3__length1 = self->priv->qualitative_red_counts_length1;
#line 1114 "../src/ColorTransformation.vala"
					_tmp4_ = _tmp3_[i];
#line 1114 "../src/ColorTransformation.vala"
					if (_tmp4_ > max_count) {
#line 7949 "ColorTransformation.c"
						gint* _tmp5_;
						gint _tmp5__length1;
						gint _tmp6_;
#line 1115 "../src/ColorTransformation.vala"
						_tmp5_ = self->priv->qualitative_red_counts;
#line 1115 "../src/ColorTransformation.vala"
						_tmp5__length1 = self->priv->qualitative_red_counts_length1;
#line 1115 "../src/ColorTransformation.vala"
						_tmp6_ = _tmp5_[i];
#line 1115 "../src/ColorTransformation.vala"
						max_count = _tmp6_;
#line 7961 "ColorTransformation.c"
					}
#line 1116 "../src/ColorTransformation.vala"
					_tmp7_ = self->priv->qualitative_green_counts;
#line 1116 "../src/ColorTransformation.vala"
					_tmp7__length1 = self->priv->qualitative_green_counts_length1;
#line 1116 "../src/ColorTransformation.vala"
					_tmp8_ = _tmp7_[i];
#line 1116 "../src/ColorTransformation.vala"
					if (_tmp8_ > max_count) {
#line 7971 "ColorTransformation.c"
						gint* _tmp9_;
						gint _tmp9__length1;
						gint _tmp10_;
#line 1117 "../src/ColorTransformation.vala"
						_tmp9_ = self->priv->qualitative_green_counts;
#line 1117 "../src/ColorTransformation.vala"
						_tmp9__length1 = self->priv->qualitative_green_counts_length1;
#line 1117 "../src/ColorTransformation.vala"
						_tmp10_ = _tmp9_[i];
#line 1117 "../src/ColorTransformation.vala"
						max_count = _tmp10_;
#line 7983 "ColorTransformation.c"
					}
#line 1118 "../src/ColorTransformation.vala"
					_tmp11_ = self->priv->qualitative_blue_counts;
#line 1118 "../src/ColorTransformation.vala"
					_tmp11__length1 = self->priv->qualitative_blue_counts_length1;
#line 1118 "../src/ColorTransformation.vala"
					_tmp12_ = _tmp11_[i];
#line 1118 "../src/ColorTransformation.vala"
					if (_tmp12_ > max_count) {
#line 7993 "ColorTransformation.c"
						gint* _tmp13_;
						gint _tmp13__length1;
						gint _tmp14_;
#line 1119 "../src/ColorTransformation.vala"
						_tmp13_ = self->priv->qualitative_blue_counts;
#line 1119 "../src/ColorTransformation.vala"
						_tmp13__length1 = self->priv->qualitative_blue_counts_length1;
#line 1119 "../src/ColorTransformation.vala"
						_tmp14_ = _tmp13_[i];
#line 1119 "../src/ColorTransformation.vala"
						max_count = _tmp14_;
#line 8005 "ColorTransformation.c"
					}
				}
			}
		}
#line 1122 "../src/ColorTransformation.vala"
		_tmp15_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, RGB_HISTOGRAM_GRAPHIC_WIDTH, RGB_HISTOGRAM_GRAPHIC_HEIGHT);
#line 1122 "../src/ColorTransformation.vala"
		_g_object_unref0 (self->priv->graphic);
#line 1122 "../src/ColorTransformation.vala"
		self->priv->graphic = _tmp15_;
#line 1125 "../src/ColorTransformation.vala"
		_tmp16_ = self->priv->graphic;
#line 1125 "../src/ColorTransformation.vala"
		_tmp17_ = gdk_pixbuf_get_rowstride (_tmp16_);
#line 1125 "../src/ColorTransformation.vala"
		_tmp18_ = _tmp17_;
#line 1125 "../src/ColorTransformation.vala"
		rowstride = _tmp18_;
#line 1126 "../src/ColorTransformation.vala"
		_tmp19_ = self->priv->graphic;
#line 1126 "../src/ColorTransformation.vala"
		sample_bytes = gdk_pixbuf_get_bits_per_sample (_tmp19_) / 8;
#line 1127 "../src/ColorTransformation.vala"
		_tmp20_ = self->priv->graphic;
#line 1127 "../src/ColorTransformation.vala"
		pixel_bytes = sample_bytes * gdk_pixbuf_get_n_channels (_tmp20_);
#line 1129 "../src/ColorTransformation.vala"
		scale_bar = (0.98 * ((gdouble) RGB_HISTOGRAM_GRAPHIC_HEIGHT)) / ((gdouble) max_count);
#line 1132 "../src/ColorTransformation.vala"
		_tmp21_ = self->priv->graphic;
#line 1132 "../src/ColorTransformation.vala"
		_tmp22_ = gdk_pixbuf_get_pixels (_tmp21_);
#line 1132 "../src/ColorTransformation.vala"
		pixel_data = _tmp22_;
#line 1132 "../src/ColorTransformation.vala"
		pixel_data_length1 = -1;
#line 1132 "../src/ColorTransformation.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 1136 "../src/ColorTransformation.vala"
		if (max_count == 0) {
#line 8046 "ColorTransformation.c"
			GdkPixbuf* _tmp32_;
			GdkPixbuf* _tmp33_;
			{
				gint i = 0;
#line 1137 "../src/ColorTransformation.vala"
				i = 0;
#line 8053 "ColorTransformation.c"
				{
					gboolean _tmp23_ = FALSE;
#line 1137 "../src/ColorTransformation.vala"
					_tmp23_ = TRUE;
#line 1137 "../src/ColorTransformation.vala"
					while (TRUE) {
#line 8060 "ColorTransformation.c"
						GdkPixbuf* _tmp25_;
						gint _tmp26_;
						gint _tmp27_;
						GdkPixbuf* _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
						guchar* _tmp31_;
						gint _tmp31__length1;
#line 1137 "../src/ColorTransformation.vala"
						if (!_tmp23_) {
#line 8071 "ColorTransformation.c"
							gint _tmp24_;
#line 1137 "../src/ColorTransformation.vala"
							_tmp24_ = i;
#line 1137 "../src/ColorTransformation.vala"
							i = _tmp24_ + 1;
#line 8077 "ColorTransformation.c"
						}
#line 1137 "../src/ColorTransformation.vala"
						_tmp23_ = FALSE;
#line 1137 "../src/ColorTransformation.vala"
						_tmp25_ = self->priv->graphic;
#line 1137 "../src/ColorTransformation.vala"
						_tmp26_ = gdk_pixbuf_get_width (_tmp25_);
#line 1137 "../src/ColorTransformation.vala"
						_tmp27_ = _tmp26_;
#line 1137 "../src/ColorTransformation.vala"
						_tmp28_ = self->priv->graphic;
#line 1137 "../src/ColorTransformation.vala"
						_tmp29_ = gdk_pixbuf_get_height (_tmp28_);
#line 1137 "../src/ColorTransformation.vala"
						_tmp30_ = _tmp29_;
#line 1137 "../src/ColorTransformation.vala"
						if (!(i < ((pixel_bytes * _tmp27_) * _tmp30_))) {
#line 1137 "../src/ColorTransformation.vala"
							break;
#line 8097 "ColorTransformation.c"
						}
#line 1138 "../src/ColorTransformation.vala"
						_tmp31_ = pixel_data;
#line 1138 "../src/ColorTransformation.vala"
						_tmp31__length1 = pixel_data_length1;
#line 1138 "../src/ColorTransformation.vala"
						_tmp31_[i] = RGB_HISTOGRAM_UNMARKED_BACKGROUND;
#line 8105 "ColorTransformation.c"
					}
				}
			}
#line 1140 "../src/ColorTransformation.vala"
			_tmp32_ = self->priv->graphic;
#line 1140 "../src/ColorTransformation.vala"
			_tmp33_ = _g_object_ref0 (_tmp32_);
#line 1140 "../src/ColorTransformation.vala"
			result = _tmp33_;
#line 1140 "../src/ColorTransformation.vala"
			return result;
#line 8117 "ColorTransformation.c"
		}
		{
			gint x = 0;
#line 1143 "../src/ColorTransformation.vala"
			x = 0;
#line 8123 "ColorTransformation.c"
			{
				gboolean _tmp34_ = FALSE;
#line 1143 "../src/ColorTransformation.vala"
				_tmp34_ = TRUE;
#line 1143 "../src/ColorTransformation.vala"
				while (TRUE) {
#line 8130 "ColorTransformation.c"
					gint red_bar_height = 0;
					gint* _tmp36_;
					gint _tmp36__length1;
					gint _tmp37_;
					gint green_bar_height = 0;
					gint* _tmp38_;
					gint _tmp38__length1;
					gint _tmp39_;
					gint blue_bar_height = 0;
					gint* _tmp40_;
					gint _tmp40__length1;
					gint _tmp41_;
					gint max_bar_height = 0;
					gint y = 0;
					gint pixel_index = 0;
#line 1143 "../src/ColorTransformation.vala"
					if (!_tmp34_) {
#line 8148 "ColorTransformation.c"
						gint _tmp35_;
#line 1143 "../src/ColorTransformation.vala"
						_tmp35_ = x;
#line 1143 "../src/ColorTransformation.vala"
						x = _tmp35_ + 1;
#line 8154 "ColorTransformation.c"
					}
#line 1143 "../src/ColorTransformation.vala"
					_tmp34_ = FALSE;
#line 1143 "../src/ColorTransformation.vala"
					if (!(x < 256)) {
#line 1143 "../src/ColorTransformation.vala"
						break;
#line 8162 "ColorTransformation.c"
					}
#line 1144 "../src/ColorTransformation.vala"
					_tmp36_ = self->priv->qualitative_red_counts;
#line 1144 "../src/ColorTransformation.vala"
					_tmp36__length1 = self->priv->qualitative_red_counts_length1;
#line 1144 "../src/ColorTransformation.vala"
					_tmp37_ = _tmp36_[x];
#line 1144 "../src/ColorTransformation.vala"
					red_bar_height = (gint) (((gdouble) _tmp37_) * scale_bar);
#line 1146 "../src/ColorTransformation.vala"
					_tmp38_ = self->priv->qualitative_green_counts;
#line 1146 "../src/ColorTransformation.vala"
					_tmp38__length1 = self->priv->qualitative_green_counts_length1;
#line 1146 "../src/ColorTransformation.vala"
					_tmp39_ = _tmp38_[x];
#line 1146 "../src/ColorTransformation.vala"
					green_bar_height = (gint) (((gdouble) _tmp39_) * scale_bar);
#line 1148 "../src/ColorTransformation.vala"
					_tmp40_ = self->priv->qualitative_blue_counts;
#line 1148 "../src/ColorTransformation.vala"
					_tmp40__length1 = self->priv->qualitative_blue_counts_length1;
#line 1148 "../src/ColorTransformation.vala"
					_tmp41_ = _tmp40_[x];
#line 1148 "../src/ColorTransformation.vala"
					blue_bar_height = (gint) (((gdouble) _tmp41_) * scale_bar);
#line 1151 "../src/ColorTransformation.vala"
					max_bar_height = MAX (MAX (red_bar_height, green_bar_height), blue_bar_height);
#line 1154 "../src/ColorTransformation.vala"
					y = RGB_HISTOGRAM_GRAPHIC_HEIGHT - 1;
#line 1155 "../src/ColorTransformation.vala"
					pixel_index = (x * pixel_bytes) + (y * rowstride);
#line 8194 "ColorTransformation.c"
					{
						gboolean _tmp42_ = FALSE;
#line 1156 "../src/ColorTransformation.vala"
						_tmp42_ = TRUE;
#line 1156 "../src/ColorTransformation.vala"
						while (TRUE) {
#line 8201 "ColorTransformation.c"
							guchar* _tmp44_;
							gint _tmp44__length1;
							guchar* _tmp45_;
							gint _tmp45__length1;
							guchar* _tmp46_;
							gint _tmp46__length1;
#line 1156 "../src/ColorTransformation.vala"
							if (!_tmp42_) {
#line 8210 "ColorTransformation.c"
								gint _tmp43_;
#line 1156 "../src/ColorTransformation.vala"
								_tmp43_ = y;
#line 1156 "../src/ColorTransformation.vala"
								y = _tmp43_ - 1;
#line 8216 "ColorTransformation.c"
							}
#line 1156 "../src/ColorTransformation.vala"
							_tmp42_ = FALSE;
#line 1156 "../src/ColorTransformation.vala"
							if (!(y >= (RGB_HISTOGRAM_GRAPHIC_HEIGHT - max_bar_height))) {
#line 1156 "../src/ColorTransformation.vala"
								break;
#line 8224 "ColorTransformation.c"
							}
#line 1157 "../src/ColorTransformation.vala"
							_tmp44_ = pixel_data;
#line 1157 "../src/ColorTransformation.vala"
							_tmp44__length1 = pixel_data_length1;
#line 1157 "../src/ColorTransformation.vala"
							_tmp44_[pixel_index] = RGB_HISTOGRAM_MARKED_BACKGROUND;
#line 1158 "../src/ColorTransformation.vala"
							_tmp45_ = pixel_data;
#line 1158 "../src/ColorTransformation.vala"
							_tmp45__length1 = pixel_data_length1;
#line 1158 "../src/ColorTransformation.vala"
							_tmp45_[pixel_index + 1] = RGB_HISTOGRAM_MARKED_BACKGROUND;
#line 1159 "../src/ColorTransformation.vala"
							_tmp46_ = pixel_data;
#line 1159 "../src/ColorTransformation.vala"
							_tmp46__length1 = pixel_data_length1;
#line 1159 "../src/ColorTransformation.vala"
							_tmp46_[pixel_index + 2] = RGB_HISTOGRAM_MARKED_BACKGROUND;
#line 1161 "../src/ColorTransformation.vala"
							if (y >= ((RGB_HISTOGRAM_GRAPHIC_HEIGHT - red_bar_height) - 1)) {
#line 8246 "ColorTransformation.c"
								guchar* _tmp47_;
								gint _tmp47__length1;
#line 1162 "../src/ColorTransformation.vala"
								_tmp47_ = pixel_data;
#line 1162 "../src/ColorTransformation.vala"
								_tmp47__length1 = pixel_data_length1;
#line 1162 "../src/ColorTransformation.vala"
								_tmp47_[pixel_index] = RGB_HISTOGRAM_MARKED_FOREGROUND;
#line 8255 "ColorTransformation.c"
							}
#line 1163 "../src/ColorTransformation.vala"
							if (y >= ((RGB_HISTOGRAM_GRAPHIC_HEIGHT - green_bar_height) - 1)) {
#line 8259 "ColorTransformation.c"
								guchar* _tmp48_;
								gint _tmp48__length1;
#line 1164 "../src/ColorTransformation.vala"
								_tmp48_ = pixel_data;
#line 1164 "../src/ColorTransformation.vala"
								_tmp48__length1 = pixel_data_length1;
#line 1164 "../src/ColorTransformation.vala"
								_tmp48_[pixel_index + 1] = RGB_HISTOGRAM_MARKED_FOREGROUND;
#line 8268 "ColorTransformation.c"
							}
#line 1165 "../src/ColorTransformation.vala"
							if (y >= ((RGB_HISTOGRAM_GRAPHIC_HEIGHT - blue_bar_height) - 1)) {
#line 8272 "ColorTransformation.c"
								guchar* _tmp49_;
								gint _tmp49__length1;
#line 1166 "../src/ColorTransformation.vala"
								_tmp49_ = pixel_data;
#line 1166 "../src/ColorTransformation.vala"
								_tmp49__length1 = pixel_data_length1;
#line 1166 "../src/ColorTransformation.vala"
								_tmp49_[pixel_index + 2] = RGB_HISTOGRAM_MARKED_FOREGROUND;
#line 8281 "ColorTransformation.c"
							}
#line 1168 "../src/ColorTransformation.vala"
							pixel_index -= rowstride;
#line 8285 "ColorTransformation.c"
						}
					}
					{
						gboolean _tmp50_ = FALSE;
#line 1171 "../src/ColorTransformation.vala"
						_tmp50_ = TRUE;
#line 1171 "../src/ColorTransformation.vala"
						while (TRUE) {
#line 8294 "ColorTransformation.c"
							guchar* _tmp52_;
							gint _tmp52__length1;
							guchar* _tmp53_;
							gint _tmp53__length1;
							guchar* _tmp54_;
							gint _tmp54__length1;
#line 1171 "../src/ColorTransformation.vala"
							if (!_tmp50_) {
#line 8303 "ColorTransformation.c"
								gint _tmp51_;
#line 1171 "../src/ColorTransformation.vala"
								_tmp51_ = y;
#line 1171 "../src/ColorTransformation.vala"
								y = _tmp51_ - 1;
#line 8309 "ColorTransformation.c"
							}
#line 1171 "../src/ColorTransformation.vala"
							_tmp50_ = FALSE;
#line 1171 "../src/ColorTransformation.vala"
							if (!(y >= 0)) {
#line 1171 "../src/ColorTransformation.vala"
								break;
#line 8317 "ColorTransformation.c"
							}
#line 1172 "../src/ColorTransformation.vala"
							_tmp52_ = pixel_data;
#line 1172 "../src/ColorTransformation.vala"
							_tmp52__length1 = pixel_data_length1;
#line 1172 "../src/ColorTransformation.vala"
							_tmp52_[pixel_index] = RGB_HISTOGRAM_UNMARKED_BACKGROUND;
#line 1173 "../src/ColorTransformation.vala"
							_tmp53_ = pixel_data;
#line 1173 "../src/ColorTransformation.vala"
							_tmp53__length1 = pixel_data_length1;
#line 1173 "../src/ColorTransformation.vala"
							_tmp53_[pixel_index + 1] = RGB_HISTOGRAM_UNMARKED_BACKGROUND;
#line 1174 "../src/ColorTransformation.vala"
							_tmp54_ = pixel_data;
#line 1174 "../src/ColorTransformation.vala"
							_tmp54__length1 = pixel_data_length1;
#line 1174 "../src/ColorTransformation.vala"
							_tmp54_[pixel_index + 2] = RGB_HISTOGRAM_UNMARKED_BACKGROUND;
#line 1176 "../src/ColorTransformation.vala"
							pixel_index -= rowstride;
#line 8339 "ColorTransformation.c"
						}
					}
				}
			}
		}
	}
#line 1181 "../src/ColorTransformation.vala"
	_tmp55_ = self->priv->graphic;
#line 1181 "../src/ColorTransformation.vala"
	_tmp56_ = _g_object_ref0 (_tmp55_);
#line 1181 "../src/ColorTransformation.vala"
	result = _tmp56_;
#line 1181 "../src/ColorTransformation.vala"
	return result;
#line 8354 "ColorTransformation.c"
}

static void
value_rgb_histogram_init (GValue* value)
{
#line 928 "../src/ColorTransformation.vala"
	value->data[0].v_pointer = NULL;
#line 8362 "ColorTransformation.c"
}

static void
value_rgb_histogram_free_value (GValue* value)
{
#line 928 "../src/ColorTransformation.vala"
	if (value->data[0].v_pointer) {
#line 928 "../src/ColorTransformation.vala"
		rgb_histogram_unref (value->data[0].v_pointer);
#line 8372 "ColorTransformation.c"
	}
}

static void
value_rgb_histogram_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 928 "../src/ColorTransformation.vala"
	if (src_value->data[0].v_pointer) {
#line 928 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = rgb_histogram_ref (src_value->data[0].v_pointer);
#line 8384 "ColorTransformation.c"
	} else {
#line 928 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8388 "ColorTransformation.c"
	}
}

static gpointer
value_rgb_histogram_peek_pointer (const GValue* value)
{
#line 928 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 8397 "ColorTransformation.c"
}

static gchar*
value_rgb_histogram_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 928 "../src/ColorTransformation.vala"
	if (collect_values[0].v_pointer) {
#line 8408 "ColorTransformation.c"
		RGBHistogram * object;
		object = collect_values[0].v_pointer;
#line 928 "../src/ColorTransformation.vala"
		if (object->parent_instance.g_class == NULL) {
#line 928 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8415 "ColorTransformation.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 928 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8419 "ColorTransformation.c"
		}
#line 928 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = rgb_histogram_ref (object);
#line 8423 "ColorTransformation.c"
	} else {
#line 928 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 8427 "ColorTransformation.c"
	}
#line 928 "../src/ColorTransformation.vala"
	return NULL;
#line 8431 "ColorTransformation.c"
}

static gchar*
value_rgb_histogram_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	RGBHistogram ** object_p;
	object_p = collect_values[0].v_pointer;
#line 928 "../src/ColorTransformation.vala"
	if (!object_p) {
#line 928 "../src/ColorTransformation.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8446 "ColorTransformation.c"
	}
#line 928 "../src/ColorTransformation.vala"
	if (!value->data[0].v_pointer) {
#line 928 "../src/ColorTransformation.vala"
		*object_p = NULL;
#line 8452 "ColorTransformation.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 928 "../src/ColorTransformation.vala"
		*object_p = value->data[0].v_pointer;
#line 8456 "ColorTransformation.c"
	} else {
#line 928 "../src/ColorTransformation.vala"
		*object_p = rgb_histogram_ref (value->data[0].v_pointer);
#line 8460 "ColorTransformation.c"
	}
#line 928 "../src/ColorTransformation.vala"
	return NULL;
#line 8464 "ColorTransformation.c"
}

GParamSpec*
param_spec_rgb_histogram (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecRGBHistogram* spec;
#line 928 "../src/ColorTransformation.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_RGB_HISTOGRAM), NULL);
#line 928 "../src/ColorTransformation.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 928 "../src/ColorTransformation.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 928 "../src/ColorTransformation.vala"
	return G_PARAM_SPEC (spec);
#line 8483 "ColorTransformation.c"
}

gpointer
value_get_rgb_histogram (const GValue* value)
{
#line 928 "../src/ColorTransformation.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RGB_HISTOGRAM), NULL);
#line 928 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 8493 "ColorTransformation.c"
}

void
value_set_rgb_histogram (GValue* value,
                         gpointer v_object)
{
	RGBHistogram * old;
#line 928 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RGB_HISTOGRAM));
#line 928 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 928 "../src/ColorTransformation.vala"
	if (v_object) {
#line 928 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_RGB_HISTOGRAM));
#line 928 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 928 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 928 "../src/ColorTransformation.vala"
		rgb_histogram_ref (value->data[0].v_pointer);
#line 8515 "ColorTransformation.c"
	} else {
#line 928 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 8519 "ColorTransformation.c"
	}
#line 928 "../src/ColorTransformation.vala"
	if (old) {
#line 928 "../src/ColorTransformation.vala"
		rgb_histogram_unref (old);
#line 8525 "ColorTransformation.c"
	}
}

void
value_take_rgb_histogram (GValue* value,
                          gpointer v_object)
{
	RGBHistogram * old;
#line 928 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RGB_HISTOGRAM));
#line 928 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 928 "../src/ColorTransformation.vala"
	if (v_object) {
#line 928 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_RGB_HISTOGRAM));
#line 928 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 928 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 8546 "ColorTransformation.c"
	} else {
#line 928 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 8550 "ColorTransformation.c"
	}
#line 928 "../src/ColorTransformation.vala"
	if (old) {
#line 928 "../src/ColorTransformation.vala"
		rgb_histogram_unref (old);
#line 8556 "ColorTransformation.c"
	}
}

static void
rgb_histogram_class_init (RGBHistogramClass * klass,
                          gpointer klass_data)
{
#line 928 "../src/ColorTransformation.vala"
	rgb_histogram_parent_class = g_type_class_peek_parent (klass);
#line 928 "../src/ColorTransformation.vala"
	((RGBHistogramClass *) klass)->finalize = rgb_histogram_finalize;
#line 928 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &RGBHistogram_private_offset);
#line 8570 "ColorTransformation.c"
}

static void
rgb_histogram_instance_init (RGBHistogram * self,
                             gpointer klass)
{
	gint* _tmp0_;
	gint* _tmp1_;
	gint* _tmp2_;
#line 928 "../src/ColorTransformation.vala"
	self->priv = rgb_histogram_get_instance_private (self);
#line 936 "../src/ColorTransformation.vala"
	_tmp0_ = g_new0 (gint, 256);
#line 936 "../src/ColorTransformation.vala"
	self->priv->red_counts = _tmp0_;
#line 936 "../src/ColorTransformation.vala"
	self->priv->red_counts_length1 = 256;
#line 936 "../src/ColorTransformation.vala"
	self->priv->_red_counts_size_ = self->priv->red_counts_length1;
#line 937 "../src/ColorTransformation.vala"
	_tmp1_ = g_new0 (gint, 256);
#line 937 "../src/ColorTransformation.vala"
	self->priv->green_counts = _tmp1_;
#line 937 "../src/ColorTransformation.vala"
	self->priv->green_counts_length1 = 256;
#line 937 "../src/ColorTransformation.vala"
	self->priv->_green_counts_size_ = self->priv->green_counts_length1;
#line 938 "../src/ColorTransformation.vala"
	_tmp2_ = g_new0 (gint, 256);
#line 938 "../src/ColorTransformation.vala"
	self->priv->blue_counts = _tmp2_;
#line 938 "../src/ColorTransformation.vala"
	self->priv->blue_counts_length1 = 256;
#line 938 "../src/ColorTransformation.vala"
	self->priv->_blue_counts_size_ = self->priv->blue_counts_length1;
#line 939 "../src/ColorTransformation.vala"
	self->priv->qualitative_red_counts = NULL;
#line 939 "../src/ColorTransformation.vala"
	self->priv->qualitative_red_counts_length1 = 0;
#line 939 "../src/ColorTransformation.vala"
	self->priv->_qualitative_red_counts_size_ = self->priv->qualitative_red_counts_length1;
#line 940 "../src/ColorTransformation.vala"
	self->priv->qualitative_green_counts = NULL;
#line 940 "../src/ColorTransformation.vala"
	self->priv->qualitative_green_counts_length1 = 0;
#line 940 "../src/ColorTransformation.vala"
	self->priv->_qualitative_green_counts_size_ = self->priv->qualitative_green_counts_length1;
#line 941 "../src/ColorTransformation.vala"
	self->priv->qualitative_blue_counts = NULL;
#line 941 "../src/ColorTransformation.vala"
	self->priv->qualitative_blue_counts_length1 = 0;
#line 941 "../src/ColorTransformation.vala"
	self->priv->_qualitative_blue_counts_size_ = self->priv->qualitative_blue_counts_length1;
#line 942 "../src/ColorTransformation.vala"
	self->priv->graphic = NULL;
#line 928 "../src/ColorTransformation.vala"
	self->ref_count = 1;
#line 8628 "ColorTransformation.c"
}

static void
rgb_histogram_finalize (RGBHistogram * obj)
{
	RGBHistogram * self;
#line 928 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RGB_HISTOGRAM, RGBHistogram);
#line 928 "../src/ColorTransformation.vala"
	g_signal_handlers_destroy (self);
#line 936 "../src/ColorTransformation.vala"
	self->priv->red_counts = (g_free (self->priv->red_counts), NULL);
#line 937 "../src/ColorTransformation.vala"
	self->priv->green_counts = (g_free (self->priv->green_counts), NULL);
#line 938 "../src/ColorTransformation.vala"
	self->priv->blue_counts = (g_free (self->priv->blue_counts), NULL);
#line 939 "../src/ColorTransformation.vala"
	self->priv->qualitative_red_counts = (g_free (self->priv->qualitative_red_counts), NULL);
#line 940 "../src/ColorTransformation.vala"
	self->priv->qualitative_green_counts = (g_free (self->priv->qualitative_green_counts), NULL);
#line 941 "../src/ColorTransformation.vala"
	self->priv->qualitative_blue_counts = (g_free (self->priv->qualitative_blue_counts), NULL);
#line 942 "../src/ColorTransformation.vala"
	_g_object_unref0 (self->priv->graphic);
#line 8653 "ColorTransformation.c"
}

static GType
rgb_histogram_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_rgb_histogram_init, value_rgb_histogram_free_value, value_rgb_histogram_copy_value, value_rgb_histogram_peek_pointer, "p", value_rgb_histogram_collect_value, "p", value_rgb_histogram_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (RGBHistogramClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rgb_histogram_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RGBHistogram), 0, (GInstanceInitFunc) rgb_histogram_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType rgb_histogram_type_id;
	rgb_histogram_type_id = g_type_register_fundamental (g_type_fundamental_next (), "RGBHistogram", &g_define_type_info, &g_define_type_fundamental_info, 0);
	RGBHistogram_private_offset = g_type_add_instance_private (rgb_histogram_type_id, sizeof (RGBHistogramPrivate));
	return rgb_histogram_type_id;
}

GType
rgb_histogram_get_type (void)
{
	static volatile gsize rgb_histogram_type_id__once = 0;
	if (g_once_init_enter (&rgb_histogram_type_id__once)) {
		GType rgb_histogram_type_id;
		rgb_histogram_type_id = rgb_histogram_get_type_once ();
		g_once_init_leave (&rgb_histogram_type_id__once, rgb_histogram_type_id);
	}
	return rgb_histogram_type_id__once;
}

gpointer
rgb_histogram_ref (gpointer instance)
{
	RGBHistogram * self;
	self = instance;
#line 928 "../src/ColorTransformation.vala"
	g_atomic_int_inc (&self->ref_count);
#line 928 "../src/ColorTransformation.vala"
	return instance;
#line 8689 "ColorTransformation.c"
}

void
rgb_histogram_unref (gpointer instance)
{
	RGBHistogram * self;
	self = instance;
#line 928 "../src/ColorTransformation.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 928 "../src/ColorTransformation.vala"
		RGB_HISTOGRAM_GET_CLASS (self)->finalize (self);
#line 928 "../src/ColorTransformation.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8703 "ColorTransformation.c"
	}
}

static inline gpointer
intensity_histogram_get_instance_private (IntensityHistogram* self)
{
	return G_STRUCT_MEMBER_P (self, IntensityHistogram_private_offset);
}

IntensityHistogram*
intensity_histogram_construct (GType object_type,
                               GdkPixbuf* pixbuf)
{
	IntensityHistogram* self = NULL;
	gint n_channels = 0;
	gint rowstride = 0;
	gint width = 0;
	gint height = 0;
	gint rowbytes = 0;
	guchar* pixels = NULL;
	guint8* _tmp0_;
	gint pixels_length1;
	gint _pixels_size_;
	gfloat pixel_count = 0.0F;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gfloat accumulator = 0.0F;
#line 1190 "../src/ColorTransformation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 1190 "../src/ColorTransformation.vala"
	self = (IntensityHistogram*) g_type_create_instance (object_type);
#line 1191 "../src/ColorTransformation.vala"
	n_channels = gdk_pixbuf_get_n_channels (pixbuf);
#line 1192 "../src/ColorTransformation.vala"
	rowstride = gdk_pixbuf_get_rowstride (pixbuf);
#line 1193 "../src/ColorTransformation.vala"
	width = gdk_pixbuf_get_width (pixbuf);
#line 1194 "../src/ColorTransformation.vala"
	height = gdk_pixbuf_get_height (pixbuf);
#line 1195 "../src/ColorTransformation.vala"
	rowbytes = n_channels * width;
#line 1196 "../src/ColorTransformation.vala"
	_tmp0_ = gdk_pixbuf_get_pixels (pixbuf);
#line 1196 "../src/ColorTransformation.vala"
	pixels = _tmp0_;
#line 1196 "../src/ColorTransformation.vala"
	pixels_length1 = -1;
#line 1196 "../src/ColorTransformation.vala"
	_pixels_size_ = pixels_length1;
#line 8755 "ColorTransformation.c"
	{
		gint j = 0;
#line 1197 "../src/ColorTransformation.vala"
		j = 0;
#line 8760 "ColorTransformation.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1197 "../src/ColorTransformation.vala"
			_tmp1_ = TRUE;
#line 1197 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 8767 "ColorTransformation.c"
				gint row_start_index = 0;
				gint row_end_index = 0;
#line 1197 "../src/ColorTransformation.vala"
				if (!_tmp1_) {
#line 8772 "ColorTransformation.c"
					gint _tmp2_;
#line 1197 "../src/ColorTransformation.vala"
					_tmp2_ = j;
#line 1197 "../src/ColorTransformation.vala"
					j = _tmp2_ + 1;
#line 8778 "ColorTransformation.c"
				}
#line 1197 "../src/ColorTransformation.vala"
				_tmp1_ = FALSE;
#line 1197 "../src/ColorTransformation.vala"
				if (!(j < height)) {
#line 1197 "../src/ColorTransformation.vala"
					break;
#line 8786 "ColorTransformation.c"
				}
#line 1198 "../src/ColorTransformation.vala"
				row_start_index = j * rowstride;
#line 1199 "../src/ColorTransformation.vala"
				row_end_index = row_start_index + rowbytes;
#line 8792 "ColorTransformation.c"
				{
					gint i = 0;
#line 1200 "../src/ColorTransformation.vala"
					i = row_start_index;
#line 8797 "ColorTransformation.c"
					{
						gboolean _tmp3_ = FALSE;
#line 1200 "../src/ColorTransformation.vala"
						_tmp3_ = TRUE;
#line 1200 "../src/ColorTransformation.vala"
						while (TRUE) {
#line 8804 "ColorTransformation.c"
							RGBAnalyticPixel pix_rgb = {0};
							guchar* _tmp4_;
							gint _tmp4__length1;
							guchar _tmp5_;
							guchar* _tmp6_;
							gint _tmp6__length1;
							guchar _tmp7_;
							guchar* _tmp8_;
							gint _tmp8__length1;
							guchar _tmp9_;
							HSVAnalyticPixel pix_hsi = {0};
							RGBAnalyticPixel _tmp10_;
							gint quantized_light_value = 0;
							HSVAnalyticPixel _tmp11_;
							gint* _tmp12_;
							gint _tmp12__length1;
#line 1200 "../src/ColorTransformation.vala"
							if (!_tmp3_) {
#line 1200 "../src/ColorTransformation.vala"
								i += n_channels;
#line 8825 "ColorTransformation.c"
							}
#line 1200 "../src/ColorTransformation.vala"
							_tmp3_ = FALSE;
#line 1200 "../src/ColorTransformation.vala"
							if (!(i < row_end_index)) {
#line 1200 "../src/ColorTransformation.vala"
								break;
#line 8833 "ColorTransformation.c"
							}
#line 1201 "../src/ColorTransformation.vala"
							_tmp4_ = pixels;
#line 1201 "../src/ColorTransformation.vala"
							_tmp4__length1 = pixels_length1;
#line 1201 "../src/ColorTransformation.vala"
							_tmp5_ = _tmp4_[i];
#line 1201 "../src/ColorTransformation.vala"
							_tmp6_ = pixels;
#line 1201 "../src/ColorTransformation.vala"
							_tmp6__length1 = pixels_length1;
#line 1201 "../src/ColorTransformation.vala"
							_tmp7_ = _tmp6_[i + 1];
#line 1201 "../src/ColorTransformation.vala"
							_tmp8_ = pixels;
#line 1201 "../src/ColorTransformation.vala"
							_tmp8__length1 = pixels_length1;
#line 1201 "../src/ColorTransformation.vala"
							_tmp9_ = _tmp8_[i + 2];
#line 1201 "../src/ColorTransformation.vala"
							rgb_analytic_pixel_init_from_quantized_components (&pix_rgb, _tmp5_, _tmp7_, _tmp9_);
#line 1203 "../src/ColorTransformation.vala"
							_tmp10_ = pix_rgb;
#line 1203 "../src/ColorTransformation.vala"
							hsv_analytic_pixel_init_from_rgb (&pix_hsi, &_tmp10_);
#line 1204 "../src/ColorTransformation.vala"
							_tmp11_ = pix_hsi;
#line 1204 "../src/ColorTransformation.vala"
							quantized_light_value = (gint) (_tmp11_.light_value * 255.0f);
#line 1205 "../src/ColorTransformation.vala"
							_tmp12_ = self->priv->counts;
#line 1205 "../src/ColorTransformation.vala"
							_tmp12__length1 = self->priv->counts_length1;
#line 1205 "../src/ColorTransformation.vala"
							_tmp12_[quantized_light_value] += 1;
#line 8869 "ColorTransformation.c"
						}
					}
				}
			}
		}
	}
#line 1209 "../src/ColorTransformation.vala"
	_tmp13_ = gdk_pixbuf_get_width (pixbuf);
#line 1209 "../src/ColorTransformation.vala"
	_tmp14_ = _tmp13_;
#line 1209 "../src/ColorTransformation.vala"
	_tmp15_ = gdk_pixbuf_get_height (pixbuf);
#line 1209 "../src/ColorTransformation.vala"
	_tmp16_ = _tmp15_;
#line 1209 "../src/ColorTransformation.vala"
	pixel_count = (gfloat) (_tmp14_ * _tmp16_);
#line 1210 "../src/ColorTransformation.vala"
	accumulator = 0.0f;
#line 8888 "ColorTransformation.c"
	{
		gint i = 0;
#line 1211 "../src/ColorTransformation.vala"
		i = 0;
#line 8893 "ColorTransformation.c"
		{
			gboolean _tmp17_ = FALSE;
#line 1211 "../src/ColorTransformation.vala"
			_tmp17_ = TRUE;
#line 1211 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 8900 "ColorTransformation.c"
				gfloat* _tmp19_;
				gint _tmp19__length1;
				gint* _tmp20_;
				gint _tmp20__length1;
				gint _tmp21_;
				gfloat* _tmp22_;
				gint _tmp22__length1;
				gfloat _tmp23_;
				gfloat* _tmp24_;
				gint _tmp24__length1;
#line 1211 "../src/ColorTransformation.vala"
				if (!_tmp17_) {
#line 8913 "ColorTransformation.c"
					gint _tmp18_;
#line 1211 "../src/ColorTransformation.vala"
					_tmp18_ = i;
#line 1211 "../src/ColorTransformation.vala"
					i = _tmp18_ + 1;
#line 8919 "ColorTransformation.c"
				}
#line 1211 "../src/ColorTransformation.vala"
				_tmp17_ = FALSE;
#line 1211 "../src/ColorTransformation.vala"
				if (!(i < 256)) {
#line 1211 "../src/ColorTransformation.vala"
					break;
#line 8927 "ColorTransformation.c"
				}
#line 1212 "../src/ColorTransformation.vala"
				_tmp19_ = self->priv->probabilities;
#line 1212 "../src/ColorTransformation.vala"
				_tmp19__length1 = self->priv->probabilities_length1;
#line 1212 "../src/ColorTransformation.vala"
				_tmp20_ = self->priv->counts;
#line 1212 "../src/ColorTransformation.vala"
				_tmp20__length1 = self->priv->counts_length1;
#line 1212 "../src/ColorTransformation.vala"
				_tmp21_ = _tmp20_[i];
#line 1212 "../src/ColorTransformation.vala"
				_tmp19_[i] = ((gfloat) _tmp21_) / pixel_count;
#line 1213 "../src/ColorTransformation.vala"
				_tmp22_ = self->priv->probabilities;
#line 1213 "../src/ColorTransformation.vala"
				_tmp22__length1 = self->priv->probabilities_length1;
#line 1213 "../src/ColorTransformation.vala"
				_tmp23_ = _tmp22_[i];
#line 1213 "../src/ColorTransformation.vala"
				accumulator += _tmp23_;
#line 1214 "../src/ColorTransformation.vala"
				_tmp24_ = self->priv->cumulative_probabilities;
#line 1214 "../src/ColorTransformation.vala"
				_tmp24__length1 = self->priv->cumulative_probabilities_length1;
#line 1214 "../src/ColorTransformation.vala"
				_tmp24_[i] = accumulator;
#line 8955 "ColorTransformation.c"
			}
		}
	}
#line 1190 "../src/ColorTransformation.vala"
	return self;
#line 8961 "ColorTransformation.c"
}

IntensityHistogram*
intensity_histogram_new (GdkPixbuf* pixbuf)
{
#line 1190 "../src/ColorTransformation.vala"
	return intensity_histogram_construct (TYPE_INTENSITY_HISTOGRAM, pixbuf);
#line 8969 "ColorTransformation.c"
}

gfloat
intensity_histogram_get_cumulative_probability (IntensityHistogram* self,
                                                gint level)
{
	gfloat* _tmp0_;
	gint _tmp0__length1;
	gfloat _tmp1_;
	gfloat result;
#line 1218 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 1220 "../src/ColorTransformation.vala"
	level = CLAMP (level, 0, 255);
#line 1221 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->cumulative_probabilities;
#line 1221 "../src/ColorTransformation.vala"
	_tmp0__length1 = self->priv->cumulative_probabilities_length1;
#line 1221 "../src/ColorTransformation.vala"
	_tmp1_ = _tmp0_[level];
#line 1221 "../src/ColorTransformation.vala"
	result = _tmp1_;
#line 1221 "../src/ColorTransformation.vala"
	return result;
#line 8994 "ColorTransformation.c"
}

static void
value_intensity_histogram_init (GValue* value)
{
#line 1185 "../src/ColorTransformation.vala"
	value->data[0].v_pointer = NULL;
#line 9002 "ColorTransformation.c"
}

static void
value_intensity_histogram_free_value (GValue* value)
{
#line 1185 "../src/ColorTransformation.vala"
	if (value->data[0].v_pointer) {
#line 1185 "../src/ColorTransformation.vala"
		intensity_histogram_unref (value->data[0].v_pointer);
#line 9012 "ColorTransformation.c"
	}
}

static void
value_intensity_histogram_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 1185 "../src/ColorTransformation.vala"
	if (src_value->data[0].v_pointer) {
#line 1185 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = intensity_histogram_ref (src_value->data[0].v_pointer);
#line 9024 "ColorTransformation.c"
	} else {
#line 1185 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9028 "ColorTransformation.c"
	}
}

static gpointer
value_intensity_histogram_peek_pointer (const GValue* value)
{
#line 1185 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 9037 "ColorTransformation.c"
}

static gchar*
value_intensity_histogram_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 1185 "../src/ColorTransformation.vala"
	if (collect_values[0].v_pointer) {
#line 9048 "ColorTransformation.c"
		IntensityHistogram * object;
		object = collect_values[0].v_pointer;
#line 1185 "../src/ColorTransformation.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1185 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9055 "ColorTransformation.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1185 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9059 "ColorTransformation.c"
		}
#line 1185 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = intensity_histogram_ref (object);
#line 9063 "ColorTransformation.c"
	} else {
#line 1185 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 9067 "ColorTransformation.c"
	}
#line 1185 "../src/ColorTransformation.vala"
	return NULL;
#line 9071 "ColorTransformation.c"
}

static gchar*
value_intensity_histogram_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	IntensityHistogram ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1185 "../src/ColorTransformation.vala"
	if (!object_p) {
#line 1185 "../src/ColorTransformation.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9086 "ColorTransformation.c"
	}
#line 1185 "../src/ColorTransformation.vala"
	if (!value->data[0].v_pointer) {
#line 1185 "../src/ColorTransformation.vala"
		*object_p = NULL;
#line 9092 "ColorTransformation.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1185 "../src/ColorTransformation.vala"
		*object_p = value->data[0].v_pointer;
#line 9096 "ColorTransformation.c"
	} else {
#line 1185 "../src/ColorTransformation.vala"
		*object_p = intensity_histogram_ref (value->data[0].v_pointer);
#line 9100 "ColorTransformation.c"
	}
#line 1185 "../src/ColorTransformation.vala"
	return NULL;
#line 9104 "ColorTransformation.c"
}

GParamSpec*
param_spec_intensity_histogram (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecIntensityHistogram* spec;
#line 1185 "../src/ColorTransformation.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_INTENSITY_HISTOGRAM), NULL);
#line 1185 "../src/ColorTransformation.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1185 "../src/ColorTransformation.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1185 "../src/ColorTransformation.vala"
	return G_PARAM_SPEC (spec);
#line 9123 "ColorTransformation.c"
}

gpointer
value_get_intensity_histogram (const GValue* value)
{
#line 1185 "../src/ColorTransformation.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_INTENSITY_HISTOGRAM), NULL);
#line 1185 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 9133 "ColorTransformation.c"
}

void
value_set_intensity_histogram (GValue* value,
                               gpointer v_object)
{
	IntensityHistogram * old;
#line 1185 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_INTENSITY_HISTOGRAM));
#line 1185 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 1185 "../src/ColorTransformation.vala"
	if (v_object) {
#line 1185 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_INTENSITY_HISTOGRAM));
#line 1185 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1185 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 1185 "../src/ColorTransformation.vala"
		intensity_histogram_ref (value->data[0].v_pointer);
#line 9155 "ColorTransformation.c"
	} else {
#line 1185 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 9159 "ColorTransformation.c"
	}
#line 1185 "../src/ColorTransformation.vala"
	if (old) {
#line 1185 "../src/ColorTransformation.vala"
		intensity_histogram_unref (old);
#line 9165 "ColorTransformation.c"
	}
}

void
value_take_intensity_histogram (GValue* value,
                                gpointer v_object)
{
	IntensityHistogram * old;
#line 1185 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_INTENSITY_HISTOGRAM));
#line 1185 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 1185 "../src/ColorTransformation.vala"
	if (v_object) {
#line 1185 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_INTENSITY_HISTOGRAM));
#line 1185 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1185 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 9186 "ColorTransformation.c"
	} else {
#line 1185 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 9190 "ColorTransformation.c"
	}
#line 1185 "../src/ColorTransformation.vala"
	if (old) {
#line 1185 "../src/ColorTransformation.vala"
		intensity_histogram_unref (old);
#line 9196 "ColorTransformation.c"
	}
}

static void
intensity_histogram_class_init (IntensityHistogramClass * klass,
                                gpointer klass_data)
{
#line 1185 "../src/ColorTransformation.vala"
	intensity_histogram_parent_class = g_type_class_peek_parent (klass);
#line 1185 "../src/ColorTransformation.vala"
	((IntensityHistogramClass *) klass)->finalize = intensity_histogram_finalize;
#line 1185 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &IntensityHistogram_private_offset);
#line 9210 "ColorTransformation.c"
}

static void
intensity_histogram_instance_init (IntensityHistogram * self,
                                   gpointer klass)
{
	gint* _tmp0_;
	gfloat* _tmp1_;
	gfloat* _tmp2_;
#line 1185 "../src/ColorTransformation.vala"
	self->priv = intensity_histogram_get_instance_private (self);
#line 1186 "../src/ColorTransformation.vala"
	_tmp0_ = g_new0 (gint, 256);
#line 1186 "../src/ColorTransformation.vala"
	self->priv->counts = _tmp0_;
#line 1186 "../src/ColorTransformation.vala"
	self->priv->counts_length1 = 256;
#line 1186 "../src/ColorTransformation.vala"
	self->priv->_counts_size_ = self->priv->counts_length1;
#line 1187 "../src/ColorTransformation.vala"
	_tmp1_ = g_new0 (gfloat, 256);
#line 1187 "../src/ColorTransformation.vala"
	self->priv->probabilities = _tmp1_;
#line 1187 "../src/ColorTransformation.vala"
	self->priv->probabilities_length1 = 256;
#line 1187 "../src/ColorTransformation.vala"
	self->priv->_probabilities_size_ = self->priv->probabilities_length1;
#line 1188 "../src/ColorTransformation.vala"
	_tmp2_ = g_new0 (gfloat, 256);
#line 1188 "../src/ColorTransformation.vala"
	self->priv->cumulative_probabilities = _tmp2_;
#line 1188 "../src/ColorTransformation.vala"
	self->priv->cumulative_probabilities_length1 = 256;
#line 1188 "../src/ColorTransformation.vala"
	self->priv->_cumulative_probabilities_size_ = self->priv->cumulative_probabilities_length1;
#line 1185 "../src/ColorTransformation.vala"
	self->ref_count = 1;
#line 9248 "ColorTransformation.c"
}

static void
intensity_histogram_finalize (IntensityHistogram * obj)
{
	IntensityHistogram * self;
#line 1185 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INTENSITY_HISTOGRAM, IntensityHistogram);
#line 1185 "../src/ColorTransformation.vala"
	g_signal_handlers_destroy (self);
#line 1186 "../src/ColorTransformation.vala"
	self->priv->counts = (g_free (self->priv->counts), NULL);
#line 1187 "../src/ColorTransformation.vala"
	self->priv->probabilities = (g_free (self->priv->probabilities), NULL);
#line 1188 "../src/ColorTransformation.vala"
	self->priv->cumulative_probabilities = (g_free (self->priv->cumulative_probabilities), NULL);
#line 9265 "ColorTransformation.c"
}

static GType
intensity_histogram_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_intensity_histogram_init, value_intensity_histogram_free_value, value_intensity_histogram_copy_value, value_intensity_histogram_peek_pointer, "p", value_intensity_histogram_collect_value, "p", value_intensity_histogram_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (IntensityHistogramClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) intensity_histogram_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IntensityHistogram), 0, (GInstanceInitFunc) intensity_histogram_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType intensity_histogram_type_id;
	intensity_histogram_type_id = g_type_register_fundamental (g_type_fundamental_next (), "IntensityHistogram", &g_define_type_info, &g_define_type_fundamental_info, 0);
	IntensityHistogram_private_offset = g_type_add_instance_private (intensity_histogram_type_id, sizeof (IntensityHistogramPrivate));
	return intensity_histogram_type_id;
}

GType
intensity_histogram_get_type (void)
{
	static volatile gsize intensity_histogram_type_id__once = 0;
	if (g_once_init_enter (&intensity_histogram_type_id__once)) {
		GType intensity_histogram_type_id;
		intensity_histogram_type_id = intensity_histogram_get_type_once ();
		g_once_init_leave (&intensity_histogram_type_id__once, intensity_histogram_type_id);
	}
	return intensity_histogram_type_id__once;
}

gpointer
intensity_histogram_ref (gpointer instance)
{
	IntensityHistogram * self;
	self = instance;
#line 1185 "../src/ColorTransformation.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1185 "../src/ColorTransformation.vala"
	return instance;
#line 9301 "ColorTransformation.c"
}

void
intensity_histogram_unref (gpointer instance)
{
	IntensityHistogram * self;
	self = instance;
#line 1185 "../src/ColorTransformation.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1185 "../src/ColorTransformation.vala"
		INTENSITY_HISTOGRAM_GET_CLASS (self)->finalize (self);
#line 1185 "../src/ColorTransformation.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9315 "ColorTransformation.c"
	}
}

static inline gpointer
expansion_transformation_get_instance_private (ExpansionTransformation* self)
{
	return G_STRUCT_MEMBER_P (self, ExpansionTransformation_private_offset);
}

ExpansionTransformation*
expansion_transformation_construct (GType object_type,
                                    IntensityHistogram* histogram)
{
	ExpansionTransformation* self = NULL;
	gfloat* _tmp0_;
#line 1238 "../src/ColorTransformation.vala"
	static const gfloat LOW_KINK_MASS = EXPANSION_TRANSFORMATION_LOW_DISCARD_MASS;
#line 1243 "../src/ColorTransformation.vala"
	static const gfloat HIGH_KINK_MASS = 1.0f - EXPANSION_TRANSFORMATION_HIGH_DISCARD_MASS;
#line 1233 "../src/ColorTransformation.vala"
	g_return_val_if_fail (histogram != NULL, NULL);
#line 1234 "../src/ColorTransformation.vala"
	self = (ExpansionTransformation*) hsv_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION);
#line 1236 "../src/ColorTransformation.vala"
	_tmp0_ = g_new0 (gfloat, 256);
#line 1236 "../src/ColorTransformation.vala"
	self->priv->remap_table = (g_free (self->priv->remap_table), NULL);
#line 1236 "../src/ColorTransformation.vala"
	self->priv->remap_table = _tmp0_;
#line 1236 "../src/ColorTransformation.vala"
	self->priv->remap_table_length1 = 256;
#line 1236 "../src/ColorTransformation.vala"
	self->priv->_remap_table_size_ = self->priv->remap_table_length1;
#line 1239 "../src/ColorTransformation.vala"
	self->priv->low_kink = 0;
#line 1240 "../src/ColorTransformation.vala"
	while (TRUE) {
#line 9353 "ColorTransformation.c"
		gint _tmp1_;
#line 1240 "../src/ColorTransformation.vala"
		if (!(intensity_histogram_get_cumulative_probability (histogram, self->priv->low_kink) < LOW_KINK_MASS)) {
#line 1240 "../src/ColorTransformation.vala"
			break;
#line 9359 "ColorTransformation.c"
		}
#line 1241 "../src/ColorTransformation.vala"
		_tmp1_ = self->priv->low_kink;
#line 1241 "../src/ColorTransformation.vala"
		self->priv->low_kink = _tmp1_ + 1;
#line 9365 "ColorTransformation.c"
	}
#line 1244 "../src/ColorTransformation.vala"
	self->priv->high_kink = 255;
#line 1245 "../src/ColorTransformation.vala"
	while (TRUE) {
#line 9371 "ColorTransformation.c"
		gboolean _tmp2_ = FALSE;
		gint _tmp3_;
#line 1245 "../src/ColorTransformation.vala"
		if (intensity_histogram_get_cumulative_probability (histogram, self->priv->high_kink) > HIGH_KINK_MASS) {
#line 1245 "../src/ColorTransformation.vala"
			_tmp2_ = self->priv->high_kink > 0;
#line 9378 "ColorTransformation.c"
		} else {
#line 1245 "../src/ColorTransformation.vala"
			_tmp2_ = FALSE;
#line 9382 "ColorTransformation.c"
		}
#line 1245 "../src/ColorTransformation.vala"
		if (!_tmp2_) {
#line 1245 "../src/ColorTransformation.vala"
			break;
#line 9388 "ColorTransformation.c"
		}
#line 1246 "../src/ColorTransformation.vala"
		_tmp3_ = self->priv->high_kink;
#line 1246 "../src/ColorTransformation.vala"
		self->priv->high_kink = _tmp3_ - 1;
#line 9394 "ColorTransformation.c"
	}
#line 1248 "../src/ColorTransformation.vala"
	expansion_transformation_build_remap_table (self);
#line 1233 "../src/ColorTransformation.vala"
	return self;
#line 9400 "ColorTransformation.c"
}

ExpansionTransformation*
expansion_transformation_new (IntensityHistogram* histogram)
{
#line 1233 "../src/ColorTransformation.vala"
	return expansion_transformation_construct (TYPE_EXPANSION_TRANSFORMATION, histogram);
#line 9408 "ColorTransformation.c"
}

ExpansionTransformation*
expansion_transformation_construct_from_extrema (GType object_type,
                                                 gint black_point,
                                                 gint white_point)
{
	ExpansionTransformation* self = NULL;
#line 1252 "../src/ColorTransformation.vala"
	self = (ExpansionTransformation*) hsv_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION);
#line 1254 "../src/ColorTransformation.vala"
	white_point = CLAMP (white_point, 0, 255);
#line 1255 "../src/ColorTransformation.vala"
	black_point = CLAMP (black_point, 0, 255);
#line 1257 "../src/ColorTransformation.vala"
	if (black_point == white_point) {
#line 1258 "../src/ColorTransformation.vala"
		if (black_point == 0) {
#line 1259 "../src/ColorTransformation.vala"
			white_point = 1;
#line 9429 "ColorTransformation.c"
		} else {
#line 1260 "../src/ColorTransformation.vala"
			if (white_point == 255) {
#line 1261 "../src/ColorTransformation.vala"
				black_point = 254;
#line 9435 "ColorTransformation.c"
			} else {
#line 1263 "../src/ColorTransformation.vala"
				black_point = white_point - 1;
#line 9439 "ColorTransformation.c"
			}
		}
	}
#line 1266 "../src/ColorTransformation.vala"
	self->priv->low_kink = black_point;
#line 1267 "../src/ColorTransformation.vala"
	self->priv->high_kink = white_point;
#line 1269 "../src/ColorTransformation.vala"
	expansion_transformation_build_remap_table (self);
#line 1251 "../src/ColorTransformation.vala"
	return self;
#line 9451 "ColorTransformation.c"
}

ExpansionTransformation*
expansion_transformation_new_from_extrema (gint black_point,
                                           gint white_point)
{
#line 1251 "../src/ColorTransformation.vala"
	return expansion_transformation_construct_from_extrema (TYPE_EXPANSION_TRANSFORMATION, black_point, white_point);
#line 9460 "ColorTransformation.c"
}

static gchar*
string_chug (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1405 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1406 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1406 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1407 "glib-2.0.vapi"
	g_strchug (_result_);
#line 1408 "glib-2.0.vapi"
	result = _result_;
#line 1408 "glib-2.0.vapi"
	return result;
#line 9481 "ColorTransformation.c"
}

static gchar*
string_chomp (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1397 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1398 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1398 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1399 "glib-2.0.vapi"
	g_strchomp (_result_);
#line 1400 "glib-2.0.vapi"
	result = _result_;
#line 1400 "glib-2.0.vapi"
	return result;
#line 9502 "ColorTransformation.c"
}

ExpansionTransformation*
expansion_transformation_construct_from_string (GType object_type,
                                                const gchar* encoded_transformation)
{
	ExpansionTransformation* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint num_captured = 0;
#line 1272 "../src/ColorTransformation.vala"
	g_return_val_if_fail (encoded_transformation != NULL, NULL);
#line 1273 "../src/ColorTransformation.vala"
	self = (ExpansionTransformation*) hsv_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION);
#line 1275 "../src/ColorTransformation.vala"
	g_strcanon (encoded_transformation, "0123456789. ", ' ');
#line 1276 "../src/ColorTransformation.vala"
	_tmp0_ = string_chug (encoded_transformation);
#line 1276 "../src/ColorTransformation.vala"
	_tmp1_ = _tmp0_;
#line 1276 "../src/ColorTransformation.vala"
	_g_free0 (_tmp1_);
#line 1277 "../src/ColorTransformation.vala"
	_tmp2_ = string_chomp (encoded_transformation);
#line 1277 "../src/ColorTransformation.vala"
	_tmp3_ = _tmp2_;
#line 1277 "../src/ColorTransformation.vala"
	_g_free0 (_tmp3_);
#line 1279 "../src/ColorTransformation.vala"
	num_captured = sscanf (encoded_transformation, "%d %d", &self->priv->low_kink, &self->priv->high_kink);
#line 1282 "../src/ColorTransformation.vala"
	_vala_assert (num_captured == 2, "num_captured == 2");
#line 1284 "../src/ColorTransformation.vala"
	expansion_transformation_build_remap_table (self);
#line 1272 "../src/ColorTransformation.vala"
	return self;
#line 9541 "ColorTransformation.c"
}

ExpansionTransformation*
expansion_transformation_new_from_string (const gchar* encoded_transformation)
{
#line 1272 "../src/ColorTransformation.vala"
	return expansion_transformation_construct_from_string (TYPE_EXPANSION_TRANSFORMATION, encoded_transformation);
#line 9549 "ColorTransformation.c"
}

static void
expansion_transformation_build_remap_table (ExpansionTransformation* self)
{
	gfloat* _tmp0_;
	gint _tmp0__length1;
	gfloat low_kink_f = 0.0F;
	gfloat high_kink_f = 0.0F;
	gfloat slope = 0.0F;
	gfloat intercept = 0.0F;
	gint i = 0;
#line 1287 "../src/ColorTransformation.vala"
	g_return_if_fail (self != NULL);
#line 1288 "../src/ColorTransformation.vala"
	_tmp0_ = self->priv->remap_table;
#line 1288 "../src/ColorTransformation.vala"
	_tmp0__length1 = self->priv->remap_table_length1;
#line 1288 "../src/ColorTransformation.vala"
	if (_tmp0_ == NULL) {
#line 9570 "ColorTransformation.c"
		gfloat* _tmp1_;
#line 1289 "../src/ColorTransformation.vala"
		_tmp1_ = g_new0 (gfloat, 256);
#line 1289 "../src/ColorTransformation.vala"
		self->priv->remap_table = (g_free (self->priv->remap_table), NULL);
#line 1289 "../src/ColorTransformation.vala"
		self->priv->remap_table = _tmp1_;
#line 1289 "../src/ColorTransformation.vala"
		self->priv->remap_table_length1 = 256;
#line 1289 "../src/ColorTransformation.vala"
		self->priv->_remap_table_size_ = self->priv->remap_table_length1;
#line 9582 "ColorTransformation.c"
	}
#line 1291 "../src/ColorTransformation.vala"
	low_kink_f = ((gfloat) self->priv->low_kink) / 255.0f;
#line 1292 "../src/ColorTransformation.vala"
	high_kink_f = ((gfloat) self->priv->high_kink) / 255.0f;
#line 1294 "../src/ColorTransformation.vala"
	slope = 1.0f / (high_kink_f - low_kink_f);
#line 1295 "../src/ColorTransformation.vala"
	intercept = -(low_kink_f / (high_kink_f - low_kink_f));
#line 1297 "../src/ColorTransformation.vala"
	i = 0;
#line 9594 "ColorTransformation.c"
	{
		gboolean _tmp2_ = FALSE;
#line 1298 "../src/ColorTransformation.vala"
		_tmp2_ = TRUE;
#line 1298 "../src/ColorTransformation.vala"
		while (TRUE) {
#line 9601 "ColorTransformation.c"
			gfloat* _tmp4_;
			gint _tmp4__length1;
#line 1298 "../src/ColorTransformation.vala"
			if (!_tmp2_) {
#line 9606 "ColorTransformation.c"
				gint _tmp3_;
#line 1298 "../src/ColorTransformation.vala"
				_tmp3_ = i;
#line 1298 "../src/ColorTransformation.vala"
				i = _tmp3_ + 1;
#line 9612 "ColorTransformation.c"
			}
#line 1298 "../src/ColorTransformation.vala"
			_tmp2_ = FALSE;
#line 1298 "../src/ColorTransformation.vala"
			if (!(i <= self->priv->low_kink)) {
#line 1298 "../src/ColorTransformation.vala"
				break;
#line 9620 "ColorTransformation.c"
			}
#line 1299 "../src/ColorTransformation.vala"
			_tmp4_ = self->priv->remap_table;
#line 1299 "../src/ColorTransformation.vala"
			_tmp4__length1 = self->priv->remap_table_length1;
#line 1299 "../src/ColorTransformation.vala"
			_tmp4_[i] = 0.0f;
#line 9628 "ColorTransformation.c"
		}
	}
	{
		gboolean _tmp5_ = FALSE;
#line 1301 "../src/ColorTransformation.vala"
		_tmp5_ = TRUE;
#line 1301 "../src/ColorTransformation.vala"
		while (TRUE) {
#line 9637 "ColorTransformation.c"
			gfloat* _tmp7_;
			gint _tmp7__length1;
#line 1301 "../src/ColorTransformation.vala"
			if (!_tmp5_) {
#line 9642 "ColorTransformation.c"
				gint _tmp6_;
#line 1301 "../src/ColorTransformation.vala"
				_tmp6_ = i;
#line 1301 "../src/ColorTransformation.vala"
				i = _tmp6_ + 1;
#line 9648 "ColorTransformation.c"
			}
#line 1301 "../src/ColorTransformation.vala"
			_tmp5_ = FALSE;
#line 1301 "../src/ColorTransformation.vala"
			if (!(i < self->priv->high_kink)) {
#line 1301 "../src/ColorTransformation.vala"
				break;
#line 9656 "ColorTransformation.c"
			}
#line 1302 "../src/ColorTransformation.vala"
			_tmp7_ = self->priv->remap_table;
#line 1302 "../src/ColorTransformation.vala"
			_tmp7__length1 = self->priv->remap_table_length1;
#line 1302 "../src/ColorTransformation.vala"
			_tmp7_[i] = (slope * (((gfloat) i) / 255.0f)) + intercept;
#line 9664 "ColorTransformation.c"
		}
	}
	{
		gboolean _tmp8_ = FALSE;
#line 1304 "../src/ColorTransformation.vala"
		_tmp8_ = TRUE;
#line 1304 "../src/ColorTransformation.vala"
		while (TRUE) {
#line 9673 "ColorTransformation.c"
			gfloat* _tmp10_;
			gint _tmp10__length1;
#line 1304 "../src/ColorTransformation.vala"
			if (!_tmp8_) {
#line 9678 "ColorTransformation.c"
				gint _tmp9_;
#line 1304 "../src/ColorTransformation.vala"
				_tmp9_ = i;
#line 1304 "../src/ColorTransformation.vala"
				i = _tmp9_ + 1;
#line 9684 "ColorTransformation.c"
			}
#line 1304 "../src/ColorTransformation.vala"
			_tmp8_ = FALSE;
#line 1304 "../src/ColorTransformation.vala"
			if (!(i < 256)) {
#line 1304 "../src/ColorTransformation.vala"
				break;
#line 9692 "ColorTransformation.c"
			}
#line 1305 "../src/ColorTransformation.vala"
			_tmp10_ = self->priv->remap_table;
#line 1305 "../src/ColorTransformation.vala"
			_tmp10__length1 = self->priv->remap_table_length1;
#line 1305 "../src/ColorTransformation.vala"
			_tmp10_[i] = 1.0f;
#line 9700 "ColorTransformation.c"
		}
	}
}

static void
expansion_transformation_real_transform_pixel_hsv (PixelTransformation* base,
                                                   HSVAnalyticPixel* pixel,
                                                   HSVAnalyticPixel* result)
{
	ExpansionTransformation * self;
	gint remap_index = 0;
	HSVAnalyticPixel _tmp0_;
	HSVAnalyticPixel _result_ = {0};
	HSVAnalyticPixel _tmp1_;
	gfloat* _tmp2_;
	gint _tmp2__length1;
	gfloat _tmp3_;
	HSVAnalyticPixel _tmp4_;
#line 1308 "../src/ColorTransformation.vala"
	self = (ExpansionTransformation*) base;
#line 1308 "../src/ColorTransformation.vala"
	g_return_if_fail (pixel != NULL);
#line 1309 "../src/ColorTransformation.vala"
	_tmp0_ = *pixel;
#line 1309 "../src/ColorTransformation.vala"
	remap_index = (gint) (_tmp0_.light_value * 255.0f);
#line 1311 "../src/ColorTransformation.vala"
	_tmp1_ = *pixel;
#line 1311 "../src/ColorTransformation.vala"
	_result_ = _tmp1_;
#line 1312 "../src/ColorTransformation.vala"
	_tmp2_ = self->priv->remap_table;
#line 1312 "../src/ColorTransformation.vala"
	_tmp2__length1 = self->priv->remap_table_length1;
#line 1312 "../src/ColorTransformation.vala"
	_tmp3_ = _tmp2_[remap_index];
#line 1312 "../src/ColorTransformation.vala"
	_result_.light_value = _tmp3_;
#line 1314 "../src/ColorTransformation.vala"
	_tmp4_ = _result_;
#line 1314 "../src/ColorTransformation.vala"
	_result_.light_value = CLAMP (_tmp4_.light_value, 0.0f, 1.0f);
#line 1316 "../src/ColorTransformation.vala"
	*result = _result_;
#line 1316 "../src/ColorTransformation.vala"
	return;
#line 9747 "ColorTransformation.c"
}

static gchar*
expansion_transformation_real_to_string (PixelTransformation* base)
{
	ExpansionTransformation * self;
	gchar* _tmp0_;
	gchar* result;
#line 1319 "../src/ColorTransformation.vala"
	self = (ExpansionTransformation*) base;
#line 1320 "../src/ColorTransformation.vala"
	_tmp0_ = g_strdup_printf ("{ %d, %d }", self->priv->low_kink, self->priv->high_kink);
#line 1320 "../src/ColorTransformation.vala"
	result = _tmp0_;
#line 1320 "../src/ColorTransformation.vala"
	return result;
#line 9764 "ColorTransformation.c"
}

gint
expansion_transformation_get_white_point (ExpansionTransformation* self)
{
	gint result;
#line 1323 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1324 "../src/ColorTransformation.vala"
	result = self->priv->high_kink;
#line 1324 "../src/ColorTransformation.vala"
	return result;
#line 9777 "ColorTransformation.c"
}

gint
expansion_transformation_get_black_point (ExpansionTransformation* self)
{
	gint result;
#line 1327 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1328 "../src/ColorTransformation.vala"
	result = self->priv->low_kink;
#line 1328 "../src/ColorTransformation.vala"
	return result;
#line 9790 "ColorTransformation.c"
}

static gboolean
expansion_transformation_real_is_identity (PixelTransformation* base)
{
	ExpansionTransformation * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 1331 "../src/ColorTransformation.vala"
	self = (ExpansionTransformation*) base;
#line 1332 "../src/ColorTransformation.vala"
	if (self->priv->low_kink == 0) {
#line 1332 "../src/ColorTransformation.vala"
		_tmp0_ = self->priv->high_kink == 255;
#line 9805 "ColorTransformation.c"
	} else {
#line 1332 "../src/ColorTransformation.vala"
		_tmp0_ = FALSE;
#line 9809 "ColorTransformation.c"
	}
#line 1332 "../src/ColorTransformation.vala"
	result = _tmp0_;
#line 1332 "../src/ColorTransformation.vala"
	return result;
#line 9815 "ColorTransformation.c"
}

static PixelTransformation*
expansion_transformation_real_copy (PixelTransformation* base)
{
	ExpansionTransformation * self;
	ExpansionTransformation* _tmp0_;
	PixelTransformation* result;
#line 1335 "../src/ColorTransformation.vala"
	self = (ExpansionTransformation*) base;
#line 1336 "../src/ColorTransformation.vala"
	_tmp0_ = expansion_transformation_new_from_extrema (self->priv->low_kink, self->priv->high_kink);
#line 1336 "../src/ColorTransformation.vala"
	result = (PixelTransformation*) _tmp0_;
#line 1336 "../src/ColorTransformation.vala"
	return result;
#line 9832 "ColorTransformation.c"
}

static void
expansion_transformation_class_init (ExpansionTransformationClass * klass,
                                     gpointer klass_data)
{
#line 1225 "../src/ColorTransformation.vala"
	expansion_transformation_parent_class = g_type_class_peek_parent (klass);
#line 1225 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = expansion_transformation_finalize;
#line 1225 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &ExpansionTransformation_private_offset);
#line 1225 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->transform_pixel_hsv = (void (*) (PixelTransformation*, HSVAnalyticPixel*, HSVAnalyticPixel*)) expansion_transformation_real_transform_pixel_hsv;
#line 1225 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->to_string = (gchar* (*) (PixelTransformation*)) expansion_transformation_real_to_string;
#line 1225 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->is_identity = (gboolean (*) (PixelTransformation*)) expansion_transformation_real_is_identity;
#line 1225 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->copy = (PixelTransformation* (*) (PixelTransformation*)) expansion_transformation_real_copy;
#line 9853 "ColorTransformation.c"
}

static void
expansion_transformation_instance_init (ExpansionTransformation * self,
                                        gpointer klass)
{
#line 1225 "../src/ColorTransformation.vala"
	self->priv = expansion_transformation_get_instance_private (self);
#line 1226 "../src/ColorTransformation.vala"
	self->priv->remap_table = NULL;
#line 1226 "../src/ColorTransformation.vala"
	self->priv->remap_table_length1 = 0;
#line 1226 "../src/ColorTransformation.vala"
	self->priv->_remap_table_size_ = self->priv->remap_table_length1;
#line 9868 "ColorTransformation.c"
}

static void
expansion_transformation_finalize (PixelTransformation * obj)
{
	ExpansionTransformation * self;
#line 1225 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPANSION_TRANSFORMATION, ExpansionTransformation);
#line 1226 "../src/ColorTransformation.vala"
	self->priv->remap_table = (g_free (self->priv->remap_table), NULL);
#line 1225 "../src/ColorTransformation.vala"
	PIXEL_TRANSFORMATION_CLASS (expansion_transformation_parent_class)->finalize (obj);
#line 9881 "ColorTransformation.c"
}

static GType
expansion_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExpansionTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) expansion_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExpansionTransformation), 0, (GInstanceInitFunc) expansion_transformation_instance_init, NULL };
	GType expansion_transformation_type_id;
	expansion_transformation_type_id = g_type_register_static (TYPE_HSV_TRANSFORMATION, "ExpansionTransformation", &g_define_type_info, 0);
	ExpansionTransformation_private_offset = g_type_add_instance_private (expansion_transformation_type_id, sizeof (ExpansionTransformationPrivate));
	return expansion_transformation_type_id;
}

GType
expansion_transformation_get_type (void)
{
	static volatile gsize expansion_transformation_type_id__once = 0;
	if (g_once_init_enter (&expansion_transformation_type_id__once)) {
		GType expansion_transformation_type_id;
		expansion_transformation_type_id = expansion_transformation_get_type_once ();
		g_once_init_leave (&expansion_transformation_type_id__once, expansion_transformation_type_id);
	}
	return expansion_transformation_type_id__once;
}

static inline gpointer
shadow_detail_transformation_get_instance_private (ShadowDetailTransformation* self)
{
	return G_STRUCT_MEMBER_P (self, ShadowDetailTransformation_private_offset);
}

ShadowDetailTransformation*
shadow_detail_transformation_construct (GType object_type,
                                        gfloat user_intensity)
{
	ShadowDetailTransformation* self = NULL;
	gfloat intensity_adj = 0.0F;
	gfloat effect_shift = 0.0F;
	HermiteGammaApproximationFunction* func = NULL;
	HermiteGammaApproximationFunction* _tmp0_;
	gfloat* _tmp1_;
#line 1353 "../src/ColorTransformation.vala"
	self = (ShadowDetailTransformation*) hsv_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_SHADOWS);
#line 1355 "../src/ColorTransformation.vala"
	self->priv->intensity = user_intensity;
#line 1356 "../src/ColorTransformation.vala"
	intensity_adj = CLAMP (self->priv->intensity / SHADOW_DETAIL_TRANSFORMATION_MAX_PARAMETER, 0.0f, 1.0f);
#line 1358 "../src/ColorTransformation.vala"
	effect_shift = SHADOW_DETAIL_TRANSFORMATION_MAX_EFFECT_SHIFT * intensity_adj;
#line 1359 "../src/ColorTransformation.vala"
	_tmp0_ = hermite_gamma_approximation_function_new (SHADOW_DETAIL_TRANSFORMATION_TONAL_WIDTH);
#line 1359 "../src/ColorTransformation.vala"
	func = _tmp0_;
#line 1362 "../src/ColorTransformation.vala"
	_tmp1_ = g_new0 (gfloat, 256);
#line 1362 "../src/ColorTransformation.vala"
	self->priv->remap_table = (g_free (self->priv->remap_table), NULL);
#line 1362 "../src/ColorTransformation.vala"
	self->priv->remap_table = _tmp1_;
#line 1362 "../src/ColorTransformation.vala"
	self->priv->remap_table_length1 = 256;
#line 1362 "../src/ColorTransformation.vala"
	self->priv->_remap_table_size_ = self->priv->remap_table_length1;
#line 9944 "ColorTransformation.c"
	{
		gint i = 0;
#line 1363 "../src/ColorTransformation.vala"
		i = 0;
#line 9949 "ColorTransformation.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1363 "../src/ColorTransformation.vala"
			_tmp2_ = TRUE;
#line 1363 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 9956 "ColorTransformation.c"
				gfloat x = 0.0F;
				gfloat weight = 0.0F;
				HermiteGammaApproximationFunction* _tmp4_;
				gfloat* _tmp5_;
				gint _tmp5__length1;
#line 1363 "../src/ColorTransformation.vala"
				if (!_tmp2_) {
#line 9964 "ColorTransformation.c"
					gint _tmp3_;
#line 1363 "../src/ColorTransformation.vala"
					_tmp3_ = i;
#line 1363 "../src/ColorTransformation.vala"
					i = _tmp3_ + 1;
#line 9970 "ColorTransformation.c"
				}
#line 1363 "../src/ColorTransformation.vala"
				_tmp2_ = FALSE;
#line 1363 "../src/ColorTransformation.vala"
				if (!(i < 256)) {
#line 1363 "../src/ColorTransformation.vala"
					break;
#line 9978 "ColorTransformation.c"
				}
#line 1364 "../src/ColorTransformation.vala"
				x = ((gfloat) i) / 255.0f;
#line 1365 "../src/ColorTransformation.vala"
				_tmp4_ = func;
#line 1365 "../src/ColorTransformation.vala"
				weight = hermite_gamma_approximation_function_evaluate (_tmp4_, x);
#line 1366 "../src/ColorTransformation.vala"
				_tmp5_ = self->priv->remap_table;
#line 1366 "../src/ColorTransformation.vala"
				_tmp5__length1 = self->priv->remap_table_length1;
#line 1366 "../src/ColorTransformation.vala"
				_tmp5_[i] = (weight * (x + effect_shift)) + ((1.0f - weight) * x);
#line 9992 "ColorTransformation.c"
			}
		}
	}
#line 1352 "../src/ColorTransformation.vala"
	_hermite_gamma_approximation_function_unref0 (func);
#line 1352 "../src/ColorTransformation.vala"
	return self;
#line 10000 "ColorTransformation.c"
}

ShadowDetailTransformation*
shadow_detail_transformation_new (gfloat user_intensity)
{
#line 1352 "../src/ColorTransformation.vala"
	return shadow_detail_transformation_construct (TYPE_SHADOW_DETAIL_TRANSFORMATION, user_intensity);
#line 10008 "ColorTransformation.c"
}

static void
shadow_detail_transformation_real_transform_pixel_hsv (PixelTransformation* base,
                                                       HSVAnalyticPixel* pixel,
                                                       HSVAnalyticPixel* result)
{
	ShadowDetailTransformation * self;
	HSVAnalyticPixel _result_ = {0};
	HSVAnalyticPixel _tmp0_;
	gfloat* _tmp1_;
	gint _tmp1__length1;
	HSVAnalyticPixel _tmp2_;
	gfloat _tmp3_;
#line 1370 "../src/ColorTransformation.vala"
	self = (ShadowDetailTransformation*) base;
#line 1370 "../src/ColorTransformation.vala"
	g_return_if_fail (pixel != NULL);
#line 1371 "../src/ColorTransformation.vala"
	_tmp0_ = *pixel;
#line 1371 "../src/ColorTransformation.vala"
	_result_ = _tmp0_;
#line 1372 "../src/ColorTransformation.vala"
	_tmp1_ = self->priv->remap_table;
#line 1372 "../src/ColorTransformation.vala"
	_tmp1__length1 = self->priv->remap_table_length1;
#line 1372 "../src/ColorTransformation.vala"
	_tmp2_ = *pixel;
#line 1372 "../src/ColorTransformation.vala"
	_tmp3_ = _tmp1_[(gint) (_tmp2_.light_value * 255.0f)];
#line 1372 "../src/ColorTransformation.vala"
	_result_.light_value = CLAMP (_tmp3_, 0.0f, 1.0f);
#line 1373 "../src/ColorTransformation.vala"
	*result = _result_;
#line 1373 "../src/ColorTransformation.vala"
	return;
#line 10045 "ColorTransformation.c"
}

static PixelTransformation*
shadow_detail_transformation_real_copy (PixelTransformation* base)
{
	ShadowDetailTransformation * self;
	ShadowDetailTransformation* _tmp0_;
	PixelTransformation* result;
#line 1376 "../src/ColorTransformation.vala"
	self = (ShadowDetailTransformation*) base;
#line 1377 "../src/ColorTransformation.vala"
	_tmp0_ = shadow_detail_transformation_new (self->priv->intensity);
#line 1377 "../src/ColorTransformation.vala"
	result = (PixelTransformation*) _tmp0_;
#line 1377 "../src/ColorTransformation.vala"
	return result;
#line 10062 "ColorTransformation.c"
}

static gboolean
shadow_detail_transformation_real_is_identity (PixelTransformation* base)
{
	ShadowDetailTransformation * self;
	gboolean result;
#line 1380 "../src/ColorTransformation.vala"
	self = (ShadowDetailTransformation*) base;
#line 1381 "../src/ColorTransformation.vala"
	result = self->priv->intensity == 0.0f;
#line 1381 "../src/ColorTransformation.vala"
	return result;
#line 10076 "ColorTransformation.c"
}

gfloat
shadow_detail_transformation_get_parameter (ShadowDetailTransformation* self)
{
	gfloat result;
#line 1384 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 1385 "../src/ColorTransformation.vala"
	result = self->priv->intensity;
#line 1385 "../src/ColorTransformation.vala"
	return result;
#line 10089 "ColorTransformation.c"
}

static void
shadow_detail_transformation_class_init (ShadowDetailTransformationClass * klass,
                                         gpointer klass_data)
{
#line 1340 "../src/ColorTransformation.vala"
	shadow_detail_transformation_parent_class = g_type_class_peek_parent (klass);
#line 1340 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = shadow_detail_transformation_finalize;
#line 1340 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &ShadowDetailTransformation_private_offset);
#line 1340 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->transform_pixel_hsv = (void (*) (PixelTransformation*, HSVAnalyticPixel*, HSVAnalyticPixel*)) shadow_detail_transformation_real_transform_pixel_hsv;
#line 1340 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->copy = (PixelTransformation* (*) (PixelTransformation*)) shadow_detail_transformation_real_copy;
#line 1340 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->is_identity = (gboolean (*) (PixelTransformation*)) shadow_detail_transformation_real_is_identity;
#line 10108 "ColorTransformation.c"
}

static void
shadow_detail_transformation_instance_init (ShadowDetailTransformation * self,
                                            gpointer klass)
{
#line 1340 "../src/ColorTransformation.vala"
	self->priv = shadow_detail_transformation_get_instance_private (self);
#line 1346 "../src/ColorTransformation.vala"
	self->priv->intensity = 0.0f;
#line 1347 "../src/ColorTransformation.vala"
	self->priv->remap_table = NULL;
#line 1347 "../src/ColorTransformation.vala"
	self->priv->remap_table_length1 = 0;
#line 1347 "../src/ColorTransformation.vala"
	self->priv->_remap_table_size_ = self->priv->remap_table_length1;
#line 10125 "ColorTransformation.c"
}

static void
shadow_detail_transformation_finalize (PixelTransformation * obj)
{
	ShadowDetailTransformation * self;
#line 1340 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHADOW_DETAIL_TRANSFORMATION, ShadowDetailTransformation);
#line 1347 "../src/ColorTransformation.vala"
	self->priv->remap_table = (g_free (self->priv->remap_table), NULL);
#line 1340 "../src/ColorTransformation.vala"
	PIXEL_TRANSFORMATION_CLASS (shadow_detail_transformation_parent_class)->finalize (obj);
#line 10138 "ColorTransformation.c"
}

static GType
shadow_detail_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ShadowDetailTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) shadow_detail_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ShadowDetailTransformation), 0, (GInstanceInitFunc) shadow_detail_transformation_instance_init, NULL };
	GType shadow_detail_transformation_type_id;
	shadow_detail_transformation_type_id = g_type_register_static (TYPE_HSV_TRANSFORMATION, "ShadowDetailTransformation", &g_define_type_info, 0);
	ShadowDetailTransformation_private_offset = g_type_add_instance_private (shadow_detail_transformation_type_id, sizeof (ShadowDetailTransformationPrivate));
	return shadow_detail_transformation_type_id;
}

GType
shadow_detail_transformation_get_type (void)
{
	static volatile gsize shadow_detail_transformation_type_id__once = 0;
	if (g_once_init_enter (&shadow_detail_transformation_type_id__once)) {
		GType shadow_detail_transformation_type_id;
		shadow_detail_transformation_type_id = shadow_detail_transformation_get_type_once ();
		g_once_init_leave (&shadow_detail_transformation_type_id__once, shadow_detail_transformation_type_id);
	}
	return shadow_detail_transformation_type_id__once;
}

static inline gpointer
hermite_gamma_approximation_function_get_instance_private (HermiteGammaApproximationFunction* self)
{
	return G_STRUCT_MEMBER_P (self, HermiteGammaApproximationFunction_private_offset);
}

HermiteGammaApproximationFunction*
hermite_gamma_approximation_function_construct (GType object_type,
                                                gfloat user_interval_upper)
{
	HermiteGammaApproximationFunction* self = NULL;
#line 1393 "../src/ColorTransformation.vala"
	self = (HermiteGammaApproximationFunction*) g_type_create_instance (object_type);
#line 1394 "../src/ColorTransformation.vala"
	self->priv->nonzero_interval_upper = CLAMP (user_interval_upper, 0.1f, 1.0f);
#line 1395 "../src/ColorTransformation.vala"
	self->priv->x_scale = 1.0f / self->priv->nonzero_interval_upper;
#line 1393 "../src/ColorTransformation.vala"
	return self;
#line 10182 "ColorTransformation.c"
}

HermiteGammaApproximationFunction*
hermite_gamma_approximation_function_new (gfloat user_interval_upper)
{
#line 1393 "../src/ColorTransformation.vala"
	return hermite_gamma_approximation_function_construct (TYPE_HERMITE_GAMMA_APPROXIMATION_FUNCTION, user_interval_upper);
#line 10190 "ColorTransformation.c"
}

gfloat
hermite_gamma_approximation_function_evaluate (HermiteGammaApproximationFunction* self,
                                               gfloat x)
{
	gfloat result;
#line 1398 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 1399 "../src/ColorTransformation.vala"
	if (x < 0.0f) {
#line 1400 "../src/ColorTransformation.vala"
		result = 0.0f;
#line 1400 "../src/ColorTransformation.vala"
		return result;
#line 10206 "ColorTransformation.c"
	} else {
#line 1401 "../src/ColorTransformation.vala"
		if (x > self->priv->nonzero_interval_upper) {
#line 1402 "../src/ColorTransformation.vala"
			result = 0.0f;
#line 1402 "../src/ColorTransformation.vala"
			return result;
#line 10214 "ColorTransformation.c"
		} else {
			gfloat indep_var = 0.0F;
			gfloat dep_var = 0.0F;
#line 1404 "../src/ColorTransformation.vala"
			indep_var = self->priv->x_scale * x;
#line 1406 "../src/ColorTransformation.vala"
			dep_var = 6.0f * ((((indep_var * indep_var) * indep_var) - (2.0f * (indep_var * indep_var))) + indep_var);
#line 1409 "../src/ColorTransformation.vala"
			result = CLAMP (dep_var, 0.0f, 1.0f);
#line 1409 "../src/ColorTransformation.vala"
			return result;
#line 10226 "ColorTransformation.c"
		}
	}
}

static void
value_hermite_gamma_approximation_function_init (GValue* value)
{
#line 1389 "../src/ColorTransformation.vala"
	value->data[0].v_pointer = NULL;
#line 10236 "ColorTransformation.c"
}

static void
value_hermite_gamma_approximation_function_free_value (GValue* value)
{
#line 1389 "../src/ColorTransformation.vala"
	if (value->data[0].v_pointer) {
#line 1389 "../src/ColorTransformation.vala"
		hermite_gamma_approximation_function_unref (value->data[0].v_pointer);
#line 10246 "ColorTransformation.c"
	}
}

static void
value_hermite_gamma_approximation_function_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 1389 "../src/ColorTransformation.vala"
	if (src_value->data[0].v_pointer) {
#line 1389 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = hermite_gamma_approximation_function_ref (src_value->data[0].v_pointer);
#line 10258 "ColorTransformation.c"
	} else {
#line 1389 "../src/ColorTransformation.vala"
		dest_value->data[0].v_pointer = NULL;
#line 10262 "ColorTransformation.c"
	}
}

static gpointer
value_hermite_gamma_approximation_function_peek_pointer (const GValue* value)
{
#line 1389 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 10271 "ColorTransformation.c"
}

static gchar*
value_hermite_gamma_approximation_function_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 1389 "../src/ColorTransformation.vala"
	if (collect_values[0].v_pointer) {
#line 10282 "ColorTransformation.c"
		HermiteGammaApproximationFunction * object;
		object = collect_values[0].v_pointer;
#line 1389 "../src/ColorTransformation.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1389 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 10289 "ColorTransformation.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1389 "../src/ColorTransformation.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 10293 "ColorTransformation.c"
		}
#line 1389 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = hermite_gamma_approximation_function_ref (object);
#line 10297 "ColorTransformation.c"
	} else {
#line 1389 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 10301 "ColorTransformation.c"
	}
#line 1389 "../src/ColorTransformation.vala"
	return NULL;
#line 10305 "ColorTransformation.c"
}

static gchar*
value_hermite_gamma_approximation_function_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	HermiteGammaApproximationFunction ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1389 "../src/ColorTransformation.vala"
	if (!object_p) {
#line 1389 "../src/ColorTransformation.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 10320 "ColorTransformation.c"
	}
#line 1389 "../src/ColorTransformation.vala"
	if (!value->data[0].v_pointer) {
#line 1389 "../src/ColorTransformation.vala"
		*object_p = NULL;
#line 10326 "ColorTransformation.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1389 "../src/ColorTransformation.vala"
		*object_p = value->data[0].v_pointer;
#line 10330 "ColorTransformation.c"
	} else {
#line 1389 "../src/ColorTransformation.vala"
		*object_p = hermite_gamma_approximation_function_ref (value->data[0].v_pointer);
#line 10334 "ColorTransformation.c"
	}
#line 1389 "../src/ColorTransformation.vala"
	return NULL;
#line 10338 "ColorTransformation.c"
}

GParamSpec*
param_spec_hermite_gamma_approximation_function (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	ParamSpecHermiteGammaApproximationFunction* spec;
#line 1389 "../src/ColorTransformation.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HERMITE_GAMMA_APPROXIMATION_FUNCTION), NULL);
#line 1389 "../src/ColorTransformation.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1389 "../src/ColorTransformation.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1389 "../src/ColorTransformation.vala"
	return G_PARAM_SPEC (spec);
#line 10357 "ColorTransformation.c"
}

gpointer
value_get_hermite_gamma_approximation_function (const GValue* value)
{
#line 1389 "../src/ColorTransformation.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HERMITE_GAMMA_APPROXIMATION_FUNCTION), NULL);
#line 1389 "../src/ColorTransformation.vala"
	return value->data[0].v_pointer;
#line 10367 "ColorTransformation.c"
}

void
value_set_hermite_gamma_approximation_function (GValue* value,
                                                gpointer v_object)
{
	HermiteGammaApproximationFunction * old;
#line 1389 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HERMITE_GAMMA_APPROXIMATION_FUNCTION));
#line 1389 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 1389 "../src/ColorTransformation.vala"
	if (v_object) {
#line 1389 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HERMITE_GAMMA_APPROXIMATION_FUNCTION));
#line 1389 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1389 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 1389 "../src/ColorTransformation.vala"
		hermite_gamma_approximation_function_ref (value->data[0].v_pointer);
#line 10389 "ColorTransformation.c"
	} else {
#line 1389 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 10393 "ColorTransformation.c"
	}
#line 1389 "../src/ColorTransformation.vala"
	if (old) {
#line 1389 "../src/ColorTransformation.vala"
		hermite_gamma_approximation_function_unref (old);
#line 10399 "ColorTransformation.c"
	}
}

void
value_take_hermite_gamma_approximation_function (GValue* value,
                                                 gpointer v_object)
{
	HermiteGammaApproximationFunction * old;
#line 1389 "../src/ColorTransformation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HERMITE_GAMMA_APPROXIMATION_FUNCTION));
#line 1389 "../src/ColorTransformation.vala"
	old = value->data[0].v_pointer;
#line 1389 "../src/ColorTransformation.vala"
	if (v_object) {
#line 1389 "../src/ColorTransformation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HERMITE_GAMMA_APPROXIMATION_FUNCTION));
#line 1389 "../src/ColorTransformation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1389 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = v_object;
#line 10420 "ColorTransformation.c"
	} else {
#line 1389 "../src/ColorTransformation.vala"
		value->data[0].v_pointer = NULL;
#line 10424 "ColorTransformation.c"
	}
#line 1389 "../src/ColorTransformation.vala"
	if (old) {
#line 1389 "../src/ColorTransformation.vala"
		hermite_gamma_approximation_function_unref (old);
#line 10430 "ColorTransformation.c"
	}
}

static void
hermite_gamma_approximation_function_class_init (HermiteGammaApproximationFunctionClass * klass,
                                                 gpointer klass_data)
{
#line 1389 "../src/ColorTransformation.vala"
	hermite_gamma_approximation_function_parent_class = g_type_class_peek_parent (klass);
#line 1389 "../src/ColorTransformation.vala"
	((HermiteGammaApproximationFunctionClass *) klass)->finalize = hermite_gamma_approximation_function_finalize;
#line 1389 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &HermiteGammaApproximationFunction_private_offset);
#line 10444 "ColorTransformation.c"
}

static void
hermite_gamma_approximation_function_instance_init (HermiteGammaApproximationFunction * self,
                                                    gpointer klass)
{
#line 1389 "../src/ColorTransformation.vala"
	self->priv = hermite_gamma_approximation_function_get_instance_private (self);
#line 1390 "../src/ColorTransformation.vala"
	self->priv->x_scale = 1.0f;
#line 1391 "../src/ColorTransformation.vala"
	self->priv->nonzero_interval_upper = 1.0f;
#line 1389 "../src/ColorTransformation.vala"
	self->ref_count = 1;
#line 10459 "ColorTransformation.c"
}

static void
hermite_gamma_approximation_function_finalize (HermiteGammaApproximationFunction * obj)
{
	HermiteGammaApproximationFunction * self;
#line 1389 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HERMITE_GAMMA_APPROXIMATION_FUNCTION, HermiteGammaApproximationFunction);
#line 1389 "../src/ColorTransformation.vala"
	g_signal_handlers_destroy (self);
#line 10470 "ColorTransformation.c"
}

static GType
hermite_gamma_approximation_function_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_hermite_gamma_approximation_function_init, value_hermite_gamma_approximation_function_free_value, value_hermite_gamma_approximation_function_copy_value, value_hermite_gamma_approximation_function_peek_pointer, "p", value_hermite_gamma_approximation_function_collect_value, "p", value_hermite_gamma_approximation_function_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HermiteGammaApproximationFunctionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hermite_gamma_approximation_function_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HermiteGammaApproximationFunction), 0, (GInstanceInitFunc) hermite_gamma_approximation_function_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType hermite_gamma_approximation_function_type_id;
	hermite_gamma_approximation_function_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HermiteGammaApproximationFunction", &g_define_type_info, &g_define_type_fundamental_info, 0);
	HermiteGammaApproximationFunction_private_offset = g_type_add_instance_private (hermite_gamma_approximation_function_type_id, sizeof (HermiteGammaApproximationFunctionPrivate));
	return hermite_gamma_approximation_function_type_id;
}

GType
hermite_gamma_approximation_function_get_type (void)
{
	static volatile gsize hermite_gamma_approximation_function_type_id__once = 0;
	if (g_once_init_enter (&hermite_gamma_approximation_function_type_id__once)) {
		GType hermite_gamma_approximation_function_type_id;
		hermite_gamma_approximation_function_type_id = hermite_gamma_approximation_function_get_type_once ();
		g_once_init_leave (&hermite_gamma_approximation_function_type_id__once, hermite_gamma_approximation_function_type_id);
	}
	return hermite_gamma_approximation_function_type_id__once;
}

gpointer
hermite_gamma_approximation_function_ref (gpointer instance)
{
	HermiteGammaApproximationFunction * self;
	self = instance;
#line 1389 "../src/ColorTransformation.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1389 "../src/ColorTransformation.vala"
	return instance;
#line 10506 "ColorTransformation.c"
}

void
hermite_gamma_approximation_function_unref (gpointer instance)
{
	HermiteGammaApproximationFunction * self;
	self = instance;
#line 1389 "../src/ColorTransformation.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1389 "../src/ColorTransformation.vala"
		HERMITE_GAMMA_APPROXIMATION_FUNCTION_GET_CLASS (self)->finalize (self);
#line 1389 "../src/ColorTransformation.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 10520 "ColorTransformation.c"
	}
}

static inline gpointer
highlight_detail_transformation_get_instance_private (HighlightDetailTransformation* self)
{
	return G_STRUCT_MEMBER_P (self, HighlightDetailTransformation_private_offset);
}

HighlightDetailTransformation*
highlight_detail_transformation_construct (GType object_type,
                                           gfloat user_intensity)
{
	HighlightDetailTransformation* self = NULL;
	gfloat intensity_adj = 0.0F;
	gfloat effect_shift = 0.0F;
	HermiteGammaApproximationFunction* func = NULL;
	HermiteGammaApproximationFunction* _tmp0_;
	gfloat* _tmp1_;
#line 1427 "../src/ColorTransformation.vala"
	self = (HighlightDetailTransformation*) hsv_transformation_construct (object_type, PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS);
#line 1429 "../src/ColorTransformation.vala"
	self->priv->intensity = user_intensity;
#line 1430 "../src/ColorTransformation.vala"
	intensity_adj = CLAMP (self->priv->intensity / HIGHLIGHT_DETAIL_TRANSFORMATION_MIN_PARAMETER, 0.0f, 1.0f);
#line 1432 "../src/ColorTransformation.vala"
	effect_shift = HIGHLIGHT_DETAIL_TRANSFORMATION_MAX_EFFECT_SHIFT * intensity_adj;
#line 1433 "../src/ColorTransformation.vala"
	_tmp0_ = hermite_gamma_approximation_function_new (HIGHLIGHT_DETAIL_TRANSFORMATION_TONAL_WIDTH);
#line 1433 "../src/ColorTransformation.vala"
	func = _tmp0_;
#line 1436 "../src/ColorTransformation.vala"
	_tmp1_ = g_new0 (gfloat, 256);
#line 1436 "../src/ColorTransformation.vala"
	self->priv->remap_table = (g_free (self->priv->remap_table), NULL);
#line 1436 "../src/ColorTransformation.vala"
	self->priv->remap_table = _tmp1_;
#line 1436 "../src/ColorTransformation.vala"
	self->priv->remap_table_length1 = 256;
#line 1436 "../src/ColorTransformation.vala"
	self->priv->_remap_table_size_ = self->priv->remap_table_length1;
#line 10562 "ColorTransformation.c"
	{
		gint i = 0;
#line 1437 "../src/ColorTransformation.vala"
		i = 0;
#line 10567 "ColorTransformation.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1437 "../src/ColorTransformation.vala"
			_tmp2_ = TRUE;
#line 1437 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 10574 "ColorTransformation.c"
				gfloat x = 0.0F;
				gfloat weight = 0.0F;
				HermiteGammaApproximationFunction* _tmp4_;
				gfloat* _tmp5_;
				gint _tmp5__length1;
#line 1437 "../src/ColorTransformation.vala"
				if (!_tmp2_) {
#line 10582 "ColorTransformation.c"
					gint _tmp3_;
#line 1437 "../src/ColorTransformation.vala"
					_tmp3_ = i;
#line 1437 "../src/ColorTransformation.vala"
					i = _tmp3_ + 1;
#line 10588 "ColorTransformation.c"
				}
#line 1437 "../src/ColorTransformation.vala"
				_tmp2_ = FALSE;
#line 1437 "../src/ColorTransformation.vala"
				if (!(i < 256)) {
#line 1437 "../src/ColorTransformation.vala"
					break;
#line 10596 "ColorTransformation.c"
				}
#line 1438 "../src/ColorTransformation.vala"
				x = ((gfloat) i) / 255.0f;
#line 1439 "../src/ColorTransformation.vala"
				_tmp4_ = func;
#line 1439 "../src/ColorTransformation.vala"
				weight = hermite_gamma_approximation_function_evaluate (_tmp4_, 1.0f - x);
#line 1440 "../src/ColorTransformation.vala"
				_tmp5_ = self->priv->remap_table;
#line 1440 "../src/ColorTransformation.vala"
				_tmp5__length1 = self->priv->remap_table_length1;
#line 1440 "../src/ColorTransformation.vala"
				_tmp5_[i] = (weight * (x - effect_shift)) + ((1.0f - weight) * x);
#line 10610 "ColorTransformation.c"
			}
		}
	}
#line 1426 "../src/ColorTransformation.vala"
	_hermite_gamma_approximation_function_unref0 (func);
#line 1426 "../src/ColorTransformation.vala"
	return self;
#line 10618 "ColorTransformation.c"
}

HighlightDetailTransformation*
highlight_detail_transformation_new (gfloat user_intensity)
{
#line 1426 "../src/ColorTransformation.vala"
	return highlight_detail_transformation_construct (TYPE_HIGHLIGHT_DETAIL_TRANSFORMATION, user_intensity);
#line 10626 "ColorTransformation.c"
}

static void
highlight_detail_transformation_real_transform_pixel_hsv (PixelTransformation* base,
                                                          HSVAnalyticPixel* pixel,
                                                          HSVAnalyticPixel* result)
{
	HighlightDetailTransformation * self;
	HSVAnalyticPixel _result_ = {0};
	HSVAnalyticPixel _tmp0_;
	gfloat* _tmp1_;
	gint _tmp1__length1;
	HSVAnalyticPixel _tmp2_;
	gfloat _tmp3_;
#line 1444 "../src/ColorTransformation.vala"
	self = (HighlightDetailTransformation*) base;
#line 1444 "../src/ColorTransformation.vala"
	g_return_if_fail (pixel != NULL);
#line 1445 "../src/ColorTransformation.vala"
	_tmp0_ = *pixel;
#line 1445 "../src/ColorTransformation.vala"
	_result_ = _tmp0_;
#line 1446 "../src/ColorTransformation.vala"
	_tmp1_ = self->priv->remap_table;
#line 1446 "../src/ColorTransformation.vala"
	_tmp1__length1 = self->priv->remap_table_length1;
#line 1446 "../src/ColorTransformation.vala"
	_tmp2_ = *pixel;
#line 1446 "../src/ColorTransformation.vala"
	_tmp3_ = _tmp1_[(gint) (_tmp2_.light_value * 255.0f)];
#line 1446 "../src/ColorTransformation.vala"
	_result_.light_value = CLAMP (_tmp3_, 0.0f, 1.0f);
#line 1447 "../src/ColorTransformation.vala"
	*result = _result_;
#line 1447 "../src/ColorTransformation.vala"
	return;
#line 10663 "ColorTransformation.c"
}

static PixelTransformation*
highlight_detail_transformation_real_copy (PixelTransformation* base)
{
	HighlightDetailTransformation * self;
	HighlightDetailTransformation* _tmp0_;
	PixelTransformation* result;
#line 1450 "../src/ColorTransformation.vala"
	self = (HighlightDetailTransformation*) base;
#line 1451 "../src/ColorTransformation.vala"
	_tmp0_ = highlight_detail_transformation_new (self->priv->intensity);
#line 1451 "../src/ColorTransformation.vala"
	result = (PixelTransformation*) _tmp0_;
#line 1451 "../src/ColorTransformation.vala"
	return result;
#line 10680 "ColorTransformation.c"
}

static gboolean
highlight_detail_transformation_real_is_identity (PixelTransformation* base)
{
	HighlightDetailTransformation * self;
	gboolean result;
#line 1454 "../src/ColorTransformation.vala"
	self = (HighlightDetailTransformation*) base;
#line 1455 "../src/ColorTransformation.vala"
	result = self->priv->intensity == 0.0f;
#line 1455 "../src/ColorTransformation.vala"
	return result;
#line 10694 "ColorTransformation.c"
}

gfloat
highlight_detail_transformation_get_parameter (HighlightDetailTransformation* self)
{
	gfloat result;
#line 1458 "../src/ColorTransformation.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 1459 "../src/ColorTransformation.vala"
	result = self->priv->intensity;
#line 1459 "../src/ColorTransformation.vala"
	return result;
#line 10707 "ColorTransformation.c"
}

static void
highlight_detail_transformation_class_init (HighlightDetailTransformationClass * klass,
                                            gpointer klass_data)
{
#line 1414 "../src/ColorTransformation.vala"
	highlight_detail_transformation_parent_class = g_type_class_peek_parent (klass);
#line 1414 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->finalize = highlight_detail_transformation_finalize;
#line 1414 "../src/ColorTransformation.vala"
	g_type_class_adjust_private_offset (klass, &HighlightDetailTransformation_private_offset);
#line 1414 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->transform_pixel_hsv = (void (*) (PixelTransformation*, HSVAnalyticPixel*, HSVAnalyticPixel*)) highlight_detail_transformation_real_transform_pixel_hsv;
#line 1414 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->copy = (PixelTransformation* (*) (PixelTransformation*)) highlight_detail_transformation_real_copy;
#line 1414 "../src/ColorTransformation.vala"
	((PixelTransformationClass *) klass)->is_identity = (gboolean (*) (PixelTransformation*)) highlight_detail_transformation_real_is_identity;
#line 10726 "ColorTransformation.c"
}

static void
highlight_detail_transformation_instance_init (HighlightDetailTransformation * self,
                                               gpointer klass)
{
#line 1414 "../src/ColorTransformation.vala"
	self->priv = highlight_detail_transformation_get_instance_private (self);
#line 1420 "../src/ColorTransformation.vala"
	self->priv->intensity = 0.0f;
#line 1421 "../src/ColorTransformation.vala"
	self->priv->remap_table = NULL;
#line 1421 "../src/ColorTransformation.vala"
	self->priv->remap_table_length1 = 0;
#line 1421 "../src/ColorTransformation.vala"
	self->priv->_remap_table_size_ = self->priv->remap_table_length1;
#line 10743 "ColorTransformation.c"
}

static void
highlight_detail_transformation_finalize (PixelTransformation * obj)
{
	HighlightDetailTransformation * self;
#line 1414 "../src/ColorTransformation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HIGHLIGHT_DETAIL_TRANSFORMATION, HighlightDetailTransformation);
#line 1421 "../src/ColorTransformation.vala"
	self->priv->remap_table = (g_free (self->priv->remap_table), NULL);
#line 1414 "../src/ColorTransformation.vala"
	PIXEL_TRANSFORMATION_CLASS (highlight_detail_transformation_parent_class)->finalize (obj);
#line 10756 "ColorTransformation.c"
}

static GType
highlight_detail_transformation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HighlightDetailTransformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) highlight_detail_transformation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HighlightDetailTransformation), 0, (GInstanceInitFunc) highlight_detail_transformation_instance_init, NULL };
	GType highlight_detail_transformation_type_id;
	highlight_detail_transformation_type_id = g_type_register_static (TYPE_HSV_TRANSFORMATION, "HighlightDetailTransformation", &g_define_type_info, 0);
	HighlightDetailTransformation_private_offset = g_type_add_instance_private (highlight_detail_transformation_type_id, sizeof (HighlightDetailTransformationPrivate));
	return highlight_detail_transformation_type_id;
}

GType
highlight_detail_transformation_get_type (void)
{
	static volatile gsize highlight_detail_transformation_type_id__once = 0;
	if (g_once_init_enter (&highlight_detail_transformation_type_id__once)) {
		GType highlight_detail_transformation_type_id;
		highlight_detail_transformation_type_id = highlight_detail_transformation_get_type_once ();
		g_once_init_leave (&highlight_detail_transformation_type_id__once, highlight_detail_transformation_type_id);
	}
	return highlight_detail_transformation_type_id__once;
}

PixelTransformationBundle*
auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf)
{
	PixelTransformationBundle* adjustments = NULL;
	PixelTransformationBundle* _tmp0_;
	IntensityHistogram* analysis_histogram = NULL;
	IntensityHistogram* _tmp1_;
	gfloat pct_in_range = 0.0F;
	IntensityHistogram* _tmp2_;
	IntensityHistogram* _tmp3_;
	gfloat shadow_range_mean_prob_val = 0.0F;
	IntensityHistogram* _tmp4_;
	IntensityHistogram* _tmp5_;
	gint shadow_mean_intensity = 0;
	gboolean _tmp9_ = FALSE;
	PixelTransformationBundle* _tmp27_;
	HighlightDetailTransformation* _tmp28_;
	HighlightDetailTransformation* _tmp29_;
	PixelTransformationBundle* _tmp30_;
	TemperatureTransformation* _tmp31_;
	TemperatureTransformation* _tmp32_;
	PixelTransformationBundle* _tmp33_;
	TintTransformation* _tmp34_;
	TintTransformation* _tmp35_;
	PixelTransformationBundle* _tmp36_;
	ExposureTransformation* _tmp37_;
	ExposureTransformation* _tmp38_;
	PixelTransformationBundle* _tmp39_;
	SaturationTransformation* _tmp40_;
	SaturationTransformation* _tmp41_;
	PixelTransformationBundle* result;
#line 1472 "../src/ColorTransformation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 1473 "../src/ColorTransformation.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 1473 "../src/ColorTransformation.vala"
	adjustments = _tmp0_;
#line 1475 "../src/ColorTransformation.vala"
	_tmp1_ = intensity_histogram_new (pixbuf);
#line 1475 "../src/ColorTransformation.vala"
	analysis_histogram = _tmp1_;
#line 1478 "../src/ColorTransformation.vala"
	_tmp2_ = analysis_histogram;
#line 1478 "../src/ColorTransformation.vala"
	_tmp3_ = analysis_histogram;
#line 1478 "../src/ColorTransformation.vala"
	pct_in_range = 100.0f * (intensity_histogram_get_cumulative_probability (_tmp2_, AUTO_ENHANCE_SHADOW_DETECT_MAX_INTENSITY) - intensity_histogram_get_cumulative_probability (_tmp3_, AUTO_ENHANCE_SHADOW_DETECT_MIN_INTENSITY));
#line 1484 "../src/ColorTransformation.vala"
	_tmp4_ = analysis_histogram;
#line 1484 "../src/ColorTransformation.vala"
	_tmp5_ = analysis_histogram;
#line 1484 "../src/ColorTransformation.vala"
	shadow_range_mean_prob_val = (intensity_histogram_get_cumulative_probability (_tmp4_, AUTO_ENHANCE_SHADOW_DETECT_MIN_INTENSITY) + intensity_histogram_get_cumulative_probability (_tmp5_, AUTO_ENHANCE_SHADOW_DETECT_MAX_INTENSITY)) * 0.5f;
#line 1487 "../src/ColorTransformation.vala"
	shadow_mean_intensity = AUTO_ENHANCE_SHADOW_DETECT_MIN_INTENSITY;
#line 10836 "ColorTransformation.c"
	{
		gboolean _tmp6_ = FALSE;
#line 1488 "../src/ColorTransformation.vala"
		_tmp6_ = TRUE;
#line 1488 "../src/ColorTransformation.vala"
		while (TRUE) {
#line 10843 "ColorTransformation.c"
			IntensityHistogram* _tmp8_;
#line 1488 "../src/ColorTransformation.vala"
			if (!_tmp6_) {
#line 10847 "ColorTransformation.c"
				gint _tmp7_;
#line 1488 "../src/ColorTransformation.vala"
				_tmp7_ = shadow_mean_intensity;
#line 1488 "../src/ColorTransformation.vala"
				shadow_mean_intensity = _tmp7_ + 1;
#line 10853 "ColorTransformation.c"
			}
#line 1488 "../src/ColorTransformation.vala"
			_tmp6_ = FALSE;
#line 1488 "../src/ColorTransformation.vala"
			if (!(shadow_mean_intensity <= AUTO_ENHANCE_SHADOW_DETECT_MAX_INTENSITY)) {
#line 1488 "../src/ColorTransformation.vala"
				break;
#line 10861 "ColorTransformation.c"
			}
#line 1489 "../src/ColorTransformation.vala"
			_tmp8_ = analysis_histogram;
#line 1489 "../src/ColorTransformation.vala"
			if (intensity_histogram_get_cumulative_probability (_tmp8_, shadow_mean_intensity) >= shadow_range_mean_prob_val) {
#line 1490 "../src/ColorTransformation.vala"
				break;
#line 10869 "ColorTransformation.c"
			}
		}
	}
#line 1498 "../src/ColorTransformation.vala"
	if (pct_in_range > 40.0f) {
#line 1498 "../src/ColorTransformation.vala"
		_tmp9_ = TRUE;
#line 10877 "ColorTransformation.c"
	} else {
		gboolean _tmp10_ = FALSE;
#line 1498 "../src/ColorTransformation.vala"
		if (pct_in_range > 20.0f) {
#line 1498 "../src/ColorTransformation.vala"
			_tmp10_ = shadow_mean_intensity < AUTO_ENHANCE_EMPIRICAL_DARK;
#line 10884 "ColorTransformation.c"
		} else {
#line 1498 "../src/ColorTransformation.vala"
			_tmp10_ = FALSE;
#line 10888 "ColorTransformation.c"
		}
#line 1498 "../src/ColorTransformation.vala"
		_tmp9_ = _tmp10_;
#line 10892 "ColorTransformation.c"
	}
#line 1498 "../src/ColorTransformation.vala"
	if (_tmp9_) {
#line 10896 "ColorTransformation.c"
		gfloat shadow_trans_effect_size = 0.0F;
		PixelTransformationBundle* _tmp11_;
		ShadowDetailTransformation* _tmp12_;
		ShadowDetailTransformation* _tmp13_;
		gint discard_point = 0;
		PixelTransformationBundle* _tmp17_;
		ExpansionTransformation* _tmp18_;
		ExpansionTransformation* _tmp19_;
#line 1499 "../src/ColorTransformation.vala"
		shadow_trans_effect_size = ((((gfloat) AUTO_ENHANCE_SHADOW_DETECT_MAX_INTENSITY) - ((gfloat) shadow_mean_intensity)) / ((gfloat) AUTO_ENHANCE_SHADOW_DETECT_INTENSITY_RANGE)) * SHADOW_DETAIL_TRANSFORMATION_MAX_PARAMETER;
#line 1503 "../src/ColorTransformation.vala"
		shadow_trans_effect_size *= AUTO_ENHANCE_SHADOW_AGGRESSIVENESS_MUL;
#line 1505 "../src/ColorTransformation.vala"
		_tmp11_ = adjustments;
#line 1505 "../src/ColorTransformation.vala"
		_tmp12_ = shadow_detail_transformation_new (shadow_trans_effect_size);
#line 1505 "../src/ColorTransformation.vala"
		_tmp13_ = _tmp12_;
#line 1505 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_set (_tmp11_, (PixelTransformation*) _tmp13_);
#line 1505 "../src/ColorTransformation.vala"
		_pixel_transformation_unref0 (_tmp13_);
#line 1509 "../src/ColorTransformation.vala"
		discard_point = 255;
#line 10921 "ColorTransformation.c"
		{
			gboolean _tmp14_ = FALSE;
#line 1510 "../src/ColorTransformation.vala"
			_tmp14_ = TRUE;
#line 1510 "../src/ColorTransformation.vala"
			while (TRUE) {
#line 10928 "ColorTransformation.c"
				IntensityHistogram* _tmp16_;
#line 1510 "../src/ColorTransformation.vala"
				if (!_tmp14_) {
#line 10932 "ColorTransformation.c"
					gint _tmp15_;
#line 1510 "../src/ColorTransformation.vala"
					_tmp15_ = discard_point;
#line 1510 "../src/ColorTransformation.vala"
					discard_point = _tmp15_ - 1;
#line 10938 "ColorTransformation.c"
				}
#line 1510 "../src/ColorTransformation.vala"
				_tmp14_ = FALSE;
#line 1510 "../src/ColorTransformation.vala"
				if (!(discard_point > -1)) {
#line 1510 "../src/ColorTransformation.vala"
					break;
#line 10946 "ColorTransformation.c"
				}
#line 1511 "../src/ColorTransformation.vala"
				_tmp16_ = analysis_histogram;
#line 1511 "../src/ColorTransformation.vala"
				if ((1.0f - intensity_histogram_get_cumulative_probability (_tmp16_, discard_point)) > AUTO_ENHANCE_SHADOW_MODE_HIGH_DISCARD_MASS) {
#line 1513 "../src/ColorTransformation.vala"
					break;
#line 10954 "ColorTransformation.c"
				}
			}
		}
#line 1516 "../src/ColorTransformation.vala"
		_tmp17_ = adjustments;
#line 1516 "../src/ColorTransformation.vala"
		_tmp18_ = expansion_transformation_new_from_extrema (0, discard_point);
#line 1516 "../src/ColorTransformation.vala"
		_tmp19_ = _tmp18_;
#line 1516 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_set (_tmp17_, (PixelTransformation*) _tmp19_);
#line 1516 "../src/ColorTransformation.vala"
		_pixel_transformation_unref0 (_tmp19_);
#line 10968 "ColorTransformation.c"
	} else {
		PixelTransformationBundle* _tmp20_;
		IntensityHistogram* _tmp21_;
		ExpansionTransformation* _tmp22_;
		ExpansionTransformation* _tmp23_;
		PixelTransformationBundle* _tmp24_;
		ShadowDetailTransformation* _tmp25_;
		ShadowDetailTransformation* _tmp26_;
#line 1518 "../src/ColorTransformation.vala"
		_tmp20_ = adjustments;
#line 1518 "../src/ColorTransformation.vala"
		_tmp21_ = analysis_histogram;
#line 1518 "../src/ColorTransformation.vala"
		_tmp22_ = expansion_transformation_new (_tmp21_);
#line 1518 "../src/ColorTransformation.vala"
		_tmp23_ = _tmp22_;
#line 1518 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_set (_tmp20_, (PixelTransformation*) _tmp23_);
#line 1518 "../src/ColorTransformation.vala"
		_pixel_transformation_unref0 (_tmp23_);
#line 1519 "../src/ColorTransformation.vala"
		_tmp24_ = adjustments;
#line 1519 "../src/ColorTransformation.vala"
		_tmp25_ = shadow_detail_transformation_new ((gfloat) 0);
#line 1519 "../src/ColorTransformation.vala"
		_tmp26_ = _tmp25_;
#line 1519 "../src/ColorTransformation.vala"
		pixel_transformation_bundle_set (_tmp24_, (PixelTransformation*) _tmp26_);
#line 1519 "../src/ColorTransformation.vala"
		_pixel_transformation_unref0 (_tmp26_);
#line 10999 "ColorTransformation.c"
	}
#line 1523 "../src/ColorTransformation.vala"
	_tmp27_ = adjustments;
#line 1523 "../src/ColorTransformation.vala"
	_tmp28_ = highlight_detail_transformation_new (0.0f);
#line 1523 "../src/ColorTransformation.vala"
	_tmp29_ = _tmp28_;
#line 1523 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (_tmp27_, (PixelTransformation*) _tmp29_);
#line 1523 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp29_);
#line 1524 "../src/ColorTransformation.vala"
	_tmp30_ = adjustments;
#line 1524 "../src/ColorTransformation.vala"
	_tmp31_ = temperature_transformation_new (0.0f);
#line 1524 "../src/ColorTransformation.vala"
	_tmp32_ = _tmp31_;
#line 1524 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (_tmp30_, (PixelTransformation*) _tmp32_);
#line 1524 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp32_);
#line 1525 "../src/ColorTransformation.vala"
	_tmp33_ = adjustments;
#line 1525 "../src/ColorTransformation.vala"
	_tmp34_ = tint_transformation_new (0.0f);
#line 1525 "../src/ColorTransformation.vala"
	_tmp35_ = _tmp34_;
#line 1525 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (_tmp33_, (PixelTransformation*) _tmp35_);
#line 1525 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp35_);
#line 1526 "../src/ColorTransformation.vala"
	_tmp36_ = adjustments;
#line 1526 "../src/ColorTransformation.vala"
	_tmp37_ = exposure_transformation_new (0.0f);
#line 1526 "../src/ColorTransformation.vala"
	_tmp38_ = _tmp37_;
#line 1526 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (_tmp36_, (PixelTransformation*) _tmp38_);
#line 1526 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp38_);
#line 1527 "../src/ColorTransformation.vala"
	_tmp39_ = adjustments;
#line 1527 "../src/ColorTransformation.vala"
	_tmp40_ = saturation_transformation_new (0.0f);
#line 1527 "../src/ColorTransformation.vala"
	_tmp41_ = _tmp40_;
#line 1527 "../src/ColorTransformation.vala"
	pixel_transformation_bundle_set (_tmp39_, (PixelTransformation*) _tmp41_);
#line 1527 "../src/ColorTransformation.vala"
	_pixel_transformation_unref0 (_tmp41_);
#line 1529 "../src/ColorTransformation.vala"
	result = adjustments;
#line 1529 "../src/ColorTransformation.vala"
	_intensity_histogram_unref0 (analysis_histogram);
#line 1529 "../src/ColorTransformation.vala"
	return result;
#line 11057 "ColorTransformation.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

