/* DirectoryMonitor.c generated by valac 0.56.18, the Vala compiler
 * generated from DirectoryMonitor.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* DirectoryMonitor will monitor an entire directory for changes to all files and directories*/
/* within it.  It uses FileMonitor to monitor all directories it discovers at initialization*/
/* and reports changes to the files and directories just as FileMonitor reports them.  Subclasses*/
/* can override the notify_* methods to filter or monitor events before the signal is fired,*/
/* or can override the signals themselves to be notified afterwards.*/
/**/
/* start_discovery () must be called to initiate monitoring.  Directories and files will be reported*/
/* as they're discovered.  Directories will be monitored as they're discovered as well.  Discovery*/
/* can only be initiated once.*/
/**/
/* All signals are virtual and have a corresponding notify_* protected virtual function.*/
/* Subclasses can either override the notify or the signal to decide when they want to process*/
/* the event.*/
/**/
/* DirectoryMonitor also adds a level of intelligence to GLib's monitoring API.Because certain*/
/* file/directory events are decomposed by FileMonitor into more atomic events, it's difficult*/
/* to know when these "composed" events have occurred.  (For example, a file move is reported*/
/* as a DELETED event followed by a CREATED event, with no clue that the two are related.)  Later*/
/* versions added the MOVE event, but we can't rely on those being installed.  Also, documentation*/
/* suggests it's only available with certain back-ends.*/
/**/
/* DirectoryMonitor attempts to solve this by deducing when a set of events actually equals*/
/* a composite event.  It requires more memory in order to do this (i.e. it stores all files and*/
/* their information), but the trade-off is easier file/directory monitoring via familiar*/
/* semantics.*/
/**/
/* DirectoryMonitor also will synthesize events when normal monitor events don't produce expected*/
/* results.  For example, if a directory is moved out of DirectoryMonitor's root, it is reported*/
/* as a delete event, but none of its children are reported as deleted.  Similarly, a directory*/
/* rename can be captured as a move, but notifications for all its children are not fired and*/
/* are synthesized by DirectoryMonitor.  DirectoryMonitor will fire delete and move notifications*/
/* for all the directory's children in depth-first order.*/
/**/
/* In general, DirectoryMonitor attempts to preserve ordering of events, so that (for example) a*/
/* file-altered event doesn't fire before a file-created, and so on.*/
/**/
/* Because of these requirements, DirectoryMonitor maintains a FileInfo struct on all directories*/
/* and files being monitored.  (It maintains the attributes gather during the discovery phase, i.e.*/
/* SUPPLIED_ATTRIBUTES.)  This information can be retrieved via get_info (), get_file_id (), and*/
/* get_etag ().  These calls can be made at any time; the information is stored before any signal*/
/* is fired.*/
/**/
/* Note that DirectoryMonitor currently only supports files and directories.  Other file types*/
/* (special, symbolic links, shortcuts, and mount points) are not supported.  It has been seen*/
/* when a temporary file is created for its file type to be reported as "unknown" and when it's*/
/* altered/deleted to be reported as a regular file.  This means it's possible for a file not to*/
/* be reported as discovered or created but to be reported as altered and/or deleted.*/
/**/
/* DirectoryMonitor can be configured to not recurse (in which case it only discovers/monitors*/
/* the root directory) and to not monitor (in which case only discovery occurs).*/
/**/

#include "io.elementary.photos.h"
#include <gio/gio.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define DIRECTORY_MONITOR_FILE_MONITOR_FLAGS G_FILE_MONITOR_SEND_MOVED
#define DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC ((guint) 500)
#define DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS 5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT (directory_monitor_query_info_queue_element_get_type ())
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))

typedef struct _DirectoryMonitorQueryInfoQueueElement DirectoryMonitorQueryInfoQueueElement;
typedef struct _DirectoryMonitorQueryInfoQueueElementClass DirectoryMonitorQueryInfoQueueElementClass;

#define DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP (directory_monitor_file_info_map_get_type ())
#define DIRECTORY_MONITOR_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))

typedef struct _DirectoryMonitorFileInfoMap DirectoryMonitorFileInfoMap;
typedef struct _DirectoryMonitorFileInfoMapClass DirectoryMonitorFileInfoMapClass;
enum  {
	DIRECTORY_MONITOR_0_PROPERTY,
	DIRECTORY_MONITOR_NUM_PROPERTIES
};
static GParamSpec* directory_monitor_properties[DIRECTORY_MONITOR_NUM_PROPERTIES];
typedef enum  {
	DIRECTORY_MONITOR_FTYPE_FILE,
	DIRECTORY_MONITOR_FTYPE_DIRECTORY,
	DIRECTORY_MONITOR_FTYPE_UNSUPPORTED
} DirectoryMonitorFType;

#define DIRECTORY_MONITOR_TYPE_FTYPE (directory_monitor_ftype_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _directory_monitor_file_info_map_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_file_info_map_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData DirectoryMonitorAsyncInternalNotifyDirectoryMovedData;
typedef struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData DirectoryMonitorAsyncNotifyDirectoryDeletedData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DirectoryMonitorExploreAsyncData DirectoryMonitorExploreAsyncData;
typedef struct _DirectoryMonitorNotifyDirectoryFilesData DirectoryMonitorNotifyDirectoryFilesData;
typedef struct _DirectoryMonitorQueryInfoQueueElementPrivate DirectoryMonitorQueryInfoQueueElementPrivate;
#define _directory_monitor_query_info_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_query_info_queue_element_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecQueryInfoQueueElement DirectoryMonitorParamSpecQueryInfoQueueElement;
typedef struct _DirectoryMonitorFileInfoMapPrivate DirectoryMonitorFileInfoMapPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecFileInfoMap DirectoryMonitorParamSpecFileInfoMap;
enum  {
	DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL,
	DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL,
	DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_FILE_CREATED_SIGNAL,
	DIRECTORY_MONITOR_FILE_MOVED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_FILE_DELETED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL,
	DIRECTORY_MONITOR_CLOSED_SIGNAL,
	DIRECTORY_MONITOR_NUM_SIGNALS
};
static guint directory_monitor_signals[DIRECTORY_MONITOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DirectoryMonitorPrivate {
	GFile* root;
	gboolean recurse;
	gboolean monitoring;
	GeeHashMap* monitors;
	GeeQueue* query_info_queue;
	DirectoryMonitorFileInfoMap* files;
	DirectoryMonitorFileInfoMap* parent_moved;
	GCancellable* cancellable;
	gint outstanding_exploration_dirs;
	gboolean started;
	gboolean has_discovery_started;
	guint delete_timer_id;
};

struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DirectoryMonitor* self;
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* new_dir;
	GFileInfo* new_dir_info;
	GeeArrayList* file_children;
	GeeArrayList* _tmp0_;
	GeeArrayList* dir_children;
	GeeArrayList* _tmp1_;
	gint count;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp5_;
	gint _dir_child_size;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _dir_child_index;
	gint _tmp9_;
	gint _tmp10_;
	GFile* dir_child;
	GeeArrayList* _tmp11_;
	gpointer _tmp12_;
	GFileInfo* dir_info;
	DirectoryMonitorFileInfoMap* _tmp13_;
	GFile* _tmp14_;
	GFileInfo* _tmp15_;
	GFileInfo* _tmp16_;
	GFile* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GFile* _tmp20_;
	GFileInfo* _tmp21_;
	GFile* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFileInfo* _tmp27_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp28_;
	gint _file_child_size;
	GeeArrayList* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint _file_child_index;
	gint _tmp32_;
	gint _tmp33_;
	GFile* file_child;
	GeeArrayList* _tmp34_;
	gpointer _tmp35_;
	GFileInfo* file_info;
	DirectoryMonitorFileInfoMap* _tmp36_;
	GFile* _tmp37_;
	GFileInfo* _tmp38_;
	GFileInfo* _tmp39_;
	GFile* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GFile* _tmp47_;
	GFile* _tmp48_;
	GFileInfo* _tmp49_;
	DirectoryMonitorFileInfoMap* _tmp50_;
	gboolean updated;
	DirectoryMonitorFileInfoMap* _tmp51_;
};

struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	gboolean already_removed;
	GeeArrayList* file_children;
	GeeArrayList* _tmp0_;
	GeeArrayList* dir_children;
	GeeArrayList* _tmp1_;
	gint count;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp5_;
	gint _dir_child_size;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _dir_child_index;
	gint _tmp9_;
	gint _tmp10_;
	GFile* dir_child;
	GeeArrayList* _tmp11_;
	gpointer _tmp12_;
	GFile* _tmp13_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp14_;
	gint _file_child_size;
	GeeArrayList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _file_child_index;
	gint _tmp18_;
	gint _tmp19_;
	GFile* file_child;
	GeeArrayList* _tmp20_;
	gpointer _tmp21_;
	DirectoryMonitorFileInfoMap* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	DirectoryMonitorFileInfoMap* _tmp25_;
};

struct _DirectoryMonitorExploreAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	GFileInfo* dir_info;
	gboolean in_discovery;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFileInfo* local_dir_info;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	GFileInfo* _tmp5_;
	GCancellable* _tmp6_;
	GFileInfo* _tmp7_;
	GFileInfo* _tmp8_;
	GError* err;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GFileInfo* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFileInfo* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gboolean _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GFileInfo* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFileInfo* _tmp25_;
	GEnumValue* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GeeHashMap* dir_map;
	GeeHashMap* file_map;
	GFileEnumerator* enumerator;
	GCancellable* _tmp29_;
	GFileEnumerator* _tmp30_;
	gboolean _tmp31_;
	GList* infos;
	GFileEnumerator* _tmp32_;
	GCancellable* _tmp33_;
	GList* _tmp34_;
	GList* _tmp35_;
	GList* _tmp36_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* _tmp37_;
	GFileInfo* info;
	GFileInfo* _tmp38_;
	GFileInfo* _tmp39_;
	const gchar* _tmp40_;
	GFile* _tmp41_;
	GFile* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GFileInfo* _tmp45_;
	GFileInfo* _tmp46_;
	GeeHashMap* _tmp47_;
	GeeHashMap* _tmp48_;
	GeeHashMap* _tmp49_;
	GFileInfo* _tmp50_;
	const gchar* _tmp51_;
	GFile* _tmp52_;
	GFile* _tmp53_;
	GFileInfo* _tmp54_;
	GeeHashMap* _tmp55_;
	GeeHashMap* _tmp56_;
	GeeHashMap* _tmp57_;
	GFileInfo* _tmp58_;
	const gchar* _tmp59_;
	GFile* _tmp60_;
	GFile* _tmp61_;
	GFileInfo* _tmp62_;
	GError* err2;
	gchar* _tmp63_;
	gchar* _tmp64_;
	GError* _tmp65_;
	const gchar* _tmp66_;
	GFileInfo* _tmp67_;
	GFileInfo* _tmp68_;
	GFileInfo* _tmp69_;
	GeeHashMap* _tmp70_;
	GeeHashMap* _tmp71_;
	gboolean _tmp72_;
	GeeHashMap* _tmp73_;
	GeeIterator* _subdir_it;
	GeeHashMap* _tmp74_;
	GeeSet* _tmp75_;
	GeeSet* _tmp76_;
	GeeSet* _tmp77_;
	GeeIterator* _tmp78_;
	GeeIterator* _tmp79_;
	GeeIterator* _tmp80_;
	GFile* subdir;
	GeeIterator* _tmp81_;
	gpointer _tmp82_;
	gint _tmp83_;
	GFile* _tmp84_;
	GeeHashMap* _tmp85_;
	GFile* _tmp86_;
	gpointer _tmp87_;
	GFileInfo* _tmp88_;
	GFile* _tmp89_;
	GeeHashMap* _tmp90_;
	GFile* _tmp91_;
	gpointer _tmp92_;
	GFileInfo* _tmp93_;
	GError* _inner_error0_;
};

struct _DirectoryMonitorNotifyDirectoryFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DirectoryMonitor* self;
	GeeMap* map;
	gboolean in_discovery;
	GeeMapIterator* iter;
	GeeMapIterator* _tmp0_;
	GeeMapIterator* _tmp1_;
	GeeMapIterator* _tmp2_;
	gpointer _tmp3_;
	GFile* _tmp4_;
	GeeMapIterator* _tmp5_;
	gpointer _tmp6_;
	GFileInfo* _tmp7_;
	GeeMapIterator* _tmp8_;
	gpointer _tmp9_;
	GFile* _tmp10_;
	GeeMapIterator* _tmp11_;
	gpointer _tmp12_;
	GFileInfo* _tmp13_;
};

struct _DirectoryMonitorQueryInfoQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorQueryInfoQueueElementPrivate * priv;
	DirectoryMonitor* owner;
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
	guint position;
	gint64 time_created_msec;
	GFileInfo* info;
	GError* err;
	gboolean completed;
};

struct _DirectoryMonitorQueryInfoQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorQueryInfoQueueElement *self);
};

struct _DirectoryMonitorParamSpecQueryInfoQueueElement {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorFileInfoMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorFileInfoMapClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorFileInfoMap *self);
};

struct _DirectoryMonitorFileInfoMapPrivate {
	GeeHashMap* map;
	GeeHashMap* id_map;
};

struct _DirectoryMonitorParamSpecFileInfoMap {
	GParamSpec parent_instance;
};

static gint DirectoryMonitor_private_offset;
static gpointer directory_monitor_parent_class = NULL;
static gpointer directory_monitor_query_info_queue_element_parent_class = NULL;
static guint directory_monitor_query_info_queue_element_current;
static guint directory_monitor_query_info_queue_element_current = (guint) 0;
static gint DirectoryMonitorFileInfoMap_private_offset;
static gpointer directory_monitor_file_info_map_parent_class = NULL;

static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance);
static void directory_monitor_query_info_queue_element_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name,
                                                                   const gchar* nick,
                                                                   const gchar* blurb,
                                                                   GType object_type,
                                                                   GParamFlags flags) G_GNUC_UNUSED ;
static void directory_monitor_value_set_query_info_queue_element (GValue* value,
                                                           gpointer v_object) G_GNUC_UNUSED ;
static void directory_monitor_value_take_query_info_queue_element (GValue* value,
                                                            gpointer v_object) G_GNUC_UNUSED ;
static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) G_GNUC_UNUSED ;
static GType directory_monitor_query_info_queue_element_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gpointer directory_monitor_file_info_map_ref (gpointer instance);
static void directory_monitor_file_info_map_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags) G_GNUC_UNUSED ;
static void directory_monitor_value_set_file_info_map (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED ;
static void directory_monitor_value_take_file_info_map (GValue* value,
                                                 gpointer v_object) G_GNUC_UNUSED ;
static gpointer directory_monitor_value_get_file_info_map (const GValue* value) G_GNUC_UNUSED ;
static GType directory_monitor_file_info_map_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType directory_monitor_ftype_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void);
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type);
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self,
                                                 GFile* root);
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self,
                                                   GFile* old_root,
                                                   GFile* new_root,
                                                   GFileInfo* new_root_info);
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self,
                                                 GFile* file,
                                                 GFileInfo* info);
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self,
                                                 GFile* file,
                                                 GFileInfo* info);
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self,
                                               GFile* old_root,
                                               GFile* new_root,
                                               GFileInfo* new_root_info);
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self,
                                                             GFile* file,
                                                             GFileInfo* info);
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self,
                                                    GFile* file,
                                                    GFileInfo* info);
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                                  GFile* dir,
                                                                  GFileInfo* info);
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self,
                                                         GFile* dir,
                                                         GFileInfo* info);
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self,
                                                     const gchar* reason);
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self,
                                                     GFile* file,
                                                     GFileInfo* info);
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self,
                                                GFile* file,
                                                GFileInfo* info,
                                                GFile** old_file,
                                                GFileInfo** old_file_info);
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self,
                                                   GFile* old_file,
                                                   GFile* new_file,
                                                   GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self,
                                                 GFile* file,
                                                 GFileInfo* info);
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self,
                                               GFile* old_file,
                                               GFile* new_file,
                                               GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self,
                                                 GFile* file);
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self,
                                                                  GFile* file,
                                                                  GFileInfo* info);
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self,
                                                              GFile* file,
                                                              GFileInfo* info);
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self,
                                                            GFile* file);
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self,
                                                     GFile* file);
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self,
                                                 GFile* file);
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self,
                                                          GFile* dir,
                                                          GFileInfo* info);
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self,
                                                         GFile* root,
                                                         DirectoryMonitorFileInfoMap* descendents);
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self,
                                                        GFile* old_dir,
                                                        GFileInfo* old_dir_info,
                                                        GFile* new_dir,
                                                        GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self,
                                                      GFile* dir,
                                                      GFileInfo* info);
static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self,
                                                              GFile* old_dir,
                                                              GFileInfo* old_dir_info,
                                                              GFile* new_dir,
                                                              GFileInfo* new_dir_info,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self,
                                                                     GAsyncResult* _res_);
static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data);
static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self,
                                                   GFile* root,
                                                   GeeCollection* files,
                                                   GeeCollection* dirs);
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self,
                                                     GFile* file);
static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self);
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self,
                                           GFile* dir,
                                           GFileInfo* info);
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self,
                                        GFile* dir,
                                        GFileInfo* info);
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self,
                                                    GFile* old_dir,
                                                    GFile* new_dir,
                                                    GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self,
                                                      GFile* dir);
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                       GFile* dir,
                                                                       GFileInfo* info);
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                   GFile* dir,
                                                                   GFileInfo* info);
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                                 GFile* dir);
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self,
                                                          GFile* dir);
static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self,
                                                       GFile* dir,
                                                       gboolean already_removed,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self,
                                                              GAsyncResult* _res_);
static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data);
static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_);
static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self);
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self,
                                                      GFile* dir);
static void directory_monitor_real_notify_closed (DirectoryMonitor* self);
static void directory_monitor_explore_async (DirectoryMonitor* self,
                                      GFile* dir,
                                      GFileInfo* dir_info,
                                      gboolean in_discovery,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void directory_monitor_explore_finish (DirectoryMonitor* self,
                                       GAsyncResult* _res_);
static void directory_monitor_real_close (DirectoryMonitor* self);
static void directory_monitor_cancel_monitor (DirectoryMonitor* self,
                                       GFileMonitor* monitor);
static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info);
static void directory_monitor_explore_async_data_free (gpointer _data);
static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_);
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self,
                                                   GFile* file,
                                                   GFileInfo* info);
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self,
                                                    gboolean in_discovery);
static void directory_monitor_explore_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
static void directory_monitor_notify_directory_files (DirectoryMonitor* self,
                                               GeeMap* map,
                                               gboolean in_discovery,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self,
                                                      GAsyncResult* _res_);
static void directory_monitor_notify_directory_files_data_free (gpointer _data);
static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_);
static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self);
static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self,
                                               GFile* file,
                                               GFileInfo* info);
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self,
                                                GFile* file,
                                                GFile* other_file,
                                                GFileMonitorEvent event);
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender,
                                                                        GFile* file,
                                                                        GFile* other_file,
                                                                        GFileMonitorEvent event_type,
                                                                        gpointer self);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner,
                                                                                       GFile* file,
                                                                                       GFile* other_file,
                                                                                       GFileMonitorEvent event);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type,
                                                                                             DirectoryMonitor* owner,
                                                                                             GFile* file,
                                                                                             GFile* other_file,
                                                                                             GFileMonitorEvent event);
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self,
                                                              GObject* source,
                                                              GAsyncResult* aresult);
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object,
                                                                                     GAsyncResult* res,
                                                                                     gpointer self);
static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self);
static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self);
static void directory_monitor_process_query_queue (DirectoryMonitor* self,
                                            DirectoryMonitorQueryInfoQueueElement* query_info);
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self,
                                                   GFileInfo* match);
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self,
                                                      GFile* file,
                                                      GFile* other_file,
                                                      GFileInfo* info,
                                                      GFileMonitorEvent event);
static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self);
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self,
                                                       GFile* file,
                                                       GCancellable* cancellable);
static void directory_monitor_real_root_moved (DirectoryMonitor* self,
                                        GFile* old_root,
                                        GFile* new_root,
                                        GFileInfo* new_root_info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static void directory_monitor_real_root_deleted (DirectoryMonitor* self,
                                          GFile* root);
static void directory_monitor_real_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_file_discovered (DirectoryMonitor* self,
                                             GFile* file,
                                             GFileInfo* info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self,
                                                  GFile* file,
                                                  GFileInfo* info);
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self,
                                              const gchar* reason);
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_file_created (DirectoryMonitor* self,
                                          GFile* file,
                                          GFileInfo* info);
static void directory_monitor_real_file_moved (DirectoryMonitor* self,
                                        GFile* old_file,
                                        GFile* new_file,
                                        GFileInfo* new_file_info);
static void directory_monitor_real_file_altered (DirectoryMonitor* self,
                                          GFile* file);
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self,
                                                       GFile* file,
                                                       GFileInfo* info);
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self,
                                                     GFile* file);
static void directory_monitor_real_file_deleted (DirectoryMonitor* self,
                                          GFile* file);
static void directory_monitor_real_directory_created (DirectoryMonitor* self,
                                               GFile* dir,
                                               GFileInfo* info);
static void directory_monitor_real_directory_moved (DirectoryMonitor* self,
                                             GFile* old_dir,
                                             GFile* new_dir,
                                             GFileInfo* new_dir_info);
static void directory_monitor_real_directory_altered (DirectoryMonitor* self,
                                               GFile* dir);
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self,
                                                            GFile* dir,
                                                            GFileInfo* info);
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self,
                                                          GFile* dir);
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self,
                                               GFile* dir);
static void directory_monitor_real_closed (DirectoryMonitor* self);
static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement * obj);
static GType directory_monitor_query_info_queue_element_get_type_once (void);
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self,
                                                         GFile* file,
                                                         GFileInfo* info,
                                                         GFile** normalized,
                                                         gchar** id);
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self,
                                                 GeeCollection* files);
static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap * obj);
static GType directory_monitor_file_info_map_get_type_once (void);
static void directory_monitor_finalize (GObject * obj);
static GType directory_monitor_get_type_once (void);

static inline gpointer
directory_monitor_get_instance_private (DirectoryMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, DirectoryMonitor_private_offset);
}

static GType
directory_monitor_ftype_get_type_once (void)
{
	static const GEnumValue values[] = {{DIRECTORY_MONITOR_FTYPE_FILE, "DIRECTORY_MONITOR_FTYPE_FILE", "file"}, {DIRECTORY_MONITOR_FTYPE_DIRECTORY, "DIRECTORY_MONITOR_FTYPE_DIRECTORY", "directory"}, {DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "DIRECTORY_MONITOR_FTYPE_UNSUPPORTED", "unsupported"}, {0, NULL, NULL}};
	GType directory_monitor_ftype_type_id;
	directory_monitor_ftype_type_id = g_enum_register_static ("DirectoryMonitorFType", values);
	return directory_monitor_ftype_type_id;
}

static GType
directory_monitor_ftype_get_type (void)
{
	static volatile gsize directory_monitor_ftype_type_id__once = 0;
	if (g_once_init_enter (&directory_monitor_ftype_type_id__once)) {
		GType directory_monitor_ftype_type_id;
		directory_monitor_ftype_type_id = directory_monitor_ftype_get_type_once ();
		g_once_init_leave (&directory_monitor_ftype_type_id__once, directory_monitor_ftype_type_id);
	}
	return directory_monitor_ftype_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 471 "../src/DirectoryMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 862 "DirectoryMonitor.c"
}

DirectoryMonitor*
directory_monitor_construct (GType object_type,
                             GFile* root,
                             gboolean recurse,
                             gboolean monitoring)
{
	DirectoryMonitor * self = NULL;
	GFile* _tmp0_;
#line 470 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 470 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitor*) g_object_new (object_type, NULL);
#line 471 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (root);
#line 471 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 471 "../src/DirectoryMonitor.vala"
	self->priv->root = _tmp0_;
#line 472 "../src/DirectoryMonitor.vala"
	self->priv->recurse = recurse;
#line 473 "../src/DirectoryMonitor.vala"
	self->priv->monitoring = monitoring;
#line 470 "../src/DirectoryMonitor.vala"
	return self;
#line 889 "DirectoryMonitor.c"
}

DirectoryMonitor*
directory_monitor_new (GFile* root,
                       gboolean recurse,
                       gboolean monitoring)
{
#line 470 "../src/DirectoryMonitor.vala"
	return directory_monitor_construct (TYPE_DIRECTORY_MONITOR, root, recurse, monitoring);
#line 899 "DirectoryMonitor.c"
}

void
directory_monitor_mdbg (const gchar* msg)
{
#line 476 "../src/DirectoryMonitor.vala"
	g_return_if_fail (msg != NULL);
#line 907 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_recursive (DirectoryMonitor* self)
{
	gboolean result;
#line 482 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 483 "../src/DirectoryMonitor.vala"
	result = self->priv->recurse;
#line 483 "../src/DirectoryMonitor.vala"
	return result;
#line 920 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_monitoring (DirectoryMonitor* self)
{
	gboolean result;
#line 486 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 487 "../src/DirectoryMonitor.vala"
	result = self->priv->monitoring;
#line 487 "../src/DirectoryMonitor.vala"
	return result;
#line 933 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_root_deleted (DirectoryMonitor* self,
                                            GFile* root)
{
	GFile* _tmp0_;
#line 490 "../src/DirectoryMonitor.vala"
	g_return_if_fail (root != NULL);
#line 491 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 491 "../src/DirectoryMonitor.vala"
	_vala_assert (g_file_equal (_tmp0_, root), "this.root.equal (root)");
#line 493 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("root deleted");
#line 494 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL], 0, root);
#line 951 "DirectoryMonitor.c"
}

void
directory_monitor_notify_root_deleted (DirectoryMonitor* self,
                                       GFile* root)
{
	DirectoryMonitorClass* _klass_;
#line 490 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 490 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 490 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_root_deleted) {
#line 490 "../src/DirectoryMonitor.vala"
		_klass_->notify_root_deleted (self, root);
#line 967 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_root_moved (DirectoryMonitor* self,
                                              GFile* old_root,
                                              GFile* new_root,
                                              GFileInfo* new_root_info)
{
	gboolean removed = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp1_;
	GFile* _tmp2_;
#line 497 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 497 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_root != NULL);
#line 497 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root != NULL);
#line 497 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root_info != NULL);
#line 498 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 498 "../src/DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (_tmp0_, old_root, NULL);
#line 499 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 501 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 501 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp1_, new_root, new_root_info);
#line 502 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 504 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (new_root);
#line 504 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 504 "../src/DirectoryMonitor.vala"
	self->priv->root = _tmp2_;
#line 506 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_root_moved (self, old_root, new_root, new_root_info);
#line 1010 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_root_moved (DirectoryMonitor* self,
                                          GFile* old_root,
                                          GFile* new_root,
                                          GFileInfo* new_root_info)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 509 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_root != NULL);
#line 509 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root != NULL);
#line 509 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root_info != NULL);
#line 510 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 510 "../src/DirectoryMonitor.vala"
	_vala_assert (g_file_equal (_tmp0_, old_root), "this.root.equal (old_root)");
#line 512 "../src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (old_root);
#line 512 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 512 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_file_get_path (new_root);
#line 512 "../src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 512 "../src/DirectoryMonitor.vala"
	_tmp5_ = g_strdup_printf ("root moved: %s -> %s", _tmp2_, _tmp4_);
#line 512 "../src/DirectoryMonitor.vala"
	_tmp6_ = _tmp5_;
#line 512 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp6_);
#line 512 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp6_);
#line 512 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 512 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 513 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL], 0, old_root, new_root, new_root_info);
#line 1058 "DirectoryMonitor.c"
}

void
directory_monitor_notify_root_moved (DirectoryMonitor* self,
                                     GFile* old_root,
                                     GFile* new_root,
                                     GFileInfo* new_root_info)
{
	DirectoryMonitorClass* _klass_;
#line 509 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 509 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 509 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_root_moved) {
#line 509 "../src/DirectoryMonitor.vala"
		_klass_->notify_root_moved (self, old_root, new_root, new_root_info);
#line 1076 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_discovery_started (DirectoryMonitor* self)
{
#line 517 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery started");
#line 518 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL], 0);
#line 1087 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_started (DirectoryMonitor* self)
{
	DirectoryMonitorClass* _klass_;
#line 516 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 516 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 516 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_discovery_started) {
#line 516 "../src/DirectoryMonitor.vala"
		_klass_->notify_discovery_started (self);
#line 1102 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self,
                                                        GFile* file,
                                                        GFileInfo* info)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 521 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 521 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 522 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 522 "../src/DirectoryMonitor.vala"
	if (!directory_monitor_file_info_map_update (_tmp0_, file, info)) {
#line 1120 "DirectoryMonitor.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 523 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (file);
#line 523 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 523 "../src/DirectoryMonitor.vala"
		g_debug ("DirectoryMonitor.vala:523: DirectoryMonitor.internal_notify_file_disco" \
"vered: %s discovered but not added to file map", _tmp2_);
#line 523 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp2_);
#line 526 "../src/DirectoryMonitor.vala"
		return;
#line 1133 "DirectoryMonitor.c"
	}
#line 529 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_discovered (self, file, info);
#line 1137 "DirectoryMonitor.c"
}

void
directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self,
                                                   GFile* file,
                                                   GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 521 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 521 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 521 "../src/DirectoryMonitor.vala"
	if (_klass_->internal_notify_file_discovered) {
#line 521 "../src/DirectoryMonitor.vala"
		_klass_->internal_notify_file_discovered (self, file, info);
#line 1154 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_file_discovered (DirectoryMonitor* self,
                                               GFile* file,
                                               GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 532 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 532 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 533 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 533 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 533 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file discovered: %s", _tmp1_);
#line 533 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 533 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 533 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 533 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 534 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL], 0, file, info);
#line 1187 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_discovered (DirectoryMonitor* self,
                                          GFile* file,
                                          GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 532 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 532 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_discovered) {
#line 532 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_discovered (self, file, info);
#line 1204 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                             GFile* dir,
                                                             GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 537 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 537 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 538 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 538 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, dir, info);
#line 539 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 541 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_discovered (self, dir, info);
#line 1227 "DirectoryMonitor.c"
}

void
directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                        GFile* dir,
                                                        GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 537 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 537 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 537 "../src/DirectoryMonitor.vala"
	if (_klass_->internal_notify_directory_discovered) {
#line 537 "../src/DirectoryMonitor.vala"
		_klass_->internal_notify_directory_discovered (self, dir, info);
#line 1244 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self,
                                                    GFile* dir,
                                                    GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 544 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 544 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 545 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 545 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 545 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory discovered: %s", _tmp1_);
#line 545 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 545 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 545 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 545 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 546 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL], 0, dir, info);
#line 1277 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_discovered (DirectoryMonitor* self,
                                               GFile* dir,
                                               GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 544 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 544 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 544 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_discovered) {
#line 544 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_discovered (self, dir, info);
#line 1294 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self,
                                                const gchar* reason)
{
#line 549 "../src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 550 "../src/DirectoryMonitor.vala"
	g_warning ("DirectoryMonitor.vala:550: discovery failed: %s", reason);
#line 551 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL], 0, reason);
#line 1308 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_failed (DirectoryMonitor* self,
                                           const gchar* reason)
{
	DirectoryMonitorClass* _klass_;
#line 549 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 549 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 549 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_discovery_failed) {
#line 549 "../src/DirectoryMonitor.vala"
		_klass_->notify_discovery_failed (self, reason);
#line 1324 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self)
{
#line 555 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL], 0);
#line 1333 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_completed (DirectoryMonitor* self)
{
	DirectoryMonitorClass* _klass_;
#line 554 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 554 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_discovery_completed) {
#line 554 "../src/DirectoryMonitor.vala"
		_klass_->notify_discovery_completed (self);
#line 1348 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_file_created (DirectoryMonitor* self,
                                                GFile* file,
                                                GFileInfo* info)
{
	GFile* old_file = NULL;
	GFileInfo* old_file_info = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
#line 558 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 558 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 558 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 561 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_is_file_create_move (self, file, info, &_tmp0_, &_tmp1_);
#line 561 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 561 "../src/DirectoryMonitor.vala"
	old_file = _tmp0_;
#line 561 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 561 "../src/DirectoryMonitor.vala"
	old_file_info = _tmp1_;
#line 561 "../src/DirectoryMonitor.vala"
	if (_tmp2_) {
#line 1380 "DirectoryMonitor.c"
		GFile* _tmp3_;
#line 562 "../src/DirectoryMonitor.vala"
		_tmp3_ = old_file;
#line 562 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_file_moved (self, _tmp3_, file, info);
#line 1386 "DirectoryMonitor.c"
	} else {
		gboolean updated = FALSE;
		DirectoryMonitorFileInfoMap* _tmp4_;
#line 564 "../src/DirectoryMonitor.vala"
		_tmp4_ = self->priv->files;
#line 564 "../src/DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (_tmp4_, file, info);
#line 565 "../src/DirectoryMonitor.vala"
		_vala_assert (updated, "updated");
#line 567 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_file_created (self, file, info);
#line 1398 "DirectoryMonitor.c"
	}
#line 558 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 558 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 1404 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_created (DirectoryMonitor* self,
                                            GFile* file,
                                            GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 571 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 571 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 572 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 572 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 572 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file created: %s", _tmp1_);
#line 572 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 572 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 572 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 572 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 573 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_CREATED_SIGNAL], 0, file, info);
#line 1436 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_created (DirectoryMonitor* self,
                                       GFile* file,
                                       GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 571 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 571 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_created) {
#line 571 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_created (self, file, info);
#line 1453 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_file_moved (DirectoryMonitor* self,
                                              GFile* old_file,
                                              GFile* new_file,
                                              GFileInfo* new_file_info)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp1_;
#line 576 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 576 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_file != NULL);
#line 576 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file != NULL);
#line 576 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file_info != NULL);
#line 579 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 579 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_tmp0_, old_file, NULL);
#line 581 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 581 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp1_, new_file, new_file_info);
#line 582 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 584 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_moved (self, old_file, new_file, new_file_info);
#line 1486 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_moved (DirectoryMonitor* self,
                                          GFile* old_file,
                                          GFile* new_file,
                                          GFileInfo* new_file_info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 587 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_file != NULL);
#line 587 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file != NULL);
#line 587 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file_info != NULL);
#line 588 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (old_file);
#line 588 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 588 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_file_get_path (new_file);
#line 588 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 588 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_strdup_printf ("file moved: %s -> %s", _tmp1_, _tmp3_);
#line 588 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 588 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp5_);
#line 588 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 588 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 588 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 589 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_MOVED_SIGNAL], 0, old_file, new_file, new_file_info);
#line 1529 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_moved (DirectoryMonitor* self,
                                     GFile* old_file,
                                     GFile* new_file,
                                     GFileInfo* new_file_info)
{
	DirectoryMonitorClass* _klass_;
#line 587 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 587 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 587 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_moved) {
#line 587 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_moved (self, old_file, new_file, new_file_info);
#line 1547 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_file_altered (DirectoryMonitor* self,
                                            GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 592 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 593 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 593 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 593 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file altered: %s", _tmp1_);
#line 593 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 593 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 593 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 593 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 594 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL], 0, file);
#line 1577 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_altered (DirectoryMonitor* self,
                                       GFile* file)
{
	DirectoryMonitorClass* _klass_;
#line 592 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 592 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 592 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_altered) {
#line 592 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_altered (self, file);
#line 1593 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self,
                                                             GFile* file,
                                                             GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 597 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 597 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 597 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 598 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 598 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, file, info);
#line 599 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 601 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_alteration_completed (self, file, info);
#line 1618 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self,
                                                         GFile* file,
                                                         GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 604 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 604 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 605 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 605 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 605 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file alteration completed: %s", _tmp1_);
#line 605 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 605 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 605 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 605 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 606 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL], 0, file, info);
#line 1650 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self,
                                                    GFile* file,
                                                    GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 604 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 604 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 604 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_alteration_completed) {
#line 604 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_alteration_completed (self, file, info);
#line 1667 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self,
                                                       GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 609 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 610 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 610 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 610 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file attributes altered: %s", _tmp1_);
#line 610 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 610 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 610 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 610 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 611 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL], 0, file);
#line 1697 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self,
                                                  GFile* file)
{
	DirectoryMonitorClass* _klass_;
#line 609 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 609 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 609 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_attributes_altered) {
#line 609 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_attributes_altered (self, file);
#line 1713 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self,
                                                GFile* file)
{
	gboolean removed = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 614 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 614 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 615 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 615 "../src/DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (_tmp0_, file, NULL);
#line 616 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 618 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_deleted (self, file);
#line 1735 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_deleted (DirectoryMonitor* self,
                                            GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 621 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 622 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 622 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 622 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file deleted: %s", _tmp1_);
#line 622 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 622 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 622 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 622 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 623 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_DELETED_SIGNAL], 0, file);
#line 1764 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_deleted (DirectoryMonitor* self,
                                       GFile* file)
{
	DirectoryMonitorClass* _klass_;
#line 621 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 621 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 621 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_deleted) {
#line 621 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_deleted (self, file);
#line 1780 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_directory_created (DirectoryMonitor* self,
                                                     GFile* dir,
                                                     GFileInfo* info)
{
	GFile* old_dir = NULL;
	GFileInfo* old_dir_info = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
#line 626 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 626 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 626 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 629 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_is_file_create_move (self, dir, info, &_tmp0_, &_tmp1_);
#line 629 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 629 "../src/DirectoryMonitor.vala"
	old_dir = _tmp0_;
#line 629 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 629 "../src/DirectoryMonitor.vala"
	old_dir_info = _tmp1_;
#line 629 "../src/DirectoryMonitor.vala"
	if (_tmp2_) {
#line 1812 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* _tmp3_;
		GFile* _tmp4_;
		DirectoryMonitorFileInfoMap* _tmp5_;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
#line 635 "../src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->files;
#line 635 "../src/DirectoryMonitor.vala"
		_tmp4_ = old_dir;
#line 635 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->parent_moved;
#line 635 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_descendents (_tmp3_, _tmp4_, _tmp5_);
#line 637 "../src/DirectoryMonitor.vala"
		_tmp6_ = old_dir;
#line 637 "../src/DirectoryMonitor.vala"
		_tmp7_ = old_dir_info;
#line 637 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_moved (self, _tmp6_, _tmp7_, dir, info);
#line 1832 "DirectoryMonitor.c"
	} else {
		gboolean updated = FALSE;
		DirectoryMonitorFileInfoMap* _tmp8_;
#line 639 "../src/DirectoryMonitor.vala"
		_tmp8_ = self->priv->files;
#line 639 "../src/DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (_tmp8_, dir, info);
#line 640 "../src/DirectoryMonitor.vala"
		_vala_assert (updated, "updated");
#line 642 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_created (self, dir, info);
#line 1844 "DirectoryMonitor.c"
	}
#line 626 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 626 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 1850 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_created (DirectoryMonitor* self,
                                                 GFile* dir,
                                                 GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 646 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 646 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 647 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 647 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 647 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory created: %s", _tmp1_);
#line 647 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 647 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 647 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 647 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 648 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL], 0, dir, info);
#line 1882 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_created (DirectoryMonitor* self,
                                            GFile* dir,
                                            GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 646 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 646 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_created) {
#line 646 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_created (self, dir, info);
#line 1899 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self,
                                                   GFile* old_dir,
                                                   GFileInfo* old_dir_info,
                                                   GFile* new_dir,
                                                   GFileInfo* new_dir_info)
{
#line 651 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 651 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir != NULL);
#line 651 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir_info != NULL);
#line 651 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir != NULL);
#line 651 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir_info != NULL);
#line 653 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved (self, old_dir, old_dir_info, new_dir, new_dir_info, NULL, NULL);
#line 1922 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = _data;
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 73 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData, _data_);
#line 1942 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self,
                                                         GFile* old_dir,
                                                         GFileInfo* old_dir_info,
                                                         GFile* new_dir,
                                                         GFileInfo* new_dir_info,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	GFile* _tmp3_;
	GFileInfo* _tmp4_;
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir_info != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir_info != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 73 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_async_internal_notify_directory_moved_data_free);
#line 73 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (old_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->old_dir = _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (old_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->old_dir_info = _tmp2_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp3_ = _g_object_ref0 (new_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->new_dir = _tmp3_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp4_ = _g_object_ref0 (new_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->new_dir_info = _tmp4_;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2006 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self,
                                                                GAsyncResult* _res_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2016 "DirectoryMonitor.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 658 "../src/DirectoryMonitor.vala"
	return result;
#line 2028 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 673 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 673 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 673 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 673 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2045 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_async_internal_notify_directory_moved_co (self);
#line 689 "../src/DirectoryMonitor.vala"
	return result;
#line 2055 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_)
{
#line 656 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 656 "../src/DirectoryMonitor.vala"
		case 0:
#line 2065 "DirectoryMonitor.c"
		goto _state_0;
#line 656 "../src/DirectoryMonitor.vala"
		case 1:
#line 2069 "DirectoryMonitor.c"
		goto _state_1;
#line 656 "../src/DirectoryMonitor.vala"
		case 2:
#line 2073 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 656 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2078 "DirectoryMonitor.c"
	}
	_state_0:
#line 658 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 658 "../src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp0_;
#line 659 "../src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 659 "../src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp1_;
#line 660 "../src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->self->priv->files;
#line 660 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _data_->file_children;
#line 660 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->dir_children;
#line 660 "../src/DirectoryMonitor.vala"
	_data_->count = directory_monitor_file_info_map_get_children (_data_->_tmp2_, _data_->old_dir, (GeeCollection*) _data_->_tmp3_, (GeeCollection*) _data_->_tmp4_);
#line 661 "../src/DirectoryMonitor.vala"
	if (_data_->count > 0) {
#line 2099 "DirectoryMonitor.c"
		{
#line 665 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->dir_children;
#line 665 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp5_;
#line 665 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _data_->_dir_child_list;
#line 665 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp6_);
#line 665 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 665 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp8_;
#line 665 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 665 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 665 "../src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_dir_child_index + 1;
#line 665 "../src/DirectoryMonitor.vala"
				_data_->_tmp9_ = _data_->_dir_child_index;
#line 665 "../src/DirectoryMonitor.vala"
				_data_->_tmp10_ = _data_->_dir_child_size;
#line 665 "../src/DirectoryMonitor.vala"
				if (!(_data_->_tmp9_ < _data_->_tmp10_)) {
#line 665 "../src/DirectoryMonitor.vala"
					break;
#line 2127 "DirectoryMonitor.c"
				}
#line 665 "../src/DirectoryMonitor.vala"
				_data_->_tmp11_ = _data_->_dir_child_list;
#line 665 "../src/DirectoryMonitor.vala"
				_data_->_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp11_, _data_->_dir_child_index);
#line 665 "../src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp12_;
#line 666 "../src/DirectoryMonitor.vala"
				_data_->_tmp13_ = _data_->self->priv->files;
#line 666 "../src/DirectoryMonitor.vala"
				_data_->_tmp14_ = _data_->dir_child;
#line 666 "../src/DirectoryMonitor.vala"
				_data_->_tmp15_ = directory_monitor_file_info_map_get_info (_data_->_tmp13_, _data_->_tmp14_);
#line 666 "../src/DirectoryMonitor.vala"
				_data_->dir_info = _data_->_tmp15_;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp16_ = _data_->dir_info;
#line 667 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp16_ == NULL) {
#line 668 "../src/DirectoryMonitor.vala"
					_data_->_tmp17_ = _data_->dir_child;
#line 668 "../src/DirectoryMonitor.vala"
					_data_->_tmp18_ = g_file_get_path (_data_->_tmp17_);
#line 668 "../src/DirectoryMonitor.vala"
					_data_->_tmp19_ = _data_->_tmp18_;
#line 668 "../src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:668: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp19_);
#line 668 "../src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp19_);
#line 670 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_info);
#line 670 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_child);
#line 670 "../src/DirectoryMonitor.vala"
					continue;
#line 2163 "DirectoryMonitor.c"
				}
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp20_ = _data_->dir_child;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp21_ = _data_->dir_info;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp22_ = _data_->dir_child;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp23_ = g_file_get_basename (_data_->_tmp22_);
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp24_ = _data_->_tmp23_;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp25_ = g_file_get_child (_data_->new_dir, _data_->_tmp24_);
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp26_ = _data_->_tmp25_;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp27_ = _data_->dir_info;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 673 "../src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved (_data_->self, _data_->_tmp20_, _data_->_tmp21_, _data_->_tmp26_, _data_->_tmp27_, directory_monitor_async_internal_notify_directory_moved_ready, _data_);
#line 673 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2187 "DirectoryMonitor.c"
				_state_1:
#line 673 "../src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved_finish (_data_->self, _data_->_res_);
#line 673 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp26_);
#line 673 "../src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp24_);
#line 665 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_info);
#line 665 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2199 "DirectoryMonitor.c"
			}
		}
		{
#line 678 "../src/DirectoryMonitor.vala"
			_data_->_tmp28_ = _data_->file_children;
#line 678 "../src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp28_;
#line 678 "../src/DirectoryMonitor.vala"
			_data_->_tmp29_ = _data_->_file_child_list;
#line 678 "../src/DirectoryMonitor.vala"
			_data_->_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp29_);
#line 678 "../src/DirectoryMonitor.vala"
			_data_->_tmp31_ = _data_->_tmp30_;
#line 678 "../src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp31_;
#line 678 "../src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 678 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 678 "../src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_file_child_index + 1;
#line 678 "../src/DirectoryMonitor.vala"
				_data_->_tmp32_ = _data_->_file_child_index;
#line 678 "../src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->_file_child_size;
#line 678 "../src/DirectoryMonitor.vala"
				if (!(_data_->_tmp32_ < _data_->_tmp33_)) {
#line 678 "../src/DirectoryMonitor.vala"
					break;
#line 2229 "DirectoryMonitor.c"
				}
#line 678 "../src/DirectoryMonitor.vala"
				_data_->_tmp34_ = _data_->_file_child_list;
#line 678 "../src/DirectoryMonitor.vala"
				_data_->_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp34_, _data_->_file_child_index);
#line 678 "../src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp35_;
#line 679 "../src/DirectoryMonitor.vala"
				_data_->_tmp36_ = _data_->self->priv->files;
#line 679 "../src/DirectoryMonitor.vala"
				_data_->_tmp37_ = _data_->file_child;
#line 679 "../src/DirectoryMonitor.vala"
				_data_->_tmp38_ = directory_monitor_file_info_map_get_info (_data_->_tmp36_, _data_->_tmp37_);
#line 679 "../src/DirectoryMonitor.vala"
				_data_->file_info = _data_->_tmp38_;
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp39_ = _data_->file_info;
#line 680 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp39_ == NULL) {
#line 681 "../src/DirectoryMonitor.vala"
					_data_->_tmp40_ = _data_->file_child;
#line 681 "../src/DirectoryMonitor.vala"
					_data_->_tmp41_ = g_file_get_path (_data_->_tmp40_);
#line 681 "../src/DirectoryMonitor.vala"
					_data_->_tmp42_ = _data_->_tmp41_;
#line 681 "../src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:681: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp42_);
#line 681 "../src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp42_);
#line 683 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_info);
#line 683 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_child);
#line 683 "../src/DirectoryMonitor.vala"
					continue;
#line 2265 "DirectoryMonitor.c"
				}
#line 686 "../src/DirectoryMonitor.vala"
				_data_->_tmp43_ = _data_->file_child;
#line 686 "../src/DirectoryMonitor.vala"
				_data_->_tmp44_ = _data_->file_child;
#line 686 "../src/DirectoryMonitor.vala"
				_data_->_tmp45_ = g_file_get_basename (_data_->_tmp44_);
#line 686 "../src/DirectoryMonitor.vala"
				_data_->_tmp46_ = _data_->_tmp45_;
#line 686 "../src/DirectoryMonitor.vala"
				_data_->_tmp47_ = g_file_get_child (_data_->new_dir, _data_->_tmp46_);
#line 686 "../src/DirectoryMonitor.vala"
				_data_->_tmp48_ = _data_->_tmp47_;
#line 686 "../src/DirectoryMonitor.vala"
				_data_->_tmp49_ = _data_->file_info;
#line 686 "../src/DirectoryMonitor.vala"
				directory_monitor_internal_notify_file_moved (_data_->self, _data_->_tmp43_, _data_->_tmp48_, _data_->_tmp49_);
#line 686 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp48_);
#line 686 "../src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp46_);
#line 689 "../src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_internal_notify_directory_moved_co_gsource_func, _data_, NULL);
#line 690 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 690 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2293 "DirectoryMonitor.c"
				_state_2:
				;
#line 678 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_info);
#line 678 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2300 "DirectoryMonitor.c"
			}
		}
	}
#line 696 "../src/DirectoryMonitor.vala"
	_data_->_tmp50_ = _data_->self->priv->files;
#line 696 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_data_->_tmp50_, _data_->old_dir, NULL);
#line 698 "../src/DirectoryMonitor.vala"
	_data_->_tmp51_ = _data_->self->priv->files;
#line 698 "../src/DirectoryMonitor.vala"
	_data_->updated = directory_monitor_file_info_map_update (_data_->_tmp51_, _data_->new_dir, _data_->new_dir_info);
#line 699 "../src/DirectoryMonitor.vala"
	_vala_assert (_data_->updated, "updated");
#line 702 "../src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (_data_->self, _data_->old_dir, _data_->old_dir_info);
#line 703 "../src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->new_dir, _data_->new_dir_info);
#line 705 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_moved (_data_->self, _data_->old_dir, _data_->new_dir, _data_->new_dir_info);
#line 656 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 656 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 656 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 656 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 656 "../src/DirectoryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 656 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2332 "DirectoryMonitor.c"
		}
	}
#line 656 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 656 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 2339 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_moved (DirectoryMonitor* self,
                                               GFile* old_dir,
                                               GFile* new_dir,
                                               GFileInfo* new_dir_info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
#line 708 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir != NULL);
#line 708 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir != NULL);
#line 708 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir_info != NULL);
#line 709 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (old_dir);
#line 709 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 709 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_file_get_path (new_dir);
#line 709 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 709 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_strdup_printf ("directory moved: %s -> %s", _tmp1_, _tmp3_);
#line 709 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 709 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp5_);
#line 709 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 709 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 709 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 710 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL], 0, old_dir, new_dir, new_dir_info);
#line 712 "../src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->root;
#line 712 "../src/DirectoryMonitor.vala"
	if (g_file_equal (old_dir, _tmp6_)) {
#line 713 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_root_moved (self, old_dir, new_dir, new_dir_info);
#line 2389 "DirectoryMonitor.c"
	}
}

void
directory_monitor_notify_directory_moved (DirectoryMonitor* self,
                                          GFile* old_dir,
                                          GFile* new_dir,
                                          GFileInfo* new_dir_info)
{
	DirectoryMonitorClass* _klass_;
#line 708 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 708 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 708 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_moved) {
#line 708 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_moved (self, old_dir, new_dir, new_dir_info);
#line 2408 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_directory_altered (DirectoryMonitor* self,
                                                 GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 716 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 717 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 717 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 717 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory altered: %s", _tmp1_);
#line 717 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 717 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 717 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 717 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 718 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL], 0, dir);
#line 2438 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_altered (DirectoryMonitor* self,
                                            GFile* dir)
{
	DirectoryMonitorClass* _klass_;
#line 716 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 716 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 716 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_altered) {
#line 716 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_altered (self, dir);
#line 2454 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                  GFile* dir,
                                                                  GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 721 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 721 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 721 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 722 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 722 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, dir, info);
#line 723 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 725 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_alteration_completed (self, dir, info);
#line 2479 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                              GFile* dir,
                                                              GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 728 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 728 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 729 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 729 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 729 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory alteration completed: %s", _tmp1_);
#line 729 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 729 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 729 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 729 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 730 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL], 0, dir, info);
#line 2511 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                         GFile* dir,
                                                         GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 728 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 728 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 728 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_alteration_completed) {
#line 728 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_alteration_completed (self, dir, info);
#line 2528 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                            GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 733 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 734 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 734 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 734 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory attributes altered: %s", _tmp1_);
#line 734 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 734 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 734 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 734 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 735 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL], 0, dir);
#line 2558 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                       GFile* dir)
{
	DirectoryMonitorClass* _klass_;
#line 733 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 733 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 733 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_attributes_altered) {
#line 733 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_attributes_altered (self, dir);
#line 2574 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self,
                                                     GFile* dir)
{
	GFileInfo* info = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFileInfo* _tmp1_;
#line 738 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 738 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 739 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 739 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_info (_tmp0_, dir);
#line 739 "../src/DirectoryMonitor.vala"
	info = _tmp1_;
#line 740 "../src/DirectoryMonitor.vala"
	_vala_assert (info != NULL, "info != null");
#line 743 "../src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (self, dir, info);
#line 745 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted (self, dir, FALSE, NULL, NULL);
#line 738 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 2603 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_data_free (gpointer _data)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = _data;
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 73 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncNotifyDirectoryDeletedData, _data_);
#line 2617 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self,
                                                  GFile* dir,
                                                  gboolean already_removed,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncNotifyDirectoryDeletedData);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 73 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_async_notify_directory_deleted_data_free);
#line 73 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->dir = _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->already_removed = already_removed;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2654 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self,
                                                         GAsyncResult* _res_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2664 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 768 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 768 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 768 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 768 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2681 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_async_notify_directory_deleted_co (self);
#line 777 "../src/DirectoryMonitor.vala"
	return result;
#line 2691 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_)
{
#line 748 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 748 "../src/DirectoryMonitor.vala"
		case 0:
#line 2701 "DirectoryMonitor.c"
		goto _state_0;
#line 748 "../src/DirectoryMonitor.vala"
		case 1:
#line 2705 "DirectoryMonitor.c"
		goto _state_1;
#line 748 "../src/DirectoryMonitor.vala"
		case 2:
#line 2709 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 748 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2714 "DirectoryMonitor.c"
	}
	_state_0:
#line 756 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 756 "../src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp0_;
#line 757 "../src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 757 "../src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp1_;
#line 758 "../src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->self->priv->files;
#line 758 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _data_->file_children;
#line 758 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->dir_children;
#line 758 "../src/DirectoryMonitor.vala"
	_data_->count = directory_monitor_file_info_map_get_children (_data_->_tmp2_, _data_->dir, (GeeCollection*) _data_->_tmp3_, (GeeCollection*) _data_->_tmp4_);
#line 759 "../src/DirectoryMonitor.vala"
	if (_data_->count > 0) {
#line 2735 "DirectoryMonitor.c"
		{
#line 767 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->dir_children;
#line 767 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp5_;
#line 767 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _data_->_dir_child_list;
#line 767 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp6_);
#line 767 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 767 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp8_;
#line 767 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 767 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 767 "../src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_dir_child_index + 1;
#line 767 "../src/DirectoryMonitor.vala"
				_data_->_tmp9_ = _data_->_dir_child_index;
#line 767 "../src/DirectoryMonitor.vala"
				_data_->_tmp10_ = _data_->_dir_child_size;
#line 767 "../src/DirectoryMonitor.vala"
				if (!(_data_->_tmp9_ < _data_->_tmp10_)) {
#line 767 "../src/DirectoryMonitor.vala"
					break;
#line 2763 "DirectoryMonitor.c"
				}
#line 767 "../src/DirectoryMonitor.vala"
				_data_->_tmp11_ = _data_->_dir_child_list;
#line 767 "../src/DirectoryMonitor.vala"
				_data_->_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp11_, _data_->_dir_child_index);
#line 767 "../src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp12_;
#line 768 "../src/DirectoryMonitor.vala"
				_data_->_tmp13_ = _data_->dir_child;
#line 768 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 768 "../src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted (_data_->self, _data_->_tmp13_, FALSE, directory_monitor_async_notify_directory_deleted_ready, _data_);
#line 768 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2779 "DirectoryMonitor.c"
				_state_1:
#line 768 "../src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted_finish (_data_->self, _data_->_res_);
#line 767 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2785 "DirectoryMonitor.c"
			}
		}
		{
#line 772 "../src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _data_->file_children;
#line 772 "../src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp14_;
#line 772 "../src/DirectoryMonitor.vala"
			_data_->_tmp15_ = _data_->_file_child_list;
#line 772 "../src/DirectoryMonitor.vala"
			_data_->_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp15_);
#line 772 "../src/DirectoryMonitor.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 772 "../src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp17_;
#line 772 "../src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 772 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 772 "../src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_file_child_index + 1;
#line 772 "../src/DirectoryMonitor.vala"
				_data_->_tmp18_ = _data_->_file_child_index;
#line 772 "../src/DirectoryMonitor.vala"
				_data_->_tmp19_ = _data_->_file_child_size;
#line 772 "../src/DirectoryMonitor.vala"
				if (!(_data_->_tmp18_ < _data_->_tmp19_)) {
#line 772 "../src/DirectoryMonitor.vala"
					break;
#line 2815 "DirectoryMonitor.c"
				}
#line 772 "../src/DirectoryMonitor.vala"
				_data_->_tmp20_ = _data_->_file_child_list;
#line 772 "../src/DirectoryMonitor.vala"
				_data_->_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp20_, _data_->_file_child_index);
#line 772 "../src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp21_;
#line 773 "../src/DirectoryMonitor.vala"
				_data_->_tmp22_ = _data_->self->priv->files;
#line 773 "../src/DirectoryMonitor.vala"
				_data_->_tmp23_ = _data_->file_child;
#line 773 "../src/DirectoryMonitor.vala"
				directory_monitor_file_info_map_remove (_data_->_tmp22_, _data_->_tmp23_, NULL);
#line 775 "../src/DirectoryMonitor.vala"
				_data_->_tmp24_ = _data_->file_child;
#line 775 "../src/DirectoryMonitor.vala"
				directory_monitor_notify_file_deleted (_data_->self, _data_->_tmp24_);
#line 777 "../src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_notify_directory_deleted_co_gsource_func, _data_, NULL);
#line 778 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 778 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2839 "DirectoryMonitor.c"
				_state_2:
				;
#line 772 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2844 "DirectoryMonitor.c"
			}
		}
	}
#line 782 "../src/DirectoryMonitor.vala"
	if (!_data_->already_removed) {
#line 783 "../src/DirectoryMonitor.vala"
		_data_->_tmp25_ = _data_->self->priv->files;
#line 783 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_data_->_tmp25_, _data_->dir, NULL);
#line 2854 "DirectoryMonitor.c"
	}
#line 785 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_deleted (_data_->self, _data_->dir);
#line 748 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 748 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 748 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 748 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 748 "../src/DirectoryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 748 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2870 "DirectoryMonitor.c"
		}
	}
#line 748 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 748 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 2877 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self,
                                                 GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
#line 788 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 789 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 789 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 789 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory deleted: %s", _tmp1_);
#line 789 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 789 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 789 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 789 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 790 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL], 0, dir);
#line 792 "../src/DirectoryMonitor.vala"
	_tmp4_ = self->priv->root;
#line 792 "../src/DirectoryMonitor.vala"
	if (g_file_equal (dir, _tmp4_)) {
#line 793 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_root_deleted (self, dir);
#line 2913 "DirectoryMonitor.c"
	}
}

void
directory_monitor_notify_directory_deleted (DirectoryMonitor* self,
                                            GFile* dir)
{
	DirectoryMonitorClass* _klass_;
#line 788 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 788 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 788 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_deleted) {
#line 788 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_deleted (self, dir);
#line 2930 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_closed (DirectoryMonitor* self)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 797 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 797 "../src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 797 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 797 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("monitoring of %s closed", _tmp2_);
#line 797 "../src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 797 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 797 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 797 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 798 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_CLOSED_SIGNAL], 0);
#line 2960 "DirectoryMonitor.c"
}

void
directory_monitor_notify_closed (DirectoryMonitor* self)
{
	DirectoryMonitorClass* _klass_;
#line 796 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 796 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 796 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_closed) {
#line 796 "../src/DirectoryMonitor.vala"
		_klass_->notify_closed (self);
#line 2975 "DirectoryMonitor.c"
	}
}

GFile*
directory_monitor_get_root (DirectoryMonitor* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
#line 801 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 802 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 802 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 802 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 802 "../src/DirectoryMonitor.vala"
	return result;
#line 2995 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_in_root (DirectoryMonitor* self,
                              GFile* file)
{
	GFile* _tmp0_;
	gboolean result;
#line 805 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 805 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 806 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 806 "../src/DirectoryMonitor.vala"
	result = g_file_has_prefix (file, _tmp0_);
#line 806 "../src/DirectoryMonitor.vala"
	return result;
#line 3014 "DirectoryMonitor.c"
}

gboolean
directory_monitor_has_started (DirectoryMonitor* self)
{
	gboolean result;
#line 809 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 810 "../src/DirectoryMonitor.vala"
	result = self->priv->started;
#line 810 "../src/DirectoryMonitor.vala"
	return result;
#line 3027 "DirectoryMonitor.c"
}

void
directory_monitor_start_discovery (DirectoryMonitor* self)
{
	GFile* _tmp0_;
#line 813 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 814 "../src/DirectoryMonitor.vala"
	_vala_assert (!self->priv->started, "!started");
#line 816 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = TRUE;
#line 817 "../src/DirectoryMonitor.vala"
	self->priv->started = TRUE;
#line 819 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_discovery_started (self);
#line 822 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 1;
#line 823 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 823 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async (self, _tmp0_, NULL, TRUE, NULL, NULL);
#line 3050 "DirectoryMonitor.c"
}

static void
directory_monitor_real_close (DirectoryMonitor* self)
{
	GCancellable* _tmp0_;
	GeeHashMap* _tmp11_;
#line 830 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 830 "../src/DirectoryMonitor.vala"
	g_cancellable_cancel (_tmp0_);
#line 3062 "DirectoryMonitor.c"
	{
		GeeIterator* _monitor_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 833 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 833 "../src/DirectoryMonitor.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 833 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 833 "../src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 833 "../src/DirectoryMonitor.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 833 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 833 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp4_);
#line 833 "../src/DirectoryMonitor.vala"
		_monitor_it = _tmp6_;
#line 833 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 3089 "DirectoryMonitor.c"
			GeeIterator* _tmp7_;
			GFileMonitor* monitor = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GFileMonitor* _tmp10_;
#line 833 "../src/DirectoryMonitor.vala"
			_tmp7_ = _monitor_it;
#line 833 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 833 "../src/DirectoryMonitor.vala"
				break;
#line 3101 "DirectoryMonitor.c"
			}
#line 833 "../src/DirectoryMonitor.vala"
			_tmp8_ = _monitor_it;
#line 833 "../src/DirectoryMonitor.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 833 "../src/DirectoryMonitor.vala"
			monitor = (GFileMonitor*) _tmp9_;
#line 834 "../src/DirectoryMonitor.vala"
			_tmp10_ = monitor;
#line 834 "../src/DirectoryMonitor.vala"
			directory_monitor_cancel_monitor (self, _tmp10_);
#line 833 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (monitor);
#line 3115 "DirectoryMonitor.c"
		}
#line 833 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_monitor_it);
#line 3119 "DirectoryMonitor.c"
	}
#line 836 "../src/DirectoryMonitor.vala"
	_tmp11_ = self->priv->monitors;
#line 836 "../src/DirectoryMonitor.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp11_);
#line 838 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_closed (self);
#line 3127 "DirectoryMonitor.c"
}

void
directory_monitor_close (DirectoryMonitor* self)
{
	DirectoryMonitorClass* _klass_;
#line 828 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 828 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 828 "../src/DirectoryMonitor.vala"
	if (_klass_->close) {
#line 828 "../src/DirectoryMonitor.vala"
		_klass_->close (self);
#line 3142 "DirectoryMonitor.c"
	}
}

static DirectoryMonitorFType
directory_monitor_get_ftype (GFileInfo* info)
{
	GFileType file_type = 0;
	DirectoryMonitorFType result;
#line 841 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, 0);
#line 842 "../src/DirectoryMonitor.vala"
	file_type = g_file_info_get_file_type (info);
#line 843 "../src/DirectoryMonitor.vala"
	switch (file_type) {
#line 843 "../src/DirectoryMonitor.vala"
		case G_FILE_TYPE_REGULAR:
#line 3159 "DirectoryMonitor.c"
		{
#line 845 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_FILE;
#line 845 "../src/DirectoryMonitor.vala"
			return result;
#line 3165 "DirectoryMonitor.c"
		}
#line 843 "../src/DirectoryMonitor.vala"
		case G_FILE_TYPE_DIRECTORY:
#line 3169 "DirectoryMonitor.c"
		{
#line 848 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_DIRECTORY;
#line 848 "../src/DirectoryMonitor.vala"
			return result;
#line 3175 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp0_;
			gchar* _tmp1_;
			gchar* _tmp2_;
#line 851 "../src/DirectoryMonitor.vala"
			_tmp0_ = g_enum_get_value (g_type_class_ref (g_file_type_get_type ()), file_type);
#line 851 "../src/DirectoryMonitor.vala"
			_tmp1_ = g_strdup_printf ("query_ftype: Unknown file type %s", (_tmp0_ != NULL) ? _tmp0_->value_name : NULL);
#line 851 "../src/DirectoryMonitor.vala"
			_tmp2_ = _tmp1_;
#line 851 "../src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp2_);
#line 851 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp2_);
#line 852 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_UNSUPPORTED;
#line 852 "../src/DirectoryMonitor.vala"
			return result;
#line 3196 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_explore_async_data_free (gpointer _data)
{
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = _data;
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 73 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorExploreAsyncData, _data_);
#line 3214 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_async (DirectoryMonitor* self,
                                 GFile* dir,
                                 GFileInfo* dir_info,
                                 gboolean in_discovery,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	DirectoryMonitorExploreAsyncData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorExploreAsyncData);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 73 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_explore_async_data_free);
#line 73 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->dir = _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->dir_info = _tmp2_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->in_discovery = in_discovery;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3259 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_finish (DirectoryMonitor* self,
                                  GAsyncResult* _res_)
{
	DirectoryMonitorExploreAsyncData* _data_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3269 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_async_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	DirectoryMonitorExploreAsyncData* _data_;
#line 869 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 869 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 869 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 869 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3286 "DirectoryMonitor.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 923 "../src/DirectoryMonitor.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3294 "DirectoryMonitor.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 923 "../src/DirectoryMonitor.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 3302 "DirectoryMonitor.c"
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 941 "../src/DirectoryMonitor.vala"
	return result;
#line 3313 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_)
{
#line 856 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 856 "../src/DirectoryMonitor.vala"
		case 0:
#line 3323 "DirectoryMonitor.c"
		goto _state_0;
#line 856 "../src/DirectoryMonitor.vala"
		case 1:
#line 3327 "DirectoryMonitor.c"
		goto _state_1;
#line 856 "../src/DirectoryMonitor.vala"
		case 2:
#line 3331 "DirectoryMonitor.c"
		goto _state_2;
#line 856 "../src/DirectoryMonitor.vala"
		case 3:
#line 3335 "DirectoryMonitor.c"
		goto _state_3;
#line 856 "../src/DirectoryMonitor.vala"
		case 4:
#line 3339 "DirectoryMonitor.c"
		goto _state_4;
#line 856 "../src/DirectoryMonitor.vala"
		case 5:
#line 3343 "DirectoryMonitor.c"
		goto _state_5;
		default:
#line 856 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 3348 "DirectoryMonitor.c"
	}
	_state_0:
#line 857 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = _data_->self->priv->files;
#line 857 "../src/DirectoryMonitor.vala"
	if (directory_monitor_file_info_map_contains (_data_->_tmp0_, _data_->dir, _data_->dir_info)) {
#line 858 "../src/DirectoryMonitor.vala"
		_data_->_tmp1_ = g_file_get_path (_data_->dir);
#line 858 "../src/DirectoryMonitor.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 858 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:858: Directory loop detected at %s, not explorin" \
"g", _data_->_tmp2_);
#line 858 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp2_);
#line 860 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 862 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 862 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 862 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 862 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3373 "DirectoryMonitor.c"
			}
		}
#line 862 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 862 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3380 "DirectoryMonitor.c"
	}
#line 866 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->dir_info);
#line 866 "../src/DirectoryMonitor.vala"
	_data_->local_dir_info = _data_->_tmp3_;
#line 867 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->local_dir_info;
#line 867 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp4_ == NULL) {
#line 3390 "DirectoryMonitor.c"
		{
#line 869 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _data_->self->priv->cancellable;
#line 869 "../src/DirectoryMonitor.vala"
			_data_->_state_ = 1;
#line 869 "../src/DirectoryMonitor.vala"
			g_file_query_info_async (_data_->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_DIR_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp6_, directory_monitor_explore_async_ready, _data_);
#line 869 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3400 "DirectoryMonitor.c"
			_state_1:
#line 869 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = g_file_query_info_finish (_data_->dir, _data_->_res_, &_data_->_inner_error0_);
#line 869 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->_tmp7_;
#line 869 "../src/DirectoryMonitor.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3408 "DirectoryMonitor.c"
				goto __catch0_g_error;
			}
#line 869 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->_tmp5_;
#line 869 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = NULL;
#line 869 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 869 "../src/DirectoryMonitor.vala"
			_data_->local_dir_info = _data_->_tmp8_;
#line 868 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp5_);
#line 3421 "DirectoryMonitor.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 868 "../src/DirectoryMonitor.vala"
			_data_->err = _data_->_inner_error0_;
#line 868 "../src/DirectoryMonitor.vala"
			_data_->_inner_error0_ = NULL;
#line 872 "../src/DirectoryMonitor.vala"
			_data_->_tmp9_ = g_file_get_path (_data_->dir);
#line 872 "../src/DirectoryMonitor.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 872 "../src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->err;
#line 872 "../src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->_tmp11_->message;
#line 872 "../src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:872: Unable to retrieve info on %s: %s", _data_->_tmp10_, _data_->_tmp12_);
#line 872 "../src/DirectoryMonitor.vala"
			_g_free0 (_data_->_tmp10_);
#line 874 "../src/DirectoryMonitor.vala"
			directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 876 "../src/DirectoryMonitor.vala"
			_g_error_free0 (_data_->err);
#line 876 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 876 "../src/DirectoryMonitor.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 876 "../src/DirectoryMonitor.vala"
			if (_data_->_state_ != 0) {
#line 876 "../src/DirectoryMonitor.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 876 "../src/DirectoryMonitor.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3456 "DirectoryMonitor.c"
				}
			}
#line 876 "../src/DirectoryMonitor.vala"
			g_object_unref (_data_->_async_result);
#line 876 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3463 "DirectoryMonitor.c"
		}
		__finally0:
#line 868 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 868 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 868 "../src/DirectoryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 868 "../src/DirectoryMonitor.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 868 "../src/DirectoryMonitor.vala"
			g_object_unref (_data_->_async_result);
#line 868 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3478 "DirectoryMonitor.c"
		}
	}
#line 880 "../src/DirectoryMonitor.vala"
	_data_->_tmp13_ = _data_->local_dir_info;
#line 880 "../src/DirectoryMonitor.vala"
	if (g_file_info_get_is_hidden (_data_->_tmp13_)) {
#line 881 "../src/DirectoryMonitor.vala"
		_data_->_tmp14_ = g_file_get_path (_data_->dir);
#line 881 "../src/DirectoryMonitor.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 881 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:881: Ignoring hidden directory %s", _data_->_tmp15_);
#line 881 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp15_);
#line 883 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 885 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 885 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 885 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 885 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 885 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3505 "DirectoryMonitor.c"
			}
		}
#line 885 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 885 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3512 "DirectoryMonitor.c"
	}
#line 891 "../src/DirectoryMonitor.vala"
	_data_->_tmp16_ = _data_->local_dir_info;
#line 891 "../src/DirectoryMonitor.vala"
	_data_->_tmp17_ = get_file_info_id (_data_->_tmp16_);
#line 891 "../src/DirectoryMonitor.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 891 "../src/DirectoryMonitor.vala"
	_data_->_tmp19_ = _data_->_tmp18_ == NULL;
#line 891 "../src/DirectoryMonitor.vala"
	_g_free0 (_data_->_tmp18_);
#line 891 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp19_) {
#line 892 "../src/DirectoryMonitor.vala"
		_data_->_tmp20_ = g_file_get_path (_data_->dir);
#line 892 "../src/DirectoryMonitor.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 892 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:892: Unable to retrieve file ID on %s: skipping", _data_->_tmp21_);
#line 892 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp21_);
#line 894 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 896 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 896 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 896 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 896 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 896 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3546 "DirectoryMonitor.c"
			}
		}
#line 896 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 896 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3553 "DirectoryMonitor.c"
	}
#line 900 "../src/DirectoryMonitor.vala"
	_data_->_tmp22_ = _data_->local_dir_info;
#line 900 "../src/DirectoryMonitor.vala"
	if (g_file_info_get_file_type (_data_->_tmp22_) != G_FILE_TYPE_DIRECTORY) {
#line 901 "../src/DirectoryMonitor.vala"
		_data_->_tmp23_ = g_file_get_path (_data_->dir);
#line 901 "../src/DirectoryMonitor.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 901 "../src/DirectoryMonitor.vala"
		_data_->_tmp25_ = _data_->local_dir_info;
#line 902 "../src/DirectoryMonitor.vala"
		_data_->_tmp26_ = g_enum_get_value (g_type_class_ref (g_file_type_get_type ()), g_file_info_get_file_type (_data_->_tmp25_));
#line 901 "../src/DirectoryMonitor.vala"
		_data_->_tmp27_ = g_strdup_printf (_ ("Unable to monitor %s: Not a directory (%s)"), _data_->_tmp24_, (_data_->_tmp26_ != NULL) ? _data_->_tmp26_->value_name : NULL);
#line 901 "../src/DirectoryMonitor.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 901 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_failed (_data_->self, _data_->_tmp28_);
#line 901 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp28_);
#line 901 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp24_);
#line 904 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 906 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 906 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 906 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 906 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 906 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3589 "DirectoryMonitor.c"
			}
		}
#line 906 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 906 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3596 "DirectoryMonitor.c"
	}
#line 913 "../src/DirectoryMonitor.vala"
	_data_->dir_map = NULL;
#line 914 "../src/DirectoryMonitor.vala"
	_data_->file_map = NULL;
#line 3602 "DirectoryMonitor.c"
	{
#line 917 "../src/DirectoryMonitor.vala"
		_data_->_tmp29_ = _data_->self->priv->cancellable;
#line 917 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 2;
#line 917 "../src/DirectoryMonitor.vala"
		g_file_enumerate_children_async (_data_->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp29_, directory_monitor_explore_async_ready, _data_);
#line 917 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3612 "DirectoryMonitor.c"
		_state_2:
#line 917 "../src/DirectoryMonitor.vala"
		_data_->_tmp30_ = g_file_enumerate_children_finish (_data_->dir, _data_->_res_, &_data_->_inner_error0_);
#line 917 "../src/DirectoryMonitor.vala"
		_data_->enumerator = _data_->_tmp30_;
#line 917 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3620 "DirectoryMonitor.c"
			goto __catch1_g_error;
		}
		{
#line 919 "../src/DirectoryMonitor.vala"
			_data_->_tmp31_ = TRUE;
#line 919 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 919 "../src/DirectoryMonitor.vala"
				if (!_data_->_tmp31_) {
#line 3630 "DirectoryMonitor.c"
				}
#line 919 "../src/DirectoryMonitor.vala"
				_data_->_tmp31_ = FALSE;
#line 920 "../src/DirectoryMonitor.vala"
				_data_->_tmp32_ = _data_->enumerator;
#line 920 "../src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->self->priv->cancellable;
#line 920 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 3;
#line 920 "../src/DirectoryMonitor.vala"
				g_file_enumerator_next_files_async (_data_->_tmp32_, 10, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp33_, directory_monitor_explore_async_ready, _data_);
#line 920 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 3644 "DirectoryMonitor.c"
				_state_3:
#line 920 "../src/DirectoryMonitor.vala"
				_data_->_tmp34_ = g_file_enumerator_next_files_finish (_data_->_tmp32_, _data_->_res_, &_data_->_inner_error0_);
#line 920 "../src/DirectoryMonitor.vala"
				_data_->infos = _data_->_tmp34_;
#line 920 "../src/DirectoryMonitor.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 920 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->enumerator);
#line 3654 "DirectoryMonitor.c"
					goto __catch1_g_error;
				}
#line 922 "../src/DirectoryMonitor.vala"
				_data_->_tmp35_ = _data_->infos;
#line 922 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp35_ == NULL) {
#line 923 "../src/DirectoryMonitor.vala"
					(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 923 "../src/DirectoryMonitor.vala"
					break;
#line 3665 "DirectoryMonitor.c"
				}
#line 925 "../src/DirectoryMonitor.vala"
				_data_->_tmp36_ = _data_->infos;
#line 3669 "DirectoryMonitor.c"
				{
#line 925 "../src/DirectoryMonitor.vala"
					_data_->info_collection = _data_->_tmp36_;
#line 925 "../src/DirectoryMonitor.vala"
					for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 925 "../src/DirectoryMonitor.vala"
						_data_->_tmp37_ = _g_object_ref0 ((GFileInfo*) _data_->info_it->data);
#line 925 "../src/DirectoryMonitor.vala"
						_data_->info = _data_->_tmp37_;
#line 3679 "DirectoryMonitor.c"
						{
#line 927 "../src/DirectoryMonitor.vala"
							_data_->_tmp38_ = _data_->info;
#line 927 "../src/DirectoryMonitor.vala"
							if (g_file_info_get_is_hidden (_data_->_tmp38_)) {
#line 928 "../src/DirectoryMonitor.vala"
								_data_->_tmp39_ = _data_->info;
#line 928 "../src/DirectoryMonitor.vala"
								_data_->_tmp40_ = g_file_info_get_name (_data_->_tmp39_);
#line 928 "../src/DirectoryMonitor.vala"
								_data_->_tmp41_ = g_file_get_child (_data_->dir, _data_->_tmp40_);
#line 928 "../src/DirectoryMonitor.vala"
								_data_->_tmp42_ = _data_->_tmp41_;
#line 928 "../src/DirectoryMonitor.vala"
								_data_->_tmp43_ = g_file_get_path (_data_->_tmp42_);
#line 928 "../src/DirectoryMonitor.vala"
								_data_->_tmp44_ = _data_->_tmp43_;
#line 928 "../src/DirectoryMonitor.vala"
								g_warning ("DirectoryMonitor.vala:928: Skipping hidden file/directory %s", _data_->_tmp44_);
#line 928 "../src/DirectoryMonitor.vala"
								_g_free0 (_data_->_tmp44_);
#line 928 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->_tmp42_);
#line 931 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 931 "../src/DirectoryMonitor.vala"
								continue;
#line 3707 "DirectoryMonitor.c"
							}
#line 935 "../src/DirectoryMonitor.vala"
							_data_->_tmp45_ = _data_->info;
#line 935 "../src/DirectoryMonitor.vala"
							if (!directory_monitor_is_file_symlink_supported (_data_->_tmp45_)) {
#line 936 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 936 "../src/DirectoryMonitor.vala"
								continue;
#line 3717 "DirectoryMonitor.c"
							}
#line 938 "../src/DirectoryMonitor.vala"
							_data_->_tmp46_ = _data_->info;
#line 938 "../src/DirectoryMonitor.vala"
							switch (g_file_info_get_file_type (_data_->_tmp46_)) {
#line 938 "../src/DirectoryMonitor.vala"
								case G_FILE_TYPE_REGULAR:
#line 3725 "DirectoryMonitor.c"
								{
#line 940 "../src/DirectoryMonitor.vala"
									_data_->_tmp47_ = _data_->file_map;
#line 940 "../src/DirectoryMonitor.vala"
									if (_data_->_tmp47_ == NULL) {
#line 941 "../src/DirectoryMonitor.vala"
										_data_->_tmp48_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 941 "../src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->file_map);
#line 941 "../src/DirectoryMonitor.vala"
										_data_->file_map = _data_->_tmp48_;
#line 3737 "DirectoryMonitor.c"
									}
#line 943 "../src/DirectoryMonitor.vala"
									_data_->_tmp49_ = _data_->file_map;
#line 943 "../src/DirectoryMonitor.vala"
									_data_->_tmp50_ = _data_->info;
#line 943 "../src/DirectoryMonitor.vala"
									_data_->_tmp51_ = g_file_info_get_name (_data_->_tmp50_);
#line 943 "../src/DirectoryMonitor.vala"
									_data_->_tmp52_ = g_file_get_child (_data_->dir, _data_->_tmp51_);
#line 943 "../src/DirectoryMonitor.vala"
									_data_->_tmp53_ = _data_->_tmp52_;
#line 943 "../src/DirectoryMonitor.vala"
									_data_->_tmp54_ = _data_->info;
#line 943 "../src/DirectoryMonitor.vala"
									gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp49_, _data_->_tmp53_, _data_->_tmp54_);
#line 943 "../src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp53_);
#line 944 "../src/DirectoryMonitor.vala"
									break;
#line 3757 "DirectoryMonitor.c"
								}
#line 938 "../src/DirectoryMonitor.vala"
								case G_FILE_TYPE_DIRECTORY:
#line 3761 "DirectoryMonitor.c"
								{
#line 947 "../src/DirectoryMonitor.vala"
									_data_->_tmp55_ = _data_->dir_map;
#line 947 "../src/DirectoryMonitor.vala"
									if (_data_->_tmp55_ == NULL) {
#line 948 "../src/DirectoryMonitor.vala"
										_data_->_tmp56_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 948 "../src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->dir_map);
#line 948 "../src/DirectoryMonitor.vala"
										_data_->dir_map = _data_->_tmp56_;
#line 3773 "DirectoryMonitor.c"
									}
#line 950 "../src/DirectoryMonitor.vala"
									_data_->_tmp57_ = _data_->dir_map;
#line 950 "../src/DirectoryMonitor.vala"
									_data_->_tmp58_ = _data_->info;
#line 950 "../src/DirectoryMonitor.vala"
									_data_->_tmp59_ = g_file_info_get_name (_data_->_tmp58_);
#line 950 "../src/DirectoryMonitor.vala"
									_data_->_tmp60_ = g_file_get_child (_data_->dir, _data_->_tmp59_);
#line 950 "../src/DirectoryMonitor.vala"
									_data_->_tmp61_ = _data_->_tmp60_;
#line 950 "../src/DirectoryMonitor.vala"
									_data_->_tmp62_ = _data_->info;
#line 950 "../src/DirectoryMonitor.vala"
									gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp57_, _data_->_tmp61_, _data_->_tmp62_);
#line 950 "../src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp61_);
#line 951 "../src/DirectoryMonitor.vala"
									break;
#line 3793 "DirectoryMonitor.c"
								}
								default:
								{
#line 955 "../src/DirectoryMonitor.vala"
									break;
#line 3799 "DirectoryMonitor.c"
								}
							}
#line 925 "../src/DirectoryMonitor.vala"
							_g_object_unref0 (_data_->info);
#line 3804 "DirectoryMonitor.c"
						}
					}
				}
#line 919 "../src/DirectoryMonitor.vala"
				(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 3810 "DirectoryMonitor.c"
			}
		}
#line 916 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->enumerator);
#line 3815 "DirectoryMonitor.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 916 "../src/DirectoryMonitor.vala"
		_data_->err2 = _data_->_inner_error0_;
#line 916 "../src/DirectoryMonitor.vala"
		_data_->_inner_error0_ = NULL;
#line 960 "../src/DirectoryMonitor.vala"
		_data_->_tmp63_ = g_file_get_path (_data_->dir);
#line 960 "../src/DirectoryMonitor.vala"
		_data_->_tmp64_ = _data_->_tmp63_;
#line 960 "../src/DirectoryMonitor.vala"
		_data_->_tmp65_ = _data_->err2;
#line 960 "../src/DirectoryMonitor.vala"
		_data_->_tmp66_ = _data_->_tmp65_->message;
#line 960 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:960: Aborted directory traversal of %s: %s", _data_->_tmp64_, _data_->_tmp66_);
#line 960 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp64_);
#line 962 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 964 "../src/DirectoryMonitor.vala"
		_g_error_free0 (_data_->err2);
#line 964 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 964 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 964 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 964 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 964 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 964 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 964 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3854 "DirectoryMonitor.c"
			}
		}
#line 964 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 964 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3861 "DirectoryMonitor.c"
	}
	__finally1:
#line 916 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 916 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 916 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 916 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 916 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 916 "../src/DirectoryMonitor.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 916 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 916 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3880 "DirectoryMonitor.c"
	}
#line 968 "../src/DirectoryMonitor.vala"
	if (_data_->in_discovery) {
#line 969 "../src/DirectoryMonitor.vala"
		_data_->_tmp67_ = _data_->local_dir_info;
#line 969 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_discovered (_data_->self, _data_->dir, _data_->_tmp67_);
#line 3888 "DirectoryMonitor.c"
	} else {
#line 971 "../src/DirectoryMonitor.vala"
		_data_->_tmp68_ = _data_->local_dir_info;
#line 971 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_created (_data_->self, _data_->dir, _data_->_tmp68_);
#line 3894 "DirectoryMonitor.c"
	}
#line 975 "../src/DirectoryMonitor.vala"
	_data_->_tmp69_ = _data_->local_dir_info;
#line 975 "../src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->dir, _data_->_tmp69_);
#line 978 "../src/DirectoryMonitor.vala"
	_data_->_tmp70_ = _data_->file_map;
#line 978 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp70_ != NULL) {
#line 979 "../src/DirectoryMonitor.vala"
		_data_->_tmp71_ = _data_->file_map;
#line 979 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 4;
#line 979 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files (_data_->self, (GeeMap*) _data_->_tmp71_, _data_->in_discovery, directory_monitor_explore_async_ready, _data_);
#line 979 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3912 "DirectoryMonitor.c"
		_state_4:
#line 979 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files_finish (_data_->self, _data_->_res_);
#line 3916 "DirectoryMonitor.c"
	}
#line 982 "../src/DirectoryMonitor.vala"
	if (_data_->self->priv->recurse) {
#line 982 "../src/DirectoryMonitor.vala"
		_data_->_tmp73_ = _data_->dir_map;
#line 982 "../src/DirectoryMonitor.vala"
		_data_->_tmp72_ = _data_->_tmp73_ != NULL;
#line 3924 "DirectoryMonitor.c"
	} else {
#line 982 "../src/DirectoryMonitor.vala"
		_data_->_tmp72_ = FALSE;
#line 3928 "DirectoryMonitor.c"
	}
#line 982 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp72_) {
#line 3932 "DirectoryMonitor.c"
		{
#line 983 "../src/DirectoryMonitor.vala"
			_data_->_tmp74_ = _data_->dir_map;
#line 983 "../src/DirectoryMonitor.vala"
			_data_->_tmp75_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _data_->_tmp74_);
#line 983 "../src/DirectoryMonitor.vala"
			_data_->_tmp76_ = _data_->_tmp75_;
#line 983 "../src/DirectoryMonitor.vala"
			_data_->_tmp77_ = _data_->_tmp76_;
#line 983 "../src/DirectoryMonitor.vala"
			_data_->_tmp78_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp77_);
#line 983 "../src/DirectoryMonitor.vala"
			_data_->_tmp79_ = _data_->_tmp78_;
#line 983 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp77_);
#line 983 "../src/DirectoryMonitor.vala"
			_data_->_subdir_it = _data_->_tmp79_;
#line 983 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 983 "../src/DirectoryMonitor.vala"
				_data_->_tmp80_ = _data_->_subdir_it;
#line 983 "../src/DirectoryMonitor.vala"
				if (!gee_iterator_next (_data_->_tmp80_)) {
#line 983 "../src/DirectoryMonitor.vala"
					break;
#line 3958 "DirectoryMonitor.c"
				}
#line 983 "../src/DirectoryMonitor.vala"
				_data_->_tmp81_ = _data_->_subdir_it;
#line 983 "../src/DirectoryMonitor.vala"
				_data_->_tmp82_ = gee_iterator_get (_data_->_tmp81_);
#line 983 "../src/DirectoryMonitor.vala"
				_data_->subdir = (GFile*) _data_->_tmp82_;
#line 984 "../src/DirectoryMonitor.vala"
				_data_->self->priv->outstanding_exploration_dirs = _data_->self->priv->outstanding_exploration_dirs + 1;
#line 984 "../src/DirectoryMonitor.vala"
				_data_->_tmp83_ = _data_->self->priv->outstanding_exploration_dirs;
#line 984 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp83_ > DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS) {
#line 985 "../src/DirectoryMonitor.vala"
					_data_->_tmp84_ = _data_->subdir;
#line 985 "../src/DirectoryMonitor.vala"
					_data_->_tmp85_ = _data_->dir_map;
#line 985 "../src/DirectoryMonitor.vala"
					_data_->_tmp86_ = _data_->subdir;
#line 985 "../src/DirectoryMonitor.vala"
					_data_->_tmp87_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp85_, _data_->_tmp86_);
#line 985 "../src/DirectoryMonitor.vala"
					_data_->_tmp88_ = (GFileInfo*) _data_->_tmp87_;
#line 985 "../src/DirectoryMonitor.vala"
					_data_->_state_ = 5;
#line 985 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp84_, _data_->_tmp88_, _data_->in_discovery, directory_monitor_explore_async_ready, _data_);
#line 985 "../src/DirectoryMonitor.vala"
					return FALSE;
#line 3988 "DirectoryMonitor.c"
					_state_5:
#line 985 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_finish (_data_->self, _data_->_res_);
#line 985 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp88_);
#line 3994 "DirectoryMonitor.c"
				} else {
#line 987 "../src/DirectoryMonitor.vala"
					_data_->_tmp89_ = _data_->subdir;
#line 987 "../src/DirectoryMonitor.vala"
					_data_->_tmp90_ = _data_->dir_map;
#line 987 "../src/DirectoryMonitor.vala"
					_data_->_tmp91_ = _data_->subdir;
#line 987 "../src/DirectoryMonitor.vala"
					_data_->_tmp92_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp90_, _data_->_tmp91_);
#line 987 "../src/DirectoryMonitor.vala"
					_data_->_tmp93_ = (GFileInfo*) _data_->_tmp92_;
#line 987 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp89_, _data_->_tmp93_, _data_->in_discovery, NULL, NULL);
#line 987 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp93_);
#line 4010 "DirectoryMonitor.c"
				}
#line 983 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->subdir);
#line 4014 "DirectoryMonitor.c"
			}
#line 983 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_subdir_it);
#line 4018 "DirectoryMonitor.c"
		}
	}
#line 991 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 856 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_map);
#line 856 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_map);
#line 856 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->local_dir_info);
#line 856 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 856 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 856 "../src/DirectoryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 856 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4037 "DirectoryMonitor.c"
		}
	}
#line 856 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 856 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 4044 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files_data_free (gpointer _data)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = _data;
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->map);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 73 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorNotifyDirectoryFilesData, _data_);
#line 4058 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files (DirectoryMonitor* self,
                                          GeeMap* map,
                                          gboolean in_discovery,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	DirectoryMonitor* _tmp0_;
	GeeMap* _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (map != NULL);
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorNotifyDirectoryFilesData);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 73 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_notify_directory_files_data_free);
#line 73 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (map);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->map);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->map = _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->in_discovery = in_discovery;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_files_co (_data_);
#line 4095 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files_finish (DirectoryMonitor* self,
                                                 GAsyncResult* _res_)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4105 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_notify_directory_files_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_notify_directory_files_co (self);
#line 1002 "../src/DirectoryMonitor.vala"
	return result;
#line 4115 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_)
{
#line 994 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 994 "../src/DirectoryMonitor.vala"
		case 0:
#line 4125 "DirectoryMonitor.c"
		goto _state_0;
#line 994 "../src/DirectoryMonitor.vala"
		case 1:
#line 4129 "DirectoryMonitor.c"
		goto _state_1;
		default:
#line 994 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 4134 "DirectoryMonitor.c"
	}
	_state_0:
#line 995 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_map_map_iterator (_data_->map);
#line 995 "../src/DirectoryMonitor.vala"
	_data_->iter = _data_->_tmp0_;
#line 996 "../src/DirectoryMonitor.vala"
	while (TRUE) {
#line 996 "../src/DirectoryMonitor.vala"
		_data_->_tmp1_ = _data_->iter;
#line 996 "../src/DirectoryMonitor.vala"
		if (!gee_map_iterator_next (_data_->_tmp1_)) {
#line 996 "../src/DirectoryMonitor.vala"
			break;
#line 4149 "DirectoryMonitor.c"
		}
#line 997 "../src/DirectoryMonitor.vala"
		if (_data_->in_discovery) {
#line 998 "../src/DirectoryMonitor.vala"
			_data_->_tmp2_ = _data_->iter;
#line 998 "../src/DirectoryMonitor.vala"
			_data_->_tmp3_ = gee_map_iterator_get_key (_data_->_tmp2_);
#line 998 "../src/DirectoryMonitor.vala"
			_data_->_tmp4_ = (GFile*) _data_->_tmp3_;
#line 998 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->iter;
#line 998 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = gee_map_iterator_get_value (_data_->_tmp5_);
#line 998 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = (GFileInfo*) _data_->_tmp6_;
#line 998 "../src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_discovered (_data_->self, _data_->_tmp4_, _data_->_tmp7_);
#line 998 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 998 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp4_);
#line 4171 "DirectoryMonitor.c"
		} else {
#line 1000 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->iter;
#line 1000 "../src/DirectoryMonitor.vala"
			_data_->_tmp9_ = gee_map_iterator_get_key (_data_->_tmp8_);
#line 1000 "../src/DirectoryMonitor.vala"
			_data_->_tmp10_ = (GFile*) _data_->_tmp9_;
#line 1000 "../src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->iter;
#line 1000 "../src/DirectoryMonitor.vala"
			_data_->_tmp12_ = gee_map_iterator_get_value (_data_->_tmp11_);
#line 1000 "../src/DirectoryMonitor.vala"
			_data_->_tmp13_ = (GFileInfo*) _data_->_tmp12_;
#line 1000 "../src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_created (_data_->self, _data_->_tmp10_, _data_->_tmp13_);
#line 1000 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp13_);
#line 1000 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 4191 "DirectoryMonitor.c"
		}
#line 1002 "../src/DirectoryMonitor.vala"
		g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_notify_directory_files_co_gsource_func, _data_, NULL);
#line 1003 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 1;
#line 1003 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 4199 "DirectoryMonitor.c"
		_state_1:
		;
	}
#line 994 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->iter);
#line 994 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 994 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 994 "../src/DirectoryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 994 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4213 "DirectoryMonitor.c"
		}
	}
#line 994 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 994 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 4220 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_directory_completed (DirectoryMonitor* self,
                                               gboolean in_discovery)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 1009 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1010 "../src/DirectoryMonitor.vala"
	_vala_assert (self->priv->outstanding_exploration_dirs > 0, "outstanding_exploration_dirs > 0");
#line 1011 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->outstanding_exploration_dirs;
#line 1011 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = _tmp0_ - 1;
#line 1013 "../src/DirectoryMonitor.vala"
	if (in_discovery) {
#line 1013 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->outstanding_exploration_dirs == 0;
#line 4241 "DirectoryMonitor.c"
	} else {
#line 1013 "../src/DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 4245 "DirectoryMonitor.c"
	}
#line 1013 "../src/DirectoryMonitor.vala"
	if (_tmp1_) {
#line 1014 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_completed (self);
#line 4251 "DirectoryMonitor.c"
	}
}

static void
_directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender,
                                                                   GFile* file,
                                                                   GFile* other_file,
                                                                   GFileMonitorEvent event_type,
                                                                   gpointer self)
{
#line 1042 "../src/DirectoryMonitor.vala"
	directory_monitor_on_monitor_notification ((DirectoryMonitor*) self, file, other_file, event_type);
#line 4264 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_add_monitor (DirectoryMonitor* self,
                               GFile* dir,
                               GFileInfo* info)
{
	gchar* id = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	GFileMonitor* monitor = NULL;
	GeeHashMap* _tmp13_;
	const gchar* _tmp14_;
	GFileMonitor* _tmp15_;
	GFileMonitor* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1020 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1020 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 1020 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 1021 "../src/DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 1022 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1022 "../src/DirectoryMonitor.vala"
		return result;
#line 4301 "DirectoryMonitor.c"
	}
#line 1024 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1024 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_id (_tmp0_, dir, info);
#line 1024 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 1025 "../src/DirectoryMonitor.vala"
	_tmp2_ = id;
#line 1025 "../src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 1026 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1026 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1026 "../src/DirectoryMonitor.vala"
		return result;
#line 4319 "DirectoryMonitor.c"
	}
#line 1029 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->monitors;
#line 1029 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 1029 "../src/DirectoryMonitor.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_)) {
#line 1030 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1030 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1030 "../src/DirectoryMonitor.vala"
		return result;
#line 4333 "DirectoryMonitor.c"
	}
#line 1032 "../src/DirectoryMonitor.vala"
	monitor = NULL;
#line 4337 "DirectoryMonitor.c"
	{
		GFileMonitor* _tmp5_ = NULL;
		GFileMonitor* _tmp6_;
		GFileMonitor* _tmp7_;
#line 1034 "../src/DirectoryMonitor.vala"
		_tmp6_ = g_file_monitor_directory (dir, DIRECTORY_MONITOR_FILE_MONITOR_FLAGS, NULL, &_inner_error0_);
#line 1034 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp6_;
#line 1034 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4348 "DirectoryMonitor.c"
			goto __catch0_g_error;
		}
#line 1034 "../src/DirectoryMonitor.vala"
		_tmp7_ = _tmp5_;
#line 1034 "../src/DirectoryMonitor.vala"
		_tmp5_ = NULL;
#line 1034 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1034 "../src/DirectoryMonitor.vala"
		monitor = _tmp7_;
#line 1033 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp5_);
#line 4361 "DirectoryMonitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 1033 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 1033 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 1036 "../src/DirectoryMonitor.vala"
		_tmp8_ = g_file_get_path (dir);
#line 1036 "../src/DirectoryMonitor.vala"
		_tmp9_ = _tmp8_;
#line 1036 "../src/DirectoryMonitor.vala"
		_tmp10_ = err;
#line 1036 "../src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_->message;
#line 1036 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:1036: Unable to monitor %s: %s", _tmp9_, _tmp11_);
#line 1036 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp9_);
#line 1038 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1038 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 1038 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1038 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1038 "../src/DirectoryMonitor.vala"
		return result;
#line 4397 "DirectoryMonitor.c"
	}
	__finally0:
#line 1033 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4402 "DirectoryMonitor.c"
		gboolean _tmp12_ = FALSE;
#line 1033 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1033 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1033 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1033 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 1033 "../src/DirectoryMonitor.vala"
		return _tmp12_;
#line 4414 "DirectoryMonitor.c"
	}
#line 1041 "../src/DirectoryMonitor.vala"
	_tmp13_ = self->priv->monitors;
#line 1041 "../src/DirectoryMonitor.vala"
	_tmp14_ = id;
#line 1041 "../src/DirectoryMonitor.vala"
	_tmp15_ = monitor;
#line 1041 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp14_, _tmp15_);
#line 1042 "../src/DirectoryMonitor.vala"
	_tmp16_ = monitor;
#line 1042 "../src/DirectoryMonitor.vala"
	g_signal_connect_object (_tmp16_, "changed", (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self, 0);
#line 1044 "../src/DirectoryMonitor.vala"
	_tmp17_ = g_file_get_path (dir);
#line 1044 "../src/DirectoryMonitor.vala"
	_tmp18_ = _tmp17_;
#line 1044 "../src/DirectoryMonitor.vala"
	_tmp19_ = g_strdup_printf ("Added monitor for %s", _tmp18_);
#line 1044 "../src/DirectoryMonitor.vala"
	_tmp20_ = _tmp19_;
#line 1044 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp20_);
#line 1044 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp20_);
#line 1044 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp18_);
#line 1046 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 1046 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1046 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1046 "../src/DirectoryMonitor.vala"
	return result;
#line 4450 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_remove_monitor (DirectoryMonitor* self,
                                  GFile* dir,
                                  GFileInfo* info)
{
	gchar* id = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GFileMonitor* monitor = NULL;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gpointer _tmp5_;
	GFileMonitor* _tmp6_;
	gboolean removed = FALSE;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
	GFileMonitor* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean result;
#line 1050 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1050 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 1050 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 1051 "../src/DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 1052 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1052 "../src/DirectoryMonitor.vala"
		return result;
#line 4488 "DirectoryMonitor.c"
	}
#line 1054 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1054 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_id (_tmp0_, dir, info);
#line 1054 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 1055 "../src/DirectoryMonitor.vala"
	_tmp2_ = id;
#line 1055 "../src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 1056 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1056 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1056 "../src/DirectoryMonitor.vala"
		return result;
#line 4506 "DirectoryMonitor.c"
	}
#line 1058 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->monitors;
#line 1058 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 1058 "../src/DirectoryMonitor.vala"
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 1058 "../src/DirectoryMonitor.vala"
	monitor = (GFileMonitor*) _tmp5_;
#line 1059 "../src/DirectoryMonitor.vala"
	_tmp6_ = monitor;
#line 1059 "../src/DirectoryMonitor.vala"
	if (_tmp6_ == NULL) {
#line 1060 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1060 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1060 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1060 "../src/DirectoryMonitor.vala"
		return result;
#line 4528 "DirectoryMonitor.c"
	}
#line 1062 "../src/DirectoryMonitor.vala"
	_tmp7_ = self->priv->monitors;
#line 1062 "../src/DirectoryMonitor.vala"
	_tmp8_ = id;
#line 1062 "../src/DirectoryMonitor.vala"
	removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, _tmp8_, NULL);
#line 1063 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 1065 "../src/DirectoryMonitor.vala"
	_tmp9_ = monitor;
#line 1065 "../src/DirectoryMonitor.vala"
	directory_monitor_cancel_monitor (self, _tmp9_);
#line 1067 "../src/DirectoryMonitor.vala"
	_tmp10_ = g_file_get_path (dir);
#line 1067 "../src/DirectoryMonitor.vala"
	_tmp11_ = _tmp10_;
#line 1067 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup_printf ("Removed monitor for %s", _tmp11_);
#line 1067 "../src/DirectoryMonitor.vala"
	_tmp13_ = _tmp12_;
#line 1067 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp13_);
#line 1067 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp13_);
#line 1067 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp11_);
#line 1069 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 1069 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1069 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1069 "../src/DirectoryMonitor.vala"
	return result;
#line 4564 "DirectoryMonitor.c"
}

static void
directory_monitor_cancel_monitor (DirectoryMonitor* self,
                                  GFileMonitor* monitor)
{
	guint _tmp0_;
#line 1072 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1072 "../src/DirectoryMonitor.vala"
	g_return_if_fail (monitor != NULL);
#line 1073 "../src/DirectoryMonitor.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp0_, NULL, FALSE);
#line 1073 "../src/DirectoryMonitor.vala"
	g_signal_handlers_disconnect_matched (monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self);
#line 1074 "../src/DirectoryMonitor.vala"
	g_file_monitor_cancel (monitor);
#line 4582 "DirectoryMonitor.c"
}

static void
_directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object,
                                                                                GAsyncResult* res,
                                                                                gpointer self)
{
#line 1094 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_on_completed ((DirectoryMonitorQueryInfoQueueElement*) self, source_object, res);
#line 1094 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_unref (self);
#line 4594 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_check_for_expired_delete_events ((DirectoryMonitor*) self);
#line 1103 "../src/DirectoryMonitor.vala"
	return result;
#line 4604 "DirectoryMonitor.c"
}

static void
directory_monitor_on_monitor_notification (DirectoryMonitor* self,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event)
{
	gchar* _tmp0_ = NULL;
	GEnumValue* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	DirectoryMonitorQueryInfoQueueElement* query_info = NULL;
	DirectoryMonitorQueryInfoQueueElement* _tmp8_;
	GeeQueue* _tmp9_;
	DirectoryMonitorQueryInfoQueueElement* _tmp10_;
#line 1077 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1077 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 1079 "../src/DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 4629 "DirectoryMonitor.c"
		gchar* _tmp1_;
#line 1079 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (other_file);
#line 1079 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1079 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp1_;
#line 4637 "DirectoryMonitor.c"
	} else {
		gchar* _tmp2_;
#line 1079 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_strdup ("(none)");
#line 1079 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1079 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp2_;
#line 4646 "DirectoryMonitor.c"
	}
#line 1078 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1078 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (file);
#line 1078 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 1078 "../src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("NOTIFY %s: file=%s other_file=%s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL, _tmp5_, _tmp0_);
#line 1078 "../src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 1078 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 1078 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 1078 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 1088 "../src/DirectoryMonitor.vala"
	_tmp8_ = directory_monitor_query_info_queue_element_new (self, file, other_file, event);
#line 1088 "../src/DirectoryMonitor.vala"
	query_info = _tmp8_;
#line 1089 "../src/DirectoryMonitor.vala"
	_tmp9_ = self->priv->query_info_queue;
#line 1089 "../src/DirectoryMonitor.vala"
	_tmp10_ = query_info;
#line 1089 "../src/DirectoryMonitor.vala"
	gee_queue_offer (_tmp9_, _tmp10_);
#line 1091 "../src/DirectoryMonitor.vala"
	switch (event) {
#line 1091 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 1091 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 4680 "DirectoryMonitor.c"
		{
			GCancellable* _tmp11_;
			DirectoryMonitorQueryInfoQueueElement* _tmp12_;
#line 1094 "../src/DirectoryMonitor.vala"
			_tmp11_ = self->priv->cancellable;
#line 1094 "../src/DirectoryMonitor.vala"
			_tmp12_ = query_info;
#line 1094 "../src/DirectoryMonitor.vala"
			g_file_query_info_async (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp11_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp12_));
#line 1096 "../src/DirectoryMonitor.vala"
			break;
#line 4692 "DirectoryMonitor.c"
		}
#line 1091 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 4696 "DirectoryMonitor.c"
		{
#line 1102 "../src/DirectoryMonitor.vala"
			if (self->priv->delete_timer_id == ((guint) 0)) {
#line 1103 "../src/DirectoryMonitor.vala"
				self->priv->delete_timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC / 2, _directory_monitor_check_for_expired_delete_events_gsource_func, g_object_ref (self), g_object_unref);
#line 4702 "DirectoryMonitor.c"
			}
#line 1104 "../src/DirectoryMonitor.vala"
			break;
#line 4706 "DirectoryMonitor.c"
		}
#line 1091 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 4710 "DirectoryMonitor.c"
		{
#line 1109 "../src/DirectoryMonitor.vala"
			if (other_file != NULL) {
#line 4714 "DirectoryMonitor.c"
				GCancellable* _tmp13_;
				DirectoryMonitorQueryInfoQueueElement* _tmp14_;
#line 1110 "../src/DirectoryMonitor.vala"
				_tmp13_ = self->priv->cancellable;
#line 1110 "../src/DirectoryMonitor.vala"
				_tmp14_ = query_info;
#line 1110 "../src/DirectoryMonitor.vala"
				g_file_query_info_async (other_file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp13_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp14_));
#line 4723 "DirectoryMonitor.c"
			} else {
				GeeQueue* _tmp15_;
				DirectoryMonitorQueryInfoQueueElement* _tmp16_;
#line 1113 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1113: Unable to process MOVED event: no other_fi" \
"le");
#line 1114 "../src/DirectoryMonitor.vala"
				_tmp15_ = self->priv->query_info_queue;
#line 1114 "../src/DirectoryMonitor.vala"
				_tmp16_ = query_info;
#line 1114 "../src/DirectoryMonitor.vala"
				gee_collection_remove ((GeeCollection*) _tmp15_, _tmp16_);
#line 4735 "DirectoryMonitor.c"
			}
#line 1116 "../src/DirectoryMonitor.vala"
			break;
#line 4739 "DirectoryMonitor.c"
		}
		default:
		{
			DirectoryMonitorQueryInfoQueueElement* _tmp17_;
			DirectoryMonitorQueryInfoQueueElement* _tmp18_;
#line 1120 "../src/DirectoryMonitor.vala"
			_tmp17_ = query_info;
#line 1120 "../src/DirectoryMonitor.vala"
			_tmp17_->completed = TRUE;
#line 1121 "../src/DirectoryMonitor.vala"
			_tmp18_ = query_info;
#line 1121 "../src/DirectoryMonitor.vala"
			directory_monitor_process_query_queue (self, _tmp18_);
#line 1122 "../src/DirectoryMonitor.vala"
			break;
#line 4755 "DirectoryMonitor.c"
		}
	}
#line 1077 "../src/DirectoryMonitor.vala"
	_directory_monitor_query_info_queue_element_unref0 (query_info);
#line 1077 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 4762 "DirectoryMonitor.c"
}

static void
directory_monitor_process_query_queue (DirectoryMonitor* self,
                                       DirectoryMonitorQueryInfoQueueElement* query_info)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 1126 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1129 "../src/DirectoryMonitor.vala"
	if (query_info != NULL) {
#line 4775 "DirectoryMonitor.c"
		GFileInfo* _tmp2_;
#line 1129 "../src/DirectoryMonitor.vala"
		_tmp2_ = query_info->info;
#line 1129 "../src/DirectoryMonitor.vala"
		_tmp1_ = _tmp2_ != NULL;
#line 4781 "DirectoryMonitor.c"
	} else {
#line 1129 "../src/DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 4785 "DirectoryMonitor.c"
	}
#line 1129 "../src/DirectoryMonitor.vala"
	if (_tmp1_) {
#line 1129 "../src/DirectoryMonitor.vala"
		_tmp0_ = query_info->event == G_FILE_MONITOR_EVENT_CREATED;
#line 4791 "DirectoryMonitor.c"
	} else {
#line 1129 "../src/DirectoryMonitor.vala"
		_tmp0_ = FALSE;
#line 4795 "DirectoryMonitor.c"
	}
#line 1129 "../src/DirectoryMonitor.vala"
	if (_tmp0_) {
#line 4799 "DirectoryMonitor.c"
		GFile* match = NULL;
		DirectoryMonitorFileInfoMap* _tmp3_;
		GFileInfo* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 1132 "../src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->files;
#line 1132 "../src/DirectoryMonitor.vala"
		_tmp4_ = query_info->info;
#line 1132 "../src/DirectoryMonitor.vala"
		_tmp5_ = directory_monitor_file_info_map_find_match (_tmp3_, _tmp4_);
#line 1132 "../src/DirectoryMonitor.vala"
		match = _tmp5_;
#line 1133 "../src/DirectoryMonitor.vala"
		_tmp6_ = match;
#line 1133 "../src/DirectoryMonitor.vala"
		if (_tmp6_ != NULL) {
#line 4817 "DirectoryMonitor.c"
			gboolean matched = FALSE;
#line 1134 "../src/DirectoryMonitor.vala"
			matched = FALSE;
#line 4821 "DirectoryMonitor.c"
			{
				GeeIterator* _enqueued_it = NULL;
				GeeQueue* _tmp7_;
				GeeIterator* _tmp8_;
#line 1135 "../src/DirectoryMonitor.vala"
				_tmp7_ = self->priv->query_info_queue;
#line 1135 "../src/DirectoryMonitor.vala"
				_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 1135 "../src/DirectoryMonitor.vala"
				_enqueued_it = _tmp8_;
#line 1135 "../src/DirectoryMonitor.vala"
				while (TRUE) {
#line 4834 "DirectoryMonitor.c"
					GeeIterator* _tmp9_;
					DirectoryMonitorQueryInfoQueueElement* enqueued = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					DirectoryMonitorQueryInfoQueueElement* _tmp14_;
					GFile* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					DirectoryMonitorQueryInfoQueueElement* _tmp22_;
					GFile* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					DirectoryMonitorQueryInfoQueueElement* _tmp28_;
					DirectoryMonitorQueryInfoQueueElement* _tmp29_;
					GFile* _tmp30_;
					GFile* _tmp31_;
					DirectoryMonitorQueryInfoQueueElement* _tmp32_;
					GFileInfo* _tmp33_;
					GFileInfo* _tmp34_;
					DirectoryMonitorQueryInfoQueueElement* _tmp35_;
#line 1135 "../src/DirectoryMonitor.vala"
					_tmp9_ = _enqueued_it;
#line 1135 "../src/DirectoryMonitor.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 1135 "../src/DirectoryMonitor.vala"
						break;
#line 4865 "DirectoryMonitor.c"
					}
#line 1135 "../src/DirectoryMonitor.vala"
					_tmp10_ = _enqueued_it;
#line 1135 "../src/DirectoryMonitor.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 1135 "../src/DirectoryMonitor.vala"
					enqueued = (DirectoryMonitorQueryInfoQueueElement*) _tmp11_;
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp14_ = enqueued;
#line 1136 "../src/DirectoryMonitor.vala"
					if (_tmp14_->event != G_FILE_MONITOR_EVENT_DELETED) {
#line 1136 "../src/DirectoryMonitor.vala"
						_tmp13_ = TRUE;
#line 4879 "DirectoryMonitor.c"
					} else {
						DirectoryMonitorQueryInfoQueueElement* _tmp15_;
#line 1137 "../src/DirectoryMonitor.vala"
						_tmp15_ = enqueued;
#line 1137 "../src/DirectoryMonitor.vala"
						_tmp13_ = _tmp15_->completed;
#line 4886 "DirectoryMonitor.c"
					}
#line 1136 "../src/DirectoryMonitor.vala"
					if (_tmp13_) {
#line 1136 "../src/DirectoryMonitor.vala"
						_tmp12_ = TRUE;
#line 4892 "DirectoryMonitor.c"
					} else {
						GFile* _tmp16_;
						DirectoryMonitorQueryInfoQueueElement* _tmp17_;
						GFile* _tmp18_;
#line 1138 "../src/DirectoryMonitor.vala"
						_tmp16_ = match;
#line 1138 "../src/DirectoryMonitor.vala"
						_tmp17_ = enqueued;
#line 1138 "../src/DirectoryMonitor.vala"
						_tmp18_ = _tmp17_->file;
#line 1138 "../src/DirectoryMonitor.vala"
						_tmp12_ = !g_file_equal (_tmp16_, _tmp18_);
#line 4905 "DirectoryMonitor.c"
					}
#line 1136 "../src/DirectoryMonitor.vala"
					if (_tmp12_) {
#line 1139 "../src/DirectoryMonitor.vala"
						_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1139 "../src/DirectoryMonitor.vala"
						continue;
#line 4913 "DirectoryMonitor.c"
					}
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp19_ = query_info->file;
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp20_ = g_file_get_path (_tmp19_);
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp21_ = _tmp20_;
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp22_ = enqueued;
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp23_ = _tmp22_->file;
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp24_ = g_file_get_path (_tmp23_);
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp25_ = _tmp24_;
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp26_ = g_strdup_printf ("Matching CREATED %s to DELETED %s for MOVED", _tmp21_, _tmp25_);
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp27_ = _tmp26_;
#line 1142 "../src/DirectoryMonitor.vala"
					directory_monitor_mdbg (_tmp27_);
#line 1142 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp27_);
#line 1142 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp25_);
#line 1142 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp21_);
#line 1145 "../src/DirectoryMonitor.vala"
					_tmp28_ = enqueued;
#line 1145 "../src/DirectoryMonitor.vala"
					_tmp28_->event = G_FILE_MONITOR_EVENT_MOVED;
#line 1146 "../src/DirectoryMonitor.vala"
					_tmp29_ = enqueued;
#line 1146 "../src/DirectoryMonitor.vala"
					_tmp30_ = query_info->file;
#line 1146 "../src/DirectoryMonitor.vala"
					_tmp31_ = _g_object_ref0 (_tmp30_);
#line 1146 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp29_->other_file);
#line 1146 "../src/DirectoryMonitor.vala"
					_tmp29_->other_file = _tmp31_;
#line 1147 "../src/DirectoryMonitor.vala"
					_tmp32_ = enqueued;
#line 1147 "../src/DirectoryMonitor.vala"
					_tmp33_ = query_info->info;
#line 1147 "../src/DirectoryMonitor.vala"
					_tmp34_ = _g_object_ref0 (_tmp33_);
#line 1147 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp32_->info);
#line 1147 "../src/DirectoryMonitor.vala"
					_tmp32_->info = _tmp34_;
#line 1148 "../src/DirectoryMonitor.vala"
					_tmp35_ = enqueued;
#line 1148 "../src/DirectoryMonitor.vala"
					_tmp35_->completed = TRUE;
#line 1150 "../src/DirectoryMonitor.vala"
					matched = TRUE;
#line 1152 "../src/DirectoryMonitor.vala"
					_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1152 "../src/DirectoryMonitor.vala"
					break;
#line 4975 "DirectoryMonitor.c"
				}
#line 1135 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_enqueued_it);
#line 4979 "DirectoryMonitor.c"
			}
#line 1155 "../src/DirectoryMonitor.vala"
			if (matched) {
#line 4983 "DirectoryMonitor.c"
				GeeQueue* _tmp36_;
#line 1156 "../src/DirectoryMonitor.vala"
				_tmp36_ = self->priv->query_info_queue;
#line 1156 "../src/DirectoryMonitor.vala"
				gee_collection_remove ((GeeCollection*) _tmp36_, query_info);
#line 4989 "DirectoryMonitor.c"
			}
		}
#line 1129 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 4994 "DirectoryMonitor.c"
	}
	{
		gboolean _tmp37_ = FALSE;
#line 1161 "../src/DirectoryMonitor.vala"
		_tmp37_ = TRUE;
#line 1161 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 5002 "DirectoryMonitor.c"
			DirectoryMonitorQueryInfoQueueElement* next = NULL;
			GeeQueue* _tmp38_;
			gpointer _tmp39_;
			gboolean _tmp40_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp41_;
			DirectoryMonitorQueryInfoQueueElement* n = NULL;
			GeeQueue* _tmp43_;
			gpointer _tmp44_;
			DirectoryMonitorQueryInfoQueueElement* _tmp45_;
			DirectoryMonitorQueryInfoQueueElement* _tmp46_;
			DirectoryMonitorQueryInfoQueueElement* _tmp47_;
			DirectoryMonitorQueryInfoQueueElement* _tmp48_;
			GEnumValue* _tmp49_;
			DirectoryMonitorQueryInfoQueueElement* _tmp50_;
			GFile* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			DirectoryMonitorQueryInfoQueueElement* _tmp56_;
			GError* _tmp57_;
			gboolean _tmp69_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp70_;
			GFileInfo* _tmp71_;
			gboolean _tmp84_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp85_;
			GFileInfo* _tmp86_;
			DirectoryMonitorQueryInfoQueueElement* _tmp97_;
			GFile* _tmp98_;
			DirectoryMonitorQueryInfoQueueElement* _tmp99_;
			GFile* _tmp100_;
			DirectoryMonitorQueryInfoQueueElement* _tmp101_;
			GFileInfo* _tmp102_;
			DirectoryMonitorQueryInfoQueueElement* _tmp103_;
#line 1161 "../src/DirectoryMonitor.vala"
			if (!_tmp37_) {
#line 5039 "DirectoryMonitor.c"
			}
#line 1161 "../src/DirectoryMonitor.vala"
			_tmp37_ = FALSE;
#line 1163 "../src/DirectoryMonitor.vala"
			_tmp38_ = self->priv->query_info_queue;
#line 1163 "../src/DirectoryMonitor.vala"
			_tmp39_ = gee_queue_peek (_tmp38_);
#line 1163 "../src/DirectoryMonitor.vala"
			next = (DirectoryMonitorQueryInfoQueueElement*) _tmp39_;
#line 1164 "../src/DirectoryMonitor.vala"
			_tmp41_ = next;
#line 1164 "../src/DirectoryMonitor.vala"
			if (_tmp41_ == NULL) {
#line 1164 "../src/DirectoryMonitor.vala"
				_tmp40_ = TRUE;
#line 5055 "DirectoryMonitor.c"
			} else {
				DirectoryMonitorQueryInfoQueueElement* _tmp42_;
#line 1164 "../src/DirectoryMonitor.vala"
				_tmp42_ = next;
#line 1164 "../src/DirectoryMonitor.vala"
				_tmp40_ = !_tmp42_->completed;
#line 5062 "DirectoryMonitor.c"
			}
#line 1164 "../src/DirectoryMonitor.vala"
			if (_tmp40_) {
#line 1165 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1165 "../src/DirectoryMonitor.vala"
				break;
#line 5070 "DirectoryMonitor.c"
			}
#line 1168 "../src/DirectoryMonitor.vala"
			_tmp43_ = self->priv->query_info_queue;
#line 1168 "../src/DirectoryMonitor.vala"
			_tmp44_ = gee_queue_poll (_tmp43_);
#line 1168 "../src/DirectoryMonitor.vala"
			n = (DirectoryMonitorQueryInfoQueueElement*) _tmp44_;
#line 1169 "../src/DirectoryMonitor.vala"
			_tmp45_ = next;
#line 1169 "../src/DirectoryMonitor.vala"
			_tmp46_ = n;
#line 1169 "../src/DirectoryMonitor.vala"
			_vala_assert (_tmp45_ == _tmp46_, "next == n");
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp47_ = next;
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp48_ = next;
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp49_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp48_->event);
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp50_ = next;
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp51_ = _tmp50_->file;
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp52_ = g_file_get_path (_tmp51_);
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp53_ = _tmp52_;
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp54_ = g_strdup_printf ("Completed info query %u for %s on %s", _tmp47_->position, (_tmp49_ != NULL) ? _tmp49_->value_name : NULL, _tmp53_);
#line 1171 "../src/DirectoryMonitor.vala"
			_tmp55_ = _tmp54_;
#line 1171 "../src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp55_);
#line 1171 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp55_);
#line 1171 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp53_);
#line 1174 "../src/DirectoryMonitor.vala"
			_tmp56_ = next;
#line 1174 "../src/DirectoryMonitor.vala"
			_tmp57_ = _tmp56_->err;
#line 1174 "../src/DirectoryMonitor.vala"
			if (_tmp57_ != NULL) {
#line 5114 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp58_;
				GFile* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				DirectoryMonitorQueryInfoQueueElement* _tmp62_;
				GEnumValue* _tmp63_;
				DirectoryMonitorQueryInfoQueueElement* _tmp64_;
				GError* _tmp65_;
				const gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp58_ = next;
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp59_ = _tmp58_->file;
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp60_ = g_file_get_path (_tmp59_);
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp61_ = _tmp60_;
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp62_ = next;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp63_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp62_->event);
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp64_ = next;
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp65_ = _tmp64_->err;
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp66_ = _tmp65_->message;
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp67_ = g_strdup_printf ("Unable to retrieve file information for %s, dropping %s: %s", _tmp61_, (_tmp63_ != NULL) ? _tmp63_->value_name : NULL, _tmp66_);
#line 1175 "../src/DirectoryMonitor.vala"
				_tmp68_ = _tmp67_;
#line 1175 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp68_);
#line 1175 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp68_);
#line 1175 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp61_);
#line 1178 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1178 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1178 "../src/DirectoryMonitor.vala"
				continue;
#line 5160 "DirectoryMonitor.c"
			}
#line 1182 "../src/DirectoryMonitor.vala"
			_tmp70_ = next;
#line 1182 "../src/DirectoryMonitor.vala"
			_tmp71_ = _tmp70_->info;
#line 1182 "../src/DirectoryMonitor.vala"
			if (_tmp71_ != NULL) {
#line 5168 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp72_;
				GFileInfo* _tmp73_;
				gchar* _tmp74_;
				gchar* _tmp75_;
#line 1182 "../src/DirectoryMonitor.vala"
				_tmp72_ = next;
#line 1182 "../src/DirectoryMonitor.vala"
				_tmp73_ = _tmp72_->info;
#line 1182 "../src/DirectoryMonitor.vala"
				_tmp74_ = get_file_info_id (_tmp73_);
#line 1182 "../src/DirectoryMonitor.vala"
				_tmp75_ = _tmp74_;
#line 1182 "../src/DirectoryMonitor.vala"
				_tmp69_ = _tmp75_ == NULL;
#line 1182 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp75_);
#line 5185 "DirectoryMonitor.c"
			} else {
#line 1182 "../src/DirectoryMonitor.vala"
				_tmp69_ = FALSE;
#line 5189 "DirectoryMonitor.c"
			}
#line 1182 "../src/DirectoryMonitor.vala"
			if (_tmp69_) {
#line 5193 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp76_;
				GFile* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
				DirectoryMonitorQueryInfoQueueElement* _tmp80_;
				GEnumValue* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp76_ = next;
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp77_ = _tmp76_->file;
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp78_ = g_file_get_path (_tmp77_);
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp79_ = _tmp78_;
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp80_ = next;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp81_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp80_->event);
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp82_ = g_strdup_printf ("Unable to retrieve file ID for %s, dropping %s", _tmp79_, (_tmp81_ != NULL) ? _tmp81_->value_name : NULL);
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp83_ = _tmp82_;
#line 1183 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp83_);
#line 1183 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp83_);
#line 1183 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp79_);
#line 1186 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1186 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1186 "../src/DirectoryMonitor.vala"
				continue;
#line 5230 "DirectoryMonitor.c"
			}
#line 1190 "../src/DirectoryMonitor.vala"
			_tmp85_ = next;
#line 1190 "../src/DirectoryMonitor.vala"
			_tmp86_ = _tmp85_->info;
#line 1190 "../src/DirectoryMonitor.vala"
			if (_tmp86_ != NULL) {
#line 5238 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp87_;
				GFileInfo* _tmp88_;
#line 1190 "../src/DirectoryMonitor.vala"
				_tmp87_ = next;
#line 1190 "../src/DirectoryMonitor.vala"
				_tmp88_ = _tmp87_->info;
#line 1190 "../src/DirectoryMonitor.vala"
				_tmp84_ = !directory_monitor_is_file_symlink_supported (_tmp88_);
#line 5247 "DirectoryMonitor.c"
			} else {
#line 1190 "../src/DirectoryMonitor.vala"
				_tmp84_ = FALSE;
#line 5251 "DirectoryMonitor.c"
			}
#line 1190 "../src/DirectoryMonitor.vala"
			if (_tmp84_) {
#line 5255 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp89_;
				GFile* _tmp90_;
				gchar* _tmp91_;
				gchar* _tmp92_;
				DirectoryMonitorQueryInfoQueueElement* _tmp93_;
				GEnumValue* _tmp94_;
				gchar* _tmp95_;
				gchar* _tmp96_;
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp89_ = next;
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp90_ = _tmp89_->file;
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp91_ = g_file_get_path (_tmp90_);
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp92_ = _tmp91_;
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp93_ = next;
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp94_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp93_->event);
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp95_ = g_strdup_printf ("No symlink support for %s, dropping %s", _tmp92_, (_tmp94_ != NULL) ? _tmp94_->value_name : NULL);
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp96_ = _tmp95_;
#line 1191 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp96_);
#line 1191 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp96_);
#line 1191 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp92_);
#line 1194 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1194 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1194 "../src/DirectoryMonitor.vala"
				continue;
#line 5292 "DirectoryMonitor.c"
			}
#line 1197 "../src/DirectoryMonitor.vala"
			_tmp97_ = next;
#line 1197 "../src/DirectoryMonitor.vala"
			_tmp98_ = _tmp97_->file;
#line 1197 "../src/DirectoryMonitor.vala"
			_tmp99_ = next;
#line 1197 "../src/DirectoryMonitor.vala"
			_tmp100_ = _tmp99_->other_file;
#line 1197 "../src/DirectoryMonitor.vala"
			_tmp101_ = next;
#line 1197 "../src/DirectoryMonitor.vala"
			_tmp102_ = _tmp101_->info;
#line 1197 "../src/DirectoryMonitor.vala"
			_tmp103_ = next;
#line 1197 "../src/DirectoryMonitor.vala"
			directory_monitor_on_monitor_notification_ready (self, _tmp98_, _tmp100_, _tmp102_, _tmp103_->event);
#line 1161 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (n);
#line 1161 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (next);
#line 5314 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self,
                                                 GFile* file,
                                                 GFile* other_file,
                                                 GFileInfo* info,
                                                 GFileMonitorEvent event)
{
	gchar* _tmp0_ = NULL;
	GEnumValue* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 1201 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1201 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 1204 "../src/DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 5338 "DirectoryMonitor.c"
		gchar* _tmp1_;
#line 1204 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (other_file);
#line 1204 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1204 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp1_;
#line 5346 "DirectoryMonitor.c"
	} else {
		gchar* _tmp2_;
#line 1204 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_strdup ("(null)");
#line 1204 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1204 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp2_;
#line 5355 "DirectoryMonitor.c"
	}
#line 1203 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1203 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (file);
#line 1203 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 1203 "../src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("READY %s: file=%s other_file=%s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL, _tmp5_, _tmp0_);
#line 1203 "../src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 1203 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 1203 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 1203 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 1208 "../src/DirectoryMonitor.vala"
	switch (event) {
#line 1208 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 5377 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
#line 1210 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1212 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1213 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1213 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5388 "DirectoryMonitor.c"
				{
#line 1215 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_created (self, file, info);
#line 1216 "../src/DirectoryMonitor.vala"
					break;
#line 5394 "DirectoryMonitor.c"
				}
#line 1213 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5398 "DirectoryMonitor.c"
				{
					gint _tmp8_;
#line 1223 "../src/DirectoryMonitor.vala"
					_tmp8_ = self->priv->outstanding_exploration_dirs;
#line 1223 "../src/DirectoryMonitor.vala"
					self->priv->outstanding_exploration_dirs = _tmp8_ + 1;
#line 1224 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (self, file, info, FALSE, NULL, NULL);
#line 1225 "../src/DirectoryMonitor.vala"
					break;
#line 5409 "DirectoryMonitor.c"
				}
				default:
				{
#line 1228 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1229 "../src/DirectoryMonitor.vala"
					break;
#line 5417 "DirectoryMonitor.c"
				}
			}
#line 1231 "../src/DirectoryMonitor.vala"
			break;
#line 5422 "DirectoryMonitor.c"
		}
#line 1208 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 5426 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp15_;
#line 1235 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1237 "../src/DirectoryMonitor.vala"
			_tmp9_ = directory_monitor_get_file_info (self, file);
#line 1237 "../src/DirectoryMonitor.vala"
			local_info = _tmp9_;
#line 1238 "../src/DirectoryMonitor.vala"
			_tmp10_ = local_info;
#line 1238 "../src/DirectoryMonitor.vala"
			if (_tmp10_ == NULL) {
#line 5443 "DirectoryMonitor.c"
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 1239 "../src/DirectoryMonitor.vala"
				_tmp11_ = g_file_get_path (file);
#line 1239 "../src/DirectoryMonitor.vala"
				_tmp12_ = _tmp11_;
#line 1239 "../src/DirectoryMonitor.vala"
				_tmp13_ = g_strdup_printf ("Changed event for unknown file %s", _tmp12_);
#line 1239 "../src/DirectoryMonitor.vala"
				_tmp14_ = _tmp13_;
#line 1239 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp14_);
#line 1239 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp14_);
#line 1239 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp12_);
#line 1241 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1241 "../src/DirectoryMonitor.vala"
				break;
#line 5466 "DirectoryMonitor.c"
			}
#line 1244 "../src/DirectoryMonitor.vala"
			_tmp15_ = local_info;
#line 1244 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp15_);
#line 1245 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1245 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5476 "DirectoryMonitor.c"
				{
#line 1247 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_file_altered (self, file);
#line 1248 "../src/DirectoryMonitor.vala"
					break;
#line 5482 "DirectoryMonitor.c"
				}
#line 1245 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5486 "DirectoryMonitor.c"
				{
#line 1251 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_altered (self, file);
#line 1252 "../src/DirectoryMonitor.vala"
					break;
#line 5492 "DirectoryMonitor.c"
				}
				default:
				{
#line 1255 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1256 "../src/DirectoryMonitor.vala"
					break;
#line 5500 "DirectoryMonitor.c"
				}
			}
#line 1258 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1258 "../src/DirectoryMonitor.vala"
			break;
#line 5507 "DirectoryMonitor.c"
		}
#line 1208 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 5511 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
#line 1261 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1263 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1264 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1264 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5522 "DirectoryMonitor.c"
				{
#line 1266 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_alteration_completed (self, file, info);
#line 1267 "../src/DirectoryMonitor.vala"
					break;
#line 5528 "DirectoryMonitor.c"
				}
#line 1264 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5532 "DirectoryMonitor.c"
				{
#line 1270 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_alteration_completed (self, file, info);
#line 1271 "../src/DirectoryMonitor.vala"
					break;
#line 5538 "DirectoryMonitor.c"
				}
				default:
				{
#line 1274 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1275 "../src/DirectoryMonitor.vala"
					break;
#line 5546 "DirectoryMonitor.c"
				}
			}
#line 1277 "../src/DirectoryMonitor.vala"
			break;
#line 5551 "DirectoryMonitor.c"
		}
#line 1208 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 5555 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
#line 1280 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1281 "../src/DirectoryMonitor.vala"
			_vala_assert (other_file != NULL, "other_file != null");
#line 1285 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1286 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1286 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5568 "DirectoryMonitor.c"
				{
#line 1288 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_moved (self, file, other_file, info);
#line 1289 "../src/DirectoryMonitor.vala"
					break;
#line 5574 "DirectoryMonitor.c"
				}
#line 1286 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5578 "DirectoryMonitor.c"
				{
					GFileInfo* old_dir_info = NULL;
					DirectoryMonitorFileInfoMap* _tmp16_;
					GFileInfo* _tmp17_;
					GFileInfo* _tmp18_;
					GFileInfo* _tmp21_;
#line 1293 "../src/DirectoryMonitor.vala"
					_tmp16_ = self->priv->files;
#line 1293 "../src/DirectoryMonitor.vala"
					_tmp17_ = directory_monitor_file_info_map_get_info (_tmp16_, file);
#line 1293 "../src/DirectoryMonitor.vala"
					old_dir_info = _tmp17_;
#line 1294 "../src/DirectoryMonitor.vala"
					_tmp18_ = old_dir_info;
#line 1294 "../src/DirectoryMonitor.vala"
					if (_tmp18_ == NULL) {
#line 5595 "DirectoryMonitor.c"
						gchar* _tmp19_;
						gchar* _tmp20_;
#line 1295 "../src/DirectoryMonitor.vala"
						_tmp19_ = g_file_get_path (file);
#line 1295 "../src/DirectoryMonitor.vala"
						_tmp20_ = _tmp19_;
#line 1295 "../src/DirectoryMonitor.vala"
						g_warning ("DirectoryMonitor.vala:1295: Directory moved event for unknown file %s", _tmp20_);
#line 1295 "../src/DirectoryMonitor.vala"
						_g_free0 (_tmp20_);
#line 1297 "../src/DirectoryMonitor.vala"
						_g_object_unref0 (old_dir_info);
#line 1297 "../src/DirectoryMonitor.vala"
						break;
#line 5610 "DirectoryMonitor.c"
					}
#line 1300 "../src/DirectoryMonitor.vala"
					_tmp21_ = old_dir_info;
#line 1300 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_moved (self, file, _tmp21_, other_file, info);
#line 1301 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (old_dir_info);
#line 1301 "../src/DirectoryMonitor.vala"
					break;
#line 5620 "DirectoryMonitor.c"
				}
				default:
				{
#line 1304 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1305 "../src/DirectoryMonitor.vala"
					break;
#line 5628 "DirectoryMonitor.c"
				}
			}
#line 1307 "../src/DirectoryMonitor.vala"
			break;
#line 5633 "DirectoryMonitor.c"
		}
#line 1208 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 5637 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp22_;
			GFileInfo* _tmp23_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp26_;
#line 1310 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1312 "../src/DirectoryMonitor.vala"
			_tmp22_ = directory_monitor_get_file_info (self, file);
#line 1312 "../src/DirectoryMonitor.vala"
			local_info = _tmp22_;
#line 1313 "../src/DirectoryMonitor.vala"
			_tmp23_ = local_info;
#line 1313 "../src/DirectoryMonitor.vala"
			if (_tmp23_ == NULL) {
#line 5654 "DirectoryMonitor.c"
				gchar* _tmp24_;
				gchar* _tmp25_;
#line 1314 "../src/DirectoryMonitor.vala"
				_tmp24_ = g_file_get_path (file);
#line 1314 "../src/DirectoryMonitor.vala"
				_tmp25_ = _tmp24_;
#line 1314 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1314: Deleted event for unknown file %s", _tmp25_);
#line 1314 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp25_);
#line 1316 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1316 "../src/DirectoryMonitor.vala"
				break;
#line 5669 "DirectoryMonitor.c"
			}
#line 1319 "../src/DirectoryMonitor.vala"
			_tmp26_ = local_info;
#line 1319 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp26_);
#line 1320 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1320 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5679 "DirectoryMonitor.c"
				{
#line 1322 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_deleted (self, file);
#line 1323 "../src/DirectoryMonitor.vala"
					break;
#line 5685 "DirectoryMonitor.c"
				}
#line 1320 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5689 "DirectoryMonitor.c"
				{
#line 1326 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_deleted (self, file);
#line 1327 "../src/DirectoryMonitor.vala"
					break;
#line 5695 "DirectoryMonitor.c"
				}
				default:
				{
#line 1330 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1331 "../src/DirectoryMonitor.vala"
					break;
#line 5703 "DirectoryMonitor.c"
				}
			}
#line 1333 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1333 "../src/DirectoryMonitor.vala"
			break;
#line 5710 "DirectoryMonitor.c"
		}
#line 1208 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 5714 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp27_;
			GFileInfo* _tmp28_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp31_;
#line 1337 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1339 "../src/DirectoryMonitor.vala"
			_tmp27_ = directory_monitor_get_file_info (self, file);
#line 1339 "../src/DirectoryMonitor.vala"
			local_info = _tmp27_;
#line 1340 "../src/DirectoryMonitor.vala"
			_tmp28_ = local_info;
#line 1340 "../src/DirectoryMonitor.vala"
			if (_tmp28_ == NULL) {
#line 5731 "DirectoryMonitor.c"
				gchar* _tmp29_;
				gchar* _tmp30_;
#line 1341 "../src/DirectoryMonitor.vala"
				_tmp29_ = g_file_get_path (file);
#line 1341 "../src/DirectoryMonitor.vala"
				_tmp30_ = _tmp29_;
#line 1341 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1341: Attribute changed event for unknown file %" \
"s", _tmp30_);
#line 1341 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp30_);
#line 1343 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1343 "../src/DirectoryMonitor.vala"
				break;
#line 5746 "DirectoryMonitor.c"
			}
#line 1346 "../src/DirectoryMonitor.vala"
			_tmp31_ = local_info;
#line 1346 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp31_);
#line 1347 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1347 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5756 "DirectoryMonitor.c"
				{
#line 1349 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_file_attributes_altered (self, file);
#line 1350 "../src/DirectoryMonitor.vala"
					break;
#line 5762 "DirectoryMonitor.c"
				}
#line 1347 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5766 "DirectoryMonitor.c"
				{
#line 1353 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_attributes_altered (self, file);
#line 1354 "../src/DirectoryMonitor.vala"
					break;
#line 5772 "DirectoryMonitor.c"
				}
				default:
				{
#line 1357 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1358 "../src/DirectoryMonitor.vala"
					break;
#line 5780 "DirectoryMonitor.c"
				}
			}
#line 1360 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1360 "../src/DirectoryMonitor.vala"
			break;
#line 5787 "DirectoryMonitor.c"
		}
#line 1208 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_PRE_UNMOUNT:
#line 1208 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_UNMOUNTED:
#line 5793 "DirectoryMonitor.c"
		{
#line 1365 "../src/DirectoryMonitor.vala"
			break;
#line 5797 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp32_;
#line 1368 "../src/DirectoryMonitor.vala"
			_tmp32_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1368 "../src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:1368: Unknown directory monitor event %s", (_tmp32_ != NULL) ? _tmp32_->value_name : NULL);
#line 1369 "../src/DirectoryMonitor.vala"
			break;
#line 5808 "DirectoryMonitor.c"
		}
	}
#line 1201 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 5813 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_is_file_create_move (DirectoryMonitor* self,
                                       GFile* file,
                                       GFileInfo* info,
                                       GFile** old_file,
                                       GFileInfo** old_file_info)
{
	GFile* _vala_old_file = NULL;
	GFileInfo* _vala_old_file_info = NULL;
	GFile* match = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean result;
#line 1375 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1375 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1375 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 1378 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->parent_moved;
#line 1378 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_find_match (_tmp0_, info);
#line 1378 "../src/DirectoryMonitor.vala"
	match = _tmp1_;
#line 1379 "../src/DirectoryMonitor.vala"
	_tmp2_ = match;
#line 1379 "../src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 5846 "DirectoryMonitor.c"
		GFile* _tmp3_;
		GFile* _tmp4_;
		DirectoryMonitorFileInfoMap* _tmp5_;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
		DirectoryMonitorFileInfoMap* _tmp8_;
		GFile* _tmp9_;
#line 1380 "../src/DirectoryMonitor.vala"
		_tmp3_ = match;
#line 1380 "../src/DirectoryMonitor.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 1380 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 1380 "../src/DirectoryMonitor.vala"
		_vala_old_file = _tmp4_;
#line 1381 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->parent_moved;
#line 1381 "../src/DirectoryMonitor.vala"
		_tmp6_ = match;
#line 1381 "../src/DirectoryMonitor.vala"
		_tmp7_ = directory_monitor_file_info_map_get_info (_tmp5_, _tmp6_);
#line 1381 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 1381 "../src/DirectoryMonitor.vala"
		_vala_old_file_info = _tmp7_;
#line 1383 "../src/DirectoryMonitor.vala"
		_tmp8_ = self->priv->parent_moved;
#line 1383 "../src/DirectoryMonitor.vala"
		_tmp9_ = match;
#line 1383 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_tmp8_, _tmp9_, info);
#line 1385 "../src/DirectoryMonitor.vala"
		result = TRUE;
#line 1385 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 1385 "../src/DirectoryMonitor.vala"
		if (old_file) {
#line 1385 "../src/DirectoryMonitor.vala"
			*old_file = _vala_old_file;
#line 5886 "DirectoryMonitor.c"
		} else {
#line 1385 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file);
#line 5890 "DirectoryMonitor.c"
		}
#line 1385 "../src/DirectoryMonitor.vala"
		if (old_file_info) {
#line 1385 "../src/DirectoryMonitor.vala"
			*old_file_info = _vala_old_file_info;
#line 5896 "DirectoryMonitor.c"
		} else {
#line 1385 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file_info);
#line 5900 "DirectoryMonitor.c"
		}
#line 1385 "../src/DirectoryMonitor.vala"
		return result;
#line 5904 "DirectoryMonitor.c"
	}
#line 1388 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_old_file);
#line 1388 "../src/DirectoryMonitor.vala"
	_vala_old_file = NULL;
#line 1389 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_old_file_info);
#line 1389 "../src/DirectoryMonitor.vala"
	_vala_old_file_info = NULL;
#line 1391 "../src/DirectoryMonitor.vala"
	result = FALSE;
#line 1391 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (match);
#line 1391 "../src/DirectoryMonitor.vala"
	if (old_file) {
#line 1391 "../src/DirectoryMonitor.vala"
		*old_file = _vala_old_file;
#line 5922 "DirectoryMonitor.c"
	} else {
#line 1391 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 5926 "DirectoryMonitor.c"
	}
#line 1391 "../src/DirectoryMonitor.vala"
	if (old_file_info) {
#line 1391 "../src/DirectoryMonitor.vala"
		*old_file_info = _vala_old_file_info;
#line 5932 "DirectoryMonitor.c"
	} else {
#line 1391 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 5936 "DirectoryMonitor.c"
	}
#line 1391 "../src/DirectoryMonitor.vala"
	return result;
#line 5940 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self)
{
	gint64 expiration = 0LL;
	gboolean any_deleted = FALSE;
	gboolean any_expired = FALSE;
	gboolean result;
#line 1394 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1395 "../src/DirectoryMonitor.vala"
	expiration = now_ms () - DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC;
#line 1397 "../src/DirectoryMonitor.vala"
	any_deleted = FALSE;
#line 1398 "../src/DirectoryMonitor.vala"
	any_expired = FALSE;
#line 5958 "DirectoryMonitor.c"
	{
		GeeIterator* _element_it = NULL;
		GeeQueue* _tmp0_;
		GeeIterator* _tmp1_;
#line 1399 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->query_info_queue;
#line 1399 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 1399 "../src/DirectoryMonitor.vala"
		_element_it = _tmp1_;
#line 1399 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 5971 "DirectoryMonitor.c"
			GeeIterator* _tmp2_;
			DirectoryMonitorQueryInfoQueueElement* element = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DirectoryMonitorQueryInfoQueueElement* _tmp5_;
			DirectoryMonitorQueryInfoQueueElement* _tmp6_;
			DirectoryMonitorQueryInfoQueueElement* _tmp7_;
#line 1399 "../src/DirectoryMonitor.vala"
			_tmp2_ = _element_it;
#line 1399 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1399 "../src/DirectoryMonitor.vala"
				break;
#line 5985 "DirectoryMonitor.c"
			}
#line 1399 "../src/DirectoryMonitor.vala"
			_tmp3_ = _element_it;
#line 1399 "../src/DirectoryMonitor.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1399 "../src/DirectoryMonitor.vala"
			element = (DirectoryMonitorQueryInfoQueueElement*) _tmp4_;
#line 1400 "../src/DirectoryMonitor.vala"
			_tmp5_ = element;
#line 1400 "../src/DirectoryMonitor.vala"
			if (_tmp5_->event != G_FILE_MONITOR_EVENT_DELETED) {
#line 1401 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1401 "../src/DirectoryMonitor.vala"
				continue;
#line 6001 "DirectoryMonitor.c"
			}
#line 1403 "../src/DirectoryMonitor.vala"
			any_deleted = TRUE;
#line 1405 "../src/DirectoryMonitor.vala"
			_tmp6_ = element;
#line 1405 "../src/DirectoryMonitor.vala"
			if (_tmp6_->time_created_msec > expiration) {
#line 1406 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1406 "../src/DirectoryMonitor.vala"
				continue;
#line 6013 "DirectoryMonitor.c"
			}
#line 1409 "../src/DirectoryMonitor.vala"
			_tmp7_ = element;
#line 1409 "../src/DirectoryMonitor.vala"
			_tmp7_->completed = TRUE;
#line 1410 "../src/DirectoryMonitor.vala"
			any_expired = TRUE;
#line 1399 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (element);
#line 6023 "DirectoryMonitor.c"
		}
#line 1399 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_element_it);
#line 6027 "DirectoryMonitor.c"
	}
#line 1413 "../src/DirectoryMonitor.vala"
	if (any_expired) {
#line 1414 "../src/DirectoryMonitor.vala"
		directory_monitor_process_query_queue (self, NULL);
#line 6033 "DirectoryMonitor.c"
	}
#line 1416 "../src/DirectoryMonitor.vala"
	if (!any_deleted) {
#line 1417 "../src/DirectoryMonitor.vala"
		self->priv->delete_timer_id = (guint) 0;
#line 6039 "DirectoryMonitor.c"
	}
#line 1419 "../src/DirectoryMonitor.vala"
	result = any_deleted;
#line 1419 "../src/DirectoryMonitor.vala"
	return result;
#line 6045 "DirectoryMonitor.c"
}

GFileInfo*
directory_monitor_get_file_info (DirectoryMonitor* self,
                                 GFile* file)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* result;
#line 1423 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1423 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1424 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1424 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_info (_tmp0_, file);
#line 1424 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 1424 "../src/DirectoryMonitor.vala"
	return result;
#line 6067 "DirectoryMonitor.c"
}

GeeCollection*
directory_monitor_get_files (DirectoryMonitor* self)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 1429 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1430 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1430 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_all (_tmp0_);
#line 1430 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 1430 "../src/DirectoryMonitor.vala"
	return result;
#line 6086 "DirectoryMonitor.c"
}

GFileInfo*
directory_monitor_query_file_info (DirectoryMonitor* self,
                                   GFile* file)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	GCancellable* _tmp1_;
	GFileInfo* _tmp2_;
	GFileInfo* result;
#line 1436 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1436 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1437 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1437 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->cancellable;
#line 1437 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_query_info (_tmp0_, file, _tmp1_);
#line 1437 "../src/DirectoryMonitor.vala"
	result = _tmp2_;
#line 1437 "../src/DirectoryMonitor.vala"
	return result;
#line 6111 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_file_symlink_supported (GFileInfo* info)
{
	DirectoryMonitorFType ftype = 0;
	gboolean result;
#line 1447 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 1448 "../src/DirectoryMonitor.vala"
	if (!g_file_info_get_is_symlink (info)) {
#line 1449 "../src/DirectoryMonitor.vala"
		result = TRUE;
#line 1449 "../src/DirectoryMonitor.vala"
		return result;
#line 6127 "DirectoryMonitor.c"
	}
#line 1451 "../src/DirectoryMonitor.vala"
	ftype = directory_monitor_get_ftype (info);
#line 1452 "../src/DirectoryMonitor.vala"
	switch (ftype) {
#line 1452 "../src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6135 "DirectoryMonitor.c"
		{
#line 1454 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS;
#line 1454 "../src/DirectoryMonitor.vala"
			return result;
#line 6141 "DirectoryMonitor.c"
		}
#line 1452 "../src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6145 "DirectoryMonitor.c"
		{
#line 1457 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS;
#line 1457 "../src/DirectoryMonitor.vala"
			return result;
#line 6151 "DirectoryMonitor.c"
		}
		default:
		{
#line 1460 "../src/DirectoryMonitor.vala"
			_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1462 "../src/DirectoryMonitor.vala"
			result = FALSE;
#line 1462 "../src/DirectoryMonitor.vala"
			return result;
#line 6161 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_real_root_moved (DirectoryMonitor* self,
                                   GFile* old_root,
                                   GFile* new_root,
                                   GFileInfo* new_root_info)
{
#line 392 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_root != NULL);
#line 392 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root != NULL);
#line 392 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root_info != NULL);
#line 6178 "DirectoryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 4);
#line 73 "../src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 73 "../src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 73 "../src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6203 "DirectoryMonitor.c"
	} else {
#line 73 "../src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 73 "../src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6209 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 73 "../src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 6215 "DirectoryMonitor.c"
}

static void
directory_monitor_real_root_deleted (DirectoryMonitor* self,
                                     GFile* root)
{
#line 400 "../src/DirectoryMonitor.vala"
	g_return_if_fail (root != NULL);
#line 6224 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_started (DirectoryMonitor* self)
{
}

static void
directory_monitor_real_file_discovered (DirectoryMonitor* self,
                                        GFile* file,
                                        GFileInfo* info)
{
#line 406 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 406 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6241 "DirectoryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 73 "../src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 73 "../src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 73 "../src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6266 "DirectoryMonitor.c"
	} else {
#line 73 "../src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 73 "../src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6272 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 73 "../src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6278 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_discovered (DirectoryMonitor* self,
                                             GFile* file,
                                             GFileInfo* info)
{
#line 409 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 409 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6290 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_failed (DirectoryMonitor* self,
                                         const gchar* reason)
{
#line 414 "../src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 6299 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_completed (DirectoryMonitor* self)
{
#line 418 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 419 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery completed");
#line 6309 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_created (DirectoryMonitor* self,
                                     GFile* file,
                                     GFileInfo* info)
{
#line 422 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 422 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6321 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_moved (DirectoryMonitor* self,
                                   GFile* old_file,
                                   GFile* new_file,
                                   GFileInfo* new_file_info)
{
#line 425 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_file != NULL);
#line 425 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file != NULL);
#line 425 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file_info != NULL);
#line 6336 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_altered (DirectoryMonitor* self,
                                     GFile* file)
{
#line 429 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 6345 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_alteration_completed (DirectoryMonitor* self,
                                                  GFile* file,
                                                  GFileInfo* info)
{
#line 434 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 434 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6357 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_attributes_altered (DirectoryMonitor* self,
                                                GFile* file)
{
#line 437 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 6366 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_deleted (DirectoryMonitor* self,
                                     GFile* file)
{
#line 440 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 6375 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_created (DirectoryMonitor* self,
                                          GFile* dir,
                                          GFileInfo* info)
{
#line 444 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 444 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6387 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_moved (DirectoryMonitor* self,
                                        GFile* old_dir,
                                        GFile* new_dir,
                                        GFileInfo* new_dir_info)
{
#line 448 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir != NULL);
#line 448 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir != NULL);
#line 448 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir_info != NULL);
#line 6402 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_altered (DirectoryMonitor* self,
                                          GFile* dir)
{
#line 452 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 6411 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self,
                                                       GFile* dir,
                                                       GFileInfo* info)
{
#line 457 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 457 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6423 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self,
                                                     GFile* dir)
{
#line 460 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 6432 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_deleted (DirectoryMonitor* self,
                                          GFile* dir)
{
#line 464 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 6441 "DirectoryMonitor.c"
}

static void
directory_monitor_real_closed (DirectoryMonitor* self)
{
}

static DirectoryMonitorQueryInfoQueueElement*
directory_monitor_query_info_queue_element_construct (GType object_type,
                                                      DirectoryMonitor* owner,
                                                      GFile* file,
                                                      GFile* other_file,
                                                      GFileMonitorEvent event)
{
	DirectoryMonitorQueryInfoQueueElement* self = NULL;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	guint _tmp3_;
#line 109 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 109 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 109 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitorQueryInfoQueueElement*) g_type_create_instance (object_type);
#line 111 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (owner);
#line 111 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 111 "../src/DirectoryMonitor.vala"
	self->owner = _tmp0_;
#line 112 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 112 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 112 "../src/DirectoryMonitor.vala"
	self->file = _tmp1_;
#line 113 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (other_file);
#line 113 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 113 "../src/DirectoryMonitor.vala"
	self->other_file = _tmp2_;
#line 114 "../src/DirectoryMonitor.vala"
	self->event = event;
#line 115 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_query_info_queue_element_current;
#line 115 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_current = _tmp3_ + 1;
#line 115 "../src/DirectoryMonitor.vala"
	self->position = _tmp3_;
#line 116 "../src/DirectoryMonitor.vala"
	self->time_created_msec = now_ms ();
#line 109 "../src/DirectoryMonitor.vala"
	return self;
#line 6497 "DirectoryMonitor.c"
}

static DirectoryMonitorQueryInfoQueueElement*
directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner,
                                                GFile* file,
                                                GFile* other_file,
                                                GFileMonitorEvent event)
{
#line 109 "../src/DirectoryMonitor.vala"
	return directory_monitor_query_info_queue_element_construct (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, owner, file, other_file, event);
#line 6508 "DirectoryMonitor.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 126 "../src/DirectoryMonitor.vala"
	return self ? g_error_copy (self) : NULL;
#line 6516 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self,
                                                         GObject* source,
                                                         GAsyncResult* aresult)
{
	GFile* source_file = NULL;
	GFile* _tmp0_;
	DirectoryMonitor* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 119 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/DirectoryMonitor.vala"
	g_return_if_fail (aresult != NULL);
#line 120 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, g_file_get_type (), GFile));
#line 120 "../src/DirectoryMonitor.vala"
	source_file = _tmp0_;
#line 6536 "DirectoryMonitor.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 124 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_file_query_info_finish (source_file, aresult, &_inner_error0_);
#line 124 "../src/DirectoryMonitor.vala"
		_tmp1_ = _tmp2_;
#line 124 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6547 "DirectoryMonitor.c"
			goto __catch0_g_error;
		}
#line 124 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp1_;
#line 124 "../src/DirectoryMonitor.vala"
		_tmp1_ = NULL;
#line 124 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (self->info);
#line 124 "../src/DirectoryMonitor.vala"
		self->info = _tmp3_;
#line 123 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp1_);
#line 6560 "DirectoryMonitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
		GError* _tmp5_;
#line 123 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 123 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 126 "../src/DirectoryMonitor.vala"
		_tmp4_ = err;
#line 126 "../src/DirectoryMonitor.vala"
		_tmp5_ = _g_error_copy0 (_tmp4_);
#line 126 "../src/DirectoryMonitor.vala"
		_g_error_free0 (self->err);
#line 126 "../src/DirectoryMonitor.vala"
		self->err = _tmp5_;
#line 123 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 6582 "DirectoryMonitor.c"
	}
	__finally0:
#line 123 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (source_file);
#line 123 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 123 "../src/DirectoryMonitor.vala"
		return;
#line 6595 "DirectoryMonitor.c"
	}
#line 130 "../src/DirectoryMonitor.vala"
	self->completed = TRUE;
#line 133 "../src/DirectoryMonitor.vala"
	_tmp6_ = self->owner;
#line 133 "../src/DirectoryMonitor.vala"
	directory_monitor_process_query_queue (_tmp6_, self);
#line 119 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (source_file);
#line 6605 "DirectoryMonitor.c"
}

static void
directory_monitor_value_query_info_queue_element_init (GValue* value)
{
#line 96 "../src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 6613 "DirectoryMonitor.c"
}

static void
directory_monitor_value_query_info_queue_element_free_value (GValue* value)
{
#line 96 "../src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 96 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (value->data[0].v_pointer);
#line 6623 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_query_info_queue_element_copy_value (const GValue* src_value,
                                                             GValue* dest_value)
{
#line 96 "../src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 96 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (src_value->data[0].v_pointer);
#line 6635 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6639 "DirectoryMonitor.c"
	}
}

static gpointer
directory_monitor_value_query_info_queue_element_peek_pointer (const GValue* value)
{
#line 96 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 6648 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_query_info_queue_element_collect_value (GValue* value,
                                                                guint n_collect_values,
                                                                GTypeCValue* collect_values,
                                                                guint collect_flags)
{
#line 96 "../src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 6659 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement * object;
		object = collect_values[0].v_pointer;
#line 96 "../src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 96 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6666 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 96 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6670 "DirectoryMonitor.c"
		}
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (object);
#line 6674 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6678 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	return NULL;
#line 6682 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_query_info_queue_element_lcopy_value (const GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
	DirectoryMonitorQueryInfoQueueElement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 96 "../src/DirectoryMonitor.vala"
	if (!object_p) {
#line 96 "../src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6697 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 96 "../src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 6703 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 96 "../src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 6707 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		*object_p = directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 6711 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	return NULL;
#line 6715 "DirectoryMonitor.c"
}

static GParamSpec*
directory_monitor_param_spec_query_info_queue_element (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags)
{
	DirectoryMonitorParamSpecQueryInfoQueueElement* spec;
#line 96 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 96 "../src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 96 "../src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 96 "../src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 6734 "DirectoryMonitor.c"
}

static gpointer
directory_monitor_value_get_query_info_queue_element (const GValue* value)
{
#line 96 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 96 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 6744 "DirectoryMonitor.c"
}

static void
directory_monitor_value_set_query_info_queue_element (GValue* value,
                                                      gpointer v_object)
{
	DirectoryMonitorQueryInfoQueueElement * old;
#line 96 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 96 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 96 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 96 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 96 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 96 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 6766 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6770 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	if (old) {
#line 96 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 6776 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_take_query_info_queue_element (GValue* value,
                                                       gpointer v_object)
{
	DirectoryMonitorQueryInfoQueueElement * old;
#line 96 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 96 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 96 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 96 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 96 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 6797 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6801 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	if (old) {
#line 96 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 6807 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_query_info_queue_element_class_init (DirectoryMonitorQueryInfoQueueElementClass * klass,
                                                       gpointer klass_data)
{
#line 96 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 96 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorQueryInfoQueueElementClass *) klass)->finalize = directory_monitor_query_info_queue_element_finalize;
#line 6819 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_instance_init (DirectoryMonitorQueryInfoQueueElement * self,
                                                          gpointer klass)
{
#line 105 "../src/DirectoryMonitor.vala"
	self->info = NULL;
#line 106 "../src/DirectoryMonitor.vala"
	self->err = NULL;
#line 107 "../src/DirectoryMonitor.vala"
	self->completed = FALSE;
#line 96 "../src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 6834 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement * obj)
{
	DirectoryMonitorQueryInfoQueueElement * self;
#line 96 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement);
#line 96 "../src/DirectoryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 99 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 100 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 101 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 105 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->info);
#line 106 "../src/DirectoryMonitor.vala"
	_g_error_free0 (self->err);
#line 6855 "DirectoryMonitor.c"
}

static GType
directory_monitor_query_info_queue_element_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_query_info_queue_element_init, directory_monitor_value_query_info_queue_element_free_value, directory_monitor_value_query_info_queue_element_copy_value, directory_monitor_value_query_info_queue_element_peek_pointer, "p", directory_monitor_value_query_info_queue_element_collect_value, "p", directory_monitor_value_query_info_queue_element_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorQueryInfoQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_query_info_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorQueryInfoQueueElement), 0, (GInstanceInitFunc) directory_monitor_query_info_queue_element_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType directory_monitor_query_info_queue_element_type_id;
	directory_monitor_query_info_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorQueryInfoQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return directory_monitor_query_info_queue_element_type_id;
}

static GType
directory_monitor_query_info_queue_element_get_type (void)
{
	static volatile gsize directory_monitor_query_info_queue_element_type_id__once = 0;
	if (g_once_init_enter (&directory_monitor_query_info_queue_element_type_id__once)) {
		GType directory_monitor_query_info_queue_element_type_id;
		directory_monitor_query_info_queue_element_type_id = directory_monitor_query_info_queue_element_get_type_once ();
		g_once_init_leave (&directory_monitor_query_info_queue_element_type_id__once, directory_monitor_query_info_queue_element_type_id);
	}
	return directory_monitor_query_info_queue_element_type_id__once;
}

static gpointer
directory_monitor_query_info_queue_element_ref (gpointer instance)
{
	DirectoryMonitorQueryInfoQueueElement * self;
	self = instance;
#line 96 "../src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 96 "../src/DirectoryMonitor.vala"
	return instance;
#line 6890 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_unref (gpointer instance)
{
	DirectoryMonitorQueryInfoQueueElement * self;
	self = instance;
#line 96 "../src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 96 "../src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 96 "../src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6904 "DirectoryMonitor.c"
	}
}

static inline gpointer
directory_monitor_file_info_map_get_instance_private (DirectoryMonitorFileInfoMap* self)
{
	return G_STRUCT_MEMBER_P (self, DirectoryMonitorFileInfoMap_private_offset);
}

static DirectoryMonitorFileInfoMap*
directory_monitor_file_info_map_construct (GType object_type)
{
	DirectoryMonitorFileInfoMap* self = NULL;
#line 147 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitorFileInfoMap*) g_type_create_instance (object_type);
#line 147 "../src/DirectoryMonitor.vala"
	return self;
#line 6922 "DirectoryMonitor.c"
}

static DirectoryMonitorFileInfoMap*
directory_monitor_file_info_map_new (void)
{
#line 147 "../src/DirectoryMonitor.vala"
	return directory_monitor_file_info_map_construct (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP);
#line 6930 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self,
                                                GFile* file,
                                                GFileInfo* info,
                                                GFile** normalized,
                                                gchar** id)
{
	GFile* _vala_normalized = NULL;
	gchar* _vala_id = NULL;
	GFileInfo* local_info = NULL;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	gchar* file_id = NULL;
	GFileInfo* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	GFile* known_file = NULL;
	GeeHashMap* _tmp8_;
	const gchar* _tmp9_;
	gpointer _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	GFile* _tmp13_ = NULL;
	GFile* _tmp14_;
	GFile* _tmp16_;
	gboolean result;
#line 150 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 150 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 153 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (info);
#line 153 "../src/DirectoryMonitor.vala"
	local_info = _tmp0_;
#line 154 "../src/DirectoryMonitor.vala"
	_tmp1_ = local_info;
#line 154 "../src/DirectoryMonitor.vala"
	if (_tmp1_ == NULL) {
#line 6971 "DirectoryMonitor.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		GFileInfo* _tmp4_;
#line 155 "../src/DirectoryMonitor.vala"
		_tmp2_ = self->priv->map;
#line 155 "../src/DirectoryMonitor.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, file);
#line 155 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 155 "../src/DirectoryMonitor.vala"
		local_info = (GFileInfo*) _tmp3_;
#line 156 "../src/DirectoryMonitor.vala"
		_tmp4_ = local_info;
#line 156 "../src/DirectoryMonitor.vala"
		if (_tmp4_ == NULL) {
#line 157 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 157 "../src/DirectoryMonitor.vala"
			_vala_normalized = NULL;
#line 158 "../src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 158 "../src/DirectoryMonitor.vala"
			_vala_id = NULL;
#line 160 "../src/DirectoryMonitor.vala"
			result = FALSE;
#line 160 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 160 "../src/DirectoryMonitor.vala"
			if (normalized) {
#line 160 "../src/DirectoryMonitor.vala"
				*normalized = _vala_normalized;
#line 7003 "DirectoryMonitor.c"
			} else {
#line 160 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_vala_normalized);
#line 7007 "DirectoryMonitor.c"
			}
#line 160 "../src/DirectoryMonitor.vala"
			if (id) {
#line 160 "../src/DirectoryMonitor.vala"
				*id = _vala_id;
#line 7013 "DirectoryMonitor.c"
			} else {
#line 160 "../src/DirectoryMonitor.vala"
				_g_free0 (_vala_id);
#line 7017 "DirectoryMonitor.c"
			}
#line 160 "../src/DirectoryMonitor.vala"
			return result;
#line 7021 "DirectoryMonitor.c"
		}
	}
#line 164 "../src/DirectoryMonitor.vala"
	_tmp5_ = local_info;
#line 164 "../src/DirectoryMonitor.vala"
	_tmp6_ = get_file_info_id (_tmp5_);
#line 164 "../src/DirectoryMonitor.vala"
	file_id = _tmp6_;
#line 165 "../src/DirectoryMonitor.vala"
	_tmp7_ = file_id;
#line 165 "../src/DirectoryMonitor.vala"
	if (_tmp7_ == NULL) {
#line 166 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 166 "../src/DirectoryMonitor.vala"
		_vala_normalized = NULL;
#line 167 "../src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 167 "../src/DirectoryMonitor.vala"
		_vala_id = NULL;
#line 169 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 169 "../src/DirectoryMonitor.vala"
		_g_free0 (file_id);
#line 169 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 169 "../src/DirectoryMonitor.vala"
		if (normalized) {
#line 169 "../src/DirectoryMonitor.vala"
			*normalized = _vala_normalized;
#line 7052 "DirectoryMonitor.c"
		} else {
#line 169 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 7056 "DirectoryMonitor.c"
		}
#line 169 "../src/DirectoryMonitor.vala"
		if (id) {
#line 169 "../src/DirectoryMonitor.vala"
			*id = _vala_id;
#line 7062 "DirectoryMonitor.c"
		} else {
#line 169 "../src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 7066 "DirectoryMonitor.c"
		}
#line 169 "../src/DirectoryMonitor.vala"
		return result;
#line 7070 "DirectoryMonitor.c"
	}
#line 172 "../src/DirectoryMonitor.vala"
	_tmp8_ = self->priv->id_map;
#line 172 "../src/DirectoryMonitor.vala"
	_tmp9_ = file_id;
#line 172 "../src/DirectoryMonitor.vala"
	_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, _tmp9_);
#line 172 "../src/DirectoryMonitor.vala"
	known_file = (GFile*) _tmp10_;
#line 174 "../src/DirectoryMonitor.vala"
	_tmp11_ = file_id;
#line 174 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup ((const gchar*) _tmp11_);
#line 174 "../src/DirectoryMonitor.vala"
	_g_free0 (_vala_id);
#line 174 "../src/DirectoryMonitor.vala"
	_vala_id = _tmp12_;
#line 175 "../src/DirectoryMonitor.vala"
	_tmp14_ = known_file;
#line 175 "../src/DirectoryMonitor.vala"
	if (_tmp14_ != NULL) {
#line 7092 "DirectoryMonitor.c"
		GFile* _tmp15_;
#line 175 "../src/DirectoryMonitor.vala"
		_tmp15_ = known_file;
#line 175 "../src/DirectoryMonitor.vala"
		_tmp13_ = _tmp15_;
#line 7098 "DirectoryMonitor.c"
	} else {
#line 175 "../src/DirectoryMonitor.vala"
		_tmp13_ = file;
#line 7102 "DirectoryMonitor.c"
	}
#line 175 "../src/DirectoryMonitor.vala"
	_tmp16_ = _g_object_ref0 (_tmp13_);
#line 175 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_normalized);
#line 175 "../src/DirectoryMonitor.vala"
	_vala_normalized = _tmp16_;
#line 177 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 177 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (known_file);
#line 177 "../src/DirectoryMonitor.vala"
	_g_free0 (file_id);
#line 177 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (local_info);
#line 177 "../src/DirectoryMonitor.vala"
	if (normalized) {
#line 177 "../src/DirectoryMonitor.vala"
		*normalized = _vala_normalized;
#line 7122 "DirectoryMonitor.c"
	} else {
#line 177 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 7126 "DirectoryMonitor.c"
	}
#line 177 "../src/DirectoryMonitor.vala"
	if (id) {
#line 177 "../src/DirectoryMonitor.vala"
		*id = _vala_id;
#line 7132 "DirectoryMonitor.c"
	} else {
#line 177 "../src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 7136 "DirectoryMonitor.c"
	}
#line 177 "../src/DirectoryMonitor.vala"
	return result;
#line 7140 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	GeeHashMap* _tmp0_;
	gchar* existing_id = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_;
	GeeHashMap* _tmp12_;
	GFile* _tmp13_;
	GeeHashMap* _tmp14_;
	const gchar* _tmp15_;
	GFile* _tmp16_;
	gboolean result;
#line 180 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 180 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 180 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 182 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 182 "../src/DirectoryMonitor.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, file)) {
#line 7174 "DirectoryMonitor.c"
		gboolean removed = FALSE;
		GeeHashMap* _tmp1_;
#line 183 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->map;
#line 183 "../src/DirectoryMonitor.vala"
		removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, file, NULL);
#line 184 "../src/DirectoryMonitor.vala"
		_vala_assert (removed, "removed");
#line 7183 "DirectoryMonitor.c"
	}
#line 188 "../src/DirectoryMonitor.vala"
	_tmp2_ = get_file_info_id (info);
#line 188 "../src/DirectoryMonitor.vala"
	existing_id = _tmp2_;
#line 189 "../src/DirectoryMonitor.vala"
	_tmp4_ = existing_id;
#line 189 "../src/DirectoryMonitor.vala"
	if (_tmp4_ != NULL) {
#line 7193 "DirectoryMonitor.c"
		GeeHashMap* _tmp5_;
		const gchar* _tmp6_;
#line 189 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->id_map;
#line 189 "../src/DirectoryMonitor.vala"
		_tmp6_ = existing_id;
#line 189 "../src/DirectoryMonitor.vala"
		_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_);
#line 7202 "DirectoryMonitor.c"
	} else {
#line 189 "../src/DirectoryMonitor.vala"
		_tmp3_ = FALSE;
#line 7206 "DirectoryMonitor.c"
	}
#line 189 "../src/DirectoryMonitor.vala"
	if (_tmp3_) {
#line 7210 "DirectoryMonitor.c"
		gboolean removed = FALSE;
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
#line 190 "../src/DirectoryMonitor.vala"
		_tmp7_ = self->priv->id_map;
#line 190 "../src/DirectoryMonitor.vala"
		_tmp8_ = existing_id;
#line 190 "../src/DirectoryMonitor.vala"
		removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, _tmp8_, NULL);
#line 191 "../src/DirectoryMonitor.vala"
		_vala_assert (removed, "removed");
#line 7222 "DirectoryMonitor.c"
	}
#line 196 "../src/DirectoryMonitor.vala"
	_tmp11_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp9_, &_tmp10_);
#line 196 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 196 "../src/DirectoryMonitor.vala"
	normalized = _tmp9_;
#line 196 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 196 "../src/DirectoryMonitor.vala"
	id = _tmp10_;
#line 196 "../src/DirectoryMonitor.vala"
	if (!_tmp11_) {
#line 197 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 197 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 197 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 197 "../src/DirectoryMonitor.vala"
		_g_free0 (existing_id);
#line 197 "../src/DirectoryMonitor.vala"
		return result;
#line 7246 "DirectoryMonitor.c"
	}
#line 199 "../src/DirectoryMonitor.vala"
	_tmp12_ = self->priv->map;
#line 199 "../src/DirectoryMonitor.vala"
	_tmp13_ = normalized;
#line 199 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, info);
#line 200 "../src/DirectoryMonitor.vala"
	_tmp14_ = self->priv->id_map;
#line 200 "../src/DirectoryMonitor.vala"
	_tmp15_ = id;
#line 200 "../src/DirectoryMonitor.vala"
	_tmp16_ = normalized;
#line 200 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, _tmp15_, _tmp16_);
#line 202 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 202 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 202 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 202 "../src/DirectoryMonitor.vala"
	_g_free0 (existing_id);
#line 202 "../src/DirectoryMonitor.vala"
	return result;
#line 7272 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	GeeHashMap* _tmp3_;
	GFile* _tmp4_;
	GeeHashMap* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 205 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 208 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp1_);
#line 208 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 208 "../src/DirectoryMonitor.vala"
	normalized = _tmp0_;
#line 208 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 208 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 208 "../src/DirectoryMonitor.vala"
	if (!_tmp2_) {
#line 209 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 209 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 209 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 209 "../src/DirectoryMonitor.vala"
		return result;
#line 7314 "DirectoryMonitor.c"
	}
#line 211 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->map;
#line 211 "../src/DirectoryMonitor.vala"
	_tmp4_ = normalized;
#line 211 "../src/DirectoryMonitor.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, _tmp4_, NULL);
#line 212 "../src/DirectoryMonitor.vala"
	_tmp5_ = self->priv->id_map;
#line 212 "../src/DirectoryMonitor.vala"
	_tmp6_ = id;
#line 212 "../src/DirectoryMonitor.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, _tmp6_, NULL);
#line 214 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 214 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 214 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 214 "../src/DirectoryMonitor.vala"
	return result;
#line 7336 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self,
                                            GeeCollection* files)
{
#line 219 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/DirectoryMonitor.vala"
	g_return_if_fail (files != NULL);
#line 7347 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeIterator* _tmp0_;
#line 220 "../src/DirectoryMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) files);
#line 220 "../src/DirectoryMonitor.vala"
		_file_it = _tmp0_;
#line 220 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 7357 "DirectoryMonitor.c"
			GeeIterator* _tmp1_;
			GFile* file = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GFile* _tmp4_;
#line 220 "../src/DirectoryMonitor.vala"
			_tmp1_ = _file_it;
#line 220 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 220 "../src/DirectoryMonitor.vala"
				break;
#line 7369 "DirectoryMonitor.c"
			}
#line 220 "../src/DirectoryMonitor.vala"
			_tmp2_ = _file_it;
#line 220 "../src/DirectoryMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 220 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp3_;
#line 221 "../src/DirectoryMonitor.vala"
			_tmp4_ = file;
#line 221 "../src/DirectoryMonitor.vala"
			directory_monitor_file_info_map_remove (self, _tmp4_, NULL);
#line 220 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 7383 "DirectoryMonitor.c"
		}
#line 220 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 7387 "DirectoryMonitor.c"
	}
}

static gboolean
directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self,
                                          GFile* file,
                                          GFileInfo* info)
{
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gboolean result;
#line 224 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 227 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp1_);
#line 227 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 227 "../src/DirectoryMonitor.vala"
	normalized = _tmp0_;
#line 227 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 227 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 227 "../src/DirectoryMonitor.vala"
	if (!_tmp2_) {
#line 228 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 228 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 228 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 228 "../src/DirectoryMonitor.vala"
		return result;
#line 7428 "DirectoryMonitor.c"
	}
#line 230 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->id_map;
#line 230 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 230 "../src/DirectoryMonitor.vala"
	result = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 230 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 230 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 230 "../src/DirectoryMonitor.vala"
	return result;
#line 7442 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_;
	gchar* result;
#line 233 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 235 "../src/DirectoryMonitor.vala"
	if (info != NULL) {
#line 7462 "DirectoryMonitor.c"
		gchar* _tmp0_;
#line 236 "../src/DirectoryMonitor.vala"
		_tmp0_ = get_file_info_id (info);
#line 236 "../src/DirectoryMonitor.vala"
		result = _tmp0_;
#line 236 "../src/DirectoryMonitor.vala"
		return result;
#line 7470 "DirectoryMonitor.c"
	}
#line 240 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp1_, &_tmp2_);
#line 240 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 240 "../src/DirectoryMonitor.vala"
	normalized = _tmp1_;
#line 240 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 240 "../src/DirectoryMonitor.vala"
	id = _tmp2_;
#line 240 "../src/DirectoryMonitor.vala"
	if (!_tmp3_) {
#line 241 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 241 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 241 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 241 "../src/DirectoryMonitor.vala"
		return result;
#line 7492 "DirectoryMonitor.c"
	}
#line 243 "../src/DirectoryMonitor.vala"
	result = id;
#line 243 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 243 "../src/DirectoryMonitor.vala"
	return result;
#line 7500 "DirectoryMonitor.c"
}

static GeeCollection*
directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeCollection* result;
#line 246 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 247 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 247 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 247 "../src/DirectoryMonitor.vala"
	result = (GeeCollection*) _tmp2_;
#line 247 "../src/DirectoryMonitor.vala"
	return result;
#line 7522 "DirectoryMonitor.c"
}

static GFileInfo*
directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self,
                                          GFile* file)
{
	GFileInfo* info = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GFileInfo* _tmp2_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean _tmp5_;
	GeeHashMap* _tmp6_;
	GFile* _tmp7_;
	gpointer _tmp8_;
	GFileInfo* result;
#line 250 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 250 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 252 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 252 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 252 "../src/DirectoryMonitor.vala"
	info = (GFileInfo*) _tmp1_;
#line 253 "../src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 253 "../src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 254 "../src/DirectoryMonitor.vala"
		result = info;
#line 254 "../src/DirectoryMonitor.vala"
		return result;
#line 7560 "DirectoryMonitor.c"
	}
#line 258 "../src/DirectoryMonitor.vala"
	_tmp5_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp3_, &_tmp4_);
#line 258 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 258 "../src/DirectoryMonitor.vala"
	normalized = _tmp3_;
#line 258 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 258 "../src/DirectoryMonitor.vala"
	id = _tmp4_;
#line 258 "../src/DirectoryMonitor.vala"
	if (!_tmp5_) {
#line 259 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 259 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 259 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 259 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 259 "../src/DirectoryMonitor.vala"
		return result;
#line 7584 "DirectoryMonitor.c"
	}
#line 261 "../src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->map;
#line 261 "../src/DirectoryMonitor.vala"
	_tmp7_ = normalized;
#line 261 "../src/DirectoryMonitor.vala"
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
#line 261 "../src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp8_;
#line 261 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 261 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 261 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 261 "../src/DirectoryMonitor.vala"
	return result;
#line 7602 "DirectoryMonitor.c"
}

static GFileInfo*
directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self,
                                            GFile* file,
                                            GCancellable* cancellable)
{
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* _tmp9_;
	gchar* id = NULL;
	GFileInfo* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	GFile* normalized = NULL;
	GeeHashMap* _tmp14_;
	const gchar* _tmp15_;
	gpointer _tmp16_;
	GFile* _tmp17_;
	GeeHashMap* _tmp18_;
	gpointer _tmp19_;
	GError* _inner_error0_ = NULL;
	GFileInfo* result;
#line 264 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 264 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 265 "../src/DirectoryMonitor.vala"
	_tmp0_ = directory_monitor_file_info_map_get_info (self, file);
#line 265 "../src/DirectoryMonitor.vala"
	info = _tmp0_;
#line 266 "../src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 266 "../src/DirectoryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 267 "../src/DirectoryMonitor.vala"
		result = info;
#line 267 "../src/DirectoryMonitor.vala"
		return result;
#line 7644 "DirectoryMonitor.c"
	}
	{
		GFileInfo* _tmp2_ = NULL;
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
#line 272 "../src/DirectoryMonitor.vala"
		_tmp3_ = g_file_query_info (file, G_FILE_ATTRIBUTE_ID_FILE, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, cancellable, &_inner_error0_);
#line 272 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp3_;
#line 272 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7656 "DirectoryMonitor.c"
			goto __catch0_g_error;
		}
#line 272 "../src/DirectoryMonitor.vala"
		_tmp4_ = _tmp2_;
#line 272 "../src/DirectoryMonitor.vala"
		_tmp2_ = NULL;
#line 272 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 272 "../src/DirectoryMonitor.vala"
		info = _tmp4_;
#line 271 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp2_);
#line 7669 "DirectoryMonitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 271 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 271 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 274 "../src/DirectoryMonitor.vala"
		_tmp5_ = g_file_get_path (file);
#line 274 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 274 "../src/DirectoryMonitor.vala"
		_tmp7_ = err;
#line 274 "../src/DirectoryMonitor.vala"
		_tmp8_ = _tmp7_->message;
#line 274 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:274: Unable to query file ID of %s: %s", _tmp6_, _tmp8_);
#line 274 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp6_);
#line 276 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 276 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 276 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 276 "../src/DirectoryMonitor.vala"
		return result;
#line 7703 "DirectoryMonitor.c"
	}
	__finally0:
#line 271 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 271 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 271 "../src/DirectoryMonitor.vala"
		return NULL;
#line 7716 "DirectoryMonitor.c"
	}
#line 279 "../src/DirectoryMonitor.vala"
	_tmp9_ = info;
#line 279 "../src/DirectoryMonitor.vala"
	if (!directory_monitor_is_file_symlink_supported (_tmp9_)) {
#line 280 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 280 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 280 "../src/DirectoryMonitor.vala"
		return result;
#line 7728 "DirectoryMonitor.c"
	}
#line 282 "../src/DirectoryMonitor.vala"
	_tmp10_ = info;
#line 282 "../src/DirectoryMonitor.vala"
	_tmp11_ = g_file_info_get_attribute_string (_tmp10_, G_FILE_ATTRIBUTE_ID_FILE);
#line 282 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 282 "../src/DirectoryMonitor.vala"
	id = _tmp12_;
#line 283 "../src/DirectoryMonitor.vala"
	_tmp13_ = id;
#line 283 "../src/DirectoryMonitor.vala"
	if (_tmp13_ == NULL) {
#line 284 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 284 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 284 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 284 "../src/DirectoryMonitor.vala"
		return result;
#line 7750 "DirectoryMonitor.c"
	}
#line 286 "../src/DirectoryMonitor.vala"
	_tmp14_ = self->priv->id_map;
#line 286 "../src/DirectoryMonitor.vala"
	_tmp15_ = id;
#line 286 "../src/DirectoryMonitor.vala"
	_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 286 "../src/DirectoryMonitor.vala"
	normalized = (GFile*) _tmp16_;
#line 287 "../src/DirectoryMonitor.vala"
	_tmp17_ = normalized;
#line 287 "../src/DirectoryMonitor.vala"
	if (_tmp17_ == NULL) {
#line 288 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 288 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 288 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 288 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 288 "../src/DirectoryMonitor.vala"
		return result;
#line 7774 "DirectoryMonitor.c"
	}
#line 290 "../src/DirectoryMonitor.vala"
	_tmp18_ = self->priv->map;
#line 290 "../src/DirectoryMonitor.vala"
	_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, file);
#line 290 "../src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp19_;
#line 290 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 290 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 290 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 290 "../src/DirectoryMonitor.vala"
	return result;
#line 7790 "DirectoryMonitor.c"
}

static GFile*
directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self,
                                            GFileInfo* match)
{
	gchar* match_id = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gint64 match_size = 0LL;
	gint64 match_time = 0LL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gint64 _tmp4_;
	GFile* result;
#line 293 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 293 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (match != NULL, NULL);
#line 294 "../src/DirectoryMonitor.vala"
	_tmp0_ = get_file_info_id (match);
#line 294 "../src/DirectoryMonitor.vala"
	match_id = _tmp0_;
#line 295 "../src/DirectoryMonitor.vala"
	_tmp1_ = match_id;
#line 295 "../src/DirectoryMonitor.vala"
	if (_tmp1_ == NULL) {
#line 296 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 296 "../src/DirectoryMonitor.vala"
		_g_free0 (match_id);
#line 296 "../src/DirectoryMonitor.vala"
		return result;
#line 7824 "DirectoryMonitor.c"
	}
#line 299 "../src/DirectoryMonitor.vala"
	match_size = g_file_info_get_size (match);
#line 300 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_file_info_get_modification_date_time (match);
#line 300 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 300 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_date_time_to_unix (_tmp3_);
#line 300 "../src/DirectoryMonitor.vala"
	_g_date_time_unref0 (_tmp3_);
#line 300 "../src/DirectoryMonitor.vala"
	match_time = _tmp4_;
#line 7838 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
#line 302 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->map;
#line 302 "../src/DirectoryMonitor.vala"
		_tmp6_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp5_);
#line 302 "../src/DirectoryMonitor.vala"
		_tmp7_ = _tmp6_;
#line 302 "../src/DirectoryMonitor.vala"
		_tmp8_ = _tmp7_;
#line 302 "../src/DirectoryMonitor.vala"
		_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 302 "../src/DirectoryMonitor.vala"
		_tmp10_ = _tmp9_;
#line 302 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp8_);
#line 302 "../src/DirectoryMonitor.vala"
		_file_it = _tmp10_;
#line 302 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 7865 "DirectoryMonitor.c"
			GeeIterator* _tmp11_;
			GFile* file = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			GFileInfo* info = NULL;
			GeeHashMap* _tmp14_;
			GFile* _tmp15_;
			gpointer _tmp16_;
			GFileInfo* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			const gchar* _tmp20_;
			gboolean _tmp21_;
			GFileInfo* _tmp22_;
			GFileInfo* _tmp23_;
			GDateTime* _tmp24_;
			GDateTime* _tmp25_;
			gboolean _tmp26_;
#line 302 "../src/DirectoryMonitor.vala"
			_tmp11_ = _file_it;
#line 302 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 302 "../src/DirectoryMonitor.vala"
				break;
#line 7890 "DirectoryMonitor.c"
			}
#line 302 "../src/DirectoryMonitor.vala"
			_tmp12_ = _file_it;
#line 302 "../src/DirectoryMonitor.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 302 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp13_;
#line 303 "../src/DirectoryMonitor.vala"
			_tmp14_ = self->priv->map;
#line 303 "../src/DirectoryMonitor.vala"
			_tmp15_ = file;
#line 303 "../src/DirectoryMonitor.vala"
			_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 303 "../src/DirectoryMonitor.vala"
			info = (GFileInfo*) _tmp16_;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp17_ = info;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp18_ = get_file_info_id (_tmp17_);
#line 306 "../src/DirectoryMonitor.vala"
			_tmp19_ = _tmp18_;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp20_ = match_id;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp21_ = g_strcmp0 (_tmp19_, _tmp20_) == 0;
#line 306 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp19_);
#line 306 "../src/DirectoryMonitor.vala"
			if (_tmp21_) {
#line 307 "../src/DirectoryMonitor.vala"
				result = file;
#line 307 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 307 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_file_it);
#line 307 "../src/DirectoryMonitor.vala"
				_g_free0 (match_id);
#line 307 "../src/DirectoryMonitor.vala"
				return result;
#line 7930 "DirectoryMonitor.c"
			}
#line 310 "../src/DirectoryMonitor.vala"
			_tmp22_ = info;
#line 310 "../src/DirectoryMonitor.vala"
			if (match_size != g_file_info_get_size (_tmp22_)) {
#line 311 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 311 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 311 "../src/DirectoryMonitor.vala"
				continue;
#line 7942 "DirectoryMonitor.c"
			}
#line 313 "../src/DirectoryMonitor.vala"
			_tmp23_ = info;
#line 313 "../src/DirectoryMonitor.vala"
			_tmp24_ = g_file_info_get_modification_date_time (_tmp23_);
#line 313 "../src/DirectoryMonitor.vala"
			_tmp25_ = _tmp24_;
#line 313 "../src/DirectoryMonitor.vala"
			_tmp26_ = g_date_time_to_unix (_tmp25_) != match_time;
#line 313 "../src/DirectoryMonitor.vala"
			_g_date_time_unref0 (_tmp25_);
#line 313 "../src/DirectoryMonitor.vala"
			if (_tmp26_) {
#line 314 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 314 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 314 "../src/DirectoryMonitor.vala"
				continue;
#line 7962 "DirectoryMonitor.c"
			}
#line 317 "../src/DirectoryMonitor.vala"
			result = file;
#line 317 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (info);
#line 317 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_file_it);
#line 317 "../src/DirectoryMonitor.vala"
			_g_free0 (match_id);
#line 317 "../src/DirectoryMonitor.vala"
			return result;
#line 7974 "DirectoryMonitor.c"
		}
#line 302 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 7978 "DirectoryMonitor.c"
	}
#line 320 "../src/DirectoryMonitor.vala"
	result = NULL;
#line 320 "../src/DirectoryMonitor.vala"
	_g_free0 (match_id);
#line 320 "../src/DirectoryMonitor.vala"
	return result;
#line 7986 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self,
                                                    GFile* root,
                                                    DirectoryMonitorFileInfoMap* descendents)
{
	GeeArrayList* pruned = NULL;
	GeeArrayList* _tmp24_;
#line 323 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/DirectoryMonitor.vala"
	g_return_if_fail (root != NULL);
#line 323 "../src/DirectoryMonitor.vala"
	g_return_if_fail (descendents != NULL);
#line 324 "../src/DirectoryMonitor.vala"
	pruned = NULL;
#line 8004 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 325 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 325 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 325 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 325 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 325 "../src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 325 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 325 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 325 "../src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 325 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8031 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			GFile* file = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GFile* parent = NULL;
			GFile* _tmp9_;
			GFile* _tmp10_;
#line 325 "../src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 325 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 325 "../src/DirectoryMonitor.vala"
				break;
#line 8045 "DirectoryMonitor.c"
			}
#line 325 "../src/DirectoryMonitor.vala"
			_tmp7_ = _file_it;
#line 325 "../src/DirectoryMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 325 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp8_;
#line 326 "../src/DirectoryMonitor.vala"
			_tmp9_ = file;
#line 326 "../src/DirectoryMonitor.vala"
			_tmp10_ = g_file_get_parent (_tmp9_);
#line 326 "../src/DirectoryMonitor.vala"
			parent = _tmp10_;
#line 327 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 8061 "DirectoryMonitor.c"
				GFile* _tmp11_;
				GFile* _tmp12_;
				GFile* _tmp22_;
				GFile* _tmp23_;
#line 327 "../src/DirectoryMonitor.vala"
				_tmp11_ = parent;
#line 327 "../src/DirectoryMonitor.vala"
				if (!(_tmp11_ != NULL)) {
#line 327 "../src/DirectoryMonitor.vala"
					break;
#line 8072 "DirectoryMonitor.c"
				}
#line 328 "../src/DirectoryMonitor.vala"
				_tmp12_ = parent;
#line 328 "../src/DirectoryMonitor.vala"
				if (g_file_equal (_tmp12_, root)) {
#line 8078 "DirectoryMonitor.c"
					GeeArrayList* _tmp13_;
					GeeArrayList* _tmp15_;
					GFile* _tmp16_;
					GFile* _tmp17_;
					GeeHashMap* _tmp18_;
					GFile* _tmp19_;
					gpointer _tmp20_;
					GFileInfo* _tmp21_;
#line 329 "../src/DirectoryMonitor.vala"
					_tmp13_ = pruned;
#line 329 "../src/DirectoryMonitor.vala"
					if (_tmp13_ == NULL) {
#line 8091 "DirectoryMonitor.c"
						GeeArrayList* _tmp14_;
#line 330 "../src/DirectoryMonitor.vala"
						_tmp14_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 330 "../src/DirectoryMonitor.vala"
						_g_object_unref0 (pruned);
#line 330 "../src/DirectoryMonitor.vala"
						pruned = _tmp14_;
#line 8099 "DirectoryMonitor.c"
					}
#line 332 "../src/DirectoryMonitor.vala"
					_tmp15_ = pruned;
#line 332 "../src/DirectoryMonitor.vala"
					_tmp16_ = file;
#line 332 "../src/DirectoryMonitor.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 333 "../src/DirectoryMonitor.vala"
					_tmp17_ = file;
#line 333 "../src/DirectoryMonitor.vala"
					_tmp18_ = self->priv->map;
#line 333 "../src/DirectoryMonitor.vala"
					_tmp19_ = file;
#line 333 "../src/DirectoryMonitor.vala"
					_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, _tmp19_);
#line 333 "../src/DirectoryMonitor.vala"
					_tmp21_ = (GFileInfo*) _tmp20_;
#line 333 "../src/DirectoryMonitor.vala"
					directory_monitor_file_info_map_update (descendents, _tmp17_, _tmp21_);
#line 333 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp21_);
#line 335 "../src/DirectoryMonitor.vala"
					break;
#line 8123 "DirectoryMonitor.c"
				}
#line 338 "../src/DirectoryMonitor.vala"
				_tmp22_ = parent;
#line 338 "../src/DirectoryMonitor.vala"
				_tmp23_ = g_file_get_parent (_tmp22_);
#line 338 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 338 "../src/DirectoryMonitor.vala"
				parent = _tmp23_;
#line 8133 "DirectoryMonitor.c"
			}
#line 325 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 325 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8139 "DirectoryMonitor.c"
		}
#line 325 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8143 "DirectoryMonitor.c"
	}
#line 342 "../src/DirectoryMonitor.vala"
	_tmp24_ = pruned;
#line 342 "../src/DirectoryMonitor.vala"
	if (_tmp24_ != NULL) {
#line 8149 "DirectoryMonitor.c"
		GeeArrayList* _tmp25_;
#line 343 "../src/DirectoryMonitor.vala"
		_tmp25_ = pruned;
#line 343 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_all (self, (GeeCollection*) _tmp25_);
#line 8155 "DirectoryMonitor.c"
	}
#line 323 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (pruned);
#line 8159 "DirectoryMonitor.c"
}

static gint
directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self,
                                              GFile* root,
                                              GeeCollection* files,
                                              GeeCollection* dirs)
{
	gint count = 0;
	gint result;
#line 348 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 348 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (root != NULL, 0);
#line 348 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (files != NULL, 0);
#line 348 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (dirs != NULL, 0);
#line 349 "../src/DirectoryMonitor.vala"
	count = 0;
#line 8180 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 350 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 350 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 350 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 350 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 350 "../src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 350 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 350 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 350 "../src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 350 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8207 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			GFile* file = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GFile* parent = NULL;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gboolean _tmp11_ = FALSE;
			GFile* _tmp12_;
			DirectoryMonitorFType ftype = 0;
			GeeHashMap* _tmp14_;
			GFile* _tmp15_;
			gpointer _tmp16_;
			GFileInfo* _tmp17_;
			DirectoryMonitorFType _tmp18_;
#line 350 "../src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 350 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 350 "../src/DirectoryMonitor.vala"
				break;
#line 8229 "DirectoryMonitor.c"
			}
#line 350 "../src/DirectoryMonitor.vala"
			_tmp7_ = _file_it;
#line 350 "../src/DirectoryMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 350 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp8_;
#line 351 "../src/DirectoryMonitor.vala"
			_tmp9_ = file;
#line 351 "../src/DirectoryMonitor.vala"
			_tmp10_ = g_file_get_parent (_tmp9_);
#line 351 "../src/DirectoryMonitor.vala"
			parent = _tmp10_;
#line 352 "../src/DirectoryMonitor.vala"
			_tmp12_ = parent;
#line 352 "../src/DirectoryMonitor.vala"
			if (_tmp12_ == NULL) {
#line 352 "../src/DirectoryMonitor.vala"
				_tmp11_ = TRUE;
#line 8249 "DirectoryMonitor.c"
			} else {
				GFile* _tmp13_;
#line 352 "../src/DirectoryMonitor.vala"
				_tmp13_ = parent;
#line 352 "../src/DirectoryMonitor.vala"
				_tmp11_ = !g_file_equal (_tmp13_, root);
#line 8256 "DirectoryMonitor.c"
			}
#line 352 "../src/DirectoryMonitor.vala"
			if (_tmp11_) {
#line 353 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 353 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 353 "../src/DirectoryMonitor.vala"
				continue;
#line 8266 "DirectoryMonitor.c"
			}
#line 355 "../src/DirectoryMonitor.vala"
			_tmp14_ = self->priv->map;
#line 355 "../src/DirectoryMonitor.vala"
			_tmp15_ = file;
#line 355 "../src/DirectoryMonitor.vala"
			_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 355 "../src/DirectoryMonitor.vala"
			_tmp17_ = (GFileInfo*) _tmp16_;
#line 355 "../src/DirectoryMonitor.vala"
			_tmp18_ = directory_monitor_get_ftype (_tmp17_);
#line 355 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_tmp17_);
#line 355 "../src/DirectoryMonitor.vala"
			ftype = _tmp18_;
#line 356 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 356 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 8286 "DirectoryMonitor.c"
				{
					GFile* _tmp19_;
					gint _tmp20_;
#line 358 "../src/DirectoryMonitor.vala"
					_tmp19_ = file;
#line 358 "../src/DirectoryMonitor.vala"
					gee_collection_add (files, _tmp19_);
#line 359 "../src/DirectoryMonitor.vala"
					_tmp20_ = count;
#line 359 "../src/DirectoryMonitor.vala"
					count = _tmp20_ + 1;
#line 360 "../src/DirectoryMonitor.vala"
					break;
#line 8300 "DirectoryMonitor.c"
				}
#line 356 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 8304 "DirectoryMonitor.c"
				{
					GFile* _tmp21_;
					gint _tmp22_;
#line 363 "../src/DirectoryMonitor.vala"
					_tmp21_ = file;
#line 363 "../src/DirectoryMonitor.vala"
					gee_collection_add (dirs, _tmp21_);
#line 364 "../src/DirectoryMonitor.vala"
					_tmp22_ = count;
#line 364 "../src/DirectoryMonitor.vala"
					count = _tmp22_ + 1;
#line 365 "../src/DirectoryMonitor.vala"
					break;
#line 8318 "DirectoryMonitor.c"
				}
				default:
				{
#line 368 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 369 "../src/DirectoryMonitor.vala"
					break;
#line 8326 "DirectoryMonitor.c"
				}
			}
#line 350 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 350 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8333 "DirectoryMonitor.c"
		}
#line 350 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8337 "DirectoryMonitor.c"
	}
#line 373 "../src/DirectoryMonitor.vala"
	result = count;
#line 373 "../src/DirectoryMonitor.vala"
	return result;
#line 8343 "DirectoryMonitor.c"
}

static void
directory_monitor_value_file_info_map_init (GValue* value)
{
#line 141 "../src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 8351 "DirectoryMonitor.c"
}

static void
directory_monitor_value_file_info_map_free_value (GValue* value)
{
#line 141 "../src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 141 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (value->data[0].v_pointer);
#line 8361 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_file_info_map_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 141 "../src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 141 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_file_info_map_ref (src_value->data[0].v_pointer);
#line 8373 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8377 "DirectoryMonitor.c"
	}
}

static gpointer
directory_monitor_value_file_info_map_peek_pointer (const GValue* value)
{
#line 141 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 8386 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_file_info_map_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 141 "../src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 8397 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap * object;
		object = collect_values[0].v_pointer;
#line 141 "../src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 141 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8404 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 141 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8408 "DirectoryMonitor.c"
		}
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_file_info_map_ref (object);
#line 8412 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8416 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	return NULL;
#line 8420 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_file_info_map_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	DirectoryMonitorFileInfoMap ** object_p;
	object_p = collect_values[0].v_pointer;
#line 141 "../src/DirectoryMonitor.vala"
	if (!object_p) {
#line 141 "../src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8435 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 141 "../src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 8441 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 141 "../src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 8445 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		*object_p = directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 8449 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	return NULL;
#line 8453 "DirectoryMonitor.c"
}

static GParamSpec*
directory_monitor_param_spec_file_info_map (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	DirectoryMonitorParamSpecFileInfoMap* spec;
#line 141 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 141 "../src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 141 "../src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 141 "../src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 8472 "DirectoryMonitor.c"
}

static gpointer
directory_monitor_value_get_file_info_map (const GValue* value)
{
#line 141 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 141 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 8482 "DirectoryMonitor.c"
}

static void
directory_monitor_value_set_file_info_map (GValue* value,
                                           gpointer v_object)
{
	DirectoryMonitorFileInfoMap * old;
#line 141 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 141 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 141 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 141 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 141 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 141 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 8504 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8508 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	if (old) {
#line 141 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 8514 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_take_file_info_map (GValue* value,
                                            gpointer v_object)
{
	DirectoryMonitorFileInfoMap * old;
#line 141 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 141 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 141 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 141 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 141 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 8535 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8539 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	if (old) {
#line 141 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 8545 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_file_info_map_class_init (DirectoryMonitorFileInfoMapClass * klass,
                                            gpointer klass_data)
{
#line 141 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_parent_class = g_type_class_peek_parent (klass);
#line 141 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorFileInfoMapClass *) klass)->finalize = directory_monitor_file_info_map_finalize;
#line 141 "../src/DirectoryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &DirectoryMonitorFileInfoMap_private_offset);
#line 8559 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_instance_init (DirectoryMonitorFileInfoMap * self,
                                               gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 141 "../src/DirectoryMonitor.vala"
	self->priv = directory_monitor_file_info_map_get_instance_private (self);
#line 142 "../src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 142 "../src/DirectoryMonitor.vala"
	self->priv->map = _tmp0_;
#line 144 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 144 "../src/DirectoryMonitor.vala"
	self->priv->id_map = _tmp1_;
#line 141 "../src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 8580 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap * obj)
{
	DirectoryMonitorFileInfoMap * self;
#line 141 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap);
#line 141 "../src/DirectoryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 142 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->map);
#line 144 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->id_map);
#line 8595 "DirectoryMonitor.c"
}

static GType
directory_monitor_file_info_map_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_file_info_map_init, directory_monitor_value_file_info_map_free_value, directory_monitor_value_file_info_map_copy_value, directory_monitor_value_file_info_map_peek_pointer, "p", directory_monitor_value_file_info_map_collect_value, "p", directory_monitor_value_file_info_map_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_file_info_map_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType directory_monitor_file_info_map_type_id;
	directory_monitor_file_info_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorFileInfoMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
	DirectoryMonitorFileInfoMap_private_offset = g_type_add_instance_private (directory_monitor_file_info_map_type_id, sizeof (DirectoryMonitorFileInfoMapPrivate));
	return directory_monitor_file_info_map_type_id;
}

static GType
directory_monitor_file_info_map_get_type (void)
{
	static volatile gsize directory_monitor_file_info_map_type_id__once = 0;
	if (g_once_init_enter (&directory_monitor_file_info_map_type_id__once)) {
		GType directory_monitor_file_info_map_type_id;
		directory_monitor_file_info_map_type_id = directory_monitor_file_info_map_get_type_once ();
		g_once_init_leave (&directory_monitor_file_info_map_type_id__once, directory_monitor_file_info_map_type_id);
	}
	return directory_monitor_file_info_map_type_id__once;
}

static gpointer
directory_monitor_file_info_map_ref (gpointer instance)
{
	DirectoryMonitorFileInfoMap * self;
	self = instance;
#line 141 "../src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 141 "../src/DirectoryMonitor.vala"
	return instance;
#line 8631 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_unref (gpointer instance)
{
	DirectoryMonitorFileInfoMap * self;
	self = instance;
#line 141 "../src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 141 "../src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->finalize (self);
#line 141 "../src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8645 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_class_init (DirectoryMonitorClass * klass,
                              gpointer klass_data)
{
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_parent_class = g_type_class_peek_parent (klass);
#line 73 "../src/DirectoryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &DirectoryMonitor_private_offset);
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_root_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_root_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_root_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_root_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_started = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_discovery_started;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->internal_notify_file_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_internal_notify_file_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->internal_notify_directory_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_internal_notify_directory_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_failed = (void (*) (DirectoryMonitor*, const gchar*)) directory_monitor_real_notify_discovery_failed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_completed = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_discovery_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_created = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_created;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_alteration_completed = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_alteration_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_attributes_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_attributes_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_created = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_created;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_alteration_completed = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_alteration_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_attributes_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_attributes_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_closed = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_closed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->close = (void (*) (DirectoryMonitor*)) directory_monitor_real_close;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->root_moved = directory_monitor_real_root_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->root_deleted = directory_monitor_real_root_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_started = directory_monitor_real_discovery_started;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_discovered = directory_monitor_real_file_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_discovered = directory_monitor_real_directory_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_failed = directory_monitor_real_discovery_failed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_completed = directory_monitor_real_discovery_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_created = directory_monitor_real_file_created;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_moved = directory_monitor_real_file_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_altered = directory_monitor_real_file_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_alteration_completed = directory_monitor_real_file_alteration_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_attributes_altered = directory_monitor_real_file_attributes_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_deleted = directory_monitor_real_file_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_created = directory_monitor_real_directory_created;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_moved = directory_monitor_real_directory_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_altered = directory_monitor_real_directory_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_alteration_completed = directory_monitor_real_directory_alteration_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_attributes_altered = directory_monitor_real_directory_attributes_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_deleted = directory_monitor_real_directory_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->closed = directory_monitor_real_closed;
#line 73 "../src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = directory_monitor_finalize;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL] = g_signal_new ("root-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL] = g_signal_new ("root-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL] = g_signal_new ("discovery-started", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL] = g_signal_new ("file-discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL] = g_signal_new ("directory-discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL] = g_signal_new ("discovery-failed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_failed), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL] = g_signal_new ("discovery-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_CREATED_SIGNAL] = g_signal_new ("file-created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_MOVED_SIGNAL] = g_signal_new ("file-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL] = g_signal_new ("file-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL] = g_signal_new ("file-alteration-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL] = g_signal_new ("file-attributes-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_DELETED_SIGNAL] = g_signal_new ("file-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL] = g_signal_new ("directory-created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL] = g_signal_new ("directory-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL] = g_signal_new ("directory-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL] = g_signal_new ("directory-alteration-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL] = g_signal_new ("directory-attributes-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL] = g_signal_new ("directory-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_CLOSED_SIGNAL] = g_signal_new ("closed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 8785 "DirectoryMonitor.c"
}

static void
directory_monitor_instance_init (DirectoryMonitor * self,
                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeLinkedList* _tmp1_;
	DirectoryMonitorFileInfoMap* _tmp2_;
	DirectoryMonitorFileInfoMap* _tmp3_;
	GCancellable* _tmp4_;
#line 73 "../src/DirectoryMonitor.vala"
	self->priv = directory_monitor_get_instance_private (self);
#line 380 "../src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_monitor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 380 "../src/DirectoryMonitor.vala"
	self->priv->monitors = _tmp0_;
#line 381 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_linked_list_new (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, (GBoxedCopyFunc) directory_monitor_query_info_queue_element_ref, (GDestroyNotify) directory_monitor_query_info_queue_element_unref, NULL, NULL, NULL);
#line 381 "../src/DirectoryMonitor.vala"
	self->priv->query_info_queue = (GeeQueue*) _tmp1_;
#line 383 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_new ();
#line 383 "../src/DirectoryMonitor.vala"
	self->priv->files = _tmp2_;
#line 384 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_new ();
#line 384 "../src/DirectoryMonitor.vala"
	self->priv->parent_moved = _tmp3_;
#line 385 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_cancellable_new ();
#line 385 "../src/DirectoryMonitor.vala"
	self->priv->cancellable = _tmp4_;
#line 386 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 0;
#line 387 "../src/DirectoryMonitor.vala"
	self->priv->started = FALSE;
#line 388 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 389 "../src/DirectoryMonitor.vala"
	self->priv->delete_timer_id = (guint) 0;
#line 8827 "DirectoryMonitor.c"
}

static void
directory_monitor_finalize (GObject * obj)
{
	DirectoryMonitor * self;
#line 73 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DIRECTORY_MONITOR, DirectoryMonitor);
#line 377 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 380 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->monitors);
#line 381 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->query_info_queue);
#line 383 "../src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->files);
#line 384 "../src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->parent_moved);
#line 385 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 73 "../src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (directory_monitor_parent_class)->finalize (obj);
#line 8850 "DirectoryMonitor.c"
}

static GType
directory_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitor), 0, (GInstanceInitFunc) directory_monitor_instance_init, NULL };
	GType directory_monitor_type_id;
	directory_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DirectoryMonitor", &g_define_type_info, 0);
	DirectoryMonitor_private_offset = g_type_add_instance_private (directory_monitor_type_id, sizeof (DirectoryMonitorPrivate));
	return directory_monitor_type_id;
}

GType
directory_monitor_get_type (void)
{
	static volatile gsize directory_monitor_type_id__once = 0;
	if (g_once_init_enter (&directory_monitor_type_id__once)) {
		GType directory_monitor_type_id;
		directory_monitor_type_id = directory_monitor_get_type_once ();
		g_once_init_leave (&directory_monitor_type_id__once, directory_monitor_type_id);
	}
	return directory_monitor_type_id__once;
}

