/* LibraryMonitor.c generated by valac 0.56.18, the Vala compiler
 * generated from LibraryMonitor.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* LibraryMonitor uses DirectoryMonitor to track assets in the user's library directory and make*/
/* sure they're reflected in the application.*/
/**/
/* NOTE: There appears to be a bug where prior versions of Photos (<= 0.6.x) were not*/
/* properly loading the file modification timestamp during import.  This was no issue*/
/* before but becomes imperative now with file monitoring.  A "proper" algorithm is*/
/* to reimport an entire photo if the modification time in the database is different*/
/* than the file's, but that's Real Bad when the user first turns on monitoring, as it*/
/* will cause a lot of reimports (think of a 10,000 photo database) and will blow away*/
/* ALL transformations, as they are now suspect.*/
/**/
/* So: If the modification time is zero and filesize is the same, simply update the*/
/* timestamp in the database and move on.*/
/**/
/* TODO: Although it seems highly unlikely that a file's timestamp could change but the file size*/
/* has not and the file really be "changed", it *is* possible, even in the case of complex little*/
/* animals like photo files.  We could be more liberal and treat this case as a metadata-changed*/
/* situation (since that's a likely case).*/
/**/

#include "io.elementary.photos.h"
#include <glib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#define LIBRARY_MONITOR_FLUSH_IMPORT_QUEUE_SEC 3
#define LIBRARY_MONITOR_IMPORT_ROLL_QUIET_SEC (5 * 60)
#define LIBRARY_MONITOR_MIN_BLACKLIST_DURATION_MSEC (5 * 1000)
#define LIBRARY_MONITOR_MAX_VERIFY_EXISTING_MEDIA_JOBS 5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
typedef struct _ParamSpecLibraryMonitorPool ParamSpecLibraryMonitorPool;
enum  {
	LIBRARY_MONITOR_POOL_MONITOR_INSTALLED_SIGNAL,
	LIBRARY_MONITOR_POOL_MONITOR_DESTROYED_SIGNAL,
	LIBRARY_MONITOR_POOL_NUM_SIGNALS
};
static guint library_monitor_pool_signals[LIBRARY_MONITOR_POOL_NUM_SIGNALS] = {0};

#define LIBRARY_MONITOR_TYPE_VERIFY_JOB (library_monitor_verify_job_get_type ())
#define LIBRARY_MONITOR_VERIFY_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJob))
#define LIBRARY_MONITOR_VERIFY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJobClass))
#define LIBRARY_MONITOR_IS_VERIFY_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB))
#define LIBRARY_MONITOR_IS_VERIFY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_VERIFY_JOB))
#define LIBRARY_MONITOR_VERIFY_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJobClass))

typedef struct _LibraryMonitorVerifyJob LibraryMonitorVerifyJob;
typedef struct _LibraryMonitorVerifyJobClass LibraryMonitorVerifyJobClass;
enum  {
	LIBRARY_MONITOR_0_PROPERTY,
	LIBRARY_MONITOR_NUM_PROPERTIES
};
static GParamSpec* library_monitor_properties[LIBRARY_MONITOR_NUM_PROPERTIES];
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _batch_import_roll_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_roll_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))

#define LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB (library_monitor_find_move_job_get_type ())
#define LIBRARY_MONITOR_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJob))
#define LIBRARY_MONITOR_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJobClass))
#define LIBRARY_MONITOR_IS_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_IS_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_FIND_MOVE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJobClass))

typedef struct _LibraryMonitorFindMoveJob LibraryMonitorFindMoveJob;
typedef struct _LibraryMonitorFindMoveJobClass LibraryMonitorFindMoveJobClass;
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _LibraryMonitorAsyncDiscoveryCompletedData LibraryMonitorAsyncDiscoveryCompletedData;
typedef struct _LibraryMonitorFindMoveJobPrivate LibraryMonitorFindMoveJobPrivate;
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _library_monitor_verify_job_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_verify_job_unref (var), NULL)))
typedef struct _LibraryMonitorVerifyJobPrivate LibraryMonitorVerifyJobPrivate;
typedef struct _LibraryMonitorVerifyMonitorableData LibraryMonitorVerifyMonitorableData;
#define _batch_import_job_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_job_unref (var), NULL)))
#define _batch_import_result_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_result_unref (var), NULL)))
#define _tombstoned_file_unref0(var) ((var == NULL) ? NULL : (var = (tombstoned_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB (library_monitor_runtime_find_move_job_get_type ())
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJob))
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJobClass))
#define LIBRARY_MONITOR_IS_RUNTIME_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_IS_RUNTIME_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJobClass))

typedef struct _LibraryMonitorRuntimeFindMoveJob LibraryMonitorRuntimeFindMoveJob;
typedef struct _LibraryMonitorRuntimeFindMoveJobClass LibraryMonitorRuntimeFindMoveJobClass;
typedef struct _LibraryMonitorRuntimeFindMoveJobPrivate LibraryMonitorRuntimeFindMoveJobPrivate;
typedef struct _LibraryMonitorParamSpecVerifyJob LibraryMonitorParamSpecVerifyJob;
enum  {
	LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL,
	LIBRARY_MONITOR_AUTO_IMPORT_PREPARING_SIGNAL,
	LIBRARY_MONITOR_AUTO_IMPORT_PROGRESS_SIGNAL,
	LIBRARY_MONITOR_NUM_SIGNALS
};
static guint library_monitor_signals[LIBRARY_MONITOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _LibraryMonitorPoolPrivate {
	LibraryMonitor* monitor;
	guint timer_id;
};

struct _ParamSpecLibraryMonitorPool {
	GParamSpec parent_instance;
};

struct _LibraryMonitorPrivate {
	Workers* workers;
	GCancellable* cancellable;
	gboolean auto_import;
	GeeHashSet* unknown_files;
	GeeList* monitors;
	GeeHashMap* discovered;
	GeeHashSet* import_queue;
	GeeHashSet* pending_imports;
	GeeArrayList* batch_import_queue;
	BatchImportRoll* current_import_roll;
	gint64 last_import_roll_use;
	BatchImport* current_batch_import;
	gint checksums_completed;
	gint checksums_total;
	guint import_queue_timer_id;
	GeeQueue* verify_queue;
	gint outstanding_verify_jobs;
	gint completed_monitorable_verifies;
	gint total_monitorable_verifies;
	GSettings* file_settings;
};

struct _LibraryMonitorAsyncDiscoveryCompletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	LibraryMonitor* self;
	GeeHashSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeArrayList* all_candidates;
	GeeArrayList* _tmp3_;
	GeeArrayList* adopted;
	GeeArrayList* _tmp4_;
	GeeIterator* _file_it;
	GeeHashSet* _tmp5_;
	GeeIterator* _tmp6_;
	GeeIterator* _tmp7_;
	GFile* file;
	GeeIterator* _tmp8_;
	gpointer _tmp9_;
	GFileInfo* info;
	GFile* _tmp10_;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp12_;
	GeeArrayList* _tmp13_;
	GeeCollection* candidates;
	gboolean associated;
	GeeList* _monitor_list;
	GeeList* _tmp14_;
	gint _monitor_size;
	GeeList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _monitor_index;
	gint _tmp18_;
	gint _tmp19_;
	MediaMonitor* monitor;
	GeeList* _tmp20_;
	gpointer _tmp21_;
	MediaMonitorDiscoveredFile _result_;
	MediaMonitor* _tmp22_;
	GFile* _tmp23_;
	GFileInfo* _tmp24_;
	MediaMonitorDiscoveredFile _tmp25_;
	GeeCollection* _tmp26_;
	gboolean _tmp27_;
	GeeCollection* _tmp28_;
	GeeArrayList* _tmp29_;
	GeeCollection* _tmp30_;
	GeeArrayList* _tmp31_;
	GFile* _tmp32_;
	GeeArrayList* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	GeeArrayList* job_candidates;
	GeeArrayList* _tmp36_;
	GeeArrayList* _tmp37_;
	GeeArrayList* _tmp38_;
	gint _tmp39_;
	Workers* _tmp40_;
	GFile* _tmp41_;
	GeeArrayList* _tmp42_;
	LibraryMonitorFindMoveJob* _tmp43_;
	LibraryMonitorFindMoveJob* _tmp44_;
	GeeHashSet* _tmp45_;
	GeeArrayList* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
};

struct _LibraryMonitorFindMoveJob {
	BackgroundJob parent_instance;
	LibraryMonitorFindMoveJobPrivate * priv;
	GFile* file;
	GeeCollection* candidates;
	Monitorable* match;
	GeeArrayList* losers;
	GError* err;
};

struct _LibraryMonitorFindMoveJobClass {
	BackgroundJobClass parent_class;
};

struct _LibraryMonitorVerifyJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LibraryMonitorVerifyJobPrivate * priv;
	Monitorable* monitorable;
	MediaMonitor* monitor;
};

struct _LibraryMonitorVerifyJobClass {
	GTypeClass parent_class;
	void (*finalize) (LibraryMonitorVerifyJob *self);
};

struct _LibraryMonitorVerifyMonitorableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	LibraryMonitor* self;
	Monitorable* monitorable;
	MediaMonitor* monitor;
	GFile** files;
	GFile** _tmp0_;
	gint files_length1;
	gint _files_size_;
	GFile** _tmp1_;
	gint _tmp1__length1;
	GFile* _tmp2_;
	GFile** aux_files;
	gint _tmp3_;
	GFile** _tmp4_;
	gint aux_files_length1;
	gint _aux_files_size_;
	GFile** _tmp5_;
	gint _tmp5__length1;
	GFile** _tmp6_;
	gint _tmp6__length1;
	GFile** aux_file_collection;
	gint aux_file_collection_length1;
	gint _aux_file_collection_size_;
	gint aux_file_it;
	GFile* _tmp7_;
	GFile* aux_file;
	GFile* _tmp8_;
	GFile* _tmp9_;
	gint ctr;
	gboolean _tmp10_;
	gint _tmp11_;
	GFile** _tmp12_;
	gint _tmp12__length1;
	GFile* file;
	GFile** _tmp13_;
	gint _tmp13__length1;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFileInfo* info;
	GFile* _tmp16_;
	GFileInfo* _tmp17_;
	GFileInfo* _tmp18_;
	GFileInfo* _tmp19_;
	GFile* _tmp20_;
	GCancellable* _tmp21_;
	GFileInfo* _tmp22_;
	GFileInfo* _tmp23_;
	gboolean _tmp24_;
	GFileInfo* _tmp25_;
	gboolean _tmp26_;
	GFileInfo* _tmp27_;
	GFile* _tmp28_;
	GFileInfo* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GError* _inner_error0_;
};

struct _LibraryMonitorRuntimeFindMoveJob {
	BackgroundJob parent_instance;
	LibraryMonitorRuntimeFindMoveJobPrivate * priv;
	GFile* file;
	GeeCollection* candidates;
	Monitorable* match;
	GError* err;
};

struct _LibraryMonitorRuntimeFindMoveJobClass {
	BackgroundJobClass parent_class;
};

struct _LibraryMonitorParamSpecVerifyJob {
	GParamSpec parent_instance;
};

static gint LibraryMonitorPool_private_offset;
static gpointer library_monitor_pool_parent_class = NULL;
static LibraryMonitorPool* library_monitor_pool_instance;
static LibraryMonitorPool* library_monitor_pool_instance = NULL;
static gint LibraryMonitor_private_offset;
static gpointer library_monitor_parent_class = NULL;
static GeeHashSet* library_monitor_blacklist;
static GRecMutex __lock_library_monitor_library_monitor_blacklist = {0};
static GeeHashSet* library_monitor_blacklist = NULL;
static HashTimedQueue* library_monitor_to_unblacklist;
static HashTimedQueue* library_monitor_to_unblacklist = NULL;
VALA_EXTERN gboolean commandline_options_no_runtime_monitoring;
static gpointer library_monitor_find_move_job_parent_class = NULL;
static gpointer library_monitor_runtime_find_move_job_parent_class = NULL;
static gpointer library_monitor_verify_job_parent_class = NULL;

static LibraryMonitorPool* library_monitor_pool_new (void);
static LibraryMonitorPool* library_monitor_pool_construct (GType object_type);
static void library_monitor_pool_close (LibraryMonitorPool* self);
static gboolean library_monitor_pool_on_start_monitor (LibraryMonitorPool* self);
static gboolean _library_monitor_pool_on_start_monitor_gsource_func (gpointer self);
static void library_monitor_pool_finalize (LibraryMonitorPool * obj);
static GType library_monitor_pool_get_type_once (void);
static gpointer library_monitor_verify_job_ref (gpointer instance);
static void library_monitor_verify_job_unref (gpointer instance);
static GParamSpec* library_monitor_param_spec_verify_job (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags) G_GNUC_UNUSED ;
static void library_monitor_value_set_verify_job (GValue* value,
                                           gpointer v_object) G_GNUC_UNUSED ;
static void library_monitor_value_take_verify_job (GValue* value,
                                            gpointer v_object) G_GNUC_UNUSED ;
static gpointer library_monitor_value_get_verify_job (const GValue* value) G_GNUC_UNUSED ;
static GType library_monitor_verify_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static void library_monitor_on_unblacklist_file (GFile* file);
static void _library_monitor_on_unblacklist_file_dequeued_callback (gconstpointer item,
                                                             gpointer self);
static void library_monitor_on_config_changed (LibraryMonitor* self,
                                        const gchar* key);
static void _library_monitor_on_config_changed_g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self);
static gboolean library_monitor_on_flush_import_queue (LibraryMonitor* self);
static gboolean _library_monitor_on_flush_import_queue_gsource_func (gpointer self);
static void library_monitor_real_close (DirectoryMonitor* base);
static void library_monitor_add_to_discovered_list (LibraryMonitor* self,
                                             MediaMonitor* monitor,
                                             Monitorable* monitorable);
static MediaMonitor* library_monitor_get_monitor_for_monitorable (LibraryMonitor* self,
                                                           Monitorable* monitorable);
static void library_monitor_real_discovery_started (DirectoryMonitor* base);
static void library_monitor_real_file_discovered (DirectoryMonitor* base,
                                           GFile* file,
                                           GFileInfo* info);
static gboolean library_monitor_is_supported_filetype (LibraryMonitor* self,
                                                GFile* file);
static void library_monitor_real_discovery_completed (DirectoryMonitor* base);
static void library_monitor_async_discovery_completed (LibraryMonitor* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void library_monitor_async_discovery_completed_finish (LibraryMonitor* self,
                                                       GAsyncResult* _res_);
static void library_monitor_async_discovery_completed_data_free (gpointer _data);
static gboolean library_monitor_async_discovery_completed_co (LibraryMonitorAsyncDiscoveryCompletedData* _data_);
static void library_monitor_discovery_stage_completed (LibraryMonitor* self);
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_new (LibraryMonitor* owner,
                                                              GFile* file,
                                                              GeeCollection* candidates);
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_construct (GType object_type,
                                                                    LibraryMonitor* owner,
                                                                    GFile* file,
                                                                    GeeCollection* candidates);
static GType library_monitor_find_move_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gboolean _library_monitor_async_discovery_completed_co_gsource_func (gpointer self);
static void library_monitor_report_checksum_job_completed (LibraryMonitor* self);
static void library_monitor_on_find_move_completed (LibraryMonitor* self,
                                             BackgroundJob* j);
static void library_monitor_on_find_move_cancelled (LibraryMonitor* self,
                                             BackgroundJob* j);
static void library_monitor_enqueue_verify_monitorable (LibraryMonitor* self,
                                                 Monitorable* monitorable,
                                                 MediaMonitor* monitor);
static void library_monitor_enqueue_import_many (LibraryMonitor* self,
                                          GeeCollection* files);
static LibraryMonitorVerifyJob* library_monitor_verify_job_new (Monitorable* monitorable,
                                                         MediaMonitor* monitor);
static LibraryMonitorVerifyJob* library_monitor_verify_job_construct (GType object_type,
                                                               Monitorable* monitorable,
                                                               MediaMonitor* monitor);
static void library_monitor_execute_next_verify_job (LibraryMonitor* self);
static void library_monitor_verify_monitorable (LibraryMonitor* self,
                                         Monitorable* monitorable,
                                         MediaMonitor* monitor,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void library_monitor_verify_monitorable_finish (LibraryMonitor* self,
                                                GAsyncResult* _res_);
static void library_monitor_verify_monitorable_data_free (gpointer _data);
static gboolean library_monitor_verify_monitorable_co (LibraryMonitorVerifyMonitorableData* _data_);
static void _vala_array_add3 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
static void library_monitor_verify_monitorable_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static gboolean _library_monitor_verify_monitorable_co_gsource_func (gpointer self);
static void library_monitor_import_unrepresented_files (LibraryMonitor* self);
static void library_monitor_cancel_batch_imports (LibraryMonitor* self);
static void library_monitor_enqueue_import (LibraryMonitor* self,
                                     GFile* file);
static void library_monitor_remove_queued_import (LibraryMonitor* self,
                                           GFile* file);
static void library_monitor_schedule_next_batch_import (LibraryMonitor* self);
static void library_monitor_on_import_preparing (LibraryMonitor* self);
static void _library_monitor_on_import_preparing_batch_import_preparing (BatchImport* _sender,
                                                                  gpointer self);
static void library_monitor_on_import_progress (LibraryMonitor* self,
                                         guint64 completed_bytes,
                                         guint64 total_bytes);
static void _library_monitor_on_import_progress_batch_import_progress (BatchImport* _sender,
                                                                guint64 completed_bytes,
                                                                guint64 total_bytes,
                                                                gpointer self);
static void library_monitor_on_import_complete (LibraryMonitor* self,
                                         BatchImport* batch_import,
                                         ImportManifest* manifest,
                                         BatchImportRoll* import_roll);
static void _library_monitor_on_import_complete_batch_import_import_complete (BatchImport* _sender,
                                                                       ImportManifest* manifest,
                                                                       BatchImportRoll* import_roll,
                                                                       gpointer self);
static void library_monitor_discard_current_batch_import (LibraryMonitor* self);
static void library_monitor_runtime_unknown_file_discovered (LibraryMonitor* self,
                                                      GFile* file);
static void library_monitor_real_notify_file_created (DirectoryMonitor* base,
                                               GFile* file,
                                               GFileInfo* info);
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_new (LibraryMonitor* owner,
                                                                             GFile* file,
                                                                             GeeCollection* candidates);
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_construct (GType object_type,
                                                                                   LibraryMonitor* owner,
                                                                                   GFile* file,
                                                                                   GeeCollection* candidates);
static GType library_monitor_runtime_find_move_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void library_monitor_on_runtime_find_move_completed (LibraryMonitor* self,
                                                     BackgroundJob* j);
static void library_monitor_real_notify_file_moved (DirectoryMonitor* base,
                                             GFile* old_file,
                                             GFile* new_file,
                                             GFileInfo* new_info);
static void library_monitor_real_notify_file_altered (DirectoryMonitor* base,
                                               GFile* file);
static void library_monitor_real_notify_file_attributes_altered (DirectoryMonitor* base,
                                                          GFile* file);
static void library_monitor_real_notify_file_alteration_completed (DirectoryMonitor* base,
                                                            GFile* file,
                                                            GFileInfo* info);
static void library_monitor_real_notify_file_deleted (DirectoryMonitor* base,
                                               GFile* file);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void _library_monitor_on_find_move_completed_completion_callback (BackgroundJob* job,
                                                                  gpointer self);
static void _library_monitor_on_find_move_cancelled_cancellation_callback (BackgroundJob* job,
                                                                    gpointer self);
static void library_monitor_find_move_job_real_execute (BackgroundJob* base);
static void library_monitor_find_move_job_finalize (BackgroundJob * obj);
static GType library_monitor_find_move_job_get_type_once (void);
static void _library_monitor_on_runtime_find_move_completed_completion_callback (BackgroundJob* job,
                                                                          gpointer self);
static void library_monitor_runtime_find_move_job_real_execute (BackgroundJob* base);
static void library_monitor_runtime_find_move_job_finalize (BackgroundJob * obj);
static GType library_monitor_runtime_find_move_job_get_type_once (void);
static void library_monitor_verify_job_finalize (LibraryMonitorVerifyJob * obj);
static GType library_monitor_verify_job_get_type_once (void);
static GObject * library_monitor_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void library_monitor_finalize (GObject * obj);
static GType library_monitor_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
library_monitor_pool_get_instance_private (LibraryMonitorPool* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryMonitorPool_private_offset);
}

static LibraryMonitorPool*
library_monitor_pool_construct (GType object_type)
{
	LibraryMonitorPool* self = NULL;
#line 51 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorPool*) g_type_create_instance (object_type);
#line 51 "../src/LibraryMonitor.vala"
	return self;
#line 568 "LibraryMonitor.c"
}

static LibraryMonitorPool*
library_monitor_pool_new (void)
{
#line 51 "../src/LibraryMonitor.vala"
	return library_monitor_pool_construct (TYPE_LIBRARY_MONITOR_POOL);
#line 576 "LibraryMonitor.c"
}

void
library_monitor_pool_init (void)
{
}

void
library_monitor_pool_terminate (void)
{
	LibraryMonitorPool* _tmp0_;
#line 58 "../src/LibraryMonitor.vala"
	_tmp0_ = library_monitor_pool_instance;
#line 58 "../src/LibraryMonitor.vala"
	if (_tmp0_ != NULL) {
#line 592 "LibraryMonitor.c"
		LibraryMonitorPool* _tmp1_;
#line 59 "../src/LibraryMonitor.vala"
		_tmp1_ = library_monitor_pool_instance;
#line 59 "../src/LibraryMonitor.vala"
		library_monitor_pool_close (_tmp1_);
#line 598 "LibraryMonitor.c"
	}
#line 61 "../src/LibraryMonitor.vala"
	_library_monitor_pool_unref0 (library_monitor_pool_instance);
#line 61 "../src/LibraryMonitor.vala"
	library_monitor_pool_instance = NULL;
#line 604 "LibraryMonitor.c"
}

static gpointer
_library_monitor_pool_ref0 (gpointer self)
{
#line 68 "../src/LibraryMonitor.vala"
	return self ? library_monitor_pool_ref (self) : NULL;
#line 612 "LibraryMonitor.c"
}

LibraryMonitorPool*
library_monitor_pool_get_instance (void)
{
	LibraryMonitorPool* _tmp0_;
	LibraryMonitorPool* _tmp2_;
	LibraryMonitorPool* _tmp3_;
	LibraryMonitorPool* result;
#line 65 "../src/LibraryMonitor.vala"
	_tmp0_ = library_monitor_pool_instance;
#line 65 "../src/LibraryMonitor.vala"
	if (_tmp0_ == NULL) {
#line 626 "LibraryMonitor.c"
		LibraryMonitorPool* _tmp1_;
#line 66 "../src/LibraryMonitor.vala"
		_tmp1_ = library_monitor_pool_new ();
#line 66 "../src/LibraryMonitor.vala"
		_library_monitor_pool_unref0 (library_monitor_pool_instance);
#line 66 "../src/LibraryMonitor.vala"
		library_monitor_pool_instance = _tmp1_;
#line 634 "LibraryMonitor.c"
	}
#line 68 "../src/LibraryMonitor.vala"
	_tmp2_ = library_monitor_pool_instance;
#line 68 "../src/LibraryMonitor.vala"
	_tmp3_ = _library_monitor_pool_ref0 (_tmp2_);
#line 68 "../src/LibraryMonitor.vala"
	result = _tmp3_;
#line 68 "../src/LibraryMonitor.vala"
	return result;
#line 644 "LibraryMonitor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 72 "../src/LibraryMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 652 "LibraryMonitor.c"
}

LibraryMonitor*
library_monitor_pool_get_monitor (LibraryMonitorPool* self)
{
	LibraryMonitor* _tmp0_;
	LibraryMonitor* _tmp1_;
	LibraryMonitor* result;
#line 71 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->monitor;
#line 72 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 72 "../src/LibraryMonitor.vala"
	result = _tmp1_;
#line 72 "../src/LibraryMonitor.vala"
	return result;
#line 671 "LibraryMonitor.c"
}

static gboolean
_library_monitor_pool_on_start_monitor_gsource_func (gpointer self)
{
	gboolean result;
	result = library_monitor_pool_on_start_monitor ((LibraryMonitorPool*) self);
#line 81 "../src/LibraryMonitor.vala"
	return result;
#line 681 "LibraryMonitor.c"
}

void
library_monitor_pool_replace (LibraryMonitorPool* self,
                              LibraryMonitor* replacement,
                              gint start_msec_delay)
{
	LibraryMonitor* _tmp0_;
	gboolean _tmp1_ = FALSE;
	LibraryMonitor* _tmp2_;
#line 76 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/LibraryMonitor.vala"
	g_return_if_fail (replacement != NULL);
#line 77 "../src/LibraryMonitor.vala"
	library_monitor_pool_close (self);
#line 79 "../src/LibraryMonitor.vala"
	_tmp0_ = _g_object_ref0 (replacement);
#line 79 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 79 "../src/LibraryMonitor.vala"
	self->priv->monitor = _tmp0_;
#line 80 "../src/LibraryMonitor.vala"
	if (start_msec_delay > 0) {
#line 80 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->timer_id == ((guint) 0);
#line 708 "LibraryMonitor.c"
	} else {
#line 80 "../src/LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 712 "LibraryMonitor.c"
	}
#line 80 "../src/LibraryMonitor.vala"
	if (_tmp1_) {
#line 81 "../src/LibraryMonitor.vala"
		self->priv->timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) start_msec_delay, _library_monitor_pool_on_start_monitor_gsource_func, library_monitor_pool_ref (self), library_monitor_pool_unref);
#line 718 "LibraryMonitor.c"
	}
#line 83 "../src/LibraryMonitor.vala"
	_tmp2_ = self->priv->monitor;
#line 83 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_pool_signals[LIBRARY_MONITOR_POOL_MONITOR_INSTALLED_SIGNAL], 0, _tmp2_);
#line 724 "LibraryMonitor.c"
}

static void
library_monitor_pool_close (LibraryMonitorPool* self)
{
	LibraryMonitor* _tmp0_;
	LibraryMonitor* _tmp1_;
	LibraryMonitor* closed = NULL;
	LibraryMonitor* _tmp2_;
	LibraryMonitor* _tmp3_;
	LibraryMonitor* _tmp4_;
#line 86 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->monitor;
#line 87 "../src/LibraryMonitor.vala"
	if (_tmp0_ == NULL) {
#line 88 "../src/LibraryMonitor.vala"
		return;
#line 744 "LibraryMonitor.c"
	}
#line 90 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->monitor;
#line 90 "../src/LibraryMonitor.vala"
	directory_monitor_close ((DirectoryMonitor*) _tmp1_);
#line 91 "../src/LibraryMonitor.vala"
	_tmp2_ = self->priv->monitor;
#line 91 "../src/LibraryMonitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 91 "../src/LibraryMonitor.vala"
	closed = _tmp3_;
#line 92 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 92 "../src/LibraryMonitor.vala"
	self->priv->monitor = NULL;
#line 94 "../src/LibraryMonitor.vala"
	_tmp4_ = closed;
#line 94 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_pool_signals[LIBRARY_MONITOR_POOL_MONITOR_DESTROYED_SIGNAL], 0, _tmp4_);
#line 86 "../src/LibraryMonitor.vala"
	_g_object_unref0 (closed);
#line 766 "LibraryMonitor.c"
}

static gboolean
library_monitor_pool_on_start_monitor (LibraryMonitorPool* self)
{
	LibraryMonitor* _tmp0_;
	LibraryMonitor* _tmp1_;
	gboolean result;
#line 97 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../src/LibraryMonitor.vala"
	self->priv->timer_id = (guint) 0;
#line 101 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->monitor;
#line 101 "../src/LibraryMonitor.vala"
	if (_tmp0_ == NULL) {
#line 102 "../src/LibraryMonitor.vala"
		result = FALSE;
#line 102 "../src/LibraryMonitor.vala"
		return result;
#line 787 "LibraryMonitor.c"
	}
#line 104 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->monitor;
#line 104 "../src/LibraryMonitor.vala"
	directory_monitor_start_discovery ((DirectoryMonitor*) _tmp1_);
#line 106 "../src/LibraryMonitor.vala"
	result = FALSE;
#line 106 "../src/LibraryMonitor.vala"
	return result;
#line 797 "LibraryMonitor.c"
}

static void
value_library_monitor_pool_init (GValue* value)
{
#line 41 "../src/LibraryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 805 "LibraryMonitor.c"
}

static void
value_library_monitor_pool_free_value (GValue* value)
{
#line 41 "../src/LibraryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 41 "../src/LibraryMonitor.vala"
		library_monitor_pool_unref (value->data[0].v_pointer);
#line 815 "LibraryMonitor.c"
	}
}

static void
value_library_monitor_pool_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
#line 41 "../src/LibraryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 41 "../src/LibraryMonitor.vala"
		dest_value->data[0].v_pointer = library_monitor_pool_ref (src_value->data[0].v_pointer);
#line 827 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 831 "LibraryMonitor.c"
	}
}

static gpointer
value_library_monitor_pool_peek_pointer (const GValue* value)
{
#line 41 "../src/LibraryMonitor.vala"
	return value->data[0].v_pointer;
#line 840 "LibraryMonitor.c"
}

static gchar*
value_library_monitor_pool_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
#line 41 "../src/LibraryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 851 "LibraryMonitor.c"
		LibraryMonitorPool * object;
		object = collect_values[0].v_pointer;
#line 41 "../src/LibraryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 41 "../src/LibraryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 858 "LibraryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 41 "../src/LibraryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 862 "LibraryMonitor.c"
		}
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = library_monitor_pool_ref (object);
#line 866 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 870 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	return NULL;
#line 874 "LibraryMonitor.c"
}

static gchar*
value_library_monitor_pool_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	LibraryMonitorPool ** object_p;
	object_p = collect_values[0].v_pointer;
#line 41 "../src/LibraryMonitor.vala"
	if (!object_p) {
#line 41 "../src/LibraryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 889 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 41 "../src/LibraryMonitor.vala"
		*object_p = NULL;
#line 895 "LibraryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 41 "../src/LibraryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 899 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		*object_p = library_monitor_pool_ref (value->data[0].v_pointer);
#line 903 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	return NULL;
#line 907 "LibraryMonitor.c"
}

GParamSpec*
param_spec_library_monitor_pool (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	ParamSpecLibraryMonitorPool* spec;
#line 41 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_LIBRARY_MONITOR_POOL), NULL);
#line 41 "../src/LibraryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 41 "../src/LibraryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 41 "../src/LibraryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 926 "LibraryMonitor.c"
}

gpointer
value_get_library_monitor_pool (const GValue* value)
{
#line 41 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL), NULL);
#line 41 "../src/LibraryMonitor.vala"
	return value->data[0].v_pointer;
#line 936 "LibraryMonitor.c"
}

void
value_set_library_monitor_pool (GValue* value,
                                gpointer v_object)
{
	LibraryMonitorPool * old;
#line 41 "../src/LibraryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL));
#line 41 "../src/LibraryMonitor.vala"
	old = value->data[0].v_pointer;
#line 41 "../src/LibraryMonitor.vala"
	if (v_object) {
#line 41 "../src/LibraryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LIBRARY_MONITOR_POOL));
#line 41 "../src/LibraryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 41 "../src/LibraryMonitor.vala"
		library_monitor_pool_ref (value->data[0].v_pointer);
#line 958 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 962 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	if (old) {
#line 41 "../src/LibraryMonitor.vala"
		library_monitor_pool_unref (old);
#line 968 "LibraryMonitor.c"
	}
}

void
value_take_library_monitor_pool (GValue* value,
                                 gpointer v_object)
{
	LibraryMonitorPool * old;
#line 41 "../src/LibraryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL));
#line 41 "../src/LibraryMonitor.vala"
	old = value->data[0].v_pointer;
#line 41 "../src/LibraryMonitor.vala"
	if (v_object) {
#line 41 "../src/LibraryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LIBRARY_MONITOR_POOL));
#line 41 "../src/LibraryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 989 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 993 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	if (old) {
#line 41 "../src/LibraryMonitor.vala"
		library_monitor_pool_unref (old);
#line 999 "LibraryMonitor.c"
	}
}

static void
library_monitor_pool_class_init (LibraryMonitorPoolClass * klass,
                                 gpointer klass_data)
{
#line 41 "../src/LibraryMonitor.vala"
	library_monitor_pool_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/LibraryMonitor.vala"
	((LibraryMonitorPoolClass *) klass)->finalize = library_monitor_pool_finalize;
#line 41 "../src/LibraryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &LibraryMonitorPool_private_offset);
#line 41 "../src/LibraryMonitor.vala"
	library_monitor_pool_signals[LIBRARY_MONITOR_POOL_MONITOR_INSTALLED_SIGNAL] = g_signal_new ("monitor-installed", TYPE_LIBRARY_MONITOR_POOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_LIBRARY_MONITOR);
#line 41 "../src/LibraryMonitor.vala"
	library_monitor_pool_signals[LIBRARY_MONITOR_POOL_MONITOR_DESTROYED_SIGNAL] = g_signal_new ("monitor-destroyed", TYPE_LIBRARY_MONITOR_POOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_LIBRARY_MONITOR);
#line 1017 "LibraryMonitor.c"
}

static void
library_monitor_pool_instance_init (LibraryMonitorPool * self,
                                    gpointer klass)
{
#line 41 "../src/LibraryMonitor.vala"
	self->priv = library_monitor_pool_get_instance_private (self);
#line 44 "../src/LibraryMonitor.vala"
	self->priv->monitor = NULL;
#line 45 "../src/LibraryMonitor.vala"
	self->priv->timer_id = (guint) 0;
#line 41 "../src/LibraryMonitor.vala"
	self->ref_count = 1;
#line 1032 "LibraryMonitor.c"
}

static void
library_monitor_pool_finalize (LibraryMonitorPool * obj)
{
	LibraryMonitorPool * self;
#line 41 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool);
#line 41 "../src/LibraryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 44 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 1045 "LibraryMonitor.c"
}

static GType
library_monitor_pool_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_library_monitor_pool_init, value_library_monitor_pool_free_value, value_library_monitor_pool_copy_value, value_library_monitor_pool_peek_pointer, "p", value_library_monitor_pool_collect_value, "p", value_library_monitor_pool_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorPoolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_pool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorPool), 0, (GInstanceInitFunc) library_monitor_pool_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType library_monitor_pool_type_id;
	library_monitor_pool_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LibraryMonitorPool", &g_define_type_info, &g_define_type_fundamental_info, 0);
	LibraryMonitorPool_private_offset = g_type_add_instance_private (library_monitor_pool_type_id, sizeof (LibraryMonitorPoolPrivate));
	return library_monitor_pool_type_id;
}

GType
library_monitor_pool_get_type (void)
{
	static volatile gsize library_monitor_pool_type_id__once = 0;
	if (g_once_init_enter (&library_monitor_pool_type_id__once)) {
		GType library_monitor_pool_type_id;
		library_monitor_pool_type_id = library_monitor_pool_get_type_once ();
		g_once_init_leave (&library_monitor_pool_type_id__once, library_monitor_pool_type_id);
	}
	return library_monitor_pool_type_id__once;
}

gpointer
library_monitor_pool_ref (gpointer instance)
{
	LibraryMonitorPool * self;
	self = instance;
#line 41 "../src/LibraryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 41 "../src/LibraryMonitor.vala"
	return instance;
#line 1081 "LibraryMonitor.c"
}

void
library_monitor_pool_unref (gpointer instance)
{
	LibraryMonitorPool * self;
	self = instance;
#line 41 "../src/LibraryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 41 "../src/LibraryMonitor.vala"
		LIBRARY_MONITOR_POOL_GET_CLASS (self)->finalize (self);
#line 41 "../src/LibraryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1095 "LibraryMonitor.c"
	}
}

static inline gpointer
library_monitor_get_instance_private (LibraryMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryMonitor_private_offset);
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 219 "../src/LibraryMonitor.vala"
	return result;
#line 1113 "LibraryMonitor.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 219 "../src/LibraryMonitor.vala"
	return result;
#line 1125 "LibraryMonitor.c"
}

static void
_library_monitor_on_unblacklist_file_dequeued_callback (gconstpointer item,
                                                        gpointer self)
{
#line 220 "../src/LibraryMonitor.vala"
	library_monitor_on_unblacklist_file ((GFile*) item);
#line 1134 "LibraryMonitor.c"
}

static void
_library_monitor_on_config_changed_g_settings_changed (GSettings* _sender,
                                                       const gchar* key,
                                                       gpointer self)
{
#line 259 "../src/LibraryMonitor.vala"
	library_monitor_on_config_changed ((LibraryMonitor*) self, key);
#line 1144 "LibraryMonitor.c"
}

static gboolean
_library_monitor_on_flush_import_queue_gsource_func (gpointer self)
{
	gboolean result;
	result = library_monitor_on_flush_import_queue ((LibraryMonitor*) self);
#line 261 "../src/LibraryMonitor.vala"
	return result;
#line 1154 "LibraryMonitor.c"
}

LibraryMonitor*
library_monitor_construct (GType object_type,
                           GFile* root,
                           gboolean recurse,
                           gboolean monitoring)
{
	LibraryMonitor * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 254 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 255 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) directory_monitor_construct (object_type, root, recurse, monitoring);
#line 258 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->file_settings;
#line 258 "../src/LibraryMonitor.vala"
	self->priv->auto_import = g_settings_get_boolean (_tmp0_, "auto-import");
#line 259 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->file_settings;
#line 259 "../src/LibraryMonitor.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _library_monitor_on_config_changed_g_settings_changed, self, 0);
#line 261 "../src/LibraryMonitor.vala"
	self->priv->import_queue_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) LIBRARY_MONITOR_FLUSH_IMPORT_QUEUE_SEC, _library_monitor_on_flush_import_queue_gsource_func, g_object_ref (self), g_object_unref);
#line 254 "../src/LibraryMonitor.vala"
	return self;
#line 1182 "LibraryMonitor.c"
}

LibraryMonitor*
library_monitor_new (GFile* root,
                     gboolean recurse,
                     gboolean monitoring)
{
#line 254 "../src/LibraryMonitor.vala"
	return library_monitor_construct (TYPE_LIBRARY_MONITOR, root, recurse, monitoring);
#line 1192 "LibraryMonitor.c"
}

static void
library_monitor_real_close (DirectoryMonitor* base)
{
	LibraryMonitor * self;
	GCancellable* _tmp0_;
#line 264 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 265 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 265 "../src/LibraryMonitor.vala"
	g_cancellable_cancel (_tmp0_);
#line 1206 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 267 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 267 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 267 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 267 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 267 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 267 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 267 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 267 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 1231 "LibraryMonitor.c"
			gint _tmp5_;
			gint _tmp6_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			MediaMonitor* _tmp9_;
#line 267 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 267 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_index;
#line 267 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_size;
#line 267 "../src/LibraryMonitor.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 267 "../src/LibraryMonitor.vala"
				break;
#line 1248 "LibraryMonitor.c"
			}
#line 267 "../src/LibraryMonitor.vala"
			_tmp7_ = _monitor_list;
#line 267 "../src/LibraryMonitor.vala"
			_tmp8_ = gee_list_get (_tmp7_, _monitor_index);
#line 267 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp8_;
#line 268 "../src/LibraryMonitor.vala"
			_tmp9_ = monitor;
#line 268 "../src/LibraryMonitor.vala"
			media_monitor_close (_tmp9_);
#line 267 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 1262 "LibraryMonitor.c"
		}
	}
#line 270 "../src/LibraryMonitor.vala"
	if (self->priv->import_queue_timer_id != ((guint) 0)) {
#line 271 "../src/LibraryMonitor.vala"
		g_source_remove (self->priv->import_queue_timer_id);
#line 272 "../src/LibraryMonitor.vala"
		self->priv->import_queue_timer_id = (guint) 0;
#line 1271 "LibraryMonitor.c"
	}
#line 275 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->close (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor));
#line 1275 "LibraryMonitor.c"
}

static void
library_monitor_add_to_discovered_list (LibraryMonitor* self,
                                        MediaMonitor* monitor,
                                        Monitorable* monitorable)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp4_;
	gpointer _tmp5_;
	GeeSet* _tmp6_;
#line 278 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitor != NULL);
#line 278 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 279 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->discovered;
#line 279 "../src/LibraryMonitor.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, monitor)) {
#line 1297 "LibraryMonitor.c"
		GeeHashMap* _tmp1_;
		GeeHashSet* _tmp2_;
		GeeHashSet* _tmp3_;
#line 280 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->discovered;
#line 280 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_hash_set_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 280 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 280 "../src/LibraryMonitor.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, monitor, (GeeSet*) _tmp3_);
#line 280 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 1311 "LibraryMonitor.c"
	}
#line 282 "../src/LibraryMonitor.vala"
	_tmp4_ = self->priv->discovered;
#line 282 "../src/LibraryMonitor.vala"
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, monitor);
#line 282 "../src/LibraryMonitor.vala"
	_tmp6_ = (GeeSet*) _tmp5_;
#line 282 "../src/LibraryMonitor.vala"
	gee_collection_add ((GeeCollection*) _tmp6_, monitorable);
#line 282 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_tmp6_);
#line 1323 "LibraryMonitor.c"
}

static MediaMonitor*
library_monitor_get_monitor_for_monitorable (LibraryMonitor* self,
                                             Monitorable* monitorable)
{
	gchar* _tmp12_;
	gchar* _tmp13_;
	MediaMonitor* result;
#line 285 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 285 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 1337 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		gint _monitor_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 286 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 286 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp0_;
#line 286 "../src/LibraryMonitor.vala"
		_tmp1_ = _monitor_list;
#line 286 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 286 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 286 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp3_;
#line 286 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 286 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 1362 "LibraryMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitor* _tmp8_;
			MediaSourceCollection* _tmp9_;
			MediaSourceCollection* _tmp10_;
			gboolean _tmp11_;
#line 286 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 286 "../src/LibraryMonitor.vala"
			_tmp4_ = _monitor_index;
#line 286 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_size;
#line 286 "../src/LibraryMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 286 "../src/LibraryMonitor.vala"
				break;
#line 1382 "LibraryMonitor.c"
			}
#line 286 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 286 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 286 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 287 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 287 "../src/LibraryMonitor.vala"
			_tmp9_ = media_monitor_get_media_source_collection (_tmp8_);
#line 287 "../src/LibraryMonitor.vala"
			_tmp10_ = _tmp9_;
#line 287 "../src/LibraryMonitor.vala"
			_tmp11_ = source_collection_holds_type_of_source ((SourceCollection*) _tmp10_, (DataSource*) monitorable);
#line 287 "../src/LibraryMonitor.vala"
			_data_collection_unref0 (_tmp10_);
#line 287 "../src/LibraryMonitor.vala"
			if (_tmp11_) {
#line 288 "../src/LibraryMonitor.vala"
				result = monitor;
#line 288 "../src/LibraryMonitor.vala"
				return result;
#line 1406 "LibraryMonitor.c"
			}
#line 286 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 1410 "LibraryMonitor.c"
		}
	}
#line 291 "../src/LibraryMonitor.vala"
	_tmp12_ = data_object_to_string ((DataObject*) monitorable);
#line 291 "../src/LibraryMonitor.vala"
	_tmp13_ = _tmp12_;
#line 291 "../src/LibraryMonitor.vala"
	g_error ("LibraryMonitor.vala:291: Unable to locate MediaMonitor for %s", _tmp13_);
#line 291 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp13_);
#line 1421 "LibraryMonitor.c"
}

static void
library_monitor_real_discovery_started (DirectoryMonitor* base)
{
	LibraryMonitor * self;
	GeeHashMap* _tmp24_;
	GeeHashSet* _tmp25_;
#line 294 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 1432 "LibraryMonitor.c"
	{
		GeeIterator* _collection_it = NULL;
		MediaCollectionRegistry* _tmp0_;
		MediaCollectionRegistry* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 295 "../src/LibraryMonitor.vala"
		_tmp0_ = media_collection_registry_get_instance ();
#line 295 "../src/LibraryMonitor.vala"
		_tmp1_ = _tmp0_;
#line 295 "../src/LibraryMonitor.vala"
		_tmp2_ = media_collection_registry_get_all (_tmp1_);
#line 295 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 295 "../src/LibraryMonitor.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 295 "../src/LibraryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 295 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 295 "../src/LibraryMonitor.vala"
		_media_collection_registry_unref0 (_tmp1_);
#line 295 "../src/LibraryMonitor.vala"
		_collection_it = _tmp5_;
#line 295 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 1461 "LibraryMonitor.c"
			GeeIterator* _tmp6_;
			MediaSourceCollection* collection = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeList* _tmp9_;
			MediaSourceCollection* _tmp10_;
			Workers* _tmp11_;
			GCancellable* _tmp12_;
			MediaMonitor* _tmp13_;
			MediaMonitor* _tmp14_;
#line 295 "../src/LibraryMonitor.vala"
			_tmp6_ = _collection_it;
#line 295 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 295 "../src/LibraryMonitor.vala"
				break;
#line 1478 "LibraryMonitor.c"
			}
#line 295 "../src/LibraryMonitor.vala"
			_tmp7_ = _collection_it;
#line 295 "../src/LibraryMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 295 "../src/LibraryMonitor.vala"
			collection = (MediaSourceCollection*) _tmp8_;
#line 296 "../src/LibraryMonitor.vala"
			_tmp9_ = self->priv->monitors;
#line 296 "../src/LibraryMonitor.vala"
			_tmp10_ = collection;
#line 296 "../src/LibraryMonitor.vala"
			_tmp11_ = self->priv->workers;
#line 296 "../src/LibraryMonitor.vala"
			_tmp12_ = self->priv->cancellable;
#line 296 "../src/LibraryMonitor.vala"
			_tmp13_ = media_source_collection_create_media_monitor (_tmp10_, _tmp11_, _tmp12_);
#line 296 "../src/LibraryMonitor.vala"
			_tmp14_ = _tmp13_;
#line 296 "../src/LibraryMonitor.vala"
			gee_collection_add ((GeeCollection*) _tmp9_, _tmp14_);
#line 296 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_tmp14_);
#line 295 "../src/LibraryMonitor.vala"
			_data_collection_unref0 (collection);
#line 1504 "LibraryMonitor.c"
		}
#line 295 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_collection_it);
#line 1508 "LibraryMonitor.c"
	}
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp15_;
		gint _monitor_size = 0;
		GeeList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _monitor_index = 0;
#line 298 "../src/LibraryMonitor.vala"
		_tmp15_ = self->priv->monitors;
#line 298 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp15_;
#line 298 "../src/LibraryMonitor.vala"
		_tmp16_ = _monitor_list;
#line 298 "../src/LibraryMonitor.vala"
		_tmp17_ = gee_collection_get_size ((GeeCollection*) _tmp16_);
#line 298 "../src/LibraryMonitor.vala"
		_tmp18_ = _tmp17_;
#line 298 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp18_;
#line 298 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 298 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 1534 "LibraryMonitor.c"
			gint _tmp19_;
			gint _tmp20_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp21_;
			gpointer _tmp22_;
			MediaMonitor* _tmp23_;
#line 298 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 298 "../src/LibraryMonitor.vala"
			_tmp19_ = _monitor_index;
#line 298 "../src/LibraryMonitor.vala"
			_tmp20_ = _monitor_size;
#line 298 "../src/LibraryMonitor.vala"
			if (!(_tmp19_ < _tmp20_)) {
#line 298 "../src/LibraryMonitor.vala"
				break;
#line 1551 "LibraryMonitor.c"
			}
#line 298 "../src/LibraryMonitor.vala"
			_tmp21_ = _monitor_list;
#line 298 "../src/LibraryMonitor.vala"
			_tmp22_ = gee_list_get (_tmp21_, _monitor_index);
#line 298 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp22_;
#line 299 "../src/LibraryMonitor.vala"
			_tmp23_ = monitor;
#line 299 "../src/LibraryMonitor.vala"
			media_monitor_notify_discovery_started (_tmp23_);
#line 298 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 1565 "LibraryMonitor.c"
		}
	}
#line 301 "../src/LibraryMonitor.vala"
	_tmp24_ = gee_hash_map_new (TYPE_MEDIA_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_SET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 301 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->discovered);
#line 301 "../src/LibraryMonitor.vala"
	self->priv->discovered = _tmp24_;
#line 302 "../src/LibraryMonitor.vala"
	_tmp25_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 302 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->unknown_files);
#line 302 "../src/LibraryMonitor.vala"
	self->priv->unknown_files = _tmp25_;
#line 304 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_started (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor));
#line 1582 "LibraryMonitor.c"
}

static void
library_monitor_real_file_discovered (DirectoryMonitor* base,
                                      GFile* file,
                                      GFileInfo* info)
{
	LibraryMonitor * self;
	Monitorable* representation = NULL;
	MediaMonitor* representing = NULL;
	gboolean ignore = FALSE;
	MediaMonitor* _tmp13_;
#line 307 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 307 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 307 "../src/LibraryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 308 "../src/LibraryMonitor.vala"
	representation = NULL;
#line 309 "../src/LibraryMonitor.vala"
	representing = NULL;
#line 310 "../src/LibraryMonitor.vala"
	ignore = FALSE;
#line 1607 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		gint _monitor_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 311 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 311 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp0_;
#line 311 "../src/LibraryMonitor.vala"
		_tmp1_ = _monitor_list;
#line 311 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 311 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 311 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp3_;
#line 311 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 311 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 1632 "LibraryMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitorDiscoveredFile _result_ = 0;
			MediaMonitor* _tmp8_;
			Monitorable* _tmp9_ = NULL;
			MediaMonitorDiscoveredFile _tmp10_;
#line 311 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 311 "../src/LibraryMonitor.vala"
			_tmp4_ = _monitor_index;
#line 311 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_size;
#line 311 "../src/LibraryMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 311 "../src/LibraryMonitor.vala"
				break;
#line 1652 "LibraryMonitor.c"
			}
#line 311 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 311 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 311 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 312 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 312 "../src/LibraryMonitor.vala"
			_tmp10_ = media_monitor_notify_file_discovered (_tmp8_, file, info, &_tmp9_);
#line 312 "../src/LibraryMonitor.vala"
			_g_object_unref0 (representation);
#line 312 "../src/LibraryMonitor.vala"
			representation = _tmp9_;
#line 312 "../src/LibraryMonitor.vala"
			_result_ = _tmp10_;
#line 314 "../src/LibraryMonitor.vala"
			if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 1672 "LibraryMonitor.c"
				MediaMonitor* _tmp11_;
				MediaMonitor* _tmp12_;
#line 315 "../src/LibraryMonitor.vala"
				_tmp11_ = monitor;
#line 315 "../src/LibraryMonitor.vala"
				_tmp12_ = _g_object_ref0 (_tmp11_);
#line 315 "../src/LibraryMonitor.vala"
				_g_object_unref0 (representing);
#line 315 "../src/LibraryMonitor.vala"
				representing = _tmp12_;
#line 317 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 317 "../src/LibraryMonitor.vala"
				break;
#line 1687 "LibraryMonitor.c"
			} else {
#line 318 "../src/LibraryMonitor.vala"
				if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE) {
#line 320 "../src/LibraryMonitor.vala"
					ignore = TRUE;
#line 322 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitor);
#line 322 "../src/LibraryMonitor.vala"
					break;
#line 1697 "LibraryMonitor.c"
				}
			}
#line 311 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 1702 "LibraryMonitor.c"
		}
	}
#line 326 "../src/LibraryMonitor.vala"
	_tmp13_ = representing;
#line 326 "../src/LibraryMonitor.vala"
	if (_tmp13_ != NULL) {
#line 1709 "LibraryMonitor.c"
		gboolean _tmp14_ = FALSE;
		Monitorable* _tmp15_;
		MediaMonitor* _tmp16_;
		Monitorable* _tmp17_;
#line 327 "../src/LibraryMonitor.vala"
		_tmp15_ = representation;
#line 327 "../src/LibraryMonitor.vala"
		if (_tmp15_ != NULL) {
#line 327 "../src/LibraryMonitor.vala"
			_tmp14_ = !ignore;
#line 1720 "LibraryMonitor.c"
		} else {
#line 327 "../src/LibraryMonitor.vala"
			_tmp14_ = FALSE;
#line 1724 "LibraryMonitor.c"
		}
#line 327 "../src/LibraryMonitor.vala"
		_vala_assert (_tmp14_, "representation != null && !ignore");
#line 328 "../src/LibraryMonitor.vala"
		_tmp16_ = representing;
#line 328 "../src/LibraryMonitor.vala"
		_tmp17_ = representation;
#line 328 "../src/LibraryMonitor.vala"
		library_monitor_add_to_discovered_list (self, _tmp16_, _tmp17_);
#line 1734 "LibraryMonitor.c"
	} else {
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
#line 329 "../src/LibraryMonitor.vala"
		if (!ignore) {
#line 1740 "LibraryMonitor.c"
			TombstoneSourceCollection* _tmp20_;
#line 329 "../src/LibraryMonitor.vala"
			_tmp20_ = tombstone_global;
#line 329 "../src/LibraryMonitor.vala"
			_tmp19_ = !tombstone_source_collection_matches (_tmp20_, file);
#line 1746 "LibraryMonitor.c"
		} else {
#line 329 "../src/LibraryMonitor.vala"
			_tmp19_ = FALSE;
#line 1750 "LibraryMonitor.c"
		}
#line 329 "../src/LibraryMonitor.vala"
		if (_tmp19_) {
#line 329 "../src/LibraryMonitor.vala"
			_tmp18_ = library_monitor_is_supported_filetype (self, file);
#line 1756 "LibraryMonitor.c"
		} else {
#line 329 "../src/LibraryMonitor.vala"
			_tmp18_ = FALSE;
#line 1760 "LibraryMonitor.c"
		}
#line 329 "../src/LibraryMonitor.vala"
		if (_tmp18_) {
#line 1764 "LibraryMonitor.c"
			GeeHashSet* _tmp21_;
#line 330 "../src/LibraryMonitor.vala"
			_tmp21_ = self->priv->unknown_files;
#line 330 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, file);
#line 1770 "LibraryMonitor.c"
		}
	}
#line 333 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->file_discovered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 307 "../src/LibraryMonitor.vala"
	_g_object_unref0 (representing);
#line 307 "../src/LibraryMonitor.vala"
	_g_object_unref0 (representation);
#line 1779 "LibraryMonitor.c"
}

static void
library_monitor_real_discovery_completed (DirectoryMonitor* base)
{
	LibraryMonitor * self;
#line 336 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 337 "../src/LibraryMonitor.vala"
	library_monitor_async_discovery_completed (self, NULL, NULL);
#line 1790 "LibraryMonitor.c"
}

static void
library_monitor_async_discovery_completed_data_free (gpointer _data)
{
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
	_data_ = _data;
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 110 "../src/LibraryMonitor.vala"
	g_slice_free (LibraryMonitorAsyncDiscoveryCompletedData, _data_);
#line 1802 "LibraryMonitor.c"
}

static void
library_monitor_async_discovery_completed (LibraryMonitor* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
	LibraryMonitor* _tmp0_;
#line 110 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/LibraryMonitor.vala"
	_data_ = g_slice_new0 (LibraryMonitorAsyncDiscoveryCompletedData);
#line 110 "../src/LibraryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 110 "../src/LibraryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, library_monitor_async_discovery_completed_data_free);
#line 110 "../src/LibraryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 110 "../src/LibraryMonitor.vala"
	_data_->self = _tmp0_;
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_async_discovery_completed_co (_data_);
#line 1826 "LibraryMonitor.c"
}

static void
library_monitor_async_discovery_completed_finish (LibraryMonitor* self,
                                                  GAsyncResult* _res_)
{
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
#line 110 "../src/LibraryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1836 "LibraryMonitor.c"
}

static gboolean
_library_monitor_async_discovery_completed_co_gsource_func (gpointer self)
{
	gboolean result;
	result = library_monitor_async_discovery_completed_co (self);
#line 392 "../src/LibraryMonitor.vala"
	return result;
#line 1846 "LibraryMonitor.c"
}

static gboolean
library_monitor_async_discovery_completed_co (LibraryMonitorAsyncDiscoveryCompletedData* _data_)
{
#line 340 "../src/LibraryMonitor.vala"
	switch (_data_->_state_) {
#line 340 "../src/LibraryMonitor.vala"
		case 0:
#line 1856 "LibraryMonitor.c"
		goto _state_0;
#line 340 "../src/LibraryMonitor.vala"
		case 1:
#line 1860 "LibraryMonitor.c"
		goto _state_1;
		default:
#line 340 "../src/LibraryMonitor.vala"
		g_assert_not_reached ();
#line 1865 "LibraryMonitor.c"
	}
	_state_0:
#line 345 "../src/LibraryMonitor.vala"
	_data_->_tmp0_ = _data_->self->priv->unknown_files;
#line 345 "../src/LibraryMonitor.vala"
	_data_->_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp0_);
#line 345 "../src/LibraryMonitor.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 345 "../src/LibraryMonitor.vala"
	if (_data_->_tmp2_ == 0) {
#line 346 "../src/LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (_data_->self);
#line 348 "../src/LibraryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 348 "../src/LibraryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 348 "../src/LibraryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 348 "../src/LibraryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1886 "LibraryMonitor.c"
			}
		}
#line 348 "../src/LibraryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 348 "../src/LibraryMonitor.vala"
		return FALSE;
#line 1893 "LibraryMonitor.c"
	}
#line 351 "../src/LibraryMonitor.vala"
	_data_->_tmp3_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 351 "../src/LibraryMonitor.vala"
	_data_->all_candidates = _data_->_tmp3_;
#line 352 "../src/LibraryMonitor.vala"
	_data_->_tmp4_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 352 "../src/LibraryMonitor.vala"
	_data_->adopted = _data_->_tmp4_;
#line 1903 "LibraryMonitor.c"
	{
#line 353 "../src/LibraryMonitor.vala"
		_data_->_tmp5_ = _data_->self->priv->unknown_files;
#line 353 "../src/LibraryMonitor.vala"
		_data_->_tmp6_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp5_);
#line 353 "../src/LibraryMonitor.vala"
		_data_->_file_it = _data_->_tmp6_;
#line 353 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 353 "../src/LibraryMonitor.vala"
			_data_->_tmp7_ = _data_->_file_it;
#line 353 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_data_->_tmp7_)) {
#line 353 "../src/LibraryMonitor.vala"
				break;
#line 1919 "LibraryMonitor.c"
			}
#line 353 "../src/LibraryMonitor.vala"
			_data_->_tmp8_ = _data_->_file_it;
#line 353 "../src/LibraryMonitor.vala"
			_data_->_tmp9_ = gee_iterator_get (_data_->_tmp8_);
#line 353 "../src/LibraryMonitor.vala"
			_data_->file = (GFile*) _data_->_tmp9_;
#line 354 "../src/LibraryMonitor.vala"
			_data_->_tmp10_ = _data_->file;
#line 354 "../src/LibraryMonitor.vala"
			_data_->_tmp11_ = directory_monitor_get_file_info ((DirectoryMonitor*) _data_->self, _data_->_tmp10_);
#line 354 "../src/LibraryMonitor.vala"
			_data_->info = _data_->_tmp11_;
#line 355 "../src/LibraryMonitor.vala"
			_data_->_tmp12_ = _data_->info;
#line 355 "../src/LibraryMonitor.vala"
			if (_data_->_tmp12_ == NULL) {
#line 356 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->info);
#line 356 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->file);
#line 356 "../src/LibraryMonitor.vala"
				continue;
#line 1943 "LibraryMonitor.c"
			}
#line 359 "../src/LibraryMonitor.vala"
			_data_->_tmp13_ = _data_->all_candidates;
#line 359 "../src/LibraryMonitor.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _data_->_tmp13_);
#line 361 "../src/LibraryMonitor.vala"
			_data_->candidates = NULL;
#line 362 "../src/LibraryMonitor.vala"
			_data_->associated = FALSE;
#line 1953 "LibraryMonitor.c"
			{
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp14_ = _data_->self->priv->monitors;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_monitor_list = _data_->_tmp14_;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp15_ = _data_->_monitor_list;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp16_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp15_);
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp17_ = _data_->_tmp16_;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_monitor_size = _data_->_tmp17_;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_monitor_index = -1;
#line 363 "../src/LibraryMonitor.vala"
				while (TRUE) {
#line 363 "../src/LibraryMonitor.vala"
					_data_->_monitor_index = _data_->_monitor_index + 1;
#line 363 "../src/LibraryMonitor.vala"
					_data_->_tmp18_ = _data_->_monitor_index;
#line 363 "../src/LibraryMonitor.vala"
					_data_->_tmp19_ = _data_->_monitor_size;
#line 363 "../src/LibraryMonitor.vala"
					if (!(_data_->_tmp18_ < _data_->_tmp19_)) {
#line 363 "../src/LibraryMonitor.vala"
						break;
#line 1981 "LibraryMonitor.c"
					}
#line 363 "../src/LibraryMonitor.vala"
					_data_->_tmp20_ = _data_->_monitor_list;
#line 363 "../src/LibraryMonitor.vala"
					_data_->_tmp21_ = gee_list_get (_data_->_tmp20_, _data_->_monitor_index);
#line 363 "../src/LibraryMonitor.vala"
					_data_->monitor = (MediaMonitor*) _data_->_tmp21_;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp22_ = _data_->monitor;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp23_ = _data_->file;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp24_ = _data_->info;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp25_ = 0;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp26_ = media_monitor_candidates_for_unknown_file (_data_->_tmp22_, _data_->_tmp23_, _data_->_tmp24_, &_data_->_tmp25_);
#line 365 "../src/LibraryMonitor.vala"
					_data_->_result_ = _data_->_tmp25_;
#line 365 "../src/LibraryMonitor.vala"
					_g_object_unref0 (_data_->candidates);
#line 365 "../src/LibraryMonitor.vala"
					_data_->candidates = _data_->_tmp26_;
#line 366 "../src/LibraryMonitor.vala"
					if (_data_->_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 366 "../src/LibraryMonitor.vala"
						_data_->_tmp27_ = TRUE;
#line 2009 "LibraryMonitor.c"
					} else {
#line 367 "../src/LibraryMonitor.vala"
						_data_->_tmp27_ = _data_->_result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
#line 2013 "LibraryMonitor.c"
					}
#line 366 "../src/LibraryMonitor.vala"
					if (_data_->_tmp27_) {
#line 368 "../src/LibraryMonitor.vala"
						_data_->associated = TRUE;
#line 370 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->monitor);
#line 370 "../src/LibraryMonitor.vala"
						break;
#line 2023 "LibraryMonitor.c"
					} else {
#line 371 "../src/LibraryMonitor.vala"
						_data_->_tmp28_ = _data_->candidates;
#line 371 "../src/LibraryMonitor.vala"
						if (_data_->_tmp28_ != NULL) {
#line 372 "../src/LibraryMonitor.vala"
							_data_->_tmp29_ = _data_->all_candidates;
#line 372 "../src/LibraryMonitor.vala"
							_data_->_tmp30_ = _data_->candidates;
#line 372 "../src/LibraryMonitor.vala"
							gee_array_list_add_all (_data_->_tmp29_, _data_->_tmp30_);
#line 2035 "LibraryMonitor.c"
						}
					}
#line 363 "../src/LibraryMonitor.vala"
					_g_object_unref0 (_data_->monitor);
#line 2040 "LibraryMonitor.c"
				}
			}
#line 376 "../src/LibraryMonitor.vala"
			if (_data_->associated) {
#line 377 "../src/LibraryMonitor.vala"
				_data_->_tmp31_ = _data_->adopted;
#line 377 "../src/LibraryMonitor.vala"
				_data_->_tmp32_ = _data_->file;
#line 377 "../src/LibraryMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp31_, _data_->_tmp32_);
#line 379 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->candidates);
#line 379 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->info);
#line 379 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->file);
#line 379 "../src/LibraryMonitor.vala"
				continue;
#line 2059 "LibraryMonitor.c"
			}
#line 383 "../src/LibraryMonitor.vala"
			_data_->_tmp33_ = _data_->all_candidates;
#line 383 "../src/LibraryMonitor.vala"
			_data_->_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp33_);
#line 383 "../src/LibraryMonitor.vala"
			_data_->_tmp35_ = _data_->_tmp34_;
#line 383 "../src/LibraryMonitor.vala"
			if (_data_->_tmp35_ > 0) {
#line 385 "../src/LibraryMonitor.vala"
				_data_->_tmp36_ = _data_->all_candidates;
#line 385 "../src/LibraryMonitor.vala"
				_data_->_tmp37_ = _g_object_ref0 (_data_->_tmp36_);
#line 385 "../src/LibraryMonitor.vala"
				_data_->job_candidates = _data_->_tmp37_;
#line 386 "../src/LibraryMonitor.vala"
				_data_->_tmp38_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 386 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->all_candidates);
#line 386 "../src/LibraryMonitor.vala"
				_data_->all_candidates = _data_->_tmp38_;
#line 388 "../src/LibraryMonitor.vala"
				_data_->_tmp39_ = _data_->self->priv->checksums_total;
#line 388 "../src/LibraryMonitor.vala"
				_data_->self->priv->checksums_total = _data_->_tmp39_ + 1;
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp40_ = _data_->self->priv->workers;
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp41_ = _data_->file;
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp42_ = _data_->job_candidates;
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp43_ = library_monitor_find_move_job_new (_data_->self, _data_->_tmp41_, (GeeCollection*) _data_->_tmp42_);
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp44_ = _data_->_tmp43_;
#line 389 "../src/LibraryMonitor.vala"
				workers_enqueue (_data_->_tmp40_, (BackgroundJob*) _data_->_tmp44_);
#line 389 "../src/LibraryMonitor.vala"
				_background_job_unref0 (_data_->_tmp44_);
#line 383 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->job_candidates);
#line 2101 "LibraryMonitor.c"
			}
#line 392 "../src/LibraryMonitor.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _library_monitor_async_discovery_completed_co_gsource_func, _data_, NULL);
#line 393 "../src/LibraryMonitor.vala"
			_data_->_state_ = 1;
#line 393 "../src/LibraryMonitor.vala"
			return FALSE;
#line 2109 "LibraryMonitor.c"
			_state_1:
			;
#line 353 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_data_->candidates);
#line 353 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_data_->info);
#line 353 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_data_->file);
#line 2118 "LibraryMonitor.c"
		}
#line 353 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_data_->_file_it);
#line 2122 "LibraryMonitor.c"
	}
#line 397 "../src/LibraryMonitor.vala"
	_data_->_tmp45_ = _data_->self->priv->unknown_files;
#line 397 "../src/LibraryMonitor.vala"
	_data_->_tmp46_ = _data_->adopted;
#line 397 "../src/LibraryMonitor.vala"
	gee_collection_remove_all ((GeeCollection*) _data_->_tmp45_, (GeeCollection*) _data_->_tmp46_);
#line 399 "../src/LibraryMonitor.vala"
	_data_->self->priv->checksums_completed = 0;
#line 401 "../src/LibraryMonitor.vala"
	if (_data_->self->priv->checksums_total == 0) {
#line 402 "../src/LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (_data_->self);
#line 2136 "LibraryMonitor.c"
	} else {
#line 404 "../src/LibraryMonitor.vala"
		_data_->_tmp47_ = g_strdup_printf ("%d checksum jobs initiated to verify unknown photo files", _data_->self->priv->checksums_total);
#line 404 "../src/LibraryMonitor.vala"
		_data_->_tmp48_ = _data_->_tmp47_;
#line 404 "../src/LibraryMonitor.vala"
		directory_monitor_mdbg (_data_->_tmp48_);
#line 404 "../src/LibraryMonitor.vala"
		_g_free0 (_data_->_tmp48_);
#line 405 "../src/LibraryMonitor.vala"
		g_signal_emit (_data_->self, library_monitor_signals[LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL], 0, _data_->self->priv->checksums_completed, _data_->self->priv->checksums_total);
#line 2148 "LibraryMonitor.c"
	}
#line 340 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->adopted);
#line 340 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->all_candidates);
#line 340 "../src/LibraryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 340 "../src/LibraryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 340 "../src/LibraryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 340 "../src/LibraryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2162 "LibraryMonitor.c"
		}
	}
#line 340 "../src/LibraryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 340 "../src/LibraryMonitor.vala"
	return FALSE;
#line 2169 "LibraryMonitor.c"
}

static void
library_monitor_report_checksum_job_completed (LibraryMonitor* self)
{
	gint _tmp0_;
#line 409 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 410 "../src/LibraryMonitor.vala"
	_vala_assert (self->priv->checksums_completed < self->priv->checksums_total, "checksums_completed < checksums_total");
#line 411 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->checksums_completed;
#line 411 "../src/LibraryMonitor.vala"
	self->priv->checksums_completed = _tmp0_ + 1;
#line 413 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_signals[LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL], 0, self->priv->checksums_completed, self->priv->checksums_total);
#line 415 "../src/LibraryMonitor.vala"
	if (self->priv->checksums_completed == self->priv->checksums_total) {
#line 416 "../src/LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (self);
#line 2190 "LibraryMonitor.c"
	}
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 420 "../src/LibraryMonitor.vala"
	return self ? background_job_ref (self) : NULL;
#line 2199 "LibraryMonitor.c"
}

static void
library_monitor_on_find_move_completed (LibraryMonitor* self,
                                        BackgroundJob* j)
{
	LibraryMonitorFindMoveJob* job = NULL;
	LibraryMonitorFindMoveJob* _tmp0_;
	LibraryMonitorFindMoveJob* _tmp1_;
	Monitorable* _tmp2_;
	LibraryMonitorFindMoveJob* _tmp27_;
	GError* _tmp28_;
#line 419 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 419 "../src/LibraryMonitor.vala"
	g_return_if_fail (j != NULL);
#line 420 "../src/LibraryMonitor.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJob));
#line 420 "../src/LibraryMonitor.vala"
	job = _tmp0_;
#line 425 "../src/LibraryMonitor.vala"
	_tmp1_ = job;
#line 425 "../src/LibraryMonitor.vala"
	_tmp2_ = _tmp1_->match;
#line 425 "../src/LibraryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 2226 "LibraryMonitor.c"
		LibraryMonitorFindMoveJob* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		LibraryMonitorFindMoveJob* _tmp7_;
		Monitorable* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		MediaMonitor* monitor = NULL;
		LibraryMonitorFindMoveJob* _tmp13_;
		Monitorable* _tmp14_;
		MediaMonitor* _tmp15_;
		MediaMonitor* _tmp16_;
		LibraryMonitorFindMoveJob* _tmp17_;
		Monitorable* _tmp18_;
		LibraryMonitorFindMoveJob* _tmp19_;
		GFile* _tmp20_;
		GeeHashSet* _tmp21_;
		LibraryMonitorFindMoveJob* _tmp22_;
		GFile* _tmp23_;
		MediaMonitor* _tmp24_;
		LibraryMonitorFindMoveJob* _tmp25_;
		Monitorable* _tmp26_;
#line 426 "../src/LibraryMonitor.vala"
		_tmp3_ = job;
#line 426 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_->file;
#line 426 "../src/LibraryMonitor.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 426 "../src/LibraryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 426 "../src/LibraryMonitor.vala"
		_tmp7_ = job;
#line 426 "../src/LibraryMonitor.vala"
		_tmp8_ = _tmp7_->match;
#line 426 "../src/LibraryMonitor.vala"
		_tmp9_ = data_object_to_string ((DataObject*) _tmp8_);
#line 426 "../src/LibraryMonitor.vala"
		_tmp10_ = _tmp9_;
#line 426 "../src/LibraryMonitor.vala"
		_tmp11_ = g_strdup_printf ("Found moved master file: %s matches %s", _tmp6_, _tmp10_);
#line 426 "../src/LibraryMonitor.vala"
		_tmp12_ = _tmp11_;
#line 426 "../src/LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp12_);
#line 426 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp12_);
#line 426 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp10_);
#line 426 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp6_);
#line 429 "../src/LibraryMonitor.vala"
		_tmp13_ = job;
#line 429 "../src/LibraryMonitor.vala"
		_tmp14_ = _tmp13_->match;
#line 429 "../src/LibraryMonitor.vala"
		_tmp15_ = library_monitor_get_monitor_for_monitorable (self, _tmp14_);
#line 429 "../src/LibraryMonitor.vala"
		monitor = _tmp15_;
#line 430 "../src/LibraryMonitor.vala"
		_tmp16_ = monitor;
#line 430 "../src/LibraryMonitor.vala"
		_tmp17_ = job;
#line 430 "../src/LibraryMonitor.vala"
		_tmp18_ = _tmp17_->match;
#line 430 "../src/LibraryMonitor.vala"
		_tmp19_ = job;
#line 430 "../src/LibraryMonitor.vala"
		_tmp20_ = _tmp19_->file;
#line 430 "../src/LibraryMonitor.vala"
		media_monitor_update_master_file (_tmp16_, _tmp18_, _tmp20_);
#line 431 "../src/LibraryMonitor.vala"
		_tmp21_ = self->priv->unknown_files;
#line 431 "../src/LibraryMonitor.vala"
		_tmp22_ = job;
#line 431 "../src/LibraryMonitor.vala"
		_tmp23_ = _tmp22_->file;
#line 431 "../src/LibraryMonitor.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp21_, _tmp23_);
#line 432 "../src/LibraryMonitor.vala"
		_tmp24_ = monitor;
#line 432 "../src/LibraryMonitor.vala"
		_tmp25_ = job;
#line 432 "../src/LibraryMonitor.vala"
		_tmp26_ = _tmp25_->match;
#line 432 "../src/LibraryMonitor.vala"
		library_monitor_add_to_discovered_list (self, _tmp24_, _tmp26_);
#line 425 "../src/LibraryMonitor.vala"
		_g_object_unref0 (monitor);
#line 2318 "LibraryMonitor.c"
	}
#line 435 "../src/LibraryMonitor.vala"
	_tmp27_ = job;
#line 435 "../src/LibraryMonitor.vala"
	_tmp28_ = _tmp27_->err;
#line 435 "../src/LibraryMonitor.vala"
	if (_tmp28_ != NULL) {
#line 2326 "LibraryMonitor.c"
		LibraryMonitorFindMoveJob* _tmp29_;
		GFile* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		LibraryMonitorFindMoveJob* _tmp33_;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 436 "../src/LibraryMonitor.vala"
		_tmp29_ = job;
#line 436 "../src/LibraryMonitor.vala"
		_tmp30_ = _tmp29_->file;
#line 436 "../src/LibraryMonitor.vala"
		_tmp31_ = g_file_get_path (_tmp30_);
#line 436 "../src/LibraryMonitor.vala"
		_tmp32_ = _tmp31_;
#line 436 "../src/LibraryMonitor.vala"
		_tmp33_ = job;
#line 436 "../src/LibraryMonitor.vala"
		_tmp34_ = _tmp33_->err;
#line 436 "../src/LibraryMonitor.vala"
		_tmp35_ = _tmp34_->message;
#line 436 "../src/LibraryMonitor.vala"
		g_warning ("LibraryMonitor.vala:436: Unable to checksum unknown media file %s: %s", _tmp32_, _tmp35_);
#line 436 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp32_);
#line 2352 "LibraryMonitor.c"
	}
#line 438 "../src/LibraryMonitor.vala"
	library_monitor_report_checksum_job_completed (self);
#line 419 "../src/LibraryMonitor.vala"
	_background_job_unref0 (job);
#line 2358 "LibraryMonitor.c"
}

static void
library_monitor_on_find_move_cancelled (LibraryMonitor* self,
                                        BackgroundJob* j)
{
#line 441 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 441 "../src/LibraryMonitor.vala"
	g_return_if_fail (j != NULL);
#line 442 "../src/LibraryMonitor.vala"
	library_monitor_report_checksum_job_completed (self);
#line 2371 "LibraryMonitor.c"
}

static void
library_monitor_discovery_stage_completed (LibraryMonitor* self)
{
	TombstoneSourceCollection* _tmp58_;
	GCancellable* _tmp59_;
#line 445 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 2381 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		gint _monitor_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 446 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 446 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp0_;
#line 446 "../src/LibraryMonitor.vala"
		_tmp1_ = _monitor_list;
#line 446 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 446 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 446 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp3_;
#line 446 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 446 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 2406 "LibraryMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			GeeSet* monitorables = NULL;
			GeeHashMap* _tmp8_;
			MediaMonitor* _tmp9_;
			gpointer _tmp10_;
			GeeSet* _tmp11_;
#line 446 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 446 "../src/LibraryMonitor.vala"
			_tmp4_ = _monitor_index;
#line 446 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_size;
#line 446 "../src/LibraryMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 446 "../src/LibraryMonitor.vala"
				break;
#line 2427 "LibraryMonitor.c"
			}
#line 446 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 446 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 446 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 447 "../src/LibraryMonitor.vala"
			_tmp8_ = self->priv->discovered;
#line 447 "../src/LibraryMonitor.vala"
			_tmp9_ = monitor;
#line 447 "../src/LibraryMonitor.vala"
			_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, _tmp9_);
#line 447 "../src/LibraryMonitor.vala"
			monitorables = (GeeSet*) _tmp10_;
#line 448 "../src/LibraryMonitor.vala"
			_tmp11_ = monitorables;
#line 448 "../src/LibraryMonitor.vala"
			if (_tmp11_ != NULL) {
#line 2447 "LibraryMonitor.c"
				{
					GeeIterator* _monitorable_it = NULL;
					GeeSet* _tmp12_;
					GeeIterator* _tmp13_;
#line 449 "../src/LibraryMonitor.vala"
					_tmp12_ = monitorables;
#line 449 "../src/LibraryMonitor.vala"
					_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 449 "../src/LibraryMonitor.vala"
					_monitorable_it = _tmp13_;
#line 449 "../src/LibraryMonitor.vala"
					while (TRUE) {
#line 2460 "LibraryMonitor.c"
						GeeIterator* _tmp14_;
						Monitorable* monitorable = NULL;
						GeeIterator* _tmp15_;
						gpointer _tmp16_;
						Monitorable* _tmp17_;
						MediaMonitor* _tmp18_;
#line 449 "../src/LibraryMonitor.vala"
						_tmp14_ = _monitorable_it;
#line 449 "../src/LibraryMonitor.vala"
						if (!gee_iterator_next (_tmp14_)) {
#line 449 "../src/LibraryMonitor.vala"
							break;
#line 2473 "LibraryMonitor.c"
						}
#line 449 "../src/LibraryMonitor.vala"
						_tmp15_ = _monitorable_it;
#line 449 "../src/LibraryMonitor.vala"
						_tmp16_ = gee_iterator_get (_tmp15_);
#line 449 "../src/LibraryMonitor.vala"
						monitorable = (Monitorable*) _tmp16_;
#line 450 "../src/LibraryMonitor.vala"
						_tmp17_ = monitorable;
#line 450 "../src/LibraryMonitor.vala"
						_tmp18_ = monitor;
#line 450 "../src/LibraryMonitor.vala"
						library_monitor_enqueue_verify_monitorable (self, _tmp17_, _tmp18_);
#line 449 "../src/LibraryMonitor.vala"
						_g_object_unref0 (monitorable);
#line 2489 "LibraryMonitor.c"
					}
#line 449 "../src/LibraryMonitor.vala"
					_g_object_unref0 (_monitorable_it);
#line 2493 "LibraryMonitor.c"
				}
			}
			{
				GeeIterator* _object_it = NULL;
				MediaMonitor* _tmp19_;
				MediaSourceCollection* _tmp20_;
				MediaSourceCollection* _tmp21_;
				GeeCollection* _tmp22_;
				GeeCollection* _tmp23_;
				GeeIterator* _tmp24_;
				GeeIterator* _tmp25_;
#line 453 "../src/LibraryMonitor.vala"
				_tmp19_ = monitor;
#line 453 "../src/LibraryMonitor.vala"
				_tmp20_ = media_monitor_get_media_source_collection (_tmp19_);
#line 453 "../src/LibraryMonitor.vala"
				_tmp21_ = _tmp20_;
#line 453 "../src/LibraryMonitor.vala"
				_tmp22_ = data_collection_get_all ((DataCollection*) _tmp21_);
#line 453 "../src/LibraryMonitor.vala"
				_tmp23_ = _tmp22_;
#line 453 "../src/LibraryMonitor.vala"
				_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 453 "../src/LibraryMonitor.vala"
				_tmp25_ = _tmp24_;
#line 453 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_tmp23_);
#line 453 "../src/LibraryMonitor.vala"
				_data_collection_unref0 (_tmp21_);
#line 453 "../src/LibraryMonitor.vala"
				_object_it = _tmp25_;
#line 453 "../src/LibraryMonitor.vala"
				while (TRUE) {
#line 2527 "LibraryMonitor.c"
					GeeIterator* _tmp26_;
					DataObject* object = NULL;
					GeeIterator* _tmp27_;
					gpointer _tmp28_;
					Monitorable* monitorable = NULL;
					DataObject* _tmp29_;
					Monitorable* _tmp30_;
					gboolean _tmp31_ = FALSE;
					GeeSet* _tmp32_;
					Monitorable* _tmp35_;
					MediaMonitor* _tmp36_;
#line 453 "../src/LibraryMonitor.vala"
					_tmp26_ = _object_it;
#line 453 "../src/LibraryMonitor.vala"
					if (!gee_iterator_next (_tmp26_)) {
#line 453 "../src/LibraryMonitor.vala"
						break;
#line 2545 "LibraryMonitor.c"
					}
#line 453 "../src/LibraryMonitor.vala"
					_tmp27_ = _object_it;
#line 453 "../src/LibraryMonitor.vala"
					_tmp28_ = gee_iterator_get (_tmp27_);
#line 453 "../src/LibraryMonitor.vala"
					object = (DataObject*) _tmp28_;
#line 454 "../src/LibraryMonitor.vala"
					_tmp29_ = object;
#line 454 "../src/LibraryMonitor.vala"
					_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_MONITORABLE, Monitorable));
#line 454 "../src/LibraryMonitor.vala"
					monitorable = _tmp30_;
#line 456 "../src/LibraryMonitor.vala"
					_tmp32_ = monitorables;
#line 456 "../src/LibraryMonitor.vala"
					if (_tmp32_ != NULL) {
#line 2563 "LibraryMonitor.c"
						GeeSet* _tmp33_;
						Monitorable* _tmp34_;
#line 456 "../src/LibraryMonitor.vala"
						_tmp33_ = monitorables;
#line 456 "../src/LibraryMonitor.vala"
						_tmp34_ = monitorable;
#line 456 "../src/LibraryMonitor.vala"
						_tmp31_ = gee_collection_contains ((GeeCollection*) _tmp33_, _tmp34_);
#line 2572 "LibraryMonitor.c"
					} else {
#line 456 "../src/LibraryMonitor.vala"
						_tmp31_ = FALSE;
#line 2576 "LibraryMonitor.c"
					}
#line 456 "../src/LibraryMonitor.vala"
					if (_tmp31_) {
#line 457 "../src/LibraryMonitor.vala"
						_g_object_unref0 (monitorable);
#line 457 "../src/LibraryMonitor.vala"
						_g_object_unref0 (object);
#line 457 "../src/LibraryMonitor.vala"
						continue;
#line 2586 "LibraryMonitor.c"
					}
#line 459 "../src/LibraryMonitor.vala"
					_tmp35_ = monitorable;
#line 459 "../src/LibraryMonitor.vala"
					_tmp36_ = monitor;
#line 459 "../src/LibraryMonitor.vala"
					library_monitor_enqueue_verify_monitorable (self, _tmp35_, _tmp36_);
#line 453 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitorable);
#line 453 "../src/LibraryMonitor.vala"
					_g_object_unref0 (object);
#line 2598 "LibraryMonitor.c"
				}
#line 453 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_object_it);
#line 2602 "LibraryMonitor.c"
			}
			{
				GeeIterator* _source_it = NULL;
				MediaMonitor* _tmp37_;
				MediaSourceCollection* _tmp38_;
				MediaSourceCollection* _tmp39_;
				MediaSourceHoldingTank* _tmp40_;
				MediaSourceHoldingTank* _tmp41_;
				GeeCollection* _tmp42_;
				GeeCollection* _tmp43_;
				GeeIterator* _tmp44_;
				GeeIterator* _tmp45_;
#line 462 "../src/LibraryMonitor.vala"
				_tmp37_ = monitor;
#line 462 "../src/LibraryMonitor.vala"
				_tmp38_ = media_monitor_get_media_source_collection (_tmp37_);
#line 462 "../src/LibraryMonitor.vala"
				_tmp39_ = _tmp38_;
#line 462 "../src/LibraryMonitor.vala"
				_tmp40_ = media_source_collection_get_offline_bin (_tmp39_);
#line 462 "../src/LibraryMonitor.vala"
				_tmp41_ = _tmp40_;
#line 462 "../src/LibraryMonitor.vala"
				_tmp42_ = source_holding_tank_get_all ((SourceHoldingTank*) _tmp41_);
#line 462 "../src/LibraryMonitor.vala"
				_tmp43_ = _tmp42_;
#line 462 "../src/LibraryMonitor.vala"
				_tmp44_ = gee_iterable_iterator ((GeeIterable*) _tmp43_);
#line 462 "../src/LibraryMonitor.vala"
				_tmp45_ = _tmp44_;
#line 462 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_tmp43_);
#line 462 "../src/LibraryMonitor.vala"
				_source_holding_tank_unref0 (_tmp41_);
#line 462 "../src/LibraryMonitor.vala"
				_data_collection_unref0 (_tmp39_);
#line 462 "../src/LibraryMonitor.vala"
				_source_it = _tmp45_;
#line 462 "../src/LibraryMonitor.vala"
				while (TRUE) {
#line 2643 "LibraryMonitor.c"
					GeeIterator* _tmp46_;
					DataSource* source = NULL;
					GeeIterator* _tmp47_;
					gpointer _tmp48_;
					Monitorable* monitorable = NULL;
					DataSource* _tmp49_;
					Monitorable* _tmp50_;
					gboolean _tmp51_ = FALSE;
					GeeSet* _tmp52_;
					Monitorable* _tmp55_;
					MediaMonitor* _tmp56_;
#line 462 "../src/LibraryMonitor.vala"
					_tmp46_ = _source_it;
#line 462 "../src/LibraryMonitor.vala"
					if (!gee_iterator_next (_tmp46_)) {
#line 462 "../src/LibraryMonitor.vala"
						break;
#line 2661 "LibraryMonitor.c"
					}
#line 462 "../src/LibraryMonitor.vala"
					_tmp47_ = _source_it;
#line 462 "../src/LibraryMonitor.vala"
					_tmp48_ = gee_iterator_get (_tmp47_);
#line 462 "../src/LibraryMonitor.vala"
					source = (DataSource*) _tmp48_;
#line 464 "../src/LibraryMonitor.vala"
					_tmp49_ = source;
#line 464 "../src/LibraryMonitor.vala"
					_tmp50_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, TYPE_MONITORABLE, Monitorable));
#line 464 "../src/LibraryMonitor.vala"
					monitorable = _tmp50_;
#line 466 "../src/LibraryMonitor.vala"
					_tmp52_ = monitorables;
#line 466 "../src/LibraryMonitor.vala"
					if (_tmp52_ != NULL) {
#line 2679 "LibraryMonitor.c"
						GeeSet* _tmp53_;
						Monitorable* _tmp54_;
#line 466 "../src/LibraryMonitor.vala"
						_tmp53_ = monitorables;
#line 466 "../src/LibraryMonitor.vala"
						_tmp54_ = monitorable;
#line 466 "../src/LibraryMonitor.vala"
						_tmp51_ = gee_collection_contains ((GeeCollection*) _tmp53_, _tmp54_);
#line 2688 "LibraryMonitor.c"
					} else {
#line 466 "../src/LibraryMonitor.vala"
						_tmp51_ = FALSE;
#line 2692 "LibraryMonitor.c"
					}
#line 466 "../src/LibraryMonitor.vala"
					if (_tmp51_) {
#line 467 "../src/LibraryMonitor.vala"
						_g_object_unref0 (monitorable);
#line 467 "../src/LibraryMonitor.vala"
						_g_object_unref0 (source);
#line 467 "../src/LibraryMonitor.vala"
						continue;
#line 2702 "LibraryMonitor.c"
					}
#line 469 "../src/LibraryMonitor.vala"
					_tmp55_ = monitorable;
#line 469 "../src/LibraryMonitor.vala"
					_tmp56_ = monitor;
#line 469 "../src/LibraryMonitor.vala"
					library_monitor_enqueue_verify_monitorable (self, _tmp55_, _tmp56_);
#line 462 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitorable);
#line 462 "../src/LibraryMonitor.vala"
					_g_object_unref0 (source);
#line 2714 "LibraryMonitor.c"
				}
#line 462 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_source_it);
#line 2718 "LibraryMonitor.c"
			}
#line 446 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitorables);
#line 446 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 2724 "LibraryMonitor.c"
		}
	}
#line 474 "../src/LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 2729 "LibraryMonitor.c"
		GeeHashSet* _tmp57_;
#line 475 "../src/LibraryMonitor.vala"
		_tmp57_ = self->priv->unknown_files;
#line 475 "../src/LibraryMonitor.vala"
		library_monitor_enqueue_import_many (self, (GeeCollection*) _tmp57_);
#line 2735 "LibraryMonitor.c"
	}
#line 478 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->discovered);
#line 478 "../src/LibraryMonitor.vala"
	self->priv->discovered = NULL;
#line 479 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->unknown_files);
#line 479 "../src/LibraryMonitor.vala"
	self->priv->unknown_files = NULL;
#line 483 "../src/LibraryMonitor.vala"
	_tmp58_ = tombstone_global;
#line 483 "../src/LibraryMonitor.vala"
	_tmp59_ = self->priv->cancellable;
#line 483 "../src/LibraryMonitor.vala"
	tombstone_source_collection_launch_scan (_tmp58_, (DirectoryMonitor*) self, _tmp59_);
#line 486 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_completed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor));
#line 2753 "LibraryMonitor.c"
}

static void
library_monitor_enqueue_verify_monitorable (LibraryMonitor* self,
                                            Monitorable* monitorable,
                                            MediaMonitor* monitor)
{
	gboolean offered = FALSE;
	GeeQueue* _tmp0_;
	LibraryMonitorVerifyJob* _tmp1_;
	LibraryMonitorVerifyJob* _tmp2_;
	gboolean _tmp3_;
#line 489 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 489 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 489 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitor != NULL);
#line 490 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->verify_queue;
#line 490 "../src/LibraryMonitor.vala"
	_tmp1_ = library_monitor_verify_job_new (monitorable, monitor);
#line 490 "../src/LibraryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 490 "../src/LibraryMonitor.vala"
	_tmp3_ = gee_queue_offer (_tmp0_, _tmp2_);
#line 490 "../src/LibraryMonitor.vala"
	_library_monitor_verify_job_unref0 (_tmp2_);
#line 490 "../src/LibraryMonitor.vala"
	offered = _tmp3_;
#line 491 "../src/LibraryMonitor.vala"
	_vala_assert (offered, "offered");
#line 493 "../src/LibraryMonitor.vala"
	library_monitor_execute_next_verify_job (self);
#line 2788 "LibraryMonitor.c"
}

static void
library_monitor_execute_next_verify_job (LibraryMonitor* self)
{
	gboolean _tmp0_ = FALSE;
	LibraryMonitorVerifyJob* job = NULL;
	GeeQueue* _tmp4_;
	gpointer _tmp5_;
	LibraryMonitorVerifyJob* _tmp6_;
	gint _tmp7_;
	LibraryMonitorVerifyJob* _tmp8_;
	Monitorable* _tmp9_;
	LibraryMonitorVerifyJob* _tmp10_;
	MediaMonitor* _tmp11_;
#line 496 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 497 "../src/LibraryMonitor.vala"
	if (self->priv->outstanding_verify_jobs >= LIBRARY_MONITOR_MAX_VERIFY_EXISTING_MEDIA_JOBS) {
#line 497 "../src/LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 2810 "LibraryMonitor.c"
	} else {
		GeeQueue* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 497 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->verify_queue;
#line 497 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 497 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 497 "../src/LibraryMonitor.vala"
		_tmp0_ = _tmp3_ == 0;
#line 2823 "LibraryMonitor.c"
	}
#line 497 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 498 "../src/LibraryMonitor.vala"
		return;
#line 2829 "LibraryMonitor.c"
	}
#line 500 "../src/LibraryMonitor.vala"
	_tmp4_ = self->priv->verify_queue;
#line 500 "../src/LibraryMonitor.vala"
	_tmp5_ = gee_queue_poll (_tmp4_);
#line 500 "../src/LibraryMonitor.vala"
	job = (LibraryMonitorVerifyJob*) _tmp5_;
#line 501 "../src/LibraryMonitor.vala"
	_tmp6_ = job;
#line 501 "../src/LibraryMonitor.vala"
	_vala_assert (_tmp6_ != NULL, "job != null");
#line 503 "../src/LibraryMonitor.vala"
	_tmp7_ = self->priv->outstanding_verify_jobs;
#line 503 "../src/LibraryMonitor.vala"
	self->priv->outstanding_verify_jobs = _tmp7_ + 1;
#line 504 "../src/LibraryMonitor.vala"
	_tmp8_ = job;
#line 504 "../src/LibraryMonitor.vala"
	_tmp9_ = _tmp8_->monitorable;
#line 504 "../src/LibraryMonitor.vala"
	_tmp10_ = job;
#line 504 "../src/LibraryMonitor.vala"
	_tmp11_ = _tmp10_->monitor;
#line 504 "../src/LibraryMonitor.vala"
	library_monitor_verify_monitorable (self, _tmp9_, _tmp11_, NULL, NULL);
#line 496 "../src/LibraryMonitor.vala"
	_library_monitor_verify_job_unref0 (job);
#line 2857 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable_data_free (gpointer _data)
{
	LibraryMonitorVerifyMonitorableData* _data_;
	_data_ = _data;
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->monitorable);
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->monitor);
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 110 "../src/LibraryMonitor.vala"
	g_slice_free (LibraryMonitorVerifyMonitorableData, _data_);
#line 2873 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable (LibraryMonitor* self,
                                    Monitorable* monitorable,
                                    MediaMonitor* monitor,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	LibraryMonitorVerifyMonitorableData* _data_;
	LibraryMonitor* _tmp0_;
	Monitorable* _tmp1_;
	MediaMonitor* _tmp2_;
#line 110 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 110 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitor != NULL);
#line 110 "../src/LibraryMonitor.vala"
	_data_ = g_slice_new0 (LibraryMonitorVerifyMonitorableData);
#line 110 "../src/LibraryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 110 "../src/LibraryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, library_monitor_verify_monitorable_data_free);
#line 110 "../src/LibraryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 110 "../src/LibraryMonitor.vala"
	_data_->self = _tmp0_;
#line 110 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (monitorable);
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->monitorable);
#line 110 "../src/LibraryMonitor.vala"
	_data_->monitorable = _tmp1_;
#line 110 "../src/LibraryMonitor.vala"
	_tmp2_ = _g_object_ref0 (monitor);
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->monitor);
#line 110 "../src/LibraryMonitor.vala"
	_data_->monitor = _tmp2_;
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_verify_monitorable_co (_data_);
#line 2917 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable_finish (LibraryMonitor* self,
                                           GAsyncResult* _res_)
{
	LibraryMonitorVerifyMonitorableData* _data_;
#line 110 "../src/LibraryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2927 "LibraryMonitor.c"
}

static void
_vala_array_add3 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
#line 514 "../src/LibraryMonitor.vala"
	if ((*length) == (*size)) {
#line 514 "../src/LibraryMonitor.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 514 "../src/LibraryMonitor.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 2942 "LibraryMonitor.c"
	}
#line 514 "../src/LibraryMonitor.vala"
	(*array)[(*length)++] = value;
#line 514 "../src/LibraryMonitor.vala"
	(*array)[*length] = NULL;
#line 2948 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	LibraryMonitorVerifyMonitorableData* _data_;
#line 523 "../src/LibraryMonitor.vala"
	_data_ = _user_data_;
#line 523 "../src/LibraryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 523 "../src/LibraryMonitor.vala"
	_data_->_res_ = _res_;
#line 523 "../src/LibraryMonitor.vala"
	library_monitor_verify_monitorable_co (_data_);
#line 2965 "LibraryMonitor.c"
}

static gboolean
_library_monitor_verify_monitorable_co_gsource_func (gpointer self)
{
	gboolean result;
	result = library_monitor_verify_monitorable_co (self);
#line 544 "../src/LibraryMonitor.vala"
	return result;
#line 2975 "LibraryMonitor.c"
}

static gboolean
library_monitor_verify_monitorable_co (LibraryMonitorVerifyMonitorableData* _data_)
{
#line 507 "../src/LibraryMonitor.vala"
	switch (_data_->_state_) {
#line 507 "../src/LibraryMonitor.vala"
		case 0:
#line 2985 "LibraryMonitor.c"
		goto _state_0;
#line 507 "../src/LibraryMonitor.vala"
		case 1:
#line 2989 "LibraryMonitor.c"
		goto _state_1;
#line 507 "../src/LibraryMonitor.vala"
		case 2:
#line 2993 "LibraryMonitor.c"
		goto _state_2;
		default:
#line 507 "../src/LibraryMonitor.vala"
		g_assert_not_reached ();
#line 2998 "LibraryMonitor.c"
	}
	_state_0:
#line 508 "../src/LibraryMonitor.vala"
	_data_->_tmp0_ = g_new0 (GFile*, 1 + 1);
#line 508 "../src/LibraryMonitor.vala"
	_data_->files = _data_->_tmp0_;
#line 508 "../src/LibraryMonitor.vala"
	_data_->files_length1 = 1;
#line 508 "../src/LibraryMonitor.vala"
	_data_->_files_size_ = _data_->files_length1;
#line 509 "../src/LibraryMonitor.vala"
	_data_->_tmp1_ = _data_->files;
#line 509 "../src/LibraryMonitor.vala"
	_data_->_tmp1__length1 = _data_->files_length1;
#line 509 "../src/LibraryMonitor.vala"
	_data_->_tmp2_ = media_monitor_get_master_file (_data_->monitor, _data_->monitorable);
#line 509 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->_tmp1_[0]);
#line 509 "../src/LibraryMonitor.vala"
	_data_->_tmp1_[0] = _data_->_tmp2_;
#line 511 "../src/LibraryMonitor.vala"
	_data_->_tmp3_ = 0;
#line 511 "../src/LibraryMonitor.vala"
	_data_->_tmp4_ = media_monitor_get_auxilliary_backing_files (_data_->monitor, _data_->monitorable, &_data_->_tmp3_);
#line 511 "../src/LibraryMonitor.vala"
	_data_->aux_files = _data_->_tmp4_;
#line 511 "../src/LibraryMonitor.vala"
	_data_->aux_files_length1 = _data_->_tmp3_;
#line 511 "../src/LibraryMonitor.vala"
	_data_->_aux_files_size_ = _data_->aux_files_length1;
#line 512 "../src/LibraryMonitor.vala"
	_data_->_tmp5_ = _data_->aux_files;
#line 512 "../src/LibraryMonitor.vala"
	_data_->_tmp5__length1 = _data_->aux_files_length1;
#line 512 "../src/LibraryMonitor.vala"
	if (_data_->_tmp5_ != NULL) {
#line 513 "../src/LibraryMonitor.vala"
		_data_->_tmp6_ = _data_->aux_files;
#line 513 "../src/LibraryMonitor.vala"
		_data_->_tmp6__length1 = _data_->aux_files_length1;
#line 3039 "LibraryMonitor.c"
		{
#line 513 "../src/LibraryMonitor.vala"
			_data_->aux_file_collection_length1 = 0;
#line 513 "../src/LibraryMonitor.vala"
			_data_->_aux_file_collection_size_ = 0;
#line 513 "../src/LibraryMonitor.vala"
			_data_->aux_file_collection = _data_->_tmp6_;
#line 513 "../src/LibraryMonitor.vala"
			_data_->aux_file_collection_length1 = _data_->_tmp6__length1;
#line 513 "../src/LibraryMonitor.vala"
			for (_data_->aux_file_it = 0; _data_->aux_file_it < _data_->aux_file_collection_length1; _data_->aux_file_it = _data_->aux_file_it + 1) {
#line 513 "../src/LibraryMonitor.vala"
				_data_->_tmp7_ = _g_object_ref0 (_data_->aux_file_collection[_data_->aux_file_it]);
#line 513 "../src/LibraryMonitor.vala"
				_data_->aux_file = _data_->_tmp7_;
#line 3055 "LibraryMonitor.c"
				{
#line 514 "../src/LibraryMonitor.vala"
					_data_->_tmp8_ = _data_->aux_file;
#line 514 "../src/LibraryMonitor.vala"
					_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 514 "../src/LibraryMonitor.vala"
					_vala_array_add3 (&_data_->files, &_data_->files_length1, &_data_->_files_size_, _data_->_tmp9_);
#line 513 "../src/LibraryMonitor.vala"
					_g_object_unref0 (_data_->aux_file);
#line 3065 "LibraryMonitor.c"
				}
			}
		}
	}
	{
#line 517 "../src/LibraryMonitor.vala"
		_data_->ctr = 0;
#line 3073 "LibraryMonitor.c"
		{
#line 517 "../src/LibraryMonitor.vala"
			_data_->_tmp10_ = TRUE;
#line 517 "../src/LibraryMonitor.vala"
			while (TRUE) {
#line 517 "../src/LibraryMonitor.vala"
				if (!_data_->_tmp10_) {
#line 517 "../src/LibraryMonitor.vala"
					_data_->_tmp11_ = _data_->ctr;
#line 517 "../src/LibraryMonitor.vala"
					_data_->ctr = _data_->_tmp11_ + 1;
#line 3085 "LibraryMonitor.c"
				}
#line 517 "../src/LibraryMonitor.vala"
				_data_->_tmp10_ = FALSE;
#line 517 "../src/LibraryMonitor.vala"
				_data_->_tmp12_ = _data_->files;
#line 517 "../src/LibraryMonitor.vala"
				_data_->_tmp12__length1 = _data_->files_length1;
#line 517 "../src/LibraryMonitor.vala"
				if (!(_data_->ctr < _data_->_tmp12__length1)) {
#line 517 "../src/LibraryMonitor.vala"
					break;
#line 3097 "LibraryMonitor.c"
				}
#line 518 "../src/LibraryMonitor.vala"
				_data_->_tmp13_ = _data_->files;
#line 518 "../src/LibraryMonitor.vala"
				_data_->_tmp13__length1 = _data_->files_length1;
#line 518 "../src/LibraryMonitor.vala"
				_data_->_tmp14_ = _data_->_tmp13_[_data_->ctr];
#line 518 "../src/LibraryMonitor.vala"
				_data_->_tmp15_ = _g_object_ref0 (_data_->_tmp14_);
#line 518 "../src/LibraryMonitor.vala"
				_data_->file = _data_->_tmp15_;
#line 520 "../src/LibraryMonitor.vala"
				_data_->_tmp16_ = _data_->file;
#line 520 "../src/LibraryMonitor.vala"
				_data_->_tmp17_ = directory_monitor_get_file_info ((DirectoryMonitor*) _data_->self, _data_->_tmp16_);
#line 520 "../src/LibraryMonitor.vala"
				_data_->info = _data_->_tmp17_;
#line 521 "../src/LibraryMonitor.vala"
				_data_->_tmp18_ = _data_->info;
#line 521 "../src/LibraryMonitor.vala"
				if (_data_->_tmp18_ == NULL) {
#line 3119 "LibraryMonitor.c"
					{
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp20_ = _data_->file;
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp21_ = _data_->self->priv->cancellable;
#line 523 "../src/LibraryMonitor.vala"
						_data_->_state_ = 1;
#line 523 "../src/LibraryMonitor.vala"
						g_file_query_info_async (_data_->_tmp20_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_FILE_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp21_, library_monitor_verify_monitorable_ready, _data_);
#line 523 "../src/LibraryMonitor.vala"
						return FALSE;
#line 3131 "LibraryMonitor.c"
						_state_1:
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp22_ = g_file_query_info_finish (_data_->_tmp20_, _data_->_res_, &_data_->_inner_error0_);
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp19_ = _data_->_tmp22_;
#line 523 "../src/LibraryMonitor.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3139 "LibraryMonitor.c"
							goto __catch0_g_error;
						}
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp23_ = _data_->_tmp19_;
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp19_ = NULL;
#line 523 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->info);
#line 523 "../src/LibraryMonitor.vala"
						_data_->info = _data_->_tmp23_;
#line 522 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->_tmp19_);
#line 3152 "LibraryMonitor.c"
					}
					goto __finally0;
					__catch0_g_error:
					{
#line 522 "../src/LibraryMonitor.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 3159 "LibraryMonitor.c"
					}
					__finally0:
#line 522 "../src/LibraryMonitor.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 522 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->info);
#line 522 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->file);
#line 522 "../src/LibraryMonitor.vala"
						_data_->aux_files = (_vala_array_free (_data_->aux_files, _data_->aux_files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 522 "../src/LibraryMonitor.vala"
						_data_->files = (_vala_array_free (_data_->files, _data_->files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 522 "../src/LibraryMonitor.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 522 "../src/LibraryMonitor.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 522 "../src/LibraryMonitor.vala"
						g_object_unref (_data_->_async_result);
#line 522 "../src/LibraryMonitor.vala"
						return FALSE;
#line 3180 "LibraryMonitor.c"
					}
				}
#line 531 "../src/LibraryMonitor.vala"
				if (_data_->ctr == 0) {
#line 532 "../src/LibraryMonitor.vala"
					_data_->_tmp25_ = _data_->info;
#line 532 "../src/LibraryMonitor.vala"
					if (_data_->_tmp25_ != NULL) {
#line 532 "../src/LibraryMonitor.vala"
						_data_->_tmp24_ = media_monitor_is_offline (_data_->monitor, _data_->monitorable);
#line 3191 "LibraryMonitor.c"
					} else {
#line 532 "../src/LibraryMonitor.vala"
						_data_->_tmp24_ = FALSE;
#line 3195 "LibraryMonitor.c"
					}
#line 532 "../src/LibraryMonitor.vala"
					if (_data_->_tmp24_) {
#line 533 "../src/LibraryMonitor.vala"
						media_monitor_update_online (_data_->monitor, _data_->monitorable);
#line 3201 "LibraryMonitor.c"
					} else {
#line 534 "../src/LibraryMonitor.vala"
						_data_->_tmp27_ = _data_->info;
#line 534 "../src/LibraryMonitor.vala"
						if (_data_->_tmp27_ == NULL) {
#line 534 "../src/LibraryMonitor.vala"
							_data_->_tmp26_ = !media_monitor_is_offline (_data_->monitor, _data_->monitorable);
#line 3209 "LibraryMonitor.c"
						} else {
#line 534 "../src/LibraryMonitor.vala"
							_data_->_tmp26_ = FALSE;
#line 3213 "LibraryMonitor.c"
						}
#line 534 "../src/LibraryMonitor.vala"
						if (_data_->_tmp26_) {
#line 535 "../src/LibraryMonitor.vala"
							media_monitor_update_offline (_data_->monitor, _data_->monitorable);
#line 3219 "LibraryMonitor.c"
						}
					}
				}
#line 538 "../src/LibraryMonitor.vala"
				_data_->_tmp28_ = _data_->file;
#line 538 "../src/LibraryMonitor.vala"
				_data_->_tmp29_ = _data_->info;
#line 538 "../src/LibraryMonitor.vala"
				media_monitor_update_backing_file_info (_data_->monitor, _data_->monitorable, _data_->_tmp28_, _data_->_tmp29_);
#line 517 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->info);
#line 517 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->file);
#line 3233 "LibraryMonitor.c"
			}
		}
	}
#line 541 "../src/LibraryMonitor.vala"
	_data_->_tmp30_ = _data_->self->priv->completed_monitorable_verifies;
#line 541 "../src/LibraryMonitor.vala"
	_data_->self->priv->completed_monitorable_verifies = _data_->_tmp30_ + 1;
#line 542 "../src/LibraryMonitor.vala"
	g_signal_emit (_data_->self, library_monitor_signals[LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL], 0, _data_->self->priv->completed_monitorable_verifies, _data_->self->priv->total_monitorable_verifies);
#line 544 "../src/LibraryMonitor.vala"
	g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _library_monitor_verify_monitorable_co_gsource_func, _data_, NULL);
#line 545 "../src/LibraryMonitor.vala"
	_data_->_state_ = 2;
#line 545 "../src/LibraryMonitor.vala"
	return FALSE;
#line 3249 "LibraryMonitor.c"
	_state_2:
	;
#line 548 "../src/LibraryMonitor.vala"
	_vala_assert (_data_->self->priv->outstanding_verify_jobs > 0, "outstanding_verify_jobs > 0");
#line 549 "../src/LibraryMonitor.vala"
	_data_->_tmp31_ = _data_->self->priv->outstanding_verify_jobs;
#line 549 "../src/LibraryMonitor.vala"
	_data_->self->priv->outstanding_verify_jobs = _data_->_tmp31_ - 1;
#line 551 "../src/LibraryMonitor.vala"
	library_monitor_execute_next_verify_job (_data_->self);
#line 507 "../src/LibraryMonitor.vala"
	_data_->aux_files = (_vala_array_free (_data_->aux_files, _data_->aux_files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 507 "../src/LibraryMonitor.vala"
	_data_->files = (_vala_array_free (_data_->files, _data_->files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 507 "../src/LibraryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 507 "../src/LibraryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 507 "../src/LibraryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 507 "../src/LibraryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3272 "LibraryMonitor.c"
		}
	}
#line 507 "../src/LibraryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 507 "../src/LibraryMonitor.vala"
	return FALSE;
#line 3279 "LibraryMonitor.c"
}

static void
library_monitor_on_config_changed (LibraryMonitor* self,
                                   const gchar* key)
{
	gboolean value = FALSE;
	GSettings* _tmp0_;
#line 554 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/LibraryMonitor.vala"
	g_return_if_fail (key != NULL);
#line 555 "../src/LibraryMonitor.vala"
	if (g_strcmp0 (key, "auto-import") != 0) {
#line 556 "../src/LibraryMonitor.vala"
		return;
#line 3296 "LibraryMonitor.c"
	}
#line 559 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->file_settings;
#line 559 "../src/LibraryMonitor.vala"
	value = g_settings_get_boolean (_tmp0_, "auto-import");
#line 561 "../src/LibraryMonitor.vala"
	if (self->priv->auto_import == value) {
#line 562 "../src/LibraryMonitor.vala"
		return;
#line 3306 "LibraryMonitor.c"
	}
#line 564 "../src/LibraryMonitor.vala"
	self->priv->auto_import = value;
#line 565 "../src/LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 566 "../src/LibraryMonitor.vala"
		if (!commandline_options_no_runtime_monitoring) {
#line 567 "../src/LibraryMonitor.vala"
			library_monitor_import_unrepresented_files (self);
#line 3316 "LibraryMonitor.c"
		}
	} else {
#line 569 "../src/LibraryMonitor.vala"
		library_monitor_cancel_batch_imports (self);
#line 3321 "LibraryMonitor.c"
	}
}

static void
library_monitor_enqueue_import (LibraryMonitor* self,
                                GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GeeHashSet* _tmp2_;
#line 573 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 573 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 574 "../src/LibraryMonitor.vala"
	_tmp2_ = self->priv->pending_imports;
#line 574 "../src/LibraryMonitor.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, file)) {
#line 574 "../src/LibraryMonitor.vala"
		_tmp1_ = library_monitor_is_supported_filetype (self, file);
#line 3342 "LibraryMonitor.c"
	} else {
#line 574 "../src/LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 3346 "LibraryMonitor.c"
	}
#line 574 "../src/LibraryMonitor.vala"
	if (_tmp1_) {
#line 574 "../src/LibraryMonitor.vala"
		_tmp0_ = !library_monitor_is_blacklisted (file);
#line 3352 "LibraryMonitor.c"
	} else {
#line 574 "../src/LibraryMonitor.vala"
		_tmp0_ = FALSE;
#line 3356 "LibraryMonitor.c"
	}
#line 574 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 3360 "LibraryMonitor.c"
		GeeHashSet* _tmp3_;
#line 575 "../src/LibraryMonitor.vala"
		_tmp3_ = self->priv->import_queue;
#line 575 "../src/LibraryMonitor.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, file);
#line 3366 "LibraryMonitor.c"
	}
}

static void
library_monitor_enqueue_import_many (LibraryMonitor* self,
                                     GeeCollection* files)
{
#line 578 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/LibraryMonitor.vala"
	g_return_if_fail (files != NULL);
#line 3378 "LibraryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeIterator* _tmp0_;
#line 579 "../src/LibraryMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) files);
#line 579 "../src/LibraryMonitor.vala"
		_file_it = _tmp0_;
#line 579 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 3388 "LibraryMonitor.c"
			GeeIterator* _tmp1_;
			GFile* file = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GFile* _tmp4_;
#line 579 "../src/LibraryMonitor.vala"
			_tmp1_ = _file_it;
#line 579 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 579 "../src/LibraryMonitor.vala"
				break;
#line 3400 "LibraryMonitor.c"
			}
#line 579 "../src/LibraryMonitor.vala"
			_tmp2_ = _file_it;
#line 579 "../src/LibraryMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 579 "../src/LibraryMonitor.vala"
			file = (GFile*) _tmp3_;
#line 580 "../src/LibraryMonitor.vala"
			_tmp4_ = file;
#line 580 "../src/LibraryMonitor.vala"
			library_monitor_enqueue_import (self, _tmp4_);
#line 579 "../src/LibraryMonitor.vala"
			_g_object_unref0 (file);
#line 3414 "LibraryMonitor.c"
		}
#line 579 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 3418 "LibraryMonitor.c"
	}
}

static void
library_monitor_remove_queued_import (LibraryMonitor* self,
                                      GFile* file)
{
	GeeHashSet* _tmp0_;
#line 583 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 583 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 584 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->import_queue;
#line 584 "../src/LibraryMonitor.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, file);
#line 3435 "LibraryMonitor.c"
}

static gboolean
library_monitor_on_flush_import_queue (LibraryMonitor* self)
{
	GCancellable* _tmp0_;
	GeeHashSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	BatchImport* _tmp4_;
	GeeHashSet* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint64 now = 0LL;
	gboolean _tmp10_ = FALSE;
	BatchImportRoll* _tmp11_;
	GeeArrayList* jobs = NULL;
	GeeArrayList* _tmp13_;
	GeeHashSet* _tmp26_;
	BatchImport* importer = NULL;
	GeeArrayList* _tmp27_;
	BatchImportRoll* _tmp28_;
	BatchImport* _tmp29_;
	BatchImport* _tmp30_;
	BatchImport* _tmp31_;
	GeeArrayList* _tmp32_;
	BatchImport* _tmp33_;
	gboolean result;
#line 587 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 588 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 588 "../src/LibraryMonitor.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 589 "../src/LibraryMonitor.vala"
		result = FALSE;
#line 589 "../src/LibraryMonitor.vala"
		return result;
#line 3476 "LibraryMonitor.c"
	}
#line 591 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->import_queue;
#line 591 "../src/LibraryMonitor.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 591 "../src/LibraryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 591 "../src/LibraryMonitor.vala"
	if (_tmp3_ == 0) {
#line 592 "../src/LibraryMonitor.vala"
		result = TRUE;
#line 592 "../src/LibraryMonitor.vala"
		return result;
#line 3490 "LibraryMonitor.c"
	}
#line 596 "../src/LibraryMonitor.vala"
	_tmp4_ = self->priv->current_batch_import;
#line 596 "../src/LibraryMonitor.vala"
	if (_tmp4_ != NULL) {
#line 597 "../src/LibraryMonitor.vala"
		result = TRUE;
#line 597 "../src/LibraryMonitor.vala"
		return result;
#line 3500 "LibraryMonitor.c"
	}
#line 599 "../src/LibraryMonitor.vala"
	_tmp5_ = self->priv->import_queue;
#line 599 "../src/LibraryMonitor.vala"
	_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 599 "../src/LibraryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 599 "../src/LibraryMonitor.vala"
	_tmp8_ = g_strdup_printf ("Auto-importing %d files", _tmp7_);
#line 599 "../src/LibraryMonitor.vala"
	_tmp9_ = _tmp8_;
#line 599 "../src/LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp9_);
#line 599 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp9_);
#line 604 "../src/LibraryMonitor.vala"
	now = now_sec ();
#line 605 "../src/LibraryMonitor.vala"
	_tmp11_ = self->priv->current_import_roll;
#line 605 "../src/LibraryMonitor.vala"
	if (_tmp11_ == NULL) {
#line 605 "../src/LibraryMonitor.vala"
		_tmp10_ = TRUE;
#line 3524 "LibraryMonitor.c"
	} else {
#line 605 "../src/LibraryMonitor.vala"
		_tmp10_ = (now - self->priv->last_import_roll_use) >= ((gint64) LIBRARY_MONITOR_IMPORT_ROLL_QUIET_SEC);
#line 3528 "LibraryMonitor.c"
	}
#line 605 "../src/LibraryMonitor.vala"
	if (_tmp10_) {
#line 3532 "LibraryMonitor.c"
		BatchImportRoll* _tmp12_;
#line 606 "../src/LibraryMonitor.vala"
		_tmp12_ = batch_import_roll_new ();
#line 606 "../src/LibraryMonitor.vala"
		_batch_import_roll_unref0 (self->priv->current_import_roll);
#line 606 "../src/LibraryMonitor.vala"
		self->priv->current_import_roll = _tmp12_;
#line 3540 "LibraryMonitor.c"
	}
#line 609 "../src/LibraryMonitor.vala"
	self->priv->last_import_roll_use = now;
#line 611 "../src/LibraryMonitor.vala"
	_tmp13_ = gee_array_list_new (TYPE_BATCH_IMPORT_JOB, (GBoxedCopyFunc) batch_import_job_ref, (GDestroyNotify) batch_import_job_unref, NULL, NULL, NULL);
#line 611 "../src/LibraryMonitor.vala"
	jobs = _tmp13_;
#line 3548 "LibraryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashSet* _tmp14_;
		GeeIterator* _tmp15_;
#line 612 "../src/LibraryMonitor.vala"
		_tmp14_ = self->priv->import_queue;
#line 612 "../src/LibraryMonitor.vala"
		_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 612 "../src/LibraryMonitor.vala"
		_file_it = _tmp15_;
#line 612 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 3561 "LibraryMonitor.c"
			GeeIterator* _tmp16_;
			GFile* file = NULL;
			GeeIterator* _tmp17_;
			gpointer _tmp18_;
			GFile* _tmp19_;
			GeeArrayList* _tmp20_;
			GFile* _tmp21_;
			FileImportJob* _tmp22_;
			FileImportJob* _tmp23_;
			GeeHashSet* _tmp24_;
			GFile* _tmp25_;
#line 612 "../src/LibraryMonitor.vala"
			_tmp16_ = _file_it;
#line 612 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp16_)) {
#line 612 "../src/LibraryMonitor.vala"
				break;
#line 3579 "LibraryMonitor.c"
			}
#line 612 "../src/LibraryMonitor.vala"
			_tmp17_ = _file_it;
#line 612 "../src/LibraryMonitor.vala"
			_tmp18_ = gee_iterator_get (_tmp17_);
#line 612 "../src/LibraryMonitor.vala"
			file = (GFile*) _tmp18_;
#line 613 "../src/LibraryMonitor.vala"
			_tmp19_ = file;
#line 613 "../src/LibraryMonitor.vala"
			if (library_monitor_is_blacklisted (_tmp19_)) {
#line 614 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 614 "../src/LibraryMonitor.vala"
				continue;
#line 3595 "LibraryMonitor.c"
			}
#line 616 "../src/LibraryMonitor.vala"
			_tmp20_ = jobs;
#line 616 "../src/LibraryMonitor.vala"
			_tmp21_ = file;
#line 616 "../src/LibraryMonitor.vala"
			_tmp22_ = file_import_job_new (_tmp21_, FALSE);
#line 616 "../src/LibraryMonitor.vala"
			_tmp23_ = _tmp22_;
#line 616 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, (BatchImportJob*) _tmp23_);
#line 616 "../src/LibraryMonitor.vala"
			_batch_import_job_unref0 (_tmp23_);
#line 617 "../src/LibraryMonitor.vala"
			_tmp24_ = self->priv->pending_imports;
#line 617 "../src/LibraryMonitor.vala"
			_tmp25_ = file;
#line 617 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 612 "../src/LibraryMonitor.vala"
			_g_object_unref0 (file);
#line 3617 "LibraryMonitor.c"
		}
#line 612 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 3621 "LibraryMonitor.c"
	}
#line 620 "../src/LibraryMonitor.vala"
	_tmp26_ = self->priv->import_queue;
#line 620 "../src/LibraryMonitor.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp26_);
#line 622 "../src/LibraryMonitor.vala"
	_tmp27_ = jobs;
#line 622 "../src/LibraryMonitor.vala"
	_tmp28_ = self->priv->current_import_roll;
#line 622 "../src/LibraryMonitor.vala"
	_tmp29_ = batch_import_new ((GeeIterable*) _tmp27_, "LibraryMonitor autoimport", NULL, NULL, NULL, NULL, NULL, _tmp28_, NULL);
#line 622 "../src/LibraryMonitor.vala"
	importer = _tmp29_;
#line 624 "../src/LibraryMonitor.vala"
	_tmp30_ = importer;
#line 624 "../src/LibraryMonitor.vala"
	batch_import_set_untrash_duplicates (_tmp30_, FALSE);
#line 625 "../src/LibraryMonitor.vala"
	_tmp31_ = importer;
#line 625 "../src/LibraryMonitor.vala"
	batch_import_set_mark_duplicates_online (_tmp31_, FALSE);
#line 626 "../src/LibraryMonitor.vala"
	_tmp32_ = self->priv->batch_import_queue;
#line 626 "../src/LibraryMonitor.vala"
	_tmp33_ = importer;
#line 626 "../src/LibraryMonitor.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 628 "../src/LibraryMonitor.vala"
	library_monitor_schedule_next_batch_import (self);
#line 630 "../src/LibraryMonitor.vala"
	result = TRUE;
#line 630 "../src/LibraryMonitor.vala"
	_g_object_unref0 (importer);
#line 630 "../src/LibraryMonitor.vala"
	_g_object_unref0 (jobs);
#line 630 "../src/LibraryMonitor.vala"
	return result;
#line 3659 "LibraryMonitor.c"
}

static void
_library_monitor_on_import_preparing_batch_import_preparing (BatchImport* _sender,
                                                             gpointer self)
{
#line 638 "../src/LibraryMonitor.vala"
	library_monitor_on_import_preparing ((LibraryMonitor*) self);
#line 3668 "LibraryMonitor.c"
}

static void
_library_monitor_on_import_progress_batch_import_progress (BatchImport* _sender,
                                                           guint64 completed_bytes,
                                                           guint64 total_bytes,
                                                           gpointer self)
{
#line 639 "../src/LibraryMonitor.vala"
	library_monitor_on_import_progress ((LibraryMonitor*) self, completed_bytes, total_bytes);
#line 3679 "LibraryMonitor.c"
}

static void
_library_monitor_on_import_complete_batch_import_import_complete (BatchImport* _sender,
                                                                  ImportManifest* manifest,
                                                                  BatchImportRoll* import_roll,
                                                                  gpointer self)
{
#line 640 "../src/LibraryMonitor.vala"
	library_monitor_on_import_complete ((LibraryMonitor*) self, _sender, manifest, import_roll);
#line 3690 "LibraryMonitor.c"
}

static void
library_monitor_schedule_next_batch_import (LibraryMonitor* self)
{
	gboolean _tmp0_ = FALSE;
	BatchImport* _tmp1_;
	GeeArrayList* _tmp5_;
	gpointer _tmp6_;
	BatchImport* _tmp7_;
	BatchImport* _tmp8_;
	BatchImport* _tmp9_;
	BatchImport* _tmp10_;
#line 633 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 634 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->current_batch_import;
#line 634 "../src/LibraryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 634 "../src/LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 3712 "LibraryMonitor.c"
	} else {
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 634 "../src/LibraryMonitor.vala"
		_tmp2_ = self->priv->batch_import_queue;
#line 634 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 634 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 634 "../src/LibraryMonitor.vala"
		_tmp0_ = _tmp4_ == 0;
#line 3725 "LibraryMonitor.c"
	}
#line 634 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 635 "../src/LibraryMonitor.vala"
		return;
#line 3731 "LibraryMonitor.c"
	}
#line 637 "../src/LibraryMonitor.vala"
	_tmp5_ = self->priv->batch_import_queue;
#line 637 "../src/LibraryMonitor.vala"
	_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, 0);
#line 637 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->current_batch_import);
#line 637 "../src/LibraryMonitor.vala"
	self->priv->current_batch_import = (BatchImport*) _tmp6_;
#line 638 "../src/LibraryMonitor.vala"
	_tmp7_ = self->priv->current_batch_import;
#line 638 "../src/LibraryMonitor.vala"
	g_signal_connect_object (_tmp7_, "preparing", (GCallback) _library_monitor_on_import_preparing_batch_import_preparing, self, 0);
#line 639 "../src/LibraryMonitor.vala"
	_tmp8_ = self->priv->current_batch_import;
#line 639 "../src/LibraryMonitor.vala"
	g_signal_connect_object (_tmp8_, "progress", (GCallback) _library_monitor_on_import_progress_batch_import_progress, self, 0);
#line 640 "../src/LibraryMonitor.vala"
	_tmp9_ = self->priv->current_batch_import;
#line 640 "../src/LibraryMonitor.vala"
	g_signal_connect_object (_tmp9_, "import-complete", (GCallback) _library_monitor_on_import_complete_batch_import_import_complete, self, 0);
#line 641 "../src/LibraryMonitor.vala"
	_tmp10_ = self->priv->current_batch_import;
#line 641 "../src/LibraryMonitor.vala"
	batch_import_schedule (_tmp10_);
#line 3757 "LibraryMonitor.c"
}

static void
library_monitor_discard_current_batch_import (LibraryMonitor* self)
{
	BatchImport* _tmp0_;
	gboolean removed = FALSE;
	GeeArrayList* _tmp1_;
	BatchImport* _tmp2_;
	BatchImport* _tmp3_;
	guint _tmp4_;
	BatchImport* _tmp5_;
	guint _tmp6_;
	BatchImport* _tmp7_;
	guint _tmp8_;
	GeeArrayList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 644 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 645 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->current_batch_import;
#line 645 "../src/LibraryMonitor.vala"
	_vala_assert (_tmp0_ != NULL, "current_batch_import != null");
#line 647 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->batch_import_queue;
#line 647 "../src/LibraryMonitor.vala"
	_tmp2_ = self->priv->current_batch_import;
#line 647 "../src/LibraryMonitor.vala"
	removed = gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, _tmp2_);
#line 648 "../src/LibraryMonitor.vala"
	_vala_assert (removed, "removed");
#line 649 "../src/LibraryMonitor.vala"
	_tmp3_ = self->priv->current_batch_import;
#line 649 "../src/LibraryMonitor.vala"
	g_signal_parse_name ("preparing", TYPE_BATCH_IMPORT, &_tmp4_, NULL, FALSE);
#line 649 "../src/LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _library_monitor_on_import_preparing_batch_import_preparing, self);
#line 650 "../src/LibraryMonitor.vala"
	_tmp5_ = self->priv->current_batch_import;
#line 650 "../src/LibraryMonitor.vala"
	g_signal_parse_name ("progress", TYPE_BATCH_IMPORT, &_tmp6_, NULL, FALSE);
#line 650 "../src/LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _library_monitor_on_import_progress_batch_import_progress, self);
#line 651 "../src/LibraryMonitor.vala"
	_tmp7_ = self->priv->current_batch_import;
#line 651 "../src/LibraryMonitor.vala"
	g_signal_parse_name ("import-complete", TYPE_BATCH_IMPORT, &_tmp8_, NULL, FALSE);
#line 651 "../src/LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _library_monitor_on_import_complete_batch_import_import_complete, self);
#line 652 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->current_batch_import);
#line 652 "../src/LibraryMonitor.vala"
	self->priv->current_batch_import = NULL;
#line 659 "../src/LibraryMonitor.vala"
	_tmp9_ = self->priv->batch_import_queue;
#line 659 "../src/LibraryMonitor.vala"
	_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 659 "../src/LibraryMonitor.vala"
	_tmp11_ = _tmp10_;
#line 659 "../src/LibraryMonitor.vala"
	if (_tmp11_ == 0) {
#line 3820 "LibraryMonitor.c"
		GeeHashSet* _tmp12_;
#line 660 "../src/LibraryMonitor.vala"
		_tmp12_ = self->priv->pending_imports;
#line 660 "../src/LibraryMonitor.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp12_);
#line 3826 "LibraryMonitor.c"
	}
}

static void
library_monitor_cancel_batch_imports (LibraryMonitor* self)
{
	gint ctr = 0;
	BatchImport* _tmp13_;
	GeeHashSet* _tmp15_;
#line 663 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 665 "../src/LibraryMonitor.vala"
	ctr = 0;
#line 666 "../src/LibraryMonitor.vala"
	while (TRUE) {
#line 3842 "LibraryMonitor.c"
		GeeArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		GeeArrayList* _tmp3_;
		gpointer _tmp4_;
		BatchImport* _tmp5_;
		BatchImport* _tmp6_;
		gboolean _tmp7_;
		GeeArrayList* _tmp9_;
		GeeArrayList* _tmp10_;
		gpointer _tmp11_;
		BatchImport* _tmp12_;
#line 666 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->batch_import_queue;
#line 666 "../src/LibraryMonitor.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 666 "../src/LibraryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 666 "../src/LibraryMonitor.vala"
		if (!(ctr < _tmp2_)) {
#line 666 "../src/LibraryMonitor.vala"
			break;
#line 3865 "LibraryMonitor.c"
		}
#line 667 "../src/LibraryMonitor.vala"
		_tmp3_ = self->priv->batch_import_queue;
#line 667 "../src/LibraryMonitor.vala"
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, ctr);
#line 667 "../src/LibraryMonitor.vala"
		_tmp5_ = (BatchImport*) _tmp4_;
#line 667 "../src/LibraryMonitor.vala"
		_tmp6_ = self->priv->current_batch_import;
#line 667 "../src/LibraryMonitor.vala"
		_tmp7_ = _tmp5_ == _tmp6_;
#line 667 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp5_);
#line 667 "../src/LibraryMonitor.vala"
		if (_tmp7_) {
#line 3881 "LibraryMonitor.c"
			gint _tmp8_;
#line 668 "../src/LibraryMonitor.vala"
			_tmp8_ = ctr;
#line 668 "../src/LibraryMonitor.vala"
			ctr = _tmp8_ + 1;
#line 670 "../src/LibraryMonitor.vala"
			continue;
#line 3889 "LibraryMonitor.c"
		}
#line 673 "../src/LibraryMonitor.vala"
		_tmp9_ = self->priv->batch_import_queue;
#line 673 "../src/LibraryMonitor.vala"
		_tmp10_ = self->priv->batch_import_queue;
#line 673 "../src/LibraryMonitor.vala"
		_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, ctr);
#line 673 "../src/LibraryMonitor.vala"
		_tmp12_ = (BatchImport*) _tmp11_;
#line 673 "../src/LibraryMonitor.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 673 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp12_);
#line 3903 "LibraryMonitor.c"
	}
#line 677 "../src/LibraryMonitor.vala"
	_tmp13_ = self->priv->current_batch_import;
#line 677 "../src/LibraryMonitor.vala"
	if (_tmp13_ != NULL) {
#line 3909 "LibraryMonitor.c"
		BatchImport* _tmp14_;
#line 678 "../src/LibraryMonitor.vala"
		_tmp14_ = self->priv->current_batch_import;
#line 678 "../src/LibraryMonitor.vala"
		batch_import_user_halt (_tmp14_);
#line 3915 "LibraryMonitor.c"
	}
#line 681 "../src/LibraryMonitor.vala"
	_tmp15_ = self->priv->pending_imports;
#line 681 "../src/LibraryMonitor.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp15_);
#line 3921 "LibraryMonitor.c"
}

static void
library_monitor_on_import_preparing (LibraryMonitor* self)
{
#line 684 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 685 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PREPARING_SIGNAL], 0);
#line 3931 "LibraryMonitor.c"
}

static void
library_monitor_on_import_progress (LibraryMonitor* self,
                                    guint64 completed_bytes,
                                    guint64 total_bytes)
{
#line 688 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 689 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PROGRESS_SIGNAL], 0, completed_bytes, total_bytes);
#line 3943 "LibraryMonitor.c"
}

static void
library_monitor_on_import_complete (LibraryMonitor* self,
                                    BatchImport* batch_import,
                                    ImportManifest* manifest,
                                    BatchImportRoll* import_roll)
{
	BatchImport* _tmp0_;
	GeeList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GeeList* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	GeeHashSet* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	GError* _inner_error0_ = NULL;
#line 692 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 692 "../src/LibraryMonitor.vala"
	g_return_if_fail (batch_import != NULL);
#line 692 "../src/LibraryMonitor.vala"
	g_return_if_fail (manifest != NULL);
#line 692 "../src/LibraryMonitor.vala"
	g_return_if_fail (import_roll != NULL);
#line 694 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->current_batch_import;
#line 694 "../src/LibraryMonitor.vala"
	_vala_assert (batch_import == _tmp0_, "batch_import == current_batch_import");
#line 696 "../src/LibraryMonitor.vala"
	_tmp1_ = manifest->all;
#line 696 "../src/LibraryMonitor.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 696 "../src/LibraryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 696 "../src/LibraryMonitor.vala"
	_tmp4_ = g_strdup_printf ("auto-import batch completed %d", _tmp3_);
#line 696 "../src/LibraryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 696 "../src/LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp5_);
#line 696 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp5_);
#line 697 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PROGRESS_SIGNAL], 0, (guint64) 0, (guint64) 0);
#line 3995 "LibraryMonitor.c"
	{
		GeeList* _result_list = NULL;
		GeeList* _tmp6_;
		gint _result_size = 0;
		GeeList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _result_index = 0;
#line 699 "../src/LibraryMonitor.vala"
		_tmp6_ = manifest->all;
#line 699 "../src/LibraryMonitor.vala"
		_result_list = _tmp6_;
#line 699 "../src/LibraryMonitor.vala"
		_tmp7_ = _result_list;
#line 699 "../src/LibraryMonitor.vala"
		_tmp8_ = gee_collection_get_size ((GeeCollection*) _tmp7_);
#line 699 "../src/LibraryMonitor.vala"
		_tmp9_ = _tmp8_;
#line 699 "../src/LibraryMonitor.vala"
		_result_size = _tmp9_;
#line 699 "../src/LibraryMonitor.vala"
		_result_index = -1;
#line 699 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 4020 "LibraryMonitor.c"
			gint _tmp10_;
			gint _tmp11_;
			BatchImportResult* _result_ = NULL;
			GeeList* _tmp12_;
			gpointer _tmp13_;
			BatchImportResult* _tmp14_;
			GFile* _tmp15_;
#line 699 "../src/LibraryMonitor.vala"
			_result_index = _result_index + 1;
#line 699 "../src/LibraryMonitor.vala"
			_tmp10_ = _result_index;
#line 699 "../src/LibraryMonitor.vala"
			_tmp11_ = _result_size;
#line 699 "../src/LibraryMonitor.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 699 "../src/LibraryMonitor.vala"
				break;
#line 4038 "LibraryMonitor.c"
			}
#line 699 "../src/LibraryMonitor.vala"
			_tmp12_ = _result_list;
#line 699 "../src/LibraryMonitor.vala"
			_tmp13_ = gee_list_get (_tmp12_, _result_index);
#line 699 "../src/LibraryMonitor.vala"
			_result_ = (BatchImportResult*) _tmp13_;
#line 702 "../src/LibraryMonitor.vala"
			_tmp14_ = _result_;
#line 702 "../src/LibraryMonitor.vala"
			_tmp15_ = _tmp14_->file;
#line 702 "../src/LibraryMonitor.vala"
			if (_tmp15_ != NULL) {
#line 4052 "LibraryMonitor.c"
				GeeHashSet* _tmp16_;
				BatchImportResult* _tmp17_;
				GFile* _tmp18_;
#line 703 "../src/LibraryMonitor.vala"
				_tmp16_ = self->priv->pending_imports;
#line 703 "../src/LibraryMonitor.vala"
				_tmp17_ = _result_;
#line 703 "../src/LibraryMonitor.vala"
				_tmp18_ = _tmp17_->file;
#line 703 "../src/LibraryMonitor.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp16_, _tmp18_);
#line 4064 "LibraryMonitor.c"
			}
#line 699 "../src/LibraryMonitor.vala"
			_batch_import_result_unref0 (_result_);
#line 4068 "LibraryMonitor.c"
		}
	}
#line 706 "../src/LibraryMonitor.vala"
	_tmp19_ = manifest->already_imported;
#line 706 "../src/LibraryMonitor.vala"
	_tmp20_ = gee_collection_get_size ((GeeCollection*) _tmp19_);
#line 706 "../src/LibraryMonitor.vala"
	_tmp21_ = _tmp20_;
#line 706 "../src/LibraryMonitor.vala"
	if (_tmp21_ > 0) {
#line 4079 "LibraryMonitor.c"
		GeeArrayList* to_tombstone = NULL;
		GeeArrayList* _tmp22_;
#line 707 "../src/LibraryMonitor.vala"
		_tmp22_ = gee_array_list_new (TYPE_TOMBSTONED_FILE, (GBoxedCopyFunc) tombstoned_file_ref, (GDestroyNotify) tombstoned_file_unref, NULL, NULL, NULL);
#line 707 "../src/LibraryMonitor.vala"
		to_tombstone = _tmp22_;
#line 4086 "LibraryMonitor.c"
		{
			GeeList* _result_list = NULL;
			GeeList* _tmp23_;
			gint _result_size = 0;
			GeeList* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			gint _result_index = 0;
#line 708 "../src/LibraryMonitor.vala"
			_tmp23_ = manifest->already_imported;
#line 708 "../src/LibraryMonitor.vala"
			_result_list = _tmp23_;
#line 708 "../src/LibraryMonitor.vala"
			_tmp24_ = _result_list;
#line 708 "../src/LibraryMonitor.vala"
			_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
#line 708 "../src/LibraryMonitor.vala"
			_tmp26_ = _tmp25_;
#line 708 "../src/LibraryMonitor.vala"
			_result_size = _tmp26_;
#line 708 "../src/LibraryMonitor.vala"
			_result_index = -1;
#line 708 "../src/LibraryMonitor.vala"
			while (TRUE) {
#line 4111 "LibraryMonitor.c"
				gint _tmp27_;
				gint _tmp28_;
				BatchImportResult* _result_ = NULL;
				GeeList* _tmp29_;
				gpointer _tmp30_;
				GFileInfo* info = NULL;
				BatchImportResult* _tmp31_;
				GFile* _tmp32_;
				GFileInfo* _tmp33_;
				GFileInfo* _tmp34_;
				GeeArrayList* _tmp39_;
				BatchImportResult* _tmp40_;
				GFile* _tmp41_;
				GFileInfo* _tmp42_;
				TombstonedFile* _tmp43_;
				TombstonedFile* _tmp44_;
#line 708 "../src/LibraryMonitor.vala"
				_result_index = _result_index + 1;
#line 708 "../src/LibraryMonitor.vala"
				_tmp27_ = _result_index;
#line 708 "../src/LibraryMonitor.vala"
				_tmp28_ = _result_size;
#line 708 "../src/LibraryMonitor.vala"
				if (!(_tmp27_ < _tmp28_)) {
#line 708 "../src/LibraryMonitor.vala"
					break;
#line 4138 "LibraryMonitor.c"
				}
#line 708 "../src/LibraryMonitor.vala"
				_tmp29_ = _result_list;
#line 708 "../src/LibraryMonitor.vala"
				_tmp30_ = gee_list_get (_tmp29_, _result_index);
#line 708 "../src/LibraryMonitor.vala"
				_result_ = (BatchImportResult*) _tmp30_;
#line 709 "../src/LibraryMonitor.vala"
				_tmp31_ = _result_;
#line 709 "../src/LibraryMonitor.vala"
				_tmp32_ = _tmp31_->file;
#line 709 "../src/LibraryMonitor.vala"
				_tmp33_ = directory_monitor_get_file_info ((DirectoryMonitor*) self, _tmp32_);
#line 709 "../src/LibraryMonitor.vala"
				info = _tmp33_;
#line 710 "../src/LibraryMonitor.vala"
				_tmp34_ = info;
#line 710 "../src/LibraryMonitor.vala"
				if (_tmp34_ == NULL) {
#line 4158 "LibraryMonitor.c"
					BatchImportResult* _tmp35_;
					GFile* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
#line 711 "../src/LibraryMonitor.vala"
					_tmp35_ = _result_;
#line 711 "../src/LibraryMonitor.vala"
					_tmp36_ = _tmp35_->file;
#line 711 "../src/LibraryMonitor.vala"
					_tmp37_ = g_file_get_path (_tmp36_);
#line 711 "../src/LibraryMonitor.vala"
					_tmp38_ = _tmp37_;
#line 711 "../src/LibraryMonitor.vala"
					g_warning ("LibraryMonitor.vala:711: Unable to get info for duplicate file %s", _tmp38_);
#line 711 "../src/LibraryMonitor.vala"
					_g_free0 (_tmp38_);
#line 713 "../src/LibraryMonitor.vala"
					_g_object_unref0 (info);
#line 713 "../src/LibraryMonitor.vala"
					_batch_import_result_unref0 (_result_);
#line 713 "../src/LibraryMonitor.vala"
					continue;
#line 4181 "LibraryMonitor.c"
				}
#line 716 "../src/LibraryMonitor.vala"
				_tmp39_ = to_tombstone;
#line 716 "../src/LibraryMonitor.vala"
				_tmp40_ = _result_;
#line 716 "../src/LibraryMonitor.vala"
				_tmp41_ = _tmp40_->file;
#line 716 "../src/LibraryMonitor.vala"
				_tmp42_ = info;
#line 716 "../src/LibraryMonitor.vala"
				_tmp43_ = tombstoned_file_new (_tmp41_, g_file_info_get_size (_tmp42_), NULL);
#line 716 "../src/LibraryMonitor.vala"
				_tmp44_ = _tmp43_;
#line 716 "../src/LibraryMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, _tmp44_);
#line 716 "../src/LibraryMonitor.vala"
				_tombstoned_file_unref0 (_tmp44_);
#line 708 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 708 "../src/LibraryMonitor.vala"
				_batch_import_result_unref0 (_result_);
#line 4203 "LibraryMonitor.c"
			}
		}
		{
			GeeArrayList* _tmp45_;
#line 720 "../src/LibraryMonitor.vala"
			_tmp45_ = to_tombstone;
#line 720 "../src/LibraryMonitor.vala"
			tombstone_entomb_many_files ((GeeCollection*) _tmp45_, TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE, &_inner_error0_);
#line 720 "../src/LibraryMonitor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 720 "../src/LibraryMonitor.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 4216 "LibraryMonitor.c"
					goto __catch0_database_error;
				}
#line 720 "../src/LibraryMonitor.vala"
				_g_object_unref0 (to_tombstone);
#line 720 "../src/LibraryMonitor.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 720 "../src/LibraryMonitor.vala"
				g_clear_error (&_inner_error0_);
#line 720 "../src/LibraryMonitor.vala"
				return;
#line 4227 "LibraryMonitor.c"
			}
		}
		goto __finally0;
		__catch0_database_error:
		{
			GError* err = NULL;
			GError* _tmp46_;
#line 719 "../src/LibraryMonitor.vala"
			err = _inner_error0_;
#line 719 "../src/LibraryMonitor.vala"
			_inner_error0_ = NULL;
#line 722 "../src/LibraryMonitor.vala"
			_tmp46_ = err;
#line 722 "../src/LibraryMonitor.vala"
			app_window_database_error (_tmp46_);
#line 719 "../src/LibraryMonitor.vala"
			_g_error_free0 (err);
#line 4245 "LibraryMonitor.c"
		}
		__finally0:
#line 719 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 719 "../src/LibraryMonitor.vala"
			_g_object_unref0 (to_tombstone);
#line 719 "../src/LibraryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 719 "../src/LibraryMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 719 "../src/LibraryMonitor.vala"
			return;
#line 4258 "LibraryMonitor.c"
		}
#line 706 "../src/LibraryMonitor.vala"
		_g_object_unref0 (to_tombstone);
#line 4262 "LibraryMonitor.c"
	}
#line 726 "../src/LibraryMonitor.vala"
	_tmp47_ = self->priv->pending_imports;
#line 726 "../src/LibraryMonitor.vala"
	_tmp48_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp47_);
#line 726 "../src/LibraryMonitor.vala"
	_tmp49_ = _tmp48_;
#line 726 "../src/LibraryMonitor.vala"
	_tmp50_ = g_strdup_printf ("%d files remain pending for auto-import", _tmp49_);
#line 726 "../src/LibraryMonitor.vala"
	_tmp51_ = _tmp50_;
#line 726 "../src/LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp51_);
#line 726 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp51_);
#line 728 "../src/LibraryMonitor.vala"
	library_monitor_discard_current_batch_import (self);
#line 729 "../src/LibraryMonitor.vala"
	library_monitor_schedule_next_batch_import (self);
#line 4282 "LibraryMonitor.c"
}

void
library_monitor_blacklist_file (GFile* file,
                                const gchar* reason)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 745 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 745 "../src/LibraryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 746 "../src/LibraryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 746 "../src/LibraryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 746 "../src/LibraryMonitor.vala"
	_tmp2_ = g_strdup_printf ("[%s] Blacklisting %s", reason, _tmp1_);
#line 746 "../src/LibraryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 746 "../src/LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 746 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp3_);
#line 746 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp1_);
#line 4312 "LibraryMonitor.c"
	{
		GeeHashSet* _tmp4_;
#line 747 "../src/LibraryMonitor.vala"
		_tmp4_ = library_monitor_blacklist;
#line 747 "../src/LibraryMonitor.vala"
		g_rec_mutex_lock (&__lock_library_monitor_library_monitor_blacklist);
#line 4319 "LibraryMonitor.c"
		{
			GeeHashSet* _tmp5_;
#line 748 "../src/LibraryMonitor.vala"
			_tmp5_ = library_monitor_blacklist;
#line 748 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, file);
#line 4326 "LibraryMonitor.c"
		}
		__finally0:
		{
			GeeHashSet* _tmp6_;
#line 747 "../src/LibraryMonitor.vala"
			_tmp6_ = library_monitor_blacklist;
#line 747 "../src/LibraryMonitor.vala"
			g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 4335 "LibraryMonitor.c"
		}
#line 747 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 747 "../src/LibraryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 747 "../src/LibraryMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 747 "../src/LibraryMonitor.vala"
			return;
#line 4345 "LibraryMonitor.c"
		}
	}
}

void
library_monitor_unblacklist_file (GFile* file)
{
	GError* _inner_error0_ = NULL;
#line 752 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 4356 "LibraryMonitor.c"
	{
		GeeHashSet* _tmp0_;
#line 755 "../src/LibraryMonitor.vala"
		_tmp0_ = library_monitor_blacklist;
#line 755 "../src/LibraryMonitor.vala"
		g_rec_mutex_lock (&__lock_library_monitor_library_monitor_blacklist);
#line 4363 "LibraryMonitor.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashSet* _tmp2_;
#line 756 "../src/LibraryMonitor.vala"
			_tmp2_ = library_monitor_blacklist;
#line 756 "../src/LibraryMonitor.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, file)) {
#line 4371 "LibraryMonitor.c"
				HashTimedQueue* _tmp3_;
#line 756 "../src/LibraryMonitor.vala"
				_tmp3_ = library_monitor_to_unblacklist;
#line 756 "../src/LibraryMonitor.vala"
				_tmp1_ = !timed_queue_contains ((TimedQueue*) _tmp3_, file);
#line 4377 "LibraryMonitor.c"
			} else {
#line 756 "../src/LibraryMonitor.vala"
				_tmp1_ = FALSE;
#line 4381 "LibraryMonitor.c"
			}
#line 756 "../src/LibraryMonitor.vala"
			if (_tmp1_) {
#line 4385 "LibraryMonitor.c"
				HashTimedQueue* _tmp4_;
#line 757 "../src/LibraryMonitor.vala"
				_tmp4_ = library_monitor_to_unblacklist;
#line 757 "../src/LibraryMonitor.vala"
				timed_queue_enqueue ((TimedQueue*) _tmp4_, file);
#line 4391 "LibraryMonitor.c"
			}
		}
		__finally0:
		{
			GeeHashSet* _tmp5_;
#line 755 "../src/LibraryMonitor.vala"
			_tmp5_ = library_monitor_blacklist;
#line 755 "../src/LibraryMonitor.vala"
			g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 4401 "LibraryMonitor.c"
		}
#line 755 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 755 "../src/LibraryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 755 "../src/LibraryMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 755 "../src/LibraryMonitor.vala"
			return;
#line 4411 "LibraryMonitor.c"
		}
	}
}

static void
library_monitor_on_unblacklist_file (GFile* file)
{
	gboolean removed = FALSE;
	GError* _inner_error0_ = NULL;
#line 761 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 4423 "LibraryMonitor.c"
	{
		GeeHashSet* _tmp0_;
#line 763 "../src/LibraryMonitor.vala"
		_tmp0_ = library_monitor_blacklist;
#line 763 "../src/LibraryMonitor.vala"
		g_rec_mutex_lock (&__lock_library_monitor_library_monitor_blacklist);
#line 4430 "LibraryMonitor.c"
		{
			GeeHashSet* _tmp1_;
#line 764 "../src/LibraryMonitor.vala"
			_tmp1_ = library_monitor_blacklist;
#line 764 "../src/LibraryMonitor.vala"
			removed = gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, file);
#line 4437 "LibraryMonitor.c"
		}
		__finally0:
		{
			GeeHashSet* _tmp2_;
#line 763 "../src/LibraryMonitor.vala"
			_tmp2_ = library_monitor_blacklist;
#line 763 "../src/LibraryMonitor.vala"
			g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 4446 "LibraryMonitor.c"
		}
#line 763 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 763 "../src/LibraryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 763 "../src/LibraryMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 763 "../src/LibraryMonitor.vala"
			return;
#line 4456 "LibraryMonitor.c"
		}
	}
#line 767 "../src/LibraryMonitor.vala"
	if (removed) {
#line 4461 "LibraryMonitor.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 768 "../src/LibraryMonitor.vala"
		_tmp3_ = g_file_get_path (file);
#line 768 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 768 "../src/LibraryMonitor.vala"
		_tmp5_ = g_strdup_printf ("Blacklist for %s removed", _tmp4_);
#line 768 "../src/LibraryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 768 "../src/LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp6_);
#line 768 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp6_);
#line 768 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp4_);
#line 4480 "LibraryMonitor.c"
	} else {
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 770 "../src/LibraryMonitor.vala"
		_tmp7_ = g_file_get_path (file);
#line 770 "../src/LibraryMonitor.vala"
		_tmp8_ = _tmp7_;
#line 770 "../src/LibraryMonitor.vala"
		g_warning ("LibraryMonitor.vala:770: File %s was not blacklisted but unblacklisted", _tmp8_);
#line 770 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp8_);
#line 4492 "LibraryMonitor.c"
	}
}

gboolean
library_monitor_is_blacklisted (GFile* file)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 773 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 4503 "LibraryMonitor.c"
	{
		GeeHashSet* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 774 "../src/LibraryMonitor.vala"
		_tmp0_ = library_monitor_blacklist;
#line 774 "../src/LibraryMonitor.vala"
		g_rec_mutex_lock (&__lock_library_monitor_library_monitor_blacklist);
#line 4511 "LibraryMonitor.c"
		{
			GeeHashSet* _tmp1_;
#line 775 "../src/LibraryMonitor.vala"
			_tmp1_ = library_monitor_blacklist;
#line 775 "../src/LibraryMonitor.vala"
			result = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp1_, file);
#line 4518 "LibraryMonitor.c"
			{
				GeeHashSet* _tmp2_;
#line 774 "../src/LibraryMonitor.vala"
				_tmp2_ = library_monitor_blacklist;
#line 774 "../src/LibraryMonitor.vala"
				g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 4525 "LibraryMonitor.c"
			}
#line 775 "../src/LibraryMonitor.vala"
			return result;
#line 4529 "LibraryMonitor.c"
		}
		__finally0:
		{
			GeeHashSet* _tmp3_;
#line 774 "../src/LibraryMonitor.vala"
			_tmp3_ = library_monitor_blacklist;
#line 774 "../src/LibraryMonitor.vala"
			g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 4538 "LibraryMonitor.c"
		}
#line 774 "../src/LibraryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 774 "../src/LibraryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 774 "../src/LibraryMonitor.vala"
		return _tmp4_;
#line 4546 "LibraryMonitor.c"
	}
}

static gboolean
library_monitor_is_supported_filetype (LibraryMonitor* self,
                                       GFile* file)
{
	MediaCollectionRegistry* _tmp0_;
	MediaCollectionRegistry* _tmp1_;
	MediaSourceCollection* _tmp2_;
	MediaSourceCollection* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 779 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 779 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 780 "../src/LibraryMonitor.vala"
	_tmp0_ = media_collection_registry_get_instance ();
#line 780 "../src/LibraryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 780 "../src/LibraryMonitor.vala"
	_tmp2_ = media_collection_registry_get_collection_for_file (_tmp1_, file);
#line 780 "../src/LibraryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 780 "../src/LibraryMonitor.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 780 "../src/LibraryMonitor.vala"
	_data_collection_unref0 (_tmp3_);
#line 780 "../src/LibraryMonitor.vala"
	_media_collection_registry_unref0 (_tmp1_);
#line 780 "../src/LibraryMonitor.vala"
	result = _tmp4_;
#line 780 "../src/LibraryMonitor.vala"
	return result;
#line 4582 "LibraryMonitor.c"
}

static void
library_monitor_import_unrepresented_files (LibraryMonitor* self)
{
	GeeArrayList* to_import = NULL;
	GeeArrayList* _tmp31_;
#line 785 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 786 "../src/LibraryMonitor.vala"
	if (!self->priv->auto_import) {
#line 787 "../src/LibraryMonitor.vala"
		return;
#line 4596 "LibraryMonitor.c"
	}
#line 789 "../src/LibraryMonitor.vala"
	to_import = NULL;
#line 4600 "LibraryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 790 "../src/LibraryMonitor.vala"
		_tmp0_ = directory_monitor_get_files ((DirectoryMonitor*) self);
#line 790 "../src/LibraryMonitor.vala"
		_tmp1_ = _tmp0_;
#line 790 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 790 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 790 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp1_);
#line 790 "../src/LibraryMonitor.vala"
		_file_it = _tmp3_;
#line 790 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 4621 "LibraryMonitor.c"
			GeeIterator* _tmp4_;
			GFile* file = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GFileInfo* info = NULL;
			GFile* _tmp7_;
			GFileInfo* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GFileInfo* _tmp10_;
			GeeHashSet* _tmp12_;
			GFile* _tmp13_;
			TombstoneSourceCollection* _tmp14_;
			GFile* _tmp15_;
			gboolean represented = FALSE;
			GFile* _tmp26_;
			GeeArrayList* _tmp27_;
			GeeArrayList* _tmp29_;
			GFile* _tmp30_;
#line 790 "../src/LibraryMonitor.vala"
			_tmp4_ = _file_it;
#line 790 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 790 "../src/LibraryMonitor.vala"
				break;
#line 4646 "LibraryMonitor.c"
			}
#line 790 "../src/LibraryMonitor.vala"
			_tmp5_ = _file_it;
#line 790 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 790 "../src/LibraryMonitor.vala"
			file = (GFile*) _tmp6_;
#line 791 "../src/LibraryMonitor.vala"
			_tmp7_ = file;
#line 791 "../src/LibraryMonitor.vala"
			_tmp8_ = directory_monitor_get_file_info ((DirectoryMonitor*) self, _tmp7_);
#line 791 "../src/LibraryMonitor.vala"
			info = _tmp8_;
#line 792 "../src/LibraryMonitor.vala"
			_tmp10_ = info;
#line 792 "../src/LibraryMonitor.vala"
			if (_tmp10_ == NULL) {
#line 792 "../src/LibraryMonitor.vala"
				_tmp9_ = TRUE;
#line 4666 "LibraryMonitor.c"
			} else {
				GFileInfo* _tmp11_;
#line 792 "../src/LibraryMonitor.vala"
				_tmp11_ = info;
#line 792 "../src/LibraryMonitor.vala"
				_tmp9_ = g_file_info_get_file_type (_tmp11_) != G_FILE_TYPE_REGULAR;
#line 4673 "LibraryMonitor.c"
			}
#line 792 "../src/LibraryMonitor.vala"
			if (_tmp9_) {
#line 793 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 793 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 793 "../src/LibraryMonitor.vala"
				continue;
#line 4683 "LibraryMonitor.c"
			}
#line 795 "../src/LibraryMonitor.vala"
			_tmp12_ = self->priv->pending_imports;
#line 795 "../src/LibraryMonitor.vala"
			_tmp13_ = file;
#line 795 "../src/LibraryMonitor.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp12_, _tmp13_)) {
#line 796 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 796 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 796 "../src/LibraryMonitor.vala"
				continue;
#line 4697 "LibraryMonitor.c"
			}
#line 798 "../src/LibraryMonitor.vala"
			_tmp14_ = tombstone_global;
#line 798 "../src/LibraryMonitor.vala"
			_tmp15_ = file;
#line 798 "../src/LibraryMonitor.vala"
			if (tombstone_source_collection_matches (_tmp14_, _tmp15_)) {
#line 799 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 799 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 799 "../src/LibraryMonitor.vala"
				continue;
#line 4711 "LibraryMonitor.c"
			}
#line 801 "../src/LibraryMonitor.vala"
			represented = FALSE;
#line 4715 "LibraryMonitor.c"
			{
				GeeList* _monitor_list = NULL;
				GeeList* _tmp16_;
				gint _monitor_size = 0;
				GeeList* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint _monitor_index = 0;
#line 802 "../src/LibraryMonitor.vala"
				_tmp16_ = self->priv->monitors;
#line 802 "../src/LibraryMonitor.vala"
				_monitor_list = _tmp16_;
#line 802 "../src/LibraryMonitor.vala"
				_tmp17_ = _monitor_list;
#line 802 "../src/LibraryMonitor.vala"
				_tmp18_ = gee_collection_get_size ((GeeCollection*) _tmp17_);
#line 802 "../src/LibraryMonitor.vala"
				_tmp19_ = _tmp18_;
#line 802 "../src/LibraryMonitor.vala"
				_monitor_size = _tmp19_;
#line 802 "../src/LibraryMonitor.vala"
				_monitor_index = -1;
#line 802 "../src/LibraryMonitor.vala"
				while (TRUE) {
#line 4740 "LibraryMonitor.c"
					gint _tmp20_;
					gint _tmp21_;
					MediaMonitor* monitor = NULL;
					GeeList* _tmp22_;
					gpointer _tmp23_;
					MediaMonitor* _tmp24_;
					GFile* _tmp25_;
#line 802 "../src/LibraryMonitor.vala"
					_monitor_index = _monitor_index + 1;
#line 802 "../src/LibraryMonitor.vala"
					_tmp20_ = _monitor_index;
#line 802 "../src/LibraryMonitor.vala"
					_tmp21_ = _monitor_size;
#line 802 "../src/LibraryMonitor.vala"
					if (!(_tmp20_ < _tmp21_)) {
#line 802 "../src/LibraryMonitor.vala"
						break;
#line 4758 "LibraryMonitor.c"
					}
#line 802 "../src/LibraryMonitor.vala"
					_tmp22_ = _monitor_list;
#line 802 "../src/LibraryMonitor.vala"
					_tmp23_ = gee_list_get (_tmp22_, _monitor_index);
#line 802 "../src/LibraryMonitor.vala"
					monitor = (MediaMonitor*) _tmp23_;
#line 803 "../src/LibraryMonitor.vala"
					_tmp24_ = monitor;
#line 803 "../src/LibraryMonitor.vala"
					_tmp25_ = file;
#line 803 "../src/LibraryMonitor.vala"
					if (media_monitor_is_file_represented (_tmp24_, _tmp25_)) {
#line 804 "../src/LibraryMonitor.vala"
						represented = TRUE;
#line 806 "../src/LibraryMonitor.vala"
						_g_object_unref0 (monitor);
#line 806 "../src/LibraryMonitor.vala"
						break;
#line 4778 "LibraryMonitor.c"
					}
#line 802 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitor);
#line 4782 "LibraryMonitor.c"
				}
			}
#line 810 "../src/LibraryMonitor.vala"
			if (represented) {
#line 811 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 811 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 811 "../src/LibraryMonitor.vala"
				continue;
#line 4793 "LibraryMonitor.c"
			}
#line 813 "../src/LibraryMonitor.vala"
			_tmp26_ = file;
#line 813 "../src/LibraryMonitor.vala"
			if (!library_monitor_is_supported_filetype (self, _tmp26_)) {
#line 814 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 814 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 814 "../src/LibraryMonitor.vala"
				continue;
#line 4805 "LibraryMonitor.c"
			}
#line 816 "../src/LibraryMonitor.vala"
			_tmp27_ = to_import;
#line 816 "../src/LibraryMonitor.vala"
			if (_tmp27_ == NULL) {
#line 4811 "LibraryMonitor.c"
				GeeArrayList* _tmp28_;
#line 817 "../src/LibraryMonitor.vala"
				_tmp28_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 817 "../src/LibraryMonitor.vala"
				_g_object_unref0 (to_import);
#line 817 "../src/LibraryMonitor.vala"
				to_import = _tmp28_;
#line 4819 "LibraryMonitor.c"
			}
#line 819 "../src/LibraryMonitor.vala"
			_tmp29_ = to_import;
#line 819 "../src/LibraryMonitor.vala"
			_tmp30_ = file;
#line 819 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
#line 790 "../src/LibraryMonitor.vala"
			_g_object_unref0 (info);
#line 790 "../src/LibraryMonitor.vala"
			_g_object_unref0 (file);
#line 4831 "LibraryMonitor.c"
		}
#line 790 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 4835 "LibraryMonitor.c"
	}
#line 822 "../src/LibraryMonitor.vala"
	_tmp31_ = to_import;
#line 822 "../src/LibraryMonitor.vala"
	if (_tmp31_ != NULL) {
#line 4841 "LibraryMonitor.c"
		GeeArrayList* _tmp32_;
#line 823 "../src/LibraryMonitor.vala"
		_tmp32_ = to_import;
#line 823 "../src/LibraryMonitor.vala"
		library_monitor_enqueue_import_many (self, (GeeCollection*) _tmp32_);
#line 4847 "LibraryMonitor.c"
	}
#line 785 "../src/LibraryMonitor.vala"
	_g_object_unref0 (to_import);
#line 4851 "LibraryMonitor.c"
}

static void
library_monitor_runtime_unknown_file_discovered (LibraryMonitor* self,
                                                 GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 828 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 828 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 829 "../src/LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 829 "../src/LibraryMonitor.vala"
		_tmp1_ = library_monitor_is_supported_filetype (self, file);
#line 4868 "LibraryMonitor.c"
	} else {
#line 829 "../src/LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 4872 "LibraryMonitor.c"
	}
#line 829 "../src/LibraryMonitor.vala"
	if (_tmp1_) {
#line 4876 "LibraryMonitor.c"
		TombstoneSourceCollection* _tmp2_;
#line 829 "../src/LibraryMonitor.vala"
		_tmp2_ = tombstone_global;
#line 829 "../src/LibraryMonitor.vala"
		_tmp0_ = !tombstone_source_collection_matches (_tmp2_, file);
#line 4882 "LibraryMonitor.c"
	} else {
#line 829 "../src/LibraryMonitor.vala"
		_tmp0_ = FALSE;
#line 4886 "LibraryMonitor.c"
	}
#line 829 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 4890 "LibraryMonitor.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 830 "../src/LibraryMonitor.vala"
		_tmp3_ = g_file_get_path (file);
#line 830 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 830 "../src/LibraryMonitor.vala"
		_tmp5_ = g_strdup_printf ("Unknown file %s discovered, enqueuing for import", _tmp4_);
#line 830 "../src/LibraryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 830 "../src/LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp6_);
#line 830 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp6_);
#line 830 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp4_);
#line 831 "../src/LibraryMonitor.vala"
		library_monitor_enqueue_import (self, file);
#line 4911 "LibraryMonitor.c"
	}
}

static void
library_monitor_real_notify_file_created (DirectoryMonitor* base,
                                          GFile* file,
                                          GFileInfo* info)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 835 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 835 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 835 "../src/LibraryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 836 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 837 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_created (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 839 "../src/LibraryMonitor.vala"
		return;
#line 4934 "LibraryMonitor.c"
	}
#line 842 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 4938 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		gint _monitor_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 843 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 843 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp0_;
#line 843 "../src/LibraryMonitor.vala"
		_tmp1_ = _monitor_list;
#line 843 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 843 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 843 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp3_;
#line 843 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 843 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 4963 "LibraryMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitor* _tmp8_;
#line 843 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 843 "../src/LibraryMonitor.vala"
			_tmp4_ = _monitor_index;
#line 843 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_size;
#line 843 "../src/LibraryMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 843 "../src/LibraryMonitor.vala"
				break;
#line 4980 "LibraryMonitor.c"
			}
#line 843 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 843 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 843 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 844 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 844 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_created (_tmp8_, file, info)) {
#line 845 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 847 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 847 "../src/LibraryMonitor.vala"
				break;
#line 4998 "LibraryMonitor.c"
			}
#line 843 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 5002 "LibraryMonitor.c"
		}
	}
#line 851 "../src/LibraryMonitor.vala"
	if (!known) {
#line 5007 "LibraryMonitor.c"
		GeeHashSet* all_candidates = NULL;
		gboolean _tmp55_ = FALSE;
		gboolean _tmp56_ = FALSE;
#line 853 "../src/LibraryMonitor.vala"
		all_candidates = NULL;
#line 5013 "LibraryMonitor.c"
		{
			GeeList* _monitor_list = NULL;
			GeeList* _tmp9_;
			gint _monitor_size = 0;
			GeeList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _monitor_index = 0;
#line 854 "../src/LibraryMonitor.vala"
			_tmp9_ = self->priv->monitors;
#line 854 "../src/LibraryMonitor.vala"
			_monitor_list = _tmp9_;
#line 854 "../src/LibraryMonitor.vala"
			_tmp10_ = _monitor_list;
#line 854 "../src/LibraryMonitor.vala"
			_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 854 "../src/LibraryMonitor.vala"
			_tmp12_ = _tmp11_;
#line 854 "../src/LibraryMonitor.vala"
			_monitor_size = _tmp12_;
#line 854 "../src/LibraryMonitor.vala"
			_monitor_index = -1;
#line 854 "../src/LibraryMonitor.vala"
			while (TRUE) {
#line 5038 "LibraryMonitor.c"
				gint _tmp13_;
				gint _tmp14_;
				MediaMonitor* monitor = NULL;
				GeeList* _tmp15_;
				gpointer _tmp16_;
				MediaMonitorDiscoveredFile _result_ = 0;
				GeeCollection* candidates = NULL;
				MediaMonitor* _tmp17_;
				MediaMonitorDiscoveredFile _tmp18_ = 0;
				GeeCollection* _tmp19_;
				gboolean _tmp20_ = FALSE;
#line 854 "../src/LibraryMonitor.vala"
				_monitor_index = _monitor_index + 1;
#line 854 "../src/LibraryMonitor.vala"
				_tmp13_ = _monitor_index;
#line 854 "../src/LibraryMonitor.vala"
				_tmp14_ = _monitor_size;
#line 854 "../src/LibraryMonitor.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 854 "../src/LibraryMonitor.vala"
					break;
#line 5060 "LibraryMonitor.c"
				}
#line 854 "../src/LibraryMonitor.vala"
				_tmp15_ = _monitor_list;
#line 854 "../src/LibraryMonitor.vala"
				_tmp16_ = gee_list_get (_tmp15_, _monitor_index);
#line 854 "../src/LibraryMonitor.vala"
				monitor = (MediaMonitor*) _tmp16_;
#line 856 "../src/LibraryMonitor.vala"
				_tmp17_ = monitor;
#line 856 "../src/LibraryMonitor.vala"
				_tmp19_ = media_monitor_candidates_for_unknown_file (_tmp17_, file, info, &_tmp18_);
#line 856 "../src/LibraryMonitor.vala"
				_result_ = _tmp18_;
#line 856 "../src/LibraryMonitor.vala"
				candidates = _tmp19_;
#line 858 "../src/LibraryMonitor.vala"
				if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 858 "../src/LibraryMonitor.vala"
					_tmp20_ = TRUE;
#line 5080 "LibraryMonitor.c"
				} else {
#line 859 "../src/LibraryMonitor.vala"
					_tmp20_ = _result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
#line 5084 "LibraryMonitor.c"
				}
#line 858 "../src/LibraryMonitor.vala"
				if (_tmp20_) {
#line 5088 "LibraryMonitor.c"
					MediaMonitor* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					GEnumValue* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
#line 860 "../src/LibraryMonitor.vala"
					_tmp21_ = monitor;
#line 860 "../src/LibraryMonitor.vala"
					_tmp22_ = media_monitor_to_string (_tmp21_);
#line 860 "../src/LibraryMonitor.vala"
					_tmp23_ = _tmp22_;
#line 860 "../src/LibraryMonitor.vala"
					_tmp24_ = g_enum_get_value (g_type_class_ref (MEDIA_MONITOR_TYPE_DISCOVERED_FILE), _result_);
#line 860 "../src/LibraryMonitor.vala"
					_tmp25_ = g_file_get_path (file);
#line 860 "../src/LibraryMonitor.vala"
					_tmp26_ = _tmp25_;
#line 860 "../src/LibraryMonitor.vala"
					_tmp27_ = g_strdup_printf ("%s %s created file %s", _tmp23_, (_tmp24_ != NULL) ? _tmp24_->value_name : NULL, _tmp26_);
#line 860 "../src/LibraryMonitor.vala"
					_tmp28_ = _tmp27_;
#line 860 "../src/LibraryMonitor.vala"
					directory_monitor_mdbg (_tmp28_);
#line 860 "../src/LibraryMonitor.vala"
					_g_free0 (_tmp28_);
#line 860 "../src/LibraryMonitor.vala"
					_g_free0 (_tmp26_);
#line 860 "../src/LibraryMonitor.vala"
					_g_free0 (_tmp23_);
#line 863 "../src/LibraryMonitor.vala"
					known = TRUE;
#line 865 "../src/LibraryMonitor.vala"
					_g_object_unref0 (candidates);
#line 865 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitor);
#line 865 "../src/LibraryMonitor.vala"
					break;
#line 5129 "LibraryMonitor.c"
				} else {
					gboolean _tmp29_ = FALSE;
					GeeCollection* _tmp30_;
#line 866 "../src/LibraryMonitor.vala"
					_tmp30_ = candidates;
#line 866 "../src/LibraryMonitor.vala"
					if (_tmp30_ != NULL) {
#line 5137 "LibraryMonitor.c"
						GeeCollection* _tmp31_;
						gint _tmp32_;
						gint _tmp33_;
#line 866 "../src/LibraryMonitor.vala"
						_tmp31_ = candidates;
#line 866 "../src/LibraryMonitor.vala"
						_tmp32_ = gee_collection_get_size (_tmp31_);
#line 866 "../src/LibraryMonitor.vala"
						_tmp33_ = _tmp32_;
#line 866 "../src/LibraryMonitor.vala"
						_tmp29_ = _tmp33_ > 0;
#line 5149 "LibraryMonitor.c"
					} else {
#line 866 "../src/LibraryMonitor.vala"
						_tmp29_ = FALSE;
#line 5153 "LibraryMonitor.c"
					}
#line 866 "../src/LibraryMonitor.vala"
					if (_tmp29_) {
#line 5157 "LibraryMonitor.c"
						MediaMonitor* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						GeeCollection* _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
						GeeHashSet* _tmp44_;
#line 867 "../src/LibraryMonitor.vala"
						_tmp34_ = monitor;
#line 867 "../src/LibraryMonitor.vala"
						_tmp35_ = media_monitor_to_string (_tmp34_);
#line 867 "../src/LibraryMonitor.vala"
						_tmp36_ = _tmp35_;
#line 867 "../src/LibraryMonitor.vala"
						_tmp37_ = candidates;
#line 867 "../src/LibraryMonitor.vala"
						_tmp38_ = gee_collection_get_size (_tmp37_);
#line 867 "../src/LibraryMonitor.vala"
						_tmp39_ = _tmp38_;
#line 867 "../src/LibraryMonitor.vala"
						_tmp40_ = g_file_get_path (file);
#line 867 "../src/LibraryMonitor.vala"
						_tmp41_ = _tmp40_;
#line 867 "../src/LibraryMonitor.vala"
						_tmp42_ = g_strdup_printf ("%s suggests %d candidates for created file %s", _tmp36_, _tmp39_, _tmp41_);
#line 867 "../src/LibraryMonitor.vala"
						_tmp43_ = _tmp42_;
#line 867 "../src/LibraryMonitor.vala"
						directory_monitor_mdbg (_tmp43_);
#line 867 "../src/LibraryMonitor.vala"
						_g_free0 (_tmp43_);
#line 867 "../src/LibraryMonitor.vala"
						_g_free0 (_tmp41_);
#line 867 "../src/LibraryMonitor.vala"
						_g_free0 (_tmp36_);
#line 870 "../src/LibraryMonitor.vala"
						_tmp44_ = all_candidates;
#line 870 "../src/LibraryMonitor.vala"
						if (_tmp44_ == NULL) {
#line 5201 "LibraryMonitor.c"
							GeeHashSet* _tmp45_;
#line 871 "../src/LibraryMonitor.vala"
							_tmp45_ = gee_hash_set_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 871 "../src/LibraryMonitor.vala"
							_g_object_unref0 (all_candidates);
#line 871 "../src/LibraryMonitor.vala"
							all_candidates = _tmp45_;
#line 5209 "LibraryMonitor.c"
						}
						{
							GeeIterator* _candidate_it = NULL;
							GeeCollection* _tmp46_;
							GeeIterator* _tmp47_;
#line 873 "../src/LibraryMonitor.vala"
							_tmp46_ = candidates;
#line 873 "../src/LibraryMonitor.vala"
							_tmp47_ = gee_iterable_iterator ((GeeIterable*) _tmp46_);
#line 873 "../src/LibraryMonitor.vala"
							_candidate_it = _tmp47_;
#line 873 "../src/LibraryMonitor.vala"
							while (TRUE) {
#line 5223 "LibraryMonitor.c"
								GeeIterator* _tmp48_;
								Monitorable* candidate = NULL;
								GeeIterator* _tmp49_;
								gpointer _tmp50_;
								MediaMonitor* _tmp51_;
								Monitorable* _tmp52_;
#line 873 "../src/LibraryMonitor.vala"
								_tmp48_ = _candidate_it;
#line 873 "../src/LibraryMonitor.vala"
								if (!gee_iterator_next (_tmp48_)) {
#line 873 "../src/LibraryMonitor.vala"
									break;
#line 5236 "LibraryMonitor.c"
								}
#line 873 "../src/LibraryMonitor.vala"
								_tmp49_ = _candidate_it;
#line 873 "../src/LibraryMonitor.vala"
								_tmp50_ = gee_iterator_get (_tmp49_);
#line 873 "../src/LibraryMonitor.vala"
								candidate = (Monitorable*) _tmp50_;
#line 874 "../src/LibraryMonitor.vala"
								_tmp51_ = monitor;
#line 874 "../src/LibraryMonitor.vala"
								_tmp52_ = candidate;
#line 874 "../src/LibraryMonitor.vala"
								if (media_monitor_is_offline (_tmp51_, _tmp52_)) {
#line 5250 "LibraryMonitor.c"
									GeeHashSet* _tmp53_;
									Monitorable* _tmp54_;
#line 875 "../src/LibraryMonitor.vala"
									_tmp53_ = all_candidates;
#line 875 "../src/LibraryMonitor.vala"
									_tmp54_ = candidate;
#line 875 "../src/LibraryMonitor.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp53_, _tmp54_);
#line 5259 "LibraryMonitor.c"
								}
#line 873 "../src/LibraryMonitor.vala"
								_g_object_unref0 (candidate);
#line 5263 "LibraryMonitor.c"
							}
#line 873 "../src/LibraryMonitor.vala"
							_g_object_unref0 (_candidate_it);
#line 5267 "LibraryMonitor.c"
						}
					}
				}
#line 854 "../src/LibraryMonitor.vala"
				_g_object_unref0 (candidates);
#line 854 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 5275 "LibraryMonitor.c"
			}
		}
#line 880 "../src/LibraryMonitor.vala"
		if (!known) {
#line 5280 "LibraryMonitor.c"
			GeeHashSet* _tmp57_;
#line 880 "../src/LibraryMonitor.vala"
			_tmp57_ = all_candidates;
#line 880 "../src/LibraryMonitor.vala"
			_tmp56_ = _tmp57_ != NULL;
#line 5286 "LibraryMonitor.c"
		} else {
#line 880 "../src/LibraryMonitor.vala"
			_tmp56_ = FALSE;
#line 5290 "LibraryMonitor.c"
		}
#line 880 "../src/LibraryMonitor.vala"
		if (_tmp56_) {
#line 5294 "LibraryMonitor.c"
			GeeHashSet* _tmp58_;
			gint _tmp59_;
			gint _tmp60_;
#line 880 "../src/LibraryMonitor.vala"
			_tmp58_ = all_candidates;
#line 880 "../src/LibraryMonitor.vala"
			_tmp59_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp58_);
#line 880 "../src/LibraryMonitor.vala"
			_tmp60_ = _tmp59_;
#line 880 "../src/LibraryMonitor.vala"
			_tmp55_ = _tmp60_ > 0;
#line 5306 "LibraryMonitor.c"
		} else {
#line 880 "../src/LibraryMonitor.vala"
			_tmp55_ = FALSE;
#line 5310 "LibraryMonitor.c"
		}
#line 880 "../src/LibraryMonitor.vala"
		if (_tmp55_) {
#line 5314 "LibraryMonitor.c"
			GeeHashSet* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			Workers* _tmp68_;
			GeeHashSet* _tmp69_;
			LibraryMonitorRuntimeFindMoveJob* _tmp70_;
			LibraryMonitorRuntimeFindMoveJob* _tmp71_;
#line 881 "../src/LibraryMonitor.vala"
			_tmp61_ = all_candidates;
#line 881 "../src/LibraryMonitor.vala"
			_tmp62_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp61_);
#line 881 "../src/LibraryMonitor.vala"
			_tmp63_ = _tmp62_;
#line 881 "../src/LibraryMonitor.vala"
			_tmp64_ = g_file_get_path (file);
#line 881 "../src/LibraryMonitor.vala"
			_tmp65_ = _tmp64_;
#line 881 "../src/LibraryMonitor.vala"
			_tmp66_ = g_strdup_printf ("%d candidates for created file %s being checksummed", _tmp63_, _tmp65_);
#line 881 "../src/LibraryMonitor.vala"
			_tmp67_ = _tmp66_;
#line 881 "../src/LibraryMonitor.vala"
			directory_monitor_mdbg (_tmp67_);
#line 881 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp67_);
#line 881 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp65_);
#line 884 "../src/LibraryMonitor.vala"
			_tmp68_ = self->priv->workers;
#line 884 "../src/LibraryMonitor.vala"
			_tmp69_ = all_candidates;
#line 884 "../src/LibraryMonitor.vala"
			_tmp70_ = library_monitor_runtime_find_move_job_new (self, file, (GeeCollection*) _tmp69_);
#line 884 "../src/LibraryMonitor.vala"
			_tmp71_ = _tmp70_;
#line 884 "../src/LibraryMonitor.vala"
			workers_enqueue (_tmp68_, (BackgroundJob*) _tmp71_);
#line 884 "../src/LibraryMonitor.vala"
			_background_job_unref0 (_tmp71_);
#line 886 "../src/LibraryMonitor.vala"
			known = TRUE;
#line 5360 "LibraryMonitor.c"
		}
#line 851 "../src/LibraryMonitor.vala"
		_g_object_unref0 (all_candidates);
#line 5364 "LibraryMonitor.c"
	}
#line 890 "../src/LibraryMonitor.vala"
	if (!known) {
#line 891 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 5370 "LibraryMonitor.c"
	}
#line 893 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_created (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 5374 "LibraryMonitor.c"
}

static void
library_monitor_on_runtime_find_move_completed (LibraryMonitor* self,
                                                BackgroundJob* j)
{
	LibraryMonitorRuntimeFindMoveJob* job = NULL;
	LibraryMonitorRuntimeFindMoveJob* _tmp0_;
	LibraryMonitorRuntimeFindMoveJob* _tmp1_;
	GError* _tmp2_;
	LibraryMonitorRuntimeFindMoveJob* _tmp10_;
	Monitorable* _tmp11_;
#line 896 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 896 "../src/LibraryMonitor.vala"
	g_return_if_fail (j != NULL);
#line 897 "../src/LibraryMonitor.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJob));
#line 897 "../src/LibraryMonitor.vala"
	job = _tmp0_;
#line 899 "../src/LibraryMonitor.vala"
	_tmp1_ = job;
#line 899 "../src/LibraryMonitor.vala"
	_tmp2_ = _tmp1_->err;
#line 899 "../src/LibraryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 5401 "LibraryMonitor.c"
		LibraryMonitorRuntimeFindMoveJob* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		LibraryMonitorRuntimeFindMoveJob* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 900 "../src/LibraryMonitor.vala"
		_tmp3_ = job;
#line 900 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_->file;
#line 900 "../src/LibraryMonitor.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 900 "../src/LibraryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 900 "../src/LibraryMonitor.vala"
		_tmp7_ = job;
#line 900 "../src/LibraryMonitor.vala"
		_tmp8_ = _tmp7_->err;
#line 900 "../src/LibraryMonitor.vala"
		_tmp9_ = _tmp8_->message;
#line 900 "../src/LibraryMonitor.vala"
		g_critical ("LibraryMonitor.vala:900: Error attempting to find a match at runtime f" \
"or %s: %s", _tmp6_, _tmp9_);
#line 900 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp6_);
#line 5427 "LibraryMonitor.c"
	}
#line 904 "../src/LibraryMonitor.vala"
	_tmp10_ = job;
#line 904 "../src/LibraryMonitor.vala"
	_tmp11_ = _tmp10_->match;
#line 904 "../src/LibraryMonitor.vala"
	if (_tmp11_ != NULL) {
#line 5435 "LibraryMonitor.c"
		MediaMonitor* monitor = NULL;
		LibraryMonitorRuntimeFindMoveJob* _tmp12_;
		Monitorable* _tmp13_;
		MediaMonitor* _tmp14_;
		MediaMonitor* _tmp15_;
		LibraryMonitorRuntimeFindMoveJob* _tmp16_;
		Monitorable* _tmp17_;
		LibraryMonitorRuntimeFindMoveJob* _tmp18_;
		GFile* _tmp19_;
		MediaMonitor* _tmp20_;
		LibraryMonitorRuntimeFindMoveJob* _tmp21_;
		Monitorable* _tmp22_;
#line 905 "../src/LibraryMonitor.vala"
		_tmp12_ = job;
#line 905 "../src/LibraryMonitor.vala"
		_tmp13_ = _tmp12_->match;
#line 905 "../src/LibraryMonitor.vala"
		_tmp14_ = library_monitor_get_monitor_for_monitorable (self, _tmp13_);
#line 905 "../src/LibraryMonitor.vala"
		monitor = _tmp14_;
#line 906 "../src/LibraryMonitor.vala"
		_tmp15_ = monitor;
#line 906 "../src/LibraryMonitor.vala"
		_tmp16_ = job;
#line 906 "../src/LibraryMonitor.vala"
		_tmp17_ = _tmp16_->match;
#line 906 "../src/LibraryMonitor.vala"
		_tmp18_ = job;
#line 906 "../src/LibraryMonitor.vala"
		_tmp19_ = _tmp18_->file;
#line 906 "../src/LibraryMonitor.vala"
		media_monitor_update_master_file (_tmp15_, _tmp17_, _tmp19_);
#line 907 "../src/LibraryMonitor.vala"
		_tmp20_ = monitor;
#line 907 "../src/LibraryMonitor.vala"
		_tmp21_ = job;
#line 907 "../src/LibraryMonitor.vala"
		_tmp22_ = _tmp21_->match;
#line 907 "../src/LibraryMonitor.vala"
		media_monitor_update_online (_tmp20_, _tmp22_);
#line 904 "../src/LibraryMonitor.vala"
		_g_object_unref0 (monitor);
#line 5478 "LibraryMonitor.c"
	} else {
		LibraryMonitorRuntimeFindMoveJob* _tmp23_;
		GFile* _tmp24_;
#line 910 "../src/LibraryMonitor.vala"
		_tmp23_ = job;
#line 910 "../src/LibraryMonitor.vala"
		_tmp24_ = _tmp23_->file;
#line 910 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, _tmp24_);
#line 5488 "LibraryMonitor.c"
	}
#line 896 "../src/LibraryMonitor.vala"
	_background_job_unref0 (job);
#line 5492 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_moved (DirectoryMonitor* base,
                                        GFile* old_file,
                                        GFile* new_file,
                                        GFileInfo* new_info)
{
	LibraryMonitor * self;
	gboolean _tmp0_ = FALSE;
	gboolean known = FALSE;
#line 914 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 914 "../src/LibraryMonitor.vala"
	g_return_if_fail (old_file != NULL);
#line 914 "../src/LibraryMonitor.vala"
	g_return_if_fail (new_file != NULL);
#line 914 "../src/LibraryMonitor.vala"
	g_return_if_fail (new_info != NULL);
#line 915 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (old_file)) {
#line 915 "../src/LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 5516 "LibraryMonitor.c"
	} else {
#line 915 "../src/LibraryMonitor.vala"
		_tmp0_ = library_monitor_is_blacklisted (new_file);
#line 5520 "LibraryMonitor.c"
	}
#line 915 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 916 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_moved (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), old_file, new_file, new_info);
#line 918 "../src/LibraryMonitor.vala"
		return;
#line 5528 "LibraryMonitor.c"
	}
#line 921 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 5532 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 922 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 922 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 922 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 922 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 922 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 922 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 922 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 922 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 5557 "LibraryMonitor.c"
			gint _tmp5_;
			gint _tmp6_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			MediaMonitor* _tmp9_;
#line 922 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 922 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_index;
#line 922 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_size;
#line 922 "../src/LibraryMonitor.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 922 "../src/LibraryMonitor.vala"
				break;
#line 5574 "LibraryMonitor.c"
			}
#line 922 "../src/LibraryMonitor.vala"
			_tmp7_ = _monitor_list;
#line 922 "../src/LibraryMonitor.vala"
			_tmp8_ = gee_list_get (_tmp7_, _monitor_index);
#line 922 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp8_;
#line 923 "../src/LibraryMonitor.vala"
			_tmp9_ = monitor;
#line 923 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_moved (_tmp9_, old_file, new_file, new_info)) {
#line 924 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 926 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 926 "../src/LibraryMonitor.vala"
				break;
#line 5592 "LibraryMonitor.c"
			}
#line 922 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 5596 "LibraryMonitor.c"
		}
	}
#line 930 "../src/LibraryMonitor.vala"
	if (!known) {
#line 931 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, new_file);
#line 5603 "LibraryMonitor.c"
	}
#line 933 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_moved (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), old_file, new_file, new_info);
#line 5607 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_altered (DirectoryMonitor* base,
                                          GFile* file)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 936 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 936 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 937 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 938 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 940 "../src/LibraryMonitor.vala"
		return;
#line 5626 "LibraryMonitor.c"
	}
#line 943 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 5630 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		gint _monitor_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 944 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 944 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp0_;
#line 944 "../src/LibraryMonitor.vala"
		_tmp1_ = _monitor_list;
#line 944 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 944 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 944 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp3_;
#line 944 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 944 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 5655 "LibraryMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitor* _tmp8_;
#line 944 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 944 "../src/LibraryMonitor.vala"
			_tmp4_ = _monitor_index;
#line 944 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_size;
#line 944 "../src/LibraryMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 944 "../src/LibraryMonitor.vala"
				break;
#line 5672 "LibraryMonitor.c"
			}
#line 944 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 944 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 944 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 945 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 945 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_altered (_tmp8_, file)) {
#line 946 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 948 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 948 "../src/LibraryMonitor.vala"
				break;
#line 5690 "LibraryMonitor.c"
			}
#line 944 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 5694 "LibraryMonitor.c"
		}
	}
#line 952 "../src/LibraryMonitor.vala"
	if (!known) {
#line 953 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 5701 "LibraryMonitor.c"
	}
#line 955 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 5705 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_attributes_altered (DirectoryMonitor* base,
                                                     GFile* file)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 958 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 958 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 959 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 960 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_attributes_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 962 "../src/LibraryMonitor.vala"
		return;
#line 5724 "LibraryMonitor.c"
	}
#line 965 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 5728 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		gint _monitor_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 966 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 966 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp0_;
#line 966 "../src/LibraryMonitor.vala"
		_tmp1_ = _monitor_list;
#line 966 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 966 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 966 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp3_;
#line 966 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 966 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 5753 "LibraryMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitor* _tmp8_;
#line 966 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 966 "../src/LibraryMonitor.vala"
			_tmp4_ = _monitor_index;
#line 966 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_size;
#line 966 "../src/LibraryMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 966 "../src/LibraryMonitor.vala"
				break;
#line 5770 "LibraryMonitor.c"
			}
#line 966 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 966 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 966 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 967 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 967 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_attributes_altered (_tmp8_, file)) {
#line 968 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 970 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 970 "../src/LibraryMonitor.vala"
				break;
#line 5788 "LibraryMonitor.c"
			}
#line 966 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 5792 "LibraryMonitor.c"
		}
	}
#line 974 "../src/LibraryMonitor.vala"
	if (!known) {
#line 975 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 5799 "LibraryMonitor.c"
	}
#line 977 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_attributes_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 5803 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_alteration_completed (DirectoryMonitor* base,
                                                       GFile* file,
                                                       GFileInfo* info)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 980 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 980 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 980 "../src/LibraryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 981 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 982 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_alteration_completed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 984 "../src/LibraryMonitor.vala"
		return;
#line 5825 "LibraryMonitor.c"
	}
#line 987 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 5829 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		gint _monitor_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 988 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 988 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp0_;
#line 988 "../src/LibraryMonitor.vala"
		_tmp1_ = _monitor_list;
#line 988 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 988 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 988 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp3_;
#line 988 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 988 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 5854 "LibraryMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitor* _tmp8_;
#line 988 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 988 "../src/LibraryMonitor.vala"
			_tmp4_ = _monitor_index;
#line 988 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_size;
#line 988 "../src/LibraryMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 988 "../src/LibraryMonitor.vala"
				break;
#line 5871 "LibraryMonitor.c"
			}
#line 988 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 988 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 988 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 989 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 989 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_alteration_completed (_tmp8_, file, info)) {
#line 990 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 992 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 992 "../src/LibraryMonitor.vala"
				break;
#line 5889 "LibraryMonitor.c"
			}
#line 988 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 5893 "LibraryMonitor.c"
		}
	}
#line 996 "../src/LibraryMonitor.vala"
	if (!known) {
#line 997 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 5900 "LibraryMonitor.c"
	}
#line 999 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_alteration_completed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 5904 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_deleted (DirectoryMonitor* base,
                                          GFile* file)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 1002 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 1002 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 1003 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 1004 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_deleted (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 1006 "../src/LibraryMonitor.vala"
		return;
#line 5923 "LibraryMonitor.c"
	}
#line 1009 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 5927 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		gint _monitor_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 1010 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 1010 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp0_;
#line 1010 "../src/LibraryMonitor.vala"
		_tmp1_ = _monitor_list;
#line 1010 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 1010 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 1010 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp3_;
#line 1010 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 1010 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 5952 "LibraryMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitor* _tmp8_;
#line 1010 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 1010 "../src/LibraryMonitor.vala"
			_tmp4_ = _monitor_index;
#line 1010 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_size;
#line 1010 "../src/LibraryMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 1010 "../src/LibraryMonitor.vala"
				break;
#line 5969 "LibraryMonitor.c"
			}
#line 1010 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 1010 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 1010 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 1011 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 1011 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_deleted (_tmp8_, file)) {
#line 1012 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 1014 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 1014 "../src/LibraryMonitor.vala"
				break;
#line 5987 "LibraryMonitor.c"
			}
#line 1010 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 5991 "LibraryMonitor.c"
		}
	}
#line 1018 "../src/LibraryMonitor.vala"
	if (!known) {
#line 5996 "LibraryMonitor.c"
		Tombstone* tombstone = NULL;
		TombstoneSourceCollection* _tmp9_;
		Tombstone* _tmp10_;
		Tombstone* _tmp11_;
#line 1020 "../src/LibraryMonitor.vala"
		_tmp9_ = tombstone_global;
#line 1020 "../src/LibraryMonitor.vala"
		_tmp10_ = tombstone_source_collection_locate (_tmp9_, file);
#line 1020 "../src/LibraryMonitor.vala"
		tombstone = _tmp10_;
#line 1021 "../src/LibraryMonitor.vala"
		_tmp11_ = tombstone;
#line 1021 "../src/LibraryMonitor.vala"
		if (_tmp11_ != NULL) {
#line 6011 "LibraryMonitor.c"
			gchar* _tmp12_;
			gchar* _tmp13_;
			TombstoneSourceCollection* _tmp14_;
			Tombstone* _tmp15_;
#line 1022 "../src/LibraryMonitor.vala"
			_tmp12_ = g_file_get_path (file);
#line 1022 "../src/LibraryMonitor.vala"
			_tmp13_ = _tmp12_;
#line 1022 "../src/LibraryMonitor.vala"
			g_debug ("LibraryMonitor.vala:1022: Resurrecting tombstoned file %s", _tmp13_);
#line 1022 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp13_);
#line 1023 "../src/LibraryMonitor.vala"
			_tmp14_ = tombstone_global;
#line 1023 "../src/LibraryMonitor.vala"
			_tmp15_ = tombstone;
#line 1023 "../src/LibraryMonitor.vala"
			tombstone_source_collection_resurrect (_tmp14_, _tmp15_);
#line 6030 "LibraryMonitor.c"
		}
#line 1027 "../src/LibraryMonitor.vala"
		library_monitor_remove_queued_import (self, file);
#line 1018 "../src/LibraryMonitor.vala"
		_g_object_unref0 (tombstone);
#line 6036 "LibraryMonitor.c"
	}
#line 1030 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_deleted (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 6040 "LibraryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 110 "../src/LibraryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 110 "../src/LibraryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 110 "../src/LibraryMonitor.vala"
		data1 = closure->data;
#line 110 "../src/LibraryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6065 "LibraryMonitor.c"
	} else {
#line 110 "../src/LibraryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 110 "../src/LibraryMonitor.vala"
		data2 = closure->data;
#line 6071 "LibraryMonitor.c"
	}
#line 110 "../src/LibraryMonitor.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 110 "../src/LibraryMonitor.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 6077 "LibraryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT64_UINT64) (gpointer data1, guint64 arg_1, guint64 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT64_UINT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 110 "../src/LibraryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 110 "../src/LibraryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 110 "../src/LibraryMonitor.vala"
		data1 = closure->data;
#line 110 "../src/LibraryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6102 "LibraryMonitor.c"
	} else {
#line 110 "../src/LibraryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 110 "../src/LibraryMonitor.vala"
		data2 = closure->data;
#line 6108 "LibraryMonitor.c"
	}
#line 110 "../src/LibraryMonitor.vala"
	callback = (GMarshalFunc_VOID__UINT64_UINT64) (marshal_data ? marshal_data : cc->callback);
#line 110 "../src/LibraryMonitor.vala"
	callback (data1, g_value_get_uint64 (param_values + 1), g_value_get_uint64 (param_values + 2), data2);
#line 6114 "LibraryMonitor.c"
}

static void
_library_monitor_on_find_move_completed_completion_callback (BackgroundJob* job,
                                                             gpointer self)
{
#line 124 "../src/LibraryMonitor.vala"
	library_monitor_on_find_move_completed ((LibraryMonitor*) self, job);
#line 6123 "LibraryMonitor.c"
}

static void
_library_monitor_on_find_move_cancelled_cancellation_callback (BackgroundJob* job,
                                                               gpointer self)
{
#line 124 "../src/LibraryMonitor.vala"
	library_monitor_on_find_move_cancelled ((LibraryMonitor*) self, job);
#line 6132 "LibraryMonitor.c"
}

static LibraryMonitorFindMoveJob*
library_monitor_find_move_job_construct (GType object_type,
                                         LibraryMonitor* owner,
                                         GFile* file,
                                         GeeCollection* candidates)
{
	LibraryMonitorFindMoveJob* self = NULL;
	GCancellable* _tmp0_;
	GFile* _tmp1_;
	GeeCollection* _tmp2_;
#line 123 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 123 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 123 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (candidates != NULL, NULL);
#line 124 "../src/LibraryMonitor.vala"
	_tmp0_ = owner->priv->cancellable;
#line 124 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorFindMoveJob*) background_job_construct (object_type, (GObject*) owner, _library_monitor_on_find_move_completed_completion_callback, owner, _tmp0_, _library_monitor_on_find_move_cancelled_cancellation_callback, owner, NULL);
#line 126 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 126 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->file);
#line 126 "../src/LibraryMonitor.vala"
	self->file = _tmp1_;
#line 127 "../src/LibraryMonitor.vala"
	_tmp2_ = _g_object_ref0 (candidates);
#line 127 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->candidates);
#line 127 "../src/LibraryMonitor.vala"
	self->candidates = _tmp2_;
#line 129 "../src/LibraryMonitor.vala"
	background_job_set_completion_priority ((BackgroundJob*) self, G_PRIORITY_LOW);
#line 123 "../src/LibraryMonitor.vala"
	return self;
#line 6171 "LibraryMonitor.c"
}

static LibraryMonitorFindMoveJob*
library_monitor_find_move_job_new (LibraryMonitor* owner,
                                   GFile* file,
                                   GeeCollection* candidates)
{
#line 123 "../src/LibraryMonitor.vala"
	return library_monitor_find_move_job_construct (LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, owner, file, candidates);
#line 6181 "LibraryMonitor.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 148 "../src/LibraryMonitor.vala"
	return self ? g_error_copy (self) : NULL;
#line 6189 "LibraryMonitor.c"
}

static void
library_monitor_find_move_job_real_execute (BackgroundJob* base)
{
	LibraryMonitorFindMoveJob * self;
	GeeIterator* iter = NULL;
	GeeCollection* _tmp0_;
	GeeIterator* _tmp1_;
	GeeCollection* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gchar* md5 = NULL;
	GError* _inner_error0_ = NULL;
#line 132 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorFindMoveJob*) base;
#line 134 "../src/LibraryMonitor.vala"
	_tmp0_ = self->candidates;
#line 134 "../src/LibraryMonitor.vala"
	_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 134 "../src/LibraryMonitor.vala"
	iter = _tmp1_;
#line 135 "../src/LibraryMonitor.vala"
	while (TRUE) {
#line 6214 "LibraryMonitor.c"
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		gpointer _tmp4_;
		Monitorable* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		gboolean _tmp8_;
#line 135 "../src/LibraryMonitor.vala"
		_tmp2_ = iter;
#line 135 "../src/LibraryMonitor.vala"
		if (!gee_iterator_next (_tmp2_)) {
#line 135 "../src/LibraryMonitor.vala"
			break;
#line 6228 "LibraryMonitor.c"
		}
#line 136 "../src/LibraryMonitor.vala"
		_tmp3_ = iter;
#line 136 "../src/LibraryMonitor.vala"
		_tmp4_ = gee_iterator_get (_tmp3_);
#line 136 "../src/LibraryMonitor.vala"
		_tmp5_ = (Monitorable*) _tmp4_;
#line 136 "../src/LibraryMonitor.vala"
		_tmp6_ = media_source_get_master_file ((MediaSource*) _tmp5_);
#line 136 "../src/LibraryMonitor.vala"
		_tmp7_ = _tmp6_;
#line 136 "../src/LibraryMonitor.vala"
		_tmp8_ = g_file_query_exists (_tmp7_, NULL);
#line 136 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp7_);
#line 136 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp5_);
#line 136 "../src/LibraryMonitor.vala"
		if (_tmp8_) {
#line 6248 "LibraryMonitor.c"
			GeeIterator* _tmp9_;
#line 137 "../src/LibraryMonitor.vala"
			_tmp9_ = iter;
#line 137 "../src/LibraryMonitor.vala"
			gee_iterator_remove (_tmp9_);
#line 6254 "LibraryMonitor.c"
		}
	}
#line 141 "../src/LibraryMonitor.vala"
	_tmp10_ = self->candidates;
#line 141 "../src/LibraryMonitor.vala"
	_tmp11_ = gee_collection_get_size (_tmp10_);
#line 141 "../src/LibraryMonitor.vala"
	_tmp12_ = _tmp11_;
#line 141 "../src/LibraryMonitor.vala"
	if (_tmp12_ == 0) {
#line 142 "../src/LibraryMonitor.vala"
		_g_object_unref0 (iter);
#line 142 "../src/LibraryMonitor.vala"
		return;
#line 6269 "LibraryMonitor.c"
	}
#line 144 "../src/LibraryMonitor.vala"
	md5 = NULL;
#line 6273 "LibraryMonitor.c"
	{
		gchar* _tmp13_ = NULL;
		GFile* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 146 "../src/LibraryMonitor.vala"
		_tmp14_ = self->file;
#line 146 "../src/LibraryMonitor.vala"
		_tmp15_ = md5_file (_tmp14_, &_inner_error0_);
#line 146 "../src/LibraryMonitor.vala"
		_tmp13_ = _tmp15_;
#line 146 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6287 "LibraryMonitor.c"
			goto __catch0_g_error;
		}
#line 146 "../src/LibraryMonitor.vala"
		_tmp16_ = _tmp13_;
#line 146 "../src/LibraryMonitor.vala"
		_tmp13_ = NULL;
#line 146 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 146 "../src/LibraryMonitor.vala"
		md5 = _tmp16_;
#line 145 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp13_);
#line 6300 "LibraryMonitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp17_;
		GError* _tmp18_;
#line 145 "../src/LibraryMonitor.vala"
		err = _inner_error0_;
#line 145 "../src/LibraryMonitor.vala"
		_inner_error0_ = NULL;
#line 148 "../src/LibraryMonitor.vala"
		_tmp17_ = err;
#line 148 "../src/LibraryMonitor.vala"
		_tmp18_ = _g_error_copy0 (_tmp17_);
#line 148 "../src/LibraryMonitor.vala"
		_g_error_free0 (self->err);
#line 148 "../src/LibraryMonitor.vala"
		self->err = _tmp18_;
#line 150 "../src/LibraryMonitor.vala"
		_g_error_free0 (err);
#line 150 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 150 "../src/LibraryMonitor.vala"
		_g_object_unref0 (iter);
#line 150 "../src/LibraryMonitor.vala"
		return;
#line 6328 "LibraryMonitor.c"
	}
	__finally0:
#line 145 "../src/LibraryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 145 "../src/LibraryMonitor.vala"
		_g_object_unref0 (iter);
#line 145 "../src/LibraryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "../src/LibraryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 145 "../src/LibraryMonitor.vala"
		return;
#line 6343 "LibraryMonitor.c"
	}
	{
		GeeIterator* _candidate_it = NULL;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
#line 153 "../src/LibraryMonitor.vala"
		_tmp19_ = self->candidates;
#line 153 "../src/LibraryMonitor.vala"
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 153 "../src/LibraryMonitor.vala"
		_candidate_it = _tmp20_;
#line 153 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 6357 "LibraryMonitor.c"
			GeeIterator* _tmp21_;
			Monitorable* candidate = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			Monitorable* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			const gchar* _tmp27_;
			gboolean _tmp28_;
			Monitorable* _tmp29_;
			Monitorable* _tmp43_;
			Monitorable* _tmp44_;
#line 153 "../src/LibraryMonitor.vala"
			_tmp21_ = _candidate_it;
#line 153 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp21_)) {
#line 153 "../src/LibraryMonitor.vala"
				break;
#line 6376 "LibraryMonitor.c"
			}
#line 153 "../src/LibraryMonitor.vala"
			_tmp22_ = _candidate_it;
#line 153 "../src/LibraryMonitor.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 153 "../src/LibraryMonitor.vala"
			candidate = (Monitorable*) _tmp23_;
#line 154 "../src/LibraryMonitor.vala"
			_tmp24_ = candidate;
#line 154 "../src/LibraryMonitor.vala"
			_tmp25_ = media_source_get_master_md5 ((MediaSource*) _tmp24_);
#line 154 "../src/LibraryMonitor.vala"
			_tmp26_ = _tmp25_;
#line 154 "../src/LibraryMonitor.vala"
			_tmp27_ = md5;
#line 154 "../src/LibraryMonitor.vala"
			_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) != 0;
#line 154 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp26_);
#line 154 "../src/LibraryMonitor.vala"
			if (_tmp28_) {
#line 155 "../src/LibraryMonitor.vala"
				_g_object_unref0 (candidate);
#line 155 "../src/LibraryMonitor.vala"
				continue;
#line 6402 "LibraryMonitor.c"
			}
#line 157 "../src/LibraryMonitor.vala"
			_tmp29_ = self->match;
#line 157 "../src/LibraryMonitor.vala"
			if (_tmp29_ != NULL) {
#line 6408 "LibraryMonitor.c"
				GFile* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				Monitorable* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				Monitorable* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				GeeArrayList* _tmp39_;
				GeeArrayList* _tmp41_;
				Monitorable* _tmp42_;
#line 158 "../src/LibraryMonitor.vala"
				_tmp30_ = self->file;
#line 158 "../src/LibraryMonitor.vala"
				_tmp31_ = g_file_get_path (_tmp30_);
#line 158 "../src/LibraryMonitor.vala"
				_tmp32_ = _tmp31_;
#line 158 "../src/LibraryMonitor.vala"
				_tmp33_ = self->match;
#line 158 "../src/LibraryMonitor.vala"
				_tmp34_ = data_object_to_string ((DataObject*) _tmp33_);
#line 158 "../src/LibraryMonitor.vala"
				_tmp35_ = _tmp34_;
#line 158 "../src/LibraryMonitor.vala"
				_tmp36_ = candidate;
#line 158 "../src/LibraryMonitor.vala"
				_tmp37_ = data_object_to_string ((DataObject*) _tmp36_);
#line 158 "../src/LibraryMonitor.vala"
				_tmp38_ = _tmp37_;
#line 158 "../src/LibraryMonitor.vala"
				g_warning ("LibraryMonitor.vala:158: Found more than one media match for %s: %s an" \
"d %s", _tmp32_, _tmp35_, _tmp38_);
#line 158 "../src/LibraryMonitor.vala"
				_g_free0 (_tmp38_);
#line 158 "../src/LibraryMonitor.vala"
				_g_free0 (_tmp35_);
#line 158 "../src/LibraryMonitor.vala"
				_g_free0 (_tmp32_);
#line 161 "../src/LibraryMonitor.vala"
				_tmp39_ = self->losers;
#line 161 "../src/LibraryMonitor.vala"
				if (_tmp39_ == NULL) {
#line 6451 "LibraryMonitor.c"
					GeeArrayList* _tmp40_;
#line 162 "../src/LibraryMonitor.vala"
					_tmp40_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 162 "../src/LibraryMonitor.vala"
					_g_object_unref0 (self->losers);
#line 162 "../src/LibraryMonitor.vala"
					self->losers = _tmp40_;
#line 6459 "LibraryMonitor.c"
				}
#line 164 "../src/LibraryMonitor.vala"
				_tmp41_ = self->losers;
#line 164 "../src/LibraryMonitor.vala"
				_tmp42_ = candidate;
#line 164 "../src/LibraryMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, _tmp42_);
#line 166 "../src/LibraryMonitor.vala"
				_g_object_unref0 (candidate);
#line 166 "../src/LibraryMonitor.vala"
				continue;
#line 6471 "LibraryMonitor.c"
			}
#line 169 "../src/LibraryMonitor.vala"
			_tmp43_ = candidate;
#line 169 "../src/LibraryMonitor.vala"
			_tmp44_ = _g_object_ref0 (_tmp43_);
#line 169 "../src/LibraryMonitor.vala"
			_g_object_unref0 (self->match);
#line 169 "../src/LibraryMonitor.vala"
			self->match = _tmp44_;
#line 153 "../src/LibraryMonitor.vala"
			_g_object_unref0 (candidate);
#line 6483 "LibraryMonitor.c"
		}
#line 153 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_candidate_it);
#line 6487 "LibraryMonitor.c"
	}
#line 132 "../src/LibraryMonitor.vala"
	_g_free0 (md5);
#line 132 "../src/LibraryMonitor.vala"
	_g_object_unref0 (iter);
#line 6493 "LibraryMonitor.c"
}

static void
library_monitor_find_move_job_class_init (LibraryMonitorFindMoveJobClass * klass,
                                          gpointer klass_data)
{
#line 116 "../src/LibraryMonitor.vala"
	library_monitor_find_move_job_parent_class = g_type_class_peek_parent (klass);
#line 116 "../src/LibraryMonitor.vala"
	((BackgroundJobClass *) klass)->finalize = library_monitor_find_move_job_finalize;
#line 116 "../src/LibraryMonitor.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) library_monitor_find_move_job_real_execute;
#line 6506 "LibraryMonitor.c"
}

static void
library_monitor_find_move_job_instance_init (LibraryMonitorFindMoveJob * self,
                                             gpointer klass)
{
#line 119 "../src/LibraryMonitor.vala"
	self->match = NULL;
#line 120 "../src/LibraryMonitor.vala"
	self->losers = NULL;
#line 121 "../src/LibraryMonitor.vala"
	self->err = NULL;
#line 6519 "LibraryMonitor.c"
}

static void
library_monitor_find_move_job_finalize (BackgroundJob * obj)
{
	LibraryMonitorFindMoveJob * self;
#line 116 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJob);
#line 117 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->file);
#line 118 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->candidates);
#line 119 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->match);
#line 120 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->losers);
#line 121 "../src/LibraryMonitor.vala"
	_g_error_free0 (self->err);
#line 116 "../src/LibraryMonitor.vala"
	BACKGROUND_JOB_CLASS (library_monitor_find_move_job_parent_class)->finalize (obj);
#line 6540 "LibraryMonitor.c"
}

static GType
library_monitor_find_move_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorFindMoveJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_find_move_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorFindMoveJob), 0, (GInstanceInitFunc) library_monitor_find_move_job_instance_init, NULL };
	GType library_monitor_find_move_job_type_id;
	library_monitor_find_move_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "LibraryMonitorFindMoveJob", &g_define_type_info, 0);
	return library_monitor_find_move_job_type_id;
}

static GType
library_monitor_find_move_job_get_type (void)
{
	static volatile gsize library_monitor_find_move_job_type_id__once = 0;
	if (g_once_init_enter (&library_monitor_find_move_job_type_id__once)) {
		GType library_monitor_find_move_job_type_id;
		library_monitor_find_move_job_type_id = library_monitor_find_move_job_get_type_once ();
		g_once_init_leave (&library_monitor_find_move_job_type_id__once, library_monitor_find_move_job_type_id);
	}
	return library_monitor_find_move_job_type_id__once;
}

static void
_library_monitor_on_runtime_find_move_completed_completion_callback (BackgroundJob* job,
                                                                     gpointer self)
{
#line 181 "../src/LibraryMonitor.vala"
	library_monitor_on_runtime_find_move_completed ((LibraryMonitor*) self, job);
#line 6570 "LibraryMonitor.c"
}

static LibraryMonitorRuntimeFindMoveJob*
library_monitor_runtime_find_move_job_construct (GType object_type,
                                                 LibraryMonitor* owner,
                                                 GFile* file,
                                                 GeeCollection* candidates)
{
	LibraryMonitorRuntimeFindMoveJob* self = NULL;
	GCancellable* _tmp0_;
	GFile* _tmp1_;
	GeeCollection* _tmp2_;
#line 180 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 180 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 180 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (candidates != NULL, NULL);
#line 181 "../src/LibraryMonitor.vala"
	_tmp0_ = owner->priv->cancellable;
#line 181 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorRuntimeFindMoveJob*) background_job_construct (object_type, (GObject*) owner, _library_monitor_on_runtime_find_move_completed_completion_callback, owner, _tmp0_, NULL, NULL, NULL);
#line 183 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 183 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->file);
#line 183 "../src/LibraryMonitor.vala"
	self->file = _tmp1_;
#line 184 "../src/LibraryMonitor.vala"
	_tmp2_ = _g_object_ref0 (candidates);
#line 184 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->candidates);
#line 184 "../src/LibraryMonitor.vala"
	self->candidates = _tmp2_;
#line 186 "../src/LibraryMonitor.vala"
	background_job_set_completion_priority ((BackgroundJob*) self, G_PRIORITY_LOW);
#line 180 "../src/LibraryMonitor.vala"
	return self;
#line 6609 "LibraryMonitor.c"
}

static LibraryMonitorRuntimeFindMoveJob*
library_monitor_runtime_find_move_job_new (LibraryMonitor* owner,
                                           GFile* file,
                                           GeeCollection* candidates)
{
#line 180 "../src/LibraryMonitor.vala"
	return library_monitor_runtime_find_move_job_construct (LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, owner, file, candidates);
#line 6619 "LibraryMonitor.c"
}

static void
library_monitor_runtime_find_move_job_real_execute (BackgroundJob* base)
{
	LibraryMonitorRuntimeFindMoveJob * self;
	gchar* md5 = NULL;
	GError* _inner_error0_ = NULL;
#line 189 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorRuntimeFindMoveJob*) base;
#line 190 "../src/LibraryMonitor.vala"
	md5 = NULL;
#line 6632 "LibraryMonitor.c"
	{
		gchar* _tmp0_ = NULL;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 192 "../src/LibraryMonitor.vala"
		_tmp1_ = self->file;
#line 192 "../src/LibraryMonitor.vala"
		_tmp2_ = md5_file (_tmp1_, &_inner_error0_);
#line 192 "../src/LibraryMonitor.vala"
		_tmp0_ = _tmp2_;
#line 192 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6646 "LibraryMonitor.c"
			goto __catch0_g_error;
		}
#line 192 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp0_;
#line 192 "../src/LibraryMonitor.vala"
		_tmp0_ = NULL;
#line 192 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 192 "../src/LibraryMonitor.vala"
		md5 = _tmp3_;
#line 191 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp0_);
#line 6659 "LibraryMonitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
		GError* _tmp5_;
#line 191 "../src/LibraryMonitor.vala"
		err = _inner_error0_;
#line 191 "../src/LibraryMonitor.vala"
		_inner_error0_ = NULL;
#line 194 "../src/LibraryMonitor.vala"
		_tmp4_ = err;
#line 194 "../src/LibraryMonitor.vala"
		_tmp5_ = _g_error_copy0 (_tmp4_);
#line 194 "../src/LibraryMonitor.vala"
		_g_error_free0 (self->err);
#line 194 "../src/LibraryMonitor.vala"
		self->err = _tmp5_;
#line 196 "../src/LibraryMonitor.vala"
		_g_error_free0 (err);
#line 196 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 196 "../src/LibraryMonitor.vala"
		return;
#line 6685 "LibraryMonitor.c"
	}
	__finally0:
#line 191 "../src/LibraryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 191 "../src/LibraryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../src/LibraryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 191 "../src/LibraryMonitor.vala"
		return;
#line 6698 "LibraryMonitor.c"
	}
	{
		GeeIterator* _candidate_it = NULL;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
#line 199 "../src/LibraryMonitor.vala"
		_tmp6_ = self->candidates;
#line 199 "../src/LibraryMonitor.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 199 "../src/LibraryMonitor.vala"
		_candidate_it = _tmp7_;
#line 199 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 6712 "LibraryMonitor.c"
			GeeIterator* _tmp8_;
			Monitorable* candidate = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			Monitorable* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			const gchar* _tmp14_;
			gboolean _tmp15_;
#line 199 "../src/LibraryMonitor.vala"
			_tmp8_ = _candidate_it;
#line 199 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 199 "../src/LibraryMonitor.vala"
				break;
#line 6728 "LibraryMonitor.c"
			}
#line 199 "../src/LibraryMonitor.vala"
			_tmp9_ = _candidate_it;
#line 199 "../src/LibraryMonitor.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 199 "../src/LibraryMonitor.vala"
			candidate = (Monitorable*) _tmp10_;
#line 200 "../src/LibraryMonitor.vala"
			_tmp11_ = candidate;
#line 200 "../src/LibraryMonitor.vala"
			_tmp12_ = media_source_get_master_md5 ((MediaSource*) _tmp11_);
#line 200 "../src/LibraryMonitor.vala"
			_tmp13_ = _tmp12_;
#line 200 "../src/LibraryMonitor.vala"
			_tmp14_ = md5;
#line 200 "../src/LibraryMonitor.vala"
			_tmp15_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
#line 200 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp13_);
#line 200 "../src/LibraryMonitor.vala"
			if (_tmp15_) {
#line 6750 "LibraryMonitor.c"
				Monitorable* _tmp16_;
				Monitorable* _tmp17_;
#line 201 "../src/LibraryMonitor.vala"
				_tmp16_ = candidate;
#line 201 "../src/LibraryMonitor.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 201 "../src/LibraryMonitor.vala"
				_g_object_unref0 (self->match);
#line 201 "../src/LibraryMonitor.vala"
				self->match = _tmp17_;
#line 203 "../src/LibraryMonitor.vala"
				_g_object_unref0 (candidate);
#line 203 "../src/LibraryMonitor.vala"
				break;
#line 6765 "LibraryMonitor.c"
			}
#line 199 "../src/LibraryMonitor.vala"
			_g_object_unref0 (candidate);
#line 6769 "LibraryMonitor.c"
		}
#line 199 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_candidate_it);
#line 6773 "LibraryMonitor.c"
	}
#line 189 "../src/LibraryMonitor.vala"
	_g_free0 (md5);
#line 6777 "LibraryMonitor.c"
}

static void
library_monitor_runtime_find_move_job_class_init (LibraryMonitorRuntimeFindMoveJobClass * klass,
                                                  gpointer klass_data)
{
#line 174 "../src/LibraryMonitor.vala"
	library_monitor_runtime_find_move_job_parent_class = g_type_class_peek_parent (klass);
#line 174 "../src/LibraryMonitor.vala"
	((BackgroundJobClass *) klass)->finalize = library_monitor_runtime_find_move_job_finalize;
#line 174 "../src/LibraryMonitor.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) library_monitor_runtime_find_move_job_real_execute;
#line 6790 "LibraryMonitor.c"
}

static void
library_monitor_runtime_find_move_job_instance_init (LibraryMonitorRuntimeFindMoveJob * self,
                                                     gpointer klass)
{
#line 177 "../src/LibraryMonitor.vala"
	self->match = NULL;
#line 178 "../src/LibraryMonitor.vala"
	self->err = NULL;
#line 6801 "LibraryMonitor.c"
}

static void
library_monitor_runtime_find_move_job_finalize (BackgroundJob * obj)
{
	LibraryMonitorRuntimeFindMoveJob * self;
#line 174 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJob);
#line 175 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->file);
#line 176 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->candidates);
#line 177 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->match);
#line 178 "../src/LibraryMonitor.vala"
	_g_error_free0 (self->err);
#line 174 "../src/LibraryMonitor.vala"
	BACKGROUND_JOB_CLASS (library_monitor_runtime_find_move_job_parent_class)->finalize (obj);
#line 6820 "LibraryMonitor.c"
}

static GType
library_monitor_runtime_find_move_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorRuntimeFindMoveJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_runtime_find_move_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorRuntimeFindMoveJob), 0, (GInstanceInitFunc) library_monitor_runtime_find_move_job_instance_init, NULL };
	GType library_monitor_runtime_find_move_job_type_id;
	library_monitor_runtime_find_move_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "LibraryMonitorRuntimeFindMoveJob", &g_define_type_info, 0);
	return library_monitor_runtime_find_move_job_type_id;
}

static GType
library_monitor_runtime_find_move_job_get_type (void)
{
	static volatile gsize library_monitor_runtime_find_move_job_type_id__once = 0;
	if (g_once_init_enter (&library_monitor_runtime_find_move_job_type_id__once)) {
		GType library_monitor_runtime_find_move_job_type_id;
		library_monitor_runtime_find_move_job_type_id = library_monitor_runtime_find_move_job_get_type_once ();
		g_once_init_leave (&library_monitor_runtime_find_move_job_type_id__once, library_monitor_runtime_find_move_job_type_id);
	}
	return library_monitor_runtime_find_move_job_type_id__once;
}

static LibraryMonitorVerifyJob*
library_monitor_verify_job_construct (GType object_type,
                                      Monitorable* monitorable,
                                      MediaMonitor* monitor)
{
	LibraryMonitorVerifyJob* self = NULL;
	Monitorable* _tmp0_;
	MediaMonitor* _tmp1_;
#line 213 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 213 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (monitor != NULL, NULL);
#line 213 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorVerifyJob*) g_type_create_instance (object_type);
#line 214 "../src/LibraryMonitor.vala"
	_tmp0_ = _g_object_ref0 (monitorable);
#line 214 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->monitorable);
#line 214 "../src/LibraryMonitor.vala"
	self->monitorable = _tmp0_;
#line 215 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (monitor);
#line 215 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->monitor);
#line 215 "../src/LibraryMonitor.vala"
	self->monitor = _tmp1_;
#line 213 "../src/LibraryMonitor.vala"
	return self;
#line 6872 "LibraryMonitor.c"
}

static LibraryMonitorVerifyJob*
library_monitor_verify_job_new (Monitorable* monitorable,
                                MediaMonitor* monitor)
{
#line 213 "../src/LibraryMonitor.vala"
	return library_monitor_verify_job_construct (LIBRARY_MONITOR_TYPE_VERIFY_JOB, monitorable, monitor);
#line 6881 "LibraryMonitor.c"
}

static void
library_monitor_value_verify_job_init (GValue* value)
{
#line 209 "../src/LibraryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 6889 "LibraryMonitor.c"
}

static void
library_monitor_value_verify_job_free_value (GValue* value)
{
#line 209 "../src/LibraryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 209 "../src/LibraryMonitor.vala"
		library_monitor_verify_job_unref (value->data[0].v_pointer);
#line 6899 "LibraryMonitor.c"
	}
}

static void
library_monitor_value_verify_job_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 209 "../src/LibraryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 209 "../src/LibraryMonitor.vala"
		dest_value->data[0].v_pointer = library_monitor_verify_job_ref (src_value->data[0].v_pointer);
#line 6911 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6915 "LibraryMonitor.c"
	}
}

static gpointer
library_monitor_value_verify_job_peek_pointer (const GValue* value)
{
#line 209 "../src/LibraryMonitor.vala"
	return value->data[0].v_pointer;
#line 6924 "LibraryMonitor.c"
}

static gchar*
library_monitor_value_verify_job_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 209 "../src/LibraryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 6935 "LibraryMonitor.c"
		LibraryMonitorVerifyJob * object;
		object = collect_values[0].v_pointer;
#line 209 "../src/LibraryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 209 "../src/LibraryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6942 "LibraryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 209 "../src/LibraryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6946 "LibraryMonitor.c"
		}
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = library_monitor_verify_job_ref (object);
#line 6950 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6954 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	return NULL;
#line 6958 "LibraryMonitor.c"
}

static gchar*
library_monitor_value_verify_job_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	LibraryMonitorVerifyJob ** object_p;
	object_p = collect_values[0].v_pointer;
#line 209 "../src/LibraryMonitor.vala"
	if (!object_p) {
#line 209 "../src/LibraryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6973 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 209 "../src/LibraryMonitor.vala"
		*object_p = NULL;
#line 6979 "LibraryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 209 "../src/LibraryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 6983 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		*object_p = library_monitor_verify_job_ref (value->data[0].v_pointer);
#line 6987 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	return NULL;
#line 6991 "LibraryMonitor.c"
}

static GParamSpec*
library_monitor_param_spec_verify_job (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	LibraryMonitorParamSpecVerifyJob* spec;
#line 209 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, LIBRARY_MONITOR_TYPE_VERIFY_JOB), NULL);
#line 209 "../src/LibraryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 209 "../src/LibraryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 209 "../src/LibraryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 7010 "LibraryMonitor.c"
}

static gpointer
library_monitor_value_get_verify_job (const GValue* value)
{
#line 209 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB), NULL);
#line 209 "../src/LibraryMonitor.vala"
	return value->data[0].v_pointer;
#line 7020 "LibraryMonitor.c"
}

static void
library_monitor_value_set_verify_job (GValue* value,
                                      gpointer v_object)
{
	LibraryMonitorVerifyJob * old;
#line 209 "../src/LibraryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
#line 209 "../src/LibraryMonitor.vala"
	old = value->data[0].v_pointer;
#line 209 "../src/LibraryMonitor.vala"
	if (v_object) {
#line 209 "../src/LibraryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
#line 209 "../src/LibraryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 209 "../src/LibraryMonitor.vala"
		library_monitor_verify_job_ref (value->data[0].v_pointer);
#line 7042 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7046 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	if (old) {
#line 209 "../src/LibraryMonitor.vala"
		library_monitor_verify_job_unref (old);
#line 7052 "LibraryMonitor.c"
	}
}

static void
library_monitor_value_take_verify_job (GValue* value,
                                       gpointer v_object)
{
	LibraryMonitorVerifyJob * old;
#line 209 "../src/LibraryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
#line 209 "../src/LibraryMonitor.vala"
	old = value->data[0].v_pointer;
#line 209 "../src/LibraryMonitor.vala"
	if (v_object) {
#line 209 "../src/LibraryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
#line 209 "../src/LibraryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 7073 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7077 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	if (old) {
#line 209 "../src/LibraryMonitor.vala"
		library_monitor_verify_job_unref (old);
#line 7083 "LibraryMonitor.c"
	}
}

static void
library_monitor_verify_job_class_init (LibraryMonitorVerifyJobClass * klass,
                                       gpointer klass_data)
{
#line 209 "../src/LibraryMonitor.vala"
	library_monitor_verify_job_parent_class = g_type_class_peek_parent (klass);
#line 209 "../src/LibraryMonitor.vala"
	((LibraryMonitorVerifyJobClass *) klass)->finalize = library_monitor_verify_job_finalize;
#line 7095 "LibraryMonitor.c"
}

static void
library_monitor_verify_job_instance_init (LibraryMonitorVerifyJob * self,
                                          gpointer klass)
{
#line 209 "../src/LibraryMonitor.vala"
	self->ref_count = 1;
#line 7104 "LibraryMonitor.c"
}

static void
library_monitor_verify_job_finalize (LibraryMonitorVerifyJob * obj)
{
	LibraryMonitorVerifyJob * self;
#line 209 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJob);
#line 209 "../src/LibraryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 210 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->monitorable);
#line 211 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->monitor);
#line 7119 "LibraryMonitor.c"
}

static GType
library_monitor_verify_job_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { library_monitor_value_verify_job_init, library_monitor_value_verify_job_free_value, library_monitor_value_verify_job_copy_value, library_monitor_value_verify_job_peek_pointer, "p", library_monitor_value_verify_job_collect_value, "p", library_monitor_value_verify_job_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorVerifyJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_verify_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorVerifyJob), 0, (GInstanceInitFunc) library_monitor_verify_job_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType library_monitor_verify_job_type_id;
	library_monitor_verify_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LibraryMonitorVerifyJob", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return library_monitor_verify_job_type_id;
}

static GType
library_monitor_verify_job_get_type (void)
{
	static volatile gsize library_monitor_verify_job_type_id__once = 0;
	if (g_once_init_enter (&library_monitor_verify_job_type_id__once)) {
		GType library_monitor_verify_job_type_id;
		library_monitor_verify_job_type_id = library_monitor_verify_job_get_type_once ();
		g_once_init_leave (&library_monitor_verify_job_type_id__once, library_monitor_verify_job_type_id);
	}
	return library_monitor_verify_job_type_id__once;
}

static gpointer
library_monitor_verify_job_ref (gpointer instance)
{
	LibraryMonitorVerifyJob * self;
	self = instance;
#line 209 "../src/LibraryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 209 "../src/LibraryMonitor.vala"
	return instance;
#line 7154 "LibraryMonitor.c"
}

static void
library_monitor_verify_job_unref (gpointer instance)
{
	LibraryMonitorVerifyJob * self;
	self = instance;
#line 209 "../src/LibraryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 209 "../src/LibraryMonitor.vala"
		LIBRARY_MONITOR_VERIFY_JOB_GET_CLASS (self)->finalize (self);
#line 209 "../src/LibraryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7168 "LibraryMonitor.c"
	}
}

static GObject *
library_monitor_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	LibraryMonitor * self;
	GSettings* _tmp0_;
#line 250 "../src/LibraryMonitor.vala"
	parent_class = G_OBJECT_CLASS (library_monitor_parent_class);
#line 250 "../src/LibraryMonitor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 250 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_MONITOR, LibraryMonitor);
#line 251 "../src/LibraryMonitor.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_FILES_PREFS_SCHEMA_NAME);
#line 251 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 251 "../src/LibraryMonitor.vala"
	self->priv->file_settings = _tmp0_;
#line 250 "../src/LibraryMonitor.vala"
	return obj;
#line 7195 "LibraryMonitor.c"
}

static void
library_monitor_class_init (LibraryMonitorClass * klass,
                            gpointer klass_data)
{
	GeeHashSet* _tmp0_;
	HashTimedQueue* _tmp1_;
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_parent_class = g_type_class_peek_parent (klass);
#line 110 "../src/LibraryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &LibraryMonitor_private_offset);
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->close = (void (*) (DirectoryMonitor*)) library_monitor_real_close;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_started = (void (*) (DirectoryMonitor*)) library_monitor_real_discovery_started;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) library_monitor_real_file_discovered;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_completed = (void (*) (DirectoryMonitor*)) library_monitor_real_discovery_completed;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_created = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) library_monitor_real_notify_file_created;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) library_monitor_real_notify_file_moved;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_altered = (void (*) (DirectoryMonitor*, GFile*)) library_monitor_real_notify_file_altered;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_attributes_altered = (void (*) (DirectoryMonitor*, GFile*)) library_monitor_real_notify_file_attributes_altered;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_alteration_completed = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) library_monitor_real_notify_file_alteration_completed;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_deleted = (void (*) (DirectoryMonitor*, GFile*)) library_monitor_real_notify_file_deleted;
#line 110 "../src/LibraryMonitor.vala"
	G_OBJECT_CLASS (klass)->constructor = library_monitor_constructor;
#line 110 "../src/LibraryMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = library_monitor_finalize;
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_signals[LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL] = g_signal_new ("auto-update-progress", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PREPARING_SIGNAL] = g_signal_new ("auto-import-preparing", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PROGRESS_SIGNAL] = g_signal_new ("auto-import-progress", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT64_UINT64, G_TYPE_NONE, 2, G_TYPE_UINT64, G_TYPE_UINT64);
#line 219 "../src/LibraryMonitor.vala"
	g_rec_mutex_init (&__lock_library_monitor_library_monitor_blacklist);
#line 219 "../src/LibraryMonitor.vala"
	_tmp0_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 219 "../src/LibraryMonitor.vala"
	library_monitor_blacklist = _tmp0_;
#line 220 "../src/LibraryMonitor.vala"
	_tmp1_ = hash_timed_queue_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (guint) LIBRARY_MONITOR_MIN_BLACKLIST_DURATION_MSEC, _library_monitor_on_unblacklist_file_dequeued_callback, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, G_PRIORITY_LOW);
#line 220 "../src/LibraryMonitor.vala"
	library_monitor_to_unblacklist = _tmp1_;
#line 7248 "LibraryMonitor.c"
}

static void
library_monitor_instance_init (LibraryMonitor * self,
                               gpointer klass)
{
	Workers* _tmp0_;
	GCancellable* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeHashSet* _tmp3_;
	GeeHashSet* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeLinkedList* _tmp6_;
#line 110 "../src/LibraryMonitor.vala"
	self->priv = library_monitor_get_instance_private (self);
#line 223 "../src/LibraryMonitor.vala"
	_tmp0_ = workers_new (workers_thread_per_cpu_minus_one (), FALSE);
#line 223 "../src/LibraryMonitor.vala"
	self->priv->workers = _tmp0_;
#line 224 "../src/LibraryMonitor.vala"
	_tmp1_ = g_cancellable_new ();
#line 224 "../src/LibraryMonitor.vala"
	self->priv->cancellable = _tmp1_;
#line 225 "../src/LibraryMonitor.vala"
	self->priv->auto_import = FALSE;
#line 226 "../src/LibraryMonitor.vala"
	self->priv->unknown_files = NULL;
#line 227 "../src/LibraryMonitor.vala"
	_tmp2_ = gee_array_list_new (TYPE_MEDIA_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 227 "../src/LibraryMonitor.vala"
	self->priv->monitors = (GeeList*) _tmp2_;
#line 228 "../src/LibraryMonitor.vala"
	self->priv->discovered = NULL;
#line 229 "../src/LibraryMonitor.vala"
	_tmp3_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 229 "../src/LibraryMonitor.vala"
	self->priv->import_queue = _tmp3_;
#line 230 "../src/LibraryMonitor.vala"
	_tmp4_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 230 "../src/LibraryMonitor.vala"
	self->priv->pending_imports = _tmp4_;
#line 231 "../src/LibraryMonitor.vala"
	_tmp5_ = gee_array_list_new (TYPE_BATCH_IMPORT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 231 "../src/LibraryMonitor.vala"
	self->priv->batch_import_queue = _tmp5_;
#line 232 "../src/LibraryMonitor.vala"
	self->priv->current_import_roll = NULL;
#line 233 "../src/LibraryMonitor.vala"
	self->priv->last_import_roll_use = (gint64) 0;
#line 234 "../src/LibraryMonitor.vala"
	self->priv->current_batch_import = NULL;
#line 235 "../src/LibraryMonitor.vala"
	self->priv->checksums_completed = 0;
#line 236 "../src/LibraryMonitor.vala"
	self->priv->checksums_total = 0;
#line 237 "../src/LibraryMonitor.vala"
	self->priv->import_queue_timer_id = (guint) 0;
#line 238 "../src/LibraryMonitor.vala"
	_tmp6_ = gee_linked_list_new (LIBRARY_MONITOR_TYPE_VERIFY_JOB, (GBoxedCopyFunc) library_monitor_verify_job_ref, (GDestroyNotify) library_monitor_verify_job_unref, NULL, NULL, NULL);
#line 238 "../src/LibraryMonitor.vala"
	self->priv->verify_queue = (GeeQueue*) _tmp6_;
#line 239 "../src/LibraryMonitor.vala"
	self->priv->outstanding_verify_jobs = 0;
#line 240 "../src/LibraryMonitor.vala"
	self->priv->completed_monitorable_verifies = 0;
#line 241 "../src/LibraryMonitor.vala"
	self->priv->total_monitorable_verifies = 0;
#line 7316 "LibraryMonitor.c"
}

static void
library_monitor_finalize (GObject * obj)
{
	LibraryMonitor * self;
#line 110 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_MONITOR, LibraryMonitor);
#line 223 "../src/LibraryMonitor.vala"
	_workers_unref0 (self->priv->workers);
#line 224 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 226 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->unknown_files);
#line 227 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->monitors);
#line 228 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->discovered);
#line 229 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->import_queue);
#line 230 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->pending_imports);
#line 231 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->batch_import_queue);
#line 232 "../src/LibraryMonitor.vala"
	_batch_import_roll_unref0 (self->priv->current_import_roll);
#line 234 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->current_batch_import);
#line 238 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->verify_queue);
#line 242 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 110 "../src/LibraryMonitor.vala"
	G_OBJECT_CLASS (library_monitor_parent_class)->finalize (obj);
#line 7351 "LibraryMonitor.c"
}

static GType
library_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitor), 0, (GInstanceInitFunc) library_monitor_instance_init, NULL };
	GType library_monitor_type_id;
	library_monitor_type_id = g_type_register_static (TYPE_DIRECTORY_MONITOR, "LibraryMonitor", &g_define_type_info, 0);
	LibraryMonitor_private_offset = g_type_add_instance_private (library_monitor_type_id, sizeof (LibraryMonitorPrivate));
	return library_monitor_type_id;
}

GType
library_monitor_get_type (void)
{
	static volatile gsize library_monitor_type_id__once = 0;
	if (g_once_init_enter (&library_monitor_type_id__once)) {
		GType library_monitor_type_id;
		library_monitor_type_id = library_monitor_get_type_once ();
		g_once_init_leave (&library_monitor_type_id__once, library_monitor_type_id);
	}
	return library_monitor_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

