/* MediaDataRepresentation.c generated by valac 0.56.18, the Vala compiler
 * generated from MediaDataRepresentation.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>

#define MEDIA_COLLECTION_REGISTRY_LIBRARY_MONITOR_START_DELAY_MSEC 1000
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecBackingFileState ParamSpecBackingFileState;
enum  {
	MEDIA_SOURCE_0_PROPERTY,
	MEDIA_SOURCE_NUM_PROPERTIES
};
static GParamSpec* media_source_properties[MEDIA_SOURCE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	MEDIA_SOURCE_MASTER_REPLACED_SIGNAL,
	MEDIA_SOURCE_NUM_SIGNALS
};
static guint media_source_signals[MEDIA_SOURCE_NUM_SIGNALS] = {0};
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _import_id_free0(var) ((var == NULL) ? NULL : (var = (import_id_free (var), NULL)))
#define _aggregate_progress_monitor_unref0(var) ((var == NULL) ? NULL : (var = (aggregate_progress_monitor_unref (var), NULL)))
enum  {
	MEDIA_SOURCE_COLLECTION_MEDIA_IMPORT_STARTING_SIGNAL,
	MEDIA_SOURCE_COLLECTION_MEDIA_IMPORT_COMPLETED_SIGNAL,
	MEDIA_SOURCE_COLLECTION_MASTER_FILE_REPLACED_SIGNAL,
	MEDIA_SOURCE_COLLECTION_TRASHCAN_CONTENTS_ALTERED_SIGNAL,
	MEDIA_SOURCE_COLLECTION_IMPORT_ROLL_ALTERED_SIGNAL,
	MEDIA_SOURCE_COLLECTION_OFFLINE_CONTENTS_ALTERED_SIGNAL,
	MEDIA_SOURCE_COLLECTION_FLAGGED_CONTENTS_ALTERED_SIGNAL,
	MEDIA_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint media_source_collection_signals[MEDIA_SOURCE_COLLECTION_NUM_SIGNALS] = {0};
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))
typedef struct _ParamSpecMediaCollectionRegistry ParamSpecMediaCollectionRegistry;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ParamSpecBackingFileState {
	GParamSpec parent_instance;
};

struct _MediaSourcePrivate {
	Event* event;
	gchar* indexable_keywords;
};

struct _MediaSourceHoldingTankPrivate {
	GeeHashMap* master_file_map;
};

struct _MediaSourceTransactionControllerPrivate {
	MediaSourceCollection* sources;
};

struct _MediaSourceCollectionPrivate {
	MediaSourceHoldingTank* trashcan;
	MediaSourceHoldingTank* offline_bin;
	GeeHashMap* by_master_file;
	GeeMultiMap* import_rolls;
	GeeTreeSet* sorted_import_ids;
	GeeSet* flagged;
};

struct _MediaCollectionRegistryPrivate {
	GeeArrayList* all;
	GeeHashMap* by_typename;
};

struct _ParamSpecMediaCollectionRegistry {
	GParamSpec parent_instance;
};

static gpointer backing_file_state_parent_class = NULL;
static gint MediaSource_private_offset;
static gpointer media_source_parent_class = NULL;
static IndexableIface * media_source_indexable_parent_iface = NULL;
static gint MediaSourceHoldingTank_private_offset;
static gpointer media_source_holding_tank_parent_class = NULL;
static gint MediaSourceTransactionController_private_offset;
static gpointer media_source_transaction_controller_parent_class = NULL;
static gint MediaSourceCollection_private_offset;
static gpointer media_source_collection_parent_class = NULL;
static gint MediaCollectionRegistry_private_offset;
static gpointer media_collection_registry_parent_class = NULL;
static MediaCollectionRegistry* media_collection_registry_instance;
static MediaCollectionRegistry* media_collection_registry_instance = NULL;
static GSettings* media_collection_registry_file_settings;
static GSettings* media_collection_registry_file_settings = NULL;
VALA_EXTERN gboolean commandline_options_no_runtime_monitoring;

static void backing_file_state_finalize (BackingFileState * obj);
static GType backing_file_state_get_type_once (void);
static void media_source_real_notify_master_replaced (MediaSource* self,
                                               GFile* old_file,
                                               GFile* new_file);
static void media_source_real_notify_altered (DataObject* base,
                                       Alteration* alteration);
static void media_source_update_indexable_keywords (MediaSource* self);
static void media_source_real_notify_membership_changed (DataObject* base,
                                                  DataCollection* collection);
static const gchar* media_source_real_get_indexable_keywords (Indexable* base);
static gboolean media_source_real_set_event_id (MediaSource* self,
                                         EventID* id);
VALA_EXTERN GFile* app_dirs_get_import_dir (void);
static gchar* media_source_real_get_name (DataObject* base);
static gchar* media_source_real_get_basename (MediaSource* self);
static GFile* media_source_real_get_file (MediaSource* self);
static GFile* media_source_real_get_master_file (MediaSource* self);
static guint64 media_source_real_get_master_filesize (MediaSource* self);
static guint64 media_source_real_get_filesize (MediaSource* self);
static gint64 media_source_real_get_timestamp (MediaSource* self);
static BackingFileState** media_source_real_get_backing_files_state (MediaSource* self,
                                                              gint* result_length1);
static gchar* media_source_real_get_title (MediaSource* self);
static gchar* media_source_real_get_comment (MediaSource* self);
static void media_source_real_set_title (MediaSource* self,
                                  const gchar* title);
static gboolean media_source_real_set_comment (MediaSource* self,
                                        const gchar* comment);
static void media_source_real_get_dimensions (MediaSource* self,
                                       PhotoException disallowed_steps,
                                       Dimensions* result);
static GdkPixbuf* media_source_real_get_preview_pixbuf (MediaSource* self,
                                                 Scaling* scaling,
                                                 GError** error);
static gboolean media_source_real_is_trashed (MediaSource* self);
static void media_source_real_trash (MediaSource* self);
static void media_source_real_untrash (MediaSource* self);
static gboolean media_source_real_is_offline (MediaSource* self);
static void media_source_real_mark_offline (MediaSource* self);
static void media_source_real_mark_online (MediaSource* self);
static gchar* media_source_real_get_master_md5 (MediaSource* self);
static void media_source_real_get_event_id (MediaSource* self,
                                     EventID* result);
static gint64 media_source_real_get_exposure_time (MediaSource* self);
static void media_source_real_get_import_id (MediaSource* self,
                                      ImportID* result);
static void media_source_real_master_replaced (MediaSource* self,
                                        GFile* old_file,
                                        GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void media_source_finalize (GObject * obj);
static GType media_source_get_type_once (void);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static void media_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                             GeeCollection* added,
                                                             GeeCollection* removed);
static void media_source_holding_tank_on_master_source_replaced (MediaSourceHoldingTank* self,
                                                          MediaSource* media_source,
                                                          GFile* old_file,
                                                          GFile* new_file);
static void _media_source_holding_tank_on_master_source_replaced_media_source_master_replaced (MediaSource* _sender,
                                                                                        GFile* old_file,
                                                                                        GFile* new_file,
                                                                                        gpointer self);
static void media_source_holding_tank_finalize (SourceHoldingTank * obj);
static GType media_source_holding_tank_get_type_once (void);
static void media_source_transaction_controller_real_begin_impl (TransactionController* base,
                                                          GError** error);
static void media_source_transaction_controller_real_commit_impl (TransactionController* base,
                                                           GError** error);
static void media_source_transaction_controller_finalize (TransactionController * obj);
static GType media_source_transaction_controller_get_type_once (void);
static gint _import_id_compare_func_gcompare_data_func (gconstpointer a,
                                                 gconstpointer b,
                                                 gpointer self);
static MediaSourceHoldingTank* media_source_collection_real_create_trashcan (MediaSourceCollection* self);
static MediaSourceHoldingTank* media_source_collection_real_create_offline_bin (MediaSourceCollection* self);
static MediaMonitor* media_source_collection_real_create_media_monitor (MediaSourceCollection* self,
                                                                 Workers* workers,
                                                                 GCancellable* cancellable);
static gchar* media_source_collection_real_get_typename (MediaSourceCollection* self);
static gboolean media_source_collection_real_is_file_recognized (MediaSourceCollection* self,
                                                          GFile* file);
static MediaSource* media_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* self,
                                                               gint64 numeric_id);
static void media_source_collection_real_notify_import_roll_altered (MediaSourceCollection* self);
static void media_source_collection_real_notify_flagged_contents_altered (MediaSourceCollection* self);
static void media_source_collection_real_notify_media_import_starting (MediaSourceCollection* self,
                                                                GeeCollection* media);
static void media_source_collection_real_notify_media_import_completed (MediaSourceCollection* self,
                                                                 GeeCollection* media);
static void media_source_collection_real_items_altered (DataCollection* base,
                                                 GeeMap* items);
static void media_source_collection_real_notify_contents_altered (DataCollection* base,
                                                           GeeIterable* added,
                                                           GeeIterable* removed);
static void media_source_collection_on_master_replaced (MediaSourceCollection* self,
                                                 MediaSource* media,
                                                 GFile* old_file,
                                                 GFile* new_file);
static void _media_source_collection_on_master_replaced_media_source_master_replaced (MediaSource* _sender,
                                                                               GFile* old_file,
                                                                               GFile* new_file,
                                                                               gpointer self);
static MediaSource* media_source_collection_real_fetch_by_source_id (MediaSourceCollection* self,
                                                              const gchar* source_id);
static GeeCollection* media_source_collection_real_get_event_source_ids (MediaSourceCollection* self,
                                                                  EventID* event_id);
static void media_source_collection_real_import_many (MediaSourceCollection* self,
                                               GeeCollection* media);
static void media_source_collection_real_postprocess_imported_media (MediaSourceCollection* self,
                                                              GeeCollection* media);
static gboolean _aggregate_progress_monitor_monitor_progress_monitor (guint64 current,
                                                               guint64 total,
                                                               gboolean do_event_loop,
                                                               gpointer self);
static void media_source_collection_real_media_import_starting (MediaSourceCollection* self,
                                                         GeeCollection* media);
static void media_source_collection_real_media_import_completed (MediaSourceCollection* self,
                                                          GeeCollection* media);
static void media_source_collection_real_master_file_replaced (MediaSourceCollection* self,
                                                        MediaSource* media,
                                                        GFile* old_file,
                                                        GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static void media_source_collection_real_trashcan_contents_altered (MediaSourceCollection* self,
                                                             GeeCollection* added,
                                                             GeeCollection* removed);
static void media_source_collection_real_import_roll_altered (MediaSourceCollection* self);
static void media_source_collection_real_offline_contents_altered (MediaSourceCollection* self,
                                                            GeeCollection* added,
                                                            GeeCollection* removed);
static void media_source_collection_real_flagged_contents_altered (MediaSourceCollection* self);
static void media_source_collection_finalize (DataCollection * obj);
static GType media_source_collection_get_type_once (void);
static void media_collection_registry_on_init_done (MediaCollectionRegistry* self);
static void _media_collection_registry_on_init_done_photos_application_init_done (PhotosApplication* _sender,
                                                                           gpointer self);
static MediaCollectionRegistry* media_collection_registry_new (void);
static MediaCollectionRegistry* media_collection_registry_construct (GType object_type);
static void media_collection_registry_on_config_changed (const gchar* key);
static void _media_collection_registry_on_config_changed_g_settings_changed (GSettings* _sender,
                                                                      const gchar* key,
                                                                      gpointer self);
static void media_collection_registry_finalize (MediaCollectionRegistry * obj);
static GType media_collection_registry_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

BackingFileState*
backing_file_state_construct (GType object_type,
                              const gchar* filepath,
                              gint64 filesize,
                              gint64 modification_time,
                              const gchar* md5)
{
	BackingFileState* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 26 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 26 "../src/MediaDataRepresentation.vala"
	self = (BackingFileState*) g_type_create_instance (object_type);
#line 27 "../src/MediaDataRepresentation.vala"
	_tmp0_ = g_strdup (filepath);
#line 27 "../src/MediaDataRepresentation.vala"
	_g_free0 (self->filepath);
#line 27 "../src/MediaDataRepresentation.vala"
	self->filepath = _tmp0_;
#line 28 "../src/MediaDataRepresentation.vala"
	self->filesize = filesize;
#line 29 "../src/MediaDataRepresentation.vala"
	self->modification_time = modification_time;
#line 30 "../src/MediaDataRepresentation.vala"
	_tmp1_ = g_strdup (md5);
#line 30 "../src/MediaDataRepresentation.vala"
	_g_free0 (self->md5);
#line 30 "../src/MediaDataRepresentation.vala"
	self->md5 = _tmp1_;
#line 26 "../src/MediaDataRepresentation.vala"
	return self;
#line 336 "MediaDataRepresentation.c"
}

BackingFileState*
backing_file_state_new (const gchar* filepath,
                        gint64 filesize,
                        gint64 modification_time,
                        const gchar* md5)
{
#line 26 "../src/MediaDataRepresentation.vala"
	return backing_file_state_construct (TYPE_BACKING_FILE_STATE, filepath, filesize, modification_time, md5);
#line 347 "MediaDataRepresentation.c"
}

BackingFileState*
backing_file_state_construct_from_photo_row (GType object_type,
                                             BackingPhotoRow* photo_row,
                                             const gchar* md5)
{
	BackingFileState* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 33 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (photo_row != NULL, NULL);
#line 33 "../src/MediaDataRepresentation.vala"
	self = (BackingFileState*) g_type_create_instance (object_type);
#line 34 "../src/MediaDataRepresentation.vala"
	_tmp0_ = photo_row->filepath;
#line 34 "../src/MediaDataRepresentation.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 34 "../src/MediaDataRepresentation.vala"
	_g_free0 (self->filepath);
#line 34 "../src/MediaDataRepresentation.vala"
	self->filepath = _tmp1_;
#line 35 "../src/MediaDataRepresentation.vala"
	self->filesize = photo_row->filesize;
#line 36 "../src/MediaDataRepresentation.vala"
	self->modification_time = photo_row->timestamp;
#line 37 "../src/MediaDataRepresentation.vala"
	_tmp2_ = g_strdup (md5);
#line 37 "../src/MediaDataRepresentation.vala"
	_g_free0 (self->md5);
#line 37 "../src/MediaDataRepresentation.vala"
	self->md5 = _tmp2_;
#line 33 "../src/MediaDataRepresentation.vala"
	return self;
#line 383 "MediaDataRepresentation.c"
}

BackingFileState*
backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row,
                                       const gchar* md5)
{
#line 33 "../src/MediaDataRepresentation.vala"
	return backing_file_state_construct_from_photo_row (TYPE_BACKING_FILE_STATE, photo_row, md5);
#line 392 "MediaDataRepresentation.c"
}

GFile*
backing_file_state_get_file (BackingFileState* self)
{
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
#line 40 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->filepath;
#line 41 "../src/MediaDataRepresentation.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 41 "../src/MediaDataRepresentation.vala"
	result = _tmp1_;
#line 41 "../src/MediaDataRepresentation.vala"
	return result;
#line 411 "MediaDataRepresentation.c"
}

static void
value_backing_file_state_init (GValue* value)
{
#line 20 "../src/MediaDataRepresentation.vala"
	value->data[0].v_pointer = NULL;
#line 419 "MediaDataRepresentation.c"
}

static void
value_backing_file_state_free_value (GValue* value)
{
#line 20 "../src/MediaDataRepresentation.vala"
	if (value->data[0].v_pointer) {
#line 20 "../src/MediaDataRepresentation.vala"
		backing_file_state_unref (value->data[0].v_pointer);
#line 429 "MediaDataRepresentation.c"
	}
}

static void
value_backing_file_state_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
#line 20 "../src/MediaDataRepresentation.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../src/MediaDataRepresentation.vala"
		dest_value->data[0].v_pointer = backing_file_state_ref (src_value->data[0].v_pointer);
#line 441 "MediaDataRepresentation.c"
	} else {
#line 20 "../src/MediaDataRepresentation.vala"
		dest_value->data[0].v_pointer = NULL;
#line 445 "MediaDataRepresentation.c"
	}
}

static gpointer
value_backing_file_state_peek_pointer (const GValue* value)
{
#line 20 "../src/MediaDataRepresentation.vala"
	return value->data[0].v_pointer;
#line 454 "MediaDataRepresentation.c"
}

static gchar*
value_backing_file_state_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
#line 20 "../src/MediaDataRepresentation.vala"
	if (collect_values[0].v_pointer) {
#line 465 "MediaDataRepresentation.c"
		BackingFileState * object;
		object = collect_values[0].v_pointer;
#line 20 "../src/MediaDataRepresentation.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../src/MediaDataRepresentation.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 472 "MediaDataRepresentation.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../src/MediaDataRepresentation.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 476 "MediaDataRepresentation.c"
		}
#line 20 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = backing_file_state_ref (object);
#line 480 "MediaDataRepresentation.c"
	} else {
#line 20 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = NULL;
#line 484 "MediaDataRepresentation.c"
	}
#line 20 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 488 "MediaDataRepresentation.c"
}

static gchar*
value_backing_file_state_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	BackingFileState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../src/MediaDataRepresentation.vala"
	if (!object_p) {
#line 20 "../src/MediaDataRepresentation.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 503 "MediaDataRepresentation.c"
	}
#line 20 "../src/MediaDataRepresentation.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../src/MediaDataRepresentation.vala"
		*object_p = NULL;
#line 509 "MediaDataRepresentation.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../src/MediaDataRepresentation.vala"
		*object_p = value->data[0].v_pointer;
#line 513 "MediaDataRepresentation.c"
	} else {
#line 20 "../src/MediaDataRepresentation.vala"
		*object_p = backing_file_state_ref (value->data[0].v_pointer);
#line 517 "MediaDataRepresentation.c"
	}
#line 20 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 521 "MediaDataRepresentation.c"
}

GParamSpec*
param_spec_backing_file_state (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	ParamSpecBackingFileState* spec;
#line 20 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKING_FILE_STATE), NULL);
#line 20 "../src/MediaDataRepresentation.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../src/MediaDataRepresentation.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../src/MediaDataRepresentation.vala"
	return G_PARAM_SPEC (spec);
#line 540 "MediaDataRepresentation.c"
}

gpointer
value_get_backing_file_state (const GValue* value)
{
#line 20 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_FILE_STATE), NULL);
#line 20 "../src/MediaDataRepresentation.vala"
	return value->data[0].v_pointer;
#line 550 "MediaDataRepresentation.c"
}

void
value_set_backing_file_state (GValue* value,
                              gpointer v_object)
{
	BackingFileState * old;
#line 20 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_FILE_STATE));
#line 20 "../src/MediaDataRepresentation.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/MediaDataRepresentation.vala"
	if (v_object) {
#line 20 "../src/MediaDataRepresentation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_FILE_STATE));
#line 20 "../src/MediaDataRepresentation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../src/MediaDataRepresentation.vala"
		backing_file_state_ref (value->data[0].v_pointer);
#line 572 "MediaDataRepresentation.c"
	} else {
#line 20 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = NULL;
#line 576 "MediaDataRepresentation.c"
	}
#line 20 "../src/MediaDataRepresentation.vala"
	if (old) {
#line 20 "../src/MediaDataRepresentation.vala"
		backing_file_state_unref (old);
#line 582 "MediaDataRepresentation.c"
	}
}

void
value_take_backing_file_state (GValue* value,
                               gpointer v_object)
{
	BackingFileState * old;
#line 20 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_FILE_STATE));
#line 20 "../src/MediaDataRepresentation.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/MediaDataRepresentation.vala"
	if (v_object) {
#line 20 "../src/MediaDataRepresentation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_FILE_STATE));
#line 20 "../src/MediaDataRepresentation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = v_object;
#line 603 "MediaDataRepresentation.c"
	} else {
#line 20 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = NULL;
#line 607 "MediaDataRepresentation.c"
	}
#line 20 "../src/MediaDataRepresentation.vala"
	if (old) {
#line 20 "../src/MediaDataRepresentation.vala"
		backing_file_state_unref (old);
#line 613 "MediaDataRepresentation.c"
	}
}

static void
backing_file_state_class_init (BackingFileStateClass * klass,
                               gpointer klass_data)
{
#line 20 "../src/MediaDataRepresentation.vala"
	backing_file_state_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/MediaDataRepresentation.vala"
	((BackingFileStateClass *) klass)->finalize = backing_file_state_finalize;
#line 625 "MediaDataRepresentation.c"
}

static void
backing_file_state_instance_init (BackingFileState * self,
                                  gpointer klass)
{
#line 20 "../src/MediaDataRepresentation.vala"
	self->ref_count = 1;
#line 634 "MediaDataRepresentation.c"
}

static void
backing_file_state_finalize (BackingFileState * obj)
{
	BackingFileState * self;
#line 20 "../src/MediaDataRepresentation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_FILE_STATE, BackingFileState);
#line 20 "../src/MediaDataRepresentation.vala"
	g_signal_handlers_destroy (self);
#line 21 "../src/MediaDataRepresentation.vala"
	_g_free0 (self->filepath);
#line 24 "../src/MediaDataRepresentation.vala"
	_g_free0 (self->md5);
#line 649 "MediaDataRepresentation.c"
}

static GType
backing_file_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_backing_file_state_init, value_backing_file_state_free_value, value_backing_file_state_copy_value, value_backing_file_state_peek_pointer, "p", value_backing_file_state_collect_value, "p", value_backing_file_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BackingFileStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_file_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingFileState), 0, (GInstanceInitFunc) backing_file_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType backing_file_state_type_id;
	backing_file_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackingFileState", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return backing_file_state_type_id;
}

GType
backing_file_state_get_type (void)
{
	static volatile gsize backing_file_state_type_id__once = 0;
	if (g_once_init_enter (&backing_file_state_type_id__once)) {
		GType backing_file_state_type_id;
		backing_file_state_type_id = backing_file_state_get_type_once ();
		g_once_init_leave (&backing_file_state_type_id__once, backing_file_state_type_id);
	}
	return backing_file_state_type_id__once;
}

gpointer
backing_file_state_ref (gpointer instance)
{
	BackingFileState * self;
	self = instance;
#line 20 "../src/MediaDataRepresentation.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../src/MediaDataRepresentation.vala"
	return instance;
#line 684 "MediaDataRepresentation.c"
}

void
backing_file_state_unref (gpointer instance)
{
	BackingFileState * self;
	self = instance;
#line 20 "../src/MediaDataRepresentation.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../src/MediaDataRepresentation.vala"
		BACKING_FILE_STATE_GET_CLASS (self)->finalize (self);
#line 20 "../src/MediaDataRepresentation.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 698 "MediaDataRepresentation.c"
	}
}

static inline gpointer
media_source_get_instance_private (MediaSource* self)
{
	return G_STRUCT_MEMBER_P (self, MediaSource_private_offset);
}

MediaSource*
media_source_construct (GType object_type,
                        gint64 object_id)
{
	MediaSource * self = NULL;
#line 53 "../src/MediaDataRepresentation.vala"
	self = (MediaSource*) thumbnail_source_construct (object_type, object_id);
#line 52 "../src/MediaDataRepresentation.vala"
	return self;
#line 717 "MediaDataRepresentation.c"
}

inline guint64
media_source_internal_add_flags (guint64 flags,
                                 guint64 selector)
{
	guint64 result;
#line 57 "../src/MediaDataRepresentation.vala"
	result = flags | selector;
#line 57 "../src/MediaDataRepresentation.vala"
	return result;
#line 729 "MediaDataRepresentation.c"
}

inline guint64
media_source_internal_remove_flags (guint64 flags,
                                    guint64 selector)
{
	guint64 result;
#line 61 "../src/MediaDataRepresentation.vala"
	result = flags & (~selector);
#line 61 "../src/MediaDataRepresentation.vala"
	return result;
#line 741 "MediaDataRepresentation.c"
}

inline gboolean
media_source_internal_is_flag_set (guint64 flags,
                                   guint64 selector)
{
	gboolean result;
#line 65 "../src/MediaDataRepresentation.vala"
	result = (flags & selector) != ((guint64) 0);
#line 65 "../src/MediaDataRepresentation.vala"
	return result;
#line 753 "MediaDataRepresentation.c"
}

static void
media_source_real_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file)
{
#line 68 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (old_file != NULL);
#line 68 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (new_file != NULL);
#line 69 "../src/MediaDataRepresentation.vala"
	g_signal_emit (self, media_source_signals[MEDIA_SOURCE_MASTER_REPLACED_SIGNAL], 0, old_file, new_file);
#line 767 "MediaDataRepresentation.c"
}

void
media_source_notify_master_replaced (MediaSource* self,
                                     GFile* old_file,
                                     GFile* new_file)
{
	MediaSourceClass* _klass_;
#line 68 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 68 "../src/MediaDataRepresentation.vala"
	if (_klass_->notify_master_replaced) {
#line 68 "../src/MediaDataRepresentation.vala"
		_klass_->notify_master_replaced (self, old_file, new_file);
#line 784 "MediaDataRepresentation.c"
	}
}

static gpointer
_alteration_ref0 (gpointer self)
{
#line 73 "../src/MediaDataRepresentation.vala"
	return self ? alteration_ref (self) : NULL;
#line 793 "MediaDataRepresentation.c"
}

static void
media_source_real_notify_altered (DataObject* base,
                                  Alteration* alteration)
{
	MediaSource * self;
	Alteration* local = NULL;
	Alteration* _tmp0_;
	gboolean _tmp1_ = FALSE;
	Alteration* _tmp2_;
	Alteration* _tmp8_;
#line 72 "../src/MediaDataRepresentation.vala"
	self = (MediaSource*) base;
#line 72 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (alteration != NULL);
#line 73 "../src/MediaDataRepresentation.vala"
	_tmp0_ = _alteration_ref0 (alteration);
#line 73 "../src/MediaDataRepresentation.vala"
	local = _tmp0_;
#line 75 "../src/MediaDataRepresentation.vala"
	_tmp2_ = local;
#line 75 "../src/MediaDataRepresentation.vala"
	if (alteration_has_detail (_tmp2_, "metadata", "name")) {
#line 75 "../src/MediaDataRepresentation.vala"
		_tmp1_ = TRUE;
#line 820 "MediaDataRepresentation.c"
	} else {
		Alteration* _tmp3_;
#line 75 "../src/MediaDataRepresentation.vala"
		_tmp3_ = local;
#line 75 "../src/MediaDataRepresentation.vala"
		_tmp1_ = alteration_has_detail (_tmp3_, "backing", "master");
#line 827 "MediaDataRepresentation.c"
	}
#line 75 "../src/MediaDataRepresentation.vala"
	if (_tmp1_) {
#line 831 "MediaDataRepresentation.c"
		Alteration* _tmp4_;
		Alteration* _tmp5_;
		Alteration* _tmp6_;
		Alteration* _tmp7_;
#line 76 "../src/MediaDataRepresentation.vala"
		media_source_update_indexable_keywords (self);
#line 77 "../src/MediaDataRepresentation.vala"
		_tmp4_ = local;
#line 77 "../src/MediaDataRepresentation.vala"
		_tmp5_ = alteration_new ("indexable", "keywords");
#line 77 "../src/MediaDataRepresentation.vala"
		_tmp6_ = _tmp5_;
#line 77 "../src/MediaDataRepresentation.vala"
		_tmp7_ = alteration_compress (_tmp4_, _tmp6_);
#line 77 "../src/MediaDataRepresentation.vala"
		_alteration_unref0 (local);
#line 77 "../src/MediaDataRepresentation.vala"
		local = _tmp7_;
#line 77 "../src/MediaDataRepresentation.vala"
		_alteration_unref0 (_tmp6_);
#line 852 "MediaDataRepresentation.c"
	}
#line 80 "../src/MediaDataRepresentation.vala"
	_tmp8_ = local;
#line 80 "../src/MediaDataRepresentation.vala"
	DATA_OBJECT_CLASS (media_source_parent_class)->notify_altered ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), _tmp8_);
#line 72 "../src/MediaDataRepresentation.vala"
	_alteration_unref0 (local);
#line 860 "MediaDataRepresentation.c"
}

static void
media_source_real_notify_membership_changed (DataObject* base,
                                             DataCollection* collection)
{
	MediaSource * self;
	gboolean _tmp0_ = FALSE;
#line 85 "../src/MediaDataRepresentation.vala"
	self = (MediaSource*) base;
#line 86 "../src/MediaDataRepresentation.vala"
	if (collection != NULL) {
#line 873 "MediaDataRepresentation.c"
		const gchar* _tmp1_;
#line 86 "../src/MediaDataRepresentation.vala"
		_tmp1_ = self->priv->indexable_keywords;
#line 86 "../src/MediaDataRepresentation.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 879 "MediaDataRepresentation.c"
	} else {
#line 86 "../src/MediaDataRepresentation.vala"
		_tmp0_ = FALSE;
#line 883 "MediaDataRepresentation.c"
	}
#line 86 "../src/MediaDataRepresentation.vala"
	if (_tmp0_) {
#line 89 "../src/MediaDataRepresentation.vala"
		media_source_update_indexable_keywords (self);
#line 889 "MediaDataRepresentation.c"
	}
#line 92 "../src/MediaDataRepresentation.vala"
	DATA_OBJECT_CLASS (media_source_parent_class)->notify_membership_changed ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), collection);
#line 893 "MediaDataRepresentation.c"
}

static void
media_source_update_indexable_keywords (MediaSource* self)
{
	gchar** indexables = NULL;
	gchar** _tmp0_;
	gint indexables_length1;
	gint _indexables_size_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 95 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/MediaDataRepresentation.vala"
	_tmp0_ = g_new0 (gchar*, 3 + 1);
#line 96 "../src/MediaDataRepresentation.vala"
	indexables = _tmp0_;
#line 96 "../src/MediaDataRepresentation.vala"
	indexables_length1 = 3;
#line 96 "../src/MediaDataRepresentation.vala"
	_indexables_size_ = indexables_length1;
#line 97 "../src/MediaDataRepresentation.vala"
	_tmp1_ = media_source_get_title (self);
#line 97 "../src/MediaDataRepresentation.vala"
	_g_free0 (indexables[0]);
#line 97 "../src/MediaDataRepresentation.vala"
	indexables[0] = _tmp1_;
#line 98 "../src/MediaDataRepresentation.vala"
	_tmp2_ = media_source_get_basename (self);
#line 98 "../src/MediaDataRepresentation.vala"
	_g_free0 (indexables[1]);
#line 98 "../src/MediaDataRepresentation.vala"
	indexables[1] = _tmp2_;
#line 99 "../src/MediaDataRepresentation.vala"
	_tmp3_ = media_source_get_comment (self);
#line 99 "../src/MediaDataRepresentation.vala"
	_g_free0 (indexables[2]);
#line 99 "../src/MediaDataRepresentation.vala"
	indexables[2] = _tmp3_;
#line 101 "../src/MediaDataRepresentation.vala"
	_tmp4_ = indexable_prepare_indexable_strings (indexables, (gint) indexables_length1);
#line 101 "../src/MediaDataRepresentation.vala"
	_g_free0 (self->priv->indexable_keywords);
#line 101 "../src/MediaDataRepresentation.vala"
	self->priv->indexable_keywords = _tmp4_;
#line 95 "../src/MediaDataRepresentation.vala"
	indexables = (_vala_array_free (indexables, indexables_length1, (GDestroyNotify) g_free), NULL);
#line 943 "MediaDataRepresentation.c"
}

static const gchar*
media_source_real_get_indexable_keywords (Indexable* base)
{
	MediaSource * self;
	const gchar* _tmp0_;
	const gchar* result;
#line 104 "../src/MediaDataRepresentation.vala"
	self = (MediaSource*) base;
#line 105 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->indexable_keywords;
#line 105 "../src/MediaDataRepresentation.vala"
	result = _tmp0_;
#line 105 "../src/MediaDataRepresentation.vala"
	return result;
#line 960 "MediaDataRepresentation.c"
}

static gboolean
media_source_real_set_event_id (MediaSource* self,
                                EventID* id)
{
	gboolean _tmp0_ = FALSE;
#line 108 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_set_event_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 108 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 972 "MediaDataRepresentation.c"
}

gboolean
media_source_set_event_id (MediaSource* self,
                           EventID* id)
{
	MediaSourceClass* _klass_;
#line 108 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 108 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 108 "../src/MediaDataRepresentation.vala"
	if (_klass_->set_event_id) {
#line 108 "../src/MediaDataRepresentation.vala"
		return _klass_->set_event_id (self, id);
#line 988 "MediaDataRepresentation.c"
	}
#line 108 "../src/MediaDataRepresentation.vala"
	return FALSE;
#line 992 "MediaDataRepresentation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 125 "../src/MediaDataRepresentation.vala"
	return self ? g_object_ref (self) : NULL;
#line 1000 "MediaDataRepresentation.c"
}

gboolean
media_source_delete_original_file (MediaSource* self)
{
	gboolean ret = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	gboolean _tmp12_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 110 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "../src/MediaDataRepresentation.vala"
	ret = FALSE;
#line 112 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_get_master_file (self);
#line 112 "../src/MediaDataRepresentation.vala"
	file = _tmp0_;
#line 1023 "MediaDataRepresentation.c"
	{
		gboolean _tmp1_ = FALSE;
		GFile* _tmp2_;
#line 115 "../src/MediaDataRepresentation.vala"
		_tmp2_ = file;
#line 115 "../src/MediaDataRepresentation.vala"
		_tmp1_ = g_file_delete (_tmp2_, NULL, &_inner_error0_);
#line 115 "../src/MediaDataRepresentation.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1033 "MediaDataRepresentation.c"
			goto __catch0_g_error;
		}
#line 115 "../src/MediaDataRepresentation.vala"
		ret = _tmp1_;
#line 1038 "MediaDataRepresentation.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 114 "../src/MediaDataRepresentation.vala"
		err = _inner_error0_;
#line 114 "../src/MediaDataRepresentation.vala"
		_inner_error0_ = NULL;
#line 119 "../src/MediaDataRepresentation.vala"
		_tmp3_ = file;
#line 119 "../src/MediaDataRepresentation.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 119 "../src/MediaDataRepresentation.vala"
		_tmp5_ = _tmp4_;
#line 119 "../src/MediaDataRepresentation.vala"
		_tmp6_ = err;
#line 119 "../src/MediaDataRepresentation.vala"
		_tmp7_ = _tmp6_->message;
#line 119 "../src/MediaDataRepresentation.vala"
		g_message ("MediaDataRepresentation.vala:119: Unable to delete original photo %s: " \
"%s", _tmp5_, _tmp7_);
#line 119 "../src/MediaDataRepresentation.vala"
		_g_free0 (_tmp5_);
#line 114 "../src/MediaDataRepresentation.vala"
		_g_error_free0 (err);
#line 1069 "MediaDataRepresentation.c"
	}
	__finally0:
#line 114 "../src/MediaDataRepresentation.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1074 "MediaDataRepresentation.c"
		gboolean _tmp8_ = FALSE;
#line 114 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (file);
#line 114 "../src/MediaDataRepresentation.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../src/MediaDataRepresentation.vala"
		g_clear_error (&_inner_error0_);
#line 114 "../src/MediaDataRepresentation.vala"
		return _tmp8_;
#line 1084 "MediaDataRepresentation.c"
	}
#line 124 "../src/MediaDataRepresentation.vala"
	_tmp9_ = file;
#line 124 "../src/MediaDataRepresentation.vala"
	_tmp10_ = app_dirs_get_import_dir ();
#line 124 "../src/MediaDataRepresentation.vala"
	_tmp11_ = _tmp10_;
#line 124 "../src/MediaDataRepresentation.vala"
	_tmp12_ = g_file_has_prefix (_tmp9_, _tmp11_);
#line 124 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (_tmp11_);
#line 124 "../src/MediaDataRepresentation.vala"
	if (_tmp12_) {
#line 1098 "MediaDataRepresentation.c"
		GFile* parent = NULL;
		GFile* _tmp13_;
		GFile* _tmp14_;
#line 125 "../src/MediaDataRepresentation.vala"
		_tmp13_ = file;
#line 125 "../src/MediaDataRepresentation.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 125 "../src/MediaDataRepresentation.vala"
		parent = _tmp14_;
#line 126 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 1110 "MediaDataRepresentation.c"
			GFile* _tmp15_;
			GFile* _tmp16_;
			GFile* _tmp17_;
			gboolean _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			gboolean _tmp21_ = FALSE;
			GFile* _tmp22_;
#line 126 "../src/MediaDataRepresentation.vala"
			_tmp15_ = parent;
#line 126 "../src/MediaDataRepresentation.vala"
			_tmp16_ = app_dirs_get_import_dir ();
#line 126 "../src/MediaDataRepresentation.vala"
			_tmp17_ = _tmp16_;
#line 126 "../src/MediaDataRepresentation.vala"
			_tmp18_ = !(!g_file_equal (_tmp15_, _tmp17_));
#line 126 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (_tmp17_);
#line 126 "../src/MediaDataRepresentation.vala"
			if (_tmp18_) {
#line 126 "../src/MediaDataRepresentation.vala"
				break;
#line 1133 "MediaDataRepresentation.c"
			}
#line 127 "../src/MediaDataRepresentation.vala"
			_tmp19_ = parent;
#line 127 "../src/MediaDataRepresentation.vala"
			_tmp20_ = g_file_get_parent (_tmp19_);
#line 127 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (parent);
#line 127 "../src/MediaDataRepresentation.vala"
			parent = _tmp20_;
#line 128 "../src/MediaDataRepresentation.vala"
			_tmp22_ = parent;
#line 128 "../src/MediaDataRepresentation.vala"
			if (_tmp22_ == NULL) {
#line 128 "../src/MediaDataRepresentation.vala"
				_tmp21_ = TRUE;
#line 1149 "MediaDataRepresentation.c"
			} else {
				GFile* _tmp23_;
				GFile* _tmp24_;
				GFile* _tmp25_;
#line 128 "../src/MediaDataRepresentation.vala"
				_tmp23_ = parent;
#line 128 "../src/MediaDataRepresentation.vala"
				_tmp24_ = app_dirs_get_import_dir ();
#line 128 "../src/MediaDataRepresentation.vala"
				_tmp25_ = _tmp24_;
#line 128 "../src/MediaDataRepresentation.vala"
				_tmp21_ = g_file_equal (_tmp23_, _tmp25_);
#line 128 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_tmp25_);
#line 1164 "MediaDataRepresentation.c"
			}
#line 128 "../src/MediaDataRepresentation.vala"
			if (_tmp21_) {
#line 129 "../src/MediaDataRepresentation.vala"
				break;
#line 1170 "MediaDataRepresentation.c"
			}
			{
				gboolean _tmp26_ = FALSE;
				GFile* _tmp27_;
#line 132 "../src/MediaDataRepresentation.vala"
				_tmp27_ = parent;
#line 132 "../src/MediaDataRepresentation.vala"
				_tmp26_ = query_is_directory_empty (_tmp27_, &_inner_error0_);
#line 132 "../src/MediaDataRepresentation.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1181 "MediaDataRepresentation.c"
					goto __catch1_g_error;
				}
#line 132 "../src/MediaDataRepresentation.vala"
				if (!_tmp26_) {
#line 133 "../src/MediaDataRepresentation.vala"
					break;
#line 1188 "MediaDataRepresentation.c"
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* err = NULL;
				GFile* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				GError* _tmp31_;
				const gchar* _tmp32_;
#line 131 "../src/MediaDataRepresentation.vala"
				err = _inner_error0_;
#line 131 "../src/MediaDataRepresentation.vala"
				_inner_error0_ = NULL;
#line 135 "../src/MediaDataRepresentation.vala"
				_tmp28_ = parent;
#line 135 "../src/MediaDataRepresentation.vala"
				_tmp29_ = g_file_get_path (_tmp28_);
#line 135 "../src/MediaDataRepresentation.vala"
				_tmp30_ = _tmp29_;
#line 135 "../src/MediaDataRepresentation.vala"
				_tmp31_ = err;
#line 135 "../src/MediaDataRepresentation.vala"
				_tmp32_ = _tmp31_->message;
#line 135 "../src/MediaDataRepresentation.vala"
				g_warning ("MediaDataRepresentation.vala:135: Unable to query file info for %s: %s", _tmp30_, _tmp32_);
#line 135 "../src/MediaDataRepresentation.vala"
				_g_free0 (_tmp30_);
#line 137 "../src/MediaDataRepresentation.vala"
				_g_error_free0 (err);
#line 137 "../src/MediaDataRepresentation.vala"
				break;
#line 1222 "MediaDataRepresentation.c"
			}
			__finally1:
#line 131 "../src/MediaDataRepresentation.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1227 "MediaDataRepresentation.c"
				gboolean _tmp33_ = FALSE;
#line 131 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (parent);
#line 131 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (file);
#line 131 "../src/MediaDataRepresentation.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/MediaDataRepresentation.vala"
				g_clear_error (&_inner_error0_);
#line 131 "../src/MediaDataRepresentation.vala"
				return _tmp33_;
#line 1239 "MediaDataRepresentation.c"
			}
			{
				GFile* _tmp34_;
				GFile* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
#line 141 "../src/MediaDataRepresentation.vala"
				_tmp34_ = parent;
#line 141 "../src/MediaDataRepresentation.vala"
				g_file_delete (_tmp34_, NULL, &_inner_error0_);
#line 141 "../src/MediaDataRepresentation.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1252 "MediaDataRepresentation.c"
					goto __catch2_g_error;
				}
#line 142 "../src/MediaDataRepresentation.vala"
				_tmp35_ = parent;
#line 142 "../src/MediaDataRepresentation.vala"
				_tmp36_ = g_file_get_path (_tmp35_);
#line 142 "../src/MediaDataRepresentation.vala"
				_tmp37_ = _tmp36_;
#line 142 "../src/MediaDataRepresentation.vala"
				g_debug ("MediaDataRepresentation.vala:142: Deleted empty directory %s", _tmp37_);
#line 142 "../src/MediaDataRepresentation.vala"
				_g_free0 (_tmp37_);
#line 1265 "MediaDataRepresentation.c"
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* err = NULL;
				GFile* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				GError* _tmp41_;
				const gchar* _tmp42_;
#line 140 "../src/MediaDataRepresentation.vala"
				err = _inner_error0_;
#line 140 "../src/MediaDataRepresentation.vala"
				_inner_error0_ = NULL;
#line 145 "../src/MediaDataRepresentation.vala"
				_tmp38_ = parent;
#line 145 "../src/MediaDataRepresentation.vala"
				_tmp39_ = g_file_get_path (_tmp38_);
#line 145 "../src/MediaDataRepresentation.vala"
				_tmp40_ = _tmp39_;
#line 145 "../src/MediaDataRepresentation.vala"
				_tmp41_ = err;
#line 145 "../src/MediaDataRepresentation.vala"
				_tmp42_ = _tmp41_->message;
#line 145 "../src/MediaDataRepresentation.vala"
				g_message ("MediaDataRepresentation.vala:145: Unable to delete empty directory %s:" \
" %s", _tmp40_, _tmp42_);
#line 145 "../src/MediaDataRepresentation.vala"
				_g_free0 (_tmp40_);
#line 140 "../src/MediaDataRepresentation.vala"
				_g_error_free0 (err);
#line 1296 "MediaDataRepresentation.c"
			}
			__finally2:
#line 140 "../src/MediaDataRepresentation.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1301 "MediaDataRepresentation.c"
				gboolean _tmp43_ = FALSE;
#line 140 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (parent);
#line 140 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (file);
#line 140 "../src/MediaDataRepresentation.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 140 "../src/MediaDataRepresentation.vala"
				g_clear_error (&_inner_error0_);
#line 140 "../src/MediaDataRepresentation.vala"
				return _tmp43_;
#line 1313 "MediaDataRepresentation.c"
			}
		}
#line 124 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (parent);
#line 1318 "MediaDataRepresentation.c"
	}
#line 151 "../src/MediaDataRepresentation.vala"
	result = ret;
#line 151 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (file);
#line 151 "../src/MediaDataRepresentation.vala"
	return result;
#line 1326 "MediaDataRepresentation.c"
}

static gchar*
media_source_real_get_name (DataObject* base)
{
	MediaSource * self;
	gchar* title = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* result;
#line 154 "../src/MediaDataRepresentation.vala"
	self = (MediaSource*) base;
#line 155 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_get_title (self);
#line 155 "../src/MediaDataRepresentation.vala"
	title = _tmp0_;
#line 157 "../src/MediaDataRepresentation.vala"
	_tmp2_ = title;
#line 157 "../src/MediaDataRepresentation.vala"
	if (is_string_empty (_tmp2_)) {
#line 1348 "MediaDataRepresentation.c"
		gchar* _tmp3_;
#line 157 "../src/MediaDataRepresentation.vala"
		_tmp3_ = media_source_get_basename (self);
#line 157 "../src/MediaDataRepresentation.vala"
		_g_free0 (_tmp1_);
#line 157 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp3_;
#line 1356 "MediaDataRepresentation.c"
	} else {
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 157 "../src/MediaDataRepresentation.vala"
		_tmp4_ = title;
#line 157 "../src/MediaDataRepresentation.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 157 "../src/MediaDataRepresentation.vala"
		_g_free0 (_tmp1_);
#line 157 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp5_;
#line 1368 "MediaDataRepresentation.c"
	}
#line 157 "../src/MediaDataRepresentation.vala"
	result = _tmp1_;
#line 157 "../src/MediaDataRepresentation.vala"
	_g_free0 (title);
#line 157 "../src/MediaDataRepresentation.vala"
	return result;
#line 1376 "MediaDataRepresentation.c"
}

static gchar*
media_source_real_get_basename (MediaSource* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 161 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_get_file (self);
#line 161 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 161 "../src/MediaDataRepresentation.vala"
	_tmp2_ = g_file_get_basename (_tmp1_);
#line 161 "../src/MediaDataRepresentation.vala"
	_tmp3_ = _tmp2_;
#line 161 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (_tmp1_);
#line 161 "../src/MediaDataRepresentation.vala"
	result = _tmp3_;
#line 161 "../src/MediaDataRepresentation.vala"
	return result;
#line 1401 "MediaDataRepresentation.c"
}

gchar*
media_source_get_basename (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 160 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 160 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_basename) {
#line 160 "../src/MediaDataRepresentation.vala"
		return _klass_->get_basename (self);
#line 1416 "MediaDataRepresentation.c"
	}
#line 160 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1420 "MediaDataRepresentation.c"
}

static GFile*
media_source_real_get_file (MediaSource* self)
{
#line 164 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 164 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1430 "MediaDataRepresentation.c"
}

GFile*
media_source_get_file (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 164 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 164 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_file) {
#line 164 "../src/MediaDataRepresentation.vala"
		return _klass_->get_file (self);
#line 1445 "MediaDataRepresentation.c"
	}
#line 164 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1449 "MediaDataRepresentation.c"
}

static GFile*
media_source_real_get_master_file (MediaSource* self)
{
#line 165 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_master_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 165 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1459 "MediaDataRepresentation.c"
}

GFile*
media_source_get_master_file (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 165 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 165 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 165 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_master_file) {
#line 165 "../src/MediaDataRepresentation.vala"
		return _klass_->get_master_file (self);
#line 1474 "MediaDataRepresentation.c"
	}
#line 165 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1478 "MediaDataRepresentation.c"
}

static guint64
media_source_real_get_master_filesize (MediaSource* self)
{
	guint64 _tmp0_ = 0ULL;
#line 166 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_master_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 166 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 1489 "MediaDataRepresentation.c"
}

guint64
media_source_get_master_filesize (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 166 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 166 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 166 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_master_filesize) {
#line 166 "../src/MediaDataRepresentation.vala"
		return _klass_->get_master_filesize (self);
#line 1504 "MediaDataRepresentation.c"
	}
#line 166 "../src/MediaDataRepresentation.vala"
	return 0ULL;
#line 1508 "MediaDataRepresentation.c"
}

static guint64
media_source_real_get_filesize (MediaSource* self)
{
	guint64 _tmp0_ = 0ULL;
#line 167 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 167 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 1519 "MediaDataRepresentation.c"
}

guint64
media_source_get_filesize (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 167 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 167 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 167 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_filesize) {
#line 167 "../src/MediaDataRepresentation.vala"
		return _klass_->get_filesize (self);
#line 1534 "MediaDataRepresentation.c"
	}
#line 167 "../src/MediaDataRepresentation.vala"
	return 0ULL;
#line 1538 "MediaDataRepresentation.c"
}

static gint64
media_source_real_get_timestamp (MediaSource* self)
{
	gint64 _tmp0_ = 0LL;
#line 168 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_timestamp'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 168 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 1549 "MediaDataRepresentation.c"
}

gint64
media_source_get_timestamp (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 168 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 168 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 168 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_timestamp) {
#line 168 "../src/MediaDataRepresentation.vala"
		return _klass_->get_timestamp (self);
#line 1564 "MediaDataRepresentation.c"
	}
#line 168 "../src/MediaDataRepresentation.vala"
	return -1LL;
#line 1568 "MediaDataRepresentation.c"
}

static BackingFileState**
media_source_real_get_backing_files_state (MediaSource* self,
                                           gint* result_length1)
{
#line 171 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_backing_files_state'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 171 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1579 "MediaDataRepresentation.c"
}

BackingFileState**
media_source_get_backing_files_state (MediaSource* self,
                                      gint* result_length1)
{
	MediaSourceClass* _klass_;
#line 171 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 171 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 171 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_backing_files_state) {
#line 171 "../src/MediaDataRepresentation.vala"
		return _klass_->get_backing_files_state (self, result_length1);
#line 1595 "MediaDataRepresentation.c"
	}
#line 171 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1599 "MediaDataRepresentation.c"
}

static gchar*
media_source_real_get_title (MediaSource* self)
{
#line 173 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_title'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 173 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1609 "MediaDataRepresentation.c"
}

gchar*
media_source_get_title (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 173 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 173 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 173 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_title) {
#line 173 "../src/MediaDataRepresentation.vala"
		return _klass_->get_title (self);
#line 1624 "MediaDataRepresentation.c"
	}
#line 173 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1628 "MediaDataRepresentation.c"
}

static gchar*
media_source_real_get_comment (MediaSource* self)
{
#line 174 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_comment'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 174 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1638 "MediaDataRepresentation.c"
}

gchar*
media_source_get_comment (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 174 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 174 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 174 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_comment) {
#line 174 "../src/MediaDataRepresentation.vala"
		return _klass_->get_comment (self);
#line 1653 "MediaDataRepresentation.c"
	}
#line 174 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1657 "MediaDataRepresentation.c"
}

static void
media_source_real_set_title (MediaSource* self,
                             const gchar* title)
{
#line 175 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_set_title'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 175 "../src/MediaDataRepresentation.vala"
	return;
#line 1668 "MediaDataRepresentation.c"
}

void
media_source_set_title (MediaSource* self,
                        const gchar* title)
{
	MediaSourceClass* _klass_;
#line 175 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 175 "../src/MediaDataRepresentation.vala"
	if (_klass_->set_title) {
#line 175 "../src/MediaDataRepresentation.vala"
		_klass_->set_title (self, title);
#line 1684 "MediaDataRepresentation.c"
	}
}

static gboolean
media_source_real_set_comment (MediaSource* self,
                               const gchar* comment)
{
	gboolean _tmp0_ = FALSE;
#line 176 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_set_comment'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 176 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 1697 "MediaDataRepresentation.c"
}

gboolean
media_source_set_comment (MediaSource* self,
                          const gchar* comment)
{
	MediaSourceClass* _klass_;
#line 176 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 176 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 176 "../src/MediaDataRepresentation.vala"
	if (_klass_->set_comment) {
#line 176 "../src/MediaDataRepresentation.vala"
		return _klass_->set_comment (self, comment);
#line 1713 "MediaDataRepresentation.c"
	}
#line 176 "../src/MediaDataRepresentation.vala"
	return FALSE;
#line 1717 "MediaDataRepresentation.c"
}

gchar*
media_source_prep_title (const gchar* title)
{
	gchar* _tmp0_;
	gchar* result;
#line 179 "../src/MediaDataRepresentation.vala"
	_tmp0_ = prepare_input_text (title, PREPARE_INPUT_TEXT_OPTIONS_DEFAULT & (~PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL), DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 179 "../src/MediaDataRepresentation.vala"
	result = _tmp0_;
#line 179 "../src/MediaDataRepresentation.vala"
	return result;
#line 1731 "MediaDataRepresentation.c"
}

gchar*
media_source_prep_comment (const gchar* comment)
{
	gchar* _tmp0_;
	gchar* result;
#line 184 "../src/MediaDataRepresentation.vala"
	_tmp0_ = prepare_input_text (comment, (PREPARE_INPUT_TEXT_OPTIONS_DEFAULT & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF)) & (~PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL), -1);
#line 184 "../src/MediaDataRepresentation.vala"
	result = _tmp0_;
#line 184 "../src/MediaDataRepresentation.vala"
	return result;
#line 1745 "MediaDataRepresentation.c"
}

static void
media_source_real_get_dimensions (MediaSource* self,
                                  PhotoException disallowed_steps,
                                  Dimensions* result)
{
#line 188 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_dimensions'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 188 "../src/MediaDataRepresentation.vala"
	return;
#line 1757 "MediaDataRepresentation.c"
}

void
media_source_get_dimensions (MediaSource* self,
                             PhotoException disallowed_steps,
                             Dimensions* result)
{
	MediaSourceClass* _klass_;
#line 188 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 188 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_dimensions) {
#line 188 "../src/MediaDataRepresentation.vala"
		_klass_->get_dimensions (self, disallowed_steps, result);
#line 1774 "MediaDataRepresentation.c"
	}
}

static GdkPixbuf*
media_source_real_get_preview_pixbuf (MediaSource* self,
                                      Scaling* scaling,
                                      GError** error)
{
#line 196 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_preview_pixbuf'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 196 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1787 "MediaDataRepresentation.c"
}

GdkPixbuf*
media_source_get_preview_pixbuf (MediaSource* self,
                                 Scaling* scaling,
                                 GError** error)
{
	MediaSourceClass* _klass_;
#line 196 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 196 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 196 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_preview_pixbuf) {
#line 196 "../src/MediaDataRepresentation.vala"
		return _klass_->get_preview_pixbuf (self, scaling, error);
#line 1804 "MediaDataRepresentation.c"
	}
#line 196 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1808 "MediaDataRepresentation.c"
}

static gboolean
media_source_real_is_trashed (MediaSource* self)
{
	gboolean _tmp0_ = FALSE;
#line 198 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_is_trashed'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 198 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 1819 "MediaDataRepresentation.c"
}

gboolean
media_source_is_trashed (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 198 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 198 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 198 "../src/MediaDataRepresentation.vala"
	if (_klass_->is_trashed) {
#line 198 "../src/MediaDataRepresentation.vala"
		return _klass_->is_trashed (self);
#line 1834 "MediaDataRepresentation.c"
	}
#line 198 "../src/MediaDataRepresentation.vala"
	return FALSE;
#line 1838 "MediaDataRepresentation.c"
}

static void
media_source_real_trash (MediaSource* self)
{
#line 199 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_trash'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 199 "../src/MediaDataRepresentation.vala"
	return;
#line 1848 "MediaDataRepresentation.c"
}

void
media_source_trash (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 199 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 199 "../src/MediaDataRepresentation.vala"
	if (_klass_->trash) {
#line 199 "../src/MediaDataRepresentation.vala"
		_klass_->trash (self);
#line 1863 "MediaDataRepresentation.c"
	}
}

static void
media_source_real_untrash (MediaSource* self)
{
#line 200 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_untrash'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 200 "../src/MediaDataRepresentation.vala"
	return;
#line 1874 "MediaDataRepresentation.c"
}

void
media_source_untrash (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 200 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 200 "../src/MediaDataRepresentation.vala"
	if (_klass_->untrash) {
#line 200 "../src/MediaDataRepresentation.vala"
		_klass_->untrash (self);
#line 1889 "MediaDataRepresentation.c"
	}
}

static gboolean
media_source_real_is_offline (MediaSource* self)
{
	gboolean _tmp0_ = FALSE;
#line 202 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_is_offline'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 202 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 1901 "MediaDataRepresentation.c"
}

gboolean
media_source_is_offline (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 202 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 202 "../src/MediaDataRepresentation.vala"
	if (_klass_->is_offline) {
#line 202 "../src/MediaDataRepresentation.vala"
		return _klass_->is_offline (self);
#line 1916 "MediaDataRepresentation.c"
	}
#line 202 "../src/MediaDataRepresentation.vala"
	return FALSE;
#line 1920 "MediaDataRepresentation.c"
}

static void
media_source_real_mark_offline (MediaSource* self)
{
#line 203 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_mark_offline'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 203 "../src/MediaDataRepresentation.vala"
	return;
#line 1930 "MediaDataRepresentation.c"
}

void
media_source_mark_offline (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 203 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 203 "../src/MediaDataRepresentation.vala"
	if (_klass_->mark_offline) {
#line 203 "../src/MediaDataRepresentation.vala"
		_klass_->mark_offline (self);
#line 1945 "MediaDataRepresentation.c"
	}
}

static void
media_source_real_mark_online (MediaSource* self)
{
#line 204 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_mark_online'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 204 "../src/MediaDataRepresentation.vala"
	return;
#line 1956 "MediaDataRepresentation.c"
}

void
media_source_mark_online (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 204 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 204 "../src/MediaDataRepresentation.vala"
	if (_klass_->mark_online) {
#line 204 "../src/MediaDataRepresentation.vala"
		_klass_->mark_online (self);
#line 1971 "MediaDataRepresentation.c"
	}
}

static gchar*
media_source_real_get_master_md5 (MediaSource* self)
{
#line 206 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_master_md5'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 206 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 1982 "MediaDataRepresentation.c"
}

gchar*
media_source_get_master_md5 (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 206 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 206 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_master_md5) {
#line 206 "../src/MediaDataRepresentation.vala"
		return _klass_->get_master_md5 (self);
#line 1997 "MediaDataRepresentation.c"
	}
#line 206 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 2001 "MediaDataRepresentation.c"
}

static void
media_source_real_get_event_id (MediaSource* self,
                                EventID* result)
{
#line 210 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_event_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 210 "../src/MediaDataRepresentation.vala"
	return;
#line 2012 "MediaDataRepresentation.c"
}

void
media_source_get_event_id (MediaSource* self,
                           EventID* result)
{
	MediaSourceClass* _klass_;
#line 210 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 210 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_event_id) {
#line 210 "../src/MediaDataRepresentation.vala"
		_klass_->get_event_id (self, result);
#line 2028 "MediaDataRepresentation.c"
	}
}

Event*
media_source_get_event (MediaSource* self)
{
	Event* _tmp0_;
	EventID event_id = {0};
	EventID _tmp3_ = {0};
	EventSourceCollection* _tmp4_;
	EventID _tmp5_;
	Event* _tmp6_;
	Event* _tmp7_;
	Event* _tmp8_;
	Event* result;
#line 212 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 213 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->event;
#line 213 "../src/MediaDataRepresentation.vala"
	if (_tmp0_ != NULL) {
#line 2050 "MediaDataRepresentation.c"
		Event* _tmp1_;
		Event* _tmp2_;
#line 214 "../src/MediaDataRepresentation.vala"
		_tmp1_ = self->priv->event;
#line 214 "../src/MediaDataRepresentation.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 214 "../src/MediaDataRepresentation.vala"
		result = _tmp2_;
#line 214 "../src/MediaDataRepresentation.vala"
		return result;
#line 2061 "MediaDataRepresentation.c"
	}
#line 216 "../src/MediaDataRepresentation.vala"
	media_source_get_event_id (self, &_tmp3_);
#line 216 "../src/MediaDataRepresentation.vala"
	event_id = _tmp3_;
#line 217 "../src/MediaDataRepresentation.vala"
	if (!event_id_is_valid (&event_id)) {
#line 218 "../src/MediaDataRepresentation.vala"
		result = NULL;
#line 218 "../src/MediaDataRepresentation.vala"
		return result;
#line 2073 "MediaDataRepresentation.c"
	}
#line 220 "../src/MediaDataRepresentation.vala"
	_tmp4_ = event_global;
#line 220 "../src/MediaDataRepresentation.vala"
	_tmp5_ = event_id;
#line 220 "../src/MediaDataRepresentation.vala"
	_tmp6_ = event_source_collection_fetch (_tmp4_, &_tmp5_);
#line 220 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->event);
#line 220 "../src/MediaDataRepresentation.vala"
	self->priv->event = _tmp6_;
#line 222 "../src/MediaDataRepresentation.vala"
	_tmp7_ = self->priv->event;
#line 222 "../src/MediaDataRepresentation.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 222 "../src/MediaDataRepresentation.vala"
	result = _tmp8_;
#line 222 "../src/MediaDataRepresentation.vala"
	return result;
#line 2093 "MediaDataRepresentation.c"
}

gboolean
media_source_set_event (MediaSource* self,
                        Event* new_event)
{
	EventID _tmp0_ = {0};
	EventID event_id = {0};
	EventID _tmp2_ = {0};
	EventID _tmp3_;
	gboolean committed = FALSE;
	EventID _tmp4_;
	gboolean result;
#line 225 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 226 "../src/MediaDataRepresentation.vala"
	if (new_event != NULL) {
#line 2111 "MediaDataRepresentation.c"
		EventID _tmp1_ = {0};
#line 226 "../src/MediaDataRepresentation.vala"
		event_get_event_id (new_event, &_tmp1_);
#line 226 "../src/MediaDataRepresentation.vala"
		_tmp0_ = _tmp1_;
#line 2117 "MediaDataRepresentation.c"
	} else {
#line 226 "../src/MediaDataRepresentation.vala"
		event_id_init (&_tmp0_, EVENT_ID_INVALID);
#line 2121 "MediaDataRepresentation.c"
	}
#line 226 "../src/MediaDataRepresentation.vala"
	event_id = _tmp0_;
#line 227 "../src/MediaDataRepresentation.vala"
	media_source_get_event_id (self, &_tmp2_);
#line 227 "../src/MediaDataRepresentation.vala"
	_tmp3_ = event_id;
#line 227 "../src/MediaDataRepresentation.vala"
	if (_tmp2_.id == _tmp3_.id) {
#line 228 "../src/MediaDataRepresentation.vala"
		result = TRUE;
#line 228 "../src/MediaDataRepresentation.vala"
		return result;
#line 2135 "MediaDataRepresentation.c"
	}
#line 230 "../src/MediaDataRepresentation.vala"
	_tmp4_ = event_id;
#line 230 "../src/MediaDataRepresentation.vala"
	committed = media_source_set_event_id (self, &_tmp4_);
#line 231 "../src/MediaDataRepresentation.vala"
	if (committed) {
#line 2143 "MediaDataRepresentation.c"
		Event* _tmp5_;
		Event* _tmp7_;
		Alteration* _tmp8_;
		Alteration* _tmp9_;
#line 232 "../src/MediaDataRepresentation.vala"
		_tmp5_ = self->priv->event;
#line 232 "../src/MediaDataRepresentation.vala"
		if (_tmp5_ != NULL) {
#line 2152 "MediaDataRepresentation.c"
			Event* _tmp6_;
#line 233 "../src/MediaDataRepresentation.vala"
			_tmp6_ = self->priv->event;
#line 233 "../src/MediaDataRepresentation.vala"
			event_detach (_tmp6_, self);
#line 2158 "MediaDataRepresentation.c"
		}
#line 235 "../src/MediaDataRepresentation.vala"
		if (new_event != NULL) {
#line 236 "../src/MediaDataRepresentation.vala"
			event_attach (new_event, self);
#line 2164 "MediaDataRepresentation.c"
		}
#line 238 "../src/MediaDataRepresentation.vala"
		_tmp7_ = _g_object_ref0 (new_event);
#line 238 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (self->priv->event);
#line 238 "../src/MediaDataRepresentation.vala"
		self->priv->event = _tmp7_;
#line 240 "../src/MediaDataRepresentation.vala"
		_tmp8_ = alteration_new ("metadata", "event");
#line 240 "../src/MediaDataRepresentation.vala"
		_tmp9_ = _tmp8_;
#line 240 "../src/MediaDataRepresentation.vala"
		data_object_notify_altered ((DataObject*) self, _tmp9_);
#line 240 "../src/MediaDataRepresentation.vala"
		_alteration_unref0 (_tmp9_);
#line 2180 "MediaDataRepresentation.c"
	}
#line 243 "../src/MediaDataRepresentation.vala"
	result = committed;
#line 243 "../src/MediaDataRepresentation.vala"
	return result;
#line 2186 "MediaDataRepresentation.c"
}

void
media_source_set_many_to_event (GeeCollection* media_sources,
                                Event* event,
                                TransactionController* controller,
                                GError** error)
{
	EventID _tmp0_ = {0};
	EventID event_id = {0};
	Alteration* alteration = NULL;
	Alteration* _tmp15_;
#line 246 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media_sources != NULL);
#line 246 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (controller != NULL);
#line 248 "../src/MediaDataRepresentation.vala"
	if (event != NULL) {
#line 2205 "MediaDataRepresentation.c"
		EventID _tmp1_ = {0};
#line 248 "../src/MediaDataRepresentation.vala"
		event_get_event_id (event, &_tmp1_);
#line 248 "../src/MediaDataRepresentation.vala"
		_tmp0_ = _tmp1_;
#line 2211 "MediaDataRepresentation.c"
	} else {
#line 248 "../src/MediaDataRepresentation.vala"
		event_id_init (&_tmp0_, EVENT_ID_INVALID);
#line 2215 "MediaDataRepresentation.c"
	}
#line 248 "../src/MediaDataRepresentation.vala"
	event_id = _tmp0_;
#line 250 "../src/MediaDataRepresentation.vala"
	transaction_controller_begin (controller);
#line 2221 "MediaDataRepresentation.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp2_;
#line 252 "../src/MediaDataRepresentation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) media_sources);
#line 252 "../src/MediaDataRepresentation.vala"
		_media_it = _tmp2_;
#line 252 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 2231 "MediaDataRepresentation.c"
			GeeIterator* _tmp3_;
			MediaSource* media = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			Event* old_event = NULL;
			MediaSource* _tmp6_;
			Event* _tmp7_;
			Event* _tmp8_;
			MediaSource* _tmp11_;
			EventID _tmp12_;
			MediaSource* _tmp13_;
			Event* _tmp14_;
#line 252 "../src/MediaDataRepresentation.vala"
			_tmp3_ = _media_it;
#line 252 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 252 "../src/MediaDataRepresentation.vala"
				break;
#line 2250 "MediaDataRepresentation.c"
			}
#line 252 "../src/MediaDataRepresentation.vala"
			_tmp4_ = _media_it;
#line 252 "../src/MediaDataRepresentation.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 252 "../src/MediaDataRepresentation.vala"
			media = (MediaSource*) _tmp5_;
#line 253 "../src/MediaDataRepresentation.vala"
			_tmp6_ = media;
#line 253 "../src/MediaDataRepresentation.vala"
			_tmp7_ = media_source_get_event (_tmp6_);
#line 253 "../src/MediaDataRepresentation.vala"
			old_event = _tmp7_;
#line 254 "../src/MediaDataRepresentation.vala"
			_tmp8_ = old_event;
#line 254 "../src/MediaDataRepresentation.vala"
			if (_tmp8_ != NULL) {
#line 2268 "MediaDataRepresentation.c"
				Event* _tmp9_;
				MediaSource* _tmp10_;
#line 255 "../src/MediaDataRepresentation.vala"
				_tmp9_ = old_event;
#line 255 "../src/MediaDataRepresentation.vala"
				_tmp10_ = media;
#line 255 "../src/MediaDataRepresentation.vala"
				event_detach (_tmp9_, _tmp10_);
#line 2277 "MediaDataRepresentation.c"
			}
#line 257 "../src/MediaDataRepresentation.vala"
			_tmp11_ = media;
#line 257 "../src/MediaDataRepresentation.vala"
			_tmp12_ = event_id;
#line 257 "../src/MediaDataRepresentation.vala"
			media_source_set_event_id (_tmp11_, &_tmp12_);
#line 258 "../src/MediaDataRepresentation.vala"
			_tmp13_ = media;
#line 258 "../src/MediaDataRepresentation.vala"
			_tmp14_ = _g_object_ref0 (event);
#line 258 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (_tmp13_->priv->event);
#line 258 "../src/MediaDataRepresentation.vala"
			_tmp13_->priv->event = _tmp14_;
#line 252 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (old_event);
#line 252 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (media);
#line 2297 "MediaDataRepresentation.c"
		}
#line 252 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_media_it);
#line 2301 "MediaDataRepresentation.c"
	}
#line 261 "../src/MediaDataRepresentation.vala"
	if (event != NULL) {
#line 262 "../src/MediaDataRepresentation.vala"
		event_attach_many (event, media_sources);
#line 2307 "MediaDataRepresentation.c"
	}
#line 264 "../src/MediaDataRepresentation.vala"
	_tmp15_ = alteration_new ("metadata", "event");
#line 264 "../src/MediaDataRepresentation.vala"
	alteration = _tmp15_;
#line 2313 "MediaDataRepresentation.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp16_;
#line 265 "../src/MediaDataRepresentation.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) media_sources);
#line 265 "../src/MediaDataRepresentation.vala"
		_media_it = _tmp16_;
#line 265 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 2323 "MediaDataRepresentation.c"
			GeeIterator* _tmp17_;
			MediaSource* media = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			MediaSource* _tmp20_;
			Alteration* _tmp21_;
#line 265 "../src/MediaDataRepresentation.vala"
			_tmp17_ = _media_it;
#line 265 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp17_)) {
#line 265 "../src/MediaDataRepresentation.vala"
				break;
#line 2336 "MediaDataRepresentation.c"
			}
#line 265 "../src/MediaDataRepresentation.vala"
			_tmp18_ = _media_it;
#line 265 "../src/MediaDataRepresentation.vala"
			_tmp19_ = gee_iterator_get (_tmp18_);
#line 265 "../src/MediaDataRepresentation.vala"
			media = (MediaSource*) _tmp19_;
#line 266 "../src/MediaDataRepresentation.vala"
			_tmp20_ = media;
#line 266 "../src/MediaDataRepresentation.vala"
			_tmp21_ = alteration;
#line 266 "../src/MediaDataRepresentation.vala"
			data_object_notify_altered ((DataObject*) _tmp20_, _tmp21_);
#line 265 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (media);
#line 2352 "MediaDataRepresentation.c"
		}
#line 265 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_media_it);
#line 2356 "MediaDataRepresentation.c"
	}
#line 268 "../src/MediaDataRepresentation.vala"
	transaction_controller_commit (controller);
#line 246 "../src/MediaDataRepresentation.vala"
	_alteration_unref0 (alteration);
#line 2362 "MediaDataRepresentation.c"
}

static gint64
media_source_real_get_exposure_time (MediaSource* self)
{
	gint64 _tmp0_ = 0LL;
#line 271 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_exposure_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 271 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 2373 "MediaDataRepresentation.c"
}

gint64
media_source_get_exposure_time (MediaSource* self)
{
	MediaSourceClass* _klass_;
#line 271 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 271 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 271 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_exposure_time) {
#line 271 "../src/MediaDataRepresentation.vala"
		return _klass_->get_exposure_time (self);
#line 2388 "MediaDataRepresentation.c"
	}
#line 271 "../src/MediaDataRepresentation.vala"
	return -1LL;
#line 2392 "MediaDataRepresentation.c"
}

static void
media_source_real_get_import_id (MediaSource* self,
                                 ImportID* result)
{
#line 273 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_get_import_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 273 "../src/MediaDataRepresentation.vala"
	return;
#line 2403 "MediaDataRepresentation.c"
}

void
media_source_get_import_id (MediaSource* self,
                            ImportID* result)
{
	MediaSourceClass* _klass_;
#line 273 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 273 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_GET_CLASS (self);
#line 273 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_import_id) {
#line 273 "../src/MediaDataRepresentation.vala"
		_klass_->get_import_id (self, result);
#line 2419 "MediaDataRepresentation.c"
	}
}

static void
media_source_real_master_replaced (MediaSource* self,
                                   GFile* old_file,
                                   GFile* new_file)
{
#line 46 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (old_file != NULL);
#line 46 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (new_file != NULL);
#line 2432 "MediaDataRepresentation.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 45 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (n_param_values == 3);
#line 45 "../src/MediaDataRepresentation.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 45 "../src/MediaDataRepresentation.vala"
		data1 = closure->data;
#line 45 "../src/MediaDataRepresentation.vala"
		data2 = param_values->data[0].v_pointer;
#line 2457 "MediaDataRepresentation.c"
	} else {
#line 45 "../src/MediaDataRepresentation.vala"
		data1 = param_values->data[0].v_pointer;
#line 45 "../src/MediaDataRepresentation.vala"
		data2 = closure->data;
#line 2463 "MediaDataRepresentation.c"
	}
#line 45 "../src/MediaDataRepresentation.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 45 "../src/MediaDataRepresentation.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 2469 "MediaDataRepresentation.c"
}

static void
media_source_class_init (MediaSourceClass * klass,
                         gpointer klass_data)
{
#line 45 "../src/MediaDataRepresentation.vala"
	media_source_parent_class = g_type_class_peek_parent (klass);
#line 45 "../src/MediaDataRepresentation.vala"
	g_type_class_adjust_private_offset (klass, &MediaSource_private_offset);
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->notify_master_replaced = (void (*) (MediaSource*, GFile*, GFile*)) media_source_real_notify_master_replaced;
#line 45 "../src/MediaDataRepresentation.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) media_source_real_notify_altered;
#line 45 "../src/MediaDataRepresentation.vala"
	((DataObjectClass *) klass)->notify_membership_changed = (void (*) (DataObject*, DataCollection*)) media_source_real_notify_membership_changed;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) media_source_real_set_event_id;
#line 45 "../src/MediaDataRepresentation.vala"
	((DataObjectClass *) klass)->get_name = (gchar* (*) (DataObject*)) media_source_real_get_name;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*) (MediaSource*)) media_source_real_get_basename;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) media_source_real_get_file;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) media_source_real_get_master_file;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) media_source_real_get_master_filesize;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) media_source_real_get_filesize;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_timestamp = (gint64 (*) (MediaSource*)) media_source_real_get_timestamp;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, gint*)) media_source_real_get_backing_files_state;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) media_source_real_get_title;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) media_source_real_get_comment;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) media_source_real_set_title;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) media_source_real_set_comment;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) media_source_real_get_dimensions;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) media_source_real_get_preview_pixbuf;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) media_source_real_is_trashed;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) media_source_real_trash;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) media_source_real_untrash;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) media_source_real_is_offline;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) media_source_real_mark_offline;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) media_source_real_mark_online;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) media_source_real_get_master_md5;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) media_source_real_get_event_id;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (gint64 (*) (MediaSource*)) media_source_real_get_exposure_time;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) media_source_real_get_import_id;
#line 45 "../src/MediaDataRepresentation.vala"
	((MediaSourceClass *) klass)->master_replaced = media_source_real_master_replaced;
#line 45 "../src/MediaDataRepresentation.vala"
	G_OBJECT_CLASS (klass)->finalize = media_source_finalize;
#line 45 "../src/MediaDataRepresentation.vala"
	media_source_signals[MEDIA_SOURCE_MASTER_REPLACED_SIGNAL] = g_signal_new ("master-replaced", TYPE_MEDIA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (MediaSourceClass, master_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 2542 "MediaDataRepresentation.c"
}

static void
media_source_indexable_interface_init (IndexableIface * iface,
                                       gpointer iface_data)
{
#line 45 "../src/MediaDataRepresentation.vala"
	media_source_indexable_parent_iface = g_type_interface_peek_parent (iface);
#line 45 "../src/MediaDataRepresentation.vala"
	iface->get_indexable_keywords = (const gchar* (*) (Indexable*)) media_source_real_get_indexable_keywords;
#line 2553 "MediaDataRepresentation.c"
}

static void
media_source_instance_init (MediaSource * self,
                            gpointer klass)
{
#line 45 "../src/MediaDataRepresentation.vala"
	self->priv = media_source_get_instance_private (self);
#line 49 "../src/MediaDataRepresentation.vala"
	self->priv->event = NULL;
#line 50 "../src/MediaDataRepresentation.vala"
	self->priv->indexable_keywords = NULL;
#line 2566 "MediaDataRepresentation.c"
}

static void
media_source_finalize (GObject * obj)
{
	MediaSource * self;
#line 45 "../src/MediaDataRepresentation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_SOURCE, MediaSource);
#line 49 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->event);
#line 50 "../src/MediaDataRepresentation.vala"
	_g_free0 (self->priv->indexable_keywords);
#line 45 "../src/MediaDataRepresentation.vala"
	G_OBJECT_CLASS (media_source_parent_class)->finalize (obj);
#line 2581 "MediaDataRepresentation.c"
}

static GType
media_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaSource), 0, (GInstanceInitFunc) media_source_instance_init, NULL };
	static const GInterfaceInfo indexable_info = { (GInterfaceInitFunc) media_source_indexable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType media_source_type_id;
	media_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "MediaSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (media_source_type_id, TYPE_INDEXABLE, &indexable_info);
	MediaSource_private_offset = g_type_add_instance_private (media_source_type_id, sizeof (MediaSourcePrivate));
	return media_source_type_id;
}

GType
media_source_get_type (void)
{
	static volatile gsize media_source_type_id__once = 0;
	if (g_once_init_enter (&media_source_type_id__once)) {
		GType media_source_type_id;
		media_source_type_id = media_source_get_type_once ();
		g_once_init_leave (&media_source_type_id__once, media_source_type_id);
	}
	return media_source_type_id__once;
}

static inline gpointer
media_source_holding_tank_get_instance_private (MediaSourceHoldingTank* self)
{
	return G_STRUCT_MEMBER_P (self, MediaSourceHoldingTank_private_offset);
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 277 "../src/MediaDataRepresentation.vala"
	return result;
#line 2622 "MediaDataRepresentation.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 277 "../src/MediaDataRepresentation.vala"
	return result;
#line 2634 "MediaDataRepresentation.c"
}

MediaSourceHoldingTank*
media_source_holding_tank_construct (GType object_type,
                                     MediaSourceCollection* sources,
                                     SourceHoldingTankCheckToKeep check_to_keep,
                                     gpointer check_to_keep_target,
                                     GetSourceDatabaseKey get_key,
                                     gpointer get_key_target)
{
	MediaSourceHoldingTank* self = NULL;
#line 280 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 282 "../src/MediaDataRepresentation.vala"
	self = (MediaSourceHoldingTank*) database_source_holding_tank_construct (object_type, (SourceCollection*) sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 280 "../src/MediaDataRepresentation.vala"
	return self;
#line 2652 "MediaDataRepresentation.c"
}

MediaSourceHoldingTank*
media_source_holding_tank_new (MediaSourceCollection* sources,
                               SourceHoldingTankCheckToKeep check_to_keep,
                               gpointer check_to_keep_target,
                               GetSourceDatabaseKey get_key,
                               gpointer get_key_target)
{
#line 280 "../src/MediaDataRepresentation.vala"
	return media_source_holding_tank_construct (TYPE_MEDIA_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 2664 "MediaDataRepresentation.c"
}

MediaSource*
media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                GFile* file)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MediaSource* result;
#line 285 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 285 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 286 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->master_file_map;
#line 286 "../src/MediaDataRepresentation.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 286 "../src/MediaDataRepresentation.vala"
	result = (MediaSource*) _tmp1_;
#line 286 "../src/MediaDataRepresentation.vala"
	return result;
#line 2686 "MediaDataRepresentation.c"
}

MediaSource*
media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self,
                                        const gchar* md5)
{
	MediaSource* result;
#line 289 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 289 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 2698 "MediaDataRepresentation.c"
	{
		GeeIterator* _source_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 290 "../src/MediaDataRepresentation.vala"
		_tmp0_ = self->priv->master_file_map;
#line 290 "../src/MediaDataRepresentation.vala"
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 290 "../src/MediaDataRepresentation.vala"
		_tmp2_ = _tmp1_;
#line 290 "../src/MediaDataRepresentation.vala"
		_tmp3_ = _tmp2_;
#line 290 "../src/MediaDataRepresentation.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 290 "../src/MediaDataRepresentation.vala"
		_tmp5_ = _tmp4_;
#line 290 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp3_);
#line 290 "../src/MediaDataRepresentation.vala"
		_source_it = _tmp5_;
#line 290 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 2725 "MediaDataRepresentation.c"
			GeeIterator* _tmp6_;
			MediaSource* source = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MediaSource* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
#line 290 "../src/MediaDataRepresentation.vala"
			_tmp6_ = _source_it;
#line 290 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 290 "../src/MediaDataRepresentation.vala"
				break;
#line 2740 "MediaDataRepresentation.c"
			}
#line 290 "../src/MediaDataRepresentation.vala"
			_tmp7_ = _source_it;
#line 290 "../src/MediaDataRepresentation.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 290 "../src/MediaDataRepresentation.vala"
			source = (MediaSource*) _tmp8_;
#line 291 "../src/MediaDataRepresentation.vala"
			_tmp9_ = source;
#line 291 "../src/MediaDataRepresentation.vala"
			_tmp10_ = media_source_get_master_md5 (_tmp9_);
#line 291 "../src/MediaDataRepresentation.vala"
			_tmp11_ = _tmp10_;
#line 291 "../src/MediaDataRepresentation.vala"
			_tmp12_ = g_strcmp0 (_tmp11_, md5) == 0;
#line 291 "../src/MediaDataRepresentation.vala"
			_g_free0 (_tmp11_);
#line 291 "../src/MediaDataRepresentation.vala"
			if (_tmp12_) {
#line 292 "../src/MediaDataRepresentation.vala"
				result = source;
#line 292 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_source_it);
#line 292 "../src/MediaDataRepresentation.vala"
				return result;
#line 2766 "MediaDataRepresentation.c"
			}
#line 290 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (source);
#line 2770 "MediaDataRepresentation.c"
		}
#line 290 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_source_it);
#line 2774 "MediaDataRepresentation.c"
	}
#line 296 "../src/MediaDataRepresentation.vala"
	result = NULL;
#line 296 "../src/MediaDataRepresentation.vala"
	return result;
#line 2780 "MediaDataRepresentation.c"
}

static void
_media_source_holding_tank_on_master_source_replaced_media_source_master_replaced (MediaSource* _sender,
                                                                                   GFile* old_file,
                                                                                   GFile* new_file,
                                                                                   gpointer self)
{
#line 305 "../src/MediaDataRepresentation.vala"
	media_source_holding_tank_on_master_source_replaced ((MediaSourceHoldingTank*) self, _sender, old_file, new_file);
#line 2791 "MediaDataRepresentation.c"
}

static void
media_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                        GeeCollection* added,
                                                        GeeCollection* removed)
{
	MediaSourceHoldingTank * self;
#line 299 "../src/MediaDataRepresentation.vala"
	self = (MediaSourceHoldingTank*) base;
#line 301 "../src/MediaDataRepresentation.vala"
	if (added != NULL) {
#line 2804 "MediaDataRepresentation.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp0_;
#line 302 "../src/MediaDataRepresentation.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) added);
#line 302 "../src/MediaDataRepresentation.vala"
			_source_it = _tmp0_;
#line 302 "../src/MediaDataRepresentation.vala"
			while (TRUE) {
#line 2814 "MediaDataRepresentation.c"
				GeeIterator* _tmp1_;
				DataSource* source = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				MediaSource* media_source = NULL;
				DataSource* _tmp4_;
				MediaSource* _tmp5_;
				GeeHashMap* _tmp6_;
				MediaSource* _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
				MediaSource* _tmp10_;
				MediaSource* _tmp11_;
#line 302 "../src/MediaDataRepresentation.vala"
				_tmp1_ = _source_it;
#line 302 "../src/MediaDataRepresentation.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 302 "../src/MediaDataRepresentation.vala"
					break;
#line 2834 "MediaDataRepresentation.c"
				}
#line 302 "../src/MediaDataRepresentation.vala"
				_tmp2_ = _source_it;
#line 302 "../src/MediaDataRepresentation.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 302 "../src/MediaDataRepresentation.vala"
				source = (DataSource*) _tmp3_;
#line 303 "../src/MediaDataRepresentation.vala"
				_tmp4_ = source;
#line 303 "../src/MediaDataRepresentation.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_SOURCE, MediaSource));
#line 303 "../src/MediaDataRepresentation.vala"
				media_source = _tmp5_;
#line 304 "../src/MediaDataRepresentation.vala"
				_tmp6_ = self->priv->master_file_map;
#line 304 "../src/MediaDataRepresentation.vala"
				_tmp7_ = media_source;
#line 304 "../src/MediaDataRepresentation.vala"
				_tmp8_ = media_source_get_master_file (_tmp7_);
#line 304 "../src/MediaDataRepresentation.vala"
				_tmp9_ = _tmp8_;
#line 304 "../src/MediaDataRepresentation.vala"
				_tmp10_ = media_source;
#line 304 "../src/MediaDataRepresentation.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp9_, _tmp10_);
#line 304 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_tmp9_);
#line 305 "../src/MediaDataRepresentation.vala"
				_tmp11_ = media_source;
#line 305 "../src/MediaDataRepresentation.vala"
				g_signal_connect (_tmp11_, "master-replaced", (GCallback) _media_source_holding_tank_on_master_source_replaced_media_source_master_replaced, self);
#line 302 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (media_source);
#line 302 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (source);
#line 2870 "MediaDataRepresentation.c"
			}
#line 302 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (_source_it);
#line 2874 "MediaDataRepresentation.c"
		}
	}
#line 309 "../src/MediaDataRepresentation.vala"
	if (removed != NULL) {
#line 2879 "MediaDataRepresentation.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp12_;
#line 310 "../src/MediaDataRepresentation.vala"
			_tmp12_ = gee_iterable_iterator ((GeeIterable*) removed);
#line 310 "../src/MediaDataRepresentation.vala"
			_source_it = _tmp12_;
#line 310 "../src/MediaDataRepresentation.vala"
			while (TRUE) {
#line 2889 "MediaDataRepresentation.c"
				GeeIterator* _tmp13_;
				DataSource* source = NULL;
				GeeIterator* _tmp14_;
				gpointer _tmp15_;
				MediaSource* media_source = NULL;
				DataSource* _tmp16_;
				MediaSource* _tmp17_;
				gboolean is_removed = FALSE;
				GeeHashMap* _tmp18_;
				MediaSource* _tmp19_;
				GFile* _tmp20_;
				GFile* _tmp21_;
				gboolean _tmp22_;
				MediaSource* _tmp23_;
				guint _tmp24_;
#line 310 "../src/MediaDataRepresentation.vala"
				_tmp13_ = _source_it;
#line 310 "../src/MediaDataRepresentation.vala"
				if (!gee_iterator_next (_tmp13_)) {
#line 310 "../src/MediaDataRepresentation.vala"
					break;
#line 2911 "MediaDataRepresentation.c"
				}
#line 310 "../src/MediaDataRepresentation.vala"
				_tmp14_ = _source_it;
#line 310 "../src/MediaDataRepresentation.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 310 "../src/MediaDataRepresentation.vala"
				source = (DataSource*) _tmp15_;
#line 311 "../src/MediaDataRepresentation.vala"
				_tmp16_ = source;
#line 311 "../src/MediaDataRepresentation.vala"
				_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_MEDIA_SOURCE, MediaSource));
#line 311 "../src/MediaDataRepresentation.vala"
				media_source = _tmp17_;
#line 312 "../src/MediaDataRepresentation.vala"
				_tmp18_ = self->priv->master_file_map;
#line 312 "../src/MediaDataRepresentation.vala"
				_tmp19_ = media_source;
#line 312 "../src/MediaDataRepresentation.vala"
				_tmp20_ = media_source_get_master_file (_tmp19_);
#line 312 "../src/MediaDataRepresentation.vala"
				_tmp21_ = _tmp20_;
#line 312 "../src/MediaDataRepresentation.vala"
				_tmp22_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp18_, _tmp21_, NULL);
#line 312 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_tmp21_);
#line 312 "../src/MediaDataRepresentation.vala"
				is_removed = _tmp22_;
#line 313 "../src/MediaDataRepresentation.vala"
				_vala_assert (is_removed, "is_removed");
#line 314 "../src/MediaDataRepresentation.vala"
				_tmp23_ = media_source;
#line 314 "../src/MediaDataRepresentation.vala"
				g_signal_parse_name ("master-replaced", TYPE_MEDIA_SOURCE, &_tmp24_, NULL, FALSE);
#line 314 "../src/MediaDataRepresentation.vala"
				g_signal_handlers_disconnect_matched (_tmp23_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp24_, 0, NULL, (GCallback) _media_source_holding_tank_on_master_source_replaced_media_source_master_replaced, self);
#line 310 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (media_source);
#line 310 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (source);
#line 2951 "MediaDataRepresentation.c"
			}
#line 310 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (_source_it);
#line 2955 "MediaDataRepresentation.c"
		}
	}
#line 318 "../src/MediaDataRepresentation.vala"
	SOURCE_HOLDING_TANK_CLASS (media_source_holding_tank_parent_class)->notify_contents_altered ((SourceHoldingTank*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank), added, removed);
#line 2960 "MediaDataRepresentation.c"
}

static void
media_source_holding_tank_on_master_source_replaced (MediaSourceHoldingTank* self,
                                                     MediaSource* media_source,
                                                     GFile* old_file,
                                                     GFile* new_file)
{
	gboolean removed = FALSE;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 321 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media_source != NULL);
#line 321 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (old_file != NULL);
#line 321 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (new_file != NULL);
#line 322 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->master_file_map;
#line 322 "../src/MediaDataRepresentation.vala"
	removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, old_file, NULL);
#line 323 "../src/MediaDataRepresentation.vala"
	_vala_assert (removed, "removed");
#line 325 "../src/MediaDataRepresentation.vala"
	_tmp1_ = self->priv->master_file_map;
#line 325 "../src/MediaDataRepresentation.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, new_file, media_source);
#line 2990 "MediaDataRepresentation.c"
}

static void
media_source_holding_tank_class_init (MediaSourceHoldingTankClass * klass,
                                      gpointer klass_data)
{
#line 276 "../src/MediaDataRepresentation.vala"
	media_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 276 "../src/MediaDataRepresentation.vala"
	((SourceHoldingTankClass *) klass)->finalize = media_source_holding_tank_finalize;
#line 276 "../src/MediaDataRepresentation.vala"
	g_type_class_adjust_private_offset (klass, &MediaSourceHoldingTank_private_offset);
#line 276 "../src/MediaDataRepresentation.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank*, GeeCollection*, GeeCollection*)) media_source_holding_tank_real_notify_contents_altered;
#line 3005 "MediaDataRepresentation.c"
}

static void
media_source_holding_tank_instance_init (MediaSourceHoldingTank * self,
                                         gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 276 "../src/MediaDataRepresentation.vala"
	self->priv = media_source_holding_tank_get_instance_private (self);
#line 277 "../src/MediaDataRepresentation.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 277 "../src/MediaDataRepresentation.vala"
	self->priv->master_file_map = _tmp0_;
#line 3019 "MediaDataRepresentation.c"
}

static void
media_source_holding_tank_finalize (SourceHoldingTank * obj)
{
	MediaSourceHoldingTank * self;
#line 276 "../src/MediaDataRepresentation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 277 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->master_file_map);
#line 276 "../src/MediaDataRepresentation.vala"
	SOURCE_HOLDING_TANK_CLASS (media_source_holding_tank_parent_class)->finalize (obj);
#line 3032 "MediaDataRepresentation.c"
}

static GType
media_source_holding_tank_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaSourceHoldingTank), 0, (GInstanceInitFunc) media_source_holding_tank_instance_init, NULL };
	GType media_source_holding_tank_type_id;
	media_source_holding_tank_type_id = g_type_register_static (TYPE_DATABASE_SOURCE_HOLDING_TANK, "MediaSourceHoldingTank", &g_define_type_info, 0);
	MediaSourceHoldingTank_private_offset = g_type_add_instance_private (media_source_holding_tank_type_id, sizeof (MediaSourceHoldingTankPrivate));
	return media_source_holding_tank_type_id;
}

GType
media_source_holding_tank_get_type (void)
{
	static volatile gsize media_source_holding_tank_type_id__once = 0;
	if (g_once_init_enter (&media_source_holding_tank_type_id__once)) {
		GType media_source_holding_tank_type_id;
		media_source_holding_tank_type_id = media_source_holding_tank_get_type_once ();
		g_once_init_leave (&media_source_holding_tank_type_id__once, media_source_holding_tank_type_id);
	}
	return media_source_holding_tank_type_id__once;
}

static inline gpointer
media_source_transaction_controller_get_instance_private (MediaSourceTransactionController* self)
{
	return G_STRUCT_MEMBER_P (self, MediaSourceTransactionController_private_offset);
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 335 "../src/MediaDataRepresentation.vala"
	return self ? data_collection_ref (self) : NULL;
#line 3068 "MediaDataRepresentation.c"
}

MediaSourceTransactionController*
media_source_transaction_controller_construct (GType object_type,
                                               MediaSourceCollection* sources)
{
	MediaSourceTransactionController* self = NULL;
	MediaSourceCollection* _tmp0_;
#line 334 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 334 "../src/MediaDataRepresentation.vala"
	self = (MediaSourceTransactionController*) transaction_controller_construct (object_type);
#line 335 "../src/MediaDataRepresentation.vala"
	_tmp0_ = _data_collection_ref0 (sources);
#line 335 "../src/MediaDataRepresentation.vala"
	_data_collection_unref0 (self->priv->sources);
#line 335 "../src/MediaDataRepresentation.vala"
	self->priv->sources = _tmp0_;
#line 334 "../src/MediaDataRepresentation.vala"
	return self;
#line 3089 "MediaDataRepresentation.c"
}

MediaSourceTransactionController*
media_source_transaction_controller_new (MediaSourceCollection* sources)
{
#line 334 "../src/MediaDataRepresentation.vala"
	return media_source_transaction_controller_construct (TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, sources);
#line 3097 "MediaDataRepresentation.c"
}

static void
media_source_transaction_controller_real_begin_impl (TransactionController* base,
                                                     GError** error)
{
	MediaSourceTransactionController * self;
	MediaSourceCollection* _tmp0_;
#line 338 "../src/MediaDataRepresentation.vala"
	self = (MediaSourceTransactionController*) base;
#line 339 "../src/MediaDataRepresentation.vala"
	database_table_begin_transaction ();
#line 340 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->sources;
#line 340 "../src/MediaDataRepresentation.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp0_);
#line 3114 "MediaDataRepresentation.c"
}

static void
media_source_transaction_controller_real_commit_impl (TransactionController* base,
                                                      GError** error)
{
	MediaSourceTransactionController * self;
	MediaSourceCollection* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 343 "../src/MediaDataRepresentation.vala"
	self = (MediaSourceTransactionController*) base;
#line 344 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->sources;
#line 344 "../src/MediaDataRepresentation.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp0_);
#line 345 "../src/MediaDataRepresentation.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 345 "../src/MediaDataRepresentation.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 345 "../src/MediaDataRepresentation.vala"
		g_propagate_error (error, _inner_error0_);
#line 345 "../src/MediaDataRepresentation.vala"
		return;
#line 3138 "MediaDataRepresentation.c"
	}
}

static void
media_source_transaction_controller_class_init (MediaSourceTransactionControllerClass * klass,
                                                gpointer klass_data)
{
#line 331 "../src/MediaDataRepresentation.vala"
	media_source_transaction_controller_parent_class = g_type_class_peek_parent (klass);
#line 331 "../src/MediaDataRepresentation.vala"
	((TransactionControllerClass *) klass)->finalize = media_source_transaction_controller_finalize;
#line 331 "../src/MediaDataRepresentation.vala"
	g_type_class_adjust_private_offset (klass, &MediaSourceTransactionController_private_offset);
#line 331 "../src/MediaDataRepresentation.vala"
	((TransactionControllerClass *) klass)->begin_impl = (void (*) (TransactionController*, GError**)) media_source_transaction_controller_real_begin_impl;
#line 331 "../src/MediaDataRepresentation.vala"
	((TransactionControllerClass *) klass)->commit_impl = (void (*) (TransactionController*, GError**)) media_source_transaction_controller_real_commit_impl;
#line 3156 "MediaDataRepresentation.c"
}

static void
media_source_transaction_controller_instance_init (MediaSourceTransactionController * self,
                                                   gpointer klass)
{
#line 331 "../src/MediaDataRepresentation.vala"
	self->priv = media_source_transaction_controller_get_instance_private (self);
#line 3165 "MediaDataRepresentation.c"
}

static void
media_source_transaction_controller_finalize (TransactionController * obj)
{
	MediaSourceTransactionController * self;
#line 331 "../src/MediaDataRepresentation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController);
#line 332 "../src/MediaDataRepresentation.vala"
	_data_collection_unref0 (self->priv->sources);
#line 331 "../src/MediaDataRepresentation.vala"
	TRANSACTION_CONTROLLER_CLASS (media_source_transaction_controller_parent_class)->finalize (obj);
#line 3178 "MediaDataRepresentation.c"
}

static GType
media_source_transaction_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaSourceTransactionControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_source_transaction_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaSourceTransactionController), 0, (GInstanceInitFunc) media_source_transaction_controller_instance_init, NULL };
	GType media_source_transaction_controller_type_id;
	media_source_transaction_controller_type_id = g_type_register_static (TYPE_TRANSACTION_CONTROLLER, "MediaSourceTransactionController", &g_define_type_info, 0);
	MediaSourceTransactionController_private_offset = g_type_add_instance_private (media_source_transaction_controller_type_id, sizeof (MediaSourceTransactionControllerPrivate));
	return media_source_transaction_controller_type_id;
}

GType
media_source_transaction_controller_get_type (void)
{
	static volatile gsize media_source_transaction_controller_type_id__once = 0;
	if (g_once_init_enter (&media_source_transaction_controller_type_id__once)) {
		GType media_source_transaction_controller_type_id;
		media_source_transaction_controller_type_id = media_source_transaction_controller_get_type_once ();
		g_once_init_leave (&media_source_transaction_controller_type_id__once, media_source_transaction_controller_type_id);
	}
	return media_source_transaction_controller_type_id__once;
}

static inline gpointer
media_source_collection_get_instance_private (MediaSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, MediaSourceCollection_private_offset);
}

static gint
_import_id_compare_func_gcompare_data_func (gconstpointer a,
                                            gconstpointer b,
                                            gpointer self)
{
	gint result;
	result = import_id_compare_func ((ImportID*) a, (ImportID*) b);
#line 358 "../src/MediaDataRepresentation.vala"
	return result;
#line 3218 "MediaDataRepresentation.c"
}

MediaSourceCollection*
media_source_collection_construct (GType object_type,
                                   const gchar* name,
                                   GetSourceDatabaseKey source_key_func,
                                   gpointer source_key_func_target)
{
	MediaSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
#line 392 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 393 "../src/MediaDataRepresentation.vala"
	self = (MediaSourceCollection*) database_source_collection_construct (object_type, name, source_key_func, source_key_func_target);
#line 395 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_collection_create_trashcan (self);
#line 395 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (self->priv->trashcan);
#line 395 "../src/MediaDataRepresentation.vala"
	self->priv->trashcan = _tmp0_;
#line 396 "../src/MediaDataRepresentation.vala"
	_tmp1_ = media_source_collection_create_offline_bin (self);
#line 396 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (self->priv->offline_bin);
#line 396 "../src/MediaDataRepresentation.vala"
	self->priv->offline_bin = _tmp1_;
#line 392 "../src/MediaDataRepresentation.vala"
	return self;
#line 3248 "MediaDataRepresentation.c"
}

void
media_source_collection_filter_media (GeeCollection* media,
                                      GeeCollection* photos,
                                      GeeCollection* videos)
{
#line 399 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 3258 "MediaDataRepresentation.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 401 "../src/MediaDataRepresentation.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) media);
#line 401 "../src/MediaDataRepresentation.vala"
		_source_it = _tmp0_;
#line 401 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 3268 "MediaDataRepresentation.c"
			GeeIterator* _tmp1_;
			MediaSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			gboolean _tmp4_ = FALSE;
#line 401 "../src/MediaDataRepresentation.vala"
			_tmp1_ = _source_it;
#line 401 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 401 "../src/MediaDataRepresentation.vala"
				break;
#line 3280 "MediaDataRepresentation.c"
			}
#line 401 "../src/MediaDataRepresentation.vala"
			_tmp2_ = _source_it;
#line 401 "../src/MediaDataRepresentation.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 401 "../src/MediaDataRepresentation.vala"
			source = (MediaSource*) _tmp3_;
#line 402 "../src/MediaDataRepresentation.vala"
			if (photos != NULL) {
#line 3290 "MediaDataRepresentation.c"
				MediaSource* _tmp5_;
#line 402 "../src/MediaDataRepresentation.vala"
				_tmp5_ = source;
#line 402 "../src/MediaDataRepresentation.vala"
				_tmp4_ = IS_LIBRARY_PHOTO (_tmp5_);
#line 3296 "MediaDataRepresentation.c"
			} else {
#line 402 "../src/MediaDataRepresentation.vala"
				_tmp4_ = FALSE;
#line 3300 "MediaDataRepresentation.c"
			}
#line 402 "../src/MediaDataRepresentation.vala"
			if (_tmp4_) {
#line 3304 "MediaDataRepresentation.c"
				MediaSource* _tmp6_;
#line 403 "../src/MediaDataRepresentation.vala"
				_tmp6_ = source;
#line 403 "../src/MediaDataRepresentation.vala"
				gee_collection_add (photos, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 3310 "MediaDataRepresentation.c"
			} else {
				gboolean _tmp7_ = FALSE;
#line 404 "../src/MediaDataRepresentation.vala"
				if (videos != NULL) {
#line 3315 "MediaDataRepresentation.c"
					MediaSource* _tmp8_;
#line 404 "../src/MediaDataRepresentation.vala"
					_tmp8_ = source;
#line 404 "../src/MediaDataRepresentation.vala"
					_tmp7_ = IS_VIDEO (_tmp8_);
#line 3321 "MediaDataRepresentation.c"
				} else {
#line 404 "../src/MediaDataRepresentation.vala"
					_tmp7_ = FALSE;
#line 3325 "MediaDataRepresentation.c"
				}
#line 404 "../src/MediaDataRepresentation.vala"
				if (_tmp7_) {
#line 3329 "MediaDataRepresentation.c"
					MediaSource* _tmp9_;
#line 405 "../src/MediaDataRepresentation.vala"
					_tmp9_ = source;
#line 405 "../src/MediaDataRepresentation.vala"
					gee_collection_add (videos, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_VIDEO, Video));
#line 3335 "MediaDataRepresentation.c"
				} else {
					gboolean _tmp10_ = FALSE;
#line 406 "../src/MediaDataRepresentation.vala"
					if (photos != NULL) {
#line 406 "../src/MediaDataRepresentation.vala"
						_tmp10_ = TRUE;
#line 3342 "MediaDataRepresentation.c"
					} else {
#line 406 "../src/MediaDataRepresentation.vala"
						_tmp10_ = videos != NULL;
#line 3346 "MediaDataRepresentation.c"
					}
#line 406 "../src/MediaDataRepresentation.vala"
					if (_tmp10_) {
#line 3350 "MediaDataRepresentation.c"
						MediaSource* _tmp11_;
						gchar* _tmp12_;
						gchar* _tmp13_;
#line 407 "../src/MediaDataRepresentation.vala"
						_tmp11_ = source;
#line 407 "../src/MediaDataRepresentation.vala"
						_tmp12_ = data_object_to_string ((DataObject*) _tmp11_);
#line 407 "../src/MediaDataRepresentation.vala"
						_tmp13_ = _tmp12_;
#line 407 "../src/MediaDataRepresentation.vala"
						g_warning ("MediaDataRepresentation.vala:407: Unrecognized media: %s", _tmp13_);
#line 407 "../src/MediaDataRepresentation.vala"
						_g_free0 (_tmp13_);
#line 3364 "MediaDataRepresentation.c"
					}
				}
			}
#line 401 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (source);
#line 3370 "MediaDataRepresentation.c"
		}
#line 401 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_source_it);
#line 3374 "MediaDataRepresentation.c"
	}
}

void
media_source_collection_count_media (GeeCollection* media,
                                     gint* photo_count,
                                     gint* video_count)
{
	gint _vala_photo_count = 0;
	gint _vala_video_count = 0;
	GeeArrayList* photos = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* videos = NULL;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 411 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 413 "../src/MediaDataRepresentation.vala"
	_tmp0_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 413 "../src/MediaDataRepresentation.vala"
	photos = _tmp0_;
#line 414 "../src/MediaDataRepresentation.vala"
	_tmp1_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 414 "../src/MediaDataRepresentation.vala"
	videos = _tmp1_;
#line 416 "../src/MediaDataRepresentation.vala"
	media_source_collection_filter_media (media, (GeeCollection*) photos, (GeeCollection*) videos);
#line 418 "../src/MediaDataRepresentation.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) photos);
#line 418 "../src/MediaDataRepresentation.vala"
	_tmp3_ = _tmp2_;
#line 418 "../src/MediaDataRepresentation.vala"
	_vala_photo_count = _tmp3_;
#line 419 "../src/MediaDataRepresentation.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) videos);
#line 419 "../src/MediaDataRepresentation.vala"
	_tmp5_ = _tmp4_;
#line 419 "../src/MediaDataRepresentation.vala"
	_vala_video_count = _tmp5_;
#line 411 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (videos);
#line 411 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (photos);
#line 411 "../src/MediaDataRepresentation.vala"
	if (photo_count) {
#line 411 "../src/MediaDataRepresentation.vala"
		*photo_count = _vala_photo_count;
#line 3425 "MediaDataRepresentation.c"
	}
#line 411 "../src/MediaDataRepresentation.vala"
	if (video_count) {
#line 411 "../src/MediaDataRepresentation.vala"
		*video_count = _vala_video_count;
#line 3431 "MediaDataRepresentation.c"
	}
}

gboolean
media_source_collection_has_photo (GeeCollection* media)
{
	gboolean result;
#line 422 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (media != NULL, FALSE);
#line 3441 "MediaDataRepresentation.c"
	{
		GeeIterator* _current_media_it = NULL;
		GeeIterator* _tmp0_;
#line 423 "../src/MediaDataRepresentation.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) media);
#line 423 "../src/MediaDataRepresentation.vala"
		_current_media_it = _tmp0_;
#line 423 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 3451 "MediaDataRepresentation.c"
			GeeIterator* _tmp1_;
			MediaSource* current_media = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			MediaSource* _tmp4_;
#line 423 "../src/MediaDataRepresentation.vala"
			_tmp1_ = _current_media_it;
#line 423 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 423 "../src/MediaDataRepresentation.vala"
				break;
#line 3463 "MediaDataRepresentation.c"
			}
#line 423 "../src/MediaDataRepresentation.vala"
			_tmp2_ = _current_media_it;
#line 423 "../src/MediaDataRepresentation.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 423 "../src/MediaDataRepresentation.vala"
			current_media = (MediaSource*) _tmp3_;
#line 424 "../src/MediaDataRepresentation.vala"
			_tmp4_ = current_media;
#line 424 "../src/MediaDataRepresentation.vala"
			if (IS_PHOTO (_tmp4_)) {
#line 425 "../src/MediaDataRepresentation.vala"
				result = TRUE;
#line 425 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (current_media);
#line 425 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_current_media_it);
#line 425 "../src/MediaDataRepresentation.vala"
				return result;
#line 3483 "MediaDataRepresentation.c"
			}
#line 423 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (current_media);
#line 3487 "MediaDataRepresentation.c"
		}
#line 423 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_current_media_it);
#line 3491 "MediaDataRepresentation.c"
	}
#line 429 "../src/MediaDataRepresentation.vala"
	result = FALSE;
#line 429 "../src/MediaDataRepresentation.vala"
	return result;
#line 3497 "MediaDataRepresentation.c"
}

gboolean
media_source_collection_has_video (GeeCollection* media)
{
	gboolean result;
#line 432 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (media != NULL, FALSE);
#line 3506 "MediaDataRepresentation.c"
	{
		GeeIterator* _current_media_it = NULL;
		GeeIterator* _tmp0_;
#line 433 "../src/MediaDataRepresentation.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) media);
#line 433 "../src/MediaDataRepresentation.vala"
		_current_media_it = _tmp0_;
#line 433 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 3516 "MediaDataRepresentation.c"
			GeeIterator* _tmp1_;
			MediaSource* current_media = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			MediaSource* _tmp4_;
#line 433 "../src/MediaDataRepresentation.vala"
			_tmp1_ = _current_media_it;
#line 433 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 433 "../src/MediaDataRepresentation.vala"
				break;
#line 3528 "MediaDataRepresentation.c"
			}
#line 433 "../src/MediaDataRepresentation.vala"
			_tmp2_ = _current_media_it;
#line 433 "../src/MediaDataRepresentation.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 433 "../src/MediaDataRepresentation.vala"
			current_media = (MediaSource*) _tmp3_;
#line 434 "../src/MediaDataRepresentation.vala"
			_tmp4_ = current_media;
#line 434 "../src/MediaDataRepresentation.vala"
			if (IS_VIDEO (_tmp4_)) {
#line 435 "../src/MediaDataRepresentation.vala"
				result = TRUE;
#line 435 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (current_media);
#line 435 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_current_media_it);
#line 435 "../src/MediaDataRepresentation.vala"
				return result;
#line 3548 "MediaDataRepresentation.c"
			}
#line 433 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (current_media);
#line 3552 "MediaDataRepresentation.c"
		}
#line 433 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_current_media_it);
#line 3556 "MediaDataRepresentation.c"
	}
#line 439 "../src/MediaDataRepresentation.vala"
	result = FALSE;
#line 439 "../src/MediaDataRepresentation.vala"
	return result;
#line 3562 "MediaDataRepresentation.c"
}

static MediaSourceHoldingTank*
media_source_collection_real_create_trashcan (MediaSourceCollection* self)
{
#line 442 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_collection_create_trashcan'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 442 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3572 "MediaDataRepresentation.c"
}

MediaSourceHoldingTank*
media_source_collection_create_trashcan (MediaSourceCollection* self)
{
	MediaSourceCollectionClass* _klass_;
#line 442 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 442 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 442 "../src/MediaDataRepresentation.vala"
	if (_klass_->create_trashcan) {
#line 442 "../src/MediaDataRepresentation.vala"
		return _klass_->create_trashcan (self);
#line 3587 "MediaDataRepresentation.c"
	}
#line 442 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3591 "MediaDataRepresentation.c"
}

static MediaSourceHoldingTank*
media_source_collection_real_create_offline_bin (MediaSourceCollection* self)
{
#line 444 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_collection_create_offline_bin'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 444 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3601 "MediaDataRepresentation.c"
}

MediaSourceHoldingTank*
media_source_collection_create_offline_bin (MediaSourceCollection* self)
{
	MediaSourceCollectionClass* _klass_;
#line 444 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 444 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 444 "../src/MediaDataRepresentation.vala"
	if (_klass_->create_offline_bin) {
#line 444 "../src/MediaDataRepresentation.vala"
		return _klass_->create_offline_bin (self);
#line 3616 "MediaDataRepresentation.c"
	}
#line 444 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3620 "MediaDataRepresentation.c"
}

static MediaMonitor*
media_source_collection_real_create_media_monitor (MediaSourceCollection* self,
                                                   Workers* workers,
                                                   GCancellable* cancellable)
{
#line 446 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_collection_create_media_monitor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 446 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3632 "MediaDataRepresentation.c"
}

MediaMonitor*
media_source_collection_create_media_monitor (MediaSourceCollection* self,
                                              Workers* workers,
                                              GCancellable* cancellable)
{
	MediaSourceCollectionClass* _klass_;
#line 446 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 446 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 446 "../src/MediaDataRepresentation.vala"
	if (_klass_->create_media_monitor) {
#line 446 "../src/MediaDataRepresentation.vala"
		return _klass_->create_media_monitor (self, workers, cancellable);
#line 3649 "MediaDataRepresentation.c"
	}
#line 446 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3653 "MediaDataRepresentation.c"
}

static gchar*
media_source_collection_real_get_typename (MediaSourceCollection* self)
{
#line 448 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_collection_get_typename'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 448 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3663 "MediaDataRepresentation.c"
}

gchar*
media_source_collection_get_typename (MediaSourceCollection* self)
{
	MediaSourceCollectionClass* _klass_;
#line 448 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 448 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 448 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_typename) {
#line 448 "../src/MediaDataRepresentation.vala"
		return _klass_->get_typename (self);
#line 3678 "MediaDataRepresentation.c"
	}
#line 448 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3682 "MediaDataRepresentation.c"
}

static gboolean
media_source_collection_real_is_file_recognized (MediaSourceCollection* self,
                                                 GFile* file)
{
	gboolean _tmp0_ = FALSE;
#line 450 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_collection_is_file_recognized'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 450 "../src/MediaDataRepresentation.vala"
	return _tmp0_;
#line 3694 "MediaDataRepresentation.c"
}

gboolean
media_source_collection_is_file_recognized (MediaSourceCollection* self,
                                            GFile* file)
{
	MediaSourceCollectionClass* _klass_;
#line 450 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 450 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 450 "../src/MediaDataRepresentation.vala"
	if (_klass_->is_file_recognized) {
#line 450 "../src/MediaDataRepresentation.vala"
		return _klass_->is_file_recognized (self, file);
#line 3710 "MediaDataRepresentation.c"
	}
#line 450 "../src/MediaDataRepresentation.vala"
	return FALSE;
#line 3714 "MediaDataRepresentation.c"
}

static gpointer
_source_holding_tank_ref0 (gpointer self)
{
#line 453 "../src/MediaDataRepresentation.vala"
	return self ? source_holding_tank_ref (self) : NULL;
#line 3722 "MediaDataRepresentation.c"
}

MediaSourceHoldingTank*
media_source_collection_get_trashcan (MediaSourceCollection* self)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* result;
#line 452 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 453 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->trashcan;
#line 453 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _source_holding_tank_ref0 (_tmp0_);
#line 453 "../src/MediaDataRepresentation.vala"
	result = _tmp1_;
#line 453 "../src/MediaDataRepresentation.vala"
	return result;
#line 3741 "MediaDataRepresentation.c"
}

MediaSourceHoldingTank*
media_source_collection_get_offline_bin (MediaSourceCollection* self)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* result;
#line 456 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 457 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->offline_bin;
#line 457 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _source_holding_tank_ref0 (_tmp0_);
#line 457 "../src/MediaDataRepresentation.vala"
	result = _tmp1_;
#line 457 "../src/MediaDataRepresentation.vala"
	return result;
#line 3760 "MediaDataRepresentation.c"
}

static MediaSource*
media_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* self,
                                                  gint64 numeric_id)
{
#line 463 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_collection_fetch_by_numeric_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 463 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3771 "MediaDataRepresentation.c"
}

MediaSource*
media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self,
                                             gint64 numeric_id)
{
	MediaSourceCollectionClass* _klass_;
#line 463 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 463 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 463 "../src/MediaDataRepresentation.vala"
	if (_klass_->fetch_by_numeric_id) {
#line 463 "../src/MediaDataRepresentation.vala"
		return _klass_->fetch_by_numeric_id (self, numeric_id);
#line 3787 "MediaDataRepresentation.c"
	}
#line 463 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 3791 "MediaDataRepresentation.c"
}

static void
media_source_collection_real_notify_import_roll_altered (MediaSourceCollection* self)
{
#line 466 "../src/MediaDataRepresentation.vala"
	g_signal_emit (self, media_source_collection_signals[MEDIA_SOURCE_COLLECTION_IMPORT_ROLL_ALTERED_SIGNAL], 0);
#line 3799 "MediaDataRepresentation.c"
}

void
media_source_collection_notify_import_roll_altered (MediaSourceCollection* self)
{
	MediaSourceCollectionClass* _klass_;
#line 465 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 465 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 465 "../src/MediaDataRepresentation.vala"
	if (_klass_->notify_import_roll_altered) {
#line 465 "../src/MediaDataRepresentation.vala"
		_klass_->notify_import_roll_altered (self);
#line 3814 "MediaDataRepresentation.c"
	}
}

static void
media_source_collection_real_notify_flagged_contents_altered (MediaSourceCollection* self)
{
#line 470 "../src/MediaDataRepresentation.vala"
	g_signal_emit (self, media_source_collection_signals[MEDIA_SOURCE_COLLECTION_FLAGGED_CONTENTS_ALTERED_SIGNAL], 0);
#line 3823 "MediaDataRepresentation.c"
}

void
media_source_collection_notify_flagged_contents_altered (MediaSourceCollection* self)
{
	MediaSourceCollectionClass* _klass_;
#line 469 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 469 "../src/MediaDataRepresentation.vala"
	if (_klass_->notify_flagged_contents_altered) {
#line 469 "../src/MediaDataRepresentation.vala"
		_klass_->notify_flagged_contents_altered (self);
#line 3838 "MediaDataRepresentation.c"
	}
}

static void
media_source_collection_real_notify_media_import_starting (MediaSourceCollection* self,
                                                           GeeCollection* media)
{
#line 473 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 474 "../src/MediaDataRepresentation.vala"
	g_signal_emit (self, media_source_collection_signals[MEDIA_SOURCE_COLLECTION_MEDIA_IMPORT_STARTING_SIGNAL], 0, media);
#line 3850 "MediaDataRepresentation.c"
}

void
media_source_collection_notify_media_import_starting (MediaSourceCollection* self,
                                                      GeeCollection* media)
{
	MediaSourceCollectionClass* _klass_;
#line 473 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 473 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 473 "../src/MediaDataRepresentation.vala"
	if (_klass_->notify_media_import_starting) {
#line 473 "../src/MediaDataRepresentation.vala"
		_klass_->notify_media_import_starting (self, media);
#line 3866 "MediaDataRepresentation.c"
	}
}

static void
media_source_collection_real_notify_media_import_completed (MediaSourceCollection* self,
                                                            GeeCollection* media)
{
#line 477 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 478 "../src/MediaDataRepresentation.vala"
	g_signal_emit (self, media_source_collection_signals[MEDIA_SOURCE_COLLECTION_MEDIA_IMPORT_COMPLETED_SIGNAL], 0, media);
#line 3878 "MediaDataRepresentation.c"
}

void
media_source_collection_notify_media_import_completed (MediaSourceCollection* self,
                                                       GeeCollection* media)
{
	MediaSourceCollectionClass* _klass_;
#line 477 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 477 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 477 "../src/MediaDataRepresentation.vala"
	if (_klass_->notify_media_import_completed) {
#line 477 "../src/MediaDataRepresentation.vala"
		_klass_->notify_media_import_completed (self, media);
#line 3894 "MediaDataRepresentation.c"
	}
}

static void
media_source_collection_real_items_altered (DataCollection* base,
                                            GeeMap* items)
{
	MediaSourceCollection * self;
	GeeArrayList* to_trashcan = NULL;
	GeeArrayList* to_offline = NULL;
	gboolean flagged_altered = FALSE;
	GeeArrayList* _tmp41_;
	GeeArrayList* _tmp45_;
#line 481 "../src/MediaDataRepresentation.vala"
	self = (MediaSourceCollection*) base;
#line 481 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (items != NULL);
#line 482 "../src/MediaDataRepresentation.vala"
	to_trashcan = NULL;
#line 483 "../src/MediaDataRepresentation.vala"
	to_offline = NULL;
#line 484 "../src/MediaDataRepresentation.vala"
	flagged_altered = FALSE;
#line 3918 "MediaDataRepresentation.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 485 "../src/MediaDataRepresentation.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 485 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp0_;
#line 485 "../src/MediaDataRepresentation.vala"
		_tmp2_ = _tmp1_;
#line 485 "../src/MediaDataRepresentation.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 485 "../src/MediaDataRepresentation.vala"
		_tmp4_ = _tmp3_;
#line 485 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp2_);
#line 485 "../src/MediaDataRepresentation.vala"
		_object_it = _tmp4_;
#line 485 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 3942 "MediaDataRepresentation.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			MediaSource* source = NULL;
			DataObject* _tmp10_;
			MediaSource* _tmp11_;
			Alteration* _tmp12_;
			gboolean _tmp13_ = FALSE;
			MediaSource* _tmp14_;
			gboolean _tmp22_ = FALSE;
			MediaSource* _tmp23_;
			Flaggable* flaggable = NULL;
			MediaSource* _tmp31_;
			Flaggable* _tmp32_;
			Flaggable* _tmp33_;
#line 485 "../src/MediaDataRepresentation.vala"
			_tmp5_ = _object_it;
#line 485 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 485 "../src/MediaDataRepresentation.vala"
				break;
#line 3968 "MediaDataRepresentation.c"
			}
#line 485 "../src/MediaDataRepresentation.vala"
			_tmp6_ = _object_it;
#line 485 "../src/MediaDataRepresentation.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 485 "../src/MediaDataRepresentation.vala"
			object = (DataObject*) _tmp7_;
#line 486 "../src/MediaDataRepresentation.vala"
			_tmp8_ = object;
#line 486 "../src/MediaDataRepresentation.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 486 "../src/MediaDataRepresentation.vala"
			alteration = (Alteration*) _tmp9_;
#line 487 "../src/MediaDataRepresentation.vala"
			_tmp10_ = object;
#line 487 "../src/MediaDataRepresentation.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_MEDIA_SOURCE, MediaSource));
#line 487 "../src/MediaDataRepresentation.vala"
			source = _tmp11_;
#line 489 "../src/MediaDataRepresentation.vala"
			_tmp12_ = alteration;
#line 489 "../src/MediaDataRepresentation.vala"
			if (!alteration_has_subject (_tmp12_, "metadata")) {
#line 490 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (source);
#line 490 "../src/MediaDataRepresentation.vala"
				_alteration_unref0 (alteration);
#line 490 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (object);
#line 490 "../src/MediaDataRepresentation.vala"
				continue;
#line 4000 "MediaDataRepresentation.c"
			}
#line 492 "../src/MediaDataRepresentation.vala"
			_tmp14_ = source;
#line 492 "../src/MediaDataRepresentation.vala"
			if (media_source_is_trashed (_tmp14_)) {
#line 4006 "MediaDataRepresentation.c"
				MediaSourceHoldingTank* _tmp15_;
				MediaSourceHoldingTank* _tmp16_;
				MediaSource* _tmp17_;
#line 492 "../src/MediaDataRepresentation.vala"
				_tmp15_ = media_source_collection_get_trashcan (self);
#line 492 "../src/MediaDataRepresentation.vala"
				_tmp16_ = _tmp15_;
#line 492 "../src/MediaDataRepresentation.vala"
				_tmp17_ = source;
#line 492 "../src/MediaDataRepresentation.vala"
				_tmp13_ = !source_holding_tank_contains ((SourceHoldingTank*) _tmp16_, (DataSource*) _tmp17_);
#line 492 "../src/MediaDataRepresentation.vala"
				_source_holding_tank_unref0 (_tmp16_);
#line 4020 "MediaDataRepresentation.c"
			} else {
#line 492 "../src/MediaDataRepresentation.vala"
				_tmp13_ = FALSE;
#line 4024 "MediaDataRepresentation.c"
			}
#line 492 "../src/MediaDataRepresentation.vala"
			if (_tmp13_) {
#line 4028 "MediaDataRepresentation.c"
				GeeArrayList* _tmp18_;
				GeeArrayList* _tmp20_;
				MediaSource* _tmp21_;
#line 493 "../src/MediaDataRepresentation.vala"
				_tmp18_ = to_trashcan;
#line 493 "../src/MediaDataRepresentation.vala"
				if (_tmp18_ == NULL) {
#line 4036 "MediaDataRepresentation.c"
					GeeArrayList* _tmp19_;
#line 494 "../src/MediaDataRepresentation.vala"
					_tmp19_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 494 "../src/MediaDataRepresentation.vala"
					_g_object_unref0 (to_trashcan);
#line 494 "../src/MediaDataRepresentation.vala"
					to_trashcan = _tmp19_;
#line 4044 "MediaDataRepresentation.c"
				}
#line 496 "../src/MediaDataRepresentation.vala"
				_tmp20_ = to_trashcan;
#line 496 "../src/MediaDataRepresentation.vala"
				_tmp21_ = source;
#line 496 "../src/MediaDataRepresentation.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 499 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (source);
#line 499 "../src/MediaDataRepresentation.vala"
				_alteration_unref0 (alteration);
#line 499 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (object);
#line 499 "../src/MediaDataRepresentation.vala"
				continue;
#line 4060 "MediaDataRepresentation.c"
			}
#line 502 "../src/MediaDataRepresentation.vala"
			_tmp23_ = source;
#line 502 "../src/MediaDataRepresentation.vala"
			if (media_source_is_offline (_tmp23_)) {
#line 4066 "MediaDataRepresentation.c"
				MediaSourceHoldingTank* _tmp24_;
				MediaSourceHoldingTank* _tmp25_;
				MediaSource* _tmp26_;
#line 502 "../src/MediaDataRepresentation.vala"
				_tmp24_ = media_source_collection_get_offline_bin (self);
#line 502 "../src/MediaDataRepresentation.vala"
				_tmp25_ = _tmp24_;
#line 502 "../src/MediaDataRepresentation.vala"
				_tmp26_ = source;
#line 502 "../src/MediaDataRepresentation.vala"
				_tmp22_ = !source_holding_tank_contains ((SourceHoldingTank*) _tmp25_, (DataSource*) _tmp26_);
#line 502 "../src/MediaDataRepresentation.vala"
				_source_holding_tank_unref0 (_tmp25_);
#line 4080 "MediaDataRepresentation.c"
			} else {
#line 502 "../src/MediaDataRepresentation.vala"
				_tmp22_ = FALSE;
#line 4084 "MediaDataRepresentation.c"
			}
#line 502 "../src/MediaDataRepresentation.vala"
			if (_tmp22_) {
#line 4088 "MediaDataRepresentation.c"
				GeeArrayList* _tmp27_;
				GeeArrayList* _tmp29_;
				MediaSource* _tmp30_;
#line 503 "../src/MediaDataRepresentation.vala"
				_tmp27_ = to_offline;
#line 503 "../src/MediaDataRepresentation.vala"
				if (_tmp27_ == NULL) {
#line 4096 "MediaDataRepresentation.c"
					GeeArrayList* _tmp28_;
#line 504 "../src/MediaDataRepresentation.vala"
					_tmp28_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 504 "../src/MediaDataRepresentation.vala"
					_g_object_unref0 (to_offline);
#line 504 "../src/MediaDataRepresentation.vala"
					to_offline = _tmp28_;
#line 4104 "MediaDataRepresentation.c"
				}
#line 506 "../src/MediaDataRepresentation.vala"
				_tmp29_ = to_offline;
#line 506 "../src/MediaDataRepresentation.vala"
				_tmp30_ = source;
#line 506 "../src/MediaDataRepresentation.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
#line 4112 "MediaDataRepresentation.c"
			}
#line 509 "../src/MediaDataRepresentation.vala"
			_tmp31_ = source;
#line 509 "../src/MediaDataRepresentation.vala"
			_tmp32_ = _g_object_ref0 (IS_FLAGGABLE (_tmp31_) ? ((Flaggable*) _tmp31_) : NULL);
#line 509 "../src/MediaDataRepresentation.vala"
			flaggable = _tmp32_;
#line 510 "../src/MediaDataRepresentation.vala"
			_tmp33_ = flaggable;
#line 510 "../src/MediaDataRepresentation.vala"
			if (_tmp33_ != NULL) {
#line 4124 "MediaDataRepresentation.c"
				Flaggable* _tmp34_;
#line 511 "../src/MediaDataRepresentation.vala"
				_tmp34_ = flaggable;
#line 511 "../src/MediaDataRepresentation.vala"
				if (flaggable_is_flagged (_tmp34_)) {
#line 4130 "MediaDataRepresentation.c"
					gboolean _tmp35_ = FALSE;
					GeeSet* _tmp36_;
					MediaSource* _tmp37_;
#line 512 "../src/MediaDataRepresentation.vala"
					_tmp36_ = self->priv->flagged;
#line 512 "../src/MediaDataRepresentation.vala"
					_tmp37_ = source;
#line 512 "../src/MediaDataRepresentation.vala"
					if (gee_collection_add ((GeeCollection*) _tmp36_, _tmp37_)) {
#line 512 "../src/MediaDataRepresentation.vala"
						_tmp35_ = TRUE;
#line 4142 "MediaDataRepresentation.c"
					} else {
#line 512 "../src/MediaDataRepresentation.vala"
						_tmp35_ = flagged_altered;
#line 4146 "MediaDataRepresentation.c"
					}
#line 512 "../src/MediaDataRepresentation.vala"
					flagged_altered = _tmp35_;
#line 4150 "MediaDataRepresentation.c"
				} else {
					gboolean _tmp38_ = FALSE;
					GeeSet* _tmp39_;
					MediaSource* _tmp40_;
#line 514 "../src/MediaDataRepresentation.vala"
					_tmp39_ = self->priv->flagged;
#line 514 "../src/MediaDataRepresentation.vala"
					_tmp40_ = source;
#line 514 "../src/MediaDataRepresentation.vala"
					if (gee_collection_remove ((GeeCollection*) _tmp39_, _tmp40_)) {
#line 514 "../src/MediaDataRepresentation.vala"
						_tmp38_ = TRUE;
#line 4163 "MediaDataRepresentation.c"
					} else {
#line 514 "../src/MediaDataRepresentation.vala"
						_tmp38_ = flagged_altered;
#line 4167 "MediaDataRepresentation.c"
					}
#line 514 "../src/MediaDataRepresentation.vala"
					flagged_altered = _tmp38_;
#line 4171 "MediaDataRepresentation.c"
				}
			}
#line 485 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (flaggable);
#line 485 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (source);
#line 485 "../src/MediaDataRepresentation.vala"
			_alteration_unref0 (alteration);
#line 485 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (object);
#line 4182 "MediaDataRepresentation.c"
		}
#line 485 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_object_it);
#line 4186 "MediaDataRepresentation.c"
	}
#line 518 "../src/MediaDataRepresentation.vala"
	_tmp41_ = to_trashcan;
#line 518 "../src/MediaDataRepresentation.vala"
	if (_tmp41_ != NULL) {
#line 4192 "MediaDataRepresentation.c"
		MediaSourceHoldingTank* _tmp42_;
		MediaSourceHoldingTank* _tmp43_;
		GeeArrayList* _tmp44_;
#line 519 "../src/MediaDataRepresentation.vala"
		_tmp42_ = media_source_collection_get_trashcan (self);
#line 519 "../src/MediaDataRepresentation.vala"
		_tmp43_ = _tmp42_;
#line 519 "../src/MediaDataRepresentation.vala"
		_tmp44_ = to_trashcan;
#line 519 "../src/MediaDataRepresentation.vala"
		source_holding_tank_unlink_and_hold ((SourceHoldingTank*) _tmp43_, (GeeCollection*) _tmp44_);
#line 519 "../src/MediaDataRepresentation.vala"
		_source_holding_tank_unref0 (_tmp43_);
#line 4206 "MediaDataRepresentation.c"
	}
#line 521 "../src/MediaDataRepresentation.vala"
	_tmp45_ = to_offline;
#line 521 "../src/MediaDataRepresentation.vala"
	if (_tmp45_ != NULL) {
#line 4212 "MediaDataRepresentation.c"
		MediaSourceHoldingTank* _tmp46_;
		MediaSourceHoldingTank* _tmp47_;
		GeeArrayList* _tmp48_;
#line 522 "../src/MediaDataRepresentation.vala"
		_tmp46_ = media_source_collection_get_offline_bin (self);
#line 522 "../src/MediaDataRepresentation.vala"
		_tmp47_ = _tmp46_;
#line 522 "../src/MediaDataRepresentation.vala"
		_tmp48_ = to_offline;
#line 522 "../src/MediaDataRepresentation.vala"
		source_holding_tank_unlink_and_hold ((SourceHoldingTank*) _tmp47_, (GeeCollection*) _tmp48_);
#line 522 "../src/MediaDataRepresentation.vala"
		_source_holding_tank_unref0 (_tmp47_);
#line 4226 "MediaDataRepresentation.c"
	}
#line 524 "../src/MediaDataRepresentation.vala"
	if (flagged_altered) {
#line 525 "../src/MediaDataRepresentation.vala"
		media_source_collection_notify_flagged_contents_altered (self);
#line 4232 "MediaDataRepresentation.c"
	}
#line 527 "../src/MediaDataRepresentation.vala"
	DATA_COLLECTION_CLASS (media_source_collection_parent_class)->items_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), items);
#line 481 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (to_offline);
#line 481 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (to_trashcan);
#line 4240 "MediaDataRepresentation.c"
}

static void
_media_source_collection_on_master_replaced_media_source_master_replaced (MediaSource* _sender,
                                                                          GFile* old_file,
                                                                          GFile* new_file,
                                                                          gpointer self)
{
#line 539 "../src/MediaDataRepresentation.vala"
	media_source_collection_on_master_replaced ((MediaSourceCollection*) self, _sender, old_file, new_file);
#line 4251 "MediaDataRepresentation.c"
}

static void
media_source_collection_real_notify_contents_altered (DataCollection* base,
                                                      GeeIterable* added,
                                                      GeeIterable* removed)
{
	MediaSourceCollection * self;
	gboolean import_roll_changed = FALSE;
	gboolean flagged_altered = FALSE;
#line 530 "../src/MediaDataRepresentation.vala"
	self = (MediaSourceCollection*) base;
#line 532 "../src/MediaDataRepresentation.vala"
	import_roll_changed = FALSE;
#line 533 "../src/MediaDataRepresentation.vala"
	flagged_altered = FALSE;
#line 534 "../src/MediaDataRepresentation.vala"
	if (added != NULL) {
#line 4270 "MediaDataRepresentation.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 535 "../src/MediaDataRepresentation.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 535 "../src/MediaDataRepresentation.vala"
			_object_it = _tmp0_;
#line 535 "../src/MediaDataRepresentation.vala"
			while (TRUE) {
#line 4280 "MediaDataRepresentation.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				MediaSource* media = NULL;
				DataObject* _tmp4_;
				MediaSource* _tmp5_;
				GeeHashMap* _tmp6_;
				MediaSource* _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
				MediaSource* _tmp10_;
				MediaSource* _tmp11_;
				ImportID import_id = {0};
				MediaSource* _tmp12_;
				ImportID _tmp13_ = {0};
				Flaggable* flaggable = NULL;
				MediaSource* _tmp19_;
				Flaggable* _tmp20_;
				Flaggable* _tmp21_;
#line 535 "../src/MediaDataRepresentation.vala"
				_tmp1_ = _object_it;
#line 535 "../src/MediaDataRepresentation.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 535 "../src/MediaDataRepresentation.vala"
					break;
#line 4307 "MediaDataRepresentation.c"
				}
#line 535 "../src/MediaDataRepresentation.vala"
				_tmp2_ = _object_it;
#line 535 "../src/MediaDataRepresentation.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 535 "../src/MediaDataRepresentation.vala"
				object = (DataObject*) _tmp3_;
#line 536 "../src/MediaDataRepresentation.vala"
				_tmp4_ = object;
#line 536 "../src/MediaDataRepresentation.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_SOURCE, MediaSource));
#line 536 "../src/MediaDataRepresentation.vala"
				media = _tmp5_;
#line 538 "../src/MediaDataRepresentation.vala"
				_tmp6_ = self->priv->by_master_file;
#line 538 "../src/MediaDataRepresentation.vala"
				_tmp7_ = media;
#line 538 "../src/MediaDataRepresentation.vala"
				_tmp8_ = media_source_get_master_file (_tmp7_);
#line 538 "../src/MediaDataRepresentation.vala"
				_tmp9_ = _tmp8_;
#line 538 "../src/MediaDataRepresentation.vala"
				_tmp10_ = media;
#line 538 "../src/MediaDataRepresentation.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp9_, _tmp10_);
#line 538 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_tmp9_);
#line 539 "../src/MediaDataRepresentation.vala"
				_tmp11_ = media;
#line 539 "../src/MediaDataRepresentation.vala"
				g_signal_connect (_tmp11_, "master-replaced", (GCallback) _media_source_collection_on_master_replaced_media_source_master_replaced, self);
#line 541 "../src/MediaDataRepresentation.vala"
				_tmp12_ = media;
#line 541 "../src/MediaDataRepresentation.vala"
				media_source_get_import_id (_tmp12_, &_tmp13_);
#line 541 "../src/MediaDataRepresentation.vala"
				import_id = _tmp13_;
#line 542 "../src/MediaDataRepresentation.vala"
				if (import_id_is_valid (&import_id)) {
#line 4347 "MediaDataRepresentation.c"
					GeeTreeSet* _tmp14_;
					ImportID _tmp15_;
					GeeMultiMap* _tmp16_;
					ImportID _tmp17_;
					MediaSource* _tmp18_;
#line 543 "../src/MediaDataRepresentation.vala"
					_tmp14_ = self->priv->sorted_import_ids;
#line 543 "../src/MediaDataRepresentation.vala"
					_tmp15_ = import_id;
#line 543 "../src/MediaDataRepresentation.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, &_tmp15_);
#line 544 "../src/MediaDataRepresentation.vala"
					_tmp16_ = self->priv->import_rolls;
#line 544 "../src/MediaDataRepresentation.vala"
					_tmp17_ = import_id;
#line 544 "../src/MediaDataRepresentation.vala"
					_tmp18_ = media;
#line 544 "../src/MediaDataRepresentation.vala"
					gee_multi_map_set (_tmp16_, &_tmp17_, _tmp18_);
#line 546 "../src/MediaDataRepresentation.vala"
					import_roll_changed = TRUE;
#line 4369 "MediaDataRepresentation.c"
				}
#line 549 "../src/MediaDataRepresentation.vala"
				_tmp19_ = media;
#line 549 "../src/MediaDataRepresentation.vala"
				_tmp20_ = _g_object_ref0 (IS_FLAGGABLE (_tmp19_) ? ((Flaggable*) _tmp19_) : NULL);
#line 549 "../src/MediaDataRepresentation.vala"
				flaggable = _tmp20_;
#line 550 "../src/MediaDataRepresentation.vala"
				_tmp21_ = flaggable;
#line 550 "../src/MediaDataRepresentation.vala"
				if (_tmp21_ != NULL) {
#line 4381 "MediaDataRepresentation.c"
					Flaggable* _tmp22_;
#line 551 "../src/MediaDataRepresentation.vala"
					_tmp22_ = flaggable;
#line 551 "../src/MediaDataRepresentation.vala"
					if (flaggable_is_flagged (_tmp22_)) {
#line 4387 "MediaDataRepresentation.c"
						gboolean _tmp23_ = FALSE;
						GeeSet* _tmp24_;
						MediaSource* _tmp25_;
#line 552 "../src/MediaDataRepresentation.vala"
						_tmp24_ = self->priv->flagged;
#line 552 "../src/MediaDataRepresentation.vala"
						_tmp25_ = media;
#line 552 "../src/MediaDataRepresentation.vala"
						if (gee_collection_add ((GeeCollection*) _tmp24_, _tmp25_)) {
#line 552 "../src/MediaDataRepresentation.vala"
							_tmp23_ = TRUE;
#line 4399 "MediaDataRepresentation.c"
						} else {
#line 552 "../src/MediaDataRepresentation.vala"
							_tmp23_ = flagged_altered;
#line 4403 "MediaDataRepresentation.c"
						}
#line 552 "../src/MediaDataRepresentation.vala"
						flagged_altered = _tmp23_;
#line 4407 "MediaDataRepresentation.c"
					} else {
						gboolean _tmp26_ = FALSE;
						GeeSet* _tmp27_;
						MediaSource* _tmp28_;
#line 554 "../src/MediaDataRepresentation.vala"
						_tmp27_ = self->priv->flagged;
#line 554 "../src/MediaDataRepresentation.vala"
						_tmp28_ = media;
#line 554 "../src/MediaDataRepresentation.vala"
						if (gee_collection_remove ((GeeCollection*) _tmp27_, _tmp28_)) {
#line 554 "../src/MediaDataRepresentation.vala"
							_tmp26_ = TRUE;
#line 4420 "MediaDataRepresentation.c"
						} else {
#line 554 "../src/MediaDataRepresentation.vala"
							_tmp26_ = flagged_altered;
#line 4424 "MediaDataRepresentation.c"
						}
#line 554 "../src/MediaDataRepresentation.vala"
						flagged_altered = _tmp26_;
#line 4428 "MediaDataRepresentation.c"
					}
				}
#line 535 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (flaggable);
#line 535 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (media);
#line 535 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (object);
#line 4437 "MediaDataRepresentation.c"
			}
#line 535 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (_object_it);
#line 4441 "MediaDataRepresentation.c"
		}
	}
#line 559 "../src/MediaDataRepresentation.vala"
	if (removed != NULL) {
#line 4446 "MediaDataRepresentation.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp29_;
#line 560 "../src/MediaDataRepresentation.vala"
			_tmp29_ = gee_iterable_iterator (removed);
#line 560 "../src/MediaDataRepresentation.vala"
			_object_it = _tmp29_;
#line 560 "../src/MediaDataRepresentation.vala"
			while (TRUE) {
#line 4456 "MediaDataRepresentation.c"
				GeeIterator* _tmp30_;
				DataObject* object = NULL;
				GeeIterator* _tmp31_;
				gpointer _tmp32_;
				MediaSource* media = NULL;
				DataObject* _tmp33_;
				MediaSource* _tmp34_;
				gboolean is_removed = FALSE;
				GeeHashMap* _tmp35_;
				MediaSource* _tmp36_;
				GFile* _tmp37_;
				GFile* _tmp38_;
				gboolean _tmp39_;
				MediaSource* _tmp40_;
				guint _tmp41_;
				ImportID import_id = {0};
				MediaSource* _tmp42_;
				ImportID _tmp43_ = {0};
				gboolean _tmp51_ = FALSE;
				GeeSet* _tmp52_;
				MediaSource* _tmp53_;
#line 560 "../src/MediaDataRepresentation.vala"
				_tmp30_ = _object_it;
#line 560 "../src/MediaDataRepresentation.vala"
				if (!gee_iterator_next (_tmp30_)) {
#line 560 "../src/MediaDataRepresentation.vala"
					break;
#line 4484 "MediaDataRepresentation.c"
				}
#line 560 "../src/MediaDataRepresentation.vala"
				_tmp31_ = _object_it;
#line 560 "../src/MediaDataRepresentation.vala"
				_tmp32_ = gee_iterator_get (_tmp31_);
#line 560 "../src/MediaDataRepresentation.vala"
				object = (DataObject*) _tmp32_;
#line 561 "../src/MediaDataRepresentation.vala"
				_tmp33_ = object;
#line 561 "../src/MediaDataRepresentation.vala"
				_tmp34_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, TYPE_MEDIA_SOURCE, MediaSource));
#line 561 "../src/MediaDataRepresentation.vala"
				media = _tmp34_;
#line 563 "../src/MediaDataRepresentation.vala"
				_tmp35_ = self->priv->by_master_file;
#line 563 "../src/MediaDataRepresentation.vala"
				_tmp36_ = media;
#line 563 "../src/MediaDataRepresentation.vala"
				_tmp37_ = media_source_get_master_file (_tmp36_);
#line 563 "../src/MediaDataRepresentation.vala"
				_tmp38_ = _tmp37_;
#line 563 "../src/MediaDataRepresentation.vala"
				_tmp39_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp35_, _tmp38_, NULL);
#line 563 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_tmp38_);
#line 563 "../src/MediaDataRepresentation.vala"
				is_removed = _tmp39_;
#line 564 "../src/MediaDataRepresentation.vala"
				_vala_assert (is_removed, "is_removed");
#line 565 "../src/MediaDataRepresentation.vala"
				_tmp40_ = media;
#line 565 "../src/MediaDataRepresentation.vala"
				g_signal_parse_name ("master-replaced", TYPE_MEDIA_SOURCE, &_tmp41_, NULL, FALSE);
#line 565 "../src/MediaDataRepresentation.vala"
				g_signal_handlers_disconnect_matched (_tmp40_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp41_, 0, NULL, (GCallback) _media_source_collection_on_master_replaced_media_source_master_replaced, self);
#line 567 "../src/MediaDataRepresentation.vala"
				_tmp42_ = media;
#line 567 "../src/MediaDataRepresentation.vala"
				media_source_get_import_id (_tmp42_, &_tmp43_);
#line 567 "../src/MediaDataRepresentation.vala"
				import_id = _tmp43_;
#line 568 "../src/MediaDataRepresentation.vala"
				if (import_id_is_valid (&import_id)) {
#line 4528 "MediaDataRepresentation.c"
					GeeMultiMap* _tmp44_;
					ImportID _tmp45_;
					MediaSource* _tmp46_;
					GeeMultiMap* _tmp47_;
					ImportID _tmp48_;
#line 569 "../src/MediaDataRepresentation.vala"
					_tmp44_ = self->priv->import_rolls;
#line 569 "../src/MediaDataRepresentation.vala"
					_tmp45_ = import_id;
#line 569 "../src/MediaDataRepresentation.vala"
					_tmp46_ = media;
#line 569 "../src/MediaDataRepresentation.vala"
					is_removed = gee_multi_map_remove (_tmp44_, &_tmp45_, _tmp46_);
#line 570 "../src/MediaDataRepresentation.vala"
					_vala_assert (is_removed, "is_removed");
#line 571 "../src/MediaDataRepresentation.vala"
					_tmp47_ = self->priv->import_rolls;
#line 571 "../src/MediaDataRepresentation.vala"
					_tmp48_ = import_id;
#line 571 "../src/MediaDataRepresentation.vala"
					if (!gee_multi_map_contains (_tmp47_, &_tmp48_)) {
#line 4550 "MediaDataRepresentation.c"
						GeeTreeSet* _tmp49_;
						ImportID _tmp50_;
#line 572 "../src/MediaDataRepresentation.vala"
						_tmp49_ = self->priv->sorted_import_ids;
#line 572 "../src/MediaDataRepresentation.vala"
						_tmp50_ = import_id;
#line 572 "../src/MediaDataRepresentation.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp49_, &_tmp50_);
#line 4559 "MediaDataRepresentation.c"
					}
#line 574 "../src/MediaDataRepresentation.vala"
					import_roll_changed = TRUE;
#line 4563 "MediaDataRepresentation.c"
				}
#line 577 "../src/MediaDataRepresentation.vala"
				_tmp52_ = self->priv->flagged;
#line 577 "../src/MediaDataRepresentation.vala"
				_tmp53_ = media;
#line 577 "../src/MediaDataRepresentation.vala"
				if (gee_collection_remove ((GeeCollection*) _tmp52_, _tmp53_)) {
#line 577 "../src/MediaDataRepresentation.vala"
					_tmp51_ = TRUE;
#line 4573 "MediaDataRepresentation.c"
				} else {
#line 577 "../src/MediaDataRepresentation.vala"
					_tmp51_ = flagged_altered;
#line 4577 "MediaDataRepresentation.c"
				}
#line 577 "../src/MediaDataRepresentation.vala"
				flagged_altered = _tmp51_;
#line 560 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (media);
#line 560 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (object);
#line 4585 "MediaDataRepresentation.c"
			}
#line 560 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (_object_it);
#line 4589 "MediaDataRepresentation.c"
		}
	}
#line 581 "../src/MediaDataRepresentation.vala"
	if (import_roll_changed) {
#line 582 "../src/MediaDataRepresentation.vala"
		media_source_collection_notify_import_roll_altered (self);
#line 4596 "MediaDataRepresentation.c"
	}
#line 584 "../src/MediaDataRepresentation.vala"
	if (flagged_altered) {
#line 585 "../src/MediaDataRepresentation.vala"
		media_source_collection_notify_flagged_contents_altered (self);
#line 4602 "MediaDataRepresentation.c"
	}
#line 587 "../src/MediaDataRepresentation.vala"
	DATA_COLLECTION_CLASS (media_source_collection_parent_class)->notify_contents_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), added, removed);
#line 4606 "MediaDataRepresentation.c"
}

static void
media_source_collection_on_master_replaced (MediaSourceCollection* self,
                                            MediaSource* media,
                                            GFile* old_file,
                                            GFile* new_file)
{
	gboolean is_removed = FALSE;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 590 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 590 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 590 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (old_file != NULL);
#line 590 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (new_file != NULL);
#line 591 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->by_master_file;
#line 591 "../src/MediaDataRepresentation.vala"
	is_removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, old_file, NULL);
#line 592 "../src/MediaDataRepresentation.vala"
	_vala_assert (is_removed, "is_removed");
#line 594 "../src/MediaDataRepresentation.vala"
	_tmp1_ = self->priv->by_master_file;
#line 594 "../src/MediaDataRepresentation.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, new_file, media);
#line 596 "../src/MediaDataRepresentation.vala"
	g_signal_emit (self, media_source_collection_signals[MEDIA_SOURCE_COLLECTION_MASTER_FILE_REPLACED_SIGNAL], 0, media, old_file, new_file);
#line 4638 "MediaDataRepresentation.c"
}

MediaSource*
media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                              GFile* file)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MediaSource* result;
#line 599 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 599 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 600 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->by_master_file;
#line 600 "../src/MediaDataRepresentation.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 600 "../src/MediaDataRepresentation.vala"
	result = (MediaSource*) _tmp1_;
#line 600 "../src/MediaDataRepresentation.vala"
	return result;
#line 4660 "MediaDataRepresentation.c"
}

static MediaSource*
media_source_collection_real_fetch_by_source_id (MediaSourceCollection* self,
                                                 const gchar* source_id)
{
	gchar** components = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint components_length1;
	gint _components_size_;
	const gchar* _tmp2_;
	MediaSource* _tmp3_;
	MediaSource* result;
#line 603 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 604 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_ = g_strsplit (source_id, "-", 0);
#line 604 "../src/MediaDataRepresentation.vala"
	components = _tmp1_;
#line 604 "../src/MediaDataRepresentation.vala"
	components_length1 = _vala_array_length (_tmp0_);
#line 604 "../src/MediaDataRepresentation.vala"
	_components_size_ = components_length1;
#line 605 "../src/MediaDataRepresentation.vala"
	_vala_assert (components_length1 == 2, "components.length == 2");
#line 607 "../src/MediaDataRepresentation.vala"
	_tmp2_ = components[1];
#line 607 "../src/MediaDataRepresentation.vala"
	_tmp3_ = media_source_collection_fetch_by_numeric_id (self, parse_int64 (_tmp2_, 16));
#line 607 "../src/MediaDataRepresentation.vala"
	result = _tmp3_;
#line 607 "../src/MediaDataRepresentation.vala"
	components = (_vala_array_free (components, components_length1, (GDestroyNotify) g_free), NULL);
#line 607 "../src/MediaDataRepresentation.vala"
	return result;
#line 4697 "MediaDataRepresentation.c"
}

MediaSource*
media_source_collection_fetch_by_source_id (MediaSourceCollection* self,
                                            const gchar* source_id)
{
	MediaSourceCollectionClass* _klass_;
#line 603 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 603 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 603 "../src/MediaDataRepresentation.vala"
	if (_klass_->fetch_by_source_id) {
#line 603 "../src/MediaDataRepresentation.vala"
		return _klass_->fetch_by_source_id (self, source_id);
#line 4713 "MediaDataRepresentation.c"
	}
#line 603 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 4717 "MediaDataRepresentation.c"
}

static GeeCollection*
media_source_collection_real_get_event_source_ids (MediaSourceCollection* self,
                                                   EventID* event_id)
{
#line 610 "../src/MediaDataRepresentation.vala"
	g_critical ("Type `%s' does not implement abstract method `media_source_collection_get_event_source_ids'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 610 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 4728 "MediaDataRepresentation.c"
}

GeeCollection*
media_source_collection_get_event_source_ids (MediaSourceCollection* self,
                                              EventID* event_id)
{
	MediaSourceCollectionClass* _klass_;
#line 610 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 610 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 610 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_event_source_ids) {
#line 610 "../src/MediaDataRepresentation.vala"
		return _klass_->get_event_source_ids (self, event_id);
#line 4744 "MediaDataRepresentation.c"
	}
#line 610 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 4748 "MediaDataRepresentation.c"
}

GeeCollection*
media_source_collection_get_trashcan_contents (MediaSourceCollection* self)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* result;
#line 612 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 613 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_collection_get_trashcan (self);
#line 613 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 613 "../src/MediaDataRepresentation.vala"
	_tmp2_ = source_holding_tank_get_all ((SourceHoldingTank*) _tmp1_);
#line 613 "../src/MediaDataRepresentation.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 613 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 613 "../src/MediaDataRepresentation.vala"
	result = _tmp3_;
#line 613 "../src/MediaDataRepresentation.vala"
	return result;
#line 4775 "MediaDataRepresentation.c"
}

GeeCollection*
media_source_collection_get_offline_bin_contents (MediaSourceCollection* self)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* result;
#line 616 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 617 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_collection_get_offline_bin (self);
#line 617 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 617 "../src/MediaDataRepresentation.vala"
	_tmp2_ = source_holding_tank_get_all ((SourceHoldingTank*) _tmp1_);
#line 617 "../src/MediaDataRepresentation.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 617 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 617 "../src/MediaDataRepresentation.vala"
	result = _tmp3_;
#line 617 "../src/MediaDataRepresentation.vala"
	return result;
#line 4802 "MediaDataRepresentation.c"
}

GeeCollection*
media_source_collection_get_flagged (MediaSourceCollection* self)
{
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeCollection* result;
#line 620 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 621 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->flagged;
#line 621 "../src/MediaDataRepresentation.vala"
	_tmp1_ = gee_set_get_read_only_view (_tmp0_);
#line 621 "../src/MediaDataRepresentation.vala"
	_tmp2_ = _tmp1_;
#line 621 "../src/MediaDataRepresentation.vala"
	result = (GeeCollection*) _tmp2_;
#line 621 "../src/MediaDataRepresentation.vala"
	return result;
#line 4824 "MediaDataRepresentation.c"
}

GeeSortedSet*
media_source_collection_get_import_roll_ids (MediaSourceCollection* self)
{
	GeeTreeSet* _tmp0_;
	GeeSortedSet* _tmp1_;
	GeeSortedSet* result;
#line 625 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 626 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->sorted_import_ids;
#line 626 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _g_object_ref0 ((GeeSortedSet*) _tmp0_);
#line 626 "../src/MediaDataRepresentation.vala"
	result = _tmp1_;
#line 626 "../src/MediaDataRepresentation.vala"
	return result;
#line 4843 "MediaDataRepresentation.c"
}

ImportID*
media_source_collection_get_last_import_id (MediaSourceCollection* self)
{
	ImportID* _tmp0_ = NULL;
	GeeTreeSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	ImportID* result;
#line 629 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 630 "../src/MediaDataRepresentation.vala"
	_tmp1_ = self->priv->sorted_import_ids;
#line 630 "../src/MediaDataRepresentation.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 630 "../src/MediaDataRepresentation.vala"
	_tmp3_ = _tmp2_;
#line 630 "../src/MediaDataRepresentation.vala"
	if (_tmp3_ != 0) {
#line 4864 "MediaDataRepresentation.c"
		GeeTreeSet* _tmp4_;
		gpointer _tmp5_;
#line 630 "../src/MediaDataRepresentation.vala"
		_tmp4_ = self->priv->sorted_import_ids;
#line 630 "../src/MediaDataRepresentation.vala"
		_tmp5_ = gee_abstract_sorted_set_last ((GeeAbstractSortedSet*) _tmp4_);
#line 630 "../src/MediaDataRepresentation.vala"
		_import_id_free0 (_tmp0_);
#line 630 "../src/MediaDataRepresentation.vala"
		_tmp0_ = (ImportID*) _tmp5_;
#line 4875 "MediaDataRepresentation.c"
	} else {
#line 630 "../src/MediaDataRepresentation.vala"
		_import_id_free0 (_tmp0_);
#line 630 "../src/MediaDataRepresentation.vala"
		_tmp0_ = NULL;
#line 4881 "MediaDataRepresentation.c"
	}
#line 630 "../src/MediaDataRepresentation.vala"
	result = _tmp0_;
#line 630 "../src/MediaDataRepresentation.vala"
	return result;
#line 4887 "MediaDataRepresentation.c"
}

GeeCollection*
media_source_collection_get_import_roll (MediaSourceCollection* self,
                                         ImportID* import_id)
{
	GeeMultiMap* _tmp0_;
	ImportID _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result;
#line 633 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 633 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 634 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->import_rolls;
#line 634 "../src/MediaDataRepresentation.vala"
	_tmp1_ = *import_id;
#line 634 "../src/MediaDataRepresentation.vala"
	_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 634 "../src/MediaDataRepresentation.vala"
	result = _tmp2_;
#line 634 "../src/MediaDataRepresentation.vala"
	return result;
#line 4912 "MediaDataRepresentation.c"
}

void
media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                           GeeCollection* sources)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
#line 637 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 637 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (sources != NULL);
#line 638 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_collection_get_trashcan (self);
#line 638 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 638 "../src/MediaDataRepresentation.vala"
	source_holding_tank_add_many ((SourceHoldingTank*) _tmp1_, sources);
#line 638 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4933 "MediaDataRepresentation.c"
}

void
media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                             GeeCollection* sources)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
#line 641 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 641 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (sources != NULL);
#line 642 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_collection_get_offline_bin (self);
#line 642 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 642 "../src/MediaDataRepresentation.vala"
	source_holding_tank_add_many ((SourceHoldingTank*) _tmp1_, sources);
#line 642 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4954 "MediaDataRepresentation.c"
}

gint
media_source_collection_get_trashcan_count (MediaSourceCollection* self)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
	gint result;
#line 645 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 646 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_source_collection_get_trashcan (self);
#line 646 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 646 "../src/MediaDataRepresentation.vala"
	_tmp2_ = source_holding_tank_get_count ((SourceHoldingTank*) _tmp1_);
#line 646 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 646 "../src/MediaDataRepresentation.vala"
	result = _tmp2_;
#line 646 "../src/MediaDataRepresentation.vala"
	return result;
#line 4978 "MediaDataRepresentation.c"
}

static void
media_source_collection_real_import_many (MediaSourceCollection* self,
                                          GeeCollection* media)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 652 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 653 "../src/MediaDataRepresentation.vala"
	media_source_collection_notify_media_import_starting (self, media);
#line 655 "../src/MediaDataRepresentation.vala"
	_tmp0_ = data_collection_add_many ((DataCollection*) self, media, NULL, NULL);
#line 655 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 655 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (_tmp1_);
#line 657 "../src/MediaDataRepresentation.vala"
	media_source_collection_postprocess_imported_media (self, media);
#line 659 "../src/MediaDataRepresentation.vala"
	media_source_collection_notify_media_import_completed (self, media);
#line 5001 "MediaDataRepresentation.c"
}

void
media_source_collection_import_many (MediaSourceCollection* self,
                                     GeeCollection* media)
{
	MediaSourceCollectionClass* _klass_;
#line 652 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 652 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 652 "../src/MediaDataRepresentation.vala"
	if (_klass_->import_many) {
#line 652 "../src/MediaDataRepresentation.vala"
		_klass_->import_many (self, media);
#line 5017 "MediaDataRepresentation.c"
	}
}

static void
media_source_collection_real_postprocess_imported_media (MediaSourceCollection* self,
                                                         GeeCollection* media)
{
#line 664 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 5027 "MediaDataRepresentation.c"
}

void
media_source_collection_postprocess_imported_media (MediaSourceCollection* self,
                                                    GeeCollection* media)
{
	MediaSourceCollectionClass* _klass_;
#line 664 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 664 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 664 "../src/MediaDataRepresentation.vala"
	if (_klass_->postprocess_imported_media) {
#line 664 "../src/MediaDataRepresentation.vala"
		_klass_->postprocess_imported_media (self, media);
#line 5043 "MediaDataRepresentation.c"
	}
}

static gboolean
_aggregate_progress_monitor_monitor_progress_monitor (guint64 current,
                                                      guint64 total,
                                                      gboolean do_event_loop,
                                                      gpointer self)
{
	gboolean result;
	result = aggregate_progress_monitor_monitor ((AggregateProgressMonitor*) self, current, total);
#line 699 "../src/MediaDataRepresentation.vala"
	return result;
#line 5057 "MediaDataRepresentation.c"
}

void
media_source_collection_remove_from_app (MediaSourceCollection* self,
                                         GeeCollection* sources,
                                         gboolean delete_backing,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target,
                                         GeeList* not_removed)
{
	GeeHashSet* _tmp0_ = NULL;
	GeeHashSet* to_tombstone = NULL;
	GeeHashSet* _tmp2_;
	GeeArrayList* trashed = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* offlined = NULL;
	GeeArrayList* _tmp4_;
	GeeArrayList* not_trashed = NULL;
	GeeArrayList* _tmp5_;
	gint total_count = 0;
	gint _tmp21_;
	gint _tmp22_;
	GeeArrayList* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GeeArrayList* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	GeeArrayList* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	AggregateProgressMonitor* agg_monitor = NULL;
	GeeArrayList* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	GeeArrayList* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	GeeArrayList* _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	gboolean _tmp52_ = FALSE;
	GeeHashSet* _tmp53_;
	GError* _inner_error0_ = NULL;
#line 670 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 672 "../src/MediaDataRepresentation.vala"
	_vala_assert (sources != NULL, "sources != null");
#line 674 "../src/MediaDataRepresentation.vala"
	if (!delete_backing) {
#line 5108 "MediaDataRepresentation.c"
		GeeHashSet* _tmp1_;
#line 674 "../src/MediaDataRepresentation.vala"
		_tmp1_ = gee_hash_set_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 674 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp0_);
#line 674 "../src/MediaDataRepresentation.vala"
		_tmp0_ = _tmp1_;
#line 5116 "MediaDataRepresentation.c"
	} else {
#line 674 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp0_);
#line 674 "../src/MediaDataRepresentation.vala"
		_tmp0_ = NULL;
#line 5122 "MediaDataRepresentation.c"
	}
#line 674 "../src/MediaDataRepresentation.vala"
	_tmp2_ = _g_object_ref0 (_tmp0_);
#line 674 "../src/MediaDataRepresentation.vala"
	to_tombstone = _tmp2_;
#line 677 "../src/MediaDataRepresentation.vala"
	_tmp3_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 677 "../src/MediaDataRepresentation.vala"
	trashed = _tmp3_;
#line 678 "../src/MediaDataRepresentation.vala"
	_tmp4_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 678 "../src/MediaDataRepresentation.vala"
	offlined = _tmp4_;
#line 679 "../src/MediaDataRepresentation.vala"
	_tmp5_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 679 "../src/MediaDataRepresentation.vala"
	not_trashed = _tmp5_;
#line 5140 "MediaDataRepresentation.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp6_;
#line 680 "../src/MediaDataRepresentation.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) sources);
#line 680 "../src/MediaDataRepresentation.vala"
		_source_it = _tmp6_;
#line 680 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 5150 "MediaDataRepresentation.c"
			GeeIterator* _tmp7_;
			MediaSource* source = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			MediaSource* _tmp10_;
			GeeHashSet* _tmp18_;
#line 680 "../src/MediaDataRepresentation.vala"
			_tmp7_ = _source_it;
#line 680 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 680 "../src/MediaDataRepresentation.vala"
				break;
#line 5163 "MediaDataRepresentation.c"
			}
#line 680 "../src/MediaDataRepresentation.vala"
			_tmp8_ = _source_it;
#line 680 "../src/MediaDataRepresentation.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 680 "../src/MediaDataRepresentation.vala"
			source = (MediaSource*) _tmp9_;
#line 681 "../src/MediaDataRepresentation.vala"
			_tmp10_ = source;
#line 681 "../src/MediaDataRepresentation.vala"
			if (media_source_is_trashed (_tmp10_)) {
#line 5175 "MediaDataRepresentation.c"
				GeeArrayList* _tmp11_;
				MediaSource* _tmp12_;
#line 682 "../src/MediaDataRepresentation.vala"
				_tmp11_ = trashed;
#line 682 "../src/MediaDataRepresentation.vala"
				_tmp12_ = source;
#line 682 "../src/MediaDataRepresentation.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 5184 "MediaDataRepresentation.c"
			} else {
				MediaSource* _tmp13_;
#line 683 "../src/MediaDataRepresentation.vala"
				_tmp13_ = source;
#line 683 "../src/MediaDataRepresentation.vala"
				if (media_source_is_offline (_tmp13_)) {
#line 5191 "MediaDataRepresentation.c"
					GeeArrayList* _tmp14_;
					MediaSource* _tmp15_;
#line 684 "../src/MediaDataRepresentation.vala"
					_tmp14_ = offlined;
#line 684 "../src/MediaDataRepresentation.vala"
					_tmp15_ = source;
#line 684 "../src/MediaDataRepresentation.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 5200 "MediaDataRepresentation.c"
				} else {
					GeeArrayList* _tmp16_;
					MediaSource* _tmp17_;
#line 686 "../src/MediaDataRepresentation.vala"
					_tmp16_ = not_trashed;
#line 686 "../src/MediaDataRepresentation.vala"
					_tmp17_ = source;
#line 686 "../src/MediaDataRepresentation.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 5210 "MediaDataRepresentation.c"
				}
			}
#line 688 "../src/MediaDataRepresentation.vala"
			_tmp18_ = to_tombstone;
#line 688 "../src/MediaDataRepresentation.vala"
			if (_tmp18_ != NULL) {
#line 5217 "MediaDataRepresentation.c"
				GeeHashSet* _tmp19_;
				MediaSource* _tmp20_;
#line 689 "../src/MediaDataRepresentation.vala"
				_tmp19_ = to_tombstone;
#line 689 "../src/MediaDataRepresentation.vala"
				_tmp20_ = source;
#line 689 "../src/MediaDataRepresentation.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 5226 "MediaDataRepresentation.c"
			}
#line 680 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (source);
#line 5230 "MediaDataRepresentation.c"
		}
#line 680 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_source_it);
#line 5234 "MediaDataRepresentation.c"
	}
#line 692 "../src/MediaDataRepresentation.vala"
	_tmp21_ = gee_collection_get_size (sources);
#line 692 "../src/MediaDataRepresentation.vala"
	_tmp22_ = _tmp21_;
#line 692 "../src/MediaDataRepresentation.vala"
	total_count = _tmp22_;
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp23_ = trashed;
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp25_ = _tmp24_;
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp26_ = offlined;
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp28_ = _tmp27_;
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp29_ = not_trashed;
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
#line 693 "../src/MediaDataRepresentation.vala"
	_tmp31_ = _tmp30_;
#line 693 "../src/MediaDataRepresentation.vala"
	_vala_assert (total_count == ((_tmp25_ + _tmp28_) + _tmp31_), "total_count == (trashed.size + offlined.size + not_trashed.size)");
#line 696 "../src/MediaDataRepresentation.vala"
	agg_monitor = NULL;
#line 697 "../src/MediaDataRepresentation.vala"
	if (monitor != NULL) {
#line 5266 "MediaDataRepresentation.c"
		AggregateProgressMonitor* _tmp32_;
		AggregateProgressMonitor* _tmp33_;
#line 698 "../src/MediaDataRepresentation.vala"
		_tmp32_ = aggregate_progress_monitor_new ((guint64) total_count, monitor, monitor_target);
#line 698 "../src/MediaDataRepresentation.vala"
		_aggregate_progress_monitor_unref0 (agg_monitor);
#line 698 "../src/MediaDataRepresentation.vala"
		agg_monitor = _tmp32_;
#line 699 "../src/MediaDataRepresentation.vala"
		_tmp33_ = agg_monitor;
#line 699 "../src/MediaDataRepresentation.vala"
		monitor = _aggregate_progress_monitor_monitor_progress_monitor;
#line 699 "../src/MediaDataRepresentation.vala"
		monitor_target = _tmp33_;
#line 5281 "MediaDataRepresentation.c"
	}
#line 702 "../src/MediaDataRepresentation.vala"
	_tmp34_ = trashed;
#line 702 "../src/MediaDataRepresentation.vala"
	_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 702 "../src/MediaDataRepresentation.vala"
	_tmp36_ = _tmp35_;
#line 702 "../src/MediaDataRepresentation.vala"
	if (_tmp36_ > 0) {
#line 5291 "MediaDataRepresentation.c"
		MediaSourceHoldingTank* _tmp37_;
		MediaSourceHoldingTank* _tmp38_;
		GeeArrayList* _tmp39_;
#line 703 "../src/MediaDataRepresentation.vala"
		_tmp37_ = media_source_collection_get_trashcan (self);
#line 703 "../src/MediaDataRepresentation.vala"
		_tmp38_ = _tmp37_;
#line 703 "../src/MediaDataRepresentation.vala"
		_tmp39_ = trashed;
#line 703 "../src/MediaDataRepresentation.vala"
		source_holding_tank_destroy_orphans ((SourceHoldingTank*) _tmp38_, (GeeList*) _tmp39_, delete_backing, monitor, monitor_target, not_removed);
#line 703 "../src/MediaDataRepresentation.vala"
		_source_holding_tank_unref0 (_tmp38_);
#line 5305 "MediaDataRepresentation.c"
	}
#line 705 "../src/MediaDataRepresentation.vala"
	_tmp40_ = offlined;
#line 705 "../src/MediaDataRepresentation.vala"
	_tmp41_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp40_);
#line 705 "../src/MediaDataRepresentation.vala"
	_tmp42_ = _tmp41_;
#line 705 "../src/MediaDataRepresentation.vala"
	if (_tmp42_ > 0) {
#line 5315 "MediaDataRepresentation.c"
		MediaSourceHoldingTank* _tmp43_;
		MediaSourceHoldingTank* _tmp44_;
		GeeArrayList* _tmp45_;
#line 706 "../src/MediaDataRepresentation.vala"
		_tmp43_ = media_source_collection_get_offline_bin (self);
#line 706 "../src/MediaDataRepresentation.vala"
		_tmp44_ = _tmp43_;
#line 706 "../src/MediaDataRepresentation.vala"
		_tmp45_ = offlined;
#line 706 "../src/MediaDataRepresentation.vala"
		source_holding_tank_destroy_orphans ((SourceHoldingTank*) _tmp44_, (GeeList*) _tmp45_, delete_backing, monitor, monitor_target, not_removed);
#line 706 "../src/MediaDataRepresentation.vala"
		_source_holding_tank_unref0 (_tmp44_);
#line 5329 "MediaDataRepresentation.c"
	}
#line 709 "../src/MediaDataRepresentation.vala"
	_tmp46_ = not_trashed;
#line 709 "../src/MediaDataRepresentation.vala"
	_tmp47_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp46_);
#line 709 "../src/MediaDataRepresentation.vala"
	_tmp48_ = _tmp47_;
#line 709 "../src/MediaDataRepresentation.vala"
	if (_tmp48_ > 0) {
#line 5339 "MediaDataRepresentation.c"
		GeeArrayList* _tmp49_;
		Marker* _tmp50_;
		Marker* _tmp51_;
#line 710 "../src/MediaDataRepresentation.vala"
		_tmp49_ = not_trashed;
#line 710 "../src/MediaDataRepresentation.vala"
		_tmp50_ = data_collection_mark_many ((DataCollection*) self, (GeeCollection*) _tmp49_);
#line 710 "../src/MediaDataRepresentation.vala"
		_tmp51_ = _tmp50_;
#line 710 "../src/MediaDataRepresentation.vala"
		source_collection_destroy_marked ((SourceCollection*) self, _tmp51_, delete_backing, monitor, monitor_target, not_removed);
#line 710 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp51_);
#line 5353 "MediaDataRepresentation.c"
	}
#line 712 "../src/MediaDataRepresentation.vala"
	_tmp53_ = to_tombstone;
#line 712 "../src/MediaDataRepresentation.vala"
	if (_tmp53_ != NULL) {
#line 5359 "MediaDataRepresentation.c"
		GeeHashSet* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
#line 712 "../src/MediaDataRepresentation.vala"
		_tmp54_ = to_tombstone;
#line 712 "../src/MediaDataRepresentation.vala"
		_tmp55_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp54_);
#line 712 "../src/MediaDataRepresentation.vala"
		_tmp56_ = _tmp55_;
#line 712 "../src/MediaDataRepresentation.vala"
		_tmp52_ = _tmp56_ > 0;
#line 5371 "MediaDataRepresentation.c"
	} else {
#line 712 "../src/MediaDataRepresentation.vala"
		_tmp52_ = FALSE;
#line 5375 "MediaDataRepresentation.c"
	}
#line 712 "../src/MediaDataRepresentation.vala"
	if (_tmp52_) {
#line 5379 "MediaDataRepresentation.c"
		{
			GeeHashSet* _tmp57_;
#line 714 "../src/MediaDataRepresentation.vala"
			_tmp57_ = to_tombstone;
#line 714 "../src/MediaDataRepresentation.vala"
			tombstone_entomb_many_sources ((GeeCollection*) _tmp57_, TOMBSTONE_REASON_REMOVED_BY_USER, &_inner_error0_);
#line 714 "../src/MediaDataRepresentation.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 714 "../src/MediaDataRepresentation.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5390 "MediaDataRepresentation.c"
					goto __catch0_database_error;
				}
#line 714 "../src/MediaDataRepresentation.vala"
				_aggregate_progress_monitor_unref0 (agg_monitor);
#line 714 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (not_trashed);
#line 714 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (offlined);
#line 714 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (trashed);
#line 714 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (to_tombstone);
#line 714 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_tmp0_);
#line 714 "../src/MediaDataRepresentation.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 714 "../src/MediaDataRepresentation.vala"
				g_clear_error (&_inner_error0_);
#line 714 "../src/MediaDataRepresentation.vala"
				return;
#line 5411 "MediaDataRepresentation.c"
			}
		}
		goto __finally0;
		__catch0_database_error:
		{
			GError* err = NULL;
			GError* _tmp58_;
#line 713 "../src/MediaDataRepresentation.vala"
			err = _inner_error0_;
#line 713 "../src/MediaDataRepresentation.vala"
			_inner_error0_ = NULL;
#line 716 "../src/MediaDataRepresentation.vala"
			_tmp58_ = err;
#line 716 "../src/MediaDataRepresentation.vala"
			app_window_database_error (_tmp58_);
#line 713 "../src/MediaDataRepresentation.vala"
			_g_error_free0 (err);
#line 5429 "MediaDataRepresentation.c"
		}
		__finally0:
#line 713 "../src/MediaDataRepresentation.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 713 "../src/MediaDataRepresentation.vala"
			_aggregate_progress_monitor_unref0 (agg_monitor);
#line 713 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (not_trashed);
#line 713 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (offlined);
#line 713 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (trashed);
#line 713 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (to_tombstone);
#line 713 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (_tmp0_);
#line 713 "../src/MediaDataRepresentation.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 713 "../src/MediaDataRepresentation.vala"
			g_clear_error (&_inner_error0_);
#line 713 "../src/MediaDataRepresentation.vala"
			return;
#line 5452 "MediaDataRepresentation.c"
		}
	}
#line 670 "../src/MediaDataRepresentation.vala"
	_aggregate_progress_monitor_unref0 (agg_monitor);
#line 670 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (not_trashed);
#line 670 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (offlined);
#line 670 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (trashed);
#line 670 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (to_tombstone);
#line 670 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (_tmp0_);
#line 5467 "MediaDataRepresentation.c"
}

void
media_source_collection_delete_backing_files (MediaSourceCollection* self,
                                              GeeCollection* sources,
                                              ProgressMonitor monitor,
                                              gpointer monitor_target,
                                              GeeList* not_deleted)
{
	gint total_count = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint i = 0;
	GError* _inner_error0_ = NULL;
#line 723 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 723 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (sources != NULL);
#line 725 "../src/MediaDataRepresentation.vala"
	_tmp0_ = gee_collection_get_size (sources);
#line 725 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 725 "../src/MediaDataRepresentation.vala"
	total_count = _tmp1_;
#line 726 "../src/MediaDataRepresentation.vala"
	i = 1;
#line 5494 "MediaDataRepresentation.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp2_;
#line 728 "../src/MediaDataRepresentation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) sources);
#line 728 "../src/MediaDataRepresentation.vala"
		_source_it = _tmp2_;
#line 728 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 5504 "MediaDataRepresentation.c"
			GeeIterator* _tmp3_;
			MediaSource* source = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GFile* file = NULL;
			MediaSource* _tmp6_;
			GFile* _tmp7_;
			gboolean deleted = FALSE;
			GFile* _tmp14_;
			gboolean _tmp15_ = FALSE;
			gint _tmp17_;
#line 728 "../src/MediaDataRepresentation.vala"
			_tmp3_ = _source_it;
#line 728 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 728 "../src/MediaDataRepresentation.vala"
				break;
#line 5522 "MediaDataRepresentation.c"
			}
#line 728 "../src/MediaDataRepresentation.vala"
			_tmp4_ = _source_it;
#line 728 "../src/MediaDataRepresentation.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 728 "../src/MediaDataRepresentation.vala"
			source = (MediaSource*) _tmp5_;
#line 729 "../src/MediaDataRepresentation.vala"
			_tmp6_ = source;
#line 729 "../src/MediaDataRepresentation.vala"
			_tmp7_ = media_source_get_file (_tmp6_);
#line 729 "../src/MediaDataRepresentation.vala"
			file = _tmp7_;
#line 5536 "MediaDataRepresentation.c"
			{
				GFile* _tmp8_;
#line 731 "../src/MediaDataRepresentation.vala"
				_tmp8_ = file;
#line 731 "../src/MediaDataRepresentation.vala"
				g_file_delete (_tmp8_, NULL, &_inner_error0_);
#line 731 "../src/MediaDataRepresentation.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5545 "MediaDataRepresentation.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GFile* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GError* _tmp12_;
				const gchar* _tmp13_;
#line 730 "../src/MediaDataRepresentation.vala"
				err = _inner_error0_;
#line 730 "../src/MediaDataRepresentation.vala"
				_inner_error0_ = NULL;
#line 734 "../src/MediaDataRepresentation.vala"
				_tmp9_ = file;
#line 734 "../src/MediaDataRepresentation.vala"
				_tmp10_ = g_file_get_path (_tmp9_);
#line 734 "../src/MediaDataRepresentation.vala"
				_tmp11_ = _tmp10_;
#line 734 "../src/MediaDataRepresentation.vala"
				_tmp12_ = err;
#line 734 "../src/MediaDataRepresentation.vala"
				_tmp13_ = _tmp12_->message;
#line 734 "../src/MediaDataRepresentation.vala"
				g_debug ("MediaDataRepresentation.vala:734: Exception deleting file %s: %s", _tmp11_, _tmp13_);
#line 734 "../src/MediaDataRepresentation.vala"
				_g_free0 (_tmp11_);
#line 730 "../src/MediaDataRepresentation.vala"
				_g_error_free0 (err);
#line 5578 "MediaDataRepresentation.c"
			}
			__finally0:
#line 730 "../src/MediaDataRepresentation.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 730 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (file);
#line 730 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (source);
#line 730 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_source_it);
#line 730 "../src/MediaDataRepresentation.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 730 "../src/MediaDataRepresentation.vala"
				g_clear_error (&_inner_error0_);
#line 730 "../src/MediaDataRepresentation.vala"
				return;
#line 5595 "MediaDataRepresentation.c"
			}
#line 737 "../src/MediaDataRepresentation.vala"
			_tmp14_ = file;
#line 737 "../src/MediaDataRepresentation.vala"
			deleted = !g_file_query_exists (_tmp14_, NULL);
#line 738 "../src/MediaDataRepresentation.vala"
			if (!deleted) {
#line 738 "../src/MediaDataRepresentation.vala"
				_tmp15_ = NULL != not_deleted;
#line 5605 "MediaDataRepresentation.c"
			} else {
#line 738 "../src/MediaDataRepresentation.vala"
				_tmp15_ = FALSE;
#line 5609 "MediaDataRepresentation.c"
			}
#line 738 "../src/MediaDataRepresentation.vala"
			if (_tmp15_) {
#line 5613 "MediaDataRepresentation.c"
				MediaSource* _tmp16_;
#line 739 "../src/MediaDataRepresentation.vala"
				_tmp16_ = source;
#line 739 "../src/MediaDataRepresentation.vala"
				gee_collection_add ((GeeCollection*) not_deleted, _tmp16_);
#line 5619 "MediaDataRepresentation.c"
			}
#line 742 "../src/MediaDataRepresentation.vala"
			if (monitor != NULL) {
#line 743 "../src/MediaDataRepresentation.vala"
				monitor ((guint64) i, (guint64) total_count, TRUE, monitor_target);
#line 5625 "MediaDataRepresentation.c"
			}
#line 745 "../src/MediaDataRepresentation.vala"
			_tmp17_ = i;
#line 745 "../src/MediaDataRepresentation.vala"
			i = _tmp17_ + 1;
#line 728 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (file);
#line 728 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (source);
#line 5635 "MediaDataRepresentation.c"
		}
#line 728 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_source_it);
#line 5639 "MediaDataRepresentation.c"
	}
}

TransactionController*
media_source_collection_get_transaction_controller (MediaSourceCollection* self)
{
	MediaSourceCollectionClass* _klass_;
#line 351 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 351 "../src/MediaDataRepresentation.vala"
	_klass_ = MEDIA_SOURCE_COLLECTION_GET_CLASS (self);
#line 351 "../src/MediaDataRepresentation.vala"
	if (_klass_->get_transaction_controller) {
#line 351 "../src/MediaDataRepresentation.vala"
		return _klass_->get_transaction_controller (self);
#line 5655 "MediaDataRepresentation.c"
	}
#line 351 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 5659 "MediaDataRepresentation.c"
}

static void
media_source_collection_real_media_import_starting (MediaSourceCollection* self,
                                                    GeeCollection* media)
{
#line 365 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 5668 "MediaDataRepresentation.c"
}

static void
media_source_collection_real_media_import_completed (MediaSourceCollection* self,
                                                     GeeCollection* media)
{
#line 372 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 5677 "MediaDataRepresentation.c"
}

static void
media_source_collection_real_master_file_replaced (MediaSourceCollection* self,
                                                   MediaSource* media,
                                                   GFile* old_file,
                                                   GFile* new_file)
{
#line 375 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (media != NULL);
#line 375 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (old_file != NULL);
#line 375 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (new_file != NULL);
#line 5692 "MediaDataRepresentation.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 349 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (n_param_values == 4);
#line 349 "../src/MediaDataRepresentation.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 349 "../src/MediaDataRepresentation.vala"
		data1 = closure->data;
#line 349 "../src/MediaDataRepresentation.vala"
		data2 = param_values->data[0].v_pointer;
#line 5717 "MediaDataRepresentation.c"
	} else {
#line 349 "../src/MediaDataRepresentation.vala"
		data1 = param_values->data[0].v_pointer;
#line 349 "../src/MediaDataRepresentation.vala"
		data2 = closure->data;
#line 5723 "MediaDataRepresentation.c"
	}
#line 349 "../src/MediaDataRepresentation.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 349 "../src/MediaDataRepresentation.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 5729 "MediaDataRepresentation.c"
}

static void
media_source_collection_real_trashcan_contents_altered (MediaSourceCollection* self,
                                                        GeeCollection* added,
                                                        GeeCollection* removed)
{
}

static void
media_source_collection_real_import_roll_altered (MediaSourceCollection* self)
{
}

static void
media_source_collection_real_offline_contents_altered (MediaSourceCollection* self,
                                                       GeeCollection* added,
                                                       GeeCollection* removed)
{
}

static void
media_source_collection_real_flagged_contents_altered (MediaSourceCollection* self)
{
}

static void
media_source_collection_class_init (MediaSourceCollectionClass * klass,
                                    gpointer klass_data)
{
#line 349 "../src/MediaDataRepresentation.vala"
	media_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 349 "../src/MediaDataRepresentation.vala"
	((DataCollectionClass *) klass)->finalize = media_source_collection_finalize;
#line 349 "../src/MediaDataRepresentation.vala"
	g_type_class_adjust_private_offset (klass, &MediaSourceCollection_private_offset);
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) media_source_collection_real_create_trashcan;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) media_source_collection_real_create_offline_bin;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) media_source_collection_real_create_media_monitor;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) media_source_collection_real_get_typename;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) media_source_collection_real_is_file_recognized;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) media_source_collection_real_fetch_by_numeric_id;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->notify_import_roll_altered = (void (*) (MediaSourceCollection*)) media_source_collection_real_notify_import_roll_altered;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->notify_flagged_contents_altered = (void (*) (MediaSourceCollection*)) media_source_collection_real_notify_flagged_contents_altered;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->notify_media_import_starting = (void (*) (MediaSourceCollection*, GeeCollection*)) media_source_collection_real_notify_media_import_starting;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->notify_media_import_completed = (void (*) (MediaSourceCollection*, GeeCollection*)) media_source_collection_real_notify_media_import_completed;
#line 349 "../src/MediaDataRepresentation.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) media_source_collection_real_items_altered;
#line 349 "../src/MediaDataRepresentation.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) media_source_collection_real_notify_contents_altered;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*) (MediaSourceCollection*, const gchar*)) media_source_collection_real_fetch_by_source_id;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) media_source_collection_real_get_event_source_ids;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->import_many = (void (*) (MediaSourceCollection*, GeeCollection*)) media_source_collection_real_import_many;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*) (MediaSourceCollection*, GeeCollection*)) media_source_collection_real_postprocess_imported_media;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->media_import_starting = media_source_collection_real_media_import_starting;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->media_import_completed = media_source_collection_real_media_import_completed;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->master_file_replaced = media_source_collection_real_master_file_replaced;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->trashcan_contents_altered = media_source_collection_real_trashcan_contents_altered;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->import_roll_altered = media_source_collection_real_import_roll_altered;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->offline_contents_altered = media_source_collection_real_offline_contents_altered;
#line 349 "../src/MediaDataRepresentation.vala"
	((MediaSourceCollectionClass *) klass)->flagged_contents_altered = media_source_collection_real_flagged_contents_altered;
#line 349 "../src/MediaDataRepresentation.vala"
	media_source_collection_signals[MEDIA_SOURCE_COLLECTION_MEDIA_IMPORT_STARTING_SIGNAL] = g_signal_new ("media-import-starting", TYPE_MEDIA_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (MediaSourceCollectionClass, media_import_starting), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 349 "../src/MediaDataRepresentation.vala"
	media_source_collection_signals[MEDIA_SOURCE_COLLECTION_MEDIA_IMPORT_COMPLETED_SIGNAL] = g_signal_new ("media-import-completed", TYPE_MEDIA_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (MediaSourceCollectionClass, media_import_completed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 349 "../src/MediaDataRepresentation.vala"
	media_source_collection_signals[MEDIA_SOURCE_COLLECTION_MASTER_FILE_REPLACED_SIGNAL] = g_signal_new ("master-file-replaced", TYPE_MEDIA_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (MediaSourceCollectionClass, master_file_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, TYPE_MEDIA_SOURCE, g_file_get_type (), g_file_get_type ());
#line 349 "../src/MediaDataRepresentation.vala"
	media_source_collection_signals[MEDIA_SOURCE_COLLECTION_TRASHCAN_CONTENTS_ALTERED_SIGNAL] = g_signal_new ("trashcan-contents-altered", TYPE_MEDIA_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (MediaSourceCollectionClass, trashcan_contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_COLLECTION, GEE_TYPE_COLLECTION);
#line 349 "../src/MediaDataRepresentation.vala"
	media_source_collection_signals[MEDIA_SOURCE_COLLECTION_IMPORT_ROLL_ALTERED_SIGNAL] = g_signal_new ("import-roll-altered", TYPE_MEDIA_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (MediaSourceCollectionClass, import_roll_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 349 "../src/MediaDataRepresentation.vala"
	media_source_collection_signals[MEDIA_SOURCE_COLLECTION_OFFLINE_CONTENTS_ALTERED_SIGNAL] = g_signal_new ("offline-contents-altered", TYPE_MEDIA_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (MediaSourceCollectionClass, offline_contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_COLLECTION, GEE_TYPE_COLLECTION);
#line 349 "../src/MediaDataRepresentation.vala"
	media_source_collection_signals[MEDIA_SOURCE_COLLECTION_FLAGGED_CONTENTS_ALTERED_SIGNAL] = g_signal_new ("flagged-contents-altered", TYPE_MEDIA_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (MediaSourceCollectionClass, flagged_contents_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5826 "MediaDataRepresentation.c"
}

static void
media_source_collection_instance_init (MediaSourceCollection * self,
                                       gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeTreeMultiMap* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeHashSet* _tmp3_;
#line 349 "../src/MediaDataRepresentation.vala"
	self->priv = media_source_collection_get_instance_private (self);
#line 354 "../src/MediaDataRepresentation.vala"
	self->priv->trashcan = NULL;
#line 355 "../src/MediaDataRepresentation.vala"
	self->priv->offline_bin = NULL;
#line 356 "../src/MediaDataRepresentation.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 356 "../src/MediaDataRepresentation.vala"
	self->priv->by_master_file = _tmp0_;
#line 358 "../src/MediaDataRepresentation.vala"
	_tmp1_ = gee_tree_multi_map_new (TYPE_IMPORT_ID, (GBoxedCopyFunc) import_id_dup, (GDestroyNotify) import_id_free, TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _import_id_compare_func_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 358 "../src/MediaDataRepresentation.vala"
	self->priv->import_rolls = (GeeMultiMap*) _tmp1_;
#line 360 "../src/MediaDataRepresentation.vala"
	_tmp2_ = gee_tree_set_new (TYPE_IMPORT_ID, (GBoxedCopyFunc) import_id_dup, (GDestroyNotify) import_id_free, _import_id_compare_func_gcompare_data_func, NULL, NULL);
#line 360 "../src/MediaDataRepresentation.vala"
	self->priv->sorted_import_ids = _tmp2_;
#line 361 "../src/MediaDataRepresentation.vala"
	_tmp3_ = gee_hash_set_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 361 "../src/MediaDataRepresentation.vala"
	self->priv->flagged = (GeeSet*) _tmp3_;
#line 5859 "MediaDataRepresentation.c"
}

static void
media_source_collection_finalize (DataCollection * obj)
{
	MediaSourceCollection * self;
#line 349 "../src/MediaDataRepresentation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection);
#line 354 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (self->priv->trashcan);
#line 355 "../src/MediaDataRepresentation.vala"
	_source_holding_tank_unref0 (self->priv->offline_bin);
#line 356 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->by_master_file);
#line 358 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->import_rolls);
#line 360 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->sorted_import_ids);
#line 361 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->flagged);
#line 349 "../src/MediaDataRepresentation.vala"
	DATA_COLLECTION_CLASS (media_source_collection_parent_class)->finalize (obj);
#line 5882 "MediaDataRepresentation.c"
}

static GType
media_source_collection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaSourceCollection), 0, (GInstanceInitFunc) media_source_collection_instance_init, NULL };
	GType media_source_collection_type_id;
	media_source_collection_type_id = g_type_register_static (TYPE_DATABASE_SOURCE_COLLECTION, "MediaSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MediaSourceCollection_private_offset = g_type_add_instance_private (media_source_collection_type_id, sizeof (MediaSourceCollectionPrivate));
	return media_source_collection_type_id;
}

GType
media_source_collection_get_type (void)
{
	static volatile gsize media_source_collection_type_id__once = 0;
	if (g_once_init_enter (&media_source_collection_type_id__once)) {
		GType media_source_collection_type_id;
		media_source_collection_type_id = media_source_collection_get_type_once ();
		g_once_init_leave (&media_source_collection_type_id__once, media_source_collection_type_id);
	}
	return media_source_collection_type_id__once;
}

static inline gpointer
media_collection_registry_get_instance_private (MediaCollectionRegistry* self)
{
	return G_STRUCT_MEMBER_P (self, MediaCollectionRegistry_private_offset);
}

static void
_media_collection_registry_on_init_done_photos_application_init_done (PhotosApplication* _sender,
                                                                      gpointer self)
{
#line 766 "../src/MediaDataRepresentation.vala"
	media_collection_registry_on_init_done ((MediaCollectionRegistry*) self);
#line 5919 "MediaDataRepresentation.c"
}

static MediaCollectionRegistry*
media_collection_registry_construct (GType object_type)
{
	MediaCollectionRegistry* self = NULL;
	GApplication* _tmp0_;
#line 761 "../src/MediaDataRepresentation.vala"
	self = (MediaCollectionRegistry*) g_type_create_instance (object_type);
#line 762 "../src/MediaDataRepresentation.vala"
	_tmp0_ = g_application_get_default ();
#line 762 "../src/MediaDataRepresentation.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTOS_TYPE_APPLICATION, PhotosApplication), "init-done", (GCallback) _media_collection_registry_on_init_done_photos_application_init_done, self);
#line 761 "../src/MediaDataRepresentation.vala"
	return self;
#line 5935 "MediaDataRepresentation.c"
}

static MediaCollectionRegistry*
media_collection_registry_new (void)
{
#line 761 "../src/MediaDataRepresentation.vala"
	return media_collection_registry_construct (TYPE_MEDIA_COLLECTION_REGISTRY);
#line 5943 "MediaDataRepresentation.c"
}

static void
media_collection_registry_on_init_done (MediaCollectionRegistry* self)
{
	LibraryMonitor* library_monitor = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	LibraryMonitor* _tmp2_;
	LibraryMonitor* _tmp3_;
	LibraryMonitorPool* _tmp4_;
	LibraryMonitorPool* _tmp5_;
#line 769 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 771 "../src/MediaDataRepresentation.vala"
	_tmp0_ = app_dirs_get_import_dir ();
#line 771 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _tmp0_;
#line 771 "../src/MediaDataRepresentation.vala"
	_tmp2_ = library_monitor_new (_tmp1_, TRUE, !commandline_options_no_runtime_monitoring);
#line 771 "../src/MediaDataRepresentation.vala"
	_tmp3_ = _tmp2_;
#line 771 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (_tmp1_);
#line 771 "../src/MediaDataRepresentation.vala"
	library_monitor = _tmp3_;
#line 774 "../src/MediaDataRepresentation.vala"
	_tmp4_ = library_monitor_pool_get_instance ();
#line 774 "../src/MediaDataRepresentation.vala"
	_tmp5_ = _tmp4_;
#line 774 "../src/MediaDataRepresentation.vala"
	library_monitor_pool_replace (_tmp5_, library_monitor, MEDIA_COLLECTION_REGISTRY_LIBRARY_MONITOR_START_DELAY_MSEC);
#line 774 "../src/MediaDataRepresentation.vala"
	_library_monitor_pool_unref0 (_tmp5_);
#line 769 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (library_monitor);
#line 5980 "MediaDataRepresentation.c"
}

static void
_media_collection_registry_on_config_changed_g_settings_changed (GSettings* _sender,
                                                                 const gchar* key,
                                                                 gpointer self)
{
#line 780 "../src/MediaDataRepresentation.vala"
	media_collection_registry_on_config_changed (key);
#line 5990 "MediaDataRepresentation.c"
}

void
media_collection_registry_init (void)
{
	GSettings* _tmp0_;
	MediaCollectionRegistry* _tmp1_;
	GSettings* _tmp2_;
#line 778 "../src/MediaDataRepresentation.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_FILES_PREFS_SCHEMA_NAME);
#line 778 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (media_collection_registry_file_settings);
#line 778 "../src/MediaDataRepresentation.vala"
	media_collection_registry_file_settings = _tmp0_;
#line 779 "../src/MediaDataRepresentation.vala"
	_tmp1_ = media_collection_registry_new ();
#line 779 "../src/MediaDataRepresentation.vala"
	_media_collection_registry_unref0 (media_collection_registry_instance);
#line 779 "../src/MediaDataRepresentation.vala"
	media_collection_registry_instance = _tmp1_;
#line 780 "../src/MediaDataRepresentation.vala"
	_tmp2_ = media_collection_registry_file_settings;
#line 780 "../src/MediaDataRepresentation.vala"
	g_signal_connect (_tmp2_, "changed", (GCallback) _media_collection_registry_on_config_changed_g_settings_changed, NULL);
#line 6015 "MediaDataRepresentation.c"
}

static void
media_collection_registry_on_config_changed (const gchar* key)
{
	GFile* import_dir = NULL;
	GFile* _tmp0_;
	LibraryMonitor* current = NULL;
	LibraryMonitorPool* _tmp1_;
	LibraryMonitorPool* _tmp2_;
	LibraryMonitor* _tmp3_;
	LibraryMonitor* _tmp4_;
	gboolean _tmp5_ = FALSE;
	LibraryMonitor* _tmp6_;
	LibraryMonitor* replacement = NULL;
	GFile* _tmp11_;
	LibraryMonitor* _tmp12_;
	LibraryMonitorPool* _tmp13_;
	LibraryMonitorPool* _tmp14_;
	LibraryMonitor* _tmp15_;
#line 783 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (key != NULL);
#line 784 "../src/MediaDataRepresentation.vala"
	if (g_strcmp0 (key, "import-dir") != 0) {
#line 785 "../src/MediaDataRepresentation.vala"
		return;
#line 6042 "MediaDataRepresentation.c"
	}
#line 788 "../src/MediaDataRepresentation.vala"
	_tmp0_ = app_dirs_get_import_dir ();
#line 788 "../src/MediaDataRepresentation.vala"
	import_dir = _tmp0_;
#line 790 "../src/MediaDataRepresentation.vala"
	_tmp1_ = library_monitor_pool_get_instance ();
#line 790 "../src/MediaDataRepresentation.vala"
	_tmp2_ = _tmp1_;
#line 790 "../src/MediaDataRepresentation.vala"
	_tmp3_ = library_monitor_pool_get_monitor (_tmp2_);
#line 790 "../src/MediaDataRepresentation.vala"
	_tmp4_ = _tmp3_;
#line 790 "../src/MediaDataRepresentation.vala"
	_library_monitor_pool_unref0 (_tmp2_);
#line 790 "../src/MediaDataRepresentation.vala"
	current = _tmp4_;
#line 791 "../src/MediaDataRepresentation.vala"
	_tmp6_ = current;
#line 791 "../src/MediaDataRepresentation.vala"
	if (_tmp6_ != NULL) {
#line 6064 "MediaDataRepresentation.c"
		LibraryMonitor* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
#line 791 "../src/MediaDataRepresentation.vala"
		_tmp7_ = current;
#line 791 "../src/MediaDataRepresentation.vala"
		_tmp8_ = directory_monitor_get_root ((DirectoryMonitor*) _tmp7_);
#line 791 "../src/MediaDataRepresentation.vala"
		_tmp9_ = _tmp8_;
#line 791 "../src/MediaDataRepresentation.vala"
		_tmp10_ = import_dir;
#line 791 "../src/MediaDataRepresentation.vala"
		_tmp5_ = g_file_equal (_tmp9_, _tmp10_);
#line 791 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp9_);
#line 6081 "MediaDataRepresentation.c"
	} else {
#line 791 "../src/MediaDataRepresentation.vala"
		_tmp5_ = FALSE;
#line 6085 "MediaDataRepresentation.c"
	}
#line 791 "../src/MediaDataRepresentation.vala"
	if (_tmp5_) {
#line 792 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (current);
#line 792 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (import_dir);
#line 792 "../src/MediaDataRepresentation.vala"
		return;
#line 6095 "MediaDataRepresentation.c"
	}
#line 794 "../src/MediaDataRepresentation.vala"
	_tmp11_ = import_dir;
#line 794 "../src/MediaDataRepresentation.vala"
	_tmp12_ = library_monitor_new (_tmp11_, TRUE, !commandline_options_no_runtime_monitoring);
#line 794 "../src/MediaDataRepresentation.vala"
	replacement = _tmp12_;
#line 796 "../src/MediaDataRepresentation.vala"
	_tmp13_ = library_monitor_pool_get_instance ();
#line 796 "../src/MediaDataRepresentation.vala"
	_tmp14_ = _tmp13_;
#line 796 "../src/MediaDataRepresentation.vala"
	_tmp15_ = replacement;
#line 796 "../src/MediaDataRepresentation.vala"
	library_monitor_pool_replace (_tmp14_, _tmp15_, MEDIA_COLLECTION_REGISTRY_LIBRARY_MONITOR_START_DELAY_MSEC);
#line 796 "../src/MediaDataRepresentation.vala"
	_library_monitor_pool_unref0 (_tmp14_);
#line 783 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (replacement);
#line 783 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (current);
#line 783 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (import_dir);
#line 6119 "MediaDataRepresentation.c"
}

static gpointer
_media_collection_registry_ref0 (gpointer self)
{
#line 800 "../src/MediaDataRepresentation.vala"
	return self ? media_collection_registry_ref (self) : NULL;
#line 6127 "MediaDataRepresentation.c"
}

MediaCollectionRegistry*
media_collection_registry_get_instance (void)
{
	MediaCollectionRegistry* _tmp0_;
	MediaCollectionRegistry* _tmp1_;
	MediaCollectionRegistry* result;
#line 800 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_collection_registry_instance;
#line 800 "../src/MediaDataRepresentation.vala"
	_tmp1_ = _media_collection_registry_ref0 (_tmp0_);
#line 800 "../src/MediaDataRepresentation.vala"
	result = _tmp1_;
#line 800 "../src/MediaDataRepresentation.vala"
	return result;
#line 6144 "MediaDataRepresentation.c"
}

gchar*
media_collection_registry_get_typename_from_source_id (const gchar* source_id)
{
	gchar* result;
#line 803 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 806 "../src/MediaDataRepresentation.vala"
	if (g_str_has_prefix (source_id, PHOTO_TYPENAME)) {
#line 6155 "MediaDataRepresentation.c"
		gchar* _tmp0_;
#line 807 "../src/MediaDataRepresentation.vala"
		_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 807 "../src/MediaDataRepresentation.vala"
		result = _tmp0_;
#line 807 "../src/MediaDataRepresentation.vala"
		return result;
#line 6163 "MediaDataRepresentation.c"
	} else {
		gchar** components = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint components_length1;
		gint _components_size_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 809 "../src/MediaDataRepresentation.vala"
		_tmp2_ = _tmp1_ = g_strsplit (source_id, "-", 0);
#line 809 "../src/MediaDataRepresentation.vala"
		components = _tmp2_;
#line 809 "../src/MediaDataRepresentation.vala"
		components_length1 = _vala_array_length (_tmp1_);
#line 809 "../src/MediaDataRepresentation.vala"
		_components_size_ = components_length1;
#line 810 "../src/MediaDataRepresentation.vala"
		_tmp3_ = components;
#line 810 "../src/MediaDataRepresentation.vala"
		_tmp3__length1 = components_length1;
#line 810 "../src/MediaDataRepresentation.vala"
		_vala_assert (_tmp3__length1 == 2, "components.length == 2");
#line 812 "../src/MediaDataRepresentation.vala"
		_tmp4_ = components;
#line 812 "../src/MediaDataRepresentation.vala"
		_tmp4__length1 = components_length1;
#line 812 "../src/MediaDataRepresentation.vala"
		_tmp5_ = _tmp4_[0];
#line 812 "../src/MediaDataRepresentation.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 812 "../src/MediaDataRepresentation.vala"
		result = _tmp6_;
#line 812 "../src/MediaDataRepresentation.vala"
		components = (_vala_array_free (components, components_length1, (GDestroyNotify) g_free), NULL);
#line 812 "../src/MediaDataRepresentation.vala"
		return result;
#line 6204 "MediaDataRepresentation.c"
	}
}

void
media_collection_registry_register_collection (MediaCollectionRegistry* self,
                                               MediaSourceCollection* collection)
{
	GeeArrayList* _tmp0_;
	GeeHashMap* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 816 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 816 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (collection != NULL);
#line 817 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->all;
#line 817 "../src/MediaDataRepresentation.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, collection);
#line 818 "../src/MediaDataRepresentation.vala"
	_tmp1_ = self->priv->by_typename;
#line 818 "../src/MediaDataRepresentation.vala"
	_tmp2_ = media_source_collection_get_typename (collection);
#line 818 "../src/MediaDataRepresentation.vala"
	_tmp3_ = _tmp2_;
#line 818 "../src/MediaDataRepresentation.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, _tmp3_, collection);
#line 818 "../src/MediaDataRepresentation.vala"
	_g_free0 (_tmp3_);
#line 6234 "MediaDataRepresentation.c"
}

MediaSourceCollection*
media_collection_registry_get_collection (MediaCollectionRegistry* self,
                                          const gchar* typename)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MediaSourceCollection* result;
#line 825 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 825 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (typename != NULL, NULL);
#line 826 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->by_typename;
#line 826 "../src/MediaDataRepresentation.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, typename);
#line 826 "../src/MediaDataRepresentation.vala"
	result = (MediaSourceCollection*) _tmp1_;
#line 826 "../src/MediaDataRepresentation.vala"
	return result;
#line 6256 "MediaDataRepresentation.c"
}

GeeCollection*
media_collection_registry_get_all (MediaCollectionRegistry* self)
{
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeCollection* result;
#line 829 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 830 "../src/MediaDataRepresentation.vala"
	_tmp0_ = self->priv->all;
#line 830 "../src/MediaDataRepresentation.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 830 "../src/MediaDataRepresentation.vala"
	_tmp2_ = _tmp1_;
#line 830 "../src/MediaDataRepresentation.vala"
	result = (GeeCollection*) _tmp2_;
#line 830 "../src/MediaDataRepresentation.vala"
	return result;
#line 6278 "MediaDataRepresentation.c"
}

void
media_collection_registry_freeze_all (MediaCollectionRegistry* self)
{
#line 833 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 6286 "MediaDataRepresentation.c"
	{
		GeeIterator* _sources_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 834 "../src/MediaDataRepresentation.vala"
		_tmp0_ = media_collection_registry_get_all (self);
#line 834 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp0_;
#line 834 "../src/MediaDataRepresentation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 834 "../src/MediaDataRepresentation.vala"
		_tmp3_ = _tmp2_;
#line 834 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp1_);
#line 834 "../src/MediaDataRepresentation.vala"
		_sources_it = _tmp3_;
#line 834 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 6307 "MediaDataRepresentation.c"
			GeeIterator* _tmp4_;
			MediaSourceCollection* sources = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MediaSourceCollection* _tmp7_;
#line 834 "../src/MediaDataRepresentation.vala"
			_tmp4_ = _sources_it;
#line 834 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 834 "../src/MediaDataRepresentation.vala"
				break;
#line 6319 "MediaDataRepresentation.c"
			}
#line 834 "../src/MediaDataRepresentation.vala"
			_tmp5_ = _sources_it;
#line 834 "../src/MediaDataRepresentation.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 834 "../src/MediaDataRepresentation.vala"
			sources = (MediaSourceCollection*) _tmp6_;
#line 835 "../src/MediaDataRepresentation.vala"
			_tmp7_ = sources;
#line 835 "../src/MediaDataRepresentation.vala"
			data_collection_freeze_notifications ((DataCollection*) _tmp7_);
#line 834 "../src/MediaDataRepresentation.vala"
			_data_collection_unref0 (sources);
#line 6333 "MediaDataRepresentation.c"
		}
#line 834 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_sources_it);
#line 6337 "MediaDataRepresentation.c"
	}
}

void
media_collection_registry_thaw_all (MediaCollectionRegistry* self)
{
#line 838 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 6346 "MediaDataRepresentation.c"
	{
		GeeIterator* _sources_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 839 "../src/MediaDataRepresentation.vala"
		_tmp0_ = media_collection_registry_get_all (self);
#line 839 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp0_;
#line 839 "../src/MediaDataRepresentation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 839 "../src/MediaDataRepresentation.vala"
		_tmp3_ = _tmp2_;
#line 839 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp1_);
#line 839 "../src/MediaDataRepresentation.vala"
		_sources_it = _tmp3_;
#line 839 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 6367 "MediaDataRepresentation.c"
			GeeIterator* _tmp4_;
			MediaSourceCollection* sources = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MediaSourceCollection* _tmp7_;
#line 839 "../src/MediaDataRepresentation.vala"
			_tmp4_ = _sources_it;
#line 839 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 839 "../src/MediaDataRepresentation.vala"
				break;
#line 6379 "MediaDataRepresentation.c"
			}
#line 839 "../src/MediaDataRepresentation.vala"
			_tmp5_ = _sources_it;
#line 839 "../src/MediaDataRepresentation.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 839 "../src/MediaDataRepresentation.vala"
			sources = (MediaSourceCollection*) _tmp6_;
#line 840 "../src/MediaDataRepresentation.vala"
			_tmp7_ = sources;
#line 840 "../src/MediaDataRepresentation.vala"
			data_collection_thaw_notifications ((DataCollection*) _tmp7_);
#line 839 "../src/MediaDataRepresentation.vala"
			_data_collection_unref0 (sources);
#line 6393 "MediaDataRepresentation.c"
		}
#line 839 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_sources_it);
#line 6397 "MediaDataRepresentation.c"
	}
}

void
media_collection_registry_begin_transaction_on_all (MediaCollectionRegistry* self)
{
#line 843 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 6406 "MediaDataRepresentation.c"
	{
		GeeIterator* _sources_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 844 "../src/MediaDataRepresentation.vala"
		_tmp0_ = media_collection_registry_get_all (self);
#line 844 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp0_;
#line 844 "../src/MediaDataRepresentation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 844 "../src/MediaDataRepresentation.vala"
		_tmp3_ = _tmp2_;
#line 844 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp1_);
#line 844 "../src/MediaDataRepresentation.vala"
		_sources_it = _tmp3_;
#line 844 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 6427 "MediaDataRepresentation.c"
			GeeIterator* _tmp4_;
			MediaSourceCollection* sources = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MediaSourceCollection* _tmp7_;
			TransactionController* _tmp8_;
			TransactionController* _tmp9_;
#line 844 "../src/MediaDataRepresentation.vala"
			_tmp4_ = _sources_it;
#line 844 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 844 "../src/MediaDataRepresentation.vala"
				break;
#line 6441 "MediaDataRepresentation.c"
			}
#line 844 "../src/MediaDataRepresentation.vala"
			_tmp5_ = _sources_it;
#line 844 "../src/MediaDataRepresentation.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 844 "../src/MediaDataRepresentation.vala"
			sources = (MediaSourceCollection*) _tmp6_;
#line 845 "../src/MediaDataRepresentation.vala"
			_tmp7_ = sources;
#line 845 "../src/MediaDataRepresentation.vala"
			_tmp8_ = media_source_collection_get_transaction_controller (_tmp7_);
#line 845 "../src/MediaDataRepresentation.vala"
			_tmp9_ = _tmp8_;
#line 845 "../src/MediaDataRepresentation.vala"
			transaction_controller_begin (_tmp9_);
#line 844 "../src/MediaDataRepresentation.vala"
			_data_collection_unref0 (sources);
#line 6459 "MediaDataRepresentation.c"
		}
#line 844 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_sources_it);
#line 6463 "MediaDataRepresentation.c"
	}
}

void
media_collection_registry_commit_transaction_on_all (MediaCollectionRegistry* self)
{
#line 848 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (self != NULL);
#line 6472 "MediaDataRepresentation.c"
	{
		GeeIterator* _sources_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 849 "../src/MediaDataRepresentation.vala"
		_tmp0_ = media_collection_registry_get_all (self);
#line 849 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp0_;
#line 849 "../src/MediaDataRepresentation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 849 "../src/MediaDataRepresentation.vala"
		_tmp3_ = _tmp2_;
#line 849 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp1_);
#line 849 "../src/MediaDataRepresentation.vala"
		_sources_it = _tmp3_;
#line 849 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 6493 "MediaDataRepresentation.c"
			GeeIterator* _tmp4_;
			MediaSourceCollection* sources = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MediaSourceCollection* _tmp7_;
			TransactionController* _tmp8_;
			TransactionController* _tmp9_;
#line 849 "../src/MediaDataRepresentation.vala"
			_tmp4_ = _sources_it;
#line 849 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 849 "../src/MediaDataRepresentation.vala"
				break;
#line 6507 "MediaDataRepresentation.c"
			}
#line 849 "../src/MediaDataRepresentation.vala"
			_tmp5_ = _sources_it;
#line 849 "../src/MediaDataRepresentation.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 849 "../src/MediaDataRepresentation.vala"
			sources = (MediaSourceCollection*) _tmp6_;
#line 850 "../src/MediaDataRepresentation.vala"
			_tmp7_ = sources;
#line 850 "../src/MediaDataRepresentation.vala"
			_tmp8_ = media_source_collection_get_transaction_controller (_tmp7_);
#line 850 "../src/MediaDataRepresentation.vala"
			_tmp9_ = _tmp8_;
#line 850 "../src/MediaDataRepresentation.vala"
			transaction_controller_commit (_tmp9_);
#line 849 "../src/MediaDataRepresentation.vala"
			_data_collection_unref0 (sources);
#line 6525 "MediaDataRepresentation.c"
		}
#line 849 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_sources_it);
#line 6529 "MediaDataRepresentation.c"
	}
}

MediaSource*
media_collection_registry_fetch_media (MediaCollectionRegistry* self,
                                       const gchar* source_id)
{
	gchar* typename = NULL;
	gchar* _tmp0_;
	MediaSourceCollection* collection = NULL;
	const gchar* _tmp1_;
	MediaSourceCollection* _tmp2_;
	MediaSourceCollection* _tmp3_;
	MediaSourceCollection* _tmp5_;
	MediaSource* _tmp6_;
	MediaSource* result;
#line 853 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 853 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 854 "../src/MediaDataRepresentation.vala"
	_tmp0_ = media_collection_registry_get_typename_from_source_id (source_id);
#line 854 "../src/MediaDataRepresentation.vala"
	typename = _tmp0_;
#line 856 "../src/MediaDataRepresentation.vala"
	_tmp1_ = typename;
#line 856 "../src/MediaDataRepresentation.vala"
	_tmp2_ = media_collection_registry_get_collection (self, _tmp1_);
#line 856 "../src/MediaDataRepresentation.vala"
	collection = _tmp2_;
#line 857 "../src/MediaDataRepresentation.vala"
	_tmp3_ = collection;
#line 857 "../src/MediaDataRepresentation.vala"
	if (_tmp3_ == NULL) {
#line 6564 "MediaDataRepresentation.c"
		const gchar* _tmp4_;
#line 858 "../src/MediaDataRepresentation.vala"
		_tmp4_ = typename;
#line 858 "../src/MediaDataRepresentation.vala"
		g_critical ("MediaDataRepresentation.vala:858: source id '%s' has unrecognized medi" \
"a type '%s'", source_id, _tmp4_);
#line 859 "../src/MediaDataRepresentation.vala"
		result = NULL;
#line 859 "../src/MediaDataRepresentation.vala"
		_data_collection_unref0 (collection);
#line 859 "../src/MediaDataRepresentation.vala"
		_g_free0 (typename);
#line 859 "../src/MediaDataRepresentation.vala"
		return result;
#line 6578 "MediaDataRepresentation.c"
	}
#line 862 "../src/MediaDataRepresentation.vala"
	_tmp5_ = collection;
#line 862 "../src/MediaDataRepresentation.vala"
	_tmp6_ = media_source_collection_fetch_by_source_id (_tmp5_, source_id);
#line 862 "../src/MediaDataRepresentation.vala"
	result = _tmp6_;
#line 862 "../src/MediaDataRepresentation.vala"
	_data_collection_unref0 (collection);
#line 862 "../src/MediaDataRepresentation.vala"
	_g_free0 (typename);
#line 862 "../src/MediaDataRepresentation.vala"
	return result;
#line 6592 "MediaDataRepresentation.c"
}

static gpointer
_import_id_dup0 (gpointer self)
{
#line 883 "../src/MediaDataRepresentation.vala"
	return self ? import_id_dup (self) : NULL;
#line 6600 "MediaDataRepresentation.c"
}

ImportID*
media_collection_registry_get_last_import_id (MediaCollectionRegistry* self)
{
	ImportID last_import_id = {0};
	ImportID _tmp13_;
	ImportID* result;
#line 865 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 866 "../src/MediaDataRepresentation.vala"
	import_id_init (&last_import_id, IMPORT_ID_INVALID);
#line 6613 "MediaDataRepresentation.c"
	{
		GeeIterator* _current_collection_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 868 "../src/MediaDataRepresentation.vala"
		_tmp0_ = media_collection_registry_get_all (self);
#line 868 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp0_;
#line 868 "../src/MediaDataRepresentation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 868 "../src/MediaDataRepresentation.vala"
		_tmp3_ = _tmp2_;
#line 868 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp1_);
#line 868 "../src/MediaDataRepresentation.vala"
		_current_collection_it = _tmp3_;
#line 868 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 6634 "MediaDataRepresentation.c"
			GeeIterator* _tmp4_;
			MediaSourceCollection* current_collection = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			ImportID* current_import_id = NULL;
			MediaSourceCollection* _tmp7_;
			ImportID* _tmp8_;
			ImportID* _tmp9_;
			ImportID* _tmp10_;
			ImportID _tmp11_;
#line 868 "../src/MediaDataRepresentation.vala"
			_tmp4_ = _current_collection_it;
#line 868 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 868 "../src/MediaDataRepresentation.vala"
				break;
#line 6651 "MediaDataRepresentation.c"
			}
#line 868 "../src/MediaDataRepresentation.vala"
			_tmp5_ = _current_collection_it;
#line 868 "../src/MediaDataRepresentation.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 868 "../src/MediaDataRepresentation.vala"
			current_collection = (MediaSourceCollection*) _tmp6_;
#line 869 "../src/MediaDataRepresentation.vala"
			_tmp7_ = current_collection;
#line 869 "../src/MediaDataRepresentation.vala"
			_tmp8_ = media_source_collection_get_last_import_id (_tmp7_);
#line 869 "../src/MediaDataRepresentation.vala"
			current_import_id = _tmp8_;
#line 871 "../src/MediaDataRepresentation.vala"
			_tmp9_ = current_import_id;
#line 871 "../src/MediaDataRepresentation.vala"
			if (_tmp9_ == NULL) {
#line 872 "../src/MediaDataRepresentation.vala"
				_import_id_free0 (current_import_id);
#line 872 "../src/MediaDataRepresentation.vala"
				_data_collection_unref0 (current_collection);
#line 872 "../src/MediaDataRepresentation.vala"
				continue;
#line 6675 "MediaDataRepresentation.c"
			}
#line 874 "../src/MediaDataRepresentation.vala"
			_tmp10_ = current_import_id;
#line 874 "../src/MediaDataRepresentation.vala"
			_tmp11_ = last_import_id;
#line 874 "../src/MediaDataRepresentation.vala"
			if ((*_tmp10_).id > _tmp11_.id) {
#line 6683 "MediaDataRepresentation.c"
				ImportID* _tmp12_;
#line 875 "../src/MediaDataRepresentation.vala"
				_tmp12_ = current_import_id;
#line 875 "../src/MediaDataRepresentation.vala"
				last_import_id = *_tmp12_;
#line 6689 "MediaDataRepresentation.c"
			}
#line 868 "../src/MediaDataRepresentation.vala"
			_import_id_free0 (current_import_id);
#line 868 "../src/MediaDataRepresentation.vala"
			_data_collection_unref0 (current_collection);
#line 6695 "MediaDataRepresentation.c"
		}
#line 868 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_current_collection_it);
#line 6699 "MediaDataRepresentation.c"
	}
#line 880 "../src/MediaDataRepresentation.vala"
	_tmp13_ = last_import_id;
#line 880 "../src/MediaDataRepresentation.vala"
	if (_tmp13_.id == IMPORT_ID_INVALID) {
#line 881 "../src/MediaDataRepresentation.vala"
		result = NULL;
#line 881 "../src/MediaDataRepresentation.vala"
		return result;
#line 6709 "MediaDataRepresentation.c"
	} else {
		ImportID* _tmp14_;
#line 883 "../src/MediaDataRepresentation.vala"
		_tmp14_ = _import_id_dup0 (&last_import_id);
#line 883 "../src/MediaDataRepresentation.vala"
		result = _tmp14_;
#line 883 "../src/MediaDataRepresentation.vala"
		return result;
#line 6718 "MediaDataRepresentation.c"
	}
}

GeeCollection*
media_collection_registry_get_source_ids_for_event_id (MediaCollectionRegistry* self,
                                                       EventID* event_id)
{
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeCollection* result;
#line 886 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 886 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 887 "../src/MediaDataRepresentation.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 887 "../src/MediaDataRepresentation.vala"
	_result_ = _tmp0_;
#line 6737 "MediaDataRepresentation.c"
	{
		GeeIterator* _current_collection_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 889 "../src/MediaDataRepresentation.vala"
		_tmp1_ = media_collection_registry_get_all (self);
#line 889 "../src/MediaDataRepresentation.vala"
		_tmp2_ = _tmp1_;
#line 889 "../src/MediaDataRepresentation.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 889 "../src/MediaDataRepresentation.vala"
		_tmp4_ = _tmp3_;
#line 889 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp2_);
#line 889 "../src/MediaDataRepresentation.vala"
		_current_collection_it = _tmp4_;
#line 889 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 6758 "MediaDataRepresentation.c"
			GeeIterator* _tmp5_;
			MediaSourceCollection* current_collection = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeArrayList* _tmp8_;
			MediaSourceCollection* _tmp9_;
			EventID _tmp10_;
			GeeCollection* _tmp11_;
			GeeCollection* _tmp12_;
#line 889 "../src/MediaDataRepresentation.vala"
			_tmp5_ = _current_collection_it;
#line 889 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 889 "../src/MediaDataRepresentation.vala"
				break;
#line 6774 "MediaDataRepresentation.c"
			}
#line 889 "../src/MediaDataRepresentation.vala"
			_tmp6_ = _current_collection_it;
#line 889 "../src/MediaDataRepresentation.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 889 "../src/MediaDataRepresentation.vala"
			current_collection = (MediaSourceCollection*) _tmp7_;
#line 890 "../src/MediaDataRepresentation.vala"
			_tmp8_ = _result_;
#line 890 "../src/MediaDataRepresentation.vala"
			_tmp9_ = current_collection;
#line 890 "../src/MediaDataRepresentation.vala"
			_tmp10_ = *event_id;
#line 890 "../src/MediaDataRepresentation.vala"
			_tmp11_ = media_source_collection_get_event_source_ids (_tmp9_, &_tmp10_);
#line 890 "../src/MediaDataRepresentation.vala"
			_tmp12_ = _tmp11_;
#line 890 "../src/MediaDataRepresentation.vala"
			gee_array_list_add_all (_tmp8_, _tmp12_);
#line 890 "../src/MediaDataRepresentation.vala"
			_g_object_unref0 (_tmp12_);
#line 889 "../src/MediaDataRepresentation.vala"
			_data_collection_unref0 (current_collection);
#line 6798 "MediaDataRepresentation.c"
		}
#line 889 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_current_collection_it);
#line 6802 "MediaDataRepresentation.c"
	}
#line 893 "../src/MediaDataRepresentation.vala"
	result = (GeeCollection*) _result_;
#line 893 "../src/MediaDataRepresentation.vala"
	return result;
#line 6808 "MediaDataRepresentation.c"
}

MediaSourceCollection*
media_collection_registry_get_collection_for_file (MediaCollectionRegistry* self,
                                                   GFile* file)
{
	MediaSourceCollection* result;
#line 896 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 896 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 6820 "MediaDataRepresentation.c"
	{
		GeeIterator* _collection_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 897 "../src/MediaDataRepresentation.vala"
		_tmp0_ = media_collection_registry_get_all (self);
#line 897 "../src/MediaDataRepresentation.vala"
		_tmp1_ = _tmp0_;
#line 897 "../src/MediaDataRepresentation.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 897 "../src/MediaDataRepresentation.vala"
		_tmp3_ = _tmp2_;
#line 897 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_tmp1_);
#line 897 "../src/MediaDataRepresentation.vala"
		_collection_it = _tmp3_;
#line 897 "../src/MediaDataRepresentation.vala"
		while (TRUE) {
#line 6841 "MediaDataRepresentation.c"
			GeeIterator* _tmp4_;
			MediaSourceCollection* collection = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MediaSourceCollection* _tmp7_;
#line 897 "../src/MediaDataRepresentation.vala"
			_tmp4_ = _collection_it;
#line 897 "../src/MediaDataRepresentation.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 897 "../src/MediaDataRepresentation.vala"
				break;
#line 6853 "MediaDataRepresentation.c"
			}
#line 897 "../src/MediaDataRepresentation.vala"
			_tmp5_ = _collection_it;
#line 897 "../src/MediaDataRepresentation.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 897 "../src/MediaDataRepresentation.vala"
			collection = (MediaSourceCollection*) _tmp6_;
#line 898 "../src/MediaDataRepresentation.vala"
			_tmp7_ = collection;
#line 898 "../src/MediaDataRepresentation.vala"
			if (media_source_collection_is_file_recognized (_tmp7_, file)) {
#line 899 "../src/MediaDataRepresentation.vala"
				result = collection;
#line 899 "../src/MediaDataRepresentation.vala"
				_g_object_unref0 (_collection_it);
#line 899 "../src/MediaDataRepresentation.vala"
				return result;
#line 6871 "MediaDataRepresentation.c"
			}
#line 897 "../src/MediaDataRepresentation.vala"
			_data_collection_unref0 (collection);
#line 6875 "MediaDataRepresentation.c"
		}
#line 897 "../src/MediaDataRepresentation.vala"
		_g_object_unref0 (_collection_it);
#line 6879 "MediaDataRepresentation.c"
	}
#line 902 "../src/MediaDataRepresentation.vala"
	result = NULL;
#line 902 "../src/MediaDataRepresentation.vala"
	return result;
#line 6885 "MediaDataRepresentation.c"
}

gboolean
media_collection_registry_is_valid_source_id (MediaCollectionRegistry* self,
                                              const gchar* source_id)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 905 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 906 "../src/MediaDataRepresentation.vala"
	if (is_string_empty (source_id)) {
#line 907 "../src/MediaDataRepresentation.vala"
		result = FALSE;
#line 907 "../src/MediaDataRepresentation.vala"
		return result;
#line 6902 "MediaDataRepresentation.c"
	}
#line 909 "../src/MediaDataRepresentation.vala"
	if (g_str_has_prefix (source_id, PHOTO_TYPENAME)) {
#line 909 "../src/MediaDataRepresentation.vala"
		_tmp0_ = TRUE;
#line 6908 "MediaDataRepresentation.c"
	} else {
#line 909 "../src/MediaDataRepresentation.vala"
		_tmp0_ = g_str_has_prefix (source_id, VIDEO_TYPENAME "-");
#line 6912 "MediaDataRepresentation.c"
	}
#line 909 "../src/MediaDataRepresentation.vala"
	result = _tmp0_;
#line 909 "../src/MediaDataRepresentation.vala"
	return result;
#line 6918 "MediaDataRepresentation.c"
}

static void
value_media_collection_registry_init (GValue* value)
{
#line 750 "../src/MediaDataRepresentation.vala"
	value->data[0].v_pointer = NULL;
#line 6926 "MediaDataRepresentation.c"
}

static void
value_media_collection_registry_free_value (GValue* value)
{
#line 750 "../src/MediaDataRepresentation.vala"
	if (value->data[0].v_pointer) {
#line 750 "../src/MediaDataRepresentation.vala"
		media_collection_registry_unref (value->data[0].v_pointer);
#line 6936 "MediaDataRepresentation.c"
	}
}

static void
value_media_collection_registry_copy_value (const GValue* src_value,
                                            GValue* dest_value)
{
#line 750 "../src/MediaDataRepresentation.vala"
	if (src_value->data[0].v_pointer) {
#line 750 "../src/MediaDataRepresentation.vala"
		dest_value->data[0].v_pointer = media_collection_registry_ref (src_value->data[0].v_pointer);
#line 6948 "MediaDataRepresentation.c"
	} else {
#line 750 "../src/MediaDataRepresentation.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6952 "MediaDataRepresentation.c"
	}
}

static gpointer
value_media_collection_registry_peek_pointer (const GValue* value)
{
#line 750 "../src/MediaDataRepresentation.vala"
	return value->data[0].v_pointer;
#line 6961 "MediaDataRepresentation.c"
}

static gchar*
value_media_collection_registry_collect_value (GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
#line 750 "../src/MediaDataRepresentation.vala"
	if (collect_values[0].v_pointer) {
#line 6972 "MediaDataRepresentation.c"
		MediaCollectionRegistry * object;
		object = collect_values[0].v_pointer;
#line 750 "../src/MediaDataRepresentation.vala"
		if (object->parent_instance.g_class == NULL) {
#line 750 "../src/MediaDataRepresentation.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6979 "MediaDataRepresentation.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 750 "../src/MediaDataRepresentation.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6983 "MediaDataRepresentation.c"
		}
#line 750 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = media_collection_registry_ref (object);
#line 6987 "MediaDataRepresentation.c"
	} else {
#line 750 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = NULL;
#line 6991 "MediaDataRepresentation.c"
	}
#line 750 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 6995 "MediaDataRepresentation.c"
}

static gchar*
value_media_collection_registry_lcopy_value (const GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	MediaCollectionRegistry ** object_p;
	object_p = collect_values[0].v_pointer;
#line 750 "../src/MediaDataRepresentation.vala"
	if (!object_p) {
#line 750 "../src/MediaDataRepresentation.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7010 "MediaDataRepresentation.c"
	}
#line 750 "../src/MediaDataRepresentation.vala"
	if (!value->data[0].v_pointer) {
#line 750 "../src/MediaDataRepresentation.vala"
		*object_p = NULL;
#line 7016 "MediaDataRepresentation.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 750 "../src/MediaDataRepresentation.vala"
		*object_p = value->data[0].v_pointer;
#line 7020 "MediaDataRepresentation.c"
	} else {
#line 750 "../src/MediaDataRepresentation.vala"
		*object_p = media_collection_registry_ref (value->data[0].v_pointer);
#line 7024 "MediaDataRepresentation.c"
	}
#line 750 "../src/MediaDataRepresentation.vala"
	return NULL;
#line 7028 "MediaDataRepresentation.c"
}

GParamSpec*
param_spec_media_collection_registry (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags)
{
	ParamSpecMediaCollectionRegistry* spec;
#line 750 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MEDIA_COLLECTION_REGISTRY), NULL);
#line 750 "../src/MediaDataRepresentation.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 750 "../src/MediaDataRepresentation.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 750 "../src/MediaDataRepresentation.vala"
	return G_PARAM_SPEC (spec);
#line 7047 "MediaDataRepresentation.c"
}

gpointer
value_get_media_collection_registry (const GValue* value)
{
#line 750 "../src/MediaDataRepresentation.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_COLLECTION_REGISTRY), NULL);
#line 750 "../src/MediaDataRepresentation.vala"
	return value->data[0].v_pointer;
#line 7057 "MediaDataRepresentation.c"
}

void
value_set_media_collection_registry (GValue* value,
                                     gpointer v_object)
{
	MediaCollectionRegistry * old;
#line 750 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_COLLECTION_REGISTRY));
#line 750 "../src/MediaDataRepresentation.vala"
	old = value->data[0].v_pointer;
#line 750 "../src/MediaDataRepresentation.vala"
	if (v_object) {
#line 750 "../src/MediaDataRepresentation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_COLLECTION_REGISTRY));
#line 750 "../src/MediaDataRepresentation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 750 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = v_object;
#line 750 "../src/MediaDataRepresentation.vala"
		media_collection_registry_ref (value->data[0].v_pointer);
#line 7079 "MediaDataRepresentation.c"
	} else {
#line 750 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = NULL;
#line 7083 "MediaDataRepresentation.c"
	}
#line 750 "../src/MediaDataRepresentation.vala"
	if (old) {
#line 750 "../src/MediaDataRepresentation.vala"
		media_collection_registry_unref (old);
#line 7089 "MediaDataRepresentation.c"
	}
}

void
value_take_media_collection_registry (GValue* value,
                                      gpointer v_object)
{
	MediaCollectionRegistry * old;
#line 750 "../src/MediaDataRepresentation.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_COLLECTION_REGISTRY));
#line 750 "../src/MediaDataRepresentation.vala"
	old = value->data[0].v_pointer;
#line 750 "../src/MediaDataRepresentation.vala"
	if (v_object) {
#line 750 "../src/MediaDataRepresentation.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_COLLECTION_REGISTRY));
#line 750 "../src/MediaDataRepresentation.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 750 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = v_object;
#line 7110 "MediaDataRepresentation.c"
	} else {
#line 750 "../src/MediaDataRepresentation.vala"
		value->data[0].v_pointer = NULL;
#line 7114 "MediaDataRepresentation.c"
	}
#line 750 "../src/MediaDataRepresentation.vala"
	if (old) {
#line 750 "../src/MediaDataRepresentation.vala"
		media_collection_registry_unref (old);
#line 7120 "MediaDataRepresentation.c"
	}
}

static void
media_collection_registry_class_init (MediaCollectionRegistryClass * klass,
                                      gpointer klass_data)
{
#line 750 "../src/MediaDataRepresentation.vala"
	media_collection_registry_parent_class = g_type_class_peek_parent (klass);
#line 750 "../src/MediaDataRepresentation.vala"
	((MediaCollectionRegistryClass *) klass)->finalize = media_collection_registry_finalize;
#line 750 "../src/MediaDataRepresentation.vala"
	g_type_class_adjust_private_offset (klass, &MediaCollectionRegistry_private_offset);
#line 7134 "MediaDataRepresentation.c"
}

static void
media_collection_registry_instance_init (MediaCollectionRegistry * self,
                                         gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeHashMap* _tmp1_;
#line 750 "../src/MediaDataRepresentation.vala"
	self->priv = media_collection_registry_get_instance_private (self);
#line 755 "../src/MediaDataRepresentation.vala"
	_tmp0_ = gee_array_list_new (TYPE_MEDIA_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, (GDestroyNotify) data_collection_unref, NULL, NULL, NULL);
#line 755 "../src/MediaDataRepresentation.vala"
	self->priv->all = _tmp0_;
#line 756 "../src/MediaDataRepresentation.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_MEDIA_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, (GDestroyNotify) data_collection_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 756 "../src/MediaDataRepresentation.vala"
	self->priv->by_typename = _tmp1_;
#line 750 "../src/MediaDataRepresentation.vala"
	self->ref_count = 1;
#line 7155 "MediaDataRepresentation.c"
}

static void
media_collection_registry_finalize (MediaCollectionRegistry * obj)
{
	MediaCollectionRegistry * self;
	GApplication* _tmp0_;
	guint _tmp1_;
#line 750 "../src/MediaDataRepresentation.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistry);
#line 750 "../src/MediaDataRepresentation.vala"
	g_signal_handlers_destroy (self);
#line 766 "../src/MediaDataRepresentation.vala"
	_tmp0_ = g_application_get_default ();
#line 766 "../src/MediaDataRepresentation.vala"
	g_signal_parse_name ("init-done", PHOTOS_TYPE_APPLICATION, &_tmp1_, NULL, FALSE);
#line 766 "../src/MediaDataRepresentation.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTOS_TYPE_APPLICATION, PhotosApplication), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _media_collection_registry_on_init_done_photos_application_init_done, self);
#line 755 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->all);
#line 756 "../src/MediaDataRepresentation.vala"
	_g_object_unref0 (self->priv->by_typename);
#line 7178 "MediaDataRepresentation.c"
}

static GType
media_collection_registry_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_media_collection_registry_init, value_media_collection_registry_free_value, value_media_collection_registry_copy_value, value_media_collection_registry_peek_pointer, "p", value_media_collection_registry_collect_value, "p", value_media_collection_registry_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MediaCollectionRegistryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_collection_registry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaCollectionRegistry), 0, (GInstanceInitFunc) media_collection_registry_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType media_collection_registry_type_id;
	media_collection_registry_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MediaCollectionRegistry", &g_define_type_info, &g_define_type_fundamental_info, 0);
	MediaCollectionRegistry_private_offset = g_type_add_instance_private (media_collection_registry_type_id, sizeof (MediaCollectionRegistryPrivate));
	return media_collection_registry_type_id;
}

GType
media_collection_registry_get_type (void)
{
	static volatile gsize media_collection_registry_type_id__once = 0;
	if (g_once_init_enter (&media_collection_registry_type_id__once)) {
		GType media_collection_registry_type_id;
		media_collection_registry_type_id = media_collection_registry_get_type_once ();
		g_once_init_leave (&media_collection_registry_type_id__once, media_collection_registry_type_id);
	}
	return media_collection_registry_type_id__once;
}

gpointer
media_collection_registry_ref (gpointer instance)
{
	MediaCollectionRegistry * self;
	self = instance;
#line 750 "../src/MediaDataRepresentation.vala"
	g_atomic_int_inc (&self->ref_count);
#line 750 "../src/MediaDataRepresentation.vala"
	return instance;
#line 7214 "MediaDataRepresentation.c"
}

void
media_collection_registry_unref (gpointer instance)
{
	MediaCollectionRegistry * self;
	self = instance;
#line 750 "../src/MediaDataRepresentation.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 750 "../src/MediaDataRepresentation.vala"
		MEDIA_COLLECTION_REGISTRY_GET_CLASS (self)->finalize (self);
#line 750 "../src/MediaDataRepresentation.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7228 "MediaDataRepresentation.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

