/* Photo.c generated by valac 0.56.18, the Vala compiler
 * generated from Photo.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>

#define PHOTO_SCALING_FUDGE 64
#define PHOTO_PRECACHE_TIME_TO_LIVE 180
#define PHOTO_MIN_EMBEDDED_SIZE 1024
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;
enum  {
	PHOTO_TRANSFORMATION_STATE_0_PROPERTY,
	PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES
};
static GParamSpec* photo_transformation_state_properties[PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES];
enum  {
	PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL,
	PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS
};
static guint photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS] = {0};

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;
enum  {
	PHOTO_0_PROPERTY,
	PHOTO_NUM_PROPERTIES
};
static GParamSpec* photo_properties[PHOTO_NUM_PROPERTIES];
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_0_PROPERTY,
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES
};
static GParamSpec* photo_photo_transformation_state_impl_properties[PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES];
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
enum  {
	PHOTO_EDITABLE_REPLACED_SIGNAL,
	PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL,
	PHOTO_BASELINE_REPLACED_SIGNAL,
	PHOTO_MASTER_REIMPORTED_SIGNAL,
	PHOTO_EDITABLE_REIMPORTED_SIGNAL,
	PHOTO_BASELINE_REIMPORTED_SIGNAL,
	PHOTO_SOURCE_REIMPORTED_SIGNAL,
	PHOTO_NUM_SIGNALS
};
static guint photo_signals[PHOTO_NUM_SIGNALS] = {0};
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS] = {0};
enum  {
	LIBRARY_PHOTO_0_PROPERTY,
	LIBRARY_PHOTO_NUM_PROPERTIES
};
static GParamSpec* library_photo_properties[LIBRARY_PHOTO_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _PhotoPrivate {
	gint64 cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GdkPixbuf* unmodified_precached;
	GRecMutex __lock_unmodified_precached;
	GTimer* secs_since_access;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	GeeHashMap* original_transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gboolean enhanced;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};

static gpointer photo_import_params_parent_class = NULL;
static gint PhotoTransformationState_private_offset;
static gpointer photo_transformation_state_parent_class = NULL;
static gint Photo_private_offset;
static gpointer photo_parent_class = NULL;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gint PhotoPhotoTransformationStateImpl_private_offset;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface * photo_dateable_parent_iface = NULL;
static gint LibraryPhotoSourceCollection_private_offset;
static gpointer library_photo_source_collection_parent_class = NULL;
static gint LibraryPhoto_private_offset;
static gpointer library_photo_parent_class = NULL;
LibraryPhotoSourceCollection* library_photo_global = NULL;
static FlaggableIface * library_photo_flaggable_parent_iface = NULL;
static MonitorableIface * library_photo_monitorable_parent_iface = NULL;
static gint LibraryPhotoSourceHoldingTank_private_offset;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

static void photo_import_params_finalize (PhotoImportParams * obj);
static GType photo_import_params_get_type_once (void);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject * obj);
static GType photo_transformation_state_get_type_once (void);
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags) G_GNUC_UNUSED ;
static void photo_value_set_backing_readers (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED ;
static void photo_value_take_backing_readers (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED ;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED ;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
static BackingPhotoRow* photo_get_backing_row (Photo* self,
                                        BackingPhotoID* id);
static void photo_internal_remove_all_transformations (Photo* self,
                                                gboolean notify);
static void photo_real_notify_editable_replaced (Photo* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void photo_real_notify_raw_development_modified (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
static void photo_real_notify_master_reimported (Photo* self,
                                          PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self,
                                          PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base,
                                             GError** error);
static void photo_detach_editable (Photo* self,
                            gboolean delete_editable,
                            gboolean remove_transformations,
                            gboolean notify);
static gboolean photo_delete_raw_development (Photo* self,
                                       RawDeveloper d);
static void photo_develop_photo (Photo* self,
                          RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base,
                                                       gint* result_length1);
static void _vala_array_add7 (BackingFileState** * array,
                       gint* length,
                       gint* size,
                       BackingFileState* value);
static void _vala_array_add8 (BackingFileState** * array,
                       gint* length,
                       gint* size,
                       BackingFileState* value);
static void _vala_array_add9 (BackingFileState** * array,
                       gint* length,
                       gint* size,
                       BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self,
                                           BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row,
                                                                    PhotoMetadata* metadata,
                                                                    gchar** alterations,
                                                                    gint alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type,
                                                                          PhotoRow* row,
                                                                          PhotoMetadata* metadata,
                                                                          gchar** alterations,
                                                                          gint alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void photo_real_apply_user_metadata_for_reimport (Photo* self,
                                                  PhotoMetadata* metadata);
static void _vala_array_add15 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean photo_verify_file_for_reimport (Photo* self,
                                         GFile* file,
                                         BackingPhotoRow** backing,
                                         DetectedPhotoInformation** detected,
                                         GError** error);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                                                        PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type,
                                                                              BackingPhotoRow* backing_state,
                                                                              PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                                    BackingPhotoRow* backing,
                                                    PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED ;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED ;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED ;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED ;
VALA_EXTERN GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST ;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
static gchar* photo_real_get_source_id (DataSource* base);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
static gboolean photo_is_extension_found (const gchar* basename,
                                   gchar** extensions,
                                   gint extensions_length1);
static GFile* photo_real_get_file (MediaSource* base);
static void _vala_array_add17 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add19 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add22 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add23 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static GFile* photo_real_get_master_file (MediaSource* base);
static gint64 photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base,
                              EventID* result);
static void photo_real_get_import_id (MediaSource* base,
                               ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
static void photo_notify_flags_altered (Photo* self,
                                 Alteration* additional_alteration);
static void photo_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
static gboolean photo_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
static gboolean photo_real_equals (DataSource* base,
                            DataSource* source);
static void photo_file_exif_updated (Photo* self);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
static gint64 photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base,
                           const gchar* title);
static gboolean photo_real_set_comment (MediaSource* base,
                                 const gchar* comment);
static void photo_real_set_exposure_time (Dateable* base,
                                   gint64 time);
static void photo_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
VALA_EXTERN void compute_arb_rotated_size (gdouble src_width,
                               gdouble src_height,
                               gdouble angle,
                               gdouble* dest_width,
                               gdouble* dest_height);
static void photo_locked_create_adjustments_from_data (Photo* self);
static KeyValueMap* photo_get_transformation (Photo* self,
                                       const gchar* name);
static PixelTransformationBundle* photo_locked_original_color_adjustments (Photo* self);
static KeyValueMap* photo_get_color_adjustments_map (Photo* self);
static gboolean photo_has_transformation (Photo* self,
                                   const gchar* name);
static gboolean photo_remove_transformation (Photo* self,
                                      const gchar* name);
static gboolean photo_set_transformation (Photo* self,
                                   KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo,
                                                                              Orientation orientation,
                                                                              GeeHashMap* transformations,
                                                                              PixelTransformer* transformer,
                                                                              PixelTransformationBundle* adjustments,
                                                                              GeeHashMap* original_transformations,
                                                                              gboolean enhanced);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type,
                                                                                    Photo* photo,
                                                                                    Orientation orientation,
                                                                                    GeeHashMap* transformations,
                                                                                    PixelTransformer* transformer,
                                                                                    PixelTransformationBundle* adjustments,
                                                                                    GeeHashMap* original_transformations,
                                                                                    gboolean enhanced);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static gboolean photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
static void photo_real_rotate (Photo* self,
                        Rotation rotation);
static gboolean photo_set_original_transforms (Photo* self,
                                        KeyValueMap* trans);
static gboolean photo_clear_original_transforms (Photo* self);
static void photo_set_raw_crop (Photo* self,
                         Box* crop);
static gboolean photo_get_raw_straighten (Photo* self,
                                   gdouble* angle);
static void photo_set_raw_straighten (Photo* self,
                               gdouble theta);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self,
                                                            gint* result_length1);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self,
                                            Scaling* scaling,
                                            PhotoException exceptions,
                                            Dimensions* scaled_image,
                                            Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                                   Scaling* scaling,
                                                   PhotoException exceptions,
                                                   Dimensions* scaled_image,
                                                   Dimensions* scaled_to_viewport);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self,
                                  Scaling* scaling,
                                  PhotoException exceptions,
                                  BackingFetchMode fetch_mode,
                                  GError** error);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self,
                                           Scaling* scaling,
                                           gboolean rotate,
                                           BackingFetchMode fetch_mode,
                                           GError** error);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base,
                                  Scaling* scaling,
                                  GError** error);
static GdkPixbuf* photo_do_redeye (Photo* self,
                            GdkPixbuf* pixbuf,
                            EditingToolsRedeyeInstance* inst);
VALA_EXTERN GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf,
                       gdouble angle);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
static void photo_real_set_user_metadata_for_export (Photo* self,
                                              PhotoMetadata* metadata);
static gboolean photo_export_fullsized_backing (Photo* self,
                                         GFile* file,
                                         gboolean export_metadata,
                                         GError** error);
static GFile* photo_generate_new_editable_file (Photo* self,
                                         PhotoFileFormat* file_format,
                                         GError** error);
static gboolean photo_launch_editor (GFile* file,
                              PhotoFileFormat file_format,
                              const gchar* commandline,
                              GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self,
                            PhotoFileFormat file_format,
                            GFile* file,
                            GError** error);
static void photo_start_monitoring_editable (Photo* self,
                                      GFile* file,
                                      GError** error);
static void photo_on_editable_file_changed (Photo* self,
                                     GFile* file,
                                     GFile* other_file,
                                     GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                             GFile* file,
                                                             GFile* other_file,
                                                             GFileMonitorEvent event_type,
                                                             gpointer self);
static void photo_update_editable (Photo* self,
                            gboolean only_attributes,
                            PhotoFileReader* new_reader,
                            GError** error);
static void photo_update_editable_attributes (Photo* self,
                                       GError** error);
static void _vala_array_add24 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add25 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add26 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add27 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add28 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add29 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self,
                                   GdkPixbuf* pixbuf,
                                   gint x,
                                   gint y);
static void photo_real_editable_replaced (Photo* self,
                                   GFile* old_file,
                                   GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                                gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject * obj);
static GType photo_photo_transformation_state_impl_get_type_once (void);
static void photo_backing_readers_finalize (PhotoBackingReaders * obj);
static GType photo_backing_readers_get_type_once (void);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState * obj);
static GType photo_reimport_master_state_get_type_once (void);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj);
static GType photo_reimport_master_state_impl_get_type_once (void);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj);
static GType photo_reimport_editable_state_get_type_once (void);
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj);
static GType photo_reimport_editable_state_impl_get_type_once (void);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj);
static GType photo_reimport_raw_development_state_get_type_once (void);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                                                                                  PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                                                                        BackingPhotoRow* backing,
                                                                                                                        PhotoMetadata* metadata);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj);
static GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once (void);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj);
static GType photo_reimport_raw_development_state_impl_get_type_once (void);
static void photo_finalize (GObject * obj);
static GType photo_get_type_once (void);
static void _vala_photo_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static gint _int64_compare_gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static gint64* _int64_dup (gint64* self);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a,
                                           gconstpointer b,
                                           gpointer self);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source,
                                                     gpointer self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                                   GeeCollection* added,
                                                                   GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                         GeeCollection* added,
                                                                                                         GeeCollection* removed,
                                                                                                         gpointer self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                                  GeeCollection* added,
                                                                  GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                        GeeCollection* added,
                                                                                                        GeeCollection* removed,
                                                                                                        gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                         Workers* workers,
                                                                         GCancellable* cancellable);
VALA_EXTERN PhotoMonitor* photo_monitor_new (Workers* workers,
                                 GCancellable* cancellable);
VALA_EXTERN PhotoMonitor* photo_monitor_construct (GType object_type,
                                       Workers* workers,
                                       GCancellable* cancellable);
VALA_EXTERN GType photo_monitor_get_type (void) G_GNUC_CONST ;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                                    DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                                  GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                                   GeeIterable* added,
                                                                   GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                           Photo* photo,
                                                           GFile* old_file,
                                                           GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                    GFile* old_file,
                                                                                    GFile* new_file,
                                                                                    gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                                  Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                  gpointer self);
static void library_photo_source_collection_real_items_altered (DataCollection* base,
                                                         GeeMap* items);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                      GeeCollection* media_sources);
VALA_EXTERN HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                                       gint64 numeric_id);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                                      const gchar* source_id);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                          EventID* event_id);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                      LibraryPhoto* photo,
                                                      GFileInfo* info,
                                                      GeeCollection* matches_master,
                                                      GeeCollection* matches_editable,
                                                      GeeCollection* matches_development);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                            SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                           SourceBacklink* backlink);
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection * obj);
static GType library_photo_source_collection_get_type_once (void);
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type,
                                       PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type,
                                                          PhotoImportParams* import_params);
static void library_photo_real_notify_master_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
static void library_photo_real_notify_altered (DataObject* base,
                                        Alteration* alteration);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base,
                                                  Scaling* scaling,
                                                  GError** error);
static void library_photo_real_rotate (Photo* base,
                                Rotation rotation);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base,
                                             gint scale,
                                             GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                            BackingPhotoRow* backing,
                                            BackingPhotoID* result,
                                            GError** error);
VALA_EXTERN GFile* library_files_duplicate (GFile* src,
                                GFileProgressCallback progress_callback,
                                gpointer progress_callback_target,
                                gboolean blacklist,
                                GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self,
                                          gint64 current,
                                          gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                                   gint64 total_num_bytes,
                                                                   gpointer self);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base,
                                                     GError** error);
static void library_photo_real_destroy (DataSource* base);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
static void library_photo_real_set_user_metadata_for_export (Photo* base,
                                                      PhotoMetadata* metadata);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                          PhotoMetadata* metadata);
VALA_EXTERN gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
VALA_EXTERN gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
static void library_photo_finalize (GObject * obj);
static GType library_photo_get_type_once (void);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                     GeeCollection* added,
                                                                     GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                             Photo* _photo,
                                                             GFile* old_file,
                                                             GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                      GFile* old_file,
                                                                                      GFile* new_file,
                                                                                      gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                                    Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                    gpointer self);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank * obj);
static GType library_photo_source_holding_tank_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

static GType
backing_fetch_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
	GType backing_fetch_mode_type_id;
	backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
	return backing_fetch_mode_type_id;
}

GType
backing_fetch_mode_get_type (void)
{
	static volatile gsize backing_fetch_mode_type_id__once = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__once)) {
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = backing_fetch_mode_get_type_once ();
		g_once_init_leave (&backing_fetch_mode_type_id__once, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 1075 "Photo.c"
}

static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 61 "../src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 1083 "Photo.c"
}

PhotoImportParams*
photo_import_params_construct (GType object_type,
                               GFile* file,
                               GFile* final_associated_file,
                               ImportID* import_id,
                               PhotoFileSnifferOptions sniffer_options,
                               const gchar* exif_md5,
                               const gchar* thumbnail_md5,
                               const gchar* full_md5,
                               Thumbnails* thumbnails)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	Thumbnails* _tmp6_;
#line 51 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 51 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 51 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 54 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 54 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 54 "../src/Photo.vala"
	self->file = _tmp0_;
#line 55 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (final_associated_file);
#line 55 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 55 "../src/Photo.vala"
	self->final_associated_file = _tmp1_;
#line 56 "../src/Photo.vala"
	_tmp2_ = *import_id;
#line 56 "../src/Photo.vala"
	self->import_id = _tmp2_;
#line 57 "../src/Photo.vala"
	self->sniffer_options = sniffer_options;
#line 58 "../src/Photo.vala"
	_tmp3_ = g_strdup (exif_md5);
#line 58 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 58 "../src/Photo.vala"
	self->exif_md5 = _tmp3_;
#line 59 "../src/Photo.vala"
	_tmp4_ = g_strdup (thumbnail_md5);
#line 59 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 59 "../src/Photo.vala"
	self->thumbnail_md5 = _tmp4_;
#line 60 "../src/Photo.vala"
	_tmp5_ = g_strdup (full_md5);
#line 60 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 60 "../src/Photo.vala"
	self->full_md5 = _tmp5_;
#line 61 "../src/Photo.vala"
	_tmp6_ = _thumbnails_ref0 (thumbnails);
#line 61 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 61 "../src/Photo.vala"
	self->thumbnails = _tmp6_;
#line 51 "../src/Photo.vala"
	return self;
#line 1155 "Photo.c"
}

PhotoImportParams*
photo_import_params_new (GFile* file,
                         GFile* final_associated_file,
                         ImportID* import_id,
                         PhotoFileSnifferOptions sniffer_options,
                         const gchar* exif_md5,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         Thumbnails* thumbnails)
{
#line 51 "../src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 1170 "Photo.c"
}

PhotoImportParams*
photo_import_params_construct_create_placeholder (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
#line 65 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 65 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 65 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 66 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 66 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 66 "../src/Photo.vala"
	self->file = _tmp0_;
#line 67 "../src/Photo.vala"
	_tmp1_ = *import_id;
#line 67 "../src/Photo.vala"
	self->import_id = _tmp1_;
#line 68 "../src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 69 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 69 "../src/Photo.vala"
	self->exif_md5 = NULL;
#line 70 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 70 "../src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 71 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 71 "../src/Photo.vala"
	self->full_md5 = NULL;
#line 72 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 72 "../src/Photo.vala"
	self->thumbnails = NULL;
#line 65 "../src/Photo.vala"
	return self;
#line 1217 "Photo.c"
}

PhotoImportParams*
photo_import_params_new_create_placeholder (GFile* file,
                                            ImportID* import_id)
{
#line 65 "../src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 1226 "Photo.c"
}

static void
value_photo_import_params_init (GValue* value)
{
#line 34 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 1234 "Photo.c"
}

static void
value_photo_import_params_free_value (GValue* value)
{
#line 34 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 34 "../src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 1244 "Photo.c"
	}
}

static void
value_photo_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 34 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 1256 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1260 "Photo.c"
	}
}

static gpointer
value_photo_import_params_peek_pointer (const GValue* value)
{
#line 34 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 1269 "Photo.c"
}

static gchar*
value_photo_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 34 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 1280 "Photo.c"
		PhotoImportParams * object;
		object = collect_values[0].v_pointer;
#line 34 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1287 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1291 "Photo.c"
		}
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 1295 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 1299 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	return NULL;
#line 1303 "Photo.c"
}

static gchar*
value_photo_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "../src/Photo.vala"
	if (!object_p) {
#line 34 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1318 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 34 "../src/Photo.vala"
		*object_p = NULL;
#line 1324 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 1328 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 1332 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	return NULL;
#line 1336 "Photo.c"
}

GParamSpec*
param_spec_photo_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecPhotoImportParams* spec;
#line 34 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 1355 "Photo.c"
}

gpointer
value_get_photo_import_params (const GValue* value)
{
#line 34 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 1365 "Photo.c"
}

void
value_set_photo_import_params (GValue* value,
                               gpointer v_object)
{
	PhotoImportParams * old;
#line 34 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/Photo.vala"
	if (v_object) {
#line 34 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34 "../src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 1387 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 1391 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	if (old) {
#line 34 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 1397 "Photo.c"
	}
}

void
value_take_photo_import_params (GValue* value,
                                gpointer v_object)
{
	PhotoImportParams * old;
#line 34 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/Photo.vala"
	if (v_object) {
#line 34 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1418 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 1422 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	if (old) {
#line 34 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 1428 "Photo.c"
	}
}

static void
photo_import_params_class_init (PhotoImportParamsClass * klass,
                                gpointer klass_data)
{
#line 34 "../src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 1440 "Photo.c"
}

static void
photo_import_params_instance_init (PhotoImportParams * self,
                                   gpointer klass)
{
	PhotoRow* _tmp0_;
#line 37 "../src/Photo.vala"
	self->final_associated_file = NULL;
#line 48 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 48 "../src/Photo.vala"
	self->row = _tmp0_;
#line 49 "../src/Photo.vala"
	self->keywords = NULL;
#line 34 "../src/Photo.vala"
	self->ref_count = 1;
#line 1458 "Photo.c"
}

static void
photo_import_params_finalize (PhotoImportParams * obj)
{
	PhotoImportParams * self;
#line 34 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 34 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 36 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 37 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 40 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 41 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 42 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 45 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 49 "../src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 1485 "Photo.c"
}

static GType
photo_import_params_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_import_params_type_id;
	photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_import_params_type_id;
}

GType
photo_import_params_get_type (void)
{
	static volatile gsize photo_import_params_type_id__once = 0;
	if (g_once_init_enter (&photo_import_params_type_id__once)) {
		GType photo_import_params_type_id;
		photo_import_params_type_id = photo_import_params_get_type_once ();
		g_once_init_leave (&photo_import_params_type_id__once, photo_import_params_type_id);
	}
	return photo_import_params_type_id__once;
}

gpointer
photo_import_params_ref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 34 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "../src/Photo.vala"
	return instance;
#line 1520 "Photo.c"
}

void
photo_import_params_unref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 34 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "../src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 34 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1534 "Photo.c"
	}
}

static inline gpointer
photo_transformation_state_get_instance_private (PhotoTransformationState* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoTransformationState_private_offset);
}

PhotoTransformationState*
photo_transformation_state_construct (GType object_type)
{
	PhotoTransformationState * self = NULL;
#line 85 "../src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 85 "../src/Photo.vala"
	return self;
#line 1552 "Photo.c"
}

gboolean
photo_transformation_state_is_broken (PhotoTransformationState* self)
{
	gboolean result;
#line 88 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../src/Photo.vala"
	result = self->priv->is_broke;
#line 89 "../src/Photo.vala"
	return result;
#line 1565 "Photo.c"
}

static void
photo_transformation_state_real_broken (PhotoTransformationState* self)
{
#line 82 "../src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 1573 "Photo.c"
}

static void
photo_transformation_state_class_init (PhotoTransformationStateClass * klass,
                                       gpointer klass_data)
{
#line 76 "../src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 76 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoTransformationState_private_offset);
#line 76 "../src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 76 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 76 "../src/Photo.vala"
	photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1590 "Photo.c"
}

static void
photo_transformation_state_instance_init (PhotoTransformationState * self,
                                          gpointer klass)
{
#line 76 "../src/Photo.vala"
	self->priv = photo_transformation_state_get_instance_private (self);
#line 77 "../src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 1601 "Photo.c"
}

static void
photo_transformation_state_finalize (GObject * obj)
{
	PhotoTransformationState * self;
#line 76 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 76 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 1612 "Photo.c"
}

static GType
photo_transformation_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
	GType photo_transformation_state_type_id;
	photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PhotoTransformationState_private_offset = g_type_add_instance_private (photo_transformation_state_type_id, sizeof (PhotoTransformationStatePrivate));
	return photo_transformation_state_type_id;
}

GType
photo_transformation_state_get_type (void)
{
	static volatile gsize photo_transformation_state_type_id__once = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__once)) {
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = photo_transformation_state_get_type_once ();
		g_once_init_leave (&photo_transformation_state_type_id__once, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__once;
}

static inline gpointer
photo_get_instance_private (Photo* self)
{
	return G_STRUCT_MEMBER_P (self, Photo_private_offset);
}

gboolean
photo_exception_prohibits (PhotoException self,
                           PhotoException exception)
{
	gboolean result;
#line 160 "../src/Photo.vala"
	result = (self & exception) != 0;
#line 160 "../src/Photo.vala"
	return result;
#line 1652 "Photo.c"
}

gboolean
photo_exception_allows (PhotoException self,
                        PhotoException exception)
{
	gboolean result;
#line 164 "../src/Photo.vala"
	result = (self & exception) == 0;
#line 164 "../src/Photo.vala"
	return result;
#line 1664 "Photo.c"
}

static GType
photo_exception_get_type_once (void)
{
	static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
	GType photo_exception_type_id;
	photo_exception_type_id = g_enum_register_static ("PhotoException", values);
	return photo_exception_type_id;
}

GType
photo_exception_get_type (void)
{
	static volatile gsize photo_exception_type_id__once = 0;
	if (g_once_init_enter (&photo_exception_type_id__once)) {
		GType photo_exception_type_id;
		photo_exception_type_id = photo_exception_get_type_once ();
		g_once_init_leave (&photo_exception_type_id__once, photo_exception_type_id);
	}
	return photo_exception_type_id__once;
}

static gpointer
_photo_row_ref0 (gpointer self)
{
#line 335 "../src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 1693 "Photo.c"
}

static gpointer
_backing_photo_row_ref0 (gpointer self)
{
#line 356 "../src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 1701 "Photo.c"
}

Photo*
photo_construct (GType object_type,
                 PhotoRow* row)
{
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoRow* _tmp5_;
	PhotoRow* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	PhotoBackingReaders* _tmp9_;
	BackingPhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	const gchar* _tmp12_;
	PhotoFileReader* _tmp13_;
	gchar* basename = NULL;
	BackingPhotoRow* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp20_;
	BackingPhotoID _tmp24_;
	BackingPhotoRow* _tmp38_;
	gboolean _tmp50_ = FALSE;
	BackingPhotoRow* _tmp51_;
	PhotoBackingReaders* _tmp60_;
	PhotoFileReader* _tmp61_;
	PhotoRow* _tmp74_;
	GError* _inner_error0_ = NULL;
#line 334 "../src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 334 "../src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 335 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 335 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 335 "../src/Photo.vala"
	self->row = _tmp0_;
#line 338 "../src/Photo.vala"
	_tmp1_ = self->row;
#line 338 "../src/Photo.vala"
	_tmp2_ = self->row;
#line 338 "../src/Photo.vala"
	_tmp3_ = _tmp2_->title;
#line 338 "../src/Photo.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 338 "../src/Photo.vala"
	_g_free0 (_tmp1_->title);
#line 338 "../src/Photo.vala"
	_tmp1_->title = _tmp4_;
#line 339 "../src/Photo.vala"
	_tmp5_ = self->row;
#line 339 "../src/Photo.vala"
	_tmp6_ = self->row;
#line 339 "../src/Photo.vala"
	_tmp7_ = _tmp6_->comment;
#line 339 "../src/Photo.vala"
	_tmp8_ = media_source_prep_comment (_tmp7_);
#line 339 "../src/Photo.vala"
	_g_free0 (_tmp5_->comment);
#line 339 "../src/Photo.vala"
	_tmp5_->comment = _tmp8_;
#line 343 "../src/Photo.vala"
	_tmp9_ = self->priv->readers;
#line 343 "../src/Photo.vala"
	_tmp10_ = row->master;
#line 343 "../src/Photo.vala"
	_tmp11_ = row->master;
#line 343 "../src/Photo.vala"
	_tmp12_ = _tmp11_->filepath;
#line 343 "../src/Photo.vala"
	_tmp13_ = photo_file_format_create_reader (_tmp10_->file_format, _tmp12_);
#line 343 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_->master);
#line 343 "../src/Photo.vala"
	_tmp9_->master = _tmp13_;
#line 346 "../src/Photo.vala"
	_tmp14_ = row->master;
#line 346 "../src/Photo.vala"
	_tmp15_ = _tmp14_->filepath;
#line 346 "../src/Photo.vala"
	_tmp16_ = string_sliced_at_last_char (_tmp15_, (gunichar) G_DIR_SEPARATOR, 0);
#line 346 "../src/Photo.vala"
	basename = _tmp16_;
#line 347 "../src/Photo.vala"
	_tmp17_ = basename;
#line 347 "../src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 1797 "Photo.c"
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 348 "../src/Photo.vala"
		_tmp18_ = basename;
#line 348 "../src/Photo.vala"
		_tmp19_ = string_sliced_at (_tmp18_, 1);
#line 348 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 348 "../src/Photo.vala"
		self->priv->file_title = _tmp19_;
#line 1808 "Photo.c"
	}
#line 350 "../src/Photo.vala"
	_tmp20_ = self->priv->file_title;
#line 350 "../src/Photo.vala"
	if (is_string_empty (_tmp20_)) {
#line 1814 "Photo.c"
		BackingPhotoRow* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
#line 351 "../src/Photo.vala"
		_tmp21_ = row->master;
#line 351 "../src/Photo.vala"
		_tmp22_ = _tmp21_->filepath;
#line 351 "../src/Photo.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 351 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 351 "../src/Photo.vala"
		self->priv->file_title = _tmp23_;
#line 1828 "Photo.c"
	}
#line 353 "../src/Photo.vala"
	_tmp24_ = row->editable_id;
#line 353 "../src/Photo.vala"
	if (_tmp24_.id != BACKING_PHOTO_ID_INVALID) {
#line 1834 "Photo.c"
		BackingPhotoRow* e = NULL;
		BackingPhotoID _tmp25_;
		BackingPhotoRow* _tmp26_;
		BackingPhotoRow* _tmp27_;
#line 354 "../src/Photo.vala"
		_tmp25_ = row->editable_id;
#line 354 "../src/Photo.vala"
		_tmp26_ = photo_get_backing_row (self, &_tmp25_);
#line 354 "../src/Photo.vala"
		e = _tmp26_;
#line 355 "../src/Photo.vala"
		_tmp27_ = e;
#line 355 "../src/Photo.vala"
		if (_tmp27_ != NULL) {
#line 1849 "Photo.c"
			BackingPhotoRow* _tmp28_;
			BackingPhotoRow* _tmp29_;
			PhotoBackingReaders* _tmp30_;
			BackingPhotoRow* _tmp31_;
			BackingPhotoRow* _tmp32_;
			const gchar* _tmp33_;
			PhotoFileReader* _tmp34_;
#line 356 "../src/Photo.vala"
			_tmp28_ = e;
#line 356 "../src/Photo.vala"
			_tmp29_ = _backing_photo_row_ref0 (_tmp28_);
#line 356 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 356 "../src/Photo.vala"
			self->priv->editable = _tmp29_;
#line 357 "../src/Photo.vala"
			_tmp30_ = self->priv->readers;
#line 357 "../src/Photo.vala"
			_tmp31_ = self->priv->editable;
#line 357 "../src/Photo.vala"
			_tmp32_ = self->priv->editable;
#line 357 "../src/Photo.vala"
			_tmp33_ = _tmp32_->filepath;
#line 357 "../src/Photo.vala"
			_tmp34_ = photo_file_format_create_reader (_tmp31_->file_format, _tmp33_);
#line 357 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp30_->editable);
#line 357 "../src/Photo.vala"
			_tmp30_->editable = _tmp34_;
#line 1879 "Photo.c"
		} else {
			{
				PhotoTable* _tmp35_;
				PhotoTable* _tmp36_;
				PhotoRow* _tmp37_;
#line 360 "../src/Photo.vala"
				_tmp35_ = photo_table_get_instance ();
#line 360 "../src/Photo.vala"
				_tmp36_ = _tmp35_;
#line 360 "../src/Photo.vala"
				_tmp37_ = self->row;
#line 360 "../src/Photo.vala"
				photo_table_detach_editable (_tmp36_, _tmp37_, &_inner_error0_);
#line 360 "../src/Photo.vala"
				_database_table_unref0 (_tmp36_);
#line 360 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1899 "Photo.c"
						goto __catch0_database_error;
					}
#line 360 "../src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 360 "../src/Photo.vala"
					_g_free0 (basename);
#line 360 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 360 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 360 "../src/Photo.vala"
					return NULL;
#line 1912 "Photo.c"
				}
			}
			goto __finally0;
			__catch0_database_error:
			{
#line 359 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1920 "Photo.c"
			}
			__finally0:
#line 359 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 359 "../src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 359 "../src/Photo.vala"
				_g_free0 (basename);
#line 359 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 359 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 359 "../src/Photo.vala"
				return NULL;
#line 1935 "Photo.c"
			}
#line 367 "../src/Photo.vala"
			photo_internal_remove_all_transformations (self, FALSE);
#line 1939 "Photo.c"
		}
#line 353 "../src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 1943 "Photo.c"
	}
#line 371 "../src/Photo.vala"
	_tmp38_ = row->master;
#line 371 "../src/Photo.vala"
	if (_tmp38_->file_format == PHOTO_FILE_FORMAT_RAW) {
#line 1949 "Photo.c"
		GeeHashMap* _tmp39_;
		gint _tmp40_ = 0;
		RawDeveloper* _tmp41_;
#line 373 "../src/Photo.vala"
		_tmp39_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, (GDestroyNotify) backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "../src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 373 "../src/Photo.vala"
		self->priv->developments = _tmp39_;
#line 374 "../src/Photo.vala"
		_tmp41_ = raw_developer_as_array (&_tmp40_);
#line 1961 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 374 "../src/Photo.vala"
			d_collection = _tmp41_;
#line 374 "../src/Photo.vala"
			d_collection_length1 = _tmp40_;
#line 374 "../src/Photo.vala"
			for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 1973 "Photo.c"
				RawDeveloper d = 0;
#line 374 "../src/Photo.vala"
				d = d_collection[d_it];
#line 1977 "Photo.c"
				{
					BackingPhotoID id = {0};
					BackingPhotoID* _tmp42_;
					gint _tmp42__length1;
					BackingPhotoID _tmp43_;
					BackingPhotoID _tmp44_;
#line 375 "../src/Photo.vala"
					_tmp42_ = row->development_ids;
#line 375 "../src/Photo.vala"
					_tmp42__length1 = row->development_ids_length1;
#line 375 "../src/Photo.vala"
					_tmp43_ = _tmp42_[d];
#line 375 "../src/Photo.vala"
					id = _tmp43_;
#line 376 "../src/Photo.vala"
					_tmp44_ = id;
#line 376 "../src/Photo.vala"
					if (_tmp44_.id != BACKING_PHOTO_ID_INVALID) {
#line 1996 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp45_;
						BackingPhotoRow* _tmp46_;
						BackingPhotoRow* _tmp47_;
#line 377 "../src/Photo.vala"
						_tmp45_ = id;
#line 377 "../src/Photo.vala"
						_tmp46_ = photo_get_backing_row (self, &_tmp45_);
#line 377 "../src/Photo.vala"
						bpr = _tmp46_;
#line 378 "../src/Photo.vala"
						_tmp47_ = bpr;
#line 378 "../src/Photo.vala"
						if (_tmp47_ != NULL) {
#line 2011 "Photo.c"
							GeeHashMap* _tmp48_;
							BackingPhotoRow* _tmp49_;
#line 379 "../src/Photo.vala"
							_tmp48_ = self->priv->developments;
#line 379 "../src/Photo.vala"
							_tmp49_ = bpr;
#line 379 "../src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp48_, (gpointer) ((gintptr) d), _tmp49_);
#line 2020 "Photo.c"
						}
#line 376 "../src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 2024 "Photo.c"
					}
				}
			}
#line 374 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 2030 "Photo.c"
		}
	}
#line 385 "../src/Photo.vala"
	_tmp51_ = row->master;
#line 385 "../src/Photo.vala"
	if (_tmp51_->file_format == PHOTO_FILE_FORMAT_RAW) {
#line 2037 "Photo.c"
		GeeHashMap* _tmp52_;
#line 385 "../src/Photo.vala"
		_tmp52_ = self->priv->developments;
#line 385 "../src/Photo.vala"
		_tmp50_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp52_, (gpointer) ((gintptr) row->developer));
#line 2043 "Photo.c"
	} else {
#line 385 "../src/Photo.vala"
		_tmp50_ = FALSE;
#line 2047 "Photo.c"
	}
#line 385 "../src/Photo.vala"
	if (_tmp50_) {
#line 2051 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp53_;
		gpointer _tmp54_;
		PhotoBackingReaders* _tmp55_;
		BackingPhotoRow* _tmp56_;
		BackingPhotoRow* _tmp57_;
		const gchar* _tmp58_;
		PhotoFileReader* _tmp59_;
#line 386 "../src/Photo.vala"
		_tmp53_ = self->priv->developments;
#line 386 "../src/Photo.vala"
		_tmp54_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp53_, (gpointer) ((gintptr) row->developer));
#line 386 "../src/Photo.vala"
		r = (BackingPhotoRow*) _tmp54_;
#line 387 "../src/Photo.vala"
		_tmp55_ = self->priv->readers;
#line 387 "../src/Photo.vala"
		_tmp56_ = r;
#line 387 "../src/Photo.vala"
		_tmp57_ = r;
#line 387 "../src/Photo.vala"
		_tmp58_ = _tmp57_->filepath;
#line 387 "../src/Photo.vala"
		_tmp59_ = photo_file_format_create_reader (_tmp56_->file_format, _tmp58_);
#line 387 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp55_->developer);
#line 387 "../src/Photo.vala"
		_tmp55_->developer = _tmp59_;
#line 385 "../src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 2082 "Photo.c"
	}
#line 391 "../src/Photo.vala"
	_tmp60_ = self->priv->readers;
#line 391 "../src/Photo.vala"
	_tmp61_ = _tmp60_->editable;
#line 391 "../src/Photo.vala"
	if (_tmp61_ != NULL) {
#line 2090 "Photo.c"
		BackingPhotoRow* _tmp62_;
		BackingPhotoRow* _tmp63_;
#line 392 "../src/Photo.vala"
		_tmp62_ = self->priv->editable;
#line 392 "../src/Photo.vala"
		_tmp63_ = _backing_photo_row_ref0 (_tmp62_);
#line 392 "../src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 392 "../src/Photo.vala"
		self->backing_photo_row = _tmp63_;
#line 2101 "Photo.c"
	} else {
		BackingPhotoRow* _tmp64_;
#line 393 "../src/Photo.vala"
		_tmp64_ = row->master;
#line 393 "../src/Photo.vala"
		if (_tmp64_->file_format != PHOTO_FILE_FORMAT_RAW) {
#line 2108 "Photo.c"
			PhotoRow* _tmp65_;
			BackingPhotoRow* _tmp66_;
			BackingPhotoRow* _tmp67_;
#line 394 "../src/Photo.vala"
			_tmp65_ = self->row;
#line 394 "../src/Photo.vala"
			_tmp66_ = _tmp65_->master;
#line 394 "../src/Photo.vala"
			_tmp67_ = _backing_photo_row_ref0 (_tmp66_);
#line 394 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 394 "../src/Photo.vala"
			self->backing_photo_row = _tmp67_;
#line 2122 "Photo.c"
		} else {
			GeeHashMap* _tmp68_;
#line 398 "../src/Photo.vala"
			_tmp68_ = self->priv->developments;
#line 398 "../src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp68_, (gpointer) ((gintptr) row->developer))) {
#line 2129 "Photo.c"
				GeeHashMap* _tmp69_;
				gpointer _tmp70_;
#line 399 "../src/Photo.vala"
				_tmp69_ = self->priv->developments;
#line 399 "../src/Photo.vala"
				_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp69_, (gpointer) ((gintptr) row->developer));
#line 399 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 399 "../src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp70_;
#line 2140 "Photo.c"
			} else {
				PhotoRow* _tmp71_;
				BackingPhotoRow* _tmp72_;
				BackingPhotoRow* _tmp73_;
#line 402 "../src/Photo.vala"
				_tmp71_ = self->row;
#line 402 "../src/Photo.vala"
				_tmp72_ = _tmp71_->master;
#line 402 "../src/Photo.vala"
				_tmp73_ = _backing_photo_row_ref0 (_tmp72_);
#line 402 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 402 "../src/Photo.vala"
				self->backing_photo_row = _tmp73_;
#line 2155 "Photo.c"
			}
		}
	}
#line 406 "../src/Photo.vala"
	_tmp74_ = self->row;
#line 406 "../src/Photo.vala"
	self->priv->cached_exposure_time = _tmp74_->exposure_time;
#line 334 "../src/Photo.vala"
	_g_free0 (basename);
#line 334 "../src/Photo.vala"
	return self;
#line 2167 "Photo.c"
}

static void
photo_real_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file)
{
#line 410 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL], 0, old_file, new_file);
#line 2177 "Photo.c"
}

void
photo_notify_editable_replaced (Photo* self,
                                GFile* old_file,
                                GFile* new_file)
{
	PhotoClass* _klass_;
#line 409 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 409 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 409 "../src/Photo.vala"
	if (_klass_->notify_editable_replaced) {
#line 409 "../src/Photo.vala"
		_klass_->notify_editable_replaced (self, old_file, new_file);
#line 2194 "Photo.c"
	}
}

static void
photo_real_notify_raw_development_modified (Photo* self)
{
#line 414 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL], 0);
#line 2203 "Photo.c"
}

void
photo_notify_raw_development_modified (Photo* self)
{
	PhotoClass* _klass_;
#line 413 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 413 "../src/Photo.vala"
	if (_klass_->notify_raw_development_modified) {
#line 413 "../src/Photo.vala"
		_klass_->notify_raw_development_modified (self);
#line 2218 "Photo.c"
	}
}

static void
photo_real_notify_baseline_replaced (Photo* self)
{
#line 418 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL], 0);
#line 2227 "Photo.c"
}

void
photo_notify_baseline_replaced (Photo* self)
{
	PhotoClass* _klass_;
#line 417 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 417 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 417 "../src/Photo.vala"
	if (_klass_->notify_baseline_replaced) {
#line 417 "../src/Photo.vala"
		_klass_->notify_baseline_replaced (self);
#line 2242 "Photo.c"
	}
}

static void
photo_real_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 422 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL], 0, metadata);
#line 2252 "Photo.c"
}

void
photo_notify_master_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 421 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 421 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 421 "../src/Photo.vala"
	if (_klass_->notify_master_reimported) {
#line 421 "../src/Photo.vala"
		_klass_->notify_master_reimported (self, metadata);
#line 2268 "Photo.c"
	}
}

static void
photo_real_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 426 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL], 0, metadata);
#line 2278 "Photo.c"
}

void
photo_notify_editable_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 425 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 425 "../src/Photo.vala"
	if (_klass_->notify_editable_reimported) {
#line 425 "../src/Photo.vala"
		_klass_->notify_editable_reimported (self, metadata);
#line 2294 "Photo.c"
	}
}

static void
photo_real_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 430 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL], 0, metadata);
#line 2304 "Photo.c"
}

void
photo_notify_source_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 429 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 429 "../src/Photo.vala"
	if (_klass_->notify_source_reimported) {
#line 429 "../src/Photo.vala"
		_klass_->notify_source_reimported (self, metadata);
#line 2320 "Photo.c"
	}
}

static void
photo_real_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 434 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL], 0, metadata);
#line 2330 "Photo.c"
}

void
photo_notify_baseline_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 433 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 433 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 433 "../src/Photo.vala"
	if (_klass_->notify_baseline_reimported) {
#line 433 "../src/Photo.vala"
		_klass_->notify_baseline_reimported (self, metadata);
#line 2346 "Photo.c"
	}
}

static gboolean
photo_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Photo * self;
	gboolean ret = FALSE;
	GFile* file = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 437 "../src/Photo.vala"
	self = (Photo*) base;
#line 438 "../src/Photo.vala"
	ret = TRUE;
#line 439 "../src/Photo.vala"
	file = NULL;
#line 2367 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 440 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 440 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 2374 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 441 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 441 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 441 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 2384 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 442 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 442 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 442 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 442 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 442 "../src/Photo.vala"
				file = _tmp5_;
#line 2398 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp6_;
#line 440 "../src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 440 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 2408 "Photo.c"
		}
#line 440 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2412 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 440 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 440 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 440 "../src/Photo.vala"
			return _tmp7_;
#line 2420 "Photo.c"
		}
	}
#line 445 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 447 "../src/Photo.vala"
	if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 2427 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_;
#line 448 "../src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 2432 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 448 "../src/Photo.vala"
			d_collection = _tmp9_;
#line 448 "../src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 448 "../src/Photo.vala"
			for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 2444 "Photo.c"
				RawDeveloper d = 0;
#line 448 "../src/Photo.vala"
				d = d_collection[d_it];
#line 2448 "Photo.c"
				{
#line 449 "../src/Photo.vala"
					photo_delete_raw_development (self, d);
#line 2452 "Photo.c"
				}
			}
#line 448 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 2457 "Photo.c"
		}
	}
#line 453 "../src/Photo.vala"
	media_source_delete_original_file ((MediaSource*) self);
#line 456 "../src/Photo.vala"
	_tmp11_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_inner_error0_);
#line 456 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2466 "Photo.c"
		gboolean _tmp12_ = FALSE;
#line 456 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 456 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 456 "../src/Photo.vala"
		return _tmp12_;
#line 2474 "Photo.c"
	}
#line 456 "../src/Photo.vala"
	if (_tmp11_) {
#line 456 "../src/Photo.vala"
		_tmp10_ = ret;
#line 2480 "Photo.c"
	} else {
#line 456 "../src/Photo.vala"
		_tmp10_ = FALSE;
#line 2484 "Photo.c"
	}
#line 456 "../src/Photo.vala"
	result = _tmp10_;
#line 456 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 456 "../src/Photo.vala"
	return result;
#line 2492 "Photo.c"
}

static BackingPhotoRow*
photo_get_backing_row (Photo* self,
                       BackingPhotoID* id)
{
	BackingPhotoID _tmp0_;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp12_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 461 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "../src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 462 "../src/Photo.vala"
	_tmp0_ = *id;
#line 462 "../src/Photo.vala"
	if (_tmp0_.id == BACKING_PHOTO_ID_INVALID) {
#line 463 "../src/Photo.vala"
		result = NULL;
#line 463 "../src/Photo.vala"
		return result;
#line 2516 "Photo.c"
	}
#line 466 "../src/Photo.vala"
	backing_row = NULL;
#line 2520 "Photo.c"
	{
		BackingPhotoRow* _tmp1_ = NULL;
		BackingPhotoTable* _tmp2_;
		BackingPhotoTable* _tmp3_;
		BackingPhotoID _tmp4_;
		BackingPhotoRow* _tmp5_;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 468 "../src/Photo.vala"
		_tmp2_ = backing_photo_table_get_instance ();
#line 468 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 468 "../src/Photo.vala"
		_tmp4_ = *id;
#line 468 "../src/Photo.vala"
		_tmp5_ = backing_photo_table_fetch (_tmp3_, &_tmp4_, &_inner_error0_);
#line 468 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 468 "../src/Photo.vala"
		_database_table_unref0 (_tmp3_);
#line 468 "../src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 468 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 468 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2547 "Photo.c"
				goto __catch0_database_error;
			}
#line 468 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 468 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 468 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 468 "../src/Photo.vala"
			return NULL;
#line 2558 "Photo.c"
		}
#line 468 "../src/Photo.vala"
		_tmp7_ = _tmp1_;
#line 468 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 468 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 468 "../src/Photo.vala"
		backing_row = _tmp7_;
#line 467 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp1_);
#line 2570 "Photo.c"
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 467 "../src/Photo.vala"
		err = _inner_error0_;
#line 467 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 470 "../src/Photo.vala"
		_tmp8_ = data_object_to_string ((DataObject*) self);
#line 470 "../src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 470 "../src/Photo.vala"
		_tmp10_ = err;
#line 470 "../src/Photo.vala"
		_tmp11_ = _tmp10_->message;
#line 470 "../src/Photo.vala"
		g_warning ("Photo.vala:470: Unable to fetch backing state for %s: %s", _tmp9_, _tmp11_);
#line 470 "../src/Photo.vala"
		_g_free0 (_tmp9_);
#line 467 "../src/Photo.vala"
		_g_error_free0 (err);
#line 2598 "Photo.c"
	}
	__finally0:
#line 467 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 467 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 467 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 467 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 467 "../src/Photo.vala"
		return NULL;
#line 2611 "Photo.c"
	}
#line 473 "../src/Photo.vala"
	_tmp12_ = backing_row;
#line 473 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 2617 "Photo.c"
		{
			BackingPhotoTable* _tmp13_;
			BackingPhotoTable* _tmp14_;
			BackingPhotoID _tmp15_;
#line 475 "../src/Photo.vala"
			_tmp13_ = backing_photo_table_get_instance ();
#line 475 "../src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 475 "../src/Photo.vala"
			_tmp15_ = *id;
#line 475 "../src/Photo.vala"
			backing_photo_table_remove (_tmp14_, &_tmp15_, &_inner_error0_);
#line 475 "../src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 475 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 475 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2636 "Photo.c"
					goto __catch1_database_error;
				}
#line 475 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 475 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 475 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 475 "../src/Photo.vala"
				return NULL;
#line 2647 "Photo.c"
			}
		}
		goto __finally1;
		__catch1_database_error:
		{
#line 474 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2655 "Photo.c"
		}
		__finally1:
#line 474 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 474 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 474 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 474 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 474 "../src/Photo.vala"
			return NULL;
#line 2668 "Photo.c"
		}
#line 479 "../src/Photo.vala"
		result = NULL;
#line 479 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 479 "../src/Photo.vala"
		return result;
#line 2676 "Photo.c"
	}
#line 482 "../src/Photo.vala"
	result = backing_row;
#line 482 "../src/Photo.vala"
	return result;
#line 2682 "Photo.c"
}

gboolean
photo_is_raw_developer_complete (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 487 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2693 "Photo.c"
	{
		GeeHashMap* _tmp0_;
		gboolean _tmp9_ = FALSE;
#line 488 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 488 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 2701 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_;
#line 489 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 489 "../src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) d))) {
#line 2709 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
				BackingPhotoRow* _tmp5_;
				const gchar* _tmp6_;
#line 490 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 490 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) d));
#line 490 "../src/Photo.vala"
				_tmp5_ = (BackingPhotoRow*) _tmp4_;
#line 490 "../src/Photo.vala"
				_tmp6_ = _tmp5_->filepath;
#line 490 "../src/Photo.vala"
				_tmp1_ = g_file_test (_tmp6_, G_FILE_TEST_EXISTS);
#line 490 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp5_);
#line 2726 "Photo.c"
			} else {
#line 489 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 2730 "Photo.c"
			}
#line 489 "../src/Photo.vala"
			result = _tmp1_;
#line 2734 "Photo.c"
			{
				GeeHashMap* _tmp7_;
#line 488 "../src/Photo.vala"
				_tmp7_ = self->priv->developments;
#line 488 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 2741 "Photo.c"
			}
#line 489 "../src/Photo.vala"
			return result;
#line 2745 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp8_;
#line 488 "../src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 488 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 2754 "Photo.c"
		}
#line 488 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 488 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 488 "../src/Photo.vala"
		return _tmp9_;
#line 2762 "Photo.c"
	}
}

gboolean
photo_is_raw_developer_available (Photo* self,
                                  RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 495 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2774 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 496 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 496 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 2781 "Photo.c"
		{
			GeeHashMap* _tmp1_;
#line 497 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 497 "../src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) d))) {
#line 498 "../src/Photo.vala"
				result = TRUE;
#line 2790 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 496 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 496 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 2797 "Photo.c"
				}
#line 498 "../src/Photo.vala"
				return result;
#line 2801 "Photo.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp3_;
#line 496 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 496 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 2811 "Photo.c"
		}
#line 496 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2815 "Photo.c"
			gboolean _tmp4_ = FALSE;
#line 496 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 496 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 496 "../src/Photo.vala"
			return _tmp4_;
#line 2823 "Photo.c"
		}
	}
#line 502 "../src/Photo.vala"
	switch (d) {
#line 502 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 2830 "Photo.c"
		{
#line 504 "../src/Photo.vala"
			result = TRUE;
#line 504 "../src/Photo.vala"
			return result;
#line 2836 "Photo.c"
		}
#line 502 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 2840 "Photo.c"
		{
#line 507 "../src/Photo.vala"
			result = FALSE;
#line 507 "../src/Photo.vala"
			return result;
#line 2846 "Photo.c"
		}
#line 502 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 2850 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp5_;
				guint num_previews = 0U;
				PhotoMetadata* _tmp6_;
#line 511 "../src/Photo.vala"
				_tmp5_ = photo_get_master_metadata (self, &_inner_error0_);
#line 511 "../src/Photo.vala"
				meta = _tmp5_;
#line 511 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2863 "Photo.c"
					goto __catch1_g_error;
				}
#line 512 "../src/Photo.vala"
				_tmp6_ = meta;
#line 512 "../src/Photo.vala"
				num_previews = photo_metadata_get_preview_count (_tmp6_);
#line 514 "../src/Photo.vala"
				if (num_previews > ((guint) 0)) {
#line 2872 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp7_;
					PhotoPreview* _tmp8_;
					PhotoPreview* _tmp9_;
					Dimensions dims = {0};
					PhotoPreview* _tmp10_;
					Dimensions _tmp11_ = {0};
					gint _tmp12_ = 0;
					Dimensions _tmp13_;
					Dimensions _tmp14_;
					gint preview_major_axis = 0;
#line 515 "../src/Photo.vala"
					_tmp7_ = meta;
#line 515 "../src/Photo.vala"
					_tmp8_ = photo_metadata_get_preview (_tmp7_, num_previews - 1);
#line 515 "../src/Photo.vala"
					prev = _tmp8_;
#line 518 "../src/Photo.vala"
					_tmp9_ = prev;
#line 518 "../src/Photo.vala"
					if (_tmp9_ == NULL) {
#line 519 "../src/Photo.vala"
						result = FALSE;
#line 519 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 519 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 519 "../src/Photo.vala"
						return result;
#line 2902 "Photo.c"
					}
#line 522 "../src/Photo.vala"
					_tmp10_ = prev;
#line 522 "../src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp10_, &_tmp11_);
#line 522 "../src/Photo.vala"
					dims = _tmp11_;
#line 525 "../src/Photo.vala"
					_tmp13_ = dims;
#line 525 "../src/Photo.vala"
					_tmp14_ = dims;
#line 525 "../src/Photo.vala"
					if (_tmp13_.width > _tmp14_.height) {
#line 2916 "Photo.c"
						Dimensions _tmp15_;
#line 525 "../src/Photo.vala"
						_tmp15_ = dims;
#line 525 "../src/Photo.vala"
						_tmp12_ = _tmp15_.width;
#line 2922 "Photo.c"
					} else {
						Dimensions _tmp16_;
#line 525 "../src/Photo.vala"
						_tmp16_ = dims;
#line 525 "../src/Photo.vala"
						_tmp12_ = _tmp16_.height;
#line 2929 "Photo.c"
					}
#line 525 "../src/Photo.vala"
					preview_major_axis = _tmp12_;
#line 526 "../src/Photo.vala"
					if (preview_major_axis < PHOTO_MIN_EMBEDDED_SIZE) {
#line 527 "../src/Photo.vala"
						result = FALSE;
#line 527 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 527 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 527 "../src/Photo.vala"
						return result;
#line 2943 "Photo.c"
					}
#line 531 "../src/Photo.vala"
					result = TRUE;
#line 531 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 531 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 531 "../src/Photo.vala"
					return result;
#line 2953 "Photo.c"
				}
#line 535 "../src/Photo.vala"
				result = FALSE;
#line 535 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 535 "../src/Photo.vala"
				return result;
#line 2961 "Photo.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp17_;
				const gchar* _tmp18_;
#line 510 "../src/Photo.vala"
				e = _inner_error0_;
#line 510 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 537 "../src/Photo.vala"
				_tmp17_ = e;
#line 537 "../src/Photo.vala"
				_tmp18_ = _tmp17_->message;
#line 537 "../src/Photo.vala"
				g_debug ("Photo.vala:537: Error accessing embedded preview. Message: %s", _tmp18_);
#line 510 "../src/Photo.vala"
				_g_error_free0 (e);
#line 2981 "Photo.c"
			}
			__finally1:
#line 510 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2986 "Photo.c"
				gboolean _tmp19_ = FALSE;
#line 510 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 510 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 510 "../src/Photo.vala"
				return _tmp19_;
#line 2994 "Photo.c"
			}
#line 539 "../src/Photo.vala"
			result = FALSE;
#line 539 "../src/Photo.vala"
			return result;
#line 3000 "Photo.c"
		}
		default:
		{
#line 542 "../src/Photo.vala"
			g_assert_not_reached ();
#line 3006 "Photo.c"
		}
	}
}

void
photo_add_backing_photo_for_development (Photo* self,
                                         RawDeveloper d,
                                         BackingPhotoRow* bpr,
                                         GError** error)
{
	PhotoRow* _tmp0_;
	Alteration* _tmp4_;
	Alteration* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 549 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 549 "../src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 550 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 550 "../src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, d, bpr, &_inner_error0_);
#line 550 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 550 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 550 "../src/Photo.vala"
		return;
#line 3035 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 551 "../src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 551 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 3043 "Photo.c"
		{
			GeeHashMap* _tmp2_;
#line 552 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 552 "../src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) d), bpr);
#line 3050 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp3_;
#line 551 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 551 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 3059 "Photo.c"
		}
#line 551 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 551 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 551 "../src/Photo.vala"
			return;
#line 3067 "Photo.c"
		}
	}
#line 554 "../src/Photo.vala"
	_tmp4_ = alteration_new ("image", "developer");
#line 554 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 554 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp5_);
#line 554 "../src/Photo.vala"
	_alteration_unref0 (_tmp5_);
#line 3078 "Photo.c"
}

void
photo_import_developed_backing_photo (PhotoRow* row,
                                      RawDeveloper d,
                                      BackingPhotoRow* bpr,
                                      GError** error)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	gint64 mod_time = 0LL;
	GFileInfo* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gint64 _tmp7_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp8_;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp11_;
	DetectedPhotoInformation* _tmp12_;
	DetectedPhotoInformation* _tmp13_;
	Dimensions _tmp14_;
	GFileInfo* _tmp15_;
	Orientation _tmp16_ = 0;
	DetectedPhotoInformation* _tmp17_;
	PhotoMetadata* _tmp18_;
	BackingPhotoTable* _tmp21_;
	BackingPhotoTable* _tmp22_;
	PhotoTable* _tmp23_;
	PhotoTable* _tmp24_;
	BackingPhotoID _tmp25_;
	GError* _inner_error0_ = NULL;
#line 557 "../src/Photo.vala"
	g_return_if_fail (row != NULL);
#line 557 "../src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 560 "../src/Photo.vala"
	_tmp0_ = bpr->filepath;
#line 560 "../src/Photo.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 560 "../src/Photo.vala"
	file = _tmp1_;
#line 561 "../src/Photo.vala"
	_tmp2_ = file;
#line 561 "../src/Photo.vala"
	_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 561 "../src/Photo.vala"
	info = _tmp3_;
#line 561 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 561 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 561 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 561 "../src/Photo.vala"
		return;
#line 3141 "Photo.c"
	}
#line 563 "../src/Photo.vala"
	_tmp4_ = info;
#line 563 "../src/Photo.vala"
	_tmp5_ = g_file_info_get_modification_date_time (_tmp4_);
#line 563 "../src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 563 "../src/Photo.vala"
	_tmp7_ = g_date_time_to_unix (_tmp6_);
#line 563 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp6_);
#line 563 "../src/Photo.vala"
	mod_time = _tmp7_;
#line 565 "../src/Photo.vala"
	_tmp8_ = file;
#line 565 "../src/Photo.vala"
	_tmp9_ = photo_file_interrogator_new (_tmp8_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 565 "../src/Photo.vala"
	interrogator = _tmp9_;
#line 567 "../src/Photo.vala"
	_tmp10_ = interrogator;
#line 567 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp10_, &_inner_error0_);
#line 567 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 567 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 567 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 567 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 567 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 567 "../src/Photo.vala"
		return;
#line 3177 "Photo.c"
	}
#line 569 "../src/Photo.vala"
	_tmp11_ = interrogator;
#line 569 "../src/Photo.vala"
	_tmp12_ = photo_file_interrogator_get_detected_photo_information (_tmp11_);
#line 569 "../src/Photo.vala"
	detected = _tmp12_;
#line 570 "../src/Photo.vala"
	_tmp13_ = detected;
#line 570 "../src/Photo.vala"
	_tmp14_ = _tmp13_->image_dim;
#line 570 "../src/Photo.vala"
	bpr->dim = _tmp14_;
#line 571 "../src/Photo.vala"
	_tmp15_ = info;
#line 571 "../src/Photo.vala"
	bpr->filesize = g_file_info_get_size (_tmp15_);
#line 572 "../src/Photo.vala"
	bpr->timestamp = mod_time;
#line 573 "../src/Photo.vala"
	_tmp17_ = detected;
#line 573 "../src/Photo.vala"
	_tmp18_ = _tmp17_->metadata;
#line 573 "../src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 3203 "Photo.c"
		DetectedPhotoInformation* _tmp19_;
		PhotoMetadata* _tmp20_;
#line 573 "../src/Photo.vala"
		_tmp19_ = detected;
#line 573 "../src/Photo.vala"
		_tmp20_ = _tmp19_->metadata;
#line 573 "../src/Photo.vala"
		_tmp16_ = photo_metadata_get_orientation (_tmp20_);
#line 3212 "Photo.c"
	} else {
#line 574 "../src/Photo.vala"
		_tmp16_ = ORIENTATION_TOP_LEFT;
#line 3216 "Photo.c"
	}
#line 573 "../src/Photo.vala"
	bpr->original_orientation = _tmp16_;
#line 577 "../src/Photo.vala"
	_tmp21_ = backing_photo_table_get_instance ();
#line 577 "../src/Photo.vala"
	_tmp22_ = _tmp21_;
#line 577 "../src/Photo.vala"
	backing_photo_table_add (_tmp22_, bpr, &_inner_error0_);
#line 577 "../src/Photo.vala"
	_database_table_unref0 (_tmp22_);
#line 577 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 577 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 577 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 577 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 577 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 577 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 577 "../src/Photo.vala"
		return;
#line 3242 "Photo.c"
	}
#line 578 "../src/Photo.vala"
	_tmp23_ = photo_table_get_instance ();
#line 578 "../src/Photo.vala"
	_tmp24_ = _tmp23_;
#line 578 "../src/Photo.vala"
	_tmp25_ = bpr->id;
#line 578 "../src/Photo.vala"
	photo_table_update_raw_development (_tmp24_, row, d, &_tmp25_, &_inner_error0_);
#line 578 "../src/Photo.vala"
	_database_table_unref0 (_tmp24_);
#line 578 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 578 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 578 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 578 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 578 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 578 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 578 "../src/Photo.vala"
		return;
#line 3268 "Photo.c"
	}
#line 557 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 557 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 557 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 557 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 3278 "Photo.c"
}

static void
photo_develop_photo (Photo* self,
                     RawDeveloper d)
{
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	GError* _inner_error0_ = NULL;
#line 583 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 584 "../src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 585 "../src/Photo.vala"
	bps = NULL;
#line 587 "../src/Photo.vala"
	switch (d) {
#line 587 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 3298 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp0_ = NULL;
				PhotoRow* _tmp1_;
				BackingPhotoRow* _tmp2_;
				const gchar* _tmp3_;
				BackingPhotoRow* _tmp4_;
				BackingPhotoRow* _tmp5_;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp13_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp17_;
				const gchar* _tmp18_;
				PhotoFileWriter* _tmp19_;
				PhotoFileWriter* _tmp20_;
				GdkPixbuf* _tmp21_;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp22_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp23_;
				const gchar* _tmp24_;
				PhotoFileMetadataWriter* _tmp25_;
				PhotoFileMetadataWriter* _tmp26_;
				PhotoMetadata* _tmp27_;
#line 591 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 591 "../src/Photo.vala"
				_tmp2_ = _tmp1_->master;
#line 591 "../src/Photo.vala"
				_tmp3_ = _tmp2_->filepath;
#line 591 "../src/Photo.vala"
				_tmp4_ = raw_developer_create_backing_row_for_development (d, _tmp3_, NULL, &_inner_error0_);
#line 591 "../src/Photo.vala"
				_tmp0_ = _tmp4_;
#line 591 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3335 "Photo.c"
					goto __catch0_g_error;
				}
#line 591 "../src/Photo.vala"
				_tmp5_ = _tmp0_;
#line 591 "../src/Photo.vala"
				_tmp0_ = NULL;
#line 591 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 591 "../src/Photo.vala"
				bps = _tmp5_;
#line 592 "../src/Photo.vala"
				pix = NULL;
#line 3348 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 593 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 593 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 3355 "Photo.c"
					{
						GdkPixbuf* _tmp7_ = NULL;
						Scaling _tmp8_ = {0};
						GdkPixbuf* _tmp9_;
						GdkPixbuf* _tmp10_;
#line 598 "../src/Photo.vala"
						scaling_for_original (&_tmp8_);
#line 598 "../src/Photo.vala"
						_tmp9_ = photo_get_master_pixbuf (self, &_tmp8_, FALSE, &_inner_error0_);
#line 598 "../src/Photo.vala"
						_tmp7_ = _tmp9_;
#line 598 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3369 "Photo.c"
							goto __catch1_g_error;
						}
#line 598 "../src/Photo.vala"
						_tmp10_ = _tmp7_;
#line 598 "../src/Photo.vala"
						_tmp7_ = NULL;
#line 598 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 598 "../src/Photo.vala"
						pix = _tmp10_;
#line 593 "../src/Photo.vala"
						_g_object_unref0 (_tmp7_);
#line 3382 "Photo.c"
					}
					goto __finally1;
					__catch1_g_error:
					{
						GError* _lock_error_ = NULL;
						GError* _tmp11_;
#line 593 "../src/Photo.vala"
						_lock_error_ = _inner_error0_;
#line 593 "../src/Photo.vala"
						_inner_error0_ = NULL;
#line 593 "../src/Photo.vala"
						_tmp11_ = _lock_error_;
#line 593 "../src/Photo.vala"
						_lock_error_ = NULL;
#line 593 "../src/Photo.vala"
						_inner_error0_ = _tmp11_;
#line 593 "../src/Photo.vala"
						_g_error_free0 (_lock_error_);
#line 3401 "Photo.c"
						goto __finally1;
					}
					__finally1:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp12_;
#line 593 "../src/Photo.vala"
						_tmp12_ = self->priv->readers;
#line 593 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 3412 "Photo.c"
					}
#line 593 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 593 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 593 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp0_);
#line 3420 "Photo.c"
						goto __catch0_g_error;
					}
				}
#line 601 "../src/Photo.vala"
				_tmp13_ = pix;
#line 601 "../src/Photo.vala"
				if (_tmp13_ == NULL) {
#line 602 "../src/Photo.vala"
					g_debug ("Photo.vala:602: Could not get preview pixbuf");
#line 603 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 603 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 3434 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 627 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 3439 "Photo.c"
							{
								BackingPhotoRow* _tmp14_;
#line 630 "../src/Photo.vala"
								_tmp14_ = bps;
#line 630 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp14_, &_inner_error0_);
#line 630 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3448 "Photo.c"
									goto __catch2_g_error;
								}
#line 632 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 3453 "Photo.c"
							}
							goto __finally2;
							__catch2_g_error:
							{
								GError* e = NULL;
								GError* _tmp15_;
								const gchar* _tmp16_;
#line 628 "../src/Photo.vala"
								e = _inner_error0_;
#line 628 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 634 "../src/Photo.vala"
								_tmp15_ = e;
#line 634 "../src/Photo.vala"
								_tmp16_ = _tmp15_->message;
#line 634 "../src/Photo.vala"
								g_debug ("Photo.vala:634: Error adding backing photo as development. Message: %s", _tmp16_);
#line 628 "../src/Photo.vala"
								_g_error_free0 (e);
#line 3473 "Photo.c"
							}
							__finally2:
#line 628 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3478 "Photo.c"
								goto __catch0_g_error;
							}
						}
					}
#line 603 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 603 "../src/Photo.vala"
					return;
#line 3487 "Photo.c"
				}
#line 607 "../src/Photo.vala"
				_tmp17_ = bps;
#line 607 "../src/Photo.vala"
				_tmp18_ = _tmp17_->filepath;
#line 607 "../src/Photo.vala"
				_tmp19_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp18_, &_inner_error0_);
#line 607 "../src/Photo.vala"
				writer = _tmp19_;
#line 607 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 607 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 607 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 3503 "Photo.c"
					goto __catch0_g_error;
				}
#line 608 "../src/Photo.vala"
				_tmp20_ = writer;
#line 608 "../src/Photo.vala"
				_tmp21_ = pix;
#line 608 "../src/Photo.vala"
				photo_file_writer_write (_tmp20_, _tmp21_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 608 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 608 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 608 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 608 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 3520 "Photo.c"
					goto __catch0_g_error;
				}
#line 616 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 621 "../src/Photo.vala"
				_tmp22_ = photo_get_master_metadata (self, &_inner_error0_);
#line 621 "../src/Photo.vala"
				meta = _tmp22_;
#line 621 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 621 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 621 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 3537 "Photo.c"
					goto __catch0_g_error;
				}
#line 622 "../src/Photo.vala"
				_tmp23_ = bps;
#line 622 "../src/Photo.vala"
				_tmp24_ = _tmp23_->filepath;
#line 622 "../src/Photo.vala"
				_tmp25_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp24_, &_inner_error0_);
#line 622 "../src/Photo.vala"
				mwriter = _tmp25_;
#line 622 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 622 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 622 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 622 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 622 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 3558 "Photo.c"
					goto __catch0_g_error;
				}
#line 623 "../src/Photo.vala"
				_tmp26_ = mwriter;
#line 623 "../src/Photo.vala"
				_tmp27_ = meta;
#line 623 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp26_, _tmp27_, &_inner_error0_);
#line 623 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 623 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 623 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 623 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 623 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 623 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 3579 "Photo.c"
					goto __catch0_g_error;
				}
#line 589 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 589 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 589 "../src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 589 "../src/Photo.vala"
				_g_object_unref0 (pix);
#line 589 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp0_);
#line 3592 "Photo.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 589 "../src/Photo.vala"
				err = _inner_error0_;
#line 589 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 625 "../src/Photo.vala"
				_tmp28_ = err;
#line 625 "../src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 625 "../src/Photo.vala"
				g_debug ("Photo.vala:625: Error developing photo: %s", _tmp29_);
#line 589 "../src/Photo.vala"
				_g_error_free0 (err);
#line 3612 "Photo.c"
			}
			__finally0:
			{
				GError* _inner_error1_ = NULL;
#line 627 "../src/Photo.vala"
				if (wrote_img_to_disk) {
#line 3619 "Photo.c"
					{
						BackingPhotoRow* _tmp30_;
#line 630 "../src/Photo.vala"
						_tmp30_ = bps;
#line 630 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp30_, &_inner_error1_);
#line 630 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 3628 "Photo.c"
							goto __catch3_g_error;
						}
#line 632 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 3633 "Photo.c"
					}
					goto __finally3;
					__catch3_g_error:
					{
						GError* e = NULL;
						GError* _tmp31_;
						const gchar* _tmp32_;
#line 628 "../src/Photo.vala"
						e = _inner_error1_;
#line 628 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 634 "../src/Photo.vala"
						_tmp31_ = e;
#line 634 "../src/Photo.vala"
						_tmp32_ = _tmp31_->message;
#line 634 "../src/Photo.vala"
						g_debug ("Photo.vala:634: Error adding backing photo as development. Message: %s", _tmp32_);
#line 628 "../src/Photo.vala"
						_g_error_free0 (e);
#line 3653 "Photo.c"
					}
					__finally3:
#line 628 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 628 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 628 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 628 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 628 "../src/Photo.vala"
						return;
#line 3666 "Photo.c"
					}
				}
			}
#line 589 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 589 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 589 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 589 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 589 "../src/Photo.vala"
				return;
#line 3680 "Photo.c"
			}
#line 640 "../src/Photo.vala"
			break;
#line 3684 "Photo.c"
		}
#line 587 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 3688 "Photo.c"
		{
#line 644 "../src/Photo.vala"
			break;
#line 3692 "Photo.c"
		}
#line 587 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 3696 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp33_;
				guint c = 0U;
				PhotoMetadata* _tmp34_;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp38_;
				PhotoPreview* _tmp39_;
				PhotoPreview* _tmp40_;
				GdkPixbuf* pix = NULL;
				PhotoPreview* _tmp44_;
				GdkPixbuf* _tmp45_;
				GdkPixbuf* _tmp46_;
				BackingPhotoRow* _tmp50_ = NULL;
				PhotoRow* _tmp51_;
				BackingPhotoRow* _tmp52_;
				const gchar* _tmp53_;
				BackingPhotoRow* _tmp54_;
				BackingPhotoRow* _tmp55_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp56_;
				const gchar* _tmp57_;
				PhotoFileWriter* _tmp58_;
				PhotoFileWriter* _tmp59_;
				GdkPixbuf* _tmp60_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp61_;
				const gchar* _tmp62_;
				PhotoFileMetadataWriter* _tmp63_;
				PhotoFileMetadataWriter* _tmp64_;
				PhotoMetadata* _tmp65_;
#line 649 "../src/Photo.vala"
				_tmp33_ = photo_get_master_metadata (self, &_inner_error0_);
#line 649 "../src/Photo.vala"
				meta = _tmp33_;
#line 649 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3735 "Photo.c"
					goto __catch4_g_error;
				}
#line 650 "../src/Photo.vala"
				_tmp34_ = meta;
#line 650 "../src/Photo.vala"
				c = photo_metadata_get_preview_count (_tmp34_);
#line 651 "../src/Photo.vala"
				if (c <= ((guint) 0)) {
#line 652 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 3746 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 682 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 3751 "Photo.c"
							{
								BackingPhotoRow* _tmp35_;
#line 685 "../src/Photo.vala"
								_tmp35_ = bps;
#line 685 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp35_, &_inner_error0_);
#line 685 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3760 "Photo.c"
									goto __catch5_g_error;
								}
#line 687 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 3765 "Photo.c"
							}
							goto __finally5;
							__catch5_g_error:
							{
								GError* e = NULL;
								GError* _tmp36_;
								const gchar* _tmp37_;
#line 683 "../src/Photo.vala"
								e = _inner_error0_;
#line 683 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 689 "../src/Photo.vala"
								_tmp36_ = e;
#line 689 "../src/Photo.vala"
								_tmp37_ = _tmp36_->message;
#line 689 "../src/Photo.vala"
								g_debug ("Photo.vala:689: Error adding backing photo as development. Message: %s", _tmp37_);
#line 683 "../src/Photo.vala"
								_g_error_free0 (e);
#line 3785 "Photo.c"
							}
							__finally5:
#line 683 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3790 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 652 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 652 "../src/Photo.vala"
					return;
#line 3799 "Photo.c"
				}
#line 654 "../src/Photo.vala"
				_tmp38_ = meta;
#line 654 "../src/Photo.vala"
				_tmp39_ = photo_metadata_get_preview (_tmp38_, c - 1);
#line 654 "../src/Photo.vala"
				prev = _tmp39_;
#line 655 "../src/Photo.vala"
				_tmp40_ = prev;
#line 655 "../src/Photo.vala"
				if (_tmp40_ == NULL) {
#line 656 "../src/Photo.vala"
					g_debug ("Photo.vala:656: Could not get preview from metadata");
#line 657 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 657 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 3817 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 682 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 3822 "Photo.c"
							{
								BackingPhotoRow* _tmp41_;
#line 685 "../src/Photo.vala"
								_tmp41_ = bps;
#line 685 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp41_, &_inner_error0_);
#line 685 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3831 "Photo.c"
									goto __catch6_g_error;
								}
#line 687 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 3836 "Photo.c"
							}
							goto __finally6;
							__catch6_g_error:
							{
								GError* e = NULL;
								GError* _tmp42_;
								const gchar* _tmp43_;
#line 683 "../src/Photo.vala"
								e = _inner_error0_;
#line 683 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 689 "../src/Photo.vala"
								_tmp42_ = e;
#line 689 "../src/Photo.vala"
								_tmp43_ = _tmp42_->message;
#line 689 "../src/Photo.vala"
								g_debug ("Photo.vala:689: Error adding backing photo as development. Message: %s", _tmp43_);
#line 683 "../src/Photo.vala"
								_g_error_free0 (e);
#line 3856 "Photo.c"
							}
							__finally6:
#line 683 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3861 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 657 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 657 "../src/Photo.vala"
					return;
#line 3870 "Photo.c"
				}
#line 660 "../src/Photo.vala"
				_tmp44_ = prev;
#line 660 "../src/Photo.vala"
				_tmp45_ = photo_preview_get_pixbuf (_tmp44_, &_inner_error0_);
#line 660 "../src/Photo.vala"
				pix = _tmp45_;
#line 660 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 660 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 660 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 3884 "Photo.c"
					goto __catch4_g_error;
				}
#line 661 "../src/Photo.vala"
				_tmp46_ = pix;
#line 661 "../src/Photo.vala"
				if (_tmp46_ == NULL) {
#line 662 "../src/Photo.vala"
					g_debug ("Photo.vala:662: Could not get preview pixbuf");
#line 663 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 663 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 663 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 3899 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 682 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 3904 "Photo.c"
							{
								BackingPhotoRow* _tmp47_;
#line 685 "../src/Photo.vala"
								_tmp47_ = bps;
#line 685 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp47_, &_inner_error0_);
#line 685 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3913 "Photo.c"
									goto __catch7_g_error;
								}
#line 687 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 3918 "Photo.c"
							}
							goto __finally7;
							__catch7_g_error:
							{
								GError* e = NULL;
								GError* _tmp48_;
								const gchar* _tmp49_;
#line 683 "../src/Photo.vala"
								e = _inner_error0_;
#line 683 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 689 "../src/Photo.vala"
								_tmp48_ = e;
#line 689 "../src/Photo.vala"
								_tmp49_ = _tmp48_->message;
#line 689 "../src/Photo.vala"
								g_debug ("Photo.vala:689: Error adding backing photo as development. Message: %s", _tmp49_);
#line 683 "../src/Photo.vala"
								_g_error_free0 (e);
#line 3938 "Photo.c"
							}
							__finally7:
#line 683 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3943 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 663 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 663 "../src/Photo.vala"
					return;
#line 3952 "Photo.c"
				}
#line 667 "../src/Photo.vala"
				_tmp51_ = self->row;
#line 667 "../src/Photo.vala"
				_tmp52_ = _tmp51_->master;
#line 667 "../src/Photo.vala"
				_tmp53_ = _tmp52_->filepath;
#line 667 "../src/Photo.vala"
				_tmp54_ = raw_developer_create_backing_row_for_development (d, _tmp53_, NULL, &_inner_error0_);
#line 667 "../src/Photo.vala"
				_tmp50_ = _tmp54_;
#line 667 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 667 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 667 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 667 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 3972 "Photo.c"
					goto __catch4_g_error;
				}
#line 667 "../src/Photo.vala"
				_tmp55_ = _tmp50_;
#line 667 "../src/Photo.vala"
				_tmp50_ = NULL;
#line 667 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 667 "../src/Photo.vala"
				bps = _tmp55_;
#line 668 "../src/Photo.vala"
				_tmp56_ = bps;
#line 668 "../src/Photo.vala"
				_tmp57_ = _tmp56_->filepath;
#line 668 "../src/Photo.vala"
				_tmp58_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp57_, &_inner_error0_);
#line 668 "../src/Photo.vala"
				writer = _tmp58_;
#line 668 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 668 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp50_);
#line 668 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 668 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 668 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 4001 "Photo.c"
					goto __catch4_g_error;
				}
#line 669 "../src/Photo.vala"
				_tmp59_ = writer;
#line 669 "../src/Photo.vala"
				_tmp60_ = pix;
#line 669 "../src/Photo.vala"
				photo_file_writer_write (_tmp59_, _tmp60_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 669 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 669 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 669 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp50_);
#line 669 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 669 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 669 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 4022 "Photo.c"
					goto __catch4_g_error;
				}
#line 673 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 676 "../src/Photo.vala"
				_tmp61_ = bps;
#line 676 "../src/Photo.vala"
				_tmp62_ = _tmp61_->filepath;
#line 676 "../src/Photo.vala"
				_tmp63_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp62_, &_inner_error0_);
#line 676 "../src/Photo.vala"
				mwriter = _tmp63_;
#line 676 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 676 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 676 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp50_);
#line 676 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 676 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 676 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 4047 "Photo.c"
					goto __catch4_g_error;
				}
#line 677 "../src/Photo.vala"
				_tmp64_ = mwriter;
#line 677 "../src/Photo.vala"
				_tmp65_ = meta;
#line 677 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp64_, _tmp65_, &_inner_error0_);
#line 677 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 677 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 677 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 677 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp50_);
#line 677 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 677 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 677 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 4070 "Photo.c"
					goto __catch4_g_error;
				}
#line 647 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 647 "../src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 647 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp50_);
#line 647 "../src/Photo.vala"
				_g_object_unref0 (pix);
#line 647 "../src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 647 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 4085 "Photo.c"
			}
			goto __finally4;
			__catch4_g_error:
			{
				GError* e = NULL;
				GError* _tmp66_;
				const gchar* _tmp67_;
#line 647 "../src/Photo.vala"
				e = _inner_error0_;
#line 647 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 679 "../src/Photo.vala"
				_tmp66_ = e;
#line 679 "../src/Photo.vala"
				_tmp67_ = _tmp66_->message;
#line 679 "../src/Photo.vala"
				g_debug ("Photo.vala:679: Error accessing embedded preview. Message: %s", _tmp67_);
#line 680 "../src/Photo.vala"
				_g_error_free0 (e);
#line 4105 "Photo.c"
				{
					GError* _inner_error0_ = NULL;
#line 682 "../src/Photo.vala"
					if (wrote_img_to_disk) {
#line 4110 "Photo.c"
						{
							BackingPhotoRow* _tmp68_;
#line 685 "../src/Photo.vala"
							_tmp68_ = bps;
#line 685 "../src/Photo.vala"
							photo_add_backing_photo_for_development (self, d, _tmp68_, &_inner_error0_);
#line 685 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4119 "Photo.c"
								goto __catch8_g_error;
							}
#line 687 "../src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 4124 "Photo.c"
						}
						goto __finally8;
						__catch8_g_error:
						{
							GError* e = NULL;
							GError* _tmp69_;
							const gchar* _tmp70_;
#line 683 "../src/Photo.vala"
							e = _inner_error0_;
#line 683 "../src/Photo.vala"
							_inner_error0_ = NULL;
#line 689 "../src/Photo.vala"
							_tmp69_ = e;
#line 689 "../src/Photo.vala"
							_tmp70_ = _tmp69_->message;
#line 689 "../src/Photo.vala"
							g_debug ("Photo.vala:689: Error adding backing photo as development. Message: %s", _tmp70_);
#line 683 "../src/Photo.vala"
							_g_error_free0 (e);
#line 4144 "Photo.c"
						}
						__finally8:
#line 683 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 683 "../src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 4151 "Photo.c"
						}
					}
				}
#line 680 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 680 "../src/Photo.vala"
				return;
#line 4159 "Photo.c"
			}
			__finally4:
			{
				GError* _inner_error1_ = NULL;
#line 682 "../src/Photo.vala"
				if (wrote_img_to_disk) {
#line 4166 "Photo.c"
					{
						BackingPhotoRow* _tmp71_;
#line 685 "../src/Photo.vala"
						_tmp71_ = bps;
#line 685 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp71_, &_inner_error1_);
#line 685 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 4175 "Photo.c"
							goto __catch9_g_error;
						}
#line 687 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 4180 "Photo.c"
					}
					goto __finally9;
					__catch9_g_error:
					{
						GError* e = NULL;
						GError* _tmp72_;
						const gchar* _tmp73_;
#line 683 "../src/Photo.vala"
						e = _inner_error1_;
#line 683 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 689 "../src/Photo.vala"
						_tmp72_ = e;
#line 689 "../src/Photo.vala"
						_tmp73_ = _tmp72_->message;
#line 689 "../src/Photo.vala"
						g_debug ("Photo.vala:689: Error adding backing photo as development. Message: %s", _tmp73_);
#line 683 "../src/Photo.vala"
						_g_error_free0 (e);
#line 4200 "Photo.c"
					}
					__finally9:
#line 683 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 683 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 683 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 683 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 683 "../src/Photo.vala"
						return;
#line 4213 "Photo.c"
					}
				}
			}
#line 647 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 647 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 647 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 647 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 647 "../src/Photo.vala"
				return;
#line 4227 "Photo.c"
			}
#line 694 "../src/Photo.vala"
			break;
#line 4231 "Photo.c"
		}
		default:
		{
#line 697 "../src/Photo.vala"
			g_assert_not_reached ();
#line 4237 "Photo.c"
		}
	}
#line 583 "../src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 4242 "Photo.c"
}

void
photo_set_default_raw_developer (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 702 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4252 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 703 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 703 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 4259 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 704 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 704 "../src/Photo.vala"
			_tmp1_->developer = d;
#line 4266 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 703 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 703 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 4275 "Photo.c"
		}
#line 703 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 703 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 703 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 703 "../src/Photo.vala"
			return;
#line 4285 "Photo.c"
		}
	}
}

void
photo_set_raw_developer (Photo* self,
                         RawDeveloper d)
{
	gboolean _tmp0_ = FALSE;
	Alteration* _tmp25_;
	Alteration* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 709 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 710 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 711 "../src/Photo.vala"
		return;
#line 4304 "Photo.c"
	}
#line 717 "../src/Photo.vala"
	if (photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA)) {
#line 717 "../src/Photo.vala"
		_tmp0_ = d == RAW_DEVELOPER_EMBEDDED;
#line 4310 "Photo.c"
	} else {
#line 717 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 4314 "Photo.c"
	}
#line 717 "../src/Photo.vala"
	if (_tmp0_) {
#line 718 "../src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 4320 "Photo.c"
	}
#line 723 "../src/Photo.vala"
	if (!photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED)) {
#line 724 "../src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 4326 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 727 "../src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 727 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4334 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp4_;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			PhotoBackingReaders* _tmp9_;
			BackingPhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			const gchar* _tmp12_;
			PhotoFileReader* _tmp13_;
			BackingPhotoRow* _tmp14_;
			gboolean _tmp22_ = FALSE;
#line 728 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 728 "../src/Photo.vala"
			stale_raw_developer = _tmp2_->developer;
#line 731 "../src/Photo.vala"
			if (!photo_is_raw_developer_complete (self, d)) {
#line 732 "../src/Photo.vala"
				photo_develop_photo (self, d);
#line 4357 "Photo.c"
				{
#line 734 "../src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error0_);
#line 734 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4363 "Photo.c"
						goto __catch1_g_error;
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
#line 733 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4372 "Photo.c"
					{
						GeeHashMap* _tmp3_;
#line 727 "../src/Photo.vala"
						_tmp3_ = self->priv->developments;
#line 727 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4379 "Photo.c"
					}
#line 737 "../src/Photo.vala"
					return;
#line 4383 "Photo.c"
				}
				__finally1:
#line 733 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 733 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 733 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 733 "../src/Photo.vala"
					return;
#line 4394 "Photo.c"
				}
			}
#line 740 "../src/Photo.vala"
			_tmp4_ = self->priv->developments;
#line 740 "../src/Photo.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) d))) {
#line 4401 "Photo.c"
				{
					GeeHashMap* _tmp5_;
#line 727 "../src/Photo.vala"
					_tmp5_ = self->priv->developments;
#line 727 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4408 "Photo.c"
				}
#line 741 "../src/Photo.vala"
				return;
#line 4412 "Photo.c"
			}
#line 745 "../src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 748 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 748 "../src/Photo.vala"
			_tmp6_->developer = d;
#line 749 "../src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 749 "../src/Photo.vala"
			_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) d));
#line 749 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 749 "../src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp8_;
#line 750 "../src/Photo.vala"
			_tmp9_ = self->priv->readers;
#line 750 "../src/Photo.vala"
			_tmp10_ = self->backing_photo_row;
#line 750 "../src/Photo.vala"
			_tmp11_ = self->backing_photo_row;
#line 750 "../src/Photo.vala"
			_tmp12_ = _tmp11_->filepath;
#line 750 "../src/Photo.vala"
			_tmp13_ = photo_file_format_create_reader (_tmp10_->file_format, _tmp12_);
#line 750 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp9_->developer);
#line 750 "../src/Photo.vala"
			_tmp9_->developer = _tmp13_;
#line 752 "../src/Photo.vala"
			_tmp14_ = self->backing_photo_row;
#line 752 "../src/Photo.vala"
			photo_set_orientation (self, _tmp14_->original_orientation);
#line 4446 "Photo.c"
			{
				PhotoTable* _tmp15_;
				PhotoTable* _tmp16_;
				PhotoRow* _tmp17_;
				BackingPhotoRow* _tmp18_;
				BackingPhotoID _tmp19_;
#line 755 "../src/Photo.vala"
				_tmp15_ = photo_table_get_instance ();
#line 755 "../src/Photo.vala"
				_tmp16_ = _tmp15_;
#line 755 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 755 "../src/Photo.vala"
				_tmp18_ = self->backing_photo_row;
#line 755 "../src/Photo.vala"
				_tmp19_ = _tmp18_->id;
#line 755 "../src/Photo.vala"
				photo_table_update_raw_development (_tmp16_, _tmp17_, d, &_tmp19_, &_inner_error0_);
#line 755 "../src/Photo.vala"
				_database_table_unref0 (_tmp16_);
#line 755 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4469 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp20_;
				const gchar* _tmp21_;
#line 754 "../src/Photo.vala"
				e = _inner_error0_;
#line 754 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 757 "../src/Photo.vala"
				_tmp20_ = e;
#line 757 "../src/Photo.vala"
				_tmp21_ = _tmp20_->message;
#line 757 "../src/Photo.vala"
				g_warning ("Photo.vala:757: Error updating database: %s", _tmp21_);
#line 754 "../src/Photo.vala"
				_g_error_free0 (e);
#line 4491 "Photo.c"
			}
			__finally2:
#line 754 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 754 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 754 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 754 "../src/Photo.vala"
				return;
#line 4502 "Photo.c"
			}
#line 764 "../src/Photo.vala"
			if (stale_raw_developer != RAW_DEVELOPER_CAMERA) {
#line 4506 "Photo.c"
				PhotoRow* _tmp23_;
#line 765 "../src/Photo.vala"
				_tmp23_ = self->row;
#line 765 "../src/Photo.vala"
				_tmp22_ = stale_raw_developer != _tmp23_->developer;
#line 4512 "Photo.c"
			} else {
#line 764 "../src/Photo.vala"
				_tmp22_ = FALSE;
#line 4516 "Photo.c"
			}
#line 764 "../src/Photo.vala"
			if (_tmp22_) {
#line 768 "../src/Photo.vala"
				photo_delete_raw_development (self, stale_raw_developer);
#line 4522 "Photo.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp24_;
#line 727 "../src/Photo.vala"
			_tmp24_ = self->priv->developments;
#line 727 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4532 "Photo.c"
		}
#line 727 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 727 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 727 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 727 "../src/Photo.vala"
			return;
#line 4542 "Photo.c"
		}
	}
#line 775 "../src/Photo.vala"
	_tmp25_ = alteration_new ("image", "developer");
#line 775 "../src/Photo.vala"
	_tmp26_ = _tmp25_;
#line 775 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp26_);
#line 775 "../src/Photo.vala"
	_alteration_unref0 (_tmp26_);
#line 776 "../src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 4555 "Photo.c"
}

RawDeveloper
photo_get_raw_developer (Photo* self)
{
	PhotoRow* _tmp0_;
	RawDeveloper result;
#line 779 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 780 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 780 "../src/Photo.vala"
	result = _tmp0_->developer;
#line 780 "../src/Photo.vala"
	return result;
#line 4571 "Photo.c"
}

static gboolean
photo_delete_raw_development (Photo* self,
                              RawDeveloper d)
{
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 785 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 786 "../src/Photo.vala"
	ret = FALSE;
#line 4585 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 788 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 788 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4592 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			BackingPhotoRow* _tmp9_;
			const gchar* _tmp10_;
			GeeHashMap* _tmp31_;
#line 789 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 789 "../src/Photo.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) d))) {
#line 790 "../src/Photo.vala"
				result = FALSE;
#line 4611 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 788 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 788 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4618 "Photo.c"
				}
#line 790 "../src/Photo.vala"
				return result;
#line 4622 "Photo.c"
			}
#line 794 "../src/Photo.vala"
			_tmp3_ = data_object_to_string ((DataObject*) self);
#line 794 "../src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 794 "../src/Photo.vala"
			_tmp5_ = raw_developer_to_string (d);
#line 794 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 794 "../src/Photo.vala"
			g_debug ("Photo.vala:794: Delete raw development: %s %s", _tmp4_, _tmp6_);
#line 794 "../src/Photo.vala"
			_g_free0 (_tmp6_);
#line 794 "../src/Photo.vala"
			_g_free0 (_tmp4_);
#line 795 "../src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 795 "../src/Photo.vala"
			_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) d));
#line 795 "../src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp8_;
#line 796 "../src/Photo.vala"
			_tmp9_ = bpr;
#line 796 "../src/Photo.vala"
			_tmp10_ = _tmp9_->filepath;
#line 796 "../src/Photo.vala"
			if (_tmp10_ != NULL) {
#line 4650 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
#line 797 "../src/Photo.vala"
				_tmp11_ = bpr;
#line 797 "../src/Photo.vala"
				_tmp12_ = _tmp11_->filepath;
#line 797 "../src/Photo.vala"
				_tmp13_ = g_file_new_for_path (_tmp12_);
#line 797 "../src/Photo.vala"
				f = _tmp13_;
#line 4663 "Photo.c"
				{
#line 799 "../src/Photo.vala"
					if (d == RAW_DEVELOPER_CAMERA) {
#line 4667 "Photo.c"
						GFile* _tmp14_;
#line 800 "../src/Photo.vala"
						_tmp14_ = f;
#line 800 "../src/Photo.vala"
						g_file_trash (_tmp14_, NULL, &_inner_error0_);
#line 800 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4675 "Photo.c"
							goto __catch1_g_error;
						}
					} else {
						GFile* _tmp15_;
#line 802 "../src/Photo.vala"
						_tmp15_ = f;
#line 802 "../src/Photo.vala"
						g_file_delete (_tmp15_, NULL, &_inner_error0_);
#line 802 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4686 "Photo.c"
							goto __catch1_g_error;
						}
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp16_;
					const gchar* _tmp17_;
					GError* _tmp18_;
					const gchar* _tmp19_;
#line 798 "../src/Photo.vala"
					e = _inner_error0_;
#line 798 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 805 "../src/Photo.vala"
					_tmp16_ = bpr;
#line 805 "../src/Photo.vala"
					_tmp17_ = _tmp16_->filepath;
#line 805 "../src/Photo.vala"
					_tmp18_ = e;
#line 805 "../src/Photo.vala"
					_tmp19_ = _tmp18_->message;
#line 805 "../src/Photo.vala"
					g_warning ("Photo.vala:805: Unable to delete RAW development: %s error: %s", _tmp17_, _tmp19_);
#line 798 "../src/Photo.vala"
					_g_error_free0 (e);
#line 4715 "Photo.c"
				}
				__finally1:
#line 798 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4720 "Photo.c"
					gboolean _tmp20_ = FALSE;
#line 798 "../src/Photo.vala"
					_g_object_unref0 (f);
#line 798 "../src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 798 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 798 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 798 "../src/Photo.vala"
					return _tmp20_;
#line 4732 "Photo.c"
				}
#line 796 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 4736 "Photo.c"
			}
			{
				PhotoTable* _tmp21_;
				PhotoTable* _tmp22_;
				PhotoRow* _tmp23_;
				BackingPhotoTable* _tmp24_;
				BackingPhotoTable* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoID _tmp27_;
#line 811 "../src/Photo.vala"
				_tmp21_ = photo_table_get_instance ();
#line 811 "../src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 811 "../src/Photo.vala"
				_tmp23_ = self->row;
#line 811 "../src/Photo.vala"
				photo_table_remove_development (_tmp22_, _tmp23_, d, &_inner_error0_);
#line 811 "../src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 811 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4758 "Photo.c"
					goto __catch2_g_error;
				}
#line 812 "../src/Photo.vala"
				_tmp24_ = backing_photo_table_get_instance ();
#line 812 "../src/Photo.vala"
				_tmp25_ = _tmp24_;
#line 812 "../src/Photo.vala"
				_tmp26_ = bpr;
#line 812 "../src/Photo.vala"
				_tmp27_ = _tmp26_->id;
#line 812 "../src/Photo.vala"
				backing_photo_table_remove (_tmp25_, &_tmp27_, &_inner_error0_);
#line 812 "../src/Photo.vala"
				_database_table_unref0 (_tmp25_);
#line 812 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4775 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 810 "../src/Photo.vala"
				e = _inner_error0_;
#line 810 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 814 "../src/Photo.vala"
				_tmp28_ = e;
#line 814 "../src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 814 "../src/Photo.vala"
				g_warning ("Photo.vala:814: Database error while deleting RAW development: %s", _tmp29_);
#line 810 "../src/Photo.vala"
				_g_error_free0 (e);
#line 4797 "Photo.c"
			}
			__finally2:
#line 810 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4802 "Photo.c"
				gboolean _tmp30_ = FALSE;
#line 810 "../src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 810 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 810 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 810 "../src/Photo.vala"
				return _tmp30_;
#line 4812 "Photo.c"
			}
#line 817 "../src/Photo.vala"
			_tmp31_ = self->priv->developments;
#line 817 "../src/Photo.vala"
			ret = gee_abstract_map_unset ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) d), NULL);
#line 788 "../src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 4820 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp32_;
#line 788 "../src/Photo.vala"
			_tmp32_ = self->priv->developments;
#line 788 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4829 "Photo.c"
		}
#line 788 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4833 "Photo.c"
			gboolean _tmp33_ = FALSE;
#line 788 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 788 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 788 "../src/Photo.vala"
			return _tmp33_;
#line 4841 "Photo.c"
		}
	}
#line 820 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 821 "../src/Photo.vala"
	result = ret;
#line 821 "../src/Photo.vala"
	return result;
#line 4850 "Photo.c"
}

void
photo_redevelop_raw (Photo* self,
                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 825 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4860 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 826 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 826 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4867 "Photo.c"
		{
			RawDeveloper dev = 0;
#line 827 "../src/Photo.vala"
			photo_delete_raw_development (self, d);
#line 828 "../src/Photo.vala"
			dev = d;
#line 829 "../src/Photo.vala"
			if (dev == RAW_DEVELOPER_CAMERA) {
#line 830 "../src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 4878 "Photo.c"
			}
#line 833 "../src/Photo.vala"
			photo_set_raw_developer (self, dev);
#line 4882 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp1_;
#line 826 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 826 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4891 "Photo.c"
		}
#line 826 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 826 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 826 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 826 "../src/Photo.vala"
			return;
#line 4901 "Photo.c"
		}
	}
}

static void
_vala_array_add7 (BackingFileState** * array,
                  gint* length,
                  gint* size,
                  BackingFileState* value)
{
#line 840 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 840 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 840 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 4918 "Photo.c"
	}
#line 840 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 840 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 4924 "Photo.c"
}

static void
_vala_array_add8 (BackingFileState** * array,
                  gint* length,
                  gint* size,
                  BackingFileState* value)
{
#line 842 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 842 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 842 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 4939 "Photo.c"
	}
#line 842 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 842 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 4945 "Photo.c"
}

static void
_vala_array_add9 (BackingFileState** * array,
                  gint* length,
                  gint* size,
                  BackingFileState* value)
{
#line 850 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 850 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 850 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 4960 "Photo.c"
	}
#line 850 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 850 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 4966 "Photo.c"
}

static BackingFileState**
photo_real_get_backing_files_state (MediaSource* base,
                                    gint* result_length1)
{
	Photo * self;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp21_;
	gint _tmp21__length1;
	GError* _inner_error0_ = NULL;
	BackingFileState** result;
#line 837 "../src/Photo.vala"
	self = (Photo*) base;
#line 838 "../src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 838 "../src/Photo.vala"
	backing = _tmp0_;
#line 838 "../src/Photo.vala"
	backing_length1 = 0;
#line 838 "../src/Photo.vala"
	_backing_size_ = backing_length1;
#line 4992 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 839 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 839 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 4999 "Photo.c"
		{
			PhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
			PhotoRow* _tmp4_;
			const gchar* _tmp5_;
			BackingFileState* _tmp6_;
#line 840 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 840 "../src/Photo.vala"
			_tmp3_ = _tmp2_->master;
#line 840 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 840 "../src/Photo.vala"
			_tmp5_ = _tmp4_->md5;
#line 840 "../src/Photo.vala"
			_tmp6_ = backing_file_state_new_from_photo_row (_tmp3_, _tmp5_);
#line 840 "../src/Photo.vala"
			_vala_array_add7 (&backing, &backing_length1, &_backing_size_, _tmp6_);
#line 841 "../src/Photo.vala"
			if (photo_has_editable (self)) {
#line 5020 "Photo.c"
				BackingPhotoRow* _tmp7_;
				BackingFileState* _tmp8_;
#line 842 "../src/Photo.vala"
				_tmp7_ = self->priv->editable;
#line 842 "../src/Photo.vala"
				_tmp8_ = backing_file_state_new_from_photo_row (_tmp7_, NULL);
#line 842 "../src/Photo.vala"
				_vala_array_add8 (&backing, &backing_length1, &_backing_size_, _tmp8_);
#line 5029 "Photo.c"
			}
#line 845 "../src/Photo.vala"
			if (photo_is_developed (self)) {
#line 5033 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp9_;
				GeeCollection* _tmp10_;
#line 846 "../src/Photo.vala"
				_tmp9_ = photo_get_raw_development_photo_rows (self);
#line 846 "../src/Photo.vala"
				dev_rows = _tmp9_;
#line 847 "../src/Photo.vala"
				_tmp10_ = dev_rows;
#line 847 "../src/Photo.vala"
				if (_tmp10_ != NULL) {
#line 5045 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp11_;
						GeeIterator* _tmp12_;
#line 848 "../src/Photo.vala"
						_tmp11_ = dev_rows;
#line 848 "../src/Photo.vala"
						_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 848 "../src/Photo.vala"
						_r_it = _tmp12_;
#line 848 "../src/Photo.vala"
						while (TRUE) {
#line 5058 "Photo.c"
							GeeIterator* _tmp13_;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp14_;
							gpointer _tmp15_;
							BackingPhotoRow* _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							BackingFileState* _tmp19_;
#line 848 "../src/Photo.vala"
							_tmp13_ = _r_it;
#line 848 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp13_)) {
#line 848 "../src/Photo.vala"
								break;
#line 5073 "Photo.c"
							}
#line 848 "../src/Photo.vala"
							_tmp14_ = _r_it;
#line 848 "../src/Photo.vala"
							_tmp15_ = gee_iterator_get (_tmp14_);
#line 848 "../src/Photo.vala"
							r = (BackingPhotoRow*) _tmp15_;
#line 849 "../src/Photo.vala"
							_tmp16_ = r;
#line 849 "../src/Photo.vala"
							_tmp17_ = _tmp16_->filepath;
#line 849 "../src/Photo.vala"
							g_debug ("Photo.vala:849: adding: %s", _tmp17_);
#line 850 "../src/Photo.vala"
							_tmp18_ = r;
#line 850 "../src/Photo.vala"
							_tmp19_ = backing_file_state_new_from_photo_row (_tmp18_, NULL);
#line 850 "../src/Photo.vala"
							_vala_array_add9 (&backing, &backing_length1, &_backing_size_, _tmp19_);
#line 848 "../src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 5095 "Photo.c"
						}
#line 848 "../src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 5099 "Photo.c"
					}
				}
#line 845 "../src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 5104 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp20_;
#line 839 "../src/Photo.vala"
			_tmp20_ = self->row;
#line 839 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 5114 "Photo.c"
		}
#line 839 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 839 "../src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 839 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 839 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 839 "../src/Photo.vala"
			return NULL;
#line 5126 "Photo.c"
		}
	}
#line 856 "../src/Photo.vala"
	_tmp21_ = backing;
#line 856 "../src/Photo.vala"
	_tmp21__length1 = backing_length1;
#line 856 "../src/Photo.vala"
	if (result_length1) {
#line 856 "../src/Photo.vala"
		*result_length1 = _tmp21__length1;
#line 5137 "Photo.c"
	}
#line 856 "../src/Photo.vala"
	result = _tmp21_;
#line 856 "../src/Photo.vala"
	return result;
#line 5143 "Photo.c"
}

static PhotoFileReader*
photo_get_backing_reader (Photo* self,
                          BackingFetchMode mode)
{
	PhotoFileReader* result;
#line 859 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 860 "../src/Photo.vala"
	switch (mode) {
#line 860 "../src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 5157 "Photo.c"
		{
			PhotoFileReader* _tmp0_;
#line 862 "../src/Photo.vala"
			_tmp0_ = photo_get_master_reader (self);
#line 862 "../src/Photo.vala"
			result = _tmp0_;
#line 862 "../src/Photo.vala"
			return result;
#line 5166 "Photo.c"
		}
#line 860 "../src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 5170 "Photo.c"
		{
			PhotoFileReader* _tmp1_;
#line 865 "../src/Photo.vala"
			_tmp1_ = photo_get_baseline_reader (self);
#line 865 "../src/Photo.vala"
			result = _tmp1_;
#line 865 "../src/Photo.vala"
			return result;
#line 5179 "Photo.c"
		}
#line 860 "../src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 5183 "Photo.c"
		{
			PhotoFileReader* _tmp2_;
#line 868 "../src/Photo.vala"
			_tmp2_ = photo_get_source_reader (self);
#line 868 "../src/Photo.vala"
			result = _tmp2_;
#line 868 "../src/Photo.vala"
			return result;
#line 5192 "Photo.c"
		}
#line 860 "../src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 5196 "Photo.c"
		{
#line 871 "../src/Photo.vala"
			if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 5200 "Photo.c"
				PhotoFileReader* _tmp3_;
#line 872 "../src/Photo.vala"
				_tmp3_ = photo_get_raw_developer_reader (self);
#line 872 "../src/Photo.vala"
				result = _tmp3_;
#line 872 "../src/Photo.vala"
				return result;
#line 5208 "Photo.c"
			} else {
				PhotoFileReader* _tmp4_;
#line 874 "../src/Photo.vala"
				_tmp4_ = photo_get_master_reader (self);
#line 874 "../src/Photo.vala"
				result = _tmp4_;
#line 874 "../src/Photo.vala"
				return result;
#line 5217 "Photo.c"
			}
		}
		default:
		{
			GEnumValue* _tmp5_;
#line 878 "../src/Photo.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), mode);
#line 878 "../src/Photo.vala"
			g_error ("Photo.vala:878: Unknown backing fetch mode %s", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 5227 "Photo.c"
		}
	}
}

static gpointer
_photo_file_adapter_ref0 (gpointer self)
{
#line 884 "../src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 5237 "Photo.c"
}

static PhotoFileReader*
photo_get_master_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 882 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5247 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 883 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 883 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5254 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 884 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 884 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 884 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 884 "../src/Photo.vala"
			result = _tmp3_;
#line 5267 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 883 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 883 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5274 "Photo.c"
			}
#line 884 "../src/Photo.vala"
			return result;
#line 5278 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 883 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 883 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5287 "Photo.c"
		}
#line 883 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 883 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 883 "../src/Photo.vala"
		return NULL;
#line 5295 "Photo.c"
	}
}

PhotoFileReader*
photo_get_editable_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 888 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5306 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 889 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 889 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5313 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 890 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 890 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 890 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 890 "../src/Photo.vala"
			result = _tmp3_;
#line 5326 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 889 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 889 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5333 "Photo.c"
			}
#line 890 "../src/Photo.vala"
			return result;
#line 5337 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 889 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 889 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5346 "Photo.c"
		}
#line 889 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 889 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 889 "../src/Photo.vala"
		return NULL;
#line 5354 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_baseline_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 895 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5365 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 896 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 896 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5372 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 897 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 897 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 897 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 5387 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 898 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 898 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 898 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 898 "../src/Photo.vala"
				result = _tmp5_;
#line 5399 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 896 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 896 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5406 "Photo.c"
				}
#line 898 "../src/Photo.vala"
				return result;
#line 5410 "Photo.c"
			}
#line 901 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 901 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 901 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 5418 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 902 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 902 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 902 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 902 "../src/Photo.vala"
				result = _tmp11_;
#line 5430 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 896 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 896 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5437 "Photo.c"
				}
#line 902 "../src/Photo.vala"
				return result;
#line 5441 "Photo.c"
			}
#line 905 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 905 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 905 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 905 "../src/Photo.vala"
			result = _tmp15_;
#line 5451 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 896 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 896 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5458 "Photo.c"
			}
#line 905 "../src/Photo.vala"
			return result;
#line 5462 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp17_;
#line 896 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 896 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5471 "Photo.c"
		}
#line 896 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 896 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 896 "../src/Photo.vala"
		return NULL;
#line 5479 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_source_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 910 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5490 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 911 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 911 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5497 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 912 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 912 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 912 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 5512 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 913 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 913 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 913 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 913 "../src/Photo.vala"
				result = _tmp5_;
#line 5524 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 911 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 911 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5531 "Photo.c"
				}
#line 913 "../src/Photo.vala"
				return result;
#line 5535 "Photo.c"
			}
#line 916 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 916 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 916 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 5543 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 917 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 917 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 917 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 917 "../src/Photo.vala"
				result = _tmp11_;
#line 5555 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 911 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 911 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5562 "Photo.c"
				}
#line 917 "../src/Photo.vala"
				return result;
#line 5566 "Photo.c"
			}
#line 920 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 920 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 920 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 920 "../src/Photo.vala"
			result = _tmp15_;
#line 5576 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 911 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 911 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5583 "Photo.c"
			}
#line 920 "../src/Photo.vala"
			return result;
#line 5587 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp17_;
#line 911 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 911 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5596 "Photo.c"
		}
#line 911 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 911 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 911 "../src/Photo.vala"
		return NULL;
#line 5604 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_raw_developer_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 925 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5615 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 926 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 926 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5622 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 927 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 927 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 927 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 927 "../src/Photo.vala"
			result = _tmp3_;
#line 5635 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 926 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 926 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5642 "Photo.c"
			}
#line 927 "../src/Photo.vala"
			return result;
#line 5646 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 926 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 926 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5655 "Photo.c"
		}
#line 926 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 926 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 926 "../src/Photo.vala"
		return NULL;
#line 5663 "Photo.c"
	}
}

gboolean
photo_is_developed (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 931 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5674 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 932 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 932 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5682 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 933 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 933 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 933 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 5692 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 932 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 932 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5699 "Photo.c"
			}
#line 933 "../src/Photo.vala"
			return result;
#line 5703 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 932 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 932 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5712 "Photo.c"
		}
#line 932 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 932 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 932 "../src/Photo.vala"
		return _tmp5_;
#line 5720 "Photo.c"
	}
}

gboolean
photo_has_editable (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 937 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5731 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 938 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 938 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5739 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 939 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 939 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 939 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 5749 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 938 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 938 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5756 "Photo.c"
			}
#line 939 "../src/Photo.vala"
			return result;
#line 5760 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 938 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 938 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5769 "Photo.c"
		}
#line 938 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 938 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 938 "../src/Photo.vala"
		return _tmp5_;
#line 5777 "Photo.c"
	}
}

gboolean
photo_does_master_exist (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 943 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5788 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 944 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 944 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5796 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 945 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 945 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 945 "../src/Photo.vala"
			result = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp2_);
#line 5806 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 944 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 944 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5813 "Photo.c"
			}
#line 945 "../src/Photo.vala"
			return result;
#line 5817 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 944 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 944 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5826 "Photo.c"
		}
#line 944 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 944 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 944 "../src/Photo.vala"
		return _tmp5_;
#line 5834 "Photo.c"
	}
}

gboolean
photo_does_editable_exist (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 950 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5845 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 951 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 951 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5853 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 952 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 952 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 952 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 5864 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 952 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 952 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 952 "../src/Photo.vala"
				_tmp1_ = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp5_);
#line 5873 "Photo.c"
			} else {
#line 952 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 5877 "Photo.c"
			}
#line 952 "../src/Photo.vala"
			result = _tmp1_;
#line 5881 "Photo.c"
			{
				PhotoBackingReaders* _tmp6_;
#line 951 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 951 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5888 "Photo.c"
			}
#line 952 "../src/Photo.vala"
			return result;
#line 5892 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp7_;
#line 951 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 951 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5901 "Photo.c"
		}
#line 951 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 951 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 951 "../src/Photo.vala"
		return _tmp8_;
#line 5909 "Photo.c"
	}
}

gboolean
photo_is_master_baseline (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 956 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5920 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 957 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 957 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5928 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 958 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 958 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 958 "../src/Photo.vala"
			result = _tmp2_ == NULL;
#line 5938 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 957 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 957 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5945 "Photo.c"
			}
#line 958 "../src/Photo.vala"
			return result;
#line 5949 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 957 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 957 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5958 "Photo.c"
		}
#line 957 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 957 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 957 "../src/Photo.vala"
		return _tmp5_;
#line 5966 "Photo.c"
	}
}

gboolean
photo_is_master_source (Photo* self)
{
	gboolean result;
#line 962 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 963 "../src/Photo.vala"
	result = !photo_has_editable (self);
#line 963 "../src/Photo.vala"
	return result;
#line 5980 "Photo.c"
}

gboolean
photo_is_editable_baseline (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 966 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5990 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 967 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 967 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5998 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 968 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 968 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 968 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 6008 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 967 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 967 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6015 "Photo.c"
			}
#line 968 "../src/Photo.vala"
			return result;
#line 6019 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 967 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 967 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6028 "Photo.c"
		}
#line 967 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 967 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 967 "../src/Photo.vala"
		return _tmp5_;
#line 6036 "Photo.c"
	}
}

gboolean
photo_is_editable_source (Photo* self)
{
	gboolean result;
#line 972 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 973 "../src/Photo.vala"
	result = photo_has_editable (self);
#line 973 "../src/Photo.vala"
	return result;
#line 6050 "Photo.c"
}

BackingPhotoRow*
photo_get_master_photo_row (Photo* self)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 976 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6060 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 977 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 977 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6067 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 978 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 978 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 978 "../src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 978 "../src/Photo.vala"
			result = _tmp3_;
#line 6080 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 977 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 977 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6087 "Photo.c"
			}
#line 978 "../src/Photo.vala"
			return result;
#line 6091 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 977 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 977 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6100 "Photo.c"
		}
#line 977 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 977 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 977 "../src/Photo.vala"
		return NULL;
#line 6108 "Photo.c"
	}
}

BackingPhotoRow*
photo_get_editable_photo_row (Photo* self)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 982 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6119 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 983 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 983 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6126 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 985 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 985 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp1_->editable_id)) {
#line 6133 "Photo.c"
				BackingPhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
#line 986 "../src/Photo.vala"
				_tmp2_ = self->priv->editable;
#line 986 "../src/Photo.vala"
				_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 986 "../src/Photo.vala"
				result = _tmp3_;
#line 6142 "Photo.c"
				{
					PhotoRow* _tmp4_;
#line 983 "../src/Photo.vala"
					_tmp4_ = self->row;
#line 983 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6149 "Photo.c"
				}
#line 986 "../src/Photo.vala"
				return result;
#line 6153 "Photo.c"
			} else {
#line 988 "../src/Photo.vala"
				result = NULL;
#line 6157 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 983 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 983 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6164 "Photo.c"
				}
#line 988 "../src/Photo.vala"
				return result;
#line 6168 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 983 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 983 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6178 "Photo.c"
		}
#line 983 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 983 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 983 "../src/Photo.vala"
		return NULL;
#line 6186 "Photo.c"
	}
}

GeeCollection*
photo_get_raw_development_photo_rows (Photo* self)
{
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 993 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6197 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 994 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 994 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6204 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 995 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 995 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 6212 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 995 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 995 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
#line 995 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 995 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 995 "../src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 6226 "Photo.c"
			} else {
#line 995 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 995 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 6232 "Photo.c"
			}
#line 995 "../src/Photo.vala"
			result = _tmp1_;
#line 6236 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 994 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 994 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6243 "Photo.c"
			}
#line 995 "../src/Photo.vala"
			return result;
#line 6247 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 994 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 994 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6256 "Photo.c"
		}
#line 994 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 994 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 994 "../src/Photo.vala"
		return NULL;
#line 6264 "Photo.c"
	}
}

BackingPhotoRow*
photo_get_raw_development_photo_row (Photo* self,
                                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 999 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6276 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1000 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1000 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6283 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1001 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1001 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 6291 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
#line 1001 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1001 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) d));
#line 1001 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1001 "../src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp4_;
#line 6302 "Photo.c"
			} else {
#line 1001 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1001 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 6308 "Photo.c"
			}
#line 1001 "../src/Photo.vala"
			result = _tmp1_;
#line 6312 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 1000 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 1000 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6319 "Photo.c"
			}
#line 1001 "../src/Photo.vala"
			return result;
#line 6323 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 1000 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 1000 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6332 "Photo.c"
		}
#line 1000 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1000 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1000 "../src/Photo.vala"
		return NULL;
#line 6340 "Photo.c"
	}
}

static PhotoFileFormat*
_photo_file_format_dup (PhotoFileFormat* self)
{
	PhotoFileFormat* dup;
#line 1012 "../src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 1012 "../src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 1012 "../src/Photo.vala"
	return dup;
#line 6354 "Photo.c"
}

static gpointer
__photo_file_format_dup0 (gpointer self)
{
#line 1012 "../src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 6362 "Photo.c"
}

PhotoFileFormat*
photo_get_editable_file_format (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat* _tmp4_;
	PhotoFileFormat* result;
#line 1005 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1006 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1006 "../src/Photo.vala"
	reader = _tmp0_;
#line 1007 "../src/Photo.vala"
	_tmp1_ = reader;
#line 1007 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1008 "../src/Photo.vala"
		result = NULL;
#line 1008 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 1008 "../src/Photo.vala"
		return result;
#line 6391 "Photo.c"
	}
#line 1012 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1012 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 1012 "../src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 1012 "../src/Photo.vala"
	result = _tmp4_;
#line 1012 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1012 "../src/Photo.vala"
	return result;
#line 6405 "Photo.c"
}

PhotoFileFormat
photo_get_export_format_for_parameters (Photo* self,
                                        ExportFormatParameters* params)
{
	PhotoFileFormat _result_ = 0;
	ExportFormatParameters _tmp0_;
	PhotoFileFormat result;
#line 1015 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1015 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1016 "../src/Photo.vala"
	_result_ = photo_file_format_get_system_default_format ();
#line 1018 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1018 "../src/Photo.vala"
	switch (_tmp0_.mode) {
#line 1018 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 6427 "Photo.c"
		{
#line 1020 "../src/Photo.vala"
			_result_ = photo_get_master_file_format (self);
#line 1021 "../src/Photo.vala"
			break;
#line 6433 "Photo.c"
		}
#line 1018 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 6437 "Photo.c"
		{
#line 1024 "../src/Photo.vala"
			_result_ = photo_get_best_export_file_format (self);
#line 1025 "../src/Photo.vala"
			break;
#line 6443 "Photo.c"
		}
#line 1018 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 6447 "Photo.c"
		{
			ExportFormatParameters _tmp1_;
#line 1028 "../src/Photo.vala"
			_tmp1_ = *params;
#line 1028 "../src/Photo.vala"
			_result_ = _tmp1_.specified_format;
#line 1029 "../src/Photo.vala"
			break;
#line 6456 "Photo.c"
		}
		default:
		{
#line 1032 "../src/Photo.vala"
			g_error ("Photo.vala:1032: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 6462 "Photo.c"
		}
	}
#line 1035 "../src/Photo.vala"
	result = _result_;
#line 1035 "../src/Photo.vala"
	return result;
#line 6469 "Photo.c"
}

gchar*
photo_get_export_basename_for_parameters (Photo* self,
                                          ExportFormatParameters* params)
{
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_;
	const gchar* _tmp7_;
	gchar* result;
#line 1038 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1038 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1039 "../src/Photo.vala"
	_result_ = NULL;
#line 1041 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1041 "../src/Photo.vala"
	switch (_tmp0_.mode) {
#line 1041 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 6492 "Photo.c"
		{
			GFile* _tmp1_;
			GFile* _tmp2_;
			gchar* _tmp3_;
#line 1043 "../src/Photo.vala"
			_tmp1_ = media_source_get_master_file ((MediaSource*) self);
#line 1043 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1043 "../src/Photo.vala"
			_tmp3_ = g_file_get_basename (_tmp2_);
#line 1043 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1043 "../src/Photo.vala"
			_result_ = _tmp3_;
#line 1043 "../src/Photo.vala"
			_g_object_unref0 (_tmp2_);
#line 1044 "../src/Photo.vala"
			break;
#line 6511 "Photo.c"
		}
#line 1041 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1041 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 6517 "Photo.c"
		{
			ExportFormatParameters _tmp4_;
			PhotoFileFormat _tmp5_;
			gchar* _tmp6_;
#line 1048 "../src/Photo.vala"
			_tmp4_ = *params;
#line 1048 "../src/Photo.vala"
			_tmp5_ = photo_get_export_format_for_parameters (self, &_tmp4_);
#line 1048 "../src/Photo.vala"
			_tmp6_ = photo_get_export_basename (self, &_tmp5_);
#line 1048 "../src/Photo.vala"
			result = _tmp6_;
#line 1048 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1048 "../src/Photo.vala"
			return result;
#line 6534 "Photo.c"
		}
		default:
		{
#line 1051 "../src/Photo.vala"
			g_error ("Photo.vala:1051: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 6540 "Photo.c"
		}
	}
#line 1054 "../src/Photo.vala"
	_tmp7_ = _result_;
#line 1054 "../src/Photo.vala"
	_vala_assert (_tmp7_ != NULL, "result != null");
#line 1055 "../src/Photo.vala"
	result = _result_;
#line 1055 "../src/Photo.vala"
	return result;
#line 6551 "Photo.c"
}

ImportResult
photo_prepare_for_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp11_;
	gint64 mod_time = 0LL;
	GFileInfo* _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	gint64 _tmp18_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	const gchar* _tmp21_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp24_;
	PhotoFileInterrogator* _tmp25_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp32_;
	DetectedPhotoInformation* _tmp33_;
	DetectedPhotoInformation* _tmp34_;
	Orientation orientation = 0;
	gint64 exposure_time = 0LL;
	gchar* title = NULL;
	gchar* _tmp44_;
	gchar* comment = NULL;
	gchar* _tmp45_;
	DetectedPhotoInformation* _tmp46_;
	PhotoMetadata* _tmp47_;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_ = FALSE;
	DetectedPhotoInformation* _tmp66_;
	PhotoRow* _tmp72_;
	PhotoRow* _tmp73_;
	BackingPhotoRow* _tmp74_;
	GFile* _tmp75_;
	gchar* _tmp76_;
	PhotoRow* _tmp77_;
	BackingPhotoRow* _tmp78_;
	DetectedPhotoInformation* _tmp79_;
	Dimensions _tmp80_;
	PhotoRow* _tmp81_;
	BackingPhotoRow* _tmp82_;
	GFileInfo* _tmp83_;
	PhotoRow* _tmp84_;
	BackingPhotoRow* _tmp85_;
	PhotoRow* _tmp86_;
	PhotoRow* _tmp87_;
	PhotoRow* _tmp88_;
	BackingPhotoRow* _tmp89_;
	PhotoRow* _tmp90_;
	ImportID _tmp91_;
	PhotoRow* _tmp92_;
	PhotoRow* _tmp93_;
	PhotoRow* _tmp94_;
	DetectedPhotoInformation* _tmp95_;
	const gchar* _tmp96_;
	gchar* _tmp97_;
	PhotoRow* _tmp98_;
	DetectedPhotoInformation* _tmp99_;
	const gchar* _tmp100_;
	gchar* _tmp101_;
	PhotoRow* _tmp102_;
	DetectedPhotoInformation* _tmp103_;
	const gchar* _tmp104_;
	gchar* _tmp105_;
	PhotoRow* _tmp106_;
	PhotoRow* _tmp107_;
	PhotoRow* _tmp108_;
	BackingPhotoRow* _tmp109_;
	DetectedPhotoInformation* _tmp110_;
	PhotoRow* _tmp111_;
	const gchar* _tmp112_;
	gchar* _tmp113_;
	PhotoRow* _tmp114_;
	const gchar* _tmp115_;
	gchar* _tmp116_;
	Thumbnails* _tmp117_;
	GError* _inner_error0_ = NULL;
	ImportResult result;
#line 1070 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1074 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1074 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1074 "../src/Photo.vala"
	file = _tmp1_;
#line 1076 "../src/Photo.vala"
	info = NULL;
#line 6648 "Photo.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 1078 "../src/Photo.vala"
		_tmp3_ = file;
#line 1078 "../src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1078 "../src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 1078 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6662 "Photo.c"
			goto __catch0_g_error;
		}
#line 1078 "../src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 1078 "../src/Photo.vala"
		_tmp2_ = NULL;
#line 1078 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1078 "../src/Photo.vala"
		info = _tmp5_;
#line 1077 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 6675 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1077 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1081 "../src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1081 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1081 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1081 "../src/Photo.vala"
		return result;
#line 6690 "Photo.c"
	}
	__finally0:
#line 1077 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1077 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1077 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1077 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1077 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1077 "../src/Photo.vala"
		return 0;
#line 6705 "Photo.c"
	}
#line 1084 "../src/Photo.vala"
	_tmp6_ = info;
#line 1084 "../src/Photo.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 1085 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1085 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1085 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1085 "../src/Photo.vala"
		return result;
#line 6719 "Photo.c"
	}
#line 1088 "../src/Photo.vala"
	_tmp7_ = file;
#line 1088 "../src/Photo.vala"
	if (!photo_is_file_image (_tmp7_)) {
#line 6725 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1089 "../src/Photo.vala"
		_tmp8_ = file;
#line 1089 "../src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1089 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1089 "../src/Photo.vala"
		g_message ("Photo.vala:1089: Not importing %s: Not an image file", _tmp10_);
#line 1089 "../src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1091 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1091 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1091 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1091 "../src/Photo.vala"
		return result;
#line 6747 "Photo.c"
	}
#line 1094 "../src/Photo.vala"
	_tmp11_ = file;
#line 1094 "../src/Photo.vala"
	if (!photo_file_format_is_file_supported (_tmp11_)) {
#line 6753 "Photo.c"
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1095 "../src/Photo.vala"
		_tmp12_ = file;
#line 1095 "../src/Photo.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1095 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1095 "../src/Photo.vala"
		g_message ("Photo.vala:1095: Not importing %s: Unsupported extension", _tmp14_);
#line 1095 "../src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1097 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1097 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1097 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1097 "../src/Photo.vala"
		return result;
#line 6775 "Photo.c"
	}
#line 1100 "../src/Photo.vala"
	_tmp15_ = info;
#line 1100 "../src/Photo.vala"
	_tmp16_ = g_file_info_get_modification_date_time (_tmp15_);
#line 1100 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 1100 "../src/Photo.vala"
	_tmp18_ = g_date_time_to_unix (_tmp17_);
#line 1100 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp17_);
#line 1100 "../src/Photo.vala"
	mod_time = _tmp18_;
#line 1103 "../src/Photo.vala"
	_tmp21_ = params->exif_md5;
#line 1103 "../src/Photo.vala"
	if (_tmp21_ != NULL) {
#line 6793 "Photo.c"
		const gchar* _tmp22_;
#line 1103 "../src/Photo.vala"
		_tmp22_ = params->thumbnail_md5;
#line 1103 "../src/Photo.vala"
		_tmp20_ = _tmp22_ != NULL;
#line 6799 "Photo.c"
	} else {
#line 1103 "../src/Photo.vala"
		_tmp20_ = FALSE;
#line 6803 "Photo.c"
	}
#line 1103 "../src/Photo.vala"
	if (_tmp20_) {
#line 6807 "Photo.c"
		const gchar* _tmp23_;
#line 1103 "../src/Photo.vala"
		_tmp23_ = params->full_md5;
#line 1103 "../src/Photo.vala"
		_tmp19_ = _tmp23_ != NULL;
#line 6813 "Photo.c"
	} else {
#line 1103 "../src/Photo.vala"
		_tmp19_ = FALSE;
#line 6817 "Photo.c"
	}
#line 1103 "../src/Photo.vala"
	if (_tmp19_) {
#line 1104 "../src/Photo.vala"
		params->sniffer_options = params->sniffer_options | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 6823 "Photo.c"
	}
#line 1108 "../src/Photo.vala"
	_tmp24_ = file;
#line 1108 "../src/Photo.vala"
	_tmp25_ = photo_file_interrogator_new (_tmp24_, params->sniffer_options);
#line 1108 "../src/Photo.vala"
	interrogator = _tmp25_;
#line 6831 "Photo.c"
	{
		PhotoFileInterrogator* _tmp26_;
#line 1110 "../src/Photo.vala"
		_tmp26_ = interrogator;
#line 1110 "../src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp26_, &_inner_error0_);
#line 1110 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6840 "Photo.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GFile* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 1109 "../src/Photo.vala"
		err = _inner_error0_;
#line 1109 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1112 "../src/Photo.vala"
		_tmp27_ = file;
#line 1112 "../src/Photo.vala"
		_tmp28_ = g_file_get_path (_tmp27_);
#line 1112 "../src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 1112 "../src/Photo.vala"
		_tmp30_ = err;
#line 1112 "../src/Photo.vala"
		_tmp31_ = _tmp30_->message;
#line 1112 "../src/Photo.vala"
		g_warning ("Photo.vala:1112: Unable to interrogate photo file %s: %s", _tmp29_, _tmp31_);
#line 1112 "../src/Photo.vala"
		_g_free0 (_tmp29_);
#line 1114 "../src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1114 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1114 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1114 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1114 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1114 "../src/Photo.vala"
		return result;
#line 6883 "Photo.c"
	}
	__finally1:
#line 1109 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1109 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1109 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1109 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1109 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1109 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1109 "../src/Photo.vala"
		return 0;
#line 6900 "Photo.c"
	}
#line 1118 "../src/Photo.vala"
	_tmp32_ = interrogator;
#line 1118 "../src/Photo.vala"
	_tmp33_ = photo_file_interrogator_get_detected_photo_information (_tmp32_);
#line 1118 "../src/Photo.vala"
	detected = _tmp33_;
#line 1119 "../src/Photo.vala"
	_tmp34_ = detected;
#line 1119 "../src/Photo.vala"
	if (_tmp34_ == NULL) {
#line 1120 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1120 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1120 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1120 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1120 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1120 "../src/Photo.vala"
		return result;
#line 6924 "Photo.c"
	}
#line 1124 "../src/Photo.vala"
	if ((params->sniffer_options & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 6928 "Photo.c"
		DetectedPhotoInformation* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		DetectedPhotoInformation* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		DetectedPhotoInformation* _tmp41_;
		const gchar* _tmp42_;
		gchar* _tmp43_;
#line 1125 "../src/Photo.vala"
		_tmp35_ = detected;
#line 1125 "../src/Photo.vala"
		_tmp36_ = params->exif_md5;
#line 1125 "../src/Photo.vala"
		_tmp37_ = g_strdup (_tmp36_);
#line 1125 "../src/Photo.vala"
		_g_free0 (_tmp35_->exif_md5);
#line 1125 "../src/Photo.vala"
		_tmp35_->exif_md5 = _tmp37_;
#line 1126 "../src/Photo.vala"
		_tmp38_ = detected;
#line 1126 "../src/Photo.vala"
		_tmp39_ = params->thumbnail_md5;
#line 1126 "../src/Photo.vala"
		_tmp40_ = g_strdup (_tmp39_);
#line 1126 "../src/Photo.vala"
		_g_free0 (_tmp38_->thumbnail_md5);
#line 1126 "../src/Photo.vala"
		_tmp38_->thumbnail_md5 = _tmp40_;
#line 1127 "../src/Photo.vala"
		_tmp41_ = detected;
#line 1127 "../src/Photo.vala"
		_tmp42_ = params->full_md5;
#line 1127 "../src/Photo.vala"
		_tmp43_ = g_strdup (_tmp42_);
#line 1127 "../src/Photo.vala"
		_g_free0 (_tmp41_->md5);
#line 1127 "../src/Photo.vala"
		_tmp41_->md5 = _tmp43_;
#line 6968 "Photo.c"
	}
#line 1130 "../src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1131 "../src/Photo.vala"
	exposure_time = (gint64) 0;
#line 1132 "../src/Photo.vala"
	_tmp44_ = g_strdup ("");
#line 1132 "../src/Photo.vala"
	title = _tmp44_;
#line 1133 "../src/Photo.vala"
	_tmp45_ = g_strdup ("");
#line 1133 "../src/Photo.vala"
	comment = _tmp45_;
#line 1140 "../src/Photo.vala"
	_tmp46_ = detected;
#line 1140 "../src/Photo.vala"
	_tmp47_ = _tmp46_->metadata;
#line 1140 "../src/Photo.vala"
	if (_tmp47_ != NULL) {
#line 6988 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp48_;
		PhotoMetadata* _tmp49_;
		MetadataDateTime* _tmp50_;
		MetadataDateTime* _tmp51_;
		DetectedPhotoInformation* _tmp53_;
		PhotoMetadata* _tmp54_;
		DetectedPhotoInformation* _tmp55_;
		PhotoMetadata* _tmp56_;
		gchar* _tmp57_;
		DetectedPhotoInformation* _tmp58_;
		PhotoMetadata* _tmp59_;
		gchar* _tmp60_;
		DetectedPhotoInformation* _tmp61_;
		PhotoMetadata* _tmp62_;
		GeeSet* _tmp63_;
#line 1141 "../src/Photo.vala"
		_tmp48_ = detected;
#line 1141 "../src/Photo.vala"
		_tmp49_ = _tmp48_->metadata;
#line 1141 "../src/Photo.vala"
		_tmp50_ = photo_metadata_get_exposure_date_time (_tmp49_);
#line 1141 "../src/Photo.vala"
		date_time = _tmp50_;
#line 1142 "../src/Photo.vala"
		_tmp51_ = date_time;
#line 1142 "../src/Photo.vala"
		if (_tmp51_ != NULL) {
#line 7017 "Photo.c"
			MetadataDateTime* _tmp52_;
#line 1143 "../src/Photo.vala"
			_tmp52_ = date_time;
#line 1143 "../src/Photo.vala"
			exposure_time = metadata_date_time_get_timestamp (_tmp52_);
#line 7023 "Photo.c"
		}
#line 1146 "../src/Photo.vala"
		_tmp53_ = detected;
#line 1146 "../src/Photo.vala"
		_tmp54_ = _tmp53_->metadata;
#line 1146 "../src/Photo.vala"
		orientation = photo_metadata_get_orientation (_tmp54_);
#line 1147 "../src/Photo.vala"
		_tmp55_ = detected;
#line 1147 "../src/Photo.vala"
		_tmp56_ = _tmp55_->metadata;
#line 1147 "../src/Photo.vala"
		_tmp57_ = media_metadata_get_title ((MediaMetadata*) _tmp56_);
#line 1147 "../src/Photo.vala"
		_g_free0 (title);
#line 1147 "../src/Photo.vala"
		title = _tmp57_;
#line 1148 "../src/Photo.vala"
		_tmp58_ = detected;
#line 1148 "../src/Photo.vala"
		_tmp59_ = _tmp58_->metadata;
#line 1148 "../src/Photo.vala"
		_tmp60_ = media_metadata_get_comment ((MediaMetadata*) _tmp59_);
#line 1148 "../src/Photo.vala"
		_g_free0 (comment);
#line 1148 "../src/Photo.vala"
		comment = _tmp60_;
#line 1149 "../src/Photo.vala"
		_tmp61_ = detected;
#line 1149 "../src/Photo.vala"
		_tmp62_ = _tmp61_->metadata;
#line 1149 "../src/Photo.vala"
		_tmp63_ = photo_metadata_get_keywords (_tmp62_, NULL, NULL, NULL);
#line 1149 "../src/Photo.vala"
		_g_object_unref0 (params->keywords);
#line 1149 "../src/Photo.vala"
		params->keywords = (GeeCollection*) _tmp63_;
#line 1140 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 7063 "Photo.c"
	}
#line 1153 "../src/Photo.vala"
	_tmp66_ = detected;
#line 1153 "../src/Photo.vala"
	if (_tmp66_->colorspace != GDK_COLORSPACE_RGB) {
#line 1153 "../src/Photo.vala"
		_tmp65_ = TRUE;
#line 7071 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp67_;
#line 1154 "../src/Photo.vala"
		_tmp67_ = detected;
#line 1154 "../src/Photo.vala"
		_tmp65_ = _tmp67_->channels < 3;
#line 7078 "Photo.c"
	}
#line 1153 "../src/Photo.vala"
	if (_tmp65_) {
#line 1153 "../src/Photo.vala"
		_tmp64_ = TRUE;
#line 7084 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp68_;
#line 1155 "../src/Photo.vala"
		_tmp68_ = detected;
#line 1155 "../src/Photo.vala"
		_tmp64_ = _tmp68_->bits_per_channel != 8;
#line 7091 "Photo.c"
	}
#line 1153 "../src/Photo.vala"
	if (_tmp64_) {
#line 7095 "Photo.c"
		GFile* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
#line 1156 "../src/Photo.vala"
		_tmp69_ = file;
#line 1156 "../src/Photo.vala"
		_tmp70_ = g_file_get_path (_tmp69_);
#line 1156 "../src/Photo.vala"
		_tmp71_ = _tmp70_;
#line 1156 "../src/Photo.vala"
		g_message ("Photo.vala:1156: Not importing %s: Unsupported color format", _tmp71_);
#line 1156 "../src/Photo.vala"
		_g_free0 (_tmp71_);
#line 1158 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1158 "../src/Photo.vala"
		_g_free0 (comment);
#line 1158 "../src/Photo.vala"
		_g_free0 (title);
#line 1158 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1158 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1158 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1158 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1158 "../src/Photo.vala"
		return result;
#line 7125 "Photo.c"
	}
#line 1164 "../src/Photo.vala"
	_tmp72_ = params->row;
#line 1164 "../src/Photo.vala"
	photo_id_init (&_tmp72_->photo_id, PHOTO_ID_INVALID);
#line 1165 "../src/Photo.vala"
	_tmp73_ = params->row;
#line 1165 "../src/Photo.vala"
	_tmp74_ = _tmp73_->master;
#line 1165 "../src/Photo.vala"
	_tmp75_ = file;
#line 1165 "../src/Photo.vala"
	_tmp76_ = g_file_get_path (_tmp75_);
#line 1165 "../src/Photo.vala"
	_g_free0 (_tmp74_->filepath);
#line 1165 "../src/Photo.vala"
	_tmp74_->filepath = _tmp76_;
#line 1166 "../src/Photo.vala"
	_tmp77_ = params->row;
#line 1166 "../src/Photo.vala"
	_tmp78_ = _tmp77_->master;
#line 1166 "../src/Photo.vala"
	_tmp79_ = detected;
#line 1166 "../src/Photo.vala"
	_tmp80_ = _tmp79_->image_dim;
#line 1166 "../src/Photo.vala"
	_tmp78_->dim = _tmp80_;
#line 1167 "../src/Photo.vala"
	_tmp81_ = params->row;
#line 1167 "../src/Photo.vala"
	_tmp82_ = _tmp81_->master;
#line 1167 "../src/Photo.vala"
	_tmp83_ = info;
#line 1167 "../src/Photo.vala"
	_tmp82_->filesize = g_file_info_get_size (_tmp83_);
#line 1168 "../src/Photo.vala"
	_tmp84_ = params->row;
#line 1168 "../src/Photo.vala"
	_tmp85_ = _tmp84_->master;
#line 1168 "../src/Photo.vala"
	_tmp85_->timestamp = mod_time;
#line 1169 "../src/Photo.vala"
	_tmp86_ = params->row;
#line 1169 "../src/Photo.vala"
	_tmp86_->exposure_time = exposure_time;
#line 1170 "../src/Photo.vala"
	_tmp87_ = params->row;
#line 1170 "../src/Photo.vala"
	_tmp87_->orientation = orientation;
#line 1171 "../src/Photo.vala"
	_tmp88_ = params->row;
#line 1171 "../src/Photo.vala"
	_tmp89_ = _tmp88_->master;
#line 1171 "../src/Photo.vala"
	_tmp89_->original_orientation = orientation;
#line 1172 "../src/Photo.vala"
	_tmp90_ = params->row;
#line 1172 "../src/Photo.vala"
	_tmp91_ = params->import_id;
#line 1172 "../src/Photo.vala"
	_tmp90_->import_id = _tmp91_;
#line 1173 "../src/Photo.vala"
	_tmp92_ = params->row;
#line 1173 "../src/Photo.vala"
	event_id_init (&_tmp92_->event_id, EVENT_ID_INVALID);
#line 1174 "../src/Photo.vala"
	_tmp93_ = params->row;
#line 1174 "../src/Photo.vala"
	_g_object_unref0 (_tmp93_->transformations);
#line 1174 "../src/Photo.vala"
	_tmp93_->transformations = NULL;
#line 1175 "../src/Photo.vala"
	_tmp94_ = params->row;
#line 1175 "../src/Photo.vala"
	_tmp95_ = detected;
#line 1175 "../src/Photo.vala"
	_tmp96_ = _tmp95_->md5;
#line 1175 "../src/Photo.vala"
	_tmp97_ = g_strdup (_tmp96_);
#line 1175 "../src/Photo.vala"
	_g_free0 (_tmp94_->md5);
#line 1175 "../src/Photo.vala"
	_tmp94_->md5 = _tmp97_;
#line 1176 "../src/Photo.vala"
	_tmp98_ = params->row;
#line 1176 "../src/Photo.vala"
	_tmp99_ = detected;
#line 1176 "../src/Photo.vala"
	_tmp100_ = _tmp99_->thumbnail_md5;
#line 1176 "../src/Photo.vala"
	_tmp101_ = g_strdup (_tmp100_);
#line 1176 "../src/Photo.vala"
	_g_free0 (_tmp98_->thumbnail_md5);
#line 1176 "../src/Photo.vala"
	_tmp98_->thumbnail_md5 = _tmp101_;
#line 1177 "../src/Photo.vala"
	_tmp102_ = params->row;
#line 1177 "../src/Photo.vala"
	_tmp103_ = detected;
#line 1177 "../src/Photo.vala"
	_tmp104_ = _tmp103_->exif_md5;
#line 1177 "../src/Photo.vala"
	_tmp105_ = g_strdup (_tmp104_);
#line 1177 "../src/Photo.vala"
	_g_free0 (_tmp102_->exif_md5);
#line 1177 "../src/Photo.vala"
	_tmp102_->exif_md5 = _tmp105_;
#line 1178 "../src/Photo.vala"
	_tmp106_ = params->row;
#line 1178 "../src/Photo.vala"
	_tmp106_->time_created = (gint64) 0;
#line 1179 "../src/Photo.vala"
	_tmp107_ = params->row;
#line 1179 "../src/Photo.vala"
	_tmp107_->flags = (guint64) 0;
#line 1180 "../src/Photo.vala"
	_tmp108_ = params->row;
#line 1180 "../src/Photo.vala"
	_tmp109_ = _tmp108_->master;
#line 1180 "../src/Photo.vala"
	_tmp110_ = detected;
#line 1180 "../src/Photo.vala"
	_tmp109_->file_format = _tmp110_->file_format;
#line 1181 "../src/Photo.vala"
	_tmp111_ = params->row;
#line 1181 "../src/Photo.vala"
	_tmp112_ = title;
#line 1181 "../src/Photo.vala"
	_tmp113_ = g_strdup (_tmp112_);
#line 1181 "../src/Photo.vala"
	_g_free0 (_tmp111_->title);
#line 1181 "../src/Photo.vala"
	_tmp111_->title = _tmp113_;
#line 1182 "../src/Photo.vala"
	_tmp114_ = params->row;
#line 1182 "../src/Photo.vala"
	_tmp115_ = comment;
#line 1182 "../src/Photo.vala"
	_tmp116_ = g_strdup (_tmp115_);
#line 1182 "../src/Photo.vala"
	_g_free0 (_tmp114_->comment);
#line 1182 "../src/Photo.vala"
	_tmp114_->comment = _tmp116_;
#line 1184 "../src/Photo.vala"
	_tmp117_ = params->thumbnails;
#line 1184 "../src/Photo.vala"
	if (_tmp117_ != NULL) {
#line 7273 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoRow* _tmp118_;
		BackingPhotoRow* _tmp119_;
		PhotoRow* _tmp120_;
		BackingPhotoRow* _tmp121_;
		const gchar* _tmp122_;
		PhotoFileReader* _tmp123_;
#line 1185 "../src/Photo.vala"
		_tmp118_ = params->row;
#line 1185 "../src/Photo.vala"
		_tmp119_ = _tmp118_->master;
#line 1185 "../src/Photo.vala"
		_tmp120_ = params->row;
#line 1185 "../src/Photo.vala"
		_tmp121_ = _tmp120_->master;
#line 1185 "../src/Photo.vala"
		_tmp122_ = _tmp121_->filepath;
#line 1185 "../src/Photo.vala"
		_tmp123_ = photo_file_format_create_reader (_tmp119_->file_format, _tmp122_);
#line 1185 "../src/Photo.vala"
		reader = _tmp123_;
#line 7295 "Photo.c"
		{
			Thumbnails* _tmp124_;
			PhotoFileReader* _tmp125_;
			PhotoRow* _tmp126_;
			PhotoRow* _tmp127_;
			BackingPhotoRow* _tmp128_;
			Dimensions _tmp129_;
#line 1188 "../src/Photo.vala"
			_tmp124_ = params->thumbnails;
#line 1188 "../src/Photo.vala"
			_tmp125_ = reader;
#line 1188 "../src/Photo.vala"
			_tmp126_ = params->row;
#line 1188 "../src/Photo.vala"
			_tmp127_ = params->row;
#line 1188 "../src/Photo.vala"
			_tmp128_ = _tmp127_->master;
#line 1188 "../src/Photo.vala"
			_tmp129_ = _tmp128_->dim;
#line 1188 "../src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp124_, _tmp125_, _tmp126_->orientation, &_tmp129_, &_inner_error0_);
#line 1188 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7319 "Photo.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* err = NULL;
			GError* _tmp130_;
#line 1187 "../src/Photo.vala"
			err = _inner_error0_;
#line 1187 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 1191 "../src/Photo.vala"
			_tmp130_ = err;
#line 1191 "../src/Photo.vala"
			result = import_result_convert_error (_tmp130_, IMPORT_RESULT_FILE_ERROR);
#line 1191 "../src/Photo.vala"
			_g_error_free0 (err);
#line 1191 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1191 "../src/Photo.vala"
			_g_free0 (comment);
#line 1191 "../src/Photo.vala"
			_g_free0 (title);
#line 1191 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1191 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1191 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1191 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1191 "../src/Photo.vala"
			return result;
#line 7354 "Photo.c"
		}
		__finally2:
#line 1187 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1187 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1187 "../src/Photo.vala"
			_g_free0 (comment);
#line 1187 "../src/Photo.vala"
			_g_free0 (title);
#line 1187 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1187 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1187 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1187 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1187 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1187 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1187 "../src/Photo.vala"
			return 0;
#line 7379 "Photo.c"
		}
#line 1184 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 7383 "Photo.c"
	}
#line 1198 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1198 "../src/Photo.vala"
	_g_free0 (comment);
#line 1198 "../src/Photo.vala"
	_g_free0 (title);
#line 1198 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1198 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1198 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1198 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1198 "../src/Photo.vala"
	return result;
#line 7401 "Photo.c"
}

void
photo_create_pre_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gchar* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	PhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoRow* _tmp12_;
	PhotoRow* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	PhotoRow* _tmp16_;
	ImportID _tmp17_;
	PhotoRow* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoRow* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoRow* _tmp22_;
	PhotoRow* _tmp23_;
	PhotoRow* _tmp24_;
	PhotoRow* _tmp25_;
	BackingPhotoRow* _tmp26_;
	PhotoRow* _tmp27_;
	PhotoRow* _tmp28_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp29_;
	PhotoFileInterrogator* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 1201 "../src/Photo.vala"
	g_return_if_fail (params != NULL);
#line 1202 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1202 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1202 "../src/Photo.vala"
	file = _tmp1_;
#line 1203 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 1203 "../src/Photo.vala"
	photo_id_init (&_tmp2_->photo_id, PHOTO_ID_INVALID);
#line 1204 "../src/Photo.vala"
	_tmp3_ = params->row;
#line 1204 "../src/Photo.vala"
	_tmp4_ = _tmp3_->master;
#line 1204 "../src/Photo.vala"
	_tmp5_ = g_file_get_path (file);
#line 1204 "../src/Photo.vala"
	_g_free0 (_tmp4_->filepath);
#line 1204 "../src/Photo.vala"
	_tmp4_->filepath = _tmp5_;
#line 1205 "../src/Photo.vala"
	_tmp6_ = params->row;
#line 1205 "../src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1205 "../src/Photo.vala"
	dimensions_init (&_tmp7_->dim, 0, 0);
#line 1206 "../src/Photo.vala"
	_tmp8_ = params->row;
#line 1206 "../src/Photo.vala"
	_tmp9_ = _tmp8_->master;
#line 1206 "../src/Photo.vala"
	_tmp9_->filesize = (gint64) 0;
#line 1207 "../src/Photo.vala"
	_tmp10_ = params->row;
#line 1207 "../src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1207 "../src/Photo.vala"
	_tmp11_->timestamp = (gint64) 0;
#line 1208 "../src/Photo.vala"
	_tmp12_ = params->row;
#line 1208 "../src/Photo.vala"
	_tmp12_->exposure_time = (gint64) 0;
#line 1209 "../src/Photo.vala"
	_tmp13_ = params->row;
#line 1209 "../src/Photo.vala"
	_tmp13_->orientation = ORIENTATION_TOP_LEFT;
#line 1210 "../src/Photo.vala"
	_tmp14_ = params->row;
#line 1210 "../src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 1210 "../src/Photo.vala"
	_tmp15_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1211 "../src/Photo.vala"
	_tmp16_ = params->row;
#line 1211 "../src/Photo.vala"
	_tmp17_ = params->import_id;
#line 1211 "../src/Photo.vala"
	_tmp16_->import_id = _tmp17_;
#line 1212 "../src/Photo.vala"
	_tmp18_ = params->row;
#line 1212 "../src/Photo.vala"
	event_id_init (&_tmp18_->event_id, EVENT_ID_INVALID);
#line 1213 "../src/Photo.vala"
	_tmp19_ = params->row;
#line 1213 "../src/Photo.vala"
	_g_object_unref0 (_tmp19_->transformations);
#line 1213 "../src/Photo.vala"
	_tmp19_->transformations = NULL;
#line 1214 "../src/Photo.vala"
	_tmp20_ = params->row;
#line 1214 "../src/Photo.vala"
	_g_free0 (_tmp20_->md5);
#line 1214 "../src/Photo.vala"
	_tmp20_->md5 = NULL;
#line 1215 "../src/Photo.vala"
	_tmp21_ = params->row;
#line 1215 "../src/Photo.vala"
	_g_free0 (_tmp21_->thumbnail_md5);
#line 1215 "../src/Photo.vala"
	_tmp21_->thumbnail_md5 = NULL;
#line 1216 "../src/Photo.vala"
	_tmp22_ = params->row;
#line 1216 "../src/Photo.vala"
	_g_free0 (_tmp22_->exif_md5);
#line 1216 "../src/Photo.vala"
	_tmp22_->exif_md5 = NULL;
#line 1217 "../src/Photo.vala"
	_tmp23_ = params->row;
#line 1217 "../src/Photo.vala"
	_tmp23_->time_created = (gint64) 0;
#line 1218 "../src/Photo.vala"
	_tmp24_ = params->row;
#line 1218 "../src/Photo.vala"
	_tmp24_->flags = (guint64) 0;
#line 1219 "../src/Photo.vala"
	_tmp25_ = params->row;
#line 1219 "../src/Photo.vala"
	_tmp26_ = _tmp25_->master;
#line 1219 "../src/Photo.vala"
	_tmp26_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1220 "../src/Photo.vala"
	_tmp27_ = params->row;
#line 1220 "../src/Photo.vala"
	_g_free0 (_tmp27_->title);
#line 1220 "../src/Photo.vala"
	_tmp27_->title = NULL;
#line 1221 "../src/Photo.vala"
	_tmp28_ = params->row;
#line 1221 "../src/Photo.vala"
	_g_free0 (_tmp28_->comment);
#line 1221 "../src/Photo.vala"
	_tmp28_->comment = NULL;
#line 1223 "../src/Photo.vala"
	_tmp29_ = params->file;
#line 1223 "../src/Photo.vala"
	_tmp30_ = photo_file_interrogator_new (_tmp29_, params->sniffer_options);
#line 1223 "../src/Photo.vala"
	interrogator = _tmp30_;
#line 7561 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp31_;
		DetectedPhotoInformation* _tmp32_;
#line 1225 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 1225 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7570 "Photo.c"
			goto __catch0_g_error;
		}
#line 1226 "../src/Photo.vala"
		_tmp31_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1226 "../src/Photo.vala"
		detected = _tmp31_;
#line 1227 "../src/Photo.vala"
		_tmp32_ = detected;
#line 1227 "../src/Photo.vala"
		if (_tmp32_ != NULL) {
#line 7581 "Photo.c"
			PhotoRow* _tmp33_;
			BackingPhotoRow* _tmp34_;
			DetectedPhotoInformation* _tmp35_;
			MetadataDateTime* date_time = NULL;
			DetectedPhotoInformation* _tmp36_;
			PhotoMetadata* _tmp37_;
			MetadataDateTime* _tmp38_;
			MetadataDateTime* _tmp39_;
#line 1228 "../src/Photo.vala"
			_tmp33_ = params->row;
#line 1228 "../src/Photo.vala"
			_tmp34_ = _tmp33_->master;
#line 1228 "../src/Photo.vala"
			_tmp35_ = detected;
#line 1228 "../src/Photo.vala"
			_tmp34_->file_format = _tmp35_->file_format;
#line 1229 "../src/Photo.vala"
			_tmp36_ = detected;
#line 1229 "../src/Photo.vala"
			_tmp37_ = _tmp36_->metadata;
#line 1229 "../src/Photo.vala"
			_tmp38_ = photo_metadata_get_exposure_date_time (_tmp37_);
#line 1229 "../src/Photo.vala"
			date_time = _tmp38_;
#line 1230 "../src/Photo.vala"
			_tmp39_ = date_time;
#line 1230 "../src/Photo.vala"
			if (_tmp39_ != NULL) {
#line 7610 "Photo.c"
				PhotoRow* _tmp40_;
				MetadataDateTime* _tmp41_;
#line 1231 "../src/Photo.vala"
				_tmp40_ = params->row;
#line 1231 "../src/Photo.vala"
				_tmp41_ = date_time;
#line 1231 "../src/Photo.vala"
				_tmp40_->exposure_time = metadata_date_time_get_timestamp (_tmp41_);
#line 7619 "Photo.c"
			}
#line 1227 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 7623 "Photo.c"
		}
#line 1224 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 7627 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp42_;
		gchar* _tmp43_;
		GError* _tmp44_;
		const gchar* _tmp45_;
#line 1224 "../src/Photo.vala"
		err = _inner_error0_;
#line 1224 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1235 "../src/Photo.vala"
		_tmp42_ = g_file_get_path (file);
#line 1235 "../src/Photo.vala"
		_tmp43_ = _tmp42_;
#line 1235 "../src/Photo.vala"
		_tmp44_ = err;
#line 1235 "../src/Photo.vala"
		_tmp45_ = _tmp44_->message;
#line 1235 "../src/Photo.vala"
		g_debug ("Photo.vala:1235: Unable to interrogate photo file %s: %s", _tmp43_, _tmp45_);
#line 1235 "../src/Photo.vala"
		_g_free0 (_tmp43_);
#line 1224 "../src/Photo.vala"
		_g_error_free0 (err);
#line 7655 "Photo.c"
	}
	__finally0:
#line 1224 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1224 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1224 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1224 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1224 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1224 "../src/Photo.vala"
		return;
#line 7670 "Photo.c"
	}
#line 1201 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1201 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 7676 "Photo.c"
}

BackingPhotoRow*
photo_query_backing_photo_row (Photo* self,
                               GFile* file,
                               PhotoFileSnifferOptions options,
                               DetectedPhotoInformation** detected,
                               GError** error)
{
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	DetectedPhotoInformation* _tmp12_;
	gint64 mod_time = 0LL;
	GFileInfo* _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	gint64 _tmp18_;
	BackingPhotoRow* _tmp19_;
	gchar* _tmp20_;
	BackingPhotoRow* _tmp21_;
	BackingPhotoRow* _tmp22_;
	GFileInfo* _tmp23_;
	BackingPhotoRow* _tmp24_;
	DetectedPhotoInformation* _tmp25_;
	BackingPhotoRow* _tmp26_;
	DetectedPhotoInformation* _tmp27_;
	Dimensions _tmp28_;
	Orientation _tmp29_ = 0;
	DetectedPhotoInformation* _tmp30_;
	PhotoMetadata* _tmp31_;
	BackingPhotoRow* _tmp34_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 1239 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1239 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1241 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1241 "../src/Photo.vala"
	_vala_detected = NULL;
#line 1243 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1243 "../src/Photo.vala"
	backing = _tmp0_;
#line 1245 "../src/Photo.vala"
	info = NULL;
#line 7731 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 1247 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1247 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 1247 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7742 "Photo.c"
			goto __catch0_g_error;
		}
#line 1247 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 1247 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 1247 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1247 "../src/Photo.vala"
		info = _tmp3_;
#line 1246 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 7755 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 1246 "../src/Photo.vala"
		err = _inner_error0_;
#line 1246 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1250 "../src/Photo.vala"
		_tmp4_ = g_file_get_path (file);
#line 1250 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1250 "../src/Photo.vala"
		_tmp6_ = err;
#line 1250 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 1250 "../src/Photo.vala"
		g_critical ("Photo.vala:1250: Unable to read file information for %s: %s", _tmp5_, _tmp7_);
#line 1250 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 1252 "../src/Photo.vala"
		result = NULL;
#line 1252 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1252 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1252 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1252 "../src/Photo.vala"
		if (detected) {
#line 1252 "../src/Photo.vala"
			*detected = _vala_detected;
#line 7793 "Photo.c"
		} else {
#line 1252 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 7797 "Photo.c"
		}
#line 1252 "../src/Photo.vala"
		return result;
#line 7801 "Photo.c"
	}
	__finally0:
#line 1246 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1246 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1246 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1246 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1246 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1246 "../src/Photo.vala"
		return NULL;
#line 7816 "Photo.c"
	}
#line 1256 "../src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, options);
#line 1256 "../src/Photo.vala"
	interrogator = _tmp8_;
#line 1257 "../src/Photo.vala"
	_tmp9_ = interrogator;
#line 1257 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error0_);
#line 1257 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1257 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1257 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1257 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1257 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1257 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1257 "../src/Photo.vala"
		return NULL;
#line 7840 "Photo.c"
	}
#line 1258 "../src/Photo.vala"
	_tmp10_ = interrogator;
#line 1258 "../src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 1258 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1258 "../src/Photo.vala"
	_vala_detected = _tmp11_;
#line 1259 "../src/Photo.vala"
	_tmp12_ = _vala_detected;
#line 1259 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 7854 "Photo.c"
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1260 "../src/Photo.vala"
		_tmp13_ = data_object_to_string ((DataObject*) self);
#line 1260 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1260 "../src/Photo.vala"
		g_critical ("Photo.vala:1260: Photo update: %s no longer a recognized image", _tmp14_);
#line 1260 "../src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1262 "../src/Photo.vala"
		result = NULL;
#line 1262 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1262 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1262 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1262 "../src/Photo.vala"
		if (detected) {
#line 1262 "../src/Photo.vala"
			*detected = _vala_detected;
#line 7877 "Photo.c"
		} else {
#line 1262 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 7881 "Photo.c"
		}
#line 1262 "../src/Photo.vala"
		return result;
#line 7885 "Photo.c"
	}
#line 1265 "../src/Photo.vala"
	_tmp15_ = info;
#line 1265 "../src/Photo.vala"
	_tmp16_ = g_file_info_get_modification_date_time (_tmp15_);
#line 1265 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 1265 "../src/Photo.vala"
	_tmp18_ = g_date_time_to_unix (_tmp17_);
#line 1265 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp17_);
#line 1265 "../src/Photo.vala"
	mod_time = _tmp18_;
#line 1267 "../src/Photo.vala"
	_tmp19_ = backing;
#line 1267 "../src/Photo.vala"
	_tmp20_ = g_file_get_path (file);
#line 1267 "../src/Photo.vala"
	_g_free0 (_tmp19_->filepath);
#line 1267 "../src/Photo.vala"
	_tmp19_->filepath = _tmp20_;
#line 1268 "../src/Photo.vala"
	_tmp21_ = backing;
#line 1268 "../src/Photo.vala"
	_tmp21_->timestamp = mod_time;
#line 1269 "../src/Photo.vala"
	_tmp22_ = backing;
#line 1269 "../src/Photo.vala"
	_tmp23_ = info;
#line 1269 "../src/Photo.vala"
	_tmp22_->filesize = g_file_info_get_size (_tmp23_);
#line 1270 "../src/Photo.vala"
	_tmp24_ = backing;
#line 1270 "../src/Photo.vala"
	_tmp25_ = _vala_detected;
#line 1270 "../src/Photo.vala"
	_tmp24_->file_format = _tmp25_->file_format;
#line 1271 "../src/Photo.vala"
	_tmp26_ = backing;
#line 1271 "../src/Photo.vala"
	_tmp27_ = _vala_detected;
#line 1271 "../src/Photo.vala"
	_tmp28_ = _tmp27_->image_dim;
#line 1271 "../src/Photo.vala"
	_tmp26_->dim = _tmp28_;
#line 1272 "../src/Photo.vala"
	_tmp30_ = _vala_detected;
#line 1272 "../src/Photo.vala"
	_tmp31_ = _tmp30_->metadata;
#line 1272 "../src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 7937 "Photo.c"
		DetectedPhotoInformation* _tmp32_;
		PhotoMetadata* _tmp33_;
#line 1273 "../src/Photo.vala"
		_tmp32_ = _vala_detected;
#line 1273 "../src/Photo.vala"
		_tmp33_ = _tmp32_->metadata;
#line 1273 "../src/Photo.vala"
		_tmp29_ = photo_metadata_get_orientation (_tmp33_);
#line 7946 "Photo.c"
	} else {
#line 1273 "../src/Photo.vala"
		_tmp29_ = ORIENTATION_TOP_LEFT;
#line 7950 "Photo.c"
	}
#line 1272 "../src/Photo.vala"
	_tmp34_ = backing;
#line 1272 "../src/Photo.vala"
	_tmp34_->original_orientation = _tmp29_;
#line 1275 "../src/Photo.vala"
	result = backing;
#line 1275 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1275 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1275 "../src/Photo.vala"
	if (detected) {
#line 1275 "../src/Photo.vala"
		*detected = _vala_detected;
#line 7966 "Photo.c"
	} else {
#line 1275 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 7970 "Photo.c"
	}
#line 1275 "../src/Photo.vala"
	return result;
#line 7974 "Photo.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1371 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1371 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1371 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7989 "Photo.c"
	}
#line 1371 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1371 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 7995 "Photo.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1375 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1375 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1375 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8010 "Photo.c"
	}
#line 1375 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1375 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8016 "Photo.c"
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1382 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1382 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1382 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8031 "Photo.c"
	}
#line 1382 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1382 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8037 "Photo.c"
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1386 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1386 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1386 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8052 "Photo.c"
	}
#line 1386 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1386 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8058 "Photo.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1390 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1390 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1390 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8073 "Photo.c"
	}
#line 1390 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1390 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8079 "Photo.c"
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 1401 "../src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 8087 "Photo.c"
}

gboolean
photo_prepare_for_reimport_master (Photo* self,
                                   PhotoReimportMasterState** reimport_state,
                                   GError** error)
{
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp20_;
	gchar** list = NULL;
	gchar** _tmp26_;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp27_;
	const gchar* _tmp28_;
	DetectedPhotoInformation* _tmp29_;
	const gchar* _tmp30_;
	PhotoRow* _tmp32_;
	BackingPhotoRow* _tmp33_;
	BackingPhotoRow* _tmp34_;
	DetectedPhotoInformation* _tmp39_;
	PhotoMetadata* _tmp40_;
	PhotoRow* _tmp65_;
	BackingPhotoRow* _tmp66_;
	BackingPhotoRow* _tmp67_;
	PhotoRow* _tmp68_;
	DetectedPhotoInformation* _tmp69_;
	const gchar* _tmp70_;
	gchar* _tmp71_;
	PhotoRow* _tmp72_;
	DetectedPhotoInformation* _tmp73_;
	const gchar* _tmp74_;
	gchar* _tmp75_;
	PhotoRow* _tmp76_;
	DetectedPhotoInformation* _tmp77_;
	const gchar* _tmp78_;
	gchar* _tmp79_;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp80_;
	PhotoMetadata* _tmp81_;
	PhotoRow* _tmp103_;
	PhotoMetadata* _tmp104_;
	gchar** _tmp105_;
	gint _tmp105__length1;
	PhotoReimportMasterStateImpl* _tmp106_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1339 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1340 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1340 "../src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1342 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1342 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1342 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1342 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1342 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1342 "../src/Photo.vala"
	file = _tmp3_;
#line 1345 "../src/Photo.vala"
	_tmp4_ = file;
#line 1345 "../src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error0_);
#line 1345 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1345 "../src/Photo.vala"
	detected = _tmp5_;
#line 1345 "../src/Photo.vala"
	backing = _tmp6_;
#line 1345 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8180 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1345 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1345 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1345 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1345 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1345 "../src/Photo.vala"
		return _tmp7_;
#line 8192 "Photo.c"
	}
#line 1347 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1347 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 8198 "Photo.c"
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1348 "../src/Photo.vala"
		_tmp9_ = file;
#line 1348 "../src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 1348 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 1348 "../src/Photo.vala"
		g_warning ("Photo.vala:1348: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 1348 "../src/Photo.vala"
		_g_free0 (_tmp11_);
#line 1349 "../src/Photo.vala"
		result = FALSE;
#line 1349 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1349 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1349 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1349 "../src/Photo.vala"
		if (reimport_state) {
#line 1349 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 8224 "Photo.c"
		} else {
#line 1349 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 8228 "Photo.c"
		}
#line 1349 "../src/Photo.vala"
		return result;
#line 8232 "Photo.c"
	}
#line 1353 "../src/Photo.vala"
	_tmp14_ = detected;
#line 1353 "../src/Photo.vala"
	if (_tmp14_->colorspace != GDK_COLORSPACE_RGB) {
#line 1353 "../src/Photo.vala"
		_tmp13_ = TRUE;
#line 8240 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp15_;
#line 1354 "../src/Photo.vala"
		_tmp15_ = detected;
#line 1354 "../src/Photo.vala"
		_tmp13_ = _tmp15_->channels < 3;
#line 8247 "Photo.c"
	}
#line 1353 "../src/Photo.vala"
	if (_tmp13_) {
#line 1353 "../src/Photo.vala"
		_tmp12_ = TRUE;
#line 8253 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_;
#line 1355 "../src/Photo.vala"
		_tmp16_ = detected;
#line 1355 "../src/Photo.vala"
		_tmp12_ = _tmp16_->bits_per_channel != 8;
#line 8260 "Photo.c"
	}
#line 1353 "../src/Photo.vala"
	if (_tmp12_) {
#line 8264 "Photo.c"
		GFile* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 1356 "../src/Photo.vala"
		_tmp17_ = file;
#line 1356 "../src/Photo.vala"
		_tmp18_ = g_file_get_path (_tmp17_);
#line 1356 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 1356 "../src/Photo.vala"
		g_warning ("Photo.vala:1356: Not re-importing %s: Unsupported color format", _tmp19_);
#line 1356 "../src/Photo.vala"
		_g_free0 (_tmp19_);
#line 1358 "../src/Photo.vala"
		result = FALSE;
#line 1358 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1358 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1358 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1358 "../src/Photo.vala"
		if (reimport_state) {
#line 1358 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 8290 "Photo.c"
		} else {
#line 1358 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 8294 "Photo.c"
		}
#line 1358 "../src/Photo.vala"
		return result;
#line 8298 "Photo.c"
	}
#line 1362 "../src/Photo.vala"
	_tmp20_ = photo_row_new ();
#line 1362 "../src/Photo.vala"
	updated_row = _tmp20_;
#line 8304 "Photo.c"
	{
		PhotoRow* _tmp21_;
#line 1363 "../src/Photo.vala"
		_tmp21_ = self->row;
#line 1363 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8311 "Photo.c"
		{
			PhotoRow* _tmp22_;
			PhotoRow* _tmp23_;
#line 1364 "../src/Photo.vala"
			_tmp22_ = self->row;
#line 1364 "../src/Photo.vala"
			_tmp23_ = _photo_row_ref0 (_tmp22_);
#line 1364 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1364 "../src/Photo.vala"
			updated_row = _tmp23_;
#line 8323 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp24_;
#line 1363 "../src/Photo.vala"
			_tmp24_ = self->row;
#line 1363 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8332 "Photo.c"
		}
#line 1363 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8336 "Photo.c"
			gboolean _tmp25_ = FALSE;
#line 1363 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1363 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1363 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1363 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1363 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1363 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1363 "../src/Photo.vala"
			return _tmp25_;
#line 8352 "Photo.c"
		}
	}
#line 1368 "../src/Photo.vala"
	_tmp26_ = g_new0 (gchar*, 0 + 1);
#line 1368 "../src/Photo.vala"
	list = _tmp26_;
#line 1368 "../src/Photo.vala"
	list_length1 = 0;
#line 1368 "../src/Photo.vala"
	_list_size_ = list_length1;
#line 1370 "../src/Photo.vala"
	_tmp27_ = updated_row;
#line 1370 "../src/Photo.vala"
	_tmp28_ = _tmp27_->md5;
#line 1370 "../src/Photo.vala"
	_tmp29_ = detected;
#line 1370 "../src/Photo.vala"
	_tmp30_ = _tmp29_->md5;
#line 1370 "../src/Photo.vala"
	if (g_strcmp0 (_tmp28_, _tmp30_) != 0) {
#line 8373 "Photo.c"
		gchar* _tmp31_;
#line 1371 "../src/Photo.vala"
		_tmp31_ = g_strdup ("metadata:md5");
#line 1371 "../src/Photo.vala"
		_vala_array_add10 (&list, &list_length1, &_list_size_, _tmp31_);
#line 8379 "Photo.c"
	}
#line 1374 "../src/Photo.vala"
	_tmp32_ = updated_row;
#line 1374 "../src/Photo.vala"
	_tmp33_ = _tmp32_->master;
#line 1374 "../src/Photo.vala"
	_tmp34_ = backing;
#line 1374 "../src/Photo.vala"
	if (_tmp33_->original_orientation != _tmp34_->original_orientation) {
#line 8389 "Photo.c"
		gchar* _tmp35_;
		PhotoRow* _tmp36_;
		BackingPhotoRow* _tmp37_;
		BackingPhotoRow* _tmp38_;
#line 1375 "../src/Photo.vala"
		_tmp35_ = g_strdup ("image:orientation");
#line 1375 "../src/Photo.vala"
		_vala_array_add11 (&list, &list_length1, &_list_size_, _tmp35_);
#line 1376 "../src/Photo.vala"
		_tmp36_ = updated_row;
#line 1376 "../src/Photo.vala"
		_tmp37_ = _tmp36_->master;
#line 1376 "../src/Photo.vala"
		_tmp38_ = backing;
#line 1376 "../src/Photo.vala"
		_tmp37_->original_orientation = _tmp38_->original_orientation;
#line 8406 "Photo.c"
	}
#line 1379 "../src/Photo.vala"
	_tmp39_ = detected;
#line 1379 "../src/Photo.vala"
	_tmp40_ = _tmp39_->metadata;
#line 1379 "../src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 8414 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp41_;
		PhotoMetadata* _tmp42_;
		MetadataDateTime* _tmp43_;
		gboolean _tmp44_ = FALSE;
		MetadataDateTime* _tmp45_;
		PhotoRow* _tmp49_;
		const gchar* _tmp50_;
		DetectedPhotoInformation* _tmp51_;
		PhotoMetadata* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gboolean _tmp55_;
		PhotoRow* _tmp57_;
		const gchar* _tmp58_;
		DetectedPhotoInformation* _tmp59_;
		PhotoMetadata* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gboolean _tmp63_;
#line 1380 "../src/Photo.vala"
		_tmp41_ = detected;
#line 1380 "../src/Photo.vala"
		_tmp42_ = _tmp41_->metadata;
#line 1380 "../src/Photo.vala"
		_tmp43_ = photo_metadata_get_exposure_date_time (_tmp42_);
#line 1380 "../src/Photo.vala"
		date_time = _tmp43_;
#line 1381 "../src/Photo.vala"
		_tmp45_ = date_time;
#line 1381 "../src/Photo.vala"
		if (_tmp45_ != NULL) {
#line 8447 "Photo.c"
			PhotoRow* _tmp46_;
			MetadataDateTime* _tmp47_;
#line 1381 "../src/Photo.vala"
			_tmp46_ = updated_row;
#line 1381 "../src/Photo.vala"
			_tmp47_ = date_time;
#line 1381 "../src/Photo.vala"
			_tmp44_ = _tmp46_->exposure_time != metadata_date_time_get_timestamp (_tmp47_);
#line 8456 "Photo.c"
		} else {
#line 1381 "../src/Photo.vala"
			_tmp44_ = FALSE;
#line 8460 "Photo.c"
		}
#line 1381 "../src/Photo.vala"
		if (_tmp44_) {
#line 8464 "Photo.c"
			gchar* _tmp48_;
#line 1382 "../src/Photo.vala"
			_tmp48_ = g_strdup ("metadata:exposure-time");
#line 1382 "../src/Photo.vala"
			_vala_array_add12 (&list, &list_length1, &_list_size_, _tmp48_);
#line 8470 "Photo.c"
		}
#line 1385 "../src/Photo.vala"
		_tmp49_ = updated_row;
#line 1385 "../src/Photo.vala"
		_tmp50_ = _tmp49_->title;
#line 1385 "../src/Photo.vala"
		_tmp51_ = detected;
#line 1385 "../src/Photo.vala"
		_tmp52_ = _tmp51_->metadata;
#line 1385 "../src/Photo.vala"
		_tmp53_ = media_metadata_get_title ((MediaMetadata*) _tmp52_);
#line 1385 "../src/Photo.vala"
		_tmp54_ = _tmp53_;
#line 1385 "../src/Photo.vala"
		_tmp55_ = g_strcmp0 (_tmp50_, _tmp54_) != 0;
#line 1385 "../src/Photo.vala"
		_g_free0 (_tmp54_);
#line 1385 "../src/Photo.vala"
		if (_tmp55_) {
#line 8490 "Photo.c"
			gchar* _tmp56_;
#line 1386 "../src/Photo.vala"
			_tmp56_ = g_strdup ("metadata:name");
#line 1386 "../src/Photo.vala"
			_vala_array_add13 (&list, &list_length1, &_list_size_, _tmp56_);
#line 8496 "Photo.c"
		}
#line 1389 "../src/Photo.vala"
		_tmp57_ = updated_row;
#line 1389 "../src/Photo.vala"
		_tmp58_ = _tmp57_->comment;
#line 1389 "../src/Photo.vala"
		_tmp59_ = detected;
#line 1389 "../src/Photo.vala"
		_tmp60_ = _tmp59_->metadata;
#line 1389 "../src/Photo.vala"
		_tmp61_ = media_metadata_get_comment ((MediaMetadata*) _tmp60_);
#line 1389 "../src/Photo.vala"
		_tmp62_ = _tmp61_;
#line 1389 "../src/Photo.vala"
		_tmp63_ = g_strcmp0 (_tmp58_, _tmp62_) != 0;
#line 1389 "../src/Photo.vala"
		_g_free0 (_tmp62_);
#line 1389 "../src/Photo.vala"
		if (_tmp63_) {
#line 8516 "Photo.c"
			gchar* _tmp64_;
#line 1390 "../src/Photo.vala"
			_tmp64_ = g_strdup ("metadata:comment");
#line 1390 "../src/Photo.vala"
			_vala_array_add14 (&list, &list_length1, &_list_size_, _tmp64_);
#line 8522 "Photo.c"
		}
#line 1379 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 8526 "Photo.c"
	}
#line 1394 "../src/Photo.vala"
	_tmp65_ = updated_row;
#line 1394 "../src/Photo.vala"
	_tmp66_ = backing;
#line 1394 "../src/Photo.vala"
	_tmp67_ = _backing_photo_row_ref0 (_tmp66_);
#line 1394 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp65_->master);
#line 1394 "../src/Photo.vala"
	_tmp65_->master = _tmp67_;
#line 1395 "../src/Photo.vala"
	_tmp68_ = updated_row;
#line 1395 "../src/Photo.vala"
	_tmp69_ = detected;
#line 1395 "../src/Photo.vala"
	_tmp70_ = _tmp69_->md5;
#line 1395 "../src/Photo.vala"
	_tmp71_ = g_strdup (_tmp70_);
#line 1395 "../src/Photo.vala"
	_g_free0 (_tmp68_->md5);
#line 1395 "../src/Photo.vala"
	_tmp68_->md5 = _tmp71_;
#line 1396 "../src/Photo.vala"
	_tmp72_ = updated_row;
#line 1396 "../src/Photo.vala"
	_tmp73_ = detected;
#line 1396 "../src/Photo.vala"
	_tmp74_ = _tmp73_->exif_md5;
#line 1396 "../src/Photo.vala"
	_tmp75_ = g_strdup (_tmp74_);
#line 1396 "../src/Photo.vala"
	_g_free0 (_tmp72_->exif_md5);
#line 1396 "../src/Photo.vala"
	_tmp72_->exif_md5 = _tmp75_;
#line 1397 "../src/Photo.vala"
	_tmp76_ = updated_row;
#line 1397 "../src/Photo.vala"
	_tmp77_ = detected;
#line 1397 "../src/Photo.vala"
	_tmp78_ = _tmp77_->thumbnail_md5;
#line 1397 "../src/Photo.vala"
	_tmp79_ = g_strdup (_tmp78_);
#line 1397 "../src/Photo.vala"
	_g_free0 (_tmp76_->thumbnail_md5);
#line 1397 "../src/Photo.vala"
	_tmp76_->thumbnail_md5 = _tmp79_;
#line 1399 "../src/Photo.vala"
	metadata = NULL;
#line 1400 "../src/Photo.vala"
	_tmp80_ = detected;
#line 1400 "../src/Photo.vala"
	_tmp81_ = _tmp80_->metadata;
#line 1400 "../src/Photo.vala"
	if (_tmp81_ != NULL) {
#line 8582 "Photo.c"
		DetectedPhotoInformation* _tmp82_;
		PhotoMetadata* _tmp83_;
		PhotoMetadata* _tmp84_;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp85_;
		PhotoMetadata* _tmp86_;
		MetadataDateTime* _tmp87_;
		MetadataDateTime* _tmp88_;
		PhotoRow* _tmp91_;
		DetectedPhotoInformation* _tmp92_;
		PhotoMetadata* _tmp93_;
		gchar* _tmp94_;
		PhotoRow* _tmp95_;
		DetectedPhotoInformation* _tmp96_;
		PhotoMetadata* _tmp97_;
		gchar* _tmp98_;
		PhotoRow* _tmp99_;
		DetectedPhotoInformation* _tmp100_;
		PhotoMetadata* _tmp101_;
		gchar* _tmp102_;
#line 1401 "../src/Photo.vala"
		_tmp82_ = detected;
#line 1401 "../src/Photo.vala"
		_tmp83_ = _tmp82_->metadata;
#line 1401 "../src/Photo.vala"
		_tmp84_ = _media_metadata_ref0 (_tmp83_);
#line 1401 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1401 "../src/Photo.vala"
		metadata = _tmp84_;
#line 1403 "../src/Photo.vala"
		_tmp85_ = detected;
#line 1403 "../src/Photo.vala"
		_tmp86_ = _tmp85_->metadata;
#line 1403 "../src/Photo.vala"
		_tmp87_ = photo_metadata_get_exposure_date_time (_tmp86_);
#line 1403 "../src/Photo.vala"
		date_time = _tmp87_;
#line 1404 "../src/Photo.vala"
		_tmp88_ = date_time;
#line 1404 "../src/Photo.vala"
		if (_tmp88_ != NULL) {
#line 8625 "Photo.c"
			PhotoRow* _tmp89_;
			MetadataDateTime* _tmp90_;
#line 1405 "../src/Photo.vala"
			_tmp89_ = updated_row;
#line 1405 "../src/Photo.vala"
			_tmp90_ = date_time;
#line 1405 "../src/Photo.vala"
			_tmp89_->exposure_time = metadata_date_time_get_timestamp (_tmp90_);
#line 8634 "Photo.c"
		}
#line 1408 "../src/Photo.vala"
		_tmp91_ = updated_row;
#line 1408 "../src/Photo.vala"
		_tmp92_ = detected;
#line 1408 "../src/Photo.vala"
		_tmp93_ = _tmp92_->metadata;
#line 1408 "../src/Photo.vala"
		_tmp94_ = media_metadata_get_title ((MediaMetadata*) _tmp93_);
#line 1408 "../src/Photo.vala"
		_g_free0 (_tmp91_->title);
#line 1408 "../src/Photo.vala"
		_tmp91_->title = _tmp94_;
#line 1409 "../src/Photo.vala"
		_tmp95_ = updated_row;
#line 1409 "../src/Photo.vala"
		_tmp96_ = detected;
#line 1409 "../src/Photo.vala"
		_tmp97_ = _tmp96_->metadata;
#line 1409 "../src/Photo.vala"
		_tmp98_ = media_metadata_get_comment ((MediaMetadata*) _tmp97_);
#line 1409 "../src/Photo.vala"
		_g_free0 (_tmp95_->comment);
#line 1409 "../src/Photo.vala"
		_tmp95_->comment = _tmp98_;
#line 1410 "../src/Photo.vala"
		_tmp99_ = updated_row;
#line 1410 "../src/Photo.vala"
		_tmp100_ = detected;
#line 1410 "../src/Photo.vala"
		_tmp101_ = _tmp100_->metadata;
#line 1410 "../src/Photo.vala"
		_tmp102_ = media_metadata_get_comment ((MediaMetadata*) _tmp101_);
#line 1410 "../src/Photo.vala"
		_g_free0 (_tmp99_->comment);
#line 1410 "../src/Photo.vala"
		_tmp99_->comment = _tmp102_;
#line 1400 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 8674 "Photo.c"
	}
#line 1413 "../src/Photo.vala"
	_tmp103_ = updated_row;
#line 1413 "../src/Photo.vala"
	_tmp104_ = metadata;
#line 1413 "../src/Photo.vala"
	_tmp105_ = list;
#line 1413 "../src/Photo.vala"
	_tmp105__length1 = list_length1;
#line 1413 "../src/Photo.vala"
	_tmp106_ = photo_reimport_master_state_impl_new (_tmp103_, _tmp104_, _tmp105_, _tmp105__length1);
#line 1413 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1413 "../src/Photo.vala"
	_vala_reimport_state = (PhotoReimportMasterState*) _tmp106_;
#line 1415 "../src/Photo.vala"
	result = TRUE;
#line 1415 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1415 "../src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1415 "../src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1415 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1415 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1415 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1415 "../src/Photo.vala"
	if (reimport_state) {
#line 1415 "../src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 8708 "Photo.c"
	} else {
#line 1415 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 8712 "Photo.c"
	}
#line 1415 "../src/Photo.vala"
	return result;
#line 8716 "Photo.c"
}

static void
photo_real_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata)
{
#line 1418 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1418 "../src/Photo.vala"
	return;
#line 8727 "Photo.c"
}

void
photo_apply_user_metadata_for_reimport (Photo* self,
                                        PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 1418 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1418 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 1418 "../src/Photo.vala"
	if (_klass_->apply_user_metadata_for_reimport) {
#line 1418 "../src/Photo.vala"
		_klass_->apply_user_metadata_for_reimport (self, metadata);
#line 8743 "Photo.c"
	}
}

static gpointer
_photo_reimport_master_state_ref0 (gpointer self)
{
#line 1422 "../src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 8752 "Photo.c"
}

static void
_vala_array_add15 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1442 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1442 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1442 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8767 "Photo.c"
	}
#line 1442 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1442 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8773 "Photo.c"
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1444 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1444 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1444 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8788 "Photo.c"
	}
#line 1444 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1444 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8794 "Photo.c"
}

void
photo_finish_reimport_master (Photo* self,
                              PhotoReimportMasterState* state,
                              GError** error)
{
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterStateImpl* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoMetadata* _tmp18_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	PhotoMetadata* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 1421 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1421 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1422 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1422 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 1424 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 1424 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1424 "../src/Photo.vala"
	_tmp3_ = reimport_state->row;
#line 1424 "../src/Photo.vala"
	photo_table_reimport (_tmp2_, _tmp3_, &_inner_error0_);
#line 1424 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 1424 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1424 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1424 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1424 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1424 "../src/Photo.vala"
			return;
#line 8840 "Photo.c"
		} else {
#line 1424 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1424 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1424 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1424 "../src/Photo.vala"
			return;
#line 8850 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp4_;
#line 1426 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 1426 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8859 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp5_;
			BackingPhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			PhotoRow* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 1428 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1428 "../src/Photo.vala"
			_tmp6_ = _tmp5_->master;
#line 1428 "../src/Photo.vala"
			_tmp7_ = _backing_photo_row_ref0 (_tmp6_);
#line 1428 "../src/Photo.vala"
			original_master = _tmp7_;
#line 1429 "../src/Photo.vala"
			_tmp8_ = reimport_state->row;
#line 1429 "../src/Photo.vala"
			_tmp9_ = _photo_row_ref0 (_tmp8_);
#line 1429 "../src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1429 "../src/Photo.vala"
			self->row = _tmp9_;
#line 1430 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 1430 "../src/Photo.vala"
			_tmp11_ = original_master;
#line 1430 "../src/Photo.vala"
			_tmp12_ = _backing_photo_row_ref0 (_tmp11_);
#line 1430 "../src/Photo.vala"
			_backing_photo_row_unref0 (_tmp10_->master);
#line 1430 "../src/Photo.vala"
			_tmp10_->master = _tmp12_;
#line 1431 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 1431 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1431 "../src/Photo.vala"
			_tmp15_ = reimport_state->row;
#line 1431 "../src/Photo.vala"
			_tmp16_ = _tmp15_->master;
#line 1431 "../src/Photo.vala"
			backing_photo_row_copy_from (_tmp14_, _tmp16_);
#line 1432 "../src/Photo.vala"
			if (!reimport_state->metadata_only) {
#line 1433 "../src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 8914 "Photo.c"
			}
#line 1426 "../src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 8918 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp17_;
#line 1426 "../src/Photo.vala"
			_tmp17_ = self->row;
#line 1426 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8927 "Photo.c"
		}
#line 1426 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1426 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1426 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1426 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1426 "../src/Photo.vala"
				return;
#line 8939 "Photo.c"
			} else {
#line 1426 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1426 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1426 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1426 "../src/Photo.vala"
				return;
#line 8949 "Photo.c"
			}
		}
	}
#line 1437 "../src/Photo.vala"
	_tmp18_ = reimport_state->metadata;
#line 1437 "../src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 8957 "Photo.c"
		PhotoMetadata* _tmp19_;
#line 1438 "../src/Photo.vala"
		_tmp19_ = reimport_state->metadata;
#line 1438 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp19_);
#line 8963 "Photo.c"
	}
#line 1441 "../src/Photo.vala"
	if (!reimport_state->metadata_only) {
#line 8967 "Photo.c"
		gchar* _tmp20_;
#line 1442 "../src/Photo.vala"
		_tmp20_ = g_strdup ("image:master");
#line 1442 "../src/Photo.vala"
		_vala_array_add15 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp20_);
#line 1443 "../src/Photo.vala"
		if (photo_is_master_baseline (self)) {
#line 8975 "Photo.c"
			gchar* _tmp21_;
#line 1444 "../src/Photo.vala"
			_tmp21_ = g_strdup ("image:baseline");
#line 1444 "../src/Photo.vala"
			_vala_array_add16 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp21_);
#line 8981 "Photo.c"
		}
	}
#line 1448 "../src/Photo.vala"
	_tmp22_ = reimport_state->alterations;
#line 1448 "../src/Photo.vala"
	_tmp22__length1 = reimport_state->alterations_length1;
#line 1448 "../src/Photo.vala"
	if (_tmp22__length1 > 0) {
#line 8990 "Photo.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 1449 "../src/Photo.vala"
		_tmp23_ = reimport_state->alterations;
#line 1449 "../src/Photo.vala"
		_tmp23__length1 = reimport_state->alterations_length1;
#line 1449 "../src/Photo.vala"
		_tmp24_ = alteration_new_from_array (_tmp23_, _tmp23__length1);
#line 1449 "../src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1449 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp25_);
#line 1449 "../src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 9007 "Photo.c"
	}
#line 1452 "../src/Photo.vala"
	_tmp26_ = reimport_state->metadata;
#line 1452 "../src/Photo.vala"
	photo_notify_master_reimported (self, _tmp26_);
#line 1454 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 9015 "Photo.c"
		PhotoMetadata* _tmp27_;
#line 1455 "../src/Photo.vala"
		_tmp27_ = reimport_state->metadata;
#line 1455 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp27_);
#line 9021 "Photo.c"
	}
#line 1458 "../src/Photo.vala"
	if (photo_is_master_source (self)) {
#line 9025 "Photo.c"
		PhotoMetadata* _tmp28_;
#line 1459 "../src/Photo.vala"
		_tmp28_ = reimport_state->metadata;
#line 1459 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp28_);
#line 9031 "Photo.c"
	}
#line 1421 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 9035 "Photo.c"
}

static gboolean
photo_verify_file_for_reimport (Photo* self,
                                GFile* file,
                                BackingPhotoRow** backing,
                                DetectedPhotoInformation** detected,
                                GError** error)
{
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	DetectedPhotoInformation* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1464 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1464 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1466 "../src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error0_);
#line 1466 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1466 "../src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1466 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1466 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9071 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 1466 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1466 "../src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 1466 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1466 "../src/Photo.vala"
		return _tmp3_;
#line 9081 "Photo.c"
	}
#line 1466 "../src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1466 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1466 "../src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1466 "../src/Photo.vala"
	_vala_backing = _tmp4_;
#line 1468 "../src/Photo.vala"
	_tmp5_ = _vala_backing;
#line 1468 "../src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 1469 "../src/Photo.vala"
		result = FALSE;
#line 1469 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1469 "../src/Photo.vala"
		if (backing) {
#line 1469 "../src/Photo.vala"
			*backing = _vala_backing;
#line 9103 "Photo.c"
		} else {
#line 1469 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 9107 "Photo.c"
		}
#line 1469 "../src/Photo.vala"
		if (detected) {
#line 1469 "../src/Photo.vala"
			*detected = _vala_detected;
#line 9113 "Photo.c"
		} else {
#line 1469 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 9117 "Photo.c"
		}
#line 1469 "../src/Photo.vala"
		return result;
#line 9121 "Photo.c"
	}
#line 1473 "../src/Photo.vala"
	_tmp8_ = _vala_detected;
#line 1473 "../src/Photo.vala"
	if (_tmp8_->colorspace != GDK_COLORSPACE_RGB) {
#line 1473 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 9129 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp9_;
#line 1474 "../src/Photo.vala"
		_tmp9_ = _vala_detected;
#line 1474 "../src/Photo.vala"
		_tmp7_ = _tmp9_->channels < 3;
#line 9136 "Photo.c"
	}
#line 1473 "../src/Photo.vala"
	if (_tmp7_) {
#line 1473 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 9142 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp10_;
#line 1475 "../src/Photo.vala"
		_tmp10_ = _vala_detected;
#line 1475 "../src/Photo.vala"
		_tmp6_ = _tmp10_->bits_per_channel != 8;
#line 9149 "Photo.c"
	}
#line 1473 "../src/Photo.vala"
	if (_tmp6_) {
#line 9153 "Photo.c"
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 1476 "../src/Photo.vala"
		_tmp11_ = g_file_get_path (file);
#line 1476 "../src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 1476 "../src/Photo.vala"
		g_warning ("Photo.vala:1476: Not re-importing %s: Unsupported color format", _tmp12_);
#line 1476 "../src/Photo.vala"
		_g_free0 (_tmp12_);
#line 1478 "../src/Photo.vala"
		result = FALSE;
#line 1478 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1478 "../src/Photo.vala"
		if (backing) {
#line 1478 "../src/Photo.vala"
			*backing = _vala_backing;
#line 9172 "Photo.c"
		} else {
#line 1478 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 9176 "Photo.c"
		}
#line 1478 "../src/Photo.vala"
		if (detected) {
#line 1478 "../src/Photo.vala"
			*detected = _vala_detected;
#line 9182 "Photo.c"
		} else {
#line 1478 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 9186 "Photo.c"
		}
#line 1478 "../src/Photo.vala"
		return result;
#line 9190 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	result = TRUE;
#line 1481 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1481 "../src/Photo.vala"
	if (backing) {
#line 1481 "../src/Photo.vala"
		*backing = _vala_backing;
#line 9200 "Photo.c"
	} else {
#line 1481 "../src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 9204 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	if (detected) {
#line 1481 "../src/Photo.vala"
		*detected = _vala_detected;
#line 9210 "Photo.c"
	} else {
#line 1481 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 9214 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	return result;
#line 9218 "Photo.c"
}

gboolean
photo_prepare_for_reimport_editable (Photo* self,
                                     PhotoReimportEditableState** state,
                                     GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp8_;
	DetectedPhotoInformation* _tmp9_;
	PhotoMetadata* _tmp10_;
	PhotoReimportEditableStateImpl* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1485 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1486 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1486 "../src/Photo.vala"
	_vala_state = NULL;
#line 1488 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1488 "../src/Photo.vala"
	file = _tmp0_;
#line 1489 "../src/Photo.vala"
	_tmp1_ = file;
#line 1489 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1490 "../src/Photo.vala"
		result = FALSE;
#line 1490 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1490 "../src/Photo.vala"
		if (state) {
#line 1490 "../src/Photo.vala"
			*state = _vala_state;
#line 9265 "Photo.c"
		} else {
#line 1490 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 9269 "Photo.c"
		}
#line 1490 "../src/Photo.vala"
		return result;
#line 9273 "Photo.c"
	}
#line 1495 "../src/Photo.vala"
	_tmp3_ = file;
#line 1495 "../src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 1495 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1495 "../src/Photo.vala"
	backing = _tmp4_;
#line 1495 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1495 "../src/Photo.vala"
	detected = _tmp5_;
#line 1495 "../src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1495 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9291 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1495 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1495 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1495 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1495 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1495 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 1495 "../src/Photo.vala"
		return _tmp7_;
#line 9305 "Photo.c"
	}
#line 1495 "../src/Photo.vala"
	if (!_tmp2_) {
#line 1496 "../src/Photo.vala"
		result = FALSE;
#line 1496 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1496 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1496 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1496 "../src/Photo.vala"
		if (state) {
#line 1496 "../src/Photo.vala"
			*state = _vala_state;
#line 9321 "Photo.c"
		} else {
#line 1496 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 9325 "Photo.c"
		}
#line 1496 "../src/Photo.vala"
		return result;
#line 9329 "Photo.c"
	}
#line 1499 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1499 "../src/Photo.vala"
	_tmp9_ = detected;
#line 1499 "../src/Photo.vala"
	_tmp10_ = _tmp9_->metadata;
#line 1499 "../src/Photo.vala"
	_tmp11_ = photo_reimport_editable_state_impl_new (_tmp8_, _tmp10_);
#line 1499 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1499 "../src/Photo.vala"
	_vala_state = (PhotoReimportEditableState*) _tmp11_;
#line 1501 "../src/Photo.vala"
	result = TRUE;
#line 1501 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1501 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1501 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1501 "../src/Photo.vala"
	if (state) {
#line 1501 "../src/Photo.vala"
		*state = _vala_state;
#line 9355 "Photo.c"
	} else {
#line 1501 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 9359 "Photo.c"
	}
#line 1501 "../src/Photo.vala"
	return result;
#line 9363 "Photo.c"
}

static gpointer
_photo_reimport_editable_state_ref0 (gpointer self)
{
#line 1511 "../src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 9371 "Photo.c"
}

void
photo_finish_reimport_editable (Photo* self,
                                PhotoReimportEditableState* state,
                                GError** error)
{
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableStateImpl* _tmp1_;
	PhotoReimportEditableStateImpl* _tmp2_;
	PhotoReimportEditableStateImpl* _tmp16_;
	PhotoMetadata* _tmp17_;
	gchar* list = NULL;
	gchar* _tmp28_;
	PhotoReimportEditableStateImpl* _tmp29_;
	const gchar* _tmp32_;
	Alteration* _tmp33_;
	Alteration* _tmp34_;
	PhotoReimportEditableStateImpl* _tmp35_;
	PhotoMetadata* _tmp36_;
	GError* _inner_error0_ = NULL;
#line 1505 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1505 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1506 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1506 "../src/Photo.vala"
	editable_id = _tmp0_;
#line 1507 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 1508 "../src/Photo.vala"
		return;
#line 9407 "Photo.c"
	}
#line 1511 "../src/Photo.vala"
	_tmp1_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1511 "../src/Photo.vala"
	reimport_state = _tmp1_;
#line 1513 "../src/Photo.vala"
	_tmp2_ = reimport_state;
#line 1513 "../src/Photo.vala"
	if (!_tmp2_->metadata_only) {
#line 9417 "Photo.c"
		BackingPhotoTable* _tmp3_;
		BackingPhotoTable* _tmp4_;
		PhotoReimportEditableStateImpl* _tmp5_;
		BackingPhotoRow* _tmp6_;
#line 1514 "../src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 1514 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1514 "../src/Photo.vala"
		_tmp5_ = reimport_state;
#line 1514 "../src/Photo.vala"
		_tmp6_ = _tmp5_->backing_state;
#line 1514 "../src/Photo.vala"
		backing_photo_table_update (_tmp4_, _tmp6_, &_inner_error0_);
#line 1514 "../src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 1514 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1514 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1514 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1514 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1514 "../src/Photo.vala"
				return;
#line 9444 "Photo.c"
			} else {
#line 1514 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1514 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1514 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1514 "../src/Photo.vala"
				return;
#line 9454 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp7_;
#line 1516 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 1516 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 9463 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp8_;
				BackingPhotoRow* _tmp9_;
				BackingPhotoRow* _tmp10_;
				PhotoReimportEditableStateImpl* _tmp11_;
				BackingPhotoRow* _tmp12_;
#line 1517 "../src/Photo.vala"
				_tmp8_ = reimport_state;
#line 1517 "../src/Photo.vala"
				_tmp9_ = _tmp8_->backing_state;
#line 1517 "../src/Photo.vala"
				_tmp10_ = _backing_photo_row_ref0 (_tmp9_);
#line 1517 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1517 "../src/Photo.vala"
				self->priv->editable = _tmp10_;
#line 1518 "../src/Photo.vala"
				_tmp11_ = reimport_state;
#line 1518 "../src/Photo.vala"
				_tmp12_ = _tmp11_->backing_state;
#line 1518 "../src/Photo.vala"
				photo_set_orientation (self, _tmp12_->original_orientation);
#line 1519 "../src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 9488 "Photo.c"
			}
			__finally0:
			{
				PhotoRow* _tmp13_;
#line 1516 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 1516 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9497 "Photo.c"
			}
#line 1516 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1516 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1516 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1516 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1516 "../src/Photo.vala"
					return;
#line 9509 "Photo.c"
				} else {
#line 1516 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1516 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1516 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1516 "../src/Photo.vala"
					return;
#line 9519 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp14_;
		BackingPhotoRow* _tmp15_;
#line 1522 "../src/Photo.vala"
		_tmp14_ = reimport_state;
#line 1522 "../src/Photo.vala"
		_tmp15_ = _tmp14_->backing_state;
#line 1522 "../src/Photo.vala"
		photo_set_orientation (self, _tmp15_->original_orientation);
#line 9532 "Photo.c"
	}
#line 1525 "../src/Photo.vala"
	_tmp16_ = reimport_state;
#line 1525 "../src/Photo.vala"
	_tmp17_ = _tmp16_->metadata;
#line 1525 "../src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 9540 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp18_;
		PhotoMetadata* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		PhotoReimportEditableStateImpl* _tmp22_;
		PhotoMetadata* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		PhotoReimportEditableStateImpl* _tmp26_;
		PhotoMetadata* _tmp27_;
#line 1526 "../src/Photo.vala"
		_tmp18_ = reimport_state;
#line 1526 "../src/Photo.vala"
		_tmp19_ = _tmp18_->metadata;
#line 1526 "../src/Photo.vala"
		_tmp20_ = media_metadata_get_title ((MediaMetadata*) _tmp19_);
#line 1526 "../src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1526 "../src/Photo.vala"
		media_source_set_title ((MediaSource*) self, _tmp21_);
#line 1526 "../src/Photo.vala"
		_g_free0 (_tmp21_);
#line 1527 "../src/Photo.vala"
		_tmp22_ = reimport_state;
#line 1527 "../src/Photo.vala"
		_tmp23_ = _tmp22_->metadata;
#line 1527 "../src/Photo.vala"
		_tmp24_ = media_metadata_get_comment ((MediaMetadata*) _tmp23_);
#line 1527 "../src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1527 "../src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, _tmp25_);
#line 1527 "../src/Photo.vala"
		_g_free0 (_tmp25_);
#line 1528 "../src/Photo.vala"
		_tmp26_ = reimport_state;
#line 1528 "../src/Photo.vala"
		_tmp27_ = _tmp26_->metadata;
#line 1528 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp27_);
#line 9581 "Photo.c"
	}
#line 1531 "../src/Photo.vala"
	_tmp28_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1531 "../src/Photo.vala"
	list = _tmp28_;
#line 1532 "../src/Photo.vala"
	_tmp29_ = reimport_state;
#line 1532 "../src/Photo.vala"
	if (!_tmp29_->metadata_only) {
#line 9591 "Photo.c"
		const gchar* _tmp30_;
		gchar* _tmp31_;
#line 1533 "../src/Photo.vala"
		_tmp30_ = list;
#line 1533 "../src/Photo.vala"
		_tmp31_ = g_strconcat (_tmp30_, "image:editable,image:baseline", NULL);
#line 1533 "../src/Photo.vala"
		_g_free0 (list);
#line 1533 "../src/Photo.vala"
		list = _tmp31_;
#line 9602 "Photo.c"
	}
#line 1536 "../src/Photo.vala"
	_tmp32_ = list;
#line 1536 "../src/Photo.vala"
	_tmp33_ = alteration_new_from_list (_tmp32_);
#line 1536 "../src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 1536 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp34_);
#line 1536 "../src/Photo.vala"
	_alteration_unref0 (_tmp34_);
#line 1538 "../src/Photo.vala"
	_tmp35_ = reimport_state;
#line 1538 "../src/Photo.vala"
	_tmp36_ = _tmp35_->metadata;
#line 1538 "../src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp36_);
#line 1540 "../src/Photo.vala"
	if (photo_is_editable_baseline (self)) {
#line 9622 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp37_;
		PhotoMetadata* _tmp38_;
#line 1541 "../src/Photo.vala"
		_tmp37_ = reimport_state;
#line 1541 "../src/Photo.vala"
		_tmp38_ = _tmp37_->metadata;
#line 1541 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp38_);
#line 9631 "Photo.c"
	}
#line 1544 "../src/Photo.vala"
	if (photo_is_editable_source (self)) {
#line 9635 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp39_;
		PhotoMetadata* _tmp40_;
#line 1545 "../src/Photo.vala"
		_tmp39_ = reimport_state;
#line 1545 "../src/Photo.vala"
		_tmp40_ = _tmp39_->metadata;
#line 1545 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp40_);
#line 9644 "Photo.c"
	}
#line 1505 "../src/Photo.vala"
	_g_free0 (list);
#line 1505 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 9650 "Photo.c"
}

static gpointer
_photo_reimport_raw_development_state_ref0 (gpointer self)
{
#line 1570 "../src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 9658 "Photo.c"
}

gboolean
photo_prepare_for_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState** state,
                                            GError** error)
{
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1550 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1551 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1551 "../src/Photo.vala"
	_vala_state = NULL;
#line 1553 "../src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1553 "../src/Photo.vala"
	files = _tmp0_;
#line 1554 "../src/Photo.vala"
	_tmp1_ = files;
#line 1554 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1555 "../src/Photo.vala"
		result = FALSE;
#line 1555 "../src/Photo.vala"
		_g_object_unref0 (files);
#line 1555 "../src/Photo.vala"
		if (state) {
#line 1555 "../src/Photo.vala"
			*state = _vala_state;
#line 9699 "Photo.c"
		} else {
#line 1555 "../src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 9703 "Photo.c"
		}
#line 1555 "../src/Photo.vala"
		return result;
#line 9707 "Photo.c"
	}
#line 1558 "../src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1558 "../src/Photo.vala"
	reimport_state = _tmp2_;
#line 9713 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 1560 "../src/Photo.vala"
		_tmp3_ = files;
#line 1560 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1560 "../src/Photo.vala"
		_file_it = _tmp4_;
#line 1560 "../src/Photo.vala"
		while (TRUE) {
#line 9726 "Photo.c"
			GeeIterator* _tmp5_;
			GFile* file = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp8_ = FALSE;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1560 "../src/Photo.vala"
			_tmp5_ = _file_it;
#line 1560 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1560 "../src/Photo.vala"
				break;
#line 9748 "Photo.c"
			}
#line 1560 "../src/Photo.vala"
			_tmp6_ = _file_it;
#line 1560 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1560 "../src/Photo.vala"
			file = (GFile*) _tmp7_;
#line 1563 "../src/Photo.vala"
			_tmp9_ = file;
#line 1563 "../src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 1563 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1563 "../src/Photo.vala"
			backing = _tmp10_;
#line 1563 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1563 "../src/Photo.vala"
			detected = _tmp11_;
#line 1563 "../src/Photo.vala"
			_tmp8_ = _tmp12_;
#line 1563 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9772 "Photo.c"
				gboolean _tmp13_ = FALSE;
#line 1563 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1563 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1563 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1563 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1563 "../src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1563 "../src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1563 "../src/Photo.vala"
				_g_object_unref0 (files);
#line 1563 "../src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1563 "../src/Photo.vala"
				return _tmp13_;
#line 9792 "Photo.c"
			}
#line 1563 "../src/Photo.vala"
			if (!_tmp8_) {
#line 1564 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1564 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1564 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1564 "../src/Photo.vala"
				continue;
#line 9804 "Photo.c"
			}
#line 1567 "../src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1567 "../src/Photo.vala"
			_tmp15_ = backing;
#line 1567 "../src/Photo.vala"
			_tmp16_ = detected;
#line 1567 "../src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1567 "../src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1560 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1560 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1560 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 9822 "Photo.c"
		}
#line 1560 "../src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 9826 "Photo.c"
	}
#line 1570 "../src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1570 "../src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 ((PhotoReimportRawDevelopmentState*) _tmp18_);
#line 1570 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1570 "../src/Photo.vala"
	_vala_state = _tmp19_;
#line 1571 "../src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1571 "../src/Photo.vala"
	result = photo_reimport_raw_development_state_impl_get_size (_tmp20_) > 0;
#line 1571 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1571 "../src/Photo.vala"
	_g_object_unref0 (files);
#line 1571 "../src/Photo.vala"
	if (state) {
#line 1571 "../src/Photo.vala"
		*state = _vala_state;
#line 9848 "Photo.c"
	} else {
#line 1571 "../src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 9852 "Photo.c"
	}
#line 1571 "../src/Photo.vala"
	return result;
#line 9856 "Photo.c"
}

void
photo_finish_reimport_raw_development (Photo* self,
                                       PhotoReimportRawDevelopmentState* state,
                                       GError** error)
{
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp0_;
	gchar* list = NULL;
	gchar* _tmp25_;
	PhotoReimportRawDevelopmentStateImpl* _tmp26_;
	const gchar* _tmp29_;
	Alteration* _tmp30_;
	Alteration* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 1575 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1575 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1576 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1577 "../src/Photo.vala"
		return;
#line 9881 "Photo.c"
	}
#line 1580 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1580 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 9887 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 1582 "../src/Photo.vala"
		_tmp1_ = reimport_state;
#line 1582 "../src/Photo.vala"
		_tmp2_ = _tmp1_->list;
#line 1582 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 1582 "../src/Photo.vala"
		_dev_it = _tmp3_;
#line 1582 "../src/Photo.vala"
		while (TRUE) {
#line 9903 "Photo.c"
			GeeIterator* _tmp4_;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PhotoReimportRawDevelopmentStateImpl* _tmp7_;
#line 1582 "../src/Photo.vala"
			_tmp4_ = _dev_it;
#line 1582 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1582 "../src/Photo.vala"
				break;
#line 9915 "Photo.c"
			}
#line 1582 "../src/Photo.vala"
			_tmp5_ = _dev_it;
#line 1582 "../src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1582 "../src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp6_;
#line 1583 "../src/Photo.vala"
			_tmp7_ = reimport_state;
#line 1583 "../src/Photo.vala"
			if (!_tmp7_->metadata_only) {
#line 9927 "Photo.c"
				BackingPhotoTable* _tmp8_;
				BackingPhotoTable* _tmp9_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp10_;
				BackingPhotoRow* _tmp11_;
#line 1584 "../src/Photo.vala"
				_tmp8_ = backing_photo_table_get_instance ();
#line 1584 "../src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1584 "../src/Photo.vala"
				_tmp10_ = dev;
#line 1584 "../src/Photo.vala"
				_tmp11_ = _tmp10_->backing;
#line 1584 "../src/Photo.vala"
				backing_photo_table_update (_tmp9_, _tmp11_, &_inner_error0_);
#line 1584 "../src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1584 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1584 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1584 "../src/Photo.vala"
						g_propagate_error (error, _inner_error0_);
#line 1584 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1584 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1584 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1584 "../src/Photo.vala"
						return;
#line 9958 "Photo.c"
					} else {
#line 1584 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1584 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1584 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1584 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1584 "../src/Photo.vala"
						g_clear_error (&_inner_error0_);
#line 1584 "../src/Photo.vala"
						return;
#line 9972 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp12_;
#line 1586 "../src/Photo.vala"
					_tmp12_ = self->row;
#line 1586 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 9981 "Photo.c"
					{
						gint _tmp13_ = 0;
						RawDeveloper* _tmp14_;
#line 1588 "../src/Photo.vala"
						_tmp14_ = raw_developer_as_array (&_tmp13_);
#line 9987 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1588 "../src/Photo.vala"
							d_collection = _tmp14_;
#line 1588 "../src/Photo.vala"
							d_collection_length1 = _tmp13_;
#line 1588 "../src/Photo.vala"
							for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 9999 "Photo.c"
								RawDeveloper d = 0;
#line 1588 "../src/Photo.vala"
								d = d_collection[d_it];
#line 10003 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp15_;
									BackingPhotoID* _tmp16_;
									gint _tmp16__length1;
									BackingPhotoID _tmp17_;
									BackingPhotoID _tmp18_;
#line 1589 "../src/Photo.vala"
									_tmp15_ = self->row;
#line 1589 "../src/Photo.vala"
									_tmp16_ = _tmp15_->development_ids;
#line 1589 "../src/Photo.vala"
									_tmp16__length1 = _tmp15_->development_ids_length1;
#line 1589 "../src/Photo.vala"
									_tmp17_ = _tmp16_[d];
#line 1589 "../src/Photo.vala"
									id = _tmp17_;
#line 1590 "../src/Photo.vala"
									_tmp18_ = id;
#line 1590 "../src/Photo.vala"
									if (_tmp18_.id != BACKING_PHOTO_ID_INVALID) {
#line 10025 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp19_;
										BackingPhotoRow* _tmp20_;
										BackingPhotoRow* _tmp21_;
#line 1591 "../src/Photo.vala"
										_tmp19_ = id;
#line 1591 "../src/Photo.vala"
										_tmp20_ = photo_get_backing_row (self, &_tmp19_);
#line 1591 "../src/Photo.vala"
										bpr = _tmp20_;
#line 1592 "../src/Photo.vala"
										_tmp21_ = bpr;
#line 1592 "../src/Photo.vala"
										if (_tmp21_ != NULL) {
#line 10040 "Photo.c"
											GeeHashMap* _tmp22_;
											BackingPhotoRow* _tmp23_;
#line 1593 "../src/Photo.vala"
											_tmp22_ = self->priv->developments;
#line 1593 "../src/Photo.vala"
											_tmp23_ = bpr;
#line 1593 "../src/Photo.vala"
											gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, (gpointer) ((gintptr) d), _tmp23_);
#line 10049 "Photo.c"
										}
#line 1590 "../src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 10053 "Photo.c"
									}
								}
							}
#line 1588 "../src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 10059 "Photo.c"
						}
					}
					__finally0:
					{
						PhotoRow* _tmp24_;
#line 1586 "../src/Photo.vala"
						_tmp24_ = self->row;
#line 1586 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 10069 "Photo.c"
					}
#line 1586 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1586 "../src/Photo.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1586 "../src/Photo.vala"
							g_propagate_error (error, _inner_error0_);
#line 1586 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1586 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1586 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1586 "../src/Photo.vala"
							return;
#line 10085 "Photo.c"
						} else {
#line 1586 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1586 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1586 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1586 "../src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1586 "../src/Photo.vala"
							g_clear_error (&_inner_error0_);
#line 1586 "../src/Photo.vala"
							return;
#line 10099 "Photo.c"
						}
					}
				}
			}
#line 1582 "../src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 10106 "Photo.c"
		}
#line 1582 "../src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 10110 "Photo.c"
	}
#line 1601 "../src/Photo.vala"
	_tmp25_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1601 "../src/Photo.vala"
	list = _tmp25_;
#line 1602 "../src/Photo.vala"
	_tmp26_ = reimport_state;
#line 1602 "../src/Photo.vala"
	if (!_tmp26_->metadata_only) {
#line 10120 "Photo.c"
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 1603 "../src/Photo.vala"
		_tmp27_ = list;
#line 1603 "../src/Photo.vala"
		_tmp28_ = g_strconcat (_tmp27_, "image:editable,image:baseline", NULL);
#line 1603 "../src/Photo.vala"
		_g_free0 (list);
#line 1603 "../src/Photo.vala"
		list = _tmp28_;
#line 10131 "Photo.c"
	}
#line 1606 "../src/Photo.vala"
	_tmp29_ = list;
#line 1606 "../src/Photo.vala"
	_tmp30_ = alteration_new_from_list (_tmp29_);
#line 1606 "../src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 1606 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp31_);
#line 1606 "../src/Photo.vala"
	_alteration_unref0 (_tmp31_);
#line 1608 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1575 "../src/Photo.vala"
	_g_free0 (list);
#line 1575 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 10149 "Photo.c"
}

static gchar*
photo_real_get_typename (DataSource* base)
{
	Photo * self;
	gchar* _tmp0_;
	gchar* result;
#line 1611 "../src/Photo.vala"
	self = (Photo*) base;
#line 1612 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1612 "../src/Photo.vala"
	result = _tmp0_;
#line 1612 "../src/Photo.vala"
	return result;
#line 10166 "Photo.c"
}

static gint64
photo_real_get_instance_id (DataSource* base)
{
	Photo * self;
	PhotoID _tmp0_ = {0};
	gint64 result;
#line 1615 "../src/Photo.vala"
	self = (Photo*) base;
#line 1616 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1616 "../src/Photo.vala"
	result = _tmp0_.id;
#line 1616 "../src/Photo.vala"
	return result;
#line 10183 "Photo.c"
}

static gchar*
photo_real_get_source_id (DataSource* base)
{
	Photo * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 1619 "../src/Photo.vala"
	self = (Photo*) base;
#line 1623 "../src/Photo.vala"
	_tmp0_ = data_source_get_typename ((DataSource*) self);
#line 1623 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1623 "../src/Photo.vala"
	_tmp2_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id ((DataSource*) self));
#line 1623 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1623 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1623 "../src/Photo.vala"
	result = _tmp3_;
#line 1623 "../src/Photo.vala"
	return result;
#line 10211 "Photo.c"
}

void
photo_set_master_timestamp (Photo* self,
                            GFileInfo* info)
{
	gint64 mod_time = 0LL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gint64 _tmp2_;
	GError* _inner_error0_ = NULL;
#line 1627 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1627 "../src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1628 "../src/Photo.vala"
	_tmp0_ = g_file_info_get_modification_date_time (info);
#line 1628 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1628 "../src/Photo.vala"
	_tmp2_ = g_date_time_to_unix (_tmp1_);
#line 1628 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1628 "../src/Photo.vala"
	mod_time = _tmp2_;
#line 10237 "Photo.c"
	{
		{
			PhotoRow* _tmp3_;
#line 1630 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1630 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 10245 "Photo.c"
			{
				PhotoRow* _tmp4_;
				BackingPhotoRow* _tmp5_;
				PhotoTable* _tmp7_;
				PhotoTable* _tmp8_;
				PhotoRow* _tmp9_;
				PhotoID _tmp10_;
				PhotoRow* _tmp11_;
				BackingPhotoRow* _tmp12_;
#line 1631 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 1631 "../src/Photo.vala"
				_tmp5_ = _tmp4_->master;
#line 1631 "../src/Photo.vala"
				if (_tmp5_->timestamp == mod_time) {
#line 10261 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						PhotoRow* _tmp6_;
#line 1630 "../src/Photo.vala"
						_tmp6_ = self->row;
#line 1630 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 10269 "Photo.c"
					}
#line 1632 "../src/Photo.vala"
					return;
#line 10273 "Photo.c"
				}
#line 1635 "../src/Photo.vala"
				_tmp7_ = photo_table_get_instance ();
#line 1635 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 1635 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 1635 "../src/Photo.vala"
				_tmp10_ = _tmp9_->photo_id;
#line 1635 "../src/Photo.vala"
				photo_table_update_timestamp (_tmp8_, &_tmp10_, mod_time, &_inner_error0_);
#line 1635 "../src/Photo.vala"
				_database_table_unref0 (_tmp8_);
#line 1635 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10289 "Photo.c"
					goto __catch1_g_error;
				}
#line 1636 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 1636 "../src/Photo.vala"
				_tmp12_ = _tmp11_->master;
#line 1636 "../src/Photo.vala"
				_tmp12_->timestamp = mod_time;
#line 10298 "Photo.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* _lock_error_ = NULL;
				GError* _tmp13_;
#line 1630 "../src/Photo.vala"
				_lock_error_ = _inner_error0_;
#line 1630 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 1630 "../src/Photo.vala"
				_tmp13_ = _lock_error_;
#line 1630 "../src/Photo.vala"
				_lock_error_ = NULL;
#line 1630 "../src/Photo.vala"
				_inner_error0_ = _tmp13_;
#line 1630 "../src/Photo.vala"
				_g_error_free0 (_lock_error_);
#line 10317 "Photo.c"
				goto __finally1;
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp14_;
#line 1630 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 1630 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 10328 "Photo.c"
			}
#line 1630 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1630 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 10334 "Photo.c"
					goto __catch0_database_error;
				}
				goto __finally0;
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp15_;
#line 1629 "../src/Photo.vala"
		err = _inner_error0_;
#line 1629 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1639 "../src/Photo.vala"
		_tmp15_ = err;
#line 1639 "../src/Photo.vala"
		app_window_database_error (_tmp15_);
#line 1641 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1641 "../src/Photo.vala"
		return;
#line 10358 "Photo.c"
	}
	__finally0:
#line 1629 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1629 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1629 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1629 "../src/Photo.vala"
		return;
#line 10369 "Photo.c"
	}
#line 1644 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 10373 "Photo.c"
		Alteration* _tmp16_;
		Alteration* _tmp17_;
#line 1645 "../src/Photo.vala"
		_tmp16_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1645 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1645 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp17_);
#line 1645 "../src/Photo.vala"
		_alteration_unref0 (_tmp17_);
#line 10384 "Photo.c"
	} else {
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 1647 "../src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "master-timestamp");
#line 1647 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 1647 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp19_);
#line 1647 "../src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 10396 "Photo.c"
	}
}

void
photo_update_editable_modification_time (Photo* self,
                                         GFileInfo* info,
                                         GError** error)
{
	gint64 mod_time = 0LL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gint64 _tmp2_;
	gboolean altered = FALSE;
	GError* _inner_error0_ = NULL;
#line 1652 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1652 "../src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1653 "../src/Photo.vala"
	_tmp0_ = g_file_info_get_modification_date_time (info);
#line 1653 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1653 "../src/Photo.vala"
	_tmp2_ = g_date_time_to_unix (_tmp1_);
#line 1653 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1653 "../src/Photo.vala"
	mod_time = _tmp2_;
#line 1655 "../src/Photo.vala"
	altered = FALSE;
#line 10427 "Photo.c"
	{
		PhotoRow* _tmp3_;
#line 1656 "../src/Photo.vala"
		_tmp3_ = self->row;
#line 1656 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 10434 "Photo.c"
		{
			gboolean _tmp4_ = FALSE;
			PhotoRow* _tmp5_;
#line 1657 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1657 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp5_->editable_id)) {
#line 10442 "Photo.c"
				BackingPhotoRow* _tmp6_;
#line 1657 "../src/Photo.vala"
				_tmp6_ = self->priv->editable;
#line 1657 "../src/Photo.vala"
				_tmp4_ = _tmp6_->timestamp != mod_time;
#line 10448 "Photo.c"
			} else {
#line 1657 "../src/Photo.vala"
				_tmp4_ = FALSE;
#line 10452 "Photo.c"
			}
#line 1657 "../src/Photo.vala"
			if (_tmp4_) {
#line 10456 "Photo.c"
				BackingPhotoTable* _tmp7_;
				BackingPhotoTable* _tmp8_;
				PhotoRow* _tmp9_;
				BackingPhotoID _tmp10_;
				BackingPhotoRow* _tmp11_;
#line 1658 "../src/Photo.vala"
				_tmp7_ = backing_photo_table_get_instance ();
#line 1658 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 1658 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 1658 "../src/Photo.vala"
				_tmp10_ = _tmp9_->editable_id;
#line 1658 "../src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp8_, &_tmp10_, mod_time, &_inner_error0_);
#line 1658 "../src/Photo.vala"
				_database_table_unref0 (_tmp8_);
#line 1658 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10476 "Photo.c"
					goto __catch0_g_error;
				}
#line 1660 "../src/Photo.vala"
				_tmp11_ = self->priv->editable;
#line 1660 "../src/Photo.vala"
				_tmp11_->timestamp = mod_time;
#line 1661 "../src/Photo.vala"
				altered = TRUE;
#line 10485 "Photo.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp12_;
#line 1656 "../src/Photo.vala"
			_lock_error_ = _inner_error0_;
#line 1656 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 1656 "../src/Photo.vala"
			_tmp12_ = _lock_error_;
#line 1656 "../src/Photo.vala"
			_lock_error_ = NULL;
#line 1656 "../src/Photo.vala"
			_inner_error0_ = _tmp12_;
#line 1656 "../src/Photo.vala"
			_g_error_free0 (_lock_error_);
#line 10505 "Photo.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp13_;
#line 1656 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 1656 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 10516 "Photo.c"
		}
#line 1656 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1656 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1656 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1656 "../src/Photo.vala"
				return;
#line 10526 "Photo.c"
			} else {
#line 1656 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1656 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1656 "../src/Photo.vala"
				return;
#line 10534 "Photo.c"
			}
		}
	}
#line 1665 "../src/Photo.vala"
	if (altered) {
#line 10540 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 1666 "../src/Photo.vala"
		_tmp14_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1666 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 1666 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 1666 "../src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 10551 "Photo.c"
	}
}

void
photo_update_many_editable_timestamps (GeeMap* map,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 1671 "../src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1673 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 10564 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 1674 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 1674 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1674 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1674 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 1674 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1674 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 1674 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 1674 "../src/Photo.vala"
		while (TRUE) {
#line 10588 "Photo.c"
			GeeIterator* _tmp5_;
			Photo* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Photo* _tmp8_;
			Photo* _tmp9_;
			gpointer _tmp10_;
			GFileInfo* _tmp11_;
#line 1674 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 1674 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1674 "../src/Photo.vala"
				break;
#line 10603 "Photo.c"
			}
#line 1674 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1674 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1674 "../src/Photo.vala"
			photo = (Photo*) _tmp7_;
#line 1675 "../src/Photo.vala"
			_tmp8_ = photo;
#line 1675 "../src/Photo.vala"
			_tmp9_ = photo;
#line 1675 "../src/Photo.vala"
			_tmp10_ = gee_map_get (map, _tmp9_);
#line 1675 "../src/Photo.vala"
			_tmp11_ = (GFileInfo*) _tmp10_;
#line 1675 "../src/Photo.vala"
			photo_update_editable_modification_time (_tmp8_, _tmp11_, &_inner_error0_);
#line 1675 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 1675 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1675 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1675 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1675 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1675 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1675 "../src/Photo.vala"
					return;
#line 10635 "Photo.c"
				} else {
#line 1675 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1675 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1675 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1675 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1675 "../src/Photo.vala"
					return;
#line 10647 "Photo.c"
				}
			}
#line 1674 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 10652 "Photo.c"
		}
#line 1674 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 10656 "Photo.c"
	}
#line 1677 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1677 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1677 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1677 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1677 "../src/Photo.vala"
			return;
#line 10668 "Photo.c"
		} else {
#line 1677 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1677 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1677 "../src/Photo.vala"
			return;
#line 10676 "Photo.c"
		}
	}
}

static PhotoFileFormat
photo_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Photo * self;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat result;
#line 1680 "../src/Photo.vala"
	self = (Photo*) base;
#line 1681 "../src/Photo.vala"
	if (photo_file_format_can_write_image (photo_get_file_format (self))) {
#line 1681 "../src/Photo.vala"
		_tmp0_ = photo_get_file_format (self);
#line 10693 "Photo.c"
	} else {
#line 1682 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_system_default_format ();
#line 10697 "Photo.c"
	}
#line 1681 "../src/Photo.vala"
	result = _tmp0_;
#line 1681 "../src/Photo.vala"
	return result;
#line 10703 "Photo.c"
}

static GdkPixbuf*
photo_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Photo * self;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 1685 "../src/Photo.vala"
	self = (Photo*) base;
#line 1686 "../src/Photo.vala"
	scaling_for_best_fit (scale, TRUE, &_tmp1_);
#line 1686 "../src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf ((PhotoSource*) self, &_tmp1_, &_inner_error0_);
#line 1686 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1686 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1686 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1686 "../src/Photo.vala"
		return NULL;
#line 10732 "Photo.c"
	}
#line 1686 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 1686 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1686 "../src/Photo.vala"
	result = _tmp3_;
#line 1686 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1686 "../src/Photo.vala"
	return result;
#line 10744 "Photo.c"
}

gboolean
photo_is_file_image (GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 1689 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1693 "../src/Photo.vala"
	if (photo_file_format_is_file_supported (file)) {
#line 1694 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 10758 "Photo.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1694 "../src/Photo.vala"
		_tmp1_ = g_file_get_basename (file);
#line 1694 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1694 "../src/Photo.vala"
		_tmp0_ = photo_is_extension_found (_tmp2_, PHOTO_IMAGE_EXTENSIONS, (gint) G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1694 "../src/Photo.vala"
		_g_free0 (_tmp2_);
#line 10770 "Photo.c"
	}
#line 1693 "../src/Photo.vala"
	result = _tmp0_;
#line 1693 "../src/Photo.vala"
	return result;
#line 10776 "Photo.c"
}

gboolean
photo_can_write_file (Photo* self)
{
	GFile* file = NULL;
	PhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFileInfo* file_info = NULL;
	GFileInfo* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1697 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1698 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 1698 "../src/Photo.vala"
	_tmp1_ = _tmp0_->master;
#line 1698 "../src/Photo.vala"
	_tmp2_ = _tmp1_->filepath;
#line 1698 "../src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 1698 "../src/Photo.vala"
	file = _tmp3_;
#line 10803 "Photo.c"
	{
		GFileInfo* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
#line 1701 "../src/Photo.vala"
		_tmp5_ = file;
#line 1701 "../src/Photo.vala"
		_tmp6_ = g_file_query_info (_tmp5_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 1701 "../src/Photo.vala"
		_tmp4_ = _tmp6_;
#line 1701 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10817 "Photo.c"
			goto __catch0_g_error;
		}
#line 1701 "../src/Photo.vala"
		_tmp7_ = _tmp4_;
#line 1701 "../src/Photo.vala"
		_tmp4_ = NULL;
#line 1701 "../src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1701 "../src/Photo.vala"
		file_info = _tmp7_;
#line 1700 "../src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 10830 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 1700 "../src/Photo.vala"
		e = _inner_error0_;
#line 1700 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1703 "../src/Photo.vala"
		_tmp8_ = e;
#line 1703 "../src/Photo.vala"
		_tmp9_ = _tmp8_->message;
#line 1703 "../src/Photo.vala"
		g_warning ("Photo.vala:1703: Error while testing if file is writeable: %s\n", _tmp9_);
#line 1704 "../src/Photo.vala"
		result = FALSE;
#line 1704 "../src/Photo.vala"
		_g_error_free0 (e);
#line 1704 "../src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1704 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1704 "../src/Photo.vala"
		return result;
#line 10858 "Photo.c"
	}
	__finally0:
#line 1700 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10863 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 1700 "../src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1700 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1700 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1700 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1700 "../src/Photo.vala"
		return _tmp10_;
#line 10875 "Photo.c"
	}
#line 1707 "../src/Photo.vala"
	_tmp11_ = file_info;
#line 1707 "../src/Photo.vala"
	result = g_file_info_get_attribute_boolean (_tmp11_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
#line 1707 "../src/Photo.vala"
	_g_object_unref0 (file_info);
#line 1707 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1707 "../src/Photo.vala"
	return result;
#line 10887 "Photo.c"
}

static gboolean
photo_is_extension_found (const gchar* basename,
                          gchar** extensions,
                          gint extensions_length1)
{
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean result;
#line 1710 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1712 "../src/Photo.vala"
	disassemble_filename (basename, &_tmp0_, &_tmp1_);
#line 1712 "../src/Photo.vala"
	_g_free0 (name);
#line 1712 "../src/Photo.vala"
	name = _tmp0_;
#line 1712 "../src/Photo.vala"
	_g_free0 (ext);
#line 1712 "../src/Photo.vala"
	ext = _tmp1_;
#line 1713 "../src/Photo.vala"
	_tmp2_ = ext;
#line 1713 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 1714 "../src/Photo.vala"
		result = FALSE;
#line 1714 "../src/Photo.vala"
		_g_free0 (ext);
#line 1714 "../src/Photo.vala"
		_g_free0 (name);
#line 1714 "../src/Photo.vala"
		return result;
#line 10927 "Photo.c"
	}
#line 1718 "../src/Photo.vala"
	_tmp3_ = ext;
#line 1718 "../src/Photo.vala"
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 1718 "../src/Photo.vala"
	_g_free0 (ext);
#line 1718 "../src/Photo.vala"
	ext = _tmp4_;
#line 10937 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1721 "../src/Photo.vala"
		extension_collection = extensions;
#line 1721 "../src/Photo.vala"
		extension_collection_length1 = extensions_length1;
#line 1721 "../src/Photo.vala"
		for (extension_it = 0; extension_it < extension_collection_length1; extension_it = extension_it + 1) {
#line 10949 "Photo.c"
			gchar* _tmp5_;
			gchar* extension = NULL;
#line 1721 "../src/Photo.vala"
			_tmp5_ = g_strdup (extension_collection[extension_it]);
#line 1721 "../src/Photo.vala"
			extension = _tmp5_;
#line 10956 "Photo.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1722 "../src/Photo.vala"
				_tmp6_ = ext;
#line 1722 "../src/Photo.vala"
				_tmp7_ = extension;
#line 1722 "../src/Photo.vala"
				if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 1723 "../src/Photo.vala"
					result = TRUE;
#line 1723 "../src/Photo.vala"
					_g_free0 (extension);
#line 1723 "../src/Photo.vala"
					_g_free0 (ext);
#line 1723 "../src/Photo.vala"
					_g_free0 (name);
#line 1723 "../src/Photo.vala"
					return result;
#line 10976 "Photo.c"
				}
#line 1721 "../src/Photo.vala"
				_g_free0 (extension);
#line 10980 "Photo.c"
			}
		}
	}
#line 1727 "../src/Photo.vala"
	result = FALSE;
#line 1727 "../src/Photo.vala"
	_g_free0 (ext);
#line 1727 "../src/Photo.vala"
	_g_free0 (name);
#line 1727 "../src/Photo.vala"
	return result;
#line 10992 "Photo.c"
}

gboolean
photo_is_duplicate (GFile* file,
                    const gchar* thumbnail_md5,
                    const gchar* full_md5,
                    PhotoFileFormat file_format)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 1736 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1736 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1736 "../src/Photo.vala"
	_tmp2_ = photo_table_has_duplicate (_tmp1_, file, thumbnail_md5, full_md5, file_format);
#line 1736 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1736 "../src/Photo.vala"
	result = _tmp2_;
#line 1736 "../src/Photo.vala"
	return result;
#line 11017 "Photo.c"
}

PhotoID*
photo_get_duplicate_ids (GFile* file,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         PhotoFileFormat file_format,
                         gint* result_length1)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gint _tmp2_ = 0;
	PhotoID* _tmp3_;
	PhotoID* _tmp4_;
	gint _tmp4__length1;
	PhotoID* _tmp5_;
	gint _tmp5__length1;
	PhotoID* result;
#line 1745 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1745 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1745 "../src/Photo.vala"
	_tmp3_ = photo_table_get_duplicate_ids (_tmp1_, file, thumbnail_md5, full_md5, file_format, &_tmp2_);
#line 1745 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1745 "../src/Photo.vala"
	_tmp4__length1 = _tmp2_;
#line 1745 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1745 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 1745 "../src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1745 "../src/Photo.vala"
	if (result_length1) {
#line 1745 "../src/Photo.vala"
		*result_length1 = _tmp5__length1;
#line 11056 "Photo.c"
	}
#line 1745 "../src/Photo.vala"
	result = _tmp5_;
#line 1745 "../src/Photo.vala"
	return result;
#line 11062 "Photo.c"
}

gint64
photo_get_photo_key (DataSource* source)
{
	PhotoID _tmp0_ = {0};
	gint64 result;
#line 1752 "../src/Photo.vala"
	g_return_val_if_fail (source != NULL, 0LL);
#line 1753 "../src/Photo.vala"
	photo_get_photo_id ((Photo*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), &_tmp0_);
#line 1753 "../src/Photo.vala"
	result = _tmp0_.id;
#line 1753 "../src/Photo.vala"
	return result;
#line 11078 "Photo.c"
}

static GFile*
photo_real_get_file (MediaSource* base)
{
	Photo * self;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 1771 "../src/Photo.vala"
	self = (Photo*) base;
#line 1772 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1772 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1772 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1772 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1772 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1772 "../src/Photo.vala"
	result = _tmp3_;
#line 1772 "../src/Photo.vala"
	return result;
#line 11106 "Photo.c"
}

static void
_vala_array_add17 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1816 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1816 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1816 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11121 "Photo.c"
	}
#line 1816 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1816 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11127 "Photo.c"
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1821 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1821 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1821 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11142 "Photo.c"
	}
#line 1821 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1821 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11148 "Photo.c"
}

static void
_vala_array_add19 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1825 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1825 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1825 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11163 "Photo.c"
	}
#line 1825 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1825 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11169 "Photo.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1829 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1829 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1829 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11184 "Photo.c"
	}
#line 1829 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1829 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11190 "Photo.c"
}

void
photo_set_master_file (Photo* self,
                       GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	GError* _inner_error0_ = NULL;
#line 1777 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1777 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1778 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1778 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1780 "../src/Photo.vala"
	altered = FALSE;
#line 1781 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1782 "../src/Photo.vala"
	is_source = FALSE;
#line 1783 "../src/Photo.vala"
	name_changed = FALSE;
#line 1784 "../src/Photo.vala"
	old_file = NULL;
#line 11223 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1786 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1786 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 11231 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1787 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1787 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 11239 "Photo.c"
					{
						PhotoBackingReaders* _tmp3_;
						PhotoFileReader* _tmp4_;
						GFile* _tmp5_;
						GFile* _tmp6_;
#line 1788 "../src/Photo.vala"
						_tmp3_ = self->priv->readers;
#line 1788 "../src/Photo.vala"
						_tmp4_ = _tmp3_->master;
#line 1788 "../src/Photo.vala"
						_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 1788 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1788 "../src/Photo.vala"
						old_file = _tmp5_;
#line 1789 "../src/Photo.vala"
						_tmp6_ = old_file;
#line 1789 "../src/Photo.vala"
						if (!g_file_equal (file, _tmp6_)) {
#line 11259 "Photo.c"
							PhotoTable* _tmp7_;
							PhotoTable* _tmp8_;
							PhotoID _tmp9_ = {0};
							const gchar* _tmp10_;
							PhotoRow* _tmp11_;
							BackingPhotoRow* _tmp12_;
							const gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							PhotoBackingReaders* _tmp16_;
							PhotoRow* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							PhotoFileReader* _tmp20_;
							gboolean _tmp21_ = FALSE;
							PhotoRow* _tmp22_;
							const gchar* _tmp23_;
#line 1790 "../src/Photo.vala"
							_tmp7_ = photo_table_get_instance ();
#line 1790 "../src/Photo.vala"
							_tmp8_ = _tmp7_;
#line 1790 "../src/Photo.vala"
							photo_get_photo_id (self, &_tmp9_);
#line 1790 "../src/Photo.vala"
							_tmp10_ = filepath;
#line 1790 "../src/Photo.vala"
							photo_table_set_filepath (_tmp8_, &_tmp9_, _tmp10_, &_inner_error0_);
#line 1790 "../src/Photo.vala"
							_database_table_unref0 (_tmp8_);
#line 1790 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11291 "Photo.c"
								goto __catch2_g_error;
							}
#line 1792 "../src/Photo.vala"
							_tmp11_ = self->row;
#line 1792 "../src/Photo.vala"
							_tmp12_ = _tmp11_->master;
#line 1792 "../src/Photo.vala"
							_tmp13_ = filepath;
#line 1792 "../src/Photo.vala"
							_tmp14_ = g_strdup (_tmp13_);
#line 1792 "../src/Photo.vala"
							_g_free0 (_tmp12_->filepath);
#line 1792 "../src/Photo.vala"
							_tmp12_->filepath = _tmp14_;
#line 1793 "../src/Photo.vala"
							_tmp15_ = g_file_get_basename (file);
#line 1793 "../src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1793 "../src/Photo.vala"
							self->priv->file_title = _tmp15_;
#line 1794 "../src/Photo.vala"
							_tmp16_ = self->priv->readers;
#line 1794 "../src/Photo.vala"
							_tmp17_ = self->row;
#line 1794 "../src/Photo.vala"
							_tmp18_ = _tmp17_->master;
#line 1794 "../src/Photo.vala"
							_tmp19_ = filepath;
#line 1794 "../src/Photo.vala"
							_tmp20_ = photo_file_format_create_reader (_tmp18_->file_format, _tmp19_);
#line 1794 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp16_->master);
#line 1794 "../src/Photo.vala"
							_tmp16_->master = _tmp20_;
#line 1796 "../src/Photo.vala"
							altered = TRUE;
#line 1797 "../src/Photo.vala"
							is_baseline = photo_is_master_baseline (self);
#line 1798 "../src/Photo.vala"
							is_source = photo_is_master_source (self);
#line 1799 "../src/Photo.vala"
							_tmp22_ = self->row;
#line 1799 "../src/Photo.vala"
							_tmp23_ = _tmp22_->title;
#line 1799 "../src/Photo.vala"
							if (is_string_empty (_tmp23_)) {
#line 11338 "Photo.c"
								GFile* _tmp24_;
								gchar* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
#line 1800 "../src/Photo.vala"
								_tmp24_ = old_file;
#line 1800 "../src/Photo.vala"
								_tmp25_ = g_file_get_basename (_tmp24_);
#line 1800 "../src/Photo.vala"
								_tmp26_ = _tmp25_;
#line 1800 "../src/Photo.vala"
								_tmp27_ = g_file_get_basename (file);
#line 1800 "../src/Photo.vala"
								_tmp28_ = _tmp27_;
#line 1800 "../src/Photo.vala"
								_tmp21_ = g_strcmp0 (_tmp26_, _tmp28_) != 0;
#line 1800 "../src/Photo.vala"
								_g_free0 (_tmp28_);
#line 1800 "../src/Photo.vala"
								_g_free0 (_tmp26_);
#line 11360 "Photo.c"
							} else {
#line 1799 "../src/Photo.vala"
								_tmp21_ = FALSE;
#line 11364 "Photo.c"
							}
#line 1799 "../src/Photo.vala"
							name_changed = _tmp21_;
#line 11368 "Photo.c"
						}
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* _lock_error_ = NULL;
						GError* _tmp29_;
#line 1787 "../src/Photo.vala"
						_lock_error_ = _inner_error0_;
#line 1787 "../src/Photo.vala"
						_inner_error0_ = NULL;
#line 1787 "../src/Photo.vala"
						_tmp29_ = _lock_error_;
#line 1787 "../src/Photo.vala"
						_lock_error_ = NULL;
#line 1787 "../src/Photo.vala"
						_inner_error0_ = _tmp29_;
#line 1787 "../src/Photo.vala"
						_g_error_free0 (_lock_error_);
#line 11388 "Photo.c"
						goto __finally2;
					}
					__finally2:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp30_;
#line 1787 "../src/Photo.vala"
						_tmp30_ = self->priv->readers;
#line 1787 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 11399 "Photo.c"
					}
#line 1787 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11403 "Photo.c"
						goto __catch1_g_error;
					}
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* _lock_error_ = NULL;
				GError* _tmp31_;
#line 1786 "../src/Photo.vala"
				_lock_error_ = _inner_error0_;
#line 1786 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 1786 "../src/Photo.vala"
				_tmp31_ = _lock_error_;
#line 1786 "../src/Photo.vala"
				_lock_error_ = NULL;
#line 1786 "../src/Photo.vala"
				_inner_error0_ = _tmp31_;
#line 1786 "../src/Photo.vala"
				_g_error_free0 (_lock_error_);
#line 11425 "Photo.c"
				goto __finally1;
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp32_;
#line 1786 "../src/Photo.vala"
				_tmp32_ = self->row;
#line 1786 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11436 "Photo.c"
			}
#line 1786 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1786 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 11442 "Photo.c"
					goto __catch0_database_error;
				}
				goto __finally0;
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp33_;
#line 1785 "../src/Photo.vala"
		err = _inner_error0_;
#line 1785 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1805 "../src/Photo.vala"
		_tmp33_ = err;
#line 1805 "../src/Photo.vala"
		app_window_database_error (_tmp33_);
#line 1785 "../src/Photo.vala"
		_g_error_free0 (err);
#line 11464 "Photo.c"
	}
	__finally0:
#line 1785 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1785 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1785 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1785 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1785 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1785 "../src/Photo.vala"
		return;
#line 11479 "Photo.c"
	}
#line 1808 "../src/Photo.vala"
	if (altered) {
#line 11483 "Photo.c"
		GFile* _tmp34_;
		gchar** alteration_list = NULL;
		gchar** _tmp35_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar* _tmp36_;
		gchar** _tmp40_;
		gint _tmp40__length1;
		Alteration* _tmp41_;
		Alteration* _tmp42_;
#line 1809 "../src/Photo.vala"
		_tmp34_ = old_file;
#line 1809 "../src/Photo.vala"
		media_source_notify_master_replaced ((MediaSource*) self, _tmp34_, file);
#line 1811 "../src/Photo.vala"
		if (is_baseline) {
#line 1812 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 11502 "Photo.c"
		}
#line 1815 "../src/Photo.vala"
		_tmp35_ = g_new0 (gchar*, 0 + 1);
#line 1815 "../src/Photo.vala"
		alteration_list = _tmp35_;
#line 1815 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1815 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1816 "../src/Photo.vala"
		_tmp36_ = g_strdup ("backing:master");
#line 1816 "../src/Photo.vala"
		_vala_array_add17 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp36_);
#line 1820 "../src/Photo.vala"
		if (name_changed) {
#line 11518 "Photo.c"
			gchar* _tmp37_;
#line 1821 "../src/Photo.vala"
			_tmp37_ = g_strdup ("metadata:name");
#line 1821 "../src/Photo.vala"
			_vala_array_add18 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp37_);
#line 11524 "Photo.c"
		}
#line 1824 "../src/Photo.vala"
		if (is_source) {
#line 11528 "Photo.c"
			gchar* _tmp38_;
#line 1825 "../src/Photo.vala"
			_tmp38_ = g_strdup ("backing:source");
#line 1825 "../src/Photo.vala"
			_vala_array_add19 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp38_);
#line 11534 "Photo.c"
		}
#line 1828 "../src/Photo.vala"
		if (is_baseline) {
#line 11538 "Photo.c"
			gchar* _tmp39_;
#line 1829 "../src/Photo.vala"
			_tmp39_ = g_strdup ("backing:baseline");
#line 1829 "../src/Photo.vala"
			_vala_array_add20 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp39_);
#line 11544 "Photo.c"
		}
#line 1832 "../src/Photo.vala"
		_tmp40_ = alteration_list;
#line 1832 "../src/Photo.vala"
		_tmp40__length1 = alteration_list_length1;
#line 1832 "../src/Photo.vala"
		_tmp41_ = alteration_new_from_array (_tmp40_, _tmp40__length1);
#line 1832 "../src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 1832 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp42_);
#line 1832 "../src/Photo.vala"
		_alteration_unref0 (_tmp42_);
#line 1808 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 11560 "Photo.c"
	}
#line 1777 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1777 "../src/Photo.vala"
	_g_free0 (filepath);
#line 11566 "Photo.c"
}

static void
_vala_array_add21 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1873 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1873 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1873 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11581 "Photo.c"
	}
#line 1873 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1873 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11587 "Photo.c"
}

static void
_vala_array_add22 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1876 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1876 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1876 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11602 "Photo.c"
	}
#line 1876 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1876 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11608 "Photo.c"
}

static void
_vala_array_add23 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1880 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1880 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1880 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11623 "Photo.c"
	}
#line 1880 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1880 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11629 "Photo.c"
}

void
photo_set_editable_file (Photo* self,
                         GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	GError* _inner_error0_ = NULL;
#line 1838 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1838 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1839 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1839 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1841 "../src/Photo.vala"
	altered = FALSE;
#line 1842 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1843 "../src/Photo.vala"
	is_source = FALSE;
#line 1844 "../src/Photo.vala"
	old_file = NULL;
#line 11659 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1846 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1846 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 11667 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1847 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1847 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 11675 "Photo.c"
					{
						GFile* _tmp3_ = NULL;
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp9_;
						gboolean _tmp10_ = FALSE;
						GFile* _tmp11_;
#line 1848 "../src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1848 "../src/Photo.vala"
						_tmp5_ = _tmp4_->editable;
#line 1848 "../src/Photo.vala"
						if (_tmp5_ != NULL) {
#line 11689 "Photo.c"
							PhotoBackingReaders* _tmp6_;
							PhotoFileReader* _tmp7_;
							GFile* _tmp8_;
#line 1848 "../src/Photo.vala"
							_tmp6_ = self->priv->readers;
#line 1848 "../src/Photo.vala"
							_tmp7_ = _tmp6_->editable;
#line 1848 "../src/Photo.vala"
							_tmp8_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp7_);
#line 1848 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1848 "../src/Photo.vala"
							_tmp3_ = _tmp8_;
#line 11703 "Photo.c"
						} else {
#line 1848 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1848 "../src/Photo.vala"
							_tmp3_ = NULL;
#line 11709 "Photo.c"
						}
#line 1848 "../src/Photo.vala"
						_tmp9_ = _g_object_ref0 (_tmp3_);
#line 1848 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1848 "../src/Photo.vala"
						old_file = _tmp9_;
#line 1849 "../src/Photo.vala"
						_tmp11_ = old_file;
#line 1849 "../src/Photo.vala"
						if (_tmp11_ != NULL) {
#line 11721 "Photo.c"
							GFile* _tmp12_;
#line 1849 "../src/Photo.vala"
							_tmp12_ = old_file;
#line 1849 "../src/Photo.vala"
							_tmp10_ = !g_file_equal (_tmp12_, file);
#line 11727 "Photo.c"
						} else {
#line 1849 "../src/Photo.vala"
							_tmp10_ = FALSE;
#line 11731 "Photo.c"
						}
#line 1849 "../src/Photo.vala"
						if (_tmp10_) {
#line 11735 "Photo.c"
							BackingPhotoTable* _tmp13_;
							BackingPhotoTable* _tmp14_;
							PhotoRow* _tmp15_;
							BackingPhotoID _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							gchar* _tmp20_;
							PhotoBackingReaders* _tmp21_;
							BackingPhotoRow* _tmp22_;
							const gchar* _tmp23_;
							PhotoFileReader* _tmp24_;
#line 1850 "../src/Photo.vala"
							_tmp13_ = backing_photo_table_get_instance ();
#line 1850 "../src/Photo.vala"
							_tmp14_ = _tmp13_;
#line 1850 "../src/Photo.vala"
							_tmp15_ = self->row;
#line 1850 "../src/Photo.vala"
							_tmp16_ = _tmp15_->editable_id;
#line 1850 "../src/Photo.vala"
							_tmp17_ = filepath;
#line 1850 "../src/Photo.vala"
							backing_photo_table_set_filepath (_tmp14_, &_tmp16_, _tmp17_, &_inner_error0_);
#line 1850 "../src/Photo.vala"
							_database_table_unref0 (_tmp14_);
#line 1850 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1850 "../src/Photo.vala"
								_g_object_unref0 (_tmp3_);
#line 11766 "Photo.c"
								goto __catch2_g_error;
							}
#line 1852 "../src/Photo.vala"
							_tmp18_ = self->priv->editable;
#line 1852 "../src/Photo.vala"
							_tmp19_ = filepath;
#line 1852 "../src/Photo.vala"
							_tmp20_ = g_strdup (_tmp19_);
#line 1852 "../src/Photo.vala"
							_g_free0 (_tmp18_->filepath);
#line 1852 "../src/Photo.vala"
							_tmp18_->filepath = _tmp20_;
#line 1853 "../src/Photo.vala"
							_tmp21_ = self->priv->readers;
#line 1853 "../src/Photo.vala"
							_tmp22_ = self->priv->editable;
#line 1853 "../src/Photo.vala"
							_tmp23_ = filepath;
#line 1853 "../src/Photo.vala"
							_tmp24_ = photo_file_format_create_reader (_tmp22_->file_format, _tmp23_);
#line 1853 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp21_->editable);
#line 1853 "../src/Photo.vala"
							_tmp21_->editable = _tmp24_;
#line 1855 "../src/Photo.vala"
							altered = TRUE;
#line 1856 "../src/Photo.vala"
							is_baseline = photo_is_editable_baseline (self);
#line 1857 "../src/Photo.vala"
							is_source = photo_is_editable_source (self);
#line 11797 "Photo.c"
						}
#line 1847 "../src/Photo.vala"
						_g_object_unref0 (_tmp3_);
#line 11801 "Photo.c"
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* _lock_error_ = NULL;
						GError* _tmp25_;
#line 1847 "../src/Photo.vala"
						_lock_error_ = _inner_error0_;
#line 1847 "../src/Photo.vala"
						_inner_error0_ = NULL;
#line 1847 "../src/Photo.vala"
						_tmp25_ = _lock_error_;
#line 1847 "../src/Photo.vala"
						_lock_error_ = NULL;
#line 1847 "../src/Photo.vala"
						_inner_error0_ = _tmp25_;
#line 1847 "../src/Photo.vala"
						_g_error_free0 (_lock_error_);
#line 11820 "Photo.c"
						goto __finally2;
					}
					__finally2:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp26_;
#line 1847 "../src/Photo.vala"
						_tmp26_ = self->priv->readers;
#line 1847 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 11831 "Photo.c"
					}
#line 1847 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11835 "Photo.c"
						goto __catch1_g_error;
					}
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* _lock_error_ = NULL;
				GError* _tmp27_;
#line 1846 "../src/Photo.vala"
				_lock_error_ = _inner_error0_;
#line 1846 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 1846 "../src/Photo.vala"
				_tmp27_ = _lock_error_;
#line 1846 "../src/Photo.vala"
				_lock_error_ = NULL;
#line 1846 "../src/Photo.vala"
				_inner_error0_ = _tmp27_;
#line 1846 "../src/Photo.vala"
				_g_error_free0 (_lock_error_);
#line 11857 "Photo.c"
				goto __finally1;
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp28_;
#line 1846 "../src/Photo.vala"
				_tmp28_ = self->row;
#line 1846 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11868 "Photo.c"
			}
#line 1846 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1846 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 11874 "Photo.c"
					goto __catch0_database_error;
				}
				goto __finally0;
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp29_;
#line 1845 "../src/Photo.vala"
		err = _inner_error0_;
#line 1845 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1862 "../src/Photo.vala"
		_tmp29_ = err;
#line 1862 "../src/Photo.vala"
		app_window_database_error (_tmp29_);
#line 1845 "../src/Photo.vala"
		_g_error_free0 (err);
#line 11896 "Photo.c"
	}
	__finally0:
#line 1845 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1845 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1845 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1845 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1845 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1845 "../src/Photo.vala"
		return;
#line 11911 "Photo.c"
	}
#line 1865 "../src/Photo.vala"
	if (altered) {
#line 11915 "Photo.c"
		GFile* _tmp30_;
		gchar** alteration_list = NULL;
		gchar** _tmp31_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar* _tmp32_;
		gchar** _tmp35_;
		gint _tmp35__length1;
		Alteration* _tmp36_;
		Alteration* _tmp37_;
#line 1866 "../src/Photo.vala"
		_tmp30_ = old_file;
#line 1866 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, file);
#line 1868 "../src/Photo.vala"
		if (is_baseline) {
#line 1869 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 11934 "Photo.c"
		}
#line 1872 "../src/Photo.vala"
		_tmp31_ = g_new0 (gchar*, 0 + 1);
#line 1872 "../src/Photo.vala"
		alteration_list = _tmp31_;
#line 1872 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1872 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1873 "../src/Photo.vala"
		_tmp32_ = g_strdup ("backing:editable");
#line 1873 "../src/Photo.vala"
		_vala_array_add21 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp32_);
#line 1875 "../src/Photo.vala"
		if (is_baseline) {
#line 11950 "Photo.c"
			gchar* _tmp33_;
#line 1876 "../src/Photo.vala"
			_tmp33_ = g_strdup ("backing:baseline");
#line 1876 "../src/Photo.vala"
			_vala_array_add22 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp33_);
#line 11956 "Photo.c"
		}
#line 1879 "../src/Photo.vala"
		if (is_source) {
#line 11960 "Photo.c"
			gchar* _tmp34_;
#line 1880 "../src/Photo.vala"
			_tmp34_ = g_strdup ("backing:source");
#line 1880 "../src/Photo.vala"
			_vala_array_add23 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp34_);
#line 11966 "Photo.c"
		}
#line 1883 "../src/Photo.vala"
		_tmp35_ = alteration_list;
#line 1883 "../src/Photo.vala"
		_tmp35__length1 = alteration_list_length1;
#line 1883 "../src/Photo.vala"
		_tmp36_ = alteration_new_from_array (_tmp35_, _tmp35__length1);
#line 1883 "../src/Photo.vala"
		_tmp37_ = _tmp36_;
#line 1883 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp37_);
#line 1883 "../src/Photo.vala"
		_alteration_unref0 (_tmp37_);
#line 1865 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 11982 "Photo.c"
	}
#line 1838 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1838 "../src/Photo.vala"
	_g_free0 (filepath);
#line 11988 "Photo.c"
}

void
photo_set_many_editable_file (GeeMap* map,
                              GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1888 "../src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1889 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 1891 "../src/Photo.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 1891 "../src/Photo.vala"
	map_iter = _tmp0_;
#line 1892 "../src/Photo.vala"
	while (TRUE) {
#line 12008 "Photo.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Photo* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 1892 "../src/Photo.vala"
		_tmp1_ = map_iter;
#line 1892 "../src/Photo.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 1892 "../src/Photo.vala"
			break;
#line 12022 "Photo.c"
		}
#line 1893 "../src/Photo.vala"
		_tmp2_ = map_iter;
#line 1893 "../src/Photo.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 1893 "../src/Photo.vala"
		_tmp4_ = (Photo*) _tmp3_;
#line 1893 "../src/Photo.vala"
		_tmp5_ = map_iter;
#line 1893 "../src/Photo.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 1893 "../src/Photo.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 1893 "../src/Photo.vala"
		photo_set_editable_file (_tmp4_, _tmp7_);
#line 1893 "../src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 1893 "../src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 12042 "Photo.c"
	}
#line 1896 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1896 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1896 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1896 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1896 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1896 "../src/Photo.vala"
			return;
#line 12056 "Photo.c"
		} else {
#line 1896 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1896 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1896 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1896 "../src/Photo.vala"
			return;
#line 12066 "Photo.c"
		}
	}
#line 1888 "../src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 12071 "Photo.c"
}

GFile*
photo_get_actual_file (Photo* self)
{
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 1901 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1902 "../src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1902 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1902 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1902 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1902 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1902 "../src/Photo.vala"
	result = _tmp3_;
#line 1902 "../src/Photo.vala"
	return result;
#line 12098 "Photo.c"
}

static GFile*
photo_real_get_master_file (MediaSource* base)
{
	Photo * self;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 1905 "../src/Photo.vala"
	self = (Photo*) base;
#line 1906 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1906 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1906 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1906 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1906 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1906 "../src/Photo.vala"
	result = _tmp3_;
#line 1906 "../src/Photo.vala"
	return result;
#line 12126 "Photo.c"
}

GFile*
photo_get_editable_file (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GFile* result;
#line 1909 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1910 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1910 "../src/Photo.vala"
	reader = _tmp0_;
#line 1912 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1912 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 12147 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_;
#line 1912 "../src/Photo.vala"
		_tmp3_ = reader;
#line 1912 "../src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp3_);
#line 1912 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1912 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 12158 "Photo.c"
	} else {
#line 1912 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1912 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 12164 "Photo.c"
	}
#line 1912 "../src/Photo.vala"
	result = _tmp1_;
#line 1912 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1912 "../src/Photo.vala"
	return result;
#line 12172 "Photo.c"
}

GeeCollection*
photo_get_raw_developer_files (Photo* self)
{
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 1915 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1916 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1917 "../src/Photo.vala"
		result = NULL;
#line 1917 "../src/Photo.vala"
		return result;
#line 12190 "Photo.c"
	}
#line 1920 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1920 "../src/Photo.vala"
	ret = _tmp0_;
#line 12196 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1921 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 1921 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12203 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 1922 "../src/Photo.vala"
				_tmp2_ = self->priv->developments;
#line 1922 "../src/Photo.vala"
				_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 1922 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 1922 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1922 "../src/Photo.vala"
				_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 1922 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1922 "../src/Photo.vala"
				_g_object_unref0 (_tmp5_);
#line 1922 "../src/Photo.vala"
				_row_it = _tmp7_;
#line 1922 "../src/Photo.vala"
				while (TRUE) {
#line 12231 "Photo.c"
					GeeIterator* _tmp8_;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					GeeArrayList* _tmp11_;
					BackingPhotoRow* _tmp12_;
					const gchar* _tmp13_;
					GFile* _tmp14_;
					GFile* _tmp15_;
#line 1922 "../src/Photo.vala"
					_tmp8_ = _row_it;
#line 1922 "../src/Photo.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 1922 "../src/Photo.vala"
						break;
#line 12247 "Photo.c"
					}
#line 1922 "../src/Photo.vala"
					_tmp9_ = _row_it;
#line 1922 "../src/Photo.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 1922 "../src/Photo.vala"
					row = (BackingPhotoRow*) _tmp10_;
#line 1923 "../src/Photo.vala"
					_tmp11_ = ret;
#line 1923 "../src/Photo.vala"
					_tmp12_ = row;
#line 1923 "../src/Photo.vala"
					_tmp13_ = _tmp12_->filepath;
#line 1923 "../src/Photo.vala"
					_tmp14_ = g_file_new_for_path (_tmp13_);
#line 1923 "../src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 1923 "../src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp15_);
#line 1923 "../src/Photo.vala"
					_g_object_unref0 (_tmp15_);
#line 1922 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 12271 "Photo.c"
				}
#line 1922 "../src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 12275 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp16_;
#line 1921 "../src/Photo.vala"
			_tmp16_ = self->row;
#line 1921 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12285 "Photo.c"
		}
#line 1921 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1921 "../src/Photo.vala"
			_g_object_unref0 (ret);
#line 1921 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1921 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1921 "../src/Photo.vala"
			return NULL;
#line 12297 "Photo.c"
		}
	}
#line 1926 "../src/Photo.vala"
	result = (GeeCollection*) ret;
#line 1926 "../src/Photo.vala"
	return result;
#line 12304 "Photo.c"
}

GFile*
photo_get_source_file (Photo* self)
{
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 1929 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1930 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1930 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1930 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1930 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1930 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1930 "../src/Photo.vala"
	result = _tmp3_;
#line 1930 "../src/Photo.vala"
	return result;
#line 12331 "Photo.c"
}

PhotoFileFormat
photo_get_file_format (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileFormat result;
#line 1933 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 12341 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1934 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1934 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12348 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 1935 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1935 "../src/Photo.vala"
			result = _tmp1_->file_format;
#line 12355 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 1934 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1934 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12362 "Photo.c"
			}
#line 1935 "../src/Photo.vala"
			return result;
#line 12366 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 1934 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1934 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12375 "Photo.c"
		}
#line 1934 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1934 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1934 "../src/Photo.vala"
		return 0;
#line 12383 "Photo.c"
	}
}

PhotoFileFormat
photo_get_best_export_file_format (Photo* self)
{
	PhotoFileFormat file_format = 0;
	PhotoFileFormat result;
#line 1939 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1940 "../src/Photo.vala"
	file_format = photo_get_file_format (self);
#line 1941 "../src/Photo.vala"
	if (!photo_file_format_can_write (file_format)) {
#line 1942 "../src/Photo.vala"
		file_format = photo_file_format_get_system_default_format ();
#line 12400 "Photo.c"
	}
#line 1945 "../src/Photo.vala"
	result = file_format;
#line 1945 "../src/Photo.vala"
	return result;
#line 12406 "Photo.c"
}

PhotoFileFormat
photo_get_master_file_format (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileFormat result;
#line 1948 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 12416 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1949 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1949 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12423 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1950 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1950 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1950 "../src/Photo.vala"
			result = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 12433 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1949 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1949 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12440 "Photo.c"
			}
#line 1950 "../src/Photo.vala"
			return result;
#line 12444 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 1949 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1949 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12453 "Photo.c"
		}
#line 1949 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1949 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1949 "../src/Photo.vala"
		return 0;
#line 12461 "Photo.c"
	}
}

static gint64
photo_real_get_timestamp (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 1954 "../src/Photo.vala"
	self = (Photo*) base;
#line 12473 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gint64 _tmp4_ = -1LL;
#line 1955 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1955 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12481 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 1956 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1956 "../src/Photo.vala"
			result = _tmp1_->timestamp;
#line 12488 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 1955 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1955 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12495 "Photo.c"
			}
#line 1956 "../src/Photo.vala"
			return result;
#line 12499 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 1955 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1955 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12508 "Photo.c"
		}
#line 1955 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1955 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1955 "../src/Photo.vala"
		return _tmp4_;
#line 12516 "Photo.c"
	}
}

void
photo_get_photo_id (Photo* self,
                    PhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 1960 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 12527 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1961 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1961 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12534 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 1962 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1962 "../src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 1962 "../src/Photo.vala"
			*result = _tmp2_;
#line 12544 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1961 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1961 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12551 "Photo.c"
			}
#line 1962 "../src/Photo.vala"
			return;
#line 12555 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 1961 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1961 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12564 "Photo.c"
		}
#line 1961 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1961 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1961 "../src/Photo.vala"
		return;
#line 12572 "Photo.c"
	}
}

static inline void
photo_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 1967 "../src/Photo.vala"
	self = (Photo*) base;
#line 1968 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 1968 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1968 "../src/Photo.vala"
	*result = _tmp1_;
#line 1968 "../src/Photo.vala"
	return;
#line 12593 "Photo.c"
}

inline gint64
photo_get_raw_event_id (Photo* self)
{
	PhotoRow* _tmp0_;
	EventID _tmp1_;
	gint64 result;
#line 1972 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1973 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 1973 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1973 "../src/Photo.vala"
	result = _tmp1_.id;
#line 1973 "../src/Photo.vala"
	return result;
#line 12612 "Photo.c"
}

static void
photo_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 1976 "../src/Photo.vala"
	self = (Photo*) base;
#line 12623 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1977 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1977 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12630 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 1978 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1978 "../src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 1978 "../src/Photo.vala"
			*result = _tmp2_;
#line 12640 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1977 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1977 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12647 "Photo.c"
			}
#line 1978 "../src/Photo.vala"
			return;
#line 12651 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 1977 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1977 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12660 "Photo.c"
		}
#line 1977 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1977 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1977 "../src/Photo.vala"
		return;
#line 12668 "Photo.c"
	}
}

void
photo_get_editable_id (Photo* self,
                       BackingPhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 1982 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 12679 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1983 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1983 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12686 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 1984 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1984 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 1984 "../src/Photo.vala"
			*result = _tmp2_;
#line 12696 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1983 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1983 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12703 "Photo.c"
			}
#line 1984 "../src/Photo.vala"
			return;
#line 12707 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 1983 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1983 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12716 "Photo.c"
		}
#line 1983 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1983 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1983 "../src/Photo.vala"
		return;
#line 12724 "Photo.c"
	}
}

static gchar*
photo_real_get_master_md5 (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1988 "../src/Photo.vala"
	self = (Photo*) base;
#line 12736 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1989 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1989 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12743 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 1990 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1990 "../src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 1990 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1990 "../src/Photo.vala"
			result = _tmp3_;
#line 12756 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1989 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 1989 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12763 "Photo.c"
			}
#line 1990 "../src/Photo.vala"
			return result;
#line 12767 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 1989 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1989 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12776 "Photo.c"
		}
#line 1989 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1989 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1989 "../src/Photo.vala"
		return NULL;
#line 12784 "Photo.c"
	}
}

guint64
photo_get_flags (Photo* self)
{
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 1996 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 12795 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 1997 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1997 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12803 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 1998 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1998 "../src/Photo.vala"
			result = _tmp1_->flags;
#line 12810 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 1997 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1997 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12817 "Photo.c"
			}
#line 1998 "../src/Photo.vala"
			return result;
#line 12821 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 1997 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1997 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12830 "Photo.c"
		}
#line 1997 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1997 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1997 "../src/Photo.vala"
		return _tmp4_;
#line 12838 "Photo.c"
	}
}

static void
photo_notify_flags_altered (Photo* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
#line 2002 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2003 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 2003 "../src/Photo.vala"
	alteration = _tmp0_;
#line 2004 "../src/Photo.vala"
	if (additional_alteration != NULL) {
#line 12857 "Photo.c"
		Alteration* _tmp1_;
		Alteration* _tmp2_;
#line 2005 "../src/Photo.vala"
		_tmp1_ = alteration;
#line 2005 "../src/Photo.vala"
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
#line 2005 "../src/Photo.vala"
		_alteration_unref0 (alteration);
#line 2005 "../src/Photo.vala"
		alteration = _tmp2_;
#line 12868 "Photo.c"
	}
#line 2008 "../src/Photo.vala"
	_tmp3_ = alteration;
#line 2008 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp3_);
#line 2002 "../src/Photo.vala"
	_alteration_unref0 (alteration);
#line 12876 "Photo.c"
}

guint64
photo_replace_flags (Photo* self,
                     guint64 flags,
                     Alteration* additional_alteration)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2011 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 12889 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2013 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2013 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12896 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
#line 2014 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2014 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2014 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 2014 "../src/Photo.vala"
			committed = photo_table_replace_flags (_tmp2_, &_tmp3_, flags);
#line 2014 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2015 "../src/Photo.vala"
			if (committed) {
#line 12913 "Photo.c"
				PhotoRow* _tmp4_;
#line 2016 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2016 "../src/Photo.vala"
				_tmp4_->flags = flags;
#line 12919 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2013 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2013 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12929 "Photo.c"
		}
#line 2013 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12933 "Photo.c"
			guint64 _tmp6_ = 0ULL;
#line 2013 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2013 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2013 "../src/Photo.vala"
			return _tmp6_;
#line 12941 "Photo.c"
		}
	}
#line 2020 "../src/Photo.vala"
	if (committed) {
#line 2021 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 12948 "Photo.c"
	}
#line 2024 "../src/Photo.vala"
	result = flags;
#line 2024 "../src/Photo.vala"
	return result;
#line 12954 "Photo.c"
}

gboolean
photo_is_flag_set (Photo* self,
                   guint64 mask)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2027 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 12965 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2028 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2028 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12973 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2029 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2029 "../src/Photo.vala"
			result = media_source_internal_is_flag_set (_tmp1_->flags, mask);
#line 12980 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2028 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2028 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12987 "Photo.c"
			}
#line 2029 "../src/Photo.vala"
			return result;
#line 12991 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2028 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2028 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13000 "Photo.c"
		}
#line 2028 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2028 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2028 "../src/Photo.vala"
		return _tmp4_;
#line 13008 "Photo.c"
	}
}

guint64
photo_add_flags (Photo* self,
                 guint64 mask,
                 Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2033 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2034 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2036 "../src/Photo.vala"
	committed = FALSE;
#line 13027 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2037 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2037 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13034 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2038 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2038 "../src/Photo.vala"
			flags = media_source_internal_add_flags (_tmp1_->flags, mask);
#line 2039 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2039 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 13046 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2040 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2040 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2040 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2040 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2040 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2041 "../src/Photo.vala"
				if (committed) {
#line 13062 "Photo.c"
					PhotoRow* _tmp6_;
#line 2042 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2042 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 13068 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2037 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2037 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13079 "Photo.c"
		}
#line 2037 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13083 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2037 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2037 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2037 "../src/Photo.vala"
			return _tmp8_;
#line 13091 "Photo.c"
		}
	}
#line 2047 "../src/Photo.vala"
	if (committed) {
#line 2048 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 13098 "Photo.c"
	}
#line 2051 "../src/Photo.vala"
	result = flags;
#line 2051 "../src/Photo.vala"
	return result;
#line 13104 "Photo.c"
}

guint64
photo_remove_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2054 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2055 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2057 "../src/Photo.vala"
	committed = FALSE;
#line 13122 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2058 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2058 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13129 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2059 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2059 "../src/Photo.vala"
			flags = media_source_internal_remove_flags (_tmp1_->flags, mask);
#line 2060 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2060 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 13141 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2061 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2061 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2061 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2061 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2061 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2062 "../src/Photo.vala"
				if (committed) {
#line 13157 "Photo.c"
					PhotoRow* _tmp6_;
#line 2063 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2063 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 13163 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2058 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2058 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13174 "Photo.c"
		}
#line 2058 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13178 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2058 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2058 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2058 "../src/Photo.vala"
			return _tmp8_;
#line 13186 "Photo.c"
		}
	}
#line 2068 "../src/Photo.vala"
	if (committed) {
#line 2069 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 13193 "Photo.c"
	}
#line 2072 "../src/Photo.vala"
	result = flags;
#line 2072 "../src/Photo.vala"
	return result;
#line 13199 "Photo.c"
}

guint64
photo_add_remove_flags (Photo* self,
                        guint64 add,
                        guint64 remove,
                        Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2075 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2076 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2078 "../src/Photo.vala"
	committed = FALSE;
#line 13218 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2079 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2079 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13225 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2080 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2080 "../src/Photo.vala"
			flags = (_tmp1_->flags | add) & (~remove);
#line 2081 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2081 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 13237 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2082 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2082 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2082 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2082 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2082 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2083 "../src/Photo.vala"
				if (committed) {
#line 13253 "Photo.c"
					PhotoRow* _tmp6_;
#line 2084 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2084 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 13259 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2079 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2079 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13270 "Photo.c"
		}
#line 2079 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13274 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2079 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2079 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2079 "../src/Photo.vala"
			return _tmp8_;
#line 13282 "Photo.c"
		}
	}
#line 2089 "../src/Photo.vala"
	if (committed) {
#line 2090 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 13289 "Photo.c"
	}
#line 2093 "../src/Photo.vala"
	result = flags;
#line 2093 "../src/Photo.vala"
	return result;
#line 13295 "Photo.c"
}

void
photo_add_remove_many_flags (GeeCollection* add,
                             guint64 add_mask,
                             Alteration* additional_add_alteration,
                             GeeCollection* remove,
                             guint64 remove_mask,
                             Alteration* additional_remove_alteration,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2099 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 2101 "../src/Photo.vala"
	if (add != NULL) {
#line 13312 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp0_;
#line 2102 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) add);
#line 2102 "../src/Photo.vala"
			_photo_it = _tmp0_;
#line 2102 "../src/Photo.vala"
			while (TRUE) {
#line 13322 "Photo.c"
				GeeIterator* _tmp1_;
				Photo* photo = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Photo* _tmp4_;
#line 2102 "../src/Photo.vala"
				_tmp1_ = _photo_it;
#line 2102 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 2102 "../src/Photo.vala"
					break;
#line 13334 "Photo.c"
				}
#line 2102 "../src/Photo.vala"
				_tmp2_ = _photo_it;
#line 2102 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 2102 "../src/Photo.vala"
				photo = (Photo*) _tmp3_;
#line 2103 "../src/Photo.vala"
				_tmp4_ = photo;
#line 2103 "../src/Photo.vala"
				photo_add_flags (_tmp4_, add_mask, additional_add_alteration);
#line 2102 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 13348 "Photo.c"
			}
#line 2102 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 13352 "Photo.c"
		}
	}
#line 2107 "../src/Photo.vala"
	if (remove != NULL) {
#line 13357 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp5_;
#line 2108 "../src/Photo.vala"
			_tmp5_ = gee_iterable_iterator ((GeeIterable*) remove);
#line 2108 "../src/Photo.vala"
			_photo_it = _tmp5_;
#line 2108 "../src/Photo.vala"
			while (TRUE) {
#line 13367 "Photo.c"
				GeeIterator* _tmp6_;
				Photo* photo = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Photo* _tmp9_;
#line 2108 "../src/Photo.vala"
				_tmp6_ = _photo_it;
#line 2108 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 2108 "../src/Photo.vala"
					break;
#line 13379 "Photo.c"
				}
#line 2108 "../src/Photo.vala"
				_tmp7_ = _photo_it;
#line 2108 "../src/Photo.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 2108 "../src/Photo.vala"
				photo = (Photo*) _tmp8_;
#line 2109 "../src/Photo.vala"
				_tmp9_ = photo;
#line 2109 "../src/Photo.vala"
				photo_remove_flags (_tmp9_, remove_mask, additional_remove_alteration);
#line 2108 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 13393 "Photo.c"
			}
#line 2108 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 13397 "Photo.c"
		}
	}
#line 2113 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 2113 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2113 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2113 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2113 "../src/Photo.vala"
			return;
#line 13410 "Photo.c"
		} else {
#line 2113 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2113 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2113 "../src/Photo.vala"
			return;
#line 13418 "Photo.c"
		}
	}
}

guint64
photo_toggle_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2116 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2117 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2119 "../src/Photo.vala"
	committed = FALSE;
#line 13438 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2120 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2120 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13445 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2121 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2121 "../src/Photo.vala"
			flags = _tmp1_->flags ^ mask;
#line 2122 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2122 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 13457 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2123 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2123 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2123 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2123 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2123 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2124 "../src/Photo.vala"
				if (committed) {
#line 13473 "Photo.c"
					PhotoRow* _tmp6_;
#line 2125 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2125 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 13479 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2120 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2120 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13490 "Photo.c"
		}
#line 2120 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13494 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2120 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2120 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2120 "../src/Photo.vala"
			return _tmp8_;
#line 13502 "Photo.c"
		}
	}
#line 2130 "../src/Photo.vala"
	if (committed) {
#line 2131 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 13509 "Photo.c"
	}
#line 2134 "../src/Photo.vala"
	result = flags;
#line 2134 "../src/Photo.vala"
	return result;
#line 13515 "Photo.c"
}

gboolean
photo_is_master_metadata_dirty (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2137 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 13525 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2138 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2138 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13533 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2139 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2139 "../src/Photo.vala"
			result = _tmp1_->metadata_dirty;
#line 13540 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2138 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2138 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13547 "Photo.c"
			}
#line 2139 "../src/Photo.vala"
			return result;
#line 13551 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2138 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2138 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13560 "Photo.c"
		}
#line 2138 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2138 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2138 "../src/Photo.vala"
		return _tmp4_;
#line 13568 "Photo.c"
	}
}

void
photo_set_master_metadata_dirty (Photo* self,
                                 gboolean dirty,
                                 GError** error)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2143 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2144 "../src/Photo.vala"
	committed = FALSE;
#line 13583 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2145 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2145 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13590 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2146 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2146 "../src/Photo.vala"
			if (_tmp1_->metadata_dirty != dirty) {
#line 13597 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoID _tmp4_ = {0};
				PhotoRow* _tmp5_;
#line 2147 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2147 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2147 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp4_);
#line 2147 "../src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp3_, &_tmp4_, dirty, &_inner_error0_);
#line 2147 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2147 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13614 "Photo.c"
					goto __catch0_g_error;
				}
#line 2148 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2148 "../src/Photo.vala"
				_tmp5_->metadata_dirty = dirty;
#line 2149 "../src/Photo.vala"
				committed = TRUE;
#line 13623 "Photo.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp6_;
#line 2145 "../src/Photo.vala"
			_lock_error_ = _inner_error0_;
#line 2145 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 2145 "../src/Photo.vala"
			_tmp6_ = _lock_error_;
#line 2145 "../src/Photo.vala"
			_lock_error_ = NULL;
#line 2145 "../src/Photo.vala"
			_inner_error0_ = _tmp6_;
#line 2145 "../src/Photo.vala"
			_g_error_free0 (_lock_error_);
#line 13643 "Photo.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp7_;
#line 2145 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2145 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13654 "Photo.c"
		}
#line 2145 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2145 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2145 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 2145 "../src/Photo.vala"
				return;
#line 13664 "Photo.c"
			} else {
#line 2145 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2145 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2145 "../src/Photo.vala"
				return;
#line 13672 "Photo.c"
			}
		}
	}
#line 2153 "../src/Photo.vala"
	if (committed) {
#line 13678 "Photo.c"
		Alteration* _tmp8_;
		Alteration* _tmp9_;
#line 2154 "../src/Photo.vala"
		_tmp8_ = alteration_new ("metadata", "master-dirty");
#line 2154 "../src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 2154 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp9_);
#line 2154 "../src/Photo.vala"
		_alteration_unref0 (_tmp9_);
#line 13689 "Photo.c"
	}
}

gboolean
photo_is_enhanced (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2158 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 13700 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2159 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2159 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13708 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2160 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2160 "../src/Photo.vala"
			result = _tmp1_->enhanced;
#line 13715 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2159 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2159 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13722 "Photo.c"
			}
#line 2160 "../src/Photo.vala"
			return result;
#line 13726 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2159 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2159 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13735 "Photo.c"
		}
#line 2159 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2159 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2159 "../src/Photo.vala"
		return _tmp4_;
#line 13743 "Photo.c"
	}
}

void
photo_set_enhanced (Photo* self,
                    gboolean enhanced)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2164 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2165 "../src/Photo.vala"
	committed = FALSE;
#line 13757 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2166 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2166 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13764 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2167 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2167 "../src/Photo.vala"
			if (_tmp1_->enhanced != enhanced) {
#line 13771 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoID _tmp4_ = {0};
#line 2168 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2168 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2168 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp4_);
#line 2168 "../src/Photo.vala"
				committed = photo_table_set_enhanced (_tmp3_, &_tmp4_, enhanced);
#line 2168 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2169 "../src/Photo.vala"
				if (committed) {
#line 13787 "Photo.c"
					PhotoRow* _tmp5_;
#line 2170 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2170 "../src/Photo.vala"
					_tmp5_->enhanced = enhanced;
#line 13793 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 2166 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2166 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13804 "Photo.c"
		}
#line 2166 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2166 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2166 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2166 "../src/Photo.vala"
			return;
#line 13814 "Photo.c"
		}
	}
#line 2175 "../src/Photo.vala"
	if (committed) {
#line 13819 "Photo.c"
		Alteration* _tmp7_;
		Alteration* _tmp8_;
#line 2176 "../src/Photo.vala"
		_tmp7_ = alteration_new ("metadata", "enhanced");
#line 2176 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2176 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp8_);
#line 2176 "../src/Photo.vala"
		_alteration_unref0 (_tmp8_);
#line 13830 "Photo.c"
	}
}

static void
photo_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2180 "../src/Photo.vala"
	self = (Photo*) base;
#line 13843 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 2185 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2185 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2185 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2185 "../src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error0_);
#line 2185 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2185 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2185 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 13862 "Photo.c"
				goto __catch0_database_error;
			}
#line 2185 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2185 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2185 "../src/Photo.vala"
			return;
#line 13871 "Photo.c"
		}
		{
			PhotoRow* _tmp3_;
#line 2186 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2186 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13879 "Photo.c"
			{
				PhotoRow* _tmp4_;
				gchar* _tmp5_;
#line 2187 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2187 "../src/Photo.vala"
				_tmp5_ = g_strdup (backlinks);
#line 2187 "../src/Photo.vala"
				_g_free0 (_tmp4_->backlinks);
#line 2187 "../src/Photo.vala"
				_tmp4_->backlinks = _tmp5_;
#line 13891 "Photo.c"
			}
			__finally1:
			{
				PhotoRow* _tmp6_;
#line 2186 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2186 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13900 "Photo.c"
			}
#line 2186 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2186 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 13906 "Photo.c"
					goto __catch0_database_error;
				}
#line 2186 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2186 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2186 "../src/Photo.vala"
				return;
#line 13915 "Photo.c"
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 2184 "../src/Photo.vala"
		err = _inner_error0_;
#line 2184 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2190 "../src/Photo.vala"
		_tmp7_ = data_object_to_string ((DataObject*) self);
#line 2190 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2190 "../src/Photo.vala"
		_tmp9_ = err;
#line 2190 "../src/Photo.vala"
		_tmp10_ = _tmp9_->message;
#line 2190 "../src/Photo.vala"
		g_warning ("Photo.vala:2190: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
#line 2190 "../src/Photo.vala"
		_g_free0 (_tmp8_);
#line 2184 "../src/Photo.vala"
		_g_error_free0 (err);
#line 13945 "Photo.c"
	}
	__finally0:
#line 2184 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2184 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2184 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2184 "../src/Photo.vala"
		return;
#line 13956 "Photo.c"
	}
}

static gboolean
photo_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2198 "../src/Photo.vala"
	self = (Photo*) base;
#line 2198 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 13971 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp11_ = FALSE;
#line 2199 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2199 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13979 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
#line 2200 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2200 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2200 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2200 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2200 "../src/Photo.vala"
			_tmp5_ = *event_id;
#line 2200 "../src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2200 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2200 "../src/Photo.vala"
			committed = _tmp6_;
#line 2202 "../src/Photo.vala"
			if (committed) {
#line 14006 "Photo.c"
				PhotoRow* _tmp7_;
				EventID _tmp8_;
#line 2203 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2203 "../src/Photo.vala"
				_tmp8_ = *event_id;
#line 2203 "../src/Photo.vala"
				_tmp7_->event_id = _tmp8_;
#line 14015 "Photo.c"
			}
#line 2206 "../src/Photo.vala"
			result = committed;
#line 14019 "Photo.c"
			{
				PhotoRow* _tmp9_;
#line 2199 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2199 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14026 "Photo.c"
			}
#line 2206 "../src/Photo.vala"
			return result;
#line 14030 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp10_;
#line 2199 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 2199 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14039 "Photo.c"
		}
#line 2199 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2199 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2199 "../src/Photo.vala"
		return _tmp11_;
#line 14047 "Photo.c"
	}
}

static gchar*
photo_real_to_string (DataObject* base)
{
	Photo * self;
	gchar* _tmp0_ = NULL;
	PhotoID _tmp9_ = {0};
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileReader* _tmp12_;
	PhotoFileReader* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* result;
#line 2210 "../src/Photo.vala"
	self = (Photo*) base;
#line 2212 "../src/Photo.vala"
	if (!photo_is_master_baseline (self)) {
#line 14070 "Photo.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 2212 "../src/Photo.vala"
		_tmp1_ = photo_get_actual_file (self);
#line 2212 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2212 "../src/Photo.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 2212 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2212 "../src/Photo.vala"
		_tmp5_ = g_strconcat (" (", _tmp4_, NULL);
#line 2212 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2212 "../src/Photo.vala"
		_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
#line 2212 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2212 "../src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 2212 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2212 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2212 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 14102 "Photo.c"
	} else {
		gchar* _tmp8_;
#line 2212 "../src/Photo.vala"
		_tmp8_ = g_strdup ("");
#line 2212 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2212 "../src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 14111 "Photo.c"
	}
#line 2211 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp9_);
#line 2211 "../src/Photo.vala"
	_tmp10_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp9_.id);
#line 2211 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 2211 "../src/Photo.vala"
	_tmp12_ = photo_get_master_reader (self);
#line 2211 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2211 "../src/Photo.vala"
	_tmp14_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp13_);
#line 2211 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 2211 "../src/Photo.vala"
	_tmp16_ = g_strdup_printf ("[%s] %s%s", _tmp11_, _tmp15_, _tmp0_);
#line 2211 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 2211 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 2211 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp13_);
#line 2211 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 2211 "../src/Photo.vala"
	result = _tmp17_;
#line 2211 "../src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2211 "../src/Photo.vala"
	return result;
#line 14143 "Photo.c"
}

static gboolean
photo_real_equals (DataSource* base,
                   DataSource* source)
{
	Photo * self;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
	gboolean result;
#line 2215 "../src/Photo.vala"
	self = (Photo*) base;
#line 2217 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_PHOTO (source) ? ((Photo*) source) : NULL);
#line 2217 "../src/Photo.vala"
	photo = _tmp0_;
#line 2218 "../src/Photo.vala"
	_tmp1_ = photo;
#line 2218 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 14165 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp2_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp3_;
		PhotoID _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		Photo* _tmp6_;
#line 2219 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2219 "../src/Photo.vala"
		photo_id = _tmp2_;
#line 2220 "../src/Photo.vala"
		_tmp3_ = photo;
#line 2220 "../src/Photo.vala"
		photo_get_photo_id (_tmp3_, &_tmp4_);
#line 2220 "../src/Photo.vala"
		other_photo_id = _tmp4_;
#line 2222 "../src/Photo.vala"
		_tmp6_ = photo;
#line 2222 "../src/Photo.vala"
		if (self != _tmp6_) {
#line 14187 "Photo.c"
			PhotoID _tmp7_;
#line 2222 "../src/Photo.vala"
			_tmp7_ = photo_id;
#line 2222 "../src/Photo.vala"
			_tmp5_ = _tmp7_.id != PHOTO_ID_INVALID;
#line 14193 "Photo.c"
		} else {
#line 2222 "../src/Photo.vala"
			_tmp5_ = FALSE;
#line 14197 "Photo.c"
		}
#line 2222 "../src/Photo.vala"
		if (_tmp5_) {
#line 14201 "Photo.c"
			PhotoID _tmp8_;
			PhotoID _tmp9_;
#line 2223 "../src/Photo.vala"
			_tmp8_ = photo_id;
#line 2223 "../src/Photo.vala"
			_tmp9_ = other_photo_id;
#line 2223 "../src/Photo.vala"
			_vala_assert (_tmp8_.id != _tmp9_.id, "photo_id.id != other_photo_id.id");
#line 14210 "Photo.c"
		}
	}
#line 2227 "../src/Photo.vala"
	result = DATA_SOURCE_CLASS (photo_parent_class)->equals ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), source);
#line 2227 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 2227 "../src/Photo.vala"
	return result;
#line 14219 "Photo.c"
}

static void
photo_file_exif_updated (Photo* self)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInfo* info = NULL;
	gint64 mod_time = 0LL;
	GFileInfo* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	gint64 _tmp10_;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp11_;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp16_;
	DetectedPhotoInformation* _tmp17_;
	gboolean success = FALSE;
	GError* _inner_error0_ = NULL;
#line 2231 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2232 "../src/Photo.vala"
	_tmp0_ = media_source_get_file ((MediaSource*) self);
#line 2232 "../src/Photo.vala"
	file = _tmp0_;
#line 2234 "../src/Photo.vala"
	info = NULL;
#line 14248 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 2236 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 2236 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2236 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14259 "Photo.c"
			goto __catch0_g_error;
		}
#line 2236 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2236 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 2236 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2236 "../src/Photo.vala"
		info = _tmp3_;
#line 2235 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 14272 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 2235 "../src/Photo.vala"
		err = _inner_error0_;
#line 2235 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2239 "../src/Photo.vala"
		_tmp4_ = data_object_to_string ((DataObject*) self);
#line 2239 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2239 "../src/Photo.vala"
		_tmp6_ = err->message;
#line 2239 "../src/Photo.vala"
		g_error ("Photo.vala:2239: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2239 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2235 "../src/Photo.vala"
		_g_error_free0 (err);
#line 14297 "Photo.c"
	}
	__finally0:
#line 2235 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2235 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2235 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2235 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2235 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2235 "../src/Photo.vala"
		return;
#line 14312 "Photo.c"
	}
#line 2242 "../src/Photo.vala"
	_tmp7_ = info;
#line 2242 "../src/Photo.vala"
	_tmp8_ = g_file_info_get_modification_date_time (_tmp7_);
#line 2242 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2242 "../src/Photo.vala"
	_tmp10_ = g_date_time_to_unix (_tmp9_);
#line 2242 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp9_);
#line 2242 "../src/Photo.vala"
	mod_time = _tmp10_;
#line 2245 "../src/Photo.vala"
	_tmp11_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2245 "../src/Photo.vala"
	interrogator = _tmp11_;
#line 14330 "Photo.c"
	{
#line 2247 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 2247 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14336 "Photo.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 2246 "../src/Photo.vala"
		err = _inner_error0_;
#line 2246 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2249 "../src/Photo.vala"
		_tmp12_ = g_file_get_path (file);
#line 2249 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2249 "../src/Photo.vala"
		_tmp14_ = err;
#line 2249 "../src/Photo.vala"
		_tmp15_ = _tmp14_->message;
#line 2249 "../src/Photo.vala"
		g_warning ("Photo.vala:2249: Unable to interrogate photo file %s: %s", _tmp13_, _tmp15_);
#line 2249 "../src/Photo.vala"
		_g_free0 (_tmp13_);
#line 2246 "../src/Photo.vala"
		_g_error_free0 (err);
#line 14366 "Photo.c"
	}
	__finally1:
#line 2246 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2246 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2246 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2246 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2246 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2246 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2246 "../src/Photo.vala"
		return;
#line 14383 "Photo.c"
	}
#line 2252 "../src/Photo.vala"
	_tmp16_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2252 "../src/Photo.vala"
	detected = _tmp16_;
#line 2253 "../src/Photo.vala"
	_tmp17_ = detected;
#line 2253 "../src/Photo.vala"
	if (_tmp17_ == NULL) {
#line 14393 "Photo.c"
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 2254 "../src/Photo.vala"
		_tmp18_ = data_object_to_string ((DataObject*) self);
#line 2254 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2254 "../src/Photo.vala"
		g_critical ("Photo.vala:2254: file_exif_updated: %s no longer an image", _tmp19_);
#line 2254 "../src/Photo.vala"
		_g_free0 (_tmp19_);
#line 2256 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2256 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2256 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2256 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2256 "../src/Photo.vala"
		return;
#line 14414 "Photo.c"
	}
	{
		PhotoRow* _tmp20_;
#line 2260 "../src/Photo.vala"
		_tmp20_ = self->row;
#line 2260 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14422 "Photo.c"
		{
			PhotoTable* _tmp21_;
			PhotoTable* _tmp22_;
			PhotoID _tmp23_ = {0};
			GFileInfo* _tmp24_;
			DetectedPhotoInformation* _tmp25_;
			const gchar* _tmp26_;
			DetectedPhotoInformation* _tmp27_;
			const gchar* _tmp28_;
			DetectedPhotoInformation* _tmp29_;
			const gchar* _tmp30_;
			PhotoRow* _tmp31_;
#line 2261 "../src/Photo.vala"
			_tmp21_ = photo_table_get_instance ();
#line 2261 "../src/Photo.vala"
			_tmp22_ = _tmp21_;
#line 2261 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp23_);
#line 2261 "../src/Photo.vala"
			_tmp24_ = info;
#line 2261 "../src/Photo.vala"
			_tmp25_ = detected;
#line 2261 "../src/Photo.vala"
			_tmp26_ = _tmp25_->md5;
#line 2261 "../src/Photo.vala"
			_tmp27_ = detected;
#line 2261 "../src/Photo.vala"
			_tmp28_ = _tmp27_->exif_md5;
#line 2261 "../src/Photo.vala"
			_tmp29_ = detected;
#line 2261 "../src/Photo.vala"
			_tmp30_ = _tmp29_->thumbnail_md5;
#line 2261 "../src/Photo.vala"
			_tmp31_ = self->row;
#line 2261 "../src/Photo.vala"
			success = photo_table_master_exif_updated (_tmp22_, &_tmp23_, g_file_info_get_size (_tmp24_), mod_time, _tmp26_, _tmp28_, _tmp30_, _tmp31_);
#line 2261 "../src/Photo.vala"
			_database_table_unref0 (_tmp22_);
#line 14461 "Photo.c"
		}
		__finally2:
		{
			PhotoRow* _tmp32_;
#line 2260 "../src/Photo.vala"
			_tmp32_ = self->row;
#line 2260 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14470 "Photo.c"
		}
#line 2260 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2260 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2260 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2260 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 2260 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 2260 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2260 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2260 "../src/Photo.vala"
			return;
#line 14488 "Photo.c"
		}
	}
#line 2267 "../src/Photo.vala"
	if (success) {
#line 14493 "Photo.c"
		Alteration* _tmp33_;
		Alteration* _tmp34_;
#line 2268 "../src/Photo.vala"
		_tmp33_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2268 "../src/Photo.vala"
		_tmp34_ = _tmp33_;
#line 2268 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp34_);
#line 2268 "../src/Photo.vala"
		_alteration_unref0 (_tmp34_);
#line 14504 "Photo.c"
	}
#line 2231 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2231 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2231 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 2231 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 14514 "Photo.c"
}

static guint64
photo_real_get_filesize (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2274 "../src/Photo.vala"
	self = (Photo*) base;
#line 14525 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2275 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2275 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14533 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2276 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2276 "../src/Photo.vala"
			result = (guint64) _tmp1_->filesize;
#line 14540 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2275 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2275 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14547 "Photo.c"
			}
#line 2276 "../src/Photo.vala"
			return result;
#line 14551 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2275 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2275 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14560 "Photo.c"
		}
#line 2275 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2275 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2275 "../src/Photo.vala"
		return _tmp4_;
#line 14568 "Photo.c"
	}
}

static guint64
photo_real_get_master_filesize (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2280 "../src/Photo.vala"
	self = (Photo*) base;
#line 14580 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2281 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2281 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14588 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
#line 2282 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2282 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2282 "../src/Photo.vala"
			result = (guint64) _tmp2_->filesize;
#line 14598 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2281 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2281 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14605 "Photo.c"
			}
#line 2282 "../src/Photo.vala"
			return result;
#line 14609 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2281 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2281 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14618 "Photo.c"
		}
#line 2281 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2281 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2281 "../src/Photo.vala"
		return _tmp5_;
#line 14626 "Photo.c"
	}
}

guint64
photo_get_editable_filesize (Photo* self)
{
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2286 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 14637 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2287 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2287 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14645 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2288 "../src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2288 "../src/Photo.vala"
			result = (guint64) _tmp1_->filesize;
#line 14652 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2287 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2287 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14659 "Photo.c"
			}
#line 2288 "../src/Photo.vala"
			return result;
#line 14663 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2287 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2287 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14672 "Photo.c"
		}
#line 2287 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2287 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2287 "../src/Photo.vala"
		return _tmp4_;
#line 14680 "Photo.c"
	}
}

static gint64
photo_real_get_exposure_time (Dateable* base)
{
	Photo * self;
	gint64 result;
#line 2292 "../src/Photo.vala"
	self = (Photo*) base;
#line 2293 "../src/Photo.vala"
	result = self->priv->cached_exposure_time;
#line 2293 "../src/Photo.vala"
	return result;
#line 14695 "Photo.c"
}

static gchar*
photo_real_get_basename (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 2296 "../src/Photo.vala"
	self = (Photo*) base;
#line 14706 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2297 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2297 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14713 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2298 "../src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2298 "../src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2298 "../src/Photo.vala"
			result = _tmp2_;
#line 14723 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2297 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2297 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14730 "Photo.c"
			}
#line 2298 "../src/Photo.vala"
			return result;
#line 14734 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2297 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2297 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14743 "Photo.c"
		}
#line 2297 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2297 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2297 "../src/Photo.vala"
		return NULL;
#line 14751 "Photo.c"
	}
}

static gchar*
photo_real_get_title (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 2302 "../src/Photo.vala"
	self = (Photo*) base;
#line 14763 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2303 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2303 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14770 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2304 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2304 "../src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2304 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2304 "../src/Photo.vala"
			result = _tmp3_;
#line 14783 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2303 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2303 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14790 "Photo.c"
			}
#line 2304 "../src/Photo.vala"
			return result;
#line 14794 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2303 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2303 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14803 "Photo.c"
		}
#line 2303 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2303 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2303 "../src/Photo.vala"
		return NULL;
#line 14811 "Photo.c"
	}
}

static gchar*
photo_real_get_comment (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 2308 "../src/Photo.vala"
	self = (Photo*) base;
#line 14823 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2309 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2309 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14830 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2310 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2310 "../src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2310 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2310 "../src/Photo.vala"
			result = _tmp3_;
#line 14843 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2309 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2309 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14850 "Photo.c"
			}
#line 2310 "../src/Photo.vala"
			return result;
#line 14854 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2309 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2309 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14863 "Photo.c"
		}
#line 2309 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2309 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2309 "../src/Photo.vala"
		return NULL;
#line 14871 "Photo.c"
	}
}

static void
photo_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Photo * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2314 "../src/Photo.vala"
	self = (Photo*) base;
#line 2315 "../src/Photo.vala"
	_tmp0_ = media_source_prep_title (title);
#line 2315 "../src/Photo.vala"
	new_title = _tmp0_;
#line 2317 "../src/Photo.vala"
	committed = FALSE;
#line 14892 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2318 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2318 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14899 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
#line 2319 "../src/Photo.vala"
			_tmp2_ = new_title;
#line 2319 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2319 "../src/Photo.vala"
			_tmp4_ = _tmp3_->title;
#line 2319 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 14917 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2318 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2318 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14924 "Photo.c"
				}
#line 2320 "../src/Photo.vala"
				_g_free0 (new_title);
#line 2320 "../src/Photo.vala"
				return;
#line 14930 "Photo.c"
			}
#line 2323 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2323 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2323 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2323 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2323 "../src/Photo.vala"
			_tmp10_ = new_title;
#line 2323 "../src/Photo.vala"
			committed = photo_table_set_title (_tmp7_, &_tmp9_, _tmp10_);
#line 2323 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2324 "../src/Photo.vala"
			if (committed) {
#line 14948 "Photo.c"
				PhotoRow* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 2325 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2325 "../src/Photo.vala"
				_tmp12_ = new_title;
#line 2325 "../src/Photo.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 2325 "../src/Photo.vala"
				_g_free0 (_tmp11_->title);
#line 2325 "../src/Photo.vala"
				_tmp11_->title = _tmp13_;
#line 14962 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2318 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2318 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14972 "Photo.c"
		}
#line 2318 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2318 "../src/Photo.vala"
			_g_free0 (new_title);
#line 2318 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2318 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2318 "../src/Photo.vala"
			return;
#line 14984 "Photo.c"
		}
	}
#line 2329 "../src/Photo.vala"
	if (committed) {
#line 14989 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2330 "../src/Photo.vala"
		_tmp15_ = alteration_new ("metadata", "name");
#line 2330 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2330 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp16_);
#line 2330 "../src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 15000 "Photo.c"
	}
#line 2314 "../src/Photo.vala"
	_g_free0 (new_title);
#line 15004 "Photo.c"
}

static gboolean
photo_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Photo * self;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2334 "../src/Photo.vala"
	self = (Photo*) base;
#line 2335 "../src/Photo.vala"
	_tmp0_ = media_source_prep_comment (comment);
#line 2335 "../src/Photo.vala"
	new_comment = _tmp0_;
#line 2337 "../src/Photo.vala"
	committed = FALSE;
#line 15025 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2338 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2338 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15032 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
#line 2339 "../src/Photo.vala"
			_tmp2_ = new_comment;
#line 2339 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2339 "../src/Photo.vala"
			_tmp4_ = _tmp3_->comment;
#line 2339 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 2340 "../src/Photo.vala"
				result = TRUE;
#line 15052 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2338 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2338 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15059 "Photo.c"
				}
#line 2340 "../src/Photo.vala"
				_g_free0 (new_comment);
#line 2340 "../src/Photo.vala"
				return result;
#line 15065 "Photo.c"
			}
#line 2343 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2343 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2343 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2343 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2343 "../src/Photo.vala"
			_tmp10_ = new_comment;
#line 2343 "../src/Photo.vala"
			committed = photo_table_set_comment (_tmp7_, &_tmp9_, _tmp10_);
#line 2343 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2344 "../src/Photo.vala"
			if (committed) {
#line 15083 "Photo.c"
				PhotoRow* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 2345 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2345 "../src/Photo.vala"
				_tmp12_ = new_comment;
#line 2345 "../src/Photo.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 2345 "../src/Photo.vala"
				_g_free0 (_tmp11_->comment);
#line 2345 "../src/Photo.vala"
				_tmp11_->comment = _tmp13_;
#line 15097 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2338 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2338 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15107 "Photo.c"
		}
#line 2338 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15111 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2338 "../src/Photo.vala"
			_g_free0 (new_comment);
#line 2338 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2338 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2338 "../src/Photo.vala"
			return _tmp15_;
#line 15121 "Photo.c"
		}
	}
#line 2349 "../src/Photo.vala"
	if (committed) {
#line 15126 "Photo.c"
		Alteration* _tmp16_;
		Alteration* _tmp17_;
#line 2350 "../src/Photo.vala"
		_tmp16_ = alteration_new ("metadata", "comment");
#line 2350 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2350 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp17_);
#line 2350 "../src/Photo.vala"
		_alteration_unref0 (_tmp17_);
#line 15137 "Photo.c"
	}
#line 2353 "../src/Photo.vala"
	result = committed;
#line 2353 "../src/Photo.vala"
	_g_free0 (new_comment);
#line 2353 "../src/Photo.vala"
	return result;
#line 15145 "Photo.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 2363 "../src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 15153 "Photo.c"
}

void
photo_set_import_id (Photo* self,
                     ImportID* import_id)
{
	GError* dberr = NULL;
	GError* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2356 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2356 "../src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2357 "../src/Photo.vala"
	dberr = NULL;
#line 15169 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2358 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2358 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15176 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2360 "../src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2360 "../src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2360 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2360 "../src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2360 "../src/Photo.vala"
				_tmp5_ = *import_id;
#line 2360 "../src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2360 "../src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2360 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2360 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 15204 "Photo.c"
						goto __catch1_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2358 "../src/Photo.vala"
						_tmp6_ = self->row;
#line 2358 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15213 "Photo.c"
					}
#line 2360 "../src/Photo.vala"
					_g_error_free0 (dberr);
#line 2360 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2360 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2360 "../src/Photo.vala"
					return;
#line 15223 "Photo.c"
				}
#line 2361 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2361 "../src/Photo.vala"
				_tmp8_ = *import_id;
#line 2361 "../src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 15231 "Photo.c"
			}
			goto __finally1;
			__catch1_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2359 "../src/Photo.vala"
				err = _inner_error0_;
#line 2359 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 2363 "../src/Photo.vala"
				_tmp9_ = err;
#line 2363 "../src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2363 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2363 "../src/Photo.vala"
				dberr = _tmp10_;
#line 2359 "../src/Photo.vala"
				_g_error_free0 (err);
#line 15253 "Photo.c"
			}
			__finally1:
#line 2359 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2359 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2359 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2359 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2359 "../src/Photo.vala"
				return;
#line 15266 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp11_;
#line 2358 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2358 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15276 "Photo.c"
		}
#line 2358 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2358 "../src/Photo.vala"
			_g_error_free0 (dberr);
#line 2358 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2358 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2358 "../src/Photo.vala"
			return;
#line 15288 "Photo.c"
		}
	}
#line 2367 "../src/Photo.vala"
	_tmp12_ = dberr;
#line 2367 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 15295 "Photo.c"
		Alteration* _tmp13_;
		Alteration* _tmp14_;
#line 2368 "../src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "import-id");
#line 2368 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2368 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp14_);
#line 2368 "../src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 15306 "Photo.c"
	} else {
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 2370 "../src/Photo.vala"
		_tmp15_ = data_object_to_string ((DataObject*) self);
#line 2370 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2370 "../src/Photo.vala"
		_tmp17_ = dberr;
#line 2370 "../src/Photo.vala"
		_tmp18_ = _tmp17_->message;
#line 2370 "../src/Photo.vala"
		g_warning ("Photo.vala:2370: Unable to write import ID for %s: %s", _tmp16_, _tmp18_);
#line 2370 "../src/Photo.vala"
		_g_free0 (_tmp16_);
#line 15324 "Photo.c"
	}
#line 2356 "../src/Photo.vala"
	_g_error_free0 (dberr);
#line 15328 "Photo.c"
}

void
photo_set_title_persistent (Photo* self,
                            const gchar* title,
                            GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2374 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2375 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2375 "../src/Photo.vala"
	source = _tmp0_;
#line 2378 "../src/Photo.vala"
	_tmp1_ = source;
#line 2378 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 15360 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2379 "../src/Photo.vala"
		_tmp2_ = source;
#line 2379 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2379 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2379 "../src/Photo.vala"
		g_warning ("Photo.vala:2379: No photo file writer available for %s", _tmp4_);
#line 2379 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2381 "../src/Photo.vala"
		media_source_set_title ((MediaSource*) self, title);
#line 2383 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2383 "../src/Photo.vala"
		return;
#line 15380 "Photo.c"
	}
#line 2386 "../src/Photo.vala"
	_tmp5_ = source;
#line 2386 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2386 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2386 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2386 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2386 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2386 "../src/Photo.vala"
		return;
#line 15396 "Photo.c"
	}
#line 2387 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2387 "../src/Photo.vala"
	photo_metadata_set_title (_tmp7_, title, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2389 "../src/Photo.vala"
	_tmp8_ = source;
#line 2389 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2389 "../src/Photo.vala"
	writer = _tmp9_;
#line 2389 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2389 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2389 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2389 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2389 "../src/Photo.vala"
		return;
#line 15418 "Photo.c"
	}
#line 2390 "../src/Photo.vala"
	_tmp10_ = source;
#line 2390 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp10_);
#line 2390 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2390 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_title");
#line 2390 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 15430 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2392 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2392 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2392 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2392 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15442 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2394 "../src/Photo.vala"
		_tmp15_ = source;
#line 2394 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp15_);
#line 2394 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2394 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2394 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 15462 "Photo.c"
	}
#line 2391 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2391 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2391 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2391 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2391 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2391 "../src/Photo.vala"
		return;
#line 15476 "Photo.c"
	}
#line 2397 "../src/Photo.vala"
	media_source_set_title ((MediaSource*) self, title);
#line 2399 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2374 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2374 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2374 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 15488 "Photo.c"
}

void
photo_set_comment_persistent (Photo* self,
                              const gchar* comment,
                              GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2402 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2403 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2403 "../src/Photo.vala"
	source = _tmp0_;
#line 2406 "../src/Photo.vala"
	_tmp1_ = source;
#line 2406 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 15520 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2407 "../src/Photo.vala"
		_tmp2_ = source;
#line 2407 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2407 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2407 "../src/Photo.vala"
		g_warning ("Photo.vala:2407: No photo file writer available for %s", _tmp4_);
#line 2407 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2409 "../src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, comment);
#line 2411 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2411 "../src/Photo.vala"
		return;
#line 15540 "Photo.c"
	}
#line 2414 "../src/Photo.vala"
	_tmp5_ = source;
#line 2414 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2414 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2414 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2414 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2414 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2414 "../src/Photo.vala"
		return;
#line 15556 "Photo.c"
	}
#line 2415 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2415 "../src/Photo.vala"
	photo_metadata_set_comment (_tmp7_, comment);
#line 2417 "../src/Photo.vala"
	_tmp8_ = source;
#line 2417 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2417 "../src/Photo.vala"
	writer = _tmp9_;
#line 2417 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2417 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2417 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2417 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2417 "../src/Photo.vala"
		return;
#line 15578 "Photo.c"
	}
#line 2418 "../src/Photo.vala"
	_tmp10_ = source;
#line 2418 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp10_);
#line 2418 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2418 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_comment");
#line 2418 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 15590 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2420 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2420 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2420 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2420 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15602 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2422 "../src/Photo.vala"
		_tmp15_ = source;
#line 2422 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp15_);
#line 2422 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2422 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2422 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 15622 "Photo.c"
	}
#line 2419 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2419 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2419 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2419 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2419 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2419 "../src/Photo.vala"
		return;
#line 15636 "Photo.c"
	}
#line 2425 "../src/Photo.vala"
	media_source_set_comment ((MediaSource*) self, comment);
#line 2427 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2402 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2402 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2402 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 15648 "Photo.c"
}

static void
photo_real_set_exposure_time (Dateable* base,
                              gint64 time)
{
	Photo * self;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2430 "../src/Photo.vala"
	self = (Photo*) base;
#line 15660 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2432 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2432 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15667 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
#line 2433 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2433 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2433 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2433 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2433 "../src/Photo.vala"
			committed = photo_table_set_exposure_time (_tmp2_, &_tmp4_, time);
#line 2433 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2434 "../src/Photo.vala"
			if (committed) {
#line 15687 "Photo.c"
				PhotoRow* _tmp5_;
#line 2435 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2435 "../src/Photo.vala"
				_tmp5_->exposure_time = time;
#line 2436 "../src/Photo.vala"
				self->priv->cached_exposure_time = time;
#line 15695 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 2432 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2432 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15705 "Photo.c"
		}
#line 2432 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2432 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2432 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2432 "../src/Photo.vala"
			return;
#line 15715 "Photo.c"
		}
	}
#line 2440 "../src/Photo.vala"
	if (committed) {
#line 15720 "Photo.c"
		Alteration* _tmp7_;
		Alteration* _tmp8_;
#line 2441 "../src/Photo.vala"
		_tmp7_ = alteration_new ("metadata", "exposure-time");
#line 2441 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2441 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp8_);
#line 2441 "../src/Photo.vala"
		_alteration_unref0 (_tmp8_);
#line 15731 "Photo.c"
	}
}

void
photo_set_exposure_time_persistent (Photo* self,
                                    gint64 time,
                                    GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	MetadataDateTime* _tmp8_;
	MetadataDateTime* _tmp9_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp10_;
	PhotoFileMetadataWriter* _tmp11_;
	PhotoFileReader* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 2445 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2446 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2446 "../src/Photo.vala"
	source = _tmp0_;
#line 2449 "../src/Photo.vala"
	_tmp1_ = source;
#line 2449 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 15766 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2450 "../src/Photo.vala"
		_tmp2_ = source;
#line 2450 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2450 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2450 "../src/Photo.vala"
		g_warning ("Photo.vala:2450: No photo file writer available for %s", _tmp4_);
#line 2450 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2452 "../src/Photo.vala"
		dateable_set_exposure_time ((Dateable*) self, time);
#line 2454 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2454 "../src/Photo.vala"
		return;
#line 15786 "Photo.c"
	}
#line 2457 "../src/Photo.vala"
	_tmp5_ = source;
#line 2457 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2457 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2457 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2457 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2457 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2457 "../src/Photo.vala"
		return;
#line 15802 "Photo.c"
	}
#line 2458 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2458 "../src/Photo.vala"
	_tmp8_ = metadata_date_time_new (time);
#line 2458 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2458 "../src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp7_, _tmp9_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2458 "../src/Photo.vala"
	_metadata_date_time_unref0 (_tmp9_);
#line 2460 "../src/Photo.vala"
	_tmp10_ = source;
#line 2460 "../src/Photo.vala"
	_tmp11_ = photo_file_reader_create_metadata_writer (_tmp10_, &_inner_error0_);
#line 2460 "../src/Photo.vala"
	writer = _tmp11_;
#line 2460 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2460 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2460 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2460 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2460 "../src/Photo.vala"
		return;
#line 15830 "Photo.c"
	}
#line 2461 "../src/Photo.vala"
	_tmp12_ = source;
#line 2461 "../src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp12_);
#line 2461 "../src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2461 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp14_, "Photo.set_exposure_time_persistent");
#line 2461 "../src/Photo.vala"
	_g_object_unref0 (_tmp14_);
#line 15842 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp15_;
		PhotoMetadata* _tmp16_;
#line 2463 "../src/Photo.vala"
		_tmp15_ = writer;
#line 2463 "../src/Photo.vala"
		_tmp16_ = metadata;
#line 2463 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp15_, _tmp16_, &_inner_error0_);
#line 2463 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15854 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
#line 2465 "../src/Photo.vala"
		_tmp17_ = source;
#line 2465 "../src/Photo.vala"
		_tmp18_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp17_);
#line 2465 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2465 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp19_);
#line 2465 "../src/Photo.vala"
		_g_object_unref0 (_tmp19_);
#line 15874 "Photo.c"
	}
#line 2462 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2462 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2462 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2462 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2462 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2462 "../src/Photo.vala"
		return;
#line 15888 "Photo.c"
	}
#line 2468 "../src/Photo.vala"
	dateable_set_exposure_time ((Dateable*) self, time);
#line 2470 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2445 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2445 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2445 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 15900 "Photo.c"
}

/**
     * Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options ()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void
photo_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
#line 2486 "../src/Photo.vala"
	self = (Photo*) base;
#line 2488 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2488 "../src/Photo.vala"
	returned_dims = _tmp0_;
#line 2491 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_ORIENTATION)) {
#line 15932 "Photo.c"
		Orientation ori_tmp = 0;
#line 2492 "../src/Photo.vala"
		ori_tmp = photo_get_orientation (self);
#line 2495 "../src/Photo.vala"
		switch (ori_tmp) {
#line 2495 "../src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2495 "../src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2495 "../src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2495 "../src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 15946 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp1_;
				Dimensions _tmp2_;
#line 2501 "../src/Photo.vala"
				_tmp1_ = returned_dims;
#line 2501 "../src/Photo.vala"
				width_tmp = _tmp1_.width;
#line 2503 "../src/Photo.vala"
				_tmp2_ = returned_dims;
#line 2503 "../src/Photo.vala"
				returned_dims.width = _tmp2_.height;
#line 2504 "../src/Photo.vala"
				returned_dims.height = width_tmp;
#line 2505 "../src/Photo.vala"
				break;
#line 15963 "Photo.c"
			}
			default:
			{
#line 2509 "../src/Photo.vala"
				break;
#line 15969 "Photo.c"
			}
		}
	}
#line 2514 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 15975 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp3_ = 0.0;
		Dimensions _tmp4_;
		Dimensions _tmp5_;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
#line 2516 "../src/Photo.vala"
		angle = 0.0;
#line 2518 "../src/Photo.vala"
		photo_get_straighten (self, &_tmp3_);
#line 2518 "../src/Photo.vala"
		angle = _tmp3_;
#line 2520 "../src/Photo.vala"
		_tmp4_ = returned_dims;
#line 2520 "../src/Photo.vala"
		_tmp5_ = returned_dims;
#line 2520 "../src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp4_.width, (gdouble) _tmp5_.height, angle, &_tmp6_, &_tmp7_);
#line 2520 "../src/Photo.vala"
		x_size = _tmp6_;
#line 2520 "../src/Photo.vala"
		y_size = _tmp7_;
#line 2522 "../src/Photo.vala"
		returned_dims.width = (gint) x_size;
#line 2523 "../src/Photo.vala"
		returned_dims.height = (gint) y_size;
#line 16004 "Photo.c"
	}
#line 2527 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_CROP)) {
#line 16008 "Photo.c"
		Box crop = {0};
		Box _tmp8_ = {0};
		gboolean _tmp9_;
#line 2529 "../src/Photo.vala"
		_tmp9_ = photo_get_crop (self, &_tmp8_, disallowed_steps);
#line 2529 "../src/Photo.vala"
		crop = _tmp8_;
#line 2529 "../src/Photo.vala"
		if (_tmp9_) {
#line 16018 "Photo.c"
			Dimensions _tmp10_ = {0};
#line 2530 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp10_);
#line 2530 "../src/Photo.vala"
			returned_dims = _tmp10_;
#line 16024 "Photo.c"
		}
	}
#line 2533 "../src/Photo.vala"
	*result = returned_dims;
#line 2533 "../src/Photo.vala"
	return;
#line 16031 "Photo.c"
}

static void
photo_locked_create_adjustments_from_data (Photo* self)
{
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_;
#line 2537 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2538 "../src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2538 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2538 "../src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2540 "../src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2540 "../src/Photo.vala"
	map = _tmp1_;
#line 2541 "../src/Photo.vala"
	_tmp2_ = map;
#line 2541 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 16059 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2542 "../src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2542 "../src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 16065 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2544 "../src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2544 "../src/Photo.vala"
		_tmp5_ = map;
#line 2544 "../src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 16075 "Photo.c"
	}
#line 2547 "../src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2547 "../src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2547 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2547 "../src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2537 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 16087 "Photo.c"
}

PixelTransformationBundle*
photo_get_color_adjustments (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PixelTransformationBundle* result;
#line 2551 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16097 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2552 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2552 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16104 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_;
#line 2553 "../src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2553 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2554 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 16115 "Photo.c"
			}
#line 2557 "../src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2557 "../src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2557 "../src/Photo.vala"
			result = _tmp3_;
#line 16123 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2552 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2552 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16130 "Photo.c"
			}
#line 2557 "../src/Photo.vala"
			return result;
#line 16134 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2552 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2552 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16143 "Photo.c"
		}
#line 2552 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2552 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2552 "../src/Photo.vala"
		return NULL;
#line 16151 "Photo.c"
	}
}

static PixelTransformationBundle*
photo_locked_original_color_adjustments (Photo* self)
{
	PixelTransformationBundle* original_adjustments = NULL;
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	PhotoRow* _tmp1_;
	GeeHashMap* _tmp2_;
	KeyValueMap* _tmp10_;
	PixelTransformationBundle* result;
#line 2562 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2563 "../src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2563 "../src/Photo.vala"
	original_adjustments = _tmp0_;
#line 2566 "../src/Photo.vala"
	_tmp1_ = self->row;
#line 2566 "../src/Photo.vala"
	_tmp2_ = _tmp1_->original_transforms;
#line 2566 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 16177 "Photo.c"
		PhotoRow* _tmp3_;
		GeeHashMap* _tmp4_;
		gpointer _tmp5_;
		KeyValueMap* _tmp6_;
#line 2567 "../src/Photo.vala"
		_tmp3_ = self->row;
#line 2567 "../src/Photo.vala"
		_tmp4_ = _tmp3_->original_transforms;
#line 2567 "../src/Photo.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, "adjustments");
#line 2567 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2567 "../src/Photo.vala"
		map = (KeyValueMap*) _tmp5_;
#line 2568 "../src/Photo.vala"
		_tmp6_ = map;
#line 2568 "../src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 16196 "Photo.c"
			KeyValueMap* _tmp7_;
			KeyValueMap* _tmp8_;
#line 2569 "../src/Photo.vala"
			_tmp7_ = map;
#line 2569 "../src/Photo.vala"
			_tmp8_ = key_value_map_copy (_tmp7_);
#line 2569 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2569 "../src/Photo.vala"
			map = _tmp8_;
#line 16207 "Photo.c"
		}
	} else {
		KeyValueMap* _tmp9_;
#line 2572 "../src/Photo.vala"
		_tmp9_ = key_value_map_new ("adjustments");
#line 2572 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2572 "../src/Photo.vala"
		map = _tmp9_;
#line 16217 "Photo.c"
	}
#line 2575 "../src/Photo.vala"
	_tmp10_ = map;
#line 2575 "../src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 16223 "Photo.c"
		PixelTransformationBundle* _tmp11_;
#line 2576 "../src/Photo.vala"
		_tmp11_ = original_adjustments;
#line 2576 "../src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp11_);
#line 16229 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp12_;
		KeyValueMap* _tmp13_;
#line 2578 "../src/Photo.vala"
		_tmp12_ = original_adjustments;
#line 2578 "../src/Photo.vala"
		_tmp13_ = map;
#line 2578 "../src/Photo.vala"
		pixel_transformation_bundle_load (_tmp12_, _tmp13_);
#line 16239 "Photo.c"
	}
#line 2581 "../src/Photo.vala"
	result = original_adjustments;
#line 2581 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2581 "../src/Photo.vala"
	return result;
#line 16247 "Photo.c"
}

static KeyValueMap*
photo_get_color_adjustments_map (Photo* self)
{
	GError* _inner_error0_ = NULL;
	KeyValueMap* result;
#line 2586 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16257 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2587 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2587 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16264 "Photo.c"
		{
			KeyValueMap* map = NULL;
			KeyValueMap* _tmp1_;
			KeyValueMap* _tmp2_;
#line 2588 "../src/Photo.vala"
			_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2588 "../src/Photo.vala"
			map = _tmp1_;
#line 2589 "../src/Photo.vala"
			_tmp2_ = map;
#line 2589 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 16277 "Photo.c"
				KeyValueMap* _tmp3_;
#line 2590 "../src/Photo.vala"
				_tmp3_ = key_value_map_new ("adjustments");
#line 2590 "../src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2590 "../src/Photo.vala"
				map = _tmp3_;
#line 16285 "Photo.c"
			}
#line 2592 "../src/Photo.vala"
			result = map;
#line 16289 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2587 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2587 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16296 "Photo.c"
			}
#line 2592 "../src/Photo.vala"
			return result;
#line 16300 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2587 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2587 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16309 "Photo.c"
		}
#line 2587 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2587 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2587 "../src/Photo.vala"
		return NULL;
#line 16317 "Photo.c"
	}
}

PixelTransformer*
photo_get_pixel_transformer (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PixelTransformer* result;
#line 2596 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16328 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2597 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2597 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16335 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_;
#line 2598 "../src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2598 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2599 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 16346 "Photo.c"
			}
#line 2602 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2602 "../src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2602 "../src/Photo.vala"
			result = _tmp3_;
#line 16354 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2597 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2597 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16361 "Photo.c"
			}
#line 2602 "../src/Photo.vala"
			return result;
#line 16365 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2597 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2597 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16374 "Photo.c"
		}
#line 2597 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2597 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2597 "../src/Photo.vala"
		return NULL;
#line 16382 "Photo.c"
	}
}

gboolean
photo_has_color_adjustments (Photo* self)
{
	gboolean result;
#line 2606 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2607 "../src/Photo.vala"
	result = photo_has_transformation (self, "adjustments");
#line 2607 "../src/Photo.vala"
	return result;
#line 16396 "Photo.c"
}

PixelTransformation*
photo_get_color_adjustment (Photo* self,
                            PixelTransformationType type)
{
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformation* _tmp2_;
	PixelTransformation* _tmp3_;
	PixelTransformation* result;
#line 2610 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2611 "../src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2611 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2611 "../src/Photo.vala"
	_tmp2_ = pixel_transformation_bundle_get_transformation (_tmp1_, type);
#line 2611 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2611 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2611 "../src/Photo.vala"
	result = _tmp3_;
#line 2611 "../src/Photo.vala"
	return result;
#line 16424 "Photo.c"
}

void
photo_set_color_adjustments (Photo* self,
                             PixelTransformationBundle* new_adjustments)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp4_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2614 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2614 "../src/Photo.vala"
	g_return_if_fail (new_adjustments != NULL);
#line 2617 "../src/Photo.vala"
	photo_set_enhanced (self, FALSE);
#line 2618 "../src/Photo.vala"
	if (pixel_transformation_bundle_is_identity (new_adjustments)) {
#line 16443 "Photo.c"
		gboolean _result_ = FALSE;
		{
			PhotoRow* _tmp0_;
#line 2620 "../src/Photo.vala"
			_tmp0_ = self->row;
#line 2620 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 16451 "Photo.c"
			{
#line 2621 "../src/Photo.vala"
				_result_ = photo_remove_transformation (self, "adjustments");
#line 2622 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2622 "../src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2623 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2623 "../src/Photo.vala"
				self->priv->transformer = NULL;
#line 16463 "Photo.c"
			}
			__finally0:
			{
				PhotoRow* _tmp1_;
#line 2620 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 2620 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16472 "Photo.c"
			}
#line 2620 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2620 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2620 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2620 "../src/Photo.vala"
				return;
#line 16482 "Photo.c"
			}
		}
#line 2626 "../src/Photo.vala"
		if (_result_) {
#line 16487 "Photo.c"
			Alteration* _tmp2_;
			Alteration* _tmp3_;
#line 2627 "../src/Photo.vala"
			_tmp2_ = alteration_new ("image", "color-adjustments");
#line 2627 "../src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 2627 "../src/Photo.vala"
			data_object_notify_altered ((DataObject*) self, _tmp3_);
#line 2627 "../src/Photo.vala"
			_alteration_unref0 (_tmp3_);
#line 16498 "Photo.c"
		}
#line 2630 "../src/Photo.vala"
		return;
#line 16502 "Photo.c"
	}
#line 2634 "../src/Photo.vala"
	_tmp4_ = pixel_transformation_bundle_save (new_adjustments, "adjustments");
#line 2634 "../src/Photo.vala"
	map = _tmp4_;
#line 16508 "Photo.c"
	{
		PhotoRow* _tmp5_;
#line 2637 "../src/Photo.vala"
		_tmp5_ = self->row;
#line 2637 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16515 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
			PixelTransformer* _tmp7_;
			KeyValueMap* _tmp25_;
#line 2638 "../src/Photo.vala"
			_tmp7_ = self->priv->transformer;
#line 2638 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 2638 "../src/Photo.vala"
				_tmp6_ = TRUE;
#line 16526 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp8_;
#line 2638 "../src/Photo.vala"
				_tmp8_ = self->priv->adjustments;
#line 2638 "../src/Photo.vala"
				_tmp6_ = _tmp8_ == NULL;
#line 16533 "Photo.c"
			}
#line 2638 "../src/Photo.vala"
			if (_tmp6_) {
#line 16537 "Photo.c"
				PixelTransformationBundle* _tmp9_;
				PixelTransformer* _tmp10_;
#line 2640 "../src/Photo.vala"
				_tmp9_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2640 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2640 "../src/Photo.vala"
				self->priv->adjustments = _tmp9_;
#line 2641 "../src/Photo.vala"
				_tmp10_ = pixel_transformation_bundle_generate_transformer (new_adjustments);
#line 2641 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2641 "../src/Photo.vala"
				self->priv->transformer = _tmp10_;
#line 16552 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp24_;
				{
					GeeIterator* _transformation_it = NULL;
					GeeIterable* _tmp11_;
					GeeIterable* _tmp12_;
					GeeIterator* _tmp13_;
					GeeIterator* _tmp14_;
#line 2644 "../src/Photo.vala"
					_tmp11_ = pixel_transformation_bundle_get_transformations (new_adjustments);
#line 2644 "../src/Photo.vala"
					_tmp12_ = _tmp11_;
#line 2644 "../src/Photo.vala"
					_tmp13_ = gee_iterable_iterator (_tmp12_);
#line 2644 "../src/Photo.vala"
					_tmp14_ = _tmp13_;
#line 2644 "../src/Photo.vala"
					_g_object_unref0 (_tmp12_);
#line 2644 "../src/Photo.vala"
					_transformation_it = _tmp14_;
#line 2644 "../src/Photo.vala"
					while (TRUE) {
#line 16575 "Photo.c"
						GeeIterator* _tmp15_;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp16_;
						gpointer _tmp17_;
						PixelTransformer* _tmp18_;
						PixelTransformationBundle* _tmp19_;
						PixelTransformation* _tmp20_;
						PixelTransformation* _tmp21_;
						PixelTransformation* _tmp22_;
						PixelTransformation* _tmp23_;
#line 2644 "../src/Photo.vala"
						_tmp15_ = _transformation_it;
#line 2644 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp15_)) {
#line 2644 "../src/Photo.vala"
							break;
#line 16592 "Photo.c"
						}
#line 2644 "../src/Photo.vala"
						_tmp16_ = _transformation_it;
#line 2644 "../src/Photo.vala"
						_tmp17_ = gee_iterator_get (_tmp16_);
#line 2644 "../src/Photo.vala"
						transformation = (PixelTransformation*) _tmp17_;
#line 2645 "../src/Photo.vala"
						_tmp18_ = self->priv->transformer;
#line 2645 "../src/Photo.vala"
						_tmp19_ = self->priv->adjustments;
#line 2645 "../src/Photo.vala"
						_tmp20_ = transformation;
#line 2645 "../src/Photo.vala"
						_tmp21_ = pixel_transformation_bundle_get_transformation (_tmp19_, pixel_transformation_get_transformation_type (_tmp20_));
#line 2645 "../src/Photo.vala"
						_tmp22_ = _tmp21_;
#line 2645 "../src/Photo.vala"
						_tmp23_ = transformation;
#line 2645 "../src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp18_, _tmp22_, _tmp23_);
#line 2645 "../src/Photo.vala"
						_pixel_transformation_unref0 (_tmp22_);
#line 2644 "../src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 16618 "Photo.c"
					}
#line 2644 "../src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 16622 "Photo.c"
				}
#line 2650 "../src/Photo.vala"
				_tmp24_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2650 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2650 "../src/Photo.vala"
				self->priv->adjustments = _tmp24_;
#line 16630 "Photo.c"
			}
#line 2653 "../src/Photo.vala"
			_tmp25_ = map;
#line 2653 "../src/Photo.vala"
			committed = photo_set_transformation (self, _tmp25_);
#line 16636 "Photo.c"
		}
		__finally1:
		{
			PhotoRow* _tmp26_;
#line 2637 "../src/Photo.vala"
			_tmp26_ = self->row;
#line 2637 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16645 "Photo.c"
		}
#line 2637 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2637 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2637 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2637 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2637 "../src/Photo.vala"
			return;
#line 16657 "Photo.c"
		}
	}
#line 2656 "../src/Photo.vala"
	if (committed) {
#line 16662 "Photo.c"
		Alteration* _tmp27_;
		Alteration* _tmp28_;
#line 2657 "../src/Photo.vala"
		_tmp27_ = alteration_new ("image", "color-adjustments");
#line 2657 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 2657 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp28_);
#line 2657 "../src/Photo.vala"
		_alteration_unref0 (_tmp28_);
#line 16673 "Photo.c"
	}
#line 2614 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 16677 "Photo.c"
}

static PhotoMetadata*
photo_real_get_metadata (PhotoSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result;
#line 2662 "../src/Photo.vala"
	self = (Photo*) base;
#line 16688 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoFileReader* _tmp2_;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
		PhotoMetadata* _tmp5_;
#line 2664 "../src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2664 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2664 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2664 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2664 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2664 "../src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2664 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16710 "Photo.c"
			goto __catch0_g_error;
		}
#line 2664 "../src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2664 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 2664 "../src/Photo.vala"
		result = _tmp5_;
#line 2664 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2664 "../src/Photo.vala"
		return result;
#line 16723 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 2663 "../src/Photo.vala"
		err = _inner_error0_;
#line 2663 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2666 "../src/Photo.vala"
		_tmp6_ = err;
#line 2666 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2666 "../src/Photo.vala"
		g_warning ("Photo.vala:2666: Unable to load metadata: %s", _tmp7_);
#line 2668 "../src/Photo.vala"
		result = NULL;
#line 2668 "../src/Photo.vala"
		_g_error_free0 (err);
#line 2668 "../src/Photo.vala"
		return result;
#line 16747 "Photo.c"
	}
	__finally0:
#line 2663 "../src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2663 "../src/Photo.vala"
	g_clear_error (&_inner_error0_);
#line 2663 "../src/Photo.vala"
	return NULL;
#line 16756 "Photo.c"
}

PhotoMetadata*
photo_get_master_metadata (Photo* self,
                           GError** error)
{
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	PhotoMetadata* _tmp5_;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result;
#line 2672 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2673 "../src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2673 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2673 "../src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2673 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2673 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2673 "../src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2673 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2673 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2673 "../src/Photo.vala"
		return NULL;
#line 16791 "Photo.c"
	}
#line 2673 "../src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2673 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 2673 "../src/Photo.vala"
	result = _tmp5_;
#line 2673 "../src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2673 "../src/Photo.vala"
	return result;
#line 16803 "Photo.c"
}

PhotoMetadata*
photo_get_editable_metadata (Photo* self,
                             GError** error)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result;
#line 2676 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2677 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2677 "../src/Photo.vala"
	reader = _tmp0_;
#line 2679 "../src/Photo.vala"
	_tmp2_ = reader;
#line 2679 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 16826 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2679 "../src/Photo.vala"
		_tmp3_ = reader;
#line 2679 "../src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error0_);
#line 2679 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2679 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2679 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2679 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2679 "../src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2679 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2679 "../src/Photo.vala"
			return NULL;
#line 16847 "Photo.c"
		}
	} else {
#line 2679 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2679 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 16854 "Photo.c"
	}
#line 2679 "../src/Photo.vala"
	result = _tmp1_;
#line 2679 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2679 "../src/Photo.vala"
	return result;
#line 16862 "Photo.c"
}

gboolean
photo_persist_master_metadata (Photo* self,
                               PhotoMetadata* metadata,
                               PhotoReimportMasterState** state,
                               GError** error)
{
	PhotoReimportMasterState* _vala_state = NULL;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileMetadataWriter* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	gboolean _tmp7_ = FALSE;
	PhotoReimportMasterState* _tmp8_ = NULL;
	gboolean _tmp9_;
	PhotoReimportMasterState* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2685 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2685 "../src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2687 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2687 "../src/Photo.vala"
	_vala_state = NULL;
#line 2689 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2689 "../src/Photo.vala"
	master_reader = _tmp0_;
#line 2691 "../src/Photo.vala"
	_tmp1_ = master_reader;
#line 2691 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 2692 "../src/Photo.vala"
		result = FALSE;
#line 2692 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2692 "../src/Photo.vala"
		if (state) {
#line 2692 "../src/Photo.vala"
			*state = _vala_state;
#line 16908 "Photo.c"
		} else {
#line 2692 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 16912 "Photo.c"
		}
#line 2692 "../src/Photo.vala"
		return result;
#line 16916 "Photo.c"
	}
#line 2695 "../src/Photo.vala"
	_tmp3_ = master_reader;
#line 2695 "../src/Photo.vala"
	_tmp4_ = photo_file_reader_create_metadata_writer (_tmp3_, &_inner_error0_);
#line 2695 "../src/Photo.vala"
	_tmp2_ = _tmp4_;
#line 2695 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16926 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 2695 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2695 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2695 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2695 "../src/Photo.vala"
		return _tmp5_;
#line 16936 "Photo.c"
	}
#line 2695 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp2_, metadata, &_inner_error0_);
#line 2695 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16942 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2695 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2695 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2695 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2695 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2695 "../src/Photo.vala"
		return _tmp6_;
#line 16954 "Photo.c"
	}
#line 2697 "../src/Photo.vala"
	_tmp9_ = photo_prepare_for_reimport_master (self, &_tmp8_, &_inner_error0_);
#line 2697 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2697 "../src/Photo.vala"
	_vala_state = _tmp8_;
#line 2697 "../src/Photo.vala"
	_tmp7_ = _tmp9_;
#line 2697 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16966 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 2697 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2697 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2697 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2697 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2697 "../src/Photo.vala"
		return _tmp10_;
#line 16978 "Photo.c"
	}
#line 2697 "../src/Photo.vala"
	if (!_tmp7_) {
#line 2698 "../src/Photo.vala"
		result = FALSE;
#line 2698 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2698 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2698 "../src/Photo.vala"
		if (state) {
#line 2698 "../src/Photo.vala"
			*state = _vala_state;
#line 16992 "Photo.c"
		} else {
#line 2698 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 16996 "Photo.c"
		}
#line 2698 "../src/Photo.vala"
		return result;
#line 17000 "Photo.c"
	}
#line 2701 "../src/Photo.vala"
	_tmp11_ = _vala_state;
#line 2701 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2703 "../src/Photo.vala"
	result = TRUE;
#line 2703 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2703 "../src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2703 "../src/Photo.vala"
	if (state) {
#line 2703 "../src/Photo.vala"
		*state = _vala_state;
#line 17016 "Photo.c"
	} else {
#line 2703 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 17020 "Photo.c"
	}
#line 2703 "../src/Photo.vala"
	return result;
#line 17024 "Photo.c"
}

void
photo_finish_update_master_metadata (Photo* self,
                                     PhotoReimportMasterState* state,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2706 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2706 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2707 "../src/Photo.vala"
	photo_finish_reimport_master (self, state, &_inner_error0_);
#line 2707 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2707 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2707 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2707 "../src/Photo.vala"
			return;
#line 17047 "Photo.c"
		} else {
#line 2707 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2707 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2707 "../src/Photo.vala"
			return;
#line 17055 "Photo.c"
		}
	}
}

gboolean
photo_persist_editable_metadata (Photo* self,
                                 PhotoMetadata* metadata,
                                 PhotoReimportEditableState** state,
                                 GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	gboolean _tmp8_ = FALSE;
	PhotoReimportEditableState* _tmp9_ = NULL;
	gboolean _tmp10_;
	PhotoReimportEditableState* _tmp12_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2710 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2710 "../src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2712 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2712 "../src/Photo.vala"
	_vala_state = NULL;
#line 2714 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2714 "../src/Photo.vala"
	editable_reader = _tmp0_;
#line 2715 "../src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2715 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2716 "../src/Photo.vala"
		result = FALSE;
#line 2716 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2716 "../src/Photo.vala"
		if (state) {
#line 2716 "../src/Photo.vala"
			*state = _vala_state;
#line 17104 "Photo.c"
		} else {
#line 2716 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 17108 "Photo.c"
		}
#line 2716 "../src/Photo.vala"
		return result;
#line 17112 "Photo.c"
	}
#line 2719 "../src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2719 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_))) {
#line 2720 "../src/Photo.vala"
		result = FALSE;
#line 2720 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2720 "../src/Photo.vala"
		if (state) {
#line 2720 "../src/Photo.vala"
			*state = _vala_state;
#line 17126 "Photo.c"
		} else {
#line 2720 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 17130 "Photo.c"
		}
#line 2720 "../src/Photo.vala"
		return result;
#line 17134 "Photo.c"
	}
#line 2723 "../src/Photo.vala"
	_tmp4_ = editable_reader;
#line 2723 "../src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error0_);
#line 2723 "../src/Photo.vala"
	_tmp3_ = _tmp5_;
#line 2723 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17144 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2723 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2723 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2723 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2723 "../src/Photo.vala"
		return _tmp6_;
#line 17154 "Photo.c"
	}
#line 2723 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp3_, metadata, &_inner_error0_);
#line 2723 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17160 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 2723 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2723 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2723 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2723 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2723 "../src/Photo.vala"
		return _tmp7_;
#line 17172 "Photo.c"
	}
#line 2725 "../src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_editable (self, &_tmp9_, &_inner_error0_);
#line 2725 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2725 "../src/Photo.vala"
	_vala_state = _tmp9_;
#line 2725 "../src/Photo.vala"
	_tmp8_ = _tmp10_;
#line 2725 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17184 "Photo.c"
		gboolean _tmp11_ = FALSE;
#line 2725 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2725 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2725 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2725 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2725 "../src/Photo.vala"
		return _tmp11_;
#line 17196 "Photo.c"
	}
#line 2725 "../src/Photo.vala"
	if (!_tmp8_) {
#line 2726 "../src/Photo.vala"
		result = FALSE;
#line 2726 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2726 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2726 "../src/Photo.vala"
		if (state) {
#line 2726 "../src/Photo.vala"
			*state = _vala_state;
#line 17210 "Photo.c"
		} else {
#line 2726 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 17214 "Photo.c"
		}
#line 2726 "../src/Photo.vala"
		return result;
#line 17218 "Photo.c"
	}
#line 2729 "../src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2729 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2731 "../src/Photo.vala"
	result = TRUE;
#line 2731 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 2731 "../src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2731 "../src/Photo.vala"
	if (state) {
#line 2731 "../src/Photo.vala"
		*state = _vala_state;
#line 17234 "Photo.c"
	} else {
#line 2731 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 17238 "Photo.c"
	}
#line 2731 "../src/Photo.vala"
	return result;
#line 17242 "Photo.c"
}

void
photo_finish_update_editable_metadata (Photo* self,
                                       PhotoReimportEditableState* state,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2734 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2734 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2735 "../src/Photo.vala"
	photo_finish_reimport_editable (self, state, &_inner_error0_);
#line 2735 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2735 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2735 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2735 "../src/Photo.vala"
			return;
#line 17265 "Photo.c"
		} else {
#line 2735 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2735 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2735 "../src/Photo.vala"
			return;
#line 17273 "Photo.c"
		}
	}
}

void
photo_get_raw_dimensions (Photo* self,
                          Dimensions* result)
{
	GError* _inner_error0_ = NULL;
#line 2740 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 17285 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2741 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2741 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17292 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2742 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2742 "../src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2742 "../src/Photo.vala"
			*result = _tmp2_;
#line 17302 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2741 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2741 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17309 "Photo.c"
			}
#line 2742 "../src/Photo.vala"
			return;
#line 17313 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2741 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2741 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17322 "Photo.c"
		}
#line 2741 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2741 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2741 "../src/Photo.vala"
		return;
#line 17330 "Photo.c"
	}
}

gboolean
photo_has_transformations (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2746 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 17341 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2747 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2747 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17349 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 2748 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2748 "../src/Photo.vala"
			_tmp3_ = self->backing_photo_row;
#line 2748 "../src/Photo.vala"
			if (_tmp2_->orientation != _tmp3_->original_orientation) {
#line 2749 "../src/Photo.vala"
				_tmp1_ = TRUE;
#line 17362 "Photo.c"
			} else {
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2750 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2750 "../src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2750 "../src/Photo.vala"
				_tmp1_ = _tmp5_ != NULL;
#line 17372 "Photo.c"
			}
#line 2748 "../src/Photo.vala"
			result = _tmp1_;
#line 17376 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2747 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2747 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17383 "Photo.c"
			}
#line 2748 "../src/Photo.vala"
			return result;
#line 17387 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2747 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2747 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17396 "Photo.c"
		}
#line 2747 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2747 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2747 "../src/Photo.vala"
		return _tmp8_;
#line 17404 "Photo.c"
	}
}

gboolean
photo_only_metadata_changed (Photo* self)
{
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2754 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2755 "../src/Photo.vala"
	date_time = NULL;
#line 2757 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2757 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2758 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2758 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 17429 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
#line 2759 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2759 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2759 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2759 "../src/Photo.vala"
		date_time = _tmp3_;
#line 17440 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
		gboolean _tmp17_ = FALSE;
#line 2762 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 2762 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17449 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
#line 2763 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2763 "../src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2763 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 17460 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				BackingPhotoRow* _tmp10_;
#line 2764 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2764 "../src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2764 "../src/Photo.vala"
				if (_tmp9_->orientation != _tmp10_->original_orientation) {
#line 2764 "../src/Photo.vala"
					_tmp8_ = TRUE;
#line 17472 "Photo.c"
				} else {
					gboolean _tmp11_ = FALSE;
					MetadataDateTime* _tmp12_;
#line 2765 "../src/Photo.vala"
					_tmp12_ = date_time;
#line 2765 "../src/Photo.vala"
					if (_tmp12_ != NULL) {
#line 17480 "Photo.c"
						PhotoRow* _tmp13_;
						MetadataDateTime* _tmp14_;
#line 2765 "../src/Photo.vala"
						_tmp13_ = self->row;
#line 2765 "../src/Photo.vala"
						_tmp14_ = date_time;
#line 2765 "../src/Photo.vala"
						_tmp11_ = _tmp13_->exposure_time != metadata_date_time_get_timestamp (_tmp14_);
#line 17489 "Photo.c"
					} else {
#line 2765 "../src/Photo.vala"
						_tmp11_ = FALSE;
#line 17493 "Photo.c"
					}
#line 2765 "../src/Photo.vala"
					_tmp8_ = _tmp11_;
#line 17497 "Photo.c"
				}
#line 2764 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 17501 "Photo.c"
			} else {
#line 2763 "../src/Photo.vala"
				_tmp5_ = FALSE;
#line 17505 "Photo.c"
			}
#line 2763 "../src/Photo.vala"
			result = _tmp5_;
#line 17509 "Photo.c"
			{
				PhotoRow* _tmp15_;
#line 2762 "../src/Photo.vala"
				_tmp15_ = self->row;
#line 2762 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17516 "Photo.c"
			}
#line 2763 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2763 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2763 "../src/Photo.vala"
			return result;
#line 17524 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp16_;
#line 2762 "../src/Photo.vala"
			_tmp16_ = self->row;
#line 2762 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17533 "Photo.c"
		}
#line 2762 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2762 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2762 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2762 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2762 "../src/Photo.vala"
		return _tmp17_;
#line 17545 "Photo.c"
	}
}

gboolean
photo_has_alterations (Photo* self)
{
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2769 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2770 "../src/Photo.vala"
	date_time = NULL;
#line 2771 "../src/Photo.vala"
	title = NULL;
#line 2772 "../src/Photo.vala"
	comment = NULL;
#line 2774 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2774 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2775 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2775 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 17577 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_;
		PhotoMetadata* _tmp6_;
		gchar* _tmp7_;
#line 2776 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2776 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2776 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2776 "../src/Photo.vala"
		date_time = _tmp3_;
#line 2777 "../src/Photo.vala"
		_tmp4_ = metadata;
#line 2777 "../src/Photo.vala"
		_tmp5_ = media_metadata_get_title ((MediaMetadata*) _tmp4_);
#line 2777 "../src/Photo.vala"
		_g_free0 (title);
#line 2777 "../src/Photo.vala"
		title = _tmp5_;
#line 2778 "../src/Photo.vala"
		_tmp6_ = metadata;
#line 2778 "../src/Photo.vala"
		_tmp7_ = media_metadata_get_comment ((MediaMetadata*) _tmp6_);
#line 2778 "../src/Photo.vala"
		_g_free0 (comment);
#line 2778 "../src/Photo.vala"
		comment = _tmp7_;
#line 17608 "Photo.c"
	}
#line 2782 "../src/Photo.vala"
	_tmp8_ = date_time;
#line 2782 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 17614 "Photo.c"
		{
			PhotoRow* _tmp9_;
#line 2784 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2784 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 17621 "Photo.c"
			{
				BackingPhotoRow* _tmp10_;
				PhotoRow* _tmp11_;
#line 2786 "../src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2786 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2786 "../src/Photo.vala"
				if (_tmp10_->timestamp != _tmp11_->exposure_time) {
#line 2788 "../src/Photo.vala"
					result = TRUE;
#line 17633 "Photo.c"
					{
						PhotoRow* _tmp12_;
#line 2784 "../src/Photo.vala"
						_tmp12_ = self->row;
#line 2784 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17640 "Photo.c"
					}
#line 2788 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2788 "../src/Photo.vala"
					_g_free0 (comment);
#line 2788 "../src/Photo.vala"
					_g_free0 (title);
#line 2788 "../src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2788 "../src/Photo.vala"
					return result;
#line 17652 "Photo.c"
				}
			}
			__finally0:
			{
				PhotoRow* _tmp13_;
#line 2784 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 2784 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17662 "Photo.c"
			}
#line 2784 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17666 "Photo.c"
				gboolean _tmp14_ = FALSE;
#line 2784 "../src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2784 "../src/Photo.vala"
				_g_free0 (comment);
#line 2784 "../src/Photo.vala"
				_g_free0 (title);
#line 2784 "../src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2784 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2784 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2784 "../src/Photo.vala"
				return _tmp14_;
#line 17682 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp15_;
		gboolean _tmp36_ = FALSE;
#line 2793 "../src/Photo.vala"
		_tmp15_ = self->row;
#line 2793 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17693 "Photo.c"
		{
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			PhotoRow* _tmp20_;
			GeeHashMap* _tmp21_;
#line 2794 "../src/Photo.vala"
			_tmp20_ = self->row;
#line 2794 "../src/Photo.vala"
			_tmp21_ = _tmp20_->transformations;
#line 2794 "../src/Photo.vala"
			if (_tmp21_ != NULL) {
#line 2794 "../src/Photo.vala"
				_tmp19_ = TRUE;
#line 17709 "Photo.c"
			} else {
				PhotoRow* _tmp22_;
				BackingPhotoRow* _tmp23_;
#line 2795 "../src/Photo.vala"
				_tmp22_ = self->row;
#line 2795 "../src/Photo.vala"
				_tmp23_ = self->backing_photo_row;
#line 2795 "../src/Photo.vala"
				_tmp19_ = _tmp22_->orientation != _tmp23_->original_orientation;
#line 17719 "Photo.c"
			}
#line 2794 "../src/Photo.vala"
			if (_tmp19_) {
#line 2794 "../src/Photo.vala"
				_tmp18_ = TRUE;
#line 17725 "Photo.c"
			} else {
				gboolean _tmp24_ = FALSE;
				MetadataDateTime* _tmp25_;
#line 2796 "../src/Photo.vala"
				_tmp25_ = date_time;
#line 2796 "../src/Photo.vala"
				if (_tmp25_ != NULL) {
#line 17733 "Photo.c"
					PhotoRow* _tmp26_;
					MetadataDateTime* _tmp27_;
#line 2796 "../src/Photo.vala"
					_tmp26_ = self->row;
#line 2796 "../src/Photo.vala"
					_tmp27_ = date_time;
#line 2796 "../src/Photo.vala"
					_tmp24_ = _tmp26_->exposure_time != metadata_date_time_get_timestamp (_tmp27_);
#line 17742 "Photo.c"
				} else {
#line 2796 "../src/Photo.vala"
					_tmp24_ = FALSE;
#line 17746 "Photo.c"
				}
#line 2796 "../src/Photo.vala"
				_tmp18_ = _tmp24_;
#line 17750 "Photo.c"
			}
#line 2794 "../src/Photo.vala"
			if (_tmp18_) {
#line 2794 "../src/Photo.vala"
				_tmp17_ = TRUE;
#line 17756 "Photo.c"
			} else {
				gchar* _tmp28_;
				gchar* _tmp29_;
				const gchar* _tmp30_;
#line 2797 "../src/Photo.vala"
				_tmp28_ = media_source_get_comment ((MediaSource*) self);
#line 2797 "../src/Photo.vala"
				_tmp29_ = _tmp28_;
#line 2797 "../src/Photo.vala"
				_tmp30_ = comment;
#line 2797 "../src/Photo.vala"
				_tmp17_ = g_strcmp0 (_tmp29_, _tmp30_) != 0;
#line 2797 "../src/Photo.vala"
				_g_free0 (_tmp29_);
#line 17771 "Photo.c"
			}
#line 2794 "../src/Photo.vala"
			if (_tmp17_) {
#line 2794 "../src/Photo.vala"
				_tmp16_ = TRUE;
#line 17777 "Photo.c"
			} else {
				gchar* _tmp31_;
				gchar* _tmp32_;
				const gchar* _tmp33_;
#line 2798 "../src/Photo.vala"
				_tmp31_ = media_source_get_title ((MediaSource*) self);
#line 2798 "../src/Photo.vala"
				_tmp32_ = _tmp31_;
#line 2798 "../src/Photo.vala"
				_tmp33_ = title;
#line 2798 "../src/Photo.vala"
				_tmp16_ = g_strcmp0 (_tmp32_, _tmp33_) != 0;
#line 2798 "../src/Photo.vala"
				_g_free0 (_tmp32_);
#line 17792 "Photo.c"
			}
#line 2794 "../src/Photo.vala"
			result = _tmp16_;
#line 17796 "Photo.c"
			{
				PhotoRow* _tmp34_;
#line 2793 "../src/Photo.vala"
				_tmp34_ = self->row;
#line 2793 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17803 "Photo.c"
			}
#line 2794 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2794 "../src/Photo.vala"
			_g_free0 (comment);
#line 2794 "../src/Photo.vala"
			_g_free0 (title);
#line 2794 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2794 "../src/Photo.vala"
			return result;
#line 17815 "Photo.c"
		}
		__finally1:
		{
			PhotoRow* _tmp35_;
#line 2793 "../src/Photo.vala"
			_tmp35_ = self->row;
#line 2793 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17824 "Photo.c"
		}
#line 2793 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2793 "../src/Photo.vala"
		_g_free0 (comment);
#line 2793 "../src/Photo.vala"
		_g_free0 (title);
#line 2793 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2793 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2793 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2793 "../src/Photo.vala"
		return _tmp36_;
#line 17840 "Photo.c"
	}
}

PhotoTransformationState*
photo_save_transformation_state (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoTransformationState* result;
#line 2803 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 17851 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2804 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2804 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17858 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			GeeHashMap* _tmp11_;
			PhotoRow* _tmp12_;
			GeeHashMap* _tmp13_;
			PhotoRow* _tmp14_;
			PhotoPhotoTransformationStateImpl* _tmp15_;
#line 2807 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2807 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 17875 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_;
#line 2807 "../src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2807 "../src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2807 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2807 "../src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 17886 "Photo.c"
			} else {
#line 2807 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2807 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 17892 "Photo.c"
			}
#line 2808 "../src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2808 "../src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 17898 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_;
#line 2808 "../src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2808 "../src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2808 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2808 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 17909 "Photo.c"
			} else {
#line 2808 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2808 "../src/Photo.vala"
				_tmp5_ = NULL;
#line 17915 "Photo.c"
			}
#line 2805 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2805 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 2805 "../src/Photo.vala"
			_tmp11_ = _tmp10_->transformations;
#line 2805 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2805 "../src/Photo.vala"
			_tmp13_ = _tmp12_->original_transforms;
#line 2805 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2805 "../src/Photo.vala"
			_tmp15_ = photo_photo_transformation_state_impl_new (self, _tmp9_->orientation, _tmp11_, _tmp1_, _tmp5_, _tmp13_, _tmp14_->enhanced);
#line 2805 "../src/Photo.vala"
			result = (PhotoTransformationState*) _tmp15_;
#line 2805 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2805 "../src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 17937 "Photo.c"
			{
				PhotoRow* _tmp16_;
#line 2804 "../src/Photo.vala"
				_tmp16_ = self->row;
#line 2804 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17944 "Photo.c"
			}
#line 2805 "../src/Photo.vala"
			return result;
#line 17948 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp17_;
#line 2804 "../src/Photo.vala"
			_tmp17_ = self->row;
#line 2804 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17957 "Photo.c"
		}
#line 2804 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2804 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2804 "../src/Photo.vala"
		return NULL;
#line 17965 "Photo.c"
	}
}

static gpointer
_pixel_transformer_ref0 (gpointer self)
{
#line 2835 "../src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 17974 "Photo.c"
}

static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 2836 "../src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 17982 "Photo.c"
}

gboolean
photo_load_transformation_state (Photo* self,
                                 PhotoTransformationState* state)
{
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoPhotoTransformationStateImpl* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	gboolean saved_enhanced = FALSE;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* saved_original_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp6_;
	GeeHashMap* _tmp7_;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp8_;
	PixelTransformer* _tmp9_;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp10_;
	PixelTransformationBundle* _tmp11_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2813 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2813 "../src/Photo.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 2814 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (state) ? ((PhotoPhotoTransformationStateImpl*) state) : NULL);
#line 2814 "../src/Photo.vala"
	state_impl = _tmp0_;
#line 2815 "../src/Photo.vala"
	_tmp1_ = state_impl;
#line 2815 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2816 "../src/Photo.vala"
		result = FALSE;
#line 2816 "../src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2816 "../src/Photo.vala"
		return result;
#line 18029 "Photo.c"
	}
#line 2819 "../src/Photo.vala"
	_tmp2_ = state_impl;
#line 2819 "../src/Photo.vala"
	saved_orientation = photo_photo_transformation_state_impl_get_orientation (_tmp2_);
#line 2820 "../src/Photo.vala"
	_tmp3_ = state_impl;
#line 2820 "../src/Photo.vala"
	saved_enhanced = photo_photo_transformation_state_impl_get_enhanced (_tmp3_);
#line 2821 "../src/Photo.vala"
	_tmp4_ = state_impl;
#line 2821 "../src/Photo.vala"
	_tmp5_ = photo_photo_transformation_state_impl_get_transformations (_tmp4_);
#line 2821 "../src/Photo.vala"
	saved_transformations = _tmp5_;
#line 2822 "../src/Photo.vala"
	_tmp6_ = state_impl;
#line 2822 "../src/Photo.vala"
	_tmp7_ = photo_photo_transformation_state_impl_get_original_transformations (_tmp6_);
#line 2822 "../src/Photo.vala"
	saved_original_transformations = _tmp7_;
#line 2823 "../src/Photo.vala"
	_tmp8_ = state_impl;
#line 2823 "../src/Photo.vala"
	_tmp9_ = photo_photo_transformation_state_impl_get_transformer (_tmp8_);
#line 2823 "../src/Photo.vala"
	saved_transformer = _tmp9_;
#line 2824 "../src/Photo.vala"
	_tmp10_ = state_impl;
#line 2824 "../src/Photo.vala"
	_tmp11_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp10_);
#line 2824 "../src/Photo.vala"
	saved_adjustments = _tmp11_;
#line 18063 "Photo.c"
	{
		PhotoRow* _tmp12_;
#line 2827 "../src/Photo.vala"
		_tmp12_ = self->row;
#line 2827 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18070 "Photo.c"
		{
			PhotoTable* _tmp13_;
			PhotoTable* _tmp14_;
			PhotoRow* _tmp15_;
			PhotoID _tmp16_;
			GeeHashMap* _tmp17_;
			GeeHashMap* _tmp18_;
#line 2828 "../src/Photo.vala"
			_tmp13_ = photo_table_get_instance ();
#line 2828 "../src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 2828 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2828 "../src/Photo.vala"
			_tmp16_ = _tmp15_->photo_id;
#line 2828 "../src/Photo.vala"
			_tmp17_ = saved_transformations;
#line 2828 "../src/Photo.vala"
			_tmp18_ = saved_transformations;
#line 2828 "../src/Photo.vala"
			committed = photo_table_set_transformation_state (_tmp14_, &_tmp16_, saved_orientation, _tmp17_, _tmp18_, saved_enhanced);
#line 2828 "../src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 2830 "../src/Photo.vala"
			if (committed) {
#line 18096 "Photo.c"
				PhotoRow* _tmp19_;
				PhotoRow* _tmp20_;
				GeeHashMap* _tmp21_;
				GeeHashMap* _tmp22_;
				PhotoRow* _tmp23_;
				GeeHashMap* _tmp24_;
				GeeHashMap* _tmp25_;
				PhotoRow* _tmp26_;
				PixelTransformer* _tmp27_;
				PixelTransformer* _tmp28_;
				PixelTransformationBundle* _tmp29_;
				PixelTransformationBundle* _tmp30_;
#line 2831 "../src/Photo.vala"
				_tmp19_ = self->row;
#line 2831 "../src/Photo.vala"
				_tmp19_->orientation = saved_orientation;
#line 2832 "../src/Photo.vala"
				_tmp20_ = self->row;
#line 2832 "../src/Photo.vala"
				_tmp21_ = saved_transformations;
#line 2832 "../src/Photo.vala"
				_tmp22_ = _g_object_ref0 (_tmp21_);
#line 2832 "../src/Photo.vala"
				_g_object_unref0 (_tmp20_->transformations);
#line 2832 "../src/Photo.vala"
				_tmp20_->transformations = _tmp22_;
#line 2833 "../src/Photo.vala"
				_tmp23_ = self->row;
#line 2833 "../src/Photo.vala"
				_tmp24_ = saved_original_transformations;
#line 2833 "../src/Photo.vala"
				_tmp25_ = _g_object_ref0 (_tmp24_);
#line 2833 "../src/Photo.vala"
				_g_object_unref0 (_tmp23_->original_transforms);
#line 2833 "../src/Photo.vala"
				_tmp23_->original_transforms = _tmp25_;
#line 2834 "../src/Photo.vala"
				_tmp26_ = self->row;
#line 2834 "../src/Photo.vala"
				_tmp26_->enhanced = saved_enhanced;
#line 2835 "../src/Photo.vala"
				_tmp27_ = saved_transformer;
#line 2835 "../src/Photo.vala"
				_tmp28_ = _pixel_transformer_ref0 (_tmp27_);
#line 2835 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2835 "../src/Photo.vala"
				self->priv->transformer = _tmp28_;
#line 2836 "../src/Photo.vala"
				_tmp29_ = saved_adjustments;
#line 2836 "../src/Photo.vala"
				_tmp30_ = _pixel_transformation_bundle_ref0 (_tmp29_);
#line 2836 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2836 "../src/Photo.vala"
				self->priv->adjustments = _tmp30_;
#line 18153 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp31_;
#line 2827 "../src/Photo.vala"
			_tmp31_ = self->row;
#line 2827 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18163 "Photo.c"
		}
#line 2827 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18167 "Photo.c"
			gboolean _tmp32_ = FALSE;
#line 2827 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2827 "../src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2827 "../src/Photo.vala"
			_g_object_unref0 (saved_original_transformations);
#line 2827 "../src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2827 "../src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2827 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2827 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2827 "../src/Photo.vala"
			return _tmp32_;
#line 18185 "Photo.c"
		}
	}
#line 2840 "../src/Photo.vala"
	if (committed) {
#line 18190 "Photo.c"
		Alteration* _tmp33_;
		Alteration* _tmp34_;
#line 2841 "../src/Photo.vala"
		_tmp33_ = alteration_new ("image", "transformation-state");
#line 2841 "../src/Photo.vala"
		_tmp34_ = _tmp33_;
#line 2841 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp34_);
#line 2841 "../src/Photo.vala"
		_alteration_unref0 (_tmp34_);
#line 18201 "Photo.c"
	}
#line 2844 "../src/Photo.vala"
	result = committed;
#line 2844 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2844 "../src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2844 "../src/Photo.vala"
	_g_object_unref0 (saved_original_transformations);
#line 2844 "../src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2844 "../src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2844 "../src/Photo.vala"
	return result;
#line 18217 "Photo.c"
}

void
photo_remove_all_transformations (Photo* self)
{
#line 2847 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2848 "../src/Photo.vala"
	photo_internal_remove_all_transformations (self, TRUE);
#line 18227 "Photo.c"
}

static void
photo_internal_remove_all_transformations (Photo* self,
                                           gboolean notify)
{
	gboolean is_altered = FALSE;
	gboolean _tmp17_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 2851 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2852 "../src/Photo.vala"
	is_altered = FALSE;
#line 18241 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2853 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2853 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18248 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			PhotoRow* _tmp5_;
			PhotoRow* _tmp6_;
			PhotoRow* _tmp7_;
			BackingPhotoRow* _tmp8_;
#line 2854 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2854 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2854 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2854 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2854 "../src/Photo.vala"
			is_altered = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2854 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2855 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2855 "../src/Photo.vala"
			_g_object_unref0 (_tmp5_->transformations);
#line 2855 "../src/Photo.vala"
			_tmp5_->transformations = NULL;
#line 2856 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2856 "../src/Photo.vala"
			_tmp6_->enhanced = FALSE;
#line 2857 "../src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2857 "../src/Photo.vala"
			self->priv->transformer = NULL;
#line 2858 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2858 "../src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2860 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2860 "../src/Photo.vala"
			_tmp8_ = self->backing_photo_row;
#line 2860 "../src/Photo.vala"
			if (_tmp7_->orientation != _tmp8_->original_orientation) {
#line 18294 "Photo.c"
				PhotoTable* _tmp9_;
				PhotoTable* _tmp10_;
				PhotoRow* _tmp11_;
				PhotoID _tmp12_;
				BackingPhotoRow* _tmp13_;
				PhotoRow* _tmp14_;
				BackingPhotoRow* _tmp15_;
#line 2861 "../src/Photo.vala"
				_tmp9_ = photo_table_get_instance ();
#line 2861 "../src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 2861 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2861 "../src/Photo.vala"
				_tmp12_ = _tmp11_->photo_id;
#line 2861 "../src/Photo.vala"
				_tmp13_ = self->backing_photo_row;
#line 2861 "../src/Photo.vala"
				photo_table_set_orientation (_tmp10_, &_tmp12_, _tmp13_->original_orientation);
#line 2861 "../src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 2863 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2863 "../src/Photo.vala"
				_tmp15_ = self->backing_photo_row;
#line 2863 "../src/Photo.vala"
				_tmp14_->orientation = _tmp15_->original_orientation;
#line 2864 "../src/Photo.vala"
				is_altered = TRUE;
#line 18324 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp16_;
#line 2853 "../src/Photo.vala"
			_tmp16_ = self->row;
#line 2853 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18334 "Photo.c"
		}
#line 2853 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2853 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2853 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2853 "../src/Photo.vala"
			return;
#line 18344 "Photo.c"
		}
	}
#line 2868 "../src/Photo.vala"
	if (is_altered) {
#line 2868 "../src/Photo.vala"
		_tmp17_ = notify;
#line 18351 "Photo.c"
	} else {
#line 2868 "../src/Photo.vala"
		_tmp17_ = FALSE;
#line 18355 "Photo.c"
	}
#line 2868 "../src/Photo.vala"
	if (_tmp17_) {
#line 18359 "Photo.c"
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 2869 "../src/Photo.vala"
		_tmp18_ = alteration_new ("image", "revert");
#line 2869 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2869 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp19_);
#line 2869 "../src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 18370 "Photo.c"
	}
}

Orientation
photo_get_original_orientation (Photo* self)
{
	GError* _inner_error0_ = NULL;
	Orientation result;
#line 2873 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 18381 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2874 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2874 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18388 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2875 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2875 "../src/Photo.vala"
			result = _tmp1_->original_orientation;
#line 18395 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2874 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2874 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18402 "Photo.c"
			}
#line 2875 "../src/Photo.vala"
			return result;
#line 18406 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2874 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2874 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18415 "Photo.c"
		}
#line 2874 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2874 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2874 "../src/Photo.vala"
		return 0;
#line 18423 "Photo.c"
	}
}

Orientation
photo_get_orientation (Photo* self)
{
	GError* _inner_error0_ = NULL;
	Orientation result;
#line 2879 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 18434 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2880 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2880 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18441 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2881 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2881 "../src/Photo.vala"
			result = _tmp1_->orientation;
#line 18448 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2880 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2880 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18455 "Photo.c"
			}
#line 2881 "../src/Photo.vala"
			return result;
#line 18459 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2880 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2880 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18468 "Photo.c"
		}
#line 2880 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2880 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2880 "../src/Photo.vala"
		return 0;
#line 18476 "Photo.c"
	}
}

gboolean
photo_set_orientation (Photo* self,
                       Orientation orientation)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2885 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2886 "../src/Photo.vala"
	committed = FALSE;
#line 18491 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2887 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2887 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18498 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2888 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2888 "../src/Photo.vala"
			if (_tmp1_->orientation != orientation) {
#line 18505 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoRow* _tmp4_;
				PhotoID _tmp5_;
#line 2889 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2889 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2889 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2889 "../src/Photo.vala"
				_tmp5_ = _tmp4_->photo_id;
#line 2889 "../src/Photo.vala"
				committed = photo_table_set_orientation (_tmp3_, &_tmp5_, orientation);
#line 2889 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2890 "../src/Photo.vala"
				if (committed) {
#line 18524 "Photo.c"
					PhotoRow* _tmp6_;
#line 2891 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2891 "../src/Photo.vala"
					_tmp6_->orientation = orientation;
#line 18530 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2887 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2887 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18541 "Photo.c"
		}
#line 2887 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18545 "Photo.c"
			gboolean _tmp8_ = FALSE;
#line 2887 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2887 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2887 "../src/Photo.vala"
			return _tmp8_;
#line 18553 "Photo.c"
		}
	}
#line 2895 "../src/Photo.vala"
	if (committed) {
#line 18558 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2896 "../src/Photo.vala"
		_tmp9_ = alteration_new ("image", "orientation");
#line 2896 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2896 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp10_);
#line 2896 "../src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 18569 "Photo.c"
	}
#line 2899 "../src/Photo.vala"
	result = committed;
#line 2899 "../src/Photo.vala"
	return result;
#line 18575 "Photo.c"
}

gboolean
photo_check_can_rotate (Photo* self)
{
	gboolean result;
#line 2902 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2903 "../src/Photo.vala"
	result = self->can_rotate_now;
#line 2903 "../src/Photo.vala"
	return result;
#line 18588 "Photo.c"
}

static void
photo_real_rotate (Photo* self,
                   Rotation rotation)
{
	GError* _inner_error0_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2907 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2907 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18602 "Photo.c"
		{
#line 2908 "../src/Photo.vala"
			photo_set_orientation (self, orientation_perform (photo_get_orientation (self), rotation));
#line 18606 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp1_;
#line 2907 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2907 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18615 "Photo.c"
		}
#line 2907 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2907 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2907 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2907 "../src/Photo.vala"
			return;
#line 18625 "Photo.c"
		}
	}
}

void
photo_rotate (Photo* self,
              Rotation rotation)
{
	PhotoClass* _klass_;
#line 2906 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2906 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 2906 "../src/Photo.vala"
	if (_klass_->rotate) {
#line 2906 "../src/Photo.vala"
		_klass_->rotate (self, rotation);
#line 18643 "Photo.c"
	}
}

static gboolean
photo_has_transformation (Photo* self,
                          const gchar* name)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2912 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2912 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 18657 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2913 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2913 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18665 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2914 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2914 "../src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2914 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 18676 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2914 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2914 "../src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2914 "../src/Photo.vala"
				_tmp1_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, name);
#line 18685 "Photo.c"
			} else {
#line 2914 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 18689 "Photo.c"
			}
#line 2914 "../src/Photo.vala"
			result = _tmp1_;
#line 18693 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2913 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2913 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18700 "Photo.c"
			}
#line 2914 "../src/Photo.vala"
			return result;
#line 18704 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2913 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2913 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18713 "Photo.c"
		}
#line 2913 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2913 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2913 "../src/Photo.vala"
		return _tmp8_;
#line 18721 "Photo.c"
	}
}

static KeyValueMap*
photo_get_transformation (Photo* self,
                          const gchar* name)
{
	KeyValueMap* map = NULL;
	GError* _inner_error0_ = NULL;
	KeyValueMap* result;
#line 2921 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2921 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2922 "../src/Photo.vala"
	map = NULL;
#line 18738 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2923 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2923 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18745 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2924 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2924 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2924 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 18755 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				gpointer _tmp5_;
				KeyValueMap* _tmp6_;
#line 2925 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2925 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2925 "../src/Photo.vala"
				_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, name);
#line 2925 "../src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2925 "../src/Photo.vala"
				map = (KeyValueMap*) _tmp5_;
#line 2926 "../src/Photo.vala"
				_tmp6_ = map;
#line 2926 "../src/Photo.vala"
				if (_tmp6_ != NULL) {
#line 18774 "Photo.c"
					KeyValueMap* _tmp7_;
					KeyValueMap* _tmp8_;
#line 2927 "../src/Photo.vala"
					_tmp7_ = map;
#line 2927 "../src/Photo.vala"
					_tmp8_ = key_value_map_copy (_tmp7_);
#line 2927 "../src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2927 "../src/Photo.vala"
					map = _tmp8_;
#line 18785 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp9_;
#line 2923 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2923 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18796 "Photo.c"
		}
#line 2923 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2923 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2923 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2923 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2923 "../src/Photo.vala"
			return NULL;
#line 18808 "Photo.c"
		}
	}
#line 2932 "../src/Photo.vala"
	result = map;
#line 2932 "../src/Photo.vala"
	return result;
#line 18815 "Photo.c"
}

static gboolean
photo_set_transformation (Photo* self,
                          KeyValueMap* trans)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2935 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2935 "../src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 18828 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2936 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2936 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18836 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2937 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2937 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2937 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 18855 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2938 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2938 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2938 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2938 "../src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 18866 "Photo.c"
			}
#line 2941 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2941 "../src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2941 "../src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2941 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2941 "../src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp8_, trans);
#line 2941 "../src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2943 "../src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2943 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2943 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2943 "../src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2943 "../src/Photo.vala"
			_tmp13_ = photo_table_set_transformation (_tmp10_, &_tmp12_, trans);
#line 2943 "../src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2943 "../src/Photo.vala"
			result = _tmp13_;
#line 18894 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2936 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2936 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18901 "Photo.c"
			}
#line 2943 "../src/Photo.vala"
			return result;
#line 18905 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp15_;
#line 2936 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2936 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18914 "Photo.c"
		}
#line 2936 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2936 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2936 "../src/Photo.vala"
		return _tmp16_;
#line 18922 "Photo.c"
	}
}

static gboolean
photo_set_original_transforms (Photo* self,
                               KeyValueMap* trans)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2947 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2947 "../src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 18936 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2948 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2948 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18944 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2949 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2949 "../src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2949 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 18963 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2950 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2950 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2950 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2950 "../src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 18974 "Photo.c"
			}
#line 2953 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2953 "../src/Photo.vala"
			_tmp6_ = _tmp5_->original_transforms;
#line 2953 "../src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2953 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2953 "../src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp8_, trans);
#line 2953 "../src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2955 "../src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2955 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2955 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2955 "../src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2955 "../src/Photo.vala"
			_tmp13_ = photo_table_set_original_transforms (_tmp10_, &_tmp12_, trans);
#line 2955 "../src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2955 "../src/Photo.vala"
			result = _tmp13_;
#line 19002 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2948 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2948 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19009 "Photo.c"
			}
#line 2955 "../src/Photo.vala"
			return result;
#line 19013 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp15_;
#line 2948 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2948 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19022 "Photo.c"
		}
#line 2948 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2948 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2948 "../src/Photo.vala"
		return _tmp16_;
#line 19030 "Photo.c"
	}
}

static gboolean
photo_clear_original_transforms (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2959 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 19041 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 2960 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2960 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19049 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp5_;
			PhotoTable* _tmp6_;
			PhotoRow* _tmp7_;
			PhotoID _tmp8_;
			gboolean _tmp9_;
#line 2961 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2961 "../src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2961 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 19064 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2962 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2962 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2962 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2962 "../src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 19075 "Photo.c"
			}
#line 2964 "../src/Photo.vala"
			_tmp5_ = photo_table_get_instance ();
#line 2964 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 2964 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2964 "../src/Photo.vala"
			_tmp8_ = _tmp7_->photo_id;
#line 2964 "../src/Photo.vala"
			_tmp9_ = photo_table_set_original_transforms (_tmp6_, &_tmp8_, NULL);
#line 2964 "../src/Photo.vala"
			_database_table_unref0 (_tmp6_);
#line 2964 "../src/Photo.vala"
			result = _tmp9_;
#line 19091 "Photo.c"
			{
				PhotoRow* _tmp10_;
#line 2960 "../src/Photo.vala"
				_tmp10_ = self->row;
#line 2960 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19098 "Photo.c"
			}
#line 2964 "../src/Photo.vala"
			return result;
#line 19102 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp11_;
#line 2960 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2960 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19111 "Photo.c"
		}
#line 2960 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2960 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2960 "../src/Photo.vala"
		return _tmp12_;
#line 19119 "Photo.c"
	}
}

static gboolean
photo_remove_transformation (Photo* self,
                             const gchar* name)
{
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2968 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2968 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 19136 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2970 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2970 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19143 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
#line 2971 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2971 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2971 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 19157 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				PhotoRow* _tmp5_;
				GeeHashMap* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 2972 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2972 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2972 "../src/Photo.vala"
				altered_cache = gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, name, NULL);
#line 2973 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2973 "../src/Photo.vala"
				_tmp6_ = _tmp5_->transformations;
#line 2973 "../src/Photo.vala"
				_tmp7_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp6_);
#line 2973 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2973 "../src/Photo.vala"
				if (_tmp8_ == 0) {
#line 19180 "Photo.c"
					PhotoRow* _tmp9_;
#line 2974 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 2974 "../src/Photo.vala"
					_g_object_unref0 (_tmp9_->transformations);
#line 2974 "../src/Photo.vala"
					_tmp9_->transformations = NULL;
#line 19188 "Photo.c"
				}
			} else {
#line 2977 "../src/Photo.vala"
				altered_cache = FALSE;
#line 19193 "Photo.c"
			}
#line 2980 "../src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2980 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2980 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2980 "../src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2980 "../src/Photo.vala"
			altered_persistent = photo_table_remove_transformation (_tmp11_, &_tmp13_, name);
#line 2980 "../src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 19207 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2970 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2970 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19216 "Photo.c"
		}
#line 2970 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19220 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2970 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2970 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2970 "../src/Photo.vala"
			return _tmp15_;
#line 19228 "Photo.c"
		}
	}
#line 2984 "../src/Photo.vala"
	if (altered_cache) {
#line 2984 "../src/Photo.vala"
		_tmp16_ = TRUE;
#line 19235 "Photo.c"
	} else {
#line 2984 "../src/Photo.vala"
		_tmp16_ = altered_persistent;
#line 19239 "Photo.c"
	}
#line 2984 "../src/Photo.vala"
	result = _tmp16_;
#line 2984 "../src/Photo.vala"
	return result;
#line 19245 "Photo.c"
}

gboolean
photo_has_crop (Photo* self)
{
	gboolean result;
#line 2987 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2988 "../src/Photo.vala"
	result = photo_has_transformation (self, "crop");
#line 2988 "../src/Photo.vala"
	return result;
#line 19258 "Photo.c"
}

gboolean
photo_get_raw_crop (Photo* self,
                    Box* crop)
{
	Box _vala_crop = {0};
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint left = 0;
	KeyValueMap* _tmp2_;
	gint top = 0;
	KeyValueMap* _tmp3_;
	gint right = 0;
	KeyValueMap* _tmp4_;
	gint bottom = 0;
	KeyValueMap* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean result;
#line 2992 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2993 "../src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2995 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2995 "../src/Photo.vala"
	map = _tmp0_;
#line 2996 "../src/Photo.vala"
	_tmp1_ = map;
#line 2996 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2997 "../src/Photo.vala"
		result = FALSE;
#line 2997 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2997 "../src/Photo.vala"
		if (crop) {
#line 2997 "../src/Photo.vala"
			*crop = _vala_crop;
#line 19301 "Photo.c"
		}
#line 2997 "../src/Photo.vala"
		return result;
#line 19305 "Photo.c"
	}
#line 3000 "../src/Photo.vala"
	_tmp2_ = map;
#line 3000 "../src/Photo.vala"
	left = key_value_map_get_int (_tmp2_, "left", -1);
#line 3001 "../src/Photo.vala"
	_tmp3_ = map;
#line 3001 "../src/Photo.vala"
	top = key_value_map_get_int (_tmp3_, "top", -1);
#line 3002 "../src/Photo.vala"
	_tmp4_ = map;
#line 3002 "../src/Photo.vala"
	right = key_value_map_get_int (_tmp4_, "right", -1);
#line 3003 "../src/Photo.vala"
	_tmp5_ = map;
#line 3003 "../src/Photo.vala"
	bottom = key_value_map_get_int (_tmp5_, "bottom", -1);
#line 3005 "../src/Photo.vala"
	if (left == -1) {
#line 3005 "../src/Photo.vala"
		_tmp8_ = TRUE;
#line 19327 "Photo.c"
	} else {
#line 3005 "../src/Photo.vala"
		_tmp8_ = top == -1;
#line 19331 "Photo.c"
	}
#line 3005 "../src/Photo.vala"
	if (_tmp8_) {
#line 3005 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 19337 "Photo.c"
	} else {
#line 3005 "../src/Photo.vala"
		_tmp7_ = right == -1;
#line 19341 "Photo.c"
	}
#line 3005 "../src/Photo.vala"
	if (_tmp7_) {
#line 3005 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 19347 "Photo.c"
	} else {
#line 3005 "../src/Photo.vala"
		_tmp6_ = bottom == -1;
#line 19351 "Photo.c"
	}
#line 3005 "../src/Photo.vala"
	if (_tmp6_) {
#line 3006 "../src/Photo.vala"
		result = FALSE;
#line 3006 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3006 "../src/Photo.vala"
		if (crop) {
#line 3006 "../src/Photo.vala"
			*crop = _vala_crop;
#line 19363 "Photo.c"
		}
#line 3006 "../src/Photo.vala"
		return result;
#line 19367 "Photo.c"
	}
#line 3009 "../src/Photo.vala"
	box_init (&_vala_crop, left, top, right, bottom);
#line 3011 "../src/Photo.vala"
	result = TRUE;
#line 3011 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3011 "../src/Photo.vala"
	if (crop) {
#line 3011 "../src/Photo.vala"
		*crop = _vala_crop;
#line 19379 "Photo.c"
	}
#line 3011 "../src/Photo.vala"
	return result;
#line 19383 "Photo.c"
}

static void
photo_set_raw_crop (Photo* self,
                    Box* crop)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	KeyValueMap* _tmp3_;
	Box _tmp4_;
	KeyValueMap* _tmp5_;
	Box _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	KeyValueMap* _tmp9_;
#line 3015 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3015 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 3016 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 3016 "../src/Photo.vala"
	map = _tmp0_;
#line 3017 "../src/Photo.vala"
	_tmp1_ = map;
#line 3017 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 3017 "../src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp2_.left);
#line 3018 "../src/Photo.vala"
	_tmp3_ = map;
#line 3018 "../src/Photo.vala"
	_tmp4_ = *crop;
#line 3018 "../src/Photo.vala"
	key_value_map_set_int (_tmp3_, "top", _tmp4_.top);
#line 3019 "../src/Photo.vala"
	_tmp5_ = map;
#line 3019 "../src/Photo.vala"
	_tmp6_ = *crop;
#line 3019 "../src/Photo.vala"
	key_value_map_set_int (_tmp5_, "right", _tmp6_.right);
#line 3020 "../src/Photo.vala"
	_tmp7_ = map;
#line 3020 "../src/Photo.vala"
	_tmp8_ = *crop;
#line 3020 "../src/Photo.vala"
	key_value_map_set_int (_tmp7_, "bottom", _tmp8_.bottom);
#line 3022 "../src/Photo.vala"
	_tmp9_ = map;
#line 3022 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp9_)) {
#line 19437 "Photo.c"
		Alteration* _tmp10_;
		Alteration* _tmp11_;
#line 3023 "../src/Photo.vala"
		_tmp10_ = alteration_new ("image", "crop");
#line 3023 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 3023 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp11_);
#line 3023 "../src/Photo.vala"
		_alteration_unref0 (_tmp11_);
#line 19448 "Photo.c"
	}
#line 3015 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19452 "Photo.c"
}

static gboolean
photo_get_raw_straighten (Photo* self,
                          gdouble* angle)
{
	gdouble _vala_angle = 0.0;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	gboolean result;
#line 3027 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3028 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 3028 "../src/Photo.vala"
	map = _tmp0_;
#line 3029 "../src/Photo.vala"
	_tmp1_ = map;
#line 3029 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 3030 "../src/Photo.vala"
		_vala_angle = 0.0;
#line 3032 "../src/Photo.vala"
		result = FALSE;
#line 3032 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3032 "../src/Photo.vala"
		if (angle) {
#line 3032 "../src/Photo.vala"
			*angle = _vala_angle;
#line 19485 "Photo.c"
		}
#line 3032 "../src/Photo.vala"
		return result;
#line 19489 "Photo.c"
	}
#line 3035 "../src/Photo.vala"
	_tmp2_ = map;
#line 3035 "../src/Photo.vala"
	_vala_angle = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 3037 "../src/Photo.vala"
	result = TRUE;
#line 3037 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3037 "../src/Photo.vala"
	if (angle) {
#line 3037 "../src/Photo.vala"
		*angle = _vala_angle;
#line 19503 "Photo.c"
	}
#line 3037 "../src/Photo.vala"
	return result;
#line 19507 "Photo.c"
}

static void
photo_set_raw_straighten (Photo* self,
                          gdouble theta)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 3040 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3041 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 3041 "../src/Photo.vala"
	map = _tmp0_;
#line 3042 "../src/Photo.vala"
	_tmp1_ = map;
#line 3042 "../src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", theta);
#line 3044 "../src/Photo.vala"
	_tmp2_ = map;
#line 3044 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp2_)) {
#line 19532 "Photo.c"
		Alteration* _tmp3_;
		Alteration* _tmp4_;
#line 3045 "../src/Photo.vala"
		_tmp3_ = alteration_new ("image", "straighten");
#line 3045 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 3045 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp4_);
#line 3045 "../src/Photo.vala"
		_alteration_unref0 (_tmp4_);
#line 19543 "Photo.c"
	}
#line 3040 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19547 "Photo.c"
}

static EditingToolsRedeyeInstance*
photo_get_raw_redeye_instances (Photo* self,
                                gint* result_length1)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	EditingToolsRedeyeInstance* res = NULL;
	EditingToolsRedeyeInstance* _tmp5_;
	gint res_length1;
	gint _res_size_;
	GdkPoint default_point = {0};
	GdkPoint _tmp6_ = {0};
	EditingToolsRedeyeInstance* _tmp29_;
	gint _tmp29__length1;
	EditingToolsRedeyeInstance* result;
#line 3050 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3051 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3051 "../src/Photo.vala"
	map = _tmp0_;
#line 3052 "../src/Photo.vala"
	_tmp1_ = map;
#line 3052 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 19578 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 3053 "../src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 3053 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3053 "../src/Photo.vala"
		_tmp3__length1 = 0;
#line 3053 "../src/Photo.vala"
		if (result_length1) {
#line 3053 "../src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 19592 "Photo.c"
		}
#line 3053 "../src/Photo.vala"
		result = _tmp3_;
#line 3053 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3053 "../src/Photo.vala"
		return result;
#line 19600 "Photo.c"
	}
#line 3056 "../src/Photo.vala"
	_tmp4_ = map;
#line 3056 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3057 "../src/Photo.vala"
	_vala_assert (num_points > 0, "num_points > 0");
#line 3059 "../src/Photo.vala"
	_tmp5_ = g_new0 (EditingToolsRedeyeInstance, num_points);
#line 3059 "../src/Photo.vala"
	res = _tmp5_;
#line 3059 "../src/Photo.vala"
	res_length1 = num_points;
#line 3059 "../src/Photo.vala"
	_res_size_ = res_length1;
#line 3061 "../src/Photo.vala"
	_tmp6_.x = 0;
#line 3061 "../src/Photo.vala"
	default_point = _tmp6_;
#line 3062 "../src/Photo.vala"
	default_point.x = -1;
#line 3063 "../src/Photo.vala"
	default_point.y = -1;
#line 19624 "Photo.c"
	{
		gint i = 0;
#line 3065 "../src/Photo.vala"
		i = 0;
#line 19629 "Photo.c"
		{
			gboolean _tmp7_ = FALSE;
#line 3065 "../src/Photo.vala"
			_tmp7_ = TRUE;
#line 3065 "../src/Photo.vala"
			while (TRUE) {
#line 19636 "Photo.c"
				gchar* center_key = NULL;
				gchar* _tmp9_;
				gchar* radius_key = NULL;
				gchar* _tmp10_;
				EditingToolsRedeyeInstance* _tmp11_;
				gint _tmp11__length1;
				KeyValueMap* _tmp12_;
				const gchar* _tmp13_;
				GdkPoint _tmp14_;
				GdkPoint _tmp15_ = {0};
				EditingToolsRedeyeInstance* _tmp16_;
				gint _tmp16__length1;
				EditingToolsRedeyeInstance _tmp17_;
				GdkPoint _tmp18_;
				GdkPoint _tmp19_;
				EditingToolsRedeyeInstance* _tmp20_;
				gint _tmp20__length1;
				EditingToolsRedeyeInstance _tmp21_;
				GdkPoint _tmp22_;
				GdkPoint _tmp23_;
				EditingToolsRedeyeInstance* _tmp24_;
				gint _tmp24__length1;
				KeyValueMap* _tmp25_;
				const gchar* _tmp26_;
				EditingToolsRedeyeInstance* _tmp27_;
				gint _tmp27__length1;
				EditingToolsRedeyeInstance _tmp28_;
#line 3065 "../src/Photo.vala"
				if (!_tmp7_) {
#line 19666 "Photo.c"
					gint _tmp8_;
#line 3065 "../src/Photo.vala"
					_tmp8_ = i;
#line 3065 "../src/Photo.vala"
					i = _tmp8_ + 1;
#line 19672 "Photo.c"
				}
#line 3065 "../src/Photo.vala"
				_tmp7_ = FALSE;
#line 3065 "../src/Photo.vala"
				if (!(i < num_points)) {
#line 3065 "../src/Photo.vala"
					break;
#line 19680 "Photo.c"
				}
#line 3066 "../src/Photo.vala"
				_tmp9_ = g_strdup_printf ("center%d", i);
#line 3066 "../src/Photo.vala"
				center_key = _tmp9_;
#line 3067 "../src/Photo.vala"
				_tmp10_ = g_strdup_printf ("radius%d", i);
#line 3067 "../src/Photo.vala"
				radius_key = _tmp10_;
#line 3069 "../src/Photo.vala"
				_tmp11_ = res;
#line 3069 "../src/Photo.vala"
				_tmp11__length1 = res_length1;
#line 3069 "../src/Photo.vala"
				_tmp12_ = map;
#line 3069 "../src/Photo.vala"
				_tmp13_ = center_key;
#line 3069 "../src/Photo.vala"
				_tmp14_ = default_point;
#line 3069 "../src/Photo.vala"
				key_value_map_get_point (_tmp12_, _tmp13_, &_tmp14_, &_tmp15_);
#line 3069 "../src/Photo.vala"
				_tmp11_[i].center = _tmp15_;
#line 3070 "../src/Photo.vala"
				_tmp16_ = res;
#line 3070 "../src/Photo.vala"
				_tmp16__length1 = res_length1;
#line 3070 "../src/Photo.vala"
				_tmp17_ = _tmp16_[i];
#line 3070 "../src/Photo.vala"
				_tmp18_ = _tmp17_.center;
#line 3070 "../src/Photo.vala"
				_tmp19_ = default_point;
#line 3070 "../src/Photo.vala"
				_vala_assert (_tmp18_.x != _tmp19_.x, "res[i].center.x != default_point.x");
#line 3071 "../src/Photo.vala"
				_tmp20_ = res;
#line 3071 "../src/Photo.vala"
				_tmp20__length1 = res_length1;
#line 3071 "../src/Photo.vala"
				_tmp21_ = _tmp20_[i];
#line 3071 "../src/Photo.vala"
				_tmp22_ = _tmp21_.center;
#line 3071 "../src/Photo.vala"
				_tmp23_ = default_point;
#line 3071 "../src/Photo.vala"
				_vala_assert (_tmp22_.y != _tmp23_.y, "res[i].center.y != default_point.y");
#line 3073 "../src/Photo.vala"
				_tmp24_ = res;
#line 3073 "../src/Photo.vala"
				_tmp24__length1 = res_length1;
#line 3073 "../src/Photo.vala"
				_tmp25_ = map;
#line 3073 "../src/Photo.vala"
				_tmp26_ = radius_key;
#line 3073 "../src/Photo.vala"
				_tmp24_[i].radius = key_value_map_get_int (_tmp25_, _tmp26_, -1);
#line 3074 "../src/Photo.vala"
				_tmp27_ = res;
#line 3074 "../src/Photo.vala"
				_tmp27__length1 = res_length1;
#line 3074 "../src/Photo.vala"
				_tmp28_ = _tmp27_[i];
#line 3074 "../src/Photo.vala"
				_vala_assert (_tmp28_.radius != -1, "res[i].radius != -1");
#line 3065 "../src/Photo.vala"
				_g_free0 (radius_key);
#line 3065 "../src/Photo.vala"
				_g_free0 (center_key);
#line 19750 "Photo.c"
			}
		}
	}
#line 3077 "../src/Photo.vala"
	_tmp29_ = res;
#line 3077 "../src/Photo.vala"
	_tmp29__length1 = res_length1;
#line 3077 "../src/Photo.vala"
	if (result_length1) {
#line 3077 "../src/Photo.vala"
		*result_length1 = _tmp29__length1;
#line 19762 "Photo.c"
	}
#line 3077 "../src/Photo.vala"
	result = _tmp29_;
#line 3077 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3077 "../src/Photo.vala"
	return result;
#line 19770 "Photo.c"
}

gboolean
photo_has_redeye_transformations (Photo* self)
{
	gboolean result;
#line 3080 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3081 "../src/Photo.vala"
	result = photo_has_transformation (self, "redeye");
#line 3081 "../src/Photo.vala"
	return result;
#line 19783 "Photo.c"
}

void
photo_add_redeye_instance (Photo* self,
                           EditingToolsRedeyeInstance* redeye)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	gchar* radius_key = NULL;
	gchar* _tmp6_;
	gchar* center_key = NULL;
	gchar* _tmp7_;
	KeyValueMap* _tmp8_;
	const gchar* _tmp9_;
	EditingToolsRedeyeInstance _tmp10_;
	KeyValueMap* _tmp11_;
	const gchar* _tmp12_;
	EditingToolsRedeyeInstance _tmp13_;
	GdkPoint _tmp14_;
	KeyValueMap* _tmp15_;
	KeyValueMap* _tmp16_;
#line 3085 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3085 "../src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 3086 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3086 "../src/Photo.vala"
	map = _tmp0_;
#line 3087 "../src/Photo.vala"
	_tmp1_ = map;
#line 3087 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 19821 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 3088 "../src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 3088 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3088 "../src/Photo.vala"
		map = _tmp2_;
#line 3089 "../src/Photo.vala"
		_tmp3_ = map;
#line 3089 "../src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 19834 "Photo.c"
	}
#line 3092 "../src/Photo.vala"
	_tmp4_ = map;
#line 3092 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3093 "../src/Photo.vala"
	_vala_assert (num_points >= 0, "num_points >= 0");
#line 3095 "../src/Photo.vala"
	_tmp5_ = num_points;
#line 3095 "../src/Photo.vala"
	num_points = _tmp5_ + 1;
#line 3097 "../src/Photo.vala"
	_tmp6_ = g_strdup_printf ("radius%d", num_points - 1);
#line 3097 "../src/Photo.vala"
	radius_key = _tmp6_;
#line 3098 "../src/Photo.vala"
	_tmp7_ = g_strdup_printf ("center%d", num_points - 1);
#line 3098 "../src/Photo.vala"
	center_key = _tmp7_;
#line 3100 "../src/Photo.vala"
	_tmp8_ = map;
#line 3100 "../src/Photo.vala"
	_tmp9_ = radius_key;
#line 3100 "../src/Photo.vala"
	_tmp10_ = *redeye;
#line 3100 "../src/Photo.vala"
	key_value_map_set_int (_tmp8_, _tmp9_, _tmp10_.radius);
#line 3101 "../src/Photo.vala"
	_tmp11_ = map;
#line 3101 "../src/Photo.vala"
	_tmp12_ = center_key;
#line 3101 "../src/Photo.vala"
	_tmp13_ = *redeye;
#line 3101 "../src/Photo.vala"
	_tmp14_ = _tmp13_.center;
#line 3101 "../src/Photo.vala"
	key_value_map_set_point (_tmp11_, _tmp12_, &_tmp14_);
#line 3103 "../src/Photo.vala"
	_tmp15_ = map;
#line 3103 "../src/Photo.vala"
	key_value_map_set_int (_tmp15_, "num_points", num_points);
#line 3105 "../src/Photo.vala"
	_tmp16_ = map;
#line 3105 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp16_)) {
#line 19880 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 3106 "../src/Photo.vala"
		_tmp17_ = alteration_new ("image", "redeye");
#line 3106 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 3106 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp18_);
#line 3106 "../src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 19891 "Photo.c"
	}
#line 3085 "../src/Photo.vala"
	_g_free0 (center_key);
#line 3085 "../src/Photo.vala"
	_g_free0 (radius_key);
#line 3085 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19899 "Photo.c"
}

static gboolean
photo_calculate_pixbuf_dimensions (Photo* self,
                                   Scaling* scaling,
                                   PhotoException exceptions,
                                   Dimensions* scaled_image,
                                   Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 3121 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3121 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 19917 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp7_ = FALSE;
#line 3123 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3123 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19925 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			gboolean _tmp4_;
#line 3125 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3125 "../src/Photo.vala"
			_tmp4_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, exceptions, &_tmp2_, &_tmp3_);
#line 3125 "../src/Photo.vala"
			_vala_scaled_image = _tmp2_;
#line 3125 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp3_;
#line 3125 "../src/Photo.vala"
			result = _tmp4_;
#line 19941 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 3123 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 3123 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19948 "Photo.c"
			}
#line 3125 "../src/Photo.vala"
			if (scaled_image) {
#line 3125 "../src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 19954 "Photo.c"
			}
#line 3125 "../src/Photo.vala"
			if (scaled_to_viewport) {
#line 3125 "../src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 19960 "Photo.c"
			}
#line 3125 "../src/Photo.vala"
			return result;
#line 19964 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 3123 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 3123 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19973 "Photo.c"
		}
#line 3123 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3123 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3123 "../src/Photo.vala"
		return _tmp7_;
#line 19981 "Photo.c"
	}
}

static gboolean
photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          Dimensions* scaled_image,
                                          Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	gboolean _tmp31_ = FALSE;
	Dimensions _tmp32_;
	Dimensions _tmp33_;
	gboolean result;
#line 3131 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3131 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3133 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3133 "../src/Photo.vala"
	raw = _tmp0_;
#line 3135 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 20011 "Photo.c"
		Dimensions _tmp1_;
		Dimensions _tmp2_;
#line 3136 "../src/Photo.vala"
		_tmp1_ = raw;
#line 3136 "../src/Photo.vala"
		_vala_scaled_image = _tmp1_;
#line 3137 "../src/Photo.vala"
		_tmp2_ = raw;
#line 3137 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp2_;
#line 3139 "../src/Photo.vala"
		result = FALSE;
#line 3139 "../src/Photo.vala"
		if (scaled_image) {
#line 3139 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 20028 "Photo.c"
		}
#line 3139 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3139 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 20034 "Photo.c"
		}
#line 3139 "../src/Photo.vala"
		return result;
#line 20038 "Photo.c"
	}
#line 3142 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 3147 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3148 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3150 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 20048 "Photo.c"
		Box crop = {0};
		Box _tmp3_ = {0};
		gboolean _tmp4_;
#line 3152 "../src/Photo.vala"
		_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 3152 "../src/Photo.vala"
		crop = _tmp3_;
#line 3152 "../src/Photo.vala"
		if (_tmp4_) {
#line 20058 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp5_;
			Box scaled_crop = {0};
			Dimensions _tmp11_ = {0};
			Dimensions _tmp12_ = {0};
			Box _tmp13_ = {0};
			Dimensions _tmp14_ = {0};
			gboolean _tmp15_ = FALSE;
			Dimensions _tmp18_ = {0};
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
#line 3155 "../src/Photo.vala"
			_tmp5_ = raw;
#line 3155 "../src/Photo.vala"
			rotated_raw = _tmp5_;
#line 3156 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 20076 "Photo.c"
				Dimensions _tmp6_;
				Box _tmp7_;
				Box _tmp8_ = {0};
				Dimensions _tmp9_;
				Dimensions _tmp10_ = {0};
#line 3157 "../src/Photo.vala"
				_tmp6_ = raw;
#line 3157 "../src/Photo.vala"
				_tmp7_ = crop;
#line 3157 "../src/Photo.vala"
				orientation_rotate_box (orientation, &_tmp6_, &_tmp7_, &_tmp8_);
#line 3157 "../src/Photo.vala"
				crop = _tmp8_;
#line 3158 "../src/Photo.vala"
				_tmp9_ = raw;
#line 3158 "../src/Photo.vala"
				orientation_rotate_dimensions (orientation, &_tmp9_, &_tmp10_);
#line 3158 "../src/Photo.vala"
				rotated_raw = _tmp10_;
#line 20096 "Photo.c"
			}
#line 3162 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp11_);
#line 3162 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp11_, &_tmp12_);
#line 3162 "../src/Photo.vala"
			box_get_scaled (&crop, &_tmp12_, &_tmp13_);
#line 3162 "../src/Photo.vala"
			scaled_crop = _tmp13_;
#line 3165 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp14_);
#line 3165 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp14_;
#line 3168 "../src/Photo.vala"
			if (box_get_width (&crop) <= box_get_width (&scaled_crop)) {
#line 3169 "../src/Photo.vala"
				_tmp15_ = box_get_height (&crop) <= box_get_height (&scaled_crop);
#line 20114 "Photo.c"
			} else {
#line 3168 "../src/Photo.vala"
				_tmp15_ = FALSE;
#line 20118 "Photo.c"
			}
#line 3168 "../src/Photo.vala"
			if (_tmp15_) {
#line 20122 "Photo.c"
				Dimensions _tmp16_;
				Dimensions _tmp17_ = {0};
#line 3170 "../src/Photo.vala"
				_tmp16_ = raw;
#line 3170 "../src/Photo.vala"
				_vala_scaled_image = _tmp16_;
#line 3171 "../src/Photo.vala"
				box_get_dimensions (&crop, &_tmp17_);
#line 3171 "../src/Photo.vala"
				_vala_scaled_to_viewport = _tmp17_;
#line 3173 "../src/Photo.vala"
				result = FALSE;
#line 3173 "../src/Photo.vala"
				if (scaled_image) {
#line 3173 "../src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 20139 "Photo.c"
				}
#line 3173 "../src/Photo.vala"
				if (scaled_to_viewport) {
#line 3173 "../src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 20145 "Photo.c"
				}
#line 3173 "../src/Photo.vala"
				return result;
#line 20149 "Photo.c"
			}
#line 3178 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp18_);
#line 3178 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp19_);
#line 3178 "../src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp18_, &_tmp19_, &_tmp20_);
#line 3178 "../src/Photo.vala"
			_vala_scaled_image = _tmp20_;
#line 3182 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 20161 "Photo.c"
				Dimensions _tmp21_;
				Dimensions _tmp22_ = {0};
#line 3183 "../src/Photo.vala"
				_tmp21_ = _vala_scaled_image;
#line 3183 "../src/Photo.vala"
				orientation_derotate_dimensions (orientation, &_tmp21_, &_tmp22_);
#line 3183 "../src/Photo.vala"
				_vala_scaled_image = _tmp22_;
#line 20170 "Photo.c"
			}
		}
	}
#line 3189 "../src/Photo.vala"
	if (!dimensions_has_area (&_vala_scaled_image)) {
#line 20176 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp23_;
		Dimensions _tmp26_;
		Dimensions _tmp27_ = {0};
		Dimensions _tmp28_;
#line 3191 "../src/Photo.vala"
		_tmp23_ = raw;
#line 3191 "../src/Photo.vala"
		rotated_raw = _tmp23_;
#line 3192 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 20188 "Photo.c"
			Dimensions _tmp24_;
			Dimensions _tmp25_ = {0};
#line 3193 "../src/Photo.vala"
			_tmp24_ = raw;
#line 3193 "../src/Photo.vala"
			orientation_rotate_dimensions (orientation, &_tmp24_, &_tmp25_);
#line 3193 "../src/Photo.vala"
			rotated_raw = _tmp25_;
#line 20197 "Photo.c"
		}
#line 3196 "../src/Photo.vala"
		_tmp26_ = rotated_raw;
#line 3196 "../src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp26_, &_tmp27_);
#line 3196 "../src/Photo.vala"
		_vala_scaled_image = _tmp27_;
#line 3197 "../src/Photo.vala"
		_tmp28_ = _vala_scaled_image;
#line 3197 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp28_;
#line 3200 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 20211 "Photo.c"
			Dimensions _tmp29_;
			Dimensions _tmp30_ = {0};
#line 3201 "../src/Photo.vala"
			_tmp29_ = _vala_scaled_image;
#line 3201 "../src/Photo.vala"
			orientation_derotate_dimensions (orientation, &_tmp29_, &_tmp30_);
#line 3201 "../src/Photo.vala"
			_vala_scaled_image = _tmp30_;
#line 20220 "Photo.c"
		}
	}
#line 3206 "../src/Photo.vala"
	_tmp32_ = _vala_scaled_image;
#line 3206 "../src/Photo.vala"
	_tmp33_ = raw;
#line 3206 "../src/Photo.vala"
	if (_tmp32_.width >= _tmp33_.width) {
#line 20229 "Photo.c"
		Dimensions _tmp34_;
		Dimensions _tmp35_;
#line 3206 "../src/Photo.vala"
		_tmp34_ = _vala_scaled_image;
#line 3206 "../src/Photo.vala"
		_tmp35_ = raw;
#line 3206 "../src/Photo.vala"
		_tmp31_ = _tmp34_.height >= _tmp35_.height;
#line 20238 "Photo.c"
	} else {
#line 3206 "../src/Photo.vala"
		_tmp31_ = FALSE;
#line 20242 "Photo.c"
	}
#line 3206 "../src/Photo.vala"
	if (_tmp31_) {
#line 20246 "Photo.c"
		Dimensions _tmp36_;
#line 3207 "../src/Photo.vala"
		_tmp36_ = raw;
#line 3207 "../src/Photo.vala"
		_vala_scaled_image = _tmp36_;
#line 3209 "../src/Photo.vala"
		result = FALSE;
#line 3209 "../src/Photo.vala"
		if (scaled_image) {
#line 3209 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 20258 "Photo.c"
		}
#line 3209 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3209 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 20264 "Photo.c"
		}
#line 3209 "../src/Photo.vala"
		return result;
#line 20268 "Photo.c"
	}
#line 3212 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_image), "scaled_image.has_area ()");
#line 3213 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_to_viewport), "scaled_to_viewport.has_area ()");
#line 3215 "../src/Photo.vala"
	result = TRUE;
#line 3215 "../src/Photo.vala"
	if (scaled_image) {
#line 3215 "../src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 20280 "Photo.c"
	}
#line 3215 "../src/Photo.vala"
	if (scaled_to_viewport) {
#line 3215 "../src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 20286 "Photo.c"
	}
#line 3215 "../src/Photo.vala"
	return result;
#line 20290 "Photo.c"
}

static GdkPixbuf*
photo_load_raw_pixbuf (Photo* self,
                       Scaling* scaling,
                       PhotoException exceptions,
                       BackingFetchMode fetch_mode,
                       GError** error)
{
	PhotoFileReader* loader = NULL;
	PhotoFileReader* _tmp0_;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp13_;
	Dimensions _tmp14_ = {0};
	Dimensions _tmp15_;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp17_;
	Dimensions _tmp18_ = {0};
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3221 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3221 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3224 "../src/Photo.vala"
	_tmp0_ = photo_get_backing_reader (self, fetch_mode);
#line 3224 "../src/Photo.vala"
	loader = _tmp0_;
#line 3227 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 20328 "Photo.c"
		GdkPixbuf* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 3232 "../src/Photo.vala"
		_tmp2_ = loader;
#line 3232 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_unscaled_read (_tmp2_, &_inner_error0_);
#line 3232 "../src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 3232 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3232 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3232 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3232 "../src/Photo.vala"
			return NULL;
#line 20347 "Photo.c"
		}
#line 3232 "../src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 3232 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 3232 "../src/Photo.vala"
		result = _tmp4_;
#line 3232 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3232 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3232 "../src/Photo.vala"
		return result;
#line 20361 "Photo.c"
	}
#line 3237 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3237 "../src/Photo.vala"
	_tmp8_ = photo_calculate_pixbuf_dimensions (self, &_tmp5_, exceptions, &_tmp6_, &_tmp7_);
#line 3237 "../src/Photo.vala"
	scaled_image = _tmp6_;
#line 3237 "../src/Photo.vala"
	scaled_to_viewport = _tmp7_;
#line 3237 "../src/Photo.vala"
	is_scaled = _tmp8_;
#line 3239 "../src/Photo.vala"
	if (!is_scaled) {
#line 20375 "Photo.c"
		GdkPixbuf* _tmp9_ = NULL;
		PhotoFileReader* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkPixbuf* _tmp12_;
#line 3244 "../src/Photo.vala"
		_tmp10_ = loader;
#line 3244 "../src/Photo.vala"
		_tmp11_ = photo_file_reader_unscaled_read (_tmp10_, &_inner_error0_);
#line 3244 "../src/Photo.vala"
		_tmp9_ = _tmp11_;
#line 3244 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3244 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3244 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3244 "../src/Photo.vala"
			return NULL;
#line 20394 "Photo.c"
		}
#line 3244 "../src/Photo.vala"
		_tmp12_ = _tmp9_;
#line 3244 "../src/Photo.vala"
		_tmp9_ = NULL;
#line 3244 "../src/Photo.vala"
		result = _tmp12_;
#line 3244 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 3244 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3244 "../src/Photo.vala"
		return result;
#line 20408 "Photo.c"
	}
#line 3247 "../src/Photo.vala"
	_tmp13_ = loader;
#line 3247 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp14_);
#line 3247 "../src/Photo.vala"
	_tmp15_ = scaled_image;
#line 3247 "../src/Photo.vala"
	_tmp16_ = photo_file_reader_scaled_read (_tmp13_, &_tmp14_, &_tmp15_, &_inner_error0_);
#line 3247 "../src/Photo.vala"
	pixbuf = _tmp16_;
#line 3247 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3247 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3247 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3247 "../src/Photo.vala"
		return NULL;
#line 20428 "Photo.c"
	}
#line 3255 "../src/Photo.vala"
	_tmp17_ = pixbuf;
#line 3255 "../src/Photo.vala"
	dimensions_for_pixbuf (_tmp17_, &_tmp18_);
#line 3255 "../src/Photo.vala"
	_vala_assert (dimensions_approx_equals (&scaled_image, &_tmp18_, PHOTO_SCALING_FUDGE), "scaled_image.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 3257 "../src/Photo.vala"
	result = pixbuf;
#line 3257 "../src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3257 "../src/Photo.vala"
	return result;
#line 20442 "Photo.c"
}

GdkPixbuf*
photo_get_master_pixbuf (Photo* self,
                         Scaling* scaling,
                         gboolean rotate,
                         GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3262 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3262 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3263 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3263 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_MASTER, &_inner_error0_);
#line 3263 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3263 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3263 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3263 "../src/Photo.vala"
		return NULL;
#line 20473 "Photo.c"
	}
#line 3263 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3263 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3263 "../src/Photo.vala"
	result = _tmp3_;
#line 3263 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3263 "../src/Photo.vala"
	return result;
#line 20485 "Photo.c"
}

GdkPixbuf*
photo_get_unmodified_pixbuf (Photo* self,
                             Scaling* scaling,
                             gboolean rotate,
                             GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3267 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3267 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3268 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3268 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error0_);
#line 3268 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3268 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3268 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3268 "../src/Photo.vala"
		return NULL;
#line 20516 "Photo.c"
	}
#line 3268 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3268 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3268 "../src/Photo.vala"
	result = _tmp3_;
#line 3268 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3268 "../src/Photo.vala"
	return result;
#line 20528 "Photo.c"
}

static GdkPixbuf*
photo_get_untransformed_pixbuf (Photo* self,
                                Scaling* scaling,
                                gboolean rotate,
                                BackingFetchMode fetch_mode,
                                GError** error)
{
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp5_;
	GdkPixbuf* _tmp6_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3272 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3272 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 20550 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3286 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3286 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20557 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
#line 3287 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3287 "../src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3287 "../src/Photo.vala"
			scaled_image = _tmp2_;
#line 3287 "../src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3289 "../src/Photo.vala"
			original_orientation = photo_get_original_orientation (self);
#line 20572 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 3286 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 3286 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20581 "Photo.c"
		}
#line 3286 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3286 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3286 "../src/Photo.vala"
			return NULL;
#line 20589 "Photo.c"
		}
	}
#line 3293 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3293 "../src/Photo.vala"
	_tmp6_ = photo_load_raw_pixbuf (self, &_tmp5_, PHOTO_EXCEPTION_NONE, fetch_mode, &_inner_error0_);
#line 3293 "../src/Photo.vala"
	pixbuf = _tmp6_;
#line 3293 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3293 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3293 "../src/Photo.vala"
		return NULL;
#line 20604 "Photo.c"
	}
#line 3299 "../src/Photo.vala"
	if (rotate) {
#line 20608 "Photo.c"
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 3300 "../src/Photo.vala"
		_tmp7_ = pixbuf;
#line 3300 "../src/Photo.vala"
		_tmp8_ = orientation_rotate_pixbuf (original_orientation, _tmp7_);
#line 3300 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3300 "../src/Photo.vala"
		pixbuf = _tmp8_;
#line 20619 "Photo.c"
	}
#line 3310 "../src/Photo.vala"
	result = pixbuf;
#line 3310 "../src/Photo.vala"
	return result;
#line 20625 "Photo.c"
}

static GdkPixbuf*
photo_real_get_pixbuf (PhotoSource* base,
                       Scaling* scaling,
                       GError** error)
{
	Photo * self;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3313 "../src/Photo.vala"
	self = (Photo*) base;
#line 3313 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3314 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3314 "../src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 3314 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3314 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3314 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3314 "../src/Photo.vala"
		return NULL;
#line 20656 "Photo.c"
	}
#line 3314 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3314 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3314 "../src/Photo.vala"
	result = _tmp3_;
#line 3314 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3314 "../src/Photo.vala"
	return result;
#line 20668 "Photo.c"
}

/**
     * Populates the cached version of the unmodified image.
     */
void
photo_populate_prefetched (Photo* self,
                           GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3320 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 20681 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3321 "../src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3321 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 20688 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
#line 3323 "../src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3323 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 20695 "Photo.c"
				GdkPixbuf* _tmp2_ = NULL;
				Scaling _tmp3_ = {0};
				GdkPixbuf* _tmp4_;
				GdkPixbuf* _tmp5_;
				GTimer* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 3324 "../src/Photo.vala"
				scaling_for_original (&_tmp3_);
#line 3324 "../src/Photo.vala"
				_tmp4_ = photo_load_raw_pixbuf (self, &_tmp3_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3324 "../src/Photo.vala"
				_tmp2_ = _tmp4_;
#line 3324 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20711 "Photo.c"
					goto __catch0_g_error;
				}
#line 3324 "../src/Photo.vala"
				_tmp5_ = _tmp2_;
#line 3324 "../src/Photo.vala"
				_tmp2_ = NULL;
#line 3324 "../src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3324 "../src/Photo.vala"
				self->priv->unmodified_precached = _tmp5_;
#line 3325 "../src/Photo.vala"
				_tmp6_ = g_timer_new ();
#line 3325 "../src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3325 "../src/Photo.vala"
				self->priv->secs_since_access = _tmp6_;
#line 3326 "../src/Photo.vala"
				g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, (GSourceFunc) photo_discard_prefetched, g_object_ref (self), g_object_unref);
#line 3327 "../src/Photo.vala"
				_tmp7_ = data_object_to_string ((DataObject*) self);
#line 3327 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3327 "../src/Photo.vala"
				g_debug ("Photo.vala:3327: spawning new precache timeout for %s", _tmp8_);
#line 3327 "../src/Photo.vala"
				_g_free0 (_tmp8_);
#line 3323 "../src/Photo.vala"
				_g_object_unref0 (_tmp2_);
#line 20740 "Photo.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp9_;
#line 3321 "../src/Photo.vala"
			_lock_error_ = _inner_error0_;
#line 3321 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 3321 "../src/Photo.vala"
			_tmp9_ = _lock_error_;
#line 3321 "../src/Photo.vala"
			_lock_error_ = NULL;
#line 3321 "../src/Photo.vala"
			_inner_error0_ = _tmp9_;
#line 3321 "../src/Photo.vala"
			_g_error_free0 (_lock_error_);
#line 20760 "Photo.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			GdkPixbuf* _tmp10_;
#line 3321 "../src/Photo.vala"
			_tmp10_ = self->priv->unmodified_precached;
#line 3321 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 20771 "Photo.c"
		}
#line 3321 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3321 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3321 "../src/Photo.vala"
			return;
#line 20779 "Photo.c"
		}
	}
}

/**
     * Get a copy of what's in the cache.
     *
     * @return A Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf*
photo_get_prefetched_copy (Photo* self)
{
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3337 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20796 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3338 "../src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3338 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 20803 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 3339 "../src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3339 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 20812 "Photo.c"
				{
#line 3341 "../src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error0_);
#line 3341 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20818 "Photo.c"
						goto __catch1_g_error;
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					gchar* _tmp2_;
					gchar* _tmp3_;
#line 3340 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 3343 "../src/Photo.vala"
					_tmp2_ = data_object_to_string ((DataObject*) self);
#line 3343 "../src/Photo.vala"
					_tmp3_ = _tmp2_;
#line 3343 "../src/Photo.vala"
					g_warning ("Photo.vala:3343: raw pixbuf for %s could not be loaded", _tmp3_);
#line 3343 "../src/Photo.vala"
					_g_free0 (_tmp3_);
#line 3344 "../src/Photo.vala"
					result = NULL;
#line 20839 "Photo.c"
					{
						GdkPixbuf* _tmp4_;
#line 3338 "../src/Photo.vala"
						_tmp4_ = self->priv->unmodified_precached;
#line 3338 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 20846 "Photo.c"
					}
#line 3344 "../src/Photo.vala"
					return result;
#line 20850 "Photo.c"
				}
				__finally1:
#line 3340 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3340 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3340 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 3340 "../src/Photo.vala"
					return NULL;
#line 20861 "Photo.c"
				}
			}
#line 3348 "../src/Photo.vala"
			_tmp5_ = self->priv->unmodified_precached;
#line 3348 "../src/Photo.vala"
			_tmp6_ = gdk_pixbuf_copy (_tmp5_);
#line 3348 "../src/Photo.vala"
			result = _tmp6_;
#line 20870 "Photo.c"
			{
				GdkPixbuf* _tmp7_;
#line 3338 "../src/Photo.vala"
				_tmp7_ = self->priv->unmodified_precached;
#line 3338 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 20877 "Photo.c"
			}
#line 3348 "../src/Photo.vala"
			return result;
#line 20881 "Photo.c"
		}
		__finally0:
		{
			GdkPixbuf* _tmp8_;
#line 3338 "../src/Photo.vala"
			_tmp8_ = self->priv->unmodified_precached;
#line 3338 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 20890 "Photo.c"
		}
#line 3338 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3338 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3338 "../src/Photo.vala"
		return NULL;
#line 20898 "Photo.c"
	}
}

/**
     * Discards the cached version of the unmodified image.
     *
     * @param immed Whether the cached version should be discarded now, or not.
     */
gboolean
photo_discard_prefetched (Photo* self,
                          gboolean immed)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 3357 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20915 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 3358 "../src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3358 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 20923 "Photo.c"
		{
			GTimer* _tmp1_;
			gdouble tmp = 0.0;
			gboolean _tmp3_ = FALSE;
			GTimer* _tmp4_;
			gulong _tmp5_ = 0UL;
			gdouble _tmp6_;
#line 3359 "../src/Photo.vala"
			_tmp1_ = self->priv->secs_since_access;
#line 3359 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 3360 "../src/Photo.vala"
				result = FALSE;
#line 20937 "Photo.c"
				{
					GdkPixbuf* _tmp2_;
#line 3358 "../src/Photo.vala"
					_tmp2_ = self->priv->unmodified_precached;
#line 3358 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 20944 "Photo.c"
				}
#line 3360 "../src/Photo.vala"
				return result;
#line 20948 "Photo.c"
			}
#line 3364 "../src/Photo.vala"
			_tmp4_ = self->priv->secs_since_access;
#line 3364 "../src/Photo.vala"
			_tmp6_ = g_timer_elapsed (_tmp4_, &_tmp5_);
#line 3364 "../src/Photo.vala"
			tmp = (gdouble) _tmp5_;
#line 3364 "../src/Photo.vala"
			if (_tmp6_ > ((gdouble) PHOTO_PRECACHE_TIME_TO_LIVE)) {
#line 3364 "../src/Photo.vala"
				_tmp3_ = TRUE;
#line 20960 "Photo.c"
			} else {
#line 3364 "../src/Photo.vala"
				_tmp3_ = immed;
#line 20964 "Photo.c"
			}
#line 3364 "../src/Photo.vala"
			if (_tmp3_) {
#line 20968 "Photo.c"
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 3365 "../src/Photo.vala"
				_tmp7_ = data_object_to_string ((DataObject*) self);
#line 3365 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3365 "../src/Photo.vala"
				g_debug ("pipeline not run in over %d seconds or got immediate command, discardi" \
"ng " "cached original for %s", PHOTO_PRECACHE_TIME_TO_LIVE, _tmp8_);
#line 3365 "../src/Photo.vala"
				_g_free0 (_tmp8_);
#line 3368 "../src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3368 "../src/Photo.vala"
				self->priv->unmodified_precached = NULL;
#line 3369 "../src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3369 "../src/Photo.vala"
				self->priv->secs_since_access = NULL;
#line 3370 "../src/Photo.vala"
				result = FALSE;
#line 20989 "Photo.c"
				{
					GdkPixbuf* _tmp9_;
#line 3358 "../src/Photo.vala"
					_tmp9_ = self->priv->unmodified_precached;
#line 3358 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 20996 "Photo.c"
				}
#line 3370 "../src/Photo.vala"
				return result;
#line 21000 "Photo.c"
			}
#line 3373 "../src/Photo.vala"
			result = TRUE;
#line 21004 "Photo.c"
			{
				GdkPixbuf* _tmp10_;
#line 3358 "../src/Photo.vala"
				_tmp10_ = self->priv->unmodified_precached;
#line 3358 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 21011 "Photo.c"
			}
#line 3373 "../src/Photo.vala"
			return result;
#line 21015 "Photo.c"
		}
		__finally0:
		{
			GdkPixbuf* _tmp11_;
#line 3358 "../src/Photo.vala"
			_tmp11_ = self->priv->unmodified_precached;
#line 3358 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 21024 "Photo.c"
		}
#line 3358 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3358 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3358 "../src/Photo.vala"
		return _tmp12_;
#line 21032 "Photo.c"
	}
}

/**
     * Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf*
photo_get_pixbuf_with_options (Photo* self,
                               Scaling* scaling,
                               PhotoException exceptions,
                               BackingFetchMode fetch_mode,
                               GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp22_;
	GTimer* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GdkPixbuf* _tmp26_;
	gboolean _tmp64_ = FALSE;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3388 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3388 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3401 "../src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3401 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3401 "../src/Photo.vala"
	if (_tmp4_) {
#line 3402 "../src/Photo.vala"
		_tmp2_ = photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 21093 "Photo.c"
	} else {
#line 3401 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 21097 "Photo.c"
	}
#line 3401 "../src/Photo.vala"
	if (_tmp2_) {
#line 21101 "Photo.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 3403 "../src/Photo.vala"
		if (fetch_mode == BACKING_FETCH_MODE_BASELINE) {
#line 3403 "../src/Photo.vala"
			_tmp6_ = TRUE;
#line 21108 "Photo.c"
		} else {
#line 3403 "../src/Photo.vala"
			_tmp6_ = fetch_mode == BACKING_FETCH_MODE_UNMODIFIED;
#line 21112 "Photo.c"
		}
#line 3403 "../src/Photo.vala"
		if (_tmp6_) {
#line 3403 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 21118 "Photo.c"
		} else {
#line 3404 "../src/Photo.vala"
			_tmp5_ = fetch_mode == BACKING_FETCH_MODE_SOURCE;
#line 21122 "Photo.c"
		}
#line 3403 "../src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 21126 "Photo.c"
	} else {
#line 3401 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 21130 "Photo.c"
	}
#line 3401 "../src/Photo.vala"
	if (_tmp1_) {
#line 3405 "../src/Photo.vala"
		_tmp0_ = !photo_is_raw_developer_complete (self, photo_get_raw_developer (self));
#line 21136 "Photo.c"
	} else {
#line 3401 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 21140 "Photo.c"
	}
#line 3401 "../src/Photo.vala"
	if (_tmp0_) {
#line 3406 "../src/Photo.vala"
		photo_set_raw_developer (self, photo_get_raw_developer (self));
#line 21146 "Photo.c"
	}
#line 3412 "../src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3413 "../src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3414 "../src/Photo.vala"
	redeye_instances = NULL;
#line 3414 "../src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3414 "../src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3417 "../src/Photo.vala"
	transformer = NULL;
#line 21160 "Photo.c"
	{
		PhotoRow* _tmp7_;
#line 3420 "../src/Photo.vala"
		_tmp7_ = self->row;
#line 3420 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21167 "Photo.c"
		{
			Dimensions _tmp8_ = {0};
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_ = {0};
			Dimensions _tmp11_;
			Dimensions _tmp12_ = {0};
			Dimensions _tmp13_;
			gint _tmp14_ = 0;
			EditingToolsRedeyeInstance* _tmp15_;
			Box _tmp16_ = {0};
			gboolean _tmp17_;
			gdouble _tmp18_ = 0.0;
			gboolean _tmp19_;
#line 3421 "../src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ALL, &_tmp8_);
#line 3421 "../src/Photo.vala"
			original = _tmp8_;
#line 3422 "../src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, exceptions, &_tmp9_);
#line 3422 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp9_, &_tmp10_);
#line 3422 "../src/Photo.vala"
			scaled = _tmp10_;
#line 3423 "../src/Photo.vala"
			_tmp11_ = scaled;
#line 3423 "../src/Photo.vala"
			scaled_to_viewport = _tmp11_;
#line 3425 "../src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp12_);
#line 3425 "../src/Photo.vala"
			_tmp13_ = scaled;
#line 3425 "../src/Photo.vala"
			is_scaled = !dimensions_equals (&_tmp12_, &_tmp13_);
#line 3427 "../src/Photo.vala"
			_tmp15_ = photo_get_raw_redeye_instances (self, &_tmp14_);
#line 3427 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3427 "../src/Photo.vala"
			redeye_instances = _tmp15_;
#line 3427 "../src/Photo.vala"
			redeye_instances_length1 = _tmp14_;
#line 3427 "../src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3429 "../src/Photo.vala"
			_tmp17_ = photo_get_raw_crop (self, &_tmp16_);
#line 3429 "../src/Photo.vala"
			crop = _tmp16_;
#line 3429 "../src/Photo.vala"
			is_cropped = _tmp17_;
#line 3431 "../src/Photo.vala"
			_tmp19_ = photo_get_raw_straighten (self, &_tmp18_);
#line 3431 "../src/Photo.vala"
			straightening_angle = _tmp18_;
#line 3431 "../src/Photo.vala"
			is_straightened = _tmp19_;
#line 3433 "../src/Photo.vala"
			if (photo_has_color_adjustments (self)) {
#line 21225 "Photo.c"
				PixelTransformer* _tmp20_;
#line 3434 "../src/Photo.vala"
				_tmp20_ = photo_get_pixel_transformer (self);
#line 3434 "../src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3434 "../src/Photo.vala"
				transformer = _tmp20_;
#line 21233 "Photo.c"
			}
#line 3437 "../src/Photo.vala"
			orientation = photo_get_orientation (self);
#line 21237 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp21_;
#line 3420 "../src/Photo.vala"
			_tmp21_ = self->row;
#line 3420 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21246 "Photo.c"
		}
#line 3420 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3420 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3420 "../src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3420 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3420 "../src/Photo.vala"
			return NULL;
#line 21258 "Photo.c"
		}
	}
#line 3443 "../src/Photo.vala"
	photo_populate_prefetched (self, &_inner_error0_);
#line 3443 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3443 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3443 "../src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3443 "../src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3443 "../src/Photo.vala"
		return NULL;
#line 21273 "Photo.c"
	}
#line 3445 "../src/Photo.vala"
	_tmp22_ = photo_get_prefetched_copy (self);
#line 3445 "../src/Photo.vala"
	pixbuf = _tmp22_;
#line 3448 "../src/Photo.vala"
	_tmp23_ = self->priv->secs_since_access;
#line 3448 "../src/Photo.vala"
	g_timer_start (_tmp23_);
#line 3449 "../src/Photo.vala"
	_tmp24_ = data_object_to_string ((DataObject*) self);
#line 3449 "../src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 3449 "../src/Photo.vala"
	g_debug ("Photo.vala:3449: pipeline being run against %s, timer restarted.", _tmp25_);
#line 3449 "../src/Photo.vala"
	_g_free0 (_tmp25_);
#line 3451 "../src/Photo.vala"
	_tmp26_ = pixbuf;
#line 3451 "../src/Photo.vala"
	_vala_assert (_tmp26_ != NULL, "pixbuf != null");
#line 3458 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_REDEYE)) {
#line 21297 "Photo.c"
		EditingToolsRedeyeInstance* _tmp27_;
		gint _tmp27__length1;
#line 3463 "../src/Photo.vala"
		_tmp27_ = redeye_instances;
#line 3463 "../src/Photo.vala"
		_tmp27__length1 = redeye_instances_length1;
#line 21304 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3463 "../src/Photo.vala"
			instance_collection = _tmp27_;
#line 3463 "../src/Photo.vala"
			instance_collection_length1 = _tmp27__length1;
#line 3463 "../src/Photo.vala"
			for (instance_it = 0; instance_it < instance_collection_length1; instance_it = instance_it + 1) {
#line 21316 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3463 "../src/Photo.vala"
				instance = instance_collection[instance_it];
#line 21320 "Photo.c"
				{
					GdkPixbuf* _tmp28_;
					EditingToolsRedeyeInstance _tmp29_;
					GdkPixbuf* _tmp30_;
#line 3464 "../src/Photo.vala"
					_tmp28_ = pixbuf;
#line 3464 "../src/Photo.vala"
					_tmp29_ = instance;
#line 3464 "../src/Photo.vala"
					_tmp30_ = photo_do_redeye (self, _tmp28_, &_tmp29_);
#line 3464 "../src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3464 "../src/Photo.vala"
					pixbuf = _tmp30_;
#line 21335 "Photo.c"
				}
			}
		}
	}
#line 3472 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 3476 "../src/Photo.vala"
		if (is_straightened) {
#line 21344 "Photo.c"
			GdkPixbuf* _tmp31_;
			GdkPixbuf* _tmp32_;
#line 3477 "../src/Photo.vala"
			_tmp31_ = pixbuf;
#line 3477 "../src/Photo.vala"
			_tmp32_ = rotate_arb (_tmp31_, straightening_angle);
#line 3477 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3477 "../src/Photo.vala"
			pixbuf = _tmp32_;
#line 21355 "Photo.c"
		}
	}
#line 3486 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 3490 "../src/Photo.vala"
		if (is_cropped) {
#line 21362 "Photo.c"
			Box _tmp33_;
			GdkPixbuf* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			Box _tmp37_;
			GdkPixbuf* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			Box _tmp41_;
			Box _tmp42_;
			GdkPixbuf* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
			Box _tmp46_;
			Box _tmp47_;
			GdkPixbuf* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
			GdkPixbuf* _tmp51_;
			Box _tmp52_;
			Box _tmp53_;
			GdkPixbuf* _tmp54_;
#line 3495 "../src/Photo.vala"
			_tmp33_ = crop;
#line 3495 "../src/Photo.vala"
			_tmp34_ = pixbuf;
#line 3495 "../src/Photo.vala"
			_tmp35_ = gdk_pixbuf_get_width (_tmp34_);
#line 3495 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 3495 "../src/Photo.vala"
			crop.left = CLAMP (_tmp33_.left, 0, _tmp36_ - 2);
#line 3496 "../src/Photo.vala"
			_tmp37_ = crop;
#line 3496 "../src/Photo.vala"
			_tmp38_ = pixbuf;
#line 3496 "../src/Photo.vala"
			_tmp39_ = gdk_pixbuf_get_height (_tmp38_);
#line 3496 "../src/Photo.vala"
			_tmp40_ = _tmp39_;
#line 3496 "../src/Photo.vala"
			crop.top = CLAMP (_tmp37_.top, 0, _tmp40_ - 2);
#line 3498 "../src/Photo.vala"
			_tmp41_ = crop;
#line 3498 "../src/Photo.vala"
			_tmp42_ = crop;
#line 3498 "../src/Photo.vala"
			_tmp43_ = pixbuf;
#line 3498 "../src/Photo.vala"
			_tmp44_ = gdk_pixbuf_get_width (_tmp43_);
#line 3498 "../src/Photo.vala"
			_tmp45_ = _tmp44_;
#line 3498 "../src/Photo.vala"
			crop.right = CLAMP (_tmp41_.right, _tmp42_.left + 1, _tmp45_ - 1);
#line 3499 "../src/Photo.vala"
			_tmp46_ = crop;
#line 3499 "../src/Photo.vala"
			_tmp47_ = crop;
#line 3499 "../src/Photo.vala"
			_tmp48_ = pixbuf;
#line 3499 "../src/Photo.vala"
			_tmp49_ = gdk_pixbuf_get_height (_tmp48_);
#line 3499 "../src/Photo.vala"
			_tmp50_ = _tmp49_;
#line 3499 "../src/Photo.vala"
			crop.bottom = CLAMP (_tmp46_.bottom, _tmp47_.top + 1, _tmp50_ - 1);
#line 3501 "../src/Photo.vala"
			_tmp51_ = pixbuf;
#line 3501 "../src/Photo.vala"
			_tmp52_ = crop;
#line 3501 "../src/Photo.vala"
			_tmp53_ = crop;
#line 3501 "../src/Photo.vala"
			_tmp54_ = gdk_pixbuf_new_subpixbuf (_tmp51_, _tmp52_.left, _tmp53_.top, box_get_width (&crop), box_get_height (&crop));
#line 3501 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3501 "../src/Photo.vala"
			pixbuf = _tmp54_;
#line 21441 "Photo.c"
		}
	}
#line 3511 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 21446 "Photo.c"
		GdkPixbuf* _tmp55_;
		GdkPixbuf* _tmp56_;
#line 3515 "../src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3515 "../src/Photo.vala"
		_tmp56_ = orientation_rotate_pixbuf (orientation, _tmp55_);
#line 3515 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3515 "../src/Photo.vala"
		pixbuf = _tmp56_;
#line 21457 "Photo.c"
	}
#line 3528 "../src/Photo.vala"
	if (is_scaled) {
#line 21461 "Photo.c"
		GdkPixbuf* _tmp57_;
		Dimensions _tmp58_;
		Dimensions _tmp59_;
		GdkPixbuf* _tmp60_;
#line 3529 "../src/Photo.vala"
		_tmp57_ = pixbuf;
#line 3529 "../src/Photo.vala"
		_tmp58_ = scaled_to_viewport;
#line 3529 "../src/Photo.vala"
		_tmp59_ = scaled_to_viewport;
#line 3529 "../src/Photo.vala"
		_tmp60_ = gdk_pixbuf_scale_simple (_tmp57_, _tmp58_.width, _tmp59_.height, GDK_INTERP_BILINEAR);
#line 3529 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3529 "../src/Photo.vala"
		pixbuf = _tmp60_;
#line 21478 "Photo.c"
	}
#line 3534 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ADJUST)) {
#line 21482 "Photo.c"
		PixelTransformer* _tmp61_;
#line 3538 "../src/Photo.vala"
		_tmp61_ = transformer;
#line 3538 "../src/Photo.vala"
		if (_tmp61_ != NULL) {
#line 21488 "Photo.c"
			PixelTransformer* _tmp62_;
			GdkPixbuf* _tmp63_;
#line 3539 "../src/Photo.vala"
			_tmp62_ = transformer;
#line 3539 "../src/Photo.vala"
			_tmp63_ = pixbuf;
#line 3539 "../src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp62_, _tmp63_, NULL);
#line 21497 "Photo.c"
		}
	}
#line 3549 "../src/Photo.vala"
	if (is_scaled) {
#line 3549 "../src/Photo.vala"
		_tmp64_ = !is_straightened;
#line 21504 "Photo.c"
	} else {
#line 3549 "../src/Photo.vala"
		_tmp64_ = FALSE;
#line 21508 "Photo.c"
	}
#line 3549 "../src/Photo.vala"
	if (_tmp64_) {
#line 21512 "Photo.c"
		GdkPixbuf* _tmp65_;
		Dimensions _tmp66_ = {0};
#line 3550 "../src/Photo.vala"
		_tmp65_ = pixbuf;
#line 3550 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp65_, &_tmp66_);
#line 3550 "../src/Photo.vala"
		_vala_assert (dimensions_approx_equals (&scaled_to_viewport, &_tmp66_, PHOTO_SCALING_FUDGE), "scaled_to_viewport.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 21521 "Photo.c"
	}
#line 3553 "../src/Photo.vala"
	result = pixbuf;
#line 3553 "../src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3553 "../src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3553 "../src/Photo.vala"
	return result;
#line 21531 "Photo.c"
}

static gboolean
photo_real_has_user_generated_metadata (Photo* self)
{
	gboolean _tmp0_ = FALSE;
#line 3561 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3561 "../src/Photo.vala"
	return _tmp0_;
#line 21542 "Photo.c"
}

gboolean
photo_has_user_generated_metadata (Photo* self)
{
	PhotoClass* _klass_;
#line 3561 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3561 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 3561 "../src/Photo.vala"
	if (_klass_->has_user_generated_metadata) {
#line 3561 "../src/Photo.vala"
		return _klass_->has_user_generated_metadata (self);
#line 21557 "Photo.c"
	}
#line 3561 "../src/Photo.vala"
	return FALSE;
#line 21561 "Photo.c"
}

static void
photo_real_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata)
{
#line 3565 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3565 "../src/Photo.vala"
	return;
#line 21572 "Photo.c"
}

void
photo_set_user_metadata_for_export (Photo* self,
                                    PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 3565 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3565 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 3565 "../src/Photo.vala"
	if (_klass_->set_user_metadata_for_export) {
#line 3565 "../src/Photo.vala"
		_klass_->set_user_metadata_for_export (self, metadata);
#line 21588 "Photo.c"
	}
}

gchar*
photo_get_export_basename (Photo* self,
                           PhotoFileFormat* file_format)
{
	gchar* result;
#line 3572 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3573 "../src/Photo.vala"
	if (file_format != NULL) {
#line 21601 "Photo.c"
		PhotoFileFormatProperties* _tmp0_;
		PhotoFileFormatProperties* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 3574 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_properties (*file_format);
#line 3574 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3574 "../src/Photo.vala"
		_tmp2_ = media_source_get_master_file ((MediaSource*) self);
#line 3574 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3574 "../src/Photo.vala"
		_tmp4_ = photo_file_format_properties_convert_file_extension (_tmp1_, _tmp3_);
#line 3574 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3574 "../src/Photo.vala"
		_tmp6_ = g_file_get_basename (_tmp5_);
#line 3574 "../src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3574 "../src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3574 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3574 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp1_);
#line 3574 "../src/Photo.vala"
		result = _tmp7_;
#line 3574 "../src/Photo.vala"
		return result;
#line 21636 "Photo.c"
	} else {
#line 3576 "../src/Photo.vala"
		if (photo_file_format_can_write (photo_get_file_format (self))) {
#line 21640 "Photo.c"
			PhotoFileFormatProperties* _tmp8_;
			PhotoFileFormatProperties* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 3577 "../src/Photo.vala"
			_tmp8_ = photo_file_format_get_properties (photo_get_file_format (self));
#line 3577 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 3577 "../src/Photo.vala"
			_tmp10_ = media_source_get_master_file ((MediaSource*) self);
#line 3577 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 3577 "../src/Photo.vala"
			_tmp12_ = photo_file_format_properties_convert_file_extension (_tmp9_, _tmp11_);
#line 3577 "../src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 3577 "../src/Photo.vala"
			_tmp14_ = g_file_get_basename (_tmp13_);
#line 3577 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3577 "../src/Photo.vala"
			_g_object_unref0 (_tmp13_);
#line 3577 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 3577 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp9_);
#line 3577 "../src/Photo.vala"
			result = _tmp15_;
#line 3577 "../src/Photo.vala"
			return result;
#line 21675 "Photo.c"
		} else {
			PhotoFileFormatProperties* _tmp16_;
			PhotoFileFormatProperties* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 3580 "../src/Photo.vala"
			_tmp16_ = photo_file_format_get_properties (photo_file_format_get_system_default_format ());
#line 3580 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 3580 "../src/Photo.vala"
			_tmp18_ = media_source_get_master_file ((MediaSource*) self);
#line 3580 "../src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 3580 "../src/Photo.vala"
			_tmp20_ = photo_file_format_properties_convert_file_extension (_tmp17_, _tmp19_);
#line 3580 "../src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 3580 "../src/Photo.vala"
			_tmp22_ = g_file_get_basename (_tmp21_);
#line 3580 "../src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3580 "../src/Photo.vala"
			_g_object_unref0 (_tmp21_);
#line 3580 "../src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 3580 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp17_);
#line 3580 "../src/Photo.vala"
			result = _tmp23_;
#line 3580 "../src/Photo.vala"
			return result;
#line 21711 "Photo.c"
		}
	}
}

static gboolean
photo_export_fullsized_backing (Photo* self,
                                GFile* file,
                                gboolean export_metadata,
                                GError** error)
{
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp24_;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp25_;
	PhotoFileFormatProperties* _tmp26_;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp27_;
	GFile* _tmp28_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	PhotoFileMetadataWriter* _tmp33_;
	PhotoFileMetadataWriter* _tmp34_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	PhotoFileMetadataWriter* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	PhotoFileReader* _tmp41_;
	GFile* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp55_;
	PhotoMetadata* _tmp56_;
	PhotoMetadata* _tmp58_;
	PhotoFileMetadataWriter* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	PhotoFileMetadataWriter* _tmp81_;
	PhotoMetadata* _tmp82_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 3586 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3586 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3589 "../src/Photo.vala"
	export_reader = NULL;
#line 3590 "../src/Photo.vala"
	is_master = TRUE;
#line 21771 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3591 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3591 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 21778 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 3592 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3592 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3592 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 21789 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 3592 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3592 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3592 "../src/Photo.vala"
				_tmp1_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp5_));
#line 21798 "Photo.c"
			} else {
#line 3592 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 21802 "Photo.c"
			}
#line 3592 "../src/Photo.vala"
			if (_tmp1_) {
#line 21806 "Photo.c"
				PhotoBackingReaders* _tmp6_;
				PhotoFileReader* _tmp7_;
				PhotoFileReader* _tmp8_;
#line 3593 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3593 "../src/Photo.vala"
				_tmp7_ = _tmp6_->editable;
#line 3593 "../src/Photo.vala"
				_tmp8_ = _photo_file_adapter_ref0 (_tmp7_);
#line 3593 "../src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3593 "../src/Photo.vala"
				export_reader = _tmp8_;
#line 3594 "../src/Photo.vala"
				is_master = FALSE;
#line 21822 "Photo.c"
			} else {
				gboolean _tmp9_ = FALSE;
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3595 "../src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3595 "../src/Photo.vala"
				_tmp11_ = _tmp10_->developer;
#line 3595 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 21833 "Photo.c"
					PhotoBackingReaders* _tmp12_;
					PhotoFileReader* _tmp13_;
#line 3595 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 3595 "../src/Photo.vala"
					_tmp13_ = _tmp12_->developer;
#line 3595 "../src/Photo.vala"
					_tmp9_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp13_));
#line 21842 "Photo.c"
				} else {
#line 3595 "../src/Photo.vala"
					_tmp9_ = FALSE;
#line 21846 "Photo.c"
				}
#line 3595 "../src/Photo.vala"
				if (_tmp9_) {
#line 21850 "Photo.c"
					PhotoBackingReaders* _tmp14_;
					PhotoFileReader* _tmp15_;
					PhotoFileReader* _tmp16_;
#line 3596 "../src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3596 "../src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3596 "../src/Photo.vala"
					_tmp16_ = _photo_file_adapter_ref0 (_tmp15_);
#line 3596 "../src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3596 "../src/Photo.vala"
					export_reader = _tmp16_;
#line 3597 "../src/Photo.vala"
					is_master = FALSE;
#line 21866 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp17_;
					PhotoFileReader* _tmp18_;
#line 3598 "../src/Photo.vala"
					_tmp17_ = self->priv->readers;
#line 3598 "../src/Photo.vala"
					_tmp18_ = _tmp17_->master;
#line 3598 "../src/Photo.vala"
					if (photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp18_))) {
#line 21876 "Photo.c"
						PhotoBackingReaders* _tmp19_;
						PhotoFileReader* _tmp20_;
						PhotoFileReader* _tmp21_;
#line 3599 "../src/Photo.vala"
						_tmp19_ = self->priv->readers;
#line 3599 "../src/Photo.vala"
						_tmp20_ = _tmp19_->master;
#line 3599 "../src/Photo.vala"
						_tmp21_ = _photo_file_adapter_ref0 (_tmp20_);
#line 3599 "../src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3599 "../src/Photo.vala"
						export_reader = _tmp21_;
#line 21890 "Photo.c"
					}
				}
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp22_;
#line 3591 "../src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 3591 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 21902 "Photo.c"
		}
#line 3591 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21906 "Photo.c"
			gboolean _tmp23_ = FALSE;
#line 3591 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3591 "../src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3591 "../src/Photo.vala"
			return _tmp23_;
#line 21914 "Photo.c"
		}
	}
#line 3603 "../src/Photo.vala"
	_tmp24_ = export_reader;
#line 3603 "../src/Photo.vala"
	if (_tmp24_ == NULL) {
#line 3604 "../src/Photo.vala"
		result = FALSE;
#line 3604 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3604 "../src/Photo.vala"
		return result;
#line 21927 "Photo.c"
	}
#line 3607 "../src/Photo.vala"
	_tmp25_ = export_reader;
#line 3607 "../src/Photo.vala"
	_tmp26_ = photo_file_format_get_properties (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp25_));
#line 3607 "../src/Photo.vala"
	format_properties = _tmp26_;
#line 3610 "../src/Photo.vala"
	_tmp27_ = format_properties;
#line 3610 "../src/Photo.vala"
	_tmp28_ = photo_file_format_properties_convert_file_extension (_tmp27_, file);
#line 3610 "../src/Photo.vala"
	dest_file = _tmp28_;
#line 3613 "../src/Photo.vala"
	_tmp29_ = export_reader;
#line 3613 "../src/Photo.vala"
	_tmp30_ = dest_file;
#line 3613 "../src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3613 "../src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3613 "../src/Photo.vala"
	_tmp33_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp29_), _tmp32_, &_inner_error0_);
#line 3613 "../src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3613 "../src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3613 "../src/Photo.vala"
	writer = _tmp34_;
#line 3613 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21959 "Photo.c"
		gboolean _tmp35_ = FALSE;
#line 3613 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3613 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3613 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3613 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3613 "../src/Photo.vala"
		return _tmp35_;
#line 21971 "Photo.c"
	}
#line 3616 "../src/Photo.vala"
	_tmp36_ = data_object_to_string ((DataObject*) self);
#line 3616 "../src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 3616 "../src/Photo.vala"
	_tmp38_ = writer;
#line 3616 "../src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp38_);
#line 3616 "../src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 3616 "../src/Photo.vala"
	g_debug ("Photo.vala:3616: Exporting full-sized copy of %s to %s", _tmp37_, _tmp40_);
#line 3616 "../src/Photo.vala"
	_g_free0 (_tmp40_);
#line 3616 "../src/Photo.vala"
	_g_free0 (_tmp37_);
#line 3618 "../src/Photo.vala"
	_tmp41_ = export_reader;
#line 3618 "../src/Photo.vala"
	_tmp42_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp41_);
#line 3618 "../src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 3618 "../src/Photo.vala"
	_tmp44_ = dest_file;
#line 3618 "../src/Photo.vala"
	g_file_copy (_tmp43_, _tmp44_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3618 "../src/Photo.vala"
	_g_object_unref0 (_tmp43_);
#line 3618 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22003 "Photo.c"
		gboolean _tmp45_ = FALSE;
#line 3618 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3618 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3618 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3618 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3618 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3618 "../src/Photo.vala"
		return _tmp45_;
#line 22017 "Photo.c"
	}
#line 3623 "../src/Photo.vala"
	if (!photo_has_alterations (self)) {
#line 3623 "../src/Photo.vala"
		_tmp50_ = is_master;
#line 22023 "Photo.c"
	} else {
#line 3623 "../src/Photo.vala"
		_tmp50_ = FALSE;
#line 22027 "Photo.c"
	}
#line 3623 "../src/Photo.vala"
	if (_tmp50_) {
#line 3623 "../src/Photo.vala"
		_tmp49_ = !photo_has_user_generated_metadata (self);
#line 22033 "Photo.c"
	} else {
#line 3623 "../src/Photo.vala"
		_tmp49_ = FALSE;
#line 22037 "Photo.c"
	}
#line 3623 "../src/Photo.vala"
	if (_tmp49_) {
#line 22041 "Photo.c"
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 3624 "../src/Photo.vala"
		_tmp51_ = media_source_get_title ((MediaSource*) self);
#line 3624 "../src/Photo.vala"
		_tmp52_ = _tmp51_;
#line 3624 "../src/Photo.vala"
		_tmp48_ = _tmp52_ == NULL;
#line 3624 "../src/Photo.vala"
		_g_free0 (_tmp52_);
#line 22052 "Photo.c"
	} else {
#line 3623 "../src/Photo.vala"
		_tmp48_ = FALSE;
#line 22056 "Photo.c"
	}
#line 3623 "../src/Photo.vala"
	if (_tmp48_) {
#line 22060 "Photo.c"
		gchar* _tmp53_;
		gchar* _tmp54_;
#line 3624 "../src/Photo.vala"
		_tmp53_ = media_source_get_comment ((MediaSource*) self);
#line 3624 "../src/Photo.vala"
		_tmp54_ = _tmp53_;
#line 3624 "../src/Photo.vala"
		_tmp47_ = _tmp54_ == NULL;
#line 3624 "../src/Photo.vala"
		_g_free0 (_tmp54_);
#line 22071 "Photo.c"
	} else {
#line 3623 "../src/Photo.vala"
		_tmp47_ = FALSE;
#line 22075 "Photo.c"
	}
#line 3623 "../src/Photo.vala"
	if (_tmp47_) {
#line 3624 "../src/Photo.vala"
		_tmp46_ = export_metadata;
#line 22081 "Photo.c"
	} else {
#line 3623 "../src/Photo.vala"
		_tmp46_ = FALSE;
#line 22085 "Photo.c"
	}
#line 3623 "../src/Photo.vala"
	if (_tmp46_) {
#line 3625 "../src/Photo.vala"
		result = TRUE;
#line 3625 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3625 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3625 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3625 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3625 "../src/Photo.vala"
		return result;
#line 22101 "Photo.c"
	}
#line 3629 "../src/Photo.vala"
	_tmp55_ = export_reader;
#line 3629 "../src/Photo.vala"
	_tmp56_ = photo_file_reader_read_metadata (_tmp55_, &_inner_error0_);
#line 3629 "../src/Photo.vala"
	metadata = _tmp56_;
#line 3629 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22111 "Photo.c"
		gboolean _tmp57_ = FALSE;
#line 3629 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3629 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3629 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3629 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3629 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3629 "../src/Photo.vala"
		return _tmp57_;
#line 22125 "Photo.c"
	}
#line 3630 "../src/Photo.vala"
	_tmp58_ = metadata;
#line 3630 "../src/Photo.vala"
	if (_tmp58_ == NULL) {
#line 22131 "Photo.c"
		PhotoFileReader* _tmp59_;
		PhotoMetadata* _tmp60_;
#line 3631 "../src/Photo.vala"
		_tmp59_ = export_reader;
#line 3631 "../src/Photo.vala"
		_tmp60_ = photo_file_format_create_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp59_));
#line 3631 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3631 "../src/Photo.vala"
		metadata = _tmp60_;
#line 22142 "Photo.c"
	}
#line 3634 "../src/Photo.vala"
	_tmp61_ = writer;
#line 3634 "../src/Photo.vala"
	_tmp62_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp61_);
#line 3634 "../src/Photo.vala"
	_tmp63_ = _tmp62_;
#line 3634 "../src/Photo.vala"
	g_debug ("Photo.vala:3634: Updating metadata of %s", _tmp63_);
#line 3634 "../src/Photo.vala"
	_g_free0 (_tmp63_);
#line 3636 "../src/Photo.vala"
	if (media_source_get_exposure_time ((MediaSource*) self) != ((gint64) 0)) {
#line 22156 "Photo.c"
		PhotoMetadata* _tmp64_;
		MetadataDateTime* _tmp65_;
		MetadataDateTime* _tmp66_;
#line 3637 "../src/Photo.vala"
		_tmp64_ = metadata;
#line 3637 "../src/Photo.vala"
		_tmp65_ = metadata_date_time_new (media_source_get_exposure_time ((MediaSource*) self));
#line 3637 "../src/Photo.vala"
		_tmp66_ = _tmp65_;
#line 3637 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp64_, _tmp66_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3637 "../src/Photo.vala"
		_metadata_date_time_unref0 (_tmp66_);
#line 22170 "Photo.c"
	} else {
		PhotoMetadata* _tmp67_;
#line 3639 "../src/Photo.vala"
		_tmp67_ = metadata;
#line 3639 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp67_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 22177 "Photo.c"
	}
#line 3642 "../src/Photo.vala"
	if (export_metadata) {
#line 22181 "Photo.c"
		PhotoMetadata* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		PhotoMetadata* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		PhotoMetadata* _tmp74_;
		Dimensions _tmp75_ = {0};
		PhotoMetadata* _tmp76_;
		PhotoMetadata* _tmp77_;
		PhotoMetadata* _tmp79_;
#line 3644 "../src/Photo.vala"
		_tmp68_ = metadata;
#line 3644 "../src/Photo.vala"
		_tmp69_ = media_source_get_title ((MediaSource*) self);
#line 3644 "../src/Photo.vala"
		_tmp70_ = _tmp69_;
#line 3644 "../src/Photo.vala"
		photo_metadata_set_title (_tmp68_, _tmp70_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3644 "../src/Photo.vala"
		_g_free0 (_tmp70_);
#line 3645 "../src/Photo.vala"
		_tmp71_ = metadata;
#line 3645 "../src/Photo.vala"
		_tmp72_ = media_source_get_comment ((MediaSource*) self);
#line 3645 "../src/Photo.vala"
		_tmp73_ = _tmp72_;
#line 3645 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp71_, _tmp73_);
#line 3645 "../src/Photo.vala"
		_g_free0 (_tmp73_);
#line 3646 "../src/Photo.vala"
		_tmp74_ = metadata;
#line 3646 "../src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp75_);
#line 3646 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp74_, &_tmp75_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3647 "../src/Photo.vala"
		_tmp76_ = metadata;
#line 3647 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp76_, photo_get_orientation (self));
#line 3648 "../src/Photo.vala"
		_tmp77_ = metadata;
#line 3648 "../src/Photo.vala"
		photo_metadata_set_software (_tmp77_, _ (RESOURCES_APP_TITLE), RESOURCES_APP_VERSION);
#line 3650 "../src/Photo.vala"
		if (photo_get_orientation (self) != photo_get_original_orientation (self)) {
#line 22229 "Photo.c"
			PhotoMetadata* _tmp78_;
#line 3651 "../src/Photo.vala"
			_tmp78_ = metadata;
#line 3651 "../src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp78_);
#line 22235 "Photo.c"
		}
#line 3654 "../src/Photo.vala"
		_tmp79_ = metadata;
#line 3654 "../src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp79_);
#line 22241 "Photo.c"
	} else {
		PhotoMetadata* _tmp80_;
#line 3657 "../src/Photo.vala"
		_tmp80_ = metadata;
#line 3657 "../src/Photo.vala"
		photo_metadata_clear (_tmp80_);
#line 22248 "Photo.c"
	}
#line 3660 "../src/Photo.vala"
	_tmp81_ = writer;
#line 3660 "../src/Photo.vala"
	_tmp82_ = metadata;
#line 3660 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp81_, _tmp82_, &_inner_error0_);
#line 3660 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22258 "Photo.c"
		gboolean _tmp83_ = FALSE;
#line 3660 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3660 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3660 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3660 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3660 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3660 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3660 "../src/Photo.vala"
		return _tmp83_;
#line 22274 "Photo.c"
	}
#line 3662 "../src/Photo.vala"
	result = TRUE;
#line 3662 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3662 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3662 "../src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3662 "../src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3662 "../src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3662 "../src/Photo.vala"
	return result;
#line 22290 "Photo.c"
}

gboolean
photo_is_export_required (Photo* self,
                          Scaling* scaling,
                          PhotoFileFormat export_format)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 3668 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3668 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3669 "../src/Photo.vala"
	if (!scaling_is_unscaled (scaling)) {
#line 3669 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 22310 "Photo.c"
	} else {
#line 3669 "../src/Photo.vala"
		_tmp2_ = photo_has_alterations (self);
#line 22314 "Photo.c"
	}
#line 3669 "../src/Photo.vala"
	if (_tmp2_) {
#line 3669 "../src/Photo.vala"
		_tmp1_ = TRUE;
#line 22320 "Photo.c"
	} else {
#line 3669 "../src/Photo.vala"
		_tmp1_ = photo_has_user_generated_metadata (self);
#line 22324 "Photo.c"
	}
#line 3669 "../src/Photo.vala"
	if (_tmp1_) {
#line 3669 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 22330 "Photo.c"
	} else {
#line 3670 "../src/Photo.vala"
		_tmp0_ = export_format != photo_get_file_format (self);
#line 22334 "Photo.c"
	}
#line 3669 "../src/Photo.vala"
	result = _tmp0_;
#line 3669 "../src/Photo.vala"
	return result;
#line 22340 "Photo.c"
}

void
photo_export (Photo* self,
              GFile* dest_file,
              Scaling* scaling,
              JpegQuality quality,
              PhotoFileFormat export_format,
              gboolean direct_copy_unmodified,
              gboolean export_metadata,
              GError** error)
{
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoFileWriter* writer = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileWriter* _tmp12_;
	PhotoFileWriter* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	PhotoFileWriter* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp20_ = FALSE;
	PhotoFileWriter* _tmp29_;
	GdkPixbuf* _tmp30_;
	PhotoFileWriter* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp50_ = FALSE;
	PhotoFileMetadataWriter* _tmp58_ = NULL;
	gchar* _tmp59_;
	gchar* _tmp60_;
	PhotoFileMetadataWriter* _tmp61_;
	PhotoFileMetadataWriter* _tmp62_;
	PhotoMetadata* _tmp63_;
	GError* _inner_error0_ = NULL;
#line 3676 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3676 "../src/Photo.vala"
	g_return_if_fail (dest_file != NULL);
#line 3676 "../src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3678 "../src/Photo.vala"
	if (direct_copy_unmodified) {
#line 22393 "Photo.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3679 "../src/Photo.vala"
		_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 3679 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3679 "../src/Photo.vala"
		g_file_copy (_tmp1_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3679 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3679 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3679 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3679 "../src/Photo.vala"
			return;
#line 22410 "Photo.c"
		}
#line 3681 "../src/Photo.vala"
		return;
#line 22414 "Photo.c"
	}
#line 3688 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 22418 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 3688 "../src/Photo.vala"
		if (!photo_has_alterations (self)) {
#line 3688 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 22424 "Photo.c"
		} else {
#line 3688 "../src/Photo.vala"
			_tmp5_ = photo_only_metadata_changed (self);
#line 22428 "Photo.c"
		}
#line 3688 "../src/Photo.vala"
		_tmp4_ = _tmp5_;
#line 22432 "Photo.c"
	} else {
#line 3688 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 22436 "Photo.c"
	}
#line 3688 "../src/Photo.vala"
	if (_tmp4_) {
#line 3689 "../src/Photo.vala"
		_tmp3_ = export_format == photo_get_file_format (self);
#line 22442 "Photo.c"
	} else {
#line 3688 "../src/Photo.vala"
		_tmp3_ = FALSE;
#line 22446 "Photo.c"
	}
#line 3688 "../src/Photo.vala"
	if (_tmp3_) {
#line 3689 "../src/Photo.vala"
		_tmp2_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 22452 "Photo.c"
	} else {
#line 3688 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 22456 "Photo.c"
	}
#line 3688 "../src/Photo.vala"
	if (_tmp2_) {
#line 22460 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 3690 "../src/Photo.vala"
		_tmp6_ = photo_export_fullsized_backing (self, dest_file, export_metadata, &_inner_error0_);
#line 3690 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3690 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3690 "../src/Photo.vala"
			return;
#line 22470 "Photo.c"
		}
#line 3690 "../src/Photo.vala"
		if (_tmp6_) {
#line 3691 "../src/Photo.vala"
			return;
#line 22476 "Photo.c"
		}
	}
#line 3697 "../src/Photo.vala"
	_tmp7_ = photo_source_get_metadata ((PhotoSource*) self);
#line 3697 "../src/Photo.vala"
	metadata = _tmp7_;
#line 3698 "../src/Photo.vala"
	_tmp8_ = metadata;
#line 3698 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 22487 "Photo.c"
		PhotoMetadata* _tmp9_;
#line 3699 "../src/Photo.vala"
		_tmp9_ = photo_file_format_create_metadata (export_format);
#line 3699 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3699 "../src/Photo.vala"
		metadata = _tmp9_;
#line 22495 "Photo.c"
	}
#line 3702 "../src/Photo.vala"
	if (!photo_file_format_can_write (export_format)) {
#line 3703 "../src/Photo.vala"
		export_format = photo_file_format_get_system_default_format ();
#line 22501 "Photo.c"
	}
#line 3706 "../src/Photo.vala"
	_tmp10_ = g_file_get_path (dest_file);
#line 3706 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3706 "../src/Photo.vala"
	_tmp12_ = photo_file_format_create_writer (export_format, _tmp11_, &_inner_error0_);
#line 3706 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 3706 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 3706 "../src/Photo.vala"
	writer = _tmp13_;
#line 3706 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3706 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3706 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3706 "../src/Photo.vala"
		return;
#line 22523 "Photo.c"
	}
#line 3708 "../src/Photo.vala"
	_tmp14_ = data_object_to_string ((DataObject*) self);
#line 3708 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3708 "../src/Photo.vala"
	_tmp16_ = writer;
#line 3708 "../src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp16_);
#line 3708 "../src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 3709 "../src/Photo.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), export_format);
#line 3708 "../src/Photo.vala"
	g_debug ("Photo.vala:3708: Saving transformed version of %s to %s in file format" \
" %s", _tmp15_, _tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL);
#line 3708 "../src/Photo.vala"
	_g_free0 (_tmp18_);
#line 3708 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3715 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3715 "../src/Photo.vala"
		_tmp20_ = TRUE;
#line 22547 "Photo.c"
	} else {
#line 3716 "../src/Photo.vala"
		_tmp20_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 22551 "Photo.c"
	}
#line 3715 "../src/Photo.vala"
	if (_tmp20_) {
#line 22555 "Photo.c"
		GdkPixbuf* _tmp21_ = NULL;
		Scaling _tmp22_;
		GdkPixbuf* _tmp23_;
		GdkPixbuf* _tmp24_;
#line 3717 "../src/Photo.vala"
		_tmp22_ = *scaling;
#line 3717 "../src/Photo.vala"
		_tmp23_ = photo_get_pixbuf_with_options (self, &_tmp22_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3717 "../src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 3717 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3717 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3717 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3717 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3717 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3717 "../src/Photo.vala"
			return;
#line 22578 "Photo.c"
		}
#line 3717 "../src/Photo.vala"
		_tmp24_ = _tmp21_;
#line 3717 "../src/Photo.vala"
		_tmp21_ = NULL;
#line 3717 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3717 "../src/Photo.vala"
		pixbuf = _tmp24_;
#line 3715 "../src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 22590 "Photo.c"
	} else {
		GdkPixbuf* _tmp25_ = NULL;
		Scaling _tmp26_;
		GdkPixbuf* _tmp27_;
		GdkPixbuf* _tmp28_;
#line 3721 "../src/Photo.vala"
		_tmp26_ = *scaling;
#line 3721 "../src/Photo.vala"
		_tmp27_ = photo_get_pixbuf_with_options (self, &_tmp26_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3721 "../src/Photo.vala"
		_tmp25_ = _tmp27_;
#line 3721 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3721 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3721 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3721 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3721 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3721 "../src/Photo.vala"
			return;
#line 22614 "Photo.c"
		}
#line 3721 "../src/Photo.vala"
		_tmp28_ = _tmp25_;
#line 3721 "../src/Photo.vala"
		_tmp25_ = NULL;
#line 3721 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3721 "../src/Photo.vala"
		pixbuf = _tmp28_;
#line 3715 "../src/Photo.vala"
		_g_object_unref0 (_tmp25_);
#line 22626 "Photo.c"
	}
#line 3725 "../src/Photo.vala"
	_tmp29_ = writer;
#line 3725 "../src/Photo.vala"
	_tmp30_ = pixbuf;
#line 3725 "../src/Photo.vala"
	photo_file_writer_write (_tmp29_, _tmp30_, quality, &_inner_error0_);
#line 3725 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3725 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3725 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3725 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3725 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3725 "../src/Photo.vala"
		return;
#line 22646 "Photo.c"
	}
#line 3727 "../src/Photo.vala"
	_tmp31_ = writer;
#line 3727 "../src/Photo.vala"
	_tmp32_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp31_);
#line 3727 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 3727 "../src/Photo.vala"
	g_debug ("Photo.vala:3727: Setting EXIF for %s", _tmp33_);
#line 3727 "../src/Photo.vala"
	_g_free0 (_tmp33_);
#line 3730 "../src/Photo.vala"
	if (export_metadata) {
#line 22660 "Photo.c"
		PhotoMetadata* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		PhotoMetadata* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		PhotoMetadata* _tmp40_;
		PhotoMetadata* _tmp45_;
		PhotoMetadata* _tmp46_;
		PhotoMetadata* _tmp47_;
#line 3732 "../src/Photo.vala"
		_tmp34_ = metadata;
#line 3732 "../src/Photo.vala"
		_tmp35_ = media_source_get_title ((MediaSource*) self);
#line 3732 "../src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 3732 "../src/Photo.vala"
		photo_metadata_set_title (_tmp34_, _tmp36_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3732 "../src/Photo.vala"
		_g_free0 (_tmp36_);
#line 3733 "../src/Photo.vala"
		_tmp37_ = metadata;
#line 3733 "../src/Photo.vala"
		_tmp38_ = media_source_get_comment ((MediaSource*) self);
#line 3733 "../src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 3733 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp37_, _tmp39_);
#line 3733 "../src/Photo.vala"
		_g_free0 (_tmp39_);
#line 3734 "../src/Photo.vala"
		_tmp40_ = metadata;
#line 3734 "../src/Photo.vala"
		photo_metadata_set_software (_tmp40_, _ (RESOURCES_APP_TITLE), RESOURCES_APP_VERSION);
#line 3736 "../src/Photo.vala"
		if (media_source_get_exposure_time ((MediaSource*) self) != ((gint64) 0)) {
#line 22697 "Photo.c"
			PhotoMetadata* _tmp41_;
			MetadataDateTime* _tmp42_;
			MetadataDateTime* _tmp43_;
#line 3737 "../src/Photo.vala"
			_tmp41_ = metadata;
#line 3737 "../src/Photo.vala"
			_tmp42_ = metadata_date_time_new (media_source_get_exposure_time ((MediaSource*) self));
#line 3737 "../src/Photo.vala"
			_tmp43_ = _tmp42_;
#line 3737 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp41_, _tmp43_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3737 "../src/Photo.vala"
			_metadata_date_time_unref0 (_tmp43_);
#line 22711 "Photo.c"
		} else {
			PhotoMetadata* _tmp44_;
#line 3739 "../src/Photo.vala"
			_tmp44_ = metadata;
#line 3739 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp44_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 22718 "Photo.c"
		}
#line 3742 "../src/Photo.vala"
		_tmp45_ = metadata;
#line 3742 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp45_, "Exif.Iop.RelatedImageWidth");
#line 3743 "../src/Photo.vala"
		_tmp46_ = metadata;
#line 3743 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp46_, "Exif.Iop.RelatedImageHeight");
#line 3744 "../src/Photo.vala"
		_tmp47_ = metadata;
#line 3744 "../src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp47_);
#line 3746 "../src/Photo.vala"
		if (photo_has_user_generated_metadata (self)) {
#line 22734 "Photo.c"
			PhotoMetadata* _tmp48_;
#line 3747 "../src/Photo.vala"
			_tmp48_ = metadata;
#line 3747 "../src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp48_);
#line 22740 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp49_;
#line 3751 "../src/Photo.vala"
		_tmp49_ = metadata;
#line 3751 "../src/Photo.vala"
		photo_metadata_clear (_tmp49_);
#line 22748 "Photo.c"
	}
#line 3758 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3758 "../src/Photo.vala"
		_tmp50_ = TRUE;
#line 22754 "Photo.c"
	} else {
#line 3759 "../src/Photo.vala"
		_tmp50_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 22758 "Photo.c"
	}
#line 3758 "../src/Photo.vala"
	if (_tmp50_) {
#line 22762 "Photo.c"
		PhotoMetadata* _tmp51_;
		Dimensions _tmp52_ = {0};
		PhotoMetadata* _tmp53_;
#line 3760 "../src/Photo.vala"
		_tmp51_ = metadata;
#line 3760 "../src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ORIENTATION, &_tmp52_);
#line 3760 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp51_, &_tmp52_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3761 "../src/Photo.vala"
		_tmp53_ = metadata;
#line 3761 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp53_, photo_get_orientation (self));
#line 22776 "Photo.c"
	} else {
		PhotoMetadata* _tmp54_;
		GdkPixbuf* _tmp55_;
		Dimensions _tmp56_ = {0};
		PhotoMetadata* _tmp57_;
#line 3764 "../src/Photo.vala"
		_tmp54_ = metadata;
#line 3764 "../src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3764 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp55_, &_tmp56_);
#line 3764 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp54_, &_tmp56_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3765 "../src/Photo.vala"
		_tmp57_ = metadata;
#line 3765 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp57_, ORIENTATION_TOP_LEFT);
#line 22794 "Photo.c"
	}
#line 3768 "../src/Photo.vala"
	_tmp59_ = g_file_get_path (dest_file);
#line 3768 "../src/Photo.vala"
	_tmp60_ = _tmp59_;
#line 3768 "../src/Photo.vala"
	_tmp61_ = photo_file_format_create_metadata_writer (export_format, _tmp60_, &_inner_error0_);
#line 3768 "../src/Photo.vala"
	_tmp62_ = _tmp61_;
#line 3768 "../src/Photo.vala"
	_g_free0 (_tmp60_);
#line 3768 "../src/Photo.vala"
	_tmp58_ = _tmp62_;
#line 3768 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3768 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3768 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3768 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3768 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3768 "../src/Photo.vala"
		return;
#line 22820 "Photo.c"
	}
#line 3768 "../src/Photo.vala"
	_tmp63_ = metadata;
#line 3768 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp58_, _tmp63_, &_inner_error0_);
#line 3768 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3768 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3768 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp58_);
#line 3768 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3768 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3768 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3768 "../src/Photo.vala"
		return;
#line 22840 "Photo.c"
	}
#line 3676 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp58_);
#line 3676 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3676 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3676 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 22850 "Photo.c"
}

static GFile*
photo_generate_new_editable_file (Photo* self,
                                  PhotoFileFormat* file_format,
                                  GError** error)
{
	PhotoFileFormat _vala_file_format = 0;
	GFile* backing = NULL;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	gchar* editable_basename = NULL;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean collision = FALSE;
	GFile* _tmp18_ = NULL;
	GFile* _tmp19_;
	GFile* _tmp20_;
	gboolean _tmp21_ = FALSE;
	GFile* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 3771 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22884 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3773 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3773 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22891 "Photo.c"
		{
			GFile* _tmp1_;
#line 3774 "../src/Photo.vala"
			_vala_file_format = photo_get_file_format (self);
#line 3775 "../src/Photo.vala"
			_tmp1_ = media_source_get_file ((MediaSource*) self);
#line 3775 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3775 "../src/Photo.vala"
			backing = _tmp1_;
#line 22902 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 3773 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 3773 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22911 "Photo.c"
		}
#line 3773 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3773 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3773 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3773 "../src/Photo.vala"
			return NULL;
#line 22921 "Photo.c"
		}
	}
#line 3778 "../src/Photo.vala"
	if (!photo_file_format_can_write (_vala_file_format)) {
#line 3779 "../src/Photo.vala"
		_vala_file_format = photo_file_format_get_system_default_format ();
#line 22928 "Photo.c"
	}
#line 3783 "../src/Photo.vala"
	_tmp3_ = g_file_get_basename (backing);
#line 3783 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3783 "../src/Photo.vala"
	disassemble_filename (_tmp4_, &_tmp5_, &_tmp6_);
#line 3783 "../src/Photo.vala"
	_g_free0 (name);
#line 3783 "../src/Photo.vala"
	name = _tmp5_;
#line 3783 "../src/Photo.vala"
	_g_free0 (ext);
#line 3783 "../src/Photo.vala"
	ext = _tmp6_;
#line 3783 "../src/Photo.vala"
	_g_free0 (_tmp4_);
#line 3785 "../src/Photo.vala"
	_tmp8_ = ext;
#line 3785 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 3785 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 22952 "Photo.c"
	} else {
		PhotoFileFormatProperties* _tmp9_;
		PhotoFileFormatProperties* _tmp10_;
		const gchar* _tmp11_;
#line 3785 "../src/Photo.vala"
		_tmp9_ = photo_file_format_get_properties (_vala_file_format);
#line 3785 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 3785 "../src/Photo.vala"
		_tmp11_ = ext;
#line 3785 "../src/Photo.vala"
		_tmp7_ = !photo_file_format_properties_is_recognized_extension (_tmp10_, _tmp11_);
#line 3785 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp10_);
#line 22967 "Photo.c"
	}
#line 3785 "../src/Photo.vala"
	if (_tmp7_) {
#line 22971 "Photo.c"
		PhotoFileFormatProperties* _tmp12_;
		PhotoFileFormatProperties* _tmp13_;
		gchar* _tmp14_;
#line 3786 "../src/Photo.vala"
		_tmp12_ = photo_file_format_get_properties (_vala_file_format);
#line 3786 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 3786 "../src/Photo.vala"
		_tmp14_ = photo_file_format_properties_get_default_extension (_tmp13_);
#line 3786 "../src/Photo.vala"
		_g_free0 (ext);
#line 3786 "../src/Photo.vala"
		ext = _tmp14_;
#line 3786 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp13_);
#line 22987 "Photo.c"
	}
#line 3789 "../src/Photo.vala"
	_tmp15_ = name;
#line 3789 "../src/Photo.vala"
	_tmp16_ = ext;
#line 3789 "../src/Photo.vala"
	_tmp17_ = g_strdup_printf ("%s_%s.%s", _tmp15_, _ ("modified"), _tmp16_);
#line 3789 "../src/Photo.vala"
	editable_basename = _tmp17_;
#line 3792 "../src/Photo.vala"
	_tmp19_ = g_file_get_parent (backing);
#line 3792 "../src/Photo.vala"
	_tmp20_ = _tmp19_;
#line 3792 "../src/Photo.vala"
	_tmp22_ = generate_unique_file (_tmp20_, editable_basename, &_tmp21_, &_inner_error0_);
#line 3792 "../src/Photo.vala"
	collision = _tmp21_;
#line 3792 "../src/Photo.vala"
	_tmp23_ = _tmp22_;
#line 3792 "../src/Photo.vala"
	_g_object_unref0 (_tmp20_);
#line 3792 "../src/Photo.vala"
	_tmp18_ = _tmp23_;
#line 3792 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3792 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3792 "../src/Photo.vala"
		_g_free0 (editable_basename);
#line 3792 "../src/Photo.vala"
		_g_free0 (ext);
#line 3792 "../src/Photo.vala"
		_g_free0 (name);
#line 3792 "../src/Photo.vala"
		_g_object_unref0 (backing);
#line 3792 "../src/Photo.vala"
		return NULL;
#line 23025 "Photo.c"
	}
#line 3792 "../src/Photo.vala"
	_tmp24_ = _tmp18_;
#line 3792 "../src/Photo.vala"
	_tmp18_ = NULL;
#line 3792 "../src/Photo.vala"
	result = _tmp24_;
#line 3792 "../src/Photo.vala"
	_g_object_unref0 (_tmp18_);
#line 3792 "../src/Photo.vala"
	_g_free0 (editable_basename);
#line 3792 "../src/Photo.vala"
	_g_free0 (ext);
#line 3792 "../src/Photo.vala"
	_g_free0 (name);
#line 3792 "../src/Photo.vala"
	_g_object_unref0 (backing);
#line 3792 "../src/Photo.vala"
	if (file_format) {
#line 3792 "../src/Photo.vala"
		*file_format = _vala_file_format;
#line 23047 "Photo.c"
	}
#line 3792 "../src/Photo.vala"
	return result;
#line 23051 "Photo.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 3813 "../src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 23059 "Photo.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 3813 "../src/Photo.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 23067 "Photo.c"
}

static gboolean
photo_launch_editor (GFile* file,
                     PhotoFileFormat file_format,
                     const gchar* commandline,
                     GError** error)
{
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp4_;
	GAppInfo* _tmp5_;
	gchar** argv = NULL;
	gchar** _tmp10_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	GPid child_pid = 0;
	gboolean _tmp15_ = FALSE;
	gchar** _tmp16_;
	gint _tmp16__length1;
	GPid _tmp17_ = 0;
	gboolean _tmp18_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 3795 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3795 "../src/Photo.vala"
	g_return_val_if_fail (commandline != NULL, FALSE);
#line 3797 "../src/Photo.vala"
	if (is_string_empty (commandline)) {
#line 3798 "../src/Photo.vala"
		result = FALSE;
#line 3798 "../src/Photo.vala"
		return result;
#line 23108 "Photo.c"
	}
	{
		GAppInfo* _tmp0_ = NULL;
		GAppInfo* _tmp1_;
		GAppInfo* _tmp2_;
#line 3803 "../src/Photo.vala"
		_tmp1_ = g_app_info_create_from_commandline (commandline, "", G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 3803 "../src/Photo.vala"
		_tmp0_ = _tmp1_;
#line 3803 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23120 "Photo.c"
			goto __catch0_g_error;
		}
#line 3803 "../src/Photo.vala"
		_tmp2_ = _tmp0_;
#line 3803 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 3803 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3803 "../src/Photo.vala"
		app = _tmp2_;
#line 3802 "../src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 23133 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3802 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3806 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3806 "../src/Photo.vala"
		app = NULL;
#line 23144 "Photo.c"
	}
	__finally0:
#line 3802 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23149 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 3802 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3802 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3802 "../src/Photo.vala"
		return _tmp3_;
#line 23157 "Photo.c"
	}
#line 3809 "../src/Photo.vala"
	files = NULL;
#line 3810 "../src/Photo.vala"
	_tmp4_ = _g_object_ref0 (file);
#line 3810 "../src/Photo.vala"
	files = g_list_insert (files, _tmp4_, -1);
#line 3812 "../src/Photo.vala"
	_tmp5_ = app;
#line 3812 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 23169 "Photo.c"
		gboolean _tmp6_ = FALSE;
		GAppInfo* _tmp7_;
		GList* _tmp8_;
#line 3813 "../src/Photo.vala"
		_tmp7_ = app;
#line 3813 "../src/Photo.vala"
		_tmp8_ = files;
#line 3813 "../src/Photo.vala"
		_tmp6_ = g_app_info_launch (_tmp7_, _tmp8_, NULL, &_inner_error0_);
#line 3813 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23181 "Photo.c"
			gboolean _tmp9_ = FALSE;
#line 3813 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3813 "../src/Photo.vala"
			(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3813 "../src/Photo.vala"
			_g_object_unref0 (app);
#line 3813 "../src/Photo.vala"
			return _tmp9_;
#line 23191 "Photo.c"
		}
#line 3813 "../src/Photo.vala"
		result = _tmp6_;
#line 3813 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3813 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3813 "../src/Photo.vala"
		return result;
#line 23201 "Photo.c"
	}
#line 3816 "../src/Photo.vala"
	_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 3816 "../src/Photo.vala"
	argv = _tmp10_;
#line 3816 "../src/Photo.vala"
	argv_length1 = 2;
#line 3816 "../src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3817 "../src/Photo.vala"
	_tmp11_ = argv;
#line 3817 "../src/Photo.vala"
	_tmp11__length1 = argv_length1;
#line 3817 "../src/Photo.vala"
	_tmp12_ = g_strdup (commandline);
#line 3817 "../src/Photo.vala"
	_g_free0 (_tmp11_[0]);
#line 3817 "../src/Photo.vala"
	_tmp11_[0] = _tmp12_;
#line 3818 "../src/Photo.vala"
	_tmp13_ = argv;
#line 3818 "../src/Photo.vala"
	_tmp13__length1 = argv_length1;
#line 3818 "../src/Photo.vala"
	_tmp14_ = g_file_get_path (file);
#line 3818 "../src/Photo.vala"
	_g_free0 (_tmp13_[1]);
#line 3818 "../src/Photo.vala"
	_tmp13_[1] = _tmp14_;
#line 3822 "../src/Photo.vala"
	_tmp16_ = argv;
#line 3822 "../src/Photo.vala"
	_tmp16__length1 = argv_length1;
#line 3822 "../src/Photo.vala"
	_tmp18_ = g_spawn_async ("/", _tmp16_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp17_, &_inner_error0_);
#line 3822 "../src/Photo.vala"
	child_pid = _tmp17_;
#line 3822 "../src/Photo.vala"
	_tmp15_ = _tmp18_;
#line 3822 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23243 "Photo.c"
		gboolean _tmp19_ = FALSE;
#line 3822 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3822 "../src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3822 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3822 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3822 "../src/Photo.vala"
		return _tmp19_;
#line 23255 "Photo.c"
	}
#line 3822 "../src/Photo.vala"
	result = _tmp15_;
#line 3822 "../src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3822 "../src/Photo.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3822 "../src/Photo.vala"
	_g_object_unref0 (app);
#line 3822 "../src/Photo.vala"
	return result;
#line 23267 "Photo.c"
}

void
photo_open_with_raw_external_editor (Photo* self,
                                     const gchar* external_editor,
                                     GError** error)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 3832 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3832 "../src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3833 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 3833 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3833 "../src/Photo.vala"
	photo_launch_editor (_tmp1_, photo_get_master_file_format (self), external_editor, &_inner_error0_);
#line 3833 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3833 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3833 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3833 "../src/Photo.vala"
		return;
#line 23296 "Photo.c"
	}
}

void
photo_open_with_external_editor (Photo* self,
                                 const gchar* external_editor,
                                 GError** error)
{
	GFile* modified_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 3837 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3837 "../src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3838 "../src/Photo.vala"
	_tmp0_ = photo_get_modified_file (self, &_inner_error0_);
#line 3838 "../src/Photo.vala"
	modified_file = _tmp0_;
#line 3838 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3838 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3838 "../src/Photo.vala"
		return;
#line 23323 "Photo.c"
	}
#line 3839 "../src/Photo.vala"
	_tmp1_ = modified_file;
#line 3839 "../src/Photo.vala"
	photo_launch_editor (_tmp1_, photo_get_file_format (self), external_editor, &_inner_error0_);
#line 3839 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3839 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3839 "../src/Photo.vala"
		_g_object_unref0 (modified_file);
#line 3839 "../src/Photo.vala"
		return;
#line 23337 "Photo.c"
	}
#line 3837 "../src/Photo.vala"
	_g_object_unref0 (modified_file);
#line 23341 "Photo.c"
}

GFile*
photo_get_modified_file (Photo* self,
                         GError** error)
{
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GFile* _tmp17_;
	gboolean _tmp23_ = FALSE;
	GFile* _tmp24_;
	GFile* _tmp38_;
	GFileMonitor* _tmp39_;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 3842 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3843 "../src/Photo.vala"
	current_editable_file = NULL;
#line 3844 "../src/Photo.vala"
	create_editable_file = NULL;
#line 23366 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3846 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3846 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 23373 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3847 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3847 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3847 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 23384 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 3848 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3848 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3848 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 3848 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3848 "../src/Photo.vala"
				current_editable_file = _tmp5_;
#line 23398 "Photo.c"
			}
#line 3851 "../src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3851 "../src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 23404 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_;
				GFile* _tmp10_;
#line 3852 "../src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error0_);
#line 3852 "../src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3852 "../src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3852 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23417 "Photo.c"
					goto __catch0_g_error;
				}
#line 3852 "../src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3852 "../src/Photo.vala"
				_tmp7_ = NULL;
#line 3852 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3852 "../src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3851 "../src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 23430 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_;
				PhotoFileReader* _tmp12_;
#line 3854 "../src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3854 "../src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3854 "../src/Photo.vala"
				editable_file_format = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp12_);
#line 23440 "Photo.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp13_;
#line 3846 "../src/Photo.vala"
			_lock_error_ = _inner_error0_;
#line 3846 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 3846 "../src/Photo.vala"
			_tmp13_ = _lock_error_;
#line 3846 "../src/Photo.vala"
			_lock_error_ = NULL;
#line 3846 "../src/Photo.vala"
			_inner_error0_ = _tmp13_;
#line 3846 "../src/Photo.vala"
			_g_error_free0 (_lock_error_);
#line 23460 "Photo.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoBackingReaders* _tmp14_;
#line 3846 "../src/Photo.vala"
			_tmp14_ = self->priv->readers;
#line 3846 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 23471 "Photo.c"
		}
#line 3846 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3846 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3846 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3846 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3846 "../src/Photo.vala"
			return NULL;
#line 23483 "Photo.c"
		}
	}
#line 3860 "../src/Photo.vala"
	_tmp17_ = create_editable_file;
#line 3860 "../src/Photo.vala"
	if (_tmp17_ == NULL) {
#line 23490 "Photo.c"
		GFile* _tmp18_;
#line 3860 "../src/Photo.vala"
		_tmp18_ = current_editable_file;
#line 3860 "../src/Photo.vala"
		_tmp16_ = _tmp18_ != NULL;
#line 23496 "Photo.c"
	} else {
#line 3860 "../src/Photo.vala"
		_tmp16_ = FALSE;
#line 23500 "Photo.c"
	}
#line 3860 "../src/Photo.vala"
	if (_tmp16_) {
#line 23504 "Photo.c"
		gboolean _tmp19_ = FALSE;
		GFile* _tmp20_;
#line 3861 "../src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3861 "../src/Photo.vala"
		if (!g_file_query_exists (_tmp20_, NULL)) {
#line 3861 "../src/Photo.vala"
			_tmp19_ = TRUE;
#line 23513 "Photo.c"
		} else {
#line 3861 "../src/Photo.vala"
			_tmp19_ = photo_has_transformations (self);
#line 23517 "Photo.c"
		}
#line 3861 "../src/Photo.vala"
		_tmp15_ = _tmp19_;
#line 23521 "Photo.c"
	} else {
#line 3860 "../src/Photo.vala"
		_tmp15_ = FALSE;
#line 23525 "Photo.c"
	}
#line 3860 "../src/Photo.vala"
	if (_tmp15_) {
#line 23529 "Photo.c"
		GFile* _tmp21_;
		GFile* _tmp22_;
#line 3862 "../src/Photo.vala"
		_tmp21_ = current_editable_file;
#line 3862 "../src/Photo.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 3862 "../src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3862 "../src/Photo.vala"
		create_editable_file = _tmp22_;
#line 23540 "Photo.c"
	}
#line 3866 "../src/Photo.vala"
	_tmp24_ = create_editable_file;
#line 3866 "../src/Photo.vala"
	if (_tmp24_ != NULL) {
#line 3866 "../src/Photo.vala"
		_tmp23_ = photo_file_format_can_write (editable_file_format);
#line 23548 "Photo.c"
	} else {
#line 3866 "../src/Photo.vala"
		_tmp23_ = FALSE;
#line 23552 "Photo.c"
	}
#line 3866 "../src/Photo.vala"
	if (_tmp23_) {
#line 23556 "Photo.c"
		GFile* _tmp35_;
		GFile* _tmp36_;
		GFile* _tmp37_;
#line 3867 "../src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 23562 "Photo.c"
		{
			GFile* _tmp25_;
			Scaling _tmp26_ = {0};
#line 3870 "../src/Photo.vala"
			_tmp25_ = create_editable_file;
#line 3870 "../src/Photo.vala"
			scaling_for_original (&_tmp26_);
#line 3870 "../src/Photo.vala"
			photo_export (self, _tmp25_, &_tmp26_, JPEG_QUALITY_MAXIMUM, editable_file_format, FALSE, TRUE, &_inner_error0_);
#line 3870 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23574 "Photo.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GError* _tmp33_;
			GError* _tmp34_;
#line 3869 "../src/Photo.vala"
			err = _inner_error0_;
#line 3869 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 23588 "Photo.c"
			{
				GFile* _tmp27_;
#line 3875 "../src/Photo.vala"
				_tmp27_ = create_editable_file;
#line 3875 "../src/Photo.vala"
				g_file_delete (_tmp27_, NULL, &_inner_error0_);
#line 3875 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23597 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				GError* _tmp31_;
				const gchar* _tmp32_;
#line 3874 "../src/Photo.vala"
				delete_err = _inner_error0_;
#line 3874 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 3878 "../src/Photo.vala"
				_tmp28_ = create_editable_file;
#line 3878 "../src/Photo.vala"
				_tmp29_ = g_file_get_path (_tmp28_);
#line 3878 "../src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 3878 "../src/Photo.vala"
				_tmp31_ = delete_err;
#line 3878 "../src/Photo.vala"
				_tmp32_ = _tmp31_->message;
#line 3878 "../src/Photo.vala"
				g_warning ("Photo.vala:3878: Unable to delete editable file %s after export error:" \
" %s", _tmp30_, _tmp32_);
#line 3878 "../src/Photo.vala"
				_g_free0 (_tmp30_);
#line 3874 "../src/Photo.vala"
				_g_error_free0 (delete_err);
#line 23630 "Photo.c"
			}
			__finally2:
#line 3874 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3874 "../src/Photo.vala"
				_g_error_free0 (err);
#line 3874 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3874 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3874 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3874 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 3874 "../src/Photo.vala"
				return NULL;
#line 23647 "Photo.c"
			}
#line 3882 "../src/Photo.vala"
			_tmp33_ = err;
#line 3882 "../src/Photo.vala"
			_tmp34_ = _g_error_copy0 (_tmp33_);
#line 3882 "../src/Photo.vala"
			_inner_error0_ = _tmp34_;
#line 3882 "../src/Photo.vala"
			_g_error_free0 (err);
#line 23657 "Photo.c"
			goto __finally1;
		}
		__finally1:
#line 3869 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3869 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3869 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3869 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3869 "../src/Photo.vala"
			return NULL;
#line 23671 "Photo.c"
		}
#line 3886 "../src/Photo.vala"
		_tmp35_ = create_editable_file;
#line 3886 "../src/Photo.vala"
		photo_attach_editable (self, editable_file_format, _tmp35_, &_inner_error0_);
#line 3886 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3886 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3886 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3886 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3886 "../src/Photo.vala"
			return NULL;
#line 23687 "Photo.c"
		}
#line 3888 "../src/Photo.vala"
		_tmp36_ = create_editable_file;
#line 3888 "../src/Photo.vala"
		_tmp37_ = _g_object_ref0 (_tmp36_);
#line 3888 "../src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3888 "../src/Photo.vala"
		current_editable_file = _tmp37_;
#line 23697 "Photo.c"
	}
#line 3891 "../src/Photo.vala"
	_tmp38_ = current_editable_file;
#line 3891 "../src/Photo.vala"
	_vala_assert (_tmp38_ != NULL, "current_editable_file != null");
#line 3894 "../src/Photo.vala"
	_tmp39_ = self->priv->editable_monitor;
#line 3894 "../src/Photo.vala"
	if (_tmp39_ == NULL) {
#line 23707 "Photo.c"
		GFile* _tmp40_;
#line 3895 "../src/Photo.vala"
		_tmp40_ = current_editable_file;
#line 3895 "../src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp40_, &_inner_error0_);
#line 3895 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3895 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3895 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3895 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3895 "../src/Photo.vala"
			return NULL;
#line 23723 "Photo.c"
		}
	}
#line 3898 "../src/Photo.vala"
	result = current_editable_file;
#line 3898 "../src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3898 "../src/Photo.vala"
	return result;
#line 23732 "Photo.c"
}

void
photo_revert_to_master (Photo* self,
                        gboolean notify)
{
#line 3901 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3902 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, notify);
#line 23743 "Photo.c"
}

static void
_photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                        GFile* file,
                                                        GFile* other_file,
                                                        GFileMonitorEvent event_type,
                                                        gpointer self)
{
#line 3912 "../src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 23755 "Photo.c"
}

static void
photo_start_monitoring_editable (Photo* self,
                                 GFile* file,
                                 GError** error)
{
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3905 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3905 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3906 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3909 "../src/Photo.vala"
	library_monitor_blacklist_file (file, "Photo.start_monitoring_editable");
#line 3911 "../src/Photo.vala"
	_tmp1_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 3911 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3911 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3911 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3911 "../src/Photo.vala"
		return;
#line 23786 "Photo.c"
	}
#line 3911 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 3911 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3911 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3911 "../src/Photo.vala"
	self->priv->editable_monitor = _tmp2_;
#line 3912 "../src/Photo.vala"
	_tmp3_ = self->priv->editable_monitor;
#line 3912 "../src/Photo.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3905 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 23802 "Photo.c"
}

static void
photo_halt_monitoring_editable (Photo* self)
{
	GFileMonitor* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_;
	GFileMonitor* _tmp6_;
#line 3915 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3916 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3916 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3917 "../src/Photo.vala"
		return;
#line 23823 "Photo.c"
	}
#line 3921 "../src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3921 "../src/Photo.vala"
	file = _tmp1_;
#line 3922 "../src/Photo.vala"
	_tmp2_ = file;
#line 3922 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 23833 "Photo.c"
		GFile* _tmp3_;
#line 3923 "../src/Photo.vala"
		_tmp3_ = file;
#line 3923 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 23839 "Photo.c"
	}
#line 3926 "../src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3926 "../src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3926 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3927 "../src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3927 "../src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3928 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3928 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3915 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 23857 "Photo.c"
}

static void
photo_attach_editable (Photo* self,
                       PhotoFileFormat file_format,
                       GFile* file,
                       GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3931 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3931 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3936 "../src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 3937 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 3937 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3937 "../src/Photo.vala"
	_tmp2_ = photo_file_format_create_reader (file_format, _tmp1_);
#line 3937 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3937 "../src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp3_, &_inner_error0_);
#line 3937 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 3937 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 3937 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3937 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3937 "../src/Photo.vala"
		return;
#line 23897 "Photo.c"
	}
}

static void
photo_update_editable_attributes (Photo* self,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3940 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3941 "../src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error0_);
#line 3941 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3941 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3941 "../src/Photo.vala"
		return;
#line 23916 "Photo.c"
	}
}

void
photo_reimport_editable (Photo* self,
                         GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3944 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3945 "../src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error0_);
#line 3945 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3945 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3945 "../src/Photo.vala"
		return;
#line 23935 "Photo.c"
	}
}

static void
_vala_array_add24 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 4052 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4052 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4052 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 23951 "Photo.c"
	}
#line 4052 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4052 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 23957 "Photo.c"
}

static void
_vala_array_add25 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 4053 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4053 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4053 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 23972 "Photo.c"
	}
#line 4053 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4053 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 23978 "Photo.c"
}

static void
_vala_array_add26 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 4056 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4056 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4056 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 23993 "Photo.c"
	}
#line 4056 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4056 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 23999 "Photo.c"
}

static void
_vala_array_add27 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 4061 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4061 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4061 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 24014 "Photo.c"
	}
#line 4061 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4061 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 24020 "Photo.c"
}

static void
_vala_array_add28 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 4062 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4062 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4062 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 24035 "Photo.c"
	}
#line 4062 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4062 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 24041 "Photo.c"
}

static void
_vala_array_add29 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 4065 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4065 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4065 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 24056 "Photo.c"
	}
#line 4065 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4065 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 24062 "Photo.c"
}

static void
photo_update_editable (Photo* self,
                       gboolean only_attributes,
                       PhotoFileReader* new_reader,
                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp5_;
	PhotoFileReader* _tmp6_;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp7_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp8_;
	GFile* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_;
	gboolean _tmp75_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp84_;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp88_ = FALSE;
	gchar** _tmp92_;
	gint _tmp92__length1;
	GError* _inner_error0_ = NULL;
#line 3950 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3952 "../src/Photo.vala"
	if (only_attributes) {
#line 3952 "../src/Photo.vala"
		_tmp1_ = new_reader == NULL;
#line 24107 "Photo.c"
	} else {
#line 3952 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 24111 "Photo.c"
	}
#line 3952 "../src/Photo.vala"
	if (_tmp1_) {
#line 3952 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 24117 "Photo.c"
	} else {
#line 3952 "../src/Photo.vala"
		_tmp0_ = !only_attributes;
#line 24121 "Photo.c"
	}
#line 3952 "../src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes && new_reader == null) || (!only_attributes)");
#line 3954 "../src/Photo.vala"
	_tmp2_ = photo_get_editable_reader (self);
#line 3954 "../src/Photo.vala"
	old_reader = _tmp2_;
#line 3956 "../src/Photo.vala"
	_tmp3_ = new_reader;
#line 3956 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 24133 "Photo.c"
		PhotoFileReader* _tmp4_;
#line 3956 "../src/Photo.vala"
		_tmp4_ = old_reader;
#line 3956 "../src/Photo.vala"
		_tmp3_ = _tmp4_;
#line 24139 "Photo.c"
	}
#line 3956 "../src/Photo.vala"
	_tmp5_ = _photo_file_adapter_ref0 (_tmp3_);
#line 3956 "../src/Photo.vala"
	reader = _tmp5_;
#line 3957 "../src/Photo.vala"
	_tmp6_ = reader;
#line 3957 "../src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 3958 "../src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3960 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3960 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3960 "../src/Photo.vala"
		return;
#line 24157 "Photo.c"
	}
#line 3963 "../src/Photo.vala"
	timestamp_changed = FALSE;
#line 3964 "../src/Photo.vala"
	filesize_changed = FALSE;
#line 3965 "../src/Photo.vala"
	is_new_editable = FALSE;
#line 3967 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp7_);
#line 3967 "../src/Photo.vala"
	editable_id = _tmp7_;
#line 3968 "../src/Photo.vala"
	_tmp8_ = reader;
#line 3968 "../src/Photo.vala"
	_tmp9_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp8_);
#line 3968 "../src/Photo.vala"
	file = _tmp9_;
#line 3971 "../src/Photo.vala"
	_tmp10_ = file;
#line 3971 "../src/Photo.vala"
	_tmp12_ = photo_query_backing_photo_row (self, _tmp10_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp11_, &_inner_error0_);
#line 3971 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3971 "../src/Photo.vala"
	detected = _tmp11_;
#line 3971 "../src/Photo.vala"
	backing = _tmp12_;
#line 3971 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3971 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3971 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3971 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 3971 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3971 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3971 "../src/Photo.vala"
		return;
#line 24199 "Photo.c"
	}
#line 3975 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 24203 "Photo.c"
		BackingPhotoRow* _tmp13_;
#line 3977 "../src/Photo.vala"
		_tmp13_ = backing;
#line 3977 "../src/Photo.vala"
		if (_tmp13_ != NULL) {
#line 24209 "Photo.c"
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 3978 "../src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 3978 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3978 "../src/Photo.vala"
			_tmp16_ = backing;
#line 3978 "../src/Photo.vala"
			backing_photo_table_add (_tmp15_, _tmp16_, &_inner_error0_);
#line 3978 "../src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 3978 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3978 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 3978 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3978 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3978 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 3978 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3978 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3978 "../src/Photo.vala"
				return;
#line 24239 "Photo.c"
			}
			{
				PhotoRow* _tmp17_;
#line 3979 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 3979 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 24247 "Photo.c"
				{
					PhotoTable* _tmp18_;
					PhotoTable* _tmp19_;
					PhotoRow* _tmp20_;
					BackingPhotoRow* _tmp21_;
					BackingPhotoID _tmp22_;
					BackingPhotoRow* _tmp23_;
					BackingPhotoRow* _tmp24_;
					BackingPhotoRow* _tmp25_;
					BackingPhotoRow* _tmp26_;
					BackingPhotoRow* _tmp27_;
#line 3980 "../src/Photo.vala"
					timestamp_changed = TRUE;
#line 3981 "../src/Photo.vala"
					filesize_changed = TRUE;
#line 3983 "../src/Photo.vala"
					_tmp18_ = photo_table_get_instance ();
#line 3983 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 3983 "../src/Photo.vala"
					_tmp20_ = self->row;
#line 3983 "../src/Photo.vala"
					_tmp21_ = backing;
#line 3983 "../src/Photo.vala"
					_tmp22_ = _tmp21_->id;
#line 3983 "../src/Photo.vala"
					photo_table_attach_editable (_tmp19_, _tmp20_, &_tmp22_, &_inner_error0_);
#line 3983 "../src/Photo.vala"
					_database_table_unref0 (_tmp19_);
#line 3983 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24279 "Photo.c"
						goto __catch0_g_error;
					}
#line 3984 "../src/Photo.vala"
					_tmp23_ = backing;
#line 3984 "../src/Photo.vala"
					_tmp24_ = _backing_photo_row_ref0 (_tmp23_);
#line 3984 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3984 "../src/Photo.vala"
					self->priv->editable = _tmp24_;
#line 3985 "../src/Photo.vala"
					_tmp25_ = self->priv->editable;
#line 3985 "../src/Photo.vala"
					_tmp26_ = _backing_photo_row_ref0 (_tmp25_);
#line 3985 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3985 "../src/Photo.vala"
					self->backing_photo_row = _tmp26_;
#line 3986 "../src/Photo.vala"
					_tmp27_ = self->backing_photo_row;
#line 3986 "../src/Photo.vala"
					photo_set_orientation (self, _tmp27_->original_orientation);
#line 24302 "Photo.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* _lock_error_ = NULL;
					GError* _tmp28_;
#line 3979 "../src/Photo.vala"
					_lock_error_ = _inner_error0_;
#line 3979 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 3979 "../src/Photo.vala"
					_tmp28_ = _lock_error_;
#line 3979 "../src/Photo.vala"
					_lock_error_ = NULL;
#line 3979 "../src/Photo.vala"
					_inner_error0_ = _tmp28_;
#line 3979 "../src/Photo.vala"
					_g_error_free0 (_lock_error_);
#line 24321 "Photo.c"
					goto __finally0;
				}
				__finally0:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp29_;
#line 3979 "../src/Photo.vala"
					_tmp29_ = self->row;
#line 3979 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24332 "Photo.c"
				}
#line 3979 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3979 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 3979 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3979 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3979 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 3979 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3979 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3979 "../src/Photo.vala"
					return;
#line 24350 "Photo.c"
				}
			}
		}
#line 3989 "../src/Photo.vala"
		is_new_editable = TRUE;
#line 24356 "Photo.c"
	}
#line 3992 "../src/Photo.vala"
	if (only_attributes) {
#line 24360 "Photo.c"
		GFileInfo* info = NULL;
		gint64 mod_time = 0LL;
		GFileInfo* _tmp38_;
		GDateTime* _tmp39_;
		GDateTime* _tmp40_;
		gint64 _tmp41_;
		BackingPhotoTable* _tmp42_;
		BackingPhotoTable* _tmp43_;
		BackingPhotoID _tmp44_;
		GFileInfo* _tmp45_;
#line 3994 "../src/Photo.vala"
		_vala_assert (backing_photo_id_is_valid (&editable_id), "editable_id.is_valid ()");
#line 24373 "Photo.c"
		{
			GFileInfo* _tmp30_ = NULL;
			GFile* _tmp31_;
			GFileInfo* _tmp32_;
			GFileInfo* _tmp33_;
#line 3998 "../src/Photo.vala"
			_tmp31_ = file;
#line 3998 "../src/Photo.vala"
			_tmp32_ = g_file_query_filesystem_info (_tmp31_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error0_);
#line 3998 "../src/Photo.vala"
			_tmp30_ = _tmp32_;
#line 3998 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24387 "Photo.c"
				goto __catch1_g_error;
			}
#line 3998 "../src/Photo.vala"
			_tmp33_ = _tmp30_;
#line 3998 "../src/Photo.vala"
			_tmp30_ = NULL;
#line 3998 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 3998 "../src/Photo.vala"
			info = _tmp33_;
#line 3997 "../src/Photo.vala"
			_g_object_unref0 (_tmp30_);
#line 24400 "Photo.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 3997 "../src/Photo.vala"
			err = _inner_error0_;
#line 3997 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4000 "../src/Photo.vala"
			_tmp34_ = data_object_to_string ((DataObject*) self);
#line 4000 "../src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 4000 "../src/Photo.vala"
			_tmp36_ = err;
#line 4000 "../src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 4000 "../src/Photo.vala"
			g_warning ("Photo.vala:4000: Unable to read editable filesystem info for %s: %s", _tmp35_, _tmp37_);
#line 4000 "../src/Photo.vala"
			_g_free0 (_tmp35_);
#line 4001 "../src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4003 "../src/Photo.vala"
			_g_error_free0 (err);
#line 4003 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4003 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4003 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4003 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4003 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4003 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4003 "../src/Photo.vala"
			return;
#line 24444 "Photo.c"
		}
		__finally1:
#line 3997 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3997 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3997 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 3997 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3997 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3997 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 3997 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3997 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3997 "../src/Photo.vala"
			return;
#line 24465 "Photo.c"
		}
#line 4006 "../src/Photo.vala"
		_tmp38_ = info;
#line 4006 "../src/Photo.vala"
		_tmp39_ = g_file_info_get_modification_date_time (_tmp38_);
#line 4006 "../src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 4006 "../src/Photo.vala"
		_tmp41_ = g_date_time_to_unix (_tmp40_);
#line 4006 "../src/Photo.vala"
		_g_date_time_unref0 (_tmp40_);
#line 4006 "../src/Photo.vala"
		mod_time = _tmp41_;
#line 4008 "../src/Photo.vala"
		_tmp42_ = backing_photo_table_get_instance ();
#line 4008 "../src/Photo.vala"
		_tmp43_ = _tmp42_;
#line 4008 "../src/Photo.vala"
		_tmp44_ = editable_id;
#line 4008 "../src/Photo.vala"
		_tmp45_ = info;
#line 4008 "../src/Photo.vala"
		backing_photo_table_update_attributes (_tmp43_, &_tmp44_, mod_time, g_file_info_get_size (_tmp45_), &_inner_error0_);
#line 4008 "../src/Photo.vala"
		_database_table_unref0 (_tmp43_);
#line 4008 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4008 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 4008 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4008 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4008 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4008 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4008 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4008 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4008 "../src/Photo.vala"
			return;
#line 24509 "Photo.c"
		}
		{
			PhotoRow* _tmp46_;
#line 4010 "../src/Photo.vala"
			_tmp46_ = self->row;
#line 4010 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 24517 "Photo.c"
			{
				BackingPhotoRow* _tmp47_;
				BackingPhotoRow* _tmp48_;
				GFileInfo* _tmp49_;
				BackingPhotoRow* _tmp50_;
				BackingPhotoRow* _tmp51_;
				GFileInfo* _tmp52_;
#line 4011 "../src/Photo.vala"
				_tmp47_ = self->priv->editable;
#line 4011 "../src/Photo.vala"
				timestamp_changed = _tmp47_->timestamp != mod_time;
#line 4012 "../src/Photo.vala"
				_tmp48_ = self->priv->editable;
#line 4012 "../src/Photo.vala"
				_tmp49_ = info;
#line 4012 "../src/Photo.vala"
				filesize_changed = _tmp48_->filesize != g_file_info_get_size (_tmp49_);
#line 4014 "../src/Photo.vala"
				_tmp50_ = self->priv->editable;
#line 4014 "../src/Photo.vala"
				_tmp50_->timestamp = mod_time;
#line 4015 "../src/Photo.vala"
				_tmp51_ = self->priv->editable;
#line 4015 "../src/Photo.vala"
				_tmp52_ = info;
#line 4015 "../src/Photo.vala"
				_tmp51_->filesize = g_file_info_get_size (_tmp52_);
#line 24545 "Photo.c"
			}
			__finally2:
			{
				PhotoRow* _tmp53_;
#line 4010 "../src/Photo.vala"
				_tmp53_ = self->row;
#line 4010 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24554 "Photo.c"
			}
#line 4010 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4010 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4010 "../src/Photo.vala"
				_g_object_unref0 (info);
#line 4010 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4010 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4010 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4010 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4010 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4010 "../src/Photo.vala"
				return;
#line 24574 "Photo.c"
			}
		}
#line 3992 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 24579 "Photo.c"
	} else {
		gboolean _tmp54_ = FALSE;
#line 4019 "../src/Photo.vala"
		if (backing_photo_id_is_valid (&editable_id)) {
#line 4019 "../src/Photo.vala"
			_tmp54_ = !is_new_editable;
#line 24586 "Photo.c"
		} else {
#line 4019 "../src/Photo.vala"
			_tmp54_ = FALSE;
#line 24590 "Photo.c"
		}
#line 4019 "../src/Photo.vala"
		if (_tmp54_) {
#line 24594 "Photo.c"
			BackingPhotoRow* _tmp55_;
			BackingPhotoID _tmp56_;
			BackingPhotoTable* _tmp57_;
			BackingPhotoTable* _tmp58_;
			BackingPhotoRow* _tmp59_;
#line 4024 "../src/Photo.vala"
			_tmp55_ = backing;
#line 4024 "../src/Photo.vala"
			_tmp56_ = editable_id;
#line 4024 "../src/Photo.vala"
			_tmp55_->id = _tmp56_;
#line 4025 "../src/Photo.vala"
			_tmp57_ = backing_photo_table_get_instance ();
#line 4025 "../src/Photo.vala"
			_tmp58_ = _tmp57_;
#line 4025 "../src/Photo.vala"
			_tmp59_ = backing;
#line 4025 "../src/Photo.vala"
			backing_photo_table_update (_tmp58_, _tmp59_, &_inner_error0_);
#line 4025 "../src/Photo.vala"
			_database_table_unref0 (_tmp58_);
#line 4025 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4025 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4025 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4025 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4025 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4025 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4025 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4025 "../src/Photo.vala"
				return;
#line 24632 "Photo.c"
			}
			{
				PhotoRow* _tmp60_;
#line 4026 "../src/Photo.vala"
				_tmp60_ = self->row;
#line 4026 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 24640 "Photo.c"
				{
					BackingPhotoRow* _tmp61_;
					BackingPhotoRow* _tmp62_;
					BackingPhotoRow* _tmp63_;
					BackingPhotoRow* _tmp64_;
					BackingPhotoRow* _tmp65_;
					BackingPhotoRow* _tmp66_;
					BackingPhotoRow* _tmp67_;
					BackingPhotoRow* _tmp68_;
					BackingPhotoRow* _tmp69_;
#line 4027 "../src/Photo.vala"
					_tmp61_ = self->priv->editable;
#line 4027 "../src/Photo.vala"
					_tmp62_ = backing;
#line 4027 "../src/Photo.vala"
					timestamp_changed = _tmp61_->timestamp != _tmp62_->timestamp;
#line 4028 "../src/Photo.vala"
					_tmp63_ = self->priv->editable;
#line 4028 "../src/Photo.vala"
					_tmp64_ = backing;
#line 4028 "../src/Photo.vala"
					filesize_changed = _tmp63_->filesize != _tmp64_->filesize;
#line 4030 "../src/Photo.vala"
					_tmp65_ = backing;
#line 4030 "../src/Photo.vala"
					_tmp66_ = _backing_photo_row_ref0 (_tmp65_);
#line 4030 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 4030 "../src/Photo.vala"
					self->priv->editable = _tmp66_;
#line 4031 "../src/Photo.vala"
					_tmp67_ = self->priv->editable;
#line 4031 "../src/Photo.vala"
					_tmp68_ = _backing_photo_row_ref0 (_tmp67_);
#line 4031 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4031 "../src/Photo.vala"
					self->backing_photo_row = _tmp68_;
#line 4032 "../src/Photo.vala"
					_tmp69_ = self->backing_photo_row;
#line 4032 "../src/Photo.vala"
					photo_set_orientation (self, _tmp69_->original_orientation);
#line 24683 "Photo.c"
				}
				__finally3:
				{
					PhotoRow* _tmp70_;
#line 4026 "../src/Photo.vala"
					_tmp70_ = self->row;
#line 4026 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24692 "Photo.c"
				}
#line 4026 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4026 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 4026 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 4026 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 4026 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 4026 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 4026 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 4026 "../src/Photo.vala"
					return;
#line 24710 "Photo.c"
				}
			}
		}
	}
#line 4038 "../src/Photo.vala"
	if (new_reader != NULL) {
#line 24717 "Photo.c"
		{
			PhotoBackingReaders* _tmp71_;
#line 4039 "../src/Photo.vala"
			_tmp71_ = self->priv->readers;
#line 4039 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 24724 "Photo.c"
			{
				PhotoBackingReaders* _tmp72_;
				PhotoFileReader* _tmp73_;
#line 4040 "../src/Photo.vala"
				_tmp72_ = self->priv->readers;
#line 4040 "../src/Photo.vala"
				_tmp73_ = _photo_file_adapter_ref0 (new_reader);
#line 4040 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp72_->editable);
#line 4040 "../src/Photo.vala"
				_tmp72_->editable = _tmp73_;
#line 24736 "Photo.c"
			}
			__finally4:
			{
				PhotoBackingReaders* _tmp74_;
#line 4039 "../src/Photo.vala"
				_tmp74_ = self->priv->readers;
#line 4039 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 24745 "Photo.c"
			}
#line 4039 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4039 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4039 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4039 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4039 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4039 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4039 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4039 "../src/Photo.vala"
				return;
#line 24763 "Photo.c"
			}
		}
	}
#line 4044 "../src/Photo.vala"
	if (!only_attributes) {
#line 24769 "Photo.c"
		PhotoFileReader* _tmp76_;
		PhotoFileReader* _tmp77_;
#line 4044 "../src/Photo.vala"
		_tmp76_ = reader;
#line 4044 "../src/Photo.vala"
		_tmp77_ = old_reader;
#line 4044 "../src/Photo.vala"
		_tmp75_ = _tmp76_ != _tmp77_;
#line 24778 "Photo.c"
	} else {
#line 4044 "../src/Photo.vala"
		_tmp75_ = FALSE;
#line 24782 "Photo.c"
	}
#line 4044 "../src/Photo.vala"
	if (_tmp75_) {
#line 24786 "Photo.c"
		GFile* _tmp78_ = NULL;
		PhotoFileReader* _tmp79_;
		GFile* _tmp82_ = NULL;
#line 4045 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4046 "../src/Photo.vala"
		_tmp79_ = old_reader;
#line 4046 "../src/Photo.vala"
		if (_tmp79_ != NULL) {
#line 24796 "Photo.c"
			PhotoFileReader* _tmp80_;
			GFile* _tmp81_;
#line 4046 "../src/Photo.vala"
			_tmp80_ = old_reader;
#line 4046 "../src/Photo.vala"
			_tmp81_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp80_);
#line 4046 "../src/Photo.vala"
			_g_object_unref0 (_tmp78_);
#line 4046 "../src/Photo.vala"
			_tmp78_ = _tmp81_;
#line 24807 "Photo.c"
		} else {
#line 4046 "../src/Photo.vala"
			_g_object_unref0 (_tmp78_);
#line 4046 "../src/Photo.vala"
			_tmp78_ = NULL;
#line 24813 "Photo.c"
		}
#line 4047 "../src/Photo.vala"
		if (new_reader != NULL) {
#line 24817 "Photo.c"
			GFile* _tmp83_;
#line 4047 "../src/Photo.vala"
			_tmp83_ = photo_file_adapter_get_file ((PhotoFileAdapter*) new_reader);
#line 4047 "../src/Photo.vala"
			_g_object_unref0 (_tmp82_);
#line 4047 "../src/Photo.vala"
			_tmp82_ = _tmp83_;
#line 24825 "Photo.c"
		} else {
#line 4047 "../src/Photo.vala"
			_g_object_unref0 (_tmp82_);
#line 4047 "../src/Photo.vala"
			_tmp82_ = NULL;
#line 24831 "Photo.c"
		}
#line 4046 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp78_, _tmp82_);
#line 4044 "../src/Photo.vala"
		_g_object_unref0 (_tmp82_);
#line 4044 "../src/Photo.vala"
		_g_object_unref0 (_tmp78_);
#line 24839 "Photo.c"
	}
#line 4050 "../src/Photo.vala"
	_tmp84_ = g_new0 (gchar*, 0 + 1);
#line 4050 "../src/Photo.vala"
	alteration_list = _tmp84_;
#line 4050 "../src/Photo.vala"
	alteration_list_length1 = 0;
#line 4050 "../src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 4051 "../src/Photo.vala"
	if (timestamp_changed) {
#line 24851 "Photo.c"
		gchar* _tmp85_;
		gchar* _tmp86_;
#line 4052 "../src/Photo.vala"
		_tmp85_ = g_strdup ("metadata:editable-timestamp");
#line 4052 "../src/Photo.vala"
		_vala_array_add24 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp85_);
#line 4053 "../src/Photo.vala"
		_tmp86_ = g_strdup ("metadata:baseline-timestamp");
#line 4053 "../src/Photo.vala"
		_vala_array_add25 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp86_);
#line 4055 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 24864 "Photo.c"
			gchar* _tmp87_;
#line 4056 "../src/Photo.vala"
			_tmp87_ = g_strdup ("metadata:source-timestamp");
#line 4056 "../src/Photo.vala"
			_vala_array_add26 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp87_);
#line 24870 "Photo.c"
		}
	}
#line 4060 "../src/Photo.vala"
	if (filesize_changed) {
#line 4060 "../src/Photo.vala"
		_tmp88_ = TRUE;
#line 24877 "Photo.c"
	} else {
#line 4060 "../src/Photo.vala"
		_tmp88_ = new_reader != NULL;
#line 24881 "Photo.c"
	}
#line 4060 "../src/Photo.vala"
	if (_tmp88_) {
#line 24885 "Photo.c"
		gchar* _tmp89_;
		gchar* _tmp90_;
#line 4061 "../src/Photo.vala"
		_tmp89_ = g_strdup ("image:editable");
#line 4061 "../src/Photo.vala"
		_vala_array_add27 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp89_);
#line 4062 "../src/Photo.vala"
		_tmp90_ = g_strdup ("image:baseline");
#line 4062 "../src/Photo.vala"
		_vala_array_add28 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp90_);
#line 4064 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 24898 "Photo.c"
			gchar* _tmp91_;
#line 4065 "../src/Photo.vala"
			_tmp91_ = g_strdup ("image:source");
#line 4065 "../src/Photo.vala"
			_vala_array_add29 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp91_);
#line 24904 "Photo.c"
		}
	}
#line 4069 "../src/Photo.vala"
	_tmp92_ = alteration_list;
#line 4069 "../src/Photo.vala"
	_tmp92__length1 = alteration_list_length1;
#line 4069 "../src/Photo.vala"
	if (_tmp92__length1 > 0) {
#line 24913 "Photo.c"
		gchar** _tmp93_;
		gint _tmp93__length1;
		Alteration* _tmp94_;
		Alteration* _tmp95_;
#line 4070 "../src/Photo.vala"
		_tmp93_ = alteration_list;
#line 4070 "../src/Photo.vala"
		_tmp93__length1 = alteration_list_length1;
#line 4070 "../src/Photo.vala"
		_tmp94_ = alteration_new_from_array (_tmp93_, _tmp93__length1);
#line 4070 "../src/Photo.vala"
		_tmp95_ = _tmp94_;
#line 4070 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp95_);
#line 4070 "../src/Photo.vala"
		_alteration_unref0 (_tmp95_);
#line 24930 "Photo.c"
	}
#line 3950 "../src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3950 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3950 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3950 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 3950 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3950 "../src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 24944 "Photo.c"
}

static void
photo_detach_editable (Photo* self,
                       gboolean delete_editable,
                       gboolean remove_transformations,
                       gboolean notify)
{
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 4074 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4075 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 4077 "../src/Photo.vala"
	has_editable = FALSE;
#line 4078 "../src/Photo.vala"
	editable_file = NULL;
#line 24967 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4079 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4079 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 24974 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 4080 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4080 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4080 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 24984 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
				PhotoBackingReaders* _tmp6_;
#line 4081 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 4081 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 4081 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 4081 "../src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 4081 "../src/Photo.vala"
				editable_file = _tmp5_;
#line 4082 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 4082 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 4082 "../src/Photo.vala"
				_tmp6_->editable = NULL;
#line 4083 "../src/Photo.vala"
				has_editable = TRUE;
#line 25007 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp7_;
#line 4079 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 4079 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 25017 "Photo.c"
		}
#line 4079 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4079 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4079 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4079 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4079 "../src/Photo.vala"
			return;
#line 25029 "Photo.c"
		}
	}
#line 4087 "../src/Photo.vala"
	if (has_editable) {
#line 25034 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 4088 "../src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 25038 "Photo.c"
		{
			{
				PhotoRow* _tmp8_;
#line 4090 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 4090 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 25046 "Photo.c"
				{
					PhotoRow* _tmp9_;
					BackingPhotoID _tmp10_;
					PhotoRow* _tmp14_;
					BackingPhotoRow* _tmp15_;
					BackingPhotoRow* _tmp16_;
#line 4091 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 4091 "../src/Photo.vala"
					_tmp10_ = _tmp9_->editable_id;
#line 4091 "../src/Photo.vala"
					editable_id = _tmp10_;
#line 4092 "../src/Photo.vala"
					if (backing_photo_id_is_valid (&editable_id)) {
#line 25061 "Photo.c"
						PhotoTable* _tmp11_;
						PhotoTable* _tmp12_;
						PhotoRow* _tmp13_;
#line 4093 "../src/Photo.vala"
						_tmp11_ = photo_table_get_instance ();
#line 4093 "../src/Photo.vala"
						_tmp12_ = _tmp11_;
#line 4093 "../src/Photo.vala"
						_tmp13_ = self->row;
#line 4093 "../src/Photo.vala"
						photo_table_detach_editable (_tmp12_, _tmp13_, &_inner_error0_);
#line 4093 "../src/Photo.vala"
						_database_table_unref0 (_tmp12_);
#line 4093 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25077 "Photo.c"
							goto __catch2_g_error;
						}
					}
#line 4095 "../src/Photo.vala"
					_tmp14_ = self->row;
#line 4095 "../src/Photo.vala"
					_tmp15_ = _tmp14_->master;
#line 4095 "../src/Photo.vala"
					_tmp16_ = _backing_photo_row_ref0 (_tmp15_);
#line 4095 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4095 "../src/Photo.vala"
					self->backing_photo_row = _tmp16_;
#line 25091 "Photo.c"
				}
				goto __finally2;
				__catch2_g_error:
				{
					GError* _lock_error_ = NULL;
					GError* _tmp17_;
#line 4090 "../src/Photo.vala"
					_lock_error_ = _inner_error0_;
#line 4090 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 4090 "../src/Photo.vala"
					_tmp17_ = _lock_error_;
#line 4090 "../src/Photo.vala"
					_lock_error_ = NULL;
#line 4090 "../src/Photo.vala"
					_inner_error0_ = _tmp17_;
#line 4090 "../src/Photo.vala"
					_g_error_free0 (_lock_error_);
#line 25110 "Photo.c"
					goto __finally2;
				}
				__finally2:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp18_;
#line 4090 "../src/Photo.vala"
					_tmp18_ = self->row;
#line 4090 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 25121 "Photo.c"
				}
#line 4090 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4090 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 25127 "Photo.c"
						goto __catch1_database_error;
					}
					goto __finally1;
				}
			}
		}
		goto __finally1;
		__catch1_database_error:
		{
			GError* err = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 4089 "../src/Photo.vala"
			err = _inner_error0_;
#line 4089 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4098 "../src/Photo.vala"
			_tmp19_ = err;
#line 4098 "../src/Photo.vala"
			_tmp20_ = _tmp19_->message;
#line 4098 "../src/Photo.vala"
			g_warning ("Photo.vala:4098: Unable to remove editable from PhotoTable: %s", _tmp20_);
#line 4089 "../src/Photo.vala"
			_g_error_free0 (err);
#line 25152 "Photo.c"
		}
		__finally1:
#line 4089 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4089 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4089 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4089 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4089 "../src/Photo.vala"
			return;
#line 25165 "Photo.c"
		}
		{
#line 4102 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&editable_id)) {
#line 25170 "Photo.c"
				BackingPhotoTable* _tmp21_;
				BackingPhotoTable* _tmp22_;
				BackingPhotoID _tmp23_;
#line 4103 "../src/Photo.vala"
				_tmp21_ = backing_photo_table_get_instance ();
#line 4103 "../src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 4103 "../src/Photo.vala"
				_tmp23_ = editable_id;
#line 4103 "../src/Photo.vala"
				backing_photo_table_remove (_tmp22_, &_tmp23_, &_inner_error0_);
#line 4103 "../src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 4103 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4103 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 25188 "Photo.c"
						goto __catch3_database_error;
					}
#line 4103 "../src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4103 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4103 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4103 "../src/Photo.vala"
					return;
#line 25199 "Photo.c"
				}
			}
		}
		goto __finally3;
		__catch3_database_error:
		{
			GError* err = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 4101 "../src/Photo.vala"
			err = _inner_error0_;
#line 4101 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4106 "../src/Photo.vala"
			_tmp24_ = err;
#line 4106 "../src/Photo.vala"
			_tmp25_ = _tmp24_->message;
#line 4106 "../src/Photo.vala"
			g_warning ("Photo.vala:4106: Unable to remove editable from BackingPhotoTable: %s", _tmp25_);
#line 4101 "../src/Photo.vala"
			_g_error_free0 (err);
#line 25221 "Photo.c"
		}
		__finally3:
#line 4101 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4101 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4101 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4101 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4101 "../src/Photo.vala"
			return;
#line 25234 "Photo.c"
		}
	}
#line 4110 "../src/Photo.vala"
	if (remove_transformations) {
#line 4111 "../src/Photo.vala"
		photo_internal_remove_all_transformations (self, FALSE);
#line 25241 "Photo.c"
	}
#line 4114 "../src/Photo.vala"
	if (has_editable) {
#line 25245 "Photo.c"
		GFile* _tmp26_;
#line 4115 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4116 "../src/Photo.vala"
		_tmp26_ = editable_file;
#line 4116 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp26_, NULL);
#line 25253 "Photo.c"
	}
#line 4119 "../src/Photo.vala"
	if (delete_editable) {
#line 25257 "Photo.c"
		GFile* _tmp28_;
#line 4119 "../src/Photo.vala"
		_tmp28_ = editable_file;
#line 4119 "../src/Photo.vala"
		_tmp27_ = _tmp28_ != NULL;
#line 25263 "Photo.c"
	} else {
#line 4119 "../src/Photo.vala"
		_tmp27_ = FALSE;
#line 25267 "Photo.c"
	}
#line 4119 "../src/Photo.vala"
	if (_tmp27_) {
#line 25271 "Photo.c"
		{
			GFile* _tmp29_;
#line 4121 "../src/Photo.vala"
			_tmp29_ = editable_file;
#line 4121 "../src/Photo.vala"
			g_file_trash (_tmp29_, NULL, &_inner_error0_);
#line 4121 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25280 "Photo.c"
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* err = NULL;
			GFile* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			GError* _tmp35_;
			const gchar* _tmp36_;
#line 4120 "../src/Photo.vala"
			err = _inner_error0_;
#line 4120 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4123 "../src/Photo.vala"
			_tmp30_ = editable_file;
#line 4123 "../src/Photo.vala"
			_tmp31_ = g_file_get_path (_tmp30_);
#line 4123 "../src/Photo.vala"
			_tmp32_ = _tmp31_;
#line 4123 "../src/Photo.vala"
			_tmp33_ = data_object_to_string ((DataObject*) self);
#line 4123 "../src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 4123 "../src/Photo.vala"
			_tmp35_ = err;
#line 4123 "../src/Photo.vala"
			_tmp36_ = _tmp35_->message;
#line 4123 "../src/Photo.vala"
			g_warning ("Photo.vala:4123: Unable to trash editable %s for %s: %s", _tmp32_, _tmp34_, _tmp36_);
#line 4123 "../src/Photo.vala"
			_g_free0 (_tmp34_);
#line 4123 "../src/Photo.vala"
			_g_free0 (_tmp32_);
#line 4120 "../src/Photo.vala"
			_g_error_free0 (err);
#line 25321 "Photo.c"
		}
		__finally4:
#line 4120 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4120 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4120 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4120 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4120 "../src/Photo.vala"
			return;
#line 25334 "Photo.c"
		}
	}
#line 4128 "../src/Photo.vala"
	if (has_editable) {
#line 4128 "../src/Photo.vala"
		_tmp38_ = TRUE;
#line 25341 "Photo.c"
	} else {
#line 4128 "../src/Photo.vala"
		_tmp38_ = remove_transformations;
#line 25345 "Photo.c"
	}
#line 4128 "../src/Photo.vala"
	if (_tmp38_) {
#line 4128 "../src/Photo.vala"
		_tmp37_ = notify;
#line 25351 "Photo.c"
	} else {
#line 4128 "../src/Photo.vala"
		_tmp37_ = FALSE;
#line 25355 "Photo.c"
	}
#line 4128 "../src/Photo.vala"
	if (_tmp37_) {
#line 25359 "Photo.c"
		Alteration* _tmp39_;
		Alteration* _tmp40_;
#line 4129 "../src/Photo.vala"
		_tmp39_ = alteration_new ("image", "revert");
#line 4129 "../src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 4129 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp40_);
#line 4129 "../src/Photo.vala"
		_alteration_unref0 (_tmp40_);
#line 25370 "Photo.c"
	}
#line 4074 "../src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 25374 "Photo.c"
}

static void
_photo_on_reimport_editable_one_shot_callback (gpointer self)
{
#line 4145 "../src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 25382 "Photo.c"
}

static void
_photo_on_update_editable_attributes_one_shot_callback (gpointer self)
{
#line 4154 "../src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 25390 "Photo.c"
}

static void
_photo_on_remove_editable_one_shot_callback (gpointer self)
{
#line 4163 "../src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 25398 "Photo.c"
}

static void
photo_on_editable_file_changed (Photo* self,
                                GFile* file,
                                GFile* other_file,
                                GFileMonitorEvent event)
{
	GEnumValue* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 4133 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4133 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 25415 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4135 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4135 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 25422 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 4136 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 4136 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 4136 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 25433 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
#line 4136 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 4136 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 4136 "../src/Photo.vala"
				_tmp6_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp5_);
#line 4136 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 4136 "../src/Photo.vala"
				_tmp1_ = g_file_equal (file, _tmp7_);
#line 4136 "../src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 25450 "Photo.c"
			} else {
#line 4136 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 25454 "Photo.c"
			}
#line 4136 "../src/Photo.vala"
			_vala_assert (_tmp1_, "readers.editable != null && file.equal (readers.editable.get_file ())");
#line 25458 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp8_;
#line 4135 "../src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 4135 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 25467 "Photo.c"
		}
#line 4135 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4135 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4135 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4135 "../src/Photo.vala"
			return;
#line 25477 "Photo.c"
		}
	}
#line 4139 "../src/Photo.vala"
	_tmp9_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 4139 "../src/Photo.vala"
	_tmp10_ = g_file_get_path (file);
#line 4139 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 4139 "../src/Photo.vala"
	g_debug ("Photo.vala:4139: EDITABLE %s: %s", (_tmp9_ != NULL) ? _tmp9_->value_name : NULL, _tmp11_);
#line 4139 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 4141 "../src/Photo.vala"
	switch (event) {
#line 4141 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 4141 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 25496 "Photo.c"
		{
			OneShotScheduler* _tmp12_;
			OneShotScheduler* _tmp14_;
#line 4144 "../src/Photo.vala"
			_tmp12_ = self->priv->reimport_editable_scheduler;
#line 4144 "../src/Photo.vala"
			if (_tmp12_ == NULL) {
#line 25504 "Photo.c"
				OneShotScheduler* _tmp13_;
#line 4145 "../src/Photo.vala"
				_tmp13_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 4145 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 4145 "../src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp13_;
#line 25512 "Photo.c"
			}
#line 4149 "../src/Photo.vala"
			_tmp14_ = self->priv->reimport_editable_scheduler;
#line 4149 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp14_, (guint) 1000, TRUE);
#line 4150 "../src/Photo.vala"
			break;
#line 25520 "Photo.c"
		}
#line 4141 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 25524 "Photo.c"
		{
			OneShotScheduler* _tmp15_;
			OneShotScheduler* _tmp17_;
#line 4153 "../src/Photo.vala"
			_tmp15_ = self->priv->update_editable_attributes_scheduler;
#line 4153 "../src/Photo.vala"
			if (_tmp15_ == NULL) {
#line 25532 "Photo.c"
				OneShotScheduler* _tmp16_;
#line 4154 "../src/Photo.vala"
				_tmp16_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 4154 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 4154 "../src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp16_;
#line 25540 "Photo.c"
			}
#line 4158 "../src/Photo.vala"
			_tmp17_ = self->priv->update_editable_attributes_scheduler;
#line 4158 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp17_, (guint) 1000, TRUE);
#line 4159 "../src/Photo.vala"
			break;
#line 25548 "Photo.c"
		}
#line 4141 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 25552 "Photo.c"
		{
			OneShotScheduler* _tmp18_;
			OneShotScheduler* _tmp20_;
#line 4162 "../src/Photo.vala"
			_tmp18_ = self->priv->remove_editable_scheduler;
#line 4162 "../src/Photo.vala"
			if (_tmp18_ == NULL) {
#line 25560 "Photo.c"
				OneShotScheduler* _tmp19_;
#line 4163 "../src/Photo.vala"
				_tmp19_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4163 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4163 "../src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp19_;
#line 25568 "Photo.c"
			}
#line 4167 "../src/Photo.vala"
			_tmp20_ = self->priv->remove_editable_scheduler;
#line 4167 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp20_, (guint) 3000, TRUE);
#line 4168 "../src/Photo.vala"
			break;
#line 25576 "Photo.c"
		}
		default:
#line 4141 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 25581 "Photo.c"
		{
#line 4173 "../src/Photo.vala"
			break;
#line 25585 "Photo.c"
		}
	}
#line 4178 "../src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 25590 "Photo.c"
}

static void
photo_on_reimport_editable (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4181 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4183 "../src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 4185 "../src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4185 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4185 "../src/Photo.vala"
	g_debug ("Photo.vala:4185: Reimporting editable for %s", _tmp1_);
#line 4185 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 25611 "Photo.c"
	{
#line 4187 "../src/Photo.vala"
		photo_reimport_editable (self, &_inner_error0_);
#line 4187 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25617 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4186 "../src/Photo.vala"
		err = _inner_error0_;
#line 4186 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4189 "../src/Photo.vala"
		_tmp2_ = data_object_to_string ((DataObject*) self);
#line 4189 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4189 "../src/Photo.vala"
		_tmp4_ = err;
#line 4189 "../src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4189 "../src/Photo.vala"
		g_warning ("Photo.vala:4189: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4189 "../src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4186 "../src/Photo.vala"
		_g_error_free0 (err);
#line 25647 "Photo.c"
	}
	__finally0:
#line 4186 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4186 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4186 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4186 "../src/Photo.vala"
		return;
#line 25658 "Photo.c"
	}
}

static void
photo_on_update_editable_attributes (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4194 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4195 "../src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4195 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4195 "../src/Photo.vala"
	g_debug ("Photo.vala:4195: Updating editable attributes for %s", _tmp1_);
#line 4195 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 25678 "Photo.c"
	{
#line 4197 "../src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error0_);
#line 4197 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25684 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4196 "../src/Photo.vala"
		err = _inner_error0_;
#line 4196 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4199 "../src/Photo.vala"
		_tmp2_ = err;
#line 4199 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4199 "../src/Photo.vala"
		g_warning ("Photo.vala:4199: Unable to update editable attributes: %s", _tmp3_);
#line 4196 "../src/Photo.vala"
		_g_error_free0 (err);
#line 25706 "Photo.c"
	}
	__finally0:
#line 4196 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4196 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4196 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4196 "../src/Photo.vala"
		return;
#line 25717 "Photo.c"
	}
}

static void
photo_on_remove_editable (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 4203 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4204 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4204 "../src/Photo.vala"
	reader = _tmp0_;
#line 4205 "../src/Photo.vala"
	_tmp1_ = reader;
#line 4205 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4206 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4206 "../src/Photo.vala"
		return;
#line 25747 "Photo.c"
	}
#line 4209 "../src/Photo.vala"
	_tmp2_ = reader;
#line 4209 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp2_);
#line 4209 "../src/Photo.vala"
	file = _tmp3_;
#line 4210 "../src/Photo.vala"
	_tmp4_ = file;
#line 4210 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 25759 "Photo.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 4211 "../src/Photo.vala"
		_tmp5_ = data_object_to_string ((DataObject*) self);
#line 4211 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4211 "../src/Photo.vala"
		g_debug ("Photo.vala:4211: Not removing editable for %s: file exists", _tmp6_);
#line 4211 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 4213 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 4213 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4213 "../src/Photo.vala"
		return;
#line 25776 "Photo.c"
	}
#line 4216 "../src/Photo.vala"
	_tmp7_ = data_object_to_string ((DataObject*) self);
#line 4216 "../src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4216 "../src/Photo.vala"
	g_debug ("Photo.vala:4216: Removing editable for %s: file no longer exists", _tmp8_);
#line 4216 "../src/Photo.vala"
	_g_free0 (_tmp8_);
#line 4217 "../src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4203 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 4203 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 25792 "Photo.c"
}

void
photo_get_original_dimensions (Photo* self,
                               Dimensions* result)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 4225 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4226 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4226 "../src/Photo.vala"
	dim = _tmp0_;
#line 4227 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4229 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4229 "../src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp1_, &_tmp2_);
#line 4229 "../src/Photo.vala"
	*result = _tmp2_;
#line 4229 "../src/Photo.vala"
	return;
#line 25820 "Photo.c"
}

void
photo_get_master_dimensions (Photo* self,
                             Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 4233 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4234 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4234 "../src/Photo.vala"
	orientation_rotate_dimensions (photo_get_original_orientation (self), &_tmp0_, &_tmp1_);
#line 4234 "../src/Photo.vala"
	*result = _tmp1_;
#line 4234 "../src/Photo.vala"
	return;
#line 25839 "Photo.c"
}

gboolean
photo_get_crop (Photo* self,
                Box* crop,
                PhotoException exceptions)
{
	Box _vala_crop = {0};
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
	gboolean result;
#line 4238 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4240 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4240 "../src/Photo.vala"
	raw = _tmp0_;
#line 4240 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4241 "../src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4243 "../src/Photo.vala"
		result = FALSE;
#line 4243 "../src/Photo.vala"
		if (crop) {
#line 4243 "../src/Photo.vala"
			*crop = _vala_crop;
#line 25871 "Photo.c"
		}
#line 4243 "../src/Photo.vala"
		return result;
#line 25875 "Photo.c"
	}
#line 4246 "../src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4246 "../src/Photo.vala"
	dim = _tmp2_;
#line 4247 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4249 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 25885 "Photo.c"
		Dimensions _tmp3_;
		Box _tmp4_;
		Box _tmp5_ = {0};
#line 4250 "../src/Photo.vala"
		_tmp3_ = dim;
#line 4250 "../src/Photo.vala"
		_tmp4_ = raw;
#line 4250 "../src/Photo.vala"
		orientation_rotate_box (orientation, &_tmp3_, &_tmp4_, &_tmp5_);
#line 4250 "../src/Photo.vala"
		_vala_crop = _tmp5_;
#line 25897 "Photo.c"
	} else {
		Box _tmp6_;
#line 4252 "../src/Photo.vala"
		_tmp6_ = raw;
#line 4252 "../src/Photo.vala"
		_vala_crop = _tmp6_;
#line 25904 "Photo.c"
	}
#line 4255 "../src/Photo.vala"
	result = TRUE;
#line 4255 "../src/Photo.vala"
	if (crop) {
#line 4255 "../src/Photo.vala"
		*crop = _vala_crop;
#line 25912 "Photo.c"
	}
#line 4255 "../src/Photo.vala"
	return result;
#line 25916 "Photo.c"
}

void
photo_set_crop (Photo* self,
                Box* crop)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Box derotated = {0};
	Dimensions _tmp1_;
	Box _tmp2_;
	Box _tmp3_ = {0};
	Box _tmp4_;
	Dimensions _tmp5_;
	Box _tmp6_;
	Box _tmp7_;
	Dimensions _tmp8_;
	Box _tmp9_;
	Dimensions _tmp10_;
	Box _tmp11_;
	Box _tmp12_;
	Dimensions _tmp13_;
	Box _tmp14_;
#line 4259 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4259 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4260 "../src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4260 "../src/Photo.vala"
	dim = _tmp0_;
#line 4261 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4263 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4263 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 4263 "../src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp1_, &_tmp2_, &_tmp3_);
#line 4263 "../src/Photo.vala"
	derotated = _tmp3_;
#line 4265 "../src/Photo.vala"
	_tmp4_ = derotated;
#line 4265 "../src/Photo.vala"
	_tmp5_ = dim;
#line 4265 "../src/Photo.vala"
	derotated.left = CLAMP (_tmp4_.left, 0, _tmp5_.width - 2);
#line 4266 "../src/Photo.vala"
	_tmp6_ = derotated;
#line 4266 "../src/Photo.vala"
	_tmp7_ = derotated;
#line 4266 "../src/Photo.vala"
	_tmp8_ = dim;
#line 4266 "../src/Photo.vala"
	derotated.right = CLAMP (_tmp6_.right, _tmp7_.left, _tmp8_.width - 1);
#line 4268 "../src/Photo.vala"
	_tmp9_ = derotated;
#line 4268 "../src/Photo.vala"
	_tmp10_ = dim;
#line 4268 "../src/Photo.vala"
	derotated.top = CLAMP (_tmp9_.top, 0, _tmp10_.height - 2);
#line 4269 "../src/Photo.vala"
	_tmp11_ = derotated;
#line 4269 "../src/Photo.vala"
	_tmp12_ = derotated;
#line 4269 "../src/Photo.vala"
	_tmp13_ = dim;
#line 4269 "../src/Photo.vala"
	derotated.bottom = CLAMP (_tmp11_.bottom, _tmp12_.top, _tmp13_.height - 1);
#line 4271 "../src/Photo.vala"
	_tmp14_ = derotated;
#line 4271 "../src/Photo.vala"
	photo_set_raw_crop (self, &_tmp14_);
#line 25991 "Photo.c"
}

gboolean
photo_get_straighten (Photo* self,
                      gdouble* theta)
{
	gdouble _vala_theta = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result;
#line 4274 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4275 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4275 "../src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4275 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4276 "../src/Photo.vala"
		result = FALSE;
#line 4276 "../src/Photo.vala"
		if (theta) {
#line 4276 "../src/Photo.vala"
			*theta = _vala_theta;
#line 26016 "Photo.c"
		}
#line 4276 "../src/Photo.vala"
		return result;
#line 26020 "Photo.c"
	}
#line 4279 "../src/Photo.vala"
	result = TRUE;
#line 4279 "../src/Photo.vala"
	if (theta) {
#line 4279 "../src/Photo.vala"
		*theta = _vala_theta;
#line 26028 "Photo.c"
	}
#line 4279 "../src/Photo.vala"
	return result;
#line 26032 "Photo.c"
}

void
photo_set_straighten (Photo* self,
                      gdouble theta)
{
#line 4282 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4283 "../src/Photo.vala"
	photo_set_raw_straighten (self, theta);
#line 26043 "Photo.c"
}

static GdkPixbuf*
photo_do_redeye (Photo* self,
                 GdkPixbuf* pixbuf,
                 EditingToolsRedeyeInstance* inst)
{
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp1_;
	gint* _tmp2_;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp7_;
	GdkPoint _tmp8_;
	EditingToolsRedeyeInstance _tmp9_;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp10_;
	GdkPoint _tmp11_;
	EditingToolsRedeyeInstance _tmp12_;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp13_;
	GdkPoint _tmp14_;
	EditingToolsRedeyeInstance _tmp15_;
	gint _tmp16_ = 0;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp17_;
	GdkPoint _tmp18_;
	gint _tmp19_ = 0;
	gint _tmp20_;
	gint _tmp21_;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp41_;
	GdkPoint _tmp42_;
	EditingToolsRedeyeInstance _tmp43_;
	GdkPoint _tmp44_;
	EditingToolsRedeyeInstance _tmp45_;
	gint* _tmp46_;
	gint _tmp46__length1;
	GdkPixbuf* _tmp64_;
	GdkPixbuf* result;
#line 4286 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4286 "../src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4286 "../src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4296 "../src/Photo.vala"
	_tmp0_ = *inst;
#line 4296 "../src/Photo.vala"
	r = (gdouble) _tmp0_.radius;
#line 4297 "../src/Photo.vala"
	_tmp1_ = *inst;
#line 4297 "../src/Photo.vala"
	_tmp2_ = g_new0 (gint, _tmp1_.radius + 1);
#line 4297 "../src/Photo.vala"
	x_insets_first_quadrant = _tmp2_;
#line 4297 "../src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp1_.radius + 1;
#line 4297 "../src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4299 "../src/Photo.vala"
	i = 0;
#line 26110 "Photo.c"
	{
		gdouble y = 0.0;
#line 4300 "../src/Photo.vala"
		y = r;
#line 26115 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
#line 4300 "../src/Photo.vala"
			_tmp3_ = TRUE;
#line 4300 "../src/Photo.vala"
			while (TRUE) {
#line 26122 "Photo.c"
				gdouble theta = 0.0;
				gint x = 0;
				gint* _tmp4_;
				gint _tmp4__length1;
				EditingToolsRedeyeInstance _tmp5_;
				gint _tmp6_;
#line 4300 "../src/Photo.vala"
				if (!_tmp3_) {
#line 4300 "../src/Photo.vala"
					y -= 1.0;
#line 26133 "Photo.c"
				}
#line 4300 "../src/Photo.vala"
				_tmp3_ = FALSE;
#line 4300 "../src/Photo.vala"
				if (!(y >= 0.0)) {
#line 4300 "../src/Photo.vala"
					break;
#line 26141 "Photo.c"
				}
#line 4301 "../src/Photo.vala"
				theta = asin (y / r);
#line 4302 "../src/Photo.vala"
				x = (gint) ((r * cos (theta)) + 0.5);
#line 4303 "../src/Photo.vala"
				_tmp4_ = x_insets_first_quadrant;
#line 4303 "../src/Photo.vala"
				_tmp4__length1 = x_insets_first_quadrant_length1;
#line 4303 "../src/Photo.vala"
				_tmp5_ = *inst;
#line 4303 "../src/Photo.vala"
				_tmp4_[i] = _tmp5_.radius - x;
#line 4305 "../src/Photo.vala"
				_tmp6_ = i;
#line 4305 "../src/Photo.vala"
				i = _tmp6_ + 1;
#line 26159 "Photo.c"
			}
		}
	}
#line 4308 "../src/Photo.vala"
	_tmp7_ = *inst;
#line 4308 "../src/Photo.vala"
	_tmp8_ = _tmp7_.center;
#line 4308 "../src/Photo.vala"
	_tmp9_ = *inst;
#line 4308 "../src/Photo.vala"
	x_bounds_min = _tmp8_.x - _tmp9_.radius;
#line 4309 "../src/Photo.vala"
	_tmp10_ = *inst;
#line 4309 "../src/Photo.vala"
	_tmp11_ = _tmp10_.center;
#line 4309 "../src/Photo.vala"
	_tmp12_ = *inst;
#line 4309 "../src/Photo.vala"
	x_bounds_max = _tmp11_.x + _tmp12_.radius;
#line 4310 "../src/Photo.vala"
	_tmp13_ = *inst;
#line 4310 "../src/Photo.vala"
	_tmp14_ = _tmp13_.center;
#line 4310 "../src/Photo.vala"
	_tmp15_ = *inst;
#line 4310 "../src/Photo.vala"
	ymin = _tmp14_.y - _tmp15_.radius;
#line 4311 "../src/Photo.vala"
	if (ymin < 0) {
#line 4311 "../src/Photo.vala"
		_tmp16_ = 0;
#line 26191 "Photo.c"
	} else {
#line 4311 "../src/Photo.vala"
		_tmp16_ = ymin;
#line 26195 "Photo.c"
	}
#line 4311 "../src/Photo.vala"
	ymin = _tmp16_;
#line 4312 "../src/Photo.vala"
	_tmp17_ = *inst;
#line 4312 "../src/Photo.vala"
	_tmp18_ = _tmp17_.center;
#line 4312 "../src/Photo.vala"
	ymax = _tmp18_.y;
#line 4313 "../src/Photo.vala"
	_tmp20_ = gdk_pixbuf_get_height (pixbuf);
#line 4313 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 4313 "../src/Photo.vala"
	if (ymax > (_tmp21_ - 1)) {
#line 26211 "Photo.c"
		gint _tmp22_;
		gint _tmp23_;
#line 4313 "../src/Photo.vala"
		_tmp22_ = gdk_pixbuf_get_height (pixbuf);
#line 4313 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 4313 "../src/Photo.vala"
		_tmp19_ = _tmp23_ - 1;
#line 26220 "Photo.c"
	} else {
#line 4313 "../src/Photo.vala"
		_tmp19_ = ymax;
#line 26224 "Photo.c"
	}
#line 4313 "../src/Photo.vala"
	ymax = _tmp19_;
#line 4317 "../src/Photo.vala"
	inset_index = 0;
#line 26230 "Photo.c"
	{
		gint y_it = 0;
#line 4318 "../src/Photo.vala"
		y_it = ymin;
#line 26235 "Photo.c"
		{
			gboolean _tmp24_ = FALSE;
#line 4318 "../src/Photo.vala"
			_tmp24_ = TRUE;
#line 4318 "../src/Photo.vala"
			while (TRUE) {
#line 26242 "Photo.c"
				gint xmin = 0;
				gint* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_;
				gint _tmp28_ = 0;
				gint xmax = 0;
				gint* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_;
				gint _tmp31_ = 0;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp40_;
#line 4318 "../src/Photo.vala"
				if (!_tmp24_) {
#line 26258 "Photo.c"
					gint _tmp25_;
#line 4318 "../src/Photo.vala"
					_tmp25_ = y_it;
#line 4318 "../src/Photo.vala"
					y_it = _tmp25_ + 1;
#line 26264 "Photo.c"
				}
#line 4318 "../src/Photo.vala"
				_tmp24_ = FALSE;
#line 4318 "../src/Photo.vala"
				if (!(y_it <= ymax)) {
#line 4318 "../src/Photo.vala"
					break;
#line 26272 "Photo.c"
				}
#line 4319 "../src/Photo.vala"
				_tmp26_ = x_insets_first_quadrant;
#line 4319 "../src/Photo.vala"
				_tmp26__length1 = x_insets_first_quadrant_length1;
#line 4319 "../src/Photo.vala"
				_tmp27_ = _tmp26_[inset_index];
#line 4319 "../src/Photo.vala"
				xmin = x_bounds_min + _tmp27_;
#line 4320 "../src/Photo.vala"
				if (xmin < 0) {
#line 4320 "../src/Photo.vala"
					_tmp28_ = 0;
#line 26286 "Photo.c"
				} else {
#line 4320 "../src/Photo.vala"
					_tmp28_ = xmin;
#line 26290 "Photo.c"
				}
#line 4320 "../src/Photo.vala"
				xmin = _tmp28_;
#line 4321 "../src/Photo.vala"
				_tmp29_ = x_insets_first_quadrant;
#line 4321 "../src/Photo.vala"
				_tmp29__length1 = x_insets_first_quadrant_length1;
#line 4321 "../src/Photo.vala"
				_tmp30_ = _tmp29_[inset_index];
#line 4321 "../src/Photo.vala"
				xmax = x_bounds_max - _tmp30_;
#line 4322 "../src/Photo.vala"
				_tmp32_ = gdk_pixbuf_get_width (pixbuf);
#line 4322 "../src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4322 "../src/Photo.vala"
				if (xmax > (_tmp33_ - 1)) {
#line 26308 "Photo.c"
					gint _tmp34_;
					gint _tmp35_;
#line 4322 "../src/Photo.vala"
					_tmp34_ = gdk_pixbuf_get_width (pixbuf);
#line 4322 "../src/Photo.vala"
					_tmp35_ = _tmp34_;
#line 4322 "../src/Photo.vala"
					_tmp31_ = _tmp35_ - 1;
#line 26317 "Photo.c"
				} else {
#line 4322 "../src/Photo.vala"
					_tmp31_ = xmax;
#line 26321 "Photo.c"
				}
#line 4322 "../src/Photo.vala"
				xmax = _tmp31_;
#line 26325 "Photo.c"
				{
					gint x_it = 0;
#line 4324 "../src/Photo.vala"
					x_it = xmin;
#line 26330 "Photo.c"
					{
						gboolean _tmp36_ = FALSE;
#line 4324 "../src/Photo.vala"
						_tmp36_ = TRUE;
#line 4324 "../src/Photo.vala"
						while (TRUE) {
#line 26337 "Photo.c"
							GdkPixbuf* _tmp38_;
							GdkPixbuf* _tmp39_;
#line 4324 "../src/Photo.vala"
							if (!_tmp36_) {
#line 26342 "Photo.c"
								gint _tmp37_;
#line 4324 "../src/Photo.vala"
								_tmp37_ = x_it;
#line 4324 "../src/Photo.vala"
								x_it = _tmp37_ + 1;
#line 26348 "Photo.c"
							}
#line 4324 "../src/Photo.vala"
							_tmp36_ = FALSE;
#line 4324 "../src/Photo.vala"
							if (!(x_it <= xmax)) {
#line 4324 "../src/Photo.vala"
								break;
#line 26356 "Photo.c"
							}
#line 4325 "../src/Photo.vala"
							_tmp38_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
#line 4325 "../src/Photo.vala"
							_tmp39_ = _tmp38_;
#line 4325 "../src/Photo.vala"
							_g_object_unref0 (_tmp39_);
#line 26364 "Photo.c"
						}
					}
				}
#line 4327 "../src/Photo.vala"
				_tmp40_ = inset_index;
#line 4327 "../src/Photo.vala"
				inset_index = _tmp40_ + 1;
#line 26372 "Photo.c"
			}
		}
	}
#line 4332 "../src/Photo.vala"
	_tmp41_ = *inst;
#line 4332 "../src/Photo.vala"
	_tmp42_ = _tmp41_.center;
#line 4332 "../src/Photo.vala"
	ymin = _tmp42_.y;
#line 4333 "../src/Photo.vala"
	_tmp43_ = *inst;
#line 4333 "../src/Photo.vala"
	_tmp44_ = _tmp43_.center;
#line 4333 "../src/Photo.vala"
	_tmp45_ = *inst;
#line 4333 "../src/Photo.vala"
	ymax = _tmp44_.y + _tmp45_.radius;
#line 4334 "../src/Photo.vala"
	_tmp46_ = x_insets_first_quadrant;
#line 4334 "../src/Photo.vala"
	_tmp46__length1 = x_insets_first_quadrant_length1;
#line 4334 "../src/Photo.vala"
	inset_index = _tmp46__length1 - 1;
#line 26396 "Photo.c"
	{
		gint y_it = 0;
#line 4335 "../src/Photo.vala"
		y_it = ymin;
#line 26401 "Photo.c"
		{
			gboolean _tmp47_ = FALSE;
#line 4335 "../src/Photo.vala"
			_tmp47_ = TRUE;
#line 4335 "../src/Photo.vala"
			while (TRUE) {
#line 26408 "Photo.c"
				gint xmin = 0;
				gint* _tmp49_;
				gint _tmp49__length1;
				gint _tmp50_;
				gint _tmp51_ = 0;
				gint xmax = 0;
				gint* _tmp52_;
				gint _tmp52__length1;
				gint _tmp53_;
				gint _tmp54_ = 0;
				gint _tmp55_;
				gint _tmp56_;
				gint _tmp63_;
#line 4335 "../src/Photo.vala"
				if (!_tmp47_) {
#line 26424 "Photo.c"
					gint _tmp48_;
#line 4335 "../src/Photo.vala"
					_tmp48_ = y_it;
#line 4335 "../src/Photo.vala"
					y_it = _tmp48_ + 1;
#line 26430 "Photo.c"
				}
#line 4335 "../src/Photo.vala"
				_tmp47_ = FALSE;
#line 4335 "../src/Photo.vala"
				if (!(y_it <= ymax)) {
#line 4335 "../src/Photo.vala"
					break;
#line 26438 "Photo.c"
				}
#line 4336 "../src/Photo.vala"
				_tmp49_ = x_insets_first_quadrant;
#line 4336 "../src/Photo.vala"
				_tmp49__length1 = x_insets_first_quadrant_length1;
#line 4336 "../src/Photo.vala"
				_tmp50_ = _tmp49_[inset_index];
#line 4336 "../src/Photo.vala"
				xmin = x_bounds_min + _tmp50_;
#line 4337 "../src/Photo.vala"
				if (xmin < 0) {
#line 4337 "../src/Photo.vala"
					_tmp51_ = 0;
#line 26452 "Photo.c"
				} else {
#line 4337 "../src/Photo.vala"
					_tmp51_ = xmin;
#line 26456 "Photo.c"
				}
#line 4337 "../src/Photo.vala"
				xmin = _tmp51_;
#line 4338 "../src/Photo.vala"
				_tmp52_ = x_insets_first_quadrant;
#line 4338 "../src/Photo.vala"
				_tmp52__length1 = x_insets_first_quadrant_length1;
#line 4338 "../src/Photo.vala"
				_tmp53_ = _tmp52_[inset_index];
#line 4338 "../src/Photo.vala"
				xmax = x_bounds_max - _tmp53_;
#line 4339 "../src/Photo.vala"
				_tmp55_ = gdk_pixbuf_get_width (pixbuf);
#line 4339 "../src/Photo.vala"
				_tmp56_ = _tmp55_;
#line 4339 "../src/Photo.vala"
				if (xmax > (_tmp56_ - 1)) {
#line 26474 "Photo.c"
					gint _tmp57_;
					gint _tmp58_;
#line 4339 "../src/Photo.vala"
					_tmp57_ = gdk_pixbuf_get_width (pixbuf);
#line 4339 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 4339 "../src/Photo.vala"
					_tmp54_ = _tmp58_ - 1;
#line 26483 "Photo.c"
				} else {
#line 4339 "../src/Photo.vala"
					_tmp54_ = xmax;
#line 26487 "Photo.c"
				}
#line 4339 "../src/Photo.vala"
				xmax = _tmp54_;
#line 26491 "Photo.c"
				{
					gint x_it = 0;
#line 4341 "../src/Photo.vala"
					x_it = xmin;
#line 26496 "Photo.c"
					{
						gboolean _tmp59_ = FALSE;
#line 4341 "../src/Photo.vala"
						_tmp59_ = TRUE;
#line 4341 "../src/Photo.vala"
						while (TRUE) {
#line 26503 "Photo.c"
							GdkPixbuf* _tmp61_;
							GdkPixbuf* _tmp62_;
#line 4341 "../src/Photo.vala"
							if (!_tmp59_) {
#line 26508 "Photo.c"
								gint _tmp60_;
#line 4341 "../src/Photo.vala"
								_tmp60_ = x_it;
#line 4341 "../src/Photo.vala"
								x_it = _tmp60_ + 1;
#line 26514 "Photo.c"
							}
#line 4341 "../src/Photo.vala"
							_tmp59_ = FALSE;
#line 4341 "../src/Photo.vala"
							if (!(x_it <= xmax)) {
#line 4341 "../src/Photo.vala"
								break;
#line 26522 "Photo.c"
							}
#line 4342 "../src/Photo.vala"
							_tmp61_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
#line 4342 "../src/Photo.vala"
							_tmp62_ = _tmp61_;
#line 4342 "../src/Photo.vala"
							_g_object_unref0 (_tmp62_);
#line 26530 "Photo.c"
						}
					}
				}
#line 4344 "../src/Photo.vala"
				_tmp63_ = inset_index;
#line 4344 "../src/Photo.vala"
				inset_index = _tmp63_ - 1;
#line 26538 "Photo.c"
			}
		}
	}
#line 4347 "../src/Photo.vala"
	_tmp64_ = _g_object_ref0 (pixbuf);
#line 4347 "../src/Photo.vala"
	result = _tmp64_;
#line 4347 "../src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4347 "../src/Photo.vala"
	return result;
#line 26550 "Photo.c"
}

static GdkPixbuf*
photo_red_reduce_pixel (Photo* self,
                        GdkPixbuf* pixbuf,
                        gint x,
                        gint y)
{
	gint px_start_byte_offset = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp13_;
	GdkPixbuf* result;
#line 4350 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4350 "../src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4351 "../src/Photo.vala"
	px_start_byte_offset = (y * gdk_pixbuf_get_rowstride (pixbuf)) + (x * gdk_pixbuf_get_n_channels (pixbuf));
#line 4358 "../src/Photo.vala"
	if (x >= 0) {
#line 4358 "../src/Photo.vala"
		_tmp2_ = y >= 0;
#line 26575 "Photo.c"
	} else {
#line 4358 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 26579 "Photo.c"
	}
#line 4358 "../src/Photo.vala"
	if (_tmp2_) {
#line 26583 "Photo.c"
		gint _tmp3_;
		gint _tmp4_;
#line 4358 "../src/Photo.vala"
		_tmp3_ = gdk_pixbuf_get_width (pixbuf);
#line 4358 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4358 "../src/Photo.vala"
		_tmp1_ = x < _tmp4_;
#line 26592 "Photo.c"
	} else {
#line 4358 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 26596 "Photo.c"
	}
#line 4358 "../src/Photo.vala"
	if (_tmp1_) {
#line 26600 "Photo.c"
		gint _tmp5_;
		gint _tmp6_;
#line 4358 "../src/Photo.vala"
		_tmp5_ = gdk_pixbuf_get_height (pixbuf);
#line 4358 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4358 "../src/Photo.vala"
		_tmp0_ = y < _tmp6_;
#line 26609 "Photo.c"
	} else {
#line 4358 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 26613 "Photo.c"
	}
#line 4358 "../src/Photo.vala"
	if (_tmp0_) {
#line 26617 "Photo.c"
		guchar* pixel_data = NULL;
		guint8* _tmp7_;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar g = '\0';
		guchar* _tmp8_;
		gint _tmp8__length1;
		guchar _tmp9_;
		guchar b = '\0';
		guchar* _tmp10_;
		gint _tmp10__length1;
		guchar _tmp11_;
		guchar r = '\0';
		guchar* _tmp12_;
		gint _tmp12__length1;
#line 4359 "../src/Photo.vala"
		_tmp7_ = gdk_pixbuf_get_pixels (pixbuf);
#line 4359 "../src/Photo.vala"
		pixel_data = _tmp7_;
#line 4359 "../src/Photo.vala"
		pixel_data_length1 = -1;
#line 4359 "../src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4369 "../src/Photo.vala"
		_tmp8_ = pixel_data;
#line 4369 "../src/Photo.vala"
		_tmp8__length1 = pixel_data_length1;
#line 4369 "../src/Photo.vala"
		_tmp9_ = _tmp8_[px_start_byte_offset + 1];
#line 4369 "../src/Photo.vala"
		g = _tmp9_;
#line 4370 "../src/Photo.vala"
		_tmp10_ = pixel_data;
#line 4370 "../src/Photo.vala"
		_tmp10__length1 = pixel_data_length1;
#line 4370 "../src/Photo.vala"
		_tmp11_ = _tmp10_[px_start_byte_offset + 2];
#line 4370 "../src/Photo.vala"
		b = _tmp11_;
#line 4372 "../src/Photo.vala"
		r = (guchar) ((g + b) / 2);
#line 4374 "../src/Photo.vala"
		_tmp12_ = pixel_data;
#line 4374 "../src/Photo.vala"
		_tmp12__length1 = pixel_data_length1;
#line 4374 "../src/Photo.vala"
		_tmp12_[px_start_byte_offset] = r;
#line 26665 "Photo.c"
	}
#line 4377 "../src/Photo.vala"
	_tmp13_ = _g_object_ref0 (pixbuf);
#line 4377 "../src/Photo.vala"
	result = _tmp13_;
#line 4377 "../src/Photo.vala"
	return result;
#line 26673 "Photo.c"
}

void
photo_unscaled_to_raw_point (Photo* self,
                             GdkPoint* unscaled_point,
                             GdkPoint* result)
{
	Orientation unscaled_orientation = 0;
	Dimensions unscaled_dims = {0};
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp2_ = {0};
	gboolean _tmp3_;
	GdkPoint derotated_point = {0};
	Dimensions _tmp6_;
	GdkPoint _tmp7_;
	GdkPoint _tmp8_ = {0};
#line 4380 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4380 "../src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4381 "../src/Photo.vala"
	unscaled_orientation = photo_get_orientation (self);
#line 4383 "../src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp0_);
#line 4383 "../src/Photo.vala"
	orientation_rotate_dimensions (unscaled_orientation, &_tmp0_, &_tmp1_);
#line 4383 "../src/Photo.vala"
	unscaled_dims = _tmp1_;
#line 4386 "../src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4387 "../src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4390 "../src/Photo.vala"
	_tmp3_ = photo_get_raw_crop (self, &_tmp2_);
#line 4390 "../src/Photo.vala"
	crop_box = _tmp2_;
#line 4390 "../src/Photo.vala"
	if (_tmp3_) {
#line 26716 "Photo.c"
		Box _tmp4_;
		Box _tmp5_;
#line 4391 "../src/Photo.vala"
		_tmp4_ = crop_box;
#line 4391 "../src/Photo.vala"
		unscaled_x_offset_raw = _tmp4_.left;
#line 4392 "../src/Photo.vala"
		_tmp5_ = crop_box;
#line 4392 "../src/Photo.vala"
		unscaled_y_offset_raw = _tmp5_.top;
#line 26727 "Photo.c"
	}
#line 4395 "../src/Photo.vala"
	_tmp6_ = unscaled_dims;
#line 4395 "../src/Photo.vala"
	_tmp7_ = *unscaled_point;
#line 4395 "../src/Photo.vala"
	orientation_derotate_point (unscaled_orientation, &_tmp6_, &_tmp7_, &_tmp8_);
#line 4395 "../src/Photo.vala"
	derotated_point = _tmp8_;
#line 4399 "../src/Photo.vala"
	derotated_point.x = derotated_point.x + unscaled_x_offset_raw;
#line 4400 "../src/Photo.vala"
	derotated_point.y = derotated_point.y + unscaled_y_offset_raw;
#line 4402 "../src/Photo.vala"
	*result = derotated_point;
#line 4402 "../src/Photo.vala"
	return;
#line 26745 "Photo.c"
}

void
photo_unscaled_to_raw_rect (Photo* self,
                            GdkRectangle* unscaled_rect,
                            GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _tmp6_;
	GdkRectangle _tmp7_;
	GdkPoint _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	GdkPoint _tmp12_;
	GdkPoint _tmp13_;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp20_;
	GdkPoint _tmp21_;
	GdkPoint _tmp22_;
	GdkPoint _tmp23_;
	GdkPoint _tmp24_;
	GdkPoint _tmp25_;
#line 4405 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4405 "../src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4406 "../src/Photo.vala"
	_tmp0_.x = 0;
#line 4406 "../src/Photo.vala"
	upper_left = _tmp0_;
#line 4407 "../src/Photo.vala"
	_tmp1_.x = 0;
#line 4407 "../src/Photo.vala"
	lower_right = _tmp1_;
#line 4408 "../src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4408 "../src/Photo.vala"
	upper_left.x = _tmp2_.x;
#line 4409 "../src/Photo.vala"
	_tmp3_ = *unscaled_rect;
#line 4409 "../src/Photo.vala"
	upper_left.y = _tmp3_.y;
#line 4410 "../src/Photo.vala"
	_tmp4_ = upper_left;
#line 4410 "../src/Photo.vala"
	_tmp5_ = *unscaled_rect;
#line 4410 "../src/Photo.vala"
	lower_right.x = _tmp4_.x + _tmp5_.width;
#line 4411 "../src/Photo.vala"
	_tmp6_ = upper_left;
#line 4411 "../src/Photo.vala"
	_tmp7_ = *unscaled_rect;
#line 4411 "../src/Photo.vala"
	lower_right.y = _tmp6_.y + _tmp7_.height;
#line 4413 "../src/Photo.vala"
	_tmp8_ = upper_left;
#line 4413 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp8_, &_tmp9_);
#line 4413 "../src/Photo.vala"
	upper_left = _tmp9_;
#line 4414 "../src/Photo.vala"
	_tmp10_ = lower_right;
#line 4414 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp10_, &_tmp11_);
#line 4414 "../src/Photo.vala"
	lower_right = _tmp11_;
#line 4416 "../src/Photo.vala"
	_tmp12_ = upper_left;
#line 4416 "../src/Photo.vala"
	_tmp13_ = lower_right;
#line 4416 "../src/Photo.vala"
	if (_tmp12_.x > _tmp13_.x) {
#line 26828 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp14_;
		GdkPoint _tmp15_;
#line 4417 "../src/Photo.vala"
		_tmp14_ = upper_left;
#line 4417 "../src/Photo.vala"
		temp = _tmp14_.x;
#line 4418 "../src/Photo.vala"
		_tmp15_ = lower_right;
#line 4418 "../src/Photo.vala"
		upper_left.x = _tmp15_.x;
#line 4419 "../src/Photo.vala"
		lower_right.x = temp;
#line 26842 "Photo.c"
	}
#line 4421 "../src/Photo.vala"
	_tmp16_ = upper_left;
#line 4421 "../src/Photo.vala"
	_tmp17_ = lower_right;
#line 4421 "../src/Photo.vala"
	if (_tmp16_.y > _tmp17_.y) {
#line 26850 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp18_;
		GdkPoint _tmp19_;
#line 4422 "../src/Photo.vala"
		_tmp18_ = upper_left;
#line 4422 "../src/Photo.vala"
		temp = _tmp18_.y;
#line 4423 "../src/Photo.vala"
		_tmp19_ = lower_right;
#line 4423 "../src/Photo.vala"
		upper_left.y = _tmp19_.y;
#line 4424 "../src/Photo.vala"
		lower_right.y = temp;
#line 26864 "Photo.c"
	}
#line 4427 "../src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4428 "../src/Photo.vala"
	_tmp20_ = upper_left;
#line 4428 "../src/Photo.vala"
	raw_rect.x = _tmp20_.x;
#line 4429 "../src/Photo.vala"
	_tmp21_ = upper_left;
#line 4429 "../src/Photo.vala"
	raw_rect.y = _tmp21_.y;
#line 4430 "../src/Photo.vala"
	_tmp22_ = lower_right;
#line 4430 "../src/Photo.vala"
	_tmp23_ = upper_left;
#line 4430 "../src/Photo.vala"
	raw_rect.width = _tmp22_.x - _tmp23_.x;
#line 4431 "../src/Photo.vala"
	_tmp24_ = lower_right;
#line 4431 "../src/Photo.vala"
	_tmp25_ = upper_left;
#line 4431 "../src/Photo.vala"
	raw_rect.height = _tmp24_.y - _tmp25_.y;
#line 4433 "../src/Photo.vala"
	*result = raw_rect;
#line 4433 "../src/Photo.vala"
	return;
#line 26892 "Photo.c"
}

PixelTransformationBundle*
photo_get_enhance_transformations (Photo* self)
{
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	GError* _inner_error0_ = NULL;
	PixelTransformationBundle* result;
#line 4436 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4437 "../src/Photo.vala"
	pixbuf = NULL;
#line 26908 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 4444 "../src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4444 "../src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 4444 "../src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4444 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26922 "Photo.c"
			goto __catch0_g_error;
		}
#line 4444 "../src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4444 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 4444 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4444 "../src/Photo.vala"
		pixbuf = _tmp3_;
#line 4443 "../src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 26935 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 4443 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4451 "../src/Photo.vala"
		g_warning ("Photo.vala:4451: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4453 "../src/Photo.vala"
		result = NULL;
#line 4453 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4453 "../src/Photo.vala"
		return result;
#line 26950 "Photo.c"
	}
	__finally0:
#line 4443 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4443 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4443 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4443 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4443 "../src/Photo.vala"
		return NULL;
#line 26963 "Photo.c"
	}
#line 4460 "../src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4460 "../src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4460 "../src/Photo.vala"
	transformations = _tmp5_;
#line 4468 "../src/Photo.vala"
	result = transformations;
#line 4468 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4468 "../src/Photo.vala"
	return result;
#line 26977 "Photo.c"
}

gboolean
photo_enhance (Photo* self)
{
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 4471 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4472 "../src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4472 "../src/Photo.vala"
	transformations = _tmp0_;
#line 4474 "../src/Photo.vala"
	_tmp1_ = transformations;
#line 4474 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4475 "../src/Photo.vala"
		result = FALSE;
#line 4475 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4475 "../src/Photo.vala"
		return result;
#line 27004 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4481 "../src/Photo.vala"
		_tmp2_ = self->row;
#line 4481 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 27012 "Photo.c"
		{
			KeyValueMap* _tmp3_;
			KeyValueMap* _tmp4_;
			PixelTransformationBundle* _tmp5_;
#line 4482 "../src/Photo.vala"
			photo_clear_original_transforms (self);
#line 4483 "../src/Photo.vala"
			_tmp3_ = photo_get_color_adjustments_map (self);
#line 4483 "../src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 4483 "../src/Photo.vala"
			photo_set_original_transforms (self, _tmp4_);
#line 4483 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp4_);
#line 4484 "../src/Photo.vala"
			_tmp5_ = transformations;
#line 4484 "../src/Photo.vala"
			photo_set_color_adjustments (self, _tmp5_);
#line 27031 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 4481 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 4481 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27040 "Photo.c"
		}
#line 4481 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27044 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 4481 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4481 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4481 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4481 "../src/Photo.vala"
			return _tmp7_;
#line 27054 "Photo.c"
		}
	}
#line 4491 "../src/Photo.vala"
	photo_set_enhanced (self, TRUE);
#line 4492 "../src/Photo.vala"
	result = TRUE;
#line 4492 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4492 "../src/Photo.vala"
	return result;
#line 27065 "Photo.c"
}

gboolean
photo_unenhance (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 4495 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27075 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 4496 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 4496 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 27082 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 4497 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 4497 "../src/Photo.vala"
			if (_tmp1_->enhanced) {
#line 27089 "Photo.c"
				gboolean _tmp2_ = FALSE;
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 4498 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 4498 "../src/Photo.vala"
				_tmp4_ = _tmp3_->original_transforms;
#line 4498 "../src/Photo.vala"
				if (_tmp4_ == NULL) {
#line 4498 "../src/Photo.vala"
					_tmp2_ = TRUE;
#line 27101 "Photo.c"
				} else {
					PhotoRow* _tmp5_;
					GeeHashMap* _tmp6_;
					gpointer _tmp7_;
					KeyValueMap* _tmp8_;
#line 4498 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 4498 "../src/Photo.vala"
					_tmp6_ = _tmp5_->original_transforms;
#line 4498 "../src/Photo.vala"
					_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, "adjustments");
#line 4498 "../src/Photo.vala"
					_tmp8_ = (KeyValueMap*) _tmp7_;
#line 4498 "../src/Photo.vala"
					_tmp2_ = _tmp8_ == NULL;
#line 4498 "../src/Photo.vala"
					_key_value_map_unref0 (_tmp8_);
#line 27119 "Photo.c"
				}
#line 4498 "../src/Photo.vala"
				if (_tmp2_) {
#line 27123 "Photo.c"
					gboolean _result_ = FALSE;
#line 4499 "../src/Photo.vala"
					photo_remove_transformation (self, "adjustments");
#line 4500 "../src/Photo.vala"
					_result_ = FALSE;
#line 4501 "../src/Photo.vala"
					_result_ = photo_remove_transformation (self, "adjustments");
#line 4502 "../src/Photo.vala"
					_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 4502 "../src/Photo.vala"
					self->priv->adjustments = NULL;
#line 4503 "../src/Photo.vala"
					_pixel_transformer_unref0 (self->priv->transformer);
#line 4503 "../src/Photo.vala"
					self->priv->transformer = NULL;
#line 4504 "../src/Photo.vala"
					if (_result_) {
#line 27141 "Photo.c"
						Alteration* _tmp9_;
						Alteration* _tmp10_;
#line 4505 "../src/Photo.vala"
						_tmp9_ = alteration_new ("image", "color-adjustments");
#line 4505 "../src/Photo.vala"
						_tmp10_ = _tmp9_;
#line 4505 "../src/Photo.vala"
						data_object_notify_altered ((DataObject*) self, _tmp10_);
#line 4505 "../src/Photo.vala"
						_alteration_unref0 (_tmp10_);
#line 27152 "Photo.c"
					}
				} else {
					PixelTransformationBundle* _tmp11_;
					PixelTransformationBundle* _tmp12_;
#line 4508 "../src/Photo.vala"
					_tmp11_ = photo_locked_original_color_adjustments (self);
#line 4508 "../src/Photo.vala"
					_tmp12_ = _tmp11_;
#line 4508 "../src/Photo.vala"
					photo_set_color_adjustments (self, _tmp12_);
#line 4508 "../src/Photo.vala"
					_pixel_transformation_bundle_unref0 (_tmp12_);
#line 27165 "Photo.c"
				}
#line 4511 "../src/Photo.vala"
				photo_set_enhanced (self, FALSE);
#line 4512 "../src/Photo.vala"
				result = TRUE;
#line 27171 "Photo.c"
				{
					PhotoRow* _tmp13_;
#line 4496 "../src/Photo.vala"
					_tmp13_ = self->row;
#line 4496 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27178 "Photo.c"
				}
#line 4512 "../src/Photo.vala"
				return result;
#line 27182 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 4496 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 4496 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27192 "Photo.c"
		}
#line 4496 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27196 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 4496 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4496 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4496 "../src/Photo.vala"
			return _tmp15_;
#line 27204 "Photo.c"
		}
	}
#line 4515 "../src/Photo.vala"
	result = FALSE;
#line 4515 "../src/Photo.vala"
	return result;
#line 27211 "Photo.c"
}

gboolean
photo_get_develop_raw_photos_to_files (void)
{
	gboolean result;
#line 281 "../src/Photo.vala"
	result = photo__develop_raw_photos_to_files;
#line 281 "../src/Photo.vala"
	return result;
#line 27222 "Photo.c"
}

void
photo_set_develop_raw_photos_to_files (gboolean value)
{
#line 282 "../src/Photo.vala"
	photo__develop_raw_photos_to_files = value;
#line 27230 "Photo.c"
}

static void
photo_real_editable_replaced (Photo* self,
                              GFile* old_file,
                              GFile* new_file)
{
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 97 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "../src/Photo.vala"
		data1 = closure->data;
#line 97 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 27262 "Photo.c"
	} else {
#line 97 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "../src/Photo.vala"
		data2 = closure->data;
#line 27268 "Photo.c"
	}
#line 97 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 97 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 27274 "Photo.c"
}

static void
photo_real_raw_development_modified (Photo* self)
{
}

static void
photo_real_baseline_replaced (Photo* self)
{
}

static void
photo_real_master_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
}

static void
g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 97 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "../src/Photo.vala"
		data1 = closure->data;
#line 97 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 27315 "Photo.c"
	} else {
#line 97 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "../src/Photo.vala"
		data2 = closure->data;
#line 27321 "Photo.c"
	}
#line 97 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 97 "../src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 27327 "Photo.c"
}

static void
photo_real_editable_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
}

static void
photo_real_baseline_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
}

static void
photo_real_source_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
}

static inline gpointer
photo_photo_transformation_state_impl_get_instance_private (PhotoPhotoTransformationStateImpl* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPhotoTransformationStateImpl_private_offset);
}

static void
_photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                           gpointer self)
{
#line 192 "../src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 27360 "Photo.c"
}

static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_construct (GType object_type,
                                                 Photo* photo,
                                                 Orientation orientation,
                                                 GeeHashMap* transformations,
                                                 PixelTransformer* transformer,
                                                 PixelTransformationBundle* adjustments,
                                                 GeeHashMap* original_transformations,
                                                 gboolean enhanced)
{
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	PixelTransformer* _tmp3_;
	PixelTransformationBundle* _tmp4_;
#line 178 "../src/Photo.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 178 "../src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 181 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 181 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 181 "../src/Photo.vala"
	self->priv->photo = _tmp0_;
#line 182 "../src/Photo.vala"
	self->priv->orientation = orientation;
#line 183 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (transformations);
#line 183 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 183 "../src/Photo.vala"
	self->priv->transformations = _tmp1_;
#line 184 "../src/Photo.vala"
	_tmp2_ = photo_photo_transformation_state_impl_copy_transformations (original_transformations);
#line 184 "../src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 184 "../src/Photo.vala"
	self->priv->original_transformations = _tmp2_;
#line 185 "../src/Photo.vala"
	_tmp3_ = _pixel_transformer_ref0 (transformer);
#line 185 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 185 "../src/Photo.vala"
	self->priv->transformer = _tmp3_;
#line 186 "../src/Photo.vala"
	_tmp4_ = _pixel_transformation_bundle_ref0 (adjustments);
#line 186 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 186 "../src/Photo.vala"
	self->priv->adjustments = _tmp4_;
#line 187 "../src/Photo.vala"
	self->priv->enhanced = enhanced;
#line 188 "../src/Photo.vala"
	g_signal_connect_object (photo, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 178 "../src/Photo.vala"
	return self;
#line 27421 "Photo.c"
}

static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_new (Photo* photo,
                                           Orientation orientation,
                                           GeeHashMap* transformations,
                                           PixelTransformer* transformer,
                                           PixelTransformationBundle* adjustments,
                                           GeeHashMap* original_transformations,
                                           gboolean enhanced)
{
#line 178 "../src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments, original_transformations, enhanced);
#line 27435 "Photo.c"
}

static gboolean
photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self)
{
	gboolean result;
#line 195 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "../src/Photo.vala"
	result = self->priv->enhanced;
#line 196 "../src/Photo.vala"
	return result;
#line 27448 "Photo.c"
}

static Orientation
photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self)
{
	Orientation result;
#line 199 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 200 "../src/Photo.vala"
	result = self->priv->orientation;
#line 200 "../src/Photo.vala"
	return result;
#line 27461 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* result;
#line 203 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "../src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 204 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 204 "../src/Photo.vala"
	result = _tmp1_;
#line 204 "../src/Photo.vala"
	return result;
#line 27480 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* result;
#line 207 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/Photo.vala"
	_tmp0_ = self->priv->original_transformations;
#line 208 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 208 "../src/Photo.vala"
	result = _tmp1_;
#line 208 "../src/Photo.vala"
	return result;
#line 27499 "Photo.c"
}

static PixelTransformer*
photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
	PixelTransformer* result;
#line 211 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "../src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 212 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 27514 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_;
#line 212 "../src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 212 "../src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 212 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 27525 "Photo.c"
	} else {
#line 212 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 27531 "Photo.c"
	}
#line 212 "../src/Photo.vala"
	result = _tmp0_;
#line 212 "../src/Photo.vala"
	return result;
#line 27537 "Photo.c"
}

static PixelTransformationBundle*
photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
	PixelTransformationBundle* result;
#line 215 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "../src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 216 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 27552 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_;
#line 216 "../src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 216 "../src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 216 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 27563 "Photo.c"
	} else {
#line 216 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 27569 "Photo.c"
	}
#line 216 "../src/Photo.vala"
	result = _tmp0_;
#line 216 "../src/Photo.vala"
	return result;
#line 27575 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original)
{
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* result;
#line 221 "../src/Photo.vala"
	if (original == NULL) {
#line 222 "../src/Photo.vala"
		result = NULL;
#line 222 "../src/Photo.vala"
		return result;
#line 27590 "Photo.c"
	}
#line 224 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 224 "../src/Photo.vala"
	clone = _tmp0_;
#line 27596 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 225 "../src/Photo.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) original);
#line 225 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 225 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 225 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 225 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 225 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 225 "../src/Photo.vala"
		_object_it = _tmp5_;
#line 225 "../src/Photo.vala"
		while (TRUE) {
#line 27620 "Photo.c"
			GeeIterator* _tmp6_;
			gchar* object = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeHashMap* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			KeyValueMap* _tmp13_;
			KeyValueMap* _tmp14_;
			KeyValueMap* _tmp15_;
#line 225 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 225 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 225 "../src/Photo.vala"
				break;
#line 27638 "Photo.c"
			}
#line 225 "../src/Photo.vala"
			_tmp7_ = _object_it;
#line 225 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 225 "../src/Photo.vala"
			object = (gchar*) _tmp8_;
#line 226 "../src/Photo.vala"
			_tmp9_ = clone;
#line 226 "../src/Photo.vala"
			_tmp10_ = object;
#line 226 "../src/Photo.vala"
			_tmp11_ = object;
#line 226 "../src/Photo.vala"
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) original, _tmp11_);
#line 226 "../src/Photo.vala"
			_tmp13_ = (KeyValueMap*) _tmp12_;
#line 226 "../src/Photo.vala"
			_tmp14_ = key_value_map_copy (_tmp13_);
#line 226 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 226 "../src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp10_, _tmp15_);
#line 226 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp15_);
#line 226 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp13_);
#line 225 "../src/Photo.vala"
			_g_free0 (object);
#line 27668 "Photo.c"
		}
#line 225 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 27672 "Photo.c"
	}
#line 228 "../src/Photo.vala"
	result = clone;
#line 228 "../src/Photo.vala"
	return result;
#line 27678 "Photo.c"
}

static void
photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self)
{
#line 231 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/Photo.vala"
	if (!photo_transformation_state_is_broken ((PhotoTransformationState*) self)) {
#line 233 "../src/Photo.vala"
		g_signal_emit ((PhotoTransformationState*) self, photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL], 0);
#line 27690 "Photo.c"
	}
}

static void
photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass,
                                                  gpointer klass_data)
{
#line 169 "../src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 169 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPhotoTransformationStateImpl_private_offset);
#line 169 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 27704 "Photo.c"
}

static void
photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self,
                                                     gpointer klass)
{
#line 169 "../src/Photo.vala"
	self->priv = photo_photo_transformation_state_impl_get_instance_private (self);
#line 27713 "Photo.c"
}

static void
photo_photo_transformation_state_impl_finalize (GObject * obj)
{
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_;
#line 169 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 192 "../src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 192 "../src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 192 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 170 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 172 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 173 "../src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 174 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 175 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 169 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 27742 "Photo.c"
}

static GType
photo_photo_transformation_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
	GType photo_photo_transformation_state_impl_type_id;
	photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
	PhotoPhotoTransformationStateImpl_private_offset = g_type_add_instance_private (photo_photo_transformation_state_impl_type_id, sizeof (PhotoPhotoTransformationStateImplPrivate));
	return photo_photo_transformation_state_impl_type_id;
}

static GType
photo_photo_transformation_state_impl_get_type (void)
{
	static volatile gsize photo_photo_transformation_state_impl_type_id__once = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__once)) {
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = photo_photo_transformation_state_impl_get_type_once ();
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__once, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__once;
}

static PhotoBackingReaders*
photo_backing_readers_construct (GType object_type)
{
	PhotoBackingReaders* self = NULL;
#line 237 "../src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 237 "../src/Photo.vala"
	return self;
#line 27775 "Photo.c"
}

static PhotoBackingReaders*
photo_backing_readers_new (void)
{
#line 237 "../src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 27783 "Photo.c"
}

static void
photo_value_backing_readers_init (GValue* value)
{
#line 237 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 27791 "Photo.c"
}

static void
photo_value_backing_readers_free_value (GValue* value)
{
#line 237 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 237 "../src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 27801 "Photo.c"
	}
}

static void
photo_value_backing_readers_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 237 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 237 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 27813 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 27817 "Photo.c"
	}
}

static gpointer
photo_value_backing_readers_peek_pointer (const GValue* value)
{
#line 237 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 27826 "Photo.c"
}

static gchar*
photo_value_backing_readers_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 237 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 27837 "Photo.c"
		PhotoBackingReaders * object;
		object = collect_values[0].v_pointer;
#line 237 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 237 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 27844 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 237 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 27848 "Photo.c"
		}
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 27852 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 27856 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	return NULL;
#line 27860 "Photo.c"
}

static gchar*
photo_value_backing_readers_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	PhotoBackingReaders ** object_p;
	object_p = collect_values[0].v_pointer;
#line 237 "../src/Photo.vala"
	if (!object_p) {
#line 237 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 27875 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 237 "../src/Photo.vala"
		*object_p = NULL;
#line 27881 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 237 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 27885 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 27889 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	return NULL;
#line 27893 "Photo.c"
}

static GParamSpec*
photo_param_spec_backing_readers (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	PhotoParamSpecBackingReaders* spec;
#line 237 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 237 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 237 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 27912 "Photo.c"
}

static gpointer
photo_value_get_backing_readers (const GValue* value)
{
#line 237 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 27922 "Photo.c"
}

static void
photo_value_set_backing_readers (GValue* value,
                                 gpointer v_object)
{
	PhotoBackingReaders * old;
#line 237 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "../src/Photo.vala"
	if (v_object) {
#line 237 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 237 "../src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 27944 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 27948 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	if (old) {
#line 237 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 27954 "Photo.c"
	}
}

static void
photo_value_take_backing_readers (GValue* value,
                                  gpointer v_object)
{
	PhotoBackingReaders * old;
#line 237 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "../src/Photo.vala"
	if (v_object) {
#line 237 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 27975 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 27979 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	if (old) {
#line 237 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 27985 "Photo.c"
	}
}

static void
photo_backing_readers_class_init (PhotoBackingReadersClass * klass,
                                  gpointer klass_data)
{
#line 237 "../src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 237 "../src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 27997 "Photo.c"
}

static void
photo_backing_readers_instance_init (PhotoBackingReaders * self,
                                     gpointer klass)
{
#line 237 "../src/Photo.vala"
	self->ref_count = 1;
#line 28006 "Photo.c"
}

static void
photo_backing_readers_finalize (PhotoBackingReaders * obj)
{
	PhotoBackingReaders * self;
#line 237 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 237 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 238 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 239 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 240 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 28023 "Photo.c"
}

static GType
photo_backing_readers_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_backing_readers_type_id;
	photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_backing_readers_type_id;
}

static GType
photo_backing_readers_get_type (void)
{
	static volatile gsize photo_backing_readers_type_id__once = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__once)) {
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = photo_backing_readers_get_type_once ();
		g_once_init_leave (&photo_backing_readers_type_id__once, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__once;
}

static gpointer
photo_backing_readers_ref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 237 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 237 "../src/Photo.vala"
	return instance;
#line 28058 "Photo.c"
}

static void
photo_backing_readers_unref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 237 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 237 "../src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 237 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 28072 "Photo.c"
	}
}

PhotoReimportMasterState*
photo_reimport_master_state_construct (GType object_type)
{
	PhotoReimportMasterState* self = NULL;
#line 1278 "../src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1278 "../src/Photo.vala"
	return self;
#line 28084 "Photo.c"
}

static void
photo_value_reimport_master_state_init (GValue* value)
{
#line 1278 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 28092 "Photo.c"
}

static void
photo_value_reimport_master_state_free_value (GValue* value)
{
#line 1278 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1278 "../src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 28102 "Photo.c"
	}
}

static void
photo_value_reimport_master_state_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 1278 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1278 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 28114 "Photo.c"
	} else {
#line 1278 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 28118 "Photo.c"
	}
}

static gpointer
photo_value_reimport_master_state_peek_pointer (const GValue* value)
{
#line 1278 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 28127 "Photo.c"
}

static gchar*
photo_value_reimport_master_state_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 1278 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 28138 "Photo.c"
		PhotoReimportMasterState * object;
		object = collect_values[0].v_pointer;
#line 1278 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1278 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 28145 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1278 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 28149 "Photo.c"
		}
#line 1278 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 28153 "Photo.c"
	} else {
#line 1278 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 28157 "Photo.c"
	}
#line 1278 "../src/Photo.vala"
	return NULL;
#line 28161 "Photo.c"
}

static gchar*
photo_value_reimport_master_state_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	PhotoReimportMasterState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1278 "../src/Photo.vala"
	if (!object_p) {
#line 1278 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 28176 "Photo.c"
	}
#line 1278 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1278 "../src/Photo.vala"
		*object_p = NULL;
#line 28182 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1278 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 28186 "Photo.c"
	} else {
#line 1278 "../src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 28190 "Photo.c"
	}
#line 1278 "../src/Photo.vala"
	return NULL;
#line 28194 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_master_state (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	PhotoParamSpecReimportMasterState* spec;
#line 1278 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1278 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1278 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1278 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 28213 "Photo.c"
}

gpointer
photo_value_get_reimport_master_state (const GValue* value)
{
#line 1278 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1278 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 28223 "Photo.c"
}

void
photo_value_set_reimport_master_state (GValue* value,
                                       gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1278 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1278 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1278 "../src/Photo.vala"
	if (v_object) {
#line 1278 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1278 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1278 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1278 "../src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 28245 "Photo.c"
	} else {
#line 1278 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 28249 "Photo.c"
	}
#line 1278 "../src/Photo.vala"
	if (old) {
#line 1278 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 28255 "Photo.c"
	}
}

void
photo_value_take_reimport_master_state (GValue* value,
                                        gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1278 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1278 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1278 "../src/Photo.vala"
	if (v_object) {
#line 1278 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1278 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1278 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 28276 "Photo.c"
	} else {
#line 1278 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 28280 "Photo.c"
	}
#line 1278 "../src/Photo.vala"
	if (old) {
#line 1278 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 28286 "Photo.c"
	}
}

static void
photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass,
                                        gpointer klass_data)
{
#line 1278 "../src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1278 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 28298 "Photo.c"
}

static void
photo_reimport_master_state_instance_init (PhotoReimportMasterState * self,
                                           gpointer klass)
{
#line 1278 "../src/Photo.vala"
	self->ref_count = 1;
#line 28307 "Photo.c"
}

static void
photo_reimport_master_state_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterState * self;
#line 1278 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1278 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 28318 "Photo.c"
}

static GType
photo_reimport_master_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_master_state_type_id;
	photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_master_state_type_id;
}

GType
photo_reimport_master_state_get_type (void)
{
	static volatile gsize photo_reimport_master_state_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__once)) {
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = photo_reimport_master_state_get_type_once ();
		g_once_init_leave (&photo_reimport_master_state_type_id__once, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__once;
}

gpointer
photo_reimport_master_state_ref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1278 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1278 "../src/Photo.vala"
	return instance;
#line 28353 "Photo.c"
}

void
photo_reimport_master_state_unref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1278 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1278 "../src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1278 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 28367 "Photo.c"
	}
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
#line 1290 "../src/Photo.vala"
	if (length >= 0) {
#line 28377 "Photo.c"
		gchar** result;
		gssize i;
#line 1290 "../src/Photo.vala"
		result = g_new0 (gchar*, length + 1);
#line 1290 "../src/Photo.vala"
		for (i = 0; i < length; i++) {
#line 28384 "Photo.c"
			gchar* _tmp0_;
#line 1290 "../src/Photo.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1290 "../src/Photo.vala"
			result[i] = _tmp0_;
#line 28390 "Photo.c"
		}
#line 1290 "../src/Photo.vala"
		return result;
#line 28394 "Photo.c"
	}
#line 1290 "../src/Photo.vala"
	return NULL;
#line 28398 "Photo.c"
}

static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_construct (GType object_type,
                                            PhotoRow* row,
                                            PhotoMetadata* metadata,
                                            gchar** alterations,
                                            gint alterations_length1)
{
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 1287 "../src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 1287 "../src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1288 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 1288 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1288 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1289 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1289 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1289 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1290 "../src/Photo.vala"
	_tmp2_ = (alterations != NULL) ? _vala_array_dup4 (alterations, alterations_length1) : alterations;
#line 1290 "../src/Photo.vala"
	_tmp2__length1 = alterations_length1;
#line 1290 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1290 "../src/Photo.vala"
	self->alterations = _tmp2_;
#line 1290 "../src/Photo.vala"
	self->alterations_length1 = _tmp2__length1;
#line 1290 "../src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1287 "../src/Photo.vala"
	return self;
#line 28443 "Photo.c"
}

static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_new (PhotoRow* row,
                                      PhotoMetadata* metadata,
                                      gchar** alterations,
                                      gint alterations_length1)
{
#line 1287 "../src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 28454 "Photo.c"
}

static void
photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass,
                                             gpointer klass_data)
{
#line 1281 "../src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1281 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 28465 "Photo.c"
}

static void
photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self,
                                                gpointer klass)
{
	PhotoRow* _tmp0_;
#line 1282 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1282 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1285 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 28479 "Photo.c"
}

static void
photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterStateImpl * self;
#line 1281 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1282 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1283 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1284 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1281 "../src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 28496 "Photo.c"
}

static GType
photo_reimport_master_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
	GType photo_reimport_master_state_impl_type_id;
	photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
	return photo_reimport_master_state_impl_type_id;
}

static GType
photo_reimport_master_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_master_state_impl_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__once)) {
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = photo_reimport_master_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__once, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__once;
}

PhotoReimportEditableState*
photo_reimport_editable_state_construct (GType object_type)
{
	PhotoReimportEditableState* self = NULL;
#line 1294 "../src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1294 "../src/Photo.vala"
	return self;
#line 28528 "Photo.c"
}

static void
photo_value_reimport_editable_state_init (GValue* value)
{
#line 1294 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 28536 "Photo.c"
}

static void
photo_value_reimport_editable_state_free_value (GValue* value)
{
#line 1294 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1294 "../src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 28546 "Photo.c"
	}
}

static void
photo_value_reimport_editable_state_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 1294 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1294 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 28558 "Photo.c"
	} else {
#line 1294 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 28562 "Photo.c"
	}
}

static gpointer
photo_value_reimport_editable_state_peek_pointer (const GValue* value)
{
#line 1294 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 28571 "Photo.c"
}

static gchar*
photo_value_reimport_editable_state_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 1294 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 28582 "Photo.c"
		PhotoReimportEditableState * object;
		object = collect_values[0].v_pointer;
#line 1294 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1294 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 28589 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1294 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 28593 "Photo.c"
		}
#line 1294 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 28597 "Photo.c"
	} else {
#line 1294 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 28601 "Photo.c"
	}
#line 1294 "../src/Photo.vala"
	return NULL;
#line 28605 "Photo.c"
}

static gchar*
photo_value_reimport_editable_state_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	PhotoReimportEditableState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1294 "../src/Photo.vala"
	if (!object_p) {
#line 1294 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 28620 "Photo.c"
	}
#line 1294 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1294 "../src/Photo.vala"
		*object_p = NULL;
#line 28626 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1294 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 28630 "Photo.c"
	} else {
#line 1294 "../src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 28634 "Photo.c"
	}
#line 1294 "../src/Photo.vala"
	return NULL;
#line 28638 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_editable_state (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	PhotoParamSpecReimportEditableState* spec;
#line 1294 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1294 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1294 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1294 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 28657 "Photo.c"
}

gpointer
photo_value_get_reimport_editable_state (const GValue* value)
{
#line 1294 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1294 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 28667 "Photo.c"
}

void
photo_value_set_reimport_editable_state (GValue* value,
                                         gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1294 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1294 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1294 "../src/Photo.vala"
	if (v_object) {
#line 1294 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1294 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1294 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1294 "../src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 28689 "Photo.c"
	} else {
#line 1294 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 28693 "Photo.c"
	}
#line 1294 "../src/Photo.vala"
	if (old) {
#line 1294 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 28699 "Photo.c"
	}
}

void
photo_value_take_reimport_editable_state (GValue* value,
                                          gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1294 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1294 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1294 "../src/Photo.vala"
	if (v_object) {
#line 1294 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1294 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1294 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 28720 "Photo.c"
	} else {
#line 1294 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 28724 "Photo.c"
	}
#line 1294 "../src/Photo.vala"
	if (old) {
#line 1294 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 28730 "Photo.c"
	}
}

static void
photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass,
                                          gpointer klass_data)
{
#line 1294 "../src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1294 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 28742 "Photo.c"
}

static void
photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self,
                                             gpointer klass)
{
#line 1294 "../src/Photo.vala"
	self->ref_count = 1;
#line 28751 "Photo.c"
}

static void
photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableState * self;
#line 1294 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1294 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 28762 "Photo.c"
}

static GType
photo_reimport_editable_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_editable_state_type_id;
	photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_editable_state_type_id;
}

GType
photo_reimport_editable_state_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__once)) {
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = photo_reimport_editable_state_get_type_once ();
		g_once_init_leave (&photo_reimport_editable_state_type_id__once, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__once;
}

gpointer
photo_reimport_editable_state_ref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1294 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1294 "../src/Photo.vala"
	return instance;
#line 28797 "Photo.c"
}

void
photo_reimport_editable_state_unref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1294 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1294 "../src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1294 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 28811 "Photo.c"
	}
}

static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_construct (GType object_type,
                                              BackingPhotoRow* backing_state,
                                              PhotoMetadata* metadata)
{
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1302 "../src/Photo.vala"
	g_return_val_if_fail (backing_state != NULL, NULL);
#line 1302 "../src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1303 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing_state);
#line 1303 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1303 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1304 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1304 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1304 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1302 "../src/Photo.vala"
	return self;
#line 28841 "Photo.c"
}

static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                        PhotoMetadata* metadata)
{
#line 1302 "../src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 28850 "Photo.c"
}

static void
photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass,
                                               gpointer klass_data)
{
#line 1297 "../src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1297 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 28861 "Photo.c"
}

static void
photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self,
                                                  gpointer klass)
{
	BackingPhotoRow* _tmp0_;
#line 1298 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1298 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1300 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 28875 "Photo.c"
}

static void
photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableStateImpl * self;
#line 1297 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1298 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1299 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1297 "../src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 28890 "Photo.c"
}

static GType
photo_reimport_editable_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
	GType photo_reimport_editable_state_impl_type_id;
	photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
	return photo_reimport_editable_state_impl_type_id;
}

static GType
photo_reimport_editable_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_impl_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__once)) {
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = photo_reimport_editable_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__once, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__once;
}

PhotoReimportRawDevelopmentState*
photo_reimport_raw_development_state_construct (GType object_type)
{
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1308 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1308 "../src/Photo.vala"
	return self;
#line 28922 "Photo.c"
}

static void
photo_value_reimport_raw_development_state_init (GValue* value)
{
#line 1308 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 28930 "Photo.c"
}

static void
photo_value_reimport_raw_development_state_free_value (GValue* value)
{
#line 1308 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1308 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 28940 "Photo.c"
	}
}

static void
photo_value_reimport_raw_development_state_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 1308 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1308 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 28952 "Photo.c"
	} else {
#line 1308 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 28956 "Photo.c"
	}
}

static gpointer
photo_value_reimport_raw_development_state_peek_pointer (const GValue* value)
{
#line 1308 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 28965 "Photo.c"
}

static gchar*
photo_value_reimport_raw_development_state_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 1308 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 28976 "Photo.c"
		PhotoReimportRawDevelopmentState * object;
		object = collect_values[0].v_pointer;
#line 1308 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1308 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 28983 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1308 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 28987 "Photo.c"
		}
#line 1308 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 28991 "Photo.c"
	} else {
#line 1308 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 28995 "Photo.c"
	}
#line 1308 "../src/Photo.vala"
	return NULL;
#line 28999 "Photo.c"
}

static gchar*
photo_value_reimport_raw_development_state_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	PhotoReimportRawDevelopmentState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1308 "../src/Photo.vala"
	if (!object_p) {
#line 1308 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 29014 "Photo.c"
	}
#line 1308 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1308 "../src/Photo.vala"
		*object_p = NULL;
#line 29020 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1308 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 29024 "Photo.c"
	} else {
#line 1308 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 29028 "Photo.c"
	}
#line 1308 "../src/Photo.vala"
	return NULL;
#line 29032 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1308 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1308 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1308 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1308 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 29051 "Photo.c"
}

gpointer
photo_value_get_reimport_raw_development_state (const GValue* value)
{
#line 1308 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1308 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 29061 "Photo.c"
}

void
photo_value_set_reimport_raw_development_state (GValue* value,
                                                gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1308 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1308 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1308 "../src/Photo.vala"
	if (v_object) {
#line 1308 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1308 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1308 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1308 "../src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 29083 "Photo.c"
	} else {
#line 1308 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 29087 "Photo.c"
	}
#line 1308 "../src/Photo.vala"
	if (old) {
#line 1308 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 29093 "Photo.c"
	}
}

void
photo_value_take_reimport_raw_development_state (GValue* value,
                                                 gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1308 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1308 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1308 "../src/Photo.vala"
	if (v_object) {
#line 1308 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1308 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1308 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 29114 "Photo.c"
	} else {
#line 1308 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 29118 "Photo.c"
	}
#line 1308 "../src/Photo.vala"
	if (old) {
#line 1308 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 29124 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass,
                                                 gpointer klass_data)
{
#line 1308 "../src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1308 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 29136 "Photo.c"
}

static void
photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self,
                                                    gpointer klass)
{
#line 1308 "../src/Photo.vala"
	self->ref_count = 1;
#line 29145 "Photo.c"
}

static void
photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentState * self;
#line 1308 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1308 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 29156 "Photo.c"
}

static GType
photo_reimport_raw_development_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_raw_development_state_type_id;
	photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_raw_development_state_type_id;
}

GType
photo_reimport_raw_development_state_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__once)) {
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = photo_reimport_raw_development_state_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__once, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__once;
}

gpointer
photo_reimport_raw_development_state_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1308 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1308 "../src/Photo.vala"
	return instance;
#line 29191 "Photo.c"
}

void
photo_reimport_raw_development_state_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1308 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1308 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1308 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 29205 "Photo.c"
	}
}

static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_construct (GType object_type)
{
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1325 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1325 "../src/Photo.vala"
	return self;
#line 29217 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_new (void)
{
#line 1325 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 29225 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                               BackingPhotoRow* backing,
                                               PhotoMetadata* metadata)
{
	GeeCollection* _tmp0_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp1_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp2_;
#line 1328 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1328 "../src/Photo.vala"
	g_return_if_fail (backing != NULL);
#line 1329 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1329 "../src/Photo.vala"
	_tmp1_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (backing, metadata);
#line 1329 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1329 "../src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp2_);
#line 1329 "../src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp2_);
#line 29250 "Photo.c"
}

static gint
photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self)
{
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 1332 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1333 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1333 "../src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1333 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1333 "../src/Photo.vala"
	result = _tmp2_;
#line 1333 "../src/Photo.vala"
	return result;
#line 29272 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                     BackingPhotoRow* backing,
                                                                     PhotoMetadata* metadata)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1316 "../src/Photo.vala"
	g_return_val_if_fail (backing != NULL, NULL);
#line 1316 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1317 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing);
#line 1317 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1317 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1318 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1318 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1318 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1316 "../src/Photo.vala"
	return self;
#line 29301 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                               PhotoMetadata* metadata)
{
#line 1316 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 29310 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value)
{
#line 1312 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 29318 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value)
{
#line 1312 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1312 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 29328 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 1312 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1312 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 29340 "Photo.c"
	} else {
#line 1312 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 29344 "Photo.c"
	}
}

static gpointer
photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value)
{
#line 1312 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 29353 "Photo.c"
}

static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 1312 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 29364 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport * object;
		object = collect_values[0].v_pointer;
#line 1312 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1312 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 29371 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1312 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 29375 "Photo.c"
		}
#line 1312 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 29379 "Photo.c"
	} else {
#line 1312 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 29383 "Photo.c"
	}
#line 1312 "../src/Photo.vala"
	return NULL;
#line 29387 "Photo.c"
}

static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1312 "../src/Photo.vala"
	if (!object_p) {
#line 1312 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 29402 "Photo.c"
	}
#line 1312 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1312 "../src/Photo.vala"
		*object_p = NULL;
#line 29408 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1312 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 29412 "Photo.c"
	} else {
#line 1312 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 29416 "Photo.c"
	}
#line 1312 "../src/Photo.vala"
	return NULL;
#line 29420 "Photo.c"
}

static GParamSpec*
photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1312 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1312 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1312 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1312 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 29439 "Photo.c"
}

static gpointer
photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value)
{
#line 1312 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1312 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 29449 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                     gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1312 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1312 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1312 "../src/Photo.vala"
	if (v_object) {
#line 1312 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1312 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1312 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1312 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 29471 "Photo.c"
	} else {
#line 1312 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 29475 "Photo.c"
	}
#line 1312 "../src/Photo.vala"
	if (old) {
#line 1312 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 29481 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                      gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1312 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1312 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1312 "../src/Photo.vala"
	if (v_object) {
#line 1312 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1312 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1312 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 29502 "Photo.c"
	} else {
#line 1312 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 29506 "Photo.c"
	}
#line 1312 "../src/Photo.vala"
	if (old) {
#line 1312 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 29512 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass,
                                                                      gpointer klass_data)
{
#line 1312 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1312 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 29524 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self,
                                                                         gpointer klass)
{
	BackingPhotoRow* _tmp0_;
#line 1313 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1313 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1312 "../src/Photo.vala"
	self->ref_count = 1;
#line 29538 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1312 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1312 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1313 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1314 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 29553 "Photo.c"
}

static GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
	photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
}

GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__once)) {
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__once, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__once;
}

static gpointer
photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1312 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1312 "../src/Photo.vala"
	return instance;
#line 29588 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1312 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1312 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1312 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 29602 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass,
                                                      gpointer klass_data)
{
#line 1311 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1311 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 29614 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self,
                                                         gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 1322 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, (GDestroyNotify) photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1322 "../src/Photo.vala"
	self->list = (GeeCollection*) _tmp0_;
#line 1323 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 29628 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1311 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1322 "../src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1311 "../src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 29641 "Photo.c"
}

static GType
photo_reimport_raw_development_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
	GType photo_reimport_raw_development_state_impl_type_id;
	photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
	return photo_reimport_raw_development_state_impl_type_id;
}

static GType
photo_reimport_raw_development_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__once)) {
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = photo_reimport_raw_development_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__once, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__once;
}

static void
photo_class_init (PhotoClass * klass,
                  gpointer klass_data)
{
#line 97 "../src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 97 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &Photo_private_offset);
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = (void (*) (Photo*, GFile*, GFile*)) photo_real_notify_editable_replaced;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = (void (*) (Photo*)) photo_real_notify_raw_development_modified;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = (void (*) (Photo*)) photo_real_notify_baseline_replaced;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_master_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_editable_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_source_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_baseline_reimported;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) photo_real_internal_delete_backing;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, gint*)) photo_real_get_backing_files_state;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) photo_real_apply_user_metadata_for_reimport;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) photo_real_get_typename;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) photo_real_get_instance_id;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource*)) photo_real_get_source_id;
#line 97 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) photo_real_get_preferred_thumbnail_format;
#line 97 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) photo_real_create_thumbnail;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) photo_real_get_file;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) photo_real_get_master_file;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = (gint64 (*) (MediaSource*)) photo_real_get_timestamp;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) photo_real_get_event_id;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) photo_real_get_import_id;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) photo_real_get_master_md5;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) photo_real_commit_backlinks;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) photo_real_set_event_id;
#line 97 "../src/Photo.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) photo_real_to_string;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource*, DataSource*)) photo_real_equals;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) photo_real_get_filesize;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) photo_real_get_master_filesize;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (gint64 (*) (MediaSource*)) photo_real_get_exposure_time;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*) (MediaSource*)) photo_real_get_basename;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) photo_real_get_title;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) photo_real_get_comment;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) photo_real_set_title;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) photo_real_set_comment;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) photo_real_get_dimensions;
#line 97 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*) (PhotoSource*)) photo_real_get_metadata;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) photo_real_rotate;
#line 97 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoSource*, Scaling*, GError**)) photo_real_get_pixbuf;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) photo_real_has_user_generated_metadata;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) photo_real_set_user_metadata_for_export;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 97 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 97 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 97 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL] = g_signal_new ("editable-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL] = g_signal_new ("raw-development-modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL] = g_signal_new ("baseline-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 29785 "Photo.c"
}

static void
photo_dateable_interface_init (DateableIface * iface,
                               gpointer iface_data)
{
#line 97 "../src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 97 "../src/Photo.vala"
	iface->get_exposure_time = (gint64 (*) (Dateable*)) photo_real_get_exposure_time;
#line 97 "../src/Photo.vala"
	iface->set_exposure_time = (void (*) (Dateable*, gint64)) photo_real_set_exposure_time;
#line 29798 "Photo.c"
}

static void
photo_instance_init (Photo * self,
                     gpointer klass)
{
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 97 "../src/Photo.vala"
	self->priv = photo_get_instance_private (self);
#line 245 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 246 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 246 "../src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 247 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 247 "../src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 247 "../src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 248 "../src/Photo.vala"
	self->priv->transformer = NULL;
#line 249 "../src/Photo.vala"
	self->priv->adjustments = NULL;
#line 251 "../src/Photo.vala"
	self->priv->file_title = NULL;
#line 252 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 253 "../src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 254 "../src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 255 "../src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 257 "../src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 273 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_unmodified_precached);
#line 273 "../src/Photo.vala"
	self->priv->unmodified_precached = NULL;
#line 274 "../src/Photo.vala"
	self->priv->secs_since_access = NULL;
#line 277 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 277 "../src/Photo.vala"
	self->priv->developments = NULL;
#line 288 "../src/Photo.vala"
	self->backing_photo_row = NULL;
#line 29849 "Photo.c"
}

static void
photo_finalize (GObject * obj)
{
	Photo * self;
#line 97 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 245 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 245 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 246 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 247 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 247 "../src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 248 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 249 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 251 "../src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 252 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 253 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 254 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 255 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 273 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_unmodified_precached);
#line 273 "../src/Photo.vala"
	_g_object_unref0 (self->priv->unmodified_precached);
#line 274 "../src/Photo.vala"
	_g_timer_destroy0 (self->priv->secs_since_access);
#line 277 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 277 "../src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 288 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 97 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 29896 "Photo.c"
}

static GType
photo_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
	static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType photo_type_id;
	photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
	Photo_private_offset = g_type_add_instance_private (photo_type_id, sizeof (PhotoPrivate));
	return photo_type_id;
}

GType
photo_get_type (void)
{
	static volatile gsize photo_type_id__once = 0;
	if (g_once_init_enter (&photo_type_id__once)) {
		GType photo_type_id;
		photo_type_id = photo_get_type_once ();
		g_once_init_leave (&photo_type_id__once, photo_type_id);
	}
	return photo_type_id__once;
}

static void
_vala_photo_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "../src/Photo.vala"
	switch (property_id) {
#line 29933 "Photo.c"
		default:
#line 97 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "../src/Photo.vala"
		break;
#line 29939 "Photo.c"
	}
}

static void
_vala_photo_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "../src/Photo.vala"
	switch (property_id) {
#line 29953 "Photo.c"
		default:
#line 97 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "../src/Photo.vala"
		break;
#line 29959 "Photo.c"
	}
}

static inline gpointer
library_photo_source_collection_get_instance_private (LibraryPhotoSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceCollection_private_offset);
}

static GType
library_photo_source_collection_state_get_type_once (void)
{
	static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
	GType library_photo_source_collection_state_type_id;
	library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
	return library_photo_source_collection_state_type_id;
}

GType
library_photo_source_collection_state_get_type (void)
{
	static volatile gsize library_photo_source_collection_state_type_id__once = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__once)) {
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = library_photo_source_collection_state_get_type_once ();
		g_once_init_leave (&library_photo_source_collection_state_type_id__once, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__once;
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 4540 "../src/Photo.vala"
	return result;
#line 29998 "Photo.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4540 "../src/Photo.vala"
	return result;
#line 30010 "Photo.c"
}

static gint
_int64_compare_gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4544 "../src/Photo.vala"
	return result;
#line 30022 "Photo.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 4544 "../src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4544 "../src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4544 "../src/Photo.vala"
	return dup;
#line 30035 "Photo.c"
}

static gboolean
_int64_equal_gee_equal_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4546 "../src/Photo.vala"
	return result;
#line 30047 "Photo.c"
}

static gint64
_photo_get_photo_key_get_source_database_key (DataSource* source,
                                              gpointer self)
{
	gint64 result;
	result = photo_get_photo_key (source);
#line 4566 "../src/Photo.vala"
	return result;
#line 30058 "Photo.c"
}

static void
_library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                    GeeCollection* added,
                                                                                                    GeeCollection* removed,
                                                                                                    gpointer self)
{
#line 4568 "../src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 30069 "Photo.c"
}

static void
_library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                   GeeCollection* added,
                                                                                                   GeeCollection* removed,
                                                                                                   gpointer self)
{
#line 4569 "../src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 30080 "Photo.c"
}

LibraryPhotoSourceCollection*
library_photo_source_collection_construct (GType object_type)
{
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4566 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4568 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4568 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4568 "../src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp1_, "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4568 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4569 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4569 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4569 "../src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp3_, "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4569 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4565 "../src/Photo.vala"
	return self;
#line 30111 "Photo.c"
}

LibraryPhotoSourceCollection*
library_photo_source_collection_new (void)
{
#line 4565 "../src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 30119 "Photo.c"
}

static gboolean
_library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4573 "../src/Photo.vala"
	return result;
#line 30131 "Photo.c"
}

static MediaSourceHoldingTank*
library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	LibraryPhotoSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* result;
#line 4572 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4573 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4573 "../src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4573 "../src/Photo.vala"
	return result;
#line 30148 "Photo.c"
}

static gboolean
_library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4577 "../src/Photo.vala"
	return result;
#line 30160 "Photo.c"
}

static MediaSourceHoldingTank*
library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	LibraryPhotoSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* result;
#line 4576 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4577 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4577 "../src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4577 "../src/Photo.vala"
	return result;
#line 30177 "Photo.c"
}

static MediaMonitor*
library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                           Workers* workers,
                                                           GCancellable* cancellable)
{
	LibraryPhotoSourceCollection * self;
	PhotoMonitor* _tmp0_;
	MediaMonitor* result;
#line 4580 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4580 "../src/Photo.vala"
	g_return_val_if_fail (workers != NULL, NULL);
#line 4580 "../src/Photo.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 4581 "../src/Photo.vala"
	_tmp0_ = photo_monitor_new (workers, cancellable);
#line 4581 "../src/Photo.vala"
	result = (MediaMonitor*) _tmp0_;
#line 4581 "../src/Photo.vala"
	return result;
#line 30200 "Photo.c"
}

static gboolean
library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                           DataSource* source)
{
	LibraryPhotoSourceCollection * self;
	gboolean result;
#line 4584 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4584 "../src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4585 "../src/Photo.vala"
	result = IS_LIBRARY_PHOTO (source);
#line 4585 "../src/Photo.vala"
	return result;
#line 30217 "Photo.c"
}

static gchar*
library_photo_source_collection_real_get_typename (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	gchar* _tmp0_;
	gchar* result;
#line 4588 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4589 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4589 "../src/Photo.vala"
	result = _tmp0_;
#line 4589 "../src/Photo.vala"
	return result;
#line 30234 "Photo.c"
}

static gboolean
library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                         GFile* file)
{
	LibraryPhotoSourceCollection * self;
	gboolean result;
#line 4592 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4592 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 4593 "../src/Photo.vala"
	result = photo_file_format_is_file_supported (file);
#line 4593 "../src/Photo.vala"
	return result;
#line 30251 "Photo.c"
}

static void
_library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                               GFile* old_file,
                                                                               GFile* new_file,
                                                                               gpointer self)
{
#line 4606 "../src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 30262 "Photo.c"
}

static void
_library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                             gpointer self)
{
#line 4615 "../src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 30271 "Photo.c"
}

static void
library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                              GeeIterable* added,
                                                              GeeIterable* removed)
{
	LibraryPhotoSourceCollection * self;
#line 4596 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4598 "../src/Photo.vala"
	if (added != NULL) {
#line 30284 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 4599 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 4599 "../src/Photo.vala"
			_object_it = _tmp0_;
#line 4599 "../src/Photo.vala"
			while (TRUE) {
#line 30294 "Photo.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp4_;
				LibraryPhoto* _tmp5_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				LibraryPhoto* _tmp12_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				LibraryPhoto* _tmp24_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoRow* _tmp27_;
				gint64 _tmp28_;
				gint64 _tmp29_ = 0LL;
				LibraryPhoto* _tmp30_;
				BackingPhotoRow* _tmp31_;
				BackingPhotoRow* _tmp32_;
				gboolean _tmp33_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp37_;
				LibraryPhoto* _tmp38_;
				GeeHashMap* _tmp39_;
				LibraryPhoto* _tmp40_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp45_;
				GeeCollection* _tmp46_;
				GeeCollection* _tmp47_;
#line 4599 "../src/Photo.vala"
				_tmp1_ = _object_it;
#line 4599 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 4599 "../src/Photo.vala"
					break;
#line 30337 "Photo.c"
				}
#line 4599 "../src/Photo.vala"
				_tmp2_ = _object_it;
#line 4599 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 4599 "../src/Photo.vala"
				object = (DataObject*) _tmp3_;
#line 4600 "../src/Photo.vala"
				_tmp4_ = object;
#line 4600 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4600 "../src/Photo.vala"
				photo = _tmp5_;
#line 4602 "../src/Photo.vala"
				_tmp6_ = photo;
#line 4602 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file ((Photo*) _tmp6_);
#line 4602 "../src/Photo.vala"
				editable = _tmp7_;
#line 4603 "../src/Photo.vala"
				_tmp8_ = editable;
#line 4603 "../src/Photo.vala"
				if (_tmp8_ != NULL) {
#line 30361 "Photo.c"
					GeeHashMap* _tmp9_;
					GFile* _tmp10_;
					LibraryPhoto* _tmp11_;
#line 4604 "../src/Photo.vala"
					_tmp9_ = self->priv->by_editable_file;
#line 4604 "../src/Photo.vala"
					_tmp10_ = editable;
#line 4604 "../src/Photo.vala"
					_tmp11_ = photo;
#line 4604 "../src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp10_, _tmp11_);
#line 30373 "Photo.c"
				}
#line 4606 "../src/Photo.vala"
				_tmp12_ = photo;
#line 4606 "../src/Photo.vala"
				g_signal_connect ((Photo*) _tmp12_, "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4608 "../src/Photo.vala"
				_tmp13_ = photo;
#line 4608 "../src/Photo.vala"
				_tmp14_ = photo_get_raw_developer_files ((Photo*) _tmp13_);
#line 4608 "../src/Photo.vala"
				raw_list = _tmp14_;
#line 4609 "../src/Photo.vala"
				_tmp15_ = raw_list;
#line 4609 "../src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 30389 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp16_;
						GeeIterator* _tmp17_;
#line 4610 "../src/Photo.vala"
						_tmp16_ = raw_list;
#line 4610 "../src/Photo.vala"
						_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 4610 "../src/Photo.vala"
						_f_it = _tmp17_;
#line 4610 "../src/Photo.vala"
						while (TRUE) {
#line 30402 "Photo.c"
							GeeIterator* _tmp18_;
							GFile* f = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
							GeeHashMap* _tmp21_;
							GFile* _tmp22_;
							LibraryPhoto* _tmp23_;
#line 4610 "../src/Photo.vala"
							_tmp18_ = _f_it;
#line 4610 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp18_)) {
#line 4610 "../src/Photo.vala"
								break;
#line 30416 "Photo.c"
							}
#line 4610 "../src/Photo.vala"
							_tmp19_ = _f_it;
#line 4610 "../src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 4610 "../src/Photo.vala"
							f = (GFile*) _tmp20_;
#line 4611 "../src/Photo.vala"
							_tmp21_ = self->priv->by_raw_development_file;
#line 4611 "../src/Photo.vala"
							_tmp22_ = f;
#line 4611 "../src/Photo.vala"
							_tmp23_ = photo;
#line 4611 "../src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, _tmp22_, _tmp23_);
#line 4610 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 30434 "Photo.c"
						}
#line 4610 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 30438 "Photo.c"
					}
				}
#line 4615 "../src/Photo.vala"
				_tmp24_ = photo;
#line 4615 "../src/Photo.vala"
				g_signal_connect ((Photo*) _tmp24_, "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4617 "../src/Photo.vala"
				_tmp25_ = photo;
#line 4617 "../src/Photo.vala"
				_tmp26_ = photo_get_master_photo_row ((Photo*) _tmp25_);
#line 4617 "../src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 4617 "../src/Photo.vala"
				_tmp28_ = _tmp27_->filesize;
#line 4617 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp27_);
#line 4617 "../src/Photo.vala"
				master_filesize = _tmp28_;
#line 4618 "../src/Photo.vala"
				_tmp30_ = photo;
#line 4618 "../src/Photo.vala"
				_tmp31_ = photo_get_editable_photo_row ((Photo*) _tmp30_);
#line 4618 "../src/Photo.vala"
				_tmp32_ = _tmp31_;
#line 4618 "../src/Photo.vala"
				_tmp33_ = _tmp32_ != NULL;
#line 4618 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp32_);
#line 4618 "../src/Photo.vala"
				if (_tmp33_) {
#line 30469 "Photo.c"
					LibraryPhoto* _tmp34_;
					BackingPhotoRow* _tmp35_;
					BackingPhotoRow* _tmp36_;
#line 4619 "../src/Photo.vala"
					_tmp34_ = photo;
#line 4619 "../src/Photo.vala"
					_tmp35_ = photo_get_editable_photo_row ((Photo*) _tmp34_);
#line 4619 "../src/Photo.vala"
					_tmp36_ = _tmp35_;
#line 4619 "../src/Photo.vala"
					_tmp29_ = _tmp36_->filesize;
#line 4619 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp36_);
#line 30483 "Photo.c"
				} else {
#line 4620 "../src/Photo.vala"
					_tmp29_ = (gint64) -1;
#line 30487 "Photo.c"
				}
#line 4618 "../src/Photo.vala"
				editable_filesize = _tmp29_;
#line 4621 "../src/Photo.vala"
				_tmp37_ = self->priv->filesize_to_photo;
#line 4621 "../src/Photo.vala"
				_tmp38_ = photo;
#line 4621 "../src/Photo.vala"
				gee_multi_map_set (_tmp37_, &master_filesize, _tmp38_);
#line 4622 "../src/Photo.vala"
				_tmp39_ = self->priv->photo_to_master_filesize;
#line 4622 "../src/Photo.vala"
				_tmp40_ = photo;
#line 4622 "../src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, _tmp40_, &master_filesize);
#line 4623 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 30505 "Photo.c"
					GeeMultiMap* _tmp41_;
					LibraryPhoto* _tmp42_;
					GeeHashMap* _tmp43_;
					LibraryPhoto* _tmp44_;
#line 4624 "../src/Photo.vala"
					_tmp41_ = self->priv->filesize_to_photo;
#line 4624 "../src/Photo.vala"
					_tmp42_ = photo;
#line 4624 "../src/Photo.vala"
					gee_multi_map_set (_tmp41_, &editable_filesize, _tmp42_);
#line 4625 "../src/Photo.vala"
					_tmp43_ = self->priv->photo_to_editable_filesize;
#line 4625 "../src/Photo.vala"
					_tmp44_ = photo;
#line 4625 "../src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp43_, _tmp44_, &editable_filesize);
#line 30522 "Photo.c"
				}
#line 4628 "../src/Photo.vala"
				_tmp45_ = photo;
#line 4628 "../src/Photo.vala"
				_tmp46_ = photo_get_raw_development_photo_rows ((Photo*) _tmp45_);
#line 4628 "../src/Photo.vala"
				raw_rows = _tmp46_;
#line 4629 "../src/Photo.vala"
				_tmp47_ = raw_rows;
#line 4629 "../src/Photo.vala"
				if (_tmp47_ != NULL) {
#line 30534 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp48_;
						GeeIterator* _tmp49_;
#line 4630 "../src/Photo.vala"
						_tmp48_ = raw_rows;
#line 4630 "../src/Photo.vala"
						_tmp49_ = gee_iterable_iterator ((GeeIterable*) _tmp48_);
#line 4630 "../src/Photo.vala"
						_row_it = _tmp49_;
#line 4630 "../src/Photo.vala"
						while (TRUE) {
#line 30547 "Photo.c"
							GeeIterator* _tmp50_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp51_;
							gpointer _tmp52_;
							BackingPhotoRow* _tmp53_;
#line 4630 "../src/Photo.vala"
							_tmp50_ = _row_it;
#line 4630 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp50_)) {
#line 4630 "../src/Photo.vala"
								break;
#line 30559 "Photo.c"
							}
#line 4630 "../src/Photo.vala"
							_tmp51_ = _row_it;
#line 4630 "../src/Photo.vala"
							_tmp52_ = gee_iterator_get (_tmp51_);
#line 4630 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp52_;
#line 4631 "../src/Photo.vala"
							_tmp53_ = row;
#line 4631 "../src/Photo.vala"
							if (_tmp53_->filesize >= ((gint64) 0)) {
#line 30571 "Photo.c"
								GeeMultiMap* _tmp54_;
								BackingPhotoRow* _tmp55_;
								LibraryPhoto* _tmp56_;
								GeeMultiMap* _tmp57_;
								LibraryPhoto* _tmp58_;
								BackingPhotoRow* _tmp59_;
#line 4632 "../src/Photo.vala"
								_tmp54_ = self->priv->filesize_to_photo;
#line 4632 "../src/Photo.vala"
								_tmp55_ = row;
#line 4632 "../src/Photo.vala"
								_tmp56_ = photo;
#line 4632 "../src/Photo.vala"
								gee_multi_map_set (_tmp54_, &_tmp55_->filesize, _tmp56_);
#line 4633 "../src/Photo.vala"
								_tmp57_ = self->priv->photo_to_raw_development_filesize;
#line 4633 "../src/Photo.vala"
								_tmp58_ = photo;
#line 4633 "../src/Photo.vala"
								_tmp59_ = row;
#line 4633 "../src/Photo.vala"
								gee_multi_map_set (_tmp57_, _tmp58_, &_tmp59_->filesize);
#line 30594 "Photo.c"
							}
#line 4630 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 30598 "Photo.c"
						}
#line 4630 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 30602 "Photo.c"
					}
				}
#line 4599 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4599 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4599 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4599 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4599 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 30615 "Photo.c"
			}
#line 4599 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 30619 "Photo.c"
		}
	}
#line 4640 "../src/Photo.vala"
	if (removed != NULL) {
#line 30624 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp60_;
#line 4641 "../src/Photo.vala"
			_tmp60_ = gee_iterable_iterator (removed);
#line 4641 "../src/Photo.vala"
			_object_it = _tmp60_;
#line 4641 "../src/Photo.vala"
			while (TRUE) {
#line 30634 "Photo.c"
				GeeIterator* _tmp61_;
				DataObject* object = NULL;
				GeeIterator* _tmp62_;
				gpointer _tmp63_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp64_;
				LibraryPhoto* _tmp65_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp66_;
				GFile* _tmp67_;
				GFile* _tmp68_;
				LibraryPhoto* _tmp74_;
				guint _tmp75_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp76_;
				GeeCollection* _tmp77_;
				GeeCollection* _tmp78_;
				LibraryPhoto* _tmp86_;
				guint _tmp87_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp88_;
				BackingPhotoRow* _tmp89_;
				BackingPhotoRow* _tmp90_;
				gint64 _tmp91_;
				gint64 _tmp92_ = 0LL;
				LibraryPhoto* _tmp93_;
				BackingPhotoRow* _tmp94_;
				BackingPhotoRow* _tmp95_;
				gboolean _tmp96_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp100_;
				LibraryPhoto* _tmp101_;
				GeeHashMap* _tmp102_;
				LibraryPhoto* _tmp103_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp108_;
				GeeCollection* _tmp109_;
				GeeCollection* _tmp110_;
#line 4641 "../src/Photo.vala"
				_tmp61_ = _object_it;
#line 4641 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp61_)) {
#line 4641 "../src/Photo.vala"
					break;
#line 30679 "Photo.c"
				}
#line 4641 "../src/Photo.vala"
				_tmp62_ = _object_it;
#line 4641 "../src/Photo.vala"
				_tmp63_ = gee_iterator_get (_tmp62_);
#line 4641 "../src/Photo.vala"
				object = (DataObject*) _tmp63_;
#line 4642 "../src/Photo.vala"
				_tmp64_ = object;
#line 4642 "../src/Photo.vala"
				_tmp65_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4642 "../src/Photo.vala"
				photo = _tmp65_;
#line 4644 "../src/Photo.vala"
				_tmp66_ = photo;
#line 4644 "../src/Photo.vala"
				_tmp67_ = photo_get_editable_file ((Photo*) _tmp66_);
#line 4644 "../src/Photo.vala"
				editable = _tmp67_;
#line 4645 "../src/Photo.vala"
				_tmp68_ = editable;
#line 4645 "../src/Photo.vala"
				if (_tmp68_ != NULL) {
#line 30703 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp69_;
					LibraryPhoto* _tmp70_;
					GFile* _tmp71_;
					GFile* _tmp72_;
					gboolean _tmp73_;
#line 4646 "../src/Photo.vala"
					_tmp69_ = self->priv->by_editable_file;
#line 4646 "../src/Photo.vala"
					_tmp70_ = photo;
#line 4646 "../src/Photo.vala"
					_tmp71_ = photo_get_editable_file ((Photo*) _tmp70_);
#line 4646 "../src/Photo.vala"
					_tmp72_ = _tmp71_;
#line 4646 "../src/Photo.vala"
					_tmp73_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp69_, _tmp72_, NULL);
#line 4646 "../src/Photo.vala"
					_g_object_unref0 (_tmp72_);
#line 4646 "../src/Photo.vala"
					is_removed = _tmp73_;
#line 4647 "../src/Photo.vala"
					_vala_assert (is_removed, "is_removed");
#line 30726 "Photo.c"
				}
#line 4649 "../src/Photo.vala"
				_tmp74_ = photo;
#line 4649 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp75_, NULL, FALSE);
#line 4649 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp74_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp75_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4651 "../src/Photo.vala"
				_tmp76_ = photo;
#line 4651 "../src/Photo.vala"
				_tmp77_ = photo_get_raw_developer_files ((Photo*) _tmp76_);
#line 4651 "../src/Photo.vala"
				raw_list = _tmp77_;
#line 4652 "../src/Photo.vala"
				_tmp78_ = raw_list;
#line 4652 "../src/Photo.vala"
				if (_tmp78_ != NULL) {
#line 30744 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp79_;
						GeeIterator* _tmp80_;
#line 4653 "../src/Photo.vala"
						_tmp79_ = raw_list;
#line 4653 "../src/Photo.vala"
						_tmp80_ = gee_iterable_iterator ((GeeIterable*) _tmp79_);
#line 4653 "../src/Photo.vala"
						_f_it = _tmp80_;
#line 4653 "../src/Photo.vala"
						while (TRUE) {
#line 30757 "Photo.c"
							GeeIterator* _tmp81_;
							GFile* f = NULL;
							GeeIterator* _tmp82_;
							gpointer _tmp83_;
							GeeHashMap* _tmp84_;
							GFile* _tmp85_;
#line 4653 "../src/Photo.vala"
							_tmp81_ = _f_it;
#line 4653 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp81_)) {
#line 4653 "../src/Photo.vala"
								break;
#line 30770 "Photo.c"
							}
#line 4653 "../src/Photo.vala"
							_tmp82_ = _f_it;
#line 4653 "../src/Photo.vala"
							_tmp83_ = gee_iterator_get (_tmp82_);
#line 4653 "../src/Photo.vala"
							f = (GFile*) _tmp83_;
#line 4654 "../src/Photo.vala"
							_tmp84_ = self->priv->by_raw_development_file;
#line 4654 "../src/Photo.vala"
							_tmp85_ = f;
#line 4654 "../src/Photo.vala"
							gee_abstract_map_unset ((GeeAbstractMap*) _tmp84_, _tmp85_, NULL);
#line 4653 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 30786 "Photo.c"
						}
#line 4653 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 30790 "Photo.c"
					}
				}
#line 4658 "../src/Photo.vala"
				_tmp86_ = photo;
#line 4658 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp87_, NULL, FALSE);
#line 4658 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp86_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp87_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4660 "../src/Photo.vala"
				_tmp88_ = photo;
#line 4660 "../src/Photo.vala"
				_tmp89_ = photo_get_master_photo_row ((Photo*) _tmp88_);
#line 4660 "../src/Photo.vala"
				_tmp90_ = _tmp89_;
#line 4660 "../src/Photo.vala"
				_tmp91_ = _tmp90_->filesize;
#line 4660 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp90_);
#line 4660 "../src/Photo.vala"
				master_filesize = _tmp91_;
#line 4661 "../src/Photo.vala"
				_tmp93_ = photo;
#line 4661 "../src/Photo.vala"
				_tmp94_ = photo_get_editable_photo_row ((Photo*) _tmp93_);
#line 4661 "../src/Photo.vala"
				_tmp95_ = _tmp94_;
#line 4661 "../src/Photo.vala"
				_tmp96_ = _tmp95_ != NULL;
#line 4661 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp95_);
#line 4661 "../src/Photo.vala"
				if (_tmp96_) {
#line 30823 "Photo.c"
					LibraryPhoto* _tmp97_;
					BackingPhotoRow* _tmp98_;
					BackingPhotoRow* _tmp99_;
#line 4662 "../src/Photo.vala"
					_tmp97_ = photo;
#line 4662 "../src/Photo.vala"
					_tmp98_ = photo_get_editable_photo_row ((Photo*) _tmp97_);
#line 4662 "../src/Photo.vala"
					_tmp99_ = _tmp98_;
#line 4662 "../src/Photo.vala"
					_tmp92_ = _tmp99_->filesize;
#line 4662 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp99_);
#line 30837 "Photo.c"
				} else {
#line 4663 "../src/Photo.vala"
					_tmp92_ = (gint64) -1;
#line 30841 "Photo.c"
				}
#line 4661 "../src/Photo.vala"
				editable_filesize = _tmp92_;
#line 4664 "../src/Photo.vala"
				_tmp100_ = self->priv->filesize_to_photo;
#line 4664 "../src/Photo.vala"
				_tmp101_ = photo;
#line 4664 "../src/Photo.vala"
				gee_multi_map_remove (_tmp100_, &master_filesize, _tmp101_);
#line 4665 "../src/Photo.vala"
				_tmp102_ = self->priv->photo_to_master_filesize;
#line 4665 "../src/Photo.vala"
				_tmp103_ = photo;
#line 4665 "../src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp102_, _tmp103_, NULL);
#line 4666 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 30859 "Photo.c"
					GeeMultiMap* _tmp104_;
					LibraryPhoto* _tmp105_;
					GeeHashMap* _tmp106_;
					LibraryPhoto* _tmp107_;
#line 4667 "../src/Photo.vala"
					_tmp104_ = self->priv->filesize_to_photo;
#line 4667 "../src/Photo.vala"
					_tmp105_ = photo;
#line 4667 "../src/Photo.vala"
					gee_multi_map_remove (_tmp104_, &editable_filesize, _tmp105_);
#line 4668 "../src/Photo.vala"
					_tmp106_ = self->priv->photo_to_editable_filesize;
#line 4668 "../src/Photo.vala"
					_tmp107_ = photo;
#line 4668 "../src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp106_, _tmp107_, NULL);
#line 30876 "Photo.c"
				}
#line 4671 "../src/Photo.vala"
				_tmp108_ = photo;
#line 4671 "../src/Photo.vala"
				_tmp109_ = photo_get_raw_development_photo_rows ((Photo*) _tmp108_);
#line 4671 "../src/Photo.vala"
				raw_rows = _tmp109_;
#line 4672 "../src/Photo.vala"
				_tmp110_ = raw_rows;
#line 4672 "../src/Photo.vala"
				if (_tmp110_ != NULL) {
#line 30888 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp111_;
						GeeIterator* _tmp112_;
#line 4673 "../src/Photo.vala"
						_tmp111_ = raw_rows;
#line 4673 "../src/Photo.vala"
						_tmp112_ = gee_iterable_iterator ((GeeIterable*) _tmp111_);
#line 4673 "../src/Photo.vala"
						_row_it = _tmp112_;
#line 4673 "../src/Photo.vala"
						while (TRUE) {
#line 30901 "Photo.c"
							GeeIterator* _tmp113_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp114_;
							gpointer _tmp115_;
							BackingPhotoRow* _tmp116_;
#line 4673 "../src/Photo.vala"
							_tmp113_ = _row_it;
#line 4673 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp113_)) {
#line 4673 "../src/Photo.vala"
								break;
#line 30913 "Photo.c"
							}
#line 4673 "../src/Photo.vala"
							_tmp114_ = _row_it;
#line 4673 "../src/Photo.vala"
							_tmp115_ = gee_iterator_get (_tmp114_);
#line 4673 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp115_;
#line 4674 "../src/Photo.vala"
							_tmp116_ = row;
#line 4674 "../src/Photo.vala"
							if (_tmp116_->filesize >= ((gint64) 0)) {
#line 30925 "Photo.c"
								GeeMultiMap* _tmp117_;
								BackingPhotoRow* _tmp118_;
								LibraryPhoto* _tmp119_;
								GeeMultiMap* _tmp120_;
								LibraryPhoto* _tmp121_;
								BackingPhotoRow* _tmp122_;
#line 4675 "../src/Photo.vala"
								_tmp117_ = self->priv->filesize_to_photo;
#line 4675 "../src/Photo.vala"
								_tmp118_ = row;
#line 4675 "../src/Photo.vala"
								_tmp119_ = photo;
#line 4675 "../src/Photo.vala"
								gee_multi_map_remove (_tmp117_, &_tmp118_->filesize, _tmp119_);
#line 4676 "../src/Photo.vala"
								_tmp120_ = self->priv->photo_to_raw_development_filesize;
#line 4676 "../src/Photo.vala"
								_tmp121_ = photo;
#line 4676 "../src/Photo.vala"
								_tmp122_ = row;
#line 4676 "../src/Photo.vala"
								gee_multi_map_remove (_tmp120_, _tmp121_, &_tmp122_->filesize);
#line 30948 "Photo.c"
							}
#line 4673 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 30952 "Photo.c"
						}
#line 4673 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 30956 "Photo.c"
					}
				}
#line 4641 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4641 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4641 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4641 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4641 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 30969 "Photo.c"
			}
#line 4641 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 30973 "Photo.c"
		}
	}
#line 4683 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), added, removed);
#line 30978 "Photo.c"
}

static void
library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                      Photo* photo,
                                                      GFile* old_file,
                                                      GFile* new_file)
{
#line 4686 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4686 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4687 "../src/Photo.vala"
	if (old_file != NULL) {
#line 30993 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp0_;
#line 4688 "../src/Photo.vala"
		_tmp0_ = self->priv->by_editable_file;
#line 4688 "../src/Photo.vala"
		is_removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, old_file, NULL);
#line 4689 "../src/Photo.vala"
		_vala_assert (is_removed, "is_removed");
#line 31002 "Photo.c"
	}
#line 4692 "../src/Photo.vala"
	if (new_file != NULL) {
#line 31006 "Photo.c"
		GeeHashMap* _tmp1_;
#line 4693 "../src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 4693 "../src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, new_file, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 31012 "Photo.c"
	}
}

static void
library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                             Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp19_;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp30_;
	GeeCollection* _tmp31_;
	GeeCollection* _tmp32_;
#line 4697 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4697 "../src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 4698 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 4698 "../src/Photo.vala"
	photo = _tmp0_;
#line 4699 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4699 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4700 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4700 "../src/Photo.vala"
		return;
#line 31049 "Photo.c"
	}
#line 4704 "../src/Photo.vala"
	_tmp2_ = self->priv->photo_to_raw_development_filesize;
#line 4704 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4704 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 31057 "Photo.c"
		GeeMultiMap* _tmp17_;
		LibraryPhoto* _tmp18_;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 4705 "../src/Photo.vala"
			_tmp4_ = self->priv->photo_to_raw_development_filesize;
#line 4705 "../src/Photo.vala"
			_tmp5_ = photo;
#line 4705 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 4705 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 4705 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 4705 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4705 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 4705 "../src/Photo.vala"
			_s_it = _tmp9_;
#line 4705 "../src/Photo.vala"
			while (TRUE) {
#line 31086 "Photo.c"
				GeeIterator* _tmp10_;
				gint64 s = 0LL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				gint64* _tmp13_;
				gint64 _tmp14_;
				GeeMultiMap* _tmp15_;
				LibraryPhoto* _tmp16_;
#line 4705 "../src/Photo.vala"
				_tmp10_ = _s_it;
#line 4705 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 4705 "../src/Photo.vala"
					break;
#line 31101 "Photo.c"
				}
#line 4705 "../src/Photo.vala"
				_tmp11_ = _s_it;
#line 4705 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 4705 "../src/Photo.vala"
				_tmp13_ = (gint64*) _tmp12_;
#line 4705 "../src/Photo.vala"
				_tmp14_ = *_tmp13_;
#line 4705 "../src/Photo.vala"
				_g_free0 (_tmp13_);
#line 4705 "../src/Photo.vala"
				s = _tmp14_;
#line 4706 "../src/Photo.vala"
				_tmp15_ = self->priv->filesize_to_photo;
#line 4706 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4706 "../src/Photo.vala"
				gee_multi_map_remove (_tmp15_, &s, _tmp16_);
#line 31121 "Photo.c"
			}
#line 4705 "../src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 31125 "Photo.c"
		}
#line 4708 "../src/Photo.vala"
		_tmp17_ = self->priv->photo_to_raw_development_filesize;
#line 4708 "../src/Photo.vala"
		_tmp18_ = photo;
#line 4708 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp17_, _tmp18_);
#line 31133 "Photo.c"
	}
#line 4712 "../src/Photo.vala"
	_tmp19_ = photo;
#line 4712 "../src/Photo.vala"
	_tmp20_ = photo_get_raw_developer_files ((Photo*) _tmp19_);
#line 4712 "../src/Photo.vala"
	raw_list = _tmp20_;
#line 4713 "../src/Photo.vala"
	_tmp21_ = raw_list;
#line 4713 "../src/Photo.vala"
	if (_tmp21_ != NULL) {
#line 31145 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp22_;
			GeeIterator* _tmp23_;
#line 4714 "../src/Photo.vala"
			_tmp22_ = raw_list;
#line 4714 "../src/Photo.vala"
			_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 4714 "../src/Photo.vala"
			_f_it = _tmp23_;
#line 4714 "../src/Photo.vala"
			while (TRUE) {
#line 31158 "Photo.c"
				GeeIterator* _tmp24_;
				GFile* f = NULL;
				GeeIterator* _tmp25_;
				gpointer _tmp26_;
				GeeHashMap* _tmp27_;
				GFile* _tmp28_;
				LibraryPhoto* _tmp29_;
#line 4714 "../src/Photo.vala"
				_tmp24_ = _f_it;
#line 4714 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp24_)) {
#line 4714 "../src/Photo.vala"
					break;
#line 31172 "Photo.c"
				}
#line 4714 "../src/Photo.vala"
				_tmp25_ = _f_it;
#line 4714 "../src/Photo.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 4714 "../src/Photo.vala"
				f = (GFile*) _tmp26_;
#line 4715 "../src/Photo.vala"
				_tmp27_ = self->priv->by_raw_development_file;
#line 4715 "../src/Photo.vala"
				_tmp28_ = f;
#line 4715 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4715 "../src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp27_, _tmp28_, _tmp29_);
#line 4714 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 31190 "Photo.c"
			}
#line 4714 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 31194 "Photo.c"
		}
	}
#line 4719 "../src/Photo.vala"
	_tmp30_ = photo;
#line 4719 "../src/Photo.vala"
	_tmp31_ = photo_get_raw_development_photo_rows ((Photo*) _tmp30_);
#line 4719 "../src/Photo.vala"
	raw_rows = _tmp31_;
#line 4720 "../src/Photo.vala"
	_tmp32_ = raw_rows;
#line 4720 "../src/Photo.vala"
	if (_tmp32_ != NULL) {
#line 31207 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp33_;
			GeeIterator* _tmp34_;
#line 4721 "../src/Photo.vala"
			_tmp33_ = raw_rows;
#line 4721 "../src/Photo.vala"
			_tmp34_ = gee_iterable_iterator ((GeeIterable*) _tmp33_);
#line 4721 "../src/Photo.vala"
			_row_it = _tmp34_;
#line 4721 "../src/Photo.vala"
			while (TRUE) {
#line 31220 "Photo.c"
				GeeIterator* _tmp35_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp36_;
				gpointer _tmp37_;
				BackingPhotoRow* _tmp38_;
#line 4721 "../src/Photo.vala"
				_tmp35_ = _row_it;
#line 4721 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp35_)) {
#line 4721 "../src/Photo.vala"
					break;
#line 31232 "Photo.c"
				}
#line 4721 "../src/Photo.vala"
				_tmp36_ = _row_it;
#line 4721 "../src/Photo.vala"
				_tmp37_ = gee_iterator_get (_tmp36_);
#line 4721 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp37_;
#line 4722 "../src/Photo.vala"
				_tmp38_ = row;
#line 4722 "../src/Photo.vala"
				if (_tmp38_->filesize > ((gint64) 0)) {
#line 31244 "Photo.c"
					GeeMultiMap* _tmp39_;
					BackingPhotoRow* _tmp40_;
					LibraryPhoto* _tmp41_;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					BackingPhotoRow* _tmp44_;
#line 4723 "../src/Photo.vala"
					_tmp39_ = self->priv->filesize_to_photo;
#line 4723 "../src/Photo.vala"
					_tmp40_ = row;
#line 4723 "../src/Photo.vala"
					_tmp41_ = photo;
#line 4723 "../src/Photo.vala"
					gee_multi_map_set (_tmp39_, &_tmp40_->filesize, _tmp41_);
#line 4724 "../src/Photo.vala"
					_tmp42_ = self->priv->photo_to_raw_development_filesize;
#line 4724 "../src/Photo.vala"
					_tmp43_ = photo;
#line 4724 "../src/Photo.vala"
					_tmp44_ = row;
#line 4724 "../src/Photo.vala"
					gee_multi_map_set (_tmp42_, _tmp43_, &_tmp44_->filesize);
#line 31267 "Photo.c"
				}
#line 4721 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 31271 "Photo.c"
			}
#line 4721 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 31275 "Photo.c"
		}
	}
#line 4697 "../src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4697 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4697 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 31284 "Photo.c"
}

static gpointer
__int64_dup0 (gpointer self)
{
#line 4740 "../src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 31292 "Photo.c"
}

static void
library_photo_source_collection_real_items_altered (DataCollection* base,
                                                    GeeMap* items)
{
	LibraryPhotoSourceCollection * self;
#line 4730 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4730 "../src/Photo.vala"
	g_return_if_fail (items != NULL);
#line 31304 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4731 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 4731 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4731 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4731 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 4731 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4731 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4731 "../src/Photo.vala"
		_object_it = _tmp4_;
#line 4731 "../src/Photo.vala"
		while (TRUE) {
#line 31328 "Photo.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp10_;
			LibraryPhoto* _tmp11_;
			gboolean _tmp12_ = FALSE;
			Alteration* _tmp13_;
#line 4731 "../src/Photo.vala"
			_tmp5_ = _object_it;
#line 4731 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4731 "../src/Photo.vala"
				break;
#line 31347 "Photo.c"
			}
#line 4731 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 4731 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4731 "../src/Photo.vala"
			object = (DataObject*) _tmp7_;
#line 4732 "../src/Photo.vala"
			_tmp8_ = object;
#line 4732 "../src/Photo.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 4732 "../src/Photo.vala"
			alteration = (Alteration*) _tmp9_;
#line 4734 "../src/Photo.vala"
			_tmp10_ = object;
#line 4734 "../src/Photo.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4734 "../src/Photo.vala"
			photo = _tmp11_;
#line 4736 "../src/Photo.vala"
			_tmp13_ = alteration;
#line 4736 "../src/Photo.vala"
			if (alteration_has_detail (_tmp13_, "image", "master")) {
#line 4736 "../src/Photo.vala"
				_tmp12_ = TRUE;
#line 31373 "Photo.c"
			} else {
				Alteration* _tmp14_;
#line 4736 "../src/Photo.vala"
				_tmp14_ = alteration;
#line 4736 "../src/Photo.vala"
				_tmp12_ = alteration_has_detail (_tmp14_, "image", "editable");
#line 31380 "Photo.c"
			}
#line 4736 "../src/Photo.vala"
			if (_tmp12_) {
#line 31384 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp15_;
				LibraryPhoto* _tmp16_;
				gpointer _tmp17_;
				gint64* _tmp18_;
				gint64 _tmp19_;
				gint64* _tmp20_ = NULL;
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GeeMultiMap* _tmp30_;
				LibraryPhoto* _tmp31_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp36_;
				BackingPhotoRow* _tmp37_;
				BackingPhotoRow* _tmp38_;
				gint64 _tmp39_;
				gint64 _tmp40_ = 0LL;
				LibraryPhoto* _tmp41_;
				BackingPhotoRow* _tmp42_;
				BackingPhotoRow* _tmp43_;
				gboolean _tmp44_;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp48_;
				LibraryPhoto* _tmp49_;
				GeeMultiMap* _tmp50_;
				LibraryPhoto* _tmp51_;
#line 4737 "../src/Photo.vala"
				_tmp15_ = self->priv->photo_to_master_filesize;
#line 4737 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4737 "../src/Photo.vala"
				_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 4737 "../src/Photo.vala"
				_tmp18_ = (gint64*) _tmp17_;
#line 4737 "../src/Photo.vala"
				_tmp19_ = *_tmp18_;
#line 4737 "../src/Photo.vala"
				_g_free0 (_tmp18_);
#line 4737 "../src/Photo.vala"
				old_master_filesize = _tmp19_;
#line 4738 "../src/Photo.vala"
				_tmp21_ = self->priv->photo_to_editable_filesize;
#line 4738 "../src/Photo.vala"
				_tmp22_ = photo;
#line 4738 "../src/Photo.vala"
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp21_, _tmp22_)) {
#line 31434 "Photo.c"
					GeeHashMap* _tmp23_;
					LibraryPhoto* _tmp24_;
					gpointer _tmp25_;
#line 4739 "../src/Photo.vala"
					_tmp23_ = self->priv->photo_to_editable_filesize;
#line 4739 "../src/Photo.vala"
					_tmp24_ = photo;
#line 4739 "../src/Photo.vala"
					_tmp25_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, _tmp24_);
#line 4739 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4739 "../src/Photo.vala"
					_tmp20_ = (gint64*) _tmp25_;
#line 31448 "Photo.c"
				} else {
					gint64 _tmp26_;
					gint64* _tmp27_;
#line 4740 "../src/Photo.vala"
					_tmp26_ = (gint64) -1;
#line 4740 "../src/Photo.vala"
					_tmp27_ = __int64_dup0 (&_tmp26_);
#line 4740 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4740 "../src/Photo.vala"
					_tmp20_ = _tmp27_;
#line 31460 "Photo.c"
				}
#line 4738 "../src/Photo.vala"
				old_editable_filesize = *_tmp20_;
#line 4742 "../src/Photo.vala"
				_tmp28_ = self->priv->photo_to_master_filesize;
#line 4742 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4742 "../src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp28_, _tmp29_, NULL);
#line 4743 "../src/Photo.vala"
				_tmp30_ = self->priv->filesize_to_photo;
#line 4743 "../src/Photo.vala"
				_tmp31_ = photo;
#line 4743 "../src/Photo.vala"
				gee_multi_map_remove (_tmp30_, &old_master_filesize, _tmp31_);
#line 4744 "../src/Photo.vala"
				if (old_editable_filesize >= ((gint64) 0)) {
#line 31478 "Photo.c"
					GeeHashMap* _tmp32_;
					LibraryPhoto* _tmp33_;
					GeeMultiMap* _tmp34_;
					LibraryPhoto* _tmp35_;
#line 4745 "../src/Photo.vala"
					_tmp32_ = self->priv->photo_to_editable_filesize;
#line 4745 "../src/Photo.vala"
					_tmp33_ = photo;
#line 4745 "../src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp32_, _tmp33_, NULL);
#line 4746 "../src/Photo.vala"
					_tmp34_ = self->priv->filesize_to_photo;
#line 4746 "../src/Photo.vala"
					_tmp35_ = photo;
#line 4746 "../src/Photo.vala"
					gee_multi_map_remove (_tmp34_, &old_editable_filesize, _tmp35_);
#line 31495 "Photo.c"
				}
#line 4749 "../src/Photo.vala"
				_tmp36_ = photo;
#line 4749 "../src/Photo.vala"
				_tmp37_ = photo_get_master_photo_row ((Photo*) _tmp36_);
#line 4749 "../src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 4749 "../src/Photo.vala"
				_tmp39_ = _tmp38_->filesize;
#line 4749 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp38_);
#line 4749 "../src/Photo.vala"
				master_filesize = _tmp39_;
#line 4750 "../src/Photo.vala"
				_tmp41_ = photo;
#line 4750 "../src/Photo.vala"
				_tmp42_ = photo_get_editable_photo_row ((Photo*) _tmp41_);
#line 4750 "../src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 4750 "../src/Photo.vala"
				_tmp44_ = _tmp43_ != NULL;
#line 4750 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp43_);
#line 4750 "../src/Photo.vala"
				if (_tmp44_) {
#line 31521 "Photo.c"
					LibraryPhoto* _tmp45_;
					BackingPhotoRow* _tmp46_;
					BackingPhotoRow* _tmp47_;
#line 4751 "../src/Photo.vala"
					_tmp45_ = photo;
#line 4751 "../src/Photo.vala"
					_tmp46_ = photo_get_editable_photo_row ((Photo*) _tmp45_);
#line 4751 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 4751 "../src/Photo.vala"
					_tmp40_ = _tmp47_->filesize;
#line 4751 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp47_);
#line 31535 "Photo.c"
				} else {
#line 4752 "../src/Photo.vala"
					_tmp40_ = (gint64) -1;
#line 31539 "Photo.c"
				}
#line 4750 "../src/Photo.vala"
				editable_filesize = _tmp40_;
#line 4753 "../src/Photo.vala"
				_tmp48_ = self->priv->photo_to_master_filesize;
#line 4753 "../src/Photo.vala"
				_tmp49_ = photo;
#line 4753 "../src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp48_, _tmp49_, &master_filesize);
#line 4754 "../src/Photo.vala"
				_tmp50_ = self->priv->filesize_to_photo;
#line 4754 "../src/Photo.vala"
				_tmp51_ = photo;
#line 4754 "../src/Photo.vala"
				gee_multi_map_set (_tmp50_, &master_filesize, _tmp51_);
#line 4755 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 31557 "Photo.c"
					GeeHashMap* _tmp52_;
					LibraryPhoto* _tmp53_;
					GeeMultiMap* _tmp54_;
					LibraryPhoto* _tmp55_;
#line 4756 "../src/Photo.vala"
					_tmp52_ = self->priv->photo_to_editable_filesize;
#line 4756 "../src/Photo.vala"
					_tmp53_ = photo;
#line 4756 "../src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp52_, _tmp53_, &editable_filesize);
#line 4757 "../src/Photo.vala"
					_tmp54_ = self->priv->filesize_to_photo;
#line 4757 "../src/Photo.vala"
					_tmp55_ = photo;
#line 4757 "../src/Photo.vala"
					gee_multi_map_set (_tmp54_, &editable_filesize, _tmp55_);
#line 31574 "Photo.c"
				}
#line 4736 "../src/Photo.vala"
				_g_free0 (_tmp20_);
#line 31578 "Photo.c"
			}
#line 4731 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4731 "../src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4731 "../src/Photo.vala"
			_g_object_unref0 (object);
#line 31586 "Photo.c"
		}
#line 4731 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 31590 "Photo.c"
	}
#line 4762 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), items);
#line 31594 "Photo.c"
}

static void
library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                 GeeCollection* media_sources)
{
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 4766 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4766 "../src/Photo.vala"
	g_return_if_fail (media_sources != NULL);
#line 4767 "../src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4767 "../src/Photo.vala"
	map = _tmp0_;
#line 31612 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 4768 "../src/Photo.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) media_sources);
#line 4768 "../src/Photo.vala"
		_media_it = _tmp1_;
#line 4768 "../src/Photo.vala"
		while (TRUE) {
#line 31622 "Photo.c"
			GeeIterator* _tmp2_;
			MediaSource* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp7_;
			PhotoMetadata* _tmp8_;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp9_;
			HierarchicalTagIndex* htag_index = NULL;
			PhotoMetadata* _tmp10_;
			LibraryPhoto* _tmp15_;
			GeeCollection* _tmp16_;
			GeeCollection* _tmp17_;
			gboolean _tmp18_;
			PhotoMetadata* _tmp49_;
#line 4768 "../src/Photo.vala"
			_tmp2_ = _media_it;
#line 4768 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 4768 "../src/Photo.vala"
				break;
#line 31648 "Photo.c"
			}
#line 4768 "../src/Photo.vala"
			_tmp3_ = _media_it;
#line 4768 "../src/Photo.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 4768 "../src/Photo.vala"
			media = (MediaSource*) _tmp4_;
#line 4769 "../src/Photo.vala"
			_tmp5_ = media;
#line 4769 "../src/Photo.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4769 "../src/Photo.vala"
			photo = _tmp6_;
#line 4770 "../src/Photo.vala"
			_tmp7_ = photo;
#line 4770 "../src/Photo.vala"
			_tmp8_ = photo_source_get_metadata ((PhotoSource*) _tmp7_);
#line 4770 "../src/Photo.vala"
			metadata = _tmp8_;
#line 4773 "../src/Photo.vala"
			_tmp9_ = hierarchical_tag_index_get_global_index ();
#line 4773 "../src/Photo.vala"
			global_index = _tmp9_;
#line 4780 "../src/Photo.vala"
			htag_index = NULL;
#line 4781 "../src/Photo.vala"
			_tmp10_ = metadata;
#line 4781 "../src/Photo.vala"
			if (photo_metadata_has_hierarchical_keywords (_tmp10_)) {
#line 31678 "Photo.c"
				PhotoMetadata* _tmp11_;
				GeeSet* _tmp12_;
				GeeSet* _tmp13_;
				HierarchicalTagIndex* _tmp14_;
#line 4782 "../src/Photo.vala"
				_tmp11_ = metadata;
#line 4782 "../src/Photo.vala"
				_tmp12_ = photo_metadata_get_hierarchical_keywords (_tmp11_);
#line 4782 "../src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 4782 "../src/Photo.vala"
				_tmp14_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp13_);
#line 4782 "../src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4782 "../src/Photo.vala"
				htag_index = _tmp14_;
#line 4782 "../src/Photo.vala"
				_g_object_unref0 (_tmp13_);
#line 31697 "Photo.c"
			}
#line 4786 "../src/Photo.vala"
			_tmp15_ = photo;
#line 4786 "../src/Photo.vala"
			_tmp16_ = library_photo_get_import_keywords (_tmp15_);
#line 4786 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 4786 "../src/Photo.vala"
			_tmp18_ = _tmp17_ != NULL;
#line 4786 "../src/Photo.vala"
			_g_object_unref0 (_tmp17_);
#line 4786 "../src/Photo.vala"
			if (_tmp18_) {
#line 31711 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp19_;
					GeeCollection* _tmp20_;
					GeeCollection* _tmp21_;
					GeeIterator* _tmp22_;
					GeeIterator* _tmp23_;
#line 4787 "../src/Photo.vala"
					_tmp19_ = photo;
#line 4787 "../src/Photo.vala"
					_tmp20_ = library_photo_get_import_keywords (_tmp19_);
#line 4787 "../src/Photo.vala"
					_tmp21_ = _tmp20_;
#line 4787 "../src/Photo.vala"
					_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 4787 "../src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 4787 "../src/Photo.vala"
					_g_object_unref0 (_tmp21_);
#line 4787 "../src/Photo.vala"
					_keyword_it = _tmp23_;
#line 4787 "../src/Photo.vala"
					while (TRUE) {
#line 31735 "Photo.c"
						GeeIterator* _tmp24_;
						gchar* keyword = NULL;
						GeeIterator* _tmp25_;
						gpointer _tmp26_;
						gboolean _tmp27_ = FALSE;
						HierarchicalTagIndex* _tmp28_;
						gchar* name = NULL;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						HierarchicalTagIndex* _tmp33_;
						const gchar* _tmp34_;
						const gchar* _tmp43_;
#line 4787 "../src/Photo.vala"
						_tmp24_ = _keyword_it;
#line 4787 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp24_)) {
#line 4787 "../src/Photo.vala"
							break;
#line 31754 "Photo.c"
						}
#line 4787 "../src/Photo.vala"
						_tmp25_ = _keyword_it;
#line 4787 "../src/Photo.vala"
						_tmp26_ = gee_iterator_get (_tmp25_);
#line 4787 "../src/Photo.vala"
						keyword = (gchar*) _tmp26_;
#line 4788 "../src/Photo.vala"
						_tmp28_ = htag_index;
#line 4788 "../src/Photo.vala"
						if (_tmp28_ != NULL) {
#line 31766 "Photo.c"
							HierarchicalTagIndex* _tmp29_;
							const gchar* _tmp30_;
#line 4788 "../src/Photo.vala"
							_tmp29_ = htag_index;
#line 4788 "../src/Photo.vala"
							_tmp30_ = keyword;
#line 4788 "../src/Photo.vala"
							_tmp27_ = hierarchical_tag_index_is_tag_in_index (_tmp29_, _tmp30_);
#line 31775 "Photo.c"
						} else {
#line 4788 "../src/Photo.vala"
							_tmp27_ = FALSE;
#line 31779 "Photo.c"
						}
#line 4788 "../src/Photo.vala"
						if (_tmp27_) {
#line 4789 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4789 "../src/Photo.vala"
							continue;
#line 31787 "Photo.c"
						}
#line 4792 "../src/Photo.vala"
						_tmp31_ = keyword;
#line 4792 "../src/Photo.vala"
						_tmp32_ = tag_prep_tag_name (_tmp31_);
#line 4792 "../src/Photo.vala"
						name = _tmp32_;
#line 4794 "../src/Photo.vala"
						_tmp33_ = global_index;
#line 4794 "../src/Photo.vala"
						_tmp34_ = name;
#line 4794 "../src/Photo.vala"
						if (hierarchical_tag_index_is_tag_in_index (_tmp33_, _tmp34_)) {
#line 31801 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp35_;
							const gchar* _tmp36_;
							gchar* _tmp37_;
							GeeHashMultiMap* _tmp38_;
							const gchar* _tmp39_;
							Tag* _tmp40_;
							Tag* _tmp41_;
							LibraryPhoto* _tmp42_;
#line 4795 "../src/Photo.vala"
							_tmp35_ = global_index;
#line 4795 "../src/Photo.vala"
							_tmp36_ = name;
#line 4795 "../src/Photo.vala"
							_tmp37_ = hierarchical_tag_index_get_path_for_name (_tmp35_, _tmp36_);
#line 4795 "../src/Photo.vala"
							most_derived_path = _tmp37_;
#line 4796 "../src/Photo.vala"
							_tmp38_ = map;
#line 4796 "../src/Photo.vala"
							_tmp39_ = most_derived_path;
#line 4796 "../src/Photo.vala"
							_tmp40_ = tag_for_path (_tmp39_);
#line 4796 "../src/Photo.vala"
							_tmp41_ = _tmp40_;
#line 4796 "../src/Photo.vala"
							_tmp42_ = photo;
#line 4796 "../src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp38_, _tmp41_, _tmp42_);
#line 4796 "../src/Photo.vala"
							_g_object_unref0 (_tmp41_);
#line 4797 "../src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4797 "../src/Photo.vala"
							_g_free0 (name);
#line 4797 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4797 "../src/Photo.vala"
							continue;
#line 31841 "Photo.c"
						}
#line 4800 "../src/Photo.vala"
						_tmp43_ = name;
#line 4800 "../src/Photo.vala"
						if (_tmp43_ != NULL) {
#line 31847 "Photo.c"
							GeeHashMultiMap* _tmp44_;
							const gchar* _tmp45_;
							Tag* _tmp46_;
							Tag* _tmp47_;
							LibraryPhoto* _tmp48_;
#line 4801 "../src/Photo.vala"
							_tmp44_ = map;
#line 4801 "../src/Photo.vala"
							_tmp45_ = name;
#line 4801 "../src/Photo.vala"
							_tmp46_ = tag_for_path (_tmp45_);
#line 4801 "../src/Photo.vala"
							_tmp47_ = _tmp46_;
#line 4801 "../src/Photo.vala"
							_tmp48_ = photo;
#line 4801 "../src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp44_, _tmp47_, _tmp48_);
#line 4801 "../src/Photo.vala"
							_g_object_unref0 (_tmp47_);
#line 31867 "Photo.c"
						}
#line 4787 "../src/Photo.vala"
						_g_free0 (name);
#line 4787 "../src/Photo.vala"
						_g_free0 (keyword);
#line 31873 "Photo.c"
					}
#line 4787 "../src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 31877 "Photo.c"
				}
			}
#line 4806 "../src/Photo.vala"
			_tmp49_ = metadata;
#line 4806 "../src/Photo.vala"
			if (photo_metadata_has_hierarchical_keywords (_tmp49_)) {
#line 31884 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp50_;
					GeeCollection* _tmp51_;
					GeeCollection* _tmp52_;
					GeeIterator* _tmp53_;
					GeeIterator* _tmp54_;
#line 4807 "../src/Photo.vala"
					_tmp50_ = htag_index;
#line 4807 "../src/Photo.vala"
					_tmp51_ = hierarchical_tag_index_get_all_paths (_tmp50_);
#line 4807 "../src/Photo.vala"
					_tmp52_ = _tmp51_;
#line 4807 "../src/Photo.vala"
					_tmp53_ = gee_iterable_iterator ((GeeIterable*) _tmp52_);
#line 4807 "../src/Photo.vala"
					_tmp54_ = _tmp53_;
#line 4807 "../src/Photo.vala"
					_g_object_unref0 (_tmp52_);
#line 4807 "../src/Photo.vala"
					_path_it = _tmp54_;
#line 4807 "../src/Photo.vala"
					while (TRUE) {
#line 31908 "Photo.c"
						GeeIterator* _tmp55_;
						gchar* path = NULL;
						GeeIterator* _tmp56_;
						gpointer _tmp57_;
						gchar* name = NULL;
						const gchar* _tmp58_;
						gchar* _tmp59_;
						const gchar* _tmp60_;
#line 4807 "../src/Photo.vala"
						_tmp55_ = _path_it;
#line 4807 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp55_)) {
#line 4807 "../src/Photo.vala"
							break;
#line 31923 "Photo.c"
						}
#line 4807 "../src/Photo.vala"
						_tmp56_ = _path_it;
#line 4807 "../src/Photo.vala"
						_tmp57_ = gee_iterator_get (_tmp56_);
#line 4807 "../src/Photo.vala"
						path = (gchar*) _tmp57_;
#line 4808 "../src/Photo.vala"
						_tmp58_ = path;
#line 4808 "../src/Photo.vala"
						_tmp59_ = tag_prep_tag_name (_tmp58_);
#line 4808 "../src/Photo.vala"
						name = _tmp59_;
#line 4809 "../src/Photo.vala"
						_tmp60_ = name;
#line 4809 "../src/Photo.vala"
						if (_tmp60_ != NULL) {
#line 31941 "Photo.c"
							GeeHashMultiMap* _tmp61_;
							const gchar* _tmp62_;
							Tag* _tmp63_;
							Tag* _tmp64_;
							LibraryPhoto* _tmp65_;
#line 4810 "../src/Photo.vala"
							_tmp61_ = map;
#line 4810 "../src/Photo.vala"
							_tmp62_ = name;
#line 4810 "../src/Photo.vala"
							_tmp63_ = tag_for_path (_tmp62_);
#line 4810 "../src/Photo.vala"
							_tmp64_ = _tmp63_;
#line 4810 "../src/Photo.vala"
							_tmp65_ = photo;
#line 4810 "../src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp61_, _tmp64_, _tmp65_);
#line 4810 "../src/Photo.vala"
							_g_object_unref0 (_tmp64_);
#line 31961 "Photo.c"
						}
#line 4807 "../src/Photo.vala"
						_g_free0 (name);
#line 4807 "../src/Photo.vala"
						_g_free0 (path);
#line 31967 "Photo.c"
					}
#line 4807 "../src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 31971 "Photo.c"
				}
			}
#line 4768 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4768 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4768 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4768 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4768 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 31984 "Photo.c"
		}
#line 4768 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 31988 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp66_;
#line 4816 "../src/Photo.vala"
		_tmp66_ = gee_iterable_iterator ((GeeIterable*) media_sources);
#line 4816 "../src/Photo.vala"
		_media_it = _tmp66_;
#line 4816 "../src/Photo.vala"
		while (TRUE) {
#line 31999 "Photo.c"
			GeeIterator* _tmp67_;
			MediaSource* media = NULL;
			GeeIterator* _tmp68_;
			gpointer _tmp69_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp70_;
			LibraryPhoto* _tmp71_;
			LibraryPhoto* _tmp72_;
#line 4816 "../src/Photo.vala"
			_tmp67_ = _media_it;
#line 4816 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp67_)) {
#line 4816 "../src/Photo.vala"
				break;
#line 32014 "Photo.c"
			}
#line 4816 "../src/Photo.vala"
			_tmp68_ = _media_it;
#line 4816 "../src/Photo.vala"
			_tmp69_ = gee_iterator_get (_tmp68_);
#line 4816 "../src/Photo.vala"
			media = (MediaSource*) _tmp69_;
#line 4817 "../src/Photo.vala"
			_tmp70_ = media;
#line 4817 "../src/Photo.vala"
			_tmp71_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4817 "../src/Photo.vala"
			photo = _tmp71_;
#line 4818 "../src/Photo.vala"
			_tmp72_ = photo;
#line 4818 "../src/Photo.vala"
			library_photo_clear_import_keywords (_tmp72_);
#line 4816 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4816 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 32036 "Photo.c"
		}
#line 4816 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 32040 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp73_;
		GeeSet* _tmp74_;
		GeeSet* _tmp75_;
		GeeIterator* _tmp76_;
		GeeIterator* _tmp77_;
#line 4821 "../src/Photo.vala"
		_tmp73_ = map;
#line 4821 "../src/Photo.vala"
		_tmp74_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp73_);
#line 4821 "../src/Photo.vala"
		_tmp75_ = _tmp74_;
#line 4821 "../src/Photo.vala"
		_tmp76_ = gee_iterable_iterator ((GeeIterable*) _tmp75_);
#line 4821 "../src/Photo.vala"
		_tmp77_ = _tmp76_;
#line 4821 "../src/Photo.vala"
		_g_object_unref0 (_tmp75_);
#line 4821 "../src/Photo.vala"
		_tag_it = _tmp77_;
#line 4821 "../src/Photo.vala"
		while (TRUE) {
#line 32065 "Photo.c"
			GeeIterator* _tmp78_;
			Tag* tag = NULL;
			GeeIterator* _tmp79_;
			gpointer _tmp80_;
			Tag* _tmp81_;
			GeeHashMultiMap* _tmp82_;
			Tag* _tmp83_;
			GeeCollection* _tmp84_;
			GeeCollection* _tmp85_;
#line 4821 "../src/Photo.vala"
			_tmp78_ = _tag_it;
#line 4821 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp78_)) {
#line 4821 "../src/Photo.vala"
				break;
#line 32081 "Photo.c"
			}
#line 4821 "../src/Photo.vala"
			_tmp79_ = _tag_it;
#line 4821 "../src/Photo.vala"
			_tmp80_ = gee_iterator_get (_tmp79_);
#line 4821 "../src/Photo.vala"
			tag = (Tag*) _tmp80_;
#line 4822 "../src/Photo.vala"
			_tmp81_ = tag;
#line 4822 "../src/Photo.vala"
			_tmp82_ = map;
#line 4822 "../src/Photo.vala"
			_tmp83_ = tag;
#line 4822 "../src/Photo.vala"
			_tmp84_ = gee_multi_map_get ((GeeMultiMap*) _tmp82_, _tmp83_);
#line 4822 "../src/Photo.vala"
			_tmp85_ = _tmp84_;
#line 4822 "../src/Photo.vala"
			tag_attach_many (_tmp81_, _tmp85_);
#line 4822 "../src/Photo.vala"
			_g_object_unref0 (_tmp85_);
#line 4821 "../src/Photo.vala"
			_g_object_unref0 (tag);
#line 32105 "Photo.c"
		}
#line 4821 "../src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 32109 "Photo.c"
	}
#line 4824 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), media_sources);
#line 4766 "../src/Photo.vala"
	_g_object_unref0 (map);
#line 32115 "Photo.c"
}

static void
library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4828 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4829 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 32127 "Photo.c"
}

void
library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4828 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4828 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4828 "../src/Photo.vala"
	if (_klass_->notify_master_reimported) {
#line 4828 "../src/Photo.vala"
		_klass_->notify_master_reimported (self, photo, metadata);
#line 32144 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4833 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4834 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 32157 "Photo.c"
}

void
library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4833 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4833 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4833 "../src/Photo.vala"
	if (_klass_->notify_editable_reimported) {
#line 4833 "../src/Photo.vala"
		_klass_->notify_editable_reimported (self, photo, metadata);
#line 32174 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4838 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4839 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 32187 "Photo.c"
}

void
library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4838 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4838 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4838 "../src/Photo.vala"
	if (_klass_->notify_source_reimported) {
#line 4838 "../src/Photo.vala"
		_klass_->notify_source_reimported (self, photo, metadata);
#line 32204 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4843 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4844 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 32217 "Photo.c"
}

void
library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4843 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4843 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4843 "../src/Photo.vala"
	if (_klass_->notify_baseline_reimported) {
#line 4843 "../src/Photo.vala"
		_klass_->notify_baseline_reimported (self, photo, metadata);
#line 32234 "Photo.c"
	}
}

static MediaSource*
library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                          gint64 numeric_id)
{
	LibraryPhotoSourceCollection * self;
	PhotoID _tmp0_ = {0};
	LibraryPhoto* _tmp1_;
	MediaSource* result;
#line 4847 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4848 "../src/Photo.vala"
	photo_id_init (&_tmp0_, numeric_id);
#line 4848 "../src/Photo.vala"
	_tmp1_ = library_photo_source_collection_fetch (self, &_tmp0_);
#line 4848 "../src/Photo.vala"
	result = (MediaSource*) _tmp1_;
#line 4848 "../src/Photo.vala"
	return result;
#line 32256 "Photo.c"
}

static void
library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                              GeeCollection* added,
                                                              GeeCollection* removed)
{
#line 4851 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4853 "../src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 32268 "Photo.c"
}

static gboolean
library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result;
#line 4857 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4857 "../src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4857 "../src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4858 "../src/Photo.vala"
	result = media_source_is_trashed ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4858 "../src/Photo.vala"
	return result;
#line 32287 "Photo.c"
}

static void
library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                             GeeCollection* added,
                                                             GeeCollection* removed)
{
#line 4861 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4863 "../src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 32299 "Photo.c"
}

static gboolean
library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result;
#line 4867 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4867 "../src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4867 "../src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4868 "../src/Photo.vala"
	result = media_source_is_offline ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4868 "../src/Photo.vala"
	return result;
#line 32318 "Photo.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 32341 "Photo.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 32350 "Photo.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 32369 "Photo.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 32373 "Photo.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 32379 "Photo.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 32389 "Photo.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 32397 "Photo.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 32401 "Photo.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 32407 "Photo.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 32417 "Photo.c"
}

static MediaSource*
library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                         const gchar* source_id)
{
	LibraryPhotoSourceCollection * self;
	gchar* numeric_only = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	MediaSource* _tmp3_;
	MediaSource* result;
#line 4871 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4871 "../src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4872 "../src/Photo.vala"
	_vala_assert (g_str_has_prefix (source_id, PHOTO_TYPENAME), "source_id.has_prefix (Photo.TYPENAME)");
#line 4873 "../src/Photo.vala"
	_tmp0_ = strlen (PHOTO_TYPENAME);
#line 4873 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4873 "../src/Photo.vala"
	_tmp2_ = string_substring (source_id, (glong) _tmp1_, (glong) -1);
#line 4873 "../src/Photo.vala"
	numeric_only = _tmp2_;
#line 4875 "../src/Photo.vala"
	_tmp3_ = media_source_collection_fetch_by_numeric_id ((MediaSourceCollection*) self, parse_int64 (numeric_only, 16));
#line 4875 "../src/Photo.vala"
	result = _tmp3_;
#line 4875 "../src/Photo.vala"
	_g_free0 (numeric_only);
#line 4875 "../src/Photo.vala"
	return result;
#line 32453 "Photo.c"
}

static GeeCollection*
library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                           EventID* event_id)
{
	LibraryPhotoSourceCollection * self;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* result;
#line 4878 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4878 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4879 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4879 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4879 "../src/Photo.vala"
	_tmp2_ = *event_id;
#line 4879 "../src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4879 "../src/Photo.vala"
	_tmp4_ = (GeeCollection*) _tmp3_;
#line 4879 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4879 "../src/Photo.vala"
	result = _tmp4_;
#line 4879 "../src/Photo.vala"
	return result;
#line 32487 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                       PhotoID* photo_id)
{
	PhotoID _tmp0_;
	DataSource* _tmp1_;
	LibraryPhoto* result;
#line 4882 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4882 "../src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4883 "../src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4883 "../src/Photo.vala"
	_tmp1_ = database_source_collection_fetch_by_key ((DatabaseSourceCollection*) self, _tmp0_.id);
#line 4883 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4883 "../src/Photo.vala"
	return result;
#line 32509 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                        GFile* file)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* result;
#line 4886 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4886 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4887 "../src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4887 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 4887 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4887 "../src/Photo.vala"
	return result;
#line 32531 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                               GFile* file)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* result;
#line 4890 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4890 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4891 "../src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4891 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 4891 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4891 "../src/Photo.vala"
	return result;
#line 32553 "Photo.c"
}

static void
library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                 LibraryPhoto* photo,
                                                 GFileInfo* info,
                                                 GeeCollection* matches_master,
                                                 GeeCollection* matches_editable,
                                                 GeeCollection* matches_development)
{
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp2_;
	BackingPhotoRow* editable = NULL;
	BackingPhotoRow* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BackingPhotoRow* _tmp5_;
	GeeCollection* development = NULL;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
#line 4894 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4894 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4894 "../src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4894 "../src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4894 "../src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4894 "../src/Photo.vala"
	g_return_if_fail (matches_development != NULL);
#line 4897 "../src/Photo.vala"
	_tmp0_ = photo_get_master_photo_row ((Photo*) photo);
#line 4897 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4897 "../src/Photo.vala"
	_tmp2_ = backing_photo_row_matches_file_info (_tmp1_, info);
#line 4897 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp1_);
#line 4897 "../src/Photo.vala"
	if (_tmp2_) {
#line 4898 "../src/Photo.vala"
		gee_collection_add (matches_master, photo);
#line 32598 "Photo.c"
	}
#line 4901 "../src/Photo.vala"
	_tmp3_ = photo_get_editable_photo_row ((Photo*) photo);
#line 4901 "../src/Photo.vala"
	editable = _tmp3_;
#line 4902 "../src/Photo.vala"
	_tmp5_ = editable;
#line 4902 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 32608 "Photo.c"
		BackingPhotoRow* _tmp6_;
#line 4902 "../src/Photo.vala"
		_tmp6_ = editable;
#line 4902 "../src/Photo.vala"
		_tmp4_ = backing_photo_row_matches_file_info (_tmp6_, info);
#line 32614 "Photo.c"
	} else {
#line 4902 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 32618 "Photo.c"
	}
#line 4902 "../src/Photo.vala"
	if (_tmp4_) {
#line 4903 "../src/Photo.vala"
		gee_collection_add (matches_editable, photo);
#line 32624 "Photo.c"
	}
#line 4906 "../src/Photo.vala"
	_tmp7_ = photo_get_raw_development_photo_rows ((Photo*) photo);
#line 4906 "../src/Photo.vala"
	development = _tmp7_;
#line 4907 "../src/Photo.vala"
	_tmp8_ = development;
#line 4907 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 32634 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_;
#line 4908 "../src/Photo.vala"
			_tmp9_ = development;
#line 4908 "../src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 4908 "../src/Photo.vala"
			_row_it = _tmp10_;
#line 4908 "../src/Photo.vala"
			while (TRUE) {
#line 32647 "Photo.c"
				GeeIterator* _tmp11_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 4908 "../src/Photo.vala"
				_tmp11_ = _row_it;
#line 4908 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 4908 "../src/Photo.vala"
					break;
#line 32659 "Photo.c"
				}
#line 4908 "../src/Photo.vala"
				_tmp12_ = _row_it;
#line 4908 "../src/Photo.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 4908 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp13_;
#line 4909 "../src/Photo.vala"
				_tmp14_ = row;
#line 4909 "../src/Photo.vala"
				if (backing_photo_row_matches_file_info (_tmp14_, info)) {
#line 4910 "../src/Photo.vala"
					gee_collection_add (matches_development, photo);
#line 4912 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4912 "../src/Photo.vala"
					break;
#line 32677 "Photo.c"
				}
#line 4908 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 32681 "Photo.c"
			}
#line 4908 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 32685 "Photo.c"
		}
	}
#line 4894 "../src/Photo.vala"
	_g_object_unref0 (development);
#line 4894 "../src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 32692 "Photo.c"
}

void
library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                           GFileInfo* info,
                                                           GeeCollection* matches_master,
                                                           GeeCollection* matches_editable,
                                                           GeeCollection* matched_development)
{
#line 4920 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4920 "../src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4920 "../src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4920 "../src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4920 "../src/Photo.vala"
	g_return_if_fail (matched_development != NULL);
#line 32712 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 4922 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4922 "../src/Photo.vala"
		_tmp1_ = g_file_info_get_size (info);
#line 4922 "../src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4922 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4922 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 4922 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4922 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4922 "../src/Photo.vala"
		_photo_it = _tmp5_;
#line 4922 "../src/Photo.vala"
		while (TRUE) {
#line 32739 "Photo.c"
			GeeIterator* _tmp6_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			LibraryPhoto* _tmp9_;
#line 4922 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4922 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 4922 "../src/Photo.vala"
				break;
#line 32751 "Photo.c"
			}
#line 4922 "../src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4922 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 4922 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 4923 "../src/Photo.vala"
			_tmp9_ = photo;
#line 4923 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp9_, info, matches_master, matches_editable, matched_development);
#line 4922 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 32765 "Photo.c"
		}
#line 4922 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 32769 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp10_;
		GeeCollection* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 4926 "../src/Photo.vala"
		_tmp10_ = media_source_collection_get_offline_bin_contents ((MediaSourceCollection*) self);
#line 4926 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 4926 "../src/Photo.vala"
		_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 4926 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 4926 "../src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 4926 "../src/Photo.vala"
		_media_it = _tmp13_;
#line 4926 "../src/Photo.vala"
		while (TRUE) {
#line 32791 "Photo.c"
			GeeIterator* _tmp14_;
			MediaSource* media = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			MediaSource* _tmp17_;
#line 4926 "../src/Photo.vala"
			_tmp14_ = _media_it;
#line 4926 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 4926 "../src/Photo.vala"
				break;
#line 32803 "Photo.c"
			}
#line 4926 "../src/Photo.vala"
			_tmp15_ = _media_it;
#line 4926 "../src/Photo.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 4926 "../src/Photo.vala"
			media = (MediaSource*) _tmp16_;
#line 4927 "../src/Photo.vala"
			_tmp17_ = media;
#line 4927 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_LIBRARY_PHOTO, LibraryPhoto), info, matches_master, matches_editable, matched_development);
#line 4926 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 32817 "Photo.c"
		}
#line 4926 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 32821 "Photo.c"
	}
}

void
library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize,
                                                                 PhotoID* result)
{
	PhotoID _tmp16_ = {0};
#line 4931 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4931 "../src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 32836 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4932 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4932 "../src/Photo.vala"
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
#line 4932 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4932 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 4932 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4932 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4932 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 4932 "../src/Photo.vala"
		while (TRUE) {
#line 32860 "Photo.c"
			GeeIterator* _tmp5_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gboolean _tmp13_;
#line 4932 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 4932 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4932 "../src/Photo.vala"
				break;
#line 32877 "Photo.c"
			}
#line 4932 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4932 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4932 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp7_;
#line 4933 "../src/Photo.vala"
			_tmp8_ = photo;
#line 4933 "../src/Photo.vala"
			_tmp9_ = media_source_get_master_file ((MediaSource*) _tmp8_);
#line 4933 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 4933 "../src/Photo.vala"
			_tmp11_ = g_file_get_basename (_tmp10_);
#line 4933 "../src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 4933 "../src/Photo.vala"
			_tmp13_ = utf8_ci_compare (_tmp12_, basename) == 0;
#line 4933 "../src/Photo.vala"
			_g_free0 (_tmp12_);
#line 4933 "../src/Photo.vala"
			_g_object_unref0 (_tmp10_);
#line 4933 "../src/Photo.vala"
			if (_tmp13_) {
#line 32903 "Photo.c"
				LibraryPhoto* _tmp14_;
				PhotoID _tmp15_ = {0};
#line 4934 "../src/Photo.vala"
				_tmp14_ = photo;
#line 4934 "../src/Photo.vala"
				photo_get_photo_id ((Photo*) _tmp14_, &_tmp15_);
#line 4934 "../src/Photo.vala"
				*result = _tmp15_;
#line 4934 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4934 "../src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4934 "../src/Photo.vala"
				return;
#line 32918 "Photo.c"
			}
#line 4932 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 32922 "Photo.c"
		}
#line 4932 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 32926 "Photo.c"
	}
#line 4938 "../src/Photo.vala"
	photo_id_init (&_tmp16_, PHOTO_ID_INVALID);
#line 4938 "../src/Photo.vala"
	*result = _tmp16_;
#line 4938 "../src/Photo.vala"
	return;
#line 32934 "Photo.c"
}

gboolean
library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize)
{
	PhotoID _tmp0_ = {0};
	gboolean result;
#line 4942 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4942 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4943 "../src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
#line 4943 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 4943 "../src/Photo.vala"
	return result;
#line 32954 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* result;
#line 4946 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4946 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4947 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4947 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4947 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4947 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4947 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4947 "../src/Photo.vala"
	photo = _tmp3_;
#line 4948 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4948 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 32988 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4949 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4949 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4949 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4949 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4949 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4949 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 33004 "Photo.c"
	}
#line 4953 "../src/Photo.vala"
	result = photo;
#line 4953 "../src/Photo.vala"
	return result;
#line 33010 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* result;
#line 4956 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4956 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4957 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4957 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4957 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4957 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4957 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4957 "../src/Photo.vala"
	result = _tmp3_;
#line 4957 "../src/Photo.vala"
	return result;
#line 33040 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* result;
#line 4960 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4960 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4961 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4961 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4961 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4961 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4961 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4961 "../src/Photo.vala"
	photo = _tmp3_;
#line 4962 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4962 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 33074 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4963 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4963 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4963 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4963 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4963 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4963 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 33090 "Photo.c"
	}
#line 4967 "../src/Photo.vala"
	result = photo;
#line 4967 "../src/Photo.vala"
	return result;
#line 33096 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* result;
#line 4970 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4970 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4971 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4971 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4971 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4971 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4971 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4971 "../src/Photo.vala"
	result = _tmp3_;
#line 4971 "../src/Photo.vala"
	return result;
#line 33126 "Photo.c"
}

gint
library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
	gint result;
#line 4974 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 4975 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4975 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4975 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count ((SourceHoldingTank*) _tmp1_);
#line 4975 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4975 "../src/Photo.vala"
	result = _tmp2_;
#line 4975 "../src/Photo.vala"
	return result;
#line 33150 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                   GFile* file,
                                                   LibraryPhotoSourceCollectionState* state)
{
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* photo = NULL;
	MediaSource* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* _tmp5_;
	LibraryPhoto* _tmp6_;
	LibraryPhoto* _tmp7_;
	LibraryPhoto* _tmp8_;
	LibraryPhoto* _tmp9_;
	LibraryPhoto* _tmp10_;
	LibraryPhoto* _tmp11_;
	LibraryPhoto* result;
#line 4978 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4978 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4979 "../src/Photo.vala"
	_tmp0_ = media_source_collection_fetch_by_master_file ((MediaSourceCollection*) self, file);
#line 4979 "../src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4980 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4980 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 4981 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4983 "../src/Photo.vala"
		result = photo;
#line 4983 "../src/Photo.vala"
		if (state) {
#line 4983 "../src/Photo.vala"
			*state = _vala_state;
#line 33193 "Photo.c"
		}
#line 4983 "../src/Photo.vala"
		return result;
#line 33197 "Photo.c"
	}
#line 4986 "../src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch_by_editable_file (self, file);
#line 4986 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4986 "../src/Photo.vala"
	photo = _tmp2_;
#line 4987 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4987 "../src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 4988 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4990 "../src/Photo.vala"
		result = photo;
#line 4990 "../src/Photo.vala"
		if (state) {
#line 4990 "../src/Photo.vala"
			*state = _vala_state;
#line 33217 "Photo.c"
		}
#line 4990 "../src/Photo.vala"
		return result;
#line 33221 "Photo.c"
	}
#line 4993 "../src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_raw_development_file (self, file);
#line 4993 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4993 "../src/Photo.vala"
	photo = _tmp4_;
#line 4994 "../src/Photo.vala"
	_tmp5_ = photo;
#line 4994 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4995 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4997 "../src/Photo.vala"
		result = photo;
#line 4997 "../src/Photo.vala"
		if (state) {
#line 4997 "../src/Photo.vala"
			*state = _vala_state;
#line 33241 "Photo.c"
		}
#line 4997 "../src/Photo.vala"
		return result;
#line 33245 "Photo.c"
	}
#line 5000 "../src/Photo.vala"
	_tmp6_ = library_photo_source_collection_get_trashed_by_file (self, file);
#line 5000 "../src/Photo.vala"
	_tmp7_ = IS_LIBRARY_PHOTO (_tmp6_) ? ((LibraryPhoto*) _tmp6_) : NULL;
#line 5000 "../src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 5000 "../src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 33255 "Photo.c"
	}
#line 5000 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 5000 "../src/Photo.vala"
	photo = _tmp7_;
#line 5001 "../src/Photo.vala"
	_tmp8_ = photo;
#line 5001 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 5002 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 5004 "../src/Photo.vala"
		result = photo;
#line 5004 "../src/Photo.vala"
		if (state) {
#line 5004 "../src/Photo.vala"
			*state = _vala_state;
#line 33273 "Photo.c"
		}
#line 5004 "../src/Photo.vala"
		return result;
#line 33277 "Photo.c"
	}
#line 5007 "../src/Photo.vala"
	_tmp9_ = library_photo_source_collection_get_offline_by_file (self, file);
#line 5007 "../src/Photo.vala"
	_tmp10_ = IS_LIBRARY_PHOTO (_tmp9_) ? ((LibraryPhoto*) _tmp9_) : NULL;
#line 5007 "../src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 5007 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 33287 "Photo.c"
	}
#line 5007 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 5007 "../src/Photo.vala"
	photo = _tmp10_;
#line 5008 "../src/Photo.vala"
	_tmp11_ = photo;
#line 5008 "../src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 5009 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 5011 "../src/Photo.vala"
		result = photo;
#line 5011 "../src/Photo.vala"
		if (state) {
#line 5011 "../src/Photo.vala"
			*state = _vala_state;
#line 33305 "Photo.c"
		}
#line 5011 "../src/Photo.vala"
		return result;
#line 33309 "Photo.c"
	}
#line 5014 "../src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 5016 "../src/Photo.vala"
	result = NULL;
#line 5016 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 5016 "../src/Photo.vala"
	if (state) {
#line 5016 "../src/Photo.vala"
		*state = _vala_state;
#line 33321 "Photo.c"
	}
#line 5016 "../src/Photo.vala"
	return result;
#line 33325 "Photo.c"
}

static gboolean
library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                   SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gboolean _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSourceHoldingTank* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 5019 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 5019 "../src/Photo.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 5020 "../src/Photo.vala"
	if (SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), backlink)) {
#line 5021 "../src/Photo.vala"
		result = TRUE;
#line 5021 "../src/Photo.vala"
		return result;
#line 33350 "Photo.c"
	}
#line 5024 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 5024 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5024 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp1_, backlink);
#line 5024 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 5024 "../src/Photo.vala"
	if (_tmp2_) {
#line 5025 "../src/Photo.vala"
		result = TRUE;
#line 5025 "../src/Photo.vala"
		return result;
#line 33366 "Photo.c"
	}
#line 5028 "../src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 5028 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5028 "../src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp4_, backlink);
#line 5028 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 5028 "../src/Photo.vala"
	if (_tmp5_) {
#line 5029 "../src/Photo.vala"
		result = TRUE;
#line 5029 "../src/Photo.vala"
		return result;
#line 33382 "Photo.c"
	}
#line 5032 "../src/Photo.vala"
	result = FALSE;
#line 5032 "../src/Photo.vala"
	return result;
#line 33388 "Photo.c"
}

static void
library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                      SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 5035 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 5035 "../src/Photo.vala"
	g_return_if_fail (backlink != NULL);
#line 5036 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 5036 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5036 "../src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp1_, backlink);
#line 5036 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 5037 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 5037 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5037 "../src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp3_, backlink);
#line 5037 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 5039 "../src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), backlink);
#line 33422 "Photo.c"
}

static TransactionController*
library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4530 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4531 "../src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4531 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 33438 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4532 "../src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new ((MediaSourceCollection*) self);
#line 4532 "../src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4532 "../src/Photo.vala"
		self->priv->_transaction_controller = (TransactionController*) _tmp1_;
#line 33446 "Photo.c"
	}
#line 4535 "../src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4535 "../src/Photo.vala"
	result = _tmp2_;
#line 4535 "../src/Photo.vala"
	return result;
#line 33454 "Photo.c"
}

static void
library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4553 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 33464 "Photo.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4519 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4519 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4519 "../src/Photo.vala"
		data1 = closure->data;
#line 4519 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 33489 "Photo.c"
	} else {
#line 4519 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4519 "../src/Photo.vala"
		data2 = closure->data;
#line 33495 "Photo.c"
	}
#line 4519 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4519 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 33501 "Photo.c"
}

static void
library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4556 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 33511 "Photo.c"
}

static void
library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4559 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 33521 "Photo.c"
}

static void
library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4562 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 33531 "Photo.c"
}

static void
library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass,
                                            gpointer klass_data)
{
#line 4519 "../src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4519 "../src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4519 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceCollection_private_offset);
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_trashcan;
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_offline_bin;
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) library_photo_source_collection_real_create_media_monitor;
#line 4519 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) library_photo_source_collection_real_holds_type_of_source;
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) library_photo_source_collection_real_get_typename;
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) library_photo_source_collection_real_is_file_recognized;
#line 4519 "../src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) library_photo_source_collection_real_notify_contents_altered;
#line 4519 "../src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) library_photo_source_collection_real_items_altered;
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*) (MediaSourceCollection*, GeeCollection*)) library_photo_source_collection_real_postprocess_imported_media;
#line 4519 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_master_reimported;
#line 4519 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_editable_reimported;
#line 4519 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_source_reimported;
#line 4519 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_baseline_reimported;
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) library_photo_source_collection_real_fetch_by_numeric_id;
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*) (MediaSourceCollection*, const gchar*)) library_photo_source_collection_real_fetch_by_source_id;
#line 4519 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) library_photo_source_collection_real_get_event_source_ids;
#line 4519 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = (gboolean (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_has_backlink;
#line 4519 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = (void (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_remove_backlink;
#line 4519 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4519 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4519 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4519 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4519 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = (TransactionController* (*) (MediaSourceCollection*)) library_photo_source_collection_real_get_transaction_controller;
#line 4519 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4519 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4519 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4519 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 33598 "Photo.c"
}

static void
library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self,
                                               gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeTreeMultiMap* _tmp5_;
#line 4519 "../src/Photo.vala"
	self->priv = library_photo_source_collection_get_instance_private (self);
#line 4539 "../src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4540 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4540 "../src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4542 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4542 "../src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4544 "../src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4544 "../src/Photo.vala"
	self->priv->filesize_to_photo = (GeeMultiMap*) _tmp2_;
#line 4546 "../src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4546 "../src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4548 "../src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4548 "../src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4550 "../src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4550 "../src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = (GeeMultiMap*) _tmp5_;
#line 33639 "Photo.c"
}

static void
library_photo_source_collection_finalize (DataCollection * obj)
{
	LibraryPhotoSourceCollection * self;
#line 4519 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4539 "../src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4540 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4542 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4544 "../src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4546 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4548 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4550 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4519 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 33664 "Photo.c"
}

static GType
library_photo_source_collection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
	GType library_photo_source_collection_type_id;
	library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
	LibraryPhotoSourceCollection_private_offset = g_type_add_instance_private (library_photo_source_collection_type_id, sizeof (LibraryPhotoSourceCollectionPrivate));
	return library_photo_source_collection_type_id;
}

GType
library_photo_source_collection_get_type (void)
{
	static volatile gsize library_photo_source_collection_type_id__once = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__once)) {
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = library_photo_source_collection_get_type_once ();
		g_once_init_leave (&library_photo_source_collection_type_id__once, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__once;
}

static inline gpointer
library_photo_get_instance_private (LibraryPhoto* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhoto_private_offset);
}

static void
_library_photo_generate_thumbnails_one_shot_callback (gpointer self)
{
#line 5067 "../src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 33700 "Photo.c"
}

static LibraryPhoto*
library_photo_construct (GType object_type,
                         PhotoRow* row)
{
	LibraryPhoto * self = NULL;
	OneShotScheduler* _tmp0_;
#line 5062 "../src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 5063 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, row);
#line 5065 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5065 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 5067 "../src/Photo.vala"
	_tmp0_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5067 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5067 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp0_;
#line 5070 "../src/Photo.vala"
	if ((row->flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 33725 "Photo.c"
		LibraryPhotoSourceCollection* _tmp1_;
		const gchar* _tmp2_;
#line 5071 "../src/Photo.vala"
		_tmp1_ = library_photo_global;
#line 5071 "../src/Photo.vala"
		_tmp2_ = row->backlinks;
#line 5071 "../src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp1_, _tmp2_);
#line 33734 "Photo.c"
	}
#line 5062 "../src/Photo.vala"
	return self;
#line 33738 "Photo.c"
}

static LibraryPhoto*
library_photo_new (PhotoRow* row)
{
#line 5062 "../src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 33746 "Photo.c"
}

static LibraryPhoto*
library_photo_construct_from_import_params (GType object_type,
                                            PhotoImportParams* import_params)
{
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	OneShotScheduler* _tmp3_;
	PhotoRow* _tmp4_;
#line 5075 "../src/Photo.vala"
	g_return_val_if_fail (import_params != NULL, NULL);
#line 5076 "../src/Photo.vala"
	_tmp0_ = import_params->row;
#line 5076 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 5078 "../src/Photo.vala"
	_tmp1_ = import_params->keywords;
#line 5078 "../src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 5078 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5078 "../src/Photo.vala"
	self->priv->import_keywords = _tmp2_;
#line 5079 "../src/Photo.vala"
	_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5079 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5079 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp3_;
#line 5082 "../src/Photo.vala"
	_tmp4_ = import_params->row;
#line 5082 "../src/Photo.vala"
	if ((_tmp4_->flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 33783 "Photo.c"
		LibraryPhotoSourceCollection* _tmp5_;
		PhotoRow* _tmp6_;
		const gchar* _tmp7_;
#line 5083 "../src/Photo.vala"
		_tmp5_ = library_photo_global;
#line 5083 "../src/Photo.vala"
		_tmp6_ = import_params->row;
#line 5083 "../src/Photo.vala"
		_tmp7_ = _tmp6_->backlinks;
#line 5083 "../src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp5_, _tmp7_);
#line 33795 "Photo.c"
	}
#line 5075 "../src/Photo.vala"
	return self;
#line 33799 "Photo.c"
}

static LibraryPhoto*
library_photo_new_from_import_params (PhotoImportParams* import_params)
{
#line 5075 "../src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 33807 "Photo.c"
}

void
library_photo_init (ProgressMonitor monitor,
                    gpointer monitor_target)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_;
	gint count = 0;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	LibraryPhotoSourceCollection* _tmp24_;
	GeeArrayList* _tmp25_;
	GeeCollection* _tmp26_;
	GeeCollection* _tmp27_;
	LibraryPhotoSourceCollection* _tmp28_;
	GeeArrayList* _tmp29_;
	LibraryPhotoSourceCollection* _tmp30_;
	GeeArrayList* _tmp31_;
#line 5088 "../src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 5088 "../src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 5088 "../src/Photo.vala"
	library_photo_global = _tmp0_;
#line 5092 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 5092 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 5092 "../src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 5092 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5092 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 5092 "../src/Photo.vala"
	all = _tmp4_;
#line 5093 "../src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5093 "../src/Photo.vala"
	all_photos = _tmp5_;
#line 5094 "../src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5094 "../src/Photo.vala"
	trashed_photos = _tmp6_;
#line 5095 "../src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5095 "../src/Photo.vala"
	offline_photos = _tmp7_;
#line 5096 "../src/Photo.vala"
	_tmp8_ = all;
#line 5096 "../src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 5096 "../src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 5096 "../src/Photo.vala"
	count = _tmp10_;
#line 33876 "Photo.c"
	{
		gint ctr = 0;
#line 5097 "../src/Photo.vala"
		ctr = 0;
#line 33881 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 5097 "../src/Photo.vala"
			_tmp11_ = TRUE;
#line 5097 "../src/Photo.vala"
			while (TRUE) {
#line 33888 "Photo.c"
				PhotoRow* row = NULL;
				GeeArrayList* _tmp13_;
				gpointer _tmp14_;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp15_;
				LibraryPhoto* _tmp16_;
				guint64 flags = 0ULL;
				PhotoRow* _tmp17_;
#line 5097 "../src/Photo.vala"
				if (!_tmp11_) {
#line 33899 "Photo.c"
					gint _tmp12_;
#line 5097 "../src/Photo.vala"
					_tmp12_ = ctr;
#line 5097 "../src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 33905 "Photo.c"
				}
#line 5097 "../src/Photo.vala"
				_tmp11_ = FALSE;
#line 5097 "../src/Photo.vala"
				if (!(ctr < count)) {
#line 5097 "../src/Photo.vala"
					break;
#line 33913 "Photo.c"
				}
#line 5098 "../src/Photo.vala"
				_tmp13_ = all;
#line 5098 "../src/Photo.vala"
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, ctr);
#line 5098 "../src/Photo.vala"
				row = (PhotoRow*) _tmp14_;
#line 5099 "../src/Photo.vala"
				_tmp15_ = row;
#line 5099 "../src/Photo.vala"
				_tmp16_ = library_photo_new (_tmp15_);
#line 5099 "../src/Photo.vala"
				photo = _tmp16_;
#line 5100 "../src/Photo.vala"
				_tmp17_ = row;
#line 5100 "../src/Photo.vala"
				flags = _tmp17_->flags;
#line 5102 "../src/Photo.vala"
				if ((flags & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 33933 "Photo.c"
					GeeArrayList* _tmp18_;
					LibraryPhoto* _tmp19_;
#line 5103 "../src/Photo.vala"
					_tmp18_ = trashed_photos;
#line 5103 "../src/Photo.vala"
					_tmp19_ = photo;
#line 5103 "../src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 33942 "Photo.c"
				} else {
#line 5104 "../src/Photo.vala"
					if ((flags & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 33946 "Photo.c"
						GeeArrayList* _tmp20_;
						LibraryPhoto* _tmp21_;
#line 5105 "../src/Photo.vala"
						_tmp20_ = offline_photos;
#line 5105 "../src/Photo.vala"
						_tmp21_ = photo;
#line 5105 "../src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 33955 "Photo.c"
					} else {
						GeeArrayList* _tmp22_;
						LibraryPhoto* _tmp23_;
#line 5107 "../src/Photo.vala"
						_tmp22_ = all_photos;
#line 5107 "../src/Photo.vala"
						_tmp23_ = photo;
#line 5107 "../src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 33965 "Photo.c"
					}
				}
#line 5110 "../src/Photo.vala"
				if (monitor != NULL) {
#line 5111 "../src/Photo.vala"
					monitor ((guint64) ctr, (guint64) count, TRUE, monitor_target);
#line 33972 "Photo.c"
				}
#line 5097 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5097 "../src/Photo.vala"
				_photo_row_unref0 (row);
#line 33978 "Photo.c"
			}
		}
	}
#line 5115 "../src/Photo.vala"
	_tmp24_ = library_photo_global;
#line 5115 "../src/Photo.vala"
	_tmp25_ = all_photos;
#line 5115 "../src/Photo.vala"
	_tmp26_ = data_collection_add_many ((DataCollection*) _tmp24_, (GeeCollection*) _tmp25_, NULL, NULL);
#line 5115 "../src/Photo.vala"
	_tmp27_ = _tmp26_;
#line 5115 "../src/Photo.vala"
	_g_object_unref0 (_tmp27_);
#line 5116 "../src/Photo.vala"
	_tmp28_ = library_photo_global;
#line 5116 "../src/Photo.vala"
	_tmp29_ = trashed_photos;
#line 5116 "../src/Photo.vala"
	media_source_collection_add_many_to_trash ((MediaSourceCollection*) _tmp28_, (GeeCollection*) _tmp29_);
#line 5117 "../src/Photo.vala"
	_tmp30_ = library_photo_global;
#line 5117 "../src/Photo.vala"
	_tmp31_ = offline_photos;
#line 5117 "../src/Photo.vala"
	media_source_collection_add_many_to_offline ((MediaSourceCollection*) _tmp30_, (GeeCollection*) _tmp31_);
#line 5087 "../src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 5087 "../src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 5087 "../src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 5087 "../src/Photo.vala"
	_g_object_unref0 (all);
#line 34012 "Photo.c"
}

void
library_photo_terminate (void)
{
}

ImportResult
library_photo_import_create (PhotoImportParams* params,
                             LibraryPhoto** photo)
{
	LibraryPhoto* _vala_photo = NULL;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	LibraryPhoto* _tmp5_;
	ImportResult result;
#line 5127 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 5129 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 5129 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5129 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 5129 "../src/Photo.vala"
	photo_table_add (_tmp1_, _tmp2_, &_tmp3_);
#line 5129 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5129 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 5129 "../src/Photo.vala"
	photo_id = _tmp4_;
#line 5130 "../src/Photo.vala"
	if (photo_id_is_invalid (&photo_id)) {
#line 5131 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 5131 "../src/Photo.vala"
		_vala_photo = NULL;
#line 5133 "../src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 5133 "../src/Photo.vala"
		if (photo) {
#line 5133 "../src/Photo.vala"
			*photo = _vala_photo;
#line 34061 "Photo.c"
		} else {
#line 5133 "../src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 34065 "Photo.c"
		}
#line 5133 "../src/Photo.vala"
		return result;
#line 34069 "Photo.c"
	}
#line 5137 "../src/Photo.vala"
	_tmp5_ = library_photo_new_from_import_params (params);
#line 5137 "../src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 5137 "../src/Photo.vala"
	_vala_photo = _tmp5_;
#line 5139 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 5139 "../src/Photo.vala"
	if (photo) {
#line 5139 "../src/Photo.vala"
		*photo = _vala_photo;
#line 34083 "Photo.c"
	} else {
#line 5139 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 34087 "Photo.c"
	}
#line 5139 "../src/Photo.vala"
	return result;
#line 34091 "Photo.c"
}

void
library_photo_import_failed (LibraryPhoto* photo)
{
	GError* _inner_error0_ = NULL;
#line 5142 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 34100 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 5144 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 5144 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5144 "../src/Photo.vala"
		photo_get_photo_id ((Photo*) photo, &_tmp2_);
#line 5144 "../src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp2_, &_inner_error0_);
#line 5144 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 5144 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5144 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 34119 "Photo.c"
				goto __catch0_database_error;
			}
#line 5144 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5144 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5144 "../src/Photo.vala"
			return;
#line 34128 "Photo.c"
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 5143 "../src/Photo.vala"
		err = _inner_error0_;
#line 5143 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5146 "../src/Photo.vala"
		_tmp3_ = err;
#line 5146 "../src/Photo.vala"
		app_window_database_error (_tmp3_);
#line 5143 "../src/Photo.vala"
		_g_error_free0 (err);
#line 34146 "Photo.c"
	}
	__finally0:
#line 5143 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5143 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5143 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5143 "../src/Photo.vala"
		return;
#line 34157 "Photo.c"
	}
}

static void
library_photo_real_notify_master_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5150 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5151 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5153 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5153 "../src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp0_, self, metadata);
#line 34175 "Photo.c"
}

static void
library_photo_real_notify_editable_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5156 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5157 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5159 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5159 "../src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp0_, self, metadata);
#line 34192 "Photo.c"
}

static void
library_photo_real_notify_source_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5162 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5163 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5165 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5165 "../src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp0_, self, metadata);
#line 34209 "Photo.c"
}

static void
library_photo_real_notify_baseline_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5168 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5169 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5171 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5171 "../src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp0_, self, metadata);
#line 34226 "Photo.c"
}

static void
library_photo_generate_thumbnails (LibraryPhoto* self)
{
	GError* _inner_error0_ = NULL;
#line 5174 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 34235 "Photo.c"
	{
#line 5176 "../src/Photo.vala"
		thumbnail_cache_import_from_source ((ThumbnailSource*) self, TRUE, &_inner_error0_);
#line 5176 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 34241 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5175 "../src/Photo.vala"
		err = _inner_error0_;
#line 5175 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5178 "../src/Photo.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 5178 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5178 "../src/Photo.vala"
		_tmp2_ = err;
#line 5178 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5178 "../src/Photo.vala"
		g_warning ("Photo.vala:5178: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5178 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5175 "../src/Photo.vala"
		_g_error_free0 (err);
#line 34271 "Photo.c"
	}
	__finally0:
#line 5175 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5175 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5175 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5175 "../src/Photo.vala"
		return;
#line 34282 "Photo.c"
	}
#line 5182 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 34286 "Photo.c"
}

GeeCollection*
library_photo_get_import_keywords (LibraryPhoto* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 5186 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5187 "../src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 5187 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 5187 "../src/Photo.vala"
	result = _tmp1_;
#line 5187 "../src/Photo.vala"
	return result;
#line 34305 "Photo.c"
}

void
library_photo_clear_import_keywords (LibraryPhoto* self)
{
#line 5190 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5191 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5191 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 34317 "Photo.c"
}

static void
library_photo_real_notify_altered (DataObject* base,
                                   Alteration* alteration)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
#line 5194 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5194 "../src/Photo.vala"
	g_return_if_fail (alteration != NULL);
#line 5196 "../src/Photo.vala"
	if (!self->priv->block_thumbnail_generation) {
#line 5196 "../src/Photo.vala"
		_tmp0_ = alteration_has_subject (alteration, "image");
#line 34334 "Photo.c"
	} else {
#line 5196 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 34338 "Photo.c"
	}
#line 5196 "../src/Photo.vala"
	if (_tmp0_) {
#line 34342 "Photo.c"
		OneShotScheduler* _tmp1_;
#line 5197 "../src/Photo.vala"
		_tmp1_ = self->priv->thumbnail_scheduler;
#line 5197 "../src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp1_, G_PRIORITY_LOW);
#line 34348 "Photo.c"
	}
#line 5199 "../src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), alteration);
#line 34352 "Photo.c"
}

static GdkPixbuf*
library_photo_real_get_preview_pixbuf (MediaSource* base,
                                       Scaling* scaling,
                                       GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 5202 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5202 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5203 "../src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail ((ThumbnailSource*) self, (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error0_);
#line 5203 "../src/Photo.vala"
	pixbuf = _tmp0_;
#line 5203 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5203 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5203 "../src/Photo.vala"
		return NULL;
#line 34380 "Photo.c"
	}
#line 5205 "../src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5205 "../src/Photo.vala"
	result = _tmp1_;
#line 5205 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5205 "../src/Photo.vala"
	return result;
#line 34390 "Photo.c"
}

static void
library_photo_real_rotate (Photo* base,
                           Rotation rotation)
{
	LibraryPhoto * self;
	GError* _inner_error0_ = NULL;
#line 5208 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5210 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5211 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), rotation);
#line 5212 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 34407 "Photo.c"
	{
#line 5220 "../src/Photo.vala"
		thumbnail_cache_rotate ((ThumbnailSource*) self, rotation, &_inner_error0_);
#line 5220 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 34413 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5219 "../src/Photo.vala"
		err = _inner_error0_;
#line 5219 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5223 "../src/Photo.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 5223 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5223 "../src/Photo.vala"
		_tmp2_ = err;
#line 5223 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5223 "../src/Photo.vala"
		g_warning ("Photo.vala:5223: Unable to update thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5223 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5219 "../src/Photo.vala"
		_g_error_free0 (err);
#line 34443 "Photo.c"
	}
	__finally0:
#line 5219 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5219 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5219 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5219 "../src/Photo.vala"
		return;
#line 34454 "Photo.c"
	}
#line 5226 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 34458 "Photo.c"
}

static GdkPixbuf*
library_photo_real_get_thumbnail (ThumbnailSource* base,
                                  gint scale,
                                  GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 5230 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5231 "../src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch ((ThumbnailSource*) self, scale, &_inner_error0_);
#line 5231 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5231 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5231 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5231 "../src/Photo.vala"
		return NULL;
#line 34484 "Photo.c"
	}
#line 5231 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 5231 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 5231 "../src/Photo.vala"
	result = _tmp2_;
#line 5231 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5231 "../src/Photo.vala"
	return result;
#line 34496 "Photo.c"
}

static void
_library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                              gint64 total_num_bytes,
                                                              gpointer self)
{
#line 5244 "../src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 34506 "Photo.c"
}

static void
library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                       BackingPhotoRow* backing,
                                       BackingPhotoID* result,
                                       GError** error)
{
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 5236 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5237 "../src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5238 "../src/Photo.vala"
	if (backing == NULL) {
#line 5238 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 34530 "Photo.c"
	} else {
		const gchar* _tmp1_;
#line 5238 "../src/Photo.vala"
		_tmp1_ = backing->filepath;
#line 5238 "../src/Photo.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 34537 "Photo.c"
	}
#line 5238 "../src/Photo.vala"
	if (_tmp0_) {
#line 5239 "../src/Photo.vala"
		*result = backing_id;
#line 5239 "../src/Photo.vala"
		return;
#line 34545 "Photo.c"
	}
#line 5242 "../src/Photo.vala"
	_tmp2_ = backing->filepath;
#line 5242 "../src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 5242 "../src/Photo.vala"
	file = _tmp3_;
#line 5243 "../src/Photo.vala"
	_tmp4_ = file;
#line 5243 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 34557 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp7_;
		DetectedPhotoInformation* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_;
		BackingPhotoRow* _tmp10_;
#line 5244 "../src/Photo.vala"
		_tmp5_ = file;
#line 5244 "../src/Photo.vala"
		_tmp6_ = library_files_duplicate (_tmp5_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5244 "../src/Photo.vala"
		dupe_file = _tmp6_;
#line 5244 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5244 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5244 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5244 "../src/Photo.vala"
			return;
#line 34581 "Photo.c"
		}
#line 5247 "../src/Photo.vala"
		_tmp7_ = dupe_file;
#line 5247 "../src/Photo.vala"
		_tmp9_ = photo_query_backing_photo_row ((Photo*) self, _tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp8_, &_inner_error0_);
#line 5247 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5247 "../src/Photo.vala"
		detected = _tmp8_;
#line 5247 "../src/Photo.vala"
		state = _tmp9_;
#line 5247 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5247 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5247 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5247 "../src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5247 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5247 "../src/Photo.vala"
			return;
#line 34605 "Photo.c"
		}
#line 5249 "../src/Photo.vala"
		_tmp10_ = state;
#line 5249 "../src/Photo.vala"
		if (_tmp10_ != NULL) {
#line 34611 "Photo.c"
			BackingPhotoTable* _tmp11_;
			BackingPhotoTable* _tmp12_;
			BackingPhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			BackingPhotoID _tmp15_;
#line 5250 "../src/Photo.vala"
			_tmp11_ = backing_photo_table_get_instance ();
#line 5250 "../src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 5250 "../src/Photo.vala"
			_tmp13_ = state;
#line 5250 "../src/Photo.vala"
			backing_photo_table_add (_tmp12_, _tmp13_, &_inner_error0_);
#line 5250 "../src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 5250 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5250 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 5250 "../src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5250 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5250 "../src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5250 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 5250 "../src/Photo.vala"
				return;
#line 34641 "Photo.c"
			}
#line 5251 "../src/Photo.vala"
			_tmp14_ = state;
#line 5251 "../src/Photo.vala"
			_tmp15_ = _tmp14_->id;
#line 5251 "../src/Photo.vala"
			backing_id = _tmp15_;
#line 34649 "Photo.c"
		}
#line 5243 "../src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5243 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5243 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 34657 "Photo.c"
	}
#line 5255 "../src/Photo.vala"
	*result = backing_id;
#line 5255 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 5255 "../src/Photo.vala"
	return;
#line 34665 "Photo.c"
}

LibraryPhoto*
library_photo_duplicate (LibraryPhoto* self,
                         GError** error)
{
	GFile* dupe_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_;
	PhotoRow* _tmp36_;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_;
	Event* _tmp44_;
	gboolean _tmp45_;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_;
	GeeList* _tmp51_;
	GeeCollection* _tmp52_;
	GError* _inner_error0_ = NULL;
	LibraryPhoto* result;
#line 5258 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5260 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 5260 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5260 "../src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5260 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5260 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5260 "../src/Photo.vala"
	dupe_file = _tmp3_;
#line 5260 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5260 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5260 "../src/Photo.vala"
		return NULL;
#line 34752 "Photo.c"
	}
#line 5263 "../src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row ((Photo*) self);
#line 5263 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5263 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error0_);
#line 5263 "../src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5263 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5263 "../src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5263 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5263 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5263 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5263 "../src/Photo.vala"
		return NULL;
#line 34774 "Photo.c"
	}
#line 5264 "../src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_SHOTWELL);
#line 5264 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5264 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error0_);
#line 5264 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5264 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5264 "../src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5264 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5264 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5264 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5264 "../src/Photo.vala"
		return NULL;
#line 34796 "Photo.c"
	}
#line 5266 "../src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_CAMERA);
#line 5266 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5266 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error0_);
#line 5266 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5266 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5266 "../src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5266 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5266 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5266 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5266 "../src/Photo.vala"
		return NULL;
#line 34818 "Photo.c"
	}
#line 5268 "../src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_EMBEDDED);
#line 5268 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5268 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error0_);
#line 5268 "../src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5268 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5268 "../src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5268 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5268 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5268 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5268 "../src/Photo.vala"
		return NULL;
#line 34840 "Photo.c"
	}
#line 5272 "../src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5272 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5272 "../src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp22_);
#line 5272 "../src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5272 "../src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5272 "../src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5272 "../src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5272 "../src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5272 "../src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5272 "../src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5272 "../src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5272 "../src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5272 "../src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5272 "../src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5272 "../src/Photo.vala"
	dupe_id = _tmp31_;
#line 5274 "../src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5274 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5274 "../src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5274 "../src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5274 "../src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5274 "../src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5274 "../src/Photo.vala"
	dupe_row = _tmp36_;
#line 5277 "../src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5277 "../src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5277 "../src/Photo.vala"
	dupe = _tmp38_;
#line 5280 "../src/Photo.vala"
	_tmp39_ = dupe;
#line 5280 "../src/Photo.vala"
	thumbnail_cache_duplicate ((ThumbnailSource*) self, (ThumbnailSource*) _tmp39_);
#line 5283 "../src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5283 "../src/Photo.vala"
	_tmp41_ = dupe;
#line 5283 "../src/Photo.vala"
	data_collection_add ((DataCollection*) _tmp40_, (DataObject*) _tmp41_);
#line 5286 "../src/Photo.vala"
	_tmp42_ = dupe;
#line 5286 "../src/Photo.vala"
	_tmp43_ = media_source_get_event ((MediaSource*) _tmp42_);
#line 5286 "../src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5286 "../src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5286 "../src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5286 "../src/Photo.vala"
	if (_tmp45_) {
#line 34914 "Photo.c"
		LibraryPhoto* _tmp46_;
		Event* _tmp47_;
		Event* _tmp48_;
		LibraryPhoto* _tmp49_;
#line 5287 "../src/Photo.vala"
		_tmp46_ = dupe;
#line 5287 "../src/Photo.vala"
		_tmp47_ = media_source_get_event ((MediaSource*) _tmp46_);
#line 5287 "../src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5287 "../src/Photo.vala"
		_tmp49_ = dupe;
#line 5287 "../src/Photo.vala"
		event_attach (_tmp48_, (MediaSource*) _tmp49_);
#line 5287 "../src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 34931 "Photo.c"
	}
#line 5290 "../src/Photo.vala"
	_tmp50_ = tag_global;
#line 5290 "../src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, (MediaSource*) self);
#line 5290 "../src/Photo.vala"
	tags = (GeeCollection*) _tmp51_;
#line 5291 "../src/Photo.vala"
	_tmp52_ = tags;
#line 5291 "../src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 34943 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
#line 5292 "../src/Photo.vala"
			_tmp53_ = tags;
#line 5292 "../src/Photo.vala"
			_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 5292 "../src/Photo.vala"
			_tag_it = _tmp54_;
#line 5292 "../src/Photo.vala"
			while (TRUE) {
#line 34956 "Photo.c"
				GeeIterator* _tmp55_;
				Tag* tag = NULL;
				GeeIterator* _tmp56_;
				gpointer _tmp57_;
				Tag* _tmp58_;
				LibraryPhoto* _tmp59_;
#line 5292 "../src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5292 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp55_)) {
#line 5292 "../src/Photo.vala"
					break;
#line 34969 "Photo.c"
				}
#line 5292 "../src/Photo.vala"
				_tmp56_ = _tag_it;
#line 5292 "../src/Photo.vala"
				_tmp57_ = gee_iterator_get (_tmp56_);
#line 5292 "../src/Photo.vala"
				tag = (Tag*) _tmp57_;
#line 5293 "../src/Photo.vala"
				_tmp58_ = tag;
#line 5293 "../src/Photo.vala"
				_tmp59_ = dupe;
#line 5293 "../src/Photo.vala"
				tag_attach (_tmp58_, (MediaSource*) _tmp59_);
#line 5292 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 34985 "Photo.c"
			}
#line 5292 "../src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 34989 "Photo.c"
		}
	}
#line 5297 "../src/Photo.vala"
	result = dupe;
#line 5297 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5297 "../src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5297 "../src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5297 "../src/Photo.vala"
	return result;
#line 35002 "Photo.c"
}

static void
library_photo_on_duplicate_progress (LibraryPhoto* self,
                                     gint64 current,
                                     gint64 total)
{
#line 5300 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5301 "../src/Photo.vala"
	spin_event_loop ();
#line 35014 "Photo.c"
}

static gboolean
library_photo_real_is_trashed (MediaSource* base)
{
	LibraryPhoto * self;
	gboolean result;
#line 5305 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5306 "../src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH);
#line 5306 "../src/Photo.vala"
	return result;
#line 35028 "Photo.c"
}

static void
library_photo_real_trash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5309 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5310 "../src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 35039 "Photo.c"
}

static void
library_photo_real_untrash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5313 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5314 "../src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 35050 "Photo.c"
}

static gboolean
library_photo_real_is_offline (Monitorable* base)
{
	LibraryPhoto * self;
	gboolean result;
#line 5317 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5318 "../src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5318 "../src/Photo.vala"
	return result;
#line 35064 "Photo.c"
}

static void
library_photo_real_mark_offline (Monitorable* base)
{
	LibraryPhoto * self;
#line 5321 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5322 "../src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 35075 "Photo.c"
}

static void
library_photo_real_mark_online (Monitorable* base)
{
	LibraryPhoto * self;
#line 5325 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5326 "../src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 35086 "Photo.c"
}

static gboolean
library_photo_real_is_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	gboolean result;
#line 5329 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5330 "../src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5330 "../src/Photo.vala"
	return result;
#line 35100 "Photo.c"
}

static void
library_photo_real_mark_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5333 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5334 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5334 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5334 "../src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5334 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 35119 "Photo.c"
}

static void
library_photo_real_mark_unflagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5337 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5338 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5338 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5338 "../src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5338 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 35138 "Photo.c"
}

static gboolean
library_photo_real_internal_delete_backing (DataSource* base,
                                            GError** error)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 5341 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5344 "../src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_inner_error0_);
#line 5344 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35155 "Photo.c"
		gboolean _tmp1_ = FALSE;
#line 5344 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5344 "../src/Photo.vala"
		return _tmp1_;
#line 35161 "Photo.c"
	}
#line 5344 "../src/Photo.vala"
	if (!_tmp0_) {
#line 5345 "../src/Photo.vala"
		result = FALSE;
#line 5345 "../src/Photo.vala"
		return result;
#line 35169 "Photo.c"
	}
#line 5348 "../src/Photo.vala"
	result = media_source_delete_original_file ((MediaSource*) self);
#line 5348 "../src/Photo.vala"
	return result;
#line 35175 "Photo.c"
}

static void
library_photo_real_destroy (DataSource* base)
{
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 5351 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5352 "../src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp0_);
#line 5352 "../src/Photo.vala"
	photo_id = _tmp0_;
#line 5355 "../src/Photo.vala"
	thumbnail_cache_remove ((ThumbnailSource*) self);
#line 35193 "Photo.c"
	{
		PhotoTable* _tmp1_;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 5361 "../src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5361 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5361 "../src/Photo.vala"
		_tmp3_ = photo_id;
#line 5361 "../src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error0_);
#line 5361 "../src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5361 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5361 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 35212 "Photo.c"
				goto __catch0_database_error;
			}
#line 5361 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5361 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5361 "../src/Photo.vala"
			return;
#line 35221 "Photo.c"
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 5360 "../src/Photo.vala"
		err = _inner_error0_;
#line 5360 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5363 "../src/Photo.vala"
		_tmp4_ = err;
#line 5363 "../src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5360 "../src/Photo.vala"
		_g_error_free0 (err);
#line 35239 "Photo.c"
	}
	__finally0:
#line 5360 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5360 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5360 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5360 "../src/Photo.vala"
		return;
#line 35250 "Photo.c"
	}
#line 5366 "../src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 35254 "Photo.c"
}

gboolean
library_photo_has_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format)
{
	PhotoID _tmp0_ = {0};
	gboolean result;
#line 5371 "../src/Photo.vala"
	library_photo_get_nontrash_duplicate (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5371 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 5371 "../src/Photo.vala"
	return result;
#line 35271 "Photo.c"
}

void
library_photo_get_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format,
                                      PhotoID* result)
{
	PhotoID* ids = NULL;
	gint _tmp0_ = 0;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp2_ = FALSE;
	PhotoID* _tmp3_;
	gint _tmp3__length1;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID _tmp13_ = {0};
#line 5376 "../src/Photo.vala"
	_tmp1_ = photo_get_duplicate_ids (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5376 "../src/Photo.vala"
	ids = _tmp1_;
#line 5376 "../src/Photo.vala"
	ids_length1 = _tmp0_;
#line 5376 "../src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5378 "../src/Photo.vala"
	_tmp3_ = ids;
#line 5378 "../src/Photo.vala"
	_tmp3__length1 = ids_length1;
#line 5378 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 5378 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 35308 "Photo.c"
	} else {
		PhotoID* _tmp4_;
		gint _tmp4__length1;
#line 5378 "../src/Photo.vala"
		_tmp4_ = ids;
#line 5378 "../src/Photo.vala"
		_tmp4__length1 = ids_length1;
#line 5378 "../src/Photo.vala"
		_tmp2_ = _tmp4__length1 == 0;
#line 35318 "Photo.c"
	}
#line 5378 "../src/Photo.vala"
	if (_tmp2_) {
#line 35322 "Photo.c"
		PhotoID _tmp5_ = {0};
#line 5379 "../src/Photo.vala"
		photo_id_init (&_tmp5_, PHOTO_ID_INVALID);
#line 5379 "../src/Photo.vala"
		*result = _tmp5_;
#line 5379 "../src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5379 "../src/Photo.vala"
		return;
#line 35332 "Photo.c"
	}
#line 5382 "../src/Photo.vala"
	_tmp6_ = ids;
#line 5382 "../src/Photo.vala"
	_tmp6__length1 = ids_length1;
#line 35338 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5382 "../src/Photo.vala"
		id_collection = _tmp6_;
#line 5382 "../src/Photo.vala"
		id_collection_length1 = _tmp6__length1;
#line 5382 "../src/Photo.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 35350 "Photo.c"
			PhotoID id = {0};
#line 5382 "../src/Photo.vala"
			id = id_collection[id_it];
#line 35354 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp7_;
				PhotoID _tmp8_;
				LibraryPhoto* _tmp9_;
				gboolean _tmp10_ = FALSE;
				LibraryPhoto* _tmp11_;
#line 5383 "../src/Photo.vala"
				_tmp7_ = library_photo_global;
#line 5383 "../src/Photo.vala"
				_tmp8_ = id;
#line 5383 "../src/Photo.vala"
				_tmp9_ = library_photo_source_collection_fetch (_tmp7_, &_tmp8_);
#line 5383 "../src/Photo.vala"
				photo = _tmp9_;
#line 5384 "../src/Photo.vala"
				_tmp11_ = photo;
#line 5384 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 35374 "Photo.c"
					LibraryPhoto* _tmp12_;
#line 5384 "../src/Photo.vala"
					_tmp12_ = photo;
#line 5384 "../src/Photo.vala"
					_tmp10_ = !media_source_is_trashed ((MediaSource*) _tmp12_);
#line 35380 "Photo.c"
				} else {
#line 5384 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 35384 "Photo.c"
				}
#line 5384 "../src/Photo.vala"
				if (_tmp10_) {
#line 5385 "../src/Photo.vala"
					*result = id;
#line 5385 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 5385 "../src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5385 "../src/Photo.vala"
					return;
#line 35396 "Photo.c"
				}
#line 5382 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 35400 "Photo.c"
			}
		}
	}
#line 5389 "../src/Photo.vala"
	photo_id_init (&_tmp13_, PHOTO_ID_INVALID);
#line 5389 "../src/Photo.vala"
	*result = _tmp13_;
#line 5389 "../src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5389 "../src/Photo.vala"
	return;
#line 35412 "Photo.c"
}

static gboolean
library_photo_real_has_user_generated_metadata (Photo* base)
{
	LibraryPhoto * self;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp9_;
	GeeSet* _tmp10_;
	gint _tmp11_ = 0;
	GeeList* _tmp12_;
	gint tags_count = 0;
	gint _tmp16_ = 0;
	GeeSet* _tmp17_;
	gint keywords_count = 0;
	gboolean _tmp21_ = FALSE;
	GeeList* _tmp22_;
	gboolean result;
#line 5392 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5393 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5393 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5393 "../src/Photo.vala"
	tags = _tmp1_;
#line 5395 "../src/Photo.vala"
	_tmp2_ = photo_source_get_metadata ((PhotoSource*) self);
#line 5395 "../src/Photo.vala"
	metadata = _tmp2_;
#line 5396 "../src/Photo.vala"
	_tmp3_ = metadata;
#line 5396 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 35453 "Photo.c"
		gboolean _tmp4_ = FALSE;
		GeeList* _tmp5_;
#line 5397 "../src/Photo.vala"
		_tmp5_ = tags;
#line 5397 "../src/Photo.vala"
		if (_tmp5_ != NULL) {
#line 5397 "../src/Photo.vala"
			_tmp4_ = TRUE;
#line 35462 "Photo.c"
		} else {
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 5397 "../src/Photo.vala"
			_tmp6_ = tags;
#line 5397 "../src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5397 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5397 "../src/Photo.vala"
			_tmp4_ = _tmp8_ > 0;
#line 35475 "Photo.c"
		}
#line 5397 "../src/Photo.vala"
		result = _tmp4_;
#line 5397 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5397 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5397 "../src/Photo.vala"
		return result;
#line 35485 "Photo.c"
	}
#line 5400 "../src/Photo.vala"
	_tmp9_ = metadata;
#line 5400 "../src/Photo.vala"
	_tmp10_ = photo_metadata_get_keywords (_tmp9_, NULL, NULL, NULL);
#line 5400 "../src/Photo.vala"
	keywords = _tmp10_;
#line 5401 "../src/Photo.vala"
	_tmp12_ = tags;
#line 5401 "../src/Photo.vala"
	if (_tmp12_ != NULL) {
#line 35497 "Photo.c"
		GeeList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 5401 "../src/Photo.vala"
		_tmp13_ = tags;
#line 5401 "../src/Photo.vala"
		_tmp14_ = gee_collection_get_size ((GeeCollection*) _tmp13_);
#line 5401 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 5401 "../src/Photo.vala"
		_tmp11_ = _tmp15_;
#line 35509 "Photo.c"
	} else {
#line 5401 "../src/Photo.vala"
		_tmp11_ = 0;
#line 35513 "Photo.c"
	}
#line 5401 "../src/Photo.vala"
	tags_count = _tmp11_;
#line 5402 "../src/Photo.vala"
	_tmp17_ = keywords;
#line 5402 "../src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 35521 "Photo.c"
		GeeSet* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
#line 5402 "../src/Photo.vala"
		_tmp18_ = keywords;
#line 5402 "../src/Photo.vala"
		_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 5402 "../src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 5402 "../src/Photo.vala"
		_tmp16_ = _tmp20_;
#line 35533 "Photo.c"
	} else {
#line 5402 "../src/Photo.vala"
		_tmp16_ = 0;
#line 35537 "Photo.c"
	}
#line 5402 "../src/Photo.vala"
	keywords_count = _tmp16_;
#line 5404 "../src/Photo.vala"
	if (tags_count != keywords_count) {
#line 5405 "../src/Photo.vala"
		result = TRUE;
#line 5405 "../src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5405 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5405 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5405 "../src/Photo.vala"
		return result;
#line 35553 "Photo.c"
	}
#line 5408 "../src/Photo.vala"
	_tmp22_ = tags;
#line 5408 "../src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 35559 "Photo.c"
		GeeSet* _tmp23_;
#line 5408 "../src/Photo.vala"
		_tmp23_ = keywords;
#line 5408 "../src/Photo.vala"
		_tmp21_ = _tmp23_ != NULL;
#line 35565 "Photo.c"
	} else {
#line 5408 "../src/Photo.vala"
		_tmp21_ = FALSE;
#line 35569 "Photo.c"
	}
#line 5408 "../src/Photo.vala"
	if (_tmp21_) {
#line 35573 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp24_;
			gint _tag_size = 0;
			GeeList* _tmp25_;
			gint _tmp26_;
			gint _tmp27_;
			gint _tag_index = 0;
#line 5409 "../src/Photo.vala"
			_tmp24_ = tags;
#line 5409 "../src/Photo.vala"
			_tag_list = _tmp24_;
#line 5409 "../src/Photo.vala"
			_tmp25_ = _tag_list;
#line 5409 "../src/Photo.vala"
			_tmp26_ = gee_collection_get_size ((GeeCollection*) _tmp25_);
#line 5409 "../src/Photo.vala"
			_tmp27_ = _tmp26_;
#line 5409 "../src/Photo.vala"
			_tag_size = _tmp27_;
#line 5409 "../src/Photo.vala"
			_tag_index = -1;
#line 5409 "../src/Photo.vala"
			while (TRUE) {
#line 35598 "Photo.c"
				gint _tmp28_;
				gint _tmp29_;
				Tag* tag = NULL;
				GeeList* _tmp30_;
				gpointer _tmp31_;
				GeeSet* _tmp32_;
				Tag* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				gboolean _tmp38_;
#line 5409 "../src/Photo.vala"
				_tag_index = _tag_index + 1;
#line 5409 "../src/Photo.vala"
				_tmp28_ = _tag_index;
#line 5409 "../src/Photo.vala"
				_tmp29_ = _tag_size;
#line 5409 "../src/Photo.vala"
				if (!(_tmp28_ < _tmp29_)) {
#line 5409 "../src/Photo.vala"
					break;
#line 35621 "Photo.c"
				}
#line 5409 "../src/Photo.vala"
				_tmp30_ = _tag_list;
#line 5409 "../src/Photo.vala"
				_tmp31_ = gee_list_get (_tmp30_, _tag_index);
#line 5409 "../src/Photo.vala"
				tag = (Tag*) _tmp31_;
#line 5410 "../src/Photo.vala"
				_tmp32_ = keywords;
#line 5410 "../src/Photo.vala"
				_tmp33_ = tag;
#line 5410 "../src/Photo.vala"
				_tmp34_ = data_object_get_name ((DataObject*) _tmp33_);
#line 5410 "../src/Photo.vala"
				_tmp35_ = _tmp34_;
#line 5410 "../src/Photo.vala"
				_tmp36_ = g_utf8_normalize (_tmp35_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5410 "../src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 5410 "../src/Photo.vala"
				_tmp38_ = !gee_collection_contains ((GeeCollection*) _tmp32_, _tmp37_);
#line 5410 "../src/Photo.vala"
				_g_free0 (_tmp37_);
#line 5410 "../src/Photo.vala"
				_g_free0 (_tmp35_);
#line 5410 "../src/Photo.vala"
				if (_tmp38_) {
#line 5411 "../src/Photo.vala"
					result = TRUE;
#line 5411 "../src/Photo.vala"
					_g_object_unref0 (tag);
#line 5411 "../src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5411 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5411 "../src/Photo.vala"
					_g_object_unref0 (tags);
#line 5411 "../src/Photo.vala"
					return result;
#line 35661 "Photo.c"
				}
#line 5409 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 35665 "Photo.c"
			}
		}
	}
#line 5416 "../src/Photo.vala"
	result = FALSE;
#line 5416 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5416 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5416 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5416 "../src/Photo.vala"
	return result;
#line 35679 "Photo.c"
}

static void
library_photo_real_set_user_metadata_for_export (Photo* base,
                                                 PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
#line 5419 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5419 "../src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5420 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5420 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5420 "../src/Photo.vala"
	photo_tags = _tmp1_;
#line 5421 "../src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5421 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 35705 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_;
		GeeCollection* _tmp16_;
#line 5422 "../src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 5422 "../src/Photo.vala"
		string_tags = (GeeCollection*) _tmp3_;
#line 35713 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_;
			gint _tag_size = 0;
			GeeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tag_index = 0;
#line 5423 "../src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5423 "../src/Photo.vala"
			_tag_list = _tmp4_;
#line 5423 "../src/Photo.vala"
			_tmp5_ = _tag_list;
#line 5423 "../src/Photo.vala"
			_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 5423 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5423 "../src/Photo.vala"
			_tag_size = _tmp7_;
#line 5423 "../src/Photo.vala"
			_tag_index = -1;
#line 5423 "../src/Photo.vala"
			while (TRUE) {
#line 35738 "Photo.c"
				gint _tmp8_;
				gint _tmp9_;
				Tag* tag = NULL;
				GeeList* _tmp10_;
				gpointer _tmp11_;
				GeeCollection* _tmp12_;
				Tag* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 5423 "../src/Photo.vala"
				_tag_index = _tag_index + 1;
#line 5423 "../src/Photo.vala"
				_tmp8_ = _tag_index;
#line 5423 "../src/Photo.vala"
				_tmp9_ = _tag_size;
#line 5423 "../src/Photo.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 5423 "../src/Photo.vala"
					break;
#line 35758 "Photo.c"
				}
#line 5423 "../src/Photo.vala"
				_tmp10_ = _tag_list;
#line 5423 "../src/Photo.vala"
				_tmp11_ = gee_list_get (_tmp10_, _tag_index);
#line 5423 "../src/Photo.vala"
				tag = (Tag*) _tmp11_;
#line 5424 "../src/Photo.vala"
				_tmp12_ = string_tags;
#line 5424 "../src/Photo.vala"
				_tmp13_ = tag;
#line 5424 "../src/Photo.vala"
				_tmp14_ = data_object_get_name ((DataObject*) _tmp13_);
#line 5424 "../src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 5424 "../src/Photo.vala"
				gee_collection_add (_tmp12_, _tmp15_);
#line 5424 "../src/Photo.vala"
				_g_free0 (_tmp15_);
#line 5423 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 35780 "Photo.c"
			}
		}
#line 5426 "../src/Photo.vala"
		_tmp16_ = string_tags;
#line 5426 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, _tmp16_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5421 "../src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 35789 "Photo.c"
	} else {
#line 5428 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 35793 "Photo.c"
	}
#line 5419 "../src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 35797 "Photo.c"
}

static void
library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                     PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	GeeCollection* keywords = NULL;
	GeeSet* _tmp3_;
	GeeCollection* _tmp4_;
	HierarchicalTagIndex* _tmp31_;
#line 5432 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5432 "../src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5433 "../src/Photo.vala"
	new_htag_index = NULL;
#line 5435 "../src/Photo.vala"
	if (photo_metadata_has_hierarchical_keywords (metadata)) {
#line 35818 "Photo.c"
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		HierarchicalTagIndex* _tmp2_;
#line 5436 "../src/Photo.vala"
		_tmp0_ = photo_metadata_get_hierarchical_keywords (metadata);
#line 5436 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5436 "../src/Photo.vala"
		_tmp2_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp1_);
#line 5436 "../src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5436 "../src/Photo.vala"
		new_htag_index = _tmp2_;
#line 5436 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 35834 "Photo.c"
	}
#line 5440 "../src/Photo.vala"
	_tmp3_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 5440 "../src/Photo.vala"
	keywords = (GeeCollection*) _tmp3_;
#line 5441 "../src/Photo.vala"
	_tmp4_ = keywords;
#line 5441 "../src/Photo.vala"
	if (_tmp4_ != NULL) {
#line 35844 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
#line 5442 "../src/Photo.vala"
			_tmp5_ = keywords;
#line 5442 "../src/Photo.vala"
			_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 5442 "../src/Photo.vala"
			_keyword_it = _tmp6_;
#line 5442 "../src/Photo.vala"
			while (TRUE) {
#line 35857 "Photo.c"
				GeeIterator* _tmp7_;
				gchar* keyword = NULL;
				GeeIterator* _tmp8_;
				gpointer _tmp9_;
				gboolean _tmp10_ = FALSE;
				HierarchicalTagIndex* _tmp11_;
				gchar* safe_keyword = NULL;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				TagSourceCollection* _tmp18_;
				const gchar* _tmp19_;
				TagSourceCollection* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp28_;
				Tag* _tmp29_;
				Tag* _tmp30_;
#line 5442 "../src/Photo.vala"
				_tmp7_ = _keyword_it;
#line 5442 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp7_)) {
#line 5442 "../src/Photo.vala"
					break;
#line 35883 "Photo.c"
				}
#line 5442 "../src/Photo.vala"
				_tmp8_ = _keyword_it;
#line 5442 "../src/Photo.vala"
				_tmp9_ = gee_iterator_get (_tmp8_);
#line 5442 "../src/Photo.vala"
				keyword = (gchar*) _tmp9_;
#line 5443 "../src/Photo.vala"
				_tmp11_ = new_htag_index;
#line 5443 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 35895 "Photo.c"
					HierarchicalTagIndex* _tmp12_;
					const gchar* _tmp13_;
#line 5443 "../src/Photo.vala"
					_tmp12_ = new_htag_index;
#line 5443 "../src/Photo.vala"
					_tmp13_ = keyword;
#line 5443 "../src/Photo.vala"
					_tmp10_ = hierarchical_tag_index_is_tag_in_index (_tmp12_, _tmp13_);
#line 35904 "Photo.c"
				} else {
#line 5443 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 35908 "Photo.c"
				}
#line 5443 "../src/Photo.vala"
				if (_tmp10_) {
#line 5444 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5444 "../src/Photo.vala"
					continue;
#line 35916 "Photo.c"
				}
#line 5447 "../src/Photo.vala"
				_tmp14_ = keyword;
#line 5447 "../src/Photo.vala"
				_tmp15_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp14_);
#line 5447 "../src/Photo.vala"
				safe_keyword = _tmp15_;
#line 5448 "../src/Photo.vala"
				_tmp16_ = safe_keyword;
#line 5448 "../src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp16_);
#line 5448 "../src/Photo.vala"
				promoted_keyword = _tmp17_;
#line 5451 "../src/Photo.vala"
				_tmp18_ = tag_global;
#line 5451 "../src/Photo.vala"
				_tmp19_ = safe_keyword;
#line 5451 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp18_, _tmp19_, FALSE)) {
#line 35936 "Photo.c"
					const gchar* _tmp20_;
					Tag* _tmp21_;
					Tag* _tmp22_;
#line 5452 "../src/Photo.vala"
					_tmp20_ = safe_keyword;
#line 5452 "../src/Photo.vala"
					_tmp21_ = tag_for_path (_tmp20_);
#line 5452 "../src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5452 "../src/Photo.vala"
					tag_attach (_tmp22_, (MediaSource*) self);
#line 5452 "../src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 5453 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5453 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5453 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5453 "../src/Photo.vala"
					continue;
#line 35958 "Photo.c"
				}
#line 5456 "../src/Photo.vala"
				_tmp23_ = tag_global;
#line 5456 "../src/Photo.vala"
				_tmp24_ = promoted_keyword;
#line 5456 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp23_, _tmp24_, FALSE)) {
#line 35966 "Photo.c"
					const gchar* _tmp25_;
					Tag* _tmp26_;
					Tag* _tmp27_;
#line 5457 "../src/Photo.vala"
					_tmp25_ = promoted_keyword;
#line 5457 "../src/Photo.vala"
					_tmp26_ = tag_for_path (_tmp25_);
#line 5457 "../src/Photo.vala"
					_tmp27_ = _tmp26_;
#line 5457 "../src/Photo.vala"
					tag_attach (_tmp27_, (MediaSource*) self);
#line 5457 "../src/Photo.vala"
					_g_object_unref0 (_tmp27_);
#line 5458 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5458 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5458 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5458 "../src/Photo.vala"
					continue;
#line 35988 "Photo.c"
				}
#line 5461 "../src/Photo.vala"
				_tmp28_ = keyword;
#line 5461 "../src/Photo.vala"
				_tmp29_ = tag_for_path (_tmp28_);
#line 5461 "../src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 5461 "../src/Photo.vala"
				tag_attach (_tmp30_, (MediaSource*) self);
#line 5461 "../src/Photo.vala"
				_g_object_unref0 (_tmp30_);
#line 5442 "../src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5442 "../src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5442 "../src/Photo.vala"
				_g_free0 (keyword);
#line 36006 "Photo.c"
			}
#line 5442 "../src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 36010 "Photo.c"
		}
	}
#line 5465 "../src/Photo.vala"
	_tmp31_ = new_htag_index;
#line 5465 "../src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 36017 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
			GeeIterator* _tmp36_;
#line 5466 "../src/Photo.vala"
			_tmp32_ = new_htag_index;
#line 5466 "../src/Photo.vala"
			_tmp33_ = hierarchical_tag_index_get_all_paths (_tmp32_);
#line 5466 "../src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 5466 "../src/Photo.vala"
			_tmp35_ = gee_iterable_iterator ((GeeIterable*) _tmp34_);
#line 5466 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 5466 "../src/Photo.vala"
			_g_object_unref0 (_tmp34_);
#line 5466 "../src/Photo.vala"
			_path_it = _tmp36_;
#line 5466 "../src/Photo.vala"
			while (TRUE) {
#line 36041 "Photo.c"
				GeeIterator* _tmp37_;
				gchar* path = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				const gchar* _tmp40_;
				Tag* _tmp41_;
				Tag* _tmp42_;
#line 5466 "../src/Photo.vala"
				_tmp37_ = _path_it;
#line 5466 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5466 "../src/Photo.vala"
					break;
#line 36055 "Photo.c"
				}
#line 5466 "../src/Photo.vala"
				_tmp38_ = _path_it;
#line 5466 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5466 "../src/Photo.vala"
				path = (gchar*) _tmp39_;
#line 5467 "../src/Photo.vala"
				_tmp40_ = path;
#line 5467 "../src/Photo.vala"
				_tmp41_ = tag_for_path (_tmp40_);
#line 5467 "../src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5467 "../src/Photo.vala"
				tag_attach (_tmp42_, (MediaSource*) self);
#line 5467 "../src/Photo.vala"
				_g_object_unref0 (_tmp42_);
#line 5466 "../src/Photo.vala"
				_g_free0 (path);
#line 36075 "Photo.c"
			}
#line 5466 "../src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 36079 "Photo.c"
		}
	}
#line 5432 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5432 "../src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 36086 "Photo.c"
}

static void
library_photo_class_init (LibraryPhotoClass * klass,
                          gpointer klass_data)
{
#line 5047 "../src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 5047 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhoto_private_offset);
#line 5047 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_master_reimported;
#line 5047 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_editable_reimported;
#line 5047 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_source_reimported;
#line 5047 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_baseline_reimported;
#line 5047 "../src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) library_photo_real_notify_altered;
#line 5047 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) library_photo_real_get_preview_pixbuf;
#line 5047 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) library_photo_real_rotate;
#line 5047 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) library_photo_real_get_thumbnail;
#line 5047 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) library_photo_real_is_trashed;
#line 5047 "../src/Photo.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) library_photo_real_trash;
#line 5047 "../src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) library_photo_real_untrash;
#line 5047 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) library_photo_real_is_offline;
#line 5047 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) library_photo_real_mark_offline;
#line 5047 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) library_photo_real_mark_online;
#line 5047 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) library_photo_real_internal_delete_backing;
#line 5047 "../src/Photo.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) library_photo_real_destroy;
#line 5047 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) library_photo_real_has_user_generated_metadata;
#line 5047 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_set_user_metadata_for_export;
#line 5047 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_apply_user_metadata_for_reimport;
#line 5047 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 36137 "Photo.c"
}

static void
library_photo_flaggable_interface_init (FlaggableIface * iface,
                                        gpointer iface_data)
{
#line 5047 "../src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 5047 "../src/Photo.vala"
	iface->is_flagged = (gboolean (*) (Flaggable*)) library_photo_real_is_flagged;
#line 5047 "../src/Photo.vala"
	iface->mark_flagged = (void (*) (Flaggable*)) library_photo_real_mark_flagged;
#line 5047 "../src/Photo.vala"
	iface->mark_unflagged = (void (*) (Flaggable*)) library_photo_real_mark_unflagged;
#line 36152 "Photo.c"
}

static void
library_photo_monitorable_interface_init (MonitorableIface * iface,
                                          gpointer iface_data)
{
#line 5047 "../src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 5047 "../src/Photo.vala"
	iface->is_offline = (gboolean (*) (Monitorable*)) library_photo_real_is_offline;
#line 5047 "../src/Photo.vala"
	iface->mark_offline = (void (*) (Monitorable*)) library_photo_real_mark_offline;
#line 5047 "../src/Photo.vala"
	iface->mark_online = (void (*) (Monitorable*)) library_photo_real_mark_online;
#line 5047 "../src/Photo.vala"
	iface->set_master_file = (void (*) (Monitorable*, GFile*)) photo_set_master_file;
#line 5047 "../src/Photo.vala"
	iface->set_master_timestamp = (void (*) (Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 36171 "Photo.c"
}

static void
library_photo_instance_init (LibraryPhoto * self,
                             gpointer klass)
{
#line 5047 "../src/Photo.vala"
	self->priv = library_photo_get_instance_private (self);
#line 5058 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 5059 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 36184 "Photo.c"
}

static void
library_photo_finalize (GObject * obj)
{
	LibraryPhoto * self;
#line 5047 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5059 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5060 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5047 "../src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 36199 "Photo.c"
}

static GType
library_photo_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
	static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType library_photo_type_id;
	library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
	g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
	g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
	LibraryPhoto_private_offset = g_type_add_instance_private (library_photo_type_id, sizeof (LibraryPhotoPrivate));
	return library_photo_type_id;
}

GType
library_photo_get_type (void)
{
	static volatile gsize library_photo_type_id__once = 0;
	if (g_once_init_enter (&library_photo_type_id__once)) {
		GType library_photo_type_id;
		library_photo_type_id = library_photo_get_type_once ();
		g_once_init_leave (&library_photo_type_id__once, library_photo_type_id);
	}
	return library_photo_type_id__once;
}

static inline gpointer
library_photo_source_holding_tank_get_instance_private (LibraryPhotoSourceHoldingTank* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceHoldingTank_private_offset);
}

LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_construct (GType object_type,
                                             LibraryPhotoSourceCollection* sources,
                                             SourceHoldingTankCheckToKeep check_to_keep,
                                             gpointer check_to_keep_target,
                                             GetSourceDatabaseKey get_key,
                                             gpointer get_key_target)
{
	LibraryPhotoSourceHoldingTank* self = NULL;
#line 5483 "../src/Photo.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 5485 "../src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, (MediaSourceCollection*) sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 5483 "../src/Photo.vala"
	return self;
#line 36249 "Photo.c"
}

LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                       SourceHoldingTankCheckToKeep check_to_keep,
                                       gpointer check_to_keep_target,
                                       GetSourceDatabaseKey get_key,
                                       gpointer get_key_target)
{
#line 5483 "../src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 36261 "Photo.c"
}

LibraryPhoto*
library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                         GFile* file)
{
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	LibraryPhoto* result;
#line 5488 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5488 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 5489 "../src/Photo.vala"
	ret = NULL;
#line 5490 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5490 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 5490 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5490 "../src/Photo.vala"
	ret = (LibraryPhoto*) _tmp1_;
#line 5491 "../src/Photo.vala"
	_tmp2_ = ret;
#line 5491 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 5492 "../src/Photo.vala"
		result = ret;
#line 5492 "../src/Photo.vala"
		return result;
#line 36297 "Photo.c"
	}
#line 5495 "../src/Photo.vala"
	_tmp3_ = self->priv->development_file_map;
#line 5495 "../src/Photo.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, file);
#line 5495 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp4_;
#line 5495 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5495 "../src/Photo.vala"
	return result;
#line 36309 "Photo.c"
}

static void
_library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                 GFile* old_file,
                                                                                 GFile* new_file,
                                                                                 gpointer self)
{
#line 5519 "../src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 36320 "Photo.c"
}

static void
_library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                               gpointer self)
{
#line 5520 "../src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 36329 "Photo.c"
}

static void
library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                GeeCollection* added,
                                                                GeeCollection* removed)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5498 "../src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) base;
#line 5500 "../src/Photo.vala"
	if (added != NULL) {
#line 36342 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp0_;
#line 5501 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) added);
#line 5501 "../src/Photo.vala"
			_source_it = _tmp0_;
#line 5501 "../src/Photo.vala"
			while (TRUE) {
#line 36352 "Photo.c"
				GeeIterator* _tmp1_;
				DataSource* source = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp4_;
				LibraryPhoto* _tmp5_;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				gboolean _tmp9_;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				LibraryPhoto* _tmp34_;
				LibraryPhoto* _tmp35_;
#line 5501 "../src/Photo.vala"
				_tmp1_ = _source_it;
#line 5501 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 5501 "../src/Photo.vala"
					break;
#line 36376 "Photo.c"
				}
#line 5501 "../src/Photo.vala"
				_tmp2_ = _source_it;
#line 5501 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 5501 "../src/Photo.vala"
				source = (DataSource*) _tmp3_;
#line 5502 "../src/Photo.vala"
				_tmp4_ = source;
#line 5502 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5502 "../src/Photo.vala"
				photo = _tmp5_;
#line 5505 "../src/Photo.vala"
				_tmp6_ = photo;
#line 5505 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file ((Photo*) _tmp6_);
#line 5505 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 5505 "../src/Photo.vala"
				_tmp9_ = _tmp8_ != NULL;
#line 5505 "../src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 5505 "../src/Photo.vala"
				if (_tmp9_) {
#line 36402 "Photo.c"
					GeeHashMap* _tmp10_;
					LibraryPhoto* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
					GeeMultiMap* _tmp15_;
					LibraryPhoto* _tmp16_;
					LibraryPhoto* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 5506 "../src/Photo.vala"
					_tmp10_ = self->priv->editable_file_map;
#line 5506 "../src/Photo.vala"
					_tmp11_ = photo;
#line 5506 "../src/Photo.vala"
					_tmp12_ = photo_get_editable_file ((Photo*) _tmp11_);
#line 5506 "../src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 5506 "../src/Photo.vala"
					_tmp14_ = photo;
#line 5506 "../src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp13_, _tmp14_);
#line 5506 "../src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 5507 "../src/Photo.vala"
					_tmp15_ = self->priv->reverse_editable_file_map;
#line 5507 "../src/Photo.vala"
					_tmp16_ = photo;
#line 5507 "../src/Photo.vala"
					_tmp17_ = photo;
#line 5507 "../src/Photo.vala"
					_tmp18_ = photo_get_editable_file ((Photo*) _tmp17_);
#line 5507 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 5507 "../src/Photo.vala"
					gee_multi_map_set (_tmp15_, _tmp16_, _tmp19_);
#line 5507 "../src/Photo.vala"
					_g_object_unref0 (_tmp19_);
#line 36441 "Photo.c"
				}
#line 5511 "../src/Photo.vala"
				_tmp20_ = photo;
#line 5511 "../src/Photo.vala"
				_tmp21_ = photo_get_raw_developer_files ((Photo*) _tmp20_);
#line 5511 "../src/Photo.vala"
				raw_files = _tmp21_;
#line 5512 "../src/Photo.vala"
				_tmp22_ = raw_files;
#line 5512 "../src/Photo.vala"
				if (_tmp22_ != NULL) {
#line 36453 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp23_;
						GeeIterator* _tmp24_;
#line 5513 "../src/Photo.vala"
						_tmp23_ = raw_files;
#line 5513 "../src/Photo.vala"
						_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 5513 "../src/Photo.vala"
						_f_it = _tmp24_;
#line 5513 "../src/Photo.vala"
						while (TRUE) {
#line 36466 "Photo.c"
							GeeIterator* _tmp25_;
							GFile* f = NULL;
							GeeIterator* _tmp26_;
							gpointer _tmp27_;
							GeeHashMap* _tmp28_;
							GFile* _tmp29_;
							LibraryPhoto* _tmp30_;
							GeeMultiMap* _tmp31_;
							LibraryPhoto* _tmp32_;
							GFile* _tmp33_;
#line 5513 "../src/Photo.vala"
							_tmp25_ = _f_it;
#line 5513 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp25_)) {
#line 5513 "../src/Photo.vala"
								break;
#line 36483 "Photo.c"
							}
#line 5513 "../src/Photo.vala"
							_tmp26_ = _f_it;
#line 5513 "../src/Photo.vala"
							_tmp27_ = gee_iterator_get (_tmp26_);
#line 5513 "../src/Photo.vala"
							f = (GFile*) _tmp27_;
#line 5514 "../src/Photo.vala"
							_tmp28_ = self->priv->development_file_map;
#line 5514 "../src/Photo.vala"
							_tmp29_ = f;
#line 5514 "../src/Photo.vala"
							_tmp30_ = photo;
#line 5514 "../src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, _tmp29_, _tmp30_);
#line 5515 "../src/Photo.vala"
							_tmp31_ = self->priv->reverse_development_file_map;
#line 5515 "../src/Photo.vala"
							_tmp32_ = photo;
#line 5515 "../src/Photo.vala"
							_tmp33_ = f;
#line 5515 "../src/Photo.vala"
							gee_multi_map_set (_tmp31_, _tmp32_, _tmp33_);
#line 5513 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 36509 "Photo.c"
						}
#line 5513 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 36513 "Photo.c"
					}
				}
#line 5519 "../src/Photo.vala"
				_tmp34_ = photo;
#line 5519 "../src/Photo.vala"
				g_signal_connect ((Photo*) _tmp34_, "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5520 "../src/Photo.vala"
				_tmp35_ = photo;
#line 5520 "../src/Photo.vala"
				g_signal_connect ((Photo*) _tmp35_, "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5501 "../src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5501 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5501 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 36530 "Photo.c"
			}
#line 5501 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 36534 "Photo.c"
		}
	}
#line 5524 "../src/Photo.vala"
	if (removed != NULL) {
#line 36539 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp36_;
#line 5525 "../src/Photo.vala"
			_tmp36_ = gee_iterable_iterator ((GeeIterable*) removed);
#line 5525 "../src/Photo.vala"
			_source_it = _tmp36_;
#line 5525 "../src/Photo.vala"
			while (TRUE) {
#line 36549 "Photo.c"
				GeeIterator* _tmp37_;
				DataSource* source = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeMultiMap* _tmp64_;
				LibraryPhoto* _tmp65_;
				GeeMultiMap* _tmp66_;
				LibraryPhoto* _tmp67_;
				LibraryPhoto* _tmp68_;
				guint _tmp69_;
				LibraryPhoto* _tmp70_;
				guint _tmp71_;
#line 5525 "../src/Photo.vala"
				_tmp37_ = _source_it;
#line 5525 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5525 "../src/Photo.vala"
					break;
#line 36571 "Photo.c"
				}
#line 5525 "../src/Photo.vala"
				_tmp38_ = _source_it;
#line 5525 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5525 "../src/Photo.vala"
				source = (DataSource*) _tmp39_;
#line 5526 "../src/Photo.vala"
				_tmp40_ = source;
#line 5526 "../src/Photo.vala"
				_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5526 "../src/Photo.vala"
				photo = _tmp41_;
#line 36585 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeCollection* _tmp44_;
					GeeCollection* _tmp45_;
					GeeIterator* _tmp46_;
					GeeIterator* _tmp47_;
#line 5527 "../src/Photo.vala"
					_tmp42_ = self->priv->reverse_editable_file_map;
#line 5527 "../src/Photo.vala"
					_tmp43_ = photo;
#line 5527 "../src/Photo.vala"
					_tmp44_ = gee_multi_map_get (_tmp42_, _tmp43_);
#line 5527 "../src/Photo.vala"
					_tmp45_ = _tmp44_;
#line 5527 "../src/Photo.vala"
					_tmp46_ = gee_iterable_iterator ((GeeIterable*) _tmp45_);
#line 5527 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 5527 "../src/Photo.vala"
					_g_object_unref0 (_tmp45_);
#line 5527 "../src/Photo.vala"
					_f_it = _tmp47_;
#line 5527 "../src/Photo.vala"
					while (TRUE) {
#line 36612 "Photo.c"
						GeeIterator* _tmp48_;
						GFile* f = NULL;
						GeeIterator* _tmp49_;
						gpointer _tmp50_;
						GeeHashMap* _tmp51_;
						GFile* _tmp52_;
#line 5527 "../src/Photo.vala"
						_tmp48_ = _f_it;
#line 5527 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp48_)) {
#line 5527 "../src/Photo.vala"
							break;
#line 36625 "Photo.c"
						}
#line 5527 "../src/Photo.vala"
						_tmp49_ = _f_it;
#line 5527 "../src/Photo.vala"
						_tmp50_ = gee_iterator_get (_tmp49_);
#line 5527 "../src/Photo.vala"
						f = (GFile*) _tmp50_;
#line 5528 "../src/Photo.vala"
						_tmp51_ = self->priv->editable_file_map;
#line 5528 "../src/Photo.vala"
						_tmp52_ = f;
#line 5528 "../src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp51_, _tmp52_, NULL);
#line 5527 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 36641 "Photo.c"
					}
#line 5527 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 36645 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp53_;
					LibraryPhoto* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 5531 "../src/Photo.vala"
					_tmp53_ = self->priv->reverse_development_file_map;
#line 5531 "../src/Photo.vala"
					_tmp54_ = photo;
#line 5531 "../src/Photo.vala"
					_tmp55_ = gee_multi_map_get (_tmp53_, _tmp54_);
#line 5531 "../src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 5531 "../src/Photo.vala"
					_tmp57_ = gee_iterable_iterator ((GeeIterable*) _tmp56_);
#line 5531 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 5531 "../src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 5531 "../src/Photo.vala"
					_f_it = _tmp58_;
#line 5531 "../src/Photo.vala"
					while (TRUE) {
#line 36673 "Photo.c"
						GeeIterator* _tmp59_;
						GFile* f = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						GeeHashMap* _tmp62_;
						GFile* _tmp63_;
#line 5531 "../src/Photo.vala"
						_tmp59_ = _f_it;
#line 5531 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 5531 "../src/Photo.vala"
							break;
#line 36686 "Photo.c"
						}
#line 5531 "../src/Photo.vala"
						_tmp60_ = _f_it;
#line 5531 "../src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 5531 "../src/Photo.vala"
						f = (GFile*) _tmp61_;
#line 5532 "../src/Photo.vala"
						_tmp62_ = self->priv->development_file_map;
#line 5532 "../src/Photo.vala"
						_tmp63_ = f;
#line 5532 "../src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp62_, _tmp63_, NULL);
#line 5531 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 36702 "Photo.c"
					}
#line 5531 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 36706 "Photo.c"
				}
#line 5535 "../src/Photo.vala"
				_tmp64_ = self->priv->reverse_editable_file_map;
#line 5535 "../src/Photo.vala"
				_tmp65_ = photo;
#line 5535 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp64_, _tmp65_);
#line 5536 "../src/Photo.vala"
				_tmp66_ = self->priv->reverse_development_file_map;
#line 5536 "../src/Photo.vala"
				_tmp67_ = photo;
#line 5536 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp66_, _tmp67_);
#line 5538 "../src/Photo.vala"
				_tmp68_ = photo;
#line 5538 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp69_, NULL, FALSE);
#line 5538 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp68_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp69_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5539 "../src/Photo.vala"
				_tmp70_ = photo;
#line 5539 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp71_, NULL, FALSE);
#line 5539 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp70_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp71_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5525 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5525 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 36736 "Photo.c"
			}
#line 5525 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 36740 "Photo.c"
		}
	}
#line 5543 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered ((SourceHoldingTank*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), added, removed);
#line 36745 "Photo.c"
}

static void
library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                        Photo* _photo,
                                                        GFile* old_file,
                                                        GFile* new_file)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 5546 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5546 "../src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5547 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 5547 "../src/Photo.vala"
	photo = _tmp0_;
#line 5548 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5548 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5550 "../src/Photo.vala"
	if (old_file != NULL) {
#line 36773 "Photo.c"
		GeeHashMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		LibraryPhoto* _tmp4_;
#line 5551 "../src/Photo.vala"
		_tmp2_ = self->priv->editable_file_map;
#line 5551 "../src/Photo.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp2_, old_file, NULL);
#line 5552 "../src/Photo.vala"
		_tmp3_ = self->priv->reverse_editable_file_map;
#line 5552 "../src/Photo.vala"
		_tmp4_ = photo;
#line 5552 "../src/Photo.vala"
		gee_multi_map_remove (_tmp3_, _tmp4_, old_file);
#line 36787 "Photo.c"
	}
#line 5555 "../src/Photo.vala"
	if (new_file != NULL) {
#line 36791 "Photo.c"
		GeeHashMap* _tmp5_;
		LibraryPhoto* _tmp6_;
#line 5556 "../src/Photo.vala"
		_tmp5_ = self->priv->editable_file_map;
#line 5556 "../src/Photo.vala"
		_tmp6_ = photo;
#line 5556 "../src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, new_file, _tmp6_);
#line 36800 "Photo.c"
	}
#line 5558 "../src/Photo.vala"
	_tmp7_ = self->priv->reverse_editable_file_map;
#line 5558 "../src/Photo.vala"
	_tmp8_ = photo;
#line 5558 "../src/Photo.vala"
	gee_multi_map_set (_tmp7_, _tmp8_, new_file);
#line 5546 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 36810 "Photo.c"
}

static void
library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                               Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp17_;
	GeeCollection* _tmp18_;
	GeeCollection* _tmp19_;
#line 5561 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5561 "../src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5562 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 5562 "../src/Photo.vala"
	photo = _tmp0_;
#line 5563 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5563 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5566 "../src/Photo.vala"
	_tmp2_ = self->priv->reverse_development_file_map;
#line 5566 "../src/Photo.vala"
	_tmp3_ = photo;
#line 5566 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 36844 "Photo.c"
		GeeMultiMap* _tmp15_;
		LibraryPhoto* _tmp16_;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 5567 "../src/Photo.vala"
			_tmp4_ = self->priv->reverse_development_file_map;
#line 5567 "../src/Photo.vala"
			_tmp5_ = photo;
#line 5567 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 5567 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5567 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 5567 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5567 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 5567 "../src/Photo.vala"
			_f_it = _tmp9_;
#line 5567 "../src/Photo.vala"
			while (TRUE) {
#line 36873 "Photo.c"
				GeeIterator* _tmp10_;
				GFile* f = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				GeeHashMap* _tmp13_;
				GFile* _tmp14_;
#line 5567 "../src/Photo.vala"
				_tmp10_ = _f_it;
#line 5567 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 5567 "../src/Photo.vala"
					break;
#line 36886 "Photo.c"
				}
#line 5567 "../src/Photo.vala"
				_tmp11_ = _f_it;
#line 5567 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 5567 "../src/Photo.vala"
				f = (GFile*) _tmp12_;
#line 5568 "../src/Photo.vala"
				_tmp13_ = self->priv->development_file_map;
#line 5568 "../src/Photo.vala"
				_tmp14_ = f;
#line 5568 "../src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp13_, _tmp14_, NULL);
#line 5567 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 36902 "Photo.c"
			}
#line 5567 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 36906 "Photo.c"
		}
#line 5570 "../src/Photo.vala"
		_tmp15_ = self->priv->reverse_development_file_map;
#line 5570 "../src/Photo.vala"
		_tmp16_ = photo;
#line 5570 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp15_, _tmp16_);
#line 36914 "Photo.c"
	}
#line 5574 "../src/Photo.vala"
	_tmp17_ = photo;
#line 5574 "../src/Photo.vala"
	_tmp18_ = photo_get_raw_developer_files ((Photo*) _tmp17_);
#line 5574 "../src/Photo.vala"
	raw_list = _tmp18_;
#line 5575 "../src/Photo.vala"
	_tmp19_ = raw_list;
#line 5575 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 36926 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp20_;
			GeeIterator* _tmp21_;
#line 5576 "../src/Photo.vala"
			_tmp20_ = raw_list;
#line 5576 "../src/Photo.vala"
			_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 5576 "../src/Photo.vala"
			_f_it = _tmp21_;
#line 5576 "../src/Photo.vala"
			while (TRUE) {
#line 36939 "Photo.c"
				GeeIterator* _tmp22_;
				GFile* f = NULL;
				GeeIterator* _tmp23_;
				gpointer _tmp24_;
				GeeHashMap* _tmp25_;
				GFile* _tmp26_;
				LibraryPhoto* _tmp27_;
				GeeMultiMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GFile* _tmp30_;
#line 5576 "../src/Photo.vala"
				_tmp22_ = _f_it;
#line 5576 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp22_)) {
#line 5576 "../src/Photo.vala"
					break;
#line 36956 "Photo.c"
				}
#line 5576 "../src/Photo.vala"
				_tmp23_ = _f_it;
#line 5576 "../src/Photo.vala"
				_tmp24_ = gee_iterator_get (_tmp23_);
#line 5576 "../src/Photo.vala"
				f = (GFile*) _tmp24_;
#line 5577 "../src/Photo.vala"
				_tmp25_ = self->priv->development_file_map;
#line 5577 "../src/Photo.vala"
				_tmp26_ = f;
#line 5577 "../src/Photo.vala"
				_tmp27_ = photo;
#line 5577 "../src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, _tmp26_, _tmp27_);
#line 5578 "../src/Photo.vala"
				_tmp28_ = self->priv->reverse_development_file_map;
#line 5578 "../src/Photo.vala"
				_tmp29_ = photo;
#line 5578 "../src/Photo.vala"
				_tmp30_ = f;
#line 5578 "../src/Photo.vala"
				gee_multi_map_set (_tmp28_, _tmp29_, _tmp30_);
#line 5576 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 36982 "Photo.c"
			}
#line 5576 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 36986 "Photo.c"
		}
	}
#line 5561 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5561 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 36993 "Photo.c"
}

static void
library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass,
                                              gpointer klass_data)
{
#line 5473 "../src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5473 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5473 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceHoldingTank_private_offset);
#line 5473 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank*, GeeCollection*, GeeCollection*)) library_photo_source_holding_tank_real_notify_contents_altered;
#line 37008 "Photo.c"
}

static void
library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self,
                                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GeeHashMultiMap* _tmp3_;
#line 5473 "../src/Photo.vala"
	self->priv = library_photo_source_holding_tank_get_instance_private (self);
#line 5474 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5474 "../src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5476 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5476 "../src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5478 "../src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5478 "../src/Photo.vala"
	self->priv->reverse_editable_file_map = (GeeMultiMap*) _tmp2_;
#line 5480 "../src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5480 "../src/Photo.vala"
	self->priv->reverse_development_file_map = (GeeMultiMap*) _tmp3_;
#line 37037 "Photo.c"
}

static void
library_photo_source_holding_tank_finalize (SourceHoldingTank * obj)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5473 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5474 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5476 "../src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5478 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5480 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5473 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 37056 "Photo.c"
}

static GType
library_photo_source_holding_tank_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
	GType library_photo_source_holding_tank_type_id;
	library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
	LibraryPhotoSourceHoldingTank_private_offset = g_type_add_instance_private (library_photo_source_holding_tank_type_id, sizeof (LibraryPhotoSourceHoldingTankPrivate));
	return library_photo_source_holding_tank_type_id;
}

GType
library_photo_source_holding_tank_get_type (void)
{
	static volatile gsize library_photo_source_holding_tank_type_id__once = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__once)) {
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = library_photo_source_holding_tank_get_type_once ();
		g_once_init_leave (&library_photo_source_holding_tank_type_id__once, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

