/* CollectionPage.c generated by valac 0.56.18, the Vala compiler
 * generated from CollectionPage.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gee.h>

#define COLLECTION_PAGE_DESKTOP_SLIDESHOW_TRANSITION_SEC 2.0
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	COLLECTION_PAGE_0_PROPERTY,
	COLLECTION_PAGE_NUM_PROPERTIES
};
static GParamSpec* collection_page_properties[COLLECTION_PAGE_NUM_PROPERTIES];
typedef enum  {
	COLLECTION_PAGE_TARGET_TYPE_GNOME_COPIED_FILES,
	COLLECTION_PAGE_TARGET_TYPE_TEXT_URI_LIST
} CollectionPageTargetType;

#define COLLECTION_PAGE_TYPE_TARGET_TYPE (collection_page_target_type_get_type ())
#define _exporter_ui_unref0(var) ((var == NULL) ? NULL : (var = (exporter_ui_unref (var), NULL)))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
#define _print_manager_unref0(var) ((var == NULL) ? NULL : (var = (print_manager_unref (var), NULL)))
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))

#define TYPE_SLIDESHOW_PAGE (slideshow_page_get_type ())
#define SLIDESHOW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SLIDESHOW_PAGE, SlideshowPage))
#define SLIDESHOW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SLIDESHOW_PAGE, SlideshowPageClass))
#define IS_SLIDESHOW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SLIDESHOW_PAGE))
#define IS_SLIDESHOW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SLIDESHOW_PAGE))
#define SLIDESHOW_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SLIDESHOW_PAGE, SlideshowPageClass))

typedef struct _SlideshowPage SlideshowPage;
typedef struct _SlideshowPageClass SlideshowPageClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _CollectionPagePrivate {
	ExporterUI* exporter;
	CollectionPageCollectionSearchViewFilter* search_filter;
	GtkToggleButton* enhance_button;
	GtkMenu* item_context_menu;
	GtkMenu* contractor_menu;
	GtkButton* rotate_button;
	GtkButton* flip_button;
};

struct _Block8Data {
	int _ref_count_;
	CollectionPage* self;
	GtkAction* copy_images_action;
	GtkAction* revert_action;
	GtkAction* duplicate_action;
	GtkAction* copy_color_action;
	GtkAction* paste_color_action;
	GtkAction* flag_action;
	GtkAction* raw_developer_app_action;
	GtkAction* raw_developer_camera_action;
	GtkAction* adjust_datetime_action;
	GtkAction* new_event_action;
	GtkAction* jump_event_action;
	GtkAction* print_action;
	GtkAction* export_action;
	GtkAction* remove_action;
	GtkAction* trash_action;
};

static gint CollectionPage_private_offset;
static gpointer collection_page_parent_class = NULL;
static GList* collection_page_copied_photos;
static GList* collection_page_copied_photos = NULL;
static GtkClipboard* collection_page_clipboard;
static GtkClipboard* collection_page_clipboard = NULL;
static gpointer collection_page_collection_search_view_filter_parent_class = NULL;

static GType collection_page_target_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void collection_page_real_add_toolbar_widgets (Page* base,
                                               GtkActionBar* toolbar);
static void collection_page_on_slideshow (CollectionPage* self);
static void _collection_page_on_slideshow_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void collection_page_on_rotate_clockwise (CollectionPage* self);
static void _collection_page_on_rotate_clockwise_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void collection_page_on_flip_horizontally (CollectionPage* self);
static void _collection_page_on_flip_horizontally_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self);
static void collection_page_on_enhance (CollectionPage* self);
static void _collection_page_on_enhance_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
static void collection_page_on_show_sidebar (CollectionPage* self);
static void _collection_page_on_show_sidebar_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static GtkMenu* collection_page_real_get_item_context_menu (CheckerboardPage* base);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda79_ (Block8Data* _data8_);
static void ____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda80_ (Block8Data* _data8_);
static void ____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda81_ (Block8Data* _data8_);
static void ____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda82_ (Block8Data* _data8_);
static void ____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda83_ (Block8Data* _data8_);
static void ____lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda84_ (Block8Data* _data8_);
static void ____lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda85_ (Block8Data* _data8_);
static void ____lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda86_ (Block8Data* _data8_);
static void ____lambda86__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda87_ (Block8Data* _data8_);
static void ____lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda88_ (Block8Data* _data8_);
static void ____lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda89_ (Block8Data* _data8_);
static void ____lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda90_ (Block8Data* _data8_);
static void ____lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda91_ (Block8Data* _data8_);
static void ____lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda92_ (Block8Data* _data8_);
static void ____lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda93_ (Block8Data* _data8_);
static void ____lambda93__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static GtkActionEntry* collection_page_real_init_collect_action_entries (Page* base,
                                                                  gint* result_length1);
static void collection_page_on_print (CollectionPage* self);
static void _collection_page_on_print_gcallback (GtkAction* action,
                                          gpointer self);
static void _collection_page_on_rotate_clockwise_gcallback (GtkAction* action,
                                                     gpointer self);
static void collection_page_on_rotate_counterclockwise (CollectionPage* self);
static void _collection_page_on_rotate_counterclockwise_gcallback (GtkAction* action,
                                                            gpointer self);
static void _collection_page_on_flip_horizontally_gcallback (GtkAction* action,
                                                      gpointer self);
static void collection_page_on_flip_vertically (CollectionPage* self);
static void _collection_page_on_flip_vertically_gcallback (GtkAction* action,
                                                    gpointer self);
static void _collection_page_on_copy_adjustments_gcallback (GtkAction* action,
                                                     gpointer self);
static void _collection_page_on_paste_adjustments_gcallback (GtkAction* action,
                                                      gpointer self);
static void collection_page_on_revert (CollectionPage* self);
static void _collection_page_on_revert_gcallback (GtkAction* action,
                                           gpointer self);
static void collection_page_on_duplicate_photo (CollectionPage* self);
static void _collection_page_on_duplicate_photo_gcallback (GtkAction* action,
                                                    gpointer self);
static void collection_page_on_adjust_date_time (CollectionPage* self);
static void _collection_page_on_adjust_date_time_gcallback (GtkAction* action,
                                                     gpointer self);
static void _collection_page_on_enhance_gcallback (GtkAction* action,
                                            gpointer self);
static void _collection_page_on_slideshow_gcallback (GtkAction* action,
                                              gpointer self);
static void collection_page_on_copy_images (CollectionPage* self);
static void _collection_page_on_copy_images_gcallback (GtkAction* action,
                                                gpointer self);
static void _vala_array_add113 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add114 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add115 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add116 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add117 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add118 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add119 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add120 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add121 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add122 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add123 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add124 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add125 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add126 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add127 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add128 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _collection_page_get_image_data_for_clipboard_gtk_clipboard_get_func (GtkClipboard* clipboard,
                                                                           GtkSelectionData* selection_data,
                                                                           guint info,
                                                                           void* user_data_or_owner);
static void _collection_page_clear_data_for_clipboard_gtk_clipboard_clear_func (GtkClipboard* clipboard,
                                                                         void* user_data_or_owner);
static gboolean collection_page_selection_has_video (CollectionPage* self);
static gboolean collection_page_page_has_photo (CollectionPage* self);
static gboolean collection_page_selection_has_photo (CollectionPage* self);
static void collection_page_real_init_actions (Page* base,
                                        gint selected_count,
                                        gint count);
static void collection_page_real_update_actions (Page* base,
                                          gint selected_count,
                                          gint count);
static gboolean collection_page_can_revert_selected (CollectionPage* self);
static void collection_page_update_enhance_toggled (CollectionPage* self);
static void collection_page_on_photos_altered (CollectionPage* self,
                                        GeeMap* altered);
static void collection_page_real_on_item_activated (CheckerboardPage* base,
                                             CheckerboardItem* item);
static gboolean collection_page_real_on_app_key_pressed (Page* base,
                                                  GdkEventKey* event);
static void collection_page_real_on_export (MediaPage* base);
static void collection_page_on_export_completed (CollectionPage* self);
static void _collection_page_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                        gboolean is_cancelled,
                                                                        gpointer self);
static gboolean collection_page_can_revert_editable_selected (CollectionPage* self);
VALA_EXTERN SlideshowPage* slideshow_page_new (SourceCollection* sources,
                                   ViewCollection* controller,
                                   Photo* start);
VALA_EXTERN SlideshowPage* slideshow_page_construct (GType object_type,
                                         SourceCollection* sources,
                                         ViewCollection* controller,
                                         Photo* start);
VALA_EXTERN GType slideshow_page_get_type (void) G_GNUC_CONST ;
static gboolean collection_page_real_on_ctrl_pressed (Page* base,
                                               GdkEventKey* event);
static void _collection_page_on_flip_vertically_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _collection_page_on_rotate_counterclockwise_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
static gboolean collection_page_real_on_ctrl_released (Page* base,
                                                GdkEventKey* event);
static gchar* collection_page_real_get_view_empty_message (CheckerboardPage* base);
static SearchViewFilter* collection_page_real_get_search_view_filter (CheckerboardPage* base);
static guint collection_page_collection_search_view_filter_real_get_criteria (SearchViewFilter* base);
static GType collection_page_collection_search_view_filter_get_type_once (void);
static GObject * collection_page_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _collection_page_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                       GeeMap* items,
                                                                       gpointer self);
static void collection_page_finalize (GObject * obj);
static GType collection_page_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GtkTargetEntry COLLECTION_PAGE_COPY_TARGETS[2] = {{"x-special/gnome-copied-files", (guint) GTK_TARGET_OTHER_APP, (guint) COLLECTION_PAGE_TARGET_TYPE_GNOME_COPIED_FILES}, {"text/uri-list", (guint) GTK_TARGET_OTHER_APP, (guint) COLLECTION_PAGE_TARGET_TYPE_TEXT_URI_LIST}};

static inline gpointer
collection_page_get_instance_private (CollectionPage* self)
{
	return G_STRUCT_MEMBER_P (self, CollectionPage_private_offset);
}

static GType
collection_page_target_type_get_type_once (void)
{
	static const GEnumValue values[] = {{COLLECTION_PAGE_TARGET_TYPE_GNOME_COPIED_FILES, "COLLECTION_PAGE_TARGET_TYPE_GNOME_COPIED_FILES", "gnome-copied-files"}, {COLLECTION_PAGE_TARGET_TYPE_TEXT_URI_LIST, "COLLECTION_PAGE_TARGET_TYPE_TEXT_URI_LIST", "text-uri-list"}, {0, NULL, NULL}};
	GType collection_page_target_type_type_id;
	collection_page_target_type_type_id = g_enum_register_static ("CollectionPageTargetType", values);
	return collection_page_target_type_type_id;
}

static GType
collection_page_target_type_get_type (void)
{
	static volatile gsize collection_page_target_type_type_id__once = 0;
	if (g_once_init_enter (&collection_page_target_type_type_id__once)) {
		GType collection_page_target_type_type_id;
		collection_page_target_type_type_id = collection_page_target_type_get_type_once ();
		g_once_init_leave (&collection_page_target_type_type_id__once, collection_page_target_type_type_id);
	}
	return collection_page_target_type_type_id__once;
}

CollectionPage*
collection_page_construct (GType object_type,
                           const gchar* page_name)
{
	CollectionPage * self = NULL;
#line 51 "../src/Views/CollectionPage.vala"
	g_return_val_if_fail (page_name != NULL, NULL);
#line 52 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) g_object_new (object_type, "page-name", page_name, NULL);
#line 51 "../src/Views/CollectionPage.vala"
	return self;
#line 396 "CollectionPage.c"
}

static void
_collection_page_on_slideshow_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 69 "../src/Views/CollectionPage.vala"
	collection_page_on_slideshow ((CollectionPage*) self);
#line 405 "CollectionPage.c"
}

static void
_collection_page_on_rotate_clockwise_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 73 "../src/Views/CollectionPage.vala"
	collection_page_on_rotate_clockwise ((CollectionPage*) self);
#line 414 "CollectionPage.c"
}

static void
_collection_page_on_flip_horizontally_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self)
{
#line 80 "../src/Views/CollectionPage.vala"
	collection_page_on_flip_horizontally ((CollectionPage*) self);
#line 423 "CollectionPage.c"
}

static void
_collection_page_on_enhance_gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 88 "../src/Views/CollectionPage.vala"
	collection_page_on_enhance ((CollectionPage*) self);
#line 432 "CollectionPage.c"
}

static void
_collection_page_on_show_sidebar_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
#line 97 "../src/Views/CollectionPage.vala"
	collection_page_on_show_sidebar ((CollectionPage*) self);
#line 441 "CollectionPage.c"
}

static void
collection_page_real_add_toolbar_widgets (Page* base,
                                          GtkActionBar* toolbar)
{
	CollectionPage * self;
	GtkButton* slideshow_button = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkAction* rotate_action = NULL;
	GtkAction* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkAction* flip_action = NULL;
	GtkAction* _tmp9_;
	GtkButton* _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkToggleButton* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkToggleButton* _tmp15_;
	GtkToggleButton* _tmp16_;
	SliderAssembly* zoom_assembly = NULL;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	SliderAssembly* _tmp21_;
	GtkButton* _tmp22_;
	GtkButton* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkSeparator* _tmp26_;
	GtkSeparator* _tmp27_;
	GtkToggleButton* _tmp28_;
	GtkButton* _tmp29_;
	LibraryWindow* app = NULL;
	AppWindow* _tmp30_;
	LibraryWindow* _tmp31_;
#line 65 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 65 "../src/Views/CollectionPage.vala"
	g_return_if_fail (toolbar != NULL);
#line 66 "../src/Views/CollectionPage.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 66 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp0_);
#line 66 "../src/Views/CollectionPage.vala"
	slideshow_button = _tmp0_;
#line 68 "../src/Views/CollectionPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) slideshow_button, _ ("Play a slideshow"));
#line 69 "../src/Views/CollectionPage.vala"
	g_signal_connect_object (slideshow_button, "clicked", (GCallback) _collection_page_on_slideshow_gtk_button_clicked, self, 0);
#line 71 "../src/Views/CollectionPage.vala"
	_tmp1_ = (GtkButton*) gtk_button_new_from_icon_name (RESOURCES_CLOCKWISE, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 71 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp1_);
#line 71 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (self->priv->rotate_button);
#line 71 "../src/Views/CollectionPage.vala"
	self->priv->rotate_button = _tmp1_;
#line 72 "../src/Views/CollectionPage.vala"
	_tmp2_ = self->priv->rotate_button;
#line 72 "../src/Views/CollectionPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, RESOURCES_ROTATE_CW_TOOLTIP);
#line 73 "../src/Views/CollectionPage.vala"
	_tmp3_ = self->priv->rotate_button;
#line 73 "../src/Views/CollectionPage.vala"
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) _collection_page_on_rotate_clockwise_gtk_button_clicked, self, 0);
#line 75 "../src/Views/CollectionPage.vala"
	_tmp4_ = page_get_action ((Page*) self, "RotateClockwise");
#line 75 "../src/Views/CollectionPage.vala"
	rotate_action = _tmp4_;
#line 76 "../src/Views/CollectionPage.vala"
	_tmp5_ = self->priv->rotate_button;
#line 76 "../src/Views/CollectionPage.vala"
	g_object_bind_property_with_closures ((GObject*) rotate_action, "sensitive", (GObject*) _tmp5_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 78 "../src/Views/CollectionPage.vala"
	_tmp6_ = (GtkButton*) gtk_button_new_from_icon_name (RESOURCES_HFLIP, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 78 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp6_);
#line 78 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (self->priv->flip_button);
#line 78 "../src/Views/CollectionPage.vala"
	self->priv->flip_button = _tmp6_;
#line 79 "../src/Views/CollectionPage.vala"
	_tmp7_ = self->priv->flip_button;
#line 79 "../src/Views/CollectionPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, RESOURCES_HFLIP_TOOLTIP);
#line 80 "../src/Views/CollectionPage.vala"
	_tmp8_ = self->priv->flip_button;
#line 80 "../src/Views/CollectionPage.vala"
	g_signal_connect_object (_tmp8_, "clicked", (GCallback) _collection_page_on_flip_horizontally_gtk_button_clicked, self, 0);
#line 82 "../src/Views/CollectionPage.vala"
	_tmp9_ = page_get_action ((Page*) self, "FlipHorizontally");
#line 82 "../src/Views/CollectionPage.vala"
	flip_action = _tmp9_;
#line 83 "../src/Views/CollectionPage.vala"
	_tmp10_ = self->priv->flip_button;
#line 83 "../src/Views/CollectionPage.vala"
	g_object_bind_property_with_closures ((GObject*) flip_action, "sensitive", (GObject*) _tmp10_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 85 "../src/Views/CollectionPage.vala"
	_tmp11_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 85 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp11_);
#line 85 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (self->priv->enhance_button);
#line 85 "../src/Views/CollectionPage.vala"
	self->priv->enhance_button = _tmp11_;
#line 86 "../src/Views/CollectionPage.vala"
	_tmp12_ = self->priv->enhance_button;
#line 86 "../src/Views/CollectionPage.vala"
	_tmp13_ = (GtkImage*) gtk_image_new_from_icon_name (RESOURCES_ENHANCE, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 86 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp13_);
#line 86 "../src/Views/CollectionPage.vala"
	_tmp14_ = _tmp13_;
#line 86 "../src/Views/CollectionPage.vala"
	gtk_button_set_image ((GtkButton*) _tmp12_, (GtkWidget*) _tmp14_);
#line 86 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp14_);
#line 87 "../src/Views/CollectionPage.vala"
	_tmp15_ = self->priv->enhance_button;
#line 87 "../src/Views/CollectionPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp15_, RESOURCES_ENHANCE_TOOLTIP);
#line 88 "../src/Views/CollectionPage.vala"
	_tmp16_ = self->priv->enhance_button;
#line 88 "../src/Views/CollectionPage.vala"
	g_signal_connect_object ((GtkButton*) _tmp16_, "clicked", (GCallback) _collection_page_on_enhance_gtk_button_clicked, self, 0);
#line 90 "../src/Views/CollectionPage.vala"
	_tmp17_ = thumbnail_get_MIN_SCALE ();
#line 90 "../src/Views/CollectionPage.vala"
	_tmp18_ = _tmp17_;
#line 90 "../src/Views/CollectionPage.vala"
	_tmp19_ = thumbnail_get_MAX_SCALE ();
#line 90 "../src/Views/CollectionPage.vala"
	_tmp20_ = _tmp19_;
#line 90 "../src/Views/CollectionPage.vala"
	_tmp21_ = slider_assembly_new ((gdouble) _tmp18_, (gdouble) _tmp20_, (gdouble) MEDIA_PAGE_MANUAL_STEPPING, (gdouble) 0);
#line 90 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp21_);
#line 90 "../src/Views/CollectionPage.vala"
	zoom_assembly = _tmp21_;
#line 94 "../src/Views/CollectionPage.vala"
	media_page_connect_slider ((MediaPage*) self, zoom_assembly);
#line 96 "../src/Views/CollectionPage.vala"
	_tmp22_ = media_page_create_sidebar_button ();
#line 96 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (((Page*) self)->show_sidebar_button);
#line 96 "../src/Views/CollectionPage.vala"
	((Page*) self)->show_sidebar_button = _tmp22_;
#line 97 "../src/Views/CollectionPage.vala"
	_tmp23_ = ((Page*) self)->show_sidebar_button;
#line 97 "../src/Views/CollectionPage.vala"
	g_signal_connect_object (_tmp23_, "clicked", (GCallback) _collection_page_on_show_sidebar_gtk_button_clicked, self, 0);
#line 99 "../src/Views/CollectionPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) slideshow_button);
#line 100 "../src/Views/CollectionPage.vala"
	_tmp24_ = self->priv->rotate_button;
#line 100 "../src/Views/CollectionPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) _tmp24_);
#line 101 "../src/Views/CollectionPage.vala"
	_tmp25_ = self->priv->flip_button;
#line 101 "../src/Views/CollectionPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) _tmp25_);
#line 102 "../src/Views/CollectionPage.vala"
	_tmp26_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
#line 102 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp26_);
#line 102 "../src/Views/CollectionPage.vala"
	_tmp27_ = _tmp26_;
#line 102 "../src/Views/CollectionPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) _tmp27_);
#line 102 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp27_);
#line 103 "../src/Views/CollectionPage.vala"
	_tmp28_ = self->priv->enhance_button;
#line 103 "../src/Views/CollectionPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) _tmp28_);
#line 104 "../src/Views/CollectionPage.vala"
	_tmp29_ = ((Page*) self)->show_sidebar_button;
#line 104 "../src/Views/CollectionPage.vala"
	gtk_action_bar_pack_end (toolbar, (GtkWidget*) _tmp29_);
#line 105 "../src/Views/CollectionPage.vala"
	gtk_action_bar_pack_end (toolbar, (GtkWidget*) zoom_assembly);
#line 107 "../src/Views/CollectionPage.vala"
	_tmp30_ = app_window_get_instance ();
#line 107 "../src/Views/CollectionPage.vala"
	_tmp31_ = IS_LIBRARY_WINDOW (_tmp30_) ? ((LibraryWindow*) _tmp30_) : NULL;
#line 107 "../src/Views/CollectionPage.vala"
	if (_tmp31_ == NULL) {
#line 107 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp30_);
#line 640 "CollectionPage.c"
	}
#line 107 "../src/Views/CollectionPage.vala"
	app = _tmp31_;
#line 108 "../src/Views/CollectionPage.vala"
	page_update_sidebar_action ((Page*) self, !library_window_is_metadata_sidebar_visible (app));
#line 109 "../src/Views/CollectionPage.vala"
	PAGE_CLASS (collection_page_parent_class)->add_toolbar_widgets ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_PAGE, MediaPage), toolbar);
#line 65 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (app);
#line 65 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (zoom_assembly);
#line 65 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (flip_action);
#line 65 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (rotate_action);
#line 65 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (slideshow_button);
#line 658 "CollectionPage.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 113 "../src/Views/CollectionPage.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 113 "../src/Views/CollectionPage.vala"
	return _data8_;
#line 668 "CollectionPage.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 113 "../src/Views/CollectionPage.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 678 "CollectionPage.c"
		CollectionPage* self;
#line 113 "../src/Views/CollectionPage.vala"
		self = _data8_->self;
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->trash_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->remove_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->export_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->print_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->jump_event_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->new_event_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->adjust_datetime_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->raw_developer_camera_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->raw_developer_app_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->flag_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->paste_color_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->copy_color_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->duplicate_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->revert_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_data8_->copy_images_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (self);
#line 113 "../src/Views/CollectionPage.vala"
		g_slice_free (Block8Data, _data8_);
#line 716 "CollectionPage.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 114 "../src/Views/CollectionPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 725 "CollectionPage.c"
}

static void
___lambda79_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 120 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 120 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->copy_images_action;
#line 120 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 739 "CollectionPage.c"
}

static void
____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 120 "../src/Views/CollectionPage.vala"
	___lambda79_ (self);
#line 748 "CollectionPage.c"
}

static void
___lambda80_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 129 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 129 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->revert_action;
#line 129 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 762 "CollectionPage.c"
}

static void
____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 129 "../src/Views/CollectionPage.vala"
	___lambda80_ (self);
#line 771 "CollectionPage.c"
}

static void
___lambda81_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 134 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 134 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->duplicate_action;
#line 134 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 785 "CollectionPage.c"
}

static void
____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 134 "../src/Views/CollectionPage.vala"
	___lambda81_ (self);
#line 794 "CollectionPage.c"
}

static void
___lambda82_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 139 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 139 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->copy_color_action;
#line 139 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 808 "CollectionPage.c"
}

static void
____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 139 "../src/Views/CollectionPage.vala"
	___lambda82_ (self);
#line 817 "CollectionPage.c"
}

static void
___lambda83_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 144 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 144 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->paste_color_action;
#line 144 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 831 "CollectionPage.c"
}

static void
____lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 144 "../src/Views/CollectionPage.vala"
	___lambda83_ (self);
#line 840 "CollectionPage.c"
}

static void
___lambda84_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 149 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 149 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->flag_action;
#line 149 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 854 "CollectionPage.c"
}

static void
____lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 149 "../src/Views/CollectionPage.vala"
	___lambda84_ (self);
#line 863 "CollectionPage.c"
}

static void
___lambda85_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 154 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 154 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->raw_developer_app_action;
#line 154 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 877 "CollectionPage.c"
}

static void
____lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 154 "../src/Views/CollectionPage.vala"
	___lambda85_ (self);
#line 886 "CollectionPage.c"
}

static void
___lambda86_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 159 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 159 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->raw_developer_camera_action;
#line 159 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 900 "CollectionPage.c"
}

static void
____lambda86__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 159 "../src/Views/CollectionPage.vala"
	___lambda86_ (self);
#line 909 "CollectionPage.c"
}

static void
___lambda87_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 173 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 173 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->adjust_datetime_action;
#line 173 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 923 "CollectionPage.c"
}

static void
____lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 173 "../src/Views/CollectionPage.vala"
	___lambda87_ (self);
#line 932 "CollectionPage.c"
}

static void
___lambda88_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 182 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 182 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->new_event_action;
#line 182 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 946 "CollectionPage.c"
}

static void
____lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 182 "../src/Views/CollectionPage.vala"
	___lambda88_ (self);
#line 955 "CollectionPage.c"
}

static void
___lambda89_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 187 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 187 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->jump_event_action;
#line 187 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 969 "CollectionPage.c"
}

static void
____lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 187 "../src/Views/CollectionPage.vala"
	___lambda89_ (self);
#line 978 "CollectionPage.c"
}

static void
___lambda90_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 192 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 192 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->print_action;
#line 192 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 992 "CollectionPage.c"
}

static void
____lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 192 "../src/Views/CollectionPage.vala"
	___lambda90_ (self);
#line 1001 "CollectionPage.c"
}

static void
___lambda91_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 197 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 197 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->export_action;
#line 197 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 1015 "CollectionPage.c"
}

static void
____lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 197 "../src/Views/CollectionPage.vala"
	___lambda91_ (self);
#line 1024 "CollectionPage.c"
}

static void
___lambda92_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 210 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 210 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->remove_action;
#line 210 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 1038 "CollectionPage.c"
}

static void
____lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 210 "../src/Views/CollectionPage.vala"
	___lambda92_ (self);
#line 1047 "CollectionPage.c"
}

static void
___lambda93_ (Block8Data* _data8_)
{
	CollectionPage* self;
	GtkAction* _tmp0_;
#line 215 "../src/Views/CollectionPage.vala"
	self = _data8_->self;
#line 215 "../src/Views/CollectionPage.vala"
	_tmp0_ = _data8_->trash_action;
#line 215 "../src/Views/CollectionPage.vala"
	gtk_action_activate (_tmp0_);
#line 1061 "CollectionPage.c"
}

static void
____lambda93__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 215 "../src/Views/CollectionPage.vala"
	___lambda93_ (self);
#line 1070 "CollectionPage.c"
}

static GtkMenu*
collection_page_real_get_item_context_menu (CheckerboardPage* base)
{
	CollectionPage * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp179_;
	GtkMenu* _tmp180_;
	GtkMenu* _tmp181_;
	GtkMenu* result;
#line 112 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 113 "../src/Views/CollectionPage.vala"
	_tmp0_ = self->priv->item_context_menu;
#line 113 "../src/Views/CollectionPage.vala"
	if (_tmp0_ == NULL) {
#line 1088 "CollectionPage.c"
		Block8Data* _data8_;
		GtkWidget* _tmp1_;
		GtkMenu* _tmp2_ = NULL;
		GtkMenuItem* copy_images_menu_item = NULL;
		GtkMenuItem* _tmp3_;
		GtkAction* _tmp4_;
		GtkMenuItem* _tmp5_;
		GtkCheckMenuItem* metadata_menu_item = NULL;
		GtkCheckMenuItem* _tmp6_;
		GtkAction* metadata_action = NULL;
		GtkAction* _tmp7_;
		GtkAction* _tmp8_;
		GtkCheckMenuItem* _tmp9_;
		GtkMenuItem* revert_menu_item = NULL;
		GtkMenuItem* _tmp10_;
		GtkAction* _tmp11_;
		GtkAction* _tmp12_;
		GtkMenuItem* _tmp13_;
		GtkMenuItem* _tmp14_;
		GtkMenuItem* duplicate_menu_item = NULL;
		GtkMenuItem* _tmp15_;
		GtkAction* _tmp16_;
		GtkAction* _tmp17_;
		GtkMenuItem* _tmp18_;
		GtkMenuItem* _tmp19_;
		GtkMenuItem* copy_color_menu_item = NULL;
		GtkMenuItem* _tmp20_;
		GtkAction* _tmp21_;
		GtkAction* _tmp22_;
		GtkMenuItem* _tmp23_;
		GtkMenuItem* _tmp24_;
		GtkMenuItem* paste_color_menu_item = NULL;
		GtkMenuItem* _tmp25_;
		GtkAction* _tmp26_;
		GtkAction* _tmp27_;
		GtkMenuItem* _tmp28_;
		GtkMenuItem* _tmp29_;
		GtkMenuItem* flag_menu_item = NULL;
		GtkMenuItem* _tmp30_;
		GtkAction* _tmp31_;
		GtkAction* _tmp32_;
		GtkMenuItem* _tmp33_;
		GtkMenuItem* _tmp34_;
		GtkMenuItem* raw_developer_app_menu_item = NULL;
		gchar* _tmp35_;
		gchar* _tmp36_;
		GtkMenuItem* _tmp37_;
		GtkMenuItem* _tmp38_;
		GtkAction* _tmp39_;
		GtkAction* _tmp40_;
		GtkMenuItem* _tmp41_;
		GtkMenuItem* _tmp42_;
		GtkMenuItem* raw_developer_camera_menu_item = NULL;
		gchar* _tmp43_;
		gchar* _tmp44_;
		GtkMenuItem* _tmp45_;
		GtkMenuItem* _tmp46_;
		GtkAction* _tmp47_;
		GtkAction* _tmp48_;
		GtkMenuItem* _tmp49_;
		GtkMenuItem* _tmp50_;
		GtkMenuItem* raw_developer_menu_item = NULL;
		GtkMenuItem* _tmp51_;
		GtkAction* raw_developer_action = NULL;
		GtkAction* _tmp52_;
		GtkAction* _tmp53_;
		GtkMenuItem* _tmp54_;
		GtkMenu* raw_developer_menu = NULL;
		GtkMenu* _tmp55_;
		GtkMenu* _tmp56_;
		GtkMenuItem* _tmp57_;
		GtkMenu* _tmp58_;
		GtkMenuItem* _tmp59_;
		GtkMenuItem* _tmp60_;
		GtkMenu* _tmp61_;
		GtkMenuItem* adjust_datetime_menu_item = NULL;
		GtkMenuItem* _tmp62_;
		GtkAction* _tmp63_;
		GtkAction* _tmp64_;
		GtkMenuItem* _tmp65_;
		GtkMenuItem* _tmp66_;
		GtkMenuItem* open_menu_item = NULL;
		gchar* _tmp67_;
		GtkMenuItem* _tmp68_ = NULL;
		GtkMenuItem* new_event_menu_item = NULL;
		GtkMenuItem* _tmp69_;
		GtkAction* _tmp70_;
		GtkAction* _tmp71_;
		GtkMenuItem* _tmp72_;
		GtkMenuItem* _tmp73_;
		GtkMenuItem* jump_event_menu_item = NULL;
		GtkMenuItem* _tmp74_;
		GtkAction* _tmp75_;
		GtkAction* _tmp76_;
		GtkMenuItem* _tmp77_;
		GtkMenuItem* _tmp78_;
		GtkMenuItem* print_menu_item = NULL;
		GtkMenuItem* _tmp79_;
		GtkAction* _tmp80_;
		GtkAction* _tmp81_;
		GtkMenuItem* _tmp82_;
		GtkMenuItem* _tmp83_;
		GtkMenuItem* export_menu_item = NULL;
		GtkMenuItem* _tmp84_;
		GtkAction* _tmp85_;
		GtkAction* _tmp86_;
		GtkMenuItem* _tmp87_;
		GtkMenuItem* _tmp88_;
		GtkMenuItem* wallpaper_menuitem = NULL;
		gchar* _tmp89_;
		GtkMenuItem* _tmp90_ = NULL;
		GtkMenuItem* contractor_menu_item = NULL;
		GtkMenuItem* _tmp91_;
		GtkMenu* _tmp92_;
		GtkMenuItem* _tmp93_;
		GtkMenu* _tmp94_;
		GtkMenuItem* remove_menu_item = NULL;
		GtkMenuItem* _tmp95_;
		GtkAction* _tmp96_;
		GtkAction* _tmp97_;
		GtkMenuItem* _tmp98_;
		GtkMenuItem* _tmp99_;
		GtkMenuItem* trash_menu_item = NULL;
		GtkMenuItem* _tmp100_;
		GtkAction* _tmp101_;
		GtkAction* _tmp102_;
		GtkMenuItem* _tmp103_;
		GtkMenuItem* _tmp104_;
		GtkMenu* _tmp105_;
		GtkMenuItem* _tmp106_;
		GtkMenu* _tmp107_;
		GtkMenuItem* _tmp108_;
		GtkMenu* _tmp109_;
		GtkMenuItem* _tmp110_;
		GtkMenu* _tmp111_;
		GtkMenuItem* _tmp112_;
		GtkMenu* _tmp113_;
		GtkMenuItem* _tmp114_;
		GtkMenu* _tmp115_;
		GtkMenuItem* _tmp116_;
		GtkMenu* _tmp117_;
		GtkSeparatorMenuItem* _tmp118_;
		GtkSeparatorMenuItem* _tmp119_;
		GtkMenu* _tmp120_;
		GtkMenuItem* _tmp121_;
		GtkMenu* _tmp122_;
		GtkMenuItem* _tmp123_;
		GtkMenu* _tmp124_;
		GtkSeparatorMenuItem* _tmp125_;
		GtkSeparatorMenuItem* _tmp126_;
		GtkMenu* _tmp127_;
		GtkMenuItem* _tmp128_;
		GtkMenu* _tmp129_;
		GtkMenuItem* _tmp130_;
		GtkMenu* _tmp131_;
		GtkMenuItem* _tmp132_;
		GtkMenu* _tmp133_;
		GtkSeparatorMenuItem* _tmp134_;
		GtkSeparatorMenuItem* _tmp135_;
		GtkMenu* _tmp136_;
		GtkMenuItem* _tmp137_;
		GtkMenu* _tmp138_;
		GtkMenuItem* _tmp139_;
		GtkMenu* _tmp140_;
		GtkSeparatorMenuItem* _tmp141_;
		GtkSeparatorMenuItem* _tmp142_;
		GtkMenu* _tmp143_;
		GtkMenuItem* _tmp144_;
		GtkMenu* _tmp145_;
		GtkMenuItem* _tmp146_;
		GtkMenu* _tmp147_;
		GtkSeparatorMenuItem* _tmp148_;
		GtkSeparatorMenuItem* _tmp149_;
		GtkMenu* _tmp150_;
		GtkCheckMenuItem* _tmp151_;
		GtkMenu* _tmp152_;
		GtkSeparatorMenuItem* _tmp153_;
		GtkSeparatorMenuItem* _tmp154_;
		GtkMenu* _tmp155_;
		GtkMenuItem* _tmp156_;
		GtkMenu* _tmp157_;
		GtkMenuItem* _tmp158_;
		GtkMenu* _tmp159_;
		DataSource* source = NULL;
		ViewCollection* _tmp160_;
		ViewCollection* _tmp161_;
		DataView* _tmp162_;
		DataView* _tmp163_;
		DataSource* _tmp164_;
		DataSource* _tmp165_;
		DataSource* _tmp166_;
		DataSource* _tmp167_;
		gboolean _tmp168_ = FALSE;
		DataSource* _tmp169_;
#line 113 "../src/Views/CollectionPage.vala"
		_data8_ = g_slice_new0 (Block8Data);
#line 113 "../src/Views/CollectionPage.vala"
		_data8_->_ref_count_ = 1;
#line 113 "../src/Views/CollectionPage.vala"
		_data8_->self = g_object_ref (self);
#line 114 "../src/Views/CollectionPage.vala"
		_tmp1_ = _g_object_ref0 ((GtkWidget*) self);
#line 114 "../src/Views/CollectionPage.vala"
		_tmp2_ = (GtkMenu*) gtk_menu_new ();
#line 114 "../src/Views/CollectionPage.vala"
		g_object_set (_tmp2_, "attach-widget", _tmp1_, NULL);
#line 114 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp1_);
#line 114 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp2_);
#line 114 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (self->priv->item_context_menu);
#line 114 "../src/Views/CollectionPage.vala"
		self->priv->item_context_menu = _tmp2_;
#line 118 "../src/Views/CollectionPage.vala"
		_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_COPY_IMAGE_LABEL);
#line 118 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp3_);
#line 118 "../src/Views/CollectionPage.vala"
		copy_images_menu_item = _tmp3_;
#line 119 "../src/Views/CollectionPage.vala"
		_tmp4_ = page_get_action ((Page*) self, "CopyImages");
#line 119 "../src/Views/CollectionPage.vala"
		_data8_->copy_images_action = _tmp4_;
#line 120 "../src/Views/CollectionPage.vala"
		_tmp5_ = copy_images_menu_item;
#line 120 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp5_, "activate", (GCallback) ____lambda79__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 122 "../src/Views/CollectionPage.vala"
		_tmp6_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_ ("Edit Photo In_fo"));
#line 122 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp6_);
#line 122 "../src/Views/CollectionPage.vala"
		metadata_menu_item = _tmp6_;
#line 123 "../src/Views/CollectionPage.vala"
		_tmp7_ = page_get_common_action ((Page*) self, "CommonDisplayMetadataSidebar", TRUE);
#line 123 "../src/Views/CollectionPage.vala"
		metadata_action = _tmp7_;
#line 124 "../src/Views/CollectionPage.vala"
		_tmp8_ = metadata_action;
#line 124 "../src/Views/CollectionPage.vala"
		_tmp9_ = metadata_menu_item;
#line 124 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp8_, "active", (GObject*) _tmp9_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 126 "../src/Views/CollectionPage.vala"
		_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_REVERT_MENU);
#line 126 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp10_);
#line 126 "../src/Views/CollectionPage.vala"
		revert_menu_item = _tmp10_;
#line 127 "../src/Views/CollectionPage.vala"
		_tmp11_ = page_get_action ((Page*) self, "Revert");
#line 127 "../src/Views/CollectionPage.vala"
		_data8_->revert_action = _tmp11_;
#line 128 "../src/Views/CollectionPage.vala"
		_tmp12_ = _data8_->revert_action;
#line 128 "../src/Views/CollectionPage.vala"
		_tmp13_ = revert_menu_item;
#line 128 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp12_, "sensitive", (GObject*) _tmp13_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 129 "../src/Views/CollectionPage.vala"
		_tmp14_ = revert_menu_item;
#line 129 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp14_, "activate", (GCallback) ____lambda80__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 131 "../src/Views/CollectionPage.vala"
		_tmp15_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_DUPLICATE_PHOTO_MENU);
#line 131 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp15_);
#line 131 "../src/Views/CollectionPage.vala"
		duplicate_menu_item = _tmp15_;
#line 132 "../src/Views/CollectionPage.vala"
		_tmp16_ = page_get_action ((Page*) self, "Duplicate");
#line 132 "../src/Views/CollectionPage.vala"
		_data8_->duplicate_action = _tmp16_;
#line 133 "../src/Views/CollectionPage.vala"
		_tmp17_ = _data8_->duplicate_action;
#line 133 "../src/Views/CollectionPage.vala"
		_tmp18_ = duplicate_menu_item;
#line 133 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp17_, "sensitive", (GObject*) _tmp18_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 134 "../src/Views/CollectionPage.vala"
		_tmp19_ = duplicate_menu_item;
#line 134 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp19_, "activate", (GCallback) ____lambda81__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 136 "../src/Views/CollectionPage.vala"
		_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_COPY_ADJUSTMENTS_MENU);
#line 136 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp20_);
#line 136 "../src/Views/CollectionPage.vala"
		copy_color_menu_item = _tmp20_;
#line 137 "../src/Views/CollectionPage.vala"
		_tmp21_ = page_get_action ((Page*) self, "CopyColorAdjustments");
#line 137 "../src/Views/CollectionPage.vala"
		_data8_->copy_color_action = _tmp21_;
#line 138 "../src/Views/CollectionPage.vala"
		_tmp22_ = _data8_->copy_color_action;
#line 138 "../src/Views/CollectionPage.vala"
		_tmp23_ = copy_color_menu_item;
#line 138 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp22_, "sensitive", (GObject*) _tmp23_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 139 "../src/Views/CollectionPage.vala"
		_tmp24_ = copy_color_menu_item;
#line 139 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp24_, "activate", (GCallback) ____lambda82__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 141 "../src/Views/CollectionPage.vala"
		_tmp25_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_PASTE_ADJUSTMENTS_MENU);
#line 141 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp25_);
#line 141 "../src/Views/CollectionPage.vala"
		paste_color_menu_item = _tmp25_;
#line 142 "../src/Views/CollectionPage.vala"
		_tmp26_ = page_get_action ((Page*) self, "PasteColorAdjustments");
#line 142 "../src/Views/CollectionPage.vala"
		_data8_->paste_color_action = _tmp26_;
#line 143 "../src/Views/CollectionPage.vala"
		_tmp27_ = _data8_->paste_color_action;
#line 143 "../src/Views/CollectionPage.vala"
		_tmp28_ = paste_color_menu_item;
#line 143 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp27_, "sensitive", (GObject*) _tmp28_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 144 "../src/Views/CollectionPage.vala"
		_tmp29_ = paste_color_menu_item;
#line 144 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp29_, "activate", (GCallback) ____lambda83__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 146 "../src/Views/CollectionPage.vala"
		_tmp30_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_FLAG_MENU);
#line 146 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp30_);
#line 146 "../src/Views/CollectionPage.vala"
		flag_menu_item = _tmp30_;
#line 147 "../src/Views/CollectionPage.vala"
		_tmp31_ = page_get_action ((Page*) self, "Flag");
#line 147 "../src/Views/CollectionPage.vala"
		_data8_->flag_action = _tmp31_;
#line 148 "../src/Views/CollectionPage.vala"
		_tmp32_ = _data8_->flag_action;
#line 148 "../src/Views/CollectionPage.vala"
		_tmp33_ = flag_menu_item;
#line 148 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp32_, "sensitive", (GObject*) _tmp33_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 149 "../src/Views/CollectionPage.vala"
		_tmp34_ = flag_menu_item;
#line 149 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp34_, "activate", (GCallback) ____lambda84__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 151 "../src/Views/CollectionPage.vala"
		_tmp35_ = raw_developer_get_label (RAW_DEVELOPER_SHOTWELL);
#line 151 "../src/Views/CollectionPage.vala"
		_tmp36_ = _tmp35_;
#line 151 "../src/Views/CollectionPage.vala"
		_tmp37_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp36_);
#line 151 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp37_);
#line 151 "../src/Views/CollectionPage.vala"
		_tmp38_ = _tmp37_;
#line 151 "../src/Views/CollectionPage.vala"
		_g_free0 (_tmp36_);
#line 151 "../src/Views/CollectionPage.vala"
		raw_developer_app_menu_item = _tmp38_;
#line 152 "../src/Views/CollectionPage.vala"
		_tmp39_ = page_get_action ((Page*) self, "RawDeveloperShotwell");
#line 152 "../src/Views/CollectionPage.vala"
		_data8_->raw_developer_app_action = _tmp39_;
#line 153 "../src/Views/CollectionPage.vala"
		_tmp40_ = _data8_->raw_developer_app_action;
#line 153 "../src/Views/CollectionPage.vala"
		_tmp41_ = raw_developer_app_menu_item;
#line 153 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp40_, "sensitive", (GObject*) _tmp41_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 154 "../src/Views/CollectionPage.vala"
		_tmp42_ = raw_developer_app_menu_item;
#line 154 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp42_, "activate", (GCallback) ____lambda85__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 156 "../src/Views/CollectionPage.vala"
		_tmp43_ = raw_developer_get_label (RAW_DEVELOPER_CAMERA);
#line 156 "../src/Views/CollectionPage.vala"
		_tmp44_ = _tmp43_;
#line 156 "../src/Views/CollectionPage.vala"
		_tmp45_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp44_);
#line 156 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp45_);
#line 156 "../src/Views/CollectionPage.vala"
		_tmp46_ = _tmp45_;
#line 156 "../src/Views/CollectionPage.vala"
		_g_free0 (_tmp44_);
#line 156 "../src/Views/CollectionPage.vala"
		raw_developer_camera_menu_item = _tmp46_;
#line 157 "../src/Views/CollectionPage.vala"
		_tmp47_ = page_get_action ((Page*) self, "RawDeveloperCamera");
#line 157 "../src/Views/CollectionPage.vala"
		_data8_->raw_developer_camera_action = _tmp47_;
#line 158 "../src/Views/CollectionPage.vala"
		_tmp48_ = _data8_->raw_developer_camera_action;
#line 158 "../src/Views/CollectionPage.vala"
		_tmp49_ = raw_developer_camera_menu_item;
#line 158 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp48_, "sensitive", (GObject*) _tmp49_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 159 "../src/Views/CollectionPage.vala"
		_tmp50_ = raw_developer_camera_menu_item;
#line 159 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp50_, "activate", (GCallback) ____lambda86__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 161 "../src/Views/CollectionPage.vala"
		_tmp51_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Developer"));
#line 161 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp51_);
#line 161 "../src/Views/CollectionPage.vala"
		raw_developer_menu_item = _tmp51_;
#line 162 "../src/Views/CollectionPage.vala"
		_tmp52_ = page_get_action ((Page*) self, "RawDeveloper");
#line 162 "../src/Views/CollectionPage.vala"
		raw_developer_action = _tmp52_;
#line 163 "../src/Views/CollectionPage.vala"
		_tmp53_ = raw_developer_action;
#line 163 "../src/Views/CollectionPage.vala"
		_tmp54_ = raw_developer_menu_item;
#line 163 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp53_, "sensitive", (GObject*) _tmp54_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 165 "../src/Views/CollectionPage.vala"
		_tmp55_ = (GtkMenu*) gtk_menu_new ();
#line 165 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp55_);
#line 165 "../src/Views/CollectionPage.vala"
		raw_developer_menu = _tmp55_;
#line 166 "../src/Views/CollectionPage.vala"
		_tmp56_ = raw_developer_menu;
#line 166 "../src/Views/CollectionPage.vala"
		_tmp57_ = raw_developer_app_menu_item;
#line 166 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp56_, (GtkWidget*) _tmp57_);
#line 167 "../src/Views/CollectionPage.vala"
		_tmp58_ = raw_developer_menu;
#line 167 "../src/Views/CollectionPage.vala"
		_tmp59_ = raw_developer_camera_menu_item;
#line 167 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp58_, (GtkWidget*) _tmp59_);
#line 168 "../src/Views/CollectionPage.vala"
		_tmp60_ = raw_developer_menu_item;
#line 168 "../src/Views/CollectionPage.vala"
		_tmp61_ = raw_developer_menu;
#line 168 "../src/Views/CollectionPage.vala"
		gtk_menu_item_set_submenu (_tmp60_, _tmp61_);
#line 170 "../src/Views/CollectionPage.vala"
		_tmp62_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_ADJUST_DATE_TIME_MENU);
#line 170 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp62_);
#line 170 "../src/Views/CollectionPage.vala"
		adjust_datetime_menu_item = _tmp62_;
#line 171 "../src/Views/CollectionPage.vala"
		_tmp63_ = page_get_action ((Page*) self, "AdjustDateTime");
#line 171 "../src/Views/CollectionPage.vala"
		_data8_->adjust_datetime_action = _tmp63_;
#line 172 "../src/Views/CollectionPage.vala"
		_tmp64_ = _data8_->adjust_datetime_action;
#line 172 "../src/Views/CollectionPage.vala"
		_tmp65_ = adjust_datetime_menu_item;
#line 172 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp64_, "sensitive", (GObject*) _tmp65_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 173 "../src/Views/CollectionPage.vala"
		_tmp66_ = adjust_datetime_menu_item;
#line 173 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp66_, "activate", (GCallback) ____lambda87__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 175 "../src/Views/CollectionPage.vala"
		_tmp67_ = g_strdup (APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_JUMP_TO_FILE);
#line 175 "../src/Views/CollectionPage.vala"
		_tmp68_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Show in Files"));
#line 175 "../src/Views/CollectionPage.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp68_, _tmp67_);
#line 175 "../src/Views/CollectionPage.vala"
		_g_free0 (_tmp67_);
#line 175 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp68_);
#line 175 "../src/Views/CollectionPage.vala"
		open_menu_item = _tmp68_;
#line 179 "../src/Views/CollectionPage.vala"
		_tmp69_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_NEW_EVENT_MENU);
#line 179 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp69_);
#line 179 "../src/Views/CollectionPage.vala"
		new_event_menu_item = _tmp69_;
#line 180 "../src/Views/CollectionPage.vala"
		_tmp70_ = page_get_action ((Page*) self, "NewEvent");
#line 180 "../src/Views/CollectionPage.vala"
		_data8_->new_event_action = _tmp70_;
#line 181 "../src/Views/CollectionPage.vala"
		_tmp71_ = _data8_->new_event_action;
#line 181 "../src/Views/CollectionPage.vala"
		_tmp72_ = new_event_menu_item;
#line 181 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp71_, "sensitive", (GObject*) _tmp72_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 182 "../src/Views/CollectionPage.vala"
		_tmp73_ = new_event_menu_item;
#line 182 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp73_, "activate", (GCallback) ____lambda88__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 184 "../src/Views/CollectionPage.vala"
		_tmp74_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("View Eve_nt for Photo"));
#line 184 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp74_);
#line 184 "../src/Views/CollectionPage.vala"
		jump_event_menu_item = _tmp74_;
#line 185 "../src/Views/CollectionPage.vala"
		_tmp75_ = page_get_common_action ((Page*) self, "CommonJumpToEvent", TRUE);
#line 185 "../src/Views/CollectionPage.vala"
		_data8_->jump_event_action = _tmp75_;
#line 186 "../src/Views/CollectionPage.vala"
		_tmp76_ = _data8_->jump_event_action;
#line 186 "../src/Views/CollectionPage.vala"
		_tmp77_ = jump_event_menu_item;
#line 186 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp76_, "sensitive", (GObject*) _tmp77_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 187 "../src/Views/CollectionPage.vala"
		_tmp78_ = jump_event_menu_item;
#line 187 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp78_, "activate", (GCallback) ____lambda89__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 189 "../src/Views/CollectionPage.vala"
		_tmp79_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_PRINT_MENU);
#line 189 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp79_);
#line 189 "../src/Views/CollectionPage.vala"
		print_menu_item = _tmp79_;
#line 190 "../src/Views/CollectionPage.vala"
		_tmp80_ = page_get_action ((Page*) self, "Print");
#line 190 "../src/Views/CollectionPage.vala"
		_data8_->print_action = _tmp80_;
#line 191 "../src/Views/CollectionPage.vala"
		_tmp81_ = _data8_->print_action;
#line 191 "../src/Views/CollectionPage.vala"
		_tmp82_ = print_menu_item;
#line 191 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp81_, "sensitive", (GObject*) _tmp82_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 192 "../src/Views/CollectionPage.vala"
		_tmp83_ = print_menu_item;
#line 192 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp83_, "activate", (GCallback) ____lambda90__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 194 "../src/Views/CollectionPage.vala"
		_tmp84_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_EXPORT_MENU);
#line 194 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp84_);
#line 194 "../src/Views/CollectionPage.vala"
		export_menu_item = _tmp84_;
#line 195 "../src/Views/CollectionPage.vala"
		_tmp85_ = page_get_action ((Page*) self, "Export");
#line 195 "../src/Views/CollectionPage.vala"
		_data8_->export_action = _tmp85_;
#line 196 "../src/Views/CollectionPage.vala"
		_tmp86_ = _data8_->export_action;
#line 196 "../src/Views/CollectionPage.vala"
		_tmp87_ = export_menu_item;
#line 196 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp86_, "sensitive", (GObject*) _tmp87_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 197 "../src/Views/CollectionPage.vala"
		_tmp88_ = export_menu_item;
#line 197 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp88_, "activate", (GCallback) ____lambda91__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 199 "../src/Views/CollectionPage.vala"
		_tmp89_ = g_strdup (APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_SET_WALLPAPER);
#line 199 "../src/Views/CollectionPage.vala"
		_tmp90_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Set as Wallpaper"));
#line 199 "../src/Views/CollectionPage.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp90_, _tmp89_);
#line 199 "../src/Views/CollectionPage.vala"
		_g_free0 (_tmp89_);
#line 199 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp90_);
#line 199 "../src/Views/CollectionPage.vala"
		wallpaper_menuitem = _tmp90_;
#line 203 "../src/Views/CollectionPage.vala"
		_tmp91_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Other Actions"));
#line 203 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp91_);
#line 203 "../src/Views/CollectionPage.vala"
		contractor_menu_item = _tmp91_;
#line 204 "../src/Views/CollectionPage.vala"
		_tmp92_ = (GtkMenu*) gtk_menu_new ();
#line 204 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp92_);
#line 204 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (self->priv->contractor_menu);
#line 204 "../src/Views/CollectionPage.vala"
		self->priv->contractor_menu = _tmp92_;
#line 205 "../src/Views/CollectionPage.vala"
		_tmp93_ = contractor_menu_item;
#line 205 "../src/Views/CollectionPage.vala"
		_tmp94_ = self->priv->contractor_menu;
#line 205 "../src/Views/CollectionPage.vala"
		gtk_menu_item_set_submenu (_tmp93_, _tmp94_);
#line 207 "../src/Views/CollectionPage.vala"
		_tmp95_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_REMOVE_FROM_LIBRARY_MENU);
#line 207 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp95_);
#line 207 "../src/Views/CollectionPage.vala"
		remove_menu_item = _tmp95_;
#line 208 "../src/Views/CollectionPage.vala"
		_tmp96_ = page_get_action ((Page*) self, "RemoveFromLibrary");
#line 208 "../src/Views/CollectionPage.vala"
		_data8_->remove_action = _tmp96_;
#line 209 "../src/Views/CollectionPage.vala"
		_tmp97_ = _data8_->remove_action;
#line 209 "../src/Views/CollectionPage.vala"
		_tmp98_ = remove_menu_item;
#line 209 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp97_, "sensitive", (GObject*) _tmp98_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 210 "../src/Views/CollectionPage.vala"
		_tmp99_ = remove_menu_item;
#line 210 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp99_, "activate", (GCallback) ____lambda92__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 212 "../src/Views/CollectionPage.vala"
		_tmp100_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_MOVE_TO_TRASH_MENU);
#line 212 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp100_);
#line 212 "../src/Views/CollectionPage.vala"
		trash_menu_item = _tmp100_;
#line 213 "../src/Views/CollectionPage.vala"
		_tmp101_ = page_get_action ((Page*) self, "MoveToTrash");
#line 213 "../src/Views/CollectionPage.vala"
		_data8_->trash_action = _tmp101_;
#line 214 "../src/Views/CollectionPage.vala"
		_tmp102_ = _data8_->trash_action;
#line 214 "../src/Views/CollectionPage.vala"
		_tmp103_ = trash_menu_item;
#line 214 "../src/Views/CollectionPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp102_, "sensitive", (GObject*) _tmp103_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 215 "../src/Views/CollectionPage.vala"
		_tmp104_ = trash_menu_item;
#line 215 "../src/Views/CollectionPage.vala"
		g_signal_connect_data (_tmp104_, "activate", (GCallback) ____lambda93__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 217 "../src/Views/CollectionPage.vala"
		_tmp105_ = self->priv->contractor_menu;
#line 217 "../src/Views/CollectionPage.vala"
		_tmp106_ = print_menu_item;
#line 217 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp105_, (GtkWidget*) _tmp106_);
#line 218 "../src/Views/CollectionPage.vala"
		_tmp107_ = self->priv->contractor_menu;
#line 218 "../src/Views/CollectionPage.vala"
		_tmp108_ = export_menu_item;
#line 218 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp107_, (GtkWidget*) _tmp108_);
#line 219 "../src/Views/CollectionPage.vala"
		_tmp109_ = self->priv->contractor_menu;
#line 219 "../src/Views/CollectionPage.vala"
		_tmp110_ = wallpaper_menuitem;
#line 219 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp109_, (GtkWidget*) _tmp110_);
#line 221 "../src/Views/CollectionPage.vala"
		_tmp111_ = self->priv->item_context_menu;
#line 221 "../src/Views/CollectionPage.vala"
		_tmp112_ = copy_images_menu_item;
#line 221 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp111_, (GtkWidget*) _tmp112_);
#line 222 "../src/Views/CollectionPage.vala"
		_tmp113_ = self->priv->item_context_menu;
#line 222 "../src/Views/CollectionPage.vala"
		_tmp114_ = adjust_datetime_menu_item;
#line 222 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp113_, (GtkWidget*) _tmp114_);
#line 223 "../src/Views/CollectionPage.vala"
		_tmp115_ = self->priv->item_context_menu;
#line 223 "../src/Views/CollectionPage.vala"
		_tmp116_ = duplicate_menu_item;
#line 223 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp115_, (GtkWidget*) _tmp116_);
#line 224 "../src/Views/CollectionPage.vala"
		_tmp117_ = self->priv->item_context_menu;
#line 224 "../src/Views/CollectionPage.vala"
		_tmp118_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 224 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp118_);
#line 224 "../src/Views/CollectionPage.vala"
		_tmp119_ = _tmp118_;
#line 224 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp117_, (GtkWidget*) _tmp119_);
#line 224 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp119_);
#line 225 "../src/Views/CollectionPage.vala"
		_tmp120_ = self->priv->item_context_menu;
#line 225 "../src/Views/CollectionPage.vala"
		_tmp121_ = open_menu_item;
#line 225 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp120_, (GtkWidget*) _tmp121_);
#line 226 "../src/Views/CollectionPage.vala"
		_tmp122_ = self->priv->item_context_menu;
#line 226 "../src/Views/CollectionPage.vala"
		_tmp123_ = contractor_menu_item;
#line 226 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp122_, (GtkWidget*) _tmp123_);
#line 227 "../src/Views/CollectionPage.vala"
		_tmp124_ = self->priv->item_context_menu;
#line 227 "../src/Views/CollectionPage.vala"
		_tmp125_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 227 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp125_);
#line 227 "../src/Views/CollectionPage.vala"
		_tmp126_ = _tmp125_;
#line 227 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp124_, (GtkWidget*) _tmp126_);
#line 227 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp126_);
#line 228 "../src/Views/CollectionPage.vala"
		_tmp127_ = self->priv->item_context_menu;
#line 228 "../src/Views/CollectionPage.vala"
		_tmp128_ = copy_color_menu_item;
#line 228 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp127_, (GtkWidget*) _tmp128_);
#line 229 "../src/Views/CollectionPage.vala"
		_tmp129_ = self->priv->item_context_menu;
#line 229 "../src/Views/CollectionPage.vala"
		_tmp130_ = paste_color_menu_item;
#line 229 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp129_, (GtkWidget*) _tmp130_);
#line 230 "../src/Views/CollectionPage.vala"
		_tmp131_ = self->priv->item_context_menu;
#line 230 "../src/Views/CollectionPage.vala"
		_tmp132_ = revert_menu_item;
#line 230 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp131_, (GtkWidget*) _tmp132_);
#line 231 "../src/Views/CollectionPage.vala"
		_tmp133_ = self->priv->item_context_menu;
#line 231 "../src/Views/CollectionPage.vala"
		_tmp134_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 231 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp134_);
#line 231 "../src/Views/CollectionPage.vala"
		_tmp135_ = _tmp134_;
#line 231 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp133_, (GtkWidget*) _tmp135_);
#line 231 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp135_);
#line 232 "../src/Views/CollectionPage.vala"
		_tmp136_ = self->priv->item_context_menu;
#line 232 "../src/Views/CollectionPage.vala"
		_tmp137_ = flag_menu_item;
#line 232 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp136_, (GtkWidget*) _tmp137_);
#line 233 "../src/Views/CollectionPage.vala"
		_tmp138_ = self->priv->item_context_menu;
#line 233 "../src/Views/CollectionPage.vala"
		_tmp139_ = raw_developer_menu_item;
#line 233 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp138_, (GtkWidget*) _tmp139_);
#line 234 "../src/Views/CollectionPage.vala"
		_tmp140_ = self->priv->item_context_menu;
#line 234 "../src/Views/CollectionPage.vala"
		_tmp141_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 234 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp141_);
#line 234 "../src/Views/CollectionPage.vala"
		_tmp142_ = _tmp141_;
#line 234 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp140_, (GtkWidget*) _tmp142_);
#line 234 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp142_);
#line 235 "../src/Views/CollectionPage.vala"
		_tmp143_ = self->priv->item_context_menu;
#line 235 "../src/Views/CollectionPage.vala"
		_tmp144_ = new_event_menu_item;
#line 235 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp143_, (GtkWidget*) _tmp144_);
#line 236 "../src/Views/CollectionPage.vala"
		_tmp145_ = self->priv->item_context_menu;
#line 236 "../src/Views/CollectionPage.vala"
		_tmp146_ = jump_event_menu_item;
#line 236 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp145_, (GtkWidget*) _tmp146_);
#line 237 "../src/Views/CollectionPage.vala"
		_tmp147_ = self->priv->item_context_menu;
#line 237 "../src/Views/CollectionPage.vala"
		_tmp148_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 237 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp148_);
#line 237 "../src/Views/CollectionPage.vala"
		_tmp149_ = _tmp148_;
#line 237 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp147_, (GtkWidget*) _tmp149_);
#line 237 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp149_);
#line 238 "../src/Views/CollectionPage.vala"
		_tmp150_ = self->priv->item_context_menu;
#line 238 "../src/Views/CollectionPage.vala"
		_tmp151_ = metadata_menu_item;
#line 238 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp150_, (GtkWidget*) _tmp151_);
#line 239 "../src/Views/CollectionPage.vala"
		_tmp152_ = self->priv->item_context_menu;
#line 239 "../src/Views/CollectionPage.vala"
		_tmp153_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 239 "../src/Views/CollectionPage.vala"
		g_object_ref_sink (_tmp153_);
#line 239 "../src/Views/CollectionPage.vala"
		_tmp154_ = _tmp153_;
#line 239 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp152_, (GtkWidget*) _tmp154_);
#line 239 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp154_);
#line 240 "../src/Views/CollectionPage.vala"
		_tmp155_ = self->priv->item_context_menu;
#line 240 "../src/Views/CollectionPage.vala"
		_tmp156_ = remove_menu_item;
#line 240 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp155_, (GtkWidget*) _tmp156_);
#line 241 "../src/Views/CollectionPage.vala"
		_tmp157_ = self->priv->item_context_menu;
#line 241 "../src/Views/CollectionPage.vala"
		_tmp158_ = trash_menu_item;
#line 241 "../src/Views/CollectionPage.vala"
		gtk_container_add ((GtkContainer*) _tmp157_, (GtkWidget*) _tmp158_);
#line 242 "../src/Views/CollectionPage.vala"
		_tmp159_ = self->priv->item_context_menu;
#line 242 "../src/Views/CollectionPage.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp159_);
#line 244 "../src/Views/CollectionPage.vala"
		_tmp160_ = page_get_view ((Page*) self);
#line 244 "../src/Views/CollectionPage.vala"
		_tmp161_ = _tmp160_;
#line 244 "../src/Views/CollectionPage.vala"
		_tmp162_ = view_collection_get_selected_at (_tmp161_, 0);
#line 244 "../src/Views/CollectionPage.vala"
		_tmp163_ = _tmp162_;
#line 244 "../src/Views/CollectionPage.vala"
		_tmp164_ = data_view_get_source (_tmp163_);
#line 244 "../src/Views/CollectionPage.vala"
		_tmp165_ = _tmp164_;
#line 244 "../src/Views/CollectionPage.vala"
		_tmp166_ = _g_object_ref0 (_tmp165_);
#line 244 "../src/Views/CollectionPage.vala"
		_tmp167_ = _tmp166_;
#line 244 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp163_);
#line 244 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp161_);
#line 244 "../src/Views/CollectionPage.vala"
		source = _tmp167_;
#line 245 "../src/Views/CollectionPage.vala"
		_tmp169_ = source;
#line 245 "../src/Views/CollectionPage.vala"
		if (_tmp169_ != NULL) {
#line 1923 "CollectionPage.c"
			DataSource* _tmp170_;
#line 245 "../src/Views/CollectionPage.vala"
			_tmp170_ = source;
#line 245 "../src/Views/CollectionPage.vala"
			_tmp168_ = IS_PHOTO (_tmp170_);
#line 1929 "CollectionPage.c"
		} else {
#line 245 "../src/Views/CollectionPage.vala"
			_tmp168_ = FALSE;
#line 1933 "CollectionPage.c"
		}
#line 245 "../src/Views/CollectionPage.vala"
		if (_tmp168_) {
#line 1937 "CollectionPage.c"
			GFile* file = NULL;
			DataSource* _tmp171_;
			GFile* _tmp172_;
			GtkMenuItem* _tmp173_;
			GFile* _tmp174_;
			gchar* _tmp175_;
			gchar* _tmp176_;
			GVariant* _tmp177_;
			GVariant* _tmp178_;
#line 246 "../src/Views/CollectionPage.vala"
			_tmp171_ = source;
#line 246 "../src/Views/CollectionPage.vala"
			_tmp172_ = media_source_get_file ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (_tmp171_, TYPE_PHOTO, Photo));
#line 246 "../src/Views/CollectionPage.vala"
			file = _tmp172_;
#line 247 "../src/Views/CollectionPage.vala"
			_tmp173_ = wallpaper_menuitem;
#line 247 "../src/Views/CollectionPage.vala"
			_tmp174_ = file;
#line 247 "../src/Views/CollectionPage.vala"
			_tmp175_ = g_file_get_uri (_tmp174_);
#line 247 "../src/Views/CollectionPage.vala"
			_tmp176_ = _tmp175_;
#line 247 "../src/Views/CollectionPage.vala"
			_tmp177_ = g_variant_new_string (_tmp176_);
#line 247 "../src/Views/CollectionPage.vala"
			g_variant_ref_sink (_tmp177_);
#line 247 "../src/Views/CollectionPage.vala"
			_tmp178_ = _tmp177_;
#line 247 "../src/Views/CollectionPage.vala"
			g_object_set ((GtkActionable*) _tmp173_, "action-target", _tmp178_, NULL);
#line 247 "../src/Views/CollectionPage.vala"
			_g_variant_unref0 (_tmp178_);
#line 247 "../src/Views/CollectionPage.vala"
			_g_free0 (_tmp176_);
#line 245 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (file);
#line 1975 "CollectionPage.c"
		}
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (source);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (trash_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (remove_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (contractor_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (wallpaper_menuitem);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (print_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (jump_event_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (new_event_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (open_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (adjust_datetime_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (raw_developer_menu);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (raw_developer_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (raw_developer_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (raw_developer_camera_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (raw_developer_app_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (flag_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (paste_color_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (copy_color_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (duplicate_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (revert_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (metadata_action);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (metadata_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (copy_images_menu_item);
#line 113 "../src/Views/CollectionPage.vala"
		block8_data_unref (_data8_);
#line 113 "../src/Views/CollectionPage.vala"
		_data8_ = NULL;
#line 2029 "CollectionPage.c"
	}
#line 251 "../src/Views/CollectionPage.vala"
	_tmp179_ = self->priv->contractor_menu;
#line 251 "../src/Views/CollectionPage.vala"
	page_populate_contractor_menu ((Page*) self, _tmp179_);
#line 252 "../src/Views/CollectionPage.vala"
	_tmp180_ = self->priv->item_context_menu;
#line 252 "../src/Views/CollectionPage.vala"
	_tmp181_ = _g_object_ref0 (_tmp180_);
#line 252 "../src/Views/CollectionPage.vala"
	result = _tmp181_;
#line 252 "../src/Views/CollectionPage.vala"
	return result;
#line 2043 "CollectionPage.c"
}

static void
_collection_page_on_print_gcallback (GtkAction* action,
                                     gpointer self)
{
#line 256 "../src/Views/CollectionPage.vala"
	collection_page_on_print ((CollectionPage*) self);
#line 2052 "CollectionPage.c"
}

static void
_collection_page_on_rotate_clockwise_gcallback (GtkAction* action,
                                                gpointer self)
{
#line 257 "../src/Views/CollectionPage.vala"
	collection_page_on_rotate_clockwise ((CollectionPage*) self);
#line 2061 "CollectionPage.c"
}

static void
_collection_page_on_rotate_counterclockwise_gcallback (GtkAction* action,
                                                       gpointer self)
{
#line 258 "../src/Views/CollectionPage.vala"
	collection_page_on_rotate_counterclockwise ((CollectionPage*) self);
#line 2070 "CollectionPage.c"
}

static void
_collection_page_on_flip_horizontally_gcallback (GtkAction* action,
                                                 gpointer self)
{
#line 259 "../src/Views/CollectionPage.vala"
	collection_page_on_flip_horizontally ((CollectionPage*) self);
#line 2079 "CollectionPage.c"
}

static void
_collection_page_on_flip_vertically_gcallback (GtkAction* action,
                                               gpointer self)
{
#line 260 "../src/Views/CollectionPage.vala"
	collection_page_on_flip_vertically ((CollectionPage*) self);
#line 2088 "CollectionPage.c"
}

static void
_collection_page_on_copy_adjustments_gcallback (GtkAction* action,
                                                gpointer self)
{
#line 261 "../src/Views/CollectionPage.vala"
	collection_page_on_copy_adjustments ((CollectionPage*) self);
#line 2097 "CollectionPage.c"
}

static void
_collection_page_on_paste_adjustments_gcallback (GtkAction* action,
                                                 gpointer self)
{
#line 262 "../src/Views/CollectionPage.vala"
	collection_page_on_paste_adjustments ((CollectionPage*) self);
#line 2106 "CollectionPage.c"
}

static void
_collection_page_on_revert_gcallback (GtkAction* action,
                                      gpointer self)
{
#line 263 "../src/Views/CollectionPage.vala"
	collection_page_on_revert ((CollectionPage*) self);
#line 2115 "CollectionPage.c"
}

static void
_collection_page_on_duplicate_photo_gcallback (GtkAction* action,
                                               gpointer self)
{
#line 264 "../src/Views/CollectionPage.vala"
	collection_page_on_duplicate_photo ((CollectionPage*) self);
#line 2124 "CollectionPage.c"
}

static void
_collection_page_on_adjust_date_time_gcallback (GtkAction* action,
                                                gpointer self)
{
#line 265 "../src/Views/CollectionPage.vala"
	collection_page_on_adjust_date_time ((CollectionPage*) self);
#line 2133 "CollectionPage.c"
}

static void
_collection_page_on_enhance_gcallback (GtkAction* action,
                                       gpointer self)
{
#line 268 "../src/Views/CollectionPage.vala"
	collection_page_on_enhance ((CollectionPage*) self);
#line 2142 "CollectionPage.c"
}

static void
_collection_page_on_slideshow_gcallback (GtkAction* action,
                                         gpointer self)
{
#line 269 "../src/Views/CollectionPage.vala"
	collection_page_on_slideshow ((CollectionPage*) self);
#line 2151 "CollectionPage.c"
}

static void
_collection_page_on_copy_images_gcallback (GtkAction* action,
                                           gpointer self)
{
#line 270 "../src/Views/CollectionPage.vala"
	collection_page_on_copy_images ((CollectionPage*) self);
#line 2160 "CollectionPage.c"
}

static void
_vala_array_add113 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 273 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 273 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 273 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2175 "CollectionPage.c"
	}
#line 273 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2179 "CollectionPage.c"
}

static void
_vala_array_add114 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 274 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 274 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 274 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2194 "CollectionPage.c"
	}
#line 274 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2198 "CollectionPage.c"
}

static void
_vala_array_add115 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 275 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 275 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 275 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2213 "CollectionPage.c"
	}
#line 275 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2217 "CollectionPage.c"
}

static void
_vala_array_add116 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 276 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 276 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 276 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2232 "CollectionPage.c"
	}
#line 276 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2236 "CollectionPage.c"
}

static void
_vala_array_add117 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 277 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 277 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 277 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2251 "CollectionPage.c"
	}
#line 277 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2255 "CollectionPage.c"
}

static void
_vala_array_add118 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 278 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 278 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 278 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2270 "CollectionPage.c"
	}
#line 278 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2274 "CollectionPage.c"
}

static void
_vala_array_add119 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 279 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 279 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 279 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2289 "CollectionPage.c"
	}
#line 279 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2293 "CollectionPage.c"
}

static void
_vala_array_add120 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 280 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 280 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 280 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2308 "CollectionPage.c"
	}
#line 280 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2312 "CollectionPage.c"
}

static void
_vala_array_add121 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 281 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 281 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 281 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2327 "CollectionPage.c"
	}
#line 281 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2331 "CollectionPage.c"
}

static void
_vala_array_add122 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 282 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 282 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 282 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2346 "CollectionPage.c"
	}
#line 282 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2350 "CollectionPage.c"
}

static void
_vala_array_add123 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 283 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 283 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 283 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2365 "CollectionPage.c"
	}
#line 283 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2369 "CollectionPage.c"
}

static void
_vala_array_add124 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 284 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 284 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 284 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2384 "CollectionPage.c"
	}
#line 284 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2388 "CollectionPage.c"
}

static void
_vala_array_add125 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 285 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 285 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 285 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2403 "CollectionPage.c"
	}
#line 285 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2407 "CollectionPage.c"
}

static void
_vala_array_add126 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 286 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 286 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 286 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2422 "CollectionPage.c"
	}
#line 286 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2426 "CollectionPage.c"
}

static void
_vala_array_add127 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 287 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 287 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 287 "../src/Views/CollectionPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 2441 "CollectionPage.c"
	}
#line 287 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = *value;
#line 2445 "CollectionPage.c"
}

static GtkActionEntry*
collection_page_real_init_collect_action_entries (Page* base,
                                                  gint* result_length1)
{
	CollectionPage * self;
	GtkActionEntry print = {0};
	GtkActionEntry _tmp0_ = {0};
	GtkActionEntry rotate_right = {0};
	GtkActionEntry _tmp1_ = {0};
	GtkActionEntry rotate_left = {0};
	GtkActionEntry _tmp2_ = {0};
	GtkActionEntry hflip = {0};
	GtkActionEntry _tmp3_ = {0};
	GtkActionEntry vflip = {0};
	GtkActionEntry _tmp4_ = {0};
	GtkActionEntry copy_adjustments = {0};
	GtkActionEntry _tmp5_ = {0};
	GtkActionEntry paste_adjustments = {0};
	GtkActionEntry _tmp6_ = {0};
	GtkActionEntry revert = {0};
	GtkActionEntry _tmp7_ = {0};
	GtkActionEntry duplicate = {0};
	GtkActionEntry _tmp8_ = {0};
	GtkActionEntry adjust_date_time = {0};
	GtkActionEntry _tmp9_ = {0};
	GtkActionEntry open_with = {0};
	GtkActionEntry _tmp10_ = {0};
	GtkActionEntry open_with_raw = {0};
	GtkActionEntry _tmp11_ = {0};
	GtkActionEntry enhance = {0};
	GtkActionEntry _tmp12_ = {0};
	GtkActionEntry slideshow = {0};
	GtkActionEntry _tmp13_ = {0};
	GtkActionEntry copy = {0};
	GtkActionEntry _tmp14_ = {0};
	GtkActionEntry* actions = NULL;
	gint _tmp15_ = 0;
	GtkActionEntry* _tmp16_;
	gint actions_length1;
	gint _actions_size_;
	GtkActionEntry _tmp17_;
	GtkActionEntry _tmp18_;
	GtkActionEntry _tmp19_;
	GtkActionEntry _tmp20_;
	GtkActionEntry _tmp21_;
	GtkActionEntry _tmp22_;
	GtkActionEntry _tmp23_;
	GtkActionEntry _tmp24_;
	GtkActionEntry _tmp25_;
	GtkActionEntry _tmp26_;
	GtkActionEntry _tmp27_;
	GtkActionEntry _tmp28_;
	GtkActionEntry _tmp29_;
	GtkActionEntry _tmp30_;
	GtkActionEntry _tmp31_;
	GtkActionEntry* _tmp32_;
	gint _tmp32__length1;
	GtkActionEntry* result;
#line 255 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 256 "../src/Views/CollectionPage.vala"
	_tmp0_.name = "Print";
#line 256 "../src/Views/CollectionPage.vala"
	_tmp0_.stock_id = NULL;
#line 256 "../src/Views/CollectionPage.vala"
	_tmp0_.label = NULL;
#line 256 "../src/Views/CollectionPage.vala"
	_tmp0_.accelerator = "<Ctrl>P";
#line 256 "../src/Views/CollectionPage.vala"
	_tmp0_.tooltip = NULL;
#line 256 "../src/Views/CollectionPage.vala"
	_tmp0_.callback = (GCallback) _collection_page_on_print_gcallback;
#line 256 "../src/Views/CollectionPage.vala"
	print = _tmp0_;
#line 257 "../src/Views/CollectionPage.vala"
	_tmp1_.name = "RotateClockwise";
#line 257 "../src/Views/CollectionPage.vala"
	_tmp1_.stock_id = NULL;
#line 257 "../src/Views/CollectionPage.vala"
	_tmp1_.label = NULL;
#line 257 "../src/Views/CollectionPage.vala"
	_tmp1_.accelerator = "<Ctrl>R";
#line 257 "../src/Views/CollectionPage.vala"
	_tmp1_.tooltip = NULL;
#line 257 "../src/Views/CollectionPage.vala"
	_tmp1_.callback = (GCallback) _collection_page_on_rotate_clockwise_gcallback;
#line 257 "../src/Views/CollectionPage.vala"
	rotate_right = _tmp1_;
#line 258 "../src/Views/CollectionPage.vala"
	_tmp2_.name = "RotateCounterclockwise";
#line 258 "../src/Views/CollectionPage.vala"
	_tmp2_.stock_id = NULL;
#line 258 "../src/Views/CollectionPage.vala"
	_tmp2_.label = NULL;
#line 258 "../src/Views/CollectionPage.vala"
	_tmp2_.accelerator = "<Ctrl><Shift>R";
#line 258 "../src/Views/CollectionPage.vala"
	_tmp2_.tooltip = NULL;
#line 258 "../src/Views/CollectionPage.vala"
	_tmp2_.callback = (GCallback) _collection_page_on_rotate_counterclockwise_gcallback;
#line 258 "../src/Views/CollectionPage.vala"
	rotate_left = _tmp2_;
#line 259 "../src/Views/CollectionPage.vala"
	_tmp3_.name = "FlipHorizontally";
#line 259 "../src/Views/CollectionPage.vala"
	_tmp3_.stock_id = NULL;
#line 259 "../src/Views/CollectionPage.vala"
	_tmp3_.label = NULL;
#line 259 "../src/Views/CollectionPage.vala"
	_tmp3_.accelerator = NULL;
#line 259 "../src/Views/CollectionPage.vala"
	_tmp3_.tooltip = NULL;
#line 259 "../src/Views/CollectionPage.vala"
	_tmp3_.callback = (GCallback) _collection_page_on_flip_horizontally_gcallback;
#line 259 "../src/Views/CollectionPage.vala"
	hflip = _tmp3_;
#line 260 "../src/Views/CollectionPage.vala"
	_tmp4_.name = "FlipVertically";
#line 260 "../src/Views/CollectionPage.vala"
	_tmp4_.stock_id = NULL;
#line 260 "../src/Views/CollectionPage.vala"
	_tmp4_.label = NULL;
#line 260 "../src/Views/CollectionPage.vala"
	_tmp4_.accelerator = NULL;
#line 260 "../src/Views/CollectionPage.vala"
	_tmp4_.tooltip = NULL;
#line 260 "../src/Views/CollectionPage.vala"
	_tmp4_.callback = (GCallback) _collection_page_on_flip_vertically_gcallback;
#line 260 "../src/Views/CollectionPage.vala"
	vflip = _tmp4_;
#line 261 "../src/Views/CollectionPage.vala"
	_tmp5_.name = "CopyColorAdjustments";
#line 261 "../src/Views/CollectionPage.vala"
	_tmp5_.stock_id = NULL;
#line 261 "../src/Views/CollectionPage.vala"
	_tmp5_.label = NULL;
#line 261 "../src/Views/CollectionPage.vala"
	_tmp5_.accelerator = "<Ctrl><Shift>C";
#line 261 "../src/Views/CollectionPage.vala"
	_tmp5_.tooltip = NULL;
#line 261 "../src/Views/CollectionPage.vala"
	_tmp5_.callback = (GCallback) _collection_page_on_copy_adjustments_gcallback;
#line 261 "../src/Views/CollectionPage.vala"
	copy_adjustments = _tmp5_;
#line 262 "../src/Views/CollectionPage.vala"
	_tmp6_.name = "PasteColorAdjustments";
#line 262 "../src/Views/CollectionPage.vala"
	_tmp6_.stock_id = NULL;
#line 262 "../src/Views/CollectionPage.vala"
	_tmp6_.label = NULL;
#line 262 "../src/Views/CollectionPage.vala"
	_tmp6_.accelerator = "<Ctrl><Shift>V";
#line 262 "../src/Views/CollectionPage.vala"
	_tmp6_.tooltip = NULL;
#line 262 "../src/Views/CollectionPage.vala"
	_tmp6_.callback = (GCallback) _collection_page_on_paste_adjustments_gcallback;
#line 262 "../src/Views/CollectionPage.vala"
	paste_adjustments = _tmp6_;
#line 263 "../src/Views/CollectionPage.vala"
	_tmp7_.name = "Revert";
#line 263 "../src/Views/CollectionPage.vala"
	_tmp7_.stock_id = NULL;
#line 263 "../src/Views/CollectionPage.vala"
	_tmp7_.label = NULL;
#line 263 "../src/Views/CollectionPage.vala"
	_tmp7_.accelerator = NULL;
#line 263 "../src/Views/CollectionPage.vala"
	_tmp7_.tooltip = NULL;
#line 263 "../src/Views/CollectionPage.vala"
	_tmp7_.callback = (GCallback) _collection_page_on_revert_gcallback;
#line 263 "../src/Views/CollectionPage.vala"
	revert = _tmp7_;
#line 264 "../src/Views/CollectionPage.vala"
	_tmp8_.name = "Duplicate";
#line 264 "../src/Views/CollectionPage.vala"
	_tmp8_.stock_id = NULL;
#line 264 "../src/Views/CollectionPage.vala"
	_tmp8_.label = NULL;
#line 264 "../src/Views/CollectionPage.vala"
	_tmp8_.accelerator = "<Ctrl>D";
#line 264 "../src/Views/CollectionPage.vala"
	_tmp8_.tooltip = NULL;
#line 264 "../src/Views/CollectionPage.vala"
	_tmp8_.callback = (GCallback) _collection_page_on_duplicate_photo_gcallback;
#line 264 "../src/Views/CollectionPage.vala"
	duplicate = _tmp8_;
#line 265 "../src/Views/CollectionPage.vala"
	_tmp9_.name = "AdjustDateTime";
#line 265 "../src/Views/CollectionPage.vala"
	_tmp9_.stock_id = NULL;
#line 265 "../src/Views/CollectionPage.vala"
	_tmp9_.label = NULL;
#line 265 "../src/Views/CollectionPage.vala"
	_tmp9_.accelerator = NULL;
#line 265 "../src/Views/CollectionPage.vala"
	_tmp9_.tooltip = NULL;
#line 265 "../src/Views/CollectionPage.vala"
	_tmp9_.callback = (GCallback) _collection_page_on_adjust_date_time_gcallback;
#line 265 "../src/Views/CollectionPage.vala"
	adjust_date_time = _tmp9_;
#line 266 "../src/Views/CollectionPage.vala"
	_tmp10_.name = "OpenWith";
#line 266 "../src/Views/CollectionPage.vala"
	_tmp10_.stock_id = NULL;
#line 266 "../src/Views/CollectionPage.vala"
	_tmp10_.label = NULL;
#line 266 "../src/Views/CollectionPage.vala"
	_tmp10_.accelerator = NULL;
#line 266 "../src/Views/CollectionPage.vala"
	_tmp10_.tooltip = NULL;
#line 266 "../src/Views/CollectionPage.vala"
	_tmp10_.callback = (GCallback) NULL;
#line 266 "../src/Views/CollectionPage.vala"
	open_with = _tmp10_;
#line 267 "../src/Views/CollectionPage.vala"
	_tmp11_.name = "OpenWithRaw";
#line 267 "../src/Views/CollectionPage.vala"
	_tmp11_.stock_id = NULL;
#line 267 "../src/Views/CollectionPage.vala"
	_tmp11_.label = NULL;
#line 267 "../src/Views/CollectionPage.vala"
	_tmp11_.accelerator = NULL;
#line 267 "../src/Views/CollectionPage.vala"
	_tmp11_.tooltip = NULL;
#line 267 "../src/Views/CollectionPage.vala"
	_tmp11_.callback = (GCallback) NULL;
#line 267 "../src/Views/CollectionPage.vala"
	open_with_raw = _tmp11_;
#line 268 "../src/Views/CollectionPage.vala"
	_tmp12_.name = "Enhance";
#line 268 "../src/Views/CollectionPage.vala"
	_tmp12_.stock_id = NULL;
#line 268 "../src/Views/CollectionPage.vala"
	_tmp12_.label = NULL;
#line 268 "../src/Views/CollectionPage.vala"
	_tmp12_.accelerator = "<Ctrl>E";
#line 268 "../src/Views/CollectionPage.vala"
	_tmp12_.tooltip = NULL;
#line 268 "../src/Views/CollectionPage.vala"
	_tmp12_.callback = (GCallback) _collection_page_on_enhance_gcallback;
#line 268 "../src/Views/CollectionPage.vala"
	enhance = _tmp12_;
#line 269 "../src/Views/CollectionPage.vala"
	_tmp13_.name = "Slideshow";
#line 269 "../src/Views/CollectionPage.vala"
	_tmp13_.stock_id = NULL;
#line 269 "../src/Views/CollectionPage.vala"
	_tmp13_.label = NULL;
#line 269 "../src/Views/CollectionPage.vala"
	_tmp13_.accelerator = "F5";
#line 269 "../src/Views/CollectionPage.vala"
	_tmp13_.tooltip = NULL;
#line 269 "../src/Views/CollectionPage.vala"
	_tmp13_.callback = (GCallback) _collection_page_on_slideshow_gcallback;
#line 269 "../src/Views/CollectionPage.vala"
	slideshow = _tmp13_;
#line 270 "../src/Views/CollectionPage.vala"
	_tmp14_.name = "CopyImages";
#line 270 "../src/Views/CollectionPage.vala"
	_tmp14_.stock_id = NULL;
#line 270 "../src/Views/CollectionPage.vala"
	_tmp14_.label = NULL;
#line 270 "../src/Views/CollectionPage.vala"
	_tmp14_.accelerator = "<Ctrl>C";
#line 270 "../src/Views/CollectionPage.vala"
	_tmp14_.tooltip = NULL;
#line 270 "../src/Views/CollectionPage.vala"
	_tmp14_.callback = (GCallback) _collection_page_on_copy_images_gcallback;
#line 270 "../src/Views/CollectionPage.vala"
	copy = _tmp14_;
#line 272 "../src/Views/CollectionPage.vala"
	_tmp16_ = PAGE_CLASS (collection_page_parent_class)->init_collect_action_entries ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_PAGE, MediaPage), &_tmp15_);
#line 272 "../src/Views/CollectionPage.vala"
	actions = _tmp16_;
#line 272 "../src/Views/CollectionPage.vala"
	actions_length1 = _tmp15_;
#line 272 "../src/Views/CollectionPage.vala"
	_actions_size_ = actions_length1;
#line 273 "../src/Views/CollectionPage.vala"
	_tmp17_ = copy;
#line 273 "../src/Views/CollectionPage.vala"
	_vala_array_add113 (&actions, &actions_length1, &_actions_size_, &_tmp17_);
#line 274 "../src/Views/CollectionPage.vala"
	_tmp18_ = print;
#line 274 "../src/Views/CollectionPage.vala"
	_vala_array_add114 (&actions, &actions_length1, &_actions_size_, &_tmp18_);
#line 275 "../src/Views/CollectionPage.vala"
	_tmp19_ = rotate_right;
#line 275 "../src/Views/CollectionPage.vala"
	_vala_array_add115 (&actions, &actions_length1, &_actions_size_, &_tmp19_);
#line 276 "../src/Views/CollectionPage.vala"
	_tmp20_ = rotate_left;
#line 276 "../src/Views/CollectionPage.vala"
	_vala_array_add116 (&actions, &actions_length1, &_actions_size_, &_tmp20_);
#line 277 "../src/Views/CollectionPage.vala"
	_tmp21_ = hflip;
#line 277 "../src/Views/CollectionPage.vala"
	_vala_array_add117 (&actions, &actions_length1, &_actions_size_, &_tmp21_);
#line 278 "../src/Views/CollectionPage.vala"
	_tmp22_ = vflip;
#line 278 "../src/Views/CollectionPage.vala"
	_vala_array_add118 (&actions, &actions_length1, &_actions_size_, &_tmp22_);
#line 279 "../src/Views/CollectionPage.vala"
	_tmp23_ = copy_adjustments;
#line 279 "../src/Views/CollectionPage.vala"
	_vala_array_add119 (&actions, &actions_length1, &_actions_size_, &_tmp23_);
#line 280 "../src/Views/CollectionPage.vala"
	_tmp24_ = paste_adjustments;
#line 280 "../src/Views/CollectionPage.vala"
	_vala_array_add120 (&actions, &actions_length1, &_actions_size_, &_tmp24_);
#line 281 "../src/Views/CollectionPage.vala"
	_tmp25_ = revert;
#line 281 "../src/Views/CollectionPage.vala"
	_vala_array_add121 (&actions, &actions_length1, &_actions_size_, &_tmp25_);
#line 282 "../src/Views/CollectionPage.vala"
	_tmp26_ = duplicate;
#line 282 "../src/Views/CollectionPage.vala"
	_vala_array_add122 (&actions, &actions_length1, &_actions_size_, &_tmp26_);
#line 283 "../src/Views/CollectionPage.vala"
	_tmp27_ = adjust_date_time;
#line 283 "../src/Views/CollectionPage.vala"
	_vala_array_add123 (&actions, &actions_length1, &_actions_size_, &_tmp27_);
#line 284 "../src/Views/CollectionPage.vala"
	_tmp28_ = open_with;
#line 284 "../src/Views/CollectionPage.vala"
	_vala_array_add124 (&actions, &actions_length1, &_actions_size_, &_tmp28_);
#line 285 "../src/Views/CollectionPage.vala"
	_tmp29_ = open_with_raw;
#line 285 "../src/Views/CollectionPage.vala"
	_vala_array_add125 (&actions, &actions_length1, &_actions_size_, &_tmp29_);
#line 286 "../src/Views/CollectionPage.vala"
	_tmp30_ = enhance;
#line 286 "../src/Views/CollectionPage.vala"
	_vala_array_add126 (&actions, &actions_length1, &_actions_size_, &_tmp30_);
#line 287 "../src/Views/CollectionPage.vala"
	_tmp31_ = slideshow;
#line 287 "../src/Views/CollectionPage.vala"
	_vala_array_add127 (&actions, &actions_length1, &_actions_size_, &_tmp31_);
#line 289 "../src/Views/CollectionPage.vala"
	_tmp32_ = actions;
#line 289 "../src/Views/CollectionPage.vala"
	_tmp32__length1 = actions_length1;
#line 289 "../src/Views/CollectionPage.vala"
	if (result_length1) {
#line 289 "../src/Views/CollectionPage.vala"
		*result_length1 = _tmp32__length1;
#line 2794 "CollectionPage.c"
	}
#line 289 "../src/Views/CollectionPage.vala"
	result = _tmp32_;
#line 289 "../src/Views/CollectionPage.vala"
	return result;
#line 2800 "CollectionPage.c"
}

void
collection_page_set_action_details (CollectionPage* self,
                                    const gchar* name,
                                    const gchar* label,
                                    const gchar* tooltip,
                                    gboolean sensitive)
{
	GtkAction* action = NULL;
	GtkAction* _tmp0_;
	GtkAction* _tmp1_;
	GtkAction* _tmp4_;
#line 292 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/Views/CollectionPage.vala"
	g_return_if_fail (name != NULL);
#line 293 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_action ((Page*) self, name);
#line 293 "../src/Views/CollectionPage.vala"
	action = _tmp0_;
#line 294 "../src/Views/CollectionPage.vala"
	_tmp1_ = action;
#line 294 "../src/Views/CollectionPage.vala"
	if (_tmp1_ == NULL) {
#line 295 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (action);
#line 295 "../src/Views/CollectionPage.vala"
		return;
#line 2830 "CollectionPage.c"
	}
#line 297 "../src/Views/CollectionPage.vala"
	if (label != NULL) {
#line 2834 "CollectionPage.c"
		GtkAction* _tmp2_;
#line 298 "../src/Views/CollectionPage.vala"
		_tmp2_ = action;
#line 298 "../src/Views/CollectionPage.vala"
		gtk_action_set_label (_tmp2_, label);
#line 2840 "CollectionPage.c"
	}
#line 300 "../src/Views/CollectionPage.vala"
	if (tooltip != NULL) {
#line 2844 "CollectionPage.c"
		GtkAction* _tmp3_;
#line 301 "../src/Views/CollectionPage.vala"
		_tmp3_ = action;
#line 301 "../src/Views/CollectionPage.vala"
		gtk_action_set_tooltip (_tmp3_, tooltip);
#line 2850 "CollectionPage.c"
	}
#line 303 "../src/Views/CollectionPage.vala"
	_tmp4_ = action;
#line 303 "../src/Views/CollectionPage.vala"
	gtk_action_set_sensitive (_tmp4_, sensitive);
#line 292 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (action);
#line 2858 "CollectionPage.c"
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
#line 5825 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5826 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 5826 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 5826 "glib-2.0.vapi"
	res_length1 = -1;
#line 5826 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 5827 "glib-2.0.vapi"
	res_length1 = (gint) self->len;
#line 5828 "glib-2.0.vapi"
	_tmp1_ = res;
#line 5828 "glib-2.0.vapi"
	_tmp1__length1 = res_length1;
#line 5828 "glib-2.0.vapi"
	if (result_length1) {
#line 5828 "glib-2.0.vapi"
		*result_length1 = _tmp1__length1;
#line 2892 "CollectionPage.c"
	}
#line 5828 "glib-2.0.vapi"
	result = _tmp1_;
#line 5828 "glib-2.0.vapi"
	return result;
#line 2898 "CollectionPage.c"
}

static void
_vala_array_add128 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 330 "../src/Views/CollectionPage.vala"
	if ((*length) == (*size)) {
#line 330 "../src/Views/CollectionPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 330 "../src/Views/CollectionPage.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2913 "CollectionPage.c"
	}
#line 330 "../src/Views/CollectionPage.vala"
	(*array)[(*length)++] = value;
#line 330 "../src/Views/CollectionPage.vala"
	(*array)[*length] = NULL;
#line 2919 "CollectionPage.c"
}

void
collection_page_get_image_data_for_clipboard (GtkClipboard* cb,
                                              GtkSelectionData* sd,
                                              guint info,
                                              void* parent)
{
	GList* _tmp0_;
#line 307 "../src/Views/CollectionPage.vala"
	g_return_if_fail (cb != NULL);
#line 307 "../src/Views/CollectionPage.vala"
	g_return_if_fail (sd != NULL);
#line 311 "../src/Views/CollectionPage.vala"
	_tmp0_ = collection_page_copied_photos;
#line 311 "../src/Views/CollectionPage.vala"
	if (_tmp0_ == NULL) {
#line 312 "../src/Views/CollectionPage.vala"
		g_critical ("CollectionPage.vala:312: Attempt to copy image but data for clipboard " \
"is null");
#line 313 "../src/Views/CollectionPage.vala"
		return;
#line 2941 "CollectionPage.c"
	}
#line 316 "../src/Views/CollectionPage.vala"
	switch (info) {
#line 316 "../src/Views/CollectionPage.vala"
		case COLLECTION_PAGE_TARGET_TYPE_GNOME_COPIED_FILES:
#line 2947 "CollectionPage.c"
		{
			GString* sb = NULL;
			GString* _tmp1_;
			GList* _tmp2_;
			GString* _tmp11_;
			guint8* _tmp12_;
			gint _tmp12__length1;
			gint _tmp13_ = 0;
			guint8* _tmp14_;
			gint _tmp14__length1;
#line 318 "../src/Views/CollectionPage.vala"
			_tmp1_ = g_string_new ("copy ");
#line 318 "../src/Views/CollectionPage.vala"
			sb = _tmp1_;
#line 320 "../src/Views/CollectionPage.vala"
			_tmp2_ = collection_page_copied_photos;
#line 2964 "CollectionPage.c"
			{
				GList* photo_collection = NULL;
				GList* photo_it = NULL;
#line 320 "../src/Views/CollectionPage.vala"
				photo_collection = _tmp2_;
#line 320 "../src/Views/CollectionPage.vala"
				for (photo_it = photo_collection; photo_it != NULL; photo_it = photo_it->next) {
#line 2972 "CollectionPage.c"
					Photo* _tmp3_;
					Photo* photo = NULL;
#line 320 "../src/Views/CollectionPage.vala"
					_tmp3_ = _g_object_ref0 ((Photo*) photo_it->data);
#line 320 "../src/Views/CollectionPage.vala"
					photo = _tmp3_;
#line 2979 "CollectionPage.c"
					{
						GString* _tmp4_;
						GString* _tmp5_;
						Photo* _tmp6_;
						GFile* _tmp7_;
						GFile* _tmp8_;
						gchar* _tmp9_;
						gchar* _tmp10_;
#line 321 "../src/Views/CollectionPage.vala"
						_tmp4_ = sb;
#line 321 "../src/Views/CollectionPage.vala"
						g_string_append (_tmp4_, "\r\n");
#line 322 "../src/Views/CollectionPage.vala"
						_tmp5_ = sb;
#line 322 "../src/Views/CollectionPage.vala"
						_tmp6_ = photo;
#line 322 "../src/Views/CollectionPage.vala"
						_tmp7_ = media_source_get_file ((MediaSource*) _tmp6_);
#line 322 "../src/Views/CollectionPage.vala"
						_tmp8_ = _tmp7_;
#line 322 "../src/Views/CollectionPage.vala"
						_tmp9_ = g_file_get_uri (_tmp8_);
#line 322 "../src/Views/CollectionPage.vala"
						_tmp10_ = _tmp9_;
#line 322 "../src/Views/CollectionPage.vala"
						g_string_append (_tmp5_, _tmp10_);
#line 322 "../src/Views/CollectionPage.vala"
						_g_free0 (_tmp10_);
#line 322 "../src/Views/CollectionPage.vala"
						_g_object_unref0 (_tmp8_);
#line 320 "../src/Views/CollectionPage.vala"
						_g_object_unref0 (photo);
#line 3012 "CollectionPage.c"
					}
				}
			}
#line 324 "../src/Views/CollectionPage.vala"
			_tmp11_ = sb;
#line 324 "../src/Views/CollectionPage.vala"
			_tmp12_ = g_string_get_data (_tmp11_, &_tmp13_);
#line 324 "../src/Views/CollectionPage.vala"
			_tmp12__length1 = _tmp13_;
#line 324 "../src/Views/CollectionPage.vala"
			_tmp14_ = _tmp12_;
#line 324 "../src/Views/CollectionPage.vala"
			_tmp14__length1 = _tmp12__length1;
#line 324 "../src/Views/CollectionPage.vala"
			gtk_selection_data_set (sd, gtk_selection_data_get_target (sd), 8, _tmp14_, (gint) _tmp14__length1);
#line 325 "../src/Views/CollectionPage.vala"
			_g_string_free0 (sb);
#line 325 "../src/Views/CollectionPage.vala"
			break;
#line 3032 "CollectionPage.c"
		}
#line 316 "../src/Views/CollectionPage.vala"
		case COLLECTION_PAGE_TARGET_TYPE_TEXT_URI_LIST:
#line 3036 "CollectionPage.c"
		{
			gchar** uris = NULL;
			gchar** _tmp15_;
			gint uris_length1;
			gint _uris_size_;
			GList* _tmp16_;
			gchar** _tmp22_;
			gint _tmp22__length1;
#line 328 "../src/Views/CollectionPage.vala"
			_tmp15_ = g_new0 (gchar*, 0 + 1);
#line 328 "../src/Views/CollectionPage.vala"
			uris = _tmp15_;
#line 328 "../src/Views/CollectionPage.vala"
			uris_length1 = 0;
#line 328 "../src/Views/CollectionPage.vala"
			_uris_size_ = uris_length1;
#line 329 "../src/Views/CollectionPage.vala"
			_tmp16_ = collection_page_copied_photos;
#line 3055 "CollectionPage.c"
			{
				GList* photo_collection = NULL;
				GList* photo_it = NULL;
#line 329 "../src/Views/CollectionPage.vala"
				photo_collection = _tmp16_;
#line 329 "../src/Views/CollectionPage.vala"
				for (photo_it = photo_collection; photo_it != NULL; photo_it = photo_it->next) {
#line 3063 "CollectionPage.c"
					Photo* _tmp17_;
					Photo* photo = NULL;
#line 329 "../src/Views/CollectionPage.vala"
					_tmp17_ = _g_object_ref0 ((Photo*) photo_it->data);
#line 329 "../src/Views/CollectionPage.vala"
					photo = _tmp17_;
#line 3070 "CollectionPage.c"
					{
						Photo* _tmp18_;
						GFile* _tmp19_;
						GFile* _tmp20_;
						gchar* _tmp21_;
#line 330 "../src/Views/CollectionPage.vala"
						_tmp18_ = photo;
#line 330 "../src/Views/CollectionPage.vala"
						_tmp19_ = media_source_get_file ((MediaSource*) _tmp18_);
#line 330 "../src/Views/CollectionPage.vala"
						_tmp20_ = _tmp19_;
#line 330 "../src/Views/CollectionPage.vala"
						_tmp21_ = g_file_get_uri (_tmp20_);
#line 330 "../src/Views/CollectionPage.vala"
						_vala_array_add128 (&uris, &uris_length1, &_uris_size_, _tmp21_);
#line 330 "../src/Views/CollectionPage.vala"
						_g_object_unref0 (_tmp20_);
#line 329 "../src/Views/CollectionPage.vala"
						_g_object_unref0 (photo);
#line 3090 "CollectionPage.c"
					}
				}
			}
#line 333 "../src/Views/CollectionPage.vala"
			_tmp22_ = uris;
#line 333 "../src/Views/CollectionPage.vala"
			_tmp22__length1 = uris_length1;
#line 333 "../src/Views/CollectionPage.vala"
			gtk_selection_data_set_uris (sd, _tmp22_);
#line 334 "../src/Views/CollectionPage.vala"
			uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 334 "../src/Views/CollectionPage.vala"
			break;
#line 3104 "CollectionPage.c"
		}
		default:
		{
#line 337 "../src/Views/CollectionPage.vala"
			g_warning ("CollectionPage.vala:337: Unknown target type");
#line 338 "../src/Views/CollectionPage.vala"
			break;
#line 3112 "CollectionPage.c"
		}
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 343 "../src/Views/CollectionPage.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3122 "CollectionPage.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 343 "../src/Views/CollectionPage.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 3130 "CollectionPage.c"
}

void
collection_page_clear_data_for_clipboard (GtkClipboard* cb,
                                          void* parent)
{
#line 342 "../src/Views/CollectionPage.vala"
	g_return_if_fail (cb != NULL);
#line 343 "../src/Views/CollectionPage.vala"
	(collection_page_copied_photos == NULL) ? NULL : (collection_page_copied_photos = (_g_list_free__g_object_unref0_ (collection_page_copied_photos), NULL));
#line 343 "../src/Views/CollectionPage.vala"
	collection_page_copied_photos = NULL;
#line 3143 "CollectionPage.c"
}

static void
_collection_page_get_image_data_for_clipboard_gtk_clipboard_get_func (GtkClipboard* clipboard,
                                                                      GtkSelectionData* selection_data,
                                                                      guint info,
                                                                      void* user_data_or_owner)
{
#line 360 "../src/Views/CollectionPage.vala"
	collection_page_get_image_data_for_clipboard (clipboard, selection_data, info, user_data_or_owner);
#line 3154 "CollectionPage.c"
}

static void
_collection_page_clear_data_for_clipboard_gtk_clipboard_clear_func (GtkClipboard* clipboard,
                                                                    void* user_data_or_owner)
{
#line 360 "../src/Views/CollectionPage.vala"
	collection_page_clear_data_for_clipboard (clipboard, user_data_or_owner);
#line 3163 "CollectionPage.c"
}

static void
collection_page_on_copy_images (CollectionPage* self)
{
	GtkClipboard* _tmp0_;
	GList* _tmp17_;
	GtkClipboard* _tmp18_;
#line 346 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/Views/CollectionPage.vala"
	_tmp0_ = collection_page_clipboard;
#line 347 "../src/Views/CollectionPage.vala"
	gtk_clipboard_clear (_tmp0_);
#line 3178 "CollectionPage.c"
	{
		GeeList* _source_list = NULL;
		ViewCollection* _tmp1_;
		ViewCollection* _tmp2_;
		GeeList* _tmp3_;
		GeeList* _tmp4_;
		gint _source_size = 0;
		GeeList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _source_index = 0;
#line 349 "../src/Views/CollectionPage.vala"
		_tmp1_ = page_get_view ((Page*) self);
#line 349 "../src/Views/CollectionPage.vala"
		_tmp2_ = _tmp1_;
#line 349 "../src/Views/CollectionPage.vala"
		_tmp3_ = view_collection_get_selected_sources (_tmp2_);
#line 349 "../src/Views/CollectionPage.vala"
		_tmp4_ = _tmp3_;
#line 349 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp2_);
#line 349 "../src/Views/CollectionPage.vala"
		_source_list = _tmp4_;
#line 349 "../src/Views/CollectionPage.vala"
		_tmp5_ = _source_list;
#line 349 "../src/Views/CollectionPage.vala"
		_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 349 "../src/Views/CollectionPage.vala"
		_tmp7_ = _tmp6_;
#line 349 "../src/Views/CollectionPage.vala"
		_source_size = _tmp7_;
#line 349 "../src/Views/CollectionPage.vala"
		_source_index = -1;
#line 349 "../src/Views/CollectionPage.vala"
		while (TRUE) {
#line 3214 "CollectionPage.c"
			gint _tmp8_;
			gint _tmp9_;
			DataSource* source = NULL;
			GeeList* _tmp10_;
			gpointer _tmp11_;
			Photo* photo = NULL;
			DataSource* _tmp12_;
			Photo* _tmp13_;
			Photo* _tmp14_;
#line 349 "../src/Views/CollectionPage.vala"
			_source_index = _source_index + 1;
#line 349 "../src/Views/CollectionPage.vala"
			_tmp8_ = _source_index;
#line 349 "../src/Views/CollectionPage.vala"
			_tmp9_ = _source_size;
#line 349 "../src/Views/CollectionPage.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 349 "../src/Views/CollectionPage.vala"
				break;
#line 3234 "CollectionPage.c"
			}
#line 349 "../src/Views/CollectionPage.vala"
			_tmp10_ = _source_list;
#line 349 "../src/Views/CollectionPage.vala"
			_tmp11_ = gee_list_get (_tmp10_, _source_index);
#line 349 "../src/Views/CollectionPage.vala"
			source = (DataSource*) _tmp11_;
#line 350 "../src/Views/CollectionPage.vala"
			_tmp12_ = source;
#line 350 "../src/Views/CollectionPage.vala"
			_tmp13_ = _g_object_ref0 (IS_PHOTO (_tmp12_) ? ((Photo*) _tmp12_) : NULL);
#line 350 "../src/Views/CollectionPage.vala"
			photo = _tmp13_;
#line 351 "../src/Views/CollectionPage.vala"
			_tmp14_ = photo;
#line 351 "../src/Views/CollectionPage.vala"
			if (_tmp14_ != NULL) {
#line 3252 "CollectionPage.c"
				Photo* _tmp15_;
				Photo* _tmp16_;
#line 352 "../src/Views/CollectionPage.vala"
				_tmp15_ = photo;
#line 352 "../src/Views/CollectionPage.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 352 "../src/Views/CollectionPage.vala"
				collection_page_copied_photos = g_list_append (collection_page_copied_photos, _tmp16_);
#line 3261 "CollectionPage.c"
			}
#line 349 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (photo);
#line 349 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (source);
#line 3267 "CollectionPage.c"
		}
#line 349 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_source_list);
#line 3271 "CollectionPage.c"
	}
#line 356 "../src/Views/CollectionPage.vala"
	_tmp17_ = collection_page_copied_photos;
#line 356 "../src/Views/CollectionPage.vala"
	if (_tmp17_ == NULL) {
#line 357 "../src/Views/CollectionPage.vala"
		return;
#line 3279 "CollectionPage.c"
	}
#line 360 "../src/Views/CollectionPage.vala"
	_tmp18_ = collection_page_clipboard;
#line 360 "../src/Views/CollectionPage.vala"
	gtk_clipboard_set_with_owner (_tmp18_, COLLECTION_PAGE_COPY_TARGETS, (guint) G_N_ELEMENTS (COLLECTION_PAGE_COPY_TARGETS), _collection_page_get_image_data_for_clipboard_gtk_clipboard_get_func, _collection_page_clear_data_for_clipboard_gtk_clipboard_clear_func, (GObject*) self);
#line 3285 "CollectionPage.c"
}

static gboolean
collection_page_selection_has_video (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 363 "../src/Views/CollectionPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 364 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 364 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 364 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_sources (_tmp1_);
#line 364 "../src/Views/CollectionPage.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 364 "../src/Views/CollectionPage.vala"
	_tmp4_ = media_source_collection_has_video (_tmp3_);
#line 364 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp3_);
#line 364 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 364 "../src/Views/CollectionPage.vala"
	result = _tmp4_;
#line 364 "../src/Views/CollectionPage.vala"
	return result;
#line 3317 "CollectionPage.c"
}

static gboolean
collection_page_page_has_photo (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 367 "../src/Views/CollectionPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 368 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 368 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 368 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_sources (_tmp1_);
#line 368 "../src/Views/CollectionPage.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 368 "../src/Views/CollectionPage.vala"
	_tmp4_ = media_source_collection_has_photo (_tmp3_);
#line 368 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp3_);
#line 368 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 368 "../src/Views/CollectionPage.vala"
	result = _tmp4_;
#line 368 "../src/Views/CollectionPage.vala"
	return result;
#line 3349 "CollectionPage.c"
}

static gboolean
collection_page_selection_has_photo (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 371 "../src/Views/CollectionPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 372 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 372 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 372 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_sources (_tmp1_);
#line 372 "../src/Views/CollectionPage.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 372 "../src/Views/CollectionPage.vala"
	_tmp4_ = media_source_collection_has_photo (_tmp3_);
#line 372 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp3_);
#line 372 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 372 "../src/Views/CollectionPage.vala"
	result = _tmp4_;
#line 372 "../src/Views/CollectionPage.vala"
	return result;
#line 3381 "CollectionPage.c"
}

static void
collection_page_real_init_actions (Page* base,
                                   gint selected_count,
                                   gint count)
{
	CollectionPage * self;
#line 375 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 376 "../src/Views/CollectionPage.vala"
	PAGE_CLASS (collection_page_parent_class)->init_actions ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_PAGE, MediaPage), selected_count, count);
#line 3394 "CollectionPage.c"
}

static void
collection_page_real_update_actions (Page* base,
                                     gint selected_count,
                                     gint count)
{
	CollectionPage * self;
	gboolean one_selected = FALSE;
	gboolean has_selected = FALSE;
	gboolean primary_is_video = FALSE;
	gboolean selection_has_videos = FALSE;
	gboolean page_has_photos = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	GtkToggleButton* _tmp34_;
#line 379 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 380 "../src/Views/CollectionPage.vala"
	PAGE_CLASS (collection_page_parent_class)->update_actions ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_PAGE, MediaPage), selected_count, count);
#line 382 "../src/Views/CollectionPage.vala"
	one_selected = selected_count == 1;
#line 383 "../src/Views/CollectionPage.vala"
	has_selected = selected_count > 0;
#line 385 "../src/Views/CollectionPage.vala"
	primary_is_video = FALSE;
#line 386 "../src/Views/CollectionPage.vala"
	if (has_selected) {
#line 3436 "CollectionPage.c"
		ViewCollection* _tmp0_;
		ViewCollection* _tmp1_;
		DataView* _tmp2_;
		DataView* _tmp3_;
		DataSource* _tmp4_;
		DataSource* _tmp5_;
		gboolean _tmp6_;
#line 387 "../src/Views/CollectionPage.vala"
		_tmp0_ = page_get_view ((Page*) self);
#line 387 "../src/Views/CollectionPage.vala"
		_tmp1_ = _tmp0_;
#line 387 "../src/Views/CollectionPage.vala"
		_tmp2_ = view_collection_get_selected_at (_tmp1_, 0);
#line 387 "../src/Views/CollectionPage.vala"
		_tmp3_ = _tmp2_;
#line 387 "../src/Views/CollectionPage.vala"
		_tmp4_ = data_view_get_source (_tmp3_);
#line 387 "../src/Views/CollectionPage.vala"
		_tmp5_ = _tmp4_;
#line 387 "../src/Views/CollectionPage.vala"
		_tmp6_ = IS_VIDEO (_tmp5_);
#line 387 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp3_);
#line 387 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp1_);
#line 387 "../src/Views/CollectionPage.vala"
		if (_tmp6_) {
#line 388 "../src/Views/CollectionPage.vala"
			primary_is_video = TRUE;
#line 3466 "CollectionPage.c"
		}
	}
#line 390 "../src/Views/CollectionPage.vala"
	selection_has_videos = collection_page_selection_has_video (self);
#line 391 "../src/Views/CollectionPage.vala"
	page_has_photos = collection_page_page_has_photo (self);
#line 395 "../src/Views/CollectionPage.vala"
	if (has_selected) {
#line 395 "../src/Views/CollectionPage.vala"
		_tmp7_ = !selection_has_videos;
#line 3477 "CollectionPage.c"
	} else {
#line 395 "../src/Views/CollectionPage.vala"
		_tmp7_ = FALSE;
#line 3481 "CollectionPage.c"
	}
#line 395 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "Duplicate", _tmp7_);
#line 396 "../src/Views/CollectionPage.vala"
	page_set_action_visible ((Page*) self, "OpenWith", !primary_is_video);
#line 397 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "OpenWith", one_selected);
#line 399 "../src/Views/CollectionPage.vala"
	if (one_selected) {
#line 399 "../src/Views/CollectionPage.vala"
		_tmp9_ = !primary_is_video;
#line 3493 "CollectionPage.c"
	} else {
#line 399 "../src/Views/CollectionPage.vala"
		_tmp9_ = FALSE;
#line 3497 "CollectionPage.c"
	}
#line 399 "../src/Views/CollectionPage.vala"
	if (_tmp9_) {
#line 3501 "CollectionPage.c"
		ViewCollection* _tmp10_;
		ViewCollection* _tmp11_;
		DataView* _tmp12_;
		DataView* _tmp13_;
		DataSource* _tmp14_;
		DataSource* _tmp15_;
#line 400 "../src/Views/CollectionPage.vala"
		_tmp10_ = page_get_view ((Page*) self);
#line 400 "../src/Views/CollectionPage.vala"
		_tmp11_ = _tmp10_;
#line 400 "../src/Views/CollectionPage.vala"
		_tmp12_ = view_collection_get_selected_at (_tmp11_, 0);
#line 400 "../src/Views/CollectionPage.vala"
		_tmp13_ = _tmp12_;
#line 400 "../src/Views/CollectionPage.vala"
		_tmp14_ = data_view_get_source (_tmp13_);
#line 400 "../src/Views/CollectionPage.vala"
		_tmp15_ = _tmp14_;
#line 400 "../src/Views/CollectionPage.vala"
		_tmp8_ = photo_get_master_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO, Photo)) == PHOTO_FILE_FORMAT_RAW;
#line 400 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp13_);
#line 400 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp11_);
#line 3526 "CollectionPage.c"
	} else {
#line 399 "../src/Views/CollectionPage.vala"
		_tmp8_ = FALSE;
#line 3530 "CollectionPage.c"
	}
#line 398 "../src/Views/CollectionPage.vala"
	page_set_action_visible ((Page*) self, "OpenWithRaw", _tmp8_);
#line 402 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 402 "../src/Views/CollectionPage.vala"
		_tmp16_ = collection_page_can_revert_selected (self);
#line 3538 "CollectionPage.c"
	} else {
#line 402 "../src/Views/CollectionPage.vala"
		_tmp16_ = FALSE;
#line 3542 "CollectionPage.c"
	}
#line 402 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "Revert", _tmp16_);
#line 403 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 403 "../src/Views/CollectionPage.vala"
		_tmp17_ = has_selected;
#line 3550 "CollectionPage.c"
	} else {
#line 403 "../src/Views/CollectionPage.vala"
		_tmp17_ = FALSE;
#line 3554 "CollectionPage.c"
	}
#line 403 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "Enhance", _tmp17_);
#line 404 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 404 "../src/Views/CollectionPage.vala"
		_tmp19_ = one_selected;
#line 3562 "CollectionPage.c"
	} else {
#line 404 "../src/Views/CollectionPage.vala"
		_tmp19_ = FALSE;
#line 3566 "CollectionPage.c"
	}
#line 404 "../src/Views/CollectionPage.vala"
	if (_tmp19_) {
#line 3570 "CollectionPage.c"
		ViewCollection* _tmp20_;
		ViewCollection* _tmp21_;
		DataView* _tmp22_;
		DataView* _tmp23_;
		DataSource* _tmp24_;
		DataSource* _tmp25_;
#line 405 "../src/Views/CollectionPage.vala"
		_tmp20_ = page_get_view ((Page*) self);
#line 405 "../src/Views/CollectionPage.vala"
		_tmp21_ = _tmp20_;
#line 405 "../src/Views/CollectionPage.vala"
		_tmp22_ = view_collection_get_selected_at (_tmp21_, 0);
#line 405 "../src/Views/CollectionPage.vala"
		_tmp23_ = _tmp22_;
#line 405 "../src/Views/CollectionPage.vala"
		_tmp24_ = data_view_get_source (_tmp23_);
#line 405 "../src/Views/CollectionPage.vala"
		_tmp25_ = _tmp24_;
#line 405 "../src/Views/CollectionPage.vala"
		_tmp18_ = photo_has_color_adjustments (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO, Photo));
#line 405 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp23_);
#line 405 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp21_);
#line 3595 "CollectionPage.c"
	} else {
#line 404 "../src/Views/CollectionPage.vala"
		_tmp18_ = FALSE;
#line 3599 "CollectionPage.c"
	}
#line 404 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "CopyColorAdjustments", _tmp18_);
#line 406 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 406 "../src/Views/CollectionPage.vala"
		_tmp27_ = has_selected;
#line 3607 "CollectionPage.c"
	} else {
#line 406 "../src/Views/CollectionPage.vala"
		_tmp27_ = FALSE;
#line 3611 "CollectionPage.c"
	}
#line 406 "../src/Views/CollectionPage.vala"
	if (_tmp27_) {
#line 407 "../src/Views/CollectionPage.vala"
		_tmp26_ = pixel_transformation_bundle_has_copied_color_adjustments ();
#line 3617 "CollectionPage.c"
	} else {
#line 406 "../src/Views/CollectionPage.vala"
		_tmp26_ = FALSE;
#line 3621 "CollectionPage.c"
	}
#line 406 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "PasteColorAdjustments", _tmp26_);
#line 408 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 408 "../src/Views/CollectionPage.vala"
		_tmp28_ = has_selected;
#line 3629 "CollectionPage.c"
	} else {
#line 408 "../src/Views/CollectionPage.vala"
		_tmp28_ = FALSE;
#line 3633 "CollectionPage.c"
	}
#line 408 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "RotateClockwise", _tmp28_);
#line 409 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 409 "../src/Views/CollectionPage.vala"
		_tmp29_ = has_selected;
#line 3641 "CollectionPage.c"
	} else {
#line 409 "../src/Views/CollectionPage.vala"
		_tmp29_ = FALSE;
#line 3645 "CollectionPage.c"
	}
#line 409 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "RotateCounterclockwise", _tmp29_);
#line 410 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 410 "../src/Views/CollectionPage.vala"
		_tmp30_ = has_selected;
#line 3653 "CollectionPage.c"
	} else {
#line 410 "../src/Views/CollectionPage.vala"
		_tmp30_ = FALSE;
#line 3657 "CollectionPage.c"
	}
#line 410 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "FlipHorizontally", _tmp30_);
#line 411 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 411 "../src/Views/CollectionPage.vala"
		_tmp31_ = has_selected;
#line 3665 "CollectionPage.c"
	} else {
#line 411 "../src/Views/CollectionPage.vala"
		_tmp31_ = FALSE;
#line 3669 "CollectionPage.c"
	}
#line 411 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "FlipVertically", _tmp31_);
#line 415 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "AdjustDateTime", has_selected);
#line 417 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "NewEvent", has_selected);
#line 418 "../src/Views/CollectionPage.vala"
	if (page_has_photos) {
#line 418 "../src/Views/CollectionPage.vala"
		_tmp32_ = !primary_is_video;
#line 3681 "CollectionPage.c"
	} else {
#line 418 "../src/Views/CollectionPage.vala"
		_tmp32_ = FALSE;
#line 3685 "CollectionPage.c"
	}
#line 418 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "Slideshow", _tmp32_);
#line 419 "../src/Views/CollectionPage.vala"
	if (!selection_has_videos) {
#line 419 "../src/Views/CollectionPage.vala"
		_tmp33_ = has_selected;
#line 3693 "CollectionPage.c"
	} else {
#line 419 "../src/Views/CollectionPage.vala"
		_tmp33_ = FALSE;
#line 3697 "CollectionPage.c"
	}
#line 419 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "Print", _tmp33_);
#line 420 "../src/Views/CollectionPage.vala"
	_tmp34_ = self->priv->enhance_button;
#line 420 "../src/Views/CollectionPage.vala"
	if (_tmp34_ != NULL) {
#line 3705 "CollectionPage.c"
		gboolean _tmp35_ = FALSE;
		GtkToggleButton* _tmp36_;
#line 421 "../src/Views/CollectionPage.vala"
		if (!selection_has_videos) {
#line 421 "../src/Views/CollectionPage.vala"
			_tmp35_ = has_selected;
#line 3712 "CollectionPage.c"
		} else {
#line 421 "../src/Views/CollectionPage.vala"
			_tmp35_ = FALSE;
#line 3716 "CollectionPage.c"
		}
#line 421 "../src/Views/CollectionPage.vala"
		_tmp36_ = self->priv->enhance_button;
#line 421 "../src/Views/CollectionPage.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp36_, _tmp35_);
#line 422 "../src/Views/CollectionPage.vala"
		collection_page_update_enhance_toggled (self);
#line 3724 "CollectionPage.c"
	}
}

static void
collection_page_on_photos_altered (CollectionPage* self,
                                   GeeMap* altered)
{
#line 426 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/Views/CollectionPage.vala"
	g_return_if_fail (altered != NULL);
#line 3736 "CollectionPage.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 429 "../src/Views/CollectionPage.vala"
		_tmp0_ = gee_map_get_keys (altered);
#line 429 "../src/Views/CollectionPage.vala"
		_tmp1_ = _tmp0_;
#line 429 "../src/Views/CollectionPage.vala"
		_tmp2_ = _tmp1_;
#line 429 "../src/Views/CollectionPage.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 429 "../src/Views/CollectionPage.vala"
		_tmp4_ = _tmp3_;
#line 429 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp2_);
#line 429 "../src/Views/CollectionPage.vala"
		_object_it = _tmp4_;
#line 429 "../src/Views/CollectionPage.vala"
		while (TRUE) {
#line 3760 "CollectionPage.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataView* view = NULL;
			DataObject* _tmp8_;
			DataView* _tmp9_;
			gboolean _tmp10_ = FALSE;
			DataView* _tmp11_;
			LibraryPhoto* photo = NULL;
			DataView* _tmp15_;
			DataSource* _tmp16_;
			DataSource* _tmp17_;
			LibraryPhoto* _tmp18_;
			LibraryPhoto* _tmp19_;
			LibraryPhoto* _tmp20_;
#line 429 "../src/Views/CollectionPage.vala"
			_tmp5_ = _object_it;
#line 429 "../src/Views/CollectionPage.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 429 "../src/Views/CollectionPage.vala"
				break;
#line 3783 "CollectionPage.c"
			}
#line 429 "../src/Views/CollectionPage.vala"
			_tmp6_ = _object_it;
#line 429 "../src/Views/CollectionPage.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 429 "../src/Views/CollectionPage.vala"
			object = (DataObject*) _tmp7_;
#line 430 "../src/Views/CollectionPage.vala"
			_tmp8_ = object;
#line 430 "../src/Views/CollectionPage.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView));
#line 430 "../src/Views/CollectionPage.vala"
			view = _tmp9_;
#line 432 "../src/Views/CollectionPage.vala"
			_tmp11_ = view;
#line 432 "../src/Views/CollectionPage.vala"
			if (!data_view_is_selected (_tmp11_)) {
#line 432 "../src/Views/CollectionPage.vala"
				_tmp10_ = TRUE;
#line 3803 "CollectionPage.c"
			} else {
				DataView* _tmp12_;
				gpointer _tmp13_;
				Alteration* _tmp14_;
#line 432 "../src/Views/CollectionPage.vala"
				_tmp12_ = view;
#line 432 "../src/Views/CollectionPage.vala"
				_tmp13_ = gee_map_get (altered, (DataObject*) _tmp12_);
#line 432 "../src/Views/CollectionPage.vala"
				_tmp14_ = (Alteration*) _tmp13_;
#line 432 "../src/Views/CollectionPage.vala"
				_tmp10_ = !alteration_has_subject (_tmp14_, "image");
#line 432 "../src/Views/CollectionPage.vala"
				_alteration_unref0 (_tmp14_);
#line 3818 "CollectionPage.c"
			}
#line 432 "../src/Views/CollectionPage.vala"
			if (_tmp10_) {
#line 433 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (view);
#line 433 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (object);
#line 433 "../src/Views/CollectionPage.vala"
				continue;
#line 3828 "CollectionPage.c"
			}
#line 435 "../src/Views/CollectionPage.vala"
			_tmp15_ = view;
#line 435 "../src/Views/CollectionPage.vala"
			_tmp16_ = data_view_get_source (_tmp15_);
#line 435 "../src/Views/CollectionPage.vala"
			_tmp17_ = _tmp16_;
#line 435 "../src/Views/CollectionPage.vala"
			_tmp18_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp17_) ? ((LibraryPhoto*) _tmp17_) : NULL);
#line 435 "../src/Views/CollectionPage.vala"
			photo = _tmp18_;
#line 436 "../src/Views/CollectionPage.vala"
			_tmp19_ = photo;
#line 436 "../src/Views/CollectionPage.vala"
			if (_tmp19_ == NULL) {
#line 437 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (photo);
#line 437 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (view);
#line 437 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (object);
#line 437 "../src/Views/CollectionPage.vala"
				continue;
#line 3852 "CollectionPage.c"
			}
#line 441 "../src/Views/CollectionPage.vala"
			page_set_action_sensitive ((Page*) self, "Revert", collection_page_can_revert_selected (self));
#line 442 "../src/Views/CollectionPage.vala"
			_tmp20_ = photo;
#line 442 "../src/Views/CollectionPage.vala"
			page_set_action_sensitive ((Page*) self, "CopyColorAdjustments", photo_has_color_adjustments ((Photo*) _tmp20_));
#line 443 "../src/Views/CollectionPage.vala"
			collection_page_update_enhance_toggled (self);
#line 444 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (photo);
#line 444 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (view);
#line 444 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (object);
#line 444 "../src/Views/CollectionPage.vala"
			break;
#line 3870 "CollectionPage.c"
		}
#line 429 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_object_it);
#line 3874 "CollectionPage.c"
	}
}

static void
collection_page_update_enhance_toggled (CollectionPage* self)
{
	gboolean toggled = FALSE;
	GtkToggleButton* _tmp19_;
	guint _tmp20_;
	GtkToggleButton* _tmp21_;
	GtkToggleButton* _tmp22_;
	GtkAction* action = NULL;
	GtkAction* _tmp23_;
	GtkAction* _tmp24_;
	const gchar* _tmp25_ = NULL;
	GtkAction* _tmp26_;
#line 448 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/Views/CollectionPage.vala"
	toggled = FALSE;
#line 3895 "CollectionPage.c"
	{
		GeeList* _view_list = NULL;
		ViewCollection* _tmp0_;
		ViewCollection* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _view_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _view_index = 0;
#line 450 "../src/Views/CollectionPage.vala"
		_tmp0_ = page_get_view ((Page*) self);
#line 450 "../src/Views/CollectionPage.vala"
		_tmp1_ = _tmp0_;
#line 450 "../src/Views/CollectionPage.vala"
		_tmp2_ = view_collection_get_selected (_tmp1_);
#line 450 "../src/Views/CollectionPage.vala"
		_tmp3_ = _tmp2_;
#line 450 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp1_);
#line 450 "../src/Views/CollectionPage.vala"
		_view_list = _tmp3_;
#line 450 "../src/Views/CollectionPage.vala"
		_tmp4_ = _view_list;
#line 450 "../src/Views/CollectionPage.vala"
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 450 "../src/Views/CollectionPage.vala"
		_tmp6_ = _tmp5_;
#line 450 "../src/Views/CollectionPage.vala"
		_view_size = _tmp6_;
#line 450 "../src/Views/CollectionPage.vala"
		_view_index = -1;
#line 450 "../src/Views/CollectionPage.vala"
		while (TRUE) {
#line 3931 "CollectionPage.c"
			gint _tmp7_;
			gint _tmp8_;
			DataView* view = NULL;
			GeeList* _tmp9_;
			gpointer _tmp10_;
			Photo* photo = NULL;
			DataView* _tmp11_;
			DataSource* _tmp12_;
			DataSource* _tmp13_;
			Photo* _tmp14_;
			gboolean _tmp15_ = FALSE;
			Photo* _tmp16_;
#line 450 "../src/Views/CollectionPage.vala"
			_view_index = _view_index + 1;
#line 450 "../src/Views/CollectionPage.vala"
			_tmp7_ = _view_index;
#line 450 "../src/Views/CollectionPage.vala"
			_tmp8_ = _view_size;
#line 450 "../src/Views/CollectionPage.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 450 "../src/Views/CollectionPage.vala"
				break;
#line 3954 "CollectionPage.c"
			}
#line 450 "../src/Views/CollectionPage.vala"
			_tmp9_ = _view_list;
#line 450 "../src/Views/CollectionPage.vala"
			_tmp10_ = gee_list_get (_tmp9_, _view_index);
#line 450 "../src/Views/CollectionPage.vala"
			view = (DataView*) _tmp10_;
#line 451 "../src/Views/CollectionPage.vala"
			_tmp11_ = view;
#line 451 "../src/Views/CollectionPage.vala"
			_tmp12_ = data_view_get_source (_tmp11_);
#line 451 "../src/Views/CollectionPage.vala"
			_tmp13_ = _tmp12_;
#line 451 "../src/Views/CollectionPage.vala"
			_tmp14_ = _g_object_ref0 (IS_PHOTO (_tmp13_) ? ((Photo*) _tmp13_) : NULL);
#line 451 "../src/Views/CollectionPage.vala"
			photo = _tmp14_;
#line 452 "../src/Views/CollectionPage.vala"
			_tmp16_ = photo;
#line 452 "../src/Views/CollectionPage.vala"
			if (_tmp16_ != NULL) {
#line 3976 "CollectionPage.c"
				Photo* _tmp17_;
#line 452 "../src/Views/CollectionPage.vala"
				_tmp17_ = photo;
#line 452 "../src/Views/CollectionPage.vala"
				_tmp15_ = !photo_is_enhanced (_tmp17_);
#line 3982 "CollectionPage.c"
			} else {
#line 452 "../src/Views/CollectionPage.vala"
				_tmp15_ = FALSE;
#line 3986 "CollectionPage.c"
			}
#line 452 "../src/Views/CollectionPage.vala"
			if (_tmp15_) {
#line 453 "../src/Views/CollectionPage.vala"
				toggled = FALSE;
#line 454 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (photo);
#line 454 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (view);
#line 454 "../src/Views/CollectionPage.vala"
				break;
#line 3998 "CollectionPage.c"
			} else {
				Photo* _tmp18_;
#line 456 "../src/Views/CollectionPage.vala"
				_tmp18_ = photo;
#line 456 "../src/Views/CollectionPage.vala"
				if (_tmp18_ != NULL) {
#line 457 "../src/Views/CollectionPage.vala"
					toggled = TRUE;
#line 4007 "CollectionPage.c"
				}
			}
#line 450 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (photo);
#line 450 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (view);
#line 4014 "CollectionPage.c"
		}
#line 450 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_view_list);
#line 4018 "CollectionPage.c"
	}
#line 460 "../src/Views/CollectionPage.vala"
	_tmp19_ = self->priv->enhance_button;
#line 460 "../src/Views/CollectionPage.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp20_, NULL, FALSE);
#line 460 "../src/Views/CollectionPage.vala"
	g_signal_handlers_disconnect_matched ((GtkButton*) _tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _collection_page_on_enhance_gtk_button_clicked, self);
#line 461 "../src/Views/CollectionPage.vala"
	_tmp21_ = self->priv->enhance_button;
#line 461 "../src/Views/CollectionPage.vala"
	gtk_toggle_button_set_active (_tmp21_, toggled);
#line 462 "../src/Views/CollectionPage.vala"
	_tmp22_ = self->priv->enhance_button;
#line 462 "../src/Views/CollectionPage.vala"
	g_signal_connect_object ((GtkButton*) _tmp22_, "clicked", (GCallback) _collection_page_on_enhance_gtk_button_clicked, self, 0);
#line 464 "../src/Views/CollectionPage.vala"
	_tmp23_ = page_get_action ((Page*) self, "Enhance");
#line 464 "../src/Views/CollectionPage.vala"
	action = _tmp23_;
#line 465 "../src/Views/CollectionPage.vala"
	_tmp24_ = action;
#line 465 "../src/Views/CollectionPage.vala"
	_vala_assert (_tmp24_ != NULL, "action != null");
#line 466 "../src/Views/CollectionPage.vala"
	if (toggled) {
#line 466 "../src/Views/CollectionPage.vala"
		_tmp25_ = RESOURCES_UNENHANCE_MENU;
#line 4046 "CollectionPage.c"
	} else {
#line 466 "../src/Views/CollectionPage.vala"
		_tmp25_ = RESOURCES_ENHANCE_MENU;
#line 4050 "CollectionPage.c"
	}
#line 466 "../src/Views/CollectionPage.vala"
	_tmp26_ = action;
#line 466 "../src/Views/CollectionPage.vala"
	gtk_action_set_label (_tmp26_, _tmp25_);
#line 448 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (action);
#line 4058 "CollectionPage.c"
}

static void
collection_page_on_print (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
#line 470 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 471 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 471 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 471 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) > 0;
#line 471 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 471 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 4079 "CollectionPage.c"
		PrintManager* _tmp3_;
		PrintManager* _tmp4_;
		ViewCollection* _tmp5_;
		ViewCollection* _tmp6_;
		GeeList* _tmp7_;
		GeeCollection* _tmp8_;
#line 472 "../src/Views/CollectionPage.vala"
		_tmp3_ = print_manager_get_instance ();
#line 472 "../src/Views/CollectionPage.vala"
		_tmp4_ = _tmp3_;
#line 472 "../src/Views/CollectionPage.vala"
		_tmp5_ = page_get_view ((Page*) self);
#line 472 "../src/Views/CollectionPage.vala"
		_tmp6_ = _tmp5_;
#line 472 "../src/Views/CollectionPage.vala"
		_tmp7_ = view_collection_get_selected_sources_of_type (_tmp6_, TYPE_PHOTO);
#line 472 "../src/Views/CollectionPage.vala"
		_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection);
#line 472 "../src/Views/CollectionPage.vala"
		print_manager_spool_photo (_tmp4_, _tmp8_);
#line 472 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp8_);
#line 472 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp6_);
#line 472 "../src/Views/CollectionPage.vala"
		_print_manager_unref0 (_tmp4_);
#line 4106 "CollectionPage.c"
	}
}

static void
collection_page_real_on_item_activated (CheckerboardPage* base,
                                        CheckerboardItem* item)
{
	CollectionPage * self;
	Thumbnail* thumbnail = NULL;
	Thumbnail* _tmp0_;
	Thumbnail* _tmp1_;
	MediaSource* _tmp2_;
	MediaSource* _tmp3_;
	gboolean _tmp4_;
	LibraryPhoto* photo = NULL;
	Thumbnail* _tmp5_;
	MediaSource* _tmp6_;
	LibraryPhoto* _tmp7_;
	LibraryPhoto* _tmp8_;
	LibraryPhoto* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	LibraryWindow* _tmp12_;
	LibraryWindow* _tmp13_;
	LibraryPhoto* _tmp14_;
#line 483 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 483 "../src/Views/CollectionPage.vala"
	g_return_if_fail (item != NULL);
#line 484 "../src/Views/CollectionPage.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (item, TYPE_THUMBNAIL, Thumbnail));
#line 484 "../src/Views/CollectionPage.vala"
	thumbnail = _tmp0_;
#line 489 "../src/Views/CollectionPage.vala"
	_tmp1_ = thumbnail;
#line 489 "../src/Views/CollectionPage.vala"
	_tmp2_ = thumbnail_get_media_source (_tmp1_);
#line 489 "../src/Views/CollectionPage.vala"
	_tmp3_ = _tmp2_;
#line 489 "../src/Views/CollectionPage.vala"
	_tmp4_ = IS_VIDEO (_tmp3_);
#line 489 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp3_);
#line 489 "../src/Views/CollectionPage.vala"
	if (_tmp4_) {
#line 490 "../src/Views/CollectionPage.vala"
		media_page_on_play_video ((MediaPage*) self);
#line 491 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (thumbnail);
#line 491 "../src/Views/CollectionPage.vala"
		return;
#line 4158 "CollectionPage.c"
	}
#line 494 "../src/Views/CollectionPage.vala"
	_tmp5_ = thumbnail;
#line 494 "../src/Views/CollectionPage.vala"
	_tmp6_ = thumbnail_get_media_source (_tmp5_);
#line 494 "../src/Views/CollectionPage.vala"
	_tmp7_ = IS_LIBRARY_PHOTO (_tmp6_) ? ((LibraryPhoto*) _tmp6_) : NULL;
#line 494 "../src/Views/CollectionPage.vala"
	if (_tmp7_ == NULL) {
#line 494 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp6_);
#line 4170 "CollectionPage.c"
	}
#line 494 "../src/Views/CollectionPage.vala"
	photo = _tmp7_;
#line 495 "../src/Views/CollectionPage.vala"
	_tmp8_ = photo;
#line 495 "../src/Views/CollectionPage.vala"
	if (_tmp8_ == NULL) {
#line 496 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (photo);
#line 496 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (thumbnail);
#line 496 "../src/Views/CollectionPage.vala"
		return;
#line 4184 "CollectionPage.c"
	}
#line 498 "../src/Views/CollectionPage.vala"
	_tmp9_ = photo;
#line 498 "../src/Views/CollectionPage.vala"
	_tmp10_ = data_object_to_string ((DataObject*) _tmp9_);
#line 498 "../src/Views/CollectionPage.vala"
	_tmp11_ = _tmp10_;
#line 498 "../src/Views/CollectionPage.vala"
	g_debug ("CollectionPage.vala:498: activating %s", _tmp11_);
#line 498 "../src/Views/CollectionPage.vala"
	_g_free0 (_tmp11_);
#line 499 "../src/Views/CollectionPage.vala"
	_tmp12_ = library_window_get_app ();
#line 499 "../src/Views/CollectionPage.vala"
	_tmp13_ = _tmp12_;
#line 499 "../src/Views/CollectionPage.vala"
	_tmp14_ = photo;
#line 499 "../src/Views/CollectionPage.vala"
	library_window_switch_to_photo_page (_tmp13_, self, (Photo*) _tmp14_);
#line 499 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp13_);
#line 483 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (photo);
#line 483 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (thumbnail);
#line 4210 "CollectionPage.c"
}

static gboolean
collection_page_real_on_app_key_pressed (Page* base,
                                         GdkEventKey* event)
{
	CollectionPage * self;
	gboolean handled = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label0 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label1 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label2 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label3 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label4 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label5 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label6 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label7 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label8 = 0;
#line 513 "../src/Views/CollectionPage.vala"
	static GQuark _tmp3_label9 = 0;
#line 4242 "CollectionPage.c"
	gboolean _tmp6_ = FALSE;
	gboolean result;
#line 502 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 502 "../src/Views/CollectionPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 503 "../src/Views/CollectionPage.vala"
	handled = TRUE;
#line 505 "../src/Views/CollectionPage.vala"
	if (page_match_keycode ((Page*) self, GDK_KEY_c, (guint) event->hardware_keycode)) {
#line 4253 "CollectionPage.c"
		gboolean _tmp0_ = FALSE;
#line 506 "../src/Views/CollectionPage.vala"
		if ((event->state & GDK_CONTROL_MASK) != 0) {
#line 507 "../src/Views/CollectionPage.vala"
			_tmp0_ = (event->state & GDK_SHIFT_MASK) == 0;
#line 4259 "CollectionPage.c"
		} else {
#line 506 "../src/Views/CollectionPage.vala"
			_tmp0_ = FALSE;
#line 4263 "CollectionPage.c"
		}
#line 506 "../src/Views/CollectionPage.vala"
		if (_tmp0_) {
#line 509 "../src/Views/CollectionPage.vala"
			page_activate_action ((Page*) self, "CopyImages");
#line 4269 "CollectionPage.c"
		}
	}
#line 513 "../src/Views/CollectionPage.vala"
	_tmp1_ = gdk_keyval_name (event->keyval);
#line 513 "../src/Views/CollectionPage.vala"
	_tmp2_ = _tmp1_;
#line 513 "../src/Views/CollectionPage.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 513 "../src/Views/CollectionPage.vala"
	if ((((((((_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("Page_Up")))) || (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("KP_Page_Up"))))) || (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("Page_Down"))))) || (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("KP_Page_Down"))))) || (_tmp4_ == ((0 != _tmp3_label4) ? _tmp3_label4 : (_tmp3_label4 = g_quark_from_static_string ("Home"))))) || (_tmp4_ == ((0 != _tmp3_label5) ? _tmp3_label5 : (_tmp3_label5 = g_quark_from_static_string ("KP_Home"))))) || (_tmp4_ == ((0 != _tmp3_label6) ? _tmp3_label6 : (_tmp3_label6 = g_quark_from_static_string ("End"))))) || (_tmp4_ == ((0 != _tmp3_label7) ? _tmp3_label7 : (_tmp3_label7 = g_quark_from_static_string ("KP_End"))))) {
#line 513 "../src/Views/CollectionPage.vala"
		switch (0) {
#line 4282 "CollectionPage.c"
			default:
			{
				gboolean _tmp5_ = FALSE;
#line 522 "../src/Views/CollectionPage.vala"
				g_signal_emit_by_name ((GtkWidget*) self, "key-press-event", event, &_tmp5_);
#line 523 "../src/Views/CollectionPage.vala"
				break;
#line 4290 "CollectionPage.c"
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label8) ? _tmp3_label8 : (_tmp3_label8 = g_quark_from_static_string ("bracketright")))) {
#line 513 "../src/Views/CollectionPage.vala"
		switch (0) {
#line 4296 "CollectionPage.c"
			default:
			{
#line 525 "../src/Views/CollectionPage.vala"
				page_activate_action ((Page*) self, "RotateClockwise");
#line 526 "../src/Views/CollectionPage.vala"
				break;
#line 4303 "CollectionPage.c"
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label9) ? _tmp3_label9 : (_tmp3_label9 = g_quark_from_static_string ("bracketleft")))) {
#line 513 "../src/Views/CollectionPage.vala"
		switch (0) {
#line 4309 "CollectionPage.c"
			default:
			{
#line 529 "../src/Views/CollectionPage.vala"
				page_activate_action ((Page*) self, "RotateCounterclockwise");
#line 530 "../src/Views/CollectionPage.vala"
				break;
#line 4316 "CollectionPage.c"
			}
		}
	} else {
#line 513 "../src/Views/CollectionPage.vala"
		switch (0) {
#line 4322 "CollectionPage.c"
			default:
			{
#line 533 "../src/Views/CollectionPage.vala"
				handled = FALSE;
#line 534 "../src/Views/CollectionPage.vala"
				break;
#line 4329 "CollectionPage.c"
			}
		}
	}
#line 537 "../src/Views/CollectionPage.vala"
	if (handled) {
#line 537 "../src/Views/CollectionPage.vala"
		_tmp6_ = TRUE;
#line 4337 "CollectionPage.c"
	} else {
#line 537 "../src/Views/CollectionPage.vala"
		_tmp6_ = PAGE_CLASS (collection_page_parent_class)->on_app_key_pressed ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_PAGE, MediaPage), event);
#line 4341 "CollectionPage.c"
	}
#line 537 "../src/Views/CollectionPage.vala"
	result = _tmp6_;
#line 537 "../src/Views/CollectionPage.vala"
	return result;
#line 4347 "CollectionPage.c"
}

static void
_collection_page_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                   gboolean is_cancelled,
                                                                   gpointer self)
{
#line 556 "../src/Views/CollectionPage.vala"
	collection_page_on_export_completed ((CollectionPage*) self);
#line 4357 "CollectionPage.c"
}

static void
collection_page_real_on_export (MediaPage* base)
{
	CollectionPage * self;
	ExporterUI* _tmp0_;
	GeeCollection* export_list = NULL;
	ViewCollection* _tmp1_;
	ViewCollection* _tmp2_;
	GeeList* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean has_some_photos = FALSE;
	gboolean has_some_videos = FALSE;
	gboolean _tmp8_ = FALSE;
	gchar* title = NULL;
	ExportDialog* export_dialog = NULL;
	const gchar* _tmp19_;
	ExportDialog* _tmp20_;
	ExportFormatParameters _tmp21_ = {0};
	ExportFormatParameters export_params = {0};
	gint scale = 0;
	ScaleConstraint constraint = 0;
	ExportDialog* _tmp24_;
	gint _tmp25_ = 0;
	ScaleConstraint _tmp26_ = 0;
	gboolean _tmp27_;
	Scaling scaling = {0};
	Scaling _tmp28_ = {0};
	GeeCollection* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GFile* export_dir = NULL;
	const gchar* _tmp61_;
	GFile* _tmp62_;
	GFile* _tmp63_;
	GeeCollection* _tmp64_;
	GFile* _tmp65_;
	Scaling _tmp66_;
	ExportFormatParameters _tmp67_;
	Exporter* _tmp68_;
	Exporter* _tmp69_;
	ExporterUI* _tmp70_;
	ExporterUI* _tmp71_;
	GError* _inner_error0_ = NULL;
#line 540 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 541 "../src/Views/CollectionPage.vala"
	_tmp0_ = self->priv->exporter;
#line 541 "../src/Views/CollectionPage.vala"
	if (_tmp0_ != NULL) {
#line 542 "../src/Views/CollectionPage.vala"
		return;
#line 4414 "CollectionPage.c"
	}
#line 544 "../src/Views/CollectionPage.vala"
	_tmp1_ = page_get_view ((Page*) self);
#line 544 "../src/Views/CollectionPage.vala"
	_tmp2_ = _tmp1_;
#line 544 "../src/Views/CollectionPage.vala"
	_tmp3_ = view_collection_get_selected_sources (_tmp2_);
#line 544 "../src/Views/CollectionPage.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 544 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp2_);
#line 544 "../src/Views/CollectionPage.vala"
	export_list = _tmp4_;
#line 546 "../src/Views/CollectionPage.vala"
	_tmp5_ = export_list;
#line 546 "../src/Views/CollectionPage.vala"
	_tmp6_ = gee_collection_get_size (_tmp5_);
#line 546 "../src/Views/CollectionPage.vala"
	_tmp7_ = _tmp6_;
#line 546 "../src/Views/CollectionPage.vala"
	if (_tmp7_ == 0) {
#line 547 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_list);
#line 547 "../src/Views/CollectionPage.vala"
		return;
#line 4440 "CollectionPage.c"
	}
#line 549 "../src/Views/CollectionPage.vala"
	has_some_photos = collection_page_selection_has_photo (self);
#line 550 "../src/Views/CollectionPage.vala"
	has_some_videos = collection_page_selection_has_video (self);
#line 551 "../src/Views/CollectionPage.vala"
	if (has_some_photos) {
#line 551 "../src/Views/CollectionPage.vala"
		_tmp8_ = TRUE;
#line 4450 "CollectionPage.c"
	} else {
#line 551 "../src/Views/CollectionPage.vala"
		_tmp8_ = has_some_videos;
#line 4454 "CollectionPage.c"
	}
#line 551 "../src/Views/CollectionPage.vala"
	_vala_assert (_tmp8_, "has_some_photos || has_some_videos");
#line 555 "../src/Views/CollectionPage.vala"
	if (!has_some_photos) {
#line 4460 "CollectionPage.c"
		GeeCollection* _tmp9_;
		ExporterUI* _tmp10_;
#line 556 "../src/Views/CollectionPage.vala"
		_tmp9_ = export_list;
#line 556 "../src/Views/CollectionPage.vala"
		_tmp10_ = video_export_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_COLLECTION, GeeCollection), _collection_page_on_export_completed_exporter_completion_callback, self, FALSE);
#line 556 "../src/Views/CollectionPage.vala"
		_exporter_ui_unref0 (self->priv->exporter);
#line 556 "../src/Views/CollectionPage.vala"
		self->priv->exporter = _tmp10_;
#line 557 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_list);
#line 557 "../src/Views/CollectionPage.vala"
		return;
#line 4475 "CollectionPage.c"
	}
#line 560 "../src/Views/CollectionPage.vala"
	title = NULL;
#line 561 "../src/Views/CollectionPage.vala"
	if (has_some_videos) {
#line 4481 "CollectionPage.c"
		GeeCollection* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
#line 562 "../src/Views/CollectionPage.vala"
		_tmp11_ = export_list;
#line 562 "../src/Views/CollectionPage.vala"
		_tmp12_ = gee_collection_get_size (_tmp11_);
#line 562 "../src/Views/CollectionPage.vala"
		_tmp13_ = _tmp12_;
#line 562 "../src/Views/CollectionPage.vala"
		_tmp14_ = g_strdup (ngettext ("Export Photo/Video", "Export Photos/Videos", (gulong) _tmp13_));
#line 562 "../src/Views/CollectionPage.vala"
		_g_free0 (title);
#line 562 "../src/Views/CollectionPage.vala"
		title = _tmp14_;
#line 4498 "CollectionPage.c"
	} else {
		GeeCollection* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
#line 564 "../src/Views/CollectionPage.vala"
		_tmp15_ = export_list;
#line 564 "../src/Views/CollectionPage.vala"
		_tmp16_ = gee_collection_get_size (_tmp15_);
#line 564 "../src/Views/CollectionPage.vala"
		_tmp17_ = _tmp16_;
#line 564 "../src/Views/CollectionPage.vala"
		_tmp18_ = g_strdup (ngettext ("Export Photo", "Export Photos", (gulong) _tmp17_));
#line 564 "../src/Views/CollectionPage.vala"
		_g_free0 (title);
#line 564 "../src/Views/CollectionPage.vala"
		title = _tmp18_;
#line 4516 "CollectionPage.c"
	}
#line 566 "../src/Views/CollectionPage.vala"
	_tmp19_ = title;
#line 566 "../src/Views/CollectionPage.vala"
	_tmp20_ = export_dialog_new (_tmp19_);
#line 566 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp20_);
#line 566 "../src/Views/CollectionPage.vala"
	export_dialog = _tmp20_;
#line 576 "../src/Views/CollectionPage.vala"
	if (has_some_videos) {
#line 4528 "CollectionPage.c"
		ExportFormatParameters _tmp22_ = {0};
#line 576 "../src/Views/CollectionPage.vala"
		export_format_parameters_current (&_tmp22_);
#line 576 "../src/Views/CollectionPage.vala"
		_tmp21_ = _tmp22_;
#line 4534 "CollectionPage.c"
	} else {
		ExportFormatParameters _tmp23_ = {0};
#line 577 "../src/Views/CollectionPage.vala"
		export_format_parameters_last (&_tmp23_);
#line 577 "../src/Views/CollectionPage.vala"
		_tmp21_ = _tmp23_;
#line 4541 "CollectionPage.c"
	}
#line 576 "../src/Views/CollectionPage.vala"
	export_params = _tmp21_;
#line 581 "../src/Views/CollectionPage.vala"
	_tmp24_ = export_dialog;
#line 581 "../src/Views/CollectionPage.vala"
	_tmp27_ = export_dialog_execute (_tmp24_, &_tmp25_, &_tmp26_, &export_params);
#line 581 "../src/Views/CollectionPage.vala"
	scale = _tmp25_;
#line 581 "../src/Views/CollectionPage.vala"
	constraint = _tmp26_;
#line 581 "../src/Views/CollectionPage.vala"
	if (!_tmp27_) {
#line 582 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_dialog);
#line 582 "../src/Views/CollectionPage.vala"
		_g_free0 (title);
#line 582 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_list);
#line 582 "../src/Views/CollectionPage.vala"
		return;
#line 4563 "CollectionPage.c"
	}
#line 584 "../src/Views/CollectionPage.vala"
	scaling_for_constraint (constraint, scale, FALSE, &_tmp28_);
#line 584 "../src/Views/CollectionPage.vala"
	scaling = _tmp28_;
#line 587 "../src/Views/CollectionPage.vala"
	_tmp29_ = export_list;
#line 587 "../src/Views/CollectionPage.vala"
	_tmp30_ = gee_collection_get_size (_tmp29_);
#line 587 "../src/Views/CollectionPage.vala"
	_tmp31_ = _tmp30_;
#line 587 "../src/Views/CollectionPage.vala"
	if (_tmp31_ == 1) {
#line 4577 "CollectionPage.c"
		LibraryPhoto* photo = NULL;
		GFile* save_as = NULL;
		LibraryPhoto* _tmp39_;
		ExportFormatParameters _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		GFile* _tmp43_;
		GFile* _tmp44_;
		GFile* _tmp45_;
#line 588 "../src/Views/CollectionPage.vala"
		photo = NULL;
#line 4589 "CollectionPage.c"
		{
			GeeIterator* _p_it = NULL;
			GeeCollection* _tmp32_;
			GeeIterator* _tmp33_;
#line 589 "../src/Views/CollectionPage.vala"
			_tmp32_ = export_list;
#line 589 "../src/Views/CollectionPage.vala"
			_tmp33_ = gee_iterable_iterator ((GeeIterable*) G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_COLLECTION, GeeCollection));
#line 589 "../src/Views/CollectionPage.vala"
			_p_it = _tmp33_;
#line 589 "../src/Views/CollectionPage.vala"
			while (TRUE) {
#line 4602 "CollectionPage.c"
				GeeIterator* _tmp34_;
				LibraryPhoto* p = NULL;
				GeeIterator* _tmp35_;
				gpointer _tmp36_;
				LibraryPhoto* _tmp37_;
				LibraryPhoto* _tmp38_;
#line 589 "../src/Views/CollectionPage.vala"
				_tmp34_ = _p_it;
#line 589 "../src/Views/CollectionPage.vala"
				if (!gee_iterator_next (_tmp34_)) {
#line 589 "../src/Views/CollectionPage.vala"
					break;
#line 4615 "CollectionPage.c"
				}
#line 589 "../src/Views/CollectionPage.vala"
				_tmp35_ = _p_it;
#line 589 "../src/Views/CollectionPage.vala"
				_tmp36_ = gee_iterator_get (_tmp35_);
#line 589 "../src/Views/CollectionPage.vala"
				p = (LibraryPhoto*) _tmp36_;
#line 590 "../src/Views/CollectionPage.vala"
				_tmp37_ = p;
#line 590 "../src/Views/CollectionPage.vala"
				_tmp38_ = _g_object_ref0 (_tmp37_);
#line 590 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (photo);
#line 590 "../src/Views/CollectionPage.vala"
				photo = _tmp38_;
#line 591 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (p);
#line 591 "../src/Views/CollectionPage.vala"
				break;
#line 4635 "CollectionPage.c"
			}
#line 589 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_p_it);
#line 4639 "CollectionPage.c"
		}
#line 594 "../src/Views/CollectionPage.vala"
		_tmp39_ = photo;
#line 594 "../src/Views/CollectionPage.vala"
		_tmp40_ = export_params;
#line 594 "../src/Views/CollectionPage.vala"
		_tmp41_ = photo_get_export_basename_for_parameters ((Photo*) _tmp39_, &_tmp40_);
#line 594 "../src/Views/CollectionPage.vala"
		_tmp42_ = _tmp41_;
#line 594 "../src/Views/CollectionPage.vala"
		_tmp43_ = export_ui_choose_file (_tmp42_);
#line 594 "../src/Views/CollectionPage.vala"
		_tmp44_ = _tmp43_;
#line 594 "../src/Views/CollectionPage.vala"
		_g_free0 (_tmp42_);
#line 594 "../src/Views/CollectionPage.vala"
		save_as = _tmp44_;
#line 596 "../src/Views/CollectionPage.vala"
		_tmp45_ = save_as;
#line 596 "../src/Views/CollectionPage.vala"
		if (_tmp45_ == NULL) {
#line 597 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (save_as);
#line 597 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (photo);
#line 597 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (export_dialog);
#line 597 "../src/Views/CollectionPage.vala"
			_g_free0 (title);
#line 597 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (export_list);
#line 597 "../src/Views/CollectionPage.vala"
			return;
#line 4673 "CollectionPage.c"
		}
		{
			AppWindow* _tmp46_;
			AppWindow* _tmp47_;
			LibraryPhoto* _tmp48_;
			GFile* _tmp49_;
			Scaling _tmp50_;
			ExportFormatParameters _tmp51_;
			LibraryPhoto* _tmp52_;
			ExportFormatParameters _tmp53_;
			ExportFormatParameters _tmp54_;
			ExportFormatParameters _tmp55_;
			AppWindow* _tmp56_;
			AppWindow* _tmp57_;
#line 600 "../src/Views/CollectionPage.vala"
			_tmp46_ = app_window_get_instance ();
#line 600 "../src/Views/CollectionPage.vala"
			_tmp47_ = _tmp46_;
#line 600 "../src/Views/CollectionPage.vala"
			page_window_set_busy_cursor ((PageWindow*) _tmp47_);
#line 600 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp47_);
#line 601 "../src/Views/CollectionPage.vala"
			_tmp48_ = photo;
#line 601 "../src/Views/CollectionPage.vala"
			_tmp49_ = save_as;
#line 601 "../src/Views/CollectionPage.vala"
			_tmp50_ = scaling;
#line 601 "../src/Views/CollectionPage.vala"
			_tmp51_ = export_params;
#line 601 "../src/Views/CollectionPage.vala"
			_tmp52_ = photo;
#line 601 "../src/Views/CollectionPage.vala"
			_tmp53_ = export_params;
#line 601 "../src/Views/CollectionPage.vala"
			_tmp54_ = export_params;
#line 601 "../src/Views/CollectionPage.vala"
			_tmp55_ = export_params;
#line 601 "../src/Views/CollectionPage.vala"
			photo_export ((Photo*) _tmp48_, _tmp49_, &_tmp50_, _tmp51_.quality, photo_get_export_format_for_parameters ((Photo*) _tmp52_, &_tmp53_), _tmp54_.mode == EXPORT_FORMAT_MODE_UNMODIFIED, _tmp55_.export_metadata, &_inner_error0_);
#line 601 "../src/Views/CollectionPage.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4716 "CollectionPage.c"
				goto __catch0_g_error;
			}
#line 604 "../src/Views/CollectionPage.vala"
			_tmp56_ = app_window_get_instance ();
#line 604 "../src/Views/CollectionPage.vala"
			_tmp57_ = _tmp56_;
#line 604 "../src/Views/CollectionPage.vala"
			page_window_set_normal_cursor ((PageWindow*) _tmp57_);
#line 604 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp57_);
#line 4727 "CollectionPage.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			AppWindow* _tmp58_;
			AppWindow* _tmp59_;
			GFile* _tmp60_;
#line 599 "../src/Views/CollectionPage.vala"
			g_clear_error (&_inner_error0_);
#line 606 "../src/Views/CollectionPage.vala"
			_tmp58_ = app_window_get_instance ();
#line 606 "../src/Views/CollectionPage.vala"
			_tmp59_ = _tmp58_;
#line 606 "../src/Views/CollectionPage.vala"
			page_window_set_normal_cursor ((PageWindow*) _tmp59_);
#line 606 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp59_);
#line 607 "../src/Views/CollectionPage.vala"
			_tmp60_ = save_as;
#line 607 "../src/Views/CollectionPage.vala"
			export_error_dialog (_tmp60_, FALSE);
#line 4749 "CollectionPage.c"
		}
		__finally0:
#line 599 "../src/Views/CollectionPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 599 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (save_as);
#line 599 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (photo);
#line 599 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (export_dialog);
#line 599 "../src/Views/CollectionPage.vala"
			_g_free0 (title);
#line 599 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (export_list);
#line 599 "../src/Views/CollectionPage.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 599 "../src/Views/CollectionPage.vala"
			g_clear_error (&_inner_error0_);
#line 599 "../src/Views/CollectionPage.vala"
			return;
#line 4770 "CollectionPage.c"
		}
#line 610 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (save_as);
#line 610 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (photo);
#line 610 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_dialog);
#line 610 "../src/Views/CollectionPage.vala"
		_g_free0 (title);
#line 610 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_list);
#line 610 "../src/Views/CollectionPage.vala"
		return;
#line 4784 "CollectionPage.c"
	}
#line 614 "../src/Views/CollectionPage.vala"
	_tmp61_ = title;
#line 614 "../src/Views/CollectionPage.vala"
	_tmp62_ = export_ui_choose_dir (_tmp61_);
#line 614 "../src/Views/CollectionPage.vala"
	export_dir = _tmp62_;
#line 615 "../src/Views/CollectionPage.vala"
	_tmp63_ = export_dir;
#line 615 "../src/Views/CollectionPage.vala"
	if (_tmp63_ == NULL) {
#line 616 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_dir);
#line 616 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_dialog);
#line 616 "../src/Views/CollectionPage.vala"
		_g_free0 (title);
#line 616 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (export_list);
#line 616 "../src/Views/CollectionPage.vala"
		return;
#line 4806 "CollectionPage.c"
	}
#line 618 "../src/Views/CollectionPage.vala"
	_tmp64_ = export_list;
#line 618 "../src/Views/CollectionPage.vala"
	_tmp65_ = export_dir;
#line 618 "../src/Views/CollectionPage.vala"
	_tmp66_ = scaling;
#line 618 "../src/Views/CollectionPage.vala"
	_tmp67_ = export_params;
#line 618 "../src/Views/CollectionPage.vala"
	_tmp68_ = exporter_new (_tmp64_, _tmp65_, &_tmp66_, &_tmp67_, FALSE);
#line 618 "../src/Views/CollectionPage.vala"
	_tmp69_ = _tmp68_;
#line 618 "../src/Views/CollectionPage.vala"
	_tmp70_ = exporter_ui_new (_tmp69_);
#line 618 "../src/Views/CollectionPage.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 618 "../src/Views/CollectionPage.vala"
	self->priv->exporter = _tmp70_;
#line 618 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp69_);
#line 619 "../src/Views/CollectionPage.vala"
	_tmp71_ = self->priv->exporter;
#line 619 "../src/Views/CollectionPage.vala"
	exporter_ui_export (_tmp71_, _collection_page_on_export_completed_exporter_completion_callback, self);
#line 540 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (export_dir);
#line 540 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (export_dialog);
#line 540 "../src/Views/CollectionPage.vala"
	_g_free0 (title);
#line 540 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (export_list);
#line 4840 "CollectionPage.c"
}

static void
collection_page_on_export_completed (CollectionPage* self)
{
#line 622 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 623 "../src/Views/CollectionPage.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 623 "../src/Views/CollectionPage.vala"
	self->priv->exporter = NULL;
#line 4852 "CollectionPage.c"
}

static gboolean
collection_page_can_revert_selected (CollectionPage* self)
{
	gboolean result;
#line 626 "../src/Views/CollectionPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4861 "CollectionPage.c"
	{
		GeeList* _source_list = NULL;
		ViewCollection* _tmp0_;
		ViewCollection* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _source_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _source_index = 0;
#line 627 "../src/Views/CollectionPage.vala"
		_tmp0_ = page_get_view ((Page*) self);
#line 627 "../src/Views/CollectionPage.vala"
		_tmp1_ = _tmp0_;
#line 627 "../src/Views/CollectionPage.vala"
		_tmp2_ = view_collection_get_selected_sources (_tmp1_);
#line 627 "../src/Views/CollectionPage.vala"
		_tmp3_ = _tmp2_;
#line 627 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp1_);
#line 627 "../src/Views/CollectionPage.vala"
		_source_list = _tmp3_;
#line 627 "../src/Views/CollectionPage.vala"
		_tmp4_ = _source_list;
#line 627 "../src/Views/CollectionPage.vala"
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 627 "../src/Views/CollectionPage.vala"
		_tmp6_ = _tmp5_;
#line 627 "../src/Views/CollectionPage.vala"
		_source_size = _tmp6_;
#line 627 "../src/Views/CollectionPage.vala"
		_source_index = -1;
#line 627 "../src/Views/CollectionPage.vala"
		while (TRUE) {
#line 4897 "CollectionPage.c"
			gint _tmp7_;
			gint _tmp8_;
			DataSource* source = NULL;
			GeeList* _tmp9_;
			gpointer _tmp10_;
			LibraryPhoto* photo = NULL;
			DataSource* _tmp11_;
			LibraryPhoto* _tmp12_;
			gboolean _tmp13_ = FALSE;
			LibraryPhoto* _tmp14_;
#line 627 "../src/Views/CollectionPage.vala"
			_source_index = _source_index + 1;
#line 627 "../src/Views/CollectionPage.vala"
			_tmp7_ = _source_index;
#line 627 "../src/Views/CollectionPage.vala"
			_tmp8_ = _source_size;
#line 627 "../src/Views/CollectionPage.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 627 "../src/Views/CollectionPage.vala"
				break;
#line 4918 "CollectionPage.c"
			}
#line 627 "../src/Views/CollectionPage.vala"
			_tmp9_ = _source_list;
#line 627 "../src/Views/CollectionPage.vala"
			_tmp10_ = gee_list_get (_tmp9_, _source_index);
#line 627 "../src/Views/CollectionPage.vala"
			source = (DataSource*) _tmp10_;
#line 628 "../src/Views/CollectionPage.vala"
			_tmp11_ = source;
#line 628 "../src/Views/CollectionPage.vala"
			_tmp12_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp11_) ? ((LibraryPhoto*) _tmp11_) : NULL);
#line 628 "../src/Views/CollectionPage.vala"
			photo = _tmp12_;
#line 629 "../src/Views/CollectionPage.vala"
			_tmp14_ = photo;
#line 629 "../src/Views/CollectionPage.vala"
			if (_tmp14_ != NULL) {
#line 4936 "CollectionPage.c"
				gboolean _tmp15_ = FALSE;
				LibraryPhoto* _tmp16_;
#line 629 "../src/Views/CollectionPage.vala"
				_tmp16_ = photo;
#line 629 "../src/Views/CollectionPage.vala"
				if (photo_has_transformations ((Photo*) _tmp16_)) {
#line 629 "../src/Views/CollectionPage.vala"
					_tmp15_ = TRUE;
#line 4945 "CollectionPage.c"
				} else {
					LibraryPhoto* _tmp17_;
#line 629 "../src/Views/CollectionPage.vala"
					_tmp17_ = photo;
#line 629 "../src/Views/CollectionPage.vala"
					_tmp15_ = photo_has_editable ((Photo*) _tmp17_);
#line 4952 "CollectionPage.c"
				}
#line 629 "../src/Views/CollectionPage.vala"
				_tmp13_ = _tmp15_;
#line 4956 "CollectionPage.c"
			} else {
#line 629 "../src/Views/CollectionPage.vala"
				_tmp13_ = FALSE;
#line 4960 "CollectionPage.c"
			}
#line 629 "../src/Views/CollectionPage.vala"
			if (_tmp13_) {
#line 630 "../src/Views/CollectionPage.vala"
				result = TRUE;
#line 630 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (photo);
#line 630 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (source);
#line 630 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (_source_list);
#line 630 "../src/Views/CollectionPage.vala"
				return result;
#line 4974 "CollectionPage.c"
			}
#line 627 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (photo);
#line 627 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (source);
#line 4980 "CollectionPage.c"
		}
#line 627 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_source_list);
#line 4984 "CollectionPage.c"
	}
#line 633 "../src/Views/CollectionPage.vala"
	result = FALSE;
#line 633 "../src/Views/CollectionPage.vala"
	return result;
#line 4990 "CollectionPage.c"
}

static gboolean
collection_page_can_revert_editable_selected (CollectionPage* self)
{
	gboolean result;
#line 636 "../src/Views/CollectionPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4999 "CollectionPage.c"
	{
		GeeList* _source_list = NULL;
		ViewCollection* _tmp0_;
		ViewCollection* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _source_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _source_index = 0;
#line 637 "../src/Views/CollectionPage.vala"
		_tmp0_ = page_get_view ((Page*) self);
#line 637 "../src/Views/CollectionPage.vala"
		_tmp1_ = _tmp0_;
#line 637 "../src/Views/CollectionPage.vala"
		_tmp2_ = view_collection_get_selected_sources (_tmp1_);
#line 637 "../src/Views/CollectionPage.vala"
		_tmp3_ = _tmp2_;
#line 637 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp1_);
#line 637 "../src/Views/CollectionPage.vala"
		_source_list = _tmp3_;
#line 637 "../src/Views/CollectionPage.vala"
		_tmp4_ = _source_list;
#line 637 "../src/Views/CollectionPage.vala"
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 637 "../src/Views/CollectionPage.vala"
		_tmp6_ = _tmp5_;
#line 637 "../src/Views/CollectionPage.vala"
		_source_size = _tmp6_;
#line 637 "../src/Views/CollectionPage.vala"
		_source_index = -1;
#line 637 "../src/Views/CollectionPage.vala"
		while (TRUE) {
#line 5035 "CollectionPage.c"
			gint _tmp7_;
			gint _tmp8_;
			DataSource* source = NULL;
			GeeList* _tmp9_;
			gpointer _tmp10_;
			LibraryPhoto* photo = NULL;
			DataSource* _tmp11_;
			LibraryPhoto* _tmp12_;
			gboolean _tmp13_ = FALSE;
			LibraryPhoto* _tmp14_;
#line 637 "../src/Views/CollectionPage.vala"
			_source_index = _source_index + 1;
#line 637 "../src/Views/CollectionPage.vala"
			_tmp7_ = _source_index;
#line 637 "../src/Views/CollectionPage.vala"
			_tmp8_ = _source_size;
#line 637 "../src/Views/CollectionPage.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 637 "../src/Views/CollectionPage.vala"
				break;
#line 5056 "CollectionPage.c"
			}
#line 637 "../src/Views/CollectionPage.vala"
			_tmp9_ = _source_list;
#line 637 "../src/Views/CollectionPage.vala"
			_tmp10_ = gee_list_get (_tmp9_, _source_index);
#line 637 "../src/Views/CollectionPage.vala"
			source = (DataSource*) _tmp10_;
#line 638 "../src/Views/CollectionPage.vala"
			_tmp11_ = source;
#line 638 "../src/Views/CollectionPage.vala"
			_tmp12_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp11_) ? ((LibraryPhoto*) _tmp11_) : NULL);
#line 638 "../src/Views/CollectionPage.vala"
			photo = _tmp12_;
#line 639 "../src/Views/CollectionPage.vala"
			_tmp14_ = photo;
#line 639 "../src/Views/CollectionPage.vala"
			if (_tmp14_ != NULL) {
#line 5074 "CollectionPage.c"
				LibraryPhoto* _tmp15_;
#line 639 "../src/Views/CollectionPage.vala"
				_tmp15_ = photo;
#line 639 "../src/Views/CollectionPage.vala"
				_tmp13_ = photo_has_editable ((Photo*) _tmp15_);
#line 5080 "CollectionPage.c"
			} else {
#line 639 "../src/Views/CollectionPage.vala"
				_tmp13_ = FALSE;
#line 5084 "CollectionPage.c"
			}
#line 639 "../src/Views/CollectionPage.vala"
			if (_tmp13_) {
#line 640 "../src/Views/CollectionPage.vala"
				result = TRUE;
#line 640 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (photo);
#line 640 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (source);
#line 640 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (_source_list);
#line 640 "../src/Views/CollectionPage.vala"
				return result;
#line 5098 "CollectionPage.c"
			}
#line 637 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (photo);
#line 637 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (source);
#line 5104 "CollectionPage.c"
		}
#line 637 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_source_list);
#line 5108 "CollectionPage.c"
	}
#line 643 "../src/Views/CollectionPage.vala"
	result = FALSE;
#line 643 "../src/Views/CollectionPage.vala"
	return result;
#line 5114 "CollectionPage.c"
}

static void
collection_page_on_show_sidebar (CollectionPage* self)
{
	LibraryWindow* app = NULL;
	AppWindow* _tmp0_;
	LibraryWindow* _tmp1_;
#line 646 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 647 "../src/Views/CollectionPage.vala"
	_tmp0_ = app_window_get_instance ();
#line 647 "../src/Views/CollectionPage.vala"
	_tmp1_ = IS_LIBRARY_WINDOW (_tmp0_) ? ((LibraryWindow*) _tmp0_) : NULL;
#line 647 "../src/Views/CollectionPage.vala"
	if (_tmp1_ == NULL) {
#line 647 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp0_);
#line 5133 "CollectionPage.c"
	}
#line 647 "../src/Views/CollectionPage.vala"
	app = _tmp1_;
#line 648 "../src/Views/CollectionPage.vala"
	library_window_set_metadata_sidebar_visible (app, !library_window_is_metadata_sidebar_visible (app));
#line 649 "../src/Views/CollectionPage.vala"
	page_update_sidebar_action ((Page*) self, !library_window_is_metadata_sidebar_visible (app));
#line 646 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (app);
#line 5143 "CollectionPage.c"
}

static void
collection_page_on_rotate_clockwise (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	RotateMultipleCommand* command = NULL;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	RotateMultipleCommand* _tmp7_;
	RotateMultipleCommand* _tmp8_;
	CommandManager* _tmp9_;
	CommandManager* _tmp10_;
	RotateMultipleCommand* _tmp11_;
#line 652 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 653 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 653 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 653 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 653 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 653 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 654 "../src/Views/CollectionPage.vala"
		return;
#line 5176 "CollectionPage.c"
	}
#line 656 "../src/Views/CollectionPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 656 "../src/Views/CollectionPage.vala"
	_tmp4_ = _tmp3_;
#line 656 "../src/Views/CollectionPage.vala"
	_tmp5_ = view_collection_get_selected (_tmp4_);
#line 656 "../src/Views/CollectionPage.vala"
	_tmp6_ = _tmp5_;
#line 656 "../src/Views/CollectionPage.vala"
	_tmp7_ = rotate_multiple_command_new ((GeeIterable*) _tmp6_, ROTATION_CLOCKWISE, RESOURCES_ROTATE_CW_FULL_LABEL, RESOURCES_ROTATE_CW_TOOLTIP, _ ("Rotating"), _ ("Undoing Rotate"));
#line 656 "../src/Views/CollectionPage.vala"
	_tmp8_ = _tmp7_;
#line 656 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp6_);
#line 656 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 656 "../src/Views/CollectionPage.vala"
	command = _tmp8_;
#line 659 "../src/Views/CollectionPage.vala"
	_tmp9_ = page_get_command_manager ((Page*) self);
#line 659 "../src/Views/CollectionPage.vala"
	_tmp10_ = _tmp9_;
#line 659 "../src/Views/CollectionPage.vala"
	_tmp11_ = command;
#line 659 "../src/Views/CollectionPage.vala"
	command_manager_execute (_tmp10_, (Command*) _tmp11_);
#line 659 "../src/Views/CollectionPage.vala"
	_command_manager_unref0 (_tmp10_);
#line 652 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (command);
#line 5208 "CollectionPage.c"
}

static void
collection_page_on_rotate_counterclockwise (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	RotateMultipleCommand* command = NULL;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	RotateMultipleCommand* _tmp7_;
	RotateMultipleCommand* _tmp8_;
	CommandManager* _tmp9_;
	CommandManager* _tmp10_;
	RotateMultipleCommand* _tmp11_;
#line 662 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 663 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 663 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 663 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 663 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 663 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 664 "../src/Views/CollectionPage.vala"
		return;
#line 5241 "CollectionPage.c"
	}
#line 666 "../src/Views/CollectionPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 666 "../src/Views/CollectionPage.vala"
	_tmp4_ = _tmp3_;
#line 666 "../src/Views/CollectionPage.vala"
	_tmp5_ = view_collection_get_selected (_tmp4_);
#line 666 "../src/Views/CollectionPage.vala"
	_tmp6_ = _tmp5_;
#line 666 "../src/Views/CollectionPage.vala"
	_tmp7_ = rotate_multiple_command_new ((GeeIterable*) _tmp6_, ROTATION_COUNTERCLOCKWISE, RESOURCES_ROTATE_CCW_FULL_LABEL, RESOURCES_ROTATE_CCW_TOOLTIP, _ ("Rotating"), _ ("Undoing Rotate"));
#line 666 "../src/Views/CollectionPage.vala"
	_tmp8_ = _tmp7_;
#line 666 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp6_);
#line 666 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 666 "../src/Views/CollectionPage.vala"
	command = _tmp8_;
#line 669 "../src/Views/CollectionPage.vala"
	_tmp9_ = page_get_command_manager ((Page*) self);
#line 669 "../src/Views/CollectionPage.vala"
	_tmp10_ = _tmp9_;
#line 669 "../src/Views/CollectionPage.vala"
	_tmp11_ = command;
#line 669 "../src/Views/CollectionPage.vala"
	command_manager_execute (_tmp10_, (Command*) _tmp11_);
#line 669 "../src/Views/CollectionPage.vala"
	_command_manager_unref0 (_tmp10_);
#line 662 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (command);
#line 5273 "CollectionPage.c"
}

static void
collection_page_on_flip_horizontally (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	RotateMultipleCommand* command = NULL;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	RotateMultipleCommand* _tmp7_;
	RotateMultipleCommand* _tmp8_;
	CommandManager* _tmp9_;
	CommandManager* _tmp10_;
	RotateMultipleCommand* _tmp11_;
#line 672 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 673 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 673 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 673 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 673 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 673 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 674 "../src/Views/CollectionPage.vala"
		return;
#line 5306 "CollectionPage.c"
	}
#line 676 "../src/Views/CollectionPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 676 "../src/Views/CollectionPage.vala"
	_tmp4_ = _tmp3_;
#line 676 "../src/Views/CollectionPage.vala"
	_tmp5_ = view_collection_get_selected (_tmp4_);
#line 676 "../src/Views/CollectionPage.vala"
	_tmp6_ = _tmp5_;
#line 676 "../src/Views/CollectionPage.vala"
	_tmp7_ = rotate_multiple_command_new ((GeeIterable*) _tmp6_, ROTATION_MIRROR, RESOURCES_HFLIP_LABEL, "", _ ("Flipping Horizontally"), _ ("Undoing Flip Horizontally"));
#line 676 "../src/Views/CollectionPage.vala"
	_tmp8_ = _tmp7_;
#line 676 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp6_);
#line 676 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 676 "../src/Views/CollectionPage.vala"
	command = _tmp8_;
#line 679 "../src/Views/CollectionPage.vala"
	_tmp9_ = page_get_command_manager ((Page*) self);
#line 679 "../src/Views/CollectionPage.vala"
	_tmp10_ = _tmp9_;
#line 679 "../src/Views/CollectionPage.vala"
	_tmp11_ = command;
#line 679 "../src/Views/CollectionPage.vala"
	command_manager_execute (_tmp10_, (Command*) _tmp11_);
#line 679 "../src/Views/CollectionPage.vala"
	_command_manager_unref0 (_tmp10_);
#line 672 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (command);
#line 5338 "CollectionPage.c"
}

static void
collection_page_on_flip_vertically (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	RotateMultipleCommand* command = NULL;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	RotateMultipleCommand* _tmp7_;
	RotateMultipleCommand* _tmp8_;
	CommandManager* _tmp9_;
	CommandManager* _tmp10_;
	RotateMultipleCommand* _tmp11_;
#line 682 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 683 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 683 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 683 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 683 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 683 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 684 "../src/Views/CollectionPage.vala"
		return;
#line 5371 "CollectionPage.c"
	}
#line 686 "../src/Views/CollectionPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 686 "../src/Views/CollectionPage.vala"
	_tmp4_ = _tmp3_;
#line 686 "../src/Views/CollectionPage.vala"
	_tmp5_ = view_collection_get_selected (_tmp4_);
#line 686 "../src/Views/CollectionPage.vala"
	_tmp6_ = _tmp5_;
#line 686 "../src/Views/CollectionPage.vala"
	_tmp7_ = rotate_multiple_command_new ((GeeIterable*) _tmp6_, ROTATION_UPSIDE_DOWN, RESOURCES_VFLIP_LABEL, "", _ ("Flipping Vertically"), _ ("Undoing Flip Vertically"));
#line 686 "../src/Views/CollectionPage.vala"
	_tmp8_ = _tmp7_;
#line 686 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp6_);
#line 686 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 686 "../src/Views/CollectionPage.vala"
	command = _tmp8_;
#line 689 "../src/Views/CollectionPage.vala"
	_tmp9_ = page_get_command_manager ((Page*) self);
#line 689 "../src/Views/CollectionPage.vala"
	_tmp10_ = _tmp9_;
#line 689 "../src/Views/CollectionPage.vala"
	_tmp11_ = command;
#line 689 "../src/Views/CollectionPage.vala"
	command_manager_execute (_tmp10_, (Command*) _tmp11_);
#line 689 "../src/Views/CollectionPage.vala"
	_command_manager_unref0 (_tmp10_);
#line 682 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (command);
#line 5403 "CollectionPage.c"
}

static void
collection_page_on_revert (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	RevertMultipleCommand* command = NULL;
	ViewCollection* _tmp22_;
	ViewCollection* _tmp23_;
	GeeList* _tmp24_;
	GeeList* _tmp25_;
	RevertMultipleCommand* _tmp26_;
	RevertMultipleCommand* _tmp27_;
	CommandManager* _tmp28_;
	CommandManager* _tmp29_;
	RevertMultipleCommand* _tmp30_;
#line 692 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 693 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 693 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 693 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 693 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 693 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 694 "../src/Views/CollectionPage.vala"
		return;
#line 5436 "CollectionPage.c"
	}
#line 696 "../src/Views/CollectionPage.vala"
	if (collection_page_can_revert_editable_selected (self)) {
#line 5440 "CollectionPage.c"
		AppWindow* _tmp3_;
		AppWindow* _tmp4_;
		ViewCollection* _tmp5_;
		ViewCollection* _tmp6_;
		GeeList* _tmp7_;
		GeeCollection* _tmp8_;
		gboolean _tmp9_;
#line 697 "../src/Views/CollectionPage.vala"
		_tmp3_ = app_window_get_instance ();
#line 697 "../src/Views/CollectionPage.vala"
		_tmp4_ = _tmp3_;
#line 697 "../src/Views/CollectionPage.vala"
		_tmp5_ = page_get_view ((Page*) self);
#line 697 "../src/Views/CollectionPage.vala"
		_tmp6_ = _tmp5_;
#line 697 "../src/Views/CollectionPage.vala"
		_tmp7_ = view_collection_get_selected_sources (_tmp6_);
#line 697 "../src/Views/CollectionPage.vala"
		_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection);
#line 697 "../src/Views/CollectionPage.vala"
		_tmp9_ = !revert_editable_dialog ((GtkWindow*) _tmp4_, _tmp8_);
#line 697 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp8_);
#line 697 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp6_);
#line 697 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp4_);
#line 697 "../src/Views/CollectionPage.vala"
		if (_tmp9_) {
#line 699 "../src/Views/CollectionPage.vala"
			return;
#line 5472 "CollectionPage.c"
		}
		{
			GeeList* _object_list = NULL;
			ViewCollection* _tmp10_;
			ViewCollection* _tmp11_;
			GeeList* _tmp12_;
			GeeList* _tmp13_;
			gint _object_size = 0;
			GeeList* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			gint _object_index = 0;
#line 702 "../src/Views/CollectionPage.vala"
			_tmp10_ = page_get_view ((Page*) self);
#line 702 "../src/Views/CollectionPage.vala"
			_tmp11_ = _tmp10_;
#line 702 "../src/Views/CollectionPage.vala"
			_tmp12_ = view_collection_get_selected_sources (_tmp11_);
#line 702 "../src/Views/CollectionPage.vala"
			_tmp13_ = _tmp12_;
#line 702 "../src/Views/CollectionPage.vala"
			_data_collection_unref0 (_tmp11_);
#line 702 "../src/Views/CollectionPage.vala"
			_object_list = _tmp13_;
#line 702 "../src/Views/CollectionPage.vala"
			_tmp14_ = _object_list;
#line 702 "../src/Views/CollectionPage.vala"
			_tmp15_ = gee_collection_get_size ((GeeCollection*) _tmp14_);
#line 702 "../src/Views/CollectionPage.vala"
			_tmp16_ = _tmp15_;
#line 702 "../src/Views/CollectionPage.vala"
			_object_size = _tmp16_;
#line 702 "../src/Views/CollectionPage.vala"
			_object_index = -1;
#line 702 "../src/Views/CollectionPage.vala"
			while (TRUE) {
#line 5509 "CollectionPage.c"
				gint _tmp17_;
				gint _tmp18_;
				DataObject* object = NULL;
				GeeList* _tmp19_;
				gpointer _tmp20_;
				DataObject* _tmp21_;
#line 702 "../src/Views/CollectionPage.vala"
				_object_index = _object_index + 1;
#line 702 "../src/Views/CollectionPage.vala"
				_tmp17_ = _object_index;
#line 702 "../src/Views/CollectionPage.vala"
				_tmp18_ = _object_size;
#line 702 "../src/Views/CollectionPage.vala"
				if (!(_tmp17_ < _tmp18_)) {
#line 702 "../src/Views/CollectionPage.vala"
					break;
#line 5526 "CollectionPage.c"
				}
#line 702 "../src/Views/CollectionPage.vala"
				_tmp19_ = _object_list;
#line 702 "../src/Views/CollectionPage.vala"
				_tmp20_ = gee_list_get (_tmp19_, _object_index);
#line 702 "../src/Views/CollectionPage.vala"
				object = (DataObject*) ((DataSource*) _tmp20_);
#line 703 "../src/Views/CollectionPage.vala"
				_tmp21_ = object;
#line 703 "../src/Views/CollectionPage.vala"
				photo_revert_to_master (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_PHOTO, Photo), TRUE);
#line 702 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (object);
#line 5540 "CollectionPage.c"
			}
#line 702 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_object_list);
#line 5544 "CollectionPage.c"
		}
	}
#line 706 "../src/Views/CollectionPage.vala"
	_tmp22_ = page_get_view ((Page*) self);
#line 706 "../src/Views/CollectionPage.vala"
	_tmp23_ = _tmp22_;
#line 706 "../src/Views/CollectionPage.vala"
	_tmp24_ = view_collection_get_selected (_tmp23_);
#line 706 "../src/Views/CollectionPage.vala"
	_tmp25_ = _tmp24_;
#line 706 "../src/Views/CollectionPage.vala"
	_tmp26_ = revert_multiple_command_new ((GeeIterable*) _tmp25_);
#line 706 "../src/Views/CollectionPage.vala"
	_tmp27_ = _tmp26_;
#line 706 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp25_);
#line 706 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp23_);
#line 706 "../src/Views/CollectionPage.vala"
	command = _tmp27_;
#line 707 "../src/Views/CollectionPage.vala"
	_tmp28_ = page_get_command_manager ((Page*) self);
#line 707 "../src/Views/CollectionPage.vala"
	_tmp29_ = _tmp28_;
#line 707 "../src/Views/CollectionPage.vala"
	_tmp30_ = command;
#line 707 "../src/Views/CollectionPage.vala"
	command_manager_execute (_tmp29_, (Command*) _tmp30_);
#line 707 "../src/Views/CollectionPage.vala"
	_command_manager_unref0 (_tmp29_);
#line 692 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (command);
#line 5577 "CollectionPage.c"
}

void
collection_page_on_copy_adjustments (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	Photo* photo = NULL;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	DataView* _tmp5_;
	DataView* _tmp6_;
	DataSource* _tmp7_;
	DataSource* _tmp8_;
	Photo* _tmp9_;
	Photo* _tmp10_;
	Photo* _tmp11_;
	PixelTransformationBundle* _tmp12_;
	PixelTransformationBundle* _tmp13_;
#line 710 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 711 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 711 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 711 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) != 1;
#line 711 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 711 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 712 "../src/Views/CollectionPage.vala"
		return;
#line 5612 "CollectionPage.c"
	}
#line 713 "../src/Views/CollectionPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 713 "../src/Views/CollectionPage.vala"
	_tmp4_ = _tmp3_;
#line 713 "../src/Views/CollectionPage.vala"
	_tmp5_ = view_collection_get_selected_at (_tmp4_, 0);
#line 713 "../src/Views/CollectionPage.vala"
	_tmp6_ = _tmp5_;
#line 713 "../src/Views/CollectionPage.vala"
	_tmp7_ = data_view_get_source (_tmp6_);
#line 713 "../src/Views/CollectionPage.vala"
	_tmp8_ = _tmp7_;
#line 713 "../src/Views/CollectionPage.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_PHOTO, Photo));
#line 713 "../src/Views/CollectionPage.vala"
	_tmp10_ = _tmp9_;
#line 713 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp6_);
#line 713 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 713 "../src/Views/CollectionPage.vala"
	photo = _tmp10_;
#line 714 "../src/Views/CollectionPage.vala"
	_tmp11_ = photo;
#line 714 "../src/Views/CollectionPage.vala"
	_tmp12_ = photo_get_color_adjustments (_tmp11_);
#line 714 "../src/Views/CollectionPage.vala"
	_tmp13_ = _tmp12_;
#line 714 "../src/Views/CollectionPage.vala"
	pixel_transformation_bundle_set_copied_color_adjustments (_tmp13_);
#line 714 "../src/Views/CollectionPage.vala"
	_pixel_transformation_bundle_unref0 (_tmp13_);
#line 715 "../src/Views/CollectionPage.vala"
	page_set_action_sensitive ((Page*) self, "PasteColorAdjustments", TRUE);
#line 710 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (photo);
#line 5650 "CollectionPage.c"
}

void
collection_page_on_paste_adjustments (CollectionPage* self)
{
	PixelTransformationBundle* copied_adjustments = NULL;
	PixelTransformationBundle* _tmp0_;
	gboolean _tmp1_ = FALSE;
	ViewCollection* _tmp2_;
	ViewCollection* _tmp3_;
	gboolean _tmp4_;
	AdjustColorsMultipleCommand* command = NULL;
	ViewCollection* _tmp6_;
	ViewCollection* _tmp7_;
	GeeList* _tmp8_;
	GeeList* _tmp9_;
	PixelTransformationBundle* _tmp10_;
	AdjustColorsMultipleCommand* _tmp11_;
	AdjustColorsMultipleCommand* _tmp12_;
	CommandManager* _tmp13_;
	CommandManager* _tmp14_;
	AdjustColorsMultipleCommand* _tmp15_;
#line 718 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 719 "../src/Views/CollectionPage.vala"
	_tmp0_ = pixel_transformation_bundle_get_copied_color_adjustments ();
#line 719 "../src/Views/CollectionPage.vala"
	copied_adjustments = _tmp0_;
#line 720 "../src/Views/CollectionPage.vala"
	_tmp2_ = page_get_view ((Page*) self);
#line 720 "../src/Views/CollectionPage.vala"
	_tmp3_ = _tmp2_;
#line 720 "../src/Views/CollectionPage.vala"
	_tmp4_ = view_collection_get_selected_count (_tmp3_) == 0;
#line 720 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp3_);
#line 720 "../src/Views/CollectionPage.vala"
	if (_tmp4_) {
#line 720 "../src/Views/CollectionPage.vala"
		_tmp1_ = TRUE;
#line 5691 "CollectionPage.c"
	} else {
		PixelTransformationBundle* _tmp5_;
#line 720 "../src/Views/CollectionPage.vala"
		_tmp5_ = copied_adjustments;
#line 720 "../src/Views/CollectionPage.vala"
		_tmp1_ = _tmp5_ == NULL;
#line 5698 "CollectionPage.c"
	}
#line 720 "../src/Views/CollectionPage.vala"
	if (_tmp1_) {
#line 721 "../src/Views/CollectionPage.vala"
		_pixel_transformation_bundle_unref0 (copied_adjustments);
#line 721 "../src/Views/CollectionPage.vala"
		return;
#line 5706 "CollectionPage.c"
	}
#line 723 "../src/Views/CollectionPage.vala"
	_tmp6_ = page_get_view ((Page*) self);
#line 723 "../src/Views/CollectionPage.vala"
	_tmp7_ = _tmp6_;
#line 723 "../src/Views/CollectionPage.vala"
	_tmp8_ = view_collection_get_selected (_tmp7_);
#line 723 "../src/Views/CollectionPage.vala"
	_tmp9_ = _tmp8_;
#line 723 "../src/Views/CollectionPage.vala"
	_tmp10_ = copied_adjustments;
#line 723 "../src/Views/CollectionPage.vala"
	_tmp11_ = adjust_colors_multiple_command_new ((GeeIterable*) _tmp9_, _tmp10_, RESOURCES_PASTE_ADJUSTMENTS_LABEL, RESOURCES_PASTE_ADJUSTMENTS_TOOLTIP);
#line 723 "../src/Views/CollectionPage.vala"
	_tmp12_ = _tmp11_;
#line 723 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp9_);
#line 723 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp7_);
#line 723 "../src/Views/CollectionPage.vala"
	command = _tmp12_;
#line 725 "../src/Views/CollectionPage.vala"
	_tmp13_ = page_get_command_manager ((Page*) self);
#line 725 "../src/Views/CollectionPage.vala"
	_tmp14_ = _tmp13_;
#line 725 "../src/Views/CollectionPage.vala"
	_tmp15_ = command;
#line 725 "../src/Views/CollectionPage.vala"
	command_manager_execute (_tmp14_, (Command*) _tmp15_);
#line 725 "../src/Views/CollectionPage.vala"
	_command_manager_unref0 (_tmp14_);
#line 718 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (command);
#line 718 "../src/Views/CollectionPage.vala"
	_pixel_transformation_bundle_unref0 (copied_adjustments);
#line 5742 "CollectionPage.c"
}

static void
collection_page_on_enhance (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	GeeArrayList* unenhanced_list = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* enhanced_list = NULL;
	GeeArrayList* _tmp4_;
	gboolean _tmp28_ = FALSE;
	GeeArrayList* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GeeArrayList* _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
#line 728 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 729 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 729 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 729 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 729 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 729 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 730 "../src/Views/CollectionPage.vala"
		return;
#line 5776 "CollectionPage.c"
	}
#line 736 "../src/Views/CollectionPage.vala"
	_tmp3_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 736 "../src/Views/CollectionPage.vala"
	unenhanced_list = _tmp3_;
#line 737 "../src/Views/CollectionPage.vala"
	_tmp4_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 737 "../src/Views/CollectionPage.vala"
	enhanced_list = _tmp4_;
#line 5786 "CollectionPage.c"
	{
		GeeList* _view_list = NULL;
		ViewCollection* _tmp5_;
		ViewCollection* _tmp6_;
		GeeList* _tmp7_;
		GeeList* _tmp8_;
		gint _view_size = 0;
		GeeList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _view_index = 0;
#line 738 "../src/Views/CollectionPage.vala"
		_tmp5_ = page_get_view ((Page*) self);
#line 738 "../src/Views/CollectionPage.vala"
		_tmp6_ = _tmp5_;
#line 738 "../src/Views/CollectionPage.vala"
		_tmp7_ = view_collection_get_selected (_tmp6_);
#line 738 "../src/Views/CollectionPage.vala"
		_tmp8_ = _tmp7_;
#line 738 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp6_);
#line 738 "../src/Views/CollectionPage.vala"
		_view_list = _tmp8_;
#line 738 "../src/Views/CollectionPage.vala"
		_tmp9_ = _view_list;
#line 738 "../src/Views/CollectionPage.vala"
		_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
#line 738 "../src/Views/CollectionPage.vala"
		_tmp11_ = _tmp10_;
#line 738 "../src/Views/CollectionPage.vala"
		_view_size = _tmp11_;
#line 738 "../src/Views/CollectionPage.vala"
		_view_index = -1;
#line 738 "../src/Views/CollectionPage.vala"
		while (TRUE) {
#line 5822 "CollectionPage.c"
			gint _tmp12_;
			gint _tmp13_;
			DataView* view = NULL;
			GeeList* _tmp14_;
			gpointer _tmp15_;
			Photo* photo = NULL;
			DataView* _tmp16_;
			DataSource* _tmp17_;
			DataSource* _tmp18_;
			Photo* _tmp19_;
			gboolean _tmp20_ = FALSE;
			Photo* _tmp21_;
#line 738 "../src/Views/CollectionPage.vala"
			_view_index = _view_index + 1;
#line 738 "../src/Views/CollectionPage.vala"
			_tmp12_ = _view_index;
#line 738 "../src/Views/CollectionPage.vala"
			_tmp13_ = _view_size;
#line 738 "../src/Views/CollectionPage.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 738 "../src/Views/CollectionPage.vala"
				break;
#line 5845 "CollectionPage.c"
			}
#line 738 "../src/Views/CollectionPage.vala"
			_tmp14_ = _view_list;
#line 738 "../src/Views/CollectionPage.vala"
			_tmp15_ = gee_list_get (_tmp14_, _view_index);
#line 738 "../src/Views/CollectionPage.vala"
			view = (DataView*) _tmp15_;
#line 739 "../src/Views/CollectionPage.vala"
			_tmp16_ = view;
#line 739 "../src/Views/CollectionPage.vala"
			_tmp17_ = data_view_get_source (_tmp16_);
#line 739 "../src/Views/CollectionPage.vala"
			_tmp18_ = _tmp17_;
#line 739 "../src/Views/CollectionPage.vala"
			_tmp19_ = _g_object_ref0 (IS_PHOTO (_tmp18_) ? ((Photo*) _tmp18_) : NULL);
#line 739 "../src/Views/CollectionPage.vala"
			photo = _tmp19_;
#line 740 "../src/Views/CollectionPage.vala"
			_tmp21_ = photo;
#line 740 "../src/Views/CollectionPage.vala"
			if (_tmp21_ != NULL) {
#line 5867 "CollectionPage.c"
				Photo* _tmp22_;
#line 740 "../src/Views/CollectionPage.vala"
				_tmp22_ = photo;
#line 740 "../src/Views/CollectionPage.vala"
				_tmp20_ = !photo_is_enhanced (_tmp22_);
#line 5873 "CollectionPage.c"
			} else {
#line 740 "../src/Views/CollectionPage.vala"
				_tmp20_ = FALSE;
#line 5877 "CollectionPage.c"
			}
#line 740 "../src/Views/CollectionPage.vala"
			if (_tmp20_) {
#line 5881 "CollectionPage.c"
				GeeArrayList* _tmp23_;
				DataView* _tmp24_;
#line 741 "../src/Views/CollectionPage.vala"
				_tmp23_ = unenhanced_list;
#line 741 "../src/Views/CollectionPage.vala"
				_tmp24_ = view;
#line 741 "../src/Views/CollectionPage.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 5890 "CollectionPage.c"
			} else {
				Photo* _tmp25_;
#line 742 "../src/Views/CollectionPage.vala"
				_tmp25_ = photo;
#line 742 "../src/Views/CollectionPage.vala"
				if (_tmp25_ != NULL) {
#line 5897 "CollectionPage.c"
					GeeArrayList* _tmp26_;
					DataView* _tmp27_;
#line 743 "../src/Views/CollectionPage.vala"
					_tmp26_ = enhanced_list;
#line 743 "../src/Views/CollectionPage.vala"
					_tmp27_ = view;
#line 743 "../src/Views/CollectionPage.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 5906 "CollectionPage.c"
				}
			}
#line 738 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (photo);
#line 738 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (view);
#line 5913 "CollectionPage.c"
		}
#line 738 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_view_list);
#line 5917 "CollectionPage.c"
	}
#line 746 "../src/Views/CollectionPage.vala"
	_tmp29_ = enhanced_list;
#line 746 "../src/Views/CollectionPage.vala"
	_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
#line 746 "../src/Views/CollectionPage.vala"
	_tmp31_ = _tmp30_;
#line 746 "../src/Views/CollectionPage.vala"
	if (_tmp31_ == 0) {
#line 5927 "CollectionPage.c"
		GeeArrayList* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
#line 746 "../src/Views/CollectionPage.vala"
		_tmp32_ = unenhanced_list;
#line 746 "../src/Views/CollectionPage.vala"
		_tmp33_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp32_);
#line 746 "../src/Views/CollectionPage.vala"
		_tmp34_ = _tmp33_;
#line 746 "../src/Views/CollectionPage.vala"
		_tmp28_ = _tmp34_ == 0;
#line 5939 "CollectionPage.c"
	} else {
#line 746 "../src/Views/CollectionPage.vala"
		_tmp28_ = FALSE;
#line 5943 "CollectionPage.c"
	}
#line 746 "../src/Views/CollectionPage.vala"
	if (_tmp28_) {
#line 747 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (enhanced_list);
#line 747 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (unenhanced_list);
#line 747 "../src/Views/CollectionPage.vala"
		return;
#line 5953 "CollectionPage.c"
	}
#line 749 "../src/Views/CollectionPage.vala"
	_tmp35_ = unenhanced_list;
#line 749 "../src/Views/CollectionPage.vala"
	_tmp36_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp35_);
#line 749 "../src/Views/CollectionPage.vala"
	_tmp37_ = _tmp36_;
#line 749 "../src/Views/CollectionPage.vala"
	if (_tmp37_ == 0) {
#line 5963 "CollectionPage.c"
		EnhanceMultipleCommand* cmd = NULL;
		CommandManager* _tmp38_;
		CommandManager* _tmp39_;
		Command* _tmp40_;
		EnhanceMultipleCommand* _tmp41_;
		EnhanceMultipleCommand* _tmp42_;
		gboolean _tmp43_ = FALSE;
		EnhanceMultipleCommand* _tmp44_;
#line 751 "../src/Views/CollectionPage.vala"
		_tmp38_ = page_get_command_manager ((Page*) self);
#line 751 "../src/Views/CollectionPage.vala"
		_tmp39_ = _tmp38_;
#line 751 "../src/Views/CollectionPage.vala"
		_tmp40_ = command_manager_get_undo_command (_tmp39_);
#line 751 "../src/Views/CollectionPage.vala"
		_tmp41_ = IS_ENHANCE_MULTIPLE_COMMAND (_tmp40_) ? ((EnhanceMultipleCommand*) _tmp40_) : NULL;
#line 751 "../src/Views/CollectionPage.vala"
		if (_tmp41_ == NULL) {
#line 751 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp40_);
#line 5984 "CollectionPage.c"
		}
#line 751 "../src/Views/CollectionPage.vala"
		_tmp42_ = _tmp41_;
#line 751 "../src/Views/CollectionPage.vala"
		_command_manager_unref0 (_tmp39_);
#line 751 "../src/Views/CollectionPage.vala"
		cmd = _tmp42_;
#line 752 "../src/Views/CollectionPage.vala"
		_tmp44_ = cmd;
#line 752 "../src/Views/CollectionPage.vala"
		if (_tmp44_ != NULL) {
#line 5996 "CollectionPage.c"
			EnhanceMultipleCommand* _tmp45_;
			GeeIterable* _tmp46_;
			GeeIterable* _tmp47_;
			ViewCollection* _tmp48_;
			ViewCollection* _tmp49_;
			GeeList* _tmp50_;
			GeeList* _tmp51_;
#line 752 "../src/Views/CollectionPage.vala"
			_tmp45_ = cmd;
#line 752 "../src/Views/CollectionPage.vala"
			_tmp46_ = multiple_data_source_command_get_sources ((MultipleDataSourceCommand*) _tmp45_);
#line 752 "../src/Views/CollectionPage.vala"
			_tmp47_ = _tmp46_;
#line 752 "../src/Views/CollectionPage.vala"
			_tmp48_ = page_get_view ((Page*) self);
#line 752 "../src/Views/CollectionPage.vala"
			_tmp49_ = _tmp48_;
#line 752 "../src/Views/CollectionPage.vala"
			_tmp50_ = view_collection_get_selected_sources (_tmp49_);
#line 752 "../src/Views/CollectionPage.vala"
			_tmp51_ = _tmp50_;
#line 752 "../src/Views/CollectionPage.vala"
			_tmp43_ = _tmp47_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_ITERABLE, GeeIterable);
#line 752 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp51_);
#line 752 "../src/Views/CollectionPage.vala"
			_data_collection_unref0 (_tmp49_);
#line 752 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp47_);
#line 6026 "CollectionPage.c"
		} else {
#line 752 "../src/Views/CollectionPage.vala"
			_tmp43_ = FALSE;
#line 6030 "CollectionPage.c"
		}
#line 752 "../src/Views/CollectionPage.vala"
		if (_tmp43_) {
#line 6034 "CollectionPage.c"
			CommandManager* _tmp52_;
			CommandManager* _tmp53_;
#line 753 "../src/Views/CollectionPage.vala"
			_tmp52_ = page_get_command_manager ((Page*) self);
#line 753 "../src/Views/CollectionPage.vala"
			_tmp53_ = _tmp52_;
#line 753 "../src/Views/CollectionPage.vala"
			command_manager_undo (_tmp53_);
#line 753 "../src/Views/CollectionPage.vala"
			_command_manager_unref0 (_tmp53_);
#line 6045 "CollectionPage.c"
		} else {
			UnEnhanceMultipleCommand* command = NULL;
			GeeArrayList* _tmp54_;
			UnEnhanceMultipleCommand* _tmp55_;
			CommandManager* _tmp56_;
			CommandManager* _tmp57_;
			UnEnhanceMultipleCommand* _tmp58_;
#line 755 "../src/Views/CollectionPage.vala"
			_tmp54_ = enhanced_list;
#line 755 "../src/Views/CollectionPage.vala"
			_tmp55_ = un_enhance_multiple_command_new ((GeeIterable*) _tmp54_);
#line 755 "../src/Views/CollectionPage.vala"
			command = _tmp55_;
#line 756 "../src/Views/CollectionPage.vala"
			_tmp56_ = page_get_command_manager ((Page*) self);
#line 756 "../src/Views/CollectionPage.vala"
			_tmp57_ = _tmp56_;
#line 756 "../src/Views/CollectionPage.vala"
			_tmp58_ = command;
#line 756 "../src/Views/CollectionPage.vala"
			command_manager_execute (_tmp57_, (Command*) _tmp58_);
#line 756 "../src/Views/CollectionPage.vala"
			_command_manager_unref0 (_tmp57_);
#line 752 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (command);
#line 6071 "CollectionPage.c"
		}
		{
			GeeArrayList* _view_list = NULL;
			GeeArrayList* _tmp59_;
			gint _view_size = 0;
			GeeArrayList* _tmp60_;
			gint _tmp61_;
			gint _tmp62_;
			gint _view_index = 0;
#line 758 "../src/Views/CollectionPage.vala"
			_tmp59_ = enhanced_list;
#line 758 "../src/Views/CollectionPage.vala"
			_view_list = _tmp59_;
#line 758 "../src/Views/CollectionPage.vala"
			_tmp60_ = _view_list;
#line 758 "../src/Views/CollectionPage.vala"
			_tmp61_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp60_);
#line 758 "../src/Views/CollectionPage.vala"
			_tmp62_ = _tmp61_;
#line 758 "../src/Views/CollectionPage.vala"
			_view_size = _tmp62_;
#line 758 "../src/Views/CollectionPage.vala"
			_view_index = -1;
#line 758 "../src/Views/CollectionPage.vala"
			while (TRUE) {
#line 6097 "CollectionPage.c"
				gint _tmp63_;
				gint _tmp64_;
				DataView* view = NULL;
				GeeArrayList* _tmp65_;
				gpointer _tmp66_;
				Photo* photo = NULL;
				DataView* _tmp67_;
				DataSource* _tmp68_;
				DataSource* _tmp69_;
				Photo* _tmp70_;
				Photo* _tmp71_;
#line 758 "../src/Views/CollectionPage.vala"
				_view_index = _view_index + 1;
#line 758 "../src/Views/CollectionPage.vala"
				_tmp63_ = _view_index;
#line 758 "../src/Views/CollectionPage.vala"
				_tmp64_ = _view_size;
#line 758 "../src/Views/CollectionPage.vala"
				if (!(_tmp63_ < _tmp64_)) {
#line 758 "../src/Views/CollectionPage.vala"
					break;
#line 6119 "CollectionPage.c"
				}
#line 758 "../src/Views/CollectionPage.vala"
				_tmp65_ = _view_list;
#line 758 "../src/Views/CollectionPage.vala"
				_tmp66_ = gee_abstract_list_get ((GeeAbstractList*) _tmp65_, _view_index);
#line 758 "../src/Views/CollectionPage.vala"
				view = (DataView*) _tmp66_;
#line 759 "../src/Views/CollectionPage.vala"
				_tmp67_ = view;
#line 759 "../src/Views/CollectionPage.vala"
				_tmp68_ = data_view_get_source (_tmp67_);
#line 759 "../src/Views/CollectionPage.vala"
				_tmp69_ = _tmp68_;
#line 759 "../src/Views/CollectionPage.vala"
				_tmp70_ = _g_object_ref0 (IS_PHOTO (_tmp69_) ? ((Photo*) _tmp69_) : NULL);
#line 759 "../src/Views/CollectionPage.vala"
				photo = _tmp70_;
#line 760 "../src/Views/CollectionPage.vala"
				_tmp71_ = photo;
#line 760 "../src/Views/CollectionPage.vala"
				photo_set_enhanced (_tmp71_, FALSE);
#line 758 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (photo);
#line 758 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (view);
#line 6145 "CollectionPage.c"
			}
		}
#line 749 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (cmd);
#line 6150 "CollectionPage.c"
	} else {
		UnEnhanceMultipleCommand* cmd = NULL;
		CommandManager* _tmp72_;
		CommandManager* _tmp73_;
		Command* _tmp74_;
		UnEnhanceMultipleCommand* _tmp75_;
		UnEnhanceMultipleCommand* _tmp76_;
		gboolean _tmp77_ = FALSE;
		UnEnhanceMultipleCommand* _tmp78_;
#line 764 "../src/Views/CollectionPage.vala"
		_tmp72_ = page_get_command_manager ((Page*) self);
#line 764 "../src/Views/CollectionPage.vala"
		_tmp73_ = _tmp72_;
#line 764 "../src/Views/CollectionPage.vala"
		_tmp74_ = command_manager_get_undo_command (_tmp73_);
#line 764 "../src/Views/CollectionPage.vala"
		_tmp75_ = IS_UN_ENHANCE_MULTIPLE_COMMAND (_tmp74_) ? ((UnEnhanceMultipleCommand*) _tmp74_) : NULL;
#line 764 "../src/Views/CollectionPage.vala"
		if (_tmp75_ == NULL) {
#line 764 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp74_);
#line 6172 "CollectionPage.c"
		}
#line 764 "../src/Views/CollectionPage.vala"
		_tmp76_ = _tmp75_;
#line 764 "../src/Views/CollectionPage.vala"
		_command_manager_unref0 (_tmp73_);
#line 764 "../src/Views/CollectionPage.vala"
		cmd = _tmp76_;
#line 765 "../src/Views/CollectionPage.vala"
		_tmp78_ = cmd;
#line 765 "../src/Views/CollectionPage.vala"
		if (_tmp78_ != NULL) {
#line 6184 "CollectionPage.c"
			UnEnhanceMultipleCommand* _tmp79_;
			GeeIterable* _tmp80_;
			GeeIterable* _tmp81_;
			ViewCollection* _tmp82_;
			ViewCollection* _tmp83_;
			GeeList* _tmp84_;
			GeeList* _tmp85_;
#line 765 "../src/Views/CollectionPage.vala"
			_tmp79_ = cmd;
#line 765 "../src/Views/CollectionPage.vala"
			_tmp80_ = multiple_data_source_command_get_sources ((MultipleDataSourceCommand*) _tmp79_);
#line 765 "../src/Views/CollectionPage.vala"
			_tmp81_ = _tmp80_;
#line 765 "../src/Views/CollectionPage.vala"
			_tmp82_ = page_get_view ((Page*) self);
#line 765 "../src/Views/CollectionPage.vala"
			_tmp83_ = _tmp82_;
#line 765 "../src/Views/CollectionPage.vala"
			_tmp84_ = view_collection_get_selected_sources (_tmp83_);
#line 765 "../src/Views/CollectionPage.vala"
			_tmp85_ = _tmp84_;
#line 765 "../src/Views/CollectionPage.vala"
			_tmp77_ = _tmp81_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp85_, GEE_TYPE_ITERABLE, GeeIterable);
#line 765 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp85_);
#line 765 "../src/Views/CollectionPage.vala"
			_data_collection_unref0 (_tmp83_);
#line 765 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (_tmp81_);
#line 6214 "CollectionPage.c"
		} else {
#line 765 "../src/Views/CollectionPage.vala"
			_tmp77_ = FALSE;
#line 6218 "CollectionPage.c"
		}
#line 765 "../src/Views/CollectionPage.vala"
		if (_tmp77_) {
#line 6222 "CollectionPage.c"
			CommandManager* _tmp86_;
			CommandManager* _tmp87_;
#line 766 "../src/Views/CollectionPage.vala"
			_tmp86_ = page_get_command_manager ((Page*) self);
#line 766 "../src/Views/CollectionPage.vala"
			_tmp87_ = _tmp86_;
#line 766 "../src/Views/CollectionPage.vala"
			command_manager_undo (_tmp87_);
#line 766 "../src/Views/CollectionPage.vala"
			_command_manager_unref0 (_tmp87_);
#line 6233 "CollectionPage.c"
		} else {
			EnhanceMultipleCommand* command = NULL;
			GeeArrayList* _tmp88_;
			EnhanceMultipleCommand* _tmp89_;
			CommandManager* _tmp90_;
			CommandManager* _tmp91_;
			EnhanceMultipleCommand* _tmp92_;
#line 768 "../src/Views/CollectionPage.vala"
			_tmp88_ = unenhanced_list;
#line 768 "../src/Views/CollectionPage.vala"
			_tmp89_ = enhance_multiple_command_new ((GeeIterable*) _tmp88_);
#line 768 "../src/Views/CollectionPage.vala"
			command = _tmp89_;
#line 769 "../src/Views/CollectionPage.vala"
			_tmp90_ = page_get_command_manager ((Page*) self);
#line 769 "../src/Views/CollectionPage.vala"
			_tmp91_ = _tmp90_;
#line 769 "../src/Views/CollectionPage.vala"
			_tmp92_ = command;
#line 769 "../src/Views/CollectionPage.vala"
			command_manager_execute (_tmp91_, (Command*) _tmp92_);
#line 769 "../src/Views/CollectionPage.vala"
			_command_manager_unref0 (_tmp91_);
#line 765 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (command);
#line 6259 "CollectionPage.c"
		}
		{
			GeeArrayList* _view_list = NULL;
			GeeArrayList* _tmp93_;
			gint _view_size = 0;
			GeeArrayList* _tmp94_;
			gint _tmp95_;
			gint _tmp96_;
			gint _view_index = 0;
#line 771 "../src/Views/CollectionPage.vala"
			_tmp93_ = enhanced_list;
#line 771 "../src/Views/CollectionPage.vala"
			_view_list = _tmp93_;
#line 771 "../src/Views/CollectionPage.vala"
			_tmp94_ = _view_list;
#line 771 "../src/Views/CollectionPage.vala"
			_tmp95_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp94_);
#line 771 "../src/Views/CollectionPage.vala"
			_tmp96_ = _tmp95_;
#line 771 "../src/Views/CollectionPage.vala"
			_view_size = _tmp96_;
#line 771 "../src/Views/CollectionPage.vala"
			_view_index = -1;
#line 771 "../src/Views/CollectionPage.vala"
			while (TRUE) {
#line 6285 "CollectionPage.c"
				gint _tmp97_;
				gint _tmp98_;
				DataView* view = NULL;
				GeeArrayList* _tmp99_;
				gpointer _tmp100_;
				Photo* photo = NULL;
				DataView* _tmp101_;
				DataSource* _tmp102_;
				DataSource* _tmp103_;
				Photo* _tmp104_;
				Photo* _tmp105_;
#line 771 "../src/Views/CollectionPage.vala"
				_view_index = _view_index + 1;
#line 771 "../src/Views/CollectionPage.vala"
				_tmp97_ = _view_index;
#line 771 "../src/Views/CollectionPage.vala"
				_tmp98_ = _view_size;
#line 771 "../src/Views/CollectionPage.vala"
				if (!(_tmp97_ < _tmp98_)) {
#line 771 "../src/Views/CollectionPage.vala"
					break;
#line 6307 "CollectionPage.c"
				}
#line 771 "../src/Views/CollectionPage.vala"
				_tmp99_ = _view_list;
#line 771 "../src/Views/CollectionPage.vala"
				_tmp100_ = gee_abstract_list_get ((GeeAbstractList*) _tmp99_, _view_index);
#line 771 "../src/Views/CollectionPage.vala"
				view = (DataView*) _tmp100_;
#line 772 "../src/Views/CollectionPage.vala"
				_tmp101_ = view;
#line 772 "../src/Views/CollectionPage.vala"
				_tmp102_ = data_view_get_source (_tmp101_);
#line 772 "../src/Views/CollectionPage.vala"
				_tmp103_ = _tmp102_;
#line 772 "../src/Views/CollectionPage.vala"
				_tmp104_ = _g_object_ref0 (IS_PHOTO (_tmp103_) ? ((Photo*) _tmp103_) : NULL);
#line 772 "../src/Views/CollectionPage.vala"
				photo = _tmp104_;
#line 773 "../src/Views/CollectionPage.vala"
				_tmp105_ = photo;
#line 773 "../src/Views/CollectionPage.vala"
				photo_set_enhanced (_tmp105_, TRUE);
#line 771 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (photo);
#line 771 "../src/Views/CollectionPage.vala"
				_g_object_unref0 (view);
#line 6333 "CollectionPage.c"
			}
		}
#line 749 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (cmd);
#line 6338 "CollectionPage.c"
	}
#line 776 "../src/Views/CollectionPage.vala"
	collection_page_update_enhance_toggled (self);
#line 728 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (enhanced_list);
#line 728 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (unenhanced_list);
#line 6346 "CollectionPage.c"
}

static void
collection_page_on_duplicate_photo (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	DuplicateMultiplePhotosCommand* command = NULL;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	DuplicateMultiplePhotosCommand* _tmp7_;
	DuplicateMultiplePhotosCommand* _tmp8_;
	CommandManager* _tmp9_;
	CommandManager* _tmp10_;
	DuplicateMultiplePhotosCommand* _tmp11_;
#line 779 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 780 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 780 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 780 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 780 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 780 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 781 "../src/Views/CollectionPage.vala"
		return;
#line 6379 "CollectionPage.c"
	}
#line 783 "../src/Views/CollectionPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 783 "../src/Views/CollectionPage.vala"
	_tmp4_ = _tmp3_;
#line 783 "../src/Views/CollectionPage.vala"
	_tmp5_ = view_collection_get_selected (_tmp4_);
#line 783 "../src/Views/CollectionPage.vala"
	_tmp6_ = _tmp5_;
#line 783 "../src/Views/CollectionPage.vala"
	_tmp7_ = duplicate_multiple_photos_command_new ((GeeIterable*) _tmp6_);
#line 783 "../src/Views/CollectionPage.vala"
	_tmp8_ = _tmp7_;
#line 783 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp6_);
#line 783 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 783 "../src/Views/CollectionPage.vala"
	command = _tmp8_;
#line 785 "../src/Views/CollectionPage.vala"
	_tmp9_ = page_get_command_manager ((Page*) self);
#line 785 "../src/Views/CollectionPage.vala"
	_tmp10_ = _tmp9_;
#line 785 "../src/Views/CollectionPage.vala"
	_tmp11_ = command;
#line 785 "../src/Views/CollectionPage.vala"
	command_manager_execute (_tmp10_, (Command*) _tmp11_);
#line 785 "../src/Views/CollectionPage.vala"
	_command_manager_unref0 (_tmp10_);
#line 779 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (command);
#line 6411 "CollectionPage.c"
}

static void
collection_page_on_adjust_date_time (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	gboolean selected_has_videos = FALSE;
	gboolean only_videos_selected = FALSE;
	Dateable* photo_source = NULL;
	ViewCollection* _tmp17_;
	ViewCollection* _tmp18_;
	DataView* _tmp19_;
	DataView* _tmp20_;
	DataSource* _tmp21_;
	DataSource* _tmp22_;
	Dateable* _tmp23_;
	Dateable* _tmp24_;
	AdjustDateTimeDialog* dialog = NULL;
	Dateable* _tmp25_;
	ViewCollection* _tmp26_;
	ViewCollection* _tmp27_;
	AdjustDateTimeDialog* _tmp28_;
	AdjustDateTimeDialog* _tmp29_;
	gint64 time_shift = 0LL;
	gboolean keep_relativity = FALSE;
	gboolean modify_originals = FALSE;
	AdjustDateTimeDialog* _tmp30_;
	gint64 _tmp31_ = 0LL;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_;
#line 788 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 789 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 789 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 789 "../src/Views/CollectionPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 789 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 789 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 790 "../src/Views/CollectionPage.vala"
		return;
#line 6459 "CollectionPage.c"
	}
#line 792 "../src/Views/CollectionPage.vala"
	selected_has_videos = FALSE;
#line 793 "../src/Views/CollectionPage.vala"
	only_videos_selected = TRUE;
#line 6465 "CollectionPage.c"
	{
		GeeList* _dv_list = NULL;
		ViewCollection* _tmp3_;
		ViewCollection* _tmp4_;
		GeeList* _tmp5_;
		GeeList* _tmp6_;
		gint _dv_size = 0;
		GeeList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _dv_index = 0;
#line 795 "../src/Views/CollectionPage.vala"
		_tmp3_ = page_get_view ((Page*) self);
#line 795 "../src/Views/CollectionPage.vala"
		_tmp4_ = _tmp3_;
#line 795 "../src/Views/CollectionPage.vala"
		_tmp5_ = view_collection_get_selected (_tmp4_);
#line 795 "../src/Views/CollectionPage.vala"
		_tmp6_ = _tmp5_;
#line 795 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp4_);
#line 795 "../src/Views/CollectionPage.vala"
		_dv_list = _tmp6_;
#line 795 "../src/Views/CollectionPage.vala"
		_tmp7_ = _dv_list;
#line 795 "../src/Views/CollectionPage.vala"
		_tmp8_ = gee_collection_get_size ((GeeCollection*) _tmp7_);
#line 795 "../src/Views/CollectionPage.vala"
		_tmp9_ = _tmp8_;
#line 795 "../src/Views/CollectionPage.vala"
		_dv_size = _tmp9_;
#line 795 "../src/Views/CollectionPage.vala"
		_dv_index = -1;
#line 795 "../src/Views/CollectionPage.vala"
		while (TRUE) {
#line 6501 "CollectionPage.c"
			gint _tmp10_;
			gint _tmp11_;
			DataView* dv = NULL;
			GeeList* _tmp12_;
			gpointer _tmp13_;
			DataView* _tmp14_;
			DataSource* _tmp15_;
			DataSource* _tmp16_;
#line 795 "../src/Views/CollectionPage.vala"
			_dv_index = _dv_index + 1;
#line 795 "../src/Views/CollectionPage.vala"
			_tmp10_ = _dv_index;
#line 795 "../src/Views/CollectionPage.vala"
			_tmp11_ = _dv_size;
#line 795 "../src/Views/CollectionPage.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 795 "../src/Views/CollectionPage.vala"
				break;
#line 6520 "CollectionPage.c"
			}
#line 795 "../src/Views/CollectionPage.vala"
			_tmp12_ = _dv_list;
#line 795 "../src/Views/CollectionPage.vala"
			_tmp13_ = gee_list_get (_tmp12_, _dv_index);
#line 795 "../src/Views/CollectionPage.vala"
			dv = (DataView*) _tmp13_;
#line 796 "../src/Views/CollectionPage.vala"
			_tmp14_ = dv;
#line 796 "../src/Views/CollectionPage.vala"
			_tmp15_ = data_view_get_source (_tmp14_);
#line 796 "../src/Views/CollectionPage.vala"
			_tmp16_ = _tmp15_;
#line 796 "../src/Views/CollectionPage.vala"
			if (IS_VIDEO (_tmp16_)) {
#line 797 "../src/Views/CollectionPage.vala"
				selected_has_videos = TRUE;
#line 6538 "CollectionPage.c"
			} else {
#line 799 "../src/Views/CollectionPage.vala"
				only_videos_selected = FALSE;
#line 6542 "CollectionPage.c"
			}
#line 795 "../src/Views/CollectionPage.vala"
			_g_object_unref0 (dv);
#line 6546 "CollectionPage.c"
		}
#line 795 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_dv_list);
#line 6550 "CollectionPage.c"
	}
#line 802 "../src/Views/CollectionPage.vala"
	_tmp17_ = page_get_view ((Page*) self);
#line 802 "../src/Views/CollectionPage.vala"
	_tmp18_ = _tmp17_;
#line 802 "../src/Views/CollectionPage.vala"
	_tmp19_ = view_collection_get_selected_at (_tmp18_, 0);
#line 802 "../src/Views/CollectionPage.vala"
	_tmp20_ = _tmp19_;
#line 802 "../src/Views/CollectionPage.vala"
	_tmp21_ = data_view_get_source (_tmp20_);
#line 802 "../src/Views/CollectionPage.vala"
	_tmp22_ = _tmp21_;
#line 802 "../src/Views/CollectionPage.vala"
	_tmp23_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_DATEABLE, Dateable));
#line 802 "../src/Views/CollectionPage.vala"
	_tmp24_ = _tmp23_;
#line 802 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp20_);
#line 802 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp18_);
#line 802 "../src/Views/CollectionPage.vala"
	photo_source = _tmp24_;
#line 804 "../src/Views/CollectionPage.vala"
	_tmp25_ = photo_source;
#line 804 "../src/Views/CollectionPage.vala"
	_tmp26_ = page_get_view ((Page*) self);
#line 804 "../src/Views/CollectionPage.vala"
	_tmp27_ = _tmp26_;
#line 804 "../src/Views/CollectionPage.vala"
	_tmp28_ = adjust_date_time_dialog_new (_tmp25_, view_collection_get_selected_count (_tmp27_), TRUE, selected_has_videos, only_videos_selected);
#line 804 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp28_);
#line 804 "../src/Views/CollectionPage.vala"
	_tmp29_ = _tmp28_;
#line 804 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp27_);
#line 804 "../src/Views/CollectionPage.vala"
	dialog = _tmp29_;
#line 809 "../src/Views/CollectionPage.vala"
	_tmp30_ = dialog;
#line 809 "../src/Views/CollectionPage.vala"
	_tmp34_ = adjust_date_time_dialog_execute (_tmp30_, &_tmp31_, &_tmp32_, &_tmp33_);
#line 809 "../src/Views/CollectionPage.vala"
	time_shift = _tmp31_;
#line 809 "../src/Views/CollectionPage.vala"
	keep_relativity = _tmp32_;
#line 809 "../src/Views/CollectionPage.vala"
	modify_originals = _tmp33_;
#line 809 "../src/Views/CollectionPage.vala"
	if (_tmp34_) {
#line 6602 "CollectionPage.c"
		AdjustDateTimePhotosCommand* command = NULL;
		ViewCollection* _tmp35_;
		ViewCollection* _tmp36_;
		GeeList* _tmp37_;
		GeeList* _tmp38_;
		AdjustDateTimePhotosCommand* _tmp39_;
		AdjustDateTimePhotosCommand* _tmp40_;
		CommandManager* _tmp41_;
		CommandManager* _tmp42_;
		AdjustDateTimePhotosCommand* _tmp43_;
#line 810 "../src/Views/CollectionPage.vala"
		_tmp35_ = page_get_view ((Page*) self);
#line 810 "../src/Views/CollectionPage.vala"
		_tmp36_ = _tmp35_;
#line 810 "../src/Views/CollectionPage.vala"
		_tmp37_ = view_collection_get_selected (_tmp36_);
#line 810 "../src/Views/CollectionPage.vala"
		_tmp38_ = _tmp37_;
#line 810 "../src/Views/CollectionPage.vala"
		_tmp39_ = adjust_date_time_photos_command_new ((GeeIterable*) _tmp38_, time_shift, keep_relativity, modify_originals);
#line 810 "../src/Views/CollectionPage.vala"
		_tmp40_ = _tmp39_;
#line 810 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp38_);
#line 810 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp36_);
#line 810 "../src/Views/CollectionPage.vala"
		command = _tmp40_;
#line 812 "../src/Views/CollectionPage.vala"
		_tmp41_ = page_get_command_manager ((Page*) self);
#line 812 "../src/Views/CollectionPage.vala"
		_tmp42_ = _tmp41_;
#line 812 "../src/Views/CollectionPage.vala"
		_tmp43_ = command;
#line 812 "../src/Views/CollectionPage.vala"
		command_manager_execute (_tmp42_, (Command*) _tmp43_);
#line 812 "../src/Views/CollectionPage.vala"
		_command_manager_unref0 (_tmp42_);
#line 809 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (command);
#line 6643 "CollectionPage.c"
	}
#line 788 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (dialog);
#line 788 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (photo_source);
#line 6649 "CollectionPage.c"
}

static void
collection_page_on_slideshow (CollectionPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	GeeList* _tmp3_ = NULL;
	ViewCollection* _tmp4_;
	ViewCollection* _tmp5_;
	gboolean _tmp6_;
	GeeList* sources = NULL;
	GeeList* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GeeList* _tmp15_;
	Thumbnail* thumbnail = NULL;
	ViewCollection* _tmp19_;
	ViewCollection* _tmp20_;
	GeeList* _tmp21_;
	gpointer _tmp22_;
	DataSource* _tmp23_;
	DataView* _tmp24_;
	Thumbnail* _tmp25_;
	Thumbnail* _tmp26_;
	LibraryPhoto* photo = NULL;
	Thumbnail* _tmp27_;
	MediaSource* _tmp28_;
	LibraryPhoto* _tmp29_;
	LibraryPhoto* _tmp30_;
	AppWindow* _tmp31_;
	AppWindow* _tmp32_;
	LibraryPhotoSourceCollection* _tmp33_;
	ViewCollection* _tmp34_;
	ViewCollection* _tmp35_;
	LibraryPhoto* _tmp36_;
	SlideshowPage* _tmp37_;
	SlideshowPage* _tmp38_;
#line 816 "../src/Views/CollectionPage.vala"
	g_return_if_fail (self != NULL);
#line 817 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 817 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 817 "../src/Views/CollectionPage.vala"
	_tmp2_ = data_collection_get_count ((DataCollection*) _tmp1_) == 0;
#line 817 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 817 "../src/Views/CollectionPage.vala"
	if (_tmp2_) {
#line 818 "../src/Views/CollectionPage.vala"
		return;
#line 6702 "CollectionPage.c"
	}
#line 821 "../src/Views/CollectionPage.vala"
	_tmp4_ = page_get_view ((Page*) self);
#line 821 "../src/Views/CollectionPage.vala"
	_tmp5_ = _tmp4_;
#line 821 "../src/Views/CollectionPage.vala"
	_tmp6_ = view_collection_get_selected_count (_tmp5_) > 0;
#line 821 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp5_);
#line 821 "../src/Views/CollectionPage.vala"
	if (_tmp6_) {
#line 6714 "CollectionPage.c"
		ViewCollection* _tmp7_;
		ViewCollection* _tmp8_;
		GeeList* _tmp9_;
#line 822 "../src/Views/CollectionPage.vala"
		_tmp7_ = page_get_view ((Page*) self);
#line 822 "../src/Views/CollectionPage.vala"
		_tmp8_ = _tmp7_;
#line 822 "../src/Views/CollectionPage.vala"
		_tmp9_ = view_collection_get_selected_sources_of_type (_tmp8_, TYPE_LIBRARY_PHOTO);
#line 822 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp3_);
#line 822 "../src/Views/CollectionPage.vala"
		_tmp3_ = _tmp9_;
#line 822 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp8_);
#line 6730 "CollectionPage.c"
	} else {
		ViewCollection* _tmp10_;
		ViewCollection* _tmp11_;
		GeeList* _tmp12_;
#line 823 "../src/Views/CollectionPage.vala"
		_tmp10_ = page_get_view ((Page*) self);
#line 823 "../src/Views/CollectionPage.vala"
		_tmp11_ = _tmp10_;
#line 823 "../src/Views/CollectionPage.vala"
		_tmp12_ = view_collection_get_sources_of_type (_tmp11_, TYPE_LIBRARY_PHOTO);
#line 823 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp3_);
#line 823 "../src/Views/CollectionPage.vala"
		_tmp3_ = _tmp12_;
#line 823 "../src/Views/CollectionPage.vala"
		_data_collection_unref0 (_tmp11_);
#line 6747 "CollectionPage.c"
	}
#line 821 "../src/Views/CollectionPage.vala"
	_tmp13_ = _g_object_ref0 (_tmp3_);
#line 821 "../src/Views/CollectionPage.vala"
	sources = _tmp13_;
#line 824 "../src/Views/CollectionPage.vala"
	_tmp15_ = sources;
#line 824 "../src/Views/CollectionPage.vala"
	if (_tmp15_ == NULL) {
#line 824 "../src/Views/CollectionPage.vala"
		_tmp14_ = TRUE;
#line 6759 "CollectionPage.c"
	} else {
		GeeList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 824 "../src/Views/CollectionPage.vala"
		_tmp16_ = sources;
#line 824 "../src/Views/CollectionPage.vala"
		_tmp17_ = gee_collection_get_size ((GeeCollection*) _tmp16_);
#line 824 "../src/Views/CollectionPage.vala"
		_tmp18_ = _tmp17_;
#line 824 "../src/Views/CollectionPage.vala"
		_tmp14_ = _tmp18_ == 0;
#line 6772 "CollectionPage.c"
	}
#line 824 "../src/Views/CollectionPage.vala"
	if (_tmp14_) {
#line 825 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (sources);
#line 825 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp3_);
#line 825 "../src/Views/CollectionPage.vala"
		return;
#line 6782 "CollectionPage.c"
	}
#line 827 "../src/Views/CollectionPage.vala"
	_tmp19_ = page_get_view ((Page*) self);
#line 827 "../src/Views/CollectionPage.vala"
	_tmp20_ = _tmp19_;
#line 827 "../src/Views/CollectionPage.vala"
	_tmp21_ = sources;
#line 827 "../src/Views/CollectionPage.vala"
	_tmp22_ = gee_list_get (_tmp21_, 0);
#line 827 "../src/Views/CollectionPage.vala"
	_tmp23_ = (DataSource*) _tmp22_;
#line 827 "../src/Views/CollectionPage.vala"
	_tmp24_ = view_collection_get_view_for_source (_tmp20_, _tmp23_);
#line 827 "../src/Views/CollectionPage.vala"
	_tmp25_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_THUMBNAIL, Thumbnail);
#line 827 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp23_);
#line 827 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp20_);
#line 827 "../src/Views/CollectionPage.vala"
	thumbnail = _tmp25_;
#line 828 "../src/Views/CollectionPage.vala"
	_tmp26_ = thumbnail;
#line 828 "../src/Views/CollectionPage.vala"
	if (_tmp26_ == NULL) {
#line 829 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (thumbnail);
#line 829 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (sources);
#line 829 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp3_);
#line 829 "../src/Views/CollectionPage.vala"
		return;
#line 6816 "CollectionPage.c"
	}
#line 831 "../src/Views/CollectionPage.vala"
	_tmp27_ = thumbnail;
#line 831 "../src/Views/CollectionPage.vala"
	_tmp28_ = thumbnail_get_media_source (_tmp27_);
#line 831 "../src/Views/CollectionPage.vala"
	_tmp29_ = IS_LIBRARY_PHOTO (_tmp28_) ? ((LibraryPhoto*) _tmp28_) : NULL;
#line 831 "../src/Views/CollectionPage.vala"
	if (_tmp29_ == NULL) {
#line 831 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp28_);
#line 6828 "CollectionPage.c"
	}
#line 831 "../src/Views/CollectionPage.vala"
	photo = _tmp29_;
#line 832 "../src/Views/CollectionPage.vala"
	_tmp30_ = photo;
#line 832 "../src/Views/CollectionPage.vala"
	if (_tmp30_ == NULL) {
#line 833 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (photo);
#line 833 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (thumbnail);
#line 833 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (sources);
#line 833 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp3_);
#line 833 "../src/Views/CollectionPage.vala"
		return;
#line 6846 "CollectionPage.c"
	}
#line 835 "../src/Views/CollectionPage.vala"
	_tmp31_ = app_window_get_instance ();
#line 835 "../src/Views/CollectionPage.vala"
	_tmp32_ = _tmp31_;
#line 835 "../src/Views/CollectionPage.vala"
	_tmp33_ = library_photo_global;
#line 835 "../src/Views/CollectionPage.vala"
	_tmp34_ = page_get_view ((Page*) self);
#line 835 "../src/Views/CollectionPage.vala"
	_tmp35_ = _tmp34_;
#line 835 "../src/Views/CollectionPage.vala"
	_tmp36_ = photo;
#line 835 "../src/Views/CollectionPage.vala"
	_tmp37_ = slideshow_page_new ((SourceCollection*) _tmp33_, _tmp35_, (Photo*) _tmp36_);
#line 835 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp37_);
#line 835 "../src/Views/CollectionPage.vala"
	_tmp38_ = _tmp37_;
#line 835 "../src/Views/CollectionPage.vala"
	app_window_go_fullscreen (_tmp32_, (Page*) _tmp38_);
#line 835 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp38_);
#line 835 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp35_);
#line 835 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp32_);
#line 816 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (photo);
#line 816 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (thumbnail);
#line 816 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (sources);
#line 816 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp3_);
#line 6882 "CollectionPage.c"
}

static void
_collection_page_on_flip_vertically_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 845 "../src/Views/CollectionPage.vala"
	collection_page_on_flip_vertically ((CollectionPage*) self);
#line 6891 "CollectionPage.c"
}

static void
_collection_page_on_rotate_counterclockwise_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
#line 847 "../src/Views/CollectionPage.vala"
	collection_page_on_rotate_counterclockwise ((CollectionPage*) self);
#line 6900 "CollectionPage.c"
}

static gboolean
collection_page_real_on_ctrl_pressed (Page* base,
                                      GdkEventKey* event)
{
	CollectionPage * self;
	GtkButton* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	guint _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	guint _tmp12_;
	GtkButton* _tmp13_;
	gboolean result;
#line 839 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 840 "../src/Views/CollectionPage.vala"
	_tmp0_ = self->priv->flip_button;
#line 840 "../src/Views/CollectionPage.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (RESOURCES_VFLIP, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 840 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp1_);
#line 840 "../src/Views/CollectionPage.vala"
	_tmp2_ = _tmp1_;
#line 840 "../src/Views/CollectionPage.vala"
	gtk_button_set_image (_tmp0_, (GtkWidget*) _tmp2_);
#line 840 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp2_);
#line 841 "../src/Views/CollectionPage.vala"
	_tmp3_ = self->priv->flip_button;
#line 841 "../src/Views/CollectionPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, RESOURCES_VFLIP_TOOLTIP);
#line 842 "../src/Views/CollectionPage.vala"
	_tmp4_ = self->priv->rotate_button;
#line 842 "../src/Views/CollectionPage.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (RESOURCES_COUNTERCLOCKWISE, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 842 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp5_);
#line 842 "../src/Views/CollectionPage.vala"
	_tmp6_ = _tmp5_;
#line 842 "../src/Views/CollectionPage.vala"
	gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp6_);
#line 842 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp6_);
#line 843 "../src/Views/CollectionPage.vala"
	_tmp7_ = self->priv->rotate_button;
#line 843 "../src/Views/CollectionPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, RESOURCES_ROTATE_CCW_TOOLTIP);
#line 844 "../src/Views/CollectionPage.vala"
	_tmp8_ = self->priv->flip_button;
#line 844 "../src/Views/CollectionPage.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp9_, NULL, FALSE);
#line 844 "../src/Views/CollectionPage.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _collection_page_on_flip_horizontally_gtk_button_clicked, self);
#line 845 "../src/Views/CollectionPage.vala"
	_tmp10_ = self->priv->flip_button;
#line 845 "../src/Views/CollectionPage.vala"
	g_signal_connect_object (_tmp10_, "clicked", (GCallback) _collection_page_on_flip_vertically_gtk_button_clicked, self, 0);
#line 846 "../src/Views/CollectionPage.vala"
	_tmp11_ = self->priv->rotate_button;
#line 846 "../src/Views/CollectionPage.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp12_, NULL, FALSE);
#line 846 "../src/Views/CollectionPage.vala"
	g_signal_handlers_disconnect_matched (_tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _collection_page_on_rotate_clockwise_gtk_button_clicked, self);
#line 847 "../src/Views/CollectionPage.vala"
	_tmp13_ = self->priv->rotate_button;
#line 847 "../src/Views/CollectionPage.vala"
	g_signal_connect_object (_tmp13_, "clicked", (GCallback) _collection_page_on_rotate_counterclockwise_gtk_button_clicked, self, 0);
#line 849 "../src/Views/CollectionPage.vala"
	result = PAGE_CLASS (collection_page_parent_class)->on_ctrl_pressed ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_PAGE, MediaPage), event);
#line 849 "../src/Views/CollectionPage.vala"
	return result;
#line 6981 "CollectionPage.c"
}

static gboolean
collection_page_real_on_ctrl_released (Page* base,
                                       GdkEventKey* event)
{
	CollectionPage * self;
	GtkButton* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	guint _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	guint _tmp12_;
	GtkButton* _tmp13_;
	gboolean result;
#line 852 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 853 "../src/Views/CollectionPage.vala"
	_tmp0_ = self->priv->flip_button;
#line 853 "../src/Views/CollectionPage.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (RESOURCES_HFLIP, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 853 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp1_);
#line 853 "../src/Views/CollectionPage.vala"
	_tmp2_ = _tmp1_;
#line 853 "../src/Views/CollectionPage.vala"
	gtk_button_set_image (_tmp0_, (GtkWidget*) _tmp2_);
#line 853 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp2_);
#line 854 "../src/Views/CollectionPage.vala"
	_tmp3_ = self->priv->flip_button;
#line 854 "../src/Views/CollectionPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, RESOURCES_HFLIP_TOOLTIP);
#line 855 "../src/Views/CollectionPage.vala"
	_tmp4_ = self->priv->rotate_button;
#line 855 "../src/Views/CollectionPage.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (RESOURCES_CLOCKWISE, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 855 "../src/Views/CollectionPage.vala"
	g_object_ref_sink (_tmp5_);
#line 855 "../src/Views/CollectionPage.vala"
	_tmp6_ = _tmp5_;
#line 855 "../src/Views/CollectionPage.vala"
	gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp6_);
#line 855 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (_tmp6_);
#line 856 "../src/Views/CollectionPage.vala"
	_tmp7_ = self->priv->rotate_button;
#line 856 "../src/Views/CollectionPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, RESOURCES_ROTATE_CW_TOOLTIP);
#line 857 "../src/Views/CollectionPage.vala"
	_tmp8_ = self->priv->flip_button;
#line 857 "../src/Views/CollectionPage.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp9_, NULL, FALSE);
#line 857 "../src/Views/CollectionPage.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _collection_page_on_flip_vertically_gtk_button_clicked, self);
#line 858 "../src/Views/CollectionPage.vala"
	_tmp10_ = self->priv->flip_button;
#line 858 "../src/Views/CollectionPage.vala"
	g_signal_connect_object (_tmp10_, "clicked", (GCallback) _collection_page_on_flip_horizontally_gtk_button_clicked, self, 0);
#line 859 "../src/Views/CollectionPage.vala"
	_tmp11_ = self->priv->rotate_button;
#line 859 "../src/Views/CollectionPage.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp12_, NULL, FALSE);
#line 859 "../src/Views/CollectionPage.vala"
	g_signal_handlers_disconnect_matched (_tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _collection_page_on_rotate_counterclockwise_gtk_button_clicked, self);
#line 860 "../src/Views/CollectionPage.vala"
	_tmp13_ = self->priv->rotate_button;
#line 860 "../src/Views/CollectionPage.vala"
	g_signal_connect_object (_tmp13_, "clicked", (GCallback) _collection_page_on_rotate_clockwise_gtk_button_clicked, self, 0);
#line 862 "../src/Views/CollectionPage.vala"
	result = PAGE_CLASS (collection_page_parent_class)->on_ctrl_released ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_PAGE, MediaPage), event);
#line 862 "../src/Views/CollectionPage.vala"
	return result;
#line 7062 "CollectionPage.c"
}

static gchar*
collection_page_real_get_view_empty_message (CheckerboardPage* base)
{
	CollectionPage * self;
	LibraryWindow* window = NULL;
	AppWindow* _tmp0_;
	LibraryWindow* _tmp1_;
	LibraryWindow* _tmp2_;
	LibraryWindow* _tmp3_;
	gchar* _tmp5_;
	gchar* result;
#line 865 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 866 "../src/Views/CollectionPage.vala"
	_tmp0_ = app_window_get_instance ();
#line 866 "../src/Views/CollectionPage.vala"
	_tmp1_ = IS_LIBRARY_WINDOW (_tmp0_) ? ((LibraryWindow*) _tmp0_) : NULL;
#line 866 "../src/Views/CollectionPage.vala"
	if (_tmp1_ == NULL) {
#line 866 "../src/Views/CollectionPage.vala"
		_g_object_unref0 (_tmp0_);
#line 7086 "CollectionPage.c"
	}
#line 866 "../src/Views/CollectionPage.vala"
	window = _tmp1_;
#line 867 "../src/Views/CollectionPage.vala"
	_tmp2_ = window;
#line 867 "../src/Views/CollectionPage.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 868 "../src/Views/CollectionPage.vala"
	_tmp3_ = window;
#line 868 "../src/Views/CollectionPage.vala"
	if (_tmp3_ != NULL) {
#line 7098 "CollectionPage.c"
		LibraryWindow* _tmp4_;
#line 869 "../src/Views/CollectionPage.vala"
		_tmp4_ = window;
#line 869 "../src/Views/CollectionPage.vala"
		library_window_toggle_welcome_page (_tmp4_, TRUE, "", _ ("No photos/videos"), FALSE);
#line 7104 "CollectionPage.c"
	}
#line 870 "../src/Views/CollectionPage.vala"
	_tmp5_ = g_strdup (_ ("No photos/videos"));
#line 870 "../src/Views/CollectionPage.vala"
	result = _tmp5_;
#line 870 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (window);
#line 870 "../src/Views/CollectionPage.vala"
	return result;
#line 7114 "CollectionPage.c"
}

static gpointer
_view_filter_ref0 (gpointer self)
{
#line 874 "../src/Views/CollectionPage.vala"
	return self ? view_filter_ref (self) : NULL;
#line 7122 "CollectionPage.c"
}

static SearchViewFilter*
collection_page_real_get_search_view_filter (CheckerboardPage* base)
{
	CollectionPage * self;
	CollectionPageCollectionSearchViewFilter* _tmp0_;
	SearchViewFilter* _tmp1_;
	SearchViewFilter* result;
#line 873 "../src/Views/CollectionPage.vala"
	self = (CollectionPage*) base;
#line 874 "../src/Views/CollectionPage.vala"
	_tmp0_ = self->priv->search_filter;
#line 874 "../src/Views/CollectionPage.vala"
	_tmp1_ = _view_filter_ref0 ((SearchViewFilter*) _tmp0_);
#line 874 "../src/Views/CollectionPage.vala"
	result = _tmp1_;
#line 874 "../src/Views/CollectionPage.vala"
	return result;
#line 7142 "CollectionPage.c"
}

static guint
collection_page_collection_search_view_filter_real_get_criteria (SearchViewFilter* base)
{
	CollectionPageCollectionSearchViewFilter * self;
	guint result;
#line 37 "../src/Views/CollectionPage.vala"
	self = (CollectionPageCollectionSearchViewFilter*) base;
#line 38 "../src/Views/CollectionPage.vala"
	result = (guint) ((SEARCH_FILTER_CRITERIA_TEXT | SEARCH_FILTER_CRITERIA_FLAG) | SEARCH_FILTER_CRITERIA_MEDIA);
#line 38 "../src/Views/CollectionPage.vala"
	return result;
#line 7156 "CollectionPage.c"
}

CollectionPageCollectionSearchViewFilter*
collection_page_collection_search_view_filter_construct (GType object_type)
{
	CollectionPageCollectionSearchViewFilter* self = NULL;
#line 36 "../src/Views/CollectionPage.vala"
	self = (CollectionPageCollectionSearchViewFilter*) default_search_view_filter_construct (object_type);
#line 36 "../src/Views/CollectionPage.vala"
	return self;
#line 7167 "CollectionPage.c"
}

CollectionPageCollectionSearchViewFilter*
collection_page_collection_search_view_filter_new (void)
{
#line 36 "../src/Views/CollectionPage.vala"
	return collection_page_collection_search_view_filter_construct (COLLECTION_PAGE_TYPE_COLLECTION_SEARCH_VIEW_FILTER);
#line 7175 "CollectionPage.c"
}

static void
collection_page_collection_search_view_filter_class_init (CollectionPageCollectionSearchViewFilterClass * klass,
                                                          gpointer klass_data)
{
#line 36 "../src/Views/CollectionPage.vala"
	collection_page_collection_search_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/Views/CollectionPage.vala"
	((SearchViewFilterClass *) klass)->get_criteria = (guint (*) (SearchViewFilter*)) collection_page_collection_search_view_filter_real_get_criteria;
#line 7186 "CollectionPage.c"
}

static void
collection_page_collection_search_view_filter_instance_init (CollectionPageCollectionSearchViewFilter * self,
                                                             gpointer klass)
{
}

static GType
collection_page_collection_search_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CollectionPageCollectionSearchViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) collection_page_collection_search_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CollectionPageCollectionSearchViewFilter), 0, (GInstanceInitFunc) collection_page_collection_search_view_filter_instance_init, NULL };
	GType collection_page_collection_search_view_filter_type_id;
	collection_page_collection_search_view_filter_type_id = g_type_register_static (TYPE_DEFAULT_SEARCH_VIEW_FILTER, "CollectionPageCollectionSearchViewFilter", &g_define_type_info, 0);
	return collection_page_collection_search_view_filter_type_id;
}

GType
collection_page_collection_search_view_filter_get_type (void)
{
	static volatile gsize collection_page_collection_search_view_filter_type_id__once = 0;
	if (g_once_init_enter (&collection_page_collection_search_view_filter_type_id__once)) {
		GType collection_page_collection_search_view_filter_type_id;
		collection_page_collection_search_view_filter_type_id = collection_page_collection_search_view_filter_get_type_once ();
		g_once_init_leave (&collection_page_collection_search_view_filter_type_id__once, collection_page_collection_search_view_filter_type_id);
	}
	return collection_page_collection_search_view_filter_type_id__once;
}

static void
_collection_page_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                  GeeMap* items,
                                                                  gpointer self)
{
#line 60 "../src/Views/CollectionPage.vala"
	collection_page_on_photos_altered ((CollectionPage*) self, items);
#line 7223 "CollectionPage.c"
}

static GObject *
collection_page_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CollectionPage * self;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
#line 59 "../src/Views/CollectionPage.vala"
	parent_class = G_OBJECT_CLASS (collection_page_parent_class);
#line 59 "../src/Views/CollectionPage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/Views/CollectionPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COLLECTION_PAGE, CollectionPage);
#line 60 "../src/Views/CollectionPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 60 "../src/Views/CollectionPage.vala"
	_tmp1_ = _tmp0_;
#line 60 "../src/Views/CollectionPage.vala"
	g_signal_connect_object ((DataCollection*) _tmp1_, "items-altered", (GCallback) _collection_page_on_photos_altered_data_collection_items_altered, self, 0);
#line 60 "../src/Views/CollectionPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 62 "../src/Views/CollectionPage.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 59 "../src/Views/CollectionPage.vala"
	return obj;
#line 7254 "CollectionPage.c"
}

static void
collection_page_class_init (CollectionPageClass * klass,
                            gpointer klass_data)
{
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	GtkClipboard* _tmp2_;
#line 20 "../src/Views/CollectionPage.vala"
	collection_page_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Views/CollectionPage.vala"
	g_type_class_adjust_private_offset (klass, &CollectionPage_private_offset);
#line 20 "../src/Views/CollectionPage.vala"
	((PageClass *) klass)->add_toolbar_widgets = (void (*) (Page*, GtkActionBar*)) collection_page_real_add_toolbar_widgets;
#line 20 "../src/Views/CollectionPage.vala"
	((CheckerboardPageClass *) klass)->get_item_context_menu = (GtkMenu* (*) (CheckerboardPage*)) collection_page_real_get_item_context_menu;
#line 20 "../src/Views/CollectionPage.vala"
	((PageClass *) klass)->init_collect_action_entries = (GtkActionEntry* (*) (Page*, gint*)) collection_page_real_init_collect_action_entries;
#line 20 "../src/Views/CollectionPage.vala"
	((PageClass *) klass)->init_actions = (void (*) (Page*, gint, gint)) collection_page_real_init_actions;
#line 20 "../src/Views/CollectionPage.vala"
	((PageClass *) klass)->update_actions = (void (*) (Page*, gint, gint)) collection_page_real_update_actions;
#line 20 "../src/Views/CollectionPage.vala"
	((CheckerboardPageClass *) klass)->on_item_activated = (void (*) (CheckerboardPage*, CheckerboardItem*)) collection_page_real_on_item_activated;
#line 20 "../src/Views/CollectionPage.vala"
	((PageClass *) klass)->on_app_key_pressed = (gboolean (*) (Page*, GdkEventKey*)) collection_page_real_on_app_key_pressed;
#line 20 "../src/Views/CollectionPage.vala"
	((MediaPageClass *) klass)->on_export = (void (*) (MediaPage*)) collection_page_real_on_export;
#line 20 "../src/Views/CollectionPage.vala"
	((PageClass *) klass)->on_ctrl_pressed = (gboolean (*) (Page*, GdkEventKey*)) collection_page_real_on_ctrl_pressed;
#line 20 "../src/Views/CollectionPage.vala"
	((PageClass *) klass)->on_ctrl_released = (gboolean (*) (Page*, GdkEventKey*)) collection_page_real_on_ctrl_released;
#line 20 "../src/Views/CollectionPage.vala"
	((CheckerboardPageClass *) klass)->get_view_empty_message = (gchar* (*) (CheckerboardPage*)) collection_page_real_get_view_empty_message;
#line 20 "../src/Views/CollectionPage.vala"
	((CheckerboardPageClass *) klass)->get_search_view_filter = (SearchViewFilter* (*) (CheckerboardPage*)) collection_page_real_get_search_view_filter;
#line 20 "../src/Views/CollectionPage.vala"
	G_OBJECT_CLASS (klass)->constructor = collection_page_constructor;
#line 20 "../src/Views/CollectionPage.vala"
	G_OBJECT_CLASS (klass)->finalize = collection_page_finalize;
#line 56 "../src/Views/CollectionPage.vala"
	_tmp0_ = gdk_display_get_default ();
#line 56 "../src/Views/CollectionPage.vala"
	_tmp1_ = gtk_clipboard_get_for_display (_tmp0_, GDK_SELECTION_CLIPBOARD);
#line 56 "../src/Views/CollectionPage.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 56 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (collection_page_clipboard);
#line 56 "../src/Views/CollectionPage.vala"
	collection_page_clipboard = _tmp2_;
#line 7306 "CollectionPage.c"
}

static void
collection_page_instance_init (CollectionPage * self,
                               gpointer klass)
{
	CollectionPageCollectionSearchViewFilter* _tmp0_;
#line 20 "../src/Views/CollectionPage.vala"
	self->priv = collection_page_get_instance_private (self);
#line 43 "../src/Views/CollectionPage.vala"
	self->priv->exporter = NULL;
#line 44 "../src/Views/CollectionPage.vala"
	_tmp0_ = collection_page_collection_search_view_filter_new ();
#line 44 "../src/Views/CollectionPage.vala"
	self->priv->search_filter = _tmp0_;
#line 45 "../src/Views/CollectionPage.vala"
	self->priv->enhance_button = NULL;
#line 7324 "CollectionPage.c"
}

static void
collection_page_finalize (GObject * obj)
{
	CollectionPage * self;
#line 20 "../src/Views/CollectionPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COLLECTION_PAGE, CollectionPage);
#line 43 "../src/Views/CollectionPage.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 44 "../src/Views/CollectionPage.vala"
	_view_filter_unref0 (self->priv->search_filter);
#line 45 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (self->priv->enhance_button);
#line 46 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (self->priv->item_context_menu);
#line 47 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (self->priv->contractor_menu);
#line 48 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (self->priv->rotate_button);
#line 49 "../src/Views/CollectionPage.vala"
	_g_object_unref0 (self->priv->flip_button);
#line 20 "../src/Views/CollectionPage.vala"
	G_OBJECT_CLASS (collection_page_parent_class)->finalize (obj);
#line 7349 "CollectionPage.c"
}

static GType
collection_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CollectionPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) collection_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CollectionPage), 0, (GInstanceInitFunc) collection_page_instance_init, NULL };
	GType collection_page_type_id;
	collection_page_type_id = g_type_register_static (TYPE_MEDIA_PAGE, "CollectionPage", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	CollectionPage_private_offset = g_type_add_instance_private (collection_page_type_id, sizeof (CollectionPagePrivate));
	return collection_page_type_id;
}

GType
collection_page_get_type (void)
{
	static volatile gsize collection_page_type_id__once = 0;
	if (g_once_init_enter (&collection_page_type_id__once)) {
		GType collection_page_type_id;
		collection_page_type_id = collection_page_get_type_once ();
		g_once_init_leave (&collection_page_type_id__once, collection_page_type_id);
	}
	return collection_page_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

