/* ImportPage.c generated by valac 0.56.18, the Vala compiler
 * generated from ImportPage.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2018 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gphoto2/gphoto2-camera.h>
#include <gphoto.h>
#include <gphoto2/gphoto2-result.h>
#include <gphoto2/gphoto2-port-result.h>
#include <gphoto2/gphoto2-context.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gee.h>
#include <gphoto2/gphoto2-abilities-list.h>
#include <granite.h>
#include <gphoto2/gphoto2-list.h>
#include <gphoto2/gphoto2-filesys.h>
#include <float.h>
#include <math.h>

#define PHOTO_IMPORT_SOURCE_INTERP GDK_INTERP_BILINEAR
#define IMPORT_PREVIEW_MAX_SCALE 128
#define IMPORT_PAGE_UNMOUNT_FAILED_MSG _ ("Unable to unmount camera. Try unmounting the camera from the file mana" \
"ger.")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_IMPORT_SOURCE_COLLECTION (import_source_collection_get_type ())
#define IMPORT_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMPORT_SOURCE_COLLECTION, ImportSourceCollection))
#define IMPORT_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMPORT_SOURCE_COLLECTION, ImportSourceCollectionClass))
#define IS_IMPORT_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMPORT_SOURCE_COLLECTION))
#define IS_IMPORT_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMPORT_SOURCE_COLLECTION))
#define IMPORT_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMPORT_SOURCE_COLLECTION, ImportSourceCollectionClass))

typedef struct _ImportSourceCollection ImportSourceCollection;
typedef struct _ImportSourceCollectionClass ImportSourceCollectionClass;
typedef struct _ImportSourceCollectionPrivate ImportSourceCollectionPrivate;

#define TYPE_IMPORT_SOURCE (import_source_get_type ())
#define IMPORT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMPORT_SOURCE, ImportSource))
#define IMPORT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMPORT_SOURCE, ImportSourceClass))
#define IS_IMPORT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMPORT_SOURCE))
#define IS_IMPORT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMPORT_SOURCE))
#define IMPORT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMPORT_SOURCE, ImportSourceClass))

typedef struct _ImportSource ImportSource;
typedef struct _ImportSourceClass ImportSourceClass;
typedef struct _ImportSourcePrivate ImportSourcePrivate;
enum  {
	IMPORT_SOURCE_0_PROPERTY,
	IMPORT_SOURCE_CAMERA_PROPERTY,
	IMPORT_SOURCE_FSID_PROPERTY,
	IMPORT_SOURCE_CAMERA_NAME_PROPERTY,
	IMPORT_SOURCE_FILENAME_PROPERTY,
	IMPORT_SOURCE_FOLDER_PROPERTY,
	IMPORT_SOURCE_FILE_SIZE_PROPERTY,
	IMPORT_SOURCE_NUM_PROPERTIES
};
static GParamSpec* import_source_properties[IMPORT_SOURCE_NUM_PROPERTIES];
#define _gp_camera_unref0(var) ((var == NULL) ? NULL : (var = (gp_camera_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_VIDEO_IMPORT_SOURCE (video_import_source_get_type ())
#define VIDEO_IMPORT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_IMPORT_SOURCE, VideoImportSource))
#define VIDEO_IMPORT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_IMPORT_SOURCE, VideoImportSourceClass))
#define IS_VIDEO_IMPORT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_IMPORT_SOURCE))
#define IS_VIDEO_IMPORT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_IMPORT_SOURCE))
#define VIDEO_IMPORT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_IMPORT_SOURCE, VideoImportSourceClass))

typedef struct _VideoImportSource VideoImportSource;
typedef struct _VideoImportSourceClass VideoImportSourceClass;
typedef struct _VideoImportSourcePrivate VideoImportSourcePrivate;
enum  {
	VIDEO_IMPORT_SOURCE_0_PROPERTY,
	VIDEO_IMPORT_SOURCE_NUM_PROPERTIES
};
static GParamSpec* video_import_source_properties[VIDEO_IMPORT_SOURCE_NUM_PROPERTIES];

#define TYPE_PHOTO_IMPORT_SOURCE (photo_import_source_get_type ())
#define PHOTO_IMPORT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSource))
#define PHOTO_IMPORT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSourceClass))
#define IS_PHOTO_IMPORT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_SOURCE))
#define IS_PHOTO_IMPORT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_SOURCE))
#define PHOTO_IMPORT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSourceClass))

typedef struct _PhotoImportSource PhotoImportSource;
typedef struct _PhotoImportSourceClass PhotoImportSourceClass;
typedef struct _PhotoImportSourcePrivate PhotoImportSourcePrivate;
enum  {
	PHOTO_IMPORT_SOURCE_0_PROPERTY,
	PHOTO_IMPORT_SOURCE_NUM_PROPERTIES
};
static GParamSpec* photo_import_source_properties[PHOTO_IMPORT_SOURCE_NUM_PROPERTIES];
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define TYPE_IMPORT_PREVIEW (import_preview_get_type ())
#define IMPORT_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMPORT_PREVIEW, ImportPreview))
#define IMPORT_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMPORT_PREVIEW, ImportPreviewClass))
#define IS_IMPORT_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMPORT_PREVIEW))
#define IS_IMPORT_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMPORT_PREVIEW))
#define IMPORT_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMPORT_PREVIEW, ImportPreviewClass))

typedef struct _ImportPreview ImportPreview;
typedef struct _ImportPreviewClass ImportPreviewClass;
typedef struct _ImportPreviewPrivate ImportPreviewPrivate;
enum  {
	IMPORT_PREVIEW_0_PROPERTY,
	IMPORT_PREVIEW_NUM_PROPERTIES
};
static GParamSpec* import_preview_properties[IMPORT_PREVIEW_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	CAMERA_ACCUMULATOR_0_PROPERTY,
	CAMERA_ACCUMULATOR_TOTAL_PROPERTY,
	CAMERA_ACCUMULATOR_PHOTOS_PROPERTY,
	CAMERA_ACCUMULATOR_VIDEOS_PROPERTY,
	CAMERA_ACCUMULATOR_RAW_PROPERTY,
	CAMERA_ACCUMULATOR_NUM_PROPERTIES
};
static GParamSpec* camera_accumulator_properties[CAMERA_ACCUMULATOR_NUM_PROPERTIES];

#define IMPORT_PAGE_TYPE_IMPORT_PAGE_SEARCH_VIEW_FILTER (import_page_import_page_search_view_filter_get_type ())
#define IMPORT_PAGE_IMPORT_PAGE_SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IMPORT_PAGE_TYPE_IMPORT_PAGE_SEARCH_VIEW_FILTER, ImportPageImportPageSearchViewFilter))
#define IMPORT_PAGE_IMPORT_PAGE_SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IMPORT_PAGE_TYPE_IMPORT_PAGE_SEARCH_VIEW_FILTER, ImportPageImportPageSearchViewFilterClass))
#define IMPORT_PAGE_IS_IMPORT_PAGE_SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IMPORT_PAGE_TYPE_IMPORT_PAGE_SEARCH_VIEW_FILTER))
#define IMPORT_PAGE_IS_IMPORT_PAGE_SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IMPORT_PAGE_TYPE_IMPORT_PAGE_SEARCH_VIEW_FILTER))
#define IMPORT_PAGE_IMPORT_PAGE_SEARCH_VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IMPORT_PAGE_TYPE_IMPORT_PAGE_SEARCH_VIEW_FILTER, ImportPageImportPageSearchViewFilterClass))

typedef struct _ImportPageImportPageSearchViewFilter ImportPageImportPageSearchViewFilter;
typedef struct _ImportPageImportPageSearchViewFilterClass ImportPageImportPageSearchViewFilterClass;

#define IMPORT_PAGE_TYPE_HIDE_IMPORTED_VIEW_FILTER (import_page_hide_imported_view_filter_get_type ())
#define IMPORT_PAGE_HIDE_IMPORTED_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IMPORT_PAGE_TYPE_HIDE_IMPORTED_VIEW_FILTER, ImportPageHideImportedViewFilter))
#define IMPORT_PAGE_HIDE_IMPORTED_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IMPORT_PAGE_TYPE_HIDE_IMPORTED_VIEW_FILTER, ImportPageHideImportedViewFilterClass))
#define IMPORT_PAGE_IS_HIDE_IMPORTED_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IMPORT_PAGE_TYPE_HIDE_IMPORTED_VIEW_FILTER))
#define IMPORT_PAGE_IS_HIDE_IMPORTED_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IMPORT_PAGE_TYPE_HIDE_IMPORTED_VIEW_FILTER))
#define IMPORT_PAGE_HIDE_IMPORTED_VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IMPORT_PAGE_TYPE_HIDE_IMPORTED_VIEW_FILTER, ImportPageHideImportedViewFilterClass))

typedef struct _ImportPageHideImportedViewFilter ImportPageHideImportedViewFilter;
typedef struct _ImportPageHideImportedViewFilterClass ImportPageHideImportedViewFilterClass;
enum  {
	IMPORT_PAGE_0_PROPERTY,
	IMPORT_PAGE_NUM_PROPERTIES
};
static GParamSpec* import_page_properties[IMPORT_PAGE_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))
#define _core_tracker_unref0(var) ((var == NULL) ? NULL : (var = (core_tracker_unref (var), NULL)))
#define _gp_context_wrapper_unref0(var) ((var == NULL) ? NULL : (var = (gp_context_wrapper_unref (var), NULL)))

#define IMPORT_PAGE_TYPE_IMPORT_VIEW_MANAGER (import_page_import_view_manager_get_type ())
#define IMPORT_PAGE_IMPORT_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IMPORT_PAGE_TYPE_IMPORT_VIEW_MANAGER, ImportPageImportViewManager))
#define IMPORT_PAGE_IMPORT_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IMPORT_PAGE_TYPE_IMPORT_VIEW_MANAGER, ImportPageImportViewManagerClass))
#define IMPORT_PAGE_IS_IMPORT_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IMPORT_PAGE_TYPE_IMPORT_VIEW_MANAGER))
#define IMPORT_PAGE_IS_IMPORT_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IMPORT_PAGE_TYPE_IMPORT_VIEW_MANAGER))
#define IMPORT_PAGE_IMPORT_VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IMPORT_PAGE_TYPE_IMPORT_VIEW_MANAGER, ImportPageImportViewManagerClass))

typedef struct _ImportPageImportViewManager ImportPageImportViewManager;
typedef struct _ImportPageImportViewManagerClass ImportPageImportViewManagerClass;
#define _view_collection_monitor_unref0(var) ((var == NULL) ? NULL : (var = (view_collection_monitor_unref (var), NULL)))
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
typedef struct _Block17Data Block17Data;

#define IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB (import_page_camera_import_job_get_type ())
#define IMPORT_PAGE_CAMERA_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB, ImportPageCameraImportJob))
#define IMPORT_PAGE_CAMERA_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB, ImportPageCameraImportJobClass))
#define IMPORT_PAGE_IS_CAMERA_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB))
#define IMPORT_PAGE_IS_CAMERA_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB))
#define IMPORT_PAGE_CAMERA_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB, ImportPageCameraImportJobClass))

typedef struct _ImportPageCameraImportJob ImportPageCameraImportJob;
typedef struct _ImportPageCameraImportJobClass ImportPageCameraImportJobClass;
#define _gp_list_unref0(var) ((var == NULL) ? NULL : (var = (gp_list_unref (var), NULL)))
#define _batch_import_job_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_job_unref (var), NULL)))
#define _import_manifest_unref0(var) ((var == NULL) ? NULL : (var = (import_manifest_unref (var), NULL)))
#define _import_ui_question_params_unref0(var) ((var == NULL) ? NULL : (var = (import_ui_question_params_unref (var), NULL)))
#define _batch_import_result_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_result_unref (var), NULL)))
typedef struct _ImportPageImportViewManagerPrivate ImportPageImportViewManagerPrivate;
typedef struct _ImportPageCameraImportJobPrivate ImportPageCameraImportJobPrivate;
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
typedef struct _ImportPageImportPageSearchViewFilterPrivate ImportPageImportPageSearchViewFilterPrivate;
typedef struct _ImportPageHideImportedViewFilterPrivate ImportPageHideImportedViewFilterPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ImportSourceCollection {
	SourceCollection parent_instance;
	ImportSourceCollectionPrivate * priv;
};

struct _ImportSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _ImportSource {
	ThumbnailSource parent_instance;
	ImportSourcePrivate * priv;
};

struct _ImportSourceClass {
	ThumbnailSourceClass parent_class;
	GdkPixbuf* (*get_preview) (ImportSource* self);
	gint64 (*get_exposure_time) (ImportSource* self);
};

struct _ImportSourcePrivate {
	Camera* _camera;
	gint _fsid;
	gchar* _camera_name;
	gchar* _filename;
	gchar* _folder;
	gulong _file_size;
	gint64 modification_time;
	GdkPixbuf* preview;
	gchar* indexable_keywords;
};

struct _VideoImportSource {
	ImportSource parent_instance;
	VideoImportSourcePrivate * priv;
};

struct _VideoImportSourceClass {
	ImportSourceClass parent_class;
};

struct _PhotoImportSource {
	ImportSource parent_instance;
	PhotoImportSourcePrivate * priv;
};

struct _PhotoImportSourceClass {
	ImportSourceClass parent_class;
};

struct _PhotoImportSourcePrivate {
	PhotoFileFormat file_format;
	gchar* preview_md5;
	PhotoMetadata* metadata;
	gchar* exif_md5;
	PhotoImportSource* associated;
};

struct _ImportPreview {
	CheckerboardItem parent_instance;
	ImportPreviewPrivate * priv;
};

struct _ImportPreviewClass {
	CheckerboardItemClass parent_class;
};

struct _ImportPreviewPrivate {
	DuplicatedFile* duplicated_file;
};

struct _CameraAccumulatorPrivate {
	gint _total;
	gint _photos;
	gint _videos;
	gint _raw;
};

struct _ImportPagePrivate {
	SourceCollection* import_sources;
	GtkLabel* camera_label;
	GtkCheckButton* hide_imported;
	GtkProgressBar* progress_bar;
	Camera* camera;
	gchar* uri;
	gboolean busy;
	gboolean refreshed;
	int refresh_result;
	gchar* refresh_error;
	gchar* camera_name;
	GVolumeMonitor* volume_monitor;
	ImportPage* local_ref;
	GIcon* icon;
	ImportPageImportPageSearchViewFilter* search_filter;
	ImportPageHideImportedViewFilter* hide_imported_filter;
	CameraViewTracker* tracker;
	GtkMenu* page_context_menu;
	GtkMenu* import_context_menu;
};

struct _Block16Data {
	int _ref_count_;
	ImportPage* self;
	GtkRadioMenuItem* ascending_menu_item;
	GtkAction* ascending_action;
	GtkRadioMenuItem* descending_menu_item;
	GtkAction* descending_action;
	GAction* select_action;
};

struct _Block17Data {
	int _ref_count_;
	ImportPage* self;
	GtkAction* selected_action;
	GtkAction* all_action;
};

struct _ImportPageImportViewManager {
	ViewManager parent_instance;
	ImportPageImportViewManagerPrivate * priv;
};

struct _ImportPageImportViewManagerClass {
	ViewManagerClass parent_class;
};

struct _ImportPageImportViewManagerPrivate {
	ImportPage* owner;
};

struct _ImportPageCameraImportJob {
	BatchImportJob parent_instance;
	ImportPageCameraImportJobPrivate * priv;
};

struct _ImportPageCameraImportJobClass {
	BatchImportJobClass parent_class;
};

struct _ImportPageCameraImportJobPrivate {
	GPContextWrapper* context;
	ImportSource* import_file;
	Camera* camera;
	gchar* fulldir;
	gchar* filename;
	guint64 filesize;
	PhotoMetadata* metadata;
	gint64 exposure_time;
	ImportPageCameraImportJob* associated;
	BackingPhotoRow* associated_file;
	DuplicatedFile* duplicated_file;
	GSettings* file_settings;
};

struct _ImportPageImportPageSearchViewFilter {
	SearchViewFilter parent_instance;
	ImportPageImportPageSearchViewFilterPrivate * priv;
};

struct _ImportPageImportPageSearchViewFilterClass {
	SearchViewFilterClass parent_class;
};

struct _ImportPageHideImportedViewFilter {
	ViewFilter parent_instance;
	ImportPageHideImportedViewFilterPrivate * priv;
};

struct _ImportPageHideImportedViewFilterClass {
	ViewFilterClass parent_class;
};

static gpointer import_source_collection_parent_class = NULL;
static gint ImportSource_private_offset;
static gpointer import_source_parent_class = NULL;
static IndexableIface * import_source_indexable_parent_iface = NULL;
static gpointer video_import_source_parent_class = NULL;
static gint PhotoImportSource_private_offset;
static gpointer photo_import_source_parent_class = NULL;
static gint ImportPreview_private_offset;
static gpointer import_preview_parent_class = NULL;
static GdkPixbuf* import_preview_placeholder_preview;
static GdkPixbuf* import_preview_placeholder_preview = NULL;
static gpointer camera_view_tracker_parent_class = NULL;
static gint CameraAccumulator_private_offset;
static gpointer camera_accumulator_parent_class = NULL;
static CoreTrackerAccumulatorIface * camera_accumulator_core_tracker_accumulator_parent_iface = NULL;
static gint ImportPage_private_offset;
static gpointer import_page_parent_class = NULL;
GPContextWrapper* import_page_null_context = NULL;
GPSpinIdleWrapper* import_page_spin_idle_context = NULL;
static gint ImportPageImportViewManager_private_offset;
static gpointer import_page_import_view_manager_parent_class = NULL;
static gint ImportPageCameraImportJob_private_offset;
static gpointer import_page_camera_import_job_parent_class = NULL;
static gpointer import_page_import_page_search_view_filter_parent_class = NULL;
static gpointer import_page_hide_imported_view_filter_parent_class = NULL;

VALA_EXTERN GType import_source_collection_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportSourceCollection* import_source_collection_new (const gchar* name);
VALA_EXTERN ImportSourceCollection* import_source_collection_construct (GType object_type,
                                                            const gchar* name);
static gboolean import_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                             DataSource* source);
VALA_EXTERN GType import_source_get_type (void) G_GNUC_CONST ;
static GType import_source_collection_get_type_once (void);
VALA_EXTERN GdkPixbuf* import_source_get_preview (ImportSource* self);
VALA_EXTERN gint64 import_source_get_exposure_time (ImportSource* self);
VALA_EXTERN ImportSource* import_source_construct (GType object_type,
                                       const gchar* camera_name,
                                       Camera* camera,
                                       gint fsid,
                                       const gchar* folder,
                                       const gchar* filename,
                                       gulong file_size,
                                       gint64 modification_time);
VALA_EXTERN void import_source_set_preview (ImportSource* self,
                                GdkPixbuf* preview);
VALA_EXTERN gint64 import_source_get_modification_time (ImportSource* self);
static GdkPixbuf* import_source_real_get_preview (ImportSource* self);
static gint64 import_source_real_get_exposure_time (ImportSource* self);
VALA_EXTERN gchar* import_source_get_fulldir (ImportSource* self);
VALA_EXTERN Camera* import_source_get_camera (ImportSource* self);
VALA_EXTERN const gchar* import_source_get_camera_name (ImportSource* self);
VALA_EXTERN gint import_source_get_fsid (ImportSource* self);
VALA_EXTERN const gchar* import_source_get_folder (ImportSource* self);
static gchar* import_source_real_to_string (DataObject* base);
VALA_EXTERN const gchar* import_source_get_filename (ImportSource* self);
static gboolean import_source_real_internal_delete_backing (DataSource* base,
                                                     GError** error);
static const gchar* import_source_real_get_indexable_keywords (Indexable* base);
static void import_source_set_camera (ImportSource* self,
                               Camera* value);
static void import_source_set_fsid (ImportSource* self,
                             gint value);
static void import_source_set_camera_name (ImportSource* self,
                                    const gchar* value);
static void import_source_set_filename (ImportSource* self,
                                 const gchar* value);
static void import_source_set_folder (ImportSource* self,
                               const gchar* value);
VALA_EXTERN gulong import_source_get_file_size (ImportSource* self);
static void import_source_set_file_size (ImportSource* self,
                                  gulong value);
static void import_source_finalize (GObject * obj);
static GType import_source_get_type_once (void);
static void _vala_import_source_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_import_source_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
VALA_EXTERN GType video_import_source_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VideoImportSource* video_import_source_new (const gchar* camera_name,
                                            Camera* camera,
                                            gint fsid,
                                            const gchar* folder,
                                            const gchar* filename,
                                            gulong file_size,
                                            gint64 modification_time);
VALA_EXTERN VideoImportSource* video_import_source_construct (GType object_type,
                                                  const gchar* camera_name,
                                                  Camera* camera,
                                                  gint fsid,
                                                  const gchar* folder,
                                                  const gchar* filename,
                                                  gulong file_size,
                                                  gint64 modification_time);
static GdkPixbuf* video_import_source_real_get_thumbnail (ThumbnailSource* base,
                                                   gint scale,
                                                   GError** error);
static GdkPixbuf* video_import_source_real_create_thumbnail (ThumbnailSource* base,
                                                      gint scale,
                                                      GError** error);
VALA_EXTERN GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf,
                         gint scale,
                         GdkInterpType interp,
                         gboolean scale_up);
static gchar* video_import_source_real_get_typename (DataSource* base);
static gint64 video_import_source_real_get_instance_id (DataSource* base);
static PhotoFileFormat video_import_source_real_get_preferred_thumbnail_format (ThumbnailSource* base);
static gchar* video_import_source_real_get_name (DataObject* base);
VALA_EXTERN void video_import_source_update (VideoImportSource* self,
                                 GdkPixbuf* preview);
static GType video_import_source_get_type_once (void);
VALA_EXTERN GType photo_import_source_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoImportSource* photo_import_source_new (const gchar* camera_name,
                                            Camera* camera,
                                            gint fsid,
                                            const gchar* folder,
                                            const gchar* filename,
                                            gulong file_size,
                                            gint64 modification_time,
                                            PhotoFileFormat file_format);
VALA_EXTERN PhotoImportSource* photo_import_source_construct (GType object_type,
                                                  const gchar* camera_name,
                                                  Camera* camera,
                                                  gint fsid,
                                                  const gchar* folder,
                                                  const gchar* filename,
                                                  gulong file_size,
                                                  gint64 modification_time,
                                                  PhotoFileFormat file_format);
static gchar* photo_import_source_real_get_name (DataObject* base);
VALA_EXTERN gchar* photo_import_source_get_title (PhotoImportSource* self);
static gchar* photo_import_source_real_get_typename (DataSource* base);
static gint64 photo_import_source_real_get_instance_id (DataSource* base);
static PhotoFileFormat photo_import_source_real_get_preferred_thumbnail_format (ThumbnailSource* base);
static GdkPixbuf* photo_import_source_real_create_thumbnail (ThumbnailSource* base,
                                                      gint scale,
                                                      GError** error);
VALA_EXTERN void photo_import_source_update (PhotoImportSource* self,
                                 GdkPixbuf* preview,
                                 const gchar* preview_md5,
                                 PhotoMetadata* metadata,
                                 const gchar* exif_md5);
static gint64 photo_import_source_real_get_exposure_time (ImportSource* base);
VALA_EXTERN PhotoMetadata* photo_import_source_get_metadata (PhotoImportSource* self);
static GdkPixbuf* photo_import_source_real_get_preview (ImportSource* base);
static GdkPixbuf* photo_import_source_real_get_thumbnail (ThumbnailSource* base,
                                                   gint scale,
                                                   GError** error);
VALA_EXTERN PhotoFileFormat photo_import_source_get_file_format (PhotoImportSource* self);
VALA_EXTERN gchar* photo_import_source_get_preview_md5 (PhotoImportSource* self);
VALA_EXTERN void photo_import_source_set_associated (PhotoImportSource* self,
                                         PhotoImportSource* associated);
VALA_EXTERN PhotoImportSource* photo_import_source_get_associated (PhotoImportSource* self);
static gboolean photo_import_source_real_internal_delete_backing (DataSource* base,
                                                           GError** error);
static void photo_import_source_finalize (GObject * obj);
static GType photo_import_source_get_type_once (void);
VALA_EXTERN GType import_preview_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportPreview* import_preview_new (ImportSource* source);
VALA_EXTERN ImportPreview* import_preview_construct (GType object_type,
                                         ImportSource* source);
static GdkPixbuf* import_preview_get_placeholder_pixbuf (ImportPreview* self);
VALA_EXTERN gboolean import_preview_is_already_imported (ImportPreview* self);
VALA_EXTERN ImportSource* import_preview_get_import_source (ImportPreview* self);
VALA_EXTERN DuplicatedFile* import_preview_get_duplicated_file (ImportPreview* self);
static void import_preview_finalize (GObject * obj);
static GType import_preview_get_type_once (void);
static void camera_view_tracker_finalize (CoreTracker * obj);
static GType camera_view_tracker_get_type_once (void);
static gboolean camera_accumulator_real_include (CoreTrackerAccumulator* base,
                                          DataObject* object);
static void camera_accumulator_set_total (CameraAccumulator* self,
                                   gint value);
static void camera_accumulator_set_photos (CameraAccumulator* self,
                                    gint value);
static void camera_accumulator_set_raw (CameraAccumulator* self,
                                 gint value);
static void camera_accumulator_set_videos (CameraAccumulator* self,
                                    gint value);
static gboolean camera_accumulator_real_uninclude (CoreTrackerAccumulator* base,
                                            DataObject* object);
static gboolean camera_accumulator_real_altered (CoreTrackerAccumulator* base,
                                          DataObject* object,
                                          Alteration* alteration);
static void camera_accumulator_finalize (GObject * obj);
static GType camera_accumulator_get_type_once (void);
static void _vala_camera_accumulator_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_camera_accumulator_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static GType import_page_import_page_search_view_filter_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType import_page_hide_imported_view_filter_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void import_page_on_media_added_removed (ImportPage* self);
static void _import_page_on_media_added_removed_data_collection_contents_altered (DataCollection* _sender,
                                                                           GeeIterable* added,
                                                                           GeeIterable* removed,
                                                                           gpointer self);
static ImportPageImportPageSearchViewFilter* import_page_import_page_search_view_filter_new (void);
static ImportPageImportPageSearchViewFilter* import_page_import_page_search_view_filter_construct (GType object_type);
static ImportPageHideImportedViewFilter* import_page_hide_imported_view_filter_new (void);
static ImportPageHideImportedViewFilter* import_page_hide_imported_view_filter_construct (GType object_type);
static ImportPageImportViewManager* import_page_import_view_manager_new (ImportPage* owner);
static ImportPageImportViewManager* import_page_import_view_manager_construct (GType object_type,
                                                                        ImportPage* owner);
static GType import_page_import_view_manager_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gint64 import_page_preview_comparator (void* a,
                                       void* b);
static gint64 _import_page_preview_comparator_comparator (void* a,
                                                   void* b,
                                                   gpointer self);
static gboolean import_page_preview_comparator_predicate (DataObject* object,
                                                   Alteration* alteration);
static gboolean _import_page_preview_comparator_predicate_comparator_predicate (DataObject* object,
                                                                         Alteration* alteration,
                                                                         gpointer self);
static void import_page_on_view_changed (ImportPage* self);
static void _import_page_on_view_changed_view_collection_items_state_changed (ViewCollection* _sender,
                                                                       GeeIterable* changed,
                                                                       gpointer self);
static void _import_page_on_view_changed_data_collection_contents_altered (DataCollection* _sender,
                                                                    GeeIterable* added,
                                                                    GeeIterable* removed,
                                                                    gpointer self);
static void _import_page_on_view_changed_view_collection_items_visibility_changed (ViewCollection* _sender,
                                                                            GeeCollection* changed,
                                                                            gpointer self);
static void import_page_real_add_toolbar_widgets (Page* base,
                                           GtkActionBar* toolbar);
static void import_page_on_hide_imported (ImportPage* self);
static void _import_page_on_hide_imported_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void import_page_update_toolbar_state (ImportPage* self);
static GtkMenu* import_page_real_get_item_context_menu (CheckerboardPage* base);
static void import_page_create_import_context_menu (ImportPage* self);
static GtkMenu* import_page_real_get_page_context_menu (Page* base);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void ___lambda119_ (Block16Data* _data16_);
static void ____lambda119__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void ___lambda120_ (Block16Data* _data16_);
static void ____lambda120__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static void ___lambda121_ (Block16Data* _data16_);
static void ____lambda121__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
static GtkMenu* import_page_real_get_page_sidebar_menu (Page* base);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void __lambda117_ (Block17Data* _data17_);
static void ___lambda117__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda118_ (Block17Data* _data17_);
static void ___lambda118__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static CoreViewTracker* import_page_real_get_view_tracker (CheckerboardPage* base);
static gchar* import_page_real_get_view_empty_message (CheckerboardPage* base);
static gint64 import_page_import_job_comparator (ImportPage* self,
                                          void* a,
                                          void* b);
static GType import_page_camera_import_job_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gint64 import_page_camera_import_job_get_exposure_time (ImportPageCameraImportJob* self);
static GtkToggleActionEntry* import_page_real_init_collect_toggle_action_entries (Page* base,
                                                                           gint* result_length1);
static void import_page_on_display_titles (ImportPage* self,
                                    GtkAction* action);
static void _import_page_on_display_titles_gcallback (GtkAction* action,
                                               gpointer self);
static void _vala_array_add153 (GtkToggleActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkToggleActionEntry* value);
static GtkActionEntry* import_page_real_init_collect_action_entries (Page* base,
                                                              gint* result_length1);
static void import_page_on_import_selected (ImportPage* self);
static void _import_page_on_import_selected_gcallback (GtkAction* action,
                                                gpointer self);
static void _vala_array_add154 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void import_page_on_import_all (ImportPage* self);
static void _import_page_on_import_all_gcallback (GtkAction* action,
                                           gpointer self);
static void _vala_array_add155 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void import_page_real_init_actions (Page* base,
                                    gint selected_count,
                                    gint count);
static void import_page_update_status (ImportPage* self,
                                gboolean busy,
                                gboolean refreshed);
static void import_page_real_switched_to (Page* base);
static void import_page_real_ready (Page* base);
static void import_page_try_refreshing_camera (ImportPage* self,
                                        gboolean fail_on_locked);
static ImportPageRefreshResult import_page_refresh_camera (ImportPage* self);
static void import_page_on_unmounted (ImportPage* self,
                               GMount* mount);
static void _import_page_on_unmounted_g_mount_unmounted (GMount* _sender,
                                                  gpointer self);
static void import_page_on_unmount_finished (ImportPage* self,
                                      GObject* source,
                                      GAsyncResult* aresult);
static void _import_page_on_unmount_finished_gasync_ready_callback (GObject* source_object,
                                                             GAsyncResult* res,
                                                             gpointer self);
static void import_page_clear_all_import_sources (ImportPage* self);
static gboolean import_page_check_directory_exists (ImportPage* self,
                                             gint fsid,
                                             const gchar* dir,
                                             const gchar* search_target);
static gboolean import_page_enumerate_files (ImportPage* self,
                                      gint fsid,
                                      const gchar* dir,
                                      GeeArrayList* import_list);
static void import_page_auto_match_raw_jpeg (ImportPage* self,
                                      GeeArrayList* import_list);
static void import_page_load_previews_and_metadata (ImportPage* self,
                                             GeeList* import_list);
static gchar* import_page_chomp_ch (const gchar* str,
                             gchar ch);
static void import_page_import (ImportPage* self,
                         GeeIterable* items);
static gint64 _import_page_import_job_comparator_comparator (void* a,
                                                      void* b,
                                                      gpointer self);
static ImportPageCameraImportJob* import_page_camera_import_job_new (GPContextWrapper* context,
                                                              ImportSource* import_file,
                                                              DuplicatedFile* duplicated_file);
static ImportPageCameraImportJob* import_page_camera_import_job_construct (GType object_type,
                                                                    GPContextWrapper* context,
                                                                    ImportSource* import_file,
                                                                    DuplicatedFile* duplicated_file);
static void import_page_import_reporter (ImportPage* self,
                                  ImportManifest* manifest);
static void _import_page_import_reporter_batch_import_import_reporter (ImportManifest* manifest,
                                                                BatchImportRoll* import_roll,
                                                                gpointer self);
static void import_page_on_import_job_failed (ImportPage* self,
                                       BatchImportResult* _result_);
static void _import_page_on_import_job_failed_batch_import_import_job_failed (BatchImport* _sender,
                                                                       BatchImportResult* _result_,
                                                                       gpointer self);
static void import_page_close_import (ImportPage* self);
static void _import_page_close_import_batch_import_import_complete (BatchImport* _sender,
                                                             ImportManifest* manifest,
                                                             BatchImportRoll* import_roll,
                                                             gpointer self);
static ImportSource* import_page_camera_import_job_get_source (ImportPageCameraImportJob* self);
static gboolean _progress_dialog_monitor_progress_monitor (guint64 current,
                                                    guint64 total,
                                                    gboolean do_event_loop,
                                                    gpointer self);
static void import_page_real_set_display_titles (CheckerboardPage* base,
                                          gboolean display);
static SearchViewFilter* import_page_real_get_search_view_filter (CheckerboardPage* base);
static DataView* import_page_import_view_manager_real_create_view (ViewManager* base,
                                                            DataSource* source);
static void import_page_import_view_manager_finalize (ViewManager * obj);
static GType import_page_import_view_manager_get_type_once (void);
static DuplicatedFile* import_page_camera_import_job_real_get_duplicated_file (BatchImportJob* base);
static gint64 import_page_camera_import_job_real_get_exposure_time_override (BatchImportJob* base);
static gchar* import_page_camera_import_job_real_get_dest_identifier (BatchImportJob* base);
static gchar* import_page_camera_import_job_real_get_source_identifier (BatchImportJob* base);
static gchar* import_page_camera_import_job_real_get_basename (BatchImportJob* base);
static gchar* import_page_camera_import_job_real_get_path (BatchImportJob* base);
static void import_page_camera_import_job_real_set_associated (BatchImportJob* base,
                                                        BatchImportJob* associated);
static gboolean import_page_camera_import_job_real_is_directory (BatchImportJob* base);
static gboolean import_page_camera_import_job_real_determine_file_size (BatchImportJob* base,
                                                                 guint64* filesize,
                                                                 GFile** file);
static gboolean import_page_camera_import_job_real_prepare (BatchImportJob* base,
                                                     GFile** file_to_import,
                                                     gboolean* copy_to_library,
                                                     GError** error);
static gboolean import_page_camera_import_job_real_complete (BatchImportJob* base,
                                                      MediaSource* source,
                                                      BatchImportRoll* import_roll,
                                                      GError** error);
static void import_page_camera_import_job_finalize (BatchImportJob * obj);
static GType import_page_camera_import_job_get_type_once (void);
static guint import_page_import_page_search_view_filter_real_get_criteria (SearchViewFilter* base);
static gboolean import_page_import_page_search_view_filter_real_predicate (ViewFilter* base,
                                                                    DataView* view);
static GType import_page_import_page_search_view_filter_get_type_once (void);
static gboolean import_page_hide_imported_view_filter_real_predicate (ViewFilter* base,
                                                               DataView* view);
static GType import_page_hide_imported_view_filter_get_type_once (void);
static void import_page_finalize (GObject * obj);
static GType import_page_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

ImportSourceCollection*
import_source_collection_construct (GType object_type,
                                    const gchar* name)
{
	ImportSourceCollection* self = NULL;
#line 22 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 23 "../src/Views/ImportPage.vala"
	self = (ImportSourceCollection*) source_collection_construct (object_type, name);
#line 22 "../src/Views/ImportPage.vala"
	return self;
#line 811 "ImportPage.c"
}

ImportSourceCollection*
import_source_collection_new (const gchar* name)
{
#line 22 "../src/Views/ImportPage.vala"
	return import_source_collection_construct (TYPE_IMPORT_SOURCE_COLLECTION, name);
#line 819 "ImportPage.c"
}

static gboolean
import_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                    DataSource* source)
{
	ImportSourceCollection * self;
	gboolean result;
#line 26 "../src/Views/ImportPage.vala"
	self = (ImportSourceCollection*) base;
#line 26 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 27 "../src/Views/ImportPage.vala"
	result = IS_IMPORT_SOURCE (source);
#line 27 "../src/Views/ImportPage.vala"
	return result;
#line 836 "ImportPage.c"
}

static void
import_source_collection_class_init (ImportSourceCollectionClass * klass,
                                     gpointer klass_data)
{
#line 21 "../src/Views/ImportPage.vala"
	import_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Views/ImportPage.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) import_source_collection_real_holds_type_of_source;
#line 847 "ImportPage.c"
}

static void
import_source_collection_instance_init (ImportSourceCollection * self,
                                        gpointer klass)
{
}

static GType
import_source_collection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImportSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportSourceCollection), 0, (GInstanceInitFunc) import_source_collection_instance_init, NULL };
	GType import_source_collection_type_id;
	import_source_collection_type_id = g_type_register_static (TYPE_SOURCE_COLLECTION, "ImportSourceCollection", &g_define_type_info, 0);
	return import_source_collection_type_id;
}

GType
import_source_collection_get_type (void)
{
	static volatile gsize import_source_collection_type_id__once = 0;
	if (g_once_init_enter (&import_source_collection_type_id__once)) {
		GType import_source_collection_type_id;
		import_source_collection_type_id = import_source_collection_get_type_once ();
		g_once_init_leave (&import_source_collection_type_id__once, import_source_collection_type_id);
	}
	return import_source_collection_type_id__once;
}

static inline gpointer
import_source_get_instance_private (ImportSource* self)
{
	return G_STRUCT_MEMBER_P (self, ImportSource_private_offset);
}

ImportSource*
import_source_construct (GType object_type,
                         const gchar* camera_name,
                         Camera* camera,
                         gint fsid,
                         const gchar* folder,
                         const gchar* filename,
                         gulong file_size,
                         gint64 modification_time)
{
	ImportSource * self = NULL;
	gchar* _tmp0_;
#line 43 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera_name != NULL, NULL);
#line 43 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera != NULL, NULL);
#line 43 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (folder != NULL, NULL);
#line 43 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 45 "../src/Views/ImportPage.vala"
	self = (ImportSource*) g_object_new (object_type, "camera", camera, "camera-name", camera_name, "filename", filename, "file-size", file_size, "folder", folder, "fsid", fsid, NULL);
#line 53 "../src/Views/ImportPage.vala"
	self->priv->modification_time = modification_time;
#line 54 "../src/Views/ImportPage.vala"
	_tmp0_ = indexable_prepare_indexable_string (filename);
#line 54 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->indexable_keywords);
#line 54 "../src/Views/ImportPage.vala"
	self->priv->indexable_keywords = _tmp0_;
#line 43 "../src/Views/ImportPage.vala"
	return self;
#line 915 "ImportPage.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/Views/ImportPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 923 "ImportPage.c"
}

void
import_source_set_preview (ImportSource* self,
                           GdkPixbuf* preview)
{
	GdkPixbuf* _tmp0_;
#line 57 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Views/ImportPage.vala"
	_tmp0_ = _g_object_ref0 (preview);
#line 58 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->preview);
#line 58 "../src/Views/ImportPage.vala"
	self->priv->preview = _tmp0_;
#line 939 "ImportPage.c"
}

gint64
import_source_get_modification_time (ImportSource* self)
{
	gint64 result;
#line 61 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 62 "../src/Views/ImportPage.vala"
	result = self->priv->modification_time;
#line 62 "../src/Views/ImportPage.vala"
	return result;
#line 952 "ImportPage.c"
}

static GdkPixbuf*
import_source_real_get_preview (ImportSource* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* result;
#line 66 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->preview;
#line 66 "../src/Views/ImportPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 66 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 66 "../src/Views/ImportPage.vala"
	return result;
#line 969 "ImportPage.c"
}

GdkPixbuf*
import_source_get_preview (ImportSource* self)
{
	ImportSourceClass* _klass_;
#line 65 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../src/Views/ImportPage.vala"
	_klass_ = IMPORT_SOURCE_GET_CLASS (self);
#line 65 "../src/Views/ImportPage.vala"
	if (_klass_->get_preview) {
#line 65 "../src/Views/ImportPage.vala"
		return _klass_->get_preview (self);
#line 984 "ImportPage.c"
	}
#line 65 "../src/Views/ImportPage.vala"
	return NULL;
#line 988 "ImportPage.c"
}

static gint64
import_source_real_get_exposure_time (ImportSource* self)
{
	gint64 result;
#line 70 "../src/Views/ImportPage.vala"
	result = import_source_get_modification_time (self);
#line 70 "../src/Views/ImportPage.vala"
	return result;
#line 999 "ImportPage.c"
}

gint64
import_source_get_exposure_time (ImportSource* self)
{
	ImportSourceClass* _klass_;
#line 69 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 69 "../src/Views/ImportPage.vala"
	_klass_ = IMPORT_SOURCE_GET_CLASS (self);
#line 69 "../src/Views/ImportPage.vala"
	if (_klass_->get_exposure_time) {
#line 69 "../src/Views/ImportPage.vala"
		return _klass_->get_exposure_time (self);
#line 1014 "ImportPage.c"
	}
#line 69 "../src/Views/ImportPage.vala"
	return -1LL;
#line 1018 "ImportPage.c"
}

gchar*
import_source_get_fulldir (ImportSource* self)
{
	Camera* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 73 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->_camera;
#line 74 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->_camera_name;
#line 74 "../src/Views/ImportPage.vala"
	_tmp2_ = self->priv->_fsid;
#line 74 "../src/Views/ImportPage.vala"
	_tmp3_ = self->priv->_folder;
#line 74 "../src/Views/ImportPage.vala"
	_tmp4_ = import_page_get_fulldir (_tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 74 "../src/Views/ImportPage.vala"
	result = _tmp4_;
#line 74 "../src/Views/ImportPage.vala"
	return result;
#line 1046 "ImportPage.c"
}

static gchar*
import_source_real_to_string (DataObject* base)
{
	ImportSource * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 77 "../src/Views/ImportPage.vala"
	self = (ImportSource*) base;
#line 78 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->_camera_name;
#line 78 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->_folder;
#line 78 "../src/Views/ImportPage.vala"
	_tmp2_ = self->priv->_filename;
#line 78 "../src/Views/ImportPage.vala"
	_tmp3_ = g_strdup_printf ("%s %s/%s", _tmp0_, _tmp1_, _tmp2_);
#line 78 "../src/Views/ImportPage.vala"
	result = _tmp3_;
#line 78 "../src/Views/ImportPage.vala"
	return result;
#line 1072 "ImportPage.c"
}

static gchar*
gp_result_to_full_string (int self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 479 "libgphoto2.vapi"
	_tmp0_ = gp_port_result_as_string (self);
#line 479 "libgphoto2.vapi"
	_tmp1_ = g_strdup_printf ("%s (%d)", _tmp0_, (gint) self);
#line 479 "libgphoto2.vapi"
	result = _tmp1_;
#line 479 "libgphoto2.vapi"
	return result;
#line 1089 "ImportPage.c"
}

static gboolean
import_source_real_internal_delete_backing (DataSource* base,
                                            GError** error)
{
	ImportSource * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* fulldir = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	int _result_ = 0;
	Camera* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GPSpinIdleWrapper* _tmp13_;
	GPContext* _tmp14_;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 81 "../src/Views/ImportPage.vala"
	self = (ImportSource*) base;
#line 82 "../src/Views/ImportPage.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 82 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 82 "../src/Views/ImportPage.vala"
	_tmp2_ = self->priv->_camera_name;
#line 82 "../src/Views/ImportPage.vala"
	g_debug ("ImportPage.vala:82: Deleting %s from %s", _tmp1_, _tmp2_);
#line 82 "../src/Views/ImportPage.vala"
	_g_free0 (_tmp1_);
#line 84 "../src/Views/ImportPage.vala"
	_tmp3_ = import_source_get_fulldir (self);
#line 84 "../src/Views/ImportPage.vala"
	fulldir = _tmp3_;
#line 85 "../src/Views/ImportPage.vala"
	_tmp4_ = fulldir;
#line 85 "../src/Views/ImportPage.vala"
	if (_tmp4_ == NULL) {
#line 1133 "ImportPage.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
#line 86 "../src/Views/ImportPage.vala"
		_tmp5_ = data_object_to_string ((DataObject*) self);
#line 86 "../src/Views/ImportPage.vala"
		_tmp6_ = _tmp5_;
#line 86 "../src/Views/ImportPage.vala"
		_tmp7_ = self->priv->_camera_name;
#line 86 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:86: Skipping deleting %s from %s: invalid folder name", _tmp6_, _tmp7_);
#line 86 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp6_);
#line 88 "../src/Views/ImportPage.vala"
		_tmp8_ = DATA_SOURCE_CLASS (import_source_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), &_inner_error0_);
#line 88 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1152 "ImportPage.c"
			gboolean _tmp9_ = FALSE;
#line 88 "../src/Views/ImportPage.vala"
			g_propagate_error (error, _inner_error0_);
#line 88 "../src/Views/ImportPage.vala"
			_g_free0 (fulldir);
#line 88 "../src/Views/ImportPage.vala"
			return _tmp9_;
#line 1160 "ImportPage.c"
		}
#line 88 "../src/Views/ImportPage.vala"
		result = _tmp8_;
#line 88 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 88 "../src/Views/ImportPage.vala"
		return result;
#line 1168 "ImportPage.c"
	}
#line 91 "../src/Views/ImportPage.vala"
	_tmp10_ = self->priv->_camera;
#line 91 "../src/Views/ImportPage.vala"
	_tmp11_ = fulldir;
#line 91 "../src/Views/ImportPage.vala"
	_tmp12_ = self->priv->_filename;
#line 91 "../src/Views/ImportPage.vala"
	_tmp13_ = import_page_spin_idle_context;
#line 91 "../src/Views/ImportPage.vala"
	_tmp14_ = ((GPContextWrapper*) _tmp13_)->context;
#line 91 "../src/Views/ImportPage.vala"
	_result_ = gp_camera_file_delete (_tmp10_, _tmp11_, _tmp12_, _tmp14_);
#line 93 "../src/Views/ImportPage.vala"
	if (_result_ != GP_OK) {
#line 1184 "ImportPage.c"
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 94 "../src/Views/ImportPage.vala"
		_tmp15_ = data_object_to_string ((DataObject*) self);
#line 94 "../src/Views/ImportPage.vala"
		_tmp16_ = _tmp15_;
#line 94 "../src/Views/ImportPage.vala"
		_tmp17_ = self->priv->_camera_name;
#line 94 "../src/Views/ImportPage.vala"
		_tmp18_ = gp_result_to_full_string (_result_);
#line 94 "../src/Views/ImportPage.vala"
		_tmp19_ = _tmp18_;
#line 94 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:94: Error deleting %s from %s: %s", _tmp16_, _tmp17_, _tmp19_);
#line 94 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp19_);
#line 94 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp16_);
#line 1206 "ImportPage.c"
	}
#line 96 "../src/Views/ImportPage.vala"
	_tmp21_ = DATA_SOURCE_CLASS (import_source_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), &_inner_error0_);
#line 96 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1212 "ImportPage.c"
		gboolean _tmp22_ = FALSE;
#line 96 "../src/Views/ImportPage.vala"
		g_propagate_error (error, _inner_error0_);
#line 96 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 96 "../src/Views/ImportPage.vala"
		return _tmp22_;
#line 1220 "ImportPage.c"
	}
#line 96 "../src/Views/ImportPage.vala"
	if (_tmp21_) {
#line 96 "../src/Views/ImportPage.vala"
		_tmp20_ = _result_ == GP_OK;
#line 1226 "ImportPage.c"
	} else {
#line 96 "../src/Views/ImportPage.vala"
		_tmp20_ = FALSE;
#line 1230 "ImportPage.c"
	}
#line 96 "../src/Views/ImportPage.vala"
	result = _tmp20_;
#line 96 "../src/Views/ImportPage.vala"
	_g_free0 (fulldir);
#line 96 "../src/Views/ImportPage.vala"
	return result;
#line 1238 "ImportPage.c"
}

static const gchar*
import_source_real_get_indexable_keywords (Indexable* base)
{
	ImportSource * self;
	const gchar* _tmp0_;
	const gchar* result;
#line 99 "../src/Views/ImportPage.vala"
	self = (ImportSource*) base;
#line 100 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->indexable_keywords;
#line 100 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 100 "../src/Views/ImportPage.vala"
	return result;
#line 1255 "ImportPage.c"
}

Camera*
import_source_get_camera (ImportSource* self)
{
	Camera* result;
	Camera* _tmp0_;
#line 32 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->_camera;
#line 32 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 32 "../src/Views/ImportPage.vala"
	return result;
#line 1271 "ImportPage.c"
}

static gpointer
_GPHOTO_REF_CAMERA0 (gpointer self)
{
#line 32 "../src/Views/ImportPage.vala"
	return self ? GPHOTO_REF_CAMERA (self) : NULL;
#line 1279 "ImportPage.c"
}

static void
import_source_set_camera (ImportSource* self,
                          Camera* value)
{
	Camera* old_value;
#line 32 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Views/ImportPage.vala"
	old_value = import_source_get_camera (self);
#line 32 "../src/Views/ImportPage.vala"
	if (old_value != value) {
#line 1293 "ImportPage.c"
		Camera* _tmp0_;
#line 32 "../src/Views/ImportPage.vala"
		_tmp0_ = _GPHOTO_REF_CAMERA0 (value);
#line 32 "../src/Views/ImportPage.vala"
		_gp_camera_unref0 (self->priv->_camera);
#line 32 "../src/Views/ImportPage.vala"
		self->priv->_camera = _tmp0_;
#line 32 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, import_source_properties[IMPORT_SOURCE_CAMERA_PROPERTY]);
#line 1303 "ImportPage.c"
	}
}

gint
import_source_get_fsid (ImportSource* self)
{
	gint result;
#line 33 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../src/Views/ImportPage.vala"
	result = self->priv->_fsid;
#line 33 "../src/Views/ImportPage.vala"
	return result;
#line 1317 "ImportPage.c"
}

static void
import_source_set_fsid (ImportSource* self,
                        gint value)
{
	gint old_value;
#line 33 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Views/ImportPage.vala"
	old_value = import_source_get_fsid (self);
#line 33 "../src/Views/ImportPage.vala"
	if (old_value != value) {
#line 33 "../src/Views/ImportPage.vala"
		self->priv->_fsid = value;
#line 33 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, import_source_properties[IMPORT_SOURCE_FSID_PROPERTY]);
#line 1335 "ImportPage.c"
	}
}

const gchar*
import_source_get_camera_name (ImportSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->_camera_name;
#line 34 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 34 "../src/Views/ImportPage.vala"
	return result;
#line 1352 "ImportPage.c"
}

static void
import_source_set_camera_name (ImportSource* self,
                               const gchar* value)
{
	gchar* old_value;
#line 34 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Views/ImportPage.vala"
	old_value = import_source_get_camera_name (self);
#line 34 "../src/Views/ImportPage.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1366 "ImportPage.c"
		gchar* _tmp0_;
#line 34 "../src/Views/ImportPage.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/Views/ImportPage.vala"
		_g_free0 (self->priv->_camera_name);
#line 34 "../src/Views/ImportPage.vala"
		self->priv->_camera_name = _tmp0_;
#line 34 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, import_source_properties[IMPORT_SOURCE_CAMERA_NAME_PROPERTY]);
#line 1376 "ImportPage.c"
	}
}

const gchar*
import_source_get_filename (ImportSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->_filename;
#line 35 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 35 "../src/Views/ImportPage.vala"
	return result;
#line 1393 "ImportPage.c"
}

static void
import_source_set_filename (ImportSource* self,
                            const gchar* value)
{
	gchar* old_value;
#line 35 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Views/ImportPage.vala"
	old_value = import_source_get_filename (self);
#line 35 "../src/Views/ImportPage.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1407 "ImportPage.c"
		gchar* _tmp0_;
#line 35 "../src/Views/ImportPage.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/Views/ImportPage.vala"
		_g_free0 (self->priv->_filename);
#line 35 "../src/Views/ImportPage.vala"
		self->priv->_filename = _tmp0_;
#line 35 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, import_source_properties[IMPORT_SOURCE_FILENAME_PROPERTY]);
#line 1417 "ImportPage.c"
	}
}

const gchar*
import_source_get_folder (ImportSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->_folder;
#line 36 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 36 "../src/Views/ImportPage.vala"
	return result;
#line 1434 "ImportPage.c"
}

static void
import_source_set_folder (ImportSource* self,
                          const gchar* value)
{
	gchar* old_value;
#line 36 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Views/ImportPage.vala"
	old_value = import_source_get_folder (self);
#line 36 "../src/Views/ImportPage.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1448 "ImportPage.c"
		gchar* _tmp0_;
#line 36 "../src/Views/ImportPage.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../src/Views/ImportPage.vala"
		_g_free0 (self->priv->_folder);
#line 36 "../src/Views/ImportPage.vala"
		self->priv->_folder = _tmp0_;
#line 36 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, import_source_properties[IMPORT_SOURCE_FOLDER_PROPERTY]);
#line 1458 "ImportPage.c"
	}
}

gulong
import_source_get_file_size (ImportSource* self)
{
	gulong result;
#line 37 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 37 "../src/Views/ImportPage.vala"
	result = self->priv->_file_size;
#line 37 "../src/Views/ImportPage.vala"
	return result;
#line 1472 "ImportPage.c"
}

static void
import_source_set_file_size (ImportSource* self,
                             gulong value)
{
	gulong old_value;
#line 37 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Views/ImportPage.vala"
	old_value = import_source_get_file_size (self);
#line 37 "../src/Views/ImportPage.vala"
	if (old_value != value) {
#line 37 "../src/Views/ImportPage.vala"
		self->priv->_file_size = value;
#line 37 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, import_source_properties[IMPORT_SOURCE_FILE_SIZE_PROPERTY]);
#line 1490 "ImportPage.c"
	}
}

static void
import_source_class_init (ImportSourceClass * klass,
                          gpointer klass_data)
{
#line 31 "../src/Views/ImportPage.vala"
	import_source_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/Views/ImportPage.vala"
	g_type_class_adjust_private_offset (klass, &ImportSource_private_offset);
#line 31 "../src/Views/ImportPage.vala"
	((ImportSourceClass *) klass)->get_preview = (GdkPixbuf* (*) (ImportSource*)) import_source_real_get_preview;
#line 31 "../src/Views/ImportPage.vala"
	((ImportSourceClass *) klass)->get_exposure_time = (gint64 (*) (ImportSource*)) import_source_real_get_exposure_time;
#line 31 "../src/Views/ImportPage.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) import_source_real_to_string;
#line 31 "../src/Views/ImportPage.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) import_source_real_internal_delete_backing;
#line 31 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_import_source_get_property;
#line 31 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_import_source_set_property;
#line 31 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->finalize = import_source_finalize;
#line 31 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMPORT_SOURCE_CAMERA_PROPERTY, import_source_properties[IMPORT_SOURCE_CAMERA_PROPERTY] = g_param_spec_pointer ("camera", "camera", "camera", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 31 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMPORT_SOURCE_FSID_PROPERTY, import_source_properties[IMPORT_SOURCE_FSID_PROPERTY] = g_param_spec_int ("fsid", "fsid", "fsid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 31 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMPORT_SOURCE_CAMERA_NAME_PROPERTY, import_source_properties[IMPORT_SOURCE_CAMERA_NAME_PROPERTY] = g_param_spec_string ("camera-name", "camera-name", "camera-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 31 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMPORT_SOURCE_FILENAME_PROPERTY, import_source_properties[IMPORT_SOURCE_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 31 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMPORT_SOURCE_FOLDER_PROPERTY, import_source_properties[IMPORT_SOURCE_FOLDER_PROPERTY] = g_param_spec_string ("folder", "folder", "folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 31 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMPORT_SOURCE_FILE_SIZE_PROPERTY, import_source_properties[IMPORT_SOURCE_FILE_SIZE_PROPERTY] = g_param_spec_ulong ("file-size", "file-size", "file-size", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1528 "ImportPage.c"
}

static void
import_source_indexable_interface_init (IndexableIface * iface,
                                        gpointer iface_data)
{
#line 31 "../src/Views/ImportPage.vala"
	import_source_indexable_parent_iface = g_type_interface_peek_parent (iface);
#line 31 "../src/Views/ImportPage.vala"
	iface->get_indexable_keywords = (const gchar* (*) (Indexable*)) import_source_real_get_indexable_keywords;
#line 1539 "ImportPage.c"
}

static void
import_source_instance_init (ImportSource * self,
                             gpointer klass)
{
#line 31 "../src/Views/ImportPage.vala"
	self->priv = import_source_get_instance_private (self);
#line 40 "../src/Views/ImportPage.vala"
	self->priv->preview = NULL;
#line 41 "../src/Views/ImportPage.vala"
	self->priv->indexable_keywords = NULL;
#line 1552 "ImportPage.c"
}

static void
import_source_finalize (GObject * obj)
{
	ImportSource * self;
#line 31 "../src/Views/ImportPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMPORT_SOURCE, ImportSource);
#line 32 "../src/Views/ImportPage.vala"
	_gp_camera_unref0 (self->priv->_camera);
#line 34 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->_camera_name);
#line 35 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->_filename);
#line 36 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->_folder);
#line 40 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->preview);
#line 41 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->indexable_keywords);
#line 31 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (import_source_parent_class)->finalize (obj);
#line 1575 "ImportPage.c"
}

static GType
import_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImportSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportSource), 0, (GInstanceInitFunc) import_source_instance_init, NULL };
	static const GInterfaceInfo indexable_info = { (GInterfaceInitFunc) import_source_indexable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType import_source_type_id;
	import_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "ImportSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (import_source_type_id, TYPE_INDEXABLE, &indexable_info);
	ImportSource_private_offset = g_type_add_instance_private (import_source_type_id, sizeof (ImportSourcePrivate));
	return import_source_type_id;
}

GType
import_source_get_type (void)
{
	static volatile gsize import_source_type_id__once = 0;
	if (g_once_init_enter (&import_source_type_id__once)) {
		GType import_source_type_id;
		import_source_type_id = import_source_get_type_once ();
		g_once_init_leave (&import_source_type_id__once, import_source_type_id);
	}
	return import_source_type_id__once;
}

static void
_vala_import_source_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	ImportSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_IMPORT_SOURCE, ImportSource);
#line 31 "../src/Views/ImportPage.vala"
	switch (property_id) {
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_CAMERA_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		g_value_set_pointer (value, import_source_get_camera (self));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_FSID_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		g_value_set_int (value, import_source_get_fsid (self));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_CAMERA_NAME_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		g_value_set_string (value, import_source_get_camera_name (self));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_FILENAME_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		g_value_set_string (value, import_source_get_filename (self));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_FOLDER_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		g_value_set_string (value, import_source_get_folder (self));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_FILE_SIZE_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		g_value_set_ulong (value, import_source_get_file_size (self));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 1648 "ImportPage.c"
		default:
#line 31 "../src/Views/ImportPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 1654 "ImportPage.c"
	}
}

static void
_vala_import_source_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	ImportSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_IMPORT_SOURCE, ImportSource);
#line 31 "../src/Views/ImportPage.vala"
	switch (property_id) {
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_CAMERA_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		import_source_set_camera (self, g_value_get_pointer (value));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_FSID_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		import_source_set_fsid (self, g_value_get_int (value));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_CAMERA_NAME_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		import_source_set_camera_name (self, g_value_get_string (value));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_FILENAME_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		import_source_set_filename (self, g_value_get_string (value));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_FOLDER_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		import_source_set_folder (self, g_value_get_string (value));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 31 "../src/Views/ImportPage.vala"
		case IMPORT_SOURCE_FILE_SIZE_PROPERTY:
#line 31 "../src/Views/ImportPage.vala"
		import_source_set_file_size (self, g_value_get_ulong (value));
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 1704 "ImportPage.c"
		default:
#line 31 "../src/Views/ImportPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/Views/ImportPage.vala"
		break;
#line 1710 "ImportPage.c"
	}
}

VideoImportSource*
video_import_source_construct (GType object_type,
                               const gchar* camera_name,
                               Camera* camera,
                               gint fsid,
                               const gchar* folder,
                               const gchar* filename,
                               gulong file_size,
                               gint64 modification_time)
{
	VideoImportSource * self = NULL;
#line 105 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera_name != NULL, NULL);
#line 105 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera != NULL, NULL);
#line 105 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (folder != NULL, NULL);
#line 105 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 107 "../src/Views/ImportPage.vala"
	self = (VideoImportSource*) import_source_construct (object_type, camera_name, camera, fsid, folder, filename, file_size, modification_time);
#line 105 "../src/Views/ImportPage.vala"
	return self;
#line 1737 "ImportPage.c"
}

VideoImportSource*
video_import_source_new (const gchar* camera_name,
                         Camera* camera,
                         gint fsid,
                         const gchar* folder,
                         const gchar* filename,
                         gulong file_size,
                         gint64 modification_time)
{
#line 105 "../src/Views/ImportPage.vala"
	return video_import_source_construct (TYPE_VIDEO_IMPORT_SOURCE, camera_name, camera, fsid, folder, filename, file_size, modification_time);
#line 1751 "ImportPage.c"
}

static GdkPixbuf*
video_import_source_real_get_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error)
{
	VideoImportSource * self;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 110 "../src/Views/ImportPage.vala"
	self = (VideoImportSource*) base;
#line 111 "../src/Views/ImportPage.vala"
	_tmp1_ = thumbnail_source_create_thumbnail ((ThumbnailSource*) self, scale, &_inner_error0_);
#line 111 "../src/Views/ImportPage.vala"
	_tmp0_ = _tmp1_;
#line 111 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/Views/ImportPage.vala"
		g_propagate_error (error, _inner_error0_);
#line 111 "../src/Views/ImportPage.vala"
		return NULL;
#line 1777 "ImportPage.c"
	}
#line 111 "../src/Views/ImportPage.vala"
	_tmp2_ = _tmp0_;
#line 111 "../src/Views/ImportPage.vala"
	_tmp0_ = NULL;
#line 111 "../src/Views/ImportPage.vala"
	result = _tmp2_;
#line 111 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp0_);
#line 111 "../src/Views/ImportPage.vala"
	return result;
#line 1789 "ImportPage.c"
}

static GdkPixbuf*
video_import_source_real_create_thumbnail (ThumbnailSource* base,
                                           gint scale,
                                           GError** error)
{
	VideoImportSource * self;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	gboolean _tmp2_;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* result;
#line 114 "../src/Views/ImportPage.vala"
	self = (VideoImportSource*) base;
#line 115 "../src/Views/ImportPage.vala"
	_tmp0_ = import_source_get_preview ((ImportSource*) self);
#line 115 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 115 "../src/Views/ImportPage.vala"
	_tmp2_ = _tmp1_ == NULL;
#line 115 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp1_);
#line 115 "../src/Views/ImportPage.vala"
	if (_tmp2_) {
#line 116 "../src/Views/ImportPage.vala"
		result = NULL;
#line 116 "../src/Views/ImportPage.vala"
		return result;
#line 1819 "ImportPage.c"
	}
#line 120 "../src/Views/ImportPage.vala"
	if (scale > 0) {
#line 1823 "ImportPage.c"
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 120 "../src/Views/ImportPage.vala"
		_tmp4_ = import_source_get_preview ((ImportSource*) self);
#line 120 "../src/Views/ImportPage.vala"
		_tmp5_ = _tmp4_;
#line 120 "../src/Views/ImportPage.vala"
		_tmp6_ = scale_pixbuf (_tmp5_, scale, GDK_INTERP_BILINEAR, TRUE);
#line 120 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp3_);
#line 120 "../src/Views/ImportPage.vala"
		_tmp3_ = _tmp6_;
#line 120 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp5_);
#line 1839 "ImportPage.c"
	} else {
		GdkPixbuf* _tmp7_;
#line 121 "../src/Views/ImportPage.vala"
		_tmp7_ = import_source_get_preview ((ImportSource*) self);
#line 121 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp3_);
#line 121 "../src/Views/ImportPage.vala"
		_tmp3_ = _tmp7_;
#line 1848 "ImportPage.c"
	}
#line 120 "../src/Views/ImportPage.vala"
	result = _tmp3_;
#line 120 "../src/Views/ImportPage.vala"
	return result;
#line 1854 "ImportPage.c"
}

static gchar*
video_import_source_real_get_typename (DataSource* base)
{
	VideoImportSource * self;
	gchar* _tmp0_;
	gchar* result;
#line 124 "../src/Views/ImportPage.vala"
	self = (VideoImportSource*) base;
#line 125 "../src/Views/ImportPage.vala"
	_tmp0_ = g_strdup ("videoimport");
#line 125 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 125 "../src/Views/ImportPage.vala"
	return result;
#line 1871 "ImportPage.c"
}

static gint64
video_import_source_real_get_instance_id (DataSource* base)
{
	VideoImportSource * self;
	gint64 result;
#line 128 "../src/Views/ImportPage.vala"
	self = (VideoImportSource*) base;
#line 129 "../src/Views/ImportPage.vala"
	result = data_object_get_object_id ((DataObject*) self);
#line 129 "../src/Views/ImportPage.vala"
	return result;
#line 1885 "ImportPage.c"
}

static PhotoFileFormat
video_import_source_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	VideoImportSource * self;
	PhotoFileFormat result;
#line 132 "../src/Views/ImportPage.vala"
	self = (VideoImportSource*) base;
#line 133 "../src/Views/ImportPage.vala"
	result = photo_file_format_get_system_default_format ();
#line 133 "../src/Views/ImportPage.vala"
	return result;
#line 1899 "ImportPage.c"
}

static gchar*
video_import_source_real_get_name (DataObject* base)
{
	VideoImportSource * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 136 "../src/Views/ImportPage.vala"
	self = (VideoImportSource*) base;
#line 137 "../src/Views/ImportPage.vala"
	_tmp0_ = import_source_get_filename ((ImportSource*) self);
#line 137 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 137 "../src/Views/ImportPage.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 137 "../src/Views/ImportPage.vala"
	result = _tmp2_;
#line 137 "../src/Views/ImportPage.vala"
	return result;
#line 1922 "ImportPage.c"
}

void
video_import_source_update (VideoImportSource* self,
                            GdkPixbuf* preview)
{
	GdkPixbuf* _tmp0_ = NULL;
#line 140 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/Views/ImportPage.vala"
	if (preview != NULL) {
#line 1934 "ImportPage.c"
		GdkPixbuf* _tmp1_;
#line 141 "../src/Views/ImportPage.vala"
		_tmp1_ = _g_object_ref0 (preview);
#line 141 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp0_);
#line 141 "../src/Views/ImportPage.vala"
		_tmp0_ = _tmp1_;
#line 1942 "ImportPage.c"
	} else {
		GdkPixbuf* _tmp2_;
#line 141 "../src/Views/ImportPage.vala"
		_tmp2_ = resources_get_noninterpretable_badge_pixbuf ();
#line 141 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp0_);
#line 141 "../src/Views/ImportPage.vala"
		_tmp0_ = _tmp2_;
#line 1951 "ImportPage.c"
	}
#line 141 "../src/Views/ImportPage.vala"
	import_source_set_preview ((ImportSource*) self, _tmp0_);
#line 140 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp0_);
#line 1957 "ImportPage.c"
}

static void
video_import_source_class_init (VideoImportSourceClass * klass,
                                gpointer klass_data)
{
#line 104 "../src/Views/ImportPage.vala"
	video_import_source_parent_class = g_type_class_peek_parent (klass);
#line 104 "../src/Views/ImportPage.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) video_import_source_real_get_thumbnail;
#line 104 "../src/Views/ImportPage.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) video_import_source_real_create_thumbnail;
#line 104 "../src/Views/ImportPage.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) video_import_source_real_get_typename;
#line 104 "../src/Views/ImportPage.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) video_import_source_real_get_instance_id;
#line 104 "../src/Views/ImportPage.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) video_import_source_real_get_preferred_thumbnail_format;
#line 104 "../src/Views/ImportPage.vala"
	((DataObjectClass *) klass)->get_name = (gchar* (*) (DataObject*)) video_import_source_real_get_name;
#line 1978 "ImportPage.c"
}

static void
video_import_source_instance_init (VideoImportSource * self,
                                   gpointer klass)
{
}

static GType
video_import_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VideoImportSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_import_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoImportSource), 0, (GInstanceInitFunc) video_import_source_instance_init, NULL };
	GType video_import_source_type_id;
	video_import_source_type_id = g_type_register_static (TYPE_IMPORT_SOURCE, "VideoImportSource", &g_define_type_info, 0);
	return video_import_source_type_id;
}

GType
video_import_source_get_type (void)
{
	static volatile gsize video_import_source_type_id__once = 0;
	if (g_once_init_enter (&video_import_source_type_id__once)) {
		GType video_import_source_type_id;
		video_import_source_type_id = video_import_source_get_type_once ();
		g_once_init_leave (&video_import_source_type_id__once, video_import_source_type_id);
	}
	return video_import_source_type_id__once;
}

static inline gpointer
photo_import_source_get_instance_private (PhotoImportSource* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoImportSource_private_offset);
}

PhotoImportSource*
photo_import_source_construct (GType object_type,
                               const gchar* camera_name,
                               Camera* camera,
                               gint fsid,
                               const gchar* folder,
                               const gchar* filename,
                               gulong file_size,
                               gint64 modification_time,
                               PhotoFileFormat file_format)
{
	PhotoImportSource * self = NULL;
#line 154 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera_name != NULL, NULL);
#line 154 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera != NULL, NULL);
#line 154 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (folder != NULL, NULL);
#line 154 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 156 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) import_source_construct (object_type, camera_name, camera, fsid, folder, filename, file_size, modification_time);
#line 157 "../src/Views/ImportPage.vala"
	self->priv->file_format = file_format;
#line 154 "../src/Views/ImportPage.vala"
	return self;
#line 2040 "ImportPage.c"
}

PhotoImportSource*
photo_import_source_new (const gchar* camera_name,
                         Camera* camera,
                         gint fsid,
                         const gchar* folder,
                         const gchar* filename,
                         gulong file_size,
                         gint64 modification_time,
                         PhotoFileFormat file_format)
{
#line 154 "../src/Views/ImportPage.vala"
	return photo_import_source_construct (TYPE_PHOTO_IMPORT_SOURCE, camera_name, camera, fsid, folder, filename, file_size, modification_time, file_format);
#line 2055 "ImportPage.c"
}

static gchar*
photo_import_source_real_get_name (DataObject* base)
{
	PhotoImportSource * self;
	gchar* title = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* _tmp6_;
	gchar* result;
#line 160 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 161 "../src/Views/ImportPage.vala"
	_tmp0_ = photo_import_source_get_title (self);
#line 161 "../src/Views/ImportPage.vala"
	title = _tmp0_;
#line 163 "../src/Views/ImportPage.vala"
	_tmp2_ = title;
#line 163 "../src/Views/ImportPage.vala"
	if (!is_string_empty (_tmp2_)) {
#line 2078 "ImportPage.c"
		const gchar* _tmp3_;
#line 163 "../src/Views/ImportPage.vala"
		_tmp3_ = title;
#line 163 "../src/Views/ImportPage.vala"
		_tmp1_ = _tmp3_;
#line 2084 "ImportPage.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 163 "../src/Views/ImportPage.vala"
		_tmp4_ = import_source_get_filename ((ImportSource*) self);
#line 163 "../src/Views/ImportPage.vala"
		_tmp5_ = _tmp4_;
#line 163 "../src/Views/ImportPage.vala"
		_tmp1_ = _tmp5_;
#line 2094 "ImportPage.c"
	}
#line 163 "../src/Views/ImportPage.vala"
	_tmp6_ = g_strdup (_tmp1_);
#line 163 "../src/Views/ImportPage.vala"
	result = _tmp6_;
#line 163 "../src/Views/ImportPage.vala"
	_g_free0 (title);
#line 163 "../src/Views/ImportPage.vala"
	return result;
#line 2104 "ImportPage.c"
}

static gchar*
photo_import_source_real_get_typename (DataSource* base)
{
	PhotoImportSource * self;
	gchar* _tmp0_;
	gchar* result;
#line 166 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 167 "../src/Views/ImportPage.vala"
	_tmp0_ = g_strdup ("photoimport");
#line 167 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 167 "../src/Views/ImportPage.vala"
	return result;
#line 2121 "ImportPage.c"
}

static gint64
photo_import_source_real_get_instance_id (DataSource* base)
{
	PhotoImportSource * self;
	gint64 result;
#line 170 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 171 "../src/Views/ImportPage.vala"
	result = data_object_get_object_id ((DataObject*) self);
#line 171 "../src/Views/ImportPage.vala"
	return result;
#line 2135 "ImportPage.c"
}

static PhotoFileFormat
photo_import_source_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	PhotoImportSource * self;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat result;
#line 174 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 175 "../src/Views/ImportPage.vala"
	if (photo_file_format_can_write (self->priv->file_format)) {
#line 175 "../src/Views/ImportPage.vala"
		_tmp0_ = self->priv->file_format;
#line 2150 "ImportPage.c"
	} else {
#line 176 "../src/Views/ImportPage.vala"
		_tmp0_ = photo_file_format_get_system_default_format ();
#line 2154 "ImportPage.c"
	}
#line 175 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 175 "../src/Views/ImportPage.vala"
	return result;
#line 2160 "ImportPage.c"
}

static GdkPixbuf*
photo_import_source_real_create_thumbnail (ThumbnailSource* base,
                                           gint scale,
                                           GError** error)
{
	PhotoImportSource * self;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	gboolean _tmp2_;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* result;
#line 179 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 180 "../src/Views/ImportPage.vala"
	_tmp0_ = import_source_get_preview ((ImportSource*) self);
#line 180 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 180 "../src/Views/ImportPage.vala"
	_tmp2_ = _tmp1_ == NULL;
#line 180 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp1_);
#line 180 "../src/Views/ImportPage.vala"
	if (_tmp2_) {
#line 181 "../src/Views/ImportPage.vala"
		result = NULL;
#line 181 "../src/Views/ImportPage.vala"
		return result;
#line 2190 "ImportPage.c"
	}
#line 185 "../src/Views/ImportPage.vala"
	if (scale > 0) {
#line 2194 "ImportPage.c"
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 185 "../src/Views/ImportPage.vala"
		_tmp4_ = import_source_get_preview ((ImportSource*) self);
#line 185 "../src/Views/ImportPage.vala"
		_tmp5_ = _tmp4_;
#line 185 "../src/Views/ImportPage.vala"
		_tmp6_ = scale_pixbuf (_tmp5_, scale, PHOTO_IMPORT_SOURCE_INTERP, TRUE);
#line 185 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp3_);
#line 185 "../src/Views/ImportPage.vala"
		_tmp3_ = _tmp6_;
#line 185 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp5_);
#line 2210 "ImportPage.c"
	} else {
		GdkPixbuf* _tmp7_;
#line 185 "../src/Views/ImportPage.vala"
		_tmp7_ = import_source_get_preview ((ImportSource*) self);
#line 185 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp3_);
#line 185 "../src/Views/ImportPage.vala"
		_tmp3_ = _tmp7_;
#line 2219 "ImportPage.c"
	}
#line 185 "../src/Views/ImportPage.vala"
	result = _tmp3_;
#line 185 "../src/Views/ImportPage.vala"
	return result;
#line 2225 "ImportPage.c"
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 192 "../src/Views/ImportPage.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 2233 "ImportPage.c"
}

void
photo_import_source_update (PhotoImportSource* self,
                            GdkPixbuf* preview,
                            const gchar* preview_md5,
                            PhotoMetadata* metadata,
                            const gchar* exif_md5)
{
	gchar* _tmp0_;
	PhotoMetadata* _tmp1_;
	gchar* _tmp2_;
#line 189 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/Views/ImportPage.vala"
	import_source_set_preview ((ImportSource*) self, preview);
#line 191 "../src/Views/ImportPage.vala"
	_tmp0_ = g_strdup (preview_md5);
#line 191 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->preview_md5);
#line 191 "../src/Views/ImportPage.vala"
	self->priv->preview_md5 = _tmp0_;
#line 192 "../src/Views/ImportPage.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 192 "../src/Views/ImportPage.vala"
	_media_metadata_unref0 (self->priv->metadata);
#line 192 "../src/Views/ImportPage.vala"
	self->priv->metadata = _tmp1_;
#line 193 "../src/Views/ImportPage.vala"
	_tmp2_ = g_strdup (exif_md5);
#line 193 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->exif_md5);
#line 193 "../src/Views/ImportPage.vala"
	self->priv->exif_md5 = _tmp2_;
#line 2268 "ImportPage.c"
}

static gint64
photo_import_source_real_get_exposure_time (ImportSource* base)
{
	PhotoImportSource * self;
	PhotoMetadata* _tmp0_;
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp2_;
	gint64 _tmp3_ = 0LL;
	MetadataDateTime* _tmp4_;
	gint64 result;
#line 196 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 197 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->metadata;
#line 197 "../src/Views/ImportPage.vala"
	if (_tmp0_ == NULL) {
#line 198 "../src/Views/ImportPage.vala"
		result = import_source_get_modification_time ((ImportSource*) self);
#line 198 "../src/Views/ImportPage.vala"
		return result;
#line 2292 "ImportPage.c"
	}
#line 200 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->metadata;
#line 200 "../src/Views/ImportPage.vala"
	_tmp2_ = photo_metadata_get_exposure_date_time (_tmp1_);
#line 200 "../src/Views/ImportPage.vala"
	date_time = _tmp2_;
#line 202 "../src/Views/ImportPage.vala"
	_tmp4_ = date_time;
#line 202 "../src/Views/ImportPage.vala"
	if (_tmp4_ != NULL) {
#line 2304 "ImportPage.c"
		MetadataDateTime* _tmp5_;
#line 202 "../src/Views/ImportPage.vala"
		_tmp5_ = date_time;
#line 202 "../src/Views/ImportPage.vala"
		_tmp3_ = metadata_date_time_get_timestamp (_tmp5_);
#line 2310 "ImportPage.c"
	} else {
#line 202 "../src/Views/ImportPage.vala"
		_tmp3_ = import_source_get_modification_time ((ImportSource*) self);
#line 2314 "ImportPage.c"
	}
#line 202 "../src/Views/ImportPage.vala"
	result = _tmp3_;
#line 202 "../src/Views/ImportPage.vala"
	_metadata_date_time_unref0 (date_time);
#line 202 "../src/Views/ImportPage.vala"
	return result;
#line 2322 "ImportPage.c"
}

gchar*
photo_import_source_get_title (PhotoImportSource* self)
{
	gchar* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_;
	gchar* result;
#line 205 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->metadata;
#line 206 "../src/Views/ImportPage.vala"
	if (_tmp1_ != NULL) {
#line 2337 "ImportPage.c"
		PhotoMetadata* _tmp2_;
		gchar* _tmp3_;
#line 206 "../src/Views/ImportPage.vala"
		_tmp2_ = self->priv->metadata;
#line 206 "../src/Views/ImportPage.vala"
		_tmp3_ = media_metadata_get_title ((MediaMetadata*) _tmp2_);
#line 206 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp0_);
#line 206 "../src/Views/ImportPage.vala"
		_tmp0_ = _tmp3_;
#line 2348 "ImportPage.c"
	} else {
#line 206 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp0_);
#line 206 "../src/Views/ImportPage.vala"
		_tmp0_ = NULL;
#line 2354 "ImportPage.c"
	}
#line 206 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 206 "../src/Views/ImportPage.vala"
	return result;
#line 2360 "ImportPage.c"
}

PhotoMetadata*
photo_import_source_get_metadata (PhotoImportSource* self)
{
	PhotoImportSource* _tmp0_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	PhotoMetadata* result;
#line 209 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->associated;
#line 210 "../src/Views/ImportPage.vala"
	if (_tmp0_ != NULL) {
#line 2376 "ImportPage.c"
		PhotoImportSource* _tmp1_;
		PhotoMetadata* _tmp2_;
#line 211 "../src/Views/ImportPage.vala"
		_tmp1_ = self->priv->associated;
#line 211 "../src/Views/ImportPage.vala"
		_tmp2_ = photo_import_source_get_metadata (_tmp1_);
#line 211 "../src/Views/ImportPage.vala"
		result = _tmp2_;
#line 211 "../src/Views/ImportPage.vala"
		return result;
#line 2387 "ImportPage.c"
	}
#line 213 "../src/Views/ImportPage.vala"
	_tmp3_ = self->priv->metadata;
#line 213 "../src/Views/ImportPage.vala"
	_tmp4_ = _media_metadata_ref0 (_tmp3_);
#line 213 "../src/Views/ImportPage.vala"
	result = _tmp4_;
#line 213 "../src/Views/ImportPage.vala"
	return result;
#line 2397 "ImportPage.c"
}

static GdkPixbuf*
photo_import_source_real_get_preview (ImportSource* base)
{
	PhotoImportSource * self;
	PhotoImportSource* _tmp0_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	gboolean _tmp5_;
	GdkPixbuf* result;
#line 216 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 217 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->associated;
#line 217 "../src/Views/ImportPage.vala"
	if (_tmp0_ != NULL) {
#line 2415 "ImportPage.c"
		PhotoImportSource* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 218 "../src/Views/ImportPage.vala"
		_tmp1_ = self->priv->associated;
#line 218 "../src/Views/ImportPage.vala"
		_tmp2_ = import_source_get_preview ((ImportSource*) _tmp1_);
#line 218 "../src/Views/ImportPage.vala"
		result = _tmp2_;
#line 218 "../src/Views/ImportPage.vala"
		return result;
#line 2426 "ImportPage.c"
	}
#line 220 "../src/Views/ImportPage.vala"
	_tmp3_ = IMPORT_SOURCE_CLASS (photo_import_source_parent_class)->get_preview (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_IMPORT_SOURCE, ImportSource));
#line 220 "../src/Views/ImportPage.vala"
	_tmp4_ = _tmp3_;
#line 220 "../src/Views/ImportPage.vala"
	_tmp5_ = _tmp4_ != NULL;
#line 220 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp4_);
#line 220 "../src/Views/ImportPage.vala"
	if (_tmp5_) {
#line 2438 "ImportPage.c"
		GdkPixbuf* _tmp6_;
#line 221 "../src/Views/ImportPage.vala"
		_tmp6_ = IMPORT_SOURCE_CLASS (photo_import_source_parent_class)->get_preview (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_IMPORT_SOURCE, ImportSource));
#line 221 "../src/Views/ImportPage.vala"
		result = _tmp6_;
#line 221 "../src/Views/ImportPage.vala"
		return result;
#line 2446 "ImportPage.c"
	}
#line 223 "../src/Views/ImportPage.vala"
	result = NULL;
#line 223 "../src/Views/ImportPage.vala"
	return result;
#line 2452 "ImportPage.c"
}

static GdkPixbuf*
photo_import_source_real_get_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error)
{
	PhotoImportSource * self;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	gboolean _tmp2_;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* result;
#line 226 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 227 "../src/Views/ImportPage.vala"
	_tmp0_ = import_source_get_preview ((ImportSource*) self);
#line 227 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 227 "../src/Views/ImportPage.vala"
	_tmp2_ = _tmp1_ == NULL;
#line 227 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp1_);
#line 227 "../src/Views/ImportPage.vala"
	if (_tmp2_) {
#line 228 "../src/Views/ImportPage.vala"
		result = NULL;
#line 228 "../src/Views/ImportPage.vala"
		return result;
#line 2482 "ImportPage.c"
	}
#line 230 "../src/Views/ImportPage.vala"
	if (scale > 0) {
#line 2486 "ImportPage.c"
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 230 "../src/Views/ImportPage.vala"
		_tmp4_ = import_source_get_preview ((ImportSource*) self);
#line 230 "../src/Views/ImportPage.vala"
		_tmp5_ = _tmp4_;
#line 230 "../src/Views/ImportPage.vala"
		_tmp6_ = scale_pixbuf (_tmp5_, scale, PHOTO_IMPORT_SOURCE_INTERP, TRUE);
#line 230 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp3_);
#line 230 "../src/Views/ImportPage.vala"
		_tmp3_ = _tmp6_;
#line 230 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp5_);
#line 2502 "ImportPage.c"
	} else {
		GdkPixbuf* _tmp7_;
#line 230 "../src/Views/ImportPage.vala"
		_tmp7_ = import_source_get_preview ((ImportSource*) self);
#line 230 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp3_);
#line 230 "../src/Views/ImportPage.vala"
		_tmp3_ = _tmp7_;
#line 2511 "ImportPage.c"
	}
#line 230 "../src/Views/ImportPage.vala"
	result = _tmp3_;
#line 230 "../src/Views/ImportPage.vala"
	return result;
#line 2517 "ImportPage.c"
}

PhotoFileFormat
photo_import_source_get_file_format (PhotoImportSource* self)
{
	PhotoFileFormat result;
#line 233 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 234 "../src/Views/ImportPage.vala"
	result = self->priv->file_format;
#line 234 "../src/Views/ImportPage.vala"
	return result;
#line 2530 "ImportPage.c"
}

gchar*
photo_import_source_get_preview_md5 (PhotoImportSource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 237 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 238 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->preview_md5;
#line 238 "../src/Views/ImportPage.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 238 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 238 "../src/Views/ImportPage.vala"
	return result;
#line 2549 "ImportPage.c"
}

void
photo_import_source_set_associated (PhotoImportSource* self,
                                    PhotoImportSource* associated)
{
	PhotoImportSource* _tmp0_;
#line 241 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/Views/ImportPage.vala"
	_tmp0_ = _g_object_ref0 (associated);
#line 242 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->associated);
#line 242 "../src/Views/ImportPage.vala"
	self->priv->associated = _tmp0_;
#line 2565 "ImportPage.c"
}

PhotoImportSource*
photo_import_source_get_associated (PhotoImportSource* self)
{
	PhotoImportSource* _tmp0_;
	PhotoImportSource* _tmp1_;
	PhotoImportSource* result;
#line 245 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 246 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->associated;
#line 246 "../src/Views/ImportPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 246 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 246 "../src/Views/ImportPage.vala"
	return result;
#line 2584 "ImportPage.c"
}

static gboolean
photo_import_source_real_internal_delete_backing (DataSource* base,
                                                  GError** error)
{
	PhotoImportSource * self;
	gboolean ret = FALSE;
	PhotoImportSource* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 249 "../src/Views/ImportPage.vala"
	self = (PhotoImportSource*) base;
#line 250 "../src/Views/ImportPage.vala"
	ret = DATA_SOURCE_CLASS (photo_import_source_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_IMPORT_SOURCE, ImportSource), &_inner_error0_);
#line 250 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2602 "ImportPage.c"
		gboolean _tmp0_ = FALSE;
#line 250 "../src/Views/ImportPage.vala"
		g_propagate_error (error, _inner_error0_);
#line 250 "../src/Views/ImportPage.vala"
		return _tmp0_;
#line 2608 "ImportPage.c"
	}
#line 251 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->associated;
#line 251 "../src/Views/ImportPage.vala"
	if (_tmp1_ != NULL) {
#line 2614 "ImportPage.c"
		gboolean _tmp2_ = FALSE;
		PhotoImportSource* _tmp3_;
#line 252 "../src/Views/ImportPage.vala"
		_tmp3_ = self->priv->associated;
#line 252 "../src/Views/ImportPage.vala"
		_tmp2_ = data_source_internal_delete_backing ((DataSource*) _tmp3_, &_inner_error0_);
#line 252 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2623 "ImportPage.c"
			gboolean _tmp4_ = FALSE;
#line 252 "../src/Views/ImportPage.vala"
			g_propagate_error (error, _inner_error0_);
#line 252 "../src/Views/ImportPage.vala"
			return _tmp4_;
#line 2629 "ImportPage.c"
		}
#line 252 "../src/Views/ImportPage.vala"
		ret &= _tmp2_;
#line 2633 "ImportPage.c"
	}
#line 253 "../src/Views/ImportPage.vala"
	result = ret;
#line 253 "../src/Views/ImportPage.vala"
	return result;
#line 2639 "ImportPage.c"
}

static void
photo_import_source_class_init (PhotoImportSourceClass * klass,
                                gpointer klass_data)
{
#line 145 "../src/Views/ImportPage.vala"
	photo_import_source_parent_class = g_type_class_peek_parent (klass);
#line 145 "../src/Views/ImportPage.vala"
	g_type_class_adjust_private_offset (klass, &PhotoImportSource_private_offset);
#line 145 "../src/Views/ImportPage.vala"
	((DataObjectClass *) klass)->get_name = (gchar* (*) (DataObject*)) photo_import_source_real_get_name;
#line 145 "../src/Views/ImportPage.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) photo_import_source_real_get_typename;
#line 145 "../src/Views/ImportPage.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) photo_import_source_real_get_instance_id;
#line 145 "../src/Views/ImportPage.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) photo_import_source_real_get_preferred_thumbnail_format;
#line 145 "../src/Views/ImportPage.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) photo_import_source_real_create_thumbnail;
#line 145 "../src/Views/ImportPage.vala"
	((ImportSourceClass *) klass)->get_exposure_time = (gint64 (*) (ImportSource*)) photo_import_source_real_get_exposure_time;
#line 145 "../src/Views/ImportPage.vala"
	((ImportSourceClass *) klass)->get_preview = (GdkPixbuf* (*) (ImportSource*)) photo_import_source_real_get_preview;
#line 145 "../src/Views/ImportPage.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) photo_import_source_real_get_thumbnail;
#line 145 "../src/Views/ImportPage.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) photo_import_source_real_internal_delete_backing;
#line 145 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_import_source_finalize;
#line 2670 "ImportPage.c"
}

static void
photo_import_source_instance_init (PhotoImportSource * self,
                                   gpointer klass)
{
#line 145 "../src/Views/ImportPage.vala"
	self->priv = photo_import_source_get_instance_private (self);
#line 149 "../src/Views/ImportPage.vala"
	self->priv->preview_md5 = NULL;
#line 150 "../src/Views/ImportPage.vala"
	self->priv->metadata = NULL;
#line 151 "../src/Views/ImportPage.vala"
	self->priv->exif_md5 = NULL;
#line 152 "../src/Views/ImportPage.vala"
	self->priv->associated = NULL;
#line 2687 "ImportPage.c"
}

static void
photo_import_source_finalize (GObject * obj)
{
	PhotoImportSource * self;
#line 145 "../src/Views/ImportPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSource);
#line 149 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->preview_md5);
#line 150 "../src/Views/ImportPage.vala"
	_media_metadata_unref0 (self->priv->metadata);
#line 151 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->exif_md5);
#line 152 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->associated);
#line 145 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (photo_import_source_parent_class)->finalize (obj);
#line 2706 "ImportPage.c"
}

static GType
photo_import_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoImportSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportSource), 0, (GInstanceInitFunc) photo_import_source_instance_init, NULL };
	GType photo_import_source_type_id;
	photo_import_source_type_id = g_type_register_static (TYPE_IMPORT_SOURCE, "PhotoImportSource", &g_define_type_info, 0);
	PhotoImportSource_private_offset = g_type_add_instance_private (photo_import_source_type_id, sizeof (PhotoImportSourcePrivate));
	return photo_import_source_type_id;
}

GType
photo_import_source_get_type (void)
{
	static volatile gsize photo_import_source_type_id__once = 0;
	if (g_once_init_enter (&photo_import_source_type_id__once)) {
		GType photo_import_source_type_id;
		photo_import_source_type_id = photo_import_source_get_type_once ();
		g_once_init_leave (&photo_import_source_type_id__once, photo_import_source_type_id);
	}
	return photo_import_source_type_id__once;
}

static inline gpointer
import_preview_get_instance_private (ImportPreview* self)
{
	return G_STRUCT_MEMBER_P (self, ImportPreview_private_offset);
}

ImportPreview*
import_preview_construct (GType object_type,
                          ImportSource* source)
{
	ImportPreview * self = NULL;
	Dimensions _tmp0_ = {0};
	gchar* _tmp1_;
	gchar* _tmp2_;
	GdkPixbuf* pixbuf = NULL;
	gboolean using_placeholder = FALSE;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* _tmp11_;
	gboolean _tmp18_ = FALSE;
	GdkPixbuf* _tmp19_;
	GdkPixbuf* _tmp39_;
	GError* _inner_error0_ = NULL;
#line 264 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 265 "../src/Views/ImportPage.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 265 "../src/Views/ImportPage.vala"
	_tmp1_ = data_object_get_name ((DataObject*) source);
#line 265 "../src/Views/ImportPage.vala"
	_tmp2_ = _tmp1_;
#line 265 "../src/Views/ImportPage.vala"
	self = (ImportPreview*) checkerboard_item_construct (object_type, (ThumbnailSource*) source, &_tmp0_, _tmp2_, NULL, FALSE, PANGO_ALIGN_LEFT);
#line 265 "../src/Views/ImportPage.vala"
	_g_free0 (_tmp2_);
#line 267 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->duplicated_file);
#line 267 "../src/Views/ImportPage.vala"
	self->priv->duplicated_file = NULL;
#line 270 "../src/Views/ImportPage.vala"
	pixbuf = NULL;
#line 2771 "ImportPage.c"
	{
		GdkPixbuf* _tmp3_ = NULL;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
#line 272 "../src/Views/ImportPage.vala"
		_tmp4_ = thumbnail_source_get_thumbnail ((ThumbnailSource*) source, 0, &_inner_error0_);
#line 272 "../src/Views/ImportPage.vala"
		_tmp3_ = _tmp4_;
#line 272 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2782 "ImportPage.c"
			goto __catch0_g_error;
		}
#line 272 "../src/Views/ImportPage.vala"
		_tmp5_ = _tmp3_;
#line 272 "../src/Views/ImportPage.vala"
		_tmp3_ = NULL;
#line 272 "../src/Views/ImportPage.vala"
		_g_object_unref0 (pixbuf);
#line 272 "../src/Views/ImportPage.vala"
		pixbuf = _tmp5_;
#line 271 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp3_);
#line 2795 "ImportPage.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 271 "../src/Views/ImportPage.vala"
		err = _inner_error0_;
#line 271 "../src/Views/ImportPage.vala"
		_inner_error0_ = NULL;
#line 274 "../src/Views/ImportPage.vala"
		_tmp6_ = data_object_to_string ((DataObject*) self);
#line 274 "../src/Views/ImportPage.vala"
		_tmp7_ = _tmp6_;
#line 274 "../src/Views/ImportPage.vala"
		_tmp8_ = err;
#line 274 "../src/Views/ImportPage.vala"
		_tmp9_ = _tmp8_->message;
#line 274 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:274: Unable to fetch loaded import preview for %s: %s", _tmp7_, _tmp9_);
#line 274 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp7_);
#line 271 "../src/Views/ImportPage.vala"
		_g_error_free0 (err);
#line 2823 "ImportPage.c"
	}
	__finally0:
#line 271 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/Views/ImportPage.vala"
		_g_object_unref0 (pixbuf);
#line 271 "../src/Views/ImportPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/Views/ImportPage.vala"
		g_clear_error (&_inner_error0_);
#line 271 "../src/Views/ImportPage.vala"
		return NULL;
#line 2836 "ImportPage.c"
	}
#line 278 "../src/Views/ImportPage.vala"
	_tmp10_ = pixbuf;
#line 278 "../src/Views/ImportPage.vala"
	using_placeholder = _tmp10_ == NULL;
#line 279 "../src/Views/ImportPage.vala"
	_tmp11_ = pixbuf;
#line 279 "../src/Views/ImportPage.vala"
	if (_tmp11_ == NULL) {
#line 2846 "ImportPage.c"
		GdkPixbuf* _tmp12_;
		GdkPixbuf* _tmp16_;
		GdkPixbuf* _tmp17_;
#line 280 "../src/Views/ImportPage.vala"
		_tmp12_ = import_preview_placeholder_preview;
#line 280 "../src/Views/ImportPage.vala"
		if (_tmp12_ == NULL) {
#line 2854 "ImportPage.c"
			GdkPixbuf* _tmp13_;
			GdkPixbuf* _tmp14_;
			GdkPixbuf* _tmp15_;
#line 281 "../src/Views/ImportPage.vala"
			_tmp13_ = import_preview_get_placeholder_pixbuf (self);
#line 281 "../src/Views/ImportPage.vala"
			_g_object_unref0 (import_preview_placeholder_preview);
#line 281 "../src/Views/ImportPage.vala"
			import_preview_placeholder_preview = _tmp13_;
#line 282 "../src/Views/ImportPage.vala"
			_tmp14_ = import_preview_placeholder_preview;
#line 282 "../src/Views/ImportPage.vala"
			_tmp15_ = scale_pixbuf (_tmp14_, IMPORT_PREVIEW_MAX_SCALE, GDK_INTERP_BILINEAR, TRUE);
#line 282 "../src/Views/ImportPage.vala"
			_g_object_unref0 (import_preview_placeholder_preview);
#line 282 "../src/Views/ImportPage.vala"
			import_preview_placeholder_preview = _tmp15_;
#line 2872 "ImportPage.c"
		}
#line 286 "../src/Views/ImportPage.vala"
		_tmp16_ = import_preview_placeholder_preview;
#line 286 "../src/Views/ImportPage.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 286 "../src/Views/ImportPage.vala"
		_g_object_unref0 (pixbuf);
#line 286 "../src/Views/ImportPage.vala"
		pixbuf = _tmp17_;
#line 2882 "ImportPage.c"
	}
#line 290 "../src/Views/ImportPage.vala"
	_tmp19_ = pixbuf;
#line 290 "../src/Views/ImportPage.vala"
	if (gdk_pixbuf_get_width (_tmp19_) > IMPORT_PREVIEW_MAX_SCALE) {
#line 290 "../src/Views/ImportPage.vala"
		_tmp18_ = TRUE;
#line 2890 "ImportPage.c"
	} else {
		GdkPixbuf* _tmp20_;
#line 290 "../src/Views/ImportPage.vala"
		_tmp20_ = pixbuf;
#line 290 "../src/Views/ImportPage.vala"
		_tmp18_ = gdk_pixbuf_get_height (_tmp20_) > IMPORT_PREVIEW_MAX_SCALE;
#line 2897 "ImportPage.c"
	}
#line 290 "../src/Views/ImportPage.vala"
	if (_tmp18_) {
#line 2901 "ImportPage.c"
		GdkPixbuf* _tmp21_;
		GdkPixbuf* _tmp22_;
#line 291 "../src/Views/ImportPage.vala"
		_tmp21_ = pixbuf;
#line 291 "../src/Views/ImportPage.vala"
		_tmp22_ = scale_pixbuf (_tmp21_, IMPORT_PREVIEW_MAX_SCALE, PHOTO_IMPORT_SOURCE_INTERP, FALSE);
#line 291 "../src/Views/ImportPage.vala"
		_g_object_unref0 (pixbuf);
#line 291 "../src/Views/ImportPage.vala"
		pixbuf = _tmp22_;
#line 2912 "ImportPage.c"
	}
#line 293 "../src/Views/ImportPage.vala"
	if (IS_PHOTO_IMPORT_SOURCE (source)) {
#line 2916 "ImportPage.c"
		PhotoImportSource* photo_import_source = NULL;
		PhotoImportSource* _tmp23_;
		gboolean _tmp24_ = FALSE;
		PhotoImportSource* _tmp33_;
		PhotoImportSource* _tmp34_;
		PhotoImportSource* _tmp35_;
		gboolean _tmp36_;
#line 295 "../src/Views/ImportPage.vala"
		_tmp23_ = _g_object_ref0 (IS_PHOTO_IMPORT_SOURCE (source) ? ((PhotoImportSource*) source) : NULL);
#line 295 "../src/Views/ImportPage.vala"
		photo_import_source = _tmp23_;
#line 296 "../src/Views/ImportPage.vala"
		if (!using_placeholder) {
#line 2930 "ImportPage.c"
			PhotoImportSource* _tmp25_;
			PhotoMetadata* _tmp26_;
			PhotoMetadata* _tmp27_;
#line 296 "../src/Views/ImportPage.vala"
			_tmp25_ = photo_import_source;
#line 296 "../src/Views/ImportPage.vala"
			_tmp26_ = photo_import_source_get_metadata (_tmp25_);
#line 296 "../src/Views/ImportPage.vala"
			_tmp27_ = _tmp26_;
#line 296 "../src/Views/ImportPage.vala"
			_tmp24_ = _tmp27_ != NULL;
#line 296 "../src/Views/ImportPage.vala"
			_media_metadata_unref0 (_tmp27_);
#line 2944 "ImportPage.c"
		} else {
#line 296 "../src/Views/ImportPage.vala"
			_tmp24_ = FALSE;
#line 2948 "ImportPage.c"
		}
#line 296 "../src/Views/ImportPage.vala"
		if (_tmp24_) {
#line 2952 "ImportPage.c"
			PhotoImportSource* _tmp28_;
			PhotoMetadata* _tmp29_;
			PhotoMetadata* _tmp30_;
			GdkPixbuf* _tmp31_;
			GdkPixbuf* _tmp32_;
#line 297 "../src/Views/ImportPage.vala"
			_tmp28_ = photo_import_source;
#line 297 "../src/Views/ImportPage.vala"
			_tmp29_ = photo_import_source_get_metadata (_tmp28_);
#line 297 "../src/Views/ImportPage.vala"
			_tmp30_ = _tmp29_;
#line 297 "../src/Views/ImportPage.vala"
			_tmp31_ = pixbuf;
#line 297 "../src/Views/ImportPage.vala"
			_tmp32_ = orientation_rotate_pixbuf (photo_metadata_get_orientation (_tmp30_), _tmp31_);
#line 297 "../src/Views/ImportPage.vala"
			_g_object_unref0 (pixbuf);
#line 297 "../src/Views/ImportPage.vala"
			pixbuf = _tmp32_;
#line 297 "../src/Views/ImportPage.vala"
			_media_metadata_unref0 (_tmp30_);
#line 2974 "ImportPage.c"
		}
#line 299 "../src/Views/ImportPage.vala"
		_tmp33_ = photo_import_source;
#line 299 "../src/Views/ImportPage.vala"
		_tmp34_ = photo_import_source_get_associated (_tmp33_);
#line 299 "../src/Views/ImportPage.vala"
		_tmp35_ = _tmp34_;
#line 299 "../src/Views/ImportPage.vala"
		_tmp36_ = _tmp35_ != NULL;
#line 299 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp35_);
#line 299 "../src/Views/ImportPage.vala"
		if (_tmp36_) {
#line 2988 "ImportPage.c"
			gchar* _tmp37_;
			gchar* _tmp38_;
#line 300 "../src/Views/ImportPage.vala"
			_tmp37_ = g_strdup_printf ("<small>%s</small>", _ ("RAW+JPEG"));
#line 300 "../src/Views/ImportPage.vala"
			_tmp38_ = _tmp37_;
#line 300 "../src/Views/ImportPage.vala"
			checkerboard_item_set_subtitle ((CheckerboardItem*) self, _tmp38_, TRUE, PANGO_ALIGN_LEFT);
#line 300 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp38_);
#line 2999 "ImportPage.c"
		}
#line 293 "../src/Views/ImportPage.vala"
		_g_object_unref0 (photo_import_source);
#line 3003 "ImportPage.c"
	}
#line 304 "../src/Views/ImportPage.vala"
	_tmp39_ = pixbuf;
#line 304 "../src/Views/ImportPage.vala"
	checkerboard_item_set_image ((CheckerboardItem*) self, _tmp39_);
#line 264 "../src/Views/ImportPage.vala"
	_g_object_unref0 (pixbuf);
#line 264 "../src/Views/ImportPage.vala"
	return self;
#line 3013 "ImportPage.c"
}

ImportPreview*
import_preview_new (ImportSource* source)
{
#line 264 "../src/Views/ImportPage.vala"
	return import_preview_construct (TYPE_IMPORT_PREVIEW, source);
#line 3021 "ImportPage.c"
}

static GdkPixbuf*
import_preview_get_placeholder_pixbuf (ImportPreview* self)
{
	GdkPixbuf* pixbuf = NULL;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 307 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "../src/Views/ImportPage.vala"
	pixbuf = NULL;
#line 3034 "ImportPage.c"
	{
		GtkIconTheme* icon_theme = NULL;
		GtkIconTheme* _tmp0_;
		GtkIconTheme* _tmp1_;
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 311 "../src/Views/ImportPage.vala"
		_tmp0_ = gtk_icon_theme_get_default ();
#line 311 "../src/Views/ImportPage.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 311 "../src/Views/ImportPage.vala"
		icon_theme = _tmp1_;
#line 312 "../src/Views/ImportPage.vala"
		_tmp3_ = gtk_icon_theme_load_icon (icon_theme, "image-missing", 48, 0, &_inner_error0_);
#line 312 "../src/Views/ImportPage.vala"
		_tmp2_ = _tmp3_;
#line 312 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 312 "../src/Views/ImportPage.vala"
			_g_object_unref0 (icon_theme);
#line 3056 "ImportPage.c"
			goto __catch0_g_error;
		}
#line 312 "../src/Views/ImportPage.vala"
		_tmp4_ = _tmp2_;
#line 312 "../src/Views/ImportPage.vala"
		_tmp2_ = NULL;
#line 312 "../src/Views/ImportPage.vala"
		_g_object_unref0 (pixbuf);
#line 312 "../src/Views/ImportPage.vala"
		pixbuf = _tmp4_;
#line 310 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp2_);
#line 310 "../src/Views/ImportPage.vala"
		_g_object_unref0 (icon_theme);
#line 3071 "ImportPage.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 310 "../src/Views/ImportPage.vala"
		g_clear_error (&_inner_error0_);
#line 315 "../src/Views/ImportPage.vala"
		_tmp5_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, 48, 48);
#line 315 "../src/Views/ImportPage.vala"
		_g_object_unref0 (pixbuf);
#line 315 "../src/Views/ImportPage.vala"
		pixbuf = _tmp5_;
#line 316 "../src/Views/ImportPage.vala"
		_tmp6_ = pixbuf;
#line 316 "../src/Views/ImportPage.vala"
		gdk_pixbuf_fill (_tmp6_, (guint32) 0);
#line 3090 "ImportPage.c"
	}
	__finally0:
#line 310 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 310 "../src/Views/ImportPage.vala"
		_g_object_unref0 (pixbuf);
#line 310 "../src/Views/ImportPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 310 "../src/Views/ImportPage.vala"
		g_clear_error (&_inner_error0_);
#line 310 "../src/Views/ImportPage.vala"
		return NULL;
#line 3103 "ImportPage.c"
	}
#line 319 "../src/Views/ImportPage.vala"
	result = pixbuf;
#line 319 "../src/Views/ImportPage.vala"
	return result;
#line 3109 "ImportPage.c"
}

gboolean
import_preview_is_already_imported (ImportPreview* self)
{
	PhotoImportSource* photo_import_source = NULL;
	ImportSource* _tmp0_;
	PhotoImportSource* _tmp1_;
	PhotoImportSource* _tmp2_;
	VideoImportSource* video_import_source = NULL;
	ImportSource* _tmp30_;
	VideoImportSource* _tmp31_;
	VideoImportSource* _tmp32_;
	gboolean result;
#line 322 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 323 "../src/Views/ImportPage.vala"
	_tmp0_ = import_preview_get_import_source (self);
#line 323 "../src/Views/ImportPage.vala"
	_tmp1_ = IS_PHOTO_IMPORT_SOURCE (_tmp0_) ? ((PhotoImportSource*) _tmp0_) : NULL;
#line 323 "../src/Views/ImportPage.vala"
	if (_tmp1_ == NULL) {
#line 323 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp0_);
#line 3134 "ImportPage.c"
	}
#line 323 "../src/Views/ImportPage.vala"
	photo_import_source = _tmp1_;
#line 324 "../src/Views/ImportPage.vala"
	_tmp2_ = photo_import_source;
#line 324 "../src/Views/ImportPage.vala"
	if (_tmp2_ != NULL) {
#line 3142 "ImportPage.c"
		gchar* preview_md5 = NULL;
		PhotoImportSource* _tmp3_;
		gchar* _tmp4_;
		PhotoFileFormat file_format = 0;
		PhotoImportSource* _tmp5_;
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
#line 325 "../src/Views/ImportPage.vala"
		_tmp3_ = photo_import_source;
#line 325 "../src/Views/ImportPage.vala"
		_tmp4_ = photo_import_source_get_preview_md5 (_tmp3_);
#line 325 "../src/Views/ImportPage.vala"
		preview_md5 = _tmp4_;
#line 326 "../src/Views/ImportPage.vala"
		_tmp5_ = photo_import_source;
#line 326 "../src/Views/ImportPage.vala"
		file_format = photo_import_source_get_file_format (_tmp5_);
#line 329 "../src/Views/ImportPage.vala"
		_tmp7_ = preview_md5;
#line 329 "../src/Views/ImportPage.vala"
		if (!is_string_empty (_tmp7_)) {
#line 3164 "ImportPage.c"
			const gchar* _tmp8_;
#line 330 "../src/Views/ImportPage.vala"
			_tmp8_ = preview_md5;
#line 330 "../src/Views/ImportPage.vala"
			_tmp6_ = library_photo_has_nontrash_duplicate (NULL, _tmp8_, NULL, file_format);
#line 3170 "ImportPage.c"
		} else {
#line 329 "../src/Views/ImportPage.vala"
			_tmp6_ = FALSE;
#line 3174 "ImportPage.c"
		}
#line 329 "../src/Views/ImportPage.vala"
		if (_tmp6_) {
#line 3178 "ImportPage.c"
			const gchar* _tmp9_;
			PhotoID _tmp10_ = {0};
			DuplicatedFile* _tmp11_;
#line 332 "../src/Views/ImportPage.vala"
			_tmp9_ = preview_md5;
#line 332 "../src/Views/ImportPage.vala"
			library_photo_get_nontrash_duplicate (NULL, _tmp9_, NULL, file_format, &_tmp10_);
#line 332 "../src/Views/ImportPage.vala"
			_tmp11_ = duplicated_file_create_from_photo_id (&_tmp10_);
#line 332 "../src/Views/ImportPage.vala"
			_g_object_unref0 (self->priv->duplicated_file);
#line 332 "../src/Views/ImportPage.vala"
			self->priv->duplicated_file = _tmp11_;
#line 335 "../src/Views/ImportPage.vala"
			result = TRUE;
#line 335 "../src/Views/ImportPage.vala"
			_g_free0 (preview_md5);
#line 335 "../src/Views/ImportPage.vala"
			_g_object_unref0 (photo_import_source);
#line 335 "../src/Views/ImportPage.vala"
			return result;
#line 3200 "ImportPage.c"
		}
#line 341 "../src/Views/ImportPage.vala"
		if (file_format == PHOTO_FILE_FORMAT_RAW) {
#line 3204 "ImportPage.c"
			guint64 filesize = 0ULL;
			ImportSource* _tmp12_;
			ImportSource* _tmp13_;
			gulong _tmp14_;
			gulong _tmp15_;
			guint64 _tmp16_;
#line 342 "../src/Views/ImportPage.vala"
			_tmp12_ = import_preview_get_import_source (self);
#line 342 "../src/Views/ImportPage.vala"
			_tmp13_ = _tmp12_;
#line 342 "../src/Views/ImportPage.vala"
			_tmp14_ = import_source_get_file_size (_tmp13_);
#line 342 "../src/Views/ImportPage.vala"
			_tmp15_ = _tmp14_;
#line 342 "../src/Views/ImportPage.vala"
			_tmp16_ = (guint64) _tmp15_;
#line 342 "../src/Views/ImportPage.vala"
			_g_object_unref0 (_tmp13_);
#line 342 "../src/Views/ImportPage.vala"
			filesize = _tmp16_;
#line 344 "../src/Views/ImportPage.vala"
			if (filesize <= ((guint64) G_MAXINT64)) {
#line 3227 "ImportPage.c"
				LibraryPhotoSourceCollection* _tmp17_;
				ImportSource* _tmp18_;
				ImportSource* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				gboolean _tmp22_;
#line 345 "../src/Views/ImportPage.vala"
				_tmp17_ = library_photo_global;
#line 345 "../src/Views/ImportPage.vala"
				_tmp18_ = import_preview_get_import_source (self);
#line 345 "../src/Views/ImportPage.vala"
				_tmp19_ = _tmp18_;
#line 345 "../src/Views/ImportPage.vala"
				_tmp20_ = import_source_get_filename (_tmp19_);
#line 345 "../src/Views/ImportPage.vala"
				_tmp21_ = _tmp20_;
#line 345 "../src/Views/ImportPage.vala"
				_tmp22_ = library_photo_source_collection_has_basename_filesize_duplicate (_tmp17_, _tmp21_, (gint64) filesize);
#line 345 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp19_);
#line 345 "../src/Views/ImportPage.vala"
				if (_tmp22_) {
#line 3250 "ImportPage.c"
					LibraryPhotoSourceCollection* _tmp23_;
					ImportSource* _tmp24_;
					ImportSource* _tmp25_;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					PhotoID _tmp28_ = {0};
					DuplicatedFile* _tmp29_;
#line 348 "../src/Views/ImportPage.vala"
					_tmp23_ = library_photo_global;
#line 348 "../src/Views/ImportPage.vala"
					_tmp24_ = import_preview_get_import_source (self);
#line 348 "../src/Views/ImportPage.vala"
					_tmp25_ = _tmp24_;
#line 348 "../src/Views/ImportPage.vala"
					_tmp26_ = import_source_get_filename (_tmp25_);
#line 348 "../src/Views/ImportPage.vala"
					_tmp27_ = _tmp26_;
#line 348 "../src/Views/ImportPage.vala"
					library_photo_source_collection_get_basename_filesize_duplicate (_tmp23_, _tmp27_, (gint64) filesize, &_tmp28_);
#line 348 "../src/Views/ImportPage.vala"
					_tmp29_ = duplicated_file_create_from_photo_id (&_tmp28_);
#line 348 "../src/Views/ImportPage.vala"
					_g_object_unref0 (self->priv->duplicated_file);
#line 348 "../src/Views/ImportPage.vala"
					self->priv->duplicated_file = _tmp29_;
#line 348 "../src/Views/ImportPage.vala"
					_g_object_unref0 (_tmp25_);
#line 352 "../src/Views/ImportPage.vala"
					result = TRUE;
#line 352 "../src/Views/ImportPage.vala"
					_g_free0 (preview_md5);
#line 352 "../src/Views/ImportPage.vala"
					_g_object_unref0 (photo_import_source);
#line 352 "../src/Views/ImportPage.vala"
					return result;
#line 3286 "ImportPage.c"
				}
			}
		}
#line 357 "../src/Views/ImportPage.vala"
		result = FALSE;
#line 357 "../src/Views/ImportPage.vala"
		_g_free0 (preview_md5);
#line 357 "../src/Views/ImportPage.vala"
		_g_object_unref0 (photo_import_source);
#line 357 "../src/Views/ImportPage.vala"
		return result;
#line 3298 "ImportPage.c"
	}
#line 360 "../src/Views/ImportPage.vala"
	_tmp30_ = import_preview_get_import_source (self);
#line 360 "../src/Views/ImportPage.vala"
	_tmp31_ = IS_VIDEO_IMPORT_SOURCE (_tmp30_) ? ((VideoImportSource*) _tmp30_) : NULL;
#line 360 "../src/Views/ImportPage.vala"
	if (_tmp31_ == NULL) {
#line 360 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp30_);
#line 3308 "ImportPage.c"
	}
#line 360 "../src/Views/ImportPage.vala"
	video_import_source = _tmp31_;
#line 361 "../src/Views/ImportPage.vala"
	_tmp32_ = video_import_source;
#line 361 "../src/Views/ImportPage.vala"
	if (_tmp32_ != NULL) {
#line 3316 "ImportPage.c"
		VideoSourceCollection* _tmp33_;
		VideoImportSource* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		VideoImportSource* _tmp37_;
		gulong _tmp38_;
		gulong _tmp39_;
#line 366 "../src/Views/ImportPage.vala"
		_tmp33_ = video_global;
#line 366 "../src/Views/ImportPage.vala"
		_tmp34_ = video_import_source;
#line 366 "../src/Views/ImportPage.vala"
		_tmp35_ = import_source_get_filename ((ImportSource*) _tmp34_);
#line 366 "../src/Views/ImportPage.vala"
		_tmp36_ = _tmp35_;
#line 366 "../src/Views/ImportPage.vala"
		_tmp37_ = video_import_source;
#line 366 "../src/Views/ImportPage.vala"
		_tmp38_ = import_source_get_file_size ((ImportSource*) _tmp37_);
#line 366 "../src/Views/ImportPage.vala"
		_tmp39_ = _tmp38_;
#line 366 "../src/Views/ImportPage.vala"
		if (video_source_collection_has_basename_filesize_duplicate (_tmp33_, _tmp36_, (guint64) _tmp39_)) {
#line 3340 "ImportPage.c"
			VideoSourceCollection* _tmp40_;
			VideoImportSource* _tmp41_;
			const gchar* _tmp42_;
			const gchar* _tmp43_;
			VideoImportSource* _tmp44_;
			gulong _tmp45_;
			gulong _tmp46_;
			VideoID _tmp47_ = {0};
			DuplicatedFile* _tmp48_;
#line 369 "../src/Views/ImportPage.vala"
			_tmp40_ = video_global;
#line 369 "../src/Views/ImportPage.vala"
			_tmp41_ = video_import_source;
#line 369 "../src/Views/ImportPage.vala"
			_tmp42_ = import_source_get_filename ((ImportSource*) _tmp41_);
#line 369 "../src/Views/ImportPage.vala"
			_tmp43_ = _tmp42_;
#line 369 "../src/Views/ImportPage.vala"
			_tmp44_ = video_import_source;
#line 369 "../src/Views/ImportPage.vala"
			_tmp45_ = import_source_get_file_size ((ImportSource*) _tmp44_);
#line 369 "../src/Views/ImportPage.vala"
			_tmp46_ = _tmp45_;
#line 369 "../src/Views/ImportPage.vala"
			video_source_collection_get_basename_filesize_duplicate (_tmp40_, _tmp43_, (guint64) _tmp46_, &_tmp47_);
#line 369 "../src/Views/ImportPage.vala"
			_tmp48_ = duplicated_file_create_from_video_id (&_tmp47_);
#line 369 "../src/Views/ImportPage.vala"
			_g_object_unref0 (self->priv->duplicated_file);
#line 369 "../src/Views/ImportPage.vala"
			self->priv->duplicated_file = _tmp48_;
#line 374 "../src/Views/ImportPage.vala"
			result = TRUE;
#line 374 "../src/Views/ImportPage.vala"
			_g_object_unref0 (video_import_source);
#line 374 "../src/Views/ImportPage.vala"
			_g_object_unref0 (photo_import_source);
#line 374 "../src/Views/ImportPage.vala"
			return result;
#line 3380 "ImportPage.c"
		}
#line 377 "../src/Views/ImportPage.vala"
		result = FALSE;
#line 377 "../src/Views/ImportPage.vala"
		_g_object_unref0 (video_import_source);
#line 377 "../src/Views/ImportPage.vala"
		_g_object_unref0 (photo_import_source);
#line 377 "../src/Views/ImportPage.vala"
		return result;
#line 3390 "ImportPage.c"
	}
#line 380 "../src/Views/ImportPage.vala"
	result = FALSE;
#line 380 "../src/Views/ImportPage.vala"
	_g_object_unref0 (video_import_source);
#line 380 "../src/Views/ImportPage.vala"
	_g_object_unref0 (photo_import_source);
#line 380 "../src/Views/ImportPage.vala"
	return result;
#line 3400 "ImportPage.c"
}

DuplicatedFile*
import_preview_get_duplicated_file (ImportPreview* self)
{
	DuplicatedFile* _tmp0_;
	DuplicatedFile* _tmp1_;
	DuplicatedFile* result;
#line 383 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 384 "../src/Views/ImportPage.vala"
	if (!import_preview_is_already_imported (self)) {
#line 385 "../src/Views/ImportPage.vala"
		result = NULL;
#line 385 "../src/Views/ImportPage.vala"
		return result;
#line 3417 "ImportPage.c"
	}
#line 387 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->duplicated_file;
#line 387 "../src/Views/ImportPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 387 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 387 "../src/Views/ImportPage.vala"
	return result;
#line 3427 "ImportPage.c"
}

ImportSource*
import_preview_get_import_source (ImportPreview* self)
{
	DataSource* _tmp0_;
	DataSource* _tmp1_;
	ImportSource* _tmp2_;
	ImportSource* result;
#line 390 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 391 "../src/Views/ImportPage.vala"
	_tmp0_ = data_view_get_source ((DataView*) self);
#line 391 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 391 "../src/Views/ImportPage.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_IMPORT_SOURCE, ImportSource));
#line 391 "../src/Views/ImportPage.vala"
	result = _tmp2_;
#line 391 "../src/Views/ImportPage.vala"
	return result;
#line 3449 "ImportPage.c"
}

static void
import_preview_class_init (ImportPreviewClass * klass,
                           gpointer klass_data)
{
#line 257 "../src/Views/ImportPage.vala"
	import_preview_parent_class = g_type_class_peek_parent (klass);
#line 257 "../src/Views/ImportPage.vala"
	g_type_class_adjust_private_offset (klass, &ImportPreview_private_offset);
#line 257 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->finalize = import_preview_finalize;
#line 3462 "ImportPage.c"
}

static void
import_preview_instance_init (ImportPreview * self,
                              gpointer klass)
{
#line 257 "../src/Views/ImportPage.vala"
	self->priv = import_preview_get_instance_private (self);
#line 3471 "ImportPage.c"
}

static void
import_preview_finalize (GObject * obj)
{
	ImportPreview * self;
#line 257 "../src/Views/ImportPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMPORT_PREVIEW, ImportPreview);
#line 262 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->duplicated_file);
#line 257 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (import_preview_parent_class)->finalize (obj);
#line 3484 "ImportPage.c"
}

static GType
import_preview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImportPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportPreview), 0, (GInstanceInitFunc) import_preview_instance_init, NULL };
	GType import_preview_type_id;
	import_preview_type_id = g_type_register_static (TYPE_CHECKERBOARD_ITEM, "ImportPreview", &g_define_type_info, 0);
	ImportPreview_private_offset = g_type_add_instance_private (import_preview_type_id, sizeof (ImportPreviewPrivate));
	return import_preview_type_id;
}

GType
import_preview_get_type (void)
{
	static volatile gsize import_preview_type_id__once = 0;
	if (g_once_init_enter (&import_preview_type_id__once)) {
		GType import_preview_type_id;
		import_preview_type_id = import_preview_get_type_once ();
		g_once_init_leave (&import_preview_type_id__once, import_preview_type_id);
	}
	return import_preview_type_id__once;
}

CameraViewTracker*
camera_view_tracker_construct (GType object_type,
                               ViewCollection* collection)
{
	CameraViewTracker* self = NULL;
	CameraAccumulator* _tmp0_;
	CameraAccumulator* _tmp1_;
	CameraAccumulator* _tmp2_;
#line 400 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (collection != NULL, NULL);
#line 401 "../src/Views/ImportPage.vala"
	self = (CameraViewTracker*) core_view_tracker_construct (object_type, collection);
#line 403 "../src/Views/ImportPage.vala"
	_tmp0_ = self->all;
#line 403 "../src/Views/ImportPage.vala"
	_tmp1_ = self->visible;
#line 403 "../src/Views/ImportPage.vala"
	_tmp2_ = self->selected;
#line 403 "../src/Views/ImportPage.vala"
	core_view_tracker_start ((CoreViewTracker*) self, (CoreTrackerAccumulator*) _tmp0_, (CoreTrackerAccumulator*) _tmp1_, (CoreTrackerAccumulator*) _tmp2_);
#line 400 "../src/Views/ImportPage.vala"
	return self;
#line 3531 "ImportPage.c"
}

CameraViewTracker*
camera_view_tracker_new (ViewCollection* collection)
{
#line 400 "../src/Views/ImportPage.vala"
	return camera_view_tracker_construct (TYPE_CAMERA_VIEW_TRACKER, collection);
#line 3539 "ImportPage.c"
}

static void
camera_view_tracker_class_init (CameraViewTrackerClass * klass,
                                gpointer klass_data)
{
#line 395 "../src/Views/ImportPage.vala"
	camera_view_tracker_parent_class = g_type_class_peek_parent (klass);
#line 395 "../src/Views/ImportPage.vala"
	((CoreTrackerClass *) klass)->finalize = camera_view_tracker_finalize;
#line 3550 "ImportPage.c"
}

static void
camera_view_tracker_instance_init (CameraViewTracker * self,
                                   gpointer klass)
{
	CameraAccumulator* _tmp0_;
	CameraAccumulator* _tmp1_;
	CameraAccumulator* _tmp2_;
#line 396 "../src/Views/ImportPage.vala"
	_tmp0_ = camera_accumulator_new ();
#line 396 "../src/Views/ImportPage.vala"
	self->all = _tmp0_;
#line 397 "../src/Views/ImportPage.vala"
	_tmp1_ = camera_accumulator_new ();
#line 397 "../src/Views/ImportPage.vala"
	self->visible = _tmp1_;
#line 398 "../src/Views/ImportPage.vala"
	_tmp2_ = camera_accumulator_new ();
#line 398 "../src/Views/ImportPage.vala"
	self->selected = _tmp2_;
#line 3572 "ImportPage.c"
}

static void
camera_view_tracker_finalize (CoreTracker * obj)
{
	CameraViewTracker * self;
#line 395 "../src/Views/ImportPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CAMERA_VIEW_TRACKER, CameraViewTracker);
#line 396 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->all);
#line 397 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->visible);
#line 398 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->selected);
#line 395 "../src/Views/ImportPage.vala"
	CORE_TRACKER_CLASS (camera_view_tracker_parent_class)->finalize (obj);
#line 3589 "ImportPage.c"
}

static GType
camera_view_tracker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraViewTrackerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_view_tracker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraViewTracker), 0, (GInstanceInitFunc) camera_view_tracker_instance_init, NULL };
	GType camera_view_tracker_type_id;
	camera_view_tracker_type_id = g_type_register_static (CORE_TYPE_VIEW_TRACKER, "CameraViewTracker", &g_define_type_info, 0);
	return camera_view_tracker_type_id;
}

GType
camera_view_tracker_get_type (void)
{
	static volatile gsize camera_view_tracker_type_id__once = 0;
	if (g_once_init_enter (&camera_view_tracker_type_id__once)) {
		GType camera_view_tracker_type_id;
		camera_view_tracker_type_id = camera_view_tracker_get_type_once ();
		g_once_init_leave (&camera_view_tracker_type_id__once, camera_view_tracker_type_id);
	}
	return camera_view_tracker_type_id__once;
}

static inline gpointer
camera_accumulator_get_instance_private (CameraAccumulator* self)
{
	return G_STRUCT_MEMBER_P (self, CameraAccumulator_private_offset);
}

static gboolean
camera_accumulator_real_include (CoreTrackerAccumulator* base,
                                 DataObject* object)
{
	CameraAccumulator * self;
	ImportSource* source = NULL;
	DataSource* _tmp0_;
	DataSource* _tmp1_;
	ImportSource* _tmp2_;
	gint _tmp3_;
	PhotoImportSource* photo = NULL;
	ImportSource* _tmp4_;
	PhotoImportSource* _tmp5_;
	gboolean _tmp6_ = FALSE;
	PhotoImportSource* _tmp7_;
	gboolean result;
#line 429 "../src/Views/ImportPage.vala"
	self = (CameraAccumulator*) base;
#line 429 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 430 "../src/Views/ImportPage.vala"
	_tmp0_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 430 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 430 "../src/Views/ImportPage.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_IMPORT_SOURCE, ImportSource));
#line 430 "../src/Views/ImportPage.vala"
	source = _tmp2_;
#line 432 "../src/Views/ImportPage.vala"
	_tmp3_ = self->priv->_total;
#line 432 "../src/Views/ImportPage.vala"
	camera_accumulator_set_total (self, _tmp3_ + 1);
#line 434 "../src/Views/ImportPage.vala"
	_tmp4_ = source;
#line 434 "../src/Views/ImportPage.vala"
	_tmp5_ = _g_object_ref0 (IS_PHOTO_IMPORT_SOURCE (_tmp4_) ? ((PhotoImportSource*) _tmp4_) : NULL);
#line 434 "../src/Views/ImportPage.vala"
	photo = _tmp5_;
#line 435 "../src/Views/ImportPage.vala"
	_tmp7_ = photo;
#line 435 "../src/Views/ImportPage.vala"
	if (_tmp7_ != NULL) {
#line 3661 "ImportPage.c"
		PhotoImportSource* _tmp8_;
#line 435 "../src/Views/ImportPage.vala"
		_tmp8_ = photo;
#line 435 "../src/Views/ImportPage.vala"
		_tmp6_ = photo_import_source_get_file_format (_tmp8_) != PHOTO_FILE_FORMAT_RAW;
#line 3667 "ImportPage.c"
	} else {
#line 435 "../src/Views/ImportPage.vala"
		_tmp6_ = FALSE;
#line 3671 "ImportPage.c"
	}
#line 435 "../src/Views/ImportPage.vala"
	if (_tmp6_) {
#line 3675 "ImportPage.c"
		gint _tmp9_;
#line 436 "../src/Views/ImportPage.vala"
		_tmp9_ = self->priv->_photos;
#line 436 "../src/Views/ImportPage.vala"
		camera_accumulator_set_photos (self, _tmp9_ + 1);
#line 3681 "ImportPage.c"
	} else {
		gboolean _tmp10_ = FALSE;
		PhotoImportSource* _tmp11_;
#line 437 "../src/Views/ImportPage.vala"
		_tmp11_ = photo;
#line 437 "../src/Views/ImportPage.vala"
		if (_tmp11_ != NULL) {
#line 3689 "ImportPage.c"
			PhotoImportSource* _tmp12_;
#line 437 "../src/Views/ImportPage.vala"
			_tmp12_ = photo;
#line 437 "../src/Views/ImportPage.vala"
			_tmp10_ = photo_import_source_get_file_format (_tmp12_) == PHOTO_FILE_FORMAT_RAW;
#line 3695 "ImportPage.c"
		} else {
#line 437 "../src/Views/ImportPage.vala"
			_tmp10_ = FALSE;
#line 3699 "ImportPage.c"
		}
#line 437 "../src/Views/ImportPage.vala"
		if (_tmp10_) {
#line 3703 "ImportPage.c"
			gint _tmp13_;
#line 438 "../src/Views/ImportPage.vala"
			_tmp13_ = self->priv->_raw;
#line 438 "../src/Views/ImportPage.vala"
			camera_accumulator_set_raw (self, _tmp13_ + 1);
#line 3709 "ImportPage.c"
		} else {
			ImportSource* _tmp14_;
#line 439 "../src/Views/ImportPage.vala"
			_tmp14_ = source;
#line 439 "../src/Views/ImportPage.vala"
			if (IS_VIDEO_IMPORT_SOURCE (_tmp14_)) {
#line 3716 "ImportPage.c"
				gint _tmp15_;
#line 440 "../src/Views/ImportPage.vala"
				_tmp15_ = self->priv->_videos;
#line 440 "../src/Views/ImportPage.vala"
				camera_accumulator_set_videos (self, _tmp15_ + 1);
#line 3722 "ImportPage.c"
			}
		}
	}
#line 443 "../src/Views/ImportPage.vala"
	result = TRUE;
#line 443 "../src/Views/ImportPage.vala"
	_g_object_unref0 (photo);
#line 443 "../src/Views/ImportPage.vala"
	_g_object_unref0 (source);
#line 443 "../src/Views/ImportPage.vala"
	return result;
#line 3734 "ImportPage.c"
}

static gboolean
camera_accumulator_real_uninclude (CoreTrackerAccumulator* base,
                                   DataObject* object)
{
	CameraAccumulator * self;
	ImportSource* source = NULL;
	DataSource* _tmp0_;
	DataSource* _tmp1_;
	ImportSource* _tmp2_;
	gint _tmp3_;
	PhotoImportSource* photo = NULL;
	ImportSource* _tmp4_;
	PhotoImportSource* _tmp5_;
	gboolean _tmp6_ = FALSE;
	PhotoImportSource* _tmp7_;
	gboolean result;
#line 446 "../src/Views/ImportPage.vala"
	self = (CameraAccumulator*) base;
#line 446 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 447 "../src/Views/ImportPage.vala"
	_tmp0_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 447 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 447 "../src/Views/ImportPage.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_IMPORT_SOURCE, ImportSource));
#line 447 "../src/Views/ImportPage.vala"
	source = _tmp2_;
#line 449 "../src/Views/ImportPage.vala"
	_tmp3_ = self->priv->_total;
#line 449 "../src/Views/ImportPage.vala"
	camera_accumulator_set_total (self, _tmp3_ + 1);
#line 451 "../src/Views/ImportPage.vala"
	_tmp4_ = source;
#line 451 "../src/Views/ImportPage.vala"
	_tmp5_ = _g_object_ref0 (IS_PHOTO_IMPORT_SOURCE (_tmp4_) ? ((PhotoImportSource*) _tmp4_) : NULL);
#line 451 "../src/Views/ImportPage.vala"
	photo = _tmp5_;
#line 452 "../src/Views/ImportPage.vala"
	_tmp7_ = photo;
#line 452 "../src/Views/ImportPage.vala"
	if (_tmp7_ != NULL) {
#line 3779 "ImportPage.c"
		PhotoImportSource* _tmp8_;
#line 452 "../src/Views/ImportPage.vala"
		_tmp8_ = photo;
#line 452 "../src/Views/ImportPage.vala"
		_tmp6_ = photo_import_source_get_file_format (_tmp8_) != PHOTO_FILE_FORMAT_RAW;
#line 3785 "ImportPage.c"
	} else {
#line 452 "../src/Views/ImportPage.vala"
		_tmp6_ = FALSE;
#line 3789 "ImportPage.c"
	}
#line 452 "../src/Views/ImportPage.vala"
	if (_tmp6_) {
#line 3793 "ImportPage.c"
		gint _tmp9_;
		gint _tmp10_;
#line 453 "../src/Views/ImportPage.vala"
		_tmp9_ = self->priv->_photos;
#line 453 "../src/Views/ImportPage.vala"
		_vala_assert (_tmp9_ > 0, "photos > 0");
#line 454 "../src/Views/ImportPage.vala"
		_tmp10_ = self->priv->_photos;
#line 454 "../src/Views/ImportPage.vala"
		camera_accumulator_set_photos (self, _tmp10_ - 1);
#line 3804 "ImportPage.c"
	} else {
		gboolean _tmp11_ = FALSE;
		PhotoImportSource* _tmp12_;
#line 455 "../src/Views/ImportPage.vala"
		_tmp12_ = photo;
#line 455 "../src/Views/ImportPage.vala"
		if (_tmp12_ != NULL) {
#line 3812 "ImportPage.c"
			PhotoImportSource* _tmp13_;
#line 455 "../src/Views/ImportPage.vala"
			_tmp13_ = photo;
#line 455 "../src/Views/ImportPage.vala"
			_tmp11_ = photo_import_source_get_file_format (_tmp13_) == PHOTO_FILE_FORMAT_RAW;
#line 3818 "ImportPage.c"
		} else {
#line 455 "../src/Views/ImportPage.vala"
			_tmp11_ = FALSE;
#line 3822 "ImportPage.c"
		}
#line 455 "../src/Views/ImportPage.vala"
		if (_tmp11_) {
#line 3826 "ImportPage.c"
			gint _tmp14_;
			gint _tmp15_;
#line 456 "../src/Views/ImportPage.vala"
			_tmp14_ = self->priv->_raw;
#line 456 "../src/Views/ImportPage.vala"
			_vala_assert (_tmp14_ > 0, "raw > 0");
#line 457 "../src/Views/ImportPage.vala"
			_tmp15_ = self->priv->_raw;
#line 457 "../src/Views/ImportPage.vala"
			camera_accumulator_set_raw (self, _tmp15_ - 1);
#line 3837 "ImportPage.c"
		} else {
			ImportSource* _tmp16_;
#line 458 "../src/Views/ImportPage.vala"
			_tmp16_ = source;
#line 458 "../src/Views/ImportPage.vala"
			if (IS_VIDEO_IMPORT_SOURCE (_tmp16_)) {
#line 3844 "ImportPage.c"
				gint _tmp17_;
				gint _tmp18_;
#line 459 "../src/Views/ImportPage.vala"
				_tmp17_ = self->priv->_videos;
#line 459 "../src/Views/ImportPage.vala"
				_vala_assert (_tmp17_ > 0, "videos > 0");
#line 460 "../src/Views/ImportPage.vala"
				_tmp18_ = self->priv->_videos;
#line 460 "../src/Views/ImportPage.vala"
				camera_accumulator_set_videos (self, _tmp18_ - 1);
#line 3855 "ImportPage.c"
			}
		}
	}
#line 464 "../src/Views/ImportPage.vala"
	result = TRUE;
#line 464 "../src/Views/ImportPage.vala"
	_g_object_unref0 (photo);
#line 464 "../src/Views/ImportPage.vala"
	_g_object_unref0 (source);
#line 464 "../src/Views/ImportPage.vala"
	return result;
#line 3867 "ImportPage.c"
}

static gboolean
camera_accumulator_real_altered (CoreTrackerAccumulator* base,
                                 DataObject* object,
                                 Alteration* alteration)
{
	CameraAccumulator * self;
	gboolean result;
#line 467 "../src/Views/ImportPage.vala"
	self = (CameraAccumulator*) base;
#line 467 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 467 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 469 "../src/Views/ImportPage.vala"
	result = FALSE;
#line 469 "../src/Views/ImportPage.vala"
	return result;
#line 3887 "ImportPage.c"
}

gchar*
camera_accumulator_to_string (CameraAccumulator* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 472 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 473 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->_total;
#line 473 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->_photos;
#line 473 "../src/Views/ImportPage.vala"
	_tmp2_ = self->priv->_videos;
#line 473 "../src/Views/ImportPage.vala"
	_tmp3_ = self->priv->_raw;
#line 473 "../src/Views/ImportPage.vala"
	_tmp4_ = g_strdup_printf ("%d total/%d photos/%d videos/%d raw", _tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 473 "../src/Views/ImportPage.vala"
	result = _tmp4_;
#line 473 "../src/Views/ImportPage.vala"
	return result;
#line 3915 "ImportPage.c"
}

CameraAccumulator*
camera_accumulator_construct (GType object_type)
{
	CameraAccumulator * self = NULL;
#line 407 "../src/Views/ImportPage.vala"
	self = (CameraAccumulator*) g_object_new (object_type, NULL);
#line 407 "../src/Views/ImportPage.vala"
	return self;
#line 3926 "ImportPage.c"
}

CameraAccumulator*
camera_accumulator_new (void)
{
#line 407 "../src/Views/ImportPage.vala"
	return camera_accumulator_construct (TYPE_CAMERA_ACCUMULATOR);
#line 3934 "ImportPage.c"
}

gint
camera_accumulator_get_total (CameraAccumulator* self)
{
	gint result;
#line 409 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 409 "../src/Views/ImportPage.vala"
	result = self->priv->_total;
#line 409 "../src/Views/ImportPage.vala"
	return result;
#line 3947 "ImportPage.c"
}

static void
camera_accumulator_set_total (CameraAccumulator* self,
                              gint value)
{
	gint old_value;
#line 410 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 410 "../src/Views/ImportPage.vala"
	old_value = camera_accumulator_get_total (self);
#line 410 "../src/Views/ImportPage.vala"
	if (old_value != value) {
#line 410 "../src/Views/ImportPage.vala"
		self->priv->_total = value;
#line 410 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, camera_accumulator_properties[CAMERA_ACCUMULATOR_TOTAL_PROPERTY]);
#line 3965 "ImportPage.c"
	}
}

gint
camera_accumulator_get_photos (CameraAccumulator* self)
{
	gint result;
#line 414 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 414 "../src/Views/ImportPage.vala"
	result = self->priv->_photos;
#line 414 "../src/Views/ImportPage.vala"
	return result;
#line 3979 "ImportPage.c"
}

static void
camera_accumulator_set_photos (CameraAccumulator* self,
                               gint value)
{
	gint old_value;
#line 415 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 415 "../src/Views/ImportPage.vala"
	old_value = camera_accumulator_get_photos (self);
#line 415 "../src/Views/ImportPage.vala"
	if (old_value != value) {
#line 415 "../src/Views/ImportPage.vala"
		self->priv->_photos = value;
#line 415 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, camera_accumulator_properties[CAMERA_ACCUMULATOR_PHOTOS_PROPERTY]);
#line 3997 "ImportPage.c"
	}
}

gint
camera_accumulator_get_videos (CameraAccumulator* self)
{
	gint result;
#line 419 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 419 "../src/Views/ImportPage.vala"
	result = self->priv->_videos;
#line 419 "../src/Views/ImportPage.vala"
	return result;
#line 4011 "ImportPage.c"
}

static void
camera_accumulator_set_videos (CameraAccumulator* self,
                               gint value)
{
	gint old_value;
#line 420 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/Views/ImportPage.vala"
	old_value = camera_accumulator_get_videos (self);
#line 420 "../src/Views/ImportPage.vala"
	if (old_value != value) {
#line 420 "../src/Views/ImportPage.vala"
		self->priv->_videos = value;
#line 420 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, camera_accumulator_properties[CAMERA_ACCUMULATOR_VIDEOS_PROPERTY]);
#line 4029 "ImportPage.c"
	}
}

gint
camera_accumulator_get_raw (CameraAccumulator* self)
{
	gint result;
#line 424 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 424 "../src/Views/ImportPage.vala"
	result = self->priv->_raw;
#line 424 "../src/Views/ImportPage.vala"
	return result;
#line 4043 "ImportPage.c"
}

static void
camera_accumulator_set_raw (CameraAccumulator* self,
                            gint value)
{
	gint old_value;
#line 425 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/Views/ImportPage.vala"
	old_value = camera_accumulator_get_raw (self);
#line 425 "../src/Views/ImportPage.vala"
	if (old_value != value) {
#line 425 "../src/Views/ImportPage.vala"
		self->priv->_raw = value;
#line 425 "../src/Views/ImportPage.vala"
		g_object_notify_by_pspec ((GObject *) self, camera_accumulator_properties[CAMERA_ACCUMULATOR_RAW_PROPERTY]);
#line 4061 "ImportPage.c"
	}
}

static void
camera_accumulator_class_init (CameraAccumulatorClass * klass,
                               gpointer klass_data)
{
#line 407 "../src/Views/ImportPage.vala"
	camera_accumulator_parent_class = g_type_class_peek_parent (klass);
#line 407 "../src/Views/ImportPage.vala"
	g_type_class_adjust_private_offset (klass, &CameraAccumulator_private_offset);
#line 407 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_camera_accumulator_get_property;
#line 407 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_camera_accumulator_set_property;
#line 407 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->finalize = camera_accumulator_finalize;
#line 407 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_ACCUMULATOR_TOTAL_PROPERTY, camera_accumulator_properties[CAMERA_ACCUMULATOR_TOTAL_PROPERTY] = g_param_spec_int ("total", "total", "total", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 407 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_ACCUMULATOR_PHOTOS_PROPERTY, camera_accumulator_properties[CAMERA_ACCUMULATOR_PHOTOS_PROPERTY] = g_param_spec_int ("photos", "photos", "photos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 407 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_ACCUMULATOR_VIDEOS_PROPERTY, camera_accumulator_properties[CAMERA_ACCUMULATOR_VIDEOS_PROPERTY] = g_param_spec_int ("videos", "videos", "videos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 407 "../src/Views/ImportPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_ACCUMULATOR_RAW_PROPERTY, camera_accumulator_properties[CAMERA_ACCUMULATOR_RAW_PROPERTY] = g_param_spec_int ("raw", "raw", "raw", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4087 "ImportPage.c"
}

static void
camera_accumulator_core_tracker_accumulator_interface_init (CoreTrackerAccumulatorIface * iface,
                                                            gpointer iface_data)
{
#line 407 "../src/Views/ImportPage.vala"
	camera_accumulator_core_tracker_accumulator_parent_iface = g_type_interface_peek_parent (iface);
#line 407 "../src/Views/ImportPage.vala"
	iface->include = (gboolean (*) (CoreTrackerAccumulator*, DataObject*)) camera_accumulator_real_include;
#line 407 "../src/Views/ImportPage.vala"
	iface->uninclude = (gboolean (*) (CoreTrackerAccumulator*, DataObject*)) camera_accumulator_real_uninclude;
#line 407 "../src/Views/ImportPage.vala"
	iface->altered = (gboolean (*) (CoreTrackerAccumulator*, DataObject*, Alteration*)) camera_accumulator_real_altered;
#line 4102 "ImportPage.c"
}

static void
camera_accumulator_instance_init (CameraAccumulator * self,
                                  gpointer klass)
{
#line 407 "../src/Views/ImportPage.vala"
	self->priv = camera_accumulator_get_instance_private (self);
#line 408 "../src/Views/ImportPage.vala"
	self->priv->_total = 0;
#line 413 "../src/Views/ImportPage.vala"
	self->priv->_photos = 0;
#line 418 "../src/Views/ImportPage.vala"
	self->priv->_videos = 0;
#line 423 "../src/Views/ImportPage.vala"
	self->priv->_raw = 0;
#line 4119 "ImportPage.c"
}

static void
camera_accumulator_finalize (GObject * obj)
{
	CameraAccumulator * self;
#line 407 "../src/Views/ImportPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CAMERA_ACCUMULATOR, CameraAccumulator);
#line 407 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (camera_accumulator_parent_class)->finalize (obj);
#line 4130 "ImportPage.c"
}

static GType
camera_accumulator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraAccumulatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_accumulator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraAccumulator), 0, (GInstanceInitFunc) camera_accumulator_instance_init, NULL };
	static const GInterfaceInfo core_tracker_accumulator_info = { (GInterfaceInitFunc) camera_accumulator_core_tracker_accumulator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType camera_accumulator_type_id;
	camera_accumulator_type_id = g_type_register_static (G_TYPE_OBJECT, "CameraAccumulator", &g_define_type_info, 0);
	g_type_add_interface_static (camera_accumulator_type_id, CORE_TYPE_TRACKER_ACCUMULATOR, &core_tracker_accumulator_info);
	CameraAccumulator_private_offset = g_type_add_instance_private (camera_accumulator_type_id, sizeof (CameraAccumulatorPrivate));
	return camera_accumulator_type_id;
}

GType
camera_accumulator_get_type (void)
{
	static volatile gsize camera_accumulator_type_id__once = 0;
	if (g_once_init_enter (&camera_accumulator_type_id__once)) {
		GType camera_accumulator_type_id;
		camera_accumulator_type_id = camera_accumulator_get_type_once ();
		g_once_init_leave (&camera_accumulator_type_id__once, camera_accumulator_type_id);
	}
	return camera_accumulator_type_id__once;
}

static void
_vala_camera_accumulator_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	CameraAccumulator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CAMERA_ACCUMULATOR, CameraAccumulator);
#line 407 "../src/Views/ImportPage.vala"
	switch (property_id) {
#line 407 "../src/Views/ImportPage.vala"
		case CAMERA_ACCUMULATOR_TOTAL_PROPERTY:
#line 407 "../src/Views/ImportPage.vala"
		g_value_set_int (value, camera_accumulator_get_total (self));
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 407 "../src/Views/ImportPage.vala"
		case CAMERA_ACCUMULATOR_PHOTOS_PROPERTY:
#line 407 "../src/Views/ImportPage.vala"
		g_value_set_int (value, camera_accumulator_get_photos (self));
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 407 "../src/Views/ImportPage.vala"
		case CAMERA_ACCUMULATOR_VIDEOS_PROPERTY:
#line 407 "../src/Views/ImportPage.vala"
		g_value_set_int (value, camera_accumulator_get_videos (self));
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 407 "../src/Views/ImportPage.vala"
		case CAMERA_ACCUMULATOR_RAW_PROPERTY:
#line 407 "../src/Views/ImportPage.vala"
		g_value_set_int (value, camera_accumulator_get_raw (self));
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 4191 "ImportPage.c"
		default:
#line 407 "../src/Views/ImportPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 4197 "ImportPage.c"
	}
}

static void
_vala_camera_accumulator_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	CameraAccumulator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CAMERA_ACCUMULATOR, CameraAccumulator);
#line 407 "../src/Views/ImportPage.vala"
	switch (property_id) {
#line 407 "../src/Views/ImportPage.vala"
		case CAMERA_ACCUMULATOR_TOTAL_PROPERTY:
#line 407 "../src/Views/ImportPage.vala"
		camera_accumulator_set_total (self, g_value_get_int (value));
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 407 "../src/Views/ImportPage.vala"
		case CAMERA_ACCUMULATOR_PHOTOS_PROPERTY:
#line 407 "../src/Views/ImportPage.vala"
		camera_accumulator_set_photos (self, g_value_get_int (value));
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 407 "../src/Views/ImportPage.vala"
		case CAMERA_ACCUMULATOR_VIDEOS_PROPERTY:
#line 407 "../src/Views/ImportPage.vala"
		camera_accumulator_set_videos (self, g_value_get_int (value));
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 407 "../src/Views/ImportPage.vala"
		case CAMERA_ACCUMULATOR_RAW_PROPERTY:
#line 407 "../src/Views/ImportPage.vala"
		camera_accumulator_set_raw (self, g_value_get_int (value));
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 4235 "ImportPage.c"
		default:
#line 407 "../src/Views/ImportPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 407 "../src/Views/ImportPage.vala"
		break;
#line 4241 "ImportPage.c"
	}
}

static inline gpointer
import_page_get_instance_private (ImportPage* self)
{
	return G_STRUCT_MEMBER_P (self, ImportPage_private_offset);
}

static void
_import_page_on_media_added_removed_data_collection_contents_altered (DataCollection* _sender,
                                                                      GeeIterable* added,
                                                                      GeeIterable* removed,
                                                                      gpointer self)
{
#line 787 "../src/Views/ImportPage.vala"
	import_page_on_media_added_removed ((ImportPage*) self);
#line 4259 "ImportPage.c"
}

static GType
import_page_refresh_result_get_type_once (void)
{
	static const GEnumValue values[] = {{IMPORT_PAGE_REFRESH_RESULT_OK, "IMPORT_PAGE_REFRESH_RESULT_OK", "ok"}, {IMPORT_PAGE_REFRESH_RESULT_BUSY, "IMPORT_PAGE_REFRESH_RESULT_BUSY", "busy"}, {IMPORT_PAGE_REFRESH_RESULT_LOCKED, "IMPORT_PAGE_REFRESH_RESULT_LOCKED", "locked"}, {IMPORT_PAGE_REFRESH_RESULT_LIBRARY_ERROR, "IMPORT_PAGE_REFRESH_RESULT_LIBRARY_ERROR", "library-error"}, {0, NULL, NULL}};
	GType import_page_refresh_result_type_id;
	import_page_refresh_result_type_id = g_enum_register_static ("ImportPageRefreshResult", values);
	return import_page_refresh_result_type_id;
}

GType
import_page_refresh_result_get_type (void)
{
	static volatile gsize import_page_refresh_result_type_id__once = 0;
	if (g_once_init_enter (&import_page_refresh_result_type_id__once)) {
		GType import_page_refresh_result_type_id;
		import_page_refresh_result_type_id = import_page_refresh_result_get_type_once ();
		g_once_init_leave (&import_page_refresh_result_type_id__once, import_page_refresh_result_type_id);
	}
	return import_page_refresh_result_type_id__once;
}

static gint64
_import_page_preview_comparator_comparator (void* a,
                                            void* b,
                                            gpointer self)
{
	gint64 result;
	result = import_page_preview_comparator (a, b);
#line 771 "../src/Views/ImportPage.vala"
	return result;
#line 4292 "ImportPage.c"
}

static gboolean
_import_page_preview_comparator_predicate_comparator_predicate (DataObject* object,
                                                                Alteration* alteration,
                                                                gpointer self)
{
	gboolean result;
	result = import_page_preview_comparator_predicate (object, alteration);
#line 771 "../src/Views/ImportPage.vala"
	return result;
#line 4304 "ImportPage.c"
}

static void
_import_page_on_view_changed_view_collection_items_state_changed (ViewCollection* _sender,
                                                                  GeeIterable* changed,
                                                                  gpointer self)
{
#line 774 "../src/Views/ImportPage.vala"
	import_page_on_view_changed ((ImportPage*) self);
#line 4314 "ImportPage.c"
}

static void
_import_page_on_view_changed_data_collection_contents_altered (DataCollection* _sender,
                                                               GeeIterable* added,
                                                               GeeIterable* removed,
                                                               gpointer self)
{
#line 775 "../src/Views/ImportPage.vala"
	import_page_on_view_changed ((ImportPage*) self);
#line 4325 "ImportPage.c"
}

static void
_import_page_on_view_changed_view_collection_items_visibility_changed (ViewCollection* _sender,
                                                                       GeeCollection* changed,
                                                                       gpointer self)
{
#line 776 "../src/Views/ImportPage.vala"
	import_page_on_view_changed ((ImportPage*) self);
#line 4335 "ImportPage.c"
}

ImportPage*
import_page_construct (GType object_type,
                       Camera* camera,
                       const gchar* uri,
                       const gchar* display_name,
                       GIcon* icon)
{
	ImportPage * self = NULL;
	Camera* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ImportSourceCollection* _tmp4_;
	GIcon* _tmp5_;
	ViewCollection* _tmp6_;
	ViewCollection* _tmp7_;
	CameraViewTracker* _tmp8_;
	GtkLabel* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GVolumeMonitor* _tmp18_;
	GPContextWrapper* _tmp19_;
	GPSpinIdleWrapper* _tmp21_;
	ViewCollection* _tmp23_;
	ViewCollection* _tmp24_;
	SourceCollection* _tmp25_;
	ImportPageImportViewManager* _tmp26_;
	ImportPageImportViewManager* _tmp27_;
	ViewCollectionMonitor* _tmp28_;
	ViewCollectionMonitor* _tmp29_;
	ViewCollection* _tmp30_;
	ViewCollection* _tmp31_;
	ViewCollection* _tmp32_;
	ViewCollection* _tmp33_;
	ViewCollection* _tmp34_;
	ViewCollection* _tmp35_;
	ViewCollection* _tmp36_;
	ViewCollection* _tmp37_;
	ViewCollection* _tmp38_;
	ViewCollection* _tmp39_;
	GValue _tmp40_ = {0};
	LibraryPhotoSourceCollection* _tmp41_;
	VideoSourceCollection* _tmp42_;
#line 733 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera != NULL, NULL);
#line 733 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 734 "../src/Views/ImportPage.vala"
	self = (ImportPage*) checkerboard_page_construct (object_type, _ ("Camera"));
#line 735 "../src/Views/ImportPage.vala"
	_tmp0_ = _GPHOTO_REF_CAMERA0 (camera);
#line 735 "../src/Views/ImportPage.vala"
	_gp_camera_unref0 (self->priv->camera);
#line 735 "../src/Views/ImportPage.vala"
	self->priv->camera = _tmp0_;
#line 736 "../src/Views/ImportPage.vala"
	_tmp1_ = g_strdup (uri);
#line 736 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->uri);
#line 736 "../src/Views/ImportPage.vala"
	self->priv->uri = _tmp1_;
#line 737 "../src/Views/ImportPage.vala"
	_tmp2_ = g_strdup_printf ("ImportSources for %s", uri);
#line 737 "../src/Views/ImportPage.vala"
	_tmp3_ = _tmp2_;
#line 737 "../src/Views/ImportPage.vala"
	_tmp4_ = import_source_collection_new (_tmp3_);
#line 737 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (self->priv->import_sources);
#line 737 "../src/Views/ImportPage.vala"
	self->priv->import_sources = (SourceCollection*) _tmp4_;
#line 737 "../src/Views/ImportPage.vala"
	_g_free0 (_tmp3_);
#line 738 "../src/Views/ImportPage.vala"
	_tmp5_ = _g_object_ref0 (icon);
#line 738 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->icon);
#line 738 "../src/Views/ImportPage.vala"
	self->priv->icon = _tmp5_;
#line 740 "../src/Views/ImportPage.vala"
	_tmp6_ = page_get_view ((Page*) self);
#line 740 "../src/Views/ImportPage.vala"
	_tmp7_ = _tmp6_;
#line 740 "../src/Views/ImportPage.vala"
	_tmp8_ = camera_view_tracker_new (_tmp7_);
#line 740 "../src/Views/ImportPage.vala"
	_core_tracker_unref0 (self->priv->tracker);
#line 740 "../src/Views/ImportPage.vala"
	self->priv->tracker = _tmp8_;
#line 740 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp7_);
#line 743 "../src/Views/ImportPage.vala"
	if (NULL != display_name) {
#line 4431 "ImportPage.c"
		gchar* _tmp9_;
#line 744 "../src/Views/ImportPage.vala"
		_tmp9_ = g_strdup (display_name);
#line 744 "../src/Views/ImportPage.vala"
		_g_free0 (self->priv->camera_name);
#line 744 "../src/Views/ImportPage.vala"
		self->priv->camera_name = _tmp9_;
#line 4439 "ImportPage.c"
	} else {
		CameraAbilities abilities = {0};
		int res = 0;
		CameraAbilities _tmp10_ = {0};
		int _tmp11_;
#line 747 "../src/Views/ImportPage.vala"
		_tmp11_ = gp_camera_get_abilities (camera, &_tmp10_);
#line 747 "../src/Views/ImportPage.vala"
		 (abilities);
#line 747 "../src/Views/ImportPage.vala"
		abilities = _tmp10_;
#line 747 "../src/Views/ImportPage.vala"
		res = _tmp11_;
#line 748 "../src/Views/ImportPage.vala"
		if (res != GP_OK) {
#line 4455 "ImportPage.c"
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 749 "../src/Views/ImportPage.vala"
			_tmp12_ = gp_result_to_full_string (res);
#line 749 "../src/Views/ImportPage.vala"
			_tmp13_ = _tmp12_;
#line 749 "../src/Views/ImportPage.vala"
			g_debug ("ImportPage.vala:749: Unable to get camera abilities: %s", _tmp13_);
#line 749 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp13_);
#line 750 "../src/Views/ImportPage.vala"
			_tmp14_ = g_strdup (_ ("Camera"));
#line 750 "../src/Views/ImportPage.vala"
			_g_free0 (self->priv->camera_name);
#line 750 "../src/Views/ImportPage.vala"
			self->priv->camera_name = _tmp14_;
#line 4473 "ImportPage.c"
		}
#line 743 "../src/Views/ImportPage.vala"
		 (abilities);
#line 4477 "ImportPage.c"
	}
#line 753 "../src/Views/ImportPage.vala"
	_tmp15_ = self->priv->camera_label;
#line 753 "../src/Views/ImportPage.vala"
	_tmp16_ = self->priv->camera_name;
#line 753 "../src/Views/ImportPage.vala"
	gtk_label_set_text (_tmp15_, _tmp16_);
#line 754 "../src/Views/ImportPage.vala"
	_tmp17_ = self->priv->camera_name;
#line 754 "../src/Views/ImportPage.vala"
	page_set_page_name ((Page*) self, _tmp17_);
#line 757 "../src/Views/ImportPage.vala"
	_tmp18_ = g_volume_monitor_get ();
#line 757 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->volume_monitor);
#line 757 "../src/Views/ImportPage.vala"
	self->priv->volume_monitor = _tmp18_;
#line 760 "../src/Views/ImportPage.vala"
	_tmp19_ = import_page_null_context;
#line 760 "../src/Views/ImportPage.vala"
	if (_tmp19_ == NULL) {
#line 4499 "ImportPage.c"
		GPContextWrapper* _tmp20_;
#line 761 "../src/Views/ImportPage.vala"
		_tmp20_ = gp_context_wrapper_new ();
#line 761 "../src/Views/ImportPage.vala"
		_gp_context_wrapper_unref0 (import_page_null_context);
#line 761 "../src/Views/ImportPage.vala"
		import_page_null_context = _tmp20_;
#line 4507 "ImportPage.c"
	}
#line 764 "../src/Views/ImportPage.vala"
	_tmp21_ = import_page_spin_idle_context;
#line 764 "../src/Views/ImportPage.vala"
	if (_tmp21_ == NULL) {
#line 4513 "ImportPage.c"
		GPSpinIdleWrapper* _tmp22_;
#line 765 "../src/Views/ImportPage.vala"
		_tmp22_ = gp_spin_idle_wrapper_new ();
#line 765 "../src/Views/ImportPage.vala"
		_gp_context_wrapper_unref0 (import_page_spin_idle_context);
#line 765 "../src/Views/ImportPage.vala"
		import_page_spin_idle_context = _tmp22_;
#line 4521 "ImportPage.c"
	}
#line 768 "../src/Views/ImportPage.vala"
	_tmp23_ = page_get_view ((Page*) self);
#line 768 "../src/Views/ImportPage.vala"
	_tmp24_ = _tmp23_;
#line 768 "../src/Views/ImportPage.vala"
	_tmp25_ = self->priv->import_sources;
#line 768 "../src/Views/ImportPage.vala"
	_tmp26_ = import_page_import_view_manager_new (self);
#line 768 "../src/Views/ImportPage.vala"
	_tmp27_ = _tmp26_;
#line 768 "../src/Views/ImportPage.vala"
	_tmp28_ = view_collection_monitor_source_collection (_tmp24_, _tmp25_, (ViewManager*) _tmp27_, NULL, NULL, NULL, NULL);
#line 768 "../src/Views/ImportPage.vala"
	_tmp29_ = _tmp28_;
#line 768 "../src/Views/ImportPage.vala"
	_view_collection_monitor_unref0 (_tmp29_);
#line 768 "../src/Views/ImportPage.vala"
	_view_manager_unref0 (_tmp27_);
#line 768 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp24_);
#line 771 "../src/Views/ImportPage.vala"
	_tmp30_ = page_get_view ((Page*) self);
#line 771 "../src/Views/ImportPage.vala"
	_tmp31_ = _tmp30_;
#line 771 "../src/Views/ImportPage.vala"
	data_collection_set_comparator ((DataCollection*) _tmp31_, _import_page_preview_comparator_comparator, NULL, _import_page_preview_comparator_predicate_comparator_predicate, NULL);
#line 771 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp31_);
#line 774 "../src/Views/ImportPage.vala"
	_tmp32_ = page_get_view ((Page*) self);
#line 774 "../src/Views/ImportPage.vala"
	_tmp33_ = _tmp32_;
#line 774 "../src/Views/ImportPage.vala"
	g_signal_connect_object (_tmp33_, "items-state-changed", (GCallback) _import_page_on_view_changed_view_collection_items_state_changed, self, 0);
#line 774 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp33_);
#line 775 "../src/Views/ImportPage.vala"
	_tmp34_ = page_get_view ((Page*) self);
#line 775 "../src/Views/ImportPage.vala"
	_tmp35_ = _tmp34_;
#line 775 "../src/Views/ImportPage.vala"
	g_signal_connect_object ((DataCollection*) _tmp35_, "contents-altered", (GCallback) _import_page_on_view_changed_data_collection_contents_altered, self, 0);
#line 775 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp35_);
#line 776 "../src/Views/ImportPage.vala"
	_tmp36_ = page_get_view ((Page*) self);
#line 776 "../src/Views/ImportPage.vala"
	_tmp37_ = _tmp36_;
#line 776 "../src/Views/ImportPage.vala"
	g_signal_connect_object (_tmp37_, "items-visibility-changed", (GCallback) _import_page_on_view_changed_view_collection_items_visibility_changed, self, 0);
#line 776 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp37_);
#line 779 "../src/Views/ImportPage.vala"
	_tmp38_ = page_get_view ((Page*) self);
#line 779 "../src/Views/ImportPage.vala"
	_tmp39_ = _tmp38_;
#line 779 "../src/Views/ImportPage.vala"
	g_value_init (&_tmp40_, G_TYPE_BOOLEAN);
#line 779 "../src/Views/ImportPage.vala"
	g_value_set_boolean (&_tmp40_, TRUE);
#line 779 "../src/Views/ImportPage.vala"
	data_collection_set_property ((DataCollection*) _tmp39_, CHECKERBOARD_ITEM_PROP_SHOW_SUBTITLES, &_tmp40_, NULL, NULL);
#line 779 "../src/Views/ImportPage.vala"
	G_IS_VALUE (&_tmp40_) ? (g_value_unset (&_tmp40_), NULL) : NULL;
#line 779 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp39_);
#line 782 "../src/Views/ImportPage.vala"
	_tmp41_ = library_photo_global;
#line 782 "../src/Views/ImportPage.vala"
	g_signal_connect_object ((DataCollection*) _tmp41_, "contents-altered", (GCallback) _import_page_on_media_added_removed_data_collection_contents_altered, self, 0);
#line 783 "../src/Views/ImportPage.vala"
	_tmp42_ = video_global;
#line 783 "../src/Views/ImportPage.vala"
	g_signal_connect_object ((DataCollection*) _tmp42_, "contents-altered", (GCallback) _import_page_on_media_added_removed_data_collection_contents_altered, self, 0);
#line 733 "../src/Views/ImportPage.vala"
	return self;
#line 4599 "ImportPage.c"
}

ImportPage*
import_page_new (Camera* camera,
                 const gchar* uri,
                 const gchar* display_name,
                 GIcon* icon)
{
#line 733 "../src/Views/ImportPage.vala"
	return import_page_construct (TYPE_IMPORT_PAGE, camera, uri, display_name, icon);
#line 4610 "ImportPage.c"
}

static void
_import_page_on_hide_imported_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 796 "../src/Views/ImportPage.vala"
	import_page_on_hide_imported ((ImportPage*) self);
#line 4619 "ImportPage.c"
}

static void
import_page_real_add_toolbar_widgets (Page* base,
                                      GtkActionBar* toolbar)
{
	ImportPage * self;
	GtkCheckButton* _tmp0_;
	GtkCheckButton* _tmp1_;
	GSettings* _tmp2_;
	GtkCheckButton* _tmp3_;
	GtkCheckButton* _tmp4_;
	GtkCheckButton* _tmp5_;
	GtkToolItem* hide_item = NULL;
	GtkToolItem* _tmp6_;
	GtkCheckButton* _tmp7_;
	GtkSeparatorToolItem* separator = NULL;
	GtkSeparatorToolItem* _tmp8_;
	GtkProgressBar* _tmp9_;
	GtkProgressBar* _tmp10_;
	GtkProgressBar* _tmp11_;
	GtkProgressBar* _tmp12_;
	GtkToolItem* progress_item = NULL;
	GtkToolItem* _tmp13_;
	GtkProgressBar* _tmp14_;
	GtkButton* import_selected_button = NULL;
	GtkButton* _tmp15_;
	GtkAction* _tmp16_;
	GtkAction* _tmp17_;
	GtkToolItem* import_sel_ti = NULL;
	GtkToolItem* _tmp18_;
	GtkButton* import_all_button = NULL;
	GtkButton* _tmp19_;
	GtkAction* _tmp20_;
	GtkAction* _tmp21_;
	GtkToolItem* import_all_ti = NULL;
	GtkToolItem* _tmp22_;
	GtkSeparator* _tmp23_;
	GtkSeparator* _tmp24_;
#line 791 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 791 "../src/Views/ImportPage.vala"
	g_return_if_fail (toolbar != NULL);
#line 792 "../src/Views/ImportPage.vala"
	_tmp0_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Hide photos already imported"));
#line 792 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp0_);
#line 792 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->hide_imported);
#line 792 "../src/Views/ImportPage.vala"
	self->priv->hide_imported = _tmp0_;
#line 793 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->hide_imported;
#line 793 "../src/Views/ImportPage.vala"
	_tmp2_ = ((Page*) self)->ui_settings;
#line 793 "../src/Views/ImportPage.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, g_settings_get_boolean (_tmp2_, "hide-photos-already-imported"));
#line 794 "../src/Views/ImportPage.vala"
	_tmp3_ = self->priv->hide_imported;
#line 794 "../src/Views/ImportPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
#line 795 "../src/Views/ImportPage.vala"
	_tmp4_ = self->priv->hide_imported;
#line 795 "../src/Views/ImportPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp4_, _ ("Only display photos that have not been imported"));
#line 796 "../src/Views/ImportPage.vala"
	_tmp5_ = self->priv->hide_imported;
#line 796 "../src/Views/ImportPage.vala"
	g_signal_connect_object ((GtkButton*) _tmp5_, "clicked", (GCallback) _import_page_on_hide_imported_gtk_button_clicked, self, 0);
#line 798 "../src/Views/ImportPage.vala"
	_tmp6_ = gtk_tool_item_new ();
#line 798 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp6_);
#line 798 "../src/Views/ImportPage.vala"
	hide_item = _tmp6_;
#line 799 "../src/Views/ImportPage.vala"
	_tmp7_ = self->priv->hide_imported;
#line 799 "../src/Views/ImportPage.vala"
	gtk_container_add ((GtkContainer*) hide_item, (GtkWidget*) _tmp7_);
#line 801 "../src/Views/ImportPage.vala"
	_tmp8_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
#line 801 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp8_);
#line 801 "../src/Views/ImportPage.vala"
	separator = _tmp8_;
#line 802 "../src/Views/ImportPage.vala"
	gtk_separator_tool_item_set_draw (separator, FALSE);
#line 804 "../src/Views/ImportPage.vala"
	_tmp9_ = self->priv->progress_bar;
#line 804 "../src/Views/ImportPage.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp9_, GTK_ORIENTATION_HORIZONTAL);
#line 805 "../src/Views/ImportPage.vala"
	_tmp10_ = self->priv->progress_bar;
#line 805 "../src/Views/ImportPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 806 "../src/Views/ImportPage.vala"
	_tmp11_ = self->priv->progress_bar;
#line 806 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_show_text (_tmp11_, TRUE);
#line 807 "../src/Views/ImportPage.vala"
	_tmp12_ = self->priv->progress_bar;
#line 807 "../src/Views/ImportPage.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp12_, TRUE);
#line 809 "../src/Views/ImportPage.vala"
	_tmp13_ = gtk_tool_item_new ();
#line 809 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp13_);
#line 809 "../src/Views/ImportPage.vala"
	progress_item = _tmp13_;
#line 810 "../src/Views/ImportPage.vala"
	gtk_tool_item_set_expand (progress_item, TRUE);
#line 811 "../src/Views/ImportPage.vala"
	_tmp14_ = self->priv->progress_bar;
#line 811 "../src/Views/ImportPage.vala"
	gtk_container_add ((GtkContainer*) progress_item, (GtkWidget*) _tmp14_);
#line 813 "../src/Views/ImportPage.vala"
	_tmp15_ = (GtkButton*) gtk_button_new_with_label ("Import Selected");
#line 813 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp15_);
#line 813 "../src/Views/ImportPage.vala"
	import_selected_button = _tmp15_;
#line 814 "../src/Views/ImportPage.vala"
	_tmp16_ = page_get_action ((Page*) self, "ImportSelected");
#line 814 "../src/Views/ImportPage.vala"
	_tmp17_ = _tmp16_;
#line 814 "../src/Views/ImportPage.vala"
	gtk_activatable_set_related_action ((GtkActivatable*) import_selected_button, _tmp17_);
#line 814 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp17_);
#line 816 "../src/Views/ImportPage.vala"
	_tmp18_ = gtk_tool_item_new ();
#line 816 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp18_);
#line 816 "../src/Views/ImportPage.vala"
	import_sel_ti = _tmp18_;
#line 817 "../src/Views/ImportPage.vala"
	gtk_container_add ((GtkContainer*) import_sel_ti, (GtkWidget*) import_selected_button);
#line 819 "../src/Views/ImportPage.vala"
	_tmp19_ = (GtkButton*) gtk_button_new_with_label ("Import All");
#line 819 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp19_);
#line 819 "../src/Views/ImportPage.vala"
	import_all_button = _tmp19_;
#line 820 "../src/Views/ImportPage.vala"
	_tmp20_ = page_get_action ((Page*) self, "ImportAll");
#line 820 "../src/Views/ImportPage.vala"
	_tmp21_ = _tmp20_;
#line 820 "../src/Views/ImportPage.vala"
	gtk_activatable_set_related_action ((GtkActivatable*) import_all_button, _tmp21_);
#line 820 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp21_);
#line 822 "../src/Views/ImportPage.vala"
	_tmp22_ = gtk_tool_item_new ();
#line 822 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp22_);
#line 822 "../src/Views/ImportPage.vala"
	import_all_ti = _tmp22_;
#line 823 "../src/Views/ImportPage.vala"
	gtk_widget_set_margin_start ((GtkWidget*) import_all_ti, 6);
#line 824 "../src/Views/ImportPage.vala"
	gtk_container_add ((GtkContainer*) import_all_ti, (GtkWidget*) import_all_button);
#line 826 "../src/Views/ImportPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) hide_item);
#line 827 "../src/Views/ImportPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) separator);
#line 828 "../src/Views/ImportPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) progress_item);
#line 829 "../src/Views/ImportPage.vala"
	_tmp23_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
#line 829 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp23_);
#line 829 "../src/Views/ImportPage.vala"
	_tmp24_ = _tmp23_;
#line 829 "../src/Views/ImportPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) _tmp24_);
#line 829 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp24_);
#line 830 "../src/Views/ImportPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) import_sel_ti);
#line 831 "../src/Views/ImportPage.vala"
	gtk_action_bar_pack_start (toolbar, (GtkWidget*) import_all_ti);
#line 833 "../src/Views/ImportPage.vala"
	import_page_update_toolbar_state (self);
#line 835 "../src/Views/ImportPage.vala"
	PAGE_CLASS (import_page_parent_class)->add_toolbar_widgets ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), toolbar);
#line 791 "../src/Views/ImportPage.vala"
	_g_object_unref0 (import_all_ti);
#line 791 "../src/Views/ImportPage.vala"
	_g_object_unref0 (import_all_button);
#line 791 "../src/Views/ImportPage.vala"
	_g_object_unref0 (import_sel_ti);
#line 791 "../src/Views/ImportPage.vala"
	_g_object_unref0 (import_selected_button);
#line 791 "../src/Views/ImportPage.vala"
	_g_object_unref0 (progress_item);
#line 791 "../src/Views/ImportPage.vala"
	_g_object_unref0 (separator);
#line 791 "../src/Views/ImportPage.vala"
	_g_object_unref0 (hide_item);
#line 4819 "ImportPage.c"
}

static GtkMenu*
import_page_real_get_item_context_menu (CheckerboardPage* base)
{
	ImportPage * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* result;
#line 838 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 839 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->import_context_menu;
#line 839 "../src/Views/ImportPage.vala"
	if (_tmp0_ == NULL) {
#line 840 "../src/Views/ImportPage.vala"
		import_page_create_import_context_menu (self);
#line 4838 "ImportPage.c"
	}
#line 843 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->import_context_menu;
#line 843 "../src/Views/ImportPage.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 843 "../src/Views/ImportPage.vala"
	result = _tmp2_;
#line 843 "../src/Views/ImportPage.vala"
	return result;
#line 4848 "ImportPage.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 847 "../src/Views/ImportPage.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 847 "../src/Views/ImportPage.vala"
	return _data16_;
#line 4858 "ImportPage.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 847 "../src/Views/ImportPage.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 4868 "ImportPage.c"
		ImportPage* self;
#line 847 "../src/Views/ImportPage.vala"
		self = _data16_->self;
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_data16_->select_action);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_data16_->descending_action);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_data16_->descending_menu_item);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_data16_->ascending_action);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_data16_->ascending_menu_item);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (self);
#line 847 "../src/Views/ImportPage.vala"
		g_slice_free (Block16Data, _data16_);
#line 4886 "ImportPage.c"
	}
}

static void
___lambda119_ (Block16Data* _data16_)
{
	ImportPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 859 "../src/Views/ImportPage.vala"
	self = _data16_->self;
#line 860 "../src/Views/ImportPage.vala"
	_tmp0_ = _data16_->ascending_menu_item;
#line 860 "../src/Views/ImportPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 860 "../src/Views/ImportPage.vala"
	_tmp2_ = _tmp1_;
#line 860 "../src/Views/ImportPage.vala"
	if (_tmp2_) {
#line 4907 "ImportPage.c"
		GtkAction* _tmp3_;
#line 861 "../src/Views/ImportPage.vala"
		_tmp3_ = _data16_->ascending_action;
#line 861 "../src/Views/ImportPage.vala"
		gtk_action_activate (_tmp3_);
#line 4913 "ImportPage.c"
	}
}

static void
____lambda119__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 859 "../src/Views/ImportPage.vala"
	___lambda119_ (self);
#line 4923 "ImportPage.c"
}

static void
___lambda120_ (Block16Data* _data16_)
{
	ImportPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 868 "../src/Views/ImportPage.vala"
	self = _data16_->self;
#line 869 "../src/Views/ImportPage.vala"
	_tmp0_ = _data16_->descending_menu_item;
#line 869 "../src/Views/ImportPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 869 "../src/Views/ImportPage.vala"
	_tmp2_ = _tmp1_;
#line 869 "../src/Views/ImportPage.vala"
	if (_tmp2_) {
#line 4943 "ImportPage.c"
		GtkAction* _tmp3_;
#line 870 "../src/Views/ImportPage.vala"
		_tmp3_ = _data16_->descending_action;
#line 870 "../src/Views/ImportPage.vala"
		gtk_action_activate (_tmp3_);
#line 4949 "ImportPage.c"
	}
}

static void
____lambda120__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 868 "../src/Views/ImportPage.vala"
	___lambda120_ (self);
#line 4959 "ImportPage.c"
}

static void
___lambda121_ (Block16Data* _data16_)
{
	ImportPage* self;
	GAction* _tmp0_;
#line 883 "../src/Views/ImportPage.vala"
	self = _data16_->self;
#line 883 "../src/Views/ImportPage.vala"
	_tmp0_ = _data16_->select_action;
#line 883 "../src/Views/ImportPage.vala"
	g_action_activate (_tmp0_, NULL);
#line 4973 "ImportPage.c"
}

static void
____lambda121__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 883 "../src/Views/ImportPage.vala"
	___lambda121_ (self);
#line 4982 "ImportPage.c"
}

static GtkMenu*
import_page_real_get_page_context_menu (Page* base)
{
	ImportPage * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp47_;
	GtkMenu* _tmp48_;
	GtkMenu* result;
#line 846 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 847 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->page_context_menu;
#line 847 "../src/Views/ImportPage.vala"
	if (_tmp0_ == NULL) {
#line 4999 "ImportPage.c"
		Block16Data* _data16_;
		GtkMenu* _tmp1_;
		GtkCheckMenuItem* viewtitle_menu_item = NULL;
		GtkCheckMenuItem* _tmp2_;
		GtkAction* viewtitle_action = NULL;
		GtkAction* _tmp3_;
		GtkAction* _tmp4_;
		GtkCheckMenuItem* _tmp5_;
		GtkMenuItem* sort_menu_item = NULL;
		GtkMenuItem* _tmp6_;
		GtkRadioMenuItem* _tmp7_;
		GtkAction* _tmp8_;
		GtkAction* _tmp9_;
		GtkRadioMenuItem* _tmp10_;
		GtkRadioMenuItem* _tmp11_;
		GtkRadioMenuItem* _tmp12_;
		GtkRadioMenuItem* _tmp13_;
		GtkAction* _tmp14_;
		GtkAction* _tmp15_;
		GtkRadioMenuItem* _tmp16_;
		GtkRadioMenuItem* _tmp17_;
		GtkMenu* sort_menu = NULL;
		GtkMenu* _tmp18_;
		GtkMenu* _tmp19_;
		GtkRadioMenuItem* _tmp20_;
		GtkMenu* _tmp21_;
		GtkRadioMenuItem* _tmp22_;
		GtkMenuItem* _tmp23_;
		GtkMenu* _tmp24_;
		GtkMenuItem* select_menu_item = NULL;
		GtkMenuItem* _tmp25_;
		AppWindow* _tmp26_;
		AppWindow* _tmp27_;
		GAction* _tmp28_;
		GAction* _tmp29_;
		GAction* _tmp30_;
		GAction* _tmp31_;
		GtkMenuItem* _tmp32_;
		GtkMenuItem* _tmp33_;
		GtkMenu* _tmp34_;
		GtkCheckMenuItem* _tmp35_;
		GtkMenu* _tmp36_;
		GtkSeparatorMenuItem* _tmp37_;
		GtkSeparatorMenuItem* _tmp38_;
		GtkMenu* _tmp39_;
		GtkMenuItem* _tmp40_;
		GtkMenu* _tmp41_;
		GtkSeparatorMenuItem* _tmp42_;
		GtkSeparatorMenuItem* _tmp43_;
		GtkMenu* _tmp44_;
		GtkMenuItem* _tmp45_;
		GtkMenu* _tmp46_;
#line 847 "../src/Views/ImportPage.vala"
		_data16_ = g_slice_new0 (Block16Data);
#line 847 "../src/Views/ImportPage.vala"
		_data16_->_ref_count_ = 1;
#line 847 "../src/Views/ImportPage.vala"
		_data16_->self = g_object_ref (self);
#line 848 "../src/Views/ImportPage.vala"
		_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 848 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp1_);
#line 848 "../src/Views/ImportPage.vala"
		_g_object_unref0 (self->priv->page_context_menu);
#line 848 "../src/Views/ImportPage.vala"
		self->priv->page_context_menu = _tmp1_;
#line 850 "../src/Views/ImportPage.vala"
		_tmp2_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_ ("_Titles"));
#line 850 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp2_);
#line 850 "../src/Views/ImportPage.vala"
		viewtitle_menu_item = _tmp2_;
#line 851 "../src/Views/ImportPage.vala"
		_tmp3_ = page_get_action ((Page*) self, "ViewTitle");
#line 851 "../src/Views/ImportPage.vala"
		viewtitle_action = _tmp3_;
#line 852 "../src/Views/ImportPage.vala"
		_tmp4_ = viewtitle_action;
#line 852 "../src/Views/ImportPage.vala"
		_tmp5_ = viewtitle_menu_item;
#line 852 "../src/Views/ImportPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp4_, "active", (GObject*) _tmp5_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 854 "../src/Views/ImportPage.vala"
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Sort _Events"));
#line 854 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp6_);
#line 854 "../src/Views/ImportPage.vala"
		sort_menu_item = _tmp6_;
#line 856 "../src/Views/ImportPage.vala"
		_tmp7_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic (NULL, _ ("_Ascending"));
#line 856 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp7_);
#line 856 "../src/Views/ImportPage.vala"
		_data16_->ascending_menu_item = _tmp7_;
#line 857 "../src/Views/ImportPage.vala"
		_tmp8_ = page_get_common_action ((Page*) self, "CommonSortEventsAscending", TRUE);
#line 857 "../src/Views/ImportPage.vala"
		_data16_->ascending_action = _tmp8_;
#line 858 "../src/Views/ImportPage.vala"
		_tmp9_ = _data16_->ascending_action;
#line 858 "../src/Views/ImportPage.vala"
		_tmp10_ = _data16_->ascending_menu_item;
#line 858 "../src/Views/ImportPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp9_, "active", (GObject*) _tmp10_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 859 "../src/Views/ImportPage.vala"
		_tmp11_ = _data16_->ascending_menu_item;
#line 859 "../src/Views/ImportPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp11_, "activate", (GCallback) ____lambda119__gtk_menu_item_activate, block16_data_ref (_data16_), (GClosureNotify) block16_data_unref, 0);
#line 865 "../src/Views/ImportPage.vala"
		_tmp12_ = _data16_->ascending_menu_item;
#line 865 "../src/Views/ImportPage.vala"
		_tmp13_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic_from_widget (_tmp12_, _ ("D_escending"));
#line 865 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp13_);
#line 865 "../src/Views/ImportPage.vala"
		_data16_->descending_menu_item = _tmp13_;
#line 866 "../src/Views/ImportPage.vala"
		_tmp14_ = page_get_common_action ((Page*) self, "CommonSortEventsDescending", TRUE);
#line 866 "../src/Views/ImportPage.vala"
		_data16_->descending_action = _tmp14_;
#line 867 "../src/Views/ImportPage.vala"
		_tmp15_ = _data16_->descending_action;
#line 867 "../src/Views/ImportPage.vala"
		_tmp16_ = _data16_->descending_menu_item;
#line 867 "../src/Views/ImportPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp15_, "active", (GObject*) _tmp16_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 868 "../src/Views/ImportPage.vala"
		_tmp17_ = _data16_->descending_menu_item;
#line 868 "../src/Views/ImportPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp17_, "activate", (GCallback) ____lambda120__gtk_menu_item_activate, block16_data_ref (_data16_), (GClosureNotify) block16_data_unref, 0);
#line 874 "../src/Views/ImportPage.vala"
		_tmp18_ = (GtkMenu*) gtk_menu_new ();
#line 874 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp18_);
#line 874 "../src/Views/ImportPage.vala"
		sort_menu = _tmp18_;
#line 875 "../src/Views/ImportPage.vala"
		_tmp19_ = sort_menu;
#line 875 "../src/Views/ImportPage.vala"
		_tmp20_ = _data16_->ascending_menu_item;
#line 875 "../src/Views/ImportPage.vala"
		gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 876 "../src/Views/ImportPage.vala"
		_tmp21_ = sort_menu;
#line 876 "../src/Views/ImportPage.vala"
		_tmp22_ = _data16_->descending_menu_item;
#line 876 "../src/Views/ImportPage.vala"
		gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 877 "../src/Views/ImportPage.vala"
		_tmp23_ = sort_menu_item;
#line 877 "../src/Views/ImportPage.vala"
		_tmp24_ = sort_menu;
#line 877 "../src/Views/ImportPage.vala"
		gtk_menu_item_set_submenu (_tmp23_, _tmp24_);
#line 879 "../src/Views/ImportPage.vala"
		_tmp25_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_SELECT_ALL_MENU);
#line 879 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp25_);
#line 879 "../src/Views/ImportPage.vala"
		select_menu_item = _tmp25_;
#line 881 "../src/Views/ImportPage.vala"
		_tmp26_ = app_window_get_instance ();
#line 881 "../src/Views/ImportPage.vala"
		_tmp27_ = _tmp26_;
#line 881 "../src/Views/ImportPage.vala"
		_tmp28_ = g_action_map_lookup_action ((GActionMap*) _tmp27_, APP_WINDOW_ACTION_SELECT_ALL);
#line 881 "../src/Views/ImportPage.vala"
		_tmp29_ = _g_object_ref0 (_tmp28_);
#line 881 "../src/Views/ImportPage.vala"
		_tmp30_ = _tmp29_;
#line 881 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp27_);
#line 881 "../src/Views/ImportPage.vala"
		_data16_->select_action = _tmp30_;
#line 882 "../src/Views/ImportPage.vala"
		_tmp31_ = _data16_->select_action;
#line 882 "../src/Views/ImportPage.vala"
		_tmp32_ = select_menu_item;
#line 882 "../src/Views/ImportPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp31_, "enabled", (GObject*) _tmp32_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 883 "../src/Views/ImportPage.vala"
		_tmp33_ = select_menu_item;
#line 883 "../src/Views/ImportPage.vala"
		g_signal_connect_data (_tmp33_, "activate", (GCallback) ____lambda121__gtk_menu_item_activate, block16_data_ref (_data16_), (GClosureNotify) block16_data_unref, 0);
#line 885 "../src/Views/ImportPage.vala"
		_tmp34_ = self->priv->page_context_menu;
#line 885 "../src/Views/ImportPage.vala"
		_tmp35_ = viewtitle_menu_item;
#line 885 "../src/Views/ImportPage.vala"
		gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 886 "../src/Views/ImportPage.vala"
		_tmp36_ = self->priv->page_context_menu;
#line 886 "../src/Views/ImportPage.vala"
		_tmp37_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 886 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp37_);
#line 886 "../src/Views/ImportPage.vala"
		_tmp38_ = _tmp37_;
#line 886 "../src/Views/ImportPage.vala"
		gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp38_);
#line 886 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp38_);
#line 887 "../src/Views/ImportPage.vala"
		_tmp39_ = self->priv->page_context_menu;
#line 887 "../src/Views/ImportPage.vala"
		_tmp40_ = sort_menu_item;
#line 887 "../src/Views/ImportPage.vala"
		gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
#line 888 "../src/Views/ImportPage.vala"
		_tmp41_ = self->priv->page_context_menu;
#line 888 "../src/Views/ImportPage.vala"
		_tmp42_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 888 "../src/Views/ImportPage.vala"
		g_object_ref_sink (_tmp42_);
#line 888 "../src/Views/ImportPage.vala"
		_tmp43_ = _tmp42_;
#line 888 "../src/Views/ImportPage.vala"
		gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp43_);
#line 888 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp43_);
#line 889 "../src/Views/ImportPage.vala"
		_tmp44_ = self->priv->page_context_menu;
#line 889 "../src/Views/ImportPage.vala"
		_tmp45_ = select_menu_item;
#line 889 "../src/Views/ImportPage.vala"
		gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
#line 890 "../src/Views/ImportPage.vala"
		_tmp46_ = self->priv->page_context_menu;
#line 890 "../src/Views/ImportPage.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp46_);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (select_menu_item);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (sort_menu);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (sort_menu_item);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (viewtitle_action);
#line 847 "../src/Views/ImportPage.vala"
		_g_object_unref0 (viewtitle_menu_item);
#line 847 "../src/Views/ImportPage.vala"
		block16_data_unref (_data16_);
#line 847 "../src/Views/ImportPage.vala"
		_data16_ = NULL;
#line 5244 "ImportPage.c"
	}
#line 893 "../src/Views/ImportPage.vala"
	_tmp47_ = self->priv->page_context_menu;
#line 893 "../src/Views/ImportPage.vala"
	_tmp48_ = _g_object_ref0 (_tmp47_);
#line 893 "../src/Views/ImportPage.vala"
	result = _tmp48_;
#line 893 "../src/Views/ImportPage.vala"
	return result;
#line 5254 "ImportPage.c"
}

static GtkMenu*
import_page_real_get_page_sidebar_menu (Page* base)
{
	ImportPage * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* result;
#line 896 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 897 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->import_context_menu;
#line 897 "../src/Views/ImportPage.vala"
	if (_tmp0_ == NULL) {
#line 898 "../src/Views/ImportPage.vala"
		import_page_create_import_context_menu (self);
#line 5273 "ImportPage.c"
	}
#line 901 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->import_context_menu;
#line 901 "../src/Views/ImportPage.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 901 "../src/Views/ImportPage.vala"
	result = _tmp2_;
#line 901 "../src/Views/ImportPage.vala"
	return result;
#line 5283 "ImportPage.c"
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 904 "../src/Views/ImportPage.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 904 "../src/Views/ImportPage.vala"
	return _data17_;
#line 5293 "ImportPage.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 904 "../src/Views/ImportPage.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 5303 "ImportPage.c"
		ImportPage* self;
#line 904 "../src/Views/ImportPage.vala"
		self = _data17_->self;
#line 904 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_data17_->all_action);
#line 904 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_data17_->selected_action);
#line 904 "../src/Views/ImportPage.vala"
		_g_object_unref0 (self);
#line 904 "../src/Views/ImportPage.vala"
		g_slice_free (Block17Data, _data17_);
#line 5315 "ImportPage.c"
	}
}

static void
__lambda117_ (Block17Data* _data17_)
{
	ImportPage* self;
#line 910 "../src/Views/ImportPage.vala"
	self = _data17_->self;
#line 910 "../src/Views/ImportPage.vala"
	gtk_action_activate (_data17_->selected_action);
#line 5327 "ImportPage.c"
}

static void
___lambda117__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 910 "../src/Views/ImportPage.vala"
	__lambda117_ (self);
#line 5336 "ImportPage.c"
}

static void
__lambda118_ (Block17Data* _data17_)
{
	ImportPage* self;
#line 915 "../src/Views/ImportPage.vala"
	self = _data17_->self;
#line 915 "../src/Views/ImportPage.vala"
	gtk_action_activate (_data17_->all_action);
#line 5347 "ImportPage.c"
}

static void
___lambda118__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 915 "../src/Views/ImportPage.vala"
	__lambda118_ (self);
#line 5356 "ImportPage.c"
}

static void
import_page_create_import_context_menu (ImportPage* self)
{
	Block17Data* _data17_;
	GtkMenu* _tmp0_;
	GtkMenuItem* selected_menu_item = NULL;
	GtkMenuItem* _tmp1_;
	GtkAction* _tmp2_;
	GtkMenuItem* all_menu_item = NULL;
	GtkMenuItem* _tmp3_;
	GtkAction* _tmp4_;
	GtkMenu* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
#line 904 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 904 "../src/Views/ImportPage.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 904 "../src/Views/ImportPage.vala"
	_data17_->_ref_count_ = 1;
#line 904 "../src/Views/ImportPage.vala"
	_data17_->self = g_object_ref (self);
#line 905 "../src/Views/ImportPage.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 905 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp0_);
#line 905 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->import_context_menu);
#line 905 "../src/Views/ImportPage.vala"
	self->priv->import_context_menu = _tmp0_;
#line 907 "../src/Views/ImportPage.vala"
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Import _Selected"));
#line 907 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp1_);
#line 907 "../src/Views/ImportPage.vala"
	selected_menu_item = _tmp1_;
#line 908 "../src/Views/ImportPage.vala"
	_tmp2_ = page_get_common_action ((Page*) self, "ImportSelected", TRUE);
#line 908 "../src/Views/ImportPage.vala"
	_data17_->selected_action = _tmp2_;
#line 909 "../src/Views/ImportPage.vala"
	g_object_bind_property_with_closures ((GObject*) _data17_->selected_action, "sensitive", (GObject*) selected_menu_item, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 910 "../src/Views/ImportPage.vala"
	g_signal_connect_data (selected_menu_item, "activate", (GCallback) ___lambda117__gtk_menu_item_activate, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 912 "../src/Views/ImportPage.vala"
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Import _All"));
#line 912 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp3_);
#line 912 "../src/Views/ImportPage.vala"
	all_menu_item = _tmp3_;
#line 913 "../src/Views/ImportPage.vala"
	_tmp4_ = page_get_common_action ((Page*) self, "ImportAll", TRUE);
#line 913 "../src/Views/ImportPage.vala"
	_data17_->all_action = _tmp4_;
#line 914 "../src/Views/ImportPage.vala"
	g_object_bind_property_with_closures ((GObject*) _data17_->all_action, "sensitive", (GObject*) all_menu_item, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 915 "../src/Views/ImportPage.vala"
	g_signal_connect_data (all_menu_item, "activate", (GCallback) ___lambda118__gtk_menu_item_activate, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 917 "../src/Views/ImportPage.vala"
	_tmp5_ = self->priv->import_context_menu;
#line 917 "../src/Views/ImportPage.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) selected_menu_item);
#line 918 "../src/Views/ImportPage.vala"
	_tmp6_ = self->priv->import_context_menu;
#line 918 "../src/Views/ImportPage.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) all_menu_item);
#line 919 "../src/Views/ImportPage.vala"
	_tmp7_ = self->priv->import_context_menu;
#line 919 "../src/Views/ImportPage.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp7_);
#line 904 "../src/Views/ImportPage.vala"
	_g_object_unref0 (all_menu_item);
#line 904 "../src/Views/ImportPage.vala"
	_g_object_unref0 (selected_menu_item);
#line 904 "../src/Views/ImportPage.vala"
	block17_data_unref (_data17_);
#line 904 "../src/Views/ImportPage.vala"
	_data17_ = NULL;
#line 5437 "ImportPage.c"
}

static gpointer
_core_tracker_ref0 (gpointer self)
{
#line 923 "../src/Views/ImportPage.vala"
	return self ? core_tracker_ref (self) : NULL;
#line 5445 "ImportPage.c"
}

static CoreViewTracker*
import_page_real_get_view_tracker (CheckerboardPage* base)
{
	ImportPage * self;
	CameraViewTracker* _tmp0_;
	CoreViewTracker* _tmp1_;
	CoreViewTracker* result;
#line 922 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 923 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->tracker;
#line 923 "../src/Views/ImportPage.vala"
	_tmp1_ = _core_tracker_ref0 ((CoreViewTracker*) _tmp0_);
#line 923 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 923 "../src/Views/ImportPage.vala"
	return result;
#line 5465 "ImportPage.c"
}

static gchar*
import_page_real_get_view_empty_message (CheckerboardPage* base)
{
	ImportPage * self;
	gchar* _tmp0_;
	gchar* result;
#line 930 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 931 "../src/Views/ImportPage.vala"
	_tmp0_ = g_strdup (_ ("Starting import, please wait…"));
#line 931 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 931 "../src/Views/ImportPage.vala"
	return result;
#line 5482 "ImportPage.c"
}

static gint64
import_page_preview_comparator (void* a,
                                void* b)
{
	ImportSource* _tmp0_;
	ImportSource* _tmp1_;
	ImportSource* _tmp2_;
	ImportSource* _tmp3_;
	gint64 _tmp4_;
	gint64 result;
#line 935 "../src/Views/ImportPage.vala"
	_tmp0_ = import_preview_get_import_source ((ImportPreview*) a);
#line 935 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 935 "../src/Views/ImportPage.vala"
	_tmp2_ = import_preview_get_import_source ((ImportPreview*) b);
#line 935 "../src/Views/ImportPage.vala"
	_tmp3_ = _tmp2_;
#line 935 "../src/Views/ImportPage.vala"
	_tmp4_ = import_source_get_exposure_time (_tmp1_) - import_source_get_exposure_time (_tmp3_);
#line 935 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp3_);
#line 935 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp1_);
#line 935 "../src/Views/ImportPage.vala"
	result = _tmp4_;
#line 935 "../src/Views/ImportPage.vala"
	return result;
#line 5513 "ImportPage.c"
}

static gboolean
import_page_preview_comparator_predicate (DataObject* object,
                                          Alteration* alteration)
{
	gboolean result;
#line 939 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 939 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 940 "../src/Views/ImportPage.vala"
	result = alteration_has_detail (alteration, "metadata", "exposure-time");
#line 940 "../src/Views/ImportPage.vala"
	return result;
#line 5529 "ImportPage.c"
}

static gint64
import_page_import_job_comparator (ImportPage* self,
                                   void* a,
                                   void* b)
{
	gint64 result;
#line 943 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 944 "../src/Views/ImportPage.vala"
	result = import_page_camera_import_job_get_exposure_time ((ImportPageCameraImportJob*) a) - import_page_camera_import_job_get_exposure_time ((ImportPageCameraImportJob*) b);
#line 944 "../src/Views/ImportPage.vala"
	return result;
#line 5544 "ImportPage.c"
}

static void
_import_page_on_display_titles_gcallback (GtkAction* action,
                                          gpointer self)
{
#line 950 "../src/Views/ImportPage.vala"
	import_page_on_display_titles ((ImportPage*) self, action);
#line 5553 "ImportPage.c"
}

static void
_vala_array_add153 (GtkToggleActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkToggleActionEntry* value)
{
#line 954 "../src/Views/ImportPage.vala"
	if ((*length) == (*size)) {
#line 954 "../src/Views/ImportPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 954 "../src/Views/ImportPage.vala"
		*array = g_renew (GtkToggleActionEntry, *array, *size);
#line 5568 "ImportPage.c"
	}
#line 954 "../src/Views/ImportPage.vala"
	(*array)[(*length)++] = *value;
#line 5572 "ImportPage.c"
}

static GtkToggleActionEntry*
import_page_real_init_collect_toggle_action_entries (Page* base,
                                                     gint* result_length1)
{
	ImportPage * self;
	GtkToggleActionEntry* toggle_actions = NULL;
	gint _tmp0_ = 0;
	GtkToggleActionEntry* _tmp1_;
	gint toggle_actions_length1;
	gint _toggle_actions_size_;
	GtkToggleActionEntry titles = {0};
	GSettings* _tmp2_;
	GtkToggleActionEntry _tmp3_ = {0};
	GtkToggleActionEntry _tmp4_;
	GtkToggleActionEntry* _tmp5_;
	gint _tmp5__length1;
	GtkToggleActionEntry* result;
#line 947 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 948 "../src/Views/ImportPage.vala"
	_tmp1_ = PAGE_CLASS (import_page_parent_class)->init_collect_toggle_action_entries ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), &_tmp0_);
#line 948 "../src/Views/ImportPage.vala"
	toggle_actions = _tmp1_;
#line 948 "../src/Views/ImportPage.vala"
	toggle_actions_length1 = _tmp0_;
#line 948 "../src/Views/ImportPage.vala"
	_toggle_actions_size_ = toggle_actions_length1;
#line 950 "../src/Views/ImportPage.vala"
	_tmp2_ = ((Page*) self)->ui_settings;
#line 950 "../src/Views/ImportPage.vala"
	_tmp3_.name = "ViewTitle";
#line 950 "../src/Views/ImportPage.vala"
	_tmp3_.stock_id = NULL;
#line 950 "../src/Views/ImportPage.vala"
	_tmp3_.label = _ ("_Titles");
#line 950 "../src/Views/ImportPage.vala"
	_tmp3_.accelerator = "<Ctrl><Shift>T";
#line 950 "../src/Views/ImportPage.vala"
	_tmp3_.tooltip = _ ("Display the title of each photo");
#line 950 "../src/Views/ImportPage.vala"
	_tmp3_.callback = (GCallback) _import_page_on_display_titles_gcallback;
#line 950 "../src/Views/ImportPage.vala"
	_tmp3_.is_active = g_settings_get_boolean (_tmp2_, "display-photo-titles");
#line 950 "../src/Views/ImportPage.vala"
	titles = _tmp3_;
#line 954 "../src/Views/ImportPage.vala"
	_tmp4_ = titles;
#line 954 "../src/Views/ImportPage.vala"
	_vala_array_add153 (&toggle_actions, &toggle_actions_length1, &_toggle_actions_size_, &_tmp4_);
#line 956 "../src/Views/ImportPage.vala"
	_tmp5_ = toggle_actions;
#line 956 "../src/Views/ImportPage.vala"
	_tmp5__length1 = toggle_actions_length1;
#line 956 "../src/Views/ImportPage.vala"
	if (result_length1) {
#line 956 "../src/Views/ImportPage.vala"
		*result_length1 = _tmp5__length1;
#line 5632 "ImportPage.c"
	}
#line 956 "../src/Views/ImportPage.vala"
	result = _tmp5_;
#line 956 "../src/Views/ImportPage.vala"
	return result;
#line 5638 "ImportPage.c"
}

static void
_import_page_on_import_selected_gcallback (GtkAction* action,
                                           gpointer self)
{
#line 962 "../src/Views/ImportPage.vala"
	import_page_on_import_selected ((ImportPage*) self);
#line 5647 "ImportPage.c"
}

static void
_vala_array_add154 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 965 "../src/Views/ImportPage.vala"
	if ((*length) == (*size)) {
#line 965 "../src/Views/ImportPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 965 "../src/Views/ImportPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 5662 "ImportPage.c"
	}
#line 965 "../src/Views/ImportPage.vala"
	(*array)[(*length)++] = *value;
#line 5666 "ImportPage.c"
}

static void
_import_page_on_import_all_gcallback (GtkAction* action,
                                      gpointer self)
{
#line 967 "../src/Views/ImportPage.vala"
	import_page_on_import_all ((ImportPage*) self);
#line 5675 "ImportPage.c"
}

static void
_vala_array_add155 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 970 "../src/Views/ImportPage.vala"
	if ((*length) == (*size)) {
#line 970 "../src/Views/ImportPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 970 "../src/Views/ImportPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 5690 "ImportPage.c"
	}
#line 970 "../src/Views/ImportPage.vala"
	(*array)[(*length)++] = *value;
#line 5694 "ImportPage.c"
}

static GtkActionEntry*
import_page_real_init_collect_action_entries (Page* base,
                                              gint* result_length1)
{
	ImportPage * self;
	GtkActionEntry* actions = NULL;
	gint _tmp0_ = 0;
	GtkActionEntry* _tmp1_;
	gint actions_length1;
	gint _actions_size_;
	GtkActionEntry import_selected = {0};
	GtkActionEntry _tmp2_ = {0};
	GtkActionEntry _tmp3_;
	GtkActionEntry import_all = {0};
	GtkActionEntry _tmp4_ = {0};
	GtkActionEntry _tmp5_;
	GtkActionEntry* _tmp6_;
	gint _tmp6__length1;
	GtkActionEntry* result;
#line 959 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 960 "../src/Views/ImportPage.vala"
	_tmp1_ = PAGE_CLASS (import_page_parent_class)->init_collect_action_entries ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), &_tmp0_);
#line 960 "../src/Views/ImportPage.vala"
	actions = _tmp1_;
#line 960 "../src/Views/ImportPage.vala"
	actions_length1 = _tmp0_;
#line 960 "../src/Views/ImportPage.vala"
	_actions_size_ = actions_length1;
#line 962 "../src/Views/ImportPage.vala"
	_tmp2_.name = "ImportSelected";
#line 962 "../src/Views/ImportPage.vala"
	_tmp2_.stock_id = RESOURCES_IMPORT;
#line 962 "../src/Views/ImportPage.vala"
	_tmp2_.label = _ ("Import _Selected");
#line 962 "../src/Views/ImportPage.vala"
	_tmp2_.accelerator = NULL;
#line 962 "../src/Views/ImportPage.vala"
	_tmp2_.tooltip = _ ("Import the selected photos into your library");
#line 962 "../src/Views/ImportPage.vala"
	_tmp2_.callback = (GCallback) _import_page_on_import_selected_gcallback;
#line 962 "../src/Views/ImportPage.vala"
	import_selected = _tmp2_;
#line 965 "../src/Views/ImportPage.vala"
	_tmp3_ = import_selected;
#line 965 "../src/Views/ImportPage.vala"
	_vala_array_add154 (&actions, &actions_length1, &_actions_size_, &_tmp3_);
#line 967 "../src/Views/ImportPage.vala"
	_tmp4_.name = "ImportAll";
#line 967 "../src/Views/ImportPage.vala"
	_tmp4_.stock_id = RESOURCES_IMPORT_ALL;
#line 967 "../src/Views/ImportPage.vala"
	_tmp4_.label = _ ("Import _All");
#line 967 "../src/Views/ImportPage.vala"
	_tmp4_.accelerator = NULL;
#line 967 "../src/Views/ImportPage.vala"
	_tmp4_.tooltip = _ ("Import all the photos into your library");
#line 967 "../src/Views/ImportPage.vala"
	_tmp4_.callback = (GCallback) _import_page_on_import_all_gcallback;
#line 967 "../src/Views/ImportPage.vala"
	import_all = _tmp4_;
#line 970 "../src/Views/ImportPage.vala"
	_tmp5_ = import_all;
#line 970 "../src/Views/ImportPage.vala"
	_vala_array_add155 (&actions, &actions_length1, &_actions_size_, &_tmp5_);
#line 972 "../src/Views/ImportPage.vala"
	_tmp6_ = actions;
#line 972 "../src/Views/ImportPage.vala"
	_tmp6__length1 = actions_length1;
#line 972 "../src/Views/ImportPage.vala"
	if (result_length1) {
#line 972 "../src/Views/ImportPage.vala"
		*result_length1 = _tmp6__length1;
#line 5770 "ImportPage.c"
	}
#line 972 "../src/Views/ImportPage.vala"
	result = _tmp6_;
#line 972 "../src/Views/ImportPage.vala"
	return result;
#line 5776 "ImportPage.c"
}

Camera*
import_page_get_camera (ImportPage* self)
{
	Camera* _tmp0_;
	Camera* _tmp1_;
	Camera* result;
#line 975 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 976 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->camera;
#line 976 "../src/Views/ImportPage.vala"
	_tmp1_ = _GPHOTO_REF_CAMERA0 (_tmp0_);
#line 976 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 976 "../src/Views/ImportPage.vala"
	return result;
#line 5795 "ImportPage.c"
}

gchar*
import_page_get_uri (ImportPage* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 979 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 980 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->uri;
#line 980 "../src/Views/ImportPage.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 980 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 980 "../src/Views/ImportPage.vala"
	return result;
#line 5814 "ImportPage.c"
}

gboolean
import_page_is_busy (ImportPage* self)
{
	gboolean result;
#line 983 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 984 "../src/Views/ImportPage.vala"
	result = self->priv->busy;
#line 984 "../src/Views/ImportPage.vala"
	return result;
#line 5827 "ImportPage.c"
}

static void
import_page_real_init_actions (Page* base,
                               gint selected_count,
                               gint count)
{
	ImportPage * self;
#line 987 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 988 "../src/Views/ImportPage.vala"
	import_page_on_view_changed (self);
#line 990 "../src/Views/ImportPage.vala"
	PAGE_CLASS (import_page_parent_class)->init_actions ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), selected_count, count);
#line 5842 "ImportPage.c"
}

gboolean
import_page_is_refreshed (ImportPage* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 993 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 994 "../src/Views/ImportPage.vala"
	if (self->priv->refreshed) {
#line 994 "../src/Views/ImportPage.vala"
		_tmp0_ = !self->priv->busy;
#line 5856 "ImportPage.c"
	} else {
#line 994 "../src/Views/ImportPage.vala"
		_tmp0_ = FALSE;
#line 5860 "ImportPage.c"
	}
#line 994 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 994 "../src/Views/ImportPage.vala"
	return result;
#line 5866 "ImportPage.c"
}

gchar*
import_page_get_refresh_message (ImportPage* self)
{
	gchar* msg = NULL;
	const gchar* _tmp0_;
	gchar* result;
#line 997 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 998 "../src/Views/ImportPage.vala"
	msg = NULL;
#line 999 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->refresh_error;
#line 999 "../src/Views/ImportPage.vala"
	if (_tmp0_ != NULL) {
#line 5883 "ImportPage.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 1000 "../src/Views/ImportPage.vala"
		_tmp1_ = self->priv->refresh_error;
#line 1000 "../src/Views/ImportPage.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1000 "../src/Views/ImportPage.vala"
		_g_free0 (msg);
#line 1000 "../src/Views/ImportPage.vala"
		msg = _tmp2_;
#line 5894 "ImportPage.c"
	} else {
#line 1001 "../src/Views/ImportPage.vala"
		if (self->priv->refresh_result == GP_OK) {
#line 5898 "ImportPage.c"
		} else {
			gchar* _tmp3_;
#line 1004 "../src/Views/ImportPage.vala"
			_tmp3_ = gp_result_to_full_string (self->priv->refresh_result);
#line 1004 "../src/Views/ImportPage.vala"
			_g_free0 (msg);
#line 1004 "../src/Views/ImportPage.vala"
			msg = _tmp3_;
#line 5907 "ImportPage.c"
		}
	}
#line 1007 "../src/Views/ImportPage.vala"
	result = msg;
#line 1007 "../src/Views/ImportPage.vala"
	return result;
#line 5914 "ImportPage.c"
}

static void
import_page_update_status (ImportPage* self,
                           gboolean busy,
                           gboolean refreshed)
{
#line 1010 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1011 "../src/Views/ImportPage.vala"
	self->priv->busy = busy;
#line 1012 "../src/Views/ImportPage.vala"
	self->priv->refreshed = refreshed;
#line 1014 "../src/Views/ImportPage.vala"
	import_page_on_view_changed (self);
#line 5930 "ImportPage.c"
}

static void
import_page_update_toolbar_state (ImportPage* self)
{
	GtkCheckButton* _tmp0_;
#line 1017 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1018 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->hide_imported;
#line 1018 "../src/Views/ImportPage.vala"
	if (_tmp0_ != NULL) {
#line 5943 "ImportPage.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		GtkCheckButton* _tmp5_;
#line 1019 "../src/Views/ImportPage.vala"
		if (!self->priv->busy) {
#line 1019 "../src/Views/ImportPage.vala"
			_tmp2_ = self->priv->refreshed;
#line 5951 "ImportPage.c"
		} else {
#line 1019 "../src/Views/ImportPage.vala"
			_tmp2_ = FALSE;
#line 5955 "ImportPage.c"
		}
#line 1019 "../src/Views/ImportPage.vala"
		if (_tmp2_) {
#line 5959 "ImportPage.c"
			ViewCollection* _tmp3_;
			ViewCollection* _tmp4_;
#line 1019 "../src/Views/ImportPage.vala"
			_tmp3_ = page_get_view ((Page*) self);
#line 1019 "../src/Views/ImportPage.vala"
			_tmp4_ = _tmp3_;
#line 1019 "../src/Views/ImportPage.vala"
			_tmp1_ = view_collection_get_unfiltered_count (_tmp4_) > 0;
#line 1019 "../src/Views/ImportPage.vala"
			_data_collection_unref0 (_tmp4_);
#line 5970 "ImportPage.c"
		} else {
#line 1019 "../src/Views/ImportPage.vala"
			_tmp1_ = FALSE;
#line 5974 "ImportPage.c"
		}
#line 1019 "../src/Views/ImportPage.vala"
		_tmp5_ = self->priv->hide_imported;
#line 1019 "../src/Views/ImportPage.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, _tmp1_);
#line 5980 "ImportPage.c"
	}
}

static void
import_page_on_view_changed (ImportPage* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_files = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp7_ = FALSE;
	AppWindow* _tmp8_;
	AppWindow* _tmp9_;
	GAction* _tmp10_;
#line 1022 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1023 "../src/Views/ImportPage.vala"
	if (!self->priv->busy) {
#line 5999 "ImportPage.c"
		ViewCollection* _tmp1_;
		ViewCollection* _tmp2_;
#line 1023 "../src/Views/ImportPage.vala"
		_tmp1_ = page_get_view ((Page*) self);
#line 1023 "../src/Views/ImportPage.vala"
		_tmp2_ = _tmp1_;
#line 1023 "../src/Views/ImportPage.vala"
		_tmp0_ = data_collection_get_count ((DataCollection*) _tmp2_) > 0;
#line 1023 "../src/Views/ImportPage.vala"
		_data_collection_unref0 (_tmp2_);
#line 6010 "ImportPage.c"
	} else {
#line 1023 "../src/Views/ImportPage.vala"
		_tmp0_ = FALSE;
#line 6014 "ImportPage.c"
	}
#line 1023 "../src/Views/ImportPage.vala"
	has_files = _tmp0_;
#line 1025 "../src/Views/ImportPage.vala"
	if (!self->priv->busy) {
#line 1025 "../src/Views/ImportPage.vala"
		_tmp4_ = self->priv->refreshed;
#line 6022 "ImportPage.c"
	} else {
#line 1025 "../src/Views/ImportPage.vala"
		_tmp4_ = FALSE;
#line 6026 "ImportPage.c"
	}
#line 1025 "../src/Views/ImportPage.vala"
	if (_tmp4_) {
#line 6030 "ImportPage.c"
		ViewCollection* _tmp5_;
		ViewCollection* _tmp6_;
#line 1025 "../src/Views/ImportPage.vala"
		_tmp5_ = page_get_view ((Page*) self);
#line 1025 "../src/Views/ImportPage.vala"
		_tmp6_ = _tmp5_;
#line 1025 "../src/Views/ImportPage.vala"
		_tmp3_ = view_collection_get_selected_count (_tmp6_) > 0;
#line 1025 "../src/Views/ImportPage.vala"
		_data_collection_unref0 (_tmp6_);
#line 6041 "ImportPage.c"
	} else {
#line 1025 "../src/Views/ImportPage.vala"
		_tmp3_ = FALSE;
#line 6045 "ImportPage.c"
	}
#line 1025 "../src/Views/ImportPage.vala"
	page_set_action_sensitive ((Page*) self, "ImportSelected", _tmp3_);
#line 1026 "../src/Views/ImportPage.vala"
	if (self->priv->refreshed) {
#line 1026 "../src/Views/ImportPage.vala"
		_tmp7_ = has_files;
#line 6053 "ImportPage.c"
	} else {
#line 1026 "../src/Views/ImportPage.vala"
		_tmp7_ = FALSE;
#line 6057 "ImportPage.c"
	}
#line 1026 "../src/Views/ImportPage.vala"
	page_set_action_sensitive ((Page*) self, "ImportAll", _tmp7_);
#line 1027 "../src/Views/ImportPage.vala"
	_tmp8_ = app_window_get_instance ();
#line 1027 "../src/Views/ImportPage.vala"
	_tmp9_ = _tmp8_;
#line 1027 "../src/Views/ImportPage.vala"
	_tmp10_ = g_action_map_lookup_action ((GActionMap*) _tmp9_, APP_WINDOW_ACTION_SELECT_ALL);
#line 1027 "../src/Views/ImportPage.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, g_simple_action_get_type (), GSimpleAction), has_files);
#line 1027 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp9_);
#line 1029 "../src/Views/ImportPage.vala"
	import_page_update_toolbar_state (self);
#line 6073 "ImportPage.c"
}

static void
import_page_on_media_added_removed (ImportPage* self)
{
	ImportPageImportPageSearchViewFilter* _tmp0_;
#line 1032 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1033 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->search_filter;
#line 1033 "../src/Views/ImportPage.vala"
	g_signal_emit_by_name ((ViewFilter*) _tmp0_, "refresh");
#line 6086 "ImportPage.c"
}

static void
import_page_on_display_titles (ImportPage* self,
                               GtkAction* action)
{
	gboolean display = FALSE;
	GSettings* _tmp0_;
#line 1036 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1036 "../src/Views/ImportPage.vala"
	g_return_if_fail (action != NULL);
#line 1037 "../src/Views/ImportPage.vala"
	display = gtk_toggle_action_get_active (G_TYPE_CHECK_INSTANCE_CAST (action, gtk_toggle_action_get_type (), GtkToggleAction));
#line 1039 "../src/Views/ImportPage.vala"
	checkerboard_page_set_display_titles ((CheckerboardPage*) self, display);
#line 1040 "../src/Views/ImportPage.vala"
	_tmp0_ = ((Page*) self)->ui_settings;
#line 1040 "../src/Views/ImportPage.vala"
	g_settings_set_boolean (_tmp0_, "display-photo-titles", display);
#line 6107 "ImportPage.c"
}

static void
import_page_real_switched_to (Page* base)
{
	ImportPage * self;
	GSettings* _tmp0_;
#line 1043 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 1044 "../src/Views/ImportPage.vala"
	_tmp0_ = ((Page*) self)->ui_settings;
#line 1044 "../src/Views/ImportPage.vala"
	checkerboard_page_set_display_titles ((CheckerboardPage*) self, g_settings_get_boolean (_tmp0_, "display-photo-titles"));
#line 1046 "../src/Views/ImportPage.vala"
	PAGE_CLASS (import_page_parent_class)->switched_to ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage));
#line 6123 "ImportPage.c"
}

static void
import_page_real_ready (Page* base)
{
	ImportPage * self;
	ImportPageHideImportedViewFilter* _tmp0_;
#line 1049 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 1050 "../src/Views/ImportPage.vala"
	import_page_try_refreshing_camera (self, FALSE);
#line 1051 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->hide_imported_filter;
#line 1051 "../src/Views/ImportPage.vala"
	g_signal_emit_by_name ((ViewFilter*) _tmp0_, "refresh");
#line 6139 "ImportPage.c"
}

static void
import_page_try_refreshing_camera (ImportPage* self,
                                   gboolean fail_on_locked)
{
	gboolean _tmp0_ = FALSE;
	ImportPageRefreshResult res = 0;
	GError* _inner_error0_ = NULL;
#line 1054 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1056 "../src/Views/ImportPage.vala"
	if (self->priv->refreshed) {
#line 1056 "../src/Views/ImportPage.vala"
		_tmp0_ = TRUE;
#line 6155 "ImportPage.c"
	} else {
#line 1056 "../src/Views/ImportPage.vala"
		_tmp0_ = self->priv->busy;
#line 6159 "ImportPage.c"
	}
#line 1056 "../src/Views/ImportPage.vala"
	if (_tmp0_) {
#line 1057 "../src/Views/ImportPage.vala"
		return;
#line 6165 "ImportPage.c"
	}
#line 1059 "../src/Views/ImportPage.vala"
	res = import_page_refresh_camera (self);
#line 1060 "../src/Views/ImportPage.vala"
	switch (res) {
#line 1060 "../src/Views/ImportPage.vala"
		case IMPORT_PAGE_REFRESH_RESULT_OK:
#line 1060 "../src/Views/ImportPage.vala"
		case IMPORT_PAGE_REFRESH_RESULT_BUSY:
#line 6175 "ImportPage.c"
		{
#line 1065 "../src/Views/ImportPage.vala"
			break;
#line 6179 "ImportPage.c"
		}
#line 1060 "../src/Views/ImportPage.vala"
		case IMPORT_PAGE_REFRESH_RESULT_LOCKED:
#line 6183 "ImportPage.c"
		{
			const gchar* _tmp1_;
			GFile* uri = NULL;
			const gchar* _tmp2_;
			GFile* _tmp3_;
			GMount* mount = NULL;
			GMount* _tmp8_;
#line 1068 "../src/Views/ImportPage.vala"
			if (fail_on_locked) {
#line 1069 "../src/Views/ImportPage.vala"
				app_window_error_message (IMPORT_PAGE_UNMOUNT_FAILED_MSG, NULL, NULL);
#line 1071 "../src/Views/ImportPage.vala"
				break;
#line 6197 "ImportPage.c"
			}
#line 1075 "../src/Views/ImportPage.vala"
			_tmp1_ = self->priv->uri;
#line 1075 "../src/Views/ImportPage.vala"
			g_debug ("ImportPage.vala:1075: Checking if %s is mounted …", _tmp1_);
#line 1077 "../src/Views/ImportPage.vala"
			_tmp2_ = self->priv->uri;
#line 1077 "../src/Views/ImportPage.vala"
			_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 1077 "../src/Views/ImportPage.vala"
			uri = _tmp3_;
#line 1079 "../src/Views/ImportPage.vala"
			mount = NULL;
#line 6211 "ImportPage.c"
			{
				GMount* _tmp4_ = NULL;
				GFile* _tmp5_;
				GMount* _tmp6_;
				GMount* _tmp7_;
#line 1081 "../src/Views/ImportPage.vala"
				_tmp5_ = uri;
#line 1081 "../src/Views/ImportPage.vala"
				_tmp6_ = g_file_find_enclosing_mount (_tmp5_, NULL, &_inner_error0_);
#line 1081 "../src/Views/ImportPage.vala"
				_tmp4_ = _tmp6_;
#line 1081 "../src/Views/ImportPage.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6225 "ImportPage.c"
					goto __catch0_g_error;
				}
#line 1081 "../src/Views/ImportPage.vala"
				_tmp7_ = _tmp4_;
#line 1081 "../src/Views/ImportPage.vala"
				_tmp4_ = NULL;
#line 1081 "../src/Views/ImportPage.vala"
				_g_object_unref0 (mount);
#line 1081 "../src/Views/ImportPage.vala"
				mount = _tmp7_;
#line 1080 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp4_);
#line 6238 "ImportPage.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 1080 "../src/Views/ImportPage.vala"
				g_clear_error (&_inner_error0_);
#line 6245 "ImportPage.c"
			}
			__finally0:
#line 1080 "../src/Views/ImportPage.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1080 "../src/Views/ImportPage.vala"
				_g_object_unref0 (mount);
#line 1080 "../src/Views/ImportPage.vala"
				_g_object_unref0 (uri);
#line 1080 "../src/Views/ImportPage.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1080 "../src/Views/ImportPage.vala"
				g_clear_error (&_inner_error0_);
#line 1080 "../src/Views/ImportPage.vala"
				return;
#line 6260 "ImportPage.c"
			}
#line 1086 "../src/Views/ImportPage.vala"
			_tmp8_ = mount;
#line 1086 "../src/Views/ImportPage.vala"
			if (_tmp8_ != NULL) {
#line 6266 "ImportPage.c"
				GraniteMessageDialog* dialog = NULL;
				GraniteMessageDialog* _tmp9_;
				GraniteMessageDialog* _tmp10_;
				AppWindow* _tmp11_;
				AppWindow* _tmp12_;
				GraniteMessageDialog* _tmp13_;
				gint dialog_res = 0;
				GraniteMessageDialog* _tmp14_;
				GraniteMessageDialog* _tmp15_;
#line 1087 "../src/Views/ImportPage.vala"
				_tmp9_ = granite_message_dialog_new_with_image_from_icon_name (_ ("The Camera Cannot Be Accessed While Mounted"), _ ("Photos needs to unmount the camera from the filesystem in order to acc" \
"ess it."), "media-eject", GTK_BUTTONS_CANCEL);
#line 1087 "../src/Views/ImportPage.vala"
				g_object_ref_sink (_tmp9_);
#line 1087 "../src/Views/ImportPage.vala"
				dialog = _tmp9_;
#line 1093 "../src/Views/ImportPage.vala"
				_tmp10_ = dialog;
#line 1093 "../src/Views/ImportPage.vala"
				_tmp11_ = app_window_get_instance ();
#line 1093 "../src/Views/ImportPage.vala"
				_tmp12_ = _tmp11_;
#line 1093 "../src/Views/ImportPage.vala"
				gtk_window_set_transient_for ((GtkWindow*) _tmp10_, (GtkWindow*) _tmp12_);
#line 1093 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp12_);
#line 1095 "../src/Views/ImportPage.vala"
				_tmp13_ = dialog;
#line 1095 "../src/Views/ImportPage.vala"
				gtk_dialog_add_button ((GtkDialog*) _tmp13_, _ ("_Unmount"), (gint) GTK_RESPONSE_YES);
#line 1097 "../src/Views/ImportPage.vala"
				_tmp14_ = dialog;
#line 1097 "../src/Views/ImportPage.vala"
				dialog_res = gtk_dialog_run ((GtkDialog*) _tmp14_);
#line 1098 "../src/Views/ImportPage.vala"
				_tmp15_ = dialog;
#line 1098 "../src/Views/ImportPage.vala"
				gtk_widget_destroy ((GtkWidget*) _tmp15_);
#line 1100 "../src/Views/ImportPage.vala"
				if (dialog_res != ((gint) GTK_RESPONSE_YES)) {
#line 1101 "../src/Views/ImportPage.vala"
					checkerboard_page_set_page_message ((CheckerboardPage*) self, _ ("Please unmount the camera."));
#line 6308 "ImportPage.c"
				} else {
					GMount* _tmp16_;
#line 1103 "../src/Views/ImportPage.vala"
					_tmp16_ = mount;
#line 1103 "../src/Views/ImportPage.vala"
					import_page_unmount_camera (self, _tmp16_);
#line 6315 "ImportPage.c"
				}
#line 1086 "../src/Views/ImportPage.vala"
				_g_object_unref0 (dialog);
#line 6319 "ImportPage.c"
			} else {
				GraniteMessageDialog* dialog = NULL;
				GraniteMessageDialog* _tmp17_;
				GraniteMessageDialog* _tmp18_;
				AppWindow* _tmp19_;
				AppWindow* _tmp20_;
				GraniteMessageDialog* _tmp21_;
				GraniteMessageDialog* _tmp22_;
#line 1107 "../src/Views/ImportPage.vala"
				_tmp17_ = granite_message_dialog_new_with_image_from_icon_name (_ ("The Camera Is Locked By Another Application"), _ ("Photos can only access the camera when it's unlocked. Please close any" \
" other application using the camera and try again."), "dialog-warning", GTK_BUTTONS_CLOSE);
#line 1107 "../src/Views/ImportPage.vala"
				g_object_ref_sink (_tmp17_);
#line 1107 "../src/Views/ImportPage.vala"
				dialog = _tmp17_;
#line 1112 "../src/Views/ImportPage.vala"
				_tmp18_ = dialog;
#line 1112 "../src/Views/ImportPage.vala"
				_tmp19_ = app_window_get_instance ();
#line 1112 "../src/Views/ImportPage.vala"
				_tmp20_ = _tmp19_;
#line 1112 "../src/Views/ImportPage.vala"
				gtk_window_set_transient_for ((GtkWindow*) _tmp18_, (GtkWindow*) _tmp20_);
#line 1112 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp20_);
#line 1113 "../src/Views/ImportPage.vala"
				_tmp21_ = dialog;
#line 1113 "../src/Views/ImportPage.vala"
				gtk_dialog_run ((GtkDialog*) _tmp21_);
#line 1114 "../src/Views/ImportPage.vala"
				_tmp22_ = dialog;
#line 1114 "../src/Views/ImportPage.vala"
				gtk_widget_destroy ((GtkWidget*) _tmp22_);
#line 1116 "../src/Views/ImportPage.vala"
				checkerboard_page_set_page_message ((CheckerboardPage*) self, _ ("Please close any other application using the camera."));
#line 1086 "../src/Views/ImportPage.vala"
				_g_object_unref0 (dialog);
#line 6356 "ImportPage.c"
			}
#line 1118 "../src/Views/ImportPage.vala"
			_g_object_unref0 (mount);
#line 1118 "../src/Views/ImportPage.vala"
			_g_object_unref0 (uri);
#line 1118 "../src/Views/ImportPage.vala"
			break;
#line 6364 "ImportPage.c"
		}
#line 1060 "../src/Views/ImportPage.vala"
		case IMPORT_PAGE_REFRESH_RESULT_LIBRARY_ERROR:
#line 6368 "ImportPage.c"
		{
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 1121 "../src/Views/ImportPage.vala"
			_tmp23_ = import_page_get_refresh_message (self);
#line 1121 "../src/Views/ImportPage.vala"
			_tmp24_ = _tmp23_;
#line 1121 "../src/Views/ImportPage.vala"
			_tmp25_ = g_strdup_printf (_ ("Unable to fetch previews from the camera:\n%s"), _tmp24_);
#line 1121 "../src/Views/ImportPage.vala"
			_tmp26_ = _tmp25_;
#line 1121 "../src/Views/ImportPage.vala"
			app_window_error_message (_tmp26_, NULL, NULL);
#line 1121 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp26_);
#line 1121 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp24_);
#line 1123 "../src/Views/ImportPage.vala"
			break;
#line 6390 "ImportPage.c"
		}
		default:
		{
#line 1126 "../src/Views/ImportPage.vala"
			g_error ("ImportPage.vala:1126: Unknown result type %d", (gint) res);
#line 6396 "ImportPage.c"
		}
	}
}

static void
_import_page_on_unmounted_g_mount_unmounted (GMount* _sender,
                                             gpointer self)
{
#line 1143 "../src/Views/ImportPage.vala"
	import_page_on_unmounted ((ImportPage*) self, _sender);
#line 6407 "ImportPage.c"
}

static void
_import_page_on_unmount_finished_gasync_ready_callback (GObject* source_object,
                                                        GAsyncResult* res,
                                                        gpointer self)
{
#line 1146 "../src/Views/ImportPage.vala"
	import_page_on_unmount_finished ((ImportPage*) self, source_object, res);
#line 1146 "../src/Views/ImportPage.vala"
	g_object_unref (self);
#line 6419 "ImportPage.c"
}

gboolean
import_page_unmount_camera (ImportPage* self,
                            GMount* mount)
{
	GtkProgressBar* _tmp0_;
	GtkProgressBar* _tmp1_;
	GtkProgressBar* _tmp2_;
	GtkProgressBar* _tmp3_;
	AppWindow* _tmp4_;
	AppWindow* _tmp5_;
	GtkMountOperation* _tmp6_;
	GtkMountOperation* _tmp7_;
	gboolean result;
#line 1130 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1130 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (mount != NULL, FALSE);
#line 1131 "../src/Views/ImportPage.vala"
	if (self->priv->busy) {
#line 1132 "../src/Views/ImportPage.vala"
		result = FALSE;
#line 1132 "../src/Views/ImportPage.vala"
		return result;
#line 6445 "ImportPage.c"
	}
#line 1134 "../src/Views/ImportPage.vala"
	import_page_update_status (self, TRUE, FALSE);
#line 1135 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->progress_bar;
#line 1135 "../src/Views/ImportPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 1136 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->progress_bar;
#line 1136 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_fraction (_tmp1_, 0.0);
#line 1137 "../src/Views/ImportPage.vala"
	_tmp2_ = self->priv->progress_bar;
#line 1137 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_ellipsize (_tmp2_, PANGO_ELLIPSIZE_NONE);
#line 1138 "../src/Views/ImportPage.vala"
	_tmp3_ = self->priv->progress_bar;
#line 1138 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_text (_tmp3_, _ ("Unmounting…"));
#line 1143 "../src/Views/ImportPage.vala"
	g_signal_connect_object (mount, "unmounted", (GCallback) _import_page_on_unmounted_g_mount_unmounted, self, 0);
#line 1145 "../src/Views/ImportPage.vala"
	g_debug ("ImportPage.vala:1145: Unmounting camera …");
#line 1146 "../src/Views/ImportPage.vala"
	_tmp4_ = app_window_get_instance ();
#line 1146 "../src/Views/ImportPage.vala"
	_tmp5_ = _tmp4_;
#line 1146 "../src/Views/ImportPage.vala"
	_tmp6_ = (GtkMountOperation*) gtk_mount_operation_new ((GtkWindow*) _tmp5_);
#line 1146 "../src/Views/ImportPage.vala"
	_tmp7_ = _tmp6_;
#line 1146 "../src/Views/ImportPage.vala"
	g_mount_unmount_with_operation (mount, G_MOUNT_UNMOUNT_NONE, (GMountOperation*) _tmp7_, NULL, _import_page_on_unmount_finished_gasync_ready_callback, g_object_ref (self));
#line 1146 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp7_);
#line 1146 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp5_);
#line 1149 "../src/Views/ImportPage.vala"
	result = TRUE;
#line 1149 "../src/Views/ImportPage.vala"
	return result;
#line 6487 "ImportPage.c"
}

static void
import_page_on_unmount_finished (ImportPage* self,
                                 GObject* source,
                                 GAsyncResult* aresult)
{
	GMount* mount = NULL;
	GMount* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1152 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1152 "../src/Views/ImportPage.vala"
	g_return_if_fail (aresult != NULL);
#line 1153 "../src/Views/ImportPage.vala"
	g_debug ("ImportPage.vala:1153: Async unmount finished");
#line 1155 "../src/Views/ImportPage.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, g_mount_get_type (), GMount));
#line 1155 "../src/Views/ImportPage.vala"
	mount = _tmp0_;
#line 6508 "ImportPage.c"
	{
#line 1157 "../src/Views/ImportPage.vala"
		g_mount_unmount_with_operation_finish (mount, aresult, &_inner_error0_);
#line 1157 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6514 "ImportPage.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		guint _tmp1_;
		GtkProgressBar* _tmp2_;
		GtkProgressBar* _tmp3_;
		GtkProgressBar* _tmp4_;
#line 1156 "../src/Views/ImportPage.vala"
		g_clear_error (&_inner_error0_);
#line 1159 "../src/Views/ImportPage.vala"
		app_window_error_message (IMPORT_PAGE_UNMOUNT_FAILED_MSG, NULL, NULL);
#line 1162 "../src/Views/ImportPage.vala"
		g_signal_parse_name ("unmounted", g_mount_get_type (), &_tmp1_, NULL, FALSE);
#line 1162 "../src/Views/ImportPage.vala"
		g_signal_handlers_disconnect_matched (mount, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _import_page_on_unmounted_g_mount_unmounted, self);
#line 1164 "../src/Views/ImportPage.vala"
		import_page_update_status (self, FALSE, self->priv->refreshed);
#line 1165 "../src/Views/ImportPage.vala"
		_tmp2_ = self->priv->progress_bar;
#line 1165 "../src/Views/ImportPage.vala"
		gtk_progress_bar_set_ellipsize (_tmp2_, PANGO_ELLIPSIZE_NONE);
#line 1166 "../src/Views/ImportPage.vala"
		_tmp3_ = self->priv->progress_bar;
#line 1166 "../src/Views/ImportPage.vala"
		gtk_progress_bar_set_text (_tmp3_, "");
#line 1167 "../src/Views/ImportPage.vala"
		_tmp4_ = self->priv->progress_bar;
#line 1167 "../src/Views/ImportPage.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 6547 "ImportPage.c"
	}
	__finally0:
#line 1156 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1156 "../src/Views/ImportPage.vala"
		_g_object_unref0 (mount);
#line 1156 "../src/Views/ImportPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1156 "../src/Views/ImportPage.vala"
		g_clear_error (&_inner_error0_);
#line 1156 "../src/Views/ImportPage.vala"
		return;
#line 6560 "ImportPage.c"
	}
#line 1152 "../src/Views/ImportPage.vala"
	_g_object_unref0 (mount);
#line 6564 "ImportPage.c"
}

static void
import_page_on_unmounted (ImportPage* self,
                          GMount* mount)
{
	GtkProgressBar* _tmp0_;
	GtkProgressBar* _tmp1_;
	GtkProgressBar* _tmp2_;
#line 1171 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1171 "../src/Views/ImportPage.vala"
	g_return_if_fail (mount != NULL);
#line 1172 "../src/Views/ImportPage.vala"
	g_debug ("ImportPage.vala:1172: on_unmounted");
#line 1174 "../src/Views/ImportPage.vala"
	import_page_update_status (self, FALSE, self->priv->refreshed);
#line 1175 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->progress_bar;
#line 1175 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_ellipsize (_tmp0_, PANGO_ELLIPSIZE_NONE);
#line 1176 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->progress_bar;
#line 1176 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_text (_tmp1_, "");
#line 1177 "../src/Views/ImportPage.vala"
	_tmp2_ = self->priv->progress_bar;
#line 1177 "../src/Views/ImportPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1179 "../src/Views/ImportPage.vala"
	import_page_try_refreshing_camera (self, TRUE);
#line 6596 "ImportPage.c"
}

static void
import_page_clear_all_import_sources (ImportPage* self)
{
	Marker* marker = NULL;
	SourceCollection* _tmp0_;
	Marker* _tmp1_;
	SourceCollection* _tmp2_;
#line 1182 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1183 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->import_sources;
#line 1183 "../src/Views/ImportPage.vala"
	_tmp1_ = data_collection_start_marking ((DataCollection*) _tmp0_);
#line 1183 "../src/Views/ImportPage.vala"
	marker = _tmp1_;
#line 1184 "../src/Views/ImportPage.vala"
	marker_mark_all (marker);
#line 1185 "../src/Views/ImportPage.vala"
	_tmp2_ = self->priv->import_sources;
#line 1185 "../src/Views/ImportPage.vala"
	source_collection_destroy_marked (_tmp2_, marker, FALSE, NULL, NULL, NULL);
#line 1182 "../src/Views/ImportPage.vala"
	_g_object_unref0 (marker);
#line 6622 "ImportPage.c"
}

/**
     * @brief Returns whether the current device has a given directory or not.
     *
     * @param fsid The file system id of the camera or other device to search.
     * @param dir The path to start searching from.
     * @param search_target The name of the directory to look for.
     */
static gboolean
import_page_check_directory_exists (ImportPage* self,
                                    gint fsid,
                                    const gchar* dir,
                                    const gchar* search_target)
{
	gchar* fulldir = NULL;
	Camera* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	int _result_ = 0;
	CameraList* folders = NULL;
	CameraList* _tmp3_ = NULL;
	int _tmp4_;
	Camera* _tmp5_;
	const gchar* _tmp6_;
	CameraList* _tmp7_;
	GPSpinIdleWrapper* _tmp8_;
	GPContext* _tmp9_;
	gint list_len = 0;
	CameraList* _tmp10_;
	gboolean result;
#line 1195 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1195 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 1195 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (search_target != NULL, FALSE);
#line 1196 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->camera;
#line 1196 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->camera_name;
#line 1196 "../src/Views/ImportPage.vala"
	_tmp2_ = import_page_get_fulldir (_tmp0_, _tmp1_, fsid, dir);
#line 1196 "../src/Views/ImportPage.vala"
	fulldir = _tmp2_;
#line 1200 "../src/Views/ImportPage.vala"
	_tmp4_ = gp_list_new (&_tmp3_);
#line 1200 "../src/Views/ImportPage.vala"
	_gp_list_unref0 (folders);
#line 1200 "../src/Views/ImportPage.vala"
	folders = _tmp3_;
#line 1200 "../src/Views/ImportPage.vala"
	_result_ = _tmp4_;
#line 1201 "../src/Views/ImportPage.vala"
	if (_result_ != GP_OK) {
#line 1203 "../src/Views/ImportPage.vala"
		result = FALSE;
#line 1203 "../src/Views/ImportPage.vala"
		_gp_list_unref0 (folders);
#line 1203 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 1203 "../src/Views/ImportPage.vala"
		return result;
#line 6686 "ImportPage.c"
	}
#line 1206 "../src/Views/ImportPage.vala"
	_tmp5_ = self->priv->camera;
#line 1206 "../src/Views/ImportPage.vala"
	_tmp6_ = fulldir;
#line 1206 "../src/Views/ImportPage.vala"
	_tmp7_ = folders;
#line 1206 "../src/Views/ImportPage.vala"
	_tmp8_ = import_page_spin_idle_context;
#line 1206 "../src/Views/ImportPage.vala"
	_tmp9_ = ((GPContextWrapper*) _tmp8_)->context;
#line 1206 "../src/Views/ImportPage.vala"
	_result_ = gp_camera_folder_list_folders (_tmp5_, _tmp6_, _tmp7_, _tmp9_);
#line 1207 "../src/Views/ImportPage.vala"
	if (_result_ != GP_OK) {
#line 1209 "../src/Views/ImportPage.vala"
		result = FALSE;
#line 1209 "../src/Views/ImportPage.vala"
		_gp_list_unref0 (folders);
#line 1209 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 1209 "../src/Views/ImportPage.vala"
		return result;
#line 6710 "ImportPage.c"
	}
#line 1212 "../src/Views/ImportPage.vala"
	_tmp10_ = folders;
#line 1212 "../src/Views/ImportPage.vala"
	list_len = gp_list_count (_tmp10_);
#line 6716 "ImportPage.c"
	{
		gint list_index = 0;
#line 1214 "../src/Views/ImportPage.vala"
		list_index = 0;
#line 6721 "ImportPage.c"
		{
			gboolean _tmp11_ = FALSE;
#line 1214 "../src/Views/ImportPage.vala"
			_tmp11_ = TRUE;
#line 1214 "../src/Views/ImportPage.vala"
			while (TRUE) {
#line 6728 "ImportPage.c"
				gchar* tmp = NULL;
				CameraList* _tmp13_;
				const gchar* _tmp14_ = NULL;
				gchar* _tmp15_;
				const gchar* _tmp16_;
#line 1214 "../src/Views/ImportPage.vala"
				if (!_tmp11_) {
#line 6736 "ImportPage.c"
					gint _tmp12_;
#line 1214 "../src/Views/ImportPage.vala"
					_tmp12_ = list_index;
#line 1214 "../src/Views/ImportPage.vala"
					list_index = _tmp12_ + 1;
#line 6742 "ImportPage.c"
				}
#line 1214 "../src/Views/ImportPage.vala"
				_tmp11_ = FALSE;
#line 1214 "../src/Views/ImportPage.vala"
				if (!(list_index < list_len)) {
#line 1214 "../src/Views/ImportPage.vala"
					break;
#line 6750 "ImportPage.c"
				}
#line 1217 "../src/Views/ImportPage.vala"
				_tmp13_ = folders;
#line 1217 "../src/Views/ImportPage.vala"
				gp_list_get_name (_tmp13_, list_index, &_tmp14_);
#line 1217 "../src/Views/ImportPage.vala"
				_g_free0 (tmp);
#line 1217 "../src/Views/ImportPage.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 1217 "../src/Views/ImportPage.vala"
				tmp = _tmp15_;
#line 1218 "../src/Views/ImportPage.vala"
				_tmp16_ = tmp;
#line 1218 "../src/Views/ImportPage.vala"
				if (g_strcmp0 (_tmp16_, search_target) == 0) {
#line 1219 "../src/Views/ImportPage.vala"
					result = TRUE;
#line 1219 "../src/Views/ImportPage.vala"
					_g_free0 (tmp);
#line 1219 "../src/Views/ImportPage.vala"
					_gp_list_unref0 (folders);
#line 1219 "../src/Views/ImportPage.vala"
					_g_free0 (fulldir);
#line 1219 "../src/Views/ImportPage.vala"
					return result;
#line 6776 "ImportPage.c"
				}
#line 1214 "../src/Views/ImportPage.vala"
				_g_free0 (tmp);
#line 6780 "ImportPage.c"
			}
		}
	}
#line 1222 "../src/Views/ImportPage.vala"
	result = FALSE;
#line 1222 "../src/Views/ImportPage.vala"
	_gp_list_unref0 (folders);
#line 1222 "../src/Views/ImportPage.vala"
	_g_free0 (fulldir);
#line 1222 "../src/Views/ImportPage.vala"
	return result;
#line 6792 "ImportPage.c"
}

static ImportPageRefreshResult
import_page_refresh_camera (ImportPage* self)
{
	Camera* _tmp0_;
	GPSpinIdleWrapper* _tmp1_;
	GPContext* _tmp2_;
	GtkProgressBar* _tmp6_;
	GtkProgressBar* _tmp7_;
	GtkProgressBar* _tmp8_;
	GtkProgressBar* _tmp9_;
	GtkProgressBar* _tmp10_;
	GeeArrayList* import_list = NULL;
	GeeArrayList* _tmp11_;
	CameraStorageInformation* sifs = NULL;
	gint sifs_length1;
	gint _sifs_size_;
	Camera* _tmp12_;
	GPSpinIdleWrapper* _tmp13_;
	GPContext* _tmp14_;
	CameraStorageInformation* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	int _tmp17_;
	GeeArrayList* _tmp32_;
	GeeArrayList* _tmp33_;
	GtkProgressBar* _tmp34_;
	GtkProgressBar* _tmp35_;
	GtkProgressBar* _tmp36_;
	GtkProgressBar* _tmp37_;
	int res = 0;
	Camera* _tmp38_;
	GPSpinIdleWrapper* _tmp39_;
	GPContext* _tmp40_;
	ImportPageRefreshResult result;
#line 1225 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1226 "../src/Views/ImportPage.vala"
	if (self->priv->busy) {
#line 1227 "../src/Views/ImportPage.vala"
		result = IMPORT_PAGE_REFRESH_RESULT_BUSY;
#line 1227 "../src/Views/ImportPage.vala"
		return result;
#line 6836 "ImportPage.c"
	}
#line 1229 "../src/Views/ImportPage.vala"
	import_page_update_status (self, self->priv->busy, FALSE);
#line 1231 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->refresh_error);
#line 1231 "../src/Views/ImportPage.vala"
	self->priv->refresh_error = NULL;
#line 1232 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->camera;
#line 1232 "../src/Views/ImportPage.vala"
	_tmp1_ = import_page_spin_idle_context;
#line 1232 "../src/Views/ImportPage.vala"
	_tmp2_ = ((GPContextWrapper*) _tmp1_)->context;
#line 1232 "../src/Views/ImportPage.vala"
	self->priv->refresh_result = gp_camera_init (_tmp0_, _tmp2_);
#line 1233 "../src/Views/ImportPage.vala"
	if (self->priv->refresh_result != GP_OK) {
#line 6854 "ImportPage.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		ImportPageRefreshResult _tmp5_ = 0;
#line 1234 "../src/Views/ImportPage.vala"
		_tmp3_ = gp_result_to_full_string (self->priv->refresh_result);
#line 1234 "../src/Views/ImportPage.vala"
		_tmp4_ = _tmp3_;
#line 1234 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:1234: Unable to initialize camera: %s", _tmp4_);
#line 1234 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp4_);
#line 1236 "../src/Views/ImportPage.vala"
		if (self->priv->refresh_result == GP_ERROR_IO_LOCK) {
#line 1236 "../src/Views/ImportPage.vala"
			_tmp5_ = IMPORT_PAGE_REFRESH_RESULT_LOCKED;
#line 6870 "ImportPage.c"
		} else {
#line 1236 "../src/Views/ImportPage.vala"
			_tmp5_ = IMPORT_PAGE_REFRESH_RESULT_LIBRARY_ERROR;
#line 6874 "ImportPage.c"
		}
#line 1236 "../src/Views/ImportPage.vala"
		result = _tmp5_;
#line 1236 "../src/Views/ImportPage.vala"
		return result;
#line 6880 "ImportPage.c"
	}
#line 1239 "../src/Views/ImportPage.vala"
	import_page_update_status (self, TRUE, self->priv->refreshed);
#line 1241 "../src/Views/ImportPage.vala"
	import_page_on_view_changed (self);
#line 1243 "../src/Views/ImportPage.vala"
	_tmp6_ = self->priv->progress_bar;
#line 1243 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_NONE);
#line 1244 "../src/Views/ImportPage.vala"
	_tmp7_ = self->priv->progress_bar;
#line 1244 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_text (_tmp7_, _ ("Fetching photo information"));
#line 1245 "../src/Views/ImportPage.vala"
	_tmp8_ = self->priv->progress_bar;
#line 1245 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_fraction (_tmp8_, 0.0);
#line 1246 "../src/Views/ImportPage.vala"
	_tmp9_ = self->priv->progress_bar;
#line 1246 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_pulse_step (_tmp9_, 0.01);
#line 1247 "../src/Views/ImportPage.vala"
	_tmp10_ = self->priv->progress_bar;
#line 1247 "../src/Views/ImportPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, TRUE);
#line 1249 "../src/Views/ImportPage.vala"
	_tmp11_ = gee_array_list_new (TYPE_IMPORT_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1249 "../src/Views/ImportPage.vala"
	import_list = _tmp11_;
#line 1251 "../src/Views/ImportPage.vala"
	sifs = NULL;
#line 1251 "../src/Views/ImportPage.vala"
	sifs_length1 = 0;
#line 1251 "../src/Views/ImportPage.vala"
	_sifs_size_ = sifs_length1;
#line 1252 "../src/Views/ImportPage.vala"
	_tmp12_ = self->priv->camera;
#line 1252 "../src/Views/ImportPage.vala"
	_tmp13_ = import_page_spin_idle_context;
#line 1252 "../src/Views/ImportPage.vala"
	_tmp14_ = ((GPContextWrapper*) _tmp13_)->context;
#line 1252 "../src/Views/ImportPage.vala"
	_tmp17_ = gp_camera_get_storageinfo (_tmp12_, &_tmp15_, &_tmp16_, _tmp14_);
#line 1252 "../src/Views/ImportPage.vala"
	sifs = (g_free (sifs), NULL);
#line 1252 "../src/Views/ImportPage.vala"
	sifs = _tmp15_;
#line 1252 "../src/Views/ImportPage.vala"
	sifs_length1 = _tmp16_;
#line 1252 "../src/Views/ImportPage.vala"
	_sifs_size_ = sifs_length1;
#line 1252 "../src/Views/ImportPage.vala"
	self->priv->refresh_result = _tmp17_;
#line 1253 "../src/Views/ImportPage.vala"
	if (self->priv->refresh_result == GP_OK) {
#line 6936 "ImportPage.c"
		{
			gint fsid = 0;
#line 1254 "../src/Views/ImportPage.vala"
			fsid = 0;
#line 6941 "ImportPage.c"
			{
				gboolean _tmp18_ = FALSE;
#line 1254 "../src/Views/ImportPage.vala"
				_tmp18_ = TRUE;
#line 1254 "../src/Views/ImportPage.vala"
				while (TRUE) {
#line 6948 "ImportPage.c"
					CameraStorageInformation* _tmp20_;
					gint _tmp20__length1;
					gboolean got_well_known_dir = FALSE;
#line 1254 "../src/Views/ImportPage.vala"
					if (!_tmp18_) {
#line 6954 "ImportPage.c"
						gint _tmp19_;
#line 1254 "../src/Views/ImportPage.vala"
						_tmp19_ = fsid;
#line 1254 "../src/Views/ImportPage.vala"
						fsid = _tmp19_ + 1;
#line 6960 "ImportPage.c"
					}
#line 1254 "../src/Views/ImportPage.vala"
					_tmp18_ = FALSE;
#line 1254 "../src/Views/ImportPage.vala"
					_tmp20_ = sifs;
#line 1254 "../src/Views/ImportPage.vala"
					_tmp20__length1 = sifs_length1;
#line 1254 "../src/Views/ImportPage.vala"
					if (!(fsid < _tmp20__length1)) {
#line 1254 "../src/Views/ImportPage.vala"
						break;
#line 6972 "ImportPage.c"
					}
#line 1258 "../src/Views/ImportPage.vala"
					got_well_known_dir = FALSE;
#line 1261 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/", "DCIM")) {
#line 6978 "ImportPage.c"
						GeeArrayList* _tmp21_;
#line 1262 "../src/Views/ImportPage.vala"
						_tmp21_ = import_list;
#line 1262 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/DCIM", _tmp21_);
#line 1263 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 6986 "ImportPage.c"
					}
#line 1265 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/", "dcim")) {
#line 6990 "ImportPage.c"
						GeeArrayList* _tmp22_;
#line 1266 "../src/Views/ImportPage.vala"
						_tmp22_ = import_list;
#line 1266 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/dcim", _tmp22_);
#line 1267 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 6998 "ImportPage.c"
					}
#line 1272 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/PRIVATE/", "AVCHD")) {
#line 7002 "ImportPage.c"
						GeeArrayList* _tmp23_;
#line 1273 "../src/Views/ImportPage.vala"
						_tmp23_ = import_list;
#line 1273 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/PRIVATE/AVCHD", _tmp23_);
#line 1274 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 7010 "ImportPage.c"
					}
#line 1276 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/private/", "avchd")) {
#line 7014 "ImportPage.c"
						GeeArrayList* _tmp24_;
#line 1277 "../src/Views/ImportPage.vala"
						_tmp24_ = import_list;
#line 1277 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/private/avchd", _tmp24_);
#line 1278 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 7022 "ImportPage.c"
					}
#line 1280 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/", "AVCHD")) {
#line 7026 "ImportPage.c"
						GeeArrayList* _tmp25_;
#line 1281 "../src/Views/ImportPage.vala"
						_tmp25_ = import_list;
#line 1281 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/AVCHD", _tmp25_);
#line 1282 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 7034 "ImportPage.c"
					}
#line 1284 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/", "avchd")) {
#line 7038 "ImportPage.c"
						GeeArrayList* _tmp26_;
#line 1285 "../src/Views/ImportPage.vala"
						_tmp26_ = import_list;
#line 1285 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/avchd", _tmp26_);
#line 1286 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 7046 "ImportPage.c"
					}
#line 1291 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/PRIVATE/", "SONY")) {
#line 7050 "ImportPage.c"
						GeeArrayList* _tmp27_;
#line 1292 "../src/Views/ImportPage.vala"
						_tmp27_ = import_list;
#line 1292 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/PRIVATE/SONY", _tmp27_);
#line 1293 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 7058 "ImportPage.c"
					}
#line 1295 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/private/", "sony")) {
#line 7062 "ImportPage.c"
						GeeArrayList* _tmp28_;
#line 1296 "../src/Views/ImportPage.vala"
						_tmp28_ = import_list;
#line 1296 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/private/sony", _tmp28_);
#line 1297 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 7070 "ImportPage.c"
					}
#line 1301 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/", "MP_ROOT")) {
#line 7074 "ImportPage.c"
						GeeArrayList* _tmp29_;
#line 1302 "../src/Views/ImportPage.vala"
						_tmp29_ = import_list;
#line 1302 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/MP_ROOT", _tmp29_);
#line 1303 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 7082 "ImportPage.c"
					}
#line 1305 "../src/Views/ImportPage.vala"
					if (import_page_check_directory_exists (self, fsid, "/", "mp_root")) {
#line 7086 "ImportPage.c"
						GeeArrayList* _tmp30_;
#line 1306 "../src/Views/ImportPage.vala"
						_tmp30_ = import_list;
#line 1306 "../src/Views/ImportPage.vala"
						import_page_enumerate_files (self, fsid, "/mp_root", _tmp30_);
#line 1307 "../src/Views/ImportPage.vala"
						got_well_known_dir = TRUE;
#line 7094 "ImportPage.c"
					}
#line 1312 "../src/Views/ImportPage.vala"
					if (!got_well_known_dir) {
#line 7098 "ImportPage.c"
						GeeArrayList* _tmp31_;
#line 1313 "../src/Views/ImportPage.vala"
						_tmp31_ = import_list;
#line 1313 "../src/Views/ImportPage.vala"
						if (!import_page_enumerate_files (self, fsid, "/", _tmp31_)) {
#line 1314 "../src/Views/ImportPage.vala"
							break;
#line 7106 "ImportPage.c"
						}
					}
				}
			}
		}
	}
#line 1319 "../src/Views/ImportPage.vala"
	import_page_clear_all_import_sources (self);
#line 1322 "../src/Views/ImportPage.vala"
	_tmp32_ = import_list;
#line 1322 "../src/Views/ImportPage.vala"
	import_page_auto_match_raw_jpeg (self, _tmp32_);
#line 1325 "../src/Views/ImportPage.vala"
	granite_services_application_set_progress_visible (TRUE, NULL, NULL);
#line 1327 "../src/Views/ImportPage.vala"
	_tmp33_ = import_list;
#line 1327 "../src/Views/ImportPage.vala"
	import_page_load_previews_and_metadata (self, (GeeList*) _tmp33_);
#line 1330 "../src/Views/ImportPage.vala"
	granite_services_application_set_progress_visible (FALSE, NULL, NULL);
#line 1331 "../src/Views/ImportPage.vala"
	granite_services_application_set_progress (0.0, NULL, NULL);
#line 1333 "../src/Views/ImportPage.vala"
	_tmp34_ = self->priv->progress_bar;
#line 1333 "../src/Views/ImportPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp34_, FALSE);
#line 1334 "../src/Views/ImportPage.vala"
	_tmp35_ = self->priv->progress_bar;
#line 1334 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_ellipsize (_tmp35_, PANGO_ELLIPSIZE_NONE);
#line 1335 "../src/Views/ImportPage.vala"
	_tmp36_ = self->priv->progress_bar;
#line 1335 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_text (_tmp36_, "");
#line 1336 "../src/Views/ImportPage.vala"
	_tmp37_ = self->priv->progress_bar;
#line 1336 "../src/Views/ImportPage.vala"
	gtk_progress_bar_set_fraction (_tmp37_, 0.0);
#line 1338 "../src/Views/ImportPage.vala"
	_tmp38_ = self->priv->camera;
#line 1338 "../src/Views/ImportPage.vala"
	_tmp39_ = import_page_spin_idle_context;
#line 1338 "../src/Views/ImportPage.vala"
	_tmp40_ = ((GPContextWrapper*) _tmp39_)->context;
#line 1338 "../src/Views/ImportPage.vala"
	res = gp_camera_exit (_tmp38_, _tmp40_);
#line 1339 "../src/Views/ImportPage.vala"
	if (res != GP_OK) {
#line 7155 "ImportPage.c"
		gchar* _tmp41_;
		gchar* _tmp42_;
#line 1341 "../src/Views/ImportPage.vala"
		_tmp41_ = gp_result_to_full_string (res);
#line 1341 "../src/Views/ImportPage.vala"
		_tmp42_ = _tmp41_;
#line 1341 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:1341: Unable to unlock camera: %s", _tmp42_);
#line 1341 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp42_);
#line 7166 "ImportPage.c"
	}
#line 1344 "../src/Views/ImportPage.vala"
	if (self->priv->refresh_result == GP_OK) {
#line 1345 "../src/Views/ImportPage.vala"
		import_page_update_status (self, FALSE, TRUE);
#line 7172 "ImportPage.c"
	} else {
#line 1347 "../src/Views/ImportPage.vala"
		import_page_update_status (self, FALSE, FALSE);
#line 1350 "../src/Views/ImportPage.vala"
		import_page_clear_all_import_sources (self);
#line 7178 "ImportPage.c"
	}
#line 1353 "../src/Views/ImportPage.vala"
	import_page_on_view_changed (self);
#line 1355 "../src/Views/ImportPage.vala"
	switch (self->priv->refresh_result) {
#line 1355 "../src/Views/ImportPage.vala"
		case GP_OK:
#line 7186 "ImportPage.c"
		{
#line 1357 "../src/Views/ImportPage.vala"
			result = IMPORT_PAGE_REFRESH_RESULT_OK;
#line 1357 "../src/Views/ImportPage.vala"
			sifs = (g_free (sifs), NULL);
#line 1357 "../src/Views/ImportPage.vala"
			_g_object_unref0 (import_list);
#line 1357 "../src/Views/ImportPage.vala"
			return result;
#line 7196 "ImportPage.c"
		}
#line 1355 "../src/Views/ImportPage.vala"
		case GP_ERROR_IO_LOCK:
#line 7200 "ImportPage.c"
		{
#line 1360 "../src/Views/ImportPage.vala"
			result = IMPORT_PAGE_REFRESH_RESULT_LOCKED;
#line 1360 "../src/Views/ImportPage.vala"
			sifs = (g_free (sifs), NULL);
#line 1360 "../src/Views/ImportPage.vala"
			_g_object_unref0 (import_list);
#line 1360 "../src/Views/ImportPage.vala"
			return result;
#line 7210 "ImportPage.c"
		}
		default:
		{
#line 1363 "../src/Views/ImportPage.vala"
			result = IMPORT_PAGE_REFRESH_RESULT_LIBRARY_ERROR;
#line 1363 "../src/Views/ImportPage.vala"
			sifs = (g_free (sifs), NULL);
#line 1363 "../src/Views/ImportPage.vala"
			_g_object_unref0 (import_list);
#line 1363 "../src/Views/ImportPage.vala"
			return result;
#line 7222 "ImportPage.c"
		}
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 7241 "ImportPage.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 7268 "ImportPage.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 7274 "ImportPage.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 7280 "ImportPage.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 7284 "ImportPage.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 7292 "ImportPage.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 7296 "ImportPage.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 7308 "ImportPage.c"
}

static gchar*
import_page_chomp_ch (const gchar* str,
                      gchar ch)
{
	glong offset = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp4_;
	gchar* result;
#line 1367 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1368 "../src/Views/ImportPage.vala"
	_tmp0_ = strlen (str);
#line 1368 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 1368 "../src/Views/ImportPage.vala"
	offset = (glong) _tmp1_;
#line 1369 "../src/Views/ImportPage.vala"
	while (TRUE) {
#line 7330 "ImportPage.c"
		glong _tmp2_;
#line 1369 "../src/Views/ImportPage.vala"
		offset = offset - 1;
#line 1369 "../src/Views/ImportPage.vala"
		_tmp2_ = offset;
#line 1369 "../src/Views/ImportPage.vala"
		if (!(_tmp2_ >= ((glong) 0))) {
#line 1369 "../src/Views/ImportPage.vala"
			break;
#line 7340 "ImportPage.c"
		}
#line 1370 "../src/Views/ImportPage.vala"
		if (string_get (str, offset) != ch) {
#line 7344 "ImportPage.c"
			gchar* _tmp3_;
#line 1371 "../src/Views/ImportPage.vala"
			_tmp3_ = string_slice (str, (glong) 0, offset);
#line 1371 "../src/Views/ImportPage.vala"
			result = _tmp3_;
#line 1371 "../src/Views/ImportPage.vala"
			return result;
#line 7352 "ImportPage.c"
		}
	}
#line 1374 "../src/Views/ImportPage.vala"
	_tmp4_ = g_strdup ("");
#line 1374 "../src/Views/ImportPage.vala"
	result = _tmp4_;
#line 1374 "../src/Views/ImportPage.vala"
	return result;
#line 7361 "ImportPage.c"
}

gchar*
import_page_append_path (const gchar* basepath,
                         const gchar* addition)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1377 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (basepath != NULL, NULL);
#line 1377 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (addition != NULL, NULL);
#line 1378 "../src/Views/ImportPage.vala"
	if (!g_str_has_suffix (basepath, "/")) {
#line 1378 "../src/Views/ImportPage.vala"
		_tmp0_ = !g_str_has_prefix (addition, "/");
#line 7378 "ImportPage.c"
	} else {
#line 1378 "../src/Views/ImportPage.vala"
		_tmp0_ = FALSE;
#line 7382 "ImportPage.c"
	}
#line 1378 "../src/Views/ImportPage.vala"
	if (_tmp0_) {
#line 7386 "ImportPage.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 1379 "../src/Views/ImportPage.vala"
		_tmp1_ = g_strconcat (basepath, "/", NULL);
#line 1379 "../src/Views/ImportPage.vala"
		_tmp2_ = _tmp1_;
#line 1379 "../src/Views/ImportPage.vala"
		_tmp3_ = g_strconcat (_tmp2_, addition, NULL);
#line 1379 "../src/Views/ImportPage.vala"
		_tmp4_ = _tmp3_;
#line 1379 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp2_);
#line 1379 "../src/Views/ImportPage.vala"
		result = _tmp4_;
#line 1379 "../src/Views/ImportPage.vala"
		return result;
#line 7405 "ImportPage.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 1380 "../src/Views/ImportPage.vala"
		if (g_str_has_suffix (basepath, "/")) {
#line 1380 "../src/Views/ImportPage.vala"
			_tmp5_ = g_str_has_prefix (addition, "/");
#line 7412 "ImportPage.c"
		} else {
#line 1380 "../src/Views/ImportPage.vala"
			_tmp5_ = FALSE;
#line 7416 "ImportPage.c"
		}
#line 1380 "../src/Views/ImportPage.vala"
		if (_tmp5_) {
#line 7420 "ImportPage.c"
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 1381 "../src/Views/ImportPage.vala"
			_tmp6_ = import_page_chomp_ch (basepath, '/');
#line 1381 "../src/Views/ImportPage.vala"
			_tmp7_ = _tmp6_;
#line 1381 "../src/Views/ImportPage.vala"
			_tmp8_ = g_strconcat (_tmp7_, addition, NULL);
#line 1381 "../src/Views/ImportPage.vala"
			_tmp9_ = _tmp8_;
#line 1381 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp7_);
#line 1381 "../src/Views/ImportPage.vala"
			result = _tmp9_;
#line 1381 "../src/Views/ImportPage.vala"
			return result;
#line 7439 "ImportPage.c"
		} else {
			gchar* _tmp10_;
#line 1383 "../src/Views/ImportPage.vala"
			_tmp10_ = g_strconcat (basepath, addition, NULL);
#line 1383 "../src/Views/ImportPage.vala"
			result = _tmp10_;
#line 1383 "../src/Views/ImportPage.vala"
			return result;
#line 7448 "ImportPage.c"
		}
	}
}

gchar*
import_page_get_fs_basedir (Camera* camera,
                            gint fsid)
{
	CameraStorageInformation* sifs = NULL;
	gint sifs_length1;
	gint _sifs_size_;
	int res = 0;
	GPContextWrapper* _tmp0_;
	GPContext* _tmp1_;
	CameraStorageInformation* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	int _tmp4_;
	CameraStorageInformation* _tmp5_;
	gint _tmp5__length1;
	const gchar* _tmp6_ = NULL;
	CameraStorageInformation* _tmp7_;
	gint _tmp7__length1;
	CameraStorageInformation _tmp8_;
	gchar* _tmp11_;
	gchar* result;
#line 1388 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera != NULL, NULL);
#line 1389 "../src/Views/ImportPage.vala"
	sifs = NULL;
#line 1389 "../src/Views/ImportPage.vala"
	sifs_length1 = 0;
#line 1389 "../src/Views/ImportPage.vala"
	_sifs_size_ = sifs_length1;
#line 1390 "../src/Views/ImportPage.vala"
	_tmp0_ = import_page_null_context;
#line 1390 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_->context;
#line 1390 "../src/Views/ImportPage.vala"
	_tmp4_ = gp_camera_get_storageinfo (camera, &_tmp2_, &_tmp3_, _tmp1_);
#line 1390 "../src/Views/ImportPage.vala"
	sifs = (g_free (sifs), NULL);
#line 1390 "../src/Views/ImportPage.vala"
	sifs = _tmp2_;
#line 1390 "../src/Views/ImportPage.vala"
	sifs_length1 = _tmp3_;
#line 1390 "../src/Views/ImportPage.vala"
	_sifs_size_ = sifs_length1;
#line 1390 "../src/Views/ImportPage.vala"
	res = _tmp4_;
#line 1391 "../src/Views/ImportPage.vala"
	if (res != GP_OK) {
#line 1392 "../src/Views/ImportPage.vala"
		result = NULL;
#line 1392 "../src/Views/ImportPage.vala"
		sifs = (g_free (sifs), NULL);
#line 1392 "../src/Views/ImportPage.vala"
		return result;
#line 7506 "ImportPage.c"
	}
#line 1394 "../src/Views/ImportPage.vala"
	_tmp5_ = sifs;
#line 1394 "../src/Views/ImportPage.vala"
	_tmp5__length1 = sifs_length1;
#line 1394 "../src/Views/ImportPage.vala"
	if (fsid >= _tmp5__length1) {
#line 1395 "../src/Views/ImportPage.vala"
		result = NULL;
#line 1395 "../src/Views/ImportPage.vala"
		sifs = (g_free (sifs), NULL);
#line 1395 "../src/Views/ImportPage.vala"
		return result;
#line 7520 "ImportPage.c"
	}
#line 1397 "../src/Views/ImportPage.vala"
	_tmp7_ = sifs;
#line 1397 "../src/Views/ImportPage.vala"
	_tmp7__length1 = sifs_length1;
#line 1397 "../src/Views/ImportPage.vala"
	_tmp8_ = _tmp7_[fsid];
#line 1397 "../src/Views/ImportPage.vala"
	if ((_tmp8_.fields & GP_STORAGEINFO_BASE) != 0) {
#line 7530 "ImportPage.c"
		CameraStorageInformation* _tmp9_;
		gint _tmp9__length1;
		CameraStorageInformation _tmp10_;
#line 1397 "../src/Views/ImportPage.vala"
		_tmp9_ = sifs;
#line 1397 "../src/Views/ImportPage.vala"
		_tmp9__length1 = sifs_length1;
#line 1397 "../src/Views/ImportPage.vala"
		_tmp10_ = _tmp9_[fsid];
#line 1397 "../src/Views/ImportPage.vala"
		_tmp6_ = (const gchar*) _tmp10_.basedir;
#line 7542 "ImportPage.c"
	} else {
#line 1397 "../src/Views/ImportPage.vala"
		_tmp6_ = "/";
#line 7546 "ImportPage.c"
	}
#line 1397 "../src/Views/ImportPage.vala"
	_tmp11_ = g_strdup (_tmp6_);
#line 1397 "../src/Views/ImportPage.vala"
	result = _tmp11_;
#line 1397 "../src/Views/ImportPage.vala"
	sifs = (g_free (sifs), NULL);
#line 1397 "../src/Views/ImportPage.vala"
	return result;
#line 7556 "ImportPage.c"
}

gchar*
import_page_get_fulldir (Camera* camera,
                         const gchar* camera_name,
                         gint fsid,
                         const gchar* folder)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* basedir = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 1400 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera != NULL, NULL);
#line 1400 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (camera_name != NULL, NULL);
#line 1400 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (folder != NULL, NULL);
#line 1401 "../src/Views/ImportPage.vala"
	_tmp0_ = strlen (folder);
#line 1401 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 1401 "../src/Views/ImportPage.vala"
	if (_tmp1_ > GP_MAX_BASEDIR_LENGTH) {
#line 1402 "../src/Views/ImportPage.vala"
		result = NULL;
#line 1402 "../src/Views/ImportPage.vala"
		return result;
#line 7589 "ImportPage.c"
	}
#line 1404 "../src/Views/ImportPage.vala"
	_tmp2_ = import_page_get_fs_basedir (camera, fsid);
#line 1404 "../src/Views/ImportPage.vala"
	basedir = _tmp2_;
#line 1405 "../src/Views/ImportPage.vala"
	_tmp3_ = basedir;
#line 1405 "../src/Views/ImportPage.vala"
	if (_tmp3_ == NULL) {
#line 7599 "ImportPage.c"
		gchar* _tmp4_;
#line 1406 "../src/Views/ImportPage.vala"
		g_debug ("ImportPage.vala:1406: Unable to find base directory for %s fsid %d", camera_name, fsid);
#line 1408 "../src/Views/ImportPage.vala"
		_tmp4_ = g_strdup (folder);
#line 1408 "../src/Views/ImportPage.vala"
		result = _tmp4_;
#line 1408 "../src/Views/ImportPage.vala"
		_g_free0 (basedir);
#line 1408 "../src/Views/ImportPage.vala"
		return result;
#line 7611 "ImportPage.c"
	}
#line 1411 "../src/Views/ImportPage.vala"
	_tmp5_ = basedir;
#line 1411 "../src/Views/ImportPage.vala"
	_tmp6_ = import_page_append_path (_tmp5_, folder);
#line 1411 "../src/Views/ImportPage.vala"
	result = _tmp6_;
#line 1411 "../src/Views/ImportPage.vala"
	_g_free0 (basedir);
#line 1411 "../src/Views/ImportPage.vala"
	return result;
#line 7623 "ImportPage.c"
}

static gboolean
import_page_enumerate_files (ImportPage* self,
                             gint fsid,
                             const gchar* dir,
                             GeeArrayList* import_list)
{
	gchar* fulldir = NULL;
	Camera* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	CameraList* files = NULL;
	CameraList* _tmp4_ = NULL;
	int _tmp5_;
	Camera* _tmp8_;
	const gchar* _tmp9_;
	CameraList* _tmp10_;
	GPSpinIdleWrapper* _tmp11_;
	GPContext* _tmp12_;
	CameraList* folders = NULL;
	CameraList* _tmp60_ = NULL;
	int _tmp61_;
	Camera* _tmp64_;
	const gchar* _tmp65_;
	CameraList* _tmp66_;
	GPSpinIdleWrapper* _tmp67_;
	GPContext* _tmp68_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1414 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1414 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 1414 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (import_list != NULL, FALSE);
#line 1415 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->camera;
#line 1415 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->camera_name;
#line 1415 "../src/Views/ImportPage.vala"
	_tmp2_ = import_page_get_fulldir (_tmp0_, _tmp1_, fsid, dir);
#line 1415 "../src/Views/ImportPage.vala"
	fulldir = _tmp2_;
#line 1416 "../src/Views/ImportPage.vala"
	_tmp3_ = fulldir;
#line 1416 "../src/Views/ImportPage.vala"
	if (_tmp3_ == NULL) {
#line 1417 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:1417: Skipping enumerating %s: invalid folder name", dir);
#line 1419 "../src/Views/ImportPage.vala"
		result = TRUE;
#line 1419 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 1419 "../src/Views/ImportPage.vala"
		return result;
#line 7681 "ImportPage.c"
	}
#line 1423 "../src/Views/ImportPage.vala"
	_tmp5_ = gp_list_new (&_tmp4_);
#line 1423 "../src/Views/ImportPage.vala"
	_gp_list_unref0 (files);
#line 1423 "../src/Views/ImportPage.vala"
	files = _tmp4_;
#line 1423 "../src/Views/ImportPage.vala"
	self->priv->refresh_result = _tmp5_;
#line 1424 "../src/Views/ImportPage.vala"
	if (self->priv->refresh_result != GP_OK) {
#line 7693 "ImportPage.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 1425 "../src/Views/ImportPage.vala"
		_tmp6_ = gp_result_to_full_string (self->priv->refresh_result);
#line 1425 "../src/Views/ImportPage.vala"
		_tmp7_ = _tmp6_;
#line 1425 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:1425: Unable to create file list: %s", _tmp7_);
#line 1425 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp7_);
#line 1427 "../src/Views/ImportPage.vala"
		result = FALSE;
#line 1427 "../src/Views/ImportPage.vala"
		_gp_list_unref0 (files);
#line 1427 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 1427 "../src/Views/ImportPage.vala"
		return result;
#line 7712 "ImportPage.c"
	}
#line 1430 "../src/Views/ImportPage.vala"
	_tmp8_ = self->priv->camera;
#line 1430 "../src/Views/ImportPage.vala"
	_tmp9_ = fulldir;
#line 1430 "../src/Views/ImportPage.vala"
	_tmp10_ = files;
#line 1430 "../src/Views/ImportPage.vala"
	_tmp11_ = import_page_spin_idle_context;
#line 1430 "../src/Views/ImportPage.vala"
	_tmp12_ = ((GPContextWrapper*) _tmp11_)->context;
#line 1430 "../src/Views/ImportPage.vala"
	self->priv->refresh_result = gp_camera_folder_list_files (_tmp8_, _tmp9_, _tmp10_, _tmp12_);
#line 1431 "../src/Views/ImportPage.vala"
	if (self->priv->refresh_result != GP_OK) {
#line 7728 "ImportPage.c"
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1432 "../src/Views/ImportPage.vala"
		_tmp13_ = fulldir;
#line 1432 "../src/Views/ImportPage.vala"
		_tmp14_ = gp_result_to_full_string (self->priv->refresh_result);
#line 1432 "../src/Views/ImportPage.vala"
		_tmp15_ = _tmp14_;
#line 1432 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:1432: Unable to list files in %s: %s", _tmp13_, _tmp15_);
#line 1432 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp15_);
#line 1435 "../src/Views/ImportPage.vala"
		self->priv->refresh_result = GP_OK;
#line 1437 "../src/Views/ImportPage.vala"
		result = TRUE;
#line 1437 "../src/Views/ImportPage.vala"
		_gp_list_unref0 (files);
#line 1437 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 1437 "../src/Views/ImportPage.vala"
		return result;
#line 7752 "ImportPage.c"
	}
	{
		gint ctr = 0;
#line 1440 "../src/Views/ImportPage.vala"
		ctr = 0;
#line 7758 "ImportPage.c"
		{
			gboolean _tmp16_ = FALSE;
#line 1440 "../src/Views/ImportPage.vala"
			_tmp16_ = TRUE;
#line 1440 "../src/Views/ImportPage.vala"
			while (TRUE) {
#line 7765 "ImportPage.c"
				CameraList* _tmp18_;
				gchar* filename = NULL;
				CameraList* _tmp19_;
				const gchar* _tmp20_ = NULL;
				int _tmp21_;
				gchar* _tmp22_;
#line 1440 "../src/Views/ImportPage.vala"
				if (!_tmp16_) {
#line 7774 "ImportPage.c"
					gint _tmp17_;
#line 1440 "../src/Views/ImportPage.vala"
					_tmp17_ = ctr;
#line 1440 "../src/Views/ImportPage.vala"
					ctr = _tmp17_ + 1;
#line 7780 "ImportPage.c"
				}
#line 1440 "../src/Views/ImportPage.vala"
				_tmp16_ = FALSE;
#line 1440 "../src/Views/ImportPage.vala"
				_tmp18_ = files;
#line 1440 "../src/Views/ImportPage.vala"
				if (!(ctr < gp_list_count (_tmp18_))) {
#line 1440 "../src/Views/ImportPage.vala"
					break;
#line 7790 "ImportPage.c"
				}
#line 1442 "../src/Views/ImportPage.vala"
				_tmp19_ = files;
#line 1442 "../src/Views/ImportPage.vala"
				_tmp21_ = gp_list_get_name (_tmp19_, ctr, &_tmp20_);
#line 1442 "../src/Views/ImportPage.vala"
				_g_free0 (filename);
#line 1442 "../src/Views/ImportPage.vala"
				_tmp22_ = g_strdup (_tmp20_);
#line 1442 "../src/Views/ImportPage.vala"
				filename = _tmp22_;
#line 1442 "../src/Views/ImportPage.vala"
				self->priv->refresh_result = _tmp21_;
#line 1443 "../src/Views/ImportPage.vala"
				if (self->priv->refresh_result != GP_OK) {
#line 7806 "ImportPage.c"
					const gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
#line 1444 "../src/Views/ImportPage.vala"
					_tmp23_ = fulldir;
#line 1444 "../src/Views/ImportPage.vala"
					_tmp24_ = gp_result_to_full_string (self->priv->refresh_result);
#line 1444 "../src/Views/ImportPage.vala"
					_tmp25_ = _tmp24_;
#line 1444 "../src/Views/ImportPage.vala"
					g_warning ("ImportPage.vala:1444: Unable to get the name of file %d in %s: %s", ctr, _tmp23_, _tmp25_);
#line 1444 "../src/Views/ImportPage.vala"
					_g_free0 (_tmp25_);
#line 1447 "../src/Views/ImportPage.vala"
					result = FALSE;
#line 1447 "../src/Views/ImportPage.vala"
					_g_free0 (filename);
#line 1447 "../src/Views/ImportPage.vala"
					_gp_list_unref0 (files);
#line 1447 "../src/Views/ImportPage.vala"
					_g_free0 (fulldir);
#line 1447 "../src/Views/ImportPage.vala"
					return result;
#line 7830 "ImportPage.c"
				}
				{
					CameraFileInfo info = {0};
					gboolean _tmp26_ = FALSE;
					GPSpinIdleWrapper* _tmp27_;
					GPContext* _tmp28_;
					Camera* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					CameraFileInfo _tmp32_ = {0};
					gboolean _tmp33_;
					const gchar* _tmp38_;
					GtkProgressBar* _tmp52_;
#line 1452 "../src/Views/ImportPage.vala"
					_tmp27_ = import_page_spin_idle_context;
#line 1452 "../src/Views/ImportPage.vala"
					_tmp28_ = ((GPContextWrapper*) _tmp27_)->context;
#line 1452 "../src/Views/ImportPage.vala"
					_tmp29_ = self->priv->camera;
#line 1452 "../src/Views/ImportPage.vala"
					_tmp30_ = fulldir;
#line 1452 "../src/Views/ImportPage.vala"
					_tmp31_ = filename;
#line 1452 "../src/Views/ImportPage.vala"
					_tmp33_ = gp_get_info (_tmp28_, _tmp29_, _tmp30_, _tmp31_, &_tmp32_, &_inner_error0_);
#line 1452 "../src/Views/ImportPage.vala"
					 (info);
#line 1452 "../src/Views/ImportPage.vala"
					info = _tmp32_;
#line 1452 "../src/Views/ImportPage.vala"
					_tmp26_ = _tmp33_;
#line 1452 "../src/Views/ImportPage.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1452 "../src/Views/ImportPage.vala"
						 (info);
#line 7866 "ImportPage.c"
						goto __catch0_g_error;
					}
#line 1452 "../src/Views/ImportPage.vala"
					if (!_tmp26_) {
#line 7871 "ImportPage.c"
						const gchar* _tmp34_;
						const gchar* _tmp35_;
#line 1453 "../src/Views/ImportPage.vala"
						_tmp34_ = fulldir;
#line 1453 "../src/Views/ImportPage.vala"
						_tmp35_ = filename;
#line 1453 "../src/Views/ImportPage.vala"
						g_warning ("ImportPage.vala:1453: Skipping import of %s/%s: name too long", _tmp34_, _tmp35_);
#line 1455 "../src/Views/ImportPage.vala"
						 (info);
#line 1455 "../src/Views/ImportPage.vala"
						_g_free0 (filename);
#line 1455 "../src/Views/ImportPage.vala"
						continue;
#line 7886 "ImportPage.c"
					}
#line 1458 "../src/Views/ImportPage.vala"
					if ((info.file.fields & GP_FILE_INFO_TYPE) == 0) {
#line 7890 "ImportPage.c"
						const gchar* _tmp36_;
						const gchar* _tmp37_;
#line 1459 "../src/Views/ImportPage.vala"
						_tmp36_ = fulldir;
#line 1459 "../src/Views/ImportPage.vala"
						_tmp37_ = filename;
#line 1459 "../src/Views/ImportPage.vala"
						g_message ("ImportPage.vala:1459: Skipping %s/%s: No file (file=%02Xh)", _tmp36_, _tmp37_, (guint) info.file.fields);
#line 1462 "../src/Views/ImportPage.vala"
						 (info);
#line 1462 "../src/Views/ImportPage.vala"
						_g_free0 (filename);
#line 1462 "../src/Views/ImportPage.vala"
						continue;
#line 7905 "ImportPage.c"
					}
#line 1465 "../src/Views/ImportPage.vala"
					_tmp38_ = filename;
#line 1465 "../src/Views/ImportPage.vala"
					if (video_reader_is_supported_video_filename (_tmp38_)) {
#line 7911 "ImportPage.c"
						VideoImportSource* video_source = NULL;
						const gchar* _tmp39_;
						Camera* _tmp40_;
						const gchar* _tmp41_;
						VideoImportSource* _tmp42_;
						VideoImportSource* _tmp43_;
#line 1466 "../src/Views/ImportPage.vala"
						_tmp39_ = self->priv->camera_name;
#line 1466 "../src/Views/ImportPage.vala"
						_tmp40_ = self->priv->camera;
#line 1466 "../src/Views/ImportPage.vala"
						_tmp41_ = filename;
#line 1466 "../src/Views/ImportPage.vala"
						_tmp42_ = video_import_source_new (_tmp39_, _tmp40_, fsid, dir, _tmp41_, info.file.size, (gint64) info.file.mtime);
#line 1466 "../src/Views/ImportPage.vala"
						video_source = _tmp42_;
#line 1468 "../src/Views/ImportPage.vala"
						_tmp43_ = video_source;
#line 1468 "../src/Views/ImportPage.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) import_list, (ImportSource*) _tmp43_);
#line 1465 "../src/Views/ImportPage.vala"
						_g_object_unref0 (video_source);
#line 7934 "ImportPage.c"
					} else {
						PhotoFileFormat file_format = 0;
						const gchar* _tmp47_;
						Camera* _tmp48_;
						const gchar* _tmp49_;
						PhotoImportSource* _tmp50_;
						PhotoImportSource* _tmp51_;
#line 1471 "../src/Views/ImportPage.vala"
						file_format = photo_file_format_from_gphoto_type ((const gchar*) info.file.type);
#line 1472 "../src/Views/ImportPage.vala"
						if (file_format == PHOTO_FILE_FORMAT_UNKNOWN) {
#line 7946 "ImportPage.c"
							const gchar* _tmp44_;
#line 1473 "../src/Views/ImportPage.vala"
							_tmp44_ = filename;
#line 1473 "../src/Views/ImportPage.vala"
							file_format = photo_file_format_get_by_basename_extension (_tmp44_);
#line 1474 "../src/Views/ImportPage.vala"
							if (file_format == PHOTO_FILE_FORMAT_UNKNOWN) {
#line 7954 "ImportPage.c"
								const gchar* _tmp45_;
								const gchar* _tmp46_;
#line 1475 "../src/Views/ImportPage.vala"
								_tmp45_ = fulldir;
#line 1475 "../src/Views/ImportPage.vala"
								_tmp46_ = filename;
#line 1475 "../src/Views/ImportPage.vala"
								g_message ("ImportPage.vala:1475: Skipping %s/%s: Not a supported file extension (" \
"%s)", _tmp45_, _tmp46_, (const gchar*) info.file.type);
#line 1478 "../src/Views/ImportPage.vala"
								 (info);
#line 1478 "../src/Views/ImportPage.vala"
								_g_free0 (filename);
#line 1478 "../src/Views/ImportPage.vala"
								continue;
#line 7969 "ImportPage.c"
							}
						}
#line 1481 "../src/Views/ImportPage.vala"
						_tmp47_ = self->priv->camera_name;
#line 1481 "../src/Views/ImportPage.vala"
						_tmp48_ = self->priv->camera;
#line 1481 "../src/Views/ImportPage.vala"
						_tmp49_ = filename;
#line 1481 "../src/Views/ImportPage.vala"
						_tmp50_ = photo_import_source_new (_tmp47_, _tmp48_, fsid, dir, _tmp49_, info.file.size, (gint64) info.file.mtime, file_format);
#line 1481 "../src/Views/ImportPage.vala"
						_tmp51_ = _tmp50_;
#line 1481 "../src/Views/ImportPage.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) import_list, (ImportSource*) _tmp51_);
#line 1481 "../src/Views/ImportPage.vala"
						_g_object_unref0 (_tmp51_);
#line 7986 "ImportPage.c"
					}
#line 1485 "../src/Views/ImportPage.vala"
					_tmp52_ = self->priv->progress_bar;
#line 1485 "../src/Views/ImportPage.vala"
					gtk_progress_bar_pulse (_tmp52_);
#line 1488 "../src/Views/ImportPage.vala"
					spin_event_loop ();
#line 1450 "../src/Views/ImportPage.vala"
					 (info);
#line 7996 "ImportPage.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* err = NULL;
					const gchar* _tmp53_;
					GError* _tmp54_;
					const gchar* _tmp55_;
					GError* _tmp56_;
					const gchar* _tmp57_;
					gchar* _tmp58_;
#line 1450 "../src/Views/ImportPage.vala"
					err = _inner_error0_;
#line 1450 "../src/Views/ImportPage.vala"
					_inner_error0_ = NULL;
#line 1490 "../src/Views/ImportPage.vala"
					_tmp53_ = fulldir;
#line 1490 "../src/Views/ImportPage.vala"
					_tmp54_ = err;
#line 1490 "../src/Views/ImportPage.vala"
					_tmp55_ = _tmp54_->message;
#line 1490 "../src/Views/ImportPage.vala"
					g_warning ("ImportPage.vala:1490: Error while enumerating files in %s: %s", _tmp53_, _tmp55_);
#line 1492 "../src/Views/ImportPage.vala"
					_tmp56_ = err;
#line 1492 "../src/Views/ImportPage.vala"
					_tmp57_ = _tmp56_->message;
#line 1492 "../src/Views/ImportPage.vala"
					_tmp58_ = g_strdup (_tmp57_);
#line 1492 "../src/Views/ImportPage.vala"
					_g_free0 (self->priv->refresh_error);
#line 1492 "../src/Views/ImportPage.vala"
					self->priv->refresh_error = _tmp58_;
#line 1494 "../src/Views/ImportPage.vala"
					result = FALSE;
#line 1494 "../src/Views/ImportPage.vala"
					_g_error_free0 (err);
#line 1494 "../src/Views/ImportPage.vala"
					_g_free0 (filename);
#line 1494 "../src/Views/ImportPage.vala"
					_gp_list_unref0 (files);
#line 1494 "../src/Views/ImportPage.vala"
					_g_free0 (fulldir);
#line 1494 "../src/Views/ImportPage.vala"
					return result;
#line 8042 "ImportPage.c"
				}
				__finally0:
#line 1450 "../src/Views/ImportPage.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8047 "ImportPage.c"
					gboolean _tmp59_ = FALSE;
#line 1450 "../src/Views/ImportPage.vala"
					_g_free0 (filename);
#line 1450 "../src/Views/ImportPage.vala"
					_gp_list_unref0 (files);
#line 1450 "../src/Views/ImportPage.vala"
					_g_free0 (fulldir);
#line 1450 "../src/Views/ImportPage.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1450 "../src/Views/ImportPage.vala"
					g_clear_error (&_inner_error0_);
#line 1450 "../src/Views/ImportPage.vala"
					return _tmp59_;
#line 8061 "ImportPage.c"
				}
#line 1440 "../src/Views/ImportPage.vala"
				_g_free0 (filename);
#line 8065 "ImportPage.c"
			}
		}
	}
#line 1499 "../src/Views/ImportPage.vala"
	_tmp61_ = gp_list_new (&_tmp60_);
#line 1499 "../src/Views/ImportPage.vala"
	_gp_list_unref0 (folders);
#line 1499 "../src/Views/ImportPage.vala"
	folders = _tmp60_;
#line 1499 "../src/Views/ImportPage.vala"
	self->priv->refresh_result = _tmp61_;
#line 1500 "../src/Views/ImportPage.vala"
	if (self->priv->refresh_result != GP_OK) {
#line 8079 "ImportPage.c"
		gchar* _tmp62_;
		gchar* _tmp63_;
#line 1501 "../src/Views/ImportPage.vala"
		_tmp62_ = gp_result_to_full_string (self->priv->refresh_result);
#line 1501 "../src/Views/ImportPage.vala"
		_tmp63_ = _tmp62_;
#line 1501 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:1501: Unable to create folder list: %s", _tmp63_);
#line 1501 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp63_);
#line 1503 "../src/Views/ImportPage.vala"
		result = FALSE;
#line 1503 "../src/Views/ImportPage.vala"
		_gp_list_unref0 (folders);
#line 1503 "../src/Views/ImportPage.vala"
		_gp_list_unref0 (files);
#line 1503 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 1503 "../src/Views/ImportPage.vala"
		return result;
#line 8100 "ImportPage.c"
	}
#line 1506 "../src/Views/ImportPage.vala"
	_tmp64_ = self->priv->camera;
#line 1506 "../src/Views/ImportPage.vala"
	_tmp65_ = fulldir;
#line 1506 "../src/Views/ImportPage.vala"
	_tmp66_ = folders;
#line 1506 "../src/Views/ImportPage.vala"
	_tmp67_ = import_page_spin_idle_context;
#line 1506 "../src/Views/ImportPage.vala"
	_tmp68_ = ((GPContextWrapper*) _tmp67_)->context;
#line 1506 "../src/Views/ImportPage.vala"
	self->priv->refresh_result = gp_camera_folder_list_folders (_tmp64_, _tmp65_, _tmp66_, _tmp68_);
#line 1507 "../src/Views/ImportPage.vala"
	if (self->priv->refresh_result != GP_OK) {
#line 8116 "ImportPage.c"
		const gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
#line 1508 "../src/Views/ImportPage.vala"
		_tmp69_ = fulldir;
#line 1508 "../src/Views/ImportPage.vala"
		_tmp70_ = gp_result_to_full_string (self->priv->refresh_result);
#line 1508 "../src/Views/ImportPage.vala"
		_tmp71_ = _tmp70_;
#line 1508 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:1508: Unable to list folders in %s: %s", _tmp69_, _tmp71_);
#line 1508 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp71_);
#line 1511 "../src/Views/ImportPage.vala"
		self->priv->refresh_result = GP_OK;
#line 1513 "../src/Views/ImportPage.vala"
		result = TRUE;
#line 1513 "../src/Views/ImportPage.vala"
		_gp_list_unref0 (folders);
#line 1513 "../src/Views/ImportPage.vala"
		_gp_list_unref0 (files);
#line 1513 "../src/Views/ImportPage.vala"
		_g_free0 (fulldir);
#line 1513 "../src/Views/ImportPage.vala"
		return result;
#line 8142 "ImportPage.c"
	}
	{
		gint ctr = 0;
#line 1516 "../src/Views/ImportPage.vala"
		ctr = 0;
#line 8148 "ImportPage.c"
		{
			gboolean _tmp72_ = FALSE;
#line 1516 "../src/Views/ImportPage.vala"
			_tmp72_ = TRUE;
#line 1516 "../src/Views/ImportPage.vala"
			while (TRUE) {
#line 8155 "ImportPage.c"
				CameraList* _tmp74_;
				gchar* subdir = NULL;
				CameraList* _tmp75_;
				const gchar* _tmp76_ = NULL;
				int _tmp77_;
				gchar* _tmp78_;
				const gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				gboolean _tmp84_;
#line 1516 "../src/Views/ImportPage.vala"
				if (!_tmp72_) {
#line 8168 "ImportPage.c"
					gint _tmp73_;
#line 1516 "../src/Views/ImportPage.vala"
					_tmp73_ = ctr;
#line 1516 "../src/Views/ImportPage.vala"
					ctr = _tmp73_ + 1;
#line 8174 "ImportPage.c"
				}
#line 1516 "../src/Views/ImportPage.vala"
				_tmp72_ = FALSE;
#line 1516 "../src/Views/ImportPage.vala"
				_tmp74_ = folders;
#line 1516 "../src/Views/ImportPage.vala"
				if (!(ctr < gp_list_count (_tmp74_))) {
#line 1516 "../src/Views/ImportPage.vala"
					break;
#line 8184 "ImportPage.c"
				}
#line 1518 "../src/Views/ImportPage.vala"
				_tmp75_ = folders;
#line 1518 "../src/Views/ImportPage.vala"
				_tmp77_ = gp_list_get_name (_tmp75_, ctr, &_tmp76_);
#line 1518 "../src/Views/ImportPage.vala"
				_g_free0 (subdir);
#line 1518 "../src/Views/ImportPage.vala"
				_tmp78_ = g_strdup (_tmp76_);
#line 1518 "../src/Views/ImportPage.vala"
				subdir = _tmp78_;
#line 1518 "../src/Views/ImportPage.vala"
				self->priv->refresh_result = _tmp77_;
#line 1519 "../src/Views/ImportPage.vala"
				if (self->priv->refresh_result != GP_OK) {
#line 8200 "ImportPage.c"
					gchar* _tmp79_;
					gchar* _tmp80_;
#line 1520 "../src/Views/ImportPage.vala"
					_tmp79_ = gp_result_to_full_string (self->priv->refresh_result);
#line 1520 "../src/Views/ImportPage.vala"
					_tmp80_ = _tmp79_;
#line 1520 "../src/Views/ImportPage.vala"
					g_warning ("ImportPage.vala:1520: Unable to get name of folder %d: %s", ctr, _tmp80_);
#line 1520 "../src/Views/ImportPage.vala"
					_g_free0 (_tmp80_);
#line 1522 "../src/Views/ImportPage.vala"
					result = FALSE;
#line 1522 "../src/Views/ImportPage.vala"
					_g_free0 (subdir);
#line 1522 "../src/Views/ImportPage.vala"
					_gp_list_unref0 (folders);
#line 1522 "../src/Views/ImportPage.vala"
					_gp_list_unref0 (files);
#line 1522 "../src/Views/ImportPage.vala"
					_g_free0 (fulldir);
#line 1522 "../src/Views/ImportPage.vala"
					return result;
#line 8223 "ImportPage.c"
				}
#line 1525 "../src/Views/ImportPage.vala"
				_tmp81_ = subdir;
#line 1525 "../src/Views/ImportPage.vala"
				_tmp82_ = import_page_append_path (dir, _tmp81_);
#line 1525 "../src/Views/ImportPage.vala"
				_tmp83_ = _tmp82_;
#line 1525 "../src/Views/ImportPage.vala"
				_tmp84_ = !import_page_enumerate_files (self, fsid, _tmp83_, import_list);
#line 1525 "../src/Views/ImportPage.vala"
				_g_free0 (_tmp83_);
#line 1525 "../src/Views/ImportPage.vala"
				if (_tmp84_) {
#line 1526 "../src/Views/ImportPage.vala"
					result = FALSE;
#line 1526 "../src/Views/ImportPage.vala"
					_g_free0 (subdir);
#line 1526 "../src/Views/ImportPage.vala"
					_gp_list_unref0 (folders);
#line 1526 "../src/Views/ImportPage.vala"
					_gp_list_unref0 (files);
#line 1526 "../src/Views/ImportPage.vala"
					_g_free0 (fulldir);
#line 1526 "../src/Views/ImportPage.vala"
					return result;
#line 8249 "ImportPage.c"
				}
#line 1516 "../src/Views/ImportPage.vala"
				_g_free0 (subdir);
#line 8253 "ImportPage.c"
			}
		}
	}
#line 1529 "../src/Views/ImportPage.vala"
	result = TRUE;
#line 1529 "../src/Views/ImportPage.vala"
	_gp_list_unref0 (folders);
#line 1529 "../src/Views/ImportPage.vala"
	_gp_list_unref0 (files);
#line 1529 "../src/Views/ImportPage.vala"
	_g_free0 (fulldir);
#line 1529 "../src/Views/ImportPage.vala"
	return result;
#line 8267 "ImportPage.c"
}

static void
import_page_auto_match_raw_jpeg (ImportPage* self,
                                 GeeArrayList* import_list)
{
#line 1533 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1533 "../src/Views/ImportPage.vala"
	g_return_if_fail (import_list != NULL);
#line 8278 "ImportPage.c"
	{
		gint i = 0;
#line 1534 "../src/Views/ImportPage.vala"
		i = 0;
#line 8283 "ImportPage.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1534 "../src/Views/ImportPage.vala"
			_tmp0_ = TRUE;
#line 1534 "../src/Views/ImportPage.vala"
			while (TRUE) {
#line 8290 "ImportPage.c"
				gint _tmp2_;
				gint _tmp3_;
				PhotoImportSource* current = NULL;
				gpointer _tmp4_;
				ImportSource* _tmp5_;
				PhotoImportSource* _tmp6_;
				PhotoImportSource* _tmp7_ = NULL;
				gint _tmp8_;
				gint _tmp9_;
				PhotoImportSource* next = NULL;
				PhotoImportSource* _tmp13_;
				PhotoImportSource* _tmp14_ = NULL;
				PhotoImportSource* prev = NULL;
				PhotoImportSource* _tmp18_;
				gboolean _tmp19_ = FALSE;
				PhotoImportSource* _tmp20_;
#line 1534 "../src/Views/ImportPage.vala"
				if (!_tmp0_) {
#line 8309 "ImportPage.c"
					gint _tmp1_;
#line 1534 "../src/Views/ImportPage.vala"
					_tmp1_ = i;
#line 1534 "../src/Views/ImportPage.vala"
					i = _tmp1_ + 1;
#line 8315 "ImportPage.c"
				}
#line 1534 "../src/Views/ImportPage.vala"
				_tmp0_ = FALSE;
#line 1534 "../src/Views/ImportPage.vala"
				_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) import_list);
#line 1534 "../src/Views/ImportPage.vala"
				_tmp3_ = _tmp2_;
#line 1534 "../src/Views/ImportPage.vala"
				if (!(i < _tmp3_)) {
#line 1534 "../src/Views/ImportPage.vala"
					break;
#line 8327 "ImportPage.c"
				}
#line 1535 "../src/Views/ImportPage.vala"
				_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) import_list, i);
#line 1535 "../src/Views/ImportPage.vala"
				_tmp5_ = (ImportSource*) _tmp4_;
#line 1535 "../src/Views/ImportPage.vala"
				_tmp6_ = IS_PHOTO_IMPORT_SOURCE (_tmp5_) ? ((PhotoImportSource*) _tmp5_) : NULL;
#line 1535 "../src/Views/ImportPage.vala"
				if (_tmp6_ == NULL) {
#line 1535 "../src/Views/ImportPage.vala"
					_g_object_unref0 (_tmp5_);
#line 8339 "ImportPage.c"
				}
#line 1535 "../src/Views/ImportPage.vala"
				current = _tmp6_;
#line 1536 "../src/Views/ImportPage.vala"
				_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) import_list);
#line 1536 "../src/Views/ImportPage.vala"
				_tmp9_ = _tmp8_;
#line 1536 "../src/Views/ImportPage.vala"
				if ((i + 1) < _tmp9_) {
#line 8349 "ImportPage.c"
					gpointer _tmp10_;
					ImportSource* _tmp11_;
					PhotoImportSource* _tmp12_;
#line 1537 "../src/Views/ImportPage.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) import_list, i + 1);
#line 1537 "../src/Views/ImportPage.vala"
					_tmp11_ = (ImportSource*) _tmp10_;
#line 1537 "../src/Views/ImportPage.vala"
					_tmp12_ = IS_PHOTO_IMPORT_SOURCE (_tmp11_) ? ((PhotoImportSource*) _tmp11_) : NULL;
#line 1537 "../src/Views/ImportPage.vala"
					if (_tmp12_ == NULL) {
#line 1537 "../src/Views/ImportPage.vala"
						_g_object_unref0 (_tmp11_);
#line 8363 "ImportPage.c"
					}
#line 1537 "../src/Views/ImportPage.vala"
					_g_object_unref0 (_tmp7_);
#line 1537 "../src/Views/ImportPage.vala"
					_tmp7_ = _tmp12_;
#line 8369 "ImportPage.c"
				} else {
#line 1537 "../src/Views/ImportPage.vala"
					_g_object_unref0 (_tmp7_);
#line 1537 "../src/Views/ImportPage.vala"
					_tmp7_ = NULL;
#line 8375 "ImportPage.c"
				}
#line 1536 "../src/Views/ImportPage.vala"
				_tmp13_ = _g_object_ref0 (_tmp7_);
#line 1536 "../src/Views/ImportPage.vala"
				next = _tmp13_;
#line 1538 "../src/Views/ImportPage.vala"
				if (i > 0) {
#line 8383 "ImportPage.c"
					gpointer _tmp15_;
					ImportSource* _tmp16_;
					PhotoImportSource* _tmp17_;
#line 1539 "../src/Views/ImportPage.vala"
					_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) import_list, i - 1);
#line 1539 "../src/Views/ImportPage.vala"
					_tmp16_ = (ImportSource*) _tmp15_;
#line 1539 "../src/Views/ImportPage.vala"
					_tmp17_ = IS_PHOTO_IMPORT_SOURCE (_tmp16_) ? ((PhotoImportSource*) _tmp16_) : NULL;
#line 1539 "../src/Views/ImportPage.vala"
					if (_tmp17_ == NULL) {
#line 1539 "../src/Views/ImportPage.vala"
						_g_object_unref0 (_tmp16_);
#line 8397 "ImportPage.c"
					}
#line 1539 "../src/Views/ImportPage.vala"
					_g_object_unref0 (_tmp14_);
#line 1539 "../src/Views/ImportPage.vala"
					_tmp14_ = _tmp17_;
#line 8403 "ImportPage.c"
				} else {
#line 1539 "../src/Views/ImportPage.vala"
					_g_object_unref0 (_tmp14_);
#line 1539 "../src/Views/ImportPage.vala"
					_tmp14_ = NULL;
#line 8409 "ImportPage.c"
				}
#line 1538 "../src/Views/ImportPage.vala"
				_tmp18_ = _g_object_ref0 (_tmp14_);
#line 1538 "../src/Views/ImportPage.vala"
				prev = _tmp18_;
#line 1540 "../src/Views/ImportPage.vala"
				_tmp20_ = current;
#line 1540 "../src/Views/ImportPage.vala"
				if (_tmp20_ != NULL) {
#line 8419 "ImportPage.c"
					PhotoImportSource* _tmp21_;
#line 1540 "../src/Views/ImportPage.vala"
					_tmp21_ = current;
#line 1540 "../src/Views/ImportPage.vala"
					_tmp19_ = photo_import_source_get_file_format (_tmp21_) == PHOTO_FILE_FORMAT_RAW;
#line 8425 "ImportPage.c"
				} else {
#line 1540 "../src/Views/ImportPage.vala"
					_tmp19_ = FALSE;
#line 8429 "ImportPage.c"
				}
#line 1540 "../src/Views/ImportPage.vala"
				if (_tmp19_) {
#line 8433 "ImportPage.c"
					gchar* current_name = NULL;
					gchar* ext = NULL;
					PhotoImportSource* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_ = NULL;
					gchar* _tmp26_ = NULL;
					PhotoImportSource* associated = NULL;
					gboolean _tmp27_ = FALSE;
					PhotoImportSource* _tmp28_;
					gboolean _tmp39_ = FALSE;
					PhotoImportSource* _tmp40_;
					PhotoImportSource* _tmp51_;
#line 1543 "../src/Views/ImportPage.vala"
					_tmp22_ = current;
#line 1543 "../src/Views/ImportPage.vala"
					_tmp23_ = import_source_get_filename ((ImportSource*) _tmp22_);
#line 1543 "../src/Views/ImportPage.vala"
					_tmp24_ = _tmp23_;
#line 1543 "../src/Views/ImportPage.vala"
					disassemble_filename (_tmp24_, &_tmp25_, &_tmp26_);
#line 1543 "../src/Views/ImportPage.vala"
					_g_free0 (current_name);
#line 1543 "../src/Views/ImportPage.vala"
					current_name = _tmp25_;
#line 1543 "../src/Views/ImportPage.vala"
					_g_free0 (ext);
#line 1543 "../src/Views/ImportPage.vala"
					ext = _tmp26_;
#line 1546 "../src/Views/ImportPage.vala"
					associated = NULL;
#line 1547 "../src/Views/ImportPage.vala"
					_tmp28_ = next;
#line 1547 "../src/Views/ImportPage.vala"
					if (_tmp28_ != NULL) {
#line 8469 "ImportPage.c"
						PhotoImportSource* _tmp29_;
#line 1547 "../src/Views/ImportPage.vala"
						_tmp29_ = next;
#line 1547 "../src/Views/ImportPage.vala"
						_tmp27_ = photo_import_source_get_file_format (_tmp29_) == PHOTO_FILE_FORMAT_JFIF;
#line 8475 "ImportPage.c"
					} else {
#line 1547 "../src/Views/ImportPage.vala"
						_tmp27_ = FALSE;
#line 8479 "ImportPage.c"
					}
#line 1547 "../src/Views/ImportPage.vala"
					if (_tmp27_) {
#line 8483 "ImportPage.c"
						gchar* next_name = NULL;
						PhotoImportSource* _tmp30_;
						const gchar* _tmp31_;
						const gchar* _tmp32_;
						gchar* _tmp33_ = NULL;
						gchar* _tmp34_ = NULL;
						const gchar* _tmp35_;
						const gchar* _tmp36_;
#line 1549 "../src/Views/ImportPage.vala"
						_tmp30_ = next;
#line 1549 "../src/Views/ImportPage.vala"
						_tmp31_ = import_source_get_filename ((ImportSource*) _tmp30_);
#line 1549 "../src/Views/ImportPage.vala"
						_tmp32_ = _tmp31_;
#line 1549 "../src/Views/ImportPage.vala"
						disassemble_filename (_tmp32_, &_tmp33_, &_tmp34_);
#line 1549 "../src/Views/ImportPage.vala"
						_g_free0 (next_name);
#line 1549 "../src/Views/ImportPage.vala"
						next_name = _tmp33_;
#line 1549 "../src/Views/ImportPage.vala"
						_g_free0 (ext);
#line 1549 "../src/Views/ImportPage.vala"
						ext = _tmp34_;
#line 1550 "../src/Views/ImportPage.vala"
						_tmp35_ = next_name;
#line 1550 "../src/Views/ImportPage.vala"
						_tmp36_ = current_name;
#line 1550 "../src/Views/ImportPage.vala"
						if (g_strcmp0 (_tmp35_, _tmp36_) == 0) {
#line 8514 "ImportPage.c"
							PhotoImportSource* _tmp37_;
							PhotoImportSource* _tmp38_;
#line 1551 "../src/Views/ImportPage.vala"
							_tmp37_ = next;
#line 1551 "../src/Views/ImportPage.vala"
							_tmp38_ = _g_object_ref0 (_tmp37_);
#line 1551 "../src/Views/ImportPage.vala"
							_g_object_unref0 (associated);
#line 1551 "../src/Views/ImportPage.vala"
							associated = _tmp38_;
#line 8525 "ImportPage.c"
						}
#line 1547 "../src/Views/ImportPage.vala"
						_g_free0 (next_name);
#line 8529 "ImportPage.c"
					}
#line 1553 "../src/Views/ImportPage.vala"
					_tmp40_ = prev;
#line 1553 "../src/Views/ImportPage.vala"
					if (_tmp40_ != NULL) {
#line 8535 "ImportPage.c"
						PhotoImportSource* _tmp41_;
#line 1553 "../src/Views/ImportPage.vala"
						_tmp41_ = prev;
#line 1553 "../src/Views/ImportPage.vala"
						_tmp39_ = photo_import_source_get_file_format (_tmp41_) == PHOTO_FILE_FORMAT_JFIF;
#line 8541 "ImportPage.c"
					} else {
#line 1553 "../src/Views/ImportPage.vala"
						_tmp39_ = FALSE;
#line 8545 "ImportPage.c"
					}
#line 1553 "../src/Views/ImportPage.vala"
					if (_tmp39_) {
#line 8549 "ImportPage.c"
						gchar* prev_name = NULL;
						PhotoImportSource* _tmp42_;
						const gchar* _tmp43_;
						const gchar* _tmp44_;
						gchar* _tmp45_ = NULL;
						gchar* _tmp46_ = NULL;
						const gchar* _tmp47_;
						const gchar* _tmp48_;
#line 1555 "../src/Views/ImportPage.vala"
						_tmp42_ = prev;
#line 1555 "../src/Views/ImportPage.vala"
						_tmp43_ = import_source_get_filename ((ImportSource*) _tmp42_);
#line 1555 "../src/Views/ImportPage.vala"
						_tmp44_ = _tmp43_;
#line 1555 "../src/Views/ImportPage.vala"
						disassemble_filename (_tmp44_, &_tmp45_, &_tmp46_);
#line 1555 "../src/Views/ImportPage.vala"
						_g_free0 (prev_name);
#line 1555 "../src/Views/ImportPage.vala"
						prev_name = _tmp45_;
#line 1555 "../src/Views/ImportPage.vala"
						_g_free0 (ext);
#line 1555 "../src/Views/ImportPage.vala"
						ext = _tmp46_;
#line 1556 "../src/Views/ImportPage.vala"
						_tmp47_ = prev_name;
#line 1556 "../src/Views/ImportPage.vala"
						_tmp48_ = current_name;
#line 1556 "../src/Views/ImportPage.vala"
						if (g_strcmp0 (_tmp47_, _tmp48_) == 0) {
#line 8580 "ImportPage.c"
							PhotoImportSource* _tmp49_;
							PhotoImportSource* _tmp50_;
#line 1557 "../src/Views/ImportPage.vala"
							_tmp49_ = prev;
#line 1557 "../src/Views/ImportPage.vala"
							_tmp50_ = _g_object_ref0 (_tmp49_);
#line 1557 "../src/Views/ImportPage.vala"
							_g_object_unref0 (associated);
#line 1557 "../src/Views/ImportPage.vala"
							associated = _tmp50_;
#line 8591 "ImportPage.c"
						}
#line 1553 "../src/Views/ImportPage.vala"
						_g_free0 (prev_name);
#line 8595 "ImportPage.c"
					}
#line 1561 "../src/Views/ImportPage.vala"
					_tmp51_ = associated;
#line 1561 "../src/Views/ImportPage.vala"
					if (_tmp51_ != NULL) {
#line 8601 "ImportPage.c"
						PhotoImportSource* _tmp52_;
						const gchar* _tmp53_;
						const gchar* _tmp54_;
						PhotoImportSource* _tmp55_;
						const gchar* _tmp56_;
						const gchar* _tmp57_;
						PhotoImportSource* _tmp58_;
						PhotoImportSource* _tmp59_;
						PhotoImportSource* _tmp60_;
#line 1562 "../src/Views/ImportPage.vala"
						_tmp52_ = current;
#line 1562 "../src/Views/ImportPage.vala"
						_tmp53_ = import_source_get_filename ((ImportSource*) _tmp52_);
#line 1562 "../src/Views/ImportPage.vala"
						_tmp54_ = _tmp53_;
#line 1562 "../src/Views/ImportPage.vala"
						_tmp55_ = associated;
#line 1562 "../src/Views/ImportPage.vala"
						_tmp56_ = import_source_get_filename ((ImportSource*) _tmp55_);
#line 1562 "../src/Views/ImportPage.vala"
						_tmp57_ = _tmp56_;
#line 1562 "../src/Views/ImportPage.vala"
						g_debug ("ImportPage.vala:1562: Found RAW+JPEG pair: %s and %s", _tmp54_, _tmp57_);
#line 1563 "../src/Views/ImportPage.vala"
						_tmp58_ = current;
#line 1563 "../src/Views/ImportPage.vala"
						_tmp59_ = associated;
#line 1563 "../src/Views/ImportPage.vala"
						photo_import_source_set_associated (_tmp58_, _tmp59_);
#line 1564 "../src/Views/ImportPage.vala"
						_tmp60_ = associated;
#line 1564 "../src/Views/ImportPage.vala"
						if (!gee_abstract_collection_remove ((GeeAbstractCollection*) import_list, (ImportSource*) _tmp60_)) {
#line 8635 "ImportPage.c"
							PhotoImportSource* _tmp61_;
#line 1565 "../src/Views/ImportPage.vala"
							g_debug ("ImportPage.vala:1565: Unable to associate files");
#line 1566 "../src/Views/ImportPage.vala"
							_tmp61_ = current;
#line 1566 "../src/Views/ImportPage.vala"
							photo_import_source_set_associated (_tmp61_, NULL);
#line 8643 "ImportPage.c"
						}
					}
#line 1540 "../src/Views/ImportPage.vala"
					_g_object_unref0 (associated);
#line 1540 "../src/Views/ImportPage.vala"
					_g_free0 (ext);
#line 1540 "../src/Views/ImportPage.vala"
					_g_free0 (current_name);
#line 8652 "ImportPage.c"
				}
#line 1534 "../src/Views/ImportPage.vala"
				_g_object_unref0 (prev);
#line 1534 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp14_);
#line 1534 "../src/Views/ImportPage.vala"
				_g_object_unref0 (next);
#line 1534 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp7_);
#line 1534 "../src/Views/ImportPage.vala"
				_g_object_unref0 (current);
#line 8664 "ImportPage.c"
			}
		}
	}
}

static void
import_page_load_previews_and_metadata (ImportPage* self,
                                        GeeList* import_list)
{
	gint loaded_photos = 0;
	GError* _inner_error0_ = NULL;
#line 1573 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1573 "../src/Views/ImportPage.vala"
	g_return_if_fail (import_list != NULL);
#line 1574 "../src/Views/ImportPage.vala"
	loaded_photos = 0;
#line 8682 "ImportPage.c"
	{
		GeeList* _import_source_list = NULL;
		gint _import_source_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _import_source_index = 0;
#line 1575 "../src/Views/ImportPage.vala"
		_import_source_list = import_list;
#line 1575 "../src/Views/ImportPage.vala"
		_tmp0_ = _import_source_list;
#line 1575 "../src/Views/ImportPage.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 1575 "../src/Views/ImportPage.vala"
		_tmp2_ = _tmp1_;
#line 1575 "../src/Views/ImportPage.vala"
		_import_source_size = _tmp2_;
#line 1575 "../src/Views/ImportPage.vala"
		_import_source_index = -1;
#line 1575 "../src/Views/ImportPage.vala"
		while (TRUE) {
#line 8704 "ImportPage.c"
			gint _tmp3_;
			gint _tmp4_;
			ImportSource* import_source = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			gchar* filename = NULL;
			ImportSource* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* fulldir = NULL;
			ImportSource* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			PhotoImportSource* associated = NULL;
			gboolean _tmp17_ = FALSE;
			ImportSource* _tmp18_;
			GtkProgressBar* _tmp24_;
			GtkProgressBar* _tmp25_;
			ImportSource* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			PhotoMetadata* metadata = NULL;
			const gchar* _tmp31_;
			gchar* exif_only_md5 = NULL;
			PhotoMetadata* _tmp44_;
			GdkPixbuf* preview = NULL;
			gchar* preview_md5 = NULL;
			ImportSource* _tmp79_;
			ImportSource* _tmp82_;
			PhotoImportSource* _tmp88_;
			SourceCollection* _tmp112_;
			ImportSource* _tmp113_;
			GtkProgressBar* _tmp114_;
			gint _tmp115_;
			gint _tmp116_;
			gint _tmp117_;
			gint _tmp118_;
			gint _tmp119_;
#line 1575 "../src/Views/ImportPage.vala"
			_import_source_index = _import_source_index + 1;
#line 1575 "../src/Views/ImportPage.vala"
			_tmp3_ = _import_source_index;
#line 1575 "../src/Views/ImportPage.vala"
			_tmp4_ = _import_source_size;
#line 1575 "../src/Views/ImportPage.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 1575 "../src/Views/ImportPage.vala"
				break;
#line 8756 "ImportPage.c"
			}
#line 1575 "../src/Views/ImportPage.vala"
			_tmp5_ = _import_source_list;
#line 1575 "../src/Views/ImportPage.vala"
			_tmp6_ = gee_list_get (_tmp5_, _import_source_index);
#line 1575 "../src/Views/ImportPage.vala"
			import_source = (ImportSource*) _tmp6_;
#line 1576 "../src/Views/ImportPage.vala"
			_tmp7_ = import_source;
#line 1576 "../src/Views/ImportPage.vala"
			_tmp8_ = import_source_get_filename (_tmp7_);
#line 1576 "../src/Views/ImportPage.vala"
			_tmp9_ = _tmp8_;
#line 1576 "../src/Views/ImportPage.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 1576 "../src/Views/ImportPage.vala"
			filename = _tmp10_;
#line 1577 "../src/Views/ImportPage.vala"
			_tmp11_ = import_source;
#line 1577 "../src/Views/ImportPage.vala"
			_tmp12_ = import_source_get_fulldir (_tmp11_);
#line 1577 "../src/Views/ImportPage.vala"
			fulldir = _tmp12_;
#line 1578 "../src/Views/ImportPage.vala"
			_tmp13_ = fulldir;
#line 1578 "../src/Views/ImportPage.vala"
			if (_tmp13_ == NULL) {
#line 8784 "ImportPage.c"
				ImportSource* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
#line 1579 "../src/Views/ImportPage.vala"
				_tmp14_ = import_source;
#line 1579 "../src/Views/ImportPage.vala"
				_tmp15_ = data_object_to_string ((DataObject*) _tmp14_);
#line 1579 "../src/Views/ImportPage.vala"
				_tmp16_ = _tmp15_;
#line 1579 "../src/Views/ImportPage.vala"
				g_warning ("ImportPage.vala:1579: Skipping loading preview of %s: invalid folder n" \
"ame", _tmp16_);
#line 1579 "../src/Views/ImportPage.vala"
				_g_free0 (_tmp16_);
#line 1581 "../src/Views/ImportPage.vala"
				_g_free0 (fulldir);
#line 1581 "../src/Views/ImportPage.vala"
				_g_free0 (filename);
#line 1581 "../src/Views/ImportPage.vala"
				_g_object_unref0 (import_source);
#line 1581 "../src/Views/ImportPage.vala"
				continue;
#line 8806 "ImportPage.c"
			}
#line 1585 "../src/Views/ImportPage.vala"
			associated = NULL;
#line 1586 "../src/Views/ImportPage.vala"
			_tmp18_ = import_source;
#line 1586 "../src/Views/ImportPage.vala"
			if (IS_PHOTO_IMPORT_SOURCE (_tmp18_)) {
#line 8814 "ImportPage.c"
				ImportSource* _tmp19_;
				PhotoImportSource* _tmp20_;
				PhotoImportSource* _tmp21_;
#line 1587 "../src/Views/ImportPage.vala"
				_tmp19_ = import_source;
#line 1587 "../src/Views/ImportPage.vala"
				_tmp20_ = photo_import_source_get_associated (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSource));
#line 1587 "../src/Views/ImportPage.vala"
				_tmp21_ = _tmp20_;
#line 1587 "../src/Views/ImportPage.vala"
				_tmp17_ = _tmp21_ != NULL;
#line 1587 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp21_);
#line 8828 "ImportPage.c"
			} else {
#line 1586 "../src/Views/ImportPage.vala"
				_tmp17_ = FALSE;
#line 8832 "ImportPage.c"
			}
#line 1586 "../src/Views/ImportPage.vala"
			if (_tmp17_) {
#line 8836 "ImportPage.c"
				ImportSource* _tmp22_;
				PhotoImportSource* _tmp23_;
#line 1588 "../src/Views/ImportPage.vala"
				_tmp22_ = import_source;
#line 1588 "../src/Views/ImportPage.vala"
				_tmp23_ = photo_import_source_get_associated (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSource));
#line 1588 "../src/Views/ImportPage.vala"
				_g_object_unref0 (associated);
#line 1588 "../src/Views/ImportPage.vala"
				associated = _tmp23_;
#line 8847 "ImportPage.c"
			}
#line 1591 "../src/Views/ImportPage.vala"
			_tmp24_ = self->priv->progress_bar;
#line 1591 "../src/Views/ImportPage.vala"
			gtk_progress_bar_set_ellipsize (_tmp24_, PANGO_ELLIPSIZE_MIDDLE);
#line 1592 "../src/Views/ImportPage.vala"
			_tmp25_ = self->priv->progress_bar;
#line 1592 "../src/Views/ImportPage.vala"
			_tmp26_ = import_source;
#line 1592 "../src/Views/ImportPage.vala"
			_tmp27_ = data_object_get_name ((DataObject*) _tmp26_);
#line 1592 "../src/Views/ImportPage.vala"
			_tmp28_ = _tmp27_;
#line 1592 "../src/Views/ImportPage.vala"
			_tmp29_ = g_strdup_printf (_ ("Fetching preview for %s"), _tmp28_);
#line 1592 "../src/Views/ImportPage.vala"
			_tmp30_ = _tmp29_;
#line 1592 "../src/Views/ImportPage.vala"
			gtk_progress_bar_set_text (_tmp25_, _tmp30_);
#line 1592 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp30_);
#line 1592 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp28_);
#line 1599 "../src/Views/ImportPage.vala"
			metadata = NULL;
#line 1600 "../src/Views/ImportPage.vala"
			_tmp31_ = filename;
#line 1600 "../src/Views/ImportPage.vala"
			if (!video_reader_is_supported_video_filename (_tmp31_)) {
#line 8877 "ImportPage.c"
				{
					PhotoMetadata* _tmp32_ = NULL;
					GPSpinIdleWrapper* _tmp33_;
					GPContext* _tmp34_;
					Camera* _tmp35_;
					const gchar* _tmp36_;
					const gchar* _tmp37_;
					PhotoMetadata* _tmp38_;
					PhotoMetadata* _tmp39_;
#line 1602 "../src/Views/ImportPage.vala"
					_tmp33_ = import_page_spin_idle_context;
#line 1602 "../src/Views/ImportPage.vala"
					_tmp34_ = ((GPContextWrapper*) _tmp33_)->context;
#line 1602 "../src/Views/ImportPage.vala"
					_tmp35_ = self->priv->camera;
#line 1602 "../src/Views/ImportPage.vala"
					_tmp36_ = fulldir;
#line 1602 "../src/Views/ImportPage.vala"
					_tmp37_ = filename;
#line 1602 "../src/Views/ImportPage.vala"
					_tmp38_ = gp_load_metadata (_tmp34_, _tmp35_, _tmp36_, _tmp37_, &_inner_error0_);
#line 1602 "../src/Views/ImportPage.vala"
					_tmp32_ = _tmp38_;
#line 1602 "../src/Views/ImportPage.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8903 "ImportPage.c"
						goto __catch0_g_error;
					}
#line 1602 "../src/Views/ImportPage.vala"
					_tmp39_ = _tmp32_;
#line 1602 "../src/Views/ImportPage.vala"
					_tmp32_ = NULL;
#line 1602 "../src/Views/ImportPage.vala"
					_media_metadata_unref0 (metadata);
#line 1602 "../src/Views/ImportPage.vala"
					metadata = _tmp39_;
#line 1601 "../src/Views/ImportPage.vala"
					_media_metadata_unref0 (_tmp32_);
#line 8916 "ImportPage.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* err = NULL;
					const gchar* _tmp40_;
					const gchar* _tmp41_;
					GError* _tmp42_;
					const gchar* _tmp43_;
#line 1601 "../src/Views/ImportPage.vala"
					err = _inner_error0_;
#line 1601 "../src/Views/ImportPage.vala"
					_inner_error0_ = NULL;
#line 1605 "../src/Views/ImportPage.vala"
					_tmp40_ = fulldir;
#line 1605 "../src/Views/ImportPage.vala"
					_tmp41_ = filename;
#line 1605 "../src/Views/ImportPage.vala"
					_tmp42_ = err;
#line 1605 "../src/Views/ImportPage.vala"
					_tmp43_ = _tmp42_->message;
#line 1605 "../src/Views/ImportPage.vala"
					g_warning ("ImportPage.vala:1605: Unable to fetch metadata for %s/%s: %s", _tmp40_, _tmp41_, _tmp43_);
#line 1601 "../src/Views/ImportPage.vala"
					_g_error_free0 (err);
#line 8942 "ImportPage.c"
				}
				__finally0:
#line 1601 "../src/Views/ImportPage.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1601 "../src/Views/ImportPage.vala"
					_media_metadata_unref0 (metadata);
#line 1601 "../src/Views/ImportPage.vala"
					_g_object_unref0 (associated);
#line 1601 "../src/Views/ImportPage.vala"
					_g_free0 (fulldir);
#line 1601 "../src/Views/ImportPage.vala"
					_g_free0 (filename);
#line 1601 "../src/Views/ImportPage.vala"
					_g_object_unref0 (import_source);
#line 1601 "../src/Views/ImportPage.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1601 "../src/Views/ImportPage.vala"
					g_clear_error (&_inner_error0_);
#line 1601 "../src/Views/ImportPage.vala"
					return;
#line 8963 "ImportPage.c"
				}
			}
#line 1611 "../src/Views/ImportPage.vala"
			exif_only_md5 = NULL;
#line 1612 "../src/Views/ImportPage.vala"
			_tmp44_ = metadata;
#line 1612 "../src/Views/ImportPage.vala"
			if (_tmp44_ != NULL) {
#line 8972 "ImportPage.c"
				guint8* flattened_sans_thumbnail = NULL;
				PhotoMetadata* _tmp45_;
				gint _tmp46_ = 0;
				guint8* _tmp47_;
				gint flattened_sans_thumbnail_length1;
				gint _flattened_sans_thumbnail_size_;
				gboolean _tmp48_ = FALSE;
				guint8* _tmp49_;
				gint _tmp49__length1;
#line 1613 "../src/Views/ImportPage.vala"
				_tmp45_ = metadata;
#line 1613 "../src/Views/ImportPage.vala"
				_tmp47_ = photo_metadata_flatten_exif (_tmp45_, FALSE, &_tmp46_);
#line 1613 "../src/Views/ImportPage.vala"
				flattened_sans_thumbnail = _tmp47_;
#line 1613 "../src/Views/ImportPage.vala"
				flattened_sans_thumbnail_length1 = _tmp46_;
#line 1613 "../src/Views/ImportPage.vala"
				_flattened_sans_thumbnail_size_ = flattened_sans_thumbnail_length1;
#line 1614 "../src/Views/ImportPage.vala"
				_tmp49_ = flattened_sans_thumbnail;
#line 1614 "../src/Views/ImportPage.vala"
				_tmp49__length1 = flattened_sans_thumbnail_length1;
#line 1614 "../src/Views/ImportPage.vala"
				if (_tmp49_ != NULL) {
#line 8998 "ImportPage.c"
					guint8* _tmp50_;
					gint _tmp50__length1;
#line 1614 "../src/Views/ImportPage.vala"
					_tmp50_ = flattened_sans_thumbnail;
#line 1614 "../src/Views/ImportPage.vala"
					_tmp50__length1 = flattened_sans_thumbnail_length1;
#line 1614 "../src/Views/ImportPage.vala"
					_tmp48_ = _tmp50__length1 > 0;
#line 9007 "ImportPage.c"
				} else {
#line 1614 "../src/Views/ImportPage.vala"
					_tmp48_ = FALSE;
#line 9011 "ImportPage.c"
				}
#line 1614 "../src/Views/ImportPage.vala"
				if (_tmp48_) {
#line 9015 "ImportPage.c"
					guint8* _tmp51_;
					gint _tmp51__length1;
					guint8* _tmp52_;
					gint _tmp52__length1;
					gchar* _tmp53_;
#line 1615 "../src/Views/ImportPage.vala"
					_tmp51_ = flattened_sans_thumbnail;
#line 1615 "../src/Views/ImportPage.vala"
					_tmp51__length1 = flattened_sans_thumbnail_length1;
#line 1615 "../src/Views/ImportPage.vala"
					_tmp52_ = flattened_sans_thumbnail;
#line 1615 "../src/Views/ImportPage.vala"
					_tmp52__length1 = flattened_sans_thumbnail_length1;
#line 1615 "../src/Views/ImportPage.vala"
					_tmp53_ = md5_binary (_tmp51_, (gsize) _tmp52__length1);
#line 1615 "../src/Views/ImportPage.vala"
					_g_free0 (exif_only_md5);
#line 1615 "../src/Views/ImportPage.vala"
					exif_only_md5 = _tmp53_;
#line 9035 "ImportPage.c"
				}
#line 1612 "../src/Views/ImportPage.vala"
				flattened_sans_thumbnail = (g_free (flattened_sans_thumbnail), NULL);
#line 9039 "ImportPage.c"
			}
#line 1624 "../src/Views/ImportPage.vala"
			preview = NULL;
#line 1625 "../src/Views/ImportPage.vala"
			preview_md5 = NULL;
#line 9045 "ImportPage.c"
			{
				gchar* preview_fulldir = NULL;
				const gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* preview_filename = NULL;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				PhotoImportSource* _tmp58_;
				GdkPixbuf* _tmp65_ = NULL;
				GPSpinIdleWrapper* _tmp66_;
				GPContext* _tmp67_;
				Camera* _tmp68_;
				const gchar* _tmp69_;
				const gchar* _tmp70_;
				gchar* _tmp71_ = NULL;
				GdkPixbuf* _tmp72_;
				GdkPixbuf* _tmp73_;
#line 1627 "../src/Views/ImportPage.vala"
				_tmp54_ = fulldir;
#line 1627 "../src/Views/ImportPage.vala"
				_tmp55_ = g_strdup (_tmp54_);
#line 1627 "../src/Views/ImportPage.vala"
				preview_fulldir = _tmp55_;
#line 1628 "../src/Views/ImportPage.vala"
				_tmp56_ = filename;
#line 1628 "../src/Views/ImportPage.vala"
				_tmp57_ = g_strdup (_tmp56_);
#line 1628 "../src/Views/ImportPage.vala"
				preview_filename = _tmp57_;
#line 1629 "../src/Views/ImportPage.vala"
				_tmp58_ = associated;
#line 1629 "../src/Views/ImportPage.vala"
				if (_tmp58_ != NULL) {
#line 9079 "ImportPage.c"
					PhotoImportSource* _tmp59_;
					gchar* _tmp60_;
					PhotoImportSource* _tmp61_;
					const gchar* _tmp62_;
					const gchar* _tmp63_;
					gchar* _tmp64_;
#line 1630 "../src/Views/ImportPage.vala"
					_tmp59_ = associated;
#line 1630 "../src/Views/ImportPage.vala"
					_tmp60_ = import_source_get_fulldir ((ImportSource*) _tmp59_);
#line 1630 "../src/Views/ImportPage.vala"
					_g_free0 (preview_fulldir);
#line 1630 "../src/Views/ImportPage.vala"
					preview_fulldir = _tmp60_;
#line 1631 "../src/Views/ImportPage.vala"
					_tmp61_ = associated;
#line 1631 "../src/Views/ImportPage.vala"
					_tmp62_ = import_source_get_filename ((ImportSource*) _tmp61_);
#line 1631 "../src/Views/ImportPage.vala"
					_tmp63_ = _tmp62_;
#line 1631 "../src/Views/ImportPage.vala"
					_tmp64_ = g_strdup (_tmp63_);
#line 1631 "../src/Views/ImportPage.vala"
					_g_free0 (preview_filename);
#line 1631 "../src/Views/ImportPage.vala"
					preview_filename = _tmp64_;
#line 9106 "ImportPage.c"
				}
#line 1633 "../src/Views/ImportPage.vala"
				_tmp66_ = import_page_spin_idle_context;
#line 1633 "../src/Views/ImportPage.vala"
				_tmp67_ = ((GPContextWrapper*) _tmp66_)->context;
#line 1633 "../src/Views/ImportPage.vala"
				_tmp68_ = self->priv->camera;
#line 1633 "../src/Views/ImportPage.vala"
				_tmp69_ = preview_fulldir;
#line 1633 "../src/Views/ImportPage.vala"
				_tmp70_ = preview_filename;
#line 1633 "../src/Views/ImportPage.vala"
				_tmp72_ = gp_load_preview (_tmp67_, _tmp68_, _tmp69_, _tmp70_, &_tmp71_, &_inner_error0_);
#line 1633 "../src/Views/ImportPage.vala"
				_g_free0 (preview_md5);
#line 1633 "../src/Views/ImportPage.vala"
				preview_md5 = _tmp71_;
#line 1633 "../src/Views/ImportPage.vala"
				_tmp65_ = _tmp72_;
#line 1633 "../src/Views/ImportPage.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1633 "../src/Views/ImportPage.vala"
					_g_free0 (preview_filename);
#line 1633 "../src/Views/ImportPage.vala"
					_g_free0 (preview_fulldir);
#line 9132 "ImportPage.c"
					goto __catch1_g_error;
				}
#line 1633 "../src/Views/ImportPage.vala"
				_tmp73_ = _tmp65_;
#line 1633 "../src/Views/ImportPage.vala"
				_tmp65_ = NULL;
#line 1633 "../src/Views/ImportPage.vala"
				_g_object_unref0 (preview);
#line 1633 "../src/Views/ImportPage.vala"
				preview = _tmp73_;
#line 1626 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp65_);
#line 1626 "../src/Views/ImportPage.vala"
				_g_free0 (preview_filename);
#line 1626 "../src/Views/ImportPage.vala"
				_g_free0 (preview_fulldir);
#line 9149 "ImportPage.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* err = NULL;
				const gchar* _tmp74_;
#line 1626 "../src/Views/ImportPage.vala"
				err = _inner_error0_;
#line 1626 "../src/Views/ImportPage.vala"
				_inner_error0_ = NULL;
#line 1641 "../src/Views/ImportPage.vala"
				_tmp74_ = filename;
#line 1641 "../src/Views/ImportPage.vala"
				if (!video_reader_is_supported_video_filename (_tmp74_)) {
#line 9164 "ImportPage.c"
					const gchar* _tmp75_;
					const gchar* _tmp76_;
					GError* _tmp77_;
					const gchar* _tmp78_;
#line 1642 "../src/Views/ImportPage.vala"
					_tmp75_ = fulldir;
#line 1642 "../src/Views/ImportPage.vala"
					_tmp76_ = filename;
#line 1642 "../src/Views/ImportPage.vala"
					_tmp77_ = err;
#line 1642 "../src/Views/ImportPage.vala"
					_tmp78_ = _tmp77_->message;
#line 1642 "../src/Views/ImportPage.vala"
					g_warning ("ImportPage.vala:1642: Unable to fetch preview for %s/%s: %s", _tmp75_, _tmp76_, _tmp78_);
#line 9179 "ImportPage.c"
				}
#line 1626 "../src/Views/ImportPage.vala"
				_g_error_free0 (err);
#line 9183 "ImportPage.c"
			}
			__finally1:
#line 1626 "../src/Views/ImportPage.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1626 "../src/Views/ImportPage.vala"
				_g_free0 (preview_md5);
#line 1626 "../src/Views/ImportPage.vala"
				_g_object_unref0 (preview);
#line 1626 "../src/Views/ImportPage.vala"
				_g_free0 (exif_only_md5);
#line 1626 "../src/Views/ImportPage.vala"
				_media_metadata_unref0 (metadata);
#line 1626 "../src/Views/ImportPage.vala"
				_g_object_unref0 (associated);
#line 1626 "../src/Views/ImportPage.vala"
				_g_free0 (fulldir);
#line 1626 "../src/Views/ImportPage.vala"
				_g_free0 (filename);
#line 1626 "../src/Views/ImportPage.vala"
				_g_object_unref0 (import_source);
#line 1626 "../src/Views/ImportPage.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1626 "../src/Views/ImportPage.vala"
				g_clear_error (&_inner_error0_);
#line 1626 "../src/Views/ImportPage.vala"
				return;
#line 9210 "ImportPage.c"
			}
#line 1650 "../src/Views/ImportPage.vala"
			_tmp79_ = import_source;
#line 1650 "../src/Views/ImportPage.vala"
			if (IS_VIDEO_IMPORT_SOURCE (_tmp79_)) {
#line 9216 "ImportPage.c"
				ImportSource* _tmp80_;
				GdkPixbuf* _tmp81_;
#line 1651 "../src/Views/ImportPage.vala"
				_tmp80_ = import_source;
#line 1651 "../src/Views/ImportPage.vala"
				_tmp81_ = preview;
#line 1651 "../src/Views/ImportPage.vala"
				video_import_source_update (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, TYPE_VIDEO_IMPORT_SOURCE, VideoImportSource), _tmp81_);
#line 9225 "ImportPage.c"
			}
#line 1653 "../src/Views/ImportPage.vala"
			_tmp82_ = import_source;
#line 1653 "../src/Views/ImportPage.vala"
			if (IS_PHOTO_IMPORT_SOURCE (_tmp82_)) {
#line 9231 "ImportPage.c"
				ImportSource* _tmp83_;
				GdkPixbuf* _tmp84_;
				const gchar* _tmp85_;
				PhotoMetadata* _tmp86_;
				const gchar* _tmp87_;
#line 1654 "../src/Views/ImportPage.vala"
				_tmp83_ = import_source;
#line 1654 "../src/Views/ImportPage.vala"
				_tmp84_ = preview;
#line 1654 "../src/Views/ImportPage.vala"
				_tmp85_ = preview_md5;
#line 1654 "../src/Views/ImportPage.vala"
				_tmp86_ = metadata;
#line 1654 "../src/Views/ImportPage.vala"
				_tmp87_ = exif_only_md5;
#line 1654 "../src/Views/ImportPage.vala"
				photo_import_source_update (G_TYPE_CHECK_INSTANCE_CAST (_tmp83_, TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSource), _tmp84_, _tmp85_, _tmp86_, _tmp87_);
#line 9249 "ImportPage.c"
			}
#line 1657 "../src/Views/ImportPage.vala"
			_tmp88_ = associated;
#line 1657 "../src/Views/ImportPage.vala"
			if (_tmp88_ != NULL) {
#line 9255 "ImportPage.c"
				{
					PhotoMetadata* associated_metadata = NULL;
					GPSpinIdleWrapper* _tmp89_;
					GPContext* _tmp90_;
					Camera* _tmp91_;
					PhotoImportSource* _tmp92_;
					gchar* _tmp93_;
					gchar* _tmp94_;
					PhotoImportSource* _tmp95_;
					const gchar* _tmp96_;
					const gchar* _tmp97_;
					PhotoMetadata* _tmp98_;
					PhotoMetadata* _tmp99_;
					PhotoImportSource* _tmp100_;
					GdkPixbuf* _tmp101_;
					const gchar* _tmp102_;
					PhotoMetadata* _tmp103_;
#line 1659 "../src/Views/ImportPage.vala"
					_tmp89_ = import_page_spin_idle_context;
#line 1659 "../src/Views/ImportPage.vala"
					_tmp90_ = ((GPContextWrapper*) _tmp89_)->context;
#line 1659 "../src/Views/ImportPage.vala"
					_tmp91_ = self->priv->camera;
#line 1659 "../src/Views/ImportPage.vala"
					_tmp92_ = associated;
#line 1659 "../src/Views/ImportPage.vala"
					_tmp93_ = import_source_get_fulldir ((ImportSource*) _tmp92_);
#line 1659 "../src/Views/ImportPage.vala"
					_tmp94_ = _tmp93_;
#line 1659 "../src/Views/ImportPage.vala"
					_tmp95_ = associated;
#line 1659 "../src/Views/ImportPage.vala"
					_tmp96_ = import_source_get_filename ((ImportSource*) _tmp95_);
#line 1659 "../src/Views/ImportPage.vala"
					_tmp97_ = _tmp96_;
#line 1659 "../src/Views/ImportPage.vala"
					_tmp98_ = gp_load_metadata (_tmp90_, _tmp91_, _tmp94_, _tmp97_, &_inner_error0_);
#line 1659 "../src/Views/ImportPage.vala"
					_tmp99_ = _tmp98_;
#line 1659 "../src/Views/ImportPage.vala"
					_g_free0 (_tmp94_);
#line 1659 "../src/Views/ImportPage.vala"
					associated_metadata = _tmp99_;
#line 1659 "../src/Views/ImportPage.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9301 "ImportPage.c"
						goto __catch2_g_error;
					}
#line 1661 "../src/Views/ImportPage.vala"
					_tmp100_ = associated;
#line 1661 "../src/Views/ImportPage.vala"
					_tmp101_ = preview;
#line 1661 "../src/Views/ImportPage.vala"
					_tmp102_ = preview_md5;
#line 1661 "../src/Views/ImportPage.vala"
					_tmp103_ = associated_metadata;
#line 1661 "../src/Views/ImportPage.vala"
					photo_import_source_update (_tmp100_, _tmp101_, _tmp102_, _tmp103_, NULL);
#line 1658 "../src/Views/ImportPage.vala"
					_media_metadata_unref0 (associated_metadata);
#line 9316 "ImportPage.c"
				}
				goto __finally2;
				__catch2_g_error:
				{
					GError* err = NULL;
					PhotoImportSource* _tmp104_;
					gchar* _tmp105_;
					gchar* _tmp106_;
					PhotoImportSource* _tmp107_;
					const gchar* _tmp108_;
					const gchar* _tmp109_;
					GError* _tmp110_;
					const gchar* _tmp111_;
#line 1658 "../src/Views/ImportPage.vala"
					err = _inner_error0_;
#line 1658 "../src/Views/ImportPage.vala"
					_inner_error0_ = NULL;
#line 1663 "../src/Views/ImportPage.vala"
					_tmp104_ = associated;
#line 1663 "../src/Views/ImportPage.vala"
					_tmp105_ = import_source_get_fulldir ((ImportSource*) _tmp104_);
#line 1663 "../src/Views/ImportPage.vala"
					_tmp106_ = _tmp105_;
#line 1663 "../src/Views/ImportPage.vala"
					_tmp107_ = associated;
#line 1663 "../src/Views/ImportPage.vala"
					_tmp108_ = import_source_get_filename ((ImportSource*) _tmp107_);
#line 1663 "../src/Views/ImportPage.vala"
					_tmp109_ = _tmp108_;
#line 1663 "../src/Views/ImportPage.vala"
					_tmp110_ = err;
#line 1663 "../src/Views/ImportPage.vala"
					_tmp111_ = _tmp110_->message;
#line 1663 "../src/Views/ImportPage.vala"
					g_warning ("ImportPage.vala:1663: Unable to fetch metadata for %s/%s: %s", _tmp106_, _tmp109_, _tmp111_);
#line 1663 "../src/Views/ImportPage.vala"
					_g_free0 (_tmp106_);
#line 1658 "../src/Views/ImportPage.vala"
					_g_error_free0 (err);
#line 9356 "ImportPage.c"
				}
				__finally2:
#line 1658 "../src/Views/ImportPage.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1658 "../src/Views/ImportPage.vala"
					_g_free0 (preview_md5);
#line 1658 "../src/Views/ImportPage.vala"
					_g_object_unref0 (preview);
#line 1658 "../src/Views/ImportPage.vala"
					_g_free0 (exif_only_md5);
#line 1658 "../src/Views/ImportPage.vala"
					_media_metadata_unref0 (metadata);
#line 1658 "../src/Views/ImportPage.vala"
					_g_object_unref0 (associated);
#line 1658 "../src/Views/ImportPage.vala"
					_g_free0 (fulldir);
#line 1658 "../src/Views/ImportPage.vala"
					_g_free0 (filename);
#line 1658 "../src/Views/ImportPage.vala"
					_g_object_unref0 (import_source);
#line 1658 "../src/Views/ImportPage.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1658 "../src/Views/ImportPage.vala"
					g_clear_error (&_inner_error0_);
#line 1658 "../src/Views/ImportPage.vala"
					return;
#line 9383 "ImportPage.c"
				}
			}
#line 1673 "../src/Views/ImportPage.vala"
			_tmp112_ = self->priv->import_sources;
#line 1673 "../src/Views/ImportPage.vala"
			_tmp113_ = import_source;
#line 1673 "../src/Views/ImportPage.vala"
			data_collection_add ((DataCollection*) _tmp112_, (DataObject*) _tmp113_);
#line 1675 "../src/Views/ImportPage.vala"
			_tmp114_ = self->priv->progress_bar;
#line 1675 "../src/Views/ImportPage.vala"
			loaded_photos = loaded_photos + 1;
#line 1675 "../src/Views/ImportPage.vala"
			_tmp115_ = loaded_photos;
#line 1675 "../src/Views/ImportPage.vala"
			_tmp116_ = gee_collection_get_size ((GeeCollection*) import_list);
#line 1675 "../src/Views/ImportPage.vala"
			_tmp117_ = _tmp116_;
#line 1675 "../src/Views/ImportPage.vala"
			gtk_progress_bar_set_fraction (_tmp114_, ((gdouble) _tmp115_) / ((gdouble) _tmp117_));
#line 1678 "../src/Views/ImportPage.vala"
			_tmp118_ = gee_collection_get_size ((GeeCollection*) import_list);
#line 1678 "../src/Views/ImportPage.vala"
			_tmp119_ = _tmp118_;
#line 1678 "../src/Views/ImportPage.vala"
			granite_services_application_set_progress (((gdouble) loaded_photos) / ((gdouble) _tmp119_), NULL, NULL);
#line 1681 "../src/Views/ImportPage.vala"
			spin_event_loop ();
#line 1575 "../src/Views/ImportPage.vala"
			_g_free0 (preview_md5);
#line 1575 "../src/Views/ImportPage.vala"
			_g_object_unref0 (preview);
#line 1575 "../src/Views/ImportPage.vala"
			_g_free0 (exif_only_md5);
#line 1575 "../src/Views/ImportPage.vala"
			_media_metadata_unref0 (metadata);
#line 1575 "../src/Views/ImportPage.vala"
			_g_object_unref0 (associated);
#line 1575 "../src/Views/ImportPage.vala"
			_g_free0 (fulldir);
#line 1575 "../src/Views/ImportPage.vala"
			_g_free0 (filename);
#line 1575 "../src/Views/ImportPage.vala"
			_g_object_unref0 (import_source);
#line 9428 "ImportPage.c"
		}
	}
}

static void
import_page_on_hide_imported (ImportPage* self)
{
	GtkCheckButton* _tmp0_;
	GSettings* _tmp7_;
	GtkCheckButton* _tmp8_;
#line 1685 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1686 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->hide_imported;
#line 1686 "../src/Views/ImportPage.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_)) {
#line 9445 "ImportPage.c"
		ViewCollection* _tmp1_;
		ViewCollection* _tmp2_;
		ImportPageHideImportedViewFilter* _tmp3_;
#line 1687 "../src/Views/ImportPage.vala"
		_tmp1_ = page_get_view ((Page*) self);
#line 1687 "../src/Views/ImportPage.vala"
		_tmp2_ = _tmp1_;
#line 1687 "../src/Views/ImportPage.vala"
		_tmp3_ = self->priv->hide_imported_filter;
#line 1687 "../src/Views/ImportPage.vala"
		view_collection_install_view_filter (_tmp2_, (ViewFilter*) _tmp3_);
#line 1687 "../src/Views/ImportPage.vala"
		_data_collection_unref0 (_tmp2_);
#line 9459 "ImportPage.c"
	} else {
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
		ImportPageHideImportedViewFilter* _tmp6_;
#line 1689 "../src/Views/ImportPage.vala"
		_tmp4_ = page_get_view ((Page*) self);
#line 1689 "../src/Views/ImportPage.vala"
		_tmp5_ = _tmp4_;
#line 1689 "../src/Views/ImportPage.vala"
		_tmp6_ = self->priv->hide_imported_filter;
#line 1689 "../src/Views/ImportPage.vala"
		view_collection_remove_view_filter (_tmp5_, (ViewFilter*) _tmp6_);
#line 1689 "../src/Views/ImportPage.vala"
		_data_collection_unref0 (_tmp5_);
#line 9474 "ImportPage.c"
	}
#line 1691 "../src/Views/ImportPage.vala"
	_tmp7_ = ((Page*) self)->ui_settings;
#line 1691 "../src/Views/ImportPage.vala"
	_tmp8_ = self->priv->hide_imported;
#line 1691 "../src/Views/ImportPage.vala"
	g_settings_set_boolean (_tmp7_, "hide-photos-already-imported", gtk_toggle_button_get_active ((GtkToggleButton*) _tmp8_));
#line 9482 "ImportPage.c"
}

static void
import_page_on_import_selected (ImportPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
#line 1694 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1695 "../src/Views/ImportPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 1695 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 1695 "../src/Views/ImportPage.vala"
	_tmp2_ = view_collection_get_selected (_tmp1_);
#line 1695 "../src/Views/ImportPage.vala"
	_tmp3_ = _tmp2_;
#line 1695 "../src/Views/ImportPage.vala"
	import_page_import (self, (GeeIterable*) _tmp3_);
#line 1695 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp3_);
#line 1695 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 9508 "ImportPage.c"
}

static void
import_page_on_import_all (ImportPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
#line 1698 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1699 "../src/Views/ImportPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 1699 "../src/Views/ImportPage.vala"
	_tmp1_ = _tmp0_;
#line 1699 "../src/Views/ImportPage.vala"
	_tmp2_ = data_collection_get_all ((DataCollection*) _tmp1_);
#line 1699 "../src/Views/ImportPage.vala"
	_tmp3_ = _tmp2_;
#line 1699 "../src/Views/ImportPage.vala"
	import_page_import (self, (GeeIterable*) _tmp3_);
#line 1699 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp3_);
#line 1699 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 9534 "ImportPage.c"
}

static gint64
_import_page_import_job_comparator_comparator (void* a,
                                               void* b,
                                               gpointer self)
{
	gint64 result;
	result = import_page_import_job_comparator ((ImportPage*) self, a, b);
#line 1715 "../src/Views/ImportPage.vala"
	return result;
#line 9546 "ImportPage.c"
}

static void
_import_page_import_reporter_batch_import_import_reporter (ImportManifest* manifest,
                                                           BatchImportRoll* import_roll,
                                                           gpointer self)
{
#line 1751 "../src/Views/ImportPage.vala"
	import_page_import_reporter ((ImportPage*) self, manifest);
#line 9556 "ImportPage.c"
}

static void
_import_page_on_import_job_failed_batch_import_import_job_failed (BatchImport* _sender,
                                                                  BatchImportResult* _result_,
                                                                  gpointer self)
{
#line 1753 "../src/Views/ImportPage.vala"
	import_page_on_import_job_failed ((ImportPage*) self, _result_);
#line 9566 "ImportPage.c"
}

static void
_import_page_close_import_batch_import_import_complete (BatchImport* _sender,
                                                        ImportManifest* manifest,
                                                        BatchImportRoll* import_roll,
                                                        gpointer self)
{
#line 1754 "../src/Views/ImportPage.vala"
	import_page_close_import ((ImportPage*) self);
#line 9577 "ImportPage.c"
}

static void
import_page_import (ImportPage* self,
                    GeeIterable* items)
{
	int res = 0;
	Camera* _tmp0_;
	GPSpinIdleWrapper* _tmp1_;
	GPContext* _tmp2_;
	GtkProgressBar* _tmp7_;
	SortedList* jobs = NULL;
	SortedList* _tmp8_;
	GeeArrayList* already_imported = NULL;
	GeeArrayList* _tmp9_;
	SortedList* _tmp49_;
	gint _tmp50_;
	gint _tmp51_;
	const gchar* _tmp52_;
	SortedList* _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
#line 1702 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1702 "../src/Views/ImportPage.vala"
	g_return_if_fail (items != NULL);
#line 1703 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->camera;
#line 1703 "../src/Views/ImportPage.vala"
	_tmp1_ = import_page_spin_idle_context;
#line 1703 "../src/Views/ImportPage.vala"
	_tmp2_ = ((GPContextWrapper*) _tmp1_)->context;
#line 1703 "../src/Views/ImportPage.vala"
	res = gp_camera_init (_tmp0_, _tmp2_);
#line 1704 "../src/Views/ImportPage.vala"
	if (res != GP_OK) {
#line 9614 "ImportPage.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1705 "../src/Views/ImportPage.vala"
		_tmp3_ = gp_result_to_full_string (res);
#line 1705 "../src/Views/ImportPage.vala"
		_tmp4_ = _tmp3_;
#line 1705 "../src/Views/ImportPage.vala"
		_tmp5_ = g_strdup_printf (_ ("Unable to lock camera: %s"), _tmp4_);
#line 1705 "../src/Views/ImportPage.vala"
		_tmp6_ = _tmp5_;
#line 1705 "../src/Views/ImportPage.vala"
		app_window_error_message (_tmp6_, NULL, NULL);
#line 1705 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp6_);
#line 1705 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp4_);
#line 1707 "../src/Views/ImportPage.vala"
		return;
#line 9635 "ImportPage.c"
	}
#line 1710 "../src/Views/ImportPage.vala"
	import_page_update_status (self, TRUE, self->priv->refreshed);
#line 1712 "../src/Views/ImportPage.vala"
	import_page_on_view_changed (self);
#line 1713 "../src/Views/ImportPage.vala"
	_tmp7_ = self->priv->progress_bar;
#line 1713 "../src/Views/ImportPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 1715 "../src/Views/ImportPage.vala"
	_tmp8_ = sorted_list_new (IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB, (GBoxedCopyFunc) batch_import_job_ref, (GDestroyNotify) batch_import_job_unref, _import_page_import_job_comparator_comparator, self);
#line 1715 "../src/Views/ImportPage.vala"
	jobs = _tmp8_;
#line 1716 "../src/Views/ImportPage.vala"
	_tmp9_ = gee_array_list_new (IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB, (GBoxedCopyFunc) batch_import_job_ref, (GDestroyNotify) batch_import_job_unref, NULL, NULL, NULL);
#line 1716 "../src/Views/ImportPage.vala"
	already_imported = _tmp9_;
#line 9653 "ImportPage.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp10_;
#line 1718 "../src/Views/ImportPage.vala"
		_tmp10_ = gee_iterable_iterator (items);
#line 1718 "../src/Views/ImportPage.vala"
		_object_it = _tmp10_;
#line 1718 "../src/Views/ImportPage.vala"
		while (TRUE) {
#line 9663 "ImportPage.c"
			GeeIterator* _tmp11_;
			DataObject* object = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			ImportPreview* preview = NULL;
			DataObject* _tmp14_;
			ImportPreview* _tmp15_;
			ImportSource* import_file = NULL;
			ImportPreview* _tmp16_;
			DataSource* _tmp17_;
			DataSource* _tmp18_;
			ImportSource* _tmp19_;
			ImportPreview* _tmp20_;
			ImportPageCameraImportJob* import_job = NULL;
			GPContextWrapper* _tmp32_;
			ImportSource* _tmp33_;
			ImportPageCameraImportJob* _tmp34_;
			gboolean _tmp35_ = FALSE;
			ImportSource* _tmp36_;
			SortedList* _tmp47_;
			ImportPageCameraImportJob* _tmp48_;
#line 1718 "../src/Views/ImportPage.vala"
			_tmp11_ = _object_it;
#line 1718 "../src/Views/ImportPage.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 1718 "../src/Views/ImportPage.vala"
				break;
#line 9691 "ImportPage.c"
			}
#line 1718 "../src/Views/ImportPage.vala"
			_tmp12_ = _object_it;
#line 1718 "../src/Views/ImportPage.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 1718 "../src/Views/ImportPage.vala"
			object = (DataObject*) _tmp13_;
#line 1719 "../src/Views/ImportPage.vala"
			_tmp14_ = object;
#line 1719 "../src/Views/ImportPage.vala"
			_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_IMPORT_PREVIEW, ImportPreview));
#line 1719 "../src/Views/ImportPage.vala"
			preview = _tmp15_;
#line 1720 "../src/Views/ImportPage.vala"
			_tmp16_ = preview;
#line 1720 "../src/Views/ImportPage.vala"
			_tmp17_ = data_view_get_source ((DataView*) _tmp16_);
#line 1720 "../src/Views/ImportPage.vala"
			_tmp18_ = _tmp17_;
#line 1720 "../src/Views/ImportPage.vala"
			_tmp19_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_IMPORT_SOURCE, ImportSource));
#line 1720 "../src/Views/ImportPage.vala"
			import_file = _tmp19_;
#line 1722 "../src/Views/ImportPage.vala"
			_tmp20_ = preview;
#line 1722 "../src/Views/ImportPage.vala"
			if (import_preview_is_already_imported (_tmp20_)) {
#line 9719 "ImportPage.c"
				ImportSource* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				GeeArrayList* _tmp24_;
				GPContextWrapper* _tmp25_;
				ImportSource* _tmp26_;
				ImportPreview* _tmp27_;
				DuplicatedFile* _tmp28_;
				DuplicatedFile* _tmp29_;
				ImportPageCameraImportJob* _tmp30_;
				ImportPageCameraImportJob* _tmp31_;
#line 1723 "../src/Views/ImportPage.vala"
				_tmp21_ = import_file;
#line 1723 "../src/Views/ImportPage.vala"
				_tmp22_ = import_source_get_filename (_tmp21_);
#line 1723 "../src/Views/ImportPage.vala"
				_tmp23_ = _tmp22_;
#line 1723 "../src/Views/ImportPage.vala"
				g_message ("ImportPage.vala:1723: Skipping import of %s: checksum detected in libr" \
"ary", _tmp23_);
#line 1726 "../src/Views/ImportPage.vala"
				_tmp24_ = already_imported;
#line 1726 "../src/Views/ImportPage.vala"
				_tmp25_ = import_page_null_context;
#line 1726 "../src/Views/ImportPage.vala"
				_tmp26_ = import_file;
#line 1726 "../src/Views/ImportPage.vala"
				_tmp27_ = preview;
#line 1726 "../src/Views/ImportPage.vala"
				_tmp28_ = import_preview_get_duplicated_file (_tmp27_);
#line 1726 "../src/Views/ImportPage.vala"
				_tmp29_ = _tmp28_;
#line 1726 "../src/Views/ImportPage.vala"
				_tmp30_ = import_page_camera_import_job_new (_tmp25_, _tmp26_, _tmp29_);
#line 1726 "../src/Views/ImportPage.vala"
				_tmp31_ = _tmp30_;
#line 1726 "../src/Views/ImportPage.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp31_);
#line 1726 "../src/Views/ImportPage.vala"
				_batch_import_job_unref0 (_tmp31_);
#line 1726 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp29_);
#line 1729 "../src/Views/ImportPage.vala"
				_g_object_unref0 (import_file);
#line 1729 "../src/Views/ImportPage.vala"
				_g_object_unref0 (preview);
#line 1729 "../src/Views/ImportPage.vala"
				_g_object_unref0 (object);
#line 1729 "../src/Views/ImportPage.vala"
				continue;
#line 9769 "ImportPage.c"
			}
#line 1732 "../src/Views/ImportPage.vala"
			_tmp32_ = import_page_null_context;
#line 1732 "../src/Views/ImportPage.vala"
			_tmp33_ = import_file;
#line 1732 "../src/Views/ImportPage.vala"
			_tmp34_ = import_page_camera_import_job_new (_tmp32_, _tmp33_, NULL);
#line 1732 "../src/Views/ImportPage.vala"
			import_job = _tmp34_;
#line 1735 "../src/Views/ImportPage.vala"
			_tmp36_ = import_file;
#line 1735 "../src/Views/ImportPage.vala"
			if (IS_PHOTO_IMPORT_SOURCE (_tmp36_)) {
#line 9783 "ImportPage.c"
				ImportSource* _tmp37_;
				PhotoImportSource* _tmp38_;
				PhotoImportSource* _tmp39_;
#line 1736 "../src/Views/ImportPage.vala"
				_tmp37_ = import_file;
#line 1736 "../src/Views/ImportPage.vala"
				_tmp38_ = photo_import_source_get_associated (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSource));
#line 1736 "../src/Views/ImportPage.vala"
				_tmp39_ = _tmp38_;
#line 1736 "../src/Views/ImportPage.vala"
				_tmp35_ = _tmp39_ != NULL;
#line 1736 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp39_);
#line 9797 "ImportPage.c"
			} else {
#line 1735 "../src/Views/ImportPage.vala"
				_tmp35_ = FALSE;
#line 9801 "ImportPage.c"
			}
#line 1735 "../src/Views/ImportPage.vala"
			if (_tmp35_) {
#line 9805 "ImportPage.c"
				ImportPageCameraImportJob* _tmp40_;
				GPContextWrapper* _tmp41_;
				ImportSource* _tmp42_;
				PhotoImportSource* _tmp43_;
				PhotoImportSource* _tmp44_;
				ImportPageCameraImportJob* _tmp45_;
				ImportPageCameraImportJob* _tmp46_;
#line 1737 "../src/Views/ImportPage.vala"
				_tmp40_ = import_job;
#line 1737 "../src/Views/ImportPage.vala"
				_tmp41_ = import_page_null_context;
#line 1737 "../src/Views/ImportPage.vala"
				_tmp42_ = import_file;
#line 1737 "../src/Views/ImportPage.vala"
				_tmp43_ = photo_import_source_get_associated (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSource));
#line 1737 "../src/Views/ImportPage.vala"
				_tmp44_ = _tmp43_;
#line 1737 "../src/Views/ImportPage.vala"
				_tmp45_ = import_page_camera_import_job_new (_tmp41_, (ImportSource*) _tmp44_, NULL);
#line 1737 "../src/Views/ImportPage.vala"
				_tmp46_ = _tmp45_;
#line 1737 "../src/Views/ImportPage.vala"
				batch_import_job_set_associated ((BatchImportJob*) _tmp40_, (BatchImportJob*) _tmp46_);
#line 1737 "../src/Views/ImportPage.vala"
				_batch_import_job_unref0 (_tmp46_);
#line 1737 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_tmp44_);
#line 9833 "ImportPage.c"
			}
#line 1741 "../src/Views/ImportPage.vala"
			_tmp47_ = jobs;
#line 1741 "../src/Views/ImportPage.vala"
			_tmp48_ = import_job;
#line 1741 "../src/Views/ImportPage.vala"
			gee_collection_add ((GeeCollection*) _tmp47_, _tmp48_);
#line 1718 "../src/Views/ImportPage.vala"
			_batch_import_job_unref0 (import_job);
#line 1718 "../src/Views/ImportPage.vala"
			_g_object_unref0 (import_file);
#line 1718 "../src/Views/ImportPage.vala"
			_g_object_unref0 (preview);
#line 1718 "../src/Views/ImportPage.vala"
			_g_object_unref0 (object);
#line 9849 "ImportPage.c"
		}
#line 1718 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_object_it);
#line 9853 "ImportPage.c"
	}
#line 1744 "../src/Views/ImportPage.vala"
	_tmp49_ = jobs;
#line 1744 "../src/Views/ImportPage.vala"
	_tmp50_ = gee_collection_get_size ((GeeCollection*) _tmp49_);
#line 1744 "../src/Views/ImportPage.vala"
	_tmp51_ = _tmp50_;
#line 1744 "../src/Views/ImportPage.vala"
	_tmp52_ = self->priv->camera_name;
#line 1744 "../src/Views/ImportPage.vala"
	g_debug ("ImportPage.vala:1744: Importing %d files from %s", _tmp51_, _tmp52_);
#line 1746 "../src/Views/ImportPage.vala"
	_tmp53_ = jobs;
#line 1746 "../src/Views/ImportPage.vala"
	_tmp54_ = gee_collection_get_size ((GeeCollection*) _tmp53_);
#line 1746 "../src/Views/ImportPage.vala"
	_tmp55_ = _tmp54_;
#line 1746 "../src/Views/ImportPage.vala"
	if (_tmp55_ > 0) {
#line 9873 "ImportPage.c"
		ImportPage* _tmp56_;
		ImportPage* _tmp57_;
		BatchImport* batch_import = NULL;
		SortedList* _tmp58_;
		const gchar* _tmp59_;
		GeeArrayList* _tmp60_;
		BatchImport* _tmp61_;
		BatchImport* _tmp62_;
		BatchImport* _tmp63_;
		LibraryWindow* _tmp64_;
		LibraryWindow* _tmp65_;
		BatchImport* _tmp66_;
		LibraryWindow* _tmp67_;
		LibraryWindow* _tmp68_;
#line 1748 "../src/Views/ImportPage.vala"
		_tmp56_ = self->priv->local_ref;
#line 1748 "../src/Views/ImportPage.vala"
		_vala_assert (_tmp56_ == NULL, "local_ref == null");
#line 1749 "../src/Views/ImportPage.vala"
		_tmp57_ = _g_object_ref0 (self);
#line 1749 "../src/Views/ImportPage.vala"
		_g_object_unref0 (self->priv->local_ref);
#line 1749 "../src/Views/ImportPage.vala"
		self->priv->local_ref = _tmp57_;
#line 1751 "../src/Views/ImportPage.vala"
		_tmp58_ = jobs;
#line 1751 "../src/Views/ImportPage.vala"
		_tmp59_ = self->priv->camera_name;
#line 1751 "../src/Views/ImportPage.vala"
		_tmp60_ = already_imported;
#line 1751 "../src/Views/ImportPage.vala"
		_tmp61_ = batch_import_new ((GeeIterable*) _tmp58_, _tmp59_, _import_page_import_reporter_batch_import_import_reporter, self, NULL, _tmp60_, NULL, NULL, NULL);
#line 1751 "../src/Views/ImportPage.vala"
		batch_import = _tmp61_;
#line 1753 "../src/Views/ImportPage.vala"
		_tmp62_ = batch_import;
#line 1753 "../src/Views/ImportPage.vala"
		g_signal_connect_object (_tmp62_, "import-job-failed", (GCallback) _import_page_on_import_job_failed_batch_import_import_job_failed, self, 0);
#line 1754 "../src/Views/ImportPage.vala"
		_tmp63_ = batch_import;
#line 1754 "../src/Views/ImportPage.vala"
		g_signal_connect_object (_tmp63_, "import-complete", (GCallback) _import_page_close_import_batch_import_import_complete, self, 0);
#line 1756 "../src/Views/ImportPage.vala"
		_tmp64_ = library_window_get_app ();
#line 1756 "../src/Views/ImportPage.vala"
		_tmp65_ = _tmp64_;
#line 1756 "../src/Views/ImportPage.vala"
		_tmp66_ = batch_import;
#line 1756 "../src/Views/ImportPage.vala"
		library_window_enqueue_batch_import (_tmp65_, _tmp66_, TRUE);
#line 1756 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp65_);
#line 1757 "../src/Views/ImportPage.vala"
		_tmp67_ = library_window_get_app ();
#line 1757 "../src/Views/ImportPage.vala"
		_tmp68_ = _tmp67_;
#line 1757 "../src/Views/ImportPage.vala"
		library_window_switch_to_import_queue_page (_tmp68_);
#line 1757 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp68_);
#line 1746 "../src/Views/ImportPage.vala"
		_g_object_unref0 (batch_import);
#line 9936 "ImportPage.c"
	} else {
		GeeArrayList* _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
#line 1761 "../src/Views/ImportPage.vala"
		_tmp69_ = already_imported;
#line 1761 "../src/Views/ImportPage.vala"
		_tmp70_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp69_);
#line 1761 "../src/Views/ImportPage.vala"
		_tmp71_ = _tmp70_;
#line 1761 "../src/Views/ImportPage.vala"
		if (_tmp71_ > 0) {
#line 9949 "ImportPage.c"
			GeeArrayList* _tmp72_;
			ImportManifest* _tmp73_;
			ImportManifest* _tmp74_;
#line 1762 "../src/Views/ImportPage.vala"
			_tmp72_ = already_imported;
#line 1762 "../src/Views/ImportPage.vala"
			_tmp73_ = import_manifest_new (NULL, (GeeList*) _tmp72_);
#line 1762 "../src/Views/ImportPage.vala"
			_tmp74_ = _tmp73_;
#line 1762 "../src/Views/ImportPage.vala"
			import_page_import_reporter (self, _tmp74_);
#line 1762 "../src/Views/ImportPage.vala"
			_import_manifest_unref0 (_tmp74_);
#line 9963 "ImportPage.c"
		}
#line 1764 "../src/Views/ImportPage.vala"
		import_page_close_import (self);
#line 9967 "ImportPage.c"
	}
#line 1702 "../src/Views/ImportPage.vala"
	_g_object_unref0 (already_imported);
#line 1702 "../src/Views/ImportPage.vala"
	_g_object_unref0 (jobs);
#line 9973 "ImportPage.c"
}

static void
import_page_on_import_job_failed (ImportPage* self,
                                  BatchImportResult* _result_)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1768 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1768 "../src/Views/ImportPage.vala"
	g_return_if_fail (_result_ != NULL);
#line 1769 "../src/Views/ImportPage.vala"
	_tmp1_ = _result_->file;
#line 1769 "../src/Views/ImportPage.vala"
	if (_tmp1_ == NULL) {
#line 1769 "../src/Views/ImportPage.vala"
		_tmp0_ = TRUE;
#line 9993 "ImportPage.c"
	} else {
#line 1769 "../src/Views/ImportPage.vala"
		_tmp0_ = _result_->result == IMPORT_RESULT_SUCCESS;
#line 9997 "ImportPage.c"
	}
#line 1769 "../src/Views/ImportPage.vala"
	if (_tmp0_) {
#line 1770 "../src/Views/ImportPage.vala"
		return;
#line 10003 "ImportPage.c"
	}
	{
		GFile* _tmp2_;
#line 1774 "../src/Views/ImportPage.vala"
		_tmp2_ = _result_->file;
#line 1774 "../src/Views/ImportPage.vala"
		g_file_delete (_tmp2_, NULL, &_inner_error0_);
#line 1774 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10013 "ImportPage.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 1773 "../src/Views/ImportPage.vala"
		err = _inner_error0_;
#line 1773 "../src/Views/ImportPage.vala"
		_inner_error0_ = NULL;
#line 1776 "../src/Views/ImportPage.vala"
		_tmp3_ = _result_->file;
#line 1776 "../src/Views/ImportPage.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 1776 "../src/Views/ImportPage.vala"
		_tmp5_ = _tmp4_;
#line 1776 "../src/Views/ImportPage.vala"
		_tmp6_ = err;
#line 1776 "../src/Views/ImportPage.vala"
		_tmp7_ = _tmp6_->message;
#line 1776 "../src/Views/ImportPage.vala"
		g_message ("ImportPage.vala:1776: Unable to delete downloaded file %s: %s", _tmp5_, _tmp7_);
#line 1776 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp5_);
#line 1773 "../src/Views/ImportPage.vala"
		_g_error_free0 (err);
#line 10046 "ImportPage.c"
	}
	__finally0:
#line 1773 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1773 "../src/Views/ImportPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1773 "../src/Views/ImportPage.vala"
		g_clear_error (&_inner_error0_);
#line 1773 "../src/Views/ImportPage.vala"
		return;
#line 10057 "ImportPage.c"
	}
}

static gpointer
_batch_import_job_ref0 (gpointer self)
{
#line 1820 "../src/Views/ImportPage.vala"
	return self ? batch_import_job_ref (self) : NULL;
#line 10066 "ImportPage.c"
}

static gboolean
_progress_dialog_monitor_progress_monitor (guint64 current,
                                           guint64 total,
                                           gboolean do_event_loop,
                                           gpointer self)
{
	gboolean result;
	result = progress_dialog_monitor ((ProgressDialog*) self, current, total, do_event_loop);
#line 1827 "../src/Views/ImportPage.vala"
	return result;
#line 10079 "ImportPage.c"
}

static void
import_page_import_reporter (ImportPage* self,
                             ImportManifest* manifest)
{
	ImportPage* local_ref = NULL;
	ImportPage* _tmp0_;
	ImportPage* _tmp1_;
	GeeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	Marker* marker = NULL;
	SourceCollection* _tmp42_;
	Marker* _tmp43_;
	ProgressDialog* progress = NULL;
	AppWindow* _tmp59_;
	AppWindow* _tmp60_;
	GCancellable* _tmp61_;
	GCancellable* _tmp62_;
	ProgressDialog* _tmp63_;
	ProgressDialog* _tmp64_;
	gint error_count = 0;
	SourceCollection* _tmp65_;
	Marker* _tmp66_;
	ProgressDialog* _tmp67_;
	ProgressDialog* _tmp70_;
#line 1780 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1780 "../src/Views/ImportPage.vala"
	g_return_if_fail (manifest != NULL);
#line 1786 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->local_ref;
#line 1786 "../src/Views/ImportPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1786 "../src/Views/ImportPage.vala"
	local_ref = _tmp1_;
#line 1787 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->local_ref);
#line 1787 "../src/Views/ImportPage.vala"
	self->priv->local_ref = NULL;
#line 1789 "../src/Views/ImportPage.vala"
	_tmp2_ = manifest->success;
#line 1789 "../src/Views/ImportPage.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 1789 "../src/Views/ImportPage.vala"
	_tmp4_ = _tmp3_;
#line 1789 "../src/Views/ImportPage.vala"
	if (_tmp4_ > 0) {
#line 10129 "ImportPage.c"
		gchar* photos_string = NULL;
		GeeList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		GeeList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gchar* _tmp11_;
		gchar* videos_string = NULL;
		GeeList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		GeeList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
		gchar* both_string = NULL;
		GeeList* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		GeeList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gchar* _tmp25_;
		gchar* neither_string = NULL;
		GeeList* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		GeeList* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		gchar* _tmp32_;
		gchar* question_string = NULL;
		GeeList* _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		ImportUIQuestionParams* question = NULL;
		const gchar* _tmp39_;
		ImportUIQuestionParams* _tmp40_;
		ImportUIQuestionParams* _tmp41_;
#line 1790 "../src/Views/ImportPage.vala"
		_tmp5_ = manifest->success;
#line 1790 "../src/Views/ImportPage.vala"
		_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 1790 "../src/Views/ImportPage.vala"
		_tmp7_ = _tmp6_;
#line 1790 "../src/Views/ImportPage.vala"
		_tmp8_ = manifest->success;
#line 1790 "../src/Views/ImportPage.vala"
		_tmp9_ = gee_collection_get_size ((GeeCollection*) _tmp8_);
#line 1790 "../src/Views/ImportPage.vala"
		_tmp10_ = _tmp9_;
#line 1790 "../src/Views/ImportPage.vala"
		_tmp11_ = g_strdup_printf (ngettext ("Delete this photo from camera?", "Delete these %d photos from camera?", (gulong) _tmp7_), _tmp10_);
#line 1790 "../src/Views/ImportPage.vala"
		photos_string = _tmp11_;
#line 1793 "../src/Views/ImportPage.vala"
		_tmp12_ = manifest->success;
#line 1793 "../src/Views/ImportPage.vala"
		_tmp13_ = gee_collection_get_size ((GeeCollection*) _tmp12_);
#line 1793 "../src/Views/ImportPage.vala"
		_tmp14_ = _tmp13_;
#line 1793 "../src/Views/ImportPage.vala"
		_tmp15_ = manifest->success;
#line 1793 "../src/Views/ImportPage.vala"
		_tmp16_ = gee_collection_get_size ((GeeCollection*) _tmp15_);
#line 1793 "../src/Views/ImportPage.vala"
		_tmp17_ = _tmp16_;
#line 1793 "../src/Views/ImportPage.vala"
		_tmp18_ = g_strdup_printf (ngettext ("Delete this video from camera?", "Delete these %d videos from camera?", (gulong) _tmp14_), _tmp17_);
#line 1793 "../src/Views/ImportPage.vala"
		videos_string = _tmp18_;
#line 1796 "../src/Views/ImportPage.vala"
		_tmp19_ = manifest->success;
#line 1796 "../src/Views/ImportPage.vala"
		_tmp20_ = gee_collection_get_size ((GeeCollection*) _tmp19_);
#line 1796 "../src/Views/ImportPage.vala"
		_tmp21_ = _tmp20_;
#line 1796 "../src/Views/ImportPage.vala"
		_tmp22_ = manifest->success;
#line 1796 "../src/Views/ImportPage.vala"
		_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
#line 1796 "../src/Views/ImportPage.vala"
		_tmp24_ = _tmp23_;
#line 1796 "../src/Views/ImportPage.vala"
		_tmp25_ = g_strdup_printf (ngettext ("Delete this photo/video from camera?", "Delete these %d photos/videos from camera?", (gulong) _tmp21_), _tmp24_);
#line 1796 "../src/Views/ImportPage.vala"
		both_string = _tmp25_;
#line 1799 "../src/Views/ImportPage.vala"
		_tmp26_ = manifest->success;
#line 1799 "../src/Views/ImportPage.vala"
		_tmp27_ = gee_collection_get_size ((GeeCollection*) _tmp26_);
#line 1799 "../src/Views/ImportPage.vala"
		_tmp28_ = _tmp27_;
#line 1799 "../src/Views/ImportPage.vala"
		_tmp29_ = manifest->success;
#line 1799 "../src/Views/ImportPage.vala"
		_tmp30_ = gee_collection_get_size ((GeeCollection*) _tmp29_);
#line 1799 "../src/Views/ImportPage.vala"
		_tmp31_ = _tmp30_;
#line 1799 "../src/Views/ImportPage.vala"
		_tmp32_ = g_strdup_printf (ngettext ("Delete these files from camera?", "Delete these %d files from camera?", (gulong) _tmp28_), _tmp31_);
#line 1799 "../src/Views/ImportPage.vala"
		neither_string = _tmp32_;
#line 1803 "../src/Views/ImportPage.vala"
		_tmp33_ = manifest->success;
#line 1803 "../src/Views/ImportPage.vala"
		_tmp34_ = photos_string;
#line 1803 "../src/Views/ImportPage.vala"
		_tmp35_ = videos_string;
#line 1803 "../src/Views/ImportPage.vala"
		_tmp36_ = both_string;
#line 1803 "../src/Views/ImportPage.vala"
		_tmp37_ = neither_string;
#line 1803 "../src/Views/ImportPage.vala"
		_tmp38_ = import_ui_get_media_specific_string ((GeeCollection*) _tmp33_, _tmp34_, _tmp35_, _tmp36_, _tmp37_);
#line 1803 "../src/Views/ImportPage.vala"
		question_string = _tmp38_;
#line 1806 "../src/Views/ImportPage.vala"
		_tmp39_ = question_string;
#line 1806 "../src/Views/ImportPage.vala"
		_tmp40_ = import_ui_question_params_new (_tmp39_, _ ("Delete"), _ ("_Keep"));
#line 1806 "../src/Views/ImportPage.vala"
		question = _tmp40_;
#line 1809 "../src/Views/ImportPage.vala"
		_tmp41_ = question;
#line 1809 "../src/Views/ImportPage.vala"
		if (!import_ui_report_manifest (manifest, FALSE, _tmp41_)) {
#line 1810 "../src/Views/ImportPage.vala"
			_import_ui_question_params_unref0 (question);
#line 1810 "../src/Views/ImportPage.vala"
			_g_free0 (question_string);
#line 1810 "../src/Views/ImportPage.vala"
			_g_free0 (neither_string);
#line 1810 "../src/Views/ImportPage.vala"
			_g_free0 (both_string);
#line 1810 "../src/Views/ImportPage.vala"
			_g_free0 (videos_string);
#line 1810 "../src/Views/ImportPage.vala"
			_g_free0 (photos_string);
#line 1810 "../src/Views/ImportPage.vala"
			_g_object_unref0 (local_ref);
#line 1810 "../src/Views/ImportPage.vala"
			return;
#line 10277 "ImportPage.c"
		}
#line 1789 "../src/Views/ImportPage.vala"
		_import_ui_question_params_unref0 (question);
#line 1789 "../src/Views/ImportPage.vala"
		_g_free0 (question_string);
#line 1789 "../src/Views/ImportPage.vala"
		_g_free0 (neither_string);
#line 1789 "../src/Views/ImportPage.vala"
		_g_free0 (both_string);
#line 1789 "../src/Views/ImportPage.vala"
		_g_free0 (videos_string);
#line 1789 "../src/Views/ImportPage.vala"
		_g_free0 (photos_string);
#line 10291 "ImportPage.c"
	} else {
#line 1812 "../src/Views/ImportPage.vala"
		import_ui_report_manifest (manifest, FALSE, NULL);
#line 1813 "../src/Views/ImportPage.vala"
		_g_object_unref0 (local_ref);
#line 1813 "../src/Views/ImportPage.vala"
		return;
#line 10299 "ImportPage.c"
	}
#line 1818 "../src/Views/ImportPage.vala"
	_tmp42_ = self->priv->import_sources;
#line 1818 "../src/Views/ImportPage.vala"
	_tmp43_ = data_collection_start_marking ((DataCollection*) _tmp42_);
#line 1818 "../src/Views/ImportPage.vala"
	marker = _tmp43_;
#line 10307 "ImportPage.c"
	{
		GeeList* _batch_result_list = NULL;
		GeeList* _tmp44_;
		gint _batch_result_size = 0;
		GeeList* _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		gint _batch_result_index = 0;
#line 1819 "../src/Views/ImportPage.vala"
		_tmp44_ = manifest->success;
#line 1819 "../src/Views/ImportPage.vala"
		_batch_result_list = _tmp44_;
#line 1819 "../src/Views/ImportPage.vala"
		_tmp45_ = _batch_result_list;
#line 1819 "../src/Views/ImportPage.vala"
		_tmp46_ = gee_collection_get_size ((GeeCollection*) _tmp45_);
#line 1819 "../src/Views/ImportPage.vala"
		_tmp47_ = _tmp46_;
#line 1819 "../src/Views/ImportPage.vala"
		_batch_result_size = _tmp47_;
#line 1819 "../src/Views/ImportPage.vala"
		_batch_result_index = -1;
#line 1819 "../src/Views/ImportPage.vala"
		while (TRUE) {
#line 10332 "ImportPage.c"
			gint _tmp48_;
			gint _tmp49_;
			BatchImportResult* batch_result = NULL;
			GeeList* _tmp50_;
			gpointer _tmp51_;
			ImportPageCameraImportJob* job = NULL;
			BatchImportResult* _tmp52_;
			BatchImportJob* _tmp53_;
			ImportPageCameraImportJob* _tmp54_;
			Marker* _tmp55_;
			ImportPageCameraImportJob* _tmp56_;
			ImportSource* _tmp57_;
			ImportSource* _tmp58_;
#line 1819 "../src/Views/ImportPage.vala"
			_batch_result_index = _batch_result_index + 1;
#line 1819 "../src/Views/ImportPage.vala"
			_tmp48_ = _batch_result_index;
#line 1819 "../src/Views/ImportPage.vala"
			_tmp49_ = _batch_result_size;
#line 1819 "../src/Views/ImportPage.vala"
			if (!(_tmp48_ < _tmp49_)) {
#line 1819 "../src/Views/ImportPage.vala"
				break;
#line 10356 "ImportPage.c"
			}
#line 1819 "../src/Views/ImportPage.vala"
			_tmp50_ = _batch_result_list;
#line 1819 "../src/Views/ImportPage.vala"
			_tmp51_ = gee_list_get (_tmp50_, _batch_result_index);
#line 1819 "../src/Views/ImportPage.vala"
			batch_result = (BatchImportResult*) _tmp51_;
#line 1820 "../src/Views/ImportPage.vala"
			_tmp52_ = batch_result;
#line 1820 "../src/Views/ImportPage.vala"
			_tmp53_ = _tmp52_->job;
#line 1820 "../src/Views/ImportPage.vala"
			_tmp54_ = _batch_import_job_ref0 (IMPORT_PAGE_IS_CAMERA_IMPORT_JOB (_tmp53_) ? ((ImportPageCameraImportJob*) _tmp53_) : NULL);
#line 1820 "../src/Views/ImportPage.vala"
			job = _tmp54_;
#line 1822 "../src/Views/ImportPage.vala"
			_tmp55_ = marker;
#line 1822 "../src/Views/ImportPage.vala"
			_tmp56_ = job;
#line 1822 "../src/Views/ImportPage.vala"
			_tmp57_ = import_page_camera_import_job_get_source (_tmp56_);
#line 1822 "../src/Views/ImportPage.vala"
			_tmp58_ = _tmp57_;
#line 1822 "../src/Views/ImportPage.vala"
			marker_mark (_tmp55_, (DataObject*) _tmp58_);
#line 1822 "../src/Views/ImportPage.vala"
			_g_object_unref0 (_tmp58_);
#line 1819 "../src/Views/ImportPage.vala"
			_batch_import_job_unref0 (job);
#line 1819 "../src/Views/ImportPage.vala"
			_batch_import_result_unref0 (batch_result);
#line 10388 "ImportPage.c"
		}
	}
#line 1825 "../src/Views/ImportPage.vala"
	_tmp59_ = app_window_get_instance ();
#line 1825 "../src/Views/ImportPage.vala"
	_tmp60_ = _tmp59_;
#line 1825 "../src/Views/ImportPage.vala"
	_tmp61_ = g_cancellable_new ();
#line 1825 "../src/Views/ImportPage.vala"
	_tmp62_ = _tmp61_;
#line 1825 "../src/Views/ImportPage.vala"
	_tmp63_ = progress_dialog_new ((GtkWindow*) _tmp60_, _ ("Removing photos/videos from camera"), _tmp62_);
#line 1825 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp63_);
#line 1825 "../src/Views/ImportPage.vala"
	_tmp64_ = _tmp63_;
#line 1825 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp62_);
#line 1825 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_tmp60_);
#line 1825 "../src/Views/ImportPage.vala"
	progress = _tmp64_;
#line 1827 "../src/Views/ImportPage.vala"
	_tmp65_ = self->priv->import_sources;
#line 1827 "../src/Views/ImportPage.vala"
	_tmp66_ = marker;
#line 1827 "../src/Views/ImportPage.vala"
	_tmp67_ = progress;
#line 1827 "../src/Views/ImportPage.vala"
	error_count = source_collection_destroy_marked (_tmp65_, _tmp66_, TRUE, _progress_dialog_monitor_progress_monitor, _tmp67_, NULL);
#line 1828 "../src/Views/ImportPage.vala"
	if (error_count > 0) {
#line 10421 "ImportPage.c"
		gchar* error_string = NULL;
		gchar* _tmp68_;
		const gchar* _tmp69_;
#line 1829 "../src/Views/ImportPage.vala"
		_tmp68_ = g_strdup_printf (ngettext ("Unable to delete %d photo/video from the camera due to errors.", "Unable to delete %d photos/videos from the camera due to errors.", (gulong) error_count), error_count);
#line 1829 "../src/Views/ImportPage.vala"
		error_string = _tmp68_;
#line 1833 "../src/Views/ImportPage.vala"
		_tmp69_ = error_string;
#line 1833 "../src/Views/ImportPage.vala"
		app_window_error_message (_tmp69_, NULL, NULL);
#line 1828 "../src/Views/ImportPage.vala"
		_g_free0 (error_string);
#line 10435 "ImportPage.c"
	}
#line 1836 "../src/Views/ImportPage.vala"
	_tmp70_ = progress;
#line 1836 "../src/Views/ImportPage.vala"
	progress_dialog_close (_tmp70_);
#line 1839 "../src/Views/ImportPage.vala"
	_g_object_unref0 (local_ref);
#line 1839 "../src/Views/ImportPage.vala"
	local_ref = NULL;
#line 1780 "../src/Views/ImportPage.vala"
	_g_object_unref0 (progress);
#line 1780 "../src/Views/ImportPage.vala"
	_g_object_unref0 (marker);
#line 1780 "../src/Views/ImportPage.vala"
	_g_object_unref0 (local_ref);
#line 10451 "ImportPage.c"
}

static void
import_page_close_import (ImportPage* self)
{
	int res = 0;
	Camera* _tmp0_;
	GPSpinIdleWrapper* _tmp1_;
	GPContext* _tmp2_;
#line 1842 "../src/Views/ImportPage.vala"
	g_return_if_fail (self != NULL);
#line 1843 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->camera;
#line 1843 "../src/Views/ImportPage.vala"
	_tmp1_ = import_page_spin_idle_context;
#line 1843 "../src/Views/ImportPage.vala"
	_tmp2_ = ((GPContextWrapper*) _tmp1_)->context;
#line 1843 "../src/Views/ImportPage.vala"
	res = gp_camera_exit (_tmp0_, _tmp2_);
#line 1844 "../src/Views/ImportPage.vala"
	if (res != GP_OK) {
#line 10473 "ImportPage.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 1846 "../src/Views/ImportPage.vala"
		_tmp3_ = gp_result_to_full_string (res);
#line 1846 "../src/Views/ImportPage.vala"
		_tmp4_ = _tmp3_;
#line 1846 "../src/Views/ImportPage.vala"
		g_message ("ImportPage.vala:1846: Unable to unlock camera: %s", _tmp4_);
#line 1846 "../src/Views/ImportPage.vala"
		_g_free0 (_tmp4_);
#line 10484 "ImportPage.c"
	}
#line 1849 "../src/Views/ImportPage.vala"
	import_page_update_status (self, FALSE, self->priv->refreshed);
#line 1851 "../src/Views/ImportPage.vala"
	import_page_on_view_changed (self);
#line 10490 "ImportPage.c"
}

static void
import_page_real_set_display_titles (CheckerboardPage* base,
                                     gboolean display)
{
	ImportPage * self;
	GtkToggleAction* action = NULL;
	GtkAction* _tmp0_;
	GtkToggleAction* _tmp1_;
	GtkToggleAction* _tmp2_;
#line 1854 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 1855 "../src/Views/ImportPage.vala"
	CHECKERBOARD_PAGE_CLASS (import_page_parent_class)->set_display_titles (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), display);
#line 1857 "../src/Views/ImportPage.vala"
	_tmp0_ = page_get_action ((Page*) self, "ViewTitle");
#line 1857 "../src/Views/ImportPage.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_toggle_action_get_type ()) ? ((GtkToggleAction*) _tmp0_) : NULL;
#line 1857 "../src/Views/ImportPage.vala"
	if (_tmp1_ == NULL) {
#line 1857 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp0_);
#line 10514 "ImportPage.c"
	}
#line 1857 "../src/Views/ImportPage.vala"
	action = _tmp1_;
#line 1858 "../src/Views/ImportPage.vala"
	_tmp2_ = action;
#line 1858 "../src/Views/ImportPage.vala"
	if (_tmp2_ != NULL) {
#line 10522 "ImportPage.c"
		GtkToggleAction* _tmp3_;
#line 1859 "../src/Views/ImportPage.vala"
		_tmp3_ = action;
#line 1859 "../src/Views/ImportPage.vala"
		gtk_toggle_action_set_active (_tmp3_, display);
#line 10528 "ImportPage.c"
	}
#line 1854 "../src/Views/ImportPage.vala"
	_g_object_unref0 (action);
#line 10532 "ImportPage.c"
}

static gpointer
_view_filter_ref0 (gpointer self)
{
#line 1864 "../src/Views/ImportPage.vala"
	return self ? view_filter_ref (self) : NULL;
#line 10540 "ImportPage.c"
}

static SearchViewFilter*
import_page_real_get_search_view_filter (CheckerboardPage* base)
{
	ImportPage * self;
	ImportPageImportPageSearchViewFilter* _tmp0_;
	SearchViewFilter* _tmp1_;
	SearchViewFilter* result;
#line 1863 "../src/Views/ImportPage.vala"
	self = (ImportPage*) base;
#line 1864 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->search_filter;
#line 1864 "../src/Views/ImportPage.vala"
	_tmp1_ = _view_filter_ref0 ((SearchViewFilter*) _tmp0_);
#line 1864 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 1864 "../src/Views/ImportPage.vala"
	return result;
#line 10560 "ImportPage.c"
}

static inline gpointer
import_page_import_view_manager_get_instance_private (ImportPageImportViewManager* self)
{
	return G_STRUCT_MEMBER_P (self, ImportPageImportViewManager_private_offset);
}

static ImportPageImportViewManager*
import_page_import_view_manager_construct (GType object_type,
                                           ImportPage* owner)
{
	ImportPageImportViewManager* self = NULL;
	ImportPage* _tmp0_;
#line 483 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 483 "../src/Views/ImportPage.vala"
	self = (ImportPageImportViewManager*) view_manager_construct (object_type);
#line 484 "../src/Views/ImportPage.vala"
	_tmp0_ = _g_object_ref0 (owner);
#line 484 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->owner);
#line 484 "../src/Views/ImportPage.vala"
	self->priv->owner = _tmp0_;
#line 483 "../src/Views/ImportPage.vala"
	return self;
#line 10587 "ImportPage.c"
}

static ImportPageImportViewManager*
import_page_import_view_manager_new (ImportPage* owner)
{
#line 483 "../src/Views/ImportPage.vala"
	return import_page_import_view_manager_construct (IMPORT_PAGE_TYPE_IMPORT_VIEW_MANAGER, owner);
#line 10595 "ImportPage.c"
}

static DataView*
import_page_import_view_manager_real_create_view (ViewManager* base,
                                                  DataSource* source)
{
	ImportPageImportViewManager * self;
	ImportPreview* _tmp0_;
	DataView* result;
#line 487 "../src/Views/ImportPage.vala"
	self = (ImportPageImportViewManager*) base;
#line 487 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 488 "../src/Views/ImportPage.vala"
	_tmp0_ = import_preview_new (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_IMPORT_SOURCE, ImportSource));
#line 488 "../src/Views/ImportPage.vala"
	result = (DataView*) _tmp0_;
#line 488 "../src/Views/ImportPage.vala"
	return result;
#line 10615 "ImportPage.c"
}

static void
import_page_import_view_manager_class_init (ImportPageImportViewManagerClass * klass,
                                            gpointer klass_data)
{
#line 480 "../src/Views/ImportPage.vala"
	import_page_import_view_manager_parent_class = g_type_class_peek_parent (klass);
#line 480 "../src/Views/ImportPage.vala"
	((ViewManagerClass *) klass)->finalize = import_page_import_view_manager_finalize;
#line 480 "../src/Views/ImportPage.vala"
	g_type_class_adjust_private_offset (klass, &ImportPageImportViewManager_private_offset);
#line 480 "../src/Views/ImportPage.vala"
	((ViewManagerClass *) klass)->create_view = (DataView* (*) (ViewManager*, DataSource*)) import_page_import_view_manager_real_create_view;
#line 10630 "ImportPage.c"
}

static void
import_page_import_view_manager_instance_init (ImportPageImportViewManager * self,
                                               gpointer klass)
{
#line 480 "../src/Views/ImportPage.vala"
	self->priv = import_page_import_view_manager_get_instance_private (self);
#line 10639 "ImportPage.c"
}

static void
import_page_import_view_manager_finalize (ViewManager * obj)
{
	ImportPageImportViewManager * self;
#line 480 "../src/Views/ImportPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IMPORT_PAGE_TYPE_IMPORT_VIEW_MANAGER, ImportPageImportViewManager);
#line 481 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->owner);
#line 480 "../src/Views/ImportPage.vala"
	VIEW_MANAGER_CLASS (import_page_import_view_manager_parent_class)->finalize (obj);
#line 10652 "ImportPage.c"
}

static GType
import_page_import_view_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImportPageImportViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_page_import_view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportPageImportViewManager), 0, (GInstanceInitFunc) import_page_import_view_manager_instance_init, NULL };
	GType import_page_import_view_manager_type_id;
	import_page_import_view_manager_type_id = g_type_register_static (TYPE_VIEW_MANAGER, "ImportPageImportViewManager", &g_define_type_info, 0);
	ImportPageImportViewManager_private_offset = g_type_add_instance_private (import_page_import_view_manager_type_id, sizeof (ImportPageImportViewManagerPrivate));
	return import_page_import_view_manager_type_id;
}

static GType
import_page_import_view_manager_get_type (void)
{
	static volatile gsize import_page_import_view_manager_type_id__once = 0;
	if (g_once_init_enter (&import_page_import_view_manager_type_id__once)) {
		GType import_page_import_view_manager_type_id;
		import_page_import_view_manager_type_id = import_page_import_view_manager_get_type_once ();
		g_once_init_leave (&import_page_import_view_manager_type_id__once, import_page_import_view_manager_type_id);
	}
	return import_page_import_view_manager_type_id__once;
}

static inline gpointer
import_page_camera_import_job_get_instance_private (ImportPageCameraImportJob* self)
{
	return G_STRUCT_MEMBER_P (self, ImportPageCameraImportJob_private_offset);
}

static gpointer
_gp_context_wrapper_ref0 (gpointer self)
{
#line 510 "../src/Views/ImportPage.vala"
	return self ? gp_context_wrapper_ref (self) : NULL;
#line 10688 "ImportPage.c"
}

static ImportPageCameraImportJob*
import_page_camera_import_job_construct (GType object_type,
                                         GPContextWrapper* context,
                                         ImportSource* import_file,
                                         DuplicatedFile* duplicated_file)
{
	ImportPageCameraImportJob* self = NULL;
	GSettings* _tmp0_;
	GPContextWrapper* _tmp1_;
	ImportSource* _tmp2_;
	DuplicatedFile* _tmp3_;
	Camera* _tmp4_;
	Camera* _tmp5_;
	Camera* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gulong _tmp12_;
	gulong _tmp13_;
	PhotoMetadata* _tmp14_ = NULL;
	PhotoMetadata* _tmp16_;
#line 506 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 506 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (import_file != NULL, NULL);
#line 506 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) batch_import_job_construct (object_type);
#line 508 "../src/Views/ImportPage.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_FILES_PREFS_SCHEMA_NAME);
#line 508 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 508 "../src/Views/ImportPage.vala"
	self->priv->file_settings = _tmp0_;
#line 510 "../src/Views/ImportPage.vala"
	_tmp1_ = _gp_context_wrapper_ref0 (context);
#line 510 "../src/Views/ImportPage.vala"
	_gp_context_wrapper_unref0 (self->priv->context);
#line 510 "../src/Views/ImportPage.vala"
	self->priv->context = _tmp1_;
#line 511 "../src/Views/ImportPage.vala"
	_tmp2_ = _g_object_ref0 (import_file);
#line 511 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->import_file);
#line 511 "../src/Views/ImportPage.vala"
	self->priv->import_file = _tmp2_;
#line 512 "../src/Views/ImportPage.vala"
	_tmp3_ = _g_object_ref0 (duplicated_file);
#line 512 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->duplicated_file);
#line 512 "../src/Views/ImportPage.vala"
	self->priv->duplicated_file = _tmp3_;
#line 515 "../src/Views/ImportPage.vala"
	_tmp4_ = import_source_get_camera (import_file);
#line 515 "../src/Views/ImportPage.vala"
	_tmp5_ = _tmp4_;
#line 515 "../src/Views/ImportPage.vala"
	_tmp6_ = _GPHOTO_REF_CAMERA0 (_tmp5_);
#line 515 "../src/Views/ImportPage.vala"
	_gp_camera_unref0 (self->priv->camera);
#line 515 "../src/Views/ImportPage.vala"
	self->priv->camera = _tmp6_;
#line 516 "../src/Views/ImportPage.vala"
	_tmp7_ = import_source_get_fulldir (import_file);
#line 516 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->fulldir);
#line 516 "../src/Views/ImportPage.vala"
	self->priv->fulldir = _tmp7_;
#line 518 "../src/Views/ImportPage.vala"
	_tmp8_ = self->priv->fulldir;
#line 518 "../src/Views/ImportPage.vala"
	_vala_assert (_tmp8_ != NULL, "fulldir != null");
#line 519 "../src/Views/ImportPage.vala"
	_tmp9_ = import_source_get_filename (import_file);
#line 519 "../src/Views/ImportPage.vala"
	_tmp10_ = _tmp9_;
#line 519 "../src/Views/ImportPage.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 519 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->filename);
#line 519 "../src/Views/ImportPage.vala"
	self->priv->filename = _tmp11_;
#line 520 "../src/Views/ImportPage.vala"
	_tmp12_ = import_source_get_file_size (import_file);
#line 520 "../src/Views/ImportPage.vala"
	_tmp13_ = _tmp12_;
#line 520 "../src/Views/ImportPage.vala"
	self->priv->filesize = (guint64) _tmp13_;
#line 521 "../src/Views/ImportPage.vala"
	if (IS_PHOTO_IMPORT_SOURCE (import_file)) {
#line 10782 "ImportPage.c"
		PhotoMetadata* _tmp15_;
#line 522 "../src/Views/ImportPage.vala"
		_tmp15_ = photo_import_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (import_file, TYPE_PHOTO_IMPORT_SOURCE, PhotoImportSource));
#line 522 "../src/Views/ImportPage.vala"
		_media_metadata_unref0 (_tmp14_);
#line 522 "../src/Views/ImportPage.vala"
		_tmp14_ = _tmp15_;
#line 10790 "ImportPage.c"
	} else {
#line 522 "../src/Views/ImportPage.vala"
		_media_metadata_unref0 (_tmp14_);
#line 522 "../src/Views/ImportPage.vala"
		_tmp14_ = NULL;
#line 10796 "ImportPage.c"
	}
#line 521 "../src/Views/ImportPage.vala"
	_tmp16_ = _media_metadata_ref0 (_tmp14_);
#line 521 "../src/Views/ImportPage.vala"
	_media_metadata_unref0 (self->priv->metadata);
#line 521 "../src/Views/ImportPage.vala"
	self->priv->metadata = _tmp16_;
#line 523 "../src/Views/ImportPage.vala"
	self->priv->exposure_time = import_source_get_exposure_time (import_file);
#line 506 "../src/Views/ImportPage.vala"
	_media_metadata_unref0 (_tmp14_);
#line 506 "../src/Views/ImportPage.vala"
	return self;
#line 10810 "ImportPage.c"
}

static ImportPageCameraImportJob*
import_page_camera_import_job_new (GPContextWrapper* context,
                                   ImportSource* import_file,
                                   DuplicatedFile* duplicated_file)
{
#line 506 "../src/Views/ImportPage.vala"
	return import_page_camera_import_job_construct (IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB, context, import_file, duplicated_file);
#line 10820 "ImportPage.c"
}

static gint64
import_page_camera_import_job_get_exposure_time (ImportPageCameraImportJob* self)
{
	gint64 result;
#line 526 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 527 "../src/Views/ImportPage.vala"
	result = self->priv->exposure_time;
#line 527 "../src/Views/ImportPage.vala"
	return result;
#line 10833 "ImportPage.c"
}

static DuplicatedFile*
import_page_camera_import_job_real_get_duplicated_file (BatchImportJob* base)
{
	ImportPageCameraImportJob * self;
	DuplicatedFile* _tmp0_;
	DuplicatedFile* _tmp1_;
	DuplicatedFile* result;
#line 530 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 531 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->duplicated_file;
#line 531 "../src/Views/ImportPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 531 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 531 "../src/Views/ImportPage.vala"
	return result;
#line 10853 "ImportPage.c"
}

static gint64
import_page_camera_import_job_real_get_exposure_time_override (BatchImportJob* base)
{
	ImportPageCameraImportJob * self;
	gint64 _tmp0_ = 0LL;
	ImportSource* _tmp1_;
	gint64 result;
#line 534 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 535 "../src/Views/ImportPage.vala"
	_tmp1_ = self->priv->import_file;
#line 535 "../src/Views/ImportPage.vala"
	if (IS_VIDEO_IMPORT_SOURCE (_tmp1_)) {
#line 535 "../src/Views/ImportPage.vala"
		_tmp0_ = import_page_camera_import_job_get_exposure_time (self);
#line 10871 "ImportPage.c"
	} else {
#line 535 "../src/Views/ImportPage.vala"
		_tmp0_ = (gint64) 0;
#line 10875 "ImportPage.c"
	}
#line 535 "../src/Views/ImportPage.vala"
	result = _tmp0_;
#line 535 "../src/Views/ImportPage.vala"
	return result;
#line 10881 "ImportPage.c"
}

static gchar*
import_page_camera_import_job_real_get_dest_identifier (BatchImportJob* base)
{
	ImportPageCameraImportJob * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 538 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 539 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->filename;
#line 539 "../src/Views/ImportPage.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 539 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 539 "../src/Views/ImportPage.vala"
	return result;
#line 10901 "ImportPage.c"
}

static gchar*
import_page_camera_import_job_real_get_source_identifier (BatchImportJob* base)
{
	ImportPageCameraImportJob * self;
	ImportSource* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 542 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 543 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->import_file;
#line 543 "../src/Views/ImportPage.vala"
	_tmp1_ = import_source_get_filename (_tmp0_);
#line 543 "../src/Views/ImportPage.vala"
	_tmp2_ = _tmp1_;
#line 543 "../src/Views/ImportPage.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 543 "../src/Views/ImportPage.vala"
	result = _tmp3_;
#line 543 "../src/Views/ImportPage.vala"
	return result;
#line 10927 "ImportPage.c"
}

static gchar*
import_page_camera_import_job_real_get_basename (BatchImportJob* base)
{
	ImportPageCameraImportJob * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 546 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 547 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->filename;
#line 547 "../src/Views/ImportPage.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 547 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 547 "../src/Views/ImportPage.vala"
	return result;
#line 10947 "ImportPage.c"
}

static gchar*
import_page_camera_import_job_real_get_path (BatchImportJob* base)
{
	ImportPageCameraImportJob * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 550 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 551 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->fulldir;
#line 551 "../src/Views/ImportPage.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 551 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 551 "../src/Views/ImportPage.vala"
	return result;
#line 10967 "ImportPage.c"
}

static void
import_page_camera_import_job_real_set_associated (BatchImportJob* base,
                                                   BatchImportJob* associated)
{
	ImportPageCameraImportJob * self;
	ImportPageCameraImportJob* _tmp0_;
#line 554 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 554 "../src/Views/ImportPage.vala"
	g_return_if_fail (associated != NULL);
#line 555 "../src/Views/ImportPage.vala"
	_tmp0_ = _batch_import_job_ref0 (IMPORT_PAGE_IS_CAMERA_IMPORT_JOB (associated) ? ((ImportPageCameraImportJob*) associated) : NULL);
#line 555 "../src/Views/ImportPage.vala"
	_batch_import_job_unref0 (self->priv->associated);
#line 555 "../src/Views/ImportPage.vala"
	self->priv->associated = _tmp0_;
#line 10986 "ImportPage.c"
}

static ImportSource*
import_page_camera_import_job_get_source (ImportPageCameraImportJob* self)
{
	ImportSource* _tmp0_;
	ImportSource* _tmp1_;
	ImportSource* result;
#line 558 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 559 "../src/Views/ImportPage.vala"
	_tmp0_ = self->priv->import_file;
#line 559 "../src/Views/ImportPage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 559 "../src/Views/ImportPage.vala"
	result = _tmp1_;
#line 559 "../src/Views/ImportPage.vala"
	return result;
#line 11005 "ImportPage.c"
}

static gboolean
import_page_camera_import_job_real_is_directory (BatchImportJob* base)
{
	ImportPageCameraImportJob * self;
	gboolean result;
#line 562 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 563 "../src/Views/ImportPage.vala"
	result = FALSE;
#line 563 "../src/Views/ImportPage.vala"
	return result;
#line 11019 "ImportPage.c"
}

static gboolean
import_page_camera_import_job_real_determine_file_size (BatchImportJob* base,
                                                        guint64* filesize,
                                                        GFile** file)
{
	ImportPageCameraImportJob * self;
	guint64 _vala_filesize = 0ULL;
	GFile* _vala_file = NULL;
	gboolean result;
#line 566 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 567 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_vala_file);
#line 567 "../src/Views/ImportPage.vala"
	_vala_file = NULL;
#line 568 "../src/Views/ImportPage.vala"
	_vala_filesize = self->priv->filesize;
#line 570 "../src/Views/ImportPage.vala"
	result = TRUE;
#line 570 "../src/Views/ImportPage.vala"
	if (filesize) {
#line 570 "../src/Views/ImportPage.vala"
		*filesize = _vala_filesize;
#line 11045 "ImportPage.c"
	}
#line 570 "../src/Views/ImportPage.vala"
	if (file) {
#line 570 "../src/Views/ImportPage.vala"
		*file = _vala_file;
#line 11051 "ImportPage.c"
	} else {
#line 570 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_vala_file);
#line 11055 "ImportPage.c"
	}
#line 570 "../src/Views/ImportPage.vala"
	return result;
#line 11059 "ImportPage.c"
}

static gboolean
import_page_camera_import_job_real_prepare (BatchImportJob* base,
                                            GFile** file_to_import,
                                            gboolean* copy_to_library,
                                            GError** error)
{
	ImportPageCameraImportJob * self;
	GFile* _vala_file_to_import = NULL;
	gboolean _vala_copy_to_library = FALSE;
	GFile* dest_file = NULL;
	GFile* _tmp12_;
	GFile* _tmp16_;
	ImportPageCameraImportJob* _tmp25_;
	GFile* _tmp58_;
	GFile* _tmp59_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 573 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 574 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_vala_file_to_import);
#line 574 "../src/Views/ImportPage.vala"
	_vala_file_to_import = NULL;
#line 575 "../src/Views/ImportPage.vala"
	_vala_copy_to_library = FALSE;
#line 577 "../src/Views/ImportPage.vala"
	dest_file = NULL;
#line 11089 "ImportPage.c"
	{
		gboolean collision = FALSE;
		GFile* _tmp0_ = NULL;
		const gchar* _tmp1_;
		PhotoMetadata* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GFile* _tmp4_;
		GFile* _tmp5_;
#line 580 "../src/Views/ImportPage.vala"
		_tmp1_ = self->priv->filename;
#line 580 "../src/Views/ImportPage.vala"
		_tmp2_ = self->priv->metadata;
#line 580 "../src/Views/ImportPage.vala"
		_tmp4_ = library_files_generate_unique_file (_tmp1_, (MediaMetadata*) _tmp2_, self->priv->exposure_time, &_tmp3_, &_inner_error0_);
#line 580 "../src/Views/ImportPage.vala"
		collision = _tmp3_;
#line 580 "../src/Views/ImportPage.vala"
		_tmp0_ = _tmp4_;
#line 580 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11110 "ImportPage.c"
			goto __catch0_g_error;
		}
#line 580 "../src/Views/ImportPage.vala"
		_tmp5_ = _tmp0_;
#line 580 "../src/Views/ImportPage.vala"
		_tmp0_ = NULL;
#line 580 "../src/Views/ImportPage.vala"
		_g_object_unref0 (dest_file);
#line 580 "../src/Views/ImportPage.vala"
		dest_file = _tmp5_;
#line 578 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_tmp0_);
#line 11123 "ImportPage.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		ImportSource* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 578 "../src/Views/ImportPage.vala"
		err = _inner_error0_;
#line 578 "../src/Views/ImportPage.vala"
		_inner_error0_ = NULL;
#line 583 "../src/Views/ImportPage.vala"
		_tmp6_ = self->priv->import_file;
#line 583 "../src/Views/ImportPage.vala"
		_tmp7_ = import_source_get_filename (_tmp6_);
#line 583 "../src/Views/ImportPage.vala"
		_tmp8_ = _tmp7_;
#line 583 "../src/Views/ImportPage.vala"
		_tmp9_ = err;
#line 583 "../src/Views/ImportPage.vala"
		_tmp10_ = _tmp9_->message;
#line 583 "../src/Views/ImportPage.vala"
		g_warning ("ImportPage.vala:583: Unable to generate local file for %s: %s", _tmp8_, _tmp10_);
#line 578 "../src/Views/ImportPage.vala"
		_g_error_free0 (err);
#line 11152 "ImportPage.c"
	}
	__finally0:
#line 578 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11157 "ImportPage.c"
		gboolean _tmp11_ = FALSE;
#line 578 "../src/Views/ImportPage.vala"
		g_propagate_error (error, _inner_error0_);
#line 578 "../src/Views/ImportPage.vala"
		_g_object_unref0 (dest_file);
#line 578 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_vala_file_to_import);
#line 578 "../src/Views/ImportPage.vala"
		return _tmp11_;
#line 11167 "ImportPage.c"
	}
#line 587 "../src/Views/ImportPage.vala"
	_tmp12_ = dest_file;
#line 587 "../src/Views/ImportPage.vala"
	if (_tmp12_ == NULL) {
#line 11173 "ImportPage.c"
		ImportSource* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 588 "../src/Views/ImportPage.vala"
		_tmp13_ = self->priv->import_file;
#line 588 "../src/Views/ImportPage.vala"
		_tmp14_ = import_source_get_filename (_tmp13_);
#line 588 "../src/Views/ImportPage.vala"
		_tmp15_ = _tmp14_;
#line 588 "../src/Views/ImportPage.vala"
		g_message ("ImportPage.vala:588: Unable to generate local file for %s", _tmp15_);
#line 590 "../src/Views/ImportPage.vala"
		result = FALSE;
#line 590 "../src/Views/ImportPage.vala"
		_g_object_unref0 (dest_file);
#line 590 "../src/Views/ImportPage.vala"
		if (file_to_import) {
#line 590 "../src/Views/ImportPage.vala"
			*file_to_import = _vala_file_to_import;
#line 11193 "ImportPage.c"
		} else {
#line 590 "../src/Views/ImportPage.vala"
			_g_object_unref0 (_vala_file_to_import);
#line 11197 "ImportPage.c"
		}
#line 590 "../src/Views/ImportPage.vala"
		if (copy_to_library) {
#line 590 "../src/Views/ImportPage.vala"
			*copy_to_library = _vala_copy_to_library;
#line 11203 "ImportPage.c"
		}
#line 590 "../src/Views/ImportPage.vala"
		return result;
#line 11207 "ImportPage.c"
	}
#line 595 "../src/Views/ImportPage.vala"
	_tmp16_ = dest_file;
#line 595 "../src/Views/ImportPage.vala"
	library_monitor_blacklist_file (_tmp16_, "CameraImportJob.prepare");
#line 11213 "ImportPage.c"
	{
		GPContextWrapper* _tmp17_;
		GPContext* _tmp18_;
		Camera* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GFile* _tmp22_;
#line 597 "../src/Views/ImportPage.vala"
		_tmp17_ = self->priv->context;
#line 597 "../src/Views/ImportPage.vala"
		_tmp18_ = _tmp17_->context;
#line 597 "../src/Views/ImportPage.vala"
		_tmp19_ = self->priv->camera;
#line 597 "../src/Views/ImportPage.vala"
		_tmp20_ = self->priv->fulldir;
#line 597 "../src/Views/ImportPage.vala"
		_tmp21_ = self->priv->filename;
#line 597 "../src/Views/ImportPage.vala"
		_tmp22_ = dest_file;
#line 597 "../src/Views/ImportPage.vala"
		gp_save_image (_tmp18_, _tmp19_, _tmp20_, _tmp21_, _tmp22_, &_inner_error0_);
#line 597 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11237 "ImportPage.c"
			goto __finally1;
		}
	}
	__finally1:
	{
		GError* _inner_error1_ = NULL;
		GFile* _tmp23_;
#line 599 "../src/Views/ImportPage.vala"
		_tmp23_ = dest_file;
#line 599 "../src/Views/ImportPage.vala"
		library_monitor_unblacklist_file (_tmp23_);
#line 11249 "ImportPage.c"
	}
#line 596 "../src/Views/ImportPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11253 "ImportPage.c"
		gboolean _tmp24_ = FALSE;
#line 596 "../src/Views/ImportPage.vala"
		g_propagate_error (error, _inner_error0_);
#line 596 "../src/Views/ImportPage.vala"
		_g_object_unref0 (dest_file);
#line 596 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_vala_file_to_import);
#line 596 "../src/Views/ImportPage.vala"
		return _tmp24_;
#line 11263 "ImportPage.c"
	}
#line 603 "../src/Views/ImportPage.vala"
	_tmp25_ = self->priv->associated;
#line 603 "../src/Views/ImportPage.vala"
	if (_tmp25_ != NULL) {
#line 11269 "ImportPage.c"
		BackingPhotoRow* _tmp41_;
		GFile* assoc_dest = NULL;
		BackingPhotoRow* _tmp44_;
		const gchar* _tmp45_;
		GFile* _tmp46_;
		GFile* _tmp47_;
		{
			BackingPhotoRow* _tmp26_ = NULL;
			GFile* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			ImportPageCameraImportJob* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			BackingPhotoRow* _tmp33_;
			BackingPhotoRow* _tmp34_;
			BackingPhotoRow* _tmp35_;
#line 606 "../src/Views/ImportPage.vala"
			_tmp27_ = dest_file;
#line 606 "../src/Views/ImportPage.vala"
			_tmp28_ = g_file_get_path (_tmp27_);
#line 606 "../src/Views/ImportPage.vala"
			_tmp29_ = _tmp28_;
#line 606 "../src/Views/ImportPage.vala"
			_tmp30_ = self->priv->associated;
#line 606 "../src/Views/ImportPage.vala"
			_tmp31_ = batch_import_job_get_basename ((BatchImportJob*) _tmp30_);
#line 606 "../src/Views/ImportPage.vala"
			_tmp32_ = _tmp31_;
#line 606 "../src/Views/ImportPage.vala"
			_tmp33_ = raw_developer_create_backing_row_for_development (RAW_DEVELOPER_CAMERA, _tmp29_, _tmp32_, &_inner_error0_);
#line 606 "../src/Views/ImportPage.vala"
			_tmp34_ = _tmp33_;
#line 606 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp32_);
#line 606 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp29_);
#line 606 "../src/Views/ImportPage.vala"
			_tmp26_ = _tmp34_;
#line 606 "../src/Views/ImportPage.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11311 "ImportPage.c"
				goto __catch2_g_error;
			}
#line 605 "../src/Views/ImportPage.vala"
			_tmp35_ = _tmp26_;
#line 605 "../src/Views/ImportPage.vala"
			_tmp26_ = NULL;
#line 605 "../src/Views/ImportPage.vala"
			_backing_photo_row_unref0 (self->priv->associated_file);
#line 605 "../src/Views/ImportPage.vala"
			self->priv->associated_file = _tmp35_;
#line 604 "../src/Views/ImportPage.vala"
			_backing_photo_row_unref0 (_tmp26_);
#line 11324 "ImportPage.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* err = NULL;
			ImportPageCameraImportJob* _tmp36_;
			const gchar* _tmp37_;
			GError* _tmp38_;
			const gchar* _tmp39_;
#line 604 "../src/Views/ImportPage.vala"
			err = _inner_error0_;
#line 604 "../src/Views/ImportPage.vala"
			_inner_error0_ = NULL;
#line 609 "../src/Views/ImportPage.vala"
			_tmp36_ = self->priv->associated;
#line 609 "../src/Views/ImportPage.vala"
			_tmp37_ = _tmp36_->priv->filename;
#line 609 "../src/Views/ImportPage.vala"
			_tmp38_ = err;
#line 609 "../src/Views/ImportPage.vala"
			_tmp39_ = _tmp38_->message;
#line 609 "../src/Views/ImportPage.vala"
			g_warning ("ImportPage.vala:609: Unable to generate backing associated file for %s" \
": %s", _tmp37_, _tmp39_);
#line 604 "../src/Views/ImportPage.vala"
			_g_error_free0 (err);
#line 11350 "ImportPage.c"
		}
		__finally2:
#line 604 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11355 "ImportPage.c"
			gboolean _tmp40_ = FALSE;
#line 604 "../src/Views/ImportPage.vala"
			g_propagate_error (error, _inner_error0_);
#line 604 "../src/Views/ImportPage.vala"
			_g_object_unref0 (dest_file);
#line 604 "../src/Views/ImportPage.vala"
			_g_object_unref0 (_vala_file_to_import);
#line 604 "../src/Views/ImportPage.vala"
			return _tmp40_;
#line 11365 "ImportPage.c"
		}
#line 613 "../src/Views/ImportPage.vala"
		_tmp41_ = self->priv->associated_file;
#line 613 "../src/Views/ImportPage.vala"
		if (_tmp41_ == NULL) {
#line 11371 "ImportPage.c"
			ImportPageCameraImportJob* _tmp42_;
			const gchar* _tmp43_;
#line 614 "../src/Views/ImportPage.vala"
			_tmp42_ = self->priv->associated;
#line 614 "../src/Views/ImportPage.vala"
			_tmp43_ = _tmp42_->priv->filename;
#line 614 "../src/Views/ImportPage.vala"
			g_message ("ImportPage.vala:614: Unable to generate backing associated file for %s", _tmp43_);
#line 615 "../src/Views/ImportPage.vala"
			result = FALSE;
#line 615 "../src/Views/ImportPage.vala"
			_g_object_unref0 (dest_file);
#line 615 "../src/Views/ImportPage.vala"
			if (file_to_import) {
#line 615 "../src/Views/ImportPage.vala"
				*file_to_import = _vala_file_to_import;
#line 11388 "ImportPage.c"
			} else {
#line 615 "../src/Views/ImportPage.vala"
				_g_object_unref0 (_vala_file_to_import);
#line 11392 "ImportPage.c"
			}
#line 615 "../src/Views/ImportPage.vala"
			if (copy_to_library) {
#line 615 "../src/Views/ImportPage.vala"
				*copy_to_library = _vala_copy_to_library;
#line 11398 "ImportPage.c"
			}
#line 615 "../src/Views/ImportPage.vala"
			return result;
#line 11402 "ImportPage.c"
		}
#line 618 "../src/Views/ImportPage.vala"
		_tmp44_ = self->priv->associated_file;
#line 618 "../src/Views/ImportPage.vala"
		_tmp45_ = _tmp44_->filepath;
#line 618 "../src/Views/ImportPage.vala"
		_tmp46_ = g_file_new_for_path (_tmp45_);
#line 618 "../src/Views/ImportPage.vala"
		assoc_dest = _tmp46_;
#line 619 "../src/Views/ImportPage.vala"
		_tmp47_ = assoc_dest;
#line 619 "../src/Views/ImportPage.vala"
		library_monitor_blacklist_file (_tmp47_, "CameraImportJob.prepare");
#line 11416 "ImportPage.c"
		{
			GPContextWrapper* _tmp48_;
			GPContext* _tmp49_;
			Camera* _tmp50_;
			ImportPageCameraImportJob* _tmp51_;
			const gchar* _tmp52_;
			ImportPageCameraImportJob* _tmp53_;
			const gchar* _tmp54_;
			GFile* _tmp55_;
#line 621 "../src/Views/ImportPage.vala"
			_tmp48_ = self->priv->context;
#line 621 "../src/Views/ImportPage.vala"
			_tmp49_ = _tmp48_->context;
#line 621 "../src/Views/ImportPage.vala"
			_tmp50_ = self->priv->camera;
#line 621 "../src/Views/ImportPage.vala"
			_tmp51_ = self->priv->associated;
#line 621 "../src/Views/ImportPage.vala"
			_tmp52_ = _tmp51_->priv->fulldir;
#line 621 "../src/Views/ImportPage.vala"
			_tmp53_ = self->priv->associated;
#line 621 "../src/Views/ImportPage.vala"
			_tmp54_ = _tmp53_->priv->filename;
#line 621 "../src/Views/ImportPage.vala"
			_tmp55_ = assoc_dest;
#line 621 "../src/Views/ImportPage.vala"
			gp_save_image (_tmp49_, _tmp50_, _tmp52_, _tmp54_, _tmp55_, &_inner_error0_);
#line 621 "../src/Views/ImportPage.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11446 "ImportPage.c"
				goto __finally3;
			}
		}
		__finally3:
		{
			GError* _inner_error1_ = NULL;
			GFile* _tmp56_;
#line 624 "../src/Views/ImportPage.vala"
			_tmp56_ = assoc_dest;
#line 624 "../src/Views/ImportPage.vala"
			library_monitor_unblacklist_file (_tmp56_);
#line 11458 "ImportPage.c"
		}
#line 620 "../src/Views/ImportPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11462 "ImportPage.c"
			gboolean _tmp57_ = FALSE;
#line 620 "../src/Views/ImportPage.vala"
			g_propagate_error (error, _inner_error0_);
#line 620 "../src/Views/ImportPage.vala"
			_g_object_unref0 (assoc_dest);
#line 620 "../src/Views/ImportPage.vala"
			_g_object_unref0 (dest_file);
#line 620 "../src/Views/ImportPage.vala"
			_g_object_unref0 (_vala_file_to_import);
#line 620 "../src/Views/ImportPage.vala"
			return _tmp57_;
#line 11474 "ImportPage.c"
		}
#line 603 "../src/Views/ImportPage.vala"
		_g_object_unref0 (assoc_dest);
#line 11478 "ImportPage.c"
	}
#line 628 "../src/Views/ImportPage.vala"
	_tmp58_ = dest_file;
#line 628 "../src/Views/ImportPage.vala"
	_tmp59_ = _g_object_ref0 (_tmp58_);
#line 628 "../src/Views/ImportPage.vala"
	_g_object_unref0 (_vala_file_to_import);
#line 628 "../src/Views/ImportPage.vala"
	_vala_file_to_import = _tmp59_;
#line 629 "../src/Views/ImportPage.vala"
	_vala_copy_to_library = FALSE;
#line 631 "../src/Views/ImportPage.vala"
	result = TRUE;
#line 631 "../src/Views/ImportPage.vala"
	_g_object_unref0 (dest_file);
#line 631 "../src/Views/ImportPage.vala"
	if (file_to_import) {
#line 631 "../src/Views/ImportPage.vala"
		*file_to_import = _vala_file_to_import;
#line 11498 "ImportPage.c"
	} else {
#line 631 "../src/Views/ImportPage.vala"
		_g_object_unref0 (_vala_file_to_import);
#line 11502 "ImportPage.c"
	}
#line 631 "../src/Views/ImportPage.vala"
	if (copy_to_library) {
#line 631 "../src/Views/ImportPage.vala"
		*copy_to_library = _vala_copy_to_library;
#line 11508 "ImportPage.c"
	}
#line 631 "../src/Views/ImportPage.vala"
	return result;
#line 11512 "ImportPage.c"
}

static gboolean
import_page_camera_import_job_real_complete (BatchImportJob* base,
                                             MediaSource* source,
                                             BatchImportRoll* import_roll,
                                             GError** error)
{
	ImportPageCameraImportJob * self;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 634 "../src/Views/ImportPage.vala"
	self = (ImportPageCameraImportJob*) base;
#line 634 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 634 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (import_roll != NULL, FALSE);
#line 635 "../src/Views/ImportPage.vala"
	ret = FALSE;
#line 636 "../src/Views/ImportPage.vala"
	if (IS_PHOTO (source)) {
#line 11535 "ImportPage.c"
		Photo* photo = NULL;
		Photo* _tmp0_;
		BackingPhotoRow* _tmp1_;
#line 637 "../src/Views/ImportPage.vala"
		_tmp0_ = _g_object_ref0 (IS_PHOTO (source) ? ((Photo*) source) : NULL);
#line 637 "../src/Views/ImportPage.vala"
		photo = _tmp0_;
#line 640 "../src/Views/ImportPage.vala"
		_tmp1_ = self->priv->associated_file;
#line 640 "../src/Views/ImportPage.vala"
		if (_tmp1_ != NULL) {
#line 11547 "ImportPage.c"
			Photo* _tmp2_;
			BackingPhotoRow* _tmp3_;
			Photo* _tmp5_;
			GSettings* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 641 "../src/Views/ImportPage.vala"
			_tmp2_ = photo;
#line 641 "../src/Views/ImportPage.vala"
			_tmp3_ = self->priv->associated_file;
#line 641 "../src/Views/ImportPage.vala"
			photo_add_backing_photo_for_development (_tmp2_, RAW_DEVELOPER_CAMERA, _tmp3_, &_inner_error0_);
#line 641 "../src/Views/ImportPage.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11562 "ImportPage.c"
				gboolean _tmp4_ = FALSE;
#line 641 "../src/Views/ImportPage.vala"
				g_propagate_error (error, _inner_error0_);
#line 641 "../src/Views/ImportPage.vala"
				_g_object_unref0 (photo);
#line 641 "../src/Views/ImportPage.vala"
				return _tmp4_;
#line 11570 "ImportPage.c"
			}
#line 642 "../src/Views/ImportPage.vala"
			ret = TRUE;
#line 643 "../src/Views/ImportPage.vala"
			_tmp5_ = photo;
#line 643 "../src/Views/ImportPage.vala"
			_tmp6_ = self->priv->file_settings;
#line 643 "../src/Views/ImportPage.vala"
			_tmp7_ = g_settings_get_string (_tmp6_, "raw-developer-default");
#line 643 "../src/Views/ImportPage.vala"
			_tmp8_ = _tmp7_;
#line 643 "../src/Views/ImportPage.vala"
			photo_set_raw_developer (_tmp5_, raw_developer_from_string (_tmp8_));
#line 643 "../src/Views/ImportPage.vala"
			_g_free0 (_tmp8_);
#line 11586 "ImportPage.c"
		}
#line 636 "../src/Views/ImportPage.vala"
		_g_object_unref0 (photo);
#line 11590 "ImportPage.c"
	}
#line 648 "../src/Views/ImportPage.vala"
	result = ret;
#line 648 "../src/Views/ImportPage.vala"
	return result;
#line 11596 "ImportPage.c"
}

static void
import_page_camera_import_job_class_init (ImportPageCameraImportJobClass * klass,
                                          gpointer klass_data)
{
#line 492 "../src/Views/ImportPage.vala"
	import_page_camera_import_job_parent_class = g_type_class_peek_parent (klass);
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->finalize = import_page_camera_import_job_finalize;
#line 492 "../src/Views/ImportPage.vala"
	g_type_class_adjust_private_offset (klass, &ImportPageCameraImportJob_private_offset);
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->get_duplicated_file = (DuplicatedFile* (*) (BatchImportJob*)) import_page_camera_import_job_real_get_duplicated_file;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->get_exposure_time_override = (gint64 (*) (BatchImportJob*)) import_page_camera_import_job_real_get_exposure_time_override;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->get_dest_identifier = (gchar* (*) (BatchImportJob*)) import_page_camera_import_job_real_get_dest_identifier;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->get_source_identifier = (gchar* (*) (BatchImportJob*)) import_page_camera_import_job_real_get_source_identifier;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->get_basename = (gchar* (*) (BatchImportJob*)) import_page_camera_import_job_real_get_basename;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->get_path = (gchar* (*) (BatchImportJob*)) import_page_camera_import_job_real_get_path;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->set_associated = (void (*) (BatchImportJob*, BatchImportJob*)) import_page_camera_import_job_real_set_associated;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->is_directory = (gboolean (*) (BatchImportJob*)) import_page_camera_import_job_real_is_directory;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->determine_file_size = (gboolean (*) (BatchImportJob*, guint64*, GFile**)) import_page_camera_import_job_real_determine_file_size;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->prepare = (gboolean (*) (BatchImportJob*, GFile**, gboolean*, GError**)) import_page_camera_import_job_real_prepare;
#line 492 "../src/Views/ImportPage.vala"
	((BatchImportJobClass *) klass)->complete = (gboolean (*) (BatchImportJob*, MediaSource*, BatchImportRoll*, GError**)) import_page_camera_import_job_real_complete;
#line 11631 "ImportPage.c"
}

static void
import_page_camera_import_job_instance_init (ImportPageCameraImportJob * self,
                                             gpointer klass)
{
#line 492 "../src/Views/ImportPage.vala"
	self->priv = import_page_camera_import_job_get_instance_private (self);
#line 501 "../src/Views/ImportPage.vala"
	self->priv->associated = NULL;
#line 502 "../src/Views/ImportPage.vala"
	self->priv->associated_file = NULL;
#line 11644 "ImportPage.c"
}

static void
import_page_camera_import_job_finalize (BatchImportJob * obj)
{
	ImportPageCameraImportJob * self;
#line 492 "../src/Views/ImportPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IMPORT_PAGE_TYPE_CAMERA_IMPORT_JOB, ImportPageCameraImportJob);
#line 493 "../src/Views/ImportPage.vala"
	_gp_context_wrapper_unref0 (self->priv->context);
#line 494 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->import_file);
#line 495 "../src/Views/ImportPage.vala"
	_gp_camera_unref0 (self->priv->camera);
#line 496 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->fulldir);
#line 497 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->filename);
#line 499 "../src/Views/ImportPage.vala"
	_media_metadata_unref0 (self->priv->metadata);
#line 501 "../src/Views/ImportPage.vala"
	_batch_import_job_unref0 (self->priv->associated);
#line 502 "../src/Views/ImportPage.vala"
	_backing_photo_row_unref0 (self->priv->associated_file);
#line 503 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->duplicated_file);
#line 504 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 492 "../src/Views/ImportPage.vala"
	BATCH_IMPORT_JOB_CLASS (import_page_camera_import_job_parent_class)->finalize (obj);
#line 11675 "ImportPage.c"
}

static GType
import_page_camera_import_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImportPageCameraImportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_page_camera_import_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportPageCameraImportJob), 0, (GInstanceInitFunc) import_page_camera_import_job_instance_init, NULL };
	GType import_page_camera_import_job_type_id;
	import_page_camera_import_job_type_id = g_type_register_static (TYPE_BATCH_IMPORT_JOB, "ImportPageCameraImportJob", &g_define_type_info, 0);
	ImportPageCameraImportJob_private_offset = g_type_add_instance_private (import_page_camera_import_job_type_id, sizeof (ImportPageCameraImportJobPrivate));
	return import_page_camera_import_job_type_id;
}

static GType
import_page_camera_import_job_get_type (void)
{
	static volatile gsize import_page_camera_import_job_type_id__once = 0;
	if (g_once_init_enter (&import_page_camera_import_job_type_id__once)) {
		GType import_page_camera_import_job_type_id;
		import_page_camera_import_job_type_id = import_page_camera_import_job_get_type_once ();
		g_once_init_leave (&import_page_camera_import_job_type_id__once, import_page_camera_import_job_type_id);
	}
	return import_page_camera_import_job_type_id__once;
}

static guint
import_page_import_page_search_view_filter_real_get_criteria (SearchViewFilter* base)
{
	ImportPageImportPageSearchViewFilter * self;
	guint result;
#line 653 "../src/Views/ImportPage.vala"
	self = (ImportPageImportPageSearchViewFilter*) base;
#line 654 "../src/Views/ImportPage.vala"
	result = (guint) (SEARCH_FILTER_CRITERIA_TEXT | SEARCH_FILTER_CRITERIA_MEDIA);
#line 654 "../src/Views/ImportPage.vala"
	return result;
#line 11711 "ImportPage.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 11730 "ImportPage.c"
}

static gboolean
import_page_import_page_search_view_filter_real_predicate (ViewFilter* base,
                                                           DataView* view)
{
	ImportPageImportPageSearchViewFilter * self;
	ImportSource* source = NULL;
	ImportSource* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 657 "../src/Views/ImportPage.vala"
	self = (ImportPageImportPageSearchViewFilter*) base;
#line 657 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 658 "../src/Views/ImportPage.vala"
	_tmp0_ = import_preview_get_import_source (G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_IMPORT_PREVIEW, ImportPreview));
#line 658 "../src/Views/ImportPage.vala"
	source = _tmp0_;
#line 661 "../src/Views/ImportPage.vala"
	if ((gboolean) (SEARCH_FILTER_CRITERIA_MEDIA & search_view_filter_get_criteria ((SearchViewFilter*) self))) {
#line 661 "../src/Views/ImportPage.vala"
		_tmp1_ = search_view_filter_filter_by_media_type ((SearchViewFilter*) self);
#line 11754 "ImportPage.c"
	} else {
#line 661 "../src/Views/ImportPage.vala"
		_tmp1_ = FALSE;
#line 11758 "ImportPage.c"
	}
#line 661 "../src/Views/ImportPage.vala"
	if (_tmp1_) {
#line 11762 "ImportPage.c"
		ImportSource* _tmp2_;
#line 662 "../src/Views/ImportPage.vala"
		_tmp2_ = source;
#line 662 "../src/Views/ImportPage.vala"
		if (IS_VIDEO_IMPORT_SOURCE (_tmp2_)) {
#line 11768 "ImportPage.c"
			gboolean _tmp3_;
			gboolean _tmp4_;
#line 663 "../src/Views/ImportPage.vala"
			_tmp3_ = search_view_filter_get_show_media_video ((SearchViewFilter*) self);
#line 663 "../src/Views/ImportPage.vala"
			_tmp4_ = _tmp3_;
#line 663 "../src/Views/ImportPage.vala"
			if (!_tmp4_) {
#line 664 "../src/Views/ImportPage.vala"
				result = FALSE;
#line 664 "../src/Views/ImportPage.vala"
				_g_object_unref0 (source);
#line 664 "../src/Views/ImportPage.vala"
				return result;
#line 11783 "ImportPage.c"
			}
		} else {
			ImportSource* _tmp5_;
#line 665 "../src/Views/ImportPage.vala"
			_tmp5_ = source;
#line 665 "../src/Views/ImportPage.vala"
			if (IS_PHOTO_IMPORT_SOURCE (_tmp5_)) {
#line 11791 "ImportPage.c"
				PhotoImportSource* photo = NULL;
				ImportSource* _tmp6_;
				PhotoImportSource* _tmp7_;
				PhotoImportSource* _tmp8_;
#line 666 "../src/Views/ImportPage.vala"
				_tmp6_ = source;
#line 666 "../src/Views/ImportPage.vala"
				_tmp7_ = _g_object_ref0 (IS_PHOTO_IMPORT_SOURCE (_tmp6_) ? ((PhotoImportSource*) _tmp6_) : NULL);
#line 666 "../src/Views/ImportPage.vala"
				photo = _tmp7_;
#line 667 "../src/Views/ImportPage.vala"
				_tmp8_ = photo;
#line 667 "../src/Views/ImportPage.vala"
				if (photo_import_source_get_file_format (_tmp8_) == PHOTO_FILE_FORMAT_RAW) {
#line 11806 "ImportPage.c"
					PhotoImportSource* _tmp9_;
					PhotoImportSource* _tmp10_;
					PhotoImportSource* _tmp11_;
					gboolean _tmp12_;
#line 668 "../src/Views/ImportPage.vala"
					_tmp9_ = photo;
#line 668 "../src/Views/ImportPage.vala"
					_tmp10_ = photo_import_source_get_associated (_tmp9_);
#line 668 "../src/Views/ImportPage.vala"
					_tmp11_ = _tmp10_;
#line 668 "../src/Views/ImportPage.vala"
					_tmp12_ = _tmp11_ != NULL;
#line 668 "../src/Views/ImportPage.vala"
					_g_object_unref0 (_tmp11_);
#line 668 "../src/Views/ImportPage.vala"
					if (_tmp12_) {
#line 11823 "ImportPage.c"
						gboolean _tmp13_ = FALSE;
						gboolean _tmp14_;
						gboolean _tmp15_;
#line 669 "../src/Views/ImportPage.vala"
						_tmp14_ = search_view_filter_get_show_media_photos ((SearchViewFilter*) self);
#line 669 "../src/Views/ImportPage.vala"
						_tmp15_ = _tmp14_;
#line 669 "../src/Views/ImportPage.vala"
						if (!_tmp15_) {
#line 11833 "ImportPage.c"
							gboolean _tmp16_;
							gboolean _tmp17_;
#line 669 "../src/Views/ImportPage.vala"
							_tmp16_ = search_view_filter_get_show_media_raw ((SearchViewFilter*) self);
#line 669 "../src/Views/ImportPage.vala"
							_tmp17_ = _tmp16_;
#line 669 "../src/Views/ImportPage.vala"
							_tmp13_ = !_tmp17_;
#line 11842 "ImportPage.c"
						} else {
#line 669 "../src/Views/ImportPage.vala"
							_tmp13_ = FALSE;
#line 11846 "ImportPage.c"
						}
#line 669 "../src/Views/ImportPage.vala"
						if (_tmp13_) {
#line 670 "../src/Views/ImportPage.vala"
							result = FALSE;
#line 670 "../src/Views/ImportPage.vala"
							_g_object_unref0 (photo);
#line 670 "../src/Views/ImportPage.vala"
							_g_object_unref0 (source);
#line 670 "../src/Views/ImportPage.vala"
							return result;
#line 11858 "ImportPage.c"
						}
					} else {
						gboolean _tmp18_;
						gboolean _tmp19_;
#line 671 "../src/Views/ImportPage.vala"
						_tmp18_ = search_view_filter_get_show_media_raw ((SearchViewFilter*) self);
#line 671 "../src/Views/ImportPage.vala"
						_tmp19_ = _tmp18_;
#line 671 "../src/Views/ImportPage.vala"
						if (!_tmp19_) {
#line 672 "../src/Views/ImportPage.vala"
							result = FALSE;
#line 672 "../src/Views/ImportPage.vala"
							_g_object_unref0 (photo);
#line 672 "../src/Views/ImportPage.vala"
							_g_object_unref0 (source);
#line 672 "../src/Views/ImportPage.vala"
							return result;
#line 11877 "ImportPage.c"
						}
					}
				} else {
					gboolean _tmp20_;
					gboolean _tmp21_;
#line 674 "../src/Views/ImportPage.vala"
					_tmp20_ = search_view_filter_get_show_media_photos ((SearchViewFilter*) self);
#line 674 "../src/Views/ImportPage.vala"
					_tmp21_ = _tmp20_;
#line 674 "../src/Views/ImportPage.vala"
					if (!_tmp21_) {
#line 675 "../src/Views/ImportPage.vala"
						result = FALSE;
#line 675 "../src/Views/ImportPage.vala"
						_g_object_unref0 (photo);
#line 675 "../src/Views/ImportPage.vala"
						_g_object_unref0 (source);
#line 675 "../src/Views/ImportPage.vala"
						return result;
#line 11897 "ImportPage.c"
					}
				}
#line 665 "../src/Views/ImportPage.vala"
				_g_object_unref0 (photo);
#line 11902 "ImportPage.c"
			}
		}
	}
#line 679 "../src/Views/ImportPage.vala"
	if ((gboolean) (SEARCH_FILTER_CRITERIA_TEXT & search_view_filter_get_criteria ((SearchViewFilter*) self))) {
#line 11908 "ImportPage.c"
		const gchar* keywords = NULL;
		ImportSource* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		gint _tmp25_ = 0;
		gchar** _tmp26_;
#line 680 "../src/Views/ImportPage.vala"
		_tmp22_ = source;
#line 680 "../src/Views/ImportPage.vala"
		_tmp23_ = indexable_get_indexable_keywords ((Indexable*) _tmp22_);
#line 680 "../src/Views/ImportPage.vala"
		keywords = _tmp23_;
#line 681 "../src/Views/ImportPage.vala"
		_tmp24_ = keywords;
#line 681 "../src/Views/ImportPage.vala"
		if (is_string_empty (_tmp24_)) {
#line 682 "../src/Views/ImportPage.vala"
			result = FALSE;
#line 682 "../src/Views/ImportPage.vala"
			_g_object_unref0 (source);
#line 682 "../src/Views/ImportPage.vala"
			return result;
#line 11931 "ImportPage.c"
		}
#line 685 "../src/Views/ImportPage.vala"
		_tmp26_ = search_view_filter_get_search_filter_words ((SearchViewFilter*) self, &_tmp25_);
#line 11935 "ImportPage.c"
		{
			gchar** word_collection = NULL;
			gint word_collection_length1 = 0;
			gint _word_collection_size_ = 0;
			gint word_it = 0;
#line 685 "../src/Views/ImportPage.vala"
			word_collection = _tmp26_;
#line 685 "../src/Views/ImportPage.vala"
			word_collection_length1 = _tmp25_;
#line 685 "../src/Views/ImportPage.vala"
			for (word_it = 0; word_it < word_collection_length1; word_it = word_it + 1) {
#line 11947 "ImportPage.c"
				const gchar* word = NULL;
#line 685 "../src/Views/ImportPage.vala"
				word = word_collection[word_it];
#line 11951 "ImportPage.c"
				{
					const gchar* _tmp27_;
					const gchar* _tmp28_;
#line 686 "../src/Views/ImportPage.vala"
					_tmp27_ = keywords;
#line 686 "../src/Views/ImportPage.vala"
					_tmp28_ = word;
#line 686 "../src/Views/ImportPage.vala"
					if (!string_contains (_tmp27_, _tmp28_)) {
#line 687 "../src/Views/ImportPage.vala"
						result = FALSE;
#line 687 "../src/Views/ImportPage.vala"
						_g_object_unref0 (source);
#line 687 "../src/Views/ImportPage.vala"
						return result;
#line 11967 "ImportPage.c"
					}
				}
			}
		}
	}
#line 691 "../src/Views/ImportPage.vala"
	result = TRUE;
#line 691 "../src/Views/ImportPage.vala"
	_g_object_unref0 (source);
#line 691 "../src/Views/ImportPage.vala"
	return result;
#line 11979 "ImportPage.c"
}

static ImportPageImportPageSearchViewFilter*
import_page_import_page_search_view_filter_construct (GType object_type)
{
	ImportPageImportPageSearchViewFilter* self = NULL;
#line 652 "../src/Views/ImportPage.vala"
	self = (ImportPageImportPageSearchViewFilter*) search_view_filter_construct (object_type);
#line 652 "../src/Views/ImportPage.vala"
	return self;
#line 11990 "ImportPage.c"
}

static ImportPageImportPageSearchViewFilter*
import_page_import_page_search_view_filter_new (void)
{
#line 652 "../src/Views/ImportPage.vala"
	return import_page_import_page_search_view_filter_construct (IMPORT_PAGE_TYPE_IMPORT_PAGE_SEARCH_VIEW_FILTER);
#line 11998 "ImportPage.c"
}

static void
import_page_import_page_search_view_filter_class_init (ImportPageImportPageSearchViewFilterClass * klass,
                                                       gpointer klass_data)
{
#line 652 "../src/Views/ImportPage.vala"
	import_page_import_page_search_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 652 "../src/Views/ImportPage.vala"
	((SearchViewFilterClass *) klass)->get_criteria = (guint (*) (SearchViewFilter*)) import_page_import_page_search_view_filter_real_get_criteria;
#line 652 "../src/Views/ImportPage.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) import_page_import_page_search_view_filter_real_predicate;
#line 12011 "ImportPage.c"
}

static void
import_page_import_page_search_view_filter_instance_init (ImportPageImportPageSearchViewFilter * self,
                                                          gpointer klass)
{
}

static GType
import_page_import_page_search_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImportPageImportPageSearchViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_page_import_page_search_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportPageImportPageSearchViewFilter), 0, (GInstanceInitFunc) import_page_import_page_search_view_filter_instance_init, NULL };
	GType import_page_import_page_search_view_filter_type_id;
	import_page_import_page_search_view_filter_type_id = g_type_register_static (TYPE_SEARCH_VIEW_FILTER, "ImportPageImportPageSearchViewFilter", &g_define_type_info, 0);
	return import_page_import_page_search_view_filter_type_id;
}

static GType
import_page_import_page_search_view_filter_get_type (void)
{
	static volatile gsize import_page_import_page_search_view_filter_type_id__once = 0;
	if (g_once_init_enter (&import_page_import_page_search_view_filter_type_id__once)) {
		GType import_page_import_page_search_view_filter_type_id;
		import_page_import_page_search_view_filter_type_id = import_page_import_page_search_view_filter_get_type_once ();
		g_once_init_leave (&import_page_import_page_search_view_filter_type_id__once, import_page_import_page_search_view_filter_type_id);
	}
	return import_page_import_page_search_view_filter_type_id__once;
}

static gboolean
import_page_hide_imported_view_filter_real_predicate (ViewFilter* base,
                                                      DataView* view)
{
	ImportPageHideImportedViewFilter * self;
	gboolean result;
#line 697 "../src/Views/ImportPage.vala"
	self = (ImportPageHideImportedViewFilter*) base;
#line 697 "../src/Views/ImportPage.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 698 "../src/Views/ImportPage.vala"
	result = !import_preview_is_already_imported (G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_IMPORT_PREVIEW, ImportPreview));
#line 698 "../src/Views/ImportPage.vala"
	return result;
#line 12055 "ImportPage.c"
}

static ImportPageHideImportedViewFilter*
import_page_hide_imported_view_filter_construct (GType object_type)
{
	ImportPageHideImportedViewFilter* self = NULL;
#line 696 "../src/Views/ImportPage.vala"
	self = (ImportPageHideImportedViewFilter*) view_filter_construct (object_type);
#line 696 "../src/Views/ImportPage.vala"
	return self;
#line 12066 "ImportPage.c"
}

static ImportPageHideImportedViewFilter*
import_page_hide_imported_view_filter_new (void)
{
#line 696 "../src/Views/ImportPage.vala"
	return import_page_hide_imported_view_filter_construct (IMPORT_PAGE_TYPE_HIDE_IMPORTED_VIEW_FILTER);
#line 12074 "ImportPage.c"
}

static void
import_page_hide_imported_view_filter_class_init (ImportPageHideImportedViewFilterClass * klass,
                                                  gpointer klass_data)
{
#line 696 "../src/Views/ImportPage.vala"
	import_page_hide_imported_view_filter_parent_class = g_type_class_peek_parent (klass);
#line 696 "../src/Views/ImportPage.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) import_page_hide_imported_view_filter_real_predicate;
#line 12085 "ImportPage.c"
}

static void
import_page_hide_imported_view_filter_instance_init (ImportPageHideImportedViewFilter * self,
                                                     gpointer klass)
{
}

static GType
import_page_hide_imported_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImportPageHideImportedViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_page_hide_imported_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportPageHideImportedViewFilter), 0, (GInstanceInitFunc) import_page_hide_imported_view_filter_instance_init, NULL };
	GType import_page_hide_imported_view_filter_type_id;
	import_page_hide_imported_view_filter_type_id = g_type_register_static (TYPE_VIEW_FILTER, "ImportPageHideImportedViewFilter", &g_define_type_info, 0);
	return import_page_hide_imported_view_filter_type_id;
}

static GType
import_page_hide_imported_view_filter_get_type (void)
{
	static volatile gsize import_page_hide_imported_view_filter_type_id__once = 0;
	if (g_once_init_enter (&import_page_hide_imported_view_filter_type_id__once)) {
		GType import_page_hide_imported_view_filter_type_id;
		import_page_hide_imported_view_filter_type_id = import_page_hide_imported_view_filter_get_type_once ();
		g_once_init_leave (&import_page_hide_imported_view_filter_type_id__once, import_page_hide_imported_view_filter_type_id);
	}
	return import_page_hide_imported_view_filter_type_id__once;
}

static void
import_page_class_init (ImportPageClass * klass,
                        gpointer klass_data)
{
#line 477 "../src/Views/ImportPage.vala"
	import_page_parent_class = g_type_class_peek_parent (klass);
#line 477 "../src/Views/ImportPage.vala"
	g_type_class_adjust_private_offset (klass, &ImportPage_private_offset);
#line 477 "../src/Views/ImportPage.vala"
	((PageClass *) klass)->add_toolbar_widgets = (void (*) (Page*, GtkActionBar*)) import_page_real_add_toolbar_widgets;
#line 477 "../src/Views/ImportPage.vala"
	((CheckerboardPageClass *) klass)->get_item_context_menu = (GtkMenu* (*) (CheckerboardPage*)) import_page_real_get_item_context_menu;
#line 477 "../src/Views/ImportPage.vala"
	((PageClass *) klass)->get_page_context_menu = (GtkMenu* (*) (Page*)) import_page_real_get_page_context_menu;
#line 477 "../src/Views/ImportPage.vala"
	((PageClass *) klass)->get_page_sidebar_menu = (GtkMenu* (*) (Page*)) import_page_real_get_page_sidebar_menu;
#line 477 "../src/Views/ImportPage.vala"
	((CheckerboardPageClass *) klass)->get_view_tracker = (CoreViewTracker* (*) (CheckerboardPage*)) import_page_real_get_view_tracker;
#line 477 "../src/Views/ImportPage.vala"
	((CheckerboardPageClass *) klass)->get_view_empty_message = (gchar* (*) (CheckerboardPage*)) import_page_real_get_view_empty_message;
#line 477 "../src/Views/ImportPage.vala"
	((PageClass *) klass)->init_collect_toggle_action_entries = (GtkToggleActionEntry* (*) (Page*, gint*)) import_page_real_init_collect_toggle_action_entries;
#line 477 "../src/Views/ImportPage.vala"
	((PageClass *) klass)->init_collect_action_entries = (GtkActionEntry* (*) (Page*, gint*)) import_page_real_init_collect_action_entries;
#line 477 "../src/Views/ImportPage.vala"
	((PageClass *) klass)->init_actions = (void (*) (Page*, gint, gint)) import_page_real_init_actions;
#line 477 "../src/Views/ImportPage.vala"
	((PageClass *) klass)->switched_to = (void (*) (Page*)) import_page_real_switched_to;
#line 477 "../src/Views/ImportPage.vala"
	((PageClass *) klass)->ready = (void (*) (Page*)) import_page_real_ready;
#line 477 "../src/Views/ImportPage.vala"
	((CheckerboardPageClass *) klass)->set_display_titles = (void (*) (CheckerboardPage*, gboolean)) import_page_real_set_display_titles;
#line 477 "../src/Views/ImportPage.vala"
	((CheckerboardPageClass *) klass)->get_search_view_filter = (SearchViewFilter* (*) (CheckerboardPage*)) import_page_real_get_search_view_filter;
#line 477 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (klass)->finalize = import_page_finalize;
#line 12151 "ImportPage.c"
}

static void
import_page_instance_init (ImportPage * self,
                           gpointer klass)
{
	GtkLabel* _tmp0_;
	GtkProgressBar* _tmp1_;
	ImportPageImportPageSearchViewFilter* _tmp2_;
	ImportPageHideImportedViewFilter* _tmp3_;
#line 477 "../src/Views/ImportPage.vala"
	self->priv = import_page_get_instance_private (self);
#line 705 "../src/Views/ImportPage.vala"
	self->priv->import_sources = NULL;
#line 706 "../src/Views/ImportPage.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 706 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp0_);
#line 706 "../src/Views/ImportPage.vala"
	self->priv->camera_label = _tmp0_;
#line 708 "../src/Views/ImportPage.vala"
	_tmp1_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 708 "../src/Views/ImportPage.vala"
	g_object_ref_sink (_tmp1_);
#line 708 "../src/Views/ImportPage.vala"
	self->priv->progress_bar = _tmp1_;
#line 711 "../src/Views/ImportPage.vala"
	self->priv->busy = FALSE;
#line 712 "../src/Views/ImportPage.vala"
	self->priv->refreshed = FALSE;
#line 713 "../src/Views/ImportPage.vala"
	self->priv->refresh_result = GP_OK;
#line 714 "../src/Views/ImportPage.vala"
	self->priv->refresh_error = NULL;
#line 716 "../src/Views/ImportPage.vala"
	self->priv->volume_monitor = NULL;
#line 717 "../src/Views/ImportPage.vala"
	self->priv->local_ref = NULL;
#line 719 "../src/Views/ImportPage.vala"
	_tmp2_ = import_page_import_page_search_view_filter_new ();
#line 719 "../src/Views/ImportPage.vala"
	self->priv->search_filter = _tmp2_;
#line 720 "../src/Views/ImportPage.vala"
	_tmp3_ = import_page_hide_imported_view_filter_new ();
#line 720 "../src/Views/ImportPage.vala"
	self->priv->hide_imported_filter = _tmp3_;
#line 12198 "ImportPage.c"
}

static void
import_page_finalize (GObject * obj)
{
	ImportPage * self;
	LibraryPhotoSourceCollection* _tmp0_;
	guint _tmp1_;
	VideoSourceCollection* _tmp2_;
	guint _tmp3_;
#line 477 "../src/Views/ImportPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMPORT_PAGE, ImportPage);
#line 787 "../src/Views/ImportPage.vala"
	_tmp0_ = library_photo_global;
#line 787 "../src/Views/ImportPage.vala"
	g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 787 "../src/Views/ImportPage.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _import_page_on_media_added_removed_data_collection_contents_altered, self);
#line 788 "../src/Views/ImportPage.vala"
	_tmp2_ = video_global;
#line 788 "../src/Views/ImportPage.vala"
	g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp3_, NULL, FALSE);
#line 788 "../src/Views/ImportPage.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _import_page_on_media_added_removed_data_collection_contents_altered, self);
#line 705 "../src/Views/ImportPage.vala"
	_data_collection_unref0 (self->priv->import_sources);
#line 706 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->camera_label);
#line 707 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->hide_imported);
#line 708 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 709 "../src/Views/ImportPage.vala"
	_gp_camera_unref0 (self->priv->camera);
#line 710 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->uri);
#line 714 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->refresh_error);
#line 715 "../src/Views/ImportPage.vala"
	_g_free0 (self->priv->camera_name);
#line 716 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->volume_monitor);
#line 717 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->local_ref);
#line 718 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->icon);
#line 719 "../src/Views/ImportPage.vala"
	_view_filter_unref0 (self->priv->search_filter);
#line 720 "../src/Views/ImportPage.vala"
	_view_filter_unref0 (self->priv->hide_imported_filter);
#line 721 "../src/Views/ImportPage.vala"
	_core_tracker_unref0 (self->priv->tracker);
#line 723 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->page_context_menu);
#line 724 "../src/Views/ImportPage.vala"
	_g_object_unref0 (self->priv->import_context_menu);
#line 477 "../src/Views/ImportPage.vala"
	G_OBJECT_CLASS (import_page_parent_class)->finalize (obj);
#line 12257 "ImportPage.c"
}

static GType
import_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImportPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportPage), 0, (GInstanceInitFunc) import_page_instance_init, NULL };
	GType import_page_type_id;
	import_page_type_id = g_type_register_static (TYPE_CHECKERBOARD_PAGE, "ImportPage", &g_define_type_info, 0);
	ImportPage_private_offset = g_type_add_instance_private (import_page_type_id, sizeof (ImportPagePrivate));
	return import_page_type_id;
}

GType
import_page_get_type (void)
{
	static volatile gsize import_page_type_id__once = 0;
	if (g_once_init_enter (&import_page_type_id__once)) {
		GType import_page_type_id;
		import_page_type_id = import_page_get_type_once ();
		g_once_init_leave (&import_page_type_id__once, import_page_type_id);
	}
	return import_page_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

