/* MediaPage.c generated by valac 0.56.18, the Vala compiler
 * generated from MediaPage.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define MEDIA_PAGE_SORT_ORDER_ASCENDING 0
#define MEDIA_PAGE_SORT_ORDER_DESCENDING 1
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	MEDIA_PAGE_0_PROPERTY,
	MEDIA_PAGE_NUM_PROPERTIES
};
static GParamSpec* media_page_properties[MEDIA_PAGE_NUM_PROPERTIES];
typedef enum  {
	MEDIA_PAGE_SORT_BY_MIN = 1,
	MEDIA_PAGE_SORT_BY_TITLE = 1,
	MEDIA_PAGE_SORT_BY_EXPOSURE_DATE = 2,
	MEDIA_PAGE_SORT_BY_TIMESTAMP = 3,
	MEDIA_PAGE_SORT_BY_MAX = 3
} MediaPageSortBy;

#define MEDIA_PAGE_TYPE_SORT_BY (media_page_sort_by_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _drag_and_drop_handler_unref0(var) ((var == NULL) ? NULL : (var = (drag_and_drop_handler_unref (var), NULL)))
#define _core_tracker_unref0(var) ((var == NULL) ? NULL : (var = (core_tracker_unref (var), NULL)))
typedef struct _Block19Data Block19Data;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MediaPagePrivate {
	SliderAssembly* connected_slider;
	DragAndDropHandler* dnd_handler;
	MediaViewTracker* tracker;
	GtkMenu* page_context_menu;
};

struct _Block19Data {
	int _ref_count_;
	MediaPage* self;
	GtkRadioMenuItem* by_title_menu_item;
	GtkAction* by_title_action;
	GtkRadioMenuItem* by_exposure_menu_item;
	GtkAction* by_exposure_action;
	GtkRadioMenuItem* by_timestamp_menu_item;
	GtkAction* by_timestamp_action;
	GtkRadioMenuItem* ascending_photos_menu_item;
	GtkAction* ascending_photos_action;
	GtkRadioMenuItem* descending_photos_menu_item;
	GtkAction* descending_photos_action;
	GtkRadioMenuItem* ascending_menu_item;
	GtkAction* ascending_action;
	GtkRadioMenuItem* descending_menu_item;
	GtkAction* descending_action;
	GAction* fullscreen_action;
	GAction* select_action;
};

static gint MediaPage_private_offset;
static gpointer media_page_parent_class = NULL;

static GType media_page_sort_by_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GtkMenu* media_page_real_get_page_context_menu (Page* base);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void ___lambda23_ (Block19Data* _data19_);
static void ____lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda24_ (Block19Data* _data19_);
static void ____lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda25_ (Block19Data* _data19_);
static void ____lambda25__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda26_ (Block19Data* _data19_);
static void ____lambda26__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda27_ (Block19Data* _data19_);
static void ____lambda27__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda28_ (Block19Data* _data19_);
static void ____lambda28__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda29_ (Block19Data* _data19_);
static void ____lambda29__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda30_ (Block19Data* _data19_);
static void ____lambda30__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda31_ (Block19Data* _data19_);
static void ____lambda31__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static gint media_page_compute_zoom_scale_increase (gint current_scale);
static gint media_page_compute_zoom_scale_decrease (gint current_scale);
static GtkActionEntry* media_page_real_init_collect_action_entries (Page* base,
                                                             gint* result_length1);
static void _media_page_on_export_gcallback (GtkAction* action,
                                      gpointer self);
static void media_page_on_remove_from_library (MediaPage* self);
static void _media_page_on_remove_from_library_gcallback (GtkAction* action,
                                                   gpointer self);
static void _media_page_on_move_to_trash_gcallback (GtkAction* action,
                                             gpointer self);
static void media_page_on_new_event (MediaPage* self);
static void _media_page_on_new_event_gcallback (GtkAction* action,
                                         gpointer self);
static void _media_page_on_increase_size_gcallback (GtkAction* action,
                                             gpointer self);
static void _media_page_on_decrease_size_gcallback (GtkAction* action,
                                             gpointer self);
static void media_page_on_flag_unflag (MediaPage* self);
static void _media_page_on_flag_unflag_gcallback (GtkAction* action,
                                           gpointer self);
static void media_page_on_raw_developer_shotwell (MediaPage* self,
                                           GtkAction* action);
static void _media_page_on_raw_developer_shotwell_gcallback (GtkAction* action,
                                                      gpointer self);
static void media_page_on_raw_developer_camera (MediaPage* self,
                                         GtkAction* action);
static void _media_page_on_raw_developer_camera_gcallback (GtkAction* action,
                                                    gpointer self);
static void _vala_array_add190 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add191 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add192 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add193 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add194 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add195 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add196 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add197 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add198 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add199 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add200 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static void _vala_array_add201 (GtkActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkActionEntry* value);
static GtkToggleActionEntry* media_page_real_init_collect_toggle_action_entries (Page* base,
                                                                          gint* result_length1);
static void _media_page_on_display_titles_gcallback (GtkAction* action,
                                              gpointer self);
static void _vala_array_add202 (GtkToggleActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkToggleActionEntry* value);
static void _media_page_on_display_comments_gcallback (GtkAction* action,
                                                gpointer self);
static void _vala_array_add203 (GtkToggleActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkToggleActionEntry* value);
static void _media_page_on_display_tags_gcallback (GtkAction* action,
                                            gpointer self);
static void _vala_array_add204 (GtkToggleActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkToggleActionEntry* value);
static void media_page_real_register_radio_actions (Page* base,
                                             GtkActionGroup* action_group);
static void _vala_array_add205 (GtkRadioActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkRadioActionEntry* value);
static void _vala_array_add206 (GtkRadioActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkRadioActionEntry* value);
static void _vala_array_add207 (GtkRadioActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkRadioActionEntry* value);
static void _media_page_on_sort_changed_gcallback (GtkAction* action,
                                            GtkAction* current,
                                            gpointer self);
static void _vala_array_add208 (GtkRadioActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkRadioActionEntry* value);
static void _vala_array_add209 (GtkRadioActionEntry* * array,
                         gint* length,
                         gint* size,
                         const GtkRadioActionEntry* value);
static void media_page_real_update_actions (Page* base,
                                     gint selected_count,
                                     gint count);
static gint media_page_get_thumb_size (MediaPage* self);
static void media_page_update_development_menu_item_sensitivity (MediaPage* self);
static void media_page_update_flag_action (MediaPage* self,
                                    gint selected_count);
static void media_page_on_media_altered (MediaPage* self,
                                  GeeMap* altered);
static CoreViewTracker* media_page_real_get_view_tracker (CheckerboardPage* base);
static gboolean media_page_real_on_mousewheel_up (Page* base,
                                           GdkEventScroll* event);
static void media_page_increase_zoom_level (MediaPage* self);
static gboolean media_page_real_on_mousewheel_down (Page* base,
                                             GdkEventScroll* event);
static void media_page_decrease_zoom_level (MediaPage* self);
static gboolean media_page_real_on_app_key_pressed (Page* base,
                                             GdkEventKey* event);
static void media_page_real_switched_to (Page* base);
static void media_page_set_display_tags (MediaPage* self,
                                  gboolean display);
static void media_page_real_switching_from (Page* base);
static void _media_page_on_zoom_changed_slider_assembly_value_changed (SliderAssembly* _sender,
                                                                gpointer self);
static void media_page_load_persistent_thumbnail_scale (MediaPage* self);
static void media_page_save_persistent_thumbnail_scale (MediaPage* self);
static void media_page_set_thumb_size (MediaPage* self,
                                gint new_scale);
static void media_page_real_on_zoom_changed (MediaPage* self);
static void media_page_real_on_export (MediaPage* self);
static void media_page_real_on_increase_size (MediaPage* self);
static void media_page_real_on_decrease_size (MediaPage* self);
static void media_page_real_on_move_to_trash (MediaPage* self);
static void media_page_real_on_display_titles (MediaPage* self,
                                        GtkAction* action);
static void media_page_real_on_display_comments (MediaPage* self,
                                          GtkAction* action);
static void media_page_real_on_display_tags (MediaPage* self,
                                      GtkAction* action);
static void media_page_real_get_config_photos_sort (MediaPage* self,
                                             gboolean* sort_order,
                                             gint* sort_by);
static void media_page_real_set_config_photos_sort (MediaPage* self,
                                             gboolean sort_order,
                                             gint sort_by);
static void media_page_real_on_sort_changed (MediaPage* self);
static void media_page_set_view_comparator (MediaPage* self,
                                     gint sort_by,
                                     gboolean ascending);
static void media_page_real_developer_changed (MediaPage* self,
                                        RawDeveloper rd);
static void media_page_real_set_display_titles (CheckerboardPage* base,
                                         gboolean display);
static void media_page_real_set_display_comments (CheckerboardPage* base,
                                           gboolean display);
static GtkRadioAction* media_page_sort_by_title_action (MediaPage* self);
static GtkRadioAction* media_page_sort_ascending_action (MediaPage* self);
static gint64 _thumbnail_title_ascending_comparator_comparator (void* a,
                                                         void* b,
                                                         gpointer self);
static gint64 _thumbnail_title_descending_comparator_comparator (void* a,
                                                          void* b,
                                                          gpointer self);
static gboolean _thumbnail_title_comparator_predicate_comparator_predicate (DataObject* object,
                                                                     Alteration* alteration,
                                                                     gpointer self);
static gint64 _thumbnail_exposure_time_ascending_comparator_comparator (void* a,
                                                                 void* b,
                                                                 gpointer self);
static gint64 _thumbnail_exposure_time_descending_comparator_comparator (void* a,
                                                                  void* b,
                                                                  gpointer self);
static gboolean _thumbnail_exposure_time_comparator_predicate_comparator_predicate (DataObject* object,
                                                                             Alteration* alteration,
                                                                             gpointer self);
static gint64 _thumbnail_timestamp_ascending_comparator_comparator (void* a,
                                                             void* b,
                                                             gpointer self);
static gint64 _thumbnail_timestamp_descending_comparator_comparator (void* a,
                                                              void* b,
                                                              gpointer self);
static gboolean _thumbnail_timestamp_comparator_predicate_comparator_predicate (DataObject* object,
                                                                         Alteration* alteration,
                                                                         gpointer self);
static void media_page_real_destroy (GtkWidget* base);
static DataView* media_page_real_create_thumbnail (MediaPage* self,
                                            DataSource* source);
static GObject * media_page_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void _media_page_on_media_altered_data_collection_items_altered (DataCollection* _sender,
                                                                 GeeMap* items,
                                                                 gpointer self);
static void media_page_finalize (GObject * obj);
static GType media_page_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
media_page_get_instance_private (MediaPage* self)
{
	return G_STRUCT_MEMBER_P (self, MediaPage_private_offset);
}

static GType
media_page_sort_by_get_type_once (void)
{
	static const GEnumValue values[] = {{MEDIA_PAGE_SORT_BY_MIN, "MEDIA_PAGE_SORT_BY_MIN", "min"}, {MEDIA_PAGE_SORT_BY_TITLE, "MEDIA_PAGE_SORT_BY_TITLE", "title"}, {MEDIA_PAGE_SORT_BY_EXPOSURE_DATE, "MEDIA_PAGE_SORT_BY_EXPOSURE_DATE", "exposure-date"}, {MEDIA_PAGE_SORT_BY_TIMESTAMP, "MEDIA_PAGE_SORT_BY_TIMESTAMP", "timestamp"}, {MEDIA_PAGE_SORT_BY_MAX, "MEDIA_PAGE_SORT_BY_MAX", "max"}, {0, NULL, NULL}};
	GType media_page_sort_by_type_id;
	media_page_sort_by_type_id = g_enum_register_static ("MediaPageSortBy", values);
	return media_page_sort_by_type_id;
}

static GType
media_page_sort_by_get_type (void)
{
	static volatile gsize media_page_sort_by_type_id__once = 0;
	if (g_once_init_enter (&media_page_sort_by_type_id__once)) {
		GType media_page_sort_by_type_id;
		media_page_sort_by_type_id = media_page_sort_by_get_type_once ();
		g_once_init_leave (&media_page_sort_by_type_id__once, media_page_sort_by_type_id);
	}
	return media_page_sort_by_type_id__once;
}

MediaPage*
media_page_construct (GType object_type,
                      const gchar* page_name)
{
	MediaPage * self = NULL;
#line 38 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (page_name != NULL, NULL);
#line 39 "../src/Views/MediaPage.vala"
	self = (MediaPage*) g_object_new (object_type, "page-name", page_name, NULL);
#line 38 "../src/Views/MediaPage.vala"
	return self;
#line 396 "MediaPage.c"
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 59 "../src/Views/MediaPage.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 59 "../src/Views/MediaPage.vala"
	return _data19_;
#line 406 "MediaPage.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 59 "../src/Views/MediaPage.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 416 "MediaPage.c"
		MediaPage* self;
#line 59 "../src/Views/MediaPage.vala"
		self = _data19_->self;
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->select_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->fullscreen_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->descending_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->descending_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->ascending_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->ascending_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->descending_photos_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->descending_photos_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->ascending_photos_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->ascending_photos_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->by_timestamp_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->by_timestamp_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->by_exposure_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->by_exposure_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->by_title_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_data19_->by_title_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (self);
#line 59 "../src/Views/MediaPage.vala"
		g_slice_free (Block19Data, _data19_);
#line 456 "MediaPage.c"
	}
}

static void
___lambda23_ (Block19Data* _data19_)
{
	MediaPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 79 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 80 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->by_title_menu_item;
#line 80 "../src/Views/MediaPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 80 "../src/Views/MediaPage.vala"
	_tmp2_ = _tmp1_;
#line 80 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 477 "MediaPage.c"
		GtkAction* _tmp3_;
#line 81 "../src/Views/MediaPage.vala"
		_tmp3_ = _data19_->by_title_action;
#line 81 "../src/Views/MediaPage.vala"
		gtk_action_activate (_tmp3_);
#line 483 "MediaPage.c"
	}
}

static void
____lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 79 "../src/Views/MediaPage.vala"
	___lambda23_ (self);
#line 493 "MediaPage.c"
}

static void
___lambda24_ (Block19Data* _data19_)
{
	MediaPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 88 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 89 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->by_exposure_menu_item;
#line 89 "../src/Views/MediaPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 89 "../src/Views/MediaPage.vala"
	_tmp2_ = _tmp1_;
#line 89 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 513 "MediaPage.c"
		GtkAction* _tmp3_;
#line 90 "../src/Views/MediaPage.vala"
		_tmp3_ = _data19_->by_exposure_action;
#line 90 "../src/Views/MediaPage.vala"
		gtk_action_activate (_tmp3_);
#line 519 "MediaPage.c"
	}
}

static void
____lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 88 "../src/Views/MediaPage.vala"
	___lambda24_ (self);
#line 529 "MediaPage.c"
}

static void
___lambda25_ (Block19Data* _data19_)
{
	MediaPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 97 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 98 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->by_timestamp_menu_item;
#line 98 "../src/Views/MediaPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 98 "../src/Views/MediaPage.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 549 "MediaPage.c"
		GtkAction* _tmp3_;
#line 99 "../src/Views/MediaPage.vala"
		_tmp3_ = _data19_->by_timestamp_action;
#line 99 "../src/Views/MediaPage.vala"
		gtk_action_activate (_tmp3_);
#line 555 "MediaPage.c"
	}
}

static void
____lambda25__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 97 "../src/Views/MediaPage.vala"
	___lambda25_ (self);
#line 565 "MediaPage.c"
}

static void
___lambda26_ (Block19Data* _data19_)
{
	MediaPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 106 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 107 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->ascending_photos_menu_item;
#line 107 "../src/Views/MediaPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 107 "../src/Views/MediaPage.vala"
	_tmp2_ = _tmp1_;
#line 107 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 585 "MediaPage.c"
		GtkAction* _tmp3_;
#line 108 "../src/Views/MediaPage.vala"
		_tmp3_ = _data19_->ascending_photos_action;
#line 108 "../src/Views/MediaPage.vala"
		gtk_action_activate (_tmp3_);
#line 591 "MediaPage.c"
	}
}

static void
____lambda26__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 106 "../src/Views/MediaPage.vala"
	___lambda26_ (self);
#line 601 "MediaPage.c"
}

static void
___lambda27_ (Block19Data* _data19_)
{
	MediaPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 115 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 116 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->descending_photos_menu_item;
#line 116 "../src/Views/MediaPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 116 "../src/Views/MediaPage.vala"
	_tmp2_ = _tmp1_;
#line 116 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 621 "MediaPage.c"
		GtkAction* _tmp3_;
#line 117 "../src/Views/MediaPage.vala"
		_tmp3_ = _data19_->descending_photos_action;
#line 117 "../src/Views/MediaPage.vala"
		gtk_action_activate (_tmp3_);
#line 627 "MediaPage.c"
	}
}

static void
____lambda27__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 115 "../src/Views/MediaPage.vala"
	___lambda27_ (self);
#line 637 "MediaPage.c"
}

static void
___lambda28_ (Block19Data* _data19_)
{
	MediaPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 135 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 136 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->ascending_menu_item;
#line 136 "../src/Views/MediaPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 136 "../src/Views/MediaPage.vala"
	_tmp2_ = _tmp1_;
#line 136 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 657 "MediaPage.c"
		GtkAction* _tmp3_;
#line 137 "../src/Views/MediaPage.vala"
		_tmp3_ = _data19_->ascending_action;
#line 137 "../src/Views/MediaPage.vala"
		gtk_action_activate (_tmp3_);
#line 663 "MediaPage.c"
	}
}

static void
____lambda28__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 135 "../src/Views/MediaPage.vala"
	___lambda28_ (self);
#line 673 "MediaPage.c"
}

static void
___lambda29_ (Block19Data* _data19_)
{
	MediaPage* self;
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 144 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 145 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->descending_menu_item;
#line 145 "../src/Views/MediaPage.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 145 "../src/Views/MediaPage.vala"
	_tmp2_ = _tmp1_;
#line 145 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 693 "MediaPage.c"
		GtkAction* _tmp3_;
#line 146 "../src/Views/MediaPage.vala"
		_tmp3_ = _data19_->descending_action;
#line 146 "../src/Views/MediaPage.vala"
		gtk_action_activate (_tmp3_);
#line 699 "MediaPage.c"
	}
}

static void
____lambda29__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 144 "../src/Views/MediaPage.vala"
	___lambda29_ (self);
#line 709 "MediaPage.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 157 "../src/Views/MediaPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 717 "MediaPage.c"
}

static void
___lambda30_ (Block19Data* _data19_)
{
	MediaPage* self;
	GAction* _tmp0_;
#line 159 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 159 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->fullscreen_action;
#line 159 "../src/Views/MediaPage.vala"
	g_action_activate (_tmp0_, NULL);
#line 731 "MediaPage.c"
}

static void
____lambda30__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 159 "../src/Views/MediaPage.vala"
	___lambda30_ (self);
#line 740 "MediaPage.c"
}

static void
___lambda31_ (Block19Data* _data19_)
{
	MediaPage* self;
	GAction* _tmp0_;
#line 165 "../src/Views/MediaPage.vala"
	self = _data19_->self;
#line 165 "../src/Views/MediaPage.vala"
	_tmp0_ = _data19_->select_action;
#line 165 "../src/Views/MediaPage.vala"
	g_action_activate (_tmp0_, NULL);
#line 754 "MediaPage.c"
}

static void
____lambda31__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 165 "../src/Views/MediaPage.vala"
	___lambda31_ (self);
#line 763 "MediaPage.c"
}

static GtkMenu*
media_page_real_get_page_context_menu (Page* base)
{
	MediaPage * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp123_;
	GtkMenu* _tmp124_;
	GtkMenu* result;
#line 58 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 59 "../src/Views/MediaPage.vala"
	_tmp0_ = self->priv->page_context_menu;
#line 59 "../src/Views/MediaPage.vala"
	if (_tmp0_ == NULL) {
#line 780 "MediaPage.c"
		Block19Data* _data19_;
		GtkMenu* _tmp1_;
		GtkCheckMenuItem* title_menu_item = NULL;
		GtkCheckMenuItem* _tmp2_;
		GtkAction* title_action = NULL;
		GtkAction* _tmp3_;
		GtkAction* _tmp4_;
		GtkCheckMenuItem* _tmp5_;
		GtkCheckMenuItem* comment_menu_item = NULL;
		GtkCheckMenuItem* _tmp6_;
		GtkAction* comment_action = NULL;
		GtkAction* _tmp7_;
		GtkAction* _tmp8_;
		GtkCheckMenuItem* _tmp9_;
		GtkCheckMenuItem* tags_menu_item = NULL;
		GtkCheckMenuItem* _tmp10_;
		GtkAction* tags_action = NULL;
		GtkAction* _tmp11_;
		GtkAction* _tmp12_;
		GtkCheckMenuItem* _tmp13_;
		GtkMenuItem* sort_photos_menu_item = NULL;
		GtkMenuItem* _tmp14_;
		GtkRadioMenuItem* _tmp15_;
		GtkAction* _tmp16_;
		GtkAction* _tmp17_;
		GtkRadioMenuItem* _tmp18_;
		GtkRadioMenuItem* _tmp19_;
		GtkRadioMenuItem* _tmp20_;
		GtkRadioMenuItem* _tmp21_;
		GtkAction* _tmp22_;
		GtkAction* _tmp23_;
		GtkRadioMenuItem* _tmp24_;
		GtkRadioMenuItem* _tmp25_;
		GtkRadioMenuItem* _tmp26_;
		GtkRadioMenuItem* _tmp27_;
		GtkAction* _tmp28_;
		GtkAction* _tmp29_;
		GtkRadioMenuItem* _tmp30_;
		GtkRadioMenuItem* _tmp31_;
		GtkRadioMenuItem* _tmp32_;
		GtkAction* _tmp33_;
		GtkAction* _tmp34_;
		GtkRadioMenuItem* _tmp35_;
		GtkRadioMenuItem* _tmp36_;
		GtkRadioMenuItem* _tmp37_;
		GtkRadioMenuItem* _tmp38_;
		GtkAction* _tmp39_;
		GtkAction* _tmp40_;
		GtkRadioMenuItem* _tmp41_;
		GtkRadioMenuItem* _tmp42_;
		GtkMenu* sort_photos_menu = NULL;
		GtkMenu* _tmp43_;
		GtkMenu* _tmp44_;
		GtkRadioMenuItem* _tmp45_;
		GtkMenu* _tmp46_;
		GtkRadioMenuItem* _tmp47_;
		GtkMenu* _tmp48_;
		GtkRadioMenuItem* _tmp49_;
		GtkMenu* _tmp50_;
		GtkSeparatorMenuItem* _tmp51_;
		GtkSeparatorMenuItem* _tmp52_;
		GtkMenu* _tmp53_;
		GtkRadioMenuItem* _tmp54_;
		GtkMenu* _tmp55_;
		GtkRadioMenuItem* _tmp56_;
		GtkMenuItem* _tmp57_;
		GtkMenu* _tmp58_;
		GtkMenuItem* sort_menu_item = NULL;
		GtkMenuItem* _tmp59_;
		GtkRadioMenuItem* _tmp60_;
		GtkAction* _tmp61_;
		GtkAction* _tmp62_;
		GtkRadioMenuItem* _tmp63_;
		GtkRadioMenuItem* _tmp64_;
		GtkRadioMenuItem* _tmp65_;
		GtkRadioMenuItem* _tmp66_;
		GtkAction* _tmp67_;
		GtkAction* _tmp68_;
		GtkRadioMenuItem* _tmp69_;
		GtkRadioMenuItem* _tmp70_;
		GtkMenu* sort_menu = NULL;
		GtkMenu* _tmp71_;
		GtkMenu* _tmp72_;
		GtkRadioMenuItem* _tmp73_;
		GtkMenu* _tmp74_;
		GtkRadioMenuItem* _tmp75_;
		GtkMenuItem* _tmp76_;
		GtkMenu* _tmp77_;
		GtkMenuItem* fullscreen_menu_item = NULL;
		GtkMenuItem* _tmp78_;
		AppWindow* _tmp79_;
		AppWindow* _tmp80_;
		GAction* _tmp81_;
		GAction* _tmp82_;
		GAction* _tmp83_;
		GAction* _tmp84_;
		GtkMenuItem* _tmp85_;
		GtkMenuItem* _tmp86_;
		GtkMenuItem* select_menu_item = NULL;
		GtkMenuItem* _tmp87_;
		AppWindow* _tmp88_;
		AppWindow* _tmp89_;
		GAction* _tmp90_;
		GAction* _tmp91_;
		GAction* _tmp92_;
		GAction* _tmp93_;
		GtkMenuItem* _tmp94_;
		GtkMenuItem* _tmp95_;
		GtkMenu* _tmp96_;
		GtkCheckMenuItem* _tmp97_;
		GtkMenu* _tmp98_;
		GtkCheckMenuItem* _tmp99_;
		GtkMenu* _tmp100_;
		GtkCheckMenuItem* _tmp101_;
		GtkMenu* _tmp102_;
		GtkSeparatorMenuItem* _tmp103_;
		GtkSeparatorMenuItem* _tmp104_;
		GtkMenu* _tmp105_;
		GtkMenuItem* _tmp106_;
		GtkMenu* _tmp107_;
		GtkSeparatorMenuItem* _tmp108_;
		GtkSeparatorMenuItem* _tmp109_;
		GtkMenu* _tmp110_;
		GtkMenuItem* _tmp111_;
		GtkMenu* _tmp112_;
		GtkSeparatorMenuItem* _tmp113_;
		GtkSeparatorMenuItem* _tmp114_;
		GtkMenu* _tmp115_;
		GtkMenuItem* _tmp116_;
		GtkMenu* _tmp117_;
		GtkSeparatorMenuItem* _tmp118_;
		GtkSeparatorMenuItem* _tmp119_;
		GtkMenu* _tmp120_;
		GtkMenuItem* _tmp121_;
		GtkMenu* _tmp122_;
#line 59 "../src/Views/MediaPage.vala"
		_data19_ = g_slice_new0 (Block19Data);
#line 59 "../src/Views/MediaPage.vala"
		_data19_->_ref_count_ = 1;
#line 59 "../src/Views/MediaPage.vala"
		_data19_->self = g_object_ref (self);
#line 60 "../src/Views/MediaPage.vala"
		_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 60 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp1_);
#line 60 "../src/Views/MediaPage.vala"
		_g_object_unref0 (self->priv->page_context_menu);
#line 60 "../src/Views/MediaPage.vala"
		self->priv->page_context_menu = _tmp1_;
#line 62 "../src/Views/MediaPage.vala"
		_tmp2_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_ ("_Titles"));
#line 62 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp2_);
#line 62 "../src/Views/MediaPage.vala"
		title_menu_item = _tmp2_;
#line 63 "../src/Views/MediaPage.vala"
		_tmp3_ = page_get_action ((Page*) self, "ViewTitle");
#line 63 "../src/Views/MediaPage.vala"
		title_action = _tmp3_;
#line 64 "../src/Views/MediaPage.vala"
		_tmp4_ = title_action;
#line 64 "../src/Views/MediaPage.vala"
		_tmp5_ = title_menu_item;
#line 64 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp4_, "active", (GObject*) _tmp5_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 66 "../src/Views/MediaPage.vala"
		_tmp6_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_ ("_Comments"));
#line 66 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp6_);
#line 66 "../src/Views/MediaPage.vala"
		comment_menu_item = _tmp6_;
#line 67 "../src/Views/MediaPage.vala"
		_tmp7_ = page_get_action ((Page*) self, "ViewComment");
#line 67 "../src/Views/MediaPage.vala"
		comment_action = _tmp7_;
#line 68 "../src/Views/MediaPage.vala"
		_tmp8_ = comment_action;
#line 68 "../src/Views/MediaPage.vala"
		_tmp9_ = comment_menu_item;
#line 68 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp8_, "active", (GObject*) _tmp9_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 70 "../src/Views/MediaPage.vala"
		_tmp10_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_ ("Ta_gs"));
#line 70 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp10_);
#line 70 "../src/Views/MediaPage.vala"
		tags_menu_item = _tmp10_;
#line 71 "../src/Views/MediaPage.vala"
		_tmp11_ = page_get_action ((Page*) self, "ViewTags");
#line 71 "../src/Views/MediaPage.vala"
		tags_action = _tmp11_;
#line 72 "../src/Views/MediaPage.vala"
		_tmp12_ = tags_action;
#line 72 "../src/Views/MediaPage.vala"
		_tmp13_ = tags_menu_item;
#line 72 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp12_, "active", (GObject*) _tmp13_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 74 "../src/Views/MediaPage.vala"
		_tmp14_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Sort _Photos"));
#line 74 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp14_);
#line 74 "../src/Views/MediaPage.vala"
		sort_photos_menu_item = _tmp14_;
#line 76 "../src/Views/MediaPage.vala"
		_tmp15_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic (NULL, _ ("By _Title"));
#line 76 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp15_);
#line 76 "../src/Views/MediaPage.vala"
		_data19_->by_title_menu_item = _tmp15_;
#line 77 "../src/Views/MediaPage.vala"
		_tmp16_ = page_get_action ((Page*) self, "SortByTitle");
#line 77 "../src/Views/MediaPage.vala"
		_data19_->by_title_action = _tmp16_;
#line 78 "../src/Views/MediaPage.vala"
		_tmp17_ = _data19_->by_title_action;
#line 78 "../src/Views/MediaPage.vala"
		_tmp18_ = _data19_->by_title_menu_item;
#line 78 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp17_, "active", (GObject*) _tmp18_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 79 "../src/Views/MediaPage.vala"
		_tmp19_ = _data19_->by_title_menu_item;
#line 79 "../src/Views/MediaPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp19_, "activate", (GCallback) ____lambda23__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 85 "../src/Views/MediaPage.vala"
		_tmp20_ = _data19_->by_title_menu_item;
#line 85 "../src/Views/MediaPage.vala"
		_tmp21_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic_from_widget (_tmp20_, _ ("By Exposure _Date"));
#line 85 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp21_);
#line 85 "../src/Views/MediaPage.vala"
		_data19_->by_exposure_menu_item = _tmp21_;
#line 86 "../src/Views/MediaPage.vala"
		_tmp22_ = page_get_action ((Page*) self, "SortByExposureDate");
#line 86 "../src/Views/MediaPage.vala"
		_data19_->by_exposure_action = _tmp22_;
#line 87 "../src/Views/MediaPage.vala"
		_tmp23_ = _data19_->by_exposure_action;
#line 87 "../src/Views/MediaPage.vala"
		_tmp24_ = _data19_->by_exposure_menu_item;
#line 87 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp23_, "active", (GObject*) _tmp24_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 88 "../src/Views/MediaPage.vala"
		_tmp25_ = _data19_->by_exposure_menu_item;
#line 88 "../src/Views/MediaPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp25_, "activate", (GCallback) ____lambda24__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 94 "../src/Views/MediaPage.vala"
		_tmp26_ = _data19_->by_title_menu_item;
#line 94 "../src/Views/MediaPage.vala"
		_tmp27_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic_from_widget (_tmp26_, _ ("By _File Modification Time"));
#line 94 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp27_);
#line 94 "../src/Views/MediaPage.vala"
		_data19_->by_timestamp_menu_item = _tmp27_;
#line 95 "../src/Views/MediaPage.vala"
		_tmp28_ = page_get_action ((Page*) self, "SortByTimestamp");
#line 95 "../src/Views/MediaPage.vala"
		_data19_->by_timestamp_action = _tmp28_;
#line 96 "../src/Views/MediaPage.vala"
		_tmp29_ = _data19_->by_timestamp_action;
#line 96 "../src/Views/MediaPage.vala"
		_tmp30_ = _data19_->by_timestamp_menu_item;
#line 96 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp29_, "active", (GObject*) _tmp30_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 97 "../src/Views/MediaPage.vala"
		_tmp31_ = _data19_->by_timestamp_menu_item;
#line 97 "../src/Views/MediaPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp31_, "activate", (GCallback) ____lambda25__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 103 "../src/Views/MediaPage.vala"
		_tmp32_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic (NULL, _ ("_Ascending"));
#line 103 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp32_);
#line 103 "../src/Views/MediaPage.vala"
		_data19_->ascending_photos_menu_item = _tmp32_;
#line 104 "../src/Views/MediaPage.vala"
		_tmp33_ = page_get_action ((Page*) self, "SortAscending");
#line 104 "../src/Views/MediaPage.vala"
		_data19_->ascending_photos_action = _tmp33_;
#line 105 "../src/Views/MediaPage.vala"
		_tmp34_ = _data19_->ascending_photos_action;
#line 105 "../src/Views/MediaPage.vala"
		_tmp35_ = _data19_->ascending_photos_menu_item;
#line 105 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp34_, "active", (GObject*) _tmp35_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 106 "../src/Views/MediaPage.vala"
		_tmp36_ = _data19_->ascending_photos_menu_item;
#line 106 "../src/Views/MediaPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp36_, "activate", (GCallback) ____lambda26__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 112 "../src/Views/MediaPage.vala"
		_tmp37_ = _data19_->ascending_photos_menu_item;
#line 112 "../src/Views/MediaPage.vala"
		_tmp38_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic_from_widget (_tmp37_, _ ("D_escending"));
#line 112 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp38_);
#line 112 "../src/Views/MediaPage.vala"
		_data19_->descending_photos_menu_item = _tmp38_;
#line 113 "../src/Views/MediaPage.vala"
		_tmp39_ = page_get_action ((Page*) self, "SortDescending");
#line 113 "../src/Views/MediaPage.vala"
		_data19_->descending_photos_action = _tmp39_;
#line 114 "../src/Views/MediaPage.vala"
		_tmp40_ = _data19_->descending_photos_action;
#line 114 "../src/Views/MediaPage.vala"
		_tmp41_ = _data19_->descending_photos_menu_item;
#line 114 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp40_, "active", (GObject*) _tmp41_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 115 "../src/Views/MediaPage.vala"
		_tmp42_ = _data19_->descending_photos_menu_item;
#line 115 "../src/Views/MediaPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp42_, "activate", (GCallback) ____lambda27__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 121 "../src/Views/MediaPage.vala"
		_tmp43_ = (GtkMenu*) gtk_menu_new ();
#line 121 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp43_);
#line 121 "../src/Views/MediaPage.vala"
		sort_photos_menu = _tmp43_;
#line 122 "../src/Views/MediaPage.vala"
		_tmp44_ = sort_photos_menu;
#line 122 "../src/Views/MediaPage.vala"
		_tmp45_ = _data19_->by_title_menu_item;
#line 122 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
#line 123 "../src/Views/MediaPage.vala"
		_tmp46_ = sort_photos_menu;
#line 123 "../src/Views/MediaPage.vala"
		_tmp47_ = _data19_->by_exposure_menu_item;
#line 123 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
#line 124 "../src/Views/MediaPage.vala"
		_tmp48_ = sort_photos_menu;
#line 124 "../src/Views/MediaPage.vala"
		_tmp49_ = _data19_->by_timestamp_menu_item;
#line 124 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
#line 125 "../src/Views/MediaPage.vala"
		_tmp50_ = sort_photos_menu;
#line 125 "../src/Views/MediaPage.vala"
		_tmp51_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 125 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp51_);
#line 125 "../src/Views/MediaPage.vala"
		_tmp52_ = _tmp51_;
#line 125 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp52_);
#line 125 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp52_);
#line 126 "../src/Views/MediaPage.vala"
		_tmp53_ = sort_photos_menu;
#line 126 "../src/Views/MediaPage.vala"
		_tmp54_ = _data19_->ascending_photos_menu_item;
#line 126 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
#line 127 "../src/Views/MediaPage.vala"
		_tmp55_ = sort_photos_menu;
#line 127 "../src/Views/MediaPage.vala"
		_tmp56_ = _data19_->descending_photos_menu_item;
#line 127 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
#line 128 "../src/Views/MediaPage.vala"
		_tmp57_ = sort_photos_menu_item;
#line 128 "../src/Views/MediaPage.vala"
		_tmp58_ = sort_photos_menu;
#line 128 "../src/Views/MediaPage.vala"
		gtk_menu_item_set_submenu (_tmp57_, _tmp58_);
#line 130 "../src/Views/MediaPage.vala"
		_tmp59_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Sort _Events"));
#line 130 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp59_);
#line 130 "../src/Views/MediaPage.vala"
		sort_menu_item = _tmp59_;
#line 132 "../src/Views/MediaPage.vala"
		_tmp60_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic (NULL, _ ("_Ascending"));
#line 132 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp60_);
#line 132 "../src/Views/MediaPage.vala"
		_data19_->ascending_menu_item = _tmp60_;
#line 133 "../src/Views/MediaPage.vala"
		_tmp61_ = page_get_common_action ((Page*) self, "CommonSortEventsAscending", TRUE);
#line 133 "../src/Views/MediaPage.vala"
		_data19_->ascending_action = _tmp61_;
#line 134 "../src/Views/MediaPage.vala"
		_tmp62_ = _data19_->ascending_action;
#line 134 "../src/Views/MediaPage.vala"
		_tmp63_ = _data19_->ascending_menu_item;
#line 134 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp62_, "active", (GObject*) _tmp63_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 135 "../src/Views/MediaPage.vala"
		_tmp64_ = _data19_->ascending_menu_item;
#line 135 "../src/Views/MediaPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp64_, "activate", (GCallback) ____lambda28__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 141 "../src/Views/MediaPage.vala"
		_tmp65_ = _data19_->ascending_menu_item;
#line 141 "../src/Views/MediaPage.vala"
		_tmp66_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic_from_widget (_tmp65_, _ ("D_escending"));
#line 141 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp66_);
#line 141 "../src/Views/MediaPage.vala"
		_data19_->descending_menu_item = _tmp66_;
#line 142 "../src/Views/MediaPage.vala"
		_tmp67_ = page_get_common_action ((Page*) self, "CommonSortEventsDescending", TRUE);
#line 142 "../src/Views/MediaPage.vala"
		_data19_->descending_action = _tmp67_;
#line 143 "../src/Views/MediaPage.vala"
		_tmp68_ = _data19_->descending_action;
#line 143 "../src/Views/MediaPage.vala"
		_tmp69_ = _data19_->descending_menu_item;
#line 143 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp68_, "active", (GObject*) _tmp69_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 144 "../src/Views/MediaPage.vala"
		_tmp70_ = _data19_->descending_menu_item;
#line 144 "../src/Views/MediaPage.vala"
		g_signal_connect_data ((GtkMenuItem*) _tmp70_, "activate", (GCallback) ____lambda29__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 150 "../src/Views/MediaPage.vala"
		_tmp71_ = (GtkMenu*) gtk_menu_new ();
#line 150 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp71_);
#line 150 "../src/Views/MediaPage.vala"
		sort_menu = _tmp71_;
#line 151 "../src/Views/MediaPage.vala"
		_tmp72_ = sort_menu;
#line 151 "../src/Views/MediaPage.vala"
		_tmp73_ = _data19_->ascending_menu_item;
#line 151 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp73_);
#line 152 "../src/Views/MediaPage.vala"
		_tmp74_ = sort_menu;
#line 152 "../src/Views/MediaPage.vala"
		_tmp75_ = _data19_->descending_menu_item;
#line 152 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp74_, (GtkWidget*) _tmp75_);
#line 153 "../src/Views/MediaPage.vala"
		_tmp76_ = sort_menu_item;
#line 153 "../src/Views/MediaPage.vala"
		_tmp77_ = sort_menu;
#line 153 "../src/Views/MediaPage.vala"
		gtk_menu_item_set_submenu (_tmp76_, _tmp77_);
#line 155 "../src/Views/MediaPage.vala"
		_tmp78_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Fulls_creen"));
#line 155 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp78_);
#line 155 "../src/Views/MediaPage.vala"
		fullscreen_menu_item = _tmp78_;
#line 157 "../src/Views/MediaPage.vala"
		_tmp79_ = app_window_get_instance ();
#line 157 "../src/Views/MediaPage.vala"
		_tmp80_ = _tmp79_;
#line 157 "../src/Views/MediaPage.vala"
		_tmp81_ = g_action_map_lookup_action ((GActionMap*) _tmp80_, APP_WINDOW_ACTION_FULLSCREEN);
#line 157 "../src/Views/MediaPage.vala"
		_tmp82_ = _g_object_ref0 (_tmp81_);
#line 157 "../src/Views/MediaPage.vala"
		_tmp83_ = _tmp82_;
#line 157 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp80_);
#line 157 "../src/Views/MediaPage.vala"
		_data19_->fullscreen_action = _tmp83_;
#line 158 "../src/Views/MediaPage.vala"
		_tmp84_ = _data19_->fullscreen_action;
#line 158 "../src/Views/MediaPage.vala"
		_tmp85_ = fullscreen_menu_item;
#line 158 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp84_, "enabled", (GObject*) _tmp85_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 159 "../src/Views/MediaPage.vala"
		_tmp86_ = fullscreen_menu_item;
#line 159 "../src/Views/MediaPage.vala"
		g_signal_connect_data (_tmp86_, "activate", (GCallback) ____lambda30__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 161 "../src/Views/MediaPage.vala"
		_tmp87_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (RESOURCES_SELECT_ALL_MENU);
#line 161 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp87_);
#line 161 "../src/Views/MediaPage.vala"
		select_menu_item = _tmp87_;
#line 163 "../src/Views/MediaPage.vala"
		_tmp88_ = app_window_get_instance ();
#line 163 "../src/Views/MediaPage.vala"
		_tmp89_ = _tmp88_;
#line 163 "../src/Views/MediaPage.vala"
		_tmp90_ = g_action_map_lookup_action ((GActionMap*) _tmp89_, APP_WINDOW_ACTION_SELECT_ALL);
#line 163 "../src/Views/MediaPage.vala"
		_tmp91_ = _g_object_ref0 (_tmp90_);
#line 163 "../src/Views/MediaPage.vala"
		_tmp92_ = _tmp91_;
#line 163 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp89_);
#line 163 "../src/Views/MediaPage.vala"
		_data19_->select_action = _tmp92_;
#line 164 "../src/Views/MediaPage.vala"
		_tmp93_ = _data19_->select_action;
#line 164 "../src/Views/MediaPage.vala"
		_tmp94_ = select_menu_item;
#line 164 "../src/Views/MediaPage.vala"
		g_object_bind_property_with_closures ((GObject*) _tmp93_, "enabled", (GObject*) _tmp94_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 165 "../src/Views/MediaPage.vala"
		_tmp95_ = select_menu_item;
#line 165 "../src/Views/MediaPage.vala"
		g_signal_connect_data (_tmp95_, "activate", (GCallback) ____lambda31__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 167 "../src/Views/MediaPage.vala"
		_tmp96_ = self->priv->page_context_menu;
#line 167 "../src/Views/MediaPage.vala"
		_tmp97_ = title_menu_item;
#line 167 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp96_, (GtkWidget*) _tmp97_);
#line 168 "../src/Views/MediaPage.vala"
		_tmp98_ = self->priv->page_context_menu;
#line 168 "../src/Views/MediaPage.vala"
		_tmp99_ = comment_menu_item;
#line 168 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp98_, (GtkWidget*) _tmp99_);
#line 169 "../src/Views/MediaPage.vala"
		_tmp100_ = self->priv->page_context_menu;
#line 169 "../src/Views/MediaPage.vala"
		_tmp101_ = tags_menu_item;
#line 169 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp100_, (GtkWidget*) _tmp101_);
#line 170 "../src/Views/MediaPage.vala"
		_tmp102_ = self->priv->page_context_menu;
#line 170 "../src/Views/MediaPage.vala"
		_tmp103_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 170 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp103_);
#line 170 "../src/Views/MediaPage.vala"
		_tmp104_ = _tmp103_;
#line 170 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp102_, (GtkWidget*) _tmp104_);
#line 170 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp104_);
#line 171 "../src/Views/MediaPage.vala"
		_tmp105_ = self->priv->page_context_menu;
#line 171 "../src/Views/MediaPage.vala"
		_tmp106_ = sort_photos_menu_item;
#line 171 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp105_, (GtkWidget*) _tmp106_);
#line 172 "../src/Views/MediaPage.vala"
		_tmp107_ = self->priv->page_context_menu;
#line 172 "../src/Views/MediaPage.vala"
		_tmp108_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 172 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp108_);
#line 172 "../src/Views/MediaPage.vala"
		_tmp109_ = _tmp108_;
#line 172 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp107_, (GtkWidget*) _tmp109_);
#line 172 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp109_);
#line 173 "../src/Views/MediaPage.vala"
		_tmp110_ = self->priv->page_context_menu;
#line 173 "../src/Views/MediaPage.vala"
		_tmp111_ = sort_menu_item;
#line 173 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp110_, (GtkWidget*) _tmp111_);
#line 174 "../src/Views/MediaPage.vala"
		_tmp112_ = self->priv->page_context_menu;
#line 174 "../src/Views/MediaPage.vala"
		_tmp113_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 174 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp113_);
#line 174 "../src/Views/MediaPage.vala"
		_tmp114_ = _tmp113_;
#line 174 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp112_, (GtkWidget*) _tmp114_);
#line 174 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp114_);
#line 175 "../src/Views/MediaPage.vala"
		_tmp115_ = self->priv->page_context_menu;
#line 175 "../src/Views/MediaPage.vala"
		_tmp116_ = fullscreen_menu_item;
#line 175 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp115_, (GtkWidget*) _tmp116_);
#line 176 "../src/Views/MediaPage.vala"
		_tmp117_ = self->priv->page_context_menu;
#line 176 "../src/Views/MediaPage.vala"
		_tmp118_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 176 "../src/Views/MediaPage.vala"
		g_object_ref_sink (_tmp118_);
#line 176 "../src/Views/MediaPage.vala"
		_tmp119_ = _tmp118_;
#line 176 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp117_, (GtkWidget*) _tmp119_);
#line 176 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp119_);
#line 177 "../src/Views/MediaPage.vala"
		_tmp120_ = self->priv->page_context_menu;
#line 177 "../src/Views/MediaPage.vala"
		_tmp121_ = select_menu_item;
#line 177 "../src/Views/MediaPage.vala"
		gtk_container_add ((GtkContainer*) _tmp120_, (GtkWidget*) _tmp121_);
#line 178 "../src/Views/MediaPage.vala"
		_tmp122_ = self->priv->page_context_menu;
#line 178 "../src/Views/MediaPage.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp122_);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (select_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (fullscreen_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (sort_menu);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (sort_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (sort_photos_menu);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (sort_photos_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (tags_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (tags_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (comment_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (comment_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (title_action);
#line 59 "../src/Views/MediaPage.vala"
		_g_object_unref0 (title_menu_item);
#line 59 "../src/Views/MediaPage.vala"
		block19_data_unref (_data19_);
#line 59 "../src/Views/MediaPage.vala"
		_data19_ = NULL;
#line 1398 "MediaPage.c"
	}
#line 181 "../src/Views/MediaPage.vala"
	_tmp123_ = self->priv->page_context_menu;
#line 181 "../src/Views/MediaPage.vala"
	_tmp124_ = _g_object_ref0 (_tmp123_);
#line 181 "../src/Views/MediaPage.vala"
	result = _tmp124_;
#line 181 "../src/Views/MediaPage.vala"
	return result;
#line 1408 "MediaPage.c"
}

static gint
media_page_compute_zoom_scale_increase (gint current_scale)
{
	gint new_scale = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint result;
#line 185 "../src/Views/MediaPage.vala"
	new_scale = current_scale + MEDIA_PAGE_MANUAL_STEPPING;
#line 186 "../src/Views/MediaPage.vala"
	_tmp0_ = thumbnail_get_MIN_SCALE ();
#line 186 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 186 "../src/Views/MediaPage.vala"
	_tmp2_ = thumbnail_get_MAX_SCALE ();
#line 186 "../src/Views/MediaPage.vala"
	_tmp3_ = _tmp2_;
#line 186 "../src/Views/MediaPage.vala"
	result = CLAMP (new_scale, _tmp1_, _tmp3_);
#line 186 "../src/Views/MediaPage.vala"
	return result;
#line 1434 "MediaPage.c"
}

static gint
media_page_compute_zoom_scale_decrease (gint current_scale)
{
	gint new_scale = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint result;
#line 190 "../src/Views/MediaPage.vala"
	new_scale = current_scale - MEDIA_PAGE_MANUAL_STEPPING;
#line 191 "../src/Views/MediaPage.vala"
	_tmp0_ = thumbnail_get_MIN_SCALE ();
#line 191 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/Views/MediaPage.vala"
	_tmp2_ = thumbnail_get_MAX_SCALE ();
#line 191 "../src/Views/MediaPage.vala"
	_tmp3_ = _tmp2_;
#line 191 "../src/Views/MediaPage.vala"
	result = CLAMP (new_scale, _tmp1_, _tmp3_);
#line 191 "../src/Views/MediaPage.vala"
	return result;
#line 1460 "MediaPage.c"
}

static void
_media_page_on_export_gcallback (GtkAction* action,
                                 gpointer self)
{
#line 195 "../src/Views/MediaPage.vala"
	media_page_on_export ((MediaPage*) self);
#line 1469 "MediaPage.c"
}

static void
_media_page_on_remove_from_library_gcallback (GtkAction* action,
                                              gpointer self)
{
#line 196 "../src/Views/MediaPage.vala"
	media_page_on_remove_from_library ((MediaPage*) self);
#line 1478 "MediaPage.c"
}

static void
_media_page_on_move_to_trash_gcallback (GtkAction* action,
                                        gpointer self)
{
#line 197 "../src/Views/MediaPage.vala"
	media_page_on_move_to_trash ((MediaPage*) self);
#line 1487 "MediaPage.c"
}

static void
_media_page_on_new_event_gcallback (GtkAction* action,
                                    gpointer self)
{
#line 198 "../src/Views/MediaPage.vala"
	media_page_on_new_event ((MediaPage*) self);
#line 1496 "MediaPage.c"
}

static void
_media_page_on_increase_size_gcallback (GtkAction* action,
                                        gpointer self)
{
#line 199 "../src/Views/MediaPage.vala"
	media_page_on_increase_size ((MediaPage*) self);
#line 1505 "MediaPage.c"
}

static void
_media_page_on_decrease_size_gcallback (GtkAction* action,
                                        gpointer self)
{
#line 200 "../src/Views/MediaPage.vala"
	media_page_on_decrease_size ((MediaPage*) self);
#line 1514 "MediaPage.c"
}

static void
_media_page_on_flag_unflag_gcallback (GtkAction* action,
                                      gpointer self)
{
#line 201 "../src/Views/MediaPage.vala"
	media_page_on_flag_unflag ((MediaPage*) self);
#line 1523 "MediaPage.c"
}

static void
_media_page_on_raw_developer_shotwell_gcallback (GtkAction* action,
                                                 gpointer self)
{
#line 205 "../src/Views/MediaPage.vala"
	media_page_on_raw_developer_shotwell ((MediaPage*) self, action);
#line 1532 "MediaPage.c"
}

static void
_media_page_on_raw_developer_camera_gcallback (GtkAction* action,
                                               gpointer self)
{
#line 206 "../src/Views/MediaPage.vala"
	media_page_on_raw_developer_camera ((MediaPage*) self, action);
#line 1541 "MediaPage.c"
}

static void
_vala_array_add190 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 209 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 209 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 209 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1556 "MediaPage.c"
	}
#line 209 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1560 "MediaPage.c"
}

static void
_vala_array_add191 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 210 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 210 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 210 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1575 "MediaPage.c"
	}
#line 210 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1579 "MediaPage.c"
}

static void
_vala_array_add192 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 211 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 211 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 211 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1594 "MediaPage.c"
	}
#line 211 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1598 "MediaPage.c"
}

static void
_vala_array_add193 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 212 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 212 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 212 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1613 "MediaPage.c"
	}
#line 212 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1617 "MediaPage.c"
}

static void
_vala_array_add194 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 213 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 213 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 213 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1632 "MediaPage.c"
	}
#line 213 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1636 "MediaPage.c"
}

static void
_vala_array_add195 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 214 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 214 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 214 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1651 "MediaPage.c"
	}
#line 214 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1655 "MediaPage.c"
}

static void
_vala_array_add196 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 215 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 215 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 215 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1670 "MediaPage.c"
	}
#line 215 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1674 "MediaPage.c"
}

static void
_vala_array_add197 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 216 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 216 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 216 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1689 "MediaPage.c"
	}
#line 216 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1693 "MediaPage.c"
}

static void
_vala_array_add198 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 217 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 217 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 217 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1708 "MediaPage.c"
	}
#line 217 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1712 "MediaPage.c"
}

static void
_vala_array_add199 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 218 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 218 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 218 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1727 "MediaPage.c"
	}
#line 218 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1731 "MediaPage.c"
}

static void
_vala_array_add200 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 219 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 219 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 219 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1746 "MediaPage.c"
	}
#line 219 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1750 "MediaPage.c"
}

static void
_vala_array_add201 (GtkActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkActionEntry* value)
{
#line 220 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 220 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 220 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1765 "MediaPage.c"
	}
#line 220 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 1769 "MediaPage.c"
}

static GtkActionEntry*
media_page_real_init_collect_action_entries (Page* base,
                                             gint* result_length1)
{
	MediaPage * self;
	GtkActionEntry export = {0};
	GtkActionEntry _tmp0_ = {0};
	GtkActionEntry remove_from_library = {0};
	GtkActionEntry _tmp1_ = {0};
	GtkActionEntry move_to_trash = {0};
	GtkActionEntry _tmp2_ = {0};
	GtkActionEntry new_event = {0};
	GtkActionEntry _tmp3_ = {0};
	GtkActionEntry increase_size = {0};
	GtkActionEntry _tmp4_ = {0};
	GtkActionEntry decrease_size = {0};
	GtkActionEntry _tmp5_ = {0};
	GtkActionEntry flag = {0};
	GtkActionEntry _tmp6_ = {0};
	GtkActionEntry sort_photos = {0};
	GtkActionEntry _tmp7_ = {0};
	GtkActionEntry filter_photos = {0};
	GtkActionEntry _tmp8_ = {0};
	GtkActionEntry raw_developer = {0};
	GtkActionEntry _tmp9_ = {0};
	GtkActionEntry dev_shotwell = {0};
	GtkActionEntry _tmp10_ = {0};
	GtkActionEntry dev_camera = {0};
	GtkActionEntry _tmp11_ = {0};
	GtkActionEntry* actions = NULL;
	gint _tmp12_ = 0;
	GtkActionEntry* _tmp13_;
	gint actions_length1;
	gint _actions_size_;
	GtkActionEntry _tmp14_;
	GtkActionEntry _tmp15_;
	GtkActionEntry _tmp16_;
	GtkActionEntry _tmp17_;
	GtkActionEntry _tmp18_;
	GtkActionEntry _tmp19_;
	GtkActionEntry _tmp20_;
	GtkActionEntry _tmp21_;
	GtkActionEntry _tmp22_;
	GtkActionEntry _tmp23_;
	GtkActionEntry _tmp24_;
	GtkActionEntry _tmp25_;
	GtkActionEntry* _tmp26_;
	gint _tmp26__length1;
	GtkActionEntry* result;
#line 194 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 195 "../src/Views/MediaPage.vala"
	_tmp0_.name = "Export";
#line 195 "../src/Views/MediaPage.vala"
	_tmp0_.stock_id = NULL;
#line 195 "../src/Views/MediaPage.vala"
	_tmp0_.label = NULL;
#line 195 "../src/Views/MediaPage.vala"
	_tmp0_.accelerator = "<Ctrl><Shift>E";
#line 195 "../src/Views/MediaPage.vala"
	_tmp0_.tooltip = NULL;
#line 195 "../src/Views/MediaPage.vala"
	_tmp0_.callback = (GCallback) _media_page_on_export_gcallback;
#line 195 "../src/Views/MediaPage.vala"
	export = _tmp0_;
#line 196 "../src/Views/MediaPage.vala"
	_tmp1_.name = "RemoveFromLibrary";
#line 196 "../src/Views/MediaPage.vala"
	_tmp1_.stock_id = NULL;
#line 196 "../src/Views/MediaPage.vala"
	_tmp1_.label = NULL;
#line 196 "../src/Views/MediaPage.vala"
	_tmp1_.accelerator = "<Shift>Delete";
#line 196 "../src/Views/MediaPage.vala"
	_tmp1_.tooltip = NULL;
#line 196 "../src/Views/MediaPage.vala"
	_tmp1_.callback = (GCallback) _media_page_on_remove_from_library_gcallback;
#line 196 "../src/Views/MediaPage.vala"
	remove_from_library = _tmp1_;
#line 197 "../src/Views/MediaPage.vala"
	_tmp2_.name = "MoveToTrash";
#line 197 "../src/Views/MediaPage.vala"
	_tmp2_.stock_id = NULL;
#line 197 "../src/Views/MediaPage.vala"
	_tmp2_.label = NULL;
#line 197 "../src/Views/MediaPage.vala"
	_tmp2_.accelerator = "Delete";
#line 197 "../src/Views/MediaPage.vala"
	_tmp2_.tooltip = NULL;
#line 197 "../src/Views/MediaPage.vala"
	_tmp2_.callback = (GCallback) _media_page_on_move_to_trash_gcallback;
#line 197 "../src/Views/MediaPage.vala"
	move_to_trash = _tmp2_;
#line 198 "../src/Views/MediaPage.vala"
	_tmp3_.name = "NewEvent";
#line 198 "../src/Views/MediaPage.vala"
	_tmp3_.stock_id = NULL;
#line 198 "../src/Views/MediaPage.vala"
	_tmp3_.label = NULL;
#line 198 "../src/Views/MediaPage.vala"
	_tmp3_.accelerator = "<Ctrl>N";
#line 198 "../src/Views/MediaPage.vala"
	_tmp3_.tooltip = NULL;
#line 198 "../src/Views/MediaPage.vala"
	_tmp3_.callback = (GCallback) _media_page_on_new_event_gcallback;
#line 198 "../src/Views/MediaPage.vala"
	new_event = _tmp3_;
#line 199 "../src/Views/MediaPage.vala"
	_tmp4_.name = "IncreaseSize";
#line 199 "../src/Views/MediaPage.vala"
	_tmp4_.stock_id = NULL;
#line 199 "../src/Views/MediaPage.vala"
	_tmp4_.label = NULL;
#line 199 "../src/Views/MediaPage.vala"
	_tmp4_.accelerator = "<Ctrl>plus";
#line 199 "../src/Views/MediaPage.vala"
	_tmp4_.tooltip = NULL;
#line 199 "../src/Views/MediaPage.vala"
	_tmp4_.callback = (GCallback) _media_page_on_increase_size_gcallback;
#line 199 "../src/Views/MediaPage.vala"
	increase_size = _tmp4_;
#line 200 "../src/Views/MediaPage.vala"
	_tmp5_.name = "DecreaseSize";
#line 200 "../src/Views/MediaPage.vala"
	_tmp5_.stock_id = NULL;
#line 200 "../src/Views/MediaPage.vala"
	_tmp5_.label = NULL;
#line 200 "../src/Views/MediaPage.vala"
	_tmp5_.accelerator = "<Ctrl>minus";
#line 200 "../src/Views/MediaPage.vala"
	_tmp5_.tooltip = NULL;
#line 200 "../src/Views/MediaPage.vala"
	_tmp5_.callback = (GCallback) _media_page_on_decrease_size_gcallback;
#line 200 "../src/Views/MediaPage.vala"
	decrease_size = _tmp5_;
#line 201 "../src/Views/MediaPage.vala"
	_tmp6_.name = "Flag";
#line 201 "../src/Views/MediaPage.vala"
	_tmp6_.stock_id = NULL;
#line 201 "../src/Views/MediaPage.vala"
	_tmp6_.label = NULL;
#line 201 "../src/Views/MediaPage.vala"
	_tmp6_.accelerator = "<Ctrl>G";
#line 201 "../src/Views/MediaPage.vala"
	_tmp6_.tooltip = NULL;
#line 201 "../src/Views/MediaPage.vala"
	_tmp6_.callback = (GCallback) _media_page_on_flag_unflag_gcallback;
#line 201 "../src/Views/MediaPage.vala"
	flag = _tmp6_;
#line 202 "../src/Views/MediaPage.vala"
	_tmp7_.name = "SortPhotos";
#line 202 "../src/Views/MediaPage.vala"
	_tmp7_.stock_id = NULL;
#line 202 "../src/Views/MediaPage.vala"
	_tmp7_.label = NULL;
#line 202 "../src/Views/MediaPage.vala"
	_tmp7_.accelerator = NULL;
#line 202 "../src/Views/MediaPage.vala"
	_tmp7_.tooltip = NULL;
#line 202 "../src/Views/MediaPage.vala"
	_tmp7_.callback = (GCallback) NULL;
#line 202 "../src/Views/MediaPage.vala"
	sort_photos = _tmp7_;
#line 203 "../src/Views/MediaPage.vala"
	_tmp8_.name = "FilterPhotos";
#line 203 "../src/Views/MediaPage.vala"
	_tmp8_.stock_id = NULL;
#line 203 "../src/Views/MediaPage.vala"
	_tmp8_.label = NULL;
#line 203 "../src/Views/MediaPage.vala"
	_tmp8_.accelerator = NULL;
#line 203 "../src/Views/MediaPage.vala"
	_tmp8_.tooltip = NULL;
#line 203 "../src/Views/MediaPage.vala"
	_tmp8_.callback = (GCallback) NULL;
#line 203 "../src/Views/MediaPage.vala"
	filter_photos = _tmp8_;
#line 204 "../src/Views/MediaPage.vala"
	_tmp9_.name = "RawDeveloper";
#line 204 "../src/Views/MediaPage.vala"
	_tmp9_.stock_id = NULL;
#line 204 "../src/Views/MediaPage.vala"
	_tmp9_.label = NULL;
#line 204 "../src/Views/MediaPage.vala"
	_tmp9_.accelerator = NULL;
#line 204 "../src/Views/MediaPage.vala"
	_tmp9_.tooltip = NULL;
#line 204 "../src/Views/MediaPage.vala"
	_tmp9_.callback = (GCallback) NULL;
#line 204 "../src/Views/MediaPage.vala"
	raw_developer = _tmp9_;
#line 205 "../src/Views/MediaPage.vala"
	_tmp10_.name = "RawDeveloperShotwell";
#line 205 "../src/Views/MediaPage.vala"
	_tmp10_.stock_id = NULL;
#line 205 "../src/Views/MediaPage.vala"
	_tmp10_.label = NULL;
#line 205 "../src/Views/MediaPage.vala"
	_tmp10_.accelerator = NULL;
#line 205 "../src/Views/MediaPage.vala"
	_tmp10_.tooltip = NULL;
#line 205 "../src/Views/MediaPage.vala"
	_tmp10_.callback = (GCallback) _media_page_on_raw_developer_shotwell_gcallback;
#line 205 "../src/Views/MediaPage.vala"
	dev_shotwell = _tmp10_;
#line 206 "../src/Views/MediaPage.vala"
	_tmp11_.name = "RawDeveloperCamera";
#line 206 "../src/Views/MediaPage.vala"
	_tmp11_.stock_id = NULL;
#line 206 "../src/Views/MediaPage.vala"
	_tmp11_.label = NULL;
#line 206 "../src/Views/MediaPage.vala"
	_tmp11_.accelerator = NULL;
#line 206 "../src/Views/MediaPage.vala"
	_tmp11_.tooltip = NULL;
#line 206 "../src/Views/MediaPage.vala"
	_tmp11_.callback = (GCallback) _media_page_on_raw_developer_camera_gcallback;
#line 206 "../src/Views/MediaPage.vala"
	dev_camera = _tmp11_;
#line 208 "../src/Views/MediaPage.vala"
	_tmp13_ = PAGE_CLASS (media_page_parent_class)->init_collect_action_entries ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), &_tmp12_);
#line 208 "../src/Views/MediaPage.vala"
	actions = _tmp13_;
#line 208 "../src/Views/MediaPage.vala"
	actions_length1 = _tmp12_;
#line 208 "../src/Views/MediaPage.vala"
	_actions_size_ = actions_length1;
#line 209 "../src/Views/MediaPage.vala"
	_tmp14_ = export;
#line 209 "../src/Views/MediaPage.vala"
	_vala_array_add190 (&actions, &actions_length1, &_actions_size_, &_tmp14_);
#line 210 "../src/Views/MediaPage.vala"
	_tmp15_ = remove_from_library;
#line 210 "../src/Views/MediaPage.vala"
	_vala_array_add191 (&actions, &actions_length1, &_actions_size_, &_tmp15_);
#line 211 "../src/Views/MediaPage.vala"
	_tmp16_ = move_to_trash;
#line 211 "../src/Views/MediaPage.vala"
	_vala_array_add192 (&actions, &actions_length1, &_actions_size_, &_tmp16_);
#line 212 "../src/Views/MediaPage.vala"
	_tmp17_ = new_event;
#line 212 "../src/Views/MediaPage.vala"
	_vala_array_add193 (&actions, &actions_length1, &_actions_size_, &_tmp17_);
#line 213 "../src/Views/MediaPage.vala"
	_tmp18_ = increase_size;
#line 213 "../src/Views/MediaPage.vala"
	_vala_array_add194 (&actions, &actions_length1, &_actions_size_, &_tmp18_);
#line 214 "../src/Views/MediaPage.vala"
	_tmp19_ = decrease_size;
#line 214 "../src/Views/MediaPage.vala"
	_vala_array_add195 (&actions, &actions_length1, &_actions_size_, &_tmp19_);
#line 215 "../src/Views/MediaPage.vala"
	_tmp20_ = flag;
#line 215 "../src/Views/MediaPage.vala"
	_vala_array_add196 (&actions, &actions_length1, &_actions_size_, &_tmp20_);
#line 216 "../src/Views/MediaPage.vala"
	_tmp21_ = sort_photos;
#line 216 "../src/Views/MediaPage.vala"
	_vala_array_add197 (&actions, &actions_length1, &_actions_size_, &_tmp21_);
#line 217 "../src/Views/MediaPage.vala"
	_tmp22_ = filter_photos;
#line 217 "../src/Views/MediaPage.vala"
	_vala_array_add198 (&actions, &actions_length1, &_actions_size_, &_tmp22_);
#line 218 "../src/Views/MediaPage.vala"
	_tmp23_ = raw_developer;
#line 218 "../src/Views/MediaPage.vala"
	_vala_array_add199 (&actions, &actions_length1, &_actions_size_, &_tmp23_);
#line 219 "../src/Views/MediaPage.vala"
	_tmp24_ = dev_shotwell;
#line 219 "../src/Views/MediaPage.vala"
	_vala_array_add200 (&actions, &actions_length1, &_actions_size_, &_tmp24_);
#line 220 "../src/Views/MediaPage.vala"
	_tmp25_ = dev_camera;
#line 220 "../src/Views/MediaPage.vala"
	_vala_array_add201 (&actions, &actions_length1, &_actions_size_, &_tmp25_);
#line 222 "../src/Views/MediaPage.vala"
	_tmp26_ = actions;
#line 222 "../src/Views/MediaPage.vala"
	_tmp26__length1 = actions_length1;
#line 222 "../src/Views/MediaPage.vala"
	if (result_length1) {
#line 222 "../src/Views/MediaPage.vala"
		*result_length1 = _tmp26__length1;
#line 2055 "MediaPage.c"
	}
#line 222 "../src/Views/MediaPage.vala"
	result = _tmp26_;
#line 222 "../src/Views/MediaPage.vala"
	return result;
#line 2061 "MediaPage.c"
}

static void
_media_page_on_display_titles_gcallback (GtkAction* action,
                                         gpointer self)
{
#line 228 "../src/Views/MediaPage.vala"
	media_page_on_display_titles ((MediaPage*) self, action);
#line 2070 "MediaPage.c"
}

static void
_vala_array_add202 (GtkToggleActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkToggleActionEntry* value)
{
#line 232 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 232 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 232 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkToggleActionEntry, *array, *size);
#line 2085 "MediaPage.c"
	}
#line 232 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 2089 "MediaPage.c"
}

static void
_media_page_on_display_comments_gcallback (GtkAction* action,
                                           gpointer self)
{
#line 234 "../src/Views/MediaPage.vala"
	media_page_on_display_comments ((MediaPage*) self, action);
#line 2098 "MediaPage.c"
}

static void
_vala_array_add203 (GtkToggleActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkToggleActionEntry* value)
{
#line 238 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 238 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 238 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkToggleActionEntry, *array, *size);
#line 2113 "MediaPage.c"
	}
#line 238 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 2117 "MediaPage.c"
}

static void
_media_page_on_display_tags_gcallback (GtkAction* action,
                                       gpointer self)
{
#line 240 "../src/Views/MediaPage.vala"
	media_page_on_display_tags ((MediaPage*) self, action);
#line 2126 "MediaPage.c"
}

static void
_vala_array_add204 (GtkToggleActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkToggleActionEntry* value)
{
#line 244 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 244 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 244 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkToggleActionEntry, *array, *size);
#line 2141 "MediaPage.c"
	}
#line 244 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 2145 "MediaPage.c"
}

static GtkToggleActionEntry*
media_page_real_init_collect_toggle_action_entries (Page* base,
                                                    gint* result_length1)
{
	MediaPage * self;
	GtkToggleActionEntry* toggle_actions = NULL;
	gint _tmp0_ = 0;
	GtkToggleActionEntry* _tmp1_;
	gint toggle_actions_length1;
	gint _toggle_actions_size_;
	GtkToggleActionEntry titles = {0};
	GSettings* _tmp2_;
	GtkToggleActionEntry _tmp3_ = {0};
	GtkToggleActionEntry _tmp4_;
	GtkToggleActionEntry comments = {0};
	GSettings* _tmp5_;
	GtkToggleActionEntry _tmp6_ = {0};
	GtkToggleActionEntry _tmp7_;
	GtkToggleActionEntry tags = {0};
	GSettings* _tmp8_;
	GtkToggleActionEntry _tmp9_ = {0};
	GtkToggleActionEntry _tmp10_;
	GtkToggleActionEntry* _tmp11_;
	gint _tmp11__length1;
	GtkToggleActionEntry* result;
#line 225 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 226 "../src/Views/MediaPage.vala"
	_tmp1_ = PAGE_CLASS (media_page_parent_class)->init_collect_toggle_action_entries ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), &_tmp0_);
#line 226 "../src/Views/MediaPage.vala"
	toggle_actions = _tmp1_;
#line 226 "../src/Views/MediaPage.vala"
	toggle_actions_length1 = _tmp0_;
#line 226 "../src/Views/MediaPage.vala"
	_toggle_actions_size_ = toggle_actions_length1;
#line 228 "../src/Views/MediaPage.vala"
	_tmp2_ = ((Page*) self)->ui_settings;
#line 228 "../src/Views/MediaPage.vala"
	_tmp3_.name = "ViewTitle";
#line 228 "../src/Views/MediaPage.vala"
	_tmp3_.stock_id = NULL;
#line 228 "../src/Views/MediaPage.vala"
	_tmp3_.label = _ ("_Titles");
#line 228 "../src/Views/MediaPage.vala"
	_tmp3_.accelerator = "<Ctrl><Shift>T";
#line 228 "../src/Views/MediaPage.vala"
	_tmp3_.tooltip = _ ("Display the title of each photo");
#line 228 "../src/Views/MediaPage.vala"
	_tmp3_.callback = (GCallback) _media_page_on_display_titles_gcallback;
#line 228 "../src/Views/MediaPage.vala"
	_tmp3_.is_active = g_settings_get_boolean (_tmp2_, "display-photo-titles");
#line 228 "../src/Views/MediaPage.vala"
	titles = _tmp3_;
#line 232 "../src/Views/MediaPage.vala"
	_tmp4_ = titles;
#line 232 "../src/Views/MediaPage.vala"
	_vala_array_add202 (&toggle_actions, &toggle_actions_length1, &_toggle_actions_size_, &_tmp4_);
#line 234 "../src/Views/MediaPage.vala"
	_tmp5_ = ((Page*) self)->ui_settings;
#line 234 "../src/Views/MediaPage.vala"
	_tmp6_.name = "ViewComment";
#line 234 "../src/Views/MediaPage.vala"
	_tmp6_.stock_id = NULL;
#line 234 "../src/Views/MediaPage.vala"
	_tmp6_.label = _ ("_Comments");
#line 234 "../src/Views/MediaPage.vala"
	_tmp6_.accelerator = "<Ctrl><Shift>C";
#line 234 "../src/Views/MediaPage.vala"
	_tmp6_.tooltip = _ ("Display the comment of each photo");
#line 234 "../src/Views/MediaPage.vala"
	_tmp6_.callback = (GCallback) _media_page_on_display_comments_gcallback;
#line 234 "../src/Views/MediaPage.vala"
	_tmp6_.is_active = g_settings_get_boolean (_tmp5_, "display-photo-comments");
#line 234 "../src/Views/MediaPage.vala"
	comments = _tmp6_;
#line 238 "../src/Views/MediaPage.vala"
	_tmp7_ = comments;
#line 238 "../src/Views/MediaPage.vala"
	_vala_array_add203 (&toggle_actions, &toggle_actions_length1, &_toggle_actions_size_, &_tmp7_);
#line 240 "../src/Views/MediaPage.vala"
	_tmp8_ = ((Page*) self)->ui_settings;
#line 240 "../src/Views/MediaPage.vala"
	_tmp9_.name = "ViewTags";
#line 240 "../src/Views/MediaPage.vala"
	_tmp9_.stock_id = NULL;
#line 240 "../src/Views/MediaPage.vala"
	_tmp9_.label = _ ("Ta_gs");
#line 240 "../src/Views/MediaPage.vala"
	_tmp9_.accelerator = "<Ctrl><Shift>G";
#line 240 "../src/Views/MediaPage.vala"
	_tmp9_.tooltip = _ ("Display each photo's tags");
#line 240 "../src/Views/MediaPage.vala"
	_tmp9_.callback = (GCallback) _media_page_on_display_tags_gcallback;
#line 240 "../src/Views/MediaPage.vala"
	_tmp9_.is_active = g_settings_get_boolean (_tmp8_, "display-photo-tags");
#line 240 "../src/Views/MediaPage.vala"
	tags = _tmp9_;
#line 244 "../src/Views/MediaPage.vala"
	_tmp10_ = tags;
#line 244 "../src/Views/MediaPage.vala"
	_vala_array_add204 (&toggle_actions, &toggle_actions_length1, &_toggle_actions_size_, &_tmp10_);
#line 246 "../src/Views/MediaPage.vala"
	_tmp11_ = toggle_actions;
#line 246 "../src/Views/MediaPage.vala"
	_tmp11__length1 = toggle_actions_length1;
#line 246 "../src/Views/MediaPage.vala"
	if (result_length1) {
#line 246 "../src/Views/MediaPage.vala"
		*result_length1 = _tmp11__length1;
#line 2257 "MediaPage.c"
	}
#line 246 "../src/Views/MediaPage.vala"
	result = _tmp11_;
#line 246 "../src/Views/MediaPage.vala"
	return result;
#line 2263 "MediaPage.c"
}

static void
_vala_array_add205 (GtkRadioActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkRadioActionEntry* value)
{
#line 260 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 260 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 260 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkRadioActionEntry, *array, *size);
#line 2278 "MediaPage.c"
	}
#line 260 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 2282 "MediaPage.c"
}

static void
_vala_array_add206 (GtkRadioActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkRadioActionEntry* value)
{
#line 265 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 265 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 265 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkRadioActionEntry, *array, *size);
#line 2297 "MediaPage.c"
	}
#line 265 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 2301 "MediaPage.c"
}

static void
_vala_array_add207 (GtkRadioActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkRadioActionEntry* value)
{
#line 270 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 270 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 270 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkRadioActionEntry, *array, *size);
#line 2316 "MediaPage.c"
	}
#line 270 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 2320 "MediaPage.c"
}

static void
_media_page_on_sort_changed_gcallback (GtkAction* action,
                                       GtkAction* current,
                                       gpointer self)
{
#line 272 "../src/Views/MediaPage.vala"
	media_page_on_sort_changed ((MediaPage*) self);
#line 2330 "MediaPage.c"
}

static void
_vala_array_add208 (GtkRadioActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkRadioActionEntry* value)
{
#line 280 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 280 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 280 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkRadioActionEntry, *array, *size);
#line 2345 "MediaPage.c"
	}
#line 280 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 2349 "MediaPage.c"
}

static void
_vala_array_add209 (GtkRadioActionEntry* * array,
                    gint* length,
                    gint* size,
                    const GtkRadioActionEntry* value)
{
#line 285 "../src/Views/MediaPage.vala"
	if ((*length) == (*size)) {
#line 285 "../src/Views/MediaPage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 285 "../src/Views/MediaPage.vala"
		*array = g_renew (GtkRadioActionEntry, *array, *size);
#line 2364 "MediaPage.c"
	}
#line 285 "../src/Views/MediaPage.vala"
	(*array)[(*length)++] = *value;
#line 2368 "MediaPage.c"
}

static void
media_page_real_register_radio_actions (Page* base,
                                        GtkActionGroup* action_group)
{
	MediaPage * self;
	gboolean sort_order = FALSE;
	gint sort_by = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	GtkRadioActionEntry* sort_crit_actions = NULL;
	GtkRadioActionEntry* _tmp2_;
	gint sort_crit_actions_length1;
	gint _sort_crit_actions_size_;
	GtkRadioActionEntry by_title = {0};
	GtkRadioActionEntry _tmp3_ = {0};
	GtkRadioActionEntry _tmp4_;
	GtkRadioActionEntry by_date = {0};
	GtkRadioActionEntry _tmp5_ = {0};
	GtkRadioActionEntry _tmp6_;
	GtkRadioActionEntry by_timestamp = {0};
	GtkRadioActionEntry _tmp7_ = {0};
	GtkRadioActionEntry _tmp8_;
	GtkRadioActionEntry* _tmp9_;
	gint _tmp9__length1;
	GtkRadioActionEntry* sort_order_actions = NULL;
	GtkRadioActionEntry* _tmp10_;
	gint sort_order_actions_length1;
	gint _sort_order_actions_size_;
	GtkRadioActionEntry ascending = {0};
	GtkRadioActionEntry _tmp11_ = {0};
	GtkRadioActionEntry _tmp12_;
	GtkRadioActionEntry descending = {0};
	GtkRadioActionEntry _tmp13_ = {0};
	GtkRadioActionEntry _tmp14_;
	gint _tmp15_ = 0;
	GtkRadioActionEntry* _tmp16_;
	gint _tmp16__length1;
#line 249 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 249 "../src/Views/MediaPage.vala"
	g_return_if_fail (action_group != NULL);
#line 252 "../src/Views/MediaPage.vala"
	media_page_get_config_photos_sort (self, &_tmp0_, &_tmp1_);
#line 252 "../src/Views/MediaPage.vala"
	sort_order = _tmp0_;
#line 252 "../src/Views/MediaPage.vala"
	sort_by = _tmp1_;
#line 255 "../src/Views/MediaPage.vala"
	_tmp2_ = g_new0 (GtkRadioActionEntry, 0);
#line 255 "../src/Views/MediaPage.vala"
	sort_crit_actions = _tmp2_;
#line 255 "../src/Views/MediaPage.vala"
	sort_crit_actions_length1 = 0;
#line 255 "../src/Views/MediaPage.vala"
	_sort_crit_actions_size_ = sort_crit_actions_length1;
#line 257 "../src/Views/MediaPage.vala"
	_tmp3_.name = "SortByTitle";
#line 257 "../src/Views/MediaPage.vala"
	_tmp3_.stock_id = NULL;
#line 257 "../src/Views/MediaPage.vala"
	_tmp3_.label = _ ("By _Title");
#line 257 "../src/Views/MediaPage.vala"
	_tmp3_.accelerator = NULL;
#line 257 "../src/Views/MediaPage.vala"
	_tmp3_.tooltip = _ ("Sort photos by title");
#line 257 "../src/Views/MediaPage.vala"
	_tmp3_.value = (gint) MEDIA_PAGE_SORT_BY_TITLE;
#line 257 "../src/Views/MediaPage.vala"
	by_title = _tmp3_;
#line 260 "../src/Views/MediaPage.vala"
	_tmp4_ = by_title;
#line 260 "../src/Views/MediaPage.vala"
	_vala_array_add205 (&sort_crit_actions, &sort_crit_actions_length1, &_sort_crit_actions_size_, &_tmp4_);
#line 262 "../src/Views/MediaPage.vala"
	_tmp5_.name = "SortByExposureDate";
#line 262 "../src/Views/MediaPage.vala"
	_tmp5_.stock_id = NULL;
#line 262 "../src/Views/MediaPage.vala"
	_tmp5_.label = _ ("By Exposure _Date");
#line 262 "../src/Views/MediaPage.vala"
	_tmp5_.accelerator = NULL;
#line 262 "../src/Views/MediaPage.vala"
	_tmp5_.tooltip = _ ("Sort photos by exposure date");
#line 262 "../src/Views/MediaPage.vala"
	_tmp5_.value = (gint) MEDIA_PAGE_SORT_BY_EXPOSURE_DATE;
#line 262 "../src/Views/MediaPage.vala"
	by_date = _tmp5_;
#line 265 "../src/Views/MediaPage.vala"
	_tmp6_ = by_date;
#line 265 "../src/Views/MediaPage.vala"
	_vala_array_add206 (&sort_crit_actions, &sort_crit_actions_length1, &_sort_crit_actions_size_, &_tmp6_);
#line 267 "../src/Views/MediaPage.vala"
	_tmp7_.name = "SortByTimestamp";
#line 267 "../src/Views/MediaPage.vala"
	_tmp7_.stock_id = NULL;
#line 267 "../src/Views/MediaPage.vala"
	_tmp7_.label = _ ("By _File Modification Time");
#line 267 "../src/Views/MediaPage.vala"
	_tmp7_.accelerator = NULL;
#line 267 "../src/Views/MediaPage.vala"
	_tmp7_.tooltip = _ ("Sort photos by import timestamp");
#line 267 "../src/Views/MediaPage.vala"
	_tmp7_.value = (gint) MEDIA_PAGE_SORT_BY_TIMESTAMP;
#line 267 "../src/Views/MediaPage.vala"
	by_timestamp = _tmp7_;
#line 270 "../src/Views/MediaPage.vala"
	_tmp8_ = by_timestamp;
#line 270 "../src/Views/MediaPage.vala"
	_vala_array_add207 (&sort_crit_actions, &sort_crit_actions_length1, &_sort_crit_actions_size_, &_tmp8_);
#line 272 "../src/Views/MediaPage.vala"
	_tmp9_ = sort_crit_actions;
#line 272 "../src/Views/MediaPage.vala"
	_tmp9__length1 = sort_crit_actions_length1;
#line 272 "../src/Views/MediaPage.vala"
	gtk_action_group_add_radio_actions (action_group, _tmp9_, (guint) _tmp9__length1, sort_by, (GCallback) _media_page_on_sort_changed_gcallback, self);
#line 275 "../src/Views/MediaPage.vala"
	_tmp10_ = g_new0 (GtkRadioActionEntry, 0);
#line 275 "../src/Views/MediaPage.vala"
	sort_order_actions = _tmp10_;
#line 275 "../src/Views/MediaPage.vala"
	sort_order_actions_length1 = 0;
#line 275 "../src/Views/MediaPage.vala"
	_sort_order_actions_size_ = sort_order_actions_length1;
#line 277 "../src/Views/MediaPage.vala"
	_tmp11_.name = "SortAscending";
#line 277 "../src/Views/MediaPage.vala"
	_tmp11_.stock_id = NULL;
#line 277 "../src/Views/MediaPage.vala"
	_tmp11_.label = _ ("_Ascending");
#line 277 "../src/Views/MediaPage.vala"
	_tmp11_.accelerator = NULL;
#line 277 "../src/Views/MediaPage.vala"
	_tmp11_.tooltip = _ ("Sort photos in an ascending order");
#line 277 "../src/Views/MediaPage.vala"
	_tmp11_.value = MEDIA_PAGE_SORT_ORDER_ASCENDING;
#line 277 "../src/Views/MediaPage.vala"
	ascending = _tmp11_;
#line 280 "../src/Views/MediaPage.vala"
	_tmp12_ = ascending;
#line 280 "../src/Views/MediaPage.vala"
	_vala_array_add208 (&sort_order_actions, &sort_order_actions_length1, &_sort_order_actions_size_, &_tmp12_);
#line 282 "../src/Views/MediaPage.vala"
	_tmp13_.name = "SortDescending";
#line 282 "../src/Views/MediaPage.vala"
	_tmp13_.stock_id = NULL;
#line 282 "../src/Views/MediaPage.vala"
	_tmp13_.label = _ ("D_escending");
#line 282 "../src/Views/MediaPage.vala"
	_tmp13_.accelerator = NULL;
#line 282 "../src/Views/MediaPage.vala"
	_tmp13_.tooltip = _ ("Sort photos in a descending order");
#line 282 "../src/Views/MediaPage.vala"
	_tmp13_.value = MEDIA_PAGE_SORT_ORDER_DESCENDING;
#line 282 "../src/Views/MediaPage.vala"
	descending = _tmp13_;
#line 285 "../src/Views/MediaPage.vala"
	_tmp14_ = descending;
#line 285 "../src/Views/MediaPage.vala"
	_vala_array_add209 (&sort_order_actions, &sort_order_actions_length1, &_sort_order_actions_size_, &_tmp14_);
#line 288 "../src/Views/MediaPage.vala"
	if (sort_order) {
#line 288 "../src/Views/MediaPage.vala"
		_tmp15_ = MEDIA_PAGE_SORT_ORDER_ASCENDING;
#line 2534 "MediaPage.c"
	} else {
#line 288 "../src/Views/MediaPage.vala"
		_tmp15_ = MEDIA_PAGE_SORT_ORDER_DESCENDING;
#line 2538 "MediaPage.c"
	}
#line 287 "../src/Views/MediaPage.vala"
	_tmp16_ = sort_order_actions;
#line 287 "../src/Views/MediaPage.vala"
	_tmp16__length1 = sort_order_actions_length1;
#line 287 "../src/Views/MediaPage.vala"
	gtk_action_group_add_radio_actions (action_group, _tmp16_, (guint) _tmp16__length1, _tmp15_, (GCallback) _media_page_on_sort_changed_gcallback, self);
#line 290 "../src/Views/MediaPage.vala"
	PAGE_CLASS (media_page_parent_class)->register_radio_actions ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), action_group);
#line 249 "../src/Views/MediaPage.vala"
	sort_order_actions = (g_free (sort_order_actions), NULL);
#line 249 "../src/Views/MediaPage.vala"
	sort_crit_actions = (g_free (sort_crit_actions), NULL);
#line 2552 "MediaPage.c"
}

static void
media_page_real_update_actions (Page* base,
                                gint selected_count,
                                gint count)
{
	MediaPage * self;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 293 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 294 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "Export", selected_count > 0);
#line 295 "../src/Views/MediaPage.vala"
	_tmp0_ = thumbnail_get_MAX_SCALE ();
#line 295 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 295 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "IncreaseSize", media_page_get_thumb_size (self) < _tmp1_);
#line 296 "../src/Views/MediaPage.vala"
	_tmp2_ = thumbnail_get_MIN_SCALE ();
#line 296 "../src/Views/MediaPage.vala"
	_tmp3_ = _tmp2_;
#line 296 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "DecreaseSize", media_page_get_thumb_size (self) > _tmp3_);
#line 297 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "RemoveFromLibrary", selected_count > 0);
#line 298 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "MoveToTrash", selected_count > 0);
#line 300 "../src/Views/MediaPage.vala"
	media_page_update_development_menu_item_sensitivity (self);
#line 302 "../src/Views/MediaPage.vala"
	media_page_update_flag_action (self, selected_count);
#line 304 "../src/Views/MediaPage.vala"
	PAGE_CLASS (media_page_parent_class)->update_actions ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), selected_count, count);
#line 2591 "MediaPage.c"
}

static void
media_page_on_media_altered (MediaPage* self,
                             GeeMap* altered)
{
#line 307 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/Views/MediaPage.vala"
	g_return_if_fail (altered != NULL);
#line 2602 "MediaPage.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 308 "../src/Views/MediaPage.vala"
		_tmp0_ = gee_map_get_keys (altered);
#line 308 "../src/Views/MediaPage.vala"
		_tmp1_ = _tmp0_;
#line 308 "../src/Views/MediaPage.vala"
		_tmp2_ = _tmp1_;
#line 308 "../src/Views/MediaPage.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 308 "../src/Views/MediaPage.vala"
		_tmp4_ = _tmp3_;
#line 308 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp2_);
#line 308 "../src/Views/MediaPage.vala"
		_object_it = _tmp4_;
#line 308 "../src/Views/MediaPage.vala"
		while (TRUE) {
#line 2626 "MediaPage.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			Alteration* _tmp10_;
			gboolean _tmp11_;
#line 308 "../src/Views/MediaPage.vala"
			_tmp5_ = _object_it;
#line 308 "../src/Views/MediaPage.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 308 "../src/Views/MediaPage.vala"
				break;
#line 2641 "MediaPage.c"
			}
#line 308 "../src/Views/MediaPage.vala"
			_tmp6_ = _object_it;
#line 308 "../src/Views/MediaPage.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 308 "../src/Views/MediaPage.vala"
			object = (DataObject*) _tmp7_;
#line 309 "../src/Views/MediaPage.vala"
			_tmp8_ = object;
#line 309 "../src/Views/MediaPage.vala"
			_tmp9_ = gee_map_get (altered, _tmp8_);
#line 309 "../src/Views/MediaPage.vala"
			_tmp10_ = (Alteration*) _tmp9_;
#line 309 "../src/Views/MediaPage.vala"
			_tmp11_ = alteration_has_detail (_tmp10_, "metadata", "flagged");
#line 309 "../src/Views/MediaPage.vala"
			_alteration_unref0 (_tmp10_);
#line 309 "../src/Views/MediaPage.vala"
			if (_tmp11_) {
#line 2661 "MediaPage.c"
				ViewCollection* _tmp12_;
				ViewCollection* _tmp13_;
#line 310 "../src/Views/MediaPage.vala"
				_tmp12_ = page_get_view ((Page*) self);
#line 310 "../src/Views/MediaPage.vala"
				_tmp13_ = _tmp12_;
#line 310 "../src/Views/MediaPage.vala"
				media_page_update_flag_action (self, view_collection_get_selected_count (_tmp13_));
#line 310 "../src/Views/MediaPage.vala"
				_data_collection_unref0 (_tmp13_);
#line 312 "../src/Views/MediaPage.vala"
				_g_object_unref0 (object);
#line 312 "../src/Views/MediaPage.vala"
				break;
#line 2676 "MediaPage.c"
			}
#line 308 "../src/Views/MediaPage.vala"
			_g_object_unref0 (object);
#line 2680 "MediaPage.c"
		}
#line 308 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_object_it);
#line 2684 "MediaPage.c"
	}
}

static void
media_page_update_development_menu_item_sensitivity (MediaPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_;
	gboolean avail_shotwell = FALSE;
	gboolean avail_camera = FALSE;
	gboolean is_raw = FALSE;
#line 317 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 318 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 318 "../src/Views/MediaPage.vala"
	_tmp2_ = view_collection_get_selected (_tmp1_);
#line 318 "../src/Views/MediaPage.vala"
	_tmp3_ = _tmp2_;
#line 318 "../src/Views/MediaPage.vala"
	_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 318 "../src/Views/MediaPage.vala"
	_tmp5_ = _tmp4_;
#line 318 "../src/Views/MediaPage.vala"
	_tmp6_ = _tmp5_ == 0;
#line 318 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp3_);
#line 318 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 318 "../src/Views/MediaPage.vala"
	if (_tmp6_) {
#line 319 "../src/Views/MediaPage.vala"
		page_set_action_sensitive ((Page*) self, "RawDeveloper", FALSE);
#line 320 "../src/Views/MediaPage.vala"
		return;
#line 2727 "MediaPage.c"
	}
#line 324 "../src/Views/MediaPage.vala"
	avail_shotwell = FALSE;
#line 325 "../src/Views/MediaPage.vala"
	avail_camera = FALSE;
#line 326 "../src/Views/MediaPage.vala"
	is_raw = FALSE;
#line 2735 "MediaPage.c"
	{
		GeeList* _view_list = NULL;
		ViewCollection* _tmp7_;
		ViewCollection* _tmp8_;
		GeeList* _tmp9_;
		GeeList* _tmp10_;
		gint _view_size = 0;
		GeeList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _view_index = 0;
#line 327 "../src/Views/MediaPage.vala"
		_tmp7_ = page_get_view ((Page*) self);
#line 327 "../src/Views/MediaPage.vala"
		_tmp8_ = _tmp7_;
#line 327 "../src/Views/MediaPage.vala"
		_tmp9_ = view_collection_get_selected (_tmp8_);
#line 327 "../src/Views/MediaPage.vala"
		_tmp10_ = _tmp9_;
#line 327 "../src/Views/MediaPage.vala"
		_data_collection_unref0 (_tmp8_);
#line 327 "../src/Views/MediaPage.vala"
		_view_list = _tmp10_;
#line 327 "../src/Views/MediaPage.vala"
		_tmp11_ = _view_list;
#line 327 "../src/Views/MediaPage.vala"
		_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
#line 327 "../src/Views/MediaPage.vala"
		_tmp13_ = _tmp12_;
#line 327 "../src/Views/MediaPage.vala"
		_view_size = _tmp13_;
#line 327 "../src/Views/MediaPage.vala"
		_view_index = -1;
#line 327 "../src/Views/MediaPage.vala"
		while (TRUE) {
#line 2771 "MediaPage.c"
			gint _tmp14_;
			gint _tmp15_;
			DataView* view = NULL;
			GeeList* _tmp16_;
			gpointer _tmp17_;
			Photo* photo = NULL;
			DataView* _tmp18_;
			MediaSource* _tmp19_;
			Photo* _tmp20_;
			gboolean _tmp21_ = FALSE;
			Photo* _tmp22_;
#line 327 "../src/Views/MediaPage.vala"
			_view_index = _view_index + 1;
#line 327 "../src/Views/MediaPage.vala"
			_tmp14_ = _view_index;
#line 327 "../src/Views/MediaPage.vala"
			_tmp15_ = _view_size;
#line 327 "../src/Views/MediaPage.vala"
			if (!(_tmp14_ < _tmp15_)) {
#line 327 "../src/Views/MediaPage.vala"
				break;
#line 2793 "MediaPage.c"
			}
#line 327 "../src/Views/MediaPage.vala"
			_tmp16_ = _view_list;
#line 327 "../src/Views/MediaPage.vala"
			_tmp17_ = gee_list_get (_tmp16_, _view_index);
#line 327 "../src/Views/MediaPage.vala"
			view = (DataView*) _tmp17_;
#line 328 "../src/Views/MediaPage.vala"
			_tmp18_ = view;
#line 328 "../src/Views/MediaPage.vala"
			_tmp19_ = thumbnail_get_media_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_THUMBNAIL, Thumbnail));
#line 328 "../src/Views/MediaPage.vala"
			_tmp20_ = IS_PHOTO (_tmp19_) ? ((Photo*) _tmp19_) : NULL;
#line 328 "../src/Views/MediaPage.vala"
			if (_tmp20_ == NULL) {
#line 328 "../src/Views/MediaPage.vala"
				_g_object_unref0 (_tmp19_);
#line 2811 "MediaPage.c"
			}
#line 328 "../src/Views/MediaPage.vala"
			photo = _tmp20_;
#line 329 "../src/Views/MediaPage.vala"
			_tmp22_ = photo;
#line 329 "../src/Views/MediaPage.vala"
			if (_tmp22_ != NULL) {
#line 2819 "MediaPage.c"
				Photo* _tmp23_;
#line 329 "../src/Views/MediaPage.vala"
				_tmp23_ = photo;
#line 329 "../src/Views/MediaPage.vala"
				_tmp21_ = photo_get_master_file_format (_tmp23_) == PHOTO_FILE_FORMAT_RAW;
#line 2825 "MediaPage.c"
			} else {
#line 329 "../src/Views/MediaPage.vala"
				_tmp21_ = FALSE;
#line 2829 "MediaPage.c"
			}
#line 329 "../src/Views/MediaPage.vala"
			if (_tmp21_) {
#line 2833 "MediaPage.c"
				gboolean _tmp24_ = FALSE;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp30_ = FALSE;
#line 330 "../src/Views/MediaPage.vala"
				is_raw = TRUE;
#line 332 "../src/Views/MediaPage.vala"
				if (!avail_shotwell) {
#line 2841 "MediaPage.c"
					Photo* _tmp25_;
#line 332 "../src/Views/MediaPage.vala"
					_tmp25_ = photo;
#line 332 "../src/Views/MediaPage.vala"
					_tmp24_ = photo_is_raw_developer_available (_tmp25_, RAW_DEVELOPER_SHOTWELL);
#line 2847 "MediaPage.c"
				} else {
#line 332 "../src/Views/MediaPage.vala"
					_tmp24_ = FALSE;
#line 2851 "MediaPage.c"
				}
#line 332 "../src/Views/MediaPage.vala"
				if (_tmp24_) {
#line 333 "../src/Views/MediaPage.vala"
					avail_shotwell = TRUE;
#line 2857 "MediaPage.c"
				}
#line 335 "../src/Views/MediaPage.vala"
				if (!avail_camera) {
#line 2861 "MediaPage.c"
					gboolean _tmp27_ = FALSE;
					Photo* _tmp28_;
#line 335 "../src/Views/MediaPage.vala"
					_tmp28_ = photo;
#line 335 "../src/Views/MediaPage.vala"
					if (photo_is_raw_developer_available (_tmp28_, RAW_DEVELOPER_CAMERA)) {
#line 335 "../src/Views/MediaPage.vala"
						_tmp27_ = TRUE;
#line 2870 "MediaPage.c"
					} else {
						Photo* _tmp29_;
#line 336 "../src/Views/MediaPage.vala"
						_tmp29_ = photo;
#line 336 "../src/Views/MediaPage.vala"
						_tmp27_ = photo_is_raw_developer_available (_tmp29_, RAW_DEVELOPER_EMBEDDED);
#line 2877 "MediaPage.c"
					}
#line 335 "../src/Views/MediaPage.vala"
					_tmp26_ = _tmp27_;
#line 2881 "MediaPage.c"
				} else {
#line 335 "../src/Views/MediaPage.vala"
					_tmp26_ = FALSE;
#line 2885 "MediaPage.c"
				}
#line 335 "../src/Views/MediaPage.vala"
				if (_tmp26_) {
#line 337 "../src/Views/MediaPage.vala"
					avail_camera = TRUE;
#line 2891 "MediaPage.c"
				}
#line 339 "../src/Views/MediaPage.vala"
				if (avail_shotwell) {
#line 339 "../src/Views/MediaPage.vala"
					_tmp30_ = avail_camera;
#line 2897 "MediaPage.c"
				} else {
#line 339 "../src/Views/MediaPage.vala"
					_tmp30_ = FALSE;
#line 2901 "MediaPage.c"
				}
#line 339 "../src/Views/MediaPage.vala"
				if (_tmp30_) {
#line 340 "../src/Views/MediaPage.vala"
					_g_object_unref0 (photo);
#line 340 "../src/Views/MediaPage.vala"
					_g_object_unref0 (view);
#line 340 "../src/Views/MediaPage.vala"
					break;
#line 2911 "MediaPage.c"
				}
			}
#line 327 "../src/Views/MediaPage.vala"
			_g_object_unref0 (photo);
#line 327 "../src/Views/MediaPage.vala"
			_g_object_unref0 (view);
#line 2918 "MediaPage.c"
		}
#line 327 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_view_list);
#line 2922 "MediaPage.c"
	}
#line 346 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "RawDeveloper", is_raw);
#line 348 "../src/Views/MediaPage.vala"
	if (is_raw) {
#line 350 "../src/Views/MediaPage.vala"
		page_set_action_sensitive ((Page*) self, "RawDeveloperShotwell", avail_shotwell);
#line 351 "../src/Views/MediaPage.vala"
		page_set_action_sensitive ((Page*) self, "RawDeveloperCamera", avail_camera);
#line 2932 "MediaPage.c"
	}
}

static void
media_page_update_flag_action (MediaPage* self,
                               gint selected_count)
{
	gchar* flag_label = NULL;
	gchar* _tmp0_;
	GtkAction* flag_action = NULL;
	GtkAction* _tmp18_;
	GtkAction* _tmp19_;
#line 355 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "Flag", selected_count > 0);
#line 358 "../src/Views/MediaPage.vala"
	_tmp0_ = g_strdup (RESOURCES_FLAG_MENU);
#line 358 "../src/Views/MediaPage.vala"
	flag_label = _tmp0_;
#line 360 "../src/Views/MediaPage.vala"
	if (selected_count > 0) {
#line 2955 "MediaPage.c"
		gboolean all_flagged = FALSE;
#line 361 "../src/Views/MediaPage.vala"
		all_flagged = TRUE;
#line 2959 "MediaPage.c"
		{
			GeeList* _source_list = NULL;
			ViewCollection* _tmp1_;
			ViewCollection* _tmp2_;
			GeeList* _tmp3_;
			GeeList* _tmp4_;
			gint _source_size = 0;
			GeeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _source_index = 0;
#line 362 "../src/Views/MediaPage.vala"
			_tmp1_ = page_get_view ((Page*) self);
#line 362 "../src/Views/MediaPage.vala"
			_tmp2_ = _tmp1_;
#line 362 "../src/Views/MediaPage.vala"
			_tmp3_ = view_collection_get_selected_sources (_tmp2_);
#line 362 "../src/Views/MediaPage.vala"
			_tmp4_ = _tmp3_;
#line 362 "../src/Views/MediaPage.vala"
			_data_collection_unref0 (_tmp2_);
#line 362 "../src/Views/MediaPage.vala"
			_source_list = _tmp4_;
#line 362 "../src/Views/MediaPage.vala"
			_tmp5_ = _source_list;
#line 362 "../src/Views/MediaPage.vala"
			_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 362 "../src/Views/MediaPage.vala"
			_tmp7_ = _tmp6_;
#line 362 "../src/Views/MediaPage.vala"
			_source_size = _tmp7_;
#line 362 "../src/Views/MediaPage.vala"
			_source_index = -1;
#line 362 "../src/Views/MediaPage.vala"
			while (TRUE) {
#line 2995 "MediaPage.c"
				gint _tmp8_;
				gint _tmp9_;
				DataSource* source = NULL;
				GeeList* _tmp10_;
				gpointer _tmp11_;
				Flaggable* flaggable = NULL;
				DataSource* _tmp12_;
				Flaggable* _tmp13_;
				gboolean _tmp14_ = FALSE;
				Flaggable* _tmp15_;
#line 362 "../src/Views/MediaPage.vala"
				_source_index = _source_index + 1;
#line 362 "../src/Views/MediaPage.vala"
				_tmp8_ = _source_index;
#line 362 "../src/Views/MediaPage.vala"
				_tmp9_ = _source_size;
#line 362 "../src/Views/MediaPage.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 362 "../src/Views/MediaPage.vala"
					break;
#line 3016 "MediaPage.c"
				}
#line 362 "../src/Views/MediaPage.vala"
				_tmp10_ = _source_list;
#line 362 "../src/Views/MediaPage.vala"
				_tmp11_ = gee_list_get (_tmp10_, _source_index);
#line 362 "../src/Views/MediaPage.vala"
				source = (DataSource*) _tmp11_;
#line 363 "../src/Views/MediaPage.vala"
				_tmp12_ = source;
#line 363 "../src/Views/MediaPage.vala"
				_tmp13_ = _g_object_ref0 (IS_FLAGGABLE (_tmp12_) ? ((Flaggable*) _tmp12_) : NULL);
#line 363 "../src/Views/MediaPage.vala"
				flaggable = _tmp13_;
#line 364 "../src/Views/MediaPage.vala"
				_tmp15_ = flaggable;
#line 364 "../src/Views/MediaPage.vala"
				if (_tmp15_ != NULL) {
#line 3034 "MediaPage.c"
					Flaggable* _tmp16_;
#line 364 "../src/Views/MediaPage.vala"
					_tmp16_ = flaggable;
#line 364 "../src/Views/MediaPage.vala"
					_tmp14_ = !flaggable_is_flagged (_tmp16_);
#line 3040 "MediaPage.c"
				} else {
#line 364 "../src/Views/MediaPage.vala"
					_tmp14_ = FALSE;
#line 3044 "MediaPage.c"
				}
#line 364 "../src/Views/MediaPage.vala"
				if (_tmp14_) {
#line 365 "../src/Views/MediaPage.vala"
					all_flagged = FALSE;
#line 367 "../src/Views/MediaPage.vala"
					_g_object_unref0 (flaggable);
#line 367 "../src/Views/MediaPage.vala"
					_g_object_unref0 (source);
#line 367 "../src/Views/MediaPage.vala"
					break;
#line 3056 "MediaPage.c"
				}
#line 362 "../src/Views/MediaPage.vala"
				_g_object_unref0 (flaggable);
#line 362 "../src/Views/MediaPage.vala"
				_g_object_unref0 (source);
#line 3062 "MediaPage.c"
			}
#line 362 "../src/Views/MediaPage.vala"
			_g_object_unref0 (_source_list);
#line 3066 "MediaPage.c"
		}
#line 371 "../src/Views/MediaPage.vala"
		if (all_flagged) {
#line 3070 "MediaPage.c"
			gchar* _tmp17_;
#line 372 "../src/Views/MediaPage.vala"
			_tmp17_ = g_strdup (RESOURCES_UNFLAG_MENU);
#line 372 "../src/Views/MediaPage.vala"
			_g_free0 (flag_label);
#line 372 "../src/Views/MediaPage.vala"
			flag_label = _tmp17_;
#line 3078 "MediaPage.c"
		}
	}
#line 376 "../src/Views/MediaPage.vala"
	_tmp18_ = page_get_action ((Page*) self, "Flag");
#line 376 "../src/Views/MediaPage.vala"
	flag_action = _tmp18_;
#line 377 "../src/Views/MediaPage.vala"
	_tmp19_ = flag_action;
#line 377 "../src/Views/MediaPage.vala"
	if (_tmp19_ != NULL) {
#line 3089 "MediaPage.c"
		GtkAction* _tmp20_;
		const gchar* _tmp21_;
#line 378 "../src/Views/MediaPage.vala"
		_tmp20_ = flag_action;
#line 378 "../src/Views/MediaPage.vala"
		_tmp21_ = flag_label;
#line 378 "../src/Views/MediaPage.vala"
		gtk_action_set_label (_tmp20_, _tmp21_);
#line 3098 "MediaPage.c"
	}
#line 355 "../src/Views/MediaPage.vala"
	_g_object_unref0 (flag_action);
#line 355 "../src/Views/MediaPage.vala"
	_g_free0 (flag_label);
#line 3104 "MediaPage.c"
}

static gpointer
_core_tracker_ref0 (gpointer self)
{
#line 383 "../src/Views/MediaPage.vala"
	return self ? core_tracker_ref (self) : NULL;
#line 3112 "MediaPage.c"
}

static CoreViewTracker*
media_page_real_get_view_tracker (CheckerboardPage* base)
{
	MediaPage * self;
	MediaViewTracker* _tmp0_;
	CoreViewTracker* _tmp1_;
	CoreViewTracker* result;
#line 382 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 383 "../src/Views/MediaPage.vala"
	_tmp0_ = self->priv->tracker;
#line 383 "../src/Views/MediaPage.vala"
	_tmp1_ = _core_tracker_ref0 ((CoreViewTracker*) _tmp0_);
#line 383 "../src/Views/MediaPage.vala"
	result = _tmp1_;
#line 383 "../src/Views/MediaPage.vala"
	return result;
#line 3132 "MediaPage.c"
}

static gboolean
media_page_real_on_mousewheel_up (Page* base,
                                  GdkEventScroll* event)
{
	MediaPage * self;
	gboolean result;
#line 386 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 386 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 387 "../src/Views/MediaPage.vala"
	if ((event->state & GDK_CONTROL_MASK) != 0) {
#line 388 "../src/Views/MediaPage.vala"
		media_page_increase_zoom_level (self);
#line 389 "../src/Views/MediaPage.vala"
		result = TRUE;
#line 389 "../src/Views/MediaPage.vala"
		return result;
#line 3153 "MediaPage.c"
	} else {
#line 391 "../src/Views/MediaPage.vala"
		result = PAGE_CLASS (media_page_parent_class)->on_mousewheel_up ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), event);
#line 391 "../src/Views/MediaPage.vala"
		return result;
#line 3159 "MediaPage.c"
	}
}

static gboolean
media_page_real_on_mousewheel_down (Page* base,
                                    GdkEventScroll* event)
{
	MediaPage * self;
	gboolean result;
#line 395 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 395 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 396 "../src/Views/MediaPage.vala"
	if ((event->state & GDK_CONTROL_MASK) != 0) {
#line 397 "../src/Views/MediaPage.vala"
		media_page_decrease_zoom_level (self);
#line 398 "../src/Views/MediaPage.vala"
		result = TRUE;
#line 398 "../src/Views/MediaPage.vala"
		return result;
#line 3181 "MediaPage.c"
	} else {
#line 400 "../src/Views/MediaPage.vala"
		result = PAGE_CLASS (media_page_parent_class)->on_mousewheel_down ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), event);
#line 400 "../src/Views/MediaPage.vala"
		return result;
#line 3187 "MediaPage.c"
	}
}

void
media_page_on_play_video (MediaPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	Video* video = NULL;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	DataView* _tmp5_;
	DataView* _tmp6_;
	DataSource* _tmp7_;
	DataSource* _tmp8_;
	Video* _tmp9_;
	Video* _tmp10_;
	Video* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 404 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 405 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 405 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 405 "../src/Views/MediaPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) != 1;
#line 405 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 405 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 406 "../src/Views/MediaPage.vala"
		return;
#line 3222 "MediaPage.c"
	}
#line 408 "../src/Views/MediaPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 408 "../src/Views/MediaPage.vala"
	_tmp4_ = _tmp3_;
#line 408 "../src/Views/MediaPage.vala"
	_tmp5_ = view_collection_get_selected_at (_tmp4_, 0);
#line 408 "../src/Views/MediaPage.vala"
	_tmp6_ = _tmp5_;
#line 408 "../src/Views/MediaPage.vala"
	_tmp7_ = data_view_get_source (_tmp6_);
#line 408 "../src/Views/MediaPage.vala"
	_tmp8_ = _tmp7_;
#line 408 "../src/Views/MediaPage.vala"
	_tmp9_ = _g_object_ref0 (IS_VIDEO (_tmp8_) ? ((Video*) _tmp8_) : NULL);
#line 408 "../src/Views/MediaPage.vala"
	_tmp10_ = _tmp9_;
#line 408 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp6_);
#line 408 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 408 "../src/Views/MediaPage.vala"
	video = _tmp10_;
#line 409 "../src/Views/MediaPage.vala"
	_tmp11_ = video;
#line 409 "../src/Views/MediaPage.vala"
	if (_tmp11_ == NULL) {
#line 410 "../src/Views/MediaPage.vala"
		_g_object_unref0 (video);
#line 410 "../src/Views/MediaPage.vala"
		return;
#line 3254 "MediaPage.c"
	}
	{
		Video* _tmp12_;
		GFile* _tmp13_;
		GFile* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 413 "../src/Views/MediaPage.vala"
		_tmp12_ = video;
#line 413 "../src/Views/MediaPage.vala"
		_tmp13_ = media_source_get_file ((MediaSource*) _tmp12_);
#line 413 "../src/Views/MediaPage.vala"
		_tmp14_ = _tmp13_;
#line 413 "../src/Views/MediaPage.vala"
		_tmp15_ = g_file_get_uri (_tmp14_);
#line 413 "../src/Views/MediaPage.vala"
		_tmp16_ = _tmp15_;
#line 413 "../src/Views/MediaPage.vala"
		g_app_info_launch_default_for_uri (_tmp16_, NULL, &_inner_error0_);
#line 413 "../src/Views/MediaPage.vala"
		_g_free0 (_tmp16_);
#line 413 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp14_);
#line 413 "../src/Views/MediaPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3280 "MediaPage.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 412 "../src/Views/MediaPage.vala"
		e = _inner_error0_;
#line 412 "../src/Views/MediaPage.vala"
		_inner_error0_ = NULL;
#line 415 "../src/Views/MediaPage.vala"
		_tmp17_ = e;
#line 415 "../src/Views/MediaPage.vala"
		_tmp18_ = _tmp17_->message;
#line 415 "../src/Views/MediaPage.vala"
		_tmp19_ = g_strdup_printf (_ ("Photos was unable to play the selected video:\n%s"), _tmp18_);
#line 415 "../src/Views/MediaPage.vala"
		_tmp20_ = _tmp19_;
#line 415 "../src/Views/MediaPage.vala"
		app_window_error_message (_tmp20_, NULL, NULL);
#line 415 "../src/Views/MediaPage.vala"
		_g_free0 (_tmp20_);
#line 412 "../src/Views/MediaPage.vala"
		_g_error_free0 (e);
#line 3310 "MediaPage.c"
	}
	__finally0:
#line 412 "../src/Views/MediaPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 412 "../src/Views/MediaPage.vala"
		_g_object_unref0 (video);
#line 412 "../src/Views/MediaPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 412 "../src/Views/MediaPage.vala"
		g_clear_error (&_inner_error0_);
#line 412 "../src/Views/MediaPage.vala"
		return;
#line 3323 "MediaPage.c"
	}
#line 404 "../src/Views/MediaPage.vala"
	_g_object_unref0 (video);
#line 3327 "MediaPage.c"
}

static gboolean
media_page_real_on_app_key_pressed (Page* base,
                                    GdkEventKey* event)
{
	MediaPage * self;
	gboolean handled = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 422 "../src/Views/MediaPage.vala"
	static GQuark _tmp2_label0 = 0;
#line 422 "../src/Views/MediaPage.vala"
	static GQuark _tmp2_label1 = 0;
#line 422 "../src/Views/MediaPage.vala"
	static GQuark _tmp2_label2 = 0;
#line 422 "../src/Views/MediaPage.vala"
	static GQuark _tmp2_label3 = 0;
#line 422 "../src/Views/MediaPage.vala"
	static GQuark _tmp2_label4 = 0;
#line 422 "../src/Views/MediaPage.vala"
	static GQuark _tmp2_label5 = 0;
#line 422 "../src/Views/MediaPage.vala"
	static GQuark _tmp2_label6 = 0;
#line 3353 "MediaPage.c"
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 420 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 420 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 421 "../src/Views/MediaPage.vala"
	handled = TRUE;
#line 422 "../src/Views/MediaPage.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 422 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 422 "../src/Views/MediaPage.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 422 "../src/Views/MediaPage.vala"
	if (((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("equal")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("plus"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("KP_Add"))))) {
#line 422 "../src/Views/MediaPage.vala"
		switch (0) {
#line 3372 "MediaPage.c"
			default:
			{
#line 426 "../src/Views/MediaPage.vala"
				page_activate_action ((Page*) self, "IncreaseSize");
#line 427 "../src/Views/MediaPage.vala"
				break;
#line 3379 "MediaPage.c"
			}
		}
	} else if (((_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("minus")))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("underscore"))))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("KP_Subtract"))))) {
#line 422 "../src/Views/MediaPage.vala"
		switch (0) {
#line 3385 "MediaPage.c"
			default:
			{
#line 432 "../src/Views/MediaPage.vala"
				page_activate_action ((Page*) self, "DecreaseSize");
#line 433 "../src/Views/MediaPage.vala"
				break;
#line 3392 "MediaPage.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("slash")))) {
#line 422 "../src/Views/MediaPage.vala"
		switch (0) {
#line 3398 "MediaPage.c"
			default:
			{
#line 436 "../src/Views/MediaPage.vala"
				page_activate_action ((Page*) self, "Flag");
#line 437 "../src/Views/MediaPage.vala"
				break;
#line 3405 "MediaPage.c"
			}
		}
	} else {
#line 422 "../src/Views/MediaPage.vala"
		switch (0) {
#line 3411 "MediaPage.c"
			default:
			{
#line 440 "../src/Views/MediaPage.vala"
				handled = FALSE;
#line 441 "../src/Views/MediaPage.vala"
				break;
#line 3418 "MediaPage.c"
			}
		}
	}
#line 444 "../src/Views/MediaPage.vala"
	if (handled) {
#line 444 "../src/Views/MediaPage.vala"
		_tmp4_ = TRUE;
#line 3426 "MediaPage.c"
	} else {
#line 444 "../src/Views/MediaPage.vala"
		_tmp4_ = PAGE_CLASS (media_page_parent_class)->on_app_key_pressed ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), event);
#line 3430 "MediaPage.c"
	}
#line 444 "../src/Views/MediaPage.vala"
	result = _tmp4_;
#line 444 "../src/Views/MediaPage.vala"
	return result;
#line 3436 "MediaPage.c"
}

static void
media_page_real_switched_to (Page* base)
{
	MediaPage * self;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	ViewCollection* _tmp5_;
	ViewCollection* _tmp6_;
#line 447 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 448 "../src/Views/MediaPage.vala"
	PAGE_CLASS (media_page_parent_class)->switched_to ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage));
#line 451 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 451 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 451 "../src/Views/MediaPage.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp1_);
#line 451 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 452 "../src/Views/MediaPage.vala"
	_tmp2_ = ((Page*) self)->ui_settings;
#line 452 "../src/Views/MediaPage.vala"
	checkerboard_page_set_display_titles ((CheckerboardPage*) self, g_settings_get_boolean (_tmp2_, "display-photo-titles"));
#line 453 "../src/Views/MediaPage.vala"
	_tmp3_ = ((Page*) self)->ui_settings;
#line 453 "../src/Views/MediaPage.vala"
	checkerboard_page_set_display_comments ((CheckerboardPage*) self, g_settings_get_boolean (_tmp3_, "display-photo-comments"));
#line 454 "../src/Views/MediaPage.vala"
	_tmp4_ = ((Page*) self)->ui_settings;
#line 454 "../src/Views/MediaPage.vala"
	media_page_set_display_tags (self, g_settings_get_boolean (_tmp4_, "display-photo-tags"));
#line 455 "../src/Views/MediaPage.vala"
	_tmp5_ = page_get_view ((Page*) self);
#line 455 "../src/Views/MediaPage.vala"
	_tmp6_ = _tmp5_;
#line 455 "../src/Views/MediaPage.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp6_);
#line 455 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp6_);
#line 457 "../src/Views/MediaPage.vala"
	media_page_sync_sort (self);
#line 3484 "MediaPage.c"
}

static void
media_page_real_switching_from (Page* base)
{
	MediaPage * self;
#line 460 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 461 "../src/Views/MediaPage.vala"
	media_page_disconnect_slider (self);
#line 463 "../src/Views/MediaPage.vala"
	PAGE_CLASS (media_page_parent_class)->switching_from ((Page*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage));
#line 3497 "MediaPage.c"
}

static void
_media_page_on_zoom_changed_slider_assembly_value_changed (SliderAssembly* _sender,
                                                           gpointer self)
{
#line 468 "../src/Views/MediaPage.vala"
	media_page_on_zoom_changed ((MediaPage*) self);
#line 3506 "MediaPage.c"
}

void
media_page_connect_slider (MediaPage* self,
                           SliderAssembly* slider)
{
	SliderAssembly* _tmp0_;
	SliderAssembly* _tmp1_;
#line 466 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 466 "../src/Views/MediaPage.vala"
	g_return_if_fail (slider != NULL);
#line 467 "../src/Views/MediaPage.vala"
	_tmp0_ = _g_object_ref0 (slider);
#line 467 "../src/Views/MediaPage.vala"
	_g_object_unref0 (self->priv->connected_slider);
#line 467 "../src/Views/MediaPage.vala"
	self->priv->connected_slider = _tmp0_;
#line 468 "../src/Views/MediaPage.vala"
	_tmp1_ = self->priv->connected_slider;
#line 468 "../src/Views/MediaPage.vala"
	g_signal_connect_object (_tmp1_, "value-changed", (GCallback) _media_page_on_zoom_changed_slider_assembly_value_changed, self, 0);
#line 469 "../src/Views/MediaPage.vala"
	media_page_load_persistent_thumbnail_scale (self);
#line 3531 "MediaPage.c"
}

static void
media_page_save_persistent_thumbnail_scale (MediaPage* self)
{
	SliderAssembly* _tmp0_;
	GSettings* _tmp1_;
	SliderAssembly* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
#line 472 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 473 "../src/Views/MediaPage.vala"
	_tmp0_ = self->priv->connected_slider;
#line 473 "../src/Views/MediaPage.vala"
	if (_tmp0_ == NULL) {
#line 474 "../src/Views/MediaPage.vala"
		return;
#line 3550 "MediaPage.c"
	}
#line 476 "../src/Views/MediaPage.vala"
	_tmp1_ = ((Page*) self)->ui_settings;
#line 476 "../src/Views/MediaPage.vala"
	_tmp2_ = self->priv->connected_slider;
#line 476 "../src/Views/MediaPage.vala"
	_tmp3_ = slider_assembly_get_slider_value (_tmp2_);
#line 476 "../src/Views/MediaPage.vala"
	_tmp4_ = _tmp3_;
#line 476 "../src/Views/MediaPage.vala"
	g_settings_set_int (_tmp1_, "photo-thumbnail-scale", (gint) _tmp4_);
#line 3562 "MediaPage.c"
}

static void
media_page_load_persistent_thumbnail_scale (MediaPage* self)
{
	SliderAssembly* _tmp0_;
	gint persistent_scale = 0;
	GSettings* _tmp1_;
	SliderAssembly* _tmp2_;
#line 479 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 480 "../src/Views/MediaPage.vala"
	_tmp0_ = self->priv->connected_slider;
#line 480 "../src/Views/MediaPage.vala"
	if (_tmp0_ == NULL) {
#line 481 "../src/Views/MediaPage.vala"
		return;
#line 3580 "MediaPage.c"
	}
#line 483 "../src/Views/MediaPage.vala"
	_tmp1_ = ((Page*) self)->ui_settings;
#line 483 "../src/Views/MediaPage.vala"
	persistent_scale = g_settings_get_int (_tmp1_, "photo-thumbnail-scale");
#line 485 "../src/Views/MediaPage.vala"
	_tmp2_ = self->priv->connected_slider;
#line 485 "../src/Views/MediaPage.vala"
	slider_assembly_set_slider_value (_tmp2_, (gdouble) persistent_scale);
#line 486 "../src/Views/MediaPage.vala"
	media_page_set_thumb_size (self, persistent_scale);
#line 3592 "MediaPage.c"
}

void
media_page_disconnect_slider (MediaPage* self)
{
	SliderAssembly* _tmp0_;
	SliderAssembly* _tmp1_;
	guint _tmp2_;
#line 489 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 490 "../src/Views/MediaPage.vala"
	_tmp0_ = self->priv->connected_slider;
#line 490 "../src/Views/MediaPage.vala"
	if (_tmp0_ == NULL) {
#line 491 "../src/Views/MediaPage.vala"
		return;
#line 3609 "MediaPage.c"
	}
#line 493 "../src/Views/MediaPage.vala"
	_tmp1_ = self->priv->connected_slider;
#line 493 "../src/Views/MediaPage.vala"
	g_signal_parse_name ("value-changed", TYPE_SLIDER_ASSEMBLY, &_tmp2_, NULL, FALSE);
#line 493 "../src/Views/MediaPage.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _media_page_on_zoom_changed_slider_assembly_value_changed, self);
#line 494 "../src/Views/MediaPage.vala"
	_g_object_unref0 (self->priv->connected_slider);
#line 494 "../src/Views/MediaPage.vala"
	self->priv->connected_slider = NULL;
#line 3621 "MediaPage.c"
}

static void
media_page_real_on_zoom_changed (MediaPage* self)
{
	SliderAssembly* _tmp0_;
#line 498 "../src/Views/MediaPage.vala"
	_tmp0_ = self->priv->connected_slider;
#line 498 "../src/Views/MediaPage.vala"
	if (_tmp0_ != NULL) {
#line 3632 "MediaPage.c"
		SliderAssembly* _tmp1_;
		gdouble _tmp2_;
		gdouble _tmp3_;
#line 499 "../src/Views/MediaPage.vala"
		_tmp1_ = self->priv->connected_slider;
#line 499 "../src/Views/MediaPage.vala"
		_tmp2_ = slider_assembly_get_slider_value (_tmp1_);
#line 499 "../src/Views/MediaPage.vala"
		_tmp3_ = _tmp2_;
#line 499 "../src/Views/MediaPage.vala"
		media_page_set_thumb_size (self, (gint) _tmp3_);
#line 3644 "MediaPage.c"
	}
#line 501 "../src/Views/MediaPage.vala"
	media_page_save_persistent_thumbnail_scale (self);
#line 3648 "MediaPage.c"
}

void
media_page_on_zoom_changed (MediaPage* self)
{
	MediaPageClass* _klass_;
#line 497 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 497 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 497 "../src/Views/MediaPage.vala"
	if (_klass_->on_zoom_changed) {
#line 497 "../src/Views/MediaPage.vala"
		_klass_->on_zoom_changed (self);
#line 3663 "MediaPage.c"
	}
}

static void
media_page_real_on_export (MediaPage* self)
{
#line 504 "../src/Views/MediaPage.vala"
	g_critical ("Type `%s' does not implement abstract method `media_page_on_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 504 "../src/Views/MediaPage.vala"
	return;
#line 3674 "MediaPage.c"
}

void
media_page_on_export (MediaPage* self)
{
	MediaPageClass* _klass_;
#line 504 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 504 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 504 "../src/Views/MediaPage.vala"
	if (_klass_->on_export) {
#line 504 "../src/Views/MediaPage.vala"
		_klass_->on_export (self);
#line 3689 "MediaPage.c"
	}
}

static void
media_page_real_on_increase_size (MediaPage* self)
{
#line 507 "../src/Views/MediaPage.vala"
	media_page_increase_zoom_level (self);
#line 3698 "MediaPage.c"
}

void
media_page_on_increase_size (MediaPage* self)
{
	MediaPageClass* _klass_;
#line 506 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 506 "../src/Views/MediaPage.vala"
	if (_klass_->on_increase_size) {
#line 506 "../src/Views/MediaPage.vala"
		_klass_->on_increase_size (self);
#line 3713 "MediaPage.c"
	}
}

static void
media_page_real_on_decrease_size (MediaPage* self)
{
#line 511 "../src/Views/MediaPage.vala"
	media_page_decrease_zoom_level (self);
#line 3722 "MediaPage.c"
}

void
media_page_on_decrease_size (MediaPage* self)
{
	MediaPageClass* _klass_;
#line 510 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 510 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 510 "../src/Views/MediaPage.vala"
	if (_klass_->on_decrease_size) {
#line 510 "../src/Views/MediaPage.vala"
		_klass_->on_decrease_size (self);
#line 3737 "MediaPage.c"
	}
}

static void
media_page_set_display_tags (MediaPage* self,
                             gboolean display)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	ViewCollection* _tmp2_;
	ViewCollection* _tmp3_;
	GValue _tmp4_ = {0};
	ViewCollection* _tmp5_;
	ViewCollection* _tmp6_;
	GtkToggleAction* action = NULL;
	GtkAction* _tmp7_;
	GtkToggleAction* _tmp8_;
	GtkToggleAction* _tmp9_;
#line 514 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 515 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 515 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 515 "../src/Views/MediaPage.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp1_);
#line 515 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 516 "../src/Views/MediaPage.vala"
	_tmp2_ = page_get_view ((Page*) self);
#line 516 "../src/Views/MediaPage.vala"
	_tmp3_ = _tmp2_;
#line 516 "../src/Views/MediaPage.vala"
	g_value_init (&_tmp4_, G_TYPE_BOOLEAN);
#line 516 "../src/Views/MediaPage.vala"
	g_value_set_boolean (&_tmp4_, display);
#line 516 "../src/Views/MediaPage.vala"
	data_collection_set_property ((DataCollection*) _tmp3_, THUMBNAIL_PROP_SHOW_TAGS, &_tmp4_, NULL, NULL);
#line 516 "../src/Views/MediaPage.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 516 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp3_);
#line 517 "../src/Views/MediaPage.vala"
	_tmp5_ = page_get_view ((Page*) self);
#line 517 "../src/Views/MediaPage.vala"
	_tmp6_ = _tmp5_;
#line 517 "../src/Views/MediaPage.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp6_);
#line 517 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp6_);
#line 519 "../src/Views/MediaPage.vala"
	_tmp7_ = page_get_action ((Page*) self, "ViewTags");
#line 519 "../src/Views/MediaPage.vala"
	_tmp8_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_toggle_action_get_type ()) ? ((GtkToggleAction*) _tmp7_) : NULL;
#line 519 "../src/Views/MediaPage.vala"
	if (_tmp8_ == NULL) {
#line 519 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp7_);
#line 3796 "MediaPage.c"
	}
#line 519 "../src/Views/MediaPage.vala"
	action = _tmp8_;
#line 520 "../src/Views/MediaPage.vala"
	_tmp9_ = action;
#line 520 "../src/Views/MediaPage.vala"
	if (_tmp9_ != NULL) {
#line 3804 "MediaPage.c"
		GtkToggleAction* _tmp10_;
#line 521 "../src/Views/MediaPage.vala"
		_tmp10_ = action;
#line 521 "../src/Views/MediaPage.vala"
		gtk_toggle_action_set_active (_tmp10_, display);
#line 3810 "MediaPage.c"
	}
#line 514 "../src/Views/MediaPage.vala"
	_g_object_unref0 (action);
#line 3814 "MediaPage.c"
}

static void
media_page_on_new_event (MediaPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
#line 524 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 525 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 525 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 525 "../src/Views/MediaPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) > 0;
#line 525 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 525 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 3835 "MediaPage.c"
		CommandManager* _tmp3_;
		CommandManager* _tmp4_;
		ViewCollection* _tmp5_;
		ViewCollection* _tmp6_;
		GeeList* _tmp7_;
		GeeList* _tmp8_;
		NewEventCommand* _tmp9_;
		NewEventCommand* _tmp10_;
#line 526 "../src/Views/MediaPage.vala"
		_tmp3_ = page_get_command_manager ((Page*) self);
#line 526 "../src/Views/MediaPage.vala"
		_tmp4_ = _tmp3_;
#line 526 "../src/Views/MediaPage.vala"
		_tmp5_ = page_get_view ((Page*) self);
#line 526 "../src/Views/MediaPage.vala"
		_tmp6_ = _tmp5_;
#line 526 "../src/Views/MediaPage.vala"
		_tmp7_ = view_collection_get_selected (_tmp6_);
#line 526 "../src/Views/MediaPage.vala"
		_tmp8_ = _tmp7_;
#line 526 "../src/Views/MediaPage.vala"
		_tmp9_ = new_event_command_new ((GeeIterable*) _tmp8_);
#line 526 "../src/Views/MediaPage.vala"
		_tmp10_ = _tmp9_;
#line 526 "../src/Views/MediaPage.vala"
		command_manager_execute (_tmp4_, (Command*) _tmp10_);
#line 526 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp10_);
#line 526 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp8_);
#line 526 "../src/Views/MediaPage.vala"
		_data_collection_unref0 (_tmp6_);
#line 526 "../src/Views/MediaPage.vala"
		_command_manager_unref0 (_tmp4_);
#line 3870 "MediaPage.c"
	}
}

static void
media_page_on_flag_unflag (MediaPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	GeeCollection* sources = NULL;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	GeeList* _tmp5_;
	GeeCollection* _tmp6_;
	gboolean flag = FALSE;
	CommandManager* _tmp17_;
	CommandManager* _tmp18_;
	GeeCollection* _tmp19_;
	FlagUnflagCommand* _tmp20_;
	FlagUnflagCommand* _tmp21_;
#line 529 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 530 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 530 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 530 "../src/Views/MediaPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 530 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 530 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 531 "../src/Views/MediaPage.vala"
		return;
#line 3905 "MediaPage.c"
	}
#line 533 "../src/Views/MediaPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 533 "../src/Views/MediaPage.vala"
	_tmp4_ = _tmp3_;
#line 533 "../src/Views/MediaPage.vala"
	_tmp5_ = view_collection_get_selected_sources_of_type (_tmp4_, TYPE_MEDIA_SOURCE);
#line 533 "../src/Views/MediaPage.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection);
#line 533 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 533 "../src/Views/MediaPage.vala"
	sources = _tmp6_;
#line 537 "../src/Views/MediaPage.vala"
	flag = FALSE;
#line 3921 "MediaPage.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp7_;
		GeeIterator* _tmp8_;
#line 538 "../src/Views/MediaPage.vala"
		_tmp7_ = sources;
#line 538 "../src/Views/MediaPage.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 538 "../src/Views/MediaPage.vala"
		_source_it = _tmp8_;
#line 538 "../src/Views/MediaPage.vala"
		while (TRUE) {
#line 3934 "MediaPage.c"
			GeeIterator* _tmp9_;
			MediaSource* source = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			Flaggable* flaggable = NULL;
			MediaSource* _tmp12_;
			Flaggable* _tmp13_;
			gboolean _tmp14_ = FALSE;
			Flaggable* _tmp15_;
#line 538 "../src/Views/MediaPage.vala"
			_tmp9_ = _source_it;
#line 538 "../src/Views/MediaPage.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 538 "../src/Views/MediaPage.vala"
				break;
#line 3950 "MediaPage.c"
			}
#line 538 "../src/Views/MediaPage.vala"
			_tmp10_ = _source_it;
#line 538 "../src/Views/MediaPage.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 538 "../src/Views/MediaPage.vala"
			source = (MediaSource*) _tmp11_;
#line 539 "../src/Views/MediaPage.vala"
			_tmp12_ = source;
#line 539 "../src/Views/MediaPage.vala"
			_tmp13_ = _g_object_ref0 (IS_FLAGGABLE (_tmp12_) ? ((Flaggable*) _tmp12_) : NULL);
#line 539 "../src/Views/MediaPage.vala"
			flaggable = _tmp13_;
#line 540 "../src/Views/MediaPage.vala"
			_tmp15_ = flaggable;
#line 540 "../src/Views/MediaPage.vala"
			if (_tmp15_ != NULL) {
#line 3968 "MediaPage.c"
				Flaggable* _tmp16_;
#line 540 "../src/Views/MediaPage.vala"
				_tmp16_ = flaggable;
#line 540 "../src/Views/MediaPage.vala"
				_tmp14_ = !flaggable_is_flagged (_tmp16_);
#line 3974 "MediaPage.c"
			} else {
#line 540 "../src/Views/MediaPage.vala"
				_tmp14_ = FALSE;
#line 3978 "MediaPage.c"
			}
#line 540 "../src/Views/MediaPage.vala"
			if (_tmp14_) {
#line 541 "../src/Views/MediaPage.vala"
				flag = TRUE;
#line 543 "../src/Views/MediaPage.vala"
				_g_object_unref0 (flaggable);
#line 543 "../src/Views/MediaPage.vala"
				_g_object_unref0 (source);
#line 543 "../src/Views/MediaPage.vala"
				break;
#line 3990 "MediaPage.c"
			}
#line 538 "../src/Views/MediaPage.vala"
			_g_object_unref0 (flaggable);
#line 538 "../src/Views/MediaPage.vala"
			_g_object_unref0 (source);
#line 3996 "MediaPage.c"
		}
#line 538 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_source_it);
#line 4000 "MediaPage.c"
	}
#line 547 "../src/Views/MediaPage.vala"
	_tmp17_ = page_get_command_manager ((Page*) self);
#line 547 "../src/Views/MediaPage.vala"
	_tmp18_ = _tmp17_;
#line 547 "../src/Views/MediaPage.vala"
	_tmp19_ = sources;
#line 547 "../src/Views/MediaPage.vala"
	_tmp20_ = flag_unflag_command_new (_tmp19_, flag);
#line 547 "../src/Views/MediaPage.vala"
	_tmp21_ = _tmp20_;
#line 547 "../src/Views/MediaPage.vala"
	command_manager_execute (_tmp18_, (Command*) _tmp21_);
#line 547 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp21_);
#line 547 "../src/Views/MediaPage.vala"
	_command_manager_unref0 (_tmp18_);
#line 529 "../src/Views/MediaPage.vala"
	_g_object_unref0 (sources);
#line 4020 "MediaPage.c"
}

static void
media_page_on_remove_from_library (MediaPage* self)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeCollection* _tmp3_;
#line 550 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 551 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 551 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 551 "../src/Views/MediaPage.vala"
	_tmp2_ = view_collection_get_selected_sources (_tmp1_);
#line 551 "../src/Views/MediaPage.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 551 "../src/Views/MediaPage.vala"
	remove_photos_from_library (_tmp3_);
#line 551 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp3_);
#line 551 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 4046 "MediaPage.c"
}

static void
media_page_real_on_move_to_trash (MediaPage* self)
{
	CheckerboardItem* restore_point = NULL;
	CheckerboardItem* _tmp0_;
	ViewCollection* _tmp6_;
	ViewCollection* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp17_ = FALSE;
	CheckerboardItem* _tmp18_;
#line 555 "../src/Views/MediaPage.vala"
	restore_point = NULL;
#line 557 "../src/Views/MediaPage.vala"
	_tmp0_ = ((CheckerboardPage*) self)->cursor;
#line 557 "../src/Views/MediaPage.vala"
	if (_tmp0_ != NULL) {
#line 4065 "MediaPage.c"
		ViewCollection* _tmp1_;
		ViewCollection* _tmp2_;
		CheckerboardItem* _tmp3_;
		DataView* _tmp4_;
		CheckerboardItem* _tmp5_;
#line 558 "../src/Views/MediaPage.vala"
		_tmp1_ = page_get_view ((Page*) self);
#line 558 "../src/Views/MediaPage.vala"
		_tmp2_ = _tmp1_;
#line 558 "../src/Views/MediaPage.vala"
		_tmp3_ = ((CheckerboardPage*) self)->cursor;
#line 558 "../src/Views/MediaPage.vala"
		_tmp4_ = view_collection_get_next (_tmp2_, (DataView*) _tmp3_);
#line 558 "../src/Views/MediaPage.vala"
		_tmp5_ = IS_CHECKERBOARD_ITEM (_tmp4_) ? ((CheckerboardItem*) _tmp4_) : NULL;
#line 558 "../src/Views/MediaPage.vala"
		if (_tmp5_ == NULL) {
#line 558 "../src/Views/MediaPage.vala"
			_g_object_unref0 (_tmp4_);
#line 4085 "MediaPage.c"
		}
#line 558 "../src/Views/MediaPage.vala"
		_g_object_unref0 (restore_point);
#line 558 "../src/Views/MediaPage.vala"
		restore_point = _tmp5_;
#line 558 "../src/Views/MediaPage.vala"
		_data_collection_unref0 (_tmp2_);
#line 4093 "MediaPage.c"
	}
#line 561 "../src/Views/MediaPage.vala"
	_tmp6_ = page_get_view ((Page*) self);
#line 561 "../src/Views/MediaPage.vala"
	_tmp7_ = _tmp6_;
#line 561 "../src/Views/MediaPage.vala"
	_tmp8_ = view_collection_get_selected_count (_tmp7_) > 0;
#line 561 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp7_);
#line 561 "../src/Views/MediaPage.vala"
	if (_tmp8_) {
#line 4105 "MediaPage.c"
		CommandManager* _tmp9_;
		CommandManager* _tmp10_;
		ViewCollection* _tmp11_;
		ViewCollection* _tmp12_;
		GeeList* _tmp13_;
		GeeCollection* _tmp14_;
		TrashUntrashPhotosCommand* _tmp15_;
		TrashUntrashPhotosCommand* _tmp16_;
#line 562 "../src/Views/MediaPage.vala"
		_tmp9_ = page_get_command_manager ((Page*) self);
#line 562 "../src/Views/MediaPage.vala"
		_tmp10_ = _tmp9_;
#line 562 "../src/Views/MediaPage.vala"
		_tmp11_ = page_get_view ((Page*) self);
#line 562 "../src/Views/MediaPage.vala"
		_tmp12_ = _tmp11_;
#line 562 "../src/Views/MediaPage.vala"
		_tmp13_ = view_collection_get_selected_sources (_tmp12_);
#line 562 "../src/Views/MediaPage.vala"
		_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection);
#line 562 "../src/Views/MediaPage.vala"
		_tmp15_ = trash_untrash_photos_command_new (_tmp14_, TRUE);
#line 562 "../src/Views/MediaPage.vala"
		_tmp16_ = _tmp15_;
#line 562 "../src/Views/MediaPage.vala"
		command_manager_execute (_tmp10_, (Command*) _tmp16_);
#line 562 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp16_);
#line 562 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp14_);
#line 562 "../src/Views/MediaPage.vala"
		_data_collection_unref0 (_tmp12_);
#line 562 "../src/Views/MediaPage.vala"
		_command_manager_unref0 (_tmp10_);
#line 4140 "MediaPage.c"
	}
#line 566 "../src/Views/MediaPage.vala"
	_tmp18_ = restore_point;
#line 566 "../src/Views/MediaPage.vala"
	if (_tmp18_ != NULL) {
#line 4146 "MediaPage.c"
		ViewCollection* _tmp19_;
		ViewCollection* _tmp20_;
		CheckerboardItem* _tmp21_;
#line 566 "../src/Views/MediaPage.vala"
		_tmp19_ = page_get_view ((Page*) self);
#line 566 "../src/Views/MediaPage.vala"
		_tmp20_ = _tmp19_;
#line 566 "../src/Views/MediaPage.vala"
		_tmp21_ = restore_point;
#line 566 "../src/Views/MediaPage.vala"
		_tmp17_ = data_collection_contains ((DataCollection*) _tmp20_, (DataObject*) _tmp21_);
#line 566 "../src/Views/MediaPage.vala"
		_data_collection_unref0 (_tmp20_);
#line 4160 "MediaPage.c"
	} else {
#line 566 "../src/Views/MediaPage.vala"
		_tmp17_ = FALSE;
#line 4164 "MediaPage.c"
	}
#line 566 "../src/Views/MediaPage.vala"
	if (_tmp17_) {
#line 4168 "MediaPage.c"
		CheckerboardItem* _tmp22_;
#line 567 "../src/Views/MediaPage.vala"
		_tmp22_ = restore_point;
#line 567 "../src/Views/MediaPage.vala"
		checkerboard_page_set_cursor ((CheckerboardPage*) self, _tmp22_);
#line 4174 "MediaPage.c"
	}
#line 554 "../src/Views/MediaPage.vala"
	_g_object_unref0 (restore_point);
#line 4178 "MediaPage.c"
}

void
media_page_on_move_to_trash (MediaPage* self)
{
	MediaPageClass* _klass_;
#line 554 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 554 "../src/Views/MediaPage.vala"
	if (_klass_->on_move_to_trash) {
#line 554 "../src/Views/MediaPage.vala"
		_klass_->on_move_to_trash (self);
#line 4193 "MediaPage.c"
	}
}

static void
media_page_real_on_display_titles (MediaPage* self,
                                   GtkAction* action)
{
	gboolean display = FALSE;
	GSettings* _tmp0_;
#line 571 "../src/Views/MediaPage.vala"
	g_return_if_fail (action != NULL);
#line 572 "../src/Views/MediaPage.vala"
	display = gtk_toggle_action_get_active (G_TYPE_CHECK_INSTANCE_CAST (action, gtk_toggle_action_get_type (), GtkToggleAction));
#line 574 "../src/Views/MediaPage.vala"
	checkerboard_page_set_display_titles ((CheckerboardPage*) self, display);
#line 576 "../src/Views/MediaPage.vala"
	_tmp0_ = ((Page*) self)->ui_settings;
#line 576 "../src/Views/MediaPage.vala"
	g_settings_set_boolean (_tmp0_, "display-photo-titles", display);
#line 4213 "MediaPage.c"
}

void
media_page_on_display_titles (MediaPage* self,
                              GtkAction* action)
{
	MediaPageClass* _klass_;
#line 571 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 571 "../src/Views/MediaPage.vala"
	if (_klass_->on_display_titles) {
#line 571 "../src/Views/MediaPage.vala"
		_klass_->on_display_titles (self, action);
#line 4229 "MediaPage.c"
	}
}

static void
media_page_real_on_display_comments (MediaPage* self,
                                     GtkAction* action)
{
	gboolean display = FALSE;
	GSettings* _tmp0_;
#line 579 "../src/Views/MediaPage.vala"
	g_return_if_fail (action != NULL);
#line 580 "../src/Views/MediaPage.vala"
	display = gtk_toggle_action_get_active (G_TYPE_CHECK_INSTANCE_CAST (action, gtk_toggle_action_get_type (), GtkToggleAction));
#line 582 "../src/Views/MediaPage.vala"
	checkerboard_page_set_display_comments ((CheckerboardPage*) self, display);
#line 584 "../src/Views/MediaPage.vala"
	_tmp0_ = ((Page*) self)->ui_settings;
#line 584 "../src/Views/MediaPage.vala"
	g_settings_set_boolean (_tmp0_, "display-photo-comments", display);
#line 4249 "MediaPage.c"
}

void
media_page_on_display_comments (MediaPage* self,
                                GtkAction* action)
{
	MediaPageClass* _klass_;
#line 579 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 579 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 579 "../src/Views/MediaPage.vala"
	if (_klass_->on_display_comments) {
#line 579 "../src/Views/MediaPage.vala"
		_klass_->on_display_comments (self, action);
#line 4265 "MediaPage.c"
	}
}

static void
media_page_real_on_display_tags (MediaPage* self,
                                 GtkAction* action)
{
	gboolean display = FALSE;
	GSettings* _tmp0_;
#line 587 "../src/Views/MediaPage.vala"
	g_return_if_fail (action != NULL);
#line 588 "../src/Views/MediaPage.vala"
	display = gtk_toggle_action_get_active (G_TYPE_CHECK_INSTANCE_CAST (action, gtk_toggle_action_get_type (), GtkToggleAction));
#line 590 "../src/Views/MediaPage.vala"
	media_page_set_display_tags (self, display);
#line 592 "../src/Views/MediaPage.vala"
	_tmp0_ = ((Page*) self)->ui_settings;
#line 592 "../src/Views/MediaPage.vala"
	g_settings_set_boolean (_tmp0_, "display-photo-tags", display);
#line 4285 "MediaPage.c"
}

void
media_page_on_display_tags (MediaPage* self,
                            GtkAction* action)
{
	MediaPageClass* _klass_;
#line 587 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 587 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 587 "../src/Views/MediaPage.vala"
	if (_klass_->on_display_tags) {
#line 587 "../src/Views/MediaPage.vala"
		_klass_->on_display_tags (self, action);
#line 4301 "MediaPage.c"
	}
}

static void
media_page_real_get_config_photos_sort (MediaPage* self,
                                        gboolean* sort_order,
                                        gint* sort_by)
{
	gboolean _vala_sort_order = FALSE;
	gint _vala_sort_by = 0;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 596 "../src/Views/MediaPage.vala"
	_tmp0_ = ((Page*) self)->ui_settings;
#line 596 "../src/Views/MediaPage.vala"
	_vala_sort_order = g_settings_get_boolean (_tmp0_, "library-photos-sort-ascending");
#line 597 "../src/Views/MediaPage.vala"
	_tmp1_ = ((Page*) self)->ui_settings;
#line 597 "../src/Views/MediaPage.vala"
	_vala_sort_by = g_settings_get_int (_tmp1_, "library-photos-sort-by");
#line 595 "../src/Views/MediaPage.vala"
	if (sort_order) {
#line 595 "../src/Views/MediaPage.vala"
		*sort_order = _vala_sort_order;
#line 4326 "MediaPage.c"
	}
#line 595 "../src/Views/MediaPage.vala"
	if (sort_by) {
#line 595 "../src/Views/MediaPage.vala"
		*sort_by = _vala_sort_by;
#line 4332 "MediaPage.c"
	}
}

void
media_page_get_config_photos_sort (MediaPage* self,
                                   gboolean* sort_order,
                                   gint* sort_by)
{
	MediaPageClass* _klass_;
#line 595 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 595 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 595 "../src/Views/MediaPage.vala"
	if (_klass_->get_config_photos_sort) {
#line 595 "../src/Views/MediaPage.vala"
		_klass_->get_config_photos_sort (self, sort_order, sort_by);
#line 4350 "MediaPage.c"
	}
}

static void
media_page_real_set_config_photos_sort (MediaPage* self,
                                        gboolean sort_order,
                                        gint sort_by)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 601 "../src/Views/MediaPage.vala"
	_tmp0_ = ((Page*) self)->ui_settings;
#line 601 "../src/Views/MediaPage.vala"
	g_settings_set_boolean (_tmp0_, "library-photos-sort-ascending", sort_order);
#line 602 "../src/Views/MediaPage.vala"
	_tmp1_ = ((Page*) self)->ui_settings;
#line 602 "../src/Views/MediaPage.vala"
	g_settings_set_int (_tmp1_, "library-photos-sort-by", sort_by);
#line 4369 "MediaPage.c"
}

void
media_page_set_config_photos_sort (MediaPage* self,
                                   gboolean sort_order,
                                   gint sort_by)
{
	MediaPageClass* _klass_;
#line 600 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 600 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 600 "../src/Views/MediaPage.vala"
	if (_klass_->set_config_photos_sort) {
#line 600 "../src/Views/MediaPage.vala"
		_klass_->set_config_photos_sort (self, sort_order, sort_by);
#line 4386 "MediaPage.c"
	}
}

static void
media_page_real_on_sort_changed (MediaPage* self)
{
	gint sort_by = 0;
	gboolean sort_order = FALSE;
#line 606 "../src/Views/MediaPage.vala"
	sort_by = media_page_get_menu_sort_by (self);
#line 607 "../src/Views/MediaPage.vala"
	sort_order = media_page_get_menu_sort_order (self);
#line 609 "../src/Views/MediaPage.vala"
	media_page_set_view_comparator (self, sort_by, sort_order);
#line 610 "../src/Views/MediaPage.vala"
	media_page_set_config_photos_sort (self, sort_order, sort_by);
#line 4403 "MediaPage.c"
}

void
media_page_on_sort_changed (MediaPage* self)
{
	MediaPageClass* _klass_;
#line 605 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 605 "../src/Views/MediaPage.vala"
	if (_klass_->on_sort_changed) {
#line 605 "../src/Views/MediaPage.vala"
		_klass_->on_sort_changed (self);
#line 4418 "MediaPage.c"
	}
}

static void
media_page_on_raw_developer_shotwell (MediaPage* self,
                                      GtkAction* action)
{
#line 613 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 613 "../src/Views/MediaPage.vala"
	g_return_if_fail (action != NULL);
#line 614 "../src/Views/MediaPage.vala"
	media_page_developer_changed (self, RAW_DEVELOPER_SHOTWELL);
#line 4432 "MediaPage.c"
}

static void
media_page_on_raw_developer_camera (MediaPage* self,
                                    GtkAction* action)
{
#line 617 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 617 "../src/Views/MediaPage.vala"
	g_return_if_fail (action != NULL);
#line 618 "../src/Views/MediaPage.vala"
	media_page_developer_changed (self, RAW_DEVELOPER_CAMERA);
#line 4445 "MediaPage.c"
}

static void
media_page_real_developer_changed (MediaPage* self,
                                   RawDeveloper rd)
{
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	gboolean _tmp2_;
	gboolean need_warn = FALSE;
	GeeArrayList* to_set = NULL;
	GeeArrayList* _tmp3_;
	gboolean _tmp25_ = FALSE;
#line 622 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 622 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 622 "../src/Views/MediaPage.vala"
	_tmp2_ = view_collection_get_selected_count (_tmp1_) == 0;
#line 622 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 622 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 623 "../src/Views/MediaPage.vala"
		return;
#line 4471 "MediaPage.c"
	}
#line 628 "../src/Views/MediaPage.vala"
	need_warn = FALSE;
#line 631 "../src/Views/MediaPage.vala"
	_tmp3_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 631 "../src/Views/MediaPage.vala"
	to_set = _tmp3_;
#line 4479 "MediaPage.c"
	{
		GeeList* _view_list = NULL;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
		GeeList* _tmp6_;
		GeeList* _tmp7_;
		gint _view_size = 0;
		GeeList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _view_index = 0;
#line 632 "../src/Views/MediaPage.vala"
		_tmp4_ = page_get_view ((Page*) self);
#line 632 "../src/Views/MediaPage.vala"
		_tmp5_ = _tmp4_;
#line 632 "../src/Views/MediaPage.vala"
		_tmp6_ = view_collection_get_selected (_tmp5_);
#line 632 "../src/Views/MediaPage.vala"
		_tmp7_ = _tmp6_;
#line 632 "../src/Views/MediaPage.vala"
		_data_collection_unref0 (_tmp5_);
#line 632 "../src/Views/MediaPage.vala"
		_view_list = _tmp7_;
#line 632 "../src/Views/MediaPage.vala"
		_tmp8_ = _view_list;
#line 632 "../src/Views/MediaPage.vala"
		_tmp9_ = gee_collection_get_size ((GeeCollection*) _tmp8_);
#line 632 "../src/Views/MediaPage.vala"
		_tmp10_ = _tmp9_;
#line 632 "../src/Views/MediaPage.vala"
		_view_size = _tmp10_;
#line 632 "../src/Views/MediaPage.vala"
		_view_index = -1;
#line 632 "../src/Views/MediaPage.vala"
		while (TRUE) {
#line 4515 "MediaPage.c"
			gint _tmp11_;
			gint _tmp12_;
			DataView* view = NULL;
			GeeList* _tmp13_;
			gpointer _tmp14_;
			Photo* p = NULL;
			DataView* _tmp15_;
			DataSource* _tmp16_;
			DataSource* _tmp17_;
			Photo* _tmp18_;
			gboolean _tmp19_ = FALSE;
			Photo* _tmp20_;
#line 632 "../src/Views/MediaPage.vala"
			_view_index = _view_index + 1;
#line 632 "../src/Views/MediaPage.vala"
			_tmp11_ = _view_index;
#line 632 "../src/Views/MediaPage.vala"
			_tmp12_ = _view_size;
#line 632 "../src/Views/MediaPage.vala"
			if (!(_tmp11_ < _tmp12_)) {
#line 632 "../src/Views/MediaPage.vala"
				break;
#line 4538 "MediaPage.c"
			}
#line 632 "../src/Views/MediaPage.vala"
			_tmp13_ = _view_list;
#line 632 "../src/Views/MediaPage.vala"
			_tmp14_ = gee_list_get (_tmp13_, _view_index);
#line 632 "../src/Views/MediaPage.vala"
			view = (DataView*) _tmp14_;
#line 633 "../src/Views/MediaPage.vala"
			_tmp15_ = view;
#line 633 "../src/Views/MediaPage.vala"
			_tmp16_ = data_view_get_source (_tmp15_);
#line 633 "../src/Views/MediaPage.vala"
			_tmp17_ = _tmp16_;
#line 633 "../src/Views/MediaPage.vala"
			_tmp18_ = _g_object_ref0 (IS_PHOTO (_tmp17_) ? ((Photo*) _tmp17_) : NULL);
#line 633 "../src/Views/MediaPage.vala"
			p = _tmp18_;
#line 634 "../src/Views/MediaPage.vala"
			_tmp20_ = p;
#line 634 "../src/Views/MediaPage.vala"
			if (_tmp20_ != NULL) {
#line 4560 "MediaPage.c"
				Photo* _tmp21_;
#line 634 "../src/Views/MediaPage.vala"
				_tmp21_ = p;
#line 634 "../src/Views/MediaPage.vala"
				_tmp19_ = !raw_developer_is_equivalent (rd, photo_get_raw_developer (_tmp21_));
#line 4566 "MediaPage.c"
			} else {
#line 634 "../src/Views/MediaPage.vala"
				_tmp19_ = FALSE;
#line 4570 "MediaPage.c"
			}
#line 634 "../src/Views/MediaPage.vala"
			if (_tmp19_) {
#line 4574 "MediaPage.c"
				GeeArrayList* _tmp22_;
				DataView* _tmp23_;
				Photo* _tmp24_;
#line 635 "../src/Views/MediaPage.vala"
				_tmp22_ = to_set;
#line 635 "../src/Views/MediaPage.vala"
				_tmp23_ = view;
#line 635 "../src/Views/MediaPage.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 637 "../src/Views/MediaPage.vala"
				_tmp24_ = p;
#line 637 "../src/Views/MediaPage.vala"
				if (photo_has_transformations (_tmp24_)) {
#line 638 "../src/Views/MediaPage.vala"
					need_warn = TRUE;
#line 4590 "MediaPage.c"
				}
			}
#line 632 "../src/Views/MediaPage.vala"
			_g_object_unref0 (p);
#line 632 "../src/Views/MediaPage.vala"
			_g_object_unref0 (view);
#line 4597 "MediaPage.c"
		}
#line 632 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_view_list);
#line 4601 "MediaPage.c"
	}
#line 643 "../src/Views/MediaPage.vala"
	if (!need_warn) {
#line 643 "../src/Views/MediaPage.vala"
		_tmp25_ = TRUE;
#line 4607 "MediaPage.c"
	} else {
		GeeArrayList* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 643 "../src/Views/MediaPage.vala"
		_tmp26_ = to_set;
#line 643 "../src/Views/MediaPage.vala"
		_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
#line 643 "../src/Views/MediaPage.vala"
		_tmp28_ = _tmp27_;
#line 643 "../src/Views/MediaPage.vala"
		_tmp25_ = dialogs_confirm_warn_developer_changed (_tmp28_);
#line 4620 "MediaPage.c"
	}
#line 643 "../src/Views/MediaPage.vala"
	if (_tmp25_) {
#line 4624 "MediaPage.c"
		SetRawDeveloperCommand* command = NULL;
		GeeArrayList* _tmp29_;
		SetRawDeveloperCommand* _tmp30_;
		CommandManager* _tmp31_;
		CommandManager* _tmp32_;
		SetRawDeveloperCommand* _tmp33_;
#line 644 "../src/Views/MediaPage.vala"
		_tmp29_ = to_set;
#line 644 "../src/Views/MediaPage.vala"
		_tmp30_ = set_raw_developer_command_new ((GeeIterable*) _tmp29_, rd);
#line 644 "../src/Views/MediaPage.vala"
		command = _tmp30_;
#line 645 "../src/Views/MediaPage.vala"
		_tmp31_ = page_get_command_manager ((Page*) self);
#line 645 "../src/Views/MediaPage.vala"
		_tmp32_ = _tmp31_;
#line 645 "../src/Views/MediaPage.vala"
		_tmp33_ = command;
#line 645 "../src/Views/MediaPage.vala"
		command_manager_execute (_tmp32_, (Command*) _tmp33_);
#line 645 "../src/Views/MediaPage.vala"
		_command_manager_unref0 (_tmp32_);
#line 647 "../src/Views/MediaPage.vala"
		media_page_update_development_menu_item_sensitivity (self);
#line 643 "../src/Views/MediaPage.vala"
		_g_object_unref0 (command);
#line 4651 "MediaPage.c"
	}
#line 621 "../src/Views/MediaPage.vala"
	_g_object_unref0 (to_set);
#line 4655 "MediaPage.c"
}

void
media_page_developer_changed (MediaPage* self,
                              RawDeveloper rd)
{
	MediaPageClass* _klass_;
#line 621 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 621 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 621 "../src/Views/MediaPage.vala"
	if (_klass_->developer_changed) {
#line 621 "../src/Views/MediaPage.vala"
		_klass_->developer_changed (self, rd);
#line 4671 "MediaPage.c"
	}
}

static void
media_page_real_set_display_titles (CheckerboardPage* base,
                                    gboolean display)
{
	MediaPage * self;
	GtkToggleAction* action = NULL;
	GtkAction* _tmp0_;
	GtkToggleAction* _tmp1_;
	GtkToggleAction* _tmp2_;
#line 651 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 652 "../src/Views/MediaPage.vala"
	CHECKERBOARD_PAGE_CLASS (media_page_parent_class)->set_display_titles (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), display);
#line 654 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_action ((Page*) self, "ViewTitle");
#line 654 "../src/Views/MediaPage.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_toggle_action_get_type ()) ? ((GtkToggleAction*) _tmp0_) : NULL;
#line 654 "../src/Views/MediaPage.vala"
	if (_tmp1_ == NULL) {
#line 654 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp0_);
#line 4696 "MediaPage.c"
	}
#line 654 "../src/Views/MediaPage.vala"
	action = _tmp1_;
#line 655 "../src/Views/MediaPage.vala"
	_tmp2_ = action;
#line 655 "../src/Views/MediaPage.vala"
	if (_tmp2_ != NULL) {
#line 4704 "MediaPage.c"
		GtkToggleAction* _tmp3_;
#line 656 "../src/Views/MediaPage.vala"
		_tmp3_ = action;
#line 656 "../src/Views/MediaPage.vala"
		gtk_toggle_action_set_active (_tmp3_, display);
#line 4710 "MediaPage.c"
	}
#line 651 "../src/Views/MediaPage.vala"
	_g_object_unref0 (action);
#line 4714 "MediaPage.c"
}

static void
media_page_real_set_display_comments (CheckerboardPage* base,
                                      gboolean display)
{
	MediaPage * self;
	GtkToggleAction* action = NULL;
	GtkAction* _tmp0_;
	GtkToggleAction* _tmp1_;
	GtkToggleAction* _tmp2_;
#line 659 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 660 "../src/Views/MediaPage.vala"
	CHECKERBOARD_PAGE_CLASS (media_page_parent_class)->set_display_comments (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage), display);
#line 662 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_action ((Page*) self, "ViewComment");
#line 662 "../src/Views/MediaPage.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_toggle_action_get_type ()) ? ((GtkToggleAction*) _tmp0_) : NULL;
#line 662 "../src/Views/MediaPage.vala"
	if (_tmp1_ == NULL) {
#line 662 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp0_);
#line 4738 "MediaPage.c"
	}
#line 662 "../src/Views/MediaPage.vala"
	action = _tmp1_;
#line 663 "../src/Views/MediaPage.vala"
	_tmp2_ = action;
#line 663 "../src/Views/MediaPage.vala"
	if (_tmp2_ != NULL) {
#line 4746 "MediaPage.c"
		GtkToggleAction* _tmp3_;
#line 664 "../src/Views/MediaPage.vala"
		_tmp3_ = action;
#line 664 "../src/Views/MediaPage.vala"
		gtk_toggle_action_set_active (_tmp3_, display);
#line 4752 "MediaPage.c"
	}
#line 659 "../src/Views/MediaPage.vala"
	_g_object_unref0 (action);
#line 4756 "MediaPage.c"
}

static GtkRadioAction*
media_page_sort_by_title_action (MediaPage* self)
{
	GtkRadioAction* action = NULL;
	GtkAction* _tmp0_;
	GtkRadioAction* result;
#line 667 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 668 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_action ((Page*) self, "SortByTitle");
#line 668 "../src/Views/MediaPage.vala"
	action = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_radio_action_get_type (), GtkRadioAction);
#line 669 "../src/Views/MediaPage.vala"
	_vala_assert (action != NULL, "action != null");
#line 670 "../src/Views/MediaPage.vala"
	result = action;
#line 670 "../src/Views/MediaPage.vala"
	return result;
#line 4777 "MediaPage.c"
}

static GtkRadioAction*
media_page_sort_ascending_action (MediaPage* self)
{
	GtkRadioAction* action = NULL;
	GtkAction* _tmp0_;
	GtkRadioAction* result;
#line 673 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 674 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_action ((Page*) self, "SortAscending");
#line 674 "../src/Views/MediaPage.vala"
	action = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_radio_action_get_type (), GtkRadioAction);
#line 675 "../src/Views/MediaPage.vala"
	_vala_assert (action != NULL, "action != null");
#line 676 "../src/Views/MediaPage.vala"
	result = action;
#line 676 "../src/Views/MediaPage.vala"
	return result;
#line 4798 "MediaPage.c"
}

gint
media_page_get_menu_sort_by (MediaPage* self)
{
	GtkRadioAction* _tmp0_;
	GtkRadioAction* _tmp1_;
	gint _tmp2_;
	gint result;
#line 679 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 681 "../src/Views/MediaPage.vala"
	_tmp0_ = media_page_sort_by_title_action (self);
#line 681 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 681 "../src/Views/MediaPage.vala"
	_tmp2_ = gtk_radio_action_get_current_value (_tmp1_);
#line 681 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp1_);
#line 681 "../src/Views/MediaPage.vala"
	result = _tmp2_;
#line 681 "../src/Views/MediaPage.vala"
	return result;
#line 4822 "MediaPage.c"
}

void
media_page_set_menu_sort_by (MediaPage* self,
                             gint val)
{
	GtkRadioAction* _tmp0_;
	GtkRadioAction* _tmp1_;
#line 684 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 685 "../src/Views/MediaPage.vala"
	_tmp0_ = media_page_sort_by_title_action (self);
#line 685 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 685 "../src/Views/MediaPage.vala"
	gtk_radio_action_set_current_value (_tmp1_, val);
#line 685 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp1_);
#line 4841 "MediaPage.c"
}

gboolean
media_page_get_menu_sort_order (MediaPage* self)
{
	GtkRadioAction* _tmp0_;
	GtkRadioAction* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 688 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 690 "../src/Views/MediaPage.vala"
	_tmp0_ = media_page_sort_ascending_action (self);
#line 690 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 690 "../src/Views/MediaPage.vala"
	_tmp2_ = gtk_radio_action_get_current_value (_tmp1_) == MEDIA_PAGE_SORT_ORDER_ASCENDING;
#line 690 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp1_);
#line 690 "../src/Views/MediaPage.vala"
	result = _tmp2_;
#line 690 "../src/Views/MediaPage.vala"
	return result;
#line 4865 "MediaPage.c"
}

void
media_page_set_menu_sort_order (MediaPage* self,
                                gboolean ascending)
{
	gint _tmp0_ = 0;
	GtkRadioAction* _tmp1_;
	GtkRadioAction* _tmp2_;
#line 693 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 695 "../src/Views/MediaPage.vala"
	if (ascending) {
#line 695 "../src/Views/MediaPage.vala"
		_tmp0_ = MEDIA_PAGE_SORT_ORDER_ASCENDING;
#line 4881 "MediaPage.c"
	} else {
#line 695 "../src/Views/MediaPage.vala"
		_tmp0_ = MEDIA_PAGE_SORT_ORDER_DESCENDING;
#line 4885 "MediaPage.c"
	}
#line 694 "../src/Views/MediaPage.vala"
	_tmp1_ = media_page_sort_ascending_action (self);
#line 694 "../src/Views/MediaPage.vala"
	_tmp2_ = _tmp1_;
#line 694 "../src/Views/MediaPage.vala"
	gtk_radio_action_set_current_value (_tmp2_, _tmp0_);
#line 694 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp2_);
#line 4895 "MediaPage.c"
}

static gint64
_thumbnail_title_ascending_comparator_comparator (void* a,
                                                  void* b,
                                                  gpointer self)
{
	gint64 result;
	result = thumbnail_title_ascending_comparator (a, b);
#line 705 "../src/Views/MediaPage.vala"
	return result;
#line 4907 "MediaPage.c"
}

static gint64
_thumbnail_title_descending_comparator_comparator (void* a,
                                                   void* b,
                                                   gpointer self)
{
	gint64 result;
	result = thumbnail_title_descending_comparator (a, b);
#line 706 "../src/Views/MediaPage.vala"
	return result;
#line 4919 "MediaPage.c"
}

static gboolean
_thumbnail_title_comparator_predicate_comparator_predicate (DataObject* object,
                                                            Alteration* alteration,
                                                            gpointer self)
{
	gboolean result;
	result = thumbnail_title_comparator_predicate (object, alteration);
#line 707 "../src/Views/MediaPage.vala"
	return result;
#line 4931 "MediaPage.c"
}

static gint64
_thumbnail_exposure_time_ascending_comparator_comparator (void* a,
                                                          void* b,
                                                          gpointer self)
{
	gint64 result;
	result = thumbnail_exposure_time_ascending_comparator (a, b);
#line 712 "../src/Views/MediaPage.vala"
	return result;
#line 4943 "MediaPage.c"
}

static gint64
_thumbnail_exposure_time_descending_comparator_comparator (void* a,
                                                           void* b,
                                                           gpointer self)
{
	gint64 result;
	result = thumbnail_exposure_time_descending_comparator (a, b);
#line 713 "../src/Views/MediaPage.vala"
	return result;
#line 4955 "MediaPage.c"
}

static gboolean
_thumbnail_exposure_time_comparator_predicate_comparator_predicate (DataObject* object,
                                                                    Alteration* alteration,
                                                                    gpointer self)
{
	gboolean result;
	result = thumbnail_exposure_time_comparator_predicate (object, alteration);
#line 714 "../src/Views/MediaPage.vala"
	return result;
#line 4967 "MediaPage.c"
}

static gint64
_thumbnail_timestamp_ascending_comparator_comparator (void* a,
                                                      void* b,
                                                      gpointer self)
{
	gint64 result;
	result = thumbnail_timestamp_ascending_comparator (a, b);
#line 719 "../src/Views/MediaPage.vala"
	return result;
#line 4979 "MediaPage.c"
}

static gint64
_thumbnail_timestamp_descending_comparator_comparator (void* a,
                                                       void* b,
                                                       gpointer self)
{
	gint64 result;
	result = thumbnail_timestamp_descending_comparator (a, b);
#line 720 "../src/Views/MediaPage.vala"
	return result;
#line 4991 "MediaPage.c"
}

static gboolean
_thumbnail_timestamp_comparator_predicate_comparator_predicate (DataObject* object,
                                                                Alteration* alteration,
                                                                gpointer self)
{
	gboolean result;
	result = thumbnail_timestamp_comparator_predicate (object, alteration);
#line 721 "../src/Views/MediaPage.vala"
	return result;
#line 5003 "MediaPage.c"
}

static void
media_page_set_view_comparator (MediaPage* self,
                                gint sort_by,
                                gboolean ascending)
{
	Comparator comparator = NULL;
	gpointer comparator_target = NULL;
	GDestroyNotify comparator_target_destroy_notify = NULL;
	ComparatorPredicate predicate = NULL;
	gpointer predicate_target = NULL;
	GDestroyNotify predicate_target_destroy_notify = NULL;
	ViewCollection* _tmp2_;
	ViewCollection* _tmp3_;
	Comparator _tmp4_;
	gpointer _tmp4__target;
	ComparatorPredicate _tmp5_;
	gpointer _tmp5__target;
#line 698 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 702 "../src/Views/MediaPage.vala"
	switch (sort_by) {
#line 702 "../src/Views/MediaPage.vala"
		case MEDIA_PAGE_SORT_BY_TITLE:
#line 5029 "MediaPage.c"
		{
#line 704 "../src/Views/MediaPage.vala"
			if (ascending) {
#line 705 "../src/Views/MediaPage.vala"
				(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 705 "../src/Views/MediaPage.vala"
				comparator = NULL;
#line 705 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 705 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 705 "../src/Views/MediaPage.vala"
				comparator = _thumbnail_title_ascending_comparator_comparator;
#line 705 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 705 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 5047 "MediaPage.c"
			} else {
#line 706 "../src/Views/MediaPage.vala"
				(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 706 "../src/Views/MediaPage.vala"
				comparator = NULL;
#line 706 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 706 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 706 "../src/Views/MediaPage.vala"
				comparator = _thumbnail_title_descending_comparator_comparator;
#line 706 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 706 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 5063 "MediaPage.c"
			}
#line 707 "../src/Views/MediaPage.vala"
			(predicate_target_destroy_notify == NULL) ? NULL : (predicate_target_destroy_notify (predicate_target), NULL);
#line 707 "../src/Views/MediaPage.vala"
			predicate = NULL;
#line 707 "../src/Views/MediaPage.vala"
			predicate_target = NULL;
#line 707 "../src/Views/MediaPage.vala"
			predicate_target_destroy_notify = NULL;
#line 707 "../src/Views/MediaPage.vala"
			predicate = _thumbnail_title_comparator_predicate_comparator_predicate;
#line 707 "../src/Views/MediaPage.vala"
			predicate_target = NULL;
#line 707 "../src/Views/MediaPage.vala"
			predicate_target_destroy_notify = NULL;
#line 708 "../src/Views/MediaPage.vala"
			break;
#line 5081 "MediaPage.c"
		}
#line 702 "../src/Views/MediaPage.vala"
		case MEDIA_PAGE_SORT_BY_EXPOSURE_DATE:
#line 5085 "MediaPage.c"
		{
#line 711 "../src/Views/MediaPage.vala"
			if (ascending) {
#line 712 "../src/Views/MediaPage.vala"
				(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 712 "../src/Views/MediaPage.vala"
				comparator = NULL;
#line 712 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 712 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 712 "../src/Views/MediaPage.vala"
				comparator = _thumbnail_exposure_time_ascending_comparator_comparator;
#line 712 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 712 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 5103 "MediaPage.c"
			} else {
#line 713 "../src/Views/MediaPage.vala"
				(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 713 "../src/Views/MediaPage.vala"
				comparator = NULL;
#line 713 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 713 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 713 "../src/Views/MediaPage.vala"
				comparator = _thumbnail_exposure_time_descending_comparator_comparator;
#line 713 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 713 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 5119 "MediaPage.c"
			}
#line 714 "../src/Views/MediaPage.vala"
			(predicate_target_destroy_notify == NULL) ? NULL : (predicate_target_destroy_notify (predicate_target), NULL);
#line 714 "../src/Views/MediaPage.vala"
			predicate = NULL;
#line 714 "../src/Views/MediaPage.vala"
			predicate_target = NULL;
#line 714 "../src/Views/MediaPage.vala"
			predicate_target_destroy_notify = NULL;
#line 714 "../src/Views/MediaPage.vala"
			predicate = _thumbnail_exposure_time_comparator_predicate_comparator_predicate;
#line 714 "../src/Views/MediaPage.vala"
			predicate_target = NULL;
#line 714 "../src/Views/MediaPage.vala"
			predicate_target_destroy_notify = NULL;
#line 715 "../src/Views/MediaPage.vala"
			break;
#line 5137 "MediaPage.c"
		}
#line 702 "../src/Views/MediaPage.vala"
		case MEDIA_PAGE_SORT_BY_TIMESTAMP:
#line 5141 "MediaPage.c"
		{
#line 718 "../src/Views/MediaPage.vala"
			if (ascending) {
#line 719 "../src/Views/MediaPage.vala"
				(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 719 "../src/Views/MediaPage.vala"
				comparator = NULL;
#line 719 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 719 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 719 "../src/Views/MediaPage.vala"
				comparator = _thumbnail_timestamp_ascending_comparator_comparator;
#line 719 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 719 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 5159 "MediaPage.c"
			} else {
#line 720 "../src/Views/MediaPage.vala"
				(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 720 "../src/Views/MediaPage.vala"
				comparator = NULL;
#line 720 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 720 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 720 "../src/Views/MediaPage.vala"
				comparator = _thumbnail_timestamp_descending_comparator_comparator;
#line 720 "../src/Views/MediaPage.vala"
				comparator_target = NULL;
#line 720 "../src/Views/MediaPage.vala"
				comparator_target_destroy_notify = NULL;
#line 5175 "MediaPage.c"
			}
#line 721 "../src/Views/MediaPage.vala"
			(predicate_target_destroy_notify == NULL) ? NULL : (predicate_target_destroy_notify (predicate_target), NULL);
#line 721 "../src/Views/MediaPage.vala"
			predicate = NULL;
#line 721 "../src/Views/MediaPage.vala"
			predicate_target = NULL;
#line 721 "../src/Views/MediaPage.vala"
			predicate_target_destroy_notify = NULL;
#line 721 "../src/Views/MediaPage.vala"
			predicate = _thumbnail_timestamp_comparator_predicate_comparator_predicate;
#line 721 "../src/Views/MediaPage.vala"
			predicate_target = NULL;
#line 721 "../src/Views/MediaPage.vala"
			predicate_target_destroy_notify = NULL;
#line 722 "../src/Views/MediaPage.vala"
			break;
#line 5193 "MediaPage.c"
		}
		default:
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 725 "../src/Views/MediaPage.vala"
			_tmp0_ = g_strdup_printf ("%i", media_page_get_menu_sort_by (self));
#line 725 "../src/Views/MediaPage.vala"
			_tmp1_ = _tmp0_;
#line 725 "../src/Views/MediaPage.vala"
			g_debug ("MediaPage.vala:725: Unknown sort criteria: %s", _tmp1_);
#line 725 "../src/Views/MediaPage.vala"
			_g_free0 (_tmp1_);
#line 726 "../src/Views/MediaPage.vala"
			(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 726 "../src/Views/MediaPage.vala"
			comparator = NULL;
#line 726 "../src/Views/MediaPage.vala"
			comparator_target = NULL;
#line 726 "../src/Views/MediaPage.vala"
			comparator_target_destroy_notify = NULL;
#line 726 "../src/Views/MediaPage.vala"
			comparator = _thumbnail_title_descending_comparator_comparator;
#line 726 "../src/Views/MediaPage.vala"
			comparator_target = NULL;
#line 726 "../src/Views/MediaPage.vala"
			comparator_target_destroy_notify = NULL;
#line 727 "../src/Views/MediaPage.vala"
			(predicate_target_destroy_notify == NULL) ? NULL : (predicate_target_destroy_notify (predicate_target), NULL);
#line 727 "../src/Views/MediaPage.vala"
			predicate = NULL;
#line 727 "../src/Views/MediaPage.vala"
			predicate_target = NULL;
#line 727 "../src/Views/MediaPage.vala"
			predicate_target_destroy_notify = NULL;
#line 727 "../src/Views/MediaPage.vala"
			predicate = _thumbnail_title_comparator_predicate_comparator_predicate;
#line 727 "../src/Views/MediaPage.vala"
			predicate_target = NULL;
#line 727 "../src/Views/MediaPage.vala"
			predicate_target_destroy_notify = NULL;
#line 728 "../src/Views/MediaPage.vala"
			break;
#line 5237 "MediaPage.c"
		}
	}
#line 731 "../src/Views/MediaPage.vala"
	_tmp2_ = page_get_view ((Page*) self);
#line 731 "../src/Views/MediaPage.vala"
	_tmp3_ = _tmp2_;
#line 731 "../src/Views/MediaPage.vala"
	_tmp4_ = comparator;
#line 731 "../src/Views/MediaPage.vala"
	_tmp4__target = comparator_target;
#line 731 "../src/Views/MediaPage.vala"
	_tmp5_ = predicate;
#line 731 "../src/Views/MediaPage.vala"
	_tmp5__target = predicate_target;
#line 731 "../src/Views/MediaPage.vala"
	data_collection_set_comparator ((DataCollection*) _tmp3_, _tmp4_, _tmp4__target, _tmp5_, _tmp5__target);
#line 731 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp3_);
#line 698 "../src/Views/MediaPage.vala"
	(predicate_target_destroy_notify == NULL) ? NULL : (predicate_target_destroy_notify (predicate_target), NULL);
#line 698 "../src/Views/MediaPage.vala"
	predicate = NULL;
#line 698 "../src/Views/MediaPage.vala"
	predicate_target = NULL;
#line 698 "../src/Views/MediaPage.vala"
	predicate_target_destroy_notify = NULL;
#line 698 "../src/Views/MediaPage.vala"
	(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 698 "../src/Views/MediaPage.vala"
	comparator = NULL;
#line 698 "../src/Views/MediaPage.vala"
	comparator_target = NULL;
#line 698 "../src/Views/MediaPage.vala"
	comparator_target_destroy_notify = NULL;
#line 5272 "MediaPage.c"
}

void
media_page_sync_sort (MediaPage* self)
{
	gboolean sort_ascending = FALSE;
	gint sort_by = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
#line 734 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 751 "../src/Views/MediaPage.vala"
	media_page_get_config_photos_sort (self, &_tmp0_, &_tmp1_);
#line 751 "../src/Views/MediaPage.vala"
	sort_ascending = _tmp0_;
#line 751 "../src/Views/MediaPage.vala"
	sort_by = _tmp1_;
#line 753 "../src/Views/MediaPage.vala"
	media_page_set_menu_sort_by (self, sort_by);
#line 754 "../src/Views/MediaPage.vala"
	media_page_set_menu_sort_order (self, sort_ascending);
#line 756 "../src/Views/MediaPage.vala"
	media_page_set_view_comparator (self, sort_by, sort_ascending);
#line 5296 "MediaPage.c"
}

static void
media_page_real_destroy (GtkWidget* base)
{
	MediaPage * self;
#line 759 "../src/Views/MediaPage.vala"
	self = (MediaPage*) base;
#line 760 "../src/Views/MediaPage.vala"
	media_page_disconnect_slider (self);
#line 762 "../src/Views/MediaPage.vala"
	GTK_WIDGET_CLASS (media_page_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CHECKERBOARD_PAGE, CheckerboardPage));
#line 5309 "MediaPage.c"
}

static void
media_page_increase_zoom_level (MediaPage* self)
{
	SliderAssembly* _tmp0_;
#line 765 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 766 "../src/Views/MediaPage.vala"
	_tmp0_ = self->priv->connected_slider;
#line 766 "../src/Views/MediaPage.vala"
	if (_tmp0_ != NULL) {
#line 5322 "MediaPage.c"
		SliderAssembly* _tmp1_;
#line 767 "../src/Views/MediaPage.vala"
		_tmp1_ = self->priv->connected_slider;
#line 767 "../src/Views/MediaPage.vala"
		slider_assembly_increase_step (_tmp1_);
#line 5328 "MediaPage.c"
	} else {
		gint new_scale = 0;
#line 769 "../src/Views/MediaPage.vala"
		new_scale = media_page_compute_zoom_scale_increase (media_page_get_thumb_size (self));
#line 770 "../src/Views/MediaPage.vala"
		media_page_save_persistent_thumbnail_scale (self);
#line 771 "../src/Views/MediaPage.vala"
		media_page_set_thumb_size (self, new_scale);
#line 5337 "MediaPage.c"
	}
}

static void
media_page_decrease_zoom_level (MediaPage* self)
{
	SliderAssembly* _tmp0_;
#line 775 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 776 "../src/Views/MediaPage.vala"
	_tmp0_ = self->priv->connected_slider;
#line 776 "../src/Views/MediaPage.vala"
	if (_tmp0_ != NULL) {
#line 5351 "MediaPage.c"
		SliderAssembly* _tmp1_;
#line 777 "../src/Views/MediaPage.vala"
		_tmp1_ = self->priv->connected_slider;
#line 777 "../src/Views/MediaPage.vala"
		slider_assembly_decrease_step (_tmp1_);
#line 5357 "MediaPage.c"
	} else {
		gint new_scale = 0;
#line 779 "../src/Views/MediaPage.vala"
		new_scale = media_page_compute_zoom_scale_decrease (media_page_get_thumb_size (self));
#line 780 "../src/Views/MediaPage.vala"
		media_page_save_persistent_thumbnail_scale (self);
#line 781 "../src/Views/MediaPage.vala"
		media_page_set_thumb_size (self, new_scale);
#line 5366 "MediaPage.c"
	}
}

static DataView*
media_page_real_create_thumbnail (MediaPage* self,
                                  DataSource* source)
{
	Thumbnail* _tmp0_;
	DataView* result;
#line 785 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 786 "../src/Views/MediaPage.vala"
	_tmp0_ = thumbnail_new (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource), media_page_get_thumb_size (self));
#line 786 "../src/Views/MediaPage.vala"
	result = (DataView*) _tmp0_;
#line 786 "../src/Views/MediaPage.vala"
	return result;
#line 5384 "MediaPage.c"
}

DataView*
media_page_create_thumbnail (MediaPage* self,
                             DataSource* source)
{
	MediaPageClass* _klass_;
#line 785 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 785 "../src/Views/MediaPage.vala"
	_klass_ = MEDIA_PAGE_GET_CLASS (self);
#line 785 "../src/Views/MediaPage.vala"
	if (_klass_->create_thumbnail) {
#line 785 "../src/Views/MediaPage.vala"
		return _klass_->create_thumbnail (self, source);
#line 5400 "MediaPage.c"
	}
#line 785 "../src/Views/MediaPage.vala"
	return NULL;
#line 5404 "MediaPage.c"
}

static void
media_page_set_thumb_size (MediaPage* self,
                           gint new_scale)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	CheckerboardLayout* _tmp7_;
	CheckerboardLayout* _tmp8_;
	ViewCollection* _tmp9_;
	ViewCollection* _tmp10_;
	ViewCollection* _tmp11_;
	ViewCollection* _tmp12_;
	GValue _tmp13_ = {0};
	ViewCollection* _tmp14_;
	ViewCollection* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
#line 791 "../src/Views/MediaPage.vala"
	g_return_if_fail (self != NULL);
#line 792 "../src/Views/MediaPage.vala"
	if (media_page_get_thumb_size (self) == new_scale) {
#line 792 "../src/Views/MediaPage.vala"
		_tmp0_ = TRUE;
#line 5435 "MediaPage.c"
	} else {
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 792 "../src/Views/MediaPage.vala"
		_tmp1_ = page_get_in_view ((Page*) self);
#line 792 "../src/Views/MediaPage.vala"
		_tmp2_ = _tmp1_;
#line 792 "../src/Views/MediaPage.vala"
		_tmp0_ = !_tmp2_;
#line 5445 "MediaPage.c"
	}
#line 792 "../src/Views/MediaPage.vala"
	if (_tmp0_) {
#line 793 "../src/Views/MediaPage.vala"
		return;
#line 5451 "MediaPage.c"
	}
#line 795 "../src/Views/MediaPage.vala"
	_tmp3_ = thumbnail_get_MIN_SCALE ();
#line 795 "../src/Views/MediaPage.vala"
	_tmp4_ = _tmp3_;
#line 795 "../src/Views/MediaPage.vala"
	_tmp5_ = thumbnail_get_MAX_SCALE ();
#line 795 "../src/Views/MediaPage.vala"
	_tmp6_ = _tmp5_;
#line 795 "../src/Views/MediaPage.vala"
	new_scale = CLAMP (new_scale, _tmp4_, _tmp6_);
#line 796 "../src/Views/MediaPage.vala"
	_tmp7_ = checkerboard_page_get_checkerboard_layout ((CheckerboardPage*) self);
#line 796 "../src/Views/MediaPage.vala"
	_tmp8_ = _tmp7_;
#line 796 "../src/Views/MediaPage.vala"
	checkerboard_layout_set_scale (_tmp8_, new_scale);
#line 796 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp8_);
#line 799 "../src/Views/MediaPage.vala"
	_tmp9_ = page_get_view ((Page*) self);
#line 799 "../src/Views/MediaPage.vala"
	_tmp10_ = _tmp9_;
#line 799 "../src/Views/MediaPage.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp10_);
#line 799 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp10_);
#line 800 "../src/Views/MediaPage.vala"
	_tmp11_ = page_get_view ((Page*) self);
#line 800 "../src/Views/MediaPage.vala"
	_tmp12_ = _tmp11_;
#line 800 "../src/Views/MediaPage.vala"
	g_value_init (&_tmp13_, G_TYPE_INT);
#line 800 "../src/Views/MediaPage.vala"
	g_value_set_int (&_tmp13_, new_scale);
#line 800 "../src/Views/MediaPage.vala"
	data_collection_set_property ((DataCollection*) _tmp12_, THUMBNAIL_PROP_SIZE, &_tmp13_, NULL, NULL);
#line 800 "../src/Views/MediaPage.vala"
	G_IS_VALUE (&_tmp13_) ? (g_value_unset (&_tmp13_), NULL) : NULL;
#line 800 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp12_);
#line 801 "../src/Views/MediaPage.vala"
	_tmp14_ = page_get_view ((Page*) self);
#line 801 "../src/Views/MediaPage.vala"
	_tmp15_ = _tmp14_;
#line 801 "../src/Views/MediaPage.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp15_);
#line 801 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp15_);
#line 803 "../src/Views/MediaPage.vala"
	_tmp16_ = thumbnail_get_MAX_SCALE ();
#line 803 "../src/Views/MediaPage.vala"
	_tmp17_ = _tmp16_;
#line 803 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "IncreaseSize", new_scale < _tmp17_);
#line 804 "../src/Views/MediaPage.vala"
	_tmp18_ = thumbnail_get_MIN_SCALE ();
#line 804 "../src/Views/MediaPage.vala"
	_tmp19_ = _tmp18_;
#line 804 "../src/Views/MediaPage.vala"
	page_set_action_sensitive ((Page*) self, "DecreaseSize", new_scale > _tmp19_);
#line 5513 "MediaPage.c"
}

static gint
media_page_get_thumb_size (MediaPage* self)
{
	CheckerboardLayout* _tmp0_;
	CheckerboardLayout* _tmp1_;
	gboolean _tmp2_;
	CheckerboardLayout* _tmp6_;
	CheckerboardLayout* _tmp7_;
	gint _tmp8_;
	gint result;
#line 807 "../src/Views/MediaPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 808 "../src/Views/MediaPage.vala"
	_tmp0_ = checkerboard_page_get_checkerboard_layout ((CheckerboardPage*) self);
#line 808 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 808 "../src/Views/MediaPage.vala"
	_tmp2_ = checkerboard_layout_get_scale (_tmp1_) <= 0;
#line 808 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp1_);
#line 808 "../src/Views/MediaPage.vala"
	if (_tmp2_) {
#line 5538 "MediaPage.c"
		CheckerboardLayout* _tmp3_;
		CheckerboardLayout* _tmp4_;
		GSettings* _tmp5_;
#line 809 "../src/Views/MediaPage.vala"
		_tmp3_ = checkerboard_page_get_checkerboard_layout ((CheckerboardPage*) self);
#line 809 "../src/Views/MediaPage.vala"
		_tmp4_ = _tmp3_;
#line 809 "../src/Views/MediaPage.vala"
		_tmp5_ = ((Page*) self)->ui_settings;
#line 809 "../src/Views/MediaPage.vala"
		checkerboard_layout_set_scale (_tmp4_, g_settings_get_int (_tmp5_, "photo-thumbnail-scale"));
#line 809 "../src/Views/MediaPage.vala"
		_g_object_unref0 (_tmp4_);
#line 5552 "MediaPage.c"
	}
#line 811 "../src/Views/MediaPage.vala"
	_tmp6_ = checkerboard_page_get_checkerboard_layout ((CheckerboardPage*) self);
#line 811 "../src/Views/MediaPage.vala"
	_tmp7_ = _tmp6_;
#line 811 "../src/Views/MediaPage.vala"
	_tmp8_ = checkerboard_layout_get_scale (_tmp7_);
#line 811 "../src/Views/MediaPage.vala"
	_g_object_unref0 (_tmp7_);
#line 811 "../src/Views/MediaPage.vala"
	result = _tmp8_;
#line 811 "../src/Views/MediaPage.vala"
	return result;
#line 5566 "MediaPage.c"
}

GtkButton*
media_page_create_sidebar_button (void)
{
	GtkButton* show_sidebar_button = NULL;
	GtkButton* _tmp0_;
	GtkButton* result;
#line 815 "../src/Views/MediaPage.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_from_icon_name (RESOURCES_SHOW_PANE, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 815 "../src/Views/MediaPage.vala"
	g_object_ref_sink (_tmp0_);
#line 815 "../src/Views/MediaPage.vala"
	show_sidebar_button = _tmp0_;
#line 816 "../src/Views/MediaPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) show_sidebar_button, RESOURCES_TOGGLE_METAPANE_TOOLTIP);
#line 817 "../src/Views/MediaPage.vala"
	result = show_sidebar_button;
#line 817 "../src/Views/MediaPage.vala"
	return result;
#line 5587 "MediaPage.c"
}

static void
_media_page_on_media_altered_data_collection_items_altered (DataCollection* _sender,
                                                            GeeMap* items,
                                                            gpointer self)
{
#line 44 "../src/Views/MediaPage.vala"
	media_page_on_media_altered ((MediaPage*) self, items);
#line 5597 "MediaPage.c"
}

static GObject *
media_page_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MediaPage * self;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	MediaViewTracker* _tmp2_;
	ViewCollection* _tmp3_;
	ViewCollection* _tmp4_;
	ViewCollection* _tmp5_;
	ViewCollection* _tmp6_;
	ViewCollection* _tmp7_;
	ViewCollection* _tmp8_;
	GSettings* _tmp9_;
	GValue _tmp10_ = {0};
	ViewCollection* _tmp11_;
	ViewCollection* _tmp12_;
	GSettings* _tmp13_;
	GValue _tmp14_ = {0};
	ViewCollection* _tmp15_;
	ViewCollection* _tmp16_;
	GSettings* _tmp17_;
	GValue _tmp18_ = {0};
	ViewCollection* _tmp19_;
	ViewCollection* _tmp20_;
	GValue _tmp21_ = {0};
	ViewCollection* _tmp22_;
	ViewCollection* _tmp23_;
	DragAndDropHandler* _tmp24_;
#line 42 "../src/Views/MediaPage.vala"
	parent_class = G_OBJECT_CLASS (media_page_parent_class);
#line 42 "../src/Views/MediaPage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 42 "../src/Views/MediaPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_PAGE, MediaPage);
#line 43 "../src/Views/MediaPage.vala"
	_tmp0_ = page_get_view ((Page*) self);
#line 43 "../src/Views/MediaPage.vala"
	_tmp1_ = _tmp0_;
#line 43 "../src/Views/MediaPage.vala"
	_tmp2_ = media_view_tracker_new (_tmp1_);
#line 43 "../src/Views/MediaPage.vala"
	_core_tracker_unref0 (self->priv->tracker);
#line 43 "../src/Views/MediaPage.vala"
	self->priv->tracker = _tmp2_;
#line 43 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp1_);
#line 44 "../src/Views/MediaPage.vala"
	_tmp3_ = page_get_view ((Page*) self);
#line 44 "../src/Views/MediaPage.vala"
	_tmp4_ = _tmp3_;
#line 44 "../src/Views/MediaPage.vala"
	g_signal_connect_object ((DataCollection*) _tmp4_, "items-altered", (GCallback) _media_page_on_media_altered_data_collection_items_altered, self, 0);
#line 44 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp4_);
#line 46 "../src/Views/MediaPage.vala"
	_tmp5_ = page_get_view ((Page*) self);
#line 46 "../src/Views/MediaPage.vala"
	_tmp6_ = _tmp5_;
#line 46 "../src/Views/MediaPage.vala"
	data_collection_freeze_notifications ((DataCollection*) _tmp6_);
#line 46 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp6_);
#line 47 "../src/Views/MediaPage.vala"
	_tmp7_ = page_get_view ((Page*) self);
#line 47 "../src/Views/MediaPage.vala"
	_tmp8_ = _tmp7_;
#line 47 "../src/Views/MediaPage.vala"
	_tmp9_ = ((Page*) self)->ui_settings;
#line 47 "../src/Views/MediaPage.vala"
	g_value_init (&_tmp10_, G_TYPE_BOOLEAN);
#line 47 "../src/Views/MediaPage.vala"
	g_value_set_boolean (&_tmp10_, g_settings_get_boolean (_tmp9_, "display-photo-titles"));
#line 47 "../src/Views/MediaPage.vala"
	data_collection_set_property ((DataCollection*) _tmp8_, CHECKERBOARD_ITEM_PROP_SHOW_TITLES, &_tmp10_, NULL, NULL);
#line 47 "../src/Views/MediaPage.vala"
	G_IS_VALUE (&_tmp10_) ? (g_value_unset (&_tmp10_), NULL) : NULL;
#line 47 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp8_);
#line 48 "../src/Views/MediaPage.vala"
	_tmp11_ = page_get_view ((Page*) self);
#line 48 "../src/Views/MediaPage.vala"
	_tmp12_ = _tmp11_;
#line 48 "../src/Views/MediaPage.vala"
	_tmp13_ = ((Page*) self)->ui_settings;
#line 48 "../src/Views/MediaPage.vala"
	g_value_init (&_tmp14_, G_TYPE_BOOLEAN);
#line 48 "../src/Views/MediaPage.vala"
	g_value_set_boolean (&_tmp14_, g_settings_get_boolean (_tmp13_, "display-photo-comments"));
#line 48 "../src/Views/MediaPage.vala"
	data_collection_set_property ((DataCollection*) _tmp12_, CHECKERBOARD_ITEM_PROP_SHOW_COMMENTS, &_tmp14_, NULL, NULL);
#line 48 "../src/Views/MediaPage.vala"
	G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
#line 48 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp12_);
#line 49 "../src/Views/MediaPage.vala"
	_tmp15_ = page_get_view ((Page*) self);
#line 49 "../src/Views/MediaPage.vala"
	_tmp16_ = _tmp15_;
#line 49 "../src/Views/MediaPage.vala"
	_tmp17_ = ((Page*) self)->ui_settings;
#line 49 "../src/Views/MediaPage.vala"
	g_value_init (&_tmp18_, G_TYPE_BOOLEAN);
#line 49 "../src/Views/MediaPage.vala"
	g_value_set_boolean (&_tmp18_, g_settings_get_boolean (_tmp17_, "display-photo-tags"));
#line 49 "../src/Views/MediaPage.vala"
	data_collection_set_property ((DataCollection*) _tmp16_, THUMBNAIL_PROP_SHOW_TAGS, &_tmp18_, NULL, NULL);
#line 49 "../src/Views/MediaPage.vala"
	G_IS_VALUE (&_tmp18_) ? (g_value_unset (&_tmp18_), NULL) : NULL;
#line 49 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp16_);
#line 50 "../src/Views/MediaPage.vala"
	_tmp19_ = page_get_view ((Page*) self);
#line 50 "../src/Views/MediaPage.vala"
	_tmp20_ = _tmp19_;
#line 50 "../src/Views/MediaPage.vala"
	g_value_init (&_tmp21_, G_TYPE_INT);
#line 50 "../src/Views/MediaPage.vala"
	g_value_set_int (&_tmp21_, media_page_get_thumb_size (self));
#line 50 "../src/Views/MediaPage.vala"
	data_collection_set_property ((DataCollection*) _tmp20_, THUMBNAIL_PROP_SIZE, &_tmp21_, NULL, NULL);
#line 50 "../src/Views/MediaPage.vala"
	G_IS_VALUE (&_tmp21_) ? (g_value_unset (&_tmp21_), NULL) : NULL;
#line 50 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp20_);
#line 52 "../src/Views/MediaPage.vala"
	_tmp22_ = page_get_view ((Page*) self);
#line 52 "../src/Views/MediaPage.vala"
	_tmp23_ = _tmp22_;
#line 52 "../src/Views/MediaPage.vala"
	data_collection_thaw_notifications ((DataCollection*) _tmp23_);
#line 52 "../src/Views/MediaPage.vala"
	_data_collection_unref0 (_tmp23_);
#line 55 "../src/Views/MediaPage.vala"
	_tmp24_ = drag_and_drop_handler_new ((Page*) self);
#line 55 "../src/Views/MediaPage.vala"
	_drag_and_drop_handler_unref0 (self->priv->dnd_handler);
#line 55 "../src/Views/MediaPage.vala"
	self->priv->dnd_handler = _tmp24_;
#line 42 "../src/Views/MediaPage.vala"
	return obj;
#line 5745 "MediaPage.c"
}

static void
media_page_class_init (MediaPageClass * klass,
                       gpointer klass_data)
{
#line 20 "../src/Views/MediaPage.vala"
	media_page_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Views/MediaPage.vala"
	g_type_class_adjust_private_offset (klass, &MediaPage_private_offset);
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->get_page_context_menu = (GtkMenu* (*) (Page*)) media_page_real_get_page_context_menu;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->init_collect_action_entries = (GtkActionEntry* (*) (Page*, gint*)) media_page_real_init_collect_action_entries;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->init_collect_toggle_action_entries = (GtkToggleActionEntry* (*) (Page*, gint*)) media_page_real_init_collect_toggle_action_entries;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->register_radio_actions = (void (*) (Page*, GtkActionGroup*)) media_page_real_register_radio_actions;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->update_actions = (void (*) (Page*, gint, gint)) media_page_real_update_actions;
#line 20 "../src/Views/MediaPage.vala"
	((CheckerboardPageClass *) klass)->get_view_tracker = (CoreViewTracker* (*) (CheckerboardPage*)) media_page_real_get_view_tracker;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->on_mousewheel_up = (gboolean (*) (Page*, GdkEventScroll*)) media_page_real_on_mousewheel_up;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->on_mousewheel_down = (gboolean (*) (Page*, GdkEventScroll*)) media_page_real_on_mousewheel_down;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->on_app_key_pressed = (gboolean (*) (Page*, GdkEventKey*)) media_page_real_on_app_key_pressed;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->switched_to = (void (*) (Page*)) media_page_real_switched_to;
#line 20 "../src/Views/MediaPage.vala"
	((PageClass *) klass)->switching_from = (void (*) (Page*)) media_page_real_switching_from;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_zoom_changed = (void (*) (MediaPage*)) media_page_real_on_zoom_changed;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_export = (void (*) (MediaPage*)) media_page_real_on_export;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_increase_size = (void (*) (MediaPage*)) media_page_real_on_increase_size;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_decrease_size = (void (*) (MediaPage*)) media_page_real_on_decrease_size;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_move_to_trash = (void (*) (MediaPage*)) media_page_real_on_move_to_trash;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_display_titles = (void (*) (MediaPage*, GtkAction*)) media_page_real_on_display_titles;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_display_comments = (void (*) (MediaPage*, GtkAction*)) media_page_real_on_display_comments;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_display_tags = (void (*) (MediaPage*, GtkAction*)) media_page_real_on_display_tags;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->get_config_photos_sort = (void (*) (MediaPage*, gboolean*, gint*)) media_page_real_get_config_photos_sort;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->set_config_photos_sort = (void (*) (MediaPage*, gboolean, gint)) media_page_real_set_config_photos_sort;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->on_sort_changed = (void (*) (MediaPage*)) media_page_real_on_sort_changed;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->developer_changed = (void (*) (MediaPage*, RawDeveloper)) media_page_real_developer_changed;
#line 20 "../src/Views/MediaPage.vala"
	((CheckerboardPageClass *) klass)->set_display_titles = (void (*) (CheckerboardPage*, gboolean)) media_page_real_set_display_titles;
#line 20 "../src/Views/MediaPage.vala"
	((CheckerboardPageClass *) klass)->set_display_comments = (void (*) (CheckerboardPage*, gboolean)) media_page_real_set_display_comments;
#line 20 "../src/Views/MediaPage.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) media_page_real_destroy;
#line 20 "../src/Views/MediaPage.vala"
	((MediaPageClass *) klass)->create_thumbnail = (DataView* (*) (MediaPage*, DataSource*)) media_page_real_create_thumbnail;
#line 20 "../src/Views/MediaPage.vala"
	G_OBJECT_CLASS (klass)->constructor = media_page_constructor;
#line 20 "../src/Views/MediaPage.vala"
	G_OBJECT_CLASS (klass)->finalize = media_page_finalize;
#line 5814 "MediaPage.c"
}

static void
media_page_instance_init (MediaPage * self,
                          gpointer klass)
{
#line 20 "../src/Views/MediaPage.vala"
	self->priv = media_page_get_instance_private (self);
#line 33 "../src/Views/MediaPage.vala"
	self->priv->connected_slider = NULL;
#line 34 "../src/Views/MediaPage.vala"
	self->priv->dnd_handler = NULL;
#line 5827 "MediaPage.c"
}

static void
media_page_finalize (GObject * obj)
{
	MediaPage * self;
#line 20 "../src/Views/MediaPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_PAGE, MediaPage);
#line 33 "../src/Views/MediaPage.vala"
	_g_object_unref0 (self->priv->connected_slider);
#line 34 "../src/Views/MediaPage.vala"
	_drag_and_drop_handler_unref0 (self->priv->dnd_handler);
#line 35 "../src/Views/MediaPage.vala"
	_core_tracker_unref0 (self->priv->tracker);
#line 36 "../src/Views/MediaPage.vala"
	_g_object_unref0 (self->priv->page_context_menu);
#line 20 "../src/Views/MediaPage.vala"
	G_OBJECT_CLASS (media_page_parent_class)->finalize (obj);
#line 5846 "MediaPage.c"
}

static GType
media_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaPage), 0, (GInstanceInitFunc) media_page_instance_init, NULL };
	GType media_page_type_id;
	media_page_type_id = g_type_register_static (TYPE_CHECKERBOARD_PAGE, "MediaPage", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MediaPage_private_offset = g_type_add_instance_private (media_page_type_id, sizeof (MediaPagePrivate));
	return media_page_type_id;
}

GType
media_page_get_type (void)
{
	static volatile gsize media_page_type_id__once = 0;
	if (g_once_init_enter (&media_page_type_id__once)) {
		GType media_page_type_id;
		media_page_type_id = media_page_get_type_once ();
		g_once_init_leave (&media_page_type_id__once, media_page_type_id);
	}
	return media_page_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

