/* CameraTable.c generated by valac 0.56.18, the Vala compiler
 * generated from CameraTable.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib-object.h>
#include <gphoto2/gphoto2-camera.h>
#include <gphoto.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>
#include <gudev/gudev.h>
#include <gphoto2/gphoto2-context.h>
#include <gphoto2/gphoto2-abilities-list.h>
#include <gee.h>
#include <gphoto2/gphoto2-result.h>
#include <gphoto2/gphoto2-port-result.h>
#include <stdio.h>
#include <gphoto2/gphoto2-port-info-list.h>
#include <gphoto2/gphoto2-list.h>

#define CAMERA_TABLE_UPDATE_DELAY_MSEC 1000
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _gp_camera_unref0(var) ((var == NULL) ? NULL : (var = (gp_camera_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecDiscoveredCamera ParamSpecDiscoveredCamera;
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _gp_context_unref0(var) ((var == NULL) ? NULL : (var = (gp_context_unref (var), NULL)))
#define _gp_abilities_list_free0(var) ((var == NULL) ? NULL : (var = (gp_abilities_list_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _camera_table_unref0(var) ((var == NULL) ? NULL : (var = (camera_table_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _gp_port_info_list_free0(var) ((var == NULL) ? NULL : (var = (gp_port_info_list_free (var), NULL)))
#define _gp_list_unref0(var) ((var == NULL) ? NULL : (var = (gp_list_unref (var), NULL)))
#define _discovered_camera_unref0(var) ((var == NULL) ? NULL : (var = (discovered_camera_unref (var), NULL)))
typedef struct _ParamSpecCameraTable ParamSpecCameraTable;
enum  {
	CAMERA_TABLE_CAMERA_ADDED_SIGNAL,
	CAMERA_TABLE_CAMERA_REMOVED_SIGNAL,
	CAMERA_TABLE_NUM_SIGNALS
};
static guint camera_table_signals[CAMERA_TABLE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ParamSpecDiscoveredCamera {
	GParamSpec parent_instance;
};

struct _CameraTablePrivate {
	GUdevClient* client;
	OneShotScheduler* camera_update_scheduler;
	GPContext* null_context;
	CameraAbilitiesList* abilities_list;
	GVolumeMonitor* volume_monitor;
	GeeHashMap* camera_map;
};

struct _ParamSpecCameraTable {
	GParamSpec parent_instance;
};

static gpointer discovered_camera_parent_class = NULL;
static gint CameraTable_private_offset;
static gpointer camera_table_parent_class = NULL;
static CameraTable* camera_table_instance;
static CameraTable* camera_table_instance = NULL;

static void discovered_camera_finalize (DiscoveredCamera * obj);
static GType discovered_camera_get_type_once (void);
static CameraTable* camera_table_new (void);
static CameraTable* camera_table_construct (GType object_type);
static void camera_table_on_update_cameras (CameraTable* self);
static void _camera_table_on_update_cameras_one_shot_callback (gpointer self);
static void camera_table_on_udev_event (CameraTable* self,
                                 const gchar* action,
                                 GUdevDevice* device);
static void _camera_table_on_udev_event_g_udev_client_uevent (GUdevClient* _sender,
                                                       const gchar* action,
                                                       GUdevDevice* device,
                                                       gpointer self);
static void _camera_table_on_volume_changed_g_volume_monitor_volume_changed (GVolumeMonitor* _sender,
                                                                      GVolume* volume,
                                                                      gpointer self);
static void _camera_table_on_volume_changed_g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                                    GVolume* volume,
                                                                    gpointer self);
static gboolean camera_table_delayed_init (CameraTable* self);
static gboolean _camera_table_delayed_init_gsource_func (gpointer self);
static void camera_table_init_camera_table (CameraTable* self,
                                     GError** error);
static void camera_table_update_camera_table (CameraTable* self,
                                       GError** error);
static void camera_table_do_op (CameraTable* self,
                         int res,
                         const gchar* op,
                         GError** error);
static gchar** camera_table_get_all_usb_cameras (CameraTable* self,
                                          gint* result_length1);
static void _vala_array_add46 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean camera_table_usb_esp (CameraTable* self,
                               gint current_camera_count,
                               gchar** usb_cameras,
                               gint usb_cameras_length1,
                               const gchar* port,
                               gchar** full_port);
static gchar* camera_table_get_name_for_uuid (CameraTable* self,
                                       const gchar* uuid);
static GIcon* camera_table_get_icon_for_uuid (CameraTable* self,
                                       const gchar* uuid);
static void _vala_array_add47 (DiscoveredCamera** * array,
                        gint* length,
                        gint* size,
                        DiscoveredCamera* value);
static void g_cclosure_user_marshal_VOID__DISCOVERED_CAMERA (GClosure * closure,
                                                      GValue * return_value,
                                                      guint n_param_values,
                                                      const GValue * param_values,
                                                      gpointer invocation_hint,
                                                      gpointer marshal_data);
static void camera_table_finalize (CameraTable * obj);
static GType camera_table_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* CAMERA_TABLE_SUBSYSTEMS[3] = {"usb", "block", NULL};

static gpointer
_GPHOTO_REF_CAMERA0 (gpointer self)
{
#line 27 "../src/camera/CameraTable.vala"
	return self ? GPHOTO_REF_CAMERA (self) : NULL;
#line 174 "CameraTable.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/camera/CameraTable.vala"
	return self ? g_object_ref (self) : NULL;
#line 182 "CameraTable.c"
}

DiscoveredCamera*
discovered_camera_construct (GType object_type,
                             Camera* gcamera,
                             const gchar* uri,
                             const gchar* display_name,
                             GIcon* icon)
{
	DiscoveredCamera* self = NULL;
	Camera* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GIcon* _tmp3_;
#line 26 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (gcamera != NULL, NULL);
#line 26 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 26 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (display_name != NULL, NULL);
#line 26 "../src/camera/CameraTable.vala"
	self = (DiscoveredCamera*) g_type_create_instance (object_type);
#line 27 "../src/camera/CameraTable.vala"
	_tmp0_ = _GPHOTO_REF_CAMERA0 (gcamera);
#line 27 "../src/camera/CameraTable.vala"
	_gp_camera_unref0 (self->gcamera);
#line 27 "../src/camera/CameraTable.vala"
	self->gcamera = _tmp0_;
#line 28 "../src/camera/CameraTable.vala"
	_tmp1_ = g_strdup (uri);
#line 28 "../src/camera/CameraTable.vala"
	_g_free0 (self->uri);
#line 28 "../src/camera/CameraTable.vala"
	self->uri = _tmp1_;
#line 29 "../src/camera/CameraTable.vala"
	_tmp2_ = g_strdup (display_name);
#line 29 "../src/camera/CameraTable.vala"
	_g_free0 (self->display_name);
#line 29 "../src/camera/CameraTable.vala"
	self->display_name = _tmp2_;
#line 30 "../src/camera/CameraTable.vala"
	_tmp3_ = _g_object_ref0 (icon);
#line 30 "../src/camera/CameraTable.vala"
	_g_object_unref0 (self->icon);
#line 30 "../src/camera/CameraTable.vala"
	self->icon = _tmp3_;
#line 26 "../src/camera/CameraTable.vala"
	return self;
#line 231 "CameraTable.c"
}

DiscoveredCamera*
discovered_camera_new (Camera* gcamera,
                       const gchar* uri,
                       const gchar* display_name,
                       GIcon* icon)
{
#line 26 "../src/camera/CameraTable.vala"
	return discovered_camera_construct (TYPE_DISCOVERED_CAMERA, gcamera, uri, display_name, icon);
#line 242 "CameraTable.c"
}

static void
value_discovered_camera_init (GValue* value)
{
#line 20 "../src/camera/CameraTable.vala"
	value->data[0].v_pointer = NULL;
#line 250 "CameraTable.c"
}

static void
value_discovered_camera_free_value (GValue* value)
{
#line 20 "../src/camera/CameraTable.vala"
	if (value->data[0].v_pointer) {
#line 20 "../src/camera/CameraTable.vala"
		discovered_camera_unref (value->data[0].v_pointer);
#line 260 "CameraTable.c"
	}
}

static void
value_discovered_camera_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 20 "../src/camera/CameraTable.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../src/camera/CameraTable.vala"
		dest_value->data[0].v_pointer = discovered_camera_ref (src_value->data[0].v_pointer);
#line 272 "CameraTable.c"
	} else {
#line 20 "../src/camera/CameraTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 276 "CameraTable.c"
	}
}

static gpointer
value_discovered_camera_peek_pointer (const GValue* value)
{
#line 20 "../src/camera/CameraTable.vala"
	return value->data[0].v_pointer;
#line 285 "CameraTable.c"
}

static gchar*
value_discovered_camera_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 20 "../src/camera/CameraTable.vala"
	if (collect_values[0].v_pointer) {
#line 296 "CameraTable.c"
		DiscoveredCamera * object;
		object = collect_values[0].v_pointer;
#line 20 "../src/camera/CameraTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../src/camera/CameraTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 303 "CameraTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../src/camera/CameraTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 307 "CameraTable.c"
		}
#line 20 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = discovered_camera_ref (object);
#line 311 "CameraTable.c"
	} else {
#line 20 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = NULL;
#line 315 "CameraTable.c"
	}
#line 20 "../src/camera/CameraTable.vala"
	return NULL;
#line 319 "CameraTable.c"
}

static gchar*
value_discovered_camera_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	DiscoveredCamera ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../src/camera/CameraTable.vala"
	if (!object_p) {
#line 20 "../src/camera/CameraTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 334 "CameraTable.c"
	}
#line 20 "../src/camera/CameraTable.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../src/camera/CameraTable.vala"
		*object_p = NULL;
#line 340 "CameraTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../src/camera/CameraTable.vala"
		*object_p = value->data[0].v_pointer;
#line 344 "CameraTable.c"
	} else {
#line 20 "../src/camera/CameraTable.vala"
		*object_p = discovered_camera_ref (value->data[0].v_pointer);
#line 348 "CameraTable.c"
	}
#line 20 "../src/camera/CameraTable.vala"
	return NULL;
#line 352 "CameraTable.c"
}

GParamSpec*
param_spec_discovered_camera (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecDiscoveredCamera* spec;
#line 20 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DISCOVERED_CAMERA), NULL);
#line 20 "../src/camera/CameraTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../src/camera/CameraTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../src/camera/CameraTable.vala"
	return G_PARAM_SPEC (spec);
#line 371 "CameraTable.c"
}

gpointer
value_get_discovered_camera (const GValue* value)
{
#line 20 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA), NULL);
#line 20 "../src/camera/CameraTable.vala"
	return value->data[0].v_pointer;
#line 381 "CameraTable.c"
}

void
value_set_discovered_camera (GValue* value,
                             gpointer v_object)
{
	DiscoveredCamera * old;
#line 20 "../src/camera/CameraTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA));
#line 20 "../src/camera/CameraTable.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/camera/CameraTable.vala"
	if (v_object) {
#line 20 "../src/camera/CameraTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DISCOVERED_CAMERA));
#line 20 "../src/camera/CameraTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../src/camera/CameraTable.vala"
		discovered_camera_ref (value->data[0].v_pointer);
#line 403 "CameraTable.c"
	} else {
#line 20 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = NULL;
#line 407 "CameraTable.c"
	}
#line 20 "../src/camera/CameraTable.vala"
	if (old) {
#line 20 "../src/camera/CameraTable.vala"
		discovered_camera_unref (old);
#line 413 "CameraTable.c"
	}
}

void
value_take_discovered_camera (GValue* value,
                              gpointer v_object)
{
	DiscoveredCamera * old;
#line 20 "../src/camera/CameraTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA));
#line 20 "../src/camera/CameraTable.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/camera/CameraTable.vala"
	if (v_object) {
#line 20 "../src/camera/CameraTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DISCOVERED_CAMERA));
#line 20 "../src/camera/CameraTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = v_object;
#line 434 "CameraTable.c"
	} else {
#line 20 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = NULL;
#line 438 "CameraTable.c"
	}
#line 20 "../src/camera/CameraTable.vala"
	if (old) {
#line 20 "../src/camera/CameraTable.vala"
		discovered_camera_unref (old);
#line 444 "CameraTable.c"
	}
}

static void
discovered_camera_class_init (DiscoveredCameraClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/camera/CameraTable.vala"
	discovered_camera_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/camera/CameraTable.vala"
	((DiscoveredCameraClass *) klass)->finalize = discovered_camera_finalize;
#line 456 "CameraTable.c"
}

static void
discovered_camera_instance_init (DiscoveredCamera * self,
                                 gpointer klass)
{
#line 20 "../src/camera/CameraTable.vala"
	self->ref_count = 1;
#line 465 "CameraTable.c"
}

static void
discovered_camera_finalize (DiscoveredCamera * obj)
{
	DiscoveredCamera * self;
#line 20 "../src/camera/CameraTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DISCOVERED_CAMERA, DiscoveredCamera);
#line 20 "../src/camera/CameraTable.vala"
	g_signal_handlers_destroy (self);
#line 21 "../src/camera/CameraTable.vala"
	_gp_camera_unref0 (self->gcamera);
#line 22 "../src/camera/CameraTable.vala"
	_g_free0 (self->uri);
#line 23 "../src/camera/CameraTable.vala"
	_g_free0 (self->display_name);
#line 24 "../src/camera/CameraTable.vala"
	_g_object_unref0 (self->icon);
#line 484 "CameraTable.c"
}

static GType
discovered_camera_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_discovered_camera_init, value_discovered_camera_free_value, value_discovered_camera_copy_value, value_discovered_camera_peek_pointer, "p", value_discovered_camera_collect_value, "p", value_discovered_camera_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DiscoveredCameraClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) discovered_camera_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiscoveredCamera), 0, (GInstanceInitFunc) discovered_camera_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType discovered_camera_type_id;
	discovered_camera_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DiscoveredCamera", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return discovered_camera_type_id;
}

GType
discovered_camera_get_type (void)
{
	static volatile gsize discovered_camera_type_id__once = 0;
	if (g_once_init_enter (&discovered_camera_type_id__once)) {
		GType discovered_camera_type_id;
		discovered_camera_type_id = discovered_camera_get_type_once ();
		g_once_init_leave (&discovered_camera_type_id__once, discovered_camera_type_id);
	}
	return discovered_camera_type_id__once;
}

gpointer
discovered_camera_ref (gpointer instance)
{
	DiscoveredCamera * self;
	self = instance;
#line 20 "../src/camera/CameraTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../src/camera/CameraTable.vala"
	return instance;
#line 519 "CameraTable.c"
}

void
discovered_camera_unref (gpointer instance)
{
	DiscoveredCamera * self;
	self = instance;
#line 20 "../src/camera/CameraTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../src/camera/CameraTable.vala"
		DISCOVERED_CAMERA_GET_CLASS (self)->finalize (self);
#line 20 "../src/camera/CameraTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 533 "CameraTable.c"
	}
}

static inline gpointer
camera_table_get_instance_private (CameraTable* self)
{
	return G_STRUCT_MEMBER_P (self, CameraTable_private_offset);
}

static void
_camera_table_on_update_cameras_one_shot_callback (gpointer self)
{
#line 55 "../src/camera/CameraTable.vala"
	camera_table_on_update_cameras ((CameraTable*) self);
#line 548 "CameraTable.c"
}

static void
_camera_table_on_udev_event_g_udev_client_uevent (GUdevClient* _sender,
                                                  const gchar* action,
                                                  GUdevDevice* device,
                                                  gpointer self)
{
#line 59 "../src/camera/CameraTable.vala"
	camera_table_on_udev_event ((CameraTable*) self, action, device);
#line 559 "CameraTable.c"
}

static void
_camera_table_on_volume_changed_g_volume_monitor_volume_changed (GVolumeMonitor* _sender,
                                                                 GVolume* volume,
                                                                 gpointer self)
{
#line 61 "../src/camera/CameraTable.vala"
	camera_table_on_volume_changed ((CameraTable*) self, volume);
#line 569 "CameraTable.c"
}

static void
_camera_table_on_volume_changed_g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                               GVolume* volume,
                                                               gpointer self)
{
#line 62 "../src/camera/CameraTable.vala"
	camera_table_on_volume_changed ((CameraTable*) self, volume);
#line 579 "CameraTable.c"
}

static gboolean
_camera_table_delayed_init_gsource_func (gpointer self)
{
	gboolean result;
	result = camera_table_delayed_init ((CameraTable*) self);
#line 67 "../src/camera/CameraTable.vala"
	return result;
#line 589 "CameraTable.c"
}

static CameraTable*
camera_table_construct (GType object_type)
{
	CameraTable* self = NULL;
	OneShotScheduler* _tmp0_;
	GUdevClient* _tmp1_;
	GVolumeMonitor* _tmp2_;
	GVolumeMonitor* _tmp3_;
	GVolumeMonitor* _tmp4_;
#line 54 "../src/camera/CameraTable.vala"
	self = (CameraTable*) g_type_create_instance (object_type);
#line 55 "../src/camera/CameraTable.vala"
	_tmp0_ = one_shot_scheduler_new ("CameraTable update scheduler", _camera_table_on_update_cameras_one_shot_callback, self);
#line 55 "../src/camera/CameraTable.vala"
	_one_shot_scheduler_unref0 (self->priv->camera_update_scheduler);
#line 55 "../src/camera/CameraTable.vala"
	self->priv->camera_update_scheduler = _tmp0_;
#line 59 "../src/camera/CameraTable.vala"
	_tmp1_ = self->priv->client;
#line 59 "../src/camera/CameraTable.vala"
	g_signal_connect (_tmp1_, "uevent", (GCallback) _camera_table_on_udev_event_g_udev_client_uevent, self);
#line 60 "../src/camera/CameraTable.vala"
	_tmp2_ = g_volume_monitor_get ();
#line 60 "../src/camera/CameraTable.vala"
	_g_object_unref0 (self->priv->volume_monitor);
#line 60 "../src/camera/CameraTable.vala"
	self->priv->volume_monitor = _tmp2_;
#line 61 "../src/camera/CameraTable.vala"
	_tmp3_ = self->priv->volume_monitor;
#line 61 "../src/camera/CameraTable.vala"
	g_signal_connect (_tmp3_, "volume-changed", (GCallback) _camera_table_on_volume_changed_g_volume_monitor_volume_changed, self);
#line 62 "../src/camera/CameraTable.vala"
	_tmp4_ = self->priv->volume_monitor;
#line 62 "../src/camera/CameraTable.vala"
	g_signal_connect (_tmp4_, "volume-added", (GCallback) _camera_table_on_volume_changed_g_volume_monitor_volume_added, self);
#line 67 "../src/camera/CameraTable.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _camera_table_delayed_init_gsource_func, camera_table_ref (self), camera_table_unref);
#line 54 "../src/camera/CameraTable.vala"
	return self;
#line 631 "CameraTable.c"
}

static CameraTable*
camera_table_new (void)
{
#line 54 "../src/camera/CameraTable.vala"
	return camera_table_construct (TYPE_CAMERA_TABLE);
#line 639 "CameraTable.c"
}

static gboolean
camera_table_delayed_init (CameraTable* self)
{
	AppWindow* _tmp0_;
	LibraryWindow* _tmp1_;
	AppWindow* _tmp10_;
	LibraryWindow* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 70 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/camera/CameraTable.vala"
	_tmp0_ = app_window_get_instance ();
#line 73 "../src/camera/CameraTable.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_WINDOW, LibraryWindow);
#line 73 "../src/camera/CameraTable.vala"
	library_window_set_page_switching_enabled (_tmp1_, FALSE);
#line 73 "../src/camera/CameraTable.vala"
	_g_object_unref0 (_tmp1_);
#line 661 "CameraTable.c"
	{
#line 76 "../src/camera/CameraTable.vala"
		camera_table_init_camera_table (self, &_inner_error0_);
#line 76 "../src/camera/CameraTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 667 "CameraTable.c"
			gboolean _tmp2_ = FALSE;
#line 76 "../src/camera/CameraTable.vala"
			if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 671 "CameraTable.c"
				goto __catch0_gphoto_error;
			}
#line 76 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 76 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 76 "../src/camera/CameraTable.vala"
			return _tmp2_;
#line 680 "CameraTable.c"
		}
	}
	goto __finally0;
	__catch0_gphoto_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 75 "../src/camera/CameraTable.vala"
		err = _inner_error0_;
#line 75 "../src/camera/CameraTable.vala"
		_inner_error0_ = NULL;
#line 78 "../src/camera/CameraTable.vala"
		_tmp3_ = err;
#line 78 "../src/camera/CameraTable.vala"
		_tmp4_ = _tmp3_->message;
#line 78 "../src/camera/CameraTable.vala"
		g_warning ("CameraTable.vala:78: Unable to initialize camera table: %s", _tmp4_);
#line 80 "../src/camera/CameraTable.vala"
		result = FALSE;
#line 80 "../src/camera/CameraTable.vala"
		_g_error_free0 (err);
#line 80 "../src/camera/CameraTable.vala"
		return result;
#line 705 "CameraTable.c"
	}
	__finally0:
#line 75 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 710 "CameraTable.c"
		gboolean _tmp5_ = FALSE;
#line 75 "../src/camera/CameraTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/camera/CameraTable.vala"
		g_clear_error (&_inner_error0_);
#line 75 "../src/camera/CameraTable.vala"
		return _tmp5_;
#line 718 "CameraTable.c"
	}
	{
#line 84 "../src/camera/CameraTable.vala"
		camera_table_update_camera_table (self, &_inner_error0_);
#line 84 "../src/camera/CameraTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 725 "CameraTable.c"
			gboolean _tmp6_ = FALSE;
#line 84 "../src/camera/CameraTable.vala"
			if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 729 "CameraTable.c"
				goto __catch1_gphoto_error;
			}
#line 84 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 84 "../src/camera/CameraTable.vala"
			return _tmp6_;
#line 738 "CameraTable.c"
		}
	}
	goto __finally1;
	__catch1_gphoto_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 83 "../src/camera/CameraTable.vala"
		err = _inner_error0_;
#line 83 "../src/camera/CameraTable.vala"
		_inner_error0_ = NULL;
#line 86 "../src/camera/CameraTable.vala"
		_tmp7_ = err;
#line 86 "../src/camera/CameraTable.vala"
		_tmp8_ = _tmp7_->message;
#line 86 "../src/camera/CameraTable.vala"
		g_warning ("CameraTable.vala:86: Unable to update camera table: %s", _tmp8_);
#line 83 "../src/camera/CameraTable.vala"
		_g_error_free0 (err);
#line 759 "CameraTable.c"
	}
	__finally1:
#line 83 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 764 "CameraTable.c"
		gboolean _tmp9_ = FALSE;
#line 83 "../src/camera/CameraTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../src/camera/CameraTable.vala"
		g_clear_error (&_inner_error0_);
#line 83 "../src/camera/CameraTable.vala"
		return _tmp9_;
#line 772 "CameraTable.c"
	}
#line 91 "../src/camera/CameraTable.vala"
	_tmp10_ = app_window_get_instance ();
#line 91 "../src/camera/CameraTable.vala"
	_tmp11_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_WINDOW, LibraryWindow);
#line 91 "../src/camera/CameraTable.vala"
	library_window_set_page_switching_enabled (_tmp11_, TRUE);
#line 91 "../src/camera/CameraTable.vala"
	_g_object_unref0 (_tmp11_);
#line 92 "../src/camera/CameraTable.vala"
	result = FALSE;
#line 92 "../src/camera/CameraTable.vala"
	return result;
#line 786 "CameraTable.c"
}

static gpointer
_camera_table_ref0 (gpointer self)
{
#line 99 "../src/camera/CameraTable.vala"
	return self ? camera_table_ref (self) : NULL;
#line 794 "CameraTable.c"
}

CameraTable*
camera_table_get_instance (void)
{
	CameraTable* _tmp0_;
	CameraTable* _tmp2_;
	CameraTable* _tmp3_;
	CameraTable* result;
#line 96 "../src/camera/CameraTable.vala"
	_tmp0_ = camera_table_instance;
#line 96 "../src/camera/CameraTable.vala"
	if (_tmp0_ == NULL) {
#line 808 "CameraTable.c"
		CameraTable* _tmp1_;
#line 97 "../src/camera/CameraTable.vala"
		_tmp1_ = camera_table_new ();
#line 97 "../src/camera/CameraTable.vala"
		_camera_table_unref0 (camera_table_instance);
#line 97 "../src/camera/CameraTable.vala"
		camera_table_instance = _tmp1_;
#line 816 "CameraTable.c"
	}
#line 99 "../src/camera/CameraTable.vala"
	_tmp2_ = camera_table_instance;
#line 99 "../src/camera/CameraTable.vala"
	_tmp3_ = _camera_table_ref0 (_tmp2_);
#line 99 "../src/camera/CameraTable.vala"
	result = _tmp3_;
#line 99 "../src/camera/CameraTable.vala"
	return result;
#line 826 "CameraTable.c"
}

GeeIterable*
camera_table_get_cameras (CameraTable* self)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeIterable* result;
#line 102 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 103 "../src/camera/CameraTable.vala"
	_tmp0_ = self->priv->camera_map;
#line 103 "../src/camera/CameraTable.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 103 "../src/camera/CameraTable.vala"
	_tmp2_ = _tmp1_;
#line 103 "../src/camera/CameraTable.vala"
	result = (GeeIterable*) _tmp2_;
#line 103 "../src/camera/CameraTable.vala"
	return result;
#line 848 "CameraTable.c"
}

gint
camera_table_get_count (CameraTable* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 106 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 107 "../src/camera/CameraTable.vala"
	_tmp0_ = self->priv->camera_map;
#line 107 "../src/camera/CameraTable.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 107 "../src/camera/CameraTable.vala"
	_tmp2_ = _tmp1_;
#line 107 "../src/camera/CameraTable.vala"
	result = _tmp2_;
#line 107 "../src/camera/CameraTable.vala"
	return result;
#line 870 "CameraTable.c"
}

DiscoveredCamera*
camera_table_get_for_uri (CameraTable* self,
                          const gchar* uri)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	DiscoveredCamera* result;
#line 110 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 111 "../src/camera/CameraTable.vala"
	_tmp0_ = self->priv->camera_map;
#line 111 "../src/camera/CameraTable.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, uri);
#line 111 "../src/camera/CameraTable.vala"
	result = (DiscoveredCamera*) _tmp1_;
#line 111 "../src/camera/CameraTable.vala"
	return result;
#line 892 "CameraTable.c"
}

static void
camera_table_do_op (CameraTable* self,
                    int res,
                    const gchar* op,
                    GError** error)
{
	GError* _inner_error0_ = NULL;
#line 114 "../src/camera/CameraTable.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/camera/CameraTable.vala"
	g_return_if_fail (op != NULL);
#line 115 "../src/camera/CameraTable.vala"
	if (res != GP_OK) {
#line 908 "CameraTable.c"
		const gchar* _tmp0_;
		GError* _tmp1_;
#line 116 "../src/camera/CameraTable.vala"
		_tmp0_ = gp_port_result_as_string (res);
#line 116 "../src/camera/CameraTable.vala"
		_tmp1_ = g_error_new (GPHOTO_ERROR, GPHOTO_ERROR_LIBRARY, "[%d] Unable to %s: %s", (gint) res, op, _tmp0_);
#line 116 "../src/camera/CameraTable.vala"
		_inner_error0_ = _tmp1_;
#line 116 "../src/camera/CameraTable.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 116 "../src/camera/CameraTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 116 "../src/camera/CameraTable.vala"
			return;
#line 923 "CameraTable.c"
		} else {
#line 116 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 116 "../src/camera/CameraTable.vala"
			return;
#line 931 "CameraTable.c"
		}
	}
}

static void
camera_table_init_camera_table (CameraTable* self,
                                GError** error)
{
	CameraAbilitiesList* _tmp0_ = NULL;
	int _tmp1_;
	CameraAbilitiesList* _tmp2_;
	GPContext* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 119 "../src/camera/CameraTable.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/camera/CameraTable.vala"
	_tmp1_ = gp_abilities_list_new (&_tmp0_);
#line 120 "../src/camera/CameraTable.vala"
	_gp_abilities_list_free0 (self->priv->abilities_list);
#line 120 "../src/camera/CameraTable.vala"
	self->priv->abilities_list = _tmp0_;
#line 120 "../src/camera/CameraTable.vala"
	camera_table_do_op (self, _tmp1_, "create camera abilities list", &_inner_error0_);
#line 120 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../src/camera/CameraTable.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 120 "../src/camera/CameraTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 120 "../src/camera/CameraTable.vala"
			return;
#line 963 "CameraTable.c"
		} else {
#line 120 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 120 "../src/camera/CameraTable.vala"
			return;
#line 971 "CameraTable.c"
		}
	}
#line 121 "../src/camera/CameraTable.vala"
	_tmp2_ = self->priv->abilities_list;
#line 121 "../src/camera/CameraTable.vala"
	_tmp3_ = self->priv->null_context;
#line 121 "../src/camera/CameraTable.vala"
	camera_table_do_op (self, gp_abilities_list_load (_tmp2_, _tmp3_), "load camera abilities list", &_inner_error0_);
#line 121 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "../src/camera/CameraTable.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 121 "../src/camera/CameraTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 121 "../src/camera/CameraTable.vala"
			return;
#line 988 "CameraTable.c"
		} else {
#line 121 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 121 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 121 "../src/camera/CameraTable.vala"
			return;
#line 996 "CameraTable.c"
		}
	}
}

static void
_vala_array_add46 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 148 "../src/camera/CameraTable.vala"
	if ((*length) == (*size)) {
#line 148 "../src/camera/CameraTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 148 "../src/camera/CameraTable.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1013 "CameraTable.c"
	}
#line 148 "../src/camera/CameraTable.vala"
	(*array)[(*length)++] = value;
#line 148 "../src/camera/CameraTable.vala"
	(*array)[*length] = NULL;
#line 1019 "CameraTable.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 152 "../src/camera/CameraTable.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1027 "CameraTable.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 152 "../src/camera/CameraTable.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1035 "CameraTable.c"
}

static gchar**
camera_table_get_all_usb_cameras (CameraTable* self,
                                  gint* result_length1)
{
	gchar** cameras = NULL;
	gchar** _tmp0_;
	gint cameras_length1;
	gint _cameras_size_;
	GList* device_list = NULL;
	GUdevClient* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	gchar** result;
#line 124 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../src/camera/CameraTable.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 125 "../src/camera/CameraTable.vala"
	cameras = _tmp0_;
#line 125 "../src/camera/CameraTable.vala"
	cameras_length1 = 0;
#line 125 "../src/camera/CameraTable.vala"
	_cameras_size_ = cameras_length1;
#line 127 "../src/camera/CameraTable.vala"
	_tmp1_ = self->priv->client;
#line 127 "../src/camera/CameraTable.vala"
	_tmp2_ = g_udev_client_query_by_subsystem (_tmp1_, NULL);
#line 127 "../src/camera/CameraTable.vala"
	device_list = _tmp2_;
#line 128 "../src/camera/CameraTable.vala"
	_tmp3_ = device_list;
#line 1071 "CameraTable.c"
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
#line 128 "../src/camera/CameraTable.vala"
		device_collection = _tmp3_;
#line 128 "../src/camera/CameraTable.vala"
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 1079 "CameraTable.c"
			GUdevDevice* _tmp4_;
			GUdevDevice* device = NULL;
#line 128 "../src/camera/CameraTable.vala"
			_tmp4_ = _g_object_ref0 ((GUdevDevice*) device_it->data);
#line 128 "../src/camera/CameraTable.vala"
			device = _tmp4_;
#line 1086 "CameraTable.c"
			{
				gchar* device_file = NULL;
				GUdevDevice* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
				const gchar* _tmp10_;
#line 129 "../src/camera/CameraTable.vala"
				_tmp5_ = device;
#line 129 "../src/camera/CameraTable.vala"
				_tmp6_ = g_udev_device_get_device_file (_tmp5_);
#line 129 "../src/camera/CameraTable.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 129 "../src/camera/CameraTable.vala"
				device_file = _tmp7_;
#line 133 "../src/camera/CameraTable.vala"
				_tmp10_ = device_file;
#line 133 "../src/camera/CameraTable.vala"
				if (_tmp10_ != NULL) {
#line 1107 "CameraTable.c"
					GUdevDevice* _tmp11_;
#line 134 "../src/camera/CameraTable.vala"
					_tmp11_ = device;
#line 134 "../src/camera/CameraTable.vala"
					_tmp9_ = g_udev_device_has_property (_tmp11_, "ID_GPHOTO2");
#line 1113 "CameraTable.c"
				} else {
#line 133 "../src/camera/CameraTable.vala"
					_tmp9_ = FALSE;
#line 1117 "CameraTable.c"
				}
#line 133 "../src/camera/CameraTable.vala"
				if (_tmp9_) {
#line 1121 "CameraTable.c"
					GUdevDevice* _tmp12_;
#line 135 "../src/camera/CameraTable.vala"
					_tmp12_ = device;
#line 135 "../src/camera/CameraTable.vala"
					_tmp8_ = g_udev_device_has_property (_tmp12_, "GPHOTO2_DRIVER");
#line 1127 "CameraTable.c"
				} else {
#line 133 "../src/camera/CameraTable.vala"
					_tmp8_ = FALSE;
#line 1131 "CameraTable.c"
				}
#line 130 "../src/camera/CameraTable.vala"
				if (_tmp8_) {
#line 1135 "CameraTable.c"
					gint camera_bus = 0;
					gint camera_device = 0;
					const gchar* _tmp13_;
					gint _tmp14_ = 0;
					gint _tmp15_ = 0;
					gint _tmp16_;
					gchar* camera = NULL;
					gchar* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					gchar* _tmp21_;
#line 141 "../src/camera/CameraTable.vala"
					_tmp13_ = device_file;
#line 141 "../src/camera/CameraTable.vala"
					_tmp16_ = sscanf (_tmp13_, "/dev/bus/usb/%d/%d", &_tmp14_, &_tmp15_);
#line 141 "../src/camera/CameraTable.vala"
					camera_bus = _tmp14_;
#line 141 "../src/camera/CameraTable.vala"
					camera_device = _tmp15_;
#line 141 "../src/camera/CameraTable.vala"
					if (_tmp16_ < 2) {
#line 1157 "CameraTable.c"
						const gchar* _tmp17_;
#line 142 "../src/camera/CameraTable.vala"
						_tmp17_ = device_file;
#line 142 "../src/camera/CameraTable.vala"
						g_critical ("CameraTable.vala:142: get_all_usb_cameras: Failed to scanf device file" \
" %s", _tmp17_);
#line 144 "../src/camera/CameraTable.vala"
						_g_free0 (device_file);
#line 144 "../src/camera/CameraTable.vala"
						_g_object_unref0 (device);
#line 144 "../src/camera/CameraTable.vala"
						continue;
#line 1169 "CameraTable.c"
					}
#line 146 "../src/camera/CameraTable.vala"
					_tmp18_ = g_strdup_printf ("usb:%.3d,%.3d", camera_bus, camera_device);
#line 146 "../src/camera/CameraTable.vala"
					camera = _tmp18_;
#line 147 "../src/camera/CameraTable.vala"
					_tmp19_ = camera;
#line 147 "../src/camera/CameraTable.vala"
					g_debug ("CameraTable.vala:147: USB camera detected at %s", _tmp19_);
#line 148 "../src/camera/CameraTable.vala"
					_tmp20_ = camera;
#line 148 "../src/camera/CameraTable.vala"
					_tmp21_ = g_strdup (_tmp20_);
#line 148 "../src/camera/CameraTable.vala"
					_vala_array_add46 (&cameras, &cameras_length1, &_cameras_size_, _tmp21_);
#line 130 "../src/camera/CameraTable.vala"
					_g_free0 (camera);
#line 1187 "CameraTable.c"
				}
#line 128 "../src/camera/CameraTable.vala"
				_g_free0 (device_file);
#line 128 "../src/camera/CameraTable.vala"
				_g_object_unref0 (device);
#line 1193 "CameraTable.c"
			}
		}
	}
#line 152 "../src/camera/CameraTable.vala"
	_tmp22_ = cameras;
#line 152 "../src/camera/CameraTable.vala"
	_tmp22__length1 = cameras_length1;
#line 152 "../src/camera/CameraTable.vala"
	if (result_length1) {
#line 152 "../src/camera/CameraTable.vala"
		*result_length1 = _tmp22__length1;
#line 1205 "CameraTable.c"
	}
#line 152 "../src/camera/CameraTable.vala"
	result = _tmp22_;
#line 152 "../src/camera/CameraTable.vala"
	(device_list == NULL) ? NULL : (device_list = (_g_list_free__g_object_unref0_ (device_list), NULL));
#line 152 "../src/camera/CameraTable.vala"
	return result;
#line 1213 "CameraTable.c"
}

static gboolean
camera_table_usb_esp (CameraTable* self,
                      gint current_camera_count,
                      gchar** usb_cameras,
                      gint usb_cameras_length1,
                      const gchar* port,
                      gchar** full_port)
{
	gchar* _vala_full_port = NULL;
	gboolean _tmp0_ = FALSE;
	gint bus = 0;
	gint device = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_;
	gboolean result;
#line 163 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (port != NULL, FALSE);
#line 166 "../src/camera/CameraTable.vala"
	_vala_assert (current_camera_count > 0, "current_camera_count > 0");
#line 168 "../src/camera/CameraTable.vala"
	g_debug ("CameraTable.vala:168: USB ESP: current_camera_count=%d port=%s", current_camera_count, port);
#line 170 "../src/camera/CameraTable.vala"
	_g_free0 (_vala_full_port);
#line 170 "../src/camera/CameraTable.vala"
	_vala_full_port = NULL;
#line 173 "../src/camera/CameraTable.vala"
	if (current_camera_count == 1) {
#line 173 "../src/camera/CameraTable.vala"
		_tmp0_ = usb_cameras_length1 == 1;
#line 1248 "CameraTable.c"
	} else {
#line 173 "../src/camera/CameraTable.vala"
		_tmp0_ = FALSE;
#line 1252 "CameraTable.c"
	}
#line 173 "../src/camera/CameraTable.vala"
	if (_tmp0_) {
#line 1256 "CameraTable.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
#line 174 "../src/camera/CameraTable.vala"
		_tmp1_ = usb_cameras[0];
#line 174 "../src/camera/CameraTable.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 174 "../src/camera/CameraTable.vala"
		_g_free0 (_vala_full_port);
#line 174 "../src/camera/CameraTable.vala"
		_vala_full_port = _tmp2_;
#line 176 "../src/camera/CameraTable.vala"
		_tmp3_ = _vala_full_port;
#line 176 "../src/camera/CameraTable.vala"
		g_debug ("CameraTable.vala:176: USB ESP: port=%s full_port=%s", port, _tmp3_);
#line 178 "../src/camera/CameraTable.vala"
		result = TRUE;
#line 178 "../src/camera/CameraTable.vala"
		if (full_port) {
#line 178 "../src/camera/CameraTable.vala"
			*full_port = _vala_full_port;
#line 1278 "CameraTable.c"
		} else {
#line 178 "../src/camera/CameraTable.vala"
			_g_free0 (_vala_full_port);
#line 1282 "CameraTable.c"
		}
#line 178 "../src/camera/CameraTable.vala"
		return result;
#line 1286 "CameraTable.c"
	}
#line 182 "../src/camera/CameraTable.vala"
	if (g_strcmp0 (port, "usb:") == 0) {
#line 183 "../src/camera/CameraTable.vala"
		g_debug ("CameraTable.vala:183: USB ESP: Skipping %s", port);
#line 185 "../src/camera/CameraTable.vala"
		result = FALSE;
#line 185 "../src/camera/CameraTable.vala"
		if (full_port) {
#line 185 "../src/camera/CameraTable.vala"
			*full_port = _vala_full_port;
#line 1298 "CameraTable.c"
		} else {
#line 185 "../src/camera/CameraTable.vala"
			_g_free0 (_vala_full_port);
#line 1302 "CameraTable.c"
		}
#line 185 "../src/camera/CameraTable.vala"
		return result;
#line 1306 "CameraTable.c"
	}
#line 190 "../src/camera/CameraTable.vala"
	_tmp6_ = sscanf (port, "usb:%d,%d", &_tmp4_, &_tmp5_);
#line 190 "../src/camera/CameraTable.vala"
	bus = _tmp4_;
#line 190 "../src/camera/CameraTable.vala"
	device = _tmp5_;
#line 190 "../src/camera/CameraTable.vala"
	if (_tmp6_ < 2) {
#line 191 "../src/camera/CameraTable.vala"
		g_critical ("CameraTable.vala:191: USB ESP: Failed to scanf %s", port);
#line 193 "../src/camera/CameraTable.vala"
		result = FALSE;
#line 193 "../src/camera/CameraTable.vala"
		if (full_port) {
#line 193 "../src/camera/CameraTable.vala"
			*full_port = _vala_full_port;
#line 1324 "CameraTable.c"
		} else {
#line 193 "../src/camera/CameraTable.vala"
			_g_free0 (_vala_full_port);
#line 1328 "CameraTable.c"
		}
#line 193 "../src/camera/CameraTable.vala"
		return result;
#line 1332 "CameraTable.c"
	}
	{
		gchar** usb_camera_collection = NULL;
		gint usb_camera_collection_length1 = 0;
		gint _usb_camera_collection_size_ = 0;
		gint usb_camera_it = 0;
#line 196 "../src/camera/CameraTable.vala"
		usb_camera_collection = usb_cameras;
#line 196 "../src/camera/CameraTable.vala"
		usb_camera_collection_length1 = usb_cameras_length1;
#line 196 "../src/camera/CameraTable.vala"
		for (usb_camera_it = 0; usb_camera_it < usb_camera_collection_length1; usb_camera_it = usb_camera_it + 1) {
#line 1345 "CameraTable.c"
			gchar* _tmp7_;
			gchar* usb_camera = NULL;
#line 196 "../src/camera/CameraTable.vala"
			_tmp7_ = g_strdup (usb_camera_collection[usb_camera_it]);
#line 196 "../src/camera/CameraTable.vala"
			usb_camera = _tmp7_;
#line 1352 "CameraTable.c"
			{
				gint camera_bus = 0;
				gint camera_device = 0;
				const gchar* _tmp8_;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint _tmp11_;
				gboolean _tmp13_ = FALSE;
#line 198 "../src/camera/CameraTable.vala"
				_tmp8_ = usb_camera;
#line 198 "../src/camera/CameraTable.vala"
				_tmp11_ = sscanf (_tmp8_, "usb:%d,%d", &_tmp9_, &_tmp10_);
#line 198 "../src/camera/CameraTable.vala"
				camera_bus = _tmp9_;
#line 198 "../src/camera/CameraTable.vala"
				camera_device = _tmp10_;
#line 198 "../src/camera/CameraTable.vala"
				if (_tmp11_ < 2) {
#line 1371 "CameraTable.c"
					const gchar* _tmp12_;
#line 199 "../src/camera/CameraTable.vala"
					_tmp12_ = usb_camera;
#line 199 "../src/camera/CameraTable.vala"
					g_critical ("CameraTable.vala:199: USB ESP: Failed to scanf %s", _tmp12_);
#line 201 "../src/camera/CameraTable.vala"
					_g_free0 (usb_camera);
#line 201 "../src/camera/CameraTable.vala"
					continue;
#line 1381 "CameraTable.c"
				}
#line 204 "../src/camera/CameraTable.vala"
				if (bus == camera_bus) {
#line 204 "../src/camera/CameraTable.vala"
					_tmp13_ = device == camera_device;
#line 1387 "CameraTable.c"
				} else {
#line 204 "../src/camera/CameraTable.vala"
					_tmp13_ = FALSE;
#line 1391 "CameraTable.c"
				}
#line 204 "../src/camera/CameraTable.vala"
				if (_tmp13_) {
#line 1395 "CameraTable.c"
					gchar* _tmp14_;
					const gchar* _tmp15_;
#line 205 "../src/camera/CameraTable.vala"
					_tmp14_ = g_strdup (port);
#line 205 "../src/camera/CameraTable.vala"
					_g_free0 (_vala_full_port);
#line 205 "../src/camera/CameraTable.vala"
					_vala_full_port = _tmp14_;
#line 207 "../src/camera/CameraTable.vala"
					_tmp15_ = _vala_full_port;
#line 207 "../src/camera/CameraTable.vala"
					g_debug ("CameraTable.vala:207: USB ESP: port=%s full_port=%s", port, _tmp15_);
#line 209 "../src/camera/CameraTable.vala"
					result = TRUE;
#line 209 "../src/camera/CameraTable.vala"
					_g_free0 (usb_camera);
#line 209 "../src/camera/CameraTable.vala"
					if (full_port) {
#line 209 "../src/camera/CameraTable.vala"
						*full_port = _vala_full_port;
#line 1416 "CameraTable.c"
					} else {
#line 209 "../src/camera/CameraTable.vala"
						_g_free0 (_vala_full_port);
#line 1420 "CameraTable.c"
					}
#line 209 "../src/camera/CameraTable.vala"
					return result;
#line 1424 "CameraTable.c"
				}
#line 196 "../src/camera/CameraTable.vala"
				_g_free0 (usb_camera);
#line 1428 "CameraTable.c"
			}
		}
	}
#line 213 "../src/camera/CameraTable.vala"
	g_debug ("CameraTable.vala:213: USB ESP: No matching bus/device found for port=%" \
"s", port);
#line 215 "../src/camera/CameraTable.vala"
	result = FALSE;
#line 215 "../src/camera/CameraTable.vala"
	if (full_port) {
#line 215 "../src/camera/CameraTable.vala"
		*full_port = _vala_full_port;
#line 1440 "CameraTable.c"
	} else {
#line 215 "../src/camera/CameraTable.vala"
		_g_free0 (_vala_full_port);
#line 1444 "CameraTable.c"
	}
#line 215 "../src/camera/CameraTable.vala"
	return result;
#line 1448 "CameraTable.c"
}

gchar*
camera_table_get_port_uri (const gchar* port)
{
	gchar* _tmp0_;
	gchar* result;
#line 218 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (port != NULL, NULL);
#line 219 "../src/camera/CameraTable.vala"
	_tmp0_ = g_strdup_printf ("gphoto2://[%s]/", port);
#line 219 "../src/camera/CameraTable.vala"
	result = _tmp0_;
#line 219 "../src/camera/CameraTable.vala"
	return result;
#line 1464 "CameraTable.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1487 "CameraTable.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1496 "CameraTable.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1515 "CameraTable.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1519 "CameraTable.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1525 "CameraTable.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1535 "CameraTable.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1543 "CameraTable.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1547 "CameraTable.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 1553 "CameraTable.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1563 "CameraTable.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1585 "CameraTable.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1589 "CameraTable.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1595 "CameraTable.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1599 "CameraTable.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1603 "CameraTable.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1611 "CameraTable.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1639 "CameraTable.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1648 "CameraTable.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1662 "CameraTable.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1671 "CameraTable.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1685 "CameraTable.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1694 "CameraTable.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1703 "CameraTable.c"
}

gchar*
camera_table_get_port_path (const gchar* port)
{
	gchar* _tmp0_ = NULL;
	gchar* result;
#line 222 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (port != NULL, NULL);
#line 224 "../src/camera/CameraTable.vala"
	if (g_str_has_prefix (port, "usb:")) {
#line 1715 "CameraTable.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 225 "../src/camera/CameraTable.vala"
		_tmp1_ = string_substring (port, (glong) 4, (glong) -1);
#line 225 "../src/camera/CameraTable.vala"
		_tmp2_ = _tmp1_;
#line 225 "../src/camera/CameraTable.vala"
		_tmp3_ = string_replace (_tmp2_, ",", "/");
#line 225 "../src/camera/CameraTable.vala"
		_tmp4_ = _tmp3_;
#line 225 "../src/camera/CameraTable.vala"
		_tmp5_ = g_strdup_printf ("/dev/bus/usb/%s", _tmp4_);
#line 225 "../src/camera/CameraTable.vala"
		_g_free0 (_tmp0_);
#line 225 "../src/camera/CameraTable.vala"
		_tmp0_ = _tmp5_;
#line 225 "../src/camera/CameraTable.vala"
		_g_free0 (_tmp4_);
#line 225 "../src/camera/CameraTable.vala"
		_g_free0 (_tmp2_);
#line 1739 "CameraTable.c"
	} else {
#line 225 "../src/camera/CameraTable.vala"
		_g_free0 (_tmp0_);
#line 225 "../src/camera/CameraTable.vala"
		_tmp0_ = NULL;
#line 1745 "CameraTable.c"
	}
#line 224 "../src/camera/CameraTable.vala"
	result = _tmp0_;
#line 224 "../src/camera/CameraTable.vala"
	return result;
#line 1751 "CameraTable.c"
}

static gchar*
camera_table_get_name_for_uuid (CameraTable* self,
                                const gchar* uuid)
{
	GVolumeMonitor* _tmp0_;
	GList* _tmp1_;
	gchar* result;
#line 228 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 229 "../src/camera/CameraTable.vala"
	_tmp0_ = self->priv->volume_monitor;
#line 229 "../src/camera/CameraTable.vala"
	_tmp1_ = g_volume_monitor_get_volumes (_tmp0_);
#line 1769 "CameraTable.c"
	{
		GList* volume_collection = NULL;
		GList* volume_it = NULL;
#line 229 "../src/camera/CameraTable.vala"
		volume_collection = _tmp1_;
#line 229 "../src/camera/CameraTable.vala"
		for (volume_it = volume_collection; volume_it != NULL; volume_it = volume_it->next) {
#line 1777 "CameraTable.c"
			GVolume* _tmp2_;
			GVolume* volume = NULL;
#line 229 "../src/camera/CameraTable.vala"
			_tmp2_ = _g_object_ref0 ((GVolume*) volume_it->data);
#line 229 "../src/camera/CameraTable.vala"
			volume = _tmp2_;
#line 1784 "CameraTable.c"
			{
				GVolume* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gboolean _tmp6_;
#line 230 "../src/camera/CameraTable.vala"
				_tmp3_ = volume;
#line 230 "../src/camera/CameraTable.vala"
				_tmp4_ = g_volume_get_identifier (_tmp3_, G_VOLUME_IDENTIFIER_KIND_UUID);
#line 230 "../src/camera/CameraTable.vala"
				_tmp5_ = _tmp4_;
#line 230 "../src/camera/CameraTable.vala"
				_tmp6_ = g_strcmp0 (_tmp5_, uuid) == 0;
#line 230 "../src/camera/CameraTable.vala"
				_g_free0 (_tmp5_);
#line 230 "../src/camera/CameraTable.vala"
				if (_tmp6_) {
#line 1802 "CameraTable.c"
					GVolume* _tmp7_;
					gchar* _tmp8_;
#line 231 "../src/camera/CameraTable.vala"
					_tmp7_ = volume;
#line 231 "../src/camera/CameraTable.vala"
					_tmp8_ = g_volume_get_name (_tmp7_);
#line 231 "../src/camera/CameraTable.vala"
					result = _tmp8_;
#line 231 "../src/camera/CameraTable.vala"
					_g_object_unref0 (volume);
#line 231 "../src/camera/CameraTable.vala"
					(volume_collection == NULL) ? NULL : (volume_collection = (_g_list_free__g_object_unref0_ (volume_collection), NULL));
#line 231 "../src/camera/CameraTable.vala"
					return result;
#line 1817 "CameraTable.c"
				}
#line 229 "../src/camera/CameraTable.vala"
				_g_object_unref0 (volume);
#line 1821 "CameraTable.c"
			}
		}
#line 229 "../src/camera/CameraTable.vala"
		(volume_collection == NULL) ? NULL : (volume_collection = (_g_list_free__g_object_unref0_ (volume_collection), NULL));
#line 1826 "CameraTable.c"
	}
#line 234 "../src/camera/CameraTable.vala"
	result = NULL;
#line 234 "../src/camera/CameraTable.vala"
	return result;
#line 1832 "CameraTable.c"
}

static GIcon*
camera_table_get_icon_for_uuid (CameraTable* self,
                                const gchar* uuid)
{
	GVolumeMonitor* _tmp0_;
	GList* _tmp1_;
	GIcon* result;
#line 237 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 237 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 238 "../src/camera/CameraTable.vala"
	_tmp0_ = self->priv->volume_monitor;
#line 238 "../src/camera/CameraTable.vala"
	_tmp1_ = g_volume_monitor_get_volumes (_tmp0_);
#line 1850 "CameraTable.c"
	{
		GList* volume_collection = NULL;
		GList* volume_it = NULL;
#line 238 "../src/camera/CameraTable.vala"
		volume_collection = _tmp1_;
#line 238 "../src/camera/CameraTable.vala"
		for (volume_it = volume_collection; volume_it != NULL; volume_it = volume_it->next) {
#line 1858 "CameraTable.c"
			GVolume* _tmp2_;
			GVolume* volume = NULL;
#line 238 "../src/camera/CameraTable.vala"
			_tmp2_ = _g_object_ref0 ((GVolume*) volume_it->data);
#line 238 "../src/camera/CameraTable.vala"
			volume = _tmp2_;
#line 1865 "CameraTable.c"
			{
				GVolume* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gboolean _tmp6_;
#line 239 "../src/camera/CameraTable.vala"
				_tmp3_ = volume;
#line 239 "../src/camera/CameraTable.vala"
				_tmp4_ = g_volume_get_identifier (_tmp3_, G_VOLUME_IDENTIFIER_KIND_UUID);
#line 239 "../src/camera/CameraTable.vala"
				_tmp5_ = _tmp4_;
#line 239 "../src/camera/CameraTable.vala"
				_tmp6_ = g_strcmp0 (_tmp5_, uuid) == 0;
#line 239 "../src/camera/CameraTable.vala"
				_g_free0 (_tmp5_);
#line 239 "../src/camera/CameraTable.vala"
				if (_tmp6_) {
#line 1883 "CameraTable.c"
					GVolume* _tmp7_;
					GIcon* _tmp8_;
#line 240 "../src/camera/CameraTable.vala"
					_tmp7_ = volume;
#line 240 "../src/camera/CameraTable.vala"
					_tmp8_ = g_volume_get_icon (_tmp7_);
#line 240 "../src/camera/CameraTable.vala"
					result = _tmp8_;
#line 240 "../src/camera/CameraTable.vala"
					_g_object_unref0 (volume);
#line 240 "../src/camera/CameraTable.vala"
					(volume_collection == NULL) ? NULL : (volume_collection = (_g_list_free__g_object_unref0_ (volume_collection), NULL));
#line 240 "../src/camera/CameraTable.vala"
					return result;
#line 1898 "CameraTable.c"
				}
#line 238 "../src/camera/CameraTable.vala"
				_g_object_unref0 (volume);
#line 1902 "CameraTable.c"
			}
		}
#line 238 "../src/camera/CameraTable.vala"
		(volume_collection == NULL) ? NULL : (volume_collection = (_g_list_free__g_object_unref0_ (volume_collection), NULL));
#line 1907 "CameraTable.c"
	}
#line 243 "../src/camera/CameraTable.vala"
	result = NULL;
#line 243 "../src/camera/CameraTable.vala"
	return result;
#line 1913 "CameraTable.c"
}

static gpointer
_discovered_camera_ref0 (gpointer self)
{
#line 305 "../src/camera/CameraTable.vala"
	return self ? discovered_camera_ref (self) : NULL;
#line 1921 "CameraTable.c"
}

static void
_vala_array_add47 (DiscoveredCamera** * array,
                   gint* length,
                   gint* size,
                   DiscoveredCamera* value)
{
#line 305 "../src/camera/CameraTable.vala"
	if ((*length) == (*size)) {
#line 305 "../src/camera/CameraTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 305 "../src/camera/CameraTable.vala"
		*array = g_renew (DiscoveredCamera*, *array, (*size) + 1);
#line 1936 "CameraTable.c"
	}
#line 305 "../src/camera/CameraTable.vala"
	(*array)[(*length)++] = value;
#line 305 "../src/camera/CameraTable.vala"
	(*array)[*length] = NULL;
#line 1942 "CameraTable.c"
}

static void
camera_table_update_camera_table (CameraTable* self,
                                  GError** error)
{
	GPPortInfoList* port_info_list = NULL;
	GPPortInfoList* _tmp0_ = NULL;
	int _tmp1_;
	GPPortInfoList* _tmp2_;
	CameraList* camera_list = NULL;
	CameraList* _tmp3_ = NULL;
	int _tmp4_;
	CameraAbilitiesList* _tmp5_;
	GPPortInfoList* _tmp6_;
	CameraList* _tmp7_;
	GPContext* _tmp8_;
	GeeHashMap* detected_map = NULL;
	GeeHashMap* _tmp9_;
	gchar** usb_cameras = NULL;
	gint _tmp10_ = 0;
	gchar** _tmp11_;
	gint usb_cameras_length1;
	gint _usb_cameras_size_;
	DiscoveredCamera** missing = NULL;
	DiscoveredCamera** _tmp37_;
	gint missing_length1;
	gint _missing_size_;
	DiscoveredCamera** _tmp65_;
	gint _tmp65__length1;
	GError* _inner_error0_ = NULL;
#line 246 "../src/camera/CameraTable.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/camera/CameraTable.vala"
	_tmp1_ = gp_port_info_list_new (&_tmp0_);
#line 249 "../src/camera/CameraTable.vala"
	_gp_port_info_list_free0 (port_info_list);
#line 249 "../src/camera/CameraTable.vala"
	port_info_list = _tmp0_;
#line 249 "../src/camera/CameraTable.vala"
	camera_table_do_op (self, _tmp1_, "create port list", &_inner_error0_);
#line 249 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 249 "../src/camera/CameraTable.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 249 "../src/camera/CameraTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 249 "../src/camera/CameraTable.vala"
			_gp_port_info_list_free0 (port_info_list);
#line 249 "../src/camera/CameraTable.vala"
			return;
#line 1994 "CameraTable.c"
		} else {
#line 249 "../src/camera/CameraTable.vala"
			_gp_port_info_list_free0 (port_info_list);
#line 249 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 249 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 249 "../src/camera/CameraTable.vala"
			return;
#line 2004 "CameraTable.c"
		}
	}
#line 250 "../src/camera/CameraTable.vala"
	_tmp2_ = port_info_list;
#line 250 "../src/camera/CameraTable.vala"
	camera_table_do_op (self, gp_port_info_list_load (_tmp2_), "load port list", &_inner_error0_);
#line 250 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../src/camera/CameraTable.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 250 "../src/camera/CameraTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 250 "../src/camera/CameraTable.vala"
			_gp_port_info_list_free0 (port_info_list);
#line 250 "../src/camera/CameraTable.vala"
			return;
#line 2021 "CameraTable.c"
		} else {
#line 250 "../src/camera/CameraTable.vala"
			_gp_port_info_list_free0 (port_info_list);
#line 250 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 250 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 250 "../src/camera/CameraTable.vala"
			return;
#line 2031 "CameraTable.c"
		}
	}
#line 253 "../src/camera/CameraTable.vala"
	_tmp4_ = gp_list_new (&_tmp3_);
#line 253 "../src/camera/CameraTable.vala"
	_gp_list_unref0 (camera_list);
#line 253 "../src/camera/CameraTable.vala"
	camera_list = _tmp3_;
#line 253 "../src/camera/CameraTable.vala"
	camera_table_do_op (self, _tmp4_, "create camera list", &_inner_error0_);
#line 253 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "../src/camera/CameraTable.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 253 "../src/camera/CameraTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 253 "../src/camera/CameraTable.vala"
			_gp_list_unref0 (camera_list);
#line 253 "../src/camera/CameraTable.vala"
			_gp_port_info_list_free0 (port_info_list);
#line 253 "../src/camera/CameraTable.vala"
			return;
#line 2054 "CameraTable.c"
		} else {
#line 253 "../src/camera/CameraTable.vala"
			_gp_list_unref0 (camera_list);
#line 253 "../src/camera/CameraTable.vala"
			_gp_port_info_list_free0 (port_info_list);
#line 253 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 253 "../src/camera/CameraTable.vala"
			return;
#line 2066 "CameraTable.c"
		}
	}
#line 254 "../src/camera/CameraTable.vala"
	_tmp5_ = self->priv->abilities_list;
#line 254 "../src/camera/CameraTable.vala"
	_tmp6_ = port_info_list;
#line 254 "../src/camera/CameraTable.vala"
	_tmp7_ = camera_list;
#line 254 "../src/camera/CameraTable.vala"
	_tmp8_ = self->priv->null_context;
#line 254 "../src/camera/CameraTable.vala"
	camera_table_do_op (self, gp_abilities_list_detect (_tmp5_, _tmp6_, _tmp7_, _tmp8_), "detect cameras", &_inner_error0_);
#line 254 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../src/camera/CameraTable.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 254 "../src/camera/CameraTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 254 "../src/camera/CameraTable.vala"
			_gp_list_unref0 (camera_list);
#line 254 "../src/camera/CameraTable.vala"
			_gp_port_info_list_free0 (port_info_list);
#line 254 "../src/camera/CameraTable.vala"
			return;
#line 2091 "CameraTable.c"
		} else {
#line 254 "../src/camera/CameraTable.vala"
			_gp_list_unref0 (camera_list);
#line 254 "../src/camera/CameraTable.vala"
			_gp_port_info_list_free0 (port_info_list);
#line 254 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 254 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 254 "../src/camera/CameraTable.vala"
			return;
#line 2103 "CameraTable.c"
		}
	}
#line 256 "../src/camera/CameraTable.vala"
	_tmp9_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 256 "../src/camera/CameraTable.vala"
	detected_map = _tmp9_;
#line 259 "../src/camera/CameraTable.vala"
	_tmp11_ = camera_table_get_all_usb_cameras (self, &_tmp10_);
#line 259 "../src/camera/CameraTable.vala"
	usb_cameras = _tmp11_;
#line 259 "../src/camera/CameraTable.vala"
	usb_cameras_length1 = _tmp10_;
#line 259 "../src/camera/CameraTable.vala"
	_usb_cameras_size_ = usb_cameras_length1;
#line 2118 "CameraTable.c"
	{
		gint ctr = 0;
#line 262 "../src/camera/CameraTable.vala"
		ctr = 0;
#line 2123 "CameraTable.c"
		{
			gboolean _tmp12_ = FALSE;
#line 262 "../src/camera/CameraTable.vala"
			_tmp12_ = TRUE;
#line 262 "../src/camera/CameraTable.vala"
			while (TRUE) {
#line 2130 "CameraTable.c"
				CameraList* _tmp14_;
				gchar* name = NULL;
				CameraList* _tmp15_;
				const gchar* _tmp16_ = NULL;
				int _tmp17_;
				gchar* _tmp18_;
				gchar* port = NULL;
				CameraList* _tmp19_;
				const gchar* _tmp20_ = NULL;
				int _tmp21_;
				gchar* _tmp22_;
				CameraList* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				GeeHashMap* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
#line 262 "../src/camera/CameraTable.vala"
				if (!_tmp12_) {
#line 2151 "CameraTable.c"
					gint _tmp13_;
#line 262 "../src/camera/CameraTable.vala"
					_tmp13_ = ctr;
#line 262 "../src/camera/CameraTable.vala"
					ctr = _tmp13_ + 1;
#line 2157 "CameraTable.c"
				}
#line 262 "../src/camera/CameraTable.vala"
				_tmp12_ = FALSE;
#line 262 "../src/camera/CameraTable.vala"
				_tmp14_ = camera_list;
#line 262 "../src/camera/CameraTable.vala"
				if (!(ctr < gp_list_count (_tmp14_))) {
#line 262 "../src/camera/CameraTable.vala"
					break;
#line 2167 "CameraTable.c"
				}
#line 264 "../src/camera/CameraTable.vala"
				_tmp15_ = camera_list;
#line 264 "../src/camera/CameraTable.vala"
				_tmp17_ = gp_list_get_name (_tmp15_, ctr, &_tmp16_);
#line 264 "../src/camera/CameraTable.vala"
				_g_free0 (name);
#line 264 "../src/camera/CameraTable.vala"
				_tmp18_ = g_strdup (_tmp16_);
#line 264 "../src/camera/CameraTable.vala"
				name = _tmp18_;
#line 264 "../src/camera/CameraTable.vala"
				camera_table_do_op (self, _tmp17_, "get detected camera name", &_inner_error0_);
#line 264 "../src/camera/CameraTable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "../src/camera/CameraTable.vala"
					if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 264 "../src/camera/CameraTable.vala"
						g_propagate_error (error, _inner_error0_);
#line 264 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 264 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 264 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 264 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 264 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 264 "../src/camera/CameraTable.vala"
						return;
#line 2199 "CameraTable.c"
					} else {
#line 264 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 264 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 264 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 264 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 264 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 264 "../src/camera/CameraTable.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 264 "../src/camera/CameraTable.vala"
						g_clear_error (&_inner_error0_);
#line 264 "../src/camera/CameraTable.vala"
						return;
#line 2217 "CameraTable.c"
					}
				}
#line 267 "../src/camera/CameraTable.vala"
				_tmp19_ = camera_list;
#line 267 "../src/camera/CameraTable.vala"
				_tmp21_ = gp_list_get_value (_tmp19_, ctr, &_tmp20_);
#line 267 "../src/camera/CameraTable.vala"
				_g_free0 (port);
#line 267 "../src/camera/CameraTable.vala"
				_tmp22_ = g_strdup (_tmp20_);
#line 267 "../src/camera/CameraTable.vala"
				port = _tmp22_;
#line 267 "../src/camera/CameraTable.vala"
				camera_table_do_op (self, _tmp21_, "get detected camera port", &_inner_error0_);
#line 267 "../src/camera/CameraTable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "../src/camera/CameraTable.vala"
					if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 267 "../src/camera/CameraTable.vala"
						g_propagate_error (error, _inner_error0_);
#line 267 "../src/camera/CameraTable.vala"
						_g_free0 (port);
#line 267 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 267 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 267 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 267 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 267 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 267 "../src/camera/CameraTable.vala"
						return;
#line 2252 "CameraTable.c"
					} else {
#line 267 "../src/camera/CameraTable.vala"
						_g_free0 (port);
#line 267 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 267 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 267 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 267 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 267 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 267 "../src/camera/CameraTable.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 267 "../src/camera/CameraTable.vala"
						g_clear_error (&_inner_error0_);
#line 267 "../src/camera/CameraTable.vala"
						return;
#line 2272 "CameraTable.c"
					}
				}
#line 269 "../src/camera/CameraTable.vala"
				_tmp23_ = camera_list;
#line 269 "../src/camera/CameraTable.vala"
				_tmp24_ = name;
#line 269 "../src/camera/CameraTable.vala"
				_tmp25_ = port;
#line 269 "../src/camera/CameraTable.vala"
				g_debug ("CameraTable.vala:269: Detected %d/%d %s @ %s", ctr + 1, gp_list_count (_tmp23_), _tmp24_, _tmp25_);
#line 272 "../src/camera/CameraTable.vala"
				_tmp26_ = port;
#line 272 "../src/camera/CameraTable.vala"
				if (g_str_has_prefix (_tmp26_, "usb:")) {
#line 2287 "CameraTable.c"
					gchar* full_port = NULL;
					CameraList* _tmp27_;
					gchar** _tmp28_;
					gint _tmp28__length1;
					const gchar* _tmp29_;
					gchar* _tmp30_ = NULL;
					gboolean _tmp31_;
					const gchar* _tmp32_;
					gchar* _tmp33_;
#line 274 "../src/camera/CameraTable.vala"
					_tmp27_ = camera_list;
#line 274 "../src/camera/CameraTable.vala"
					_tmp28_ = usb_cameras;
#line 274 "../src/camera/CameraTable.vala"
					_tmp28__length1 = usb_cameras_length1;
#line 274 "../src/camera/CameraTable.vala"
					_tmp29_ = port;
#line 274 "../src/camera/CameraTable.vala"
					_tmp31_ = camera_table_usb_esp (self, gp_list_count (_tmp27_), _tmp28_, (gint) _tmp28__length1, _tmp29_, &_tmp30_);
#line 274 "../src/camera/CameraTable.vala"
					_g_free0 (full_port);
#line 274 "../src/camera/CameraTable.vala"
					full_port = _tmp30_;
#line 274 "../src/camera/CameraTable.vala"
					if (!_tmp31_) {
#line 275 "../src/camera/CameraTable.vala"
						_g_free0 (full_port);
#line 275 "../src/camera/CameraTable.vala"
						_g_free0 (port);
#line 275 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 275 "../src/camera/CameraTable.vala"
						continue;
#line 2321 "CameraTable.c"
					}
#line 277 "../src/camera/CameraTable.vala"
					_tmp32_ = full_port;
#line 277 "../src/camera/CameraTable.vala"
					_tmp33_ = g_strdup (_tmp32_);
#line 277 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 277 "../src/camera/CameraTable.vala"
					port = _tmp33_;
#line 272 "../src/camera/CameraTable.vala"
					_g_free0 (full_port);
#line 2333 "CameraTable.c"
				}
#line 280 "../src/camera/CameraTable.vala"
				_tmp34_ = detected_map;
#line 280 "../src/camera/CameraTable.vala"
				_tmp35_ = port;
#line 280 "../src/camera/CameraTable.vala"
				_tmp36_ = name;
#line 280 "../src/camera/CameraTable.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp34_, _tmp35_, _tmp36_);
#line 262 "../src/camera/CameraTable.vala"
				_g_free0 (port);
#line 262 "../src/camera/CameraTable.vala"
				_g_free0 (name);
#line 2347 "CameraTable.c"
			}
		}
	}
#line 284 "../src/camera/CameraTable.vala"
	_tmp37_ = g_new0 (DiscoveredCamera*, 0 + 1);
#line 284 "../src/camera/CameraTable.vala"
	missing = _tmp37_;
#line 284 "../src/camera/CameraTable.vala"
	missing_length1 = 0;
#line 284 "../src/camera/CameraTable.vala"
	_missing_size_ = missing_length1;
#line 2359 "CameraTable.c"
	{
		GeeIterator* _camera_it = NULL;
		GeeHashMap* _tmp38_;
		GeeCollection* _tmp39_;
		GeeCollection* _tmp40_;
		GeeCollection* _tmp41_;
		GeeIterator* _tmp42_;
		GeeIterator* _tmp43_;
#line 285 "../src/camera/CameraTable.vala"
		_tmp38_ = self->priv->camera_map;
#line 285 "../src/camera/CameraTable.vala"
		_tmp39_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp38_);
#line 285 "../src/camera/CameraTable.vala"
		_tmp40_ = _tmp39_;
#line 285 "../src/camera/CameraTable.vala"
		_tmp41_ = _tmp40_;
#line 285 "../src/camera/CameraTable.vala"
		_tmp42_ = gee_iterable_iterator ((GeeIterable*) _tmp41_);
#line 285 "../src/camera/CameraTable.vala"
		_tmp43_ = _tmp42_;
#line 285 "../src/camera/CameraTable.vala"
		_g_object_unref0 (_tmp41_);
#line 285 "../src/camera/CameraTable.vala"
		_camera_it = _tmp43_;
#line 285 "../src/camera/CameraTable.vala"
		while (TRUE) {
#line 2386 "CameraTable.c"
			GeeIterator* _tmp44_;
			DiscoveredCamera* camera = NULL;
			GeeIterator* _tmp45_;
			gpointer _tmp46_;
			GPPortInfo port_info = {0};
			gchar* tmp_path = NULL;
			DiscoveredCamera* _tmp47_;
			Camera* _tmp48_;
			GPPortInfo _tmp49_ = {0};
			int _tmp50_;
			const gchar* _tmp51_ = NULL;
			gchar* _tmp52_;
			CameraAbilities abilities = {0};
			DiscoveredCamera* _tmp53_;
			Camera* _tmp54_;
			CameraAbilities _tmp55_ = {0};
			int _tmp56_;
			GeeHashMap* _tmp57_;
			const gchar* _tmp58_;
			const gchar* _tmp61_;
			const gchar* _tmp62_;
			DiscoveredCamera* _tmp63_;
			DiscoveredCamera* _tmp64_;
#line 285 "../src/camera/CameraTable.vala"
			_tmp44_ = _camera_it;
#line 285 "../src/camera/CameraTable.vala"
			if (!gee_iterator_next (_tmp44_)) {
#line 285 "../src/camera/CameraTable.vala"
				break;
#line 2416 "CameraTable.c"
			}
#line 285 "../src/camera/CameraTable.vala"
			_tmp45_ = _camera_it;
#line 285 "../src/camera/CameraTable.vala"
			_tmp46_ = gee_iterator_get (_tmp45_);
#line 285 "../src/camera/CameraTable.vala"
			camera = (DiscoveredCamera*) _tmp46_;
#line 289 "../src/camera/CameraTable.vala"
			_tmp47_ = camera;
#line 289 "../src/camera/CameraTable.vala"
			_tmp48_ = _tmp47_->gcamera;
#line 289 "../src/camera/CameraTable.vala"
			_tmp50_ = gp_camera_get_port_info (_tmp48_, &_tmp49_);
#line 289 "../src/camera/CameraTable.vala"
			 (port_info);
#line 289 "../src/camera/CameraTable.vala"
			port_info = _tmp49_;
#line 289 "../src/camera/CameraTable.vala"
			camera_table_do_op (self, _tmp50_, "retrieve missing camera port information", &_inner_error0_);
#line 289 "../src/camera/CameraTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 289 "../src/camera/CameraTable.vala"
				if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 289 "../src/camera/CameraTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 289 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 289 "../src/camera/CameraTable.vala"
					 (port_info);
#line 289 "../src/camera/CameraTable.vala"
					_discovered_camera_unref0 (camera);
#line 289 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_camera_it);
#line 289 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 289 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 289 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 289 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 289 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 289 "../src/camera/CameraTable.vala"
					return;
#line 2462 "CameraTable.c"
				} else {
#line 289 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 289 "../src/camera/CameraTable.vala"
					 (port_info);
#line 289 "../src/camera/CameraTable.vala"
					_discovered_camera_unref0 (camera);
#line 289 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_camera_it);
#line 289 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 289 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 289 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 289 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 289 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 289 "../src/camera/CameraTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 289 "../src/camera/CameraTable.vala"
					g_clear_error (&_inner_error0_);
#line 289 "../src/camera/CameraTable.vala"
					return;
#line 2488 "CameraTable.c"
				}
			}
#line 292 "../src/camera/CameraTable.vala"
			gp_port_info_get_path (port_info, &_tmp51_);
#line 292 "../src/camera/CameraTable.vala"
			_g_free0 (tmp_path);
#line 292 "../src/camera/CameraTable.vala"
			_tmp52_ = g_strdup (_tmp51_);
#line 292 "../src/camera/CameraTable.vala"
			tmp_path = _tmp52_;
#line 295 "../src/camera/CameraTable.vala"
			_tmp53_ = camera;
#line 295 "../src/camera/CameraTable.vala"
			_tmp54_ = _tmp53_->gcamera;
#line 295 "../src/camera/CameraTable.vala"
			_tmp56_ = gp_camera_get_abilities (_tmp54_, &_tmp55_);
#line 295 "../src/camera/CameraTable.vala"
			 (abilities);
#line 295 "../src/camera/CameraTable.vala"
			abilities = _tmp55_;
#line 295 "../src/camera/CameraTable.vala"
			camera_table_do_op (self, _tmp56_, "retrieve camera abilities", &_inner_error0_);
#line 295 "../src/camera/CameraTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 295 "../src/camera/CameraTable.vala"
				if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 295 "../src/camera/CameraTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 295 "../src/camera/CameraTable.vala"
					 (abilities);
#line 295 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 295 "../src/camera/CameraTable.vala"
					 (port_info);
#line 295 "../src/camera/CameraTable.vala"
					_discovered_camera_unref0 (camera);
#line 295 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_camera_it);
#line 295 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 295 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 295 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 295 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 295 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 295 "../src/camera/CameraTable.vala"
					return;
#line 2539 "CameraTable.c"
				} else {
#line 295 "../src/camera/CameraTable.vala"
					 (abilities);
#line 295 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 295 "../src/camera/CameraTable.vala"
					 (port_info);
#line 295 "../src/camera/CameraTable.vala"
					_discovered_camera_unref0 (camera);
#line 295 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_camera_it);
#line 295 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 295 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 295 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 295 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 295 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 295 "../src/camera/CameraTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 295 "../src/camera/CameraTable.vala"
					g_clear_error (&_inner_error0_);
#line 295 "../src/camera/CameraTable.vala"
					return;
#line 2567 "CameraTable.c"
				}
			}
#line 297 "../src/camera/CameraTable.vala"
			_tmp57_ = detected_map;
#line 297 "../src/camera/CameraTable.vala"
			_tmp58_ = tmp_path;
#line 297 "../src/camera/CameraTable.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp57_, _tmp58_)) {
#line 2576 "CameraTable.c"
				const gchar* _tmp59_;
				const gchar* _tmp60_;
#line 298 "../src/camera/CameraTable.vala"
				_tmp59_ = abilities.model;
#line 298 "../src/camera/CameraTable.vala"
				_tmp60_ = tmp_path;
#line 298 "../src/camera/CameraTable.vala"
				g_debug ("CameraTable.vala:298: Found camera for %s @ %s in detected map", _tmp59_, _tmp60_);
#line 300 "../src/camera/CameraTable.vala"
				 (abilities);
#line 300 "../src/camera/CameraTable.vala"
				_g_free0 (tmp_path);
#line 300 "../src/camera/CameraTable.vala"
				 (port_info);
#line 300 "../src/camera/CameraTable.vala"
				_discovered_camera_unref0 (camera);
#line 300 "../src/camera/CameraTable.vala"
				continue;
#line 2595 "CameraTable.c"
			}
#line 303 "../src/camera/CameraTable.vala"
			_tmp61_ = abilities.model;
#line 303 "../src/camera/CameraTable.vala"
			_tmp62_ = tmp_path;
#line 303 "../src/camera/CameraTable.vala"
			g_debug ("CameraTable.vala:303: %s @ %s missing", _tmp61_, _tmp62_);
#line 305 "../src/camera/CameraTable.vala"
			_tmp63_ = camera;
#line 305 "../src/camera/CameraTable.vala"
			_tmp64_ = _discovered_camera_ref0 (_tmp63_);
#line 305 "../src/camera/CameraTable.vala"
			_vala_array_add47 (&missing, &missing_length1, &_missing_size_, _tmp64_);
#line 285 "../src/camera/CameraTable.vala"
			 (abilities);
#line 285 "../src/camera/CameraTable.vala"
			_g_free0 (tmp_path);
#line 285 "../src/camera/CameraTable.vala"
			 (port_info);
#line 285 "../src/camera/CameraTable.vala"
			_discovered_camera_unref0 (camera);
#line 2617 "CameraTable.c"
		}
#line 285 "../src/camera/CameraTable.vala"
		_g_object_unref0 (_camera_it);
#line 2621 "CameraTable.c"
	}
#line 309 "../src/camera/CameraTable.vala"
	_tmp65_ = missing;
#line 309 "../src/camera/CameraTable.vala"
	_tmp65__length1 = missing_length1;
#line 2627 "CameraTable.c"
	{
		DiscoveredCamera** camera_collection = NULL;
		gint camera_collection_length1 = 0;
		gint _camera_collection_size_ = 0;
		gint camera_it = 0;
#line 309 "../src/camera/CameraTable.vala"
		camera_collection = _tmp65_;
#line 309 "../src/camera/CameraTable.vala"
		camera_collection_length1 = _tmp65__length1;
#line 309 "../src/camera/CameraTable.vala"
		for (camera_it = 0; camera_it < camera_collection_length1; camera_it = camera_it + 1) {
#line 2639 "CameraTable.c"
			DiscoveredCamera* _tmp66_;
			DiscoveredCamera* camera = NULL;
#line 309 "../src/camera/CameraTable.vala"
			_tmp66_ = _discovered_camera_ref0 (camera_collection[camera_it]);
#line 309 "../src/camera/CameraTable.vala"
			camera = _tmp66_;
#line 2646 "CameraTable.c"
			{
				GPPortInfo port_info = {0};
				gchar* tmp_path = NULL;
				DiscoveredCamera* _tmp67_;
				Camera* _tmp68_;
				GPPortInfo _tmp69_ = {0};
				int _tmp70_;
				const gchar* _tmp71_ = NULL;
				gchar* _tmp72_;
				CameraAbilities abilities = {0};
				DiscoveredCamera* _tmp73_;
				Camera* _tmp74_;
				CameraAbilities _tmp75_ = {0};
				int _tmp76_;
				const gchar* _tmp77_;
				const gchar* _tmp78_;
				GeeHashMap* _tmp79_;
				const gchar* _tmp80_;
				gchar* _tmp81_;
				gchar* _tmp82_;
				DiscoveredCamera* _tmp83_;
#line 313 "../src/camera/CameraTable.vala"
				_tmp67_ = camera;
#line 313 "../src/camera/CameraTable.vala"
				_tmp68_ = _tmp67_->gcamera;
#line 313 "../src/camera/CameraTable.vala"
				_tmp70_ = gp_camera_get_port_info (_tmp68_, &_tmp69_);
#line 313 "../src/camera/CameraTable.vala"
				 (port_info);
#line 313 "../src/camera/CameraTable.vala"
				port_info = _tmp69_;
#line 313 "../src/camera/CameraTable.vala"
				camera_table_do_op (self, _tmp70_, "retrieve missing camera port information", &_inner_error0_);
#line 313 "../src/camera/CameraTable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "../src/camera/CameraTable.vala"
					if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 313 "../src/camera/CameraTable.vala"
						g_propagate_error (error, _inner_error0_);
#line 313 "../src/camera/CameraTable.vala"
						_g_free0 (tmp_path);
#line 313 "../src/camera/CameraTable.vala"
						 (port_info);
#line 313 "../src/camera/CameraTable.vala"
						_discovered_camera_unref0 (camera);
#line 313 "../src/camera/CameraTable.vala"
						missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 313 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 313 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 313 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 313 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 313 "../src/camera/CameraTable.vala"
						return;
#line 2704 "CameraTable.c"
					} else {
#line 313 "../src/camera/CameraTable.vala"
						_g_free0 (tmp_path);
#line 313 "../src/camera/CameraTable.vala"
						 (port_info);
#line 313 "../src/camera/CameraTable.vala"
						_discovered_camera_unref0 (camera);
#line 313 "../src/camera/CameraTable.vala"
						missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 313 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 313 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 313 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 313 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 313 "../src/camera/CameraTable.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 313 "../src/camera/CameraTable.vala"
						g_clear_error (&_inner_error0_);
#line 313 "../src/camera/CameraTable.vala"
						return;
#line 2728 "CameraTable.c"
					}
				}
#line 315 "../src/camera/CameraTable.vala"
				gp_port_info_get_path (port_info, &_tmp71_);
#line 315 "../src/camera/CameraTable.vala"
				_g_free0 (tmp_path);
#line 315 "../src/camera/CameraTable.vala"
				_tmp72_ = g_strdup (_tmp71_);
#line 315 "../src/camera/CameraTable.vala"
				tmp_path = _tmp72_;
#line 318 "../src/camera/CameraTable.vala"
				_tmp73_ = camera;
#line 318 "../src/camera/CameraTable.vala"
				_tmp74_ = _tmp73_->gcamera;
#line 318 "../src/camera/CameraTable.vala"
				_tmp76_ = gp_camera_get_abilities (_tmp74_, &_tmp75_);
#line 318 "../src/camera/CameraTable.vala"
				 (abilities);
#line 318 "../src/camera/CameraTable.vala"
				abilities = _tmp75_;
#line 318 "../src/camera/CameraTable.vala"
				camera_table_do_op (self, _tmp76_, "retrieve missing camera abilities", &_inner_error0_);
#line 318 "../src/camera/CameraTable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "../src/camera/CameraTable.vala"
					if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 318 "../src/camera/CameraTable.vala"
						g_propagate_error (error, _inner_error0_);
#line 318 "../src/camera/CameraTable.vala"
						 (abilities);
#line 318 "../src/camera/CameraTable.vala"
						_g_free0 (tmp_path);
#line 318 "../src/camera/CameraTable.vala"
						 (port_info);
#line 318 "../src/camera/CameraTable.vala"
						_discovered_camera_unref0 (camera);
#line 318 "../src/camera/CameraTable.vala"
						missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 318 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 318 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 318 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 318 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 318 "../src/camera/CameraTable.vala"
						return;
#line 2777 "CameraTable.c"
					} else {
#line 318 "../src/camera/CameraTable.vala"
						 (abilities);
#line 318 "../src/camera/CameraTable.vala"
						_g_free0 (tmp_path);
#line 318 "../src/camera/CameraTable.vala"
						 (port_info);
#line 318 "../src/camera/CameraTable.vala"
						_discovered_camera_unref0 (camera);
#line 318 "../src/camera/CameraTable.vala"
						missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 318 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 318 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 318 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 318 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 318 "../src/camera/CameraTable.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 318 "../src/camera/CameraTable.vala"
						g_clear_error (&_inner_error0_);
#line 318 "../src/camera/CameraTable.vala"
						return;
#line 2803 "CameraTable.c"
					}
				}
#line 320 "../src/camera/CameraTable.vala"
				_tmp77_ = abilities.model;
#line 320 "../src/camera/CameraTable.vala"
				_tmp78_ = tmp_path;
#line 320 "../src/camera/CameraTable.vala"
				g_debug ("CameraTable.vala:320: Removing from camera table: %s @ %s", _tmp77_, _tmp78_);
#line 322 "../src/camera/CameraTable.vala"
				_tmp79_ = self->priv->camera_map;
#line 322 "../src/camera/CameraTable.vala"
				_tmp80_ = tmp_path;
#line 322 "../src/camera/CameraTable.vala"
				_tmp81_ = camera_table_get_port_uri (_tmp80_);
#line 322 "../src/camera/CameraTable.vala"
				_tmp82_ = _tmp81_;
#line 322 "../src/camera/CameraTable.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp79_, _tmp82_, NULL);
#line 322 "../src/camera/CameraTable.vala"
				_g_free0 (_tmp82_);
#line 324 "../src/camera/CameraTable.vala"
				_tmp83_ = camera;
#line 324 "../src/camera/CameraTable.vala"
				g_signal_emit (self, camera_table_signals[CAMERA_TABLE_CAMERA_REMOVED_SIGNAL], 0, _tmp83_);
#line 309 "../src/camera/CameraTable.vala"
				 (abilities);
#line 309 "../src/camera/CameraTable.vala"
				_g_free0 (tmp_path);
#line 309 "../src/camera/CameraTable.vala"
				 (port_info);
#line 309 "../src/camera/CameraTable.vala"
				_discovered_camera_unref0 (camera);
#line 2836 "CameraTable.c"
			}
		}
	}
	{
		GeeIterator* _port_it = NULL;
		GeeHashMap* _tmp84_;
		GeeSet* _tmp85_;
		GeeSet* _tmp86_;
		GeeSet* _tmp87_;
		GeeIterator* _tmp88_;
		GeeIterator* _tmp89_;
#line 328 "../src/camera/CameraTable.vala"
		_tmp84_ = detected_map;
#line 328 "../src/camera/CameraTable.vala"
		_tmp85_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp84_);
#line 328 "../src/camera/CameraTable.vala"
		_tmp86_ = _tmp85_;
#line 328 "../src/camera/CameraTable.vala"
		_tmp87_ = _tmp86_;
#line 328 "../src/camera/CameraTable.vala"
		_tmp88_ = gee_iterable_iterator ((GeeIterable*) _tmp87_);
#line 328 "../src/camera/CameraTable.vala"
		_tmp89_ = _tmp88_;
#line 328 "../src/camera/CameraTable.vala"
		_g_object_unref0 (_tmp87_);
#line 328 "../src/camera/CameraTable.vala"
		_port_it = _tmp89_;
#line 328 "../src/camera/CameraTable.vala"
		while (TRUE) {
#line 2866 "CameraTable.c"
			GeeIterator* _tmp90_;
			gchar* port = NULL;
			GeeIterator* _tmp91_;
			gpointer _tmp92_;
			gchar* name = NULL;
			GeeHashMap* _tmp93_;
			const gchar* _tmp94_;
			gpointer _tmp95_;
			gchar* display_name = NULL;
			GIcon* icon = NULL;
			gchar* uri = NULL;
			const gchar* _tmp96_;
			gchar* _tmp97_;
			GeeHashMap* _tmp98_;
			const gchar* _tmp99_;
			gchar* path = NULL;
			const gchar* _tmp102_;
			gchar* _tmp103_;
			const gchar* _tmp104_;
			const gchar* _tmp124_;
			gint index = 0;
			GPPortInfoList* _tmp127_;
			const gchar* _tmp128_;
			GPPortInfo port_info = {0};
			gchar* tmp_path = NULL;
			GPPortInfoList* _tmp132_;
			GPPortInfo _tmp133_ = {0};
			int _tmp134_;
			const gchar* _tmp135_;
			gchar* _tmp136_;
			gchar* _tmp137_;
			const gchar* _tmp138_ = NULL;
			gchar* _tmp139_;
			const gchar* _tmp140_;
			const gchar* _tmp141_;
			CameraAbilitiesList* _tmp142_;
			const gchar* _tmp143_;
			CameraAbilities camera_abilities = {0};
			CameraAbilitiesList* _tmp147_;
			CameraAbilities _tmp148_ = {0};
			int _tmp149_;
			const gchar* _tmp150_;
			gchar* _tmp151_;
			gchar* _tmp152_;
			Camera* gcamera = NULL;
			Camera* _tmp153_ = NULL;
			int _tmp154_;
			const gchar* _tmp155_;
			gchar* _tmp156_;
			gchar* _tmp157_;
			Camera* _tmp158_;
			const gchar* _tmp159_;
			gchar* _tmp160_;
			gchar* _tmp161_;
			Camera* _tmp162_;
			const gchar* _tmp163_;
			const gchar* _tmp164_;
			gchar* _tmp165_;
			gchar* _tmp166_;
			const gchar* _tmp167_;
			const gchar* _tmp168_;
			DiscoveredCamera* camera = NULL;
			Camera* _tmp169_;
			const gchar* _tmp170_;
			const gchar* _tmp171_;
			GIcon* _tmp172_;
			DiscoveredCamera* _tmp173_;
			GeeHashMap* _tmp174_;
			const gchar* _tmp175_;
			DiscoveredCamera* _tmp176_;
			DiscoveredCamera* _tmp177_;
#line 328 "../src/camera/CameraTable.vala"
			_tmp90_ = _port_it;
#line 328 "../src/camera/CameraTable.vala"
			if (!gee_iterator_next (_tmp90_)) {
#line 328 "../src/camera/CameraTable.vala"
				break;
#line 2944 "CameraTable.c"
			}
#line 328 "../src/camera/CameraTable.vala"
			_tmp91_ = _port_it;
#line 328 "../src/camera/CameraTable.vala"
			_tmp92_ = gee_iterator_get (_tmp91_);
#line 328 "../src/camera/CameraTable.vala"
			port = (gchar*) _tmp92_;
#line 329 "../src/camera/CameraTable.vala"
			_tmp93_ = detected_map;
#line 329 "../src/camera/CameraTable.vala"
			_tmp94_ = port;
#line 329 "../src/camera/CameraTable.vala"
			_tmp95_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp93_, _tmp94_);
#line 329 "../src/camera/CameraTable.vala"
			name = (gchar*) _tmp95_;
#line 330 "../src/camera/CameraTable.vala"
			display_name = NULL;
#line 331 "../src/camera/CameraTable.vala"
			icon = NULL;
#line 332 "../src/camera/CameraTable.vala"
			_tmp96_ = port;
#line 332 "../src/camera/CameraTable.vala"
			_tmp97_ = camera_table_get_port_uri (_tmp96_);
#line 332 "../src/camera/CameraTable.vala"
			uri = _tmp97_;
#line 334 "../src/camera/CameraTable.vala"
			_tmp98_ = self->priv->camera_map;
#line 334 "../src/camera/CameraTable.vala"
			_tmp99_ = uri;
#line 334 "../src/camera/CameraTable.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp98_, _tmp99_)) {
#line 2976 "CameraTable.c"
				const gchar* _tmp100_;
				const gchar* _tmp101_;
#line 336 "../src/camera/CameraTable.vala"
				_tmp100_ = name;
#line 336 "../src/camera/CameraTable.vala"
				_tmp101_ = port;
#line 336 "../src/camera/CameraTable.vala"
				g_debug ("CameraTable.vala:336: %s @ %s already registered, skipping", _tmp100_, _tmp101_);
#line 338 "../src/camera/CameraTable.vala"
				_g_free0 (uri);
#line 338 "../src/camera/CameraTable.vala"
				_g_object_unref0 (icon);
#line 338 "../src/camera/CameraTable.vala"
				_g_free0 (display_name);
#line 338 "../src/camera/CameraTable.vala"
				_g_free0 (name);
#line 338 "../src/camera/CameraTable.vala"
				_g_free0 (port);
#line 338 "../src/camera/CameraTable.vala"
				continue;
#line 2997 "CameraTable.c"
			}
#line 342 "../src/camera/CameraTable.vala"
			_tmp102_ = port;
#line 342 "../src/camera/CameraTable.vala"
			_tmp103_ = camera_table_get_port_path (_tmp102_);
#line 342 "../src/camera/CameraTable.vala"
			path = _tmp103_;
#line 343 "../src/camera/CameraTable.vala"
			_tmp104_ = path;
#line 343 "../src/camera/CameraTable.vala"
			if (NULL != _tmp104_) {
#line 3009 "CameraTable.c"
				GUdevDevice* device = NULL;
				GUdevClient* _tmp105_;
				const gchar* _tmp106_;
				GUdevDevice* _tmp107_;
				gchar* serial = NULL;
				GUdevDevice* _tmp108_;
				const gchar* _tmp109_;
				gchar* _tmp110_;
				const gchar* _tmp111_;
				const gchar* _tmp116_;
				const gchar* _tmp120_;
#line 344 "../src/camera/CameraTable.vala"
				_tmp105_ = self->priv->client;
#line 344 "../src/camera/CameraTable.vala"
				_tmp106_ = path;
#line 344 "../src/camera/CameraTable.vala"
				_tmp107_ = g_udev_client_query_by_device_file (_tmp105_, _tmp106_);
#line 344 "../src/camera/CameraTable.vala"
				device = _tmp107_;
#line 345 "../src/camera/CameraTable.vala"
				_tmp108_ = device;
#line 345 "../src/camera/CameraTable.vala"
				_tmp109_ = g_udev_device_get_property (_tmp108_, "ID_SERIAL_SHORT");
#line 345 "../src/camera/CameraTable.vala"
				_tmp110_ = g_strdup (_tmp109_);
#line 345 "../src/camera/CameraTable.vala"
				serial = _tmp110_;
#line 346 "../src/camera/CameraTable.vala"
				_tmp111_ = serial;
#line 346 "../src/camera/CameraTable.vala"
				if (NULL != _tmp111_) {
#line 3041 "CameraTable.c"
					const gchar* _tmp112_;
					gchar* _tmp113_;
					const gchar* _tmp114_;
					GIcon* _tmp115_;
#line 348 "../src/camera/CameraTable.vala"
					_tmp112_ = serial;
#line 348 "../src/camera/CameraTable.vala"
					_tmp113_ = camera_table_get_name_for_uuid (self, _tmp112_);
#line 348 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 348 "../src/camera/CameraTable.vala"
					display_name = _tmp113_;
#line 349 "../src/camera/CameraTable.vala"
					_tmp114_ = serial;
#line 349 "../src/camera/CameraTable.vala"
					_tmp115_ = camera_table_get_icon_for_uuid (self, _tmp114_);
#line 349 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 349 "../src/camera/CameraTable.vala"
					icon = _tmp115_;
#line 3062 "CameraTable.c"
				}
#line 351 "../src/camera/CameraTable.vala"
				_tmp116_ = display_name;
#line 351 "../src/camera/CameraTable.vala"
				if (NULL == _tmp116_) {
#line 3068 "CameraTable.c"
					GUdevDevice* _tmp117_;
					const gchar* _tmp118_;
					gchar* _tmp119_;
#line 352 "../src/camera/CameraTable.vala"
					_tmp117_ = device;
#line 352 "../src/camera/CameraTable.vala"
					_tmp118_ = g_udev_device_get_sysfs_attr (_tmp117_, "product");
#line 352 "../src/camera/CameraTable.vala"
					_tmp119_ = g_strdup (_tmp118_);
#line 352 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 352 "../src/camera/CameraTable.vala"
					display_name = _tmp119_;
#line 3082 "CameraTable.c"
				}
#line 354 "../src/camera/CameraTable.vala"
				_tmp120_ = display_name;
#line 354 "../src/camera/CameraTable.vala"
				if (NULL == _tmp120_) {
#line 3088 "CameraTable.c"
					GUdevDevice* _tmp121_;
					const gchar* _tmp122_;
					gchar* _tmp123_;
#line 355 "../src/camera/CameraTable.vala"
					_tmp121_ = device;
#line 355 "../src/camera/CameraTable.vala"
					_tmp122_ = g_udev_device_get_property (_tmp121_, "ID_MODEL");
#line 355 "../src/camera/CameraTable.vala"
					_tmp123_ = g_strdup (_tmp122_);
#line 355 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 355 "../src/camera/CameraTable.vala"
					display_name = _tmp123_;
#line 3102 "CameraTable.c"
				}
#line 343 "../src/camera/CameraTable.vala"
				_g_free0 (serial);
#line 343 "../src/camera/CameraTable.vala"
				_g_object_unref0 (device);
#line 3108 "CameraTable.c"
			}
#line 358 "../src/camera/CameraTable.vala"
			_tmp124_ = display_name;
#line 358 "../src/camera/CameraTable.vala"
			if (NULL == _tmp124_) {
#line 3114 "CameraTable.c"
				const gchar* _tmp125_;
				gchar* _tmp126_;
#line 360 "../src/camera/CameraTable.vala"
				_tmp125_ = name;
#line 360 "../src/camera/CameraTable.vala"
				_tmp126_ = g_strdup (_tmp125_);
#line 360 "../src/camera/CameraTable.vala"
				_g_free0 (display_name);
#line 360 "../src/camera/CameraTable.vala"
				display_name = _tmp126_;
#line 3125 "CameraTable.c"
			}
#line 363 "../src/camera/CameraTable.vala"
			_tmp127_ = port_info_list;
#line 363 "../src/camera/CameraTable.vala"
			_tmp128_ = port;
#line 363 "../src/camera/CameraTable.vala"
			index = gp_port_info_list_lookup_path (_tmp127_, _tmp128_);
#line 364 "../src/camera/CameraTable.vala"
			if (index < 0) {
#line 3135 "CameraTable.c"
				const gchar* _tmp129_;
				gchar* _tmp130_;
				gchar* _tmp131_;
#line 365 "../src/camera/CameraTable.vala"
				_tmp129_ = port;
#line 365 "../src/camera/CameraTable.vala"
				_tmp130_ = g_strdup_printf ("lookup port %s", _tmp129_);
#line 365 "../src/camera/CameraTable.vala"
				_tmp131_ = _tmp130_;
#line 365 "../src/camera/CameraTable.vala"
				camera_table_do_op (self, (int) index, _tmp131_, &_inner_error0_);
#line 365 "../src/camera/CameraTable.vala"
				_g_free0 (_tmp131_);
#line 365 "../src/camera/CameraTable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 365 "../src/camera/CameraTable.vala"
					if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 365 "../src/camera/CameraTable.vala"
						g_propagate_error (error, _inner_error0_);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (path);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (uri);
#line 365 "../src/camera/CameraTable.vala"
						_g_object_unref0 (icon);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (display_name);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (port);
#line 365 "../src/camera/CameraTable.vala"
						_g_object_unref0 (_port_it);
#line 365 "../src/camera/CameraTable.vala"
						missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 365 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 365 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 365 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 365 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 365 "../src/camera/CameraTable.vala"
						return;
#line 3181 "CameraTable.c"
					} else {
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (path);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (uri);
#line 365 "../src/camera/CameraTable.vala"
						_g_object_unref0 (icon);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (display_name);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 365 "../src/camera/CameraTable.vala"
						_g_free0 (port);
#line 365 "../src/camera/CameraTable.vala"
						_g_object_unref0 (_port_it);
#line 365 "../src/camera/CameraTable.vala"
						missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 365 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 365 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 365 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 365 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 365 "../src/camera/CameraTable.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 365 "../src/camera/CameraTable.vala"
						g_clear_error (&_inner_error0_);
#line 365 "../src/camera/CameraTable.vala"
						return;
#line 3213 "CameraTable.c"
					}
				}
			}
#line 370 "../src/camera/CameraTable.vala"
			_tmp132_ = port_info_list;
#line 370 "../src/camera/CameraTable.vala"
			_tmp134_ = gp_port_info_list_get_info (_tmp132_, index, &_tmp133_);
#line 370 "../src/camera/CameraTable.vala"
			 (port_info);
#line 370 "../src/camera/CameraTable.vala"
			port_info = _tmp133_;
#line 370 "../src/camera/CameraTable.vala"
			_tmp135_ = port;
#line 370 "../src/camera/CameraTable.vala"
			_tmp136_ = g_strdup_printf ("get port info for %s", _tmp135_);
#line 370 "../src/camera/CameraTable.vala"
			_tmp137_ = _tmp136_;
#line 370 "../src/camera/CameraTable.vala"
			camera_table_do_op (self, _tmp134_, _tmp137_, &_inner_error0_);
#line 370 "../src/camera/CameraTable.vala"
			_g_free0 (_tmp137_);
#line 370 "../src/camera/CameraTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 370 "../src/camera/CameraTable.vala"
				if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 370 "../src/camera/CameraTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 370 "../src/camera/CameraTable.vala"
					 (port_info);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 370 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 370 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 370 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 370 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 370 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 370 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 370 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 370 "../src/camera/CameraTable.vala"
					return;
#line 3271 "CameraTable.c"
				} else {
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 370 "../src/camera/CameraTable.vala"
					 (port_info);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 370 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 370 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 370 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 370 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 370 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 370 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 370 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 370 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 370 "../src/camera/CameraTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 370 "../src/camera/CameraTable.vala"
					g_clear_error (&_inner_error0_);
#line 370 "../src/camera/CameraTable.vala"
					return;
#line 3307 "CameraTable.c"
				}
			}
#line 371 "../src/camera/CameraTable.vala"
			gp_port_info_get_path (port_info, &_tmp138_);
#line 371 "../src/camera/CameraTable.vala"
			_g_free0 (tmp_path);
#line 371 "../src/camera/CameraTable.vala"
			_tmp139_ = g_strdup (_tmp138_);
#line 371 "../src/camera/CameraTable.vala"
			tmp_path = _tmp139_;
#line 374 "../src/camera/CameraTable.vala"
			_tmp140_ = port;
#line 374 "../src/camera/CameraTable.vala"
			_tmp141_ = tmp_path;
#line 374 "../src/camera/CameraTable.vala"
			_vala_assert (g_strcmp0 (_tmp140_, _tmp141_) == 0, "port == tmp_path");
#line 376 "../src/camera/CameraTable.vala"
			_tmp142_ = self->priv->abilities_list;
#line 376 "../src/camera/CameraTable.vala"
			_tmp143_ = name;
#line 376 "../src/camera/CameraTable.vala"
			index = gp_abilities_list_lookup_model (_tmp142_, _tmp143_);
#line 377 "../src/camera/CameraTable.vala"
			if (index < 0) {
#line 3332 "CameraTable.c"
				const gchar* _tmp144_;
				gchar* _tmp145_;
				gchar* _tmp146_;
#line 378 "../src/camera/CameraTable.vala"
				_tmp144_ = name;
#line 378 "../src/camera/CameraTable.vala"
				_tmp145_ = g_strdup_printf ("lookup camera model %s", _tmp144_);
#line 378 "../src/camera/CameraTable.vala"
				_tmp146_ = _tmp145_;
#line 378 "../src/camera/CameraTable.vala"
				camera_table_do_op (self, (int) index, _tmp146_, &_inner_error0_);
#line 378 "../src/camera/CameraTable.vala"
				_g_free0 (_tmp146_);
#line 378 "../src/camera/CameraTable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 378 "../src/camera/CameraTable.vala"
					if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 378 "../src/camera/CameraTable.vala"
						g_propagate_error (error, _inner_error0_);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (tmp_path);
#line 378 "../src/camera/CameraTable.vala"
						 (port_info);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (path);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (uri);
#line 378 "../src/camera/CameraTable.vala"
						_g_object_unref0 (icon);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (display_name);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (port);
#line 378 "../src/camera/CameraTable.vala"
						_g_object_unref0 (_port_it);
#line 378 "../src/camera/CameraTable.vala"
						missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 378 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 378 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 378 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 378 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 378 "../src/camera/CameraTable.vala"
						return;
#line 3382 "CameraTable.c"
					} else {
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (tmp_path);
#line 378 "../src/camera/CameraTable.vala"
						 (port_info);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (path);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (uri);
#line 378 "../src/camera/CameraTable.vala"
						_g_object_unref0 (icon);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (display_name);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (name);
#line 378 "../src/camera/CameraTable.vala"
						_g_free0 (port);
#line 378 "../src/camera/CameraTable.vala"
						_g_object_unref0 (_port_it);
#line 378 "../src/camera/CameraTable.vala"
						missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 378 "../src/camera/CameraTable.vala"
						usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 378 "../src/camera/CameraTable.vala"
						_g_object_unref0 (detected_map);
#line 378 "../src/camera/CameraTable.vala"
						_gp_list_unref0 (camera_list);
#line 378 "../src/camera/CameraTable.vala"
						_gp_port_info_list_free0 (port_info_list);
#line 378 "../src/camera/CameraTable.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 378 "../src/camera/CameraTable.vala"
						g_clear_error (&_inner_error0_);
#line 378 "../src/camera/CameraTable.vala"
						return;
#line 3418 "CameraTable.c"
					}
				}
			}
#line 381 "../src/camera/CameraTable.vala"
			_tmp147_ = self->priv->abilities_list;
#line 381 "../src/camera/CameraTable.vala"
			_tmp149_ = gp_abilities_list_get_abilities (_tmp147_, index, &_tmp148_);
#line 381 "../src/camera/CameraTable.vala"
			 (camera_abilities);
#line 381 "../src/camera/CameraTable.vala"
			camera_abilities = _tmp148_;
#line 381 "../src/camera/CameraTable.vala"
			_tmp150_ = name;
#line 381 "../src/camera/CameraTable.vala"
			_tmp151_ = g_strdup_printf ("lookup camera abilities for %s", _tmp150_);
#line 381 "../src/camera/CameraTable.vala"
			_tmp152_ = _tmp151_;
#line 381 "../src/camera/CameraTable.vala"
			camera_table_do_op (self, _tmp149_, _tmp152_, &_inner_error0_);
#line 381 "../src/camera/CameraTable.vala"
			_g_free0 (_tmp152_);
#line 381 "../src/camera/CameraTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 381 "../src/camera/CameraTable.vala"
				if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 381 "../src/camera/CameraTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 381 "../src/camera/CameraTable.vala"
					 (camera_abilities);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 381 "../src/camera/CameraTable.vala"
					 (port_info);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 381 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 381 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 381 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 381 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 381 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 381 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 381 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 381 "../src/camera/CameraTable.vala"
					return;
#line 3478 "CameraTable.c"
				} else {
#line 381 "../src/camera/CameraTable.vala"
					 (camera_abilities);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 381 "../src/camera/CameraTable.vala"
					 (port_info);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 381 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 381 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 381 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 381 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 381 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 381 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 381 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 381 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 381 "../src/camera/CameraTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 381 "../src/camera/CameraTable.vala"
					g_clear_error (&_inner_error0_);
#line 381 "../src/camera/CameraTable.vala"
					return;
#line 3516 "CameraTable.c"
				}
			}
#line 385 "../src/camera/CameraTable.vala"
			_tmp154_ = gp_camera_new (&_tmp153_);
#line 385 "../src/camera/CameraTable.vala"
			_gp_camera_unref0 (gcamera);
#line 385 "../src/camera/CameraTable.vala"
			gcamera = _tmp153_;
#line 385 "../src/camera/CameraTable.vala"
			_tmp155_ = name;
#line 385 "../src/camera/CameraTable.vala"
			_tmp156_ = g_strdup_printf ("create camera object for %s", _tmp155_);
#line 385 "../src/camera/CameraTable.vala"
			_tmp157_ = _tmp156_;
#line 385 "../src/camera/CameraTable.vala"
			camera_table_do_op (self, _tmp154_, _tmp157_, &_inner_error0_);
#line 385 "../src/camera/CameraTable.vala"
			_g_free0 (_tmp157_);
#line 385 "../src/camera/CameraTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../src/camera/CameraTable.vala"
				if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 385 "../src/camera/CameraTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 385 "../src/camera/CameraTable.vala"
					_gp_camera_unref0 (gcamera);
#line 385 "../src/camera/CameraTable.vala"
					 (camera_abilities);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 385 "../src/camera/CameraTable.vala"
					 (port_info);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 385 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 385 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 385 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 385 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 385 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 385 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 385 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 385 "../src/camera/CameraTable.vala"
					return;
#line 3575 "CameraTable.c"
				} else {
#line 385 "../src/camera/CameraTable.vala"
					_gp_camera_unref0 (gcamera);
#line 385 "../src/camera/CameraTable.vala"
					 (camera_abilities);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 385 "../src/camera/CameraTable.vala"
					 (port_info);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 385 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 385 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 385 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 385 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 385 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 385 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 385 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 385 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 385 "../src/camera/CameraTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 385 "../src/camera/CameraTable.vala"
					g_clear_error (&_inner_error0_);
#line 385 "../src/camera/CameraTable.vala"
					return;
#line 3615 "CameraTable.c"
				}
			}
#line 386 "../src/camera/CameraTable.vala"
			_tmp158_ = gcamera;
#line 386 "../src/camera/CameraTable.vala"
			_tmp159_ = name;
#line 386 "../src/camera/CameraTable.vala"
			_tmp160_ = g_strdup_printf ("set camera abilities for %s", _tmp159_);
#line 386 "../src/camera/CameraTable.vala"
			_tmp161_ = _tmp160_;
#line 386 "../src/camera/CameraTable.vala"
			camera_table_do_op (self, gp_camera_set_abilities (_tmp158_, camera_abilities), _tmp161_, &_inner_error0_);
#line 386 "../src/camera/CameraTable.vala"
			_g_free0 (_tmp161_);
#line 386 "../src/camera/CameraTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 386 "../src/camera/CameraTable.vala"
				if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 386 "../src/camera/CameraTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 386 "../src/camera/CameraTable.vala"
					_gp_camera_unref0 (gcamera);
#line 386 "../src/camera/CameraTable.vala"
					 (camera_abilities);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 386 "../src/camera/CameraTable.vala"
					 (port_info);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 386 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 386 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 386 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 386 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 386 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 386 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 386 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 386 "../src/camera/CameraTable.vala"
					return;
#line 3670 "CameraTable.c"
				} else {
#line 386 "../src/camera/CameraTable.vala"
					_gp_camera_unref0 (gcamera);
#line 386 "../src/camera/CameraTable.vala"
					 (camera_abilities);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 386 "../src/camera/CameraTable.vala"
					 (port_info);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 386 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 386 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 386 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 386 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 386 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 386 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 386 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 386 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 386 "../src/camera/CameraTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 386 "../src/camera/CameraTable.vala"
					g_clear_error (&_inner_error0_);
#line 386 "../src/camera/CameraTable.vala"
					return;
#line 3710 "CameraTable.c"
				}
			}
#line 387 "../src/camera/CameraTable.vala"
			_tmp162_ = gcamera;
#line 387 "../src/camera/CameraTable.vala"
			_tmp163_ = name;
#line 387 "../src/camera/CameraTable.vala"
			_tmp164_ = port;
#line 387 "../src/camera/CameraTable.vala"
			_tmp165_ = g_strdup_printf ("set port info for %s on %s", _tmp163_, _tmp164_);
#line 387 "../src/camera/CameraTable.vala"
			_tmp166_ = _tmp165_;
#line 387 "../src/camera/CameraTable.vala"
			camera_table_do_op (self, gp_camera_set_port_info (_tmp162_, port_info), _tmp166_, &_inner_error0_);
#line 387 "../src/camera/CameraTable.vala"
			_g_free0 (_tmp166_);
#line 387 "../src/camera/CameraTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 387 "../src/camera/CameraTable.vala"
				if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 387 "../src/camera/CameraTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 387 "../src/camera/CameraTable.vala"
					_gp_camera_unref0 (gcamera);
#line 387 "../src/camera/CameraTable.vala"
					 (camera_abilities);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 387 "../src/camera/CameraTable.vala"
					 (port_info);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 387 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 387 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 387 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 387 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 387 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 387 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 387 "../src/camera/CameraTable.vala"
					return;
#line 3767 "CameraTable.c"
				} else {
#line 387 "../src/camera/CameraTable.vala"
					_gp_camera_unref0 (gcamera);
#line 387 "../src/camera/CameraTable.vala"
					 (camera_abilities);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (tmp_path);
#line 387 "../src/camera/CameraTable.vala"
					 (port_info);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (path);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (uri);
#line 387 "../src/camera/CameraTable.vala"
					_g_object_unref0 (icon);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (display_name);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (name);
#line 387 "../src/camera/CameraTable.vala"
					_g_free0 (port);
#line 387 "../src/camera/CameraTable.vala"
					_g_object_unref0 (_port_it);
#line 387 "../src/camera/CameraTable.vala"
					missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 387 "../src/camera/CameraTable.vala"
					usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/camera/CameraTable.vala"
					_g_object_unref0 (detected_map);
#line 387 "../src/camera/CameraTable.vala"
					_gp_list_unref0 (camera_list);
#line 387 "../src/camera/CameraTable.vala"
					_gp_port_info_list_free0 (port_info_list);
#line 387 "../src/camera/CameraTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 387 "../src/camera/CameraTable.vala"
					g_clear_error (&_inner_error0_);
#line 387 "../src/camera/CameraTable.vala"
					return;
#line 3807 "CameraTable.c"
				}
			}
#line 389 "../src/camera/CameraTable.vala"
			_tmp167_ = name;
#line 389 "../src/camera/CameraTable.vala"
			_tmp168_ = port;
#line 389 "../src/camera/CameraTable.vala"
			g_debug ("CameraTable.vala:389: Adding to camera table: %s @ %s", _tmp167_, _tmp168_);
#line 391 "../src/camera/CameraTable.vala"
			_tmp169_ = gcamera;
#line 391 "../src/camera/CameraTable.vala"
			_tmp170_ = uri;
#line 391 "../src/camera/CameraTable.vala"
			_tmp171_ = display_name;
#line 391 "../src/camera/CameraTable.vala"
			_tmp172_ = icon;
#line 391 "../src/camera/CameraTable.vala"
			_tmp173_ = discovered_camera_new (_tmp169_, _tmp170_, _tmp171_, _tmp172_);
#line 391 "../src/camera/CameraTable.vala"
			camera = _tmp173_;
#line 392 "../src/camera/CameraTable.vala"
			_tmp174_ = self->priv->camera_map;
#line 392 "../src/camera/CameraTable.vala"
			_tmp175_ = uri;
#line 392 "../src/camera/CameraTable.vala"
			_tmp176_ = camera;
#line 392 "../src/camera/CameraTable.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp174_, _tmp175_, _tmp176_);
#line 394 "../src/camera/CameraTable.vala"
			_tmp177_ = camera;
#line 394 "../src/camera/CameraTable.vala"
			g_signal_emit (self, camera_table_signals[CAMERA_TABLE_CAMERA_ADDED_SIGNAL], 0, _tmp177_);
#line 328 "../src/camera/CameraTable.vala"
			_discovered_camera_unref0 (camera);
#line 328 "../src/camera/CameraTable.vala"
			_gp_camera_unref0 (gcamera);
#line 328 "../src/camera/CameraTable.vala"
			 (camera_abilities);
#line 328 "../src/camera/CameraTable.vala"
			_g_free0 (tmp_path);
#line 328 "../src/camera/CameraTable.vala"
			 (port_info);
#line 328 "../src/camera/CameraTable.vala"
			_g_free0 (path);
#line 328 "../src/camera/CameraTable.vala"
			_g_free0 (uri);
#line 328 "../src/camera/CameraTable.vala"
			_g_object_unref0 (icon);
#line 328 "../src/camera/CameraTable.vala"
			_g_free0 (display_name);
#line 328 "../src/camera/CameraTable.vala"
			_g_free0 (name);
#line 328 "../src/camera/CameraTable.vala"
			_g_free0 (port);
#line 3862 "CameraTable.c"
		}
#line 328 "../src/camera/CameraTable.vala"
		_g_object_unref0 (_port_it);
#line 3866 "CameraTable.c"
	}
#line 246 "../src/camera/CameraTable.vala"
	missing = (_vala_array_free (missing, missing_length1, (GDestroyNotify) discovered_camera_unref), NULL);
#line 246 "../src/camera/CameraTable.vala"
	usb_cameras = (_vala_array_free (usb_cameras, usb_cameras_length1, (GDestroyNotify) g_free), NULL);
#line 246 "../src/camera/CameraTable.vala"
	_g_object_unref0 (detected_map);
#line 246 "../src/camera/CameraTable.vala"
	_gp_list_unref0 (camera_list);
#line 246 "../src/camera/CameraTable.vala"
	_gp_port_info_list_free0 (port_info_list);
#line 3878 "CameraTable.c"
}

static void
camera_table_on_udev_event (CameraTable* self,
                            const gchar* action,
                            GUdevDevice* device)
{
	const gchar* _tmp0_;
	OneShotScheduler* _tmp1_;
#line 398 "../src/camera/CameraTable.vala"
	g_return_if_fail (self != NULL);
#line 398 "../src/camera/CameraTable.vala"
	g_return_if_fail (action != NULL);
#line 398 "../src/camera/CameraTable.vala"
	g_return_if_fail (device != NULL);
#line 399 "../src/camera/CameraTable.vala"
	_tmp0_ = g_udev_device_get_name (device);
#line 399 "../src/camera/CameraTable.vala"
	g_debug ("CameraTable.vala:399: udev event: %s on %s", action, _tmp0_);
#line 403 "../src/camera/CameraTable.vala"
	_tmp1_ = self->priv->camera_update_scheduler;
#line 403 "../src/camera/CameraTable.vala"
	one_shot_scheduler_after_timeout (_tmp1_, (guint) CAMERA_TABLE_UPDATE_DELAY_MSEC, TRUE);
#line 3902 "CameraTable.c"
}

void
camera_table_on_volume_changed (CameraTable* self,
                                GVolume* volume)
{
	OneShotScheduler* _tmp0_;
#line 406 "../src/camera/CameraTable.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/camera/CameraTable.vala"
	g_return_if_fail (volume != NULL);
#line 407 "../src/camera/CameraTable.vala"
	_tmp0_ = self->priv->camera_update_scheduler;
#line 407 "../src/camera/CameraTable.vala"
	one_shot_scheduler_after_timeout (_tmp0_, (guint) CAMERA_TABLE_UPDATE_DELAY_MSEC, TRUE);
#line 3918 "CameraTable.c"
}

static void
camera_table_on_update_cameras (CameraTable* self)
{
	GError* _inner_error0_ = NULL;
#line 410 "../src/camera/CameraTable.vala"
	g_return_if_fail (self != NULL);
#line 3927 "CameraTable.c"
	{
		CameraTable* _tmp0_;
		CameraTable* _tmp1_;
#line 412 "../src/camera/CameraTable.vala"
		_tmp0_ = camera_table_get_instance ();
#line 412 "../src/camera/CameraTable.vala"
		_tmp1_ = _tmp0_;
#line 412 "../src/camera/CameraTable.vala"
		camera_table_update_camera_table (_tmp1_, &_inner_error0_);
#line 412 "../src/camera/CameraTable.vala"
		_camera_table_unref0 (_tmp1_);
#line 412 "../src/camera/CameraTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 412 "../src/camera/CameraTable.vala"
			if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 3943 "CameraTable.c"
				goto __catch0_gphoto_error;
			}
#line 412 "../src/camera/CameraTable.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 412 "../src/camera/CameraTable.vala"
			g_clear_error (&_inner_error0_);
#line 412 "../src/camera/CameraTable.vala"
			return;
#line 3952 "CameraTable.c"
		}
	}
	goto __finally0;
	__catch0_gphoto_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 411 "../src/camera/CameraTable.vala"
		err = _inner_error0_;
#line 411 "../src/camera/CameraTable.vala"
		_inner_error0_ = NULL;
#line 414 "../src/camera/CameraTable.vala"
		_tmp2_ = err;
#line 414 "../src/camera/CameraTable.vala"
		_tmp3_ = _tmp2_->message;
#line 414 "../src/camera/CameraTable.vala"
		g_warning ("CameraTable.vala:414: Error updating camera table: %s", _tmp3_);
#line 411 "../src/camera/CameraTable.vala"
		_g_error_free0 (err);
#line 3973 "CameraTable.c"
	}
	__finally0:
#line 411 "../src/camera/CameraTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 411 "../src/camera/CameraTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../src/camera/CameraTable.vala"
		g_clear_error (&_inner_error0_);
#line 411 "../src/camera/CameraTable.vala"
		return;
#line 3984 "CameraTable.c"
	}
}

static void
g_cclosure_user_marshal_VOID__DISCOVERED_CAMERA (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DISCOVERED_CAMERA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__DISCOVERED_CAMERA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 34 "../src/camera/CameraTable.vala"
	g_return_if_fail (n_param_values == 2);
#line 34 "../src/camera/CameraTable.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 34 "../src/camera/CameraTable.vala"
		data1 = closure->data;
#line 34 "../src/camera/CameraTable.vala"
		data2 = param_values->data[0].v_pointer;
#line 4010 "CameraTable.c"
	} else {
#line 34 "../src/camera/CameraTable.vala"
		data1 = param_values->data[0].v_pointer;
#line 34 "../src/camera/CameraTable.vala"
		data2 = closure->data;
#line 4016 "CameraTable.c"
	}
#line 34 "../src/camera/CameraTable.vala"
	callback = (GMarshalFunc_VOID__DISCOVERED_CAMERA) (marshal_data ? marshal_data : cc->callback);
#line 34 "../src/camera/CameraTable.vala"
	callback (data1, value_get_discovered_camera (param_values + 1), data2);
#line 4022 "CameraTable.c"
}

static void
value_camera_table_init (GValue* value)
{
#line 34 "../src/camera/CameraTable.vala"
	value->data[0].v_pointer = NULL;
#line 4030 "CameraTable.c"
}

static void
value_camera_table_free_value (GValue* value)
{
#line 34 "../src/camera/CameraTable.vala"
	if (value->data[0].v_pointer) {
#line 34 "../src/camera/CameraTable.vala"
		camera_table_unref (value->data[0].v_pointer);
#line 4040 "CameraTable.c"
	}
}

static void
value_camera_table_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 34 "../src/camera/CameraTable.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "../src/camera/CameraTable.vala"
		dest_value->data[0].v_pointer = camera_table_ref (src_value->data[0].v_pointer);
#line 4052 "CameraTable.c"
	} else {
#line 34 "../src/camera/CameraTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4056 "CameraTable.c"
	}
}

static gpointer
value_camera_table_peek_pointer (const GValue* value)
{
#line 34 "../src/camera/CameraTable.vala"
	return value->data[0].v_pointer;
#line 4065 "CameraTable.c"
}

static gchar*
value_camera_table_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 34 "../src/camera/CameraTable.vala"
	if (collect_values[0].v_pointer) {
#line 4076 "CameraTable.c"
		CameraTable * object;
		object = collect_values[0].v_pointer;
#line 34 "../src/camera/CameraTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "../src/camera/CameraTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4083 "CameraTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "../src/camera/CameraTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4087 "CameraTable.c"
		}
#line 34 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = camera_table_ref (object);
#line 4091 "CameraTable.c"
	} else {
#line 34 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = NULL;
#line 4095 "CameraTable.c"
	}
#line 34 "../src/camera/CameraTable.vala"
	return NULL;
#line 4099 "CameraTable.c"
}

static gchar*
value_camera_table_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	CameraTable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "../src/camera/CameraTable.vala"
	if (!object_p) {
#line 34 "../src/camera/CameraTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4114 "CameraTable.c"
	}
#line 34 "../src/camera/CameraTable.vala"
	if (!value->data[0].v_pointer) {
#line 34 "../src/camera/CameraTable.vala"
		*object_p = NULL;
#line 4120 "CameraTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "../src/camera/CameraTable.vala"
		*object_p = value->data[0].v_pointer;
#line 4124 "CameraTable.c"
	} else {
#line 34 "../src/camera/CameraTable.vala"
		*object_p = camera_table_ref (value->data[0].v_pointer);
#line 4128 "CameraTable.c"
	}
#line 34 "../src/camera/CameraTable.vala"
	return NULL;
#line 4132 "CameraTable.c"
}

GParamSpec*
param_spec_camera_table (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecCameraTable* spec;
#line 34 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CAMERA_TABLE), NULL);
#line 34 "../src/camera/CameraTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "../src/camera/CameraTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "../src/camera/CameraTable.vala"
	return G_PARAM_SPEC (spec);
#line 4151 "CameraTable.c"
}

gpointer
value_get_camera_table (const GValue* value)
{
#line 34 "../src/camera/CameraTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CAMERA_TABLE), NULL);
#line 34 "../src/camera/CameraTable.vala"
	return value->data[0].v_pointer;
#line 4161 "CameraTable.c"
}

void
value_set_camera_table (GValue* value,
                        gpointer v_object)
{
	CameraTable * old;
#line 34 "../src/camera/CameraTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CAMERA_TABLE));
#line 34 "../src/camera/CameraTable.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/camera/CameraTable.vala"
	if (v_object) {
#line 34 "../src/camera/CameraTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CAMERA_TABLE));
#line 34 "../src/camera/CameraTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = v_object;
#line 34 "../src/camera/CameraTable.vala"
		camera_table_ref (value->data[0].v_pointer);
#line 4183 "CameraTable.c"
	} else {
#line 34 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = NULL;
#line 4187 "CameraTable.c"
	}
#line 34 "../src/camera/CameraTable.vala"
	if (old) {
#line 34 "../src/camera/CameraTable.vala"
		camera_table_unref (old);
#line 4193 "CameraTable.c"
	}
}

void
value_take_camera_table (GValue* value,
                         gpointer v_object)
{
	CameraTable * old;
#line 34 "../src/camera/CameraTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CAMERA_TABLE));
#line 34 "../src/camera/CameraTable.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/camera/CameraTable.vala"
	if (v_object) {
#line 34 "../src/camera/CameraTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CAMERA_TABLE));
#line 34 "../src/camera/CameraTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = v_object;
#line 4214 "CameraTable.c"
	} else {
#line 34 "../src/camera/CameraTable.vala"
		value->data[0].v_pointer = NULL;
#line 4218 "CameraTable.c"
	}
#line 34 "../src/camera/CameraTable.vala"
	if (old) {
#line 34 "../src/camera/CameraTable.vala"
		camera_table_unref (old);
#line 4224 "CameraTable.c"
	}
}

static void
camera_table_class_init (CameraTableClass * klass,
                         gpointer klass_data)
{
#line 34 "../src/camera/CameraTable.vala"
	camera_table_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/camera/CameraTable.vala"
	((CameraTableClass *) klass)->finalize = camera_table_finalize;
#line 34 "../src/camera/CameraTable.vala"
	g_type_class_adjust_private_offset (klass, &CameraTable_private_offset);
#line 34 "../src/camera/CameraTable.vala"
	camera_table_signals[CAMERA_TABLE_CAMERA_ADDED_SIGNAL] = g_signal_new ("camera-added", TYPE_CAMERA_TABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DISCOVERED_CAMERA, G_TYPE_NONE, 1, TYPE_DISCOVERED_CAMERA);
#line 34 "../src/camera/CameraTable.vala"
	camera_table_signals[CAMERA_TABLE_CAMERA_REMOVED_SIGNAL] = g_signal_new ("camera-removed", TYPE_CAMERA_TABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DISCOVERED_CAMERA, G_TYPE_NONE, 1, TYPE_DISCOVERED_CAMERA);
#line 4242 "CameraTable.c"
}

static void
camera_table_instance_init (CameraTable * self,
                            gpointer klass)
{
	GUdevClient* _tmp0_;
	GPContext* _tmp1_;
	GeeHashMap* _tmp2_;
#line 34 "../src/camera/CameraTable.vala"
	self->priv = camera_table_get_instance_private (self);
#line 42 "../src/camera/CameraTable.vala"
	_tmp0_ = g_udev_client_new (CAMERA_TABLE_SUBSYSTEMS);
#line 42 "../src/camera/CameraTable.vala"
	self->priv->client = _tmp0_;
#line 43 "../src/camera/CameraTable.vala"
	self->priv->camera_update_scheduler = NULL;
#line 44 "../src/camera/CameraTable.vala"
	_tmp1_ = gp_context_new ();
#line 44 "../src/camera/CameraTable.vala"
	self->priv->null_context = _tmp1_;
#line 48 "../src/camera/CameraTable.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_DISCOVERED_CAMERA, (GBoxedCopyFunc) discovered_camera_ref, (GDestroyNotify) discovered_camera_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/camera/CameraTable.vala"
	self->priv->camera_map = _tmp2_;
#line 34 "../src/camera/CameraTable.vala"
	self->ref_count = 1;
#line 4270 "CameraTable.c"
}

static void
camera_table_finalize (CameraTable * obj)
{
	CameraTable * self;
#line 34 "../src/camera/CameraTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CAMERA_TABLE, CameraTable);
#line 34 "../src/camera/CameraTable.vala"
	g_signal_handlers_destroy (self);
#line 42 "../src/camera/CameraTable.vala"
	_g_object_unref0 (self->priv->client);
#line 43 "../src/camera/CameraTable.vala"
	_one_shot_scheduler_unref0 (self->priv->camera_update_scheduler);
#line 44 "../src/camera/CameraTable.vala"
	_gp_context_unref0 (self->priv->null_context);
#line 45 "../src/camera/CameraTable.vala"
	_gp_abilities_list_free0 (self->priv->abilities_list);
#line 46 "../src/camera/CameraTable.vala"
	_g_object_unref0 (self->priv->volume_monitor);
#line 48 "../src/camera/CameraTable.vala"
	_g_object_unref0 (self->priv->camera_map);
#line 4293 "CameraTable.c"
}

static GType
camera_table_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_camera_table_init, value_camera_table_free_value, value_camera_table_copy_value, value_camera_table_peek_pointer, "p", value_camera_table_collect_value, "p", value_camera_table_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (CameraTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraTable), 0, (GInstanceInitFunc) camera_table_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType camera_table_type_id;
	camera_table_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CameraTable", &g_define_type_info, &g_define_type_fundamental_info, 0);
	CameraTable_private_offset = g_type_add_instance_private (camera_table_type_id, sizeof (CameraTablePrivate));
	return camera_table_type_id;
}

GType
camera_table_get_type (void)
{
	static volatile gsize camera_table_type_id__once = 0;
	if (g_once_init_enter (&camera_table_type_id__once)) {
		GType camera_table_type_id;
		camera_table_type_id = camera_table_get_type_once ();
		g_once_init_leave (&camera_table_type_id__once, camera_table_type_id);
	}
	return camera_table_type_id__once;
}

gpointer
camera_table_ref (gpointer instance)
{
	CameraTable * self;
	self = instance;
#line 34 "../src/camera/CameraTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "../src/camera/CameraTable.vala"
	return instance;
#line 4329 "CameraTable.c"
}

void
camera_table_unref (gpointer instance)
{
	CameraTable * self;
	self = instance;
#line 34 "../src/camera/CameraTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "../src/camera/CameraTable.vala"
		CAMERA_TABLE_GET_CLASS (self)->finalize (self);
#line 34 "../src/camera/CameraTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4343 "CameraTable.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

