/* ViewCollection.c generated by valac 0.56.18, the Vala compiler
 * generated from ViewCollection.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* A ViewCollection holds DataView objects, which are view instances wrapping DataSource objects.*/
/* Thus, multiple views can exist of a single SourceCollection, each view displaying all or some*/
/* of that SourceCollection.  A view collection also has a notion of order*/
/* (first/last/next/previous) that can be overridden by child classes.  It also understands hidden*/
/* objects, which are withheld entirely from the collection until they're made visible.  Currently*/
/* the only way to hide objects is with a ViewFilter.*/
/**/
/* A ViewCollection may also be locked.  When locked, it will not (a) remove hidden items from the*/
/* collection and (b) remove DataViews representing unlinked DataSources.  This allows for the*/
/* ViewCollection to be "frozen" while manipulating items within it.  When the collection is*/
/* unlocked, all changes are applied at once.*/
/**/
/* The default implementation provides a browser which orders the view in the order they're*/
/* stored in DataCollection, which is not specified.*/

#include "io.elementary.photos.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define VIEW_COLLECTION_TYPE_MONITOR_IMPL (view_collection_monitor_impl_get_type ())
#define VIEW_COLLECTION_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl))
#define VIEW_COLLECTION_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))
#define VIEW_COLLECTION_IS_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_IS_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_MONITOR_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))

typedef struct _ViewCollectionMonitorImpl ViewCollectionMonitorImpl;
typedef struct _ViewCollectionMonitorImplClass ViewCollectionMonitorImplClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))
typedef struct _ViewCollectionMonitorImplPrivate ViewCollectionMonitorImplPrivate;
#define _view_collection_monitor_unref0(var) ((var == NULL) ? NULL : (var = (view_collection_monitor_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;
typedef struct _ViewCollectionParamSpecMonitor ViewCollectionParamSpecMonitor;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_0_PROPERTY,
	VIEW_COLLECTION_TOGGLE_LISTS_NUM_PROPERTIES
};
static GParamSpec* view_collection_toggle_lists_properties[VIEW_COLLECTION_TOGGLE_LISTS_NUM_PROPERTIES];
enum  {
	VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL,
	VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL,
	VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL,
	VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL,
	VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL,
	VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL,
	VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL,
	VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL,
	VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL,
	VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL,
	VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL,
	VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL,
	VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL,
	VIEW_COLLECTION_NUM_SIGNALS
};
static guint view_collection_signals[VIEW_COLLECTION_NUM_SIGNALS] = {0};
typedef struct _ParamSpecViewFilter ParamSpecViewFilter;
enum  {
	VIEW_FILTER_REFRESH_SIGNAL,
	VIEW_FILTER_NUM_SIGNALS
};
static guint view_filter_signals[VIEW_FILTER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ViewCollectionPrivate {
	GeeHashMultiMap* monitors;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	CreateViewPredicate should_mirror;
	gpointer should_mirror_target;
	GeeSet* filters;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	GeeHashMap* source_map;
};

struct _ViewCollectionMonitorImpl {
	ViewCollectionMonitor parent_instance;
	ViewCollectionMonitorImplPrivate * priv;
	ViewCollection* owner;
	SourceCollection* sources;
	ViewManager* manager;
	Alteration* prereq;
};

struct _ViewCollectionMonitorImplClass {
	ViewCollectionMonitorClass parent_class;
};

struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};

struct _ViewCollectionParamSpecMonitor {
	GParamSpec parent_instance;
};

struct _ParamSpecViewFilter {
	GParamSpec parent_instance;
};

static gint ViewCollection_private_offset;
static gpointer view_collection_parent_class = NULL;
static gpointer view_collection_monitor_parent_class = NULL;
static gpointer view_collection_monitor_impl_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_filter_parent_class = NULL;

static GType view_collection_monitor_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void view_collection_real_notify_items_selected_unselected (ViewCollection* self,
                                                            GeeCollection* selected,
                                                            GeeCollection* unselected);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
static void view_collection_real_notify_item_view_altered (ViewCollection* self,
                                                    DataView* view);
static void view_collection_real_notify_views_altered (ViewCollection* self,
                                                GeeCollection* views);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self,
                                                        DataView* view);
static void view_collection_real_notify_geometries_altered (ViewCollection* self,
                                                     GeeCollection* views);
static void view_collection_real_notify_items_shown (ViewCollection* self,
                                              GeeCollection* shown);
static void view_collection_real_notify_items_hidden (ViewCollection* self,
                                               GeeCollection* hidden);
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self,
                                                           GeeCollection* changed);
static void view_collection_real_notify_view_filter_installed (ViewCollection* self,
                                                        ViewFilter* filter);
static void view_collection_real_notify_view_filter_removed (ViewCollection* self,
                                                      ViewFilter* filter);
static void view_collection_real_clear (DataCollection* base);
static void view_collection_real_close (DataCollection* base);
static void view_collection_on_view_filter_refresh (ViewCollection* self);
static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender,
                                                                  gpointer self);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner,
                                                             SourceCollection* sources,
                                                             ViewManager* manager,
                                                             Alteration* prereq);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type,
                                                                   ViewCollection* owner,
                                                                   SourceCollection* sources,
                                                                   ViewManager* manager,
                                                                   Alteration* prereq);
static void view_collection_add_sources (ViewCollection* self,
                                  SourceCollection* sources,
                                  GeeIterable* added,
                                  ProgressMonitor progress_monitor,
                                  gpointer progress_monitor_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self,
                                               GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender,
                                                                            GeeIterable* added,
                                                                            gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self,
                                                 GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender,
                                                                                GeeIterable* removed,
                                                                                gpointer self);
static void view_collection_filter_altered_items (ViewCollection* self,
                                           GeeCollection* views);
static gboolean view_collection_is_in_filter (ViewCollection* self,
                                       DataView* view);
static gboolean view_collection_real_valid_type (DataCollection* base,
                                          DataObject* object);
static void view_collection_on_sources_added (ViewCollection* self,
                                       DataCollection* sources,
                                       GeeIterable* added);
static DataView* _view_manager_create_view_create_view (DataSource* source,
                                                 gpointer self);
static gboolean view_collection_real_add (DataCollection* base,
                                   DataObject* object);
static GeeCollection* view_collection_real_add_many (DataCollection* base,
                                              GeeCollection* objects,
                                              ProgressMonitor monitor,
                                              gpointer monitor_target);
static void view_collection_on_sources_removed (ViewCollection* self,
                                         GeeIterable* removed);
static void view_collection_on_sources_altered (ViewCollection* self,
                                         DataCollection* collection,
                                         GeeMap* items);
static gboolean view_collection_is_visible (ViewCollection* self,
                                     DataView* view);
static void view_collection_real_notify_items_added (DataCollection* base,
                                              GeeIterable* added);
static gboolean view_collection_add_many_visible (ViewCollection* self,
                                           GeeCollection* many);
static void view_collection_add_many_selected (ViewCollection* self,
                                        GeeCollection* views);
static void view_collection_real_notify_items_removed (DataCollection* base,
                                                GeeIterable* removed);
static void view_collection_remove_many_selected (ViewCollection* self,
                                           GeeCollection* views);
static void view_collection_show_items (ViewCollection* self,
                                 GeeList* to_show);
static void view_collection_hide_items (ViewCollection* self,
                                 GeeList* to_hide);
static void view_collection_real_items_altered (DataCollection* base,
                                         GeeMap* map);
static void view_collection_real_set_comparator (DataCollection* base,
                                          Comparator comparator,
                                          gpointer comparator_target,
                                          ComparatorPredicate predicate,
                                          gpointer predicate_target);
static void view_collection_real_reset_comparator (DataCollection* base);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
static gint view_collection_real_get_count (DataCollection* base);
static DataObject* view_collection_real_get_at (DataCollection* base,
                                         gint index);
static gint view_collection_real_index_of (DataCollection* base,
                                    DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base,
                                        DataObject* object);
static DataView* view_collection_real_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first_unrejected (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
static DataView* view_collection_real_get_next (ViewCollection* self,
                                         DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self,
                                             DataView* view);
static gboolean view_collection_select_item (ViewCollection* self,
                                      DataObject* object,
                                      GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object,
                                                     GObject* user,
                                                     gpointer self);
static gboolean view_collection_unselect_item (ViewCollection* self,
                                        DataObject* object,
                                        GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object,
                                                       GObject* user,
                                                       gpointer self);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static gboolean view_collection_toggle_item (ViewCollection* self,
                                      DataObject* object,
                                      GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object,
                                                     GObject* user,
                                                     gpointer self);
static void view_collection_real_notify_thawed (DataCollection* base);
static void view_collection_real_items_selected (ViewCollection* self,
                                          GeeIterable* selected);
static void view_collection_real_items_unselected (ViewCollection* self,
                                            GeeIterable* unselected);
static void view_collection_real_items_state_changed (ViewCollection* self,
                                               GeeIterable* changed);
static void view_collection_real_selection_group_altered (ViewCollection* self);
static void view_collection_real_items_shown (ViewCollection* self,
                                       GeeCollection* visible);
static void view_collection_real_items_hidden (ViewCollection* self,
                                        GeeCollection* hidden);
static void view_collection_real_items_visibility_changed (ViewCollection* self,
                                                    GeeCollection* changed);
static void view_collection_real_item_view_altered (ViewCollection* self,
                                             DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self,
                                                 DataView* view);
static void view_collection_real_views_altered (ViewCollection* self,
                                         GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self,
                                              GeeCollection* views);
static void view_collection_real_view_filter_installed (ViewCollection* self,
                                                 ViewFilter* filer);
static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void view_collection_real_view_filter_removed (ViewCollection* self,
                                               ViewFilter* filer);
static void view_collection_monitor_finalize (ViewCollectionMonitor * obj);
static GType view_collection_monitor_get_type_once (void);
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender,
                                                                    GeeIterable* added,
                                                                    gpointer self);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender,
                                                                        GeeIterable* removed,
                                                                        gpointer self);
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender,
                                                                        GeeMap* items,
                                                                        gpointer self);
static void view_collection_monitor_impl_finalize (ViewCollectionMonitor * obj);
static GType view_collection_monitor_impl_get_type_once (void);
static void view_collection_toggle_lists_finalize (GObject * obj);
static GType view_collection_toggle_lists_get_type_once (void);
static void view_collection_finalize (DataCollection * obj);
static GType view_collection_get_type_once (void);
static gboolean view_filter_real_predicate (ViewFilter* self,
                                     DataView* view);
static void view_filter_real_refresh (ViewFilter* self);
static void view_filter_finalize (ViewFilter * obj);
static GType view_filter_get_type_once (void);

static inline gpointer
view_collection_get_instance_private (ViewCollection* self)
{
	return G_STRUCT_MEMBER_P (self, ViewCollection_private_offset);
}

ViewCollection*
view_collection_construct (GType object_type,
                           const gchar* name)
{
	ViewCollection* self = NULL;
#line 138 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 139 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, name);
#line 138 "../src/core/ViewCollection.vala"
	return self;
#line 378 "ViewCollection.c"
}

ViewCollection*
view_collection_new (const gchar* name)
{
#line 138 "../src/core/ViewCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 386 "ViewCollection.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 155 "../src/core/ViewCollection.vala"
	return self ? g_object_ref (self) : NULL;
#line 394 "ViewCollection.c"
}

static void
view_collection_real_notify_items_selected_unselected (ViewCollection* self,
                                                       GeeCollection* selected,
                                                       GeeCollection* unselected)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_selected = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean has_unselected = FALSE;
	GeeCollection* sum = NULL;
	gboolean _tmp6_ = FALSE;
	GeeCollection* _tmp14_;
#line 144 "../src/core/ViewCollection.vala"
	if (selected != NULL) {
#line 411 "ViewCollection.c"
		gint _tmp1_;
		gint _tmp2_;
#line 144 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_collection_get_size (selected);
#line 144 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 144 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp2_ > 0;
#line 420 "ViewCollection.c"
	} else {
#line 144 "../src/core/ViewCollection.vala"
		_tmp0_ = FALSE;
#line 424 "ViewCollection.c"
	}
#line 144 "../src/core/ViewCollection.vala"
	has_selected = _tmp0_;
#line 145 "../src/core/ViewCollection.vala"
	if (unselected != NULL) {
#line 430 "ViewCollection.c"
		gint _tmp4_;
		gint _tmp5_;
#line 145 "../src/core/ViewCollection.vala"
		_tmp4_ = gee_collection_get_size (unselected);
#line 145 "../src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 145 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp5_ > 0;
#line 439 "ViewCollection.c"
	} else {
#line 145 "../src/core/ViewCollection.vala"
		_tmp3_ = FALSE;
#line 443 "ViewCollection.c"
	}
#line 145 "../src/core/ViewCollection.vala"
	has_unselected = _tmp3_;
#line 147 "../src/core/ViewCollection.vala"
	if (has_selected) {
#line 148 "../src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL], 0, (GeeIterable*) selected);
#line 451 "ViewCollection.c"
	}
#line 150 "../src/core/ViewCollection.vala"
	if (has_unselected) {
#line 151 "../src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL], 0, (GeeIterable*) unselected);
#line 457 "ViewCollection.c"
	}
#line 154 "../src/core/ViewCollection.vala"
	if (has_selected) {
#line 154 "../src/core/ViewCollection.vala"
		_tmp6_ = !has_unselected;
#line 463 "ViewCollection.c"
	} else {
#line 154 "../src/core/ViewCollection.vala"
		_tmp6_ = FALSE;
#line 467 "ViewCollection.c"
	}
#line 154 "../src/core/ViewCollection.vala"
	if (_tmp6_) {
#line 471 "ViewCollection.c"
		GeeCollection* _tmp7_;
#line 155 "../src/core/ViewCollection.vala"
		_tmp7_ = _g_object_ref0 (selected);
#line 155 "../src/core/ViewCollection.vala"
		_g_object_unref0 (sum);
#line 155 "../src/core/ViewCollection.vala"
		sum = _tmp7_;
#line 479 "ViewCollection.c"
	} else {
		gboolean _tmp8_ = FALSE;
#line 156 "../src/core/ViewCollection.vala"
		if (!has_selected) {
#line 156 "../src/core/ViewCollection.vala"
			_tmp8_ = has_unselected;
#line 486 "ViewCollection.c"
		} else {
#line 156 "../src/core/ViewCollection.vala"
			_tmp8_ = FALSE;
#line 490 "ViewCollection.c"
		}
#line 156 "../src/core/ViewCollection.vala"
		if (_tmp8_) {
#line 494 "ViewCollection.c"
			GeeCollection* _tmp9_;
#line 157 "../src/core/ViewCollection.vala"
			_tmp9_ = _g_object_ref0 (unselected);
#line 157 "../src/core/ViewCollection.vala"
			_g_object_unref0 (sum);
#line 157 "../src/core/ViewCollection.vala"
			sum = _tmp9_;
#line 502 "ViewCollection.c"
		} else {
			gboolean _tmp10_ = FALSE;
#line 158 "../src/core/ViewCollection.vala"
			if (!has_selected) {
#line 158 "../src/core/ViewCollection.vala"
				_tmp10_ = !has_unselected;
#line 509 "ViewCollection.c"
			} else {
#line 158 "../src/core/ViewCollection.vala"
				_tmp10_ = FALSE;
#line 513 "ViewCollection.c"
			}
#line 158 "../src/core/ViewCollection.vala"
			if (_tmp10_) {
#line 159 "../src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 159 "../src/core/ViewCollection.vala"
				sum = NULL;
#line 521 "ViewCollection.c"
			} else {
				GeeHashSet* _tmp11_;
				GeeCollection* _tmp12_;
				GeeCollection* _tmp13_;
#line 161 "../src/core/ViewCollection.vala"
				_tmp11_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 161 "../src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 161 "../src/core/ViewCollection.vala"
				sum = (GeeCollection*) _tmp11_;
#line 162 "../src/core/ViewCollection.vala"
				_tmp12_ = sum;
#line 162 "../src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp12_, selected);
#line 163 "../src/core/ViewCollection.vala"
				_tmp13_ = sum;
#line 163 "../src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp13_, unselected);
#line 540 "ViewCollection.c"
			}
		}
	}
#line 166 "../src/core/ViewCollection.vala"
	_tmp14_ = sum;
#line 166 "../src/core/ViewCollection.vala"
	if (_tmp14_ != NULL) {
#line 548 "ViewCollection.c"
		GeeCollection* _tmp15_;
#line 167 "../src/core/ViewCollection.vala"
		_tmp15_ = sum;
#line 167 "../src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL], 0, (GeeIterable*) _tmp15_);
#line 168 "../src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 556 "ViewCollection.c"
	}
#line 142 "../src/core/ViewCollection.vala"
	_g_object_unref0 (sum);
#line 560 "ViewCollection.c"
}

void
view_collection_notify_items_selected_unselected (ViewCollection* self,
                                                  GeeCollection* selected,
                                                  GeeCollection* unselected)
{
	ViewCollectionClass* _klass_;
#line 142 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 142 "../src/core/ViewCollection.vala"
	if (_klass_->notify_items_selected_unselected) {
#line 142 "../src/core/ViewCollection.vala"
		_klass_->notify_items_selected_unselected (self, selected, unselected);
#line 577 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_selection_group_altered (ViewCollection* self)
{
#line 173 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL], 0);
#line 586 "ViewCollection.c"
}

void
view_collection_notify_selection_group_altered (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 172 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 172 "../src/core/ViewCollection.vala"
	if (_klass_->notify_selection_group_altered) {
#line 172 "../src/core/ViewCollection.vala"
		_klass_->notify_selection_group_altered (self);
#line 601 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_item_view_altered (ViewCollection* self,
                                               DataView* view)
{
#line 176 "../src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 177 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL], 0, view);
#line 613 "ViewCollection.c"
}

void
view_collection_notify_item_view_altered (ViewCollection* self,
                                          DataView* view)
{
	ViewCollectionClass* _klass_;
#line 176 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 176 "../src/core/ViewCollection.vala"
	if (_klass_->notify_item_view_altered) {
#line 176 "../src/core/ViewCollection.vala"
		_klass_->notify_item_view_altered (self, view);
#line 629 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_views_altered (ViewCollection* self,
                                           GeeCollection* views)
{
#line 180 "../src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 181 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL], 0, views);
#line 641 "ViewCollection.c"
}

void
view_collection_notify_views_altered (ViewCollection* self,
                                      GeeCollection* views)
{
	ViewCollectionClass* _klass_;
#line 180 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 180 "../src/core/ViewCollection.vala"
	if (_klass_->notify_views_altered) {
#line 180 "../src/core/ViewCollection.vala"
		_klass_->notify_views_altered (self, views);
#line 657 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_item_geometry_altered (ViewCollection* self,
                                                   DataView* view)
{
#line 184 "../src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 185 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL], 0, view);
#line 669 "ViewCollection.c"
}

void
view_collection_notify_item_geometry_altered (ViewCollection* self,
                                              DataView* view)
{
	ViewCollectionClass* _klass_;
#line 184 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 184 "../src/core/ViewCollection.vala"
	if (_klass_->notify_item_geometry_altered) {
#line 184 "../src/core/ViewCollection.vala"
		_klass_->notify_item_geometry_altered (self, view);
#line 685 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_geometries_altered (ViewCollection* self,
                                                GeeCollection* views)
{
#line 188 "../src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 189 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL], 0, views);
#line 697 "ViewCollection.c"
}

void
view_collection_notify_geometries_altered (ViewCollection* self,
                                           GeeCollection* views)
{
	ViewCollectionClass* _klass_;
#line 188 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 188 "../src/core/ViewCollection.vala"
	if (_klass_->notify_geometries_altered) {
#line 188 "../src/core/ViewCollection.vala"
		_klass_->notify_geometries_altered (self, views);
#line 713 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_items_shown (ViewCollection* self,
                                         GeeCollection* shown)
{
#line 192 "../src/core/ViewCollection.vala"
	g_return_if_fail (shown != NULL);
#line 193 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL], 0, shown);
#line 725 "ViewCollection.c"
}

void
view_collection_notify_items_shown (ViewCollection* self,
                                    GeeCollection* shown)
{
	ViewCollectionClass* _klass_;
#line 192 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 192 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 192 "../src/core/ViewCollection.vala"
	if (_klass_->notify_items_shown) {
#line 192 "../src/core/ViewCollection.vala"
		_klass_->notify_items_shown (self, shown);
#line 741 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_items_hidden (ViewCollection* self,
                                          GeeCollection* hidden)
{
#line 196 "../src/core/ViewCollection.vala"
	g_return_if_fail (hidden != NULL);
#line 197 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL], 0, hidden);
#line 753 "ViewCollection.c"
}

void
view_collection_notify_items_hidden (ViewCollection* self,
                                     GeeCollection* hidden)
{
	ViewCollectionClass* _klass_;
#line 196 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 196 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 196 "../src/core/ViewCollection.vala"
	if (_klass_->notify_items_hidden) {
#line 196 "../src/core/ViewCollection.vala"
		_klass_->notify_items_hidden (self, hidden);
#line 769 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_items_visibility_changed (ViewCollection* self,
                                                      GeeCollection* changed)
{
#line 200 "../src/core/ViewCollection.vala"
	g_return_if_fail (changed != NULL);
#line 201 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL], 0, changed);
#line 781 "ViewCollection.c"
}

void
view_collection_notify_items_visibility_changed (ViewCollection* self,
                                                 GeeCollection* changed)
{
	ViewCollectionClass* _klass_;
#line 200 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 200 "../src/core/ViewCollection.vala"
	if (_klass_->notify_items_visibility_changed) {
#line 200 "../src/core/ViewCollection.vala"
		_klass_->notify_items_visibility_changed (self, changed);
#line 797 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_view_filter_installed (ViewCollection* self,
                                                   ViewFilter* filter)
{
#line 204 "../src/core/ViewCollection.vala"
	g_return_if_fail (filter != NULL);
#line 205 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL], 0, filter);
#line 809 "ViewCollection.c"
}

void
view_collection_notify_view_filter_installed (ViewCollection* self,
                                              ViewFilter* filter)
{
	ViewCollectionClass* _klass_;
#line 204 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 204 "../src/core/ViewCollection.vala"
	if (_klass_->notify_view_filter_installed) {
#line 204 "../src/core/ViewCollection.vala"
		_klass_->notify_view_filter_installed (self, filter);
#line 825 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_view_filter_removed (ViewCollection* self,
                                                 ViewFilter* filter)
{
#line 208 "../src/core/ViewCollection.vala"
	g_return_if_fail (filter != NULL);
#line 209 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL], 0, filter);
#line 837 "ViewCollection.c"
}

void
view_collection_notify_view_filter_removed (ViewCollection* self,
                                            ViewFilter* filter)
{
	ViewCollectionClass* _klass_;
#line 208 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 208 "../src/core/ViewCollection.vala"
	if (_klass_->notify_view_filter_removed) {
#line 208 "../src/core/ViewCollection.vala"
		_klass_->notify_view_filter_removed (self, filter);
#line 853 "ViewCollection.c"
	}
}

static void
view_collection_real_clear (DataCollection* base)
{
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	GeeHashMultiMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 212 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 215 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 215 "../src/core/ViewCollection.vala"
	_tmp2_ = gee_multi_map_get_size ((GeeMultiMap*) _tmp1_);
#line 215 "../src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 215 "../src/core/ViewCollection.vala"
	if (_tmp3_ > 0) {
#line 215 "../src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 877 "ViewCollection.c"
	} else {
		ViewCollection* _tmp4_;
#line 215 "../src/core/ViewCollection.vala"
		_tmp4_ = self->priv->mirroring;
#line 215 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 884 "ViewCollection.c"
	}
#line 215 "../src/core/ViewCollection.vala"
	if (_tmp0_) {
#line 888 "ViewCollection.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 216 "../src/core/ViewCollection.vala"
		_tmp5_ = data_collection_to_string ((DataCollection*) self);
#line 216 "../src/core/ViewCollection.vala"
		_tmp6_ = _tmp5_;
#line 216 "../src/core/ViewCollection.vala"
		g_warning ("ViewCollection.vala:216: Cannot clear %s: monitoring or mirroring in e" \
"ffect", _tmp6_);
#line 216 "../src/core/ViewCollection.vala"
		_g_free0 (_tmp6_);
#line 218 "../src/core/ViewCollection.vala"
		return;
#line 901 "ViewCollection.c"
	}
#line 221 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 905 "ViewCollection.c"
}

static void
_view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender,
                                                             gpointer self)
{
#line 228 "../src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh ((ViewCollection*) self);
#line 914 "ViewCollection.c"
}

static void
view_collection_real_close (DataCollection* base)
{
	ViewCollection * self;
	GeeSet* _tmp7_;
#line 224 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 225 "../src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 226 "../src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 928 "ViewCollection.c"
	{
		GeeIterator* _f_it = NULL;
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 227 "../src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 227 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 227 "../src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 227 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 941 "ViewCollection.c"
			GeeIterator* _tmp2_;
			ViewFilter* f = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			ViewFilter* _tmp5_;
			guint _tmp6_;
#line 227 "../src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 227 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 227 "../src/core/ViewCollection.vala"
				break;
#line 954 "ViewCollection.c"
			}
#line 227 "../src/core/ViewCollection.vala"
			_tmp3_ = _f_it;
#line 227 "../src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 227 "../src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp4_;
#line 228 "../src/core/ViewCollection.vala"
			_tmp5_ = f;
#line 228 "../src/core/ViewCollection.vala"
			g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp6_, NULL, FALSE);
#line 228 "../src/core/ViewCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 227 "../src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 970 "ViewCollection.c"
		}
#line 227 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 974 "ViewCollection.c"
	}
#line 229 "../src/core/ViewCollection.vala"
	_tmp7_ = self->priv->filters;
#line 229 "../src/core/ViewCollection.vala"
	gee_collection_clear ((GeeCollection*) _tmp7_);
#line 231 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 982 "ViewCollection.c"
}

ViewCollectionMonitor*
view_collection_monitor_source_collection (ViewCollection* self,
                                           SourceCollection* sources,
                                           ViewManager* manager,
                                           Alteration* prereq,
                                           GeeCollection* initial,
                                           ProgressMonitor progress_monitor,
                                           gpointer progress_monitor_target)
{
	ViewCollectionMonitorImpl* monitor = NULL;
	ViewCollectionMonitorImpl* _tmp0_;
	GeeHashMultiMap* _tmp1_;
	ViewCollectionMonitorImpl* _tmp2_;
	gboolean _tmp3_ = FALSE;
	ViewCollectionMonitor* result;
#line 234 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 234 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 234 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 238 "../src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 240 "../src/core/ViewCollection.vala"
	data_collection_freeze_notifications ((DataCollection*) self);
#line 243 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_monitor_impl_new (self, sources, manager, prereq);
#line 243 "../src/core/ViewCollection.vala"
	monitor = _tmp0_;
#line 244 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 244 "../src/core/ViewCollection.vala"
	_tmp2_ = monitor;
#line 244 "../src/core/ViewCollection.vala"
	gee_multi_map_set ((GeeMultiMap*) _tmp1_, sources, _tmp2_);
#line 246 "../src/core/ViewCollection.vala"
	if (initial != NULL) {
#line 1022 "ViewCollection.c"
		gint _tmp4_;
		gint _tmp5_;
#line 246 "../src/core/ViewCollection.vala"
		_tmp4_ = gee_collection_get_size (initial);
#line 246 "../src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 246 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp5_ > 0;
#line 1031 "ViewCollection.c"
	} else {
#line 246 "../src/core/ViewCollection.vala"
		_tmp3_ = FALSE;
#line 1035 "ViewCollection.c"
	}
#line 246 "../src/core/ViewCollection.vala"
	if (_tmp3_) {
#line 1039 "ViewCollection.c"
		GeeArrayList* created_views = NULL;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
#line 248 "../src/core/ViewCollection.vala"
		_tmp6_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 248 "../src/core/ViewCollection.vala"
		created_views = _tmp6_;
#line 1049 "ViewCollection.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp7_;
#line 249 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_iterable_iterator ((GeeIterable*) initial);
#line 249 "../src/core/ViewCollection.vala"
			_source_it = _tmp7_;
#line 249 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 1059 "ViewCollection.c"
				GeeIterator* _tmp8_;
				DataSource* source = NULL;
				GeeIterator* _tmp9_;
				gpointer _tmp10_;
				GeeArrayList* _tmp11_;
				DataSource* _tmp12_;
				DataView* _tmp13_;
				DataView* _tmp14_;
#line 249 "../src/core/ViewCollection.vala"
				_tmp8_ = _source_it;
#line 249 "../src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp8_)) {
#line 249 "../src/core/ViewCollection.vala"
					break;
#line 1074 "ViewCollection.c"
				}
#line 249 "../src/core/ViewCollection.vala"
				_tmp9_ = _source_it;
#line 249 "../src/core/ViewCollection.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 249 "../src/core/ViewCollection.vala"
				source = (DataSource*) _tmp10_;
#line 250 "../src/core/ViewCollection.vala"
				_tmp11_ = created_views;
#line 250 "../src/core/ViewCollection.vala"
				_tmp12_ = source;
#line 250 "../src/core/ViewCollection.vala"
				_tmp13_ = view_manager_create_view (manager, _tmp12_);
#line 250 "../src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 250 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp14_);
#line 250 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 249 "../src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1096 "ViewCollection.c"
			}
#line 249 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_source_it);
#line 1100 "ViewCollection.c"
		}
#line 252 "../src/core/ViewCollection.vala"
		_tmp15_ = created_views;
#line 252 "../src/core/ViewCollection.vala"
		_tmp16_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp15_, progress_monitor, progress_monitor_target);
#line 252 "../src/core/ViewCollection.vala"
		_tmp17_ = _tmp16_;
#line 252 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp17_);
#line 246 "../src/core/ViewCollection.vala"
		_g_object_unref0 (created_views);
#line 1112 "ViewCollection.c"
	} else {
		GeeCollection* _tmp18_;
		GeeIterable* _tmp19_;
#line 255 "../src/core/ViewCollection.vala"
		_tmp18_ = data_collection_get_all ((DataCollection*) sources);
#line 255 "../src/core/ViewCollection.vala"
		_tmp19_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable);
#line 255 "../src/core/ViewCollection.vala"
		view_collection_add_sources (self, sources, _tmp19_, progress_monitor, progress_monitor_target);
#line 255 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp19_);
#line 1124 "ViewCollection.c"
	}
#line 258 "../src/core/ViewCollection.vala"
	data_collection_thaw_notifications ((DataCollection*) self);
#line 260 "../src/core/ViewCollection.vala"
	result = (ViewCollectionMonitor*) monitor;
#line 260 "../src/core/ViewCollection.vala"
	return result;
#line 1132 "ViewCollection.c"
}

static gpointer
_view_collection_monitor_ref0 (gpointer self)
{
#line 264 "../src/core/ViewCollection.vala"
	return self ? view_collection_monitor_ref (self) : NULL;
#line 1140 "ViewCollection.c"
}

void
view_collection_halt_monitoring (ViewCollection* self,
                                 ViewCollectionMonitor* m)
{
	ViewCollectionMonitorImpl* monitor = NULL;
	ViewCollectionMonitorImpl* _tmp0_;
	gboolean removed = FALSE;
	GeeHashMultiMap* _tmp1_;
	SourceCollection* _tmp2_;
#line 263 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/core/ViewCollection.vala"
	g_return_if_fail (m != NULL);
#line 264 "../src/core/ViewCollection.vala"
	_tmp0_ = _view_collection_monitor_ref0 (G_TYPE_CHECK_INSTANCE_CAST (m, VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl));
#line 264 "../src/core/ViewCollection.vala"
	monitor = _tmp0_;
#line 266 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 266 "../src/core/ViewCollection.vala"
	_tmp2_ = monitor->sources;
#line 266 "../src/core/ViewCollection.vala"
	removed = gee_multi_map_remove ((GeeMultiMap*) _tmp1_, _tmp2_, monitor);
#line 267 "../src/core/ViewCollection.vala"
	_vala_assert (removed, "removed");
#line 263 "../src/core/ViewCollection.vala"
	_view_collection_monitor_unref0 (monitor);
#line 1170 "ViewCollection.c"
}

void
view_collection_halt_all_monitoring (ViewCollection* self)
{
	GeeHashMultiMap* _tmp0_;
#line 270 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->monitors;
#line 271 "../src/core/ViewCollection.vala"
	gee_multi_map_clear ((GeeMultiMap*) _tmp0_);
#line 1183 "ViewCollection.c"
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 280 "../src/core/ViewCollection.vala"
	return self ? data_collection_ref (self) : NULL;
#line 1191 "ViewCollection.c"
}

static void
_view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender,
                                                                       GeeIterable* added,
                                                                       gpointer self)
{
#line 288 "../src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added ((ViewCollection*) self, added);
#line 1201 "ViewCollection.c"
}

static void
_view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender,
                                                                           GeeIterable* removed,
                                                                           gpointer self)
{
#line 289 "../src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_removed ((ViewCollection*) self, removed);
#line 1211 "ViewCollection.c"
}

void
view_collection_mirror (ViewCollection* self,
                        ViewCollection* to_mirror,
                        CreateView mirroring_ctor,
                        gpointer mirroring_ctor_target,
                        CreateViewPredicate should_mirror,
                        gpointer should_mirror_target)
{
	ViewCollection* _tmp0_;
	gpointer _tmp1_ = NULL;
	Comparator _tmp2_;
	gpointer _tmp3_ = NULL;
	ComparatorPredicate _tmp4_;
	ViewCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	ViewCollection* _tmp8_;
	ViewCollection* _tmp9_;
#line 274 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/core/ViewCollection.vala"
	g_return_if_fail (to_mirror != NULL);
#line 276 "../src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 277 "../src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 278 "../src/core/ViewCollection.vala"
	data_collection_clear ((DataCollection*) self);
#line 280 "../src/core/ViewCollection.vala"
	_tmp0_ = _data_collection_ref0 (to_mirror);
#line 280 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 280 "../src/core/ViewCollection.vala"
	self->priv->mirroring = _tmp0_;
#line 281 "../src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = mirroring_ctor;
#line 281 "../src/core/ViewCollection.vala"
	self->priv->mirroring_ctor_target = mirroring_ctor_target;
#line 282 "../src/core/ViewCollection.vala"
	self->priv->should_mirror = should_mirror;
#line 282 "../src/core/ViewCollection.vala"
	self->priv->should_mirror_target = should_mirror_target;
#line 283 "../src/core/ViewCollection.vala"
	_tmp2_ = data_collection_get_comparator ((DataCollection*) to_mirror, &_tmp1_);
#line 283 "../src/core/ViewCollection.vala"
	_tmp4_ = data_collection_get_comparator_predicate ((DataCollection*) to_mirror, &_tmp3_);
#line 283 "../src/core/ViewCollection.vala"
	data_collection_set_comparator ((DataCollection*) self, _tmp2_, _tmp1_, _tmp4_, _tmp3_);
#line 286 "../src/core/ViewCollection.vala"
	_tmp5_ = self->priv->mirroring;
#line 286 "../src/core/ViewCollection.vala"
	_tmp6_ = data_collection_get_all ((DataCollection*) _tmp5_);
#line 286 "../src/core/ViewCollection.vala"
	_tmp7_ = _tmp6_;
#line 286 "../src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added (self, (GeeIterable*) _tmp7_);
#line 286 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp7_);
#line 288 "../src/core/ViewCollection.vala"
	_tmp8_ = self->priv->mirroring;
#line 288 "../src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) _tmp8_, "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 289 "../src/core/ViewCollection.vala"
	_tmp9_ = self->priv->mirroring;
#line 289 "../src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) _tmp9_, "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1280 "ViewCollection.c"
}

void
view_collection_halt_mirroring (ViewCollection* self)
{
	ViewCollection* _tmp0_;
#line 292 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->mirroring;
#line 293 "../src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 1293 "ViewCollection.c"
		ViewCollection* _tmp1_;
		guint _tmp2_;
		ViewCollection* _tmp3_;
		guint _tmp4_;
#line 294 "../src/core/ViewCollection.vala"
		_tmp1_ = self->priv->mirroring;
#line 294 "../src/core/ViewCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 294 "../src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched ((DataCollection*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 295 "../src/core/ViewCollection.vala"
		_tmp3_ = self->priv->mirroring;
#line 295 "../src/core/ViewCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp4_, NULL, FALSE);
#line 295 "../src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched ((DataCollection*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1310 "ViewCollection.c"
	}
#line 298 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 298 "../src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 1316 "ViewCollection.c"
}

void
view_collection_copy_into (ViewCollection* self,
                           ViewCollection* to_copy,
                           CreateView copying_ctor,
                           gpointer copying_ctor_target,
                           CreateViewPredicate should_copy,
                           gpointer should_copy_target)
{
	GeeArrayList* copy_view = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp19_;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp21_;
#line 301 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/core/ViewCollection.vala"
	g_return_if_fail (to_copy != NULL);
#line 304 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 304 "../src/core/ViewCollection.vala"
	copy_view = _tmp0_;
#line 1340 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 305 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_all ((DataCollection*) to_copy);
#line 305 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 305 "../src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 305 "../src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 305 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 305 "../src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 305 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 1361 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataView* view = NULL;
			DataObject* _tmp8_;
			DataView* _tmp9_;
			DataView* _tmp10_;
			DataSource* _tmp11_;
			DataSource* _tmp12_;
#line 305 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 305 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 305 "../src/core/ViewCollection.vala"
				break;
#line 1378 "ViewCollection.c"
			}
#line 305 "../src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 305 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 305 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 306 "../src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 306 "../src/core/ViewCollection.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView));
#line 306 "../src/core/ViewCollection.vala"
			view = _tmp9_;
#line 307 "../src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 307 "../src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (_tmp10_);
#line 307 "../src/core/ViewCollection.vala"
			_tmp12_ = _tmp11_;
#line 307 "../src/core/ViewCollection.vala"
			if (should_copy (_tmp12_, should_copy_target)) {
#line 1400 "ViewCollection.c"
				GeeArrayList* _tmp13_;
				DataView* _tmp14_;
				DataSource* _tmp15_;
				DataSource* _tmp16_;
				DataView* _tmp17_;
				DataView* _tmp18_;
#line 308 "../src/core/ViewCollection.vala"
				_tmp13_ = copy_view;
#line 308 "../src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 308 "../src/core/ViewCollection.vala"
				_tmp15_ = data_view_get_source (_tmp14_);
#line 308 "../src/core/ViewCollection.vala"
				_tmp16_ = _tmp15_;
#line 308 "../src/core/ViewCollection.vala"
				_tmp17_ = copying_ctor (_tmp16_, copying_ctor_target);
#line 308 "../src/core/ViewCollection.vala"
				_tmp18_ = _tmp17_;
#line 308 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, (DataObject*) _tmp18_);
#line 308 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp18_);
#line 1423 "ViewCollection.c"
			}
#line 305 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 305 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 1429 "ViewCollection.c"
		}
#line 305 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 1433 "ViewCollection.c"
	}
#line 311 "../src/core/ViewCollection.vala"
	_tmp19_ = copy_view;
#line 311 "../src/core/ViewCollection.vala"
	_tmp20_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp19_, NULL, NULL);
#line 311 "../src/core/ViewCollection.vala"
	_tmp21_ = _tmp20_;
#line 311 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp21_);
#line 301 "../src/core/ViewCollection.vala"
	_g_object_unref0 (copy_view);
#line 1445 "ViewCollection.c"
}

gboolean
view_collection_is_view_filter_installed (ViewCollection* self,
                                          ViewFilter* f)
{
	GeeSet* _tmp0_;
	gboolean result;
#line 314 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 314 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (f != NULL, FALSE);
#line 315 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 315 "../src/core/ViewCollection.vala"
	result = gee_collection_contains ((GeeCollection*) _tmp0_, f);
#line 315 "../src/core/ViewCollection.vala"
	return result;
#line 1464 "ViewCollection.c"
}

void
view_collection_install_view_filter (ViewCollection* self,
                                     ViewFilter* f)
{
	GeeSet* _tmp0_;
#line 318 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/core/ViewCollection.vala"
	g_return_if_fail (f != NULL);
#line 319 "../src/core/ViewCollection.vala"
	if (view_collection_is_view_filter_installed (self, f)) {
#line 320 "../src/core/ViewCollection.vala"
		return;
#line 1480 "ViewCollection.c"
	}
#line 322 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 322 "../src/core/ViewCollection.vala"
	gee_collection_add ((GeeCollection*) _tmp0_, f);
#line 323 "../src/core/ViewCollection.vala"
	g_signal_connect (f, "refresh", (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 326 "../src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 329 "../src/core/ViewCollection.vala"
	view_collection_notify_view_filter_installed (self, f);
#line 1492 "ViewCollection.c"
}

void
view_collection_remove_view_filter (ViewCollection* self,
                                    ViewFilter* f)
{
	GeeSet* _tmp0_;
	guint _tmp1_;
#line 332 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/core/ViewCollection.vala"
	g_return_if_fail (f != NULL);
#line 333 "../src/core/ViewCollection.vala"
	if (!view_collection_is_view_filter_installed (self, f)) {
#line 334 "../src/core/ViewCollection.vala"
		return;
#line 1509 "ViewCollection.c"
	}
#line 336 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 336 "../src/core/ViewCollection.vala"
	gee_collection_remove ((GeeCollection*) _tmp0_, f);
#line 337 "../src/core/ViewCollection.vala"
	g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp1_, NULL, FALSE);
#line 337 "../src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (f, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 340 "../src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 343 "../src/core/ViewCollection.vala"
	view_collection_notify_view_filter_removed (self, f);
#line 1523 "ViewCollection.c"
}

static void
view_collection_on_view_filter_refresh (ViewCollection* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 346 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 347 "../src/core/ViewCollection.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 347 "../src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp1_);
#line 347 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1541 "ViewCollection.c"
}

static gboolean
view_collection_is_in_filter (ViewCollection* self,
                              DataView* view)
{
	gboolean result;
#line 351 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 351 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 1553 "ViewCollection.c"
	{
		GeeIterator* _f_it = NULL;
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 352 "../src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 352 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 352 "../src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 352 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 1566 "ViewCollection.c"
			GeeIterator* _tmp2_;
			ViewFilter* f = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			ViewFilter* _tmp5_;
#line 352 "../src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 352 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 352 "../src/core/ViewCollection.vala"
				break;
#line 1578 "ViewCollection.c"
			}
#line 352 "../src/core/ViewCollection.vala"
			_tmp3_ = _f_it;
#line 352 "../src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 352 "../src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp4_;
#line 353 "../src/core/ViewCollection.vala"
			_tmp5_ = f;
#line 353 "../src/core/ViewCollection.vala"
			if (!view_filter_predicate (_tmp5_, view)) {
#line 354 "../src/core/ViewCollection.vala"
				result = FALSE;
#line 354 "../src/core/ViewCollection.vala"
				_view_filter_unref0 (f);
#line 354 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_f_it);
#line 354 "../src/core/ViewCollection.vala"
				return result;
#line 1598 "ViewCollection.c"
			}
#line 352 "../src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 1602 "ViewCollection.c"
		}
#line 352 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 1606 "ViewCollection.c"
	}
#line 356 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 356 "../src/core/ViewCollection.vala"
	return result;
#line 1612 "ViewCollection.c"
}

static gboolean
view_collection_real_valid_type (DataCollection* base,
                                 DataObject* object)
{
	ViewCollection * self;
	gboolean result;
#line 359 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 359 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 360 "../src/core/ViewCollection.vala"
	result = IS_DATA_VIEW (object);
#line 360 "../src/core/ViewCollection.vala"
	return result;
#line 1629 "ViewCollection.c"
}

static void
view_collection_on_sources_added (ViewCollection* self,
                                  DataCollection* sources,
                                  GeeIterable* added)
{
#line 363 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 363 "../src/core/ViewCollection.vala"
	g_return_if_fail (sources != NULL);
#line 363 "../src/core/ViewCollection.vala"
	g_return_if_fail (added != NULL);
#line 364 "../src/core/ViewCollection.vala"
	view_collection_add_sources (self, G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_SOURCE_COLLECTION, SourceCollection), added, NULL, NULL);
#line 1645 "ViewCollection.c"
}

static DataView*
_view_manager_create_view_create_view (DataSource* source,
                                       gpointer self)
{
	DataView* result;
	result = view_manager_create_view ((ViewManager*) self, source);
#line 377 "../src/core/ViewCollection.vala"
	return result;
#line 1656 "ViewCollection.c"
}

static void
view_collection_add_sources (ViewCollection* self,
                             SourceCollection* sources,
                             GeeIterable* added,
                             ProgressMonitor progress_monitor,
                             gpointer progress_monitor_target)
{
	DataView* created_view = NULL;
	GeeArrayList* created_views = NULL;
	DataView* _tmp32_;
#line 367 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/core/ViewCollection.vala"
	g_return_if_fail (sources != NULL);
#line 367 "../src/core/ViewCollection.vala"
	g_return_if_fail (added != NULL);
#line 371 "../src/core/ViewCollection.vala"
	created_view = NULL;
#line 372 "../src/core/ViewCollection.vala"
	created_views = NULL;
#line 1679 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 373 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (added);
#line 373 "../src/core/ViewCollection.vala"
		_source_it = _tmp0_;
#line 373 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 1689 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			CreateView factory = NULL;
			gpointer factory_target;
			GDestroyNotify factory_target_destroy_notify;
			CreateView _tmp17_;
			gpointer _tmp17__target;
#line 373 "../src/core/ViewCollection.vala"
			_tmp1_ = _source_it;
#line 373 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 373 "../src/core/ViewCollection.vala"
				break;
#line 1705 "ViewCollection.c"
			}
#line 373 "../src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 373 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 373 "../src/core/ViewCollection.vala"
			source = (DataSource*) _tmp3_;
#line 374 "../src/core/ViewCollection.vala"
			factory = NULL;
#line 374 "../src/core/ViewCollection.vala"
			factory_target = NULL;
#line 374 "../src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 1719 "ViewCollection.c"
			{
				GeeIterator* _monitor_it = NULL;
				GeeHashMultiMap* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
				GeeIterator* _tmp7_;
				GeeIterator* _tmp8_;
#line 375 "../src/core/ViewCollection.vala"
				_tmp4_ = self->priv->monitors;
#line 375 "../src/core/ViewCollection.vala"
				_tmp5_ = gee_multi_map_get ((GeeMultiMap*) _tmp4_, sources);
#line 375 "../src/core/ViewCollection.vala"
				_tmp6_ = _tmp5_;
#line 375 "../src/core/ViewCollection.vala"
				_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 375 "../src/core/ViewCollection.vala"
				_tmp8_ = _tmp7_;
#line 375 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp6_);
#line 375 "../src/core/ViewCollection.vala"
				_monitor_it = _tmp8_;
#line 375 "../src/core/ViewCollection.vala"
				while (TRUE) {
#line 1743 "ViewCollection.c"
					GeeIterator* _tmp9_;
					ViewCollectionMonitorImpl* monitor = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					ViewCollectionMonitorImpl* _tmp12_;
					ViewManager* _tmp13_;
					DataSource* _tmp14_;
#line 375 "../src/core/ViewCollection.vala"
					_tmp9_ = _monitor_it;
#line 375 "../src/core/ViewCollection.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 375 "../src/core/ViewCollection.vala"
						break;
#line 1757 "ViewCollection.c"
					}
#line 375 "../src/core/ViewCollection.vala"
					_tmp10_ = _monitor_it;
#line 375 "../src/core/ViewCollection.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 375 "../src/core/ViewCollection.vala"
					monitor = (ViewCollectionMonitorImpl*) _tmp11_;
#line 376 "../src/core/ViewCollection.vala"
					_tmp12_ = monitor;
#line 376 "../src/core/ViewCollection.vala"
					_tmp13_ = _tmp12_->manager;
#line 376 "../src/core/ViewCollection.vala"
					_tmp14_ = source;
#line 376 "../src/core/ViewCollection.vala"
					if (view_manager_include_in_view (_tmp13_, _tmp14_)) {
#line 1773 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp15_;
						ViewManager* _tmp16_;
#line 377 "../src/core/ViewCollection.vala"
						_tmp15_ = monitor;
#line 377 "../src/core/ViewCollection.vala"
						_tmp16_ = _tmp15_->manager;
#line 377 "../src/core/ViewCollection.vala"
						(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 377 "../src/core/ViewCollection.vala"
						factory = NULL;
#line 377 "../src/core/ViewCollection.vala"
						factory_target = NULL;
#line 377 "../src/core/ViewCollection.vala"
						factory_target_destroy_notify = NULL;
#line 377 "../src/core/ViewCollection.vala"
						factory = _view_manager_create_view_create_view;
#line 377 "../src/core/ViewCollection.vala"
						factory_target = view_manager_ref (_tmp16_);
#line 377 "../src/core/ViewCollection.vala"
						factory_target_destroy_notify = view_manager_unref;
#line 379 "../src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 379 "../src/core/ViewCollection.vala"
						break;
#line 1798 "ViewCollection.c"
					}
#line 375 "../src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor);
#line 1802 "ViewCollection.c"
				}
#line 375 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_it);
#line 1806 "ViewCollection.c"
			}
#line 383 "../src/core/ViewCollection.vala"
			_tmp17_ = factory;
#line 383 "../src/core/ViewCollection.vala"
			_tmp17__target = factory_target;
#line 383 "../src/core/ViewCollection.vala"
			if (_tmp17_ != NULL) {
#line 1814 "ViewCollection.c"
				DataView* new_view = NULL;
				CreateView _tmp18_;
				gpointer _tmp18__target;
				DataSource* _tmp19_;
				DataView* _tmp20_;
				GeeArrayList* _tmp21_;
#line 384 "../src/core/ViewCollection.vala"
				_tmp18_ = factory;
#line 384 "../src/core/ViewCollection.vala"
				_tmp18__target = factory_target;
#line 384 "../src/core/ViewCollection.vala"
				_tmp19_ = source;
#line 384 "../src/core/ViewCollection.vala"
				_tmp20_ = _tmp18_ (_tmp19_, _tmp18__target);
#line 384 "../src/core/ViewCollection.vala"
				new_view = _tmp20_;
#line 388 "../src/core/ViewCollection.vala"
				_tmp21_ = created_views;
#line 388 "../src/core/ViewCollection.vala"
				if (_tmp21_ != NULL) {
#line 1835 "ViewCollection.c"
					GeeArrayList* _tmp22_;
					DataView* _tmp23_;
#line 389 "../src/core/ViewCollection.vala"
					_tmp22_ = created_views;
#line 389 "../src/core/ViewCollection.vala"
					_tmp23_ = new_view;
#line 389 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 1844 "ViewCollection.c"
				} else {
					DataView* _tmp24_;
#line 390 "../src/core/ViewCollection.vala"
					_tmp24_ = created_view;
#line 390 "../src/core/ViewCollection.vala"
					if (_tmp24_ == NULL) {
#line 1851 "ViewCollection.c"
						DataView* _tmp25_;
						DataView* _tmp26_;
#line 391 "../src/core/ViewCollection.vala"
						_tmp25_ = new_view;
#line 391 "../src/core/ViewCollection.vala"
						_tmp26_ = _g_object_ref0 (_tmp25_);
#line 391 "../src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 391 "../src/core/ViewCollection.vala"
						created_view = _tmp26_;
#line 1862 "ViewCollection.c"
					} else {
						GeeArrayList* _tmp27_;
						GeeArrayList* _tmp28_;
						DataView* _tmp29_;
						GeeArrayList* _tmp30_;
						DataView* _tmp31_;
#line 393 "../src/core/ViewCollection.vala"
						_tmp27_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 393 "../src/core/ViewCollection.vala"
						_g_object_unref0 (created_views);
#line 393 "../src/core/ViewCollection.vala"
						created_views = _tmp27_;
#line 394 "../src/core/ViewCollection.vala"
						_tmp28_ = created_views;
#line 394 "../src/core/ViewCollection.vala"
						_tmp29_ = created_view;
#line 394 "../src/core/ViewCollection.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 395 "../src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 395 "../src/core/ViewCollection.vala"
						created_view = NULL;
#line 396 "../src/core/ViewCollection.vala"
						_tmp30_ = created_views;
#line 396 "../src/core/ViewCollection.vala"
						_tmp31_ = new_view;
#line 396 "../src/core/ViewCollection.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 1891 "ViewCollection.c"
					}
				}
#line 383 "../src/core/ViewCollection.vala"
				_g_object_unref0 (new_view);
#line 1896 "ViewCollection.c"
			}
#line 373 "../src/core/ViewCollection.vala"
			(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 373 "../src/core/ViewCollection.vala"
			factory = NULL;
#line 373 "../src/core/ViewCollection.vala"
			factory_target = NULL;
#line 373 "../src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 373 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1908 "ViewCollection.c"
		}
#line 373 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 1912 "ViewCollection.c"
	}
#line 401 "../src/core/ViewCollection.vala"
	_tmp32_ = created_view;
#line 401 "../src/core/ViewCollection.vala"
	if (_tmp32_ != NULL) {
#line 1918 "ViewCollection.c"
		DataView* _tmp33_;
#line 402 "../src/core/ViewCollection.vala"
		_tmp33_ = created_view;
#line 402 "../src/core/ViewCollection.vala"
		data_collection_add ((DataCollection*) self, (DataObject*) _tmp33_);
#line 1924 "ViewCollection.c"
	} else {
		gboolean _tmp34_ = FALSE;
		GeeArrayList* _tmp35_;
#line 403 "../src/core/ViewCollection.vala"
		_tmp35_ = created_views;
#line 403 "../src/core/ViewCollection.vala"
		if (_tmp35_ != NULL) {
#line 1932 "ViewCollection.c"
			GeeArrayList* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
#line 403 "../src/core/ViewCollection.vala"
			_tmp36_ = created_views;
#line 403 "../src/core/ViewCollection.vala"
			_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 403 "../src/core/ViewCollection.vala"
			_tmp38_ = _tmp37_;
#line 403 "../src/core/ViewCollection.vala"
			_tmp34_ = _tmp38_ > 0;
#line 1944 "ViewCollection.c"
		} else {
#line 403 "../src/core/ViewCollection.vala"
			_tmp34_ = FALSE;
#line 1948 "ViewCollection.c"
		}
#line 403 "../src/core/ViewCollection.vala"
		if (_tmp34_) {
#line 1952 "ViewCollection.c"
			GeeArrayList* _tmp39_;
			GeeCollection* _tmp40_;
			GeeCollection* _tmp41_;
#line 404 "../src/core/ViewCollection.vala"
			_tmp39_ = created_views;
#line 404 "../src/core/ViewCollection.vala"
			_tmp40_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp39_, progress_monitor, progress_monitor_target);
#line 404 "../src/core/ViewCollection.vala"
			_tmp41_ = _tmp40_;
#line 404 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp41_);
#line 1964 "ViewCollection.c"
		}
	}
#line 367 "../src/core/ViewCollection.vala"
	_g_object_unref0 (created_views);
#line 367 "../src/core/ViewCollection.vala"
	_g_object_unref0 (created_view);
#line 1971 "ViewCollection.c"
}

static gboolean
view_collection_real_add (DataCollection* base,
                          DataObject* object)
{
	ViewCollection * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean result;
#line 407 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 407 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 408 "../src/core/ViewCollection.vala"
	data_view_internal_set_visible (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView), TRUE);
#line 410 "../src/core/ViewCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->add (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object)) {
#line 411 "../src/core/ViewCollection.vala"
		result = FALSE;
#line 411 "../src/core/ViewCollection.vala"
		return result;
#line 1994 "ViewCollection.c"
	}
#line 413 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_get_singleton (object);
#line 413 "../src/core/ViewCollection.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 413 "../src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp1_);
#line 413 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 415 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 415 "../src/core/ViewCollection.vala"
	return result;
#line 2008 "ViewCollection.c"
}

static GeeCollection*
view_collection_real_add_many (DataCollection* base,
                               GeeCollection* objects,
                               ProgressMonitor monitor,
                               gpointer monitor_target)
{
	ViewCollection * self;
	GeeCollection* return_list = NULL;
	GeeCollection* _tmp5_;
	GeeCollection* result;
#line 418 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 418 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (objects != NULL, NULL);
#line 2025 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 420 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) objects);
#line 420 "../src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 420 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2035 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataObject* _tmp4_;
#line 420 "../src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 420 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 420 "../src/core/ViewCollection.vala"
				break;
#line 2047 "ViewCollection.c"
			}
#line 420 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 420 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 420 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 421 "../src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 421 "../src/core/ViewCollection.vala"
			data_view_internal_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView), TRUE);
#line 420 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2061 "ViewCollection.c"
		}
#line 420 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2065 "ViewCollection.c"
	}
#line 423 "../src/core/ViewCollection.vala"
	_tmp5_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), objects, monitor, monitor_target);
#line 423 "../src/core/ViewCollection.vala"
	return_list = _tmp5_;
#line 425 "../src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, G_TYPE_CHECK_INSTANCE_CAST (return_list, GEE_TYPE_COLLECTION, GeeCollection));
#line 427 "../src/core/ViewCollection.vala"
	result = return_list;
#line 427 "../src/core/ViewCollection.vala"
	return result;
#line 2077 "ViewCollection.c"
}

static void
view_collection_on_sources_removed (ViewCollection* self,
                                    GeeIterable* removed)
{
	Marker* marker = NULL;
	gboolean _tmp12_ = FALSE;
	Marker* _tmp13_;
#line 430 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/core/ViewCollection.vala"
	g_return_if_fail (removed != NULL);
#line 432 "../src/core/ViewCollection.vala"
	marker = NULL;
#line 2093 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 433 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (removed);
#line 433 "../src/core/ViewCollection.vala"
		_source_it = _tmp0_;
#line 433 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2103 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			GeeHashMap* _tmp4_;
			DataSource* _tmp5_;
			gpointer _tmp6_;
			DataView* _tmp7_;
#line 433 "../src/core/ViewCollection.vala"
			_tmp1_ = _source_it;
#line 433 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 433 "../src/core/ViewCollection.vala"
				break;
#line 2119 "ViewCollection.c"
			}
#line 433 "../src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 433 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 433 "../src/core/ViewCollection.vala"
			source = (DataSource*) _tmp3_;
#line 434 "../src/core/ViewCollection.vala"
			_tmp4_ = self->priv->source_map;
#line 434 "../src/core/ViewCollection.vala"
			_tmp5_ = source;
#line 434 "../src/core/ViewCollection.vala"
			_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
#line 434 "../src/core/ViewCollection.vala"
			view = (DataView*) _tmp6_;
#line 437 "../src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 437 "../src/core/ViewCollection.vala"
			if (_tmp7_ != NULL) {
#line 2139 "ViewCollection.c"
				Marker* _tmp8_;
				Marker* _tmp10_;
				DataView* _tmp11_;
#line 438 "../src/core/ViewCollection.vala"
				_tmp8_ = marker;
#line 438 "../src/core/ViewCollection.vala"
				if (_tmp8_ == NULL) {
#line 2147 "ViewCollection.c"
					Marker* _tmp9_;
#line 439 "../src/core/ViewCollection.vala"
					_tmp9_ = data_collection_start_marking ((DataCollection*) self);
#line 439 "../src/core/ViewCollection.vala"
					_g_object_unref0 (marker);
#line 439 "../src/core/ViewCollection.vala"
					marker = _tmp9_;
#line 2155 "ViewCollection.c"
				}
#line 441 "../src/core/ViewCollection.vala"
				_tmp10_ = marker;
#line 441 "../src/core/ViewCollection.vala"
				_tmp11_ = view;
#line 441 "../src/core/ViewCollection.vala"
				marker_mark (_tmp10_, (DataObject*) _tmp11_);
#line 2163 "ViewCollection.c"
			}
#line 433 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 433 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 2169 "ViewCollection.c"
		}
#line 433 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 2173 "ViewCollection.c"
	}
#line 445 "../src/core/ViewCollection.vala"
	_tmp13_ = marker;
#line 445 "../src/core/ViewCollection.vala"
	if (_tmp13_ != NULL) {
#line 2179 "ViewCollection.c"
		Marker* _tmp14_;
#line 445 "../src/core/ViewCollection.vala"
		_tmp14_ = marker;
#line 445 "../src/core/ViewCollection.vala"
		_tmp12_ = marker_get_count (_tmp14_) != 0;
#line 2185 "ViewCollection.c"
	} else {
#line 445 "../src/core/ViewCollection.vala"
		_tmp12_ = FALSE;
#line 2189 "ViewCollection.c"
	}
#line 445 "../src/core/ViewCollection.vala"
	if (_tmp12_) {
#line 2193 "ViewCollection.c"
		Marker* _tmp15_;
#line 446 "../src/core/ViewCollection.vala"
		_tmp15_ = marker;
#line 446 "../src/core/ViewCollection.vala"
		data_collection_remove_marked ((DataCollection*) self, _tmp15_);
#line 2199 "ViewCollection.c"
	}
#line 430 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 2203 "ViewCollection.c"
}

static void
view_collection_on_sources_altered (ViewCollection* self,
                                    DataCollection* collection,
                                    GeeMap* items)
{
	GeeArrayList* to_add = NULL;
	GeeArrayList* to_remove = NULL;
	gboolean ordering_changed = FALSE;
	GeeArrayList* _tmp68_;
	GeeArrayList* _tmp72_;
#line 449 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/core/ViewCollection.vala"
	g_return_if_fail (collection != NULL);
#line 449 "../src/core/ViewCollection.vala"
	g_return_if_fail (items != NULL);
#line 452 "../src/core/ViewCollection.vala"
	to_add = NULL;
#line 453 "../src/core/ViewCollection.vala"
	to_remove = NULL;
#line 454 "../src/core/ViewCollection.vala"
	ordering_changed = FALSE;
#line 2228 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 455 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 455 "../src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 455 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 455 "../src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 455 "../src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 455 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 455 "../src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 455 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2252 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			DataSource* source = NULL;
			DataObject* _tmp10_;
			DataSource* _tmp11_;
			ViewCollectionMonitorImpl* monitor = NULL;
			gboolean ignored = FALSE;
			gboolean _tmp32_ = FALSE;
			ViewCollectionMonitorImpl* _tmp33_;
#line 455 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 455 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 455 "../src/core/ViewCollection.vala"
				break;
#line 2273 "ViewCollection.c"
			}
#line 455 "../src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 455 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 455 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 456 "../src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 456 "../src/core/ViewCollection.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 456 "../src/core/ViewCollection.vala"
			alteration = (Alteration*) _tmp9_;
#line 457 "../src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 457 "../src/core/ViewCollection.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_SOURCE, DataSource));
#line 457 "../src/core/ViewCollection.vala"
			source = _tmp11_;
#line 459 "../src/core/ViewCollection.vala"
			monitor = NULL;
#line 460 "../src/core/ViewCollection.vala"
			ignored = TRUE;
#line 2297 "ViewCollection.c"
			{
				GeeIterator* _monitor_impl_it = NULL;
				GeeHashMultiMap* _tmp12_;
				GeeCollection* _tmp13_;
				GeeCollection* _tmp14_;
				GeeIterator* _tmp15_;
				GeeIterator* _tmp16_;
#line 461 "../src/core/ViewCollection.vala"
				_tmp12_ = self->priv->monitors;
#line 461 "../src/core/ViewCollection.vala"
				_tmp13_ = gee_multi_map_get ((GeeMultiMap*) _tmp12_, G_TYPE_CHECK_INSTANCE_CAST (collection, TYPE_SOURCE_COLLECTION, SourceCollection));
#line 461 "../src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 461 "../src/core/ViewCollection.vala"
				_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 461 "../src/core/ViewCollection.vala"
				_tmp16_ = _tmp15_;
#line 461 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 461 "../src/core/ViewCollection.vala"
				_monitor_impl_it = _tmp16_;
#line 461 "../src/core/ViewCollection.vala"
				while (TRUE) {
#line 2321 "ViewCollection.c"
					GeeIterator* _tmp17_;
					ViewCollectionMonitorImpl* monitor_impl = NULL;
					GeeIterator* _tmp18_;
					gpointer _tmp19_;
					gboolean _tmp20_ = FALSE;
					ViewCollectionMonitorImpl* _tmp21_;
					Alteration* _tmp22_;
					ViewCollectionMonitorImpl* _tmp26_;
					ViewManager* _tmp27_;
					DataSource* _tmp28_;
#line 461 "../src/core/ViewCollection.vala"
					_tmp17_ = _monitor_impl_it;
#line 461 "../src/core/ViewCollection.vala"
					if (!gee_iterator_next (_tmp17_)) {
#line 461 "../src/core/ViewCollection.vala"
						break;
#line 2338 "ViewCollection.c"
					}
#line 461 "../src/core/ViewCollection.vala"
					_tmp18_ = _monitor_impl_it;
#line 461 "../src/core/ViewCollection.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 461 "../src/core/ViewCollection.vala"
					monitor_impl = (ViewCollectionMonitorImpl*) _tmp19_;
#line 462 "../src/core/ViewCollection.vala"
					_tmp21_ = monitor_impl;
#line 462 "../src/core/ViewCollection.vala"
					_tmp22_ = _tmp21_->prereq;
#line 462 "../src/core/ViewCollection.vala"
					if (_tmp22_ != NULL) {
#line 2352 "ViewCollection.c"
						Alteration* _tmp23_;
						ViewCollectionMonitorImpl* _tmp24_;
						Alteration* _tmp25_;
#line 462 "../src/core/ViewCollection.vala"
						_tmp23_ = alteration;
#line 462 "../src/core/ViewCollection.vala"
						_tmp24_ = monitor_impl;
#line 462 "../src/core/ViewCollection.vala"
						_tmp25_ = _tmp24_->prereq;
#line 462 "../src/core/ViewCollection.vala"
						_tmp20_ = !alteration_contains_any (_tmp23_, _tmp25_);
#line 2364 "ViewCollection.c"
					} else {
#line 462 "../src/core/ViewCollection.vala"
						_tmp20_ = FALSE;
#line 2368 "ViewCollection.c"
					}
#line 462 "../src/core/ViewCollection.vala"
					if (_tmp20_) {
#line 463 "../src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 463 "../src/core/ViewCollection.vala"
						continue;
#line 2376 "ViewCollection.c"
					}
#line 465 "../src/core/ViewCollection.vala"
					ignored = FALSE;
#line 467 "../src/core/ViewCollection.vala"
					_tmp26_ = monitor_impl;
#line 467 "../src/core/ViewCollection.vala"
					_tmp27_ = _tmp26_->manager;
#line 467 "../src/core/ViewCollection.vala"
					_tmp28_ = source;
#line 467 "../src/core/ViewCollection.vala"
					if (view_manager_include_in_view (_tmp27_, _tmp28_)) {
#line 2388 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp29_;
						ViewCollectionMonitorImpl* _tmp30_;
#line 468 "../src/core/ViewCollection.vala"
						_tmp29_ = monitor_impl;
#line 468 "../src/core/ViewCollection.vala"
						_tmp30_ = _view_collection_monitor_ref0 (_tmp29_);
#line 468 "../src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 468 "../src/core/ViewCollection.vala"
						monitor = _tmp30_;
#line 470 "../src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 470 "../src/core/ViewCollection.vala"
						break;
#line 2403 "ViewCollection.c"
					}
#line 461 "../src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor_impl);
#line 2407 "ViewCollection.c"
				}
#line 461 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_impl_it);
#line 2411 "ViewCollection.c"
			}
#line 474 "../src/core/ViewCollection.vala"
			if (ignored) {
#line 2415 "ViewCollection.c"
				ViewCollectionMonitorImpl* _tmp31_;
#line 475 "../src/core/ViewCollection.vala"
				_tmp31_ = monitor;
#line 475 "../src/core/ViewCollection.vala"
				_vala_assert (_tmp31_ == NULL, "monitor == null");
#line 477 "../src/core/ViewCollection.vala"
				_view_collection_monitor_unref0 (monitor);
#line 477 "../src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 477 "../src/core/ViewCollection.vala"
				_alteration_unref0 (alteration);
#line 477 "../src/core/ViewCollection.vala"
				_g_object_unref0 (object);
#line 477 "../src/core/ViewCollection.vala"
				continue;
#line 2431 "ViewCollection.c"
			}
#line 480 "../src/core/ViewCollection.vala"
			_tmp33_ = monitor;
#line 480 "../src/core/ViewCollection.vala"
			if (_tmp33_ != NULL) {
#line 2437 "ViewCollection.c"
				DataSource* _tmp34_;
#line 480 "../src/core/ViewCollection.vala"
				_tmp34_ = source;
#line 480 "../src/core/ViewCollection.vala"
				_tmp32_ = !view_collection_has_view_for_source (self, _tmp34_);
#line 2443 "ViewCollection.c"
			} else {
#line 480 "../src/core/ViewCollection.vala"
				_tmp32_ = FALSE;
#line 2447 "ViewCollection.c"
			}
#line 480 "../src/core/ViewCollection.vala"
			if (_tmp32_) {
#line 2451 "ViewCollection.c"
				GeeArrayList* _tmp35_;
				GeeArrayList* _tmp37_;
				ViewCollectionMonitorImpl* _tmp38_;
				ViewManager* _tmp39_;
				DataSource* _tmp40_;
				DataView* _tmp41_;
				DataView* _tmp42_;
#line 481 "../src/core/ViewCollection.vala"
				_tmp35_ = to_add;
#line 481 "../src/core/ViewCollection.vala"
				if (_tmp35_ == NULL) {
#line 2463 "ViewCollection.c"
					GeeArrayList* _tmp36_;
#line 482 "../src/core/ViewCollection.vala"
					_tmp36_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 482 "../src/core/ViewCollection.vala"
					_g_object_unref0 (to_add);
#line 482 "../src/core/ViewCollection.vala"
					to_add = _tmp36_;
#line 2471 "ViewCollection.c"
				}
#line 484 "../src/core/ViewCollection.vala"
				_tmp37_ = to_add;
#line 484 "../src/core/ViewCollection.vala"
				_tmp38_ = monitor;
#line 484 "../src/core/ViewCollection.vala"
				_tmp39_ = _tmp38_->manager;
#line 484 "../src/core/ViewCollection.vala"
				_tmp40_ = source;
#line 484 "../src/core/ViewCollection.vala"
				_tmp41_ = view_manager_create_view (_tmp39_, _tmp40_);
#line 484 "../src/core/ViewCollection.vala"
				_tmp42_ = _tmp41_;
#line 484 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp37_, _tmp42_);
#line 484 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp42_);
#line 2489 "ViewCollection.c"
			} else {
				gboolean _tmp43_ = FALSE;
				ViewCollectionMonitorImpl* _tmp44_;
#line 485 "../src/core/ViewCollection.vala"
				_tmp44_ = monitor;
#line 485 "../src/core/ViewCollection.vala"
				if (_tmp44_ == NULL) {
#line 2497 "ViewCollection.c"
					DataSource* _tmp45_;
#line 485 "../src/core/ViewCollection.vala"
					_tmp45_ = source;
#line 485 "../src/core/ViewCollection.vala"
					_tmp43_ = view_collection_has_view_for_source (self, _tmp45_);
#line 2503 "ViewCollection.c"
				} else {
#line 485 "../src/core/ViewCollection.vala"
					_tmp43_ = FALSE;
#line 2507 "ViewCollection.c"
				}
#line 485 "../src/core/ViewCollection.vala"
				if (_tmp43_) {
#line 2511 "ViewCollection.c"
					GeeArrayList* _tmp46_;
					GeeArrayList* _tmp48_;
					DataSource* _tmp49_;
					DataView* _tmp50_;
					DataView* _tmp51_;
#line 486 "../src/core/ViewCollection.vala"
					_tmp46_ = to_remove;
#line 486 "../src/core/ViewCollection.vala"
					if (_tmp46_ == NULL) {
#line 2521 "ViewCollection.c"
						GeeArrayList* _tmp47_;
#line 487 "../src/core/ViewCollection.vala"
						_tmp47_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 487 "../src/core/ViewCollection.vala"
						_g_object_unref0 (to_remove);
#line 487 "../src/core/ViewCollection.vala"
						to_remove = _tmp47_;
#line 2529 "ViewCollection.c"
					}
#line 489 "../src/core/ViewCollection.vala"
					_tmp48_ = to_remove;
#line 489 "../src/core/ViewCollection.vala"
					_tmp49_ = source;
#line 489 "../src/core/ViewCollection.vala"
					_tmp50_ = view_collection_get_view_for_source (self, _tmp49_);
#line 489 "../src/core/ViewCollection.vala"
					_tmp51_ = _tmp50_;
#line 489 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp48_, _tmp51_);
#line 489 "../src/core/ViewCollection.vala"
					_g_object_unref0 (_tmp51_);
#line 2543 "ViewCollection.c"
				} else {
					gboolean _tmp52_ = FALSE;
					ViewCollectionMonitorImpl* _tmp53_;
#line 490 "../src/core/ViewCollection.vala"
					_tmp53_ = monitor;
#line 490 "../src/core/ViewCollection.vala"
					if (_tmp53_ != NULL) {
#line 2551 "ViewCollection.c"
						DataSource* _tmp54_;
#line 490 "../src/core/ViewCollection.vala"
						_tmp54_ = source;
#line 490 "../src/core/ViewCollection.vala"
						_tmp52_ = view_collection_has_view_for_source (self, _tmp54_);
#line 2557 "ViewCollection.c"
					} else {
#line 490 "../src/core/ViewCollection.vala"
						_tmp52_ = FALSE;
#line 2561 "ViewCollection.c"
					}
#line 490 "../src/core/ViewCollection.vala"
					if (_tmp52_) {
#line 2565 "ViewCollection.c"
						DataView* view = NULL;
						DataSource* _tmp55_;
						DataView* _tmp56_;
						DataSet* _tmp57_;
						DataView* _tmp58_;
						gboolean _tmp62_ = FALSE;
						DataSet* _tmp63_;
#line 491 "../src/core/ViewCollection.vala"
						_tmp55_ = source;
#line 491 "../src/core/ViewCollection.vala"
						_tmp56_ = view_collection_get_view_for_source (self, _tmp55_);
#line 491 "../src/core/ViewCollection.vala"
						view = _tmp56_;
#line 493 "../src/core/ViewCollection.vala"
						_tmp57_ = self->priv->selected;
#line 493 "../src/core/ViewCollection.vala"
						_tmp58_ = view;
#line 493 "../src/core/ViewCollection.vala"
						if (data_set_contains (_tmp57_, (DataObject*) _tmp58_)) {
#line 2585 "ViewCollection.c"
							DataSet* _tmp59_;
							DataView* _tmp60_;
							Alteration* _tmp61_;
#line 494 "../src/core/ViewCollection.vala"
							_tmp59_ = self->priv->selected;
#line 494 "../src/core/ViewCollection.vala"
							_tmp60_ = view;
#line 494 "../src/core/ViewCollection.vala"
							_tmp61_ = alteration;
#line 494 "../src/core/ViewCollection.vala"
							data_set_resort_object (_tmp59_, (DataObject*) _tmp60_, _tmp61_);
#line 2597 "ViewCollection.c"
						}
#line 496 "../src/core/ViewCollection.vala"
						_tmp63_ = self->priv->visible;
#line 496 "../src/core/ViewCollection.vala"
						if (_tmp63_ != NULL) {
#line 2603 "ViewCollection.c"
							DataView* _tmp64_;
#line 496 "../src/core/ViewCollection.vala"
							_tmp64_ = view;
#line 496 "../src/core/ViewCollection.vala"
							_tmp62_ = view_collection_is_visible (self, _tmp64_);
#line 2609 "ViewCollection.c"
						} else {
#line 496 "../src/core/ViewCollection.vala"
							_tmp62_ = FALSE;
#line 2613 "ViewCollection.c"
						}
#line 496 "../src/core/ViewCollection.vala"
						if (_tmp62_) {
#line 2617 "ViewCollection.c"
							DataSet* _tmp65_;
							DataView* _tmp66_;
							Alteration* _tmp67_;
#line 497 "../src/core/ViewCollection.vala"
							_tmp65_ = self->priv->visible;
#line 497 "../src/core/ViewCollection.vala"
							_tmp66_ = view;
#line 497 "../src/core/ViewCollection.vala"
							_tmp67_ = alteration;
#line 497 "../src/core/ViewCollection.vala"
							if (data_set_resort_object (_tmp65_, (DataObject*) _tmp66_, _tmp67_)) {
#line 498 "../src/core/ViewCollection.vala"
								ordering_changed = TRUE;
#line 2631 "ViewCollection.c"
							}
						}
#line 490 "../src/core/ViewCollection.vala"
						_g_object_unref0 (view);
#line 2636 "ViewCollection.c"
					}
				}
			}
#line 455 "../src/core/ViewCollection.vala"
			_view_collection_monitor_unref0 (monitor);
#line 455 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 455 "../src/core/ViewCollection.vala"
			_alteration_unref0 (alteration);
#line 455 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2648 "ViewCollection.c"
		}
#line 455 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2652 "ViewCollection.c"
	}
#line 503 "../src/core/ViewCollection.vala"
	_tmp68_ = to_add;
#line 503 "../src/core/ViewCollection.vala"
	if (_tmp68_ != NULL) {
#line 2658 "ViewCollection.c"
		GeeArrayList* _tmp69_;
		GeeCollection* _tmp70_;
		GeeCollection* _tmp71_;
#line 504 "../src/core/ViewCollection.vala"
		_tmp69_ = to_add;
#line 504 "../src/core/ViewCollection.vala"
		_tmp70_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp69_, NULL, NULL);
#line 504 "../src/core/ViewCollection.vala"
		_tmp71_ = _tmp70_;
#line 504 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp71_);
#line 2670 "ViewCollection.c"
	}
#line 506 "../src/core/ViewCollection.vala"
	_tmp72_ = to_remove;
#line 506 "../src/core/ViewCollection.vala"
	if (_tmp72_ != NULL) {
#line 2676 "ViewCollection.c"
		GeeArrayList* _tmp73_;
		Marker* _tmp74_;
		Marker* _tmp75_;
#line 507 "../src/core/ViewCollection.vala"
		_tmp73_ = to_remove;
#line 507 "../src/core/ViewCollection.vala"
		_tmp74_ = data_collection_mark_many ((DataCollection*) self, (GeeCollection*) _tmp73_);
#line 507 "../src/core/ViewCollection.vala"
		_tmp75_ = _tmp74_;
#line 507 "../src/core/ViewCollection.vala"
		data_collection_remove_marked ((DataCollection*) self, _tmp75_);
#line 507 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp75_);
#line 2690 "ViewCollection.c"
	}
#line 509 "../src/core/ViewCollection.vala"
	if (ordering_changed) {
#line 510 "../src/core/ViewCollection.vala"
		data_collection_notify_ordering_changed ((DataCollection*) self);
#line 2696 "ViewCollection.c"
	}
#line 449 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_remove);
#line 449 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 2702 "ViewCollection.c"
}

static void
view_collection_on_mirror_contents_added (ViewCollection* self,
                                          GeeIterable* added)
{
	GeeArrayList* to_add = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
#line 513 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 513 "../src/core/ViewCollection.vala"
	g_return_if_fail (added != NULL);
#line 514 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 514 "../src/core/ViewCollection.vala"
	to_add = _tmp0_;
#line 2722 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp1_;
#line 515 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (added);
#line 515 "../src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 515 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2732 "ViewCollection.c"
			GeeIterator* _tmp2_;
			DataObject* object = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataSource* source = NULL;
			DataObject* _tmp5_;
			DataSource* _tmp6_;
			DataSource* _tmp7_;
			DataSource* _tmp8_;
			gboolean _tmp9_ = FALSE;
			CreateViewPredicate _tmp10_;
			gpointer _tmp10__target;
#line 515 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 515 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 515 "../src/core/ViewCollection.vala"
				break;
#line 2751 "ViewCollection.c"
			}
#line 515 "../src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 515 "../src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 515 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp4_;
#line 516 "../src/core/ViewCollection.vala"
			_tmp5_ = object;
#line 516 "../src/core/ViewCollection.vala"
			_tmp6_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_VIEW, DataView));
#line 516 "../src/core/ViewCollection.vala"
			_tmp7_ = _tmp6_;
#line 516 "../src/core/ViewCollection.vala"
			_tmp8_ = _g_object_ref0 (_tmp7_);
#line 516 "../src/core/ViewCollection.vala"
			source = _tmp8_;
#line 518 "../src/core/ViewCollection.vala"
			_tmp10_ = self->priv->should_mirror;
#line 518 "../src/core/ViewCollection.vala"
			_tmp10__target = self->priv->should_mirror_target;
#line 518 "../src/core/ViewCollection.vala"
			if (_tmp10_ == NULL) {
#line 518 "../src/core/ViewCollection.vala"
				_tmp9_ = TRUE;
#line 2777 "ViewCollection.c"
			} else {
				CreateViewPredicate _tmp11_;
				gpointer _tmp11__target;
				DataSource* _tmp12_;
#line 518 "../src/core/ViewCollection.vala"
				_tmp11_ = self->priv->should_mirror;
#line 518 "../src/core/ViewCollection.vala"
				_tmp11__target = self->priv->should_mirror_target;
#line 518 "../src/core/ViewCollection.vala"
				_tmp12_ = source;
#line 518 "../src/core/ViewCollection.vala"
				_tmp9_ = _tmp11_ (_tmp12_, _tmp11__target);
#line 2790 "ViewCollection.c"
			}
#line 518 "../src/core/ViewCollection.vala"
			if (_tmp9_) {
#line 2794 "ViewCollection.c"
				GeeArrayList* _tmp13_;
				CreateView _tmp14_;
				gpointer _tmp14__target;
				DataSource* _tmp15_;
				DataView* _tmp16_;
				DataView* _tmp17_;
#line 519 "../src/core/ViewCollection.vala"
				_tmp13_ = to_add;
#line 519 "../src/core/ViewCollection.vala"
				_tmp14_ = self->priv->mirroring_ctor;
#line 519 "../src/core/ViewCollection.vala"
				_tmp14__target = self->priv->mirroring_ctor_target;
#line 519 "../src/core/ViewCollection.vala"
				_tmp15_ = source;
#line 519 "../src/core/ViewCollection.vala"
				_tmp16_ = _tmp14_ (_tmp15_, _tmp14__target);
#line 519 "../src/core/ViewCollection.vala"
				_tmp17_ = _tmp16_;
#line 519 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp17_);
#line 519 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp17_);
#line 2817 "ViewCollection.c"
			}
#line 515 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 515 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2823 "ViewCollection.c"
		}
#line 515 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2827 "ViewCollection.c"
	}
#line 522 "../src/core/ViewCollection.vala"
	_tmp18_ = to_add;
#line 522 "../src/core/ViewCollection.vala"
	_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 522 "../src/core/ViewCollection.vala"
	_tmp20_ = _tmp19_;
#line 522 "../src/core/ViewCollection.vala"
	if (_tmp20_ > 0) {
#line 2837 "ViewCollection.c"
		GeeArrayList* _tmp21_;
		GeeCollection* _tmp22_;
		GeeCollection* _tmp23_;
#line 523 "../src/core/ViewCollection.vala"
		_tmp21_ = to_add;
#line 523 "../src/core/ViewCollection.vala"
		_tmp22_ = data_collection_add_many ((DataCollection*) self, (GeeCollection*) _tmp21_, NULL, NULL);
#line 523 "../src/core/ViewCollection.vala"
		_tmp23_ = _tmp22_;
#line 523 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp23_);
#line 2849 "ViewCollection.c"
	}
#line 513 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 2853 "ViewCollection.c"
}

static void
view_collection_on_mirror_contents_removed (ViewCollection* self,
                                            GeeIterable* removed)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
	Marker* _tmp14_;
#line 526 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 526 "../src/core/ViewCollection.vala"
	g_return_if_fail (removed != NULL);
#line 527 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking ((DataCollection*) self);
#line 527 "../src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 2871 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp1_;
#line 528 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (removed);
#line 528 "../src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 528 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2881 "ViewCollection.c"
			GeeIterator* _tmp2_;
			DataObject* object = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataView* view = NULL;
			DataObject* _tmp5_;
			DataView* _tmp6_;
			DataView* our_view = NULL;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			DataView* _tmp10_;
			DataView* _tmp11_;
			Marker* _tmp12_;
			DataView* _tmp13_;
#line 528 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 528 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 528 "../src/core/ViewCollection.vala"
				break;
#line 2903 "ViewCollection.c"
			}
#line 528 "../src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 528 "../src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 528 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp4_;
#line 529 "../src/core/ViewCollection.vala"
			_tmp5_ = object;
#line 529 "../src/core/ViewCollection.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_VIEW, DataView));
#line 529 "../src/core/ViewCollection.vala"
			view = _tmp6_;
#line 531 "../src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 531 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 531 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 531 "../src/core/ViewCollection.vala"
			_tmp10_ = view_collection_get_view_for_source (self, _tmp9_);
#line 531 "../src/core/ViewCollection.vala"
			our_view = _tmp10_;
#line 532 "../src/core/ViewCollection.vala"
			_tmp11_ = our_view;
#line 532 "../src/core/ViewCollection.vala"
			_vala_assert (_tmp11_ != NULL, "our_view != null");
#line 534 "../src/core/ViewCollection.vala"
			_tmp12_ = marker;
#line 534 "../src/core/ViewCollection.vala"
			_tmp13_ = our_view;
#line 534 "../src/core/ViewCollection.vala"
			marker_mark (_tmp12_, (DataObject*) _tmp13_);
#line 528 "../src/core/ViewCollection.vala"
			_g_object_unref0 (our_view);
#line 528 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 528 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2943 "ViewCollection.c"
		}
#line 528 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2947 "ViewCollection.c"
	}
#line 537 "../src/core/ViewCollection.vala"
	_tmp14_ = marker;
#line 537 "../src/core/ViewCollection.vala"
	data_collection_remove_marked ((DataCollection*) self, _tmp14_);
#line 526 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 2955 "ViewCollection.c"
}

static void
view_collection_real_notify_items_added (DataCollection* base,
                                         GeeIterable* added)
{
	ViewCollection * self;
	GeeArrayList* added_visible = NULL;
	GeeArrayList* added_selected = NULL;
	GeeArrayList* _tmp25_;
	GeeArrayList* _tmp27_;
#line 541 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 541 "../src/core/ViewCollection.vala"
	g_return_if_fail (added != NULL);
#line 542 "../src/core/ViewCollection.vala"
	added_visible = NULL;
#line 543 "../src/core/ViewCollection.vala"
	added_selected = NULL;
#line 2975 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 545 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (added);
#line 545 "../src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 545 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2985 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			DataObject* _tmp4_;
			DataView* _tmp5_;
			GeeHashMap* _tmp6_;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			DataView* _tmp10_;
			gboolean _tmp11_ = FALSE;
			DataView* _tmp12_;
			gboolean _tmp18_ = FALSE;
			DataView* _tmp19_;
#line 545 "../src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 545 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 545 "../src/core/ViewCollection.vala"
				break;
#line 3008 "ViewCollection.c"
			}
#line 545 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 545 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 545 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 546 "../src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 546 "../src/core/ViewCollection.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 546 "../src/core/ViewCollection.vala"
			view = _tmp5_;
#line 547 "../src/core/ViewCollection.vala"
			_tmp6_ = self->priv->source_map;
#line 547 "../src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 547 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 547 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 547 "../src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 547 "../src/core/ViewCollection.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp9_, _tmp10_);
#line 549 "../src/core/ViewCollection.vala"
			_tmp12_ = view;
#line 549 "../src/core/ViewCollection.vala"
			if (data_view_is_selected (_tmp12_)) {
#line 3038 "ViewCollection.c"
				DataView* _tmp13_;
#line 549 "../src/core/ViewCollection.vala"
				_tmp13_ = view;
#line 549 "../src/core/ViewCollection.vala"
				_tmp11_ = data_view_is_visible (_tmp13_);
#line 3044 "ViewCollection.c"
			} else {
#line 549 "../src/core/ViewCollection.vala"
				_tmp11_ = FALSE;
#line 3048 "ViewCollection.c"
			}
#line 549 "../src/core/ViewCollection.vala"
			if (_tmp11_) {
#line 3052 "ViewCollection.c"
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp16_;
				DataView* _tmp17_;
#line 550 "../src/core/ViewCollection.vala"
				_tmp14_ = added_selected;
#line 550 "../src/core/ViewCollection.vala"
				if (_tmp14_ == NULL) {
#line 3060 "ViewCollection.c"
					GeeArrayList* _tmp15_;
#line 551 "../src/core/ViewCollection.vala"
					_tmp15_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 551 "../src/core/ViewCollection.vala"
					_g_object_unref0 (added_selected);
#line 551 "../src/core/ViewCollection.vala"
					added_selected = _tmp15_;
#line 3068 "ViewCollection.c"
				}
#line 553 "../src/core/ViewCollection.vala"
				_tmp16_ = added_selected;
#line 553 "../src/core/ViewCollection.vala"
				_tmp17_ = view;
#line 553 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 3076 "ViewCollection.c"
			}
#line 557 "../src/core/ViewCollection.vala"
			_tmp19_ = view;
#line 557 "../src/core/ViewCollection.vala"
			if (data_view_is_visible (_tmp19_)) {
#line 3082 "ViewCollection.c"
				DataSet* _tmp20_;
#line 557 "../src/core/ViewCollection.vala"
				_tmp20_ = self->priv->visible;
#line 557 "../src/core/ViewCollection.vala"
				_tmp18_ = _tmp20_ != NULL;
#line 3088 "ViewCollection.c"
			} else {
#line 557 "../src/core/ViewCollection.vala"
				_tmp18_ = FALSE;
#line 3092 "ViewCollection.c"
			}
#line 557 "../src/core/ViewCollection.vala"
			if (_tmp18_) {
#line 3096 "ViewCollection.c"
				GeeArrayList* _tmp21_;
				GeeArrayList* _tmp23_;
				DataView* _tmp24_;
#line 558 "../src/core/ViewCollection.vala"
				_tmp21_ = added_visible;
#line 558 "../src/core/ViewCollection.vala"
				if (_tmp21_ == NULL) {
#line 3104 "ViewCollection.c"
					GeeArrayList* _tmp22_;
#line 559 "../src/core/ViewCollection.vala"
					_tmp22_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 559 "../src/core/ViewCollection.vala"
					_g_object_unref0 (added_visible);
#line 559 "../src/core/ViewCollection.vala"
					added_visible = _tmp22_;
#line 3112 "ViewCollection.c"
				}
#line 561 "../src/core/ViewCollection.vala"
				_tmp23_ = added_visible;
#line 561 "../src/core/ViewCollection.vala"
				_tmp24_ = view;
#line 561 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 3120 "ViewCollection.c"
			}
#line 545 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 545 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3126 "ViewCollection.c"
		}
#line 545 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3130 "ViewCollection.c"
	}
#line 565 "../src/core/ViewCollection.vala"
	_tmp25_ = added_visible;
#line 565 "../src/core/ViewCollection.vala"
	if (_tmp25_ != NULL) {
#line 3136 "ViewCollection.c"
		gboolean is_added = FALSE;
		GeeArrayList* _tmp26_;
#line 566 "../src/core/ViewCollection.vala"
		_tmp26_ = added_visible;
#line 566 "../src/core/ViewCollection.vala"
		is_added = view_collection_add_many_visible (self, (GeeCollection*) _tmp26_);
#line 567 "../src/core/ViewCollection.vala"
		_vala_assert (is_added, "is_added");
#line 3145 "ViewCollection.c"
	}
#line 570 "../src/core/ViewCollection.vala"
	_tmp27_ = added_selected;
#line 570 "../src/core/ViewCollection.vala"
	if (_tmp27_ != NULL) {
#line 3151 "ViewCollection.c"
		GeeArrayList* _tmp28_;
		GeeArrayList* _tmp29_;
#line 571 "../src/core/ViewCollection.vala"
		_tmp28_ = added_selected;
#line 571 "../src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, (GeeCollection*) _tmp28_);
#line 572 "../src/core/ViewCollection.vala"
		_tmp29_ = added_selected;
#line 572 "../src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, (GeeCollection*) _tmp29_, NULL);
#line 3162 "ViewCollection.c"
	}
#line 575 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), added);
#line 541 "../src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 541 "../src/core/ViewCollection.vala"
	_g_object_unref0 (added_visible);
#line 3170 "ViewCollection.c"
}

static void
view_collection_real_notify_items_removed (DataCollection* base,
                                           GeeIterable* removed)
{
	ViewCollection * self;
	GeeArrayList* selected_removed = NULL;
	GeeArrayList* _tmp28_;
#line 579 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 579 "../src/core/ViewCollection.vala"
	g_return_if_fail (removed != NULL);
#line 580 "../src/core/ViewCollection.vala"
	selected_removed = NULL;
#line 3186 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 581 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (removed);
#line 581 "../src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 581 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 3196 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			DataObject* _tmp4_;
			DataView* _tmp5_;
			GeeHashMap* _tmp6_;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
#line 581 "../src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 581 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 581 "../src/core/ViewCollection.vala"
				break;
#line 3214 "ViewCollection.c"
			}
#line 581 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 581 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 581 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 582 "../src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 582 "../src/core/ViewCollection.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 582 "../src/core/ViewCollection.vala"
			view = _tmp5_;
#line 588 "../src/core/ViewCollection.vala"
			_tmp6_ = self->priv->source_map;
#line 588 "../src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 588 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 588 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 588 "../src/core/ViewCollection.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, _tmp9_)) {
#line 3238 "ViewCollection.c"
				gboolean is_removed = FALSE;
				GeeHashMap* _tmp10_;
				DataView* _tmp11_;
				DataSource* _tmp12_;
				DataSource* _tmp13_;
				DataView* _tmp14_;
				gboolean _tmp23_ = FALSE;
				DataView* _tmp24_;
#line 589 "../src/core/ViewCollection.vala"
				_tmp10_ = self->priv->source_map;
#line 589 "../src/core/ViewCollection.vala"
				_tmp11_ = view;
#line 589 "../src/core/ViewCollection.vala"
				_tmp12_ = data_view_get_source (_tmp11_);
#line 589 "../src/core/ViewCollection.vala"
				_tmp13_ = _tmp12_;
#line 589 "../src/core/ViewCollection.vala"
				is_removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp10_, _tmp13_, NULL);
#line 590 "../src/core/ViewCollection.vala"
				_vala_assert (is_removed, "is_removed");
#line 592 "../src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 592 "../src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp14_)) {
#line 3263 "ViewCollection.c"
					DataSet* _tmp15_;
					DataView* _tmp16_;
					DataView* _tmp17_;
					DataView* _tmp18_;
#line 594 "../src/core/ViewCollection.vala"
					_tmp15_ = self->priv->selected;
#line 594 "../src/core/ViewCollection.vala"
					_tmp16_ = view;
#line 594 "../src/core/ViewCollection.vala"
					_tmp17_ = view;
#line 594 "../src/core/ViewCollection.vala"
					_vala_assert (data_set_contains (_tmp15_, (DataObject*) _tmp16_) == data_view_is_visible (_tmp17_), "selected.contains (view) == view.is_visible ()");
#line 596 "../src/core/ViewCollection.vala"
					_tmp18_ = view;
#line 596 "../src/core/ViewCollection.vala"
					if (data_view_is_visible (_tmp18_)) {
#line 3280 "ViewCollection.c"
						GeeArrayList* _tmp19_;
						GeeArrayList* _tmp21_;
						DataView* _tmp22_;
#line 597 "../src/core/ViewCollection.vala"
						_tmp19_ = selected_removed;
#line 597 "../src/core/ViewCollection.vala"
						if (_tmp19_ == NULL) {
#line 3288 "ViewCollection.c"
							GeeArrayList* _tmp20_;
#line 598 "../src/core/ViewCollection.vala"
							_tmp20_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 598 "../src/core/ViewCollection.vala"
							_g_object_unref0 (selected_removed);
#line 598 "../src/core/ViewCollection.vala"
							selected_removed = _tmp20_;
#line 3296 "ViewCollection.c"
						}
#line 600 "../src/core/ViewCollection.vala"
						_tmp21_ = selected_removed;
#line 600 "../src/core/ViewCollection.vala"
						_tmp22_ = view;
#line 600 "../src/core/ViewCollection.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 3304 "ViewCollection.c"
					}
				}
#line 604 "../src/core/ViewCollection.vala"
				_tmp24_ = view;
#line 604 "../src/core/ViewCollection.vala"
				if (data_view_is_visible (_tmp24_)) {
#line 3311 "ViewCollection.c"
					DataSet* _tmp25_;
#line 604 "../src/core/ViewCollection.vala"
					_tmp25_ = self->priv->visible;
#line 604 "../src/core/ViewCollection.vala"
					_tmp23_ = _tmp25_ != NULL;
#line 3317 "ViewCollection.c"
				} else {
#line 604 "../src/core/ViewCollection.vala"
					_tmp23_ = FALSE;
#line 3321 "ViewCollection.c"
				}
#line 604 "../src/core/ViewCollection.vala"
				if (_tmp23_) {
#line 3325 "ViewCollection.c"
					DataSet* _tmp26_;
					DataView* _tmp27_;
#line 605 "../src/core/ViewCollection.vala"
					_tmp26_ = self->priv->visible;
#line 605 "../src/core/ViewCollection.vala"
					_tmp27_ = view;
#line 605 "../src/core/ViewCollection.vala"
					is_removed = data_set_remove (_tmp26_, (DataObject*) _tmp27_);
#line 606 "../src/core/ViewCollection.vala"
					_vala_assert (is_removed, "is_removed");
#line 3336 "ViewCollection.c"
				}
			}
#line 581 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 581 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3343 "ViewCollection.c"
		}
#line 581 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3347 "ViewCollection.c"
	}
#line 611 "../src/core/ViewCollection.vala"
	_tmp28_ = selected_removed;
#line 611 "../src/core/ViewCollection.vala"
	if (_tmp28_ != NULL) {
#line 3353 "ViewCollection.c"
		GeeArrayList* _tmp29_;
#line 612 "../src/core/ViewCollection.vala"
		_tmp29_ = selected_removed;
#line 612 "../src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, (GeeCollection*) _tmp29_);
#line 617 "../src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 3361 "ViewCollection.c"
	}
#line 620 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), removed);
#line 579 "../src/core/ViewCollection.vala"
	_g_object_unref0 (selected_removed);
#line 3367 "ViewCollection.c"
}

static void
view_collection_filter_altered_items (ViewCollection* self,
                                      GeeCollection* views)
{
	GeeArrayList* to_show = NULL;
	GeeArrayList* to_hide = NULL;
	GeeArrayList* _tmp15_;
	GeeArrayList* _tmp17_;
#line 623 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 623 "../src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 626 "../src/core/ViewCollection.vala"
	to_show = NULL;
#line 627 "../src/core/ViewCollection.vala"
	to_hide = NULL;
#line 3386 "ViewCollection.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp0_;
#line 632 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) views);
#line 632 "../src/core/ViewCollection.vala"
		_view_it = _tmp0_;
#line 632 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 3396 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataView* view = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* _tmp4_;
#line 632 "../src/core/ViewCollection.vala"
			_tmp1_ = _view_it;
#line 632 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 632 "../src/core/ViewCollection.vala"
				break;
#line 3408 "ViewCollection.c"
			}
#line 632 "../src/core/ViewCollection.vala"
			_tmp2_ = _view_it;
#line 632 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 632 "../src/core/ViewCollection.vala"
			view = (DataView*) _tmp3_;
#line 633 "../src/core/ViewCollection.vala"
			_tmp4_ = view;
#line 633 "../src/core/ViewCollection.vala"
			if (view_collection_is_in_filter (self, _tmp4_)) {
#line 3420 "ViewCollection.c"
				DataView* _tmp5_;
#line 634 "../src/core/ViewCollection.vala"
				_tmp5_ = view;
#line 634 "../src/core/ViewCollection.vala"
				if (!data_view_is_visible (_tmp5_)) {
#line 3426 "ViewCollection.c"
					GeeArrayList* _tmp6_;
					GeeArrayList* _tmp8_;
					DataView* _tmp9_;
#line 635 "../src/core/ViewCollection.vala"
					_tmp6_ = to_show;
#line 635 "../src/core/ViewCollection.vala"
					if (_tmp6_ == NULL) {
#line 3434 "ViewCollection.c"
						GeeArrayList* _tmp7_;
#line 636 "../src/core/ViewCollection.vala"
						_tmp7_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 636 "../src/core/ViewCollection.vala"
						_g_object_unref0 (to_show);
#line 636 "../src/core/ViewCollection.vala"
						to_show = _tmp7_;
#line 3442 "ViewCollection.c"
					}
#line 638 "../src/core/ViewCollection.vala"
					_tmp8_ = to_show;
#line 638 "../src/core/ViewCollection.vala"
					_tmp9_ = view;
#line 638 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 3450 "ViewCollection.c"
				}
			} else {
				DataView* _tmp10_;
#line 641 "../src/core/ViewCollection.vala"
				_tmp10_ = view;
#line 641 "../src/core/ViewCollection.vala"
				if (data_view_is_visible (_tmp10_)) {
#line 3458 "ViewCollection.c"
					GeeArrayList* _tmp11_;
					GeeArrayList* _tmp13_;
					DataView* _tmp14_;
#line 642 "../src/core/ViewCollection.vala"
					_tmp11_ = to_hide;
#line 642 "../src/core/ViewCollection.vala"
					if (_tmp11_ == NULL) {
#line 3466 "ViewCollection.c"
						GeeArrayList* _tmp12_;
#line 643 "../src/core/ViewCollection.vala"
						_tmp12_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 643 "../src/core/ViewCollection.vala"
						_g_object_unref0 (to_hide);
#line 643 "../src/core/ViewCollection.vala"
						to_hide = _tmp12_;
#line 3474 "ViewCollection.c"
					}
#line 645 "../src/core/ViewCollection.vala"
					_tmp13_ = to_hide;
#line 645 "../src/core/ViewCollection.vala"
					_tmp14_ = view;
#line 645 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 3482 "ViewCollection.c"
				}
			}
#line 632 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 3487 "ViewCollection.c"
		}
#line 632 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 3491 "ViewCollection.c"
	}
#line 654 "../src/core/ViewCollection.vala"
	_tmp15_ = to_show;
#line 654 "../src/core/ViewCollection.vala"
	if (_tmp15_ != NULL) {
#line 3497 "ViewCollection.c"
		GeeArrayList* _tmp16_;
#line 655 "../src/core/ViewCollection.vala"
		_tmp16_ = to_show;
#line 655 "../src/core/ViewCollection.vala"
		view_collection_show_items (self, (GeeList*) _tmp16_);
#line 3503 "ViewCollection.c"
	}
#line 657 "../src/core/ViewCollection.vala"
	_tmp17_ = to_hide;
#line 657 "../src/core/ViewCollection.vala"
	if (_tmp17_ != NULL) {
#line 3509 "ViewCollection.c"
		GeeArrayList* _tmp18_;
#line 658 "../src/core/ViewCollection.vala"
		_tmp18_ = to_hide;
#line 658 "../src/core/ViewCollection.vala"
		view_collection_hide_items (self, (GeeList*) _tmp18_);
#line 3515 "ViewCollection.c"
	}
#line 623 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_hide);
#line 623 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_show);
#line 3521 "ViewCollection.c"
}

static void
view_collection_real_items_altered (DataCollection* base,
                                    GeeMap* map)
{
	ViewCollection * self;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeCollection* _tmp2_;
#line 661 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 661 "../src/core/ViewCollection.vala"
	g_return_if_fail (map != NULL);
#line 663 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_map_get_keys (map);
#line 663 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 663 "../src/core/ViewCollection.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 663 "../src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp2_);
#line 663 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp2_);
#line 665 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), map);
#line 3548 "ViewCollection.c"
}

static void
view_collection_real_set_comparator (DataCollection* base,
                                     Comparator comparator,
                                     gpointer comparator_target,
                                     ComparatorPredicate predicate,
                                     gpointer predicate_target)
{
	ViewCollection * self;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
#line 668 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 669 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 669 "../src/core/ViewCollection.vala"
	data_set_set_comparator (_tmp0_, comparator, comparator_target, predicate, predicate_target);
#line 670 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 670 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 3571 "ViewCollection.c"
		DataSet* _tmp2_;
#line 671 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 671 "../src/core/ViewCollection.vala"
		data_set_set_comparator (_tmp2_, comparator, comparator_target, predicate, predicate_target);
#line 3577 "ViewCollection.c"
	}
#line 673 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), comparator, comparator_target, predicate, predicate_target);
#line 3581 "ViewCollection.c"
}

static void
view_collection_real_reset_comparator (DataCollection* base)
{
	ViewCollection * self;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
#line 676 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 677 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 677 "../src/core/ViewCollection.vala"
	data_set_reset_comparator (_tmp0_);
#line 678 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 678 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 3600 "ViewCollection.c"
		DataSet* _tmp2_;
#line 679 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 679 "../src/core/ViewCollection.vala"
		data_set_reset_comparator (_tmp2_);
#line 3606 "ViewCollection.c"
	}
#line 681 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 3610 "ViewCollection.c"
}

static GeeCollection*
view_collection_real_get_all (DataCollection* base)
{
	ViewCollection * self;
	GeeCollection* _tmp0_ = NULL;
	DataSet* _tmp1_;
	GeeCollection* result;
#line 684 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 685 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 685 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 3626 "ViewCollection.c"
		DataSet* _tmp2_;
		GeeList* _tmp3_;
#line 685 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 685 "../src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_all (_tmp2_);
#line 685 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 685 "../src/core/ViewCollection.vala"
		_tmp0_ = (GeeCollection*) _tmp3_;
#line 3637 "ViewCollection.c"
	} else {
		GeeCollection* _tmp4_;
#line 685 "../src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 685 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 685 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 3646 "ViewCollection.c"
	}
#line 685 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 685 "../src/core/ViewCollection.vala"
	return result;
#line 3652 "ViewCollection.c"
}

GeeCollection*
view_collection_get_all_unfiltered (ViewCollection* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* result;
#line 688 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 689 "../src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 689 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 689 "../src/core/ViewCollection.vala"
	return result;
#line 3668 "ViewCollection.c"
}

static gint
view_collection_real_get_count (DataCollection* base)
{
	ViewCollection * self;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
	gint result;
#line 692 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 693 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 693 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 3684 "ViewCollection.c"
		DataSet* _tmp2_;
#line 693 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 693 "../src/core/ViewCollection.vala"
		_tmp0_ = data_set_get_count (_tmp2_);
#line 3690 "ViewCollection.c"
	} else {
#line 693 "../src/core/ViewCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 3694 "ViewCollection.c"
	}
#line 693 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 693 "../src/core/ViewCollection.vala"
	return result;
#line 3700 "ViewCollection.c"
}

gint
view_collection_get_unfiltered_count (ViewCollection* self)
{
	gint result;
#line 696 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 697 "../src/core/ViewCollection.vala"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 697 "../src/core/ViewCollection.vala"
	return result;
#line 3713 "ViewCollection.c"
}

static DataObject*
view_collection_real_get_at (DataCollection* base,
                             gint index)
{
	ViewCollection * self;
	DataObject* _tmp0_ = NULL;
	DataSet* _tmp1_;
	DataObject* result;
#line 700 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 701 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 701 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 3730 "ViewCollection.c"
		DataSet* _tmp2_;
		DataObject* _tmp3_;
#line 701 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 701 "../src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_at (_tmp2_, index);
#line 701 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 701 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp3_;
#line 3741 "ViewCollection.c"
	} else {
		DataObject* _tmp4_;
#line 701 "../src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), index);
#line 701 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 701 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 3750 "ViewCollection.c"
	}
#line 701 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 701 "../src/core/ViewCollection.vala"
	return result;
#line 3756 "ViewCollection.c"
}

static gint
view_collection_real_index_of (DataCollection* base,
                               DataObject* object)
{
	ViewCollection * self;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
	gint result;
#line 704 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 704 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, 0);
#line 705 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 705 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 3775 "ViewCollection.c"
		DataSet* _tmp2_;
#line 705 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 705 "../src/core/ViewCollection.vala"
		_tmp0_ = data_set_index_of (_tmp2_, object);
#line 3781 "ViewCollection.c"
	} else {
#line 705 "../src/core/ViewCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object);
#line 3785 "ViewCollection.c"
	}
#line 705 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 705 "../src/core/ViewCollection.vala"
	return result;
#line 3791 "ViewCollection.c"
}

static gboolean
view_collection_real_contains (DataCollection* base,
                               DataObject* object)
{
	ViewCollection * self;
	gboolean result;
#line 708 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 708 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 711 "../src/core/ViewCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object)) {
#line 712 "../src/core/ViewCollection.vala"
		result = FALSE;
#line 712 "../src/core/ViewCollection.vala"
		return result;
#line 3810 "ViewCollection.c"
	}
#line 715 "../src/core/ViewCollection.vala"
	result = view_collection_is_visible (self, G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 715 "../src/core/ViewCollection.vala"
	return result;
#line 3816 "ViewCollection.c"
}

static DataView*
view_collection_real_get_first (ViewCollection* self)
{
	DataView* _tmp0_ = NULL;
	DataView* result;
#line 719 "../src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) > 0) {
#line 3826 "ViewCollection.c"
		DataObject* _tmp1_;
#line 719 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_at ((DataCollection*) self, 0);
#line 719 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 719 "../src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 3834 "ViewCollection.c"
	} else {
#line 719 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 719 "../src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 3840 "ViewCollection.c"
	}
#line 719 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 719 "../src/core/ViewCollection.vala"
	return result;
#line 3846 "ViewCollection.c"
}

DataView*
view_collection_get_first (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 718 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 718 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 718 "../src/core/ViewCollection.vala"
	if (_klass_->get_first) {
#line 718 "../src/core/ViewCollection.vala"
		return _klass_->get_first (self);
#line 3861 "ViewCollection.c"
	}
#line 718 "../src/core/ViewCollection.vala"
	return NULL;
#line 3865 "ViewCollection.c"
}

/**
     * A helper method for places in the app that need a
     * non-rejected media source (namely Events, when looking to
     * automatically choose a thumbnail).
     *
     * Note: If every view in this collection is rejected, we
     * return the first view; this is intentional.  This prevents
     * pathological events that have nothing but rejected images
     * in them from breaking.
     */
static DataView*
view_collection_real_get_first_unrejected (ViewCollection* self)
{
	DataView* dv = NULL;
	DataView* _tmp0_;
	gint num_views = 0;
	DataView* _tmp11_;
	DataView* result;
#line 734 "../src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) < 1) {
#line 735 "../src/core/ViewCollection.vala"
		result = NULL;
#line 735 "../src/core/ViewCollection.vala"
		return result;
#line 3892 "ViewCollection.c"
	}
#line 738 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_first (self);
#line 738 "../src/core/ViewCollection.vala"
	dv = _tmp0_;
#line 739 "../src/core/ViewCollection.vala"
	num_views = data_collection_get_count ((DataCollection*) self);
#line 741 "../src/core/ViewCollection.vala"
	while (TRUE) {
#line 3902 "ViewCollection.c"
		gboolean _tmp1_ = FALSE;
		DataView* _tmp2_;
		MediaSource* tmp = NULL;
		DataView* _tmp4_;
		DataSource* _tmp5_;
		DataSource* _tmp6_;
		MediaSource* _tmp7_;
		MediaSource* _tmp8_;
#line 741 "../src/core/ViewCollection.vala"
		_tmp2_ = dv;
#line 741 "../src/core/ViewCollection.vala"
		if (_tmp2_ != NULL) {
#line 3915 "ViewCollection.c"
			DataView* _tmp3_;
#line 741 "../src/core/ViewCollection.vala"
			_tmp3_ = dv;
#line 741 "../src/core/ViewCollection.vala"
			_tmp1_ = data_collection_index_of ((DataCollection*) self, (DataObject*) _tmp3_) < (num_views - 1);
#line 3921 "ViewCollection.c"
		} else {
#line 741 "../src/core/ViewCollection.vala"
			_tmp1_ = FALSE;
#line 3925 "ViewCollection.c"
		}
#line 741 "../src/core/ViewCollection.vala"
		if (!_tmp1_) {
#line 741 "../src/core/ViewCollection.vala"
			break;
#line 3931 "ViewCollection.c"
		}
#line 742 "../src/core/ViewCollection.vala"
		_tmp4_ = dv;
#line 742 "../src/core/ViewCollection.vala"
		_tmp5_ = data_view_get_source (_tmp4_);
#line 742 "../src/core/ViewCollection.vala"
		_tmp6_ = _tmp5_;
#line 742 "../src/core/ViewCollection.vala"
		_tmp7_ = _g_object_ref0 (IS_MEDIA_SOURCE (_tmp6_) ? ((MediaSource*) _tmp6_) : NULL);
#line 742 "../src/core/ViewCollection.vala"
		tmp = _tmp7_;
#line 744 "../src/core/ViewCollection.vala"
		_tmp8_ = tmp;
#line 744 "../src/core/ViewCollection.vala"
		if (_tmp8_ != NULL) {
#line 746 "../src/core/ViewCollection.vala"
			result = dv;
#line 746 "../src/core/ViewCollection.vala"
			_g_object_unref0 (tmp);
#line 746 "../src/core/ViewCollection.vala"
			return result;
#line 3953 "ViewCollection.c"
		} else {
			DataView* _tmp9_;
			DataView* _tmp10_;
#line 748 "../src/core/ViewCollection.vala"
			_tmp9_ = dv;
#line 748 "../src/core/ViewCollection.vala"
			_tmp10_ = view_collection_get_next (self, _tmp9_);
#line 748 "../src/core/ViewCollection.vala"
			_g_object_unref0 (dv);
#line 748 "../src/core/ViewCollection.vala"
			dv = _tmp10_;
#line 3965 "ViewCollection.c"
		}
#line 741 "../src/core/ViewCollection.vala"
		_g_object_unref0 (tmp);
#line 3969 "ViewCollection.c"
	}
#line 754 "../src/core/ViewCollection.vala"
	_tmp11_ = view_collection_get_first (self);
#line 754 "../src/core/ViewCollection.vala"
	result = _tmp11_;
#line 754 "../src/core/ViewCollection.vala"
	_g_object_unref0 (dv);
#line 754 "../src/core/ViewCollection.vala"
	return result;
#line 3979 "ViewCollection.c"
}

DataView*
view_collection_get_first_unrejected (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 732 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 732 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 732 "../src/core/ViewCollection.vala"
	if (_klass_->get_first_unrejected) {
#line 732 "../src/core/ViewCollection.vala"
		return _klass_->get_first_unrejected (self);
#line 3994 "ViewCollection.c"
	}
#line 732 "../src/core/ViewCollection.vala"
	return NULL;
#line 3998 "ViewCollection.c"
}

static DataView*
view_collection_real_get_last (ViewCollection* self)
{
	DataView* _tmp0_ = NULL;
	DataView* result;
#line 758 "../src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) > 0) {
#line 4008 "ViewCollection.c"
		DataObject* _tmp1_;
#line 758 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_at ((DataCollection*) self, data_collection_get_count ((DataCollection*) self) - 1);
#line 758 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 758 "../src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 4016 "ViewCollection.c"
	} else {
#line 758 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 758 "../src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 4022 "ViewCollection.c"
	}
#line 758 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 758 "../src/core/ViewCollection.vala"
	return result;
#line 4028 "ViewCollection.c"
}

DataView*
view_collection_get_last (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 757 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 757 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 757 "../src/core/ViewCollection.vala"
	if (_klass_->get_last) {
#line 757 "../src/core/ViewCollection.vala"
		return _klass_->get_last (self);
#line 4043 "ViewCollection.c"
	}
#line 757 "../src/core/ViewCollection.vala"
	return NULL;
#line 4047 "ViewCollection.c"
}

static DataView*
view_collection_real_get_next (ViewCollection* self,
                               DataView* view)
{
	gint index = 0;
	gint _tmp0_;
	DataObject* _tmp1_;
	DataView* result;
#line 761 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 762 "../src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) == 0) {
#line 763 "../src/core/ViewCollection.vala"
		result = NULL;
#line 763 "../src/core/ViewCollection.vala"
		return result;
#line 4066 "ViewCollection.c"
	}
#line 765 "../src/core/ViewCollection.vala"
	index = data_collection_index_of ((DataCollection*) self, (DataObject*) view);
#line 766 "../src/core/ViewCollection.vala"
	if (index < 0) {
#line 767 "../src/core/ViewCollection.vala"
		result = NULL;
#line 767 "../src/core/ViewCollection.vala"
		return result;
#line 4076 "ViewCollection.c"
	}
#line 769 "../src/core/ViewCollection.vala"
	_tmp0_ = index;
#line 769 "../src/core/ViewCollection.vala"
	index = _tmp0_ + 1;
#line 770 "../src/core/ViewCollection.vala"
	if (index >= data_collection_get_count ((DataCollection*) self)) {
#line 771 "../src/core/ViewCollection.vala"
		index = 0;
#line 4086 "ViewCollection.c"
	}
#line 773 "../src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_at ((DataCollection*) self, index);
#line 773 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 773 "../src/core/ViewCollection.vala"
	return result;
#line 4094 "ViewCollection.c"
}

DataView*
view_collection_get_next (ViewCollection* self,
                          DataView* view)
{
	ViewCollectionClass* _klass_;
#line 761 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 761 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 761 "../src/core/ViewCollection.vala"
	if (_klass_->get_next) {
#line 761 "../src/core/ViewCollection.vala"
		return _klass_->get_next (self, view);
#line 4110 "ViewCollection.c"
	}
#line 761 "../src/core/ViewCollection.vala"
	return NULL;
#line 4114 "ViewCollection.c"
}

static DataView*
view_collection_real_get_previous (ViewCollection* self,
                                   DataView* view)
{
	gint index = 0;
	gint _tmp0_;
	DataObject* _tmp1_;
	DataView* result;
#line 776 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 777 "../src/core/ViewCollection.vala"
	if (data_collection_get_count ((DataCollection*) self) == 0) {
#line 778 "../src/core/ViewCollection.vala"
		result = NULL;
#line 778 "../src/core/ViewCollection.vala"
		return result;
#line 4133 "ViewCollection.c"
	}
#line 780 "../src/core/ViewCollection.vala"
	index = data_collection_index_of ((DataCollection*) self, (DataObject*) view);
#line 781 "../src/core/ViewCollection.vala"
	if (index < 0) {
#line 782 "../src/core/ViewCollection.vala"
		result = NULL;
#line 782 "../src/core/ViewCollection.vala"
		return result;
#line 4143 "ViewCollection.c"
	}
#line 784 "../src/core/ViewCollection.vala"
	_tmp0_ = index;
#line 784 "../src/core/ViewCollection.vala"
	index = _tmp0_ - 1;
#line 785 "../src/core/ViewCollection.vala"
	if (index < 0) {
#line 786 "../src/core/ViewCollection.vala"
		index = data_collection_get_count ((DataCollection*) self) - 1;
#line 4153 "ViewCollection.c"
	}
#line 788 "../src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_at ((DataCollection*) self, index);
#line 788 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 788 "../src/core/ViewCollection.vala"
	return result;
#line 4161 "ViewCollection.c"
}

DataView*
view_collection_get_previous (ViewCollection* self,
                              DataView* view)
{
	ViewCollectionClass* _klass_;
#line 776 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 776 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 776 "../src/core/ViewCollection.vala"
	if (_klass_->get_previous) {
#line 776 "../src/core/ViewCollection.vala"
		return _klass_->get_previous (self, view);
#line 4177 "ViewCollection.c"
	}
#line 776 "../src/core/ViewCollection.vala"
	return NULL;
#line 4181 "ViewCollection.c"
}

gboolean
view_collection_get_immediate_neighbors (ViewCollection* self,
                                         DataSource* home,
                                         DataSource** next,
                                         DataSource** prev,
                                         const gchar* type_selector)
{
	DataSource* _vala_next = NULL;
	DataSource* _vala_prev = NULL;
	DataView* home_view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* next_view = NULL;
	DataView* _tmp2_;
	DataView* _tmp3_;
	DataView* prev_view = NULL;
	DataView* _tmp18_;
	DataView* _tmp19_;
	gboolean result;
#line 791 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 791 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (home != NULL, FALSE);
#line 793 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_next);
#line 793 "../src/core/ViewCollection.vala"
	_vala_next = NULL;
#line 794 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_prev);
#line 794 "../src/core/ViewCollection.vala"
	_vala_prev = NULL;
#line 796 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, home);
#line 796 "../src/core/ViewCollection.vala"
	home_view = _tmp0_;
#line 797 "../src/core/ViewCollection.vala"
	_tmp1_ = home_view;
#line 797 "../src/core/ViewCollection.vala"
	if (_tmp1_ == NULL) {
#line 798 "../src/core/ViewCollection.vala"
		result = FALSE;
#line 798 "../src/core/ViewCollection.vala"
		_g_object_unref0 (home_view);
#line 798 "../src/core/ViewCollection.vala"
		if (next) {
#line 798 "../src/core/ViewCollection.vala"
			*next = _vala_next;
#line 4231 "ViewCollection.c"
		} else {
#line 798 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 4235 "ViewCollection.c"
		}
#line 798 "../src/core/ViewCollection.vala"
		if (prev) {
#line 798 "../src/core/ViewCollection.vala"
			*prev = _vala_prev;
#line 4241 "ViewCollection.c"
		} else {
#line 798 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 4245 "ViewCollection.c"
		}
#line 798 "../src/core/ViewCollection.vala"
		return result;
#line 4249 "ViewCollection.c"
	}
#line 800 "../src/core/ViewCollection.vala"
	_tmp2_ = home_view;
#line 800 "../src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_next (self, _tmp2_);
#line 800 "../src/core/ViewCollection.vala"
	next_view = _tmp3_;
#line 801 "../src/core/ViewCollection.vala"
	while (TRUE) {
#line 4259 "ViewCollection.c"
		DataView* _tmp4_;
		DataView* _tmp5_;
		gboolean _tmp6_ = FALSE;
		DataView* _tmp16_;
		DataView* _tmp17_;
#line 801 "../src/core/ViewCollection.vala"
		_tmp4_ = next_view;
#line 801 "../src/core/ViewCollection.vala"
		_tmp5_ = home_view;
#line 801 "../src/core/ViewCollection.vala"
		if (!(_tmp4_ != _tmp5_)) {
#line 801 "../src/core/ViewCollection.vala"
			break;
#line 4273 "ViewCollection.c"
		}
#line 802 "../src/core/ViewCollection.vala"
		if (type_selector == NULL) {
#line 802 "../src/core/ViewCollection.vala"
			_tmp6_ = TRUE;
#line 4279 "ViewCollection.c"
		} else {
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 802 "../src/core/ViewCollection.vala"
			_tmp7_ = next_view;
#line 802 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 802 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 802 "../src/core/ViewCollection.vala"
			_tmp10_ = data_source_get_typename (_tmp9_);
#line 802 "../src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 802 "../src/core/ViewCollection.vala"
			_tmp6_ = g_strcmp0 (_tmp11_, type_selector) == 0;
#line 802 "../src/core/ViewCollection.vala"
			_g_free0 (_tmp11_);
#line 4300 "ViewCollection.c"
		}
#line 802 "../src/core/ViewCollection.vala"
		if (_tmp6_) {
#line 4304 "ViewCollection.c"
			DataView* _tmp12_;
			DataSource* _tmp13_;
			DataSource* _tmp14_;
			DataSource* _tmp15_;
#line 803 "../src/core/ViewCollection.vala"
			_tmp12_ = next_view;
#line 803 "../src/core/ViewCollection.vala"
			_tmp13_ = data_view_get_source (_tmp12_);
#line 803 "../src/core/ViewCollection.vala"
			_tmp14_ = _tmp13_;
#line 803 "../src/core/ViewCollection.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 803 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 803 "../src/core/ViewCollection.vala"
			_vala_next = _tmp15_;
#line 804 "../src/core/ViewCollection.vala"
			break;
#line 4323 "ViewCollection.c"
		}
#line 806 "../src/core/ViewCollection.vala"
		_tmp16_ = next_view;
#line 806 "../src/core/ViewCollection.vala"
		_tmp17_ = view_collection_get_next (self, _tmp16_);
#line 806 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_view);
#line 806 "../src/core/ViewCollection.vala"
		next_view = _tmp17_;
#line 4333 "ViewCollection.c"
	}
#line 809 "../src/core/ViewCollection.vala"
	_tmp18_ = home_view;
#line 809 "../src/core/ViewCollection.vala"
	_tmp19_ = view_collection_get_previous (self, _tmp18_);
#line 809 "../src/core/ViewCollection.vala"
	prev_view = _tmp19_;
#line 810 "../src/core/ViewCollection.vala"
	while (TRUE) {
#line 4343 "ViewCollection.c"
		DataView* _tmp20_;
		DataView* _tmp21_;
		gboolean _tmp22_ = FALSE;
		DataView* _tmp32_;
		DataView* _tmp33_;
#line 810 "../src/core/ViewCollection.vala"
		_tmp20_ = prev_view;
#line 810 "../src/core/ViewCollection.vala"
		_tmp21_ = home_view;
#line 810 "../src/core/ViewCollection.vala"
		if (!(_tmp20_ != _tmp21_)) {
#line 810 "../src/core/ViewCollection.vala"
			break;
#line 4357 "ViewCollection.c"
		}
#line 811 "../src/core/ViewCollection.vala"
		if (type_selector == NULL) {
#line 811 "../src/core/ViewCollection.vala"
			_tmp22_ = TRUE;
#line 4363 "ViewCollection.c"
		} else {
			DataView* _tmp23_;
			DataSource* _tmp24_;
			DataSource* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
#line 811 "../src/core/ViewCollection.vala"
			_tmp23_ = prev_view;
#line 811 "../src/core/ViewCollection.vala"
			_tmp24_ = data_view_get_source (_tmp23_);
#line 811 "../src/core/ViewCollection.vala"
			_tmp25_ = _tmp24_;
#line 811 "../src/core/ViewCollection.vala"
			_tmp26_ = data_source_get_typename (_tmp25_);
#line 811 "../src/core/ViewCollection.vala"
			_tmp27_ = _tmp26_;
#line 811 "../src/core/ViewCollection.vala"
			_tmp22_ = g_strcmp0 (_tmp27_, type_selector) == 0;
#line 811 "../src/core/ViewCollection.vala"
			_g_free0 (_tmp27_);
#line 4384 "ViewCollection.c"
		}
#line 811 "../src/core/ViewCollection.vala"
		if (_tmp22_) {
#line 4388 "ViewCollection.c"
			DataView* _tmp28_;
			DataSource* _tmp29_;
			DataSource* _tmp30_;
			DataSource* _tmp31_;
#line 812 "../src/core/ViewCollection.vala"
			_tmp28_ = prev_view;
#line 812 "../src/core/ViewCollection.vala"
			_tmp29_ = data_view_get_source (_tmp28_);
#line 812 "../src/core/ViewCollection.vala"
			_tmp30_ = _tmp29_;
#line 812 "../src/core/ViewCollection.vala"
			_tmp31_ = _g_object_ref0 (_tmp30_);
#line 812 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 812 "../src/core/ViewCollection.vala"
			_vala_prev = _tmp31_;
#line 813 "../src/core/ViewCollection.vala"
			break;
#line 4407 "ViewCollection.c"
		}
#line 815 "../src/core/ViewCollection.vala"
		_tmp32_ = prev_view;
#line 815 "../src/core/ViewCollection.vala"
		_tmp33_ = view_collection_get_previous (self, _tmp32_);
#line 815 "../src/core/ViewCollection.vala"
		_g_object_unref0 (prev_view);
#line 815 "../src/core/ViewCollection.vala"
		prev_view = _tmp33_;
#line 4417 "ViewCollection.c"
	}
#line 818 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 818 "../src/core/ViewCollection.vala"
	_g_object_unref0 (prev_view);
#line 818 "../src/core/ViewCollection.vala"
	_g_object_unref0 (next_view);
#line 818 "../src/core/ViewCollection.vala"
	_g_object_unref0 (home_view);
#line 818 "../src/core/ViewCollection.vala"
	if (next) {
#line 818 "../src/core/ViewCollection.vala"
		*next = _vala_next;
#line 4431 "ViewCollection.c"
	} else {
#line 818 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_next);
#line 4435 "ViewCollection.c"
	}
#line 818 "../src/core/ViewCollection.vala"
	if (prev) {
#line 818 "../src/core/ViewCollection.vala"
		*prev = _vala_prev;
#line 4441 "ViewCollection.c"
	} else {
#line 818 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_prev);
#line 4445 "ViewCollection.c"
	}
#line 818 "../src/core/ViewCollection.vala"
	return result;
#line 4449 "ViewCollection.c"
}

GeeSet*
view_collection_get_extended_neighbors (ViewCollection* self,
                                        DataSource* home,
                                        const gchar* typename)
{
	GeeSet* neighbors = NULL;
	GeeHashSet* _tmp0_;
	DataSource* next = NULL;
	DataSource* prev = NULL;
	DataSource* _tmp1_ = NULL;
	DataSource* _tmp2_ = NULL;
	gboolean _tmp3_;
	DataSource* _tmp4_;
	DataSource* _tmp13_;
	GeeSet* _tmp22_;
	GeeSet* result;
#line 822 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 822 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (home != NULL, NULL);
#line 824 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 824 "../src/core/ViewCollection.vala"
	neighbors = (GeeSet*) _tmp0_;
#line 828 "../src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_immediate_neighbors (self, home, &_tmp1_, &_tmp2_, typename);
#line 828 "../src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 828 "../src/core/ViewCollection.vala"
	next = _tmp1_;
#line 828 "../src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 828 "../src/core/ViewCollection.vala"
	prev = _tmp2_;
#line 828 "../src/core/ViewCollection.vala"
	if (!_tmp3_) {
#line 829 "../src/core/ViewCollection.vala"
		result = neighbors;
#line 829 "../src/core/ViewCollection.vala"
		_g_object_unref0 (prev);
#line 829 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next);
#line 829 "../src/core/ViewCollection.vala"
		return result;
#line 4496 "ViewCollection.c"
	}
#line 832 "../src/core/ViewCollection.vala"
	_tmp4_ = next;
#line 832 "../src/core/ViewCollection.vala"
	if (_tmp4_ != NULL) {
#line 4502 "ViewCollection.c"
		GeeSet* _tmp5_;
		DataSource* _tmp6_;
		DataSource* next_next = NULL;
		DataSource* next_prev = NULL;
		DataSource* _tmp7_;
		DataSource* _tmp8_ = NULL;
		DataSource* _tmp9_ = NULL;
		DataSource* _tmp10_;
#line 833 "../src/core/ViewCollection.vala"
		_tmp5_ = neighbors;
#line 833 "../src/core/ViewCollection.vala"
		_tmp6_ = next;
#line 833 "../src/core/ViewCollection.vala"
		gee_collection_add ((GeeCollection*) _tmp5_, _tmp6_);
#line 836 "../src/core/ViewCollection.vala"
		_tmp7_ = next;
#line 836 "../src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp7_, &_tmp8_, &_tmp9_, typename);
#line 836 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 836 "../src/core/ViewCollection.vala"
		next_next = _tmp8_;
#line 836 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 836 "../src/core/ViewCollection.vala"
		next_prev = _tmp9_;
#line 839 "../src/core/ViewCollection.vala"
		_tmp10_ = next_next;
#line 839 "../src/core/ViewCollection.vala"
		if (_tmp10_ != NULL) {
#line 4533 "ViewCollection.c"
			GeeSet* _tmp11_;
			DataSource* _tmp12_;
#line 840 "../src/core/ViewCollection.vala"
			_tmp11_ = neighbors;
#line 840 "../src/core/ViewCollection.vala"
			_tmp12_ = next_next;
#line 840 "../src/core/ViewCollection.vala"
			gee_collection_add ((GeeCollection*) _tmp11_, _tmp12_);
#line 4542 "ViewCollection.c"
		}
#line 832 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 832 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 4548 "ViewCollection.c"
	}
#line 844 "../src/core/ViewCollection.vala"
	_tmp13_ = prev;
#line 844 "../src/core/ViewCollection.vala"
	if (_tmp13_ != NULL) {
#line 4554 "ViewCollection.c"
		GeeSet* _tmp14_;
		DataSource* _tmp15_;
		DataSource* next_prev = NULL;
		DataSource* prev_prev = NULL;
		DataSource* _tmp16_;
		DataSource* _tmp17_ = NULL;
		DataSource* _tmp18_ = NULL;
		DataSource* _tmp19_;
#line 845 "../src/core/ViewCollection.vala"
		_tmp14_ = neighbors;
#line 845 "../src/core/ViewCollection.vala"
		_tmp15_ = prev;
#line 845 "../src/core/ViewCollection.vala"
		gee_collection_add ((GeeCollection*) _tmp14_, _tmp15_);
#line 848 "../src/core/ViewCollection.vala"
		_tmp16_ = prev;
#line 848 "../src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp16_, &_tmp17_, &_tmp18_, typename);
#line 848 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 848 "../src/core/ViewCollection.vala"
		next_prev = _tmp17_;
#line 848 "../src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 848 "../src/core/ViewCollection.vala"
		prev_prev = _tmp18_;
#line 851 "../src/core/ViewCollection.vala"
		_tmp19_ = prev_prev;
#line 851 "../src/core/ViewCollection.vala"
		if (_tmp19_ != NULL) {
#line 4585 "ViewCollection.c"
			GeeSet* _tmp20_;
			DataSource* _tmp21_;
#line 852 "../src/core/ViewCollection.vala"
			_tmp20_ = neighbors;
#line 852 "../src/core/ViewCollection.vala"
			_tmp21_ = prev_prev;
#line 852 "../src/core/ViewCollection.vala"
			gee_collection_add ((GeeCollection*) _tmp20_, _tmp21_);
#line 4594 "ViewCollection.c"
		}
#line 844 "../src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 844 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 4600 "ViewCollection.c"
	}
#line 856 "../src/core/ViewCollection.vala"
	_tmp22_ = neighbors;
#line 856 "../src/core/ViewCollection.vala"
	gee_collection_remove ((GeeCollection*) _tmp22_, home);
#line 858 "../src/core/ViewCollection.vala"
	result = neighbors;
#line 858 "../src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 858 "../src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 858 "../src/core/ViewCollection.vala"
	return result;
#line 4614 "ViewCollection.c"
}

static void
view_collection_add_many_selected (ViewCollection* self,
                                   GeeCollection* views)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean added = FALSE;
	DataSet* _tmp7_;
#line 863 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 863 "../src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 864 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_collection_get_size (views);
#line 864 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 864 "../src/core/ViewCollection.vala"
	if (_tmp1_ == 0) {
#line 865 "../src/core/ViewCollection.vala"
		return;
#line 4637 "ViewCollection.c"
	}
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp2_;
#line 867 "../src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) views);
#line 867 "../src/core/ViewCollection.vala"
		_view_it = _tmp2_;
#line 867 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 4648 "ViewCollection.c"
			GeeIterator* _tmp3_;
			DataView* view = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			DataView* _tmp6_;
#line 867 "../src/core/ViewCollection.vala"
			_tmp3_ = _view_it;
#line 867 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 867 "../src/core/ViewCollection.vala"
				break;
#line 4660 "ViewCollection.c"
			}
#line 867 "../src/core/ViewCollection.vala"
			_tmp4_ = _view_it;
#line 867 "../src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 867 "../src/core/ViewCollection.vala"
			view = (DataView*) _tmp5_;
#line 868 "../src/core/ViewCollection.vala"
			_tmp6_ = view;
#line 868 "../src/core/ViewCollection.vala"
			_vala_assert (data_view_is_visible (_tmp6_), "view.is_visible ()");
#line 867 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 4674 "ViewCollection.c"
		}
#line 867 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 4678 "ViewCollection.c"
	}
#line 870 "../src/core/ViewCollection.vala"
	_tmp7_ = self->priv->selected;
#line 870 "../src/core/ViewCollection.vala"
	added = data_set_add_many (_tmp7_, views);
#line 871 "../src/core/ViewCollection.vala"
	_vala_assert (added, "added");
#line 4686 "ViewCollection.c"
}

static void
view_collection_remove_many_selected (ViewCollection* self,
                                      GeeCollection* views)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean removed = FALSE;
	DataSet* _tmp2_;
#line 874 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 874 "../src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 875 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_collection_get_size (views);
#line 875 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 875 "../src/core/ViewCollection.vala"
	if (_tmp1_ == 0) {
#line 876 "../src/core/ViewCollection.vala"
		return;
#line 4709 "ViewCollection.c"
	}
#line 878 "../src/core/ViewCollection.vala"
	_tmp2_ = self->priv->selected;
#line 878 "../src/core/ViewCollection.vala"
	removed = data_set_remove_many (_tmp2_, views);
#line 879 "../src/core/ViewCollection.vala"
	_vala_assert (removed, "removed");
#line 4717 "ViewCollection.c"
}

static gboolean
_view_collection_select_item_marked_action (DataObject* object,
                                            GObject* user,
                                            gpointer self)
{
	gboolean result;
	result = view_collection_select_item ((ViewCollection*) self, object, user);
#line 885 "../src/core/ViewCollection.vala"
	return result;
#line 4729 "ViewCollection.c"
}

void
view_collection_select_marked (ViewCollection* self,
                               Marker* marker)
{
	GeeArrayList* selected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 883 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 883 "../src/core/ViewCollection.vala"
	g_return_if_fail (marker != NULL);
#line 884 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 884 "../src/core/ViewCollection.vala"
	selected = _tmp0_;
#line 885 "../src/core/ViewCollection.vala"
	_tmp1_ = selected;
#line 885 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, marker, _view_collection_select_item_marked_action, self, NULL, NULL, (GObject*) _tmp1_);
#line 887 "../src/core/ViewCollection.vala"
	_tmp2_ = selected;
#line 887 "../src/core/ViewCollection.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 887 "../src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 887 "../src/core/ViewCollection.vala"
	if (_tmp4_ > 0) {
#line 4762 "ViewCollection.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
#line 888 "../src/core/ViewCollection.vala"
		_tmp5_ = selected;
#line 888 "../src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, (GeeCollection*) _tmp5_);
#line 889 "../src/core/ViewCollection.vala"
		_tmp6_ = selected;
#line 889 "../src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, (GeeCollection*) _tmp6_, NULL);
#line 4773 "ViewCollection.c"
	}
#line 883 "../src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 4777 "ViewCollection.c"
}

void
view_collection_select_all (ViewCollection* self)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
#line 894 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 895 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking ((DataCollection*) self);
#line 895 "../src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 896 "../src/core/ViewCollection.vala"
	marker_mark_all (marker);
#line 897 "../src/core/ViewCollection.vala"
	view_collection_select_marked (self, marker);
#line 894 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 4797 "ViewCollection.c"
}

static gboolean
view_collection_select_item (ViewCollection* self,
                             DataObject* object,
                             GObject* user)
{
	DataView* view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* _tmp5_;
	DataView* _tmp6_;
	gboolean result;
#line 900 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 900 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 901 "../src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 901 "../src/core/ViewCollection.vala"
	view = _tmp0_;
#line 902 "../src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 902 "../src/core/ViewCollection.vala"
	if (data_view_is_selected (_tmp1_)) {
#line 4823 "ViewCollection.c"
		DataView* _tmp2_;
#line 903 "../src/core/ViewCollection.vala"
		_tmp2_ = view;
#line 903 "../src/core/ViewCollection.vala"
		if (data_view_is_visible (_tmp2_)) {
#line 4829 "ViewCollection.c"
			DataSet* _tmp3_;
			DataView* _tmp4_;
#line 904 "../src/core/ViewCollection.vala"
			_tmp3_ = self->priv->selected;
#line 904 "../src/core/ViewCollection.vala"
			_tmp4_ = view;
#line 904 "../src/core/ViewCollection.vala"
			_vala_assert (data_set_contains (_tmp3_, (DataObject*) _tmp4_), "selected.contains (view)");
#line 4838 "ViewCollection.c"
		}
#line 906 "../src/core/ViewCollection.vala"
		result = TRUE;
#line 906 "../src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 906 "../src/core/ViewCollection.vala"
		return result;
#line 4846 "ViewCollection.c"
	}
#line 909 "../src/core/ViewCollection.vala"
	_tmp5_ = view;
#line 909 "../src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp5_, TRUE);
#line 913 "../src/core/ViewCollection.vala"
	_tmp6_ = view;
#line 913 "../src/core/ViewCollection.vala"
	if (data_view_is_visible (_tmp6_)) {
#line 4856 "ViewCollection.c"
		DataView* _tmp7_;
#line 914 "../src/core/ViewCollection.vala"
		_tmp7_ = view;
#line 914 "../src/core/ViewCollection.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (user, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp7_);
#line 4862 "ViewCollection.c"
	}
#line 916 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 916 "../src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 916 "../src/core/ViewCollection.vala"
	return result;
#line 4870 "ViewCollection.c"
}

static gboolean
_view_collection_unselect_item_marked_action (DataObject* object,
                                              GObject* user,
                                              gpointer self)
{
	gboolean result;
	result = view_collection_unselect_item ((ViewCollection*) self, object, user);
#line 922 "../src/core/ViewCollection.vala"
	return result;
#line 4882 "ViewCollection.c"
}

void
view_collection_unselect_marked (ViewCollection* self,
                                 Marker* marker)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 920 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 920 "../src/core/ViewCollection.vala"
	g_return_if_fail (marker != NULL);
#line 921 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 921 "../src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 922 "../src/core/ViewCollection.vala"
	_tmp1_ = unselected;
#line 922 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, marker, _view_collection_unselect_item_marked_action, self, NULL, NULL, (GObject*) _tmp1_);
#line 924 "../src/core/ViewCollection.vala"
	_tmp2_ = unselected;
#line 924 "../src/core/ViewCollection.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 924 "../src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 924 "../src/core/ViewCollection.vala"
	if (_tmp4_ > 0) {
#line 4915 "ViewCollection.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
#line 925 "../src/core/ViewCollection.vala"
		_tmp5_ = unselected;
#line 925 "../src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, (GeeCollection*) _tmp5_);
#line 926 "../src/core/ViewCollection.vala"
		_tmp6_ = unselected;
#line 926 "../src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, (GeeCollection*) _tmp6_);
#line 4926 "ViewCollection.c"
	}
#line 920 "../src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 4930 "ViewCollection.c"
}

void
view_collection_unselect_all (ViewCollection* self)
{
	DataSet* _tmp0_;
	Marker* marker = NULL;
	Marker* _tmp1_;
	Marker* _tmp2_;
	GeeList* _tmp3_;
	GeeList* _tmp4_;
	Marker* _tmp5_;
#line 931 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 932 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 932 "../src/core/ViewCollection.vala"
	if (data_set_get_count (_tmp0_) == 0) {
#line 933 "../src/core/ViewCollection.vala"
		return;
#line 4951 "ViewCollection.c"
	}
#line 935 "../src/core/ViewCollection.vala"
	_tmp1_ = data_collection_start_marking ((DataCollection*) self);
#line 935 "../src/core/ViewCollection.vala"
	marker = _tmp1_;
#line 936 "../src/core/ViewCollection.vala"
	_tmp2_ = marker;
#line 936 "../src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_selected (self);
#line 936 "../src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 936 "../src/core/ViewCollection.vala"
	marker_mark_many (_tmp2_, (GeeCollection*) _tmp4_);
#line 936 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp4_);
#line 938 "../src/core/ViewCollection.vala"
	_tmp5_ = marker;
#line 938 "../src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp5_);
#line 931 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 4973 "ViewCollection.c"
}

void
view_collection_unselect_all_but (ViewCollection* self,
                                  DataView* exception)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
	Marker* _tmp13_;
#line 942 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 942 "../src/core/ViewCollection.vala"
	g_return_if_fail (exception != NULL);
#line 943 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking ((DataCollection*) self);
#line 943 "../src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 4991 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 944 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_all ((DataCollection*) self);
#line 944 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 944 "../src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 944 "../src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 944 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 944 "../src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 944 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 5012 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataView* view = NULL;
			DataObject* _tmp8_;
			DataView* _tmp9_;
			DataView* _tmp10_;
#line 944 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 944 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 944 "../src/core/ViewCollection.vala"
				break;
#line 5027 "ViewCollection.c"
			}
#line 944 "../src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 944 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 944 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 945 "../src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 945 "../src/core/ViewCollection.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView));
#line 945 "../src/core/ViewCollection.vala"
			view = _tmp9_;
#line 946 "../src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 946 "../src/core/ViewCollection.vala"
			if (_tmp10_ != exception) {
#line 5045 "ViewCollection.c"
				Marker* _tmp11_;
				DataView* _tmp12_;
#line 947 "../src/core/ViewCollection.vala"
				_tmp11_ = marker;
#line 947 "../src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 947 "../src/core/ViewCollection.vala"
				marker_mark (_tmp11_, (DataObject*) _tmp12_);
#line 5054 "ViewCollection.c"
			}
#line 944 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 944 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 5060 "ViewCollection.c"
		}
#line 944 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 5064 "ViewCollection.c"
	}
#line 950 "../src/core/ViewCollection.vala"
	_tmp13_ = marker;
#line 950 "../src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp13_);
#line 942 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5072 "ViewCollection.c"
}

static gboolean
view_collection_unselect_item (ViewCollection* self,
                               DataObject* object,
                               GObject* user)
{
	DataView* view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* _tmp4_;
	DataView* _tmp5_;
	gboolean result;
#line 953 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 953 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 954 "../src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 954 "../src/core/ViewCollection.vala"
	view = _tmp0_;
#line 955 "../src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 955 "../src/core/ViewCollection.vala"
	if (!data_view_is_selected (_tmp1_)) {
#line 5098 "ViewCollection.c"
		DataSet* _tmp2_;
		DataView* _tmp3_;
#line 956 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->selected;
#line 956 "../src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 956 "../src/core/ViewCollection.vala"
		_vala_assert (!data_set_contains (_tmp2_, (DataObject*) _tmp3_), "!selected.contains (view)");
#line 958 "../src/core/ViewCollection.vala"
		result = TRUE;
#line 958 "../src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 958 "../src/core/ViewCollection.vala"
		return result;
#line 5113 "ViewCollection.c"
	}
#line 961 "../src/core/ViewCollection.vala"
	_tmp4_ = view;
#line 961 "../src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp4_, FALSE);
#line 962 "../src/core/ViewCollection.vala"
	_tmp5_ = view;
#line 962 "../src/core/ViewCollection.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (user, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp5_);
#line 964 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 964 "../src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 964 "../src/core/ViewCollection.vala"
	return result;
#line 5129 "ViewCollection.c"
}

void
view_collection_unselect_and_select_marked (ViewCollection* self,
                                            Marker* unselect,
                                            Marker* select)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* selected = NULL;
	GeeArrayList* _tmp1_;
#line 968 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 968 "../src/core/ViewCollection.vala"
	g_return_if_fail (unselect != NULL);
#line 968 "../src/core/ViewCollection.vala"
	g_return_if_fail (select != NULL);
#line 969 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 969 "../src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 970 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, unselect, _view_collection_unselect_item_marked_action, self, NULL, NULL, (GObject*) unselected);
#line 972 "../src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, (GeeCollection*) unselected);
#line 974 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 974 "../src/core/ViewCollection.vala"
	selected = _tmp1_;
#line 975 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, select, _view_collection_select_item_marked_action, self, NULL, NULL, (GObject*) selected);
#line 977 "../src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, (GeeCollection*) selected);
#line 979 "../src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, (GeeCollection*) selected, (GeeCollection*) unselected);
#line 968 "../src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 968 "../src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 5169 "ViewCollection.c"
}

static gboolean
_view_collection_toggle_item_marked_action (DataObject* object,
                                            GObject* user,
                                            gpointer self)
{
	gboolean result;
	result = view_collection_toggle_item ((ViewCollection*) self, object, user);
#line 986 "../src/core/ViewCollection.vala"
	return result;
#line 5181 "ViewCollection.c"
}

void
view_collection_toggle_marked (ViewCollection* self,
                               Marker* marker)
{
	ViewCollectionToggleLists* lists = NULL;
	ViewCollectionToggleLists* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
#line 984 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 984 "../src/core/ViewCollection.vala"
	g_return_if_fail (marker != NULL);
#line 985 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_toggle_lists_new ();
#line 985 "../src/core/ViewCollection.vala"
	lists = _tmp0_;
#line 986 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked ((DataCollection*) self, marker, _view_collection_toggle_item_marked_action, self, NULL, NULL, (GObject*) lists);
#line 989 "../src/core/ViewCollection.vala"
	_tmp1_ = lists->selected;
#line 989 "../src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, (GeeCollection*) _tmp1_);
#line 990 "../src/core/ViewCollection.vala"
	_tmp2_ = lists->unselected;
#line 990 "../src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, (GeeCollection*) _tmp2_);
#line 992 "../src/core/ViewCollection.vala"
	_tmp3_ = lists->selected;
#line 992 "../src/core/ViewCollection.vala"
	_tmp4_ = lists->unselected;
#line 992 "../src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, (GeeCollection*) _tmp3_, (GeeCollection*) _tmp4_);
#line 984 "../src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 5220 "ViewCollection.c"
}

static gboolean
view_collection_toggle_item (ViewCollection* self,
                             DataObject* object,
                             GObject* user)
{
	DataView* view = NULL;
	DataView* _tmp0_;
	ViewCollectionToggleLists* lists = NULL;
	ViewCollectionToggleLists* _tmp1_;
	DataView* _tmp2_;
	gboolean result;
#line 995 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 995 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 996 "../src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 996 "../src/core/ViewCollection.vala"
	view = _tmp0_;
#line 997 "../src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (user, VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists));
#line 997 "../src/core/ViewCollection.vala"
	lists = _tmp1_;
#line 1003 "../src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 1003 "../src/core/ViewCollection.vala"
	if (data_view_internal_toggle (_tmp2_)) {
#line 5250 "ViewCollection.c"
		DataView* _tmp3_;
#line 1004 "../src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 1004 "../src/core/ViewCollection.vala"
		if (data_view_is_visible (_tmp3_)) {
#line 5256 "ViewCollection.c"
			ViewCollectionToggleLists* _tmp4_;
			GeeArrayList* _tmp5_;
			DataView* _tmp6_;
#line 1005 "../src/core/ViewCollection.vala"
			_tmp4_ = lists;
#line 1005 "../src/core/ViewCollection.vala"
			_tmp5_ = _tmp4_->selected;
#line 1005 "../src/core/ViewCollection.vala"
			_tmp6_ = view;
#line 1005 "../src/core/ViewCollection.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 5268 "ViewCollection.c"
		}
	} else {
		ViewCollectionToggleLists* _tmp7_;
		GeeArrayList* _tmp8_;
		DataView* _tmp9_;
#line 1007 "../src/core/ViewCollection.vala"
		_tmp7_ = lists;
#line 1007 "../src/core/ViewCollection.vala"
		_tmp8_ = _tmp7_->unselected;
#line 1007 "../src/core/ViewCollection.vala"
		_tmp9_ = view;
#line 1007 "../src/core/ViewCollection.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 5282 "ViewCollection.c"
	}
#line 1010 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 1010 "../src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 1010 "../src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 1010 "../src/core/ViewCollection.vala"
	return result;
#line 5292 "ViewCollection.c"
}

gint
view_collection_get_selected_count (ViewCollection* self)
{
	DataSet* _tmp0_;
	gint result;
#line 1013 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1014 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1014 "../src/core/ViewCollection.vala"
	result = data_set_get_count (_tmp0_);
#line 1014 "../src/core/ViewCollection.vala"
	return result;
#line 5308 "ViewCollection.c"
}

GeeList*
view_collection_get_selected (ViewCollection* self)
{
	DataSet* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 1017 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1018 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1018 "../src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_all (_tmp0_);
#line 1018 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 1018 "../src/core/ViewCollection.vala"
	return result;
#line 5327 "ViewCollection.c"
}

DataView*
view_collection_get_selected_at (ViewCollection* self,
                                 gint index)
{
	DataSet* _tmp0_;
	DataObject* _tmp1_;
	DataView* result;
#line 1021 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1022 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1022 "../src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_at (_tmp0_, index);
#line 1022 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 1022 "../src/core/ViewCollection.vala"
	return result;
#line 5347 "ViewCollection.c"
}

static gboolean
view_collection_is_visible (ViewCollection* self,
                            DataView* view)
{
	gboolean _tmp0_ = FALSE;
	DataSet* _tmp1_;
	gboolean result;
#line 1025 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1025 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 1026 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 1026 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 5365 "ViewCollection.c"
		DataSet* _tmp2_;
#line 1026 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 1026 "../src/core/ViewCollection.vala"
		_tmp0_ = data_set_contains (_tmp2_, (DataObject*) view);
#line 5371 "ViewCollection.c"
	} else {
#line 1026 "../src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 5375 "ViewCollection.c"
	}
#line 1026 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 1026 "../src/core/ViewCollection.vala"
	return result;
#line 5381 "ViewCollection.c"
}

static gboolean
view_collection_add_many_visible (ViewCollection* self,
                                  GeeCollection* many)
{
	DataSet* _tmp0_;
	DataSet* _tmp1_;
	DataSet* _tmp2_;
	gboolean result;
#line 1029 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1029 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (many != NULL, FALSE);
#line 1030 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->visible;
#line 1030 "../src/core/ViewCollection.vala"
	if (_tmp0_ == NULL) {
#line 1031 "../src/core/ViewCollection.vala"
		result = TRUE;
#line 1031 "../src/core/ViewCollection.vala"
		return result;
#line 5404 "ViewCollection.c"
	}
#line 1033 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 1033 "../src/core/ViewCollection.vala"
	if (!data_set_add_many (_tmp1_, many)) {
#line 1034 "../src/core/ViewCollection.vala"
		result = FALSE;
#line 1034 "../src/core/ViewCollection.vala"
		return result;
#line 5414 "ViewCollection.c"
	}
#line 1037 "../src/core/ViewCollection.vala"
	_tmp2_ = self->priv->visible;
#line 1037 "../src/core/ViewCollection.vala"
	if (data_set_get_count (_tmp2_) == DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection))) {
#line 1038 "../src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1038 "../src/core/ViewCollection.vala"
		self->priv->visible = NULL;
#line 5424 "ViewCollection.c"
	}
#line 1040 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 1040 "../src/core/ViewCollection.vala"
	return result;
#line 5430 "ViewCollection.c"
}

static void
view_collection_hide_items (ViewCollection* self,
                            GeeList* to_hide)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	gint _tmp1_;
	gint _tmp2_;
	DataSet* _tmp14_;
	gboolean removed = FALSE;
	DataSet* _tmp16_;
	GeeArrayList* _tmp17_;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp22_;
	gint _tmp23_;
#line 1044 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 1044 "../src/core/ViewCollection.vala"
	g_return_if_fail (to_hide != NULL);
#line 1045 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1045 "../src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 1047 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) to_hide);
#line 1047 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1047 "../src/core/ViewCollection.vala"
	count = _tmp2_;
#line 5465 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1048 "../src/core/ViewCollection.vala"
		ctr = 0;
#line 5470 "ViewCollection.c"
		{
			gboolean _tmp3_ = FALSE;
#line 1048 "../src/core/ViewCollection.vala"
			_tmp3_ = TRUE;
#line 1048 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 5477 "ViewCollection.c"
				DataView* view = NULL;
				gpointer _tmp5_;
				DataView* _tmp6_;
				DataView* _tmp7_;
				DataView* _tmp13_;
#line 1048 "../src/core/ViewCollection.vala"
				if (!_tmp3_) {
#line 5485 "ViewCollection.c"
					gint _tmp4_;
#line 1048 "../src/core/ViewCollection.vala"
					_tmp4_ = ctr;
#line 1048 "../src/core/ViewCollection.vala"
					ctr = _tmp4_ + 1;
#line 5491 "ViewCollection.c"
				}
#line 1048 "../src/core/ViewCollection.vala"
				_tmp3_ = FALSE;
#line 1048 "../src/core/ViewCollection.vala"
				if (!(ctr < count)) {
#line 1048 "../src/core/ViewCollection.vala"
					break;
#line 5499 "ViewCollection.c"
				}
#line 1049 "../src/core/ViewCollection.vala"
				_tmp5_ = gee_list_get (to_hide, ctr);
#line 1049 "../src/core/ViewCollection.vala"
				view = (DataView*) _tmp5_;
#line 1050 "../src/core/ViewCollection.vala"
				_tmp6_ = view;
#line 1050 "../src/core/ViewCollection.vala"
				_vala_assert (data_view_is_visible (_tmp6_), "view.is_visible ()");
#line 1052 "../src/core/ViewCollection.vala"
				_tmp7_ = view;
#line 1052 "../src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp7_)) {
#line 5513 "ViewCollection.c"
					DataView* _tmp8_;
					GeeArrayList* _tmp9_;
					DataView* _tmp10_;
#line 1053 "../src/core/ViewCollection.vala"
					_tmp8_ = view;
#line 1053 "../src/core/ViewCollection.vala"
					data_view_internal_set_selected (_tmp8_, FALSE);
#line 1054 "../src/core/ViewCollection.vala"
					_tmp9_ = unselected;
#line 1054 "../src/core/ViewCollection.vala"
					_tmp10_ = view;
#line 1054 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp10_);
#line 5527 "ViewCollection.c"
				} else {
					DataSet* _tmp11_;
					DataView* _tmp12_;
#line 1056 "../src/core/ViewCollection.vala"
					_tmp11_ = self->priv->selected;
#line 1056 "../src/core/ViewCollection.vala"
					_tmp12_ = view;
#line 1056 "../src/core/ViewCollection.vala"
					_vala_assert (!data_set_contains (_tmp11_, (DataObject*) _tmp12_), "!selected.contains (view)");
#line 5537 "ViewCollection.c"
				}
#line 1059 "../src/core/ViewCollection.vala"
				_tmp13_ = view;
#line 1059 "../src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp13_, FALSE);
#line 1048 "../src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 5545 "ViewCollection.c"
			}
		}
	}
#line 1062 "../src/core/ViewCollection.vala"
	_tmp14_ = self->priv->visible;
#line 1062 "../src/core/ViewCollection.vala"
	if (_tmp14_ == NULL) {
#line 5553 "ViewCollection.c"
		DataSet* _tmp15_;
#line 1064 "../src/core/ViewCollection.vala"
		_tmp15_ = data_collection_get_dataset_copy ((DataCollection*) self);
#line 1064 "../src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1064 "../src/core/ViewCollection.vala"
		self->priv->visible = _tmp15_;
#line 5561 "ViewCollection.c"
	}
#line 1067 "../src/core/ViewCollection.vala"
	_tmp16_ = self->priv->visible;
#line 1067 "../src/core/ViewCollection.vala"
	removed = data_set_remove_many (_tmp16_, (GeeCollection*) to_hide);
#line 1068 "../src/core/ViewCollection.vala"
	_vala_assert (removed, "removed");
#line 1070 "../src/core/ViewCollection.vala"
	_tmp17_ = unselected;
#line 1070 "../src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, (GeeCollection*) _tmp17_);
#line 1072 "../src/core/ViewCollection.vala"
	_tmp18_ = unselected;
#line 1072 "../src/core/ViewCollection.vala"
	_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 1072 "../src/core/ViewCollection.vala"
	_tmp20_ = _tmp19_;
#line 1072 "../src/core/ViewCollection.vala"
	if (_tmp20_ > 0) {
#line 5581 "ViewCollection.c"
		GeeArrayList* _tmp21_;
#line 1073 "../src/core/ViewCollection.vala"
		_tmp21_ = unselected;
#line 1073 "../src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, (GeeCollection*) _tmp21_);
#line 5587 "ViewCollection.c"
	}
#line 1075 "../src/core/ViewCollection.vala"
	_tmp22_ = gee_collection_get_size ((GeeCollection*) to_hide);
#line 1075 "../src/core/ViewCollection.vala"
	_tmp23_ = _tmp22_;
#line 1075 "../src/core/ViewCollection.vala"
	if (_tmp23_ > 0) {
#line 1076 "../src/core/ViewCollection.vala"
		view_collection_notify_items_hidden (self, (GeeCollection*) to_hide);
#line 1077 "../src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, (GeeCollection*) to_hide);
#line 5599 "ViewCollection.c"
	}
#line 1044 "../src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 5603 "ViewCollection.c"
}

static void
view_collection_show_items (ViewCollection* self,
                            GeeList* to_show)
{
	GeeArrayList* added_selected = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	gint _tmp1_;
	gint _tmp2_;
	gboolean added = FALSE;
	GeeArrayList* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
#line 1082 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 1082 "../src/core/ViewCollection.vala"
	g_return_if_fail (to_show != NULL);
#line 1083 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1083 "../src/core/ViewCollection.vala"
	added_selected = _tmp0_;
#line 1085 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) to_show);
#line 1085 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1085 "../src/core/ViewCollection.vala"
	count = _tmp2_;
#line 5633 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1086 "../src/core/ViewCollection.vala"
		ctr = 0;
#line 5638 "ViewCollection.c"
		{
			gboolean _tmp3_ = FALSE;
#line 1086 "../src/core/ViewCollection.vala"
			_tmp3_ = TRUE;
#line 1086 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 5645 "ViewCollection.c"
				DataView* view = NULL;
				gpointer _tmp5_;
				DataView* _tmp6_;
				DataView* _tmp7_;
				DataView* _tmp8_;
#line 1086 "../src/core/ViewCollection.vala"
				if (!_tmp3_) {
#line 5653 "ViewCollection.c"
					gint _tmp4_;
#line 1086 "../src/core/ViewCollection.vala"
					_tmp4_ = ctr;
#line 1086 "../src/core/ViewCollection.vala"
					ctr = _tmp4_ + 1;
#line 5659 "ViewCollection.c"
				}
#line 1086 "../src/core/ViewCollection.vala"
				_tmp3_ = FALSE;
#line 1086 "../src/core/ViewCollection.vala"
				if (!(ctr < count)) {
#line 1086 "../src/core/ViewCollection.vala"
					break;
#line 5667 "ViewCollection.c"
				}
#line 1087 "../src/core/ViewCollection.vala"
				_tmp5_ = gee_list_get (to_show, ctr);
#line 1087 "../src/core/ViewCollection.vala"
				view = (DataView*) _tmp5_;
#line 1088 "../src/core/ViewCollection.vala"
				_tmp6_ = view;
#line 1088 "../src/core/ViewCollection.vala"
				_vala_assert (!data_view_is_visible (_tmp6_), "!view.is_visible ()");
#line 1090 "../src/core/ViewCollection.vala"
				_tmp7_ = view;
#line 1090 "../src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp7_, TRUE);
#line 1093 "../src/core/ViewCollection.vala"
				_tmp8_ = view;
#line 1093 "../src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp8_)) {
#line 5685 "ViewCollection.c"
					DataSet* _tmp9_;
					DataView* _tmp10_;
					GeeArrayList* _tmp11_;
					DataView* _tmp12_;
#line 1094 "../src/core/ViewCollection.vala"
					_tmp9_ = self->priv->selected;
#line 1094 "../src/core/ViewCollection.vala"
					_tmp10_ = view;
#line 1094 "../src/core/ViewCollection.vala"
					_vala_assert (!data_set_contains (_tmp9_, (DataObject*) _tmp10_), "!selected.contains (view)");
#line 1095 "../src/core/ViewCollection.vala"
					_tmp11_ = added_selected;
#line 1095 "../src/core/ViewCollection.vala"
					_tmp12_ = view;
#line 1095 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 5702 "ViewCollection.c"
				}
#line 1086 "../src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 5706 "ViewCollection.c"
			}
		}
	}
#line 1099 "../src/core/ViewCollection.vala"
	added = view_collection_add_many_visible (self, (GeeCollection*) to_show);
#line 1100 "../src/core/ViewCollection.vala"
	_vala_assert (added, "added");
#line 1102 "../src/core/ViewCollection.vala"
	_tmp13_ = added_selected;
#line 1102 "../src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, (GeeCollection*) _tmp13_);
#line 1104 "../src/core/ViewCollection.vala"
	_tmp14_ = gee_collection_get_size ((GeeCollection*) to_show);
#line 1104 "../src/core/ViewCollection.vala"
	_tmp15_ = _tmp14_;
#line 1104 "../src/core/ViewCollection.vala"
	if (_tmp15_ > 0) {
#line 1105 "../src/core/ViewCollection.vala"
		view_collection_notify_items_shown (self, (GeeCollection*) to_show);
#line 1106 "../src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, (GeeCollection*) to_show);
#line 5728 "ViewCollection.c"
	}
#line 1082 "../src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 5732 "ViewCollection.c"
}

gboolean
view_collection_has_view_for_source (ViewCollection* self,
                                     DataSource* source)
{
	DataView* _tmp0_;
	DataView* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 1111 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1111 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 1112 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, source);
#line 1112 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 1112 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 1112 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1112 "../src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1112 "../src/core/ViewCollection.vala"
	return result;
#line 5759 "ViewCollection.c"
}

DataView*
view_collection_get_view_for_source (ViewCollection* self,
                                     DataSource* source)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	DataView* result;
#line 1116 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1116 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 1117 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1117 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, source);
#line 1117 "../src/core/ViewCollection.vala"
	result = (DataView*) _tmp1_;
#line 1117 "../src/core/ViewCollection.vala"
	return result;
#line 5781 "ViewCollection.c"
}

gboolean
view_collection_has_view_for_source_with_filtered (ViewCollection* self,
                                                   DataSource* source)
{
	DataView* _tmp0_;
	DataView* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 1121 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1121 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 1122 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source_filtered (self, source);
#line 1122 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 1122 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 1122 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1122 "../src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1122 "../src/core/ViewCollection.vala"
	return result;
#line 5808 "ViewCollection.c"
}

DataView*
view_collection_get_view_for_source_filtered (ViewCollection* self,
                                              DataSource* source)
{
	DataView* view = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
	DataView* _tmp3_;
	DataView* result;
#line 1126 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1126 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 1127 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1127 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, source);
#line 1127 "../src/core/ViewCollection.vala"
	view = (DataView*) _tmp1_;
#line 1129 "../src/core/ViewCollection.vala"
	_tmp3_ = view;
#line 1129 "../src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 5835 "ViewCollection.c"
		DataView* _tmp4_;
#line 1129 "../src/core/ViewCollection.vala"
		_tmp4_ = view;
#line 1129 "../src/core/ViewCollection.vala"
		_tmp2_ = !view_collection_is_in_filter (self, _tmp4_);
#line 5841 "ViewCollection.c"
	} else {
#line 1129 "../src/core/ViewCollection.vala"
		_tmp2_ = FALSE;
#line 5845 "ViewCollection.c"
	}
#line 1129 "../src/core/ViewCollection.vala"
	if (_tmp2_) {
#line 1130 "../src/core/ViewCollection.vala"
		result = NULL;
#line 1130 "../src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 1130 "../src/core/ViewCollection.vala"
		return result;
#line 5855 "ViewCollection.c"
	}
#line 1131 "../src/core/ViewCollection.vala"
	result = view;
#line 1131 "../src/core/ViewCollection.vala"
	return result;
#line 5861 "ViewCollection.c"
}

GeeCollection*
view_collection_get_sources (ViewCollection* self)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* result;
#line 1135 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1136 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1136 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 1136 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1136 "../src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 1136 "../src/core/ViewCollection.vala"
	_tmp4_ = gee_set_get_read_only_view (_tmp3_);
#line 1136 "../src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 1136 "../src/core/ViewCollection.vala"
	_tmp6_ = (GeeCollection*) _tmp5_;
#line 1136 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp3_);
#line 1136 "../src/core/ViewCollection.vala"
	result = _tmp6_;
#line 1136 "../src/core/ViewCollection.vala"
	return result;
#line 5897 "ViewCollection.c"
}

gboolean
view_collection_has_source_of_type (ViewCollection* self,
                                    GType t)
{
	gboolean result;
#line 1140 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1141 "../src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a (typeof (DataSource))");
#line 5909 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 1143 "../src/core/ViewCollection.vala"
		_tmp0_ = self->priv->source_map;
#line 1143 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 1143 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 1143 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1143 "../src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1143 "../src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1143 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1143 "../src/core/ViewCollection.vala"
		_source_it = _tmp5_;
#line 1143 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 5936 "ViewCollection.c"
			GeeIterator* _tmp6_;
			DataSource* source = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			DataSource* _tmp9_;
#line 1143 "../src/core/ViewCollection.vala"
			_tmp6_ = _source_it;
#line 1143 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 1143 "../src/core/ViewCollection.vala"
				break;
#line 5948 "ViewCollection.c"
			}
#line 1143 "../src/core/ViewCollection.vala"
			_tmp7_ = _source_it;
#line 1143 "../src/core/ViewCollection.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1143 "../src/core/ViewCollection.vala"
			source = (DataSource*) _tmp8_;
#line 1144 "../src/core/ViewCollection.vala"
			_tmp9_ = source;
#line 1144 "../src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp9_), t)) {
#line 1145 "../src/core/ViewCollection.vala"
				result = TRUE;
#line 1145 "../src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1145 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_source_it);
#line 1145 "../src/core/ViewCollection.vala"
				return result;
#line 5968 "ViewCollection.c"
			}
#line 1143 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 5972 "ViewCollection.c"
		}
#line 1143 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 5976 "ViewCollection.c"
	}
#line 1148 "../src/core/ViewCollection.vala"
	result = FALSE;
#line 1148 "../src/core/ViewCollection.vala"
	return result;
#line 5982 "ViewCollection.c"
}

gint
view_collection_get_sources_of_type_count (ViewCollection* self,
                                           GType t)
{
	gint count = 0;
	gint result;
#line 1151 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1152 "../src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a (typeof (DataSource))");
#line 1154 "../src/core/ViewCollection.vala"
	count = 0;
#line 5997 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 1155 "../src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_all ((DataCollection*) self);
#line 1155 "../src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 1155 "../src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 1155 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1155 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 1155 "../src/core/ViewCollection.vala"
		_object_it = _tmp3_;
#line 1155 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 6018 "ViewCollection.c"
			GeeIterator* _tmp4_;
			DataObject* object = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			DataObject* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
#line 1155 "../src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 1155 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1155 "../src/core/ViewCollection.vala"
				break;
#line 6032 "ViewCollection.c"
			}
#line 1155 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 1155 "../src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1155 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 1156 "../src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 1156 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_VIEW, DataView));
#line 1156 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 1156 "../src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp9_), t)) {
#line 6048 "ViewCollection.c"
				gint _tmp10_;
#line 1157 "../src/core/ViewCollection.vala"
				_tmp10_ = count;
#line 1157 "../src/core/ViewCollection.vala"
				count = _tmp10_ + 1;
#line 6054 "ViewCollection.c"
			}
#line 1155 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 6058 "ViewCollection.c"
		}
#line 1155 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 6062 "ViewCollection.c"
	}
#line 1160 "../src/core/ViewCollection.vala"
	result = count;
#line 1160 "../src/core/ViewCollection.vala"
	return result;
#line 6068 "ViewCollection.c"
}

GeeList*
view_collection_get_sources_of_type (ViewCollection* self,
                                     GType t)
{
	GeeList* sources = NULL;
	GeeList* result;
#line 1163 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1164 "../src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a (typeof (DataSource))");
#line 1166 "../src/core/ViewCollection.vala"
	sources = NULL;
#line 6083 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 1167 "../src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_all ((DataCollection*) self);
#line 1167 "../src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 1167 "../src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 1167 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1167 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 1167 "../src/core/ViewCollection.vala"
		_object_it = _tmp3_;
#line 1167 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 6104 "ViewCollection.c"
			GeeIterator* _tmp4_;
			DataObject* object = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			DataSource* source = NULL;
			DataObject* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			DataSource* _tmp10_;
			DataSource* _tmp11_;
#line 1167 "../src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 1167 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1167 "../src/core/ViewCollection.vala"
				break;
#line 6121 "ViewCollection.c"
			}
#line 1167 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 1167 "../src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1167 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 1168 "../src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 1168 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_VIEW, DataView));
#line 1168 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 1168 "../src/core/ViewCollection.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1168 "../src/core/ViewCollection.vala"
			source = _tmp10_;
#line 1169 "../src/core/ViewCollection.vala"
			_tmp11_ = source;
#line 1169 "../src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp11_), t)) {
#line 6143 "ViewCollection.c"
				GeeList* _tmp12_;
				GeeList* _tmp14_;
				DataSource* _tmp15_;
#line 1170 "../src/core/ViewCollection.vala"
				_tmp12_ = sources;
#line 1170 "../src/core/ViewCollection.vala"
				if (_tmp12_ == NULL) {
#line 6151 "ViewCollection.c"
					GeeArrayList* _tmp13_;
#line 1171 "../src/core/ViewCollection.vala"
					_tmp13_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1171 "../src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1171 "../src/core/ViewCollection.vala"
					sources = (GeeList*) _tmp13_;
#line 6159 "ViewCollection.c"
				}
#line 1173 "../src/core/ViewCollection.vala"
				_tmp14_ = sources;
#line 1173 "../src/core/ViewCollection.vala"
				_tmp15_ = source;
#line 1173 "../src/core/ViewCollection.vala"
				gee_collection_add ((GeeCollection*) _tmp14_, _tmp15_);
#line 6167 "ViewCollection.c"
			}
#line 1167 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1167 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 6173 "ViewCollection.c"
		}
#line 1167 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 6177 "ViewCollection.c"
	}
#line 1177 "../src/core/ViewCollection.vala"
	result = sources;
#line 1177 "../src/core/ViewCollection.vala"
	return result;
#line 6183 "ViewCollection.c"
}

GeeList*
view_collection_get_selected_sources (ViewCollection* self)
{
	GeeList* sources = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	DataSet* _tmp1_;
	GeeList* result;
#line 1180 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1181 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1181 "../src/core/ViewCollection.vala"
	sources = (GeeList*) _tmp0_;
#line 1183 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->selected;
#line 1183 "../src/core/ViewCollection.vala"
	count = data_set_get_count (_tmp1_);
#line 6204 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1184 "../src/core/ViewCollection.vala"
		ctr = 0;
#line 6209 "ViewCollection.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1184 "../src/core/ViewCollection.vala"
			_tmp2_ = TRUE;
#line 1184 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 6216 "ViewCollection.c"
				GeeList* _tmp4_;
				DataSet* _tmp5_;
				DataObject* _tmp6_;
				DataView* _tmp7_;
				DataSource* _tmp8_;
				DataSource* _tmp9_;
#line 1184 "../src/core/ViewCollection.vala"
				if (!_tmp2_) {
#line 6225 "ViewCollection.c"
					gint _tmp3_;
#line 1184 "../src/core/ViewCollection.vala"
					_tmp3_ = ctr;
#line 1184 "../src/core/ViewCollection.vala"
					ctr = _tmp3_ + 1;
#line 6231 "ViewCollection.c"
				}
#line 1184 "../src/core/ViewCollection.vala"
				_tmp2_ = FALSE;
#line 1184 "../src/core/ViewCollection.vala"
				if (!(ctr < count)) {
#line 1184 "../src/core/ViewCollection.vala"
					break;
#line 6239 "ViewCollection.c"
				}
#line 1185 "../src/core/ViewCollection.vala"
				_tmp4_ = sources;
#line 1185 "../src/core/ViewCollection.vala"
				_tmp5_ = self->priv->selected;
#line 1185 "../src/core/ViewCollection.vala"
				_tmp6_ = data_set_get_at (_tmp5_, ctr);
#line 1185 "../src/core/ViewCollection.vala"
				_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_VIEW, DataView);
#line 1185 "../src/core/ViewCollection.vala"
				_tmp8_ = data_view_get_source (_tmp7_);
#line 1185 "../src/core/ViewCollection.vala"
				_tmp9_ = _tmp8_;
#line 1185 "../src/core/ViewCollection.vala"
				gee_collection_add ((GeeCollection*) _tmp4_, _tmp9_);
#line 1185 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp7_);
#line 6257 "ViewCollection.c"
			}
		}
	}
#line 1187 "../src/core/ViewCollection.vala"
	result = sources;
#line 1187 "../src/core/ViewCollection.vala"
	return result;
#line 6265 "ViewCollection.c"
}

DataSource*
view_collection_get_selected_source_at (ViewCollection* self,
                                        gint index)
{
	DataObject* object = NULL;
	DataSet* _tmp0_;
	DataObject* _tmp1_;
	DataSource* _tmp2_ = NULL;
	DataObject* _tmp3_;
	DataSource* _tmp7_;
	DataSource* result;
#line 1190 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1191 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1191 "../src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_at (_tmp0_, index);
#line 1191 "../src/core/ViewCollection.vala"
	object = _tmp1_;
#line 1193 "../src/core/ViewCollection.vala"
	_tmp3_ = object;
#line 1193 "../src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 6291 "ViewCollection.c"
		DataObject* _tmp4_;
		DataSource* _tmp5_;
		DataSource* _tmp6_;
#line 1193 "../src/core/ViewCollection.vala"
		_tmp4_ = object;
#line 1193 "../src/core/ViewCollection.vala"
		_tmp5_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 1193 "../src/core/ViewCollection.vala"
		_tmp6_ = _tmp5_;
#line 1193 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp6_;
#line 6303 "ViewCollection.c"
	} else {
#line 1193 "../src/core/ViewCollection.vala"
		_tmp2_ = NULL;
#line 6307 "ViewCollection.c"
	}
#line 1193 "../src/core/ViewCollection.vala"
	_tmp7_ = _g_object_ref0 (_tmp2_);
#line 1193 "../src/core/ViewCollection.vala"
	result = _tmp7_;
#line 1193 "../src/core/ViewCollection.vala"
	_g_object_unref0 (object);
#line 1193 "../src/core/ViewCollection.vala"
	return result;
#line 6317 "ViewCollection.c"
}

GeeList*
view_collection_get_selected_sources_of_type (ViewCollection* self,
                                              GType t)
{
	GeeList* sources = NULL;
	GeeList* result;
#line 1196 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1197 "../src/core/ViewCollection.vala"
	sources = NULL;
#line 6330 "ViewCollection.c"
	{
		GeeList* _view_list = NULL;
		GeeList* _tmp0_;
		gint _view_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _view_index = 0;
#line 1198 "../src/core/ViewCollection.vala"
		_tmp0_ = view_collection_get_selected (self);
#line 1198 "../src/core/ViewCollection.vala"
		_view_list = _tmp0_;
#line 1198 "../src/core/ViewCollection.vala"
		_tmp1_ = _view_list;
#line 1198 "../src/core/ViewCollection.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 1198 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1198 "../src/core/ViewCollection.vala"
		_view_size = _tmp3_;
#line 1198 "../src/core/ViewCollection.vala"
		_view_index = -1;
#line 1198 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 6355 "ViewCollection.c"
			gint _tmp4_;
			gint _tmp5_;
			DataView* view = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			DataSource* source = NULL;
			DataView* _tmp8_;
			DataSource* _tmp9_;
			DataSource* _tmp10_;
			DataSource* _tmp11_;
			DataSource* _tmp12_;
#line 1198 "../src/core/ViewCollection.vala"
			_view_index = _view_index + 1;
#line 1198 "../src/core/ViewCollection.vala"
			_tmp4_ = _view_index;
#line 1198 "../src/core/ViewCollection.vala"
			_tmp5_ = _view_size;
#line 1198 "../src/core/ViewCollection.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 1198 "../src/core/ViewCollection.vala"
				break;
#line 6377 "ViewCollection.c"
			}
#line 1198 "../src/core/ViewCollection.vala"
			_tmp6_ = _view_list;
#line 1198 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_list_get (_tmp6_, _view_index);
#line 1198 "../src/core/ViewCollection.vala"
			view = (DataView*) _tmp7_;
#line 1199 "../src/core/ViewCollection.vala"
			_tmp8_ = view;
#line 1199 "../src/core/ViewCollection.vala"
			_tmp9_ = data_view_get_source (_tmp8_);
#line 1199 "../src/core/ViewCollection.vala"
			_tmp10_ = _tmp9_;
#line 1199 "../src/core/ViewCollection.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1199 "../src/core/ViewCollection.vala"
			source = _tmp11_;
#line 1200 "../src/core/ViewCollection.vala"
			_tmp12_ = source;
#line 1200 "../src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp12_), t)) {
#line 6399 "ViewCollection.c"
				GeeList* _tmp13_;
				GeeList* _tmp15_;
				DataSource* _tmp16_;
#line 1201 "../src/core/ViewCollection.vala"
				_tmp13_ = sources;
#line 1201 "../src/core/ViewCollection.vala"
				if (_tmp13_ == NULL) {
#line 6407 "ViewCollection.c"
					GeeArrayList* _tmp14_;
#line 1202 "../src/core/ViewCollection.vala"
					_tmp14_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1202 "../src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1202 "../src/core/ViewCollection.vala"
					sources = (GeeList*) _tmp14_;
#line 6415 "ViewCollection.c"
				}
#line 1204 "../src/core/ViewCollection.vala"
				_tmp15_ = sources;
#line 1204 "../src/core/ViewCollection.vala"
				_tmp16_ = source;
#line 1204 "../src/core/ViewCollection.vala"
				gee_collection_add ((GeeCollection*) _tmp15_, _tmp16_);
#line 6423 "ViewCollection.c"
			}
#line 1198 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1198 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 6429 "ViewCollection.c"
		}
#line 1198 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_view_list);
#line 6433 "ViewCollection.c"
	}
#line 1208 "../src/core/ViewCollection.vala"
	result = sources;
#line 1208 "../src/core/ViewCollection.vala"
	return result;
#line 6439 "ViewCollection.c"
}

gint
view_collection_index_of_source (ViewCollection* self,
                                 DataSource* source)
{
	DataView* view = NULL;
	DataView* _tmp0_;
	gint _tmp1_ = 0;
	DataView* _tmp2_;
	gint result;
#line 1212 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1212 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (source != NULL, 0);
#line 1213 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, source);
#line 1213 "../src/core/ViewCollection.vala"
	view = _tmp0_;
#line 1215 "../src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 1215 "../src/core/ViewCollection.vala"
	if (_tmp2_ != NULL) {
#line 6463 "ViewCollection.c"
		DataView* _tmp3_;
#line 1215 "../src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 1215 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_index_of ((DataCollection*) self, (DataObject*) _tmp3_);
#line 6469 "ViewCollection.c"
	} else {
#line 1215 "../src/core/ViewCollection.vala"
		_tmp1_ = -1;
#line 6473 "ViewCollection.c"
	}
#line 1215 "../src/core/ViewCollection.vala"
	result = _tmp1_;
#line 1215 "../src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 1215 "../src/core/ViewCollection.vala"
	return result;
#line 6481 "ViewCollection.c"
}

void
view_collection_internal_notify_view_altered (ViewCollection* self,
                                              DataView* view)
{
#line 1219 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 1219 "../src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 1220 "../src/core/ViewCollection.vala"
	if (!data_collection_are_notifications_frozen ((DataCollection*) self)) {
#line 6494 "ViewCollection.c"
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
#line 1221 "../src/core/ViewCollection.vala"
		view_collection_notify_item_view_altered (self, view);
#line 1222 "../src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_singleton ((DataObject*) view);
#line 1222 "../src/core/ViewCollection.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1222 "../src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, _tmp1_);
#line 1222 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 6507 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp2_;
		GeeHashSet* _tmp4_;
#line 1224 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->frozen_views_altered;
#line 1224 "../src/core/ViewCollection.vala"
		if (_tmp2_ == NULL) {
#line 6515 "ViewCollection.c"
			GeeHashSet* _tmp3_;
#line 1225 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1225 "../src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_views_altered);
#line 1225 "../src/core/ViewCollection.vala"
			self->priv->frozen_views_altered = _tmp3_;
#line 6523 "ViewCollection.c"
		}
#line 1226 "../src/core/ViewCollection.vala"
		_tmp4_ = self->priv->frozen_views_altered;
#line 1226 "../src/core/ViewCollection.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, view);
#line 6529 "ViewCollection.c"
	}
}

void
view_collection_internal_notify_geometry_altered (ViewCollection* self,
                                                  DataView* view)
{
#line 1231 "../src/core/ViewCollection.vala"
	g_return_if_fail (self != NULL);
#line 1231 "../src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 1232 "../src/core/ViewCollection.vala"
	if (!data_collection_are_notifications_frozen ((DataCollection*) self)) {
#line 6543 "ViewCollection.c"
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
#line 1233 "../src/core/ViewCollection.vala"
		view_collection_notify_item_geometry_altered (self, view);
#line 1234 "../src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_singleton ((DataObject*) view);
#line 1234 "../src/core/ViewCollection.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1234 "../src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, _tmp1_);
#line 1234 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 6556 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp2_;
		GeeHashSet* _tmp4_;
#line 1236 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->frozen_geometries_altered;
#line 1236 "../src/core/ViewCollection.vala"
		if (_tmp2_ == NULL) {
#line 6564 "ViewCollection.c"
			GeeHashSet* _tmp3_;
#line 1237 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1237 "../src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1237 "../src/core/ViewCollection.vala"
			self->priv->frozen_geometries_altered = _tmp3_;
#line 6572 "ViewCollection.c"
		}
#line 1238 "../src/core/ViewCollection.vala"
		_tmp4_ = self->priv->frozen_geometries_altered;
#line 1238 "../src/core/ViewCollection.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, view);
#line 6578 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_thawed (DataCollection* base)
{
	ViewCollection * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp8_;
#line 1242 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) base;
#line 1243 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->frozen_views_altered;
#line 1243 "../src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 6594 "ViewCollection.c"
		GeeHashSet* _tmp7_;
		{
			GeeIterator* _view_it = NULL;
			GeeHashSet* _tmp1_;
			GeeIterator* _tmp2_;
#line 1244 "../src/core/ViewCollection.vala"
			_tmp1_ = self->priv->frozen_views_altered;
#line 1244 "../src/core/ViewCollection.vala"
			_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 1244 "../src/core/ViewCollection.vala"
			_view_it = _tmp2_;
#line 1244 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 6608 "ViewCollection.c"
				GeeIterator* _tmp3_;
				DataView* view = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				DataView* _tmp6_;
#line 1244 "../src/core/ViewCollection.vala"
				_tmp3_ = _view_it;
#line 1244 "../src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 1244 "../src/core/ViewCollection.vala"
					break;
#line 6620 "ViewCollection.c"
				}
#line 1244 "../src/core/ViewCollection.vala"
				_tmp4_ = _view_it;
#line 1244 "../src/core/ViewCollection.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 1244 "../src/core/ViewCollection.vala"
				view = (DataView*) _tmp5_;
#line 1245 "../src/core/ViewCollection.vala"
				_tmp6_ = view;
#line 1245 "../src/core/ViewCollection.vala"
				view_collection_notify_item_view_altered (self, _tmp6_);
#line 1244 "../src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6634 "ViewCollection.c"
			}
#line 1244 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 6638 "ViewCollection.c"
		}
#line 1246 "../src/core/ViewCollection.vala"
		_tmp7_ = self->priv->frozen_views_altered;
#line 1246 "../src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, (GeeCollection*) _tmp7_);
#line 1247 "../src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_views_altered);
#line 1247 "../src/core/ViewCollection.vala"
		self->priv->frozen_views_altered = NULL;
#line 6648 "ViewCollection.c"
	}
#line 1250 "../src/core/ViewCollection.vala"
	_tmp8_ = self->priv->frozen_geometries_altered;
#line 1250 "../src/core/ViewCollection.vala"
	if (_tmp8_ != NULL) {
#line 6654 "ViewCollection.c"
		GeeHashSet* _tmp15_;
		{
			GeeIterator* _view_it = NULL;
			GeeHashSet* _tmp9_;
			GeeIterator* _tmp10_;
#line 1251 "../src/core/ViewCollection.vala"
			_tmp9_ = self->priv->frozen_geometries_altered;
#line 1251 "../src/core/ViewCollection.vala"
			_tmp10_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp9_);
#line 1251 "../src/core/ViewCollection.vala"
			_view_it = _tmp10_;
#line 1251 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 6668 "ViewCollection.c"
				GeeIterator* _tmp11_;
				DataView* view = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				DataView* _tmp14_;
#line 1251 "../src/core/ViewCollection.vala"
				_tmp11_ = _view_it;
#line 1251 "../src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 1251 "../src/core/ViewCollection.vala"
					break;
#line 6680 "ViewCollection.c"
				}
#line 1251 "../src/core/ViewCollection.vala"
				_tmp12_ = _view_it;
#line 1251 "../src/core/ViewCollection.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 1251 "../src/core/ViewCollection.vala"
				view = (DataView*) _tmp13_;
#line 1252 "../src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 1252 "../src/core/ViewCollection.vala"
				view_collection_notify_item_geometry_altered (self, _tmp14_);
#line 1251 "../src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6694 "ViewCollection.c"
			}
#line 1251 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 6698 "ViewCollection.c"
		}
#line 1253 "../src/core/ViewCollection.vala"
		_tmp15_ = self->priv->frozen_geometries_altered;
#line 1253 "../src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, (GeeCollection*) _tmp15_);
#line 1254 "../src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1254 "../src/core/ViewCollection.vala"
		self->priv->frozen_geometries_altered = NULL;
#line 6708 "ViewCollection.c"
	}
#line 1257 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_thawed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 6712 "ViewCollection.c"
}

gboolean
view_collection_are_items_filtered_out (ViewCollection* self)
{
	gboolean result;
#line 1260 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1261 "../src/core/ViewCollection.vala"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) != data_collection_get_count ((DataCollection*) self);
#line 1261 "../src/core/ViewCollection.vala"
	return result;
#line 6725 "ViewCollection.c"
}

static void
view_collection_real_items_selected (ViewCollection* self,
                                     GeeIterable* selected)
{
#line 88 "../src/core/ViewCollection.vala"
	g_return_if_fail (selected != NULL);
#line 6734 "ViewCollection.c"
}

static void
view_collection_real_items_unselected (ViewCollection* self,
                                       GeeIterable* unselected)
{
#line 92 "../src/core/ViewCollection.vala"
	g_return_if_fail (unselected != NULL);
#line 6743 "ViewCollection.c"
}

static void
view_collection_real_items_state_changed (ViewCollection* self,
                                          GeeIterable* changed)
{
#line 96 "../src/core/ViewCollection.vala"
	g_return_if_fail (changed != NULL);
#line 6752 "ViewCollection.c"
}

static void
view_collection_real_selection_group_altered (ViewCollection* self)
{
}

static void
view_collection_real_items_shown (ViewCollection* self,
                                  GeeCollection* visible)
{
#line 107 "../src/core/ViewCollection.vala"
	g_return_if_fail (visible != NULL);
#line 6766 "ViewCollection.c"
}

static void
view_collection_real_items_hidden (ViewCollection* self,
                                   GeeCollection* hidden)
{
#line 111 "../src/core/ViewCollection.vala"
	g_return_if_fail (hidden != NULL);
#line 6775 "ViewCollection.c"
}

static void
view_collection_real_items_visibility_changed (ViewCollection* self,
                                               GeeCollection* changed)
{
#line 115 "../src/core/ViewCollection.vala"
	g_return_if_fail (changed != NULL);
#line 6784 "ViewCollection.c"
}

static void
view_collection_real_item_view_altered (ViewCollection* self,
                                        DataView* view)
{
#line 119 "../src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 6793 "ViewCollection.c"
}

static void
view_collection_real_item_geometry_altered (ViewCollection* self,
                                            DataView* view)
{
#line 123 "../src/core/ViewCollection.vala"
	g_return_if_fail (view != NULL);
#line 6802 "ViewCollection.c"
}

static void
view_collection_real_views_altered (ViewCollection* self,
                                    GeeCollection* views)
{
#line 126 "../src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 6811 "ViewCollection.c"
}

static void
view_collection_real_geometries_altered (ViewCollection* self,
                                         GeeCollection* views)
{
#line 129 "../src/core/ViewCollection.vala"
	g_return_if_fail (views != NULL);
#line 6820 "ViewCollection.c"
}

static void
view_collection_real_view_filter_installed (ViewCollection* self,
                                            ViewFilter* filer)
{
#line 132 "../src/core/ViewCollection.vala"
	g_return_if_fail (filer != NULL);
#line 6829 "ViewCollection.c"
}

static void
g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__VIEW_FILTER) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__VIEW_FILTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 34 "../src/core/ViewCollection.vala"
	g_return_if_fail (n_param_values == 2);
#line 34 "../src/core/ViewCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 34 "../src/core/ViewCollection.vala"
		data1 = closure->data;
#line 34 "../src/core/ViewCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 6854 "ViewCollection.c"
	} else {
#line 34 "../src/core/ViewCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 34 "../src/core/ViewCollection.vala"
		data2 = closure->data;
#line 6860 "ViewCollection.c"
	}
#line 34 "../src/core/ViewCollection.vala"
	callback = (GMarshalFunc_VOID__VIEW_FILTER) (marshal_data ? marshal_data : cc->callback);
#line 34 "../src/core/ViewCollection.vala"
	callback (data1, value_get_view_filter (param_values + 1), data2);
#line 6866 "ViewCollection.c"
}

static void
view_collection_real_view_filter_removed (ViewCollection* self,
                                          ViewFilter* filer)
{
#line 135 "../src/core/ViewCollection.vala"
	g_return_if_fail (filer != NULL);
#line 6875 "ViewCollection.c"
}

ViewCollectionMonitor*
view_collection_monitor_construct (GType object_type)
{
	ViewCollectionMonitor* self = NULL;
#line 35 "../src/core/ViewCollection.vala"
	self = (ViewCollectionMonitor*) g_type_create_instance (object_type);
#line 35 "../src/core/ViewCollection.vala"
	return self;
#line 6886 "ViewCollection.c"
}

ViewCollectionMonitor*
view_collection_monitor_new (void)
{
#line 35 "../src/core/ViewCollection.vala"
	return view_collection_monitor_construct (VIEW_COLLECTION_TYPE_MONITOR);
#line 6894 "ViewCollection.c"
}

static void
view_collection_value_monitor_init (GValue* value)
{
#line 35 "../src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 6902 "ViewCollection.c"
}

static void
view_collection_value_monitor_free_value (GValue* value)
{
#line 35 "../src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 35 "../src/core/ViewCollection.vala"
		view_collection_monitor_unref (value->data[0].v_pointer);
#line 6912 "ViewCollection.c"
	}
}

static void
view_collection_value_monitor_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 35 "../src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 35 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_collection_monitor_ref (src_value->data[0].v_pointer);
#line 6924 "ViewCollection.c"
	} else {
#line 35 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6928 "ViewCollection.c"
	}
}

static gpointer
view_collection_value_monitor_peek_pointer (const GValue* value)
{
#line 35 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 6937 "ViewCollection.c"
}

static gchar*
view_collection_value_monitor_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 35 "../src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 6948 "ViewCollection.c"
		ViewCollectionMonitor * object;
		object = collect_values[0].v_pointer;
#line 35 "../src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 35 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6955 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 35 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6959 "ViewCollection.c"
		}
#line 35 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_collection_monitor_ref (object);
#line 6963 "ViewCollection.c"
	} else {
#line 35 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 6967 "ViewCollection.c"
	}
#line 35 "../src/core/ViewCollection.vala"
	return NULL;
#line 6971 "ViewCollection.c"
}

static gchar*
view_collection_value_monitor_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	ViewCollectionMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 35 "../src/core/ViewCollection.vala"
	if (!object_p) {
#line 35 "../src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6986 "ViewCollection.c"
	}
#line 35 "../src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 35 "../src/core/ViewCollection.vala"
		*object_p = NULL;
#line 6992 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 35 "../src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 6996 "ViewCollection.c"
	} else {
#line 35 "../src/core/ViewCollection.vala"
		*object_p = view_collection_monitor_ref (value->data[0].v_pointer);
#line 7000 "ViewCollection.c"
	}
#line 35 "../src/core/ViewCollection.vala"
	return NULL;
#line 7004 "ViewCollection.c"
}

GParamSpec*
view_collection_param_spec_monitor (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	ViewCollectionParamSpecMonitor* spec;
#line 35 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 35 "../src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 35 "../src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 35 "../src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 7023 "ViewCollection.c"
}

gpointer
view_collection_value_get_monitor (const GValue* value)
{
#line 35 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 35 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 7033 "ViewCollection.c"
}

void
view_collection_value_set_monitor (GValue* value,
                                   gpointer v_object)
{
	ViewCollectionMonitor * old;
#line 35 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 35 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 35 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 35 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 35 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 35 "../src/core/ViewCollection.vala"
		view_collection_monitor_ref (value->data[0].v_pointer);
#line 7055 "ViewCollection.c"
	} else {
#line 35 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7059 "ViewCollection.c"
	}
#line 35 "../src/core/ViewCollection.vala"
	if (old) {
#line 35 "../src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 7065 "ViewCollection.c"
	}
}

void
view_collection_value_take_monitor (GValue* value,
                                    gpointer v_object)
{
	ViewCollectionMonitor * old;
#line 35 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 35 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 35 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 35 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 35 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 7086 "ViewCollection.c"
	} else {
#line 35 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7090 "ViewCollection.c"
	}
#line 35 "../src/core/ViewCollection.vala"
	if (old) {
#line 35 "../src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 7096 "ViewCollection.c"
	}
}

static void
view_collection_monitor_class_init (ViewCollectionMonitorClass * klass,
                                    gpointer klass_data)
{
#line 35 "../src/core/ViewCollection.vala"
	view_collection_monitor_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/core/ViewCollection.vala"
	((ViewCollectionMonitorClass *) klass)->finalize = view_collection_monitor_finalize;
#line 7108 "ViewCollection.c"
}

static void
view_collection_monitor_instance_init (ViewCollectionMonitor * self,
                                       gpointer klass)
{
#line 35 "../src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 7117 "ViewCollection.c"
}

static void
view_collection_monitor_finalize (ViewCollectionMonitor * obj)
{
	ViewCollectionMonitor * self;
#line 35 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor);
#line 35 "../src/core/ViewCollection.vala"
	g_signal_handlers_destroy (self);
#line 7128 "ViewCollection.c"
}

static GType
view_collection_monitor_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { view_collection_value_monitor_init, view_collection_value_monitor_free_value, view_collection_value_monitor_copy_value, view_collection_value_monitor_peek_pointer, "p", view_collection_value_monitor_collect_value, "p", view_collection_value_monitor_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitor), 0, (GInstanceInitFunc) view_collection_monitor_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType view_collection_monitor_type_id;
	view_collection_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewCollectionMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return view_collection_monitor_type_id;
}

GType
view_collection_monitor_get_type (void)
{
	static volatile gsize view_collection_monitor_type_id__once = 0;
	if (g_once_init_enter (&view_collection_monitor_type_id__once)) {
		GType view_collection_monitor_type_id;
		view_collection_monitor_type_id = view_collection_monitor_get_type_once ();
		g_once_init_leave (&view_collection_monitor_type_id__once, view_collection_monitor_type_id);
	}
	return view_collection_monitor_type_id__once;
}

gpointer
view_collection_monitor_ref (gpointer instance)
{
	ViewCollectionMonitor * self;
	self = instance;
#line 35 "../src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 35 "../src/core/ViewCollection.vala"
	return instance;
#line 7163 "ViewCollection.c"
}

void
view_collection_monitor_unref (gpointer instance)
{
	ViewCollectionMonitor * self;
	self = instance;
#line 35 "../src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 35 "../src/core/ViewCollection.vala"
		VIEW_COLLECTION_MONITOR_GET_CLASS (self)->finalize (self);
#line 35 "../src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7177 "ViewCollection.c"
	}
}

static void
_view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender,
                                                               GeeIterable* added,
                                                               gpointer self)
{
#line 57 "../src/core/ViewCollection.vala"
	view_collection_on_sources_added ((ViewCollection*) self, _sender, added);
#line 7188 "ViewCollection.c"
}

static void
_view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender,
                                                                   GeeIterable* removed,
                                                                   gpointer self)
{
#line 58 "../src/core/ViewCollection.vala"
	view_collection_on_sources_removed ((ViewCollection*) self, removed);
#line 7198 "ViewCollection.c"
}

static void
_view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender,
                                                                   GeeMap* items,
                                                                   gpointer self)
{
#line 59 "../src/core/ViewCollection.vala"
	view_collection_on_sources_altered ((ViewCollection*) self, _sender, items);
#line 7208 "ViewCollection.c"
}

static gpointer
_view_manager_ref0 (gpointer self)
{
#line 48 "../src/core/ViewCollection.vala"
	return self ? view_manager_ref (self) : NULL;
#line 7216 "ViewCollection.c"
}

static gpointer
_alteration_ref0 (gpointer self)
{
#line 49 "../src/core/ViewCollection.vala"
	return self ? alteration_ref (self) : NULL;
#line 7224 "ViewCollection.c"
}

static ViewCollectionMonitorImpl*
view_collection_monitor_impl_construct (GType object_type,
                                        ViewCollection* owner,
                                        SourceCollection* sources,
                                        ViewManager* manager,
                                        Alteration* prereq)
{
	ViewCollectionMonitorImpl* self = NULL;
	ViewCollection* _tmp0_;
	SourceCollection* _tmp1_;
	ViewManager* _tmp2_;
	Alteration* _tmp3_;
#line 44 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 44 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 44 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 44 "../src/core/ViewCollection.vala"
	self = (ViewCollectionMonitorImpl*) view_collection_monitor_construct (object_type);
#line 46 "../src/core/ViewCollection.vala"
	_tmp0_ = _data_collection_ref0 (owner);
#line 46 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 46 "../src/core/ViewCollection.vala"
	self->owner = _tmp0_;
#line 47 "../src/core/ViewCollection.vala"
	_tmp1_ = _data_collection_ref0 (sources);
#line 47 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 47 "../src/core/ViewCollection.vala"
	self->sources = _tmp1_;
#line 48 "../src/core/ViewCollection.vala"
	_tmp2_ = _view_manager_ref0 (manager);
#line 48 "../src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 48 "../src/core/ViewCollection.vala"
	self->manager = _tmp2_;
#line 49 "../src/core/ViewCollection.vala"
	_tmp3_ = _alteration_ref0 (prereq);
#line 49 "../src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 49 "../src/core/ViewCollection.vala"
	self->prereq = _tmp3_;
#line 51 "../src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) sources, "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, owner);
#line 52 "../src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) sources, "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, owner);
#line 53 "../src/core/ViewCollection.vala"
	g_signal_connect ((DataCollection*) sources, "items-altered", (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, owner);
#line 44 "../src/core/ViewCollection.vala"
	return self;
#line 7279 "ViewCollection.c"
}

static ViewCollectionMonitorImpl*
view_collection_monitor_impl_new (ViewCollection* owner,
                                  SourceCollection* sources,
                                  ViewManager* manager,
                                  Alteration* prereq)
{
#line 44 "../src/core/ViewCollection.vala"
	return view_collection_monitor_impl_construct (VIEW_COLLECTION_TYPE_MONITOR_IMPL, owner, sources, manager, prereq);
#line 7290 "ViewCollection.c"
}

static void
view_collection_monitor_impl_class_init (ViewCollectionMonitorImplClass * klass,
                                         gpointer klass_data)
{
#line 38 "../src/core/ViewCollection.vala"
	view_collection_monitor_impl_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/core/ViewCollection.vala"
	((ViewCollectionMonitorClass *) klass)->finalize = view_collection_monitor_impl_finalize;
#line 7301 "ViewCollection.c"
}

static void
view_collection_monitor_impl_instance_init (ViewCollectionMonitorImpl * self,
                                            gpointer klass)
{
}

static void
view_collection_monitor_impl_finalize (ViewCollectionMonitor * obj)
{
	ViewCollectionMonitorImpl * self;
	SourceCollection* _tmp0_;
	ViewCollection* _tmp1_;
	guint _tmp2_;
	SourceCollection* _tmp3_;
	ViewCollection* _tmp4_;
	guint _tmp5_;
	SourceCollection* _tmp6_;
	ViewCollection* _tmp7_;
	guint _tmp8_;
#line 38 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl);
#line 57 "../src/core/ViewCollection.vala"
	_tmp0_ = self->sources;
#line 57 "../src/core/ViewCollection.vala"
	_tmp1_ = self->owner;
#line 57 "../src/core/ViewCollection.vala"
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 57 "../src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, _tmp1_);
#line 58 "../src/core/ViewCollection.vala"
	_tmp3_ = self->sources;
#line 58 "../src/core/ViewCollection.vala"
	_tmp4_ = self->owner;
#line 58 "../src/core/ViewCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp5_, NULL, FALSE);
#line 58 "../src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, _tmp4_);
#line 59 "../src/core/ViewCollection.vala"
	_tmp6_ = self->sources;
#line 59 "../src/core/ViewCollection.vala"
	_tmp7_ = self->owner;
#line 59 "../src/core/ViewCollection.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 59 "../src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, _tmp7_);
#line 39 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 40 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 41 "../src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 42 "../src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 38 "../src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (view_collection_monitor_impl_parent_class)->finalize (obj);
#line 7359 "ViewCollection.c"
}

static GType
view_collection_monitor_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitorImpl), 0, (GInstanceInitFunc) view_collection_monitor_impl_instance_init, NULL };
	GType view_collection_monitor_impl_type_id;
	view_collection_monitor_impl_type_id = g_type_register_static (VIEW_COLLECTION_TYPE_MONITOR, "ViewCollectionMonitorImpl", &g_define_type_info, 0);
	return view_collection_monitor_impl_type_id;
}

static GType
view_collection_monitor_impl_get_type (void)
{
	static volatile gsize view_collection_monitor_impl_type_id__once = 0;
	if (g_once_init_enter (&view_collection_monitor_impl_type_id__once)) {
		GType view_collection_monitor_impl_type_id;
		view_collection_monitor_impl_type_id = view_collection_monitor_impl_get_type_once ();
		g_once_init_leave (&view_collection_monitor_impl_type_id__once, view_collection_monitor_impl_type_id);
	}
	return view_collection_monitor_impl_type_id__once;
}

static ViewCollectionToggleLists*
view_collection_toggle_lists_construct (GType object_type)
{
	ViewCollectionToggleLists * self = NULL;
#line 63 "../src/core/ViewCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 63 "../src/core/ViewCollection.vala"
	return self;
#line 7391 "ViewCollection.c"
}

static ViewCollectionToggleLists*
view_collection_toggle_lists_new (void)
{
#line 63 "../src/core/ViewCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 7399 "ViewCollection.c"
}

static void
view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass,
                                         gpointer klass_data)
{
#line 63 "../src/core/ViewCollection.vala"
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
#line 63 "../src/core/ViewCollection.vala"
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
#line 7410 "ViewCollection.c"
}

static void
view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self,
                                            gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 64 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 64 "../src/core/ViewCollection.vala"
	self->selected = _tmp0_;
#line 65 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 65 "../src/core/ViewCollection.vala"
	self->unselected = _tmp1_;
#line 7427 "ViewCollection.c"
}

static void
view_collection_toggle_lists_finalize (GObject * obj)
{
	ViewCollectionToggleLists * self;
#line 63 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists);
#line 64 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->selected);
#line 65 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->unselected);
#line 63 "../src/core/ViewCollection.vala"
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
#line 7442 "ViewCollection.c"
}

static GType
view_collection_toggle_lists_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
	GType view_collection_toggle_lists_type_id;
	view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
	return view_collection_toggle_lists_type_id;
}

static GType
view_collection_toggle_lists_get_type (void)
{
	static volatile gsize view_collection_toggle_lists_type_id__once = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__once)) {
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = view_collection_toggle_lists_get_type_once ();
		g_once_init_leave (&view_collection_toggle_lists_type_id__once, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__once;
}

static void
view_collection_class_init (ViewCollectionClass * klass,
                            gpointer klass_data)
{
#line 34 "../src/core/ViewCollection.vala"
	view_collection_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->finalize = view_collection_finalize;
#line 34 "../src/core/ViewCollection.vala"
	g_type_class_adjust_private_offset (klass, &ViewCollection_private_offset);
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_selected_unselected = (void (*) (ViewCollection*, GeeCollection*, GeeCollection*)) view_collection_real_notify_items_selected_unselected;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_selection_group_altered = (void (*) (ViewCollection*)) view_collection_real_notify_selection_group_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_item_view_altered = (void (*) (ViewCollection*, DataView*)) view_collection_real_notify_item_view_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_views_altered = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_views_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_item_geometry_altered = (void (*) (ViewCollection*, DataView*)) view_collection_real_notify_item_geometry_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_geometries_altered = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_geometries_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_shown = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_items_shown;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_hidden = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_items_hidden;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_visibility_changed = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_items_visibility_changed;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_view_filter_installed = (void (*) (ViewCollection*, ViewFilter*)) view_collection_real_notify_view_filter_installed;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_view_filter_removed = (void (*) (ViewCollection*, ViewFilter*)) view_collection_real_notify_view_filter_removed;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->clear = (void (*) (DataCollection*)) view_collection_real_clear;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->close = (void (*) (DataCollection*)) view_collection_real_close;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->valid_type = (gboolean (*) (DataCollection*, DataObject*)) view_collection_real_valid_type;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->add = (gboolean (*) (DataCollection*, DataObject*)) view_collection_real_add;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->add_many = (GeeCollection* (*) (DataCollection*, GeeCollection*, ProgressMonitor, gpointer)) view_collection_real_add_many;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_items_added = (void (*) (DataCollection*, GeeIterable*)) view_collection_real_notify_items_added;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_items_removed = (void (*) (DataCollection*, GeeIterable*)) view_collection_real_notify_items_removed;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) view_collection_real_items_altered;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->set_comparator = (void (*) (DataCollection*, Comparator, gpointer, ComparatorPredicate, gpointer)) view_collection_real_set_comparator;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->reset_comparator = (void (*) (DataCollection*)) view_collection_real_reset_comparator;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_all = (GeeCollection* (*) (DataCollection*)) view_collection_real_get_all;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_count = (gint (*) (DataCollection*)) view_collection_real_get_count;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_at = (DataObject* (*) (DataCollection*, gint)) view_collection_real_get_at;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->index_of = (gint (*) (DataCollection*, DataObject*)) view_collection_real_index_of;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->contains = (gboolean (*) (DataCollection*, DataObject*)) view_collection_real_contains;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_first = (DataView* (*) (ViewCollection*)) view_collection_real_get_first;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_first_unrejected = (DataView* (*) (ViewCollection*)) view_collection_real_get_first_unrejected;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_last = (DataView* (*) (ViewCollection*)) view_collection_real_get_last;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_next = (DataView* (*) (ViewCollection*, DataView*)) view_collection_real_get_next;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_previous = (DataView* (*) (ViewCollection*, DataView*)) view_collection_real_get_previous;
#line 34 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_thawed = (void (*) (DataCollection*)) view_collection_real_notify_thawed;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_selected = view_collection_real_items_selected;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_unselected = view_collection_real_items_unselected;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_state_changed = view_collection_real_items_state_changed;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->selection_group_altered = view_collection_real_selection_group_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_shown = view_collection_real_items_shown;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_hidden = view_collection_real_items_hidden;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->item_view_altered = view_collection_real_item_view_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->views_altered = view_collection_real_views_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->geometries_altered = view_collection_real_geometries_altered;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->view_filter_installed = view_collection_real_view_filter_installed;
#line 34 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->view_filter_removed = view_collection_real_view_filter_removed;
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL] = g_signal_new ("items-selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL] = g_signal_new ("items-unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL] = g_signal_new ("items-state-changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL] = g_signal_new ("selection-group-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL] = g_signal_new ("items-shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL] = g_signal_new ("items-hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("items-visibility-changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL] = g_signal_new ("item-view-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL] = g_signal_new ("item-geometry-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL] = g_signal_new ("views-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL] = g_signal_new ("geometries-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL] = g_signal_new ("view-filter-installed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_installed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 34 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL] = g_signal_new ("view-filter-removed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_removed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 7592 "ViewCollection.c"
}

static void
view_collection_instance_init (ViewCollection * self,
                               gpointer klass)
{
	GeeHashMultiMap* _tmp0_;
	GeeHashSet* _tmp1_;
	DataSet* _tmp2_;
	GeeHashMap* _tmp3_;
#line 34 "../src/core/ViewCollection.vala"
	self->priv = view_collection_get_instance_private (self);
#line 72 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, (GDestroyNotify) data_collection_unref, VIEW_COLLECTION_TYPE_MONITOR_IMPL, (GBoxedCopyFunc) view_collection_monitor_ref, (GDestroyNotify) view_collection_monitor_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 72 "../src/core/ViewCollection.vala"
	self->priv->monitors = _tmp0_;
#line 74 "../src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 75 "../src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = NULL;
#line 75 "../src/core/ViewCollection.vala"
	self->priv->mirroring_ctor_target = NULL;
#line 76 "../src/core/ViewCollection.vala"
	self->priv->should_mirror = NULL;
#line 76 "../src/core/ViewCollection.vala"
	self->priv->should_mirror_target = NULL;
#line 77 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_hash_set_new (TYPE_VIEW_FILTER, (GBoxedCopyFunc) view_filter_ref, (GDestroyNotify) view_filter_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 77 "../src/core/ViewCollection.vala"
	self->priv->filters = (GeeSet*) _tmp1_;
#line 78 "../src/core/ViewCollection.vala"
	_tmp2_ = data_set_new ();
#line 78 "../src/core/ViewCollection.vala"
	self->priv->selected = _tmp2_;
#line 79 "../src/core/ViewCollection.vala"
	self->priv->visible = NULL;
#line 80 "../src/core/ViewCollection.vala"
	self->priv->frozen_views_altered = NULL;
#line 81 "../src/core/ViewCollection.vala"
	self->priv->frozen_geometries_altered = NULL;
#line 85 "../src/core/ViewCollection.vala"
	_tmp3_ = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 85 "../src/core/ViewCollection.vala"
	self->priv->source_map = _tmp3_;
#line 7637 "ViewCollection.c"
}

static void
view_collection_finalize (DataCollection * obj)
{
	ViewCollection * self;
#line 34 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_COLLECTION, ViewCollection);
#line 72 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->monitors);
#line 74 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 77 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->filters);
#line 78 "../src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->selected);
#line 79 "../src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->visible);
#line 80 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_views_altered);
#line 81 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 85 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->source_map);
#line 34 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
#line 7664 "ViewCollection.c"
}

static GType
view_collection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
	GType view_collection_type_id;
	view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
	ViewCollection_private_offset = g_type_add_instance_private (view_collection_type_id, sizeof (ViewCollectionPrivate));
	return view_collection_type_id;
}

GType
view_collection_get_type (void)
{
	static volatile gsize view_collection_type_id__once = 0;
	if (g_once_init_enter (&view_collection_type_id__once)) {
		GType view_collection_type_id;
		view_collection_type_id = view_collection_get_type_once ();
		g_once_init_leave (&view_collection_type_id__once, view_collection_type_id);
	}
	return view_collection_type_id__once;
}

static gboolean
view_filter_real_predicate (ViewFilter* self,
                            DataView* view)
{
	gboolean _tmp0_ = FALSE;
#line 1284 "../src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_filter_predicate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1284 "../src/core/ViewCollection.vala"
	return _tmp0_;
#line 7698 "ViewCollection.c"
}

gboolean
view_filter_predicate (ViewFilter* self,
                       DataView* view)
{
	ViewFilterClass* _klass_;
#line 1284 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1284 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_FILTER_GET_CLASS (self);
#line 1284 "../src/core/ViewCollection.vala"
	if (_klass_->predicate) {
#line 1284 "../src/core/ViewCollection.vala"
		return _klass_->predicate (self, view);
#line 7714 "ViewCollection.c"
	}
#line 1284 "../src/core/ViewCollection.vala"
	return FALSE;
#line 7718 "ViewCollection.c"
}

ViewFilter*
view_filter_construct (GType object_type)
{
	ViewFilter* self = NULL;
#line 1277 "../src/core/ViewCollection.vala"
	self = (ViewFilter*) g_type_create_instance (object_type);
#line 1277 "../src/core/ViewCollection.vala"
	return self;
#line 7729 "ViewCollection.c"
}

static void
view_filter_real_refresh (ViewFilter* self)
{
}

static void
value_view_filter_init (GValue* value)
{
#line 1277 "../src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 7742 "ViewCollection.c"
}

static void
value_view_filter_free_value (GValue* value)
{
#line 1277 "../src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1277 "../src/core/ViewCollection.vala"
		view_filter_unref (value->data[0].v_pointer);
#line 7752 "ViewCollection.c"
	}
}

static void
value_view_filter_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 1277 "../src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1277 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_filter_ref (src_value->data[0].v_pointer);
#line 7764 "ViewCollection.c"
	} else {
#line 1277 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7768 "ViewCollection.c"
	}
}

static gpointer
value_view_filter_peek_pointer (const GValue* value)
{
#line 1277 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 7777 "ViewCollection.c"
}

static gchar*
value_view_filter_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 1277 "../src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 7788 "ViewCollection.c"
		ViewFilter * object;
		object = collect_values[0].v_pointer;
#line 1277 "../src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1277 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7795 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1277 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7799 "ViewCollection.c"
		}
#line 1277 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_filter_ref (object);
#line 7803 "ViewCollection.c"
	} else {
#line 1277 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7807 "ViewCollection.c"
	}
#line 1277 "../src/core/ViewCollection.vala"
	return NULL;
#line 7811 "ViewCollection.c"
}

static gchar*
value_view_filter_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	ViewFilter ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1277 "../src/core/ViewCollection.vala"
	if (!object_p) {
#line 1277 "../src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7826 "ViewCollection.c"
	}
#line 1277 "../src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1277 "../src/core/ViewCollection.vala"
		*object_p = NULL;
#line 7832 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1277 "../src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 7836 "ViewCollection.c"
	} else {
#line 1277 "../src/core/ViewCollection.vala"
		*object_p = view_filter_ref (value->data[0].v_pointer);
#line 7840 "ViewCollection.c"
	}
#line 1277 "../src/core/ViewCollection.vala"
	return NULL;
#line 7844 "ViewCollection.c"
}

GParamSpec*
param_spec_view_filter (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecViewFilter* spec;
#line 1277 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_FILTER), NULL);
#line 1277 "../src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1277 "../src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1277 "../src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 7863 "ViewCollection.c"
}

gpointer
value_get_view_filter (const GValue* value)
{
#line 1277 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER), NULL);
#line 1277 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 7873 "ViewCollection.c"
}

void
value_set_view_filter (GValue* value,
                       gpointer v_object)
{
	ViewFilter * old;
#line 1277 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1277 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1277 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 1277 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1277 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1277 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1277 "../src/core/ViewCollection.vala"
		view_filter_ref (value->data[0].v_pointer);
#line 7895 "ViewCollection.c"
	} else {
#line 1277 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7899 "ViewCollection.c"
	}
#line 1277 "../src/core/ViewCollection.vala"
	if (old) {
#line 1277 "../src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 7905 "ViewCollection.c"
	}
}

void
value_take_view_filter (GValue* value,
                        gpointer v_object)
{
	ViewFilter * old;
#line 1277 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1277 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1277 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 1277 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1277 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1277 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 7926 "ViewCollection.c"
	} else {
#line 1277 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7930 "ViewCollection.c"
	}
#line 1277 "../src/core/ViewCollection.vala"
	if (old) {
#line 1277 "../src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 7936 "ViewCollection.c"
	}
}

static void
view_filter_class_init (ViewFilterClass * klass,
                        gpointer klass_data)
{
#line 1277 "../src/core/ViewCollection.vala"
	view_filter_parent_class = g_type_class_peek_parent (klass);
#line 1277 "../src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->finalize = view_filter_finalize;
#line 1277 "../src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) view_filter_real_predicate;
#line 1277 "../src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->refresh = view_filter_real_refresh;
#line 1277 "../src/core/ViewCollection.vala"
	view_filter_signals[VIEW_FILTER_REFRESH_SIGNAL] = g_signal_new ("refresh", TYPE_VIEW_FILTER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewFilterClass, refresh), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 7954 "ViewCollection.c"
}

static void
view_filter_instance_init (ViewFilter * self,
                           gpointer klass)
{
#line 1277 "../src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 7963 "ViewCollection.c"
}

static void
view_filter_finalize (ViewFilter * obj)
{
	ViewFilter * self;
#line 1277 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_FILTER, ViewFilter);
#line 1277 "../src/core/ViewCollection.vala"
	g_signal_handlers_destroy (self);
#line 7974 "ViewCollection.c"
}

static GType
view_filter_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_view_filter_init, value_view_filter_free_value, value_view_filter_copy_value, value_view_filter_peek_pointer, "p", value_view_filter_collect_value, "p", value_view_filter_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewFilter), 0, (GInstanceInitFunc) view_filter_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType view_filter_type_id;
	view_filter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewFilter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return view_filter_type_id;
}

GType
view_filter_get_type (void)
{
	static volatile gsize view_filter_type_id__once = 0;
	if (g_once_init_enter (&view_filter_type_id__once)) {
		GType view_filter_type_id;
		view_filter_type_id = view_filter_get_type_once ();
		g_once_init_leave (&view_filter_type_id__once, view_filter_type_id);
	}
	return view_filter_type_id__once;
}

gpointer
view_filter_ref (gpointer instance)
{
	ViewFilter * self;
	self = instance;
#line 1277 "../src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1277 "../src/core/ViewCollection.vala"
	return instance;
#line 8009 "ViewCollection.c"
}

void
view_filter_unref (gpointer instance)
{
	ViewFilter * self;
	self = instance;
#line 1277 "../src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1277 "../src/core/ViewCollection.vala"
		VIEW_FILTER_GET_CLASS (self)->finalize (self);
#line 1277 "../src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8023 "ViewCollection.c"
	}
}

