/* PhotoTable.c generated by valac 0.56.18, the Vala compiler
 * generated from PhotoTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <gee.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPhotoRow ParamSpecPhotoRow;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _ParamSpecBackingPhotoRow ParamSpecBackingPhotoRow;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ParamSpecPhotoRow {
	GParamSpec parent_instance;
};

struct _ParamSpecBackingPhotoRow {
	GParamSpec parent_instance;
};

static gpointer photo_row_parent_class = NULL;
static gpointer photo_table_parent_class = NULL;
static PhotoTable* photo_table_instance;
static PhotoTable* photo_table_instance = NULL;
static gpointer backing_photo_row_parent_class = NULL;
static gpointer backing_photo_table_parent_class = NULL;
static BackingPhotoTable* backing_photo_table_instance;
static BackingPhotoTable* backing_photo_table_instance = NULL;

static void photo_row_finalize (PhotoRow * obj);
static GType photo_row_get_type_once (void);
static PhotoTable* photo_table_new (void);
static PhotoTable* photo_table_construct (GType object_type);
static void photo_table_validate_orientation (PhotoTable* self,
                                       PhotoRow* row);
static gchar* photo_table_get_raw_transformations (PhotoTable* self,
                                            PhotoID* photo_id);
static gboolean photo_table_set_raw_transformations (PhotoTable* self,
                                              PhotoID* photo_id,
                                              const gchar* trans);
static gboolean photo_table_set_raw_original_transforms (PhotoTable* self,
                                                  PhotoID* photo_id,
                                                  const gchar* trans);
static sqlite3_stmt* photo_table_get_duplicate_stmt (PhotoTable* self,
                                              GFile* file,
                                              const gchar* thumbnail_md5,
                                              const gchar* md5,
                                              PhotoFileFormat file_format);
static void _vala_array_add49 (PhotoID* * array,
                        gint* length,
                        gint* size,
                        const PhotoID* value);
static void photo_table_finalize (DatabaseTable * obj);
static GType photo_table_get_type_once (void);
static void backing_photo_row_finalize (BackingPhotoRow * obj);
static GType backing_photo_row_get_type_once (void);
static BackingPhotoTable* backing_photo_table_new (void);
static BackingPhotoTable* backing_photo_table_construct (GType object_type);
static void backing_photo_table_finalize (DatabaseTable * obj);
static GType backing_photo_table_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
photo_id_init (PhotoID *self,
               gint64 id)
{
#line 25 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (PhotoID));
#line 26 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 123 "PhotoTable.c"
}

gboolean
photo_id_is_invalid (PhotoID *self)
{
	gboolean result;
#line 30 "../src/db/PhotoTable.vala"
	result = (*self).id == PHOTO_ID_INVALID;
#line 30 "../src/db/PhotoTable.vala"
	return result;
#line 134 "PhotoTable.c"
}

gboolean
photo_id_is_valid (PhotoID *self)
{
	gboolean result;
#line 34 "../src/db/PhotoTable.vala"
	result = (*self).id != PHOTO_ID_INVALID;
#line 34 "../src/db/PhotoTable.vala"
	return result;
#line 145 "PhotoTable.c"
}

guint
photo_id_hash (PhotoID *self)
{
	guint result;
#line 38 "../src/db/PhotoTable.vala"
	result = int64_hash (&(*self).id);
#line 38 "../src/db/PhotoTable.vala"
	return result;
#line 156 "PhotoTable.c"
}

gboolean
photo_id_equal (void* a,
                void* b)
{
	gboolean result;
#line 42 "../src/db/PhotoTable.vala"
	result = (*((PhotoID*) a)).id == (*((PhotoID*) b)).id;
#line 42 "../src/db/PhotoTable.vala"
	return result;
#line 168 "PhotoTable.c"
}

gchar*
photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id)
{
	PhotoID _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 45 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 46 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 46 "../src/db/PhotoTable.vala"
	_tmp1_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", PHOTO_TYPENAME, _tmp0_.id);
#line 46 "../src/db/PhotoTable.vala"
	result = _tmp1_;
#line 46 "../src/db/PhotoTable.vala"
	return result;
#line 187 "PhotoTable.c"
}

PhotoID*
photo_id_dup (const PhotoID* self)
{
	PhotoID* dup;
#line 20 "../src/db/PhotoTable.vala"
	dup = g_new0 (PhotoID, 1);
#line 20 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (PhotoID));
#line 20 "../src/db/PhotoTable.vala"
	return dup;
#line 200 "PhotoTable.c"
}

void
photo_id_free (PhotoID* self)
{
#line 20 "../src/db/PhotoTable.vala"
	g_free (self);
#line 208 "PhotoTable.c"
}

static GType
photo_id_get_type_once (void)
{
	GType photo_id_type_id;
	photo_id_type_id = g_boxed_type_register_static ("PhotoID", (GBoxedCopyFunc) photo_id_dup, (GBoxedFreeFunc) photo_id_free);
	return photo_id_type_id;
}

GType
photo_id_get_type (void)
{
	static volatile gsize photo_id_type_id__once = 0;
	if (g_once_init_enter (&photo_id_type_id__once)) {
		GType photo_id_type_id;
		photo_id_type_id = photo_id_get_type_once ();
		g_once_init_leave (&photo_id_type_id__once, photo_id_type_id);
	}
	return photo_id_type_id__once;
}

void
import_id_init (ImportID *self,
                gint64 id)
{
#line 55 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (ImportID));
#line 56 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 239 "PhotoTable.c"
}

void
import_id_generate (ImportID* result)
{
	ImportID _tmp0_ = {0};
#line 60 "../src/db/PhotoTable.vala"
	import_id_init (&_tmp0_, now_sec ());
#line 60 "../src/db/PhotoTable.vala"
	*result = _tmp0_;
#line 60 "../src/db/PhotoTable.vala"
	return;
#line 252 "PhotoTable.c"
}

gboolean
import_id_is_invalid (ImportID *self)
{
	gboolean result;
#line 64 "../src/db/PhotoTable.vala"
	result = (*self).id == IMPORT_ID_INVALID;
#line 64 "../src/db/PhotoTable.vala"
	return result;
#line 263 "PhotoTable.c"
}

gboolean
import_id_is_valid (ImportID *self)
{
	gboolean result;
#line 68 "../src/db/PhotoTable.vala"
	result = (*self).id != IMPORT_ID_INVALID;
#line 68 "../src/db/PhotoTable.vala"
	return result;
#line 274 "PhotoTable.c"
}

gint
import_id_compare_func (ImportID* a,
                        ImportID* b)
{
	gboolean _tmp0_ = FALSE;
	gint result;
#line 72 "../src/db/PhotoTable.vala"
	if (a != NULL) {
#line 72 "../src/db/PhotoTable.vala"
		_tmp0_ = b != NULL;
#line 287 "PhotoTable.c"
	} else {
#line 72 "../src/db/PhotoTable.vala"
		_tmp0_ = FALSE;
#line 291 "PhotoTable.c"
	}
#line 72 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp0_, "a != null && b != null");
#line 73 "../src/db/PhotoTable.vala"
	result = (gint) ((*a).id - (*b).id);
#line 73 "../src/db/PhotoTable.vala"
	return result;
#line 299 "PhotoTable.c"
}

gint64
import_id_comparator (void* a,
                      void* b)
{
	gint64 result;
#line 77 "../src/db/PhotoTable.vala"
	result = (*((ImportID*) a)).id - (*((ImportID*) b)).id;
#line 77 "../src/db/PhotoTable.vala"
	return result;
#line 311 "PhotoTable.c"
}

ImportID*
import_id_dup (const ImportID* self)
{
	ImportID* dup;
#line 50 "../src/db/PhotoTable.vala"
	dup = g_new0 (ImportID, 1);
#line 50 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (ImportID));
#line 50 "../src/db/PhotoTable.vala"
	return dup;
#line 324 "PhotoTable.c"
}

void
import_id_free (ImportID* self)
{
#line 50 "../src/db/PhotoTable.vala"
	g_free (self);
#line 332 "PhotoTable.c"
}

static GType
import_id_get_type_once (void)
{
	GType import_id_type_id;
	import_id_type_id = g_boxed_type_register_static ("ImportID", (GBoxedCopyFunc) import_id_dup, (GBoxedFreeFunc) import_id_free);
	return import_id_type_id;
}

GType
import_id_get_type (void)
{
	static volatile gsize import_id_type_id__once = 0;
	if (g_once_init_enter (&import_id_type_id__once)) {
		GType import_id_type_id;
		import_id_type_id = import_id_get_type_once ();
		g_once_init_leave (&import_id_type_id__once, import_id_type_id);
	}
	return import_id_type_id__once;
}

PhotoRow*
photo_row_construct (GType object_type)
{
	PhotoRow* self = NULL;
	BackingPhotoRow* _tmp0_;
	gint _tmp1_ = 0;
	RawDeveloper* _tmp2_;
	RawDeveloper* _tmp3_;
	gint _tmp3__length1;
	BackingPhotoID* _tmp4_;
	gint _tmp5_ = 0;
	RawDeveloper* _tmp6_;
#line 110 "../src/db/PhotoTable.vala"
	self = (PhotoRow*) g_type_create_instance (object_type);
#line 111 "../src/db/PhotoTable.vala"
	_tmp0_ = backing_photo_row_new ();
#line 111 "../src/db/PhotoTable.vala"
	_backing_photo_row_unref0 (self->master);
#line 111 "../src/db/PhotoTable.vala"
	self->master = _tmp0_;
#line 112 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&self->editable_id, BACKING_PHOTO_ID_INVALID);
#line 113 "../src/db/PhotoTable.vala"
	_tmp2_ = raw_developer_as_array (&_tmp1_);
#line 113 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_;
#line 113 "../src/db/PhotoTable.vala"
	_tmp3__length1 = _tmp1_;
#line 113 "../src/db/PhotoTable.vala"
	_tmp4_ = g_new0 (BackingPhotoID, _tmp1_);
#line 113 "../src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 113 "../src/db/PhotoTable.vala"
	self->development_ids = _tmp4_;
#line 113 "../src/db/PhotoTable.vala"
	self->development_ids_length1 = _tmp1_;
#line 113 "../src/db/PhotoTable.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 114 "../src/db/PhotoTable.vala"
	_tmp6_ = raw_developer_as_array (&_tmp5_);
#line 395 "PhotoTable.c"
	{
		RawDeveloper* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 114 "../src/db/PhotoTable.vala"
		d_collection = _tmp6_;
#line 114 "../src/db/PhotoTable.vala"
		d_collection_length1 = _tmp5_;
#line 114 "../src/db/PhotoTable.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 407 "PhotoTable.c"
			RawDeveloper d = 0;
#line 114 "../src/db/PhotoTable.vala"
			d = d_collection[d_it];
#line 411 "PhotoTable.c"
			{
				BackingPhotoID* _tmp7_;
				gint _tmp7__length1;
				BackingPhotoID _tmp8_ = {0};
#line 115 "../src/db/PhotoTable.vala"
				_tmp7_ = self->development_ids;
#line 115 "../src/db/PhotoTable.vala"
				_tmp7__length1 = self->development_ids_length1;
#line 115 "../src/db/PhotoTable.vala"
				backing_photo_id_init (&_tmp8_, BACKING_PHOTO_ID_INVALID);
#line 115 "../src/db/PhotoTable.vala"
				_tmp7_[d] = _tmp8_;
#line 424 "PhotoTable.c"
			}
		}
#line 114 "../src/db/PhotoTable.vala"
		d_collection = (g_free (d_collection), NULL);
#line 429 "PhotoTable.c"
	}
#line 110 "../src/db/PhotoTable.vala"
	return self;
#line 433 "PhotoTable.c"
}

PhotoRow*
photo_row_new (void)
{
#line 110 "../src/db/PhotoTable.vala"
	return photo_row_construct (TYPE_PHOTO_ROW);
#line 441 "PhotoTable.c"
}

static void
value_photo_row_init (GValue* value)
{
#line 81 "../src/db/PhotoTable.vala"
	value->data[0].v_pointer = NULL;
#line 449 "PhotoTable.c"
}

static void
value_photo_row_free_value (GValue* value)
{
#line 81 "../src/db/PhotoTable.vala"
	if (value->data[0].v_pointer) {
#line 81 "../src/db/PhotoTable.vala"
		photo_row_unref (value->data[0].v_pointer);
#line 459 "PhotoTable.c"
	}
}

static void
value_photo_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 81 "../src/db/PhotoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 81 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = photo_row_ref (src_value->data[0].v_pointer);
#line 471 "PhotoTable.c"
	} else {
#line 81 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 475 "PhotoTable.c"
	}
}

static gpointer
value_photo_row_peek_pointer (const GValue* value)
{
#line 81 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 484 "PhotoTable.c"
}

static gchar*
value_photo_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 81 "../src/db/PhotoTable.vala"
	if (collect_values[0].v_pointer) {
#line 495 "PhotoTable.c"
		PhotoRow * object;
		object = collect_values[0].v_pointer;
#line 81 "../src/db/PhotoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 81 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 502 "PhotoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 81 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 506 "PhotoTable.c"
		}
#line 81 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = photo_row_ref (object);
#line 510 "PhotoTable.c"
	} else {
#line 81 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 514 "PhotoTable.c"
	}
#line 81 "../src/db/PhotoTable.vala"
	return NULL;
#line 518 "PhotoTable.c"
}

static gchar*
value_photo_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	PhotoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 81 "../src/db/PhotoTable.vala"
	if (!object_p) {
#line 81 "../src/db/PhotoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 533 "PhotoTable.c"
	}
#line 81 "../src/db/PhotoTable.vala"
	if (!value->data[0].v_pointer) {
#line 81 "../src/db/PhotoTable.vala"
		*object_p = NULL;
#line 539 "PhotoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 81 "../src/db/PhotoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 543 "PhotoTable.c"
	} else {
#line 81 "../src/db/PhotoTable.vala"
		*object_p = photo_row_ref (value->data[0].v_pointer);
#line 547 "PhotoTable.c"
	}
#line 81 "../src/db/PhotoTable.vala"
	return NULL;
#line 551 "PhotoTable.c"
}

GParamSpec*
param_spec_photo_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecPhotoRow* spec;
#line 81 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_ROW), NULL);
#line 81 "../src/db/PhotoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 81 "../src/db/PhotoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 81 "../src/db/PhotoTable.vala"
	return G_PARAM_SPEC (spec);
#line 570 "PhotoTable.c"
}

gpointer
value_get_photo_row (const GValue* value)
{
#line 81 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW), NULL);
#line 81 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 580 "PhotoTable.c"
}

void
value_set_photo_row (GValue* value,
                     gpointer v_object)
{
	PhotoRow * old;
#line 81 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW));
#line 81 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 81 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 81 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_ROW));
#line 81 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 81 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 81 "../src/db/PhotoTable.vala"
		photo_row_ref (value->data[0].v_pointer);
#line 602 "PhotoTable.c"
	} else {
#line 81 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 606 "PhotoTable.c"
	}
#line 81 "../src/db/PhotoTable.vala"
	if (old) {
#line 81 "../src/db/PhotoTable.vala"
		photo_row_unref (old);
#line 612 "PhotoTable.c"
	}
}

void
value_take_photo_row (GValue* value,
                      gpointer v_object)
{
	PhotoRow * old;
#line 81 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW));
#line 81 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 81 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 81 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_ROW));
#line 81 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 81 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 633 "PhotoTable.c"
	} else {
#line 81 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 637 "PhotoTable.c"
	}
#line 81 "../src/db/PhotoTable.vala"
	if (old) {
#line 81 "../src/db/PhotoTable.vala"
		photo_row_unref (old);
#line 643 "PhotoTable.c"
	}
}

static void
photo_row_class_init (PhotoRowClass * klass,
                      gpointer klass_data)
{
#line 81 "../src/db/PhotoTable.vala"
	photo_row_parent_class = g_type_class_peek_parent (klass);
#line 81 "../src/db/PhotoTable.vala"
	((PhotoRowClass *) klass)->finalize = photo_row_finalize;
#line 655 "PhotoTable.c"
}

static void
photo_row_instance_init (PhotoRow * self,
                         gpointer klass)
{
#line 81 "../src/db/PhotoTable.vala"
	self->ref_count = 1;
#line 664 "PhotoTable.c"
}

static void
photo_row_finalize (PhotoRow * obj)
{
	PhotoRow * self;
#line 81 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_ROW, PhotoRow);
#line 81 "../src/db/PhotoTable.vala"
	g_signal_handlers_destroy (self);
#line 83 "../src/db/PhotoTable.vala"
	_backing_photo_row_unref0 (self->master);
#line 88 "../src/db/PhotoTable.vala"
	_g_object_unref0 (self->transformations);
#line 89 "../src/db/PhotoTable.vala"
	_g_free0 (self->md5);
#line 90 "../src/db/PhotoTable.vala"
	_g_free0 (self->thumbnail_md5);
#line 91 "../src/db/PhotoTable.vala"
	_g_free0 (self->exif_md5);
#line 94 "../src/db/PhotoTable.vala"
	_g_free0 (self->title);
#line 95 "../src/db/PhotoTable.vala"
	_g_free0 (self->comment);
#line 96 "../src/db/PhotoTable.vala"
	_g_free0 (self->backlinks);
#line 101 "../src/db/PhotoTable.vala"
	_g_object_unref0 (self->original_transforms);
#line 107 "../src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 695 "PhotoTable.c"
}

static GType
photo_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_row_init, value_photo_row_free_value, value_photo_row_copy_value, value_photo_row_peek_pointer, "p", value_photo_row_collect_value, "p", value_photo_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoRow), 0, (GInstanceInitFunc) photo_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_row_type_id;
	photo_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_row_type_id;
}

GType
photo_row_get_type (void)
{
	static volatile gsize photo_row_type_id__once = 0;
	if (g_once_init_enter (&photo_row_type_id__once)) {
		GType photo_row_type_id;
		photo_row_type_id = photo_row_get_type_once ();
		g_once_init_leave (&photo_row_type_id__once, photo_row_type_id);
	}
	return photo_row_type_id__once;
}

gpointer
photo_row_ref (gpointer instance)
{
	PhotoRow * self;
	self = instance;
#line 81 "../src/db/PhotoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 81 "../src/db/PhotoTable.vala"
	return instance;
#line 730 "PhotoTable.c"
}

void
photo_row_unref (gpointer instance)
{
	PhotoRow * self;
	self = instance;
#line 81 "../src/db/PhotoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 81 "../src/db/PhotoTable.vala"
		PHOTO_ROW_GET_CLASS (self)->finalize (self);
#line 81 "../src/db/PhotoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 744 "PhotoTable.c"
	}
}

static PhotoTable*
photo_table_construct (GType object_type)
{
	PhotoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
#line 122 "../src/db/PhotoTable.vala"
	self = (PhotoTable*) database_table_construct (object_type);
#line 123 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS PhotoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "orientation INTEGER, " "original_orientation INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "transformations TEXT, " "md5 TEXT, " "thumbnail_md5 TEXT, " "exif_md5 TEXT, " "time_created INTEGER, " "flags INTEGER DEFAULT 0, " "file_format INTEGER DEFAULT 0, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "editable_id INTEGER DEFAULT -1, " "metadata_dirty INTEGER DEFAULT 0, " "developer TEXT, " "develop_shotwell_id INTEGER DEFAULT -1, " "develop_camera_id INTEGER DEFAULT -1, " "develop_embedded_id INTEGER DEFAULT -1, " "comment TEXT, " "enhanced INTEGER DEFAULT 0, " "original_transforms TEXT " ")");
#line 123 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 157 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 157 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 158 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 159 "../src/db/PhotoTable.vala"
		database_table_fatal ("create photo table", res);
#line 772 "PhotoTable.c"
	}
#line 162 "../src/db/PhotoTable.vala"
	_tmp2_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS PhotoEventIDIndex ON PhotoTable (event_id)");
#line 162 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 162 "../src/db/PhotoTable.vala"
	stmt = _tmp2_;
#line 164 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 164 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 165 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 166 "../src/db/PhotoTable.vala"
		database_table_fatal ("create photo table", res);
#line 788 "PhotoTable.c"
	}
#line 168 "../src/db/PhotoTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "PhotoTable");
#line 122 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 122 "../src/db/PhotoTable.vala"
	return self;
#line 796 "PhotoTable.c"
}

static PhotoTable*
photo_table_new (void)
{
#line 122 "../src/db/PhotoTable.vala"
	return photo_table_construct (TYPE_PHOTO_TABLE);
#line 804 "PhotoTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 175 "../src/db/PhotoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 812 "PhotoTable.c"
}

PhotoTable*
photo_table_get_instance (void)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp2_;
	PhotoTable* _tmp3_;
	PhotoTable* result;
#line 172 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_instance;
#line 172 "../src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 826 "PhotoTable.c"
		PhotoTable* _tmp1_;
#line 173 "../src/db/PhotoTable.vala"
		_tmp1_ = photo_table_new ();
#line 173 "../src/db/PhotoTable.vala"
		_database_table_unref0 (photo_table_instance);
#line 173 "../src/db/PhotoTable.vala"
		photo_table_instance = _tmp1_;
#line 834 "PhotoTable.c"
	}
#line 175 "../src/db/PhotoTable.vala"
	_tmp2_ = photo_table_instance;
#line 175 "../src/db/PhotoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 175 "../src/db/PhotoTable.vala"
	result = _tmp3_;
#line 175 "../src/db/PhotoTable.vala"
	return result;
#line 844 "PhotoTable.c"
}

void
photo_table_add (PhotoTable* self,
                 PhotoRow* photo_row,
                 PhotoID* result)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp1_;
	BackingPhotoRow* _tmp2_;
	const gchar* _tmp3_;
	sqlite3_stmt* _tmp4_;
	BackingPhotoRow* _tmp5_;
	Dimensions _tmp6_;
	sqlite3_stmt* _tmp7_;
	BackingPhotoRow* _tmp8_;
	Dimensions _tmp9_;
	sqlite3_stmt* _tmp10_;
	BackingPhotoRow* _tmp11_;
	sqlite3_stmt* _tmp12_;
	BackingPhotoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	sqlite3_stmt* _tmp15_;
	BackingPhotoRow* _tmp16_;
	sqlite3_stmt* _tmp17_;
	BackingPhotoRow* _tmp18_;
	sqlite3_stmt* _tmp19_;
	ImportID _tmp20_;
	sqlite3_stmt* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_;
	const gchar* _tmp25_;
	sqlite3_stmt* _tmp26_;
	const gchar* _tmp27_;
	sqlite3_stmt* _tmp28_;
	sqlite3_stmt* _tmp29_;
	BackingPhotoRow* _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	sqlite3_stmt* _tmp33_;
	sqlite3_stmt* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	gint res = 0;
	sqlite3_stmt* _tmp39_;
	sqlite3* _tmp41_;
	BackingPhotoRow* _tmp42_;
	PhotoID _tmp43_;
#line 180 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_row != NULL);
#line 181 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO PhotoTable (filename, width, height, filesize, timestamp, " \
"exposure_time, " "orientation, original_orientation, import_id, event_id, md5, thumbnail" \
"_md5, " "exif_md5, time_created, file_format, title, editable_id, developer, co" \
"mment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
#line 181 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 187 "../src/db/PhotoTable.vala"
	time_created = now_sec ();
#line 189 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 189 "../src/db/PhotoTable.vala"
	_tmp2_ = photo_row->master;
#line 189 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_->filepath;
#line 189 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp3_);
#line 190 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 190 "../src/db/PhotoTable.vala"
	_tmp5_ = photo_row->master;
#line 190 "../src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_->dim;
#line 190 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp4_, 2, _tmp6_.width);
#line 191 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 191 "../src/db/PhotoTable.vala"
	_tmp8_ = photo_row->master;
#line 191 "../src/db/PhotoTable.vala"
	_tmp9_ = _tmp8_->dim;
#line 191 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp7_, 3, _tmp9_.height);
#line 192 "../src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 192 "../src/db/PhotoTable.vala"
	_tmp11_ = photo_row->master;
#line 192 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp10_, 4, _tmp11_->filesize);
#line 193 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 193 "../src/db/PhotoTable.vala"
	_tmp13_ = photo_row->master;
#line 193 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp12_, 5, _tmp13_->timestamp);
#line 194 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 194 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp14_, 6, photo_row->exposure_time);
#line 195 "../src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 195 "../src/db/PhotoTable.vala"
	_tmp16_ = photo_row->master;
#line 195 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp15_, 7, (gint) _tmp16_->original_orientation);
#line 196 "../src/db/PhotoTable.vala"
	_tmp17_ = stmt;
#line 196 "../src/db/PhotoTable.vala"
	_tmp18_ = photo_row->master;
#line 196 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp17_, 8, (gint) _tmp18_->original_orientation);
#line 197 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 197 "../src/db/PhotoTable.vala"
	_tmp20_ = photo_row->import_id;
#line 197 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp19_, 9, _tmp20_.id);
#line 198 "../src/db/PhotoTable.vala"
	_tmp21_ = stmt;
#line 198 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp21_, 10, EVENT_ID_INVALID);
#line 199 "../src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 199 "../src/db/PhotoTable.vala"
	_tmp23_ = photo_row->md5;
#line 199 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp22_, 11, _tmp23_);
#line 200 "../src/db/PhotoTable.vala"
	_tmp24_ = stmt;
#line 200 "../src/db/PhotoTable.vala"
	_tmp25_ = photo_row->thumbnail_md5;
#line 200 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp24_, 12, _tmp25_);
#line 201 "../src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 201 "../src/db/PhotoTable.vala"
	_tmp27_ = photo_row->exif_md5;
#line 201 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp26_, 13, _tmp27_);
#line 202 "../src/db/PhotoTable.vala"
	_tmp28_ = stmt;
#line 202 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp28_, 14, time_created);
#line 203 "../src/db/PhotoTable.vala"
	_tmp29_ = stmt;
#line 203 "../src/db/PhotoTable.vala"
	_tmp30_ = photo_row->master;
#line 203 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp29_, 15, photo_file_format_serialize (_tmp30_->file_format));
#line 204 "../src/db/PhotoTable.vala"
	_tmp31_ = stmt;
#line 204 "../src/db/PhotoTable.vala"
	_tmp32_ = photo_row->title;
#line 204 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp31_, 16, _tmp32_);
#line 205 "../src/db/PhotoTable.vala"
	_tmp33_ = stmt;
#line 205 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp33_, 17, BACKING_PHOTO_ID_INVALID);
#line 206 "../src/db/PhotoTable.vala"
	_tmp34_ = stmt;
#line 206 "../src/db/PhotoTable.vala"
	_tmp35_ = raw_developer_to_string (photo_row->developer);
#line 206 "../src/db/PhotoTable.vala"
	_tmp36_ = _tmp35_;
#line 206 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp34_, 18, _tmp36_);
#line 206 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp36_);
#line 207 "../src/db/PhotoTable.vala"
	_tmp37_ = stmt;
#line 207 "../src/db/PhotoTable.vala"
	_tmp38_ = photo_row->comment;
#line 207 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp37_, 19, _tmp38_);
#line 209 "../src/db/PhotoTable.vala"
	_tmp39_ = stmt;
#line 209 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp39_);
#line 210 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1030 "PhotoTable.c"
		PhotoID _tmp40_ = {0};
#line 211 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 212 "../src/db/PhotoTable.vala"
			database_table_fatal ("add_photo", res);
#line 1036 "PhotoTable.c"
		}
#line 214 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp40_, PHOTO_ID_INVALID);
#line 214 "../src/db/PhotoTable.vala"
		*result = _tmp40_;
#line 214 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 214 "../src/db/PhotoTable.vala"
		return;
#line 1046 "PhotoTable.c"
	}
#line 218 "../src/db/PhotoTable.vala"
	_tmp41_ = database_table_db;
#line 218 "../src/db/PhotoTable.vala"
	photo_id_init (&photo_row->photo_id, sqlite3_last_insert_rowid (_tmp41_));
#line 219 "../src/db/PhotoTable.vala"
	_tmp42_ = photo_row->master;
#line 219 "../src/db/PhotoTable.vala"
	photo_row->orientation = _tmp42_->original_orientation;
#line 220 "../src/db/PhotoTable.vala"
	event_id_init (&photo_row->event_id, EVENT_ID_INVALID);
#line 221 "../src/db/PhotoTable.vala"
	photo_row->time_created = time_created;
#line 222 "../src/db/PhotoTable.vala"
	photo_row->flags = (guint64) 0;
#line 224 "../src/db/PhotoTable.vala"
	_tmp43_ = photo_row->photo_id;
#line 224 "../src/db/PhotoTable.vala"
	*result = _tmp43_;
#line 224 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 224 "../src/db/PhotoTable.vala"
	return;
#line 1070 "PhotoTable.c"
}

void
photo_table_reimport (PhotoTable* self,
                      PhotoRow* row,
                      GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint64 time_reimported = 0LL;
	sqlite3_stmt* _tmp1_;
	BackingPhotoRow* _tmp2_;
	Dimensions _tmp3_;
	sqlite3_stmt* _tmp4_;
	BackingPhotoRow* _tmp5_;
	Dimensions _tmp6_;
	sqlite3_stmt* _tmp7_;
	BackingPhotoRow* _tmp8_;
	sqlite3_stmt* _tmp9_;
	BackingPhotoRow* _tmp10_;
	sqlite3_stmt* _tmp11_;
	sqlite3_stmt* _tmp12_;
	BackingPhotoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	const gchar* _tmp19_;
	sqlite3_stmt* _tmp20_;
	const gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	BackingPhotoRow* _tmp23_;
	sqlite3_stmt* _tmp24_;
	const gchar* _tmp25_;
	sqlite3_stmt* _tmp26_;
	sqlite3_stmt* _tmp27_;
	PhotoID _tmp28_;
	gint res = 0;
	sqlite3_stmt* _tmp29_;
	BackingPhotoRow* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 232 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/db/PhotoTable.vala"
	g_return_if_fail (row != NULL);
#line 233 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE PhotoTable SET width = ?, height = ?, filesize = ?, timestamp =" \
" ?, " "exposure_time = ?, orientation = ?, original_orientation = ?, md5 = ?," \
" " "exif_md5 = ?, thumbnail_md5 = ?, file_format = ?, title = ?, time_reim" \
"ported = ? " "WHERE id = ?");
#line 233 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 239 "../src/db/PhotoTable.vala"
	time_reimported = now_sec ();
#line 241 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 241 "../src/db/PhotoTable.vala"
	_tmp2_ = row->master;
#line 241 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_->dim;
#line 241 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp1_, 1, _tmp3_.width);
#line 242 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 242 "../src/db/PhotoTable.vala"
	_tmp5_ = row->master;
#line 242 "../src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_->dim;
#line 242 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp4_, 2, _tmp6_.height);
#line 243 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 243 "../src/db/PhotoTable.vala"
	_tmp8_ = row->master;
#line 243 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp7_, 3, _tmp8_->filesize);
#line 244 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 244 "../src/db/PhotoTable.vala"
	_tmp10_ = row->master;
#line 244 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp9_, 4, _tmp10_->timestamp);
#line 245 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 245 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp11_, 5, row->exposure_time);
#line 246 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 246 "../src/db/PhotoTable.vala"
	_tmp13_ = row->master;
#line 246 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp12_, 6, (gint) _tmp13_->original_orientation);
#line 247 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 247 "../src/db/PhotoTable.vala"
	_tmp15_ = row->master;
#line 247 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp14_, 7, (gint) _tmp15_->original_orientation);
#line 248 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 248 "../src/db/PhotoTable.vala"
	_tmp17_ = row->md5;
#line 248 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp16_, 8, _tmp17_);
#line 249 "../src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 249 "../src/db/PhotoTable.vala"
	_tmp19_ = row->exif_md5;
#line 249 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp18_, 9, _tmp19_);
#line 250 "../src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 250 "../src/db/PhotoTable.vala"
	_tmp21_ = row->thumbnail_md5;
#line 250 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp20_, 10, _tmp21_);
#line 251 "../src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 251 "../src/db/PhotoTable.vala"
	_tmp23_ = row->master;
#line 251 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp22_, 11, photo_file_format_serialize (_tmp23_->file_format));
#line 252 "../src/db/PhotoTable.vala"
	_tmp24_ = stmt;
#line 252 "../src/db/PhotoTable.vala"
	_tmp25_ = row->title;
#line 252 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp24_, 12, _tmp25_);
#line 253 "../src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 253 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp26_, 13, time_reimported);
#line 254 "../src/db/PhotoTable.vala"
	_tmp27_ = stmt;
#line 254 "../src/db/PhotoTable.vala"
	_tmp28_ = row->photo_id;
#line 254 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp27_, 14, _tmp28_.id);
#line 256 "../src/db/PhotoTable.vala"
	_tmp29_ = stmt;
#line 256 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp29_);
#line 257 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 258 "../src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoTable.reimport_master", res, &_inner_error0_);
#line 258 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 258 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 258 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 258 "../src/db/PhotoTable.vala"
				return;
#line 1225 "PhotoTable.c"
			} else {
#line 258 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 258 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 258 "../src/db/PhotoTable.vala"
				return;
#line 1235 "PhotoTable.c"
			}
		}
	}
#line 260 "../src/db/PhotoTable.vala"
	row->time_reimported = time_reimported;
#line 261 "../src/db/PhotoTable.vala"
	_tmp30_ = row->master;
#line 261 "../src/db/PhotoTable.vala"
	row->orientation = _tmp30_->original_orientation;
#line 232 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1247 "PhotoTable.c"
}

gboolean
photo_table_master_exif_updated (PhotoTable* self,
                                 PhotoID* photo_id,
                                 gint64 filesize,
                                 gint64 timestamp,
                                 const gchar* md5,
                                 const gchar* exif_md5,
                                 const gchar* thumbnail_md5,
                                 PhotoRow* row)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp6_;
	PhotoID _tmp7_;
	gint res = 0;
	sqlite3_stmt* _tmp8_;
	BackingPhotoRow* _tmp9_;
	BackingPhotoRow* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean result;
#line 264 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 264 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 264 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (md5 != NULL, FALSE);
#line 264 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (row != NULL, FALSE);
#line 266 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE PhotoTable SET filesize = ?, timestamp = ?, md5 = ?, exif_md5 =" \
" ?," "thumbnail_md5 =? WHERE id = ?");
#line 266 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 270 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 270 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, filesize);
#line 271 "../src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 271 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp2_, 2, timestamp);
#line 272 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 272 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp3_, 3, md5);
#line 273 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 273 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp4_, 4, exif_md5);
#line 274 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 274 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp5_, 5, thumbnail_md5);
#line 275 "../src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 275 "../src/db/PhotoTable.vala"
	_tmp7_ = *photo_id;
#line 275 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp6_, 6, _tmp7_.id);
#line 277 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 277 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp8_);
#line 278 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 279 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 280 "../src/db/PhotoTable.vala"
			database_table_fatal ("write_update_photo", res);
#line 1325 "PhotoTable.c"
		}
#line 282 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 282 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 282 "../src/db/PhotoTable.vala"
		return result;
#line 1333 "PhotoTable.c"
	}
#line 285 "../src/db/PhotoTable.vala"
	_tmp9_ = row->master;
#line 285 "../src/db/PhotoTable.vala"
	_tmp9_->filesize = filesize;
#line 286 "../src/db/PhotoTable.vala"
	_tmp10_ = row->master;
#line 286 "../src/db/PhotoTable.vala"
	_tmp10_->timestamp = timestamp;
#line 287 "../src/db/PhotoTable.vala"
	_tmp11_ = g_strdup (md5);
#line 287 "../src/db/PhotoTable.vala"
	_g_free0 (row->md5);
#line 287 "../src/db/PhotoTable.vala"
	row->md5 = _tmp11_;
#line 288 "../src/db/PhotoTable.vala"
	_tmp12_ = g_strdup (exif_md5);
#line 288 "../src/db/PhotoTable.vala"
	_g_free0 (row->exif_md5);
#line 288 "../src/db/PhotoTable.vala"
	row->exif_md5 = _tmp12_;
#line 289 "../src/db/PhotoTable.vala"
	_tmp13_ = g_strdup (thumbnail_md5);
#line 289 "../src/db/PhotoTable.vala"
	_g_free0 (row->thumbnail_md5);
#line 289 "../src/db/PhotoTable.vala"
	row->thumbnail_md5 = _tmp13_;
#line 291 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 291 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 291 "../src/db/PhotoTable.vala"
	return result;
#line 1367 "PhotoTable.c"
}

static void
photo_table_validate_orientation (PhotoTable* self,
                                  PhotoRow* row)
{
	gboolean _tmp0_ = FALSE;
#line 302 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 302 "../src/db/PhotoTable.vala"
	g_return_if_fail (row != NULL);
#line 303 "../src/db/PhotoTable.vala"
	if (row->orientation < ORIENTATION_MIN) {
#line 303 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 1383 "PhotoTable.c"
	} else {
#line 304 "../src/db/PhotoTable.vala"
		_tmp0_ = row->orientation > ORIENTATION_MAX;
#line 1387 "PhotoTable.c"
	}
#line 303 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 1391 "PhotoTable.c"
		PhotoID _tmp1_;
#line 306 "../src/db/PhotoTable.vala"
		_tmp1_ = row->photo_id;
#line 306 "../src/db/PhotoTable.vala"
		photo_table_set_orientation (self, &_tmp1_, ORIENTATION_MIN);
#line 307 "../src/db/PhotoTable.vala"
		row->orientation = ORIENTATION_MIN;
#line 1399 "PhotoTable.c"
	}
}

PhotoRow*
photo_table_get_row (PhotoTable* self,
                     PhotoID* photo_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	PhotoID _tmp2_;
	sqlite3_stmt* _tmp3_;
	PhotoRow* row = NULL;
	PhotoRow* _tmp4_;
	PhotoRow* _tmp5_;
	PhotoID _tmp6_;
	PhotoRow* _tmp7_;
	BackingPhotoRow* _tmp8_;
	sqlite3_stmt* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	sqlite3_stmt* _tmp15_;
	PhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	PhotoRow* _tmp19_;
	BackingPhotoRow* _tmp20_;
	sqlite3_stmt* _tmp21_;
	PhotoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	PhotoRow* _tmp24_;
	sqlite3_stmt* _tmp25_;
	PhotoRow* _tmp26_;
	BackingPhotoRow* _tmp27_;
	sqlite3_stmt* _tmp28_;
	PhotoRow* _tmp29_;
	sqlite3_stmt* _tmp30_;
	PhotoRow* _tmp31_;
	sqlite3_stmt* _tmp32_;
	PhotoRow* _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	GeeHashMap* _tmp36_;
	PhotoRow* _tmp37_;
	sqlite3_stmt* _tmp38_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	PhotoRow* _tmp41_;
	sqlite3_stmt* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	PhotoRow* _tmp45_;
	sqlite3_stmt* _tmp46_;
	const gchar* _tmp47_;
	gchar* _tmp48_;
	PhotoRow* _tmp49_;
	sqlite3_stmt* _tmp50_;
	PhotoRow* _tmp51_;
	sqlite3_stmt* _tmp52_;
	PhotoRow* _tmp53_;
	BackingPhotoRow* _tmp54_;
	sqlite3_stmt* _tmp55_;
	PhotoRow* _tmp56_;
	sqlite3_stmt* _tmp57_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
	PhotoRow* _tmp60_;
	sqlite3_stmt* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	PhotoRow* _tmp64_;
	sqlite3_stmt* _tmp65_;
	PhotoRow* _tmp66_;
	sqlite3_stmt* _tmp67_;
	PhotoRow* _tmp68_;
	sqlite3_stmt* _tmp69_;
	RawDeveloper _tmp70_ = 0;
	sqlite3_stmt* _tmp71_;
	const gchar* _tmp72_;
	PhotoRow* _tmp75_;
	PhotoRow* _tmp76_;
	BackingPhotoID* _tmp77_;
	gint _tmp77__length1;
	sqlite3_stmt* _tmp78_;
	BackingPhotoID _tmp79_ = {0};
	PhotoRow* _tmp80_;
	BackingPhotoID* _tmp81_;
	gint _tmp81__length1;
	sqlite3_stmt* _tmp82_;
	BackingPhotoID _tmp83_ = {0};
	PhotoRow* _tmp84_;
	BackingPhotoID* _tmp85_;
	gint _tmp85__length1;
	sqlite3_stmt* _tmp86_;
	BackingPhotoID _tmp87_ = {0};
	PhotoRow* _tmp88_;
	sqlite3_stmt* _tmp89_;
	const gchar* _tmp90_;
	gchar* _tmp91_;
	PhotoRow* _tmp92_;
	sqlite3_stmt* _tmp93_;
	PhotoRow* _tmp94_;
	sqlite3_stmt* _tmp95_;
	const gchar* _tmp96_;
	GeeHashMap* _tmp97_;
	PhotoRow* result;
#line 311 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 311 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 312 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT filename, width, height, filesize, timestamp, exposure_time, or" \
"ientation, " "original_orientation, import_id, event_id, transformations, md5, thumb" \
"nail_md5, " "exif_md5, time_created, flags, file_format, title, backlinks, " "time_reimported, editable_id, metadata_dirty, developer, develop_shotw" \
"ell_id, " "develop_camera_id, develop_embedded_id, comment, enhanced, original_tr" \
"ansforms " "FROM PhotoTable WHERE id=?");
#line 312 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 321 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 321 "../src/db/PhotoTable.vala"
	_tmp2_ = *photo_id;
#line 321 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 323 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 323 "../src/db/PhotoTable.vala"
	if (sqlite3_step (_tmp3_) != SQLITE_ROW) {
#line 324 "../src/db/PhotoTable.vala"
		result = NULL;
#line 324 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 324 "../src/db/PhotoTable.vala"
		return result;
#line 1533 "PhotoTable.c"
	}
#line 326 "../src/db/PhotoTable.vala"
	_tmp4_ = photo_row_new ();
#line 326 "../src/db/PhotoTable.vala"
	row = _tmp4_;
#line 327 "../src/db/PhotoTable.vala"
	_tmp5_ = row;
#line 327 "../src/db/PhotoTable.vala"
	_tmp6_ = *photo_id;
#line 327 "../src/db/PhotoTable.vala"
	_tmp5_->photo_id = _tmp6_;
#line 328 "../src/db/PhotoTable.vala"
	_tmp7_ = row;
#line 328 "../src/db/PhotoTable.vala"
	_tmp8_ = _tmp7_->master;
#line 328 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 328 "../src/db/PhotoTable.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (_tmp9_, 0);
#line 328 "../src/db/PhotoTable.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 328 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp8_->filepath);
#line 328 "../src/db/PhotoTable.vala"
	_tmp8_->filepath = _tmp11_;
#line 329 "../src/db/PhotoTable.vala"
	_tmp12_ = row;
#line 329 "../src/db/PhotoTable.vala"
	_tmp13_ = _tmp12_->master;
#line 329 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 329 "../src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 329 "../src/db/PhotoTable.vala"
	dimensions_init (&_tmp13_->dim, sqlite3_column_int (_tmp14_, 1), sqlite3_column_int (_tmp15_, 2));
#line 330 "../src/db/PhotoTable.vala"
	_tmp16_ = row;
#line 330 "../src/db/PhotoTable.vala"
	_tmp17_ = _tmp16_->master;
#line 330 "../src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 330 "../src/db/PhotoTable.vala"
	_tmp17_->filesize = sqlite3_column_int64 (_tmp18_, 3);
#line 331 "../src/db/PhotoTable.vala"
	_tmp19_ = row;
#line 331 "../src/db/PhotoTable.vala"
	_tmp20_ = _tmp19_->master;
#line 331 "../src/db/PhotoTable.vala"
	_tmp21_ = stmt;
#line 331 "../src/db/PhotoTable.vala"
	_tmp20_->timestamp = sqlite3_column_int64 (_tmp21_, 4);
#line 332 "../src/db/PhotoTable.vala"
	_tmp22_ = row;
#line 332 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 332 "../src/db/PhotoTable.vala"
	_tmp22_->exposure_time = sqlite3_column_int64 (_tmp23_, 5);
#line 333 "../src/db/PhotoTable.vala"
	_tmp24_ = row;
#line 333 "../src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 333 "../src/db/PhotoTable.vala"
	_tmp24_->orientation = (Orientation) sqlite3_column_int (_tmp25_, 6);
#line 334 "../src/db/PhotoTable.vala"
	_tmp26_ = row;
#line 334 "../src/db/PhotoTable.vala"
	_tmp27_ = _tmp26_->master;
#line 334 "../src/db/PhotoTable.vala"
	_tmp28_ = stmt;
#line 334 "../src/db/PhotoTable.vala"
	_tmp27_->original_orientation = (Orientation) sqlite3_column_int (_tmp28_, 7);
#line 335 "../src/db/PhotoTable.vala"
	_tmp29_ = row;
#line 335 "../src/db/PhotoTable.vala"
	_tmp30_ = stmt;
#line 335 "../src/db/PhotoTable.vala"
	_tmp29_->import_id.id = sqlite3_column_int64 (_tmp30_, 8);
#line 336 "../src/db/PhotoTable.vala"
	_tmp31_ = row;
#line 336 "../src/db/PhotoTable.vala"
	_tmp32_ = stmt;
#line 336 "../src/db/PhotoTable.vala"
	_tmp31_->event_id.id = sqlite3_column_int64 (_tmp32_, 9);
#line 337 "../src/db/PhotoTable.vala"
	_tmp33_ = row;
#line 337 "../src/db/PhotoTable.vala"
	_tmp34_ = stmt;
#line 337 "../src/db/PhotoTable.vala"
	_tmp35_ = (const gchar*) sqlite3_column_text (_tmp34_, 10);
#line 337 "../src/db/PhotoTable.vala"
	_tmp36_ = photo_table_marshall_all_transformations (_tmp35_);
#line 337 "../src/db/PhotoTable.vala"
	_g_object_unref0 (_tmp33_->transformations);
#line 337 "../src/db/PhotoTable.vala"
	_tmp33_->transformations = _tmp36_;
#line 338 "../src/db/PhotoTable.vala"
	_tmp37_ = row;
#line 338 "../src/db/PhotoTable.vala"
	_tmp38_ = stmt;
#line 338 "../src/db/PhotoTable.vala"
	_tmp39_ = (const gchar*) sqlite3_column_text (_tmp38_, 11);
#line 338 "../src/db/PhotoTable.vala"
	_tmp40_ = g_strdup (_tmp39_);
#line 338 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp37_->md5);
#line 338 "../src/db/PhotoTable.vala"
	_tmp37_->md5 = _tmp40_;
#line 339 "../src/db/PhotoTable.vala"
	_tmp41_ = row;
#line 339 "../src/db/PhotoTable.vala"
	_tmp42_ = stmt;
#line 339 "../src/db/PhotoTable.vala"
	_tmp43_ = (const gchar*) sqlite3_column_text (_tmp42_, 12);
#line 339 "../src/db/PhotoTable.vala"
	_tmp44_ = g_strdup (_tmp43_);
#line 339 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp41_->thumbnail_md5);
#line 339 "../src/db/PhotoTable.vala"
	_tmp41_->thumbnail_md5 = _tmp44_;
#line 340 "../src/db/PhotoTable.vala"
	_tmp45_ = row;
#line 340 "../src/db/PhotoTable.vala"
	_tmp46_ = stmt;
#line 340 "../src/db/PhotoTable.vala"
	_tmp47_ = (const gchar*) sqlite3_column_text (_tmp46_, 13);
#line 340 "../src/db/PhotoTable.vala"
	_tmp48_ = g_strdup (_tmp47_);
#line 340 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp45_->exif_md5);
#line 340 "../src/db/PhotoTable.vala"
	_tmp45_->exif_md5 = _tmp48_;
#line 341 "../src/db/PhotoTable.vala"
	_tmp49_ = row;
#line 341 "../src/db/PhotoTable.vala"
	_tmp50_ = stmt;
#line 341 "../src/db/PhotoTable.vala"
	_tmp49_->time_created = sqlite3_column_int64 (_tmp50_, 14);
#line 342 "../src/db/PhotoTable.vala"
	_tmp51_ = row;
#line 342 "../src/db/PhotoTable.vala"
	_tmp52_ = stmt;
#line 342 "../src/db/PhotoTable.vala"
	_tmp51_->flags = (guint64) sqlite3_column_int64 (_tmp52_, 15);
#line 343 "../src/db/PhotoTable.vala"
	_tmp53_ = row;
#line 343 "../src/db/PhotoTable.vala"
	_tmp54_ = _tmp53_->master;
#line 343 "../src/db/PhotoTable.vala"
	_tmp55_ = stmt;
#line 343 "../src/db/PhotoTable.vala"
	_tmp54_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp55_, 16));
#line 344 "../src/db/PhotoTable.vala"
	_tmp56_ = row;
#line 344 "../src/db/PhotoTable.vala"
	_tmp57_ = stmt;
#line 344 "../src/db/PhotoTable.vala"
	_tmp58_ = (const gchar*) sqlite3_column_text (_tmp57_, 17);
#line 344 "../src/db/PhotoTable.vala"
	_tmp59_ = g_strdup (_tmp58_);
#line 344 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp56_->title);
#line 344 "../src/db/PhotoTable.vala"
	_tmp56_->title = _tmp59_;
#line 345 "../src/db/PhotoTable.vala"
	_tmp60_ = row;
#line 345 "../src/db/PhotoTable.vala"
	_tmp61_ = stmt;
#line 345 "../src/db/PhotoTable.vala"
	_tmp62_ = (const gchar*) sqlite3_column_text (_tmp61_, 18);
#line 345 "../src/db/PhotoTable.vala"
	_tmp63_ = g_strdup (_tmp62_);
#line 345 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp60_->backlinks);
#line 345 "../src/db/PhotoTable.vala"
	_tmp60_->backlinks = _tmp63_;
#line 346 "../src/db/PhotoTable.vala"
	_tmp64_ = row;
#line 346 "../src/db/PhotoTable.vala"
	_tmp65_ = stmt;
#line 346 "../src/db/PhotoTable.vala"
	_tmp64_->time_reimported = sqlite3_column_int64 (_tmp65_, 19);
#line 347 "../src/db/PhotoTable.vala"
	_tmp66_ = row;
#line 347 "../src/db/PhotoTable.vala"
	_tmp67_ = stmt;
#line 347 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp66_->editable_id, sqlite3_column_int64 (_tmp67_, 20));
#line 348 "../src/db/PhotoTable.vala"
	_tmp68_ = row;
#line 348 "../src/db/PhotoTable.vala"
	_tmp69_ = stmt;
#line 348 "../src/db/PhotoTable.vala"
	_tmp68_->metadata_dirty = sqlite3_column_int (_tmp69_, 21) != 0;
#line 349 "../src/db/PhotoTable.vala"
	_tmp71_ = stmt;
#line 349 "../src/db/PhotoTable.vala"
	_tmp72_ = (const gchar*) sqlite3_column_text (_tmp71_, 22);
#line 349 "../src/db/PhotoTable.vala"
	if (_tmp72_ != NULL) {
#line 1733 "PhotoTable.c"
		sqlite3_stmt* _tmp73_;
		const gchar* _tmp74_;
#line 349 "../src/db/PhotoTable.vala"
		_tmp73_ = stmt;
#line 349 "../src/db/PhotoTable.vala"
		_tmp74_ = (const gchar*) sqlite3_column_text (_tmp73_, 22);
#line 349 "../src/db/PhotoTable.vala"
		_tmp70_ = raw_developer_from_string (_tmp74_);
#line 1742 "PhotoTable.c"
	} else {
#line 350 "../src/db/PhotoTable.vala"
		_tmp70_ = RAW_DEVELOPER_CAMERA;
#line 1746 "PhotoTable.c"
	}
#line 349 "../src/db/PhotoTable.vala"
	_tmp75_ = row;
#line 349 "../src/db/PhotoTable.vala"
	_tmp75_->developer = _tmp70_;
#line 351 "../src/db/PhotoTable.vala"
	_tmp76_ = row;
#line 351 "../src/db/PhotoTable.vala"
	_tmp77_ = _tmp76_->development_ids;
#line 351 "../src/db/PhotoTable.vala"
	_tmp77__length1 = _tmp76_->development_ids_length1;
#line 351 "../src/db/PhotoTable.vala"
	_tmp78_ = stmt;
#line 351 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp79_, sqlite3_column_int64 (_tmp78_, 23));
#line 351 "../src/db/PhotoTable.vala"
	_tmp77_[RAW_DEVELOPER_SHOTWELL] = _tmp79_;
#line 352 "../src/db/PhotoTable.vala"
	_tmp80_ = row;
#line 352 "../src/db/PhotoTable.vala"
	_tmp81_ = _tmp80_->development_ids;
#line 352 "../src/db/PhotoTable.vala"
	_tmp81__length1 = _tmp80_->development_ids_length1;
#line 352 "../src/db/PhotoTable.vala"
	_tmp82_ = stmt;
#line 352 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp83_, sqlite3_column_int64 (_tmp82_, 24));
#line 352 "../src/db/PhotoTable.vala"
	_tmp81_[RAW_DEVELOPER_CAMERA] = _tmp83_;
#line 353 "../src/db/PhotoTable.vala"
	_tmp84_ = row;
#line 353 "../src/db/PhotoTable.vala"
	_tmp85_ = _tmp84_->development_ids;
#line 353 "../src/db/PhotoTable.vala"
	_tmp85__length1 = _tmp84_->development_ids_length1;
#line 353 "../src/db/PhotoTable.vala"
	_tmp86_ = stmt;
#line 353 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp87_, sqlite3_column_int64 (_tmp86_, 25));
#line 353 "../src/db/PhotoTable.vala"
	_tmp85_[RAW_DEVELOPER_EMBEDDED] = _tmp87_;
#line 354 "../src/db/PhotoTable.vala"
	_tmp88_ = row;
#line 354 "../src/db/PhotoTable.vala"
	_tmp89_ = stmt;
#line 354 "../src/db/PhotoTable.vala"
	_tmp90_ = (const gchar*) sqlite3_column_text (_tmp89_, 26);
#line 354 "../src/db/PhotoTable.vala"
	_tmp91_ = g_strdup (_tmp90_);
#line 354 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp88_->comment);
#line 354 "../src/db/PhotoTable.vala"
	_tmp88_->comment = _tmp91_;
#line 355 "../src/db/PhotoTable.vala"
	_tmp92_ = row;
#line 355 "../src/db/PhotoTable.vala"
	_tmp93_ = stmt;
#line 355 "../src/db/PhotoTable.vala"
	_tmp92_->enhanced = sqlite3_column_int (_tmp93_, 27) != 0;
#line 356 "../src/db/PhotoTable.vala"
	_tmp94_ = row;
#line 356 "../src/db/PhotoTable.vala"
	_tmp95_ = stmt;
#line 356 "../src/db/PhotoTable.vala"
	_tmp96_ = (const gchar*) sqlite3_column_text (_tmp95_, 28);
#line 356 "../src/db/PhotoTable.vala"
	_tmp97_ = photo_table_marshall_all_transformations (_tmp96_);
#line 356 "../src/db/PhotoTable.vala"
	_g_object_unref0 (_tmp94_->original_transforms);
#line 356 "../src/db/PhotoTable.vala"
	_tmp94_->original_transforms = _tmp97_;
#line 358 "../src/db/PhotoTable.vala"
	result = row;
#line 358 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 358 "../src/db/PhotoTable.vala"
	return result;
#line 1824 "PhotoTable.c"
}

GeeArrayList*
photo_table_get_all (PhotoTable* self)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* result;
#line 361 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 362 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id, filename, width, height, filesize, timestamp, exposure_time" \
", orientation, " "original_orientation, import_id, event_id, transformations, md5, thumb" \
"nail_md5, " "exif_md5, time_created, flags, file_format, title, backlinks, time_rei" \
"mported, " "editable_id, metadata_dirty, developer, develop_shotwell_id, develop_c" \
"amera_id, " "develop_embedded_id, comment, enhanced, original_transforms FROM Photo" \
"Table");
#line 362 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 369 "../src/db/PhotoTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_PHOTO_ROW, (GBoxedCopyFunc) photo_row_ref, (GDestroyNotify) photo_row_unref, NULL, NULL, NULL);
#line 369 "../src/db/PhotoTable.vala"
	all = _tmp1_;
#line 371 "../src/db/PhotoTable.vala"
	while (TRUE) {
#line 1847 "PhotoTable.c"
		sqlite3_stmt* _tmp2_;
		PhotoRow* row = NULL;
		PhotoRow* _tmp3_;
		PhotoRow* _tmp4_;
		sqlite3_stmt* _tmp5_;
		PhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
		sqlite3_stmt* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		PhotoRow* _tmp11_;
		BackingPhotoRow* _tmp12_;
		sqlite3_stmt* _tmp13_;
		sqlite3_stmt* _tmp14_;
		PhotoRow* _tmp15_;
		BackingPhotoRow* _tmp16_;
		sqlite3_stmt* _tmp17_;
		PhotoRow* _tmp18_;
		BackingPhotoRow* _tmp19_;
		sqlite3_stmt* _tmp20_;
		PhotoRow* _tmp21_;
		sqlite3_stmt* _tmp22_;
		PhotoRow* _tmp23_;
		sqlite3_stmt* _tmp24_;
		PhotoRow* _tmp25_;
		BackingPhotoRow* _tmp26_;
		sqlite3_stmt* _tmp27_;
		PhotoRow* _tmp28_;
		sqlite3_stmt* _tmp29_;
		PhotoRow* _tmp30_;
		sqlite3_stmt* _tmp31_;
		PhotoRow* _tmp32_;
		sqlite3_stmt* _tmp33_;
		const gchar* _tmp34_;
		GeeHashMap* _tmp35_;
		PhotoRow* _tmp36_;
		sqlite3_stmt* _tmp37_;
		const gchar* _tmp38_;
		gchar* _tmp39_;
		PhotoRow* _tmp40_;
		sqlite3_stmt* _tmp41_;
		const gchar* _tmp42_;
		gchar* _tmp43_;
		PhotoRow* _tmp44_;
		sqlite3_stmt* _tmp45_;
		const gchar* _tmp46_;
		gchar* _tmp47_;
		PhotoRow* _tmp48_;
		sqlite3_stmt* _tmp49_;
		PhotoRow* _tmp50_;
		sqlite3_stmt* _tmp51_;
		PhotoRow* _tmp52_;
		BackingPhotoRow* _tmp53_;
		sqlite3_stmt* _tmp54_;
		PhotoRow* _tmp55_;
		sqlite3_stmt* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		PhotoRow* _tmp59_;
		sqlite3_stmt* _tmp60_;
		const gchar* _tmp61_;
		gchar* _tmp62_;
		PhotoRow* _tmp63_;
		sqlite3_stmt* _tmp64_;
		PhotoRow* _tmp65_;
		sqlite3_stmt* _tmp66_;
		PhotoRow* _tmp67_;
		sqlite3_stmt* _tmp68_;
		RawDeveloper _tmp69_ = 0;
		sqlite3_stmt* _tmp70_;
		const gchar* _tmp71_;
		PhotoRow* _tmp74_;
		PhotoRow* _tmp75_;
		BackingPhotoID* _tmp76_;
		gint _tmp76__length1;
		sqlite3_stmt* _tmp77_;
		BackingPhotoID _tmp78_ = {0};
		PhotoRow* _tmp79_;
		BackingPhotoID* _tmp80_;
		gint _tmp80__length1;
		sqlite3_stmt* _tmp81_;
		BackingPhotoID _tmp82_ = {0};
		PhotoRow* _tmp83_;
		BackingPhotoID* _tmp84_;
		gint _tmp84__length1;
		sqlite3_stmt* _tmp85_;
		BackingPhotoID _tmp86_ = {0};
		PhotoRow* _tmp87_;
		sqlite3_stmt* _tmp88_;
		const gchar* _tmp89_;
		gchar* _tmp90_;
		PhotoRow* _tmp91_;
		sqlite3_stmt* _tmp92_;
		PhotoRow* _tmp93_;
		sqlite3_stmt* _tmp94_;
		const gchar* _tmp95_;
		GeeHashMap* _tmp96_;
		PhotoRow* _tmp97_;
		GeeArrayList* _tmp98_;
		PhotoRow* _tmp99_;
#line 371 "../src/db/PhotoTable.vala"
		_tmp2_ = stmt;
#line 371 "../src/db/PhotoTable.vala"
		if (!(sqlite3_step (_tmp2_) == SQLITE_ROW)) {
#line 371 "../src/db/PhotoTable.vala"
			break;
#line 1954 "PhotoTable.c"
		}
#line 372 "../src/db/PhotoTable.vala"
		_tmp3_ = photo_row_new ();
#line 372 "../src/db/PhotoTable.vala"
		row = _tmp3_;
#line 373 "../src/db/PhotoTable.vala"
		_tmp4_ = row;
#line 373 "../src/db/PhotoTable.vala"
		_tmp5_ = stmt;
#line 373 "../src/db/PhotoTable.vala"
		_tmp4_->photo_id.id = sqlite3_column_int64 (_tmp5_, 0);
#line 374 "../src/db/PhotoTable.vala"
		_tmp6_ = row;
#line 374 "../src/db/PhotoTable.vala"
		_tmp7_ = _tmp6_->master;
#line 374 "../src/db/PhotoTable.vala"
		_tmp8_ = stmt;
#line 374 "../src/db/PhotoTable.vala"
		_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 1);
#line 374 "../src/db/PhotoTable.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 374 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp7_->filepath);
#line 374 "../src/db/PhotoTable.vala"
		_tmp7_->filepath = _tmp10_;
#line 375 "../src/db/PhotoTable.vala"
		_tmp11_ = row;
#line 375 "../src/db/PhotoTable.vala"
		_tmp12_ = _tmp11_->master;
#line 375 "../src/db/PhotoTable.vala"
		_tmp13_ = stmt;
#line 375 "../src/db/PhotoTable.vala"
		_tmp14_ = stmt;
#line 375 "../src/db/PhotoTable.vala"
		dimensions_init (&_tmp12_->dim, sqlite3_column_int (_tmp13_, 2), sqlite3_column_int (_tmp14_, 3));
#line 376 "../src/db/PhotoTable.vala"
		_tmp15_ = row;
#line 376 "../src/db/PhotoTable.vala"
		_tmp16_ = _tmp15_->master;
#line 376 "../src/db/PhotoTable.vala"
		_tmp17_ = stmt;
#line 376 "../src/db/PhotoTable.vala"
		_tmp16_->filesize = sqlite3_column_int64 (_tmp17_, 4);
#line 377 "../src/db/PhotoTable.vala"
		_tmp18_ = row;
#line 377 "../src/db/PhotoTable.vala"
		_tmp19_ = _tmp18_->master;
#line 377 "../src/db/PhotoTable.vala"
		_tmp20_ = stmt;
#line 377 "../src/db/PhotoTable.vala"
		_tmp19_->timestamp = sqlite3_column_int64 (_tmp20_, 5);
#line 378 "../src/db/PhotoTable.vala"
		_tmp21_ = row;
#line 378 "../src/db/PhotoTable.vala"
		_tmp22_ = stmt;
#line 378 "../src/db/PhotoTable.vala"
		_tmp21_->exposure_time = sqlite3_column_int64 (_tmp22_, 6);
#line 379 "../src/db/PhotoTable.vala"
		_tmp23_ = row;
#line 379 "../src/db/PhotoTable.vala"
		_tmp24_ = stmt;
#line 379 "../src/db/PhotoTable.vala"
		_tmp23_->orientation = (Orientation) sqlite3_column_int (_tmp24_, 7);
#line 380 "../src/db/PhotoTable.vala"
		_tmp25_ = row;
#line 380 "../src/db/PhotoTable.vala"
		_tmp26_ = _tmp25_->master;
#line 380 "../src/db/PhotoTable.vala"
		_tmp27_ = stmt;
#line 380 "../src/db/PhotoTable.vala"
		_tmp26_->original_orientation = (Orientation) sqlite3_column_int (_tmp27_, 8);
#line 381 "../src/db/PhotoTable.vala"
		_tmp28_ = row;
#line 381 "../src/db/PhotoTable.vala"
		_tmp29_ = stmt;
#line 381 "../src/db/PhotoTable.vala"
		_tmp28_->import_id.id = sqlite3_column_int64 (_tmp29_, 9);
#line 382 "../src/db/PhotoTable.vala"
		_tmp30_ = row;
#line 382 "../src/db/PhotoTable.vala"
		_tmp31_ = stmt;
#line 382 "../src/db/PhotoTable.vala"
		_tmp30_->event_id.id = sqlite3_column_int64 (_tmp31_, 10);
#line 383 "../src/db/PhotoTable.vala"
		_tmp32_ = row;
#line 383 "../src/db/PhotoTable.vala"
		_tmp33_ = stmt;
#line 383 "../src/db/PhotoTable.vala"
		_tmp34_ = (const gchar*) sqlite3_column_text (_tmp33_, 11);
#line 383 "../src/db/PhotoTable.vala"
		_tmp35_ = photo_table_marshall_all_transformations (_tmp34_);
#line 383 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp32_->transformations);
#line 383 "../src/db/PhotoTable.vala"
		_tmp32_->transformations = _tmp35_;
#line 384 "../src/db/PhotoTable.vala"
		_tmp36_ = row;
#line 384 "../src/db/PhotoTable.vala"
		_tmp37_ = stmt;
#line 384 "../src/db/PhotoTable.vala"
		_tmp38_ = (const gchar*) sqlite3_column_text (_tmp37_, 12);
#line 384 "../src/db/PhotoTable.vala"
		_tmp39_ = g_strdup (_tmp38_);
#line 384 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp36_->md5);
#line 384 "../src/db/PhotoTable.vala"
		_tmp36_->md5 = _tmp39_;
#line 385 "../src/db/PhotoTable.vala"
		_tmp40_ = row;
#line 385 "../src/db/PhotoTable.vala"
		_tmp41_ = stmt;
#line 385 "../src/db/PhotoTable.vala"
		_tmp42_ = (const gchar*) sqlite3_column_text (_tmp41_, 13);
#line 385 "../src/db/PhotoTable.vala"
		_tmp43_ = g_strdup (_tmp42_);
#line 385 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp40_->thumbnail_md5);
#line 385 "../src/db/PhotoTable.vala"
		_tmp40_->thumbnail_md5 = _tmp43_;
#line 386 "../src/db/PhotoTable.vala"
		_tmp44_ = row;
#line 386 "../src/db/PhotoTable.vala"
		_tmp45_ = stmt;
#line 386 "../src/db/PhotoTable.vala"
		_tmp46_ = (const gchar*) sqlite3_column_text (_tmp45_, 14);
#line 386 "../src/db/PhotoTable.vala"
		_tmp47_ = g_strdup (_tmp46_);
#line 386 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp44_->exif_md5);
#line 386 "../src/db/PhotoTable.vala"
		_tmp44_->exif_md5 = _tmp47_;
#line 387 "../src/db/PhotoTable.vala"
		_tmp48_ = row;
#line 387 "../src/db/PhotoTable.vala"
		_tmp49_ = stmt;
#line 387 "../src/db/PhotoTable.vala"
		_tmp48_->time_created = sqlite3_column_int64 (_tmp49_, 15);
#line 388 "../src/db/PhotoTable.vala"
		_tmp50_ = row;
#line 388 "../src/db/PhotoTable.vala"
		_tmp51_ = stmt;
#line 388 "../src/db/PhotoTable.vala"
		_tmp50_->flags = (guint64) sqlite3_column_int64 (_tmp51_, 16);
#line 389 "../src/db/PhotoTable.vala"
		_tmp52_ = row;
#line 389 "../src/db/PhotoTable.vala"
		_tmp53_ = _tmp52_->master;
#line 389 "../src/db/PhotoTable.vala"
		_tmp54_ = stmt;
#line 389 "../src/db/PhotoTable.vala"
		_tmp53_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp54_, 17));
#line 390 "../src/db/PhotoTable.vala"
		_tmp55_ = row;
#line 390 "../src/db/PhotoTable.vala"
		_tmp56_ = stmt;
#line 390 "../src/db/PhotoTable.vala"
		_tmp57_ = (const gchar*) sqlite3_column_text (_tmp56_, 18);
#line 390 "../src/db/PhotoTable.vala"
		_tmp58_ = g_strdup (_tmp57_);
#line 390 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp55_->title);
#line 390 "../src/db/PhotoTable.vala"
		_tmp55_->title = _tmp58_;
#line 391 "../src/db/PhotoTable.vala"
		_tmp59_ = row;
#line 391 "../src/db/PhotoTable.vala"
		_tmp60_ = stmt;
#line 391 "../src/db/PhotoTable.vala"
		_tmp61_ = (const gchar*) sqlite3_column_text (_tmp60_, 19);
#line 391 "../src/db/PhotoTable.vala"
		_tmp62_ = g_strdup (_tmp61_);
#line 391 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp59_->backlinks);
#line 391 "../src/db/PhotoTable.vala"
		_tmp59_->backlinks = _tmp62_;
#line 392 "../src/db/PhotoTable.vala"
		_tmp63_ = row;
#line 392 "../src/db/PhotoTable.vala"
		_tmp64_ = stmt;
#line 392 "../src/db/PhotoTable.vala"
		_tmp63_->time_reimported = sqlite3_column_int64 (_tmp64_, 20);
#line 393 "../src/db/PhotoTable.vala"
		_tmp65_ = row;
#line 393 "../src/db/PhotoTable.vala"
		_tmp66_ = stmt;
#line 393 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp65_->editable_id, sqlite3_column_int64 (_tmp66_, 21));
#line 394 "../src/db/PhotoTable.vala"
		_tmp67_ = row;
#line 394 "../src/db/PhotoTable.vala"
		_tmp68_ = stmt;
#line 394 "../src/db/PhotoTable.vala"
		_tmp67_->metadata_dirty = sqlite3_column_int (_tmp68_, 22) != 0;
#line 395 "../src/db/PhotoTable.vala"
		_tmp70_ = stmt;
#line 395 "../src/db/PhotoTable.vala"
		_tmp71_ = (const gchar*) sqlite3_column_text (_tmp70_, 23);
#line 395 "../src/db/PhotoTable.vala"
		if (_tmp71_ != NULL) {
#line 2154 "PhotoTable.c"
			sqlite3_stmt* _tmp72_;
			const gchar* _tmp73_;
#line 395 "../src/db/PhotoTable.vala"
			_tmp72_ = stmt;
#line 395 "../src/db/PhotoTable.vala"
			_tmp73_ = (const gchar*) sqlite3_column_text (_tmp72_, 23);
#line 395 "../src/db/PhotoTable.vala"
			_tmp69_ = raw_developer_from_string (_tmp73_);
#line 2163 "PhotoTable.c"
		} else {
#line 396 "../src/db/PhotoTable.vala"
			_tmp69_ = RAW_DEVELOPER_CAMERA;
#line 2167 "PhotoTable.c"
		}
#line 395 "../src/db/PhotoTable.vala"
		_tmp74_ = row;
#line 395 "../src/db/PhotoTable.vala"
		_tmp74_->developer = _tmp69_;
#line 397 "../src/db/PhotoTable.vala"
		_tmp75_ = row;
#line 397 "../src/db/PhotoTable.vala"
		_tmp76_ = _tmp75_->development_ids;
#line 397 "../src/db/PhotoTable.vala"
		_tmp76__length1 = _tmp75_->development_ids_length1;
#line 397 "../src/db/PhotoTable.vala"
		_tmp77_ = stmt;
#line 397 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp78_, sqlite3_column_int64 (_tmp77_, 24));
#line 397 "../src/db/PhotoTable.vala"
		_tmp76_[RAW_DEVELOPER_SHOTWELL] = _tmp78_;
#line 398 "../src/db/PhotoTable.vala"
		_tmp79_ = row;
#line 398 "../src/db/PhotoTable.vala"
		_tmp80_ = _tmp79_->development_ids;
#line 398 "../src/db/PhotoTable.vala"
		_tmp80__length1 = _tmp79_->development_ids_length1;
#line 398 "../src/db/PhotoTable.vala"
		_tmp81_ = stmt;
#line 398 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp82_, sqlite3_column_int64 (_tmp81_, 25));
#line 398 "../src/db/PhotoTable.vala"
		_tmp80_[RAW_DEVELOPER_CAMERA] = _tmp82_;
#line 399 "../src/db/PhotoTable.vala"
		_tmp83_ = row;
#line 399 "../src/db/PhotoTable.vala"
		_tmp84_ = _tmp83_->development_ids;
#line 399 "../src/db/PhotoTable.vala"
		_tmp84__length1 = _tmp83_->development_ids_length1;
#line 399 "../src/db/PhotoTable.vala"
		_tmp85_ = stmt;
#line 399 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp86_, sqlite3_column_int64 (_tmp85_, 26));
#line 399 "../src/db/PhotoTable.vala"
		_tmp84_[RAW_DEVELOPER_EMBEDDED] = _tmp86_;
#line 400 "../src/db/PhotoTable.vala"
		_tmp87_ = row;
#line 400 "../src/db/PhotoTable.vala"
		_tmp88_ = stmt;
#line 400 "../src/db/PhotoTable.vala"
		_tmp89_ = (const gchar*) sqlite3_column_text (_tmp88_, 27);
#line 400 "../src/db/PhotoTable.vala"
		_tmp90_ = g_strdup (_tmp89_);
#line 400 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp87_->comment);
#line 400 "../src/db/PhotoTable.vala"
		_tmp87_->comment = _tmp90_;
#line 401 "../src/db/PhotoTable.vala"
		_tmp91_ = row;
#line 401 "../src/db/PhotoTable.vala"
		_tmp92_ = stmt;
#line 401 "../src/db/PhotoTable.vala"
		_tmp91_->enhanced = sqlite3_column_int (_tmp92_, 28) != 0;
#line 402 "../src/db/PhotoTable.vala"
		_tmp93_ = row;
#line 402 "../src/db/PhotoTable.vala"
		_tmp94_ = stmt;
#line 402 "../src/db/PhotoTable.vala"
		_tmp95_ = (const gchar*) sqlite3_column_text (_tmp94_, 29);
#line 402 "../src/db/PhotoTable.vala"
		_tmp96_ = photo_table_marshall_all_transformations (_tmp95_);
#line 402 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp93_->original_transforms);
#line 402 "../src/db/PhotoTable.vala"
		_tmp93_->original_transforms = _tmp96_;
#line 403 "../src/db/PhotoTable.vala"
		_tmp97_ = row;
#line 403 "../src/db/PhotoTable.vala"
		photo_table_validate_orientation (self, _tmp97_);
#line 405 "../src/db/PhotoTable.vala"
		_tmp98_ = all;
#line 405 "../src/db/PhotoTable.vala"
		_tmp99_ = row;
#line 405 "../src/db/PhotoTable.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp98_, _tmp99_);
#line 371 "../src/db/PhotoTable.vala"
		_photo_row_unref0 (row);
#line 2251 "PhotoTable.c"
	}
#line 408 "../src/db/PhotoTable.vala"
	result = all;
#line 408 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 408 "../src/db/PhotoTable.vala"
	return result;
#line 2259 "PhotoTable.c"
}

void
photo_table_duplicate (PhotoTable* self,
                       PhotoID* photo_id,
                       const gchar* new_filename,
                       BackingPhotoID* editable_id,
                       BackingPhotoID* develop_shotwell,
                       BackingPhotoID* develop_camera_id,
                       BackingPhotoID* develop_embedded_id,
                       PhotoID* result)
{
	PhotoRow* original = NULL;
	PhotoID _tmp0_;
	PhotoRow* _tmp1_;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	PhotoRow* _tmp5_;
	BackingPhotoRow* _tmp6_;
	Dimensions _tmp7_;
	sqlite3_stmt* _tmp8_;
	PhotoRow* _tmp9_;
	BackingPhotoRow* _tmp10_;
	Dimensions _tmp11_;
	sqlite3_stmt* _tmp12_;
	PhotoRow* _tmp13_;
	BackingPhotoRow* _tmp14_;
	sqlite3_stmt* _tmp15_;
	PhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	PhotoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	PhotoRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	PhotoRow* _tmp23_;
	BackingPhotoRow* _tmp24_;
	sqlite3_stmt* _tmp25_;
	PhotoRow* _tmp26_;
	ImportID _tmp27_;
	sqlite3_stmt* _tmp28_;
	PhotoRow* _tmp29_;
	EventID _tmp30_;
	sqlite3_stmt* _tmp31_;
	PhotoRow* _tmp32_;
	GeeHashMap* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	sqlite3_stmt* _tmp36_;
	PhotoRow* _tmp37_;
	const gchar* _tmp38_;
	sqlite3_stmt* _tmp39_;
	PhotoRow* _tmp40_;
	const gchar* _tmp41_;
	sqlite3_stmt* _tmp42_;
	PhotoRow* _tmp43_;
	const gchar* _tmp44_;
	sqlite3_stmt* _tmp45_;
	sqlite3_stmt* _tmp46_;
	PhotoRow* _tmp47_;
	sqlite3_stmt* _tmp48_;
	PhotoRow* _tmp49_;
	BackingPhotoRow* _tmp50_;
	sqlite3_stmt* _tmp51_;
	PhotoRow* _tmp52_;
	const gchar* _tmp53_;
	sqlite3_stmt* _tmp54_;
	BackingPhotoID _tmp55_;
	sqlite3_stmt* _tmp56_;
	PhotoRow* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	sqlite3_stmt* _tmp60_;
	BackingPhotoID _tmp61_;
	sqlite3_stmt* _tmp62_;
	BackingPhotoID _tmp63_;
	sqlite3_stmt* _tmp64_;
	BackingPhotoID _tmp65_;
	sqlite3_stmt* _tmp66_;
	PhotoRow* _tmp67_;
	const gchar* _tmp68_;
	gint _tmp69_ = 0;
	PhotoRow* _tmp70_;
	sqlite3_stmt* _tmp71_;
	sqlite3_stmt* _tmp72_;
	PhotoRow* _tmp73_;
	GeeHashMap* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gint res = 0;
	sqlite3_stmt* _tmp77_;
	sqlite3* _tmp79_;
	PhotoID _tmp80_ = {0};
#line 413 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 413 "../src/db/PhotoTable.vala"
	g_return_if_fail (new_filename != NULL);
#line 413 "../src/db/PhotoTable.vala"
	g_return_if_fail (editable_id != NULL);
#line 413 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_shotwell != NULL);
#line 413 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_camera_id != NULL);
#line 413 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_embedded_id != NULL);
#line 417 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 417 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_row (self, &_tmp0_);
#line 417 "../src/db/PhotoTable.vala"
	original = _tmp1_;
#line 419 "../src/db/PhotoTable.vala"
	_tmp2_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO PhotoTable (filename, width, height, filesize, " "timestamp, exposure_time, orientation, original_orientation, import_id" \
", event_id, " "transformations, md5, thumbnail_md5, exif_md5, time_created, flags, " "file_format, title, editable_id, developer, develop_shotwell_id, devel" \
"op_camera_id, " "develop_embedded_id, comment, enhanced, original_transforms) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?," \
" ?, ?, ?, ?, ?)");
#line 419 "../src/db/PhotoTable.vala"
	stmt = _tmp2_;
#line 427 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 427 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp3_, 1, new_filename);
#line 428 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 428 "../src/db/PhotoTable.vala"
	_tmp5_ = original;
#line 428 "../src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_->master;
#line 428 "../src/db/PhotoTable.vala"
	_tmp7_ = _tmp6_->dim;
#line 428 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp4_, 2, _tmp7_.width);
#line 429 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 429 "../src/db/PhotoTable.vala"
	_tmp9_ = original;
#line 429 "../src/db/PhotoTable.vala"
	_tmp10_ = _tmp9_->master;
#line 429 "../src/db/PhotoTable.vala"
	_tmp11_ = _tmp10_->dim;
#line 429 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp8_, 3, _tmp11_.height);
#line 430 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 430 "../src/db/PhotoTable.vala"
	_tmp13_ = original;
#line 430 "../src/db/PhotoTable.vala"
	_tmp14_ = _tmp13_->master;
#line 430 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp12_, 4, _tmp14_->filesize);
#line 431 "../src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 431 "../src/db/PhotoTable.vala"
	_tmp16_ = original;
#line 431 "../src/db/PhotoTable.vala"
	_tmp17_ = _tmp16_->master;
#line 431 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp15_, 5, _tmp17_->timestamp);
#line 432 "../src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 432 "../src/db/PhotoTable.vala"
	_tmp19_ = original;
#line 432 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp18_, 6, _tmp19_->exposure_time);
#line 433 "../src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 433 "../src/db/PhotoTable.vala"
	_tmp21_ = original;
#line 433 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp20_, 7, (gint) _tmp21_->orientation);
#line 434 "../src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 434 "../src/db/PhotoTable.vala"
	_tmp23_ = original;
#line 434 "../src/db/PhotoTable.vala"
	_tmp24_ = _tmp23_->master;
#line 434 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp22_, 8, (gint) _tmp24_->original_orientation);
#line 435 "../src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 435 "../src/db/PhotoTable.vala"
	_tmp26_ = original;
#line 435 "../src/db/PhotoTable.vala"
	_tmp27_ = _tmp26_->import_id;
#line 435 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp25_, 9, _tmp27_.id);
#line 436 "../src/db/PhotoTable.vala"
	_tmp28_ = stmt;
#line 436 "../src/db/PhotoTable.vala"
	_tmp29_ = original;
#line 436 "../src/db/PhotoTable.vala"
	_tmp30_ = _tmp29_->event_id;
#line 436 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp28_, 10, _tmp30_.id);
#line 437 "../src/db/PhotoTable.vala"
	_tmp31_ = stmt;
#line 437 "../src/db/PhotoTable.vala"
	_tmp32_ = original;
#line 437 "../src/db/PhotoTable.vala"
	_tmp33_ = _tmp32_->transformations;
#line 437 "../src/db/PhotoTable.vala"
	_tmp34_ = photo_table_unmarshall_all_transformations (_tmp33_);
#line 437 "../src/db/PhotoTable.vala"
	_tmp35_ = _tmp34_;
#line 437 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp31_, 11, _tmp35_);
#line 437 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp35_);
#line 438 "../src/db/PhotoTable.vala"
	_tmp36_ = stmt;
#line 438 "../src/db/PhotoTable.vala"
	_tmp37_ = original;
#line 438 "../src/db/PhotoTable.vala"
	_tmp38_ = _tmp37_->md5;
#line 438 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp36_, 12, _tmp38_);
#line 439 "../src/db/PhotoTable.vala"
	_tmp39_ = stmt;
#line 439 "../src/db/PhotoTable.vala"
	_tmp40_ = original;
#line 439 "../src/db/PhotoTable.vala"
	_tmp41_ = _tmp40_->thumbnail_md5;
#line 439 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp39_, 13, _tmp41_);
#line 440 "../src/db/PhotoTable.vala"
	_tmp42_ = stmt;
#line 440 "../src/db/PhotoTable.vala"
	_tmp43_ = original;
#line 440 "../src/db/PhotoTable.vala"
	_tmp44_ = _tmp43_->exif_md5;
#line 440 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp42_, 14, _tmp44_);
#line 441 "../src/db/PhotoTable.vala"
	_tmp45_ = stmt;
#line 441 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp45_, 15, now_sec ());
#line 442 "../src/db/PhotoTable.vala"
	_tmp46_ = stmt;
#line 442 "../src/db/PhotoTable.vala"
	_tmp47_ = original;
#line 442 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp46_, 16, (gint64) _tmp47_->flags);
#line 443 "../src/db/PhotoTable.vala"
	_tmp48_ = stmt;
#line 443 "../src/db/PhotoTable.vala"
	_tmp49_ = original;
#line 443 "../src/db/PhotoTable.vala"
	_tmp50_ = _tmp49_->master;
#line 443 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp48_, 17, photo_file_format_serialize (_tmp50_->file_format));
#line 444 "../src/db/PhotoTable.vala"
	_tmp51_ = stmt;
#line 444 "../src/db/PhotoTable.vala"
	_tmp52_ = original;
#line 444 "../src/db/PhotoTable.vala"
	_tmp53_ = _tmp52_->title;
#line 444 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp51_, 18, _tmp53_);
#line 445 "../src/db/PhotoTable.vala"
	_tmp54_ = stmt;
#line 445 "../src/db/PhotoTable.vala"
	_tmp55_ = *editable_id;
#line 445 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp54_, 19, _tmp55_.id);
#line 447 "../src/db/PhotoTable.vala"
	_tmp56_ = stmt;
#line 447 "../src/db/PhotoTable.vala"
	_tmp57_ = original;
#line 447 "../src/db/PhotoTable.vala"
	_tmp58_ = raw_developer_to_string (_tmp57_->developer);
#line 447 "../src/db/PhotoTable.vala"
	_tmp59_ = _tmp58_;
#line 447 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp56_, 20, _tmp59_);
#line 447 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp59_);
#line 448 "../src/db/PhotoTable.vala"
	_tmp60_ = stmt;
#line 448 "../src/db/PhotoTable.vala"
	_tmp61_ = *develop_shotwell;
#line 448 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp60_, 21, _tmp61_.id);
#line 449 "../src/db/PhotoTable.vala"
	_tmp62_ = stmt;
#line 449 "../src/db/PhotoTable.vala"
	_tmp63_ = *develop_camera_id;
#line 449 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp62_, 22, _tmp63_.id);
#line 450 "../src/db/PhotoTable.vala"
	_tmp64_ = stmt;
#line 450 "../src/db/PhotoTable.vala"
	_tmp65_ = *develop_embedded_id;
#line 450 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp64_, 23, _tmp65_.id);
#line 451 "../src/db/PhotoTable.vala"
	_tmp66_ = stmt;
#line 451 "../src/db/PhotoTable.vala"
	_tmp67_ = original;
#line 451 "../src/db/PhotoTable.vala"
	_tmp68_ = _tmp67_->comment;
#line 451 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp66_, 24, _tmp68_);
#line 452 "../src/db/PhotoTable.vala"
	_tmp70_ = original;
#line 452 "../src/db/PhotoTable.vala"
	if (_tmp70_->enhanced) {
#line 452 "../src/db/PhotoTable.vala"
		_tmp69_ = 1;
#line 2569 "PhotoTable.c"
	} else {
#line 452 "../src/db/PhotoTable.vala"
		_tmp69_ = 0;
#line 2573 "PhotoTable.c"
	}
#line 452 "../src/db/PhotoTable.vala"
	_tmp71_ = stmt;
#line 452 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp71_, 25, _tmp69_);
#line 453 "../src/db/PhotoTable.vala"
	_tmp72_ = stmt;
#line 453 "../src/db/PhotoTable.vala"
	_tmp73_ = original;
#line 453 "../src/db/PhotoTable.vala"
	_tmp74_ = _tmp73_->original_transforms;
#line 453 "../src/db/PhotoTable.vala"
	_tmp75_ = photo_table_unmarshall_all_transformations (_tmp74_);
#line 453 "../src/db/PhotoTable.vala"
	_tmp76_ = _tmp75_;
#line 453 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp72_, 26, _tmp76_);
#line 453 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp76_);
#line 455 "../src/db/PhotoTable.vala"
	_tmp77_ = stmt;
#line 455 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp77_);
#line 456 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 2599 "PhotoTable.c"
		PhotoID _tmp78_ = {0};
#line 457 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 458 "../src/db/PhotoTable.vala"
			database_table_fatal ("duplicate", res);
#line 2605 "PhotoTable.c"
		}
#line 460 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp78_, PHOTO_ID_INVALID);
#line 460 "../src/db/PhotoTable.vala"
		*result = _tmp78_;
#line 460 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 460 "../src/db/PhotoTable.vala"
		_photo_row_unref0 (original);
#line 460 "../src/db/PhotoTable.vala"
		return;
#line 2617 "PhotoTable.c"
	}
#line 463 "../src/db/PhotoTable.vala"
	_tmp79_ = database_table_db;
#line 463 "../src/db/PhotoTable.vala"
	photo_id_init (&_tmp80_, sqlite3_last_insert_rowid (_tmp79_));
#line 463 "../src/db/PhotoTable.vala"
	*result = _tmp80_;
#line 463 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 463 "../src/db/PhotoTable.vala"
	_photo_row_unref0 (original);
#line 463 "../src/db/PhotoTable.vala"
	return;
#line 2631 "PhotoTable.c"
}

gboolean
photo_table_set_title (PhotoTable* self,
                       PhotoID* photo_id,
                       const gchar* new_title)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gboolean result;
#line 466 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 466 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 467 "../src/db/PhotoTable.vala"
	if (new_title != NULL) {
#line 467 "../src/db/PhotoTable.vala"
		_tmp0_ = new_title;
#line 2650 "PhotoTable.c"
	} else {
#line 467 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 2654 "PhotoTable.c"
	}
#line 467 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 467 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id ((DatabaseTable*) self, _tmp1_.id, "title", _tmp0_);
#line 467 "../src/db/PhotoTable.vala"
	return result;
#line 2662 "PhotoTable.c"
}

gboolean
photo_table_set_comment (PhotoTable* self,
                         PhotoID* photo_id,
                         const gchar* new_comment)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gboolean result;
#line 470 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 470 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 471 "../src/db/PhotoTable.vala"
	if (new_comment != NULL) {
#line 471 "../src/db/PhotoTable.vala"
		_tmp0_ = new_comment;
#line 2681 "PhotoTable.c"
	} else {
#line 471 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 2685 "PhotoTable.c"
	}
#line 471 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 471 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id ((DatabaseTable*) self, _tmp1_.id, "comment", _tmp0_);
#line 471 "../src/db/PhotoTable.vala"
	return result;
#line 2693 "PhotoTable.c"
}

void
photo_table_set_filepath (PhotoTable* self,
                          PhotoID* photo_id,
                          const gchar* filepath,
                          GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 474 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 474 "../src/db/PhotoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 475 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 475 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "filename", filepath, &_inner_error0_);
#line 475 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 475 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 475 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 475 "../src/db/PhotoTable.vala"
			return;
#line 2722 "PhotoTable.c"
		} else {
#line 475 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 475 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 475 "../src/db/PhotoTable.vala"
			return;
#line 2730 "PhotoTable.c"
		}
	}
}

void
photo_table_update_timestamp (PhotoTable* self,
                              PhotoID* photo_id,
                              gint64 timestamp,
                              GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 478 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 478 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 479 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 479 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "timestamp", timestamp, &_inner_error0_);
#line 479 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 479 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 479 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 479 "../src/db/PhotoTable.vala"
			return;
#line 2759 "PhotoTable.c"
		} else {
#line 479 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 479 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 479 "../src/db/PhotoTable.vala"
			return;
#line 2767 "PhotoTable.c"
		}
	}
}

gboolean
photo_table_set_exposure_time (PhotoTable* self,
                               PhotoID* photo_id,
                               gint64 time)
{
	PhotoID _tmp0_;
	gboolean result;
#line 482 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 482 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 483 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 483 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id ((DatabaseTable*) self, _tmp0_.id, "exposure_time", time);
#line 483 "../src/db/PhotoTable.vala"
	return result;
#line 2789 "PhotoTable.c"
}

void
photo_table_set_import_id (PhotoTable* self,
                           PhotoID* photo_id,
                           ImportID* import_id,
                           GError** error)
{
	PhotoID _tmp0_;
	ImportID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 486 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 486 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 486 "../src/db/PhotoTable.vala"
	g_return_if_fail (import_id != NULL);
#line 487 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 487 "../src/db/PhotoTable.vala"
	_tmp1_ = *import_id;
#line 487 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "import_id", _tmp1_.id, &_inner_error0_);
#line 487 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 487 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 487 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 487 "../src/db/PhotoTable.vala"
			return;
#line 2821 "PhotoTable.c"
		} else {
#line 487 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 487 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 487 "../src/db/PhotoTable.vala"
			return;
#line 2829 "PhotoTable.c"
		}
	}
}

gboolean
photo_table_remove_by_file (PhotoTable* self,
                            GFile* file)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	gboolean result;
#line 490 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 490 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 491 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "DELETE FROM PhotoTable WHERE filename=?");
#line 491 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 493 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 493 "../src/db/PhotoTable.vala"
	_tmp2_ = g_file_get_path (file);
#line 493 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_;
#line 493 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp3_);
#line 493 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp3_);
#line 495 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 495 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 496 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 497 "../src/db/PhotoTable.vala"
		database_table_warning ("remove", res);
#line 499 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 499 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 499 "../src/db/PhotoTable.vala"
		return result;
#line 2878 "PhotoTable.c"
	}
#line 502 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 502 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 502 "../src/db/PhotoTable.vala"
	return result;
#line 2886 "PhotoTable.c"
}

void
photo_table_remove (PhotoTable* self,
                    PhotoID* photo_id,
                    GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 505 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 505 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 506 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 506 "../src/db/PhotoTable.vala"
	database_table_delete_by_id ((DatabaseTable*) self, _tmp0_.id, &_inner_error0_);
#line 506 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 506 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 506 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 506 "../src/db/PhotoTable.vala"
			return;
#line 2912 "PhotoTable.c"
		} else {
#line 506 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 506 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 506 "../src/db/PhotoTable.vala"
			return;
#line 2920 "PhotoTable.c"
		}
	}
}

GeeArrayList*
photo_table_get_photos (PhotoTable* self)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* photo_ids = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* result;
#line 509 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 510 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM PhotoTable");
#line 510 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 512 "../src/db/PhotoTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_PHOTO_ID, (GBoxedCopyFunc) photo_id_dup, (GDestroyNotify) photo_id_free, NULL, NULL, NULL);
#line 512 "../src/db/PhotoTable.vala"
	photo_ids = _tmp1_;
#line 2943 "PhotoTable.c"
	{
		gboolean _tmp2_ = FALSE;
#line 513 "../src/db/PhotoTable.vala"
		_tmp2_ = TRUE;
#line 513 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 2950 "PhotoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp3_;
			GeeArrayList* _tmp4_;
			sqlite3_stmt* _tmp5_;
			PhotoID _tmp6_ = {0};
#line 513 "../src/db/PhotoTable.vala"
			if (!_tmp2_) {
#line 2958 "PhotoTable.c"
			}
#line 513 "../src/db/PhotoTable.vala"
			_tmp2_ = FALSE;
#line 514 "../src/db/PhotoTable.vala"
			_tmp3_ = stmt;
#line 514 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp3_);
#line 515 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 516 "../src/db/PhotoTable.vala"
				break;
#line 2970 "PhotoTable.c"
			} else {
#line 517 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 518 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_photos", res);
#line 520 "../src/db/PhotoTable.vala"
					break;
#line 2978 "PhotoTable.c"
				}
			}
#line 523 "../src/db/PhotoTable.vala"
			_tmp4_ = photo_ids;
#line 523 "../src/db/PhotoTable.vala"
			_tmp5_ = stmt;
#line 523 "../src/db/PhotoTable.vala"
			photo_id_init (&_tmp6_, sqlite3_column_int64 (_tmp5_, 0));
#line 523 "../src/db/PhotoTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, &_tmp6_);
#line 2989 "PhotoTable.c"
		}
	}
#line 526 "../src/db/PhotoTable.vala"
	result = photo_ids;
#line 526 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 526 "../src/db/PhotoTable.vala"
	return result;
#line 2998 "PhotoTable.c"
}

gboolean
photo_table_set_orientation (PhotoTable* self,
                             PhotoID* photo_id,
                             Orientation orientation)
{
	PhotoID _tmp0_;
	gboolean result;
#line 529 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 529 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 530 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 530 "../src/db/PhotoTable.vala"
	result = database_table_update_int_by_id ((DatabaseTable*) self, _tmp0_.id, "orientation", (gint) orientation);
#line 530 "../src/db/PhotoTable.vala"
	return result;
#line 3018 "PhotoTable.c"
}

gboolean
photo_table_replace_flags (PhotoTable* self,
                           PhotoID* photo_id,
                           guint64 flags)
{
	PhotoID _tmp0_;
	gboolean result;
#line 533 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 533 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 534 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 534 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id ((DatabaseTable*) self, _tmp0_.id, "flags", (gint64) flags);
#line 534 "../src/db/PhotoTable.vala"
	return result;
#line 3038 "PhotoTable.c"
}

gint
photo_table_get_event_photo_count (PhotoTable* self,
                                   EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	EventID _tmp2_;
	gint count = 0;
	gint result;
#line 537 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 537 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, 0);
#line 538 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM PhotoTable WHERE event_id = ?");
#line 538 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 540 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 540 "../src/db/PhotoTable.vala"
	_tmp2_ = *event_id;
#line 540 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 542 "../src/db/PhotoTable.vala"
	count = 0;
#line 3067 "PhotoTable.c"
	{
		gboolean _tmp3_ = FALSE;
#line 543 "../src/db/PhotoTable.vala"
		_tmp3_ = TRUE;
#line 543 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 3074 "PhotoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp4_;
			gint _tmp5_;
#line 543 "../src/db/PhotoTable.vala"
			if (!_tmp3_) {
#line 3080 "PhotoTable.c"
			}
#line 543 "../src/db/PhotoTable.vala"
			_tmp3_ = FALSE;
#line 544 "../src/db/PhotoTable.vala"
			_tmp4_ = stmt;
#line 544 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp4_);
#line 545 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 546 "../src/db/PhotoTable.vala"
				break;
#line 3092 "PhotoTable.c"
			} else {
#line 547 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 548 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_event_photo_count", res);
#line 550 "../src/db/PhotoTable.vala"
					break;
#line 3100 "PhotoTable.c"
				}
			}
#line 553 "../src/db/PhotoTable.vala"
			_tmp5_ = count;
#line 553 "../src/db/PhotoTable.vala"
			count = _tmp5_ + 1;
#line 3107 "PhotoTable.c"
		}
	}
#line 556 "../src/db/PhotoTable.vala"
	result = count;
#line 556 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 556 "../src/db/PhotoTable.vala"
	return result;
#line 3116 "PhotoTable.c"
}

GeeArrayList*
photo_table_get_event_source_ids (PhotoTable* self,
                                  EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* result;
#line 559 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 559 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 560 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM PhotoTable WHERE event_id = ?");
#line 560 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 562 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 562 "../src/db/PhotoTable.vala"
	_tmp2_ = *event_id;
#line 562 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 564 "../src/db/PhotoTable.vala"
	_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 564 "../src/db/PhotoTable.vala"
	_result_ = _tmp3_;
#line 3148 "PhotoTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 565 "../src/db/PhotoTable.vala"
		_tmp4_ = TRUE;
#line 565 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 3155 "PhotoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp5_;
			GeeArrayList* _tmp6_;
			sqlite3_stmt* _tmp7_;
			PhotoID _tmp8_ = {0};
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 565 "../src/db/PhotoTable.vala"
			if (!_tmp4_) {
#line 3165 "PhotoTable.c"
			}
#line 565 "../src/db/PhotoTable.vala"
			_tmp4_ = FALSE;
#line 566 "../src/db/PhotoTable.vala"
			_tmp5_ = stmt;
#line 566 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp5_);
#line 567 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 568 "../src/db/PhotoTable.vala"
				break;
#line 3177 "PhotoTable.c"
			} else {
#line 569 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 570 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_event_source_ids", res);
#line 572 "../src/db/PhotoTable.vala"
					break;
#line 3185 "PhotoTable.c"
				}
			}
#line 575 "../src/db/PhotoTable.vala"
			_tmp6_ = _result_;
#line 575 "../src/db/PhotoTable.vala"
			_tmp7_ = stmt;
#line 575 "../src/db/PhotoTable.vala"
			photo_id_init (&_tmp8_, sqlite3_column_int64 (_tmp7_, 0));
#line 575 "../src/db/PhotoTable.vala"
			_tmp9_ = photo_id_upgrade_photo_id_to_source_id (&_tmp8_);
#line 575 "../src/db/PhotoTable.vala"
			_tmp10_ = _tmp9_;
#line 575 "../src/db/PhotoTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp10_);
#line 575 "../src/db/PhotoTable.vala"
			_g_free0 (_tmp10_);
#line 3202 "PhotoTable.c"
		}
	}
#line 578 "../src/db/PhotoTable.vala"
	result = _result_;
#line 578 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 578 "../src/db/PhotoTable.vala"
	return result;
#line 3211 "PhotoTable.c"
}

gboolean
photo_table_event_has_photos (PhotoTable* self,
                              EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	EventID _tmp2_;
	gint res = 0;
	sqlite3_stmt* _tmp3_;
	gboolean result;
#line 581 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 581 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 582 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM PhotoTable WHERE event_id = ? LIMIT 1");
#line 582 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 584 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 584 "../src/db/PhotoTable.vala"
	_tmp2_ = *event_id;
#line 584 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 586 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 586 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 587 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 588 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 588 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 588 "../src/db/PhotoTable.vala"
		return result;
#line 3251 "PhotoTable.c"
	} else {
#line 589 "../src/db/PhotoTable.vala"
		if (res != SQLITE_ROW) {
#line 590 "../src/db/PhotoTable.vala"
			database_table_fatal ("event_has_photos", res);
#line 592 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 592 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 592 "../src/db/PhotoTable.vala"
			return result;
#line 3263 "PhotoTable.c"
		}
	}
#line 595 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 595 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 595 "../src/db/PhotoTable.vala"
	return result;
#line 3272 "PhotoTable.c"
}

gboolean
photo_table_drop_event (PhotoTable* self,
                        EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	EventID _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	gboolean result;
#line 598 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 598 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 599 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE PhotoTable SET event_id = ? WHERE event_id = ?");
#line 599 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 601 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 601 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, EVENT_ID_INVALID);
#line 602 "../src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 602 "../src/db/PhotoTable.vala"
	_tmp3_ = *event_id;
#line 602 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp2_, 2, _tmp3_.id);
#line 604 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 604 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 605 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 606 "../src/db/PhotoTable.vala"
		database_table_fatal ("drop_event", res);
#line 608 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 608 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 608 "../src/db/PhotoTable.vala"
		return result;
#line 3319 "PhotoTable.c"
	}
#line 611 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 611 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 611 "../src/db/PhotoTable.vala"
	return result;
#line 3327 "PhotoTable.c"
}

gboolean
photo_table_set_event (PhotoTable* self,
                       PhotoID* photo_id,
                       EventID* event_id)
{
	PhotoID _tmp0_;
	EventID _tmp1_;
	gboolean result;
#line 614 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 614 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 614 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 615 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 615 "../src/db/PhotoTable.vala"
	_tmp1_ = *event_id;
#line 615 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id ((DatabaseTable*) self, _tmp0_.id, "event_id", _tmp1_.id);
#line 615 "../src/db/PhotoTable.vala"
	return result;
#line 3352 "PhotoTable.c"
}

static gchar*
photo_table_get_raw_transformations (PhotoTable* self,
                                     PhotoID* photo_id)
{
	sqlite3_stmt* stmt = NULL;
	PhotoID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	gchar* trans = NULL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gchar* result;
#line 618 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 618 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 620 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 620 "../src/db/PhotoTable.vala"
	_tmp2_ = database_table_select_by_id ((DatabaseTable*) self, _tmp0_.id, "transformations", &_tmp1_);
#line 620 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 620 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 620 "../src/db/PhotoTable.vala"
	if (!_tmp2_) {
#line 621 "../src/db/PhotoTable.vala"
		result = NULL;
#line 621 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 621 "../src/db/PhotoTable.vala"
		return result;
#line 3390 "PhotoTable.c"
	}
#line 623 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 623 "../src/db/PhotoTable.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 623 "../src/db/PhotoTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 623 "../src/db/PhotoTable.vala"
	trans = _tmp5_;
#line 624 "../src/db/PhotoTable.vala"
	_tmp7_ = trans;
#line 624 "../src/db/PhotoTable.vala"
	if (_tmp7_ == NULL) {
#line 624 "../src/db/PhotoTable.vala"
		_tmp6_ = TRUE;
#line 3406 "PhotoTable.c"
	} else {
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 624 "../src/db/PhotoTable.vala"
		_tmp8_ = trans;
#line 624 "../src/db/PhotoTable.vala"
		_tmp9_ = strlen (_tmp8_);
#line 624 "../src/db/PhotoTable.vala"
		_tmp10_ = _tmp9_;
#line 624 "../src/db/PhotoTable.vala"
		_tmp6_ = _tmp10_ == 0;
#line 3419 "PhotoTable.c"
	}
#line 624 "../src/db/PhotoTable.vala"
	if (_tmp6_) {
#line 625 "../src/db/PhotoTable.vala"
		result = NULL;
#line 625 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 625 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 625 "../src/db/PhotoTable.vala"
		return result;
#line 3431 "PhotoTable.c"
	}
#line 627 "../src/db/PhotoTable.vala"
	result = trans;
#line 627 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 627 "../src/db/PhotoTable.vala"
	return result;
#line 3439 "PhotoTable.c"
}

static gboolean
photo_table_set_raw_transformations (PhotoTable* self,
                                     PhotoID* photo_id,
                                     const gchar* trans)
{
	PhotoID _tmp0_;
	gboolean result;
#line 630 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 630 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 630 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 631 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 631 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id ((DatabaseTable*) self, _tmp0_.id, "transformations", trans);
#line 631 "../src/db/PhotoTable.vala"
	return result;
#line 3461 "PhotoTable.c"
}

static gboolean
photo_table_set_raw_original_transforms (PhotoTable* self,
                                         PhotoID* photo_id,
                                         const gchar* trans)
{
	PhotoID _tmp0_;
	gboolean result;
#line 634 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 634 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 634 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 635 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 635 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id ((DatabaseTable*) self, _tmp0_.id, "original_transforms", trans);
#line 635 "../src/db/PhotoTable.vala"
	return result;
#line 3483 "PhotoTable.c"
}

gboolean
photo_table_set_transformation_state (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation,
                                      GeeHashMap* transformations,
                                      GeeHashMap* original_transforms,
                                      gboolean enhanced)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	sqlite3_stmt* _tmp5_;
	PhotoID _tmp6_;
	gint res = 0;
	sqlite3_stmt* _tmp7_;
	gboolean result;
#line 638 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 638 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 642 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE PhotoTable SET orientation = ?, transformations = ? WHERE id = " \
"?");
#line 642 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 644 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 644 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp1_, 1, (gint) orientation);
#line 645 "../src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 645 "../src/db/PhotoTable.vala"
	_tmp3_ = photo_table_unmarshall_all_transformations (transformations);
#line 645 "../src/db/PhotoTable.vala"
	_tmp4_ = _tmp3_;
#line 645 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp2_, 2, _tmp4_);
#line 645 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp4_);
#line 646 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 646 "../src/db/PhotoTable.vala"
	_tmp6_ = *photo_id;
#line 646 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp5_, 3, _tmp6_.id);
#line 648 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 648 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp7_);
#line 649 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 650 "../src/db/PhotoTable.vala"
		database_table_fatal ("set_transformation_state", res);
#line 652 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 652 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 652 "../src/db/PhotoTable.vala"
		return result;
#line 3547 "PhotoTable.c"
	}
#line 655 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 655 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 655 "../src/db/PhotoTable.vala"
	return result;
#line 3555 "PhotoTable.c"
}

GeeHashMap*
photo_table_marshall_all_transformations (const gchar* trans)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	GeeHashMap* result;
#line 659 "../src/db/PhotoTable.vala"
	if (trans == NULL) {
#line 659 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 3568 "PhotoTable.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 659 "../src/db/PhotoTable.vala"
		_tmp1_ = strlen (trans);
#line 659 "../src/db/PhotoTable.vala"
		_tmp2_ = _tmp1_;
#line 659 "../src/db/PhotoTable.vala"
		_tmp0_ = _tmp2_ == 0;
#line 3578 "PhotoTable.c"
	}
#line 659 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 660 "../src/db/PhotoTable.vala"
		result = NULL;
#line 660 "../src/db/PhotoTable.vala"
		return result;
#line 3586 "PhotoTable.c"
	}
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GKeyFile* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		GeeHashMap* map = NULL;
		GeeHashMap* _tmp8_;
		gchar** objects = NULL;
		GKeyFile* _tmp9_;
		gsize _tmp10_ = 0;
		gchar** _tmp11_;
		gint objects_length1;
		gint _objects_size_;
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 663 "../src/db/PhotoTable.vala"
		_tmp3_ = g_key_file_new ();
#line 663 "../src/db/PhotoTable.vala"
		keyfile = _tmp3_;
#line 664 "../src/db/PhotoTable.vala"
		_tmp5_ = keyfile;
#line 664 "../src/db/PhotoTable.vala"
		_tmp6_ = strlen (trans);
#line 664 "../src/db/PhotoTable.vala"
		_tmp7_ = _tmp6_;
#line 664 "../src/db/PhotoTable.vala"
		_tmp4_ = g_key_file_load_from_data (_tmp5_, trans, (gsize) _tmp7_, G_KEY_FILE_NONE, &_inner_error0_);
#line 664 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 664 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 3621 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 664 "../src/db/PhotoTable.vala"
		if (!_tmp4_) {
#line 665 "../src/db/PhotoTable.vala"
			result = NULL;
#line 665 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 665 "../src/db/PhotoTable.vala"
			return result;
#line 3632 "PhotoTable.c"
		}
#line 667 "../src/db/PhotoTable.vala"
		_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 667 "../src/db/PhotoTable.vala"
		map = _tmp8_;
#line 669 "../src/db/PhotoTable.vala"
		_tmp9_ = keyfile;
#line 669 "../src/db/PhotoTable.vala"
		_tmp11_ = g_key_file_get_groups (_tmp9_, &_tmp10_);
#line 669 "../src/db/PhotoTable.vala"
		objects = _tmp11_;
#line 669 "../src/db/PhotoTable.vala"
		objects_length1 = _tmp10_;
#line 669 "../src/db/PhotoTable.vala"
		_objects_size_ = objects_length1;
#line 670 "../src/db/PhotoTable.vala"
		_tmp12_ = objects;
#line 670 "../src/db/PhotoTable.vala"
		_tmp12__length1 = objects_length1;
#line 3652 "PhotoTable.c"
		{
			gchar** object_collection = NULL;
			gint object_collection_length1 = 0;
			gint _object_collection_size_ = 0;
			gint object_it = 0;
#line 670 "../src/db/PhotoTable.vala"
			object_collection = _tmp12_;
#line 670 "../src/db/PhotoTable.vala"
			object_collection_length1 = _tmp12__length1;
#line 670 "../src/db/PhotoTable.vala"
			for (object_it = 0; object_it < object_collection_length1; object_it = object_it + 1) {
#line 3664 "PhotoTable.c"
				gchar* _tmp13_;
				gchar* object = NULL;
#line 670 "../src/db/PhotoTable.vala"
				_tmp13_ = g_strdup (object_collection[object_it]);
#line 670 "../src/db/PhotoTable.vala"
				object = _tmp13_;
#line 3671 "PhotoTable.c"
				{
					gchar** keys = NULL;
					GKeyFile* _tmp14_;
					const gchar* _tmp15_;
					gsize _tmp16_ = 0;
					gchar** _tmp17_;
					gint keys_length1;
					gint _keys_size_;
					gboolean _tmp18_ = FALSE;
					gchar** _tmp19_;
					gint _tmp19__length1;
					KeyValueMap* key_map = NULL;
					const gchar* _tmp21_;
					KeyValueMap* _tmp22_;
					GeeHashMap* _tmp35_;
					const gchar* _tmp36_;
					KeyValueMap* _tmp37_;
#line 671 "../src/db/PhotoTable.vala"
					_tmp14_ = keyfile;
#line 671 "../src/db/PhotoTable.vala"
					_tmp15_ = object;
#line 671 "../src/db/PhotoTable.vala"
					_tmp17_ = g_key_file_get_keys (_tmp14_, _tmp15_, &_tmp16_, &_inner_error0_);
#line 671 "../src/db/PhotoTable.vala"
					keys = _tmp17_;
#line 671 "../src/db/PhotoTable.vala"
					keys_length1 = _tmp16_;
#line 671 "../src/db/PhotoTable.vala"
					_keys_size_ = keys_length1;
#line 671 "../src/db/PhotoTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 671 "../src/db/PhotoTable.vala"
						_g_free0 (object);
#line 671 "../src/db/PhotoTable.vala"
						objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 671 "../src/db/PhotoTable.vala"
						_g_object_unref0 (map);
#line 671 "../src/db/PhotoTable.vala"
						_g_key_file_unref0 (keyfile);
#line 3711 "PhotoTable.c"
						goto __catch0_g_error;
					}
#line 672 "../src/db/PhotoTable.vala"
					_tmp19_ = keys;
#line 672 "../src/db/PhotoTable.vala"
					_tmp19__length1 = keys_length1;
#line 672 "../src/db/PhotoTable.vala"
					if (_tmp19_ == NULL) {
#line 672 "../src/db/PhotoTable.vala"
						_tmp18_ = TRUE;
#line 3722 "PhotoTable.c"
					} else {
						gchar** _tmp20_;
						gint _tmp20__length1;
#line 672 "../src/db/PhotoTable.vala"
						_tmp20_ = keys;
#line 672 "../src/db/PhotoTable.vala"
						_tmp20__length1 = keys_length1;
#line 672 "../src/db/PhotoTable.vala"
						_tmp18_ = _tmp20__length1 == 0;
#line 3732 "PhotoTable.c"
					}
#line 672 "../src/db/PhotoTable.vala"
					if (_tmp18_) {
#line 673 "../src/db/PhotoTable.vala"
						keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 673 "../src/db/PhotoTable.vala"
						_g_free0 (object);
#line 673 "../src/db/PhotoTable.vala"
						continue;
#line 3742 "PhotoTable.c"
					}
#line 675 "../src/db/PhotoTable.vala"
					_tmp21_ = object;
#line 675 "../src/db/PhotoTable.vala"
					_tmp22_ = key_value_map_new (_tmp21_);
#line 675 "../src/db/PhotoTable.vala"
					key_map = _tmp22_;
#line 3750 "PhotoTable.c"
					{
						gint ctr = 0;
#line 676 "../src/db/PhotoTable.vala"
						ctr = 0;
#line 3755 "PhotoTable.c"
						{
							gboolean _tmp23_ = FALSE;
#line 676 "../src/db/PhotoTable.vala"
							_tmp23_ = TRUE;
#line 676 "../src/db/PhotoTable.vala"
							while (TRUE) {
#line 3762 "PhotoTable.c"
								gchar** _tmp25_;
								gint _tmp25__length1;
								gchar* _tmp26_ = NULL;
								GKeyFile* _tmp27_;
								const gchar* _tmp28_;
								gchar** _tmp29_;
								gint _tmp29__length1;
								const gchar* _tmp30_;
								gchar* _tmp31_;
								KeyValueMap* _tmp32_;
								gchar** _tmp33_;
								gint _tmp33__length1;
								const gchar* _tmp34_;
#line 676 "../src/db/PhotoTable.vala"
								if (!_tmp23_) {
#line 3778 "PhotoTable.c"
									gint _tmp24_;
#line 676 "../src/db/PhotoTable.vala"
									_tmp24_ = ctr;
#line 676 "../src/db/PhotoTable.vala"
									ctr = _tmp24_ + 1;
#line 3784 "PhotoTable.c"
								}
#line 676 "../src/db/PhotoTable.vala"
								_tmp23_ = FALSE;
#line 676 "../src/db/PhotoTable.vala"
								_tmp25_ = keys;
#line 676 "../src/db/PhotoTable.vala"
								_tmp25__length1 = keys_length1;
#line 676 "../src/db/PhotoTable.vala"
								if (!(ctr < _tmp25__length1)) {
#line 676 "../src/db/PhotoTable.vala"
									break;
#line 3796 "PhotoTable.c"
								}
#line 677 "../src/db/PhotoTable.vala"
								_tmp27_ = keyfile;
#line 677 "../src/db/PhotoTable.vala"
								_tmp28_ = object;
#line 677 "../src/db/PhotoTable.vala"
								_tmp29_ = keys;
#line 677 "../src/db/PhotoTable.vala"
								_tmp29__length1 = keys_length1;
#line 677 "../src/db/PhotoTable.vala"
								_tmp30_ = _tmp29_[ctr];
#line 677 "../src/db/PhotoTable.vala"
								_tmp31_ = g_key_file_get_string (_tmp27_, _tmp28_, _tmp30_, &_inner_error0_);
#line 677 "../src/db/PhotoTable.vala"
								_tmp26_ = _tmp31_;
#line 677 "../src/db/PhotoTable.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 677 "../src/db/PhotoTable.vala"
									_key_value_map_unref0 (key_map);
#line 677 "../src/db/PhotoTable.vala"
									keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 677 "../src/db/PhotoTable.vala"
									_g_free0 (object);
#line 677 "../src/db/PhotoTable.vala"
									objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 677 "../src/db/PhotoTable.vala"
									_g_object_unref0 (map);
#line 677 "../src/db/PhotoTable.vala"
									_g_key_file_unref0 (keyfile);
#line 3826 "PhotoTable.c"
									goto __catch0_g_error;
								}
#line 677 "../src/db/PhotoTable.vala"
								_tmp32_ = key_map;
#line 677 "../src/db/PhotoTable.vala"
								_tmp33_ = keys;
#line 677 "../src/db/PhotoTable.vala"
								_tmp33__length1 = keys_length1;
#line 677 "../src/db/PhotoTable.vala"
								_tmp34_ = _tmp33_[ctr];
#line 677 "../src/db/PhotoTable.vala"
								key_value_map_set_string (_tmp32_, _tmp34_, _tmp26_);
#line 676 "../src/db/PhotoTable.vala"
								_g_free0 (_tmp26_);
#line 3841 "PhotoTable.c"
							}
						}
					}
#line 679 "../src/db/PhotoTable.vala"
					_tmp35_ = map;
#line 679 "../src/db/PhotoTable.vala"
					_tmp36_ = object;
#line 679 "../src/db/PhotoTable.vala"
					_tmp37_ = key_map;
#line 679 "../src/db/PhotoTable.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp35_, _tmp36_, _tmp37_);
#line 670 "../src/db/PhotoTable.vala"
					_key_value_map_unref0 (key_map);
#line 670 "../src/db/PhotoTable.vala"
					keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 670 "../src/db/PhotoTable.vala"
					_g_free0 (object);
#line 3859 "PhotoTable.c"
				}
			}
		}
#line 682 "../src/db/PhotoTable.vala"
		result = map;
#line 682 "../src/db/PhotoTable.vala"
		objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 682 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 682 "../src/db/PhotoTable.vala"
		return result;
#line 3871 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp38_;
#line 662 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 662 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 684 "../src/db/PhotoTable.vala"
		_tmp38_ = err->message;
#line 684 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:684: %s", _tmp38_);
#line 662 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 3888 "PhotoTable.c"
	}
	__finally0:
#line 662 "../src/db/PhotoTable.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 662 "../src/db/PhotoTable.vala"
	g_clear_error (&_inner_error0_);
#line 662 "../src/db/PhotoTable.vala"
	return NULL;
#line 3897 "PhotoTable.c"
}

gchar*
photo_table_unmarshall_all_transformations (GeeHashMap* transformations)
{
	gboolean _tmp0_ = FALSE;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp6_;
	gsize length = 0UL;
	gchar* unmarshalled = NULL;
	GKeyFile* _tmp33_;
	gsize _tmp34_ = 0UL;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gchar* result;
#line 689 "../src/db/PhotoTable.vala"
	if (transformations == NULL) {
#line 689 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 3920 "PhotoTable.c"
	} else {
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 689 "../src/db/PhotoTable.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) transformations);
#line 689 "../src/db/PhotoTable.vala"
		_tmp2_ = _tmp1_;
#line 689 "../src/db/PhotoTable.vala"
		_tmp3_ = _tmp2_;
#line 689 "../src/db/PhotoTable.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 689 "../src/db/PhotoTable.vala"
		_tmp5_ = _tmp4_;
#line 689 "../src/db/PhotoTable.vala"
		_tmp0_ = _tmp5_ == 0;
#line 689 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp3_);
#line 3941 "PhotoTable.c"
	}
#line 689 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 690 "../src/db/PhotoTable.vala"
		result = NULL;
#line 690 "../src/db/PhotoTable.vala"
		return result;
#line 3949 "PhotoTable.c"
	}
#line 692 "../src/db/PhotoTable.vala"
	_tmp6_ = g_key_file_new ();
#line 692 "../src/db/PhotoTable.vala"
	keyfile = _tmp6_;
#line 3955 "PhotoTable.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 694 "../src/db/PhotoTable.vala"
		_tmp7_ = gee_abstract_map_get_keys ((GeeAbstractMap*) transformations);
#line 694 "../src/db/PhotoTable.vala"
		_tmp8_ = _tmp7_;
#line 694 "../src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_;
#line 694 "../src/db/PhotoTable.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 694 "../src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_;
#line 694 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp9_);
#line 694 "../src/db/PhotoTable.vala"
		_object_it = _tmp11_;
#line 694 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 3979 "PhotoTable.c"
			GeeIterator* _tmp12_;
			gchar* object = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			KeyValueMap* map = NULL;
			const gchar* _tmp15_;
			gpointer _tmp16_;
#line 694 "../src/db/PhotoTable.vala"
			_tmp12_ = _object_it;
#line 694 "../src/db/PhotoTable.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 694 "../src/db/PhotoTable.vala"
				break;
#line 3993 "PhotoTable.c"
			}
#line 694 "../src/db/PhotoTable.vala"
			_tmp13_ = _object_it;
#line 694 "../src/db/PhotoTable.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 694 "../src/db/PhotoTable.vala"
			object = (gchar*) _tmp14_;
#line 695 "../src/db/PhotoTable.vala"
			_tmp15_ = object;
#line 695 "../src/db/PhotoTable.vala"
			_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) transformations, _tmp15_);
#line 695 "../src/db/PhotoTable.vala"
			map = (KeyValueMap*) _tmp16_;
#line 4007 "PhotoTable.c"
			{
				GeeIterator* _key_it = NULL;
				KeyValueMap* _tmp17_;
				GeeSet* _tmp18_;
				GeeSet* _tmp19_;
				GeeIterator* _tmp20_;
				GeeIterator* _tmp21_;
#line 697 "../src/db/PhotoTable.vala"
				_tmp17_ = map;
#line 697 "../src/db/PhotoTable.vala"
				_tmp18_ = key_value_map_get_keys (_tmp17_);
#line 697 "../src/db/PhotoTable.vala"
				_tmp19_ = _tmp18_;
#line 697 "../src/db/PhotoTable.vala"
				_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 697 "../src/db/PhotoTable.vala"
				_tmp21_ = _tmp20_;
#line 697 "../src/db/PhotoTable.vala"
				_g_object_unref0 (_tmp19_);
#line 697 "../src/db/PhotoTable.vala"
				_key_it = _tmp21_;
#line 697 "../src/db/PhotoTable.vala"
				while (TRUE) {
#line 4031 "PhotoTable.c"
					GeeIterator* _tmp22_;
					gchar* key = NULL;
					GeeIterator* _tmp23_;
					gpointer _tmp24_;
					gchar* value = NULL;
					KeyValueMap* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					const gchar* _tmp28_;
					GKeyFile* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
#line 697 "../src/db/PhotoTable.vala"
					_tmp22_ = _key_it;
#line 697 "../src/db/PhotoTable.vala"
					if (!gee_iterator_next (_tmp22_)) {
#line 697 "../src/db/PhotoTable.vala"
						break;
#line 4051 "PhotoTable.c"
					}
#line 697 "../src/db/PhotoTable.vala"
					_tmp23_ = _key_it;
#line 697 "../src/db/PhotoTable.vala"
					_tmp24_ = gee_iterator_get (_tmp23_);
#line 697 "../src/db/PhotoTable.vala"
					key = (gchar*) _tmp24_;
#line 698 "../src/db/PhotoTable.vala"
					_tmp25_ = map;
#line 698 "../src/db/PhotoTable.vala"
					_tmp26_ = key;
#line 698 "../src/db/PhotoTable.vala"
					_tmp27_ = key_value_map_get_string (_tmp25_, _tmp26_, NULL);
#line 698 "../src/db/PhotoTable.vala"
					value = _tmp27_;
#line 699 "../src/db/PhotoTable.vala"
					_tmp28_ = value;
#line 699 "../src/db/PhotoTable.vala"
					_vala_assert (_tmp28_ != NULL, "value != null");
#line 701 "../src/db/PhotoTable.vala"
					_tmp29_ = keyfile;
#line 701 "../src/db/PhotoTable.vala"
					_tmp30_ = object;
#line 701 "../src/db/PhotoTable.vala"
					_tmp31_ = key;
#line 701 "../src/db/PhotoTable.vala"
					_tmp32_ = value;
#line 701 "../src/db/PhotoTable.vala"
					g_key_file_set_string (_tmp29_, _tmp30_, _tmp31_, _tmp32_);
#line 697 "../src/db/PhotoTable.vala"
					_g_free0 (value);
#line 697 "../src/db/PhotoTable.vala"
					_g_free0 (key);
#line 4085 "PhotoTable.c"
				}
#line 697 "../src/db/PhotoTable.vala"
				_g_object_unref0 (_key_it);
#line 4089 "PhotoTable.c"
			}
#line 694 "../src/db/PhotoTable.vala"
			_key_value_map_unref0 (map);
#line 694 "../src/db/PhotoTable.vala"
			_g_free0 (object);
#line 4095 "PhotoTable.c"
		}
#line 694 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_object_it);
#line 4099 "PhotoTable.c"
	}
#line 706 "../src/db/PhotoTable.vala"
	_tmp33_ = keyfile;
#line 706 "../src/db/PhotoTable.vala"
	_tmp35_ = g_key_file_to_data (_tmp33_, &_tmp34_, NULL);
#line 706 "../src/db/PhotoTable.vala"
	length = _tmp34_;
#line 706 "../src/db/PhotoTable.vala"
	unmarshalled = _tmp35_;
#line 707 "../src/db/PhotoTable.vala"
	_tmp36_ = unmarshalled;
#line 707 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp36_ != NULL, "unmarshalled != null");
#line 708 "../src/db/PhotoTable.vala"
	_tmp37_ = unmarshalled;
#line 708 "../src/db/PhotoTable.vala"
	_tmp38_ = strlen (_tmp37_);
#line 708 "../src/db/PhotoTable.vala"
	_tmp39_ = _tmp38_;
#line 708 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp39_ > 0, "unmarshalled.length > 0");
#line 710 "../src/db/PhotoTable.vala"
	result = unmarshalled;
#line 710 "../src/db/PhotoTable.vala"
	_g_key_file_unref0 (keyfile);
#line 710 "../src/db/PhotoTable.vala"
	return result;
#line 4127 "PhotoTable.c"
}

gboolean
photo_table_set_transformation (PhotoTable* self,
                                PhotoID* photo_id,
                                KeyValueMap* map)
{
	gchar* trans = NULL;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	PhotoID _tmp33_;
	const gchar* _tmp34_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 713 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 713 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 713 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (map != NULL, FALSE);
#line 714 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 714 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 714 "../src/db/PhotoTable.vala"
	trans = _tmp1_;
#line 4154 "PhotoTable.c"
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp2_;
		const gchar* _tmp3_;
		GeeSet* keys = NULL;
		GeeSet* _tmp10_;
		gsize length = 0UL;
		GKeyFile* _tmp24_;
		gsize _tmp25_ = 0UL;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 717 "../src/db/PhotoTable.vala"
		_tmp2_ = g_key_file_new ();
#line 717 "../src/db/PhotoTable.vala"
		keyfile = _tmp2_;
#line 718 "../src/db/PhotoTable.vala"
		_tmp3_ = trans;
#line 718 "../src/db/PhotoTable.vala"
		if (_tmp3_ != NULL) {
#line 4177 "PhotoTable.c"
			gboolean _tmp4_ = FALSE;
			GKeyFile* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 719 "../src/db/PhotoTable.vala"
			_tmp5_ = keyfile;
#line 719 "../src/db/PhotoTable.vala"
			_tmp6_ = trans;
#line 719 "../src/db/PhotoTable.vala"
			_tmp7_ = trans;
#line 719 "../src/db/PhotoTable.vala"
			_tmp8_ = strlen (_tmp7_);
#line 719 "../src/db/PhotoTable.vala"
			_tmp9_ = _tmp8_;
#line 719 "../src/db/PhotoTable.vala"
			_tmp4_ = g_key_file_load_from_data (_tmp5_, _tmp6_, (gsize) _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 719 "../src/db/PhotoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 719 "../src/db/PhotoTable.vala"
				_g_key_file_unref0 (keyfile);
#line 4200 "PhotoTable.c"
				goto __catch0_g_error;
			}
#line 719 "../src/db/PhotoTable.vala"
			if (!_tmp4_) {
#line 720 "../src/db/PhotoTable.vala"
				result = FALSE;
#line 720 "../src/db/PhotoTable.vala"
				_g_key_file_unref0 (keyfile);
#line 720 "../src/db/PhotoTable.vala"
				_g_free0 (trans);
#line 720 "../src/db/PhotoTable.vala"
				return result;
#line 4213 "PhotoTable.c"
			}
		}
#line 723 "../src/db/PhotoTable.vala"
		_tmp10_ = key_value_map_get_keys (map);
#line 723 "../src/db/PhotoTable.vala"
		keys = _tmp10_;
#line 4220 "PhotoTable.c"
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp11_;
			GeeIterator* _tmp12_;
#line 724 "../src/db/PhotoTable.vala"
			_tmp11_ = keys;
#line 724 "../src/db/PhotoTable.vala"
			_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 724 "../src/db/PhotoTable.vala"
			_key_it = _tmp12_;
#line 724 "../src/db/PhotoTable.vala"
			while (TRUE) {
#line 4233 "PhotoTable.c"
				GeeIterator* _tmp13_;
				gchar* key = NULL;
				GeeIterator* _tmp14_;
				gpointer _tmp15_;
				gchar* value = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				GKeyFile* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
#line 724 "../src/db/PhotoTable.vala"
				_tmp13_ = _key_it;
#line 724 "../src/db/PhotoTable.vala"
				if (!gee_iterator_next (_tmp13_)) {
#line 724 "../src/db/PhotoTable.vala"
					break;
#line 4253 "PhotoTable.c"
				}
#line 724 "../src/db/PhotoTable.vala"
				_tmp14_ = _key_it;
#line 724 "../src/db/PhotoTable.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 724 "../src/db/PhotoTable.vala"
				key = (gchar*) _tmp15_;
#line 725 "../src/db/PhotoTable.vala"
				_tmp16_ = key;
#line 725 "../src/db/PhotoTable.vala"
				_tmp17_ = key_value_map_get_string (map, _tmp16_, NULL);
#line 725 "../src/db/PhotoTable.vala"
				value = _tmp17_;
#line 726 "../src/db/PhotoTable.vala"
				_tmp18_ = value;
#line 726 "../src/db/PhotoTable.vala"
				_vala_assert (_tmp18_ != NULL, "value != null");
#line 728 "../src/db/PhotoTable.vala"
				_tmp19_ = keyfile;
#line 728 "../src/db/PhotoTable.vala"
				_tmp20_ = key_value_map_get_group (map);
#line 728 "../src/db/PhotoTable.vala"
				_tmp21_ = _tmp20_;
#line 728 "../src/db/PhotoTable.vala"
				_tmp22_ = key;
#line 728 "../src/db/PhotoTable.vala"
				_tmp23_ = value;
#line 728 "../src/db/PhotoTable.vala"
				g_key_file_set_string (_tmp19_, _tmp21_, _tmp22_, _tmp23_);
#line 728 "../src/db/PhotoTable.vala"
				_g_free0 (_tmp21_);
#line 724 "../src/db/PhotoTable.vala"
				_g_free0 (value);
#line 724 "../src/db/PhotoTable.vala"
				_g_free0 (key);
#line 4289 "PhotoTable.c"
			}
#line 724 "../src/db/PhotoTable.vala"
			_g_object_unref0 (_key_it);
#line 4293 "PhotoTable.c"
		}
#line 732 "../src/db/PhotoTable.vala"
		_tmp24_ = keyfile;
#line 732 "../src/db/PhotoTable.vala"
		_tmp26_ = g_key_file_to_data (_tmp24_, &_tmp25_, NULL);
#line 732 "../src/db/PhotoTable.vala"
		length = _tmp25_;
#line 732 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 732 "../src/db/PhotoTable.vala"
		trans = _tmp26_;
#line 733 "../src/db/PhotoTable.vala"
		_tmp27_ = trans;
#line 733 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp27_ != NULL, "trans != null");
#line 734 "../src/db/PhotoTable.vala"
		_tmp28_ = trans;
#line 734 "../src/db/PhotoTable.vala"
		_tmp29_ = strlen (_tmp28_);
#line 734 "../src/db/PhotoTable.vala"
		_tmp30_ = _tmp29_;
#line 734 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp30_ > 0, "trans.length > 0");
#line 716 "../src/db/PhotoTable.vala"
		_g_object_unref0 (keys);
#line 716 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 4321 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp31_;
#line 716 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 716 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 736 "../src/db/PhotoTable.vala"
		_tmp31_ = err->message;
#line 736 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:736: %s", _tmp31_);
#line 716 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 4338 "PhotoTable.c"
	}
	__finally0:
#line 716 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4343 "PhotoTable.c"
		gboolean _tmp32_ = FALSE;
#line 716 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 716 "../src/db/PhotoTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 716 "../src/db/PhotoTable.vala"
		g_clear_error (&_inner_error0_);
#line 716 "../src/db/PhotoTable.vala"
		return _tmp32_;
#line 4353 "PhotoTable.c"
	}
#line 739 "../src/db/PhotoTable.vala"
	_tmp33_ = *photo_id;
#line 739 "../src/db/PhotoTable.vala"
	_tmp34_ = trans;
#line 739 "../src/db/PhotoTable.vala"
	result = photo_table_set_raw_transformations (self, &_tmp33_, _tmp34_);
#line 739 "../src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 739 "../src/db/PhotoTable.vala"
	return result;
#line 4365 "PhotoTable.c"
}

gboolean
photo_table_set_original_transforms (PhotoTable* self,
                                     PhotoID* photo_id,
                                     KeyValueMap* map)
{
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp1_;
	GeeSet* keys = NULL;
	GeeSet* _tmp2_;
	gsize length = 0UL;
	gchar* trans = NULL;
	GKeyFile* _tmp16_;
	gsize _tmp17_ = 0UL;
	gchar* _tmp18_;
	PhotoID _tmp19_;
	const gchar* _tmp20_;
	gboolean result;
#line 742 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 742 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 743 "../src/db/PhotoTable.vala"
	if (map == NULL) {
#line 4391 "PhotoTable.c"
		PhotoID _tmp0_;
#line 744 "../src/db/PhotoTable.vala"
		_tmp0_ = *photo_id;
#line 744 "../src/db/PhotoTable.vala"
		result = photo_table_set_raw_original_transforms (self, &_tmp0_, "");
#line 744 "../src/db/PhotoTable.vala"
		return result;
#line 4399 "PhotoTable.c"
	}
#line 746 "../src/db/PhotoTable.vala"
	_tmp1_ = g_key_file_new ();
#line 746 "../src/db/PhotoTable.vala"
	keyfile = _tmp1_;
#line 747 "../src/db/PhotoTable.vala"
	_tmp2_ = key_value_map_get_keys (map);
#line 747 "../src/db/PhotoTable.vala"
	keys = _tmp2_;
#line 4409 "PhotoTable.c"
	{
		GeeIterator* _key_it = NULL;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
#line 748 "../src/db/PhotoTable.vala"
		_tmp3_ = keys;
#line 748 "../src/db/PhotoTable.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 748 "../src/db/PhotoTable.vala"
		_key_it = _tmp4_;
#line 748 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 4422 "PhotoTable.c"
			GeeIterator* _tmp5_;
			gchar* key = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			gchar* value = NULL;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			GKeyFile* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
#line 748 "../src/db/PhotoTable.vala"
			_tmp5_ = _key_it;
#line 748 "../src/db/PhotoTable.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 748 "../src/db/PhotoTable.vala"
				break;
#line 4442 "PhotoTable.c"
			}
#line 748 "../src/db/PhotoTable.vala"
			_tmp6_ = _key_it;
#line 748 "../src/db/PhotoTable.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 748 "../src/db/PhotoTable.vala"
			key = (gchar*) _tmp7_;
#line 749 "../src/db/PhotoTable.vala"
			_tmp8_ = key;
#line 749 "../src/db/PhotoTable.vala"
			_tmp9_ = key_value_map_get_string (map, _tmp8_, NULL);
#line 749 "../src/db/PhotoTable.vala"
			value = _tmp9_;
#line 750 "../src/db/PhotoTable.vala"
			_tmp10_ = value;
#line 750 "../src/db/PhotoTable.vala"
			_vala_assert (_tmp10_ != NULL, "value != null");
#line 752 "../src/db/PhotoTable.vala"
			_tmp11_ = keyfile;
#line 752 "../src/db/PhotoTable.vala"
			_tmp12_ = key_value_map_get_group (map);
#line 752 "../src/db/PhotoTable.vala"
			_tmp13_ = _tmp12_;
#line 752 "../src/db/PhotoTable.vala"
			_tmp14_ = key;
#line 752 "../src/db/PhotoTable.vala"
			_tmp15_ = value;
#line 752 "../src/db/PhotoTable.vala"
			g_key_file_set_string (_tmp11_, _tmp13_, _tmp14_, _tmp15_);
#line 752 "../src/db/PhotoTable.vala"
			_g_free0 (_tmp13_);
#line 748 "../src/db/PhotoTable.vala"
			_g_free0 (value);
#line 748 "../src/db/PhotoTable.vala"
			_g_free0 (key);
#line 4478 "PhotoTable.c"
		}
#line 748 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_key_it);
#line 4482 "PhotoTable.c"
	}
#line 756 "../src/db/PhotoTable.vala"
	_tmp16_ = keyfile;
#line 756 "../src/db/PhotoTable.vala"
	_tmp18_ = g_key_file_to_data (_tmp16_, &_tmp17_, NULL);
#line 756 "../src/db/PhotoTable.vala"
	length = _tmp17_;
#line 756 "../src/db/PhotoTable.vala"
	trans = _tmp18_;
#line 758 "../src/db/PhotoTable.vala"
	_tmp19_ = *photo_id;
#line 758 "../src/db/PhotoTable.vala"
	_tmp20_ = trans;
#line 758 "../src/db/PhotoTable.vala"
	result = photo_table_set_raw_original_transforms (self, &_tmp19_, _tmp20_);
#line 758 "../src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 758 "../src/db/PhotoTable.vala"
	_g_object_unref0 (keys);
#line 758 "../src/db/PhotoTable.vala"
	_g_key_file_unref0 (keyfile);
#line 758 "../src/db/PhotoTable.vala"
	return result;
#line 4506 "PhotoTable.c"
}

gboolean
photo_table_remove_transformation (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* object)
{
	gchar* trans = NULL;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoID _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 761 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 761 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 761 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 762 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 762 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 762 "../src/db/PhotoTable.vala"
	trans = _tmp1_;
#line 763 "../src/db/PhotoTable.vala"
	_tmp2_ = trans;
#line 763 "../src/db/PhotoTable.vala"
	if (_tmp2_ == NULL) {
#line 764 "../src/db/PhotoTable.vala"
		result = TRUE;
#line 764 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 764 "../src/db/PhotoTable.vala"
		return result;
#line 4544 "PhotoTable.c"
	}
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		GKeyFile* _tmp10_;
		GKeyFile* _tmp11_;
		gsize length = 0UL;
		GKeyFile* _tmp12_;
		gsize _tmp13_ = 0UL;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 767 "../src/db/PhotoTable.vala"
		_tmp3_ = g_key_file_new ();
#line 767 "../src/db/PhotoTable.vala"
		keyfile = _tmp3_;
#line 768 "../src/db/PhotoTable.vala"
		_tmp5_ = keyfile;
#line 768 "../src/db/PhotoTable.vala"
		_tmp6_ = trans;
#line 768 "../src/db/PhotoTable.vala"
		_tmp7_ = trans;
#line 768 "../src/db/PhotoTable.vala"
		_tmp8_ = strlen (_tmp7_);
#line 768 "../src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_;
#line 768 "../src/db/PhotoTable.vala"
		_tmp4_ = g_key_file_load_from_data (_tmp5_, _tmp6_, (gsize) _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 768 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 768 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 4582 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 768 "../src/db/PhotoTable.vala"
		if (!_tmp4_) {
#line 769 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 769 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 769 "../src/db/PhotoTable.vala"
			_g_free0 (trans);
#line 769 "../src/db/PhotoTable.vala"
			return result;
#line 4595 "PhotoTable.c"
		}
#line 771 "../src/db/PhotoTable.vala"
		_tmp10_ = keyfile;
#line 771 "../src/db/PhotoTable.vala"
		if (!g_key_file_has_group (_tmp10_, object)) {
#line 772 "../src/db/PhotoTable.vala"
			result = TRUE;
#line 772 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 772 "../src/db/PhotoTable.vala"
			_g_free0 (trans);
#line 772 "../src/db/PhotoTable.vala"
			return result;
#line 4609 "PhotoTable.c"
		}
#line 774 "../src/db/PhotoTable.vala"
		_tmp11_ = keyfile;
#line 774 "../src/db/PhotoTable.vala"
		g_key_file_remove_group (_tmp11_, object, &_inner_error0_);
#line 774 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 774 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 4619 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 777 "../src/db/PhotoTable.vala"
		_tmp12_ = keyfile;
#line 777 "../src/db/PhotoTable.vala"
		_tmp14_ = g_key_file_to_data (_tmp12_, &_tmp13_, NULL);
#line 777 "../src/db/PhotoTable.vala"
		length = _tmp13_;
#line 777 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 777 "../src/db/PhotoTable.vala"
		trans = _tmp14_;
#line 778 "../src/db/PhotoTable.vala"
		_tmp15_ = trans;
#line 778 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp15_ != NULL, "trans != null");
#line 766 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 4638 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp16_;
#line 766 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 766 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 780 "../src/db/PhotoTable.vala"
		_tmp16_ = err->message;
#line 780 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:780: %s", _tmp16_);
#line 766 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 4655 "PhotoTable.c"
	}
	__finally0:
#line 766 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4660 "PhotoTable.c"
		gboolean _tmp17_ = FALSE;
#line 766 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 766 "../src/db/PhotoTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 766 "../src/db/PhotoTable.vala"
		g_clear_error (&_inner_error0_);
#line 766 "../src/db/PhotoTable.vala"
		return _tmp17_;
#line 4670 "PhotoTable.c"
	}
#line 783 "../src/db/PhotoTable.vala"
	_tmp18_ = *photo_id;
#line 783 "../src/db/PhotoTable.vala"
	_tmp19_ = trans;
#line 783 "../src/db/PhotoTable.vala"
	result = photo_table_set_raw_transformations (self, &_tmp18_, _tmp19_);
#line 783 "../src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 783 "../src/db/PhotoTable.vala"
	return result;
#line 4682 "PhotoTable.c"
}

gboolean
photo_table_remove_all_transformations (PhotoTable* self,
                                        PhotoID* photo_id)
{
	PhotoID _tmp0_;
	PhotoID _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	PhotoID _tmp5_;
	gboolean result;
#line 786 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 786 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 787 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 787 "../src/db/PhotoTable.vala"
	photo_table_set_enhanced (self, &_tmp0_, FALSE);
#line 788 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 788 "../src/db/PhotoTable.vala"
	_tmp2_ = photo_table_get_raw_transformations (self, &_tmp1_);
#line 788 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_;
#line 788 "../src/db/PhotoTable.vala"
	_tmp4_ = _tmp3_ == NULL;
#line 788 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp3_);
#line 788 "../src/db/PhotoTable.vala"
	if (_tmp4_) {
#line 789 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 789 "../src/db/PhotoTable.vala"
		return result;
#line 4720 "PhotoTable.c"
	}
#line 791 "../src/db/PhotoTable.vala"
	_tmp5_ = *photo_id;
#line 791 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id ((DatabaseTable*) self, _tmp5_.id, "transformations", "");
#line 791 "../src/db/PhotoTable.vala"
	return result;
#line 4728 "PhotoTable.c"
}

static sqlite3_stmt*
photo_table_get_duplicate_stmt (PhotoTable* self,
                                GFile* file,
                                const gchar* thumbnail_md5,
                                const gchar* md5,
                                PhotoFileFormat file_format)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* sql = NULL;
	gchar* _tmp2_;
	gboolean first = FALSE;
	gboolean _tmp5_ = FALSE;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp22_;
	sqlite3_stmt* _tmp23_;
	gint col = 0;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	sqlite3_stmt* result;
#line 796 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 798 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 798 "../src/db/PhotoTable.vala"
		_tmp1_ = TRUE;
#line 4757 "PhotoTable.c"
	} else {
#line 798 "../src/db/PhotoTable.vala"
		_tmp1_ = thumbnail_md5 != NULL;
#line 4761 "PhotoTable.c"
	}
#line 798 "../src/db/PhotoTable.vala"
	if (_tmp1_) {
#line 798 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 4767 "PhotoTable.c"
	} else {
#line 798 "../src/db/PhotoTable.vala"
		_tmp0_ = md5 != NULL;
#line 4771 "PhotoTable.c"
	}
#line 798 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp0_, "file != null || thumbnail_md5 != null || md5 != null");
#line 800 "../src/db/PhotoTable.vala"
	_tmp2_ = g_strdup ("SELECT id FROM PhotoTable WHERE");
#line 800 "../src/db/PhotoTable.vala"
	sql = _tmp2_;
#line 801 "../src/db/PhotoTable.vala"
	first = TRUE;
#line 803 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 4783 "PhotoTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 804 "../src/db/PhotoTable.vala"
		_tmp3_ = sql;
#line 804 "../src/db/PhotoTable.vala"
		_tmp4_ = g_strconcat (_tmp3_, " filename=?", NULL);
#line 804 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 804 "../src/db/PhotoTable.vala"
		sql = _tmp4_;
#line 805 "../src/db/PhotoTable.vala"
		first = FALSE;
#line 4796 "PhotoTable.c"
	}
#line 808 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 808 "../src/db/PhotoTable.vala"
		_tmp5_ = TRUE;
#line 4802 "PhotoTable.c"
	} else {
#line 808 "../src/db/PhotoTable.vala"
		_tmp5_ = md5 != NULL;
#line 4806 "PhotoTable.c"
	}
#line 808 "../src/db/PhotoTable.vala"
	if (_tmp5_) {
#line 4810 "PhotoTable.c"
		const gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
#line 809 "../src/db/PhotoTable.vala"
		if (first) {
#line 4817 "PhotoTable.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 810 "../src/db/PhotoTable.vala"
			_tmp6_ = sql;
#line 810 "../src/db/PhotoTable.vala"
			_tmp7_ = g_strconcat (_tmp6_, " ((", NULL);
#line 810 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 810 "../src/db/PhotoTable.vala"
			sql = _tmp7_;
#line 4828 "PhotoTable.c"
		} else {
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 812 "../src/db/PhotoTable.vala"
			_tmp8_ = sql;
#line 812 "../src/db/PhotoTable.vala"
			_tmp9_ = g_strconcat (_tmp8_, " OR ((", NULL);
#line 812 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 812 "../src/db/PhotoTable.vala"
			sql = _tmp9_;
#line 4840 "PhotoTable.c"
		}
#line 813 "../src/db/PhotoTable.vala"
		first = FALSE;
#line 815 "../src/db/PhotoTable.vala"
		if (thumbnail_md5 != NULL) {
#line 4846 "PhotoTable.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 816 "../src/db/PhotoTable.vala"
			_tmp10_ = sql;
#line 816 "../src/db/PhotoTable.vala"
			_tmp11_ = g_strconcat (_tmp10_, " thumbnail_md5=?", NULL);
#line 816 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 816 "../src/db/PhotoTable.vala"
			sql = _tmp11_;
#line 4857 "PhotoTable.c"
		}
#line 818 "../src/db/PhotoTable.vala"
		if (md5 != NULL) {
#line 819 "../src/db/PhotoTable.vala"
			if (thumbnail_md5 == NULL) {
#line 4863 "PhotoTable.c"
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 820 "../src/db/PhotoTable.vala"
				_tmp12_ = sql;
#line 820 "../src/db/PhotoTable.vala"
				_tmp13_ = g_strconcat (_tmp12_, " md5=?", NULL);
#line 820 "../src/db/PhotoTable.vala"
				_g_free0 (sql);
#line 820 "../src/db/PhotoTable.vala"
				sql = _tmp13_;
#line 4874 "PhotoTable.c"
			} else {
				const gchar* _tmp14_;
				gchar* _tmp15_;
#line 822 "../src/db/PhotoTable.vala"
				_tmp14_ = sql;
#line 822 "../src/db/PhotoTable.vala"
				_tmp15_ = g_strconcat (_tmp14_, " OR md5=?", NULL);
#line 822 "../src/db/PhotoTable.vala"
				_g_free0 (sql);
#line 822 "../src/db/PhotoTable.vala"
				sql = _tmp15_;
#line 4886 "PhotoTable.c"
			}
		}
#line 825 "../src/db/PhotoTable.vala"
		_tmp16_ = sql;
#line 825 "../src/db/PhotoTable.vala"
		_tmp17_ = g_strconcat (_tmp16_, ")", NULL);
#line 825 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 825 "../src/db/PhotoTable.vala"
		sql = _tmp17_;
#line 827 "../src/db/PhotoTable.vala"
		if (file_format != PHOTO_FILE_FORMAT_UNKNOWN) {
#line 4899 "PhotoTable.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 828 "../src/db/PhotoTable.vala"
			_tmp18_ = sql;
#line 828 "../src/db/PhotoTable.vala"
			_tmp19_ = g_strconcat (_tmp18_, " AND file_format=?", NULL);
#line 828 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 828 "../src/db/PhotoTable.vala"
			sql = _tmp19_;
#line 4910 "PhotoTable.c"
		}
#line 830 "../src/db/PhotoTable.vala"
		_tmp20_ = sql;
#line 830 "../src/db/PhotoTable.vala"
		_tmp21_ = g_strconcat (_tmp20_, ")", NULL);
#line 830 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 830 "../src/db/PhotoTable.vala"
		sql = _tmp21_;
#line 4920 "PhotoTable.c"
	}
#line 833 "../src/db/PhotoTable.vala"
	_tmp22_ = sql;
#line 833 "../src/db/PhotoTable.vala"
	_tmp23_ = database_table_create_stmt ((DatabaseTable*) self, _tmp22_);
#line 833 "../src/db/PhotoTable.vala"
	stmt = _tmp23_;
#line 834 "../src/db/PhotoTable.vala"
	col = 1;
#line 836 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 4932 "PhotoTable.c"
		sqlite3_stmt* _tmp24_;
		gint _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 837 "../src/db/PhotoTable.vala"
		_tmp24_ = stmt;
#line 837 "../src/db/PhotoTable.vala"
		_tmp25_ = col;
#line 837 "../src/db/PhotoTable.vala"
		col = _tmp25_ + 1;
#line 837 "../src/db/PhotoTable.vala"
		_tmp26_ = g_file_get_path (file);
#line 837 "../src/db/PhotoTable.vala"
		_tmp27_ = _tmp26_;
#line 837 "../src/db/PhotoTable.vala"
		database_table_bind_text (_tmp24_, _tmp25_, _tmp27_);
#line 837 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp27_);
#line 4951 "PhotoTable.c"
	}
#line 840 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 4955 "PhotoTable.c"
		sqlite3_stmt* _tmp28_;
		gint _tmp29_;
		const gchar* _tmp30_;
#line 841 "../src/db/PhotoTable.vala"
		_tmp28_ = stmt;
#line 841 "../src/db/PhotoTable.vala"
		_tmp29_ = col;
#line 841 "../src/db/PhotoTable.vala"
		col = _tmp29_ + 1;
#line 841 "../src/db/PhotoTable.vala"
		_tmp30_ = thumbnail_md5;
#line 841 "../src/db/PhotoTable.vala"
		database_table_bind_text (_tmp28_, _tmp29_, _tmp30_);
#line 4969 "PhotoTable.c"
	}
#line 844 "../src/db/PhotoTable.vala"
	if (md5 != NULL) {
#line 4973 "PhotoTable.c"
		sqlite3_stmt* _tmp31_;
		gint _tmp32_;
		const gchar* _tmp33_;
#line 845 "../src/db/PhotoTable.vala"
		_tmp31_ = stmt;
#line 845 "../src/db/PhotoTable.vala"
		_tmp32_ = col;
#line 845 "../src/db/PhotoTable.vala"
		col = _tmp32_ + 1;
#line 845 "../src/db/PhotoTable.vala"
		_tmp33_ = md5;
#line 845 "../src/db/PhotoTable.vala"
		database_table_bind_text (_tmp31_, _tmp32_, _tmp33_);
#line 4987 "PhotoTable.c"
	}
#line 848 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 848 "../src/db/PhotoTable.vala"
		_tmp35_ = TRUE;
#line 4993 "PhotoTable.c"
	} else {
#line 848 "../src/db/PhotoTable.vala"
		_tmp35_ = md5 != NULL;
#line 4997 "PhotoTable.c"
	}
#line 848 "../src/db/PhotoTable.vala"
	if (_tmp35_) {
#line 848 "../src/db/PhotoTable.vala"
		_tmp34_ = file_format != PHOTO_FILE_FORMAT_UNKNOWN;
#line 5003 "PhotoTable.c"
	} else {
#line 848 "../src/db/PhotoTable.vala"
		_tmp34_ = FALSE;
#line 5007 "PhotoTable.c"
	}
#line 848 "../src/db/PhotoTable.vala"
	if (_tmp34_) {
#line 5011 "PhotoTable.c"
		sqlite3_stmt* _tmp36_;
		gint _tmp37_;
#line 849 "../src/db/PhotoTable.vala"
		_tmp36_ = stmt;
#line 849 "../src/db/PhotoTable.vala"
		_tmp37_ = col;
#line 849 "../src/db/PhotoTable.vala"
		col = _tmp37_ + 1;
#line 849 "../src/db/PhotoTable.vala"
		database_table_bind_int (_tmp36_, _tmp37_, photo_file_format_serialize (file_format));
#line 5022 "PhotoTable.c"
	}
#line 852 "../src/db/PhotoTable.vala"
	result = stmt;
#line 852 "../src/db/PhotoTable.vala"
	_g_free0 (sql);
#line 852 "../src/db/PhotoTable.vala"
	return result;
#line 5030 "PhotoTable.c"
}

gboolean
photo_table_has_duplicate (PhotoTable* self,
                           GFile* file,
                           const gchar* thumbnail_md5,
                           const gchar* md5,
                           PhotoFileFormat file_format)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gboolean result;
#line 855 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 856 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_get_duplicate_stmt (self, file, thumbnail_md5, md5, file_format);
#line 856 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 857 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 857 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 859 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 861 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 861 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 861 "../src/db/PhotoTable.vala"
		return result;
#line 5063 "PhotoTable.c"
	} else {
#line 862 "../src/db/PhotoTable.vala"
		if (res == SQLITE_ROW) {
#line 864 "../src/db/PhotoTable.vala"
			result = TRUE;
#line 864 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 864 "../src/db/PhotoTable.vala"
			return result;
#line 5073 "PhotoTable.c"
		} else {
#line 866 "../src/db/PhotoTable.vala"
			database_table_fatal ("has_duplicate", res);
#line 868 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 868 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 868 "../src/db/PhotoTable.vala"
			return result;
#line 5083 "PhotoTable.c"
		}
	}
}

static void
_vala_array_add49 (PhotoID* * array,
                   gint* length,
                   gint* size,
                   const PhotoID* value)
{
#line 880 "../src/db/PhotoTable.vala"
	if ((*length) == (*size)) {
#line 880 "../src/db/PhotoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 880 "../src/db/PhotoTable.vala"
		*array = g_renew (PhotoID, *array, *size);
#line 5100 "PhotoTable.c"
	}
#line 880 "../src/db/PhotoTable.vala"
	(*array)[(*length)++] = *value;
#line 5104 "PhotoTable.c"
}

PhotoID*
photo_table_get_duplicate_ids (PhotoTable* self,
                               GFile* file,
                               const gchar* thumbnail_md5,
                               const gchar* md5,
                               PhotoFileFormat file_format,
                               gint* result_length1)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	PhotoID* ids = NULL;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp2_;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID* result;
#line 872 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 874 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_get_duplicate_stmt (self, file, thumbnail_md5, md5, file_format);
#line 874 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 876 "../src/db/PhotoTable.vala"
	_tmp1_ = g_new0 (PhotoID, 0);
#line 876 "../src/db/PhotoTable.vala"
	ids = _tmp1_;
#line 876 "../src/db/PhotoTable.vala"
	ids_length1 = 0;
#line 876 "../src/db/PhotoTable.vala"
	_ids_size_ = ids_length1;
#line 878 "../src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 878 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp2_);
#line 879 "../src/db/PhotoTable.vala"
	while (TRUE) {
#line 5146 "PhotoTable.c"
		sqlite3_stmt* _tmp3_;
		PhotoID _tmp4_ = {0};
		sqlite3_stmt* _tmp5_;
#line 879 "../src/db/PhotoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 879 "../src/db/PhotoTable.vala"
			break;
#line 5154 "PhotoTable.c"
		}
#line 880 "../src/db/PhotoTable.vala"
		_tmp3_ = stmt;
#line 880 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp4_, sqlite3_column_int64 (_tmp3_, 0));
#line 880 "../src/db/PhotoTable.vala"
		_vala_array_add49 (&ids, &ids_length1, &_ids_size_, &_tmp4_);
#line 881 "../src/db/PhotoTable.vala"
		_tmp5_ = stmt;
#line 881 "../src/db/PhotoTable.vala"
		res = sqlite3_step (_tmp5_);
#line 5166 "PhotoTable.c"
	}
#line 884 "../src/db/PhotoTable.vala"
	_tmp6_ = ids;
#line 884 "../src/db/PhotoTable.vala"
	_tmp6__length1 = ids_length1;
#line 884 "../src/db/PhotoTable.vala"
	if (result_length1) {
#line 884 "../src/db/PhotoTable.vala"
		*result_length1 = _tmp6__length1;
#line 5176 "PhotoTable.c"
	}
#line 884 "../src/db/PhotoTable.vala"
	result = _tmp6_;
#line 884 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 884 "../src/db/PhotoTable.vala"
	return result;
#line 5184 "PhotoTable.c"
}

void
photo_table_update_backlinks (PhotoTable* self,
                              PhotoID* photo_id,
                              const gchar* backlinks,
                              GError** error)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 887 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 887 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 888 "../src/db/PhotoTable.vala"
	if (backlinks != NULL) {
#line 888 "../src/db/PhotoTable.vala"
		_tmp0_ = backlinks;
#line 5204 "PhotoTable.c"
	} else {
#line 888 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 5208 "PhotoTable.c"
	}
#line 888 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 888 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp1_.id, "backlinks", _tmp0_, &_inner_error0_);
#line 888 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 888 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 888 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 888 "../src/db/PhotoTable.vala"
			return;
#line 5222 "PhotoTable.c"
		} else {
#line 888 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 888 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 888 "../src/db/PhotoTable.vala"
			return;
#line 5230 "PhotoTable.c"
		}
	}
}

void
photo_table_attach_editable (PhotoTable* self,
                             PhotoRow* row,
                             BackingPhotoID* editable_id,
                             GError** error)
{
	PhotoID _tmp0_;
	BackingPhotoID _tmp1_;
	BackingPhotoID _tmp2_;
	GError* _inner_error0_ = NULL;
#line 891 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 891 "../src/db/PhotoTable.vala"
	g_return_if_fail (row != NULL);
#line 891 "../src/db/PhotoTable.vala"
	g_return_if_fail (editable_id != NULL);
#line 892 "../src/db/PhotoTable.vala"
	_tmp0_ = row->photo_id;
#line 892 "../src/db/PhotoTable.vala"
	_tmp1_ = *editable_id;
#line 892 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "editable_id", _tmp1_.id, &_inner_error0_);
#line 892 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 892 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 892 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 892 "../src/db/PhotoTable.vala"
			return;
#line 5265 "PhotoTable.c"
		} else {
#line 892 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 892 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 892 "../src/db/PhotoTable.vala"
			return;
#line 5273 "PhotoTable.c"
		}
	}
#line 894 "../src/db/PhotoTable.vala"
	_tmp2_ = *editable_id;
#line 894 "../src/db/PhotoTable.vala"
	row->editable_id = _tmp2_;
#line 5280 "PhotoTable.c"
}

void
photo_table_detach_editable (PhotoTable* self,
                             PhotoRow* row,
                             GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 897 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 897 "../src/db/PhotoTable.vala"
	g_return_if_fail (row != NULL);
#line 898 "../src/db/PhotoTable.vala"
	_tmp0_ = row->photo_id;
#line 898 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "editable_id", BACKING_PHOTO_ID_INVALID, &_inner_error0_);
#line 898 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 898 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 898 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 898 "../src/db/PhotoTable.vala"
			return;
#line 5306 "PhotoTable.c"
		} else {
#line 898 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 898 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 898 "../src/db/PhotoTable.vala"
			return;
#line 5314 "PhotoTable.c"
		}
	}
#line 900 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&row->editable_id, BACKING_PHOTO_ID_INVALID);
#line 5319 "PhotoTable.c"
}

void
photo_table_set_metadata_dirty (PhotoTable* self,
                                PhotoID* photo_id,
                                gboolean dirty,
                                GError** error)
{
	gint _tmp0_ = 0;
	PhotoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 903 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 903 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 904 "../src/db/PhotoTable.vala"
	if (dirty) {
#line 904 "../src/db/PhotoTable.vala"
		_tmp0_ = 1;
#line 5339 "PhotoTable.c"
	} else {
#line 904 "../src/db/PhotoTable.vala"
		_tmp0_ = 0;
#line 5343 "PhotoTable.c"
	}
#line 904 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 904 "../src/db/PhotoTable.vala"
	database_table_update_int_by_id_2 ((DatabaseTable*) self, _tmp1_.id, "metadata_dirty", _tmp0_, &_inner_error0_);
#line 904 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 904 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 904 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 904 "../src/db/PhotoTable.vala"
			return;
#line 5357 "PhotoTable.c"
		} else {
#line 904 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 904 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 904 "../src/db/PhotoTable.vala"
			return;
#line 5365 "PhotoTable.c"
		}
	}
}

gboolean
photo_table_set_enhanced (PhotoTable* self,
                          PhotoID* photo_id,
                          gboolean enhanced)
{
	gint _tmp0_ = 0;
	PhotoID _tmp1_;
	gboolean result;
#line 907 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 907 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 908 "../src/db/PhotoTable.vala"
	if (enhanced) {
#line 908 "../src/db/PhotoTable.vala"
		_tmp0_ = 1;
#line 5386 "PhotoTable.c"
	} else {
#line 908 "../src/db/PhotoTable.vala"
		_tmp0_ = 0;
#line 5390 "PhotoTable.c"
	}
#line 908 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 908 "../src/db/PhotoTable.vala"
	result = database_table_update_int_by_id ((DatabaseTable*) self, _tmp1_.id, "enhanced", _tmp0_);
#line 908 "../src/db/PhotoTable.vala"
	return result;
#line 5398 "PhotoTable.c"
}

void
photo_table_update_raw_development (PhotoTable* self,
                                    PhotoRow* row,
                                    RawDeveloper rd,
                                    BackingPhotoID* backing_photo_id,
                                    GError** error)
{
	gchar* col = NULL;
	BackingPhotoID* _tmp3_;
	gint _tmp3__length1;
	BackingPhotoID _tmp4_;
	PhotoID _tmp5_;
	const gchar* _tmp6_;
	BackingPhotoID _tmp7_;
	BackingPhotoID _tmp8_;
	GError* _inner_error0_ = NULL;
#line 911 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 911 "../src/db/PhotoTable.vala"
	g_return_if_fail (row != NULL);
#line 911 "../src/db/PhotoTable.vala"
	g_return_if_fail (backing_photo_id != NULL);
#line 915 "../src/db/PhotoTable.vala"
	switch (rd) {
#line 915 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 5427 "PhotoTable.c"
		{
			gchar* _tmp0_;
#line 917 "../src/db/PhotoTable.vala"
			_tmp0_ = g_strdup ("develop_shotwell_id");
#line 917 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 917 "../src/db/PhotoTable.vala"
			col = _tmp0_;
#line 918 "../src/db/PhotoTable.vala"
			break;
#line 5438 "PhotoTable.c"
		}
#line 915 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_CAMERA:
#line 5442 "PhotoTable.c"
		{
			gchar* _tmp1_;
#line 921 "../src/db/PhotoTable.vala"
			_tmp1_ = g_strdup ("develop_camera_id");
#line 921 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 921 "../src/db/PhotoTable.vala"
			col = _tmp1_;
#line 922 "../src/db/PhotoTable.vala"
			break;
#line 5453 "PhotoTable.c"
		}
#line 915 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 5457 "PhotoTable.c"
		{
			gchar* _tmp2_;
#line 925 "../src/db/PhotoTable.vala"
			_tmp2_ = g_strdup ("develop_embedded_id");
#line 925 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 925 "../src/db/PhotoTable.vala"
			col = _tmp2_;
#line 926 "../src/db/PhotoTable.vala"
			break;
#line 5468 "PhotoTable.c"
		}
		default:
		{
#line 929 "../src/db/PhotoTable.vala"
			g_assert_not_reached ();
#line 5474 "PhotoTable.c"
		}
	}
#line 932 "../src/db/PhotoTable.vala"
	_tmp3_ = row->development_ids;
#line 932 "../src/db/PhotoTable.vala"
	_tmp3__length1 = row->development_ids_length1;
#line 932 "../src/db/PhotoTable.vala"
	_tmp4_ = *backing_photo_id;
#line 932 "../src/db/PhotoTable.vala"
	_tmp3_[rd] = _tmp4_;
#line 933 "../src/db/PhotoTable.vala"
	_tmp5_ = row->photo_id;
#line 933 "../src/db/PhotoTable.vala"
	_tmp6_ = col;
#line 933 "../src/db/PhotoTable.vala"
	_tmp7_ = *backing_photo_id;
#line 933 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp5_.id, _tmp6_, _tmp7_.id, &_inner_error0_);
#line 933 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 933 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 933 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 933 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 933 "../src/db/PhotoTable.vala"
			return;
#line 5503 "PhotoTable.c"
		} else {
#line 933 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 933 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 933 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 933 "../src/db/PhotoTable.vala"
			return;
#line 5513 "PhotoTable.c"
		}
	}
#line 935 "../src/db/PhotoTable.vala"
	_tmp8_ = *backing_photo_id;
#line 935 "../src/db/PhotoTable.vala"
	if (_tmp8_.id != BACKING_PHOTO_ID_INVALID) {
#line 5520 "PhotoTable.c"
		PhotoID _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 936 "../src/db/PhotoTable.vala"
		_tmp9_ = row->photo_id;
#line 936 "../src/db/PhotoTable.vala"
		_tmp10_ = raw_developer_to_string (rd);
#line 936 "../src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_;
#line 936 "../src/db/PhotoTable.vala"
		database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp9_.id, "developer", _tmp11_, &_inner_error0_);
#line 936 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp11_);
#line 936 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 936 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 936 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 936 "../src/db/PhotoTable.vala"
				_g_free0 (col);
#line 936 "../src/db/PhotoTable.vala"
				return;
#line 5544 "PhotoTable.c"
			} else {
#line 936 "../src/db/PhotoTable.vala"
				_g_free0 (col);
#line 936 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 936 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 936 "../src/db/PhotoTable.vala"
				return;
#line 5554 "PhotoTable.c"
			}
		}
	}
#line 911 "../src/db/PhotoTable.vala"
	_g_free0 (col);
#line 5560 "PhotoTable.c"
}

void
photo_table_remove_development (PhotoTable* self,
                                PhotoRow* row,
                                RawDeveloper rd,
                                GError** error)
{
	BackingPhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 939 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 939 "../src/db/PhotoTable.vala"
	g_return_if_fail (row != NULL);
#line 940 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp0_, BACKING_PHOTO_ID_INVALID);
#line 940 "../src/db/PhotoTable.vala"
	photo_table_update_raw_development (self, row, rd, &_tmp0_, &_inner_error0_);
#line 940 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 940 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 940 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 940 "../src/db/PhotoTable.vala"
			return;
#line 5587 "PhotoTable.c"
		} else {
#line 940 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 940 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 940 "../src/db/PhotoTable.vala"
			return;
#line 5595 "PhotoTable.c"
		}
	}
}

static void
photo_table_class_init (PhotoTableClass * klass,
                        gpointer klass_data)
{
#line 119 "../src/db/PhotoTable.vala"
	photo_table_parent_class = g_type_class_peek_parent (klass);
#line 119 "../src/db/PhotoTable.vala"
	((DatabaseTableClass *) klass)->finalize = photo_table_finalize;
#line 5608 "PhotoTable.c"
}

static void
photo_table_instance_init (PhotoTable * self,
                           gpointer klass)
{
}

static void
photo_table_finalize (DatabaseTable * obj)
{
	PhotoTable * self;
#line 119 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TABLE, PhotoTable);
#line 119 "../src/db/PhotoTable.vala"
	DATABASE_TABLE_CLASS (photo_table_parent_class)->finalize (obj);
#line 5625 "PhotoTable.c"
}

static GType
photo_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTable), 0, (GInstanceInitFunc) photo_table_instance_init, NULL };
	GType photo_table_type_id;
	photo_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "PhotoTable", &g_define_type_info, 0);
	return photo_table_type_id;
}

GType
photo_table_get_type (void)
{
	static volatile gsize photo_table_type_id__once = 0;
	if (g_once_init_enter (&photo_table_type_id__once)) {
		GType photo_table_type_id;
		photo_table_type_id = photo_table_get_type_once ();
		g_once_init_leave (&photo_table_type_id__once, photo_table_type_id);
	}
	return photo_table_type_id__once;
}

void
backing_photo_id_init (BackingPhotoID *self,
                       gint64 id)
{
#line 960 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (BackingPhotoID));
#line 961 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 5657 "PhotoTable.c"
}

gboolean
backing_photo_id_is_invalid (BackingPhotoID *self)
{
	gboolean result;
#line 965 "../src/db/PhotoTable.vala"
	result = (*self).id == BACKING_PHOTO_ID_INVALID;
#line 965 "../src/db/PhotoTable.vala"
	return result;
#line 5668 "PhotoTable.c"
}

gboolean
backing_photo_id_is_valid (BackingPhotoID *self)
{
	gboolean result;
#line 969 "../src/db/PhotoTable.vala"
	result = (*self).id != BACKING_PHOTO_ID_INVALID;
#line 969 "../src/db/PhotoTable.vala"
	return result;
#line 5679 "PhotoTable.c"
}

BackingPhotoID*
backing_photo_id_dup (const BackingPhotoID* self)
{
	BackingPhotoID* dup;
#line 955 "../src/db/PhotoTable.vala"
	dup = g_new0 (BackingPhotoID, 1);
#line 955 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (BackingPhotoID));
#line 955 "../src/db/PhotoTable.vala"
	return dup;
#line 5692 "PhotoTable.c"
}

void
backing_photo_id_free (BackingPhotoID* self)
{
#line 955 "../src/db/PhotoTable.vala"
	g_free (self);
#line 5700 "PhotoTable.c"
}

static GType
backing_photo_id_get_type_once (void)
{
	GType backing_photo_id_type_id;
	backing_photo_id_type_id = g_boxed_type_register_static ("BackingPhotoID", (GBoxedCopyFunc) backing_photo_id_dup, (GBoxedFreeFunc) backing_photo_id_free);
	return backing_photo_id_type_id;
}

GType
backing_photo_id_get_type (void)
{
	static volatile gsize backing_photo_id_type_id__once = 0;
	if (g_once_init_enter (&backing_photo_id_type_id__once)) {
		GType backing_photo_id_type_id;
		backing_photo_id_type_id = backing_photo_id_get_type_once ();
		g_once_init_leave (&backing_photo_id_type_id__once, backing_photo_id_type_id);
	}
	return backing_photo_id_type_id__once;
}

gboolean
backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                     GFileInfo* info)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 983 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 983 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 984 "../src/db/PhotoTable.vala"
	if (self->filesize != g_file_info_get_size (info)) {
#line 985 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 985 "../src/db/PhotoTable.vala"
		return result;
#line 5741 "PhotoTable.c"
	}
#line 987 "../src/db/PhotoTable.vala"
	_tmp0_ = g_file_info_get_modification_date_time (info);
#line 987 "../src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_;
#line 987 "../src/db/PhotoTable.vala"
	_tmp2_ = self->timestamp == g_date_time_to_unix (_tmp1_);
#line 987 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (_tmp1_);
#line 987 "../src/db/PhotoTable.vala"
	result = _tmp2_;
#line 987 "../src/db/PhotoTable.vala"
	return result;
#line 5755 "PhotoTable.c"
}

gboolean
backing_photo_row_is_touched (BackingPhotoRow* self,
                              GFileInfo* info)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 990 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 990 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 991 "../src/db/PhotoTable.vala"
	if (self->filesize != g_file_info_get_size (info)) {
#line 992 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 992 "../src/db/PhotoTable.vala"
		return result;
#line 5776 "PhotoTable.c"
	}
#line 994 "../src/db/PhotoTable.vala"
	_tmp0_ = g_file_info_get_modification_date_time (info);
#line 994 "../src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_;
#line 994 "../src/db/PhotoTable.vala"
	_tmp2_ = self->timestamp != g_date_time_to_unix (_tmp1_);
#line 994 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (_tmp1_);
#line 994 "../src/db/PhotoTable.vala"
	result = _tmp2_;
#line 994 "../src/db/PhotoTable.vala"
	return result;
#line 5790 "PhotoTable.c"
}

void
backing_photo_row_copy_from (BackingPhotoRow* self,
                             BackingPhotoRow* from)
{
	BackingPhotoID _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	Dimensions _tmp3_;
#line 998 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 998 "../src/db/PhotoTable.vala"
	g_return_if_fail (from != NULL);
#line 999 "../src/db/PhotoTable.vala"
	_tmp0_ = from->id;
#line 999 "../src/db/PhotoTable.vala"
	self->id = _tmp0_;
#line 1000 "../src/db/PhotoTable.vala"
	self->time_created = from->time_created;
#line 1001 "../src/db/PhotoTable.vala"
	_tmp1_ = from->filepath;
#line 1001 "../src/db/PhotoTable.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1001 "../src/db/PhotoTable.vala"
	_g_free0 (self->filepath);
#line 1001 "../src/db/PhotoTable.vala"
	self->filepath = _tmp2_;
#line 1002 "../src/db/PhotoTable.vala"
	self->filesize = from->filesize;
#line 1003 "../src/db/PhotoTable.vala"
	self->timestamp = from->timestamp;
#line 1004 "../src/db/PhotoTable.vala"
	self->file_format = from->file_format;
#line 1005 "../src/db/PhotoTable.vala"
	_tmp3_ = from->dim;
#line 1005 "../src/db/PhotoTable.vala"
	self->dim = _tmp3_;
#line 1006 "../src/db/PhotoTable.vala"
	self->original_orientation = from->original_orientation;
#line 5831 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_row_construct (GType object_type)
{
	BackingPhotoRow* self = NULL;
#line 973 "../src/db/PhotoTable.vala"
	self = (BackingPhotoRow*) g_type_create_instance (object_type);
#line 973 "../src/db/PhotoTable.vala"
	return self;
#line 5842 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_row_new (void)
{
#line 973 "../src/db/PhotoTable.vala"
	return backing_photo_row_construct (TYPE_BACKING_PHOTO_ROW);
#line 5850 "PhotoTable.c"
}

static void
value_backing_photo_row_init (GValue* value)
{
#line 973 "../src/db/PhotoTable.vala"
	value->data[0].v_pointer = NULL;
#line 5858 "PhotoTable.c"
}

static void
value_backing_photo_row_free_value (GValue* value)
{
#line 973 "../src/db/PhotoTable.vala"
	if (value->data[0].v_pointer) {
#line 973 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (value->data[0].v_pointer);
#line 5868 "PhotoTable.c"
	}
}

static void
value_backing_photo_row_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 973 "../src/db/PhotoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 973 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = backing_photo_row_ref (src_value->data[0].v_pointer);
#line 5880 "PhotoTable.c"
	} else {
#line 973 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5884 "PhotoTable.c"
	}
}

static gpointer
value_backing_photo_row_peek_pointer (const GValue* value)
{
#line 973 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 5893 "PhotoTable.c"
}

static gchar*
value_backing_photo_row_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 973 "../src/db/PhotoTable.vala"
	if (collect_values[0].v_pointer) {
#line 5904 "PhotoTable.c"
		BackingPhotoRow * object;
		object = collect_values[0].v_pointer;
#line 973 "../src/db/PhotoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 973 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5911 "PhotoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 973 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5915 "PhotoTable.c"
		}
#line 973 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = backing_photo_row_ref (object);
#line 5919 "PhotoTable.c"
	} else {
#line 973 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 5923 "PhotoTable.c"
	}
#line 973 "../src/db/PhotoTable.vala"
	return NULL;
#line 5927 "PhotoTable.c"
}

static gchar*
value_backing_photo_row_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	BackingPhotoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 973 "../src/db/PhotoTable.vala"
	if (!object_p) {
#line 973 "../src/db/PhotoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5942 "PhotoTable.c"
	}
#line 973 "../src/db/PhotoTable.vala"
	if (!value->data[0].v_pointer) {
#line 973 "../src/db/PhotoTable.vala"
		*object_p = NULL;
#line 5948 "PhotoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 973 "../src/db/PhotoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 5952 "PhotoTable.c"
	} else {
#line 973 "../src/db/PhotoTable.vala"
		*object_p = backing_photo_row_ref (value->data[0].v_pointer);
#line 5956 "PhotoTable.c"
	}
#line 973 "../src/db/PhotoTable.vala"
	return NULL;
#line 5960 "PhotoTable.c"
}

GParamSpec*
param_spec_backing_photo_row (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecBackingPhotoRow* spec;
#line 973 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKING_PHOTO_ROW), NULL);
#line 973 "../src/db/PhotoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 973 "../src/db/PhotoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 973 "../src/db/PhotoTable.vala"
	return G_PARAM_SPEC (spec);
#line 5979 "PhotoTable.c"
}

gpointer
value_get_backing_photo_row (const GValue* value)
{
#line 973 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW), NULL);
#line 973 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 5989 "PhotoTable.c"
}

void
value_set_backing_photo_row (GValue* value,
                             gpointer v_object)
{
	BackingPhotoRow * old;
#line 973 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW));
#line 973 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 973 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 973 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_PHOTO_ROW));
#line 973 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 973 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 973 "../src/db/PhotoTable.vala"
		backing_photo_row_ref (value->data[0].v_pointer);
#line 6011 "PhotoTable.c"
	} else {
#line 973 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 6015 "PhotoTable.c"
	}
#line 973 "../src/db/PhotoTable.vala"
	if (old) {
#line 973 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (old);
#line 6021 "PhotoTable.c"
	}
}

void
value_take_backing_photo_row (GValue* value,
                              gpointer v_object)
{
	BackingPhotoRow * old;
#line 973 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW));
#line 973 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 973 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 973 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_PHOTO_ROW));
#line 973 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 973 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 6042 "PhotoTable.c"
	} else {
#line 973 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 6046 "PhotoTable.c"
	}
#line 973 "../src/db/PhotoTable.vala"
	if (old) {
#line 973 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (old);
#line 6052 "PhotoTable.c"
	}
}

static void
backing_photo_row_class_init (BackingPhotoRowClass * klass,
                              gpointer klass_data)
{
#line 973 "../src/db/PhotoTable.vala"
	backing_photo_row_parent_class = g_type_class_peek_parent (klass);
#line 973 "../src/db/PhotoTable.vala"
	((BackingPhotoRowClass *) klass)->finalize = backing_photo_row_finalize;
#line 6064 "PhotoTable.c"
}

static void
backing_photo_row_instance_init (BackingPhotoRow * self,
                                 gpointer klass)
{
#line 976 "../src/db/PhotoTable.vala"
	self->filepath = NULL;
#line 973 "../src/db/PhotoTable.vala"
	self->ref_count = 1;
#line 6075 "PhotoTable.c"
}

static void
backing_photo_row_finalize (BackingPhotoRow * obj)
{
	BackingPhotoRow * self;
#line 973 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_PHOTO_ROW, BackingPhotoRow);
#line 973 "../src/db/PhotoTable.vala"
	g_signal_handlers_destroy (self);
#line 976 "../src/db/PhotoTable.vala"
	_g_free0 (self->filepath);
#line 6088 "PhotoTable.c"
}

static GType
backing_photo_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_backing_photo_row_init, value_backing_photo_row_free_value, value_backing_photo_row_copy_value, value_backing_photo_row_peek_pointer, "p", value_backing_photo_row_collect_value, "p", value_backing_photo_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BackingPhotoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_photo_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingPhotoRow), 0, (GInstanceInitFunc) backing_photo_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType backing_photo_row_type_id;
	backing_photo_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackingPhotoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return backing_photo_row_type_id;
}

GType
backing_photo_row_get_type (void)
{
	static volatile gsize backing_photo_row_type_id__once = 0;
	if (g_once_init_enter (&backing_photo_row_type_id__once)) {
		GType backing_photo_row_type_id;
		backing_photo_row_type_id = backing_photo_row_get_type_once ();
		g_once_init_leave (&backing_photo_row_type_id__once, backing_photo_row_type_id);
	}
	return backing_photo_row_type_id__once;
}

gpointer
backing_photo_row_ref (gpointer instance)
{
	BackingPhotoRow * self;
	self = instance;
#line 973 "../src/db/PhotoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 973 "../src/db/PhotoTable.vala"
	return instance;
#line 6123 "PhotoTable.c"
}

void
backing_photo_row_unref (gpointer instance)
{
	BackingPhotoRow * self;
	self = instance;
#line 973 "../src/db/PhotoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 973 "../src/db/PhotoTable.vala"
		BACKING_PHOTO_ROW_GET_CLASS (self)->finalize (self);
#line 973 "../src/db/PhotoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6137 "PhotoTable.c"
	}
}

static BackingPhotoTable*
backing_photo_table_construct (GType object_type)
{
	BackingPhotoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
#line 1013 "../src/db/PhotoTable.vala"
	self = (BackingPhotoTable*) database_table_construct (object_type);
#line 1014 "../src/db/PhotoTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "BackingPhotoTable");
#line 1016 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS " "BackingPhotoTable " "(" "id INTEGER PRIMARY KEY, " "filepath TEXT UNIQUE NOT NULL, " "timestamp INTEGER, " "filesize INTEGER, " "width INTEGER, " "height INTEGER, " "original_orientation INTEGER, " "file_format INTEGER, " "time_created INTEGER)");
#line 1016 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1030 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 1030 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 1031 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1032 "../src/db/PhotoTable.vala"
		database_table_fatal ("create PhotoBackingTable", res);
#line 6165 "PhotoTable.c"
	}
#line 1013 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1013 "../src/db/PhotoTable.vala"
	return self;
#line 6171 "PhotoTable.c"
}

static BackingPhotoTable*
backing_photo_table_new (void)
{
#line 1013 "../src/db/PhotoTable.vala"
	return backing_photo_table_construct (TYPE_BACKING_PHOTO_TABLE);
#line 6179 "PhotoTable.c"
}

BackingPhotoTable*
backing_photo_table_get_instance (void)
{
	BackingPhotoTable* _tmp0_;
	BackingPhotoTable* _tmp2_;
	BackingPhotoTable* _tmp3_;
	BackingPhotoTable* result;
#line 1036 "../src/db/PhotoTable.vala"
	_tmp0_ = backing_photo_table_instance;
#line 1036 "../src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 6193 "PhotoTable.c"
		BackingPhotoTable* _tmp1_;
#line 1037 "../src/db/PhotoTable.vala"
		_tmp1_ = backing_photo_table_new ();
#line 1037 "../src/db/PhotoTable.vala"
		_database_table_unref0 (backing_photo_table_instance);
#line 1037 "../src/db/PhotoTable.vala"
		backing_photo_table_instance = _tmp1_;
#line 6201 "PhotoTable.c"
	}
#line 1039 "../src/db/PhotoTable.vala"
	_tmp2_ = backing_photo_table_instance;
#line 1039 "../src/db/PhotoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 1039 "../src/db/PhotoTable.vala"
	result = _tmp3_;
#line 1039 "../src/db/PhotoTable.vala"
	return result;
#line 6211 "PhotoTable.c"
}

void
backing_photo_table_add (BackingPhotoTable* self,
                         BackingPhotoRow* state,
                         GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	Dimensions _tmp6_;
	sqlite3_stmt* _tmp7_;
	Dimensions _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp11_;
	gint res = 0;
	sqlite3_stmt* _tmp12_;
	sqlite3* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 1042 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 1042 "../src/db/PhotoTable.vala"
	g_return_if_fail (state != NULL);
#line 1043 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO BackingPhotoTable " "(filepath, timestamp, filesize, width, height, original_orientation, " "file_format, time_created) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
#line 1043 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1049 "../src/db/PhotoTable.vala"
	time_created = now_sec ();
#line 1051 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 1051 "../src/db/PhotoTable.vala"
	_tmp2_ = state->filepath;
#line 1051 "../src/db/PhotoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp2_);
#line 1052 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1052 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp3_, 2, state->timestamp);
#line 1053 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1053 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp4_, 3, state->filesize);
#line 1054 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1054 "../src/db/PhotoTable.vala"
	_tmp6_ = state->dim;
#line 1054 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp5_, 4, _tmp6_.width);
#line 1055 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 1055 "../src/db/PhotoTable.vala"
	_tmp8_ = state->dim;
#line 1055 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp7_, 5, _tmp8_.height);
#line 1056 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 1056 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp9_, 6, (gint) state->original_orientation);
#line 1057 "../src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 1057 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp10_, 7, photo_file_format_serialize (state->file_format));
#line 1058 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 1058 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp11_, 8, time_created);
#line 1060 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 1060 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp12_);
#line 1061 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1062 "../src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoBackingTable.add", res, &_inner_error0_);
#line 1062 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1062 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1062 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1062 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1062 "../src/db/PhotoTable.vala"
				return;
#line 6303 "PhotoTable.c"
			} else {
#line 1062 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1062 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1062 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1062 "../src/db/PhotoTable.vala"
				return;
#line 6313 "PhotoTable.c"
			}
		}
	}
#line 1064 "../src/db/PhotoTable.vala"
	_tmp13_ = database_table_db;
#line 1064 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&state->id, sqlite3_last_insert_rowid (_tmp13_));
#line 1065 "../src/db/PhotoTable.vala"
	state->time_created = time_created;
#line 1042 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 6325 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_table_fetch (BackingPhotoTable* self,
                           BackingPhotoID* id,
                           GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	BackingPhotoID _tmp2_;
	gint res = 0;
	sqlite3_stmt* _tmp3_;
	BackingPhotoRow* row = NULL;
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_;
	BackingPhotoRow* _tmp7_;
	sqlite3_stmt* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	BackingPhotoRow* _tmp11_;
	sqlite3_stmt* _tmp12_;
	BackingPhotoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp17_;
	BackingPhotoRow* _tmp18_;
	sqlite3_stmt* _tmp19_;
	BackingPhotoRow* _tmp20_;
	sqlite3_stmt* _tmp21_;
	BackingPhotoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 1068 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1068 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1069 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT filepath, timestamp, filesize, width, height, " "original_orientation, file_format, time_created FROM BackingPhotoTable" \
" WHERE id=?");
#line 1069 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1072 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 1072 "../src/db/PhotoTable.vala"
	_tmp2_ = *id;
#line 1072 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp2_.id);
#line 1074 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1074 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 1075 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 1076 "../src/db/PhotoTable.vala"
		result = NULL;
#line 1076 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 1076 "../src/db/PhotoTable.vala"
		return result;
#line 6388 "PhotoTable.c"
	} else {
#line 1077 "../src/db/PhotoTable.vala"
		if (res != SQLITE_ROW) {
#line 1078 "../src/db/PhotoTable.vala"
			database_table_throw_error ("BackingPhotoTable.fetch_for_photo", res, &_inner_error0_);
#line 1078 "../src/db/PhotoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1078 "../src/db/PhotoTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1078 "../src/db/PhotoTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 1078 "../src/db/PhotoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 1078 "../src/db/PhotoTable.vala"
					return NULL;
#line 6404 "PhotoTable.c"
				} else {
#line 1078 "../src/db/PhotoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 1078 "../src/db/PhotoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1078 "../src/db/PhotoTable.vala"
					g_clear_error (&_inner_error0_);
#line 1078 "../src/db/PhotoTable.vala"
					return NULL;
#line 6414 "PhotoTable.c"
				}
			}
		}
	}
#line 1080 "../src/db/PhotoTable.vala"
	_tmp4_ = backing_photo_row_new ();
#line 1080 "../src/db/PhotoTable.vala"
	row = _tmp4_;
#line 1081 "../src/db/PhotoTable.vala"
	_tmp5_ = row;
#line 1081 "../src/db/PhotoTable.vala"
	_tmp6_ = *id;
#line 1081 "../src/db/PhotoTable.vala"
	_tmp5_->id = _tmp6_;
#line 1082 "../src/db/PhotoTable.vala"
	_tmp7_ = row;
#line 1082 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 1082 "../src/db/PhotoTable.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (_tmp8_, 0);
#line 1082 "../src/db/PhotoTable.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 1082 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp7_->filepath);
#line 1082 "../src/db/PhotoTable.vala"
	_tmp7_->filepath = _tmp10_;
#line 1083 "../src/db/PhotoTable.vala"
	_tmp11_ = row;
#line 1083 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 1083 "../src/db/PhotoTable.vala"
	_tmp11_->timestamp = sqlite3_column_int64 (_tmp12_, 1);
#line 1084 "../src/db/PhotoTable.vala"
	_tmp13_ = row;
#line 1084 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 1084 "../src/db/PhotoTable.vala"
	_tmp13_->filesize = sqlite3_column_int64 (_tmp14_, 2);
#line 1085 "../src/db/PhotoTable.vala"
	_tmp15_ = row;
#line 1085 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 1085 "../src/db/PhotoTable.vala"
	_tmp17_ = stmt;
#line 1085 "../src/db/PhotoTable.vala"
	dimensions_init (&_tmp15_->dim, sqlite3_column_int (_tmp16_, 3), sqlite3_column_int (_tmp17_, 4));
#line 1086 "../src/db/PhotoTable.vala"
	_tmp18_ = row;
#line 1086 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 1086 "../src/db/PhotoTable.vala"
	_tmp18_->original_orientation = (Orientation) sqlite3_column_int (_tmp19_, 5);
#line 1087 "../src/db/PhotoTable.vala"
	_tmp20_ = row;
#line 1087 "../src/db/PhotoTable.vala"
	_tmp21_ = stmt;
#line 1087 "../src/db/PhotoTable.vala"
	_tmp20_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp21_, 6));
#line 1088 "../src/db/PhotoTable.vala"
	_tmp22_ = row;
#line 1088 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 1088 "../src/db/PhotoTable.vala"
	_tmp22_->time_created = sqlite3_column_int64 (_tmp23_, 7);
#line 1090 "../src/db/PhotoTable.vala"
	result = row;
#line 1090 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1090 "../src/db/PhotoTable.vala"
	return result;
#line 6485 "PhotoTable.c"
}

void
backing_photo_table_update (BackingPhotoTable* self,
                            BackingPhotoRow* row,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	Dimensions _tmp4_;
	sqlite3_stmt* _tmp5_;
	Dimensions _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	BackingPhotoID _tmp10_;
	gint res = 0;
	sqlite3_stmt* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 1094 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 1094 "../src/db/PhotoTable.vala"
	g_return_if_fail (row != NULL);
#line 1095 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE BackingPhotoTable SET timestamp=?, filesize=?, " "width=?, height=?, original_orientation=?, file_format=? " "WHERE id=?");
#line 1095 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1100 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 1100 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, row->timestamp);
#line 1101 "../src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 1101 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp2_, 2, row->filesize);
#line 1102 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1102 "../src/db/PhotoTable.vala"
	_tmp4_ = row->dim;
#line 1102 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp3_, 3, _tmp4_.width);
#line 1103 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1103 "../src/db/PhotoTable.vala"
	_tmp6_ = row->dim;
#line 1103 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp5_, 4, _tmp6_.height);
#line 1104 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 1104 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp7_, 5, (gint) row->original_orientation);
#line 1105 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 1105 "../src/db/PhotoTable.vala"
	database_table_bind_int (_tmp8_, 6, photo_file_format_serialize (row->file_format));
#line 1106 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 1106 "../src/db/PhotoTable.vala"
	_tmp10_ = row->id;
#line 1106 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp9_, 7, _tmp10_.id);
#line 1108 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 1108 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp11_);
#line 1109 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1110 "../src/db/PhotoTable.vala"
		database_table_throw_error ("BackingPhotoTable.update", res, &_inner_error0_);
#line 1110 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1110 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1110 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1110 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1110 "../src/db/PhotoTable.vala"
				return;
#line 6568 "PhotoTable.c"
			} else {
#line 1110 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1110 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1110 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1110 "../src/db/PhotoTable.vala"
				return;
#line 6578 "PhotoTable.c"
			}
		}
	}
#line 1094 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 6584 "PhotoTable.c"
}

void
backing_photo_table_update_attributes (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       gint64 timestamp,
                                       gint64 filesize,
                                       GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp3_;
	BackingPhotoID _tmp4_;
	gint res = 0;
	sqlite3_stmt* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 1113 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 1113 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1114 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE BackingPhotoTable SET timestamp=?, filesize=? WHERE id=?");
#line 1114 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1116 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 1116 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, timestamp);
#line 1117 "../src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 1117 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp2_, 2, filesize);
#line 1118 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1118 "../src/db/PhotoTable.vala"
	_tmp4_ = *id;
#line 1118 "../src/db/PhotoTable.vala"
	database_table_bind_int64 (_tmp3_, 3, _tmp4_.id);
#line 1120 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1120 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 1121 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1122 "../src/db/PhotoTable.vala"
		database_table_throw_error ("BackingPhotoTable.update_attributes", res, &_inner_error0_);
#line 1122 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1122 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1122 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1122 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1122 "../src/db/PhotoTable.vala"
				return;
#line 6643 "PhotoTable.c"
			} else {
#line 1122 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1122 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1122 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1122 "../src/db/PhotoTable.vala"
				return;
#line 6653 "PhotoTable.c"
			}
		}
	}
#line 1113 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 6659 "PhotoTable.c"
}

void
backing_photo_table_remove (BackingPhotoTable* self,
                            BackingPhotoID* backing_id,
                            GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1125 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 1125 "../src/db/PhotoTable.vala"
	g_return_if_fail (backing_id != NULL);
#line 1126 "../src/db/PhotoTable.vala"
	_tmp0_ = *backing_id;
#line 1126 "../src/db/PhotoTable.vala"
	database_table_delete_by_id ((DatabaseTable*) self, _tmp0_.id, &_inner_error0_);
#line 1126 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1126 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1126 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1126 "../src/db/PhotoTable.vala"
			return;
#line 6685 "PhotoTable.c"
		} else {
#line 1126 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1126 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1126 "../src/db/PhotoTable.vala"
			return;
#line 6693 "PhotoTable.c"
		}
	}
}

void
backing_photo_table_set_filepath (BackingPhotoTable* self,
                                  BackingPhotoID* id,
                                  const gchar* filepath,
                                  GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1129 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 1129 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1129 "../src/db/PhotoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 1130 "../src/db/PhotoTable.vala"
	_tmp0_ = *id;
#line 1130 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "filepath", filepath, &_inner_error0_);
#line 1130 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1130 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1130 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1130 "../src/db/PhotoTable.vala"
			return;
#line 6724 "PhotoTable.c"
		} else {
#line 1130 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1130 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1130 "../src/db/PhotoTable.vala"
			return;
#line 6732 "PhotoTable.c"
		}
	}
}

void
backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                      BackingPhotoID* id,
                                      gint64 timestamp,
                                      GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1133 "../src/db/PhotoTable.vala"
	g_return_if_fail (self != NULL);
#line 1133 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1134 "../src/db/PhotoTable.vala"
	_tmp0_ = *id;
#line 1134 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp0_.id, "timestamp", timestamp, &_inner_error0_);
#line 1134 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1134 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1134 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1134 "../src/db/PhotoTable.vala"
			return;
#line 6761 "PhotoTable.c"
		} else {
#line 1134 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1134 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1134 "../src/db/PhotoTable.vala"
			return;
#line 6769 "PhotoTable.c"
		}
	}
}

static void
backing_photo_table_class_init (BackingPhotoTableClass * klass,
                                gpointer klass_data)
{
#line 1010 "../src/db/PhotoTable.vala"
	backing_photo_table_parent_class = g_type_class_peek_parent (klass);
#line 1010 "../src/db/PhotoTable.vala"
	((DatabaseTableClass *) klass)->finalize = backing_photo_table_finalize;
#line 6782 "PhotoTable.c"
}

static void
backing_photo_table_instance_init (BackingPhotoTable * self,
                                   gpointer klass)
{
}

static void
backing_photo_table_finalize (DatabaseTable * obj)
{
	BackingPhotoTable * self;
#line 1010 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable);
#line 1010 "../src/db/PhotoTable.vala"
	DATABASE_TABLE_CLASS (backing_photo_table_parent_class)->finalize (obj);
#line 6799 "PhotoTable.c"
}

static GType
backing_photo_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BackingPhotoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_photo_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingPhotoTable), 0, (GInstanceInitFunc) backing_photo_table_instance_init, NULL };
	GType backing_photo_table_type_id;
	backing_photo_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "BackingPhotoTable", &g_define_type_info, 0);
	return backing_photo_table_type_id;
}

GType
backing_photo_table_get_type (void)
{
	static volatile gsize backing_photo_table_type_id__once = 0;
	if (g_once_init_enter (&backing_photo_table_type_id__once)) {
		GType backing_photo_table_type_id;
		backing_photo_table_type_id = backing_photo_table_get_type_once ();
		g_once_init_leave (&backing_photo_table_type_id__once, backing_photo_table_type_id);
	}
	return backing_photo_table_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

