/* CropTool.c generated by valac 0.56.18, the Vala compiler
 * generated from CropTool.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2016-2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Felipe Escoto <felescoto95@hotmail.com>
*/

#include "io.elementary.photos.h"
#include <glib-object.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#define EDITING_TOOLS_CROP_TOOL_CROP_INIT_X_PCT 0.15
#define EDITING_TOOLS_CROP_TOOL_CROP_INIT_Y_PCT 0.15
#define EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE 8
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_SATURATION 0.00f
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_RED_SHIFT -32
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_GREEN_SHIFT -32
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_BLUE_SHIFT -32
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_ALPHA_SHIFT 0
#define EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO (-1.0f)
#define EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO (-2.0f)
#define EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO (-3.0f)
#define EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO (-4.0f)
#define EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS (-5.0f)
#define EDITING_TOOLS_CROP_TOOL_SEPARATOR (-6.0f)
#define EDITING_TOOLS_CROP_TOOL_MIN_ASPECT_RATIO (1.0f / 64.0f)
#define EDITING_TOOLS_CROP_TOOL_MAX_ASPECT_RATIO 64.0f
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW (editing_tools_crop_tool_crop_tool_window_get_type ())
#define EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindow))
#define EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindowClass))
#define EDITING_TOOLS_CROP_TOOL_IS_CROP_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW))
#define EDITING_TOOLS_CROP_TOOL_IS_CROP_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW))
#define EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindowClass))

typedef struct _EditingToolsCropToolCropToolWindow EditingToolsCropToolCropToolWindow;
typedef struct _EditingToolsCropToolCropToolWindowClass EditingToolsCropToolCropToolWindowClass;

#define EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION (editing_tools_crop_tool_constraint_description_get_type ())
#define EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescription))
#define EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescriptionClass))
#define EDITING_TOOLS_CROP_TOOL_IS_CONSTRAINT_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION))
#define EDITING_TOOLS_CROP_TOOL_IS_CONSTRAINT_DESCRIPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION))
#define EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescriptionClass))

typedef struct _EditingToolsCropToolConstraintDescription EditingToolsCropToolConstraintDescription;
typedef struct _EditingToolsCropToolConstraintDescriptionClass EditingToolsCropToolConstraintDescriptionClass;
typedef enum  {
	EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE,
	EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT
} EditingToolsCropToolReticleOrientation;

#define EDITING_TOOLS_CROP_TOOL_TYPE_RETICLE_ORIENTATION (editing_tools_crop_tool_reticle_orientation_get_type ())
typedef enum  {
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL,
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM
} EditingToolsCropToolConstraintMode;

#define EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_MODE (editing_tools_crop_tool_constraint_mode_get_type ())
enum  {
	EDITING_TOOLS_CROP_TOOL_0_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_NUM_PROPERTIES
};
static GParamSpec* editing_tools_crop_tool_properties[EDITING_TOOLS_CROP_TOOL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _EditingToolsCropToolConstraintDescriptionPrivate EditingToolsCropToolConstraintDescriptionPrivate;
enum  {
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_0_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_NAME_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_WIDTH_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_HEIGHT_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_IS_PIVOTABLE_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_ASPECT_RATIO_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_NUM_PROPERTIES
};
static GParamSpec* editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_NUM_PROPERTIES];
typedef struct _EditingToolsCropToolCropToolWindowPrivate EditingToolsCropToolCropToolWindowPrivate;
enum  {
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_0_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CROP_BUTTON_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CANCEL_BUTTON_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONSTRAINT_COMBO_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_PIVOT_RETICLE_BUTTON_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_WIDTH_ENTRY_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_HEIGHT_ENTRY_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_ASPECT_REVEALER_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_MOST_RECENTLY_EDITED_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _EditingToolsCropToolPrivate {
	EditingToolsCropToolCropToolWindow* crop_tool_window;
	GdkCursorType current_cursor_type;
	BoxLocation in_manipulation;
	cairo_t* wide_black_ctx;
	cairo_t* wide_white_ctx;
	cairo_t* thin_white_ctx;
	cairo_t* text_ctx;
	cairo_surface_t* crop_surface;
	Box scaled_crop;
	gint last_grab_x;
	gint last_grab_y;
	EditingToolsCropToolConstraintDescription** constraints;
	gint constraints_length1;
	gint _constraints_size_;
	GtkListStore* constraint_list;
	EditingToolsCropToolReticleOrientation reticle_orientation;
	EditingToolsCropToolConstraintMode constraint_mode;
	gboolean entry_insert_in_progress;
	gfloat custom_aspect_ratio;
	gint custom_width;
	gint custom_height;
	gint custom_init_width;
	gint custom_init_height;
	gint scale_factor;
	gfloat pre_aspect_ratio;
	GSettings* crop_settings;
};

struct _EditingToolsCropToolConstraintDescription {
	GObject parent_instance;
	EditingToolsCropToolConstraintDescriptionPrivate * priv;
};

struct _EditingToolsCropToolConstraintDescriptionClass {
	GObjectClass parent_class;
};

struct _EditingToolsCropToolConstraintDescriptionPrivate {
	gchar* _name;
	gint _basis_width;
	gint _basis_height;
	gboolean _is_pivotable;
	gfloat _aspect_ratio;
};

struct _EditingToolsCropToolCropToolWindow {
	EditingToolsEditingToolWindow parent_instance;
	EditingToolsCropToolCropToolWindowPrivate * priv;
};

struct _EditingToolsCropToolCropToolWindowClass {
	EditingToolsEditingToolWindowClass parent_class;
};

struct _EditingToolsCropToolCropToolWindowPrivate {
	GtkButton* _crop_button;
	GtkButton* _cancel_button;
	GtkComboBox* _constraint_combo;
	GtkButton* _pivot_reticle_button;
	GtkEntry* _custom_width_entry;
	GtkEntry* _custom_height_entry;
	GtkRevealer* _custom_aspect_revealer;
	GtkEntry* _most_recently_edited;
};

static gint EditingToolsCropTool_private_offset;
static gpointer editing_tools_crop_tool_parent_class = NULL;
static gint EditingToolsCropToolConstraintDescription_private_offset;
static gpointer editing_tools_crop_tool_constraint_description_parent_class = NULL;
static gint EditingToolsCropToolCropToolWindow_private_offset;
static gpointer editing_tools_crop_tool_crop_tool_window_parent_class = NULL;

static GType editing_tools_crop_tool_crop_tool_window_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType editing_tools_crop_tool_constraint_description_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType editing_tools_crop_tool_reticle_orientation_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType editing_tools_crop_tool_constraint_mode_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static EditingToolsCropToolReticleOrientation editing_tools_crop_tool_reticle_orientation_toggle (EditingToolsCropToolReticleOrientation self);
static EditingToolsCropToolConstraintDescription** editing_tools_crop_tool_create_constraints (gint* result_length1);
static GtkListStore* editing_tools_crop_tool_create_constraint_list (EditingToolsCropToolConstraintDescription** constraint_data,
                                                              gint constraint_data_length1);
static EditingToolsCropTool* editing_tools_crop_tool_new (void);
static EditingToolsCropTool* editing_tools_crop_tool_construct (GType object_type);
static EditingToolsCropToolConstraintDescription* editing_tools_crop_tool_constraint_description_new (const gchar* new_name,
                                                                                               gint new_basis_width,
                                                                                               gint new_basis_height,
                                                                                               gboolean new_pivotable,
                                                                                               gfloat new_aspect_ratio);
static EditingToolsCropToolConstraintDescription* editing_tools_crop_tool_constraint_description_construct (GType object_type,
                                                                                                     const gchar* new_name,
                                                                                                     gint new_basis_width,
                                                                                                     gint new_basis_height,
                                                                                                     gboolean new_pivotable,
                                                                                                     gfloat new_aspect_ratio);
static void _vala_array_add51 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add52 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add53 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add54 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add55 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add56 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add57 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add58 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add59 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add60 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add61 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add62 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add63 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add64 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add65 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add66 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add67 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add68 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add69 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add70 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add71 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add72 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add73 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add74 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add75 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add76 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add77 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add78 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add79 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static const gchar* editing_tools_crop_tool_constraint_description_get_name (EditingToolsCropToolConstraintDescription* self);
static void editing_tools_crop_tool_update_pivot_button_state (EditingToolsCropTool* self);
static GtkButton* editing_tools_crop_tool_crop_tool_window_get_pivot_reticle_button (EditingToolsCropToolCropToolWindow* self);
static EditingToolsCropToolConstraintDescription* editing_tools_crop_tool_get_selected_constraint (EditingToolsCropTool* self);
static gboolean editing_tools_crop_tool_constraint_description_get_is_pivotable (EditingToolsCropToolConstraintDescription* self);
static GtkComboBox* editing_tools_crop_tool_crop_tool_window_get_constraint_combo (EditingToolsCropToolCropToolWindow* self);
static gfloat editing_tools_crop_tool_constraint_description_get_aspect_ratio (EditingToolsCropToolConstraintDescription* self);
static void editing_tools_crop_tool_constraint_description_set_basis_width (EditingToolsCropToolConstraintDescription* self,
                                                                     gint value);
static void editing_tools_crop_tool_constraint_description_set_basis_height (EditingToolsCropToolConstraintDescription* self,
                                                                      gint value);
static gboolean editing_tools_crop_tool_on_custom_entry_focus_out (EditingToolsCropTool* self,
                                                            GdkEventFocus* event);
static GtkEntry* editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (EditingToolsCropToolCropToolWindow* self);
static GtkEntry* editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (EditingToolsCropToolCropToolWindow* self);
static GtkEntry* editing_tools_crop_tool_crop_tool_window_get_most_recently_edited (EditingToolsCropToolCropToolWindow* self);
static void editing_tools_crop_tool_constrain_crop (EditingToolsCropTool* self,
                                             Box* crop,
                                             Box* result);
static void editing_tools_crop_tool_crop_resized (EditingToolsCropTool* self,
                                           Box* new_crop);
static void editing_tools_crop_tool_on_width_insert_text (EditingToolsCropTool* self,
                                                   const gchar* text,
                                                   gint length,
                                                   gint* position);
static void editing_tools_crop_tool_on_entry_insert_text (EditingToolsCropTool* self,
                                                   GtkEntry* sender,
                                                   const gchar* text,
                                                   gint length,
                                                   gint* position);
static void editing_tools_crop_tool_on_height_insert_text (EditingToolsCropTool* self,
                                                    const gchar* text,
                                                    gint length,
                                                    gint* position);
static gfloat editing_tools_crop_tool_get_constraint_aspect_ratio (EditingToolsCropTool* self);
static void editing_tools_crop_tool_constraint_changed (EditingToolsCropTool* self);
static void editing_tools_crop_tool_set_custom_constraint_mode (EditingToolsCropTool* self);
static GtkRevealer* editing_tools_crop_tool_crop_tool_window_get_custom_aspect_revealer (EditingToolsCropToolCropToolWindow* self);
static void editing_tools_crop_tool_get_photo_dimensions (EditingToolsCropTool* self,
                                                   Dimensions* result);
VALA_EXTERN void clamp_inside_rotated_image (Box* src,
                                 gint img_w,
                                 gint img_h,
                                 gdouble angle_deg,
                                 gboolean preserve_geom,
                                 Box* result);
static EditingToolsCropToolConstraintDescription* editing_tools_crop_tool_get_last_constraint (EditingToolsCropTool* self,
                                                                                        gint* index);
static void editing_tools_crop_tool_real_activate (EditingToolsEditingTool* base,
                                            EditingToolsPhotoCanvas* canvas);
static void editing_tools_crop_tool_bind_canvas_handlers (EditingToolsCropTool* self,
                                                   EditingToolsPhotoCanvas* canvas);
static void editing_tools_crop_tool_prepare_ctx (EditingToolsCropTool* self,
                                          cairo_t* ctx,
                                          Dimensions* dim);
static EditingToolsCropToolCropToolWindow* editing_tools_crop_tool_crop_tool_window_new (GtkWindow* container);
static EditingToolsCropToolCropToolWindow* editing_tools_crop_tool_crop_tool_window_construct (GType object_type,
                                                                                        GtkWindow* container);
static gboolean editing_tools_crop_tool_constraint_description_is_separator (EditingToolsCropToolConstraintDescription* self);
static void editing_tools_crop_tool_bind_window_handlers (EditingToolsCropTool* self);
static void _editing_tools_crop_tool_prepare_ctx_editing_tools_photo_canvas_new_surface (EditingToolsPhotoCanvas* _sender,
                                                                                  cairo_t* ctx,
                                                                                  Dimensions* dim,
                                                                                  gpointer self);
static void editing_tools_crop_tool_on_resized_pixbuf (EditingToolsCropTool* self,
                                                Dimensions* old_dim,
                                                GdkPixbuf* scaled,
                                                GdkRectangle* scaled_position);
static void _editing_tools_crop_tool_on_resized_pixbuf_editing_tools_photo_canvas_resized_scaled_pixbuf (EditingToolsPhotoCanvas* _sender,
                                                                                                  Dimensions* old_dim,
                                                                                                  GdkPixbuf* scaled,
                                                                                                  GdkRectangle* scaled_position,
                                                                                                  gpointer self);
static void editing_tools_crop_tool_unbind_canvas_handlers (EditingToolsCropTool* self,
                                                     EditingToolsPhotoCanvas* canvas);
static GtkButton* editing_tools_crop_tool_crop_tool_window_get_crop_button (EditingToolsCropToolCropToolWindow* self);
static void editing_tools_crop_tool_on_crop_ok (EditingToolsCropTool* self);
static void _editing_tools_crop_tool_on_crop_ok_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static GtkButton* editing_tools_crop_tool_crop_tool_window_get_cancel_button (EditingToolsCropToolCropToolWindow* self);
static void _editing_tools_editing_tool_notify_cancel_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _editing_tools_crop_tool_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self);
static void editing_tools_crop_tool_on_pivot_button_clicked (EditingToolsCropTool* self);
static void _editing_tools_crop_tool_on_pivot_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self);
static gboolean _editing_tools_crop_tool_on_custom_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                        GdkEventFocus* event,
                                                                                        gpointer self);
static void _editing_tools_crop_tool_on_width_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                             const gchar* new_text,
                                                                             gint new_text_length,
                                                                             gint* position,
                                                                             gpointer self);
static void _editing_tools_crop_tool_on_height_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                              const gchar* new_text,
                                                                              gint new_text_length,
                                                                              gint* position,
                                                                              gpointer self);
static void editing_tools_crop_tool_unbind_window_handlers (EditingToolsCropTool* self);
static void editing_tools_crop_tool_real_deactivate (EditingToolsEditingTool* base);
static EditingToolsEditingToolWindow* editing_tools_crop_tool_real_get_tool_window (EditingToolsEditingTool* base);
static GdkPixbuf* editing_tools_crop_tool_real_get_display_pixbuf (EditingToolsEditingTool* base,
                                                            Scaling* scaling,
                                                            Photo* photo,
                                                            Dimensions* max_dim,
                                                            GError** error);
VALA_EXTERN void set_source_color_from_string (cairo_t* ctx,
                                   const gchar* spec);
static void editing_tools_crop_tool_real_on_left_click (EditingToolsEditingTool* base,
                                                 gint x,
                                                 gint y);
static void editing_tools_crop_tool_real_on_left_released (EditingToolsEditingTool* base,
                                                    gint x,
                                                    gint y);
static void editing_tools_crop_tool_update_cursor (EditingToolsCropTool* self,
                                            gint x,
                                            gint y);
static void editing_tools_crop_tool_real_on_motion (EditingToolsEditingTool* base,
                                             gint x,
                                             gint y,
                                             GdkModifierType mask);
static gboolean editing_tools_crop_tool_on_canvas_manipulation (EditingToolsCropTool* self,
                                                         gint x,
                                                         gint y);
static void editing_tools_crop_tool_real_paint (EditingToolsEditingTool* base,
                                         cairo_t* default_ctx);
static void editing_tools_crop_tool_paint_crop_tool (EditingToolsCropTool* self,
                                              Box* crop);
static gint editing_tools_crop_tool_eval_radial_line (EditingToolsCropTool* self,
                                               gdouble center_x,
                                               gdouble center_y,
                                               gdouble bounds_x,
                                               gdouble bounds_y,
                                               gdouble user_x);
static gboolean _box_equal (const Box * s1,
                     const Box * s2);
static void editing_tools_crop_tool_crop_moved (EditingToolsCropTool* self,
                                         Box* new_crop);
static void editing_tools_crop_tool_set_area_alpha (EditingToolsCropTool* self,
                                             Box* area,
                                             gdouble alpha);
static gint editing_tools_crop_tool_constraint_description_get_basis_width (EditingToolsCropToolConstraintDescription* self);
static gint editing_tools_crop_tool_constraint_description_get_basis_height (EditingToolsCropToolConstraintDescription* self);
static void editing_tools_crop_tool_constraint_description_set_aspect_ratio (EditingToolsCropToolConstraintDescription* self,
                                                                      gfloat value);
static void editing_tools_crop_tool_constraint_description_set_name (EditingToolsCropToolConstraintDescription* self,
                                                              const gchar* value);
static void editing_tools_crop_tool_constraint_description_set_is_pivotable (EditingToolsCropToolConstraintDescription* self,
                                                                      gboolean value);
static void editing_tools_crop_tool_constraint_description_finalize (GObject * obj);
static GType editing_tools_crop_tool_constraint_description_get_type_once (void);
static void _vala_editing_tools_crop_tool_constraint_description_get_property (GObject * object,
                                                                        guint property_id,
                                                                        GValue * value,
                                                                        GParamSpec * pspec);
static void _vala_editing_tools_crop_tool_constraint_description_set_property (GObject * object,
                                                                        guint property_id,
                                                                        const GValue * value,
                                                                        GParamSpec * pspec);
static gboolean editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func (GtkTreeModel* model,
                                                                                   GtkTreeIter* iter);
static void editing_tools_crop_tool_crop_tool_window_set_crop_button (EditingToolsCropToolCropToolWindow* self,
                                                               GtkButton* value);
static void editing_tools_crop_tool_crop_tool_window_set_cancel_button (EditingToolsCropToolCropToolWindow* self,
                                                                 GtkButton* value);
static void editing_tools_crop_tool_crop_tool_window_set_constraint_combo (EditingToolsCropToolCropToolWindow* self,
                                                                    GtkComboBox* value);
static void editing_tools_crop_tool_crop_tool_window_set_pivot_reticle_button (EditingToolsCropToolCropToolWindow* self,
                                                                        GtkButton* value);
static void editing_tools_crop_tool_crop_tool_window_set_custom_width_entry (EditingToolsCropToolCropToolWindow* self,
                                                                      GtkEntry* value);
static void editing_tools_crop_tool_crop_tool_window_set_custom_height_entry (EditingToolsCropToolCropToolWindow* self,
                                                                       GtkEntry* value);
static void editing_tools_crop_tool_crop_tool_window_set_custom_aspect_revealer (EditingToolsCropToolCropToolWindow* self,
                                                                          GtkRevealer* value);
static void editing_tools_crop_tool_crop_tool_window_set_most_recently_edited (EditingToolsCropToolCropToolWindow* self,
                                                                        GtkEntry* value);
static GObject * editing_tools_crop_tool_crop_tool_window_constructor (GType type,
                                                                guint n_construct_properties,
                                                                GObjectConstructParam * construct_properties);
static gboolean _editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func_gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                                                                                     GtkTreeIter* iter,
                                                                                                                     gpointer self);
static gboolean _editing_tools_crop_tool_crop_tool_window___lambda48_ (EditingToolsCropToolCropToolWindow* self);
static gboolean __editing_tools_crop_tool_crop_tool_window___lambda48__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                            GdkEventFocus* event,
                                                                                            gpointer self);
static gboolean _editing_tools_crop_tool_crop_tool_window___lambda49_ (EditingToolsCropToolCropToolWindow* self);
static gboolean __editing_tools_crop_tool_crop_tool_window___lambda49__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                            GdkEventFocus* event,
                                                                                            gpointer self);
static void editing_tools_crop_tool_crop_tool_window_finalize (GObject * obj);
static GType editing_tools_crop_tool_crop_tool_window_get_type_once (void);
static void _vala_editing_tools_crop_tool_crop_tool_window_get_property (GObject * object,
                                                                  guint property_id,
                                                                  GValue * value,
                                                                  GParamSpec * pspec);
static void _vala_editing_tools_crop_tool_crop_tool_window_set_property (GObject * object,
                                                                  guint property_id,
                                                                  const GValue * value,
                                                                  GParamSpec * pspec);
static GObject * editing_tools_crop_tool_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void editing_tools_crop_tool_finalize (GObject * obj);
static GType editing_tools_crop_tool_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
editing_tools_crop_tool_get_instance_private (EditingToolsCropTool* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsCropTool_private_offset);
}

static EditingToolsCropToolReticleOrientation
editing_tools_crop_tool_reticle_orientation_toggle (EditingToolsCropToolReticleOrientation self)
{
	EditingToolsCropToolReticleOrientation _tmp0_ = 0;
	EditingToolsCropToolReticleOrientation result;
#line 78 "../src/editing_tools/CropTool.vala"
	if (self == EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE) {
#line 78 "../src/editing_tools/CropTool.vala"
		_tmp0_ = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT;
#line 576 "CropTool.c"
	} else {
#line 79 "../src/editing_tools/CropTool.vala"
		_tmp0_ = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE;
#line 580 "CropTool.c"
	}
#line 78 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 78 "../src/editing_tools/CropTool.vala"
	return result;
#line 586 "CropTool.c"
}

static GType
editing_tools_crop_tool_reticle_orientation_get_type_once (void)
{
	static const GEnumValue values[] = {{EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE, "EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE", "landscape"}, {EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT, "EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT", "portrait"}, {0, NULL, NULL}};
	GType editing_tools_crop_tool_reticle_orientation_type_id;
	editing_tools_crop_tool_reticle_orientation_type_id = g_enum_register_static ("EditingToolsCropToolReticleOrientation", values);
	return editing_tools_crop_tool_reticle_orientation_type_id;
}

static GType
editing_tools_crop_tool_reticle_orientation_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_reticle_orientation_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_reticle_orientation_type_id__once)) {
		GType editing_tools_crop_tool_reticle_orientation_type_id;
		editing_tools_crop_tool_reticle_orientation_type_id = editing_tools_crop_tool_reticle_orientation_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_reticle_orientation_type_id__once, editing_tools_crop_tool_reticle_orientation_type_id);
	}
	return editing_tools_crop_tool_reticle_orientation_type_id__once;
}

static GType
editing_tools_crop_tool_constraint_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL, "EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL", "normal"}, {EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM, "EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType editing_tools_crop_tool_constraint_mode_type_id;
	editing_tools_crop_tool_constraint_mode_type_id = g_enum_register_static ("EditingToolsCropToolConstraintMode", values);
	return editing_tools_crop_tool_constraint_mode_type_id;
}

static GType
editing_tools_crop_tool_constraint_mode_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_constraint_mode_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_constraint_mode_type_id__once)) {
		GType editing_tools_crop_tool_constraint_mode_type_id;
		editing_tools_crop_tool_constraint_mode_type_id = editing_tools_crop_tool_constraint_mode_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_constraint_mode_type_id__once, editing_tools_crop_tool_constraint_mode_type_id);
	}
	return editing_tools_crop_tool_constraint_mode_type_id__once;
}

static EditingToolsCropTool*
editing_tools_crop_tool_construct (GType object_type)
{
	EditingToolsCropTool * self = NULL;
#line 212 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) g_object_new (object_type, "name", "CropTool", NULL);
#line 211 "../src/editing_tools/CropTool.vala"
	return self;
#line 639 "CropTool.c"
}

static EditingToolsCropTool*
editing_tools_crop_tool_new (void)
{
#line 211 "../src/editing_tools/CropTool.vala"
	return editing_tools_crop_tool_construct (EDITING_TOOLS_TYPE_CROP_TOOL);
#line 647 "CropTool.c"
}

EditingToolsCropTool*
editing_tools_crop_tool_factory (void)
{
	EditingToolsCropTool* _tmp0_;
	EditingToolsCropTool* result;
#line 220 "../src/editing_tools/CropTool.vala"
	_tmp0_ = editing_tools_crop_tool_new ();
#line 220 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 220 "../src/editing_tools/CropTool.vala"
	return result;
#line 661 "CropTool.c"
}

gboolean
editing_tools_crop_tool_is_available (Photo* photo,
                                      Scaling* scaling)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	Dimensions _tmp3_;
	gboolean result;
#line 223 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (photo != NULL, FALSE);
#line 223 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 224 "../src/editing_tools/CropTool.vala"
	photo_get_original_dimensions (photo, &_tmp0_);
#line 224 "../src/editing_tools/CropTool.vala"
	scaling_get_scaled_dimensions (scaling, &_tmp0_, &_tmp1_);
#line 224 "../src/editing_tools/CropTool.vala"
	dim = _tmp1_;
#line 226 "../src/editing_tools/CropTool.vala"
	_tmp3_ = dim;
#line 226 "../src/editing_tools/CropTool.vala"
	if (_tmp3_.width > EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 688 "CropTool.c"
		Dimensions _tmp4_;
#line 226 "../src/editing_tools/CropTool.vala"
		_tmp4_ = dim;
#line 226 "../src/editing_tools/CropTool.vala"
		_tmp2_ = _tmp4_.height > EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 694 "CropTool.c"
	} else {
#line 226 "../src/editing_tools/CropTool.vala"
		_tmp2_ = FALSE;
#line 698 "CropTool.c"
	}
#line 226 "../src/editing_tools/CropTool.vala"
	result = _tmp2_;
#line 226 "../src/editing_tools/CropTool.vala"
	return result;
#line 704 "CropTool.c"
}

static void
_vala_array_add51 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 232 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 232 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 232 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 719 "CropTool.c"
	}
#line 232 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 232 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 725 "CropTool.c"
}

static void
_vala_array_add52 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 233 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 233 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 233 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 740 "CropTool.c"
	}
#line 233 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 233 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 746 "CropTool.c"
}

static void
_vala_array_add53 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 234 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 234 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 234 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 761 "CropTool.c"
	}
#line 234 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 234 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 767 "CropTool.c"
}

static void
_vala_array_add54 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 235 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 235 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 235 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 782 "CropTool.c"
	}
#line 235 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 235 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 788 "CropTool.c"
}

static void
_vala_array_add55 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 236 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 236 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 236 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 803 "CropTool.c"
	}
#line 236 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 236 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 809 "CropTool.c"
}

static void
_vala_array_add56 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 237 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 237 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 237 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 824 "CropTool.c"
	}
#line 237 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 237 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 830 "CropTool.c"
}

static void
_vala_array_add57 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 238 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 238 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 238 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 845 "CropTool.c"
	}
#line 238 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 238 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 851 "CropTool.c"
}

static void
_vala_array_add58 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 239 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 239 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 239 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 866 "CropTool.c"
	}
#line 239 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 239 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 872 "CropTool.c"
}

static void
_vala_array_add59 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 240 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 240 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 240 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 887 "CropTool.c"
	}
#line 240 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 240 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 893 "CropTool.c"
}

static void
_vala_array_add60 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 241 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 241 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 241 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 908 "CropTool.c"
	}
#line 241 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 241 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 914 "CropTool.c"
}

static void
_vala_array_add61 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 242 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 242 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 242 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 929 "CropTool.c"
	}
#line 242 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 242 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 935 "CropTool.c"
}

static void
_vala_array_add62 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 243 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 243 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 243 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 950 "CropTool.c"
	}
#line 243 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 243 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 956 "CropTool.c"
}

static void
_vala_array_add63 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 244 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 244 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 244 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 971 "CropTool.c"
	}
#line 244 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 244 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 977 "CropTool.c"
}

static void
_vala_array_add64 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 245 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 245 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 245 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 992 "CropTool.c"
	}
#line 245 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 245 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 998 "CropTool.c"
}

static void
_vala_array_add65 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 246 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 246 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 246 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1013 "CropTool.c"
	}
#line 246 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 246 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1019 "CropTool.c"
}

static void
_vala_array_add66 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 247 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 247 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 247 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1034 "CropTool.c"
	}
#line 247 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 247 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1040 "CropTool.c"
}

static void
_vala_array_add67 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 248 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 248 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 248 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1055 "CropTool.c"
	}
#line 248 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 248 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1061 "CropTool.c"
}

static void
_vala_array_add68 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 249 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 249 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 249 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1076 "CropTool.c"
	}
#line 249 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 249 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1082 "CropTool.c"
}

static void
_vala_array_add69 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 250 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 250 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 250 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1097 "CropTool.c"
	}
#line 250 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 250 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1103 "CropTool.c"
}

static void
_vala_array_add70 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 251 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 251 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 251 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1118 "CropTool.c"
	}
#line 251 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 251 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1124 "CropTool.c"
}

static void
_vala_array_add71 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 252 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 252 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 252 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1139 "CropTool.c"
	}
#line 252 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 252 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1145 "CropTool.c"
}

static void
_vala_array_add72 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 253 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 253 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 253 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1160 "CropTool.c"
	}
#line 253 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 253 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1166 "CropTool.c"
}

static void
_vala_array_add73 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 254 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 254 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 254 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1181 "CropTool.c"
	}
#line 254 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 254 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1187 "CropTool.c"
}

static void
_vala_array_add74 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 255 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 255 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 255 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1202 "CropTool.c"
	}
#line 255 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 255 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1208 "CropTool.c"
}

static void
_vala_array_add75 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 256 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 256 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 256 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1223 "CropTool.c"
	}
#line 256 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 256 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1229 "CropTool.c"
}

static void
_vala_array_add76 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 257 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 257 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 257 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1244 "CropTool.c"
	}
#line 257 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 257 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1250 "CropTool.c"
}

static void
_vala_array_add77 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 258 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 258 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 258 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1265 "CropTool.c"
	}
#line 258 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 258 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1271 "CropTool.c"
}

static void
_vala_array_add78 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 259 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 259 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 259 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1286 "CropTool.c"
	}
#line 259 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 259 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1292 "CropTool.c"
}

static void
_vala_array_add79 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 260 "../src/editing_tools/CropTool.vala"
	if ((*length) == (*size)) {
#line 260 "../src/editing_tools/CropTool.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 260 "../src/editing_tools/CropTool.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 1307 "CropTool.c"
	}
#line 260 "../src/editing_tools/CropTool.vala"
	(*array)[(*length)++] = value;
#line 260 "../src/editing_tools/CropTool.vala"
	(*array)[*length] = NULL;
#line 1313 "CropTool.c"
}

static EditingToolsCropToolConstraintDescription**
editing_tools_crop_tool_create_constraints (gint* result_length1)
{
	EditingToolsCropToolConstraintDescription** _result_ = NULL;
	EditingToolsCropToolConstraintDescription** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	EditingToolsCropToolConstraintDescription* _tmp1_;
	EditingToolsCropToolConstraintDescription* _tmp2_;
	EditingToolsCropToolConstraintDescription* _tmp3_;
	EditingToolsCropToolConstraintDescription* _tmp4_;
	EditingToolsCropToolConstraintDescription* _tmp5_;
	EditingToolsCropToolConstraintDescription* _tmp6_;
	EditingToolsCropToolConstraintDescription* _tmp7_;
	EditingToolsCropToolConstraintDescription* _tmp8_;
	EditingToolsCropToolConstraintDescription* _tmp9_;
	EditingToolsCropToolConstraintDescription* _tmp10_;
	EditingToolsCropToolConstraintDescription* _tmp11_;
	EditingToolsCropToolConstraintDescription* _tmp12_;
	EditingToolsCropToolConstraintDescription* _tmp13_;
	EditingToolsCropToolConstraintDescription* _tmp14_;
	EditingToolsCropToolConstraintDescription* _tmp15_;
	EditingToolsCropToolConstraintDescription* _tmp16_;
	EditingToolsCropToolConstraintDescription* _tmp17_;
	EditingToolsCropToolConstraintDescription* _tmp18_;
	EditingToolsCropToolConstraintDescription* _tmp19_;
	EditingToolsCropToolConstraintDescription* _tmp20_;
	EditingToolsCropToolConstraintDescription* _tmp21_;
	EditingToolsCropToolConstraintDescription* _tmp22_;
	EditingToolsCropToolConstraintDescription* _tmp23_;
	EditingToolsCropToolConstraintDescription* _tmp24_;
	EditingToolsCropToolConstraintDescription* _tmp25_;
	EditingToolsCropToolConstraintDescription* _tmp26_;
	EditingToolsCropToolConstraintDescription* _tmp27_;
	EditingToolsCropToolConstraintDescription* _tmp28_;
	EditingToolsCropToolConstraintDescription* _tmp29_;
	EditingToolsCropToolConstraintDescription** _tmp30_;
	gint _tmp30__length1;
	EditingToolsCropToolConstraintDescription** result;
#line 230 "../src/editing_tools/CropTool.vala"
	_tmp0_ = g_new0 (EditingToolsCropToolConstraintDescription*, 0 + 1);
#line 230 "../src/editing_tools/CropTool.vala"
	_result_ = _tmp0_;
#line 230 "../src/editing_tools/CropTool.vala"
	_result__length1 = 0;
#line 230 "../src/editing_tools/CropTool.vala"
	__result__size_ = _result__length1;
#line 232 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_constraint_description_new (_ ("Unconstrained"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO);
#line 232 "../src/editing_tools/CropTool.vala"
	_vala_array_add51 (&_result_, &_result__length1, &__result__size_, _tmp1_);
#line 233 "../src/editing_tools/CropTool.vala"
	_tmp2_ = editing_tools_crop_tool_constraint_description_new (_ ("Square"), 1, 1, FALSE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 233 "../src/editing_tools/CropTool.vala"
	_vala_array_add52 (&_result_, &_result__length1, &__result__size_, _tmp2_);
#line 234 "../src/editing_tools/CropTool.vala"
	_tmp3_ = editing_tools_crop_tool_constraint_description_new (_ ("Screen"), 0, 0, TRUE, EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO);
#line 234 "../src/editing_tools/CropTool.vala"
	_vala_array_add53 (&_result_, &_result__length1, &__result__size_, _tmp3_);
#line 235 "../src/editing_tools/CropTool.vala"
	_tmp4_ = editing_tools_crop_tool_constraint_description_new (_ ("Original Size"), 0, 0, TRUE, EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO);
#line 235 "../src/editing_tools/CropTool.vala"
	_vala_array_add54 (&_result_, &_result__length1, &__result__size_, _tmp4_);
#line 236 "../src/editing_tools/CropTool.vala"
	_tmp5_ = editing_tools_crop_tool_constraint_description_new (_ ("-"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_SEPARATOR);
#line 236 "../src/editing_tools/CropTool.vala"
	_vala_array_add55 (&_result_, &_result__length1, &__result__size_, _tmp5_);
#line 237 "../src/editing_tools/CropTool.vala"
	_tmp6_ = editing_tools_crop_tool_constraint_description_new (_ ("SD Video (4 : 3)"), 4, 3, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 237 "../src/editing_tools/CropTool.vala"
	_vala_array_add56 (&_result_, &_result__length1, &__result__size_, _tmp6_);
#line 238 "../src/editing_tools/CropTool.vala"
	_tmp7_ = editing_tools_crop_tool_constraint_description_new (_ ("HD Video (16 : 9)"), 16, 9, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 238 "../src/editing_tools/CropTool.vala"
	_vala_array_add57 (&_result_, &_result__length1, &__result__size_, _tmp7_);
#line 239 "../src/editing_tools/CropTool.vala"
	_tmp8_ = editing_tools_crop_tool_constraint_description_new (_ ("-"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_SEPARATOR);
#line 239 "../src/editing_tools/CropTool.vala"
	_vala_array_add58 (&_result_, &_result__length1, &__result__size_, _tmp8_);
#line 240 "../src/editing_tools/CropTool.vala"
	_tmp9_ = editing_tools_crop_tool_constraint_description_new (_ ("Wallet (2 x 3 in.)"), 3, 2, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 240 "../src/editing_tools/CropTool.vala"
	_vala_array_add59 (&_result_, &_result__length1, &__result__size_, _tmp9_);
#line 241 "../src/editing_tools/CropTool.vala"
	_tmp10_ = editing_tools_crop_tool_constraint_description_new (_ ("Notecard (3 x 5 in.)"), 5, 3, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 241 "../src/editing_tools/CropTool.vala"
	_vala_array_add60 (&_result_, &_result__length1, &__result__size_, _tmp10_);
#line 242 "../src/editing_tools/CropTool.vala"
	_tmp11_ = editing_tools_crop_tool_constraint_description_new (_ ("4 x 6 in."), 6, 4, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 242 "../src/editing_tools/CropTool.vala"
	_vala_array_add61 (&_result_, &_result__length1, &__result__size_, _tmp11_);
#line 243 "../src/editing_tools/CropTool.vala"
	_tmp12_ = editing_tools_crop_tool_constraint_description_new (_ ("5 x 7 in."), 7, 5, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 243 "../src/editing_tools/CropTool.vala"
	_vala_array_add62 (&_result_, &_result__length1, &__result__size_, _tmp12_);
#line 244 "../src/editing_tools/CropTool.vala"
	_tmp13_ = editing_tools_crop_tool_constraint_description_new (_ ("8 x 10 in."), 10, 8, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 244 "../src/editing_tools/CropTool.vala"
	_vala_array_add63 (&_result_, &_result__length1, &__result__size_, _tmp13_);
#line 245 "../src/editing_tools/CropTool.vala"
	_tmp14_ = editing_tools_crop_tool_constraint_description_new (_ ("Letter (8.5 x 11 in.)"), 85, 110, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 245 "../src/editing_tools/CropTool.vala"
	_vala_array_add64 (&_result_, &_result__length1, &__result__size_, _tmp14_);
#line 246 "../src/editing_tools/CropTool.vala"
	_tmp15_ = editing_tools_crop_tool_constraint_description_new (_ ("11 x 14 in."), 14, 11, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 246 "../src/editing_tools/CropTool.vala"
	_vala_array_add65 (&_result_, &_result__length1, &__result__size_, _tmp15_);
#line 247 "../src/editing_tools/CropTool.vala"
	_tmp16_ = editing_tools_crop_tool_constraint_description_new (_ ("Tabloid (11 x 17 in.)"), 17, 11, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 247 "../src/editing_tools/CropTool.vala"
	_vala_array_add66 (&_result_, &_result__length1, &__result__size_, _tmp16_);
#line 248 "../src/editing_tools/CropTool.vala"
	_tmp17_ = editing_tools_crop_tool_constraint_description_new (_ ("16 x 20 in."), 20, 16, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 248 "../src/editing_tools/CropTool.vala"
	_vala_array_add67 (&_result_, &_result__length1, &__result__size_, _tmp17_);
#line 249 "../src/editing_tools/CropTool.vala"
	_tmp18_ = editing_tools_crop_tool_constraint_description_new (_ ("-"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_SEPARATOR);
#line 249 "../src/editing_tools/CropTool.vala"
	_vala_array_add68 (&_result_, &_result__length1, &__result__size_, _tmp18_);
#line 250 "../src/editing_tools/CropTool.vala"
	_tmp19_ = editing_tools_crop_tool_constraint_description_new (_ ("Metric Wallet (9 x 13 cm)"), 13, 9, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 250 "../src/editing_tools/CropTool.vala"
	_vala_array_add69 (&_result_, &_result__length1, &__result__size_, _tmp19_);
#line 251 "../src/editing_tools/CropTool.vala"
	_tmp20_ = editing_tools_crop_tool_constraint_description_new (_ ("Postcard (10 x 15 cm)"), 15, 10, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 251 "../src/editing_tools/CropTool.vala"
	_vala_array_add70 (&_result_, &_result__length1, &__result__size_, _tmp20_);
#line 252 "../src/editing_tools/CropTool.vala"
	_tmp21_ = editing_tools_crop_tool_constraint_description_new (_ ("13 x 18 cm"), 18, 13, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 252 "../src/editing_tools/CropTool.vala"
	_vala_array_add71 (&_result_, &_result__length1, &__result__size_, _tmp21_);
#line 253 "../src/editing_tools/CropTool.vala"
	_tmp22_ = editing_tools_crop_tool_constraint_description_new (_ ("18 x 24 cm"), 24, 18, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 253 "../src/editing_tools/CropTool.vala"
	_vala_array_add72 (&_result_, &_result__length1, &__result__size_, _tmp22_);
#line 254 "../src/editing_tools/CropTool.vala"
	_tmp23_ = editing_tools_crop_tool_constraint_description_new (_ ("A4 (210 x 297 mm)"), 210, 297, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 254 "../src/editing_tools/CropTool.vala"
	_vala_array_add73 (&_result_, &_result__length1, &__result__size_, _tmp23_);
#line 255 "../src/editing_tools/CropTool.vala"
	_tmp24_ = editing_tools_crop_tool_constraint_description_new (_ ("20 x 30 cm"), 30, 20, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 255 "../src/editing_tools/CropTool.vala"
	_vala_array_add74 (&_result_, &_result__length1, &__result__size_, _tmp24_);
#line 256 "../src/editing_tools/CropTool.vala"
	_tmp25_ = editing_tools_crop_tool_constraint_description_new (_ ("24 x 40 cm"), 40, 24, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 256 "../src/editing_tools/CropTool.vala"
	_vala_array_add75 (&_result_, &_result__length1, &__result__size_, _tmp25_);
#line 257 "../src/editing_tools/CropTool.vala"
	_tmp26_ = editing_tools_crop_tool_constraint_description_new (_ ("30 x 40 cm"), 40, 30, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 257 "../src/editing_tools/CropTool.vala"
	_vala_array_add76 (&_result_, &_result__length1, &__result__size_, _tmp26_);
#line 258 "../src/editing_tools/CropTool.vala"
	_tmp27_ = editing_tools_crop_tool_constraint_description_new (_ ("A3 (297 x 420 mm)"), 420, 297, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 258 "../src/editing_tools/CropTool.vala"
	_vala_array_add77 (&_result_, &_result__length1, &__result__size_, _tmp27_);
#line 259 "../src/editing_tools/CropTool.vala"
	_tmp28_ = editing_tools_crop_tool_constraint_description_new (_ ("-"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_SEPARATOR);
#line 259 "../src/editing_tools/CropTool.vala"
	_vala_array_add78 (&_result_, &_result__length1, &__result__size_, _tmp28_);
#line 260 "../src/editing_tools/CropTool.vala"
	_tmp29_ = editing_tools_crop_tool_constraint_description_new (_ ("Custom"), 0, 0, TRUE, EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO);
#line 260 "../src/editing_tools/CropTool.vala"
	_vala_array_add79 (&_result_, &_result__length1, &__result__size_, _tmp29_);
#line 262 "../src/editing_tools/CropTool.vala"
	_tmp30_ = _result_;
#line 262 "../src/editing_tools/CropTool.vala"
	_tmp30__length1 = _result__length1;
#line 262 "../src/editing_tools/CropTool.vala"
	if (result_length1) {
#line 262 "../src/editing_tools/CropTool.vala"
		*result_length1 = _tmp30__length1;
#line 1487 "CropTool.c"
	}
#line 262 "../src/editing_tools/CropTool.vala"
	result = _tmp30_;
#line 262 "../src/editing_tools/CropTool.vala"
	return result;
#line 1493 "CropTool.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 269 "../src/editing_tools/CropTool.vala"
	return self ? g_object_ref (self) : NULL;
#line 1501 "CropTool.c"
}

static GtkListStore*
editing_tools_crop_tool_create_constraint_list (EditingToolsCropToolConstraintDescription** constraint_data,
                                                gint constraint_data_length1)
{
	GtkListStore* _result_ = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	GtkListStore* result;
#line 266 "../src/editing_tools/CropTool.vala"
	_tmp0_ = gtk_list_store_new (1, G_TYPE_STRING, G_TYPE_STRING, -1);
#line 266 "../src/editing_tools/CropTool.vala"
	_result_ = _tmp0_;
#line 1516 "CropTool.c"
	{
		EditingToolsCropToolConstraintDescription** constraint_collection = NULL;
		gint constraint_collection_length1 = 0;
		gint _constraint_collection_size_ = 0;
		gint constraint_it = 0;
#line 269 "../src/editing_tools/CropTool.vala"
		constraint_collection = constraint_data;
#line 269 "../src/editing_tools/CropTool.vala"
		constraint_collection_length1 = constraint_data_length1;
#line 269 "../src/editing_tools/CropTool.vala"
		for (constraint_it = 0; constraint_it < constraint_collection_length1; constraint_it = constraint_it + 1) {
#line 1528 "CropTool.c"
			EditingToolsCropToolConstraintDescription* _tmp1_;
			EditingToolsCropToolConstraintDescription* constraint = NULL;
#line 269 "../src/editing_tools/CropTool.vala"
			_tmp1_ = _g_object_ref0 (constraint_collection[constraint_it]);
#line 269 "../src/editing_tools/CropTool.vala"
			constraint = _tmp1_;
#line 1535 "CropTool.c"
			{
				GtkListStore* _tmp2_;
				GtkTreeIter _tmp3_ = {0};
				GtkListStore* _tmp4_;
				GtkTreeIter _tmp5_;
				EditingToolsCropToolConstraintDescription* _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				GValue _tmp9_ = {0};
#line 270 "../src/editing_tools/CropTool.vala"
				_tmp2_ = _result_;
#line 270 "../src/editing_tools/CropTool.vala"
				gtk_list_store_append (_tmp2_, &_tmp3_);
#line 270 "../src/editing_tools/CropTool.vala"
				iter = _tmp3_;
#line 271 "../src/editing_tools/CropTool.vala"
				_tmp4_ = _result_;
#line 271 "../src/editing_tools/CropTool.vala"
				_tmp5_ = iter;
#line 271 "../src/editing_tools/CropTool.vala"
				_tmp6_ = constraint;
#line 271 "../src/editing_tools/CropTool.vala"
				_tmp7_ = editing_tools_crop_tool_constraint_description_get_name (_tmp6_);
#line 271 "../src/editing_tools/CropTool.vala"
				_tmp8_ = _tmp7_;
#line 271 "../src/editing_tools/CropTool.vala"
				g_value_init (&_tmp9_, G_TYPE_STRING);
#line 271 "../src/editing_tools/CropTool.vala"
				g_value_set_string (&_tmp9_, _tmp8_);
#line 271 "../src/editing_tools/CropTool.vala"
				gtk_list_store_set_value (_tmp4_, &_tmp5_, 0, &_tmp9_);
#line 271 "../src/editing_tools/CropTool.vala"
				G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 269 "../src/editing_tools/CropTool.vala"
				_g_object_unref0 (constraint);
#line 1571 "CropTool.c"
			}
		}
	}
#line 274 "../src/editing_tools/CropTool.vala"
	result = _result_;
#line 274 "../src/editing_tools/CropTool.vala"
	return result;
#line 1579 "CropTool.c"
}

static void
editing_tools_crop_tool_update_pivot_button_state (EditingToolsCropTool* self)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	EditingToolsCropToolConstraintDescription* _tmp3_;
	EditingToolsCropToolConstraintDescription* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 277 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 278 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_crop_tool_window_get_pivot_reticle_button (_tmp0_);
#line 278 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 278 "../src/editing_tools/CropTool.vala"
	_tmp3_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 278 "../src/editing_tools/CropTool.vala"
	_tmp4_ = _tmp3_;
#line 278 "../src/editing_tools/CropTool.vala"
	_tmp5_ = editing_tools_crop_tool_constraint_description_get_is_pivotable (_tmp4_);
#line 278 "../src/editing_tools/CropTool.vala"
	_tmp6_ = _tmp5_;
#line 278 "../src/editing_tools/CropTool.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, _tmp6_);
#line 278 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp4_);
#line 1612 "CropTool.c"
}

static EditingToolsCropToolConstraintDescription*
editing_tools_crop_tool_get_selected_constraint (EditingToolsCropTool* self)
{
	EditingToolsCropToolConstraintDescription* _result_ = NULL;
	EditingToolsCropToolConstraintDescription** _tmp0_;
	gint _tmp0__length1;
	EditingToolsCropToolCropToolWindow* _tmp1_;
	GtkComboBox* _tmp2_;
	GtkComboBox* _tmp3_;
	EditingToolsCropToolConstraintDescription* _tmp4_;
	EditingToolsCropToolConstraintDescription* _tmp5_;
	EditingToolsCropToolConstraintDescription* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	EditingToolsCropToolConstraintDescription* result;
#line 281 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 282 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->constraints;
#line 282 "../src/editing_tools/CropTool.vala"
	_tmp0__length1 = self->priv->constraints_length1;
#line 282 "../src/editing_tools/CropTool.vala"
	_tmp1_ = self->priv->crop_tool_window;
#line 282 "../src/editing_tools/CropTool.vala"
	_tmp2_ = editing_tools_crop_tool_crop_tool_window_get_constraint_combo (_tmp1_);
#line 282 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 282 "../src/editing_tools/CropTool.vala"
	_tmp4_ = _tmp0_[gtk_combo_box_get_active (_tmp3_)];
#line 282 "../src/editing_tools/CropTool.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 282 "../src/editing_tools/CropTool.vala"
	_result_ = _tmp5_;
#line 284 "../src/editing_tools/CropTool.vala"
	_tmp6_ = _result_;
#line 284 "../src/editing_tools/CropTool.vala"
	_tmp7_ = editing_tools_crop_tool_constraint_description_get_aspect_ratio (_tmp6_);
#line 284 "../src/editing_tools/CropTool.vala"
	_tmp8_ = _tmp7_;
#line 284 "../src/editing_tools/CropTool.vala"
	if (_tmp8_ == EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO) {
#line 1656 "CropTool.c"
		EditingToolsCropToolConstraintDescription* _tmp9_;
		EditingToolsPhotoCanvas* _tmp10_;
		GdkRectangle _tmp11_ = {0};
		GdkRectangle _tmp12_;
		EditingToolsCropToolConstraintDescription* _tmp13_;
		EditingToolsPhotoCanvas* _tmp14_;
		GdkRectangle _tmp15_ = {0};
		GdkRectangle _tmp16_;
#line 285 "../src/editing_tools/CropTool.vala"
		_tmp9_ = _result_;
#line 285 "../src/editing_tools/CropTool.vala"
		_tmp10_ = ((EditingToolsEditingTool*) self)->canvas;
#line 285 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_get_scaled_position (_tmp10_, &_tmp11_);
#line 285 "../src/editing_tools/CropTool.vala"
		_tmp12_ = _tmp11_;
#line 285 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_basis_width (_tmp9_, _tmp12_.width);
#line 286 "../src/editing_tools/CropTool.vala"
		_tmp13_ = _result_;
#line 286 "../src/editing_tools/CropTool.vala"
		_tmp14_ = ((EditingToolsEditingTool*) self)->canvas;
#line 286 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_get_scaled_position (_tmp14_, &_tmp15_);
#line 286 "../src/editing_tools/CropTool.vala"
		_tmp16_ = _tmp15_;
#line 286 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_basis_height (_tmp13_, _tmp16_.height);
#line 1685 "CropTool.c"
	} else {
		EditingToolsCropToolConstraintDescription* _tmp17_;
		gfloat _tmp18_;
		gfloat _tmp19_;
#line 287 "../src/editing_tools/CropTool.vala"
		_tmp17_ = _result_;
#line 287 "../src/editing_tools/CropTool.vala"
		_tmp18_ = editing_tools_crop_tool_constraint_description_get_aspect_ratio (_tmp17_);
#line 287 "../src/editing_tools/CropTool.vala"
		_tmp19_ = _tmp18_;
#line 287 "../src/editing_tools/CropTool.vala"
		if (_tmp19_ == EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO) {
#line 1698 "CropTool.c"
			Dimensions dimensions = {0};
			AppWindow* _tmp20_;
			AppWindow* _tmp21_;
			Dimensions _tmp22_ = {0};
			Dimensions _tmp23_;
			EditingToolsCropToolConstraintDescription* _tmp24_;
			Dimensions _tmp25_;
			EditingToolsCropToolConstraintDescription* _tmp26_;
			Dimensions _tmp27_;
#line 288 "../src/editing_tools/CropTool.vala"
			_tmp20_ = app_window_get_instance ();
#line 288 "../src/editing_tools/CropTool.vala"
			_tmp21_ = _tmp20_;
#line 288 "../src/editing_tools/CropTool.vala"
			scaling_get_screen_dimensions ((GtkWindow*) _tmp21_, &_tmp22_);
#line 288 "../src/editing_tools/CropTool.vala"
			_tmp23_ = _tmp22_;
#line 288 "../src/editing_tools/CropTool.vala"
			_g_object_unref0 (_tmp21_);
#line 288 "../src/editing_tools/CropTool.vala"
			dimensions = _tmp23_;
#line 289 "../src/editing_tools/CropTool.vala"
			_tmp24_ = _result_;
#line 289 "../src/editing_tools/CropTool.vala"
			_tmp25_ = dimensions;
#line 289 "../src/editing_tools/CropTool.vala"
			editing_tools_crop_tool_constraint_description_set_basis_width (_tmp24_, _tmp25_.width);
#line 290 "../src/editing_tools/CropTool.vala"
			_tmp26_ = _result_;
#line 290 "../src/editing_tools/CropTool.vala"
			_tmp27_ = dimensions;
#line 290 "../src/editing_tools/CropTool.vala"
			editing_tools_crop_tool_constraint_description_set_basis_height (_tmp26_, _tmp27_.height);
#line 1732 "CropTool.c"
		}
	}
#line 293 "../src/editing_tools/CropTool.vala"
	result = _result_;
#line 293 "../src/editing_tools/CropTool.vala"
	return result;
#line 1739 "CropTool.c"
}

static gboolean
editing_tools_crop_tool_on_custom_entry_focus_out (EditingToolsCropTool* self,
                                                   GdkEventFocus* event)
{
	gint width = 0;
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint height = 0;
	EditingToolsCropToolCropToolWindow* _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gboolean _tmp20_ = FALSE;
	Box new_crop = {0};
	Box _tmp53_;
	Box _tmp54_ = {0};
	Box _tmp55_;
	Box _tmp56_;
	EditingToolsPhotoCanvas* _tmp57_;
	Box _tmp58_;
	EditingToolsPhotoCanvas* _tmp59_;
	gboolean result;
#line 296 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 296 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 297 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 297 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp0_);
#line 297 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 297 "../src/editing_tools/CropTool.vala"
	_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 297 "../src/editing_tools/CropTool.vala"
	_tmp4_ = _tmp3_;
#line 297 "../src/editing_tools/CropTool.vala"
	width = atoi (_tmp4_);
#line 298 "../src/editing_tools/CropTool.vala"
	_tmp5_ = self->priv->crop_tool_window;
#line 298 "../src/editing_tools/CropTool.vala"
	_tmp6_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp5_);
#line 298 "../src/editing_tools/CropTool.vala"
	_tmp7_ = _tmp6_;
#line 298 "../src/editing_tools/CropTool.vala"
	_tmp8_ = gtk_entry_get_text (_tmp7_);
#line 298 "../src/editing_tools/CropTool.vala"
	_tmp9_ = _tmp8_;
#line 298 "../src/editing_tools/CropTool.vala"
	height = atoi (_tmp9_);
#line 300 "../src/editing_tools/CropTool.vala"
	if (width < 1) {
#line 1798 "CropTool.c"
		EditingToolsCropToolCropToolWindow* _tmp10_;
		GtkEntry* _tmp11_;
		GtkEntry* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 301 "../src/editing_tools/CropTool.vala"
		width = 1;
#line 302 "../src/editing_tools/CropTool.vala"
		_tmp10_ = self->priv->crop_tool_window;
#line 302 "../src/editing_tools/CropTool.vala"
		_tmp11_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp10_);
#line 302 "../src/editing_tools/CropTool.vala"
		_tmp12_ = _tmp11_;
#line 302 "../src/editing_tools/CropTool.vala"
		_tmp13_ = g_strdup_printf ("%d", width);
#line 302 "../src/editing_tools/CropTool.vala"
		_tmp14_ = _tmp13_;
#line 302 "../src/editing_tools/CropTool.vala"
		gtk_entry_set_text (_tmp12_, _tmp14_);
#line 302 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp14_);
#line 1820 "CropTool.c"
	}
#line 305 "../src/editing_tools/CropTool.vala"
	if (height < 1) {
#line 1824 "CropTool.c"
		EditingToolsCropToolCropToolWindow* _tmp15_;
		GtkEntry* _tmp16_;
		GtkEntry* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 306 "../src/editing_tools/CropTool.vala"
		height = 1;
#line 307 "../src/editing_tools/CropTool.vala"
		_tmp15_ = self->priv->crop_tool_window;
#line 307 "../src/editing_tools/CropTool.vala"
		_tmp16_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp15_);
#line 307 "../src/editing_tools/CropTool.vala"
		_tmp17_ = _tmp16_;
#line 307 "../src/editing_tools/CropTool.vala"
		_tmp18_ = g_strdup_printf ("%d", height);
#line 307 "../src/editing_tools/CropTool.vala"
		_tmp19_ = _tmp18_;
#line 307 "../src/editing_tools/CropTool.vala"
		gtk_entry_set_text (_tmp17_, _tmp19_);
#line 307 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp19_);
#line 1846 "CropTool.c"
	}
#line 310 "../src/editing_tools/CropTool.vala"
	if (width == self->priv->custom_width) {
#line 310 "../src/editing_tools/CropTool.vala"
		_tmp20_ = height == self->priv->custom_height;
#line 1852 "CropTool.c"
	} else {
#line 310 "../src/editing_tools/CropTool.vala"
		_tmp20_ = FALSE;
#line 1856 "CropTool.c"
	}
#line 310 "../src/editing_tools/CropTool.vala"
	if (_tmp20_) {
#line 311 "../src/editing_tools/CropTool.vala"
		result = FALSE;
#line 311 "../src/editing_tools/CropTool.vala"
		return result;
#line 1864 "CropTool.c"
	}
#line 314 "../src/editing_tools/CropTool.vala"
	self->priv->custom_aspect_ratio = ((gfloat) width) / ((gfloat) height);
#line 316 "../src/editing_tools/CropTool.vala"
	if (self->priv->custom_aspect_ratio < EDITING_TOOLS_CROP_TOOL_MIN_ASPECT_RATIO) {
#line 1870 "CropTool.c"
		EditingToolsCropToolCropToolWindow* _tmp21_;
		GtkEntry* _tmp22_;
		GtkEntry* _tmp23_;
		EditingToolsCropToolCropToolWindow* _tmp24_;
		GtkEntry* _tmp25_;
		GtkEntry* _tmp26_;
#line 317 "../src/editing_tools/CropTool.vala"
		_tmp21_ = self->priv->crop_tool_window;
#line 317 "../src/editing_tools/CropTool.vala"
		_tmp22_ = editing_tools_crop_tool_crop_tool_window_get_most_recently_edited (_tmp21_);
#line 317 "../src/editing_tools/CropTool.vala"
		_tmp23_ = _tmp22_;
#line 317 "../src/editing_tools/CropTool.vala"
		_tmp24_ = self->priv->crop_tool_window;
#line 317 "../src/editing_tools/CropTool.vala"
		_tmp25_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp24_);
#line 317 "../src/editing_tools/CropTool.vala"
		_tmp26_ = _tmp25_;
#line 317 "../src/editing_tools/CropTool.vala"
		if (_tmp23_ == _tmp26_) {
#line 1891 "CropTool.c"
			EditingToolsCropToolCropToolWindow* _tmp27_;
			GtkEntry* _tmp28_;
			GtkEntry* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
#line 318 "../src/editing_tools/CropTool.vala"
			height = (gint) (width / EDITING_TOOLS_CROP_TOOL_MIN_ASPECT_RATIO);
#line 319 "../src/editing_tools/CropTool.vala"
			_tmp27_ = self->priv->crop_tool_window;
#line 319 "../src/editing_tools/CropTool.vala"
			_tmp28_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp27_);
#line 319 "../src/editing_tools/CropTool.vala"
			_tmp29_ = _tmp28_;
#line 319 "../src/editing_tools/CropTool.vala"
			_tmp30_ = g_strdup_printf ("%d", height);
#line 319 "../src/editing_tools/CropTool.vala"
			_tmp31_ = _tmp30_;
#line 319 "../src/editing_tools/CropTool.vala"
			gtk_entry_set_text (_tmp29_, _tmp31_);
#line 319 "../src/editing_tools/CropTool.vala"
			_g_free0 (_tmp31_);
#line 1913 "CropTool.c"
		} else {
			EditingToolsCropToolCropToolWindow* _tmp32_;
			GtkEntry* _tmp33_;
			GtkEntry* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
#line 321 "../src/editing_tools/CropTool.vala"
			width = (gint) (height * EDITING_TOOLS_CROP_TOOL_MIN_ASPECT_RATIO);
#line 322 "../src/editing_tools/CropTool.vala"
			_tmp32_ = self->priv->crop_tool_window;
#line 322 "../src/editing_tools/CropTool.vala"
			_tmp33_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp32_);
#line 322 "../src/editing_tools/CropTool.vala"
			_tmp34_ = _tmp33_;
#line 322 "../src/editing_tools/CropTool.vala"
			_tmp35_ = g_strdup_printf ("%d", width);
#line 322 "../src/editing_tools/CropTool.vala"
			_tmp36_ = _tmp35_;
#line 322 "../src/editing_tools/CropTool.vala"
			gtk_entry_set_text (_tmp34_, _tmp36_);
#line 322 "../src/editing_tools/CropTool.vala"
			_g_free0 (_tmp36_);
#line 1936 "CropTool.c"
		}
	} else {
#line 324 "../src/editing_tools/CropTool.vala"
		if (self->priv->custom_aspect_ratio > EDITING_TOOLS_CROP_TOOL_MAX_ASPECT_RATIO) {
#line 1941 "CropTool.c"
			EditingToolsCropToolCropToolWindow* _tmp37_;
			GtkEntry* _tmp38_;
			GtkEntry* _tmp39_;
			EditingToolsCropToolCropToolWindow* _tmp40_;
			GtkEntry* _tmp41_;
			GtkEntry* _tmp42_;
#line 325 "../src/editing_tools/CropTool.vala"
			_tmp37_ = self->priv->crop_tool_window;
#line 325 "../src/editing_tools/CropTool.vala"
			_tmp38_ = editing_tools_crop_tool_crop_tool_window_get_most_recently_edited (_tmp37_);
#line 325 "../src/editing_tools/CropTool.vala"
			_tmp39_ = _tmp38_;
#line 325 "../src/editing_tools/CropTool.vala"
			_tmp40_ = self->priv->crop_tool_window;
#line 325 "../src/editing_tools/CropTool.vala"
			_tmp41_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp40_);
#line 325 "../src/editing_tools/CropTool.vala"
			_tmp42_ = _tmp41_;
#line 325 "../src/editing_tools/CropTool.vala"
			if (_tmp39_ == _tmp42_) {
#line 1962 "CropTool.c"
				EditingToolsCropToolCropToolWindow* _tmp43_;
				GtkEntry* _tmp44_;
				GtkEntry* _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
#line 326 "../src/editing_tools/CropTool.vala"
				height = (gint) (width / EDITING_TOOLS_CROP_TOOL_MAX_ASPECT_RATIO);
#line 327 "../src/editing_tools/CropTool.vala"
				_tmp43_ = self->priv->crop_tool_window;
#line 327 "../src/editing_tools/CropTool.vala"
				_tmp44_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp43_);
#line 327 "../src/editing_tools/CropTool.vala"
				_tmp45_ = _tmp44_;
#line 327 "../src/editing_tools/CropTool.vala"
				_tmp46_ = g_strdup_printf ("%d", height);
#line 327 "../src/editing_tools/CropTool.vala"
				_tmp47_ = _tmp46_;
#line 327 "../src/editing_tools/CropTool.vala"
				gtk_entry_set_text (_tmp45_, _tmp47_);
#line 327 "../src/editing_tools/CropTool.vala"
				_g_free0 (_tmp47_);
#line 1984 "CropTool.c"
			} else {
				EditingToolsCropToolCropToolWindow* _tmp48_;
				GtkEntry* _tmp49_;
				GtkEntry* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
#line 329 "../src/editing_tools/CropTool.vala"
				width = (gint) (height * EDITING_TOOLS_CROP_TOOL_MAX_ASPECT_RATIO);
#line 330 "../src/editing_tools/CropTool.vala"
				_tmp48_ = self->priv->crop_tool_window;
#line 330 "../src/editing_tools/CropTool.vala"
				_tmp49_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp48_);
#line 330 "../src/editing_tools/CropTool.vala"
				_tmp50_ = _tmp49_;
#line 330 "../src/editing_tools/CropTool.vala"
				_tmp51_ = g_strdup_printf ("%d", width);
#line 330 "../src/editing_tools/CropTool.vala"
				_tmp52_ = _tmp51_;
#line 330 "../src/editing_tools/CropTool.vala"
				gtk_entry_set_text (_tmp50_, _tmp52_);
#line 330 "../src/editing_tools/CropTool.vala"
				_g_free0 (_tmp52_);
#line 2007 "CropTool.c"
			}
		}
	}
#line 334 "../src/editing_tools/CropTool.vala"
	self->priv->custom_aspect_ratio = ((gfloat) width) / ((gfloat) height);
#line 336 "../src/editing_tools/CropTool.vala"
	_tmp53_ = self->priv->scaled_crop;
#line 336 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_constrain_crop (self, &_tmp53_, &_tmp54_);
#line 336 "../src/editing_tools/CropTool.vala"
	new_crop = _tmp54_;
#line 338 "../src/editing_tools/CropTool.vala"
	_tmp55_ = new_crop;
#line 338 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_resized (self, &_tmp55_);
#line 339 "../src/editing_tools/CropTool.vala"
	_tmp56_ = new_crop;
#line 339 "../src/editing_tools/CropTool.vala"
	self->priv->scaled_crop = _tmp56_;
#line 340 "../src/editing_tools/CropTool.vala"
	_tmp57_ = ((EditingToolsEditingTool*) self)->canvas;
#line 340 "../src/editing_tools/CropTool.vala"
	_tmp58_ = new_crop;
#line 340 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp57_, &_tmp58_);
#line 341 "../src/editing_tools/CropTool.vala"
	_tmp59_ = ((EditingToolsEditingTool*) self)->canvas;
#line 341 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_repaint (_tmp59_);
#line 343 "../src/editing_tools/CropTool.vala"
	self->priv->custom_width = width;
#line 344 "../src/editing_tools/CropTool.vala"
	self->priv->custom_height = height;
#line 346 "../src/editing_tools/CropTool.vala"
	result = FALSE;
#line 346 "../src/editing_tools/CropTool.vala"
	return result;
#line 2045 "CropTool.c"
}

static void
editing_tools_crop_tool_on_width_insert_text (EditingToolsCropTool* self,
                                              const gchar* text,
                                              gint length,
                                              gint* position)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
#line 349 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 349 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (text != NULL);
#line 350 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 350 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp0_);
#line 350 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 350 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_on_entry_insert_text (self, _tmp2_, text, length, position);
#line 2069 "CropTool.c"
}

static void
editing_tools_crop_tool_on_height_insert_text (EditingToolsCropTool* self,
                                               const gchar* text,
                                               gint length,
                                               gint* position)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
#line 353 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (text != NULL);
#line 354 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 354 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp0_);
#line 354 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 354 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_on_entry_insert_text (self, _tmp2_, text, length, position);
#line 2093 "CropTool.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 2110 "CropTool.c"
}

static void
editing_tools_crop_tool_on_entry_insert_text (EditingToolsCropTool* self,
                                              GtkEntry* sender,
                                              const gchar* text,
                                              gint length,
                                              gint* position)
{
	gchar* new_text = NULL;
	gchar* _tmp2_;
	const gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 357 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (sender != NULL);
#line 357 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (text != NULL);
#line 358 "../src/editing_tools/CropTool.vala"
	if (self->priv->entry_insert_in_progress) {
#line 359 "../src/editing_tools/CropTool.vala"
		return;
#line 2135 "CropTool.c"
	}
#line 362 "../src/editing_tools/CropTool.vala"
	self->priv->entry_insert_in_progress = TRUE;
#line 364 "../src/editing_tools/CropTool.vala"
	if (length == -1) {
#line 2141 "CropTool.c"
		gint _tmp0_;
		gint _tmp1_;
#line 365 "../src/editing_tools/CropTool.vala"
		_tmp0_ = strlen (text);
#line 365 "../src/editing_tools/CropTool.vala"
		_tmp1_ = _tmp0_;
#line 365 "../src/editing_tools/CropTool.vala"
		length = (gint) _tmp1_;
#line 2150 "CropTool.c"
	}
#line 369 "../src/editing_tools/CropTool.vala"
	_tmp2_ = g_strdup ("");
#line 369 "../src/editing_tools/CropTool.vala"
	new_text = _tmp2_;
#line 2156 "CropTool.c"
	{
		gint ctr = 0;
#line 370 "../src/editing_tools/CropTool.vala"
		ctr = 0;
#line 2161 "CropTool.c"
		{
			gboolean _tmp3_ = FALSE;
#line 370 "../src/editing_tools/CropTool.vala"
			_tmp3_ = TRUE;
#line 370 "../src/editing_tools/CropTool.vala"
			while (TRUE) {
#line 370 "../src/editing_tools/CropTool.vala"
				if (!_tmp3_) {
#line 2170 "CropTool.c"
					gint _tmp4_;
#line 370 "../src/editing_tools/CropTool.vala"
					_tmp4_ = ctr;
#line 370 "../src/editing_tools/CropTool.vala"
					ctr = _tmp4_ + 1;
#line 2176 "CropTool.c"
				}
#line 370 "../src/editing_tools/CropTool.vala"
				_tmp3_ = FALSE;
#line 370 "../src/editing_tools/CropTool.vala"
				if (!(ctr < length)) {
#line 370 "../src/editing_tools/CropTool.vala"
					break;
#line 2184 "CropTool.c"
				}
#line 371 "../src/editing_tools/CropTool.vala"
				if (g_ascii_isdigit (string_get (text, (glong) ctr))) {
#line 2188 "CropTool.c"
					const gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
#line 372 "../src/editing_tools/CropTool.vala"
					_tmp5_ = new_text;
#line 372 "../src/editing_tools/CropTool.vala"
					_tmp6_ = g_strdup_printf ("%c", (gchar) string_get (text, (glong) ctr));
#line 372 "../src/editing_tools/CropTool.vala"
					_tmp7_ = _tmp6_;
#line 372 "../src/editing_tools/CropTool.vala"
					_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 372 "../src/editing_tools/CropTool.vala"
					_g_free0 (new_text);
#line 372 "../src/editing_tools/CropTool.vala"
					new_text = _tmp8_;
#line 372 "../src/editing_tools/CropTool.vala"
					_g_free0 (_tmp7_);
#line 2207 "CropTool.c"
				}
			}
		}
	}
#line 376 "../src/editing_tools/CropTool.vala"
	_tmp9_ = new_text;
#line 376 "../src/editing_tools/CropTool.vala"
	_tmp10_ = strlen (_tmp9_);
#line 376 "../src/editing_tools/CropTool.vala"
	_tmp11_ = _tmp10_;
#line 376 "../src/editing_tools/CropTool.vala"
	if (_tmp11_ > 0) {
#line 2220 "CropTool.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 377 "../src/editing_tools/CropTool.vala"
		_tmp12_ = new_text;
#line 377 "../src/editing_tools/CropTool.vala"
		_tmp13_ = new_text;
#line 377 "../src/editing_tools/CropTool.vala"
		_tmp14_ = strlen (_tmp13_);
#line 377 "../src/editing_tools/CropTool.vala"
		_tmp15_ = _tmp14_;
#line 377 "../src/editing_tools/CropTool.vala"
		g_signal_emit_by_name ((GtkEditable*) sender, "insert-text", _tmp12_, (gint) _tmp15_, position);
#line 2235 "CropTool.c"
	}
#line 380 "../src/editing_tools/CropTool.vala"
	g_signal_stop_emission_by_name (sender, "insert-text");
#line 382 "../src/editing_tools/CropTool.vala"
	self->priv->entry_insert_in_progress = FALSE;
#line 357 "../src/editing_tools/CropTool.vala"
	_g_free0 (new_text);
#line 2243 "CropTool.c"
}

static gfloat
editing_tools_crop_tool_get_constraint_aspect_ratio (EditingToolsCropTool* self)
{
	gfloat _result_ = 0.0F;
	EditingToolsCropToolConstraintDescription* _tmp0_;
	EditingToolsCropToolConstraintDescription* _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat result;
#line 385 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 386 "../src/editing_tools/CropTool.vala"
	_tmp0_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 386 "../src/editing_tools/CropTool.vala"
	_tmp1_ = _tmp0_;
#line 386 "../src/editing_tools/CropTool.vala"
	_tmp2_ = editing_tools_crop_tool_constraint_description_get_aspect_ratio (_tmp1_);
#line 386 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 386 "../src/editing_tools/CropTool.vala"
	_tmp4_ = _tmp3_;
#line 386 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp1_);
#line 386 "../src/editing_tools/CropTool.vala"
	_result_ = _tmp4_;
#line 388 "../src/editing_tools/CropTool.vala"
	if (_result_ == EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO) {
#line 2274 "CropTool.c"
		EditingToolsPhotoCanvas* _tmp5_;
		GdkRectangle _tmp6_ = {0};
		GdkRectangle _tmp7_;
		EditingToolsPhotoCanvas* _tmp8_;
		GdkRectangle _tmp9_ = {0};
		GdkRectangle _tmp10_;
#line 389 "../src/editing_tools/CropTool.vala"
		_tmp5_ = ((EditingToolsEditingTool*) self)->canvas;
#line 389 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_get_scaled_position (_tmp5_, &_tmp6_);
#line 389 "../src/editing_tools/CropTool.vala"
		_tmp7_ = _tmp6_;
#line 389 "../src/editing_tools/CropTool.vala"
		_tmp8_ = ((EditingToolsEditingTool*) self)->canvas;
#line 389 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_get_scaled_position (_tmp8_, &_tmp9_);
#line 389 "../src/editing_tools/CropTool.vala"
		_tmp10_ = _tmp9_;
#line 389 "../src/editing_tools/CropTool.vala"
		_result_ = ((gfloat) _tmp7_.width) / ((gfloat) _tmp10_.height);
#line 2295 "CropTool.c"
	} else {
#line 391 "../src/editing_tools/CropTool.vala"
		if (_result_ == EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO) {
#line 2299 "CropTool.c"
			Dimensions dimensions = {0};
			AppWindow* _tmp11_;
			AppWindow* _tmp12_;
			Dimensions _tmp13_ = {0};
			Dimensions _tmp14_;
			Dimensions _tmp15_;
			Dimensions _tmp16_;
#line 392 "../src/editing_tools/CropTool.vala"
			_tmp11_ = app_window_get_instance ();
#line 392 "../src/editing_tools/CropTool.vala"
			_tmp12_ = _tmp11_;
#line 392 "../src/editing_tools/CropTool.vala"
			scaling_get_screen_dimensions ((GtkWindow*) _tmp12_, &_tmp13_);
#line 392 "../src/editing_tools/CropTool.vala"
			_tmp14_ = _tmp13_;
#line 392 "../src/editing_tools/CropTool.vala"
			_g_object_unref0 (_tmp12_);
#line 392 "../src/editing_tools/CropTool.vala"
			dimensions = _tmp14_;
#line 393 "../src/editing_tools/CropTool.vala"
			_tmp15_ = dimensions;
#line 393 "../src/editing_tools/CropTool.vala"
			_tmp16_ = dimensions;
#line 393 "../src/editing_tools/CropTool.vala"
			_result_ = ((gfloat) _tmp15_.width) / ((gfloat) _tmp16_.height);
#line 2325 "CropTool.c"
		} else {
#line 394 "../src/editing_tools/CropTool.vala"
			if (_result_ == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO) {
#line 395 "../src/editing_tools/CropTool.vala"
				_result_ = self->priv->custom_aspect_ratio;
#line 2331 "CropTool.c"
			}
		}
	}
#line 398 "../src/editing_tools/CropTool.vala"
	if (self->priv->reticle_orientation == EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT) {
#line 399 "../src/editing_tools/CropTool.vala"
		_result_ = 1.0f / _result_;
#line 2339 "CropTool.c"
	}
#line 402 "../src/editing_tools/CropTool.vala"
	result = _result_;
#line 402 "../src/editing_tools/CropTool.vala"
	return result;
#line 2345 "CropTool.c"
}

static void
editing_tools_crop_tool_constraint_changed (EditingToolsCropTool* self)
{
	EditingToolsCropToolConstraintDescription* selected_constraint = NULL;
	EditingToolsCropToolConstraintDescription* _tmp0_;
	EditingToolsCropToolConstraintDescription* _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	EditingToolsCropToolConstraintDescription* _tmp12_;
	EditingToolsCropToolConstraintDescription* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
#line 405 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/editing_tools/CropTool.vala"
	_tmp0_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 406 "../src/editing_tools/CropTool.vala"
	selected_constraint = _tmp0_;
#line 407 "../src/editing_tools/CropTool.vala"
	_tmp1_ = selected_constraint;
#line 407 "../src/editing_tools/CropTool.vala"
	_tmp2_ = editing_tools_crop_tool_constraint_description_get_aspect_ratio (_tmp1_);
#line 407 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 407 "../src/editing_tools/CropTool.vala"
	if (_tmp3_ == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO) {
#line 408 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_set_custom_constraint_mode (self);
#line 2377 "CropTool.c"
	} else {
		EditingToolsCropToolConstraintDescription* _tmp7_;
		gfloat _tmp8_;
		gfloat _tmp9_;
#line 410 "../src/editing_tools/CropTool.vala"
		if (self->priv->constraint_mode != EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL) {
#line 2384 "CropTool.c"
			EditingToolsCropToolCropToolWindow* _tmp4_;
			GtkRevealer* _tmp5_;
			GtkRevealer* _tmp6_;
#line 411 "../src/editing_tools/CropTool.vala"
			_tmp4_ = self->priv->crop_tool_window;
#line 411 "../src/editing_tools/CropTool.vala"
			_tmp5_ = editing_tools_crop_tool_crop_tool_window_get_custom_aspect_revealer (_tmp4_);
#line 411 "../src/editing_tools/CropTool.vala"
			_tmp6_ = _tmp5_;
#line 411 "../src/editing_tools/CropTool.vala"
			gtk_revealer_set_reveal_child (_tmp6_, FALSE);
#line 412 "../src/editing_tools/CropTool.vala"
			self->priv->constraint_mode = EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL;
#line 2398 "CropTool.c"
		}
#line 415 "../src/editing_tools/CropTool.vala"
		_tmp7_ = selected_constraint;
#line 415 "../src/editing_tools/CropTool.vala"
		_tmp8_ = editing_tools_crop_tool_constraint_description_get_aspect_ratio (_tmp7_);
#line 415 "../src/editing_tools/CropTool.vala"
		_tmp9_ = _tmp8_;
#line 415 "../src/editing_tools/CropTool.vala"
		if (_tmp9_ != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 2408 "CropTool.c"
			GSettings* _tmp10_;
			GSettings* _tmp11_;
#line 419 "../src/editing_tools/CropTool.vala"
			_tmp10_ = self->priv->crop_settings;
#line 419 "../src/editing_tools/CropTool.vala"
			self->priv->custom_init_width = g_settings_get_int (_tmp10_, "last-crop-width");
#line 420 "../src/editing_tools/CropTool.vala"
			_tmp11_ = self->priv->crop_settings;
#line 420 "../src/editing_tools/CropTool.vala"
			self->priv->custom_init_height = g_settings_get_int (_tmp11_, "last-crop-height");
#line 421 "../src/editing_tools/CropTool.vala"
			self->priv->custom_aspect_ratio = ((gfloat) self->priv->custom_init_width) / ((gfloat) self->priv->custom_init_height);
#line 2421 "CropTool.c"
		}
	}
#line 425 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_update_pivot_button_state (self);
#line 427 "../src/editing_tools/CropTool.vala"
	_tmp12_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 427 "../src/editing_tools/CropTool.vala"
	_tmp13_ = _tmp12_;
#line 427 "../src/editing_tools/CropTool.vala"
	_tmp14_ = editing_tools_crop_tool_constraint_description_get_is_pivotable (_tmp13_);
#line 427 "../src/editing_tools/CropTool.vala"
	_tmp15_ = _tmp14_;
#line 427 "../src/editing_tools/CropTool.vala"
	_tmp16_ = !_tmp15_;
#line 427 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp13_);
#line 427 "../src/editing_tools/CropTool.vala"
	if (_tmp16_) {
#line 428 "../src/editing_tools/CropTool.vala"
		self->priv->reticle_orientation = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE;
#line 2442 "CropTool.c"
	}
#line 431 "../src/editing_tools/CropTool.vala"
	if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != self->priv->pre_aspect_ratio) {
#line 2446 "CropTool.c"
		Box new_crop = {0};
		Box _tmp17_;
		Box _tmp18_ = {0};
		Box _tmp19_;
		Box _tmp20_;
		EditingToolsPhotoCanvas* _tmp21_;
		Box _tmp22_;
		EditingToolsPhotoCanvas* _tmp23_;
#line 432 "../src/editing_tools/CropTool.vala"
		_tmp17_ = self->priv->scaled_crop;
#line 432 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constrain_crop (self, &_tmp17_, &_tmp18_);
#line 432 "../src/editing_tools/CropTool.vala"
		new_crop = _tmp18_;
#line 434 "../src/editing_tools/CropTool.vala"
		_tmp19_ = new_crop;
#line 434 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_resized (self, &_tmp19_);
#line 435 "../src/editing_tools/CropTool.vala"
		_tmp20_ = new_crop;
#line 435 "../src/editing_tools/CropTool.vala"
		self->priv->scaled_crop = _tmp20_;
#line 436 "../src/editing_tools/CropTool.vala"
		_tmp21_ = ((EditingToolsEditingTool*) self)->canvas;
#line 436 "../src/editing_tools/CropTool.vala"
		_tmp22_ = new_crop;
#line 436 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_invalidate_area (_tmp21_, &_tmp22_);
#line 437 "../src/editing_tools/CropTool.vala"
		_tmp23_ = ((EditingToolsEditingTool*) self)->canvas;
#line 437 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_repaint (_tmp23_);
#line 439 "../src/editing_tools/CropTool.vala"
		self->priv->pre_aspect_ratio = editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 2481 "CropTool.c"
	}
#line 405 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (selected_constraint);
#line 2485 "CropTool.c"
}

static void
editing_tools_crop_tool_set_custom_constraint_mode (EditingToolsCropTool* self)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkRevealer* _tmp2_;
#line 443 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 444 "../src/editing_tools/CropTool.vala"
	if (self->priv->constraint_mode == EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM) {
#line 445 "../src/editing_tools/CropTool.vala"
		return;
#line 2500 "CropTool.c"
	}
#line 448 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 448 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_crop_tool_window_get_custom_aspect_revealer (_tmp0_);
#line 448 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 448 "../src/editing_tools/CropTool.vala"
	gtk_revealer_set_reveal_child (_tmp2_, TRUE);
#line 450 "../src/editing_tools/CropTool.vala"
	if (self->priv->reticle_orientation == EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE) {
#line 2512 "CropTool.c"
		EditingToolsCropToolCropToolWindow* _tmp3_;
		GtkEntry* _tmp4_;
		GtkEntry* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		EditingToolsCropToolCropToolWindow* _tmp8_;
		GtkEntry* _tmp9_;
		GtkEntry* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 451 "../src/editing_tools/CropTool.vala"
		_tmp3_ = self->priv->crop_tool_window;
#line 451 "../src/editing_tools/CropTool.vala"
		_tmp4_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp3_);
#line 451 "../src/editing_tools/CropTool.vala"
		_tmp5_ = _tmp4_;
#line 451 "../src/editing_tools/CropTool.vala"
		_tmp6_ = g_strdup_printf ("%d", self->priv->custom_init_width);
#line 451 "../src/editing_tools/CropTool.vala"
		_tmp7_ = _tmp6_;
#line 451 "../src/editing_tools/CropTool.vala"
		gtk_entry_set_text (_tmp5_, _tmp7_);
#line 451 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp7_);
#line 452 "../src/editing_tools/CropTool.vala"
		_tmp8_ = self->priv->crop_tool_window;
#line 452 "../src/editing_tools/CropTool.vala"
		_tmp9_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp8_);
#line 452 "../src/editing_tools/CropTool.vala"
		_tmp10_ = _tmp9_;
#line 452 "../src/editing_tools/CropTool.vala"
		_tmp11_ = g_strdup_printf ("%d", self->priv->custom_init_height);
#line 452 "../src/editing_tools/CropTool.vala"
		_tmp12_ = _tmp11_;
#line 452 "../src/editing_tools/CropTool.vala"
		gtk_entry_set_text (_tmp10_, _tmp12_);
#line 452 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp12_);
#line 2551 "CropTool.c"
	} else {
		EditingToolsCropToolCropToolWindow* _tmp13_;
		GtkEntry* _tmp14_;
		GtkEntry* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		EditingToolsCropToolCropToolWindow* _tmp18_;
		GtkEntry* _tmp19_;
		GtkEntry* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 454 "../src/editing_tools/CropTool.vala"
		_tmp13_ = self->priv->crop_tool_window;
#line 454 "../src/editing_tools/CropTool.vala"
		_tmp14_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp13_);
#line 454 "../src/editing_tools/CropTool.vala"
		_tmp15_ = _tmp14_;
#line 454 "../src/editing_tools/CropTool.vala"
		_tmp16_ = g_strdup_printf ("%d", self->priv->custom_init_height);
#line 454 "../src/editing_tools/CropTool.vala"
		_tmp17_ = _tmp16_;
#line 454 "../src/editing_tools/CropTool.vala"
		gtk_entry_set_text (_tmp15_, _tmp17_);
#line 454 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp17_);
#line 455 "../src/editing_tools/CropTool.vala"
		_tmp18_ = self->priv->crop_tool_window;
#line 455 "../src/editing_tools/CropTool.vala"
		_tmp19_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp18_);
#line 455 "../src/editing_tools/CropTool.vala"
		_tmp20_ = _tmp19_;
#line 455 "../src/editing_tools/CropTool.vala"
		_tmp21_ = g_strdup_printf ("%d", self->priv->custom_init_width);
#line 455 "../src/editing_tools/CropTool.vala"
		_tmp22_ = _tmp21_;
#line 455 "../src/editing_tools/CropTool.vala"
		gtk_entry_set_text (_tmp20_, _tmp22_);
#line 455 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp22_);
#line 2591 "CropTool.c"
	}
#line 458 "../src/editing_tools/CropTool.vala"
	self->priv->custom_aspect_ratio = ((gfloat) self->priv->custom_init_width) / ((gfloat) self->priv->custom_init_height);
#line 460 "../src/editing_tools/CropTool.vala"
	self->priv->constraint_mode = EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM;
#line 2597 "CropTool.c"
}

static void
editing_tools_crop_tool_constrain_crop (EditingToolsCropTool* self,
                                        Box* crop,
                                        Box* result)
{
	gfloat user_aspect_ratio = 0.0F;
	gfloat old_area = 0.0F;
	Dimensions image_size = {0};
	Dimensions _tmp1_ = {0};
	gdouble angle = 0.0;
	EditingToolsPhotoCanvas* _tmp2_;
	Photo* _tmp3_;
	Photo* _tmp4_;
	gdouble _tmp5_ = 0.0;
	Box _tmp6_;
	Dimensions _tmp7_;
	Dimensions _tmp8_;
	Box _tmp9_ = {0};
	Box _tmp10_;
#line 463 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 463 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (crop != NULL);
#line 464 "../src/editing_tools/CropTool.vala"
	user_aspect_ratio = editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 465 "../src/editing_tools/CropTool.vala"
	if (user_aspect_ratio == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 2627 "CropTool.c"
		Box _tmp0_;
#line 466 "../src/editing_tools/CropTool.vala"
		_tmp0_ = *crop;
#line 466 "../src/editing_tools/CropTool.vala"
		*result = _tmp0_;
#line 466 "../src/editing_tools/CropTool.vala"
		return;
#line 2635 "CropTool.c"
	}
#line 470 "../src/editing_tools/CropTool.vala"
	old_area = (gfloat) (box_get_width (crop) * box_get_height (crop));
#line 471 "../src/editing_tools/CropTool.vala"
	box_adjust_height (crop, (gint) sqrt ((gdouble) (old_area / user_aspect_ratio)));
#line 472 "../src/editing_tools/CropTool.vala"
	box_adjust_width (crop, (gint) sqrt ((gdouble) (old_area * user_aspect_ratio)));
#line 475 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_get_photo_dimensions (self, &_tmp1_);
#line 475 "../src/editing_tools/CropTool.vala"
	image_size = _tmp1_;
#line 477 "../src/editing_tools/CropTool.vala"
	_tmp2_ = ((EditingToolsEditingTool*) self)->canvas;
#line 477 "../src/editing_tools/CropTool.vala"
	_tmp3_ = editing_tools_photo_canvas_get_photo (_tmp2_);
#line 477 "../src/editing_tools/CropTool.vala"
	_tmp4_ = _tmp3_;
#line 477 "../src/editing_tools/CropTool.vala"
	photo_get_straighten (_tmp4_, &_tmp5_);
#line 477 "../src/editing_tools/CropTool.vala"
	angle = _tmp5_;
#line 478 "../src/editing_tools/CropTool.vala"
	_tmp6_ = *crop;
#line 478 "../src/editing_tools/CropTool.vala"
	_tmp7_ = image_size;
#line 478 "../src/editing_tools/CropTool.vala"
	_tmp8_ = image_size;
#line 478 "../src/editing_tools/CropTool.vala"
	clamp_inside_rotated_image (&_tmp6_, _tmp7_.width, _tmp8_.height, angle, FALSE, &_tmp9_);
#line 478 "../src/editing_tools/CropTool.vala"
	*crop = _tmp9_;
#line 481 "../src/editing_tools/CropTool.vala"
	if (((gfloat) box_get_width (crop)) >= (box_get_height (crop) * user_aspect_ratio)) {
#line 482 "../src/editing_tools/CropTool.vala"
		box_adjust_width (crop, (gint) (box_get_height (crop) * user_aspect_ratio));
#line 2671 "CropTool.c"
	} else {
#line 484 "../src/editing_tools/CropTool.vala"
		box_adjust_height (crop, (gint) (box_get_width (crop) / user_aspect_ratio));
#line 2675 "CropTool.c"
	}
#line 487 "../src/editing_tools/CropTool.vala"
	_tmp10_ = *crop;
#line 487 "../src/editing_tools/CropTool.vala"
	*result = _tmp10_;
#line 487 "../src/editing_tools/CropTool.vala"
	return;
#line 2683 "CropTool.c"
}

static EditingToolsCropToolConstraintDescription*
editing_tools_crop_tool_get_last_constraint (EditingToolsCropTool* self,
                                             gint* index)
{
	gint _vala_index = 0;
	GSettings* _tmp0_;
	EditingToolsCropToolConstraintDescription* _tmp1_ = NULL;
	EditingToolsCropToolConstraintDescription** _tmp2_;
	gint _tmp2__length1;
	EditingToolsCropToolConstraintDescription* _tmp5_;
	EditingToolsCropToolConstraintDescription* result;
#line 490 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 491 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_settings;
#line 491 "../src/editing_tools/CropTool.vala"
	_vala_index = g_settings_get_int (_tmp0_, "last-crop-menu-choice");
#line 493 "../src/editing_tools/CropTool.vala"
	_tmp2_ = self->priv->constraints;
#line 493 "../src/editing_tools/CropTool.vala"
	_tmp2__length1 = self->priv->constraints_length1;
#line 493 "../src/editing_tools/CropTool.vala"
	if (_vala_index < _tmp2__length1) {
#line 2709 "CropTool.c"
		EditingToolsCropToolConstraintDescription** _tmp3_;
		gint _tmp3__length1;
		EditingToolsCropToolConstraintDescription* _tmp4_;
#line 493 "../src/editing_tools/CropTool.vala"
		_tmp3_ = self->priv->constraints;
#line 493 "../src/editing_tools/CropTool.vala"
		_tmp3__length1 = self->priv->constraints_length1;
#line 493 "../src/editing_tools/CropTool.vala"
		_tmp4_ = _tmp3_[_vala_index];
#line 493 "../src/editing_tools/CropTool.vala"
		_tmp1_ = _tmp4_;
#line 2721 "CropTool.c"
	} else {
#line 493 "../src/editing_tools/CropTool.vala"
		_tmp1_ = NULL;
#line 2725 "CropTool.c"
	}
#line 493 "../src/editing_tools/CropTool.vala"
	_tmp5_ = _g_object_ref0 (_tmp1_);
#line 493 "../src/editing_tools/CropTool.vala"
	result = _tmp5_;
#line 493 "../src/editing_tools/CropTool.vala"
	if (index) {
#line 493 "../src/editing_tools/CropTool.vala"
		*index = _vala_index;
#line 2735 "CropTool.c"
	}
#line 493 "../src/editing_tools/CropTool.vala"
	return result;
#line 2739 "CropTool.c"
}

static void
editing_tools_crop_tool_real_activate (EditingToolsEditingTool* base,
                                       EditingToolsPhotoCanvas* canvas)
{
	EditingToolsCropTool * self;
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_;
	cairo_surface_t* _tmp8_;
	GdkRectangle _tmp9_ = {0};
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_ = {0};
	GdkRectangle _tmp12_;
	cairo_surface_t* _tmp13_;
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp14_;
	cairo_t* _tmp15_;
	cairo_t* _tmp16_;
	cairo_t* _tmp17_;
	GtkWindow* _tmp18_;
	GtkWindow* _tmp19_;
	EditingToolsCropToolCropToolWindow* _tmp20_;
	EditingToolsCropToolCropToolWindow* _tmp21_;
	GtkComboBox* _tmp22_;
	GtkComboBox* _tmp23_;
	GtkListStore* _tmp24_;
	Photo* _tmp25_;
	Photo* _tmp26_;
	Dimensions uncropped_dim = {0};
	Photo* _tmp35_;
	Photo* _tmp36_;
	Dimensions _tmp37_ = {0};
	Box crop = {0};
	Photo* _tmp38_;
	Photo* _tmp39_;
	Box _tmp40_ = {0};
	gboolean _tmp41_;
	Dimensions _tmp46_;
	GdkRectangle _tmp47_ = {0};
	GdkRectangle _tmp48_;
	Dimensions _tmp49_ = {0};
	Box _tmp50_ = {0};
	GSettings* _tmp51_;
	GSettings* _tmp52_;
	EditingToolsCropToolCropToolWindow* _tmp53_;
	EditingToolsCropToolCropToolWindow* _tmp54_;
	Photo* _tmp55_;
	Photo* _tmp56_;
	Box new_crop = {0};
	Box _tmp65_;
	Box _tmp66_ = {0};
	Box _tmp67_;
	Box _tmp68_;
	Box _tmp69_;
#line 496 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) base;
#line 496 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (canvas != NULL);
#line 497 "../src/editing_tools/CropTool.vala"
	_tmp0_ = editing_tools_photo_canvas_get_container (canvas);
#line 497 "../src/editing_tools/CropTool.vala"
	_tmp1_ = _tmp0_;
#line 497 "../src/editing_tools/CropTool.vala"
	_tmp2_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp1_);
#line 497 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 497 "../src/editing_tools/CropTool.vala"
	self->priv->scale_factor = _tmp3_;
#line 498 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_bind_canvas_handlers (self, canvas);
#line 500 "../src/editing_tools/CropTool.vala"
	_tmp4_ = editing_tools_photo_canvas_get_default_ctx (canvas);
#line 500 "../src/editing_tools/CropTool.vala"
	_tmp5_ = _tmp4_;
#line 500 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_surface_dim (canvas, &_tmp6_);
#line 500 "../src/editing_tools/CropTool.vala"
	_tmp7_ = _tmp6_;
#line 500 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_prepare_ctx (self, _tmp5_, &_tmp7_);
#line 502 "../src/editing_tools/CropTool.vala"
	_tmp8_ = self->priv->crop_surface;
#line 502 "../src/editing_tools/CropTool.vala"
	if (_tmp8_ != NULL) {
#line 503 "../src/editing_tools/CropTool.vala"
		_cairo_surface_destroy0 (self->priv->crop_surface);
#line 503 "../src/editing_tools/CropTool.vala"
		self->priv->crop_surface = NULL;
#line 2835 "CropTool.c"
	}
#line 506 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_scaled_position (canvas, &_tmp9_);
#line 506 "../src/editing_tools/CropTool.vala"
	_tmp10_ = _tmp9_;
#line 506 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_scaled_position (canvas, &_tmp11_);
#line 506 "../src/editing_tools/CropTool.vala"
	_tmp12_ = _tmp11_;
#line 506 "../src/editing_tools/CropTool.vala"
	_tmp13_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp10_.width, _tmp12_.height);
#line 506 "../src/editing_tools/CropTool.vala"
	_cairo_surface_destroy0 (self->priv->crop_surface);
#line 506 "../src/editing_tools/CropTool.vala"
	self->priv->crop_surface = _tmp13_;
#line 510 "../src/editing_tools/CropTool.vala"
	_tmp14_ = self->priv->crop_surface;
#line 510 "../src/editing_tools/CropTool.vala"
	_tmp15_ = cairo_create (_tmp14_);
#line 510 "../src/editing_tools/CropTool.vala"
	ctx = _tmp15_;
#line 511 "../src/editing_tools/CropTool.vala"
	_tmp16_ = ctx;
#line 511 "../src/editing_tools/CropTool.vala"
	cairo_set_source_rgba (_tmp16_, 0.0, 0.0, 0.0, 1.0);
#line 512 "../src/editing_tools/CropTool.vala"
	_tmp17_ = ctx;
#line 512 "../src/editing_tools/CropTool.vala"
	cairo_paint (_tmp17_);
#line 515 "../src/editing_tools/CropTool.vala"
	_tmp18_ = editing_tools_photo_canvas_get_container (canvas);
#line 515 "../src/editing_tools/CropTool.vala"
	_tmp19_ = _tmp18_;
#line 515 "../src/editing_tools/CropTool.vala"
	_tmp20_ = editing_tools_crop_tool_crop_tool_window_new (_tmp19_);
#line 515 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp20_);
#line 515 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->crop_tool_window);
#line 515 "../src/editing_tools/CropTool.vala"
	self->priv->crop_tool_window = _tmp20_;
#line 518 "../src/editing_tools/CropTool.vala"
	_tmp21_ = self->priv->crop_tool_window;
#line 518 "../src/editing_tools/CropTool.vala"
	_tmp22_ = editing_tools_crop_tool_crop_tool_window_get_constraint_combo (_tmp21_);
#line 518 "../src/editing_tools/CropTool.vala"
	_tmp23_ = _tmp22_;
#line 518 "../src/editing_tools/CropTool.vala"
	_tmp24_ = self->priv->constraint_list;
#line 518 "../src/editing_tools/CropTool.vala"
	gtk_combo_box_set_model (_tmp23_, (GtkTreeModel*) _tmp24_);
#line 519 "../src/editing_tools/CropTool.vala"
	_tmp25_ = editing_tools_photo_canvas_get_photo (canvas);
#line 519 "../src/editing_tools/CropTool.vala"
	_tmp26_ = _tmp25_;
#line 519 "../src/editing_tools/CropTool.vala"
	if (!photo_has_crop (_tmp26_)) {
#line 2893 "CropTool.c"
		gint index = 0;
		EditingToolsCropToolConstraintDescription* desc = NULL;
		gint _tmp27_ = 0;
		EditingToolsCropToolConstraintDescription* _tmp28_;
		gboolean _tmp29_ = FALSE;
		EditingToolsCropToolConstraintDescription* _tmp30_;
#line 521 "../src/editing_tools/CropTool.vala"
		_tmp28_ = editing_tools_crop_tool_get_last_constraint (self, &_tmp27_);
#line 521 "../src/editing_tools/CropTool.vala"
		index = _tmp27_;
#line 521 "../src/editing_tools/CropTool.vala"
		desc = _tmp28_;
#line 522 "../src/editing_tools/CropTool.vala"
		_tmp30_ = desc;
#line 522 "../src/editing_tools/CropTool.vala"
		if (_tmp30_ != NULL) {
#line 2910 "CropTool.c"
			EditingToolsCropToolConstraintDescription* _tmp31_;
#line 522 "../src/editing_tools/CropTool.vala"
			_tmp31_ = desc;
#line 522 "../src/editing_tools/CropTool.vala"
			_tmp29_ = !editing_tools_crop_tool_constraint_description_is_separator (_tmp31_);
#line 2916 "CropTool.c"
		} else {
#line 522 "../src/editing_tools/CropTool.vala"
			_tmp29_ = FALSE;
#line 2920 "CropTool.c"
		}
#line 522 "../src/editing_tools/CropTool.vala"
		if (_tmp29_) {
#line 2924 "CropTool.c"
			EditingToolsCropToolCropToolWindow* _tmp32_;
			GtkComboBox* _tmp33_;
			GtkComboBox* _tmp34_;
#line 523 "../src/editing_tools/CropTool.vala"
			_tmp32_ = self->priv->crop_tool_window;
#line 523 "../src/editing_tools/CropTool.vala"
			_tmp33_ = editing_tools_crop_tool_crop_tool_window_get_constraint_combo (_tmp32_);
#line 523 "../src/editing_tools/CropTool.vala"
			_tmp34_ = _tmp33_;
#line 523 "../src/editing_tools/CropTool.vala"
			gtk_combo_box_set_active (_tmp34_, index);
#line 2936 "CropTool.c"
		}
#line 519 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (desc);
#line 2940 "CropTool.c"
	}
#line 528 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_update_pivot_button_state (self);
#line 529 "../src/editing_tools/CropTool.vala"
	self->priv->reticle_orientation = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE;
#line 531 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_bind_window_handlers (self);
#line 534 "../src/editing_tools/CropTool.vala"
	_tmp35_ = editing_tools_photo_canvas_get_photo (canvas);
#line 534 "../src/editing_tools/CropTool.vala"
	_tmp36_ = _tmp35_;
#line 534 "../src/editing_tools/CropTool.vala"
	media_source_get_dimensions ((MediaSource*) _tmp36_, PHOTO_EXCEPTION_CROP, &_tmp37_);
#line 534 "../src/editing_tools/CropTool.vala"
	uncropped_dim = _tmp37_;
#line 537 "../src/editing_tools/CropTool.vala"
	_tmp38_ = editing_tools_photo_canvas_get_photo (canvas);
#line 537 "../src/editing_tools/CropTool.vala"
	_tmp39_ = _tmp38_;
#line 537 "../src/editing_tools/CropTool.vala"
	_tmp41_ = photo_get_crop (_tmp39_, &_tmp40_, PHOTO_EXCEPTION_NONE);
#line 537 "../src/editing_tools/CropTool.vala"
	crop = _tmp40_;
#line 537 "../src/editing_tools/CropTool.vala"
	if (!_tmp41_) {
#line 2966 "CropTool.c"
		gint xofs = 0;
		Dimensions _tmp42_;
		gint yofs = 0;
		Dimensions _tmp43_;
		Dimensions _tmp44_;
		Dimensions _tmp45_;
#line 538 "../src/editing_tools/CropTool.vala"
		_tmp42_ = uncropped_dim;
#line 538 "../src/editing_tools/CropTool.vala"
		xofs = (gint) (_tmp42_.width * EDITING_TOOLS_CROP_TOOL_CROP_INIT_X_PCT);
#line 539 "../src/editing_tools/CropTool.vala"
		_tmp43_ = uncropped_dim;
#line 539 "../src/editing_tools/CropTool.vala"
		yofs = (gint) (_tmp43_.height * EDITING_TOOLS_CROP_TOOL_CROP_INIT_Y_PCT);
#line 543 "../src/editing_tools/CropTool.vala"
		_tmp44_ = uncropped_dim;
#line 543 "../src/editing_tools/CropTool.vala"
		_tmp45_ = uncropped_dim;
#line 543 "../src/editing_tools/CropTool.vala"
		box_init (&crop, xofs, yofs, _tmp44_.width - xofs, _tmp45_.height - yofs);
#line 2987 "CropTool.c"
	}
#line 548 "../src/editing_tools/CropTool.vala"
	_tmp46_ = uncropped_dim;
#line 548 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_scaled_position (canvas, &_tmp47_);
#line 548 "../src/editing_tools/CropTool.vala"
	_tmp48_ = _tmp47_;
#line 548 "../src/editing_tools/CropTool.vala"
	dimensions_for_rectangle (&_tmp48_, &_tmp49_);
#line 548 "../src/editing_tools/CropTool.vala"
	box_get_scaled_similar (&crop, &_tmp46_, &_tmp49_, &_tmp50_);
#line 548 "../src/editing_tools/CropTool.vala"
	self->priv->scaled_crop = _tmp50_;
#line 553 "../src/editing_tools/CropTool.vala"
	_tmp51_ = self->priv->crop_settings;
#line 553 "../src/editing_tools/CropTool.vala"
	self->priv->custom_width = g_settings_get_int (_tmp51_, "last-crop-width");
#line 554 "../src/editing_tools/CropTool.vala"
	_tmp52_ = self->priv->crop_settings;
#line 554 "../src/editing_tools/CropTool.vala"
	self->priv->custom_height = g_settings_get_int (_tmp52_, "last-crop-height");
#line 555 "../src/editing_tools/CropTool.vala"
	self->priv->custom_init_width = self->priv->custom_width;
#line 556 "../src/editing_tools/CropTool.vala"
	self->priv->custom_init_height = self->priv->custom_height;
#line 557 "../src/editing_tools/CropTool.vala"
	self->priv->pre_aspect_ratio = ((gfloat) self->priv->custom_init_width) / ((gfloat) self->priv->custom_init_height);
#line 559 "../src/editing_tools/CropTool.vala"
	self->priv->constraint_mode = EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL;
#line 561 "../src/editing_tools/CropTool.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_crop_tool_parent_class)->activate (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), canvas);
#line 566 "../src/editing_tools/CropTool.vala"
	_tmp53_ = self->priv->crop_tool_window;
#line 566 "../src/editing_tools/CropTool.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp53_);
#line 567 "../src/editing_tools/CropTool.vala"
	_tmp54_ = self->priv->crop_tool_window;
#line 567 "../src/editing_tools/CropTool.vala"
	gtk_widget_hide ((GtkWidget*) _tmp54_);
#line 570 "../src/editing_tools/CropTool.vala"
	_tmp55_ = editing_tools_photo_canvas_get_photo (canvas);
#line 570 "../src/editing_tools/CropTool.vala"
	_tmp56_ = _tmp55_;
#line 570 "../src/editing_tools/CropTool.vala"
	if (!photo_has_crop (_tmp56_)) {
#line 3033 "CropTool.c"
		EditingToolsCropToolConstraintDescription* desc = NULL;
		EditingToolsCropToolConstraintDescription* _tmp57_;
		gboolean _tmp58_ = FALSE;
		gboolean _tmp59_ = FALSE;
		EditingToolsCropToolConstraintDescription* _tmp60_;
#line 571 "../src/editing_tools/CropTool.vala"
		_tmp57_ = editing_tools_crop_tool_get_last_constraint (self, NULL);
#line 571 "../src/editing_tools/CropTool.vala"
		desc = _tmp57_;
#line 572 "../src/editing_tools/CropTool.vala"
		_tmp60_ = desc;
#line 572 "../src/editing_tools/CropTool.vala"
		if (_tmp60_ != NULL) {
#line 3047 "CropTool.c"
			EditingToolsCropToolConstraintDescription* _tmp61_;
#line 572 "../src/editing_tools/CropTool.vala"
			_tmp61_ = desc;
#line 572 "../src/editing_tools/CropTool.vala"
			_tmp59_ = !editing_tools_crop_tool_constraint_description_is_separator (_tmp61_);
#line 3053 "CropTool.c"
		} else {
#line 572 "../src/editing_tools/CropTool.vala"
			_tmp59_ = FALSE;
#line 3057 "CropTool.c"
		}
#line 572 "../src/editing_tools/CropTool.vala"
		if (_tmp59_) {
#line 3061 "CropTool.c"
			EditingToolsCropToolConstraintDescription* _tmp62_;
			gfloat _tmp63_;
			gfloat _tmp64_;
#line 572 "../src/editing_tools/CropTool.vala"
			_tmp62_ = desc;
#line 572 "../src/editing_tools/CropTool.vala"
			_tmp63_ = editing_tools_crop_tool_constraint_description_get_aspect_ratio (_tmp62_);
#line 572 "../src/editing_tools/CropTool.vala"
			_tmp64_ = _tmp63_;
#line 572 "../src/editing_tools/CropTool.vala"
			_tmp58_ = _tmp64_ == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO;
#line 3073 "CropTool.c"
		} else {
#line 572 "../src/editing_tools/CropTool.vala"
			_tmp58_ = FALSE;
#line 3077 "CropTool.c"
		}
#line 572 "../src/editing_tools/CropTool.vala"
		if (_tmp58_) {
#line 573 "../src/editing_tools/CropTool.vala"
			editing_tools_crop_tool_set_custom_constraint_mode (self);
#line 3083 "CropTool.c"
		}
#line 570 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (desc);
#line 3087 "CropTool.c"
	}
#line 581 "../src/editing_tools/CropTool.vala"
	_tmp65_ = self->priv->scaled_crop;
#line 581 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_constrain_crop (self, &_tmp65_, &_tmp66_);
#line 581 "../src/editing_tools/CropTool.vala"
	new_crop = _tmp66_;
#line 583 "../src/editing_tools/CropTool.vala"
	_tmp67_ = new_crop;
#line 583 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_resized (self, &_tmp67_);
#line 584 "../src/editing_tools/CropTool.vala"
	_tmp68_ = new_crop;
#line 584 "../src/editing_tools/CropTool.vala"
	self->priv->scaled_crop = _tmp68_;
#line 585 "../src/editing_tools/CropTool.vala"
	_tmp69_ = new_crop;
#line 585 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_invalidate_area (canvas, &_tmp69_);
#line 586 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_repaint (canvas);
#line 588 "../src/editing_tools/CropTool.vala"
	self->priv->pre_aspect_ratio = editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 496 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (ctx);
#line 3113 "CropTool.c"
}

static void
_editing_tools_crop_tool_prepare_ctx_editing_tools_photo_canvas_new_surface (EditingToolsPhotoCanvas* _sender,
                                                                             cairo_t* ctx,
                                                                             Dimensions* dim,
                                                                             gpointer self)
{
#line 592 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_prepare_ctx ((EditingToolsCropTool*) self, ctx, dim);
#line 3124 "CropTool.c"
}

static void
_editing_tools_crop_tool_on_resized_pixbuf_editing_tools_photo_canvas_resized_scaled_pixbuf (EditingToolsPhotoCanvas* _sender,
                                                                                             Dimensions* old_dim,
                                                                                             GdkPixbuf* scaled,
                                                                                             GdkRectangle* scaled_position,
                                                                                             gpointer self)
{
#line 593 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_on_resized_pixbuf ((EditingToolsCropTool*) self, old_dim, scaled, scaled_position);
#line 3136 "CropTool.c"
}

static void
editing_tools_crop_tool_bind_canvas_handlers (EditingToolsCropTool* self,
                                              EditingToolsPhotoCanvas* canvas)
{
#line 591 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 591 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (canvas != NULL);
#line 592 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object (canvas, "new-surface", (GCallback) _editing_tools_crop_tool_prepare_ctx_editing_tools_photo_canvas_new_surface, self, 0);
#line 593 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object (canvas, "resized-scaled-pixbuf", (GCallback) _editing_tools_crop_tool_on_resized_pixbuf_editing_tools_photo_canvas_resized_scaled_pixbuf, self, 0);
#line 3151 "CropTool.c"
}

static void
editing_tools_crop_tool_unbind_canvas_handlers (EditingToolsCropTool* self,
                                                EditingToolsPhotoCanvas* canvas)
{
	guint _tmp0_;
	guint _tmp1_;
#line 596 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 596 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (canvas != NULL);
#line 597 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("new-surface", EDITING_TOOLS_TYPE_PHOTO_CANVAS, &_tmp0_, NULL, FALSE);
#line 597 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched (canvas, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _editing_tools_crop_tool_prepare_ctx_editing_tools_photo_canvas_new_surface, self);
#line 598 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("resized-scaled-pixbuf", EDITING_TOOLS_TYPE_PHOTO_CANVAS, &_tmp1_, NULL, FALSE);
#line 598 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched (canvas, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_resized_pixbuf_editing_tools_photo_canvas_resized_scaled_pixbuf, self);
#line 3172 "CropTool.c"
}

static void
_editing_tools_crop_tool_on_crop_ok_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 602 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_on_crop_ok ((EditingToolsCropTool*) self);
#line 3181 "CropTool.c"
}

static void
_editing_tools_editing_tool_notify_cancel_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 603 "../src/editing_tools/CropTool.vala"
	editing_tools_editing_tool_notify_cancel ((EditingToolsEditingTool*) self);
#line 3190 "CropTool.c"
}

static void
_editing_tools_crop_tool_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self)
{
#line 604 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_constraint_changed ((EditingToolsCropTool*) self);
#line 3199 "CropTool.c"
}

static void
_editing_tools_crop_tool_on_pivot_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self)
{
#line 605 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_on_pivot_button_clicked ((EditingToolsCropTool*) self);
#line 3208 "CropTool.c"
}

static gboolean
_editing_tools_crop_tool_on_custom_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                               GdkEventFocus* event,
                                                                               gpointer self)
{
	gboolean result;
	result = editing_tools_crop_tool_on_custom_entry_focus_out ((EditingToolsCropTool*) self, event);
#line 608 "../src/editing_tools/CropTool.vala"
	return result;
#line 3220 "CropTool.c"
}

static void
_editing_tools_crop_tool_on_width_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                        const gchar* new_text,
                                                                        gint new_text_length,
                                                                        gint* position,
                                                                        gpointer self)
{
#line 610 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_on_width_insert_text ((EditingToolsCropTool*) self, new_text, new_text_length, position);
#line 3232 "CropTool.c"
}

static void
_editing_tools_crop_tool_on_height_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                         const gchar* new_text,
                                                                         gint new_text_length,
                                                                         gint* position,
                                                                         gpointer self)
{
#line 611 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_on_height_insert_text ((EditingToolsCropTool*) self, new_text, new_text_length, position);
#line 3244 "CropTool.c"
}

static void
editing_tools_crop_tool_bind_window_handlers (EditingToolsCropTool* self)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	EditingToolsCropToolCropToolWindow* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	EditingToolsCropToolCropToolWindow* _tmp6_;
	GtkComboBox* _tmp7_;
	GtkComboBox* _tmp8_;
	EditingToolsCropToolCropToolWindow* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	EditingToolsCropToolCropToolWindow* _tmp12_;
	GtkEntry* _tmp13_;
	GtkEntry* _tmp14_;
	EditingToolsCropToolCropToolWindow* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	EditingToolsCropToolCropToolWindow* _tmp18_;
	GtkEntry* _tmp19_;
	GtkEntry* _tmp20_;
	EditingToolsCropToolCropToolWindow* _tmp21_;
	GtkEntry* _tmp22_;
	GtkEntry* _tmp23_;
#line 601 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 602 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 602 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_crop_tool_window_get_crop_button (_tmp0_);
#line 602 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 602 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object (_tmp2_, "clicked", (GCallback) _editing_tools_crop_tool_on_crop_ok_gtk_button_clicked, self, 0);
#line 603 "../src/editing_tools/CropTool.vala"
	_tmp3_ = self->priv->crop_tool_window;
#line 603 "../src/editing_tools/CropTool.vala"
	_tmp4_ = editing_tools_crop_tool_crop_tool_window_get_cancel_button (_tmp3_);
#line 603 "../src/editing_tools/CropTool.vala"
	_tmp5_ = _tmp4_;
#line 603 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object (_tmp5_, "clicked", (GCallback) _editing_tools_editing_tool_notify_cancel_gtk_button_clicked, (EditingToolsEditingTool*) self, 0);
#line 604 "../src/editing_tools/CropTool.vala"
	_tmp6_ = self->priv->crop_tool_window;
#line 604 "../src/editing_tools/CropTool.vala"
	_tmp7_ = editing_tools_crop_tool_crop_tool_window_get_constraint_combo (_tmp6_);
#line 604 "../src/editing_tools/CropTool.vala"
	_tmp8_ = _tmp7_;
#line 604 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object (_tmp8_, "changed", (GCallback) _editing_tools_crop_tool_constraint_changed_gtk_combo_box_changed, self, 0);
#line 605 "../src/editing_tools/CropTool.vala"
	_tmp9_ = self->priv->crop_tool_window;
#line 605 "../src/editing_tools/CropTool.vala"
	_tmp10_ = editing_tools_crop_tool_crop_tool_window_get_pivot_reticle_button (_tmp9_);
#line 605 "../src/editing_tools/CropTool.vala"
	_tmp11_ = _tmp10_;
#line 605 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object (_tmp11_, "clicked", (GCallback) _editing_tools_crop_tool_on_pivot_button_clicked_gtk_button_clicked, self, 0);
#line 608 "../src/editing_tools/CropTool.vala"
	_tmp12_ = self->priv->crop_tool_window;
#line 608 "../src/editing_tools/CropTool.vala"
	_tmp13_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp12_);
#line 608 "../src/editing_tools/CropTool.vala"
	_tmp14_ = _tmp13_;
#line 608 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object ((GtkWidget*) _tmp14_, "focus-out-event", (GCallback) _editing_tools_crop_tool_on_custom_entry_focus_out_gtk_widget_focus_out_event, self, 0);
#line 609 "../src/editing_tools/CropTool.vala"
	_tmp15_ = self->priv->crop_tool_window;
#line 609 "../src/editing_tools/CropTool.vala"
	_tmp16_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp15_);
#line 609 "../src/editing_tools/CropTool.vala"
	_tmp17_ = _tmp16_;
#line 609 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object ((GtkWidget*) _tmp17_, "focus-out-event", (GCallback) _editing_tools_crop_tool_on_custom_entry_focus_out_gtk_widget_focus_out_event, self, 0);
#line 610 "../src/editing_tools/CropTool.vala"
	_tmp18_ = self->priv->crop_tool_window;
#line 610 "../src/editing_tools/CropTool.vala"
	_tmp19_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp18_);
#line 610 "../src/editing_tools/CropTool.vala"
	_tmp20_ = _tmp19_;
#line 610 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object ((GtkEditable*) _tmp20_, "insert-text", (GCallback) _editing_tools_crop_tool_on_width_insert_text_gtk_editable_insert_text, self, 0);
#line 611 "../src/editing_tools/CropTool.vala"
	_tmp21_ = self->priv->crop_tool_window;
#line 611 "../src/editing_tools/CropTool.vala"
	_tmp22_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp21_);
#line 611 "../src/editing_tools/CropTool.vala"
	_tmp23_ = _tmp22_;
#line 611 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object ((GtkEditable*) _tmp23_, "insert-text", (GCallback) _editing_tools_crop_tool_on_height_insert_text_gtk_editable_insert_text, self, 0);
#line 3340 "CropTool.c"
}

static void
editing_tools_crop_tool_unbind_window_handlers (EditingToolsCropTool* self)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	guint _tmp3_;
	EditingToolsCropToolCropToolWindow* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	guint _tmp7_;
	EditingToolsCropToolCropToolWindow* _tmp8_;
	GtkComboBox* _tmp9_;
	GtkComboBox* _tmp10_;
	guint _tmp11_;
	EditingToolsCropToolCropToolWindow* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	guint _tmp15_;
	EditingToolsCropToolCropToolWindow* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	guint _tmp19_;
	EditingToolsCropToolCropToolWindow* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	guint _tmp23_;
	EditingToolsCropToolCropToolWindow* _tmp24_;
	GtkEntry* _tmp25_;
	GtkEntry* _tmp26_;
	guint _tmp27_;
#line 614 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 615 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 615 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_crop_tool_window_get_crop_button (_tmp0_);
#line 615 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 615 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp3_, NULL, FALSE);
#line 615 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_crop_ok_gtk_button_clicked, self);
#line 616 "../src/editing_tools/CropTool.vala"
	_tmp4_ = self->priv->crop_tool_window;
#line 616 "../src/editing_tools/CropTool.vala"
	_tmp5_ = editing_tools_crop_tool_crop_tool_window_get_cancel_button (_tmp4_);
#line 616 "../src/editing_tools/CropTool.vala"
	_tmp6_ = _tmp5_;
#line 616 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp7_, NULL, FALSE);
#line 616 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _editing_tools_editing_tool_notify_cancel_gtk_button_clicked, (EditingToolsEditingTool*) self);
#line 617 "../src/editing_tools/CropTool.vala"
	_tmp8_ = self->priv->crop_tool_window;
#line 617 "../src/editing_tools/CropTool.vala"
	_tmp9_ = editing_tools_crop_tool_crop_tool_window_get_constraint_combo (_tmp8_);
#line 617 "../src/editing_tools/CropTool.vala"
	_tmp10_ = _tmp9_;
#line 617 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp11_, NULL, FALSE);
#line 617 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _editing_tools_crop_tool_constraint_changed_gtk_combo_box_changed, self);
#line 618 "../src/editing_tools/CropTool.vala"
	_tmp12_ = self->priv->crop_tool_window;
#line 618 "../src/editing_tools/CropTool.vala"
	_tmp13_ = editing_tools_crop_tool_crop_tool_window_get_pivot_reticle_button (_tmp12_);
#line 618 "../src/editing_tools/CropTool.vala"
	_tmp14_ = _tmp13_;
#line 618 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp15_, NULL, FALSE);
#line 618 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_pivot_button_clicked_gtk_button_clicked, self);
#line 621 "../src/editing_tools/CropTool.vala"
	_tmp16_ = self->priv->crop_tool_window;
#line 621 "../src/editing_tools/CropTool.vala"
	_tmp17_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp16_);
#line 621 "../src/editing_tools/CropTool.vala"
	_tmp18_ = _tmp17_;
#line 621 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("focus-out-event", gtk_widget_get_type (), &_tmp19_, NULL, FALSE);
#line 621 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_custom_entry_focus_out_gtk_widget_focus_out_event, self);
#line 622 "../src/editing_tools/CropTool.vala"
	_tmp20_ = self->priv->crop_tool_window;
#line 622 "../src/editing_tools/CropTool.vala"
	_tmp21_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp20_);
#line 622 "../src/editing_tools/CropTool.vala"
	_tmp22_ = _tmp21_;
#line 622 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("focus-out-event", gtk_widget_get_type (), &_tmp23_, NULL, FALSE);
#line 622 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_custom_entry_focus_out_gtk_widget_focus_out_event, self);
#line 623 "../src/editing_tools/CropTool.vala"
	_tmp24_ = self->priv->crop_tool_window;
#line 623 "../src/editing_tools/CropTool.vala"
	_tmp25_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp24_);
#line 623 "../src/editing_tools/CropTool.vala"
	_tmp26_ = _tmp25_;
#line 623 "../src/editing_tools/CropTool.vala"
	g_signal_parse_name ("insert-text", gtk_editable_get_type (), &_tmp27_, NULL, FALSE);
#line 623 "../src/editing_tools/CropTool.vala"
	g_signal_handlers_disconnect_matched ((GtkEditable*) _tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_width_insert_text_gtk_editable_insert_text, self);
#line 3446 "CropTool.c"
}

static void
editing_tools_crop_tool_on_pivot_button_clicked (EditingToolsCropTool* self)
{
	EditingToolsCropToolConstraintDescription* _tmp0_;
	EditingToolsCropToolConstraintDescription* _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gboolean _tmp4_;
#line 626 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/editing_tools/CropTool.vala"
	_tmp0_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 627 "../src/editing_tools/CropTool.vala"
	_tmp1_ = _tmp0_;
#line 627 "../src/editing_tools/CropTool.vala"
	_tmp2_ = editing_tools_crop_tool_constraint_description_get_aspect_ratio (_tmp1_);
#line 627 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 627 "../src/editing_tools/CropTool.vala"
	_tmp4_ = _tmp3_ == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO;
#line 627 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp1_);
#line 627 "../src/editing_tools/CropTool.vala"
	if (_tmp4_) {
#line 3473 "CropTool.c"
		gchar* width_text = NULL;
		EditingToolsCropToolCropToolWindow* _tmp5_;
		GtkEntry* _tmp6_;
		GtkEntry* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* height_text = NULL;
		EditingToolsCropToolCropToolWindow* _tmp10_;
		GtkEntry* _tmp11_;
		GtkEntry* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		EditingToolsCropToolCropToolWindow* _tmp15_;
		GtkEntry* _tmp16_;
		GtkEntry* _tmp17_;
		const gchar* _tmp18_;
		EditingToolsCropToolCropToolWindow* _tmp19_;
		GtkEntry* _tmp20_;
		GtkEntry* _tmp21_;
		const gchar* _tmp22_;
		gint temp = 0;
#line 628 "../src/editing_tools/CropTool.vala"
		_tmp5_ = self->priv->crop_tool_window;
#line 628 "../src/editing_tools/CropTool.vala"
		_tmp6_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp5_);
#line 628 "../src/editing_tools/CropTool.vala"
		_tmp7_ = _tmp6_;
#line 628 "../src/editing_tools/CropTool.vala"
		_tmp8_ = gtk_entry_get_text (_tmp7_);
#line 628 "../src/editing_tools/CropTool.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 628 "../src/editing_tools/CropTool.vala"
		width_text = _tmp9_;
#line 629 "../src/editing_tools/CropTool.vala"
		_tmp10_ = self->priv->crop_tool_window;
#line 629 "../src/editing_tools/CropTool.vala"
		_tmp11_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp10_);
#line 629 "../src/editing_tools/CropTool.vala"
		_tmp12_ = _tmp11_;
#line 629 "../src/editing_tools/CropTool.vala"
		_tmp13_ = gtk_entry_get_text (_tmp12_);
#line 629 "../src/editing_tools/CropTool.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 629 "../src/editing_tools/CropTool.vala"
		height_text = _tmp14_;
#line 630 "../src/editing_tools/CropTool.vala"
		_tmp15_ = self->priv->crop_tool_window;
#line 630 "../src/editing_tools/CropTool.vala"
		_tmp16_ = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (_tmp15_);
#line 630 "../src/editing_tools/CropTool.vala"
		_tmp17_ = _tmp16_;
#line 630 "../src/editing_tools/CropTool.vala"
		_tmp18_ = height_text;
#line 630 "../src/editing_tools/CropTool.vala"
		gtk_entry_set_text (_tmp17_, _tmp18_);
#line 631 "../src/editing_tools/CropTool.vala"
		_tmp19_ = self->priv->crop_tool_window;
#line 631 "../src/editing_tools/CropTool.vala"
		_tmp20_ = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (_tmp19_);
#line 631 "../src/editing_tools/CropTool.vala"
		_tmp21_ = _tmp20_;
#line 631 "../src/editing_tools/CropTool.vala"
		_tmp22_ = width_text;
#line 631 "../src/editing_tools/CropTool.vala"
		gtk_entry_set_text (_tmp21_, _tmp22_);
#line 633 "../src/editing_tools/CropTool.vala"
		temp = self->priv->custom_width;
#line 634 "../src/editing_tools/CropTool.vala"
		self->priv->custom_width = self->priv->custom_height;
#line 635 "../src/editing_tools/CropTool.vala"
		self->priv->custom_height = temp;
#line 627 "../src/editing_tools/CropTool.vala"
		_g_free0 (height_text);
#line 627 "../src/editing_tools/CropTool.vala"
		_g_free0 (width_text);
#line 3549 "CropTool.c"
	}
#line 638 "../src/editing_tools/CropTool.vala"
	self->priv->reticle_orientation = editing_tools_crop_tool_reticle_orientation_toggle (self->priv->reticle_orientation);
#line 639 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_constraint_changed (self);
#line 3555 "CropTool.c"
}

static void
editing_tools_crop_tool_real_deactivate (EditingToolsEditingTool* base)
{
	EditingToolsCropTool * self;
	EditingToolsPhotoCanvas* _tmp0_;
	EditingToolsCropToolCropToolWindow* _tmp2_;
	EditingToolsPhotoCanvas* _tmp5_;
#line 642 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) base;
#line 643 "../src/editing_tools/CropTool.vala"
	_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 643 "../src/editing_tools/CropTool.vala"
	if (_tmp0_ != NULL) {
#line 3571 "CropTool.c"
		EditingToolsPhotoCanvas* _tmp1_;
#line 644 "../src/editing_tools/CropTool.vala"
		_tmp1_ = ((EditingToolsEditingTool*) self)->canvas;
#line 644 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_unbind_canvas_handlers (self, _tmp1_);
#line 3577 "CropTool.c"
	}
#line 647 "../src/editing_tools/CropTool.vala"
	_tmp2_ = self->priv->crop_tool_window;
#line 647 "../src/editing_tools/CropTool.vala"
	if (_tmp2_ != NULL) {
#line 3583 "CropTool.c"
		EditingToolsCropToolCropToolWindow* _tmp3_;
		EditingToolsCropToolCropToolWindow* _tmp4_;
#line 648 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_unbind_window_handlers (self);
#line 649 "../src/editing_tools/CropTool.vala"
		_tmp3_ = self->priv->crop_tool_window;
#line 649 "../src/editing_tools/CropTool.vala"
		gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 650 "../src/editing_tools/CropTool.vala"
		_tmp4_ = self->priv->crop_tool_window;
#line 650 "../src/editing_tools/CropTool.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp4_);
#line 651 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->crop_tool_window);
#line 651 "../src/editing_tools/CropTool.vala"
		self->priv->crop_tool_window = NULL;
#line 3600 "CropTool.c"
	}
#line 655 "../src/editing_tools/CropTool.vala"
	_tmp5_ = ((EditingToolsEditingTool*) self)->canvas;
#line 655 "../src/editing_tools/CropTool.vala"
	if (_tmp5_ != NULL) {
#line 3606 "CropTool.c"
		EditingToolsPhotoCanvas* _tmp6_;
		GdkWindow* _tmp7_;
		GdkWindow* _tmp8_;
		GdkDisplay* _tmp9_;
		GdkCursor* _tmp10_;
		GdkCursor* _tmp11_;
#line 656 "../src/editing_tools/CropTool.vala"
		_tmp6_ = ((EditingToolsEditingTool*) self)->canvas;
#line 656 "../src/editing_tools/CropTool.vala"
		_tmp7_ = editing_tools_photo_canvas_get_drawing_window (_tmp6_);
#line 656 "../src/editing_tools/CropTool.vala"
		_tmp8_ = _tmp7_;
#line 656 "../src/editing_tools/CropTool.vala"
		_tmp9_ = gdk_display_get_default ();
#line 656 "../src/editing_tools/CropTool.vala"
		_tmp10_ = gdk_cursor_new_for_display (_tmp9_, GDK_LEFT_PTR);
#line 656 "../src/editing_tools/CropTool.vala"
		_tmp11_ = _tmp10_;
#line 656 "../src/editing_tools/CropTool.vala"
		gdk_window_set_cursor (_tmp8_, _tmp11_);
#line 656 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (_tmp11_);
#line 3629 "CropTool.c"
	}
#line 659 "../src/editing_tools/CropTool.vala"
	_cairo_surface_destroy0 (self->priv->crop_surface);
#line 659 "../src/editing_tools/CropTool.vala"
	self->priv->crop_surface = NULL;
#line 661 "../src/editing_tools/CropTool.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_crop_tool_parent_class)->deactivate (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 3637 "CropTool.c"
}

static EditingToolsEditingToolWindow*
editing_tools_crop_tool_real_get_tool_window (EditingToolsEditingTool* base)
{
	EditingToolsCropTool * self;
	EditingToolsCropToolCropToolWindow* _tmp0_;
	EditingToolsEditingToolWindow* _tmp1_;
	EditingToolsEditingToolWindow* result;
#line 664 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) base;
#line 665 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 665 "../src/editing_tools/CropTool.vala"
	_tmp1_ = _g_object_ref0 ((EditingToolsEditingToolWindow*) _tmp0_);
#line 665 "../src/editing_tools/CropTool.vala"
	result = _tmp1_;
#line 665 "../src/editing_tools/CropTool.vala"
	return result;
#line 3657 "CropTool.c"
}

static GdkPixbuf*
editing_tools_crop_tool_real_get_display_pixbuf (EditingToolsEditingTool* base,
                                                 Scaling* scaling,
                                                 Photo* photo,
                                                 Dimensions* max_dim,
                                                 GError** error)
{
	EditingToolsCropTool * self;
	Dimensions _vala_max_dim = {0};
	Dimensions _tmp0_ = {0};
	GdkPixbuf* _tmp1_ = NULL;
	Scaling _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 668 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) base;
#line 668 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 668 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 670 "../src/editing_tools/CropTool.vala"
	media_source_get_dimensions ((MediaSource*) photo, PHOTO_EXCEPTION_CROP, &_tmp0_);
#line 670 "../src/editing_tools/CropTool.vala"
	_vala_max_dim = _tmp0_;
#line 672 "../src/editing_tools/CropTool.vala"
	_tmp2_ = *scaling;
#line 672 "../src/editing_tools/CropTool.vala"
	_tmp3_ = photo_get_pixbuf_with_options (photo, &_tmp2_, PHOTO_EXCEPTION_CROP, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 672 "../src/editing_tools/CropTool.vala"
	_tmp1_ = _tmp3_;
#line 672 "../src/editing_tools/CropTool.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 672 "../src/editing_tools/CropTool.vala"
		g_propagate_error (error, _inner_error0_);
#line 672 "../src/editing_tools/CropTool.vala"
		return NULL;
#line 3698 "CropTool.c"
	}
#line 672 "../src/editing_tools/CropTool.vala"
	_tmp4_ = _tmp1_;
#line 672 "../src/editing_tools/CropTool.vala"
	_tmp1_ = NULL;
#line 672 "../src/editing_tools/CropTool.vala"
	result = _tmp4_;
#line 672 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp1_);
#line 672 "../src/editing_tools/CropTool.vala"
	if (max_dim) {
#line 672 "../src/editing_tools/CropTool.vala"
		*max_dim = _vala_max_dim;
#line 3712 "CropTool.c"
	}
#line 672 "../src/editing_tools/CropTool.vala"
	return result;
#line 3716 "CropTool.c"
}

static void
editing_tools_crop_tool_prepare_ctx (EditingToolsCropTool* self,
                                     cairo_t* ctx,
                                     Dimensions* dim)
{
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_t* _tmp15_;
#line 675 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 675 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (ctx != NULL);
#line 675 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (dim != NULL);
#line 676 "../src/editing_tools/CropTool.vala"
	_tmp0_ = cairo_get_target (ctx);
#line 676 "../src/editing_tools/CropTool.vala"
	_tmp1_ = cairo_create (_tmp0_);
#line 676 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (self->priv->wide_black_ctx);
#line 676 "../src/editing_tools/CropTool.vala"
	self->priv->wide_black_ctx = _tmp1_;
#line 677 "../src/editing_tools/CropTool.vala"
	_tmp2_ = self->priv->wide_black_ctx;
#line 677 "../src/editing_tools/CropTool.vala"
	set_source_color_from_string (_tmp2_, "#000");
#line 678 "../src/editing_tools/CropTool.vala"
	_tmp3_ = self->priv->wide_black_ctx;
#line 678 "../src/editing_tools/CropTool.vala"
	cairo_set_line_width (_tmp3_, (gdouble) (1 * self->priv->scale_factor));
#line 680 "../src/editing_tools/CropTool.vala"
	_tmp4_ = cairo_get_target (ctx);
#line 680 "../src/editing_tools/CropTool.vala"
	_tmp5_ = cairo_create (_tmp4_);
#line 680 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (self->priv->wide_white_ctx);
#line 680 "../src/editing_tools/CropTool.vala"
	self->priv->wide_white_ctx = _tmp5_;
#line 681 "../src/editing_tools/CropTool.vala"
	_tmp6_ = self->priv->wide_white_ctx;
#line 681 "../src/editing_tools/CropTool.vala"
	set_source_color_from_string (_tmp6_, "#FFF");
#line 682 "../src/editing_tools/CropTool.vala"
	_tmp7_ = self->priv->wide_white_ctx;
#line 682 "../src/editing_tools/CropTool.vala"
	cairo_set_line_width (_tmp7_, (gdouble) (1 * self->priv->scale_factor));
#line 684 "../src/editing_tools/CropTool.vala"
	_tmp8_ = cairo_get_target (ctx);
#line 684 "../src/editing_tools/CropTool.vala"
	_tmp9_ = cairo_create (_tmp8_);
#line 684 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (self->priv->thin_white_ctx);
#line 684 "../src/editing_tools/CropTool.vala"
	self->priv->thin_white_ctx = _tmp9_;
#line 685 "../src/editing_tools/CropTool.vala"
	_tmp10_ = self->priv->thin_white_ctx;
#line 685 "../src/editing_tools/CropTool.vala"
	set_source_color_from_string (_tmp10_, "#FFF");
#line 686 "../src/editing_tools/CropTool.vala"
	_tmp11_ = self->priv->thin_white_ctx;
#line 686 "../src/editing_tools/CropTool.vala"
	cairo_set_line_width (_tmp11_, 0.5 * self->priv->scale_factor);
#line 688 "../src/editing_tools/CropTool.vala"
	_tmp12_ = cairo_get_target (ctx);
#line 688 "../src/editing_tools/CropTool.vala"
	_tmp13_ = cairo_create (_tmp12_);
#line 688 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (self->priv->text_ctx);
#line 688 "../src/editing_tools/CropTool.vala"
	self->priv->text_ctx = _tmp13_;
#line 689 "../src/editing_tools/CropTool.vala"
	_tmp14_ = self->priv->text_ctx;
#line 689 "../src/editing_tools/CropTool.vala"
	cairo_select_font_face (_tmp14_, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
#line 690 "../src/editing_tools/CropTool.vala"
	_tmp15_ = self->priv->text_ctx;
#line 690 "../src/editing_tools/CropTool.vala"
	cairo_set_font_size (_tmp15_, 10.0 * self->priv->scale_factor);
#line 3810 "CropTool.c"
}

static void
editing_tools_crop_tool_on_resized_pixbuf (EditingToolsCropTool* self,
                                           Dimensions* old_dim,
                                           GdkPixbuf* scaled,
                                           GdkRectangle* scaled_position)
{
	Dimensions new_dim = {0};
	Dimensions _tmp0_ = {0};
	Dimensions uncropped_dim = {0};
	EditingToolsPhotoCanvas* _tmp1_;
	Photo* _tmp2_;
	Photo* _tmp3_;
	Dimensions _tmp4_ = {0};
	Box crop = {0};
	Dimensions _tmp5_;
	Dimensions _tmp6_;
	Box _tmp7_ = {0};
	Dimensions _tmp8_;
	Dimensions _tmp9_;
	Box _tmp10_ = {0};
	cairo_surface_t* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	cairo_surface_t* _tmp16_;
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp17_;
	cairo_t* _tmp18_;
#line 693 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 693 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (old_dim != NULL);
#line 693 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (scaled != NULL);
#line 693 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (scaled_position != NULL);
#line 694 "../src/editing_tools/CropTool.vala"
	dimensions_for_pixbuf (scaled, &_tmp0_);
#line 694 "../src/editing_tools/CropTool.vala"
	new_dim = _tmp0_;
#line 695 "../src/editing_tools/CropTool.vala"
	_tmp1_ = ((EditingToolsEditingTool*) self)->canvas;
#line 695 "../src/editing_tools/CropTool.vala"
	_tmp2_ = editing_tools_photo_canvas_get_photo (_tmp1_);
#line 695 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 695 "../src/editing_tools/CropTool.vala"
	media_source_get_dimensions ((MediaSource*) _tmp3_, PHOTO_EXCEPTION_CROP, &_tmp4_);
#line 695 "../src/editing_tools/CropTool.vala"
	uncropped_dim = _tmp4_;
#line 698 "../src/editing_tools/CropTool.vala"
	_tmp5_ = *old_dim;
#line 698 "../src/editing_tools/CropTool.vala"
	_tmp6_ = uncropped_dim;
#line 698 "../src/editing_tools/CropTool.vala"
	box_get_scaled_similar (&self->priv->scaled_crop, &_tmp5_, &_tmp6_, &_tmp7_);
#line 698 "../src/editing_tools/CropTool.vala"
	crop = _tmp7_;
#line 701 "../src/editing_tools/CropTool.vala"
	_tmp8_ = uncropped_dim;
#line 701 "../src/editing_tools/CropTool.vala"
	_tmp9_ = new_dim;
#line 701 "../src/editing_tools/CropTool.vala"
	box_get_scaled_similar (&crop, &_tmp8_, &_tmp9_, &_tmp10_);
#line 701 "../src/editing_tools/CropTool.vala"
	self->priv->scaled_crop = _tmp10_;
#line 702 "../src/editing_tools/CropTool.vala"
	_tmp11_ = self->priv->crop_surface;
#line 702 "../src/editing_tools/CropTool.vala"
	if (_tmp11_ != NULL) {
#line 703 "../src/editing_tools/CropTool.vala"
		_cairo_surface_destroy0 (self->priv->crop_surface);
#line 703 "../src/editing_tools/CropTool.vala"
		self->priv->crop_surface = NULL;
#line 3888 "CropTool.c"
	}
#line 706 "../src/editing_tools/CropTool.vala"
	_tmp12_ = gdk_pixbuf_get_width (scaled);
#line 706 "../src/editing_tools/CropTool.vala"
	_tmp13_ = _tmp12_;
#line 706 "../src/editing_tools/CropTool.vala"
	_tmp14_ = gdk_pixbuf_get_height (scaled);
#line 706 "../src/editing_tools/CropTool.vala"
	_tmp15_ = _tmp14_;
#line 706 "../src/editing_tools/CropTool.vala"
	_tmp16_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp13_, _tmp15_);
#line 706 "../src/editing_tools/CropTool.vala"
	_cairo_surface_destroy0 (self->priv->crop_surface);
#line 706 "../src/editing_tools/CropTool.vala"
	self->priv->crop_surface = _tmp16_;
#line 707 "../src/editing_tools/CropTool.vala"
	_tmp17_ = self->priv->crop_surface;
#line 707 "../src/editing_tools/CropTool.vala"
	_tmp18_ = cairo_create (_tmp17_);
#line 707 "../src/editing_tools/CropTool.vala"
	ctx = _tmp18_;
#line 708 "../src/editing_tools/CropTool.vala"
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
#line 709 "../src/editing_tools/CropTool.vala"
	cairo_paint (ctx);
#line 693 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (ctx);
#line 3916 "CropTool.c"
}

static void
editing_tools_crop_tool_real_on_left_click (EditingToolsEditingTool* base,
                                            gint x,
                                            gint y)
{
	EditingToolsCropTool * self;
	GdkRectangle scaled_pixbuf_pos = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_;
	Box offset_scaled_crop = {0};
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	Box _tmp5_ = {0};
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	EditingToolsPhotoCanvas* _tmp8_;
#line 713 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) base;
#line 714 "../src/editing_tools/CropTool.vala"
	x = x * self->priv->scale_factor;
#line 715 "../src/editing_tools/CropTool.vala"
	y = y * self->priv->scale_factor;
#line 717 "../src/editing_tools/CropTool.vala"
	_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 717 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_scaled_position (_tmp0_, &_tmp1_);
#line 717 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 717 "../src/editing_tools/CropTool.vala"
	scaled_pixbuf_pos = _tmp2_;
#line 720 "../src/editing_tools/CropTool.vala"
	_tmp3_ = scaled_pixbuf_pos;
#line 720 "../src/editing_tools/CropTool.vala"
	_tmp4_ = scaled_pixbuf_pos;
#line 720 "../src/editing_tools/CropTool.vala"
	box_get_offset (&self->priv->scaled_crop, _tmp3_.x, _tmp4_.y, &_tmp5_);
#line 720 "../src/editing_tools/CropTool.vala"
	offset_scaled_crop = _tmp5_;
#line 723 "../src/editing_tools/CropTool.vala"
	self->priv->in_manipulation = box_approx_location (&offset_scaled_crop, x, y);
#line 724 "../src/editing_tools/CropTool.vala"
	_tmp6_ = scaled_pixbuf_pos;
#line 724 "../src/editing_tools/CropTool.vala"
	x = x - _tmp6_.x;
#line 724 "../src/editing_tools/CropTool.vala"
	self->priv->last_grab_x = x;
#line 725 "../src/editing_tools/CropTool.vala"
	_tmp7_ = scaled_pixbuf_pos;
#line 725 "../src/editing_tools/CropTool.vala"
	y = y - _tmp7_.y;
#line 725 "../src/editing_tools/CropTool.vala"
	self->priv->last_grab_y = y;
#line 728 "../src/editing_tools/CropTool.vala"
	_tmp8_ = ((EditingToolsEditingTool*) self)->canvas;
#line 728 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_repaint (_tmp8_);
#line 3976 "CropTool.c"
}

static void
editing_tools_crop_tool_real_on_left_released (EditingToolsEditingTool* base,
                                               gint x,
                                               gint y)
{
	EditingToolsCropTool * self;
	EditingToolsPhotoCanvas* _tmp0_;
#line 731 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) base;
#line 732 "../src/editing_tools/CropTool.vala"
	x = x * self->priv->scale_factor;
#line 733 "../src/editing_tools/CropTool.vala"
	y = y * self->priv->scale_factor;
#line 736 "../src/editing_tools/CropTool.vala"
	if (self->priv->in_manipulation == BOX_LOCATION_OUTSIDE) {
#line 737 "../src/editing_tools/CropTool.vala"
		return;
#line 3996 "CropTool.c"
	}
#line 741 "../src/editing_tools/CropTool.vala"
	self->priv->in_manipulation = BOX_LOCATION_OUTSIDE;
#line 742 "../src/editing_tools/CropTool.vala"
	self->priv->last_grab_x = -1;
#line 743 "../src/editing_tools/CropTool.vala"
	self->priv->last_grab_y = -1;
#line 745 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_update_cursor (self, x, y);
#line 748 "../src/editing_tools/CropTool.vala"
	_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 748 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_repaint (_tmp0_);
#line 4010 "CropTool.c"
}

static void
editing_tools_crop_tool_real_on_motion (EditingToolsEditingTool* base,
                                        gint x,
                                        gint y,
                                        GdkModifierType mask)
{
	EditingToolsCropTool * self;
	EditingToolsPhotoCanvas* _tmp0_;
#line 751 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) base;
#line 752 "../src/editing_tools/CropTool.vala"
	x = x * self->priv->scale_factor;
#line 753 "../src/editing_tools/CropTool.vala"
	y = y * self->priv->scale_factor;
#line 757 "../src/editing_tools/CropTool.vala"
	if (self->priv->in_manipulation != BOX_LOCATION_OUTSIDE) {
#line 758 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_on_canvas_manipulation (self, x, y);
#line 4031 "CropTool.c"
	}
#line 761 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_update_cursor (self, x, y);
#line 762 "../src/editing_tools/CropTool.vala"
	_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 762 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_repaint (_tmp0_);
#line 4039 "CropTool.c"
}

static void
editing_tools_crop_tool_real_paint (EditingToolsEditingTool* base,
                                    cairo_t* default_ctx)
{
	EditingToolsCropTool * self;
	gint w = 0;
	EditingToolsPhotoCanvas* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gint h = 0;
	EditingToolsPhotoCanvas* _tmp3_;
	GdkWindow* _tmp4_;
	GdkWindow* _tmp5_;
	EditingToolsPhotoCanvas* _tmp6_;
	GtkStyleContext* _tmp7_;
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	Box _tmp10_;
	Box _tmp11_;
	EditingToolsPhotoCanvas* _tmp12_;
	cairo_surface_t* _tmp13_;
	Box _tmp14_;
#line 765 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropTool*) base;
#line 765 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (default_ctx != NULL);
#line 767 "../src/editing_tools/CropTool.vala"
	_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 767 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_photo_canvas_get_drawing_window (_tmp0_);
#line 767 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 767 "../src/editing_tools/CropTool.vala"
	w = gdk_window_get_width (_tmp2_) * self->priv->scale_factor;
#line 768 "../src/editing_tools/CropTool.vala"
	_tmp3_ = ((EditingToolsEditingTool*) self)->canvas;
#line 768 "../src/editing_tools/CropTool.vala"
	_tmp4_ = editing_tools_photo_canvas_get_drawing_window (_tmp3_);
#line 768 "../src/editing_tools/CropTool.vala"
	_tmp5_ = _tmp4_;
#line 768 "../src/editing_tools/CropTool.vala"
	h = gdk_window_get_height (_tmp5_) * self->priv->scale_factor;
#line 770 "../src/editing_tools/CropTool.vala"
	_tmp6_ = ((EditingToolsEditingTool*) self)->canvas;
#line 770 "../src/editing_tools/CropTool.vala"
	_tmp7_ = editing_tools_photo_canvas_get_style_context (_tmp6_);
#line 770 "../src/editing_tools/CropTool.vala"
	gtk_render_background (_tmp7_, default_ctx, (gdouble) 0, (gdouble) 0, (gdouble) w, (gdouble) h);
#line 772 "../src/editing_tools/CropTool.vala"
	_tmp8_ = self->priv->crop_surface;
#line 772 "../src/editing_tools/CropTool.vala"
	_tmp9_ = cairo_create (_tmp8_);
#line 772 "../src/editing_tools/CropTool.vala"
	ctx = _tmp9_;
#line 773 "../src/editing_tools/CropTool.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
#line 774 "../src/editing_tools/CropTool.vala"
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 0.5);
#line 775 "../src/editing_tools/CropTool.vala"
	cairo_paint (ctx);
#line 778 "../src/editing_tools/CropTool.vala"
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 0.0);
#line 779 "../src/editing_tools/CropTool.vala"
	_tmp10_ = self->priv->scaled_crop;
#line 779 "../src/editing_tools/CropTool.vala"
	_tmp11_ = self->priv->scaled_crop;
#line 779 "../src/editing_tools/CropTool.vala"
	cairo_rectangle (ctx, (gdouble) _tmp10_.left, (gdouble) _tmp11_.top, (gdouble) box_get_width (&self->priv->scaled_crop), (gdouble) box_get_height (&self->priv->scaled_crop));
#line 781 "../src/editing_tools/CropTool.vala"
	cairo_fill (ctx);
#line 782 "../src/editing_tools/CropTool.vala"
	_tmp12_ = ((EditingToolsEditingTool*) self)->canvas;
#line 782 "../src/editing_tools/CropTool.vala"
	_tmp13_ = self->priv->crop_surface;
#line 782 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_paint_surface (_tmp12_, _tmp13_, TRUE);
#line 785 "../src/editing_tools/CropTool.vala"
	_tmp14_ = self->priv->scaled_crop;
#line 785 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_paint_crop_tool (self, &_tmp14_);
#line 765 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (ctx);
#line 4125 "CropTool.c"
}

static void
editing_tools_crop_tool_on_crop_ok (EditingToolsCropTool* self)
{
	GSettings* _tmp0_;
	EditingToolsCropToolCropToolWindow* _tmp1_;
	GtkComboBox* _tmp2_;
	GtkComboBox* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	Box crop = {0};
	EditingToolsPhotoCanvas* _tmp6_;
	GdkRectangle _tmp7_ = {0};
	GdkRectangle _tmp8_;
	Dimensions _tmp9_ = {0};
	EditingToolsPhotoCanvas* _tmp10_;
	Photo* _tmp11_;
	Photo* _tmp12_;
	Dimensions _tmp13_ = {0};
	Box _tmp14_ = {0};
	GdkPixbuf* cropped = NULL;
	EditingToolsPhotoCanvas* _tmp15_;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp17_;
	Box _tmp18_;
	Box _tmp19_;
	GdkPixbuf* _tmp20_;
	EditingToolsPhotoCanvas* _tmp21_;
	Photo* _tmp22_;
	Photo* _tmp23_;
	Box _tmp24_;
	CropCommand* _tmp25_;
	CropCommand* _tmp26_;
	Dimensions _tmp27_ = {0};
#line 788 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 792 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_settings;
#line 792 "../src/editing_tools/CropTool.vala"
	_tmp1_ = self->priv->crop_tool_window;
#line 792 "../src/editing_tools/CropTool.vala"
	_tmp2_ = editing_tools_crop_tool_crop_tool_window_get_constraint_combo (_tmp1_);
#line 792 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 792 "../src/editing_tools/CropTool.vala"
	g_settings_set_int (_tmp0_, "last-crop-menu-choice", gtk_combo_box_get_active (_tmp3_));
#line 793 "../src/editing_tools/CropTool.vala"
	_tmp4_ = self->priv->crop_settings;
#line 793 "../src/editing_tools/CropTool.vala"
	g_settings_set_int (_tmp4_, "last-crop-width", self->priv->custom_width);
#line 794 "../src/editing_tools/CropTool.vala"
	_tmp5_ = self->priv->crop_settings;
#line 794 "../src/editing_tools/CropTool.vala"
	g_settings_set_int (_tmp5_, "last-crop-height", self->priv->custom_height);
#line 797 "../src/editing_tools/CropTool.vala"
	_tmp6_ = ((EditingToolsEditingTool*) self)->canvas;
#line 797 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_scaled_position (_tmp6_, &_tmp7_);
#line 797 "../src/editing_tools/CropTool.vala"
	_tmp8_ = _tmp7_;
#line 797 "../src/editing_tools/CropTool.vala"
	dimensions_for_rectangle (&_tmp8_, &_tmp9_);
#line 797 "../src/editing_tools/CropTool.vala"
	_tmp10_ = ((EditingToolsEditingTool*) self)->canvas;
#line 797 "../src/editing_tools/CropTool.vala"
	_tmp11_ = editing_tools_photo_canvas_get_photo (_tmp10_);
#line 797 "../src/editing_tools/CropTool.vala"
	_tmp12_ = _tmp11_;
#line 797 "../src/editing_tools/CropTool.vala"
	media_source_get_dimensions ((MediaSource*) _tmp12_, PHOTO_EXCEPTION_CROP, &_tmp13_);
#line 797 "../src/editing_tools/CropTool.vala"
	box_get_scaled_similar (&self->priv->scaled_crop, &_tmp9_, &_tmp13_, &_tmp14_);
#line 797 "../src/editing_tools/CropTool.vala"
	crop = _tmp14_;
#line 802 "../src/editing_tools/CropTool.vala"
	_tmp15_ = ((EditingToolsEditingTool*) self)->canvas;
#line 802 "../src/editing_tools/CropTool.vala"
	_tmp16_ = editing_tools_photo_canvas_get_scaled_pixbuf (_tmp15_);
#line 802 "../src/editing_tools/CropTool.vala"
	_tmp17_ = _tmp16_;
#line 802 "../src/editing_tools/CropTool.vala"
	_tmp18_ = self->priv->scaled_crop;
#line 802 "../src/editing_tools/CropTool.vala"
	_tmp19_ = self->priv->scaled_crop;
#line 802 "../src/editing_tools/CropTool.vala"
	_tmp20_ = gdk_pixbuf_new_subpixbuf (_tmp17_, _tmp18_.left, _tmp19_.top, box_get_width (&self->priv->scaled_crop), box_get_height (&self->priv->scaled_crop));
#line 802 "../src/editing_tools/CropTool.vala"
	cropped = _tmp20_;
#line 807 "../src/editing_tools/CropTool.vala"
	_tmp21_ = ((EditingToolsEditingTool*) self)->canvas;
#line 807 "../src/editing_tools/CropTool.vala"
	_tmp22_ = editing_tools_photo_canvas_get_photo (_tmp21_);
#line 807 "../src/editing_tools/CropTool.vala"
	_tmp23_ = _tmp22_;
#line 807 "../src/editing_tools/CropTool.vala"
	_tmp24_ = crop;
#line 807 "../src/editing_tools/CropTool.vala"
	_tmp25_ = crop_command_new (_tmp23_, &_tmp24_, RESOURCES_CROP_LABEL, RESOURCES_CROP_TOOLTIP);
#line 807 "../src/editing_tools/CropTool.vala"
	_tmp26_ = _tmp25_;
#line 807 "../src/editing_tools/CropTool.vala"
	box_get_dimensions (&crop, &_tmp27_);
#line 807 "../src/editing_tools/CropTool.vala"
	g_signal_emit_by_name ((EditingToolsEditingTool*) self, "applied", (Command*) _tmp26_, cropped, &_tmp27_, TRUE);
#line 807 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp26_);
#line 788 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (cropped);
#line 4235 "CropTool.c"
}

static void
editing_tools_crop_tool_update_cursor (EditingToolsCropTool* self,
                                       gint x,
                                       gint y)
{
	GdkRectangle scaled_pos = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_;
	Box offset_scaled_crop = {0};
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	Box _tmp5_ = {0};
	GdkCursorType cursor_type = 0;
#line 811 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 813 "../src/editing_tools/CropTool.vala"
	_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 813 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_scaled_position (_tmp0_, &_tmp1_);
#line 813 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 813 "../src/editing_tools/CropTool.vala"
	scaled_pos = _tmp2_;
#line 814 "../src/editing_tools/CropTool.vala"
	_tmp3_ = scaled_pos;
#line 814 "../src/editing_tools/CropTool.vala"
	_tmp4_ = scaled_pos;
#line 814 "../src/editing_tools/CropTool.vala"
	box_get_offset (&self->priv->scaled_crop, _tmp3_.x, _tmp4_.y, &_tmp5_);
#line 814 "../src/editing_tools/CropTool.vala"
	offset_scaled_crop = _tmp5_;
#line 816 "../src/editing_tools/CropTool.vala"
	cursor_type = GDK_LEFT_PTR;
#line 817 "../src/editing_tools/CropTool.vala"
	switch (box_approx_location (&offset_scaled_crop, x, y)) {
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_LEFT_SIDE:
#line 4276 "CropTool.c"
		{
#line 819 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_LEFT_SIDE;
#line 820 "../src/editing_tools/CropTool.vala"
			break;
#line 4282 "CropTool.c"
		}
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_TOP_SIDE:
#line 4286 "CropTool.c"
		{
#line 823 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_TOP_SIDE;
#line 824 "../src/editing_tools/CropTool.vala"
			break;
#line 4292 "CropTool.c"
		}
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_RIGHT_SIDE:
#line 4296 "CropTool.c"
		{
#line 827 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_RIGHT_SIDE;
#line 828 "../src/editing_tools/CropTool.vala"
			break;
#line 4302 "CropTool.c"
		}
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_BOTTOM_SIDE:
#line 4306 "CropTool.c"
		{
#line 831 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_BOTTOM_SIDE;
#line 832 "../src/editing_tools/CropTool.vala"
			break;
#line 4312 "CropTool.c"
		}
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_TOP_LEFT:
#line 4316 "CropTool.c"
		{
#line 835 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_TOP_LEFT_CORNER;
#line 836 "../src/editing_tools/CropTool.vala"
			break;
#line 4322 "CropTool.c"
		}
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_BOTTOM_LEFT:
#line 4326 "CropTool.c"
		{
#line 839 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_BOTTOM_LEFT_CORNER;
#line 840 "../src/editing_tools/CropTool.vala"
			break;
#line 4332 "CropTool.c"
		}
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_TOP_RIGHT:
#line 4336 "CropTool.c"
		{
#line 843 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_TOP_RIGHT_CORNER;
#line 844 "../src/editing_tools/CropTool.vala"
			break;
#line 4342 "CropTool.c"
		}
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_BOTTOM_RIGHT:
#line 4346 "CropTool.c"
		{
#line 847 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_BOTTOM_RIGHT_CORNER;
#line 848 "../src/editing_tools/CropTool.vala"
			break;
#line 4352 "CropTool.c"
		}
#line 817 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_INSIDE:
#line 4356 "CropTool.c"
		{
#line 851 "../src/editing_tools/CropTool.vala"
			cursor_type = GDK_FLEUR;
#line 852 "../src/editing_tools/CropTool.vala"
			break;
#line 4362 "CropTool.c"
		}
		default:
		{
#line 856 "../src/editing_tools/CropTool.vala"
			break;
#line 4368 "CropTool.c"
		}
	}
#line 859 "../src/editing_tools/CropTool.vala"
	if (cursor_type != self->priv->current_cursor_type) {
#line 4373 "CropTool.c"
		GdkCursor* cursor = NULL;
		GdkDisplay* _tmp6_;
		GdkCursor* _tmp7_;
		EditingToolsPhotoCanvas* _tmp8_;
		GdkWindow* _tmp9_;
		GdkWindow* _tmp10_;
		GdkCursor* _tmp11_;
#line 860 "../src/editing_tools/CropTool.vala"
		_tmp6_ = gdk_display_get_default ();
#line 860 "../src/editing_tools/CropTool.vala"
		_tmp7_ = gdk_cursor_new_for_display (_tmp6_, cursor_type);
#line 860 "../src/editing_tools/CropTool.vala"
		cursor = _tmp7_;
#line 861 "../src/editing_tools/CropTool.vala"
		_tmp8_ = ((EditingToolsEditingTool*) self)->canvas;
#line 861 "../src/editing_tools/CropTool.vala"
		_tmp9_ = editing_tools_photo_canvas_get_drawing_window (_tmp8_);
#line 861 "../src/editing_tools/CropTool.vala"
		_tmp10_ = _tmp9_;
#line 861 "../src/editing_tools/CropTool.vala"
		_tmp11_ = cursor;
#line 861 "../src/editing_tools/CropTool.vala"
		gdk_window_set_cursor (_tmp10_, _tmp11_);
#line 862 "../src/editing_tools/CropTool.vala"
		self->priv->current_cursor_type = cursor_type;
#line 859 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (cursor);
#line 4401 "CropTool.c"
	}
}

static gint
editing_tools_crop_tool_eval_radial_line (EditingToolsCropTool* self,
                                          gdouble center_x,
                                          gdouble center_y,
                                          gdouble bounds_x,
                                          gdouble bounds_y,
                                          gdouble user_x)
{
	gdouble decision_slope = 0.0;
	gdouble decision_intercept = 0.0;
	gint result;
#line 866 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 868 "../src/editing_tools/CropTool.vala"
	decision_slope = (bounds_y - center_y) / (bounds_x - center_x);
#line 869 "../src/editing_tools/CropTool.vala"
	decision_intercept = bounds_y - (decision_slope * bounds_x);
#line 871 "../src/editing_tools/CropTool.vala"
	result = (gint) ((decision_slope * user_x) + decision_intercept);
#line 871 "../src/editing_tools/CropTool.vala"
	return result;
#line 4426 "CropTool.c"
}

static void
editing_tools_crop_tool_get_photo_dimensions (EditingToolsCropTool* self,
                                              Dimensions* result)
{
	Dimensions photo_dims = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	Photo* _tmp1_;
	Photo* _tmp2_;
	Dimensions _tmp3_ = {0};
	Dimensions surface_dims = {0};
	EditingToolsPhotoCanvas* _tmp4_;
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_;
	gdouble scale_factor = 0.0;
	Dimensions _tmp7_;
	Dimensions _tmp8_;
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	EditingToolsPhotoCanvas* _tmp11_;
	Photo* _tmp12_;
	Photo* _tmp13_;
	Dimensions _tmp14_ = {0};
	Dimensions _tmp15_;
	Dimensions _tmp16_;
	Dimensions _tmp17_ = {0};
#line 875 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 876 "../src/editing_tools/CropTool.vala"
	_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 876 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_photo_canvas_get_photo (_tmp0_);
#line 876 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 876 "../src/editing_tools/CropTool.vala"
	media_source_get_dimensions ((MediaSource*) _tmp2_, PHOTO_EXCEPTION_CROP, &_tmp3_);
#line 876 "../src/editing_tools/CropTool.vala"
	photo_dims = _tmp3_;
#line 877 "../src/editing_tools/CropTool.vala"
	_tmp4_ = ((EditingToolsEditingTool*) self)->canvas;
#line 877 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_surface_dim (_tmp4_, &_tmp5_);
#line 877 "../src/editing_tools/CropTool.vala"
	_tmp6_ = _tmp5_;
#line 877 "../src/editing_tools/CropTool.vala"
	surface_dims = _tmp6_;
#line 878 "../src/editing_tools/CropTool.vala"
	_tmp7_ = surface_dims;
#line 878 "../src/editing_tools/CropTool.vala"
	_tmp8_ = photo_dims;
#line 878 "../src/editing_tools/CropTool.vala"
	_tmp9_ = surface_dims;
#line 878 "../src/editing_tools/CropTool.vala"
	_tmp10_ = photo_dims;
#line 878 "../src/editing_tools/CropTool.vala"
	scale_factor = MIN (((gdouble) _tmp7_.width) / _tmp8_.width, ((gdouble) _tmp9_.height) / _tmp10_.height);
#line 880 "../src/editing_tools/CropTool.vala"
	scale_factor = MIN (scale_factor, 1.0);
#line 882 "../src/editing_tools/CropTool.vala"
	_tmp11_ = ((EditingToolsEditingTool*) self)->canvas;
#line 882 "../src/editing_tools/CropTool.vala"
	_tmp12_ = editing_tools_photo_canvas_get_photo (_tmp11_);
#line 882 "../src/editing_tools/CropTool.vala"
	_tmp13_ = _tmp12_;
#line 882 "../src/editing_tools/CropTool.vala"
	media_source_get_dimensions ((MediaSource*) _tmp13_, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_STRAIGHTEN, &_tmp14_);
#line 882 "../src/editing_tools/CropTool.vala"
	photo_dims = _tmp14_;
#line 885 "../src/editing_tools/CropTool.vala"
	_tmp15_ = photo_dims;
#line 885 "../src/editing_tools/CropTool.vala"
	_tmp16_ = photo_dims;
#line 885 "../src/editing_tools/CropTool.vala"
	_tmp17_.width = (gint) (_tmp15_.width * scale_factor);
#line 885 "../src/editing_tools/CropTool.vala"
	_tmp17_.height = (gint) (_tmp16_.height * scale_factor);
#line 885 "../src/editing_tools/CropTool.vala"
	*result = _tmp17_;
#line 885 "../src/editing_tools/CropTool.vala"
	return;
#line 4508 "CropTool.c"
}

static gboolean
_box_equal (const Box * s1,
            const Box * s2)
{
#line 1172 "../src/editing_tools/CropTool.vala"
	if (s1 == s2) {
#line 1172 "../src/editing_tools/CropTool.vala"
		return TRUE;
#line 4519 "CropTool.c"
	}
#line 1172 "../src/editing_tools/CropTool.vala"
	if (s1 == NULL) {
#line 1172 "../src/editing_tools/CropTool.vala"
		return FALSE;
#line 4525 "CropTool.c"
	}
#line 1172 "../src/editing_tools/CropTool.vala"
	if (s2 == NULL) {
#line 1172 "../src/editing_tools/CropTool.vala"
		return FALSE;
#line 4531 "CropTool.c"
	}
#line 1172 "../src/editing_tools/CropTool.vala"
	if (s1->left != s2->left) {
#line 1172 "../src/editing_tools/CropTool.vala"
		return FALSE;
#line 4537 "CropTool.c"
	}
#line 1172 "../src/editing_tools/CropTool.vala"
	if (s1->top != s2->top) {
#line 1172 "../src/editing_tools/CropTool.vala"
		return FALSE;
#line 4543 "CropTool.c"
	}
#line 1172 "../src/editing_tools/CropTool.vala"
	if (s1->right != s2->right) {
#line 1172 "../src/editing_tools/CropTool.vala"
		return FALSE;
#line 4549 "CropTool.c"
	}
#line 1172 "../src/editing_tools/CropTool.vala"
	if (s1->bottom != s2->bottom) {
#line 1172 "../src/editing_tools/CropTool.vala"
		return FALSE;
#line 4555 "CropTool.c"
	}
#line 1172 "../src/editing_tools/CropTool.vala"
	return TRUE;
#line 4559 "CropTool.c"
}

static gboolean
editing_tools_crop_tool_on_canvas_manipulation (EditingToolsCropTool* self,
                                                gint x,
                                                gint y)
{
	GdkRectangle scaled_pos = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp6_;
	gint left = 0;
	Box _tmp9_;
	gint top = 0;
	Box _tmp10_;
	gint right = 0;
	Box _tmp11_;
	gint bottom = 0;
	Box _tmp12_;
	gint center_x = 0;
	gint center_y = 0;
	gint width = 0;
	gint height = 0;
	Dimensions photo_dims = {0};
	Dimensions _tmp17_ = {0};
	gdouble angle = 0.0;
	EditingToolsPhotoCanvas* _tmp18_;
	Photo* _tmp19_;
	Photo* _tmp20_;
	gdouble _tmp21_ = 0.0;
	Box new_crop = {0};
	Box _tmp37_;
	gboolean result;
#line 890 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 891 "../src/editing_tools/CropTool.vala"
	_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 891 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_get_scaled_position (_tmp0_, &_tmp1_);
#line 891 "../src/editing_tools/CropTool.vala"
	_tmp2_ = _tmp1_;
#line 891 "../src/editing_tools/CropTool.vala"
	scaled_pos = _tmp2_;
#line 895 "../src/editing_tools/CropTool.vala"
	_tmp3_ = scaled_pos;
#line 895 "../src/editing_tools/CropTool.vala"
	x = x - _tmp3_.x;
#line 896 "../src/editing_tools/CropTool.vala"
	if (x < 0) {
#line 897 "../src/editing_tools/CropTool.vala"
		x = 0;
#line 4613 "CropTool.c"
	} else {
		GdkRectangle _tmp4_;
#line 898 "../src/editing_tools/CropTool.vala"
		_tmp4_ = scaled_pos;
#line 898 "../src/editing_tools/CropTool.vala"
		if (x >= _tmp4_.width) {
#line 4620 "CropTool.c"
			GdkRectangle _tmp5_;
#line 899 "../src/editing_tools/CropTool.vala"
			_tmp5_ = scaled_pos;
#line 899 "../src/editing_tools/CropTool.vala"
			x = _tmp5_.width - 1;
#line 4626 "CropTool.c"
		}
	}
#line 902 "../src/editing_tools/CropTool.vala"
	_tmp6_ = scaled_pos;
#line 902 "../src/editing_tools/CropTool.vala"
	y = y - _tmp6_.y;
#line 903 "../src/editing_tools/CropTool.vala"
	if (y < 0) {
#line 904 "../src/editing_tools/CropTool.vala"
		y = 0;
#line 4637 "CropTool.c"
	} else {
		GdkRectangle _tmp7_;
#line 905 "../src/editing_tools/CropTool.vala"
		_tmp7_ = scaled_pos;
#line 905 "../src/editing_tools/CropTool.vala"
		if (y >= _tmp7_.height) {
#line 4644 "CropTool.c"
			GdkRectangle _tmp8_;
#line 906 "../src/editing_tools/CropTool.vala"
			_tmp8_ = scaled_pos;
#line 906 "../src/editing_tools/CropTool.vala"
			y = _tmp8_.height - 1;
#line 4650 "CropTool.c"
		}
	}
#line 911 "../src/editing_tools/CropTool.vala"
	_tmp9_ = self->priv->scaled_crop;
#line 911 "../src/editing_tools/CropTool.vala"
	left = _tmp9_.left;
#line 912 "../src/editing_tools/CropTool.vala"
	_tmp10_ = self->priv->scaled_crop;
#line 912 "../src/editing_tools/CropTool.vala"
	top = _tmp10_.top;
#line 913 "../src/editing_tools/CropTool.vala"
	_tmp11_ = self->priv->scaled_crop;
#line 913 "../src/editing_tools/CropTool.vala"
	right = _tmp11_.right;
#line 914 "../src/editing_tools/CropTool.vala"
	_tmp12_ = self->priv->scaled_crop;
#line 914 "../src/editing_tools/CropTool.vala"
	bottom = _tmp12_.bottom;
#line 917 "../src/editing_tools/CropTool.vala"
	center_x = (left + right) / 2;
#line 918 "../src/editing_tools/CropTool.vala"
	center_y = (top + bottom) / 2;
#line 920 "../src/editing_tools/CropTool.vala"
	switch (self->priv->in_manipulation) {
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_LEFT_SIDE:
#line 4677 "CropTool.c"
		{
#line 922 "../src/editing_tools/CropTool.vala"
			left = x;
#line 923 "../src/editing_tools/CropTool.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 4683 "CropTool.c"
				gfloat new_height = 0.0F;
#line 924 "../src/editing_tools/CropTool.vala"
				new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 925 "../src/editing_tools/CropTool.vala"
				bottom = top + ((gint) new_height);
#line 4689 "CropTool.c"
			}
#line 928 "../src/editing_tools/CropTool.vala"
			break;
#line 4693 "CropTool.c"
		}
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_TOP_SIDE:
#line 4697 "CropTool.c"
		{
#line 931 "../src/editing_tools/CropTool.vala"
			top = y;
#line 932 "../src/editing_tools/CropTool.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 4703 "CropTool.c"
				gfloat new_width = 0.0F;
#line 933 "../src/editing_tools/CropTool.vala"
				new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 934 "../src/editing_tools/CropTool.vala"
				right = left + ((gint) new_width);
#line 4709 "CropTool.c"
			}
#line 937 "../src/editing_tools/CropTool.vala"
			break;
#line 4713 "CropTool.c"
		}
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_RIGHT_SIDE:
#line 4717 "CropTool.c"
		{
#line 940 "../src/editing_tools/CropTool.vala"
			right = x;
#line 941 "../src/editing_tools/CropTool.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 4723 "CropTool.c"
				gfloat new_height = 0.0F;
#line 942 "../src/editing_tools/CropTool.vala"
				new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 943 "../src/editing_tools/CropTool.vala"
				bottom = top + ((gint) new_height);
#line 4729 "CropTool.c"
			}
#line 946 "../src/editing_tools/CropTool.vala"
			break;
#line 4733 "CropTool.c"
		}
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_BOTTOM_SIDE:
#line 4737 "CropTool.c"
		{
#line 949 "../src/editing_tools/CropTool.vala"
			bottom = y;
#line 950 "../src/editing_tools/CropTool.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 4743 "CropTool.c"
				gfloat new_width = 0.0F;
#line 951 "../src/editing_tools/CropTool.vala"
				new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 952 "../src/editing_tools/CropTool.vala"
				right = left + ((gint) new_width);
#line 4749 "CropTool.c"
			}
#line 955 "../src/editing_tools/CropTool.vala"
			break;
#line 4753 "CropTool.c"
		}
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_TOP_LEFT:
#line 4757 "CropTool.c"
		{
#line 958 "../src/editing_tools/CropTool.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 959 "../src/editing_tools/CropTool.vala"
				top = y;
#line 960 "../src/editing_tools/CropTool.vala"
				left = x;
#line 4765 "CropTool.c"
			} else {
#line 962 "../src/editing_tools/CropTool.vala"
				if (y < editing_tools_crop_tool_eval_radial_line (self, (gdouble) center_x, (gdouble) center_y, (gdouble) left, (gdouble) top, (gdouble) x)) {
#line 4769 "CropTool.c"
					gfloat new_width = 0.0F;
#line 963 "../src/editing_tools/CropTool.vala"
					top = y;
#line 964 "../src/editing_tools/CropTool.vala"
					new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 965 "../src/editing_tools/CropTool.vala"
					left = right - ((gint) new_width);
#line 4777 "CropTool.c"
				} else {
					gfloat new_height = 0.0F;
#line 967 "../src/editing_tools/CropTool.vala"
					left = x;
#line 968 "../src/editing_tools/CropTool.vala"
					new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 969 "../src/editing_tools/CropTool.vala"
					top = bottom - ((gint) new_height);
#line 4786 "CropTool.c"
				}
			}
#line 973 "../src/editing_tools/CropTool.vala"
			break;
#line 4791 "CropTool.c"
		}
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_BOTTOM_LEFT:
#line 4795 "CropTool.c"
		{
#line 976 "../src/editing_tools/CropTool.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 977 "../src/editing_tools/CropTool.vala"
				bottom = y;
#line 978 "../src/editing_tools/CropTool.vala"
				left = x;
#line 4803 "CropTool.c"
			} else {
#line 980 "../src/editing_tools/CropTool.vala"
				if (y < editing_tools_crop_tool_eval_radial_line (self, (gdouble) center_x, (gdouble) center_y, (gdouble) left, (gdouble) bottom, (gdouble) x)) {
#line 4807 "CropTool.c"
					gfloat new_height = 0.0F;
#line 981 "../src/editing_tools/CropTool.vala"
					left = x;
#line 982 "../src/editing_tools/CropTool.vala"
					new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 983 "../src/editing_tools/CropTool.vala"
					bottom = top + ((gint) new_height);
#line 4815 "CropTool.c"
				} else {
					gfloat new_width = 0.0F;
#line 985 "../src/editing_tools/CropTool.vala"
					bottom = y;
#line 986 "../src/editing_tools/CropTool.vala"
					new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 987 "../src/editing_tools/CropTool.vala"
					left = right - ((gint) new_width);
#line 4824 "CropTool.c"
				}
			}
#line 991 "../src/editing_tools/CropTool.vala"
			break;
#line 4829 "CropTool.c"
		}
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_TOP_RIGHT:
#line 4833 "CropTool.c"
		{
#line 994 "../src/editing_tools/CropTool.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 995 "../src/editing_tools/CropTool.vala"
				top = y;
#line 996 "../src/editing_tools/CropTool.vala"
				right = x;
#line 4841 "CropTool.c"
			} else {
#line 998 "../src/editing_tools/CropTool.vala"
				if (y < editing_tools_crop_tool_eval_radial_line (self, (gdouble) center_x, (gdouble) center_y, (gdouble) right, (gdouble) top, (gdouble) x)) {
#line 4845 "CropTool.c"
					gfloat new_width = 0.0F;
#line 999 "../src/editing_tools/CropTool.vala"
					top = y;
#line 1000 "../src/editing_tools/CropTool.vala"
					new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1001 "../src/editing_tools/CropTool.vala"
					right = left + ((gint) new_width);
#line 4853 "CropTool.c"
				} else {
					gfloat new_height = 0.0F;
#line 1003 "../src/editing_tools/CropTool.vala"
					right = x;
#line 1004 "../src/editing_tools/CropTool.vala"
					new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1005 "../src/editing_tools/CropTool.vala"
					top = bottom - ((gint) new_height);
#line 4862 "CropTool.c"
				}
			}
#line 1009 "../src/editing_tools/CropTool.vala"
			break;
#line 4867 "CropTool.c"
		}
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_BOTTOM_RIGHT:
#line 4871 "CropTool.c"
		{
#line 1012 "../src/editing_tools/CropTool.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 1013 "../src/editing_tools/CropTool.vala"
				bottom = y;
#line 1014 "../src/editing_tools/CropTool.vala"
				right = x;
#line 4879 "CropTool.c"
			} else {
#line 1016 "../src/editing_tools/CropTool.vala"
				if (y < editing_tools_crop_tool_eval_radial_line (self, (gdouble) center_x, (gdouble) center_y, (gdouble) right, (gdouble) bottom, (gdouble) x)) {
#line 4883 "CropTool.c"
					gfloat new_height = 0.0F;
#line 1017 "../src/editing_tools/CropTool.vala"
					right = x;
#line 1018 "../src/editing_tools/CropTool.vala"
					new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1019 "../src/editing_tools/CropTool.vala"
					bottom = top + ((gint) new_height);
#line 4891 "CropTool.c"
				} else {
					gfloat new_width = 0.0F;
#line 1021 "../src/editing_tools/CropTool.vala"
					bottom = y;
#line 1022 "../src/editing_tools/CropTool.vala"
					new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1023 "../src/editing_tools/CropTool.vala"
					right = left + ((gint) new_width);
#line 4900 "CropTool.c"
				}
			}
#line 1027 "../src/editing_tools/CropTool.vala"
			break;
#line 4905 "CropTool.c"
		}
#line 920 "../src/editing_tools/CropTool.vala"
		case BOX_LOCATION_INSIDE:
#line 4909 "CropTool.c"
		{
			gint delta_x = 0;
			gint delta_y = 0;
			gint width = 0;
			gint height = 0;
			GdkRectangle _tmp13_;
			GdkRectangle _tmp15_;
			gint adj_width = 0;
			gint adj_height = 0;
#line 1030 "../src/editing_tools/CropTool.vala"
			_vala_assert (self->priv->last_grab_x >= 0, "last_grab_x >= 0");
#line 1031 "../src/editing_tools/CropTool.vala"
			_vala_assert (self->priv->last_grab_y >= 0, "last_grab_y >= 0");
#line 1033 "../src/editing_tools/CropTool.vala"
			delta_x = x - self->priv->last_grab_x;
#line 1034 "../src/editing_tools/CropTool.vala"
			delta_y = y - self->priv->last_grab_y;
#line 1036 "../src/editing_tools/CropTool.vala"
			self->priv->last_grab_x = x;
#line 1037 "../src/editing_tools/CropTool.vala"
			self->priv->last_grab_y = y;
#line 1039 "../src/editing_tools/CropTool.vala"
			width = (right - left) + 1;
#line 1040 "../src/editing_tools/CropTool.vala"
			height = (bottom - top) + 1;
#line 1042 "../src/editing_tools/CropTool.vala"
			left += delta_x;
#line 1043 "../src/editing_tools/CropTool.vala"
			top += delta_y;
#line 1044 "../src/editing_tools/CropTool.vala"
			right += delta_x;
#line 1045 "../src/editing_tools/CropTool.vala"
			bottom += delta_y;
#line 1048 "../src/editing_tools/CropTool.vala"
			if (left < 0) {
#line 1049 "../src/editing_tools/CropTool.vala"
				left = 0;
#line 4947 "CropTool.c"
			}
#line 1052 "../src/editing_tools/CropTool.vala"
			if (top < 0) {
#line 1053 "../src/editing_tools/CropTool.vala"
				top = 0;
#line 4953 "CropTool.c"
			}
#line 1056 "../src/editing_tools/CropTool.vala"
			_tmp13_ = scaled_pos;
#line 1056 "../src/editing_tools/CropTool.vala"
			if (right >= _tmp13_.width) {
#line 4959 "CropTool.c"
				GdkRectangle _tmp14_;
#line 1057 "../src/editing_tools/CropTool.vala"
				_tmp14_ = scaled_pos;
#line 1057 "../src/editing_tools/CropTool.vala"
				right = _tmp14_.width - 1;
#line 4965 "CropTool.c"
			}
#line 1060 "../src/editing_tools/CropTool.vala"
			_tmp15_ = scaled_pos;
#line 1060 "../src/editing_tools/CropTool.vala"
			if (bottom >= _tmp15_.height) {
#line 4971 "CropTool.c"
				GdkRectangle _tmp16_;
#line 1061 "../src/editing_tools/CropTool.vala"
				_tmp16_ = scaled_pos;
#line 1061 "../src/editing_tools/CropTool.vala"
				bottom = _tmp16_.height - 1;
#line 4977 "CropTool.c"
			}
#line 1064 "../src/editing_tools/CropTool.vala"
			adj_width = (right - left) + 1;
#line 1065 "../src/editing_tools/CropTool.vala"
			adj_height = (bottom - top) + 1;
#line 1068 "../src/editing_tools/CropTool.vala"
			if (adj_width != width) {
#line 1069 "../src/editing_tools/CropTool.vala"
				if (delta_x < 0) {
#line 1070 "../src/editing_tools/CropTool.vala"
					right = (left + width) - 1;
#line 4989 "CropTool.c"
				} else {
#line 1072 "../src/editing_tools/CropTool.vala"
					left = (right - width) + 1;
#line 4993 "CropTool.c"
				}
			}
#line 1076 "../src/editing_tools/CropTool.vala"
			if (adj_height != height) {
#line 1077 "../src/editing_tools/CropTool.vala"
				if (delta_y < 0) {
#line 1078 "../src/editing_tools/CropTool.vala"
					bottom = (top + height) - 1;
#line 5002 "CropTool.c"
				} else {
#line 1080 "../src/editing_tools/CropTool.vala"
					top = (bottom - height) + 1;
#line 5006 "CropTool.c"
				}
			}
#line 1084 "../src/editing_tools/CropTool.vala"
			break;
#line 5011 "CropTool.c"
		}
		default:
		{
#line 1088 "../src/editing_tools/CropTool.vala"
			result = FALSE;
#line 1088 "../src/editing_tools/CropTool.vala"
			return result;
#line 5019 "CropTool.c"
		}
	}
#line 1098 "../src/editing_tools/CropTool.vala"
	width = (right - left) + 1;
#line 1099 "../src/editing_tools/CropTool.vala"
	height = (bottom - top) + 1;
#line 1101 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_get_photo_dimensions (self, &_tmp17_);
#line 1101 "../src/editing_tools/CropTool.vala"
	photo_dims = _tmp17_;
#line 1103 "../src/editing_tools/CropTool.vala"
	_tmp18_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1103 "../src/editing_tools/CropTool.vala"
	_tmp19_ = editing_tools_photo_canvas_get_photo (_tmp18_);
#line 1103 "../src/editing_tools/CropTool.vala"
	_tmp20_ = _tmp19_;
#line 1103 "../src/editing_tools/CropTool.vala"
	photo_get_straighten (_tmp20_, &_tmp21_);
#line 1103 "../src/editing_tools/CropTool.vala"
	angle = _tmp21_;
#line 1106 "../src/editing_tools/CropTool.vala"
	if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 5042 "CropTool.c"
		Box _tmp22_ = {0};
		Dimensions _tmp23_;
		Dimensions _tmp24_;
		Box _tmp25_ = {0};
#line 1107 "../src/editing_tools/CropTool.vala"
		width = (right - left) + 1;
#line 1108 "../src/editing_tools/CropTool.vala"
		height = (bottom - top) + 1;
#line 1110 "../src/editing_tools/CropTool.vala"
		switch (self->priv->in_manipulation) {
#line 1110 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_LEFT_SIDE:
#line 1110 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_TOP_LEFT:
#line 1110 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_BOTTOM_LEFT:
#line 5059 "CropTool.c"
			{
#line 1114 "../src/editing_tools/CropTool.vala"
				if (width < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 1115 "../src/editing_tools/CropTool.vala"
					left = right - EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 5065 "CropTool.c"
				}
#line 1118 "../src/editing_tools/CropTool.vala"
				break;
#line 5069 "CropTool.c"
			}
#line 1110 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_RIGHT_SIDE:
#line 1110 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_TOP_RIGHT:
#line 1110 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_BOTTOM_RIGHT:
#line 5077 "CropTool.c"
			{
#line 1123 "../src/editing_tools/CropTool.vala"
				if (width < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 1124 "../src/editing_tools/CropTool.vala"
					right = left + EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 5083 "CropTool.c"
				}
#line 1127 "../src/editing_tools/CropTool.vala"
				break;
#line 5087 "CropTool.c"
			}
			default:
			{
#line 1129 "../src/editing_tools/CropTool.vala"
				break;
#line 5093 "CropTool.c"
			}
		}
#line 1132 "../src/editing_tools/CropTool.vala"
		switch (self->priv->in_manipulation) {
#line 1132 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_TOP_SIDE:
#line 1132 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_TOP_LEFT:
#line 1132 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_TOP_RIGHT:
#line 5104 "CropTool.c"
			{
#line 1136 "../src/editing_tools/CropTool.vala"
				if (height < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 1137 "../src/editing_tools/CropTool.vala"
					top = bottom - EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 5110 "CropTool.c"
				}
#line 1140 "../src/editing_tools/CropTool.vala"
				break;
#line 5114 "CropTool.c"
			}
#line 1132 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_BOTTOM_SIDE:
#line 1132 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_BOTTOM_LEFT:
#line 1132 "../src/editing_tools/CropTool.vala"
			case BOX_LOCATION_BOTTOM_RIGHT:
#line 5122 "CropTool.c"
			{
#line 1145 "../src/editing_tools/CropTool.vala"
				if (height < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 1146 "../src/editing_tools/CropTool.vala"
					bottom = top + EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 5128 "CropTool.c"
				}
#line 1149 "../src/editing_tools/CropTool.vala"
				break;
#line 5132 "CropTool.c"
			}
			default:
			{
#line 1152 "../src/editing_tools/CropTool.vala"
				break;
#line 5138 "CropTool.c"
			}
		}
#line 1158 "../src/editing_tools/CropTool.vala"
		box_init (&_tmp22_, left, top, right, bottom);
#line 1158 "../src/editing_tools/CropTool.vala"
		_tmp23_ = photo_dims;
#line 1158 "../src/editing_tools/CropTool.vala"
		_tmp24_ = photo_dims;
#line 1158 "../src/editing_tools/CropTool.vala"
		clamp_inside_rotated_image (&_tmp22_, _tmp23_.width, _tmp24_.height, angle, self->priv->in_manipulation == BOX_LOCATION_INSIDE, &_tmp25_);
#line 1158 "../src/editing_tools/CropTool.vala"
		new_crop = _tmp25_;
#line 5151 "CropTool.c"
	} else {
		Box adjusted = {0};
		Box _tmp26_;
		Dimensions _tmp27_;
		Dimensions _tmp28_;
		Box _tmp29_ = {0};
		gboolean _tmp30_ = FALSE;
		gboolean _tmp31_ = FALSE;
		Box _tmp32_;
		Box _tmp33_;
#line 1167 "../src/editing_tools/CropTool.vala"
		box_init (&new_crop, left, top, right, bottom);
#line 1168 "../src/editing_tools/CropTool.vala"
		_tmp26_ = new_crop;
#line 1168 "../src/editing_tools/CropTool.vala"
		_tmp27_ = photo_dims;
#line 1168 "../src/editing_tools/CropTool.vala"
		_tmp28_ = photo_dims;
#line 1168 "../src/editing_tools/CropTool.vala"
		clamp_inside_rotated_image (&_tmp26_, _tmp27_.width, _tmp28_.height, angle, self->priv->in_manipulation == BOX_LOCATION_INSIDE, &_tmp29_);
#line 1168 "../src/editing_tools/CropTool.vala"
		adjusted = _tmp29_;
#line 1172 "../src/editing_tools/CropTool.vala"
		_tmp32_ = adjusted;
#line 1172 "../src/editing_tools/CropTool.vala"
		_tmp33_ = new_crop;
#line 1172 "../src/editing_tools/CropTool.vala"
		if (_box_equal (&_tmp32_, &_tmp33_) != TRUE) {
#line 1172 "../src/editing_tools/CropTool.vala"
			_tmp31_ = TRUE;
#line 5182 "CropTool.c"
		} else {
#line 1172 "../src/editing_tools/CropTool.vala"
			_tmp31_ = width < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 5186 "CropTool.c"
		}
#line 1172 "../src/editing_tools/CropTool.vala"
		if (_tmp31_) {
#line 1172 "../src/editing_tools/CropTool.vala"
			_tmp30_ = TRUE;
#line 5192 "CropTool.c"
		} else {
#line 1172 "../src/editing_tools/CropTool.vala"
			_tmp30_ = height < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 5196 "CropTool.c"
		}
#line 1172 "../src/editing_tools/CropTool.vala"
		if (_tmp30_) {
#line 5200 "CropTool.c"
			Box _tmp34_;
#line 1173 "../src/editing_tools/CropTool.vala"
			_tmp34_ = self->priv->scaled_crop;
#line 1173 "../src/editing_tools/CropTool.vala"
			new_crop = _tmp34_;
#line 5206 "CropTool.c"
		}
	}
#line 1177 "../src/editing_tools/CropTool.vala"
	if (self->priv->in_manipulation != BOX_LOCATION_INSIDE) {
#line 5211 "CropTool.c"
		Box _tmp35_;
#line 1178 "../src/editing_tools/CropTool.vala"
		_tmp35_ = new_crop;
#line 1178 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_resized (self, &_tmp35_);
#line 5217 "CropTool.c"
	} else {
		Box _tmp36_;
#line 1180 "../src/editing_tools/CropTool.vala"
		_tmp36_ = new_crop;
#line 1180 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_moved (self, &_tmp36_);
#line 5224 "CropTool.c"
	}
#line 1184 "../src/editing_tools/CropTool.vala"
	_tmp37_ = new_crop;
#line 1184 "../src/editing_tools/CropTool.vala"
	self->priv->scaled_crop = _tmp37_;
#line 1186 "../src/editing_tools/CropTool.vala"
	if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 1187 "../src/editing_tools/CropTool.vala"
		self->priv->custom_init_width = box_get_width (&self->priv->scaled_crop);
#line 1188 "../src/editing_tools/CropTool.vala"
		self->priv->custom_init_height = box_get_height (&self->priv->scaled_crop);
#line 1189 "../src/editing_tools/CropTool.vala"
		self->priv->custom_aspect_ratio = ((gfloat) self->priv->custom_init_width) / ((gfloat) self->priv->custom_init_height);
#line 5238 "CropTool.c"
	}
#line 1192 "../src/editing_tools/CropTool.vala"
	result = FALSE;
#line 1192 "../src/editing_tools/CropTool.vala"
	return result;
#line 5244 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_resized (EditingToolsCropTool* self,
                                      Box* new_crop)
{
	Box _tmp0_;
	EditingToolsPhotoCanvas* _tmp1_;
	Box _tmp2_;
	Box horizontal = {0};
	gboolean horizontal_enlarged = FALSE;
	Box vertical = {0};
	gboolean vertical_enlarged = FALSE;
	BoxComplements complements = 0;
	Box _tmp3_;
	Box _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	Box _tmp6_ = {0};
	gboolean _tmp7_ = FALSE;
	BoxComplements _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp12_ = FALSE;
	Box _tmp15_;
	EditingToolsPhotoCanvas* _tmp16_;
	Box _tmp17_;
#line 1195 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 1195 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (new_crop != NULL);
#line 1196 "../src/editing_tools/CropTool.vala"
	_tmp0_ = *new_crop;
#line 1196 "../src/editing_tools/CropTool.vala"
	if (box_equals (&self->priv->scaled_crop, &_tmp0_)) {
#line 1198 "../src/editing_tools/CropTool.vala"
		return;
#line 5280 "CropTool.c"
	}
#line 1201 "../src/editing_tools/CropTool.vala"
	_tmp1_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1201 "../src/editing_tools/CropTool.vala"
	_tmp2_ = self->priv->scaled_crop;
#line 1201 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp1_, &_tmp2_);
#line 1207 "../src/editing_tools/CropTool.vala"
	_tmp3_ = *new_crop;
#line 1207 "../src/editing_tools/CropTool.vala"
	_tmp8_ = box_resized_complements (&self->priv->scaled_crop, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 1207 "../src/editing_tools/CropTool.vala"
	horizontal = _tmp4_;
#line 1207 "../src/editing_tools/CropTool.vala"
	horizontal_enlarged = _tmp5_;
#line 1207 "../src/editing_tools/CropTool.vala"
	vertical = _tmp6_;
#line 1207 "../src/editing_tools/CropTool.vala"
	vertical_enlarged = _tmp7_;
#line 1207 "../src/editing_tools/CropTool.vala"
	complements = _tmp8_;
#line 1211 "../src/editing_tools/CropTool.vala"
	_vala_assert (complements != BOX_COMPLEMENTS_NONE, "complements != BoxComplements.NONE");
#line 1213 "../src/editing_tools/CropTool.vala"
	if (complements == BOX_COMPLEMENTS_HORIZONTAL) {
#line 1213 "../src/editing_tools/CropTool.vala"
		_tmp9_ = TRUE;
#line 5308 "CropTool.c"
	} else {
#line 1213 "../src/editing_tools/CropTool.vala"
		_tmp9_ = complements == BOX_COMPLEMENTS_BOTH;
#line 5312 "CropTool.c"
	}
#line 1213 "../src/editing_tools/CropTool.vala"
	if (_tmp9_) {
#line 5316 "CropTool.c"
		gdouble _tmp10_ = 0.0;
		Box _tmp11_;
#line 1214 "../src/editing_tools/CropTool.vala"
		if (horizontal_enlarged) {
#line 1214 "../src/editing_tools/CropTool.vala"
			_tmp10_ = 0.0;
#line 5323 "CropTool.c"
		} else {
#line 1214 "../src/editing_tools/CropTool.vala"
			_tmp10_ = 0.5;
#line 5327 "CropTool.c"
		}
#line 1214 "../src/editing_tools/CropTool.vala"
		_tmp11_ = horizontal;
#line 1214 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_set_area_alpha (self, &_tmp11_, _tmp10_);
#line 5333 "CropTool.c"
	}
#line 1217 "../src/editing_tools/CropTool.vala"
	if (complements == BOX_COMPLEMENTS_VERTICAL) {
#line 1217 "../src/editing_tools/CropTool.vala"
		_tmp12_ = TRUE;
#line 5339 "CropTool.c"
	} else {
#line 1217 "../src/editing_tools/CropTool.vala"
		_tmp12_ = complements == BOX_COMPLEMENTS_BOTH;
#line 5343 "CropTool.c"
	}
#line 1217 "../src/editing_tools/CropTool.vala"
	if (_tmp12_) {
#line 5347 "CropTool.c"
		gdouble _tmp13_ = 0.0;
		Box _tmp14_;
#line 1218 "../src/editing_tools/CropTool.vala"
		if (vertical_enlarged) {
#line 1218 "../src/editing_tools/CropTool.vala"
			_tmp13_ = 0.0;
#line 5354 "CropTool.c"
		} else {
#line 1218 "../src/editing_tools/CropTool.vala"
			_tmp13_ = 0.5;
#line 5358 "CropTool.c"
		}
#line 1218 "../src/editing_tools/CropTool.vala"
		_tmp14_ = vertical;
#line 1218 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_set_area_alpha (self, &_tmp14_, _tmp13_);
#line 5364 "CropTool.c"
	}
#line 1221 "../src/editing_tools/CropTool.vala"
	_tmp15_ = *new_crop;
#line 1221 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_paint_crop_tool (self, &_tmp15_);
#line 1222 "../src/editing_tools/CropTool.vala"
	_tmp16_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1222 "../src/editing_tools/CropTool.vala"
	_tmp17_ = *new_crop;
#line 1222 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp16_, &_tmp17_);
#line 5376 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_moved (EditingToolsCropTool* self,
                                    Box* new_crop)
{
	Box _tmp0_;
	EditingToolsPhotoCanvas* _tmp1_;
	Box _tmp2_;
	Box _tmp3_;
	Box _tmp4_;
	Box _tmp5_;
	EditingToolsPhotoCanvas* _tmp6_;
	Box _tmp7_;
#line 1225 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 1225 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (new_crop != NULL);
#line 1226 "../src/editing_tools/CropTool.vala"
	_tmp0_ = *new_crop;
#line 1226 "../src/editing_tools/CropTool.vala"
	if (box_equals (&self->priv->scaled_crop, &_tmp0_)) {
#line 1228 "../src/editing_tools/CropTool.vala"
		return;
#line 5401 "CropTool.c"
	}
#line 1231 "../src/editing_tools/CropTool.vala"
	_tmp1_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1231 "../src/editing_tools/CropTool.vala"
	_tmp2_ = self->priv->scaled_crop;
#line 1231 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp1_, &_tmp2_);
#line 1233 "../src/editing_tools/CropTool.vala"
	_tmp3_ = self->priv->scaled_crop;
#line 1233 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_set_area_alpha (self, &_tmp3_, 0.5);
#line 1234 "../src/editing_tools/CropTool.vala"
	_tmp4_ = *new_crop;
#line 1234 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_set_area_alpha (self, &_tmp4_, 0.0);
#line 1238 "../src/editing_tools/CropTool.vala"
	_tmp5_ = *new_crop;
#line 1238 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_paint_crop_tool (self, &_tmp5_);
#line 1239 "../src/editing_tools/CropTool.vala"
	_tmp6_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1239 "../src/editing_tools/CropTool.vala"
	_tmp7_ = *new_crop;
#line 1239 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp6_, &_tmp7_);
#line 5427 "CropTool.c"
}

static void
editing_tools_crop_tool_set_area_alpha (EditingToolsCropTool* self,
                                        Box* area,
                                        gdouble alpha)
{
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	Box _tmp2_;
	Box _tmp3_;
	EditingToolsPhotoCanvas* _tmp4_;
	cairo_surface_t* _tmp5_;
	Box _tmp6_;
#line 1242 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 1242 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (area != NULL);
#line 1243 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->crop_surface;
#line 1243 "../src/editing_tools/CropTool.vala"
	_tmp1_ = cairo_create (_tmp0_);
#line 1243 "../src/editing_tools/CropTool.vala"
	ctx = _tmp1_;
#line 1244 "../src/editing_tools/CropTool.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
#line 1245 "../src/editing_tools/CropTool.vala"
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, alpha);
#line 1246 "../src/editing_tools/CropTool.vala"
	_tmp2_ = *area;
#line 1246 "../src/editing_tools/CropTool.vala"
	_tmp3_ = *area;
#line 1246 "../src/editing_tools/CropTool.vala"
	cairo_rectangle (ctx, (gdouble) _tmp2_.left, (gdouble) _tmp3_.top, (gdouble) box_get_width (area), (gdouble) box_get_height (area));
#line 1247 "../src/editing_tools/CropTool.vala"
	cairo_fill (ctx);
#line 1248 "../src/editing_tools/CropTool.vala"
	_tmp4_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1248 "../src/editing_tools/CropTool.vala"
	_tmp5_ = self->priv->crop_surface;
#line 1248 "../src/editing_tools/CropTool.vala"
	_tmp6_ = *area;
#line 1248 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_paint_surface_area (_tmp4_, _tmp5_, &_tmp6_, TRUE);
#line 1242 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (ctx);
#line 5475 "CropTool.c"
}

static void
editing_tools_crop_tool_paint_crop_tool (EditingToolsCropTool* self,
                                         Box* crop)
{
	EditingToolsPhotoCanvas* _tmp38_;
	cairo_t* _tmp39_;
	Box _tmp40_;
	EditingToolsPhotoCanvas* _tmp41_;
	cairo_t* _tmp42_;
	Box _tmp43_ = {0};
	EditingToolsPhotoCanvas* _tmp44_;
	cairo_t* _tmp45_;
	Box _tmp46_ = {0};
#line 1251 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 1251 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (crop != NULL);
#line 1253 "../src/editing_tools/CropTool.vala"
	if (self->priv->in_manipulation != BOX_LOCATION_OUTSIDE) {
#line 5497 "CropTool.c"
		gint one_third_x = 0;
		gint one_third_y = 0;
		EditingToolsPhotoCanvas* _tmp0_;
		cairo_t* _tmp1_;
		Box _tmp2_;
		Box _tmp3_;
		EditingToolsPhotoCanvas* _tmp4_;
		cairo_t* _tmp5_;
		Box _tmp6_;
		Box _tmp7_;
		EditingToolsPhotoCanvas* _tmp8_;
		cairo_t* _tmp9_;
		Box _tmp10_;
		Box _tmp11_;
		EditingToolsPhotoCanvas* _tmp12_;
		cairo_t* _tmp13_;
		Box _tmp14_;
		Box _tmp15_;
		Box adj_crop = {0};
		EditingToolsPhotoCanvas* _tmp16_;
		GdkRectangle _tmp17_ = {0};
		GdkRectangle _tmp18_;
		Dimensions _tmp19_ = {0};
		EditingToolsPhotoCanvas* _tmp20_;
		Photo* _tmp21_;
		Photo* _tmp22_;
		Dimensions _tmp23_ = {0};
		Box _tmp24_ = {0};
		gchar* text = NULL;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gint x = 0;
		Box _tmp33_;
		gint y = 0;
		Box _tmp34_;
		EditingToolsPhotoCanvas* _tmp35_;
		cairo_t* _tmp36_;
		const gchar* _tmp37_;
#line 1254 "../src/editing_tools/CropTool.vala"
		one_third_x = box_get_width (crop) / 3;
#line 1255 "../src/editing_tools/CropTool.vala"
		one_third_y = box_get_height (crop) / 3;
#line 1257 "../src/editing_tools/CropTool.vala"
		_tmp0_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1257 "../src/editing_tools/CropTool.vala"
		_tmp1_ = self->priv->thin_white_ctx;
#line 1257 "../src/editing_tools/CropTool.vala"
		_tmp2_ = *crop;
#line 1257 "../src/editing_tools/CropTool.vala"
		_tmp3_ = *crop;
#line 1257 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_draw_horizontal_line (_tmp0_, _tmp1_, _tmp2_.left, _tmp3_.top + one_third_y, box_get_width (crop), TRUE);
#line 1258 "../src/editing_tools/CropTool.vala"
		_tmp4_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1258 "../src/editing_tools/CropTool.vala"
		_tmp5_ = self->priv->thin_white_ctx;
#line 1258 "../src/editing_tools/CropTool.vala"
		_tmp6_ = *crop;
#line 1258 "../src/editing_tools/CropTool.vala"
		_tmp7_ = *crop;
#line 1258 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_draw_horizontal_line (_tmp4_, _tmp5_, _tmp6_.left, _tmp7_.top + (one_third_y * 2), box_get_width (crop), TRUE);
#line 1260 "../src/editing_tools/CropTool.vala"
		_tmp8_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1260 "../src/editing_tools/CropTool.vala"
		_tmp9_ = self->priv->thin_white_ctx;
#line 1260 "../src/editing_tools/CropTool.vala"
		_tmp10_ = *crop;
#line 1260 "../src/editing_tools/CropTool.vala"
		_tmp11_ = *crop;
#line 1260 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_draw_vertical_line (_tmp8_, _tmp9_, _tmp10_.left + one_third_x, _tmp11_.top, box_get_height (crop), TRUE);
#line 1261 "../src/editing_tools/CropTool.vala"
		_tmp12_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1261 "../src/editing_tools/CropTool.vala"
		_tmp13_ = self->priv->thin_white_ctx;
#line 1261 "../src/editing_tools/CropTool.vala"
		_tmp14_ = *crop;
#line 1261 "../src/editing_tools/CropTool.vala"
		_tmp15_ = *crop;
#line 1261 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_draw_vertical_line (_tmp12_, _tmp13_, _tmp14_.left + (one_third_x * 2), _tmp15_.top, box_get_height (crop), TRUE);
#line 1265 "../src/editing_tools/CropTool.vala"
		_tmp16_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1265 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_get_scaled_position (_tmp16_, &_tmp17_);
#line 1265 "../src/editing_tools/CropTool.vala"
		_tmp18_ = _tmp17_;
#line 1265 "../src/editing_tools/CropTool.vala"
		dimensions_for_rectangle (&_tmp18_, &_tmp19_);
#line 1265 "../src/editing_tools/CropTool.vala"
		_tmp20_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1265 "../src/editing_tools/CropTool.vala"
		_tmp21_ = editing_tools_photo_canvas_get_photo (_tmp20_);
#line 1265 "../src/editing_tools/CropTool.vala"
		_tmp22_ = _tmp21_;
#line 1265 "../src/editing_tools/CropTool.vala"
		media_source_get_dimensions ((MediaSource*) _tmp22_, PHOTO_EXCEPTION_CROP, &_tmp23_);
#line 1265 "../src/editing_tools/CropTool.vala"
		box_get_scaled_similar (&self->priv->scaled_crop, &_tmp19_, &_tmp23_, &_tmp24_);
#line 1265 "../src/editing_tools/CropTool.vala"
		adj_crop = _tmp24_;
#line 1268 "../src/editing_tools/CropTool.vala"
		_tmp25_ = g_strdup_printf ("%i", box_get_width (&adj_crop));
#line 1268 "../src/editing_tools/CropTool.vala"
		_tmp26_ = _tmp25_;
#line 1268 "../src/editing_tools/CropTool.vala"
		_tmp27_ = g_strconcat (_tmp26_, "x", NULL);
#line 1268 "../src/editing_tools/CropTool.vala"
		_tmp28_ = _tmp27_;
#line 1268 "../src/editing_tools/CropTool.vala"
		_tmp29_ = g_strdup_printf ("%i", box_get_height (&adj_crop));
#line 1268 "../src/editing_tools/CropTool.vala"
		_tmp30_ = _tmp29_;
#line 1268 "../src/editing_tools/CropTool.vala"
		_tmp31_ = g_strconcat (_tmp28_, _tmp30_, NULL);
#line 1268 "../src/editing_tools/CropTool.vala"
		_tmp32_ = _tmp31_;
#line 1268 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp30_);
#line 1268 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp28_);
#line 1268 "../src/editing_tools/CropTool.vala"
		_g_free0 (_tmp26_);
#line 1268 "../src/editing_tools/CropTool.vala"
		text = _tmp32_;
#line 1269 "../src/editing_tools/CropTool.vala"
		_tmp33_ = *crop;
#line 1269 "../src/editing_tools/CropTool.vala"
		x = _tmp33_.left + (box_get_width (crop) / 2);
#line 1270 "../src/editing_tools/CropTool.vala"
		_tmp34_ = *crop;
#line 1270 "../src/editing_tools/CropTool.vala"
		y = _tmp34_.top + (box_get_height (crop) / 2);
#line 1271 "../src/editing_tools/CropTool.vala"
		_tmp35_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1271 "../src/editing_tools/CropTool.vala"
		_tmp36_ = self->priv->text_ctx;
#line 1271 "../src/editing_tools/CropTool.vala"
		_tmp37_ = text;
#line 1271 "../src/editing_tools/CropTool.vala"
		editing_tools_photo_canvas_draw_text (_tmp35_, _tmp36_, _tmp37_, x, y, TRUE);
#line 1253 "../src/editing_tools/CropTool.vala"
		_g_free0 (text);
#line 5648 "CropTool.c"
	}
#line 1275 "../src/editing_tools/CropTool.vala"
	_tmp38_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1275 "../src/editing_tools/CropTool.vala"
	_tmp39_ = self->priv->wide_black_ctx;
#line 1275 "../src/editing_tools/CropTool.vala"
	_tmp40_ = *crop;
#line 1275 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_draw_box (_tmp38_, _tmp39_, &_tmp40_);
#line 1276 "../src/editing_tools/CropTool.vala"
	_tmp41_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1276 "../src/editing_tools/CropTool.vala"
	_tmp42_ = self->priv->wide_white_ctx;
#line 1276 "../src/editing_tools/CropTool.vala"
	box_get_reduced (crop, 1, &_tmp43_);
#line 1276 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_draw_box (_tmp41_, _tmp42_, &_tmp43_);
#line 1277 "../src/editing_tools/CropTool.vala"
	_tmp44_ = ((EditingToolsEditingTool*) self)->canvas;
#line 1277 "../src/editing_tools/CropTool.vala"
	_tmp45_ = self->priv->wide_white_ctx;
#line 1277 "../src/editing_tools/CropTool.vala"
	box_get_reduced (crop, 2, &_tmp46_);
#line 1277 "../src/editing_tools/CropTool.vala"
	editing_tools_photo_canvas_draw_box (_tmp44_, _tmp45_, &_tmp46_);
#line 5674 "CropTool.c"
}

static inline gpointer
editing_tools_crop_tool_constraint_description_get_instance_private (EditingToolsCropToolConstraintDescription* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsCropToolConstraintDescription_private_offset);
}

static EditingToolsCropToolConstraintDescription*
editing_tools_crop_tool_constraint_description_construct (GType object_type,
                                                          const gchar* new_name,
                                                          gint new_basis_width,
                                                          gint new_basis_height,
                                                          gboolean new_pivotable,
                                                          gfloat new_aspect_ratio)
{
	EditingToolsCropToolConstraintDescription * self = NULL;
	gfloat _tmp0_;
#line 51 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (new_name != NULL, NULL);
#line 53 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropToolConstraintDescription*) g_object_new (object_type, "name", new_name, "basis-width", new_basis_width, "basis-height", new_basis_height, "is-pivotable", new_pivotable, "aspect-ratio", new_aspect_ratio, NULL);
#line 61 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_aspect_ratio;
#line 61 "../src/editing_tools/CropTool.vala"
	if (_tmp0_ == EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS) {
#line 5701 "CropTool.c"
		gint _tmp1_;
		gint _tmp2_;
#line 62 "../src/editing_tools/CropTool.vala"
		_tmp1_ = self->priv->_basis_width;
#line 62 "../src/editing_tools/CropTool.vala"
		_tmp2_ = self->priv->_basis_height;
#line 62 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_aspect_ratio (self, ((gfloat) _tmp1_) / ((gfloat) _tmp2_));
#line 5710 "CropTool.c"
	} else {
#line 64 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_aspect_ratio (self, new_aspect_ratio);
#line 5714 "CropTool.c"
	}
#line 51 "../src/editing_tools/CropTool.vala"
	return self;
#line 5718 "CropTool.c"
}

static EditingToolsCropToolConstraintDescription*
editing_tools_crop_tool_constraint_description_new (const gchar* new_name,
                                                    gint new_basis_width,
                                                    gint new_basis_height,
                                                    gboolean new_pivotable,
                                                    gfloat new_aspect_ratio)
{
#line 51 "../src/editing_tools/CropTool.vala"
	return editing_tools_crop_tool_constraint_description_construct (EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, new_name, new_basis_width, new_basis_height, new_pivotable, new_aspect_ratio);
#line 5730 "CropTool.c"
}

static gboolean
editing_tools_crop_tool_constraint_description_is_separator (EditingToolsCropToolConstraintDescription* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean result;
#line 68 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../src/editing_tools/CropTool.vala"
	_tmp1_ = self->priv->_is_pivotable;
#line 69 "../src/editing_tools/CropTool.vala"
	if (!_tmp1_) {
#line 5745 "CropTool.c"
		gfloat _tmp2_;
#line 69 "../src/editing_tools/CropTool.vala"
		_tmp2_ = self->priv->_aspect_ratio;
#line 69 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _tmp2_ == EDITING_TOOLS_CROP_TOOL_SEPARATOR;
#line 5751 "CropTool.c"
	} else {
#line 69 "../src/editing_tools/CropTool.vala"
		_tmp0_ = FALSE;
#line 5755 "CropTool.c"
	}
#line 69 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 69 "../src/editing_tools/CropTool.vala"
	return result;
#line 5761 "CropTool.c"
}

static const gchar*
editing_tools_crop_tool_constraint_description_get_name (EditingToolsCropToolConstraintDescription* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 45 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_name;
#line 45 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 45 "../src/editing_tools/CropTool.vala"
	return result;
#line 5777 "CropTool.c"
}

static void
editing_tools_crop_tool_constraint_description_set_name (EditingToolsCropToolConstraintDescription* self,
                                                         const gchar* value)
{
	gchar* old_value;
#line 45 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_constraint_description_get_name (self);
#line 45 "../src/editing_tools/CropTool.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 5791 "CropTool.c"
		gchar* _tmp0_;
#line 45 "../src/editing_tools/CropTool.vala"
		_tmp0_ = g_strdup (value);
#line 45 "../src/editing_tools/CropTool.vala"
		_g_free0 (self->priv->_name);
#line 45 "../src/editing_tools/CropTool.vala"
		self->priv->_name = _tmp0_;
#line 45 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_NAME_PROPERTY]);
#line 5801 "CropTool.c"
	}
}

static gint
editing_tools_crop_tool_constraint_description_get_basis_width (EditingToolsCropToolConstraintDescription* self)
{
	gint result;
#line 46 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../src/editing_tools/CropTool.vala"
	result = self->priv->_basis_width;
#line 46 "../src/editing_tools/CropTool.vala"
	return result;
#line 5815 "CropTool.c"
}

static void
editing_tools_crop_tool_constraint_description_set_basis_width (EditingToolsCropToolConstraintDescription* self,
                                                                gint value)
{
	gint old_value;
#line 46 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_constraint_description_get_basis_width (self);
#line 46 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 46 "../src/editing_tools/CropTool.vala"
		self->priv->_basis_width = value;
#line 46 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_WIDTH_PROPERTY]);
#line 5833 "CropTool.c"
	}
}

static gint
editing_tools_crop_tool_constraint_description_get_basis_height (EditingToolsCropToolConstraintDescription* self)
{
	gint result;
#line 47 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../src/editing_tools/CropTool.vala"
	result = self->priv->_basis_height;
#line 47 "../src/editing_tools/CropTool.vala"
	return result;
#line 5847 "CropTool.c"
}

static void
editing_tools_crop_tool_constraint_description_set_basis_height (EditingToolsCropToolConstraintDescription* self,
                                                                 gint value)
{
	gint old_value;
#line 47 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_constraint_description_get_basis_height (self);
#line 47 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 47 "../src/editing_tools/CropTool.vala"
		self->priv->_basis_height = value;
#line 47 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_HEIGHT_PROPERTY]);
#line 5865 "CropTool.c"
	}
}

static gboolean
editing_tools_crop_tool_constraint_description_get_is_pivotable (EditingToolsCropToolConstraintDescription* self)
{
	gboolean result;
#line 48 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/editing_tools/CropTool.vala"
	result = self->priv->_is_pivotable;
#line 48 "../src/editing_tools/CropTool.vala"
	return result;
#line 5879 "CropTool.c"
}

static void
editing_tools_crop_tool_constraint_description_set_is_pivotable (EditingToolsCropToolConstraintDescription* self,
                                                                 gboolean value)
{
	gboolean old_value;
#line 48 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_constraint_description_get_is_pivotable (self);
#line 48 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 48 "../src/editing_tools/CropTool.vala"
		self->priv->_is_pivotable = value;
#line 48 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_IS_PIVOTABLE_PROPERTY]);
#line 5897 "CropTool.c"
	}
}

static gfloat
editing_tools_crop_tool_constraint_description_get_aspect_ratio (EditingToolsCropToolConstraintDescription* self)
{
	gfloat result;
#line 49 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 49 "../src/editing_tools/CropTool.vala"
	result = self->priv->_aspect_ratio;
#line 49 "../src/editing_tools/CropTool.vala"
	return result;
#line 5911 "CropTool.c"
}

static void
editing_tools_crop_tool_constraint_description_set_aspect_ratio (EditingToolsCropToolConstraintDescription* self,
                                                                 gfloat value)
{
	gfloat old_value;
#line 49 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_constraint_description_get_aspect_ratio (self);
#line 49 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 49 "../src/editing_tools/CropTool.vala"
		self->priv->_aspect_ratio = value;
#line 49 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_ASPECT_RATIO_PROPERTY]);
#line 5929 "CropTool.c"
	}
}

static void
editing_tools_crop_tool_constraint_description_class_init (EditingToolsCropToolConstraintDescriptionClass * klass,
                                                           gpointer klass_data)
{
#line 44 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_constraint_description_parent_class = g_type_class_peek_parent (klass);
#line 44 "../src/editing_tools/CropTool.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsCropToolConstraintDescription_private_offset);
#line 44 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_editing_tools_crop_tool_constraint_description_get_property;
#line 44 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_editing_tools_crop_tool_constraint_description_set_property;
#line 44 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_crop_tool_constraint_description_finalize;
#line 44 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_NAME_PROPERTY, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 44 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_WIDTH_PROPERTY, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_WIDTH_PROPERTY] = g_param_spec_int ("basis-width", "basis-width", "basis-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 44 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_HEIGHT_PROPERTY, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_HEIGHT_PROPERTY] = g_param_spec_int ("basis-height", "basis-height", "basis-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 44 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_IS_PIVOTABLE_PROPERTY, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_IS_PIVOTABLE_PROPERTY] = g_param_spec_boolean ("is-pivotable", "is-pivotable", "is-pivotable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 44 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_ASPECT_RATIO_PROPERTY, editing_tools_crop_tool_constraint_description_properties[EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_ASPECT_RATIO_PROPERTY] = g_param_spec_float ("aspect-ratio", "aspect-ratio", "aspect-ratio", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 5957 "CropTool.c"
}

static void
editing_tools_crop_tool_constraint_description_instance_init (EditingToolsCropToolConstraintDescription * self,
                                                              gpointer klass)
{
#line 44 "../src/editing_tools/CropTool.vala"
	self->priv = editing_tools_crop_tool_constraint_description_get_instance_private (self);
#line 5966 "CropTool.c"
}

static void
editing_tools_crop_tool_constraint_description_finalize (GObject * obj)
{
	EditingToolsCropToolConstraintDescription * self;
#line 44 "../src/editing_tools/CropTool.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescription);
#line 45 "../src/editing_tools/CropTool.vala"
	_g_free0 (self->priv->_name);
#line 44 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (editing_tools_crop_tool_constraint_description_parent_class)->finalize (obj);
#line 5979 "CropTool.c"
}

static GType
editing_tools_crop_tool_constraint_description_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsCropToolConstraintDescriptionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_crop_tool_constraint_description_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsCropToolConstraintDescription), 0, (GInstanceInitFunc) editing_tools_crop_tool_constraint_description_instance_init, NULL };
	GType editing_tools_crop_tool_constraint_description_type_id;
	editing_tools_crop_tool_constraint_description_type_id = g_type_register_static (G_TYPE_OBJECT, "EditingToolsCropToolConstraintDescription", &g_define_type_info, 0);
	EditingToolsCropToolConstraintDescription_private_offset = g_type_add_instance_private (editing_tools_crop_tool_constraint_description_type_id, sizeof (EditingToolsCropToolConstraintDescriptionPrivate));
	return editing_tools_crop_tool_constraint_description_type_id;
}

static GType
editing_tools_crop_tool_constraint_description_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_constraint_description_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_constraint_description_type_id__once)) {
		GType editing_tools_crop_tool_constraint_description_type_id;
		editing_tools_crop_tool_constraint_description_type_id = editing_tools_crop_tool_constraint_description_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_constraint_description_type_id__once, editing_tools_crop_tool_constraint_description_type_id);
	}
	return editing_tools_crop_tool_constraint_description_type_id__once;
}

static void
_vala_editing_tools_crop_tool_constraint_description_get_property (GObject * object,
                                                                   guint property_id,
                                                                   GValue * value,
                                                                   GParamSpec * pspec)
{
	EditingToolsCropToolConstraintDescription * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescription);
#line 44 "../src/editing_tools/CropTool.vala"
	switch (property_id) {
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_NAME_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		g_value_set_string (value, editing_tools_crop_tool_constraint_description_get_name (self));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_WIDTH_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		g_value_set_int (value, editing_tools_crop_tool_constraint_description_get_basis_width (self));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_HEIGHT_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		g_value_set_int (value, editing_tools_crop_tool_constraint_description_get_basis_height (self));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_IS_PIVOTABLE_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		g_value_set_boolean (value, editing_tools_crop_tool_constraint_description_get_is_pivotable (self));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_ASPECT_RATIO_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		g_value_set_float (value, editing_tools_crop_tool_constraint_description_get_aspect_ratio (self));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 6044 "CropTool.c"
		default:
#line 44 "../src/editing_tools/CropTool.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 6050 "CropTool.c"
	}
}

static void
_vala_editing_tools_crop_tool_constraint_description_set_property (GObject * object,
                                                                   guint property_id,
                                                                   const GValue * value,
                                                                   GParamSpec * pspec)
{
	EditingToolsCropToolConstraintDescription * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescription);
#line 44 "../src/editing_tools/CropTool.vala"
	switch (property_id) {
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_NAME_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_name (self, g_value_get_string (value));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_WIDTH_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_basis_width (self, g_value_get_int (value));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_BASIS_HEIGHT_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_basis_height (self, g_value_get_int (value));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_IS_PIVOTABLE_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_is_pivotable (self, g_value_get_boolean (value));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 44 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_ASPECT_RATIO_PROPERTY:
#line 44 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_constraint_description_set_aspect_ratio (self, g_value_get_float (value));
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 6094 "CropTool.c"
		default:
#line 44 "../src/editing_tools/CropTool.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 44 "../src/editing_tools/CropTool.vala"
		break;
#line 6100 "CropTool.c"
	}
}

static inline gpointer
editing_tools_crop_tool_crop_tool_window_get_instance_private (EditingToolsCropToolCropToolWindow* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsCropToolCropToolWindow_private_offset);
}

static EditingToolsCropToolCropToolWindow*
editing_tools_crop_tool_crop_tool_window_construct (GType object_type,
                                                    GtkWindow* container)
{
	EditingToolsCropToolCropToolWindow * self = NULL;
#line 98 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (container != NULL, NULL);
#line 99 "../src/editing_tools/CropTool.vala"
	self = (EditingToolsCropToolCropToolWindow*) g_object_new (object_type, "transient-for", container, NULL);
#line 98 "../src/editing_tools/CropTool.vala"
	return self;
#line 6121 "CropTool.c"
}

static EditingToolsCropToolCropToolWindow*
editing_tools_crop_tool_crop_tool_window_new (GtkWindow* container)
{
#line 98 "../src/editing_tools/CropTool.vala"
	return editing_tools_crop_tool_crop_tool_window_construct (EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, container);
#line 6129 "CropTool.c"
}

static gboolean
editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func (GtkTreeModel* model,
                                                                          GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 173 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 173 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 175 "../src/editing_tools/CropTool.vala"
	_tmp0_ = *iter;
#line 175 "../src/editing_tools/CropTool.vala"
	gtk_tree_model_get_value (model, &_tmp0_, 0, &_tmp1_);
#line 175 "../src/editing_tools/CropTool.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 175 "../src/editing_tools/CropTool.vala"
	val = _tmp1_;
#line 177 "../src/editing_tools/CropTool.vala"
	_tmp2_ = g_value_dup_string (&val);
#line 177 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 177 "../src/editing_tools/CropTool.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "-") == 0;
#line 177 "../src/editing_tools/CropTool.vala"
	_g_free0 (_tmp3_);
#line 177 "../src/editing_tools/CropTool.vala"
	result = _tmp4_;
#line 177 "../src/editing_tools/CropTool.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 177 "../src/editing_tools/CropTool.vala"
	return result;
#line 6169 "CropTool.c"
}

static GtkButton*
editing_tools_crop_tool_crop_tool_window_get_crop_button (EditingToolsCropToolCropToolWindow* self)
{
	GtkButton* result;
	GtkButton* _tmp0_;
#line 89 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_crop_button;
#line 89 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 89 "../src/editing_tools/CropTool.vala"
	return result;
#line 6185 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_set_crop_button (EditingToolsCropToolCropToolWindow* self,
                                                          GtkButton* value)
{
	GtkButton* old_value;
#line 89 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_crop_tool_window_get_crop_button (self);
#line 89 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 6199 "CropTool.c"
		GtkButton* _tmp0_;
#line 89 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 89 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->_crop_button);
#line 89 "../src/editing_tools/CropTool.vala"
		self->priv->_crop_button = _tmp0_;
#line 89 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CROP_BUTTON_PROPERTY]);
#line 6209 "CropTool.c"
	}
}

static GtkButton*
editing_tools_crop_tool_crop_tool_window_get_cancel_button (EditingToolsCropToolCropToolWindow* self)
{
	GtkButton* result;
	GtkButton* _tmp0_;
#line 90 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_cancel_button;
#line 90 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 90 "../src/editing_tools/CropTool.vala"
	return result;
#line 6226 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_set_cancel_button (EditingToolsCropToolCropToolWindow* self,
                                                            GtkButton* value)
{
	GtkButton* old_value;
#line 90 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_crop_tool_window_get_cancel_button (self);
#line 90 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 6240 "CropTool.c"
		GtkButton* _tmp0_;
#line 90 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 90 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->_cancel_button);
#line 90 "../src/editing_tools/CropTool.vala"
		self->priv->_cancel_button = _tmp0_;
#line 90 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CANCEL_BUTTON_PROPERTY]);
#line 6250 "CropTool.c"
	}
}

static GtkComboBox*
editing_tools_crop_tool_crop_tool_window_get_constraint_combo (EditingToolsCropToolCropToolWindow* self)
{
	GtkComboBox* result;
	GtkComboBox* _tmp0_;
#line 91 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_constraint_combo;
#line 91 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 91 "../src/editing_tools/CropTool.vala"
	return result;
#line 6267 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_set_constraint_combo (EditingToolsCropToolCropToolWindow* self,
                                                               GtkComboBox* value)
{
	GtkComboBox* old_value;
#line 91 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_crop_tool_window_get_constraint_combo (self);
#line 91 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 6281 "CropTool.c"
		GtkComboBox* _tmp0_;
#line 91 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 91 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->_constraint_combo);
#line 91 "../src/editing_tools/CropTool.vala"
		self->priv->_constraint_combo = _tmp0_;
#line 91 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONSTRAINT_COMBO_PROPERTY]);
#line 6291 "CropTool.c"
	}
}

static GtkButton*
editing_tools_crop_tool_crop_tool_window_get_pivot_reticle_button (EditingToolsCropToolCropToolWindow* self)
{
	GtkButton* result;
	GtkButton* _tmp0_;
#line 92 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_pivot_reticle_button;
#line 92 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 92 "../src/editing_tools/CropTool.vala"
	return result;
#line 6308 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_set_pivot_reticle_button (EditingToolsCropToolCropToolWindow* self,
                                                                   GtkButton* value)
{
	GtkButton* old_value;
#line 92 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_crop_tool_window_get_pivot_reticle_button (self);
#line 92 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 6322 "CropTool.c"
		GtkButton* _tmp0_;
#line 92 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 92 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->_pivot_reticle_button);
#line 92 "../src/editing_tools/CropTool.vala"
		self->priv->_pivot_reticle_button = _tmp0_;
#line 92 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_PIVOT_RETICLE_BUTTON_PROPERTY]);
#line 6332 "CropTool.c"
	}
}

static GtkEntry*
editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (EditingToolsCropToolCropToolWindow* self)
{
	GtkEntry* result;
	GtkEntry* _tmp0_;
#line 93 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_custom_width_entry;
#line 93 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 93 "../src/editing_tools/CropTool.vala"
	return result;
#line 6349 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_set_custom_width_entry (EditingToolsCropToolCropToolWindow* self,
                                                                 GtkEntry* value)
{
	GtkEntry* old_value;
#line 93 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (self);
#line 93 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 6363 "CropTool.c"
		GtkEntry* _tmp0_;
#line 93 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 93 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->_custom_width_entry);
#line 93 "../src/editing_tools/CropTool.vala"
		self->priv->_custom_width_entry = _tmp0_;
#line 93 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_WIDTH_ENTRY_PROPERTY]);
#line 6373 "CropTool.c"
	}
}

static GtkEntry*
editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (EditingToolsCropToolCropToolWindow* self)
{
	GtkEntry* result;
	GtkEntry* _tmp0_;
#line 94 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_custom_height_entry;
#line 94 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 94 "../src/editing_tools/CropTool.vala"
	return result;
#line 6390 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_set_custom_height_entry (EditingToolsCropToolCropToolWindow* self,
                                                                  GtkEntry* value)
{
	GtkEntry* old_value;
#line 94 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (self);
#line 94 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 6404 "CropTool.c"
		GtkEntry* _tmp0_;
#line 94 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 94 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->_custom_height_entry);
#line 94 "../src/editing_tools/CropTool.vala"
		self->priv->_custom_height_entry = _tmp0_;
#line 94 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_HEIGHT_ENTRY_PROPERTY]);
#line 6414 "CropTool.c"
	}
}

static GtkRevealer*
editing_tools_crop_tool_crop_tool_window_get_custom_aspect_revealer (EditingToolsCropToolCropToolWindow* self)
{
	GtkRevealer* result;
	GtkRevealer* _tmp0_;
#line 95 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_custom_aspect_revealer;
#line 95 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 95 "../src/editing_tools/CropTool.vala"
	return result;
#line 6431 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_set_custom_aspect_revealer (EditingToolsCropToolCropToolWindow* self,
                                                                     GtkRevealer* value)
{
	GtkRevealer* old_value;
#line 95 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_crop_tool_window_get_custom_aspect_revealer (self);
#line 95 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 6445 "CropTool.c"
		GtkRevealer* _tmp0_;
#line 95 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 95 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->_custom_aspect_revealer);
#line 95 "../src/editing_tools/CropTool.vala"
		self->priv->_custom_aspect_revealer = _tmp0_;
#line 95 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_ASPECT_REVEALER_PROPERTY]);
#line 6455 "CropTool.c"
	}
}

static GtkEntry*
editing_tools_crop_tool_crop_tool_window_get_most_recently_edited (EditingToolsCropToolCropToolWindow* self)
{
	GtkEntry* result;
	GtkEntry* _tmp0_;
#line 96 "../src/editing_tools/CropTool.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_most_recently_edited;
#line 96 "../src/editing_tools/CropTool.vala"
	result = _tmp0_;
#line 96 "../src/editing_tools/CropTool.vala"
	return result;
#line 6472 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_set_most_recently_edited (EditingToolsCropToolCropToolWindow* self,
                                                                   GtkEntry* value)
{
	GtkEntry* old_value;
#line 96 "../src/editing_tools/CropTool.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/editing_tools/CropTool.vala"
	old_value = editing_tools_crop_tool_crop_tool_window_get_most_recently_edited (self);
#line 96 "../src/editing_tools/CropTool.vala"
	if (old_value != value) {
#line 6486 "CropTool.c"
		GtkEntry* _tmp0_;
#line 96 "../src/editing_tools/CropTool.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 96 "../src/editing_tools/CropTool.vala"
		_g_object_unref0 (self->priv->_most_recently_edited);
#line 96 "../src/editing_tools/CropTool.vala"
		self->priv->_most_recently_edited = _tmp0_;
#line 96 "../src/editing_tools/CropTool.vala"
		g_object_notify_by_pspec ((GObject *) self, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_MOST_RECENTLY_EDITED_PROPERTY]);
#line 6496 "CropTool.c"
	}
}

static gboolean
_editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func_gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                                                                            GtkTreeIter* iter,
                                                                                                            gpointer self)
{
	gboolean result;
	result = editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func (model, iter);
#line 114 "../src/editing_tools/CropTool.vala"
	return result;
#line 6509 "CropTool.c"
}

static gboolean
_editing_tools_crop_tool_crop_tool_window___lambda48_ (EditingToolsCropToolCropToolWindow* self)
{
	GtkEntry* _tmp0_;
#line 165 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_custom_width_entry;
#line 165 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_most_recently_edited (self, _tmp0_);
#line 6520 "CropTool.c"
}

static gboolean
__editing_tools_crop_tool_crop_tool_window___lambda48__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                   GdkEventFocus* event,
                                                                                   gpointer self)
{
	gboolean result;
	result = _editing_tools_crop_tool_crop_tool_window___lambda48_ ((EditingToolsCropToolCropToolWindow*) self);
#line 164 "../src/editing_tools/CropTool.vala"
	return result;
#line 6532 "CropTool.c"
}

static gboolean
_editing_tools_crop_tool_crop_tool_window___lambda49_ (EditingToolsCropToolCropToolWindow* self)
{
	GtkEntry* _tmp0_;
#line 169 "../src/editing_tools/CropTool.vala"
	_tmp0_ = self->priv->_custom_height_entry;
#line 169 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_most_recently_edited (self, _tmp0_);
#line 6543 "CropTool.c"
}

static gboolean
__editing_tools_crop_tool_crop_tool_window___lambda49__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                   GdkEventFocus* event,
                                                                                   gpointer self)
{
	gboolean result;
	result = _editing_tools_crop_tool_crop_tool_window___lambda49_ ((EditingToolsCropToolCropToolWindow*) self);
#line 168 "../src/editing_tools/CropTool.vala"
	return result;
#line 6555 "CropTool.c"
}

static GObject *
editing_tools_crop_tool_crop_tool_window_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	EditingToolsCropToolCropToolWindow * self;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_ = NULL;
	GtkButton* _tmp3_;
	GtkCellRendererText* combo_text_renderer = NULL;
	GtkCellRendererText* _tmp4_;
	GtkComboBox* _tmp5_;
	GtkComboBox* _tmp6_;
	GtkComboBox* _tmp7_;
	GtkCellRendererText* _tmp8_;
	GtkComboBox* _tmp9_;
	GtkCellRendererText* _tmp10_;
	GtkComboBox* _tmp11_;
	GtkComboBox* _tmp12_;
	gchar* _tmp13_;
	GtkButton* _tmp14_ = NULL;
	GtkButton* _tmp15_;
	GtkEntry* _tmp16_ = NULL;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_ = NULL;
	GtkEntry* _tmp19_;
	GtkGrid* custom_aspect_grid = NULL;
	GtkGrid* _tmp20_ = NULL;
	GtkGrid* _tmp21_;
	GtkEntry* _tmp22_;
	GtkGrid* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkEntry* _tmp27_;
	GtkRevealer* _tmp28_ = NULL;
	GtkRevealer* _tmp29_;
	GtkRevealer* _tmp30_;
	GtkGrid* _tmp31_;
	GtkSizeGroup* response_sizegroup = NULL;
	GtkSizeGroup* _tmp32_;
	GtkSizeGroup* _tmp33_;
	GtkButton* _tmp34_;
	GtkSizeGroup* _tmp35_;
	GtkButton* _tmp36_;
	GtkGrid* layout = NULL;
	GtkGrid* _tmp37_;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkComboBox* _tmp40_;
	GtkGrid* _tmp41_;
	GtkRevealer* _tmp42_;
	GtkGrid* _tmp43_;
	GtkButton* _tmp44_;
	GtkGrid* _tmp45_;
	GtkButton* _tmp46_;
	GtkGrid* _tmp47_;
	GtkButton* _tmp48_;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkButton* _tmp52_;
	GtkEntry* _tmp53_;
	GtkEntry* _tmp54_;
#line 102 "../src/editing_tools/CropTool.vala"
	parent_class = G_OBJECT_CLASS (editing_tools_crop_tool_crop_tool_window_parent_class);
#line 102 "../src/editing_tools/CropTool.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 102 "../src/editing_tools/CropTool.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindow);
#line 103 "../src/editing_tools/CropTool.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_mnemonic (_ ("_Cancel"));
#line 103 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp0_);
#line 103 "../src/editing_tools/CropTool.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_cancel_button (self, _tmp1_);
#line 103 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp1_);
#line 105 "../src/editing_tools/CropTool.vala"
	_tmp2_ = (GtkButton*) gtk_button_new_with_label (RESOURCES_CROP_LABEL);
#line 105 "../src/editing_tools/CropTool.vala"
	gtk_widget_set_can_default ((GtkWidget*) _tmp2_, TRUE);
#line 105 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp2_);
#line 105 "../src/editing_tools/CropTool.vala"
	_tmp3_ = _tmp2_;
#line 105 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_crop_button (self, _tmp3_);
#line 105 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp3_);
#line 109 "../src/editing_tools/CropTool.vala"
	_tmp4_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 109 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp4_);
#line 109 "../src/editing_tools/CropTool.vala"
	combo_text_renderer = _tmp4_;
#line 111 "../src/editing_tools/CropTool.vala"
	_tmp5_ = (GtkComboBox*) gtk_combo_box_new ();
#line 111 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp5_);
#line 111 "../src/editing_tools/CropTool.vala"
	_tmp6_ = _tmp5_;
#line 111 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_constraint_combo (self, _tmp6_);
#line 111 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp6_);
#line 112 "../src/editing_tools/CropTool.vala"
	_tmp7_ = self->priv->_constraint_combo;
#line 112 "../src/editing_tools/CropTool.vala"
	_tmp8_ = combo_text_renderer;
#line 112 "../src/editing_tools/CropTool.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp7_, (GtkCellRenderer*) _tmp8_, TRUE);
#line 113 "../src/editing_tools/CropTool.vala"
	_tmp9_ = self->priv->_constraint_combo;
#line 113 "../src/editing_tools/CropTool.vala"
	_tmp10_ = combo_text_renderer;
#line 113 "../src/editing_tools/CropTool.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp9_, (GtkCellRenderer*) _tmp10_, "text", 0);
#line 114 "../src/editing_tools/CropTool.vala"
	_tmp11_ = self->priv->_constraint_combo;
#line 114 "../src/editing_tools/CropTool.vala"
	gtk_combo_box_set_row_separator_func (_tmp11_, _editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func_gtk_tree_view_row_separator_func, NULL, NULL);
#line 115 "../src/editing_tools/CropTool.vala"
	_tmp12_ = self->priv->_constraint_combo;
#line 115 "../src/editing_tools/CropTool.vala"
	gtk_combo_box_set_active (_tmp12_, 0);
#line 117 "../src/editing_tools/CropTool.vala"
	_tmp13_ = g_strdup (_ ("Pivot the crop rectangle between portrait and landscape orientations"));
#line 117 "../src/editing_tools/CropTool.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_from_icon_name ("object-rotate-right-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 117 "../src/editing_tools/CropTool.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _tmp13_);
#line 117 "../src/editing_tools/CropTool.vala"
	_g_free0 (_tmp13_);
#line 117 "../src/editing_tools/CropTool.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp14_, 18);
#line 117 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp14_);
#line 117 "../src/editing_tools/CropTool.vala"
	_tmp15_ = _tmp14_;
#line 117 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_pivot_reticle_button (self, _tmp15_);
#line 117 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp15_);
#line 122 "../src/editing_tools/CropTool.vala"
	_tmp16_ = (GtkEntry*) gtk_entry_new ();
#line 122 "../src/editing_tools/CropTool.vala"
	gtk_entry_set_activates_default (_tmp16_, TRUE);
#line 122 "../src/editing_tools/CropTool.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp16_, TRUE);
#line 122 "../src/editing_tools/CropTool.vala"
	gtk_entry_set_width_chars (_tmp16_, 4);
#line 122 "../src/editing_tools/CropTool.vala"
	g_object_set (_tmp16_, "xalign", 0.5f, NULL);
#line 122 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp16_);
#line 122 "../src/editing_tools/CropTool.vala"
	_tmp17_ = _tmp16_;
#line 122 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_custom_width_entry (self, _tmp17_);
#line 122 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp17_);
#line 129 "../src/editing_tools/CropTool.vala"
	_tmp18_ = (GtkEntry*) gtk_entry_new ();
#line 129 "../src/editing_tools/CropTool.vala"
	gtk_entry_set_activates_default (_tmp18_, TRUE);
#line 129 "../src/editing_tools/CropTool.vala"
	gtk_entry_set_width_chars (_tmp18_, 4);
#line 129 "../src/editing_tools/CropTool.vala"
	g_object_set (_tmp18_, "xalign", 0.5f, NULL);
#line 129 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp18_);
#line 129 "../src/editing_tools/CropTool.vala"
	_tmp19_ = _tmp18_;
#line 129 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_custom_height_entry (self, _tmp19_);
#line 129 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp19_);
#line 135 "../src/editing_tools/CropTool.vala"
	_tmp20_ = (GtkGrid*) gtk_grid_new ();
#line 135 "../src/editing_tools/CropTool.vala"
	gtk_grid_set_column_spacing (_tmp20_, 3);
#line 135 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp20_);
#line 135 "../src/editing_tools/CropTool.vala"
	custom_aspect_grid = _tmp20_;
#line 138 "../src/editing_tools/CropTool.vala"
	_tmp21_ = custom_aspect_grid;
#line 138 "../src/editing_tools/CropTool.vala"
	_tmp22_ = self->priv->_custom_width_entry;
#line 138 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 139 "../src/editing_tools/CropTool.vala"
	_tmp23_ = custom_aspect_grid;
#line 139 "../src/editing_tools/CropTool.vala"
	_tmp24_ = (GtkLabel*) gtk_label_new (":");
#line 139 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp24_);
#line 139 "../src/editing_tools/CropTool.vala"
	_tmp25_ = _tmp24_;
#line 139 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp25_);
#line 139 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp25_);
#line 140 "../src/editing_tools/CropTool.vala"
	_tmp26_ = custom_aspect_grid;
#line 140 "../src/editing_tools/CropTool.vala"
	_tmp27_ = self->priv->_custom_height_entry;
#line 140 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 142 "../src/editing_tools/CropTool.vala"
	_tmp28_ = (GtkRevealer*) gtk_revealer_new ();
#line 142 "../src/editing_tools/CropTool.vala"
	gtk_revealer_set_transition_type (_tmp28_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
#line 142 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp28_);
#line 142 "../src/editing_tools/CropTool.vala"
	_tmp29_ = _tmp28_;
#line 142 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_set_custom_aspect_revealer (self, _tmp29_);
#line 142 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (_tmp29_);
#line 145 "../src/editing_tools/CropTool.vala"
	_tmp30_ = self->priv->_custom_aspect_revealer;
#line 145 "../src/editing_tools/CropTool.vala"
	_tmp31_ = custom_aspect_grid;
#line 145 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 147 "../src/editing_tools/CropTool.vala"
	_tmp32_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 147 "../src/editing_tools/CropTool.vala"
	response_sizegroup = _tmp32_;
#line 148 "../src/editing_tools/CropTool.vala"
	_tmp33_ = response_sizegroup;
#line 148 "../src/editing_tools/CropTool.vala"
	_tmp34_ = self->priv->_cancel_button;
#line 148 "../src/editing_tools/CropTool.vala"
	gtk_size_group_add_widget (_tmp33_, (GtkWidget*) _tmp34_);
#line 149 "../src/editing_tools/CropTool.vala"
	_tmp35_ = response_sizegroup;
#line 149 "../src/editing_tools/CropTool.vala"
	_tmp36_ = self->priv->_crop_button;
#line 149 "../src/editing_tools/CropTool.vala"
	gtk_size_group_add_widget (_tmp35_, (GtkWidget*) _tmp36_);
#line 151 "../src/editing_tools/CropTool.vala"
	_tmp37_ = (GtkGrid*) gtk_grid_new ();
#line 151 "../src/editing_tools/CropTool.vala"
	g_object_ref_sink (_tmp37_);
#line 151 "../src/editing_tools/CropTool.vala"
	layout = _tmp37_;
#line 152 "../src/editing_tools/CropTool.vala"
	_tmp38_ = layout;
#line 152 "../src/editing_tools/CropTool.vala"
	gtk_grid_set_column_spacing (_tmp38_, 6);
#line 153 "../src/editing_tools/CropTool.vala"
	_tmp39_ = layout;
#line 153 "../src/editing_tools/CropTool.vala"
	_tmp40_ = self->priv->_constraint_combo;
#line 153 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
#line 154 "../src/editing_tools/CropTool.vala"
	_tmp41_ = layout;
#line 154 "../src/editing_tools/CropTool.vala"
	_tmp42_ = self->priv->_custom_aspect_revealer;
#line 154 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
#line 155 "../src/editing_tools/CropTool.vala"
	_tmp43_ = layout;
#line 155 "../src/editing_tools/CropTool.vala"
	_tmp44_ = self->priv->_pivot_reticle_button;
#line 155 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
#line 156 "../src/editing_tools/CropTool.vala"
	_tmp45_ = layout;
#line 156 "../src/editing_tools/CropTool.vala"
	_tmp46_ = self->priv->_cancel_button;
#line 156 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
#line 157 "../src/editing_tools/CropTool.vala"
	_tmp47_ = layout;
#line 157 "../src/editing_tools/CropTool.vala"
	_tmp48_ = self->priv->_crop_button;
#line 157 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 159 "../src/editing_tools/CropTool.vala"
	_tmp49_ = editing_tools_editing_tool_window_get_content_area ((EditingToolsEditingToolWindow*) self);
#line 159 "../src/editing_tools/CropTool.vala"
	_tmp50_ = _tmp49_;
#line 159 "../src/editing_tools/CropTool.vala"
	_tmp51_ = layout;
#line 159 "../src/editing_tools/CropTool.vala"
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
#line 162 "../src/editing_tools/CropTool.vala"
	_tmp52_ = self->priv->_crop_button;
#line 162 "../src/editing_tools/CropTool.vala"
	g_object_set ((GtkWidget*) _tmp52_, "has-default", TRUE, NULL);
#line 164 "../src/editing_tools/CropTool.vala"
	_tmp53_ = self->priv->_custom_width_entry;
#line 164 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object ((GtkWidget*) _tmp53_, "focus-out-event", (GCallback) __editing_tools_crop_tool_crop_tool_window___lambda48__gtk_widget_focus_out_event, self, 0);
#line 168 "../src/editing_tools/CropTool.vala"
	_tmp54_ = self->priv->_custom_height_entry;
#line 168 "../src/editing_tools/CropTool.vala"
	g_signal_connect_object ((GtkWidget*) _tmp54_, "focus-out-event", (GCallback) __editing_tools_crop_tool_crop_tool_window___lambda49__gtk_widget_focus_out_event, self, 0);
#line 102 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (layout);
#line 102 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (response_sizegroup);
#line 102 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (custom_aspect_grid);
#line 102 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (combo_text_renderer);
#line 102 "../src/editing_tools/CropTool.vala"
	return obj;
#line 6877 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_class_init (EditingToolsCropToolCropToolWindowClass * klass,
                                                     gpointer klass_data)
{
#line 88 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_crop_tool_window_parent_class = g_type_class_peek_parent (klass);
#line 88 "../src/editing_tools/CropTool.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsCropToolCropToolWindow_private_offset);
#line 88 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_editing_tools_crop_tool_crop_tool_window_get_property;
#line 88 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_editing_tools_crop_tool_crop_tool_window_set_property;
#line 88 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->constructor = editing_tools_crop_tool_crop_tool_window_constructor;
#line 88 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_crop_tool_crop_tool_window_finalize;
#line 88 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CROP_BUTTON_PROPERTY, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CROP_BUTTON_PROPERTY] = g_param_spec_object ("crop-button", "crop-button", "crop-button", gtk_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 88 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CANCEL_BUTTON_PROPERTY, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CANCEL_BUTTON_PROPERTY] = g_param_spec_object ("cancel-button", "cancel-button", "cancel-button", gtk_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 88 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONSTRAINT_COMBO_PROPERTY, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONSTRAINT_COMBO_PROPERTY] = g_param_spec_object ("constraint-combo", "constraint-combo", "constraint-combo", gtk_combo_box_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 88 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_PIVOT_RETICLE_BUTTON_PROPERTY, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_PIVOT_RETICLE_BUTTON_PROPERTY] = g_param_spec_object ("pivot-reticle-button", "pivot-reticle-button", "pivot-reticle-button", gtk_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 88 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_WIDTH_ENTRY_PROPERTY, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_WIDTH_ENTRY_PROPERTY] = g_param_spec_object ("custom-width-entry", "custom-width-entry", "custom-width-entry", gtk_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 88 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_HEIGHT_ENTRY_PROPERTY, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_HEIGHT_ENTRY_PROPERTY] = g_param_spec_object ("custom-height-entry", "custom-height-entry", "custom-height-entry", gtk_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 88 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_ASPECT_REVEALER_PROPERTY, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_ASPECT_REVEALER_PROPERTY] = g_param_spec_object ("custom-aspect-revealer", "custom-aspect-revealer", "custom-aspect-revealer", gtk_revealer_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 88 "../src/editing_tools/CropTool.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_MOST_RECENTLY_EDITED_PROPERTY, editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_MOST_RECENTLY_EDITED_PROPERTY] = g_param_spec_object ("most-recently-edited", "most-recently-edited", "most-recently-edited", gtk_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6912 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_instance_init (EditingToolsCropToolCropToolWindow * self,
                                                        gpointer klass)
{
#line 88 "../src/editing_tools/CropTool.vala"
	self->priv = editing_tools_crop_tool_crop_tool_window_get_instance_private (self);
#line 96 "../src/editing_tools/CropTool.vala"
	self->priv->_most_recently_edited = NULL;
#line 6923 "CropTool.c"
}

static void
editing_tools_crop_tool_crop_tool_window_finalize (GObject * obj)
{
	EditingToolsCropToolCropToolWindow * self;
#line 88 "../src/editing_tools/CropTool.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindow);
#line 89 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->_crop_button);
#line 90 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->_cancel_button);
#line 91 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->_constraint_combo);
#line 92 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->_pivot_reticle_button);
#line 93 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->_custom_width_entry);
#line 94 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->_custom_height_entry);
#line 95 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->_custom_aspect_revealer);
#line 96 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->_most_recently_edited);
#line 88 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (editing_tools_crop_tool_crop_tool_window_parent_class)->finalize (obj);
#line 6950 "CropTool.c"
}

static GType
editing_tools_crop_tool_crop_tool_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsCropToolCropToolWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_crop_tool_crop_tool_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsCropToolCropToolWindow), 0, (GInstanceInitFunc) editing_tools_crop_tool_crop_tool_window_instance_init, NULL };
	GType editing_tools_crop_tool_crop_tool_window_type_id;
	editing_tools_crop_tool_crop_tool_window_type_id = g_type_register_static (EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, "EditingToolsCropToolCropToolWindow", &g_define_type_info, 0);
	EditingToolsCropToolCropToolWindow_private_offset = g_type_add_instance_private (editing_tools_crop_tool_crop_tool_window_type_id, sizeof (EditingToolsCropToolCropToolWindowPrivate));
	return editing_tools_crop_tool_crop_tool_window_type_id;
}

static GType
editing_tools_crop_tool_crop_tool_window_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_crop_tool_window_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_crop_tool_window_type_id__once)) {
		GType editing_tools_crop_tool_crop_tool_window_type_id;
		editing_tools_crop_tool_crop_tool_window_type_id = editing_tools_crop_tool_crop_tool_window_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_crop_tool_window_type_id__once, editing_tools_crop_tool_crop_tool_window_type_id);
	}
	return editing_tools_crop_tool_crop_tool_window_type_id__once;
}

static void
_vala_editing_tools_crop_tool_crop_tool_window_get_property (GObject * object,
                                                             guint property_id,
                                                             GValue * value,
                                                             GParamSpec * pspec)
{
	EditingToolsCropToolCropToolWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindow);
#line 88 "../src/editing_tools/CropTool.vala"
	switch (property_id) {
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CROP_BUTTON_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		g_value_set_object (value, editing_tools_crop_tool_crop_tool_window_get_crop_button (self));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CANCEL_BUTTON_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		g_value_set_object (value, editing_tools_crop_tool_crop_tool_window_get_cancel_button (self));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONSTRAINT_COMBO_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		g_value_set_object (value, editing_tools_crop_tool_crop_tool_window_get_constraint_combo (self));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_PIVOT_RETICLE_BUTTON_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		g_value_set_object (value, editing_tools_crop_tool_crop_tool_window_get_pivot_reticle_button (self));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_WIDTH_ENTRY_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		g_value_set_object (value, editing_tools_crop_tool_crop_tool_window_get_custom_width_entry (self));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_HEIGHT_ENTRY_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		g_value_set_object (value, editing_tools_crop_tool_crop_tool_window_get_custom_height_entry (self));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_ASPECT_REVEALER_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		g_value_set_object (value, editing_tools_crop_tool_crop_tool_window_get_custom_aspect_revealer (self));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_MOST_RECENTLY_EDITED_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		g_value_set_object (value, editing_tools_crop_tool_crop_tool_window_get_most_recently_edited (self));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 7033 "CropTool.c"
		default:
#line 88 "../src/editing_tools/CropTool.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 7039 "CropTool.c"
	}
}

static void
_vala_editing_tools_crop_tool_crop_tool_window_set_property (GObject * object,
                                                             guint property_id,
                                                             const GValue * value,
                                                             GParamSpec * pspec)
{
	EditingToolsCropToolCropToolWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindow);
#line 88 "../src/editing_tools/CropTool.vala"
	switch (property_id) {
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CROP_BUTTON_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_tool_window_set_crop_button (self, g_value_get_object (value));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CANCEL_BUTTON_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_tool_window_set_cancel_button (self, g_value_get_object (value));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONSTRAINT_COMBO_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_tool_window_set_constraint_combo (self, g_value_get_object (value));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_PIVOT_RETICLE_BUTTON_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_tool_window_set_pivot_reticle_button (self, g_value_get_object (value));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_WIDTH_ENTRY_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_tool_window_set_custom_width_entry (self, g_value_get_object (value));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_HEIGHT_ENTRY_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_tool_window_set_custom_height_entry (self, g_value_get_object (value));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CUSTOM_ASPECT_REVEALER_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_tool_window_set_custom_aspect_revealer (self, g_value_get_object (value));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 88 "../src/editing_tools/CropTool.vala"
		case EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_MOST_RECENTLY_EDITED_PROPERTY:
#line 88 "../src/editing_tools/CropTool.vala"
		editing_tools_crop_tool_crop_tool_window_set_most_recently_edited (self, g_value_get_object (value));
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 7101 "CropTool.c"
		default:
#line 88 "../src/editing_tools/CropTool.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 88 "../src/editing_tools/CropTool.vala"
		break;
#line 7107 "CropTool.c"
	}
}

static GObject *
editing_tools_crop_tool_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	EditingToolsCropTool * self;
	GSettings* _tmp0_;
#line 215 "../src/editing_tools/CropTool.vala"
	parent_class = G_OBJECT_CLASS (editing_tools_crop_tool_parent_class);
#line 215 "../src/editing_tools/CropTool.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 215 "../src/editing_tools/CropTool.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 216 "../src/editing_tools/CropTool.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_CROP_SCHEMA_NAME);
#line 216 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->crop_settings);
#line 216 "../src/editing_tools/CropTool.vala"
	self->priv->crop_settings = _tmp0_;
#line 215 "../src/editing_tools/CropTool.vala"
	return obj;
#line 7134 "CropTool.c"
}

static void
editing_tools_crop_tool_class_init (EditingToolsCropToolClass * klass,
                                    gpointer klass_data)
{
#line 23 "../src/editing_tools/CropTool.vala"
	editing_tools_crop_tool_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/editing_tools/CropTool.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsCropTool_private_offset);
#line 23 "../src/editing_tools/CropTool.vala"
	((EditingToolsEditingToolClass *) klass)->activate = (void (*) (EditingToolsEditingTool*, EditingToolsPhotoCanvas*)) editing_tools_crop_tool_real_activate;
#line 23 "../src/editing_tools/CropTool.vala"
	((EditingToolsEditingToolClass *) klass)->deactivate = (void (*) (EditingToolsEditingTool*)) editing_tools_crop_tool_real_deactivate;
#line 23 "../src/editing_tools/CropTool.vala"
	((EditingToolsEditingToolClass *) klass)->get_tool_window = (EditingToolsEditingToolWindow* (*) (EditingToolsEditingTool*)) editing_tools_crop_tool_real_get_tool_window;
#line 23 "../src/editing_tools/CropTool.vala"
	((EditingToolsEditingToolClass *) klass)->get_display_pixbuf = (GdkPixbuf* (*) (EditingToolsEditingTool*, Scaling*, Photo*, Dimensions*, GError**)) editing_tools_crop_tool_real_get_display_pixbuf;
#line 23 "../src/editing_tools/CropTool.vala"
	((EditingToolsEditingToolClass *) klass)->on_left_click = (void (*) (EditingToolsEditingTool*, gint, gint)) editing_tools_crop_tool_real_on_left_click;
#line 23 "../src/editing_tools/CropTool.vala"
	((EditingToolsEditingToolClass *) klass)->on_left_released = (void (*) (EditingToolsEditingTool*, gint, gint)) editing_tools_crop_tool_real_on_left_released;
#line 23 "../src/editing_tools/CropTool.vala"
	((EditingToolsEditingToolClass *) klass)->on_motion = (void (*) (EditingToolsEditingTool*, gint, gint, GdkModifierType)) editing_tools_crop_tool_real_on_motion;
#line 23 "../src/editing_tools/CropTool.vala"
	((EditingToolsEditingToolClass *) klass)->paint = (void (*) (EditingToolsEditingTool*, cairo_t*)) editing_tools_crop_tool_real_paint;
#line 23 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->constructor = editing_tools_crop_tool_constructor;
#line 23 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_crop_tool_finalize;
#line 7165 "CropTool.c"
}

static void
editing_tools_crop_tool_instance_init (EditingToolsCropTool * self,
                                       gpointer klass)
{
	gint _tmp0_ = 0;
	EditingToolsCropToolConstraintDescription** _tmp1_;
	gint _tmp2_ = 0;
	EditingToolsCropToolConstraintDescription** _tmp3_;
	EditingToolsCropToolConstraintDescription** _tmp4_;
	gint _tmp4__length1;
	GtkListStore* _tmp5_;
#line 23 "../src/editing_tools/CropTool.vala"
	self->priv = editing_tools_crop_tool_get_instance_private (self);
#line 181 "../src/editing_tools/CropTool.vala"
	self->priv->crop_tool_window = NULL;
#line 182 "../src/editing_tools/CropTool.vala"
	self->priv->current_cursor_type = GDK_LEFT_PTR;
#line 183 "../src/editing_tools/CropTool.vala"
	self->priv->in_manipulation = BOX_LOCATION_OUTSIDE;
#line 184 "../src/editing_tools/CropTool.vala"
	self->priv->wide_black_ctx = NULL;
#line 185 "../src/editing_tools/CropTool.vala"
	self->priv->wide_white_ctx = NULL;
#line 186 "../src/editing_tools/CropTool.vala"
	self->priv->thin_white_ctx = NULL;
#line 187 "../src/editing_tools/CropTool.vala"
	self->priv->text_ctx = NULL;
#line 190 "../src/editing_tools/CropTool.vala"
	self->priv->crop_surface = NULL;
#line 194 "../src/editing_tools/CropTool.vala"
	self->priv->last_grab_x = -1;
#line 195 "../src/editing_tools/CropTool.vala"
	self->priv->last_grab_y = -1;
#line 197 "../src/editing_tools/CropTool.vala"
	_tmp1_ = editing_tools_crop_tool_create_constraints (&_tmp0_);
#line 197 "../src/editing_tools/CropTool.vala"
	self->priv->constraints = _tmp1_;
#line 197 "../src/editing_tools/CropTool.vala"
	self->priv->constraints_length1 = _tmp0_;
#line 197 "../src/editing_tools/CropTool.vala"
	self->priv->_constraints_size_ = self->priv->constraints_length1;
#line 198 "../src/editing_tools/CropTool.vala"
	_tmp3_ = editing_tools_crop_tool_create_constraints (&_tmp2_);
#line 198 "../src/editing_tools/CropTool.vala"
	_tmp4_ = _tmp3_;
#line 198 "../src/editing_tools/CropTool.vala"
	_tmp4__length1 = _tmp2_;
#line 198 "../src/editing_tools/CropTool.vala"
	_tmp5_ = editing_tools_crop_tool_create_constraint_list (_tmp4_, (gint) _tmp2_);
#line 198 "../src/editing_tools/CropTool.vala"
	self->priv->constraint_list = _tmp5_;
#line 198 "../src/editing_tools/CropTool.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_object_unref), NULL);
#line 199 "../src/editing_tools/CropTool.vala"
	self->priv->reticle_orientation = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE;
#line 200 "../src/editing_tools/CropTool.vala"
	self->priv->constraint_mode = EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL;
#line 201 "../src/editing_tools/CropTool.vala"
	self->priv->entry_insert_in_progress = FALSE;
#line 202 "../src/editing_tools/CropTool.vala"
	self->priv->custom_aspect_ratio = 1.0f;
#line 203 "../src/editing_tools/CropTool.vala"
	self->priv->custom_width = -1;
#line 204 "../src/editing_tools/CropTool.vala"
	self->priv->custom_height = -1;
#line 205 "../src/editing_tools/CropTool.vala"
	self->priv->custom_init_width = -1;
#line 206 "../src/editing_tools/CropTool.vala"
	self->priv->custom_init_height = -1;
#line 207 "../src/editing_tools/CropTool.vala"
	self->priv->scale_factor = 1;
#line 208 "../src/editing_tools/CropTool.vala"
	self->priv->pre_aspect_ratio = EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO;
#line 7241 "CropTool.c"
}

static void
editing_tools_crop_tool_finalize (GObject * obj)
{
	EditingToolsCropTool * self;
#line 23 "../src/editing_tools/CropTool.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 181 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->crop_tool_window);
#line 184 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (self->priv->wide_black_ctx);
#line 185 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (self->priv->wide_white_ctx);
#line 186 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (self->priv->thin_white_ctx);
#line 187 "../src/editing_tools/CropTool.vala"
	_cairo_destroy0 (self->priv->text_ctx);
#line 190 "../src/editing_tools/CropTool.vala"
	_cairo_surface_destroy0 (self->priv->crop_surface);
#line 197 "../src/editing_tools/CropTool.vala"
	self->priv->constraints = (_vala_array_free (self->priv->constraints, self->priv->constraints_length1, (GDestroyNotify) g_object_unref), NULL);
#line 198 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->constraint_list);
#line 209 "../src/editing_tools/CropTool.vala"
	_g_object_unref0 (self->priv->crop_settings);
#line 23 "../src/editing_tools/CropTool.vala"
	G_OBJECT_CLASS (editing_tools_crop_tool_parent_class)->finalize (obj);
#line 7270 "CropTool.c"
}

static GType
editing_tools_crop_tool_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsCropToolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_crop_tool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsCropTool), 0, (GInstanceInitFunc) editing_tools_crop_tool_instance_init, NULL };
	GType editing_tools_crop_tool_type_id;
	editing_tools_crop_tool_type_id = g_type_register_static (EDITING_TOOLS_TYPE_EDITING_TOOL, "EditingToolsCropTool", &g_define_type_info, 0);
	EditingToolsCropTool_private_offset = g_type_add_instance_private (editing_tools_crop_tool_type_id, sizeof (EditingToolsCropToolPrivate));
	return editing_tools_crop_tool_type_id;
}

GType
editing_tools_crop_tool_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_type_id__once)) {
		GType editing_tools_crop_tool_type_id;
		editing_tools_crop_tool_type_id = editing_tools_crop_tool_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_type_id__once, editing_tools_crop_tool_type_id);
	}
	return editing_tools_crop_tool_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

