/* PhotoMetadata.c generated by valac 0.56.18, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitiate*/
/* interface changes to meet Photos' requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Photos' metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include "io.elementary.photos.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>

#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecHierarchicalKeywordField ParamSpecHierarchicalKeywordField;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
typedef void (*PhotoMetadataSetGenericValue) (const gchar* tag, gpointer user_data);
typedef struct _Block3Data Block3Data;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;
#define _hierarchical_keyword_field_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_keyword_field_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ParamSpecHierarchicalKeywordField {
	GParamSpec parent_instance;
};

struct _PhotoPreviewPrivate {
	gchar* name;
	Dimensions dimensions;
	guint32 size;
	gchar* mime_type;
	gchar* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	gchar* source_name;
};

struct _Block3Data {
	int _ref_count_;
	PhotoMetadata* self;
	gchar* value;
};

struct _Block4Data {
	int _ref_count_;
	PhotoMetadata* self;
	GeeCollection* values;
};

struct _Block5Data {
	int _ref_count_;
	PhotoMetadata* self;
	glong value;
};

struct _Block6Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataRational rational;
};

struct _Block7Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataDateTime* date_time;
};

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};

static gpointer hierarchical_keyword_field_parent_class = NULL;
static gint PhotoPreview_private_offset;
static gpointer photo_preview_parent_class = NULL;
static gint PhotoMetadata_private_offset;
static gpointer photo_metadata_parent_class = NULL;
static gchar** photo_metadata_date_int64ags;
static gint photo_metadata_date_int64ags_length1;
static gchar** photo_metadata_date_int64ags = NULL;
static gint photo_metadata_date_int64ags_length1 = 0;
static gint _photo_metadata_date_int64ags_size_ = 0;
static gchar** photo_metadata_exposure_date_int64ags;
static gint photo_metadata_exposure_date_int64ags_length1;
static gchar** photo_metadata_exposure_date_int64ags = NULL;
static gint photo_metadata_exposure_date_int64ags_length1 = 0;
static gint _photo_metadata_exposure_date_int64ags_size_ = 0;
static gchar** photo_metadata_digitized_date_int64ags;
static gint photo_metadata_digitized_date_int64ags_length1;
static gchar** photo_metadata_digitized_date_int64ags = NULL;
static gint photo_metadata_digitized_date_int64ags_length1 = 0;
static gint _photo_metadata_digitized_date_int64ags_size_ = 0;
static gchar** photo_metadata_width_tags;
static gint photo_metadata_width_tags_length1;
static gchar** photo_metadata_width_tags = NULL;
static gint photo_metadata_width_tags_length1 = 0;
static gint _photo_metadata_width_tags_size_ = 0;
gchar** photo_metadata_height_tags = NULL;
gint photo_metadata_height_tags_length1 = 0;
static gchar** photo_metadata_standard_title_tags;
static gint photo_metadata_standard_title_tags_length1;
static gchar** photo_metadata_standard_title_tags = NULL;
static gint photo_metadata_standard_title_tags_length1 = 0;
static gint _photo_metadata_standard_title_tags_size_ = 0;
static gchar** photo_metadata_keyword_tags;
static gint photo_metadata_keyword_tags_length1;
static gchar** photo_metadata_keyword_tags = NULL;
static gint photo_metadata_keyword_tags_length1 = 0;
static gint _photo_metadata_keyword_tags_size_ = 0;
static HierarchicalKeywordField** photo_metadata_hierarchical_keyword_tags;
static gint photo_metadata_hierarchical_keyword_tags_length1;
static HierarchicalKeywordField** photo_metadata_hierarchical_keyword_tags = NULL;
static gint photo_metadata_hierarchical_keyword_tags_length1 = 0;
static gint _photo_metadata_hierarchical_keyword_tags_size_ = 0;
static gchar** photo_metadata_artist_tags;
static gint photo_metadata_artist_tags_length1;
static gchar** photo_metadata_artist_tags = NULL;
static gint photo_metadata_artist_tags_length1 = 0;
static gint _photo_metadata_artist_tags_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;

static void hierarchical_keyword_field_finalize (HierarchicalKeywordField * obj);
static GType hierarchical_keyword_field_get_type_once (void);
static GBytes* photo_preview_real_flatten (PhotoPreview* self,
                                    GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self,
                                          GError** error);
static void photo_preview_finalize (PhotoPreview * obj);
static GType photo_preview_get_type_once (void);
static void photo_metadata_real_read_from_file (MediaMetadata* base,
                                         GFile* file,
                                         GError** error);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self,
                                          GCompareDataFunc compare_func,
                                          gpointer compare_func_target,
                                          GDestroyNotify compare_func_target_destroy_notify);
static void photo_metadata_set_all_generic (PhotoMetadata* self,
                                     gchar** tags,
                                     gint tags_length1,
                                     PhotoMetadataSetOption option,
                                     PhotoMetadataSetGenericValue setter,
                                     gpointer setter_target);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda4_ (Block3Data* _data3_,
                 const gchar* tag);
static void ___lambda4__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
static void _vala_array_add94 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add95 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda5_ (Block4Data* _data4_,
                 const gchar* tag);
static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda6_ (Block5Data* _data5_,
                 const gchar* tag);
static void ___lambda6__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda7_ (Block6Data* _data6_,
                 const gchar* tag);
static void ___lambda7__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda8_ (Block7Data* _data7_,
                 const gchar* tag);
static void ___lambda8__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
static guint8* _vala_array_dup17 (guint8* self,
                           gssize length);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner,
                                                                              const gchar* name,
                                                                              guint number,
                                                                              GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type,
                                                                                    PhotoMetadata* owner,
                                                                                    const gchar* name,
                                                                                    guint number,
                                                                                    GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
static gchar* photo_metadata_real_get_title (MediaMetadata* base);
static gchar* photo_metadata_real_get_comment (MediaMetadata* base);
VALA_EXTERN gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self,
                                                        HierarchicalTagIndex* index);
VALA_EXTERN GeeList* hierarchical_tag_utilities_enumerate_path_components (const gchar* in_path);
VALA_EXTERN gchar* hierarchical_tag_utilities_canonicalize (const gchar* in_tag,
                                                const gchar* foreign_separator);
static GBytes* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base,
                                                            GError** error);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview * obj);
static GType photo_metadata_internal_photo_preview_get_type_once (void);
static void photo_metadata_finalize (MediaMetadata * obj);
static GType photo_metadata_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
metadata_domain_get_type_once (void)
{
	static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
	GType metadata_domain_type_id;
	metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
	return metadata_domain_type_id;
}

GType
metadata_domain_get_type (void)
{
	static volatile gsize metadata_domain_type_id__once = 0;
	if (g_once_init_enter (&metadata_domain_type_id__once)) {
		GType metadata_domain_type_id;
		metadata_domain_type_id = metadata_domain_get_type_once ();
		g_once_init_leave (&metadata_domain_type_id__once, metadata_domain_type_id);
	}
	return metadata_domain_type_id__once;
}

HierarchicalKeywordField*
hierarchical_keyword_field_construct (GType object_type,
                                      const gchar* field_name,
                                      const gchar* path_separator,
                                      gboolean wants_leading_separator,
                                      gboolean is_writeable)
{
	HierarchicalKeywordField* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 50 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (field_name != NULL, NULL);
#line 50 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (path_separator != NULL, NULL);
#line 50 "../src/photos/PhotoMetadata.vala"
	self = (HierarchicalKeywordField*) g_type_create_instance (object_type);
#line 52 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (field_name);
#line 52 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 52 "../src/photos/PhotoMetadata.vala"
	self->field_name = _tmp0_;
#line 53 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (path_separator);
#line 53 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 53 "../src/photos/PhotoMetadata.vala"
	self->path_separator = _tmp1_;
#line 54 "../src/photos/PhotoMetadata.vala"
	self->wants_leading_separator = wants_leading_separator;
#line 55 "../src/photos/PhotoMetadata.vala"
	self->is_writeable = is_writeable;
#line 50 "../src/photos/PhotoMetadata.vala"
	return self;
#line 363 "PhotoMetadata.c"
}

HierarchicalKeywordField*
hierarchical_keyword_field_new (const gchar* field_name,
                                const gchar* path_separator,
                                gboolean wants_leading_separator,
                                gboolean is_writeable)
{
#line 50 "../src/photos/PhotoMetadata.vala"
	return hierarchical_keyword_field_construct (TYPE_HIERARCHICAL_KEYWORD_FIELD, field_name, path_separator, wants_leading_separator, is_writeable);
#line 374 "PhotoMetadata.c"
}

static void
value_hierarchical_keyword_field_init (GValue* value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 382 "PhotoMetadata.c"
}

static void
value_hierarchical_keyword_field_free_value (GValue* value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 44 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (value->data[0].v_pointer);
#line 392 "PhotoMetadata.c"
	}
}

static void
value_hierarchical_keyword_field_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 44 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = hierarchical_keyword_field_ref (src_value->data[0].v_pointer);
#line 404 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 408 "PhotoMetadata.c"
	}
}

static gpointer
value_hierarchical_keyword_field_peek_pointer (const GValue* value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 417 "PhotoMetadata.c"
}

static gchar*
value_hierarchical_keyword_field_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 428 "PhotoMetadata.c"
		HierarchicalKeywordField * object;
		object = collect_values[0].v_pointer;
#line 44 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 44 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 435 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 44 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 439 "PhotoMetadata.c"
		}
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = hierarchical_keyword_field_ref (object);
#line 443 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 447 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 451 "PhotoMetadata.c"
}

static gchar*
value_hierarchical_keyword_field_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	HierarchicalKeywordField ** object_p;
	object_p = collect_values[0].v_pointer;
#line 44 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 44 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 466 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 44 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 472 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 44 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 476 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		*object_p = hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 480 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 484 "PhotoMetadata.c"
}

GParamSpec*
param_spec_hierarchical_keyword_field (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	ParamSpecHierarchicalKeywordField* spec;
#line 44 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 44 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 44 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 44 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 503 "PhotoMetadata.c"
}

gpointer
value_get_hierarchical_keyword_field (const GValue* value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 44 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 513 "PhotoMetadata.c"
}

void
value_set_hierarchical_keyword_field (GValue* value,
                                      gpointer v_object)
{
	HierarchicalKeywordField * old;
#line 44 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 44 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 44 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 44 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 535 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 539 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 44 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 545 "PhotoMetadata.c"
	}
}

void
value_take_hierarchical_keyword_field (GValue* value,
                                       gpointer v_object)
{
	HierarchicalKeywordField * old;
#line 44 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 44 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 44 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 566 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 570 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 44 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 576 "PhotoMetadata.c"
	}
}

static void
hierarchical_keyword_field_class_init (HierarchicalKeywordFieldClass * klass,
                                       gpointer klass_data)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	hierarchical_keyword_field_parent_class = g_type_class_peek_parent (klass);
#line 44 "../src/photos/PhotoMetadata.vala"
	((HierarchicalKeywordFieldClass *) klass)->finalize = hierarchical_keyword_field_finalize;
#line 588 "PhotoMetadata.c"
}

static void
hierarchical_keyword_field_instance_init (HierarchicalKeywordField * self,
                                          gpointer klass)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 597 "PhotoMetadata.c"
}

static void
hierarchical_keyword_field_finalize (HierarchicalKeywordField * obj)
{
	HierarchicalKeywordField * self;
#line 44 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField);
#line 44 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 45 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 46 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 612 "PhotoMetadata.c"
}

static GType
hierarchical_keyword_field_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_hierarchical_keyword_field_init, value_hierarchical_keyword_field_free_value, value_hierarchical_keyword_field_copy_value, value_hierarchical_keyword_field_peek_pointer, "p", value_hierarchical_keyword_field_collect_value, "p", value_hierarchical_keyword_field_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HierarchicalKeywordFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hierarchical_keyword_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HierarchicalKeywordField), 0, (GInstanceInitFunc) hierarchical_keyword_field_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType hierarchical_keyword_field_type_id;
	hierarchical_keyword_field_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HierarchicalKeywordField", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return hierarchical_keyword_field_type_id;
}

GType
hierarchical_keyword_field_get_type (void)
{
	static volatile gsize hierarchical_keyword_field_type_id__once = 0;
	if (g_once_init_enter (&hierarchical_keyword_field_type_id__once)) {
		GType hierarchical_keyword_field_type_id;
		hierarchical_keyword_field_type_id = hierarchical_keyword_field_get_type_once ();
		g_once_init_leave (&hierarchical_keyword_field_type_id__once, hierarchical_keyword_field_type_id);
	}
	return hierarchical_keyword_field_type_id__once;
}

gpointer
hierarchical_keyword_field_ref (gpointer instance)
{
	HierarchicalKeywordField * self;
	self = instance;
#line 44 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 44 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 647 "PhotoMetadata.c"
}

void
hierarchical_keyword_field_unref (gpointer instance)
{
	HierarchicalKeywordField * self;
	self = instance;
#line 44 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 44 "../src/photos/PhotoMetadata.vala"
		HIERARCHICAL_KEYWORD_FIELD_GET_CLASS (self)->finalize (self);
#line 44 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 661 "PhotoMetadata.c"
	}
}

static inline gpointer
photo_preview_get_instance_private (PhotoPreview* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPreview_private_offset);
}

PhotoPreview*
photo_preview_construct (GType object_type,
                         const gchar* name,
                         Dimensions* dimensions,
                         guint32 size,
                         const gchar* mime_type,
                         const gchar* extension)
{
	PhotoPreview* self = NULL;
	gchar* _tmp0_;
	Dimensions _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 66 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 66 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (dimensions != NULL, NULL);
#line 66 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 66 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 66 "../src/photos/PhotoMetadata.vala"
	self = (PhotoPreview*) g_type_create_instance (object_type);
#line 67 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (name);
#line 67 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 67 "../src/photos/PhotoMetadata.vala"
	self->priv->name = _tmp0_;
#line 68 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = *dimensions;
#line 68 "../src/photos/PhotoMetadata.vala"
	self->priv->dimensions = _tmp1_;
#line 69 "../src/photos/PhotoMetadata.vala"
	self->priv->size = size;
#line 70 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (mime_type);
#line 70 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 70 "../src/photos/PhotoMetadata.vala"
	self->priv->mime_type = _tmp2_;
#line 71 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup (extension);
#line 71 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 71 "../src/photos/PhotoMetadata.vala"
	self->priv->extension = _tmp3_;
#line 66 "../src/photos/PhotoMetadata.vala"
	return self;
#line 720 "PhotoMetadata.c"
}

gchar*
photo_preview_get_name (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 74 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->name;
#line 75 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 75 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 75 "../src/photos/PhotoMetadata.vala"
	return result;
#line 739 "PhotoMetadata.c"
}

void
photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                    Dimensions* result)
{
	Dimensions _tmp0_;
#line 78 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->dimensions;
#line 79 "../src/photos/PhotoMetadata.vala"
	*result = _tmp0_;
#line 79 "../src/photos/PhotoMetadata.vala"
	return;
#line 755 "PhotoMetadata.c"
}

guint32
photo_preview_get_size (PhotoPreview* self)
{
	guint32 result;
#line 82 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 83 "../src/photos/PhotoMetadata.vala"
	result = self->priv->size;
#line 83 "../src/photos/PhotoMetadata.vala"
	return result;
#line 768 "PhotoMetadata.c"
}

gchar*
photo_preview_get_mime_type (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 86 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->mime_type;
#line 87 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 87 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 87 "../src/photos/PhotoMetadata.vala"
	return result;
#line 787 "PhotoMetadata.c"
}

gchar*
photo_preview_get_extension (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 90 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->extension;
#line 91 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 91 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 91 "../src/photos/PhotoMetadata.vala"
	return result;
#line 806 "PhotoMetadata.c"
}

static GBytes*
photo_preview_real_flatten (PhotoPreview* self,
                            GError** error)
{
#line 94 "../src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 94 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 817 "PhotoMetadata.c"
}

GBytes*
photo_preview_flatten (PhotoPreview* self,
                       GError** error)
{
	PhotoPreviewClass* _klass_;
#line 94 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../src/photos/PhotoMetadata.vala"
	_klass_ = PHOTO_PREVIEW_GET_CLASS (self);
#line 94 "../src/photos/PhotoMetadata.vala"
	if (_klass_->flatten) {
#line 94 "../src/photos/PhotoMetadata.vala"
		return _klass_->flatten (self, error);
#line 833 "PhotoMetadata.c"
	}
#line 94 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 837 "PhotoMetadata.c"
}

static GdkPixbuf*
photo_preview_real_get_pixbuf (PhotoPreview* self,
                               GError** error)
{
	GBytes* flattened = NULL;
	GBytes* _tmp0_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 97 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_preview_flatten (self, &_inner_error0_);
#line 97 "../src/photos/PhotoMetadata.vala"
	flattened = _tmp0_;
#line 97 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 97 "../src/photos/PhotoMetadata.vala"
		return NULL;
#line 858 "PhotoMetadata.c"
	}
	{
		GdkPixbuf* _tmp1_ = NULL;
		GMemoryInputStream* _tmp2_;
		GMemoryInputStream* _tmp3_;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = (GMemoryInputStream*) g_memory_input_stream_new_from_bytes (flattened);
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = gdk_pixbuf_new_from_stream ((GInputStream*) _tmp3_, NULL, &_inner_error0_);
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp3_);
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = _tmp5_;
#line 102 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 881 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp1_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = NULL;
#line 102 "../src/photos/PhotoMetadata.vala"
		result = _tmp6_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp1_);
#line 102 "../src/photos/PhotoMetadata.vala"
		_g_bytes_unref0 (flattened);
#line 102 "../src/photos/PhotoMetadata.vala"
		return result;
#line 896 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 101 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 101 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 104 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->name;
#line 104 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = err;
#line 104 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp8_->message;
#line 104 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:104: Unable to decode thumbnail for %s: %s", _tmp7_, _tmp9_);
#line 106 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 106 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 106 "../src/photos/PhotoMetadata.vala"
		_g_bytes_unref0 (flattened);
#line 106 "../src/photos/PhotoMetadata.vala"
		return result;
#line 925 "PhotoMetadata.c"
	}
	__finally0:
#line 101 "../src/photos/PhotoMetadata.vala"
	g_propagate_error (error, _inner_error0_);
#line 101 "../src/photos/PhotoMetadata.vala"
	_g_bytes_unref0 (flattened);
#line 101 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 934 "PhotoMetadata.c"
}

GdkPixbuf*
photo_preview_get_pixbuf (PhotoPreview* self,
                          GError** error)
{
	PhotoPreviewClass* _klass_;
#line 96 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "../src/photos/PhotoMetadata.vala"
	_klass_ = PHOTO_PREVIEW_GET_CLASS (self);
#line 96 "../src/photos/PhotoMetadata.vala"
	if (_klass_->get_pixbuf) {
#line 96 "../src/photos/PhotoMetadata.vala"
		return _klass_->get_pixbuf (self, error);
#line 950 "PhotoMetadata.c"
	}
#line 96 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 954 "PhotoMetadata.c"
}

static void
value_photo_preview_init (GValue* value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 962 "PhotoMetadata.c"
}

static void
value_photo_preview_free_value (GValue* value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 59 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (value->data[0].v_pointer);
#line 972 "PhotoMetadata.c"
	}
}

static void
value_photo_preview_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 59 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
#line 984 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 988 "PhotoMetadata.c"
	}
}

static gpointer
value_photo_preview_peek_pointer (const GValue* value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 997 "PhotoMetadata.c"
}

static gchar*
value_photo_preview_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1008 "PhotoMetadata.c"
		PhotoPreview * object;
		object = collect_values[0].v_pointer;
#line 59 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 59 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1015 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 59 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1019 "PhotoMetadata.c"
		}
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = photo_preview_ref (object);
#line 1023 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1027 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1031 "PhotoMetadata.c"
}

static gchar*
value_photo_preview_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	PhotoPreview ** object_p;
	object_p = collect_values[0].v_pointer;
#line 59 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 59 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1046 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 59 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 1052 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 59 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1056 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		*object_p = photo_preview_ref (value->data[0].v_pointer);
#line 1060 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1064 "PhotoMetadata.c"
}

GParamSpec*
param_spec_photo_preview (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecPhotoPreview* spec;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
#line 59 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 59 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 59 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1083 "PhotoMetadata.c"
}

gpointer
value_get_photo_preview (const GValue* value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
#line 59 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1093 "PhotoMetadata.c"
}

void
value_set_photo_preview (GValue* value,
                         gpointer v_object)
{
	PhotoPreview * old;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 59 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 59 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 59 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 59 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 59 "../src/photos/PhotoMetadata.vala"
		photo_preview_ref (value->data[0].v_pointer);
#line 1115 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1119 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 59 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 1125 "PhotoMetadata.c"
	}
}

void
value_take_photo_preview (GValue* value,
                          gpointer v_object)
{
	PhotoPreview * old;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 59 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 59 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 59 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 59 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1146 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1150 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 59 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 1156 "PhotoMetadata.c"
	}
}

static void
photo_preview_class_init (PhotoPreviewClass * klass,
                          gpointer klass_data)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 59 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_preview_finalize;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPreview_private_offset);
#line 59 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = (GBytes* (*) (PhotoPreview*, GError**)) photo_preview_real_flatten;
#line 59 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoPreview*, GError**)) photo_preview_real_get_pixbuf;
#line 1174 "PhotoMetadata.c"
}

static void
photo_preview_instance_init (PhotoPreview * self,
                             gpointer klass)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	self->priv = photo_preview_get_instance_private (self);
#line 59 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 1185 "PhotoMetadata.c"
}

static void
photo_preview_finalize (PhotoPreview * obj)
{
	PhotoPreview * self;
#line 59 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_PREVIEW, PhotoPreview);
#line 59 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 60 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 63 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 64 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 1202 "PhotoMetadata.c"
}

static GType
photo_preview_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_preview_type_id;
	photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	PhotoPreview_private_offset = g_type_add_instance_private (photo_preview_type_id, sizeof (PhotoPreviewPrivate));
	return photo_preview_type_id;
}

GType
photo_preview_get_type (void)
{
	static volatile gsize photo_preview_type_id__once = 0;
	if (g_once_init_enter (&photo_preview_type_id__once)) {
		GType photo_preview_type_id;
		photo_preview_type_id = photo_preview_get_type_once ();
		g_once_init_leave (&photo_preview_type_id__once, photo_preview_type_id);
	}
	return photo_preview_type_id__once;
}

gpointer
photo_preview_ref (gpointer instance)
{
	PhotoPreview * self;
	self = instance;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 59 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 1238 "PhotoMetadata.c"
}

void
photo_preview_unref (gpointer instance)
{
	PhotoPreview * self;
	self = instance;
#line 59 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 59 "../src/photos/PhotoMetadata.vala"
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
#line 59 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1252 "PhotoMetadata.c"
	}
}

static inline gpointer
photo_metadata_get_instance_private (PhotoMetadata* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoMetadata_private_offset);
}

static GType
photo_metadata_set_option_get_type_once (void)
{
	static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
	GType photo_metadata_set_option_type_id;
	photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
	return photo_metadata_set_option_type_id;
}

GType
photo_metadata_set_option_get_type (void)
{
	static volatile gsize photo_metadata_set_option_type_id__once = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__once)) {
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = photo_metadata_set_option_get_type_once ();
		g_once_init_leave (&photo_metadata_set_option_type_id__once, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__once;
}

PhotoMetadata*
photo_metadata_construct (GType object_type)
{
	PhotoMetadata* self = NULL;
#line 151 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) media_metadata_construct (object_type);
#line 151 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1291 "PhotoMetadata.c"
}

PhotoMetadata*
photo_metadata_new (void)
{
#line 151 "../src/photos/PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 1299 "PhotoMetadata.c"
}

static void
photo_metadata_real_read_from_file (MediaMetadata* base,
                                    GFile* file,
                                    GError** error)
{
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	ExifData* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 154 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 154 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (file != NULL);
#line 155 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 155 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 155 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 156 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 156 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 158 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 158 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_file_get_path (file);
#line 158 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 158 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_path (_tmp1_, _tmp3_, &_inner_error0_);
#line 158 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 158 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 158 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 158 "../src/photos/PhotoMetadata.vala"
		return;
#line 1347 "PhotoMetadata.c"
	}
#line 159 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = g_file_get_path (file);
#line 159 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 159 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = exif_data_new_from_file (_tmp5_);
#line 159 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 159 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp6_;
#line 159 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp5_);
#line 160 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_file_get_basename (file);
#line 160 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 160 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp7_;
#line 1367 "PhotoMetadata.c"
}

void
photo_metadata_write_to_file (PhotoMetadata* self,
                              GFile* file,
                              GError** error)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 163 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (file != NULL);
#line 164 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 164 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_file_get_path (file);
#line 164 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 164 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_save_file (_tmp0_, _tmp2_, &_inner_error0_);
#line 164 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 164 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 164 "../src/photos/PhotoMetadata.vala"
		return;
#line 1399 "PhotoMetadata.c"
	}
}

void
photo_metadata_read_from_buffer (PhotoMetadata* self,
                                 guint8* buffer,
                                 gint buffer_length1,
                                 gint length,
                                 GError** error)
{
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	ExifData* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/photos/PhotoMetadata.vala"
	if (length <= 0) {
#line 169 "../src/photos/PhotoMetadata.vala"
		length = buffer_length1;
#line 1421 "PhotoMetadata.c"
	}
#line 171 "../src/photos/PhotoMetadata.vala"
	_vala_assert (buffer_length1 >= length, "buffer.length >= length");
#line 173 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 173 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 173 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 174 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 174 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 176 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 176 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_buf (_tmp1_, buffer + 0, (glong) (length - 0), &_inner_error0_);
#line 176 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 176 "../src/photos/PhotoMetadata.vala"
		return;
#line 1445 "PhotoMetadata.c"
	}
#line 177 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = exif_data_new_from_data (buffer + 0, (gint) (length - 0));
#line 177 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 177 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp2_;
#line 178 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup_printf ("<memory buffer %d bytes>", length);
#line 178 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 178 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp3_;
#line 1459 "PhotoMetadata.c"
}

void
photo_metadata_read_from_app1_segment (PhotoMetadata* self,
                                       GBytes* buffer,
                                       GError** error)
{
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	gsize _tmp2_ = 0;
	guint8* _tmp3_;
	gsize _tmp4_ = 0;
	guint8* _tmp5_;
	ExifData* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 181 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (buffer != NULL);
#line 182 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 182 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 182 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 183 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 183 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 185 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 185 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_bytes_get_data (buffer, &_tmp2_);
#line 185 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (_tmp1_, _tmp3_, (glong) _tmp2_, &_inner_error0_);
#line 185 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 185 "../src/photos/PhotoMetadata.vala"
		return;
#line 1502 "PhotoMetadata.c"
	}
#line 186 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = g_bytes_get_data (buffer, &_tmp4_);
#line 186 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = exif_data_new_from_data (_tmp5_, (gint) _tmp4_);
#line 186 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 186 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp6_;
#line 187 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup_printf ("<app1 segment %zu bytes>", g_bytes_get_size (buffer));
#line 187 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 187 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp7_;
#line 1518 "PhotoMetadata.c"
}

MetadataDomain
photo_metadata_get_tag_domain (const gchar* tag)
{
	MetadataDomain result;
#line 190 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 191 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_exif_tag (tag)) {
#line 192 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_EXIF;
#line 192 "../src/photos/PhotoMetadata.vala"
		return result;
#line 1533 "PhotoMetadata.c"
	}
#line 194 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_xmp_tag (tag)) {
#line 195 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_XMP;
#line 195 "../src/photos/PhotoMetadata.vala"
		return result;
#line 1541 "PhotoMetadata.c"
	}
#line 197 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_iptc_tag (tag)) {
#line 198 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_IPTC;
#line 198 "../src/photos/PhotoMetadata.vala"
		return result;
#line 1549 "PhotoMetadata.c"
	}
#line 200 "../src/photos/PhotoMetadata.vala"
	result = METADATA_DOMAIN_UNKNOWN;
#line 200 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1555 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_domain (PhotoMetadata* self,
                           MetadataDomain domain)
{
	gboolean result;
#line 203 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 204 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 204 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1569 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 206 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 206 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_exif (_tmp0_);
#line 206 "../src/photos/PhotoMetadata.vala"
			return result;
#line 1578 "PhotoMetadata.c"
		}
#line 204 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1582 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 209 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 209 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_xmp (_tmp1_);
#line 209 "../src/photos/PhotoMetadata.vala"
			return result;
#line 1591 "PhotoMetadata.c"
		}
#line 204 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1595 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 212 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 212 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_iptc (_tmp2_);
#line 212 "../src/photos/PhotoMetadata.vala"
			return result;
#line 1604 "PhotoMetadata.c"
		}
		default:
#line 204 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 1609 "PhotoMetadata.c"
		{
#line 216 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 216 "../src/photos/PhotoMetadata.vala"
			return result;
#line 1615 "PhotoMetadata.c"
		}
	}
}

gboolean
photo_metadata_has_exif (PhotoMetadata* self)
{
	gboolean result;
#line 220 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 221 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 221 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1630 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_xmp (PhotoMetadata* self)
{
	gboolean result;
#line 224 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 225 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 225 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1643 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_iptc (PhotoMetadata* self)
{
	gboolean result;
#line 228 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 229 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 229 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1656 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_to_domain (PhotoMetadata* self,
                                    MetadataDomain domain)
{
	gboolean result;
#line 232 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 233 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 233 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1670 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 235 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 235 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_exif (_tmp0_);
#line 235 "../src/photos/PhotoMetadata.vala"
			return result;
#line 1679 "PhotoMetadata.c"
		}
#line 233 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1683 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 238 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 238 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_xmp (_tmp1_);
#line 238 "../src/photos/PhotoMetadata.vala"
			return result;
#line 1692 "PhotoMetadata.c"
		}
#line 233 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1696 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 241 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 241 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_iptc (_tmp2_);
#line 241 "../src/photos/PhotoMetadata.vala"
			return result;
#line 1705 "PhotoMetadata.c"
		}
		default:
#line 233 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 1710 "PhotoMetadata.c"
		{
#line 245 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 245 "../src/photos/PhotoMetadata.vala"
			return result;
#line 1716 "PhotoMetadata.c"
		}
	}
}

gboolean
photo_metadata_can_write_exif (PhotoMetadata* self)
{
	gboolean result;
#line 249 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 250 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 250 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1731 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_xmp (PhotoMetadata* self)
{
	gboolean result;
#line 253 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 254 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 254 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1744 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_iptc (PhotoMetadata* self)
{
	gboolean result;
#line 257 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 258 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 258 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1757 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_tag (PhotoMetadata* self,
                        const gchar* tag)
{
	GExiv2Metadata* _tmp0_;
	gboolean result;
#line 261 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 261 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 262 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 262 "../src/photos/PhotoMetadata.vala"
	result = gexiv2_metadata_has_tag (_tmp0_, tag);
#line 262 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1776 "PhotoMetadata.c"
}

static GeeSet*
photo_metadata_create_string_set (PhotoMetadata* self,
                                  GCompareDataFunc compare_func,
                                  gpointer compare_func_target,
                                  GDestroyNotify compare_func_target_destroy_notify)
{
	GeeSet* result;
#line 265 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 267 "../src/photos/PhotoMetadata.vala"
	if (compare_func == NULL) {
#line 1790 "PhotoMetadata.c"
		GeeHashSet* _tmp0_;
#line 268 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 268 "../src/photos/PhotoMetadata.vala"
		result = (GeeSet*) _tmp0_;
#line 268 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 268 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 268 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 268 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 268 "../src/photos/PhotoMetadata.vala"
		return result;
#line 1806 "PhotoMetadata.c"
	} else {
		GCompareDataFunc _tmp1_;
		gpointer _tmp1__target;
		GDestroyNotify _tmp1__target_destroy_notify;
		GeeTreeSet* _tmp2_;
#line 270 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = compare_func;
#line 270 "../src/photos/PhotoMetadata.vala"
		_tmp1__target = compare_func_target;
#line 270 "../src/photos/PhotoMetadata.vala"
		_tmp1__target_destroy_notify = compare_func_target_destroy_notify;
#line 270 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 270 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 270 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 270 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
#line 270 "../src/photos/PhotoMetadata.vala"
		result = (GeeSet*) _tmp2_;
#line 270 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 270 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 270 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 270 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 270 "../src/photos/PhotoMetadata.vala"
		return result;
#line 1838 "PhotoMetadata.c"
	}
}

GeeCollection*
photo_metadata_get_tags (PhotoMetadata* self,
                         MetadataDomain domain,
                         GCompareDataFunc compare_func,
                         gpointer compare_func_target,
                         GDestroyNotify compare_func_target_destroy_notify)
{
	gchar** tags = NULL;
	gint tags_length1;
	gint _tags_size_;
	gboolean _tmp9_ = FALSE;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GeeCollection* collection = NULL;
	GCompareDataFunc _tmp12_;
	gpointer _tmp12__target;
	GDestroyNotify _tmp12__target_destroy_notify;
	GeeSet* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	GeeCollection* result;
#line 273 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 275 "../src/photos/PhotoMetadata.vala"
	tags = NULL;
#line 275 "../src/photos/PhotoMetadata.vala"
	tags_length1 = 0;
#line 275 "../src/photos/PhotoMetadata.vala"
	_tags_size_ = tags_length1;
#line 276 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 276 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1875 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
			gchar** _tmp1_;
			gchar** _tmp2_;
#line 278 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 278 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _tmp1_ = gexiv2_metadata_get_exif_tags (_tmp0_);
#line 278 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 278 "../src/photos/PhotoMetadata.vala"
			tags = _tmp2_;
#line 278 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp1_);
#line 278 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 279 "../src/photos/PhotoMetadata.vala"
			break;
#line 1894 "PhotoMetadata.c"
		}
#line 276 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1898 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
			gchar** _tmp4_;
			gchar** _tmp5_;
#line 282 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 282 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _tmp4_ = gexiv2_metadata_get_xmp_tags (_tmp3_);
#line 282 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 282 "../src/photos/PhotoMetadata.vala"
			tags = _tmp5_;
#line 282 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp4_);
#line 282 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 283 "../src/photos/PhotoMetadata.vala"
			break;
#line 1917 "PhotoMetadata.c"
		}
#line 276 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1921 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp6_;
			gchar** _tmp7_;
			gchar** _tmp8_;
#line 286 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = self->priv->exiv2;
#line 286 "../src/photos/PhotoMetadata.vala"
			_tmp8_ = _tmp7_ = gexiv2_metadata_get_iptc_tags (_tmp6_);
#line 286 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 286 "../src/photos/PhotoMetadata.vala"
			tags = _tmp8_;
#line 286 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp7_);
#line 286 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 287 "../src/photos/PhotoMetadata.vala"
			break;
#line 1940 "PhotoMetadata.c"
		}
		default:
#line 276 "../src/photos/PhotoMetadata.vala"
		break;
#line 1945 "PhotoMetadata.c"
	}
#line 290 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = tags;
#line 290 "../src/photos/PhotoMetadata.vala"
	_tmp10__length1 = tags_length1;
#line 290 "../src/photos/PhotoMetadata.vala"
	if (_tmp10_ == NULL) {
#line 290 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = TRUE;
#line 1955 "PhotoMetadata.c"
	} else {
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 290 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = tags;
#line 290 "../src/photos/PhotoMetadata.vala"
		_tmp11__length1 = tags_length1;
#line 290 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp11__length1 == 0;
#line 1965 "PhotoMetadata.c"
	}
#line 290 "../src/photos/PhotoMetadata.vala"
	if (_tmp9_) {
#line 291 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 291 "../src/photos/PhotoMetadata.vala"
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 291 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 291 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 291 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 291 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 291 "../src/photos/PhotoMetadata.vala"
		return result;
#line 1983 "PhotoMetadata.c"
	}
#line 293 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = compare_func;
#line 293 "../src/photos/PhotoMetadata.vala"
	_tmp12__target = compare_func_target;
#line 293 "../src/photos/PhotoMetadata.vala"
	_tmp12__target_destroy_notify = compare_func_target_destroy_notify;
#line 293 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 293 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 293 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 293 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = photo_metadata_create_string_set (self, _tmp12_, _tmp12__target, _tmp12__target_destroy_notify);
#line 293 "../src/photos/PhotoMetadata.vala"
	collection = (GeeCollection*) _tmp13_;
#line 294 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = tags;
#line 294 "../src/photos/PhotoMetadata.vala"
	_tmp14__length1 = tags_length1;
#line 2005 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 294 "../src/photos/PhotoMetadata.vala"
		tag_collection = _tmp14_;
#line 294 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp14__length1;
#line 294 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 2017 "PhotoMetadata.c"
			gchar* _tmp15_;
			gchar* tag = NULL;
#line 294 "../src/photos/PhotoMetadata.vala"
			_tmp15_ = g_strdup (tag_collection[tag_it]);
#line 294 "../src/photos/PhotoMetadata.vala"
			tag = _tmp15_;
#line 2024 "PhotoMetadata.c"
			{
				GeeCollection* _tmp16_;
				const gchar* _tmp17_;
#line 295 "../src/photos/PhotoMetadata.vala"
				_tmp16_ = collection;
#line 295 "../src/photos/PhotoMetadata.vala"
				_tmp17_ = tag;
#line 295 "../src/photos/PhotoMetadata.vala"
				gee_collection_add (_tmp16_, _tmp17_);
#line 294 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2036 "PhotoMetadata.c"
			}
		}
	}
#line 297 "../src/photos/PhotoMetadata.vala"
	result = collection;
#line 297 "../src/photos/PhotoMetadata.vala"
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 297 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 297 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 297 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 297 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 297 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2054 "PhotoMetadata.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 316 "../src/photos/PhotoMetadata.vala"
	return self ? g_object_ref (self) : NULL;
#line 2062 "PhotoMetadata.c"
}

GeeCollection*
photo_metadata_get_all_tags (PhotoMetadata* self,
                             GCompareDataFunc compare_func,
                             gpointer compare_func_target,
                             GDestroyNotify compare_func_target_destroy_notify)
{
	GeeCollection* all_tags = NULL;
	GCompareDataFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeeSet* _tmp1_;
	GeeCollection* exif_tags = NULL;
	GeeCollection* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeCollection* _tmp4_;
	GeeCollection* xmp_tags = NULL;
	GeeCollection* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GeeCollection* _tmp12_;
	GeeCollection* iptc_tags = NULL;
	GeeCollection* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp26_ = NULL;
	GeeCollection* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GeeCollection* _tmp31_;
	GeeCollection* result;
#line 300 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 302 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 302 "../src/photos/PhotoMetadata.vala"
	_tmp0__target = compare_func_target;
#line 302 "../src/photos/PhotoMetadata.vala"
	_tmp0__target_destroy_notify = compare_func_target_destroy_notify;
#line 302 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 302 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 302 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 302 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 302 "../src/photos/PhotoMetadata.vala"
	all_tags = (GeeCollection*) _tmp1_;
#line 304 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL, NULL, NULL);
#line 304 "../src/photos/PhotoMetadata.vala"
	exif_tags = _tmp2_;
#line 305 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = exif_tags;
#line 305 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 2120 "PhotoMetadata.c"
		GeeCollection* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 305 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = exif_tags;
#line 305 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = gee_collection_get_size (_tmp5_);
#line 305 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 305 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp7_ > 0;
#line 2132 "PhotoMetadata.c"
	} else {
#line 305 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = FALSE;
#line 2136 "PhotoMetadata.c"
	}
#line 305 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 2140 "PhotoMetadata.c"
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
#line 306 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = all_tags;
#line 306 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = exif_tags;
#line 306 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp8_, _tmp9_);
#line 2149 "PhotoMetadata.c"
	}
#line 308 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL, NULL, NULL);
#line 308 "../src/photos/PhotoMetadata.vala"
	xmp_tags = _tmp10_;
#line 309 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = xmp_tags;
#line 309 "../src/photos/PhotoMetadata.vala"
	if (_tmp12_ != NULL) {
#line 2159 "PhotoMetadata.c"
		GeeCollection* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 309 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = xmp_tags;
#line 309 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = gee_collection_get_size (_tmp13_);
#line 309 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp14_;
#line 309 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp15_ > 0;
#line 2171 "PhotoMetadata.c"
	} else {
#line 309 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = FALSE;
#line 2175 "PhotoMetadata.c"
	}
#line 309 "../src/photos/PhotoMetadata.vala"
	if (_tmp11_) {
#line 2179 "PhotoMetadata.c"
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
#line 310 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = all_tags;
#line 310 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = xmp_tags;
#line 310 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp16_, _tmp17_);
#line 2188 "PhotoMetadata.c"
	}
#line 312 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL, NULL, NULL);
#line 312 "../src/photos/PhotoMetadata.vala"
	iptc_tags = _tmp18_;
#line 313 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = iptc_tags;
#line 313 "../src/photos/PhotoMetadata.vala"
	if (_tmp20_ != NULL) {
#line 2198 "PhotoMetadata.c"
		GeeCollection* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 313 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = iptc_tags;
#line 313 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = gee_collection_get_size (_tmp21_);
#line 313 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = _tmp22_;
#line 313 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp23_ > 0;
#line 2210 "PhotoMetadata.c"
	} else {
#line 313 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 2214 "PhotoMetadata.c"
	}
#line 313 "../src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 2218 "PhotoMetadata.c"
		GeeCollection* _tmp24_;
		GeeCollection* _tmp25_;
#line 314 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = all_tags;
#line 314 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = iptc_tags;
#line 314 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp24_, _tmp25_);
#line 2227 "PhotoMetadata.c"
	}
#line 316 "../src/photos/PhotoMetadata.vala"
	_tmp27_ = all_tags;
#line 316 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = gee_collection_get_size (_tmp27_);
#line 316 "../src/photos/PhotoMetadata.vala"
	_tmp29_ = _tmp28_;
#line 316 "../src/photos/PhotoMetadata.vala"
	if (_tmp29_ > 0) {
#line 2237 "PhotoMetadata.c"
		GeeCollection* _tmp30_;
#line 316 "../src/photos/PhotoMetadata.vala"
		_tmp30_ = all_tags;
#line 316 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp30_;
#line 2243 "PhotoMetadata.c"
	} else {
#line 316 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = NULL;
#line 2247 "PhotoMetadata.c"
	}
#line 316 "../src/photos/PhotoMetadata.vala"
	_tmp31_ = _g_object_ref0 (_tmp26_);
#line 316 "../src/photos/PhotoMetadata.vala"
	result = _tmp31_;
#line 316 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (iptc_tags);
#line 316 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (xmp_tags);
#line 316 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (exif_tags);
#line 316 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (all_tags);
#line 316 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 316 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 316 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 316 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 316 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2271 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_tag_label (PhotoMetadata* self,
                              const gchar* tag)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 319 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 319 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 320 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_get_tag_label (tag);
#line 320 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 320 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 320 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2293 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_tag_description (PhotoMetadata* self,
                                    const gchar* tag)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 323 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 324 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_get_tag_description (tag);
#line 324 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 324 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 324 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2315 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_string (PhotoMetadata* self,
                           const gchar* tag,
                           PrepareInputTextOptions options)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 327 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 327 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 328 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 328 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_string (_tmp0_, tag);
#line 328 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 328 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepare_input_text (_tmp2_, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 328 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 328 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 328 "../src/photos/PhotoMetadata.vala"
	result = _tmp4_;
#line 328 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2349 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_string_interpreted (PhotoMetadata* self,
                                       const gchar* tag,
                                       PrepareInputTextOptions options)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 331 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 331 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 332 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 332 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_interpreted_string (_tmp0_, tag);
#line 332 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 332 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepare_input_text (_tmp2_, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 332 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 332 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 332 "../src/photos/PhotoMetadata.vala"
	result = _tmp4_;
#line 332 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2383 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_first_string (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1)
{
	gchar* result;
#line 335 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2394 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 336 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 336 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 336 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 2406 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 336 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 336 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 2413 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
#line 337 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 337 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string (self, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 337 "../src/photos/PhotoMetadata.vala"
				value = _tmp2_;
#line 338 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 338 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 339 "../src/photos/PhotoMetadata.vala"
					result = value;
#line 339 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 339 "../src/photos/PhotoMetadata.vala"
					return result;
#line 2435 "PhotoMetadata.c"
				}
#line 336 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 336 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2441 "PhotoMetadata.c"
			}
		}
	}
#line 342 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 342 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2449 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_first_string_interpreted (PhotoMetadata* self,
                                             gchar** tags,
                                             gint tags_length1)
{
	gchar* result;
#line 345 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2460 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 346 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 346 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 346 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 2472 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 346 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 346 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 2479 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
#line 347 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 347 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string_interpreted (self, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 347 "../src/photos/PhotoMetadata.vala"
				value = _tmp2_;
#line 348 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 348 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 349 "../src/photos/PhotoMetadata.vala"
					result = value;
#line 349 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 349 "../src/photos/PhotoMetadata.vala"
					return result;
#line 2501 "PhotoMetadata.c"
				}
#line 346 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 346 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2507 "PhotoMetadata.c"
			}
		}
	}
#line 352 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 352 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2515 "PhotoMetadata.c"
}

GeeList*
photo_metadata_get_string_multiple (PhotoMetadata* self,
                                    const gchar* tag)
{
	gchar** values = NULL;
	GExiv2Metadata* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint values_length1;
	gint _values_size_;
	gboolean _tmp3_ = FALSE;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GeeList* list = NULL;
	GeeArrayList* _tmp6_;
	GeeHashSet* collection = NULL;
	GeeHashSet* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GeeList* _tmp20_ = NULL;
	GeeList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GeeList* _tmp25_;
	GeeList* result;
#line 361 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 361 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 362 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 362 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_tag_multiple (_tmp0_, tag);
#line 362 "../src/photos/PhotoMetadata.vala"
	values = _tmp2_;
#line 362 "../src/photos/PhotoMetadata.vala"
	values_length1 = _vala_array_length (_tmp1_);
#line 362 "../src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 363 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = values;
#line 363 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = values_length1;
#line 363 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 363 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 2565 "PhotoMetadata.c"
	} else {
		gchar** _tmp5_;
		gint _tmp5__length1;
#line 363 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = values;
#line 363 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = values_length1;
#line 363 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1 == 0;
#line 2575 "PhotoMetadata.c"
	}
#line 363 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 364 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 364 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 364 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2585 "PhotoMetadata.c"
	}
#line 366 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 366 "../src/photos/PhotoMetadata.vala"
	list = (GeeList*) _tmp6_;
#line 368 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 368 "../src/photos/PhotoMetadata.vala"
	collection = _tmp7_;
#line 369 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = values;
#line 369 "../src/photos/PhotoMetadata.vala"
	_tmp8__length1 = values_length1;
#line 2599 "PhotoMetadata.c"
	{
		gchar** value_collection = NULL;
		gint value_collection_length1 = 0;
		gint _value_collection_size_ = 0;
		gint value_it = 0;
#line 369 "../src/photos/PhotoMetadata.vala"
		value_collection = _tmp8_;
#line 369 "../src/photos/PhotoMetadata.vala"
		value_collection_length1 = _tmp8__length1;
#line 369 "../src/photos/PhotoMetadata.vala"
		for (value_it = 0; value_it < value_collection_length1; value_it = value_it + 1) {
#line 2611 "PhotoMetadata.c"
			gchar* _tmp9_;
			gchar* value = NULL;
#line 369 "../src/photos/PhotoMetadata.vala"
			_tmp9_ = g_strdup (value_collection[value_it]);
#line 369 "../src/photos/PhotoMetadata.vala"
			value = _tmp9_;
#line 2618 "PhotoMetadata.c"
			{
				gchar* prepped = NULL;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gboolean _tmp12_ = FALSE;
				const gchar* _tmp13_;
#line 370 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = value;
#line 370 "../src/photos/PhotoMetadata.vala"
				_tmp11_ = prepare_input_text (_tmp10_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 370 "../src/photos/PhotoMetadata.vala"
				prepped = _tmp11_;
#line 373 "../src/photos/PhotoMetadata.vala"
				_tmp13_ = prepped;
#line 373 "../src/photos/PhotoMetadata.vala"
				if (_tmp13_ != NULL) {
#line 2635 "PhotoMetadata.c"
					GeeHashSet* _tmp14_;
					const gchar* _tmp15_;
#line 373 "../src/photos/PhotoMetadata.vala"
					_tmp14_ = collection;
#line 373 "../src/photos/PhotoMetadata.vala"
					_tmp15_ = prepped;
#line 373 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 2644 "PhotoMetadata.c"
				} else {
#line 373 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = FALSE;
#line 2648 "PhotoMetadata.c"
				}
#line 373 "../src/photos/PhotoMetadata.vala"
				if (_tmp12_) {
#line 2652 "PhotoMetadata.c"
					GeeList* _tmp16_;
					const gchar* _tmp17_;
					GeeHashSet* _tmp18_;
					const gchar* _tmp19_;
#line 374 "../src/photos/PhotoMetadata.vala"
					_tmp16_ = list;
#line 374 "../src/photos/PhotoMetadata.vala"
					_tmp17_ = prepped;
#line 374 "../src/photos/PhotoMetadata.vala"
					gee_collection_add ((GeeCollection*) _tmp16_, _tmp17_);
#line 375 "../src/photos/PhotoMetadata.vala"
					_tmp18_ = collection;
#line 375 "../src/photos/PhotoMetadata.vala"
					_tmp19_ = prepped;
#line 375 "../src/photos/PhotoMetadata.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 2669 "PhotoMetadata.c"
				}
#line 369 "../src/photos/PhotoMetadata.vala"
				_g_free0 (prepped);
#line 369 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 2675 "PhotoMetadata.c"
			}
		}
	}
#line 379 "../src/photos/PhotoMetadata.vala"
	_tmp21_ = list;
#line 379 "../src/photos/PhotoMetadata.vala"
	_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
#line 379 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = _tmp22_;
#line 379 "../src/photos/PhotoMetadata.vala"
	if (_tmp23_ > 0) {
#line 2687 "PhotoMetadata.c"
		GeeList* _tmp24_;
#line 379 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = list;
#line 379 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = _tmp24_;
#line 2693 "PhotoMetadata.c"
	} else {
#line 379 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = NULL;
#line 2697 "PhotoMetadata.c"
	}
#line 379 "../src/photos/PhotoMetadata.vala"
	_tmp25_ = _g_object_ref0 (_tmp20_);
#line 379 "../src/photos/PhotoMetadata.vala"
	result = _tmp25_;
#line 379 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (collection);
#line 379 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (list);
#line 379 "../src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 379 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2711 "PhotoMetadata.c"
}

GeeList*
photo_metadata_get_first_string_multiple (PhotoMetadata* self,
                                          gchar** tags,
                                          gint tags_length1)
{
	GeeList* result;
#line 388 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2722 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 389 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 389 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 389 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 2734 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 389 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 389 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 2741 "PhotoMetadata.c"
			{
				GeeList* values = NULL;
				const gchar* _tmp1_;
				GeeList* _tmp2_;
				gboolean _tmp3_ = FALSE;
				GeeList* _tmp4_;
#line 390 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 390 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string_multiple (self, _tmp1_);
#line 390 "../src/photos/PhotoMetadata.vala"
				values = _tmp2_;
#line 391 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = values;
#line 391 "../src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 2758 "PhotoMetadata.c"
					GeeList* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
#line 391 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = values;
#line 391 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 391 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = _tmp6_;
#line 391 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = _tmp7_ > 0;
#line 2770 "PhotoMetadata.c"
				} else {
#line 391 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = FALSE;
#line 2774 "PhotoMetadata.c"
				}
#line 391 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 392 "../src/photos/PhotoMetadata.vala"
					result = values;
#line 392 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 392 "../src/photos/PhotoMetadata.vala"
					return result;
#line 2784 "PhotoMetadata.c"
				}
#line 389 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 389 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2790 "PhotoMetadata.c"
			}
		}
	}
#line 395 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 395 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2798 "PhotoMetadata.c"
}

void
photo_metadata_set_string (PhotoMetadata* self,
                           const gchar* tag,
                           const gchar* value,
                           PrepareInputTextOptions options)
{
	gchar* prepped = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GExiv2Metadata* _tmp2_;
	const gchar* _tmp3_;
#line 398 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 398 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 398 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 399 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = prepare_input_text (value, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 399 "../src/photos/PhotoMetadata.vala"
	prepped = _tmp0_;
#line 400 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = prepped;
#line 400 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 401 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:401: Not setting tag %s to string %s: invalid UTF-8", tag, value);
#line 403 "../src/photos/PhotoMetadata.vala"
		_g_free0 (prepped);
#line 403 "../src/photos/PhotoMetadata.vala"
		return;
#line 2832 "PhotoMetadata.c"
	}
#line 406 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exiv2;
#line 406 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepped;
#line 406 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_string (_tmp2_, tag, _tmp3_)) {
#line 2840 "PhotoMetadata.c"
		const gchar* _tmp4_;
#line 407 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->source_name;
#line 407 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:407: Unable to set tag %s to string %s from source " \
"%s", tag, value, _tmp4_);
#line 2846 "PhotoMetadata.c"
	}
#line 398 "../src/photos/PhotoMetadata.vala"
	_g_free0 (prepped);
#line 2850 "PhotoMetadata.c"
}

static void
photo_metadata_set_all_generic (PhotoMetadata* self,
                                gchar** tags,
                                gint tags_length1,
                                PhotoMetadataSetOption option,
                                PhotoMetadataSetGenericValue setter,
                                gpointer setter_target)
{
	gboolean written = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 412 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/photos/PhotoMetadata.vala"
	written = FALSE;
#line 2868 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 414 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 414 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 414 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 2880 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 414 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 414 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 2887 "PhotoMetadata.c"
			{
				gboolean _tmp1_ = FALSE;
#line 415 "../src/photos/PhotoMetadata.vala"
				if (option == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
#line 415 "../src/photos/PhotoMetadata.vala"
					_tmp1_ = TRUE;
#line 2894 "PhotoMetadata.c"
				} else {
					const gchar* _tmp2_;
#line 415 "../src/photos/PhotoMetadata.vala"
					_tmp2_ = tag;
#line 415 "../src/photos/PhotoMetadata.vala"
					_tmp1_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (_tmp2_));
#line 2901 "PhotoMetadata.c"
				}
#line 415 "../src/photos/PhotoMetadata.vala"
				if (_tmp1_) {
#line 2905 "PhotoMetadata.c"
					const gchar* _tmp3_;
#line 416 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = tag;
#line 416 "../src/photos/PhotoMetadata.vala"
					setter (_tmp3_, setter_target);
#line 417 "../src/photos/PhotoMetadata.vala"
					written = TRUE;
#line 2913 "PhotoMetadata.c"
				}
#line 414 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2917 "PhotoMetadata.c"
			}
		}
	}
#line 421 "../src/photos/PhotoMetadata.vala"
	if (option == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = !written;
#line 2925 "PhotoMetadata.c"
	} else {
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = FALSE;
#line 2929 "PhotoMetadata.c"
	}
#line 421 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_) {
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = tags_length1 > 0;
#line 2935 "PhotoMetadata.c"
	} else {
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 2939 "PhotoMetadata.c"
	}
#line 421 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 2943 "PhotoMetadata.c"
		MetadataDomain default_domain = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 422 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = tags[0];
#line 422 "../src/photos/PhotoMetadata.vala"
		default_domain = photo_metadata_get_tag_domain (_tmp6_);
#line 425 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = tags[0];
#line 425 "../src/photos/PhotoMetadata.vala"
		setter (_tmp7_, setter_target);
#line 2955 "PhotoMetadata.c"
		{
			gint ctr = 0;
#line 428 "../src/photos/PhotoMetadata.vala"
			ctr = 1;
#line 2960 "PhotoMetadata.c"
			{
				gboolean _tmp8_ = FALSE;
#line 428 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = TRUE;
#line 428 "../src/photos/PhotoMetadata.vala"
				while (TRUE) {
#line 2967 "PhotoMetadata.c"
					const gchar* _tmp10_;
#line 428 "../src/photos/PhotoMetadata.vala"
					if (!_tmp8_) {
#line 2971 "PhotoMetadata.c"
						gint _tmp9_;
#line 428 "../src/photos/PhotoMetadata.vala"
						_tmp9_ = ctr;
#line 428 "../src/photos/PhotoMetadata.vala"
						ctr = _tmp9_ + 1;
#line 2977 "PhotoMetadata.c"
					}
#line 428 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = FALSE;
#line 428 "../src/photos/PhotoMetadata.vala"
					if (!(ctr < tags_length1)) {
#line 428 "../src/photos/PhotoMetadata.vala"
						break;
#line 2985 "PhotoMetadata.c"
					}
#line 429 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = tags[ctr];
#line 429 "../src/photos/PhotoMetadata.vala"
					if (photo_metadata_get_tag_domain (_tmp10_) == default_domain) {
#line 2991 "PhotoMetadata.c"
						const gchar* _tmp11_;
#line 430 "../src/photos/PhotoMetadata.vala"
						_tmp11_ = tags[ctr];
#line 430 "../src/photos/PhotoMetadata.vala"
						setter (_tmp11_, setter_target);
#line 2997 "PhotoMetadata.c"
					}
				}
			}
		}
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 435 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 435 "../src/photos/PhotoMetadata.vala"
	return _data3_;
#line 3012 "PhotoMetadata.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 435 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 3022 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 435 "../src/photos/PhotoMetadata.vala"
		self = _data3_->self;
#line 435 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_data3_->value);
#line 435 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 435 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block3Data, _data3_);
#line 3032 "PhotoMetadata.c"
	}
}

static void
__lambda4_ (Block3Data* _data3_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 436 "../src/photos/PhotoMetadata.vala"
	self = _data3_->self;
#line 436 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 437 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, tag, _data3_->value, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 3047 "PhotoMetadata.c"
}

static void
___lambda4__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 436 "../src/photos/PhotoMetadata.vala"
	__lambda4_ (self, tag);
#line 3056 "PhotoMetadata.c"
}

void
photo_metadata_set_all_string (PhotoMetadata* self,
                               gchar** tags,
                               gint tags_length1,
                               const gchar* value,
                               PhotoMetadataSetOption option)
{
	Block3Data* _data3_;
	gchar* _tmp0_;
#line 435 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 435 "../src/photos/PhotoMetadata.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 435 "../src/photos/PhotoMetadata.vala"
	_data3_->_ref_count_ = 1;
#line 435 "../src/photos/PhotoMetadata.vala"
	_data3_->self = media_metadata_ref (self);
#line 435 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (value);
#line 435 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_data3_->value);
#line 435 "../src/photos/PhotoMetadata.vala"
	_data3_->value = _tmp0_;
#line 436 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda4__photo_metadata_set_generic_value, _data3_);
#line 435 "../src/photos/PhotoMetadata.vala"
	block3_data_unref (_data3_);
#line 435 "../src/photos/PhotoMetadata.vala"
	_data3_ = NULL;
#line 3090 "PhotoMetadata.c"
}

static void
_vala_array_add94 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 446 "../src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 446 "../src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 446 "../src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3105 "PhotoMetadata.c"
	}
#line 446 "../src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 446 "../src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3111 "PhotoMetadata.c"
}

static void
_vala_array_add95 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 458 "../src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 458 "../src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 458 "../src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3126 "PhotoMetadata.c"
	}
#line 458 "../src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 458 "../src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3132 "PhotoMetadata.c"
}

void
photo_metadata_set_string_multiple (PhotoMetadata* self,
                                    const gchar* tag,
                                    GeeCollection* collection)
{
	gchar** values = NULL;
	gchar** _tmp0_;
	gint values_length1;
	gint _values_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	GExiv2Metadata* _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
#line 441 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 441 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 441 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (collection != NULL);
#line 442 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 442 "../src/photos/PhotoMetadata.vala"
	values = _tmp0_;
#line 442 "../src/photos/PhotoMetadata.vala"
	values_length1 = 0;
#line 442 "../src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 3163 "PhotoMetadata.c"
	{
		GeeIterator* _value_it = NULL;
		GeeIterator* _tmp1_;
#line 443 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) collection);
#line 443 "../src/photos/PhotoMetadata.vala"
		_value_it = _tmp1_;
#line 443 "../src/photos/PhotoMetadata.vala"
		while (TRUE) {
#line 3173 "PhotoMetadata.c"
			GeeIterator* _tmp2_;
			gchar* value = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gchar* prepped = NULL;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			const gchar* _tmp7_;
#line 443 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _value_it;
#line 443 "../src/photos/PhotoMetadata.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 443 "../src/photos/PhotoMetadata.vala"
				break;
#line 3188 "PhotoMetadata.c"
			}
#line 443 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _value_it;
#line 443 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 443 "../src/photos/PhotoMetadata.vala"
			value = (gchar*) _tmp4_;
#line 444 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = value;
#line 444 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = prepare_input_text (_tmp5_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, -1);
#line 444 "../src/photos/PhotoMetadata.vala"
			prepped = _tmp6_;
#line 445 "../src/photos/PhotoMetadata.vala"
			_tmp7_ = prepped;
#line 445 "../src/photos/PhotoMetadata.vala"
			if (_tmp7_ != NULL) {
#line 3206 "PhotoMetadata.c"
				const gchar* _tmp8_;
				gchar* _tmp9_;
#line 446 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = prepped;
#line 446 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 446 "../src/photos/PhotoMetadata.vala"
				_vala_array_add94 (&values, &values_length1, &_values_size_, _tmp9_);
#line 3215 "PhotoMetadata.c"
			} else {
				const gchar* _tmp10_;
#line 448 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = value;
#line 448 "../src/photos/PhotoMetadata.vala"
				g_warning ("PhotoMetadata.vala:448: Unable to set string %s to %s: invalid UTF-8", _tmp10_, tag);
#line 3222 "PhotoMetadata.c"
			}
#line 443 "../src/photos/PhotoMetadata.vala"
			_g_free0 (prepped);
#line 443 "../src/photos/PhotoMetadata.vala"
			_g_free0 (value);
#line 3228 "PhotoMetadata.c"
		}
#line 443 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_value_it);
#line 3232 "PhotoMetadata.c"
	}
#line 451 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = values;
#line 451 "../src/photos/PhotoMetadata.vala"
	_tmp11__length1 = values_length1;
#line 451 "../src/photos/PhotoMetadata.vala"
	if (_tmp11__length1 == 0) {
#line 452 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 452 "../src/photos/PhotoMetadata.vala"
		return;
#line 3244 "PhotoMetadata.c"
	}
#line 458 "../src/photos/PhotoMetadata.vala"
	_vala_array_add95 (&values, &values_length1, &_values_size_, NULL);
#line 460 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = self->priv->exiv2;
#line 460 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = values;
#line 460 "../src/photos/PhotoMetadata.vala"
	_tmp13__length1 = values_length1;
#line 460 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_multiple (_tmp12_, tag, _tmp13_)) {
#line 3256 "PhotoMetadata.c"
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
#line 461 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = values;
#line 461 "../src/photos/PhotoMetadata.vala"
		_tmp14__length1 = values_length1;
#line 461 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = self->priv->source_name;
#line 461 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:461: Unable to set %d strings to tag %s from source" \
" %s", _tmp14__length1, tag, _tmp15_);
#line 3268 "PhotoMetadata.c"
	}
#line 441 "../src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 3272 "PhotoMetadata.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 464 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 464 "../src/photos/PhotoMetadata.vala"
	return _data4_;
#line 3282 "PhotoMetadata.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 464 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 3292 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 464 "../src/photos/PhotoMetadata.vala"
		self = _data4_->self;
#line 464 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_data4_->values);
#line 464 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 464 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block4Data, _data4_);
#line 3302 "PhotoMetadata.c"
	}
}

static void
__lambda5_ (Block4Data* _data4_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 465 "../src/photos/PhotoMetadata.vala"
	self = _data4_->self;
#line 465 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 466 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string_multiple (self, tag, _data4_->values);
#line 3317 "PhotoMetadata.c"
}

static void
___lambda5__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 465 "../src/photos/PhotoMetadata.vala"
	__lambda5_ (self, tag);
#line 3326 "PhotoMetadata.c"
}

void
photo_metadata_set_all_string_multiple (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1,
                                        GeeCollection* values,
                                        PhotoMetadataSetOption option)
{
	Block4Data* _data4_;
	GeeCollection* _tmp0_;
#line 464 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 464 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (values != NULL);
#line 464 "../src/photos/PhotoMetadata.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 464 "../src/photos/PhotoMetadata.vala"
	_data4_->_ref_count_ = 1;
#line 464 "../src/photos/PhotoMetadata.vala"
	_data4_->self = media_metadata_ref (self);
#line 464 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _g_object_ref0 (values);
#line 464 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_data4_->values);
#line 464 "../src/photos/PhotoMetadata.vala"
	_data4_->values = _tmp0_;
#line 465 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda5__photo_metadata_set_generic_value, _data4_);
#line 464 "../src/photos/PhotoMetadata.vala"
	block4_data_unref (_data4_);
#line 464 "../src/photos/PhotoMetadata.vala"
	_data4_ = NULL;
#line 3360 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_long (PhotoMetadata* self,
                         const gchar* tag,
                         glong* value)
{
	glong _vala_value = 0L;
	GExiv2Metadata* _tmp0_;
	gboolean result;
#line 470 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 470 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 471 "../src/photos/PhotoMetadata.vala"
	if (!photo_metadata_has_tag (self, tag)) {
#line 472 "../src/photos/PhotoMetadata.vala"
		_vala_value = (glong) 0;
#line 474 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 474 "../src/photos/PhotoMetadata.vala"
		if (value) {
#line 474 "../src/photos/PhotoMetadata.vala"
			*value = _vala_value;
#line 3385 "PhotoMetadata.c"
		}
#line 474 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3389 "PhotoMetadata.c"
	}
#line 477 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 477 "../src/photos/PhotoMetadata.vala"
	_vala_value = gexiv2_metadata_get_tag_long (_tmp0_, tag);
#line 479 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 479 "../src/photos/PhotoMetadata.vala"
	if (value) {
#line 479 "../src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3401 "PhotoMetadata.c"
	}
#line 479 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3405 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_first_long (PhotoMetadata* self,
                               gchar** tags,
                               gint tags_length1,
                               glong* value)
{
	glong _vala_value = 0L;
	gboolean result;
#line 482 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3418 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 483 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 483 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 483 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 3430 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 483 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 483 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 3437 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
				glong _tmp2_ = 0L;
				gboolean _tmp3_;
#line 484 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 484 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_long (self, _tmp1_, &_tmp2_);
#line 484 "../src/photos/PhotoMetadata.vala"
				_vala_value = _tmp2_;
#line 484 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 485 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 485 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 485 "../src/photos/PhotoMetadata.vala"
					if (value) {
#line 485 "../src/photos/PhotoMetadata.vala"
						*value = _vala_value;
#line 3458 "PhotoMetadata.c"
					}
#line 485 "../src/photos/PhotoMetadata.vala"
					return result;
#line 3462 "PhotoMetadata.c"
				}
#line 483 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3466 "PhotoMetadata.c"
			}
		}
	}
#line 488 "../src/photos/PhotoMetadata.vala"
	_vala_value = (glong) 0;
#line 490 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 490 "../src/photos/PhotoMetadata.vala"
	if (value) {
#line 490 "../src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3478 "PhotoMetadata.c"
	}
#line 490 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3482 "PhotoMetadata.c"
}

void
photo_metadata_set_long (PhotoMetadata* self,
                         const gchar* tag,
                         glong value)
{
	GExiv2Metadata* _tmp0_;
#line 493 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 494 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 494 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_long (_tmp0_, tag, value)) {
#line 3499 "PhotoMetadata.c"
		const gchar* _tmp1_;
#line 495 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->source_name;
#line 495 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:495: Unable to set tag %s to long %ld from source %" \
"s", tag, value, _tmp1_);
#line 3505 "PhotoMetadata.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 498 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 498 "../src/photos/PhotoMetadata.vala"
	return _data5_;
#line 3516 "PhotoMetadata.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 498 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 3526 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 498 "../src/photos/PhotoMetadata.vala"
		self = _data5_->self;
#line 498 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 498 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block5Data, _data5_);
#line 3534 "PhotoMetadata.c"
	}
}

static void
__lambda6_ (Block5Data* _data5_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 499 "../src/photos/PhotoMetadata.vala"
	self = _data5_->self;
#line 499 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 500 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_long (self, tag, _data5_->value);
#line 3549 "PhotoMetadata.c"
}

static void
___lambda6__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 499 "../src/photos/PhotoMetadata.vala"
	__lambda6_ (self, tag);
#line 3558 "PhotoMetadata.c"
}

void
photo_metadata_set_all_long (PhotoMetadata* self,
                             gchar** tags,
                             gint tags_length1,
                             glong value,
                             PhotoMetadataSetOption option)
{
	Block5Data* _data5_;
#line 498 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 498 "../src/photos/PhotoMetadata.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 498 "../src/photos/PhotoMetadata.vala"
	_data5_->_ref_count_ = 1;
#line 498 "../src/photos/PhotoMetadata.vala"
	_data5_->self = media_metadata_ref (self);
#line 498 "../src/photos/PhotoMetadata.vala"
	_data5_->value = value;
#line 499 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda6__photo_metadata_set_generic_value, _data5_);
#line 498 "../src/photos/PhotoMetadata.vala"
	block5_data_unref (_data5_);
#line 498 "../src/photos/PhotoMetadata.vala"
	_data5_ = NULL;
#line 3585 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_rational (PhotoMetadata* self,
                             const gchar* tag,
                             MetadataRational* rational)
{
	MetadataRational _vala_rational = {0};
	gint numerator = 0;
	gint denominator = 0;
	gboolean _result_ = FALSE;
	GExiv2Metadata* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gboolean result;
#line 504 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 504 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 506 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 506 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_get_exif_tag_rational (_tmp0_, tag, &_tmp1_, &_tmp2_);
#line 506 "../src/photos/PhotoMetadata.vala"
	numerator = _tmp1_;
#line 506 "../src/photos/PhotoMetadata.vala"
	denominator = _tmp2_;
#line 506 "../src/photos/PhotoMetadata.vala"
	_result_ = _tmp3_;
#line 508 "../src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, numerator, denominator);
#line 510 "../src/photos/PhotoMetadata.vala"
	result = _result_;
#line 510 "../src/photos/PhotoMetadata.vala"
	if (rational) {
#line 510 "../src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 3624 "PhotoMetadata.c"
	}
#line 510 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3628 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_first_rational (PhotoMetadata* self,
                                   gchar** tags,
                                   gint tags_length1,
                                   MetadataRational* rational)
{
	MetadataRational _vala_rational = {0};
	gboolean result;
#line 513 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3641 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 514 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 514 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 514 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 3653 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 514 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 514 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 3660 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
				MetadataRational _tmp2_ = {0};
				gboolean _tmp3_;
#line 515 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 515 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_rational (self, _tmp1_, &_tmp2_);
#line 515 "../src/photos/PhotoMetadata.vala"
				_vala_rational = _tmp2_;
#line 515 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 516 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 516 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 516 "../src/photos/PhotoMetadata.vala"
					if (rational) {
#line 516 "../src/photos/PhotoMetadata.vala"
						*rational = _vala_rational;
#line 3681 "PhotoMetadata.c"
					}
#line 516 "../src/photos/PhotoMetadata.vala"
					return result;
#line 3685 "PhotoMetadata.c"
				}
#line 514 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3689 "PhotoMetadata.c"
			}
		}
	}
#line 519 "../src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, 0, 0);
#line 521 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 521 "../src/photos/PhotoMetadata.vala"
	if (rational) {
#line 521 "../src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 3701 "PhotoMetadata.c"
	}
#line 521 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3705 "PhotoMetadata.c"
}

void
photo_metadata_set_rational (PhotoMetadata* self,
                             const gchar* tag,
                             MetadataRational* rational)
{
	GExiv2Metadata* _tmp0_;
	MetadataRational _tmp1_;
	MetadataRational _tmp2_;
#line 524 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 524 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 524 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 525 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 525 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = *rational;
#line 525 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = *rational;
#line 525 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_exif_tag_rational (_tmp0_, tag, _tmp1_.numerator, _tmp2_.denominator)) {
#line 3730 "PhotoMetadata.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 526 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = metadata_rational_to_string (rational);
#line 526 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp3_;
#line 526 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = self->priv->source_name;
#line 526 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:526: Unable to set tag %s to rational %s from sourc" \
"e %s", tag, _tmp4_, _tmp5_);
#line 526 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp4_);
#line 3744 "PhotoMetadata.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 531 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 531 "../src/photos/PhotoMetadata.vala"
	return _data6_;
#line 3755 "PhotoMetadata.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 531 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 3765 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 531 "../src/photos/PhotoMetadata.vala"
		self = _data6_->self;
#line 531 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 531 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block6Data, _data6_);
#line 3773 "PhotoMetadata.c"
	}
}

static void
__lambda7_ (Block6Data* _data6_,
            const gchar* tag)
{
	PhotoMetadata* self;
	MetadataRational _tmp0_;
#line 532 "../src/photos/PhotoMetadata.vala"
	self = _data6_->self;
#line 532 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 533 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _data6_->rational;
#line 533 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_rational (self, tag, &_tmp0_);
#line 3791 "PhotoMetadata.c"
}

static void
___lambda7__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 532 "../src/photos/PhotoMetadata.vala"
	__lambda7_ (self, tag);
#line 3800 "PhotoMetadata.c"
}

void
photo_metadata_set_all_rational (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1,
                                 MetadataRational* rational,
                                 PhotoMetadataSetOption option)
{
	Block6Data* _data6_;
	MetadataRational _tmp0_;
#line 531 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 531 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 531 "../src/photos/PhotoMetadata.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 531 "../src/photos/PhotoMetadata.vala"
	_data6_->_ref_count_ = 1;
#line 531 "../src/photos/PhotoMetadata.vala"
	_data6_->self = media_metadata_ref (self);
#line 531 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = *rational;
#line 531 "../src/photos/PhotoMetadata.vala"
	_data6_->rational = _tmp0_;
#line 532 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda7__photo_metadata_set_generic_value, _data6_);
#line 531 "../src/photos/PhotoMetadata.vala"
	block6_data_unref (_data6_);
#line 531 "../src/photos/PhotoMetadata.vala"
	_data6_ = NULL;
#line 3832 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_date_time (PhotoMetadata* self,
                              const gchar* tag)
{
	gchar* value = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	MetadataDateTime* result;
#line 537 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 537 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 538 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string (self, tag, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 538 "../src/photos/PhotoMetadata.vala"
	value = _tmp0_;
#line 539 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = value;
#line 539 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 540 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 540 "../src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 540 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3862 "PhotoMetadata.c"
	}
	{
#line 543 "../src/photos/PhotoMetadata.vala"
		switch (photo_metadata_get_tag_domain (tag)) {
#line 543 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_XMP:
#line 3869 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp2_ = NULL;
				const gchar* _tmp3_;
				MetadataDateTime* _tmp4_;
				MetadataDateTime* _tmp5_;
#line 545 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 545 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = metadata_date_time_new_from_xmp (_tmp3_, &_inner_error0_);
#line 545 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = _tmp4_;
#line 545 "../src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3883 "PhotoMetadata.c"
					goto __catch0_g_error;
				}
#line 545 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = _tmp2_;
#line 545 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = NULL;
#line 545 "../src/photos/PhotoMetadata.vala"
				result = _tmp5_;
#line 545 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp2_);
#line 545 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 545 "../src/photos/PhotoMetadata.vala"
				return result;
#line 3898 "PhotoMetadata.c"
			}
#line 543 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_IPTC:
#line 3902 "PhotoMetadata.c"
			{
#line 550 "../src/photos/PhotoMetadata.vala"
				result = NULL;
#line 550 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 550 "../src/photos/PhotoMetadata.vala"
				return result;
#line 3910 "PhotoMetadata.c"
			}
			default:
#line 543 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_EXIF:
#line 3915 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp6_ = NULL;
				const gchar* _tmp7_;
				MetadataDateTime* _tmp8_;
				MetadataDateTime* _tmp9_;
#line 554 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = value;
#line 554 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = metadata_date_time_new_from_exif (_tmp7_, &_inner_error0_);
#line 554 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = _tmp8_;
#line 554 "../src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3929 "PhotoMetadata.c"
					goto __catch0_g_error;
				}
#line 554 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp6_;
#line 554 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = NULL;
#line 554 "../src/photos/PhotoMetadata.vala"
				result = _tmp9_;
#line 554 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp6_);
#line 554 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 554 "../src/photos/PhotoMetadata.vala"
				return result;
#line 3944 "PhotoMetadata.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 542 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 542 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 557 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = self->priv->source_name;
#line 557 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = err;
#line 557 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = _tmp11_->message;
#line 557 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:557: Unable to read date/time %s from source %s: %s", tag, _tmp10_, _tmp12_);
#line 559 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 559 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 559 "../src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 559 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3975 "PhotoMetadata.c"
	}
	__finally0:
#line 542 "../src/photos/PhotoMetadata.vala"
	_g_free0 (value);
#line 542 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 542 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 542 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 3986 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_first_date_time (PhotoMetadata* self,
                                    gchar** tags,
                                    gint tags_length1)
{
	MetadataDateTime* result;
#line 563 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3997 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 564 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 564 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 564 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4009 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 564 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 564 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4016 "PhotoMetadata.c"
			{
				MetadataDateTime* date_time = NULL;
				const gchar* _tmp1_;
				MetadataDateTime* _tmp2_;
				MetadataDateTime* _tmp3_;
#line 565 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 565 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_date_time (self, _tmp1_);
#line 565 "../src/photos/PhotoMetadata.vala"
				date_time = _tmp2_;
#line 566 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = date_time;
#line 566 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 567 "../src/photos/PhotoMetadata.vala"
					result = date_time;
#line 567 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 567 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4038 "PhotoMetadata.c"
				}
#line 564 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (date_time);
#line 564 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4044 "PhotoMetadata.c"
			}
		}
	}
#line 570 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 570 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4052 "PhotoMetadata.c"
}

void
photo_metadata_set_date_time (PhotoMetadata* self,
                              const gchar* tag,
                              MetadataDateTime* date_time)
{
#line 573 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 573 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 573 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (date_time != NULL);
#line 574 "../src/photos/PhotoMetadata.vala"
	switch (photo_metadata_get_tag_domain (tag)) {
#line 574 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 4070 "PhotoMetadata.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 576 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = metadata_date_time_get_exif_label (date_time);
#line 576 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _tmp0_;
#line 576 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 576 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp1_);
#line 577 "../src/photos/PhotoMetadata.vala"
			break;
#line 4084 "PhotoMetadata.c"
		}
#line 574 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 4088 "PhotoMetadata.c"
		{
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 580 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = metadata_date_time_get_xmp_label (date_time);
#line 580 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _tmp2_;
#line 580 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 580 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp3_);
#line 581 "../src/photos/PhotoMetadata.vala"
			break;
#line 4102 "PhotoMetadata.c"
		}
		default:
#line 574 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 4107 "PhotoMetadata.c"
		{
			const gchar* _tmp4_;
			GEnumValue* _tmp5_;
#line 586 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = self->priv->source_name;
#line 587 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), photo_metadata_get_tag_domain (tag));
#line 586 "../src/photos/PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:586: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", tag, _tmp4_, (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 588 "../src/photos/PhotoMetadata.vala"
			break;
#line 4119 "PhotoMetadata.c"
		}
	}
}

static gpointer
_metadata_date_time_ref0 (gpointer self)
{
#line 592 "../src/photos/PhotoMetadata.vala"
	return self ? metadata_date_time_ref (self) : NULL;
#line 4129 "PhotoMetadata.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 592 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 592 "../src/photos/PhotoMetadata.vala"
	return _data7_;
#line 4139 "PhotoMetadata.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 592 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 4149 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 592 "../src/photos/PhotoMetadata.vala"
		self = _data7_->self;
#line 592 "../src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (_data7_->date_time);
#line 592 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 592 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block7Data, _data7_);
#line 4159 "PhotoMetadata.c"
	}
}

static void
__lambda8_ (Block7Data* _data7_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 593 "../src/photos/PhotoMetadata.vala"
	self = _data7_->self;
#line 593 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 594 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_date_time (self, tag, _data7_->date_time);
#line 4174 "PhotoMetadata.c"
}

static void
___lambda8__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 593 "../src/photos/PhotoMetadata.vala"
	__lambda8_ (self, tag);
#line 4183 "PhotoMetadata.c"
}

void
photo_metadata_set_all_date_time (PhotoMetadata* self,
                                  gchar** tags,
                                  gint tags_length1,
                                  MetadataDateTime* date_time,
                                  PhotoMetadataSetOption option)
{
	Block7Data* _data7_;
	MetadataDateTime* _tmp0_;
#line 592 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 592 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (date_time != NULL);
#line 592 "../src/photos/PhotoMetadata.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 592 "../src/photos/PhotoMetadata.vala"
	_data7_->_ref_count_ = 1;
#line 592 "../src/photos/PhotoMetadata.vala"
	_data7_->self = media_metadata_ref (self);
#line 592 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _metadata_date_time_ref0 (date_time);
#line 592 "../src/photos/PhotoMetadata.vala"
	_metadata_date_time_unref0 (_data7_->date_time);
#line 592 "../src/photos/PhotoMetadata.vala"
	_data7_->date_time = _tmp0_;
#line 593 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda8__photo_metadata_set_generic_value, _data7_);
#line 592 "../src/photos/PhotoMetadata.vala"
	block7_data_unref (_data7_);
#line 592 "../src/photos/PhotoMetadata.vala"
	_data7_ = NULL;
#line 4217 "PhotoMetadata.c"
}

guint8*
photo_metadata_flatten_exif (PhotoMetadata* self,
                             gboolean include_preview,
                             gint* result_length1)
{
	ExifData* _tmp0_;
	guchar* thumbnail = NULL;
	ExifData* _tmp2_;
	guchar* _tmp3_;
	guint thumbnail_size = 0U;
	ExifData* _tmp4_;
	guint8* flattened = NULL;
	gint flattened_length1;
	gint _flattened_size_;
	guchar* saved_data = NULL;
	guint saved_size = 0U;
	ExifData* _tmp7_;
	gboolean _tmp8_ = FALSE;
	ExifData* _tmp16_;
	guchar* _tmp17_;
	ExifData* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	guint8* result;
#line 599 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 600 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exif;
#line 600 "../src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 4250 "PhotoMetadata.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 601 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = NULL;
#line 601 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = 0;
#line 601 "../src/photos/PhotoMetadata.vala"
		if (result_length1) {
#line 601 "../src/photos/PhotoMetadata.vala"
			*result_length1 = _tmp1__length1;
#line 4261 "PhotoMetadata.c"
		}
#line 601 "../src/photos/PhotoMetadata.vala"
		result = _tmp1_;
#line 601 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4267 "PhotoMetadata.c"
	}
#line 605 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exif;
#line 605 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_->data;
#line 605 "../src/photos/PhotoMetadata.vala"
	thumbnail = _tmp3_;
#line 606 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = self->priv->exif;
#line 606 "../src/photos/PhotoMetadata.vala"
	thumbnail_size = _tmp4_->size;
#line 607 "../src/photos/PhotoMetadata.vala"
	if (!include_preview) {
#line 4281 "PhotoMetadata.c"
		ExifData* _tmp5_;
		ExifData* _tmp6_;
#line 608 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = self->priv->exif;
#line 608 "../src/photos/PhotoMetadata.vala"
		_tmp5_->data = NULL;
#line 609 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 609 "../src/photos/PhotoMetadata.vala"
		_tmp6_->size = (guint) 0;
#line 4292 "PhotoMetadata.c"
	}
#line 612 "../src/photos/PhotoMetadata.vala"
	flattened = NULL;
#line 612 "../src/photos/PhotoMetadata.vala"
	flattened_length1 = 0;
#line 612 "../src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 615 "../src/photos/PhotoMetadata.vala"
	saved_data = NULL;
#line 616 "../src/photos/PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 617 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = self->priv->exif;
#line 617 "../src/photos/PhotoMetadata.vala"
	exif_data_save_data (_tmp7_, &saved_data, &saved_size);
#line 618 "../src/photos/PhotoMetadata.vala"
	if (saved_size > ((guint) 0)) {
#line 4310 "PhotoMetadata.c"
		guchar* _tmp9_;
#line 618 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = saved_data;
#line 618 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp9_ != NULL;
#line 4316 "PhotoMetadata.c"
	} else {
#line 618 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = FALSE;
#line 4320 "PhotoMetadata.c"
	}
#line 618 "../src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 4324 "PhotoMetadata.c"
		guint8* _tmp10_;
		guint8* _tmp11_;
		gint _tmp11__length1;
		guchar* _tmp12_;
		ExifMem* _tmp13_;
		ExifMem* _tmp14_;
		guchar* _tmp15_;
#line 619 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = g_new0 (guint8, saved_size);
#line 619 "../src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 619 "../src/photos/PhotoMetadata.vala"
		flattened = _tmp10_;
#line 619 "../src/photos/PhotoMetadata.vala"
		flattened_length1 = saved_size;
#line 619 "../src/photos/PhotoMetadata.vala"
		_flattened_size_ = flattened_length1;
#line 620 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = flattened;
#line 620 "../src/photos/PhotoMetadata.vala"
		_tmp11__length1 = flattened_length1;
#line 620 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = saved_data;
#line 620 "../src/photos/PhotoMetadata.vala"
		memcpy (_tmp11_, _tmp12_, (gsize) saved_size);
#line 622 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = exif_mem_new_default ();
#line 622 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = _tmp13_;
#line 622 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = saved_data;
#line 622 "../src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp14_, _tmp15_);
#line 622 "../src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp14_);
#line 4360 "PhotoMetadata.c"
	}
#line 626 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = self->priv->exif;
#line 626 "../src/photos/PhotoMetadata.vala"
	_tmp17_ = thumbnail;
#line 626 "../src/photos/PhotoMetadata.vala"
	_tmp16_->data = _tmp17_;
#line 627 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = self->priv->exif;
#line 627 "../src/photos/PhotoMetadata.vala"
	_tmp18_->size = thumbnail_size;
#line 629 "../src/photos/PhotoMetadata.vala"
	_tmp19_ = flattened;
#line 629 "../src/photos/PhotoMetadata.vala"
	_tmp19__length1 = flattened_length1;
#line 629 "../src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 629 "../src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp19__length1;
#line 4380 "PhotoMetadata.c"
	}
#line 629 "../src/photos/PhotoMetadata.vala"
	result = _tmp19_;
#line 629 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4386 "PhotoMetadata.c"
}

static guint8*
_vala_array_dup17 (guint8* self,
                   gssize length)
{
#line 635 "../src/photos/PhotoMetadata.vala"
	if (length > 0) {
#line 635 "../src/photos/PhotoMetadata.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 4397 "PhotoMetadata.c"
	}
#line 635 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 4401 "PhotoMetadata.c"
}

guint8*
photo_metadata_flatten_exif_preview (PhotoMetadata* self,
                                     gint* result_length1)
{
	guchar* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	guchar* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint __tmp0__size_ = 0;
	GExiv2Metadata* _tmp1_;
	guint8* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
	guint8* result;
#line 633 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 635 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 635 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_exif_thumbnail (_tmp1_, &_tmp2_, &_tmp3_);
#line 635 "../src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 635 "../src/photos/PhotoMetadata.vala"
	buffer = _tmp2_;
#line 635 "../src/photos/PhotoMetadata.vala"
	buffer_length1 = _tmp3_;
#line 635 "../src/photos/PhotoMetadata.vala"
	_buffer_size_ = buffer_length1;
#line 635 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 4439 "PhotoMetadata.c"
		guchar* _tmp5_;
		gint _tmp5__length1;
#line 635 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = buffer;
#line 635 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = buffer_length1;
#line 635 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp5_;
#line 635 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = _tmp5__length1;
#line 635 "../src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 4452 "PhotoMetadata.c"
	} else {
#line 635 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = NULL;
#line 635 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = 0;
#line 635 "../src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 4460 "PhotoMetadata.c"
	}
#line 635 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = (_tmp0_ != NULL) ? _vala_array_dup17 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 635 "../src/photos/PhotoMetadata.vala"
	_tmp6__length1 = _tmp0__length1;
#line 635 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 635 "../src/photos/PhotoMetadata.vala"
	_tmp7__length1 = _tmp6__length1;
#line 635 "../src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 635 "../src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp7__length1;
#line 4474 "PhotoMetadata.c"
	}
#line 635 "../src/photos/PhotoMetadata.vala"
	result = _tmp7_;
#line 635 "../src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 635 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4482 "PhotoMetadata.c"
}

guint
photo_metadata_get_preview_count (PhotoMetadata* self)
{
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	gint props_length1;
	gint _props_size_;
	gint _tmp3_ = 0;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	guint result;
#line 638 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 639 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 639 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 639 "../src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 639 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 639 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 641 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 641 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 641 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 4516 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 641 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 641 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 641 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1;
#line 4525 "PhotoMetadata.c"
	} else {
#line 641 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = 0;
#line 4529 "PhotoMetadata.c"
	}
#line 641 "../src/photos/PhotoMetadata.vala"
	result = (guint) _tmp3_;
#line 641 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4535 "PhotoMetadata.c"
}

PhotoPreview*
photo_metadata_get_preview (PhotoMetadata* self,
                            guint number)
{
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp3_ = FALSE;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp6_;
	GExiv2PreviewProperties** _tmp7_;
	gint _tmp7__length1;
	GExiv2PreviewProperties* _tmp8_;
	PhotoMetadataInternalPhotoPreview* _tmp9_;
	PhotoPreview* result;
#line 645 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 646 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 646 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 646 "../src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 646 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 646 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 647 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 647 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 647 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 647 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 4577 "PhotoMetadata.c"
	} else {
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 647 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 647 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 647 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = ((guint) _tmp5__length1) <= number;
#line 4587 "PhotoMetadata.c"
	}
#line 647 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 648 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 648 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4595 "PhotoMetadata.c"
	}
#line 650 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->source_name;
#line 650 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = props;
#line 650 "../src/photos/PhotoMetadata.vala"
	_tmp7__length1 = props_length1;
#line 650 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_[number];
#line 650 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = photo_metadata_internal_photo_preview_new (self, _tmp6_, number, _tmp8_);
#line 650 "../src/photos/PhotoMetadata.vala"
	result = (PhotoPreview*) _tmp9_;
#line 650 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4611 "PhotoMetadata.c"
}

void
photo_metadata_remove_exif_thumbnail (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
#line 653 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 654 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 654 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_erase_exif_thumbnail (_tmp0_);
#line 655 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exif;
#line 655 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 4629 "PhotoMetadata.c"
		ExifMem* _tmp2_;
		ExifMem* _tmp3_;
		ExifData* _tmp4_;
		guchar* _tmp5_;
		ExifData* _tmp6_;
		ExifData* _tmp7_;
#line 656 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = exif_mem_new_default ();
#line 656 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 656 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->exif;
#line 656 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_->data;
#line 656 "../src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp3_, _tmp5_);
#line 656 "../src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp3_);
#line 657 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 657 "../src/photos/PhotoMetadata.vala"
		_tmp6_->data = NULL;
#line 658 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 658 "../src/photos/PhotoMetadata.vala"
		_tmp7_->size = (guint) 0;
#line 4656 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_tag (PhotoMetadata* self,
                           const gchar* tag)
{
	GExiv2Metadata* _tmp0_;
#line 662 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 662 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 663 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 663 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear_tag (_tmp0_, tag);
#line 4673 "PhotoMetadata.c"
}

void
photo_metadata_remove_tags (PhotoMetadata* self,
                            gchar** tags,
                            gint tags_length1)
{
#line 666 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 4683 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 667 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 667 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 667 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4695 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 667 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 667 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4702 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
#line 668 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 668 "../src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp1_);
#line 667 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4711 "PhotoMetadata.c"
			}
		}
	}
}

void
photo_metadata_clear_domain (PhotoMetadata* self,
                             MetadataDomain domain)
{
#line 671 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 672 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 672 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 4727 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 674 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 674 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (_tmp0_);
#line 675 "../src/photos/PhotoMetadata.vala"
			break;
#line 4736 "PhotoMetadata.c"
		}
#line 672 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 4740 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 678 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 678 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (_tmp1_);
#line 679 "../src/photos/PhotoMetadata.vala"
			break;
#line 4749 "PhotoMetadata.c"
		}
#line 672 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 4753 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 682 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 682 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (_tmp2_);
#line 683 "../src/photos/PhotoMetadata.vala"
			break;
#line 4762 "PhotoMetadata.c"
		}
		default:
#line 672 "../src/photos/PhotoMetadata.vala"
		break;
#line 4767 "PhotoMetadata.c"
	}
}

void
photo_metadata_clear (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
#line 687 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 688 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 688 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear (_tmp0_);
#line 4781 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_modification_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 697 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 698 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_date_int64ags;
#line 698 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_date_int64ags_length1;
#line 698 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 698 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 698 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4803 "PhotoMetadata.c"
}

void
photo_metadata_set_modification_date_time (PhotoMetadata* self,
                                           MetadataDateTime* date_time,
                                           PhotoMetadataSetOption option)
{
#line 701 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 703 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 4815 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 704 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_date_int64ags;
#line 704 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_date_int64ags_length1;
#line 704 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 4824 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 706 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_date_int64ags;
#line 706 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_date_int64ags_length1;
#line 706 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 4834 "PhotoMetadata.c"
	}
}

MetadataDateTime*
photo_metadata_get_exposure_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 718 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 719 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_exposure_date_int64ags;
#line 719 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_exposure_date_int64ags_length1;
#line 719 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 719 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 719 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4857 "PhotoMetadata.c"
}

void
photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                       MetadataDateTime* date_time,
                                       PhotoMetadataSetOption option)
{
#line 722 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 724 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 4869 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 725 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_exposure_date_int64ags;
#line 725 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_exposure_date_int64ags_length1;
#line 725 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 4878 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 727 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_exposure_date_int64ags;
#line 727 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_exposure_date_int64ags_length1;
#line 727 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 4888 "PhotoMetadata.c"
	}
}

MetadataDateTime*
photo_metadata_get_digitized_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 735 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 736 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_digitized_date_int64ags;
#line 736 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_digitized_date_int64ags_length1;
#line 736 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 736 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 736 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4911 "PhotoMetadata.c"
}

void
photo_metadata_set_digitized_date_time (PhotoMetadata* self,
                                        MetadataDateTime* date_time,
                                        PhotoMetadataSetOption option)
{
#line 739 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 741 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 4923 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 742 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_digitized_date_int64ags;
#line 742 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_digitized_date_int64ags_length1;
#line 742 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 4932 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 744 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_digitized_date_int64ags;
#line 744 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_digitized_date_int64ags_length1;
#line 744 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 4942 "PhotoMetadata.c"
	}
}

static MetadataDateTime*
photo_metadata_real_get_creation_date_time (MediaMetadata* base)
{
	PhotoMetadata * self;
	MetadataDateTime* creation = NULL;
	MetadataDateTime* _tmp0_;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 747 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 748 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_exposure_date_time (self);
#line 748 "../src/photos/PhotoMetadata.vala"
	creation = _tmp0_;
#line 749 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = creation;
#line 749 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 4964 "PhotoMetadata.c"
		MetadataDateTime* _tmp2_;
#line 750 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_digitized_date_time (self);
#line 750 "../src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (creation);
#line 750 "../src/photos/PhotoMetadata.vala"
		creation = _tmp2_;
#line 4972 "PhotoMetadata.c"
	}
#line 752 "../src/photos/PhotoMetadata.vala"
	result = creation;
#line 752 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4978 "PhotoMetadata.c"
}

static gpointer
_dimensions_dup0 (gpointer self)
{
#line 783 "../src/photos/PhotoMetadata.vala"
	return self ? dimensions_dup (self) : NULL;
#line 4986 "PhotoMetadata.c"
}

Dimensions*
photo_metadata_get_pixel_dimensions (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	Dimensions* result;
#line 769 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 771 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_width_tags;
#line 771 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_width_tags_length1;
#line 771 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_height_tags;
#line 771 "../src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_height_tags_length1;
#line 771 "../src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp0__length1 == _tmp1__length1, "width_tags.length == height_tags.length");
#line 5009 "PhotoMetadata.c"
	{
		gint ctr = 0;
#line 772 "../src/photos/PhotoMetadata.vala"
		ctr = 0;
#line 5014 "PhotoMetadata.c"
		{
			gboolean _tmp2_ = FALSE;
#line 772 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = TRUE;
#line 772 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 5021 "PhotoMetadata.c"
				gchar** _tmp4_;
				gint _tmp4__length1;
				glong width = 0L;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				glong _tmp7_ = 0L;
				gboolean _tmp8_;
				glong height = 0L;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				glong _tmp11_ = 0L;
				gboolean _tmp12_;
				Dimensions _tmp13_ = {0};
				Dimensions* _tmp14_;
#line 772 "../src/photos/PhotoMetadata.vala"
				if (!_tmp2_) {
#line 5040 "PhotoMetadata.c"
					gint _tmp3_;
#line 772 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = ctr;
#line 772 "../src/photos/PhotoMetadata.vala"
					ctr = _tmp3_ + 1;
#line 5046 "PhotoMetadata.c"
				}
#line 772 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = FALSE;
#line 772 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_width_tags;
#line 772 "../src/photos/PhotoMetadata.vala"
				_tmp4__length1 = photo_metadata_width_tags_length1;
#line 772 "../src/photos/PhotoMetadata.vala"
				if (!(ctr < _tmp4__length1)) {
#line 772 "../src/photos/PhotoMetadata.vala"
					break;
#line 5058 "PhotoMetadata.c"
				}
#line 776 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_width_tags;
#line 776 "../src/photos/PhotoMetadata.vala"
				_tmp5__length1 = photo_metadata_width_tags_length1;
#line 776 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = _tmp5_[ctr];
#line 776 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = photo_metadata_get_long (self, _tmp6_, &_tmp7_);
#line 776 "../src/photos/PhotoMetadata.vala"
				width = _tmp7_;
#line 776 "../src/photos/PhotoMetadata.vala"
				if (!_tmp8_) {
#line 777 "../src/photos/PhotoMetadata.vala"
					continue;
#line 5074 "PhotoMetadata.c"
				}
#line 780 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = photo_metadata_height_tags;
#line 780 "../src/photos/PhotoMetadata.vala"
				_tmp9__length1 = photo_metadata_height_tags_length1;
#line 780 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = _tmp9_[ctr];
#line 780 "../src/photos/PhotoMetadata.vala"
				_tmp12_ = photo_metadata_get_long (self, _tmp10_, &_tmp11_);
#line 780 "../src/photos/PhotoMetadata.vala"
				height = _tmp11_;
#line 780 "../src/photos/PhotoMetadata.vala"
				if (!_tmp12_) {
#line 781 "../src/photos/PhotoMetadata.vala"
					continue;
#line 5090 "PhotoMetadata.c"
				}
#line 783 "../src/photos/PhotoMetadata.vala"
				dimensions_init (&_tmp13_, (gint) width, (gint) height);
#line 783 "../src/photos/PhotoMetadata.vala"
				_tmp14_ = _dimensions_dup0 (&_tmp13_);
#line 783 "../src/photos/PhotoMetadata.vala"
				result = _tmp14_;
#line 783 "../src/photos/PhotoMetadata.vala"
				return result;
#line 5100 "PhotoMetadata.c"
			}
		}
	}
#line 786 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 786 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5108 "PhotoMetadata.c"
}

void
photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                     Dimensions* dim,
                                     PhotoMetadataSetOption option)
{
#line 789 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 790 "../src/photos/PhotoMetadata.vala"
	if (dim != NULL) {
#line 5120 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 791 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_width_tags;
#line 791 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_width_tags_length1;
#line 791 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp0_, (gint) _tmp0__length1, (glong) (*dim).width, option);
#line 792 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_height_tags;
#line 792 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_height_tags_length1;
#line 792 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp1_, (gint) _tmp1__length1, (glong) (*dim).height, option);
#line 5137 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 794 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_width_tags;
#line 794 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_width_tags_length1;
#line 794 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp2_, (gint) _tmp2__length1);
#line 795 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_height_tags;
#line 795 "../src/photos/PhotoMetadata.vala"
		_tmp3__length1 = photo_metadata_height_tags_length1;
#line 795 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp3_, (gint) _tmp3__length1);
#line 5155 "PhotoMetadata.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 5177 "PhotoMetadata.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 5196 "PhotoMetadata.c"
}

static gchar*
photo_metadata_real_get_title (MediaMetadata* base)
{
	PhotoMetadata * self;
	GeeList* _tmp0_ = NULL;
	GeeList* titles = NULL;
	GeeList* _tmp4_;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GeeList* _tmp7_;
	gchar* title = NULL;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	const gchar* _tmp20_;
	gchar* _tmp24_;
	gchar* result;
#line 828 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 836 "../src/photos/PhotoMetadata.vala"
	if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 5222 "PhotoMetadata.c"
		GeeList* _tmp1_;
#line 837 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 837 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 837 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp1_;
#line 5230 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		GeeList* _tmp3_;
#line 838 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_standard_title_tags;
#line 838 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_standard_title_tags_length1;
#line 838 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_get_first_string_multiple (self, _tmp2_, (gint) _tmp2__length1);
#line 838 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 838 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp3_;
#line 5245 "PhotoMetadata.c"
	}
#line 836 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 836 "../src/photos/PhotoMetadata.vala"
	titles = _tmp4_;
#line 843 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = titles;
#line 843 "../src/photos/PhotoMetadata.vala"
	if (_tmp7_ != NULL) {
#line 5255 "PhotoMetadata.c"
		GeeList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = titles;
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = gee_collection_get_size ((GeeCollection*) _tmp8_);
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp9_;
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp10_ > 0;
#line 5267 "PhotoMetadata.c"
	} else {
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = FALSE;
#line 5271 "PhotoMetadata.c"
	}
#line 843 "../src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 5275 "PhotoMetadata.c"
		GeeList* _tmp11_;
		gpointer _tmp12_;
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = titles;
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = gee_list_get (_tmp11_, 0);
#line 843 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp5_);
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = (gchar*) _tmp12_;
#line 5286 "PhotoMetadata.c"
	} else {
#line 843 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp5_);
#line 843 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = NULL;
#line 5292 "PhotoMetadata.c"
	}
#line 843 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = g_strdup (_tmp5_);
#line 843 "../src/photos/PhotoMetadata.vala"
	title = _tmp13_;
#line 846 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = title;
#line 846 "../src/photos/PhotoMetadata.vala"
	if (_tmp14_ != NULL) {
#line 5302 "PhotoMetadata.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 847 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = title;
#line 847 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = string_strip (_tmp15_);
#line 847 "../src/photos/PhotoMetadata.vala"
		_g_free0 (title);
#line 847 "../src/photos/PhotoMetadata.vala"
		title = _tmp16_;
#line 5313 "PhotoMetadata.c"
	}
#line 850 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = title;
#line 850 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (_tmp20_)) {
#line 5319 "PhotoMetadata.c"
		const gchar* _tmp21_;
#line 850 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = title;
#line 850 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = !string_contains (_tmp21_, "\n");
#line 5325 "PhotoMetadata.c"
	} else {
#line 850 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 5329 "PhotoMetadata.c"
	}
#line 850 "../src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 5333 "PhotoMetadata.c"
		const gchar* _tmp22_;
#line 850 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = title;
#line 850 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = !string_contains (_tmp22_, "\r");
#line 5339 "PhotoMetadata.c"
	} else {
#line 850 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = FALSE;
#line 5343 "PhotoMetadata.c"
	}
#line 850 "../src/photos/PhotoMetadata.vala"
	if (_tmp18_) {
#line 5347 "PhotoMetadata.c"
		const gchar* _tmp23_;
#line 851 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = title;
#line 851 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = _tmp23_;
#line 5353 "PhotoMetadata.c"
	} else {
#line 851 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = NULL;
#line 5357 "PhotoMetadata.c"
	}
#line 850 "../src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup (_tmp17_);
#line 850 "../src/photos/PhotoMetadata.vala"
	result = _tmp24_;
#line 850 "../src/photos/PhotoMetadata.vala"
	_g_free0 (title);
#line 850 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp5_);
#line 850 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (titles);
#line 850 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp0_);
#line 850 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5373 "PhotoMetadata.c"
}

void
photo_metadata_set_title (PhotoMetadata* self,
                          const gchar* title,
                          PhotoMetadataSetOption option)
{
#line 854 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 855 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (title)) {
#line 856 "../src/photos/PhotoMetadata.vala"
		if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 857 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, title, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 5389 "PhotoMetadata.c"
		} else {
			gchar** _tmp0_;
			gint _tmp0__length1;
#line 859 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = photo_metadata_standard_title_tags;
#line 859 "../src/photos/PhotoMetadata.vala"
			_tmp0__length1 = photo_metadata_standard_title_tags_length1;
#line 859 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_all_string (self, _tmp0_, (gint) _tmp0__length1, title, option);
#line 5399 "PhotoMetadata.c"
		}
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 861 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_standard_title_tags;
#line 861 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_standard_title_tags_length1;
#line 861 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 5410 "PhotoMetadata.c"
	}
}

static gchar*
photo_metadata_real_get_comment (MediaMetadata* base)
{
	PhotoMetadata * self;
	gchar* _tmp0_;
	gchar* result;
#line 865 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 866 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.UserComment", PREPARE_INPUT_TEXT_OPTIONS_DEFAULT & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF));
#line 866 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 866 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5428 "PhotoMetadata.c"
}

void
photo_metadata_set_comment (PhotoMetadata* self,
                            const gchar* comment)
{
#line 869 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 870 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (comment)) {
#line 871 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Exif.Photo.UserComment", comment, PREPARE_INPUT_TEXT_OPTIONS_DEFAULT & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF));
#line 5441 "PhotoMetadata.c"
	} else {
#line 873 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tag (self, "Exif.Photo.UserComment");
#line 5445 "PhotoMetadata.c"
	}
}

GeeSet*
photo_metadata_get_keywords (PhotoMetadata* self,
                             GCompareDataFunc compare_func,
                             gpointer compare_func_target,
                             GDestroyNotify compare_func_target_destroy_notify)
{
	GeeSet* keywords = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GeeSet* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	GeeSet* _tmp23_;
	GeeSet* _tmp28_;
	GeeSet* result;
#line 887 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 888 "../src/photos/PhotoMetadata.vala"
	keywords = NULL;
#line 889 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_keyword_tags;
#line 889 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_keyword_tags_length1;
#line 5471 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 889 "../src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 889 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 889 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 5483 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 889 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 889 "../src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 5490 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				const gchar* _tmp2_;
				GeeList* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeCollection* _tmp5_;
#line 890 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 890 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 890 "../src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp3_;
#line 891 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 891 "../src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 5507 "PhotoMetadata.c"
					GeeCollection* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
#line 891 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 891 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (_tmp6_);
#line 891 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 891 "../src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 5519 "PhotoMetadata.c"
				} else {
#line 891 "../src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 5523 "PhotoMetadata.c"
				}
#line 891 "../src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 5527 "PhotoMetadata.c"
					GeeSet* _tmp9_;
#line 892 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = keywords;
#line 892 "../src/photos/PhotoMetadata.vala"
					if (_tmp9_ == NULL) {
#line 5533 "PhotoMetadata.c"
						GCompareDataFunc _tmp10_;
						gpointer _tmp10__target;
						GDestroyNotify _tmp10__target_destroy_notify;
						GeeSet* _tmp11_;
#line 893 "../src/photos/PhotoMetadata.vala"
						_tmp10_ = compare_func;
#line 893 "../src/photos/PhotoMetadata.vala"
						_tmp10__target = compare_func_target;
#line 893 "../src/photos/PhotoMetadata.vala"
						_tmp10__target_destroy_notify = compare_func_target_destroy_notify;
#line 893 "../src/photos/PhotoMetadata.vala"
						compare_func = NULL;
#line 893 "../src/photos/PhotoMetadata.vala"
						compare_func_target = NULL;
#line 893 "../src/photos/PhotoMetadata.vala"
						compare_func_target_destroy_notify = NULL;
#line 893 "../src/photos/PhotoMetadata.vala"
						_tmp11_ = photo_metadata_create_string_set (self, _tmp10_, _tmp10__target, _tmp10__target_destroy_notify);
#line 893 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (keywords);
#line 893 "../src/photos/PhotoMetadata.vala"
						keywords = _tmp11_;
#line 5556 "PhotoMetadata.c"
					}
					{
						GeeIterator* _current_value_it = NULL;
						GeeCollection* _tmp12_;
						GeeIterator* _tmp13_;
#line 895 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = values;
#line 895 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 895 "../src/photos/PhotoMetadata.vala"
						_current_value_it = _tmp13_;
#line 895 "../src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 5570 "PhotoMetadata.c"
							GeeIterator* _tmp14_;
							gchar* current_value = NULL;
							GeeIterator* _tmp15_;
							gpointer _tmp16_;
							GeeSet* _tmp17_;
							const gchar* _tmp18_;
							gchar* _tmp19_;
							gchar* _tmp20_;
#line 895 "../src/photos/PhotoMetadata.vala"
							_tmp14_ = _current_value_it;
#line 895 "../src/photos/PhotoMetadata.vala"
							if (!gee_iterator_next (_tmp14_)) {
#line 895 "../src/photos/PhotoMetadata.vala"
								break;
#line 5585 "PhotoMetadata.c"
							}
#line 895 "../src/photos/PhotoMetadata.vala"
							_tmp15_ = _current_value_it;
#line 895 "../src/photos/PhotoMetadata.vala"
							_tmp16_ = gee_iterator_get (_tmp15_);
#line 895 "../src/photos/PhotoMetadata.vala"
							current_value = (gchar*) _tmp16_;
#line 896 "../src/photos/PhotoMetadata.vala"
							_tmp17_ = keywords;
#line 896 "../src/photos/PhotoMetadata.vala"
							_tmp18_ = current_value;
#line 896 "../src/photos/PhotoMetadata.vala"
							_tmp19_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp18_);
#line 896 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = _tmp19_;
#line 896 "../src/photos/PhotoMetadata.vala"
							gee_collection_add ((GeeCollection*) _tmp17_, _tmp20_);
#line 896 "../src/photos/PhotoMetadata.vala"
							_g_free0 (_tmp20_);
#line 895 "../src/photos/PhotoMetadata.vala"
							_g_free0 (current_value);
#line 5607 "PhotoMetadata.c"
						}
#line 895 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_current_value_it);
#line 5611 "PhotoMetadata.c"
					}
				}
#line 889 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 889 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5618 "PhotoMetadata.c"
			}
		}
	}
#line 900 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = keywords;
#line 900 "../src/photos/PhotoMetadata.vala"
	if (_tmp23_ != NULL) {
#line 5626 "PhotoMetadata.c"
		GeeSet* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 900 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = keywords;
#line 900 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
#line 900 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp25_;
#line 900 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp26_ > 0;
#line 5638 "PhotoMetadata.c"
	} else {
#line 900 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = FALSE;
#line 5642 "PhotoMetadata.c"
	}
#line 900 "../src/photos/PhotoMetadata.vala"
	if (_tmp22_) {
#line 5646 "PhotoMetadata.c"
		GeeSet* _tmp27_;
#line 900 "../src/photos/PhotoMetadata.vala"
		_tmp27_ = keywords;
#line 900 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = _tmp27_;
#line 5652 "PhotoMetadata.c"
	} else {
#line 900 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = NULL;
#line 5656 "PhotoMetadata.c"
	}
#line 900 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = _g_object_ref0 (_tmp21_);
#line 900 "../src/photos/PhotoMetadata.vala"
	result = _tmp28_;
#line 900 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (keywords);
#line 900 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 900 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 900 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 900 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 900 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5674 "PhotoMetadata.c"
}

static gpointer
_hierarchical_keyword_field_ref0 (gpointer self)
{
#line 904 "../src/photos/PhotoMetadata.vala"
	return self ? hierarchical_keyword_field_ref (self) : NULL;
#line 5682 "PhotoMetadata.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 5704 "PhotoMetadata.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 5708 "PhotoMetadata.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 5714 "PhotoMetadata.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 5718 "PhotoMetadata.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 5722 "PhotoMetadata.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 5730 "PhotoMetadata.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 5758 "PhotoMetadata.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 5767 "PhotoMetadata.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 5781 "PhotoMetadata.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 5790 "PhotoMetadata.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 5804 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 5813 "PhotoMetadata.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 5822 "PhotoMetadata.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 5845 "PhotoMetadata.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 5854 "PhotoMetadata.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 5873 "PhotoMetadata.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 5877 "PhotoMetadata.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 5883 "PhotoMetadata.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 5893 "PhotoMetadata.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 5901 "PhotoMetadata.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 5905 "PhotoMetadata.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 5911 "PhotoMetadata.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 5921 "PhotoMetadata.c"
}

static void
photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self,
                                                   HierarchicalTagIndex* index)
{
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
	HierarchicalKeywordField** _tmp4_;
	gint _tmp4__length1;
#line 903 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 904 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_hierarchical_keyword_tags;
#line 904 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_hierarchical_keyword_tags_length1;
#line 5938 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 904 "../src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp0_;
#line 904 "../src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp0__length1;
#line 904 "../src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < current_field_collection_length1; current_field_it = current_field_it + 1) {
#line 5950 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* current_field = NULL;
#line 904 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 904 "../src/photos/PhotoMetadata.vala"
			current_field = _tmp1_;
#line 5957 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
#line 905 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = current_field;
#line 905 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 905 "../src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp3_);
#line 904 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 5969 "PhotoMetadata.c"
			}
		}
	}
#line 907 "../src/photos/PhotoMetadata.vala"
	if (index == NULL) {
#line 908 "../src/photos/PhotoMetadata.vala"
		return;
#line 5977 "PhotoMetadata.c"
	}
#line 910 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_hierarchical_keyword_tags;
#line 910 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = photo_metadata_hierarchical_keyword_tags_length1;
#line 5983 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 910 "../src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp4_;
#line 910 "../src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp4__length1;
#line 910 "../src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < current_field_collection_length1; current_field_it = current_field_it + 1) {
#line 5995 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp5_;
			HierarchicalKeywordField* current_field = NULL;
#line 910 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 910 "../src/photos/PhotoMetadata.vala"
			current_field = _tmp5_;
#line 6002 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp6_;
				GeeSet* writeable_set = NULL;
				GeeTreeSet* _tmp7_;
				HierarchicalKeywordField* _tmp24_;
				const gchar* _tmp25_;
				GeeSet* _tmp26_;
#line 911 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = current_field;
#line 911 "../src/photos/PhotoMetadata.vala"
				if (!_tmp6_->is_writeable) {
#line 912 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (current_field);
#line 912 "../src/photos/PhotoMetadata.vala"
					continue;
#line 6018 "PhotoMetadata.c"
				}
#line 914 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 914 "../src/photos/PhotoMetadata.vala"
				writeable_set = (GeeSet*) _tmp7_;
#line 6024 "PhotoMetadata.c"
				{
					GeeIterator* _current_path_it = NULL;
					GeeCollection* _tmp8_;
					GeeCollection* _tmp9_;
					GeeIterator* _tmp10_;
					GeeIterator* _tmp11_;
#line 916 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = hierarchical_tag_index_get_all_paths (index);
#line 916 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 916 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 916 "../src/photos/PhotoMetadata.vala"
					_tmp11_ = _tmp10_;
#line 916 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_tmp9_);
#line 916 "../src/photos/PhotoMetadata.vala"
					_current_path_it = _tmp11_;
#line 916 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 6045 "PhotoMetadata.c"
						GeeIterator* _tmp12_;
						gchar* current_path = NULL;
						GeeIterator* _tmp13_;
						gpointer _tmp14_;
						gchar* writeable_path = NULL;
						const gchar* _tmp15_;
						HierarchicalKeywordField* _tmp16_;
						const gchar* _tmp17_;
						gchar* _tmp18_;
						HierarchicalKeywordField* _tmp19_;
						GeeSet* _tmp22_;
						const gchar* _tmp23_;
#line 916 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = _current_path_it;
#line 916 "../src/photos/PhotoMetadata.vala"
						if (!gee_iterator_next (_tmp12_)) {
#line 916 "../src/photos/PhotoMetadata.vala"
							break;
#line 6064 "PhotoMetadata.c"
						}
#line 916 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = _current_path_it;
#line 916 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = gee_iterator_get (_tmp13_);
#line 916 "../src/photos/PhotoMetadata.vala"
						current_path = (gchar*) _tmp14_;
#line 917 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = current_path;
#line 917 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = current_field;
#line 917 "../src/photos/PhotoMetadata.vala"
						_tmp17_ = _tmp16_->path_separator;
#line 917 "../src/photos/PhotoMetadata.vala"
						_tmp18_ = string_replace (_tmp15_, TAG_PATH_SEPARATOR_STRING, _tmp17_);
#line 917 "../src/photos/PhotoMetadata.vala"
						writeable_path = _tmp18_;
#line 919 "../src/photos/PhotoMetadata.vala"
						_tmp19_ = current_field;
#line 919 "../src/photos/PhotoMetadata.vala"
						if (!_tmp19_->wants_leading_separator) {
#line 6086 "PhotoMetadata.c"
							const gchar* _tmp20_;
							gchar* _tmp21_;
#line 920 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = writeable_path;
#line 920 "../src/photos/PhotoMetadata.vala"
							_tmp21_ = string_substring (_tmp20_, (glong) 1, (glong) -1);
#line 920 "../src/photos/PhotoMetadata.vala"
							_g_free0 (writeable_path);
#line 920 "../src/photos/PhotoMetadata.vala"
							writeable_path = _tmp21_;
#line 6097 "PhotoMetadata.c"
						}
#line 922 "../src/photos/PhotoMetadata.vala"
						_tmp22_ = writeable_set;
#line 922 "../src/photos/PhotoMetadata.vala"
						_tmp23_ = writeable_path;
#line 922 "../src/photos/PhotoMetadata.vala"
						gee_collection_add ((GeeCollection*) _tmp22_, _tmp23_);
#line 916 "../src/photos/PhotoMetadata.vala"
						_g_free0 (writeable_path);
#line 916 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_path);
#line 6109 "PhotoMetadata.c"
					}
#line 916 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_path_it);
#line 6113 "PhotoMetadata.c"
				}
#line 925 "../src/photos/PhotoMetadata.vala"
				_tmp24_ = current_field;
#line 925 "../src/photos/PhotoMetadata.vala"
				_tmp25_ = _tmp24_->field_name;
#line 925 "../src/photos/PhotoMetadata.vala"
				_tmp26_ = writeable_set;
#line 925 "../src/photos/PhotoMetadata.vala"
				photo_metadata_set_string_multiple (self, _tmp25_, (GeeCollection*) _tmp26_);
#line 910 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (writeable_set);
#line 910 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 6127 "PhotoMetadata.c"
			}
		}
	}
}

void
photo_metadata_set_keywords (PhotoMetadata* self,
                             GeeCollection* keywords,
                             PhotoMetadataSetOption option)
{
	HierarchicalTagIndex* htag_index = NULL;
	HierarchicalTagIndex* _tmp0_;
	GeeSet* flat_keywords = NULL;
	GeeTreeSet* _tmp1_;
#line 929 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 930 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = hierarchical_tag_index_new ();
#line 930 "../src/photos/PhotoMetadata.vala"
	htag_index = _tmp0_;
#line 931 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 931 "../src/photos/PhotoMetadata.vala"
	flat_keywords = (GeeSet*) _tmp1_;
#line 933 "../src/photos/PhotoMetadata.vala"
	if (keywords != NULL) {
#line 6154 "PhotoMetadata.c"
		GeeSet* _tmp19_;
		HierarchicalTagIndex* _tmp20_;
		GeeCollection* _tmp21_;
		GeeCollection* _tmp22_;
		{
			GeeIterator* _keyword_it = NULL;
			GeeIterator* _tmp2_;
#line 934 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = gee_iterable_iterator ((GeeIterable*) keywords);
#line 934 "../src/photos/PhotoMetadata.vala"
			_keyword_it = _tmp2_;
#line 934 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 6168 "PhotoMetadata.c"
				GeeIterator* _tmp3_;
				gchar* keyword = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				const gchar* _tmp6_;
#line 934 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _keyword_it;
#line 934 "../src/photos/PhotoMetadata.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 934 "../src/photos/PhotoMetadata.vala"
					break;
#line 6180 "PhotoMetadata.c"
				}
#line 934 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _keyword_it;
#line 934 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 934 "../src/photos/PhotoMetadata.vala"
				keyword = (gchar*) _tmp5_;
#line 935 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = keyword;
#line 935 "../src/photos/PhotoMetadata.vala"
				if (g_str_has_prefix (_tmp6_, TAG_PATH_SEPARATOR_STRING)) {
#line 6192 "PhotoMetadata.c"
					GeeCollection* path_components = NULL;
					const gchar* _tmp7_;
					GeeList* _tmp8_;
#line 936 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = keyword;
#line 936 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = hierarchical_tag_utilities_enumerate_path_components (_tmp7_);
#line 936 "../src/photos/PhotoMetadata.vala"
					path_components = (GeeCollection*) _tmp8_;
#line 6202 "PhotoMetadata.c"
					{
						GeeIterator* _component_it = NULL;
						GeeCollection* _tmp9_;
						GeeIterator* _tmp10_;
#line 938 "../src/photos/PhotoMetadata.vala"
						_tmp9_ = path_components;
#line 938 "../src/photos/PhotoMetadata.vala"
						_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 938 "../src/photos/PhotoMetadata.vala"
						_component_it = _tmp10_;
#line 938 "../src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 6215 "PhotoMetadata.c"
							GeeIterator* _tmp11_;
							gchar* component = NULL;
							GeeIterator* _tmp12_;
							gpointer _tmp13_;
							HierarchicalTagIndex* _tmp14_;
							const gchar* _tmp15_;
							const gchar* _tmp16_;
#line 938 "../src/photos/PhotoMetadata.vala"
							_tmp11_ = _component_it;
#line 938 "../src/photos/PhotoMetadata.vala"
							if (!gee_iterator_next (_tmp11_)) {
#line 938 "../src/photos/PhotoMetadata.vala"
								break;
#line 6229 "PhotoMetadata.c"
							}
#line 938 "../src/photos/PhotoMetadata.vala"
							_tmp12_ = _component_it;
#line 938 "../src/photos/PhotoMetadata.vala"
							_tmp13_ = gee_iterator_get (_tmp12_);
#line 938 "../src/photos/PhotoMetadata.vala"
							component = (gchar*) _tmp13_;
#line 939 "../src/photos/PhotoMetadata.vala"
							_tmp14_ = htag_index;
#line 939 "../src/photos/PhotoMetadata.vala"
							_tmp15_ = component;
#line 939 "../src/photos/PhotoMetadata.vala"
							_tmp16_ = keyword;
#line 939 "../src/photos/PhotoMetadata.vala"
							hierarchical_tag_index_add_path (_tmp14_, _tmp15_, _tmp16_);
#line 938 "../src/photos/PhotoMetadata.vala"
							_g_free0 (component);
#line 6247 "PhotoMetadata.c"
						}
#line 938 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_component_it);
#line 6251 "PhotoMetadata.c"
					}
#line 935 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (path_components);
#line 6255 "PhotoMetadata.c"
				} else {
					GeeSet* _tmp17_;
					const gchar* _tmp18_;
#line 941 "../src/photos/PhotoMetadata.vala"
					_tmp17_ = flat_keywords;
#line 941 "../src/photos/PhotoMetadata.vala"
					_tmp18_ = keyword;
#line 941 "../src/photos/PhotoMetadata.vala"
					gee_collection_add ((GeeCollection*) _tmp17_, _tmp18_);
#line 6265 "PhotoMetadata.c"
				}
#line 934 "../src/photos/PhotoMetadata.vala"
				_g_free0 (keyword);
#line 6269 "PhotoMetadata.c"
			}
#line 934 "../src/photos/PhotoMetadata.vala"
			_g_object_unref0 (_keyword_it);
#line 6273 "PhotoMetadata.c"
		}
#line 945 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = flat_keywords;
#line 945 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = htag_index;
#line 945 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = hierarchical_tag_index_get_all_tags (_tmp20_);
#line 945 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp21_;
#line 945 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all ((GeeCollection*) _tmp19_, _tmp22_);
#line 945 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp22_);
#line 6287 "PhotoMetadata.c"
	}
#line 948 "../src/photos/PhotoMetadata.vala"
	if (keywords != NULL) {
#line 6291 "PhotoMetadata.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		GeeSet* _tmp24_;
		HierarchicalTagIndex* _tmp25_;
#line 949 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = photo_metadata_keyword_tags;
#line 949 "../src/photos/PhotoMetadata.vala"
		_tmp23__length1 = photo_metadata_keyword_tags_length1;
#line 949 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = flat_keywords;
#line 949 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, _tmp23_, (gint) _tmp23__length1, (GeeCollection*) _tmp24_, option);
#line 950 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = htag_index;
#line 950 "../src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, _tmp25_);
#line 6308 "PhotoMetadata.c"
	} else {
		gchar** _tmp26_;
		gint _tmp26__length1;
#line 952 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = photo_metadata_keyword_tags;
#line 952 "../src/photos/PhotoMetadata.vala"
		_tmp26__length1 = photo_metadata_keyword_tags_length1;
#line 952 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp26_, (gint) _tmp26__length1);
#line 953 "../src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, NULL);
#line 6320 "PhotoMetadata.c"
	}
#line 929 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (flat_keywords);
#line 929 "../src/photos/PhotoMetadata.vala"
	_hierarchical_tag_index_unref0 (htag_index);
#line 6326 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_hierarchical_keywords (PhotoMetadata* self)
{
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
	gboolean result;
#line 957 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 958 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_hierarchical_keyword_tags;
#line 958 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_hierarchical_keyword_tags_length1;
#line 6341 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 958 "../src/photos/PhotoMetadata.vala"
		field_collection = _tmp0_;
#line 958 "../src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp0__length1;
#line 958 "../src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 6353 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* field = NULL;
#line 958 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 958 "../src/photos/PhotoMetadata.vala"
			field = _tmp1_;
#line 6360 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
				GeeList* _tmp4_;
				gboolean _tmp5_ = FALSE;
				GeeCollection* _tmp6_;
#line 959 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = field;
#line 959 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 959 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_string_multiple (self, _tmp3_);
#line 959 "../src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp4_;
#line 961 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = values;
#line 961 "../src/photos/PhotoMetadata.vala"
				if (_tmp6_ != NULL) {
#line 6380 "PhotoMetadata.c"
					GeeCollection* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
#line 961 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = values;
#line 961 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = gee_collection_get_size (_tmp7_);
#line 961 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 961 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = _tmp9_ > 0;
#line 6392 "PhotoMetadata.c"
				} else {
#line 961 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = FALSE;
#line 6396 "PhotoMetadata.c"
				}
#line 961 "../src/photos/PhotoMetadata.vala"
				if (_tmp5_) {
#line 962 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 962 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 962 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 962 "../src/photos/PhotoMetadata.vala"
					return result;
#line 6408 "PhotoMetadata.c"
				}
#line 958 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 958 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 6414 "PhotoMetadata.c"
			}
		}
	}
#line 965 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 965 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6422 "PhotoMetadata.c"
}

GeeSet*
photo_metadata_get_hierarchical_keywords (PhotoMetadata* self)
{
	GeeSet* h_keywords = NULL;
	GeeSet* _tmp0_;
	HierarchicalKeywordField** _tmp1_;
	gint _tmp1__length1;
	GeeSet* result;
#line 968 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 969 "../src/photos/PhotoMetadata.vala"
	_vala_assert (photo_metadata_has_hierarchical_keywords (self), "has_hierarchical_keywords ()");
#line 971 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_create_string_set (self, NULL, NULL, NULL);
#line 971 "../src/photos/PhotoMetadata.vala"
	h_keywords = _tmp0_;
#line 973 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_hierarchical_keyword_tags;
#line 973 "../src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_hierarchical_keyword_tags_length1;
#line 6445 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 973 "../src/photos/PhotoMetadata.vala"
		field_collection = _tmp1_;
#line 973 "../src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp1__length1;
#line 973 "../src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 6457 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp2_;
			HierarchicalKeywordField* field = NULL;
#line 973 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 973 "../src/photos/PhotoMetadata.vala"
			field = _tmp2_;
#line 6464 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp3_;
				const gchar* _tmp4_;
				GeeList* _tmp5_;
				gboolean _tmp6_ = FALSE;
				GeeCollection* _tmp7_;
#line 974 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = field;
#line 974 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _tmp3_->field_name;
#line 974 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_get_string_multiple (self, _tmp4_);
#line 974 "../src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp5_;
#line 976 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = values;
#line 976 "../src/photos/PhotoMetadata.vala"
				if (_tmp7_ == NULL) {
#line 976 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = TRUE;
#line 6486 "PhotoMetadata.c"
				} else {
					GeeCollection* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
#line 976 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = values;
#line 976 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = gee_collection_get_size (_tmp8_);
#line 976 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = _tmp9_;
#line 976 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = _tmp10_ < 1;
#line 6499 "PhotoMetadata.c"
				}
#line 976 "../src/photos/PhotoMetadata.vala"
				if (_tmp6_) {
#line 977 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 977 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 977 "../src/photos/PhotoMetadata.vala"
					continue;
#line 6509 "PhotoMetadata.c"
				}
				{
					GeeIterator* _current_value_it = NULL;
					GeeCollection* _tmp11_;
					GeeIterator* _tmp12_;
#line 979 "../src/photos/PhotoMetadata.vala"
					_tmp11_ = values;
#line 979 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 979 "../src/photos/PhotoMetadata.vala"
					_current_value_it = _tmp12_;
#line 979 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 6523 "PhotoMetadata.c"
						GeeIterator* _tmp13_;
						gchar* current_value = NULL;
						GeeIterator* _tmp14_;
						gpointer _tmp15_;
						gchar* canonicalized = NULL;
						const gchar* _tmp16_;
						HierarchicalKeywordField* _tmp17_;
						const gchar* _tmp18_;
						gchar* _tmp19_;
						const gchar* _tmp20_;
#line 979 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = _current_value_it;
#line 979 "../src/photos/PhotoMetadata.vala"
						if (!gee_iterator_next (_tmp13_)) {
#line 979 "../src/photos/PhotoMetadata.vala"
							break;
#line 6540 "PhotoMetadata.c"
						}
#line 979 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = _current_value_it;
#line 979 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = gee_iterator_get (_tmp14_);
#line 979 "../src/photos/PhotoMetadata.vala"
						current_value = (gchar*) _tmp15_;
#line 980 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = current_value;
#line 980 "../src/photos/PhotoMetadata.vala"
						_tmp17_ = field;
#line 980 "../src/photos/PhotoMetadata.vala"
						_tmp18_ = _tmp17_->path_separator;
#line 980 "../src/photos/PhotoMetadata.vala"
						_tmp19_ = hierarchical_tag_utilities_canonicalize (_tmp16_, _tmp18_);
#line 980 "../src/photos/PhotoMetadata.vala"
						canonicalized = _tmp19_;
#line 983 "../src/photos/PhotoMetadata.vala"
						_tmp20_ = canonicalized;
#line 983 "../src/photos/PhotoMetadata.vala"
						if (_tmp20_ != NULL) {
#line 6562 "PhotoMetadata.c"
							GeeSet* _tmp21_;
							const gchar* _tmp22_;
#line 984 "../src/photos/PhotoMetadata.vala"
							_tmp21_ = h_keywords;
#line 984 "../src/photos/PhotoMetadata.vala"
							_tmp22_ = canonicalized;
#line 984 "../src/photos/PhotoMetadata.vala"
							gee_collection_add ((GeeCollection*) _tmp21_, _tmp22_);
#line 6571 "PhotoMetadata.c"
						}
#line 979 "../src/photos/PhotoMetadata.vala"
						_g_free0 (canonicalized);
#line 979 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_value);
#line 6577 "PhotoMetadata.c"
					}
#line 979 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_value_it);
#line 6581 "PhotoMetadata.c"
				}
#line 973 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 973 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 6587 "PhotoMetadata.c"
			}
		}
	}
#line 988 "../src/photos/PhotoMetadata.vala"
	result = h_keywords;
#line 988 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6595 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_orientation (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
	gboolean result;
#line 991 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 992 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 992 "../src/photos/PhotoMetadata.vala"
	result = gexiv2_metadata_get_orientation (_tmp0_) == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 992 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6611 "PhotoMetadata.c"
}

Orientation
photo_metadata_get_orientation (PhotoMetadata* self)
{
	GExiv2Orientation orientation = 0;
	GExiv2Metadata* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Orientation result;
#line 996 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 999 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 999 "../src/photos/PhotoMetadata.vala"
	orientation = gexiv2_metadata_get_orientation (_tmp0_);
#line 1000 "../src/photos/PhotoMetadata.vala"
	if (orientation == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 1000 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 6632 "PhotoMetadata.c"
	} else {
#line 1000 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = orientation < ORIENTATION_MIN;
#line 6636 "PhotoMetadata.c"
	}
#line 1000 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_) {
#line 1000 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = TRUE;
#line 6642 "PhotoMetadata.c"
	} else {
#line 1001 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = orientation > ORIENTATION_MAX;
#line 6646 "PhotoMetadata.c"
	}
#line 1000 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 1002 "../src/photos/PhotoMetadata.vala"
		result = ORIENTATION_TOP_LEFT;
#line 1002 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6654 "PhotoMetadata.c"
	} else {
#line 1004 "../src/photos/PhotoMetadata.vala"
		result = (Orientation) orientation;
#line 1004 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6660 "PhotoMetadata.c"
	}
}

void
photo_metadata_set_orientation (PhotoMetadata* self,
                                Orientation orientation)
{
	GExiv2Metadata* _tmp0_;
#line 1007 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1009 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1009 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_set_orientation (_tmp0_, (GExiv2Orientation) orientation);
#line 6675 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_gps (PhotoMetadata* self,
                        gdouble* longitude,
                        gchar** long_ref,
                        gdouble* latitude,
                        gchar** lat_ref,
                        gdouble* altitude)
{
	gdouble _vala_longitude = 0.0;
	gchar* _vala_long_ref = NULL;
	gdouble _vala_latitude = 0.0;
	gchar* _vala_lat_ref = NULL;
	gdouble _vala_altitude = 0.0;
	GExiv2Metadata* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean result;
#line 1012 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_gps_info (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 1014 "../src/photos/PhotoMetadata.vala"
	_vala_longitude = _tmp1_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_vala_latitude = _tmp2_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_vala_altitude = _tmp3_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	if (!_tmp4_) {
#line 1015 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 1015 "../src/photos/PhotoMetadata.vala"
		_vala_long_ref = NULL;
#line 1016 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 1016 "../src/photos/PhotoMetadata.vala"
		_vala_lat_ref = NULL;
#line 1018 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1018 "../src/photos/PhotoMetadata.vala"
		if (longitude) {
#line 1018 "../src/photos/PhotoMetadata.vala"
			*longitude = _vala_longitude;
#line 6727 "PhotoMetadata.c"
		}
#line 1018 "../src/photos/PhotoMetadata.vala"
		if (long_ref) {
#line 1018 "../src/photos/PhotoMetadata.vala"
			*long_ref = _vala_long_ref;
#line 6733 "PhotoMetadata.c"
		} else {
#line 1018 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_long_ref);
#line 6737 "PhotoMetadata.c"
		}
#line 1018 "../src/photos/PhotoMetadata.vala"
		if (latitude) {
#line 1018 "../src/photos/PhotoMetadata.vala"
			*latitude = _vala_latitude;
#line 6743 "PhotoMetadata.c"
		}
#line 1018 "../src/photos/PhotoMetadata.vala"
		if (lat_ref) {
#line 1018 "../src/photos/PhotoMetadata.vala"
			*lat_ref = _vala_lat_ref;
#line 6749 "PhotoMetadata.c"
		} else {
#line 1018 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_lat_ref);
#line 6753 "PhotoMetadata.c"
		}
#line 1018 "../src/photos/PhotoMetadata.vala"
		if (altitude) {
#line 1018 "../src/photos/PhotoMetadata.vala"
			*altitude = _vala_altitude;
#line 6759 "PhotoMetadata.c"
		}
#line 1018 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6763 "PhotoMetadata.c"
	}
#line 1021 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1021 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_long_ref);
#line 1021 "../src/photos/PhotoMetadata.vala"
	_vala_long_ref = _tmp5_;
#line 1022 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1022 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_lat_ref);
#line 1022 "../src/photos/PhotoMetadata.vala"
	_vala_lat_ref = _tmp6_;
#line 1024 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1024 "../src/photos/PhotoMetadata.vala"
	if (longitude) {
#line 1024 "../src/photos/PhotoMetadata.vala"
		*longitude = _vala_longitude;
#line 6783 "PhotoMetadata.c"
	}
#line 1024 "../src/photos/PhotoMetadata.vala"
	if (long_ref) {
#line 1024 "../src/photos/PhotoMetadata.vala"
		*long_ref = _vala_long_ref;
#line 6789 "PhotoMetadata.c"
	} else {
#line 1024 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 6793 "PhotoMetadata.c"
	}
#line 1024 "../src/photos/PhotoMetadata.vala"
	if (latitude) {
#line 1024 "../src/photos/PhotoMetadata.vala"
		*latitude = _vala_latitude;
#line 6799 "PhotoMetadata.c"
	}
#line 1024 "../src/photos/PhotoMetadata.vala"
	if (lat_ref) {
#line 1024 "../src/photos/PhotoMetadata.vala"
		*lat_ref = _vala_lat_ref;
#line 6805 "PhotoMetadata.c"
	} else {
#line 1024 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 6809 "PhotoMetadata.c"
	}
#line 1024 "../src/photos/PhotoMetadata.vala"
	if (altitude) {
#line 1024 "../src/photos/PhotoMetadata.vala"
		*altitude = _vala_altitude;
#line 6815 "PhotoMetadata.c"
	}
#line 1024 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6819 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_exposure (PhotoMetadata* self,
                             MetadataRational* exposure)
{
	MetadataRational _vala_exposure = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result;
#line 1027 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1028 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1028 "../src/photos/PhotoMetadata.vala"
	_vala_exposure = _tmp0_;
#line 1028 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1028 "../src/photos/PhotoMetadata.vala"
	if (exposure) {
#line 1028 "../src/photos/PhotoMetadata.vala"
		*exposure = _vala_exposure;
#line 6842 "PhotoMetadata.c"
	}
#line 1028 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6846 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_exposure_string (PhotoMetadata* self)
{
	MetadataRational exposure_time = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 1031 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1033 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1033 "../src/photos/PhotoMetadata.vala"
	exposure_time = _tmp0_;
#line 1033 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1034 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1034 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6869 "PhotoMetadata.c"
	}
#line 1036 "../src/photos/PhotoMetadata.vala"
	if (!metadata_rational_is_valid (&exposure_time)) {
#line 1037 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1037 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6877 "PhotoMetadata.c"
	}
#line 1039 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1039 "../src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1039 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6885 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_iso (PhotoMetadata* self,
                        glong* iso)
{
	glong _vala_iso = 0L;
	gboolean fetched_ok = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 1042 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1043 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", &_tmp0_);
#line 1043 "../src/photos/PhotoMetadata.vala"
	_vala_iso = _tmp0_;
#line 1043 "../src/photos/PhotoMetadata.vala"
	fetched_ok = _tmp1_;
#line 1045 "../src/photos/PhotoMetadata.vala"
	if (fetched_ok == FALSE) {
#line 1046 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1046 "../src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1046 "../src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 6914 "PhotoMetadata.c"
		}
#line 1046 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6918 "PhotoMetadata.c"
	}
#line 1050 "../src/photos/PhotoMetadata.vala"
	if (_vala_iso < ((glong) 6)) {
#line 1050 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 6924 "PhotoMetadata.c"
	} else {
#line 1050 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = _vala_iso > ((glong) 409600);
#line 6928 "PhotoMetadata.c"
	}
#line 1050 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_) {
#line 1051 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1051 "../src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1051 "../src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 6938 "PhotoMetadata.c"
		}
#line 1051 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6942 "PhotoMetadata.c"
	}
#line 1053 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1053 "../src/photos/PhotoMetadata.vala"
	if (iso) {
#line 1053 "../src/photos/PhotoMetadata.vala"
		*iso = _vala_iso;
#line 6950 "PhotoMetadata.c"
	}
#line 1053 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6954 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_iso_string (PhotoMetadata* self)
{
	glong iso = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 1056 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1058 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_iso (self, &_tmp0_);
#line 1058 "../src/photos/PhotoMetadata.vala"
	iso = _tmp0_;
#line 1058 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1059 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1059 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6977 "PhotoMetadata.c"
	}
#line 1061 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1061 "../src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1061 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6985 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_aperture (PhotoMetadata* self,
                             MetadataRational* aperture)
{
	MetadataRational _vala_aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result;
#line 1064 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FNumber", &_tmp0_);
#line 1065 "../src/photos/PhotoMetadata.vala"
	_vala_aperture = _tmp0_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	if (aperture) {
#line 1065 "../src/photos/PhotoMetadata.vala"
		*aperture = _vala_aperture;
#line 7008 "PhotoMetadata.c"
	}
#line 1065 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7012 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_aperture_string (PhotoMetadata* self,
                                    gboolean pango_formatted)
{
	MetadataRational aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gdouble aperture_value = 0.0;
	MetadataRational _tmp2_;
	MetadataRational _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 1068 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1070 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_aperture (self, &_tmp0_);
#line 1070 "../src/photos/PhotoMetadata.vala"
	aperture = _tmp0_;
#line 1070 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1071 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1071 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7044 "PhotoMetadata.c"
	}
#line 1073 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = aperture;
#line 1073 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = aperture;
#line 1073 "../src/photos/PhotoMetadata.vala"
	aperture_value = ((gdouble) _tmp2_.numerator) / ((gdouble) _tmp3_.denominator);
#line 1074 "../src/photos/PhotoMetadata.vala"
	aperture_value = ((gint) (aperture_value * 10.0)) / 10.0;
#line 1076 "../src/photos/PhotoMetadata.vala"
	if (pango_formatted) {
#line 1076 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = "<i>f</i>/";
#line 7058 "PhotoMetadata.c"
	} else {
#line 1076 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = "f/";
#line 7062 "PhotoMetadata.c"
	}
#line 1077 "../src/photos/PhotoMetadata.vala"
	if (fmod (aperture_value, 1) == ((gdouble) 0)) {
#line 1077 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = "%.0f";
#line 7068 "PhotoMetadata.c"
	} else {
#line 1077 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = "%.1f";
#line 7072 "PhotoMetadata.c"
	}
#line 1076 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup_printf (_tmp5_, aperture_value);
#line 1076 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 1076 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
#line 1076 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = _tmp8_;
#line 1076 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 1076 "../src/photos/PhotoMetadata.vala"
	result = _tmp9_;
#line 1076 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7088 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_camera_make (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1080 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1081 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Make", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1081 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1081 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7104 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_camera_model (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1084 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1085 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Model", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1085 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1085 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7120 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_flash (PhotoMetadata* self,
                          glong* flash)
{
	glong _vala_flash = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gboolean result;
#line 1088 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1090 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.Flash", &_tmp0_);
#line 1090 "../src/photos/PhotoMetadata.vala"
	_vala_flash = _tmp0_;
#line 1090 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1090 "../src/photos/PhotoMetadata.vala"
	if (flash) {
#line 1090 "../src/photos/PhotoMetadata.vala"
		*flash = _vala_flash;
#line 7143 "PhotoMetadata.c"
	}
#line 1090 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7147 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_flash_string (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1093 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1095 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1095 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1095 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7163 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_focal_length (PhotoMetadata* self,
                                 MetadataRational* focal_length)
{
	MetadataRational _vala_focal_length = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result;
#line 1098 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1099 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", &_tmp0_);
#line 1099 "../src/photos/PhotoMetadata.vala"
	_vala_focal_length = _tmp0_;
#line 1099 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1099 "../src/photos/PhotoMetadata.vala"
	if (focal_length) {
#line 1099 "../src/photos/PhotoMetadata.vala"
		*focal_length = _vala_focal_length;
#line 7186 "PhotoMetadata.c"
	}
#line 1099 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7190 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_focal_length_string (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1102 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1103 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1103 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1103 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7206 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_artist (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gchar* result;
#line 1111 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1112 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_artist_tags;
#line 1112 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_artist_tags_length1;
#line 1112 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, (gint) _tmp0__length1);
#line 1112 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1112 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7228 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_copyright (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1115 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1116 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1116 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1116 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7244 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_software (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1119 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1120 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Software", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1120 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1120 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7260 "PhotoMetadata.c"
}

void
photo_metadata_set_software (PhotoMetadata* self,
                             const gchar* software,
                             const gchar* version)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1123 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1123 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (software != NULL);
#line 1123 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (version != NULL);
#line 1125 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup_printf ("%s %s", software, version);
#line 1125 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_;
#line 1125 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1125 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp1_);
#line 1127 "../src/photos/PhotoMetadata.vala"
	if (photo_metadata_has_iptc (self)) {
#line 1128 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.Program", software, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1129 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", version, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 7290 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_software (PhotoMetadata* self)
{
#line 1133 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1134 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Exif.Image.Software");
#line 1135 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
#line 1136 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
#line 7305 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_exposure_bias (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1139 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1140 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1140 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1140 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7321 "PhotoMetadata.c"
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 135 "../src/photos/PhotoMetadata.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 7329 "PhotoMetadata.c"
}

static PhotoMetadataInternalPhotoPreview*
photo_metadata_internal_photo_preview_construct (GType object_type,
                                                 PhotoMetadata* owner,
                                                 const gchar* name,
                                                 guint number,
                                                 GExiv2PreviewProperties* props)
{
	PhotoMetadataInternalPhotoPreview* self = NULL;
	Dimensions _tmp0_ = {0};
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 130 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 130 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 130 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 132 "../src/photos/PhotoMetadata.vala"
	dimensions_init (&_tmp0_, (gint) gexiv2_preview_properties_get_width (props), (gint) gexiv2_preview_properties_get_height (props));
#line 132 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_preview_properties_get_mime_type (props);
#line 132 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_preview_properties_get_extension (props);
#line 132 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, name, &_tmp0_, gexiv2_preview_properties_get_size (props), _tmp1_, _tmp2_);
#line 135 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _media_metadata_ref0 (owner);
#line 135 "../src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 135 "../src/photos/PhotoMetadata.vala"
	self->owner = _tmp3_;
#line 136 "../src/photos/PhotoMetadata.vala"
	self->number = number;
#line 130 "../src/photos/PhotoMetadata.vala"
	return self;
#line 7368 "PhotoMetadata.c"
}

static PhotoMetadataInternalPhotoPreview*
photo_metadata_internal_photo_preview_new (PhotoMetadata* owner,
                                           const gchar* name,
                                           guint number,
                                           GExiv2PreviewProperties* props)
{
#line 130 "../src/photos/PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 7379 "PhotoMetadata.c"
}

static GBytes*
photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base,
                                                    GError** error)
{
	PhotoMetadataInternalPhotoPreview * self;
	GExiv2PreviewProperties** props = NULL;
	PhotoMetadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	GExiv2PreviewProperties** _tmp3_;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp4_ = FALSE;
	GExiv2PreviewProperties** _tmp5_;
	gint _tmp5__length1;
	PhotoMetadata* _tmp7_;
	GExiv2Metadata* _tmp8_;
	GExiv2PreviewProperties** _tmp9_;
	gint _tmp9__length1;
	GExiv2PreviewProperties* _tmp10_;
	GExiv2PreviewImage* _tmp11_;
	GExiv2PreviewImage* _tmp12_;
	guint32 _tmp13_ = 0;
	guint8* _tmp14_;
	GBytes* _tmp15_;
	GBytes* _tmp16_;
	GBytes* result;
#line 139 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) base;
#line 140 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->owner;
#line 140 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_->priv->exiv2;
#line 140 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_preview_properties (_tmp1_);
#line 140 "../src/photos/PhotoMetadata.vala"
	props = _tmp3_;
#line 140 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp2_);
#line 140 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 141 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = props;
#line 141 "../src/photos/PhotoMetadata.vala"
	_tmp5__length1 = props_length1;
#line 141 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_ != NULL) {
#line 7429 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp6_;
		gint _tmp6__length1;
#line 141 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = props;
#line 141 "../src/photos/PhotoMetadata.vala"
		_tmp6__length1 = props_length1;
#line 141 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = ((guint) _tmp6__length1) > self->number;
#line 7438 "PhotoMetadata.c"
	} else {
#line 141 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 7442 "PhotoMetadata.c"
	}
#line 141 "../src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp4_, "props != null && props.length > number");
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = self->owner;
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_->priv->exiv2;
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = props;
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp9__length1 = props_length1;
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = _tmp9_[self->number];
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = gexiv2_metadata_get_preview_image (_tmp8_, _tmp10_);
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = _tmp11_;
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = gexiv2_preview_image_get_data (_tmp12_, &_tmp13_);
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp15_ = g_bytes_new (_tmp14_, _tmp13_);
#line 143 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = _tmp15_;
#line 143 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp12_);
#line 143 "../src/photos/PhotoMetadata.vala"
	result = _tmp16_;
#line 143 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7472 "PhotoMetadata.c"
}

static void
photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass,
                                                  gpointer klass_data)
{
#line 126 "../src/photos/PhotoMetadata.vala"
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 126 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_metadata_internal_photo_preview_finalize;
#line 126 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = (GBytes* (*) (PhotoPreview*, GError**)) photo_metadata_internal_photo_preview_real_flatten;
#line 7485 "PhotoMetadata.c"
}

static void
photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self,
                                                     gpointer klass)
{
}

static void
photo_metadata_internal_photo_preview_finalize (PhotoPreview * obj)
{
	PhotoMetadataInternalPhotoPreview * self;
#line 126 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview);
#line 127 "../src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 126 "../src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
#line 7504 "PhotoMetadata.c"
}

static GType
photo_metadata_internal_photo_preview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
	GType photo_metadata_internal_photo_preview_type_id;
	photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
	return photo_metadata_internal_photo_preview_type_id;
}

static GType
photo_metadata_internal_photo_preview_get_type (void)
{
	static volatile gsize photo_metadata_internal_photo_preview_type_id__once = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__once)) {
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = photo_metadata_internal_photo_preview_get_type_once ();
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__once, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__once;
}

static void
photo_metadata_class_init (PhotoMetadataClass * klass,
                           gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar** _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar** _tmp31_;
	HierarchicalKeywordField* _tmp32_;
	HierarchicalKeywordField* _tmp33_;
	HierarchicalKeywordField* _tmp34_;
	HierarchicalKeywordField** _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar** _tmp38_;
#line 111 "../src/photos/PhotoMetadata.vala"
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
#line 111 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->finalize = photo_metadata_finalize;
#line 111 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &PhotoMetadata_private_offset);
#line 111 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->read_from_file = (void (*) (MediaMetadata*, GFile*, GError**)) photo_metadata_real_read_from_file;
#line 111 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_creation_date_time = (MetadataDateTime* (*) (MediaMetadata*)) photo_metadata_real_get_creation_date_time;
#line 111 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_title = (gchar* (*) (MediaMetadata*)) photo_metadata_real_get_title;
#line 111 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_comment = (gchar* (*) (MediaMetadata*)) photo_metadata_real_get_comment;
#line 691 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup ("Exif.Image.DateTime");
#line 691 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("Xmp.tiff.DateTime");
#line 691 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup ("Xmp.xmp.ModifyDate");
#line 691 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_new0 (gchar*, 3 + 1);
#line 691 "../src/photos/PhotoMetadata.vala"
	_tmp3_[0] = _tmp0_;
#line 691 "../src/photos/PhotoMetadata.vala"
	_tmp3_[1] = _tmp1_;
#line 691 "../src/photos/PhotoMetadata.vala"
	_tmp3_[2] = _tmp2_;
#line 691 "../src/photos/PhotoMetadata.vala"
	photo_metadata_date_int64ags = _tmp3_;
#line 691 "../src/photos/PhotoMetadata.vala"
	photo_metadata_date_int64ags_length1 = 3;
#line 691 "../src/photos/PhotoMetadata.vala"
	_photo_metadata_date_int64ags_size_ = photo_metadata_date_int64ags_length1;
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = g_strdup ("Exif.Photo.DateTimeOriginal");
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup ("Xmp.exif.DateTimeOriginal");
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup ("Xmp.xmp.CreateDate");
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = g_strdup ("Exif.Image.DateTime");
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = g_new0 (gchar*, 6 + 1);
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp10_[0] = _tmp4_;
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp10_[1] = _tmp5_;
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp10_[2] = _tmp6_;
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp10_[3] = _tmp7_;
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp10_[4] = _tmp8_;
#line 709 "../src/photos/PhotoMetadata.vala"
	_tmp10_[5] = _tmp9_;
#line 709 "../src/photos/PhotoMetadata.vala"
	photo_metadata_exposure_date_int64ags = _tmp10_;
#line 709 "../src/photos/PhotoMetadata.vala"
	photo_metadata_exposure_date_int64ags_length1 = 6;
#line 709 "../src/photos/PhotoMetadata.vala"
	_photo_metadata_exposure_date_int64ags_size_ = photo_metadata_exposure_date_int64ags_length1;
#line 730 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 730 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 730 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = g_new0 (gchar*, 2 + 1);
#line 730 "../src/photos/PhotoMetadata.vala"
	_tmp13_[0] = _tmp11_;
#line 730 "../src/photos/PhotoMetadata.vala"
	_tmp13_[1] = _tmp12_;
#line 730 "../src/photos/PhotoMetadata.vala"
	photo_metadata_digitized_date_int64ags = _tmp13_;
#line 730 "../src/photos/PhotoMetadata.vala"
	photo_metadata_digitized_date_int64ags_length1 = 2;
#line 730 "../src/photos/PhotoMetadata.vala"
	_photo_metadata_digitized_date_int64ags_size_ = photo_metadata_digitized_date_int64ags_length1;
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strdup ("Exif.Photo.PixelXDimension");
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp15_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strdup ("Xmp.tiff.ImageWidth");
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = g_new0 (gchar*, 4 + 1);
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp18_[0] = _tmp14_;
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp18_[1] = _tmp15_;
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp18_[2] = _tmp16_;
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp18_[3] = _tmp17_;
#line 755 "../src/photos/PhotoMetadata.vala"
	photo_metadata_width_tags = _tmp18_;
#line 755 "../src/photos/PhotoMetadata.vala"
	photo_metadata_width_tags_length1 = 4;
#line 755 "../src/photos/PhotoMetadata.vala"
	_photo_metadata_width_tags_size_ = photo_metadata_width_tags_length1;
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp19_ = g_strdup ("Exif.Photo.PixelYDimension");
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp21_ = g_strdup ("Xmp.tiff.ImageHeight");
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp22_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = g_new0 (gchar*, 4 + 1);
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp23_[0] = _tmp19_;
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp23_[1] = _tmp20_;
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp23_[2] = _tmp21_;
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp23_[3] = _tmp22_;
#line 762 "../src/photos/PhotoMetadata.vala"
	photo_metadata_height_tags = _tmp23_;
#line 762 "../src/photos/PhotoMetadata.vala"
	photo_metadata_height_tags_length1 = 4;
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup ("Iptc.Application2.Caption");
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp25_ = g_strdup ("Xmp.dc.title");
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp26_ = g_strdup ("Iptc.Application2.Headline");
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp27_ = g_strdup ("Xmp.photoshop.Headline");
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = g_new0 (gchar*, 4 + 1);
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp28_[0] = _tmp24_;
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp28_[1] = _tmp25_;
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp28_[2] = _tmp26_;
#line 821 "../src/photos/PhotoMetadata.vala"
	_tmp28_[3] = _tmp27_;
#line 821 "../src/photos/PhotoMetadata.vala"
	photo_metadata_standard_title_tags = _tmp28_;
#line 821 "../src/photos/PhotoMetadata.vala"
	photo_metadata_standard_title_tags_length1 = 4;
#line 821 "../src/photos/PhotoMetadata.vala"
	_photo_metadata_standard_title_tags_size_ = photo_metadata_standard_title_tags_length1;
#line 876 "../src/photos/PhotoMetadata.vala"
	_tmp29_ = g_strdup ("Xmp.dc.subject");
#line 876 "../src/photos/PhotoMetadata.vala"
	_tmp30_ = g_strdup ("Iptc.Application2.Keywords");
#line 876 "../src/photos/PhotoMetadata.vala"
	_tmp31_ = g_new0 (gchar*, 2 + 1);
#line 876 "../src/photos/PhotoMetadata.vala"
	_tmp31_[0] = _tmp29_;
#line 876 "../src/photos/PhotoMetadata.vala"
	_tmp31_[1] = _tmp30_;
#line 876 "../src/photos/PhotoMetadata.vala"
	photo_metadata_keyword_tags = _tmp31_;
#line 876 "../src/photos/PhotoMetadata.vala"
	photo_metadata_keyword_tags_length1 = 2;
#line 876 "../src/photos/PhotoMetadata.vala"
	_photo_metadata_keyword_tags_size_ = photo_metadata_keyword_tags_length1;
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp32_ = hierarchical_keyword_field_new ("Xmp.lr.hierarchicalSubject", "|", FALSE, TRUE);
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp33_ = hierarchical_keyword_field_new ("Xmp.digiKam.TagsList", "/", FALSE, TRUE);
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp34_ = hierarchical_keyword_field_new ("Xmp.MicrosoftPhoto.LastKeywordXMP", "/", FALSE, TRUE);
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp35_ = g_new0 (HierarchicalKeywordField*, 3 + 1);
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp35_[0] = _tmp32_;
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp35_[1] = _tmp33_;
#line 881 "../src/photos/PhotoMetadata.vala"
	_tmp35_[2] = _tmp34_;
#line 881 "../src/photos/PhotoMetadata.vala"
	photo_metadata_hierarchical_keyword_tags = _tmp35_;
#line 881 "../src/photos/PhotoMetadata.vala"
	photo_metadata_hierarchical_keyword_tags_length1 = 3;
#line 881 "../src/photos/PhotoMetadata.vala"
	_photo_metadata_hierarchical_keyword_tags_size_ = photo_metadata_hierarchical_keyword_tags_length1;
#line 1106 "../src/photos/PhotoMetadata.vala"
	_tmp36_ = g_strdup ("Exif.Image.Artist");
#line 1106 "../src/photos/PhotoMetadata.vala"
	_tmp37_ = g_strdup ("Exif.Canon.OwnerName");
#line 1106 "../src/photos/PhotoMetadata.vala"
	_tmp38_ = g_new0 (gchar*, 2 + 1);
#line 1106 "../src/photos/PhotoMetadata.vala"
	_tmp38_[0] = _tmp36_;
#line 1106 "../src/photos/PhotoMetadata.vala"
	_tmp38_[1] = _tmp37_;
#line 1106 "../src/photos/PhotoMetadata.vala"
	photo_metadata_artist_tags = _tmp38_;
#line 1106 "../src/photos/PhotoMetadata.vala"
	photo_metadata_artist_tags_length1 = 2;
#line 1106 "../src/photos/PhotoMetadata.vala"
	_photo_metadata_artist_tags_size_ = photo_metadata_artist_tags_length1;
#line 7775 "PhotoMetadata.c"
}

static void
photo_metadata_instance_init (PhotoMetadata * self,
                              gpointer klass)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
#line 111 "../src/photos/PhotoMetadata.vala"
	self->priv = photo_metadata_get_instance_private (self);
#line 147 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 147 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 148 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 149 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("<uninitialized>");
#line 149 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp1_;
#line 7796 "PhotoMetadata.c"
}

static void
photo_metadata_finalize (MediaMetadata * obj)
{
	PhotoMetadata * self;
#line 111 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 147 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 148 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 149 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 111 "../src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
#line 7813 "PhotoMetadata.c"
}

static GType
photo_metadata_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
	GType photo_metadata_type_id;
	photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
	PhotoMetadata_private_offset = g_type_add_instance_private (photo_metadata_type_id, sizeof (PhotoMetadataPrivate));
	return photo_metadata_type_id;
}

GType
photo_metadata_get_type (void)
{
	static volatile gsize photo_metadata_type_id__once = 0;
	if (g_once_init_enter (&photo_metadata_type_id__once)) {
		GType photo_metadata_type_id;
		photo_metadata_type_id = photo_metadata_get_type_once ();
		g_once_init_leave (&photo_metadata_type_id__once, photo_metadata_type_id);
	}
	return photo_metadata_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

